/*
 Navicat Premium Data Transfer

 Source Server         : onemall
 Source Server Type    : MySQL
 Source Server Version : 50726
 Source Host           : 192.168.88.14:3306
 Source Schema         : mall_admin

 Target Server Type    : MySQL
 Target Server Version : 50726
 File Encoding         : 65001

 Date: 13/03/2020 07:36:17
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for access_log
-- ----------------------------
DROP TABLE IF EXISTS `access_log`;
CREATE TABLE `access_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '编号',
  `trace_id` varchar(64) NOT NULL COMMENT '链路追踪编号',
  `user_id` int(11) NOT NULL DEFAULT '-1' COMMENT '用户编号.',
  `user_type` tinyint(4) DEFAULT NULL COMMENT '用户类型',
  `application_name` varchar(50) DEFAULT NULL COMMENT '应用名',
  `uri` varchar(4096) NOT NULL DEFAULT '' COMMENT '访问地址',
  `query_string` varchar(4096) NOT NULL DEFAULT '' COMMENT '参数',
  `method` varchar(50) NOT NULL DEFAULT '' COMMENT 'http 方法',
  `user_agent` varchar(1024) NOT NULL DEFAULT '' COMMENT 'userAgent',
  `ip` varchar(50) NOT NULL DEFAULT '' COMMENT 'ip',
  `start_time` datetime NOT NULL COMMENT '请求时间',
  `response_time` int(11) NOT NULL COMMENT '响应时长 -- 毫秒级',
  `error_code` int(11) NOT NULL COMMENT '错误码',
  `error_message` varchar(512) DEFAULT NULL COMMENT '错误提示',
  `create_time` datetime NOT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=77242 DEFAULT CHARSET=utf8mb4 COMMENT='admin_access_log';

-- ----------------------------
-- Records of access_log
-- ----------------------------
BEGIN;
INSERT INTO `access_log` VALUES (1, 'd60c051f-82cd-4da8-881d-338e152bdeaa', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:37:07', 60, 0, '', '2019-05-11 02:37:07');
INSERT INTO `access_log` VALUES (2, 'ae9bc36c-9e88-4a32-9860-449170a44cda', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:37:07', 66, 0, '', '2019-05-11 02:37:07');
INSERT INTO `access_log` VALUES (3, '505659b5-8b40-4170-9298-1f772ebd03dc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:37:07', 76, 2001001000, '服务端发生异常', '2019-05-11 02:37:07');
INSERT INTO `access_log` VALUES (4, '87d217eb-3b35-4d54-b7f8-996f8a76b3ba', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:37:14', 511, 0, '', '2019-05-11 02:37:14');
INSERT INTO `access_log` VALUES (5, 'e693572e-192f-4c27-a594-9f6597617d22', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:37:14', 512, 0, '', '2019-05-11 02:37:14');
INSERT INTO `access_log` VALUES (6, '2fb81aa2-72e2-4662-86d3-d5e6552371cf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:37:14', 525, 2001001000, '服务端发生异常', '2019-05-11 02:37:14');
INSERT INTO `access_log` VALUES (7, '6cd5d412-ef12-4185-a5ea-89a4e69472f9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:44:24', 223, 0, '', '2019-05-11 02:44:24');
INSERT INTO `access_log` VALUES (8, '76d007ab-06be-4a0d-93f7-f90be4dc641a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:44:24', 223, 0, '', '2019-05-11 02:44:24');
INSERT INTO `access_log` VALUES (9, '6d1d4add-738f-4ec0-99b4-e40e5139890a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:44:24', 552, 2001001000, '服务端发生异常', '2019-05-11 02:44:25');
INSERT INTO `access_log` VALUES (10, '34f3a516-cead-4e43-ae9c-f19d1c87acdf', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:48:05', 279, 0, '', '2019-05-11 02:48:05');
INSERT INTO `access_log` VALUES (11, '4a7f4f6f-8646-4fd6-b98e-d8c5c3de8d18', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:48:05', 279, 0, '', '2019-05-11 02:48:05');
INSERT INTO `access_log` VALUES (12, '7de9a377-f8ed-465a-9627-e89cc3657f8f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:48:05', 472, 2001001000, '服务端发生异常', '2019-05-11 02:48:05');
INSERT INTO `access_log` VALUES (13, 'c49aabb2-f264-49f3-a1f1-063065e9025f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:48:06', 44, 0, '', '2019-05-11 02:48:06');
INSERT INTO `access_log` VALUES (14, '9d9523df-cdfb-40d8-a955-0a0f0be9f19f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:48:06', 55, 0, '', '2019-05-11 02:48:06');
INSERT INTO `access_log` VALUES (15, '3c7695d2-2fe2-46b5-926e-27252bcdb772', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:48:06', 268, 2001001000, '服务端发生异常', '2019-05-11 02:48:06');
INSERT INTO `access_log` VALUES (16, 'bd954d65-707c-46dc-8d6b-aca9ef9241d2', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:34:37', 252, 2001001000, '服务端发生异常', '2019-05-11 15:34:37');
INSERT INTO `access_log` VALUES (17, 'ae2da8ce-039c-4463-bc01-5b8f190af907', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:34:45', 48, 2001001000, '服务端发生异常', '2019-05-11 15:34:45');
INSERT INTO `access_log` VALUES (18, 'c936390c-b98c-4f56-a3cc-2cbec0739e96', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:37:24', 1827, 2001001000, '服务端发生异常', '2019-05-11 15:37:26');
INSERT INTO `access_log` VALUES (19, 'a4be5a20-dfd4-4425-bdd1-e7c079402fc9', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:37:58', 628, 2001001000, '服务端发生异常', '2019-05-11 15:37:59');
INSERT INTO `access_log` VALUES (20, 'dc0c9b45-be7e-4023-a548-1fc5df751227', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:38:35', 1951, 2001001000, '服务端发生异常', '2019-05-11 15:38:37');
INSERT INTO `access_log` VALUES (21, '5a30665a-9330-4317-8f1a-ed61652e6304', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:39:12', 886, 2001001000, '服务端发生异常', '2019-05-11 15:39:13');
INSERT INTO `access_log` VALUES (22, '49ca8219-1842-43be-b79b-6a33c10bf2d6', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:39:13', 616, 2001001000, '服务端发生异常', '2019-05-11 15:39:14');
INSERT INTO `access_log` VALUES (23, 'c95acd0e-4462-41ee-8fd3-7ce7f0000411', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:39:24', 1028, 2001001000, '服务端发生异常', '2019-05-11 15:39:25');
INSERT INTO `access_log` VALUES (24, 'bd4028f9-6768-4306-8cb2-7694c74f80f2', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:42:33', 998, 0, '', '2019-05-11 15:42:37');
INSERT INTO `access_log` VALUES (25, 'bd4028f9-6768-4306-8cb2-7694c74f80f2', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:42:33', 998, 0, '', '2019-05-11 15:42:37');
INSERT INTO `access_log` VALUES (26, 'bd4028f9-6768-4306-8cb2-7694c74f80f2', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:42:33', 998, 0, '', '2019-05-11 15:42:34');
INSERT INTO `access_log` VALUES (27, 'ca86e743-700d-4507-a1b5-5b65c272b354', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:43:00', 891, 0, '', '2019-05-11 15:43:01');
INSERT INTO `access_log` VALUES (28, 'ca86e743-700d-4507-a1b5-5b65c272b354', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:43:00', 891, 0, '', '2019-05-11 15:43:02');
INSERT INTO `access_log` VALUES (29, 'e3bc36b0-7665-4b67-acee-0d822fe7d280', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:43:03', 253, 0, '', '2019-05-11 15:43:03');
INSERT INTO `access_log` VALUES (30, 'a140e115-ad43-4e2f-84bb-9342bc3c3a74', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:43:04', 1009, 0, '', '2019-05-11 15:43:06');
INSERT INTO `access_log` VALUES (31, '602f35c6-e40d-4c3e-a543-4b8e446abc76', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:43:06', 246, 0, '', '2019-05-11 15:43:06');
INSERT INTO `access_log` VALUES (32, '7f5aae4d-fd4a-445d-a826-3aa7d52bcd4e', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:43:07', 260, 0, '', '2019-05-11 15:43:07');
INSERT INTO `access_log` VALUES (33, '7334f3b3-efa2-41c0-bd5b-f8087fe2520e', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:46:35', 959, 0, '', '2019-05-11 15:46:36');
INSERT INTO `access_log` VALUES (34, '70d5221e-b707-4dae-bfd6-7b3bee70a636', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:46:35', 1215, 0, '', '2019-05-11 15:46:36');
INSERT INTO `access_log` VALUES (35, '81a07c41-16ad-4554-838f-ff0fc7121c52', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:46:38', 220, 0, '', '2019-05-11 15:46:38');
INSERT INTO `access_log` VALUES (36, 'b3dbae90-89d4-46c8-9054-b66f631b8f2d', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:46:38', 101, 0, '', '2019-05-11 15:46:39');
INSERT INTO `access_log` VALUES (37, '2050e79d-31f9-430f-9fdf-f1e46ab6eb3f', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:46:40', 201, 0, '', '2019-05-11 15:46:40');
INSERT INTO `access_log` VALUES (38, '23a8fcb8-5f76-469d-a5f4-698be58994be', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:46:40', 155, 0, '', '2019-05-11 15:46:41');
INSERT INTO `access_log` VALUES (39, '77c88a8e-2b88-4fcc-bd40-7fa56a9e9d0f', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:46:41', 338, 0, '', '2019-05-11 15:46:41');
INSERT INTO `access_log` VALUES (40, 'a7b02903-f7fd-42db-b9dc-b7b214423dbc', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:46:42', 147, 0, '', '2019-05-11 15:46:42');
INSERT INTO `access_log` VALUES (41, '1cde4995-7500-4c97-bc23-6ef493cf4bec', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:46:42', 179, 0, '', '2019-05-11 15:46:42');
INSERT INTO `access_log` VALUES (42, '853efe78-4837-45b5-aa59-59b9263b1d44', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:47:32', 403, 0, '', '2019-05-11 15:47:33');
INSERT INTO `access_log` VALUES (43, '57b7b485-bd63-480a-8784-9dc6f14530d7', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:47:34', 349, 0, '', '2019-05-11 15:47:35');
INSERT INTO `access_log` VALUES (44, '4005b323-540f-421a-8a1d-be6761dfae61', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:49:10', 393, 0, '', '2019-05-11 15:49:11');
INSERT INTO `access_log` VALUES (45, '23f068b1-795d-4af6-99d2-6a7ceef759ec', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:49:13', 366, 0, '', '2019-05-11 15:49:14');
INSERT INTO `access_log` VALUES (46, 'ebf6514f-bfde-47fd-a8c2-f0c65b4783ff', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:50:03', 360, 0, '', '2019-05-11 15:50:03');
INSERT INTO `access_log` VALUES (47, '77bc916c-ee60-4796-9a29-058293931e67', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:50:18', 363, 0, '', '2019-05-11 15:50:18');
INSERT INTO `access_log` VALUES (48, '3d4f0691-ffe5-4079-bcf3-18f1e4e7329a', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:50:18', 293, 0, '', '2019-05-11 15:50:19');
INSERT INTO `access_log` VALUES (49, 'bec1c8d0-6477-49c8-a813-13d7c8bf5610', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:50:19', 483, 0, '', '2019-05-11 15:50:19');
INSERT INTO `access_log` VALUES (50, '24ba8db3-84b1-471a-839f-43c9f3c756b9', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:50:23', 182, 0, '', '2019-05-11 15:50:23');
INSERT INTO `access_log` VALUES (51, '91df5fd6-548e-4166-a2eb-92e43eeba62d', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:50:23', 413, 0, '', '2019-05-11 15:50:23');
INSERT INTO `access_log` VALUES (52, 'bd6e018d-f4ea-4063-8004-4778010dcb61', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:50:23', 1055, 0, '', '2019-05-11 15:50:24');
INSERT INTO `access_log` VALUES (53, 'afd0c843-dc90-4982-ae36-0a452c3b3e0c', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:50:26', 168, 0, '', '2019-05-11 15:50:26');
INSERT INTO `access_log` VALUES (54, 'b05179f6-23ff-432d-a99c-6d4063e70eb2', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:50:26', 463, 0, '', '2019-05-11 15:50:27');
INSERT INTO `access_log` VALUES (55, '86cc4832-047e-4a82-9c34-fc449338f53f', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:50:27', 153, 0, '', '2019-05-11 15:50:28');
INSERT INTO `access_log` VALUES (56, 'c6eef7c8-6b1d-4760-b238-1eebb57c0ccd', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:50:29', 130, 0, '', '2019-05-11 15:50:29');
INSERT INTO `access_log` VALUES (57, '6c5f67aa-e806-4b29-9cd7-653ee1c51dd9', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:50:29', 462, 0, '', '2019-05-11 15:50:29');
INSERT INTO `access_log` VALUES (58, '5b652afa-d2ef-408d-9555-fb94267a3dcb', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:50:36', 9575, 2001001000, '服务端发生异常', '2019-05-11 15:50:46');
INSERT INTO `access_log` VALUES (59, '31a84609-55bd-44d0-a25f-3be8b0c119a5', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:52:17', 59835, 2001001000, '服务端发生异常', '2019-05-11 15:53:17');
INSERT INTO `access_log` VALUES (60, '2456329c-cdf3-4553-81b6-a32507b5a1e5', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:57:06', 139, 0, '', '2019-05-11 15:57:06');
INSERT INTO `access_log` VALUES (61, '750a68bc-b945-4808-89b3-dac07a9700d7', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:57:06', 436, 0, '', '2019-05-11 15:57:06');
INSERT INTO `access_log` VALUES (62, '88ae7a42-6785-4d91-810c-7c83a97ae8bb', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:57:08', 153, 0, '', '2019-05-11 15:57:08');
INSERT INTO `access_log` VALUES (63, '264dae1d-410a-404b-bf67-b55e8bbe902a', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:57:09', 157, 0, '', '2019-05-11 15:57:09');
INSERT INTO `access_log` VALUES (64, '38bfea36-292c-419b-a0d5-5db4905da83b', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:57:09', 435, 0, '', '2019-05-11 15:57:10');
INSERT INTO `access_log` VALUES (65, '8f09ea04-80a3-4604-9e2c-ffd4cee4f210', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:57:14', 4254, 2001001000, '服务端发生异常', '2019-05-11 15:57:18');
INSERT INTO `access_log` VALUES (66, '68ab33bb-5bf8-424b-b894-93ff717bb4a4', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 15:58:23', 39800, 2001001000, '服务端发生异常', '2019-05-11 15:59:03');
INSERT INTO `access_log` VALUES (67, 'ee14b9a4-1f27-43d9-9423-b987c15a4153', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:20:07', 394, 1001001012, '访问令牌已过期', '2019-05-11 17:20:07');
INSERT INTO `access_log` VALUES (68, 'f8ef5c3f-f169-4053-8841-b9f5bd53a108', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=f49fe9fdbd6b4d6e8cb271fbecfac3ee', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:20:08', 476, 0, '', '2019-05-11 17:20:08');
INSERT INTO `access_log` VALUES (69, 'e2d16419-c7b9-43c3-a2a2-925eef408da6', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:20:08', 45, 0, '', '2019-05-11 17:20:08');
INSERT INTO `access_log` VALUES (70, '860c1625-5e65-4b36-9357-59e29ac3022c', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:30:51', 28, 0, '', '2019-05-11 17:30:51');
INSERT INTO `access_log` VALUES (71, '11c51126-4386-4580-8d01-f149f1a80f86', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:30:51', 1182, 0, '', '2019-05-11 17:30:52');
INSERT INTO `access_log` VALUES (72, '279fc809-e735-4d12-8df0-6cc1bc0fe513', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:30:53', 41, 0, '', '2019-05-11 17:30:53');
INSERT INTO `access_log` VALUES (73, '6f3b0b1e-1a7c-4cd3-8f4b-1d4e3ee7a33e', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:30:54', 56, 0, '', '2019-05-11 17:30:54');
INSERT INTO `access_log` VALUES (74, 'd8b2f67c-e9f6-4ca6-abad-a7030fade40a', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:30:54', 116, 0, '', '2019-05-11 17:30:54');
INSERT INTO `access_log` VALUES (75, '7bd891f2-79e2-4be7-a69b-646f54762ce4', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:30:55', 592, 2001001000, '服务端发生异常', '2019-05-11 17:30:56');
INSERT INTO `access_log` VALUES (76, 'aaeecfbe-2314-4a15-8738-c80d566479fe', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:33:54', 33, 0, '', '2019-05-11 17:33:54');
INSERT INTO `access_log` VALUES (77, '1b2e382f-bd74-4405-8f7c-bb1d3e8d915d', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:33:56', 33, 0, '', '2019-05-11 17:33:56');
INSERT INTO `access_log` VALUES (78, '4aedac75-7792-4140-b4bf-bea405a426d8', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:34:00', 142, 0, '', '2019-05-11 17:34:00');
INSERT INTO `access_log` VALUES (79, 'd88feafd-c151-4f7b-9bb4-a64e8035e8ce', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:34:01', 29, 0, '', '2019-05-11 17:34:01');
INSERT INTO `access_log` VALUES (80, 'e01b3f2d-185d-426c-8f92-e5353d14dd28', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:34:22', 35, 0, '', '2019-05-11 17:34:22');
INSERT INTO `access_log` VALUES (81, 'fa96edb1-e58b-439a-9bbd-7c88521aa00a', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:34:22', 28, 0, '', '2019-05-11 17:34:22');
INSERT INTO `access_log` VALUES (82, 'b42328bf-6d93-4b7e-b8c2-4eedc7db80a5', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:34:23', 443, 0, '', '2019-05-11 17:34:23');
INSERT INTO `access_log` VALUES (83, 'ff9cb0ec-b2c0-48e3-8393-6552143c4a18', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:34:24', 2837, 2001001000, '服务端发生异常', '2019-05-11 17:34:27');
INSERT INTO `access_log` VALUES (84, '7a0296c6-71ee-4657-83da-885ac961382e', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:50:00', 31, 0, '', '2019-05-11 17:50:00');
INSERT INTO `access_log` VALUES (85, '5af889d9-1bca-4d77-bba8-27a94ab270fc', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:50:00', 120, 0, '', '2019-05-11 17:50:00');
INSERT INTO `access_log` VALUES (86, '41512b98-79d9-4e37-a51e-85ba3608d0c7', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:13', 43, 0, '', '2019-05-11 17:51:13');
INSERT INTO `access_log` VALUES (87, '09795ed6-4fb0-479a-ae64-167e68565063', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:17', 30, 0, '', '2019-05-11 17:51:17');
INSERT INTO `access_log` VALUES (88, '943fbbf9-10b0-41b8-b32c-a1081bdbb95a', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:18', 27, 0, '', '2019-05-11 17:51:18');
INSERT INTO `access_log` VALUES (89, '1f5afbe8-b532-4711-bc43-597fb6f7598e', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:19', 29, 0, '', '2019-05-11 17:51:19');
INSERT INTO `access_log` VALUES (90, 'c74b086f-d6ae-4d80-97de-9dd8934140fe', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:21', 26, 0, '', '2019-05-11 17:51:21');
INSERT INTO `access_log` VALUES (91, '38a78d17-eabd-4c68-b7ae-6cb1ed7b24a1', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:22', 37, 0, '', '2019-05-11 17:51:22');
INSERT INTO `access_log` VALUES (92, '002bc518-e095-4f5b-8b0e-6b920649194f', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:24', 37, 0, '', '2019-05-11 17:51:24');
INSERT INTO `access_log` VALUES (93, '97c28cef-e21c-4e33-8ee7-5966ce354d8f', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:27', 28, 0, '', '2019-05-11 17:51:27');
INSERT INTO `access_log` VALUES (94, 'd9c709a6-66b0-40d6-8c12-4f868875fa62', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:28', 29, 0, '', '2019-05-11 17:51:28');
INSERT INTO `access_log` VALUES (95, '320dae9d-ed86-459a-b374-ca9800466a04', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:29', 29, 0, '', '2019-05-11 17:51:29');
INSERT INTO `access_log` VALUES (96, '5eab80ab-2183-4477-a64e-a23a12fd5286', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:30', 873, 0, '', '2019-05-11 17:51:31');
INSERT INTO `access_log` VALUES (97, 'aa640000-0eaa-419b-81e5-39a31d292fb5', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:31', 22, 0, '', '2019-05-11 17:51:31');
INSERT INTO `access_log` VALUES (98, 'f78f861f-7b83-4ab5-93dd-77b20b0771d7', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:33', 26, 0, '', '2019-05-11 17:51:33');
INSERT INTO `access_log` VALUES (99, 'be36b7d8-2647-4ed3-96e1-cb5cb461d5e9', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:33', 352, 0, '', '2019-05-11 17:51:33');
INSERT INTO `access_log` VALUES (100, 'a98a5cb7-24e6-4616-9f01-6bca95b6b373', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:36', 34, 0, '', '2019-05-11 17:51:36');
INSERT INTO `access_log` VALUES (101, 'c7fddb9f-913f-4d36-bb7e-8f37cff1fb6e', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:36', 33, 0, '', '2019-05-11 17:51:36');
INSERT INTO `access_log` VALUES (102, 'bf3e0bbb-455b-4ac2-9de1-c094e23a2185', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:36', 99, 0, '', '2019-05-11 17:51:36');
INSERT INTO `access_log` VALUES (103, 'd02827ac-0f0d-4136-8aeb-089949f6fa95', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:51:38', 5586, 2001001000, '服务端发生异常', '2019-05-11 17:51:43');
INSERT INTO `access_log` VALUES (104, 'c39b0d1f-5ac8-4ecf-9ac2-9d8557a34270', 0, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:59:44', 77, 2001001000, '服务端发生异常', '2019-05-11 17:59:45');
INSERT INTO `access_log` VALUES (105, '67e1c336-d148-4433-ba42-ff41666fe422', 0, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 17:59:48', 68, 2001001000, '服务端发生异常', '2019-05-11 17:59:48');
INSERT INTO `access_log` VALUES (106, 'e4172d11-e894-4d02-b197-887c2936d4d4', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:00:06', 118334, 2001001000, '服务端发生异常', '2019-05-11 18:02:05');
INSERT INTO `access_log` VALUES (107, '2a7ddf6f-4e34-40e1-9d86-feab5a984928', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:03:36', 30, 0, '', '2019-05-11 18:03:36');
INSERT INTO `access_log` VALUES (108, '4960f962-791d-4d59-8d6d-4397e306c2ac', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:03:36', 102, 0, '', '2019-05-11 18:03:36');
INSERT INTO `access_log` VALUES (109, '1ab1ce66-627c-4acd-97e7-96a68dfb017e', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:03:38', 35, 0, '', '2019-05-11 18:03:38');
INSERT INTO `access_log` VALUES (110, 'ed011390-39ad-424f-be94-b987153b2d04', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:03:38', 29, 0, '', '2019-05-11 18:03:38');
INSERT INTO `access_log` VALUES (111, 'aed1d3c6-a248-4f25-8022-cf0eb10e9c09', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:03:38', 86, 0, '', '2019-05-11 18:03:38');
INSERT INTO `access_log` VALUES (112, 'c93054e3-8110-42c0-8195-8616c8ddfc0a', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:03:27', 12059, 2001001000, '服务端发生异常', '2019-05-11 18:03:40');
INSERT INTO `access_log` VALUES (113, 'f3edbe85-146f-450a-b152-955881935097', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:02:25', 84654, 2001001000, '服务端发生异常', '2019-05-11 18:03:50');
INSERT INTO `access_log` VALUES (114, '9a38f086-3eb6-4380-89a2-f746d10cadec', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:03:48', 45400, 2001001000, '服务端发生异常', '2019-05-11 18:04:34');
INSERT INTO `access_log` VALUES (115, '9a38f086-3eb6-4380-89a2-f746d10cadec', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:03:48', 45400, 2001001000, '服务端发生异常', '2019-05-11 18:05:32');
INSERT INTO `access_log` VALUES (116, '2e1331b8-bc5b-4059-a33b-5d4ab1071476', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:03:39', 112642, 2001001000, '服务端发生异常', '2019-05-11 18:05:32');
INSERT INTO `access_log` VALUES (117, '8b6bb471-8c3b-4b40-8e38-cb0221ea1b01', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:03:32', 120055, 2001001000, '服务端发生异常', '2019-05-11 18:05:32');
INSERT INTO `access_log` VALUES (118, 'f74fe632-adca-4110-a32b-8040baf1519c', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:06:27', 134286, 2001001000, '服务端发生异常', '2019-05-11 18:08:41');
INSERT INTO `access_log` VALUES (119, '6c4db6f8-237f-4022-9c2f-38da2d454805', 0, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:08:46', 40, 1001001012, '访问令牌已过期', '2019-05-11 18:08:46');
INSERT INTO `access_log` VALUES (120, '65392938-a2e7-4bd3-9d35-09489d50a9f1', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=f49fe9fdbd6b4d6e8cb271fbecfac3ee', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:08:46', 328, 0, '', '2019-05-11 18:08:46');
INSERT INTO `access_log` VALUES (121, 'd1a4fff8-6d2b-4c6c-9153-476184f2bfbe', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:08:46', 122, 2001001000, '服务端发生异常', '2019-05-11 18:08:46');
INSERT INTO `access_log` VALUES (122, 'de071ad3-95db-4787-bfef-0fbb0bed7f37', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:10:18', 184, 0, '', '2019-05-11 18:10:18');
INSERT INTO `access_log` VALUES (123, 'eaadbc27-8c86-4a5c-898b-3fb4ab7d7af6', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:10:18', 661, 0, '', '2019-05-11 18:10:19');
INSERT INTO `access_log` VALUES (124, 'd997013a-846b-4536-bd75-feaaafac6805', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:10:19', 171, 0, '', '2019-05-11 18:10:20');
INSERT INTO `access_log` VALUES (125, '46e39f72-4e15-4387-b5c5-9757e7d967a6', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:10:20', 371, 0, '', '2019-05-11 18:10:20');
INSERT INTO `access_log` VALUES (126, '785cea71-f5a5-4a83-9971-906f95a38bc9', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:10:20', 219, 0, '', '2019-05-11 18:10:20');
INSERT INTO `access_log` VALUES (127, 'eaad37fb-e418-454b-a099-dfecbc7cca25', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:10:21', 98, 0, '', '2019-05-11 18:10:21');
INSERT INTO `access_log` VALUES (128, 'd26e38f0-fc3f-470a-b85f-bf865eba1094', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:10:21', 394, 0, '', '2019-05-11 18:10:22');
INSERT INTO `access_log` VALUES (129, '5a0f462c-3eaf-4d33-b834-8d51a5f16e07', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:10:23', 118, 0, '', '2019-05-11 18:10:23');
INSERT INTO `access_log` VALUES (130, 'f1e8fa3c-9f5b-409d-91dd-61f34290c49b', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:10:24', 109, 0, '', '2019-05-11 18:10:24');
INSERT INTO `access_log` VALUES (131, 'fd29b1f9-973e-4926-aca1-865f1f8ec916', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:10:24', 252, 0, '', '2019-05-11 18:10:24');
INSERT INTO `access_log` VALUES (132, '045717ae-0ebd-4ee0-a24c-06d967146ad4', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:10:25', 3682, 2001001000, '服务端发生异常', '2019-05-11 18:10:29');
INSERT INTO `access_log` VALUES (133, 'f3048cd3-d3ab-445a-a568-0ff04fc183cf', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:11:15', 128, 0, '', '2019-05-11 18:11:15');
INSERT INTO `access_log` VALUES (134, '4d7714ff-698f-494e-9c51-a58b3ecf221e', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:11:16', 64, 0, '', '2019-05-11 18:11:16');
INSERT INTO `access_log` VALUES (135, '7f76c0ab-dc9c-465d-89e3-f133351757d0', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:11:17', 76, 0, '', '2019-05-11 18:11:17');
INSERT INTO `access_log` VALUES (136, '89fbf596-aa7f-4578-8a5b-5dca588fc45e', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:12:29', 31, 0, '', '2019-05-11 18:12:30');
INSERT INTO `access_log` VALUES (137, '749f63c2-6e0f-49a7-acad-0fed29a03479', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:12:30', 343, 0, '', '2019-05-11 18:12:30');
INSERT INTO `access_log` VALUES (138, 'f8da5d9d-562b-4976-bdc6-528f1c7e5f0e', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:12:34', 35, 0, '', '2019-05-11 18:12:34');
INSERT INTO `access_log` VALUES (139, '91eeb689-83c6-45ca-a956-f24572c6acfe', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:12:35', 40, 0, '', '2019-05-11 18:12:35');
INSERT INTO `access_log` VALUES (140, '3d09b553-b3b6-40ea-ae79-66ce638cedc1', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:12:35', 96, 0, '', '2019-05-11 18:12:35');
INSERT INTO `access_log` VALUES (141, '80e707f1-7fc0-4c76-8d4c-cf34d92869f6', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:12:35', 23, 0, '', '2019-05-11 18:12:35');
INSERT INTO `access_log` VALUES (142, 'd1f3f604-d22f-425b-8dac-10b5a5923269', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:12:41', 28, 0, '', '2019-05-11 18:12:41');
INSERT INTO `access_log` VALUES (143, '2d3a87ea-1745-4d2a-8c03-27a5482e0b74', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:12:41', 22, 0, '', '2019-05-11 18:12:41');
INSERT INTO `access_log` VALUES (144, '16f75539-6e00-4f00-b642-88368964d8ed', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:12:41', 91, 0, '', '2019-05-11 18:12:41');
INSERT INTO `access_log` VALUES (145, '01a46f00-bb4d-42d0-8980-9738ab4baf04', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:12:43', 3441, 2001001000, '服务端发生异常', '2019-05-11 18:12:46');
INSERT INTO `access_log` VALUES (146, 'c832eb87-baa4-4967-b852-a7feadb29632', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:14:49', 38, 0, '', '2019-05-11 18:14:49');
INSERT INTO `access_log` VALUES (147, '1746171b-4fb9-45f9-8b41-fba8fb68e86f', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:14:51', 67, 0, '', '2019-05-11 18:14:51');
INSERT INTO `access_log` VALUES (148, 'e0631dbe-09f2-4cc9-a575-41703869f4f8', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:14:53', 28, 0, '', '2019-05-11 18:14:53');
INSERT INTO `access_log` VALUES (149, '73114856-1e73-44ed-b60b-0bcd3a9791a8', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:14:56', 54, 0, '', '2019-05-11 18:14:56');
INSERT INTO `access_log` VALUES (150, 'a38ae6f6-aea5-475c-891e-597f74fc93e2', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:34:22', 29, 0, '', '2019-05-11 18:34:23');
INSERT INTO `access_log` VALUES (151, '48dc5cb4-cfcd-4c58-8d5d-01c4e0a63d3a', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:34:23', 327, 0, '', '2019-05-11 18:34:23');
INSERT INTO `access_log` VALUES (152, '76ffb1b4-6e4a-47f1-97ea-7975f1cc6293', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:34:25', 29, 0, '', '2019-05-11 18:34:25');
INSERT INTO `access_log` VALUES (153, 'e9b59c14-3018-46d9-9ec4-b6ae85800b31', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:34:25', 21, 0, '', '2019-05-11 18:34:25');
INSERT INTO `access_log` VALUES (154, '4431cf92-a012-4c19-a6f4-177c6ae51581', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:34:25', 85, 0, '', '2019-05-11 18:34:25');
INSERT INTO `access_log` VALUES (155, '1b1238a5-910e-4624-bb75-e1ad1a13c069', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:34:26', 66786, 2001001000, '服务端发生异常', '2019-05-11 18:35:33');
INSERT INTO `access_log` VALUES (156, 'b104232a-b9ae-4b70-802b-c41cea635bca', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:38:54', 27, 0, '', '2019-05-11 18:38:54');
INSERT INTO `access_log` VALUES (157, 'ec7d6c39-bb28-42c6-ad48-87d75a06b3df', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:39:02', 61, 0, '', '2019-05-11 18:39:02');
INSERT INTO `access_log` VALUES (158, 'f3e4cbf8-608e-4480-9bbd-2be4395884cf', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:39:03', 27, 0, '', '2019-05-11 18:39:04');
INSERT INTO `access_log` VALUES (159, '94b5e537-74fb-49bc-b91f-42f6ea970cd5', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:39:05', 26, 0, '', '2019-05-11 18:39:05');
INSERT INTO `access_log` VALUES (160, '2885b997-9632-4045-91aa-b0144041bb0e', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:39:06', 26, 0, '', '2019-05-11 18:39:06');
INSERT INTO `access_log` VALUES (161, '04401b16-5240-49f1-80bf-b39cfd2c8d5a', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:39:07', 28, 0, '', '2019-05-11 18:39:07');
INSERT INTO `access_log` VALUES (162, '87dc6112-f886-411a-953d-0e8cd856a366', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:39:09', 28, 0, '', '2019-05-11 18:39:09');
INSERT INTO `access_log` VALUES (163, '3a71b6f6-71f4-4a9e-b14a-57a23706ae9d', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:39:10', 106, 0, '', '2019-05-11 18:39:10');
INSERT INTO `access_log` VALUES (164, '34c24d3f-9df8-43f9-b10a-ccd52d19452c', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:39:13', 33, 0, '', '2019-05-11 18:39:13');
INSERT INTO `access_log` VALUES (165, '86272c50-995d-4ef4-9398-c43668e5c493', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:39:13', 372, 0, '', '2019-05-11 18:39:13');
INSERT INTO `access_log` VALUES (166, '831c9a46-ab0b-405a-b3a5-e79dddae3bd2', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:39:16', 58, 0, '', '2019-05-11 18:39:16');
INSERT INTO `access_log` VALUES (167, '6f2dec22-d3c3-48ab-b219-0de248a716a5', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:39:17', 32, 0, '', '2019-05-11 18:39:17');
INSERT INTO `access_log` VALUES (168, 'cc149f8a-4592-4890-840c-6092946220a4', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:39:17', 94, 0, '', '2019-05-11 18:39:17');
INSERT INTO `access_log` VALUES (169, 'ca1079ac-042b-437f-94da-934f5e050d76', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:39:18', 6021, 2001001000, '服务端发生异常', '2019-05-11 18:39:24');
INSERT INTO `access_log` VALUES (170, '695d04f6-0a88-40bb-80a6-ce9bc4a329da', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:42:11', 30, 0, '', '2019-05-11 18:42:11');
INSERT INTO `access_log` VALUES (171, '85cdf211-31d3-40e4-ad34-4118dd82e861', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:42:11', 378, 0, '', '2019-05-11 18:42:12');
INSERT INTO `access_log` VALUES (172, '86b9bf1a-59ba-4233-be85-57470dae3216', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:42:13', 26, 0, '', '2019-05-11 18:42:13');
INSERT INTO `access_log` VALUES (173, '594a3529-cea6-4d20-abe8-1e09b6ba5498', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:42:14', 35, 0, '', '2019-05-11 18:42:14');
INSERT INTO `access_log` VALUES (174, '3ca2b2a3-66d9-4208-bebe-3ed389555bac', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:42:14', 98, 0, '', '2019-05-11 18:42:14');
INSERT INTO `access_log` VALUES (175, 'ccc7b9f6-3360-468f-9c27-cae7e782fc46', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:42:15', 898, 2001001000, '服务端发生异常', '2019-05-11 18:42:16');
INSERT INTO `access_log` VALUES (176, '642cfb5c-bc79-4073-a46a-e2b3c06c78e4', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:37:43', 351, 1001001012, '访问令牌已过期', '2019-05-11 21:37:43');
INSERT INTO `access_log` VALUES (177, 'd9936eb8-38a0-49d3-b3d3-7398970434c5', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:37:43', 416, 1001001012, '访问令牌已过期', '2019-05-11 21:37:43');
INSERT INTO `access_log` VALUES (178, '340e327b-cd87-4757-a25b-1e3cc4adf044', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=f49fe9fdbd6b4d6e8cb271fbecfac3ee', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:37:44', 356, 0, '', '2019-05-11 21:37:44');
INSERT INTO `access_log` VALUES (179, '0c0fff15-cfa3-462c-a28d-0d2b219e7345', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=f49fe9fdbd6b4d6e8cb271fbecfac3ee', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:37:44', 361, 0, '', '2019-05-11 21:37:44');
INSERT INTO `access_log` VALUES (180, '3930a49e-1d88-491f-866f-0060a13d5612', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:37:44', 14, 1001001013, '访问令牌已失效', '2019-05-11 21:37:44');
INSERT INTO `access_log` VALUES (181, 'ca66976f-8c1a-4866-8a7f-955652ad9039', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:37:45', 19, 0, '', '2019-05-11 21:37:45');
INSERT INTO `access_log` VALUES (182, '08010b41-441c-4c13-a21d-8854311c7a77', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:37:51', 121, 0, '', '2019-05-11 21:37:51');
INSERT INTO `access_log` VALUES (183, 'a10409b0-94a3-4751-893b-4866bf752e57', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:37:55', 211, 0, '', '2019-05-11 21:37:55');
INSERT INTO `access_log` VALUES (184, 'c2c3d4a6-9b5e-4f86-b4fc-659e6693143b', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:37:57', 60, 0, '', '2019-05-11 21:37:57');
INSERT INTO `access_log` VALUES (185, '5cda3488-b9b4-4eea-abc2-914a00412f83', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:00', 57, 0, '', '2019-05-11 21:38:00');
INSERT INTO `access_log` VALUES (186, '232afcfc-659f-4fa2-95b4-e5ccfed02fdb', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:00', 21, 0, '', '2019-05-11 21:38:00');
INSERT INTO `access_log` VALUES (187, '1b7d3279-430e-406e-aa72-a29ef1e3885a', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:02', 42, 0, '', '2019-05-11 21:38:02');
INSERT INTO `access_log` VALUES (188, 'c5888551-0f60-4426-b02d-74199e2651a1', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:02', 41, 0, '', '2019-05-11 21:38:02');
INSERT INTO `access_log` VALUES (189, 'fa64f23f-e3d1-4b6f-a9e5-81fe05fbcccb', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:03', 317, 0, '', '2019-05-11 21:38:03');
INSERT INTO `access_log` VALUES (190, 'dd288564-bb21-42df-bbd3-a8511efd0fa7', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:04', 81, 0, '', '2019-05-11 21:38:04');
INSERT INTO `access_log` VALUES (191, '7adf88d9-ab73-4eda-8555-f4ed6857bde2', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:04', 293, 0, '', '2019-05-11 21:38:04');
INSERT INTO `access_log` VALUES (192, '3aecae6e-01f7-4916-be8a-615ffe4fc87a', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:04', 128, 0, '', '2019-05-11 21:38:04');
INSERT INTO `access_log` VALUES (193, '9df142da-f6f2-4fcd-9b45-3264ae8f3cb3', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:06', 36, 0, '', '2019-05-11 21:38:06');
INSERT INTO `access_log` VALUES (194, '31d54332-e5ff-4563-ac9c-df4af42866ea', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:06', 118, 0, '', '2019-05-11 21:38:06');
INSERT INTO `access_log` VALUES (195, '5e3ef845-8e08-46da-bf9f-f184383463a7', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:07', 34, 0, '', '2019-05-11 21:38:07');
INSERT INTO `access_log` VALUES (196, '7fe705e1-a39a-4316-b4bb-b5326d474576', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:08', 16, 0, '', '2019-05-11 21:38:08');
INSERT INTO `access_log` VALUES (197, '585e2323-d9bc-4c09-96c3-ffc09fde4641', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:08', 101, 0, '', '2019-05-11 21:38:08');
INSERT INTO `access_log` VALUES (198, '7924b4c8-ebc3-4e6c-ac43-594ecd652562', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:09', 13015, 0, '', '2019-05-11 21:38:22');
INSERT INTO `access_log` VALUES (199, '352593ce-a132-4730-ae10-b87b40b7fc9c', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=178', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 21:38:22', 129, 0, '', '2019-05-11 21:38:22');
INSERT INTO `access_log` VALUES (200, 'a3852d85-86dd-414b-83a0-ddd81b19fab2', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=178', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 22:12:53', 47, 0, '', '2019-05-11 22:12:53');
INSERT INTO `access_log` VALUES (201, '483083ed-a138-4ac4-bc4f-5c4ea7bd90bf', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 22:12:56', 33, 0, '', '2019-05-11 22:12:56');
INSERT INTO `access_log` VALUES (202, 'a52095df-6add-4546-b1ea-0bf57586b5b4', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 22:12:59', 34, 0, '', '2019-05-11 22:12:59');
INSERT INTO `access_log` VALUES (203, '9c112f30-f986-4589-a650-644ff76b4797', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:06:44', 20, 1001001012, '访问令牌已过期', '2019-05-12 00:06:44');
INSERT INTO `access_log` VALUES (204, '34342b6a-93f2-456a-bc79-86fe4e56e94b', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:06:44', 155, 1001001012, '访问令牌已过期', '2019-05-12 00:06:44');
INSERT INTO `access_log` VALUES (205, '9b204612-460a-46cf-921f-8ba8d399099a', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=22d5ccdb631c4af49b4dd0e9a56c8afa', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:06:44', 196, 0, '', '2019-05-12 00:06:44');
INSERT INTO `access_log` VALUES (206, '6521dedb-a875-49a5-93fe-691b93e18f7a', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:06:44', 21, 0, '', '2019-05-12 00:06:44');
INSERT INTO `access_log` VALUES (207, '24b5ad58-1850-400c-87df-c2b485067db6', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=22d5ccdb631c4af49b4dd0e9a56c8afa', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:06:44', 199, 0, '', '2019-05-12 00:06:44');
INSERT INTO `access_log` VALUES (208, '8ad99b39-c44c-4453-ad00-df43ba3845a7', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:06:45', 197, 0, '', '2019-05-12 00:06:45');
INSERT INTO `access_log` VALUES (209, '7423d7ad-1f28-458d-a95c-b302b162c32c', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:06:45', 33, 0, '', '2019-05-12 00:06:45');
INSERT INTO `access_log` VALUES (210, '49bf3995-c9b7-4e92-b3cd-5ef3270b6a40', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:06:46', 24, 0, '', '2019-05-12 00:06:46');
INSERT INTO `access_log` VALUES (211, 'd6fc8925-28c3-4d23-b568-ea4e8903aea7', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:06:46', 95, 0, '', '2019-05-12 00:06:46');
INSERT INTO `access_log` VALUES (212, '34ecb78f-c978-4473-a673-17a5fd62f636', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:06:47', 686, 0, '', '2019-05-12 00:06:48');
INSERT INTO `access_log` VALUES (213, '54e9172b-7137-4786-ad99-9046c280453d', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=179', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:06:48', 33, 0, '', '2019-05-12 00:06:48');
INSERT INTO `access_log` VALUES (214, '5eef5a0d-1c5b-40a2-9caa-af1487bad351', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:06:50', 29, 0, '', '2019-05-12 00:06:50');
INSERT INTO `access_log` VALUES (215, '46e8ad98-7af1-4f49-bc78-13cafb247921', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:06:50', 82, 0, '', '2019-05-12 00:06:50');
INSERT INTO `access_log` VALUES (216, 'cc14ea2d-a7b4-49b0-aa69-a9500935ec33', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:08:02', 39, 0, '', '2019-05-12 00:08:02');
INSERT INTO `access_log` VALUES (217, 'b3717417-0975-4f6d-8002-a0f8cd74c584', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:08:06', 30, 0, '', '2019-05-12 00:08:06');
INSERT INTO `access_log` VALUES (218, '7ab984ba-65c6-427b-9546-63239e213b84', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:08:11', 120, 0, '', '2019-05-12 00:08:11');
INSERT INTO `access_log` VALUES (219, 'c8125086-9b53-40b7-b2cf-aa6d5281c4fa', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:08:41', 31, 0, '', '2019-05-12 00:08:41');
INSERT INTO `access_log` VALUES (220, '5e3ff66e-cdbc-4831-8bf5-5da05c446987', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:08:42', 40, 0, '', '2019-05-12 00:08:42');
INSERT INTO `access_log` VALUES (221, '96c5d492-1cf4-416a-a9e8-756f75a38900', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:08:41', 872, 0, '', '2019-05-12 00:08:42');
INSERT INTO `access_log` VALUES (222, '527e21ec-20eb-4fda-9dea-58b0cd58885b', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:08:42', 51, 0, '', '2019-05-12 00:08:42');
INSERT INTO `access_log` VALUES (223, '743b8357-841d-4766-bf43-30a76a7eba7a', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:08:42', 131, 0, '', '2019-05-12 00:08:42');
INSERT INTO `access_log` VALUES (224, '23362435-4af1-4882-b1f3-7944a54b12ad', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:08:45', 1337, 2001001000, '服务端发生异常', '2019-05-12 00:08:46');
INSERT INTO `access_log` VALUES (225, '558a6b04-5f0b-4b42-8552-bf02ddffb1fe', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:12:48', 448, 0, '', '2019-05-12 00:12:49');
INSERT INTO `access_log` VALUES (226, '91423343-614f-48fe-9868-dbd87778ab0b', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:12:54', 40, 0, '', '2019-05-12 00:12:54');
INSERT INTO `access_log` VALUES (227, '360c1c33-854d-4c3a-b20a-1d4a493c3709', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:12:56', 28, 0, '', '2019-05-12 00:12:56');
INSERT INTO `access_log` VALUES (228, 'd4476d14-31a3-427b-b92b-19397e62d146', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:12:58', 39, 0, '', '2019-05-12 00:12:58');
INSERT INTO `access_log` VALUES (229, 'd63f13f5-ba82-456f-b859-cfcb34a10dd2', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:13:00', 27, 0, '', '2019-05-12 00:13:00');
INSERT INTO `access_log` VALUES (230, '46ee70ca-2689-4b94-adad-59f926eabd89', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:13:02', 31, 0, '', '2019-05-12 00:13:02');
INSERT INTO `access_log` VALUES (231, '948d60cd-768b-4b3a-86d1-ab69b798b789', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:13:04', 51, 0, '', '2019-05-12 00:13:04');
INSERT INTO `access_log` VALUES (232, 'aab819b0-784f-4c34-a4f6-2fb90cedda62', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:13:06', 35, 0, '', '2019-05-12 00:13:06');
INSERT INTO `access_log` VALUES (233, '17581af8-9f9b-4877-bfdc-ce659bf9f596', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:13:07', 44, 0, '', '2019-05-12 00:13:07');
INSERT INTO `access_log` VALUES (234, '4b64984f-1dd7-4e5c-b006-594e7415445e', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:13:09', 34, 0, '', '2019-05-12 00:13:09');
INSERT INTO `access_log` VALUES (235, '860217ea-031f-463a-9f94-06c9fd853fc3', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:13:13', 28, 0, '', '2019-05-12 00:13:13');
INSERT INTO `access_log` VALUES (236, '6bef7b1d-3f0a-402e-a95e-651c519257e4', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:13:13', 336, 0, '', '2019-05-12 00:13:14');
INSERT INTO `access_log` VALUES (237, 'ab19425e-4f9a-4e4d-8f71-695d705836fd', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:13:16', 44, 0, '', '2019-05-12 00:13:16');
INSERT INTO `access_log` VALUES (238, 'cb58434f-d376-4884-8ab0-e4b982a4bf1b', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:13:17', 30, 0, '', '2019-05-12 00:13:17');
INSERT INTO `access_log` VALUES (239, '1a9b99b0-74b4-4f39-96c4-2ab532b42dfd', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:13:17', 91, 0, '', '2019-05-12 00:13:17');
INSERT INTO `access_log` VALUES (240, '32b3542e-ac27-4870-9045-8bd8262cb54d', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:13:18', 1024, 2001001000, '服务端发生异常', '2019-05-12 00:13:19');
INSERT INTO `access_log` VALUES (241, 'd75862dc-fb43-41ed-8515-1dcb1c68dd52', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:19:39', 33, 0, '', '2019-05-12 00:19:39');
INSERT INTO `access_log` VALUES (242, '7ae1b0a0-9290-4ecc-9c99-a5f4cea04be2', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:19:39', 365, 0, '', '2019-05-12 00:19:40');
INSERT INTO `access_log` VALUES (243, 'abc8cf12-2fc1-4241-90a2-ef126c043e10', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:19:45', 35, 0, '', '2019-05-12 00:19:45');
INSERT INTO `access_log` VALUES (244, 'fbcf3629-0f50-4e38-80a6-c89b5798edc5', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:19:45', 37, 0, '', '2019-05-12 00:19:45');
INSERT INTO `access_log` VALUES (245, '742d49b4-3db5-402a-8011-14fad6d96967', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:19:45', 105, 0, '', '2019-05-12 00:19:45');
INSERT INTO `access_log` VALUES (246, 'e63d5f52-8f88-4790-89cc-88bcbe7b3250', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:19:47', 6482, 2001001000, '服务端发生异常', '2019-05-12 00:19:53');
INSERT INTO `access_log` VALUES (247, 'cf184d6f-41a0-4cdb-add1-c782409dca45', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:26', 29, 0, '', '2019-05-12 00:20:26');
INSERT INTO `access_log` VALUES (248, 'c51c21a5-0acb-4817-926b-9d107a7ed389', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:28', 29, 0, '', '2019-05-12 00:20:28');
INSERT INTO `access_log` VALUES (249, '61d66440-5bdc-462f-83ff-1955fe4bc542', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:29', 983, 0, '', '2019-05-12 00:20:30');
INSERT INTO `access_log` VALUES (250, 'ab6c28d4-3cd7-4e0b-bf63-b7254b58fb21', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:31', 127, 0, '', '2019-05-12 00:20:31');
INSERT INTO `access_log` VALUES (251, 'bb1c98f2-4377-4314-87ec-d9e3ccd89f4f', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:32', 27, 0, '', '2019-05-12 00:20:32');
INSERT INTO `access_log` VALUES (252, '176bf3f4-a385-4860-ac0f-84985f49a7f2', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:33', 96, 0, '', '2019-05-12 00:20:33');
INSERT INTO `access_log` VALUES (253, '38feaa45-2726-4ea7-b1bb-1f18699e50a7', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:36', 29, 0, '', '2019-05-12 00:20:36');
INSERT INTO `access_log` VALUES (254, 'a87e6ae6-101b-40b4-9466-765f031cba99', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:42', 27, 0, '', '2019-05-12 00:20:42');
INSERT INTO `access_log` VALUES (255, '2b0047a6-3e5c-4d28-95bf-f41c1cd62a30', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:48', 27, 0, '', '2019-05-12 00:20:48');
INSERT INTO `access_log` VALUES (256, '2cc48f90-20e4-4c64-8343-0e43ed1bc144', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:48', 332, 0, '', '2019-05-12 00:20:49');
INSERT INTO `access_log` VALUES (257, '12cc0f21-80f4-4d94-8417-9441c6483ad6', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:50', 517, 0, '', '2019-05-12 00:20:50');
INSERT INTO `access_log` VALUES (258, '9a437e01-2d71-4dff-bc66-75ab577a40fa', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:50', 507, 0, '', '2019-05-12 00:20:50');
INSERT INTO `access_log` VALUES (259, 'e95be9ab-beab-4842-bc28-234016eb81a7', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:50', 61, 0, '', '2019-05-12 00:20:50');
INSERT INTO `access_log` VALUES (260, 'f13a5c4e-6bdb-4c9e-b4b6-8e09970accfe', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:51', 33, 0, '', '2019-05-12 00:20:51');
INSERT INTO `access_log` VALUES (261, '327b662b-5549-42dc-b0aa-e49c9d548d33', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:51', 87, 0, '', '2019-05-12 00:20:51');
INSERT INTO `access_log` VALUES (262, 'c2aba5a9-ed05-4491-b3c1-d9a2d23e0e93', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:52', 35, 0, '', '2019-05-12 00:20:52');
INSERT INTO `access_log` VALUES (263, '8d1b6e6c-91ea-4e7e-af97-e8ec8e6d4c95', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:53', 34, 0, '', '2019-05-12 00:20:53');
INSERT INTO `access_log` VALUES (264, 'd56fcfb2-2486-4ea2-a30e-a652ac774a7c', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:53', 90, 0, '', '2019-05-12 00:20:53');
INSERT INTO `access_log` VALUES (265, 'a5bd4e1b-0b59-457c-8106-67f41dfa9eea', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:20:54', 6939, 2001001000, '服务端发生异常', '2019-05-12 00:21:01');
INSERT INTO `access_log` VALUES (266, 'e5445ba8-3f69-40eb-8fab-92a9a96e1109', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:22:28', 2659, 2001001000, '服务端发生异常', '2019-05-12 00:22:31');
INSERT INTO `access_log` VALUES (267, '5a3be19f-72f9-4b4b-ae56-d62a2002d0ba', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:22:58', 2403, 2001001000, '服务端发生异常', '2019-05-12 00:23:00');
INSERT INTO `access_log` VALUES (268, '743b395c-c7d9-4e1a-8f2c-06506e49128e', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:23:10', 108477, 2001001000, '服务端发生异常', '2019-05-12 00:24:59');
INSERT INTO `access_log` VALUES (269, '516e4f8b-071a-4bdc-a326-f1d4cdae10df', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:26:24', 7407, 2001001000, '服务端发生异常', '2019-05-12 00:26:31');
INSERT INTO `access_log` VALUES (270, 'ba9ad362-40a0-4160-8395-c9abdc601b2a', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:29:22', 29, 0, '', '2019-05-12 00:29:22');
INSERT INTO `access_log` VALUES (271, 'a9e29825-02bb-40a1-bfbf-7c83709e246a', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:29:22', 334, 0, '', '2019-05-12 00:29:23');
INSERT INTO `access_log` VALUES (272, 'a328eedb-10b3-4460-9ca8-f739928a0f43', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:29:25', 33, 0, '', '2019-05-12 00:29:25');
INSERT INTO `access_log` VALUES (273, 'f17e6241-62db-492d-af5d-3012ec291c79', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:29:26', 27, 0, '', '2019-05-12 00:29:26');
INSERT INTO `access_log` VALUES (274, '110d52d4-ad2b-40cb-84d6-95a0884416cb', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:29:26', 98, 0, '', '2019-05-12 00:29:26');
INSERT INTO `access_log` VALUES (275, 'f8864bb8-3f3e-43f0-9797-50cf6141f961', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:29:31', 1377, 2001001000, '服务端发生异常', '2019-05-12 00:29:32');
INSERT INTO `access_log` VALUES (276, 'f1f5dcc5-2c0e-40c9-8299-30df1911f5e3', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:30:30', 29, 0, '', '2019-05-12 00:30:30');
INSERT INTO `access_log` VALUES (277, '4a6f81d8-9ddf-4c35-b2dc-5d3cce4fd254', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:30:30', 92, 0, '', '2019-05-12 00:30:30');
INSERT INTO `access_log` VALUES (278, '84dbbedb-0aa8-4315-939b-357345a58082', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:30:31', 30, 0, '', '2019-05-12 00:30:31');
INSERT INTO `access_log` VALUES (279, 'eeae2ee2-535e-47ad-9028-4753aeb53fed', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:30:32', 39, 0, '', '2019-05-12 00:30:32');
INSERT INTO `access_log` VALUES (280, 'd607c0a2-8d2b-485c-ab69-f88e88f7c8c8', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:30:32', 92, 0, '', '2019-05-12 00:30:32');
INSERT INTO `access_log` VALUES (281, 'fd5dcd63-9dd6-45db-b5f4-4cce9eeb2b03', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:30:33', 759, 2001001000, '服务端发生异常', '2019-05-12 00:30:34');
INSERT INTO `access_log` VALUES (282, '934b5a8a-c913-463c-b528-02b5777b4993', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:30:46', 683, 2001001000, '服务端发生异常', '2019-05-12 00:30:47');
INSERT INTO `access_log` VALUES (283, '9ce645ad-9c62-4954-9ff5-37db90182725', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:31:45', 1859, 2001001000, '服务端发生异常', '2019-05-12 00:31:47');
INSERT INTO `access_log` VALUES (284, 'ac9976bf-ae37-4f50-b179-d3b1569d4c3e', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:33:04', 627, 0, '', '2019-05-12 00:33:05');
INSERT INTO `access_log` VALUES (285, 'bd60a1bc-8c8e-47c9-8564-db2b66147b0d', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=193', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:33:05', 155, 0, '', '2019-05-12 00:33:05');
INSERT INTO `access_log` VALUES (286, 'cdd34759-10b4-49d6-a297-a5ee22b9f59c', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:46', 35, 0, '', '2019-05-12 00:34:46');
INSERT INTO `access_log` VALUES (287, '9b1c968e-a614-4784-b645-e5b82e471f77', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:46', 277, 0, '', '2019-05-12 00:34:46');
INSERT INTO `access_log` VALUES (288, 'ac2f51ad-5692-477d-ae79-bf8bbf77551d', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:47', 59, 0, '', '2019-05-12 00:34:47');
INSERT INTO `access_log` VALUES (289, '679b8c4e-b31e-48ac-a741-7bc75cfdc095', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:47', 81, 0, '', '2019-05-12 00:34:47');
INSERT INTO `access_log` VALUES (290, 'f33af141-3cfa-4733-9cb6-1997a1cd1fd8', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:47', 54, 0, '', '2019-05-12 00:34:47');
INSERT INTO `access_log` VALUES (291, 'a01304b2-d180-49ca-8a5a-deac62074d1b', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:47', 23, 0, '', '2019-05-12 00:34:47');
INSERT INTO `access_log` VALUES (292, '1466a2d6-27d4-4f6a-b74a-662ab92dd74f', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:47', 37, 0, '', '2019-05-12 00:34:47');
INSERT INTO `access_log` VALUES (293, 'e6c8b32f-442b-4209-a34a-f9628d2d209a', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:49', 43, 0, '', '2019-05-12 00:34:49');
INSERT INTO `access_log` VALUES (294, 'b117ec2c-40e6-40ea-b7f6-7a703e888d0a', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:50', 21, 0, '', '2019-05-12 00:34:50');
INSERT INTO `access_log` VALUES (295, '81defb9c-89a4-4f49-8b4e-15442a11e769', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:51', 34, 0, '', '2019-05-12 00:34:51');
INSERT INTO `access_log` VALUES (296, '3cace720-45ae-4750-bdd2-9c1f7407dc51', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:51', 53, 0, '', '2019-05-12 00:34:51');
INSERT INTO `access_log` VALUES (297, '20c48a07-e62d-4db7-847a-6c8b9141560e', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:52', 43, 0, '', '2019-05-12 00:34:52');
INSERT INTO `access_log` VALUES (298, 'ca32fed6-a757-4595-8a87-b47dcc5c8b49', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:52', 53, 0, '', '2019-05-12 00:34:52');
INSERT INTO `access_log` VALUES (299, 'a3982190-07a1-4e62-902f-40b7fa9a8ed6', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:53', 968, 0, '', '2019-05-12 00:34:54');
INSERT INTO `access_log` VALUES (300, 'a63d0f37-879b-4870-b387-ee10a252a88f', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:53', 1019, 0, '', '2019-05-12 00:34:54');
INSERT INTO `access_log` VALUES (301, 'bb0dd611-9451-40b3-8998-ffea3621d3f4', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:54', 43, 0, '', '2019-05-12 00:34:54');
INSERT INTO `access_log` VALUES (302, '81545347-130c-4439-baf2-3d9249c46d86', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:56', 25, 0, '', '2019-05-12 00:34:56');
INSERT INTO `access_log` VALUES (303, '73fc022a-cbd4-4c95-b1ae-09650e05eb45', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:34:56', 93, 0, '', '2019-05-12 00:34:56');
INSERT INTO `access_log` VALUES (304, '1c573c9b-5977-4683-8ed0-3c0d5bbe358c', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:01', 37, 0, '', '2019-05-12 00:35:01');
INSERT INTO `access_log` VALUES (305, '50b362cc-d861-4be0-b7fb-61fe71dd66bf', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:01', 90, 0, '', '2019-05-12 00:35:01');
INSERT INTO `access_log` VALUES (306, '8e8f3ae4-5caf-49af-a47f-40a8167a8922', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:01', 46, 0, '', '2019-05-12 00:35:01');
INSERT INTO `access_log` VALUES (307, 'bbd2b800-bd27-4c5a-9f8c-76ea5adba7ef', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:02', 52, 0, '', '2019-05-12 00:35:02');
INSERT INTO `access_log` VALUES (308, '5e1d19bb-cbde-4784-9cd1-1078c9cc0d39', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:02', 48, 0, '', '2019-05-12 00:35:02');
INSERT INTO `access_log` VALUES (309, '1d16a90b-cd11-4320-914c-9e3a9628c3b4', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:09', 34, 0, '', '2019-05-12 00:35:09');
INSERT INTO `access_log` VALUES (310, 'a3c65033-6354-493c-a340-3442872420ce', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:09', 74, 0, '', '2019-05-12 00:35:09');
INSERT INTO `access_log` VALUES (311, '068b5504-3743-47bb-b745-0a59629804a3', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:09', 47, 0, '', '2019-05-12 00:35:09');
INSERT INTO `access_log` VALUES (312, '1e5f25fc-9c19-4158-9a3a-7a9bc5c6982e', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:11', 359, 0, '', '2019-05-12 00:35:11');
INSERT INTO `access_log` VALUES (313, '501985df-b5ef-4ed6-853d-10148f6e3932', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:11', 403, 0, '', '2019-05-12 00:35:11');
INSERT INTO `access_log` VALUES (314, 'd7903bd5-089a-45db-a9b7-04be9ec693b5', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:14', 32, 0, '', '2019-05-12 00:35:14');
INSERT INTO `access_log` VALUES (315, '615bd2a0-9b2b-4c4a-888d-bfcfa6fce326', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:14', 79, 0, '', '2019-05-12 00:35:14');
INSERT INTO `access_log` VALUES (316, 'beac17c4-c3cf-482c-9ce5-24e9fa7ba7c7', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:14', 41, 0, '', '2019-05-12 00:35:14');
INSERT INTO `access_log` VALUES (317, 'f1d9e98c-136a-4197-a574-72987f16a490', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:14', 31, 0, '', '2019-05-12 00:35:14');
INSERT INTO `access_log` VALUES (318, 'd33ae2c2-7615-4745-a0b9-d98ef3758fe3', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:14', 42, 0, '', '2019-05-12 00:35:14');
INSERT INTO `access_log` VALUES (319, 'fae5e42a-7f7a-47d2-8612-7759bf18f38e', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:16', 43, 0, '', '2019-05-12 00:35:16');
INSERT INTO `access_log` VALUES (320, '18a0da9b-72b1-496d-a074-6f86d55b7183', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:16', 94, 0, '', '2019-05-12 00:35:17');
INSERT INTO `access_log` VALUES (321, '3c452b64-d0cf-4fc9-b95e-a1c61b5317ef', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=44', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:17', 47, 0, '', '2019-05-12 00:35:17');
INSERT INTO `access_log` VALUES (322, '7cb7af76-ae5d-415d-a1fc-42a516f49de7', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:19', 34, 0, '', '2019-05-12 00:35:19');
INSERT INTO `access_log` VALUES (323, '322ed5db-c23f-4058-a803-57e14dea8c2d', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=44&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:19', 83, 0, '', '2019-05-12 00:35:19');
INSERT INTO `access_log` VALUES (324, 'b9311be7-af8e-4b1d-a55e-8f8eccab5e0c', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:23', 28, 0, '', '2019-05-12 00:35:23');
INSERT INTO `access_log` VALUES (325, '71e59e2a-3c92-4751-ab01-78736adcec93', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:23', 82, 0, '', '2019-05-12 00:35:23');
INSERT INTO `access_log` VALUES (326, '9c8313cf-3c39-45a8-98e8-a58e8b0b141c', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=44', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:23', 40, 0, '', '2019-05-12 00:35:23');
INSERT INTO `access_log` VALUES (327, 'aacfe790-79aa-475b-a94a-30b76a3c990e', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:30', 40, 0, '', '2019-05-12 00:35:31');
INSERT INTO `access_log` VALUES (328, '56147597-2abc-4010-8ce9-6a83b38f19fd', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:30', 49, 0, '', '2019-05-12 00:35:31');
INSERT INTO `access_log` VALUES (329, 'a0bbdd12-0459-44bf-8471-7797ed04df7e', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:32', 47, 0, '', '2019-05-12 00:35:32');
INSERT INTO `access_log` VALUES (330, '71b20f75-94f5-4d0a-a50f-f588190cc174', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:32', 19, 0, '', '2019-05-12 00:35:32');
INSERT INTO `access_log` VALUES (331, '2b0818f8-e56b-405b-b44c-96051931f71e', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:35:32', 241, 0, '', '2019-05-12 00:35:33');
INSERT INTO `access_log` VALUES (332, '96cbd97b-8da2-4765-8454-d88ec5fff4c1', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:36:44', 38, 0, '', '2019-05-12 00:36:44');
INSERT INTO `access_log` VALUES (333, '258fb549-f4cb-42a3-a879-adb5cc005fed', 1, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:36:46', 259, 0, '', '2019-05-12 00:36:47');
INSERT INTO `access_log` VALUES (334, '7a4b11a1-9041-404c-a1ab-9fafab9018ee', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:37:41', 37, 0, '', '2019-05-12 00:37:41');
INSERT INTO `access_log` VALUES (335, '810d11e9-f65e-4134-8515-f447a9304c7c', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:37:42', 38, 0, '', '2019-05-12 00:37:42');
INSERT INTO `access_log` VALUES (336, '7934fab4-f8e6-4fea-a55f-b65206b2148f', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:37:42', 22, 0, '', '2019-05-12 00:37:42');
INSERT INTO `access_log` VALUES (337, '4ed8a438-e951-43f4-82a2-e2b7963f0a65', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:37:43', 38, 0, '', '2019-05-12 00:37:43');
INSERT INTO `access_log` VALUES (338, 'dadf13a8-eaca-487b-8a77-dd21f8db389f', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:37:45', 512, 0, '', '2019-05-12 00:37:45');
INSERT INTO `access_log` VALUES (339, '0d7e64d3-f3d4-44a5-81f9-ebee75512318', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:37:45', 518, 0, '', '2019-05-12 00:37:45');
INSERT INTO `access_log` VALUES (340, '3641e6a1-03f1-42ea-8335-afe71b283925', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:37:48', 67, 0, '', '2019-05-12 00:37:48');
INSERT INTO `access_log` VALUES (341, '91b8057d-e04e-4e2d-9a6e-e9f4476cecfc', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:37:48', 87, 0, '', '2019-05-12 00:37:48');
INSERT INTO `access_log` VALUES (342, 'ace913d6-ff90-447a-9eb6-952a4ba3ab07', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:37:48', 47, 0, '', '2019-05-12 00:37:48');
INSERT INTO `access_log` VALUES (343, 'befa7054-694b-4a6b-af0e-82fcb1887546', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:37:57', 37, 0, '', '2019-05-12 00:37:57');
INSERT INTO `access_log` VALUES (344, 'ac6e644c-90fc-43bd-b901-a5b43ecff548', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:37:57', 96, 0, '', '2019-05-12 00:37:57');
INSERT INTO `access_log` VALUES (345, '47c24f6f-cfa8-4465-ac0c-d8d108811216', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:38:51', 28, 0, '', '2019-05-12 00:38:51');
INSERT INTO `access_log` VALUES (346, 'd98a77c1-3d28-42bf-b584-3b141e479ae9', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:38:51', 92, 0, '', '2019-05-12 00:38:51');
INSERT INTO `access_log` VALUES (347, '612ea81b-c972-45f9-8c63-a151aec1b75d', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:39:52', 30, 0, '', '2019-05-12 00:39:52');
INSERT INTO `access_log` VALUES (348, '01c77035-be62-496e-ae37-d16d30494202', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:39:52', 139, 2001001000, '服务端发生异常', '2019-05-12 00:39:52');
INSERT INTO `access_log` VALUES (349, '1c479360-bee5-4ef2-8714-7cd15aca7794', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:40:08', 30, 0, '', '2019-05-12 00:40:09');
INSERT INTO `access_log` VALUES (350, 'c3589d5f-15db-46d7-82b4-29dfdb85caa0', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:40:08', 663, 0, '', '2019-05-12 00:40:09');
INSERT INTO `access_log` VALUES (351, 'f62e5648-4ba5-4dfb-bfd7-fcc530fece26', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:40:21', 32, 0, '', '2019-05-12 00:40:21');
INSERT INTO `access_log` VALUES (352, 'a3616756-a0e3-4558-9eaa-2898c5d78a35', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:40:21', 88, 0, '', '2019-05-12 00:40:21');
INSERT INTO `access_log` VALUES (353, '067ec4da-01d7-4bb9-ae87-3c46188aa4e5', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:43:54', 29, 0, '', '2019-05-12 00:43:55');
INSERT INTO `access_log` VALUES (354, '051fcbf4-0ad6-427e-8ace-8cd28106d3e1', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:43:55', 3892, 2001001000, '服务端发生异常', '2019-05-12 00:43:58');
INSERT INTO `access_log` VALUES (355, '4e0a0402-6538-4831-9134-4ee44133f476', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:44:02', 25, 0, '', '2019-05-12 00:44:02');
INSERT INTO `access_log` VALUES (356, '6d3d6c47-d137-4569-abe0-e5c7b75e7196', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:44:02', 155, 0, '', '2019-05-12 00:44:02');
INSERT INTO `access_log` VALUES (357, '3f0895ae-dc3e-402b-add6-495da0743fc4', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:44:03', 151, 0, '', '2019-05-12 00:44:04');
INSERT INTO `access_log` VALUES (358, '6c3d8cac-d87e-4bb7-9168-5eb230b98595', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:44:07', 186, 0, '', '2019-05-12 00:44:07');
INSERT INTO `access_log` VALUES (359, '11a57e3e-45dd-4e11-b479-d589aab3205c', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:44:10', 42, 0, '', '2019-05-12 00:44:10');
INSERT INTO `access_log` VALUES (360, '4a1dbcbe-fa46-4e99-8865-08e5612fbfc3', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:44:11', 26, 0, '', '2019-05-12 00:44:11');
INSERT INTO `access_log` VALUES (361, 'c69757aa-f9bb-49a6-ba13-0e9497a5d1df', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:44:11', 152, 0, '', '2019-05-12 00:44:11');
INSERT INTO `access_log` VALUES (362, 'ea4aade8-a3dd-478a-8adb-82bc130e2e91', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:44:13', 146, 0, '', '2019-05-12 00:44:13');
INSERT INTO `access_log` VALUES (363, 'c5045254-be55-4b2f-98a8-52e96aacf9f7', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:44:15', 1319, 0, '', '2019-05-12 00:44:16');
INSERT INTO `access_log` VALUES (364, 'e0226dce-c295-4e6c-98ce-c08d5d2874da', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=194', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:44:16', 37, 0, '', '2019-05-12 00:44:16');
INSERT INTO `access_log` VALUES (365, '586ad127-9d26-492b-88a9-268f8ad4995f', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:45:09', 27, 0, '', '2019-05-12 00:45:09');
INSERT INTO `access_log` VALUES (366, 'ccc391e1-a837-49d0-875d-cee397553193', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:45:09', 123, 0, '', '2019-05-12 00:45:09');
INSERT INTO `access_log` VALUES (367, 'c04760d9-cf52-49e0-b46c-d20541872f56', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:45:12', 145, 0, '', '2019-05-12 00:45:12');
INSERT INTO `access_log` VALUES (368, 'de8ed048-ed8a-4255-81c5-ee4cd956bdcf', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:45:13', 1147, 0, '', '2019-05-12 00:45:14');
INSERT INTO `access_log` VALUES (369, 'ee2d25aa-6747-44e2-a786-8d3e9efb1d43', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=195', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:45:14', 178, 0, '', '2019-05-12 00:45:14');
INSERT INTO `access_log` VALUES (370, '50f14f87-6fb6-4034-9662-44e5787a3649', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:45:35', 59, 0, '', '2019-05-12 00:45:35');
INSERT INTO `access_log` VALUES (371, 'f155d218-fd8b-4228-ac25-a88eded73265', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:45:35', 138, 0, '', '2019-05-12 00:45:35');
INSERT INTO `access_log` VALUES (372, '94c31c88-55dc-4f0c-b05b-af7821b63720', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:45:39', 138, 0, '', '2019-05-12 00:45:39');
INSERT INTO `access_log` VALUES (373, 'ebf3338a-37b3-4583-aac6-33326da473f9', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:45:39', 10823, 0, '', '2019-05-12 00:45:50');
INSERT INTO `access_log` VALUES (374, '143251b5-38d1-471d-bdae-137675ca55bf', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=196', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:45:50', 23, 0, '', '2019-05-12 00:45:50');
INSERT INTO `access_log` VALUES (375, '62871c20-1bc0-4a4a-8472-6de4e07ac99e', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:45:54', 36, 0, '', '2019-05-12 00:45:54');
INSERT INTO `access_log` VALUES (376, 'c906b855-88dd-4546-863f-f9a35aafca13', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:45:54', 139, 0, '', '2019-05-12 00:45:54');
INSERT INTO `access_log` VALUES (377, '628e4069-6283-4f46-84b9-87177caa0a8a', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:47:05', 28, 0, '', '2019-05-12 00:47:05');
INSERT INTO `access_log` VALUES (378, 'de925516-1b71-4bd0-997d-5807ce0049a2', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:47:05', 104, 0, '', '2019-05-12 00:47:05');
INSERT INTO `access_log` VALUES (379, 'c493bd2b-f694-4a4b-9445-2a7b2f9a66d1', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:47:07', 145, 0, '', '2019-05-12 00:47:07');
INSERT INTO `access_log` VALUES (380, '76b7f91c-3fe4-40c2-8bd3-da555c009795', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:47:09', 29, 0, '', '2019-05-12 00:47:09');
INSERT INTO `access_log` VALUES (381, 'c4ee9ada-6902-4196-a8fa-799ab6ad9c80', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:47:10', 47, 0, '', '2019-05-12 00:47:10');
INSERT INTO `access_log` VALUES (382, '489ed928-d4e7-4839-84aa-88f9f0740a76', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:47:10', 135, 0, '', '2019-05-12 00:47:10');
INSERT INTO `access_log` VALUES (383, 'dce50a3c-f8a5-450d-b201-f8c5c29ee57a', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:47:11', 141, 0, '', '2019-05-12 00:47:12');
INSERT INTO `access_log` VALUES (384, 'd7533d65-335e-47ba-b453-8b86a53b80ba', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:47:13', 9586, 2001001000, '服务端发生异常', '2019-05-12 00:47:22');
INSERT INTO `access_log` VALUES (385, 'a24a8f16-57d5-4168-ba5f-98fc4dfe42f8', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:48:17', 29, 0, '', '2019-05-12 00:48:17');
INSERT INTO `access_log` VALUES (386, 'e10b45fe-960a-4a2f-bb53-1c0bd331198f', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:48:17', 110, 0, '', '2019-05-12 00:48:17');
INSERT INTO `access_log` VALUES (387, '1016ece3-636d-41b2-9cac-8cb493f12fa1', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:48:18', 28, 0, '', '2019-05-12 00:48:18');
INSERT INTO `access_log` VALUES (388, 'a8e1d160-a079-474e-b3c7-0c85129b74b0', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:48:18', 21, 0, '', '2019-05-12 00:48:18');
INSERT INTO `access_log` VALUES (389, '0cf02146-861d-4404-844e-f19d2a5175bc', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:48:18', 126, 0, '', '2019-05-12 00:48:18');
INSERT INTO `access_log` VALUES (390, 'dc04cfa7-1744-4286-8361-5baf7833ca7a', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:48:21', 142, 0, '', '2019-05-12 00:48:21');
INSERT INTO `access_log` VALUES (391, '3126ef53-d103-493c-a602-8da5ccd24783', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:48:22', 4621, 1006003003, '优惠劵不处于待使用状态', '2019-05-12 00:48:27');
INSERT INTO `access_log` VALUES (392, '0f491465-c723-4f63-a56e-45321f1ad104', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:49:29', 28, 0, '', '2019-05-12 00:49:29');
INSERT INTO `access_log` VALUES (393, 'a04c429f-b53d-4332-bb49-92942761ccc4', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:49:32', 27, 0, '', '2019-05-12 00:49:32');
INSERT INTO `access_log` VALUES (394, '0bce4987-76f0-4721-bc99-334a36e93b7d', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:49:34', 27, 0, '', '2019-05-12 00:49:34');
INSERT INTO `access_log` VALUES (395, '64e0485b-ad29-45ab-9b0b-7bffae861ad9', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:49:37', 40, 0, '', '2019-05-12 00:49:37');
INSERT INTO `access_log` VALUES (396, '0a452ba1-7355-419d-a9fa-e5a56178482f', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:49:38', 29, 0, '', '2019-05-12 00:49:38');
INSERT INTO `access_log` VALUES (397, 'cdbaef68-834d-4ea6-ac12-4867599d6407', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:49:40', 26, 0, '', '2019-05-12 00:49:40');
INSERT INTO `access_log` VALUES (398, 'bbc9491a-b905-4ec3-be2f-a88d230b02b2', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:49:42', 32, 0, '', '2019-05-12 00:49:42');
INSERT INTO `access_log` VALUES (399, 'f3ced345-de1f-4698-83ae-4c45be0cc1e2', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:49:46', 35, 0, '', '2019-05-12 00:49:46');
INSERT INTO `access_log` VALUES (400, 'fdd5fc62-a701-4830-b09a-3cc8f50a0b6f', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:49:47', 26, 0, '', '2019-05-12 00:49:47');
INSERT INTO `access_log` VALUES (401, '79ea5dd3-b1c4-475e-998f-34319fb21ee4', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:49:49', 25, 0, '', '2019-05-12 00:49:49');
INSERT INTO `access_log` VALUES (402, '05eb3fa5-5eb1-40da-a40e-259ca161b58f', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:49:51', 44, 0, '', '2019-05-12 00:49:51');
INSERT INTO `access_log` VALUES (403, '25aec8fc-873c-48f4-a346-3103d8e629a6', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:49:52', 29, 0, '', '2019-05-12 00:49:52');
INSERT INTO `access_log` VALUES (404, '4907d561-dac7-438f-a09a-deab74cf15ae', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:50:00', 30, 0, '', '2019-05-12 00:50:00');
INSERT INTO `access_log` VALUES (405, 'c9f01476-3ae4-4fce-b6d0-552073db0f4c', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:50:08', 31, 0, '', '2019-05-12 00:50:08');
INSERT INTO `access_log` VALUES (406, 'cd2e82cf-858d-41ac-9cca-969d7df6e689', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:51:59', 25, 0, '', '2019-05-12 00:51:59');
INSERT INTO `access_log` VALUES (407, '65135902-445b-41eb-8a40-5589f11953ae', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:51:59', 1046, 0, '', '2019-05-12 00:52:00');
INSERT INTO `access_log` VALUES (408, '6fc3c4fc-15b8-40af-ad22-c3171eed7d5f', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:52:01', 25, 0, '', '2019-05-12 00:52:01');
INSERT INTO `access_log` VALUES (409, '7f8a9f85-c9b9-44ed-8493-d225dc964828', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:52:02', 23, 0, '', '2019-05-12 00:52:02');
INSERT INTO `access_log` VALUES (410, 'dd531193-d16b-49a9-8586-fc20790ebd40', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:52:02', 98, 0, '', '2019-05-12 00:52:02');
INSERT INTO `access_log` VALUES (411, 'fa0f77bd-4dad-4c63-8002-63b67d268610', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:52:05', 171, 0, '', '2019-05-12 00:52:05');
INSERT INTO `access_log` VALUES (412, 'f958e2cb-c64e-44eb-91bd-f42902e9cf01', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:52:06', 4984, 1006003003, '优惠劵不处于待使用状态', '2019-05-12 00:52:11');
INSERT INTO `access_log` VALUES (413, 'e6cffd6c-941f-4b54-bda5-e07d35abe2d5', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:57:58', 153, 1001001012, '访问令牌已过期', '2019-05-12 00:57:58');
INSERT INTO `access_log` VALUES (414, 'fb00618c-94d3-4951-908e-bc8c22034005', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:57:58', 159, 1001001012, '访问令牌已过期', '2019-05-12 00:57:58');
INSERT INTO `access_log` VALUES (415, '5504467a-947c-43e1-92c7-fbee5969a54e', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=22d5ccdb631c4af49b4dd0e9a56c8afa', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:57:58', 354, 0, '', '2019-05-12 00:57:58');
INSERT INTO `access_log` VALUES (416, '5907f7cf-a7b1-4854-995a-f95e84062909', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:57:59', 59, 1001001013, '访问令牌已失效', '2019-05-12 00:57:59');
INSERT INTO `access_log` VALUES (417, '88cac3ab-8367-403c-a2bc-c5572c27b1e4', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=22d5ccdb631c4af49b4dd0e9a56c8afa', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:57:58', 426, 0, '', '2019-05-12 00:57:59');
INSERT INTO `access_log` VALUES (418, '33fd64f8-70e3-40f3-9b19-c43ac1631562', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:57:59', 99, 0, '', '2019-05-12 00:57:59');
INSERT INTO `access_log` VALUES (419, 'e7b99d08-f677-49fc-b432-39d2b405b41e', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:58:06', 262, 0, '', '2019-05-12 00:58:06');
INSERT INTO `access_log` VALUES (420, '0aa7554a-ea8f-4a14-8c24-2e52f50f71dc', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:58:09', 372, 0, '', '2019-05-12 00:58:10');
INSERT INTO `access_log` VALUES (421, 'eec241ae-c4d4-4a4e-87a4-efeea0566300', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:58:11', 59, 0, '', '2019-05-12 00:58:11');
INSERT INTO `access_log` VALUES (422, '02155e24-79a3-4946-a9a9-1986c0ed1224', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:58:17', 1173, 0, '', '2019-05-12 00:58:18');
INSERT INTO `access_log` VALUES (423, '06f2c186-6dbd-4134-99ea-7a907876bf31', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:58:17', 1490, 0, '', '2019-05-12 00:58:19');
INSERT INTO `access_log` VALUES (424, '095078a0-1fa3-4be4-977a-1f9c42e91a15', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:00:41', 562, 0, '', '2019-05-12 01:00:41');
INSERT INTO `access_log` VALUES (425, '879a5926-bfde-4164-995d-bef82c614adf', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:00:41', 653, 0, '', '2019-05-12 01:00:41');
INSERT INTO `access_log` VALUES (426, '93f0a180-2776-4f2e-8289-cac0aaf573fd', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:00:42', 376, 0, '', '2019-05-12 01:00:42');
INSERT INTO `access_log` VALUES (427, '2ed043a0-2375-4931-8fa7-1c6937ad4f60', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:00:44', 365, 0, '', '2019-05-12 01:00:44');
INSERT INTO `access_log` VALUES (428, 'a3db709a-7398-42ae-b221-7ec66d7e0867', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:00:45', 276, 0, '', '2019-05-12 01:00:45');
INSERT INTO `access_log` VALUES (429, '460bc8f2-8e93-4fcc-9d1b-137333dc5e46', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:00:44', 1283, 0, '', '2019-05-12 01:00:45');
INSERT INTO `access_log` VALUES (430, '9a5d5ccf-5cb3-43c8-9b8c-c947eae779b1', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:00:46', 455, 0, '', '2019-05-12 01:00:46');
INSERT INTO `access_log` VALUES (431, 'b17bd61d-34b9-4d25-b2c4-94cf3576a187', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:00:46', 800, 0, '', '2019-05-12 01:00:47');
INSERT INTO `access_log` VALUES (432, '5043dc86-d129-4a6d-a36e-b37a5e727b7b', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:00:48', 592, 0, '', '2019-05-12 01:00:49');
INSERT INTO `access_log` VALUES (433, 'dcecc2c7-2f47-44a6-ace3-a60599231065', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:00:51', 7658, 2001001000, '服务端发生异常', '2019-05-12 01:00:58');
INSERT INTO `access_log` VALUES (434, '3edd2d77-0e37-4d55-838c-ea48d38b9c8f', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:01:12', 3882, 1006003003, '优惠劵不处于待使用状态', '2019-05-12 01:01:16');
INSERT INTO `access_log` VALUES (435, 'a9214ad3-dc56-4839-8bd3-f1fcf8e00aff', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:01:19', 3004, 1006003003, '优惠劵不处于待使用状态', '2019-05-12 01:01:22');
INSERT INTO `access_log` VALUES (436, '223fdefe-39c1-48d3-8814-277e78c718e8', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:01:40', 4636, 2001001000, '服务端发生异常', '2019-05-12 01:01:45');
INSERT INTO `access_log` VALUES (437, '6a17c874-afc8-42e3-9ca3-1e7e503a7662', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:40:53', 38, 0, '', '2019-05-12 01:40:53');
INSERT INTO `access_log` VALUES (438, 'a83e24a1-0b6c-4df1-ba8b-e4e669320e72', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:40:55', 33, 0, '', '2019-05-12 01:40:55');
INSERT INTO `access_log` VALUES (439, '1a6e8c15-56d9-4685-b2cd-bfcd65c36d1b', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:41:28', 32, 0, '', '2019-05-12 01:41:28');
INSERT INTO `access_log` VALUES (440, '8b6b7527-6fa9-4252-bd5f-a504c2ce91c1', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:41:30', 62, 0, '', '2019-05-12 01:41:30');
INSERT INTO `access_log` VALUES (441, '2fc4b393-5e9c-4f27-b3c6-281667a2b03b', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:41:33', 34, 0, '', '2019-05-12 01:41:33');
INSERT INTO `access_log` VALUES (442, 'cb09305f-7bff-41b8-a1b5-0b1edd8bfcd7', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:42:38', 75, 0, '', '2019-05-12 01:42:38');
INSERT INTO `access_log` VALUES (443, 'ebdba91b-1988-46d4-9686-9b590628d984', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:42:38', 784, 0, '', '2019-05-12 01:42:38');
INSERT INTO `access_log` VALUES (444, '19de5d9c-5b7a-4602-93b8-2084cc555452', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:42:41', 68, 0, '', '2019-05-12 01:42:41');
INSERT INTO `access_log` VALUES (445, '6be88119-8d39-425f-a8fd-350279f0b61d', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:42:42', 33, 0, '', '2019-05-12 01:42:42');
INSERT INTO `access_log` VALUES (446, '2734e374-8868-493d-894b-cc3c6c073579', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:42:42', 219, 0, '', '2019-05-12 01:42:42');
INSERT INTO `access_log` VALUES (447, 'c26d4b03-49d5-442d-bc46-a0c179321a87', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:42:44', 162, 0, '', '2019-05-12 01:42:44');
INSERT INTO `access_log` VALUES (448, '17f42666-0e37-4ca6-a705-eb95691a1b9d', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:42:45', 3711, 2001001000, '服务端发生异常', '2019-05-12 01:42:48');
INSERT INTO `access_log` VALUES (449, '336e79f7-d18f-4d46-a9f6-2f65712603f4', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:44:01', 837, 2001001000, '服务端发生异常', '2019-05-12 01:44:02');
INSERT INTO `access_log` VALUES (450, 'a405e41a-b407-4794-8aea-1eb932021a99', 0, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:46:12', 22, 1001001012, '访问令牌已过期', '2019-05-12 01:46:12');
INSERT INTO `access_log` VALUES (451, '250e1cad-bbf0-4671-9064-4608859f9187', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=c09c1d1c02314cf69cd626675f71fe53', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:46:13', 203, 0, '', '2019-05-12 01:46:13');
INSERT INTO `access_log` VALUES (452, '6259c563-6ff3-4a55-87d9-46dd84a3c2f1', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:46:13', 195, 2001001000, '服务端发生异常', '2019-05-12 01:46:13');
INSERT INTO `access_log` VALUES (453, '44763730-03a6-477e-a13c-d5e342b2169f', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:47:20', 2377, 1006003003, '优惠劵不处于待使用状态', '2019-05-12 01:47:23');
INSERT INTO `access_log` VALUES (454, 'fee8f9fc-ef9e-4e1a-b2df-84dd425aa3b8', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:47:53', 27, 0, '', '2019-05-12 01:47:53');
INSERT INTO `access_log` VALUES (455, '8e5051c5-1544-4f9b-9059-d23f3747b32b', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:47:53', 572, 0, '', '2019-05-12 01:47:53');
INSERT INTO `access_log` VALUES (456, 'd6d344c5-bfa7-49f3-8d59-e9919a1b65e6', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:47:56', 138, 0, '', '2019-05-12 01:47:56');
INSERT INTO `access_log` VALUES (457, '213aa040-f0d8-4b6e-98a9-45c23ad6073c', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:47:56', 39, 0, '', '2019-05-12 01:47:56');
INSERT INTO `access_log` VALUES (458, '1903e50d-23ce-4ede-849b-680219381ddc', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:47:57', 29, 0, '', '2019-05-12 01:47:57');
INSERT INTO `access_log` VALUES (459, '5ae57a62-c494-405b-bd49-e585e8479b8e', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:47:57', 116, 0, '', '2019-05-12 01:47:57');
INSERT INTO `access_log` VALUES (460, '22e98e00-28a7-46b9-9de0-4eca037647a7', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:47:59', 142, 0, '', '2019-05-12 01:47:59');
INSERT INTO `access_log` VALUES (461, '89d76b6c-1a83-43b5-92f0-7862e026c563', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:48:00', 7598, 2001001000, '服务端发生异常', '2019-05-12 01:48:07');
INSERT INTO `access_log` VALUES (462, '73de5806-754a-46cc-8d72-d78c8b908a25', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=2', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:49:57', 171, 0, '', '2019-05-12 01:49:57');
INSERT INTO `access_log` VALUES (463, '0aaff8a1-630b-4f1c-a58b-55af337b58bd', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:49:58', 6072, 1006003003, '优惠劵不处于待使用状态', '2019-05-12 01:50:04');
INSERT INTO `access_log` VALUES (464, 'a3981831-93de-4ecc-b697-c58a0ec4f8ce', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:50:18', 3609, 2001001000, '服务端发生异常', '2019-05-12 01:50:21');
INSERT INTO `access_log` VALUES (465, '300a3fca-bdf9-4a18-ad17-85a85d3738ec', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:50:36', 32, 0, '', '2019-05-12 01:50:36');
INSERT INTO `access_log` VALUES (466, 'c60c3f66-a73c-4621-ab19-6d9e45e7f8bc', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:50:36', 111, 0, '', '2019-05-12 01:50:36');
INSERT INTO `access_log` VALUES (467, '839bf11d-3a52-4b7d-9e53-537d24b290fe', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:50:38', 567, 0, '', '2019-05-12 01:50:39');
INSERT INTO `access_log` VALUES (468, '05dd6f7f-c626-4b54-90ca-0542aba8d5e6', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:50:40', 37, 0, '', '2019-05-12 01:50:40');
INSERT INTO `access_log` VALUES (469, '9a8f71c2-4dfd-49c9-9578-585e114be438', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:50:41', 27, 0, '', '2019-05-12 01:50:41');
INSERT INTO `access_log` VALUES (470, '3d443561-2728-4089-a3da-5a54c50c623b', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:50:41', 110, 0, '', '2019-05-12 01:50:41');
INSERT INTO `access_log` VALUES (471, 'b21dd47c-f566-42b8-9223-9f00b80aa638', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:50:43', 153, 0, '', '2019-05-12 01:50:43');
INSERT INTO `access_log` VALUES (472, 'd2cacfc0-8186-4b2c-898a-37f5739e2d70', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:51:20', 3619, 2001001000, '服务端发生异常', '2019-05-12 01:51:24');
INSERT INTO `access_log` VALUES (473, '8c509646-dc4e-4946-a88b-17186db9b210', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:52:15', 4443, 1006003003, '优惠劵不处于待使用状态', '2019-05-12 01:52:20');
INSERT INTO `access_log` VALUES (474, 'bdf1d1ee-164b-48f2-b9bb-d3cf50984ea1', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:52:28', 4481, 2001001000, '服务端发生异常', '2019-05-12 01:52:32');
INSERT INTO `access_log` VALUES (475, '98d6186a-2f4c-4195-92dd-c11b8aeb9b09', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:52:59', 3776, 2001001000, '服务端发生异常', '2019-05-12 01:53:03');
INSERT INTO `access_log` VALUES (476, 'd2a65489-580e-464c-a000-c57a80ef2469', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:53:26', 32, 0, '', '2019-05-12 01:53:26');
INSERT INTO `access_log` VALUES (477, 'd95dcc1c-ba53-48d5-9704-5ff856078116', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:53:26', 108, 0, '', '2019-05-12 01:53:26');
INSERT INTO `access_log` VALUES (478, '766c2a6b-54f9-42fc-abae-edeebcf6bec9', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:54:32', 137, 0, '', '2019-05-12 01:54:33');
INSERT INTO `access_log` VALUES (479, '35b01b83-2e28-4db3-abc6-fca7ea3102f0', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:54:35', 29, 0, '', '2019-05-12 01:54:35');
INSERT INTO `access_log` VALUES (480, 'cd79c13c-6b54-445b-94bd-d39f08d74286', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:54:36', 43, 0, '', '2019-05-12 01:54:36');
INSERT INTO `access_log` VALUES (481, '2ed75946-e25c-48ca-a3b4-62de897bc423', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:54:36', 111, 0, '', '2019-05-12 01:54:36');
INSERT INTO `access_log` VALUES (482, 'e725a4ea-67ea-42ea-b5ae-25b5c395fe2b', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:54:38', 136, 0, '', '2019-05-12 01:54:38');
INSERT INTO `access_log` VALUES (483, 'd00c6caf-2738-4b08-94a6-30a7ea9ce1d1', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:54:41', 3358, 2001001000, '服务端发生异常', '2019-05-12 01:54:45');
INSERT INTO `access_log` VALUES (484, '292e2168-8a25-4dd9-869b-0256f3bae399', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:56:06', 4403, 2001001000, '服务端发生异常', '2019-05-12 01:56:10');
INSERT INTO `access_log` VALUES (485, 'f7a4566a-9b45-49f9-93d6-c0c50efa0d32', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=3', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:56:32', 129, 0, '', '2019-05-12 01:56:32');
INSERT INTO `access_log` VALUES (486, 'eebc7013-8a99-4005-844e-b30d022c8877', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:56:33', 3591, 1006003003, '优惠劵不处于待使用状态', '2019-05-12 01:56:37');
INSERT INTO `access_log` VALUES (487, 'abfaa804-b376-4be1-bb14-f74fa788cd40', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:56:56', 3308, 2001001000, '服务端发生异常', '2019-05-12 01:56:59');
INSERT INTO `access_log` VALUES (488, '51ef2b12-9037-4713-9011-24a38d4b75e2', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 12:21:39', 1202, 1001001012, '访问令牌已过期', '2019-05-12 12:21:41');
INSERT INTO `access_log` VALUES (489, '24544aa3-bc8f-4333-9aed-c16aaa2d8c0f', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 12:21:39', 1202, 1001001012, '访问令牌已过期', '2019-05-12 12:21:41');
INSERT INTO `access_log` VALUES (490, '473399c5-2aec-4178-bb2d-5b6c6e9c88d5', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=c09c1d1c02314cf69cd626675f71fe53', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 12:21:41', 284, 0, '', '2019-05-12 12:21:41');
INSERT INTO `access_log` VALUES (491, 'b399cdd3-4bb8-4e3a-bd4f-b6bbec3f2f8a', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=c09c1d1c02314cf69cd626675f71fe53', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 12:21:41', 284, 0, '', '2019-05-12 12:21:41');
INSERT INTO `access_log` VALUES (492, '87ce6acf-1e9c-4497-821f-f542e962bf66', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 12:21:42', 411, 0, '', '2019-05-12 12:21:43');
INSERT INTO `access_log` VALUES (493, '9afb6a59-4ffd-4dfc-8b90-6c17b338a89f', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 12:21:42', 1571, 0, '', '2019-05-12 12:21:44');
INSERT INTO `access_log` VALUES (494, '09e060a3-cd28-458a-aa6c-abd4686a5f14', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:15:49', 121, 1001001012, '访问令牌已过期', '2019-05-12 18:15:49');
INSERT INTO `access_log` VALUES (495, 'efb68c7a-b1e0-4be1-96f6-2d0297ccf246', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:15:49', 121, 1001001012, '访问令牌已过期', '2019-05-12 18:15:49');
INSERT INTO `access_log` VALUES (496, '3172fbe8-4d2f-4a27-93ab-9b80400af73a', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=c09c1d1c02314cf69cd626675f71fe53', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:15:50', 15, 1001001022, '访问令牌已过期', '2019-05-12 18:15:50');
INSERT INTO `access_log` VALUES (497, 'a5b4d3f0-3311-4cfa-9880-2a5c37c2d56c', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=c09c1d1c02314cf69cd626675f71fe53', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:15:50', 15, 1001001022, '访问令牌已过期', '2019-05-12 18:15:50');
INSERT INTO `access_log` VALUES (498, 'df256908-ef34-4621-8361-eb02709297e6', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:15:52', 86, 1001001012, '访问令牌已过期', '2019-05-12 18:15:52');
INSERT INTO `access_log` VALUES (499, '8a4af86d-a4b5-4f6c-8b26-c7439249755b', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=c09c1d1c02314cf69cd626675f71fe53', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:15:52', 11, 1001001022, '访问令牌已过期', '2019-05-12 18:15:52');
INSERT INTO `access_log` VALUES (500, '0eb9be96-0c17-416a-8f27-71363f6f40d3', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:15:56', 31, 1001001012, '访问令牌已过期', '2019-05-12 18:15:56');
INSERT INTO `access_log` VALUES (501, '4bf2e9d5-170b-4adc-897a-2b47bde35878', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=c09c1d1c02314cf69cd626675f71fe53', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:15:56', 11, 1001001022, '访问令牌已过期', '2019-05-12 18:15:56');
INSERT INTO `access_log` VALUES (502, 'cf92cedb-15cb-4caf-8c78-abf316336be7', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:16:02', 121, 0, '', '2019-05-12 18:16:02');
INSERT INTO `access_log` VALUES (503, '70842495-7335-4e0f-8951-36fdcbf2028b', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:16:05', 208, 0, '', '2019-05-12 18:16:06');
INSERT INTO `access_log` VALUES (504, 'edecb4af-4ed4-406e-ac27-36f6ee1fd216', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:16:07', 105, 0, '', '2019-05-12 18:16:07');
INSERT INTO `access_log` VALUES (505, '9d0e5a9e-5411-4250-b5cc-aebf419f054d', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:43', 53, 0, '', '2019-05-12 18:25:43');
INSERT INTO `access_log` VALUES (506, '60fb91ec-a214-4512-a01f-3ebdf50bc347', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:43', 223, 0, '', '2019-05-12 18:25:44');
INSERT INTO `access_log` VALUES (507, '887ceed6-709c-4c39-9176-fa3b5eefe5a2', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:43', 273, 0, '', '2019-05-12 18:25:44');
INSERT INTO `access_log` VALUES (508, '96c93eed-8bf6-46d5-95f6-4075832b31d2', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:44', 39, 0, '', '2019-05-12 18:25:44');
INSERT INTO `access_log` VALUES (509, '7456b53a-416c-495a-b32d-d94c476e483f', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:46', 41, 0, '', '2019-05-12 18:25:46');
INSERT INTO `access_log` VALUES (510, 'e50ee77d-6247-401f-b797-2123bdb4f409', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:46', 67, 0, '', '2019-05-12 18:25:46');
INSERT INTO `access_log` VALUES (511, '3f13c3f0-a239-447c-888e-4eb599dc3745', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:51', 181, 0, '', '2019-05-12 18:25:51');
INSERT INTO `access_log` VALUES (512, '987aefc2-eb85-4ef0-8340-97727b2758f8', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:51', 208, 0, '', '2019-05-12 18:25:51');
INSERT INTO `access_log` VALUES (513, 'eef49a4f-b591-4410-a43b-77cb36a374b7', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:52', 172, 0, '', '2019-05-12 18:25:52');
INSERT INTO `access_log` VALUES (514, 'a1054330-451a-44fd-bfe0-8aaf99baeee3', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:55', 57, 0, '', '2019-05-12 18:25:55');
INSERT INTO `access_log` VALUES (515, 'd6decffc-0d0a-4469-9e3b-5b28da59fcaf', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:55', 184, 0, '', '2019-05-12 18:25:55');
INSERT INTO `access_log` VALUES (516, 'd3704af4-c311-409a-a34a-e530f369d17c', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:57', 43, 0, '', '2019-05-12 18:25:57');
INSERT INTO `access_log` VALUES (517, '5f1d89d6-bbc5-48cd-a6a1-2867703c1412', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:57', 35, 0, '', '2019-05-12 18:25:57');
INSERT INTO `access_log` VALUES (518, 'b43ff2eb-410b-4084-8ae4-bdef93273221', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:57', 134, 0, '', '2019-05-12 18:25:57');
INSERT INTO `access_log` VALUES (519, 'ec52db2d-e35e-41ec-a26f-d3938a3baf47', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:25:59', 149, 0, '', '2019-05-12 18:25:59');
INSERT INTO `access_log` VALUES (520, '6965b034-9f2d-494d-964d-95eeca1084f0', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:26:01', 3585, 2001001000, '服务端发生异常', '2019-05-12 18:26:05');
INSERT INTO `access_log` VALUES (521, '111a7aa8-2cfc-499c-a19c-a1c53749d3dc', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:33:36', 3399, 2001001000, '服务端发生异常', '2019-05-12 18:33:40');
INSERT INTO `access_log` VALUES (522, '5e58014f-b939-4758-83d4-f502497d0f5f', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:38:13', 32, 0, '', '2019-05-12 18:38:13');
INSERT INTO `access_log` VALUES (523, 'ac3c3ea3-01dc-41bf-aef8-e420c5055b83', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:38:13', 416, 0, '', '2019-05-12 18:38:14');
INSERT INTO `access_log` VALUES (524, '9b29dded-9454-4761-9a5e-16ce16dd384c', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:38:15', 35, 0, '', '2019-05-12 18:38:15');
INSERT INTO `access_log` VALUES (525, '0be6c7a2-66bc-448a-8b7d-58fda186f9c7', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:38:16', 33, 0, '', '2019-05-12 18:38:16');
INSERT INTO `access_log` VALUES (526, '9e6a1575-50a5-40db-8b8c-e60465f877f8', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:38:16', 123, 0, '', '2019-05-12 18:38:16');
INSERT INTO `access_log` VALUES (527, 'e84bd414-fd26-4fc8-a9cc-2c7f600c0ca7', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:38:19', 157, 0, '', '2019-05-12 18:38:19');
INSERT INTO `access_log` VALUES (528, '9fdd4235-16de-460e-b59f-f9513aa1a947', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:38:20', 12272, 0, '', '2019-05-12 18:38:33');
INSERT INTO `access_log` VALUES (529, '4dcd8c00-bc2a-486f-8e93-70df635a21e5', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=197', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:38:33', 124, 0, '', '2019-05-12 18:38:33');
INSERT INTO `access_log` VALUES (530, 'e1b5da09-0429-408c-82b0-2dbb1ad613da', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:38:59', 28, 0, '', '2019-05-12 18:38:59');
INSERT INTO `access_log` VALUES (531, 'e87cd09a-685c-46d8-a361-0fd3422fd266', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:38:59', 125, 0, '', '2019-05-12 18:38:59');
INSERT INTO `access_log` VALUES (532, 'df8a6078-19a5-49ee-bd65-acf640cb1a93', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:39:11', 281, 0, '', '2019-05-12 18:39:11');
INSERT INTO `access_log` VALUES (533, 'a0f3f5ca-ecf5-4a0d-8933-c035f745790e', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:39:11', 191, 0, '', '2019-05-12 18:39:11');
INSERT INTO `access_log` VALUES (534, '0139c9d8-6d7c-4614-9987-1fe1c64d577b', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:39:11', 823, 0, '', '2019-05-12 18:39:12');
INSERT INTO `access_log` VALUES (535, '2d287db7-271a-40d3-9987-52ca75ee2731', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:41:10', 78, 0, '', '2019-05-12 18:41:10');
INSERT INTO `access_log` VALUES (536, 'b73167a6-f156-48aa-beb3-702b288059af', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:42:16', 37, 0, '', '2019-05-12 18:42:16');
INSERT INTO `access_log` VALUES (537, '9b38fe64-6bd4-4ee7-9b0f-0d6107ef40b5', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:42:16', 322, 0, '', '2019-05-12 18:42:16');
INSERT INTO `access_log` VALUES (538, 'e9690471-958f-497c-851a-8a80ddf6c13f', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:42:17', 32, 0, '', '2019-05-12 18:42:17');
INSERT INTO `access_log` VALUES (539, '1021a7d6-d3a8-430a-8015-9fd7faf56ef6', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:42:18', 36, 0, '', '2019-05-12 18:42:18');
INSERT INTO `access_log` VALUES (540, 'cfb24033-8db0-4586-964a-f9e221c3445b', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:42:18', 149, 0, '', '2019-05-12 18:42:18');
INSERT INTO `access_log` VALUES (541, '68e4c566-29c0-4482-8be3-d4140769b0cb', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:42:19', 198, 0, '', '2019-05-12 18:42:20');
INSERT INTO `access_log` VALUES (542, 'e95d5fc3-0f56-45fb-9c03-97d2d3378521', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:42:25', 7647, 2001001000, '服务端发生异常', '2019-05-12 18:42:33');
INSERT INTO `access_log` VALUES (543, 'f6ff5ef5-198a-47e8-9aab-8555a118432a', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:46:40', 30, 1001001012, '访问令牌已过期', '2019-05-12 20:46:40');
INSERT INTO `access_log` VALUES (544, 'c71ec689-5bd7-47ef-a8b8-c12c49616add', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:46:40', 31, 1001001012, '访问令牌已过期', '2019-05-12 20:46:40');
INSERT INTO `access_log` VALUES (545, '17f2bc0c-68ff-4cfc-8535-73242c05686c', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=f10380d69898474e80f5ae37182bb281', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:46:40', 119, 0, '', '2019-05-12 20:46:40');
INSERT INTO `access_log` VALUES (546, '590e6bae-cae9-4b4c-9e0f-323cbc69ec31', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=f10380d69898474e80f5ae37182bb281', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:46:40', 160, 0, '', '2019-05-12 20:46:40');
INSERT INTO `access_log` VALUES (547, '025f17b7-757a-4845-ace4-194e3bdeb54e', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:46:40', 21, 0, '', '2019-05-12 20:46:41');
INSERT INTO `access_log` VALUES (548, '5f6b3ecc-29a1-4438-8801-023064caa048', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:46:40', 197, 2001001000, '服务端发生异常', '2019-05-12 20:46:41');
INSERT INTO `access_log` VALUES (549, '90313127-da28-491f-b663-65ac3bb7b2cc', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:46:43', 29, 0, '', '2019-05-12 20:46:43');
INSERT INTO `access_log` VALUES (550, 'a3e46dd3-a35d-4d53-98fe-1e7d198ad517', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:46:43', 221, 2001001000, '服务端发生异常', '2019-05-12 20:46:43');
INSERT INTO `access_log` VALUES (551, '82038faf-be4a-4d23-ada5-56503705f40b', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:49:24', 30, 0, '', '2019-05-12 20:49:24');
INSERT INTO `access_log` VALUES (552, 'b26be0db-2240-492b-99ab-55c27450f26e', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:49:24', 560, 0, '', '2019-05-12 20:49:25');
INSERT INTO `access_log` VALUES (553, 'f3648a83-735c-4d3f-b43b-00000914e84b', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:49:27', 37, 0, '', '2019-05-12 20:49:27');
INSERT INTO `access_log` VALUES (554, '77a6091b-7973-4a08-b40a-7d8dd5c93c6c', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:49:27', 129, 0, '', '2019-05-12 20:49:27');
INSERT INTO `access_log` VALUES (555, '34fc418a-5ae1-4450-8896-5a8b41e5360b', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:49:29', 402, 0, '', '2019-05-12 20:49:30');
INSERT INTO `access_log` VALUES (556, '2158dc69-aa53-4d82-8298-d06f9d1d79cc', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:49:30', 35, 0, '', '2019-05-12 20:49:30');
INSERT INTO `access_log` VALUES (557, 'fd21f064-a0ad-4a0e-a3c1-c72e18739e32', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:49:30', 126, 0, '', '2019-05-12 20:49:30');
INSERT INTO `access_log` VALUES (558, 'dd039350-660f-4f8e-9d03-8ed6227bf549', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:49:52', 170, 0, '', '2019-05-12 20:49:52');
INSERT INTO `access_log` VALUES (559, '1e3e01b3-0a54-470d-9d48-318e3947f75a', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:49:54', 347, 1006003003, '优惠劵不处于待使用状态', '2019-05-12 20:49:54');
INSERT INTO `access_log` VALUES (560, 'b7b4abff-6255-49a6-b335-7f90264f7e10', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:49:53', 1804, 2001001000, '服务端发生异常', '2019-05-12 20:49:55');
INSERT INTO `access_log` VALUES (561, 'bd7d5852-42c5-48e0-afc1-797dfb2b1446', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=2', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:50:08', 142, 0, '', '2019-05-12 20:50:08');
INSERT INTO `access_log` VALUES (562, 'e4d77fe9-f324-402f-9197-52e7366b2793', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:50:09', 902, 2001001000, '服务端发生异常', '2019-05-12 20:50:09');
INSERT INTO `access_log` VALUES (563, 'f2f40aa7-d03e-4a6a-8a12-5ea4b130ac0b', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:50:31', 859, 2001001000, '服务端发生异常', '2019-05-12 20:50:32');
INSERT INTO `access_log` VALUES (564, '6a913a96-2745-4931-ab29-69b7cd363d08', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:59:46', 906, 1001001012, '访问令牌已过期', '2019-05-12 20:59:47');
INSERT INTO `access_log` VALUES (565, '60b39447-0838-4b75-b537-1db3d6cddb2f', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:59:46', 906, 1001001012, '访问令牌已过期', '2019-05-12 20:59:47');
INSERT INTO `access_log` VALUES (566, '5394f3ce-fe50-404d-901e-ae6148f67dbf', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=33dd27aae48c406db3fe7f7069048023', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:59:47', 126, 1001001022, '访问令牌已过期', '2019-05-12 20:59:47');
INSERT INTO `access_log` VALUES (567, 'cac028bc-ef43-4a63-838a-f68fcb5d7ce4', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=33dd27aae48c406db3fe7f7069048023', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:59:47', 126, 1001001022, '访问令牌已过期', '2019-05-12 20:59:47');
INSERT INTO `access_log` VALUES (568, '6a51bb0e-c4e5-4d6c-a625-1b0884f0c590', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691300&code=999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:00:59', 1027, 0, '', '2019-05-12 21:01:00');
INSERT INTO `access_log` VALUES (569, 'd1e7ad8d-7fb1-42eb-9103-923aae015474', 29, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:01:01', 139, 0, '', '2019-05-12 21:01:01');
INSERT INTO `access_log` VALUES (570, '9d947124-773f-41cf-9951-d7a52595136c', 29, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:23', 10088, 0, '', '2019-05-12 21:07:34');
INSERT INTO `access_log` VALUES (571, '1385c1a7-f274-42d5-b86c-ae46f12935d0', 29, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:25', 10125, 0, '', '2019-05-12 21:07:35');
INSERT INTO `access_log` VALUES (572, '9d947124-773f-41cf-9951-d7a52595136c', 29, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:23', 10088, 0, '', '2019-05-12 21:07:35');
INSERT INTO `access_log` VALUES (573, '1385c1a7-f274-42d5-b86c-ae46f12935d0', 29, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:25', 10125, 0, '', '2019-05-12 21:07:36');
INSERT INTO `access_log` VALUES (574, '26ce5472-395e-42d9-8cd6-25b12ec91334', 29, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:31', 215, 0, '', '2019-05-12 21:07:31');
INSERT INTO `access_log` VALUES (575, 'e98a9d17-1d2c-4fa6-8361-39ad5a97b097', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:30', 6236, 2001001000, '服务端发生异常', '2019-05-12 21:07:36');
INSERT INTO `access_log` VALUES (576, '256100fd-37e2-4469-b4f8-f46f77e6d6c8', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:25', 10729, 2001001000, '服务端发生异常', '2019-05-12 21:07:36');
INSERT INTO `access_log` VALUES (577, '595294eb-2c59-4e34-afbb-7df5f39a5e66', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:21', 15319, 2001001000, '服务端发生异常', '2019-05-12 21:07:37');
INSERT INTO `access_log` VALUES (578, '26ce5472-395e-42d9-8cd6-25b12ec91334', 29, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:31', 215, 0, '', '2019-05-12 21:07:32');
INSERT INTO `access_log` VALUES (579, '9d79eaa7-783f-40c4-a573-316a6b395fb5', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:28', 10362, 2001001000, '服务端发生异常', '2019-05-12 21:07:38');
INSERT INTO `access_log` VALUES (580, '26ce5472-395e-42d9-8cd6-25b12ec91334', 29, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:31', 215, 0, '', '2019-05-12 21:07:33');
INSERT INTO `access_log` VALUES (581, '9d947124-773f-41cf-9951-d7a52595136c', 29, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:23', 10088, 0, '', '2019-05-12 21:07:33');
INSERT INTO `access_log` VALUES (582, '6be7120f-9ce0-4e21-9156-6857462edfa1', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:28', 10260, 2001001000, '服务端发生异常', '2019-05-12 21:07:39');
INSERT INTO `access_log` VALUES (583, '9e0b850b-821a-4973-8ae0-d6f2cc9df18d', 29, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:39', 110, 0, '', '2019-05-12 21:07:39');
INSERT INTO `access_log` VALUES (584, 'b7ba0352-c04b-4c20-bc20-4f0c8dd92d1f', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:29', 10260, 2001001000, '服务端发生异常', '2019-05-12 21:07:39');
INSERT INTO `access_log` VALUES (585, '918275be-d2b0-49d5-ac10-6484175e5304', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:40', 306, 2001001000, '服务端发生异常', '2019-05-12 21:07:40');
INSERT INTO `access_log` VALUES (586, '8cd08361-1943-4aa9-9654-bcc87c6925b9', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:10:34', 649, 2001001000, '服务端发生异常', '2019-05-12 21:10:34');
INSERT INTO `access_log` VALUES (587, '3388c67e-e0f9-48a6-b95e-a9c8333d0857', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:17:04', 40560, 2001001000, '服务端发生异常', '2019-05-12 21:17:45');
INSERT INTO `access_log` VALUES (588, '5cd3571d-6f6b-4c16-a6b2-c8b2c7de1971', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:17:18', 30391, 2001001000, '服务端发生异常', '2019-05-12 21:17:48');
INSERT INTO `access_log` VALUES (589, '40fde10a-efb9-4f68-97f1-d82f15d2a5cd', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:17:18', 30588, 2001001000, '服务端发生异常', '2019-05-12 21:17:49');
INSERT INTO `access_log` VALUES (590, '818e0ac5-20ff-46f9-8db9-f6044579f375', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:17', 523, 0, '', '2019-05-12 21:20:18');
INSERT INTO `access_log` VALUES (591, '6bff4fed-e15c-4e9b-a6bd-3a937ed1f9b2', 29, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:19', 115, 0, '', '2019-05-12 21:20:19');
INSERT INTO `access_log` VALUES (592, '4e793bd3-f05a-4c64-acce-953670d1f36f', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:20', 254, 0, '', '2019-05-12 21:20:20');
INSERT INTO `access_log` VALUES (593, 'b3ff73ed-066f-4525-a38e-adfb5ffe2953', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:22', 233, 0, '', '2019-05-12 21:20:22');
INSERT INTO `access_log` VALUES (594, '2e9763d6-7945-4adb-b04b-ea527eb9ea27', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:23', 118, 0, '', '2019-05-12 21:20:23');
INSERT INTO `access_log` VALUES (595, '054c58f1-340c-48d4-a056-66a57e362ef8', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:24', 236, 0, '', '2019-05-12 21:20:24');
INSERT INTO `access_log` VALUES (596, 'ff4b08be-1802-4b8f-8f7f-3259f2b552a0', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:25', 248, 0, '', '2019-05-12 21:20:26');
INSERT INTO `access_log` VALUES (597, '61e5ad01-7ab1-4dda-9ff6-042f74ad5487', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:27', 526, 0, '', '2019-05-12 21:20:27');
INSERT INTO `access_log` VALUES (598, 'f25ada3e-312b-4291-bbb4-385feb20c616', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:28', 244, 0, '', '2019-05-12 21:20:28');
INSERT INTO `access_log` VALUES (599, 'c965c086-b9a0-4198-9850-1f192c40d7c8', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:32', 241, 0, '', '2019-05-12 21:20:32');
INSERT INTO `access_log` VALUES (600, '5009cacd-c0b3-4f82-a0c6-395ce3d01398', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:34', 144, 0, '', '2019-05-12 21:20:34');
INSERT INTO `access_log` VALUES (601, 'e4bc0c25-cffa-426b-9221-0dc147e33df7', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:36', 272, 0, '', '2019-05-12 21:20:36');
INSERT INTO `access_log` VALUES (602, '9bef4f2f-33bb-4eaa-b96f-bfcff7111494', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:37', 255, 0, '', '2019-05-12 21:20:37');
INSERT INTO `access_log` VALUES (603, '0d62a42c-7b0c-4d31-8767-b95a1c379c9b', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:38', 270, 0, '', '2019-05-12 21:20:38');
INSERT INTO `access_log` VALUES (604, 'a6233516-c464-4772-be6e-4baf5de23f17', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:40', 229, 0, '', '2019-05-12 21:20:41');
INSERT INTO `access_log` VALUES (605, '88be1c1b-102a-419b-96d1-070b902b6b3b', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:41', 116, 0, '', '2019-05-12 21:20:41');
INSERT INTO `access_log` VALUES (606, '8479f795-65e0-4c97-893e-9406654c5dcc', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:42', 742, 0, '', '2019-05-12 21:20:43');
INSERT INTO `access_log` VALUES (607, 'f192df42-8292-4cc8-bdf0-6f6757ea86ac', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:43', 248, 0, '', '2019-05-12 21:20:43');
INSERT INTO `access_log` VALUES (608, 'f64e99d4-6f39-4afb-b8b2-3fce9f5928c7', 29, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:46', 110, 0, '', '2019-05-12 21:20:46');
INSERT INTO `access_log` VALUES (609, 'd77178b5-fcec-4b81-a0a5-baccb9ef80a0', 29, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:47', 1202, 0, '', '2019-05-12 21:20:49');
INSERT INTO `access_log` VALUES (610, '222c2c8d-2c33-4637-a1ec-d087c80d3158', 29, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:47', 1238, 0, '', '2019-05-12 21:20:49');
INSERT INTO `access_log` VALUES (611, 'f95f1769-d791-4337-8598-751dbe525491', 29, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:49', 230, 0, '', '2019-05-12 21:20:49');
INSERT INTO `access_log` VALUES (612, '72901360-324e-4b14-a649-eafcdface6d0', 29, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:50', 85, 0, '', '2019-05-12 21:20:50');
INSERT INTO `access_log` VALUES (613, 'a6d841ff-6657-4847-a016-8f9961a3e986', 29, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:51', 150, 0, '', '2019-05-12 21:20:51');
INSERT INTO `access_log` VALUES (614, '3875c354-d53f-48e8-8bc7-6eaca6d9c4a0', 29, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:51', 147, 0, '', '2019-05-12 21:20:51');
INSERT INTO `access_log` VALUES (615, '00167d6d-2292-4ddb-87b7-c637f149f40f', 29, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:53', 150, 0, '', '2019-05-12 21:20:53');
INSERT INTO `access_log` VALUES (616, '4c7fb5e2-29c7-4f1f-b17b-12db3a382015', 29, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:55', 149, 0, '', '2019-05-12 21:20:55');
INSERT INTO `access_log` VALUES (617, '295ae108-9cf5-49e4-ab2f-5ffb0d828286', 29, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:57', 147, 0, '', '2019-05-12 21:20:57');
INSERT INTO `access_log` VALUES (618, 'cc562ee6-5609-4bad-82b3-2e4734a93c93', 29, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:57', 77, 0, '', '2019-05-12 21:20:57');
INSERT INTO `access_log` VALUES (619, '85a7e7d7-571d-4dcf-a566-2be864b16ec8', 29, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:58', 267, 0, '', '2019-05-12 21:20:58');
INSERT INTO `access_log` VALUES (620, '3011a8a2-9e48-4753-a6ff-08e6c84cb744', 29, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:20:59', 78, 0, '', '2019-05-12 21:20:59');
INSERT INTO `access_log` VALUES (621, '4fc9be57-b003-4a35-a805-b6730c301526', 29, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:03', 149, 0, '', '2019-05-12 21:21:03');
INSERT INTO `access_log` VALUES (622, 'ced2505a-daad-45bc-b80b-3d299b0e9657', 29, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:03', 77, 0, '', '2019-05-12 21:21:03');
INSERT INTO `access_log` VALUES (623, 'ba066ba9-5c61-4a2f-8544-29b3b52fd062', 29, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:05', 511, 0, '', '2019-05-12 21:21:05');
INSERT INTO `access_log` VALUES (624, 'fa3227cc-3196-4b25-93b8-731d11e757ce', 29, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:10', 150, 0, '', '2019-05-12 21:21:10');
INSERT INTO `access_log` VALUES (625, '41665bce-4ab4-4ca5-bd79-ca3daecce4fb', 29, 1, 'order-application', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:10', 433, 0, '', '2019-05-12 21:21:10');
INSERT INTO `access_log` VALUES (626, '550226e5-cf2f-45bc-954e-0f68b04dffb1', 29, 1, 'order-application', '/order-api/users/order/create_order_from_cart', 'userAddressId=6&remark=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:13', 325, 2001001000, '服务端发生异常', '2019-05-12 21:21:13');
INSERT INTO `access_log` VALUES (627, '9e92bb7c-c6fd-441e-b940-ba8bd8cbd007', 29, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:17', 358, 0, '', '2019-05-12 21:21:17');
INSERT INTO `access_log` VALUES (628, 'c1fd8f4c-d0b2-454d-85cd-1866ddaa53a7', 29, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:18', 151, 0, '', '2019-05-12 21:21:18');
INSERT INTO `access_log` VALUES (629, '391d5913-ca9c-4f23-a633-4f7454c1e0b9', 29, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:18', 77, 0, '', '2019-05-12 21:21:18');
INSERT INTO `access_log` VALUES (630, '089b0c5f-2f6c-4270-8b5b-fbd68e5582c4', 29, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:20', 110, 0, '', '2019-05-12 21:21:20');
INSERT INTO `access_log` VALUES (631, 'e52cf7f7-b39c-4dc9-8dc1-c2082af9cd8e', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:21', 227, 0, '', '2019-05-12 21:21:21');
INSERT INTO `access_log` VALUES (632, '28f9373c-e487-40b1-9aeb-9050ddf7d6ca', 29, 1, 'order-application', '/order-api/users/order_logistics/info_order', 'orderId=47', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:25', 180, 0, '', '2019-05-12 21:21:26');
INSERT INTO `access_log` VALUES (633, '393391a0-3421-4894-8686-d81d39448c28', 29, 1, 'order-application', '/order-api/users/order_logistics/info_order', 'orderId=47', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:28', 149, 0, '', '2019-05-12 21:21:29');
INSERT INTO `access_log` VALUES (634, '9311fdef-1283-40a5-9463-eb5db877f038', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:31', 1008, 0, '', '2019-05-12 21:21:32');
INSERT INTO `access_log` VALUES (635, 'd60ff587-7c50-4f7b-8622-0c52e99074c6', 29, 1, 'order-application', '/order-api/users/order_logistics/info_order', 'orderId=48', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:35', 151, 0, '', '2019-05-12 21:21:35');
INSERT INTO `access_log` VALUES (636, '296fbad7-e08a-40cf-b914-71a45b3b528f', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:43', 235, 0, '', '2019-05-12 21:21:43');
INSERT INTO `access_log` VALUES (637, '888e2364-06bf-423d-9cbd-cd677b57f075', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:43', 228, 0, '', '2019-05-12 21:21:44');
INSERT INTO `access_log` VALUES (638, '0cfe8e35-137f-4721-a7af-d445b21adba3', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:44', 78, 0, '', '2019-05-12 21:21:44');
INSERT INTO `access_log` VALUES (639, '2b7af123-f4e0-4f75-83ae-4aea22bded91', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:45', 755, 0, '', '2019-05-12 21:21:45');
INSERT INTO `access_log` VALUES (640, 'd8d35af3-6fcf-4619-baa5-34177643ee56', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:46', 97, 0, '', '2019-05-12 21:21:46');
INSERT INTO `access_log` VALUES (641, 'c42bf1d4-6e06-4ae6-9bf8-a3a7951afc20', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:47', 234, 0, '', '2019-05-12 21:21:47');
INSERT INTO `access_log` VALUES (642, 'e668549a-4bc4-4af2-afc3-a1ecf02c16d8', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:23:11', 151, 0, '', '2019-05-12 21:23:11');
INSERT INTO `access_log` VALUES (643, 'be602637-5d43-4a0a-a3cb-1e098bf605cd', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:23:13', 233, 0, '', '2019-05-12 21:23:13');
INSERT INTO `access_log` VALUES (644, '946e4b65-e0a0-402a-a20e-aecfed6aa6f0', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:23:14', 228, 0, '', '2019-05-12 21:23:15');
INSERT INTO `access_log` VALUES (645, '4b3ff1c7-2c75-4a76-85bc-e31cb63bb633', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:23:16', 232, 0, '', '2019-05-12 21:23:16');
INSERT INTO `access_log` VALUES (646, '3b73b308-fdb8-4c10-805c-b1a3c37544d7', 29, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:23:17', 112, 0, '', '2019-05-12 21:23:17');
INSERT INTO `access_log` VALUES (647, 'f6093e66-88e4-4ab6-ab2d-3c2bacc63ade', 29, 1, 'product-application', '/product-api/users/spu/info', 'id=undefined', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:23:17', 482, 2001001000, '服务端发生异常', '2019-05-12 21:23:17');
INSERT INTO `access_log` VALUES (648, 'b362a309-db73-453d-9b09-097f634e68bb', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:23:20', 228, 0, '', '2019-05-12 21:23:20');
INSERT INTO `access_log` VALUES (649, '0f5630e8-4370-422e-9823-876d48fa2d65', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:23:22', 388, 0, '', '2019-05-12 21:23:22');
INSERT INTO `access_log` VALUES (650, '4c94e605-fdcb-4d5e-89db-af054c144238', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:24:02', 234, 0, '', '2019-05-12 21:24:02');
INSERT INTO `access_log` VALUES (651, 'ed07bd67-fcec-4fac-b843-a384ff66ad2d', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:24:03', 113, 0, '', '2019-05-12 21:24:03');
INSERT INTO `access_log` VALUES (652, '9745d9f7-65b5-47bc-b1b3-626514d34e7c', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:24:05', 227, 0, '', '2019-05-12 21:24:05');
INSERT INTO `access_log` VALUES (653, 'c156919d-6a2b-476a-8ef7-22b75a744eef', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:24:06', 230, 0, '', '2019-05-12 21:24:07');
INSERT INTO `access_log` VALUES (654, 'c35d8ddb-37b9-4efe-b1be-3dc35aee496f', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:24:38', 225, 0, '', '2019-05-12 21:24:38');
INSERT INTO `access_log` VALUES (655, '59b86284-750f-4f01-8bad-836e8114e3b0', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:24:39', 112, 0, '', '2019-05-12 21:24:39');
INSERT INTO `access_log` VALUES (656, '5d052988-b294-4e47-878d-f6107017354c', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:24:59', 227, 0, '', '2019-05-12 21:25:00');
INSERT INTO `access_log` VALUES (657, '90ce313a-5577-453d-8853-0f6e99c509d8', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:25:02', 229, 0, '', '2019-05-12 21:25:02');
INSERT INTO `access_log` VALUES (658, '2a3f47e8-f538-4ee4-9f49-11334b02aac8', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:25:03', 235, 0, '', '2019-05-12 21:25:04');
INSERT INTO `access_log` VALUES (659, 'fcb7c1aa-3620-45a1-b88f-35410f02efa2', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:25:04', 109, 0, '', '2019-05-12 21:25:04');
INSERT INTO `access_log` VALUES (660, 'e098e20d-a939-4a86-8e4e-61808d117584', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:25:06', 228, 0, '', '2019-05-12 21:25:06');
INSERT INTO `access_log` VALUES (661, 'a8715e28-71c7-432c-ab63-ce2088fad9d4', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:27:36', 265, 0, '', '2019-05-12 21:27:37');
INSERT INTO `access_log` VALUES (662, 'b4237947-7cff-4904-bcee-508810218e5b', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:28:13', 231, 0, '', '2019-05-12 21:28:14');
INSERT INTO `access_log` VALUES (663, 'd05c2fbc-132c-4e52-a355-3d7eb346130e', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:28:14', 235, 0, '', '2019-05-12 21:28:15');
INSERT INTO `access_log` VALUES (664, 'd3c4b2b3-f225-405f-beba-20eec70d5a31', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:28:15', 118, 0, '', '2019-05-12 21:28:15');
INSERT INTO `access_log` VALUES (665, '29d205a5-08c7-43a5-9421-591cec2352b8', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:28:16', 234, 0, '', '2019-05-12 21:28:16');
INSERT INTO `access_log` VALUES (666, '5c6604fa-e622-48e1-bee9-c85aadea319c', 29, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=50', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:28:19', 588, 100401000, '支付交易单不存在', '2019-05-12 21:28:20');
INSERT INTO `access_log` VALUES (667, '4d4b6325-2adc-4dc5-a013-a2ee00d4b82c', 29, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=50', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:30:32', 176, 100401000, '支付交易单不存在', '2019-05-12 21:30:32');
INSERT INTO `access_log` VALUES (668, 'ecc30dcb-4ddf-4646-8b58-921a020d0337', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:30:32', 264, 0, '', '2019-05-12 21:30:32');
INSERT INTO `access_log` VALUES (669, 'b2cb4e3c-3572-435b-9caf-6bfaefbbc37e', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:30:34', 1372, 0, '', '2019-05-12 21:30:35');
INSERT INTO `access_log` VALUES (670, '490d5012-f27f-441a-8816-d09e300ce0eb', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:30:39', 119, 0, '', '2019-05-12 21:30:39');
INSERT INTO `access_log` VALUES (671, '6abda501-9965-4a76-9adb-32c4d4a0a58e', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:30:35', 5235, 0, '', '2019-05-12 21:30:40');
INSERT INTO `access_log` VALUES (672, '2b28ce49-50ee-44a4-aada-7808d30cd5e0', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:30:40', 193, 0, '', '2019-05-12 21:30:40');
INSERT INTO `access_log` VALUES (673, '26b9e7f0-d849-4d70-8441-fc414ce07df4', 29, 1, 'order-application', '/order-api/users/order/info', 'orderId=50', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:30:42', 408, 0, '', '2019-05-12 21:30:42');
INSERT INTO `access_log` VALUES (674, 'baf23be9-73e5-47d1-95f3-131b400a8b41', 29, 1, 'order-application', '/order-api/users/order_return/reason', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:30:42', 5172, 0, '', '2019-05-12 21:30:47');
INSERT INTO `access_log` VALUES (675, '4fd4e5ad-5ad2-47a4-8860-48a83e17d0d0', 29, 1, 'order-application', '/order-api/users/order/info', 'orderId=50', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:31:23', 339, 0, '', '2019-05-12 21:31:23');
INSERT INTO `access_log` VALUES (676, 'f9e9062d-984a-4446-8947-a16b27205950', 29, 1, 'order-application', '/order-api/users/order_return/reason', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:31:23', 5173, 0, '', '2019-05-12 21:31:28');
INSERT INTO `access_log` VALUES (677, 'e7ea60ef-0744-437c-8377-a6b6b44a9ab8', 29, 1, 'order-application', '/order-api/users/order_return/apply', '', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:31:34', 359, 2001001000, '服务端发生异常', '2019-05-12 21:31:34');
INSERT INTO `access_log` VALUES (678, 'd046c2f9-37da-4105-9bea-fe27d81b55be', 29, 1, 'order-application', '/order-api/users/order/info', 'orderId=50', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:31:45', 506, 0, '', '2019-05-12 21:31:46');
INSERT INTO `access_log` VALUES (679, '6f9d24be-3758-480e-8ecf-be46cdbf88cb', 29, 1, 'order-application', '/order-api/users/order_return/reason', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:31:45', 5157, 0, '', '2019-05-12 21:31:51');
INSERT INTO `access_log` VALUES (680, 'd1c29a58-4373-4f52-a4e6-417372ddcd09', 29, 1, 'order-application', '/order-api/users/order_return/apply', '', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:31:53', 293, 2001001000, '服务端发生异常', '2019-05-12 21:31:53');
INSERT INTO `access_log` VALUES (681, 'b59787b4-4a2c-415e-97c3-3f9d4b4282ba', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:32:16', 233, 0, '', '2019-05-12 21:32:17');
INSERT INTO `access_log` VALUES (682, '00817be0-22f3-4b2c-9246-54170aa5484b', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:32:18', 226, 0, '', '2019-05-12 21:32:18');
INSERT INTO `access_log` VALUES (683, '763fe540-ae41-4ad4-918b-71fcedd6a631', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:32:19', 231, 0, '', '2019-05-12 21:32:19');
INSERT INTO `access_log` VALUES (684, '4439a563-8814-4674-aefc-6a185792f91a', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:32:20', 225, 0, '', '2019-05-12 21:32:20');
INSERT INTO `access_log` VALUES (685, 'cec84951-165c-456d-9fb5-d35141368ebe', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:32:21', 227, 0, '', '2019-05-12 21:32:21');
INSERT INTO `access_log` VALUES (686, '93809bf3-59bb-497b-a588-430437541726', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:32:22', 226, 0, '', '2019-05-12 21:32:22');
INSERT INTO `access_log` VALUES (687, 'ba028f37-c6e4-4c7c-9069-7c31c5ef460a', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:32:23', 227, 0, '', '2019-05-12 21:32:23');
INSERT INTO `access_log` VALUES (688, '335bf05b-1125-4a4e-b84a-91b7b4a63b37', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 22:28:06', 36, 1001001012, '访问令牌已过期', '2019-05-12 22:28:06');
INSERT INTO `access_log` VALUES (689, '5d604f02-0efd-4714-9724-2d7904d70080', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 22:28:06', 35, 1001001012, '访问令牌已过期', '2019-05-12 22:28:06');
INSERT INTO `access_log` VALUES (690, '28557fc7-6135-4a42-af9b-579ac96fd2fd', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=f10380d69898474e80f5ae37182bb281', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 22:28:07', 127, 0, '', '2019-05-12 22:28:07');
INSERT INTO `access_log` VALUES (691, '9278baf3-626f-4e19-b71e-b1b1e4541453', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=f10380d69898474e80f5ae37182bb281', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 22:28:07', 184, 0, '', '2019-05-12 22:28:07');
INSERT INTO `access_log` VALUES (692, 'a2ea8dc1-aff6-4a2c-bfe0-8a810588166e', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 22:28:07', 21, 0, '', '2019-05-12 22:28:07');
INSERT INTO `access_log` VALUES (693, 'd55d4ec2-82a5-407a-b20a-9f10fea1c858', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 22:28:07', 375, 0, '', '2019-05-12 22:28:07');
INSERT INTO `access_log` VALUES (694, '2e78f503-7585-482a-8915-3320f3a5414f', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:18', 18, 1001001012, '访问令牌已过期', '2019-05-12 23:21:18');
INSERT INTO `access_log` VALUES (695, '72277e4c-0587-4a07-bb3a-d59562ae3df4', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:18', 80, 1001001012, '访问令牌已过期', '2019-05-12 23:21:18');
INSERT INTO `access_log` VALUES (696, 'cc6c3b04-8c11-4771-982e-7d04c8435fe1', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=f10380d69898474e80f5ae37182bb281', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:18', 272, 0, '', '2019-05-12 23:21:19');
INSERT INTO `access_log` VALUES (697, '4be23c48-a926-4e3f-82a8-524258e9c04d', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:19', 11, 1001001013, '访问令牌已失效', '2019-05-12 23:21:19');
INSERT INTO `access_log` VALUES (698, '4c5aa730-cb0f-4d66-ae9a-8ca051e5213f', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=f10380d69898474e80f5ae37182bb281', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:18', 214, 0, '', '2019-05-12 23:21:19');
INSERT INTO `access_log` VALUES (699, 'b1fc1ee1-137f-429c-8e36-1ea066cac701', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:19', 331, 0, '', '2019-05-12 23:21:19');
INSERT INTO `access_log` VALUES (700, '78fb6178-2e63-4f7b-8d41-6fccfb36ffbe', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:25', 118, 0, '', '2019-05-12 23:21:26');
INSERT INTO `access_log` VALUES (701, '776a64be-6f38-4634-be6c-c09ef11c415a', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:30', 1692, 0, '', '2019-05-12 23:21:31');
INSERT INTO `access_log` VALUES (702, 'c9822331-034f-41b6-8661-df22043974de', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:31', 393, 0, '', '2019-05-12 23:21:31');
INSERT INTO `access_log` VALUES (703, '4bec40b9-a7da-41c5-9a75-b5f31c413b51', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:32', 486, 0, '', '2019-05-12 23:21:33');
INSERT INTO `access_log` VALUES (704, '0bb91204-f606-4af8-b414-d3d7c2a0cec8', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:36', 73, 0, '', '2019-05-12 23:21:36');
INSERT INTO `access_log` VALUES (705, 'eedfdb53-2c95-4002-b30d-eb9724667464', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:36', 23, 0, '', '2019-05-12 23:21:36');
INSERT INTO `access_log` VALUES (706, '85eb048b-0ab7-4a87-bbcc-3beea879329c', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:38', 42, 0, '', '2019-05-12 23:21:38');
INSERT INTO `access_log` VALUES (707, 'be1e4692-10e2-4dc0-8f70-c18a3b2e6826', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:39', 35, 0, '', '2019-05-12 23:21:39');
INSERT INTO `access_log` VALUES (708, '60a357b6-1a91-4a8b-a690-84b45931f2b7', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:39', 22, 0, '', '2019-05-12 23:21:39');
INSERT INTO `access_log` VALUES (709, 'bdaee96e-0c66-45a7-bf9f-f96c16f8022f', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:49', 196, 0, '', '2019-05-12 23:21:49');
INSERT INTO `access_log` VALUES (710, 'df91e270-51c5-4d03-94d6-3918235c441d', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:49', 207, 0, '', '2019-05-12 23:21:49');
INSERT INTO `access_log` VALUES (711, '55593414-3bac-47cd-8644-f15e2334a506', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:51', 90, 0, '', '2019-05-12 23:21:51');
INSERT INTO `access_log` VALUES (712, '2955780f-87d4-4a1b-909b-690fe728bef5', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:51', 134, 0, '', '2019-05-12 23:21:51');
INSERT INTO `access_log` VALUES (713, 'ea716e0c-49ce-4786-868d-a4647e1bc1e1', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:51', 67, 0, '', '2019-05-12 23:21:51');
INSERT INTO `access_log` VALUES (714, '0651f35a-3289-462e-90c3-a2d507d9c450', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:53', 30, 0, '', '2019-05-12 23:21:53');
INSERT INTO `access_log` VALUES (715, '11d922d4-f598-4045-9414-87886042848f', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:53', 124, 0, '', '2019-05-12 23:21:53');
INSERT INTO `access_log` VALUES (716, 'ff1fbca5-0161-4aef-a7ef-cc5f428febf8', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:55', 36, 0, '', '2019-05-12 23:21:55');
INSERT INTO `access_log` VALUES (717, 'bde9b402-621e-42ba-9c6f-a5590243e5f5', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:55', 39, 0, '', '2019-05-12 23:21:55');
INSERT INTO `access_log` VALUES (718, '5d33ae14-bdd7-47c4-8be7-41f0392748fc', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:55', 153, 0, '', '2019-05-12 23:21:55');
INSERT INTO `access_log` VALUES (719, '3184dcd1-79c4-49f0-afce-637d2482bf6c', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:01:56', 34, 0, '', '2019-05-13 00:01:56');
INSERT INTO `access_log` VALUES (720, 'af47cf82-5c7b-4fca-8887-b2da13d81261', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:02:04', 30, 0, '', '2019-05-13 00:02:04');
INSERT INTO `access_log` VALUES (721, '5264deba-f867-4642-b832-6a5c47d7c0c6', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:02:05', 32, 0, '', '2019-05-13 00:02:05');
INSERT INTO `access_log` VALUES (722, 'd6ef50cc-5328-4d5b-bb3e-0e4395e73111', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:02:06', 31, 0, '', '2019-05-13 00:02:06');
INSERT INTO `access_log` VALUES (723, '1e228f74-9602-40bf-b3a4-f13c179b643e', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:02:48', 31, 0, '', '2019-05-13 00:02:48');
INSERT INTO `access_log` VALUES (724, 'f1be1e00-f510-4ab7-9f3f-9ccae73c1845', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:02:49', 37, 0, '', '2019-05-13 00:02:50');
INSERT INTO `access_log` VALUES (725, '46aa4b9e-6769-49a2-b8ae-0087c837b229', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:02:50', 28, 0, '', '2019-05-13 00:02:50');
INSERT INTO `access_log` VALUES (726, '02c6a9d8-ea6c-4489-82fa-06a387f7da1b', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:03:13', 4107, 0, '', '2019-05-13 00:03:17');
INSERT INTO `access_log` VALUES (727, '9f41c640-76b5-4df3-947b-7a046b6e276a', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 23:21:56', 2481045, 2001001000, '服务端发生异常', '2019-05-13 00:03:17');
INSERT INTO `access_log` VALUES (728, 'ce8335ba-946f-4105-9d64-19375cea5f6e', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:03:17', 94, 0, '', '2019-05-13 00:03:17');
INSERT INTO `access_log` VALUES (729, '85c6a47e-9193-4c33-9b37-ba5b98dc1d1a', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:03:13', 18785, 2001001000, '服务端发生异常', '2019-05-13 00:03:32');
INSERT INTO `access_log` VALUES (730, 'ba7352b6-c86a-4d1e-9648-54f82cffd992', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:03:13', 18826, 2001001000, '服务端发生异常', '2019-05-13 00:03:32');
INSERT INTO `access_log` VALUES (731, '920ed990-fb32-40b8-889e-25405caf5b27', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:03:13', 18826, 2001001000, '服务端发生异常', '2019-05-13 00:03:32');
INSERT INTO `access_log` VALUES (732, 'e8568b18-c1a5-406b-b46e-c32d3ff917c5', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:03:13', 18993, 2001001000, '服务端发生异常', '2019-05-13 00:03:32');
INSERT INTO `access_log` VALUES (733, 'e6b5401a-98b1-451c-8f14-836dbf742ea5', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:16:50', 18, 1001001012, '访问令牌已过期', '2019-05-13 00:16:50');
INSERT INTO `access_log` VALUES (734, '9963abb4-7067-4959-99fd-e70a895c7426', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=9640c8b7a974462181eb221669d70702', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:16:50', 180, 0, '', '2019-05-13 00:16:50');
INSERT INTO `access_log` VALUES (735, '363e25a3-135e-4b83-95bd-47c2a5753ff6', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:16:50', 26, 0, '', '2019-05-13 00:16:50');
INSERT INTO `access_log` VALUES (736, '1f688cb3-e440-4c4d-a702-0cabba3f6567', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:16:51', 41, 0, '', '2019-05-13 00:16:51');
INSERT INTO `access_log` VALUES (737, '8396fc15-95aa-4b02-a21a-da5e603b698a', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:16:51', 126, 0, '', '2019-05-13 00:16:51');
INSERT INTO `access_log` VALUES (738, '4a3a8584-4c21-415f-9721-95d49fe82d23', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:16:53', 134, 0, '', '2019-05-13 00:16:53');
INSERT INTO `access_log` VALUES (739, '99acb4ff-ba7d-40b5-8a79-27fa43f1b716', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:16:54', 89639, 2001001000, '服务端发生异常', '2019-05-13 00:18:24');
INSERT INTO `access_log` VALUES (740, 'c571e0ca-9c0c-4c76-99f9-537157651184', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:18:46', 3600, 2001001000, '服务端发生异常', '2019-05-13 00:18:49');
INSERT INTO `access_log` VALUES (741, '83bac3de-bf6b-427d-97a8-bd1b3b26c3cb', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:21:47', 33174, 2001001000, '服务端发生异常', '2019-05-13 00:22:20');
INSERT INTO `access_log` VALUES (742, 'c60e1e17-52fa-4755-8bfd-a8a5b8425c2b', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:24:01', 28, 0, '', '2019-05-13 00:24:01');
INSERT INTO `access_log` VALUES (743, 'f732aed7-9edf-415e-8f74-80b57d28e044', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:24:01', 300, 2001001000, '服务端发生异常', '2019-05-13 00:24:01');
INSERT INTO `access_log` VALUES (744, 'ecf5cb1b-959c-4df0-8316-3856d35d3252', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:24:02', 27, 0, '', '2019-05-13 00:24:02');
INSERT INTO `access_log` VALUES (745, '4c9e74be-3aeb-4a1d-b6d3-3b6a73d4f4b2', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:24:02', 181, 2001001000, '服务端发生异常', '2019-05-13 00:24:02');
INSERT INTO `access_log` VALUES (746, '270941f1-9161-4363-9bd6-bd220960220b', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:24:05', 25, 0, '', '2019-05-13 00:24:05');
INSERT INTO `access_log` VALUES (747, 'ac594fa6-898e-409d-a5a1-b751c992b42c', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:24:05', 178, 2001001000, '服务端发生异常', '2019-05-13 00:24:05');
INSERT INTO `access_log` VALUES (748, '30eb0cee-c5fd-464c-b28b-4c66bb2d025a', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:24:06', 29, 0, '', '2019-05-13 00:24:06');
INSERT INTO `access_log` VALUES (749, 'f5670811-16b7-4f93-b1eb-b6d7b1a615c0', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:24:06', 283, 2001001000, '服务端发生异常', '2019-05-13 00:24:06');
INSERT INTO `access_log` VALUES (750, 'a321411a-b0a0-4ae3-a437-fc8399a74474', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:27:24', 40, 0, '', '2019-05-13 00:27:24');
INSERT INTO `access_log` VALUES (751, 'aa07510c-d027-41e7-a3d9-6cfdafb55e10', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:27:24', 38, 0, '', '2019-05-13 00:27:24');
INSERT INTO `access_log` VALUES (752, 'd2acacf9-e35e-4c2e-aa9a-c1bc8294dc61', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:27:24', 375, 0, '', '2019-05-13 00:27:25');
INSERT INTO `access_log` VALUES (753, '73b7bace-aceb-456e-bbdf-613bb140531c', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:27:27', 186, 0, '', '2019-05-13 00:27:27');
INSERT INTO `access_log` VALUES (754, '674cd85a-732b-4b11-b443-0675d052be6b', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:27:28', 43056, 2001001000, '服务端发生异常', '2019-05-13 00:28:11');
INSERT INTO `access_log` VALUES (755, '9ddf3b55-9868-42ab-80c7-cea50ae84df9', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:30:30', 20854, 2001001000, '服务端发生异常', '2019-05-13 00:30:51');
INSERT INTO `access_log` VALUES (756, '67c9cdae-bdc6-430c-a1e1-1e1963a59a2d', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:30:54', 30779, 2001001000, '服务端发生异常', '2019-05-13 00:31:25');
INSERT INTO `access_log` VALUES (757, '3839a2b3-de27-4eb3-b64d-8b894967c62a', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:32:16', 30709, 2001001000, '服务端发生异常', '2019-05-13 00:32:47');
INSERT INTO `access_log` VALUES (758, '6ffd4fab-e2ee-4608-bd05-7e6d0206a03d', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 08:15:11', 60, 1001001012, '访问令牌已过期', '2019-05-13 08:15:11');
INSERT INTO `access_log` VALUES (759, '8f447096-f82e-4aec-bb2e-0591c4f08a71', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 08:15:11', 49, 1001001012, '访问令牌已过期', '2019-05-13 08:15:11');
INSERT INTO `access_log` VALUES (760, 'bdb52d08-5e4d-4abe-adde-a83ea0bb463b', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=9640c8b7a974462181eb221669d70702', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 08:15:11', 145, 0, '', '2019-05-13 08:15:12');
INSERT INTO `access_log` VALUES (761, 'e24bc4f2-2b2f-44a7-9677-728bf22ee3d5', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=9640c8b7a974462181eb221669d70702', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 08:15:11', 194, 0, '', '2019-05-13 08:15:12');
INSERT INTO `access_log` VALUES (762, 'af7b04a7-9b30-4921-b62d-dd2ea04a71fd', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 08:15:12', 19, 0, '', '2019-05-13 08:15:12');
INSERT INTO `access_log` VALUES (763, '8ad13603-00c7-462c-a194-c2442e359487', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 08:15:12', 249, 0, '', '2019-05-13 08:15:12');
INSERT INTO `access_log` VALUES (764, 'd4782ba3-195d-486d-b51e-d491db842881', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'PostmanRuntime/6.4.1', '127.0.0.1', '2019-05-13 18:57:42', 103, 1002001012, '访问令牌已过期', '2019-05-13 18:57:42');
INSERT INTO `access_log` VALUES (765, '74c7d5a0-59ad-484a-842f-3e7e94b51a8f', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'PostmanRuntime/6.4.1', '127.0.0.1', '2019-05-13 19:27:40', 197, 1002001012, '访问令牌已过期', '2019-05-13 19:27:40');
INSERT INTO `access_log` VALUES (766, 'fe1fbd4f-5959-4cd1-bcef-ee5bcee96d85', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'PostmanRuntime/6.4.1', '127.0.0.1', '2019-05-13 19:48:35', 122, 1002001012, '访问令牌已过期', '2019-05-13 19:48:35');
INSERT INTO `access_log` VALUES (767, '31.50.15577929577650001', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-14 08:15:58', 5105, 2001001000, '服务端发生异常', '2019-05-14 08:16:03');
INSERT INTO `access_log` VALUES (768, '35.73.15577929563510001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-14 08:15:56', 6680, 2001001000, '服务端发生异常', '2019-05-14 08:16:03');
INSERT INTO `access_log` VALUES (769, '35.80.15577929563470001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-14 08:15:56', 6682, 2001001000, '服务端发生异常', '2019-05-14 08:16:03');
INSERT INTO `access_log` VALUES (770, '31.48.15577929650580001', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-14 08:16:05', 263, 2001001000, '服务端发生异常', '2019-05-14 08:16:05');
INSERT INTO `access_log` VALUES (771, '35.78.15577952535120001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.142.128.228', '2019-05-14 08:54:14', 818, 0, '', '2019-05-14 08:54:14');
INSERT INTO `access_log` VALUES (772, '35.71.15577952535120001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.142.128.228', '2019-05-14 08:54:14', 2252, 0, '', '2019-05-14 08:54:16');
INSERT INTO `access_log` VALUES (773, '32.85.15577952659670003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.142.128.228', '2019-05-14 08:54:26', 128, 0, '', '2019-05-14 08:54:26');
INSERT INTO `access_log` VALUES (774, '32.81.15577952666220003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.142.128.228', '2019-05-14 08:54:27', 7, 0, '', '2019-05-14 08:54:27');
INSERT INTO `access_log` VALUES (775, '32.79.15577952702010003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.142.128.228', '2019-05-14 08:54:30', 6, 0, '', '2019-05-14 08:54:30');
INSERT INTO `access_log` VALUES (776, '32.86.15577952709220003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.142.128.228', '2019-05-14 08:54:31', 5, 0, '', '2019-05-14 08:54:31');
INSERT INTO `access_log` VALUES (777, '32.83.15577952714780005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.142.128.228', '2019-05-14 08:54:31', 7, 0, '', '2019-05-14 08:54:31');
INSERT INTO `access_log` VALUES (778, '32.84.15577952851520003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.142.128.228', '2019-05-14 08:54:45', 6, 0, '', '2019-05-14 08:54:45');
INSERT INTO `access_log` VALUES (779, '32.82.15577952853070005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.142.128.228', '2019-05-14 08:54:45', 9, 0, '', '2019-05-14 08:54:45');
INSERT INTO `access_log` VALUES (780, '32.80.15577952903220005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.142.128.228', '2019-05-14 08:54:50', 6, 0, '', '2019-05-14 08:54:50');
INSERT INTO `access_log` VALUES (781, '32.87.15577952904670003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.142.128.228', '2019-05-14 08:54:50', 7, 0, '', '2019-05-14 08:54:50');
INSERT INTO `access_log` VALUES (782, '35.72.15577970581270001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '49.4.151.24', '2019-05-14 09:24:18', 56, 0, '', '2019-05-14 09:24:18');
INSERT INTO `access_log` VALUES (783, '35.74.15577970581270001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '49.4.151.24', '2019-05-14 09:24:18', 189, 0, '', '2019-05-14 09:24:18');
INSERT INTO `access_log` VALUES (784, '32.88.15577970639740003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '49.4.151.24', '2019-05-14 09:24:24', 9, 0, '', '2019-05-14 09:24:24');
INSERT INTO `access_log` VALUES (785, '32.85.15577970641170005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '49.4.151.24', '2019-05-14 09:24:24', 5, 0, '', '2019-05-14 09:24:24');
INSERT INTO `access_log` VALUES (786, '32.81.15577970711120005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '49.4.151.24', '2019-05-14 09:24:31', 7, 0, '', '2019-05-14 09:24:31');
INSERT INTO `access_log` VALUES (787, '32.79.15577970712280005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '49.4.151.24', '2019-05-14 09:24:31', 6, 0, '', '2019-05-14 09:24:31');
INSERT INTO `access_log` VALUES (788, '35.79.15577970717750003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '49.4.151.24', '2019-05-14 09:24:32', 29, 0, '', '2019-05-14 09:24:32');
INSERT INTO `access_log` VALUES (789, '35.77.15577970717750001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '49.4.151.24', '2019-05-14 09:24:32', 8, 0, '', '2019-05-14 09:24:32');
INSERT INTO `access_log` VALUES (790, '30.66.15577970851340005', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '49.4.151.24', '2019-05-14 09:24:45', 1351, 2001001000, '服务端发生异常', '2019-05-14 09:24:47');
INSERT INTO `access_log` VALUES (791, '30.73.15577970851280003', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '49.4.151.24', '2019-05-14 09:24:45', 1381, 2001001000, '服务端发生异常', '2019-05-14 09:24:47');
INSERT INTO `access_log` VALUES (792, '30.68.15577970851300003', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '49.4.151.24', '2019-05-14 09:24:45', 1546, 0, '', '2019-05-14 09:24:47');
INSERT INTO `access_log` VALUES (793, '35.75.15577973421000005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '1.193.57.118', '2019-05-14 09:29:02', 11, 0, '', '2019-05-14 09:29:02');
INSERT INTO `access_log` VALUES (794, '35.76.15577973421140003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '1.193.57.118', '2019-05-14 09:29:02', 24, 0, '', '2019-05-14 09:29:02');
INSERT INTO `access_log` VALUES (795, '32.86.15577973526130005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Mobile Safari/537.36', '1.193.57.118', '2019-05-14 09:29:13', 6, 0, '', '2019-05-14 09:29:13');
INSERT INTO `access_log` VALUES (796, '32.83.15577973527680007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Mobile Safari/537.36', '1.193.57.118', '2019-05-14 09:29:13', 5, 0, '', '2019-05-14 09:29:13');
INSERT INTO `access_log` VALUES (797, '32.84.15577973568920005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Mobile Safari/537.36', '1.193.57.118', '2019-05-14 09:29:17', 8, 0, '', '2019-05-14 09:29:17');
INSERT INTO `access_log` VALUES (798, '32.82.15577973570090007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Mobile Safari/537.36', '1.193.57.118', '2019-05-14 09:29:17', 5, 0, '', '2019-05-14 09:29:17');
INSERT INTO `access_log` VALUES (799, '35.73.15577973587130003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Mobile Safari/537.36', '1.193.57.118', '2019-05-14 09:29:19', 8, 0, '', '2019-05-14 09:29:19');
INSERT INTO `access_log` VALUES (800, '35.80.15577973587130003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Mobile Safari/537.36', '1.193.57.118', '2019-05-14 09:29:19', 30, 0, '', '2019-05-14 09:29:19');
INSERT INTO `access_log` VALUES (801, '35.78.15577990285200003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:09', 8, 0, '', '2019-05-14 09:57:09');
INSERT INTO `access_log` VALUES (802, '35.71.15577990285200003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:09', 45, 0, '', '2019-05-14 09:57:09');
INSERT INTO `access_log` VALUES (803, '32.80.15577990310550007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:11', 5, 0, '', '2019-05-14 09:57:11');
INSERT INTO `access_log` VALUES (804, '32.87.15577990311940005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:11', 5, 0, '', '2019-05-14 09:57:11');
INSERT INTO `access_log` VALUES (805, '32.88.15577990374200005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:17', 6, 0, '', '2019-05-14 09:57:17');
INSERT INTO `access_log` VALUES (806, '32.85.15577990375520007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:18', 5, 0, '', '2019-05-14 09:57:18');
INSERT INTO `access_log` VALUES (807, '36.81.15577990404010001', 0, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:21', 552, -1, '未授权', '2019-05-14 09:57:22');
INSERT INTO `access_log` VALUES (808, '36.82.15577990412070001', 0, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:21', 205, -1, '未授权', '2019-05-14 09:57:22');
INSERT INTO `access_log` VALUES (809, '35.72.15577990487500003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:29', 11, 0, '', '2019-05-14 09:57:29');
INSERT INTO `access_log` VALUES (810, '35.74.15577990487520003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:29', 168, 0, '', '2019-05-14 09:57:29');
INSERT INTO `access_log` VALUES (811, '32.81.15577990523600007', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:32', 186, 0, '', '2019-05-14 09:57:33');
INSERT INTO `access_log` VALUES (812, '36.83.15577990528290001', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:33', 608, 0, '', '2019-05-14 09:57:33');
INSERT INTO `access_log` VALUES (813, '36.84.15577990569040001', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=32', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:37', 43, 0, '', '2019-05-14 09:57:37');
INSERT INTO `access_log` VALUES (814, '36.86.15577990576210001', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:38', 58, 0, '', '2019-05-14 09:57:38');
INSERT INTO `access_log` VALUES (815, '36.85.15577990595840001', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=32', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:40', 17, 0, '', '2019-05-14 09:57:40');
INSERT INTO `access_log` VALUES (816, '36.87.15577990603560001', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:57:40', 25, 0, '', '2019-05-14 09:57:40');
INSERT INTO `access_log` VALUES (817, '31.46.15577990927100001', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18611112222&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:58:13', 457, 2001001000, '服务端发生异常', '2019-05-14 09:58:13');
INSERT INTO `access_log` VALUES (818, '31.52.15577990975920003', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18611112222&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:58:18', 87, 2001001000, '服务端发生异常', '2019-05-14 09:58:18');
INSERT INTO `access_log` VALUES (819, '31.50.15577991005950003', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18611112222', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:58:21', 147, 2001001000, '服务端发生异常', '2019-05-14 09:58:21');
INSERT INTO `access_log` VALUES (820, '32.79.15577991066420007', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:58:27', 76, 0, '', '2019-05-14 09:58:27');
INSERT INTO `access_log` VALUES (821, '36.88.15577991068560001', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:58:27', 75, 0, '', '2019-05-14 09:58:27');
INSERT INTO `access_log` VALUES (822, '35.79.15577991077210005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:58:28', 6, 0, '', '2019-05-14 09:58:28');
INSERT INTO `access_log` VALUES (823, '35.77.15577991077230003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:58:28', 30, 0, '', '2019-05-14 09:58:28');
INSERT INTO `access_log` VALUES (824, '32.86.15577991213070007', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:58:41', 567, 1003002003, 'Spu 只能添加在二级分类下', '2019-05-14 09:58:42');
INSERT INTO `access_log` VALUES (825, '32.83.15577991248390009', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:58:45', 7, 1003002003, 'Spu 只能添加在二级分类下', '2019-05-14 09:58:45');
INSERT INTO `access_log` VALUES (826, '32.84.15577991291650007', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:58:49', 7, 1003002003, 'Spu 只能添加在二级分类下', '2019-05-14 09:58:49');
INSERT INTO `access_log` VALUES (827, '32.82.15577991335590009', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:58:54', 6, 1003002003, 'Spu 只能添加在二级分类下', '2019-05-14 09:58:54');
INSERT INTO `access_log` VALUES (828, '32.80.15577991446140009', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:59:05', 6, 1003002003, 'Spu 只能添加在二级分类下', '2019-05-14 09:59:05');
INSERT INTO `access_log` VALUES (829, '35.80.15578003356280005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.54.41.188', '2019-05-14 10:18:56', 232, 2001001000, '服务端发生异常', '2019-05-14 10:18:56');
INSERT INTO `access_log` VALUES (830, '35.73.15578003356250005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.54.41.188', '2019-05-14 10:18:56', 234, 2001001000, '服务端发生异常', '2019-05-14 10:18:56');
INSERT INTO `access_log` VALUES (831, '35.78.15578049077020005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '119.139.199.184', '2019-05-14 11:35:08', 23, 0, '', '2019-05-14 11:35:08');
INSERT INTO `access_log` VALUES (832, '35.71.15578049077060005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '119.139.199.184', '2019-05-14 11:35:08', 63, 0, '', '2019-05-14 11:35:08');
INSERT INTO `access_log` VALUES (833, '32.87.15578049132750007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '119.139.199.184', '2019-05-14 11:35:13', 7, 0, '', '2019-05-14 11:35:13');
INSERT INTO `access_log` VALUES (834, '32.88.15578049134400007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '119.139.199.184', '2019-05-14 11:35:13', 5, 0, '', '2019-05-14 11:35:13');
INSERT INTO `access_log` VALUES (835, '32.85.15578049146740009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '119.139.199.184', '2019-05-14 11:35:15', 6, 0, '', '2019-05-14 11:35:15');
INSERT INTO `access_log` VALUES (836, '32.81.15578049152930009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '119.139.199.184', '2019-05-14 11:35:15', 6, 0, '', '2019-05-14 11:35:15');
INSERT INTO `access_log` VALUES (837, '30.68.15578049225830007', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '119.139.199.184', '2019-05-14 11:35:23', 14, 0, '', '2019-05-14 11:35:23');
INSERT INTO `access_log` VALUES (838, '30.72.15578049226250003', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '119.139.199.184', '2019-05-14 11:35:23', 110, 2001001000, '服务端发生异常', '2019-05-14 11:35:23');
INSERT INTO `access_log` VALUES (839, '30.69.15578049225800003', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '119.139.199.184', '2019-05-14 11:35:23', 154, 2001001000, '服务端发生异常', '2019-05-14 11:35:23');
INSERT INTO `access_log` VALUES (840, '35.74.15578055227320005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:23', 11, 0, '', '2019-05-14 11:45:23');
INSERT INTO `access_log` VALUES (841, '35.72.15578055227320005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:23', 22, 0, '', '2019-05-14 11:45:23');
INSERT INTO `access_log` VALUES (842, '32.79.15578055248920009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:25', 5, 0, '', '2019-05-14 11:45:25');
INSERT INTO `access_log` VALUES (843, '32.86.15578055250280009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:25', 7, 0, '', '2019-05-14 11:45:25');
INSERT INTO `access_log` VALUES (844, '30.66.15578055312330007', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:31', 19, 0, '', '2019-05-14 11:45:31');
INSERT INTO `access_log` VALUES (845, '30.73.15578055312300005', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:31', 87, 2001001000, '服务端发生异常', '2019-05-14 11:45:31');
INSERT INTO `access_log` VALUES (846, '30.67.15578055312320009', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:31', 84, 2001001000, '服务端发生异常', '2019-05-14 11:45:31');
INSERT INTO `access_log` VALUES (847, '30.64.15578055391190009', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:39', 799, 0, '', '2019-05-14 11:45:40');
INSERT INTO `access_log` VALUES (848, '30.70.15578055401190005', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:40', 37, 0, '', '2019-05-14 11:45:40');
INSERT INTO `access_log` VALUES (849, '30.71.15578055401150007', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:40', 85, 2001001000, '服务端发生异常', '2019-05-14 11:45:40');
INSERT INTO `access_log` VALUES (850, '30.65.15578055401140011', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:40', 127, 2001001000, '服务端发生异常', '2019-05-14 11:45:40');
INSERT INTO `access_log` VALUES (851, '35.79.15578057010410007', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:48:21', 7, 0, '', '2019-05-14 11:48:21');
INSERT INTO `access_log` VALUES (852, '35.77.15578057010410005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:48:21', 22, 0, '', '2019-05-14 11:48:21');
INSERT INTO `access_log` VALUES (853, '32.83.15578057093310011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.41.161.175', '2019-05-14 11:48:29', 8, 0, '', '2019-05-14 11:48:29');
INSERT INTO `access_log` VALUES (854, '32.84.15578057094390009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.41.161.175', '2019-05-14 11:48:29', 5, 0, '', '2019-05-14 11:48:29');
INSERT INTO `access_log` VALUES (855, '32.82.15578057102850011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.41.161.175', '2019-05-14 11:48:30', 7, 0, '', '2019-05-14 11:48:30');
INSERT INTO `access_log` VALUES (856, '33.87.15578057102870001', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.41.161.175', '2019-05-14 11:48:30', 104, -1, '未授权', '2019-05-14 11:48:31');
INSERT INTO `access_log` VALUES (857, '33.88.15578057132260001', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.41.161.175', '2019-05-14 11:48:33', 2, -1, '未授权', '2019-05-14 11:48:33');
INSERT INTO `access_log` VALUES (858, '32.80.15578057150340011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.41.161.175', '2019-05-14 11:48:35', 5, 0, '', '2019-05-14 11:48:35');
INSERT INTO `access_log` VALUES (859, '32.87.15578057152060009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.41.161.175', '2019-05-14 11:48:35', 5, 0, '', '2019-05-14 11:48:35');
INSERT INTO `access_log` VALUES (860, '31.53.15578057371460001', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678901&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.41.161.175', '2019-05-14 11:48:57', 254, 2001001000, '服务端发生异常', '2019-05-14 11:48:57');
INSERT INTO `access_log` VALUES (861, '31.48.15578057394250003', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=12345678901', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.41.161.175', '2019-05-14 11:48:59', 92, 2001001000, '服务端发生异常', '2019-05-14 11:49:00');
INSERT INTO `access_log` VALUES (862, '31.45.15578057409990003', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678901&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.41.161.175', '2019-05-14 11:49:01', 121, 2001001000, '服务端发生异常', '2019-05-14 11:49:01');
INSERT INTO `access_log` VALUES (863, '35.75.15578073658310009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/4.0 (compatible;)', '219.233.201.34', '2019-05-14 12:16:06', 6, 0, '', '2019-05-14 12:16:06');
INSERT INTO `access_log` VALUES (864, '30.68.15578089411540009', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '106.38.115.24', '2019-05-14 12:42:21', 105, 2001001000, '服务端发生异常', '2019-05-14 12:42:21');
INSERT INTO `access_log` VALUES (865, '30.72.15578089411540005', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '106.38.115.24', '2019-05-14 12:42:21', 106, 2001001000, '服务端发生异常', '2019-05-14 12:42:21');
INSERT INTO `access_log` VALUES (866, '30.69.15578089411610005', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '106.38.115.24', '2019-05-14 12:42:21', 13, 0, '', '2019-05-14 12:42:21');
INSERT INTO `access_log` VALUES (867, '35.73.15578107358460007', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:16', 563, 0, '', '2019-05-14 13:12:16');
INSERT INTO `access_log` VALUES (868, '35.76.15578107358460007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:16', 595, 0, '', '2019-05-14 13:12:16');
INSERT INTO `access_log` VALUES (869, '32.88.15578107395360009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:20', 7, 0, '', '2019-05-14 13:12:20');
INSERT INTO `access_log` VALUES (870, '32.85.15578107396450011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:20', 5, 0, '', '2019-05-14 13:12:20');
INSERT INTO `access_log` VALUES (871, '32.81.15578107411540011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:21', 5, 0, '', '2019-05-14 13:12:21');
INSERT INTO `access_log` VALUES (872, '32.79.15578107420900011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:22', 4, 0, '', '2019-05-14 13:12:22');
INSERT INTO `access_log` VALUES (873, '32.86.15578107452630011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:25', 5, 0, '', '2019-05-14 13:12:25');
INSERT INTO `access_log` VALUES (874, '32.83.15578107453550013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:25', 5, 0, '', '2019-05-14 13:12:25');
INSERT INTO `access_log` VALUES (875, '35.80.15578107536610007', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:34', 9, 0, '', '2019-05-14 13:12:34');
INSERT INTO `access_log` VALUES (876, '35.71.15578107536620007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:34', 24, 0, '', '2019-05-14 13:12:34');
INSERT INTO `access_log` VALUES (877, '32.84.15578107553280011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:35', 5, 0, '', '2019-05-14 13:12:35');
INSERT INTO `access_log` VALUES (878, '32.82.15578107554070013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:35', 5, 0, '', '2019-05-14 13:12:35');
INSERT INTO `access_log` VALUES (879, '32.80.15578107568980013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:37', 5, 0, '', '2019-05-14 13:12:37');
INSERT INTO `access_log` VALUES (880, '32.87.15578107574110011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:37', 5, 0, '', '2019-05-14 13:12:37');
INSERT INTO `access_log` VALUES (881, '35.78.15578107586770007', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:39', 6, 0, '', '2019-05-14 13:12:39');
INSERT INTO `access_log` VALUES (882, '35.72.15578107586770007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:39', 29, 0, '', '2019-05-14 13:12:39');
INSERT INTO `access_log` VALUES (883, '32.88.15578107605700011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:41', 4, 0, '', '2019-05-14 13:12:41');
INSERT INTO `access_log` VALUES (884, '32.85.15578107606620013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:41', 5, 0, '', '2019-05-14 13:12:41');
INSERT INTO `access_log` VALUES (885, '35.74.15578107615970007', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:42', 7, 0, '', '2019-05-14 13:12:42');
INSERT INTO `access_log` VALUES (886, '35.77.15578107615970007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-14 13:12:42', 21, 0, '', '2019-05-14 13:12:42');
INSERT INTO `access_log` VALUES (887, '35.79.15578116640510009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '58.23.36.249', '2019-05-14 13:27:44', 7, 0, '', '2019-05-14 13:27:44');
INSERT INTO `access_log` VALUES (888, '35.75.15578116640570011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '58.23.36.249', '2019-05-14 13:27:44', 17, 0, '', '2019-05-14 13:27:44');
INSERT INTO `access_log` VALUES (889, '32.81.15578116673820013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '58.23.36.249', '2019-05-14 13:27:47', 6, 0, '', '2019-05-14 13:27:47');
INSERT INTO `access_log` VALUES (890, '32.79.15578116675030013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '58.23.36.249', '2019-05-14 13:27:48', 5, 0, '', '2019-05-14 13:27:48');
INSERT INTO `access_log` VALUES (891, '35.76.15578116696590009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '58.23.36.249', '2019-05-14 13:27:50', 8, 0, '', '2019-05-14 13:27:50');
INSERT INTO `access_log` VALUES (892, '35.73.15578116696600009', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '58.23.36.249', '2019-05-14 13:27:50', 15, 0, '', '2019-05-14 13:27:50');
INSERT INTO `access_log` VALUES (893, '35.80.15578116804870009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '58.23.36.249', '2019-05-14 13:28:00', 6, 0, '', '2019-05-14 13:28:00');
INSERT INTO `access_log` VALUES (894, '35.71.15578116804900009', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '58.23.36.249', '2019-05-14 13:28:00', 17, 0, '', '2019-05-14 13:28:01');
INSERT INTO `access_log` VALUES (895, '35.78.15578120097770009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:33:30', 6, 0, '', '2019-05-14 13:33:30');
INSERT INTO `access_log` VALUES (896, '35.72.15578120097780009', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:33:30', 22, 0, '', '2019-05-14 13:33:30');
INSERT INTO `access_log` VALUES (897, '32.86.15578120207590013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:33:41', 5, 0, '', '2019-05-14 13:33:41');
INSERT INTO `access_log` VALUES (898, '32.83.15578120209180015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:33:41', 5, 0, '', '2019-05-14 13:33:41');
INSERT INTO `access_log` VALUES (899, '32.84.15578120227600013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:33:43', 5, 0, '', '2019-05-14 13:33:43');
INSERT INTO `access_log` VALUES (900, '32.82.15578120234120015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:33:43', 5, 0, '', '2019-05-14 13:33:43');
INSERT INTO `access_log` VALUES (901, '32.80.15578120245670015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:33:45', 5, 0, '', '2019-05-14 13:33:45');
INSERT INTO `access_log` VALUES (902, '32.87.15578120249510013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:33:45', 5, 0, '', '2019-05-14 13:33:45');
INSERT INTO `access_log` VALUES (903, '32.88.15578120253740013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:33:45', 5, 0, '', '2019-05-14 13:33:45');
INSERT INTO `access_log` VALUES (904, '32.85.15578120298660015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:33:50', 5, 0, '', '2019-05-14 13:33:50');
INSERT INTO `access_log` VALUES (905, '32.81.15578120300150015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:33:50', 5, 0, '', '2019-05-14 13:33:50');
INSERT INTO `access_log` VALUES (906, '32.79.15578120459420015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:34:06', 5, 0, '', '2019-05-14 13:34:06');
INSERT INTO `access_log` VALUES (907, '32.86.15578120460590015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:34:06', 5, 0, '', '2019-05-14 13:34:06');
INSERT INTO `access_log` VALUES (908, '32.83.15578120477870017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:34:08', 5, 0, '', '2019-05-14 13:34:08');
INSERT INTO `access_log` VALUES (909, '35.77.15578120489680009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:34:09', 6, 0, '', '2019-05-14 13:34:09');
INSERT INTO `access_log` VALUES (910, '35.74.15578120489690009', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:34:09', 13, 0, '', '2019-05-14 13:34:09');
INSERT INTO `access_log` VALUES (911, '32.84.15578120508400015', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:34:11', 17, 0, '', '2019-05-14 13:34:11');
INSERT INTO `access_log` VALUES (912, '36.90.15578120511530001', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:34:11', 133, 0, '', '2019-05-14 13:34:11');
INSERT INTO `access_log` VALUES (913, '30.67.15578124125720013', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:40:13', 15, 0, '', '2019-05-14 13:40:13');
INSERT INTO `access_log` VALUES (914, '30.66.15578124125690009', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:40:13', 80, 2001001000, '服务端发生异常', '2019-05-14 13:40:13');
INSERT INTO `access_log` VALUES (915, '30.71.15578124125690009', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:40:13', 121, 2001001000, '服务端发生异常', '2019-05-14 13:40:13');
INSERT INTO `access_log` VALUES (916, '35.79.15578133978810011', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 13:56:38', 8, 0, '', '2019-05-14 13:56:38');
INSERT INTO `access_log` VALUES (917, '35.75.15578133978810013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 13:56:38', 30, 0, '', '2019-05-14 13:56:38');
INSERT INTO `access_log` VALUES (918, '35.73.15578134167830011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 13:56:57', 14, 0, '', '2019-05-14 13:56:57');
INSERT INTO `access_log` VALUES (919, '35.76.15578134167820011', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 13:56:57', 6, 0, '', '2019-05-14 13:56:57');
INSERT INTO `access_log` VALUES (920, '30.73.15578138394790011', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '218.17.157.169', '2019-05-14 14:03:59', 10, 0, '', '2019-05-14 14:03:59');
INSERT INTO `access_log` VALUES (921, '30.64.15578138394770011', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '218.17.157.169', '2019-05-14 14:03:59', 327, 2001001000, '服务端发生异常', '2019-05-14 14:04:00');
INSERT INTO `access_log` VALUES (922, '30.68.15578138394760013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '218.17.157.169', '2019-05-14 14:03:59', 329, 2001001000, '服务端发生异常', '2019-05-14 14:04:00');
INSERT INTO `access_log` VALUES (923, '35.80.15578138412980011', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '218.17.157.169', '2019-05-14 14:04:01', 7, 0, '', '2019-05-14 14:04:01');
INSERT INTO `access_log` VALUES (924, '35.71.15578138412980011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '218.17.157.169', '2019-05-14 14:04:01', 23, 0, '', '2019-05-14 14:04:01');
INSERT INTO `access_log` VALUES (925, '35.72.15578138500060011', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:10', 7, 0, '', '2019-05-14 14:04:10');
INSERT INTO `access_log` VALUES (926, '35.78.15578138500060011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:10', 15, 0, '', '2019-05-14 14:04:10');
INSERT INTO `access_log` VALUES (927, '32.85.15578138519660017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:12', 5, 0, '', '2019-05-14 14:04:12');
INSERT INTO `access_log` VALUES (928, '32.84.15578138524150017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:12', 5, 0, '', '2019-05-14 14:04:12');
INSERT INTO `access_log` VALUES (929, '32.82.15578138536410017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:14', 4, 0, '', '2019-05-14 14:04:14');
INSERT INTO `access_log` VALUES (930, '32.80.15578138543300017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:14', 4, 0, '', '2019-05-14 14:04:14');
INSERT INTO `access_log` VALUES (931, '32.87.15578138549180017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:15', 5, 0, '', '2019-05-14 14:04:15');
INSERT INTO `access_log` VALUES (932, '32.88.15578138553640017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:15', 4, 0, '', '2019-05-14 14:04:15');
INSERT INTO `access_log` VALUES (933, '32.83.15578138556240019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:16', 4, 0, '', '2019-05-14 14:04:16');
INSERT INTO `access_log` VALUES (934, '32.79.15578138585390017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:19', 4, 0, '', '2019-05-14 14:04:19');
INSERT INTO `access_log` VALUES (935, '35.74.15578138617690011', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:22', 7, 0, '', '2019-05-14 14:04:22');
INSERT INTO `access_log` VALUES (936, '35.77.15578138617720011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:22', 19, 0, '', '2019-05-14 14:04:22');
INSERT INTO `access_log` VALUES (937, '33.79.15578138638120001', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:24', 2, -1, '未授权', '2019-05-14 14:04:24');
INSERT INTO `access_log` VALUES (938, '35.75.15578138696190015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:30', 6, 0, '', '2019-05-14 14:04:30');
INSERT INTO `access_log` VALUES (939, '35.79.15578138696190013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:30', 18, 0, '', '2019-05-14 14:04:30');
INSERT INTO `access_log` VALUES (940, '35.73.15578138734410013', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:33', 6, 0, '', '2019-05-14 14:04:33');
INSERT INTO `access_log` VALUES (941, '35.76.15578138734410013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.246.6.18', '2019-05-14 14:04:33', 17, 0, '', '2019-05-14 14:04:33');
INSERT INTO `access_log` VALUES (942, '35.71.15578138836080013', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.17.157.169', '2019-05-14 14:04:44', 7, 0, '', '2019-05-14 14:04:44');
INSERT INTO `access_log` VALUES (943, '35.80.15578138836090013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.17.157.169', '2019-05-14 14:04:44', 18, 0, '', '2019-05-14 14:04:44');
INSERT INTO `access_log` VALUES (944, '32.81.15578139188700019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:05:19', 4, 0, '', '2019-05-14 14:05:19');
INSERT INTO `access_log` VALUES (945, '32.86.15578139190070017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:05:19', 4, 0, '', '2019-05-14 14:05:19');
INSERT INTO `access_log` VALUES (946, '32.85.15578139253240019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:05:25', 5, 0, '', '2019-05-14 14:05:25');
INSERT INTO `access_log` VALUES (947, '32.84.15578139254760019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:05:25', 6, 0, '', '2019-05-14 14:05:25');
INSERT INTO `access_log` VALUES (948, '32.82.15578139413730019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:05:41', 4, 0, '', '2019-05-14 14:05:41');
INSERT INTO `access_log` VALUES (949, '32.80.15578139415060019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:05:42', 4, 0, '', '2019-05-14 14:05:42');
INSERT INTO `access_log` VALUES (950, '35.72.15578139426070013', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:05:43', 6, 0, '', '2019-05-14 14:05:43');
INSERT INTO `access_log` VALUES (951, '35.78.15578139426090013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:05:43', 14, 0, '', '2019-05-14 14:05:43');
INSERT INTO `access_log` VALUES (952, '32.87.15578139463880019', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:05:46', 80, 0, '', '2019-05-14 14:05:46');
INSERT INTO `access_log` VALUES (953, '36.82.15578139473990003', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:05:47', 32, 0, '', '2019-05-14 14:05:47');
INSERT INTO `access_log` VALUES (954, '35.74.15578139528550013', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:05:53', 6, 0, '', '2019-05-14 14:05:53');
INSERT INTO `access_log` VALUES (955, '35.77.15578139528560013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:05:53', 21, 0, '', '2019-05-14 14:05:53');
INSERT INTO `access_log` VALUES (956, '32.88.15578139544480019', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:05:54', 14, 0, '', '2019-05-14 14:05:54');
INSERT INTO `access_log` VALUES (957, '36.81.15578139546230003', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:05:55', 23, 0, '', '2019-05-14 14:05:55');
INSERT INTO `access_log` VALUES (958, '36.83.15578139663510003', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=37', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:06:06', 23, 0, '', '2019-05-14 14:06:06');
INSERT INTO `access_log` VALUES (959, '36.84.15578139668470003', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:06:07', 21, 0, '', '2019-05-14 14:06:07');
INSERT INTO `access_log` VALUES (960, '36.86.15578139741820003', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=37', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:06:14', 46, 0, '', '2019-05-14 14:06:14');
INSERT INTO `access_log` VALUES (961, '36.85.15578139753730003', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:06:15', 23, 0, '', '2019-05-14 14:06:15');
INSERT INTO `access_log` VALUES (962, '36.87.15578139761170003', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=37', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:06:16', 453, 0, '', '2019-05-14 14:06:17');
INSERT INTO `access_log` VALUES (963, '36.88.15578139767230003', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:06:17', 30, 0, '', '2019-05-14 14:06:17');
INSERT INTO `access_log` VALUES (964, '36.90.15578139771030003', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=37', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:06:17', 194, 0, '', '2019-05-14 14:06:17');
INSERT INTO `access_log` VALUES (965, '36.89.15578139774980001', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:06:18', 15, 0, '', '2019-05-14 14:06:18');
INSERT INTO `access_log` VALUES (966, '35.79.15578139807280015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:06:21', 6, 0, '', '2019-05-14 14:06:21');
INSERT INTO `access_log` VALUES (967, '35.75.15578139807280017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '218.17.157.169', '2019-05-14 14:06:21', 17, 0, '', '2019-05-14 14:06:21');
INSERT INTO `access_log` VALUES (968, '30.69.15578140398150011', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '218.17.157.169', '2019-05-14 14:07:20', 88, 0, '', '2019-05-14 14:07:20');
INSERT INTO `access_log` VALUES (969, '30.71.15578140401380011', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '218.17.157.169', '2019-05-14 14:07:20', 13, 0, '', '2019-05-14 14:07:20');
INSERT INTO `access_log` VALUES (970, '30.66.15578140401310011', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '218.17.157.169', '2019-05-14 14:07:20', 79, 2001001000, '服务端发生异常', '2019-05-14 14:07:20');
INSERT INTO `access_log` VALUES (971, '30.67.15578140401310015', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '218.17.157.169', '2019-05-14 14:07:20', 80, 2001001000, '服务端发生异常', '2019-05-14 14:07:20');
INSERT INTO `access_log` VALUES (972, '35.73.15578173285540015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.195.50', '2019-05-14 15:02:09', 17, 0, '', '2019-05-14 15:02:09');
INSERT INTO `access_log` VALUES (973, '35.76.15578173285540015', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.195.50', '2019-05-14 15:02:09', 52, 0, '', '2019-05-14 15:02:09');
INSERT INTO `access_log` VALUES (974, '35.80.15578175651440015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:05', 106, 0, '', '2019-05-14 15:06:05');
INSERT INTO `access_log` VALUES (975, '35.71.15578175651430015', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:05', 123, 0, '', '2019-05-14 15:06:05');
INSERT INTO `access_log` VALUES (976, '32.83.15578175703060021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:10', 5, 0, '', '2019-05-14 15:06:10');
INSERT INTO `access_log` VALUES (977, '32.79.15578175704970019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:10', 4, 0, '', '2019-05-14 15:06:11');
INSERT INTO `access_log` VALUES (978, '32.81.15578175717500021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:12', 4, 0, '', '2019-05-14 15:06:12');
INSERT INTO `access_log` VALUES (979, '32.86.15578175722450019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:12', 4, 0, '', '2019-05-14 15:06:12');
INSERT INTO `access_log` VALUES (980, '33.80.15578175751580001', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=a&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:15', 2, -1, '未授权', '2019-05-14 15:06:15');
INSERT INTO `access_log` VALUES (981, '32.85.15578175786720021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:19', 5, 0, '', '2019-05-14 15:06:19');
INSERT INTO `access_log` VALUES (982, '32.84.15578175788380021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:19', 4, 0, '', '2019-05-14 15:06:19');
INSERT INTO `access_log` VALUES (983, '35.72.15578175796860015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:20', 6, 0, '', '2019-05-14 15:06:20');
INSERT INTO `access_log` VALUES (984, '35.78.15578175797740015', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:20', 21, 0, '', '2019-05-14 15:06:20');
INSERT INTO `access_log` VALUES (985, '30.65.15578175867140017', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:27', 21, 0, '', '2019-05-14 15:06:27');
INSERT INTO `access_log` VALUES (986, '30.72.15578175867110007', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:27', 106, 2001001000, '服务端发生异常', '2019-05-14 15:06:27');
INSERT INTO `access_log` VALUES (987, '30.70.15578175867110011', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:27', 648, 2001001000, '服务端发生异常', '2019-05-14 15:06:27');
INSERT INTO `access_log` VALUES (988, '35.74.15578185063790015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.233.79.168', '2019-05-14 15:21:46', 6, 0, '', '2019-05-14 15:21:46');
INSERT INTO `access_log` VALUES (989, '35.77.15578185063820015', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.233.79.168', '2019-05-14 15:21:46', 21, 0, '', '2019-05-14 15:21:46');
INSERT INTO `access_log` VALUES (990, '35.75.15578190375030019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.68.26.216', '2019-05-14 15:30:38', 9, 0, '', '2019-05-14 15:30:38');
INSERT INTO `access_log` VALUES (991, '35.79.15578190375040017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.68.26.216', '2019-05-14 15:30:38', 20, 0, '', '2019-05-14 15:30:38');
INSERT INTO `access_log` VALUES (992, '32.82.15578190416480021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.68.26.216', '2019-05-14 15:30:42', 5, 0, '', '2019-05-14 15:30:42');
INSERT INTO `access_log` VALUES (993, '32.80.15578190417550021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.68.26.216', '2019-05-14 15:30:42', 4, 0, '', '2019-05-14 15:30:42');
INSERT INTO `access_log` VALUES (994, '32.87.15578190458490021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.68.26.216', '2019-05-14 15:30:46', 5, 0, '', '2019-05-14 15:30:46');
INSERT INTO `access_log` VALUES (995, '32.88.15578190459690021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.68.26.216', '2019-05-14 15:30:46', 4, 0, '', '2019-05-14 15:30:46');
INSERT INTO `access_log` VALUES (996, '35.73.15578190464300017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.68.26.216', '2019-05-14 15:30:46', 9, 0, '', '2019-05-14 15:30:46');
INSERT INTO `access_log` VALUES (997, '35.76.15578190464310017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.68.26.216', '2019-05-14 15:30:46', 20, 0, '', '2019-05-14 15:30:46');
INSERT INTO `access_log` VALUES (998, '30.64.15578204588960013', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '218.76.8.40', '2019-05-14 15:54:19', 16, 0, '', '2019-05-14 15:54:19');
INSERT INTO `access_log` VALUES (999, '30.73.15578204588860013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '218.76.8.40', '2019-05-14 15:54:19', 25, 2001001000, '服务端发生异常', '2019-05-14 15:54:19');
INSERT INTO `access_log` VALUES (1000, '30.68.15578204588860015', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '218.76.8.40', '2019-05-14 15:54:19', 33, 2001001000, '服务端发生异常', '2019-05-14 15:54:19');
INSERT INTO `access_log` VALUES (1001, '30.69.15578213527950013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4094.1 Safari/537.36', '218.81.97.14', '2019-05-14 16:09:13', 22, 2001001000, '服务端发生异常', '2019-05-14 16:09:13');
INSERT INTO `access_log` VALUES (1002, '30.66.15578213528110013', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4094.1 Safari/537.36', '218.81.97.14', '2019-05-14 16:09:13', 9, 0, '', '2019-05-14 16:09:13');
INSERT INTO `access_log` VALUES (1003, '30.71.15578213527960013', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4094.1 Safari/537.36', '218.81.97.14', '2019-05-14 16:09:13', 45, 2001001000, '服务端发生异常', '2019-05-14 16:09:13');
INSERT INTO `access_log` VALUES (1004, '35.71.15578213746710017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4094.1 Safari/537.36', '218.81.97.14', '2019-05-14 16:09:35', 15, 0, '', '2019-05-14 16:09:35');
INSERT INTO `access_log` VALUES (1005, '35.80.15578213746710017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4094.1 Safari/537.36', '218.81.97.14', '2019-05-14 16:09:35', 49, 0, '', '2019-05-14 16:09:35');
INSERT INTO `access_log` VALUES (1006, '32.82.15578213761540023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4094.1 Safari/537.36', '218.81.97.14', '2019-05-14 16:09:36', 6, 0, '', '2019-05-14 16:09:36');
INSERT INTO `access_log` VALUES (1007, '32.88.15578213762520023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4094.1 Safari/537.36', '218.81.97.14', '2019-05-14 16:09:36', 5, 0, '', '2019-05-14 16:09:36');
INSERT INTO `access_log` VALUES (1008, '35.72.15578213779430017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4094.1 Safari/537.36', '218.81.97.14', '2019-05-14 16:09:38', 8, 0, '', '2019-05-14 16:09:38');
INSERT INTO `access_log` VALUES (1009, '35.78.15578213779430017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4094.1 Safari/537.36', '218.81.97.14', '2019-05-14 16:09:38', 19, 0, '', '2019-05-14 16:09:38');
INSERT INTO `access_log` VALUES (1010, '32.83.15578213842710023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4094.1 Safari/537.36', '218.81.97.14', '2019-05-14 16:09:44', 4, 0, '', '2019-05-14 16:09:44');
INSERT INTO `access_log` VALUES (1011, '32.79.15578213843500023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4094.1 Safari/537.36', '218.81.97.14', '2019-05-14 16:09:44', 5, 0, '', '2019-05-14 16:09:44');
INSERT INTO `access_log` VALUES (1012, '32.85.15578213897490025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4094.1 Safari/537.36', '218.81.97.14', '2019-05-14 16:09:50', 5, 0, '', '2019-05-14 16:09:50');
INSERT INTO `access_log` VALUES (1013, '32.81.15578213899440023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4094.1 Safari/537.36', '218.81.97.14', '2019-05-14 16:09:50', 4, 0, '', '2019-05-14 16:09:50');
INSERT INTO `access_log` VALUES (1014, '35.74.15578224891540017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:09', 7, 0, '', '2019-05-14 16:28:09');
INSERT INTO `access_log` VALUES (1015, '35.77.15578224891560017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.23.154.150', '2019-05-14 16:28:09', 18, 0, '', '2019-05-14 16:28:09');
INSERT INTO `access_log` VALUES (1016, '30.67.15578224916400017', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:12', 6, 1002001012, '访问令牌已过期', '2019-05-14 16:28:12');
INSERT INTO `access_log` VALUES (1017, '30.72.15578224916450009', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.23.154.150', '2019-05-14 16:28:12', 5, 1002001012, '访问令牌已过期', '2019-05-14 16:28:12');
INSERT INTO `access_log` VALUES (1018, '30.65.15578224916430019', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.23.154.150', '2019-05-14 16:28:12', 4, 1002001012, '访问令牌已过期', '2019-05-14 16:28:12');
INSERT INTO `access_log` VALUES (1019, '35.75.15578225056290021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.23.154.150', '2019-05-14 16:28:26', 6, 0, '', '2019-05-14 16:28:26');
INSERT INTO `access_log` VALUES (1020, '35.79.15578225056280019', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:26', 16, 0, '', '2019-05-14 16:28:26');
INSERT INTO `access_log` VALUES (1021, '32.86.15578225062660021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:26', 4, 0, '', '2019-05-14 16:28:26');
INSERT INTO `access_log` VALUES (1022, '32.84.15578225064580023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:26', 5, 0, '', '2019-05-14 16:28:26');
INSERT INTO `access_log` VALUES (1023, '32.80.15578225077840025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:28', 5, 0, '', '2019-05-14 16:28:28');
INSERT INTO `access_log` VALUES (1024, '32.87.15578225083480023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:28', 5, 0, '', '2019-05-14 16:28:28');
INSERT INTO `access_log` VALUES (1025, '32.82.15578225088430025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:29', 4, 0, '', '2019-05-14 16:28:29');
INSERT INTO `access_log` VALUES (1026, '32.88.15578225091100025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:29', 4, 0, '', '2019-05-14 16:28:29');
INSERT INTO `access_log` VALUES (1027, '32.83.15578225095620025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:30', 5, 0, '', '2019-05-14 16:28:30');
INSERT INTO `access_log` VALUES (1028, '32.79.15578225098390025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:30', 5, 0, '', '2019-05-14 16:28:30');
INSERT INTO `access_log` VALUES (1029, '32.85.15578225101960027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:30', 4, 0, '', '2019-05-14 16:28:30');
INSERT INTO `access_log` VALUES (1030, '35.73.15578225114030019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:31', 6, 0, '', '2019-05-14 16:28:31');
INSERT INTO `access_log` VALUES (1031, '35.76.15578225114030019', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.23.154.150', '2019-05-14 16:28:31', 14, 0, '', '2019-05-14 16:28:31');
INSERT INTO `access_log` VALUES (1032, '32.81.15578225126380025', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.23.154.150', '2019-05-14 16:28:33', 13, 0, '', '2019-05-14 16:28:33');
INSERT INTO `access_log` VALUES (1033, '36.81.15578225128310005', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:33', 19, 0, '', '2019-05-14 16:28:33');
INSERT INTO `access_log` VALUES (1034, '32.86.15578225181220023', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.23.154.150', '2019-05-14 16:28:38', 15, 0, '', '2019-05-14 16:28:38');
INSERT INTO `access_log` VALUES (1035, '36.83.15578225182750005', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.230.166', '2019-05-14 16:28:38', 18, 0, '', '2019-05-14 16:28:38');
INSERT INTO `access_log` VALUES (1036, '30.70.15578225210470013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.23.154.150', '2019-05-14 16:28:41', 6, 1002001012, '访问令牌已过期', '2019-05-14 16:28:41');
INSERT INTO `access_log` VALUES (1037, '30.73.15578225225610015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.23.154.150', '2019-05-14 16:28:43', 4, 1002001012, '访问令牌已过期', '2019-05-14 16:28:43');
INSERT INTO `access_log` VALUES (1038, '30.68.15578225347810017', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.23.154.150', '2019-05-14 16:28:55', 4, 1002001012, '访问令牌已过期', '2019-05-14 16:28:55');
INSERT INTO `access_log` VALUES (1039, '30.64.15578225361480015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.23.154.150', '2019-05-14 16:28:56', 4, 1002001012, '访问令牌已过期', '2019-05-14 16:28:56');
INSERT INTO `access_log` VALUES (1040, '35.71.15578240057990019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.64.252', '2019-05-14 16:53:26', 576, 0, '', '2019-05-14 16:53:26');
INSERT INTO `access_log` VALUES (1041, '35.80.15578240058000019', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.64.252', '2019-05-14 16:53:26', 593, 0, '', '2019-05-14 16:53:26');
INSERT INTO `access_log` VALUES (1042, '32.84.15578240080770025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.64.252', '2019-05-14 16:53:28', 719, 0, '', '2019-05-14 16:53:29');
INSERT INTO `access_log` VALUES (1043, '32.80.15578240089640027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.64.252', '2019-05-14 16:53:29', 4, 0, '', '2019-05-14 16:53:29');
INSERT INTO `access_log` VALUES (1044, '30.71.15578240176120015', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.64.252', '2019-05-14 16:53:38', 15, 2001001000, '服务端发生异常', '2019-05-14 16:53:38');
INSERT INTO `access_log` VALUES (1045, '30.66.15578240176220017', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.64.252', '2019-05-14 16:53:38', 9, 0, '', '2019-05-14 16:53:38');
INSERT INTO `access_log` VALUES (1046, '30.65.15578240176020021', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.64.252', '2019-05-14 16:53:38', 13, 2001001000, '服务端发生异常', '2019-05-14 16:53:38');
INSERT INTO `access_log` VALUES (1047, '32.87.15578240507090025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.64.252', '2019-05-14 16:54:11', 5, 0, '', '2019-05-14 16:54:11');
INSERT INTO `access_log` VALUES (1048, '32.82.15578240508760027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.64.252', '2019-05-14 16:54:11', 4, 0, '', '2019-05-14 16:54:11');
INSERT INTO `access_log` VALUES (1049, '35.72.15578240521860019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.64.252', '2019-05-14 16:54:12', 6, 0, '', '2019-05-14 16:54:12');
INSERT INTO `access_log` VALUES (1050, '35.78.15578240521860019', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.64.252', '2019-05-14 16:54:12', 21, 0, '', '2019-05-14 16:54:12');
INSERT INTO `access_log` VALUES (1051, '35.74.15578285393600019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:08:59', 22, 0, '', '2019-05-14 18:08:59');
INSERT INTO `access_log` VALUES (1052, '35.77.15578285393610019', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:08:59', 50, 0, '', '2019-05-14 18:08:59');
INSERT INTO `access_log` VALUES (1053, '30.72.15578285441700013', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:09:04', 9, 0, '', '2019-05-14 18:09:04');
INSERT INTO `access_log` VALUES (1054, '30.67.15578285441660019', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:09:04', 16, 2001001000, '服务端发生异常', '2019-05-14 18:09:04');
INSERT INTO `access_log` VALUES (1055, '30.70.15578285441750017', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:09:04', 14, 2001001000, '服务端发生异常', '2019-05-14 18:09:04');
INSERT INTO `access_log` VALUES (1056, '32.88.15578285442370027', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:09:04', 20, 0, '', '2019-05-14 18:09:04');
INSERT INTO `access_log` VALUES (1057, '36.86.15578285446460005', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:09:05', 26, 0, '', '2019-05-14 18:09:05');
INSERT INTO `access_log` VALUES (1058, '35.75.15578285528260023', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:09:13', 7, 0, '', '2019-05-14 18:09:13');
INSERT INTO `access_log` VALUES (1059, '35.79.15578285528260021', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:09:13', 27, 0, '', '2019-05-14 18:09:13');
INSERT INTO `access_log` VALUES (1060, '32.83.15578285542050027', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:09:14', 17, 0, '', '2019-05-14 18:09:14');
INSERT INTO `access_log` VALUES (1061, '36.85.15578285543430005', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:09:14', 17, 0, '', '2019-05-14 18:09:14');
INSERT INTO `access_log` VALUES (1062, '35.73.15578288643200021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:14:24', 8, 0, '', '2019-05-14 18:14:24');
INSERT INTO `access_log` VALUES (1063, '35.76.15578288643210021', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:14:24', 31, 0, '', '2019-05-14 18:14:24');
INSERT INTO `access_log` VALUES (1064, '30.64.15578288688130017', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:14:29', 14, 2001001000, '服务端发生异常', '2019-05-14 18:14:29');
INSERT INTO `access_log` VALUES (1065, '30.73.15578288688150017', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:14:29', 16, 0, '', '2019-05-14 18:14:29');
INSERT INTO `access_log` VALUES (1066, '30.68.15578288688160021', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:14:29', 16, 2001001000, '服务端发生异常', '2019-05-14 18:14:29');
INSERT INTO `access_log` VALUES (1067, '30.65.15578288745430023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:14:35', 90, 0, '', '2019-05-14 18:14:35');
INSERT INTO `access_log` VALUES (1068, '30.71.15578288750210017', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:14:35', 162, 0, '', '2019-05-14 18:14:35');
INSERT INTO `access_log` VALUES (1069, '30.66.15578288750200019', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:14:35', 161, 2001001000, '服务端发生异常', '2019-05-14 18:14:35');
INSERT INTO `access_log` VALUES (1070, '30.69.15578288750220017', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:14:35', 164, 2001001000, '服务端发生异常', '2019-05-14 18:14:35');
INSERT INTO `access_log` VALUES (1071, '31.53.15578288843730003', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:14:44', 220, 2001001000, '服务端发生异常', '2019-05-14 18:14:45');
INSERT INTO `access_log` VALUES (1072, '31.48.15578288846720005', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:14:45', 202, 2001001000, '服务端发生异常', '2019-05-14 18:14:45');
INSERT INTO `access_log` VALUES (1073, '30.66.15578311797240021', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '14.154.178.202', '2019-05-14 18:53:00', 12, 2001001000, '服务端发生异常', '2019-05-14 18:53:00');
INSERT INTO `access_log` VALUES (1074, '30.71.15578311797240019', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '14.154.178.202', '2019-05-14 18:53:00', 24, 2001001000, '服务端发生异常', '2019-05-14 18:53:00');
INSERT INTO `access_log` VALUES (1075, '30.67.15578311797280021', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '14.154.178.202', '2019-05-14 18:53:00', 36, 0, '', '2019-05-14 18:53:00');
INSERT INTO `access_log` VALUES (1076, '35.72.15578379207880023', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '123.113.106.247', '2019-05-14 20:45:21', 26, 0, '', '2019-05-14 20:45:21');
INSERT INTO `access_log` VALUES (1077, '35.73.15578379207860023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '123.113.106.247', '2019-05-14 20:45:21', 69, 0, '', '2019-05-14 20:45:21');
INSERT INTO `access_log` VALUES (1078, '32.79.15578379306290027', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '123.113.106.247', '2019-05-14 20:45:31', 15, 0, '', '2019-05-14 20:45:31');
INSERT INTO `access_log` VALUES (1079, '36.88.15578379307790005', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '123.113.106.247', '2019-05-14 20:45:31', 16, 0, '', '2019-05-14 20:45:31');
INSERT INTO `access_log` VALUES (1080, '31.51.15578379450590005', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13111111111&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '123.113.106.247', '2019-05-14 20:45:45', 215, 2001001000, '服务端发生异常', '2019-05-14 20:45:45');
INSERT INTO `access_log` VALUES (1081, '35.78.15578379765910021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 20:46:17', 879, 0, '', '2019-05-14 20:46:17');
INSERT INTO `access_log` VALUES (1082, '35.77.15578379765910021', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 20:46:17', 977, 0, '', '2019-05-14 20:46:18');
INSERT INTO `access_log` VALUES (1083, '30.70.15578379835060019', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.129.40.151', '2019-05-14 20:46:24', 8, 0, '', '2019-05-14 20:46:24');
INSERT INTO `access_log` VALUES (1084, '30.64.15578379835030021', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.129.40.151', '2019-05-14 20:46:24', 22, 2001001000, '服务端发生异常', '2019-05-14 20:46:24');
INSERT INTO `access_log` VALUES (1085, '30.69.15578379835030021', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.129.40.151', '2019-05-14 20:46:24', 25, 2001001000, '服务端发生异常', '2019-05-14 20:46:24');
INSERT INTO `access_log` VALUES (1086, '32.85.15578380099320029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 20:46:50', 4, 0, '', '2019-05-14 20:46:50');
INSERT INTO `access_log` VALUES (1087, '32.81.15578380100860027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 20:46:50', 5, 0, '', '2019-05-14 20:46:50');
INSERT INTO `access_log` VALUES (1088, '32.86.15578380139660025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 20:46:54', 4, 0, '', '2019-05-14 20:46:54');
INSERT INTO `access_log` VALUES (1089, '32.84.15578380146630027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 20:46:55', 4, 0, '', '2019-05-14 20:46:55');
INSERT INTO `access_log` VALUES (1090, '32.80.15578380223670029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 20:47:02', 4, 0, '', '2019-05-14 20:47:02');
INSERT INTO `access_log` VALUES (1091, '32.87.15578380224900027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 20:47:02', 3, 0, '', '2019-05-14 20:47:02');
INSERT INTO `access_log` VALUES (1092, '35.75.15578380300080025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 20:47:10', 45, 0, '', '2019-05-14 20:47:10');
INSERT INTO `access_log` VALUES (1093, '35.79.15578380300100023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 20:47:10', 50, 0, '', '2019-05-14 20:47:10');
INSERT INTO `access_log` VALUES (1094, '32.82.15578380315750029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 20:47:12', 6, 0, '', '2019-05-14 20:47:12');
INSERT INTO `access_log` VALUES (1095, '32.88.15578380317160029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 20:47:12', 3, 0, '', '2019-05-14 20:47:12');
INSERT INTO `access_log` VALUES (1096, '35.71.15578389177230021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.239.74.122', '2019-05-14 21:01:58', 6, 0, '', '2019-05-14 21:01:58');
INSERT INTO `access_log` VALUES (1097, '35.74.15578389177270021', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.239.74.122', '2019-05-14 21:01:58', 14, 0, '', '2019-05-14 21:01:58');
INSERT INTO `access_log` VALUES (1098, '32.83.15578389223200029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.239.74.122', '2019-05-14 21:02:02', 234, 0, '', '2019-05-14 21:02:03');
INSERT INTO `access_log` VALUES (1099, '32.79.15578389231170029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.239.74.122', '2019-05-14 21:02:03', 4, 0, '', '2019-05-14 21:02:03');
INSERT INTO `access_log` VALUES (1100, '32.85.15578389265490031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.239.74.122', '2019-05-14 21:02:07', 4, 0, '', '2019-05-14 21:02:07');
INSERT INTO `access_log` VALUES (1101, '32.81.15578389267110029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.239.74.122', '2019-05-14 21:02:07', 5, 0, '', '2019-05-14 21:02:07');
INSERT INTO `access_log` VALUES (1102, '35.80.15578389294530021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.239.74.122', '2019-05-14 21:02:09', 4, 0, '', '2019-05-14 21:02:09');
INSERT INTO `access_log` VALUES (1103, '35.76.15578389294500023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.239.74.122', '2019-05-14 21:02:09', 17, 0, '', '2019-05-14 21:02:09');
INSERT INTO `access_log` VALUES (1104, '35.72.15578395893340025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.8.255.62', '2019-05-14 21:13:09', 8, 0, '', '2019-05-14 21:13:09');
INSERT INTO `access_log` VALUES (1105, '35.73.15578395893340025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.8.255.62', '2019-05-14 21:13:09', 37, 0, '', '2019-05-14 21:13:09');
INSERT INTO `access_log` VALUES (1106, '35.78.15578401068760023', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '114.219.22.229', '2019-05-14 21:21:47', 6, 0, '', '2019-05-14 21:21:47');
INSERT INTO `access_log` VALUES (1107, '35.77.15578401068850023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '114.219.22.229', '2019-05-14 21:21:47', 13, 0, '', '2019-05-14 21:21:47');
INSERT INTO `access_log` VALUES (1108, '32.86.15578401090140027', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '114.219.22.229', '2019-05-14 21:21:49', 15, 0, '', '2019-05-14 21:21:49');
INSERT INTO `access_log` VALUES (1109, '36.89.15578401091750003', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '114.219.22.229', '2019-05-14 21:21:49', 18, 0, '', '2019-05-14 21:21:49');
INSERT INTO `access_log` VALUES (1110, '30.64.15578404564420023', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.36.219.219', '2019-05-14 21:27:36', 7, 0, '', '2019-05-14 21:27:36');
INSERT INTO `access_log` VALUES (1111, '30.70.15578404564390021', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.36.219.219', '2019-05-14 21:27:36', 15, 2001001000, '服务端发生异常', '2019-05-14 21:27:36');
INSERT INTO `access_log` VALUES (1112, '30.73.15578404564710021', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.36.219.219', '2019-05-14 21:27:36', 14, 2001001000, '服务端发生异常', '2019-05-14 21:27:36');
INSERT INTO `access_log` VALUES (1113, '30.71.15578404794950021', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.36.219.219', '2019-05-14 21:27:59', 7, 0, '', '2019-05-14 21:28:00');
INSERT INTO `access_log` VALUES (1114, '30.65.15578404794810029', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.36.219.219', '2019-05-14 21:27:59', 53, 2001001000, '服务端发生异常', '2019-05-14 21:28:00');
INSERT INTO `access_log` VALUES (1115, '30.66.15578404794920025', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.36.219.219', '2019-05-14 21:27:59', 41, 2001001000, '服务端发生异常', '2019-05-14 21:28:00');
INSERT INTO `access_log` VALUES (1116, '35.79.15578422560630025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:57:36', 22, 0, '', '2019-05-14 21:57:36');
INSERT INTO `access_log` VALUES (1117, '35.75.15578422560630027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:57:36', 40, 0, '', '2019-05-14 21:57:36');
INSERT INTO `access_log` VALUES (1118, '33.82.15578422628710003', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=kafa&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:57:43', 2, -1, '未授权', '2019-05-14 21:57:43');
INSERT INTO `access_log` VALUES (1119, '35.71.15578422687850023', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:57:49', 7, 0, '', '2019-05-14 21:57:49');
INSERT INTO `access_log` VALUES (1120, '35.74.15578422687850023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:57:49', 14, 0, '', '2019-05-14 21:57:49');
INSERT INTO `access_log` VALUES (1121, '33.81.15578422744040003', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:57:54', 2, -1, '未授权', '2019-05-14 21:57:54');
INSERT INTO `access_log` VALUES (1122, '35.80.15578422775970023', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:57:58', 8, 0, '', '2019-05-14 21:57:58');
INSERT INTO `access_log` VALUES (1123, '35.76.15578422775970025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:57:58', 21, 0, '', '2019-05-14 21:57:58');
INSERT INTO `access_log` VALUES (1124, '32.84.15578422787250029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:57:59', 5, 0, '', '2019-05-14 21:57:59');
INSERT INTO `access_log` VALUES (1125, '32.80.15578422788540031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:57:59', 3, 0, '', '2019-05-14 21:57:59');
INSERT INTO `access_log` VALUES (1126, '32.87.15578422801330029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:58:00', 4, 0, '', '2019-05-14 21:58:00');
INSERT INTO `access_log` VALUES (1127, '32.82.15578422807430031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:58:01', 4, 0, '', '2019-05-14 21:58:01');
INSERT INTO `access_log` VALUES (1128, '32.88.15578422813050031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:58:01', 4, 0, '', '2019-05-14 21:58:01');
INSERT INTO `access_log` VALUES (1129, '32.83.15578423034100031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:58:23', 4, 0, '', '2019-05-14 21:58:23');
INSERT INTO `access_log` VALUES (1130, '32.79.15578423035530031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:58:24', 4, 0, '', '2019-05-14 21:58:24');
INSERT INTO `access_log` VALUES (1131, '31.49.15578423284470003', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18092176625&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:58:48', 84, 2001001000, '服务端发生异常', '2019-05-14 21:58:49');
INSERT INTO `access_log` VALUES (1132, '36.81.15578423349190007', 0, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:58:55', 2, -1, '未授权', '2019-05-14 21:58:55');
INSERT INTO `access_log` VALUES (1133, '35.72.15578423392630027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:58:59', 8, 0, '', '2019-05-14 21:58:59');
INSERT INTO `access_log` VALUES (1134, '35.73.15578423392630027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:58:59', 14, 0, '', '2019-05-14 21:58:59');
INSERT INTO `access_log` VALUES (1135, '32.85.15578423417300033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:02', 4, 0, '', '2019-05-14 21:59:02');
INSERT INTO `access_log` VALUES (1136, '32.81.15578423418650031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:02', 4, 0, '', '2019-05-14 21:59:02');
INSERT INTO `access_log` VALUES (1137, '32.86.15578423431160029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:03', 4, 0, '', '2019-05-14 21:59:03');
INSERT INTO `access_log` VALUES (1138, '32.84.15578423435760031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:04', 3, 0, '', '2019-05-14 21:59:04');
INSERT INTO `access_log` VALUES (1139, '35.78.15578423444010025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:04', 6, 0, '', '2019-05-14 21:59:04');
INSERT INTO `access_log` VALUES (1140, '35.77.15578423444010025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:04', 15, 0, '', '2019-05-14 21:59:04');
INSERT INTO `access_log` VALUES (1141, '32.80.15578423467770033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:07', 4, 0, '', '2019-05-14 21:59:07');
INSERT INTO `access_log` VALUES (1142, '32.87.15578423469040031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:07', 3, 0, '', '2019-05-14 21:59:07');
INSERT INTO `access_log` VALUES (1143, '35.79.15578423481500027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:08', 13, 0, '', '2019-05-14 21:59:08');
INSERT INTO `access_log` VALUES (1144, '35.75.15578423481500029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:08', 24, 0, '', '2019-05-14 21:59:08');
INSERT INTO `access_log` VALUES (1145, '30.69.15578423546240023', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:15', 7, 0, '', '2019-05-14 21:59:15');
INSERT INTO `access_log` VALUES (1146, '30.72.15578423546220015', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:15', 16, 2001001000, '服务端发生异常', '2019-05-14 21:59:15');
INSERT INTO `access_log` VALUES (1147, '30.68.15578423546220023', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:15', 19, 2001001000, '服务端发生异常', '2019-05-14 21:59:15');
INSERT INTO `access_log` VALUES (1148, '30.67.15578423653430023', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:25', 14, 2001001000, '服务端发生异常', '2019-05-14 21:59:25');
INSERT INTO `access_log` VALUES (1149, '30.70.15578423653440023', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:25', 21, 2001001000, '服务端发生异常', '2019-05-14 21:59:25');
INSERT INTO `access_log` VALUES (1150, '30.64.15578423653710025', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:59:25', 5, 0, '', '2019-05-14 21:59:25');
INSERT INTO `access_log` VALUES (1151, '35.71.15578428138830025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '123.52.24.227', '2019-05-14 22:06:54', 9, 0, '', '2019-05-14 22:06:54');
INSERT INTO `access_log` VALUES (1152, '35.74.15578428138830025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '123.52.24.227', '2019-05-14 22:06:54', 16, 0, '', '2019-05-14 22:06:54');
INSERT INTO `access_log` VALUES (1153, '30.73.15578428165050023', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '123.52.24.227', '2019-05-14 22:06:57', 15, 2001001000, '服务端发生异常', '2019-05-14 22:06:57');
INSERT INTO `access_log` VALUES (1154, '30.66.15578428165170027', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '123.52.24.227', '2019-05-14 22:06:57', 11, 0, '', '2019-05-14 22:06:57');
INSERT INTO `access_log` VALUES (1155, '30.71.15578428165160023', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '123.52.24.227', '2019-05-14 22:06:57', 13, 2001001000, '服务端发生异常', '2019-05-14 22:06:57');
INSERT INTO `access_log` VALUES (1156, '32.82.15578428240220033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '123.52.24.227', '2019-05-14 22:07:04', 4, 0, '', '2019-05-14 22:07:04');
INSERT INTO `access_log` VALUES (1157, '32.88.15578428241690033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '123.52.24.227', '2019-05-14 22:07:04', 4, 0, '', '2019-05-14 22:07:04');
INSERT INTO `access_log` VALUES (1158, '32.83.15578428254370033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '123.52.24.227', '2019-05-14 22:07:05', 4, 0, '', '2019-05-14 22:07:05');
INSERT INTO `access_log` VALUES (1159, '32.79.15578428260650033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '123.52.24.227', '2019-05-14 22:07:06', 4, 0, '', '2019-05-14 22:07:06');
INSERT INTO `access_log` VALUES (1160, '35.80.15578428269790025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '123.52.24.227', '2019-05-14 22:07:07', 5, 0, '', '2019-05-14 22:07:07');
INSERT INTO `access_log` VALUES (1161, '35.76.15578428269790027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '123.52.24.227', '2019-05-14 22:07:07', 15, 0, '', '2019-05-14 22:07:07');
INSERT INTO `access_log` VALUES (1162, '32.85.15578428280680035', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '123.52.24.227', '2019-05-14 22:07:08', 15, 0, '', '2019-05-14 22:07:08');
INSERT INTO `access_log` VALUES (1163, '36.84.15578428282720005', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '123.52.24.227', '2019-05-14 22:07:08', 22, 0, '', '2019-05-14 22:07:08');
INSERT INTO `access_log` VALUES (1164, '35.72.15578431871580029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 22:13:07', 12, 0, '', '2019-05-14 22:13:07');
INSERT INTO `access_log` VALUES (1165, '35.73.15578431871610029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 22:13:07', 16, 0, '', '2019-05-14 22:13:07');
INSERT INTO `access_log` VALUES (1166, '32.81.15578432127790033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 22:13:33', 4, 0, '', '2019-05-14 22:13:33');
INSERT INTO `access_log` VALUES (1167, '32.86.15578432131660031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 22:13:33', 4, 0, '', '2019-05-14 22:13:33');
INSERT INTO `access_log` VALUES (1168, '32.84.15578432148590033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 22:13:35', 1404, 0, '', '2019-05-14 22:13:36');
INSERT INTO `access_log` VALUES (1169, '32.84.15578432148590033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.129.40.151', '2019-05-14 22:13:35', 1404, 0, '', '2019-05-14 22:13:37');
INSERT INTO `access_log` VALUES (1170, '35.77.15578445695030027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:36:10', 4, 0, '', '2019-05-14 22:36:10');
INSERT INTO `access_log` VALUES (1171, '35.78.15578445694990027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:36:10', 144, 0, '', '2019-05-14 22:36:10');
INSERT INTO `access_log` VALUES (1172, '32.80.15578445777100035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:36:18', 20, 0, '', '2019-05-14 22:36:18');
INSERT INTO `access_log` VALUES (1173, '32.87.15578445778920033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:36:18', 4, 0, '', '2019-05-14 22:36:18');
INSERT INTO `access_log` VALUES (1174, '32.82.15578445830870035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:36:23', 4, 0, '', '2019-05-14 22:36:23');
INSERT INTO `access_log` VALUES (1175, '32.88.15578445846360035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:36:25', 4, 0, '', '2019-05-14 22:36:25');
INSERT INTO `access_log` VALUES (1176, '32.83.15578445921620035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:36:32', 4, 0, '', '2019-05-14 22:36:32');
INSERT INTO `access_log` VALUES (1177, '32.79.15578445923200035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:36:32', 4, 0, '', '2019-05-14 22:36:32');
INSERT INTO `access_log` VALUES (1178, '32.85.15578446020500037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:36:42', 4, 0, '', '2019-05-14 22:36:42');
INSERT INTO `access_log` VALUES (1179, '32.81.15578446021900035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:36:42', 4, 0, '', '2019-05-14 22:36:42');
INSERT INTO `access_log` VALUES (1180, '31.46.15578446293700005', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17765823217', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:37:10', 2070, 2001001000, '服务端发生异常', '2019-05-14 22:37:12');
INSERT INTO `access_log` VALUES (1181, '30.65.15578446513860031', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:37:31', 7, 0, '', '2019-05-14 22:37:31');
INSERT INTO `access_log` VALUES (1182, '30.69.15578446513860025', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:37:31', 151, 2001001000, '服务端发生异常', '2019-05-14 22:37:32');
INSERT INTO `access_log` VALUES (1183, '30.72.15578446513860017', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:37:31', 152, 2001001000, '服务端发生异常', '2019-05-14 22:37:32');
INSERT INTO `access_log` VALUES (1184, '30.73.15578451475330025', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:45:48', 54, 0, '', '2019-05-14 22:45:48');
INSERT INTO `access_log` VALUES (1185, '30.71.15578451734780025', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:46:13', 7, 0, '', '2019-05-14 22:46:13');
INSERT INTO `access_log` VALUES (1186, '30.72.15578452079900019', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:46:48', 7, 0, '', '2019-05-14 22:46:48');
INSERT INTO `access_log` VALUES (1187, '30.68.15578452079900027', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:46:48', 18, 2001001000, '服务端发生异常', '2019-05-14 22:46:48');
INSERT INTO `access_log` VALUES (1188, '30.69.15578452080000027', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:46:48', 23, 2001001000, '服务端发生异常', '2019-05-14 22:46:48');
INSERT INTO `access_log` VALUES (1189, '70f88d62-fc18-40c9-992a-9d2f0efab2cc', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:51:47', 180, 1002001012, '访问令牌已过期', '2019-05-14 23:51:48');
INSERT INTO `access_log` VALUES (1190, '47c48f8e-e3e1-4b1e-a2a8-0a5aa9b39f28', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:51:47', 180, 1002001012, '访问令牌已过期', '2019-05-14 23:51:48');
INSERT INTO `access_log` VALUES (1191, '05f0c11d-c1f4-4e29-8d00-732209860587', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:51:47', 184, 1002001012, '访问令牌已过期', '2019-05-14 23:51:48');
INSERT INTO `access_log` VALUES (1192, '92ae99a5-55f3-418e-bb05-18cffd173ab0', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:51:55', 242, 0, '', '2019-05-14 23:51:55');
INSERT INTO `access_log` VALUES (1193, '2431de91-91c2-41b2-96f3-de84f1355fbc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:51:55', 87, 0, '', '2019-05-14 23:51:55');
INSERT INTO `access_log` VALUES (1194, '6dab703c-1e4d-408e-bab3-6d5b3f147af4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:51:55', 106, 0, '', '2019-05-14 23:51:55');
INSERT INTO `access_log` VALUES (1195, '2bfa0086-6920-45d4-b10c-957f65200cc4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:51:55', 101, 0, '', '2019-05-14 23:51:55');
INSERT INTO `access_log` VALUES (1196, '1f3499b9-dc1d-4d05-b8a7-0db2d868a881', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:51:59', 138, 0, '', '2019-05-14 23:51:59');
INSERT INTO `access_log` VALUES (1197, '9daa61ed-4714-440b-bbf6-8fb8aab1eb7d', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:52:03', 1144, 0, '', '2019-05-14 23:52:04');
INSERT INTO `access_log` VALUES (1198, '501800d2-95f7-4f5f-a225-0b6332124a3a', 1, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=tianjiji&nickname=田基基&password=buzhidao', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:52:22', 154, 0, '', '2019-05-14 23:52:22');
INSERT INTO `access_log` VALUES (1199, 'fd0a647b-bb7f-472b-9dca-086398e50033', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:52:22', 42, 0, '', '2019-05-14 23:52:22');
INSERT INTO `access_log` VALUES (1200, '56a087a8-4685-44a9-b764-72190ede85e6', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:52:25', 81, 0, '', '2019-05-14 23:52:25');
INSERT INTO `access_log` VALUES (1201, '24a7701a-95a8-4c65-9f80-cab4e1a9e49f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:52:28', 28, 0, '', '2019-05-14 23:52:28');
INSERT INTO `access_log` VALUES (1202, 'f9465222-2f05-41bd-a07a-e97b600b8fb6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:52:28', 31, 0, '', '2019-05-14 23:52:28');
INSERT INTO `access_log` VALUES (1203, 'f69caf83-8b0c-4cab-a02d-22d700465318', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:52:28', 27, 0, '', '2019-05-14 23:52:28');
INSERT INTO `access_log` VALUES (1204, '075457ae-d950-410b-bab8-543ab928e5b7', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:52:28', 58, 0, '', '2019-05-14 23:52:28');
INSERT INTO `access_log` VALUES (1205, 'cf7a1d66-e460-4de7-9274-255fdb986ce5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:55:38', 256, 0, '', '2019-05-14 23:55:39');
INSERT INTO `access_log` VALUES (1206, '96d10031-9ab3-4156-92cb-75cb629711ff', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:55:38', 256, 0, '', '2019-05-14 23:55:39');
INSERT INTO `access_log` VALUES (1207, '1bd1af83-9501-46c8-a5d7-b2371fde6f4d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:55:38', 256, 0, '', '2019-05-14 23:55:39');
INSERT INTO `access_log` VALUES (1208, 'f8b77a90-8c6d-46cd-b508-f9affd9a7f7a', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:55:39', 241, 0, '', '2019-05-14 23:55:39');
INSERT INTO `access_log` VALUES (1209, '8f99e409-eb29-4588-bb2d-b42f55d8f455', 1, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=laotian&nickname=老田&password=buzhidao', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:55:53', 158, 0, '', '2019-05-14 23:55:53');
INSERT INTO `access_log` VALUES (1210, 'f90dbdc8-d109-4a6f-8c5f-73298b09a859', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:55:54', 45, 0, '', '2019-05-14 23:55:54');
INSERT INTO `access_log` VALUES (1211, 'd2c796b3-e01a-4aa1-b57c-a525c13f8eed', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:55:56', 52, 0, '', '2019-05-14 23:55:56');
INSERT INTO `access_log` VALUES (1212, 'de77a640-ec2d-4603-96e8-c7db837a4a4b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:57:26', 353, 0, '', '2019-05-14 23:57:27');
INSERT INTO `access_log` VALUES (1213, '8a3c27f6-28fc-4a1e-8f50-3770a5233fa3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:57:26', 353, 0, '', '2019-05-14 23:57:27');
INSERT INTO `access_log` VALUES (1214, 'f0f0ef1b-74a4-43ae-9a08-26fb557bfddf', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:57:26', 351, 0, '', '2019-05-14 23:57:27');
INSERT INTO `access_log` VALUES (1215, 'c09486b5-0437-4c37-8a87-9786f1af09d5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:57:26', 353, 0, '', '2019-05-14 23:57:27');
INSERT INTO `access_log` VALUES (1216, 'a2e054b9-d0b3-4f95-a2dd-a62ed5779424', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:57:32', 27, 0, '', '2019-05-14 23:57:32');
INSERT INTO `access_log` VALUES (1217, 'c0009466-3399-4f7f-8876-438aeae1d5ca', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:57:32', 38, 0, '', '2019-05-14 23:57:32');
INSERT INTO `access_log` VALUES (1218, '9f4ff990-fb3a-4e30-9fe5-e736b58d4058', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:57:32', 40, 0, '', '2019-05-14 23:57:32');
INSERT INTO `access_log` VALUES (1219, '7485ed84-c5ac-41b1-8253-a0bb40196509', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:57:32', 40, 0, '', '2019-05-14 23:57:32');
INSERT INTO `access_log` VALUES (1220, 'd755e0d0-da81-404c-9b6d-e4c97dd73a99', 1, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=wangyunai&nickname=王芋艿&password=buzhidao', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:57:53', 151, 0, '', '2019-05-14 23:57:54');
INSERT INTO `access_log` VALUES (1221, '00ef667c-906d-4bee-88bf-30e9783a8fdc', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:57:54', 43, 0, '', '2019-05-14 23:57:54');
INSERT INTO `access_log` VALUES (1222, 'ad8a658a-8099-4f5a-9f27-3bebc17fbb4b', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-14 23:57:57', 47, 0, '', '2019-05-14 23:57:57');
INSERT INTO `access_log` VALUES (1223, 'd23911fc-eb84-4834-8ee5-137f3cfb3290', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:14:59', 393, 0, '', '2019-05-15 00:15:00');
INSERT INTO `access_log` VALUES (1224, '7bc72dba-2bbb-442b-84e6-aae1010f3fb9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:14:59', 393, 0, '', '2019-05-15 00:15:00');
INSERT INTO `access_log` VALUES (1225, '07a2a824-c891-4681-90ea-9914086ed19e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:14:59', 405, 0, '', '2019-05-15 00:15:00');
INSERT INTO `access_log` VALUES (1226, 'd0196611-50a6-4547-b064-e5bd0faeb5b7', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:14:59', 443, 0, '', '2019-05-15 00:15:00');
INSERT INTO `access_log` VALUES (1227, 'd0acf401-dc29-4805-ab73-9adcb87b7e96', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:17:20', 280, 0, '', '2019-05-15 00:17:21');
INSERT INTO `access_log` VALUES (1228, '7ceba84c-f489-416d-bdba-9f00f1b44642', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:17:20', 262, 0, '', '2019-05-15 00:17:21');
INSERT INTO `access_log` VALUES (1229, '53969e23-b33c-4e4d-9518-91d41ebf1671', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:17:20', 245, 0, '', '2019-05-15 00:17:21');
INSERT INTO `access_log` VALUES (1230, '5b05a25a-d868-48c1-aa1c-dbb16be359ec', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:17:21', 347, 0, '', '2019-05-15 00:17:21');
INSERT INTO `access_log` VALUES (1231, 'd3b0ba44-1a05-497c-82ef-9eb64a998f03', 1, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=doudou&nickname=我是豆豆&password=buzhidao', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:17:40', 460, 2001001000, '服务端发生异常', '2019-05-15 00:17:41');
INSERT INTO `access_log` VALUES (1232, '35.75.15578506847750031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.199.190.48', '2019-05-15 00:18:05', 54, 0, '', '2019-05-15 00:18:05');
INSERT INTO `access_log` VALUES (1233, '35.79.15578506847740029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.199.190.48', '2019-05-15 00:18:05', 135, 0, '', '2019-05-15 00:18:05');
INSERT INTO `access_log` VALUES (1234, '32.86.15578506923620033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.199.190.48', '2019-05-15 00:18:12', 47, 0, '', '2019-05-15 00:18:12');
INSERT INTO `access_log` VALUES (1235, '32.84.15578506925400035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.199.190.48', '2019-05-15 00:18:13', 4, 0, '', '2019-05-15 00:18:13');
INSERT INTO `access_log` VALUES (1236, '2fca37c8-e4e3-411f-8b00-6966e2c23743', 1, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=doudou&nickname=我是豆豆&password=buzhidao', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:19:00', 134, 0, '', '2019-05-15 00:19:00');
INSERT INTO `access_log` VALUES (1237, '510d660e-cace-477a-a6f4-92e9e3602251', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:19:00', 40, 0, '', '2019-05-15 00:19:00');
INSERT INTO `access_log` VALUES (1238, '8abb8e64-1be8-4e88-911e-4057357a6c56', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:19:02', 50, 0, '', '2019-05-15 00:19:02');
INSERT INTO `access_log` VALUES (1239, '354afbcd-55f9-41b4-9f4a-5bb8be0abdb0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:19:03', 24, 0, '', '2019-05-15 00:19:03');
INSERT INTO `access_log` VALUES (1240, '2c32ef87-fdd4-4e8a-ae22-c7dfc92104d6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:19:03', 39, 0, '', '2019-05-15 00:19:04');
INSERT INTO `access_log` VALUES (1241, '34d9cd2f-cd08-4235-80f8-d40e46a2a5c6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:19:03', 42, 0, '', '2019-05-15 00:19:04');
INSERT INTO `access_log` VALUES (1242, 'd21e3368-8edb-4cdb-b017-a53d0f435464', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:19:04', 52, 0, '', '2019-05-15 00:19:04');
INSERT INTO `access_log` VALUES (1243, '5e0759a3-2637-479a-bda9-c4e194030dae', 1, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=doudouo&nickname=管理员&password=buzhidao', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:19:21', 145, 0, '', '2019-05-15 00:19:21');
INSERT INTO `access_log` VALUES (1244, '49be76a8-fa47-4c60-83b9-1bd5d77e7787', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:19:21', 51, 0, '', '2019-05-15 00:19:21');
INSERT INTO `access_log` VALUES (1245, '35.74.15578512551260027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.72.76.3', '2019-05-15 00:27:35', 7, 0, '', '2019-05-15 00:27:35');
INSERT INTO `access_log` VALUES (1246, '35.71.15578512551270027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.72.76.3', '2019-05-15 00:27:35', 116, 0, '', '2019-05-15 00:27:35');
INSERT INTO `access_log` VALUES (1247, '30.65.15578512628160033', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.72.76.3', '2019-05-15 00:27:43', 7, 0, '', '2019-05-15 00:27:43');
INSERT INTO `access_log` VALUES (1248, '30.70.15578512628130025', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.72.76.3', '2019-05-15 00:27:43', 16, 2001001000, '服务端发生异常', '2019-05-15 00:27:43');
INSERT INTO `access_log` VALUES (1249, '30.66.15578512628130029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.72.76.3', '2019-05-15 00:27:43', 21, 2001001000, '服务端发生异常', '2019-05-15 00:27:43');
INSERT INTO `access_log` VALUES (1250, 'b337d204-a609-417a-8ada-590a29ae6122', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:28:22', 230, 0, '', '2019-05-15 00:28:23');
INSERT INTO `access_log` VALUES (1251, '9763bb8d-ca91-4f11-b0c4-f3f652e3a968', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:28:22', 234, 0, '', '2019-05-15 00:28:23');
INSERT INTO `access_log` VALUES (1252, 'fea11294-fac9-45cd-899a-f761f90bbeee', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:28:22', 233, 0, '', '2019-05-15 00:28:23');
INSERT INTO `access_log` VALUES (1253, '990070de-8e01-4084-8cfa-835c9b52e723', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:28:22', 233, 0, '', '2019-05-15 00:28:23');
INSERT INTO `access_log` VALUES (1254, '50210678-8da6-4f2e-a34a-2cd29e9d1db2', 1, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=huibuhui&nickname=会不会&password=buzhidao', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:28:41', 78, 1002002002, '账号已经存在', '2019-05-15 00:28:42');
INSERT INTO `access_log` VALUES (1255, '53358285-debc-4e9d-baad-16c055da2340', 1, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=huibuhui&nickname=会不会&password=buzhidao', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:28:59', 120, 0, '', '2019-05-15 00:29:00');
INSERT INTO `access_log` VALUES (1256, '4cb35763-ae8b-426c-a232-5dead22ed597', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:29:00', 42, 0, '', '2019-05-15 00:29:00');
INSERT INTO `access_log` VALUES (1257, '5d0a3232-372a-40dc-90a6-27b6862e9b85', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=sdsfsdf', 'POST', 'PostmanRuntime/6.2.5', '0:0:0:0:0:0:0:1', '2019-05-15 00:55:04', 11052, 1001001021, '刷新令牌不存在', '2019-05-15 00:55:16');
INSERT INTO `access_log` VALUES (1258, '093b93d3-48d9-472a-bd71-86d7d287cedc', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=sdsfsdf', 'POST', 'PostmanRuntime/6.2.5', '0:0:0:0:0:0:0:1', '2019-05-15 01:00:22', 7111, 2001001000, '服务端发生异常', '2019-05-15 01:00:29');
INSERT INTO `access_log` VALUES (1259, '54fe8e8b-2ce1-4b28-b55a-67fce1970940', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=sdsfsdf', 'POST', 'PostmanRuntime/6.2.5', '0:0:0:0:0:0:0:1', '2019-05-15 01:02:03', 4615, 1001001021, '刷新令牌不存在', '2019-05-15 01:02:07');
INSERT INTO `access_log` VALUES (1260, '35.76.15578830311500029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.101.22', '2019-05-15 09:17:11', 19, 0, '', '2019-05-15 09:17:11');
INSERT INTO `access_log` VALUES (1261, '35.80.15578830311500027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.101.22', '2019-05-15 09:17:11', 41, 0, '', '2019-05-15 09:17:11');
INSERT INTO `access_log` VALUES (1262, '32.80.15578830399630037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.101.22', '2019-05-15 09:17:20', 113, 0, '', '2019-05-15 09:17:20');
INSERT INTO `access_log` VALUES (1263, '32.87.15578830407220035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.101.22', '2019-05-15 09:17:21', 12, 0, '', '2019-05-15 09:17:21');
INSERT INTO `access_log` VALUES (1264, '35.72.15578831007190031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.131.117.100', '2019-05-15 09:18:21', 639, 0, '', '2019-05-15 09:18:21');
INSERT INTO `access_log` VALUES (1265, '35.73.15578831007260031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.131.117.100', '2019-05-15 09:18:21', 639, 0, '', '2019-05-15 09:18:21');
INSERT INTO `access_log` VALUES (1266, '35.77.15578857922280029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '72.52.87.190', '2019-05-15 10:03:12', 911, 0, '', '2019-05-15 10:03:13');
INSERT INTO `access_log` VALUES (1267, '35.78.15578857922280029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '72.52.87.190', '2019-05-15 10:03:12', 1205, 0, '', '2019-05-15 10:03:13');
INSERT INTO `access_log` VALUES (1268, '30.67.15578859291410027', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.7.82', '2019-05-15 10:05:29', 53, 2001001000, '服务端发生异常', '2019-05-15 10:05:29');
INSERT INTO `access_log` VALUES (1269, '30.72.15578859291560021', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.7.82', '2019-05-15 10:05:29', 48, 2001001000, '服务端发生异常', '2019-05-15 10:05:29');
INSERT INTO `access_log` VALUES (1270, '30.64.15578859291570031', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.7.82', '2019-05-15 10:05:29', 52, 0, '', '2019-05-15 10:05:29');
INSERT INTO `access_log` VALUES (1271, '35.75.15578866407510033', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.90.47.66', '2019-05-15 10:17:21', 8, 0, '', '2019-05-15 10:17:21');
INSERT INTO `access_log` VALUES (1272, '35.79.15578866409710031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.90.47.66', '2019-05-15 10:17:21', 97, 0, '', '2019-05-15 10:17:21');
INSERT INTO `access_log` VALUES (1273, '32.82.15578866493670037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.90.47.66', '2019-05-15 10:17:29', 31, 0, '', '2019-05-15 10:17:29');
INSERT INTO `access_log` VALUES (1274, '32.88.15578866495170037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.90.47.66', '2019-05-15 10:17:30', 4, 0, '', '2019-05-15 10:17:30');
INSERT INTO `access_log` VALUES (1275, '35.74.15578866527390029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.90.47.66', '2019-05-15 10:17:33', 6, 0, '', '2019-05-15 10:17:33');
INSERT INTO `access_log` VALUES (1276, '35.71.15578866527410029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.90.47.66', '2019-05-15 10:17:33', 25, 0, '', '2019-05-15 10:17:33');
INSERT INTO `access_log` VALUES (1277, '30.70.15578866624540027', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.90.47.66', '2019-05-15 10:17:42', 6, 0, '', '2019-05-15 10:17:42');
INSERT INTO `access_log` VALUES (1278, '30.73.15578866624480027', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.90.47.66', '2019-05-15 10:17:42', 49, 2001001000, '服务端发生异常', '2019-05-15 10:17:42');
INSERT INTO `access_log` VALUES (1279, '30.65.15578866624450035', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.90.47.66', '2019-05-15 10:17:42', 51, 2001001000, '服务端发生异常', '2019-05-15 10:17:42');
INSERT INTO `access_log` VALUES (1280, 'e7d857f1-bd44-495d-bc5a-86bdee4b514b', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:23:45', 167, 1002001012, '访问令牌已过期', '2019-05-15 10:23:45');
INSERT INTO `access_log` VALUES (1281, 'e7125952-4bad-4cd6-99b2-a2a4c8c01ee7', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:23:45', 167, 1002001012, '访问令牌已过期', '2019-05-15 10:23:45');
INSERT INTO `access_log` VALUES (1282, '7fb617c7-3070-4ce1-b4d7-29004d376f45', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:23:45', 167, 1002001012, '访问令牌已过期', '2019-05-15 10:23:45');
INSERT INTO `access_log` VALUES (1283, 'ad4d40c9-48c7-4689-8700-5299c6c8a0b1', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:23:48', 159, 0, '', '2019-05-15 10:23:48');
INSERT INTO `access_log` VALUES (1284, '1a36d409-e036-402a-847a-f61737375063', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:23:48', 76, 0, '', '2019-05-15 10:23:48');
INSERT INTO `access_log` VALUES (1285, '8168c747-0f76-4bd9-965f-ad54db504d3c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:23:48', 100, 0, '', '2019-05-15 10:23:48');
INSERT INTO `access_log` VALUES (1286, '616c0f86-7d45-48ea-9eec-51241404e1b5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:23:48', 119, 0, '', '2019-05-15 10:23:48');
INSERT INTO `access_log` VALUES (1287, 'e19b6489-2790-42a0-b50b-26a9e9db730a', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:23:50', 73, 0, '', '2019-05-15 10:23:50');
INSERT INTO `access_log` VALUES (1288, '5e072a3e-6eeb-4549-8f5f-c14d2a022859', 1, 2, 'admin-application', '/admin-api/admins/admin/update', 'id=4&username=lilizaimu&nickname=我也想变成管理员', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:24:14', 128, 0, '', '2019-05-15 10:24:14');
INSERT INTO `access_log` VALUES (1289, 'b03364c5-badf-457c-bf45-f0400c11032b', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:24:14', 19, 0, '', '2019-05-15 10:24:14');
INSERT INTO `access_log` VALUES (1290, 'accd434f-5385-4c36-b8f5-5c43ae115a7d', 1, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=4&status=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:24:21', 129, 0, '', '2019-05-15 10:24:21');
INSERT INTO `access_log` VALUES (1291, 'cc47e17b-598a-4f11-a172-4c9b655bae07', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:24:21', 22, 0, '', '2019-05-15 10:24:21');
INSERT INTO `access_log` VALUES (1292, '02c53ea6-d5a9-4eb6-8637-a0016d7963ab', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=4', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:24:22', 53, 0, '', '2019-05-15 10:24:23');
INSERT INTO `access_log` VALUES (1293, '35.76.15578871249290031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.115.22.14', '2019-05-15 10:25:25', 6, 0, '', '2019-05-15 10:25:25');
INSERT INTO `access_log` VALUES (1294, '35.80.15578871249300029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.115.22.14', '2019-05-15 10:25:25', 17, 0, '', '2019-05-15 10:25:25');
INSERT INTO `access_log` VALUES (1295, '30.69.15578871398180033', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.115.22.14', '2019-05-15 10:25:40', 7, 0, '', '2019-05-15 10:25:40');
INSERT INTO `access_log` VALUES (1296, '30.66.15578871398110031', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.115.22.14', '2019-05-15 10:25:40', 18, 2001001000, '服务端发生异常', '2019-05-15 10:25:40');
INSERT INTO `access_log` VALUES (1297, '30.68.15578871398110029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.115.22.14', '2019-05-15 10:25:40', 28, 2001001000, '服务端发生异常', '2019-05-15 10:25:40');
INSERT INTO `access_log` VALUES (1298, '30.71.15578872694110029', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.7.82', '2019-05-15 10:27:49', 15, 2001001000, '服务端发生异常', '2019-05-15 10:27:49');
INSERT INTO `access_log` VALUES (1299, '30.64.15578872694300033', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.7.82', '2019-05-15 10:27:49', 6, 0, '', '2019-05-15 10:27:49');
INSERT INTO `access_log` VALUES (1300, '30.67.15578872694190029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.7.82', '2019-05-15 10:27:49', 35, 2001001000, '服务端发生异常', '2019-05-15 10:27:49');
INSERT INTO `access_log` VALUES (1301, '5cc5c5f9-d602-41af-8aa8-4abd2c0cf824', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:38:47', 276, 0, '', '2019-05-15 10:38:48');
INSERT INTO `access_log` VALUES (1302, '9b560e45-77d8-4284-9a97-74de43842c2d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:38:47', 276, 0, '', '2019-05-15 10:38:48');
INSERT INTO `access_log` VALUES (1303, 'a2a19976-0770-44e8-8428-b41b395d382c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:38:47', 276, 0, '', '2019-05-15 10:38:48');
INSERT INTO `access_log` VALUES (1304, '47c1a77b-f1f3-4663-98a5-cd9de493ee4b', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:38:47', 264, 0, '', '2019-05-15 10:38:48');
INSERT INTO `access_log` VALUES (1305, '6e303f4e-ce8b-4ff0-bbfa-28018d14befe', 1, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=4&status=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:38:53', 155, 0, '', '2019-05-15 10:38:53');
INSERT INTO `access_log` VALUES (1306, 'd52ce6be-f248-42cc-bc89-be04d861fce1', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:38:53', 19, 0, '', '2019-05-15 10:38:53');
INSERT INTO `access_log` VALUES (1307, '45682586-c49d-4f9c-a310-69b5562d7b9b', 1, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=4&status=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:38:56', 77, 0, '', '2019-05-15 10:38:56');
INSERT INTO `access_log` VALUES (1308, 'caf09872-6ac1-408f-bd2b-ac5f4272253f', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 10:38:56', 21, 0, '', '2019-05-15 10:38:56');
INSERT INTO `access_log` VALUES (1309, '30.72.15578893987750023', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.162', '2019-05-15 11:03:19', 86, 1002001012, '访问令牌已过期', '2019-05-15 11:03:19');
INSERT INTO `access_log` VALUES (1310, '30.73.15578893987790029', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.162', '2019-05-15 11:03:19', 85, 1002001012, '访问令牌已过期', '2019-05-15 11:03:19');
INSERT INTO `access_log` VALUES (1311, '30.70.15578893987770029', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.162', '2019-05-15 11:03:19', 97, 1002001012, '访问令牌已过期', '2019-05-15 11:03:19');
INSERT INTO `access_log` VALUES (1312, '35.73.15578908645680033', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-15 11:27:45', 19, 0, '', '2019-05-15 11:27:45');
INSERT INTO `access_log` VALUES (1313, '35.72.15578908645680033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-15 11:27:45', 132, 0, '', '2019-05-15 11:27:45');
INSERT INTO `access_log` VALUES (1314, '35.77.15578908694510031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.36.215', '2019-05-15 11:27:49', 7, 0, '', '2019-05-15 11:27:49');
INSERT INTO `access_log` VALUES (1315, '35.78.15578908695980031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.36.215', '2019-05-15 11:27:50', 5, 0, '', '2019-05-15 11:27:50');
INSERT INTO `access_log` VALUES (1316, '35.75.15578908696510035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-15 11:27:50', 6, 0, '', '2019-05-15 11:27:50');
INSERT INTO `access_log` VALUES (1317, '35.79.15578908696510033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-15 11:27:50', 86, 0, '', '2019-05-15 11:27:50');
INSERT INTO `access_log` VALUES (1318, '35.74.15578908697320031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.36.215', '2019-05-15 11:27:50', 5, 0, '', '2019-05-15 11:27:50');
INSERT INTO `access_log` VALUES (1319, '35.71.15578908697730031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-05-15 11:27:50', 11, 0, '', '2019-05-15 11:27:50');
INSERT INTO `access_log` VALUES (1320, '35.80.15578908699310031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-05-15 11:27:50', 15, 0, '', '2019-05-15 11:27:50');
INSERT INTO `access_log` VALUES (1321, '35.76.15578908698900033', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.36.215', '2019-05-15 11:27:50', 5, 0, '', '2019-05-15 11:27:50');
INSERT INTO `access_log` VALUES (1322, '35.73.15578908700850035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-05-15 11:27:50', 11, 0, '', '2019-05-15 11:27:50');
INSERT INTO `access_log` VALUES (1323, '35.72.15578908701290035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.36.215', '2019-05-15 11:27:50', 4, 0, '', '2019-05-15 11:27:50');
INSERT INTO `access_log` VALUES (1324, '35.77.15578908702260033', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Java/1.8.0_181', '117.50.36.215', '2019-05-15 11:27:50', 6, 0, '', '2019-05-15 11:27:50');
INSERT INTO `access_log` VALUES (1325, '35.78.15578908702510033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-05-15 11:27:50', 10, 0, '', '2019-05-15 11:27:50');
INSERT INTO `access_log` VALUES (1326, '35.75.15578908703790037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-05-15 11:27:50', 25, 0, '', '2019-05-15 11:27:50');
INSERT INTO `access_log` VALUES (1327, '35.74.15578908705310033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Java/1.8.0_151', '120.132.59.70', '2019-05-15 11:27:51', 13, 0, '', '2019-05-15 11:27:51');
INSERT INTO `access_log` VALUES (1328, '31.47.15578908788750005', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15521508114', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-15 11:27:59', 189, 2001001000, '服务端发生异常', '2019-05-15 11:27:59');
INSERT INTO `access_log` VALUES (1329, '32.83.15578908840620037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-15 11:28:04', 14, 0, '', '2019-05-15 11:28:04');
INSERT INTO `access_log` VALUES (1330, '32.79.15578908841800037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-15 11:28:04', 20, 0, '', '2019-05-15 11:28:04');
INSERT INTO `access_log` VALUES (1331, '35.79.15578908852150035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-15 11:28:05', 5, 0, '', '2019-05-15 11:28:05');
INSERT INTO `access_log` VALUES (1332, '35.71.15578908852430033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-15 11:28:05', 13, 0, '', '2019-05-15 11:28:05');
INSERT INTO `access_log` VALUES (1333, '32.85.15578908855390039', 0, 1, 'product-application', '/product-api/users/category/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.97.43', '2019-05-15 11:28:06', 1026, 2001001001, '参数缺失:Required Integer parameter \'pid\' is not present', '2019-05-15 11:28:07');
INSERT INTO `access_log` VALUES (1334, '32.81.15578908868030037', 0, 1, 'product-application', '/product-api/users/category/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.97.43', '2019-05-15 11:28:07', 7, 2001001001, '参数缺失:Required Integer parameter \'pid\' is not present', '2019-05-15 11:28:07');
INSERT INTO `access_log` VALUES (1335, '32.86.15578908869490035', 0, 1, 'product-application', '/product-api/users/category/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.97.43', '2019-05-15 11:28:07', 3, 2001001001, '参数缺失:Required Integer parameter \'pid\' is not present', '2019-05-15 11:28:07');
INSERT INTO `access_log` VALUES (1336, '32.84.15578908871000037', 0, 1, 'product-application', '/product-api/users/category/list', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.97.43', '2019-05-15 11:28:07', 19, 2001001001, '参数缺失:Required Integer parameter \'pid\' is not present', '2019-05-15 11:28:07');
INSERT INTO `access_log` VALUES (1337, '32.80.15578908873450039', 0, 1, 'product-application', '/product-api/users/category/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.97.43', '2019-05-15 11:28:07', 4, 2001001001, '参数缺失:Required Integer parameter \'pid\' is not present', '2019-05-15 11:28:07');
INSERT INTO `access_log` VALUES (1338, '32.87.15578908874710037', 0, 1, 'product-application', '/product-api/users/category/list', '', 'GET', 'Java/1.8.0_171', '106.75.97.43', '2019-05-15 11:28:07', 10, 2001001001, '参数缺失:Required Integer parameter \'pid\' is not present', '2019-05-15 11:28:07');
INSERT INTO `access_log` VALUES (1339, '30.68.15578910673000031', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.186.227.106', '2019-05-15 11:31:07', 8, 0, '', '2019-05-15 11:31:07');
INSERT INTO `access_log` VALUES (1340, '30.69.15578910672980035', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.186.227.106', '2019-05-15 11:31:07', 30, 2001001000, '服务端发生异常', '2019-05-15 11:31:07');
INSERT INTO `access_log` VALUES (1341, '30.65.15578910672980037', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.186.227.106', '2019-05-15 11:31:07', 44, 2001001000, '服务端发生异常', '2019-05-15 11:31:07');
INSERT INTO `access_log` VALUES (1342, '7d8a6d5c-3002-45ff-a525-9d6c5fcec8fe', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:32:13', 109, 1002001012, '访问令牌已过期', '2019-05-15 11:32:13');
INSERT INTO `access_log` VALUES (1343, '756d015d-67d1-4a77-b6d9-56109c176783', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:32:13', 58, 1002001012, '访问令牌已过期', '2019-05-15 11:32:13');
INSERT INTO `access_log` VALUES (1344, 'ea2a4b42-8795-498d-9587-88ba4516b5c5', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:32:13', 109, 1002001012, '访问令牌已过期', '2019-05-15 11:32:13');
INSERT INTO `access_log` VALUES (1345, '58165974-eea6-4529-b236-bda33c1a45b1', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:32:13', 109, 1002001012, '访问令牌已过期', '2019-05-15 11:32:13');
INSERT INTO `access_log` VALUES (1346, 'f105b9cf-c560-4dd3-b205-e69d92c89d47', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:32:15', 150, 0, '', '2019-05-15 11:32:15');
INSERT INTO `access_log` VALUES (1347, 'b802dfeb-213f-43e0-b583-faebc515fa61', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:32:15', 59, 0, '', '2019-05-15 11:32:16');
INSERT INTO `access_log` VALUES (1348, 'd45f2f4a-c505-4922-bede-17ba39c57bb7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:32:15', 75, 0, '', '2019-05-15 11:32:16');
INSERT INTO `access_log` VALUES (1349, '96c3af11-64ad-43da-83dd-a0150478b92d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:32:15', 79, 0, '', '2019-05-15 11:32:16');
INSERT INTO `access_log` VALUES (1350, '458981fa-2aaf-4756-9861-e1b872d6971d', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:32:17', 65, 0, '', '2019-05-15 11:32:17');
INSERT INTO `access_log` VALUES (1351, '49b37546-db6e-45aa-82b5-dd80e16ef6fd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:32:29', 8, 0, '', '2019-05-15 11:32:29');
INSERT INTO `access_log` VALUES (1352, '3fc3b52e-fc20-4d5c-8476-9e746edb79ef', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:32:29', 14, 0, '', '2019-05-15 11:32:29');
INSERT INTO `access_log` VALUES (1353, 'd2a5c6df-583f-415b-9fd9-a5414747b169', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:32:29', 13, 0, '', '2019-05-15 11:32:29');
INSERT INTO `access_log` VALUES (1354, '62bf62f4-1697-42d5-b1f0-899161a5d8f2', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:32:29', 8, 0, '', '2019-05-15 11:32:29');
INSERT INTO `access_log` VALUES (1355, 'ac4102b8-788d-42fb-9df3-6d18e8784174', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:34:03', 214, 0, '', '2019-05-15 11:34:03');
INSERT INTO `access_log` VALUES (1356, 'bce915f1-d570-41ba-bb59-613bdf6be8c3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:34:03', 214, 0, '', '2019-05-15 11:34:03');
INSERT INTO `access_log` VALUES (1357, '59ec249e-cfc1-44d3-aad3-e76f3ce21a3b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:34:03', 213, 0, '', '2019-05-15 11:34:03');
INSERT INTO `access_log` VALUES (1358, '3ab33306-13f0-42b4-9b5b-48c4b62bf64c', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:34:03', 275, 0, '', '2019-05-15 11:34:03');
INSERT INTO `access_log` VALUES (1359, '3fcf8c27-c5ae-4589-be95-f3f2fce3c501', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:34:25', 287, 0, '', '2019-05-15 11:34:25');
INSERT INTO `access_log` VALUES (1360, '4421a36a-9fbf-4255-96f2-58ca18068534', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:34:25', 287, 0, '', '2019-05-15 11:34:25');
INSERT INTO `access_log` VALUES (1361, 'c430db9e-b49f-4a3d-ac0c-fc862dec4c0f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:34:25', 287, 0, '', '2019-05-15 11:34:25');
INSERT INTO `access_log` VALUES (1362, 'd4583b23-f269-45af-9e36-6b314ea74edb', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:34:25', 6681, 0, '', '2019-05-15 11:34:32');
INSERT INTO `access_log` VALUES (1363, '35.80.15578913469430033', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:35:47', 7, 0, '', '2019-05-15 11:35:47');
INSERT INTO `access_log` VALUES (1364, '35.76.15578913469450035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:35:47', 51, 0, '', '2019-05-15 11:35:47');
INSERT INTO `access_log` VALUES (1365, '32.82.15578913525790039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:35:53', 4, 0, '', '2019-05-15 11:35:53');
INSERT INTO `access_log` VALUES (1366, '32.88.15578913527100039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:35:53', 4, 0, '', '2019-05-15 11:35:53');
INSERT INTO `access_log` VALUES (1367, '32.83.15578913585670039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:35:59', 4, 0, '', '2019-05-15 11:35:59');
INSERT INTO `access_log` VALUES (1368, '32.79.15578913587050039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:35:59', 3, 0, '', '2019-05-15 11:35:59');
INSERT INTO `access_log` VALUES (1369, '32.85.15578913670960041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:36:07', 5, 0, '', '2019-05-15 11:36:07');
INSERT INTO `access_log` VALUES (1370, '32.81.15578913672060039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:36:07', 4, 0, '', '2019-05-15 11:36:07');
INSERT INTO `access_log` VALUES (1371, '35.72.15578913682250037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:36:08', 5, 0, '', '2019-05-15 11:36:08');
INSERT INTO `access_log` VALUES (1372, '35.73.15578913682300037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:36:08', 10, 0, '', '2019-05-15 11:36:08');
INSERT INTO `access_log` VALUES (1373, '32.86.15578913718640037', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:36:12', 114, 0, '', '2019-05-15 11:36:12');
INSERT INTO `access_log` VALUES (1374, '36.85.15578913721940007', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=38', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:36:12', 742, 0, '', '2019-05-15 11:36:13');
INSERT INTO `access_log` VALUES (1375, '32.84.15578913791020039', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:36:19', 12, 0, '', '2019-05-15 11:36:19');
INSERT INTO `access_log` VALUES (1376, '36.87.15578913792560005', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=38', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:36:19', 21, 0, '', '2019-05-15 11:36:19');
INSERT INTO `access_log` VALUES (1377, '35.77.15578913794880035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:36:19', 5, 0, '', '2019-05-15 11:36:19');
INSERT INTO `access_log` VALUES (1378, '35.78.15578913794920035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:36:19', 11, 0, '', '2019-05-15 11:36:20');
INSERT INTO `access_log` VALUES (1379, 'cb2e295c-60b8-481e-8964-70f001e875ec', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:36:23', 242, 0, '', '2019-05-15 11:36:24');
INSERT INTO `access_log` VALUES (1380, 'd5d5fbef-4821-4754-8cfb-55e9c0f030ab', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:36:23', 242, 0, '', '2019-05-15 11:36:24');
INSERT INTO `access_log` VALUES (1381, '97e0b055-9fbd-401f-b9f4-76c0bb82638b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:36:23', 242, 0, '', '2019-05-15 11:36:24');
INSERT INTO `access_log` VALUES (1382, '1a6c3924-66fc-45e9-b50e-caf5a8fe8945', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:36:23', 308, 0, '', '2019-05-15 11:36:24');
INSERT INTO `access_log` VALUES (1383, 'f17768de-2f68-4b34-94ed-61cd400cb591', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:36:26', 15, 0, '', '2019-05-15 11:36:26');
INSERT INTO `access_log` VALUES (1384, '48acad73-b129-40f6-ba46-d9efaeeb4769', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:36:26', 19, 0, '', '2019-05-15 11:36:26');
INSERT INTO `access_log` VALUES (1385, 'cfa37594-0e76-43fd-85a6-903c95a407d6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:36:26', 17, 0, '', '2019-05-15 11:36:26');
INSERT INTO `access_log` VALUES (1386, 'ddd382d3-638b-4697-96e7-ee9c79a2724b', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:36:26', 12, 0, '', '2019-05-15 11:36:26');
INSERT INTO `access_log` VALUES (1387, '30.66.15578913872100033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:36:27', 14, 2001001000, '服务端发生异常', '2019-05-15 11:36:27');
INSERT INTO `access_log` VALUES (1388, '30.64.15578913872230035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:36:27', 5, 0, '', '2019-05-15 11:36:27');
INSERT INTO `access_log` VALUES (1389, '30.71.15578913872190031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.50.125.102', '2019-05-15 11:36:27', 25, 2001001000, '服务端发生异常', '2019-05-15 11:36:27');
INSERT INTO `access_log` VALUES (1390, '4706019a-2284-490e-be2f-ef69807cceb5', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:36:51', 9, 0, '', '2019-05-15 11:36:51');
INSERT INTO `access_log` VALUES (1391, '4bb2dc2c-06b1-4945-8f5b-2639e7bad15f', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:36:54', 6, 0, '', '2019-05-15 11:36:54');
INSERT INTO `access_log` VALUES (1392, '5be5b6db-8181-40cd-a983-b3892b962d3e', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:48:58', 243, 0, '', '2019-05-15 11:48:58');
INSERT INTO `access_log` VALUES (1393, 'c74abe72-19cb-4fd6-ab97-dc7348c73a3f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:51:35', 293, 0, '', '2019-05-15 11:51:36');
INSERT INTO `access_log` VALUES (1394, '6dd886e5-b03c-4f9c-89cc-24d02155339e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:51:35', 293, 0, '', '2019-05-15 11:51:36');
INSERT INTO `access_log` VALUES (1395, '4eb2c92b-ea21-4f6a-b375-9b4345905fd2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:51:35', 293, 0, '', '2019-05-15 11:51:36');
INSERT INTO `access_log` VALUES (1396, '89efb6da-1d91-45ed-aac4-c2fcb3ac2aac', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:51:35', 3849, 0, '', '2019-05-15 11:51:39');
INSERT INTO `access_log` VALUES (1397, '91e2a6f4-ad9f-4f9b-907d-ee65c2f94329', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:51:56', 15, 0, '', '2019-05-15 11:51:56');
INSERT INTO `access_log` VALUES (1398, 'c89be6d4-c3ab-4b04-897e-007fe4b4deb7', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:52:01', 6928, 0, '', '2019-05-15 11:52:08');
INSERT INTO `access_log` VALUES (1399, 'e9927722-d7a0-4185-a7bb-c25d12ab858e', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:52:45', 289, 0, '', '2019-05-15 11:52:45');
INSERT INTO `access_log` VALUES (1400, 'a20a791f-29f2-4c8f-b207-36206a916016', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:52:48', 503, 0, '', '2019-05-15 11:52:49');
INSERT INTO `access_log` VALUES (1401, '34d3bc15-7fbe-431b-941e-71b83ead11d7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:52:48', 698, 0, '', '2019-05-15 11:52:49');
INSERT INTO `access_log` VALUES (1402, '075351c7-46c6-47cf-ad9a-dec2e5f8775d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:52:48', 714, 0, '', '2019-05-15 11:52:49');
INSERT INTO `access_log` VALUES (1403, '2c04e7ce-a481-4f9a-9809-fa1791abb754', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:52:48', 715, 0, '', '2019-05-15 11:52:49');
INSERT INTO `access_log` VALUES (1404, 'a620dc1e-3cda-415b-898d-6bb5947fae12', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:52:51', 15, 0, '', '2019-05-15 11:52:51');
INSERT INTO `access_log` VALUES (1405, '871c0c29-b5ad-47a8-b213-cc58508256b5', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:52:53', 14, 0, '', '2019-05-15 11:52:53');
INSERT INTO `access_log` VALUES (1406, '1622c209-a32e-4f23-a3e2-c5cc03c6c517', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 11:52:54', 15, 0, '', '2019-05-15 11:52:54');
INSERT INTO `access_log` VALUES (1407, '526ed2bd-c829-4055-b760-8cbcadd8854a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:00:06', 635, 0, '', '2019-05-15 12:00:07');
INSERT INTO `access_log` VALUES (1408, '7a124df2-756a-41cb-ad82-992d4cd84092', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:00:06', 696, 0, '', '2019-05-15 12:00:07');
INSERT INTO `access_log` VALUES (1409, 'ef6b128f-3a74-4fa1-8921-1833f569a0fe', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:00:06', 1004, 0, '', '2019-05-15 12:00:07');
INSERT INTO `access_log` VALUES (1410, '48293e7c-4436-47d0-bff2-4b8dc310c4ce', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:00:06', 1036, 0, '', '2019-05-15 12:00:07');
INSERT INTO `access_log` VALUES (1411, '20ba6069-ed7e-4782-8909-4af187dfcd9c', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:00:09', 14, 0, '', '2019-05-15 12:00:09');
INSERT INTO `access_log` VALUES (1412, '7709d853-2821-478c-a178-cf85a61ffa11', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:00:29', 12, 0, '', '2019-05-15 12:00:29');
INSERT INTO `access_log` VALUES (1413, '32a7326e-9210-4c09-88e9-4f9a9e1be37c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:00:29', 20, 0, '', '2019-05-15 12:00:29');
INSERT INTO `access_log` VALUES (1414, '5f6d9bd3-21e7-481f-b562-5653a3d2abc9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:00:29', 22, 0, '', '2019-05-15 12:00:29');
INSERT INTO `access_log` VALUES (1415, 'fceacc6c-c660-4f2c-a06e-896e76bbbd7f', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:00:30', 4405, 0, '', '2019-05-15 12:00:34');
INSERT INTO `access_log` VALUES (1416, '5d6d8dba-1df0-4614-a2cf-caa1c725203b', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:00:36', 13776, 0, '', '2019-05-15 12:00:50');
INSERT INTO `access_log` VALUES (1417, 'ff0517cf-2968-42c4-b1a5-38c73f55faa3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:01:50', 282, 0, '', '2019-05-15 12:01:50');
INSERT INTO `access_log` VALUES (1418, '5ccc259a-cf57-4893-acd6-8c096561108a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:01:50', 282, 0, '', '2019-05-15 12:01:50');
INSERT INTO `access_log` VALUES (1419, '8e6bf33d-470d-4416-a135-0fbcc1d9ed28', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:01:50', 282, 0, '', '2019-05-15 12:01:50');
INSERT INTO `access_log` VALUES (1420, '4e615416-f3ba-44ba-9e65-d80bc703c4e4', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:01:50', 330, 0, '', '2019-05-15 12:01:50');
INSERT INTO `access_log` VALUES (1421, '7cabe7b8-542c-4760-9729-c02d31e58596', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:01:52', 18, 0, '', '2019-05-15 12:01:52');
INSERT INTO `access_log` VALUES (1422, '43800831-c580-4abd-b025-a5274360c79b', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:01:54', 14, 0, '', '2019-05-15 12:01:54');
INSERT INTO `access_log` VALUES (1423, '364df577-3c23-4b3f-9087-2ed708099cea', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:01:55', 14, 0, '', '2019-05-15 12:01:55');
INSERT INTO `access_log` VALUES (1424, 'db711b6e-c099-4823-9c1f-6a26a9d3a046', 1, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=4&status=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:02:00', 111, 0, '', '2019-05-15 12:02:00');
INSERT INTO `access_log` VALUES (1425, 'b30005ad-7945-425a-bfa0-6019fceffab2', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:02:00', 18, 0, '', '2019-05-15 12:02:00');
INSERT INTO `access_log` VALUES (1426, 'fe9f2eec-05c9-4226-abbd-d15077fe5652', 1, 2, 'admin-application', '/admin-api/admins/admin/delete', 'id=4', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:02:02', 285, 2001001000, '服务端发生异常', '2019-05-15 12:02:02');
INSERT INTO `access_log` VALUES (1427, '98d5fd4c-e6b3-4eba-aebf-2cfb515a6786', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:02:18', 9, 0, '', '2019-05-15 12:02:18');
INSERT INTO `access_log` VALUES (1428, 'c90aabc5-e976-44c0-835b-6f9c98cc6827', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:02:18', 16, 0, '', '2019-05-15 12:02:18');
INSERT INTO `access_log` VALUES (1429, '21d16c51-8cf0-4d32-9b59-9a0170880312', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:02:18', 20, 0, '', '2019-05-15 12:02:18');
INSERT INTO `access_log` VALUES (1430, 'b1efd6ee-1b06-4f21-9fd9-877d2073930b', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:02:18', 12, 0, '', '2019-05-15 12:02:18');
INSERT INTO `access_log` VALUES (1431, '8fbf0203-80d7-431b-9924-3b21a0fb7db1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:05:52', 257, 0, '', '2019-05-15 12:05:53');
INSERT INTO `access_log` VALUES (1432, 'c749a933-efdc-4382-856c-47c10b3de854', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:05:52', 257, 0, '', '2019-05-15 12:05:53');
INSERT INTO `access_log` VALUES (1433, '8ea61b95-df0c-48e0-98d8-dc5b02391911', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:05:52', 257, 0, '', '2019-05-15 12:05:53');
INSERT INTO `access_log` VALUES (1434, '94d87b34-44b7-41bd-8fb9-d8dad42ed048', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:05:52', 362, 0, '', '2019-05-15 12:05:53');
INSERT INTO `access_log` VALUES (1435, '37263ac7-6e03-4e8e-9046-790c240ae89a', 1, 2, 'admin-application', '/admin-api/admins/admin/delete', 'id=4', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:06:02', 759, 2001001000, '服务端发生异常', '2019-05-15 12:06:02');
INSERT INTO `access_log` VALUES (1436, 'e572fe26-c0de-4557-8d4b-597c2cd1e8d1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:07:03', 274, 0, '', '2019-05-15 12:07:03');
INSERT INTO `access_log` VALUES (1437, '77e10f0f-09aa-4373-95aa-313b7c38aafd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:07:03', 274, 0, '', '2019-05-15 12:07:03');
INSERT INTO `access_log` VALUES (1438, '9af18d3d-0c9b-40ec-a48f-703411d82529', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:07:03', 274, 0, '', '2019-05-15 12:07:03');
INSERT INTO `access_log` VALUES (1439, '3c85b341-c4ba-49d7-8dd2-d30a608f150d', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:07:03', 378, 0, '', '2019-05-15 12:07:03');
INSERT INTO `access_log` VALUES (1440, 'efd172f9-3ac7-4747-9671-67ffe2096767', 1, 2, 'admin-application', '/admin-api/admins/admin/delete', 'id=4', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:07:08', 104, 0, '', '2019-05-15 12:07:08');
INSERT INTO `access_log` VALUES (1441, '8827ed3b-5186-40ed-9d0f-242042c088ae', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:07:08', 28, 0, '', '2019-05-15 12:07:08');
INSERT INTO `access_log` VALUES (1442, 'f7aee282-646b-4c34-a2b1-d8441b10c4d2', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:07:09', 17, 0, '', '2019-05-15 12:07:09');
INSERT INTO `access_log` VALUES (1443, '79fcb82b-899c-4e48-aece-1d3629c9bb6a', 1, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=25&status=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:07:14', 104, 0, '', '2019-05-15 12:07:14');
INSERT INTO `access_log` VALUES (1444, 'bebf531f-ecde-403c-986e-a5c079773c83', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:07:14', 17, 0, '', '2019-05-15 12:07:14');
INSERT INTO `access_log` VALUES (1445, '315b74f0-1f55-4e13-8b1d-bada7f06e022', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:07:18', 29, 0, '', '2019-05-15 12:07:18');
INSERT INTO `access_log` VALUES (1446, '9b83a676-2072-4e84-b2a7-706c0e9e3fcf', 1, 2, 'admin-application', '/admin-api/admins/admin/delete', 'id=25', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:07:20', 146, 0, '', '2019-05-15 12:07:20');
INSERT INTO `access_log` VALUES (1447, '2fc422cd-46b4-458b-a81b-f2b8ee9873f4', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:07:20', 19, 0, '', '2019-05-15 12:07:20');
INSERT INTO `access_log` VALUES (1448, '06a35de9-053b-4c16-96a2-3347ea8d62eb', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:07:49', 14, 0, '', '2019-05-15 12:07:49');
INSERT INTO `access_log` VALUES (1449, '9e7f9508-58a9-4a67-aea2-b620658bcd18', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:08:55', 259, 0, '', '2019-05-15 12:08:56');
INSERT INTO `access_log` VALUES (1450, 'a5bccfa9-d756-4118-8fbd-9e29bfb39e67', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:08:55', 259, 0, '', '2019-05-15 12:08:56');
INSERT INTO `access_log` VALUES (1451, 'abb6dce9-c72f-444f-8e3b-182b20d64122', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:08:55', 259, 0, '', '2019-05-15 12:08:56');
INSERT INTO `access_log` VALUES (1452, '988bb6dc-f67b-4577-b9fd-0091f0462e17', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:08:55', 370, 0, '', '2019-05-15 12:08:56');
INSERT INTO `access_log` VALUES (1453, 'a4e504bf-54ea-4b68-97a3-e467cc8fe983', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:08:59', 18, 0, '', '2019-05-15 12:08:59');
INSERT INTO `access_log` VALUES (1454, '8a5fd9b6-2e3c-477f-bef9-d0a2724b0c59', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=fu', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:09:02', 198, 0, '', '2019-05-15 12:09:03');
INSERT INTO `access_log` VALUES (1455, '896ea66c-7cd7-4dad-8617-a4a508dfef14', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=fu', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:09:05', 12, 0, '', '2019-05-15 12:09:05');
INSERT INTO `access_log` VALUES (1456, '37238091-803a-49d4-93e1-cd1757099c15', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=fu', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:09:05', 13, 0, '', '2019-05-15 12:09:05');
INSERT INTO `access_log` VALUES (1457, 'f3de8e21-f698-49df-acaa-bd175eb6c00c', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=fu', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:10:10', 354, 0, '', '2019-05-15 12:10:11');
INSERT INTO `access_log` VALUES (1458, '9568334d-820d-4991-a833-b71cb6ca428d', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=fu', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:10:17', 20784, 0, '', '2019-05-15 12:10:37');
INSERT INTO `access_log` VALUES (1459, 'af23d12f-5179-455f-bdfc-cbdb9c03cffb', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:10:49', 3207, 0, '', '2019-05-15 12:10:53');
INSERT INTO `access_log` VALUES (1460, '991d1482-7baa-470d-bf6e-d415832c2976', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=管理', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:10:56', 16, 0, '', '2019-05-15 12:10:56');
INSERT INTO `access_log` VALUES (1461, '35.75.15578962055710039', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.76.1.133', '2019-05-15 12:56:46', 14, 0, '', '2019-05-15 12:56:46');
INSERT INTO `access_log` VALUES (1462, '35.74.15578962055720035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.76.1.133', '2019-05-15 12:56:46', 52, 0, '', '2019-05-15 12:56:46');
INSERT INTO `access_log` VALUES (1463, '30.70.15578962090300031', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.76.1.133', '2019-05-15 12:56:49', 6, 0, '', '2019-05-15 12:56:49');
INSERT INTO `access_log` VALUES (1464, '30.73.15578962090330031', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.76.1.133', '2019-05-15 12:56:49', 14, 2001001000, '服务端发生异常', '2019-05-15 12:56:49');
INSERT INTO `access_log` VALUES (1465, '30.67.15578962090280031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.76.1.133', '2019-05-15 12:56:49', 26, 2001001000, '服务端发生异常', '2019-05-15 12:56:49');
INSERT INTO `access_log` VALUES (1466, '32.80.15578962171710041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.76.1.133', '2019-05-15 12:56:57', 24, 0, '', '2019-05-15 12:56:57');
INSERT INTO `access_log` VALUES (1467, '32.87.15578962172990039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.76.1.133', '2019-05-15 12:56:57', 4, 0, '', '2019-05-15 12:56:57');
INSERT INTO `access_log` VALUES (1468, '32.82.15578962288590041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.76.1.133', '2019-05-15 12:57:09', 19, 0, '', '2019-05-15 12:57:09');
INSERT INTO `access_log` VALUES (1469, '32.88.15578962289790041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.76.1.133', '2019-05-15 12:57:09', 3, 0, '', '2019-05-15 12:57:09');
INSERT INTO `access_log` VALUES (1470, '35.79.15579011251650037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '60.191.10.77', '2019-05-15 14:18:45', 17, 0, '', '2019-05-15 14:18:45');
INSERT INTO `access_log` VALUES (1471, '35.71.15579011251650035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '60.191.10.77', '2019-05-15 14:18:45', 118, 0, '', '2019-05-15 14:18:45');
INSERT INTO `access_log` VALUES (1472, '30.65.15579011359970039', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '60.191.10.77', '2019-05-15 14:18:56', 10, 0, '', '2019-05-15 14:18:56');
INSERT INTO `access_log` VALUES (1473, '30.72.15579011359940025', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '60.191.10.77', '2019-05-15 14:18:56', 24, 2001001000, '服务端发生异常', '2019-05-15 14:18:56');
INSERT INTO `access_log` VALUES (1474, '30.69.15579011360040037', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '60.191.10.77', '2019-05-15 14:18:56', 62, 2001001000, '服务端发生异常', '2019-05-15 14:18:56');
INSERT INTO `access_log` VALUES (1475, '30.68.15579018435140033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.34.143.121', '2019-05-15 14:30:44', 31, 2001001000, '服务端发生异常', '2019-05-15 14:30:44');
INSERT INTO `access_log` VALUES (1476, '30.64.15579018435230037', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.34.143.121', '2019-05-15 14:30:44', 30, 2001001000, '服务端发生异常', '2019-05-15 14:30:44');
INSERT INTO `access_log` VALUES (1477, '30.66.15579018435270035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.34.143.121', '2019-05-15 14:30:44', 1119, 0, '', '2019-05-15 14:30:45');
INSERT INTO `access_log` VALUES (1478, '35.80.15579020058780035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.176.97', '2019-05-15 14:33:26', 11, 0, '', '2019-05-15 14:33:26');
INSERT INTO `access_log` VALUES (1479, '35.76.15579020058780037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.176.97', '2019-05-15 14:33:26', 20, 0, '', '2019-05-15 14:33:26');
INSERT INTO `access_log` VALUES (1480, '30.70.15579020094660033', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.176.97', '2019-05-15 14:33:29', 6, 0, '', '2019-05-15 14:33:29');
INSERT INTO `access_log` VALUES (1481, '30.71.15579020094610033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.176.97', '2019-05-15 14:33:29', 14, 2001001000, '服务端发生异常', '2019-05-15 14:33:29');
INSERT INTO `access_log` VALUES (1482, '30.73.15579020094630033', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.176.97', '2019-05-15 14:33:29', 15, 2001001000, '服务端发生异常', '2019-05-15 14:33:29');
INSERT INTO `access_log` VALUES (1483, '32.83.15579020178580041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.176.97', '2019-05-15 14:33:38', 18, 0, '', '2019-05-15 14:33:38');
INSERT INTO `access_log` VALUES (1484, '32.79.15579020179870041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.176.97', '2019-05-15 14:33:38', 4, 0, '', '2019-05-15 14:33:38');
INSERT INTO `access_log` VALUES (1485, '32.85.15579020198100043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.176.97', '2019-05-15 14:33:40', 4, 0, '', '2019-05-15 14:33:40');
INSERT INTO `access_log` VALUES (1486, '32.81.15579020204180041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.176.97', '2019-05-15 14:33:40', 3, 0, '', '2019-05-15 14:33:40');
INSERT INTO `access_log` VALUES (1487, '35.73.15579020217100039', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.176.97', '2019-05-15 14:33:42', 6, 0, '', '2019-05-15 14:33:42');
INSERT INTO `access_log` VALUES (1488, '35.72.15579020217100039', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.176.97', '2019-05-15 14:33:42', 12, 0, '', '2019-05-15 14:33:42');
INSERT INTO `access_log` VALUES (1489, 'd91461b5-181c-4d94-bfd5-4f467e2f576c', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:40:09', 135, 1002001012, '访问令牌已过期', '2019-05-15 14:40:09');
INSERT INTO `access_log` VALUES (1490, 'c52bee50-7f85-4444-892d-e60ea3940420', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:40:09', 135, 1002001012, '访问令牌已过期', '2019-05-15 14:40:09');
INSERT INTO `access_log` VALUES (1491, '14bfc222-102c-4b86-bbd9-702cf4652d2a', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:40:09', 135, 1002001012, '访问令牌已过期', '2019-05-15 14:40:09');
INSERT INTO `access_log` VALUES (1492, '074f3abd-fefd-4882-9c38-5d149ee1082b', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:40:09', 81, 1002001012, '访问令牌已过期', '2019-05-15 14:40:09');
INSERT INTO `access_log` VALUES (1493, '0bb245a4-36db-4ae8-b397-95ddb7b227b9', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:40:11', 151, 0, '', '2019-05-15 14:40:11');
INSERT INTO `access_log` VALUES (1494, '543d9b90-46c8-468b-b222-31dda7d05ac5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:40:11', 75, 0, '', '2019-05-15 14:40:12');
INSERT INTO `access_log` VALUES (1495, '7d138595-6eca-4564-aff4-2cad0f81b4d2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:40:11', 86, 0, '', '2019-05-15 14:40:12');
INSERT INTO `access_log` VALUES (1496, '5922a642-1f72-4194-8ae6-5b785605b4b2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:40:11', 97, 0, '', '2019-05-15 14:40:12');
INSERT INTO `access_log` VALUES (1497, '5770a57f-8269-4e3d-9436-0f69c0558420', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:40:14', 403, 2001001000, '服务端发生异常', '2019-05-15 14:40:15');
INSERT INTO `access_log` VALUES (1498, '35.77.15579024799240037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.176.97', '2019-05-15 14:41:20', 4, 0, '', '2019-05-15 14:41:20');
INSERT INTO `access_log` VALUES (1499, '35.78.15579024799240037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.57.176.97', '2019-05-15 14:41:20', 153, 0, '', '2019-05-15 14:41:20');
INSERT INTO `access_log` VALUES (1500, 'b37dd599-7b05-4419-aa91-e4b6e4243703', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:41:32', 306, 0, '', '2019-05-15 14:41:32');
INSERT INTO `access_log` VALUES (1501, '5512c3a3-2100-4a94-a9ff-2ee2afb844b0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:41:32', 306, 0, '', '2019-05-15 14:41:32');
INSERT INTO `access_log` VALUES (1502, 'de679280-fcc0-4fc6-93fd-8da9f6572363', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:41:32', 306, 0, '', '2019-05-15 14:41:32');
INSERT INTO `access_log` VALUES (1503, '541385ab-91e2-44ea-be1a-b1e7f5cafa6d', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:41:32', 2539, 2001001000, '服务端发生异常', '2019-05-15 14:41:34');
INSERT INTO `access_log` VALUES (1504, '00f0fd6f-89bf-4fb3-8a12-aeb2cf7b83c0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:42:22', 327, 0, '', '2019-05-15 14:42:22');
INSERT INTO `access_log` VALUES (1505, 'e819e7dd-bed5-4bd5-a148-e3fa95683c24', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:42:22', 327, 0, '', '2019-05-15 14:42:22');
INSERT INTO `access_log` VALUES (1506, 'bf6baf5c-dbca-4632-bb57-7d2d72e357e7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:42:22', 327, 0, '', '2019-05-15 14:42:22');
INSERT INTO `access_log` VALUES (1507, '73ebaa97-c3b5-42ad-a18e-f85f3fd56b5a', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:42:22', 534, 0, '', '2019-05-15 14:42:22');
INSERT INTO `access_log` VALUES (1508, 'ca27cdc0-2b5f-4a1d-8036-42e489a6b79f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:42:30', 14, 0, '', '2019-05-15 14:42:30');
INSERT INTO `access_log` VALUES (1509, '8caf09ce-34b2-41dc-8a05-9ba69f9a4a58', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:42:30', 27, 0, '', '2019-05-15 14:42:30');
INSERT INTO `access_log` VALUES (1510, '4b241614-9470-4ca5-924c-5683dda41d77', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:42:30', 25, 0, '', '2019-05-15 14:42:30');
INSERT INTO `access_log` VALUES (1511, '1cd150b8-c0a8-4f1d-adba-3a11def5b6bf', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:42:30', 25, 0, '', '2019-05-15 14:42:30');
INSERT INTO `access_log` VALUES (1512, '7947fa82-dcc5-4a64-a516-769c2c2b25bc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:42:36', 12, 0, '', '2019-05-15 14:42:36');
INSERT INTO `access_log` VALUES (1513, '9c050261-75ef-4a34-8c6d-6fca95422695', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:42:36', 23, 0, '', '2019-05-15 14:42:36');
INSERT INTO `access_log` VALUES (1514, '208ee8cb-fb00-44bb-9e5d-2cb7e63b7aef', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:42:37', 27, 0, '', '2019-05-15 14:42:37');
INSERT INTO `access_log` VALUES (1515, 'b7b0ae92-9cc6-4a13-8880-d64123d5b47a', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:42:37', 46, 0, '', '2019-05-15 14:42:37');
INSERT INTO `access_log` VALUES (1516, '35.75.15579027570690041', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '140.206.46.74', '2019-05-15 14:45:57', 5, 0, '', '2019-05-15 14:45:57');
INSERT INTO `access_log` VALUES (1517, '35.74.15579027570690037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '140.206.46.74', '2019-05-15 14:45:57', 14, 0, '', '2019-05-15 14:45:57');
INSERT INTO `access_log` VALUES (1518, '32.86.15579027611900039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '140.206.46.74', '2019-05-15 14:46:01', 4, 0, '', '2019-05-15 14:46:01');
INSERT INTO `access_log` VALUES (1519, '32.84.15579027612790041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '140.206.46.74', '2019-05-15 14:46:01', 12, 0, '', '2019-05-15 14:46:01');
INSERT INTO `access_log` VALUES (1520, '32.80.15579027674420043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '140.206.46.74', '2019-05-15 14:46:07', 47, 0, '', '2019-05-15 14:46:07');
INSERT INTO `access_log` VALUES (1521, '32.87.15579027675810041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '140.206.46.74', '2019-05-15 14:46:08', 4, 0, '', '2019-05-15 14:46:08');
INSERT INTO `access_log` VALUES (1522, '35.79.15579027682530039', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '140.206.46.74', '2019-05-15 14:46:08', 5, 0, '', '2019-05-15 14:46:08');
INSERT INTO `access_log` VALUES (1523, '35.71.15579027682670037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '140.206.46.74', '2019-05-15 14:46:08', 17, 0, '', '2019-05-15 14:46:08');
INSERT INTO `access_log` VALUES (1524, '35.76.15579028370100039', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '54.186.178.251', '2019-05-15 14:47:17', 5, 0, '', '2019-05-15 14:47:17');
INSERT INTO `access_log` VALUES (1525, '32.82.15579028491720043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '52.91.61.38', '2019-05-15 14:47:29', 688, 0, '', '2019-05-15 14:47:30');
INSERT INTO `access_log` VALUES (1526, '35.80.15579028539280037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '3.91.221.139', '2019-05-15 14:47:34', 11, 0, '', '2019-05-15 14:47:34');
INSERT INTO `access_log` VALUES (1527, '32.88.15579028659960043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '54.190.185.228', '2019-05-15 14:47:46', 3, 0, '', '2019-05-15 14:47:46');
INSERT INTO `access_log` VALUES (1528, '4ffb5fc6-18c8-4e30-84de-0612019e21bd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:47:48', 276, 0, '', '2019-05-15 14:47:49');
INSERT INTO `access_log` VALUES (1529, 'a2ca60a5-cc0a-4c6b-a620-ce06a63c7530', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:47:48', 262, 0, '', '2019-05-15 14:47:49');
INSERT INTO `access_log` VALUES (1530, 'eb4247a5-43df-4cb1-a077-e38a5c4355c5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:47:48', 262, 0, '', '2019-05-15 14:47:49');
INSERT INTO `access_log` VALUES (1531, '3781eda4-a721-4a8a-8b70-4aa080e4cf53', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:47:49', 22079, 0, '', '2019-05-15 14:48:11');
INSERT INTO `access_log` VALUES (1532, 'f4860f05-3497-42a7-8296-756b49289d46', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:48:27', 12, 0, '', '2019-05-15 14:48:27');
INSERT INTO `access_log` VALUES (1533, '258c5103-f1ee-4d04-8c82-c695c410d3a9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:48:27', 23, 0, '', '2019-05-15 14:48:27');
INSERT INTO `access_log` VALUES (1534, '77f0e78e-71f6-4841-96ea-3fcb55f5bc65', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:48:27', 27, 0, '', '2019-05-15 14:48:27');
INSERT INTO `access_log` VALUES (1535, '78b8fd4f-7d76-4dc0-9a4a-620fd950d1fb', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:48:27', 26, 0, '', '2019-05-15 14:48:27');
INSERT INTO `access_log` VALUES (1536, 'ac190f57-fc08-46fe-ad53-5b4bfcce3f4a', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:53:17', 180, 0, '', '2019-05-15 14:53:17');
INSERT INTO `access_log` VALUES (1537, '7462a56e-aab4-4bf1-a898-dd4778cc01df', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:53:46', 66, 0, '', '2019-05-15 14:53:46');
INSERT INTO `access_log` VALUES (1538, '277e9335-d7f4-4def-8c94-f95f9d3a56e4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:53:46', 91, 0, '', '2019-05-15 14:53:46');
INSERT INTO `access_log` VALUES (1539, 'd756475f-8012-4d05-963c-9e2f471bcea3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:53:46', 107, 0, '', '2019-05-15 14:53:46');
INSERT INTO `access_log` VALUES (1540, 'af09a3df-16e1-45f5-95bf-1234ba3a2624', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:53:46', 168, 0, '', '2019-05-15 14:53:46');
INSERT INTO `access_log` VALUES (1541, '584ff4be-54f7-4bf6-b9e1-6cc3b5b7c169', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:54:01', 110, 0, '', '2019-05-15 14:54:01');
INSERT INTO `access_log` VALUES (1542, '880dd042-0ea8-45d0-bf2f-815fe22ecebe', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:54:01', 111, 0, '', '2019-05-15 14:54:01');
INSERT INTO `access_log` VALUES (1543, '86035c4b-8269-4270-8d8a-1af9d861b04f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:54:01', 114, 0, '', '2019-05-15 14:54:01');
INSERT INTO `access_log` VALUES (1544, '92f4fe20-83e2-4d36-a91c-83dfcafbfe9e', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:54:01', 67, 0, '', '2019-05-15 14:54:01');
INSERT INTO `access_log` VALUES (1545, '4e072da7-0cb8-42d7-a517-3b1ba1f1afe9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:54:25', 15, 0, '', '2019-05-15 14:54:25');
INSERT INTO `access_log` VALUES (1546, '467f831a-b9ba-422f-8ec2-5c6d36bcf39a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:54:25', 46, 0, '', '2019-05-15 14:54:25');
INSERT INTO `access_log` VALUES (1547, 'ec82dc6b-917c-4530-a86d-1524a087d80f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:54:25', 44, 0, '', '2019-05-15 14:54:25');
INSERT INTO `access_log` VALUES (1548, 'c240e7cc-5466-4edb-8791-41742388bddb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:54:31', 10, 0, '', '2019-05-15 14:54:31');
INSERT INTO `access_log` VALUES (1549, 'eef8b888-0c40-4f7b-917f-ff643777de16', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:54:31', 17, 0, '', '2019-05-15 14:54:31');
INSERT INTO `access_log` VALUES (1550, '2535d24a-e1b5-47a4-89e8-26877ac6d49e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:54:31', 20, 0, '', '2019-05-15 14:54:31');
INSERT INTO `access_log` VALUES (1551, '1ea6c9b2-5a96-4e53-a761-849fd7b9a8fe', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:54:31', 21, 0, '', '2019-05-15 14:54:31');
INSERT INTO `access_log` VALUES (1552, 'dc13ab9f-3bba-4f5c-81e5-661b253abb1f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:55:25', 13, 0, '', '2019-05-15 14:55:25');
INSERT INTO `access_log` VALUES (1553, '399fff4d-1bfc-4809-8c95-87a2d8d64902', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:55:25', 26, 0, '', '2019-05-15 14:55:25');
INSERT INTO `access_log` VALUES (1554, '534e1571-0862-4401-b4d4-427ed381902d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:55:25', 25, 0, '', '2019-05-15 14:55:25');
INSERT INTO `access_log` VALUES (1555, '1176e4c6-68e5-4c99-b673-610ad977ad76', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:55:25', 31, 0, '', '2019-05-15 14:55:25');
INSERT INTO `access_log` VALUES (1556, '6373948f-6604-426f-b696-be7603284236', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:55:44', 12, 0, '', '2019-05-15 14:55:44');
INSERT INTO `access_log` VALUES (1557, '3db122ff-5072-41a7-b445-af7f4b5038f6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:55:44', 23, 0, '', '2019-05-15 14:55:44');
INSERT INTO `access_log` VALUES (1558, 'eff852f8-20c7-4b15-b47b-c946ce1359b9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:55:44', 21, 0, '', '2019-05-15 14:55:44');
INSERT INTO `access_log` VALUES (1559, '0a82e63d-d5e6-42e4-becd-c4452e039914', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:55:45', 8, 0, '', '2019-05-15 14:55:45');
INSERT INTO `access_log` VALUES (1560, 'e59b04c6-03a5-4f60-83d1-3e3762c4a89c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:55:45', 15, 0, '', '2019-05-15 14:55:45');
INSERT INTO `access_log` VALUES (1561, 'd4bbbbcc-7c87-4868-b044-d00d360604c3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:55:45', 14, 0, '', '2019-05-15 14:55:45');
INSERT INTO `access_log` VALUES (1562, '3b944dda-40b1-48f0-9f68-076b0eb12e58', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:55:45', 17, 0, '', '2019-05-15 14:55:45');
INSERT INTO `access_log` VALUES (1563, 'b6025b46-c668-405a-ad7d-4c747d847b06', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:03', 9, 0, '', '2019-05-15 14:56:03');
INSERT INTO `access_log` VALUES (1564, '40c163b5-3f7a-4edc-bab9-ce3565a0cfab', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:03', 16, 0, '', '2019-05-15 14:56:03');
INSERT INTO `access_log` VALUES (1565, '0c644895-8e13-479a-8b8e-c51f8ebe7c04', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:03', 22, 0, '', '2019-05-15 14:56:03');
INSERT INTO `access_log` VALUES (1566, 'f9422e6b-d26e-4ea1-bd85-5a4d9cfe346f', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:03', 14, 0, '', '2019-05-15 14:56:03');
INSERT INTO `access_log` VALUES (1567, '7771deb4-b06e-4407-a632-6fa6b63637ce', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:12', 11, 0, '', '2019-05-15 14:56:12');
INSERT INTO `access_log` VALUES (1568, 'a18e8793-eb36-4fb2-8d9f-68ea2820d3ae', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=1,6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:14', 25, 1002004001, '分配角色资源时，有资源不存在', '2019-05-15 14:56:14');
INSERT INTO `access_log` VALUES (1569, 'fbc4cc82-8f59-46b2-9657-7019259ddc63', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:19', 9, 0, '', '2019-05-15 14:56:19');
INSERT INTO `access_log` VALUES (1570, '0158c5eb-4acf-4fd2-b5bf-d351c9bb558b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:30', 8, 0, '', '2019-05-15 14:56:30');
INSERT INTO `access_log` VALUES (1571, '6f30d66e-3d2e-46dd-9e15-a380a43b6211', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:30', 15, 0, '', '2019-05-15 14:56:30');
INSERT INTO `access_log` VALUES (1572, 'd74b3096-d71c-418c-a2ba-6122b288e90f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:30', 20, 0, '', '2019-05-15 14:56:30');
INSERT INTO `access_log` VALUES (1573, '49d39ce2-cded-4233-b652-7e723eff6dca', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:30', 18, 0, '', '2019-05-15 14:56:30');
INSERT INTO `access_log` VALUES (1574, '51a64de1-d499-48ea-bab5-716481678127', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:43', 10, 0, '', '2019-05-15 14:56:43');
INSERT INTO `access_log` VALUES (1575, '47b99209-5414-4fb1-9eee-91ae86141f3f', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=1,6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:45', 12, 1002004001, '分配角色资源时，有资源不存在', '2019-05-15 14:56:45');
INSERT INTO `access_log` VALUES (1576, '8c346307-9ce0-4cfc-8010-b2ab2263f717', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:51', 9, 0, '', '2019-05-15 14:56:51');
INSERT INTO `access_log` VALUES (1577, '8ff372d1-12c0-4401-a5bc-97ec6f1a8de1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:51', 15, 0, '', '2019-05-15 14:56:51');
INSERT INTO `access_log` VALUES (1578, '2d0dea2d-d8a9-4cd3-aec8-376067a45e4d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:51', 15, 0, '', '2019-05-15 14:56:51');
INSERT INTO `access_log` VALUES (1579, '37fce99e-3df2-4742-a3e3-d792078f82a0', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:56:51', 15, 0, '', '2019-05-15 14:56:51');
INSERT INTO `access_log` VALUES (1580, '5c5f61ac-4daa-4a75-a2f8-512fd32ee866', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:57:57', 8, 0, '', '2019-05-15 14:57:57');
INSERT INTO `access_log` VALUES (1581, 'c53f17a9-c90e-48ed-b121-098617e3a726', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:57:57', 14, 0, '', '2019-05-15 14:57:57');
INSERT INTO `access_log` VALUES (1582, '500e749e-9e53-4c3a-8d4d-318058f4f47b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:57:57', 11, 0, '', '2019-05-15 14:57:57');
INSERT INTO `access_log` VALUES (1583, '3cef6526-6c8d-4cdd-a0e7-a0a2576dcdef', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:57:57', 15, 0, '', '2019-05-15 14:57:57');
INSERT INTO `access_log` VALUES (1584, '251cd9c8-3d3d-4fd1-a5fa-3539e8d0dd82', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:11', 9, 0, '', '2019-05-15 14:58:11');
INSERT INTO `access_log` VALUES (1585, '03e7d73b-ca1f-42d7-8c6a-ddd46032b6e5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:11', 17, 0, '', '2019-05-15 14:58:11');
INSERT INTO `access_log` VALUES (1586, '79c15b77-30c2-45af-a2f8-5dc2b6bb6c04', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:11', 23, 0, '', '2019-05-15 14:58:11');
INSERT INTO `access_log` VALUES (1587, '24ba46ef-1a82-499a-aa8d-30daac6452ab', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:11', 17, 0, '', '2019-05-15 14:58:12');
INSERT INTO `access_log` VALUES (1588, 'cd579719-649c-4b5a-8d1c-e639948aacd7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:13', 9, 0, '', '2019-05-15 14:58:13');
INSERT INTO `access_log` VALUES (1589, '4777c5a8-e789-4a16-bc79-94bdab4973da', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:13', 21, 0, '', '2019-05-15 14:58:13');
INSERT INTO `access_log` VALUES (1590, '9c63d714-c66e-4c11-a93b-9a90b20ac75c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:13', 28, 0, '', '2019-05-15 14:58:13');
INSERT INTO `access_log` VALUES (1591, '17de1a08-bbfc-44fe-bdc3-a6356914da02', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:13', 21, 0, '', '2019-05-15 14:58:13');
INSERT INTO `access_log` VALUES (1592, '5f89188d-cc1a-4005-b239-5e75b1ed64a1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:14', 8, 0, '', '2019-05-15 14:58:14');
INSERT INTO `access_log` VALUES (1593, 'bd7239e8-2af8-4d5b-b684-366cb2c2ade1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:14', 16, 0, '', '2019-05-15 14:58:14');
INSERT INTO `access_log` VALUES (1594, '23d32b47-7ab0-4101-bc0e-00ef5927608a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:14', 21, 0, '', '2019-05-15 14:58:14');
INSERT INTO `access_log` VALUES (1595, '9c02fdaf-79fb-4659-a1dd-3d3703385562', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:14', 17, 0, '', '2019-05-15 14:58:14');
INSERT INTO `access_log` VALUES (1596, '380534d1-f4d9-41de-a2a7-21de2ef780c4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:45', 9, 0, '', '2019-05-15 14:58:45');
INSERT INTO `access_log` VALUES (1597, 'b2d741da-4e6b-4cc7-b9b1-4778a3dbb443', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:45', 21, 0, '', '2019-05-15 14:58:45');
INSERT INTO `access_log` VALUES (1598, '0fa064ab-e5c5-45dd-b27f-23a7c1e5e1c8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:45', 19, 0, '', '2019-05-15 14:58:45');
INSERT INTO `access_log` VALUES (1599, 'bd400790-dafd-4dda-8025-13c9e1696331', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:45', 22, 0, '', '2019-05-15 14:58:45');
INSERT INTO `access_log` VALUES (1600, '21272c36-b4a4-48cb-92af-a8fa2ab5b2bd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:48', 7, 0, '', '2019-05-15 14:58:48');
INSERT INTO `access_log` VALUES (1601, '38fbc12f-83d6-49f4-a2ba-ad010cfa7f5a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:48', 13, 0, '', '2019-05-15 14:58:48');
INSERT INTO `access_log` VALUES (1602, '8d96768b-f53e-445d-81e4-27c594fe3d82', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:48', 16, 0, '', '2019-05-15 14:58:48');
INSERT INTO `access_log` VALUES (1603, '2594c495-15eb-4a80-b95a-ad53423ea229', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:58:48', 14, 0, '', '2019-05-15 14:58:48');
INSERT INTO `access_log` VALUES (1604, 'b5e7a21e-cdf8-4f77-b03c-729b068db324', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:09', 9, 0, '', '2019-05-15 14:59:09');
INSERT INTO `access_log` VALUES (1605, 'b09602b5-f0f1-42b7-9009-f75a5341a212', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:09', 17, 0, '', '2019-05-15 14:59:09');
INSERT INTO `access_log` VALUES (1606, 'a4c1df50-d14c-4e9d-9fbf-09f288c56d1a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:09', 24, 0, '', '2019-05-15 14:59:09');
INSERT INTO `access_log` VALUES (1607, '92e24aa3-a27d-470b-a148-9ab28a5ef50b', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:09', 28, 0, '', '2019-05-15 14:59:09');
INSERT INTO `access_log` VALUES (1608, '73c5ee27-30e7-4bfe-b65c-b253e4fa9722', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:13', 11, 0, '', '2019-05-15 14:59:13');
INSERT INTO `access_log` VALUES (1609, '2997df2e-eede-4bc3-93eb-79fe789f7fd9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:13', 23, 0, '', '2019-05-15 14:59:13');
INSERT INTO `access_log` VALUES (1610, 'b2da5bd0-2ac3-41c7-81d3-7994416514a9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:13', 13, 0, '', '2019-05-15 14:59:13');
INSERT INTO `access_log` VALUES (1611, 'fa430beb-4e62-4392-9346-43817f96e316', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:13', 19, 0, '', '2019-05-15 14:59:13');
INSERT INTO `access_log` VALUES (1612, '30b183b7-0539-4619-8b35-09714341f8cb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:37', 61, 0, '', '2019-05-15 14:59:37');
INSERT INTO `access_log` VALUES (1613, '8195e22e-7f28-4acf-b339-4a37bf0701bf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:37', 54, 0, '', '2019-05-15 14:59:37');
INSERT INTO `access_log` VALUES (1614, '7fc9ef18-5013-49a3-8d4e-644f2f24efcf', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:37', 61, 0, '', '2019-05-15 14:59:37');
INSERT INTO `access_log` VALUES (1615, '4bd06eec-f917-47d9-814c-b3b38c239112', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:38', 21, 0, '', '2019-05-15 14:59:38');
INSERT INTO `access_log` VALUES (1616, '98897d11-d4d2-4321-8bb3-c4cd2b3572c2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:45', 12, 0, '', '2019-05-15 14:59:45');
INSERT INTO `access_log` VALUES (1617, 'f2b6fe08-2aed-4bac-8cbc-2663034cbf7e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:45', 29, 0, '', '2019-05-15 14:59:45');
INSERT INTO `access_log` VALUES (1618, '0c134030-d9c6-4151-83ff-d668e525ebfa', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:45', 34, 0, '', '2019-05-15 14:59:45');
INSERT INTO `access_log` VALUES (1619, 'a310ca3f-baa5-4f56-a44b-b55fe1f724a4', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:46', 28, 0, '', '2019-05-15 14:59:46');
INSERT INTO `access_log` VALUES (1620, '1bd5d60b-7d37-49b9-ba0c-facbd9a64549', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:49', 7, 0, '', '2019-05-15 14:59:49');
INSERT INTO `access_log` VALUES (1621, 'd5c7d1bd-1889-412f-8fe6-cf54ea5237ae', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:49', 13, 0, '', '2019-05-15 14:59:49');
INSERT INTO `access_log` VALUES (1622, '390ecd1f-fe25-4fa6-91fc-4bf5e1e54ef8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:49', 18, 0, '', '2019-05-15 14:59:49');
INSERT INTO `access_log` VALUES (1623, '287b9483-f589-4fcf-b42e-3d18fbcfeeb2', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:59:49', 14, 0, '', '2019-05-15 14:59:49');
INSERT INTO `access_log` VALUES (1624, 'cd44f233-9bf6-45f6-a453-06cd4f4aaf3a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:00:03', 8, 0, '', '2019-05-15 15:00:03');
INSERT INTO `access_log` VALUES (1625, '8f5c9f57-bd7a-4508-acf1-6980a4efa702', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:00:03', 16, 0, '', '2019-05-15 15:00:03');
INSERT INTO `access_log` VALUES (1626, '0986cb71-b216-4157-bd56-7d36bd860b87', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:00:03', 20, 0, '', '2019-05-15 15:00:03');
INSERT INTO `access_log` VALUES (1627, 'b610e670-c4f6-476a-91c1-1da335f402a8', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:00:03', 15, 0, '', '2019-05-15 15:00:03');
INSERT INTO `access_log` VALUES (1628, 'e3c64dee-3e33-43d4-b95e-9e65a5167806', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:00:04', 8, 0, '', '2019-05-15 15:00:04');
INSERT INTO `access_log` VALUES (1629, '09702429-b1f2-452f-8560-b9ee99be5d80', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:00:04', 14, 0, '', '2019-05-15 15:00:04');
INSERT INTO `access_log` VALUES (1630, '8e96da0b-437d-427e-ad0c-adabae910032', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:00:04', 17, 0, '', '2019-05-15 15:00:04');
INSERT INTO `access_log` VALUES (1631, '7b93daf8-7bc3-4f5e-9e3e-c692aed1454b', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:00:04', 14, 0, '', '2019-05-15 15:00:04');
INSERT INTO `access_log` VALUES (1632, '8de3a369-7c51-435a-9bf5-57bf7e514899', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:10', 14, 0, '', '2019-05-15 15:01:10');
INSERT INTO `access_log` VALUES (1633, 'f75fb6ba-a1f4-4f3a-bfa6-641ba30c454a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:10', 23, 0, '', '2019-05-15 15:01:10');
INSERT INTO `access_log` VALUES (1634, '0fe83706-51cd-4645-b096-1cfbffd3574c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:10', 22, 0, '', '2019-05-15 15:01:10');
INSERT INTO `access_log` VALUES (1635, 'ed631ad4-90db-4340-9440-ab87159a3832', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:11', 20, 0, '', '2019-05-15 15:01:11');
INSERT INTO `access_log` VALUES (1636, '7b5272c6-9f9f-4b3c-b889-172b7227ed85', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:17', 9, 0, '', '2019-05-15 15:01:17');
INSERT INTO `access_log` VALUES (1637, '15a738af-e92c-48f9-a498-43568a309721', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:17', 19, 0, '', '2019-05-15 15:01:17');
INSERT INTO `access_log` VALUES (1638, '4128d77b-3c11-49f5-a663-a43efb7d1647', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:17', 17, 0, '', '2019-05-15 15:01:17');
INSERT INTO `access_log` VALUES (1639, '58cf9446-3075-4e32-8363-74f62459e8c4', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:18', 18, 0, '', '2019-05-15 15:01:18');
INSERT INTO `access_log` VALUES (1640, 'f0bf0468-7901-4237-8ff9-7c02a36eaa0d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:27', 7, 0, '', '2019-05-15 15:01:27');
INSERT INTO `access_log` VALUES (1641, 'e4f7794a-c361-4a23-b202-36ff6f32f415', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:27', 12, 0, '', '2019-05-15 15:01:27');
INSERT INTO `access_log` VALUES (1642, '3e5b170b-fa7c-417e-a07d-acf27ca2d2d7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:27', 15, 0, '', '2019-05-15 15:01:27');
INSERT INTO `access_log` VALUES (1643, '937f7a58-953a-44e7-9aee-8e443a54424d', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:28', 14, 0, '', '2019-05-15 15:01:28');
INSERT INTO `access_log` VALUES (1644, '2d8b2ef5-fd10-49b4-96f0-43f2ea49db8a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:43', 10, 0, '', '2019-05-15 15:01:43');
INSERT INTO `access_log` VALUES (1645, 'e96d6621-6239-4c8e-ade8-3f1e6277b8ce', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:43', 19, 0, '', '2019-05-15 15:01:43');
INSERT INTO `access_log` VALUES (1646, 'db154a18-86b5-46b9-9d66-8870b50f82a3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:43', 18, 0, '', '2019-05-15 15:01:43');
INSERT INTO `access_log` VALUES (1647, '8fd98688-f2df-4162-a940-017a5e7b7b9e', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:43', 17, 0, '', '2019-05-15 15:01:43');
INSERT INTO `access_log` VALUES (1648, '347d0497-a237-4107-904c-533ba659522e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:45', 7, 0, '', '2019-05-15 15:01:45');
INSERT INTO `access_log` VALUES (1649, 'c8760638-17b6-46a2-bb7c-87dedb487117', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:45', 14, 0, '', '2019-05-15 15:01:45');
INSERT INTO `access_log` VALUES (1650, '4de672ef-ebe9-463b-ac05-d610ba712b76', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:45', 19, 0, '', '2019-05-15 15:01:45');
INSERT INTO `access_log` VALUES (1651, '688484ea-7731-4865-83bb-70c74cf4bf5e', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:45', 14, 0, '', '2019-05-15 15:01:45');
INSERT INTO `access_log` VALUES (1652, 'bf88c3f2-da9d-4a29-aa56-39d3495ea246', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:55', 15, 0, '', '2019-05-15 15:01:55');
INSERT INTO `access_log` VALUES (1653, '023b01ba-c99c-4151-9a29-71a2fcb16d38', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:01:58', 9, 0, '', '2019-05-15 15:01:58');
INSERT INTO `access_log` VALUES (1654, 'e86c03f5-8529-4736-909b-91a841a2ccc4', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:02:04', 4413, 2001001001, '参数缺失:Required Set parameter \'roleIds\' is not present', '2019-05-15 15:02:08');
INSERT INTO `access_log` VALUES (1655, '35.73.15579037283050041', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-05-15 15:02:08', 5, 0, '', '2019-05-15 15:02:08');
INSERT INTO `access_log` VALUES (1656, '35.72.15579037283050041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-05-15 15:02:08', 12, 0, '', '2019-05-15 15:02:08');
INSERT INTO `access_log` VALUES (1657, '32.83.15579037356240043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-05-15 15:02:16', 4, 0, '', '2019-05-15 15:02:16');
INSERT INTO `access_log` VALUES (1658, '32.79.15579037357570043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-05-15 15:02:16', 3, 0, '', '2019-05-15 15:02:16');
INSERT INTO `access_log` VALUES (1659, '7bfc050a-4587-44e9-8598-e84e5afbe128', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:02:21', 12, 0, '', '2019-05-15 15:02:21');
INSERT INTO `access_log` VALUES (1660, '499c67ec-1062-4715-a99b-666a55976c22', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=6&roleIds=6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:02:24', 12, 1002004001, '分配角色资源时，有资源不存在', '2019-05-15 15:02:24');
INSERT INTO `access_log` VALUES (1661, '30.65.15579037505230041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-05-15 15:02:31', 5, 0, '', '2019-05-15 15:02:31');
INSERT INTO `access_log` VALUES (1662, '30.72.15579037505210027', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-05-15 15:02:31', 18, 2001001000, '服务端发生异常', '2019-05-15 15:02:31');
INSERT INTO `access_log` VALUES (1663, '30.67.15579037505200033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-05-15 15:02:31', 31, 2001001000, '服务端发生异常', '2019-05-15 15:02:31');
INSERT INTO `access_log` VALUES (1664, 'fccd0e77-608d-4b80-b5bf-ed8ab8ff57ee', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:03:34', 10, 0, '', '2019-05-15 15:03:34');
INSERT INTO `access_log` VALUES (1665, 'd16f9f64-3887-49ac-8f02-00e42cfcd2d2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:03:34', 14, 0, '', '2019-05-15 15:03:34');
INSERT INTO `access_log` VALUES (1666, '72e689aa-8885-475e-8a08-ab468d643db7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:03:34', 19, 0, '', '2019-05-15 15:03:34');
INSERT INTO `access_log` VALUES (1667, 'c0b83800-5770-40f7-998b-351068c77c23', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:03:34', 14, 0, '', '2019-05-15 15:03:34');
INSERT INTO `access_log` VALUES (1668, 'e8333aee-0cd3-4dae-8e5d-0261b1650e26', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:03:36', 9, 0, '', '2019-05-15 15:03:36');
INSERT INTO `access_log` VALUES (1669, '104841cd-343f-4acb-afcf-43c8d166a2c4', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=1,6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:03:37', 34710, 1002004001, '分配角色资源时，有资源不存在', '2019-05-15 15:04:12');
INSERT INTO `access_log` VALUES (1670, '12377d9a-1b66-41f4-ac49-58d73bc50709', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:04:16', 9, 0, '', '2019-05-15 15:04:16');
INSERT INTO `access_log` VALUES (1671, '33361001-53c2-4f41-add8-a74f47dfd275', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=1,6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:04:17', 7869, 1002004001, '分配角色资源时，有资源不存在', '2019-05-15 15:04:25');
INSERT INTO `access_log` VALUES (1672, '5e77b51a-4c4d-4185-bcf4-2619f06a3f80', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:05:26', 10, 0, '', '2019-05-15 15:05:26');
INSERT INTO `access_log` VALUES (1673, '526ef5d9-9155-4185-9a9c-3a3419dee872', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=1,6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:05:27', 28681, 1002004001, '分配角色资源时，有资源不存在', '2019-05-15 15:05:56');
INSERT INTO `access_log` VALUES (1674, 'ad7394dd-8c98-4a26-8df3-50e6b376a0a2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:08:51', 7, 0, '', '2019-05-15 15:08:51');
INSERT INTO `access_log` VALUES (1675, 'bdb66c09-9373-468f-82d6-9f1b47bd269f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:08:51', 14, 0, '', '2019-05-15 15:08:51');
INSERT INTO `access_log` VALUES (1676, '385ed8a4-3b52-4098-a11a-87613e1b27cd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:08:51', 17, 0, '', '2019-05-15 15:08:51');
INSERT INTO `access_log` VALUES (1677, 'c78847f2-f138-4d6c-9468-affe794da1cc', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:08:51', 22859, 0, '', '2019-05-15 15:09:14');
INSERT INTO `access_log` VALUES (1678, '66ddfb6d-0029-43f5-8034-828250acab6b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:10:24', 9, 0, '', '2019-05-15 15:10:24');
INSERT INTO `access_log` VALUES (1679, '413f17c9-9f0b-4d45-9aa7-a17943dc2b24', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:10:24', 13, 0, '', '2019-05-15 15:10:24');
INSERT INTO `access_log` VALUES (1680, '79b851ee-d89a-4a1b-86d4-04979dc6ce54', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:10:24', 13, 0, '', '2019-05-15 15:10:24');
INSERT INTO `access_log` VALUES (1681, '2691bd7e-9e83-4585-a607-3f0eca04b32e', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:10:24', 6463, 0, '', '2019-05-15 15:10:30');
INSERT INTO `access_log` VALUES (1682, '30.66.15579042479420037', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-15 15:10:48', 6, 1002001012, '访问令牌已过期', '2019-05-15 15:10:48');
INSERT INTO `access_log` VALUES (1683, '30.69.15579042479420039', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-15 15:10:48', 7, 1002001012, '访问令牌已过期', '2019-05-15 15:10:48');
INSERT INTO `access_log` VALUES (1684, '30.68.15579042479480035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-15 15:10:48', 4, 1002001012, '访问令牌已过期', '2019-05-15 15:10:48');
INSERT INTO `access_log` VALUES (1685, '30.64.15579042494110039', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-15 15:10:49', 5, 1002001012, '访问令牌已过期', '2019-05-15 15:10:49');
INSERT INTO `access_log` VALUES (1686, '30.73.15579042509040035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-15 15:10:51', 4, 1002001012, '访问令牌已过期', '2019-05-15 15:10:51');
INSERT INTO `access_log` VALUES (1687, '30.71.15579042517940035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-15 15:10:52', 4, 1002001012, '访问令牌已过期', '2019-05-15 15:10:52');
INSERT INTO `access_log` VALUES (1688, '30.70.15579042528590035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-15 15:10:53', 3, 1002001012, '访问令牌已过期', '2019-05-15 15:10:53');
INSERT INTO `access_log` VALUES (1689, '30.65.15579042536840043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-15 15:10:54', 3, 1002001012, '访问令牌已过期', '2019-05-15 15:10:54');
INSERT INTO `access_log` VALUES (1690, '3b6397f5-d2bb-414f-9c2a-82e37dc5f8ed', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:11:08', 8, 0, '', '2019-05-15 15:11:08');
INSERT INTO `access_log` VALUES (1691, '969ad504-cb3d-484d-88df-4c96f49ab581', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:11:08', 15, 0, '', '2019-05-15 15:11:08');
INSERT INTO `access_log` VALUES (1692, 'd310b4ae-2f27-4b0c-af56-c92ffdc3d00a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:11:08', 13, 0, '', '2019-05-15 15:11:08');
INSERT INTO `access_log` VALUES (1693, '729eedb0-acb3-48c0-9396-813b7eae8fd9', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:11:09', 33082, 0, '', '2019-05-15 15:11:42');
INSERT INTO `access_log` VALUES (1694, '6d657407-a192-4759-96b2-5b2aa0e4d47a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:13:45', 29, 0, '', '2019-05-15 15:13:45');
INSERT INTO `access_log` VALUES (1695, 'eba619bd-ed30-4ce8-8261-1510b361b407', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:13:45', 24, 0, '', '2019-05-15 15:13:45');
INSERT INTO `access_log` VALUES (1696, 'a102dc5a-ef52-4f3d-93f4-8b601511bda0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:13:45', 34, 0, '', '2019-05-15 15:13:45');
INSERT INTO `access_log` VALUES (1697, '133cf1f6-96d7-4a45-bf9c-5d5474a3fc21', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:13:45', 72257, 0, '', '2019-05-15 15:14:58');
INSERT INTO `access_log` VALUES (1698, 'e6ea07dd-6664-4e16-8191-f63a23955a0a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:14:58', 17, 0, '', '2019-05-15 15:14:58');
INSERT INTO `access_log` VALUES (1699, '44adf233-76d8-4670-8ff0-d7b341e9438a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:14:58', 18, 0, '', '2019-05-15 15:14:58');
INSERT INTO `access_log` VALUES (1700, 'f5286b31-a4c7-47be-8a3f-31e64a6e2b0e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:14:58', 30, 0, '', '2019-05-15 15:14:58');
INSERT INTO `access_log` VALUES (1701, 'e8ac68ba-b08d-47c2-a412-ee234ff8060e', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:14:58', 3114, 0, '', '2019-05-15 15:15:01');
INSERT INTO `access_log` VALUES (1702, 'd440bbb7-7998-4fc6-916d-518fa7fb00bd', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:15:04', 10, 0, '', '2019-05-15 15:15:04');
INSERT INTO `access_log` VALUES (1703, '714131aa-b345-4f00-b837-12991f5d357b', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=1,6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:15:06', 13448, 1002004001, '分配角色资源时，有资源不存在', '2019-05-15 15:15:19');
INSERT INTO `access_log` VALUES (1704, '9d5a3cd2-49c3-4fbc-b6ea-cbade5184bd6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:16:08', 7, 0, '', '2019-05-15 15:16:08');
INSERT INTO `access_log` VALUES (1705, 'c992307b-6d22-40ac-b87d-d77fa8a7f3c6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:16:08', 13, 0, '', '2019-05-15 15:16:08');
INSERT INTO `access_log` VALUES (1706, 'e1a1ff40-d3f0-4803-8da2-81f8e067986a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:16:08', 16, 0, '', '2019-05-15 15:16:08');
INSERT INTO `access_log` VALUES (1707, '3a637684-6ce4-447f-a78f-01538f02470a', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:16:08', 14, 0, '', '2019-05-15 15:16:08');
INSERT INTO `access_log` VALUES (1708, '1bfc5d80-344e-41af-9170-9645816ecad9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:16:39', 292, 0, '', '2019-05-15 15:16:39');
INSERT INTO `access_log` VALUES (1709, '80c5a5ae-f965-4b0d-aa30-2ea06ade9fa2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:16:39', 292, 0, '', '2019-05-15 15:16:39');
INSERT INTO `access_log` VALUES (1710, '8b2e64a8-2974-4b38-a0a4-fea191bbc2ca', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:16:39', 292, 0, '', '2019-05-15 15:16:39');
INSERT INTO `access_log` VALUES (1711, 'a45ad743-ccbd-4693-b008-f207ea522869', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:16:39', 493, 0, '', '2019-05-15 15:16:40');
INSERT INTO `access_log` VALUES (1712, 'afa4d731-4a4f-4d43-838a-3e071a886eb7', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:16:49', 42, 0, '', '2019-05-15 15:16:49');
INSERT INTO `access_log` VALUES (1713, '0a8fe44f-f48b-4346-8bb7-78b05e236848', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=1,6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:16:50', 4468, 1002002006, '分配员工角色时，有角色不存在', '2019-05-15 15:16:55');
INSERT INTO `access_log` VALUES (1714, '4a5482f6-de78-43f3-aa8a-31fe53fd1689', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:18:15', 298, 0, '', '2019-05-15 15:18:15');
INSERT INTO `access_log` VALUES (1715, 'a16f1452-9f86-4957-a8a3-131077727eab', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:18:15', 298, 0, '', '2019-05-15 15:18:15');
INSERT INTO `access_log` VALUES (1716, 'ba136374-9f3d-4e67-abd8-3516ded8d534', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:18:15', 298, 0, '', '2019-05-15 15:18:15');
INSERT INTO `access_log` VALUES (1717, '74fd08ca-b33f-41f6-b656-7f4f27545668', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:18:15', 915, 0, '', '2019-05-15 15:18:15');
INSERT INTO `access_log` VALUES (1718, '3a14db3e-b59f-4fb7-b16d-9033540b0ece', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:19:19', 18, 0, '', '2019-05-15 15:19:19');
INSERT INTO `access_log` VALUES (1719, 'f292b7d5-c74c-42b7-b64c-075307e9033b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:19:19', 23, 0, '', '2019-05-15 15:19:19');
INSERT INTO `access_log` VALUES (1720, '721a8283-12a3-4caa-8273-66eef2ce415a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:19:19', 26, 0, '', '2019-05-15 15:19:19');
INSERT INTO `access_log` VALUES (1721, '54f84a66-c5e3-40be-a89c-9ba4e405e04b', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:19:19', 10547, 0, '', '2019-05-15 15:19:30');
INSERT INTO `access_log` VALUES (1722, '5a5f9f47-2700-4052-918d-80a46e954a23', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:19:35', 40, 0, '', '2019-05-15 15:19:35');
INSERT INTO `access_log` VALUES (1723, '3fb2768e-8f59-44fc-9563-43d9d430e731', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=1,6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:19:37', 59358, 1002002006, '分配员工角色时，有角色不存在', '2019-05-15 15:20:36');
INSERT INTO `access_log` VALUES (1724, '825aeadf-4806-4417-90df-b7aab0db4e4f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:24:51', 288, 0, '', '2019-05-15 15:24:51');
INSERT INTO `access_log` VALUES (1725, '4cc2779d-bc2a-4ed4-9392-2af7f55b3e25', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:24:51', 288, 0, '', '2019-05-15 15:24:51');
INSERT INTO `access_log` VALUES (1726, '209b5e8a-d525-4dde-98f2-437b8fab2e94', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:24:51', 288, 0, '', '2019-05-15 15:24:51');
INSERT INTO `access_log` VALUES (1727, '7819ac4b-ab96-48df-9a18-1b04f0f4d11a', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:24:51', 8937, 2001001000, '服务端发生异常', '2019-05-15 15:25:00');
INSERT INTO `access_log` VALUES (1728, 'a6d0b9f1-d963-41e1-8ddb-5537fdf5778b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:25:55', 12, 0, '', '2019-05-15 15:25:55');
INSERT INTO `access_log` VALUES (1729, 'ba786d74-455c-4e89-afff-58e5d57c7f6d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:25:55', 23, 0, '', '2019-05-15 15:25:55');
INSERT INTO `access_log` VALUES (1730, 'b3c6c462-d1ba-4a77-be6c-0ba493ba2c5e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:25:55', 25, 0, '', '2019-05-15 15:25:55');
INSERT INTO `access_log` VALUES (1731, 'db730661-88fe-4afe-a4e4-530da4b3a8b8', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:25:55', 368, 0, '', '2019-05-15 15:25:55');
INSERT INTO `access_log` VALUES (1732, '44b129dc-abe7-427f-a855-f42d58aa6f51', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:26:01', 10, 0, '', '2019-05-15 15:26:01');
INSERT INTO `access_log` VALUES (1733, 'aca6c791-1ac8-46ae-84d1-ed7cef87f941', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:26:01', 20, 0, '', '2019-05-15 15:26:01');
INSERT INTO `access_log` VALUES (1734, '74a9dcf0-8816-422f-85d5-03484bb4d974', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:26:01', 26, 0, '', '2019-05-15 15:26:01');
INSERT INTO `access_log` VALUES (1735, '7dc427d3-1fe3-4a3c-bd90-802fa8da83c6', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:26:01', 23, 0, '', '2019-05-15 15:26:01');
INSERT INTO `access_log` VALUES (1736, '6aef8881-d6b8-46f5-a18d-24a1617ea422', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:27:52', 276, 0, '', '2019-05-15 15:27:52');
INSERT INTO `access_log` VALUES (1737, '6bfd1382-6a4b-4bad-98cd-768d28bf1236', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:27:52', 276, 0, '', '2019-05-15 15:27:52');
INSERT INTO `access_log` VALUES (1738, 'e6fad79d-00b1-437f-9c5b-87fd59c04361', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:27:52', 276, 0, '', '2019-05-15 15:27:52');
INSERT INTO `access_log` VALUES (1739, '01d28f29-0b41-4587-be11-30a0dcadc2ef', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:27:53', 13, 0, '', '2019-05-15 15:27:53');
INSERT INTO `access_log` VALUES (1740, '7a69a956-4351-4dcc-8ae4-aa8e3e6110b7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:27:53', 35, 0, '', '2019-05-15 15:27:53');
INSERT INTO `access_log` VALUES (1741, 'b73d531b-b643-4fed-bea8-7ebc2e9f90ad', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:27:53', 36, 0, '', '2019-05-15 15:27:53');
INSERT INTO `access_log` VALUES (1742, '9875db0a-5977-4650-9c54-57d851b59e73', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:27:55', 19, 0, '', '2019-05-15 15:27:55');
INSERT INTO `access_log` VALUES (1743, '76125b3b-c46c-4ef5-a733-62cc444865b7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:27:55', 30, 0, '', '2019-05-15 15:27:55');
INSERT INTO `access_log` VALUES (1744, '7b5dee50-eb99-423e-ab1c-621655cd06ab', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:27:55', 33, 0, '', '2019-05-15 15:27:55');
INSERT INTO `access_log` VALUES (1745, '127e5226-4852-4567-9bfc-1ed3bc2d8ff2', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:27:58', 174, 0, '', '2019-05-15 15:27:59');
INSERT INTO `access_log` VALUES (1746, 'dc11c4e3-7d39-416a-a188-0a12377bd1c6', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:29:03', 13, 1002001012, '访问令牌已过期', '2019-05-15 15:29:03');
INSERT INTO `access_log` VALUES (1747, '6ae99805-0563-4804-b5c3-58ee94df039e', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:29:03', 7, 1002001012, '访问令牌已过期', '2019-05-15 15:29:03');
INSERT INTO `access_log` VALUES (1748, 'eb992684-4f36-467c-8dbc-6077c1096a2f', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:29:03', 10, 1002001012, '访问令牌已过期', '2019-05-15 15:29:03');
INSERT INTO `access_log` VALUES (1749, 'b0bc7f0d-bcae-49c0-8474-3a54394ea5f2', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:29:03', 12, 1002001012, '访问令牌已过期', '2019-05-15 15:29:03');
INSERT INTO `access_log` VALUES (1750, '2d6cd5a9-3269-4dff-a706-93c62d67fd9c', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:29:05', 130, 0, '', '2019-05-15 15:29:05');
INSERT INTO `access_log` VALUES (1751, '4bba3b99-0aea-4c51-bff0-544ee5e2f86f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:29:05', 14, 0, '', '2019-05-15 15:29:05');
INSERT INTO `access_log` VALUES (1752, '94fbba47-1c36-424f-9fbc-8a094b6c69ea', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:29:05', 24, 0, '', '2019-05-15 15:29:05');
INSERT INTO `access_log` VALUES (1753, 'ed5ef3d7-b840-42b9-bed8-147660740a76', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:29:05', 22, 0, '', '2019-05-15 15:29:05');
INSERT INTO `access_log` VALUES (1754, 'e9a0a583-66a6-46ba-80d1-ccc8d71e1469', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:29:07', 34, 0, '', '2019-05-15 15:29:07');
INSERT INTO `access_log` VALUES (1755, 'b2539470-d085-4856-b0c6-99f6b2813bd2', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:29:11', 39, 0, '', '2019-05-15 15:29:11');
INSERT INTO `access_log` VALUES (1756, 'e85e24d2-1152-4eee-94a6-076ca2d860c8', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=1,2,6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:29:15', 73, 0, '', '2019-05-15 15:29:15');
INSERT INTO `access_log` VALUES (1757, '1ecf111f-3c32-4a19-a624-c059ed34495b', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:29:17', 16, 0, '', '2019-05-15 15:29:17');
INSERT INTO `access_log` VALUES (1758, '35.77.15579056734090039', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.204.103.18', '2019-05-15 15:34:33', 14, 0, '', '2019-05-15 15:34:33');
INSERT INTO `access_log` VALUES (1759, '35.78.15579056734200039', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.204.103.18', '2019-05-15 15:34:33', 28, 0, '', '2019-05-15 15:34:33');
INSERT INTO `access_log` VALUES (1760, '33.83.15579056863140001', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=mysql&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.204.103.18', '2019-05-15 15:34:46', 2, -1, '未授权', '2019-05-15 15:34:46');
INSERT INTO `access_log` VALUES (1761, '35.75.15579057012600043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.204.103.18', '2019-05-15 15:35:01', 6, 0, '', '2019-05-15 15:35:01');
INSERT INTO `access_log` VALUES (1762, '35.74.15579057012600039', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.204.103.18', '2019-05-15 15:35:01', 42, 0, '', '2019-05-15 15:35:01');
INSERT INTO `access_log` VALUES (1763, '30.68.15579057284710037', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.204.103.18', '2019-05-15 15:35:28', 5, 0, '', '2019-05-15 15:35:28');
INSERT INTO `access_log` VALUES (1764, '30.67.15579057284610035', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.204.103.18', '2019-05-15 15:35:28', 15, 2001001000, '服务端发生异常', '2019-05-15 15:35:28');
INSERT INTO `access_log` VALUES (1765, '30.72.15579057284610029', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.204.103.18', '2019-05-15 15:35:28', 17, 2001001000, '服务端发生异常', '2019-05-15 15:35:28');
INSERT INTO `access_log` VALUES (1766, '35.79.15579059627190041', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.91.52.198', '2019-05-15 15:39:23', 6, 0, '', '2019-05-15 15:39:23');
INSERT INTO `access_log` VALUES (1767, '35.71.15579059627210039', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.91.52.198', '2019-05-15 15:39:23', 15, 0, '', '2019-05-15 15:39:23');
INSERT INTO `access_log` VALUES (1768, '32.85.15579059830090045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.91.52.198', '2019-05-15 15:39:43', 5, 0, '', '2019-05-15 15:39:43');
INSERT INTO `access_log` VALUES (1769, '32.81.15579059831630043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.91.52.198', '2019-05-15 15:39:43', 21, 0, '', '2019-05-15 15:39:43');
INSERT INTO `access_log` VALUES (1770, '32.86.15579059906370041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.91.52.198', '2019-05-15 15:39:51', 4, 0, '', '2019-05-15 15:39:51');
INSERT INTO `access_log` VALUES (1771, '32.84.15579059907670043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.91.52.198', '2019-05-15 15:39:51', 3, 0, '', '2019-05-15 15:39:51');
INSERT INTO `access_log` VALUES (1772, '35.80.15579059959490039', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.91.52.198', '2019-05-15 15:39:56', 4, 0, '', '2019-05-15 15:39:56');
INSERT INTO `access_log` VALUES (1773, '35.76.15579059959490041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.91.52.198', '2019-05-15 15:39:56', 35, 0, '', '2019-05-15 15:39:56');
INSERT INTO `access_log` VALUES (1774, '32.80.15579060029670045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.91.52.198', '2019-05-15 15:40:03', 4, 0, '', '2019-05-15 15:40:03');
INSERT INTO `access_log` VALUES (1775, '32.80.15579060029670045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.91.52.198', '2019-05-15 15:40:03', 4, 0, '', '2019-05-15 15:40:04');
INSERT INTO `access_log` VALUES (1776, '32.87.15579060046920043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.91.52.198', '2019-05-15 15:40:05', 800, 0, '', '2019-05-15 15:40:05');
INSERT INTO `access_log` VALUES (1777, '30.66.15579062207850039', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '171.8.64.88', '2019-05-15 15:43:41', 17, 2001001000, '服务端发生异常', '2019-05-15 15:43:41');
INSERT INTO `access_log` VALUES (1778, '30.64.15579062207940041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '171.8.64.88', '2019-05-15 15:43:41', 8, 0, '', '2019-05-15 15:43:41');
INSERT INTO `access_log` VALUES (1779, '30.69.15579062207910041', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '171.8.64.88', '2019-05-15 15:43:41', 14, 2001001000, '服务端发生异常', '2019-05-15 15:43:41');
INSERT INTO `access_log` VALUES (1780, '35.73.15579062461090043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.255.132.7', '2019-05-15 15:44:06', 5, 0, '', '2019-05-15 15:44:06');
INSERT INTO `access_log` VALUES (1781, '35.72.15579062461120043', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.255.132.7', '2019-05-15 15:44:06', 18, 0, '', '2019-05-15 15:44:06');
INSERT INTO `access_log` VALUES (1782, '32.82.15579062529870045', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.255.132.7', '2019-05-15 15:44:13', 399, 0, '', '2019-05-15 15:44:13');
INSERT INTO `access_log` VALUES (1783, '36.90.15579062537530005', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=38', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.255.132.7', '2019-05-15 15:44:14', 66, 0, '', '2019-05-15 15:44:14');
INSERT INTO `access_log` VALUES (1784, '30.73.15579062547610037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '171.8.64.88', '2019-05-15 15:44:15', 146, 0, '', '2019-05-15 15:44:15');
INSERT INTO `access_log` VALUES (1785, '30.65.15579062551580045', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '171.8.64.88', '2019-05-15 15:44:15', 8, 0, '', '2019-05-15 15:44:15');
INSERT INTO `access_log` VALUES (1786, '30.71.15579062551490037', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '171.8.64.88', '2019-05-15 15:44:15', 230, 2001001000, '服务端发生异常', '2019-05-15 15:44:15');
INSERT INTO `access_log` VALUES (1787, '30.70.15579062551530037', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '171.8.64.88', '2019-05-15 15:44:15', 230, 2001001000, '服务端发生异常', '2019-05-15 15:44:15');
INSERT INTO `access_log` VALUES (1788, '35.77.15579062701180041', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:30', 474, 0, '', '2019-05-15 15:44:31');
INSERT INTO `access_log` VALUES (1789, '35.78.15579062701180041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:30', 482, 0, '', '2019-05-15 15:44:31');
INSERT INTO `access_log` VALUES (1790, '32.88.15579062733670045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:33', 4, 0, '', '2019-05-15 15:44:33');
INSERT INTO `access_log` VALUES (1791, '32.83.15579062735700045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:34', 4, 0, '', '2019-05-15 15:44:34');
INSERT INTO `access_log` VALUES (1792, '32.79.15579062746010045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:35', 4, 0, '', '2019-05-15 15:44:35');
INSERT INTO `access_log` VALUES (1793, '32.85.15579062752960047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:35', 3, 0, '', '2019-05-15 15:44:35');
INSERT INTO `access_log` VALUES (1794, '32.81.15579062757710045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:36', 4, 0, '', '2019-05-15 15:44:36');
INSERT INTO `access_log` VALUES (1795, '33.84.15579062767670003', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:37', 3, -1, '未授权', '2019-05-15 15:44:37');
INSERT INTO `access_log` VALUES (1796, '32.86.15579062767650043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:37', 4, 0, '', '2019-05-15 15:44:37');
INSERT INTO `access_log` VALUES (1797, '0c43ed06-889e-4e9e-9991-816831053dcb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:44:37', 368, 0, '', '2019-05-15 15:44:37');
INSERT INTO `access_log` VALUES (1798, 'c584b258-010c-4577-bdf9-576e248fba94', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:44:37', 368, 0, '', '2019-05-15 15:44:37');
INSERT INTO `access_log` VALUES (1799, '0a5723be-05da-4430-ad41-43296a9344ba', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:44:37', 368, 0, '', '2019-05-15 15:44:37');
INSERT INTO `access_log` VALUES (1800, 'dab329ca-7c70-4011-8df5-e26f2637ff61', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:44:37', 576, 0, '', '2019-05-15 15:44:37');
INSERT INTO `access_log` VALUES (1801, '33.85.15579062789140003', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:39', 2, -1, '未授权', '2019-05-15 15:44:39');
INSERT INTO `access_log` VALUES (1802, '33.86.15579062792230001', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:39', 2, -1, '未授权', '2019-05-15 15:44:39');
INSERT INTO `access_log` VALUES (1803, '33.87.15579062834950003', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:43', 2, -1, '未授权', '2019-05-15 15:44:44');
INSERT INTO `access_log` VALUES (1804, '32.84.15579062857910045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:46', 4, 0, '', '2019-05-15 15:44:46');
INSERT INTO `access_log` VALUES (1805, '32.80.15579062861320047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:46', 4, 0, '', '2019-05-15 15:44:46');
INSERT INTO `access_log` VALUES (1806, '32.87.15579062877730045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:48', 3, 0, '', '2019-05-15 15:44:48');
INSERT INTO `access_log` VALUES (1807, '32.82.15579062883200047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:48', 4, 0, '', '2019-05-15 15:44:48');
INSERT INTO `access_log` VALUES (1808, '35.74.15579062896390041', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:50', 4, 0, '', '2019-05-15 15:44:50');
INSERT INTO `access_log` VALUES (1809, '35.75.15579062896410045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:50', 9, 0, '', '2019-05-15 15:44:50');
INSERT INTO `access_log` VALUES (1810, '980fbad2-cac8-47fb-9ba8-744ab908b0cc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:44:52', 16, 0, '', '2019-05-15 15:44:52');
INSERT INTO `access_log` VALUES (1811, '32.88.15579062919780047', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:52', 46, 0, '', '2019-05-15 15:44:52');
INSERT INTO `access_log` VALUES (1812, 'd4ec3a8d-f268-4995-8e09-f5b86b88d8c2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:44:52', 30, 0, '', '2019-05-15 15:44:52');
INSERT INTO `access_log` VALUES (1813, 'e2d03468-e845-4fcb-8e7f-4728840d5738', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:44:52', 33, 0, '', '2019-05-15 15:44:52');
INSERT INTO `access_log` VALUES (1814, '6d5c4762-b125-410e-bcab-c82f4f2e543b', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:44:52', 34, 0, '', '2019-05-15 15:44:52');
INSERT INTO `access_log` VALUES (1815, '36.89.15579062922660005', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=42', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '116.255.132.7', '2019-05-15 15:44:52', 14, 0, '', '2019-05-15 15:44:52');
INSERT INTO `access_log` VALUES (1816, 'ceca2040-4ea5-427d-a08a-be7bc1d1334c', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:45:10', 47, 0, '', '2019-05-15 15:45:10');
INSERT INTO `access_log` VALUES (1817, '98c72367-1a39-44f5-b246-30d03a958df4', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=5&roleIds=2,6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:45:13', 353, 0, '', '2019-05-15 15:45:13');
INSERT INTO `access_log` VALUES (1818, '16359220-7d24-489f-896d-e97db11d2f8d', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:45:19', 22, 0, '', '2019-05-15 15:45:19');
INSERT INTO `access_log` VALUES (1819, '6d213a19-302d-4050-8368-a90b17f31a3f', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:45:24', 49, 0, '', '2019-05-15 15:45:24');
INSERT INTO `access_log` VALUES (1820, '846f20c9-c94c-4d6e-9982-d00932d26e84', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:45:25', 13, 0, '', '2019-05-15 15:45:25');
INSERT INTO `access_log` VALUES (1821, 'd29a7f8f-0f04-4595-8f1f-c8b45213e129', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:45:29', 22, 0, '', '2019-05-15 15:45:29');
INSERT INTO `access_log` VALUES (1822, '7944553b-6878-4c2b-ab9c-1791d482330a', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:45:29', 20, 0, '', '2019-05-15 15:45:29');
INSERT INTO `access_log` VALUES (1823, 'ae7cba53-2af0-46d5-8010-f1ab624f3902', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:45:32', 23, 0, '', '2019-05-15 15:45:32');
INSERT INTO `access_log` VALUES (1824, '48b4de61-74fb-4b51-b793-2d6a3bfb86ab', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:45:35', 13, 0, '', '2019-05-15 15:45:35');
INSERT INTO `access_log` VALUES (1825, '4498a9c4-e3d0-40f2-9dff-e7ecb3ba8409', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:45:37', 12, 0, '', '2019-05-15 15:45:37');
INSERT INTO `access_log` VALUES (1826, '35.79.15579065304580043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '114.91.21.63', '2019-05-15 15:48:50', 5, 0, '', '2019-05-15 15:48:50');
INSERT INTO `access_log` VALUES (1827, '35.71.15579065304610041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '114.91.21.63', '2019-05-15 15:48:50', 34, 0, '', '2019-05-15 15:48:50');
INSERT INTO `access_log` VALUES (1828, '33.88.15579065437870003', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '114.91.21.63', '2019-05-15 15:49:04', 2, -1, '未授权', '2019-05-15 15:49:04');
INSERT INTO `access_log` VALUES (1829, '35.76.15579065498420043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '114.91.21.63', '2019-05-15 15:49:10', 4, 0, '', '2019-05-15 15:49:10');
INSERT INTO `access_log` VALUES (1830, '35.80.15579065498420041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '114.91.21.63', '2019-05-15 15:49:10', 10, 0, '', '2019-05-15 15:49:10');
INSERT INTO `access_log` VALUES (1831, '30.67.15579066966540037', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.180.198.114', '2019-05-15 15:51:37', 6, 0, '', '2019-05-15 15:51:37');
INSERT INTO `access_log` VALUES (1832, '30.68.15579066966520039', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.180.198.114', '2019-05-15 15:51:37', 20, 2001001000, '服务端发生异常', '2019-05-15 15:51:37');
INSERT INTO `access_log` VALUES (1833, '30.72.15579066966520031', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.180.198.114', '2019-05-15 15:51:37', 118, 2001001000, '服务端发生异常', '2019-05-15 15:51:37');
INSERT INTO `access_log` VALUES (1834, 'fb0fff9c-e5f0-471c-aa8e-a90c41ee281e', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:52:15', 379, 0, '', '2019-05-15 15:52:15');
INSERT INTO `access_log` VALUES (1835, 'e07d3d65-90f6-4b24-97be-6abb89e8d6a6', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:52:19', 13, 0, '', '2019-05-15 15:52:19');
INSERT INTO `access_log` VALUES (1836, '99a99959-d5df-423e-9740-d27f42521f18', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:01', 15, 0, '', '2019-05-15 15:53:01');
INSERT INTO `access_log` VALUES (1837, '2e9533f3-430c-44b5-9909-6a7a39376763', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:01', 19, 0, '', '2019-05-15 15:53:01');
INSERT INTO `access_log` VALUES (1838, '5d134122-a271-4f6f-89a9-cadb1774c18c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:01', 31, 0, '', '2019-05-15 15:53:01');
INSERT INTO `access_log` VALUES (1839, 'a4c8a7a9-5863-4310-ad29-d7e089fb3b62', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:02', 15, 0, '', '2019-05-15 15:53:02');
INSERT INTO `access_log` VALUES (1840, '5b8cb749-96ec-4456-b459-f0e90b9aaabd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:03', 8, 0, '', '2019-05-15 15:53:03');
INSERT INTO `access_log` VALUES (1841, 'afcd5510-86d1-4669-8935-ba3cb2f3f0de', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:03', 15, 0, '', '2019-05-15 15:53:03');
INSERT INTO `access_log` VALUES (1842, '708d7b09-1cff-455f-b1b0-30e68bd18872', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:03', 18, 0, '', '2019-05-15 15:53:03');
INSERT INTO `access_log` VALUES (1843, 'd2e80f17-61b4-42f5-aca2-832fa4747d9b', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:03', 12, 0, '', '2019-05-15 15:53:03');
INSERT INTO `access_log` VALUES (1844, '449dbdf2-8db3-4c3d-8fc9-5f4288b5c7ff', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:11', 10, 0, '', '2019-05-15 15:53:11');
INSERT INTO `access_log` VALUES (1845, '8af3300a-bb41-44fa-8671-80da32caa575', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:11', 15, 0, '', '2019-05-15 15:53:11');
INSERT INTO `access_log` VALUES (1846, 'b2e74d51-4bad-40d2-94c9-c1e71407ab48', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:11', 18, 0, '', '2019-05-15 15:53:11');
INSERT INTO `access_log` VALUES (1847, '4befeda8-bfe8-4679-b4f3-ad9ee9914932', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:11', 10, 0, '', '2019-05-15 15:53:11');
INSERT INTO `access_log` VALUES (1848, '70f4a99a-a0ca-49ec-8ef0-199d7811ec10', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:19', 9, 0, '', '2019-05-15 15:53:19');
INSERT INTO `access_log` VALUES (1849, 'b46588e5-5ec2-496b-a9da-48334a366fc5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:19', 19, 0, '', '2019-05-15 15:53:20');
INSERT INTO `access_log` VALUES (1850, '6277bfc8-dc90-42d6-92fe-8f5cd28c3d66', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:19', 25, 0, '', '2019-05-15 15:53:20');
INSERT INTO `access_log` VALUES (1851, '4ec30763-0d79-449d-a45f-55a7887eb77a', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:20', 11, 0, '', '2019-05-15 15:53:20');
INSERT INTO `access_log` VALUES (1852, '8b27e581-349e-49ba-9ad8-a54870f55e28', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:21', 374, 0, '', '2019-05-15 15:53:21');
INSERT INTO `access_log` VALUES (1853, 'dce0661a-ed7e-4aa4-9d3f-1a225d13b1bc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:21', 382, 0, '', '2019-05-15 15:53:21');
INSERT INTO `access_log` VALUES (1854, '31d077b2-6e60-49d2-8281-6414f0ecbff0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:21', 380, 0, '', '2019-05-15 15:53:21');
INSERT INTO `access_log` VALUES (1855, '73208469-e5d0-4558-a15b-cc78d8444507', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:21', 292, 0, '', '2019-05-15 15:53:21');
INSERT INTO `access_log` VALUES (1856, 'f312aad9-9ca5-4e77-ba4b-6eaa6f0b2c01', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:53:23', 13, 0, '', '2019-05-15 15:53:23');
INSERT INTO `access_log` VALUES (1857, 'cd47ee1d-f98c-4b7e-b5eb-1e1d30032ac7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:59:55', 314, 0, '', '2019-05-15 15:59:56');
INSERT INTO `access_log` VALUES (1858, '589de7f7-85b2-4df3-b880-c90e45903439', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:59:55', 314, 0, '', '2019-05-15 15:59:56');
INSERT INTO `access_log` VALUES (1859, 'adec054b-1203-4c3a-9eb5-e22da8b2c6b3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:59:55', 314, 0, '', '2019-05-15 15:59:56');
INSERT INTO `access_log` VALUES (1860, 'a8491148-b001-439e-a5a5-6dce62e43225', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:59:56', 138, 0, '', '2019-05-15 15:59:56');
INSERT INTO `access_log` VALUES (1861, '15867dbc-217d-40a9-aac0-2982167a202d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:59:56', 159, 0, '', '2019-05-15 15:59:56');
INSERT INTO `access_log` VALUES (1862, '521422d7-2bb4-40fa-adda-b1376816dc81', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:59:56', 161, 0, '', '2019-05-15 15:59:56');
INSERT INTO `access_log` VALUES (1863, 'ba8d996b-1a64-4ec6-8c7d-4895472a94b7', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:00:01', 177, 0, '', '2019-05-15 16:00:01');
INSERT INTO `access_log` VALUES (1864, 'a6086a89-f1ae-4365-a080-8afd5731e347', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:00:02', 175, 0, '', '2019-05-15 16:00:02');
INSERT INTO `access_log` VALUES (1865, '45cf4796-3487-4caa-bd53-0aff75babf8c', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:00:04', 22, 0, '', '2019-05-15 16:00:04');
INSERT INTO `access_log` VALUES (1866, 'befb44b1-a2e8-499f-a9b6-db78957a6006', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:00:06', 16, 0, '', '2019-05-15 16:00:06');
INSERT INTO `access_log` VALUES (1867, '35.73.15579076896170045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:10', 6, 0, '', '2019-05-15 16:08:10');
INSERT INTO `access_log` VALUES (1868, '35.72.15579076896170045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:10', 15, 0, '', '2019-05-15 16:08:10');
INSERT INTO `access_log` VALUES (1869, '32.83.15579077010780047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:21', 164, 0, '', '2019-05-15 16:08:21');
INSERT INTO `access_log` VALUES (1870, '32.79.15579077015400047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:22', 4, 0, '', '2019-05-15 16:08:22');
INSERT INTO `access_log` VALUES (1871, '32.85.15579077137020049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:34', 235, 0, '', '2019-05-15 16:08:34');
INSERT INTO `access_log` VALUES (1872, '32.81.15579077140790047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:34', 35, 0, '', '2019-05-15 16:08:34');
INSERT INTO `access_log` VALUES (1873, '32.86.15579077152170045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:35', 3, 0, '', '2019-05-15 16:08:35');
INSERT INTO `access_log` VALUES (1874, '32.84.15579077169830047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:37', 3, 0, '', '2019-05-15 16:08:37');
INSERT INTO `access_log` VALUES (1875, '35.77.15579077200900043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:40', 4, 0, '', '2019-05-15 16:08:40');
INSERT INTO `access_log` VALUES (1876, '35.78.15579077200900043', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:40', 12, 0, '', '2019-05-15 16:08:40');
INSERT INTO `access_log` VALUES (1877, '32.80.15579077240810049', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:44', 12, 0, '', '2019-05-15 16:08:44');
INSERT INTO `access_log` VALUES (1878, '36.81.15579077242330009', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:44', 98, 0, '', '2019-05-15 16:08:44');
INSERT INTO `access_log` VALUES (1879, '35.74.15579077299930043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:50', 309, 0, '', '2019-05-15 16:08:50');
INSERT INTO `access_log` VALUES (1880, '35.75.15579077299930047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:50', 319, 0, '', '2019-05-15 16:08:50');
INSERT INTO `access_log` VALUES (1881, '32.87.15579077346550047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:55', 4, 0, '', '2019-05-15 16:08:55');
INSERT INTO `access_log` VALUES (1882, '32.82.15579077348090049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:55', 4, 0, '', '2019-05-15 16:08:55');
INSERT INTO `access_log` VALUES (1883, '35.71.15579077352950043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:55', 4, 0, '', '2019-05-15 16:08:55');
INSERT INTO `access_log` VALUES (1884, '35.79.15579077353010045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:08:55', 13, 0, '', '2019-05-15 16:08:55');
INSERT INTO `access_log` VALUES (1885, '30.66.15579077420580041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:09:02', 6, 0, '', '2019-05-15 16:09:02');
INSERT INTO `access_log` VALUES (1886, '30.64.15579077420550043', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:09:02', 15, 2001001000, '服务端发生异常', '2019-05-15 16:09:02');
INSERT INTO `access_log` VALUES (1887, '30.69.15579077420550043', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:09:02', 23, 2001001000, '服务端发生异常', '2019-05-15 16:09:02');
INSERT INTO `access_log` VALUES (1888, '30.73.15579078043650039', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:10:04', 14, 2001001000, '服务端发生异常', '2019-05-15 16:10:04');
INSERT INTO `access_log` VALUES (1889, '30.70.15579078043920039', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:10:04', 6, 0, '', '2019-05-15 16:10:04');
INSERT INTO `access_log` VALUES (1890, '30.65.15579078043870047', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:10:04', 44, 2001001000, '服务端发生异常', '2019-05-15 16:10:04');
INSERT INTO `access_log` VALUES (1891, '30.68.15579078132800041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:10:13', 5, 0, '', '2019-05-15 16:10:13');
INSERT INTO `access_log` VALUES (1892, '30.71.15579078132750039', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:10:13', 13, 2001001000, '服务端发生异常', '2019-05-15 16:10:13');
INSERT INTO `access_log` VALUES (1893, '30.67.15579078132780039', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:10:13', 14, 2001001000, '服务端发生异常', '2019-05-15 16:10:13');
INSERT INTO `access_log` VALUES (1894, '30.64.15579078187190045', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:10:19', 5, 0, '', '2019-05-15 16:10:19');
INSERT INTO `access_log` VALUES (1895, '30.72.15579078187120033', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:10:19', 13, 2001001000, '服务端发生异常', '2019-05-15 16:10:19');
INSERT INTO `access_log` VALUES (1896, '30.66.15579078187130043', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:10:19', 17, 2001001000, '服务端发生异常', '2019-05-15 16:10:19');
INSERT INTO `access_log` VALUES (1897, '30.73.15579078228850041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:10:23', 5, 0, '', '2019-05-15 16:10:23');
INSERT INTO `access_log` VALUES (1898, '30.69.15579078228810045', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:10:23', 15, 2001001000, '服务端发生异常', '2019-05-15 16:10:23');
INSERT INTO `access_log` VALUES (1899, '30.70.15579078228830041', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.13.14.221', '2019-05-15 16:10:23', 17, 2001001000, '服务端发生异常', '2019-05-15 16:10:23');
INSERT INTO `access_log` VALUES (1900, 'e43752c4-d8ee-4da7-9ff7-3bb5ada7e185', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:40:53', 180, 1002001012, '访问令牌已过期', '2019-05-15 16:40:54');
INSERT INTO `access_log` VALUES (1901, 'daf1135e-c0cc-4e5e-9bc3-22ae94afc50d', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:40:53', 180, 1002001012, '访问令牌已过期', '2019-05-15 16:40:54');
INSERT INTO `access_log` VALUES (1902, '805cb31d-320b-4921-a7ba-6a6cbd51e48f', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:40:53', 180, 1002001012, '访问令牌已过期', '2019-05-15 16:40:54');
INSERT INTO `access_log` VALUES (1903, 'c60feab0-b3e7-4c0a-b1ba-a8d68e9c0a4a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:40:59', 175, 0, '', '2019-05-15 16:40:59');
INSERT INTO `access_log` VALUES (1904, 'ab0960fd-3bd1-48ff-848a-7efd29a2e3d0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:40:59', 78, 0, '', '2019-05-15 16:40:59');
INSERT INTO `access_log` VALUES (1905, '60ba5128-3d66-415c-bd37-671826cfb1ca', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:40:59', 102, 0, '', '2019-05-15 16:40:59');
INSERT INTO `access_log` VALUES (1906, '8d525297-52ed-40f9-8c73-6030c9455fb8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:40:59', 121, 0, '', '2019-05-15 16:40:59');
INSERT INTO `access_log` VALUES (1907, 'fdb31833-38f9-4701-887e-e055e72dde38', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:41:01', 3505, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-05-15 16:41:05');
INSERT INTO `access_log` VALUES (1908, '403d01b7-7c2c-401d-8685-c6065cee14b3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:41:49', 19, 0, '', '2019-05-15 16:41:49');
INSERT INTO `access_log` VALUES (1909, '2cacd879-2420-4118-96c2-dcffba76de7d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:41:49', 32, 0, '', '2019-05-15 16:41:49');
INSERT INTO `access_log` VALUES (1910, '7ed76882-98c7-439d-85e9-7166f7931dc2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:41:49', 35, 0, '', '2019-05-15 16:41:49');
INSERT INTO `access_log` VALUES (1911, '4142f0c4-7e9f-4775-a1be-941cc829c6c9', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:41:49', 85, 0, '', '2019-05-15 16:41:49');
INSERT INTO `access_log` VALUES (1912, 'b2b4e2c5-1e73-4366-9bef-1527d2ea5db0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:41:50', 10, 0, '', '2019-05-15 16:41:50');
INSERT INTO `access_log` VALUES (1913, '99729cbe-0481-4885-b412-dfaf969eb6c5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:41:50', 19, 0, '', '2019-05-15 16:41:50');
INSERT INTO `access_log` VALUES (1914, 'cc5bf9be-f36c-496c-84ba-40cbd13b5afd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:41:50', 23, 0, '', '2019-05-15 16:41:50');
INSERT INTO `access_log` VALUES (1915, '168283ec-7d20-4f01-a11c-6cd90194d077', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:41:50', 22, 0, '', '2019-05-15 16:41:50');
INSERT INTO `access_log` VALUES (1916, '23ee8be1-1494-477f-b593-c9fc26f60625', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:41:54', 11, 0, '', '2019-05-15 16:41:54');
INSERT INTO `access_log` VALUES (1917, 'cba7a314-cd5a-4694-b23c-5e9e96f5a405', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:41:54', 14, 0, '', '2019-05-15 16:41:54');
INSERT INTO `access_log` VALUES (1918, '16bcc1f5-baa6-4dc4-964d-bacd13e2df4d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:41:54', 43, 0, '', '2019-05-15 16:41:54');
INSERT INTO `access_log` VALUES (1919, '95917860-e5e6-4c50-8778-d4678b21d67d', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:41:55', 14, 0, '', '2019-05-15 16:41:55');
INSERT INTO `access_log` VALUES (1920, 'bdf83479-8524-4554-be02-75e3520083ab', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:42:03', 12, 0, '', '2019-05-15 16:42:03');
INSERT INTO `access_log` VALUES (1921, '98c20994-e9a9-41b7-9886-e98f06b1a556', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:42:03', 18, 0, '', '2019-05-15 16:42:03');
INSERT INTO `access_log` VALUES (1922, '1d236531-0338-4c64-975a-ac225a6dbb88', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:42:03', 21, 0, '', '2019-05-15 16:42:03');
INSERT INTO `access_log` VALUES (1923, 'fb711a34-833e-4b8f-b5d4-35cc7745785b', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:42:03', 14, 0, '', '2019-05-15 16:42:03');
INSERT INTO `access_log` VALUES (1924, '6df1ea33-f06f-43b3-b2a1-477b3df91f46', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:42:16', 625, 0, '', '2019-05-15 16:42:17');
INSERT INTO `access_log` VALUES (1925, '14b7cd1c-22c6-44a8-ad56-625aa6f515c3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:42:16', 617, 0, '', '2019-05-15 16:42:17');
INSERT INTO `access_log` VALUES (1926, '574ed586-506e-488a-9cf5-88d097ecda38', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:42:16', 628, 0, '', '2019-05-15 16:42:17');
INSERT INTO `access_log` VALUES (1927, 'c9204703-d8fc-4357-90e5-34c061c58223', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:42:16', 480, 0, '', '2019-05-15 16:42:17');
INSERT INTO `access_log` VALUES (1928, '37dcc94d-95d1-49a0-ab08-61ed15095459', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:43:01', 11, 0, '', '2019-05-15 16:43:01');
INSERT INTO `access_log` VALUES (1929, '26b524f0-b24b-42c7-8fde-a77d39a3bbeb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:43:01', 19, 0, '', '2019-05-15 16:43:01');
INSERT INTO `access_log` VALUES (1930, '0fd3a87a-619b-41a3-8a1f-f5ab90912c46', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:43:01', 27, 0, '', '2019-05-15 16:43:01');
INSERT INTO `access_log` VALUES (1931, '106e28af-189f-40f9-b803-707f6cb41149', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:43:01', 15, 0, '', '2019-05-15 16:43:01');
INSERT INTO `access_log` VALUES (1932, '375b5794-6660-4c03-94e8-7739d8c994ea', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:43:06', 10, 0, '', '2019-05-15 16:43:06');
INSERT INTO `access_log` VALUES (1933, '6a2591df-9cb7-4bbb-9957-7b69d3802885', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:43:06', 15, 0, '', '2019-05-15 16:43:06');
INSERT INTO `access_log` VALUES (1934, 'b22130d8-3c06-48e2-9327-06e3caab71fd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:43:06', 18, 0, '', '2019-05-15 16:43:06');
INSERT INTO `access_log` VALUES (1935, '36203c0c-27cb-47d7-8cf4-3b5f888f2b43', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:43:06', 11, 0, '', '2019-05-15 16:43:06');
INSERT INTO `access_log` VALUES (1936, '75899ced-6da3-4111-8c58-8b7babc03e25', 1, 2, 'admin-application', '/admin-api/admins/role/update', 'id=1&name=系统管理员&createTime=2019-02-24T01:03:51.000+0000', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:43:11', 25, 0, '', '2019-05-15 16:43:11');
INSERT INTO `access_log` VALUES (1937, '4c9500ac-058c-4b3f-b372-9a332d873d11', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:43:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-05-15 16:43:12');
INSERT INTO `access_log` VALUES (1938, 'ca8e7ce0-14e2-426e-a764-d7c1a8128e55', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:43:13', 19, 0, '', '2019-05-15 16:43:13');
INSERT INTO `access_log` VALUES (1939, '3748f96e-5d2d-41b6-8712-8215e6ce039a', 1, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=1&resourceIds=31,32,44,45,21,22,29,30,28,46,43,24,25,26,41,42,14,15,16,19', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 16:43:14', 141, 0, '', '2019-05-15 16:43:15');
INSERT INTO `access_log` VALUES (1940, '30.67.15579115885670041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:13:09', 14, 1002001012, '访问令牌已过期', '2019-05-15 17:13:09');
INSERT INTO `access_log` VALUES (1941, '30.71.15579115885670041', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:13:09', 22, 1002001012, '访问令牌已过期', '2019-05-15 17:13:09');
INSERT INTO `access_log` VALUES (1942, '30.65.15579115885670049', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:13:09', 27, 1002001012, '访问令牌已过期', '2019-05-15 17:13:09');
INSERT INTO `access_log` VALUES (1943, '30.68.15579115899040043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:13:10', 3, 1002001012, '访问令牌已过期', '2019-05-15 17:13:10');
INSERT INTO `access_log` VALUES (1944, '30.72.15579115919150035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:13:12', 4, 1002001012, '访问令牌已过期', '2019-05-15 17:13:12');
INSERT INTO `access_log` VALUES (1945, '30.64.15579116152210047', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.203.12.98', '2019-05-15 17:13:35', 6, 0, '', '2019-05-15 17:13:35');
INSERT INTO `access_log` VALUES (1946, '30.66.15579116152200045', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.203.12.98', '2019-05-15 17:13:35', 25, 2001001000, '服务端发生异常', '2019-05-15 17:13:35');
INSERT INTO `access_log` VALUES (1947, '30.73.15579116152920043', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.203.12.98', '2019-05-15 17:13:35', 11, 2001001000, '服务端发生异常', '2019-05-15 17:13:35');
INSERT INTO `access_log` VALUES (1948, '35.80.15579116432050043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.203.12.98', '2019-05-15 17:14:03', 18, 0, '', '2019-05-15 17:14:03');
INSERT INTO `access_log` VALUES (1949, '35.76.15579116432050045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.203.12.98', '2019-05-15 17:14:03', 50, 0, '', '2019-05-15 17:14:03');
INSERT INTO `access_log` VALUES (1950, '32.88.15579116484570049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.203.12.98', '2019-05-15 17:14:08', 53, 0, '', '2019-05-15 17:14:09');
INSERT INTO `access_log` VALUES (1951, '32.83.15579116485970049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.203.12.98', '2019-05-15 17:14:09', 4, 0, '', '2019-05-15 17:14:09');
INSERT INTO `access_log` VALUES (1952, '32.79.15579116528560049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.203.12.98', '2019-05-15 17:14:13', 11, 0, '', '2019-05-15 17:14:13');
INSERT INTO `access_log` VALUES (1953, '32.85.15579116529800051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.203.12.98', '2019-05-15 17:14:13', 13, 0, '', '2019-05-15 17:14:13');
INSERT INTO `access_log` VALUES (1954, '35.72.15579116536020047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.203.12.98', '2019-05-15 17:14:14', 7, 0, '', '2019-05-15 17:14:14');
INSERT INTO `access_log` VALUES (1955, '35.73.15579116536020047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.203.12.98', '2019-05-15 17:14:14', 46, 0, '', '2019-05-15 17:14:14');
INSERT INTO `access_log` VALUES (1956, '35.77.15579118034040045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-15 17:16:43', 6, 0, '', '2019-05-15 17:16:43');
INSERT INTO `access_log` VALUES (1957, '35.78.15579118034030045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-15 17:16:43', 41, 0, '', '2019-05-15 17:16:43');
INSERT INTO `access_log` VALUES (1958, '32.81.15579118066070049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-15 17:16:47', 5, 0, '', '2019-05-15 17:16:47');
INSERT INTO `access_log` VALUES (1959, '32.86.15579118067560047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-15 17:16:47', 4, 0, '', '2019-05-15 17:16:47');
INSERT INTO `access_log` VALUES (1960, '35.74.15579118098000045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-15 17:16:50', 4, 0, '', '2019-05-15 17:16:50');
INSERT INTO `access_log` VALUES (1961, '35.75.15579118098040049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-15 17:16:50', 34, 0, '', '2019-05-15 17:16:50');
INSERT INTO `access_log` VALUES (1962, '35.79.15579118155390047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-15 17:16:56', 5, 0, '', '2019-05-15 17:16:56');
INSERT INTO `access_log` VALUES (1963, '35.71.15579118155400045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-15 17:16:56', 177, 0, '', '2019-05-15 17:16:56');
INSERT INTO `access_log` VALUES (1964, '35.80.15579118193810045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-15 17:16:59', 5, 0, '', '2019-05-15 17:16:59');
INSERT INTO `access_log` VALUES (1965, '35.76.15579118193830047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-15 17:16:59', 15, 0, '', '2019-05-15 17:16:59');
INSERT INTO `access_log` VALUES (1966, '30.67.15579122871100043', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.129.221.130', '2019-05-15 17:24:47', 6, 0, '', '2019-05-15 17:24:47');
INSERT INTO `access_log` VALUES (1967, '30.70.15579122871050043', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.129.221.130', '2019-05-15 17:24:47', 14, 2001001000, '服务端发生异常', '2019-05-15 17:24:47');
INSERT INTO `access_log` VALUES (1968, '30.69.15579122871060047', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.129.221.130', '2019-05-15 17:24:47', 17, 2001001000, '服务端发生异常', '2019-05-15 17:24:47');
INSERT INTO `access_log` VALUES (1969, '35.73.15579127018920049', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.128.148.106', '2019-05-15 17:31:42', 103, 0, '', '2019-05-15 17:31:42');
INSERT INTO `access_log` VALUES (1970, '35.72.15579127018930049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.128.148.106', '2019-05-15 17:31:42', 125, 0, '', '2019-05-15 17:31:42');
INSERT INTO `access_log` VALUES (1971, '32.84.15579127129760049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.128.148.106', '2019-05-15 17:31:53', 4, 0, '', '2019-05-15 17:31:53');
INSERT INTO `access_log` VALUES (1972, '32.80.15579127147140051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.128.148.106', '2019-05-15 17:31:55', 4, 0, '', '2019-05-15 17:31:55');
INSERT INTO `access_log` VALUES (1973, '30.65.15579127353970051', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.128.148.106', '2019-05-15 17:32:15', 4, 1002001012, '访问令牌已过期', '2019-05-15 17:32:15');
INSERT INTO `access_log` VALUES (1974, '30.71.15579127354080045', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.128.148.106', '2019-05-15 17:32:15', 4, 1002001012, '访问令牌已过期', '2019-05-15 17:32:15');
INSERT INTO `access_log` VALUES (1975, '30.66.15579127354600047', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.128.148.106', '2019-05-15 17:32:15', 4, 1002001012, '访问令牌已过期', '2019-05-15 17:32:15');
INSERT INTO `access_log` VALUES (1976, '30.67.15579127862540045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.128.148.106', '2019-05-15 17:33:06', 3, 1002001012, '访问令牌已过期', '2019-05-15 17:33:06');
INSERT INTO `access_log` VALUES (1977, '30.68.15579127889620045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.128.148.106', '2019-05-15 17:33:09', 3, 1002001012, '访问令牌已过期', '2019-05-15 17:33:09');
INSERT INTO `access_log` VALUES (1978, '36.88.15579128220190007', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuid=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36 QIHU 360SE/Nutch-1.13', '61.129.39.80', '2019-05-15 17:33:42', 83, 2001001001, '参数缺失:Required Integer parameter \'skuId\' is not present', '2019-05-15 17:33:42');
INSERT INTO `access_log` VALUES (1979, '32.87.15579129611990049', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.236.68.170', '2019-05-15 17:36:01', 2780, 0, '', '2019-05-15 17:36:04');
INSERT INTO `access_log` VALUES (1980, '35.74.15579139659070047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:52:46', 394, 2001001000, '服务端发生异常', '2019-05-15 17:52:46');
INSERT INTO `access_log` VALUES (1981, '35.75.15579139659090051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:52:46', 392, 2001001000, '服务端发生异常', '2019-05-15 17:52:46');
INSERT INTO `access_log` VALUES (1982, '35.80.15579139798430047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:53:00', 411, 2001001000, '服务端发生异常', '2019-05-15 17:53:00');
INSERT INTO `access_log` VALUES (1983, '35.76.15579139798440049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:53:00', 411, 2001001000, '服务端发生异常', '2019-05-15 17:53:00');
INSERT INTO `access_log` VALUES (1984, '35.77.15579142062220049', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:56:46', 149, 2001001000, '服务端发生异常', '2019-05-15 17:56:46');
INSERT INTO `access_log` VALUES (1985, '35.78.15579142062160049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:56:46', 206, 2001001000, '服务端发生异常', '2019-05-15 17:56:46');
INSERT INTO `access_log` VALUES (1986, '35.74.15579147334960049', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '58.213.139.98', '2019-05-15 18:05:33', 15, 0, '', '2019-05-15 18:05:34');
INSERT INTO `access_log` VALUES (1987, '35.75.15579147334960053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '58.213.139.98', '2019-05-15 18:05:33', 23, 0, '', '2019-05-15 18:05:34');
INSERT INTO `access_log` VALUES (1988, '35.71.15579154080740049', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.23.146.219', '2019-05-15 18:16:48', 7, 0, '', '2019-05-15 18:16:48');
INSERT INTO `access_log` VALUES (1989, '35.79.15579154080740051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.23.146.219', '2019-05-15 18:16:48', 19, 0, '', '2019-05-15 18:16:48');
INSERT INTO `access_log` VALUES (1990, '32.80.15579154161860053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.23.146.219', '2019-05-15 18:16:56', 41, 0, '', '2019-05-15 18:16:56');
INSERT INTO `access_log` VALUES (1991, '32.88.15579154163540051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.23.146.219', '2019-05-15 18:16:56', 3, 0, '', '2019-05-15 18:16:56');
INSERT INTO `access_log` VALUES (1992, '32.82.15579154187670053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.23.146.219', '2019-05-15 18:16:59', 4, 0, '', '2019-05-15 18:16:59');
INSERT INTO `access_log` VALUES (1993, '32.83.15579154194210053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.23.146.219', '2019-05-15 18:16:59', 4, 0, '', '2019-05-15 18:16:59');
INSERT INTO `access_log` VALUES (1994, '32.79.15579154230020051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.23.146.219', '2019-05-15 18:17:03', 4, 0, '', '2019-05-15 18:17:03');
INSERT INTO `access_log` VALUES (1995, '32.86.15579154231040049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.23.146.219', '2019-05-15 18:17:03', 3, 0, '', '2019-05-15 18:17:03');
INSERT INTO `access_log` VALUES (1996, '32.85.15579154290630055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.23.146.219', '2019-05-15 18:17:09', 4, 0, '', '2019-05-15 18:17:09');
INSERT INTO `access_log` VALUES (1997, '32.81.15579154292020051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.23.146.219', '2019-05-15 18:17:09', 6, 0, '', '2019-05-15 18:17:09');
INSERT INTO `access_log` VALUES (1998, '35.80.15579154305380049', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.23.146.219', '2019-05-15 18:17:11', 5, 0, '', '2019-05-15 18:17:11');
INSERT INTO `access_log` VALUES (1999, '35.76.15579154305380051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.23.146.219', '2019-05-15 18:17:11', 11, 0, '', '2019-05-15 18:17:11');
INSERT INTO `access_log` VALUES (2000, '30.71.15579159112070049', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.28.133.31', '2019-05-15 18:25:11', 4, 1002001012, '访问令牌已过期', '2019-05-15 18:25:11');
INSERT INTO `access_log` VALUES (2001, '30.66.15579159112100049', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.28.133.31', '2019-05-15 18:25:11', 3, 1002001012, '访问令牌已过期', '2019-05-15 18:25:11');
INSERT INTO `access_log` VALUES (2002, '30.68.15579159112130047', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.28.133.31', '2019-05-15 18:25:11', 13, 1002001012, '访问令牌已过期', '2019-05-15 18:25:11');
INSERT INTO `access_log` VALUES (2003, '30.67.15579159132390047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.28.133.31', '2019-05-15 18:25:13', 46, 1002001012, '访问令牌已过期', '2019-05-15 18:25:13');
INSERT INTO `access_log` VALUES (2004, '30.72.15579159150120043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.28.133.31', '2019-05-15 18:25:15', 3, 1002001012, '访问令牌已过期', '2019-05-15 18:25:15');
INSERT INTO `access_log` VALUES (2005, '35.73.15579171668700053', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 18:46:07', 5, 0, '', '2019-05-15 18:46:07');
INSERT INTO `access_log` VALUES (2006, '35.72.15579171668700053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 18:46:07', 40, 0, '', '2019-05-15 18:46:07');
INSERT INTO `access_log` VALUES (2007, '35.77.15579172840060051', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:04', 5, 0, '', '2019-05-15 18:48:04');
INSERT INTO `access_log` VALUES (2008, '35.78.15579172840070051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:04', 11, 0, '', '2019-05-15 18:48:04');
INSERT INTO `access_log` VALUES (2009, '32.85.15579172943220057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:14', 4, 0, '', '2019-05-15 18:48:14');
INSERT INTO `access_log` VALUES (2010, '32.81.15579172947980053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:15', 4, 0, '', '2019-05-15 18:48:15');
INSERT INTO `access_log` VALUES (2011, '32.87.15579172966920051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:17', 4, 0, '', '2019-05-15 18:48:17');
INSERT INTO `access_log` VALUES (2012, '32.84.15579173015450051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:22', 4, 0, '', '2019-05-15 18:48:22');
INSERT INTO `access_log` VALUES (2013, '32.88.15579173034990055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:23', 1048, 0, '', '2019-05-15 18:48:25');
INSERT INTO `access_log` VALUES (2014, '32.80.15579173127190057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:33', 4, 0, '', '2019-05-15 18:48:33');
INSERT INTO `access_log` VALUES (2015, '32.83.15579173128260057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:33', 3, 0, '', '2019-05-15 18:48:33');
INSERT INTO `access_log` VALUES (2016, '35.74.15579173149250051', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:35', 5, 0, '', '2019-05-15 18:48:35');
INSERT INTO `access_log` VALUES (2017, '35.75.15579173149250055', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:35', 19, 0, '', '2019-05-15 18:48:35');
INSERT INTO `access_log` VALUES (2018, '32.79.15579173174750053', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:37', 90, 0, '', '2019-05-15 18:48:38');
INSERT INTO `access_log` VALUES (2019, '36.90.15579173203560007', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:40', 106, 0, '', '2019-05-15 18:48:40');
INSERT INTO `access_log` VALUES (2020, '32.82.15579173348520055', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:55', 32, 0, '', '2019-05-15 18:48:55');
INSERT INTO `access_log` VALUES (2021, '36.82.15579173351520005', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '111.20.192.216', '2019-05-15 18:48:55', 26, 0, '', '2019-05-15 18:48:55');
INSERT INTO `access_log` VALUES (2022, '30.65.15579181931410053', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:03:13', 3, 1002001012, '访问令牌已过期', '2019-05-15 19:03:13');
INSERT INTO `access_log` VALUES (2023, '30.73.15579181931410051', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:03:13', 5, 1002001012, '访问令牌已过期', '2019-05-15 19:03:13');
INSERT INTO `access_log` VALUES (2024, '30.71.15579181931500051', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:03:13', 13, 1002001012, '访问令牌已过期', '2019-05-15 19:03:13');
INSERT INTO `access_log` VALUES (2025, '30.66.15579181968360051', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:03:17', 4, 1002001012, '访问令牌已过期', '2019-05-15 19:03:17');
INSERT INTO `access_log` VALUES (2026, '30.68.15579181979820049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:03:18', 3, 1002001012, '访问令牌已过期', '2019-05-15 19:03:18');
INSERT INTO `access_log` VALUES (2027, '30.67.15579181985930049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:03:19', 4, 1002001012, '访问令牌已过期', '2019-05-15 19:03:19');
INSERT INTO `access_log` VALUES (2028, '30.72.15579181992310045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:03:19', 4, 1002001012, '访问令牌已过期', '2019-05-15 19:03:19');
INSERT INTO `access_log` VALUES (2029, '35.71.15579182120550051', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:03:32', 5, 0, '', '2019-05-15 19:03:32');
INSERT INTO `access_log` VALUES (2030, '35.79.15579182120550053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:03:32', 11, 0, '', '2019-05-15 19:03:32');
INSERT INTO `access_log` VALUES (2031, '32.86.15579182162990051', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:03:36', 148, 0, '', '2019-05-15 19:03:36');
INSERT INTO `access_log` VALUES (2032, '36.83.15579182167000007', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:03:37', 24, 0, '', '2019-05-15 19:03:37');
INSERT INTO `access_log` VALUES (2033, '36.86.15579183699020007', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=37', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:06:10', 19, 0, '', '2019-05-15 19:06:10');
INSERT INTO `access_log` VALUES (2034, '36.85.15579183708230011', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:06:11', 12, 0, '', '2019-05-15 19:06:11');
INSERT INTO `access_log` VALUES (2035, '35.76.15579183822950053', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:06:22', 61, 0, '', '2019-05-15 19:06:22');
INSERT INTO `access_log` VALUES (2036, '35.80.15579183822950051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:06:22', 71, 0, '', '2019-05-15 19:06:22');
INSERT INTO `access_log` VALUES (2037, '32.85.15579183992050059', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:06:39', 35, 0, '', '2019-05-15 19:06:39');
INSERT INTO `access_log` VALUES (2038, '36.87.15579183993450009', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:06:39', 12, 0, '', '2019-05-15 19:06:39');
INSERT INTO `access_log` VALUES (2039, '35.73.15579184086710055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:06:49', 5, 0, '', '2019-05-15 19:06:49');
INSERT INTO `access_log` VALUES (2040, '35.72.15579184086710055', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:06:49', 44, 0, '', '2019-05-15 19:06:49');
INSERT INTO `access_log` VALUES (2041, '32.81.15579184732820055', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:07:53', 36, 0, '', '2019-05-15 19:07:53');
INSERT INTO `access_log` VALUES (2042, '36.90.15579184734280009', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:07:53', 25, 0, '', '2019-05-15 19:07:53');
INSERT INTO `access_log` VALUES (2043, '35.78.15579184828640053', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.32.216.11', '2019-05-15 19:08:03', 5, 0, '', '2019-05-15 19:08:03');
INSERT INTO `access_log` VALUES (2044, '35.77.15579184828640053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.32.216.11', '2019-05-15 19:08:03', 46, 0, '', '2019-05-15 19:08:03');
INSERT INTO `access_log` VALUES (2045, '30.70.15579185090930049', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.32.216.11', '2019-05-15 19:08:29', 4, 0, '', '2019-05-15 19:08:29');
INSERT INTO `access_log` VALUES (2046, '30.69.15579185090810051', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.32.216.11', '2019-05-15 19:08:29', 17, 2001001000, '服务端发生异常', '2019-05-15 19:08:29');
INSERT INTO `access_log` VALUES (2047, '30.64.15579185090930053', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.32.216.11', '2019-05-15 19:08:29', 12, 2001001000, '服务端发生异常', '2019-05-15 19:08:29');
INSERT INTO `access_log` VALUES (2048, '35.75.15579185790660057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:09:39', 5, 0, '', '2019-05-15 19:09:39');
INSERT INTO `access_log` VALUES (2049, '35.74.15579185790660053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-05-15 19:09:39', 11, 0, '', '2019-05-15 19:09:39');
INSERT INTO `access_log` VALUES (2050, '37.70.15579236233950001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-15 20:33:43', 588, 0, '', '2019-05-15 20:33:44');
INSERT INTO `access_log` VALUES (2051, '37.68.15579236233980001', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-15 20:33:43', 413, 0, '', '2019-05-15 20:33:44');
INSERT INTO `access_log` VALUES (2052, '37.69.15579236233940001', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-15 20:33:43', 407, 0, '', '2019-05-15 20:33:44');
INSERT INTO `access_log` VALUES (2053, '37.71.15579263011350001', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.11.130.225', '2019-05-15 21:18:21', 131, 1002001012, '访问令牌已过期', '2019-05-15 21:18:21');
INSERT INTO `access_log` VALUES (2054, '37.72.15579263011320001', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.11.130.225', '2019-05-15 21:18:21', 133, 1002001012, '访问令牌已过期', '2019-05-15 21:18:21');
INSERT INTO `access_log` VALUES (2055, '37.73.15579263011360001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.11.130.225', '2019-05-15 21:18:21', 130, 1002001012, '访问令牌已过期', '2019-05-15 21:18:21');
INSERT INTO `access_log` VALUES (2056, '37.64.15579263026500003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.11.130.225', '2019-05-15 21:18:23', 40, 1002001012, '访问令牌已过期', '2019-05-15 21:18:23');
INSERT INTO `access_log` VALUES (2057, '37.65.15579263047320001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.11.130.225', '2019-05-15 21:18:25', 5, 1002001012, '访问令牌已过期', '2019-05-15 21:18:25');
INSERT INTO `access_log` VALUES (2058, '37.66.15579281917140001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.11.130.225', '2019-05-15 21:49:52', 16, 1002001012, '访问令牌已过期', '2019-05-15 21:49:52');
INSERT INTO `access_log` VALUES (2059, '37.67.15579281988210001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.11.130.225', '2019-05-15 21:49:59', 6, 1002001012, '访问令牌已过期', '2019-05-15 21:49:59');
INSERT INTO `access_log` VALUES (2060, '37.70.15579282039460003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.11.130.225', '2019-05-15 21:50:04', 5, 1002001012, '访问令牌已过期', '2019-05-15 21:50:04');
INSERT INTO `access_log` VALUES (2061, '37.69.15579283888770003', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.96.194.57', '2019-05-15 21:53:09', 4, 0, '', '2019-05-15 21:53:09');
INSERT INTO `access_log` VALUES (2062, '37.68.15579283889060003', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.96.194.57', '2019-05-15 21:53:09', 4, 0, '', '2019-05-15 21:53:09');
INSERT INTO `access_log` VALUES (2063, '37.72.15579283889060003', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.96.194.57', '2019-05-15 21:53:09', 38, 0, '', '2019-05-15 21:53:09');
INSERT INTO `access_log` VALUES (2064, '37.73.15579298304300003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-15 22:17:10', 7, 1002001012, '访问令牌已过期', '2019-05-15 22:17:10');
INSERT INTO `access_log` VALUES (2065, '37.71.15579298327370003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-15 22:17:13', 8, 1002001012, '访问令牌已过期', '2019-05-15 22:17:13');
INSERT INTO `access_log` VALUES (2066, '37.64.15579298358270005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-15 22:17:16', 6, 1002001012, '访问令牌已过期', '2019-05-15 22:17:16');
INSERT INTO `access_log` VALUES (2067, '37.66.15579304279720003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-15 22:27:08', 6, 1002001012, '访问令牌已过期', '2019-05-15 22:27:08');
INSERT INTO `access_log` VALUES (2068, '37.67.15579304295820003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-15 22:27:10', 5, 1002001012, '访问令牌已过期', '2019-05-15 22:27:10');
INSERT INTO `access_log` VALUES (2069, '08e1d0ad-96d3-4e4e-9f11-2f9cc39f1350', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:16', 198, 1002001012, '访问令牌已过期', '2019-05-15 22:27:16');
INSERT INTO `access_log` VALUES (2070, 'f3901a73-f685-4fe9-bb45-77b5f4571971', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:16', 198, 1002001012, '访问令牌已过期', '2019-05-15 22:27:16');
INSERT INTO `access_log` VALUES (2071, '9b71dfd0-c9c9-4853-80f0-74ff4551434b', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:16', 198, 1002001012, '访问令牌已过期', '2019-05-15 22:27:16');
INSERT INTO `access_log` VALUES (2072, '33a91e3a-6257-4a73-a7b7-b009411a0d23', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:18', 260, 0, '', '2019-05-15 22:27:18');
INSERT INTO `access_log` VALUES (2073, '0d8095d3-7e51-4629-bd6c-b3908fc01566', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:18', 100, 0, '', '2019-05-15 22:27:19');
INSERT INTO `access_log` VALUES (2074, '40e58336-6a4b-4962-b206-289f4c6c31b2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:19', 119, 0, '', '2019-05-15 22:27:19');
INSERT INTO `access_log` VALUES (2075, '679a2d13-a7f6-4f99-8204-5b294d05b677', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:18', 317, 2001001000, '服务端发生异常', '2019-05-15 22:27:19');
INSERT INTO `access_log` VALUES (2076, '47e2ee39-f062-49f0-9488-7d08764fa443', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:26', 35, 0, '', '2019-05-15 22:27:26');
INSERT INTO `access_log` VALUES (2077, '30982b3f-6624-4a54-8f4d-9dd57f1d42b9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:26', 41, 0, '', '2019-05-15 22:27:26');
INSERT INTO `access_log` VALUES (2078, '909f19d4-df3d-4af2-a7bf-a99ae8f99f01', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:26', 133, 2001001000, '服务端发生异常', '2019-05-15 22:27:26');
INSERT INTO `access_log` VALUES (2079, 'a316942c-159f-4c02-8d78-27a7beb485ab', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:30', 30, 0, '', '2019-05-15 22:27:30');
INSERT INTO `access_log` VALUES (2080, 'e7f3f78c-7df4-4b9c-9789-c75aa8e747b8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:30', 33, 0, '', '2019-05-15 22:27:30');
INSERT INTO `access_log` VALUES (2081, 'fd649bbf-3721-405d-95c1-12caa04a7335', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:30', 384, 2001001000, '服务端发生异常', '2019-05-15 22:27:30');
INSERT INTO `access_log` VALUES (2082, '63b491cb-ee26-4f70-b692-5ae1670b4472', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:28:11', 36, 0, '', '2019-05-15 22:28:11');
INSERT INTO `access_log` VALUES (2083, '8b4698d1-2022-4193-869a-2d5163248f6b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:28:11', 34, 0, '', '2019-05-15 22:28:11');
INSERT INTO `access_log` VALUES (2084, '516acbdf-eac6-4b49-873d-b9c179195ed9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:28:11', 164, 2001001000, '服务端发生异常', '2019-05-15 22:28:11');
INSERT INTO `access_log` VALUES (2085, 'ab00d93d-eca9-4add-b72d-2b00d1ae1c49', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:29:31', 225954, 0, '', '2019-05-15 22:33:17');
INSERT INTO `access_log` VALUES (2086, 'e31e023a-0bb3-4fad-a043-c9b48e14475b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:33:17', 79, 0, '', '2019-05-15 22:33:17');
INSERT INTO `access_log` VALUES (2087, '88cf3c0a-0c3e-418d-96f9-19dd42effae4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:33:17', 209, 0, '', '2019-05-15 22:33:18');
INSERT INTO `access_log` VALUES (2088, '953020e8-75c8-4cda-82c0-a89c74ba526c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:29:31', 230753, 2001001000, '服务端发生异常', '2019-05-15 22:33:21');
INSERT INTO `access_log` VALUES (2089, '4c544308-c7b3-420b-8e38-5daeaf8f7821', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:33:17', 4935, 2001001000, '服务端发生异常', '2019-05-15 22:33:22');
INSERT INTO `access_log` VALUES (2090, '6e03c863-3ead-409e-bfc9-2d1801626475', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:29:31', 230878, 2001001000, '服务端发生异常', '2019-05-15 22:33:22');
INSERT INTO `access_log` VALUES (2091, 'b17ba3e3-0aa8-4b99-9cc7-9686617daf53', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:33:23', 47, 0, '', '2019-05-15 22:33:23');
INSERT INTO `access_log` VALUES (2092, '31de3eb5-27b0-455a-8a10-cf6eb9ed861c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:33:23', 51, 0, '', '2019-05-15 22:33:23');
INSERT INTO `access_log` VALUES (2093, 'bc89fc52-30a5-4b60-901a-a5ac0af996a9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:33:23', 183, 2001001000, '服务端发生异常', '2019-05-15 22:33:23');
INSERT INTO `access_log` VALUES (2094, 'cf4f0314-768b-428e-9277-e47e3238b86e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:33:39', 41, 0, '', '2019-05-15 22:33:39');
INSERT INTO `access_log` VALUES (2095, 'afa55510-3d57-456c-8844-94648147b078', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:35:04', 121, 0, '', '2019-05-15 22:35:04');
INSERT INTO `access_log` VALUES (2096, '4b4ff1eb-9790-4e6a-b283-4fc7e5382c4c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:33:39', 85740, 2001001000, '服务端发生异常', '2019-05-15 22:35:04');
INSERT INTO `access_log` VALUES (2097, '31fc2bec-4171-496d-be48-50e9331e96d9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:35:04', 102, 0, '', '2019-05-15 22:35:04');
INSERT INTO `access_log` VALUES (2098, 'adb3834d-31e9-43a5-8095-ac14ec145b7d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:33:39', 85733, 2001001000, '服务端发生异常', '2019-05-15 22:35:04');
INSERT INTO `access_log` VALUES (2099, '1fa898bc-e3a9-4c81-b842-f2cb70724d60', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:35:04', 742, 0, '', '2019-05-15 22:35:05');
INSERT INTO `access_log` VALUES (2100, '3c960bd1-caf0-444b-b16d-cfcb602f4bfd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:35:06', 36, 0, '', '2019-05-15 22:35:06');
INSERT INTO `access_log` VALUES (2101, 'cf70d855-e0ef-4c5c-aefc-fbf7d0aaff69', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:35:06', 34, 0, '', '2019-05-15 22:35:06');
INSERT INTO `access_log` VALUES (2102, 'd77140e7-36f2-4c24-8454-a84468a5a46f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:35:06', 47, 0, '', '2019-05-15 22:35:06');
INSERT INTO `access_log` VALUES (2103, 'a11bdf00-077a-4622-b5fe-e5d66cf9d9c5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:35:13', 49, 0, '', '2019-05-15 22:35:13');
INSERT INTO `access_log` VALUES (2104, 'a6bed169-8c1c-4227-883a-5ea8cd718677', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:35:13', 45, 0, '', '2019-05-15 22:35:13');
INSERT INTO `access_log` VALUES (2105, 'e3bcee3e-7327-48d2-aba5-a36ea7f813c1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:35:13', 72, 0, '', '2019-05-15 22:35:13');
INSERT INTO `access_log` VALUES (2106, '37.70.15579309895530005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-15 22:36:30', 6, 1002001012, '访问令牌已过期', '2019-05-15 22:36:30');
INSERT INTO `access_log` VALUES (2107, '37.69.15579309905030005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-15 22:36:31', 5, 1002001012, '访问令牌已过期', '2019-05-15 22:36:31');
INSERT INTO `access_log` VALUES (2108, '37.68.15579309957020005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-15 22:36:36', 8, 1002001012, '访问令牌已过期', '2019-05-15 22:36:36');
INSERT INTO `access_log` VALUES (2109, '532856ba-5471-42f6-bbb6-e6d8fcf09011', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:38:38', 287, 0, '', '2019-05-15 22:38:38');
INSERT INTO `access_log` VALUES (2110, '3952a250-8e39-42dc-a4f6-82a12245a459', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:38:38', 287, 0, '', '2019-05-15 22:38:38');
INSERT INTO `access_log` VALUES (2111, '87e9baf5-2545-441d-8d57-57a95507f10c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:38:38', 287, 0, '', '2019-05-15 22:38:38');
INSERT INTO `access_log` VALUES (2112, '412c43af-4b43-4b1b-b9c2-0cca99ab82b6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:38:42', 42, 0, '', '2019-05-15 22:38:43');
INSERT INTO `access_log` VALUES (2113, 'b9a1c10b-c425-487e-9ebc-f29f3054982c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:38:42', 54, 0, '', '2019-05-15 22:38:43');
INSERT INTO `access_log` VALUES (2114, 'f9fee56c-c22b-4063-aa5f-b78cc85af5ff', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:38:42', 53, 0, '', '2019-05-15 22:38:43');
INSERT INTO `access_log` VALUES (2115, 'dbb5d1de-b417-43ab-a5dc-658b045ee19c', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:38:49', 224, 0, '', '2019-05-15 22:38:49');
INSERT INTO `access_log` VALUES (2116, '1f705029-5717-47d8-8e5c-a81219978729', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:38:50', 90, 0, '', '2019-05-15 22:38:50');
INSERT INTO `access_log` VALUES (2117, '6d1d208d-4d2d-4aba-8e23-c6250b40aaf7', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:38:52', 57, 0, '', '2019-05-15 22:38:53');
INSERT INTO `access_log` VALUES (2118, '35.71.15579313234040053', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 22:42:03', 42, 0, '', '2019-05-15 22:42:03');
INSERT INTO `access_log` VALUES (2119, '35.79.15579313234110055', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 22:42:03', 77, 0, '', '2019-05-15 22:42:04');
INSERT INTO `access_log` VALUES (2120, '32.83.15579313329440059', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 22:42:13', 254, 0, '', '2019-05-15 22:42:13');
INSERT INTO `access_log` VALUES (2121, '36.82.15579313333790007', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 22:42:13', 21, 0, '', '2019-05-15 22:42:13');
INSERT INTO `access_log` VALUES (2122, '35.76.15579313355370055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 22:42:16', 12, 0, '', '2019-05-15 22:42:16');
INSERT INTO `access_log` VALUES (2123, '35.80.15579313355340053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 22:42:16', 28, 0, '', '2019-05-15 22:42:16');
INSERT INTO `access_log` VALUES (2124, '04022069-d1c2-4804-970c-afacb8b32807', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:42:16', 121, 0, '', '2019-05-15 22:42:16');
INSERT INTO `access_log` VALUES (2125, 'cb22b4a0-eadf-4db5-8f93-49ff865f1314', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:42:16', 119, 0, '', '2019-05-15 22:42:16');
INSERT INTO `access_log` VALUES (2126, '64a6b36e-aeef-4c10-abda-e1ae84fc4e51', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:42:16', 134, 0, '', '2019-05-15 22:42:16');
INSERT INTO `access_log` VALUES (2127, 'f16f7824-e015-4c53-92ca-c6410dac086e', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:42:16', 70, 0, '', '2019-05-15 22:42:16');
INSERT INTO `access_log` VALUES (2128, '32.79.15579313399010055', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 22:42:20', 11, 0, '', '2019-05-15 22:42:20');
INSERT INTO `access_log` VALUES (2129, '36.81.15579313400710011', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 22:42:20', 12, 0, '', '2019-05-15 22:42:20');
INSERT INTO `access_log` VALUES (2130, '35.73.15579313448340057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 22:42:25', 5, 0, '', '2019-05-15 22:42:25');
INSERT INTO `access_log` VALUES (2131, '35.72.15579313448400057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 22:42:25', 13, 0, '', '2019-05-15 22:42:25');
INSERT INTO `access_log` VALUES (2132, '33.87.15579313505040005', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=ka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 22:42:31', 767, -1, '未授权', '2019-05-15 22:42:33');
INSERT INTO `access_log` VALUES (2133, '2dbb0b3c-04c6-4b34-b7a0-6bd011272b45', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:44', 39, 0, '', '2019-05-15 22:44:44');
INSERT INTO `access_log` VALUES (2134, '9aec0755-99f4-49d6-b1bf-c14085d68f8c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:44', 47, 0, '', '2019-05-15 22:44:45');
INSERT INTO `access_log` VALUES (2135, 'ed725288-2bcf-469b-a015-1ed4cc8771b6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:44', 56, 0, '', '2019-05-15 22:44:45');
INSERT INTO `access_log` VALUES (2136, '482a8735-017a-4670-ae0f-11f02a0972c2', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:45', 43, 0, '', '2019-05-15 22:44:45');
INSERT INTO `access_log` VALUES (2137, '681b4882-5d33-4d42-af0a-db91856c4ea1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:46', 44, 0, '', '2019-05-15 22:44:46');
INSERT INTO `access_log` VALUES (2138, '18f3c572-6fe7-47e5-9026-d08a06ea4461', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:47', 46, 0, '', '2019-05-15 22:44:47');
INSERT INTO `access_log` VALUES (2139, 'c18a6403-fc76-47ed-a508-230e3546a946', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:47', 166, 0, '', '2019-05-15 22:44:47');
INSERT INTO `access_log` VALUES (2140, 'a509dc66-6197-45bc-9a47-84ba68692b26', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:47', 167, 0, '', '2019-05-15 22:44:47');
INSERT INTO `access_log` VALUES (2141, 'e8a1dcea-1ad5-4a2f-935b-454387d43a05', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:50', 46, 0, '', '2019-05-15 22:44:50');
INSERT INTO `access_log` VALUES (2142, '28c72557-0f56-47c9-b19d-1cb1601c7692', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:50', 45, 0, '', '2019-05-15 22:44:50');
INSERT INTO `access_log` VALUES (2143, '4a07f39b-67fb-4c6f-bac1-369ad7af89c6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:50', 55, 0, '', '2019-05-15 22:44:50');
INSERT INTO `access_log` VALUES (2144, 'bafddc67-ebac-438f-b841-dbc1c67d0398', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:50', 39, 0, '', '2019-05-15 22:44:51');
INSERT INTO `access_log` VALUES (2145, '031bedab-dc33-4f41-91d5-7e7c322036be', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:55', 56, 0, '', '2019-05-15 22:44:55');
INSERT INTO `access_log` VALUES (2146, 'fa2bda17-8119-4956-baf8-6ab529e99bb3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:55', 52, 0, '', '2019-05-15 22:44:55');
INSERT INTO `access_log` VALUES (2147, 'bfce22a1-a8f7-4d53-ba89-35cbf20a8775', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:55', 54, 0, '', '2019-05-15 22:44:55');
INSERT INTO `access_log` VALUES (2148, '60a34dbe-b926-4c0d-80d6-520226447eda', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:55', 58, 0, '', '2019-05-15 22:44:55');
INSERT INTO `access_log` VALUES (2149, '01c7ca74-036b-43f6-a4f0-cd0481be2614', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:58', 35, 0, '', '2019-05-15 22:44:58');
INSERT INTO `access_log` VALUES (2150, 'aa7f3527-0a20-4e4a-9845-0dd7cf0ca49d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:58', 38, 0, '', '2019-05-15 22:44:58');
INSERT INTO `access_log` VALUES (2151, '394ae399-e2f0-4bac-b54c-13695afb91ea', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:58', 34, 0, '', '2019-05-15 22:44:58');
INSERT INTO `access_log` VALUES (2152, '41145c04-81ec-4fea-8cd5-0b68271f9dec', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:58', 33, 0, '', '2019-05-15 22:44:58');
INSERT INTO `access_log` VALUES (2153, '00a8afc4-2eee-4531-8425-2c4f1800711e', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:44:59', 67, 0, '', '2019-05-15 22:44:59');
INSERT INTO `access_log` VALUES (2154, '1c8ec833-439a-4ec6-9d3f-e65e13160ea7', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:45:00', 49, 0, '', '2019-05-15 22:45:00');
INSERT INTO `access_log` VALUES (2155, 'a9d5042d-7d61-411b-9ca3-ba7553603df9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:45:09', 34, 0, '', '2019-05-15 22:45:09');
INSERT INTO `access_log` VALUES (2156, 'c6be5438-c9ec-492f-8b06-affd9d661455', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:45:09', 40, 0, '', '2019-05-15 22:45:09');
INSERT INTO `access_log` VALUES (2157, 'f213d718-81c0-40be-8db6-44fa48feb944', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:45:09', 43, 0, '', '2019-05-15 22:45:09');
INSERT INTO `access_log` VALUES (2158, '4902884a-f00f-406a-a67c-b254028a14db', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:45:09', 31, 0, '', '2019-05-15 22:45:09');
INSERT INTO `access_log` VALUES (2159, 'f7fb888f-c822-487a-b06c-e11b0687dd31', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:45:10', 54, 0, '', '2019-05-15 22:45:10');
INSERT INTO `access_log` VALUES (2160, 'c5cd18d8-3fcc-450d-8fa6-f074dd115431', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:45:11', 38, 0, '', '2019-05-15 22:45:11');
INSERT INTO `access_log` VALUES (2161, '9a3c51f8-c472-4a11-bd8e-6d1351b3a104', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:46:54', 53, 0, '', '2019-05-15 22:46:54');
INSERT INTO `access_log` VALUES (2162, '0bef0b26-152a-413c-ad43-da096860424b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:46:54', 49, 0, '', '2019-05-15 22:46:54');
INSERT INTO `access_log` VALUES (2163, '1f7f5b8c-b83c-43dc-94ae-577fd428639f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:46:54', 53, 0, '', '2019-05-15 22:46:54');
INSERT INTO `access_log` VALUES (2164, 'e1ff969a-9655-48a2-a918-5a88af7b0709', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:46:54', 40, 0, '', '2019-05-15 22:46:54');
INSERT INTO `access_log` VALUES (2165, '2857e3e7-fc55-4893-a591-4c2cf714bb50', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:47:27', 37, 0, '', '2019-05-15 22:47:27');
INSERT INTO `access_log` VALUES (2166, '21add469-4a31-44ef-bbcf-ea5c86bc1eee', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:47:27', 35, 0, '', '2019-05-15 22:47:27');
INSERT INTO `access_log` VALUES (2167, '8201d5af-6a92-4df2-a56d-ba064d66cd7d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:47:27', 36, 0, '', '2019-05-15 22:47:27');
INSERT INTO `access_log` VALUES (2168, 'e5a623b2-30fe-4d4b-92f6-281d9c50e3f3', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:47:27', 31, 0, '', '2019-05-15 22:47:27');
INSERT INTO `access_log` VALUES (2169, 'e00617c1-939f-4c91-b32e-d43e09086143', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:47:30', 30, 0, '', '2019-05-15 22:47:30');
INSERT INTO `access_log` VALUES (2170, '5d602143-fd94-432c-a7cd-df1b4f82133f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:47:30', 33, 0, '', '2019-05-15 22:47:30');
INSERT INTO `access_log` VALUES (2171, 'a2ddb21a-3c0b-4a92-9fe2-5eee77c839df', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:47:30', 43, 0, '', '2019-05-15 22:47:30');
INSERT INTO `access_log` VALUES (2172, 'efad5ca5-fa33-4c11-a547-a3ed399340f8', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:47:30', 31, 0, '', '2019-05-15 22:47:30');
INSERT INTO `access_log` VALUES (2173, '6c5dce27-fbce-4606-adf6-c6aa9d7dd092', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:48:45', 58, 0, '', '2019-05-15 22:48:45');
INSERT INTO `access_log` VALUES (2174, '9f02945d-0329-4446-b4eb-597db750b624', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:48:45', 50, 0, '', '2019-05-15 22:48:45');
INSERT INTO `access_log` VALUES (2175, '0ccb6d81-3846-4176-a7db-1e8b568c29ed', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:48:45', 64, 0, '', '2019-05-15 22:48:45');
INSERT INTO `access_log` VALUES (2176, '95dc1d7a-e9ef-4fe5-9533-4e53e5360ea3', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:48:45', 44, 0, '', '2019-05-15 22:48:45');
INSERT INTO `access_log` VALUES (2177, 'd3a87e76-8266-474c-bdf6-e6abc8d6d0b5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:48:51', 40, 0, '', '2019-05-15 22:48:51');
INSERT INTO `access_log` VALUES (2178, 'a732538e-2fb4-4bc3-9ba4-f09d82cfdd1c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:48:51', 37, 0, '', '2019-05-15 22:48:51');
INSERT INTO `access_log` VALUES (2179, 'd4262682-4b36-49b4-900e-475d9c774d42', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:48:51', 47, 0, '', '2019-05-15 22:48:51');
INSERT INTO `access_log` VALUES (2180, '4617d35b-6a6f-491e-b11e-5d8c8b6a9ced', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:48:51', 32, 0, '', '2019-05-15 22:48:51');
INSERT INTO `access_log` VALUES (2181, '4a18166b-0495-42f1-8446-5778bc713c72', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:49:18', 42, 0, '', '2019-05-15 22:49:18');
INSERT INTO `access_log` VALUES (2182, '57e92cc5-a822-49be-aa99-7c0b0d9ee5ea', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:49:18', 45, 0, '', '2019-05-15 22:49:18');
INSERT INTO `access_log` VALUES (2183, '0ea77118-a40f-4892-a207-e04f9d7ce377', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:49:18', 45, 0, '', '2019-05-15 22:49:18');
INSERT INTO `access_log` VALUES (2184, '14b0bda3-b511-464e-bf42-4ef65c7d7dc3', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:49:18', 48, 0, '', '2019-05-15 22:49:18');
INSERT INTO `access_log` VALUES (2185, '9717f839-13c6-4aec-83cf-3a987cb51fca', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:49:21', 38, 0, '', '2019-05-15 22:49:21');
INSERT INTO `access_log` VALUES (2186, '1770e99a-2412-47a7-b97f-3937706af6a1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:49:21', 34, 0, '', '2019-05-15 22:49:21');
INSERT INTO `access_log` VALUES (2187, 'b0975586-0e68-4249-b225-77001c9a8e3f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:49:21', 50, 0, '', '2019-05-15 22:49:21');
INSERT INTO `access_log` VALUES (2188, '9ffd6d1f-2493-4ffa-b378-9562dcb46da2', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:49:21', 31, 0, '', '2019-05-15 22:49:21');
INSERT INTO `access_log` VALUES (2189, '422f4612-e029-4e1c-8f27-b1586feae4a0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:49:28', 44, 0, '', '2019-05-15 22:49:28');
INSERT INTO `access_log` VALUES (2190, '2cc93adf-f768-4edd-9cba-5ccc08da28de', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:49:28', 42, 0, '', '2019-05-15 22:49:28');
INSERT INTO `access_log` VALUES (2191, 'c1036eb5-3246-41ac-8803-ef5a40f177d8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:49:28', 54, 0, '', '2019-05-15 22:49:28');
INSERT INTO `access_log` VALUES (2192, 'abe4fa05-12c6-4697-ae20-b90df0b2557f', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:49:28', 33, 0, '', '2019-05-15 22:49:28');
INSERT INTO `access_log` VALUES (2193, '37.72.15579317815560005', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.199', '2019-05-15 22:49:42', 4, 0, '', '2019-05-15 22:49:42');
INSERT INTO `access_log` VALUES (2194, '37.73.15579317815620005', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.198', '2019-05-15 22:49:42', 15, 0, '', '2019-05-15 22:49:42');
INSERT INTO `access_log` VALUES (2195, '37.71.15579317865530005', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.2.198.37', '2019-05-15 22:49:47', 3, 0, '', '2019-05-15 22:49:47');
INSERT INTO `access_log` VALUES (2196, 'f0128614-f002-486c-8f47-47bb237ce527', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:49:56', 79, 0, '', '2019-05-15 22:49:56');
INSERT INTO `access_log` VALUES (2197, 'da5b72b2-8970-4c38-9e16-3627d03eacfe', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:49:58', 37, 0, '', '2019-05-15 22:49:58');
INSERT INTO `access_log` VALUES (2198, '11983bf5-e7bc-4498-8dc9-94dbd8f7ab0a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:50:06', 41, 0, '', '2019-05-15 22:50:06');
INSERT INTO `access_log` VALUES (2199, 'e3cb3163-0ac7-4d88-9af9-9ef4e906c458', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:50:06', 40, 0, '', '2019-05-15 22:50:06');
INSERT INTO `access_log` VALUES (2200, 'e9d65333-6da8-434b-b471-07c6f7c7301e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:50:06', 63, 0, '', '2019-05-15 22:50:06');
INSERT INTO `access_log` VALUES (2201, 'f3892219-1928-49fc-ab19-1d2c807c2b6a', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:50:07', 32, 0, '', '2019-05-15 22:50:07');
INSERT INTO `access_log` VALUES (2202, '35.78.15579318148100055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.196', '2019-05-15 22:50:15', 7, 0, '', '2019-05-15 22:50:15');
INSERT INTO `access_log` VALUES (2203, '35.77.15579318148110055', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.197', '2019-05-15 22:50:15', 47, 0, '', '2019-05-15 22:50:15');
INSERT INTO `access_log` VALUES (2204, '32.82.15579318207980057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.197', '2019-05-15 22:50:21', 4, 0, '', '2019-05-15 22:50:21');
INSERT INTO `access_log` VALUES (2205, '32.86.15579318209280053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.197', '2019-05-15 22:50:21', 7, 0, '', '2019-05-15 22:50:21');
INSERT INTO `access_log` VALUES (2206, '32.85.15579318229440061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.197', '2019-05-15 22:50:23', 4, 0, '', '2019-05-15 22:50:23');
INSERT INTO `access_log` VALUES (2207, '32.81.15579318234390057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.197', '2019-05-15 22:50:23', 4, 0, '', '2019-05-15 22:50:23');
INSERT INTO `access_log` VALUES (2208, '871ee4a9-b2d9-49b5-8622-d03f8d2a4a9a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:50:47', 37, 0, '', '2019-05-15 22:50:47');
INSERT INTO `access_log` VALUES (2209, 'be3569f7-a93f-42d9-ad5b-35e863189771', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:50:47', 34, 0, '', '2019-05-15 22:50:47');
INSERT INTO `access_log` VALUES (2210, '7fc63b01-4d7b-4456-81fa-413d8d713dc5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:50:47', 50, 0, '', '2019-05-15 22:50:47');
INSERT INTO `access_log` VALUES (2211, 'fc2e2312-b6d5-4439-9d79-f381d480df10', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:50:47', 45, 0, '', '2019-05-15 22:50:47');
INSERT INTO `access_log` VALUES (2212, '082da940-32d7-4a2a-a639-67a68643296c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:51:07', 45, 0, '', '2019-05-15 22:51:07');
INSERT INTO `access_log` VALUES (2213, '8ad7c70c-1453-4f3a-a9af-8b8f934f2c0e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:51:07', 42, 0, '', '2019-05-15 22:51:07');
INSERT INTO `access_log` VALUES (2214, 'a926fae8-d38c-4ef8-b6fe-0225c98d07e1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:51:07', 47, 0, '', '2019-05-15 22:51:07');
INSERT INTO `access_log` VALUES (2215, '7fafaad7-4c2c-4b9a-ab0c-00a744d65896', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:51:08', 36, 0, '', '2019-05-15 22:51:08');
INSERT INTO `access_log` VALUES (2216, 'c760eecb-ffa2-4c8f-a734-df7d0ef865ef', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:51:11', 54, 0, '', '2019-05-15 22:51:11');
INSERT INTO `access_log` VALUES (2217, '1935da04-795b-4f46-9293-3cce67bfafb6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:51:11', 52, 0, '', '2019-05-15 22:51:11');
INSERT INTO `access_log` VALUES (2218, 'be04faeb-975e-4019-b570-8f75f854445a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:51:11', 60, 0, '', '2019-05-15 22:51:11');
INSERT INTO `access_log` VALUES (2219, 'bb549de2-4448-432e-b8ee-4c730a637d50', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:51:11', 47, 0, '', '2019-05-15 22:51:11');
INSERT INTO `access_log` VALUES (2220, '3ce792ce-7093-4020-9c92-6033b02d8bc6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:16', 55, 0, '', '2019-05-15 22:52:16');
INSERT INTO `access_log` VALUES (2221, 'e4f5781b-a079-4aa6-884b-1b994a81d435', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:16', 59, 0, '', '2019-05-15 22:52:16');
INSERT INTO `access_log` VALUES (2222, '95ea36d9-5794-4767-92d9-0bbe830dc409', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:16', 68, 0, '', '2019-05-15 22:52:16');
INSERT INTO `access_log` VALUES (2223, '19659edd-b928-45bf-a131-260f5c9faf58', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:17', 34, 0, '', '2019-05-15 22:52:17');
INSERT INTO `access_log` VALUES (2224, '54ab262c-19a8-4696-b6b1-aab07acd0941', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:18', 34, 0, '', '2019-05-15 22:52:18');
INSERT INTO `access_log` VALUES (2225, 'cfe28a86-ecbe-4d44-b635-7bc64dd4ceca', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:18', 33, 0, '', '2019-05-15 22:52:18');
INSERT INTO `access_log` VALUES (2226, 'f8e592e4-f166-4a2e-af73-e925f27b9288', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:18', 33, 0, '', '2019-05-15 22:52:18');
INSERT INTO `access_log` VALUES (2227, 'b1d69960-628a-4ff4-b81b-bf7ea80c244a', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:18', 61, 0, '', '2019-05-15 22:52:18');
INSERT INTO `access_log` VALUES (2228, 'dc1ba006-17e7-4d4a-968d-649e51221ad4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:20', 41, 0, '', '2019-05-15 22:52:20');
INSERT INTO `access_log` VALUES (2229, '3939836c-4d6a-45cd-86d7-e8fa2383b369', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:20', 37, 0, '', '2019-05-15 22:52:20');
INSERT INTO `access_log` VALUES (2230, '308fcbc6-33fc-4eb4-9bdf-78c44f841488', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:20', 40, 0, '', '2019-05-15 22:52:20');
INSERT INTO `access_log` VALUES (2231, '6c2f70e4-573b-4a9c-aa5f-2c45682385f2', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:20', 43, 0, '', '2019-05-15 22:52:20');
INSERT INTO `access_log` VALUES (2232, 'f0299995-c3e8-49b0-8938-cf5e66649819', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:33', 27, 0, '', '2019-05-15 22:52:33');
INSERT INTO `access_log` VALUES (2233, '3ce10400-9ab5-457c-8c75-a9831bd26dbf', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:33', 40, 0, '', '2019-05-15 22:52:33');
INSERT INTO `access_log` VALUES (2234, '9e0f211f-8d6d-4bf4-8d64-33a5fd22311c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:33', 26, 0, '', '2019-05-15 22:52:33');
INSERT INTO `access_log` VALUES (2235, 'e9d5ce79-7e7b-4cc5-ad57-db11df517c40', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:33', 36, 0, '', '2019-05-15 22:52:33');
INSERT INTO `access_log` VALUES (2236, 'b76588fe-882a-4e5f-99af-88ff0af07038', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:35', 37, 0, '', '2019-05-15 22:52:35');
INSERT INTO `access_log` VALUES (2237, '75fdb37a-9c2b-4a40-88b1-60b1ba16fb14', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:35', 33, 0, '', '2019-05-15 22:52:35');
INSERT INTO `access_log` VALUES (2238, '3fa573b7-5cc6-4c80-bab6-f95f3ca33f8a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:35', 36, 0, '', '2019-05-15 22:52:35');
INSERT INTO `access_log` VALUES (2239, 'fd0df3a0-c891-4713-b41e-543f6f42db05', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:35', 56, 0, '', '2019-05-15 22:52:35');
INSERT INTO `access_log` VALUES (2240, '91ea9e88-ea74-4def-a456-7df93d678b2c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:45', 270, 0, '', '2019-05-15 22:52:45');
INSERT INTO `access_log` VALUES (2241, '8a3d2749-4a29-4286-98dd-16156f729583', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:45', 266, 0, '', '2019-05-15 22:52:45');
INSERT INTO `access_log` VALUES (2242, '817fc153-b1d1-4f45-8c4d-19289dff6d62', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:45', 157, 0, '', '2019-05-15 22:52:45');
INSERT INTO `access_log` VALUES (2243, '54edb182-5012-407b-9725-93cf4fdd781d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:45', 270, 0, '', '2019-05-15 22:52:45');
INSERT INTO `access_log` VALUES (2244, '9cc1c4fa-39d9-4fa2-82ba-cefd92fc5256', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:57', 38, 0, '', '2019-05-15 22:52:57');
INSERT INTO `access_log` VALUES (2245, 'eed5bdae-d99d-4403-907a-fe4579349b2c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:57', 39, 0, '', '2019-05-15 22:52:57');
INSERT INTO `access_log` VALUES (2246, '203f17fd-180e-4935-8de7-050be9625430', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:57', 41, 0, '', '2019-05-15 22:52:57');
INSERT INTO `access_log` VALUES (2247, '639c2e3e-b8b4-4b1f-82e6-0f7031cd53ee', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:52:58', 759, 0, '', '2019-05-15 22:52:58');
INSERT INTO `access_log` VALUES (2248, '8f579133-535c-4577-8a6d-233d9b4cc0e8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:01', 43, 0, '', '2019-05-15 22:53:01');
INSERT INTO `access_log` VALUES (2249, 'a89883d7-e0a1-4651-9771-0975e117e032', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:02', 37, 0, '', '2019-05-15 22:53:02');
INSERT INTO `access_log` VALUES (2250, 'a68c5f9d-cf77-4bbe-b4b9-ba823305e232', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:02', 59, 0, '', '2019-05-15 22:53:02');
INSERT INTO `access_log` VALUES (2251, '548b3902-0d0a-469d-a2bb-219ed96409f2', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:03', 36, 0, '', '2019-05-15 22:53:03');
INSERT INTO `access_log` VALUES (2252, '4d8ea6c6-67e2-4108-966d-a56b5099b482', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:05', 34, 0, '', '2019-05-15 22:53:05');
INSERT INTO `access_log` VALUES (2253, '79bf23f9-6a60-4739-a07b-3fd5a430c4d7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:05', 31, 0, '', '2019-05-15 22:53:05');
INSERT INTO `access_log` VALUES (2254, '4743bccb-2dd2-4468-b648-a7dada6b0a43', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:05', 46, 0, '', '2019-05-15 22:53:05');
INSERT INTO `access_log` VALUES (2255, '1e635e12-d242-404f-bfbe-7353a6de6d7c', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:05', 29, 0, '', '2019-05-15 22:53:05');
INSERT INTO `access_log` VALUES (2256, 'a4bc405a-4c8b-409a-950b-d3acf02f09e8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:50', 760, 0, '', '2019-05-15 22:53:51');
INSERT INTO `access_log` VALUES (2257, 'af5db980-ea94-4f3e-b722-63174f77fab6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:50', 761, 0, '', '2019-05-15 22:53:51');
INSERT INTO `access_log` VALUES (2258, '1b646168-3d4a-4a3a-b2d2-31451325fbc9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:50', 785, 0, '', '2019-05-15 22:53:51');
INSERT INTO `access_log` VALUES (2259, '9258c3b6-0631-4a0e-9d32-aace3a5f046c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:52', 37, 0, '', '2019-05-15 22:53:52');
INSERT INTO `access_log` VALUES (2260, '70de5342-bd01-45fa-923c-21fcac9b96bf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:52', 33, 0, '', '2019-05-15 22:53:52');
INSERT INTO `access_log` VALUES (2261, '07718932-c7ee-48b9-9e53-2dc219f9f2d8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:52', 41, 0, '', '2019-05-15 22:53:52');
INSERT INTO `access_log` VALUES (2262, '8a7442d3-7439-42b8-b9a0-eb3a79510aeb', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:53:52', 35, 0, '', '2019-05-15 22:53:52');
INSERT INTO `access_log` VALUES (2263, 'e969b725-e8c5-45a0-9d88-fbaf938f6df8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:08', 40, 0, '', '2019-05-15 22:54:08');
INSERT INTO `access_log` VALUES (2264, 'ace7d522-19bb-4757-9666-3f86fc9b87a0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:08', 43, 0, '', '2019-05-15 22:54:08');
INSERT INTO `access_log` VALUES (2265, '7e4059d3-e374-4a89-9f4e-5f8671ffb3ba', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:08', 46, 0, '', '2019-05-15 22:54:08');
INSERT INTO `access_log` VALUES (2266, '4259dbcf-fc99-412f-9631-ccb9f61c2ead', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:08', 33, 0, '', '2019-05-15 22:54:08');
INSERT INTO `access_log` VALUES (2267, '7f0d0514-9651-4c19-ade8-7ee21ad3a61c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:15', 38, 0, '', '2019-05-15 22:54:15');
INSERT INTO `access_log` VALUES (2268, 'df4803ea-5a1a-4e47-aa3f-b33738437fe7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:15', 42, 0, '', '2019-05-15 22:54:15');
INSERT INTO `access_log` VALUES (2269, '3a016868-9c6b-4ad4-affd-037b649053f5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:15', 47, 0, '', '2019-05-15 22:54:15');
INSERT INTO `access_log` VALUES (2270, '22cb19b4-7434-4b93-8806-833d650decaf', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:15', 143, 0, '', '2019-05-15 22:54:15');
INSERT INTO `access_log` VALUES (2271, 'b49c5b06-ee39-4909-94d6-1895f2ec2da3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:33', 32, 0, '', '2019-05-15 22:54:33');
INSERT INTO `access_log` VALUES (2272, '03f638b1-15df-4af4-85f6-aa2c1c401d93', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:33', 49, 0, '', '2019-05-15 22:54:33');
INSERT INTO `access_log` VALUES (2273, '5c46cc20-df14-4a51-a03c-425ec33ecc49', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:33', 49, 0, '', '2019-05-15 22:54:33');
INSERT INTO `access_log` VALUES (2274, '08fc0a0a-d200-4624-8aeb-c0ed9da79130', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:34', 52, 0, '', '2019-05-15 22:54:34');
INSERT INTO `access_log` VALUES (2275, 'fc9e95bd-01d3-476a-9c50-d42b0cf4c8bd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:36', 40, 0, '', '2019-05-15 22:54:36');
INSERT INTO `access_log` VALUES (2276, '53319556-b85b-4400-b17f-c2aac1ad7ba4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:36', 33, 0, '', '2019-05-15 22:54:36');
INSERT INTO `access_log` VALUES (2277, 'cfabe1c2-b2bc-43c8-8aed-68012bc1652e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:36', 33, 0, '', '2019-05-15 22:54:36');
INSERT INTO `access_log` VALUES (2278, '9702818f-9d79-4e11-b3ed-32e8299a8c6e', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:36', 31, 0, '', '2019-05-15 22:54:36');
INSERT INTO `access_log` VALUES (2279, '5b99a2ef-bb18-4eb7-8911-54426da4d656', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:41', 39, 0, '', '2019-05-15 22:54:41');
INSERT INTO `access_log` VALUES (2280, 'e311521e-bacd-4619-9ea8-7f2ef0dfa902', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:41', 38, 0, '', '2019-05-15 22:54:41');
INSERT INTO `access_log` VALUES (2281, 'e5182c16-fc3b-4a7f-a642-51883eff5cd4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:41', 57, 0, '', '2019-05-15 22:54:41');
INSERT INTO `access_log` VALUES (2282, 'b50c0b71-47ff-4e86-8232-bc1442fee139', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:41', 36, 0, '', '2019-05-15 22:54:41');
INSERT INTO `access_log` VALUES (2283, '054d1ef6-cc65-437e-a759-efc9cbe6b314', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:43', 27, 0, '', '2019-05-15 22:54:43');
INSERT INTO `access_log` VALUES (2284, '418c520b-5245-4199-a270-b67beb78d82d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:43', 31, 0, '', '2019-05-15 22:54:43');
INSERT INTO `access_log` VALUES (2285, '7f3d10a4-8bf7-4d6b-b7cd-58a03027724f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:43', 41, 0, '', '2019-05-15 22:54:43');
INSERT INTO `access_log` VALUES (2286, 'd4860a76-55fc-4f19-80aa-e1b1e10cdd94', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:44', 30, 0, '', '2019-05-15 22:54:44');
INSERT INTO `access_log` VALUES (2287, '2a55e8ac-2e9f-4971-9658-f5d63619649e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:56', 1607, 0, '', '2019-05-15 22:54:58');
INSERT INTO `access_log` VALUES (2288, 'e2079eaa-9dcd-4276-982f-4662e8d19c06', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:56', 1605, 0, '', '2019-05-15 22:54:58');
INSERT INTO `access_log` VALUES (2289, '538a991d-a58a-4920-8b26-0114a215405b', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:56', 1542, 0, '', '2019-05-15 22:54:58');
INSERT INTO `access_log` VALUES (2290, '8b68c888-dedf-44c4-84d5-2343eb646897', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:56', 1612, 0, '', '2019-05-15 22:54:58');
INSERT INTO `access_log` VALUES (2291, '50880318-268f-46b7-97d7-71fe8288a03b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:58', 31, 0, '', '2019-05-15 22:54:58');
INSERT INTO `access_log` VALUES (2292, '15f1fc44-7289-4915-9389-1d1bead5db11', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:58', 30, 0, '', '2019-05-15 22:54:58');
INSERT INTO `access_log` VALUES (2293, '24de470f-aadc-4125-9252-3abfaeacb070', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:58', 41, 0, '', '2019-05-15 22:54:58');
INSERT INTO `access_log` VALUES (2294, '0a618eb6-daaa-4a1a-80a7-e269cf7045a3', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:54:58', 45, 0, '', '2019-05-15 22:54:59');
INSERT INTO `access_log` VALUES (2295, '2fd119e0-2f2c-4d1d-a796-1a0eeed03db8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:56:55', 52, 0, '', '2019-05-15 22:56:55');
INSERT INTO `access_log` VALUES (2296, '50741297-bcc6-4eb8-bee7-befa0e5bc992', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:56:55', 49, 0, '', '2019-05-15 22:56:55');
INSERT INTO `access_log` VALUES (2297, 'b55bbbb3-15ba-45ca-97fc-f79138417fc8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:56:55', 65, 0, '', '2019-05-15 22:56:55');
INSERT INTO `access_log` VALUES (2298, '6fa13a1d-60ee-49fe-b455-499c56acff1e', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:56:56', 32, 0, '', '2019-05-15 22:56:56');
INSERT INTO `access_log` VALUES (2299, 'f42fb681-bef9-4f49-b398-c07f5d7b0749', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:56:58', 37, 0, '', '2019-05-15 22:56:58');
INSERT INTO `access_log` VALUES (2300, 'd4b954f0-f0a2-43c5-9d05-0b8a52d45629', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:56:58', 40, 0, '', '2019-05-15 22:56:58');
INSERT INTO `access_log` VALUES (2301, '735d3912-ae88-4997-be04-01472fe7705e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:56:58', 57, 0, '', '2019-05-15 22:56:58');
INSERT INTO `access_log` VALUES (2302, '4a8bfcd0-d1b1-4fcf-a4c4-6798683da5d5', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:56:58', 56, 0, '', '2019-05-15 22:56:59');
INSERT INTO `access_log` VALUES (2303, '55963822-65ec-4358-970e-38cd2bab7c71', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:20', 42, 0, '', '2019-05-15 23:01:20');
INSERT INTO `access_log` VALUES (2304, '3368c2be-8bde-4926-8189-0f0f8cf6d896', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:20', 382, 2001001000, '服务端发生异常', '2019-05-15 23:01:21');
INSERT INTO `access_log` VALUES (2305, 'd767a30e-4901-4c94-8d66-5b48ad544ad9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:20', 386, 2001001000, '服务端发生异常', '2019-05-15 23:01:21');
INSERT INTO `access_log` VALUES (2306, 'f845eadc-f140-4b7c-bf3f-79625cd8e4bb', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:22', 177, 2001001000, '服务端发生异常', '2019-05-15 23:01:22');
INSERT INTO `access_log` VALUES (2307, '3207d184-e9fb-4f41-be8d-beb643d7bcb2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:25', 69, 0, '', '2019-05-15 23:01:25');
INSERT INTO `access_log` VALUES (2308, 'de6e2d62-3af8-4be5-a383-221eb56d0d37', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:25', 482, 2001001000, '服务端发生异常', '2019-05-15 23:01:26');
INSERT INTO `access_log` VALUES (2309, '06aff637-4c3a-4c3d-bc4d-607668785db1', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:25', 390, 2001001000, '服务端发生异常', '2019-05-15 23:01:26');
INSERT INTO `access_log` VALUES (2310, '4cf759af-fce5-481a-9b23-bca3faba9ba0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:25', 482, 2001001000, '服务端发生异常', '2019-05-15 23:01:26');
INSERT INTO `access_log` VALUES (2311, '3b2ffc55-d628-4bf0-8d11-51e7c61462f5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:27', 46, 0, '', '2019-05-15 23:01:27');
INSERT INTO `access_log` VALUES (2312, 'aff76da8-5c04-4a7c-8c51-d8a88c5ce58d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:27', 236, 2001001000, '服务端发生异常', '2019-05-15 23:01:27');
INSERT INTO `access_log` VALUES (2313, '74c72036-a871-4812-b322-076ae5ad0938', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:27', 237, 2001001000, '服务端发生异常', '2019-05-15 23:01:27');
INSERT INTO `access_log` VALUES (2314, 'bcefeec5-debb-4bbb-8365-69cbfa58fac8', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:27', 239, 2001001000, '服务端发生异常', '2019-05-15 23:01:28');
INSERT INTO `access_log` VALUES (2315, '3c25891e-4c7f-423f-bdfd-b6555e5b2f11', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:37', 27, 0, '', '2019-05-15 23:01:37');
INSERT INTO `access_log` VALUES (2316, 'f15276e5-8067-4218-a20a-292a3ea5ba07', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:38', 166, 2001001000, '服务端发生异常', '2019-05-15 23:01:38');
INSERT INTO `access_log` VALUES (2317, '1c299397-e3e3-473e-9ca2-81af35e91e29', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:37', 268, 2001001000, '服务端发生异常', '2019-05-15 23:01:38');
INSERT INTO `access_log` VALUES (2318, '1ef4de9c-9e1c-47e0-951f-c70162e118e6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:37', 271, 2001001000, '服务端发生异常', '2019-05-15 23:01:38');
INSERT INTO `access_log` VALUES (2319, '9acd5b9a-825e-4dfd-85d2-681b87c99413', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:03:11', 57, 0, '', '2019-05-15 23:03:11');
INSERT INTO `access_log` VALUES (2320, '86669291-b653-40ff-b82d-82d88ec89339', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:03:11', 164, 2001001000, '服务端发生异常', '2019-05-15 23:03:11');
INSERT INTO `access_log` VALUES (2321, '363bedbf-1249-4fcf-bb08-1dc3af2b9ce6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:03:11', 202, 2001001000, '服务端发生异常', '2019-05-15 23:03:11');
INSERT INTO `access_log` VALUES (2322, '898c080d-d694-4549-9af8-6c806fa5fc21', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:03:11', 224, 2001001000, '服务端发生异常', '2019-05-15 23:03:11');
INSERT INTO `access_log` VALUES (2323, '7579d693-2548-4181-b41b-c8b89e674153', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:05:49', 720, 0, '', '2019-05-15 23:05:50');
INSERT INTO `access_log` VALUES (2324, '909d1527-93fb-4daf-bf9e-b94607db4b73', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:05:49', 1015, 2001001000, '服务端发生异常', '2019-05-15 23:05:50');
INSERT INTO `access_log` VALUES (2325, 'c1935aa2-5c8e-43ee-9fa7-3e97c530418c', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:05:49', 1015, 2001001000, '服务端发生异常', '2019-05-15 23:05:50');
INSERT INTO `access_log` VALUES (2326, '3ff08ace-fc5e-4753-b0ef-6548b3b7460f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:05:49', 1015, 2001001000, '服务端发生异常', '2019-05-15 23:05:50');
INSERT INTO `access_log` VALUES (2327, 'ae9cba94-d3ab-44df-a7a8-168f62152fdd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:05:51', 53, 0, '', '2019-05-15 23:05:51');
INSERT INTO `access_log` VALUES (2328, 'eeb39f23-0000-450d-83b4-1ff2a14af654', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:05:51', 169, 2001001000, '服务端发生异常', '2019-05-15 23:05:51');
INSERT INTO `access_log` VALUES (2329, '8cd24d11-6e17-4507-8e7f-91f7ccfafa25', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:05:51', 219, 2001001000, '服务端发生异常', '2019-05-15 23:05:51');
INSERT INTO `access_log` VALUES (2330, '5517e64c-ee67-4b7d-888b-f5bca4eadbe5', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:05:51', 193, 2001001000, '服务端发生异常', '2019-05-15 23:05:51');
INSERT INTO `access_log` VALUES (2331, 'a3992dbd-686b-4222-b887-f6d18f3c01f3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:06:54', 546, 0, '', '2019-05-15 23:06:55');
INSERT INTO `access_log` VALUES (2332, 'ab24b511-d5db-41e2-a2ad-26037d86e790', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:06:54', 546, 0, '', '2019-05-15 23:06:55');
INSERT INTO `access_log` VALUES (2333, 'de02f590-fe32-465a-9f24-f03f298f3d9b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:06:54', 982, 2001001000, '服务端发生异常', '2019-05-15 23:06:55');
INSERT INTO `access_log` VALUES (2334, 'e37f504f-6dc9-4419-a410-d0b017ab7eb7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:06:54', 982, 2001001000, '服务端发生异常', '2019-05-15 23:06:55');
INSERT INTO `access_log` VALUES (2335, '37d1307c-1e23-42ce-a77c-cd421092e28a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:06:57', 43, 0, '', '2019-05-15 23:06:57');
INSERT INTO `access_log` VALUES (2336, 'd9fb5c6b-a188-4859-a522-2e82465451fc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:06:57', 453, 2001001000, '服务端发生异常', '2019-05-15 23:06:58');
INSERT INTO `access_log` VALUES (2337, '1682b7ef-cac5-4a74-9e8a-bcd97472f63a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:06:57', 450, 2001001000, '服务端发生异常', '2019-05-15 23:06:58');
INSERT INTO `access_log` VALUES (2338, '2b4b46e0-b458-4456-ab72-577437fc8c60', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:06:57', 379, 0, '', '2019-05-15 23:06:58');
INSERT INTO `access_log` VALUES (2339, '452bdb20-da01-42ad-9099-c50aacdc97a0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:07:39', 33, 0, '', '2019-05-15 23:07:39');
INSERT INTO `access_log` VALUES (2340, '23667e36-1b1f-46fa-9c8a-b93b5e102cc4', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:07:39', 54, 0, '', '2019-05-15 23:07:39');
INSERT INTO `access_log` VALUES (2341, '531eafba-c69e-4bc9-99db-8ba7b4ad7bb1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:07:39', 179, 2001001000, '服务端发生异常', '2019-05-15 23:07:39');
INSERT INTO `access_log` VALUES (2342, '806fe802-cd69-405f-b3b1-83841fbac757', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:07:39', 218, 2001001000, '服务端发生异常', '2019-05-15 23:07:39');
INSERT INTO `access_log` VALUES (2343, 'f8632ee1-0562-4625-9bcb-2e02e1fcd539', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:25', 49, 0, '', '2019-05-15 23:08:25');
INSERT INTO `access_log` VALUES (2344, '13482b9c-6f2e-4620-93b8-0cfb570646ef', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:25', 185, 0, '', '2019-05-15 23:08:25');
INSERT INTO `access_log` VALUES (2345, '4620d58a-d7e4-44a7-b91c-6fbea9905a36', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:25', 420, 2001001000, '服务端发生异常', '2019-05-15 23:08:25');
INSERT INTO `access_log` VALUES (2346, 'd95a023e-2f12-4dfc-aea5-86ffe2350171', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:25', 422, 2001001000, '服务端发生异常', '2019-05-15 23:08:25');
INSERT INTO `access_log` VALUES (2347, '3aa379b5-028b-4a10-88e7-c5b0193ead8c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:27', 136, 0, '', '2019-05-15 23:08:27');
INSERT INTO `access_log` VALUES (2348, '314f957a-76fc-472c-b849-3e1e8f09c580', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:27', 68, 0, '', '2019-05-15 23:08:27');
INSERT INTO `access_log` VALUES (2349, '09e5a0a1-79fd-4f0c-a469-86a80ed400c6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:27', 270, 2001001000, '服务端发生异常', '2019-05-15 23:08:27');
INSERT INTO `access_log` VALUES (2350, '2c606558-39cf-4e2e-8daa-34a57e07f47c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:27', 317, 2001001000, '服务端发生异常', '2019-05-15 23:08:27');
INSERT INTO `access_log` VALUES (2351, '474ba1ff-b165-4276-83a7-f058edcbaacf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:43', 35, 0, '', '2019-05-15 23:08:43');
INSERT INTO `access_log` VALUES (2352, '81341fea-c5a5-4021-abd7-343921fbef7c', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:43', 45, 0, '', '2019-05-15 23:08:43');
INSERT INTO `access_log` VALUES (2353, '67203432-bde2-4a7b-894c-ee6cf5c69fb3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:43', 140, 2001001000, '服务端发生异常', '2019-05-15 23:08:43');
INSERT INTO `access_log` VALUES (2354, '58f2e24f-3cb3-4e18-8d4a-d79ae1efc6d2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:43', 188, 2001001000, '服务端发生异常', '2019-05-15 23:08:43');
INSERT INTO `access_log` VALUES (2355, '8b6745f6-378d-49ab-a3ee-d7062e5405c2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:09:14', 39, 0, '', '2019-05-15 23:09:14');
INSERT INTO `access_log` VALUES (2356, '4fd22a48-2e32-4d9d-ba92-446f2fab984e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:09:14', 259, 2001001000, '服务端发生异常', '2019-05-15 23:09:14');
INSERT INTO `access_log` VALUES (2357, '4fdb67f0-ccba-405c-b863-daa7a4f536b2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:09:14', 325, 2001001000, '服务端发生异常', '2019-05-15 23:09:14');
INSERT INTO `access_log` VALUES (2358, '08eca7db-bb17-4c5d-8ea8-7d61fd2d0ac9', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:09:14', 34, 0, '', '2019-05-15 23:09:14');
INSERT INTO `access_log` VALUES (2359, '2b2860be-1aa0-4fd0-80a7-fea8a857f9bf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:10:52', 43, 0, '', '2019-05-15 23:10:52');
INSERT INTO `access_log` VALUES (2360, 'd5710d48-ffd2-4234-bb10-a67685a150b6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:10:52', 310, 2001001000, '服务端发生异常', '2019-05-15 23:10:52');
INSERT INTO `access_log` VALUES (2361, '3eb4d665-d390-4e93-82e2-ea4a69321ffd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:10:52', 351, 2001001000, '服务端发生异常', '2019-05-15 23:10:52');
INSERT INTO `access_log` VALUES (2362, '8122975c-d741-4652-8058-6c1b7b8bce7e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:06', 26, 0, '', '2019-05-15 23:11:06');
INSERT INTO `access_log` VALUES (2363, '5a7905a7-5ec7-4d99-8f5c-9fb687a72ccf', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:06', 40, 0, '', '2019-05-15 23:11:06');
INSERT INTO `access_log` VALUES (2364, 'a863903b-1c9b-4eaa-87ac-69f339aa999e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:06', 146, 2001001000, '服务端发生异常', '2019-05-15 23:11:06');
INSERT INTO `access_log` VALUES (2365, '8679793d-5592-4475-914a-437e142cf9bc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:06', 195, 2001001000, '服务端发生异常', '2019-05-15 23:11:06');
INSERT INTO `access_log` VALUES (2366, '12ee3128-0965-42dd-8960-82db15231c0b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:06', 66, 0, '', '2019-05-15 23:11:07');
INSERT INTO `access_log` VALUES (2367, 'c84a20dd-43ed-4a9c-8e28-ab5f1ba1511e', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:07', 48, 0, '', '2019-05-15 23:11:07');
INSERT INTO `access_log` VALUES (2368, 'c7349a4e-c2d3-4688-91ae-c328a6496037', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:06', 237, 2001001000, '服务端发生异常', '2019-05-15 23:11:07');
INSERT INTO `access_log` VALUES (2369, '6f7ef2f2-b3ca-49ef-856a-59096f297350', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:06', 284, 2001001000, '服务端发生异常', '2019-05-15 23:11:07');
INSERT INTO `access_log` VALUES (2370, '4105c8c6-1a2c-4db3-bfad-90acf843b9a9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:12', 63, 0, '', '2019-05-15 23:11:12');
INSERT INTO `access_log` VALUES (2371, '2af489e5-e349-4588-a539-1ede0528c783', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:12', 210, 2001001000, '服务端发生异常', '2019-05-15 23:11:12');
INSERT INTO `access_log` VALUES (2372, '04d2412a-78a0-4fe6-824b-da659f929a54', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:12', 478, 2001001000, '服务端发生异常', '2019-05-15 23:11:13');
INSERT INTO `access_log` VALUES (2373, '2d1c1e40-ced9-4954-bca1-eca30c46381f', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:14', 40, 0, '', '2019-05-15 23:11:14');
INSERT INTO `access_log` VALUES (2374, 'c03464ef-62b9-4ce9-8d4a-00be2d9b8eb8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:15', 34, 0, '', '2019-05-15 23:11:15');
INSERT INTO `access_log` VALUES (2375, '733f4765-025b-408f-a1b8-241fa4f6de66', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:15', 403, 2001001000, '服务端发生异常', '2019-05-15 23:11:15');
INSERT INTO `access_log` VALUES (2376, 'd8652a7f-f14d-446a-82c5-bb441dec6869', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:15', 307, 0, '', '2019-05-15 23:11:15');
INSERT INTO `access_log` VALUES (2377, '636e5d29-b31f-419c-a6ff-85e006e79120', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:15', 522, 2001001000, '服务端发生异常', '2019-05-15 23:11:15');
INSERT INTO `access_log` VALUES (2378, 'b52731f9-f53a-4d11-beaa-704e958003f6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:20', 68, 0, '', '2019-05-15 23:11:21');
INSERT INTO `access_log` VALUES (2379, 'b26723be-0542-466e-aafd-a9e5582c581d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:20', 302, 2001001000, '服务端发生异常', '2019-05-15 23:11:21');
INSERT INTO `access_log` VALUES (2380, '5477498f-61f6-4d2c-8a2a-3b30178070e4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:20', 305, 2001001000, '服务端发生异常', '2019-05-15 23:11:21');
INSERT INTO `access_log` VALUES (2381, '64c8690c-66f8-41fb-a90e-7c68a7271ae9', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:21', 43, 0, '', '2019-05-15 23:11:21');
INSERT INTO `access_log` VALUES (2382, '03b00037-6b70-4135-b99c-245469c74fa3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:24', 44, 0, '', '2019-05-15 23:11:24');
INSERT INTO `access_log` VALUES (2383, '2bc9bc1a-5a57-4bc5-9f6e-01259070d1f7', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:24', 75, 0, '', '2019-05-15 23:11:24');
INSERT INTO `access_log` VALUES (2384, '990d406a-eabf-4da6-8716-16025ff80f72', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:24', 204, 2001001000, '服务端发生异常', '2019-05-15 23:11:24');
INSERT INTO `access_log` VALUES (2385, 'fc21ad73-87d4-4af9-bfe0-0e370c0ba60a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:24', 242, 2001001000, '服务端发生异常', '2019-05-15 23:11:24');
INSERT INTO `access_log` VALUES (2386, 'ad37d9cb-9521-4db2-82ca-8156f4f5fdbc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:25', 38, 0, '', '2019-05-15 23:11:25');
INSERT INTO `access_log` VALUES (2387, 'f081770f-ff23-4e5b-81a4-f38780519bd6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:25', 1198, 2001001000, '服务端发生异常', '2019-05-15 23:11:26');
INSERT INTO `access_log` VALUES (2388, '803ab30b-c0e0-49a9-b3c4-deefd5c5a5bf', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:25', 1191, 2001001000, '服务端发生异常', '2019-05-15 23:11:26');
INSERT INTO `access_log` VALUES (2389, 'c501b94a-e9f9-4d6e-ac80-ad329818eaff', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:25', 1107, 0, '', '2019-05-15 23:11:26');
INSERT INTO `access_log` VALUES (2390, '5f7ad764-64ad-4848-95db-d89c38333de1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:41', 34, 0, '', '2019-05-15 23:11:41');
INSERT INTO `access_log` VALUES (2391, '1c04fdf5-74f2-4918-be68-84e71f864bc5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:41', 204, 2001001000, '服务端发生异常', '2019-05-15 23:11:42');
INSERT INTO `access_log` VALUES (2392, 'a1245632-bfc2-43ba-9d17-6f029e14f8e6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:41', 207, 2001001000, '服务端发生异常', '2019-05-15 23:11:42');
INSERT INTO `access_log` VALUES (2393, 'ff2c00cf-df52-44a7-afda-2aa5581957e6', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:42', 64, 0, '', '2019-05-15 23:11:42');
INSERT INTO `access_log` VALUES (2394, 'a670ff61-8732-46fc-8b4e-02cc04793be4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:47', 29, 0, '', '2019-05-15 23:11:47');
INSERT INTO `access_log` VALUES (2395, '35528f07-6258-4f0b-be14-3f99041ce7da', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:47', 297, 0, '', '2019-05-15 23:11:47');
INSERT INTO `access_log` VALUES (2396, '92cac0c4-0953-4915-bd56-3873aa6797c7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:47', 503, 2001001000, '服务端发生异常', '2019-05-15 23:11:47');
INSERT INTO `access_log` VALUES (2397, '88b0a810-73cb-4710-b504-a5421b918fe5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:47', 500, 2001001000, '服务端发生异常', '2019-05-15 23:11:47');
INSERT INTO `access_log` VALUES (2398, 'afdf3181-3ea2-4200-9736-215ecda5186f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:52', 49, 0, '', '2019-05-15 23:11:52');
INSERT INTO `access_log` VALUES (2399, '0c0adbc6-e7ff-4251-a4eb-cb17daffe51f', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:52', 26, 0, '', '2019-05-15 23:11:52');
INSERT INTO `access_log` VALUES (2400, 'd1546a67-0762-4765-99a9-bf0091c77cd6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:52', 220, 2001001000, '服务端发生异常', '2019-05-15 23:11:52');
INSERT INTO `access_log` VALUES (2401, '9d25e378-257e-4859-aaad-4181fc213b36', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:52', 224, 2001001000, '服务端发生异常', '2019-05-15 23:11:52');
INSERT INTO `access_log` VALUES (2402, 'a7f3e0c6-9886-4f27-9af1-ba03b1a57ab9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:53', 45, 0, '', '2019-05-15 23:11:53');
INSERT INTO `access_log` VALUES (2403, '31a78d5d-4da9-4f1d-8ca7-5b22410a4e2d', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:53', 48, 0, '', '2019-05-15 23:11:53');
INSERT INTO `access_log` VALUES (2404, '5b1c59b8-5cad-4393-a215-f03b9ae4557e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:53', 247, 2001001000, '服务端发生异常', '2019-05-15 23:11:53');
INSERT INTO `access_log` VALUES (2405, '32c75804-bd96-48dc-8e49-df9172046288', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:53', 246, 2001001000, '服务端发生异常', '2019-05-15 23:11:53');
INSERT INTO `access_log` VALUES (2406, '506c9872-0953-423f-b05d-4b16d102cf35', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:12:28', 41, 0, '', '2019-05-15 23:12:28');
INSERT INTO `access_log` VALUES (2407, '408afb94-2960-4107-a2dc-067f777d46b9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:12:28', 369, 2001001000, '服务端发生异常', '2019-05-15 23:12:29');
INSERT INTO `access_log` VALUES (2408, '3576b24d-d5a7-4480-b8dd-3affccebca07', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:12:28', 534, 0, '', '2019-05-15 23:12:29');
INSERT INTO `access_log` VALUES (2409, 'bd832b3c-d6cb-45f4-9ea9-3724e3a2da8c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:12:28', 733, 2001001000, '服务端发生异常', '2019-05-15 23:12:29');
INSERT INTO `access_log` VALUES (2410, 'e1919cb9-c57f-46b9-8583-6a46a2314b0a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:13:59', 93, 0, '', '2019-05-15 23:14:00');
INSERT INTO `access_log` VALUES (2411, '8891983e-5e0d-40e2-ad98-d9132e8c24cb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:13:59', 230, 2001001000, '服务端发生异常', '2019-05-15 23:14:00');
INSERT INTO `access_log` VALUES (2412, 'e58a4a9e-a78a-4506-baa5-c58fc873723f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:13:59', 228, 2001001000, '服务端发生异常', '2019-05-15 23:14:00');
INSERT INTO `access_log` VALUES (2413, 'e787594a-0dff-45a2-9bfa-41eed271cecd', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:14:00', 35, 0, '', '2019-05-15 23:14:00');
INSERT INTO `access_log` VALUES (2414, 'edd8e697-fb09-4319-a2f5-90b9b472cf86', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:14:04', 35, 0, '', '2019-05-15 23:14:04');
INSERT INTO `access_log` VALUES (2415, '1bccb6ad-6b80-4f83-98f9-150b1350ed17', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:14:04', 81, 0, '', '2019-05-15 23:14:04');
INSERT INTO `access_log` VALUES (2416, '9d95ec76-9ee1-484f-b738-4623805c04ad', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:14:04', 250, 2001001000, '服务端发生异常', '2019-05-15 23:14:04');
INSERT INTO `access_log` VALUES (2417, '0b4eff1f-3aa4-4d1a-b20d-2f717edbc2bb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:14:04', 248, 2001001000, '服务端发生异常', '2019-05-15 23:14:04');
INSERT INTO `access_log` VALUES (2418, '2ec36b3e-540f-4c76-8668-7a4b86434c2c', 0, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=33&type=1&sort=2&displayName=店铺资产&createTime=2019-05-02T16:02:57.000+0000&pid=0&children[0][id]=44&children[0][name]=&children[0][type]=1&children[0][sort]=1&children[0][displayName]=支付单&children[0][createTime]=2019-05-08T06:17:15.000+0000&children[0][pid]=33&children[0][handler]=/pay/transaction-list&children[0][children]=&children[1][id]=45&children[1][name]=&children[1][type]=1&children[1][sort]=2&children[1][displayName]=退款单&children[1][createTime]=2019-05-08T08:58:05.000+0000&children[1][pid]=33&children[1][handler]=/pay/refund-list&children[1][children]=&icon=money-collect', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:35', 22, 1002001012, '访问令牌已过期', '2019-05-15 23:18:35');
INSERT INTO `access_log` VALUES (2419, 'a27b2a0e-108f-4e25-937b-a77167eeb2a8', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:36', 10, 1002001012, '访问令牌已过期', '2019-05-15 23:18:36');
INSERT INTO `access_log` VALUES (2420, '418ff89a-cbfa-4765-b319-003dad987f3e', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:37', 482, 0, '', '2019-05-15 23:18:38');
INSERT INTO `access_log` VALUES (2421, 'ce1eea80-16c8-49f8-aaf7-c9fe6e6cff40', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:38', 87, 0, '', '2019-05-15 23:18:38');
INSERT INTO `access_log` VALUES (2422, '85643c3f-5b3e-4db1-9425-45a14d7fd44a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:38', 220, 2001001000, '服务端发生异常', '2019-05-15 23:18:38');
INSERT INTO `access_log` VALUES (2423, 'a0c4cfff-81e9-4fe8-a89c-fe5e7538953a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:38', 269, 2001001000, '服务端发生异常', '2019-05-15 23:18:38');
INSERT INTO `access_log` VALUES (2424, 'a7936ed7-644b-460e-ac56-1a5181e0ddb6', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:41', 29, 0, '', '2019-05-15 23:18:41');
INSERT INTO `access_log` VALUES (2425, 'cb194860-f6a3-4cc6-b63e-990ca3e94a98', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:40', 185, 0, '', '2019-05-15 23:18:41');
INSERT INTO `access_log` VALUES (2426, '0c1341b9-dd95-4abd-acc3-34a7f66828bc', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=33&type=1&sort=2&displayName=店铺资产&createTime=2019-05-02T16:02:57.000+0000&pid=0&children[0][id]=44&children[0][name]=&children[0][type]=1&children[0][sort]=1&children[0][displayName]=支付单&children[0][createTime]=2019-05-08T06:17:15.000+0000&children[0][pid]=33&children[0][handler]=/pay/transaction-list&children[0][children]=&children[1][id]=45&children[1][name]=&children[1][type]=1&children[1][sort]=2&children[1][displayName]=退款单&children[1][createTime]=2019-05-08T08:58:05.000+0000&children[1][pid]=33&children[1][handler]=/pay/refund-list&children[1][children]=&icon=money-collect', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:48', 332, 2001001000, '服务端发生异常', '2019-05-15 23:18:48');
INSERT INTO `access_log` VALUES (2427, '42e7802b-0a37-4170-a729-eb7b8491410f', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:48', 61, 0, '', '2019-05-15 23:18:48');
INSERT INTO `access_log` VALUES (2428, '5e78eda3-3614-43ed-82ff-3ed2a100b35b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:51', 76, 0, '', '2019-05-15 23:18:51');
INSERT INTO `access_log` VALUES (2429, 'fe736364-4233-411a-9bde-f17f2f375164', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:51', 69, 0, '', '2019-05-15 23:18:51');
INSERT INTO `access_log` VALUES (2430, 'fc9a2b1e-5da1-4479-a228-069d6610c1c1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:51', 190, 2001001000, '服务端发生异常', '2019-05-15 23:18:51');
INSERT INTO `access_log` VALUES (2431, '05b1de85-54c0-4631-8c5d-5d988f427533', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:51', 193, 2001001000, '服务端发生异常', '2019-05-15 23:18:51');
INSERT INTO `access_log` VALUES (2432, '4ea29c37-4396-4cab-b9a6-27b6e6b2ac14', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=33&type=1&sort=2&displayName=店铺资产&createTime=2019-05-02T16:02:57.000+0000&pid=0&children[0][id]=44&children[0][name]=&children[0][type]=1&children[0][sort]=1&children[0][displayName]=支付单&children[0][createTime]=2019-05-08T06:17:15.000+0000&children[0][pid]=33&children[0][handler]=/pay/transaction-list&children[0][children]=&children[1][id]=45&children[1][name]=&children[1][type]=1&children[1][sort]=2&children[1][displayName]=退款单&children[1][createTime]=2019-05-08T08:58:05.000+0000&children[1][pid]=33&children[1][handler]=/pay/refund-list&children[1][children]=&icon=money-collect', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:20:35', 254, 2001001000, '服务端发生异常', '2019-05-15 23:20:35');
INSERT INTO `access_log` VALUES (2433, '6e3b1d64-f965-470b-a0ab-2c4160f14ec0', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:20:35', 52, 0, '', '2019-05-15 23:20:35');
INSERT INTO `access_log` VALUES (2434, '2d83e9ce-a43f-428f-993f-889e0c3c74e3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:22:06', 371, 0, '', '2019-05-15 23:22:07');
INSERT INTO `access_log` VALUES (2435, '8958b36c-9547-4ac9-9825-5a55be74b67b', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:22:06', 371, 0, '', '2019-05-15 23:22:07');
INSERT INTO `access_log` VALUES (2436, '3027bd3f-5ffc-4db0-a36c-74504f547368', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:22:06', 612, 2001001000, '服务端发生异常', '2019-05-15 23:22:07');
INSERT INTO `access_log` VALUES (2437, '4422ddd6-6926-4855-b84c-8d89bde31e39', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:22:06', 1075, 2001001000, '服务端发生异常', '2019-05-15 23:22:07');
INSERT INTO `access_log` VALUES (2438, '3bd2f074-558d-4f3f-8918-13e8a8f414c8', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=33&type=1&sort=2&displayName=店铺资产&createTime=2019-05-02T16:02:57.000+0000&pid=0&children[0][id]=44&children[0][name]=&children[0][type]=1&children[0][sort]=1&children[0][displayName]=支付单&children[0][createTime]=2019-05-08T06:17:15.000+0000&children[0][pid]=33&children[0][handler]=/pay/transaction-list&children[0][children]=&children[1][id]=45&children[1][name]=&children[1][type]=1&children[1][sort]=2&children[1][displayName]=退款单&children[1][createTime]=2019-05-08T08:58:05.000+0000&children[1][pid]=33&children[1][handler]=/pay/refund-list&children[1][children]=&icon=money-collect', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:23:21', 236, 0, '', '2019-05-15 23:23:21');
INSERT INTO `access_log` VALUES (2439, 'e4288347-dc0b-4d17-b4ee-7070ceb736c3', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:23:21', 54, 0, '', '2019-05-15 23:23:21');
INSERT INTO `access_log` VALUES (2440, 'b36b33f5-bfdc-4a31-b542-82d012a73990', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:23:30', 51, 0, '', '2019-05-15 23:23:30');
INSERT INTO `access_log` VALUES (2441, 'c7a98f56-4bd5-4e99-bab9-299cbb9d8fec', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:23:30', 51, 0, '', '2019-05-15 23:23:30');
INSERT INTO `access_log` VALUES (2442, 'f7fdf979-f1b8-44e4-9c6b-44163a29265e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:23:30', 219, 2001001000, '服务端发生异常', '2019-05-15 23:23:30');
INSERT INTO `access_log` VALUES (2443, '4598ced3-ffb1-4cde-ac11-56cbb849cf11', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:23:30', 224, 2001001000, '服务端发生异常', '2019-05-15 23:23:30');
INSERT INTO `access_log` VALUES (2444, '81cf53ca-ba13-497c-a9b6-879be9a923a5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:23:40', 62, 0, '', '2019-05-15 23:23:40');
INSERT INTO `access_log` VALUES (2445, 'c773d6dd-028e-441e-94c5-156aad797ced', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:23:40', 54, 0, '', '2019-05-15 23:23:40');
INSERT INTO `access_log` VALUES (2446, '569a9562-aa3a-4f18-8f43-1bc5bd1fce6d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:23:40', 253, 2001001000, '服务端发生异常', '2019-05-15 23:23:40');
INSERT INTO `access_log` VALUES (2447, '30f8c68e-3d26-413a-bb5d-1e5e1b93e46f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:23:40', 249, 2001001000, '服务端发生异常', '2019-05-15 23:23:40');
INSERT INTO `access_log` VALUES (2448, 'a37d39b7-d131-453e-bfe5-f2ceec040082', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:27:07', 210, 0, '', '2019-05-15 23:27:07');
INSERT INTO `access_log` VALUES (2449, 'c15cfaef-e9af-419a-9371-29169cd48a32', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:27:08', 45, 0, '', '2019-05-15 23:27:08');
INSERT INTO `access_log` VALUES (2450, 'f8008316-40d9-4403-9332-5e13cc66b7f2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:27:08', 222, 0, '', '2019-05-15 23:27:08');
INSERT INTO `access_log` VALUES (2451, 'e1e4d0b5-a5b2-4d56-af13-61825388323b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:27:08', 431, 2001001000, '服务端发生异常', '2019-05-15 23:27:08');
INSERT INTO `access_log` VALUES (2452, 'abfdf02d-08ce-4a78-9f11-d5c4a59a50f1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:27:08', 479, 2001001000, '服务端发生异常', '2019-05-15 23:27:08');
INSERT INTO `access_log` VALUES (2453, '79d54fcd-1934-44c5-b137-36b5a3d7cd9d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:13', 60, 0, '', '2019-05-15 23:28:13');
INSERT INTO `access_log` VALUES (2454, 'fe3f900f-080f-4bd7-a095-9dcdce8d7e7e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:13', 490, 2001001000, '服务端发生异常', '2019-05-15 23:28:14');
INSERT INTO `access_log` VALUES (2455, '2707af82-58ab-4936-89f3-410cfa5bc08c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:13', 492, 2001001000, '服务端发生异常', '2019-05-15 23:28:14');
INSERT INTO `access_log` VALUES (2456, '7d49dd34-d4a9-4639-ac1b-ad8751c1aabc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:20', 37, 0, '', '2019-05-15 23:28:20');
INSERT INTO `access_log` VALUES (2457, '4dc53cd4-a7f9-406c-92bd-d8db7dc4a451', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:20', 161, 2001001000, '服务端发生异常', '2019-05-15 23:28:21');
INSERT INTO `access_log` VALUES (2458, 'dfd71a18-fcef-49b2-939e-71f945b6d79c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:20', 164, 2001001000, '服务端发生异常', '2019-05-15 23:28:21');
INSERT INTO `access_log` VALUES (2459, 'f61f5967-b8bc-44b9-b5ff-ed1148110484', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:21', 50, 0, '', '2019-05-15 23:28:21');
INSERT INTO `access_log` VALUES (2460, 'e353d531-abbf-4fe2-9c7a-c54ea17cd0bd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:22', 40, 0, '', '2019-05-15 23:28:22');
INSERT INTO `access_log` VALUES (2461, '7ecf672c-7019-49b1-8682-8b777b9072c8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:22', 167, 2001001000, '服务端发生异常', '2019-05-15 23:28:22');
INSERT INTO `access_log` VALUES (2462, '697081cc-7733-492e-9de4-44ddda482bbf', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:22', 184, 2001001000, '服务端发生异常', '2019-05-15 23:28:22');
INSERT INTO `access_log` VALUES (2463, 'd489740e-17f5-40c7-931f-33019ea5b521', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:22', 46, 0, '', '2019-05-15 23:28:22');
INSERT INTO `access_log` VALUES (2464, 'a91e1368-56fd-41b3-8ea9-83e09c0ed8cd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:49', 36, 0, '', '2019-05-15 23:28:49');
INSERT INTO `access_log` VALUES (2465, '9d90e48b-c299-4ae1-9d71-f5795b6d505e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:49', 148, 2001001000, '服务端发生异常', '2019-05-15 23:28:49');
INSERT INTO `access_log` VALUES (2466, '5504ea4e-8230-477d-b769-9da56186562d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:49', 199, 2001001000, '服务端发生异常', '2019-05-15 23:28:49');
INSERT INTO `access_log` VALUES (2467, '99408484-95a5-40e3-aebc-51d9a1cd46cf', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:49', 31, 0, '', '2019-05-15 23:28:49');
INSERT INTO `access_log` VALUES (2468, '1e158096-aa57-452f-9ad7-da994148aa2b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:50', 35, 0, '', '2019-05-15 23:28:51');
INSERT INTO `access_log` VALUES (2469, '843aa1fa-993e-4bed-957f-4a2161849c0b', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:51', 47, 0, '', '2019-05-15 23:28:51');
INSERT INTO `access_log` VALUES (2470, '2679f84f-feb6-43be-9123-4b38452c15d0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:50', 174, 2001001000, '服务端发生异常', '2019-05-15 23:28:51');
INSERT INTO `access_log` VALUES (2471, 'f8a14041-f84d-4cf6-907b-f2d45f84d7b4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:50', 222, 2001001000, '服务端发生异常', '2019-05-15 23:28:51');
INSERT INTO `access_log` VALUES (2472, '9cdcc85a-778e-4409-93da-17e648dc0be3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:29:08', 108, 0, '', '2019-05-15 23:29:08');
INSERT INTO `access_log` VALUES (2473, 'b8c4e8ed-8c38-4df6-8827-d99025735c09', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:29:08', 197, 2001001000, '服务端发生异常', '2019-05-15 23:29:08');
INSERT INTO `access_log` VALUES (2474, '5ced7d55-b1ad-413d-8ad6-be37493a4bb0', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:29:08', 53, 0, '', '2019-05-15 23:29:08');
INSERT INTO `access_log` VALUES (2475, 'bd1551f5-6ab3-4d95-bb6d-14a0697dc6a6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:29:08', 299, 2001001000, '服务端发生异常', '2019-05-15 23:29:08');
INSERT INTO `access_log` VALUES (2476, '5c789978-57f6-48cc-ad14-a2cc7a76441b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:29:09', 48, 0, '', '2019-05-15 23:29:09');
INSERT INTO `access_log` VALUES (2477, 'b967861c-8335-42bf-959b-eb4953b17036', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:29:09', 112, 0, '', '2019-05-15 23:29:09');
INSERT INTO `access_log` VALUES (2478, 'e9ef9d42-435a-4eea-8508-3ef2178203e3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:29:09', 208, 2001001000, '服务端发生异常', '2019-05-15 23:29:09');
INSERT INTO `access_log` VALUES (2479, '900849b1-310b-43ea-8523-0ebab165fe7c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:29:09', 246, 2001001000, '服务端发生异常', '2019-05-15 23:29:10');
INSERT INTO `access_log` VALUES (2480, '35.74.15579343051700055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 23:31:45', 53, 0, '', '2019-05-15 23:31:45');
INSERT INTO `access_log` VALUES (2481, '35.75.15579343051710059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 23:31:45', 80, 0, '', '2019-05-15 23:31:45');
INSERT INTO `access_log` VALUES (2482, '37.70.15579343240110007', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 23:32:04', 3, 0, '', '2019-05-15 23:32:04');
INSERT INTO `access_log` VALUES (2483, '37.67.15579343240120005', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 23:32:04', 2, 0, '', '2019-05-15 23:32:04');
INSERT INTO `access_log` VALUES (2484, '37.69.15579343240140009', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-15 23:32:04', 33, 0, '', '2019-05-15 23:32:04');
INSERT INTO `access_log` VALUES (2485, '831244a8-41d5-4f4f-8cd3-e8b542aea391', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:10', 126, 0, '', '2019-05-15 23:35:10');
INSERT INTO `access_log` VALUES (2486, 'ed8303b8-0de6-4519-b4fd-49f6aad3a93b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:10', 325, 2001001000, '服务端发生异常', '2019-05-15 23:35:10');
INSERT INTO `access_log` VALUES (2487, 'b1c9a0f7-497d-4387-b442-edc5007a1a53', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:10', 322, 2001001000, '服务端发生异常', '2019-05-15 23:35:10');
INSERT INTO `access_log` VALUES (2488, 'a5a1b812-1838-42a9-a556-ab8a47270615', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:11', 39, 0, '', '2019-05-15 23:35:11');
INSERT INTO `access_log` VALUES (2489, 'ce9cee3e-5e4f-4103-8506-8193cae55fb9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:24', 38, 0, '', '2019-05-15 23:35:24');
INSERT INTO `access_log` VALUES (2490, '58279757-08d6-4ce8-890a-6772b344553f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:24', 187, 2001001000, '服务端发生异常', '2019-05-15 23:35:24');
INSERT INTO `access_log` VALUES (2491, 'd1aa2cae-b5ee-483f-9f35-e17d7bf26c30', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:24', 29, 0, '', '2019-05-15 23:35:24');
INSERT INTO `access_log` VALUES (2492, '035a7878-d1ea-4a8f-a28e-e13904fe8cc6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:24', 236, 2001001000, '服务端发生异常', '2019-05-15 23:35:24');
INSERT INTO `access_log` VALUES (2493, '0378c181-6d72-418c-aa5b-fd8140bc571e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:26', 31, 0, '', '2019-05-15 23:35:26');
INSERT INTO `access_log` VALUES (2494, '720d43b5-7931-4c5f-9def-312164ba43b3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:26', 386, 2001001000, '服务端发生异常', '2019-05-15 23:35:26');
INSERT INTO `access_log` VALUES (2495, '2c7e0f0f-e5e2-47a1-9554-2bca6e9925b0', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:26', 323, 0, '', '2019-05-15 23:35:26');
INSERT INTO `access_log` VALUES (2496, 'ce4fc6f6-8f4c-46f3-be5b-c674e2963ff6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:26', 453, 2001001000, '服务端发生异常', '2019-05-15 23:35:26');
INSERT INTO `access_log` VALUES (2497, 'f2994461-b232-405f-a254-c58bd3adc6f9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:39', 34, 0, '', '2019-05-15 23:35:39');
INSERT INTO `access_log` VALUES (2498, 'bde468d4-787b-4666-b1d7-32024cfedf8b', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:39', 69, 0, '', '2019-05-15 23:35:39');
INSERT INTO `access_log` VALUES (2499, 'e9419831-c020-4c43-ab4c-03f2377b2b7d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:39', 199, 2001001000, '服务端发生异常', '2019-05-15 23:35:39');
INSERT INTO `access_log` VALUES (2500, '2e720c07-513b-46d6-a78b-de039e3f5230', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:39', 242, 2001001000, '服务端发生异常', '2019-05-15 23:35:39');
INSERT INTO `access_log` VALUES (2501, '28f7eedd-1c8d-4361-a6d2-14f47fc3371f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:58', 59, 0, '', '2019-05-15 23:35:59');
INSERT INTO `access_log` VALUES (2502, 'cf9f86c9-12f2-44ed-9adc-c41c7ba7ac09', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:58', 210, 2001001000, '服务端发生异常', '2019-05-15 23:35:59');
INSERT INTO `access_log` VALUES (2503, 'ad72f57a-a383-46b4-a0a5-5a4f28fd3294', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:58', 210, 2001001000, '服务端发生异常', '2019-05-15 23:35:59');
INSERT INTO `access_log` VALUES (2504, 'f23fefe2-73c3-49e0-8af8-49465f852cc0', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:59', 50, 0, '', '2019-05-15 23:35:59');
INSERT INTO `access_log` VALUES (2505, '6237923a-44be-45f3-984d-694faca66b44', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:00', 30, 0, '', '2019-05-15 23:36:00');
INSERT INTO `access_log` VALUES (2506, '44dd8305-6407-44f0-bffc-ea0bdc29d68d', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:00', 48, 0, '', '2019-05-15 23:36:00');
INSERT INTO `access_log` VALUES (2507, '207363d8-834f-4d7e-aa42-054e5f93ebe9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:00', 187, 2001001000, '服务端发生异常', '2019-05-15 23:36:00');
INSERT INTO `access_log` VALUES (2508, 'c5ad19de-a3a5-434e-810d-caac64a0bc0f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:00', 250, 2001001000, '服务端发生异常', '2019-05-15 23:36:00');
INSERT INTO `access_log` VALUES (2509, '2d3ed246-446a-4f30-9cef-5032e5884571', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:11', 41, 0, '', '2019-05-15 23:36:11');
INSERT INTO `access_log` VALUES (2510, 'e3d49370-353e-445f-aded-747569484803', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:11', 71, 0, '', '2019-05-15 23:36:11');
INSERT INTO `access_log` VALUES (2511, 'b597ceac-fc22-4e15-a487-3391c714a8ee', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:11', 604, 2001001000, '服务端发生异常', '2019-05-15 23:36:12');
INSERT INTO `access_log` VALUES (2512, 'caaafc69-fe66-47bb-90ba-321efb54c92b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:11', 602, 2001001000, '服务端发生异常', '2019-05-15 23:36:12');
INSERT INTO `access_log` VALUES (2513, '176245e3-bdee-4fdb-86dc-c3a0a20d245e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:13', 33, 0, '', '2019-05-15 23:36:13');
INSERT INTO `access_log` VALUES (2514, '55012daf-345a-4a4e-9f98-2ec9267a6738', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:13', 139, 2001001000, '服务端发生异常', '2019-05-15 23:36:13');
INSERT INTO `access_log` VALUES (2515, '88461c59-ec69-41b0-93cc-bb093b0a7271', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:13', 25, 0, '', '2019-05-15 23:36:13');
INSERT INTO `access_log` VALUES (2516, '22c966f0-73aa-4cac-bdde-821986f6178c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:13', 184, 2001001000, '服务端发生异常', '2019-05-15 23:36:13');
INSERT INTO `access_log` VALUES (2517, '1cd5384f-b17d-4da0-bb20-022ac8dab056', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:20', 150, 0, '', '2019-05-15 23:36:21');
INSERT INTO `access_log` VALUES (2518, 'fd2fb057-4ecd-4c5e-a0c0-dd1ed6d7586b', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:21', 437, 0, '', '2019-05-15 23:36:21');
INSERT INTO `access_log` VALUES (2519, 'f2ecca85-f8a5-46bc-bdf0-8eba755b1b0a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:20', 598, 2001001000, '服务端发生异常', '2019-05-15 23:36:21');
INSERT INTO `access_log` VALUES (2520, '2174380f-199e-40eb-ac9b-c7a4c056dd9a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:20', 602, 2001001000, '服务端发生异常', '2019-05-15 23:36:21');
INSERT INTO `access_log` VALUES (2521, '472263c8-48a3-45f1-9c1f-0f6965e84549', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:37:54', 41, 0, '', '2019-05-15 23:37:54');
INSERT INTO `access_log` VALUES (2522, '479177fa-b1ee-4f0f-b536-42e812c108ad', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:37:54', 28, 0, '', '2019-05-15 23:37:54');
INSERT INTO `access_log` VALUES (2523, '3aa87678-c8ce-4e7e-b743-ef07a0e02c6b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:37:54', 205, 2001001000, '服务端发生异常', '2019-05-15 23:37:55');
INSERT INTO `access_log` VALUES (2524, '3085b382-79c3-409e-b7a3-3b628c98a96a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:37:54', 200, 2001001000, '服务端发生异常', '2019-05-15 23:37:55');
INSERT INTO `access_log` VALUES (2525, '531af3ad-9275-4a55-b890-7e561ba7d193', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:39:03', 136, 0, '', '2019-05-15 23:39:03');
INSERT INTO `access_log` VALUES (2526, '17bf8441-ab18-46a3-8929-25f123df5852', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:39:03', 142, 0, '', '2019-05-15 23:39:03');
INSERT INTO `access_log` VALUES (2527, '77f594c1-d8ce-46b0-8bb4-9ec64b2fcd97', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:39:03', 364, 2001001000, '服务端发生异常', '2019-05-15 23:39:03');
INSERT INTO `access_log` VALUES (2528, '4fffb48f-4583-4aff-bc8d-361531bbd1f7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:39:03', 361, 2001001000, '服务端发生异常', '2019-05-15 23:39:03');
INSERT INTO `access_log` VALUES (2529, '7db2783c-4c6a-4aff-89e7-4340d68d80f8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:39:58', 44, 0, '', '2019-05-15 23:39:58');
INSERT INTO `access_log` VALUES (2530, 'df380bc3-1737-4887-81e0-d25281a371c4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:39:58', 393, 2001001000, '服务端发生异常', '2019-05-15 23:39:59');
INSERT INTO `access_log` VALUES (2531, '674722ae-bae4-4315-900f-0df885f9a6a5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:39:58', 500, 2001001000, '服务端发生异常', '2019-05-15 23:39:59');
INSERT INTO `access_log` VALUES (2532, '92dc7855-c6cb-4b2e-957c-092d0e697b4e', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:39:59', 46, 0, '', '2019-05-15 23:39:59');
INSERT INTO `access_log` VALUES (2533, 'f742f66a-677e-4f41-9506-d1f7f51ba2ac', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:13', 49, 0, '', '2019-05-15 23:40:13');
INSERT INTO `access_log` VALUES (2534, '2acbd629-4ea9-4f2d-b8e2-9c0580a9da7c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:13', 409, 2001001000, '服务端发生异常', '2019-05-15 23:40:13');
INSERT INTO `access_log` VALUES (2535, 'cc980a21-87bb-4faf-ae32-1d07bf0bb6c3', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:13', 305, 0, '', '2019-05-15 23:40:13');
INSERT INTO `access_log` VALUES (2536, '8db165a5-7a0e-47f4-a6da-f78504046e99', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:13', 702, 2001001000, '服务端发生异常', '2019-05-15 23:40:13');
INSERT INTO `access_log` VALUES (2537, '1ae5f131-2ac7-40a5-8e23-2fb25d518a3e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:20', 41, 0, '', '2019-05-15 23:40:20');
INSERT INTO `access_log` VALUES (2538, '06c70956-3ddc-49ce-ab0a-4be12d721db9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:20', 267, 2001001000, '服务端发生异常', '2019-05-15 23:40:21');
INSERT INTO `access_log` VALUES (2539, '68ff04cf-fa3c-4c59-a6c6-c9c7b3ff57b6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:20', 273, 2001001000, '服务端发生异常', '2019-05-15 23:40:21');
INSERT INTO `access_log` VALUES (2540, 'ce53b8a8-af24-4f53-938f-d52a0be4442e', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:22', 34, 0, '', '2019-05-15 23:40:22');
INSERT INTO `access_log` VALUES (2541, '948703ed-47b9-4b0a-984b-493bd7080052', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:23', 51, 0, '', '2019-05-15 23:40:23');
INSERT INTO `access_log` VALUES (2542, '0d71131e-4357-4149-b7c9-44889f7eb9e8', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:23', 70, 0, '', '2019-05-15 23:40:23');
INSERT INTO `access_log` VALUES (2543, '76b6b2bc-cc8f-4690-854f-2dcf6dbb5cab', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:23', 235, 2001001000, '服务端发生异常', '2019-05-15 23:40:24');
INSERT INTO `access_log` VALUES (2544, '0a889ec5-2069-464b-8710-4fe7db304c2d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:23', 291, 2001001000, '服务端发生异常', '2019-05-15 23:40:24');
INSERT INTO `access_log` VALUES (2545, 'b50b8d11-45c6-475a-bc63-31dea3c711f6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:38', 64, 0, '', '2019-05-15 23:40:38');
INSERT INTO `access_log` VALUES (2546, 'eea4620e-30aa-4582-8506-340ba4f7fbca', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:39', 47, 0, '', '2019-05-15 23:40:39');
INSERT INTO `access_log` VALUES (2547, '92932b04-0b96-43f6-9b6f-13c3d1681fe8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:38', 231, 2001001000, '服务端发生异常', '2019-05-15 23:40:39');
INSERT INTO `access_log` VALUES (2548, '508edabd-485e-4a0b-bc81-3e5074aeb93e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:38', 228, 2001001000, '服务端发生异常', '2019-05-15 23:40:39');
INSERT INTO `access_log` VALUES (2549, '4763d4d0-b29a-4d44-b4e8-94e4696b373b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:57', 71, 0, '', '2019-05-15 23:40:58');
INSERT INTO `access_log` VALUES (2550, '987e33e7-3afb-4d39-a5e8-66c83945ab19', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:57', 501, 2001001000, '服务端发生异常', '2019-05-15 23:40:58');
INSERT INTO `access_log` VALUES (2551, 'da2f437e-a1c7-4fbd-9e9b-812704ee6e2f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:57', 503, 2001001000, '服务端发生异常', '2019-05-15 23:40:58');
INSERT INTO `access_log` VALUES (2552, '67386a6b-c2cc-48af-82c4-b56ae539023a', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:58', 346, 0, '', '2019-05-15 23:40:58');
INSERT INTO `access_log` VALUES (2553, '9ad0fbd9-ed0b-4bd9-b6ab-a8323652817e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:03', 58, 0, '', '2019-05-15 23:41:03');
INSERT INTO `access_log` VALUES (2554, 'cba0bec1-0176-4685-87d2-058a37cc4742', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:03', 56, 0, '', '2019-05-15 23:41:03');
INSERT INTO `access_log` VALUES (2555, 'c90c83be-c54d-48cb-92cc-c5615ab21d4f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:03', 495, 2001001000, '服务端发生异常', '2019-05-15 23:41:04');
INSERT INTO `access_log` VALUES (2556, '06b28b2e-14b3-4a81-b470-dcd3e36e7570', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:03', 558, 2001001000, '服务端发生异常', '2019-05-15 23:41:04');
INSERT INTO `access_log` VALUES (2557, 'ebe75877-217f-45fa-9f57-c7165b76513c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:06', 43, 0, '', '2019-05-15 23:41:06');
INSERT INTO `access_log` VALUES (2558, '6c2be4b4-0de4-4100-847f-e97c1e0bbf19', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:06', 492, 2001001000, '服务端发生异常', '2019-05-15 23:41:07');
INSERT INTO `access_log` VALUES (2559, '06ccb83a-d019-45f3-8735-347e7ef6a1bb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:06', 495, 2001001000, '服务端发生异常', '2019-05-15 23:41:07');
INSERT INTO `access_log` VALUES (2560, 'eb960e06-73cc-42b9-a632-eaf51ec11b41', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:07', 114, 0, '', '2019-05-15 23:41:07');
INSERT INTO `access_log` VALUES (2561, '1419b2cd-4154-473b-83fa-042dacc98fa7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:10', 212, 2001001000, '服务端发生异常', '2019-05-15 23:41:10');
INSERT INTO `access_log` VALUES (2562, '62fe6eda-01b4-4cd8-b3e0-67c9de6295b5', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:10', 37, 0, '', '2019-05-15 23:41:10');
INSERT INTO `access_log` VALUES (2563, 'e1eeb71f-1301-4f9f-a33f-d3eef865b955', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:10', 41, 0, '', '2019-05-15 23:41:10');
INSERT INTO `access_log` VALUES (2564, '210c8d21-92cd-4c0f-97cb-13e536bf48c3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:10', 330, 2001001000, '服务端发生异常', '2019-05-15 23:41:11');
INSERT INTO `access_log` VALUES (2565, 'd6965527-9c27-466a-9647-3b1a28a613cb', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:13', 73, 0, '', '2019-05-15 23:41:13');
INSERT INTO `access_log` VALUES (2566, 'e9135b41-3663-4019-b8b1-31b2e7dcc595', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:13', 309, 2001001000, '服务端发生异常', '2019-05-15 23:41:13');
INSERT INTO `access_log` VALUES (2567, '371b697b-12e0-4acd-ac44-605f70c17ad2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:13', 318, 2001001000, '服务端发生异常', '2019-05-15 23:41:13');
INSERT INTO `access_log` VALUES (2568, 'bd7cee8e-7ac4-480b-accd-c85fb7b8bc6a', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:14', 39, 0, '', '2019-05-15 23:41:14');
INSERT INTO `access_log` VALUES (2569, 'e16c0b89-6df2-46c7-80b2-706c00d828b3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:34', 33, 0, '', '2019-05-15 23:41:34');
INSERT INTO `access_log` VALUES (2570, '03666851-16ec-4cbe-a2fa-1663d1b008fa', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:34', 82, 0, '', '2019-05-15 23:41:34');
INSERT INTO `access_log` VALUES (2571, '3175f2ac-9841-4308-81f1-f357faf9c6e9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:34', 287, 2001001000, '服务端发生异常', '2019-05-15 23:41:34');
INSERT INTO `access_log` VALUES (2572, '41dac857-226d-44c7-b50b-22df9e6ca33d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:34', 293, 2001001000, '服务端发生异常', '2019-05-15 23:41:34');
INSERT INTO `access_log` VALUES (2573, '3d2eab5c-7146-42b1-bf70-96915a38af00', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:40', 91, 0, '', '2019-05-15 23:41:40');
INSERT INTO `access_log` VALUES (2574, '0336bd8e-ebba-4c41-9b19-1317ecbe282e', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:40', 324, 0, '', '2019-05-15 23:41:41');
INSERT INTO `access_log` VALUES (2575, '4560c02d-72ec-49af-b9d7-faf46e436af5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:40', 830, 2001001000, '服务端发生异常', '2019-05-15 23:41:41');
INSERT INTO `access_log` VALUES (2576, '54ddff92-a812-420a-a47a-60f5e6897cb8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:40', 834, 2001001000, '服务端发生异常', '2019-05-15 23:41:41');
INSERT INTO `access_log` VALUES (2577, '53e2bd8a-1816-497d-81eb-b67d1c394b2c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:58', 57, 0, '', '2019-05-15 23:41:58');
INSERT INTO `access_log` VALUES (2578, 'cd015418-24c6-4678-a931-47ff782cf089', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:58', 224, 2001001000, '服务端发生异常', '2019-05-15 23:41:58');
INSERT INTO `access_log` VALUES (2579, '64413416-800f-480d-af7a-2753b7ec8af1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:58', 227, 2001001000, '服务端发生异常', '2019-05-15 23:41:58');
INSERT INTO `access_log` VALUES (2580, '95d3ffcf-af5b-4695-957e-a1d3d1912215', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:09', 30, 0, '', '2019-05-15 23:42:09');
INSERT INTO `access_log` VALUES (2581, 'a966c44b-9966-484e-a02b-8e8b4a26c02a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:09', 335, 2001001000, '服务端发生异常', '2019-05-15 23:42:09');
INSERT INTO `access_log` VALUES (2582, '1a38cd65-afec-4626-8389-82e6aaed4af8', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:09', 226, 0, '', '2019-05-15 23:42:09');
INSERT INTO `access_log` VALUES (2583, 'd4213889-2420-45b1-a914-4f76b58febc2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:09', 406, 2001001000, '服务端发生异常', '2019-05-15 23:42:09');
INSERT INTO `access_log` VALUES (2584, '9c6895a2-5aa9-4cb6-8e65-7f246fcdc708', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:56', 33, 0, '', '2019-05-15 23:42:56');
INSERT INTO `access_log` VALUES (2585, '939c5701-6e0c-46bb-803d-840de50c1bb6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:56', 231, 2001001000, '服务端发生异常', '2019-05-15 23:42:57');
INSERT INTO `access_log` VALUES (2586, '8ce41d27-c93f-4cab-aee5-9965e4f457ef', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:56', 285, 2001001000, '服务端发生异常', '2019-05-15 23:42:57');
INSERT INTO `access_log` VALUES (2587, '1d321a37-ba2b-4e1b-b728-e22802c2e438', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:57', 34, 0, '', '2019-05-15 23:42:57');
INSERT INTO `access_log` VALUES (2588, 'ff031489-fcd6-4b8b-8a5d-a8eb9fccc87b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:58', 43, 0, '', '2019-05-15 23:42:58');
INSERT INTO `access_log` VALUES (2589, '02fd57cc-8229-4e5b-9cab-503ceced81c2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:58', 388, 2001001000, '服务端发生异常', '2019-05-15 23:42:58');
INSERT INTO `access_log` VALUES (2590, '29d9cc86-7952-4776-9463-d9f9c3ac9078', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:58', 259, 0, '', '2019-05-15 23:42:58');
INSERT INTO `access_log` VALUES (2591, '6a5af04d-d33e-421c-ba14-6c22065080c2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:58', 451, 2001001000, '服务端发生异常', '2019-05-15 23:42:58');
INSERT INTO `access_log` VALUES (2592, '4133dddf-0c69-4994-a405-dd443148f273', 1, 2, 'admin-application', '/admin-api/admins/resource/add', 'type=2&displayName=新建员工&pid=14&sort=1&permissions=system.admin.add', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:43:58', 114, 0, '', '2019-05-15 23:43:58');
INSERT INTO `access_log` VALUES (2593, '6920889c-fabb-4bd4-b4d4-bdbfd4d846a4', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:43:59', 32, 0, '', '2019-05-15 23:43:59');
INSERT INTO `access_log` VALUES (2594, '6a586923-4366-4a29-9097-d8d735ff3399', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:44:00', 100, 0, '', '2019-05-15 23:44:01');
INSERT INTO `access_log` VALUES (2595, '9640e1c4-2399-45d6-bffc-0b8c03bca5cc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:44:00', 391, 2001001000, '服务端发生异常', '2019-05-15 23:44:01');
INSERT INTO `access_log` VALUES (2596, '783fd517-3377-4f7f-910e-336f1f8710ab', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:44:01', 324, 0, '', '2019-05-15 23:44:01');
INSERT INTO `access_log` VALUES (2597, '77b956cb-8990-4c16-bcad-78d1d84503b0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:44:00', 539, 2001001000, '服务端发生异常', '2019-05-15 23:44:01');
INSERT INTO `access_log` VALUES (2598, 'e6fb348a-eb69-4a47-8857-a1fad834c4a5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:44:37', 41, 0, '', '2019-05-15 23:44:37');
INSERT INTO `access_log` VALUES (2599, 'b84d8c3e-ac64-4686-8427-7476c052450d', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:44:38', 694, 0, '', '2019-05-15 23:44:38');
INSERT INTO `access_log` VALUES (2600, '41b3b7e9-eb32-4293-8509-304d4c6f699d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:44:37', 911, 2001001000, '服务端发生异常', '2019-05-15 23:44:38');
INSERT INTO `access_log` VALUES (2601, 'f54ee676-a1c3-43b2-8e19-2673adf3df64', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:44:37', 911, 2001001000, '服务端发生异常', '2019-05-15 23:44:38');
INSERT INTO `access_log` VALUES (2602, '7bf96288-62aa-4e1a-807b-f3b0d99a429a', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=47&type=2&sort=1&displayName=新建员工&pid=14&permissions=system.admin.add,system.admin.update&createTime=2019-05-15T15:43:58.000+0000', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:45:12', 219, 0, '', '2019-05-15 23:45:12');
INSERT INTO `access_log` VALUES (2603, '3d2d0e65-9c5f-47a5-a5c7-24dce260faf6', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:45:12', 57, 0, '', '2019-05-15 23:45:12');
INSERT INTO `access_log` VALUES (2604, 'a29d9383-10c2-4c2a-8162-66ceac236f1d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:45:15', 39, 0, '', '2019-05-15 23:45:15');
INSERT INTO `access_log` VALUES (2605, '2d317fc7-0f40-492f-bdb4-23a97d71d4ad', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:45:15', 330, 2001001000, '服务端发生异常', '2019-05-15 23:45:15');
INSERT INTO `access_log` VALUES (2606, '6f067543-d863-467a-9ce2-e4168239f204', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:45:15', 260, 0, '', '2019-05-15 23:45:15');
INSERT INTO `access_log` VALUES (2607, '9440abac-a924-4f1d-ae87-37a28629857f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:45:15', 437, 2001001000, '服务端发生异常', '2019-05-15 23:45:16');
INSERT INTO `access_log` VALUES (2608, 'dcdf9acd-64d4-49e7-9b8a-067284114d50', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=14&type=1&sort=0&displayName=员工列表&pid=13&handler=/admin/admin-list&icon=team&permissions=system.admin.list&createTime=2019-03-09T19:59:29.000+0000&children[0][id]=47&children[0][type]=2&children[0][sort]=1&children[0][displayName]=新建员工&children[0][pid]=14&children[0][handler]=&children[0][icon]=&children[0][permissions][0]=system.admin.add&children[0][permissions][1]=system.admin.update&children[0][createTime]=2019-05-15T15:43:58.000+0000&children[0][children]=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:46:47', 135, 0, '', '2019-05-15 23:46:47');
INSERT INTO `access_log` VALUES (2609, '1cbcdadf-63a3-4576-a471-873571856f74', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:46:47', 34, 0, '', '2019-05-15 23:46:47');
INSERT INTO `access_log` VALUES (2610, '0a22a2a1-f1f3-4352-8cd3-e8e599dbc1a1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:46:49', 43, 0, '', '2019-05-15 23:46:49');
INSERT INTO `access_log` VALUES (2611, '5bf2397c-d8e2-4df6-8b3e-38aabdd170df', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:46:49', 276, 0, '', '2019-05-15 23:46:50');
INSERT INTO `access_log` VALUES (2612, '214ea1aa-abf6-457e-b7b0-f0df7997ca5a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:46:49', 383, 2001001000, '服务端发生异常', '2019-05-15 23:46:50');
INSERT INTO `access_log` VALUES (2613, '1829a108-5347-431d-b81d-0fe735069d85', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:46:49', 467, 2001001000, '服务端发生异常', '2019-05-15 23:46:50');
INSERT INTO `access_log` VALUES (2614, 'ae402970-c5b1-41b5-a855-9cf5dfc7920c', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=13&type=1&sort=8&displayName=系统管理&pid=0&icon=desktop&createTime=2019-03-09T19:59:07.000+0000&children[0][id]=14&children[0][type]=1&children[0][sort]=0&children[0][displayName]=员工列表&children[0][pid]=13&children[0][handler]=/admin/admin-list&children[0][icon]=team&children[0][permissions][0]=system.admin.list&children[0][createTime]=2019-03-09T19:59:29.000+0000&children[0][children][0][id]=47&children[0][children][0][type]=2&children[0][children][0][sort]=1&children[0][children][0][displayName]=新建员工&children[0][children][0][pid]=14&children[0][children][0][handler]=&children[0][children][0][icon]=&children[0][children][0][permissions][0]=system.admin.add&children[0][children][0][permissions][1]=system.admin.update&children[0][children][0][createTime]=2019-05-15T15:43:58.000+0000&children[0][children][0][children]=&children[1][id]=15&children[1][type]=1&children[1][sort]=2&children[1][displayName]=权限列表&children[1][pid]=13&children[1][handler]=/admin/resource-list&children[1][icon]=&children[1][createTime]=2019-03-09T19:59:56.000+0000&children[1][children]=&children[2][id]=16&children[2][type]=1&children[2][sort]=1&children[2][displayName]=角色列表&children[2][pid]=13&children[2][handler]=/admin/role-list&children[2][icon]=&children[2][createTime]=2019-03-09T20:00:35.000+0000&children[2][children]=&children[3][id]=19&children[3][type]=1&children[3][sort]=4&children[3][displayName]=数据字典&children[3][pid]=13&children[3][handler]=/admin/dictionary-list&children[3][icon]=&children[3][createTime]=2019-03-15T11:10:30.000+0000&children[3][children]=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:48:05', 151, 0, '', '2019-05-15 23:48:06');
INSERT INTO `access_log` VALUES (2615, '737f836f-b352-4197-879f-1df1030f0a93', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:48:06', 37, 0, '', '2019-05-15 23:48:06');
INSERT INTO `access_log` VALUES (2616, '35.71.15579369926960055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '120.85.149.186', '2019-05-16 00:16:33', 40, 0, '', '2019-05-16 00:16:33');
INSERT INTO `access_log` VALUES (2617, '35.79.15579369927030057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '120.85.149.237', '2019-05-16 00:16:33', 97, 0, '', '2019-05-16 00:16:33');
INSERT INTO `access_log` VALUES (2618, '35.80.15579369962300055', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '42.236.10.125', '2019-05-16 00:16:36', 17, 0, '', '2019-05-16 00:16:36');
INSERT INTO `access_log` VALUES (2619, '35.76.15579369961830057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '42.236.10.114', '2019-05-16 00:16:36', 70, 0, '', '2019-05-16 00:16:36');
INSERT INTO `access_log` VALUES (2620, '32.87.15579370023520055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '120.85.149.237', '2019-05-16 00:16:42', 4, 0, '', '2019-05-16 00:16:42');
INSERT INTO `access_log` VALUES (2621, '32.84.15579370024940055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '120.85.149.237', '2019-05-16 00:16:42', 4, 0, '', '2019-05-16 00:16:43');
INSERT INTO `access_log` VALUES (2622, '32.88.15579370103810059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '120.85.149.237', '2019-05-16 00:16:50', 4, 0, '', '2019-05-16 00:16:50');
INSERT INTO `access_log` VALUES (2623, '32.80.15579370105390061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '120.85.149.237', '2019-05-16 00:16:51', 3, 0, '', '2019-05-16 00:16:51');
INSERT INTO `access_log` VALUES (2624, '35.73.15579370134430059', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '120.85.149.237', '2019-05-16 00:16:53', 4, 0, '', '2019-05-16 00:16:53');
INSERT INTO `access_log` VALUES (2625, '35.72.15579370134410059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '120.85.149.186', '2019-05-16 00:16:53', 11, 0, '', '2019-05-16 00:16:53');
INSERT INTO `access_log` VALUES (2626, '8bb893a3-c2f3-42cf-bb79-3066ffc23acc', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:23', 197, 1002001012, '访问令牌已过期', '2019-05-16 00:23:23');
INSERT INTO `access_log` VALUES (2627, '6d66853b-727c-4096-8fdb-6fa5291500cb', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:23', 192, 1002001012, '访问令牌已过期', '2019-05-16 00:23:23');
INSERT INTO `access_log` VALUES (2628, '076e6cc7-2000-4744-bf75-aee2276e3615', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:23', 192, 1002001012, '访问令牌已过期', '2019-05-16 00:23:23');
INSERT INTO `access_log` VALUES (2629, '58b57a7a-4817-457e-9a1c-5b15cbd3a926', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:23', 192, 1002001012, '访问令牌已过期', '2019-05-16 00:23:23');
INSERT INTO `access_log` VALUES (2630, '6b8487b5-e3a5-4a52-bdb2-fb65ddca1720', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:25', 271, 0, '', '2019-05-16 00:23:25');
INSERT INTO `access_log` VALUES (2631, '9b9d2051-ef59-42da-914a-5344e186697c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:25', 153, 0, '', '2019-05-16 00:23:25');
INSERT INTO `access_log` VALUES (2632, 'a90811fd-d07e-48f4-8cc4-0b5b1eadd4f9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:25', 415, 2001001000, '服务端发生异常', '2019-05-16 00:23:26');
INSERT INTO `access_log` VALUES (2633, '51ed7e01-f357-4e88-878c-0889680e5560', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:25', 461, 2001001000, '服务端发生异常', '2019-05-16 00:23:26');
INSERT INTO `access_log` VALUES (2634, 'bb02e44b-0744-4dcb-84bf-9dc8ccb5c992', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:34', 54, 0, '', '2019-05-16 00:23:34');
INSERT INTO `access_log` VALUES (2635, '56bf3cda-cd9e-4be5-bd0f-6009e94b325e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:34', 193, 2001001000, '服务端发生异常', '2019-05-16 00:23:34');
INSERT INTO `access_log` VALUES (2636, '198a6729-8f12-41ab-a0c5-2d3240b9e6a5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:34', 239, 2001001000, '服务端发生异常', '2019-05-16 00:23:34');
INSERT INTO `access_log` VALUES (2637, '35.77.15579720277030057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.216.51.129', '2019-05-16 10:00:28', 42, 0, '', '2019-05-16 10:00:28');
INSERT INTO `access_log` VALUES (2638, '35.78.15579720277030057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.216.51.129', '2019-05-16 10:00:28', 62, 0, '', '2019-05-16 10:00:28');
INSERT INTO `access_log` VALUES (2639, '32.83.15579720407720061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.216.51.129', '2019-05-16 10:00:41', 10, 0, '', '2019-05-16 10:00:41');
INSERT INTO `access_log` VALUES (2640, '32.79.15579720409040057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.216.51.129', '2019-05-16 10:00:41', 6, 0, '', '2019-05-16 10:00:41');
INSERT INTO `access_log` VALUES (2641, '32.82.15579720462510059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.216.51.129', '2019-05-16 10:00:46', 291, 0, '', '2019-05-16 10:00:47');
INSERT INTO `access_log` VALUES (2642, '32.86.15579720467250055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.216.51.129', '2019-05-16 10:00:47', 4, 0, '', '2019-05-16 10:00:47');
INSERT INTO `access_log` VALUES (2643, '37.71.15579720556080007', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.216.51.129', '2019-05-16 10:00:56', 4, 0, '', '2019-05-16 10:00:56');
INSERT INTO `access_log` VALUES (2644, '37.65.15579720556110005', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.216.51.129', '2019-05-16 10:00:56', 19, 0, '', '2019-05-16 10:00:56');
INSERT INTO `access_log` VALUES (2645, '37.66.15579720556380007', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.216.51.129', '2019-05-16 10:00:56', 3, 0, '', '2019-05-16 10:00:56');
INSERT INTO `access_log` VALUES (2646, '37.66.15579739872160009', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.243.216.192', '2019-05-16 10:33:07', 5, 0, '', '2019-05-16 10:33:07');
INSERT INTO `access_log` VALUES (2647, '37.65.15579739872210007', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.243.216.192', '2019-05-16 10:33:07', 1, 0, '', '2019-05-16 10:33:07');
INSERT INTO `access_log` VALUES (2648, '37.71.15579739872210009', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.243.216.192', '2019-05-16 10:33:07', 26, 0, '', '2019-05-16 10:33:07');
INSERT INTO `access_log` VALUES (2649, '959e04f9-634e-499e-b32a-f53289e40ce8', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:01', 184, 1002001012, '访问令牌已过期', '2019-05-16 10:43:01');
INSERT INTO `access_log` VALUES (2650, '25ffb8fe-1dbc-4bc8-8c6e-388be0b7d02d', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:01', 184, 1002001012, '访问令牌已过期', '2019-05-16 10:43:01');
INSERT INTO `access_log` VALUES (2651, '2bd8648f-8085-40b4-90cc-abdcdc80d223', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:01', 184, 1002001012, '访问令牌已过期', '2019-05-16 10:43:01');
INSERT INTO `access_log` VALUES (2652, '5926bb01-a747-4953-9070-49f8375eaee3', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:03', 150, 0, '', '2019-05-16 10:43:03');
INSERT INTO `access_log` VALUES (2653, '54afc8c7-0ac9-4118-bf49-5d37c712a4ae', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:04', 99, 0, '', '2019-05-16 10:43:04');
INSERT INTO `access_log` VALUES (2654, '594d921e-6142-4d4b-b4bf-eb222bcd063a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:04', 293, 2001001000, '服务端发生异常', '2019-05-16 10:43:04');
INSERT INTO `access_log` VALUES (2655, '840a2673-40e3-4ce2-819b-c47fb4fa9f86', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:04', 290, 2001001000, '服务端发生异常', '2019-05-16 10:43:04');
INSERT INTO `access_log` VALUES (2656, 'cd286214-750e-4986-8eae-2848c662cc5e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:16', 17, 0, '', '2019-05-16 10:43:16');
INSERT INTO `access_log` VALUES (2657, '0f8f7644-6d60-4cb5-9ec3-9c6a8e1d6528', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:16', 368, 2001001000, '服务端发生异常', '2019-05-16 10:43:16');
INSERT INTO `access_log` VALUES (2658, 'f7c8c34b-9b82-4a66-b0a6-c6501cb56e38', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:16', 366, 2001001000, '服务端发生异常', '2019-05-16 10:43:16');
INSERT INTO `access_log` VALUES (2659, '16bf97b2-56ff-4e7a-9b79-59bf2dd3ec4c', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:24', 92, 0, '', '2019-05-16 10:43:24');
INSERT INTO `access_log` VALUES (2660, 'de995890-bde8-4270-9ab9-7ed398ff7a33', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:25', 15, 0, '', '2019-05-16 10:43:25');
INSERT INTO `access_log` VALUES (2661, '001ecb18-a6a2-4a0f-8dc5-883ebf3ceecf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:27', 13, 0, '', '2019-05-16 10:43:28');
INSERT INTO `access_log` VALUES (2662, '5fb7d13f-c6d5-4f95-a040-5e5c320c9e7b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:27', 114, 2001001000, '服务端发生异常', '2019-05-16 10:43:28');
INSERT INTO `access_log` VALUES (2663, '04b0286a-e31e-4091-8e46-9fc0f42516ea', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:27', 110, 2001001000, '服务端发生异常', '2019-05-16 10:43:28');
INSERT INTO `access_log` VALUES (2664, '7653a8eb-a469-49ca-a69b-3ed8d00335f6', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:28', 13, 0, '', '2019-05-16 10:43:28');
INSERT INTO `access_log` VALUES (2665, '76235f95-25ad-4eca-a0da-3c5b34f4b041', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:37', 12, 0, '', '2019-05-16 10:43:37');
INSERT INTO `access_log` VALUES (2666, '5fc489fc-f232-4d30-8b33-1f2176bfca94', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:37', 16, 0, '', '2019-05-16 10:43:37');
INSERT INTO `access_log` VALUES (2667, '58ff78fc-eaee-4a52-9462-3c7437f8d2d0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:37', 174, 2001001000, '服务端发生异常', '2019-05-16 10:43:37');
INSERT INTO `access_log` VALUES (2668, '3341fa29-d442-48c5-9da7-830ef92c1b2f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:37', 177, 2001001000, '服务端发生异常', '2019-05-16 10:43:37');
INSERT INTO `access_log` VALUES (2669, 'f6718cbe-64b0-45d4-a16c-4d06d0f06387', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:48', 10, 0, '', '2019-05-16 10:43:48');
INSERT INTO `access_log` VALUES (2670, '9650f4f7-1567-48ec-b0a3-9dd33095feba', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:48', 8, 0, '', '2019-05-16 10:43:48');
INSERT INTO `access_log` VALUES (2671, 'ce746745-8dde-4cbf-850e-1d4fe594653f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:48', 169, 2001001000, '服务端发生异常', '2019-05-16 10:43:48');
INSERT INTO `access_log` VALUES (2672, '23af005d-e878-4ccc-84b8-55510c4e2962', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:48', 387, 2001001000, '服务端发生异常', '2019-05-16 10:43:48');
INSERT INTO `access_log` VALUES (2673, '9a7dd0db-38d0-42da-b352-4658ee8339ce', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:27', 232, 0, '', '2019-05-16 10:44:27');
INSERT INTO `access_log` VALUES (2674, '11f16b55-181c-4e52-b698-d21621faf45c', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:28', 31, 0, '', '2019-05-16 10:44:28');
INSERT INTO `access_log` VALUES (2675, '9e8ffe8e-9d57-4ef7-8264-d0f39b8d6a1a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:28', 45, 0, '', '2019-05-16 10:44:28');
INSERT INTO `access_log` VALUES (2676, '00350046-335e-432e-90a4-6019543820fe', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:28', 66, 0, '', '2019-05-16 10:44:29');
INSERT INTO `access_log` VALUES (2677, '5ab617c4-e53b-40a3-acba-eefcb152bd29', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:28', 123, 0, '', '2019-05-16 10:44:29');
INSERT INTO `access_log` VALUES (2678, '6463c9bc-803f-42d5-994f-c8fcc4244f23', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:36', 280, 0, '', '2019-05-16 10:44:37');
INSERT INTO `access_log` VALUES (2679, 'f7cc6a43-6081-4f16-a81f-f9e721b37a36', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:37', 85, 0, '', '2019-05-16 10:44:37');
INSERT INTO `access_log` VALUES (2680, '3c52dc40-bbf5-4f18-b43a-24a62eb74114', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:39', 11, 0, '', '2019-05-16 10:44:39');
INSERT INTO `access_log` VALUES (2681, '4adb8dd4-aef6-4196-8c7d-2300a709b05a', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:40', 14, 0, '', '2019-05-16 10:44:40');
INSERT INTO `access_log` VALUES (2682, 'fc0d7f30-4fd9-4858-8453-c06ce18e4119', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:41', 17, 0, '', '2019-05-16 10:44:41');
INSERT INTO `access_log` VALUES (2683, 'a941d50f-bfe4-48d5-aa79-d6e449702c8d', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:44', 14, 0, '', '2019-05-16 10:44:44');
INSERT INTO `access_log` VALUES (2684, 'ff7645a6-7f42-4fd7-ad12-d7186c29b2f6', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:46', 12, 0, '', '2019-05-16 10:44:46');
INSERT INTO `access_log` VALUES (2685, '370d8f62-e8ce-48b5-84e9-22b51be73032', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:48', 11, 0, '', '2019-05-16 10:44:48');
INSERT INTO `access_log` VALUES (2686, '49847172-2ce1-485e-8ffd-9cf58040e0b0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:48', 16, 0, '', '2019-05-16 10:44:48');
INSERT INTO `access_log` VALUES (2687, 'd0896875-41c2-4ff6-9e36-1006dedd191d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:48', 19, 0, '', '2019-05-16 10:44:48');
INSERT INTO `access_log` VALUES (2688, '7fea2e3a-fff4-4ed8-812f-2fb401ece2f3', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:44:48', 18, 0, '', '2019-05-16 10:44:48');
INSERT INTO `access_log` VALUES (2689, '33a112df-5ba7-42f7-990d-6f7f42668b3f', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:47:12', 370, 0, '', '2019-05-16 10:47:13');
INSERT INTO `access_log` VALUES (2690, 'dd053247-622c-45f2-a92d-33dd5cd7e585', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:47:12', 367, 0, '', '2019-05-16 10:47:13');
INSERT INTO `access_log` VALUES (2691, '845f0b08-acc4-4035-8b15-71f0d175e22f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:47:12', 367, 0, '', '2019-05-16 10:47:13');
INSERT INTO `access_log` VALUES (2692, 'd9de897b-d245-499a-a772-01c37b03d1e3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:47:12', 367, 0, '', '2019-05-16 10:47:13');
INSERT INTO `access_log` VALUES (2693, 'b8f60a74-146e-4096-bf98-9b3d62b073cc', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=14&type=1&sort=0&displayName=员工列表&pid=14&handler=/admin/admin-list&icon=team&permissions=system.admin.page&createTime=2019-03-09T19:59:29.000+0000&children[0][id]=47&children[0][type]=2&children[0][sort]=1&children[0][displayName]=新建员工&children[0][pid]=14&children[0][handler]=&children[0][icon]=&children[0][permissions][0]=system.admin.add&children[0][permissions][1]=system.admin.update&children[0][createTime]=2019-05-15T15:43:58.000+0000&children[0][children]=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:47:39', 38, 1002003002, '不能设置自己为父资源', '2019-05-16 10:47:39');
INSERT INTO `access_log` VALUES (2694, '5745f989-0188-47c7-84c5-2b3994a2dc8a', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:47:39', 16, 0, '', '2019-05-16 10:47:39');
INSERT INTO `access_log` VALUES (2695, 'd7e790ba-d2f8-47f2-810a-d2804a458082', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=14&type=1&sort=0&displayName=员工列表&pid=13&handler=/admin/admin-list&icon=team&permissions=system.admin.page&createTime=2019-03-09T19:59:29.000+0000&children[0][id]=47&children[0][type]=2&children[0][sort]=1&children[0][displayName]=新建员工&children[0][pid]=14&children[0][handler]=&children[0][icon]=&children[0][permissions][0]=system.admin.add&children[0][permissions][1]=system.admin.update&children[0][createTime]=2019-05-15T15:43:58.000+0000&children[0][children]=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:47:59', 90, 0, '', '2019-05-16 10:47:59');
INSERT INTO `access_log` VALUES (2696, 'ed8ede7f-7ea2-4274-96f9-aced4efc629b', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:47:59', 19, 0, '', '2019-05-16 10:47:59');
INSERT INTO `access_log` VALUES (2697, '66da721c-fb0d-4674-b5b4-b14ab3856385', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:48:19', 114, 0, '', '2019-05-16 10:48:19');
INSERT INTO `access_log` VALUES (2698, '0183d182-0943-4444-a2c8-9f7199dde0a1', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:49:08', 23, 0, '', '2019-05-16 10:49:08');
INSERT INTO `access_log` VALUES (2699, '0ee98b7a-861b-40be-98c7-2267b4c293ed', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:49:10', 15, 0, '', '2019-05-16 10:49:10');
INSERT INTO `access_log` VALUES (2700, '155747fb-1764-4400-802a-c84bae7c216f', 1, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=1&resourceIds=13,14,15,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,41,42,43,44,45,46,47', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:49:15', 295, 0, '', '2019-05-16 10:49:15');
INSERT INTO `access_log` VALUES (2701, '9a2cafc6-c1d2-44fe-9181-d2ef27fbf5e1', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:49:18', 17, 0, '', '2019-05-16 10:49:18');
INSERT INTO `access_log` VALUES (2702, '37.64.15579762649020011', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-16 11:11:05', 1186, 2001001000, '服务端发生异常', '2019-05-16 11:11:06');
INSERT INTO `access_log` VALUES (2703, '37.72.15579762742510011', 0, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-16 11:11:14', 125, 2001001000, '服务端发生异常', '2019-05-16 11:11:14');
INSERT INTO `access_log` VALUES (2704, '37.71.15579762831720011', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'name=系统管理员&pageSize=10&pageNo=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-16 11:11:23', 99, 0, '', '2019-05-16 11:11:23');
INSERT INTO `access_log` VALUES (2705, '37.65.15579762945380009', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-16 11:11:35', 18, 0, '', '2019-05-16 11:11:35');
INSERT INTO `access_log` VALUES (2706, '37.68.15579763019080007', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-16 11:11:42', 18, 0, '', '2019-05-16 11:11:42');
INSERT INTO `access_log` VALUES (2707, '32.80.15579763817030063', 0, 2, 'product-application', '/product-api/admins/spu/add', 'cid=反正我是信了&description=你就说强不强 MQ 骚操作&name=厮大牛逼&picUrls=http://www.iocoder.cn&sellPoint=各种 MQ 骚操作&skuStr=[{\"attrs\": [1,3 ], \"price\": 1, \"quantity\": 100, \"picUrl\": \"http://www.iocoder.cn\"}]&visible=true', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-16 11:13:02', 737, 2001001000, '服务端发生异常', '2019-05-16 11:13:02');
INSERT INTO `access_log` VALUES (2708, '35.74.15579793474130057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.72.100.115', '2019-05-16 12:02:27', 43, 0, '', '2019-05-16 12:02:27');
INSERT INTO `access_log` VALUES (2709, '35.75.15579793474140061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.72.100.115', '2019-05-16 12:02:27', 69, 0, '', '2019-05-16 12:02:27');
INSERT INTO `access_log` VALUES (2710, '37.67.15579793626190009', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.72.100.115', '2019-05-16 12:02:43', 3, 0, '', '2019-05-16 12:02:43');
INSERT INTO `access_log` VALUES (2711, '37.70.15579793626180011', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.72.100.115', '2019-05-16 12:02:43', 3, 0, '', '2019-05-16 12:02:43');
INSERT INTO `access_log` VALUES (2712, '37.69.15579793626220015', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.72.100.115', '2019-05-16 12:02:43', 14, 0, '', '2019-05-16 12:02:43');
INSERT INTO `access_log` VALUES (2713, '35.71.15579794492990057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.72.76.3', '2019-05-16 12:04:09', 29, 0, '', '2019-05-16 12:04:09');
INSERT INTO `access_log` VALUES (2714, '35.79.15579794504980059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.72.76.3', '2019-05-16 12:04:10', 60, 0, '', '2019-05-16 12:04:11');
INSERT INTO `access_log` VALUES (2715, '37.66.15579794525680013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.72.76.3', '2019-05-16 12:04:13', 3, 0, '', '2019-05-16 12:04:13');
INSERT INTO `access_log` VALUES (2716, '37.73.15579794525680007', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.72.76.3', '2019-05-16 12:04:13', 3, 0, '', '2019-05-16 12:04:13');
INSERT INTO `access_log` VALUES (2717, '37.64.15579794526900013', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.72.76.3', '2019-05-16 12:04:13', 12, 0, '', '2019-05-16 12:04:13');
INSERT INTO `access_log` VALUES (2718, '35.76.15579839171370059', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.101.22', '2019-05-16 13:18:37', 42, 0, '', '2019-05-16 13:18:37');
INSERT INTO `access_log` VALUES (2719, '35.77.15579839171370059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.101.22', '2019-05-16 13:18:37', 64, 0, '', '2019-05-16 13:18:37');
INSERT INTO `access_log` VALUES (2720, '32.79.15579839221580059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.101.22', '2019-05-16 13:18:42', 5, 0, '', '2019-05-16 13:18:42');
INSERT INTO `access_log` VALUES (2721, '32.86.15579839222940057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.101.22', '2019-05-16 13:18:42', 11, 0, '', '2019-05-16 13:18:42');
INSERT INTO `access_log` VALUES (2722, '32.81.15579839249420059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.101.22', '2019-05-16 13:18:45', 4, 0, '', '2019-05-16 13:18:45');
INSERT INTO `access_log` VALUES (2723, '32.85.15579839250510063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.101.22', '2019-05-16 13:18:45', 4, 0, '', '2019-05-16 13:18:45');
INSERT INTO `access_log` VALUES (2724, '35.72.15579839256510061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.101.22', '2019-05-16 13:18:46', 7, 0, '', '2019-05-16 13:18:46');
INSERT INTO `access_log` VALUES (2725, '35.75.15579839256520063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.101.22', '2019-05-16 13:18:46', 12, 0, '', '2019-05-16 13:18:46');
INSERT INTO `access_log` VALUES (2726, '35.79.15579882105520061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.76.177.64', '2019-05-16 14:30:11', 17, 0, '', '2019-05-16 14:30:11');
INSERT INTO `access_log` VALUES (2727, '35.78.15579882105520059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.76.177.64', '2019-05-16 14:30:11', 55, 0, '', '2019-05-16 14:30:11');
INSERT INTO `access_log` VALUES (2728, '32.82.15579882175000061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.76.177.64', '2019-05-16 14:30:18', 5, 0, '', '2019-05-16 14:30:18');
INSERT INTO `access_log` VALUES (2729, '32.87.15579882176090059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.76.177.64', '2019-05-16 14:30:18', 6, 0, '', '2019-05-16 14:30:18');
INSERT INTO `access_log` VALUES (2730, '32.84.15579882222910059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.76.177.64', '2019-05-16 14:30:22', 4, 0, '', '2019-05-16 14:30:22');
INSERT INTO `access_log` VALUES (2731, '32.88.15579882224300063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.76.177.64', '2019-05-16 14:30:22', 4, 0, '', '2019-05-16 14:30:22');
INSERT INTO `access_log` VALUES (2732, '35.71.15579890216960059', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.40.34', '2019-05-16 14:43:42', 37, 0, '', '2019-05-16 14:43:42');
INSERT INTO `access_log` VALUES (2733, '35.73.15579890216990061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.40.34', '2019-05-16 14:43:42', 12, 0, '', '2019-05-16 14:43:42');
INSERT INTO `access_log` VALUES (2734, '32.83.15579890381520063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.40.34', '2019-05-16 14:43:58', 4, 0, '', '2019-05-16 14:43:58');
INSERT INTO `access_log` VALUES (2735, '32.80.15579890382710065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.40.34', '2019-05-16 14:43:58', 3, 0, '', '2019-05-16 14:43:58');
INSERT INTO `access_log` VALUES (2736, '32.79.15579890461320061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.40.34', '2019-05-16 14:44:06', 4, 0, '', '2019-05-16 14:44:06');
INSERT INTO `access_log` VALUES (2737, '32.86.15579890462410059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.40.34', '2019-05-16 14:44:06', 3, 0, '', '2019-05-16 14:44:06');
INSERT INTO `access_log` VALUES (2738, '32.81.15579890565870061', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.40.34', '2019-05-16 14:44:17', 39, 1003002003, 'Spu 只能添加在二级分类下', '2019-05-16 14:44:17');
INSERT INTO `access_log` VALUES (2739, 'ba3fb2f3-ca81-4005-a9cd-4b85360220c8', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:09:38', 2012, 2001001000, '服务端发生异常', '2019-05-16 15:09:40');
INSERT INTO `access_log` VALUES (2740, '5cfc56fd-3857-4ae3-be89-4796e5374b95', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:09:38', 2012, 2001001000, '服务端发生异常', '2019-05-16 15:09:40');
INSERT INTO `access_log` VALUES (2741, 'fb3fb411-92ba-466f-b9dd-5f9a0aed6fd8', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:09:38', 2011, 2001001000, '服务端发生异常', '2019-05-16 15:09:40');
INSERT INTO `access_log` VALUES (2742, '1055945b-7e0b-44f9-90b7-1ef52132e6e2', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:09:38', 2011, 2001001000, '服务端发生异常', '2019-05-16 15:09:40');
INSERT INTO `access_log` VALUES (2743, '49494fe3-eee4-4c51-ae98-76bff64acd67', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:10:49', 612, 2001001000, '服务端发生异常', '2019-05-16 15:10:50');
INSERT INTO `access_log` VALUES (2744, '6a3fed0c-b5a0-4ab7-9b57-baa1dcb06906', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:11:15', 173, 2001001000, '服务端发生异常', '2019-05-16 15:11:15');
INSERT INTO `access_log` VALUES (2745, '712d7277-af07-4e7e-a275-9426f703273e', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:13:12', 42945, 2001001000, '服务端发生异常', '2019-05-16 15:13:55');
INSERT INTO `access_log` VALUES (2746, 'cdc1cfef-fa6e-4259-9aa4-fe44887d8aa3', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:14:17', 20604, 2001001000, '服务端发生异常', '2019-05-16 15:14:38');
INSERT INTO `access_log` VALUES (2747, '56d0bd9b-37f2-4933-b6b8-49d73da2c3fc', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:19:23', 13557, 2001001000, '服务端发生异常', '2019-05-16 15:19:36');
INSERT INTO `access_log` VALUES (2748, 'dca67d25-2ad7-41ff-aa0f-8e3bb3527a25', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:22:10', 1972, 2001001000, '服务端发生异常', '2019-05-16 15:22:12');
INSERT INTO `access_log` VALUES (2749, 'b2c97a70-c99b-403a-b98d-2469c9f203df', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:23:29', 3191, 2001001000, '服务端发生异常', '2019-05-16 15:23:33');
INSERT INTO `access_log` VALUES (2750, '2cc076cb-3ae8-44b0-82ea-91da682fcb03', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:24:21', 5019, 0, '', '2019-05-16 15:24:26');
INSERT INTO `access_log` VALUES (2751, '8ef3ca24-a0e7-43b1-b57c-16ef005bc15a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:24:27', 110, 0, '', '2019-05-16 15:24:27');
INSERT INTO `access_log` VALUES (2752, '25d57607-5644-42a1-bd08-8dd74ab27c78', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:24:27', 105, 0, '', '2019-05-16 15:24:27');
INSERT INTO `access_log` VALUES (2753, '2ebf66df-2819-4a02-afb4-abdf0bad9de0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:24:27', 140, 0, '', '2019-05-16 15:24:27');
INSERT INTO `access_log` VALUES (2754, 'ffafb16f-974c-4e39-aa32-008c0e165df6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:24:39', 5, 0, '', '2019-05-16 15:24:39');
INSERT INTO `access_log` VALUES (2755, '1e1d6f0a-5d38-4e41-982c-122207268805', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:24:39', 4, 0, '', '2019-05-16 15:24:39');
INSERT INTO `access_log` VALUES (2756, '508a9c4c-9fa8-4b1b-bf4a-2d78dc5504dc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:24:39', 29, 0, '', '2019-05-16 15:24:39');
INSERT INTO `access_log` VALUES (2757, '500f2cf9-d70c-4762-8372-6bd79cd8ddc9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:24:48', 12, 0, '', '2019-05-16 15:24:48');
INSERT INTO `access_log` VALUES (2758, '9f696f78-3006-4326-801b-051559e71f49', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:24:48', 54, 0, '', '2019-05-16 15:24:48');
INSERT INTO `access_log` VALUES (2759, '6943027f-77b3-432f-934f-d3d2d9ca3caa', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:24:48', 48, 0, '', '2019-05-16 15:24:48');
INSERT INTO `access_log` VALUES (2760, '4857a49e-9d20-4208-ba88-54c794b882b4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:25:17', 5, 0, '', '2019-05-16 15:25:17');
INSERT INTO `access_log` VALUES (2761, 'abdb5482-0f6d-481b-8de0-5063d6dc2a50', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:25:17', 10, 0, '', '2019-05-16 15:25:17');
INSERT INTO `access_log` VALUES (2762, '4ec0e53e-de16-4331-bbca-1bf3e9188576', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:25:17', 20, 0, '', '2019-05-16 15:25:17');
INSERT INTO `access_log` VALUES (2763, '6e4a26c2-9d15-483c-9e14-1648f95239ca', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:26:10', 1947, 0, '', '2019-05-16 15:26:11');
INSERT INTO `access_log` VALUES (2764, '7287d645-99d8-4533-95c5-50e4b2398cf1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:26:10', 2781, 0, '', '2019-05-16 15:26:13');
INSERT INTO `access_log` VALUES (2765, '298a10bb-c2e5-43ac-9fca-24dc8c48d352', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:26:07', 45898, 0, '', '2019-05-16 15:26:53');
INSERT INTO `access_log` VALUES (2766, 'e8a235e0-e1be-40e8-83df-832965646568', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:29:46', 6371, 0, '', '2019-05-16 15:29:52');
INSERT INTO `access_log` VALUES (2767, '5b13d536-82a8-4797-9e97-f19a723ce6a9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:29:46', 6371, 0, '', '2019-05-16 15:29:52');
INSERT INTO `access_log` VALUES (2768, 'fb9f9999-1901-434c-94ed-09d78aecfa53', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:29:46', 22048, 0, '', '2019-05-16 15:30:08');
INSERT INTO `access_log` VALUES (2769, 'b146a51b-925b-464d-a95f-c838b397dc23', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:35:01', 338, 0, '', '2019-05-16 15:35:01');
INSERT INTO `access_log` VALUES (2770, '38cbaacc-e64c-43c2-b1f5-1a1ef7a22011', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:35:01', 338, 0, '', '2019-05-16 15:35:01');
INSERT INTO `access_log` VALUES (2771, 'eed788ed-9baf-4529-a113-026565208be5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:35:01', 338, 0, '', '2019-05-16 15:35:01');
INSERT INTO `access_log` VALUES (2772, 'b5ec5755-b2d7-4b78-a1fe-1b0a7499ff5f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:35:11', 10321, 0, '', '2019-05-16 15:35:22');
INSERT INTO `access_log` VALUES (2773, '6c4d4f82-ffd9-4a0c-aadc-621d148f8cf0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:35:17', 5092, 0, '', '2019-05-16 15:35:22');
INSERT INTO `access_log` VALUES (2774, 'fd7ab388-5440-4a99-b66e-806bd28ad814', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:35:11', 10330, 0, '', '2019-05-16 15:35:22');
INSERT INTO `access_log` VALUES (2775, 'a0b8e0cc-4457-4691-97e9-d47deb814eff', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:35:31', 7941, 0, '', '2019-05-16 15:35:39');
INSERT INTO `access_log` VALUES (2776, '8fcae2fc-70e5-4dca-a37a-476c2cf96d03', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:35:55', 2717, 0, '', '2019-05-16 15:35:58');
INSERT INTO `access_log` VALUES (2777, '3427c4b1-99b4-446b-b461-21144b4286c0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:35:57', 682, 0, '', '2019-05-16 15:35:58');
INSERT INTO `access_log` VALUES (2778, '89d511f1-efb2-4b70-815c-f3fa318ff0b2', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:35:57', 693, 0, '', '2019-05-16 15:35:58');
INSERT INTO `access_log` VALUES (2779, '3f2f3f24-c1c4-499a-b04a-62e40c3e492a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:35:55', 19583, 0, '', '2019-05-16 15:36:15');
INSERT INTO `access_log` VALUES (2780, '219ad417-b98b-42b8-b7aa-389df72d5b6e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:36:21', 55469, 0, '', '2019-05-16 15:37:16');
INSERT INTO `access_log` VALUES (2781, 'f7d66880-a51f-4434-a133-3c3a250f5e66', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:36:21', 55480, 0, '', '2019-05-16 15:37:16');
INSERT INTO `access_log` VALUES (2782, '68f67833-b45a-492e-a791-607933ebeb77', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:36:42', 33605, 0, '', '2019-05-16 15:37:16');
INSERT INTO `access_log` VALUES (2783, '2d58027d-5ccd-4c1f-8d5a-ec31a342eb80', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:36:42', 33626, 0, '', '2019-05-16 15:37:16');
INSERT INTO `access_log` VALUES (2784, 'b8077339-11eb-4218-b793-03544e48621f', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:37:21', 20, 0, '', '2019-05-16 15:37:21');
INSERT INTO `access_log` VALUES (2785, '1bf90c2e-2ea0-498a-9f7b-68abdf814dcd', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:37:27', 74422, 0, '', '2019-05-16 15:38:41');
INSERT INTO `access_log` VALUES (2786, '00213167-3985-46a8-8574-90239a18f382', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:39:47', 25136, 2001001000, '服务端发生异常', '2019-05-16 15:40:12');
INSERT INTO `access_log` VALUES (2787, '3bc94773-0d46-4f54-85c8-deb244791c59', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:02', 322, 0, '', '2019-05-16 15:45:02');
INSERT INTO `access_log` VALUES (2788, 'f3c52926-a62b-4874-b263-80eda124959c', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:02', 322, 1002002007, '没有该操作权限', '2019-05-16 15:45:02');
INSERT INTO `access_log` VALUES (2789, 'd76f8dbb-62b2-4e12-b2d6-1fc862f76eb1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:02', 323, 0, '', '2019-05-16 15:45:02');
INSERT INTO `access_log` VALUES (2790, 'd49cde94-6ed9-4730-89f9-e734867f7ffc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:02', 322, 0, '', '2019-05-16 15:45:02');
INSERT INTO `access_log` VALUES (2791, 'e1ed610d-7993-434e-84e5-33ea4b1ec27a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:06', 303, 0, '', '2019-05-16 15:45:06');
INSERT INTO `access_log` VALUES (2792, 'f5c584a7-0500-4f1e-91e4-df8387cb2a44', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:06', 313, 0, '', '2019-05-16 15:45:06');
INSERT INTO `access_log` VALUES (2793, 'bbdf0e67-f06e-45c7-aee2-0c22c6d6ca84', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:06', 311, 0, '', '2019-05-16 15:45:06');
INSERT INTO `access_log` VALUES (2794, '881c491b-53f9-4313-9f9e-ea4089ad0e82', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:06', 236, 1002002007, '没有该操作权限', '2019-05-16 15:45:06');
INSERT INTO `access_log` VALUES (2795, '005236ca-8c1b-4266-84f1-2a010cc51b28', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:09', 12, 0, '', '2019-05-16 15:45:09');
INSERT INTO `access_log` VALUES (2796, '0304dac0-e2f0-48e9-ac5b-d26cf49d8db9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:09', 22, 0, '', '2019-05-16 15:45:09');
INSERT INTO `access_log` VALUES (2797, 'e8549897-76ed-4d4d-91bd-385466a9e462', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:09', 19, 0, '', '2019-05-16 15:45:09');
INSERT INTO `access_log` VALUES (2798, 'c7f24fe7-5f30-4dd5-b81d-f8531cc468f6', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:09', 15, 1002002007, '没有该操作权限', '2019-05-16 15:45:09');
INSERT INTO `access_log` VALUES (2799, 'fc31eec2-baeb-4228-aca5-6e5842c688bb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:17', 10, 0, '', '2019-05-16 15:45:17');
INSERT INTO `access_log` VALUES (2800, '844abea3-65e9-4d2e-b739-e3e1ac913e3b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:17', 17, 0, '', '2019-05-16 15:45:17');
INSERT INTO `access_log` VALUES (2801, '755bfa01-516f-44d2-9fe5-db0df05486e3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:17', 15, 0, '', '2019-05-16 15:45:17');
INSERT INTO `access_log` VALUES (2802, 'e6233c56-3ea6-4ba2-9e76-2c1352bd8dd1', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:17', 15, 1002002007, '没有该操作权限', '2019-05-16 15:45:17');
INSERT INTO `access_log` VALUES (2803, '3dd5ef9a-67ad-4a4b-be7f-e50f3968ddfd', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:22', 117, 0, '', '2019-05-16 15:45:22');
INSERT INTO `access_log` VALUES (2804, 'ee7537f8-eaf5-46c2-b8ca-face7bd2034e', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:45:24', 23, 0, '', '2019-05-16 15:45:24');
INSERT INTO `access_log` VALUES (2805, '209e3db5-e7ab-4c5a-bfd9-a9b5153a6cfb', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:51:08', 25, 0, '', '2019-05-16 15:51:08');
INSERT INTO `access_log` VALUES (2806, '3fc33864-7fd1-4a69-9a5a-9c31e7db2850', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:51:13', 17, 1002002007, '没有该操作权限', '2019-05-16 15:51:13');
INSERT INTO `access_log` VALUES (2807, 'cd4359df-0501-4e97-b59d-91a45abd2aa7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:51:20', 16, 0, '', '2019-05-16 15:51:20');
INSERT INTO `access_log` VALUES (2808, '5a9133e3-3155-481a-a073-9c5f46747e45', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:51:19', 1877, 0, '', '2019-05-16 15:51:20');
INSERT INTO `access_log` VALUES (2809, '4caf75eb-8e64-49bf-b4bd-aef48eb6be06', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:51:20', 20, 1002002007, '没有该操作权限', '2019-05-16 15:51:20');
INSERT INTO `access_log` VALUES (2810, 'b1742f97-ed4b-4adc-8837-e064d06afabf', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:51:19', 5006, 0, '', '2019-05-16 15:51:24');
INSERT INTO `access_log` VALUES (2811, '9e4dac29-2c17-4e9e-b7e6-afc46a47c7c1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:51:50', 2196, 0, '', '2019-05-16 15:51:53');
INSERT INTO `access_log` VALUES (2812, '50df5a20-0bfe-4b3f-90fa-51cedc82d9d1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:51:50', 2196, 0, '', '2019-05-16 15:51:53');
INSERT INTO `access_log` VALUES (2813, 'ce1f43a7-047b-45f1-bae7-70946cd895d3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:51:50', 2196, 0, '', '2019-05-16 15:51:53');
INSERT INTO `access_log` VALUES (2814, '3037727b-cf90-4f21-9331-bf87cf30dd46', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:51:50', 34652, 1002002007, '没有该操作权限', '2019-05-16 15:52:25');
INSERT INTO `access_log` VALUES (2815, 'd0c4afff-6e64-443e-845f-3d80090b2818', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:55:47', 336, 0, '', '2019-05-16 15:55:47');
INSERT INTO `access_log` VALUES (2816, 'bf2d1b84-511e-4ec7-90eb-44539342dab8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:55:47', 336, 0, '', '2019-05-16 15:55:47');
INSERT INTO `access_log` VALUES (2817, '41795d67-6125-41de-b5b4-7aa85ea01f5a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:55:47', 336, 0, '', '2019-05-16 15:55:47');
INSERT INTO `access_log` VALUES (2818, '5537c5bd-a355-4abf-851c-0bd965800db4', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:55:47', 445, 0, '', '2019-05-16 15:55:47');
INSERT INTO `access_log` VALUES (2819, '4856a225-63db-44fd-adde-29b714cc5725', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:55:57', 14, 0, '', '2019-05-16 15:55:57');
INSERT INTO `access_log` VALUES (2820, 'fbdd7727-ecce-4fc0-a519-48cfa453636e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:55:57', 28, 0, '', '2019-05-16 15:55:57');
INSERT INTO `access_log` VALUES (2821, '8789dc51-1672-410f-be31-308ff403566e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:55:57', 26, 0, '', '2019-05-16 15:55:57');
INSERT INTO `access_log` VALUES (2822, '17532903-afec-419b-aab8-f9bed4705ee5', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:55:57', 38, 0, '', '2019-05-16 15:55:57');
INSERT INTO `access_log` VALUES (2823, 'dad2f76c-ec67-4a94-a985-4df5e0cfcbc4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:56:43', 10, 0, '', '2019-05-16 15:56:43');
INSERT INTO `access_log` VALUES (2824, '1fbdc111-b028-4b22-b68e-4536e0435590', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:56:43', 20, 0, '', '2019-05-16 15:56:43');
INSERT INTO `access_log` VALUES (2825, 'e85b0ba9-c8a4-463b-a47b-7e458fb5e760', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:56:43', 18, 0, '', '2019-05-16 15:56:43');
INSERT INTO `access_log` VALUES (2826, 'c540c400-2a45-469b-861b-e8ffaff1987f', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:56:43', 20, 0, '', '2019-05-16 15:56:43');
INSERT INTO `access_log` VALUES (2827, '5938d76e-5bf2-47ba-853e-8eff446db584', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:56:49', 32, 0, '', '2019-05-16 15:56:49');
INSERT INTO `access_log` VALUES (2828, 'cfafcc51-769b-4031-8a69-ecce7cc7dd0b', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:56:54', 51, 0, '', '2019-05-16 15:56:54');
INSERT INTO `access_log` VALUES (2829, '23ec7a56-e103-440d-b8d7-112e76ccb1b5', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:56:55', 26, 0, '', '2019-05-16 15:56:55');
INSERT INTO `access_log` VALUES (2830, '4b157236-04cc-4ba8-b90b-f385b9f6af60', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:57:00', 16, 0, '', '2019-05-16 15:57:00');
INSERT INTO `access_log` VALUES (2831, 'a51c929f-4937-4a37-9641-59a13849dfa1', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:57:01', 26, 0, '', '2019-05-16 15:57:01');
INSERT INTO `access_log` VALUES (2832, '3a3b16bc-75dd-452f-966e-a4b420fbc5ec', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:59:57', 15, 0, '', '2019-05-16 15:59:57');
INSERT INTO `access_log` VALUES (2833, '2dcb8460-42f1-4e8a-be06-570099dfd1ce', 1, 2, 'admin-application', '/admin-api/admins/resource/add', 'type=2&displayName=新建字典&pid=19&sort=1&permissions=system.dataDict.add', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:00:57', 167, 0, '', '2019-05-16 16:00:57');
INSERT INTO `access_log` VALUES (2834, '4f7c910f-d714-4560-8e01-5f1ac77acba3', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:00:57', 11, 0, '', '2019-05-16 16:00:57');
INSERT INTO `access_log` VALUES (2835, 'bb281475-2867-4557-a158-5606757e3111', 1, 2, 'admin-application', '/admin-api/admins/resource/add', 'type=2&displayName=编辑字典&pid=19&sort=2&permissions=system.dataDict.update', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:01:18', 74, 0, '', '2019-05-16 16:01:19');
INSERT INTO `access_log` VALUES (2836, 'e723a6aa-e445-4826-b695-7ad6bf1dcac8', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:01:19', 9, 0, '', '2019-05-16 16:01:19');
INSERT INTO `access_log` VALUES (2837, '781dd91b-2385-479d-8c33-c38f296afbc4', 1, 2, 'admin-application', '/admin-api/admins/resource/add', 'type=2&displayName=删除字典&pid=19&sort=3&permissions=system.dataDict.delete', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:01:36', 152, 0, '', '2019-05-16 16:01:36');
INSERT INTO `access_log` VALUES (2838, 'c32e1eeb-3d2b-4904-b5d5-65feb70a9d43', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:01:36', 11, 0, '', '2019-05-16 16:01:36');
INSERT INTO `access_log` VALUES (2839, '5871799b-fae9-475f-a143-04e2d534f2c1', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=19&type=1&sort=4&displayName=数据字典&pid=19&handler=/admin/dictionary-list&icon=select&permissions=system.dataDict.list&createTime=2019-03-15T11:10:30.000+0000&children[0][id]=48&children[0][type]=2&children[0][sort]=1&children[0][displayName]=新建字典&children[0][pid]=19&children[0][handler]=&children[0][icon]=&children[0][permissions][0]=system.dataDict.add&children[0][createTime]=2019-05-16T08:00:57.000+0000&children[0][children]=&children[1][id]=49&children[1][type]=2&children[1][sort]=2&children[1][displayName]=编辑字典&children[1][pid]=19&children[1][handler]=&children[1][icon]=&children[1][permissions][0]=system.dataDict.update&children[1][createTime]=2019-05-16T08:01:18.000+0000&children[1][children]=&children[2][id]=50&children[2][type]=2&children[2][sort]=3&children[2][displayName]=删除字典&children[2][pid]=19&children[2][handler]=&children[2][icon]=&children[2][permissions][0]=system.dataDict.delete&children[2][createTime]=2019-05-16T08:01:36.000+0000&children[2][children]=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:02:44', 26, 1002003002, '不能设置自己为父资源', '2019-05-16 16:02:44');
INSERT INTO `access_log` VALUES (2840, 'ddbe97a3-aa72-4e87-86a7-c3e156caebee', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:02:44', 10, 0, '', '2019-05-16 16:02:44');
INSERT INTO `access_log` VALUES (2841, '35.74.15579937701200059', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:02:50', 13, 0, '', '2019-05-16 16:02:50');
INSERT INTO `access_log` VALUES (2842, '35.80.15579937701200057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:02:50', 41, 0, '', '2019-05-16 16:02:50');
INSERT INTO `access_log` VALUES (2843, '32.85.15579937747220065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:02:55', 5, 0, '', '2019-05-16 16:02:55');
INSERT INTO `access_log` VALUES (2844, '32.82.15579937748290063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:02:55', 3, 0, '', '2019-05-16 16:02:55');
INSERT INTO `access_log` VALUES (2845, '32.87.15579937759650061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:02:56', 4, 0, '', '2019-05-16 16:02:56');
INSERT INTO `access_log` VALUES (2846, '32.84.15579937797810061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:03:00', 4, 0, '', '2019-05-16 16:03:00');
INSERT INTO `access_log` VALUES (2847, '32.88.15579937799160065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:03:00', 4, 0, '', '2019-05-16 16:03:00');
INSERT INTO `access_log` VALUES (2848, 'f676947d-5e53-435f-ba0a-573533e1d6b1', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=19&type=1&sort=4&displayName=数据字典&pid=13&handler=/admin/dictionary-list&icon=select&permissions=system.dataDict.list&createTime=2019-03-15T11:10:30.000+0000&children[0][id]=48&children[0][type]=2&children[0][sort]=1&children[0][displayName]=新建字典&children[0][pid]=19&children[0][handler]=&children[0][icon]=&children[0][permissions][0]=system.dataDict.add&children[0][createTime]=2019-05-16T08:00:57.000+0000&children[0][children]=&children[1][id]=49&children[1][type]=2&children[1][sort]=2&children[1][displayName]=编辑字典&children[1][pid]=19&children[1][handler]=&children[1][icon]=&children[1][permissions][0]=system.dataDict.update&children[1][createTime]=2019-05-16T08:01:18.000+0000&children[1][children]=&children[2][id]=50&children[2][type]=2&children[2][sort]=3&children[2][displayName]=删除字典&children[2][pid]=19&children[2][handler]=&children[2][icon]=&children[2][permissions][0]=system.dataDict.delete&children[2][createTime]=2019-05-16T08:01:36.000+0000&children[2][children]=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:03:01', 91, 0, '', '2019-05-16 16:03:02');
INSERT INTO `access_log` VALUES (2849, '3a6666a9-c149-435b-a63b-289cd089faeb', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:03:02', 10, 0, '', '2019-05-16 16:03:02');
INSERT INTO `access_log` VALUES (2850, '36.84.15579937832310009', 0, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:03:03', 1, -1, '未授权', '2019-05-16 16:03:03');
INSERT INTO `access_log` VALUES (2851, '36.86.15579937859340009', 0, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:03:06', 1, -1, '未授权', '2019-05-16 16:03:06');
INSERT INTO `access_log` VALUES (2852, '31.52.15579937918380011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:03:12', 894, 2001001000, '服务端发生异常', '2019-05-16 16:03:13');
INSERT INTO `access_log` VALUES (2853, '35.76.15579937976770061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:03:18', 46, 0, '', '2019-05-16 16:03:18');
INSERT INTO `access_log` VALUES (2854, '35.77.15579937976780061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:03:18', 52, 0, '', '2019-05-16 16:03:18');
INSERT INTO `access_log` VALUES (2855, '32.83.15579938001870065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:03:20', 4, 0, '', '2019-05-16 16:03:20');
INSERT INTO `access_log` VALUES (2856, '32.80.15579938003030067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:03:20', 3, 0, '', '2019-05-16 16:03:20');
INSERT INTO `access_log` VALUES (2857, '68095c92-b527-48c9-a5bc-265d5af82d08', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:03:27', 678, 0, '', '2019-05-16 16:03:28');
INSERT INTO `access_log` VALUES (2858, '89fc5658-93e7-46e8-92b4-498024df353a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:03:27', 678, 0, '', '2019-05-16 16:03:28');
INSERT INTO `access_log` VALUES (2859, 'b7646a2d-d3e4-41a2-89e5-3604128e7e32', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:03:27', 678, 0, '', '2019-05-16 16:03:28');
INSERT INTO `access_log` VALUES (2860, '784114d6-8b5e-47f2-9b1f-573daaa69b66', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:03:27', 678, 0, '', '2019-05-16 16:03:28');
INSERT INTO `access_log` VALUES (2861, '37.70.15579938079740013', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:03:28', 3, 0, '', '2019-05-16 16:03:28');
INSERT INTO `access_log` VALUES (2862, '37.65.15579938079750011', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:03:28', 11, 0, '', '2019-05-16 16:03:28');
INSERT INTO `access_log` VALUES (2863, '37.68.15579938079910009', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:03:28', 2, 0, '', '2019-05-16 16:03:28');
INSERT INTO `access_log` VALUES (2864, '9116270f-a7ff-4bc9-927d-93b3d9c26b4e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:03:30', 434, 0, '', '2019-05-16 16:03:30');
INSERT INTO `access_log` VALUES (2865, '724515eb-2ace-4087-a528-39f7c63ec909', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:03:34', 107, 0, '', '2019-05-16 16:03:34');
INSERT INTO `access_log` VALUES (2866, 'cac6a931-d24d-4451-be01-0c90003552ee', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:03:35', 18, 0, '', '2019-05-16 16:03:35');
INSERT INTO `access_log` VALUES (2867, '37.72.15579938481180013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:04:08', 2, 0, '', '2019-05-16 16:04:08');
INSERT INTO `access_log` VALUES (2868, '37.69.15579938481850017', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:04:08', 2, 0, '', '2019-05-16 16:04:08');
INSERT INTO `access_log` VALUES (2869, '37.67.15579938481850011', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:04:08', 10, 0, '', '2019-05-16 16:04:08');
INSERT INTO `access_log` VALUES (2870, '37.73.15579938506420009', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:04:11', 2, 0, '', '2019-05-16 16:04:11');
INSERT INTO `access_log` VALUES (2871, '37.71.15579938506390013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:04:11', 3, 0, '', '2019-05-16 16:04:11');
INSERT INTO `access_log` VALUES (2872, '37.66.15579938506440015', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:04:11', 10, 0, '', '2019-05-16 16:04:11');
INSERT INTO `access_log` VALUES (2873, '0bfaf06f-a890-47bb-8486-4279f0e129d9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:04:35', 330, 0, '', '2019-05-16 16:04:35');
INSERT INTO `access_log` VALUES (2874, '3fc5bbfd-09ca-42b3-8890-46f6d897675a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:04:35', 330, 0, '', '2019-05-16 16:04:35');
INSERT INTO `access_log` VALUES (2875, '4ad7e97e-fc44-447a-b65c-12a701b6c31e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:04:35', 330, 0, '', '2019-05-16 16:04:35');
INSERT INTO `access_log` VALUES (2876, '8452ee32-434d-4874-99b0-2876836918c9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:04:35', 330, 0, '', '2019-05-16 16:04:35');
INSERT INTO `access_log` VALUES (2877, '53bfbf31-5883-4b43-b8a4-07752ba35c41', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:04:38', 119, 0, '', '2019-05-16 16:04:38');
INSERT INTO `access_log` VALUES (2878, '79882399-2e9a-43d8-adde-8bd84cae553a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:04:39', 19, 0, '', '2019-05-16 16:04:39');
INSERT INTO `access_log` VALUES (2879, '14629b5b-3880-4fe7-9c8a-3448d77708ee', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:05:01', 14, 0, '', '2019-05-16 16:05:01');
INSERT INTO `access_log` VALUES (2880, 'ba158ad3-fbf7-45fb-ba31-e14eaada2f1b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:05:01', 25, 0, '', '2019-05-16 16:05:01');
INSERT INTO `access_log` VALUES (2881, '475ef154-6d75-4b28-bf9e-a6dc03f150d3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:05:01', 25, 0, '', '2019-05-16 16:05:01');
INSERT INTO `access_log` VALUES (2882, '9aeeceab-db00-4e11-adfe-f857b70b782d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:05:01', 13509, 0, '', '2019-05-16 16:05:15');
INSERT INTO `access_log` VALUES (2883, 'a3e276d4-5df2-4022-acd1-4845928de99d', 0, 2, 'admin-application', '/admin-api/admins/data_dict/update', 'id=1&enumValue=gender&value=1&displayName=男&sort=1&memo=性别 - 男（嗨）&index=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:05:25', 5262, 1002002007, '没有该操作权限', '2019-05-16 16:05:30');
INSERT INTO `access_log` VALUES (2884, '24a740ff-c0ad-4fc8-ae21-e3befc776b6d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:05:30', 3169, 0, '', '2019-05-16 16:05:33');
INSERT INTO `access_log` VALUES (2885, '32b3a56e-f3de-4476-abe4-ca7ef209c49e', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:42:38', 234, 1002001012, '访问令牌已过期', '2019-05-16 16:42:39');
INSERT INTO `access_log` VALUES (2886, '92945e45-5aa0-47c7-bdf6-f8471fd3cfdc', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:42:38', 234, 1002001012, '访问令牌已过期', '2019-05-16 16:42:39');
INSERT INTO `access_log` VALUES (2887, '308fa951-f673-4d9e-9e07-d217278c1c2f', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:42:38', 234, 1002001012, '访问令牌已过期', '2019-05-16 16:42:39');
INSERT INTO `access_log` VALUES (2888, '292aa1a0-5198-4714-9002-e4ed836cc8de', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:42:38', 234, 1002001012, '访问令牌已过期', '2019-05-16 16:42:39');
INSERT INTO `access_log` VALUES (2889, '2373a331-6ddf-4b66-93d8-661e52309cb3', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:42:40', 2, 1002001015, '账号未登陆', '2019-05-16 16:42:40');
INSERT INTO `access_log` VALUES (2890, 'c1a6f590-fd1c-4a4d-9164-0b5daa80edd2', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:42:41', 0, 1002001015, '账号未登陆', '2019-05-16 16:42:41');
INSERT INTO `access_log` VALUES (2891, '59852e77-093c-4c23-92cf-a5ae0662d2f6', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:43:41', 1, 1002001015, '账号未登陆', '2019-05-16 16:43:41');
INSERT INTO `access_log` VALUES (2892, '76f22173-4859-48d1-ab99-082eab6c8acd', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:43:42', 1, 1002001015, '账号未登陆', '2019-05-16 16:43:42');
INSERT INTO `access_log` VALUES (2893, '4d796b86-9dff-4f24-a7be-7ca8823b60f2', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:45:43', 40, 1002001015, '账号未登陆', '2019-05-16 16:45:43');
INSERT INTO `access_log` VALUES (2894, '86f17d13-5302-4533-8387-414fce3e0484', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:45:55', 2, 1002001015, '账号未登陆', '2019-05-16 16:45:55');
INSERT INTO `access_log` VALUES (2895, 'e77d3dad-d744-415a-bdb8-a9d5d040ac14', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:46:19', 1, 1002001015, '账号未登陆', '2019-05-16 16:46:19');
INSERT INTO `access_log` VALUES (2896, '1e2e5296-4333-4644-85c4-f65a125f7ce2', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:46:25', 1, 1002001015, '账号未登陆', '2019-05-16 16:46:25');
INSERT INTO `access_log` VALUES (2897, '292a4fa6-7a74-4cee-a6e8-2f0ba6f45906', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:47:35', 1, 1002001015, '账号未登陆', '2019-05-16 16:47:35');
INSERT INTO `access_log` VALUES (2898, '62e70edb-1748-4a6f-a8b9-f6c51be299e1', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:47:37', 1, 1002001015, '账号未登陆', '2019-05-16 16:47:37');
INSERT INTO `access_log` VALUES (2899, 'aab1a4bf-51ac-4802-bd87-69820f5c23f0', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:47:38', 1, 1002001015, '账号未登陆', '2019-05-16 16:47:38');
INSERT INTO `access_log` VALUES (2900, '7cf8cf44-9390-48c0-87ea-ad76c7d1a074', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:48:09', 1, 1002001015, '账号未登陆', '2019-05-16 16:48:09');
INSERT INTO `access_log` VALUES (2901, '2cb74ec8-ac7b-4441-b251-7c845a673789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:48:19', 1, 1002001015, '账号未登陆', '2019-05-16 16:48:19');
INSERT INTO `access_log` VALUES (2902, 'f047ccc9-2c82-49f9-887a-8beba4de8420', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:48:19', 2, 1002001015, '账号未登陆', '2019-05-16 16:48:19');
INSERT INTO `access_log` VALUES (2903, '00b7fd00-8d2f-4ff9-8840-5941db7d6f5a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:48:20', 1, 1002001015, '账号未登陆', '2019-05-16 16:48:20');
INSERT INTO `access_log` VALUES (2904, 'f08fc295-a755-4861-b1ae-ea9af3b240b2', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:48:21', 1, 1002001015, '账号未登陆', '2019-05-16 16:48:21');
INSERT INTO `access_log` VALUES (2905, '3f973281-4611-4b9f-ad42-ec38192fef9f', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:48:22', 1, 1002001015, '账号未登陆', '2019-05-16 16:48:22');
INSERT INTO `access_log` VALUES (2906, '9ed2e903-4c24-446b-987d-0b99219f5af1', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:48:22', 1, 1002001015, '账号未登陆', '2019-05-16 16:48:22');
INSERT INTO `access_log` VALUES (2907, '6fa5d0d9-dd5d-4c21-9182-6c2bd82616f9', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:48:23', 1, 1002001015, '账号未登陆', '2019-05-16 16:48:23');
INSERT INTO `access_log` VALUES (2908, '5323cad1-9a4a-4165-a4b3-b44f5e88456d', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:48:29', 3, 1002001015, '账号未登陆', '2019-05-16 16:48:29');
INSERT INTO `access_log` VALUES (2909, '48291223-2225-40cb-85e1-2c6f95477c53', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:52:08', 0, 1002001015, '账号未登陆', '2019-05-16 16:52:08');
INSERT INTO `access_log` VALUES (2910, '9592d9b9-d562-40a7-9c44-b6d8eb3237df', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:52:09', 1, 1002001015, '账号未登陆', '2019-05-16 16:52:09');
INSERT INTO `access_log` VALUES (2911, 'a0764f36-4959-407c-a924-a2f1b48afc50', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:52:10', 1, 1002001015, '账号未登陆', '2019-05-16 16:52:10');
INSERT INTO `access_log` VALUES (2912, '0b4b3df6-bb15-4e09-ad55-e4a6eb7ec5d0', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:52:27', 1, 1002001015, '账号未登陆', '2019-05-16 16:52:27');
INSERT INTO `access_log` VALUES (2913, '38beefe5-3f2b-45f9-9b79-245b7f72028e', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:52:29', 1, 1002001015, '账号未登陆', '2019-05-16 16:52:29');
INSERT INTO `access_log` VALUES (2914, '2d939cd0-807b-4bb1-bcc0-b8706da60272', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:52:30', 1, 1002001015, '账号未登陆', '2019-05-16 16:52:30');
INSERT INTO `access_log` VALUES (2915, '1bfc4a7e-bafb-4af6-9755-2284380a86ac', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:52:31', 2, 1002001015, '账号未登陆', '2019-05-16 16:52:31');
INSERT INTO `access_log` VALUES (2916, 'f86506c3-ed9f-4ff7-ba64-9b885dc0876e', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:54:20', 0, 1002001015, '账号未登陆', '2019-05-16 16:54:20');
INSERT INTO `access_log` VALUES (2917, '332ea872-66cc-44bd-8c6f-36e628d52f74', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:54:23', 1, 1002001015, '账号未登陆', '2019-05-16 16:54:23');
INSERT INTO `access_log` VALUES (2918, '04726584-c118-4293-9689-67fdf7216ac5', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:54:26', 1, 1002001015, '账号未登陆', '2019-05-16 16:54:26');
INSERT INTO `access_log` VALUES (2919, '328b659e-0550-4ddc-8ede-a9c9eff3c6c7', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:54:27', 1, 1002001015, '账号未登陆', '2019-05-16 16:54:27');
INSERT INTO `access_log` VALUES (2920, '49b80548-29ed-4733-82fa-a6ee256fdf3c', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:54:28', 1, 1002001015, '账号未登陆', '2019-05-16 16:54:28');
INSERT INTO `access_log` VALUES (2921, '000630d4-2770-4131-9155-a4882d493b9c', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:54:29', 1, 1002001015, '账号未登陆', '2019-05-16 16:54:29');
INSERT INTO `access_log` VALUES (2922, '6953d9a5-f678-4604-9961-f07527f76dc2', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:54:58', 1, 1002001015, '账号未登陆', '2019-05-16 16:54:58');
INSERT INTO `access_log` VALUES (2923, '12eb7a3e-4a6a-4700-be8a-57d376495778', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:55:03', 0, 1002001015, '账号未登陆', '2019-05-16 16:55:03');
INSERT INTO `access_log` VALUES (2924, '9bd9635d-992b-4e41-8598-4b2d660f5729', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:55:04', 1, 1002001015, '账号未登陆', '2019-05-16 16:55:04');
INSERT INTO `access_log` VALUES (2925, '2eb7d0e9-83b8-4d47-bd71-31265c509242', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:55:20', 1, 1002001015, '账号未登陆', '2019-05-16 16:55:20');
INSERT INTO `access_log` VALUES (2926, '8ab2e917-cf64-4cca-bb9c-7c1302aa2431', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:55:31', 1, 1002001015, '账号未登陆', '2019-05-16 16:55:31');
INSERT INTO `access_log` VALUES (2927, '740e6547-a9ea-4573-ab53-4da50d066936', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:55:35', 0, 1002001015, '账号未登陆', '2019-05-16 16:55:35');
INSERT INTO `access_log` VALUES (2928, 'f3cba033-b828-43f8-9e07-bbb67c0bbc3a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:55:36', 1, 1002001015, '账号未登陆', '2019-05-16 16:55:36');
INSERT INTO `access_log` VALUES (2929, '4acbd6b7-f895-4dbd-a5a3-79680d581b7a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:55:37', 0, 1002001015, '账号未登陆', '2019-05-16 16:55:37');
INSERT INTO `access_log` VALUES (2930, '8f386ea9-34a7-4c9c-bb16-0cf276daeb5a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:57:53', 43, 1002001015, '账号未登陆', '2019-05-16 16:57:53');
INSERT INTO `access_log` VALUES (2931, '8cf1c13c-88f8-4105-9195-54fe9afe0e7c', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:57:55', 1, 1002001015, '账号未登陆', '2019-05-16 16:57:55');
INSERT INTO `access_log` VALUES (2932, 'f8fbb4fb-1a90-45a2-8e8e-38c5c8893e76', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:57:59', 1, 1002001015, '账号未登陆', '2019-05-16 16:57:59');
INSERT INTO `access_log` VALUES (2933, 'a85d3bb1-0682-4ad9-a9e2-6476b02acffe', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:58:00', 1, 1002001015, '账号未登陆', '2019-05-16 16:58:00');
INSERT INTO `access_log` VALUES (2934, 'cd46ddea-1870-410f-b48e-f06ae7fe8ea4', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:58:21', 0, 1002001015, '账号未登陆', '2019-05-16 16:58:21');
INSERT INTO `access_log` VALUES (2935, 'c43bb729-b486-4408-bc64-9e4cbe4b1ca6', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:58:22', 1, 1002001015, '账号未登陆', '2019-05-16 16:58:22');
INSERT INTO `access_log` VALUES (2936, 'e326af0a-5cfc-4a25-a390-a47109f7e3e5', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:58:23', 0, 1002001015, '账号未登陆', '2019-05-16 16:58:23');
INSERT INTO `access_log` VALUES (2937, '67832f26-4e1f-4cb8-ba70-f728231b1815', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:58:24', 1, 1002001015, '账号未登陆', '2019-05-16 16:58:24');
INSERT INTO `access_log` VALUES (2938, 'da9deae4-caba-4f20-991f-55418d1ff521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:59:16', 1, 1002001015, '账号未登陆', '2019-05-16 16:59:16');
INSERT INTO `access_log` VALUES (2939, '6a99c5cd-e675-4dc0-af0f-6bbee98b86e7', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 16:59:17', 1, 1002001015, '账号未登陆', '2019-05-16 16:59:17');
INSERT INTO `access_log` VALUES (2940, 'cca97bc5-3ea6-4889-aa53-ca399908e190', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:00:10', 1, 1002001015, '账号未登陆', '2019-05-16 17:00:10');
INSERT INTO `access_log` VALUES (2941, '3ffcfd96-39b9-4b9e-b6bd-36ff53972d90', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:00:50', 11872, 1002001015, '账号未登陆', '2019-05-16 17:01:02');
INSERT INTO `access_log` VALUES (2942, '32.79.15579972650860063', 0, 2, 'product-application', '/product-api/admins/category/add', 'description=1&name=admin/info&pid=1&sort=1&picUrl=http://www.iocoder.cn/images/common/wechat_mp_2017_07_31_bak.jpg/', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.115.23', '2019-05-16 17:01:05', 121, 1003001000, '父分类不存在', '2019-05-16 17:01:05');
INSERT INTO `access_log` VALUES (2943, '32.86.15579972769070063', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.115.23', '2019-05-16 17:01:17', 8, 0, '', '2019-05-16 17:01:17');
INSERT INTO `access_log` VALUES (2944, 'b8eae029-3626-459f-a1d7-a8ae9b2b260f', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:02:18', 12231, 2001001000, '服务端发生异常', '2019-05-16 17:02:30');
INSERT INTO `access_log` VALUES (2945, '7760881b-40d5-40c1-beca-64a95f19b2d2', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:12:43', 2243, 2001001000, '服务端发生异常', '2019-05-16 17:12:46');
INSERT INTO `access_log` VALUES (2946, '35.72.15579981332550063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.83.124.219', '2019-05-16 17:15:33', 41, 0, '', '2019-05-16 17:15:33');
INSERT INTO `access_log` VALUES (2947, '35.75.15579981332550065', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.83.124.219', '2019-05-16 17:15:33', 57, 0, '', '2019-05-16 17:15:33');
INSERT INTO `access_log` VALUES (2948, '8de0919f-ef27-4ccd-ba56-866f59c967d0', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:17:42', 393, 0, '', '2019-05-16 17:17:42');
INSERT INTO `access_log` VALUES (2949, '0fb68fc3-603b-4491-bbb9-c22071610332', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:17:43', 138, 0, '', '2019-05-16 17:17:43');
INSERT INTO `access_log` VALUES (2950, '48a83831-473f-4696-9002-e2379106ac40', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:17:43', 157, 0, '', '2019-05-16 17:17:43');
INSERT INTO `access_log` VALUES (2951, 'decf5dc6-a626-4e47-bb58-4b7300b771fc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:17:43', 153, 0, '', '2019-05-16 17:17:43');
INSERT INTO `access_log` VALUES (2952, '4aee1cf7-2f3e-45c0-8a09-c93b86b4243f', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:17:51', 120, 0, '', '2019-05-16 17:17:51');
INSERT INTO `access_log` VALUES (2953, 'b6153593-3849-4f1f-a451-5ce5f2903578', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:17:54', 27, 0, '', '2019-05-16 17:17:54');
INSERT INTO `access_log` VALUES (2954, '323b1960-0fa7-4a8b-a508-56f650f1c13f', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:17:55', 31, 0, '', '2019-05-16 17:17:55');
INSERT INTO `access_log` VALUES (2955, '409b0148-0900-4f85-8c29-e2579bb660af', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:17:56', 93, 0, '', '2019-05-16 17:17:56');
INSERT INTO `access_log` VALUES (2956, '0a5a61f0-eea8-40fd-b188-d26a24161ac2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:17:57', 17, 0, '', '2019-05-16 17:17:57');
INSERT INTO `access_log` VALUES (2957, '5ace12d0-0d63-469e-875b-0fa123c2ba77', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:17:57', 30, 0, '', '2019-05-16 17:17:57');
INSERT INTO `access_log` VALUES (2958, '35.71.15579985118410061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.55', '2019-05-16 17:21:52', 222, 2001001000, '服务端发生异常', '2019-05-16 17:21:52');
INSERT INTO `access_log` VALUES (2959, '35.73.15579985118420063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.55', '2019-05-16 17:21:52', 221, 2001001000, '服务端发生异常', '2019-05-16 17:21:52');
INSERT INTO `access_log` VALUES (2960, '32.85.15579985240690067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.55', '2019-05-16 17:22:04', 460, 2001001000, '服务端发生异常', '2019-05-16 17:22:05');
INSERT INTO `access_log` VALUES (2961, '36.88.15579985280810009', 0, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.55', '2019-05-16 17:22:08', 175, 2001001000, '服务端发生异常', '2019-05-16 17:22:08');
INSERT INTO `access_log` VALUES (2962, '36.90.15579985364010011', 0, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.55', '2019-05-16 17:22:16', 125, 2001001000, '服务端发生异常', '2019-05-16 17:22:17');
INSERT INTO `access_log` VALUES (2963, '32.82.15579985410170065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.55', '2019-05-16 17:22:21', 150, 2001001000, '服务端发生异常', '2019-05-16 17:22:21');
INSERT INTO `access_log` VALUES (2964, '35.80.15579985453890059', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.55', '2019-05-16 17:22:25', 115, 2001001000, '服务端发生异常', '2019-05-16 17:22:26');
INSERT INTO `access_log` VALUES (2965, '35.74.15579985453900061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.55', '2019-05-16 17:22:25', 114, 2001001000, '服务端发生异常', '2019-05-16 17:22:26');
INSERT INTO `access_log` VALUES (2966, '37.64.15579986052130015', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.83.124.219', '2019-05-16 17:23:25', 3, 0, '', '2019-05-16 17:23:25');
INSERT INTO `access_log` VALUES (2967, '37.68.15579986052130011', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.83.124.219', '2019-05-16 17:23:25', 3, 0, '', '2019-05-16 17:23:25');
INSERT INTO `access_log` VALUES (2968, '37.70.15579986052180015', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.83.124.219', '2019-05-16 17:23:25', 15, 0, '', '2019-05-16 17:23:25');
INSERT INTO `access_log` VALUES (2969, '43620ca2-ee41-4c87-a98c-8d59b5ae1772', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:24:33', 392, 0, '', '2019-05-16 17:24:33');
INSERT INTO `access_log` VALUES (2970, 'fc7dbcb5-310b-40d5-bc60-66120a54d848', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:24:33', 392, 0, '', '2019-05-16 17:24:33');
INSERT INTO `access_log` VALUES (2971, 'f162e77f-0e29-42e4-a1cf-8d90a14f96e5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:24:33', 392, 0, '', '2019-05-16 17:24:33');
INSERT INTO `access_log` VALUES (2972, 'fcb5457f-da4c-493d-8f5a-f7e6f8177424', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:24:33', 426, 0, '', '2019-05-16 17:24:33');
INSERT INTO `access_log` VALUES (2973, '864e71cd-6710-4887-b412-f1d0c8fc125b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:24:35', 15, 0, '', '2019-05-16 17:24:35');
INSERT INTO `access_log` VALUES (2974, 'ce74a93a-e790-4115-828b-34b90f697809', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:24:35', 26, 0, '', '2019-05-16 17:24:35');
INSERT INTO `access_log` VALUES (2975, '7c5bfb84-36e1-4a8f-8308-2b0d21634bcc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:24:35', 24, 0, '', '2019-05-16 17:24:35');
INSERT INTO `access_log` VALUES (2976, '92d1fb02-c8e3-45fb-9e11-3f998b1a5de9', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:24:35', 35, 0, '', '2019-05-16 17:24:35');
INSERT INTO `access_log` VALUES (2977, '5b56634c-dca3-4fee-bf6e-f197401359db', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:24:37', 12, 0, '', '2019-05-16 17:24:37');
INSERT INTO `access_log` VALUES (2978, 'c2c70e62-29d2-4b09-b139-1c39e8184a24', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:24:37', 24, 0, '', '2019-05-16 17:24:37');
INSERT INTO `access_log` VALUES (2979, '6df9943a-7c0f-44ec-86c5-9649fee1639c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:24:37', 23, 0, '', '2019-05-16 17:24:37');
INSERT INTO `access_log` VALUES (2980, 'c5501830-0f73-4e13-97d4-cfa4957ddb99', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:24:37', 29, 0, '', '2019-05-16 17:24:37');
INSERT INTO `access_log` VALUES (2981, '35.76.15579989092140063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '113.246.122.40', '2019-05-16 17:28:29', 10, 0, '', '2019-05-16 17:28:29');
INSERT INTO `access_log` VALUES (2982, '35.77.15579989092140063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '113.246.122.40', '2019-05-16 17:28:29', 24, 0, '', '2019-05-16 17:28:29');
INSERT INTO `access_log` VALUES (2983, '32.87.15579989156850065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '113.246.122.40', '2019-05-16 17:28:36', 3, 0, '', '2019-05-16 17:28:36');
INSERT INTO `access_log` VALUES (2984, '32.84.15579989158540063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '113.246.122.40', '2019-05-16 17:28:36', 4, 0, '', '2019-05-16 17:28:36');
INSERT INTO `access_log` VALUES (2985, 'fb49be13-4d9c-414e-b0fb-daf78a175ed4', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:00', 449, 0, '', '2019-05-16 17:35:01');
INSERT INTO `access_log` VALUES (2986, '366bc8d3-7aa3-42a7-b1f3-1561ac47f4d8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:00', 416, 0, '', '2019-05-16 17:35:01');
INSERT INTO `access_log` VALUES (2987, '31ec69a0-4003-4a3e-97ab-d713945d962d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:00', 417, 0, '', '2019-05-16 17:35:01');
INSERT INTO `access_log` VALUES (2988, '021b24c7-69bf-45e7-a8b0-76ea925ac169', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:00', 417, 0, '', '2019-05-16 17:35:01');
INSERT INTO `access_log` VALUES (2989, '7048a340-c89b-47a8-a62d-a506a57ab9e8', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=9', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:03', 16, 0, '', '2019-05-16 17:35:03');
INSERT INTO `access_log` VALUES (2990, 'fabbcb93-e663-4600-a5a9-bfc0b1439f78', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:05', 16, 0, '', '2019-05-16 17:35:05');
INSERT INTO `access_log` VALUES (2991, '137c824b-45f6-48bc-856f-369cea0d5b0a', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:08', 20, 0, '', '2019-05-16 17:35:08');
INSERT INTO `access_log` VALUES (2992, '103da704-25c2-4ab6-b248-e59d49decb38', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=9', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:10', 13, 0, '', '2019-05-16 17:35:10');
INSERT INTO `access_log` VALUES (2993, '61d48636-422e-46f2-9909-7e12e33918b9', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=11', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:14', 579, 0, '', '2019-05-16 17:35:15');
INSERT INTO `access_log` VALUES (2994, '5ea2be72-a3d5-4567-a331-c9f20956a292', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:20', 13, 0, '', '2019-05-16 17:35:20');
INSERT INTO `access_log` VALUES (2995, '19df4e57-bfed-40fd-b62d-e537c6caebf2', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:25', 13, 0, '', '2019-05-16 17:35:25');
INSERT INTO `access_log` VALUES (2996, '30483aa8-d313-40a2-b472-f0657d43d517', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=5&roleIds=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:29', 7451, 0, '', '2019-05-16 17:35:36');
INSERT INTO `access_log` VALUES (2997, 'abd32d9d-a8bd-4b08-8a9f-1b9b45cbcf8b', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:39', 16, 0, '', '2019-05-16 17:35:39');
INSERT INTO `access_log` VALUES (2998, 'aaff149f-7c7f-4a75-b97c-e09b41829691', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:41', 12, 0, '', '2019-05-16 17:35:41');
INSERT INTO `access_log` VALUES (2999, '1b475d0e-e0a7-48e0-b900-649739e0091c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:41', 19, 0, '', '2019-05-16 17:35:41');
INSERT INTO `access_log` VALUES (3000, '43cfc140-9dc5-4d35-b38f-634f64e8d4a2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:41', 21, 0, '', '2019-05-16 17:35:41');
INSERT INTO `access_log` VALUES (3001, 'a102facc-316a-443f-9248-64df14232d66', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:35:41', 30, 0, '', '2019-05-16 17:35:41');
INSERT INTO `access_log` VALUES (3002, '6c441757-289a-4fca-aeb6-8f96214d85e1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:38:10', 14, 0, '', '2019-05-16 17:38:10');
INSERT INTO `access_log` VALUES (3003, '0ce456ba-1ff3-4b98-a58f-6be2f1e4ca0f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:38:10', 13, 0, '', '2019-05-16 17:38:10');
INSERT INTO `access_log` VALUES (3004, '9166ccaa-c662-4440-9e08-58ed7738227d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:38:10', 19, 0, '', '2019-05-16 17:38:10');
INSERT INTO `access_log` VALUES (3005, '98e16a65-42f2-47be-a4db-f3d7a324b7e7', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:38:10', 25, 0, '', '2019-05-16 17:38:10');
INSERT INTO `access_log` VALUES (3006, 'e66ddf78-f44d-445f-a16f-6fa351029617', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:38:11', 13, 0, '', '2019-05-16 17:38:11');
INSERT INTO `access_log` VALUES (3007, '461aa3ee-5f5c-4dca-881c-28a079b61f42', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:38:13', 11, 0, '', '2019-05-16 17:38:13');
INSERT INTO `access_log` VALUES (3008, 'bcf8af67-f9c8-4b02-8beb-a032d9ed0aeb', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:38:39', 12, 0, '', '2019-05-16 17:38:39');
INSERT INTO `access_log` VALUES (3009, '734a5539-6727-4005-a043-59b6d3d7f60d', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=13', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:38:47', 10, 0, '', '2019-05-16 17:38:47');
INSERT INTO `access_log` VALUES (3010, '6ec77775-b7aa-4e6e-b337-b058c8cad933', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:46:16', 512, 0, '', '2019-05-16 17:46:17');
INSERT INTO `access_log` VALUES (3011, '14475504-8c23-4bd8-af02-0eb05dccbe1d', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:46:16', 588, 0, '', '2019-05-16 17:46:17');
INSERT INTO `access_log` VALUES (3012, '416c81cf-c5e4-4b61-aaf7-1fe22022204f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:46:16', 512, 0, '', '2019-05-16 17:46:17');
INSERT INTO `access_log` VALUES (3013, 'f566b700-8b2a-4e3d-b602-ccd64ed7163a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:46:16', 511, 0, '', '2019-05-16 17:46:17');
INSERT INTO `access_log` VALUES (3014, '5ba292cd-9c4a-4339-bb84-e95bff48c68b', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:46:18', 130, 0, '', '2019-05-16 17:46:18');
INSERT INTO `access_log` VALUES (3015, '6b0e115e-1874-4bab-a82d-54f44b6c960c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:54:03', 348, 0, '', '2019-05-16 17:54:04');
INSERT INTO `access_log` VALUES (3016, '184fb30d-0157-4144-818c-8c17c3a38246', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:54:03', 348, 0, '', '2019-05-16 17:54:04');
INSERT INTO `access_log` VALUES (3017, 'e3f601ca-0c26-4448-8bb2-4190dec556a0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:54:03', 348, 0, '', '2019-05-16 17:54:04');
INSERT INTO `access_log` VALUES (3018, '8e8266b8-a390-47dd-a1a1-da107c29cb3e', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:54:06', 227, 0, '', '2019-05-16 17:54:06');
INSERT INTO `access_log` VALUES (3019, '8373ceaf-5e33-4749-aa31-c7b0442b5e0c', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:54:09', 59, 0, '', '2019-05-16 17:54:09');
INSERT INTO `access_log` VALUES (3020, 'f60c5d8b-69aa-450d-87a7-1a36e0e41ce9', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:54:11', 25, 0, '', '2019-05-16 17:54:11');
INSERT INTO `access_log` VALUES (3021, 'a22e8587-acab-415f-a2aa-6952e72aeef9', 1, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=2&resourceIds=31', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:54:13', 2877, 0, '', '2019-05-16 17:54:16');
INSERT INTO `access_log` VALUES (3022, '903bc5a2-6cef-4075-a55f-1a2b2fe02e0d', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:54:20', 16, 0, '', '2019-05-16 17:54:20');
INSERT INTO `access_log` VALUES (3023, 'd08bfcb8-4509-46c7-bafa-77a6449c5c4f', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 20:22:07', 181, 1002001012, '访问令牌已过期', '2019-05-16 20:22:08');
INSERT INTO `access_log` VALUES (3024, '800ebce0-6bf9-4569-a1a0-6692d7f9ff90', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 20:22:07', 181, 1002001012, '访问令牌已过期', '2019-05-16 20:22:08');
INSERT INTO `access_log` VALUES (3025, '1f65485f-ee45-4ead-b2b5-df0c5c76fdb2', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 20:22:07', 181, 1002001012, '访问令牌已过期', '2019-05-16 20:22:08');
INSERT INTO `access_log` VALUES (3026, 'b4aed53c-cd4f-47c5-bc88-8a180edad6e2', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 20:22:10', 205, 0, '', '2019-05-16 20:22:10');
INSERT INTO `access_log` VALUES (3027, '819dddfe-1448-47ad-ad9b-0c89b3c71107', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 20:22:10', 85, 0, '', '2019-05-16 20:22:10');
INSERT INTO `access_log` VALUES (3028, 'b843da93-bdb0-4bf2-998d-d0358552a563', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 20:22:10', 98, 0, '', '2019-05-16 20:22:10');
INSERT INTO `access_log` VALUES (3029, '959d6147-4be9-493e-b469-17a3383a7b71', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 20:22:10', 112, 0, '', '2019-05-16 20:22:10');
INSERT INTO `access_log` VALUES (3030, '38108a55-34c0-4dbc-ba3b-ea9575b51f0f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 20:22:14', 12, 0, '', '2019-05-16 20:22:14');
INSERT INTO `access_log` VALUES (3031, '36a812b6-7521-4145-9603-e541f3d1fab2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 20:22:14', 15, 0, '', '2019-05-16 20:22:14');
INSERT INTO `access_log` VALUES (3032, '0e6221d7-f543-4eb4-96d5-9ced7c978b60', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 20:22:14', 17, 0, '', '2019-05-16 20:22:14');
INSERT INTO `access_log` VALUES (3033, '6fa1e314-1f37-44aa-ac9f-f1656acee41a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 20:22:18', 36, 0, '', '2019-05-16 20:22:18');
INSERT INTO `access_log` VALUES (3034, '37.70.15580115245700017', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.152.145.201', '2019-05-16 20:58:45', 3, 0, '', '2019-05-16 20:58:45');
INSERT INTO `access_log` VALUES (3035, '37.68.15580115245810013', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.152.145.201', '2019-05-16 20:58:45', 2, 0, '', '2019-05-16 20:58:45');
INSERT INTO `access_log` VALUES (3036, '37.65.15580115245850013', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.152.145.201', '2019-05-16 20:58:45', 39, 0, '', '2019-05-16 20:58:45');
INSERT INTO `access_log` VALUES (3037, '35.75.15580159189270067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-16 22:11:59', 13, 0, '', '2019-05-16 22:11:59');
INSERT INTO `access_log` VALUES (3038, '35.72.15580159189240065', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-16 22:11:59', 54, 0, '', '2019-05-16 22:11:59');
INSERT INTO `access_log` VALUES (3039, '35.78.15580159744150063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-16 22:12:54', 36, 0, '', '2019-05-16 22:12:54');
INSERT INTO `access_log` VALUES (3040, '35.79.15580159744070065', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-16 22:12:54', 7, 0, '', '2019-05-16 22:12:54');
INSERT INTO `access_log` VALUES (3041, '32.84.15580159760970065', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-16 22:12:56', 382, 0, '', '2019-05-16 22:12:56');
INSERT INTO `access_log` VALUES (3042, '36.82.15580159767630009', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-16 22:12:57', 22, 0, '', '2019-05-16 22:12:57');
INSERT INTO `access_log` VALUES (3043, '31.45.15580159981530009', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13133336666&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-16 22:13:18', 259, 2001001000, '服务端发生异常', '2019-05-16 22:13:18');
INSERT INTO `access_log` VALUES (3044, '32.87.15580160026210067', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-16 22:13:23', 14, 0, '', '2019-05-16 22:13:23');
INSERT INTO `access_log` VALUES (3045, '36.81.15580160028140013', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-16 22:13:23', 20, 0, '', '2019-05-16 22:13:23');
INSERT INTO `access_log` VALUES (3046, '36.83.15580160080950009', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=37', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-16 22:13:28', 956, 0, '', '2019-05-16 22:13:29');
INSERT INTO `access_log` VALUES (3047, '36.84.15580160089340011', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-16 22:13:29', 506, 0, '', '2019-05-16 22:13:29');
INSERT INTO `access_log` VALUES (3048, '32.88.15580160235730067', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-16 22:13:44', 11, 0, '', '2019-05-16 22:13:44');
INSERT INTO `access_log` VALUES (3049, '36.86.15580160237700011', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-16 22:13:44', 15, 0, '', '2019-05-16 22:13:44');
INSERT INTO `access_log` VALUES (3050, '35.71.15580160712050063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.73.119.193', '2019-05-16 22:14:31', 4, 0, '', '2019-05-16 22:14:31');
INSERT INTO `access_log` VALUES (3051, '35.73.15580160712040065', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.73.119.193', '2019-05-16 22:14:31', 11, 0, '', '2019-05-16 22:14:31');
INSERT INTO `access_log` VALUES (3052, '37.72.15580160760770017', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.73.119.193', '2019-05-16 22:14:36', 10, 0, '', '2019-05-16 22:14:36');
INSERT INTO `access_log` VALUES (3053, '37.69.15580160760980021', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.73.119.193', '2019-05-16 22:14:36', 1, 0, '', '2019-05-16 22:14:36');
INSERT INTO `access_log` VALUES (3054, '37.67.15580160850650013', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.73.119.193', '2019-05-16 22:14:45', 2, 0, '', '2019-05-16 22:14:45');
INSERT INTO `access_log` VALUES (3055, '35.80.15580194775940061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9.0; HMA-AL00 Build/HUAWEIHMA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '223.104.63.87', '2019-05-16 23:11:18', 34, 0, '', '2019-05-16 23:11:18');
INSERT INTO `access_log` VALUES (3056, '35.74.15580194775930063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9.0; HMA-AL00 Build/HUAWEIHMA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '223.104.63.87', '2019-05-16 23:11:18', 58, 0, '', '2019-05-16 23:11:18');
INSERT INTO `access_log` VALUES (3057, '32.83.15580194808730067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9.0; HMA-AL00 Build/HUAWEIHMA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '223.104.63.87', '2019-05-16 23:11:21', 5, 0, '', '2019-05-16 23:11:21');
INSERT INTO `access_log` VALUES (3058, '32.79.15580194811010067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9.0; HMA-AL00 Build/HUAWEIHMA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '223.104.63.87', '2019-05-16 23:11:21', 4, 0, '', '2019-05-16 23:11:21');
INSERT INTO `access_log` VALUES (3059, '37.70.15580197435370019', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'name=系统管理员&pageSize=10&pageNo=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-16 23:15:44', 14, 0, '', '2019-05-16 23:15:44');
INSERT INTO `access_log` VALUES (3060, '37.65.15580197694760015', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'name=员&pageSize=10&pageNo=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-16 23:16:09', 9, 0, '', '2019-05-16 23:16:09');
INSERT INTO `access_log` VALUES (3061, '37.66.15580197791000017', 0, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-16 23:16:19', 133, 2001001000, '服务端发生异常', '2019-05-16 23:16:19');
INSERT INTO `access_log` VALUES (3062, '35.72.15580204386350067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:19', 153, 2001001000, '服务端发生异常', '2019-05-16 23:27:19');
INSERT INTO `access_log` VALUES (3063, '35.75.15580204386350069', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:19', 155, 2001001000, '服务端发生异常', '2019-05-16 23:27:19');
INSERT INTO `access_log` VALUES (3064, '32.85.15580204411380069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:21', 215, 2001001000, '服务端发生异常', '2019-05-16 23:27:21');
INSERT INTO `access_log` VALUES (3065, '36.87.15580204431870013', 0, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:23', 149, 2001001000, '服务端发生异常', '2019-05-16 23:27:23');
INSERT INTO `access_log` VALUES (3066, '32.81.15580204471540067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:27', 338, 2001001000, '服务端发生异常', '2019-05-16 23:27:27');
INSERT INTO `access_log` VALUES (3067, '35.79.15580204477870067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:28', 96, 2001001000, '服务端发生异常', '2019-05-16 23:27:28');
INSERT INTO `access_log` VALUES (3068, '35.78.15580204477860065', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:28', 97, 2001001000, '服务端发生异常', '2019-05-16 23:27:28');
INSERT INTO `access_log` VALUES (3069, '37.68.15580204608510015', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:41', 4, 1002001012, '访问令牌已过期', '2019-05-16 23:27:41');
INSERT INTO `access_log` VALUES (3070, '37.67.15580204608530015', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:41', 3, 1002001012, '访问令牌已过期', '2019-05-16 23:27:41');
INSERT INTO `access_log` VALUES (3071, '37.64.15580204608720017', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:41', 15, 1002001012, '访问令牌已过期', '2019-05-16 23:27:41');
INSERT INTO `access_log` VALUES (3072, '37.73.15580204717780013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:52', 5, 1002001012, '访问令牌已过期', '2019-05-16 23:27:52');
INSERT INTO `access_log` VALUES (3073, '37.71.15580204733120019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:53', 4, 1002001012, '访问令牌已过期', '2019-05-16 23:27:53');
INSERT INTO `access_log` VALUES (3074, '37.69.15580204743840025', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:54', 4, 1002001012, '访问令牌已过期', '2019-05-16 23:27:54');
INSERT INTO `access_log` VALUES (3075, '37.72.15580206103160019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:30:10', 5, 1002001012, '访问令牌已过期', '2019-05-16 23:30:10');
INSERT INTO `access_log` VALUES (3076, '37.70.15580206183080021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:30:18', 5, 1002001012, '访问令牌已过期', '2019-05-16 23:30:18');
INSERT INTO `access_log` VALUES (3077, '37.65.15580206193030017', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:30:19', 3, 1002001012, '访问令牌已过期', '2019-05-16 23:30:19');
INSERT INTO `access_log` VALUES (3078, '37.66.15580206201720019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:30:20', 5, 1002001012, '访问令牌已过期', '2019-05-16 23:30:20');
INSERT INTO `access_log` VALUES (3079, '37.67.15580206209990017', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:30:21', 4, 1002001012, '访问令牌已过期', '2019-05-16 23:30:21');
INSERT INTO `access_log` VALUES (3080, '37.68.15580206219180017', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:30:22', 4, 1002001012, '访问令牌已过期', '2019-05-16 23:30:22');
INSERT INTO `access_log` VALUES (3081, '37.64.15580206229570019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:30:23', 4, 1002001012, '访问令牌已过期', '2019-05-16 23:30:23');
INSERT INTO `access_log` VALUES (3082, '37.73.15580206296450015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:30:30', 734, 1002001012, '访问令牌已过期', '2019-05-16 23:30:30');
INSERT INTO `access_log` VALUES (3083, '37.71.15580206347650021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=12345&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:30:35', 4, 1002001012, '访问令牌已过期', '2019-05-16 23:30:35');
INSERT INTO `access_log` VALUES (3084, '37.68.15580208725300019', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-16 23:34:33', 2, 0, '', '2019-05-16 23:34:33');
INSERT INTO `access_log` VALUES (3085, '37.64.15580208725350021', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-16 23:34:33', 2, 0, '', '2019-05-16 23:34:33');
INSERT INTO `access_log` VALUES (3086, '37.73.15580208725350017', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.85.39', '2019-05-16 23:34:33', 13, 0, '', '2019-05-16 23:34:33');
INSERT INTO `access_log` VALUES (3087, '31.48.15580211716200009', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:39:32', 96, -1, '未授权', '2019-05-16 23:39:32');
INSERT INTO `access_log` VALUES (3088, '577aa853-c231-461d-b99d-1fe8b8b1485d', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 23:39:50', 245, 1001001012, '访问令牌已过期', '2019-05-16 23:39:50');
INSERT INTO `access_log` VALUES (3089, '0125387f-6a04-4176-83ae-3a38ba505241', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=9640c8b7a974462181eb221669d70702', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 23:39:50', 25, 1001001022, '访问令牌已过期', '2019-05-16 23:39:50');
INSERT INTO `access_log` VALUES (3090, 'e4364666-c708-4f07-8d83-844c933cd1f1', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 23:40:05', 754, 2001001000, '服务端发生异常', '2019-05-16 23:40:06');
INSERT INTO `access_log` VALUES (3091, '31.51.15580212162210011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'code=9999&mobile=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:40:16', 210, 2001001000, '服务端发生异常', '2019-05-16 23:40:16');
INSERT INTO `access_log` VALUES (3092, '31.50.15580212288000011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:40:29', 31, 2001001001, '参数缺失:Required String parameter \'mobile\' is not present', '2019-05-16 23:40:29');
INSERT INTO `access_log` VALUES (3093, '31.49.15580212456410009', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:40:46', 6, 2001001001, '参数缺失:Required String parameter \'mobile\' is not present', '2019-05-16 23:40:46');
INSERT INTO `access_log` VALUES (3094, '31.54.15580212466410011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:40:47', 4, 2001001001, '参数缺失:Required String parameter \'mobile\' is not present', '2019-05-16 23:40:47');
INSERT INTO `access_log` VALUES (3095, '31.53.15580212472960011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:40:47', 3, 2001001001, '参数缺失:Required String parameter \'mobile\' is not present', '2019-05-16 23:40:47');
INSERT INTO `access_log` VALUES (3096, '31.47.15580212497840011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:40:50', 3, 2001001001, '参数缺失:Required String parameter \'mobile\' is not present', '2019-05-16 23:40:50');
INSERT INTO `access_log` VALUES (3097, '31.52.15580212546430013', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:40:55', 3, 2001001001, '参数缺失:Required String parameter \'mobile\' is not present', '2019-05-16 23:40:55');
INSERT INTO `access_log` VALUES (3098, '31.46.15580212632810011', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:41:03', 73, 2001001000, '服务端发生异常', '2019-05-16 23:41:03');
INSERT INTO `access_log` VALUES (3099, '31.48.15580212659520011', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:41:06', 3, 2001001001, '参数缺失:Required String parameter \'mobile\' is not present', '2019-05-16 23:41:06');
INSERT INTO `access_log` VALUES (3100, '31.51.15580212763930013', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:41:16', 4, 2001001001, '参数缺失:Required String parameter \'mobile\' is not present', '2019-05-16 23:41:16');
INSERT INTO `access_log` VALUES (3101, '37.64.15580213516870023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=future&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:42:32', 175, 1002002000, '账号不存在', '2019-05-16 23:42:32');
INSERT INTO `access_log` VALUES (3102, '37.73.15580213711770019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:42:51', 5, 2001001001, '参数缺失:Required String parameter \'username\' is not present', '2019-05-16 23:42:51');
INSERT INTO `access_log` VALUES (3103, '37.72.15580213793040025', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=future&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:42:59', 7, 1002002000, '账号不存在', '2019-05-16 23:42:59');
INSERT INTO `access_log` VALUES (3104, '37.69.15580213885670027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=admin&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:43:09', 106, 0, '', '2019-05-16 23:43:09');
INSERT INTO `access_log` VALUES (3105, '37.65.15580213928960021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=admin&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:43:13', 56, 0, '', '2019-05-16 23:43:13');
INSERT INTO `access_log` VALUES (3106, '37.70.15580213939690023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=admin&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:43:14', 61, 0, '', '2019-05-16 23:43:14');
INSERT INTO `access_log` VALUES (3107, '37.66.15580214408880023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:44:01', 4, 2001001001, '参数缺失:Required String parameter \'username\' is not present', '2019-05-16 23:44:01');
INSERT INTO `access_log` VALUES (3108, '37.67.15580214470880021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=admin&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:44:07', 104, 0, '', '2019-05-16 23:44:07');
INSERT INTO `access_log` VALUES (3109, '37.68.15580214598400021', 0, 2, 'admin-application', '/admin-api/admins/role/add', 'name=系统管理员', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:44:20', 93, 0, '', '2019-05-16 23:44:20');
INSERT INTO `access_log` VALUES (3110, '32.86.15580215159880065', 0, 2, 'product-application', '/product-api/admins/attr/add', 'name=颜色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:45:16', 525, 1003003002, '商品规格已经存在', '2019-05-16 23:45:17');
INSERT INTO `access_log` VALUES (3111, '32.88.15580215215530071', 0, 2, 'product-application', '/product-api/admins/attr/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:45:22', 3, 2001001001, '参数缺失:Required String parameter \'name\' is not present', '2019-05-16 23:45:22');
INSERT INTO `access_log` VALUES (3112, '3df6e82a-b197-4d33-976d-fbe7b3ddd14f', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:09:03', 1488, 0, '', '2019-05-17 00:09:05');
INSERT INTO `access_log` VALUES (3113, 'd818a98b-d49b-42ee-b08f-a4b72ec34445', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:09:11', 108, 1001003003, '验证码不正确', '2019-05-17 00:09:11');
INSERT INTO `access_log` VALUES (3114, '4556f561-a6bf-4227-8c6a-56d4601b6767', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:09:15', 80, 1001003003, '验证码不正确', '2019-05-17 00:09:15');
INSERT INTO `access_log` VALUES (3115, 'fb7c6c54-f8e4-4d09-90cb-bd4d5a30fbd6', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:09:31', 21250, 1001003003, '验证码不正确', '2019-05-17 00:09:53');
INSERT INTO `access_log` VALUES (3116, '97100889-5e77-4242-8193-24fd6022d8d2', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:10:04', 6351, 1001003003, '验证码不正确', '2019-05-17 00:10:10');
INSERT INTO `access_log` VALUES (3117, '70469159-7b78-4b7b-bef5-2d2b4ee77593', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:12:45', 661, 2001001000, '服务端发生异常', '2019-05-17 00:12:46');
INSERT INTO `access_log` VALUES (3118, '16ab647c-4c45-4b4b-94e0-11a5a30981fd', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:13:49', 234, 2001001000, '服务端发生异常', '2019-05-17 00:13:49');
INSERT INTO `access_log` VALUES (3119, '5cc05de5-e556-4a70-ba79-7b905632c5a8', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:13:58', 227, 2001001000, '服务端发生异常', '2019-05-17 00:13:58');
INSERT INTO `access_log` VALUES (3120, 'f3ac414a-07de-4acf-b51f-896fd4d9d35c', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:18:02', 591, 2001001000, '服务端发生异常', '2019-05-17 00:18:03');
INSERT INTO `access_log` VALUES (3121, '6f003103-07cd-4af1-8e29-121a27a5f191', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:18:04', 327, 2001001000, '服务端发生异常', '2019-05-17 00:18:05');
INSERT INTO `access_log` VALUES (3122, 'e3c3689c-f4c7-4f03-a323-68259245e21f', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:19:50', 343, 0, '', '2019-05-17 00:19:50');
INSERT INTO `access_log` VALUES (3123, '122290e9-5277-4fa0-8a5a-a636578c7810', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:19:55', 11488, 2001001000, '服务端发生异常', '2019-05-17 00:20:07');
INSERT INTO `access_log` VALUES (3124, '6a6d5ad7-f721-4f9e-b794-40a3d3fab0d4', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:22:07', 293, 0, '', '2019-05-17 00:22:08');
INSERT INTO `access_log` VALUES (3125, '35243652-14d9-4ffc-95f6-a03bc238d48b', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:22:12', 11466, 0, '', '2019-05-17 00:22:23');
INSERT INTO `access_log` VALUES (3126, '5c0796c5-5169-425b-ba8d-942a6e3f666b', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:22:25', 44, 1001001011, '访问令牌不存在', '2019-05-17 00:22:25');
INSERT INTO `access_log` VALUES (3127, '7dcc33e3-4d79-4da2-a1f0-c370ca49740b', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:23:05', 18, 1001003005, '短信发送过于频率', '2019-05-17 00:23:05');
INSERT INTO `access_log` VALUES (3128, '3dfcb45f-a71c-4a18-9f34-f9dd4cfbb9ea', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:23:08', 87, 0, '', '2019-05-17 00:23:08');
INSERT INTO `access_log` VALUES (3129, '5fe48df6-87de-4fc9-a6c6-bcc715d4094d', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:23:12', 2151, 0, '', '2019-05-17 00:23:15');
INSERT INTO `access_log` VALUES (3130, '3deb9712-aafc-49ba-ad11-771d9f887b22', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:23:17', 21, 1001001011, '访问令牌不存在', '2019-05-17 00:23:17');
INSERT INTO `access_log` VALUES (3131, 'fb4042b5-ef75-4740-99fd-6a77f8931707', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:23:21', 91, 1001001011, '访问令牌不存在', '2019-05-17 00:23:21');
INSERT INTO `access_log` VALUES (3132, '650475be-b39a-4cbd-a46d-a6913b6dad59', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:23:53', 188, 1001003005, '短信发送过于频率', '2019-05-17 00:23:53');
INSERT INTO `access_log` VALUES (3133, '1690210a-2440-4aca-b092-7d06cb947042', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:23:56', 14, 1001003005, '短信发送过于频率', '2019-05-17 00:23:56');
INSERT INTO `access_log` VALUES (3134, 'ea2dbca4-a6fa-4ab6-956c-832d469be762', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:24:07', 20, 1001003005, '短信发送过于频率', '2019-05-17 00:24:07');
INSERT INTO `access_log` VALUES (3135, '399c3679-86c5-4e7b-8dd0-3b22449926e6', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:24:10', 279, 0, '', '2019-05-17 00:24:10');
INSERT INTO `access_log` VALUES (3136, 'e3d9487b-a20c-4717-a208-6ce79d0eb486', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:24:15', 2645, 0, '', '2019-05-17 00:24:18');
INSERT INTO `access_log` VALUES (3137, 'dffa07fb-d1c9-4831-9493-73a0a7ecc730', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:24:20', 18, 1001001011, '访问令牌不存在', '2019-05-17 00:24:20');
INSERT INTO `access_log` VALUES (3138, 'e87f16de-8676-4570-80cd-8a5332ef2a98', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691400', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:25:06', 116, 0, '', '2019-05-17 00:25:06');
INSERT INTO `access_log` VALUES (3139, '67f7af71-d8fc-49b0-bc90-94f9511a31f4', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691400&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:25:08', 4296, 0, '', '2019-05-17 00:25:12');
INSERT INTO `access_log` VALUES (3140, '43b1b8aa-5ee3-48ed-8b37-43322192296c', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:25:14', 11, 1001001011, '访问令牌不存在', '2019-05-17 00:25:14');
INSERT INTO `access_log` VALUES (3141, '598a8ed1-201d-4154-b38d-cad548d534e2', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691341', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:25:48', 1401, 0, '', '2019-05-17 00:25:50');
INSERT INTO `access_log` VALUES (3142, '892e9a16-0d05-4a5b-98af-b2d2e0374836', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691341&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:25:54', 441, 0, '', '2019-05-17 00:25:54');
INSERT INTO `access_log` VALUES (3143, '0b37c9d1-3537-49e0-8a59-460d9220a29b', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:26:07', 20, 1001001011, '访问令牌不存在', '2019-05-17 00:26:07');
INSERT INTO `access_log` VALUES (3144, 'd248bae6-5dff-4d33-a69c-1a8d48b19216', 72, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:34:58', 321, 0, '', '2019-05-17 00:34:58');
INSERT INTO `access_log` VALUES (3145, '2c87fe66-735f-4dfa-b808-7ccab5b2b3e7', 72, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:35:00', 30, 0, '', '2019-05-17 00:35:00');
INSERT INTO `access_log` VALUES (3146, '4bddd64b-2ba8-440b-96b8-efe13b201f4e', 72, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:35:05', 49, 0, '', '2019-05-17 00:35:05');
INSERT INTO `access_log` VALUES (3147, '11580525-6d25-44fb-898f-d19947e745be', 72, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:35:06', 23, 0, '', '2019-05-17 00:35:06');
INSERT INTO `access_log` VALUES (3148, '37.64.15580331454700025', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:05', 18, 1002001012, '访问令牌已过期', '2019-05-17 02:59:05');
INSERT INTO `access_log` VALUES (3149, '37.73.15580331469440021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:07', 5, 1002001012, '访问令牌已过期', '2019-05-17 02:59:07');
INSERT INTO `access_log` VALUES (3150, '37.72.15580331480330027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:08', 4, 1002001012, '访问令牌已过期', '2019-05-17 02:59:08');
INSERT INTO `access_log` VALUES (3151, '35.74.15580331661530065', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:26', 410, 2001001000, '服务端发生异常', '2019-05-17 02:59:27');
INSERT INTO `access_log` VALUES (3152, '35.80.15580331661520063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:26', 469, 2001001000, '服务端发生异常', '2019-05-17 02:59:27');
INSERT INTO `access_log` VALUES (3153, '32.80.15580331693640075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:29', 199, 2001001000, '服务端发生异常', '2019-05-17 02:59:30');
INSERT INTO `access_log` VALUES (3154, '35.76.15580331715380067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:32', 86, 2001001000, '服务端发生异常', '2019-05-17 02:59:32');
INSERT INTO `access_log` VALUES (3155, '35.77.15580331715390067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:32', 86, 2001001000, '服务端发生异常', '2019-05-17 02:59:32');
INSERT INTO `access_log` VALUES (3156, '31.54.15580331736810013', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:34', 263, 2001001000, '服务端发生异常', '2019-05-17 02:59:34');
INSERT INTO `access_log` VALUES (3157, '35.72.15580331762730069', 0, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:36', 116, 2001001000, '服务端发生异常', '2019-05-17 02:59:36');
INSERT INTO `access_log` VALUES (3158, '31.53.15580331785200013', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:39', 106, 2001001000, '服务端发生异常', '2019-05-17 02:59:39');
INSERT INTO `access_log` VALUES (3159, '36.89.15580331861600007', 0, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:46', 104, 2001001000, '服务端发生异常', '2019-05-17 02:59:46');
INSERT INTO `access_log` VALUES (3160, '36.81.15580331886480015', 0, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:49', 235, 2001001000, '服务端发生异常', '2019-05-17 02:59:49');
INSERT INTO `access_log` VALUES (3161, '36.84.15580331910340013', 0, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:51', 102, 2001001000, '服务端发生异常', '2019-05-17 02:59:51');
INSERT INTO `access_log` VALUES (3162, '31.47.15580331932340013', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:53', 105, 2001001000, '服务端发生异常', '2019-05-17 02:59:53');
INSERT INTO `access_log` VALUES (3163, '35.79.15580573173140069', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.92.33.48', '2019-05-17 09:41:57', 16, 0, '', '2019-05-17 09:41:57');
INSERT INTO `access_log` VALUES (3164, '35.78.15580573173140067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.92.33.48', '2019-05-17 09:41:57', 30, 0, '', '2019-05-17 09:41:57');
INSERT INTO `access_log` VALUES (3165, '35.71.15580574424230067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.129.50.215', '2019-05-17 09:44:02', 744, 0, '', '2019-05-17 09:44:03');
INSERT INTO `access_log` VALUES (3166, '35.73.15580574424280069', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.129.50.215', '2019-05-17 09:44:02', 751, 0, '', '2019-05-17 09:44:03');
INSERT INTO `access_log` VALUES (3167, '37.64.15580577894640027', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.170.219.228', '2019-05-17 09:49:49', 3, 0, '', '2019-05-17 09:49:49');
INSERT INTO `access_log` VALUES (3168, '37.73.15580577894660023', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.170.219.228', '2019-05-17 09:49:49', 8, 0, '', '2019-05-17 09:49:49');
INSERT INTO `access_log` VALUES (3169, '37.65.15580577894830023', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.170.219.228', '2019-05-17 09:49:49', 2, 0, '', '2019-05-17 09:49:49');
INSERT INTO `access_log` VALUES (3170, '35.74.15580603721960067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:32:52', 15, 0, '', '2019-05-17 10:32:52');
INSERT INTO `access_log` VALUES (3171, '35.80.15580603721970065', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:32:52', 40, 0, '', '2019-05-17 10:32:52');
INSERT INTO `access_log` VALUES (3172, '32.79.15580603765020069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:32:57', 6, 0, '', '2019-05-17 10:32:57');
INSERT INTO `access_log` VALUES (3173, '32.82.15580603766120069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:32:57', 3, 0, '', '2019-05-17 10:32:57');
INSERT INTO `access_log` VALUES (3174, '32.83.15580603789550071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:32:59', 4, 0, '', '2019-05-17 10:32:59');
INSERT INTO `access_log` VALUES (3175, '32.86.15580603799080067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:33:00', 4, 0, '', '2019-05-17 10:33:00');
INSERT INTO `access_log` VALUES (3176, '32.88.15580603807080073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:33:01', 4, 0, '', '2019-05-17 10:33:01');
INSERT INTO `access_log` VALUES (3177, '35.76.15580603820250069', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:33:02', 6, 0, '', '2019-05-17 10:33:02');
INSERT INTO `access_log` VALUES (3178, '35.77.15580603820280069', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:33:02', 13, 0, '', '2019-05-17 10:33:02');
INSERT INTO `access_log` VALUES (3179, '32.87.15580603888020071', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:33:09', 11, 0, '', '2019-05-17 10:33:09');
INSERT INTO `access_log` VALUES (3180, '36.85.15580603894540015', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:33:09', 19, 0, '', '2019-05-17 10:33:09');
INSERT INTO `access_log` VALUES (3181, '35.72.15580603971210071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:33:17', 5, 0, '', '2019-05-17 10:33:17');
INSERT INTO `access_log` VALUES (3182, '35.75.15580603971200073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:33:17', 10, 0, '', '2019-05-17 10:33:17');
INSERT INTO `access_log` VALUES (3183, '32.80.15580603983190077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:33:18', 4, 0, '', '2019-05-17 10:33:18');
INSERT INTO `access_log` VALUES (3184, '32.84.15580603984210069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.120.2', '2019-05-17 10:33:18', 3, 0, '', '2019-05-17 10:33:18');
INSERT INTO `access_log` VALUES (3185, '35.79.15580608520180071', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:40:52', 12, 0, '', '2019-05-17 10:40:52');
INSERT INTO `access_log` VALUES (3186, '35.78.15580608520170069', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:40:52', 7, 0, '', '2019-05-17 10:40:52');
INSERT INTO `access_log` VALUES (3187, '32.81.15580608575960073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:40:58', 3, 0, '', '2019-05-17 10:40:58');
INSERT INTO `access_log` VALUES (3188, '32.85.15580608577210073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:40:58', 3, 0, '', '2019-05-17 10:40:58');
INSERT INTO `access_log` VALUES (3189, '35.73.15580608595440071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:41:00', 4, 0, '', '2019-05-17 10:41:00');
INSERT INTO `access_log` VALUES (3190, '35.71.15580608595460069', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:41:00', 43, 0, '', '2019-05-17 10:41:00');
INSERT INTO `access_log` VALUES (3191, '32.79.15580608604460071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:41:00', 4, 0, '', '2019-05-17 10:41:00');
INSERT INTO `access_log` VALUES (3192, '32.82.15580608605610071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:41:01', 4, 0, '', '2019-05-17 10:41:01');
INSERT INTO `access_log` VALUES (3193, '32.83.15580608640050073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:41:04', 4, 0, '', '2019-05-17 10:41:04');
INSERT INTO `access_log` VALUES (3194, '32.86.15580608641180069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:41:04', 3, 0, '', '2019-05-17 10:41:04');
INSERT INTO `access_log` VALUES (3195, '32.88.15580608739580075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:41:14', 4, 0, '', '2019-05-17 10:41:14');
INSERT INTO `access_log` VALUES (3196, '32.87.15580608740640073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:41:14', 4, 0, '', '2019-05-17 10:41:14');
INSERT INTO `access_log` VALUES (3197, '35.74.15580608751670069', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:41:15', 4, 0, '', '2019-05-17 10:41:15');
INSERT INTO `access_log` VALUES (3198, '35.80.15580608751670067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:41:15', 14, 0, '', '2019-05-17 10:41:15');
INSERT INTO `access_log` VALUES (3199, '35.77.15580608821430071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:41:22', 4, 0, '', '2019-05-17 10:41:22');
INSERT INTO `access_log` VALUES (3200, '35.76.15580608821440071', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:41:22', 9, 0, '', '2019-05-17 10:41:22');
INSERT INTO `access_log` VALUES (3201, '35.72.15580608891120073', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:41:29', 4, 0, '', '2019-05-17 10:41:29');
INSERT INTO `access_log` VALUES (3202, '35.75.15580608891140075', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.192.8.167', '2019-05-17 10:41:29', 13, 0, '', '2019-05-17 10:41:29');
INSERT INTO `access_log` VALUES (3203, '4e129bd3-9876-4bdd-84f4-35e5de11c8d8', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 10:51:43', 278, 1002001012, '访问令牌已过期', '2019-05-17 10:51:43');
INSERT INTO `access_log` VALUES (3204, '2a0d623b-c23e-430f-9f0d-dcd502a78683', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 10:52:21', 177, 0, '', '2019-05-17 10:52:21');
INSERT INTO `access_log` VALUES (3205, '189491ad-c65d-44e8-a9a3-b94de3a19e1c', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 10:52:26', 370, 0, '', '2019-05-17 10:52:26');
INSERT INTO `access_log` VALUES (3206, '6daa138b-d010-4132-9620-c3517d981638', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 10:52:28', 20, 0, '', '2019-05-17 10:52:28');
INSERT INTO `access_log` VALUES (3207, 'a3b40674-ff36-4c3a-97d1-f317fd1c8888', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 10:52:33', 3, 1002001015, '账号未登陆', '2019-05-17 10:52:33');
INSERT INTO `access_log` VALUES (3208, '41364d23-2397-4a95-b0ed-66aeb1c6e5ea', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 10:52:35', 1, 1002001015, '账号未登陆', '2019-05-17 10:52:35');
INSERT INTO `access_log` VALUES (3209, '0f3cb307-c339-4d54-8d0a-5b4a01cb6b54', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 10:54:05', 14, 0, '', '2019-05-17 10:54:05');
INSERT INTO `access_log` VALUES (3210, '1f68cbb9-6fca-4aaa-bbbe-aa6ca9f0c433', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 10:54:12', 14, 0, '', '2019-05-17 10:54:12');
INSERT INTO `access_log` VALUES (3211, '28020f35-22cb-4e96-bff4-fb22ae9dedb9', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 10:54:13', 12, 0, '', '2019-05-17 10:54:13');
INSERT INTO `access_log` VALUES (3212, '2666c224-6ff0-422c-acea-1e1045e84849', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 10:58:52', 15, 0, '', '2019-05-17 10:58:52');
INSERT INTO `access_log` VALUES (3213, 'ae45946a-a2a4-4204-a355-64f4a0241fe5', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 10:59:07', 10, 0, '', '2019-05-17 10:59:07');
INSERT INTO `access_log` VALUES (3214, '2c48910a-8ddc-44cb-8582-8e5883007960', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:05:48', 13, 0, '', '2019-05-17 11:05:48');
INSERT INTO `access_log` VALUES (3215, '33e15bde-eb40-4437-8357-ef4463b92142', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:06:24', 10, 0, '', '2019-05-17 11:06:24');
INSERT INTO `access_log` VALUES (3216, 'a9554b0f-b214-4279-a803-55fa57a780f0', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:06:25', 12, 0, '', '2019-05-17 11:06:25');
INSERT INTO `access_log` VALUES (3217, '16861c60-8642-475c-bfaa-38e589d7579c', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:06:27', 10, 0, '', '2019-05-17 11:06:27');
INSERT INTO `access_log` VALUES (3218, '7a0a212e-4bee-4a10-b46f-d6cb7036564b', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:06:41', 12, 0, '', '2019-05-17 11:06:41');
INSERT INTO `access_log` VALUES (3219, '222ed10e-edbd-4790-b907-6c53b01a28e1', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:06:54', 11, 0, '', '2019-05-17 11:06:54');
INSERT INTO `access_log` VALUES (3220, 'e77b4254-4be3-4dab-806e-0d11b85f0c70', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:07:00', 12, 0, '', '2019-05-17 11:07:00');
INSERT INTO `access_log` VALUES (3221, '37.66.15580624586840027', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:07:39', 2, 0, '', '2019-05-17 11:07:39');
INSERT INTO `access_log` VALUES (3222, '37.69.15580624586840031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:07:39', 2, 0, '', '2019-05-17 11:07:39');
INSERT INTO `access_log` VALUES (3223, '37.68.15580624586870025', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:07:39', 16, 0, '', '2019-05-17 11:07:39');
INSERT INTO `access_log` VALUES (3224, '35.79.15580624881360073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:08', 15, 0, '', '2019-05-17 11:08:08');
INSERT INTO `access_log` VALUES (3225, '35.78.15580624881360071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:08', 20, 0, '', '2019-05-17 11:08:08');
INSERT INTO `access_log` VALUES (3226, '32.80.15580624969820079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:17', 382, 0, '', '2019-05-17 11:08:17');
INSERT INTO `access_log` VALUES (3227, '32.84.15580624975530071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:18', 3, 0, '', '2019-05-17 11:08:18');
INSERT INTO `access_log` VALUES (3228, '32.81.15580624986610075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:19', 4, 0, '', '2019-05-17 11:08:19');
INSERT INTO `access_log` VALUES (3229, '32.85.15580624991830075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:19', 7, 0, '', '2019-05-17 11:08:19');
INSERT INTO `access_log` VALUES (3230, '32.79.15580624995580073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:20', 4, 0, '', '2019-05-17 11:08:20');
INSERT INTO `access_log` VALUES (3231, '35.73.15580625005160073', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:21', 5, 0, '', '2019-05-17 11:08:21');
INSERT INTO `access_log` VALUES (3232, '35.71.15580625005180071', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:21', 11, 0, '', '2019-05-17 11:08:21');
INSERT INTO `access_log` VALUES (3233, '32.82.15580625022910073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:22', 3, 0, '', '2019-05-17 11:08:22');
INSERT INTO `access_log` VALUES (3234, '32.83.15580625024030075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:22', 3, 0, '', '2019-05-17 11:08:22');
INSERT INTO `access_log` VALUES (3235, '31.52.15580625138870015', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13900223331&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:34', 416, 2001001000, '服务端发生异常', '2019-05-17 11:08:34');
INSERT INTO `access_log` VALUES (3236, '32.86.15580625169030071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:37', 201, 0, '', '2019-05-17 11:08:37');
INSERT INTO `access_log` VALUES (3237, '32.88.15580625173160077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:37', 4, 0, '', '2019-05-17 11:08:37');
INSERT INTO `access_log` VALUES (3238, '35.74.15580625177750071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:38', 4, 0, '', '2019-05-17 11:08:38');
INSERT INTO `access_log` VALUES (3239, '35.80.15580625177760069', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:38', 11, 0, '', '2019-05-17 11:08:38');
INSERT INTO `access_log` VALUES (3240, '37.67.15580631829260025', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.165', '2019-05-17 11:19:43', 2, 0, '', '2019-05-17 11:19:43');
INSERT INTO `access_log` VALUES (3241, '37.72.15580631829270029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.165', '2019-05-17 11:19:43', 1, 0, '', '2019-05-17 11:19:43');
INSERT INTO `access_log` VALUES (3242, '37.71.15580631829290033', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.165', '2019-05-17 11:19:43', 8, 0, '', '2019-05-17 11:19:43');
INSERT INTO `access_log` VALUES (3243, '804ccf17-97d0-4fad-ba02-121ae66d5e0c', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:52:19', 415, 1002001012, '访问令牌已过期', '2019-05-17 11:52:20');
INSERT INTO `access_log` VALUES (3244, '2da46dc4-a8e9-4603-9788-b80a8a51096d', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:52:28', 11, 1002001012, '访问令牌已过期', '2019-05-17 11:52:28');
INSERT INTO `access_log` VALUES (3245, 'b219013a-8a1f-482d-a617-7e534edd8aed', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:52:32', 10, 1002001012, '访问令牌已过期', '2019-05-17 11:52:32');
INSERT INTO `access_log` VALUES (3246, '21e2beec-a593-4106-8e04-32f3c69bab63', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:56:29', 26, 1002001012, '访问令牌已过期', '2019-05-17 11:56:29');
INSERT INTO `access_log` VALUES (3247, '58be333b-d8ec-49c0-bc68-c5d70c0fbf58', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=53a7619e43b748499579bb7ce44f236c', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:56:29', 245, 2001001000, '服务端发生异常', '2019-05-17 11:56:30');
INSERT INTO `access_log` VALUES (3248, '7d0db966-b1a5-45dc-9831-b21a828f3b9e', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:58:08', 319, 1002001012, '访问令牌已过期', '2019-05-17 11:58:08');
INSERT INTO `access_log` VALUES (3249, 'd0dcf0e3-b156-4d8e-b47f-bd26d29330a6', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=53a7619e43b748499579bb7ce44f236c', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:58:09', 224, 0, '', '2019-05-17 11:58:09');
INSERT INTO `access_log` VALUES (3250, 'da5258f6-b059-4423-b368-5bfeed1611a3', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:58:09', 65, 0, '', '2019-05-17 11:58:09');
INSERT INTO `access_log` VALUES (3251, '35.75.15580655570820077', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-17 11:59:17', 242, 2001001000, '服务端发生异常', '2019-05-17 11:59:17');
INSERT INTO `access_log` VALUES (3252, '35.72.15580655570830075', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-17 11:59:17', 241, 2001001000, '服务端发生异常', '2019-05-17 11:59:17');
INSERT INTO `access_log` VALUES (3253, '35.79.15580694744120075', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:04:34', 13, 0, '', '2019-05-17 13:04:34');
INSERT INTO `access_log` VALUES (3254, '35.78.15580694744130073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:04:34', 36, 0, '', '2019-05-17 13:04:34');
INSERT INTO `access_log` VALUES (3255, '32.87.15580694858670075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:04:46', 6, 0, '', '2019-05-17 13:04:46');
INSERT INTO `access_log` VALUES (3256, '32.80.15580694859800081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:04:46', 3, 0, '', '2019-05-17 13:04:46');
INSERT INTO `access_log` VALUES (3257, '32.84.15580694891350073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:04:49', 4, 0, '', '2019-05-17 13:04:49');
INSERT INTO `access_log` VALUES (3258, '32.81.15580694898000077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:04:50', 4, 0, '', '2019-05-17 13:04:50');
INSERT INTO `access_log` VALUES (3259, '35.73.15580694913290075', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:04:51', 6, 0, '', '2019-05-17 13:04:51');
INSERT INTO `access_log` VALUES (3260, '35.71.15580694913290073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:04:51', 13, 0, '', '2019-05-17 13:04:51');
INSERT INTO `access_log` VALUES (3261, '32.85.15580694939310077', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:04:54', 36, 0, '', '2019-05-17 13:04:54');
INSERT INTO `access_log` VALUES (3262, '36.88.15580694940820011', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=50', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:04:54', 21, 0, '', '2019-05-17 13:04:54');
INSERT INTO `access_log` VALUES (3263, '32.79.15580695102380075', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:05:10', 21, 0, '', '2019-05-17 13:05:10');
INSERT INTO `access_log` VALUES (3264, '36.90.15580695103480015', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=50', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:05:10', 20, 0, '', '2019-05-17 13:05:10');
INSERT INTO `access_log` VALUES (3265, '35.80.15580695109210071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:05:11', 4, 0, '', '2019-05-17 13:05:11');
INSERT INTO `access_log` VALUES (3266, '35.74.15580695109210073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:05:11', 12, 0, '', '2019-05-17 13:05:11');
INSERT INTO `access_log` VALUES (3267, '32.82.15580695364350075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:05:36', 4, 0, '', '2019-05-17 13:05:36');
INSERT INTO `access_log` VALUES (3268, '32.83.15580695365300077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:05:37', 4, 0, '', '2019-05-17 13:05:37');
INSERT INTO `access_log` VALUES (3269, '35.76.15580695391860075', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:05:39', 139, 0, '', '2019-05-17 13:05:39');
INSERT INTO `access_log` VALUES (3270, '35.77.15580695391860075', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:05:39', 145, 0, '', '2019-05-17 13:05:39');
INSERT INTO `access_log` VALUES (3271, '37.71.15580695496420037', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:05:50', 2, 0, '', '2019-05-17 13:05:50');
INSERT INTO `access_log` VALUES (3272, '37.68.15580695496420027', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:05:50', 2, 0, '', '2019-05-17 13:05:50');
INSERT INTO `access_log` VALUES (3273, '37.69.15580695496460033', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '61.152.71.206', '2019-05-17 13:05:50', 7, 0, '', '2019-05-17 13:05:50');
INSERT INTO `access_log` VALUES (3274, 'ec47f397-78c2-469f-9190-5e2cc1d96444', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:27:38', 178, 1002001012, '访问令牌已过期', '2019-05-17 13:27:39');
INSERT INTO `access_log` VALUES (3275, '8505099d-aba1-494b-ab2f-bcd60ef501a7', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:27:38', 178, 1002001012, '访问令牌已过期', '2019-05-17 13:27:39');
INSERT INTO `access_log` VALUES (3276, '47b8fdfd-e9bf-43f7-bada-16c48b4a4df2', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:27:38', 178, 1002001012, '访问令牌已过期', '2019-05-17 13:27:39');
INSERT INTO `access_log` VALUES (3277, '70441f4e-8ed7-4d0e-8de0-33329ef2d8ae', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:28:28', 145, 0, '', '2019-05-17 13:28:29');
INSERT INTO `access_log` VALUES (3278, '3ae3af76-8378-4fc3-8b82-fb772fa2f997', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:28:29', 118, 0, '', '2019-05-17 13:28:29');
INSERT INTO `access_log` VALUES (3279, 'c8729148-89f0-4238-ab6d-f64e8ff4674d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:28:29', 131, 0, '', '2019-05-17 13:28:29');
INSERT INTO `access_log` VALUES (3280, 'b1368b1d-22c0-4dac-b822-cfa548d25b86', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:28:29', 132, 0, '', '2019-05-17 13:28:29');
INSERT INTO `access_log` VALUES (3281, 'ad00f10e-7738-4f54-8aef-852ef0cea7c3', 0, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:28:41', 341, 2001001000, '服务端发生异常', '2019-05-17 13:28:42');
INSERT INTO `access_log` VALUES (3282, '4fdcb7db-fa16-4ced-8055-85e37f319b13', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:29:42', 380, 0, '', '2019-05-17 13:29:42');
INSERT INTO `access_log` VALUES (3283, '18fc1a9a-c044-4677-969c-0512a07516d8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:29:42', 380, 0, '', '2019-05-17 13:29:42');
INSERT INTO `access_log` VALUES (3284, 'c4c15d1a-4a19-4aa6-91f8-98903613ff30', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:29:42', 380, 0, '', '2019-05-17 13:29:42');
INSERT INTO `access_log` VALUES (3285, 'adc72435-cb73-4717-a1fa-8f99bae6460a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:30:08', 14, 0, '', '2019-05-17 13:30:08');
INSERT INTO `access_log` VALUES (3286, '00419167-80d2-4234-bfec-56f6fccefd6a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:30:08', 19, 0, '', '2019-05-17 13:30:08');
INSERT INTO `access_log` VALUES (3287, 'f5e3fddb-f2ae-4f8e-a5ea-945aacc3d183', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:30:08', 21, 0, '', '2019-05-17 13:30:08');
INSERT INTO `access_log` VALUES (3288, '9b2cb003-fb8d-4427-ba89-5e989b4009bd', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:30:10', 3503, 2001001000, '服务端发生异常', '2019-05-17 13:30:14');
INSERT INTO `access_log` VALUES (3289, 'fe900cc5-5858-47f7-bab8-8ddedf4edc83', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:30:27', 12, 0, '', '2019-05-17 13:30:27');
INSERT INTO `access_log` VALUES (3290, '7ee78001-848b-4488-b627-70c3444450e4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:30:27', 16, 0, '', '2019-05-17 13:30:27');
INSERT INTO `access_log` VALUES (3291, '4329fdee-4e14-4135-8414-9d8208aaf22e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:30:27', 15, 0, '', '2019-05-17 13:30:27');
INSERT INTO `access_log` VALUES (3292, 'c73a3253-3eef-4ec5-85eb-cae7342cddeb', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:30:27', 178, 2001001000, '服务端发生异常', '2019-05-17 13:30:27');
INSERT INTO `access_log` VALUES (3293, 'e76d1a17-5d49-4213-a61d-6dd28730f4f1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:33:49', 15, 0, '', '2019-05-17 13:33:49');
INSERT INTO `access_log` VALUES (3294, 'f7669a67-3196-478d-a2cd-cc67e44d5632', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:33:49', 15, 0, '', '2019-05-17 13:33:49');
INSERT INTO `access_log` VALUES (3295, '5574269a-27eb-40e3-8992-95a2b43c5620', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:33:49', 14, 0, '', '2019-05-17 13:33:49');
INSERT INTO `access_log` VALUES (3296, '05494eb5-a409-4f1c-b0d1-509eb89abd75', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:33:50', 420, 0, '', '2019-05-17 13:33:50');
INSERT INTO `access_log` VALUES (3297, 'acb20060-b158-4454-80b8-ad4cdb91db47', 1, 2, 'order-application', '/order-api/admins/order/cancel_order', 'orderId=49&reasons=1', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:34:14', 1596, 0, '', '2019-05-17 13:34:16');
INSERT INTO `access_log` VALUES (3298, 'f6e96023-8bff-4236-881b-8c187f16a90e', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:34:16', 88, 0, '', '2019-05-17 13:34:16');
INSERT INTO `access_log` VALUES (3299, 'eab8196f-2a6b-4ec2-b937-99311c1f2e84', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:34:47', 97, 0, '', '2019-05-17 13:34:47');
INSERT INTO `access_log` VALUES (3300, '707f708b-2dc3-4599-b18f-53fff4411a49', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:34:52', 29, 0, '', '2019-05-17 13:34:52');
INSERT INTO `access_log` VALUES (3301, '255d2f79-2c66-405e-9010-99af35ff5a4b', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:44:59', 10, 1002001012, '访问令牌已过期', '2019-05-17 13:44:59');
INSERT INTO `access_log` VALUES (3302, 'e49114b5-8d4f-4e76-9c26-f8d51ff0cae0', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:44:59', 15, 1002001012, '访问令牌已过期', '2019-05-17 13:44:59');
INSERT INTO `access_log` VALUES (3303, 'd61e3f7b-0867-42d0-97d0-ea8c17263f6b', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:44:59', 5, 1002001012, '访问令牌已过期', '2019-05-17 13:44:59');
INSERT INTO `access_log` VALUES (3304, '3acb7e6f-c7df-4c02-82a6-550e38ea57e6', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:45:05', 364, 0, '', '2019-05-17 13:45:06');
INSERT INTO `access_log` VALUES (3305, '3bc57927-8db1-42b0-9b86-2cc3adb542b1', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:45:05', 615, 0, '', '2019-05-17 13:45:06');
INSERT INTO `access_log` VALUES (3306, '7c179f65-f3b0-48fd-b039-7c8b67c7258b', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:45:11', 23, 0, '', '2019-05-17 13:45:11');
INSERT INTO `access_log` VALUES (3307, 'ec6f96ec-13f8-421d-a9c8-5090d146d581', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:45:11', 13, 0, '', '2019-05-17 13:45:11');
INSERT INTO `access_log` VALUES (3308, 'ffe53a85-951b-4f3a-99af-489efe7903f7', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:45:15', 143, 0, '', '2019-05-17 13:45:15');
INSERT INTO `access_log` VALUES (3309, '7b4bd10b-6a34-453d-8650-72e3ba8880b6', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:45:15', 22, 0, '', '2019-05-17 13:45:15');
INSERT INTO `access_log` VALUES (3310, '3e78656f-9ad3-4539-9c90-44fa13f4ca8e', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:45:15', 81, 0, '', '2019-05-17 13:45:16');
INSERT INTO `access_log` VALUES (3311, '69c5511d-3c71-4cd2-a2cf-af453c5325df', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:45:15', 92, 0, '', '2019-05-17 13:45:16');
INSERT INTO `access_log` VALUES (3312, '163ea132-d954-4c59-946a-1b507197b2ca', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:45:39', 180, 1002001012, '访问令牌已过期', '2019-05-17 13:45:39');
INSERT INTO `access_log` VALUES (3313, '01073d37-48fc-4e3f-a433-62414057ebaf', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=53a7619e43b748499579bb7ce44f236c', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:45:39', 207, 0, '', '2019-05-17 13:45:40');
INSERT INTO `access_log` VALUES (3314, '61aa6421-7c90-45e8-966e-d84c7ae0ffc1', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:45:40', 100, 0, '', '2019-05-17 13:45:40');
INSERT INTO `access_log` VALUES (3315, 'c4b608b8-d1cf-4df0-bf8a-6862bec36d40', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:45:41', 15, 0, '', '2019-05-17 13:45:41');
INSERT INTO `access_log` VALUES (3316, '89222a25-6944-473e-9b7f-285d33d2967e', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:45:41', 40, 0, '', '2019-05-17 13:45:41');
INSERT INTO `access_log` VALUES (3317, '0a7f8850-4969-4473-b27e-c1e774eb94fa', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:32', 11, 0, '', '2019-05-17 13:46:32');
INSERT INTO `access_log` VALUES (3318, '3b20d221-45a7-425c-b92d-7fee3f9d574e', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:34', 11, 0, '', '2019-05-17 13:46:34');
INSERT INTO `access_log` VALUES (3319, '16ee051c-4836-4857-99b7-64d30cd02877', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:34', 20, 0, '', '2019-05-17 13:46:34');
INSERT INTO `access_log` VALUES (3320, 'ccdb0ba0-25e2-4ce2-81e1-6cfdf5617883', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:35', 11, 0, '', '2019-05-17 13:46:35');
INSERT INTO `access_log` VALUES (3321, 'a90df6b1-8f81-455d-9ff9-5b10c7da607c', 1, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:36', 59, 0, '', '2019-05-17 13:46:36');
INSERT INTO `access_log` VALUES (3322, 'a9434e8e-70f7-4700-b1b5-7ab49642bb29', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:37', 10, 0, '', '2019-05-17 13:46:37');
INSERT INTO `access_log` VALUES (3323, '1dd1fd5e-cb5f-42b1-81b8-ce1423b9e461', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:38', 14, 0, '', '2019-05-17 13:46:38');
INSERT INTO `access_log` VALUES (3324, '1a66a511-c621-4cc7-ae72-e89493788718', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:38', 10, 0, '', '2019-05-17 13:46:38');
INSERT INTO `access_log` VALUES (3325, '190274f5-8ffa-49ce-a340-fcde29e3bc83', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:39', 9, 0, '', '2019-05-17 13:46:39');
INSERT INTO `access_log` VALUES (3326, '399982f4-d7b4-47fc-a1be-44621331956a', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:40', 8, 0, '', '2019-05-17 13:46:40');
INSERT INTO `access_log` VALUES (3327, 'fa16e027-7a1f-41e3-b0dc-2646ef6ddeb1', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:41', 13, 0, '', '2019-05-17 13:46:41');
INSERT INTO `access_log` VALUES (3328, 'ef1c5d90-8476-4a6f-b65c-c7c6bc9c7a0e', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:41', 20, 0, '', '2019-05-17 13:46:41');
INSERT INTO `access_log` VALUES (3329, '4d61a027-6d78-4eba-b989-df94c4b4738a', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:43', 13, 0, '', '2019-05-17 13:46:43');
INSERT INTO `access_log` VALUES (3330, '1c6a2859-987a-442e-a392-677bcc5c717f', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:43', 78, 0, '', '2019-05-17 13:46:43');
INSERT INTO `access_log` VALUES (3331, 'c6f33601-bf9f-4d9d-9f84-7c06c9637adf', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:43', 134, 0, '', '2019-05-17 13:46:43');
INSERT INTO `access_log` VALUES (3332, '334f0ca0-cd16-489d-978f-95e50ca77a82', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:44', 11, 0, '', '2019-05-17 13:46:44');
INSERT INTO `access_log` VALUES (3333, '8425e027-97d6-4cd7-ba58-c1c3f4952c5a', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:44', 18, 0, '', '2019-05-17 13:46:44');
INSERT INTO `access_log` VALUES (3334, '86a2286d-04ea-4f5c-bc8e-710279e4ad28', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:45', 17, 0, '', '2019-05-17 13:46:45');
INSERT INTO `access_log` VALUES (3335, '2c55d67a-511c-4ec4-bf55-908ca234f1c7', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:49', 11, 0, '', '2019-05-17 13:46:49');
INSERT INTO `access_log` VALUES (3336, '82a9f9de-7a9b-422d-aa68-35ed875f9950', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:49', 18, 0, '', '2019-05-17 13:46:49');
INSERT INTO `access_log` VALUES (3337, '8ff61b51-5b18-4d2e-b27d-f75744d88aef', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:51', 10, 0, '', '2019-05-17 13:46:51');
INSERT INTO `access_log` VALUES (3338, '95066f11-f9bb-4c4d-919a-ce156a0e64ae', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:51', 18, 0, '', '2019-05-17 13:46:51');
INSERT INTO `access_log` VALUES (3339, 'f97c0864-1ffd-41b6-aa3d-5292646a2bd7', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:51', 18, 0, '', '2019-05-17 13:46:51');
INSERT INTO `access_log` VALUES (3340, 'fcc91dde-90da-4529-a4f3-a2a901afa642', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:55', 441, 0, '', '2019-05-17 13:46:55');
INSERT INTO `access_log` VALUES (3341, 'c197817a-ce36-47b1-a026-3f8086c08027', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=40&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:55', 505, 0, '', '2019-05-17 13:46:55');
INSERT INTO `access_log` VALUES (3342, '561cc770-fd23-4a93-82c4-5306ab39cb99', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:56', 14, 0, '', '2019-05-17 13:46:56');
INSERT INTO `access_log` VALUES (3343, '14bfd403-bef6-4b5f-bfdd-a69d605ec575', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:56', 26, 0, '', '2019-05-17 13:46:56');
INSERT INTO `access_log` VALUES (3344, '847865e0-d198-4b38-bf84-070712e58681', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:46:57', 19, 0, '', '2019-05-17 13:46:57');
INSERT INTO `access_log` VALUES (3345, '915cbc16-d896-4fae-a5ab-0baad68b98c9', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:01', 12, 0, '', '2019-05-17 13:47:01');
INSERT INTO `access_log` VALUES (3346, '1d7475f8-24f5-4185-baf7-0f035b9327b7', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=40&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:01', 36, 0, '', '2019-05-17 13:47:01');
INSERT INTO `access_log` VALUES (3347, '02f36fad-8ff8-43d5-8df1-ee7befbc63db', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:03', 10, 0, '', '2019-05-17 13:47:03');
INSERT INTO `access_log` VALUES (3348, '50362b2b-a998-49f8-9aac-eb6ae4b0b74f', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:03', 36, 0, '', '2019-05-17 13:47:03');
INSERT INTO `access_log` VALUES (3349, '023e4a57-a2cf-4e99-b505-2eb3b5c6b052', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:03', 19, 0, '', '2019-05-17 13:47:03');
INSERT INTO `access_log` VALUES (3350, 'e009bc66-8828-497d-94e0-d48a968a17d7', 1, 1, 'order-application', '/order-api/users/cart/add', 'skuId=40&quantity=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:05', 123, 0, '', '2019-05-17 13:47:05');
INSERT INTO `access_log` VALUES (3351, '367c8e5a-1784-4d82-aa7e-fe77cddbabfe', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:08', 10, 0, '', '2019-05-17 13:47:08');
INSERT INTO `access_log` VALUES (3352, 'b98fef9c-0ba0-4737-8871-5a12cbd088fe', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:08', 16, 0, '', '2019-05-17 13:47:08');
INSERT INTO `access_log` VALUES (3353, '0a80bd7f-1de7-4b7d-a89d-55816e78fafd', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:12', 12, 0, '', '2019-05-17 13:47:12');
INSERT INTO `access_log` VALUES (3354, '9f40b132-81f9-4f34-9a7c-bf1e94d38be9', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:12', 21, 0, '', '2019-05-17 13:47:12');
INSERT INTO `access_log` VALUES (3355, '5302b782-ee3e-40ab-ac63-bff2f213661b', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:13', 17, 0, '', '2019-05-17 13:47:13');
INSERT INTO `access_log` VALUES (3356, '4e0b5cf3-a7f8-45b1-9c2f-1822648c6f10', 1, 1, 'order-application', '/order-api/users/cart/add', 'skuId=31&quantity=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:15', 118, 0, '', '2019-05-17 13:47:15');
INSERT INTO `access_log` VALUES (3357, '57117e9c-6693-4e15-bf28-9d5c737fe874', 1, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:17', 34, 0, '', '2019-05-17 13:47:17');
INSERT INTO `access_log` VALUES (3358, '0bc447cd-0817-4e86-8c05-4f7d83c3bab3', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:30', 15, 0, '', '2019-05-17 13:47:30');
INSERT INTO `access_log` VALUES (3359, 'f710188f-a703-4c76-9e10-7ce011a7bbc6', 1, 1, 'order-application', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:30', 40, 0, '', '2019-05-17 13:47:30');
INSERT INTO `access_log` VALUES (3360, '4e1faca6-159f-404b-b8c8-e71039729d47', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:35', 19, 0, '', '2019-05-17 13:47:36');
INSERT INTO `access_log` VALUES (3361, '7529f0cc-e862-4c0c-96dd-725a32e3e237', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:36', 10, 0, '', '2019-05-17 13:47:36');
INSERT INTO `access_log` VALUES (3362, 'a1d0e98b-fa74-444c-a369-752ef2f7714d', 1, 1, 'order-application', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:47:36', 33, 0, '', '2019-05-17 13:47:36');
INSERT INTO `access_log` VALUES (3363, '8aa7f588-75c6-4a89-ae84-26d737356faa', 1, 1, 'order-application', '/order-api/users/order/create_order_from_cart', 'userAddressId=1&remark=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:49:16', 820, 2001001000, '服务端发生异常', '2019-05-17 13:49:16');
INSERT INTO `access_log` VALUES (3364, 'ffa6d126-c322-4cee-874b-3d8e43c4f899', 1, 1, 'order-application', '/order-api/users/order/create_order_from_cart', 'userAddressId=1&remark=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:48:38', 39446, 2001001000, '服务端发生异常', '2019-05-17 13:49:18');
INSERT INTO `access_log` VALUES (3365, '6afceb7f-8c31-4b11-9508-99e0316dd202', 1, 1, 'order-application', '/order-api/users/order/create_order_from_cart', 'userAddressId=1&remark=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:50:06', 803, 2001001000, '服务端发生异常', '2019-05-17 13:50:06');
INSERT INTO `access_log` VALUES (3366, '1f59284e-9148-4e93-8a95-a109e85f9fc4', 1, 1, 'order-application', '/order-api/users/order/create_order_from_cart', 'userAddressId=1&remark=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:51:10', 4049, 0, '', '2019-05-17 13:51:14');
INSERT INTO `access_log` VALUES (3367, '50889164-6974-48b7-9208-174dd9dd227c', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:51:15', 162, 0, '', '2019-05-17 13:51:15');
INSERT INTO `access_log` VALUES (3368, '148b186c-7ce9-4946-8da3-73a77e20478f', 1, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=216&payChannel=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:51:18', 576, 0, '', '2019-05-17 13:51:18');
INSERT INTO `access_log` VALUES (3369, 'f0390439-36c6-4bd1-a32c-e6ea10251865', 0, 1, 'pay-application', '/pay-api/users/transaction/pingxx_pay_success', '', 'POST', 'Go-http-client/1.1', '120.27.254.247', '2019-05-17 13:51:21', 490, 2001001000, '服务端发生异常', '2019-05-17 13:51:21');
INSERT INTO `access_log` VALUES (3370, '8a2028e1-4361-48ec-bae0-f5b1d746a823', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:51:22', 56, 0, '', '2019-05-17 13:51:22');
INSERT INTO `access_log` VALUES (3371, 'f93df348-3048-419d-8a37-65ba05ac3d96', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:51:25', 17, 0, '', '2019-05-17 13:51:25');
INSERT INTO `access_log` VALUES (3372, 'f6193c0d-6727-4eec-b45f-6eca6552a9b2', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:51:26', 21, 0, '', '2019-05-17 13:51:26');
INSERT INTO `access_log` VALUES (3373, '1d987efd-6f30-4537-ba7b-d2f3dd4fde05', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:51:29', 19, 0, '', '2019-05-17 13:51:29');
INSERT INTO `access_log` VALUES (3374, 'ab23d383-25ef-49f7-8a7a-6683e398f3fa', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:51:47', 18, 0, '', '2019-05-17 13:51:47');
INSERT INTO `access_log` VALUES (3375, '37.67.15580726522270027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=future&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 13:57:32', 19, 1002002000, '账号不存在', '2019-05-17 13:57:32');
INSERT INTO `access_log` VALUES (3376, '35.75.15580728445670079', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '119.61.17.154', '2019-05-17 14:00:45', 15, 0, '', '2019-05-17 14:00:45');
INSERT INTO `access_log` VALUES (3377, '35.72.15580728445670077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '119.61.17.154', '2019-05-17 14:00:45', 59, 0, '', '2019-05-17 14:00:45');
INSERT INTO `access_log` VALUES (3378, '32.86.15580728525230073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '119.61.17.154', '2019-05-17 14:00:53', 33, 0, '', '2019-05-17 14:00:53');
INSERT INTO `access_log` VALUES (3379, '32.88.15580728527960079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '119.61.17.154', '2019-05-17 14:00:53', 4, 0, '', '2019-05-17 14:00:53');
INSERT INTO `access_log` VALUES (3380, '32.87.15580728540960077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '119.61.17.154', '2019-05-17 14:00:54', 4, 0, '', '2019-05-17 14:00:54');
INSERT INTO `access_log` VALUES (3381, '32.80.15580728554300083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '119.61.17.154', '2019-05-17 14:00:55', 3, 0, '', '2019-05-17 14:00:55');
INSERT INTO `access_log` VALUES (3382, '35.79.15580728566830077', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '119.61.17.154', '2019-05-17 14:00:57', 8, 0, '', '2019-05-17 14:00:57');
INSERT INTO `access_log` VALUES (3383, '35.78.15580728566910075', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '119.61.17.154', '2019-05-17 14:00:57', 16, 0, '', '2019-05-17 14:00:57');
INSERT INTO `access_log` VALUES (3384, '37.70.15580728673510029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '119.61.17.154', '2019-05-17 14:01:07', 2, 0, '', '2019-05-17 14:01:07');
INSERT INTO `access_log` VALUES (3385, '37.73.15580728673510029', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '119.61.17.154', '2019-05-17 14:01:07', 3, 0, '', '2019-05-17 14:01:07');
INSERT INTO `access_log` VALUES (3386, '37.65.15580728673550031', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '119.61.17.154', '2019-05-17 14:01:07', 17, 0, '', '2019-05-17 14:01:07');
INSERT INTO `access_log` VALUES (3387, '37.64.15580729321240029', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '106.38.115.24', '2019-05-17 14:02:12', 3, 0, '', '2019-05-17 14:02:12');
INSERT INTO `access_log` VALUES (3388, '37.68.15580729321240029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '106.38.115.24', '2019-05-17 14:02:12', 3, 0, '', '2019-05-17 14:02:12');
INSERT INTO `access_log` VALUES (3389, '37.69.15580729321270035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '106.38.115.24', '2019-05-17 14:02:12', 10, 0, '', '2019-05-17 14:02:12');
INSERT INTO `access_log` VALUES (3390, 'b5811b45-cc2f-4f38-bd80-a9237f80352b', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:04:51', 24, 0, '', '2019-05-17 14:04:51');
INSERT INTO `access_log` VALUES (3391, '095d6594-f0f4-4e3b-a7ce-1c16583f5bb0', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:04:54', 38, 0, '', '2019-05-17 14:04:54');
INSERT INTO `access_log` VALUES (3392, '4b899f61-0993-4796-ac7c-30f5d0dc0f5e', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:04:58', 336, 0, '', '2019-05-17 14:04:58');
INSERT INTO `access_log` VALUES (3393, '102bdf2d-22aa-4b8f-8870-9121569b3d96', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:04:59', 32, 0, '', '2019-05-17 14:04:59');
INSERT INTO `access_log` VALUES (3394, 'ca5b938e-5e0a-4d25-b117-76c46839ff10', 1, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=216&payChannel=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:05:04', 526, 0, '', '2019-05-17 14:05:04');
INSERT INTO `access_log` VALUES (3395, 'e375763e-c19b-42cd-aa8d-d069f0d65dc6', 0, 1, 'pay-application', '/pay-api/users/transaction/pingxx_pay_success', '', 'POST', 'Go-http-client/1.1', '120.27.254.247', '2019-05-17 14:05:06', 12461, 2001001000, '服务端发生异常', '2019-05-17 14:05:19');
INSERT INTO `access_log` VALUES (3396, '176d75de-866f-4bae-a58a-22152351be8d', 0, 1, 'pay-application', '/pay-api/users/transaction/pingxx_pay_success', '', 'POST', 'Go-http-client/1.1', '116.62.75.199', '2019-05-17 14:05:21', 380, 2001001000, '服务端发生异常', '2019-05-17 14:05:22');
INSERT INTO `access_log` VALUES (3397, '219e5959-1b87-4d0f-b89f-0f77f61e551f', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:05:33', 24, 0, '', '2019-05-17 14:05:33');
INSERT INTO `access_log` VALUES (3398, 'be2e42ee-5192-4ef6-a1c7-333f11c990c9', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:05:35', 32, 0, '', '2019-05-17 14:05:35');
INSERT INTO `access_log` VALUES (3399, '809d409e-b9ef-4c86-95c7-4f3bfe7a549f', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:05:36', 10, 0, '', '2019-05-17 14:05:36');
INSERT INTO `access_log` VALUES (3400, '66c9ac3d-f2a3-4374-8003-c5f091026d7e', 1, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=216&payChannel=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:05:37', 273, 0, '', '2019-05-17 14:05:37');
INSERT INTO `access_log` VALUES (3401, '197a90f2-9772-469f-9611-531faec3023d', 0, 1, 'pay-application', '/pay-api/users/transaction/pingxx_pay_success', '', 'POST', 'Go-http-client/1.1', '116.62.75.199', '2019-05-17 14:05:39', 351, 2001001000, '服务端发生异常', '2019-05-17 14:05:39');
INSERT INTO `access_log` VALUES (3402, '6275d5a2-f199-4400-b35c-f230bf088fbf', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:05:40', 253, 0, '', '2019-05-17 14:05:40');
INSERT INTO `access_log` VALUES (3403, '0b3dba2e-66ea-4c75-a883-bc1ed7dbe94c', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:07:54', 986, 0, '', '2019-05-17 14:07:55');
INSERT INTO `access_log` VALUES (3404, '37.71.15580732763500041', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 14:07:56', 2, 0, '', '2019-05-17 14:07:56');
INSERT INTO `access_log` VALUES (3405, '37.66.15580732763610033', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 14:07:56', 2, 0, '', '2019-05-17 14:07:56');
INSERT INTO `access_log` VALUES (3406, '37.72.15580732763660033', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 14:07:56', 5, 0, '', '2019-05-17 14:07:56');
INSERT INTO `access_log` VALUES (3407, '3fb66f8d-d1d8-4f61-9d4c-3008e57c5092', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:07:57', 41, 0, '', '2019-05-17 14:07:57');
INSERT INTO `access_log` VALUES (3408, 'eaa5bf65-ca92-46da-bedf-b9990ec9b11c', 1, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=216&payChannel=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:07:58', 226, 0, '', '2019-05-17 14:07:58');
INSERT INTO `access_log` VALUES (3409, 'ddaabf6a-35dc-49de-aed9-057e95ca360b', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:08:00', 22, 0, '', '2019-05-17 14:08:00');
INSERT INTO `access_log` VALUES (3410, 'a6d6fc07-2099-4209-bd60-f99a1a5c4ef1', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:08:02', 43, 0, '', '2019-05-17 14:08:02');
INSERT INTO `access_log` VALUES (3411, '37.67.15580732875870029', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 14:08:08', 2, 0, '', '2019-05-17 14:08:08');
INSERT INTO `access_log` VALUES (3412, '37.70.15580732875930031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 14:08:08', 2, 0, '', '2019-05-17 14:08:08');
INSERT INTO `access_log` VALUES (3413, '37.65.15580732875990033', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 14:08:08', 6, 0, '', '2019-05-17 14:08:08');
INSERT INTO `access_log` VALUES (3414, '37.73.15580732909470031', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 14:08:11', 2, 0, '', '2019-05-17 14:08:11');
INSERT INTO `access_log` VALUES (3415, '37.64.15580732909580031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 14:08:11', 2, 0, '', '2019-05-17 14:08:11');
INSERT INTO `access_log` VALUES (3416, '37.69.15580732909630037', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 14:08:11', 262, 0, '', '2019-05-17 14:08:11');
INSERT INTO `access_log` VALUES (3417, '35.71.15580732986780075', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 14:08:19', 6, 0, '', '2019-05-17 14:08:19');
INSERT INTO `access_log` VALUES (3418, '35.73.15580732986810077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 14:08:19', 37, 0, '', '2019-05-17 14:08:19');
INSERT INTO `access_log` VALUES (3419, '31.47.15580733049070015', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 14:08:25', 99, 2001001000, '服务端发生异常', '2019-05-17 14:08:25');
INSERT INTO `access_log` VALUES (3420, '6c3b6456-0abb-4477-8289-6035ffb44b71', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:10:30', 98, 0, '', '2019-05-17 14:10:30');
INSERT INTO `access_log` VALUES (3421, 'c81c426d-06a3-42a9-b9bf-794b94071d62', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:10:33', 443, 0, '', '2019-05-17 14:10:34');
INSERT INTO `access_log` VALUES (3422, '1ab978c6-768a-4203-8997-430834999dd1', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=216', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:10:56', 33, 0, '', '2019-05-17 14:10:56');
INSERT INTO `access_log` VALUES (3423, '0cdd4e47-cf8a-417f-97e2-81d7e799f5d6', 1, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=216&payChannel=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:01', 27, 100401001, '支付交易单不处于待支付', '2019-05-17 14:11:01');
INSERT INTO `access_log` VALUES (3424, '7e630122-2369-4160-a1ba-919ff914f225', 1, 1, 'order-application', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:03', 10, 0, '', '2019-05-17 14:11:03');
INSERT INTO `access_log` VALUES (3425, '3d0bcf33-6fcc-4651-b3c9-8ffe6482b537', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:03', 10, 0, '', '2019-05-17 14:11:03');
INSERT INTO `access_log` VALUES (3426, '6ba7f0cd-b389-483d-a79a-998216a75f21', 1, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:04', 31, 0, '', '2019-05-17 14:11:04');
INSERT INTO `access_log` VALUES (3427, '0b6b3c91-05fd-4cba-87a7-218c5fe511d4', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:06', 8, 0, '', '2019-05-17 14:11:06');
INSERT INTO `access_log` VALUES (3428, 'fb3048bb-c271-438c-b189-ca4dfa66216d', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:06', 17, 0, '', '2019-05-17 14:11:06');
INSERT INTO `access_log` VALUES (3429, '33c07369-284e-44f5-a477-f775408a2f5b', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:06', 17, 0, '', '2019-05-17 14:11:06');
INSERT INTO `access_log` VALUES (3430, 'f8fb5f4e-3d60-47d0-818b-614b4e5d271c', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:10', 11, 0, '', '2019-05-17 14:11:10');
INSERT INTO `access_log` VALUES (3431, 'de9aa12e-7f7c-4baa-86d3-493ff2a88f1a', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:10', 37, 0, '', '2019-05-17 14:11:10');
INSERT INTO `access_log` VALUES (3432, '42239a08-63a5-4703-b848-81101e52760b', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:11', 13, 0, '', '2019-05-17 14:11:11');
INSERT INTO `access_log` VALUES (3433, 'd602c05c-1693-4e89-a36a-c5a496ae42ae', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:11', 10, 0, '', '2019-05-17 14:11:11');
INSERT INTO `access_log` VALUES (3434, '997c63ab-799a-40f1-ba54-7bd85f4137b1', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:11', 36, 0, '', '2019-05-17 14:11:11');
INSERT INTO `access_log` VALUES (3435, '1696a5bf-9b94-412f-94f0-2cb63eff94a4', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:14', 826, 0, '', '2019-05-17 14:11:15');
INSERT INTO `access_log` VALUES (3436, 'cc7eadef-d051-41a8-9a71-4f0bfb413243', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=217', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:15', 29, 0, '', '2019-05-17 14:11:15');
INSERT INTO `access_log` VALUES (3437, '01d6f0a6-7165-4c5f-aba4-97e5170128ea', 1, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=217&payChannel=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:16', 526, 0, '', '2019-05-17 14:11:17');
INSERT INTO `access_log` VALUES (3438, 'e33cdb11-81f6-40e8-99f3-06287fa7fd00', 0, 1, 'pay-application', '/pay-api/users/transaction/pingxx_pay_success', '', 'POST', 'Go-http-client/1.1', '116.62.75.199', '2019-05-17 14:11:18', 259, 2001001000, '服务端发生异常', '2019-05-17 14:11:19');
INSERT INTO `access_log` VALUES (3439, 'e9e8701d-88ea-4b63-b733-c07a9cb786ea', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=217', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:20', 21, 0, '', '2019-05-17 14:11:20');
INSERT INTO `access_log` VALUES (3440, '73fb0c21-248d-43ed-9e6e-8e793d24e043', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=217', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:22', 20, 0, '', '2019-05-17 14:11:22');
INSERT INTO `access_log` VALUES (3441, '1db67c27-3965-49d7-a30a-3617355a6edb', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=217', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:32', 14, 0, '', '2019-05-17 14:11:32');
INSERT INTO `access_log` VALUES (3442, 'c002533f-1937-485d-844d-656b59acbea2', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=217', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:33', 11, 0, '', '2019-05-17 14:11:33');
INSERT INTO `access_log` VALUES (3443, 'ba94af5d-8379-4df9-96d2-5e897e2c642f', 1, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=217&payChannel=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:34', 233, 0, '', '2019-05-17 14:11:35');
INSERT INTO `access_log` VALUES (3444, 'b789264a-ac1a-4309-8190-bc9ad2df7c71', 0, 1, 'pay-application', '/pay-api/users/transaction/pingxx_pay_success', '', 'POST', 'Go-http-client/1.1', '120.27.254.247', '2019-05-17 14:11:36', 355, 2001001000, '服务端发生异常', '2019-05-17 14:11:37');
INSERT INTO `access_log` VALUES (3445, '5ac1120c-8d27-4bdd-a6a2-15e62a310c0f', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=217', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:11:37', 20, 0, '', '2019-05-17 14:11:37');
INSERT INTO `access_log` VALUES (3446, '5899f922-7ac1-4e9f-aa27-7b8d69098116', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=217', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:15:51', 19, 0, '', '2019-05-17 14:15:51');
INSERT INTO `access_log` VALUES (3447, 'b2e7006f-de2e-4310-8366-986cd6b31794', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=217', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:16:08', 18, 0, '', '2019-05-17 14:16:08');
INSERT INTO `access_log` VALUES (3448, '79ed8d70-6536-45e5-8b48-eac9e445584d', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=217', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:16:11', 16, 0, '', '2019-05-17 14:16:11');
INSERT INTO `access_log` VALUES (3449, 'f8ab618b-0f9d-44b2-b1c2-056ba08f5787', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=217', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:18:48', 304, 0, '', '2019-05-17 14:18:49');
INSERT INTO `access_log` VALUES (3450, '32.80.15580739432570085', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 14:19:03', 309, 0, '', '2019-05-17 14:19:04');
INSERT INTO `access_log` VALUES (3451, '61af0643-8928-4948-afe2-0e5357f796b6', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:19:36', 13, 0, '', '2019-05-17 14:19:36');
INSERT INTO `access_log` VALUES (3452, 'c77a2249-edbf-4b8a-a140-3d2e459da3ea', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:19:36', 40, 0, '', '2019-05-17 14:19:37');
INSERT INTO `access_log` VALUES (3453, '850e2b2b-9cb4-4e77-a492-ba197a26aa69', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:20:07', 9, 0, '', '2019-05-17 14:20:07');
INSERT INTO `access_log` VALUES (3454, 'ef52c54a-9b5d-45d0-9103-8f71c7c94ad9', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:20:07', 29, 0, '', '2019-05-17 14:20:07');
INSERT INTO `access_log` VALUES (3455, '91065196-c912-4b09-a9f0-45c04cc73c41', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:21:08', 33, 0, '', '2019-05-17 14:21:08');
INSERT INTO `access_log` VALUES (3456, 'f03ed49e-b01f-4bde-8bfb-5ae13f52ce3f', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:21:08', 367, 0, '', '2019-05-17 14:21:08');
INSERT INTO `access_log` VALUES (3457, '92c6efb4-4df9-49dc-99ac-97feafb112c8', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:21:09', 475, 0, '', '2019-05-17 14:21:10');
INSERT INTO `access_log` VALUES (3458, '88330bb7-7b12-43ee-84af-9ef5c90b2955', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:21:11', 9, 0, '', '2019-05-17 14:21:11');
INSERT INTO `access_log` VALUES (3459, 'a219a533-365f-4a07-bde2-ef26e38dfc67', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:21:11', 27, 0, '', '2019-05-17 14:21:11');
INSERT INTO `access_log` VALUES (3460, '5cc017ca-9a58-488a-ad43-ebdbafbc4695', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1&couponCardId=2', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:21:13', 39, 0, '', '2019-05-17 14:21:13');
INSERT INTO `access_log` VALUES (3461, '1bfefc18-78ce-4f78-941a-7437a2559eab', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:21:17', 1131, 0, '', '2019-05-17 14:21:19');
INSERT INTO `access_log` VALUES (3462, '1b488ba9-5c75-4c94-9f03-13ab3e96b5b0', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=218', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:21:19', 133, 0, '', '2019-05-17 14:21:19');
INSERT INTO `access_log` VALUES (3463, 'b20eb628-b6b2-4025-924c-4640061dc46c', 1, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=218&payChannel=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:21:21', 544, 0, '', '2019-05-17 14:21:21');
INSERT INTO `access_log` VALUES (3464, '2e42784e-f784-4e38-87b0-27ed19f91c33', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=218', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:21:46', 18, 0, '', '2019-05-17 14:21:46');
INSERT INTO `access_log` VALUES (3465, '3374e5e8-cc33-45d0-95ce-1b214a86ed65', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=218', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:21:48', 20, 0, '', '2019-05-17 14:21:48');
INSERT INTO `access_log` VALUES (3466, '50b18fba-0a16-46ee-831e-9ac468576ce4', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=218', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:22:19', 15, 0, '', '2019-05-17 14:22:19');
INSERT INTO `access_log` VALUES (3467, '5bd38015-fdd3-4a20-931f-cbab043da09d', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:22:50', 5, 1002001012, '访问令牌已过期', '2019-05-17 14:22:50');
INSERT INTO `access_log` VALUES (3468, '1335ba96-a69c-4a1f-b2c5-e872c25892f6', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:22:50', 3, 1002001012, '访问令牌已过期', '2019-05-17 14:22:50');
INSERT INTO `access_log` VALUES (3469, 'bda7655f-743a-4d8e-944c-817c304833b4', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:22:50', 4, 1002001012, '访问令牌已过期', '2019-05-17 14:22:50');
INSERT INTO `access_log` VALUES (3470, 'c62b170f-aca9-4a18-b1ec-741e869ce824', 0, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:22:50', 6, 1002001012, '访问令牌已过期', '2019-05-17 14:22:50');
INSERT INTO `access_log` VALUES (3471, '143f5e47-8517-43e5-8623-e1de7a7af56c', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:22:52', 106, 0, '', '2019-05-17 14:22:52');
INSERT INTO `access_log` VALUES (3472, 'd215569c-787f-4d17-9208-b13491723f6c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:22:53', 12, 0, '', '2019-05-17 14:22:53');
INSERT INTO `access_log` VALUES (3473, '63ed60c2-d50e-4758-813b-1b7244778503', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:22:53', 16, 0, '', '2019-05-17 14:22:53');
INSERT INTO `access_log` VALUES (3474, '168b6119-b5b1-4c25-9fab-13f3c2be1d89', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:22:53', 13, 0, '', '2019-05-17 14:22:53');
INSERT INTO `access_log` VALUES (3475, '2891bc1f-a7c5-4319-a46f-8a0728115ab5', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:22:55', 20, 0, '', '2019-05-17 14:22:55');
INSERT INTO `access_log` VALUES (3476, '4090cc49-fe6d-43a5-be55-fa9018453626', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:23:05', 16, 0, '', '2019-05-17 14:23:05');
INSERT INTO `access_log` VALUES (3477, '8088f9e4-4637-4d03-acee-98656357114f', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:23:06', 16, 0, '', '2019-05-17 14:23:06');
INSERT INTO `access_log` VALUES (3478, 'e5f0acd0-3047-4578-ba41-1cbb070e2f2f', 1, 2, 'order-application', '/order-api/admins/order/page', 'id=218&pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:23:26', 22, 0, '', '2019-05-17 14:23:26');
INSERT INTO `access_log` VALUES (3479, '683b1e81-93fd-404b-b405-176ccaf85611', 1, 2, 'order-application', '/order-api/admins/order/page', 'id=218&pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 14:24:01', 18, 0, '', '2019-05-17 14:24:01');
INSERT INTO `access_log` VALUES (3480, '35.80.15580748111050073', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.691.400 QQBrowser/9.0.2524.400', '111.200.62.30', '2019-05-17 14:33:31', 5, 0, '', '2019-05-17 14:33:31');
INSERT INTO `access_log` VALUES (3481, '35.74.15580748111080075', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.691.400 QQBrowser/9.0.2524.400', '111.200.62.30', '2019-05-17 14:33:31', 15, 0, '', '2019-05-17 14:33:31');
INSERT INTO `access_log` VALUES (3482, '32.84.15580748169530075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.691.400 QQBrowser/9.0.2524.400', '111.200.62.30', '2019-05-17 14:33:37', 4, 0, '', '2019-05-17 14:33:37');
INSERT INTO `access_log` VALUES (3483, '32.81.15580748170700081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.691.400 QQBrowser/9.0.2524.400', '111.200.62.30', '2019-05-17 14:33:37', 11, 0, '', '2019-05-17 14:33:37');
INSERT INTO `access_log` VALUES (3484, '35.77.15580748215530077', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.691.400 QQBrowser/9.0.2524.400', '111.200.62.30', '2019-05-17 14:33:42', 89, 0, '', '2019-05-17 14:33:42');
INSERT INTO `access_log` VALUES (3485, '35.76.15580748215530077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.691.400 QQBrowser/9.0.2524.400', '111.200.62.30', '2019-05-17 14:33:42', 97, 0, '', '2019-05-17 14:33:42');
INSERT INTO `access_log` VALUES (3486, '37.68.15580748354660031', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.691.400 QQBrowser/9.0.2524.400', '111.200.62.30', '2019-05-17 14:33:55', 2, 0, '', '2019-05-17 14:33:55');
INSERT INTO `access_log` VALUES (3487, '37.66.15580748354790035', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.691.400 QQBrowser/9.0.2524.400', '111.200.62.30', '2019-05-17 14:33:55', 2, 0, '', '2019-05-17 14:33:55');
INSERT INTO `access_log` VALUES (3488, '37.71.15580748354880043', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.691.400 QQBrowser/9.0.2524.400', '111.200.62.30', '2019-05-17 14:33:55', 7, 0, '', '2019-05-17 14:33:55');
INSERT INTO `access_log` VALUES (3489, '35.75.15580755463860081', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '106.38.30.165', '2019-05-17 14:45:46', 5, 0, '', '2019-05-17 14:45:46');
INSERT INTO `access_log` VALUES (3490, '35.72.15580755463860079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '106.38.30.165', '2019-05-17 14:45:46', 18, 0, '', '2019-05-17 14:45:46');
INSERT INTO `access_log` VALUES (3491, 'a8b6b2bc-0217-4546-8ae4-58d5931c2672', 0, 1, 'order-application', '/order-api/users/order/info', 'orderId=218', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:12:59', 28, 0, '', '2019-05-17 15:12:59');
INSERT INTO `access_log` VALUES (3492, 'fa315ec1-9588-4b12-8e74-703da1c36779', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:13:03', 19, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-05-17 15:13:03');
INSERT INTO `access_log` VALUES (3493, '56d7d879-5ef4-4b38-97c9-680194fd006a', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:13:03', 44, 0, '', '2019-05-17 15:13:03');
INSERT INTO `access_log` VALUES (3494, 'c689e1b4-8a2b-402d-b2e2-82f5e5c1c472', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:13:06', 7, 0, '', '2019-05-17 15:13:06');
INSERT INTO `access_log` VALUES (3495, '98935091-25ac-48f8-b1a0-48199b604ca6', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:13:06', 27, 0, '', '2019-05-17 15:13:06');
INSERT INTO `access_log` VALUES (3496, 'c97845df-36f3-4b47-b4af-99333977becb', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:13:06', 22, 0, '', '2019-05-17 15:13:06');
INSERT INTO `access_log` VALUES (3497, '5adfc0bd-060c-4a51-9d82-080837a49aa7', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:13:06', 9, 0, '', '2019-05-17 15:13:06');
INSERT INTO `access_log` VALUES (3498, '8804ba51-766d-4e33-a88a-444ed00e736c', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:13:06', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-05-17 15:13:06');
INSERT INTO `access_log` VALUES (3499, '7afebc0e-a522-4203-a48b-7a4d0be1d92f', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:13:09', 9, 0, '', '2019-05-17 15:13:09');
INSERT INTO `access_log` VALUES (3500, '190c8f49-4030-4722-a588-e69c27b7efaa', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:13:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-05-17 15:13:09');
INSERT INTO `access_log` VALUES (3501, 'b97cfaa9-5533-4a3e-ab23-670fbe3f5ef8', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:13:19', 9, 0, '', '2019-05-17 15:13:19');
INSERT INTO `access_log` VALUES (3502, '43cf0a78-07ea-49ca-9e13-572413c6ada4', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:13:19', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-05-17 15:13:19');
INSERT INTO `access_log` VALUES (3503, 'd3d2cb9f-e146-405e-958a-1d4eab5365ac', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:14:17', 11, 0, '', '2019-05-17 15:14:17');
INSERT INTO `access_log` VALUES (3504, 'e34ee6a3-c1df-4eaa-a941-f895ac8d25c1', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:14:17', 22, 0, '', '2019-05-17 15:14:17');
INSERT INTO `access_log` VALUES (3505, 'abb6d3d2-f04f-484f-8044-e8a145689859', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:14:17', 18, 0, '', '2019-05-17 15:14:17');
INSERT INTO `access_log` VALUES (3506, '77ab681d-771d-4350-9f3e-8a61f3fad76a', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:14:19', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-05-17 15:14:19');
INSERT INTO `access_log` VALUES (3507, '60fe1ae3-3c29-44ac-a04b-9a704a414270', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:14:19', 15, 0, '', '2019-05-17 15:14:19');
INSERT INTO `access_log` VALUES (3508, '4f6abe9f-cccf-443e-8436-ebacad953125', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:15:13', 22, 0, '', '2019-05-17 15:15:13');
INSERT INTO `access_log` VALUES (3509, 'add30ffc-9258-413b-bc81-6b0e9654c39a', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:10', 18, 0, '', '2019-05-17 15:18:10');
INSERT INTO `access_log` VALUES (3510, '8aae07c1-0ed6-45ec-8671-b5f5daab5116', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:10', 240, 0, '', '2019-05-17 15:18:11');
INSERT INTO `access_log` VALUES (3511, '883836e3-dd04-40ae-9aa3-fa2364748705', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:10', 277, 0, '', '2019-05-17 15:18:11');
INSERT INTO `access_log` VALUES (3512, '6a261582-c299-49d6-aaba-2657700f10d2', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:15', 13, 0, '', '2019-05-17 15:18:15');
INSERT INTO `access_log` VALUES (3513, '61dcdcff-a9bc-4de3-801e-229c7e43f57e', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:15', 29, 1002001012, '访问令牌已过期', '2019-05-17 15:18:15');
INSERT INTO `access_log` VALUES (3514, '5ace44ea-f91d-4e45-958c-79e0a13e2037', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=53a7619e43b748499579bb7ce44f236c', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:15', 453, 0, '', '2019-05-17 15:18:16');
INSERT INTO `access_log` VALUES (3515, 'a0a3805b-d10b-46ad-9bff-c46ddcd020fb', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:16', 68, 0, '', '2019-05-17 15:18:16');
INSERT INTO `access_log` VALUES (3516, 'a932c0a3-62ac-499b-8bc2-2fddfbcaf3ab', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:17', 11, 0, '', '2019-05-17 15:18:17');
INSERT INTO `access_log` VALUES (3517, '0ee8a313-95fc-4c55-b6b8-12663663cd47', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:17', 9, 0, '', '2019-05-17 15:18:17');
INSERT INTO `access_log` VALUES (3518, 'd726da1b-7004-412d-b318-6b9f4d956f8f', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:17', 29, 0, '', '2019-05-17 15:18:17');
INSERT INTO `access_log` VALUES (3519, 'b0f75643-48cf-485d-afbc-835859ea09ea', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:21', 1168, 0, '', '2019-05-17 15:18:22');
INSERT INTO `access_log` VALUES (3520, 'f91370e2-29b9-411b-be95-f4431bf55d69', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=219', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:22', 208, 0, '', '2019-05-17 15:18:23');
INSERT INTO `access_log` VALUES (3521, '7c760a87-3d83-4a16-9c34-eddc62e0dc7d', 1, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=219&payChannel=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:24', 563, 0, '', '2019-05-17 15:18:24');
INSERT INTO `access_log` VALUES (3522, 'f03cab75-a58b-4ee5-9423-b8dca20795c2', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=219', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:27', 53, 0, '', '2019-05-17 15:18:27');
INSERT INTO `access_log` VALUES (3523, 'e27da5bb-2600-4888-b79d-edc39cd334f4', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=219', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:29', 18, 0, '', '2019-05-17 15:18:29');
INSERT INTO `access_log` VALUES (3524, 'a89eb2ff-1fa8-48e3-8552-e7f360e1c6dd', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=219', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:18:38', 35, 0, '', '2019-05-17 15:18:38');
INSERT INTO `access_log` VALUES (3525, 'cdb06efa-4497-4c92-afd8-74b1bd5092fe', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=219', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 15:19:12', 36, 0, '', '2019-05-17 15:19:12');
INSERT INTO `access_log` VALUES (3526, 'e941ffdc-64c5-4644-9e16-4d01eb91923a', 0, 2, 'order-application', '/order-api/admins/order/page', 'id=218&pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:02:45', 15, 1002001012, '访问令牌已过期', '2019-05-17 16:02:45');
INSERT INTO `access_log` VALUES (3527, '986ee4e6-81a1-45ef-a4ea-559b3946af56', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:02:47', 93, 0, '', '2019-05-17 16:02:47');
INSERT INTO `access_log` VALUES (3528, '8ec89a13-155a-4686-b4a0-cea289dc7bac', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:02:47', 22, 0, '', '2019-05-17 16:02:47');
INSERT INTO `access_log` VALUES (3529, 'c5ae5e6c-30a7-4c10-ae02-d50cc7120631', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:02:47', 26, 0, '', '2019-05-17 16:02:47');
INSERT INTO `access_log` VALUES (3530, '5f77a384-62cf-405a-9061-b48c263449ba', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:02:47', 33, 0, '', '2019-05-17 16:02:47');
INSERT INTO `access_log` VALUES (3531, '4b9b164a-d86f-4513-86e0-65093c7b9975', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:03:03', 175, 0, '', '2019-05-17 16:03:03');
INSERT INTO `access_log` VALUES (3532, 'd44a7b65-d283-49cd-aef3-ba203b812f87', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=219', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:03:15', 26, 0, '', '2019-05-17 16:03:15');
INSERT INTO `access_log` VALUES (3533, '297ab531-3624-4104-9fbd-663592512397', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:03:19', 22, 0, '', '2019-05-17 16:03:19');
INSERT INTO `access_log` VALUES (3534, '49e424be-16d9-48aa-9bd3-feb3828d5dd5', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=31&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:03:19', 58, 0, '', '2019-05-17 16:03:19');
INSERT INTO `access_log` VALUES (3535, 'd87712cc-9b58-4761-8a45-ee7fad160d88', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:03:19', 10, 0, '', '2019-05-17 16:03:19');
INSERT INTO `access_log` VALUES (3536, '2b3ca7e1-4bea-4eec-a6d9-fcb2486f23ed', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:03:19', 16, 0, '', '2019-05-17 16:03:19');
INSERT INTO `access_log` VALUES (3537, 'a3febbf0-06d2-4998-8a26-5a20ba428049', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:03:20', 13, 0, '', '2019-05-17 16:03:20');
INSERT INTO `access_log` VALUES (3538, 'fb152d64-465c-4492-a229-586e76ca188c', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:03:21', 10, 0, '', '2019-05-17 16:03:21');
INSERT INTO `access_log` VALUES (3539, '71a5e0a7-c321-425f-8795-a39f1f8d98af', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:03:21', 13, 0, '', '2019-05-17 16:03:21');
INSERT INTO `access_log` VALUES (3540, '18569137-85f4-4b9f-aed6-25c18d291cf3', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:03:23', 8, 0, '', '2019-05-17 16:03:23');
INSERT INTO `access_log` VALUES (3541, '37d17a5d-1fbf-47bb-ba6f-ef523ca9d6ee', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:03:24', 38, 0, '', '2019-05-17 16:03:24');
INSERT INTO `access_log` VALUES (3542, '29b6942a-ae12-466b-9a2a-468ef323a848', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=128', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:03:26', 20, 0, '', '2019-05-17 16:03:26');
INSERT INTO `access_log` VALUES (3543, '7e57b812-b60c-4655-971c-05ee7a9bcb43', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:03:28', 21, 0, '', '2019-05-17 16:03:28');
INSERT INTO `access_log` VALUES (3544, 'c090801e-fd72-47c0-a983-70226de71908', 1, 2, 'order-application', '/order-api/admins/order/page', 'id=219&pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:04:23', 37, 0, '', '2019-05-17 16:04:23');
INSERT INTO `access_log` VALUES (3545, 'eb4c4031-b6d4-4406-8ff7-0875b614f7a7', 1, 2, 'order-application', '/order-api/admins/order/order_items', 'orderId=219', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:04:25', 24, 0, '', '2019-05-17 16:04:25');
INSERT INTO `access_log` VALUES (3546, '58b1cc47-287c-4848-b3c4-8fbcd70e94d6', 1, 2, 'order-application', '/order-api/admins/order/order_recipient_info', 'orderId=219', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:04:25', 15, 0, '', '2019-05-17 16:04:25');
INSERT INTO `access_log` VALUES (3547, '2694c002-c71c-46b2-b37d-518da46ac23f', 1, 2, 'order-application', '/order-api/admins/order/page', 'id=219&pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:05:52', 22, 0, '', '2019-05-17 16:05:52');
INSERT INTO `access_log` VALUES (3548, 'fa387e5f-28cf-4119-b4a3-6b0e75d8d93f', 1, 2, 'order-application', '/order-api/admins/order/order_items', 'orderId=219', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:05:54', 13, 0, '', '2019-05-17 16:05:54');
INSERT INTO `access_log` VALUES (3549, '32fe5d8f-2397-4633-a300-56b11903f60e', 1, 2, 'order-application', '/order-api/admins/order/order_recipient_info', 'orderId=219', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:05:54', 15, 0, '', '2019-05-17 16:05:54');
INSERT INTO `access_log` VALUES (3550, 'c21cfca4-da74-4f01-b111-f1c690bc3ac1', 1, 2, 'order-application', '/order-api/admins/order/order_deliver', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:06:03', 36, 1008000005, NULL, '2019-05-17 16:06:03');
INSERT INTO `access_log` VALUES (3551, '3dd2ab91-f354-407b-8b98-eceeb7e5ddb2', 1, 2, 'order-application', '/order-api/admins/order/order_deliver', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:06:18', 14, 1008000005, NULL, '2019-05-17 16:06:18');
INSERT INTO `access_log` VALUES (3552, '1dae4301-8f34-4f27-bc28-588c282914c5', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:10:44', 71, 0, '', '2019-05-17 16:10:44');
INSERT INTO `access_log` VALUES (3553, '9a5cb200-e446-4f35-a6b8-386f4515a903', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:14:00', 14, 0, '', '2019-05-17 16:14:00');
INSERT INTO `access_log` VALUES (3554, 'b8bfc663-9506-40f9-942f-4e81c2d2bec3', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=2', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:14:02', 17, 0, '', '2019-05-17 16:14:02');
INSERT INTO `access_log` VALUES (3555, '3fe8e5b0-42db-4ecc-be6f-a9154800a3df', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:14:06', 13, 0, '', '2019-05-17 16:14:06');
INSERT INTO `access_log` VALUES (3556, '6d7c66e6-bbbc-4544-9462-8ed88b993a47', 0, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:22:53', 314, 1002001012, '访问令牌已过期', '2019-05-17 16:22:53');
INSERT INTO `access_log` VALUES (3557, 'efd2f836-3c0d-446a-946e-dc3d856692b7', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=53a7619e43b748499579bb7ce44f236c', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:22:54', 179, 0, '', '2019-05-17 16:22:54');
INSERT INTO `access_log` VALUES (3558, '0149ba9f-4b2c-4562-a063-3fb919a8619d', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:22:54', 21, 0, '', '2019-05-17 16:22:54');
INSERT INTO `access_log` VALUES (3559, '37.66.15580819365310037', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '124.161.8.191', '2019-05-17 16:32:17', 2, 0, '', '2019-05-17 16:32:17');
INSERT INTO `access_log` VALUES (3560, '37.71.15580819365310045', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '124.161.8.191', '2019-05-17 16:32:17', 2, 0, '', '2019-05-17 16:32:17');
INSERT INTO `access_log` VALUES (3561, '37.72.15580819365370035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '124.161.8.191', '2019-05-17 16:32:17', 34, 0, '', '2019-05-17 16:32:17');
INSERT INTO `access_log` VALUES (3562, 'a73d3408-7dfb-4f92-a207-dd4efcf713b6', 1, 2, 'order-application', '/order-api/admins/order_return/agree', 'id=12', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:35:59', 226, 0, '', '2019-05-17 16:36:00');
INSERT INTO `access_log` VALUES (3563, '26002d95-4ba1-486b-ab4a-91916106de43', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:00', 12, 0, '', '2019-05-17 16:36:00');
INSERT INTO `access_log` VALUES (3564, 'df87bad5-32aa-4b46-a101-b4f442f9fbba', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=2', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:01', 17, 0, '', '2019-05-17 16:36:01');
INSERT INTO `access_log` VALUES (3565, 'd5e6f595-6f6e-4821-850c-d00704b14f98', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:02', 15, 0, '', '2019-05-17 16:36:02');
INSERT INTO `access_log` VALUES (3566, '7299b2b4-e26a-4061-b60a-d2d9f933848a', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:02', 14, 0, '', '2019-05-17 16:36:02');
INSERT INTO `access_log` VALUES (3567, '9f05c65f-29f5-4f1d-848a-c3e61cfe449c', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:03', 11, 0, '', '2019-05-17 16:36:03');
INSERT INTO `access_log` VALUES (3568, '73765e75-afb0-414d-bc35-adba9f62b40c', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:04', 13, 0, '', '2019-05-17 16:36:04');
INSERT INTO `access_log` VALUES (3569, 'b66db060-3576-48e4-8f19-7b391c5442c5', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:05', 13, 0, '', '2019-05-17 16:36:05');
INSERT INTO `access_log` VALUES (3570, '6680eabc-6831-483d-83cb-3181bc42f11e', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:05', 16, 0, '', '2019-05-17 16:36:05');
INSERT INTO `access_log` VALUES (3571, '8997b924-a1dc-4c3c-b8cb-0f0fcd1edec6', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:06', 27, 0, '', '2019-05-17 16:36:06');
INSERT INTO `access_log` VALUES (3572, 'b28fe074-dca9-49f5-8b89-08fa6d6b38ff', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=2', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:07', 19, 0, '', '2019-05-17 16:36:07');
INSERT INTO `access_log` VALUES (3573, 'b0dc75eb-746f-4371-bf16-ebe8a245c655', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:08', 13, 0, '', '2019-05-17 16:36:08');
INSERT INTO `access_log` VALUES (3574, '9789f374-09fc-410f-9b89-1259cb69c446', 1, 2, 'order-application', '/order-api/admins/order_return/confirm_refund', 'id=6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:11', 71, 1008000402, NULL, '2019-05-17 16:36:11');
INSERT INTO `access_log` VALUES (3575, '399f696d-fa13-42f1-91df-60a3dd98c880', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:13', 17, 0, '', '2019-05-17 16:36:13');
INSERT INTO `access_log` VALUES (3576, 'ed7bbb0d-e5ea-4ff2-bd1d-2d3cd0c02f57', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:14', 13, 0, '', '2019-05-17 16:36:14');
INSERT INTO `access_log` VALUES (3577, 'bc34a1d6-2189-4608-b76d-19e80a9c5757', 1, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 16:36:16', 53, 0, '', '2019-05-17 16:36:16');
INSERT INTO `access_log` VALUES (3578, 'e99c384a-e3cd-41b1-bd38-1dc3852a1169', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:05:47', 303, 0, '', '2019-05-17 17:05:47');
INSERT INTO `access_log` VALUES (3579, 'f31b47fa-ba56-4fb4-88c8-c9ca1562adea', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:05:47', 140, 0, '', '2019-05-17 17:05:48');
INSERT INTO `access_log` VALUES (3580, '3e2fa034-cf56-427e-9dc6-823bcbca3f07', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:05:47', 154, 0, '', '2019-05-17 17:05:48');
INSERT INTO `access_log` VALUES (3581, '4814701d-8f1a-4ecc-86e4-272babff8027', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:05:47', 157, 0, '', '2019-05-17 17:05:48');
INSERT INTO `access_log` VALUES (3582, '5059cea6-bd55-433f-8d9a-0c040c56f466', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:07:39', 344, 0, '', '2019-05-17 17:07:40');
INSERT INTO `access_log` VALUES (3583, '208b5efa-66e7-4798-bab1-e7c5738e8410', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:07:39', 344, 0, '', '2019-05-17 17:07:40');
INSERT INTO `access_log` VALUES (3584, '289d607a-4d0b-4310-af6f-96eba1b38171', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:07:39', 344, 0, '', '2019-05-17 17:07:40');
INSERT INTO `access_log` VALUES (3585, '37.72.15580840614300037', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-17 17:07:41', 166, 0, '', '2019-05-17 17:07:42');
INSERT INTO `access_log` VALUES (3586, '697b1e7e-71f9-4c9e-8db1-7bf562cd7535', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:07:44', 147, 0, '', '2019-05-17 17:07:45');
INSERT INTO `access_log` VALUES (3587, 'e56c189d-353b-47ff-9845-7562764e81d3', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:07:46', 75, 0, '', '2019-05-17 17:07:46');
INSERT INTO `access_log` VALUES (3588, '413280a6-4421-4b4e-ad4e-7428b1434586', 1, 2, 'admin-application', '/admin-api/admins/role/delete', 'id=7', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:07:55', 95, 0, '', '2019-05-17 17:07:55');
INSERT INTO `access_log` VALUES (3589, '73d96971-bdef-4266-aecb-2cea3a92683d', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:07:55', 45, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-05-17 17:07:55');
INSERT INTO `access_log` VALUES (3590, '29c9e015-49e8-4a07-935c-21921026bad4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:07:57', 14, 0, '', '2019-05-17 17:07:57');
INSERT INTO `access_log` VALUES (3591, '587b1533-b219-4114-b91e-683ccf3f506f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:07:57', 26, 0, '', '2019-05-17 17:07:57');
INSERT INTO `access_log` VALUES (3592, 'daab84e1-c6e1-43af-8800-a3901bd44060', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:07:57', 25, 0, '', '2019-05-17 17:07:57');
INSERT INTO `access_log` VALUES (3593, 'b4e44342-03ae-4113-8e85-c1b29db4f9bc', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:07:57', 13, 0, '', '2019-05-17 17:07:57');
INSERT INTO `access_log` VALUES (3594, 'df035d4d-bfe0-459b-8032-767f111bf01d', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:01', 36, 0, '', '2019-05-17 17:08:01');
INSERT INTO `access_log` VALUES (3595, '1c0a6e21-d789-46ea-bc22-c21c18bfc73c', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:04', 15, 0, '', '2019-05-17 17:08:04');
INSERT INTO `access_log` VALUES (3596, '37.68.15580840837280033', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-17 17:08:04', 7, 1002002002, '账号已经存在', '2019-05-17 17:08:04');
INSERT INTO `access_log` VALUES (3597, '09a45e6c-eafe-47c7-b888-c059c97845ce', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:08', 30, 0, '', '2019-05-17 17:08:08');
INSERT INTO `access_log` VALUES (3598, 'e6e1b976-6e4f-4df5-b383-c6004af69602', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:10', 19, 0, '', '2019-05-17 17:08:10');
INSERT INTO `access_log` VALUES (3599, 'a2bff4eb-0b72-4517-bd1a-4e050bf2ba63', 1, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=yudaoyuanma&nickname=芋道源码（演示账号）&password=yudaoyuanma', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:27', 107, 0, '', '2019-05-17 17:08:27');
INSERT INTO `access_log` VALUES (3600, 'f4049ab3-3338-47aa-adc1-310d314ee598', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:27', 37, 0, '', '2019-05-17 17:08:27');
INSERT INTO `access_log` VALUES (3601, 'bb2fdf33-f93c-425a-950b-df5150e54436', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:30', 24, 0, '', '2019-05-17 17:08:30');
INSERT INTO `access_log` VALUES (3602, '7d68bc7c-fcad-4754-8b4e-6b0913bfab3a', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=27', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:31', 15, 0, '', '2019-05-17 17:08:31');
INSERT INTO `access_log` VALUES (3603, '8742028c-8c1c-4ad7-adfc-fd573242aef8', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=27&roleIds=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:33', 4121, 0, '', '2019-05-17 17:08:37');
INSERT INTO `access_log` VALUES (3604, 'ede1c504-09b6-4c50-a496-c75ff3ee1376', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:42', 132, 0, '', '2019-05-17 17:08:42');
INSERT INTO `access_log` VALUES (3605, '659603bb-0607-4150-a8e0-6720d7829df8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:42', 135, 0, '', '2019-05-17 17:08:42');
INSERT INTO `access_log` VALUES (3606, 'fe88bcfa-23bd-4596-9684-f2104b27d51d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:42', 134, 0, '', '2019-05-17 17:08:42');
INSERT INTO `access_log` VALUES (3607, 'bf0885d1-b587-4e75-8fa2-76945bf9cdb0', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:42', 84, 0, '', '2019-05-17 17:08:42');
INSERT INTO `access_log` VALUES (3608, 'fb7dc2a3-5e8c-4167-9c50-839610392373', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:43', 55, 0, '', '2019-05-17 17:08:44');
INSERT INTO `access_log` VALUES (3609, 'cbe4df32-e6af-4a9c-b635-9ef17f6537b5', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanm&password=ydym1024&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:51', 11, 1002002000, '账号不存在', '2019-05-17 17:08:51');
INSERT INTO `access_log` VALUES (3610, '7e462f63-fc52-4e67-a67b-8d6ea6e0a3c4', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=ydym1024&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:58', 447, 0, '', '2019-05-17 17:08:58');
INSERT INTO `access_log` VALUES (3611, '743c37a8-1877-403c-b8c8-1db1de4df94b', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:59', 14, 0, '', '2019-05-17 17:08:59');
INSERT INTO `access_log` VALUES (3612, '8fe4cd18-d709-43d7-9863-6170eb68a811', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:59', 22, 0, '', '2019-05-17 17:08:59');
INSERT INTO `access_log` VALUES (3613, 'deceb86f-ca53-483b-9f4d-522cf01ccb74', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:08:59', 320, 0, '', '2019-05-17 17:08:59');
INSERT INTO `access_log` VALUES (3614, 'cdd64cb0-aac1-4c2e-ab3c-d63d1fdf4226', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:09:01', 52, 0, '', '2019-05-17 17:09:01');
INSERT INTO `access_log` VALUES (3615, '05b33301-dccb-4393-8f9e-0fd3f8ac6336', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:09:04', 57, 0, '', '2019-05-17 17:09:04');
INSERT INTO `access_log` VALUES (3616, 'd2ef73b0-6b20-45de-a079-fbc7bd47805b', 27, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=1,2,6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:09:05', 127, 0, '', '2019-05-17 17:09:05');
INSERT INTO `access_log` VALUES (3617, 'ad9d6c4e-8343-4eba-a68c-243b4e9c2768', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:09:25', 13910, 0, '', '2019-05-17 17:09:39');
INSERT INTO `access_log` VALUES (3618, '35.79.15580842542600079', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '61.140.242.2', '2019-05-17 17:10:54', 17, 0, '', '2019-05-17 17:10:54');
INSERT INTO `access_log` VALUES (3619, '35.78.15580842542600077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '61.140.242.2', '2019-05-17 17:10:54', 43, 0, '', '2019-05-17 17:10:54');
INSERT INTO `access_log` VALUES (3620, '221dcc23-449f-4a55-b6b5-aafcd348a8d4', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:11:24', 1136, 0, '', '2019-05-17 17:11:25');
INSERT INTO `access_log` VALUES (3621, 'cb40a4cb-362a-4439-844f-aafa0daf878b', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:11:24', 1161, 0, '', '2019-05-17 17:11:25');
INSERT INTO `access_log` VALUES (3622, 'ba99134d-ad6c-46b4-a96a-368df5940a1b', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:11:24', 1169, 0, '', '2019-05-17 17:11:25');
INSERT INTO `access_log` VALUES (3623, 'fd79c7e5-5741-4358-bd42-88adc8f786a2', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:11:24', 1174, 0, '', '2019-05-17 17:11:25');
INSERT INTO `access_log` VALUES (3624, 'b6161ff1-3842-408f-b635-7ff0e862ae8b', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:11:28', 327, 0, '', '2019-05-17 17:11:28');
INSERT INTO `access_log` VALUES (3625, 'eb24ce77-6b83-4f61-a930-0d171d4a96e7', 27, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=5&roleIds=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:11:29', 59, 1002002009, '演示账号，暂不允许写操作', '2019-05-17 17:11:30');
INSERT INTO `access_log` VALUES (3626, '735b0abc-6bb5-473c-8a94-e2e6ca72674f', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=8', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:11:35', 15, 0, '', '2019-05-17 17:11:35');
INSERT INTO `access_log` VALUES (3627, 'cd938dbc-f94b-420f-9fd8-b64be97424d5', 27, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=8', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:11:36', 10, 1002002009, '演示账号，暂不允许写操作', '2019-05-17 17:11:36');
INSERT INTO `access_log` VALUES (3628, 'da32964a-e4ec-4763-9279-1d4dc8f90bc4', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:14:05', 409, 0, '', '2019-05-17 17:14:05');
INSERT INTO `access_log` VALUES (3629, 'bbc0f174-9fcd-4484-b48a-be0eacf390c6', 27, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=1,2,6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:14:07', 15, 1002002009, '演示账号，暂不允许写操作<br />欢迎假如加入我们的交流群：<a href=\'传送门\'>http://t.cn/EKEr5WE</a>', '2019-05-17 17:14:07');
INSERT INTO `access_log` VALUES (3630, '6b5545c5-7dd5-46ec-a9f9-edee8881c8ae', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:14:34', 268, 0, '', '2019-05-17 17:14:34');
INSERT INTO `access_log` VALUES (3631, '110b7dc6-93de-4443-988a-283aab824340', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:14:34', 268, 0, '', '2019-05-17 17:14:34');
INSERT INTO `access_log` VALUES (3632, '6db6e111-6a99-4cd3-aa2f-70b309f388be', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:14:34', 268, 0, '', '2019-05-17 17:14:34');
INSERT INTO `access_log` VALUES (3633, '286ccfd7-09de-4d84-bde5-36414eaf297a', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:14:36', 120, 0, '', '2019-05-17 17:14:36');
INSERT INTO `access_log` VALUES (3634, '59e1482b-3806-455c-bfc2-dfdc9bf24db6', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:14:38', 43, 0, '', '2019-05-17 17:14:38');
INSERT INTO `access_log` VALUES (3635, 'fe82870a-df85-4f18-974d-6c668c7e1f03', 27, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=1,2,6', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:14:39', 18, 1002002009, '演示账号，暂不允许写操作<br />欢迎假如加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-17 17:14:39');
INSERT INTO `access_log` VALUES (3636, '579e250f-8abf-47ed-99ba-2cb7abd9d259', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:17', 1638, 0, '', '2019-05-17 17:30:19');
INSERT INTO `access_log` VALUES (3637, 'cf8559d1-0187-4c52-b9cc-d1ae19446836', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:17', 1705, 0, '', '2019-05-17 17:30:19');
INSERT INTO `access_log` VALUES (3638, '074d6351-4a77-437b-8eae-31d0d5b461cb', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:21', 35, 0, '', '2019-05-17 17:30:22');
INSERT INTO `access_log` VALUES (3639, '99685f57-550a-45ce-b4a0-afa88a1dc0ad', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:21', 52, 0, '', '2019-05-17 17:30:22');
INSERT INTO `access_log` VALUES (3640, 'cea4d359-c859-4596-843e-813c9c3b0640', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=kafka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:31', 293, 0, '', '2019-05-17 17:30:31');
INSERT INTO `access_log` VALUES (3641, 'f7a45cab-9ec2-4e53-b424-5be79e8294c5', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kafka', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:31', 68, 0, '', '2019-05-17 17:30:31');
INSERT INTO `access_log` VALUES (3642, '799ff319-c806-422c-abff-9fd400910016', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:32', 32, 0, '', '2019-05-17 17:30:32');
INSERT INTO `access_log` VALUES (3643, 'eb65805f-fbfe-4e87-bb6d-c6c683ba490c', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:32', 29, 0, '', '2019-05-17 17:30:32');
INSERT INTO `access_log` VALUES (3644, 'df219130-f287-4b8c-9abc-f2e7e42f6f95', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:34', 196, 0, '', '2019-05-17 17:30:34');
INSERT INTO `access_log` VALUES (3645, '2d10f494-51d5-4038-9f4f-dd6c9e543651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:34', 29, 0, '', '2019-05-17 17:30:34');
INSERT INTO `access_log` VALUES (3646, 'df3e82a1-c4a9-44a5-b9ed-51516291a99d', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:36', 13, 0, '', '2019-05-17 17:30:36');
INSERT INTO `access_log` VALUES (3647, 'c35bcfcf-9041-43b6-8905-1e217057f295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:36', 11, 0, '', '2019-05-17 17:30:36');
INSERT INTO `access_log` VALUES (3648, '9c34495f-9116-4fd2-a67a-8d928b183105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:37', 160, 0, '', '2019-05-17 17:30:37');
INSERT INTO `access_log` VALUES (3649, '86b1c751-4e97-4322-9c84-8ba715dd674c', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:38', 13, 0, '', '2019-05-17 17:30:38');
INSERT INTO `access_log` VALUES (3650, '5371cf50-9ca8-4a62-a637-ed0911443cbf', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:38', 11, 0, '', '2019-05-17 17:30:38');
INSERT INTO `access_log` VALUES (3651, '635ddc30-df65-4fb0-b962-352510210095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:47', 18, 0, '', '2019-05-17 17:30:47');
INSERT INTO `access_log` VALUES (3652, 'ceea5a13-6d74-4025-adac-7daed396c3e6', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:48', 23, 0, '', '2019-05-17 17:30:48');
INSERT INTO `access_log` VALUES (3653, '8de1fe4e-a29c-4bbb-a135-098dfb523d5d', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:49', 19, 0, '', '2019-05-17 17:30:49');
INSERT INTO `access_log` VALUES (3654, '5b474065-aea6-4af8-bc33-eda8e77b4fc2', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:49', 23, 0, '', '2019-05-17 17:30:49');
INSERT INTO `access_log` VALUES (3655, '5a382a14-a8bb-4b99-9107-09c90903a081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:50', 14, 0, '', '2019-05-17 17:30:50');
INSERT INTO `access_log` VALUES (3656, 'af701f38-80eb-41d4-842d-855a32f947c0', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:50', 13, 0, '', '2019-05-17 17:30:50');
INSERT INTO `access_log` VALUES (3657, '80ecfa87-b8df-406e-93b5-7bb6601066d5', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:51', 12, 0, '', '2019-05-17 17:30:51');
INSERT INTO `access_log` VALUES (3658, '3a4ae840-cd97-485f-9f7e-4097fb6b8675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:52', 10, 0, '', '2019-05-17 17:30:52');
INSERT INTO `access_log` VALUES (3659, 'abaf0f11-eb1e-43d0-aa08-ba64d3b6361a', 0, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:53', 195, 0, '', '2019-05-17 17:30:53');
INSERT INTO `access_log` VALUES (3660, '6f88e562-fde3-4d77-a5e7-aba4eaf25fd7', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:55', 17, 0, '', '2019-05-17 17:30:55');
INSERT INTO `access_log` VALUES (3661, 'bde125a4-089a-4d1b-8b01-7bd4d9dbb0ed', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:55', 12, 0, '', '2019-05-17 17:30:55');
INSERT INTO `access_log` VALUES (3662, '67a63506-47d7-403a-871f-6dd356123f9b', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:56', 164, 1002001012, '访问令牌已过期', '2019-05-17 17:30:56');
INSERT INTO `access_log` VALUES (3663, '16e4353e-2fa7-401c-ac0e-023e051ca4f0', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=53a7619e43b748499579bb7ce44f236c', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:56', 253, 0, '', '2019-05-17 17:30:56');
INSERT INTO `access_log` VALUES (3664, '5ddfd9da-df7a-43e6-99ff-bff116742876', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:56', 84, 0, '', '2019-05-17 17:30:56');
INSERT INTO `access_log` VALUES (3665, 'd9d7dcc8-d7ca-47c4-841d-d6dc287b1a38', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:57', 14, 0, '', '2019-05-17 17:30:58');
INSERT INTO `access_log` VALUES (3666, '9d062ea1-d433-4fb9-9d78-b3e5ca1f72a8', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:58', 10, 0, '', '2019-05-17 17:30:58');
INSERT INTO `access_log` VALUES (3667, '0aa34064-31c3-439f-9791-2e193c239b11', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:30:59', 10, 0, '', '2019-05-17 17:30:59');
INSERT INTO `access_log` VALUES (3668, 'bde76513-066e-40e2-8771-4ae24912b5d6', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:31:09', 454, 0, '', '2019-05-17 17:31:09');
INSERT INTO `access_log` VALUES (3669, '543776f0-95e3-4d21-ac3d-f2a2ce63ccba', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:31:09', 8, 0, '', '2019-05-17 17:31:09');
INSERT INTO `access_log` VALUES (3670, '2bf0ef1f-f206-4829-acb7-db273bacfe64', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:31:15', 9, 0, '', '2019-05-17 17:31:15');
INSERT INTO `access_log` VALUES (3671, 'bc2a4083-d59e-4a8b-a090-105c3c13ee35', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:31:15', 10, 0, '', '2019-05-17 17:31:15');
INSERT INTO `access_log` VALUES (3672, '24b2c0f1-20f8-4347-b641-b319e8fd6955', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:31:19', 8, 0, '', '2019-05-17 17:31:19');
INSERT INTO `access_log` VALUES (3673, '8b27e9b9-b279-4ac7-a471-a01ee4e18e2f', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:31:19', 9, 0, '', '2019-05-17 17:31:19');
INSERT INTO `access_log` VALUES (3674, '1a1cd388-2216-448f-9d00-b474eb5eb30b', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:31:33', 11, 0, '', '2019-05-17 17:31:33');
INSERT INTO `access_log` VALUES (3675, '7d073453-3211-4c3c-b6b5-82e8178784b1', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:31:47', 9, 0, '', '2019-05-17 17:31:47');
INSERT INTO `access_log` VALUES (3676, '4096f920-8715-446d-82ff-042e721e12fc', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:31:48', 11, 0, '', '2019-05-17 17:31:48');
INSERT INTO `access_log` VALUES (3677, 'ae55467e-8f92-4326-a37f-f5889540fc4a', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:32:34', 7, 0, '', '2019-05-17 17:32:34');
INSERT INTO `access_log` VALUES (3678, 'e5827661-01cb-43ac-9b50-432629cab973', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:32:34', 14, 0, '', '2019-05-17 17:32:34');
INSERT INTO `access_log` VALUES (3679, '83574312-4160-4986-aec3-01a56b87029d', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:32:36', 8, 0, '', '2019-05-17 17:32:36');
INSERT INTO `access_log` VALUES (3680, '3293ad03-57f5-4d5f-a261-38c6581182fb', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:32:54', 8, 0, '', '2019-05-17 17:32:54');
INSERT INTO `access_log` VALUES (3681, 'dbc36c12-1768-4657-8c1b-7d1feb54afc6', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:32:54', 8, 0, '', '2019-05-17 17:32:54');
INSERT INTO `access_log` VALUES (3682, '0a005d99-2194-498e-9e57-affa75e50958', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:32:56', 8, 0, '', '2019-05-17 17:32:56');
INSERT INTO `access_log` VALUES (3683, 'a940ec30-601b-4735-b144-52559914fe3e', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:33:23', 43, 0, '', '2019-05-17 17:33:23');
INSERT INTO `access_log` VALUES (3684, 'f8f564e9-cb63-4b2b-82e9-c573deb03bf0', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:33:23', 35, 0, '', '2019-05-17 17:33:23');
INSERT INTO `access_log` VALUES (3685, '439fae59-fe22-4fd2-a4f2-79956a6471b0', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:33:25', 24, 0, '', '2019-05-17 17:33:25');
INSERT INTO `access_log` VALUES (3686, '39774d14-5a2e-47de-aa33-9613d34d27a0', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:33:37', 18, 0, '', '2019-05-17 17:33:37');
INSERT INTO `access_log` VALUES (3687, '0efabbff-8d82-4841-8994-038407da688c', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:33:37', 10, 0, '', '2019-05-17 17:33:37');
INSERT INTO `access_log` VALUES (3688, '0a7fff57-00c8-4e12-8010-4157413c8829', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:33:40', 8, 0, '', '2019-05-17 17:33:40');
INSERT INTO `access_log` VALUES (3689, '528a8ab2-0c20-4d34-930d-32274cf3671c', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:35:33', 10, 0, '', '2019-05-17 17:35:33');
INSERT INTO `access_log` VALUES (3690, '9e8c436b-cd60-4bb0-8e6d-e1550741b498', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:35:33', 8, 0, '', '2019-05-17 17:35:33');
INSERT INTO `access_log` VALUES (3691, '2637a6d7-e4f0-446d-b2fc-2559551965fa', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:35:35', 10, 0, '', '2019-05-17 17:35:35');
INSERT INTO `access_log` VALUES (3692, '18c1f588-0f0f-4afd-968f-eaccf619325c', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:35:36', 9, 0, '', '2019-05-17 17:35:36');
INSERT INTO `access_log` VALUES (3693, '35.71.15580857879050077', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-05-17 17:36:28', 9, 0, '', '2019-05-17 17:36:28');
INSERT INTO `access_log` VALUES (3694, '35.73.15580857879050079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-05-17 17:36:28', 20, 0, '', '2019-05-17 17:36:28');
INSERT INTO `access_log` VALUES (3695, '859edcde-378e-4e8f-a375-7fec3b0caa51', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:36:37', 14, 0, '', '2019-05-17 17:36:37');
INSERT INTO `access_log` VALUES (3696, 'b6eca21f-ea27-4dd5-8b1b-605f929bcb3a', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:36:37', 8, 0, '', '2019-05-17 17:36:37');
INSERT INTO `access_log` VALUES (3697, '89330fb4-45d1-441e-aeef-134dda6f3491', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:36:38', 8, 0, '', '2019-05-17 17:36:38');
INSERT INTO `access_log` VALUES (3698, 'f43409bb-d700-4777-979a-77b2f1351e4c', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:36:39', 7, 0, '', '2019-05-17 17:36:39');
INSERT INTO `access_log` VALUES (3699, '32.85.15580858000770081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-05-17 17:36:40', 32, 0, '', '2019-05-17 17:36:40');
INSERT INTO `access_log` VALUES (3700, '32.79.15580858002140077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-05-17 17:36:40', 3, 0, '', '2019-05-17 17:36:40');
INSERT INTO `access_log` VALUES (3701, '6257ecb2-2361-44fc-a517-231fd81f1b1e', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:36:47', 19, 0, '', '2019-05-17 17:36:47');
INSERT INTO `access_log` VALUES (3702, 'ca2e78ce-a6f6-445e-94f9-a48730d0e36e', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:36:47', 23, 0, '', '2019-05-17 17:36:47');
INSERT INTO `access_log` VALUES (3703, '3ac040c5-d88f-49d0-a5ee-8ab98e90935f', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:37:44', 14, 0, '', '2019-05-17 17:37:44');
INSERT INTO `access_log` VALUES (3704, 'cfb752ab-4d06-4210-bd64-6aef899baf63', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:37:44', 29, 0, '', '2019-05-17 17:37:44');
INSERT INTO `access_log` VALUES (3705, 'cb0769eb-f0c8-463c-82f5-594407d0a317', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:37:45', 11, 0, '', '2019-05-17 17:37:45');
INSERT INTO `access_log` VALUES (3706, 'cb539296-51ef-4b0c-a7fb-b00b7054ad89', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:37:58', 11, 0, '', '2019-05-17 17:37:58');
INSERT INTO `access_log` VALUES (3707, 'ba73c551-5508-425f-98c2-f1ea5ad1a700', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:37:58', 20, 0, '', '2019-05-17 17:37:58');
INSERT INTO `access_log` VALUES (3708, 'e8709385-12d0-49f8-9ac9-403d863099b7', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:37:59', 8, 0, '', '2019-05-17 17:37:59');
INSERT INTO `access_log` VALUES (3709, '570f2ac8-6aa9-4ae8-8d39-60586e506158', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:38:00', 7, 0, '', '2019-05-17 17:38:00');
INSERT INTO `access_log` VALUES (3710, 'bdcf5060-557f-4309-8753-fc55e25fa54e', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:38:02', 8, 0, '', '2019-05-17 17:38:02');
INSERT INTO `access_log` VALUES (3711, 'd6748120-060a-4419-a1f5-849e4d91cee0', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:38:02', 12, 0, '', '2019-05-17 17:38:02');
INSERT INTO `access_log` VALUES (3712, 'ca4c7947-f3bb-4365-a4b0-ce8f64c4eb5a', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:38:03', 9, 0, '', '2019-05-17 17:38:03');
INSERT INTO `access_log` VALUES (3713, '4dd9da4b-ad4b-4a4c-bc20-5f7afdc7bef0', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:38:03', 8, 0, '', '2019-05-17 17:38:03');
INSERT INTO `access_log` VALUES (3714, '37.73.15580858921520033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-05-17 17:38:12', 2, 0, '', '2019-05-17 17:38:12');
INSERT INTO `access_log` VALUES (3715, '37.66.15580858921570041', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-05-17 17:38:12', 1, 0, '', '2019-05-17 17:38:12');
INSERT INTO `access_log` VALUES (3716, '37.65.15580858921600037', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-05-17 17:38:12', 14, 0, '', '2019-05-17 17:38:12');
INSERT INTO `access_log` VALUES (3717, '79b2370b-77d1-4e54-91f0-0ceedd510878', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:38:32', 8, 0, '', '2019-05-17 17:38:32');
INSERT INTO `access_log` VALUES (3718, '05f813fb-7a3b-4a1a-a0b6-993d717734da', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:38:32', 7, 0, '', '2019-05-17 17:38:32');
INSERT INTO `access_log` VALUES (3719, '222b2f9f-b06e-4ed7-8d8d-b52755fd883f', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:38:33', 9, 0, '', '2019-05-17 17:38:33');
INSERT INTO `access_log` VALUES (3720, '6b155a33-eceb-40d8-b038-63680b01ffde', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:38:56', 8, 0, '', '2019-05-17 17:38:56');
INSERT INTO `access_log` VALUES (3721, '222560cb-c33a-454e-bcb6-2bea280afdb8', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:38:56', 7, 0, '', '2019-05-17 17:38:56');
INSERT INTO `access_log` VALUES (3722, '5f01066f-644f-4aa6-874e-e2aed029678c', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:38:57', 7, 0, '', '2019-05-17 17:38:57');
INSERT INTO `access_log` VALUES (3723, '9ea55eee-563c-4aa1-a127-a76d9c9cd93f', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:38:58', 9, 0, '', '2019-05-17 17:38:58');
INSERT INTO `access_log` VALUES (3724, '725c73f3-0708-4096-8c96-0c36fcf3dfe9', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:38:58', 8, 0, '', '2019-05-17 17:38:58');
INSERT INTO `access_log` VALUES (3725, '00040080-70ea-44d4-bfe9-0920ce15e90b', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:39:13', 15, 0, '', '2019-05-17 17:39:13');
INSERT INTO `access_log` VALUES (3726, '6ba693eb-d197-477b-a041-765420cfcee1', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:39:14', 13, 0, '', '2019-05-17 17:39:14');
INSERT INTO `access_log` VALUES (3727, 'e25844ec-baa7-4084-9c2f-2d23728c40fd', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:39:15', 10, 0, '', '2019-05-17 17:39:15');
INSERT INTO `access_log` VALUES (3728, '08a254d1-6b07-484b-b636-415af8fec5ad', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:39:45', 17, 0, '', '2019-05-17 17:39:45');
INSERT INTO `access_log` VALUES (3729, '56071dab-f316-4a58-a209-ca0e2f928b60', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:39:45', 24, 0, '', '2019-05-17 17:39:45');
INSERT INTO `access_log` VALUES (3730, 'cff22be9-64f1-4f34-8eb1-7a96f883e07e', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:39:46', 7, 0, '', '2019-05-17 17:39:46');
INSERT INTO `access_log` VALUES (3731, '6ababe0c-9531-4911-992e-9fd11d7c9d56', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:39:47', 10, 0, '', '2019-05-17 17:39:47');
INSERT INTO `access_log` VALUES (3732, 'a7acfb58-c21e-44ed-86a4-6b284a6b3775', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:39:48', 9, 0, '', '2019-05-17 17:39:48');
INSERT INTO `access_log` VALUES (3733, 'a5151583-3c7d-47a4-a0cb-b72c9ecb7604', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:39:49', 8, 0, '', '2019-05-17 17:39:49');
INSERT INTO `access_log` VALUES (3734, '8d369a32-dff3-4f0e-8c4a-0637a858f063', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:39:49', 10, 0, '', '2019-05-17 17:39:49');
INSERT INTO `access_log` VALUES (3735, '26ea5ea1-8f52-4ce5-8758-8b6039ffe10d', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:39:50', 7, 0, '', '2019-05-17 17:39:50');
INSERT INTO `access_log` VALUES (3736, '99139204-5d55-4148-8e0b-4118aade2424', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:39:50', 9, 0, '', '2019-05-17 17:39:50');
INSERT INTO `access_log` VALUES (3737, 'ea044af3-76e8-4bd5-81da-ef50cdd94d6e', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:41:00', 13, 0, '', '2019-05-17 17:41:00');
INSERT INTO `access_log` VALUES (3738, 'f067b4fd-3881-43c8-8338-2a21ce1ca9de', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:41:15', 11, 0, '', '2019-05-17 17:41:15');
INSERT INTO `access_log` VALUES (3739, 'c7cfe5c2-d69b-4162-8b1e-bb9c9de77812', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:41:36', 20, 0, '', '2019-05-17 17:41:36');
INSERT INTO `access_log` VALUES (3740, '42910c6a-3507-4984-94dc-b8667d8b4db4', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:41:36', 16, 0, '', '2019-05-17 17:41:36');
INSERT INTO `access_log` VALUES (3741, '0f704b34-58f9-4047-8e87-1dac7a532bb5', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:41:39', 8, 0, '', '2019-05-17 17:41:39');
INSERT INTO `access_log` VALUES (3742, 'f02e5d1e-5645-45e6-87ca-e828cfd9433d', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:41:39', 9, 0, '', '2019-05-17 17:41:39');
INSERT INTO `access_log` VALUES (3743, 'b4da8f27-764d-4c06-a956-276c606b385c', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:41:44', 12, 0, '', '2019-05-17 17:41:44');
INSERT INTO `access_log` VALUES (3744, 'ce5bd52a-fd09-4c92-951a-3b880758aada', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:41:44', 6, 0, '', '2019-05-17 17:41:44');
INSERT INTO `access_log` VALUES (3745, 'be67988b-c7a7-49b0-a86c-57bd5876a093', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:41:50', 8, 0, '', '2019-05-17 17:41:50');
INSERT INTO `access_log` VALUES (3746, 'e80c084b-720d-46e7-90a0-0e534dedaf5c', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:41:50', 8, 0, '', '2019-05-17 17:41:50');
INSERT INTO `access_log` VALUES (3747, 'eb94e15f-1701-45ec-be90-cda8d60c1f5c', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:42:25', 19, 0, '', '2019-05-17 17:42:25');
INSERT INTO `access_log` VALUES (3748, 'f7b52ded-7ee0-4af9-9e97-293a14239788', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:42:25', 33, 0, '', '2019-05-17 17:42:25');
INSERT INTO `access_log` VALUES (3749, '2675eb1e-a940-4e28-859e-0a7bbf134e84', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:43:35', 8, 0, '', '2019-05-17 17:43:35');
INSERT INTO `access_log` VALUES (3750, 'ce67cb80-9a0f-4401-bbe7-9962a7a29809', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:43:36', 8, 0, '', '2019-05-17 17:43:36');
INSERT INTO `access_log` VALUES (3751, 'e3203e51-c7cc-43a2-8dba-5aef1e919c5d', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:43:37', 7, 0, '', '2019-05-17 17:43:37');
INSERT INTO `access_log` VALUES (3752, '8dcc150d-86b5-45c3-800b-be9b89fbdf5c', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:43:37', 6, 0, '', '2019-05-17 17:43:37');
INSERT INTO `access_log` VALUES (3753, '411d8e83-3dd8-494a-8a45-b1bf3e9e43f9', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:43:39', 6, 0, '', '2019-05-17 17:43:39');
INSERT INTO `access_log` VALUES (3754, 'e77ac277-6d84-4a1a-a920-3bf56387fb72', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:43:39', 7, 0, '', '2019-05-17 17:43:39');
INSERT INTO `access_log` VALUES (3755, 'a7005f3d-3175-4073-aa6f-04c4b1775f99', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:43:47', 11, 0, '', '2019-05-17 17:43:47');
INSERT INTO `access_log` VALUES (3756, '4a7075cd-5e21-4a3a-a649-899a081d1b4e', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:43:47', 15, 0, '', '2019-05-17 17:43:47');
INSERT INTO `access_log` VALUES (3757, '7c7b4b4f-1d86-4290-b96a-d709be8d395f', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '127.0.0.1', '2019-05-17 17:44:19', 397, 0, '', '2019-05-17 17:44:19');
INSERT INTO `access_log` VALUES (3758, 'b919e159-96bc-4cc7-97e4-06914b88874d', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '127.0.0.1', '2019-05-17 17:44:19', 7, 0, '', '2019-05-17 17:44:19');
INSERT INTO `access_log` VALUES (3759, '37.71.15580862594220047', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.255.140.98', '2019-05-17 17:44:19', 2, 0, '', '2019-05-17 17:44:19');
INSERT INTO `access_log` VALUES (3760, '37.72.15580862594240039', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.255.140.98', '2019-05-17 17:44:19', 2, 0, '', '2019-05-17 17:44:19');
INSERT INTO `access_log` VALUES (3761, '37.70.15580862594340035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.255.140.98', '2019-05-17 17:44:19', 8, 0, '', '2019-05-17 17:44:19');
INSERT INTO `access_log` VALUES (3762, '9cd24fa6-4397-4a2f-ba41-b82a80b8bea3', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '127.0.0.1', '2019-05-17 17:44:20', 9, 0, '', '2019-05-17 17:44:20');
INSERT INTO `access_log` VALUES (3763, 'a927c56c-a155-43db-9fe6-7cce355a7d44', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '127.0.0.1', '2019-05-17 17:44:21', 7, 0, '', '2019-05-17 17:44:21');
INSERT INTO `access_log` VALUES (3764, '4d241e4a-42f7-4420-9ee5-344f7dab6735', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '127.0.0.1', '2019-05-17 17:44:21', 6, 0, '', '2019-05-17 17:44:21');
INSERT INTO `access_log` VALUES (3765, 'd00a3a90-b5a2-4cc9-96c1-62a1ccc5f860', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:44:24', 6, 0, '', '2019-05-17 17:44:24');
INSERT INTO `access_log` VALUES (3766, '71e47ef5-6781-4f1f-aa0c-32e5e7df6149', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:44:24', 7, 0, '', '2019-05-17 17:44:24');
INSERT INTO `access_log` VALUES (3767, 'f4a6b319-da32-4e8e-a33b-d851a27b661d', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:44:25', 7, 0, '', '2019-05-17 17:44:25');
INSERT INTO `access_log` VALUES (3768, 'ccb68877-0303-4b65-80ba-1cdb4bb51957', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:44:26', 5, 0, '', '2019-05-17 17:44:26');
INSERT INTO `access_log` VALUES (3769, '0fa525fb-1fc0-4ce2-b0a1-9fe9d68ad9d0', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 17:44:26', 7, 0, '', '2019-05-17 17:44:26');
INSERT INTO `access_log` VALUES (3770, '97979fe9-953a-4d8d-a75f-829452df919e', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '127.0.0.1', '2019-05-17 17:44:28', 8, 0, '', '2019-05-17 17:44:28');
INSERT INTO `access_log` VALUES (3771, '06107fbd-0d6e-41c8-9646-176c26a9a46e', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '127.0.0.1', '2019-05-17 17:44:28', 8, 0, '', '2019-05-17 17:44:28');
INSERT INTO `access_log` VALUES (3772, '37.67.15580862838450035', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.255.140.98', '2019-05-17 17:44:44', 1, 0, '', '2019-05-17 17:44:44');
INSERT INTO `access_log` VALUES (3773, '37.69.15580862838490043', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.255.140.98', '2019-05-17 17:44:44', 12, 0, '', '2019-05-17 17:44:44');
INSERT INTO `access_log` VALUES (3774, '37.64.15580862838490039', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.255.140.98', '2019-05-17 17:44:44', 1, 0, '', '2019-05-17 17:44:44');
INSERT INTO `access_log` VALUES (3775, '934f7891-4ba6-4bb9-a1e0-8d9d328110e7', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '127.0.0.1', '2019-05-17 17:44:48', 7, 0, '', '2019-05-17 17:44:48');
INSERT INTO `access_log` VALUES (3776, '37.68.15580862885130035', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.255.140.98', '2019-05-17 17:44:49', 2, 0, '', '2019-05-17 17:44:49');
INSERT INTO `access_log` VALUES (3777, '37.65.15580862885170039', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.255.140.98', '2019-05-17 17:44:49', 2, 0, '', '2019-05-17 17:44:49');
INSERT INTO `access_log` VALUES (3778, '37.73.15580862885180035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.255.140.98', '2019-05-17 17:44:49', 5, 0, '', '2019-05-17 17:44:49');
INSERT INTO `access_log` VALUES (3779, 'e13a74ee-b96c-4c26-82b2-ea642bbd2838', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '127.0.0.1', '2019-05-17 17:44:49', 6, 0, '', '2019-05-17 17:44:49');
INSERT INTO `access_log` VALUES (3780, '862e27c6-cc60-418c-8e18-7f735e64af17', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '127.0.0.1', '2019-05-17 17:44:50', 60, 0, '', '2019-05-17 17:44:50');
INSERT INTO `access_log` VALUES (3781, '66164cef-7443-4f94-a7b8-d7c11b9f81d9', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '127.0.0.1', '2019-05-17 17:44:50', 71, 0, '', '2019-05-17 17:44:50');
INSERT INTO `access_log` VALUES (3782, 'e4230ea5-854a-4680-81e2-37f88b205f84', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '127.0.0.1', '2019-05-17 17:44:51', 12, 0, '', '2019-05-17 17:44:51');
INSERT INTO `access_log` VALUES (3783, '66ba3eaa-403c-4545-8309-b72e2b4ffbbc', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '127.0.0.1', '2019-05-17 17:44:51', 14, 0, '', '2019-05-17 17:44:51');
INSERT INTO `access_log` VALUES (3784, '2e22e39d-121f-429c-b854-29026ae2adaf', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:44:57', 20, 0, '', '2019-05-17 17:44:57');
INSERT INTO `access_log` VALUES (3785, 'ed0b1c41-34ee-4de5-b8ea-d54d1fae19b0', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:01', 6, 0, '', '2019-05-17 17:45:01');
INSERT INTO `access_log` VALUES (3786, '86d9f370-d8fd-4cd9-91f6-e1d04a473b17', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:01', 15, 0, '', '2019-05-17 17:45:01');
INSERT INTO `access_log` VALUES (3787, 'b6520ee4-7415-46f3-9512-690f76ce8862', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:04', 6, 0, '', '2019-05-17 17:45:04');
INSERT INTO `access_log` VALUES (3788, '0bd1adbd-421f-4402-a659-e56d3cf1b1dc', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:04', 12, 0, '', '2019-05-17 17:45:04');
INSERT INTO `access_log` VALUES (3789, '7f619bfa-95b0-4e57-8d87-f7826516748f', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:04', 3, 0, '', '2019-05-17 17:45:04');
INSERT INTO `access_log` VALUES (3790, '5c04e09c-12ed-4d73-93a4-e05fd9598eec', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:04', 4, 0, '', '2019-05-17 17:45:04');
INSERT INTO `access_log` VALUES (3791, '05a06965-0882-4fff-850e-c616cd529162', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:06', 14, 0, '', '2019-05-17 17:45:06');
INSERT INTO `access_log` VALUES (3792, 'efd4f496-dfce-4dee-86fb-dc91a019dc7d', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:06', 1041, 0, '', '2019-05-17 17:45:07');
INSERT INTO `access_log` VALUES (3793, '3b881405-157f-46e2-8cd2-91e98fd4617c', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:07', 2, 0, '', '2019-05-17 17:45:07');
INSERT INTO `access_log` VALUES (3794, '4bd38e0f-a9a5-4a04-ba27-9382fcde7c42', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:08', 4, 0, '', '2019-05-17 17:45:08');
INSERT INTO `access_log` VALUES (3795, 'ce264eb0-7cda-42c1-b7fa-154918397475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:08', 3, 0, '', '2019-05-17 17:45:08');
INSERT INTO `access_log` VALUES (3796, '2800e33b-1374-4503-a9e4-1d0afaa46cff', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:09', 116, 0, '', '2019-05-17 17:45:09');
INSERT INTO `access_log` VALUES (3797, 'a54dd72d-f5d5-484e-856b-23800282b30a', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:09', 120, 0, '', '2019-05-17 17:45:09');
INSERT INTO `access_log` VALUES (3798, '6eee2761-2561-44cc-bb72-04243da74717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:58', 2, 0, '', '2019-05-17 17:45:58');
INSERT INTO `access_log` VALUES (3799, '31280d4c-ab13-4ec8-98c2-eedd3db806b6', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:58', 3, 0, '', '2019-05-17 17:45:58');
INSERT INTO `access_log` VALUES (3800, 'f04face2-a2ff-431d-b8e8-1b0e8546b5b8', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:45:59', 563, 0, '', '2019-05-17 17:46:00');
INSERT INTO `access_log` VALUES (3801, '0e1073d2-2a8c-43ca-a55a-ff9b1cb416bf', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:01', 8, 0, '', '2019-05-17 17:46:01');
INSERT INTO `access_log` VALUES (3802, '10ece02c-f997-471e-b2fd-57932927b260', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:01', 160, 0, '', '2019-05-17 17:46:01');
INSERT INTO `access_log` VALUES (3803, '6b61bfc1-fce5-4cb9-8ab8-bc935250d586', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:02', 3, 0, '', '2019-05-17 17:46:02');
INSERT INTO `access_log` VALUES (3804, '70363d11-f9ba-495e-afd3-da25d91db48d', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:02', 3, 0, '', '2019-05-17 17:46:02');
INSERT INTO `access_log` VALUES (3805, '301bfff6-e2ff-4581-9315-d81e83aa382f', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:08', 153, 0, '', '2019-05-17 17:46:08');
INSERT INTO `access_log` VALUES (3806, 'de68b363-de5d-4d8e-9299-a3184a3c9cb6', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:12', 316, 0, '', '2019-05-17 17:46:12');
INSERT INTO `access_log` VALUES (3807, '48095292-7a83-4606-82e3-051b7155a202', 1, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:13', 26, 0, '', '2019-05-17 17:46:13');
INSERT INTO `access_log` VALUES (3808, 'adc39816-0b15-4a81-9bd8-a995b0b0a81c', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:16', 7, 0, '', '2019-05-17 17:46:16');
INSERT INTO `access_log` VALUES (3809, '717e8549-692d-4208-a5ae-7cd4a1f57b2a', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:16', 8, 0, '', '2019-05-17 17:46:16');
INSERT INTO `access_log` VALUES (3810, '74f9b8a9-6de9-4f56-8134-1e31cdb20c63', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:17', 874, 0, '', '2019-05-17 17:46:18');
INSERT INTO `access_log` VALUES (3811, 'a884acf9-5c59-4ece-a035-8abd197e6d11', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:17', 878, 0, '', '2019-05-17 17:46:18');
INSERT INTO `access_log` VALUES (3812, '4bcfbeac-442b-4b72-b983-5a106a2ea138', 1, 1, 'search-application', '/search-api/users/product/page', 'keyword=kafka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:21', 23, 0, '', '2019-05-17 17:46:21');
INSERT INTO `access_log` VALUES (3813, 'de0e4752-87bf-411a-9ef7-945a3cc1b678', 1, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kafka', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:21', 19, 0, '', '2019-05-17 17:46:21');
INSERT INTO `access_log` VALUES (3814, '630f0a8e-48f7-4942-9d1f-373f0aee41bc', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:22', 24, 0, '', '2019-05-17 17:46:22');
INSERT INTO `access_log` VALUES (3815, '38c37600-50a4-43cf-a37f-8ac9c4e917af', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:22', 64, 0, '', '2019-05-17 17:46:22');
INSERT INTO `access_log` VALUES (3816, 'f783967b-aa18-429b-91bb-a38424c8cc9e', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:22', 148, 0, '', '2019-05-17 17:46:22');
INSERT INTO `access_log` VALUES (3817, '670b6778-c04a-43f9-97fd-c409b37684bf', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:24', 37, 0, '', '2019-05-17 17:46:25');
INSERT INTO `access_log` VALUES (3818, 'b358b83d-c2da-466a-a5a1-825fa66b101e', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:24', 108, 0, '', '2019-05-17 17:46:25');
INSERT INTO `access_log` VALUES (3819, '49d31189-9de4-40ac-8b1b-f11d44f523ef', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:26', 19, 0, '', '2019-05-17 17:46:26');
INSERT INTO `access_log` VALUES (3820, 'adb73094-4732-47b5-9314-46ae51197016', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:27', 19, 0, '', '2019-05-17 17:46:27');
INSERT INTO `access_log` VALUES (3821, '19aafc73-558d-4b72-94c5-5a93a57ca842', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:27', 36, 0, '', '2019-05-17 17:46:27');
INSERT INTO `access_log` VALUES (3822, 'fc8c6491-eb04-493b-9edf-02a8df7c23b7', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1&couponCardId=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:29', 50, 0, '', '2019-05-17 17:46:29');
INSERT INTO `access_log` VALUES (3823, '6196ec60-1129-4c36-923c-d4e3b30a52ca', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:30', 1432, 0, '', '2019-05-17 17:46:32');
INSERT INTO `access_log` VALUES (3824, '0fc2ff9f-09be-4df5-8703-5d72c606d557', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=220', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:32', 114, 0, '', '2019-05-17 17:46:32');
INSERT INTO `access_log` VALUES (3825, '3c725a53-ad0c-4896-ba18-9fbd852409c0', 1, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=220&payChannel=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:33', 634, 0, '', '2019-05-17 17:46:33');
INSERT INTO `access_log` VALUES (3826, 'da0671c2-ac1e-4aed-95f0-0e75ad98d219', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=220', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:38', 66, 0, '', '2019-05-17 17:46:38');
INSERT INTO `access_log` VALUES (3827, '5dc00a17-6d59-4f73-ba8f-caa11f592b20', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=220', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:40', 33, 0, '', '2019-05-17 17:46:40');
INSERT INTO `access_log` VALUES (3828, '93242253-d5b1-47f5-ac00-9a8ee079c75d', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=220', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:42', 35, 0, '', '2019-05-17 17:46:42');
INSERT INTO `access_log` VALUES (3829, '25cfb945-924f-4ebb-b8da-c2552417dad5', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=220', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:43', 32, 0, '', '2019-05-17 17:46:43');
INSERT INTO `access_log` VALUES (3830, '466fa99c-c832-4218-b631-630db78c610d', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=220', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:44', 17, 0, '', '2019-05-17 17:46:44');
INSERT INTO `access_log` VALUES (3831, '3db12b13-a0c2-4b61-a0a9-f2b2ce713b92', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=220', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:45', 19, 0, '', '2019-05-17 17:46:45');
INSERT INTO `access_log` VALUES (3832, 'b59fee07-ee6a-418d-b9b7-fcfb0ec3851f', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=220', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:46', 17, 0, '', '2019-05-17 17:46:46');
INSERT INTO `access_log` VALUES (3833, 'c7a0ee1e-56ab-478e-8aeb-c5514c77bab6', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=220', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:57', 11, 0, '', '2019-05-17 17:46:57');
INSERT INTO `access_log` VALUES (3834, '92334ce7-0dd4-4278-9e61-ffcda2912522', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:58', 11, 0, '', '2019-05-17 17:46:58');
INSERT INTO `access_log` VALUES (3835, '24b981db-8b07-420f-beb0-2be2873a0e57', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:58', 25, 0, '', '2019-05-17 17:46:58');
INSERT INTO `access_log` VALUES (3836, '470fa987-3c67-4bec-b36d-6142adc3bdc9', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:58', 8, 0, '', '2019-05-17 17:46:58');
INSERT INTO `access_log` VALUES (3837, '95c953c5-a9e1-48a1-a15f-7d9d94797f7b', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:58', 14, 0, '', '2019-05-17 17:46:58');
INSERT INTO `access_log` VALUES (3838, 'a7bbdce4-ca60-4897-bdc2-8437ab587ede', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:58', 13, 0, '', '2019-05-17 17:46:58');
INSERT INTO `access_log` VALUES (3839, '262ca0c3-4aa0-4544-999c-9eb94cb489bc', 1, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:58', 32, 0, '', '2019-05-17 17:46:58');
INSERT INTO `access_log` VALUES (3840, 'd94ea885-e41d-42de-bab8-47ff634d40c0', 1, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:59', 16, 0, '', '2019-05-17 17:46:59');
INSERT INTO `access_log` VALUES (3841, '2016f0b0-666e-473d-b938-73f8efe73e7b', 1, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:59', 12, 0, '', '2019-05-17 17:46:59');
INSERT INTO `access_log` VALUES (3842, '837ef3f0-7952-4370-aac2-26ecfe7658a7', 1, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:59', 26, 0, '', '2019-05-17 17:46:59');
INSERT INTO `access_log` VALUES (3843, 'a4afb620-a84d-4614-8938-060865877c70', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:59', 9, 0, '', '2019-05-17 17:46:59');
INSERT INTO `access_log` VALUES (3844, '601efbd6-8887-44cf-a34e-990e76c478f0', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:46:59', 13, 0, '', '2019-05-17 17:46:59');
INSERT INTO `access_log` VALUES (3845, '7dedc358-2ea0-4b68-9063-3d8ae73888f5', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:00', 8, 0, '', '2019-05-17 17:47:00');
INSERT INTO `access_log` VALUES (3846, 'a9be6427-43b1-4b3b-a38c-3a177941f5b9', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:03', 4, 0, '', '2019-05-17 17:47:03');
INSERT INTO `access_log` VALUES (3847, '3eb9e444-45f2-4060-806f-16d062834568', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:03', 9, 0, '', '2019-05-17 17:47:03');
INSERT INTO `access_log` VALUES (3848, '15904f15-3661-4b3c-8aaa-4cd6840e5881', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:27', 88, 0, '', '2019-05-17 17:47:27');
INSERT INTO `access_log` VALUES (3849, '35ee3697-773e-4180-9e66-58f5585b33e2', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:30', 557, 0, '', '2019-05-17 17:47:31');
INSERT INTO `access_log` VALUES (3850, '212284cf-fbe3-4f82-a6ec-75f820615858', 1, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:31', 222, 0, '', '2019-05-17 17:47:32');
INSERT INTO `access_log` VALUES (3851, '422f6337-71fb-42f7-88ab-0abb03830041', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:33', 8, 0, '', '2019-05-17 17:47:33');
INSERT INTO `access_log` VALUES (3852, '957a9fa1-2f6c-4944-aee3-9f007934fc3b', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:33', 12, 0, '', '2019-05-17 17:47:33');
INSERT INTO `access_log` VALUES (3853, '1606afb8-b964-4b1e-9fb3-0df1f586eb96', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:34', 8, 0, '', '2019-05-17 17:47:35');
INSERT INTO `access_log` VALUES (3854, '9b240b9e-268f-4572-9e24-2e767c6ce2af', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:36', 50, 0, '', '2019-05-17 17:47:36');
INSERT INTO `access_log` VALUES (3855, '09166d95-bd70-4dd8-aea5-27d691aa2ed7', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:38', 7, 0, '', '2019-05-17 17:47:38');
INSERT INTO `access_log` VALUES (3856, 'a956921f-5cd9-4d7c-b01c-620367b1ceb5', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=undefined', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:38', 550, 2001001000, '服务端发生异常', '2019-05-17 17:47:39');
INSERT INTO `access_log` VALUES (3857, 'b0c0e04c-4ef6-42ad-8b6c-ea136ed3205c', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:42', 6, 0, '', '2019-05-17 17:47:42');
INSERT INTO `access_log` VALUES (3858, '8453f96e-f150-4c88-af03-e5cea255e9ab', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=undefined', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:42', 91, 2001001000, '服务端发生异常', '2019-05-17 17:47:42');
INSERT INTO `access_log` VALUES (3859, '429fa267-25d9-4ec0-a9d2-382f4f0dcdc9', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:46', 26, 0, '', '2019-05-17 17:47:46');
INSERT INTO `access_log` VALUES (3860, '76773742-25c8-4f93-aee0-780718bceff8', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=128', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:47', 19, 0, '', '2019-05-17 17:47:47');
INSERT INTO `access_log` VALUES (3861, '16432f79-34bf-48f6-bac2-be77d4a9374d', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:48', 17, 0, '', '2019-05-17 17:47:48');
INSERT INTO `access_log` VALUES (3862, '50664991-887f-4b6c-8f95-72eaf2198e28', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=128', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:49', 16, 0, '', '2019-05-17 17:47:49');
INSERT INTO `access_log` VALUES (3863, '8ebd3e9b-08c4-4d49-8808-0704a940d6fd', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:50', 17, 0, '', '2019-05-17 17:47:50');
INSERT INTO `access_log` VALUES (3864, '30c16b56-24ca-4861-8d61-efff7473c35c', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:50', 8, 0, '', '2019-05-17 17:47:50');
INSERT INTO `access_log` VALUES (3865, '4f6e57dd-2086-4533-83d2-e1cae89e1f48', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=undefined', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:50', 259, 2001001000, '服务端发生异常', '2019-05-17 17:47:51');
INSERT INTO `access_log` VALUES (3866, '90a12c47-3ec0-42cb-a7f8-012bc37e3b33', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:53', 607, 0, '', '2019-05-17 17:47:53');
INSERT INTO `access_log` VALUES (3867, 'ff32acc4-e224-40e8-ae3f-5d74307fdcf2', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=128', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:54', 14, 0, '', '2019-05-17 17:47:54');
INSERT INTO `access_log` VALUES (3868, '0b125478-ff75-41f1-8d19-5c33fb7c7411', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:56', 17, 0, '', '2019-05-17 17:47:56');
INSERT INTO `access_log` VALUES (3869, '51e6b128-9ccc-458f-9c4d-786ff77976b4', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:58', 11, 0, '', '2019-05-17 17:47:58');
INSERT INTO `access_log` VALUES (3870, '8dfbeb03-d985-4b1b-9303-e354bf4a8fdc', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:59', 9, 0, '', '2019-05-17 17:47:59');
INSERT INTO `access_log` VALUES (3871, '026c52f0-11d7-4059-80e2-6b9568681134', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:59', 14, 0, '', '2019-05-17 17:47:59');
INSERT INTO `access_log` VALUES (3872, '3ecdab64-9197-4d08-8585-6e9abafa822d', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:48:01', 9, 0, '', '2019-05-17 17:48:01');
INSERT INTO `access_log` VALUES (3873, '5e278648-760d-4e88-9356-2825eea7f586', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:48:04', 4, 0, '', '2019-05-17 17:48:04');
INSERT INTO `access_log` VALUES (3874, '963231b5-8723-4430-9700-7205eb57adf2', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:48:04', 8, 0, '', '2019-05-17 17:48:04');
INSERT INTO `access_log` VALUES (3875, '087f378c-69e1-49a4-8d70-10cd240c944a', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:48:20', 3, 0, '', '2019-05-17 17:48:20');
INSERT INTO `access_log` VALUES (3876, 'd133b341-8bbd-4e6b-a7e6-e783e722c528', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:48:20', 2, 0, '', '2019-05-17 17:48:20');
INSERT INTO `access_log` VALUES (3877, '9c0e816d-18e4-4fe8-943a-ed461b7f3318', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:48:21', 2, 0, '', '2019-05-17 17:48:21');
INSERT INTO `access_log` VALUES (3878, 'f1375683-421a-4289-84c2-756ba3bd4afa', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691388', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:22', 515, 0, '', '2019-05-17 17:49:22');
INSERT INTO `access_log` VALUES (3879, '59e2e9d4-69a2-45e4-a97c-d11a899e90b1', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691388&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:25', 354, 0, '', '2019-05-17 17:49:25');
INSERT INTO `access_log` VALUES (3880, '08d6b99c-4d0e-48a5-bb71-301217417fef', 73, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:26', 8, 0, '', '2019-05-17 17:49:26');
INSERT INTO `access_log` VALUES (3881, 'b5e62674-a708-432b-ac4f-73c0b89ab322', 73, 1, 'user-application', '/user-api/users/user/update_nickname', 'nickname=你猜', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:31', 110, 0, '', '2019-05-17 17:49:31');
INSERT INTO `access_log` VALUES (3882, 'be43a54f-07c5-4817-b947-6d254f3cc7eb', 73, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:33', 8, 0, '', '2019-05-17 17:49:33');
INSERT INTO `access_log` VALUES (3883, '935059b1-9555-4bd2-bf27-3139622bfe88', 73, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:34', 8, 0, '', '2019-05-17 17:49:34');
INSERT INTO `access_log` VALUES (3884, '0bd3f74f-1c0d-4cc0-a09b-dc6ce5638283', 73, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:36', 9, 0, '', '2019-05-17 17:49:36');
INSERT INTO `access_log` VALUES (3885, '275b0964-b16c-43d6-ad8a-dbd39952e531', 73, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:36', 14, 0, '', '2019-05-17 17:49:36');
INSERT INTO `access_log` VALUES (3886, '5d937f15-0082-422a-a149-b8f3b0a455c7', 73, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:37', 8, 0, '', '2019-05-17 17:49:37');
INSERT INTO `access_log` VALUES (3887, 'be527b38-a743-462a-902b-10c564eb1d7a', 73, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:37', 13, 0, '', '2019-05-17 17:49:37');
INSERT INTO `access_log` VALUES (3888, '570ce458-28b8-44d0-90ca-767a66fbe588', 73, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:37', 15, 0, '', '2019-05-17 17:49:37');
INSERT INTO `access_log` VALUES (3889, '9ac7cabd-b661-4b4a-b8f4-c32cfe166fa6', 73, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:38', 8, 0, '', '2019-05-17 17:49:38');
INSERT INTO `access_log` VALUES (3890, '94e825e8-d10e-45e6-b4ad-912caf7df96d', 73, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:38', 12, 0, '', '2019-05-17 17:49:38');
INSERT INTO `access_log` VALUES (3891, 'd446595a-213e-479c-b132-780a30f6be91', 73, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:39', 6, 0, '', '2019-05-17 17:49:39');
INSERT INTO `access_log` VALUES (3892, '24155166-e783-45d5-bbba-ceddb4fc199d', 73, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:39', 7, 0, '', '2019-05-17 17:49:39');
INSERT INTO `access_log` VALUES (3893, 'f55d4138-51bd-4976-a09a-6e2644daa662', 73, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:40', 7, 0, '', '2019-05-17 17:49:40');
INSERT INTO `access_log` VALUES (3894, 'e2195ebf-cf86-4fb9-8a8e-fba77fd7754f', 73, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:41', 8, 0, '', '2019-05-17 17:49:41');
INSERT INTO `access_log` VALUES (3895, 'bd6fd76a-0d42-44ed-9ce3-a11a70907f92', 73, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:41', 13, 0, '', '2019-05-17 17:49:41');
INSERT INTO `access_log` VALUES (3896, '3380dfd8-acb8-4ba1-a9e4-bcb846abf1c3', 73, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:42', 6, 0, '', '2019-05-17 17:49:42');
INSERT INTO `access_log` VALUES (3897, '06a6ff73-cb69-4133-80e5-54c126ca79d7', 73, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:42', 6, 0, '', '2019-05-17 17:49:42');
INSERT INTO `access_log` VALUES (3898, '9b7d98fc-c3ae-4488-a011-f2d97119e28a', 73, 1, 'search-application', '/search-api/users/product/page', 'keyword=kafka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:44', 309, 0, '', '2019-05-17 17:49:45');
INSERT INTO `access_log` VALUES (3899, '9777bd37-cc27-44cd-8308-ca22d6bb4daa', 73, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kafka', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:45', 17, 0, '', '2019-05-17 17:49:45');
INSERT INTO `access_log` VALUES (3900, '20785aa2-b77e-4400-9afb-a9dfdab90740', 73, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:46', 8, 0, '', '2019-05-17 17:49:46');
INSERT INTO `access_log` VALUES (3901, 'd310f233-ef68-4df0-9e71-fd857c7c0269', 73, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:46', 15, 0, '', '2019-05-17 17:49:46');
INSERT INTO `access_log` VALUES (3902, '332c8e35-5df8-4491-ba59-97a7ae267edc', 73, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:46', 14, 0, '', '2019-05-17 17:49:46');
INSERT INTO `access_log` VALUES (3903, '32ea7f6f-daa2-4f23-ba4c-1bdd021c7045', 73, 1, 'order-application', '/order-api/users/cart/add', 'skuId=36&quantity=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:48', 71, 0, '', '2019-05-17 17:49:49');
INSERT INTO `access_log` VALUES (3904, 'ca3dacfa-a637-4c9c-b3a6-c2c82317769a', 73, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:52', 11, 0, '', '2019-05-17 17:49:52');
INSERT INTO `access_log` VALUES (3905, '422b1336-5d25-49db-8154-e08413cbaf01', 73, 1, 'order-application', '/order-api/users/cart/add', 'skuId=37&quantity=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:53', 695, 0, '', '2019-05-17 17:49:54');
INSERT INTO `access_log` VALUES (3906, 'fc0de86c-0391-4fdb-8418-4bb73e3556bf', 73, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:56', 25, 0, '', '2019-05-17 17:49:56');
INSERT INTO `access_log` VALUES (3907, 'be252fb5-1e12-4dc4-8e00-934c2710f71b', 73, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:58', 8, 0, '', '2019-05-17 17:49:58');
INSERT INTO `access_log` VALUES (3908, 'a68a2806-345c-4c79-95c2-5c8c1ac42d2c', 73, 1, 'order-application', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:49:58', 21, 0, '', '2019-05-17 17:49:58');
INSERT INTO `access_log` VALUES (3909, 'f12effa3-7b06-489d-9d26-40b0c5bb6062', 73, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:50:01', 7, 0, '', '2019-05-17 17:50:01');
INSERT INTO `access_log` VALUES (3910, '54c66c21-ff89-4508-b849-bc78e53202f7', 73, 1, 'user-application', '/user-api/users/address/add', 'name=你猜&tel=15601691388&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=你猜&isDefault=false&address=你猜&areaNo=110101&mobile=15601691388&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:50:16', 130, 2001001000, '服务端发生异常', '2019-05-17 17:50:16');
INSERT INTO `access_log` VALUES (3911, 'b741afc6-fbf3-420b-82ad-fc94a1800419', 73, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:50:18', 7, 0, '', '2019-05-17 17:50:18');
INSERT INTO `access_log` VALUES (3912, 'e9b5537a-e0e8-4889-bff9-04534173d976', 73, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:50:19', 8, 0, '', '2019-05-17 17:50:19');
INSERT INTO `access_log` VALUES (3913, '2f838a90-cdb1-4745-9603-856d0dbaee3c', 73, 1, 'order-application', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:50:19', 25, 0, '', '2019-05-17 17:50:19');
INSERT INTO `access_log` VALUES (3914, '7ea81727-b84d-46b2-893a-547e7dc1402b', 73, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:50:19', 20, 0, '', '2019-05-17 17:50:19');
INSERT INTO `access_log` VALUES (3915, '475a8469-efd6-47f7-aeeb-1c127cc558f6', 73, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:50:21', 7, 0, '', '2019-05-17 17:50:22');
INSERT INTO `access_log` VALUES (3916, 'fac3bca0-7afd-4436-962c-c0198d0e0cf2', 73, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:50:21', 14, 0, '', '2019-05-17 17:50:22');
INSERT INTO `access_log` VALUES (3917, 'dab34f65-1a7c-447a-827f-de0b01d8737a', 73, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:50:22', 12, 0, '', '2019-05-17 17:50:22');
INSERT INTO `access_log` VALUES (3918, 'bec11548-23ad-4e39-a00e-defb511e1c02', 73, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:51:34', 13, 0, '', '2019-05-17 17:51:34');
INSERT INTO `access_log` VALUES (3919, '0d5fdd68-e1b1-4f1d-b08f-65d27f45300e', 73, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:51:34', 9, 0, '', '2019-05-17 17:51:35');
INSERT INTO `access_log` VALUES (3920, '979856dd-fd14-418f-9b03-d612b23f397f', 73, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:51:34', 18, 0, '', '2019-05-17 17:51:35');
INSERT INTO `access_log` VALUES (3921, '4bc173c3-eb06-4253-83c9-3991eb536efc', 73, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:51:35', 6, 0, '', '2019-05-17 17:51:35');
INSERT INTO `access_log` VALUES (3922, '5cc676b7-f67f-441e-bb78-b86d4ecf6886', 73, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:51:35', 15, 0, '', '2019-05-17 17:51:35');
INSERT INTO `access_log` VALUES (3923, '7617f4e7-7095-46f1-a1d9-965ddc2582df', 73, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:51:35', 6, 0, '', '2019-05-17 17:51:35');
INSERT INTO `access_log` VALUES (3924, '8bcb5b0d-8bf3-4b5c-9827-75e746c37169', 73, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:51:36', 314, 0, '', '2019-05-17 17:51:36');
INSERT INTO `access_log` VALUES (3925, '3daf245a-bf0b-49a5-82e8-e8c241b0fc8c', 73, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:51:37', 24, 0, '', '2019-05-17 17:51:37');
INSERT INTO `access_log` VALUES (3926, '87d75911-9694-4752-97d8-e873ae11948b', 73, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:51:38', 21, 0, '', '2019-05-17 17:51:38');
INSERT INTO `access_log` VALUES (3927, 'a9fede03-a616-404c-9961-d57ccee3b5dd', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691388', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:51:43', 1250, 0, '', '2019-05-17 17:51:45');
INSERT INTO `access_log` VALUES (3928, '61c5aec3-264e-4ffb-90a1-e00472f89b14', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691388&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:51:48', 190, 0, '', '2019-05-17 17:51:48');
INSERT INTO `access_log` VALUES (3929, '17c8cfcc-7535-49e0-8618-ce1b30090d77', 73, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:51:49', 9, 0, '', '2019-05-17 17:51:49');
INSERT INTO `access_log` VALUES (3930, 'f1b3fc3d-4849-4efb-a0f4-d284628d0fab', 73, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:51:51', 39, 0, '', '2019-05-17 17:51:51');
INSERT INTO `access_log` VALUES (3931, '419f4eb4-957c-4e31-9a64-3b51486577c6', 73, 1, 'user-application', '/user-api/users/address/add', 'name=芋道源码&tel=15601691388&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=你猜&isDefault=false&address=你猜&areaNo=110101&mobile=15601691388&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:52:04', 124, 2001001000, '服务端发生异常', '2019-05-17 17:52:05');
INSERT INTO `access_log` VALUES (3932, 'a24b67cf-c216-4e8c-8d77-24736dd45b52', 73, 1, 'user-application', '/user-api/users/address/add', 'name=芋道源码&tel=15601691388&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=你猜&isDefault=false&address=你猜&areaNo=110101&mobile=15601691388&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:53:26', 84, 2001001000, '服务端发生异常', '2019-05-17 17:53:26');
INSERT INTO `access_log` VALUES (3933, '8f2f58e8-0638-4444-a11e-688186cee1b4', 73, 1, 'user-application', '/user-api/users/address/add', 'name=芋道源码&tel=15601691388&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=你猜&isDefault=false&address=你猜&areaNo=110101&mobile=15601691388&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:54:34', 351, 2001001000, '服务端发生异常', '2019-05-17 17:54:34');
INSERT INTO `access_log` VALUES (3934, '93968b9b-9d60-4699-8cb0-dab2cc50660b', 73, 1, 'user-application', '/user-api/users/address/add', 'name=芋道源码&tel=15601691388&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=北京五环，就是五环啊&isDefault=false&address=北京五环，就是五环啊&areaNo=110101&mobile=15601691388&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:57:35', 464, 0, '', '2019-05-17 17:57:35');
INSERT INTO `access_log` VALUES (3935, '937b3000-ef6f-4412-a006-6ae686394dff', 73, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:57:35', 38, 0, '', '2019-05-17 17:57:35');
INSERT INTO `access_log` VALUES (3936, '3961a9e5-2088-47b9-b962-52f94bf1e394', 73, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:57:37', 60, 0, '', '2019-05-17 17:57:37');
INSERT INTO `access_log` VALUES (3937, 'af7644f9-94d8-4f24-b04b-6be9baabf862', 73, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:57:39', 9, 0, '', '2019-05-17 17:57:39');
INSERT INTO `access_log` VALUES (3938, 'cf61b482-d4a2-41fc-a17f-1bef8266e211', 73, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:57:39', 14, 0, '', '2019-05-17 17:57:39');
INSERT INTO `access_log` VALUES (3939, 'c5f9cc52-a814-4f58-a3ed-cadfe4ba0640', 73, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:57:39', 8, 0, '', '2019-05-17 17:57:39');
INSERT INTO `access_log` VALUES (3940, '0a9b5e5a-d089-426b-8c06-9286a3cd9b67', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:57:42', 4, 0, '', '2019-05-17 17:57:42');
INSERT INTO `access_log` VALUES (3941, 'bb9e82bd-d12f-4f44-b423-aec470136633', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:57:42', 8, 0, '', '2019-05-17 17:57:42');
INSERT INTO `access_log` VALUES (3942, '62cb40e7-a96f-48b8-ae9f-76eb3be0f374', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:57:45', 4, 0, '', '2019-05-17 17:57:46');
INSERT INTO `access_log` VALUES (3943, 'a88731ec-6479-4e2d-95c0-c5f7c6b0a212', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:57:45', 8, 0, '', '2019-05-17 17:57:46');
INSERT INTO `access_log` VALUES (3944, 'd1da7b67-05b9-4226-b4fd-863cc62d809a', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:08', 168, 0, '', '2019-05-17 17:58:08');
INSERT INTO `access_log` VALUES (3945, '0d68bae9-d674-42c8-b829-d68d7dea1d49', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:10', 240, 0, '', '2019-05-17 17:58:10');
INSERT INTO `access_log` VALUES (3946, 'fdeffafa-53c6-4949-a792-173b184826dc', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:11', 9, 0, '', '2019-05-17 17:58:11');
INSERT INTO `access_log` VALUES (3947, 'd94c374e-a20c-4062-aa18-192a77bbcb41', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:12', 7, 0, '', '2019-05-17 17:58:12');
INSERT INTO `access_log` VALUES (3948, 'b4da8b1c-ee5d-46ce-9a7d-8b7fa68e55ce', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:12', 7, 0, '', '2019-05-17 17:58:12');
INSERT INTO `access_log` VALUES (3949, '7af11a32-286e-4374-afe1-d7da56bf5754', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:13', 7, 0, '', '2019-05-17 17:58:13');
INSERT INTO `access_log` VALUES (3950, 'f02a34b3-599a-47eb-b1bf-ff9509a37287', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:14', 7, 0, '', '2019-05-17 17:58:14');
INSERT INTO `access_log` VALUES (3951, 'd8cce6d9-1615-4128-9637-5a3dfcf8ab7d', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:14', 12, 0, '', '2019-05-17 17:58:14');
INSERT INTO `access_log` VALUES (3952, '1bed577b-e79c-433f-9e70-d9e10f01a03f', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:15', 6, 0, '', '2019-05-17 17:58:15');
INSERT INTO `access_log` VALUES (3953, '59dd4f88-9a43-46da-9221-3aabf4448410', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:15', 13, 0, '', '2019-05-17 17:58:15');
INSERT INTO `access_log` VALUES (3954, 'da5877c3-57af-4bd5-9b9b-ac81e1c7d7ae', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:15', 22, 0, '', '2019-05-17 17:58:15');
INSERT INTO `access_log` VALUES (3955, 'b322e4ed-085c-4ada-922b-b4d621909a2f', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:16', 6, 0, '', '2019-05-17 17:58:16');
INSERT INTO `access_log` VALUES (3956, 'fbe8ab7a-d9e3-4f91-9cff-d21811b99920', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:16', 11, 0, '', '2019-05-17 17:58:16');
INSERT INTO `access_log` VALUES (3957, 'ae7a221b-f9c9-4e05-a40b-619b241d8721', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:17', 7, 0, '', '2019-05-17 17:58:17');
INSERT INTO `access_log` VALUES (3958, '88b7f696-c9e4-42eb-b78a-0d0b87f93171', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:17', 13, 0, '', '2019-05-17 17:58:17');
INSERT INTO `access_log` VALUES (3959, 'ee9cfa76-44a6-4c3c-b583-19140820b45a', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:17', 12, 0, '', '2019-05-17 17:58:17');
INSERT INTO `access_log` VALUES (3960, '0996152d-3432-4e4c-8b5b-dab351bd1862', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:19', 9, 0, '', '2019-05-17 17:58:19');
INSERT INTO `access_log` VALUES (3961, 'f52ec16a-4ace-4573-ba04-ecc722731383', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=33&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:19', 28, 0, '', '2019-05-17 17:58:19');
INSERT INTO `access_log` VALUES (3962, '47579d0a-3a3f-44d0-9367-aa95dbf7472c', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:20', 6, 0, '', '2019-05-17 17:58:20');
INSERT INTO `access_log` VALUES (3963, '95afd293-4a0f-443a-8ab4-1a4867902189', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:20', 13, 0, '', '2019-05-17 17:58:20');
INSERT INTO `access_log` VALUES (3964, '7e09c971-cad7-4132-a03f-0ac28db7df0e', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:20', 14, 0, '', '2019-05-17 17:58:20');
INSERT INTO `access_log` VALUES (3965, 'a82bf0b9-1a8a-47cd-aed1-399dcca4791d', 1, 1, 'order-application', '/order-api/users/cart/add', 'skuId=33&quantity=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:23', 64, 0, '', '2019-05-17 17:58:23');
INSERT INTO `access_log` VALUES (3966, 'ec156a86-c352-44de-a0c2-6c11e3eda033', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:25', 6, 0, '', '2019-05-17 17:58:25');
INSERT INTO `access_log` VALUES (3967, 'd2d2c107-b0ca-4969-b7a2-4bca806ca09b', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:25', 11, 0, '', '2019-05-17 17:58:25');
INSERT INTO `access_log` VALUES (3968, '3b4a4a17-4b85-4876-9d98-0dd8da873453', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:27', 8, 0, '', '2019-05-17 17:58:27');
INSERT INTO `access_log` VALUES (3969, '120d3fe1-fd13-4ff9-b3eb-728f950fdbb7', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:27', 6, 0, '', '2019-05-17 17:58:27');
INSERT INTO `access_log` VALUES (3970, '9df3cff8-faa8-4862-8e97-d17a499d0984', 1, 1, 'search-application', '/search-api/users/product/page', 'keyword=kafka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:29', 12, 0, '', '2019-05-17 17:58:29');
INSERT INTO `access_log` VALUES (3971, 'f734a83f-b015-494a-89ff-46386ddaa03f', 1, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kafka', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:29', 17, 0, '', '2019-05-17 17:58:29');
INSERT INTO `access_log` VALUES (3972, '6ca1ec14-ddf0-4aa3-8cbf-8193709f658a', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:30', 7, 0, '', '2019-05-17 17:58:30');
INSERT INTO `access_log` VALUES (3973, '928e1f49-2632-4c24-b477-cb42dba18f50', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:30', 13, 0, '', '2019-05-17 17:58:30');
INSERT INTO `access_log` VALUES (3974, 'be4fc00b-ec1c-41c9-9566-6a3902e55ba4', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:30', 11, 0, '', '2019-05-17 17:58:30');
INSERT INTO `access_log` VALUES (3975, 'd898d9e4-9508-478a-80dd-71d22a3a6b00', 1, 1, 'order-application', '/order-api/users/cart/add', 'skuId=33&quantity=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:32', 70, 0, '', '2019-05-17 17:58:32');
INSERT INTO `access_log` VALUES (3976, 'c048c08c-90d2-42a8-b7ce-f699039b5a50', 1, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:34', 17, 0, '', '2019-05-17 17:58:34');
INSERT INTO `access_log` VALUES (3977, '47fb62ef-1985-4d68-ba11-a2c505003f81', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:36', 6, 0, '', '2019-05-17 17:58:36');
INSERT INTO `access_log` VALUES (3978, 'd6e17cd5-8310-42c7-8a34-747bdff0afc6', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:36', 12, 0, '', '2019-05-17 17:58:36');
INSERT INTO `access_log` VALUES (3979, '8b6cacbf-a303-4ae0-a78b-cc61d1067235', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:36', 12, 0, '', '2019-05-17 17:58:36');
INSERT INTO `access_log` VALUES (3980, '5f582498-635c-4487-8217-b86e5af8d141', 1, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:37', 11, 0, '', '2019-05-17 17:58:37');
INSERT INTO `access_log` VALUES (3981, '568960f6-85a5-4f66-b04b-c9c1cb1080f5', 1, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:37', 11, 0, '', '2019-05-17 17:58:37');
INSERT INTO `access_log` VALUES (3982, '1fa23a43-a307-41bd-be08-abe0627e386a', 1, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:37', 17, 0, '', '2019-05-17 17:58:37');
INSERT INTO `access_log` VALUES (3983, 'c183e27b-65a3-49dd-bc23-1b0de8114a64', 1, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:37', 21, 0, '', '2019-05-17 17:58:37');
INSERT INTO `access_log` VALUES (3984, '816a543a-7166-4123-9925-7a20063996ac', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:38', 6, 0, '', '2019-05-17 17:58:38');
INSERT INTO `access_log` VALUES (3985, 'f363a4bd-5ee8-4bca-8ae9-68000d54b525', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:38', 11, 0, '', '2019-05-17 17:58:38');
INSERT INTO `access_log` VALUES (3986, '57c827c5-443d-4e30-876b-48c81a93ca26', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:38', 13, 0, '', '2019-05-17 17:58:38');
INSERT INTO `access_log` VALUES (3987, '8734cbfc-2a72-44eb-8ea5-381d06baec58', 1, 1, 'order-application', '/order-api/users/cart/add', 'skuId=31&quantity=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:40', 99, 0, '', '2019-05-17 17:58:40');
INSERT INTO `access_log` VALUES (3988, 'bec2ca35-f487-4f31-8013-44fee056cf99', 1, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:42', 18, 0, '', '2019-05-17 17:58:42');
INSERT INTO `access_log` VALUES (3989, '470b8bf3-e99b-4324-817b-9c9cbe0d8d72', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:44', 9, 0, '', '2019-05-17 17:58:44');
INSERT INTO `access_log` VALUES (3990, '35b66d02-60c5-4d23-96a6-b60aab14ce2e', 1, 1, 'order-application', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:44', 25, 0, '', '2019-05-17 17:58:44');
INSERT INTO `access_log` VALUES (3991, 'a2c0385f-94ea-4ab4-872c-f285b7f114cd', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:46', 10, 0, '', '2019-05-17 17:58:46');
INSERT INTO `access_log` VALUES (3992, '1ad5bc0d-8e99-41b4-932c-819aad3d8da4', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:47', 8, 0, '', '2019-05-17 17:58:47');
INSERT INTO `access_log` VALUES (3993, '4e3aa08b-3dca-4635-834e-cf6b1906d1cf', 1, 1, 'order-application', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:47', 25, 0, '', '2019-05-17 17:58:47');
INSERT INTO `access_log` VALUES (3994, '9f91be3c-79cc-4efb-bb5e-4d6f4764d5a1', 1, 1, 'order-application', '/order-api/users/cart/confirm_create_order', 'couponCardId=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:49', 29, 0, '', '2019-05-17 17:58:49');
INSERT INTO `access_log` VALUES (3995, '67947faf-b216-4adf-8310-85f62932874a', 1, 1, 'order-application', '/order-api/users/order/create_order_from_cart', 'userAddressId=1&remark=&couponCardId=3', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:50', 916, 0, '', '2019-05-17 17:58:51');
INSERT INTO `access_log` VALUES (3996, '346ab3f8-b471-4fd9-92fc-63f549ee5f46', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=221', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:51', 10, 0, '', '2019-05-17 17:58:51');
INSERT INTO `access_log` VALUES (3997, '83c86bd4-79b6-495b-a77e-5ef82de2972c', 1, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=221&payChannel=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:55', 230, 0, '', '2019-05-17 17:58:55');
INSERT INTO `access_log` VALUES (3998, '0858adb2-dcc9-4706-a409-9bfc3ce0f435', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=221', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:58:59', 18, 0, '', '2019-05-17 17:58:59');
INSERT INTO `access_log` VALUES (3999, 'd28bec63-ef31-41a0-a1dc-c74ff5100889', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=221', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:03', 16, 0, '', '2019-05-17 17:59:03');
INSERT INTO `access_log` VALUES (4000, '46cf71f9-9ff9-4efd-81b9-de4db1123329', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=221', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:05', 17, 0, '', '2019-05-17 17:59:05');
INSERT INTO `access_log` VALUES (4001, '2cb04ca5-70dd-4019-8a75-16ce34272892', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=221', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:06', 16, 0, '', '2019-05-17 17:59:06');
INSERT INTO `access_log` VALUES (4002, 'badf0abb-6a37-4b58-bd81-2c9c847169d6', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=221', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:07', 14, 0, '', '2019-05-17 17:59:07');
INSERT INTO `access_log` VALUES (4003, '1c3c7988-5390-4f5b-8f94-ae0943f3b8ca', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=221', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:08', 21, 0, '', '2019-05-17 17:59:08');
INSERT INTO `access_log` VALUES (4004, '62383630-b12a-4fef-8759-74dcb1b631b9', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=221', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:09', 15, 0, '', '2019-05-17 17:59:09');
INSERT INTO `access_log` VALUES (4005, 'dbe73443-1485-465f-a1a8-e4fb8c82bbe7', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=221', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:11', 16, 0, '', '2019-05-17 17:59:11');
INSERT INTO `access_log` VALUES (4006, '20c1f7ce-d955-4c96-94eb-38bc7b9d0424', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=221', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:12', 14, 0, '', '2019-05-17 17:59:12');
INSERT INTO `access_log` VALUES (4007, 'db80297a-58d1-49be-9e8c-e807bd64c863', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=221', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:14', 15, 0, '', '2019-05-17 17:59:14');
INSERT INTO `access_log` VALUES (4008, 'bd77f239-5415-4e61-8bdc-a645f66a8af4', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=221', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:15', 14, 0, '', '2019-05-17 17:59:15');
INSERT INTO `access_log` VALUES (4009, 'e0f973a8-38a1-431b-a4b1-c04925e1d77d', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=221', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:17', 9, 0, '', '2019-05-17 17:59:17');
INSERT INTO `access_log` VALUES (4010, 'ab75904f-b0b2-4bdb-ad30-2fd00cff1b2e', 1, 1, 'order-application', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:19', 7, 0, '', '2019-05-17 17:59:19');
INSERT INTO `access_log` VALUES (4011, '4fe1891a-7712-4e72-9bb0-1da5cb6a5419', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:19', 8, 0, '', '2019-05-17 17:59:19');
INSERT INTO `access_log` VALUES (4012, '44eeb0a3-71eb-4ce3-ae50-b6407b272ff2', 1, 1, 'order-application', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:20', 7, 0, '', '2019-05-17 17:59:20');
INSERT INTO `access_log` VALUES (4013, '14a4f841-5a69-42f4-8f9d-faa1309c5c86', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:59:20', 7, 0, '', '2019-05-17 17:59:20');
INSERT INTO `access_log` VALUES (4014, 'c9a52c30-87a7-4ccd-aa16-1029516d9cb3', 1, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:00:01', 8, 0, '', '2019-05-17 18:00:01');
INSERT INTO `access_log` VALUES (4015, 'ce84f92c-957a-44fb-8c49-0f55e070cee4', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:00:01', 7, 0, '', '2019-05-17 18:00:01');
INSERT INTO `access_log` VALUES (4016, '79751cc2-02a6-4762-bd84-126424a92cdf', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:00:01', 14, 0, '', '2019-05-17 18:00:01');
INSERT INTO `access_log` VALUES (4017, 'a062f380-841c-443b-93de-ea589fadd112', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:00:02', 16, 0, '', '2019-05-17 18:00:02');
INSERT INTO `access_log` VALUES (4018, '9e3b5857-126c-4a49-88ab-02523b99c20e', 1, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:00:02', 12, 0, '', '2019-05-17 18:00:02');
INSERT INTO `access_log` VALUES (4019, '282b9e33-361a-4aae-aa6a-211b17b683dd', 1, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:00:02', 11, 0, '', '2019-05-17 18:00:02');
INSERT INTO `access_log` VALUES (4020, 'c3f44877-1cb3-4194-afd8-ae42081bfd09', 1, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:00:02', 17, 0, '', '2019-05-17 18:00:02');
INSERT INTO `access_log` VALUES (4021, '26931579-6bb8-463b-9ed1-5839ff53ba41', 1, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:00:02', 15, 0, '', '2019-05-17 18:00:02');
INSERT INTO `access_log` VALUES (4022, '402966df-0b9f-4503-9004-f603f9d10109', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:00:03', 7, 0, '', '2019-05-17 18:00:03');
INSERT INTO `access_log` VALUES (4023, 'd97eee67-06b8-4a05-a08d-c695acf85ab8', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:00:03', 6, 0, '', '2019-05-17 18:00:03');
INSERT INTO `access_log` VALUES (4024, 'fdea56a4-4d1a-417e-b3c1-84643dcdaa94', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:00:04', 10, 0, '', '2019-05-17 18:00:04');
INSERT INTO `access_log` VALUES (4025, '9a198f4d-8e07-46e0-a1dd-4bb41159aae1', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:00:05', 17, 0, '', '2019-05-17 18:00:05');
INSERT INTO `access_log` VALUES (4026, 'd95d9cfe-b698-47af-8bfa-8b1137e4b178', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=128', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:00:09', 236, 0, '', '2019-05-17 18:00:10');
INSERT INTO `access_log` VALUES (4027, '9d6d1b14-3f96-4cc1-84cf-88eaa5299d19', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:00:12', 15, 0, '', '2019-05-17 18:00:12');
INSERT INTO `access_log` VALUES (4028, '43ae034e-ba66-4d2e-b126-7fb5afdfda26', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:21:15', 59, 0, '', '2019-05-17 18:21:15');
INSERT INTO `access_log` VALUES (4029, '7cd48794-41f1-44dc-83e7-775574f67c37', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:21:21', 27, 0, '', '2019-05-17 18:21:21');
INSERT INTO `access_log` VALUES (4030, 'a3e5084b-1788-43d4-836f-cd10b1b713bf', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 18:21:21', 38, 0, '', '2019-05-17 18:21:21');
INSERT INTO `access_log` VALUES (4031, '5afc1eb9-cf10-4b2b-828c-7de389672099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:21:37', 191, 1002002001, '密码不正确', '2019-05-17 18:21:37');
INSERT INTO `access_log` VALUES (4032, '40ca836f-9722-4439-994e-29f1cd3ad412', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:21:44', 5, 1002002001, '密码不正确', '2019-05-17 18:21:44');
INSERT INTO `access_log` VALUES (4033, '7c5bbccf-3e4f-4fef-9e01-2939b9f9cd71', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:21:51', 6, 1002002001, '密码不正确', '2019-05-17 18:21:51');
INSERT INTO `access_log` VALUES (4034, '8dd76df9-15c9-4ccf-bd64-df6eced20e18', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:21:55', 19, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 18:21:55');
INSERT INTO `access_log` VALUES (4035, '732c055d-0f1d-4649-811b-1bd059e04983', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:21:59', 4, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 18:21:59');
INSERT INTO `access_log` VALUES (4036, '7deb3f29-8bdd-4397-8e7b-c81d20b22a3b', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:22:10', 131, 0, '', '2019-05-17 18:22:10');
INSERT INTO `access_log` VALUES (4037, 'd0868035-8841-49c1-b25d-d9335905af89', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:22:11', 166, 0, '', '2019-05-17 18:22:11');
INSERT INTO `access_log` VALUES (4038, '281da859-6601-4b92-8b15-c738a393cffa', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:22:11', 174, 0, '', '2019-05-17 18:22:11');
INSERT INTO `access_log` VALUES (4039, '9621022f-fa9a-4424-b63d-b68a2cd84ccc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:22:11', 170, 0, '', '2019-05-17 18:22:11');
INSERT INTO `access_log` VALUES (4040, 'e2c8054b-a808-4208-90fc-3cbff77853cc', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:22:13', 120, 0, '', '2019-05-17 18:22:14');
INSERT INTO `access_log` VALUES (4041, 'f43934a2-ad5d-4143-a76f-2ac1f89dc367', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:22:17', 26, 0, '', '2019-05-17 18:22:17');
INSERT INTO `access_log` VALUES (4042, '42501492-a64f-4b21-8f63-b1bebce85b2a', 1, 2, 'admin-application', '/admin-api/admins/admin/update', 'id=27&username=yudaoyuanma&nickname=芋道源码（演示账号）&password=yudaoyuanma', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:22:24', 24, 1002002008, '管理员的账号不允许变更', '2019-05-17 18:22:24');
INSERT INTO `access_log` VALUES (4043, '16123ff6-52e7-4fef-a24c-206cdacb1ff7', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:22:36', 5, 1002002001, '密码不正确', '2019-05-17 18:22:36');
INSERT INTO `access_log` VALUES (4044, '15313baa-fd41-44f3-a767-8ec18f5742c9', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:22:45', 3, 1002002001, '密码不正确', '2019-05-17 18:22:45');
INSERT INTO `access_log` VALUES (4045, '1b95baea-596a-4912-a71f-b1589d03fdf6', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:22:53', 5, 1002002001, '密码不正确', '2019-05-17 18:22:53');
INSERT INTO `access_log` VALUES (4046, '7ad69c76-b2f3-420f-9374-608d593536ec', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:22:58', 113, 0, '', '2019-05-17 18:22:58');
INSERT INTO `access_log` VALUES (4047, 'd048f0cd-96b2-47ab-8027-88cd53aee2a5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:22:59', 15, 0, '', '2019-05-17 18:22:59');
INSERT INTO `access_log` VALUES (4048, 'a1f2e84b-aa78-4365-8892-8c0db9390b5f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:22:59', 17, 0, '', '2019-05-17 18:22:59');
INSERT INTO `access_log` VALUES (4049, '1d6a8bea-afaf-43c0-9bf4-4c76b8dd2a25', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:22:59', 18, 0, '', '2019-05-17 18:22:59');
INSERT INTO `access_log` VALUES (4050, 'f74f01a0-d9b3-4103-9fd8-fc8a680a3056', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:23:00', 130, 0, '', '2019-05-17 18:23:00');
INSERT INTO `access_log` VALUES (4051, '4dbf7833-69b7-4ee3-87a1-db25a1325ff9', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:23:02', 17, 0, '', '2019-05-17 18:23:02');
INSERT INTO `access_log` VALUES (4052, '3ff0c33f-f5e7-4e03-bd8a-aeda96eba2c9', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:23:03', 21, 0, '', '2019-05-17 18:23:03');
INSERT INTO `access_log` VALUES (4053, '8ab15189-7e05-4161-8cb2-af0fa69b5b66', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:25:27', 208, 0, '', '2019-05-17 18:25:27');
INSERT INTO `access_log` VALUES (4054, '6f82ef86-bae9-4e5b-9ad8-2d84e31ff5da', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:25:27', 15, 0, '', '2019-05-17 18:25:27');
INSERT INTO `access_log` VALUES (4055, '76356658-e4d5-4e74-a1b2-a5ce0fb04e82', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:25:27', 15, 0, '', '2019-05-17 18:25:27');
INSERT INTO `access_log` VALUES (4056, '32dc7a68-c763-4a8e-bea9-adf5d3e4a1b5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:25:27', 15, 0, '', '2019-05-17 18:25:27');
INSERT INTO `access_log` VALUES (4057, '21fffc71-a6df-4f71-a2f1-ec2d1459778a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:25:38', 76, 0, '', '2019-05-17 18:25:38');
INSERT INTO `access_log` VALUES (4058, 'e07d33c6-a068-4bd4-8116-6e7dbd76eb74', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:25:38', 15, 0, '', '2019-05-17 18:25:38');
INSERT INTO `access_log` VALUES (4059, '0b48c7b8-ae54-4f8d-b860-543ebf6235c1', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:25:38', 14, 0, '', '2019-05-17 18:25:38');
INSERT INTO `access_log` VALUES (4060, 'e9043815-ce29-458c-a829-ffae4625ebf4', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:25:38', 14, 0, '', '2019-05-17 18:25:38');
INSERT INTO `access_log` VALUES (4061, 'ce65d931-8052-4be1-a53f-df9a2c6b1352', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:27:45', 70, 0, '', '2019-05-17 18:27:45');
INSERT INTO `access_log` VALUES (4062, '2566e431-97bf-4cb9-975c-8973e5292f22', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:27:45', 13, 0, '', '2019-05-17 18:27:45');
INSERT INTO `access_log` VALUES (4063, 'd12b1bf8-b922-4d3e-8887-5672d33a4541', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:27:45', 16, 0, '', '2019-05-17 18:27:45');
INSERT INTO `access_log` VALUES (4064, '7488f914-65ea-448b-a6af-2810b8f9ba2c', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:27:45', 16, 0, '', '2019-05-17 18:27:45');
INSERT INTO `access_log` VALUES (4065, '33e47470-dbbb-4888-a862-eb72c357863c', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:28:40', 97, 0, '', '2019-05-17 18:28:40');
INSERT INTO `access_log` VALUES (4066, 'ae008f13-f8be-471a-a6c6-894dfc66c843', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:28:41', 12, 0, '', '2019-05-17 18:28:41');
INSERT INTO `access_log` VALUES (4067, 'cab55d30-75fd-4b15-bedb-80610069607c', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:28:41', 15, 0, '', '2019-05-17 18:28:41');
INSERT INTO `access_log` VALUES (4068, 'ac6e6e68-91f6-430e-8ae5-3219925dabe4', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:28:41', 15, 0, '', '2019-05-17 18:28:41');
INSERT INTO `access_log` VALUES (4069, '272afd33-40dd-4ee3-8620-676bf10ce006', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:28:45', 102, 0, '', '2019-05-17 18:28:45');
INSERT INTO `access_log` VALUES (4070, 'd64cf262-c468-4a9c-b8d8-8441cf1117bd', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:28:47', 122, 0, '', '2019-05-17 18:28:47');
INSERT INTO `access_log` VALUES (4071, '4645293a-de8a-4101-beac-f86fc794eace', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:28:49', 131, 0, '', '2019-05-17 18:28:49');
INSERT INTO `access_log` VALUES (4072, 'f6a52223-3cb9-4f99-ae34-28f6dbfbf15d', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:28:49', 160, 0, '', '2019-05-17 18:28:49');
INSERT INTO `access_log` VALUES (4073, '20a4bb93-5789-405e-a215-f82cc167dbb3', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:28:51', 15, 0, '', '2019-05-17 18:28:51');
INSERT INTO `access_log` VALUES (4074, '1955c456-2673-4c75-8bc5-f5ddf712727d', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:28:51', 42, 0, '', '2019-05-17 18:28:51');
INSERT INTO `access_log` VALUES (4075, 'e3ed1225-cf79-4cef-bfaa-c27ba25b508a', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:28:54', 31, 0, '', '2019-05-17 18:28:54');
INSERT INTO `access_log` VALUES (4076, '1b1cadb3-2549-4ab8-8b56-ba76badaa3a5', 27, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:28:58', 71, 0, '', '2019-05-17 18:28:58');
INSERT INTO `access_log` VALUES (4077, '5488662a-f48e-4f74-9034-1d245301a027', 27, 2, 'order-application', '/order-api/admins/order_return/list', 'index=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:29:01', 105, 0, '', '2019-05-17 18:29:01');
INSERT INTO `access_log` VALUES (4078, '49144c7b-af0a-4de9-be7d-c83abe7fb85e', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:29:04', 3352, 0, '', '2019-05-17 18:29:07');
INSERT INTO `access_log` VALUES (4079, '54da6875-7c24-4665-93b6-8d95c25dff63', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:29:10', 85, 0, '', '2019-05-17 18:29:10');
INSERT INTO `access_log` VALUES (4080, 'e0ef5140-9703-4f17-bf5e-537fbb70c05e', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:29:11', 35, 0, '', '2019-05-17 18:29:11');
INSERT INTO `access_log` VALUES (4081, 'b4aa4b47-f036-4e57-8b4d-c312c6d5282f', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:29:13', 87, 0, '', '2019-05-17 18:29:13');
INSERT INTO `access_log` VALUES (4082, 'c2c953c3-3062-400b-9a3c-8cda7791d657', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:29:15', 133, 0, '', '2019-05-17 18:29:15');
INSERT INTO `access_log` VALUES (4083, 'eacf7d80-527a-486f-a6e5-a69447d4327c', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:29:18', 40, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-17 18:29:18');
INSERT INTO `access_log` VALUES (4084, '6fb94851-78a3-408e-845b-ffe01a6dd2ed', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:29:20', 28, 0, '', '2019-05-17 18:29:20');
INSERT INTO `access_log` VALUES (4085, 'aaf4d468-9bbd-421b-a8b2-fbe04ee8575f', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:29:22', 67, 0, '', '2019-05-17 18:29:22');
INSERT INTO `access_log` VALUES (4086, '8d58fa09-df0c-4480-b41a-9abca5138f20', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:29:24', 19, 0, '', '2019-05-17 18:29:24');
INSERT INTO `access_log` VALUES (4087, 'f68a4bb2-3819-4264-b0d3-5f1e6bb3907d', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 18:29:25', 20, 0, '', '2019-05-17 18:29:25');
INSERT INTO `access_log` VALUES (4088, '37.65.15580909489730041', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 19:02:29', 14, 1002001012, '访问令牌已过期', '2019-05-17 19:02:29');
INSERT INTO `access_log` VALUES (4089, '37.67.15580909501340037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 19:02:30', 4, 1002001012, '访问令牌已过期', '2019-05-17 19:02:30');
INSERT INTO `access_log` VALUES (4090, '37.72.15580909510330041', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 19:02:31', 3, 1002001012, '访问令牌已过期', '2019-05-17 19:02:31');
INSERT INTO `access_log` VALUES (4091, '37.64.15580909732110041', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 19:02:53', 4, 1002001012, '访问令牌已过期', '2019-05-17 19:02:53');
INSERT INTO `access_log` VALUES (4092, '37.68.15580909761940037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 19:02:56', 245, 1002001012, '访问令牌已过期', '2019-05-17 19:02:56');
INSERT INTO `access_log` VALUES (4093, '37.73.15580909773250037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 19:02:57', 3, 1002001012, '访问令牌已过期', '2019-05-17 19:02:57');
INSERT INTO `access_log` VALUES (4094, '35.80.15580913901830075', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:09:50', 79, 0, '', '2019-05-17 19:09:50');
INSERT INTO `access_log` VALUES (4095, '35.74.15580913901830077', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:09:50', 61, 0, '', '2019-05-17 19:09:50');
INSERT INTO `access_log` VALUES (4096, '37.69.15580913952170047', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:09:55', 2, 0, '', '2019-05-17 19:09:55');
INSERT INTO `access_log` VALUES (4097, '37.72.15580913952390045', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:09:55', 2, 0, '', '2019-05-17 19:09:55');
INSERT INTO `access_log` VALUES (4098, '37.67.15580913952540041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:09:55', 17, 0, '', '2019-05-17 19:09:55');
INSERT INTO `access_log` VALUES (4099, '32.82.15580913968660077', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:09:57', 13, 0, '', '2019-05-17 19:09:57');
INSERT INTO `access_log` VALUES (4100, '36.82.15580913970830013', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:09:57', 21, 0, '', '2019-05-17 19:09:57');
INSERT INTO `access_log` VALUES (4101, '32.83.15580914182080079', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:18', 14, 0, '', '2019-05-17 19:10:18');
INSERT INTO `access_log` VALUES (4102, '36.81.15580914183230017', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:18', 27, 0, '', '2019-05-17 19:10:18');
INSERT INTO `access_log` VALUES (4103, '36.83.15580914257450013', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=37', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:26', 13, 0, '', '2019-05-17 19:10:26');
INSERT INTO `access_log` VALUES (4104, '32.86.15580914322590077', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:32', 11, 0, '', '2019-05-17 19:10:32');
INSERT INTO `access_log` VALUES (4105, '36.84.15580914323580015', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:32', 15, 0, '', '2019-05-17 19:10:32');
INSERT INTO `access_log` VALUES (4106, '35.77.15580914380230079', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:38', 5, 0, '', '2019-05-17 19:10:38');
INSERT INTO `access_log` VALUES (4107, '35.76.15580914380240079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:38', 9, 0, '', '2019-05-17 19:10:38');
INSERT INTO `access_log` VALUES (4108, '32.88.15580914397910081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:40', 278, 0, '', '2019-05-17 19:10:40');
INSERT INTO `access_log` VALUES (4109, '32.87.15580914402300079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:40', 3, 0, '', '2019-05-17 19:10:40');
INSERT INTO `access_log` VALUES (4110, '32.80.15580914415400087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:42', 3, 0, '', '2019-05-17 19:10:42');
INSERT INTO `access_log` VALUES (4111, '32.84.15580914432320077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:43', 3, 0, '', '2019-05-17 19:10:43');
INSERT INTO `access_log` VALUES (4112, '32.81.15580914439620083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:44', 4, 0, '', '2019-05-17 19:10:44');
INSERT INTO `access_log` VALUES (4113, '35.72.15580914470180081', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:47', 5, 0, '', '2019-05-17 19:10:47');
INSERT INTO `access_log` VALUES (4114, '35.75.15580914470170083', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:47', 12, 0, '', '2019-05-17 19:10:47');
INSERT INTO `access_log` VALUES (4115, '32.85.15580914484180083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:48', 4, 0, '', '2019-05-17 19:10:48');
INSERT INTO `access_log` VALUES (4116, '32.79.15580914485200079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:49', 3, 0, '', '2019-05-17 19:10:49');
INSERT INTO `access_log` VALUES (4117, '35.78.15580914500100079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:50', 15, 0, '', '2019-05-17 19:10:50');
INSERT INTO `access_log` VALUES (4118, '35.79.15580914500100081', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:50', 5, 0, '', '2019-05-17 19:10:50');
INSERT INTO `access_log` VALUES (4119, '32.82.15580914532010079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:53', 4, 0, '', '2019-05-17 19:10:53');
INSERT INTO `access_log` VALUES (4120, '32.83.15580914532990081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:53', 4, 0, '', '2019-05-17 19:10:53');
INSERT INTO `access_log` VALUES (4121, '32.86.15580914577460079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:58', 3, 0, '', '2019-05-17 19:10:58');
INSERT INTO `access_log` VALUES (4122, '32.88.15580914578730083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:58', 4, 0, '', '2019-05-17 19:10:58');
INSERT INTO `access_log` VALUES (4123, '35.71.15580914594300079', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:59', 4, 0, '', '2019-05-17 19:10:59');
INSERT INTO `access_log` VALUES (4124, '35.73.15580914594300081', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:10:59', 11, 0, '', '2019-05-17 19:10:59');
INSERT INTO `access_log` VALUES (4125, '35.80.15580914703680077', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:11:10', 4, 0, '', '2019-05-17 19:11:10');
INSERT INTO `access_log` VALUES (4126, '35.74.15580914703690079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:11:10', 12, 0, '', '2019-05-17 19:11:10');
INSERT INTO `access_log` VALUES (4127, '36.86.15580914766800013', 0, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:11:17', 2, -1, '未授权', '2019-05-17 19:11:17');
INSERT INTO `access_log` VALUES (4128, '36.85.15580914810890017', 0, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:11:21', 2, -1, '未授权', '2019-05-17 19:11:21');
INSERT INTO `access_log` VALUES (4129, '31.51.15580915003470017', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17765823217&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:11:40', 242, 2001001000, '服务端发生异常', '2019-05-17 19:11:41');
INSERT INTO `access_log` VALUES (4130, '35.76.15580915163440081', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:11:56', 4, 0, '', '2019-05-17 19:11:56');
INSERT INTO `access_log` VALUES (4131, '35.77.15580915163450081', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:11:56', 9, 0, '', '2019-05-17 19:11:56');
INSERT INTO `access_log` VALUES (4132, '32.87.15580915180110081', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:11:58', 10, 0, '', '2019-05-17 19:11:58');
INSERT INTO `access_log` VALUES (4133, '36.87.15580915181530015', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=50', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:11:58', 132, 0, '', '2019-05-17 19:11:58');
INSERT INTO `access_log` VALUES (4134, '35.72.15580915196560083', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:12:00', 5, 0, '', '2019-05-17 19:12:00');
INSERT INTO `access_log` VALUES (4135, '35.75.15580915196570085', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:12:00', 11, 0, '', '2019-05-17 19:12:00');
INSERT INTO `access_log` VALUES (4136, '32.80.15580915228670089', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:12:03', 32, 0, '', '2019-05-17 19:12:03');
INSERT INTO `access_log` VALUES (4137, '36.88.15580915230750013', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:12:03', 886, 0, '', '2019-05-17 19:12:04');
INSERT INTO `access_log` VALUES (4138, '38.67.15580956467580001', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.115.23', '2019-05-17 20:20:47', 164, 1002001015, '账号未登陆', '2019-05-17 20:20:48');
INSERT INTO `access_log` VALUES (4139, '38.64.15580956467580001', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.115.23', '2019-05-17 20:20:47', 165, 1002001015, '账号未登陆', '2019-05-17 20:20:48');
INSERT INTO `access_log` VALUES (4140, '38.65.15580956467580001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.115.23', '2019-05-17 20:20:47', 165, 1002001015, '账号未登陆', '2019-05-17 20:20:48');
INSERT INTO `access_log` VALUES (4141, '38.66.15580956504120001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.38.115.23', '2019-05-17 20:20:50', 126, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 20:20:51');
INSERT INTO `access_log` VALUES (4142, '42.73.15581005407690001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:42:21', 14902, 2001001000, '服务端发生异常', '2019-05-17 21:42:36');
INSERT INTO `access_log` VALUES (4143, '42.74.15581005407690001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:42:21', 14902, 2001001000, '服务端发生异常', '2019-05-17 21:42:36');
INSERT INTO `access_log` VALUES (4144, '42.75.15581007983930001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:46:38', 1361, 2001001000, '服务端发生异常', '2019-05-17 21:46:40');
INSERT INTO `access_log` VALUES (4145, '42.76.15581007983930001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:46:38', 3875, 0, '', '2019-05-17 21:46:42');
INSERT INTO `access_log` VALUES (4146, '42.78.15581008066230001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:46:47', 75, 0, '', '2019-05-17 21:46:47');
INSERT INTO `access_log` VALUES (4147, '42.77.15581008066230001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:46:47', 191, 2001001000, '服务端发生异常', '2019-05-17 21:46:47');
INSERT INTO `access_log` VALUES (4148, '42.80.15581008123120001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:46:52', 75, 0, '', '2019-05-17 21:46:53');
INSERT INTO `access_log` VALUES (4149, '42.79.15581008123080001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:46:52', 295, 2001001000, '服务端发生异常', '2019-05-17 21:46:53');
INSERT INTO `access_log` VALUES (4150, '42.71.15581008339790003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:47:14', 431, 0, '', '2019-05-17 21:47:14');
INSERT INTO `access_log` VALUES (4151, '42.72.15581008339720003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:47:14', 666, 2001001000, '服务端发生异常', '2019-05-17 21:47:15');
INSERT INTO `access_log` VALUES (4152, '39.50.15581008336330001', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:47:14', 6114, 1002001011, '访问令牌不存在', '2019-05-17 21:47:20');
INSERT INTO `access_log` VALUES (4153, '42.74.15581009363820003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:48:56', 595, 0, '', '2019-05-17 21:48:57');
INSERT INTO `access_log` VALUES (4154, '42.73.15581009363820003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:48:56', 929, 2001001000, '服务端发生异常', '2019-05-17 21:48:57');
INSERT INTO `access_log` VALUES (4155, '45.71.15581010532510001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:50:54', 1114, 0, '', '2019-05-17 21:50:55');
INSERT INTO `access_log` VALUES (4156, '45.72.15581010532510001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:50:54', 1214, 0, '', '2019-05-17 21:50:55');
INSERT INTO `access_log` VALUES (4157, '44.77.15581010570700001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:50:57', 989, 0, '', '2019-05-17 21:50:58');
INSERT INTO `access_log` VALUES (4158, '45.75.15581010582210001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:50:58', 128, 0, '', '2019-05-17 21:50:58');
INSERT INTO `access_log` VALUES (4159, '45.73.15581010582130001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:50:58', 167, 0, '', '2019-05-17 21:50:58');
INSERT INTO `access_log` VALUES (4160, '44.80.15581010583240001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:50:58', 194, 0, '', '2019-05-17 21:50:59');
INSERT INTO `access_log` VALUES (4161, '45.76.15581010606110001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:01', 160, 0, '', '2019-05-17 21:51:01');
INSERT INTO `access_log` VALUES (4162, '45.74.15581010606100001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:01', 258, 0, '', '2019-05-17 21:51:01');
INSERT INTO `access_log` VALUES (4163, '39.51.15581010593610001', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:00', 3199, 1002001011, '访问令牌不存在', '2019-05-17 21:51:04');
INSERT INTO `access_log` VALUES (4164, '39.52.15581010673960001', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:07', 275, 1002001011, '访问令牌不存在', '2019-05-17 21:51:08');
INSERT INTO `access_log` VALUES (4165, '38.68.15581010758400001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 21:51:20', 6753, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 21:51:27');
INSERT INTO `access_log` VALUES (4166, '39.57.15581010890900001', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:29', 5695, 1001003001, '验证码已过期', '2019-05-17 21:51:35');
INSERT INTO `access_log` VALUES (4167, '39.56.15581010832850001', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:23', 12115, 0, '', '2019-05-17 21:51:35');
INSERT INTO `access_log` VALUES (4168, '39.55.15581010768200001', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:17', 18580, 0, '', '2019-05-17 21:51:35');
INSERT INTO `access_log` VALUES (4169, '39.53.15581010739050001', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:14', 21467, 0, '', '2019-05-17 21:51:35');
INSERT INTO `access_log` VALUES (4170, '39.54.15581010761570001', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:16', 19242, 0, '', '2019-05-17 21:51:35');
INSERT INTO `access_log` VALUES (4171, '39.48.15581010964920003', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:37', 86, 1001003005, '短信发送过于频率', '2019-05-17 21:51:37');
INSERT INTO `access_log` VALUES (4172, '39.49.15581011015990003', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:42', 1129, 0, '', '2019-05-17 21:51:43');
INSERT INTO `access_log` VALUES (4173, '38.69.15581010902660001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 21:51:30', 13603, 0, '', '2019-05-17 21:51:44');
INSERT INTO `access_log` VALUES (4174, '39.50.15581011046480003', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:45', 303, 0, '', '2019-05-17 21:51:45');
INSERT INTO `access_log` VALUES (4175, '45.78.15581011058020001', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:46', 57, 0, '', '2019-05-17 21:51:46');
INSERT INTO `access_log` VALUES (4176, '45.77.15581011063330001', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:46', 173, 0, '', '2019-05-17 21:51:47');
INSERT INTO `access_log` VALUES (4177, '44.81.15581011073050001', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:47', 262, 0, '', '2019-05-17 21:51:48');
INSERT INTO `access_log` VALUES (4178, '44.83.15581011079700001', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:48', 189, 0, '', '2019-05-17 21:51:48');
INSERT INTO `access_log` VALUES (4179, '44.84.15581011089250001', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:49', 232, 0, '', '2019-05-17 21:51:49');
INSERT INTO `access_log` VALUES (4180, '44.76.15581011097270003', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:51:50', 92, 0, '', '2019-05-17 21:51:50');
INSERT INTO `access_log` VALUES (4181, '44.78.15581011125790003', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:51:53', 141, 0, '', '2019-05-17 21:51:53');
INSERT INTO `access_log` VALUES (4182, '44.77.15581011129340003', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:51:53', 108, 0, '', '2019-05-17 21:51:53');
INSERT INTO `access_log` VALUES (4183, '39.51.15581011252400003', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:05', 1276, 0, '', '2019-05-17 21:52:07');
INSERT INTO `access_log` VALUES (4184, '45.79.15581011142400001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:51:54', 9726, 2001001000, '服务端发生异常', '2019-05-17 21:52:07');
INSERT INTO `access_log` VALUES (4185, '45.79.15581011142400001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:51:54', 9726, 2001001000, '服务端发生异常', '2019-05-17 21:52:07');
INSERT INTO `access_log` VALUES (4186, '45.80.15581011142400001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:51:54', 9726, 2001001000, '服务端发生异常', '2019-05-17 21:52:07');
INSERT INTO `access_log` VALUES (4187, '45.80.15581011142400001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:51:54', 9726, 2001001000, '服务端发生异常', '2019-05-17 21:52:07');
INSERT INTO `access_log` VALUES (4188, '45.72.15581011208460003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:01', 6091, 2001001000, '服务端发生异常', '2019-05-17 21:52:08');
INSERT INTO `access_log` VALUES (4189, '38.71.15581011044780001', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 21:51:44', 23053, 0, '', '2019-05-17 21:52:08');
INSERT INTO `access_log` VALUES (4190, '45.79.15581011142400001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:51:54', 9726, 2001001000, '服务端发生异常', '2019-05-17 21:52:08');
INSERT INTO `access_log` VALUES (4191, '45.80.15581011142400001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:51:54', 9726, 2001001000, '服务端发生异常', '2019-05-17 21:52:08');
INSERT INTO `access_log` VALUES (4192, '38.70.15581011043990001', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 21:51:44', 23280, 0, '', '2019-05-17 21:52:08');
INSERT INTO `access_log` VALUES (4193, '45.71.15581011208420003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:01', 6095, 2001001000, '服务端发生异常', '2019-05-17 21:52:08');
INSERT INTO `access_log` VALUES (4194, '45.71.15581011208420003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:01', 6095, 2001001000, '服务端发生异常', '2019-05-17 21:52:08');
INSERT INTO `access_log` VALUES (4195, '45.72.15581011208460003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:01', 6091, 2001001000, '服务端发生异常', '2019-05-17 21:52:08');
INSERT INTO `access_log` VALUES (4196, '44.79.15581011222070003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:02', 6507, 2001001000, '服务端发生异常', '2019-05-17 21:52:09');
INSERT INTO `access_log` VALUES (4197, '45.73.15581011286570003', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:09', 92, 0, '', '2019-05-17 21:52:09');
INSERT INTO `access_log` VALUES (4198, '45.75.15581011286560003', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:09', 127, 0, '', '2019-05-17 21:52:09');
INSERT INTO `access_log` VALUES (4199, '45.76.15581011289540003', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:09', 86, 0, '', '2019-05-17 21:52:09');
INSERT INTO `access_log` VALUES (4200, '45.74.15581011289540003', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:09', 156, 0, '', '2019-05-17 21:52:09');
INSERT INTO `access_log` VALUES (4201, '38.72.15581011044490001', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 21:51:44', 24973, 0, '', '2019-05-17 21:52:09');
INSERT INTO `access_log` VALUES (4202, '45.77.15581011313890003', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:11', 55, 0, '', '2019-05-17 21:52:11');
INSERT INTO `access_log` VALUES (4203, '45.78.15581011313890003', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:11', 57, 0, '', '2019-05-17 21:52:11');
INSERT INTO `access_log` VALUES (4204, '44.80.15581011337710003', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:14', 29, 0, '', '2019-05-17 21:52:14');
INSERT INTO `access_log` VALUES (4205, '44.81.15581011340360003', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:14', 45, 0, '', '2019-05-17 21:52:14');
INSERT INTO `access_log` VALUES (4206, '44.83.15581011352680003', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:15', 39, 0, '', '2019-05-17 21:52:15');
INSERT INTO `access_log` VALUES (4207, '45.80.15581011358420003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:52:16', 8, 0, '', '2019-05-17 21:52:16');
INSERT INTO `access_log` VALUES (4208, '45.79.15581011358460003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:52:16', 41, 0, '', '2019-05-17 21:52:16');
INSERT INTO `access_log` VALUES (4209, '44.82.15581011358880003', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:16', 85, 0, '', '2019-05-17 21:52:16');
INSERT INTO `access_log` VALUES (4210, '44.84.15581011374500003', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:52:18', 266, 0, '', '2019-05-17 21:52:18');
INSERT INTO `access_log` VALUES (4211, '44.85.15581011398670003', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:20', 128, 0, '', '2019-05-17 21:52:20');
INSERT INTO `access_log` VALUES (4212, '44.76.15581011401300005', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:20', 58, 0, '', '2019-05-17 21:52:20');
INSERT INTO `access_log` VALUES (4213, '44.78.15581011410030005', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:21', 47, 0, '', '2019-05-17 21:52:21');
INSERT INTO `access_log` VALUES (4214, '44.77.15581011411760005', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:52:21', 21, 0, '', '2019-05-17 21:52:21');
INSERT INTO `access_log` VALUES (4215, '44.79.15581011416660005', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:22', 81, 0, '', '2019-05-17 21:52:22');
INSERT INTO `access_log` VALUES (4216, '41.81.15581011385810001', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:52:20', 3327, 0, '', '2019-05-17 21:52:24');
INSERT INTO `access_log` VALUES (4217, '41.82.15581011439050001', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:52:24', 59, 0, '', '2019-05-17 21:52:24');
INSERT INTO `access_log` VALUES (4218, '44.80.15581011487240005', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:29', 239, 0, '', '2019-05-17 21:52:29');
INSERT INTO `access_log` VALUES (4219, '44.81.15581011510940005', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:31', 30, 0, '', '2019-05-17 21:52:31');
INSERT INTO `access_log` VALUES (4220, '44.83.15581011513940005', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:31', 21, 0, '', '2019-05-17 21:52:31');
INSERT INTO `access_log` VALUES (4221, 'N/A', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:25', 6173, 0, '', '2019-05-17 21:52:32');
INSERT INTO `access_log` VALUES (4222, 'N/A', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:29', 2237, 0, '', '2019-05-17 21:52:32');
INSERT INTO `access_log` VALUES (4223, 'N/A', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:32', 57, 0, '', '2019-05-17 21:52:32');
INSERT INTO `access_log` VALUES (4224, 'N/A', 1, 1, 'search-application', '/search-api/users/product/page', 'keyword=kafka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:33', 536, 0, '', '2019-05-17 21:52:34');
INSERT INTO `access_log` VALUES (4225, '39.52.15581011536120003', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15166669999', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:52:34', 132, 0, '', '2019-05-17 21:52:34');
INSERT INTO `access_log` VALUES (4226, '44.82.15581011549260005', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:35', 36, 0, '', '2019-05-17 21:52:35');
INSERT INTO `access_log` VALUES (4227, '44.84.15581011551260005', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:35', 13, 0, '', '2019-05-17 21:52:35');
INSERT INTO `access_log` VALUES (4228, 'N/A', 1, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kafka', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:34', 1218, 0, '', '2019-05-17 21:52:35');
INSERT INTO `access_log` VALUES (4229, '44.85.15581011558370005', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:36', 19, 0, '', '2019-05-17 21:52:36');
INSERT INTO `access_log` VALUES (4230, '44.76.15581011563690007', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:36', 85, 0, '', '2019-05-17 21:52:36');
INSERT INTO `access_log` VALUES (4231, 'N/A', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:36', 142, 0, '', '2019-05-17 21:52:37');
INSERT INTO `access_log` VALUES (4232, '44.78.15581011574830007', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:37', 35, 0, '', '2019-05-17 21:52:38');
INSERT INTO `access_log` VALUES (4233, '44.77.15581011577080007', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:38', 28, 0, '', '2019-05-17 21:52:38');
INSERT INTO `access_log` VALUES (4234, '39.57.15581011584920003', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:38', 18, 0, '', '2019-05-17 21:52:39');
INSERT INTO `access_log` VALUES (4235, '44.79.15581011590600007', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:39', 15, 0, '', '2019-05-17 21:52:39');
INSERT INTO `access_log` VALUES (4236, '44.80.15581011591650007', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:39', 19, 0, '', '2019-05-17 21:52:39');
INSERT INTO `access_log` VALUES (4237, '45.73.15581011596370005', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:40', 14, 0, '', '2019-05-17 21:52:40');
INSERT INTO `access_log` VALUES (4238, '45.75.15581011596380005', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:40', 64, 0, '', '2019-05-17 21:52:40');
INSERT INTO `access_log` VALUES (4239, '44.83.15581011602120007', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:40', 82, 0, '', '2019-05-17 21:52:40');
INSERT INTO `access_log` VALUES (4240, '41.87.15581011604560001', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:40', 89, 0, '', '2019-05-17 21:52:41');
INSERT INTO `access_log` VALUES (4241, '41.83.15581011602300001', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:40', 635, 0, '', '2019-05-17 21:52:41');
INSERT INTO `access_log` VALUES (4242, '45.76.15581011613840005', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:41', 37, 0, '', '2019-05-17 21:52:41');
INSERT INTO `access_log` VALUES (4243, '45.74.15581011613850005', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:41', 51, 0, '', '2019-05-17 21:52:41');
INSERT INTO `access_log` VALUES (4244, '44.84.15581011619850007', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:42', 69, 0, '', '2019-05-17 21:52:42');
INSERT INTO `access_log` VALUES (4245, '41.86.15581011619710001', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:42', 85, 0, '', '2019-05-17 21:52:42');
INSERT INTO `access_log` VALUES (4246, '41.89.15581011621730001', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:42', 104, 0, '', '2019-05-17 21:52:42');
INSERT INTO `access_log` VALUES (4247, '39.56.15581011633690003', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15136212594', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:52:43', 88, 0, '', '2019-05-17 21:52:43');
INSERT INTO `access_log` VALUES (4248, '45.78.15581011641150005', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:44', 49, 0, '', '2019-05-17 21:52:44');
INSERT INTO `access_log` VALUES (4249, '45.77.15581011641180005', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:44', 58, 0, '', '2019-05-17 21:52:44');
INSERT INTO `access_log` VALUES (4250, '44.85.15581011650990007', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:45', 716, 0, '', '2019-05-17 21:52:46');
INSERT INTO `access_log` VALUES (4251, '44.76.15581011659610009', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:46', 25, 0, '', '2019-05-17 21:52:46');
INSERT INTO `access_log` VALUES (4252, '44.78.15581011671560009', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:47', 43, 0, '', '2019-05-17 21:52:47');
INSERT INTO `access_log` VALUES (4253, '44.77.15581011676950009', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:48', 41, 0, '', '2019-05-17 21:52:48');
INSERT INTO `access_log` VALUES (4254, 'N/A', 1, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:48', 202, 0, '', '2019-05-17 21:52:48');
INSERT INTO `access_log` VALUES (4255, '44.79.15581011685790009', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:49', 292, 0, '', '2019-05-17 21:52:49');
INSERT INTO `access_log` VALUES (4256, '44.80.15581011689680009', 1, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:49', 19, 0, '', '2019-05-17 21:52:49');
INSERT INTO `access_log` VALUES (4257, '39.53.15581011695470003', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:50', 42, 0, '', '2019-05-17 21:52:50');
INSERT INTO `access_log` VALUES (4258, '41.81.15581011711260003', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:51', 539, 0, '', '2019-05-17 21:52:52');
INSERT INTO `access_log` VALUES (4259, '41.84.15581011721620003', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:52', 96, 0, '', '2019-05-17 21:52:52');
INSERT INTO `access_log` VALUES (4260, '41.87.15581011727780003', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:53', 91, 0, '', '2019-05-17 21:52:53');
INSERT INTO `access_log` VALUES (4261, '41.86.15581011733340003', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:53', 43, 0, '', '2019-05-17 21:52:53');
INSERT INTO `access_log` VALUES (4262, '41.89.15581011738920003', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:54', 73, 0, '', '2019-05-17 21:52:54');
INSERT INTO `access_log` VALUES (4263, '41.90.15581011746350003', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:55', 72, 0, '', '2019-05-17 21:52:55');
INSERT INTO `access_log` VALUES (4264, '39.55.15581011748860003', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15136212594&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:52:55', 292, 0, '', '2019-05-17 21:52:55');
INSERT INTO `access_log` VALUES (4265, '41.81.15581011753100005', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:55', 39, 0, '', '2019-05-17 21:52:55');
INSERT INTO `access_log` VALUES (4266, '41.82.15581011758200005', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:56', 60, 0, '', '2019-05-17 21:52:56');
INSERT INTO `access_log` VALUES (4267, '41.84.15581011763440005', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:56', 22, 0, '', '2019-05-17 21:52:56');
INSERT INTO `access_log` VALUES (4268, '41.83.15581011768980005', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:57', 68, 0, '', '2019-05-17 21:52:57');
INSERT INTO `access_log` VALUES (4269, '39.48.15581011767310005', 74, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:52:57', 393, 0, '', '2019-05-17 21:52:57');
INSERT INTO `access_log` VALUES (4270, '41.87.15581011767310005', 74, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:52:57', 544, 0, '', '2019-05-17 21:52:57');
INSERT INTO `access_log` VALUES (4271, '41.86.15581011774760005', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:57', 67, 0, '', '2019-05-17 21:52:58');
INSERT INTO `access_log` VALUES (4272, '41.88.15581011821770005', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:02', 121, 0, '', '2019-05-17 21:53:02');
INSERT INTO `access_log` VALUES (4273, '43.87.15581011811860001', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=129', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:01', 1486, 0, '', '2019-05-17 21:53:03');
INSERT INTO `access_log` VALUES (4274, '43.88.15581011801350001', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=129', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:00', 2445, 0, '', '2019-05-17 21:53:03');
INSERT INTO `access_log` VALUES (4275, '39.50.15581011832230005', 74, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:03', 361, 0, '', '2019-05-17 21:53:04');
INSERT INTO `access_log` VALUES (4276, '43.89.15581011839440001', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=129', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:04', 97, 0, '', '2019-05-17 21:53:04');
INSERT INTO `access_log` VALUES (4277, '43.90.15581011851220001', 1, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=129&payChannel=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:05', 2931, 0, '', '2019-05-17 21:53:08');
INSERT INTO `access_log` VALUES (4278, '41.90.15581011911550005', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=129', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:11', 1765, 0, '', '2019-05-17 21:53:13');
INSERT INTO `access_log` VALUES (4279, '41.81.15581011934230007', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=129', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:13', 81, 0, '', '2019-05-17 21:53:14');
INSERT INTO `access_log` VALUES (4280, '41.82.15581011953970007', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=129', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:15', 76, 0, '', '2019-05-17 21:53:15');
INSERT INTO `access_log` VALUES (4281, '41.84.15581011967650007', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=129', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:17', 101, 0, '', '2019-05-17 21:53:17');
INSERT INTO `access_log` VALUES (4282, '41.85.15581011998910007', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=129', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:20', 83, 0, '', '2019-05-17 21:53:20');
INSERT INTO `access_log` VALUES (4283, '41.83.15581012041320007', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=129', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:24', 53, 0, '', '2019-05-17 21:53:24');
INSERT INTO `access_log` VALUES (4284, '41.87.15581012069470007', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=129', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:27', 148, 0, '', '2019-05-17 21:53:27');
INSERT INTO `access_log` VALUES (4285, '41.86.15581012092630007', 1, 1, 'order-application', '/order-api/users/order/info', 'orderId=129', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:29', 87, 0, '', '2019-05-17 21:53:29');
INSERT INTO `access_log` VALUES (4286, '43.95.15581012109760001', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=129', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:31', 55, 0, '', '2019-05-17 21:53:31');
INSERT INTO `access_log` VALUES (4287, '41.88.15581012129730007', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:33', 35, 0, '', '2019-05-17 21:53:33');
INSERT INTO `access_log` VALUES (4288, '41.89.15581012142170007', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:34', 71, 0, '', '2019-05-17 21:53:34');
INSERT INTO `access_log` VALUES (4289, '41.90.15581012149710007', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:35', 27, 0, '', '2019-05-17 21:53:35');
INSERT INTO `access_log` VALUES (4290, '44.83.15581012150450009', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=undefined', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:35', 567, 2001001000, '服务端发生异常', '2019-05-17 21:53:36');
INSERT INTO `access_log` VALUES (4291, '39.52.15581012149650005', 74, 1, 'user-application', '/user-api/users/address/add', 'name=test&tel=13100000000&country=&province=浙江省&city=杭州市&county=萧山区&areaCode=330109&postalCode=&addressDetail=123&isDefault=false&address=123&areaNo=330109&mobile=13100000000&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:35', 1805, 2001001000, '服务端发生异常', '2019-05-17 21:53:37');
INSERT INTO `access_log` VALUES (4292, '41.81.15581012165010009', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:37', 319, 0, '', '2019-05-17 21:53:37');
INSERT INTO `access_log` VALUES (4293, '39.57.15581012165900005', 74, 1, 'user-application', '/user-api/users/address/add', 'name=test&tel=13100000000&country=&province=浙江省&city=杭州市&county=萧山区&areaCode=330109&postalCode=&addressDetail=123&isDefault=false&address=123&areaNo=330109&mobile=13100000000&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:37', 857, 2001001000, '服务端发生异常', '2019-05-17 21:53:37');
INSERT INTO `access_log` VALUES (4294, '39.56.15581012198900005', 74, 1, 'user-application', '/user-api/users/address/add', 'name=test&tel=13100000000&country=&province=浙江省&city=杭州市&county=萧山区&areaCode=330109&postalCode=&addressDetail=123&isDefault=false&address=123&areaNo=330109&mobile=13100000000&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:40', 166, 2001001000, '服务端发生异常', '2019-05-17 21:53:40');
INSERT INTO `access_log` VALUES (4295, '41.82.15581012220690009', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:42', 40, 0, '', '2019-05-17 21:53:42');
INSERT INTO `access_log` VALUES (4296, '44.82.15581012220680009', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=undefined', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:42', 176, 2001001000, '服务端发生异常', '2019-05-17 21:53:42');
INSERT INTO `access_log` VALUES (4297, '39.55.15581012227770005', 74, 1, 'user-application', '/user-api/users/address/add', 'name=test&tel=13100000000&country=&province=浙江省&city=杭州市&county=萧山区&areaCode=330109&postalCode=&addressDetail=123&isDefault=true&address=123&areaNo=330109&mobile=13100000000&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:43', 335, 2001001000, '服务端发生异常', '2019-05-17 21:53:43');
INSERT INTO `access_log` VALUES (4298, '41.84.15581012247320009', 1, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:45', 69, 0, '', '2019-05-17 21:53:45');
INSERT INTO `access_log` VALUES (4299, '39.54.15581012249500005', 74, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:45', 51, 0, '', '2019-05-17 21:53:45');
INSERT INTO `access_log` VALUES (4300, '39.48.15581012252860007', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:45', 24, 0, '', '2019-05-17 21:53:45');
INSERT INTO `access_log` VALUES (4301, '39.49.15581012258340007', 74, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:46', 14, 0, '', '2019-05-17 21:53:46');
INSERT INTO `access_log` VALUES (4302, '41.85.15581012258300009', 74, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:46', 208, 0, '', '2019-05-17 21:53:46');
INSERT INTO `access_log` VALUES (4303, '45.80.15581012263860005', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:46', 30, 0, '', '2019-05-17 21:53:46');
INSERT INTO `access_log` VALUES (4304, '45.79.15581012263950005', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:46', 77, 0, '', '2019-05-17 21:53:46');
INSERT INTO `access_log` VALUES (4305, '44.85.15581012276380009', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:48', 64, 0, '', '2019-05-17 21:53:48');
INSERT INTO `access_log` VALUES (4306, '41.83.15581012276190009', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:48', 89, 0, '', '2019-05-17 21:53:48');
INSERT INTO `access_log` VALUES (4307, '41.86.15581012278880009', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:48', 78, 0, '', '2019-05-17 21:53:48');
INSERT INTO `access_log` VALUES (4308, '45.71.15581012290180007', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:49', 49, 0, '', '2019-05-17 21:53:49');
INSERT INTO `access_log` VALUES (4309, '45.72.15581012290180007', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:49', 62, 0, '', '2019-05-17 21:53:49');
INSERT INTO `access_log` VALUES (4310, '39.50.15581012304190007', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:50', 70, 0, '', '2019-05-17 21:53:50');
INSERT INTO `access_log` VALUES (4311, '44.78.15581012332690011', 74, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:53', 56, 0, '', '2019-05-17 21:53:53');
INSERT INTO `access_log` VALUES (4312, '41.89.15581012332720009', 74, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:53', 61, 0, '', '2019-05-17 21:53:53');
INSERT INTO `access_log` VALUES (4313, '41.81.15581012338090011', 74, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:54', 37, 0, '', '2019-05-17 21:53:54');
INSERT INTO `access_log` VALUES (4314, '45.76.15581012378610007', 74, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:58', 50, 0, '', '2019-05-17 21:53:58');
INSERT INTO `access_log` VALUES (4315, '45.74.15581012378820007', 74, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:58', 39, 0, '', '2019-05-17 21:53:58');
INSERT INTO `access_log` VALUES (4316, '39.52.15581012407400007', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:54:01', 54, 0, '', '2019-05-17 21:54:01');
INSERT INTO `access_log` VALUES (4317, '41.84.15581012417440011', 74, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:54:02', 78, 0, '', '2019-05-17 21:54:02');
INSERT INTO `access_log` VALUES (4318, '39.57.15581012456410007', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:54:06', 69, 0, '', '2019-05-17 21:54:06');
INSERT INTO `access_log` VALUES (4319, '41.83.15581012479560011', 74, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:54:08', 28, 0, '', '2019-05-17 21:54:08');
INSERT INTO `access_log` VALUES (4320, '41.86.15581012492300011', 74, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:54:09', 15, 0, '', '2019-05-17 21:54:09');
INSERT INTO `access_log` VALUES (4321, '41.89.15581012496800011', 74, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:54:10', 50, 0, '', '2019-05-17 21:54:10');
INSERT INTO `access_log` VALUES (4322, '41.81.15581012499860013', 74, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:54:10', 15, 0, '', '2019-05-17 21:54:10');
INSERT INTO `access_log` VALUES (4323, '41.84.15581012503390013', 74, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:54:10', 54, 0, '', '2019-05-17 21:54:10');
INSERT INTO `access_log` VALUES (4324, '39.56.15581012510410007', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:54:11', 51, 0, '', '2019-05-17 21:54:11');
INSERT INTO `access_log` VALUES (4325, '39.53.15581012512880007', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:54:11', 63, 0, '', '2019-05-17 21:54:11');
INSERT INTO `access_log` VALUES (4326, '45.77.15581012515810007', 74, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:54:12', 14, 0, '', '2019-05-17 21:54:12');
INSERT INTO `access_log` VALUES (4327, '45.78.15581012515750007', 74, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:54:12', 251, 0, '', '2019-05-17 21:54:12');
INSERT INTO `access_log` VALUES (4328, '45.79.15581013268950007', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '112.10.65.227', '2019-05-17 21:55:27', 9, 0, '', '2019-05-17 21:55:27');
INSERT INTO `access_log` VALUES (4329, '45.80.15581013268950007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '112.10.65.227', '2019-05-17 21:55:27', 20, 0, '', '2019-05-17 21:55:27');
INSERT INTO `access_log` VALUES (4330, '45.72.15581013390440009', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '112.10.65.227', '2019-05-17 21:55:39', 68, 0, '', '2019-05-17 21:55:39');
INSERT INTO `access_log` VALUES (4331, '45.71.15581013390440009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '112.10.65.227', '2019-05-17 21:55:39', 59, 0, '', '2019-05-17 21:55:39');
INSERT INTO `access_log` VALUES (4332, '38.73.15581020301450001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 22:07:10', 508, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:07:11');
INSERT INTO `access_log` VALUES (4333, '38.64.15581020356670003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 22:07:16', 63, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:07:16');
INSERT INTO `access_log` VALUES (4334, '38.65.15581020371440003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 22:07:17', 73, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:07:17');
INSERT INTO `access_log` VALUES (4335, '38.67.15581020382890003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 22:07:18', 62, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:07:18');
INSERT INTO `access_log` VALUES (4336, '38.66.15581020392120003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 22:07:19', 49, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:07:19');
INSERT INTO `access_log` VALUES (4337, '38.68.15581020400060003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 22:07:20', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:07:20');
INSERT INTO `access_log` VALUES (4338, '38.69.15581020408630003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 22:07:21', 46, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:07:21');
INSERT INTO `access_log` VALUES (4339, '38.71.15581020415520003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 22:07:22', 71, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:07:22');
INSERT INTO `access_log` VALUES (4340, '38.70.15581020529320003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 22:07:33', 96, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:07:33');
INSERT INTO `access_log` VALUES (4341, '38.72.15581020547360003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 22:07:35', 76, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:07:35');
INSERT INTO `access_log` VALUES (4342, '38.73.15581020556510003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 22:07:36', 59, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:07:36');
INSERT INTO `access_log` VALUES (4343, '38.64.15581020566020005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 22:07:37', 62, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:07:37');
INSERT INTO `access_log` VALUES (4344, '38.65.15581020573350005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 22:07:37', 70, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:07:37');
INSERT INTO `access_log` VALUES (4345, '38.67.15581020580060005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 22:07:38', 123, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:07:38');
INSERT INTO `access_log` VALUES (4346, '38.69.15581021295620005', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:08:50', 241, 1002001012, '访问令牌已过期', '2019-05-17 22:08:50');
INSERT INTO `access_log` VALUES (4347, '38.66.15581021295320005', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:08:50', 249, 1002001012, '访问令牌已过期', '2019-05-17 22:08:50');
INSERT INTO `access_log` VALUES (4348, '38.68.15581021295360005', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:08:50', 223, 1002001012, '访问令牌已过期', '2019-05-17 22:08:50');
INSERT INTO `access_log` VALUES (4349, '38.71.15581021328000005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:08:53', 137, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:08:53');
INSERT INTO `access_log` VALUES (4350, '38.70.15581021470960005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:09:07', 346, 0, '', '2019-05-17 22:09:07');
INSERT INTO `access_log` VALUES (4351, '38.72.15581021477800005', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:09:08', 246, 0, '', '2019-05-17 22:09:08');
INSERT INTO `access_log` VALUES (4352, '38.64.15581021477820007', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:09:08', 299, 0, '', '2019-05-17 22:09:08');
INSERT INTO `access_log` VALUES (4353, '38.73.15581021477800005', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:09:08', 305, 0, '', '2019-05-17 22:09:08');
INSERT INTO `access_log` VALUES (4354, '43.87.15581021553140003', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:09:15', 565, 0, '', '2019-05-17 22:09:16');
INSERT INTO `access_log` VALUES (4355, '43.88.15581021628440003', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:09:23', 412, 0, '', '2019-05-17 22:09:23');
INSERT INTO `access_log` VALUES (4356, '44.83.15581021802800011', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:09:40', 1147, 0, '', '2019-05-17 22:09:41');
INSERT INTO `access_log` VALUES (4357, '44.82.15581021802810011', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:09:40', 1146, 0, '', '2019-05-17 22:09:41');
INSERT INTO `access_log` VALUES (4358, '39.55.15581021836840007', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:09:44', 1452, 0, '', '2019-05-17 22:09:45');
INSERT INTO `access_log` VALUES (4359, '39.54.15581021982860007', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:09:58', 470, 0, '', '2019-05-17 22:09:59');
INSERT INTO `access_log` VALUES (4360, '39.54.15581021982860007', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:09:58', 470, 0, '', '2019-05-17 22:10:00');
INSERT INTO `access_log` VALUES (4361, '39.48.15581022046520009', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=3&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:10:05', 119, 0, '', '2019-05-17 22:10:05');
INSERT INTO `access_log` VALUES (4362, '39.49.15581022084130009', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=4&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:10:08', 86, 0, '', '2019-05-17 22:10:09');
INSERT INTO `access_log` VALUES (4363, '39.50.15581022112530009', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=5&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:10:11', 54, 0, '', '2019-05-17 22:10:11');
INSERT INTO `access_log` VALUES (4364, '39.51.15581022148290009', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=6&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:10:15', 65, 0, '', '2019-05-17 22:10:15');
INSERT INTO `access_log` VALUES (4365, '43.89.15581022483070003', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:10:48', 98, 0, '', '2019-05-17 22:10:48');
INSERT INTO `access_log` VALUES (4366, '43.91.15581022501150003', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:10:50', 157, 0, '', '2019-05-17 22:10:50');
INSERT INTO `access_log` VALUES (4367, '44.85.15581022551520011', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:10:55', 113, 0, '', '2019-05-17 22:10:55');
INSERT INTO `access_log` VALUES (4368, '44.84.15581022551520011', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:10:55', 127, 0, '', '2019-05-17 22:10:55');
INSERT INTO `access_log` VALUES (4369, '44.76.15581022717250013', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=8&name=衣服', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:11:12', 73, 1002002009, NULL, '2019-05-17 22:11:12');
INSERT INTO `access_log` VALUES (4370, '44.77.15581023520750011', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:12:32', 21, 0, '', '2019-05-17 22:12:32');
INSERT INTO `access_log` VALUES (4371, '44.78.15581023520690013', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:12:32', 142, 0, '', '2019-05-17 22:12:32');
INSERT INTO `access_log` VALUES (4372, '44.80.15581023545010013', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:12:35', 315, 0, '', '2019-05-17 22:12:35');
INSERT INTO `access_log` VALUES (4373, '44.79.15581023544980011', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:12:35', 334, 0, '', '2019-05-17 22:12:35');
INSERT INTO `access_log` VALUES (4374, '44.81.15581023544990013', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:12:35', 343, 0, '', '2019-05-17 22:12:35');
INSERT INTO `access_log` VALUES (4375, '44.83.15581023702900013', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:12:50', 42, 0, '', '2019-05-17 22:12:50');
INSERT INTO `access_log` VALUES (4376, '45.73.15581023999530009', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:13:20', 386, 0, '', '2019-05-17 22:13:20');
INSERT INTO `access_log` VALUES (4377, '45.75.15581024058940009', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:13:26', 100, 0, '', '2019-05-17 22:13:26');
INSERT INTO `access_log` VALUES (4378, '45.76.15581024192610009', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:13:39', 222, 0, '', '2019-05-17 22:13:39');
INSERT INTO `access_log` VALUES (4379, '44.82.15581024214650013', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:13:41', 51, 0, '', '2019-05-17 22:13:42');
INSERT INTO `access_log` VALUES (4380, '44.84.15581025402530013', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:15:40', 42, 0, '', '2019-05-17 22:15:40');
INSERT INTO `access_log` VALUES (4381, '44.85.15581025409090013', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:15:41', 40, 0, '', '2019-05-17 22:15:41');
INSERT INTO `access_log` VALUES (4382, '44.76.15581025432570015', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:15:43', 51, 0, '', '2019-05-17 22:15:43');
INSERT INTO `access_log` VALUES (4383, '45.74.15581025452360009', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:15:45', 145, 0, '', '2019-05-17 22:15:45');
INSERT INTO `access_log` VALUES (4384, '45.77.15581025512740009', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:15:51', 62, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-17 22:15:51');
INSERT INTO `access_log` VALUES (4385, '38.66.15581025821620007', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:16:22', 893, 0, '', '2019-05-17 22:16:23');
INSERT INTO `access_log` VALUES (4386, '38.71.15581025821650007', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:16:22', 890, 0, '', '2019-05-17 22:16:23');
INSERT INTO `access_log` VALUES (4387, '38.67.15581025578640007', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:15:58', 25875, 0, '', '2019-05-17 22:16:24');
INSERT INTO `access_log` VALUES (4388, '38.68.15581025820730007', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:16:22', 1590, 0, '', '2019-05-17 22:16:24');
INSERT INTO `access_log` VALUES (4389, '38.65.15581025565640007', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:15:57', 27308, 0, '', '2019-05-17 22:16:24');
INSERT INTO `access_log` VALUES (4390, '38.69.15581025821670007', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.89.236.37', '2019-05-17 22:16:22', 1723, 0, '', '2019-05-17 22:16:24');
INSERT INTO `access_log` VALUES (4391, '38.70.15581025894250007', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:16:29', 2, 1002001015, '账号未登陆', '2019-05-17 22:16:29');
INSERT INTO `access_log` VALUES (4392, '38.72.15581025894330007', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:16:29', 2, 1002001015, '账号未登陆', '2019-05-17 22:16:29');
INSERT INTO `access_log` VALUES (4393, '38.64.15581025894360009', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:16:29', 1, 1002001015, '账号未登陆', '2019-05-17 22:16:29');
INSERT INTO `access_log` VALUES (4394, '38.73.15581025993460007', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:16:39', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 22:16:39');
INSERT INTO `access_log` VALUES (4395, '38.66.15581026134790009', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:16:53', 69, 0, '', '2019-05-17 22:16:54');
INSERT INTO `access_log` VALUES (4396, '38.71.15581026138760009', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:16:54', 20, 0, '', '2019-05-17 22:16:54');
INSERT INTO `access_log` VALUES (4397, '38.68.15581026168640009', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:16:57', 16, 0, '', '2019-05-17 22:16:57');
INSERT INTO `access_log` VALUES (4398, '38.67.15581026168800009', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:16:57', 45, 0, '', '2019-05-17 22:16:57');
INSERT INTO `access_log` VALUES (4399, '43.94.15581026288540001', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:17:09', 28, 0, '', '2019-05-17 22:17:09');
INSERT INTO `access_log` VALUES (4400, '43.93.15581026382900003', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:17:18', 73, 0, '', '2019-05-17 22:17:18');
INSERT INTO `access_log` VALUES (4401, '43.95.15581026433110003', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:17:23', 83, 0, '', '2019-05-17 22:17:23');
INSERT INTO `access_log` VALUES (4402, '44.78.15581026506780015', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:17:31', 25, 0, '', '2019-05-17 22:17:31');
INSERT INTO `access_log` VALUES (4403, '44.77.15581026506660013', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:17:31', 57, 0, '', '2019-05-17 22:17:31');
INSERT INTO `access_log` VALUES (4404, '44.81.15581026741390015', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:17:54', 18, 0, '', '2019-05-17 22:17:54');
INSERT INTO `access_log` VALUES (4405, '44.80.15581026741370015', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:17:54', 32, 0, '', '2019-05-17 22:17:54');
INSERT INTO `access_log` VALUES (4406, '44.83.15581026830260015', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:18:03', 23, 0, '', '2019-05-17 22:18:03');
INSERT INTO `access_log` VALUES (4407, '44.82.15581026830290015', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:18:03', 18, 0, '', '2019-05-17 22:18:03');
INSERT INTO `access_log` VALUES (4408, '44.79.15581026830170013', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:18:03', 35, 0, '', '2019-05-17 22:18:03');
INSERT INTO `access_log` VALUES (4409, '44.84.15581027392160015', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:18:59', 22, 0, '', '2019-05-17 22:18:59');
INSERT INTO `access_log` VALUES (4410, '44.85.15581027392220015', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:18:59', 55, 0, '', '2019-05-17 22:18:59');
INSERT INTO `access_log` VALUES (4411, '44.76.15581027425310017', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:19:03', 19, 0, '', '2019-05-17 22:19:03');
INSERT INTO `access_log` VALUES (4412, '39.52.15581027810750009', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:19:41', 226, 0, '', '2019-05-17 22:19:41');
INSERT INTO `access_log` VALUES (4413, '45.78.15581027928510009', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:19:53', 44, 0, '', '2019-05-17 22:19:53');
INSERT INTO `access_log` VALUES (4414, '45.80.15581028119830009', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:20:12', 97, 0, '', '2019-05-17 22:20:12');
INSERT INTO `access_log` VALUES (4415, '45.79.15581028178870009', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:20:18', 47, 0, '', '2019-05-17 22:20:18');
INSERT INTO `access_log` VALUES (4416, '38.69.15581028226800009', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:20:23', 33, 0, '', '2019-05-17 22:20:23');
INSERT INTO `access_log` VALUES (4417, '38.65.15581028296520009', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:20:30', 19, 0, '', '2019-05-17 22:20:30');
INSERT INTO `access_log` VALUES (4418, '38.70.15581028327400009', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:20:33', 68, 0, '', '2019-05-17 22:20:33');
INSERT INTO `access_log` VALUES (4419, '38.64.15581028352080011', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:20:35', 53, 0, '', '2019-05-17 22:20:35');
INSERT INTO `access_log` VALUES (4420, '38.72.15581028417540009', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:20:42', 71, 0, '', '2019-05-17 22:20:42');
INSERT INTO `access_log` VALUES (4421, '38.73.15581028587180009', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:20:59', 29, 0, '', '2019-05-17 22:20:59');
INSERT INTO `access_log` VALUES (4422, '38.66.15581028911190011', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:21:31', 18, 0, '', '2019-05-17 22:21:31');
INSERT INTO `access_log` VALUES (4423, '38.71.15581029114300011', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:21:51', 18, 0, '', '2019-05-17 22:21:51');
INSERT INTO `access_log` VALUES (4424, '38.68.15581029152340011', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-17 22:21:55', 70, 0, '', '2019-05-17 22:21:55');
INSERT INTO `access_log` VALUES (4425, '45.72.15581035104310011', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:31:50', 23, 0, '', '2019-05-17 22:31:50');
INSERT INTO `access_log` VALUES (4426, '45.71.15581035191990011', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:31:59', 17, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-17 22:31:59');
INSERT INTO `access_log` VALUES (4427, '38.67.15581035284840011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:32:08', 90, 0, '', '2019-05-17 22:32:09');
INSERT INTO `access_log` VALUES (4428, '38.69.15581035386520011', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:32:19', 56, 0, '', '2019-05-17 22:32:19');
INSERT INTO `access_log` VALUES (4429, '38.65.15581035432840011', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:32:23', 30, 0, '', '2019-05-17 22:32:23');
INSERT INTO `access_log` VALUES (4430, '38.70.15581035457480011', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:32:26', 27, 0, '', '2019-05-17 22:32:26');
INSERT INTO `access_log` VALUES (4431, '45.73.15581035540240011', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:32:34', 58, 0, '', '2019-05-17 22:32:34');
INSERT INTO `access_log` VALUES (4432, '43.89.15581035649330005', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:32:45', 440, 0, '', '2019-05-17 22:32:45');
INSERT INTO `access_log` VALUES (4433, '43.91.15581035793220005', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:32:59', 45, 0, '', '2019-05-17 22:32:59');
INSERT INTO `access_log` VALUES (4434, '45.75.15581037491200011', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.36.225.135', '2019-05-17 22:35:49', 7, 0, '', '2019-05-17 22:35:49');
INSERT INTO `access_log` VALUES (4435, '45.76.15581037491200011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.36.225.135', '2019-05-17 22:35:49', 21, 0, '', '2019-05-17 22:35:49');
INSERT INTO `access_log` VALUES (4436, '45.74.15581037525340011', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.36.225.135', '2019-05-17 22:35:53', 65, 0, '', '2019-05-17 22:35:53');
INSERT INTO `access_log` VALUES (4437, '45.77.15581037525350011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.36.225.135', '2019-05-17 22:35:53', 89, 0, '', '2019-05-17 22:35:53');
INSERT INTO `access_log` VALUES (4438, '44.78.15581037585280017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.36.225.135', '2019-05-17 22:35:59', 5, 0, '', '2019-05-17 22:35:59');
INSERT INTO `access_log` VALUES (4439, '44.77.15581037586700015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.36.225.135', '2019-05-17 22:35:59', 4, 0, '', '2019-05-17 22:35:59');
INSERT INTO `access_log` VALUES (4440, '44.81.15581037618500017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.36.225.135', '2019-05-17 22:36:02', 4, 0, '', '2019-05-17 22:36:02');
INSERT INTO `access_log` VALUES (4441, '44.80.15581037627600017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.36.225.135', '2019-05-17 22:36:03', 4, 0, '', '2019-05-17 22:36:03');
INSERT INTO `access_log` VALUES (4442, '44.83.15581037631280017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.36.225.135', '2019-05-17 22:36:03', 5, 0, '', '2019-05-17 22:36:03');
INSERT INTO `access_log` VALUES (4443, '44.79.15581037661510015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.36.225.135', '2019-05-17 22:36:06', 4, 0, '', '2019-05-17 22:36:06');
INSERT INTO `access_log` VALUES (4444, '44.82.15581037662990017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.36.225.135', '2019-05-17 22:36:06', 4, 0, '', '2019-05-17 22:36:06');
INSERT INTO `access_log` VALUES (4445, '45.78.15581037707910011', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.36.225.135', '2019-05-17 22:36:11', 8, 0, '', '2019-05-17 22:36:11');
INSERT INTO `access_log` VALUES (4446, '45.80.15581037707910011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.36.225.135', '2019-05-17 22:36:11', 16, 0, '', '2019-05-17 22:36:11');
INSERT INTO `access_log` VALUES (4447, '38.72.15581045975120011', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:49:58', 20, 0, '', '2019-05-17 22:49:58');
INSERT INTO `access_log` VALUES (4448, '38.64.15581045975120013', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:49:58', 90, 0, '', '2019-05-17 22:49:58');
INSERT INTO `access_log` VALUES (4449, '38.73.15581045975240011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:49:58', 73, 0, '', '2019-05-17 22:49:58');
INSERT INTO `access_log` VALUES (4450, '44.85.15581046013820017', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:50:01', 22, 0, '', '2019-05-17 22:50:01');
INSERT INTO `access_log` VALUES (4451, '44.84.15581046013810017', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:50:01', 28, 0, '', '2019-05-17 22:50:01');
INSERT INTO `access_log` VALUES (4452, '44.76.15581046065970019', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:50:07', 22, 0, '', '2019-05-17 22:50:07');
INSERT INTO `access_log` VALUES (4453, '44.78.15581046065970019', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:50:07', 24, 0, '', '2019-05-17 22:50:07');
INSERT INTO `access_log` VALUES (4454, '44.77.15581046177590017', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.118.196.50', '2019-05-17 22:50:18', 19, 0, '', '2019-05-17 22:50:18');
INSERT INTO `access_log` VALUES (4455, '38.71.15581058574490013', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:10:57', 2, 1002001015, '账号未登陆', '2019-05-17 23:10:57');
INSERT INTO `access_log` VALUES (4456, '38.66.15581058574480013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:10:57', 5, 1002001015, '账号未登陆', '2019-05-17 23:10:57');
INSERT INTO `access_log` VALUES (4457, '38.68.15581058574520013', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:10:57', 2, 1002001015, '账号未登陆', '2019-05-17 23:10:57');
INSERT INTO `access_log` VALUES (4458, '38.67.15581058594840013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:10:59', 94, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 23:11:00');
INSERT INTO `access_log` VALUES (4459, '38.69.15581058641650013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:11:04', 69, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 23:11:04');
INSERT INTO `access_log` VALUES (4460, '38.65.15581058784540013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:11:18', 97, 0, '', '2019-05-17 23:11:19');
INSERT INTO `access_log` VALUES (4461, '38.70.15581058787480013', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:11:19', 27, 0, '', '2019-05-17 23:11:19');
INSERT INTO `access_log` VALUES (4462, '38.72.15581058787540013', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:11:19', 30, 0, '', '2019-05-17 23:11:19');
INSERT INTO `access_log` VALUES (4463, '38.64.15581058787490015', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:11:19', 49, 0, '', '2019-05-17 23:11:19');
INSERT INTO `access_log` VALUES (4464, '43.94.15581058889100003', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:11:29', 88, 0, '', '2019-05-17 23:11:29');
INSERT INTO `access_log` VALUES (4465, '43.93.15581058968680005', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:11:37', 101, 0, '', '2019-05-17 23:11:37');
INSERT INTO `access_log` VALUES (4466, '44.80.15581059014010019', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:11:41', 424, 0, '', '2019-05-17 23:11:42');
INSERT INTO `access_log` VALUES (4467, '44.81.15581059014000019', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:11:41', 426, 0, '', '2019-05-17 23:11:42');
INSERT INTO `access_log` VALUES (4468, '44.83.15581059052470019', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:11:45', 23, 0, '', '2019-05-17 23:11:45');
INSERT INTO `access_log` VALUES (4469, '44.79.15581059052470017', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:11:45', 20, 0, '', '2019-05-17 23:11:45');
INSERT INTO `access_log` VALUES (4470, '44.82.15581059111030019', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:11:51', 17, 0, '', '2019-05-17 23:11:51');
INSERT INTO `access_log` VALUES (4471, '39.57.15581059185760009', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:11:59', 673, 0, '', '2019-05-17 23:11:59');
INSERT INTO `access_log` VALUES (4472, '45.79.15581059203070011', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:12:00', 41, 0, '', '2019-05-17 23:12:00');
INSERT INTO `access_log` VALUES (4473, '45.72.15581059236980013', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:12:04', 21, 0, '', '2019-05-17 23:12:04');
INSERT INTO `access_log` VALUES (4474, '45.71.15581059257400013', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:12:06', 77, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-17 23:12:06');
INSERT INTO `access_log` VALUES (4475, '45.73.15581059277000013', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:12:08', 28, 0, '', '2019-05-17 23:12:08');
INSERT INTO `access_log` VALUES (4476, '38.73.15581059300880013', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:12:10', 30, 0, '', '2019-05-17 23:12:10');
INSERT INTO `access_log` VALUES (4477, '38.71.15581059318350015', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:12:12', 32, 0, '', '2019-05-17 23:12:12');
INSERT INTO `access_log` VALUES (4478, '38.66.15581059326750015', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:12:13', 16, 0, '', '2019-05-17 23:12:13');
INSERT INTO `access_log` VALUES (4479, '38.68.15581059339320015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:12:14', 22, 0, '', '2019-05-17 23:12:14');
INSERT INTO `access_log` VALUES (4480, '38.67.15581059553310015', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:12:35', 58, 0, '', '2019-05-17 23:12:35');
INSERT INTO `access_log` VALUES (4481, '38.69.15581060899540015', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:14:50', 18, 0, '', '2019-05-17 23:14:50');
INSERT INTO `access_log` VALUES (4482, '38.65.15581060923730015', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:14:52', 86, 0, '', '2019-05-17 23:14:52');
INSERT INTO `access_log` VALUES (4483, '38.70.15581061071010015', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:15:07', 191, 0, '', '2019-05-17 23:15:07');
INSERT INTO `access_log` VALUES (4484, '38.72.15581061239290015', 27, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=50&type=2&sort=3&displayName=删除字典&pid=19&permissions[0]=system.dataDict.delete&createTime=2019-05-16T08:01:36.000+0000', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:15:24', 51, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-17 23:15:24');
INSERT INTO `access_log` VALUES (4485, '38.64.15581061241210017', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:15:24', 13, 0, '', '2019-05-17 23:15:24');
INSERT INTO `access_log` VALUES (4486, '38.73.15581061449350015', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:15:45', 19, 0, '', '2019-05-17 23:15:45');
INSERT INTO `access_log` VALUES (4487, '38.71.15581061510930017', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:15:51', 79, 0, '', '2019-05-17 23:15:51');
INSERT INTO `access_log` VALUES (4488, '38.66.15581061551520017', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:15:55', 404, 0, '', '2019-05-17 23:15:56');
INSERT INTO `access_log` VALUES (4489, '38.68.15581061688450017', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:09', 27, 0, '', '2019-05-17 23:16:09');
INSERT INTO `access_log` VALUES (4490, '38.67.15581061726060017', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=27', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:13', 18, 0, '', '2019-05-17 23:16:13');
INSERT INTO `access_log` VALUES (4491, '38.69.15581061749990017', 27, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=27&roleIds=1,6', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:15', 17, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-17 23:16:15');
INSERT INTO `access_log` VALUES (4492, '39.56.15581061811890009', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:21', 54, 0, '', '2019-05-17 23:16:21');
INSERT INTO `access_log` VALUES (4493, '38.65.15581061942880017', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:34', 15, 0, '', '2019-05-17 23:16:34');
INSERT INTO `access_log` VALUES (4494, '38.72.15581061942950017', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:34', 18, 0, '', '2019-05-17 23:16:34');
INSERT INTO `access_log` VALUES (4495, '38.70.15581061942890017', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:34', 25, 0, '', '2019-05-17 23:16:34');
INSERT INTO `access_log` VALUES (4496, '39.53.15581061943730009', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:34', 260, 0, '', '2019-05-17 23:16:35');
INSERT INTO `access_log` VALUES (4497, '38.71.15581061975570019', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:38', 35, 0, '', '2019-05-17 23:16:38');
INSERT INTO `access_log` VALUES (4498, '38.73.15581061975500017', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:38', 47, 0, '', '2019-05-17 23:16:38');
INSERT INTO `access_log` VALUES (4499, '38.64.15581061975500019', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:38', 64, 0, '', '2019-05-17 23:16:38');
INSERT INTO `access_log` VALUES (4500, '39.55.15581061976030009', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:38', 47, 0, '', '2019-05-17 23:16:38');
INSERT INTO `access_log` VALUES (4501, '38.66.15581062023520019', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:42', 38, 0, '', '2019-05-17 23:16:42');
INSERT INTO `access_log` VALUES (4502, '38.68.15581062026170019', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:43', 17, 0, '', '2019-05-17 23:16:43');
INSERT INTO `access_log` VALUES (4503, '38.67.15581062027990019', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:43', 16, 0, '', '2019-05-17 23:16:43');
INSERT INTO `access_log` VALUES (4504, '38.69.15581062029560019', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:43', 14, 0, '', '2019-05-17 23:16:43');
INSERT INTO `access_log` VALUES (4505, '38.65.15581062031540019', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:43', 14, 0, '', '2019-05-17 23:16:43');
INSERT INTO `access_log` VALUES (4506, '38.70.15581062033110019', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:43', 20, 0, '', '2019-05-17 23:16:43');
INSERT INTO `access_log` VALUES (4507, '38.72.15581062035270019', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:44', 41, 0, '', '2019-05-17 23:16:44');
INSERT INTO `access_log` VALUES (4508, '38.71.15581062036530021', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:44', 15, 0, '', '2019-05-17 23:16:44');
INSERT INTO `access_log` VALUES (4509, '38.64.15581062038570021', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:44', 26, 0, '', '2019-05-17 23:16:44');
INSERT INTO `access_log` VALUES (4510, '45.75.15581062040280013', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:44', 68, 0, '', '2019-05-17 23:16:44');
INSERT INTO `access_log` VALUES (4511, '45.76.15581062041970013', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:44', 15, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-17 23:16:44');
INSERT INTO `access_log` VALUES (4512, '45.77.15581062043680013', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:44', 19, 0, '', '2019-05-17 23:16:44');
INSERT INTO `access_log` VALUES (4513, '45.74.15581062045520013', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:45', 34, 0, '', '2019-05-17 23:16:45');
INSERT INTO `access_log` VALUES (4514, '39.54.15581062047560009', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.1.173.198', '2019-05-17 23:16:45', 48, 0, '', '2019-05-17 23:16:45');
INSERT INTO `access_log` VALUES (4515, '38.73.15581079724430019', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:46:12', 2, 1002001015, '账号未登陆', '2019-05-17 23:46:12');
INSERT INTO `access_log` VALUES (4516, '38.68.15581079724460021', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:46:12', 1, 1002001015, '账号未登陆', '2019-05-17 23:46:12');
INSERT INTO `access_log` VALUES (4517, '38.66.15581079724440021', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:46:12', 2, 1002001015, '账号未登陆', '2019-05-17 23:46:12');
INSERT INTO `access_log` VALUES (4518, '38.67.15581079773570021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:46:17', 35, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-17 23:46:17');
INSERT INTO `access_log` VALUES (4519, '38.69.15581079855410021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:46:26', 65, 0, '', '2019-05-17 23:46:26');
INSERT INTO `access_log` VALUES (4520, '38.72.15581079861890021', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:46:26', 13, 0, '', '2019-05-17 23:46:26');
INSERT INTO `access_log` VALUES (4521, '38.70.15581079861880021', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:46:26', 19, 0, '', '2019-05-17 23:46:26');
INSERT INTO `access_log` VALUES (4522, '38.65.15581079861830021', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:46:26', 24, 0, '', '2019-05-17 23:46:26');
INSERT INTO `access_log` VALUES (4523, '38.71.15581079924990023', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:46:33', 203, 0, '', '2019-05-17 23:46:33');
INSERT INTO `access_log` VALUES (4524, '38.64.15581080174490023', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:46:57', 51, 0, '', '2019-05-17 23:46:58');
INSERT INTO `access_log` VALUES (4525, '38.73.15581080263660021', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:47:06', 561, 0, '', '2019-05-17 23:47:07');
INSERT INTO `access_log` VALUES (4526, '38.68.15581080345720023', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:47:15', 18, 0, '', '2019-05-17 23:47:15');
INSERT INTO `access_log` VALUES (4527, '38.66.15581080395140023', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:47:20', 22, 0, '', '2019-05-17 23:47:20');
INSERT INTO `access_log` VALUES (4528, '44.84.15581080632530019', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:47:43', 37, 0, '', '2019-05-17 23:47:43');
INSERT INTO `access_log` VALUES (4529, '44.85.15581080632550019', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:47:43', 51, 0, '', '2019-05-17 23:47:43');
INSERT INTO `access_log` VALUES (4530, '44.76.15581080789240021', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:47:59', 22, 0, '', '2019-05-17 23:47:59');
INSERT INTO `access_log` VALUES (4531, '44.78.15581080789190021', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:47:59', 32, 0, '', '2019-05-17 23:47:59');
INSERT INTO `access_log` VALUES (4532, '43.89.15581081215770007', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:48:42', 57, 0, '', '2019-05-17 23:48:42');
INSERT INTO `access_log` VALUES (4533, '43.91.15581081345040007', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:48:55', 31, 0, '', '2019-05-17 23:48:55');
INSERT INTO `access_log` VALUES (4534, '44.77.15581081479220019', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:49:08', 21, 0, '', '2019-05-17 23:49:08');
INSERT INTO `access_log` VALUES (4535, '45.78.15581081646730013', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:49:25', 32, 0, '', '2019-05-17 23:49:25');
INSERT INTO `access_log` VALUES (4536, '45.80.15581081761400013', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '111.196.245.137', '2019-05-17 23:49:36', 1118, 0, '', '2019-05-17 23:49:37');
INSERT INTO `access_log` VALUES (4537, '45.79.15581134565560013', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', '\"Mozilla/5.0 (iPod; U; CPU iPhone OS 2_1 like Mac OS X; ja-jp) AppleWebKit/525.18.1 (KHTML, like Gecko) Version/3.1.1 Mobile/5F137 Safari/525.20\"', '47.112.109.161', '2019-05-18 01:17:37', 16, 0, '', '2019-05-18 01:17:37');
INSERT INTO `access_log` VALUES (4538, '45.72.15581134565560015', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', '\"Mozilla/5.0 (iPod; U; CPU iPhone OS 2_1 like Mac OS X; ja-jp) AppleWebKit/525.18.1 (KHTML, like Gecko) Version/3.1.1 Mobile/5F137 Safari/525.20\"', '47.112.109.161', '2019-05-18 01:17:37', 46, 0, '', '2019-05-18 01:17:37');
INSERT INTO `access_log` VALUES (4539, '38.67.15581136068460023', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:20:07', 1, 1002001015, '账号未登陆', '2019-05-18 01:20:07');
INSERT INTO `access_log` VALUES (4540, '38.69.15581136068500023', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:20:07', 1, 1002001015, '账号未登陆', '2019-05-18 01:20:07');
INSERT INTO `access_log` VALUES (4541, '38.72.15581136068610023', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:20:07', 2, 1002001015, '账号未登陆', '2019-05-18 01:20:07');
INSERT INTO `access_log` VALUES (4542, '38.65.15581136098960023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:20:10', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-18 01:20:10');
INSERT INTO `access_log` VALUES (4543, '38.70.15581136284120023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:20:28', 107, 0, '', '2019-05-18 01:20:29');
INSERT INTO `access_log` VALUES (4544, '38.73.15581136289560023', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:20:29', 16, 0, '', '2019-05-18 01:20:29');
INSERT INTO `access_log` VALUES (4545, '38.71.15581136289530025', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:20:29', 21, 0, '', '2019-05-18 01:20:29');
INSERT INTO `access_log` VALUES (4546, '38.64.15581136289540025', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:20:29', 22, 0, '', '2019-05-18 01:20:29');
INSERT INTO `access_log` VALUES (4547, '43.94.15581136361410005', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:20:36', 38, 0, '', '2019-05-18 01:20:36');
INSERT INTO `access_log` VALUES (4548, '43.93.15581136491570007', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:20:49', 61, 0, '', '2019-05-18 01:20:49');
INSERT INTO `access_log` VALUES (4549, '44.81.15581136557950021', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:20:56', 40, 0, '', '2019-05-18 01:20:56');
INSERT INTO `access_log` VALUES (4550, '44.80.15581136557940021', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:20:56', 43, 0, '', '2019-05-18 01:20:56');
INSERT INTO `access_log` VALUES (4551, '44.83.15581136640440021', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:21:04', 83, 0, '', '2019-05-18 01:21:04');
INSERT INTO `access_log` VALUES (4552, '38.68.15581136711040025', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:21:11', 28, 0, '', '2019-05-18 01:21:11');
INSERT INTO `access_log` VALUES (4553, '38.66.15581136764010025', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:21:16', 17, 0, '', '2019-05-18 01:21:16');
INSERT INTO `access_log` VALUES (4554, '38.67.15581136799600025', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:21:20', 56, 0, '', '2019-05-18 01:21:20');
INSERT INTO `access_log` VALUES (4555, '38.69.15581136833620025', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:21:23', 14, 0, '', '2019-05-18 01:21:23');
INSERT INTO `access_log` VALUES (4556, '38.72.15581136874520025', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:21:27', 18, 0, '', '2019-05-18 01:21:27');
INSERT INTO `access_log` VALUES (4557, '38.65.15581137121400025', 27, 2, 'admin-application', '/admin-api/admins/role/add', 'name=DRE', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:21:52', 63, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-18 01:21:52');
INSERT INTO `access_log` VALUES (4558, '38.70.15581137123210025', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:21:52', 34, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-05-18 01:21:52');
INSERT INTO `access_log` VALUES (4559, '38.64.15581137228220027', 27, 2, 'admin-application', '/admin-api/admins/role/add', 'name=dre', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:22:03', 10, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-18 01:22:03');
INSERT INTO `access_log` VALUES (4560, '38.71.15581137229430027', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:22:03', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-05-18 01:22:03');
INSERT INTO `access_log` VALUES (4561, '38.73.15581137594790025', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:22:39', 28, 0, '', '2019-05-18 01:22:40');
INSERT INTO `access_log` VALUES (4562, '38.68.15581137617080027', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:22:42', 20, 0, '', '2019-05-18 01:22:42');
INSERT INTO `access_log` VALUES (4563, '38.66.15581137811340027', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:23:01', 258, 0, '', '2019-05-18 01:23:01');
INSERT INTO `access_log` VALUES (4564, '45.71.15581143050150015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:31:45', 11, 0, '', '2019-05-18 01:31:45');
INSERT INTO `access_log` VALUES (4565, '45.73.15581143050160015', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:31:45', 28, 0, '', '2019-05-18 01:31:45');
INSERT INTO `access_log` VALUES (4566, '45.75.15581143156580015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:31:56', 6, 0, '', '2019-05-18 01:31:56');
INSERT INTO `access_log` VALUES (4567, '45.76.15581143156590015', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:31:56', 24, 0, '', '2019-05-18 01:31:56');
INSERT INTO `access_log` VALUES (4568, '38.67.15581143424840027', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:32:22', 514, 0, '', '2019-05-18 01:32:23');
INSERT INTO `access_log` VALUES (4569, '38.69.15581143468370027', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:32:27', 17, 0, '', '2019-05-18 01:32:27');
INSERT INTO `access_log` VALUES (4570, '45.77.15581143516050015', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:32:32', 22, 0, '', '2019-05-18 01:32:32');
INSERT INTO `access_log` VALUES (4571, '45.74.15581143705010015', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:32:51', 23, 0, '', '2019-05-18 01:32:51');
INSERT INTO `access_log` VALUES (4572, '44.79.15581143876680019', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:33:08', 23, 0, '', '2019-05-18 01:33:08');
INSERT INTO `access_log` VALUES (4573, '44.82.15581144070230021', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:33:27', 20, 0, '', '2019-05-18 01:33:27');
INSERT INTO `access_log` VALUES (4574, '44.85.15581144194010021', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:33:39', 29, 0, '', '2019-05-18 01:33:39');
INSERT INTO `access_log` VALUES (4575, '44.84.15581144193980021', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:33:39', 154, 0, '', '2019-05-18 01:33:40');
INSERT INTO `access_log` VALUES (4576, '39.48.15581144283010011', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:33:48', 154, 0, '', '2019-05-18 01:33:48');
INSERT INTO `access_log` VALUES (4577, '45.78.15581144395660015', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:34:00', 26, 0, '', '2019-05-18 01:34:00');
INSERT INTO `access_log` VALUES (4578, '45.80.15581144568040015', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:34:17', 28, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-18 01:34:17');
INSERT INTO `access_log` VALUES (4579, '45.72.15581144621000017', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '139.226.105.0', '2019-05-18 01:34:22', 42, 0, '', '2019-05-18 01:34:22');
INSERT INTO `access_log` VALUES (4580, '38.72.15581146288040027', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.152.146.103', '2019-05-18 01:37:09', 1, 1002001015, '账号未登陆', '2019-05-18 01:37:09');
INSERT INTO `access_log` VALUES (4581, '38.65.15581146288040027', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.152.146.103', '2019-05-18 01:37:09', 1, 1002001015, '账号未登陆', '2019-05-18 01:37:09');
INSERT INTO `access_log` VALUES (4582, '38.70.15581146288130027', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.152.146.103', '2019-05-18 01:37:09', 1, 1002001015, '账号未登陆', '2019-05-18 01:37:09');
INSERT INTO `access_log` VALUES (4583, '45.79.15581170204630015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/4.0 (compatible;)', '219.233.201.34', '2019-05-18 02:17:00', 15, 0, '', '2019-05-18 02:17:00');
INSERT INTO `access_log` VALUES (4584, '38.71.15581365761380029', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', '\"Mozilla/5.0 (iPod; U; CPU iPhone OS 2_1 like Mac OS X; ja-jp) AppleWebKit/525.18.1 (KHTML, like Gecko) Version/3.1.1 Mobile/5F137 Safari/525.20\"', '47.112.136.130', '2019-05-18 07:42:56', 2, 1002001015, '账号未登陆', '2019-05-18 07:42:56');
INSERT INTO `access_log` VALUES (4585, '38.73.15581365761430027', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', '\"Mozilla/5.0 (iPod; U; CPU iPhone OS 2_1 like Mac OS X; ja-jp) AppleWebKit/525.18.1 (KHTML, like Gecko) Version/3.1.1 Mobile/5F137 Safari/525.20\"', '47.112.136.130', '2019-05-18 07:42:56', 1, 1002001015, '账号未登陆', '2019-05-18 07:42:56');
INSERT INTO `access_log` VALUES (4586, '38.64.15581365761380029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', '\"Mozilla/5.0 (iPod; U; CPU iPhone OS 2_1 like Mac OS X; ja-jp) AppleWebKit/525.18.1 (KHTML, like Gecko) Version/3.1.1 Mobile/5F137 Safari/525.20\"', '47.112.136.130', '2019-05-18 07:42:56', 5, 1002001015, '账号未登陆', '2019-05-18 07:42:56');
INSERT INTO `access_log` VALUES (4587, '38.70.15581514421440029', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:50:42', 2, 1002001015, '账号未登陆', '2019-05-18 11:50:42');
INSERT INTO `access_log` VALUES (4588, '38.65.15581514421500029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:50:42', 1, 1002001015, '账号未登陆', '2019-05-18 11:50:42');
INSERT INTO `access_log` VALUES (4589, '38.66.15581514421470029', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:50:42', 1, 1002001015, '账号未登陆', '2019-05-18 11:50:42');
INSERT INTO `access_log` VALUES (4590, '38.72.15581514456580029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:50:46', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-18 11:50:46');
INSERT INTO `access_log` VALUES (4591, '38.73.15581514487640029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:50:49', 109, 0, '', '2019-05-18 11:50:49');
INSERT INTO `access_log` VALUES (4592, '38.64.15581514492360031', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:50:49', 27, 0, '', '2019-05-18 11:50:49');
INSERT INTO `access_log` VALUES (4593, '38.68.15581514492420029', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:50:49', 24, 0, '', '2019-05-18 11:50:49');
INSERT INTO `access_log` VALUES (4594, '38.69.15581514492520029', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:50:49', 17, 0, '', '2019-05-18 11:50:49');
INSERT INTO `access_log` VALUES (4595, '43.87.15581514540750007', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:50:54', 80, 0, '', '2019-05-18 11:50:54');
INSERT INTO `access_log` VALUES (4596, '38.67.15581514621930031', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:51:02', 67, 0, '', '2019-05-18 11:51:02');
INSERT INTO `access_log` VALUES (4597, '38.71.15581514659560033', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:51:06', 54, 0, '', '2019-05-18 11:51:06');
INSERT INTO `access_log` VALUES (4598, '38.70.15581514717700031', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:51:12', 18, 0, '', '2019-05-18 11:51:12');
INSERT INTO `access_log` VALUES (4599, '38.66.15581514794700031', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:51:19', 29, 0, '', '2019-05-18 11:51:20');
INSERT INTO `access_log` VALUES (4600, '38.65.15581514805730031', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:51:21', 19, 0, '', '2019-05-18 11:51:21');
INSERT INTO `access_log` VALUES (4601, '38.72.15581514829910031', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:51:23', 13, 0, '', '2019-05-18 11:51:23');
INSERT INTO `access_log` VALUES (4602, '38.73.15581517482380031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:55:48', 73, 0, '', '2019-05-18 11:55:48');
INSERT INTO `access_log` VALUES (4603, '38.64.15581517487730033', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:55:49', 11, 0, '', '2019-05-18 11:55:49');
INSERT INTO `access_log` VALUES (4604, '38.69.15581517488080031', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:55:49', 11, 0, '', '2019-05-18 11:55:49');
INSERT INTO `access_log` VALUES (4605, '38.68.15581517488510031', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '14.213.141.2', '2019-05-18 11:55:49', 12, 0, '', '2019-05-18 11:55:49');
INSERT INTO `access_log` VALUES (4606, '45.73.15581554951710017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '61.175.197.202', '2019-05-18 12:58:15', 19, 0, '', '2019-05-18 12:58:15');
INSERT INTO `access_log` VALUES (4607, '45.71.15581554951710017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '61.175.197.202', '2019-05-18 12:58:15', 57, 0, '', '2019-05-18 12:58:15');
INSERT INTO `access_log` VALUES (4608, '38.67.15581555307740033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '61.175.197.202', '2019-05-18 12:58:51', 1, 1002001015, '账号未登陆', '2019-05-18 12:58:51');
INSERT INTO `access_log` VALUES (4609, '38.71.15581555307800035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '61.175.197.202', '2019-05-18 12:58:51', 1, 1002001015, '账号未登陆', '2019-05-18 12:58:51');
INSERT INTO `access_log` VALUES (4610, '38.70.15581555307800033', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '61.175.197.202', '2019-05-18 12:58:51', 1, 1002001015, '账号未登陆', '2019-05-18 12:58:51');
INSERT INTO `access_log` VALUES (4611, '38.66.15581555338590033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '61.175.197.202', '2019-05-18 12:58:54', 28, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-18 12:58:54');
INSERT INTO `access_log` VALUES (4612, '38.65.15581555371270033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '61.175.197.202', '2019-05-18 12:58:57', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-18 12:58:57');
INSERT INTO `access_log` VALUES (4613, '38.72.15581555402620033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai1&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '61.175.197.202', '2019-05-18 12:59:00', 59, 0, '', '2019-05-18 12:59:00');
INSERT INTO `access_log` VALUES (4614, '38.73.15581555405490033', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '61.175.197.202', '2019-05-18 12:59:01', 13, 0, '', '2019-05-18 12:59:01');
INSERT INTO `access_log` VALUES (4615, '38.64.15581555405590035', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '61.175.197.202', '2019-05-18 12:59:01', 13, 0, '', '2019-05-18 12:59:01');
INSERT INTO `access_log` VALUES (4616, '38.69.15581555405820033', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '61.175.197.202', '2019-05-18 12:59:01', 27, 0, '', '2019-05-18 12:59:01');
INSERT INTO `access_log` VALUES (4617, '43.89.15581555475080009', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '61.175.197.202', '2019-05-18 12:59:08', 1002, 0, '', '2019-05-18 12:59:09');
INSERT INTO `access_log` VALUES (4618, '43.91.15581555552000009', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '61.175.197.202', '2019-05-18 12:59:15', 36, 0, '', '2019-05-18 12:59:15');
INSERT INTO `access_log` VALUES (4619, '38.68.15581555729880033', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '61.175.197.202', '2019-05-18 12:59:33', 40, 0, '', '2019-05-18 12:59:33');
INSERT INTO `access_log` VALUES (4620, '45.75.15581604986900017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.168.91.167', '2019-05-18 14:21:39', 148, 0, '', '2019-05-18 14:21:39');
INSERT INTO `access_log` VALUES (4621, '45.76.15581604986930017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.168.91.167', '2019-05-18 14:21:39', 178, 0, '', '2019-05-18 14:21:39');
INSERT INTO `access_log` VALUES (4622, '44.76.15581605052900023', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.168.91.167', '2019-05-18 14:21:45', 15, 0, '', '2019-05-18 14:21:45');
INSERT INTO `access_log` VALUES (4623, '41.87.15581605055550013', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.168.91.167', '2019-05-18 14:21:46', 634, 0, '', '2019-05-18 14:21:46');
INSERT INTO `access_log` VALUES (4624, '45.80.15581655604470017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:46:00', 39, 0, '', '2019-05-18 15:46:00');
INSERT INTO `access_log` VALUES (4625, '45.78.15581655604470017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:46:00', 55, 0, '', '2019-05-18 15:46:01');
INSERT INTO `access_log` VALUES (4626, '44.77.15581655703180021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:46:10', 18, 0, '', '2019-05-18 15:46:10');
INSERT INTO `access_log` VALUES (4627, '44.81.15581655705390023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:46:11', 17, 0, '', '2019-05-18 15:46:11');
INSERT INTO `access_log` VALUES (4628, '44.79.15581655723580021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:46:12', 12, 0, '', '2019-05-18 15:46:12');
INSERT INTO `access_log` VALUES (4629, '44.82.15581655724790023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:46:12', 16, 0, '', '2019-05-18 15:46:12');
INSERT INTO `access_log` VALUES (4630, '44.84.15581655737380023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:46:14', 412, 0, '', '2019-05-18 15:46:14');
INSERT INTO `access_log` VALUES (4631, '45.72.15581655758470019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:46:16', 757, 0, '', '2019-05-18 15:46:17');
INSERT INTO `access_log` VALUES (4632, '45.79.15581655758480017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:46:16', 765, 0, '', '2019-05-18 15:46:17');
INSERT INTO `access_log` VALUES (4633, '44.78.15581655940980025', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:46:34', 251, 0, '', '2019-05-18 15:46:34');
INSERT INTO `access_log` VALUES (4634, '41.89.15581655941590013', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:46:34', 559, 0, '', '2019-05-18 15:46:35');
INSERT INTO `access_log` VALUES (4635, '41.81.15581655947390015', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:46:35', 53, 0, '', '2019-05-18 15:46:35');
INSERT INTO `access_log` VALUES (4636, '39.50.15581660791790011', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:54:39', 72, 0, '', '2019-05-18 15:54:39');
INSERT INTO `access_log` VALUES (4637, '41.83.15581660791800013', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:54:39', 231, 1002001011, '访问令牌不存在', '2019-05-18 15:54:39');
INSERT INTO `access_log` VALUES (4638, '39.51.15581661032470011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=1111111111&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.84', '2019-05-18 15:55:03', 69, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-05-18 15:55:03');
INSERT INTO `access_log` VALUES (4639, '39.52.15581661139790011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=1111111111&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:55:14', 34, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-05-18 15:55:14');
INSERT INTO `access_log` VALUES (4640, '39.57.15581661255390011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13111111111111&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:55:26', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-05-18 15:55:26');
INSERT INTO `access_log` VALUES (4641, '39.56.15581661371670011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13111111111&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:55:37', 54, 1001003000, '验证码不存在', '2019-05-18 15:55:37');
INSERT INTO `access_log` VALUES (4642, '39.53.15581661412190011', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13111111111', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:55:41', 82, 0, '', '2019-05-18 15:55:41');
INSERT INTO `access_log` VALUES (4643, '39.55.15581661435590011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13111111111&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:55:44', 201, 0, '', '2019-05-18 15:55:44');
INSERT INTO `access_log` VALUES (4644, '39.48.15581661458590013', 75, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:55:46', 20, 0, '', '2019-05-18 15:55:46');
INSERT INTO `access_log` VALUES (4645, '41.88.15581661485180015', 75, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:55:49', 105, 0, '', '2019-05-18 15:55:49');
INSERT INTO `access_log` VALUES (4646, '41.81.15581661499980017', 75, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:55:50', 103, 0, '', '2019-05-18 15:55:50');
INSERT INTO `access_log` VALUES (4647, '41.82.15581661509980015', 75, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:55:51', 806, 0, '', '2019-05-18 15:55:52');
INSERT INTO `access_log` VALUES (4648, '39.49.15581661538990013', 75, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:55:54', 28, 0, '', '2019-05-18 15:55:54');
INSERT INTO `access_log` VALUES (4649, '41.85.15581661573180015', 75, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:55:57', 9, 0, '', '2019-05-18 15:55:57');
INSERT INTO `access_log` VALUES (4650, '39.50.15581661618670013', 75, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:56:02', 34, 0, '', '2019-05-18 15:56:02');
INSERT INTO `access_log` VALUES (4651, '44.77.15581661638190023', 75, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:56:04', 10, 0, '', '2019-05-18 15:56:04');
INSERT INTO `access_log` VALUES (4652, '44.80.15581661639870025', 75, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:56:04', 11, 0, '', '2019-05-18 15:56:04');
INSERT INTO `access_log` VALUES (4653, '44.81.15581661661390025', 75, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:56:06', 11, 0, '', '2019-05-18 15:56:06');
INSERT INTO `access_log` VALUES (4654, 'N/A', 75, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:56:06', 189, 0, '', '2019-05-18 15:56:06');
INSERT INTO `access_log` VALUES (4655, 'N/A', 75, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:56:08', 23, 0, '', '2019-05-18 15:56:08');
INSERT INTO `access_log` VALUES (4656, '44.83.15581661709990025', 75, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:56:11', 22, 0, '', '2019-05-18 15:56:11');
INSERT INTO `access_log` VALUES (4657, '41.83.15581661710140015', 75, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:56:11', 9, 0, '', '2019-05-18 15:56:11');
INSERT INTO `access_log` VALUES (4658, '41.87.15581661712340015', 75, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:56:11', 372, 0, '', '2019-05-18 15:56:12');
INSERT INTO `access_log` VALUES (4659, '39.51.15581661732670013', 75, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:56:13', 9, 0, '', '2019-05-18 15:56:13');
INSERT INTO `access_log` VALUES (4660, '41.86.15581661732680015', 75, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.84', '2019-05-18 15:56:13', 216, 0, '', '2019-05-18 15:56:13');
INSERT INTO `access_log` VALUES (4661, '38.67.15581686148880035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:36:55', 114, 0, '', '2019-05-18 16:36:55');
INSERT INTO `access_log` VALUES (4662, '38.70.15581686153710035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:36:55', 165, 0, '', '2019-05-18 16:36:56');
INSERT INTO `access_log` VALUES (4663, '38.66.15581686153790035', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:36:55', 162, 0, '', '2019-05-18 16:36:56');
INSERT INTO `access_log` VALUES (4664, '38.71.15581686153780037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:36:55', 162, 0, '', '2019-05-18 16:36:56');
INSERT INTO `access_log` VALUES (4665, '43.95.15581686206520009', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:37:01', 43, 0, '', '2019-05-18 16:37:01');
INSERT INTO `access_log` VALUES (4666, '44.82.15581686254620025', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:37:05', 45, 0, '', '2019-05-18 16:37:06');
INSERT INTO `access_log` VALUES (4667, '44.79.15581686254620023', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:37:05', 48, 0, '', '2019-05-18 16:37:06');
INSERT INTO `access_log` VALUES (4668, '38.65.15581686726560035', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:37:53', 2147, 0, '', '2019-05-18 16:37:55');
INSERT INTO `access_log` VALUES (4669, '38.72.15581686762140035', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:37:56', 7, 0, '', '2019-05-18 16:37:56');
INSERT INTO `access_log` VALUES (4670, '44.84.15581686823810025', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:02', 19, 0, '', '2019-05-18 16:38:02');
INSERT INTO `access_log` VALUES (4671, '44.85.15581686823800025', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:02', 31, 0, '', '2019-05-18 16:38:02');
INSERT INTO `access_log` VALUES (4672, '44.76.15581686881430027', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:08', 15, 0, '', '2019-05-18 16:38:08');
INSERT INTO `access_log` VALUES (4673, '39.52.15581686956590013', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:16', 97, 0, '', '2019-05-18 16:38:16');
INSERT INTO `access_log` VALUES (4674, '45.73.15581686980130019', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:18', 28, 0, '', '2019-05-18 16:38:18');
INSERT INTO `access_log` VALUES (4675, '45.71.15581687017540019', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:22', 828, 0, '', '2019-05-18 16:38:23');
INSERT INTO `access_log` VALUES (4676, '45.75.15581687048340019', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:25', 18, 0, '', '2019-05-18 16:38:25');
INSERT INTO `access_log` VALUES (4677, '45.76.15581687052950019', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:25', 20, 0, '', '2019-05-18 16:38:25');
INSERT INTO `access_log` VALUES (4678, '45.77.15581687056690019', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:26', 17, 0, '', '2019-05-18 16:38:26');
INSERT INTO `access_log` VALUES (4679, '45.74.15581687060550019', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=INVALID&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:26', 17, 0, '', '2019-05-18 16:38:26');
INSERT INTO `access_log` VALUES (4680, '45.80.15581687072870019', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:27', 20, 0, '', '2019-05-18 16:38:27');
INSERT INTO `access_log` VALUES (4681, '38.73.15581687111110035', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:31', 27, 0, '', '2019-05-18 16:38:31');
INSERT INTO `access_log` VALUES (4682, '38.64.15581687131340037', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:33', 16, 0, '', '2019-05-18 16:38:33');
INSERT INTO `access_log` VALUES (4683, '38.69.15581687150820035', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:35', 22, 0, '', '2019-05-18 16:38:35');
INSERT INTO `access_log` VALUES (4684, '38.68.15581687163100035', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:36', 18, 0, '', '2019-05-18 16:38:36');
INSERT INTO `access_log` VALUES (4685, '38.67.15581687185260037', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:39', 17, 0, '', '2019-05-18 16:38:39');
INSERT INTO `access_log` VALUES (4686, '38.71.15581687256570039', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:46', 13, 0, '', '2019-05-18 16:38:46');
INSERT INTO `access_log` VALUES (4687, '38.70.15581687330290037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:53', 37, 0, '', '2019-05-18 16:38:53');
INSERT INTO `access_log` VALUES (4688, '38.66.15581687356490037', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-18 16:38:56', 24, 0, '', '2019-05-18 16:38:56');
INSERT INTO `access_log` VALUES (4689, '38.73.15581735783990037', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 17:59:38', 0, 1002001015, '账号未登陆', '2019-05-18 17:59:38');
INSERT INTO `access_log` VALUES (4690, '38.72.15581735783930037', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 17:59:38', 1, 1002001015, '账号未登陆', '2019-05-18 17:59:38');
INSERT INTO `access_log` VALUES (4691, '38.65.15581735783840037', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 17:59:38', 2, 1002001015, '账号未登陆', '2019-05-18 17:59:38');
INSERT INTO `access_log` VALUES (4692, '38.64.15581735807200039', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 17:59:41', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-18 17:59:41');
INSERT INTO `access_log` VALUES (4693, '38.69.15581735906480037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 17:59:51', 110, 0, '', '2019-05-18 17:59:51');
INSERT INTO `access_log` VALUES (4694, '38.68.15581735910080037', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 17:59:51', 18, 0, '', '2019-05-18 17:59:51');
INSERT INTO `access_log` VALUES (4695, '38.67.15581735910150039', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 17:59:51', 13, 0, '', '2019-05-18 17:59:51');
INSERT INTO `access_log` VALUES (4696, '38.71.15581735910330041', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 17:59:51', 11, 0, '', '2019-05-18 17:59:51');
INSERT INTO `access_log` VALUES (4697, '43.89.15581735955440011', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 17:59:56', 40, 0, '', '2019-05-18 17:59:56');
INSERT INTO `access_log` VALUES (4698, '38.70.15581735989590039', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 17:59:59', 25, 0, '', '2019-05-18 17:59:59');
INSERT INTO `access_log` VALUES (4699, '38.66.15581735995990039', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 18:00:00', 32, 0, '', '2019-05-18 18:00:00');
INSERT INTO `access_log` VALUES (4700, '38.65.15581736002200039', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 18:00:00', 14, 0, '', '2019-05-18 18:00:00');
INSERT INTO `access_log` VALUES (4701, '38.73.15581736007430039', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 18:00:01', 19, 0, '', '2019-05-18 18:00:01');
INSERT INTO `access_log` VALUES (4702, '45.78.15581736021100019', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 18:00:02', 31, 0, '', '2019-05-18 18:00:02');
INSERT INTO `access_log` VALUES (4703, '45.79.15581736150930019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 18:00:15', 6, 0, '', '2019-05-18 18:00:15');
INSERT INTO `access_log` VALUES (4704, '45.72.15581736150940021', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 18:00:15', 46, 0, '', '2019-05-18 18:00:15');
INSERT INTO `access_log` VALUES (4705, '45.73.15581736202710021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 18:00:20', 10, 0, '', '2019-05-18 18:00:20');
INSERT INTO `access_log` VALUES (4706, '45.71.15581736202770021', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.88.114.90', '2019-05-18 18:00:20', 18, 0, '', '2019-05-18 18:00:20');
INSERT INTO `access_log` VALUES (4707, '45.75.15581751179040021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:25:18', 6, 0, '', '2019-05-18 18:25:18');
INSERT INTO `access_log` VALUES (4708, '45.76.15581751179220021', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:25:18', 12, 0, '', '2019-05-18 18:25:18');
INSERT INTO `access_log` VALUES (4709, '44.78.15581751237530027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:25:24', 5, 0, '', '2019-05-18 18:25:24');
INSERT INTO `access_log` VALUES (4710, '44.77.15581751238790025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:25:24', 4, 0, '', '2019-05-18 18:25:24');
INSERT INTO `access_log` VALUES (4711, '44.80.15581751286450027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:25:29', 5, 0, '', '2019-05-18 18:25:29');
INSERT INTO `access_log` VALUES (4712, '44.81.15581751287800027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:25:29', 4, 0, '', '2019-05-18 18:25:29');
INSERT INTO `access_log` VALUES (4713, '45.77.15581751321020021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:25:32', 6, 0, '', '2019-05-18 18:25:32');
INSERT INTO `access_log` VALUES (4714, '45.74.15581751321300021', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:25:32', 15, 0, '', '2019-05-18 18:25:32');
INSERT INTO `access_log` VALUES (4715, '38.72.15581760431440039', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:40:43', 1, 1002001015, '账号未登陆', '2019-05-18 18:40:43');
INSERT INTO `access_log` VALUES (4716, '38.64.15581760431500041', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:40:43', 1, 1002001015, '账号未登陆', '2019-05-18 18:40:43');
INSERT INTO `access_log` VALUES (4717, '38.69.15581760431580039', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:40:43', 1, 1002001015, '账号未登陆', '2019-05-18 18:40:43');
INSERT INTO `access_log` VALUES (4718, '38.71.15581760459730043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:40:46', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-18 18:40:46');
INSERT INTO `access_log` VALUES (4719, '38.68.15581760540070039', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:40:54', 1023, 0, '', '2019-05-18 18:40:55');
INSERT INTO `access_log` VALUES (4720, '38.67.15581760553620041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:40:55', 14, 0, '', '2019-05-18 18:40:55');
INSERT INTO `access_log` VALUES (4721, '38.70.15581760553690041', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:40:55', 13, 0, '', '2019-05-18 18:40:55');
INSERT INTO `access_log` VALUES (4722, '38.66.15581760553760041', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:40:55', 12, 0, '', '2019-05-18 18:40:55');
INSERT INTO `access_log` VALUES (4723, '43.91.15581761080640011', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:41:48', 111, 0, '', '2019-05-18 18:41:48');
INSERT INTO `access_log` VALUES (4724, '43.90.15581761193490011', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:41:59', 37, 0, '', '2019-05-18 18:41:59');
INSERT INTO `access_log` VALUES (4725, '39.57.15581761373710013', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:42:17', 30, 0, '', '2019-05-18 18:42:17');
INSERT INTO `access_log` VALUES (4726, '45.80.15581761465410021', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:42:27', 20, 0, '', '2019-05-18 18:42:27');
INSERT INTO `access_log` VALUES (4727, '45.78.15581761683410021', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:42:48', 55, 0, '', '2019-05-18 18:42:48');
INSERT INTO `access_log` VALUES (4728, '38.65.15581761872040041', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:43:07', 332, 0, '', '2019-05-18 18:43:08');
INSERT INTO `access_log` VALUES (4729, '38.73.15581761911370041', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:43:11', 18, 0, '', '2019-05-18 18:43:11');
INSERT INTO `access_log` VALUES (4730, '38.69.15581761975890041', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:43:18', 21, 0, '', '2019-05-18 18:43:18');
INSERT INTO `access_log` VALUES (4731, '38.72.15581761996640041', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:43:20', 18, 0, '', '2019-05-18 18:43:20');
INSERT INTO `access_log` VALUES (4732, '38.64.15581762058940043', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:43:26', 13, 0, '', '2019-05-18 18:43:26');
INSERT INTO `access_log` VALUES (4733, '38.71.15581762084260045', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:43:28', 18, 0, '', '2019-05-18 18:43:28');
INSERT INTO `access_log` VALUES (4734, '38.68.15581762284080041', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:43:48', 13, 0, '', '2019-05-18 18:43:48');
INSERT INTO `access_log` VALUES (4735, '45.79.15581762691650021', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:44:29', 20, 0, '', '2019-05-18 18:44:29');
INSERT INTO `access_log` VALUES (4736, '45.72.15581762712820023', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:44:31', 17, 0, '', '2019-05-18 18:44:31');
INSERT INTO `access_log` VALUES (4737, '45.73.15581762724720023', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '106.120.206.182', '2019-05-18 18:44:32', 17, 0, '', '2019-05-18 18:44:32');
INSERT INTO `access_log` VALUES (4738, '45.77.15581823579020023', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:25:58', 32, 0, '', '2019-05-18 20:25:58');
INSERT INTO `access_log` VALUES (4739, '45.76.15581823578970023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:25:58', 51, 0, '', '2019-05-18 20:25:58');
INSERT INTO `access_log` VALUES (4740, '44.79.15581823736760025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:14', 17, 0, '', '2019-05-18 20:26:14');
INSERT INTO `access_log` VALUES (4741, '44.85.15581823739210027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:14', 11, 0, '', '2019-05-18 20:26:14');
INSERT INTO `access_log` VALUES (4742, '44.76.15581823754290029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:15', 14, 0, '', '2019-05-18 20:26:15');
INSERT INTO `access_log` VALUES (4743, '44.77.15581823760270027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:16', 16, 0, '', '2019-05-18 20:26:16');
INSERT INTO `access_log` VALUES (4744, '41.81.15581823770830019', 0, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:17', 38, 0, '', '2019-05-18 20:26:17');
INSERT INTO `access_log` VALUES (4745, '44.80.15581823791190029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:19', 11, 0, '', '2019-05-18 20:26:19');
INSERT INTO `access_log` VALUES (4746, '44.81.15581823792550029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:19', 14, 0, '', '2019-05-18 20:26:19');
INSERT INTO `access_log` VALUES (4747, '39.53.15581823805480013', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:21', 15, 1002001012, '访问令牌已过期', '2019-05-18 20:26:21');
INSERT INTO `access_log` VALUES (4748, '39.55.15581823806640013', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=5c54ff49fdf740bfbf24cf0d0a5471d3', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:21', 45, 1002001018, '访问令牌已过期', '2019-05-18 20:26:21');
INSERT INTO `access_log` VALUES (4749, '39.54.15581823883090013', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:28', 87, 0, '', '2019-05-18 20:26:28');
INSERT INTO `access_log` VALUES (4750, '39.48.15581823920950015', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:32', 166, 0, '', '2019-05-18 20:26:32');
INSERT INTO `access_log` VALUES (4751, '39.49.15581823936210015', 1, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:34', 15, 0, '', '2019-05-18 20:26:34');
INSERT INTO `access_log` VALUES (4752, '45.74.15581823949640023', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:35', 14, 0, '', '2019-05-18 20:26:35');
INSERT INTO `access_log` VALUES (4753, '45.80.15581823949640023', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:35', 23, 0, '', '2019-05-18 20:26:35');
INSERT INTO `access_log` VALUES (4754, '41.82.15581823960450017', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:36', 8, 0, '', '2019-05-18 20:26:36');
INSERT INTO `access_log` VALUES (4755, '44.79.15581823960380027', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:36', 17, 0, '', '2019-05-18 20:26:36');
INSERT INTO `access_log` VALUES (4756, '41.85.15581823961840017', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:36', 21, 0, '', '2019-05-18 20:26:36');
INSERT INTO `access_log` VALUES (4757, '45.78.15581823975410023', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:38', 12, 0, '', '2019-05-18 20:26:38');
INSERT INTO `access_log` VALUES (4758, '45.79.15581823975410023', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:38', 21, 0, '', '2019-05-18 20:26:38');
INSERT INTO `access_log` VALUES (4759, '41.83.15581823981420017', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:38', 9, 0, '', '2019-05-18 20:26:38');
INSERT INTO `access_log` VALUES (4760, '44.85.15581823982990029', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:38', 16, 0, '', '2019-05-18 20:26:38');
INSERT INTO `access_log` VALUES (4761, '41.86.15581823984360017', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=38', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:38', 19, 0, '', '2019-05-18 20:26:38');
INSERT INTO `access_log` VALUES (4762, '45.73.15581824041250025', 1, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:44', 10, 0, '', '2019-05-18 20:26:44');
INSERT INTO `access_log` VALUES (4763, '45.72.15581824041250025', 1, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:44', 79, 0, '', '2019-05-18 20:26:44');
INSERT INTO `access_log` VALUES (4764, '44.76.15581824052990031', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:45', 15, 0, '', '2019-05-18 20:26:45');
INSERT INTO `access_log` VALUES (4765, '41.88.15581824052850017', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:45', 34, 0, '', '2019-05-18 20:26:45');
INSERT INTO `access_log` VALUES (4766, '41.81.15581824054780021', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=42', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:45', 488, 0, '', '2019-05-18 20:26:46');
INSERT INTO `access_log` VALUES (4767, '39.51.15581824084080015', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:48', 11, 0, '', '2019-05-18 20:26:48');
INSERT INTO `access_log` VALUES (4768, '41.82.15581824084070019', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=42&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:48', 84, 0, '', '2019-05-18 20:26:48');
INSERT INTO `access_log` VALUES (4769, '39.57.15581824096930015', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:50', 42, 0, '', '2019-05-18 20:26:50');
INSERT INTO `access_log` VALUES (4770, '39.56.15581824102090015', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:50', 13, 0, '', '2019-05-18 20:26:50');
INSERT INTO `access_log` VALUES (4771, '41.85.15581824102300019', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:50', 9, 0, '', '2019-05-18 20:26:50');
INSERT INTO `access_log` VALUES (4772, '44.78.15581824102250031', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:50', 24, 0, '', '2019-05-18 20:26:50');
INSERT INTO `access_log` VALUES (4773, '41.84.15581824102100019', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=42&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:50', 103, 0, '', '2019-05-18 20:26:50');
INSERT INTO `access_log` VALUES (4774, '41.83.15581824104190019', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=42', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:50', 33, 0, '', '2019-05-18 20:26:50');
INSERT INTO `access_log` VALUES (4775, '39.53.15581824123940015', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:52', 10, 0, '', '2019-05-18 20:26:52');
INSERT INTO `access_log` VALUES (4776, '41.87.15581824124420019', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=42&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:52', 86, 0, '', '2019-05-18 20:26:53');
INSERT INTO `access_log` VALUES (4777, '39.55.15581824195190015', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:27:00', 11, 0, '', '2019-05-18 20:27:00');
INSERT INTO `access_log` VALUES (4778, '41.88.15581824143060019', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:54', 5556, 2001001000, '服务端发生异常', '2019-05-18 20:27:00');
INSERT INTO `access_log` VALUES (4779, '41.90.15581824157650021', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:26:56', 4645, 0, '', '2019-05-18 20:27:00');
INSERT INTO `access_log` VALUES (4780, '43.86.15581824205320011', 1, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=223', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:27:01', 13, 0, '', '2019-05-18 20:27:01');
INSERT INTO `access_log` VALUES (4781, '39.54.15581824224480015', 1, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:27:02', 710, 0, '', '2019-05-18 20:27:03');
INSERT INTO `access_log` VALUES (4782, '39.48.15581824232200017', 1, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:27:03', 12, 0, '', '2019-05-18 20:27:03');
INSERT INTO `access_log` VALUES (4783, '41.81.15581824232200023', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=42&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:27:03', 42, 0, '', '2019-05-18 20:27:03');
INSERT INTO `access_log` VALUES (4784, '41.89.15581824247880021', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:27:05', 881, 2001001000, '服务端发生异常', '2019-05-18 20:27:06');
INSERT INTO `access_log` VALUES (4785, '41.82.15581824315060021', 1, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:27:12', 9, 0, '', '2019-05-18 20:27:12');
INSERT INTO `access_log` VALUES (4786, '44.77.15581824315060029', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:27:12', 17, 0, '', '2019-05-18 20:27:12');
INSERT INTO `access_log` VALUES (4787, '41.85.15581824315950021', 1, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=42', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:27:12', 23, 0, '', '2019-05-18 20:27:12');
INSERT INTO `access_log` VALUES (4788, '38.67.15581978367490043', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:43:57', 2, 1002001015, '账号未登陆', '2019-05-19 00:43:57');
INSERT INTO `access_log` VALUES (4789, '38.70.15581978367520043', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:43:57', 1, 1002001015, '账号未登陆', '2019-05-19 00:43:57');
INSERT INTO `access_log` VALUES (4790, '38.66.15581978367550043', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:43:57', 1, 1002001015, '账号未登陆', '2019-05-19 00:43:57');
INSERT INTO `access_log` VALUES (4791, '38.65.15581978412230043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:44:01', 62, 0, '', '2019-05-19 00:44:01');
INSERT INTO `access_log` VALUES (4792, '38.73.15581978415300043', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:44:02', 19, 0, '', '2019-05-19 00:44:02');
INSERT INTO `access_log` VALUES (4793, '38.72.15581978415330043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:44:02', 17, 0, '', '2019-05-19 00:44:02');
INSERT INTO `access_log` VALUES (4794, '38.69.15581978415330043', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:44:02', 19, 0, '', '2019-05-19 00:44:02');
INSERT INTO `access_log` VALUES (4795, '43.87.15581978474830011', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:44:07', 63, 0, '', '2019-05-19 00:44:08');
INSERT INTO `access_log` VALUES (4796, '43.88.15581978510940011', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:44:11', 25, 0, '', '2019-05-19 00:44:11');
INSERT INTO `access_log` VALUES (4797, '44.83.15581978557520031', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:44:16', 33, 0, '', '2019-05-19 00:44:16');
INSERT INTO `access_log` VALUES (4798, '44.81.15581978557520031', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:44:16', 37, 0, '', '2019-05-19 00:44:16');
INSERT INTO `access_log` VALUES (4799, '38.64.15581978614270045', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:44:21', 348, 0, '', '2019-05-19 00:44:22');
INSERT INTO `access_log` VALUES (4800, '38.71.15581978684190047', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:44:28', 25, 0, '', '2019-05-19 00:44:28');
INSERT INTO `access_log` VALUES (4801, '38.68.15581978693870043', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:44:29', 20, 0, '', '2019-05-19 00:44:29');
INSERT INTO `access_log` VALUES (4802, '38.67.15581978710500045', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.63.204.192', '2019-05-19 00:44:31', 12, 0, '', '2019-05-19 00:44:31');
INSERT INTO `access_log` VALUES (4803, '45.71.15582357443680025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:15:44', 16, 0, '', '2019-05-19 11:15:44');
INSERT INTO `access_log` VALUES (4804, '45.75.15582357443680025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:15:44', 35, 0, '', '2019-05-19 11:15:44');
INSERT INTO `access_log` VALUES (4805, '45.77.15582357738750025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.61.219', '2019-05-19 11:16:14', 9, 0, '', '2019-05-19 11:16:14');
INSERT INTO `access_log` VALUES (4806, '45.76.15582357738750025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.61.219', '2019-05-19 11:16:14', 20, 0, '', '2019-05-19 11:16:14');
INSERT INTO `access_log` VALUES (4807, '44.79.15582357757670029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.61.219', '2019-05-19 11:16:16', 5, 0, '', '2019-05-19 11:16:16');
INSERT INTO `access_log` VALUES (4808, '44.82.15582357758770031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.61.219', '2019-05-19 11:16:16', 4, 0, '', '2019-05-19 11:16:16');
INSERT INTO `access_log` VALUES (4809, '44.85.15582357777710031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.61.219', '2019-05-19 11:16:18', 4, 0, '', '2019-05-19 11:16:18');
INSERT INTO `access_log` VALUES (4810, '44.84.15582357824080031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.61.219', '2019-05-19 11:16:22', 5, 0, '', '2019-05-19 11:16:22');
INSERT INTO `access_log` VALUES (4811, '44.76.15582357826780033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.61.219', '2019-05-19 11:16:23', 4, 0, '', '2019-05-19 11:16:23');
INSERT INTO `access_log` VALUES (4812, '45.74.15582357977110025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.61.219', '2019-05-19 11:16:38', 1300, 0, '', '2019-05-19 11:16:39');
INSERT INTO `access_log` VALUES (4813, '45.80.15582357977140025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.61.219', '2019-05-19 11:16:38', 1303, 0, '', '2019-05-19 11:16:39');
INSERT INTO `access_log` VALUES (4814, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=简介&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.61.219', '2019-05-19 11:16:45', 171, 0, '', '2019-05-19 11:16:45');
INSERT INTO `access_log` VALUES (4815, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=简介', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.61.219', '2019-05-19 11:16:45', 50, 0, '', '2019-05-19 11:16:45');
INSERT INTO `access_log` VALUES (4816, '45.79.15582358067480025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.61.219', '2019-05-19 11:16:47', 4, 0, '', '2019-05-19 11:16:47');
INSERT INTO `access_log` VALUES (4817, '45.78.15582358067500025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.61.219', '2019-05-19 11:16:47', 12, 0, '', '2019-05-19 11:16:47');
INSERT INTO `access_log` VALUES (4818, '38.70.15582358848270045', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:18:05', 1, 1002001015, '账号未登陆', '2019-05-19 11:18:05');
INSERT INTO `access_log` VALUES (4819, '38.66.15582358848290045', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:18:05', 1, 1002001015, '账号未登陆', '2019-05-19 11:18:05');
INSERT INTO `access_log` VALUES (4820, '38.65.15582358848430045', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:18:05', 1, 1002001015, '账号未登陆', '2019-05-19 11:18:05');
INSERT INTO `access_log` VALUES (4821, '38.69.15582358869530045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:18:07', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-19 11:18:07');
INSERT INTO `access_log` VALUES (4822, '38.73.15582359109250045', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '111.201.240.49', '2019-05-19 11:18:31', 1, 1002001015, '账号未登陆', '2019-05-19 11:18:31');
INSERT INTO `access_log` VALUES (4823, '38.72.15582359109330045', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '111.201.240.49', '2019-05-19 11:18:31', 1, 1002001015, '账号未登陆', '2019-05-19 11:18:31');
INSERT INTO `access_log` VALUES (4824, '38.64.15582359109450047', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '111.201.240.49', '2019-05-19 11:18:31', 1, 1002001015, '账号未登陆', '2019-05-19 11:18:31');
INSERT INTO `access_log` VALUES (4825, '38.71.15582359140340049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '111.201.240.49', '2019-05-19 11:18:34', 22, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-19 11:18:34');
INSERT INTO `access_log` VALUES (4826, '38.68.15582359150590045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:18:35', 220, 0, '', '2019-05-19 11:18:35');
INSERT INTO `access_log` VALUES (4827, '38.67.15582359156910047', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:18:36', 14, 0, '', '2019-05-19 11:18:36');
INSERT INTO `access_log` VALUES (4828, '38.66.15582359158080047', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:18:36', 14, 0, '', '2019-05-19 11:18:36');
INSERT INTO `access_log` VALUES (4829, '38.70.15582359166020047', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:18:37', 11, 0, '', '2019-05-19 11:18:37');
INSERT INTO `access_log` VALUES (4830, '43.89.15582359320510013', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:18:52', 50, 0, '', '2019-05-19 11:18:52');
INSERT INTO `access_log` VALUES (4831, '45.73.15582359375720027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '111.201.240.49', '2019-05-19 11:18:58', 6, 0, '', '2019-05-19 11:18:58');
INSERT INTO `access_log` VALUES (4832, '45.72.15582359375720027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '111.201.240.49', '2019-05-19 11:18:58', 13, 0, '', '2019-05-19 11:18:58');
INSERT INTO `access_log` VALUES (4833, '44.77.15582359385460031', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:18:59', 15, 0, '', '2019-05-19 11:18:59');
INSERT INTO `access_log` VALUES (4834, '44.78.15582359385600033', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:18:59', 17, 0, '', '2019-05-19 11:18:59');
INSERT INTO `access_log` VALUES (4835, '38.65.15582359431540047', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:19:03', 25, 0, '', '2019-05-19 11:19:03');
INSERT INTO `access_log` VALUES (4836, '38.69.15582359442820047', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:19:04', 14, 0, '', '2019-05-19 11:19:04');
INSERT INTO `access_log` VALUES (4837, '38.64.15582359452990049', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:19:05', 13, 0, '', '2019-05-19 11:19:05');
INSERT INTO `access_log` VALUES (4838, '38.73.15582359465990047', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:19:07', 19, 0, '', '2019-05-19 11:19:07');
INSERT INTO `access_log` VALUES (4839, '43.91.15582359622750013', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:19:22', 24, 0, '', '2019-05-19 11:19:22');
INSERT INTO `access_log` VALUES (4840, '43.90.15582359644810013', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.64.61.219', '2019-05-19 11:19:24', 50, 0, '', '2019-05-19 11:19:25');
INSERT INTO `access_log` VALUES (4841, '45.77.15582421397050027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:20', 43, 0, '', '2019-05-19 13:02:20');
INSERT INTO `access_log` VALUES (4842, '45.76.15582421397070027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:20', 62, 0, '', '2019-05-19 13:02:20');
INSERT INTO `access_log` VALUES (4843, '44.83.15582421432600033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:23', 14, 0, '', '2019-05-19 13:02:23');
INSERT INTO `access_log` VALUES (4844, '44.79.15582421434870031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:23', 15, 0, '', '2019-05-19 13:02:24');
INSERT INTO `access_log` VALUES (4845, '41.86.15582421448770021', 0, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:25', 35, 0, '', '2019-05-19 13:02:25');
INSERT INTO `access_log` VALUES (4846, '44.82.15582421469240033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:27', 11, 0, '', '2019-05-19 13:02:27');
INSERT INTO `access_log` VALUES (4847, '44.85.15582421470740033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:27', 10, 0, '', '2019-05-19 13:02:27');
INSERT INTO `access_log` VALUES (4848, '39.50.15582421480930017', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:28', 13, 1002001011, '访问令牌不存在', '2019-05-19 13:02:28');
INSERT INTO `access_log` VALUES (4849, '39.51.15582421532830017', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:33', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号必须都是数字\n手机号不能为空\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-05-19 13:02:33');
INSERT INTO `access_log` VALUES (4850, '39.52.15582421552830017', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:35', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-05-19 13:02:35');
INSERT INTO `access_log` VALUES (4851, '44.84.15582421580760033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:38', 10, 0, '', '2019-05-19 13:02:38');
INSERT INTO `access_log` VALUES (4852, '44.76.15582421582110035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:38', 12, 0, '', '2019-05-19 13:02:38');
INSERT INTO `access_log` VALUES (4853, '45.74.15582421587590027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:39', 24, 0, '', '2019-05-19 13:02:39');
INSERT INTO `access_log` VALUES (4854, '45.80.15582421587600027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:39', 65, 0, '', '2019-05-19 13:02:39');
INSERT INTO `access_log` VALUES (4855, '44.78.15582421607260035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:41', 10, 0, '', '2019-05-19 13:02:41');
INSERT INTO `access_log` VALUES (4856, '44.77.15582421608670033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:41', 11, 0, '', '2019-05-19 13:02:41');
INSERT INTO `access_log` VALUES (4857, '44.83.15582421617100035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:42', 11, 0, '', '2019-05-19 13:02:42');
INSERT INTO `access_log` VALUES (4858, '44.79.15582421623040033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:42', 14, 0, '', '2019-05-19 13:02:42');
INSERT INTO `access_log` VALUES (4859, '44.82.15582421626290035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:43', 11, 0, '', '2019-05-19 13:02:43');
INSERT INTO `access_log` VALUES (4860, '44.85.15582421629010035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:43', 10, 0, '', '2019-05-19 13:02:43');
INSERT INTO `access_log` VALUES (4861, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:44', 178, 0, '', '2019-05-19 13:02:44');
INSERT INTO `access_log` VALUES (4862, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:45', 66, 0, '', '2019-05-19 13:02:45');
INSERT INTO `access_log` VALUES (4863, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:45', 18, 0, '', '2019-05-19 13:02:45');
INSERT INTO `access_log` VALUES (4864, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:45', 53, 0, '', '2019-05-19 13:02:45');
INSERT INTO `access_log` VALUES (4865, '41.90.15582421693810023', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:49', 15, 0, '', '2019-05-19 13:02:49');
INSERT INTO `access_log` VALUES (4866, '44.76.15582421693820037', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:49', 19, 0, '', '2019-05-19 13:02:49');
INSERT INTO `access_log` VALUES (4867, '41.89.15582421696210023', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=44', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:50', 70, 0, '', '2019-05-19 13:02:50');
INSERT INTO `access_log` VALUES (4868, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:56', 21, 0, '', '2019-05-19 13:02:56');
INSERT INTO `access_log` VALUES (4869, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:57', 29, 0, '', '2019-05-19 13:02:57');
INSERT INTO `access_log` VALUES (4870, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:57', 94, 0, '', '2019-05-19 13:02:57');
INSERT INTO `access_log` VALUES (4871, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:57', 44, 0, '', '2019-05-19 13:02:57');
INSERT INTO `access_log` VALUES (4872, '44.78.15582421776930037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:58', 10, 0, '', '2019-05-19 13:02:58');
INSERT INTO `access_log` VALUES (4873, '44.77.15582421778280035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:02:58', 10, 0, '', '2019-05-19 13:02:58');
INSERT INTO `access_log` VALUES (4874, '44.80.15582421798510037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:03:00', 11, 0, '', '2019-05-19 13:03:00');
INSERT INTO `access_log` VALUES (4875, '44.83.15582421803820037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:03:00', 11, 0, '', '2019-05-19 13:03:00');
INSERT INTO `access_log` VALUES (4876, '44.81.15582421806680037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:03:01', 11, 0, '', '2019-05-19 13:03:01');
INSERT INTO `access_log` VALUES (4877, '44.79.15582421809100035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:03:01', 11, 0, '', '2019-05-19 13:03:01');
INSERT INTO `access_log` VALUES (4878, '45.79.15582421817930027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:03:02', 1065, 0, '', '2019-05-19 13:03:03');
INSERT INTO `access_log` VALUES (4879, '45.78.15582421817860027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:03:02', 1076, 0, '', '2019-05-19 13:03:03');
INSERT INTO `access_log` VALUES (4880, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:14:32', 41, 0, '', '2019-05-19 13:14:32');
INSERT INTO `access_log` VALUES (4881, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:14:32', 47, 0, '', '2019-05-19 13:14:32');
INSERT INTO `access_log` VALUES (4882, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:14:32', 16, 0, '', '2019-05-19 13:14:32');
INSERT INTO `access_log` VALUES (4883, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:14:32', 22, 0, '', '2019-05-19 13:14:32');
INSERT INTO `access_log` VALUES (4884, '45.75.15582428729400029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:14:33', 12, 0, '', '2019-05-19 13:14:33');
INSERT INTO `access_log` VALUES (4885, '45.71.15582428729400029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:14:33', 25, 0, '', '2019-05-19 13:14:33');
INSERT INTO `access_log` VALUES (4886, '44.85.15582428744510037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:14:34', 10, 0, '', '2019-05-19 13:14:34');
INSERT INTO `access_log` VALUES (4887, '44.76.15582428746540039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:14:35', 16, 0, '', '2019-05-19 13:14:35');
INSERT INTO `access_log` VALUES (4888, '41.84.15582428764070021', 0, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:14:36', 12, 0, '', '2019-05-19 13:14:36');
INSERT INTO `access_log` VALUES (4889, '44.78.15582428785420039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:14:39', 14, 0, '', '2019-05-19 13:14:39');
INSERT INTO `access_log` VALUES (4890, '44.77.15582428786920037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:14:39', 16, 0, '', '2019-05-19 13:14:39');
INSERT INTO `access_log` VALUES (4891, '45.76.15582428826710029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:14:43', 79, 0, '', '2019-05-19 13:14:43');
INSERT INTO `access_log` VALUES (4892, '45.77.15582428826710029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:14:43', 141, 0, '', '2019-05-19 13:14:43');
INSERT INTO `access_log` VALUES (4893, '41.83.15582428834860021', 0, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:14:43', 16, 0, '', '2019-05-19 13:14:44');
INSERT INTO `access_log` VALUES (4894, '45.74.15582428847990029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:14:45', 15, 0, '', '2019-05-19 13:14:45');
INSERT INTO `access_log` VALUES (4895, '45.80.15582428848000029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:14:45', 36, 0, '', '2019-05-19 13:14:45');
INSERT INTO `access_log` VALUES (4896, '39.56.15582428856780017', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:14:46', 20, 1002001011, '访问令牌不存在', '2019-05-19 13:14:46');
INSERT INTO `access_log` VALUES (4897, '45.78.15582428890090029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:14:49', 14, 0, '', '2019-05-19 13:14:49');
INSERT INTO `access_log` VALUES (4898, '45.79.15582428890080029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:14:49', 22, 0, '', '2019-05-19 13:14:49');
INSERT INTO `access_log` VALUES (4899, '39.53.15582428932130017', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:14:53', 11, 1002001011, '访问令牌不存在', '2019-05-19 13:14:53');
INSERT INTO `access_log` VALUES (4900, '39.55.15582428965180017', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:14:57', 13, 1002001011, '访问令牌不存在', '2019-05-19 13:14:57');
INSERT INTO `access_log` VALUES (4901, '39.54.15582428999150017', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:15:00', 26, 1002001011, '访问令牌不存在', '2019-05-19 13:15:00');
INSERT INTO `access_log` VALUES (4902, '45.73.15582429018530031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:15:02', 11, 0, '', '2019-05-19 13:15:02');
INSERT INTO `access_log` VALUES (4903, '45.72.15582429018530031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:15:02', 29, 0, '', '2019-05-19 13:15:02');
INSERT INTO `access_log` VALUES (4904, '41.86.15582429034200023', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:15:03', 17, 0, '', '2019-05-19 13:15:03');
INSERT INTO `access_log` VALUES (4905, '44.83.15582429034200039', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:15:03', 20, 0, '', '2019-05-19 13:15:03');
INSERT INTO `access_log` VALUES (4906, '41.90.15582429037420025', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:15:04', 31, 0, '', '2019-05-19 13:15:04');
INSERT INTO `access_log` VALUES (4907, '41.89.15582429069200025', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:15:07', 28, 0, '', '2019-05-19 13:15:07');
INSERT INTO `access_log` VALUES (4908, '41.82.15582429072010023', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:15:07', 19, 0, '', '2019-05-19 13:15:07');
INSERT INTO `access_log` VALUES (4909, '41.85.15582429074980025', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:15:07', 19, 0, '', '2019-05-19 13:15:08');
INSERT INTO `access_log` VALUES (4910, '41.84.15582429077880023', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:15:08', 53, 0, '', '2019-05-19 13:15:08');
INSERT INTO `access_log` VALUES (4911, '41.87.15582429085220025', 0, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:15:09', 8, 1002001011, '访问令牌不存在', '2019-05-19 13:15:09');
INSERT INTO `access_log` VALUES (4912, '39.49.15582429085230019', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-19 13:15:09', 20, 0, '', '2019-05-19 13:15:09');
INSERT INTO `access_log` VALUES (4913, '39.50.15582429207410019', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:15:21', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字\n手机号不能为空', '2019-05-19 13:15:21');
INSERT INTO `access_log` VALUES (4914, '41.86.15582429244530025', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:15:24', 13, 0, '', '2019-05-19 13:15:24');
INSERT INTO `access_log` VALUES (4915, '44.81.15582429244530039', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:15:24', 19, 0, '', '2019-05-19 13:15:24');
INSERT INTO `access_log` VALUES (4916, '41.88.15582429247110025', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:15:25', 18, 0, '', '2019-05-19 13:15:25');
INSERT INTO `access_log` VALUES (4917, '45.75.15582429258760031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:15:26', 22, 0, '', '2019-05-19 13:15:26');
INSERT INTO `access_log` VALUES (4918, '45.71.15582429258760031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-19 13:15:26', 35, 0, '', '2019-05-19 13:15:26');
INSERT INTO `access_log` VALUES (4919, '45.76.15582441736800031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.66.107.104', '2019-05-19 13:36:14', 8, 0, '', '2019-05-19 13:36:14');
INSERT INTO `access_log` VALUES (4920, '45.77.15582441736810031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.66.107.104', '2019-05-19 13:36:14', 24, 0, '', '2019-05-19 13:36:14');
INSERT INTO `access_log` VALUES (4921, '44.79.15582441857130037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '113.66.107.104', '2019-05-19 13:36:26', 182, 0, '', '2019-05-19 13:36:26');
INSERT INTO `access_log` VALUES (4922, '44.82.15582441861190039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '113.66.107.104', '2019-05-19 13:36:26', 3, 0, '', '2019-05-19 13:36:26');
INSERT INTO `access_log` VALUES (4923, '44.85.15582441947520039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '113.66.107.104', '2019-05-19 13:36:35', 4, 0, '', '2019-05-19 13:36:35');
INSERT INTO `access_log` VALUES (4924, '44.84.15582441948710039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '113.66.107.104', '2019-05-19 13:36:35', 3, 0, '', '2019-05-19 13:36:35');
INSERT INTO `access_log` VALUES (4925, '38.70.15583203836290049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:46:24', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 10:46:24');
INSERT INTO `access_log` VALUES (4926, '38.67.15583203949280051', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=ydym1024&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:46:35', 590, 0, '', '2019-05-20 10:46:36');
INSERT INTO `access_log` VALUES (4927, '38.66.15583203957420049', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:46:36', 188, 0, '', '2019-05-20 10:46:36');
INSERT INTO `access_log` VALUES (4928, '38.72.15583203957390047', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:46:36', 517, 0, '', '2019-05-20 10:46:36');
INSERT INTO `access_log` VALUES (4929, '38.68.15583203957330049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:46:36', 522, 0, '', '2019-05-20 10:46:36');
INSERT INTO `access_log` VALUES (4930, '43.92.15583203995910011', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:46:40', 526, 0, '', '2019-05-20 10:46:40');
INSERT INTO `access_log` VALUES (4931, '38.64.15583204070570051', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=ydym1024&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:46:47', 159, 0, '', '2019-05-20 10:46:47');
INSERT INTO `access_log` VALUES (4932, '38.69.15583204073510049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:46:47', 14, 0, '', '2019-05-20 10:46:47');
INSERT INTO `access_log` VALUES (4933, '38.71.15583204073560051', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:46:47', 11, 0, '', '2019-05-20 10:46:47');
INSERT INTO `access_log` VALUES (4934, '38.73.15583204073560049', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:46:47', 12, 0, '', '2019-05-20 10:46:47');
INSERT INTO `access_log` VALUES (4935, '44.78.15583204109140041', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:46:51', 235, 0, '', '2019-05-20 10:46:51');
INSERT INTO `access_log` VALUES (4936, '44.76.15583204109130041', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:46:51', 319, 0, '', '2019-05-20 10:46:51');
INSERT INTO `access_log` VALUES (4937, '43.94.15583204122350009', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:46:52', 24, 0, '', '2019-05-20 10:46:52');
INSERT INTO `access_log` VALUES (4938, '38.65.15583207456500049', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:52:26', 141, 1002001012, '访问令牌已过期', '2019-05-20 10:52:26');
INSERT INTO `access_log` VALUES (4939, '38.67.15583207456560053', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:52:26', 135, 1002001012, '访问令牌已过期', '2019-05-20 10:52:26');
INSERT INTO `access_log` VALUES (4940, '38.70.15583207456500051', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:52:26', 141, 1002001012, '访问令牌已过期', '2019-05-20 10:52:26');
INSERT INTO `access_log` VALUES (4941, '38.66.15583207488010051', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:52:29', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 10:52:29');
INSERT INTO `access_log` VALUES (4942, '38.68.15583207568350051', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:52:37', 278, 0, '', '2019-05-20 10:52:37');
INSERT INTO `access_log` VALUES (4943, '38.64.15583207574660053', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:52:37', 12, 0, '', '2019-05-20 10:52:37');
INSERT INTO `access_log` VALUES (4944, '38.72.15583207574660049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:52:37', 12, 0, '', '2019-05-20 10:52:37');
INSERT INTO `access_log` VALUES (4945, '38.71.15583207574770053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:52:37', 11, 0, '', '2019-05-20 10:52:37');
INSERT INTO `access_log` VALUES (4946, '43.86.15583207610620013', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:52:41', 24, 0, '', '2019-05-20 10:52:41');
INSERT INTO `access_log` VALUES (4947, '43.87.15583207682120013', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:52:48', 106, 0, '', '2019-05-20 10:52:48');
INSERT INTO `access_log` VALUES (4948, '44.77.15583207713250039', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:52:51', 22, 0, '', '2019-05-20 10:52:51');
INSERT INTO `access_log` VALUES (4949, '44.80.15583207713320041', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:52:51', 15, 0, '', '2019-05-20 10:52:51');
INSERT INTO `access_log` VALUES (4950, '45.74.15583207909170031', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:53:11', 101, 0, '', '2019-05-20 10:53:11');
INSERT INTO `access_log` VALUES (4951, '45.80.15583208002660031', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:53:20', 170, 0, '', '2019-05-20 10:53:20');
INSERT INTO `access_log` VALUES (4952, '45.72.15583208185640033', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:53:39', 71, 0, '', '2019-05-20 10:53:39');
INSERT INTO `access_log` VALUES (4953, '45.73.15583208185670033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:53:39', 85, 0, '', '2019-05-20 10:53:39');
INSERT INTO `access_log` VALUES (4954, '44.81.15583208205400041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:53:41', 301, 0, '', '2019-05-20 10:53:41');
INSERT INTO `access_log` VALUES (4955, '44.82.15583208209790041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:53:41', 9, 0, '', '2019-05-20 10:53:41');
INSERT INTO `access_log` VALUES (4956, '45.71.15583208213640033', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:53:41', 13, 0, '', '2019-05-20 10:53:41');
INSERT INTO `access_log` VALUES (4957, '45.75.15583208213650033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:53:41', 20, 0, '', '2019-05-20 10:53:41');
INSERT INTO `access_log` VALUES (4958, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=kafka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:53:43', 74, 0, '', '2019-05-20 10:53:43');
INSERT INTO `access_log` VALUES (4959, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kafka', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:53:44', 204, 0, '', '2019-05-20 10:53:44');
INSERT INTO `access_log` VALUES (4960, '45.76.15583208278160033', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:53:48', 14, 0, '', '2019-05-20 10:53:48');
INSERT INTO `access_log` VALUES (4961, '45.77.15583208278180033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:53:48', 25, 0, '', '2019-05-20 10:53:48');
INSERT INTO `access_log` VALUES (4962, '39.52.15583208290300019', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:53:49', 261, 1002001012, '访问令牌已过期', '2019-05-20 10:53:49');
INSERT INTO `access_log` VALUES (4963, '39.57.15583208293940019', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=c0039cec6aba456d8422c64052ae681e', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 10:53:49', 17, 1002001018, '访问令牌已过期', '2019-05-20 10:53:49');
INSERT INTO `access_log` VALUES (4964, '45.74.15583209106590033', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:55:11', 132, 0, '', '2019-05-20 10:55:11');
INSERT INTO `access_log` VALUES (4965, '45.80.15583209149560033', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:55:15', 41, 0, '', '2019-05-20 10:55:15');
INSERT INTO `access_log` VALUES (4966, '45.79.15583209192140033', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:55:19', 12, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-20 10:55:19');
INSERT INTO `access_log` VALUES (4967, '38.69.15583209228970051', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:55:23', 98, 0, '', '2019-05-20 10:55:23');
INSERT INTO `access_log` VALUES (4968, '38.73.15583209245610051', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:55:25', 19, 0, '', '2019-05-20 10:55:25');
INSERT INTO `access_log` VALUES (4969, '38.65.15583209257050051', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '175.0.129.1', '2019-05-20 10:55:26', 24, 0, '', '2019-05-20 10:55:26');
INSERT INTO `access_log` VALUES (4970, '45.78.15583221225700033', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-20 11:15:23', 6, 0, '', '2019-05-20 11:15:23');
INSERT INTO `access_log` VALUES (4971, '45.73.15583221225700035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-20 11:15:23', 44, 0, '', '2019-05-20 11:15:23');
INSERT INTO `access_log` VALUES (4972, '44.85.15583221294990041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-20 11:15:29', 5, 0, '', '2019-05-20 11:15:30');
INSERT INTO `access_log` VALUES (4973, '44.84.15583221296120041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-20 11:15:30', 4, 0, '', '2019-05-20 11:15:30');
INSERT INTO `access_log` VALUES (4974, '44.78.15583221322770043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-20 11:15:32', 5, 0, '', '2019-05-20 11:15:32');
INSERT INTO `access_log` VALUES (4975, '44.76.15583221331530043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-20 11:15:33', 3, 0, '', '2019-05-20 11:15:33');
INSERT INTO `access_log` VALUES (4976, '44.80.15583221376220043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-20 11:15:38', 4, 0, '', '2019-05-20 11:15:38');
INSERT INTO `access_log` VALUES (4977, '44.77.15583221377330041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-20 11:15:38', 4, 0, '', '2019-05-20 11:15:38');
INSERT INTO `access_log` VALUES (4978, '45.72.15583221378250035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-20 11:15:38', 5, 0, '', '2019-05-20 11:15:38');
INSERT INTO `access_log` VALUES (4979, '45.71.15583221378260035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-20 11:15:38', 10, 0, '', '2019-05-20 11:15:38');
INSERT INTO `access_log` VALUES (4980, '45.75.15583227601520035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '115.233.213.102', '2019-05-20 11:26:00', 6, 0, '', '2019-05-20 11:26:00');
INSERT INTO `access_log` VALUES (4981, '45.76.15583227601520035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '115.233.213.102', '2019-05-20 11:26:00', 13, 0, '', '2019-05-20 11:26:00');
INSERT INTO `access_log` VALUES (4982, '44.83.15583227621700043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '115.233.213.102', '2019-05-20 11:26:02', 4, 0, '', '2019-05-20 11:26:02');
INSERT INTO `access_log` VALUES (4983, '44.81.15583227622460043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '115.233.213.102', '2019-05-20 11:26:02', 4, 0, '', '2019-05-20 11:26:02');
INSERT INTO `access_log` VALUES (4984, '44.79.15583227648880041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '115.233.213.102', '2019-05-20 11:26:05', 6, 0, '', '2019-05-20 11:26:05');
INSERT INTO `access_log` VALUES (4985, '44.82.15583227659940043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '115.233.213.102', '2019-05-20 11:26:06', 4, 0, '', '2019-05-20 11:26:06');
INSERT INTO `access_log` VALUES (4986, '44.85.15583227669100043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '115.233.213.102', '2019-05-20 11:26:07', 4, 0, '', '2019-05-20 11:26:07');
INSERT INTO `access_log` VALUES (4987, '44.84.15583227685750043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '115.233.213.102', '2019-05-20 11:26:09', 4, 0, '', '2019-05-20 11:26:09');
INSERT INTO `access_log` VALUES (4988, '45.77.15583227694760035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '115.233.213.102', '2019-05-20 11:26:09', 7, 0, '', '2019-05-20 11:26:09');
INSERT INTO `access_log` VALUES (4989, '45.74.15583227694770035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '115.233.213.102', '2019-05-20 11:26:09', 14, 0, '', '2019-05-20 11:26:09');
INSERT INTO `access_log` VALUES (4990, '45.80.15583227747950035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '115.233.213.102', '2019-05-20 11:26:15', 5, 0, '', '2019-05-20 11:26:15');
INSERT INTO `access_log` VALUES (4991, '45.79.15583227747960035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '115.233.213.102', '2019-05-20 11:26:15', 17, 0, '', '2019-05-20 11:26:15');
INSERT INTO `access_log` VALUES (4992, '38.67.15583235351830055', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '14.146.75.108', '2019-05-20 11:38:55', 1, 1002001015, '账号未登陆', '2019-05-20 11:38:55');
INSERT INTO `access_log` VALUES (4993, '38.70.15583235351900053', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '14.146.75.108', '2019-05-20 11:38:55', 1, 1002001015, '账号未登陆', '2019-05-20 11:38:55');
INSERT INTO `access_log` VALUES (4994, '38.66.15583235351960053', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '14.146.75.108', '2019-05-20 11:38:55', 1, 1002001015, '账号未登陆', '2019-05-20 11:38:55');
INSERT INTO `access_log` VALUES (4995, '38.68.15583235401170053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '14.146.75.108', '2019-05-20 11:39:00', 40, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 11:39:00');
INSERT INTO `access_log` VALUES (4996, '38.64.15583235949200055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '14.146.75.108', '2019-05-20 11:39:55', 96, 0, '', '2019-05-20 11:39:55');
INSERT INTO `access_log` VALUES (4997, '38.71.15583235952480055', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '14.146.75.108', '2019-05-20 11:39:55', 16, 0, '', '2019-05-20 11:39:55');
INSERT INTO `access_log` VALUES (4998, '38.72.15583235952560051', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '14.146.75.108', '2019-05-20 11:39:55', 12, 0, '', '2019-05-20 11:39:55');
INSERT INTO `access_log` VALUES (4999, '38.69.15583235952570053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '14.146.75.108', '2019-05-20 11:39:55', 12, 0, '', '2019-05-20 11:39:55');
INSERT INTO `access_log` VALUES (5000, '43.89.15583236040940015', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '14.146.75.108', '2019-05-20 11:40:04', 38, 0, '', '2019-05-20 11:40:04');
INSERT INTO `access_log` VALUES (5001, '44.78.15583236133300045', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '14.146.75.108', '2019-05-20 11:40:13', 25, 0, '', '2019-05-20 11:40:13');
INSERT INTO `access_log` VALUES (5002, '44.76.15583236133350045', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '14.146.75.108', '2019-05-20 11:40:13', 15, 0, '', '2019-05-20 11:40:13');
INSERT INTO `access_log` VALUES (5003, '39.56.15583236203680019', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '14.146.75.108', '2019-05-20 11:40:20', 140, 0, '', '2019-05-20 11:40:21');
INSERT INTO `access_log` VALUES (5004, '45.78.15583236292930035', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '14.146.75.108', '2019-05-20 11:40:29', 17, 0, '', '2019-05-20 11:40:29');
INSERT INTO `access_log` VALUES (5005, '39.53.15583236381190019', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '14.146.75.108', '2019-05-20 11:40:38', 48, 0, '', '2019-05-20 11:40:38');
INSERT INTO `access_log` VALUES (5006, '45.73.15583240219010037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '27.38.248.153', '2019-05-20 11:47:02', 6, 0, '', '2019-05-20 11:47:02');
INSERT INTO `access_log` VALUES (5007, '45.72.15583240219020037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '27.38.248.153', '2019-05-20 11:47:02', 23, 0, '', '2019-05-20 11:47:02');
INSERT INTO `access_log` VALUES (5008, '45.71.15583240288430037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '27.38.248.153', '2019-05-20 11:47:09', 5, 0, '', '2019-05-20 11:47:09');
INSERT INTO `access_log` VALUES (5009, '45.75.15583240288430037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '27.38.248.153', '2019-05-20 11:47:09', 13, 0, '', '2019-05-20 11:47:09');
INSERT INTO `access_log` VALUES (5010, '44.80.15583240305380045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '27.38.248.153', '2019-05-20 11:47:11', 5, 0, '', '2019-05-20 11:47:11');
INSERT INTO `access_log` VALUES (5011, '44.77.15583240306610043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '27.38.248.153', '2019-05-20 11:47:11', 4, 0, '', '2019-05-20 11:47:11');
INSERT INTO `access_log` VALUES (5012, '44.83.15583240336450045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '27.38.248.153', '2019-05-20 11:47:14', 15, 0, '', '2019-05-20 11:47:14');
INSERT INTO `access_log` VALUES (5013, '45.71.15583424637270045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.231.93.122', '2019-05-20 16:54:24', 256, 0, '', '2019-05-20 16:54:24');
INSERT INTO `access_log` VALUES (5014, '45.74.15583424637280045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.231.93.122', '2019-05-20 16:54:24', 367, 0, '', '2019-05-20 16:54:24');
INSERT INTO `access_log` VALUES (5015, '44.84.15583424683950055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.231.93.122', '2019-05-20 16:54:28', 44, 0, '', '2019-05-20 16:54:28');
INSERT INTO `access_log` VALUES (5016, '44.79.15583424687610055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.231.93.122', '2019-05-20 16:54:29', 4, 0, '', '2019-05-20 16:54:29');
INSERT INTO `access_log` VALUES (5017, '44.83.15583424728860055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.231.93.122', '2019-05-20 16:54:33', 667, 0, '', '2019-05-20 16:54:34');
INSERT INTO `access_log` VALUES (5018, '44.82.15583424737010057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.231.93.122', '2019-05-20 16:54:34', 3, 0, '', '2019-05-20 16:54:34');
INSERT INTO `access_log` VALUES (5019, '44.85.15583424773670057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.231.93.122', '2019-05-20 16:54:37', 4, 0, '', '2019-05-20 16:54:37');
INSERT INTO `access_log` VALUES (5020, '44.77.15583424775250057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.231.93.122', '2019-05-20 16:54:38', 4, 0, '', '2019-05-20 16:54:38');
INSERT INTO `access_log` VALUES (5021, '45.79.15583424836060045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.231.93.122', '2019-05-20 16:54:44', 6, 0, '', '2019-05-20 16:54:44');
INSERT INTO `access_log` VALUES (5022, '45.77.15583424836060045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.231.93.122', '2019-05-20 16:54:44', 11, 0, '', '2019-05-20 16:54:44');
INSERT INTO `access_log` VALUES (5023, '44.78.15583424917880059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.231.93.122', '2019-05-20 16:54:52', 4, 0, '', '2019-05-20 16:54:52');
INSERT INTO `access_log` VALUES (5024, '44.76.15583424922710059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.231.93.122', '2019-05-20 16:54:52', 3, 0, '', '2019-05-20 16:54:52');
INSERT INTO `access_log` VALUES (5025, '45.78.15583424938300045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.231.93.122', '2019-05-20 16:54:54', 5, 0, '', '2019-05-20 16:54:54');
INSERT INTO `access_log` VALUES (5026, '45.80.15583424938300045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.231.93.122', '2019-05-20 16:54:54', 12, 0, '', '2019-05-20 16:54:54');
INSERT INTO `access_log` VALUES (5027, '49.64.15583441259830007', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '42.120.74.100', '2019-05-20 17:22:06', 54, 1002001015, '账号未登陆', '2019-05-20 17:22:06');
INSERT INTO `access_log` VALUES (5028, '49.62.15583441259360005', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '42.120.74.100', '2019-05-20 17:22:06', 89, 1002001015, '账号未登陆', '2019-05-20 17:22:06');
INSERT INTO `access_log` VALUES (5029, '49.63.15583441259780007', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '42.120.74.100', '2019-05-20 17:22:06', 56, 1002001015, '账号未登陆', '2019-05-20 17:22:06');
INSERT INTO `access_log` VALUES (5030, '50.51.15583459973880025', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:53:17', 115, 1002001015, '账号未登陆', '2019-05-20 17:53:18');
INSERT INTO `access_log` VALUES (5031, '50.53.15583459973880025', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:53:17', 115, 1002001015, '账号未登陆', '2019-05-20 17:53:18');
INSERT INTO `access_log` VALUES (5032, '50.52.15583459973960023', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:53:17', 115, 1002001015, '账号未登陆', '2019-05-20 17:53:18');
INSERT INTO `access_log` VALUES (5033, '50.54.15583460000930027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:53:20', 106, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 17:53:20');
INSERT INTO `access_log` VALUES (5034, '50.46.15583460076490025', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 17:53:28', 210, 1002001012, '访问令牌已过期', '2019-05-20 17:53:28');
INSERT INTO `access_log` VALUES (5035, '50.48.15583460076510027', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 17:53:28', 209, 1002001012, '访问令牌已过期', '2019-05-20 17:53:28');
INSERT INTO `access_log` VALUES (5036, '50.47.15583460076490029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 17:53:28', 210, 1002001012, '访问令牌已过期', '2019-05-20 17:53:28');
INSERT INTO `access_log` VALUES (5037, '50.49.15583460082600025', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:53:28', 544, 0, '', '2019-05-20 17:53:29');
INSERT INTO `access_log` VALUES (5038, '50.50.15583460090850029', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:53:29', 338, 0, '', '2019-05-20 17:53:29');
INSERT INTO `access_log` VALUES (5039, '50.53.15583460090860027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:53:29', 359, 0, '', '2019-05-20 17:53:29');
INSERT INTO `access_log` VALUES (5040, '50.52.15583460090910025', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:53:29', 375, 0, '', '2019-05-20 17:53:29');
INSERT INTO `access_log` VALUES (5041, '50.51.15583460096620027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 17:53:30', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 17:53:30');
INSERT INTO `access_log` VALUES (5042, '43.95.15583460155980023', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:53:36', 912, 0, '', '2019-05-20 17:53:37');
INSERT INTO `access_log` VALUES (5043, '43.93.15583460126350021', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:53:33', 3138, 0, '', '2019-05-20 17:53:37');
INSERT INTO `access_log` VALUES (5044, '50.54.15583460170480029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=ydym1024&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 17:53:37', 236, 0, '', '2019-05-20 17:53:37');
INSERT INTO `access_log` VALUES (5045, '50.55.15583460176300027', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 17:53:38', 38, 0, '', '2019-05-20 17:53:38');
INSERT INTO `access_log` VALUES (5046, '50.47.15583460176380031', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 17:53:38', 38, 0, '', '2019-05-20 17:53:38');
INSERT INTO `access_log` VALUES (5047, '50.46.15583460176340027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 17:53:38', 44, 0, '', '2019-05-20 17:53:38');
INSERT INTO `access_log` VALUES (5048, '50.49.15583460196550027', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 17:53:40', 242, 0, '', '2019-05-20 17:53:40');
INSERT INTO `access_log` VALUES (5049, '50.50.15583460208280031', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 17:53:41', 93, 0, '', '2019-05-20 17:53:41');
INSERT INTO `access_log` VALUES (5050, '50.52.15583460216160027', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 17:53:42', 45, 0, '', '2019-05-20 17:53:42');
INSERT INTO `access_log` VALUES (5051, '50.53.15583460220510029', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-20 17:53:42', 40, 0, '', '2019-05-20 17:53:42');
INSERT INTO `access_log` VALUES (5052, '45.72.15583460787410047', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:54:39', 62, 0, '', '2019-05-20 17:54:39');
INSERT INTO `access_log` VALUES (5053, '50.50.15583461333510033', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:55:33', 826, 0, '', '2019-05-20 17:55:34');
INSERT INTO `access_log` VALUES (5054, '45.73.15583461376570047', 27, 2, 'promotion-application', '/promotion-api/admins/banner/add', 'title=哈哈哈&url=http://127.0.0.1&sort=-1&picUrl=http://static.shop.iocoder.cn/50cc9d59-f101-4275-8cc0-8717df46eb4c', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:55:38', 47, 1002002009, NULL, '2019-05-20 17:55:38');
INSERT INTO `access_log` VALUES (5055, '45.75.15583461438890047', 27, 2, 'promotion-application', '/promotion-api/admins/banner/add', 'title=哈哈哈&url=http://127.0.0.1&sort=0&picUrl=http://static.shop.iocoder.cn/50cc9d59-f101-4275-8cc0-8717df46eb4c', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:55:44', 19, 1002002009, NULL, '2019-05-20 17:55:44');
INSERT INTO `access_log` VALUES (5056, '45.76.15583461541360047', 27, 2, 'promotion-application', '/promotion-api/admins/banner/add', 'title=哈哈哈&url=http://127.0.0.1&sort=0&picUrl=http://static.shop.iocoder.cn/50cc9d59-f101-4275-8cc0-8717df46eb4c', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.24.36.228', '2019-05-20 17:55:54', 43, 1002002009, NULL, '2019-05-20 17:55:54');
INSERT INTO `access_log` VALUES (5057, '50.52.15583464227200033', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.235.207.212', '2019-05-20 18:00:23', 1, 1002001015, '账号未登陆', '2019-05-20 18:00:23');
INSERT INTO `access_log` VALUES (5058, '50.53.15583464227230035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.235.207.212', '2019-05-20 18:00:23', 0, 1002001015, '账号未登陆', '2019-05-20 18:00:23');
INSERT INTO `access_log` VALUES (5059, '50.50.15583464227200037', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.235.207.212', '2019-05-20 18:00:23', 15, 1002001015, '账号未登陆', '2019-05-20 18:00:23');
INSERT INTO `access_log` VALUES (5060, '50.54.15583464255860037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.235.207.212', '2019-05-20 18:00:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 18:00:26');
INSERT INTO `access_log` VALUES (5061, '50.46.15583464314730035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.235.207.212', '2019-05-20 18:00:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 18:00:31');
INSERT INTO `access_log` VALUES (5062, '50.48.15583464550350037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.235.207.212', '2019-05-20 18:00:55', 108, 0, '', '2019-05-20 18:00:55');
INSERT INTO `access_log` VALUES (5063, '50.53.15583464553430037', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.235.207.212', '2019-05-20 18:00:55', 24, 0, '', '2019-05-20 18:00:55');
INSERT INTO `access_log` VALUES (5064, '50.49.15583464553420035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.235.207.212', '2019-05-20 18:00:55', 30, 0, '', '2019-05-20 18:00:55');
INSERT INTO `access_log` VALUES (5065, '50.50.15583464554690039', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.235.207.212', '2019-05-20 18:00:55', 21, 0, '', '2019-05-20 18:00:55');
INSERT INTO `access_log` VALUES (5066, '43.86.15583464638150023', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.235.207.212', '2019-05-20 18:01:04', 55, 0, '', '2019-05-20 18:01:04');
INSERT INTO `access_log` VALUES (5067, '43.87.15583464679090023', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.235.207.212', '2019-05-20 18:01:08', 34, 0, '', '2019-05-20 18:01:08');
INSERT INTO `access_log` VALUES (5068, '44.84.15583464703550059', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.235.207.212', '2019-05-20 18:01:10', 153, 0, '', '2019-05-20 18:01:11');
INSERT INTO `access_log` VALUES (5069, '44.82.15583464703550059', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.235.207.212', '2019-05-20 18:01:10', 173, 0, '', '2019-05-20 18:01:11');
INSERT INTO `access_log` VALUES (5070, '50.48.15583466994960041', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.24.36.228', '2019-05-20 18:04:59', 2, 1002001015, '账号未登陆', '2019-05-20 18:05:00');
INSERT INTO `access_log` VALUES (5071, '50.49.15583466995030039', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.24.36.228', '2019-05-20 18:05:00', 1, 1002001015, '账号未登陆', '2019-05-20 18:05:00');
INSERT INTO `access_log` VALUES (5072, '50.53.15583466994990041', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.24.36.228', '2019-05-20 18:05:00', 1, 1002001015, '账号未登陆', '2019-05-20 18:05:00');
INSERT INTO `access_log` VALUES (5073, '50.50.15583467060910043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.24.36.228', '2019-05-20 18:05:06', 80, 0, '', '2019-05-20 18:05:06');
INSERT INTO `access_log` VALUES (5074, '50.51.15583467063970041', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.24.36.228', '2019-05-20 18:05:06', 26, 0, '', '2019-05-20 18:05:06');
INSERT INTO `access_log` VALUES (5075, '50.52.15583467063920039', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.24.36.228', '2019-05-20 18:05:06', 32, 0, '', '2019-05-20 18:05:06');
INSERT INTO `access_log` VALUES (5076, '50.54.15583467063980043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.24.36.228', '2019-05-20 18:05:06', 35, 0, '', '2019-05-20 18:05:06');
INSERT INTO `access_log` VALUES (5077, '43.88.15583467106480023', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.24.36.228', '2019-05-20 18:05:11', 597, 0, '', '2019-05-20 18:05:11');
INSERT INTO `access_log` VALUES (5078, '50.52.15583478493510055', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:24:09', 1, 1002001015, '账号未登陆', '2019-05-20 18:24:09');
INSERT INTO `access_log` VALUES (5079, '50.54.15583478493510059', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:24:09', 1, 1002001015, '账号未登陆', '2019-05-20 18:24:09');
INSERT INTO `access_log` VALUES (5080, '50.51.15583478493400057', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:24:09', 2, 1002001015, '账号未登陆', '2019-05-20 18:24:09');
INSERT INTO `access_log` VALUES (5081, '50.46.15583478495440057', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:24:10', 2, 1002001015, '账号未登陆', '2019-05-20 18:24:10');
INSERT INTO `access_log` VALUES (5082, '50.55.15583478495440057', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:24:10', 2, 1002001015, '账号未登陆', '2019-05-20 18:24:10');
INSERT INTO `access_log` VALUES (5083, '50.47.15583478495580061', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:24:10', 1, 1002001015, '账号未登陆', '2019-05-20 18:24:10');
INSERT INTO `access_log` VALUES (5084, '50.53.15583478543430059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:24:14', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 18:24:14');
INSERT INTO `access_log` VALUES (5085, '50.48.15583478591560059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:24:19', 148, 0, '', '2019-05-20 18:24:19');
INSERT INTO `access_log` VALUES (5086, '50.49.15583478599780057', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:24:20', 32, 0, '', '2019-05-20 18:24:20');
INSERT INTO `access_log` VALUES (5087, '50.50.15583478599800061', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:24:20', 36, 0, '', '2019-05-20 18:24:20');
INSERT INTO `access_log` VALUES (5088, '50.54.15583478599950061', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:24:20', 25, 0, '', '2019-05-20 18:24:20');
INSERT INTO `access_log` VALUES (5089, '53.81.15583478717190003', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:24:32', 754, 0, '', '2019-05-20 18:24:33');
INSERT INTO `access_log` VALUES (5090, '54.74.15583478867860003', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:24:47', 901, 0, '', '2019-05-20 18:24:48');
INSERT INTO `access_log` VALUES (5091, '54.76.15583479021190003', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=40', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:25:02', 79, 0, '', '2019-05-20 18:25:02');
INSERT INTO `access_log` VALUES (5092, '50.47.15583479068360063', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:25:07', 40, 0, '', '2019-05-20 18:25:07');
INSERT INTO `access_log` VALUES (5093, '50.48.15583479351120061', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:25:35', 20, 0, '', '2019-05-20 18:25:35');
INSERT INTO `access_log` VALUES (5094, '50.54.15583479384370063', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:25:38', 22, 0, '', '2019-05-20 18:25:38');
INSERT INTO `access_log` VALUES (5095, '50.50.15583479497990063', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:25:50', 86, 0, '', '2019-05-20 18:25:50');
INSERT INTO `access_log` VALUES (5096, '44.79.15583479727110067', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:26:13', 1212, 0, '', '2019-05-20 18:26:14');
INSERT INTO `access_log` VALUES (5097, '44.83.15583479727110065', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:26:13', 2041, 0, '', '2019-05-20 18:26:15');
INSERT INTO `access_log` VALUES (5098, '44.77.15583479900250067', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:26:30', 108, 0, '', '2019-05-20 18:26:30');
INSERT INTO `access_log` VALUES (5099, '44.78.15583479900170069', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:26:30', 194, 0, '', '2019-05-20 18:26:30');
INSERT INTO `access_log` VALUES (5100, '44.76.15583479899990069', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:26:30', 346, 0, '', '2019-05-20 18:26:30');
INSERT INTO `access_log` VALUES (5101, '50.53.15583480143740063', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.98.18.24', '2019-05-20 18:26:54', 28, 0, '', '2019-05-20 18:26:54');
INSERT INTO `access_log` VALUES (5102, '54.71.15583501977940035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:03:18', 49, 0, '', '2019-05-20 19:03:18');
INSERT INTO `access_log` VALUES (5103, '54.80.15583501977900033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:03:18', 746, 0, '', '2019-05-20 19:03:19');
INSERT INTO `access_log` VALUES (5104, '44.77.15583502221660097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:03:42', 70, 0, '', '2019-05-20 19:03:42');
INSERT INTO `access_log` VALUES (5105, '44.81.15583502226040101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:03:43', 3, 0, '', '2019-05-20 19:03:43');
INSERT INTO `access_log` VALUES (5106, '44.80.15583502278350099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:03:48', 4, 0, '', '2019-05-20 19:03:48');
INSERT INTO `access_log` VALUES (5107, '44.84.15583502291930099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:03:49', 3, 0, '', '2019-05-20 19:03:49');
INSERT INTO `access_log` VALUES (5108, '44.79.15583502315790099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:03:52', 3, 0, '', '2019-05-20 19:03:52');
INSERT INTO `access_log` VALUES (5109, '44.83.15583502316520097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:03:52', 3, 0, '', '2019-05-20 19:03:52');
INSERT INTO `access_log` VALUES (5110, '44.85.15583502318350099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:03:52', 3, 0, '', '2019-05-20 19:03:52');
INSERT INTO `access_log` VALUES (5111, '44.78.15583502319170101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:03:52', 3, 0, '', '2019-05-20 19:03:52');
INSERT INTO `access_log` VALUES (5112, '44.76.15583502328310101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:03:53', 3, 0, '', '2019-05-20 19:03:53');
INSERT INTO `access_log` VALUES (5113, '44.77.15583502349950099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:03:55', 4, 0, '', '2019-05-20 19:03:55');
INSERT INTO `access_log` VALUES (5114, '48.49.15583502530860095', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:04:13', 4606, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号必须都是数字\n手机验证码不能为空', '2019-05-20 19:04:18');
INSERT INTO `access_log` VALUES (5115, '48.50.15583502517070095', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:04:12', 5385, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空\n手机号必须都是数字\n手机号不能为空\n账号长度为 11 位', '2019-05-20 19:04:18');
INSERT INTO `access_log` VALUES (5116, '44.84.15583502729700101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:04:33', 4, 0, '', '2019-05-20 19:04:33');
INSERT INTO `access_log` VALUES (5117, '44.82.15583502731140101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:04:33', 3, 0, '', '2019-05-20 19:04:33');
INSERT INTO `access_log` VALUES (5118, '54.79.15583502798560035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:04:40', 10, 0, '', '2019-05-20 19:04:40');
INSERT INTO `access_log` VALUES (5119, '54.78.15583502798380035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:04:40', 253, 0, '', '2019-05-20 19:04:40');
INSERT INTO `access_log` VALUES (5120, '44.83.15583502832360099', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:04:43', 37, 0, '', '2019-05-20 19:04:43');
INSERT INTO `access_log` VALUES (5121, '54.80.15583502951560035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:04:55', 714, 0, '', '2019-05-20 19:04:56');
INSERT INTO `access_log` VALUES (5122, '54.72.15583502951590037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:04:55', 690, 0, '', '2019-05-20 19:04:56');
INSERT INTO `access_log` VALUES (5123, '44.78.15583502977490103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:04:58', 4, 0, '', '2019-05-20 19:04:58');
INSERT INTO `access_log` VALUES (5124, '44.76.15583502979450103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:04:58', 61, 0, '', '2019-05-20 19:04:58');
INSERT INTO `access_log` VALUES (5125, '54.73.15583502991860037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:04:59', 11, 0, '', '2019-05-20 19:04:59');
INSERT INTO `access_log` VALUES (5126, '54.74.15583502991870037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.3 Mobile Safari/537.36', '122.96.41.21', '2019-05-20 19:04:59', 56, 0, '', '2019-05-20 19:04:59');
INSERT INTO `access_log` VALUES (5127, '50.49.15583535377450135', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:58:58', 276, 1002001015, '账号未登陆', '2019-05-20 19:58:58');
INSERT INTO `access_log` VALUES (5128, '50.48.15583535377400137', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:58:58', 276, 1002001015, '账号未登陆', '2019-05-20 19:58:58');
INSERT INTO `access_log` VALUES (5129, '50.54.15583535377450139', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:58:58', 276, 1002001015, '账号未登陆', '2019-05-20 19:58:58');
INSERT INTO `access_log` VALUES (5130, '50.50.15583535477250139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:59:08', 676, 0, '', '2019-05-20 19:59:08');
INSERT INTO `access_log` VALUES (5131, '50.51.15583535487170135', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:59:09', 232, 0, '', '2019-05-20 19:59:09');
INSERT INTO `access_log` VALUES (5132, '50.55.15583535487280137', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:59:09', 246, 0, '', '2019-05-20 19:59:09');
INSERT INTO `access_log` VALUES (5133, '50.52.15583535487250135', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:59:09', 273, 0, '', '2019-05-20 19:59:09');
INSERT INTO `access_log` VALUES (5134, '53.81.15583535543740079', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:59:14', 209, 0, '', '2019-05-20 19:59:15');
INSERT INTO `access_log` VALUES (5135, '55.77.15583535602880015', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:59:20', 2473, 0, '', '2019-05-20 19:59:23');
INSERT INTO `access_log` VALUES (5136, '55.82.15583535602880011', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:59:20', 2473, 0, '', '2019-05-20 19:59:23');
INSERT INTO `access_log` VALUES (5137, '54.73.15583535649070081', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:59:25', 82, 0, '', '2019-05-20 19:59:25');
INSERT INTO `access_log` VALUES (5138, '50.53.15583535666040139', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:59:27', 353, 0, '', '2019-05-20 19:59:27');
INSERT INTO `access_log` VALUES (5139, '50.48.15583535683850139', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:59:28', 157, 0, '', '2019-05-20 19:59:29');
INSERT INTO `access_log` VALUES (5140, '50.49.15583535715000137', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:59:32', 76, 0, '', '2019-05-20 19:59:32');
INSERT INTO `access_log` VALUES (5141, '48.52.15583535624090139', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:59:22', 9157, 0, '', '2019-05-20 19:59:32');
INSERT INTO `access_log` VALUES (5142, '53.85.15583535930430079', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 19:59:53', 210, 0, '', '2019-05-20 19:59:53');
INSERT INTO `access_log` VALUES (5143, '53.86.15583536050070079', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=200', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 20:00:05', 28, 0, '', '2019-05-20 20:00:05');
INSERT INTO `access_log` VALUES (5144, '53.89.15583536075640079', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 20:00:08', 73, 0, '', '2019-05-20 20:00:08');
INSERT INTO `access_log` VALUES (5145, '53.88.15583536100100079', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=101', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 20:00:10', 88, 0, '', '2019-05-20 20:00:10');
INSERT INTO `access_log` VALUES (5146, '53.80.15583536122810081', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=9999', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-20 20:00:12', 77, 0, '', '2019-05-20 20:00:12');
INSERT INTO `access_log` VALUES (5147, '50.49.15583536809000139', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:01:21', 0, 1002001015, '账号未登陆', '2019-05-20 20:01:21');
INSERT INTO `access_log` VALUES (5148, '50.48.15583536808980141', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:01:21', 1, 1002001015, '账号未登陆', '2019-05-20 20:01:21');
INSERT INTO `access_log` VALUES (5149, '50.53.15583536808980141', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:01:21', 1, 1002001015, '账号未登陆', '2019-05-20 20:01:21');
INSERT INTO `access_log` VALUES (5150, '50.50.15583536905510143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:01:31', 178, 0, '', '2019-05-20 20:01:31');
INSERT INTO `access_log` VALUES (5151, '50.51.15583536911290139', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:01:31', 16, 0, '', '2019-05-20 20:01:31');
INSERT INTO `access_log` VALUES (5152, '50.52.15583536911350139', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:01:31', 17, 0, '', '2019-05-20 20:01:31');
INSERT INTO `access_log` VALUES (5153, '50.55.15583536911410141', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:01:31', 16, 0, '', '2019-05-20 20:01:31');
INSERT INTO `access_log` VALUES (5154, '50.47.15583536952610145', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:01:35', 85, 0, '', '2019-05-20 20:01:35');
INSERT INTO `access_log` VALUES (5155, '50.46.15583536959140139', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:01:36', 74, 0, '', '2019-05-20 20:01:36');
INSERT INTO `access_log` VALUES (5156, '54.73.15583537063210083', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:01:46', 752, 0, '', '2019-05-20 20:01:47');
INSERT INTO `access_log` VALUES (5157, '48.52.15583537103060141', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:01:50', 270, 0, '', '2019-05-20 20:01:51');
INSERT INTO `access_log` VALUES (5158, '55.81.15583537168960015', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:01:57', 150, 0, '', '2019-05-20 20:01:57');
INSERT INTO `access_log` VALUES (5159, '55.80.15583537168920013', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:01:57', 347, 0, '', '2019-05-20 20:01:57');
INSERT INTO `access_log` VALUES (5160, '50.49.15583537209990141', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:02:01', 74, 0, '', '2019-05-20 20:02:01');
INSERT INTO `access_log` VALUES (5161, '50.54.15583537217330145', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.150', '2019-05-20 20:02:02', 21, 0, '', '2019-05-20 20:02:02');
INSERT INTO `access_log` VALUES (5162, '50.47.15583578862500201', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.246.232', '2019-05-20 21:11:26', 679, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 21:11:27');
INSERT INTO `access_log` VALUES (5163, '50.51.15583578953520197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.246.232', '2019-05-20 21:11:35', 70, 0, '', '2019-05-20 21:11:35');
INSERT INTO `access_log` VALUES (5164, '50.48.15583578958710201', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.246.232', '2019-05-20 21:11:36', 34, 0, '', '2019-05-20 21:11:36');
INSERT INTO `access_log` VALUES (5165, '50.46.15583578958720197', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.246.232', '2019-05-20 21:11:36', 36, 0, '', '2019-05-20 21:11:36');
INSERT INTO `access_log` VALUES (5166, '50.53.15583578958950199', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.246.232', '2019-05-20 21:11:36', 113, 0, '', '2019-05-20 21:11:36');
INSERT INTO `access_log` VALUES (5167, '53.87.15583579009920137', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.246.232', '2019-05-20 21:11:41', 1637, 0, '', '2019-05-20 21:11:43');
INSERT INTO `access_log` VALUES (5168, '53.88.15583579127650137', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.246.232', '2019-05-20 21:11:53', 276, 0, '', '2019-05-20 21:11:53');
INSERT INTO `access_log` VALUES (5169, '53.80.15583579186550139', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.246.232', '2019-05-20 21:11:59', 270, 0, '', '2019-05-20 21:11:59');
INSERT INTO `access_log` VALUES (5170, '55.76.15583579240480073', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.246.232', '2019-05-20 21:12:04', 119, 0, '', '2019-05-20 21:12:04');
INSERT INTO `access_log` VALUES (5171, '55.78.15583579240460075', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.246.232', '2019-05-20 21:12:04', 100, 0, '', '2019-05-20 21:12:04');
INSERT INTO `access_log` VALUES (5172, '50.47.15583591727750219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:32:53', 55, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 21:32:53');
INSERT INTO `access_log` VALUES (5173, '50.48.15583591768740219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:32:57', 167, 0, '', '2019-05-20 21:32:57');
INSERT INTO `access_log` VALUES (5174, '50.49.15583591776410215', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:32:58', 26, 0, '', '2019-05-20 21:32:58');
INSERT INTO `access_log` VALUES (5175, '50.46.15583591776280215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:32:58', 40, 0, '', '2019-05-20 21:32:58');
INSERT INTO `access_log` VALUES (5176, '50.53.15583591776280217', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:32:58', 38, 0, '', '2019-05-20 21:32:58');
INSERT INTO `access_log` VALUES (5177, '53.85.15583591853520155', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:33:05', 66, 0, '', '2019-05-20 21:33:05');
INSERT INTO `access_log` VALUES (5178, '53.89.15583592156860155', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:33:36', 79, 0, '', '2019-05-20 21:33:36');
INSERT INTO `access_log` VALUES (5179, '55.76.15583592197060091', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:33:40', 105, 0, '', '2019-05-20 21:33:40');
INSERT INTO `access_log` VALUES (5180, '55.83.15583592197050093', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:33:40', 141, 0, '', '2019-05-20 21:33:40');
INSERT INTO `access_log` VALUES (5181, '50.51.15583592571710217', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:34:17', 228, 0, '', '2019-05-20 21:34:17');
INSERT INTO `access_log` VALUES (5182, '50.53.15583592732450219', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:34:33', 52, 0, '', '2019-05-20 21:34:33');
INSERT INTO `access_log` VALUES (5183, '50.49.15583592752360217', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:34:35', 522, 0, '', '2019-05-20 21:34:36');
INSERT INTO `access_log` VALUES (5184, '50.46.15583592778210217', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:34:38', 48, 0, '', '2019-05-20 21:34:38');
INSERT INTO `access_log` VALUES (5185, '50.52.15583592789690219', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:34:39', 115, 0, '', '2019-05-20 21:34:39');
INSERT INTO `access_log` VALUES (5186, '50.55.15583592819950221', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:34:42', 42, 0, '', '2019-05-20 21:34:42');
INSERT INTO `access_log` VALUES (5187, '50.46.15583593979220221', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10&name=系统管理员&offset=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:36:38', 30, 1002001015, '账号未登陆', '2019-05-20 21:36:38');
INSERT INTO `access_log` VALUES (5188, '50.52.15583600241110229', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.17.233.149', '2019-05-20 21:47:04', 1, 1002001015, '账号未登陆', '2019-05-20 21:47:04');
INSERT INTO `access_log` VALUES (5189, '50.47.15583600241380235', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.17.233.149', '2019-05-20 21:47:04', 1, 1002001015, '账号未登陆', '2019-05-20 21:47:04');
INSERT INTO `access_log` VALUES (5190, '50.54.15583600241380235', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.17.233.149', '2019-05-20 21:47:04', 1, 1002001015, '账号未登陆', '2019-05-20 21:47:04');
INSERT INTO `access_log` VALUES (5191, '50.48.15583600264260233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.17.233.149', '2019-05-20 21:47:06', 49, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 21:47:06');
INSERT INTO `access_log` VALUES (5192, '50.46.15583600367550231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.17.233.149', '2019-05-20 21:47:17', 533, 0, '', '2019-05-20 21:47:17');
INSERT INTO `access_log` VALUES (5193, '50.53.15583600376440233', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.17.233.149', '2019-05-20 21:47:18', 36, 0, '', '2019-05-20 21:47:18');
INSERT INTO `access_log` VALUES (5194, '50.50.15583600376510235', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.17.233.149', '2019-05-20 21:47:18', 16, 0, '', '2019-05-20 21:47:18');
INSERT INTO `access_log` VALUES (5195, '50.51.15583600376480229', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.17.233.149', '2019-05-20 21:47:18', 72, 0, '', '2019-05-20 21:47:18');
INSERT INTO `access_log` VALUES (5196, '53.85.15583600417690167', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.17.233.149', '2019-05-20 21:47:22', 140, 0, '', '2019-05-20 21:47:22');
INSERT INTO `access_log` VALUES (5197, '55.85.15583600441380101', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.17.233.149', '2019-05-20 21:47:24', 65, 0, '', '2019-05-20 21:47:24');
INSERT INTO `access_log` VALUES (5198, '55.84.15583600441380101', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.17.233.149', '2019-05-20 21:47:24', 72, 0, '', '2019-05-20 21:47:24');
INSERT INTO `access_log` VALUES (5199, '48.52.15583600459020227', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.17.233.149', '2019-05-20 21:47:26', 224, 0, '', '2019-05-20 21:47:26');
INSERT INTO `access_log` VALUES (5200, '54.77.15583600473420167', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.17.233.149', '2019-05-20 21:47:27', 1138, 0, '', '2019-05-20 21:47:29');
INSERT INTO `access_log` VALUES (5201, '50.51.15583601127440231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:48:33', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n登陆账号不能为空\n密码不能为空', '2019-05-20 21:48:33');
INSERT INTO `access_log` VALUES (5202, '50.50.15583601173530237', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=admin&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:48:37', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 21:48:37');
INSERT INTO `access_log` VALUES (5203, '50.52.15583601220080231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=admin&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:48:42', 35, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 21:48:42');
INSERT INTO `access_log` VALUES (5204, '50.47.15583601306490239', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:48:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码不能为空\n登陆账号不能为空', '2019-05-20 21:48:51');
INSERT INTO `access_log` VALUES (5205, '50.49.15583601612340235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n登陆账号不能为空\n密码不能为空', '2019-05-20 21:49:21');
INSERT INTO `access_log` VALUES (5206, '50.51.15583601711920233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:31', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码不能为空\n登陆账号不能为空', '2019-05-20 21:49:31');
INSERT INTO `access_log` VALUES (5207, '50.50.15583601723760239', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:32', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n登陆账号不能为空\n密码不能为空', '2019-05-20 21:49:32');
INSERT INTO `access_log` VALUES (5208, '50.55.15583601730240235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:33', 37, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码不能为空\n登陆账号不能为空', '2019-05-20 21:49:33');
INSERT INTO `access_log` VALUES (5209, '50.52.15583601737300233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:34', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码不能为空\n登陆账号不能为空', '2019-05-20 21:49:34');
INSERT INTO `access_log` VALUES (5210, '50.47.15583601742640241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:34', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n登陆账号不能为空\n密码不能为空', '2019-05-20 21:49:34');
INSERT INTO `access_log` VALUES (5211, '50.54.15583601746570241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:35', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码不能为空\n登陆账号不能为空', '2019-05-20 21:49:35');
INSERT INTO `access_log` VALUES (5212, '50.48.15583601752800239', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:35', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n登陆账号不能为空\n密码不能为空', '2019-05-20 21:49:35');
INSERT INTO `access_log` VALUES (5213, '50.49.15583601758240237', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:36', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码不能为空\n登陆账号不能为空', '2019-05-20 21:49:36');
INSERT INTO `access_log` VALUES (5214, '50.46.15583601765370237', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:37', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n登陆账号不能为空\n密码不能为空', '2019-05-20 21:49:37');
INSERT INTO `access_log` VALUES (5215, '50.53.15583601771770239', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:37', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n登陆账号不能为空\n密码不能为空', '2019-05-20 21:49:37');
INSERT INTO `access_log` VALUES (5216, '50.50.15583601807640241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=admin&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:41', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 21:49:41');
INSERT INTO `access_log` VALUES (5217, '50.55.15583601843520237', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=admin&username=admin2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:44', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 21:49:44');
INSERT INTO `access_log` VALUES (5218, '50.52.15583601853050235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=admin&username=admin2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:45', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 21:49:45');
INSERT INTO `access_log` VALUES (5219, '50.47.15583601881330243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=admin&username=admin22', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:49:48', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 21:49:48');
INSERT INTO `access_log` VALUES (5220, '50.55.15583602187280239', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:50:19', 3, 0, '', '2019-05-20 21:50:19');
INSERT INTO `access_log` VALUES (5221, '50.47.15583602295700245', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-20 21:50:30', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n登陆账号不能为空\n密码不能为空', '2019-05-20 21:50:30');
INSERT INTO `access_log` VALUES (5222, '59.71.15583624123090017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '111.14.211.69', '2019-05-20 22:26:53', 5680, 2001001000, '服务端发生异常', '2019-05-20 22:26:58');
INSERT INTO `access_log` VALUES (5223, '59.80.15583624123090015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '111.14.211.69', '2019-05-20 22:26:53', 5571, 0, '', '2019-05-20 22:26:58');
INSERT INTO `access_log` VALUES (5224, '59.75.15583624722630017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '183.192.164.85', '2019-05-20 22:27:52', 8, 0, '', '2019-05-20 22:27:52');
INSERT INTO `access_log` VALUES (5225, '59.77.15583624722630017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '183.192.164.85', '2019-05-20 22:27:52', 152, 2001001000, '服务端发生异常', '2019-05-20 22:27:52');
INSERT INTO `access_log` VALUES (5226, '59.72.15583646347450047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:03:55', 27, 0, '', '2019-05-20 23:03:55');
INSERT INTO `access_log` VALUES (5227, '59.73.15583646347490047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:03:55', 490, 2001001000, '服务端发生异常', '2019-05-20 23:03:55');
INSERT INTO `access_log` VALUES (5228, '60.77.15583646385090035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:03:59', 837, 0, '', '2019-05-20 23:04:00');
INSERT INTO `access_log` VALUES (5229, '60.78.15583646401630035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:04:00', 12, 0, '', '2019-05-20 23:04:00');
INSERT INTO `access_log` VALUES (5230, '50.51.15583646561000295', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:04:17', 1814, 1002001015, '账号未登陆', '2019-05-20 23:04:19');
INSERT INTO `access_log` VALUES (5231, '50.55.15583646561000299', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:04:17', 1814, 1002001015, '账号未登陆', '2019-05-20 23:04:19');
INSERT INTO `access_log` VALUES (5232, '50.50.15583646561000303', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:04:17', 1814, 1002001015, '账号未登陆', '2019-05-20 23:04:19');
INSERT INTO `access_log` VALUES (5233, '50.54.15583646881290303', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:04:48', 1444, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-20 23:04:50');
INSERT INTO `access_log` VALUES (5234, '50.49.15583647022480301', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:05:02', 1725, 0, '', '2019-05-20 23:05:04');
INSERT INTO `access_log` VALUES (5235, '50.46.15583647043370301', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:05:04', 1267, 0, '', '2019-05-20 23:05:06');
INSERT INTO `access_log` VALUES (5236, '50.53.15583647043370303', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:05:04', 1300, 0, '', '2019-05-20 23:05:06');
INSERT INTO `access_log` VALUES (5237, '50.55.15583647055500301', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:05:06', 996, 0, '', '2019-05-20 23:05:07');
INSERT INTO `access_log` VALUES (5238, '62.83.15583647149310001', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:05:15', 1843, 0, '', '2019-05-20 23:05:17');
INSERT INTO `access_log` VALUES (5239, '62.85.15583647244430001', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:05:24', 142, 0, '', '2019-05-20 23:05:25');
INSERT INTO `access_log` VALUES (5240, '62.86.15583647274830001', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:05:27', 213, 0, '', '2019-05-20 23:05:28');
INSERT INTO `access_log` VALUES (5241, '59.80.15583647335550047', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:05:34', 764, 0, '', '2019-05-20 23:05:34');
INSERT INTO `access_log` VALUES (5242, '59.72.15583647399120049', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:05:40', 262, 2001001000, '服务端发生异常', '2019-05-20 23:05:40');
INSERT INTO `access_log` VALUES (5243, '50.47.15583647439370307', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:05:44', 782, 0, '', '2019-05-20 23:05:45');
INSERT INTO `access_log` VALUES (5244, '50.54.15583647451890305', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:05:45', 98, 0, '', '2019-05-20 23:05:45');
INSERT INTO `access_log` VALUES (5245, '50.48.15583647472180303', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:05:47', 86, 0, '', '2019-05-20 23:05:47');
INSERT INTO `access_log` VALUES (5246, '50.49.15583647486480303', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:05:49', 163, 0, '', '2019-05-20 23:05:49');
INSERT INTO `access_log` VALUES (5247, '50.48.15583648632860305', 0, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'enumValue=测试1&value=测试2&displayName=测试&sort=1&memo=1', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:07:43', 217, 1002002007, '没有该操作权限', '2019-05-20 23:07:44');
INSERT INTO `access_log` VALUES (5248, '50.49.15583648645390305', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:07:45', 70, 0, '', '2019-05-20 23:07:45');
INSERT INTO `access_log` VALUES (5249, '50.53.15583656284720317', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:20:28', 171, 0, '', '2019-05-20 23:20:29');
INSERT INTO `access_log` VALUES (5250, '50.55.15583656284790315', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:20:28', 187, 0, '', '2019-05-20 23:20:29');
INSERT INTO `access_log` VALUES (5251, '50.50.15583656284790319', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:20:29', 138, 0, '', '2019-05-20 23:20:29');
INSERT INTO `access_log` VALUES (5252, '63.83.15583656316830007', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:20:32', 833, 0, '', '2019-05-20 23:20:33');
INSERT INTO `access_log` VALUES (5253, '63.84.15583656316850007', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:20:32', 833, 0, '', '2019-05-20 23:20:33');
INSERT INTO `access_log` VALUES (5254, '59.73.15583656427260061', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:20:43', 2035, 0, '', '2019-05-20 23:20:45');
INSERT INTO `access_log` VALUES (5255, '48.50.15583656389840301', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:20:39', 8006, 0, '', '2019-05-20 23:20:47');
INSERT INTO `access_log` VALUES (5256, '59.77.15583656907250061', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:31', 109, 0, '', '2019-05-20 23:21:31');
INSERT INTO `access_log` VALUES (5257, '59.78.15583656910410061', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:31', 82, 0, '', '2019-05-20 23:21:31');
INSERT INTO `access_log` VALUES (5258, '59.79.15583656914340061', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:31', 52, 0, '', '2019-05-20 23:21:31');
INSERT INTO `access_log` VALUES (5259, '59.71.15583656915950063', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:32', 98, 0, '', '2019-05-20 23:21:32');
INSERT INTO `access_log` VALUES (5260, '59.80.15583656918110061', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:32', 71, 0, '', '2019-05-20 23:21:32');
INSERT INTO `access_log` VALUES (5261, '59.72.15583656920090063', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:32', 65, 0, '', '2019-05-20 23:21:32');
INSERT INTO `access_log` VALUES (5262, '59.73.15583656921990063', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:32', 44, 0, '', '2019-05-20 23:21:32');
INSERT INTO `access_log` VALUES (5263, '59.74.15583656923670063', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:32', 48, 0, '', '2019-05-20 23:21:32');
INSERT INTO `access_log` VALUES (5264, '59.76.15583656925660063', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:33', 85, 0, '', '2019-05-20 23:21:33');
INSERT INTO `access_log` VALUES (5265, '59.75.15583656927840063', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:33', 43, 0, '', '2019-05-20 23:21:33');
INSERT INTO `access_log` VALUES (5266, '59.77.15583656929330063', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:33', 83, 0, '', '2019-05-20 23:21:33');
INSERT INTO `access_log` VALUES (5267, '59.78.15583656931330063', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:33', 112, 0, '', '2019-05-20 23:21:33');
INSERT INTO `access_log` VALUES (5268, '59.79.15583656933850063', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:33', 149, 0, '', '2019-05-20 23:21:34');
INSERT INTO `access_log` VALUES (5269, '59.71.15583656936510065', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:34', 63, 0, '', '2019-05-20 23:21:34');
INSERT INTO `access_log` VALUES (5270, '59.80.15583656938520063', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:34', 20, 0, '', '2019-05-20 23:21:34');
INSERT INTO `access_log` VALUES (5271, '59.72.15583656940180065', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:34', 20, 0, '', '2019-05-20 23:21:34');
INSERT INTO `access_log` VALUES (5272, '59.74.15583656941420065', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:34', 69, 0, '', '2019-05-20 23:21:34');
INSERT INTO `access_log` VALUES (5273, '59.76.15583656943180065', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:34', 43, 0, '', '2019-05-20 23:21:34');
INSERT INTO `access_log` VALUES (5274, '59.75.15583656947800065', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:35', 18, 0, '', '2019-05-20 23:21:35');
INSERT INTO `access_log` VALUES (5275, '59.77.15583656949180065', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:21:35', 49, 0, '', '2019-05-20 23:21:35');
INSERT INTO `access_log` VALUES (5276, '59.79.15583657207830065', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:01', 64, 0, '', '2019-05-20 23:22:01');
INSERT INTO `access_log` VALUES (5277, '59.71.15583657209540067', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:01', 44, 0, '', '2019-05-20 23:22:01');
INSERT INTO `access_log` VALUES (5278, '59.80.15583657211000065', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:01', 19, 0, '', '2019-05-20 23:22:01');
INSERT INTO `access_log` VALUES (5279, '59.73.15583657213570067', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:01', 28, 0, '', '2019-05-20 23:22:01');
INSERT INTO `access_log` VALUES (5280, '59.72.15583657215360067', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:02', 17, 0, '', '2019-05-20 23:22:02');
INSERT INTO `access_log` VALUES (5281, '59.74.15583657216680067', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:02', 45, 0, '', '2019-05-20 23:22:02');
INSERT INTO `access_log` VALUES (5282, '59.76.15583657218190067', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:02', 21, 0, '', '2019-05-20 23:22:02');
INSERT INTO `access_log` VALUES (5283, '59.75.15583657219690067', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:02', 53, 0, '', '2019-05-20 23:22:02');
INSERT INTO `access_log` VALUES (5284, '59.77.15583657221960067', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:02', 34, 0, '', '2019-05-20 23:22:02');
INSERT INTO `access_log` VALUES (5285, '59.78.15583657223770067', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:02', 21, 0, '', '2019-05-20 23:22:02');
INSERT INTO `access_log` VALUES (5286, '59.79.15583657225060067', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:03', 23, 0, '', '2019-05-20 23:22:03');
INSERT INTO `access_log` VALUES (5287, '59.71.15583657226250069', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:03', 17, 0, '', '2019-05-20 23:22:03');
INSERT INTO `access_log` VALUES (5288, '59.80.15583657228950067', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:03', 41, 0, '', '2019-05-20 23:22:03');
INSERT INTO `access_log` VALUES (5289, '59.73.15583657230850069', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:03', 26, 0, '', '2019-05-20 23:22:03');
INSERT INTO `access_log` VALUES (5290, '59.72.15583657232100069', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:03', 17, 0, '', '2019-05-20 23:22:03');
INSERT INTO `access_log` VALUES (5291, '59.74.15583657233530069', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:03', 17, 0, '', '2019-05-20 23:22:03');
INSERT INTO `access_log` VALUES (5292, '59.76.15583657235140069', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:04', 24, 0, '', '2019-05-20 23:22:04');
INSERT INTO `access_log` VALUES (5293, '59.75.15583657236770069', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:04', 17, 0, '', '2019-05-20 23:22:04');
INSERT INTO `access_log` VALUES (5294, '59.77.15583657237920069', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:04', 32, 0, '', '2019-05-20 23:22:04');
INSERT INTO `access_log` VALUES (5295, '59.78.15583657239450069', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:04', 20, 0, '', '2019-05-20 23:22:04');
INSERT INTO `access_log` VALUES (5296, '59.71.15583657241090071', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:04', 18, 0, '', '2019-05-20 23:22:04');
INSERT INTO `access_log` VALUES (5297, '59.80.15583657242540069', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:04', 24, 0, '', '2019-05-20 23:22:04');
INSERT INTO `access_log` VALUES (5298, '59.73.15583657243770071', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:04', 19, 0, '', '2019-05-20 23:22:04');
INSERT INTO `access_log` VALUES (5299, '59.72.15583657245280071', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:05', 20, 0, '', '2019-05-20 23:22:05');
INSERT INTO `access_log` VALUES (5300, '59.74.15583657247460071', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:05', 18, 0, '', '2019-05-20 23:22:05');
INSERT INTO `access_log` VALUES (5301, '59.76.15583657249250071', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:05', 20, 0, '', '2019-05-20 23:22:05');
INSERT INTO `access_log` VALUES (5302, '59.75.15583657250750071', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:05', 24, 0, '', '2019-05-20 23:22:05');
INSERT INTO `access_log` VALUES (5303, '59.77.15583657252230071', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:05', 19, 0, '', '2019-05-20 23:22:05');
INSERT INTO `access_log` VALUES (5304, '59.78.15583657253880071', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:22:05', 19, 0, '', '2019-05-20 23:22:05');
INSERT INTO `access_log` VALUES (5305, '59.76.15583918044660415', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.63.204.74', '2019-05-21 06:36:44', 568, 0, '', '2019-05-21 06:36:45');
INSERT INTO `access_log` VALUES (5306, '59.75.15583918044780417', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.63.204.74', '2019-05-21 06:36:45', 1271, 2001001000, '服务端发生异常', '2019-05-21 06:36:46');
INSERT INTO `access_log` VALUES (5307, '63.84.15583918099350355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.63.204.74', '2019-05-21 06:36:50', 281, 0, '', '2019-05-21 06:36:50');
INSERT INTO `access_log` VALUES (5308, '63.85.15583918105080353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.63.204.74', '2019-05-21 06:36:51', 7, 0, '', '2019-05-21 06:36:51');
INSERT INTO `access_log` VALUES (5309, '48.55.15583918218670647', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.63.204.74', '2019-05-21 06:37:02', 565, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机号必须都是数字\n账号长度为 11 位\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-05-21 06:37:03');
INSERT INTO `access_log` VALUES (5310, '50.48.15584029205870811', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.170.219.228', '2019-05-21 09:42:01', 1, 1002001015, '账号未登陆', '2019-05-21 09:42:01');
INSERT INTO `access_log` VALUES (5311, '50.49.15584029206070811', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.170.219.228', '2019-05-21 09:42:01', 0, 1002001015, '账号未登陆', '2019-05-21 09:42:01');
INSERT INTO `access_log` VALUES (5312, '50.46.15584029206070811', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.170.219.228', '2019-05-21 09:42:01', 1, 1002001015, '账号未登陆', '2019-05-21 09:42:01');
INSERT INTO `access_log` VALUES (5313, '50.53.15584029228970813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.170.219.228', '2019-05-21 09:42:03', 40, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 09:42:03');
INSERT INTO `access_log` VALUES (5314, '62.87.15584031207230511', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-21 09:45:21', 381, 1002001012, '访问令牌已过期', '2019-05-21 09:45:21');
INSERT INTO `access_log` VALUES (5315, '50.47.15584031298750819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma &type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-21 09:45:30', 382, 0, '', '2019-05-21 09:45:30');
INSERT INTO `access_log` VALUES (5316, '50.54.15584031310200815', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-21 09:45:31', 23, 0, '', '2019-05-21 09:45:31');
INSERT INTO `access_log` VALUES (5317, '50.48.15584031310320815', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-21 09:45:31', 20, 0, '', '2019-05-21 09:45:31');
INSERT INTO `access_log` VALUES (5318, '50.49.15584031310620815', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-21 09:45:31', 14, 0, '', '2019-05-21 09:45:31');
INSERT INTO `access_log` VALUES (5319, '50.46.15584031322220815', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.104.107', '2019-05-21 09:45:32', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:32');
INSERT INTO `access_log` VALUES (5320, '50.53.15584031326880817', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.104.107', '2019-05-21 09:45:33', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:33');
INSERT INTO `access_log` VALUES (5321, '50.55.15584031331730815', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.104.107', '2019-05-21 09:45:33', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:33');
INSERT INTO `access_log` VALUES (5322, '50.50.15584031335770819', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.36.215', '2019-05-21 09:45:34', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:34');
INSERT INTO `access_log` VALUES (5323, '50.51.15584031337450811', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.104.107', '2019-05-21 09:45:34', 2, 1002001015, '账号未登陆', '2019-05-21 09:45:34');
INSERT INTO `access_log` VALUES (5324, '50.52.15584031341040811', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.36.215', '2019-05-21 09:45:34', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:34');
INSERT INTO `access_log` VALUES (5325, '50.47.15584031342370821', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.104.107', '2019-05-21 09:45:34', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:34');
INSERT INTO `access_log` VALUES (5326, '50.54.15584031344180817', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.36.215', '2019-05-21 09:45:34', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:34');
INSERT INTO `access_log` VALUES (5327, '50.49.15584031348900817', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.19.93', '2019-05-21 09:45:35', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:35');
INSERT INTO `access_log` VALUES (5328, '50.46.15584031395370817', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.36.215', '2019-05-21 09:45:40', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:40');
INSERT INTO `access_log` VALUES (5329, '50.53.15584031399570819', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Java/1.8.0_181', '106.75.104.107', '2019-05-21 09:45:40', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:40');
INSERT INTO `access_log` VALUES (5330, '50.55.15584031414050817', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.36.215', '2019-05-21 09:45:41', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:41');
INSERT INTO `access_log` VALUES (5331, '62.81.15584031430150513', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-05-21 09:45:43', 43, 1002001015, '账号未登陆', '2019-05-21 09:45:43');
INSERT INTO `access_log` VALUES (5332, '62.89.15584031341300511', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-21 09:45:34', 8973, 0, '', '2019-05-21 09:45:43');
INSERT INTO `access_log` VALUES (5333, '63.82.15584031363100503', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-21 09:45:36', 6796, 0, '', '2019-05-21 09:45:43');
INSERT INTO `access_log` VALUES (5334, '63.83.15584031363100507', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-21 09:45:36', 6791, 0, '', '2019-05-21 09:45:43');
INSERT INTO `access_log` VALUES (5335, '48.54.15584031391140797', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-21 09:45:39', 3999, 0, '', '2019-05-21 09:45:43');
INSERT INTO `access_log` VALUES (5336, '50.50.15584031434930821', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Java/1.8.0_181', '117.50.36.215', '2019-05-21 09:45:43', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:43');
INSERT INTO `access_log` VALUES (5337, '62.82.15584031435220511', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-05-21 09:45:44', 2, 1002001015, '账号未登陆', '2019-05-21 09:45:44');
INSERT INTO `access_log` VALUES (5338, '63.84.15584031439310507', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.97.43', '2019-05-21 09:45:44', 75, 1002001015, '账号未登陆', '2019-05-21 09:45:44');
INSERT INTO `access_log` VALUES (5339, '50.51.15584031435280813', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-21 09:45:44', 513, 0, '', '2019-05-21 09:45:44');
INSERT INTO `access_log` VALUES (5340, '48.48.15584031440960799', 0, 2, 'user-application', '/user-api/admins/user/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.25.223', '2019-05-21 09:45:44', 302, 1002001015, '账号未登陆', '2019-05-21 09:45:44');
INSERT INTO `access_log` VALUES (5341, '62.83.15584031446190513', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-05-21 09:45:45', 2, 1002001015, '账号未登陆', '2019-05-21 09:45:45');
INSERT INTO `access_log` VALUES (5342, '63.85.15584031446240505', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.97.43', '2019-05-21 09:45:45', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:45');
INSERT INTO `access_log` VALUES (5343, '63.76.15584031446200509', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-05-21 09:45:45', 4, 1002001015, '账号未登陆', '2019-05-21 09:45:45');
INSERT INTO `access_log` VALUES (5344, '59.72.15584031408790567', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-21 09:45:41', 3879, 2001001000, '服务端发生异常', '2019-05-21 09:45:45');
INSERT INTO `access_log` VALUES (5345, '48.53.15584031448610797', 0, 2, 'user-application', '/user-api/admins/user/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.25.223', '2019-05-21 09:45:45', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:45');
INSERT INTO `access_log` VALUES (5346, '50.52.15584031450160813', 0, 2, 'admin-application', '/admin-api/admins/role/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-05-21 09:45:45', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:45');
INSERT INTO `access_log` VALUES (5347, '63.78.15584031450260509', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-05-21 09:45:45', 2, 1002001015, '账号未登陆', '2019-05-21 09:45:45');
INSERT INTO `access_log` VALUES (5348, '63.79.15584031450350507', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.97.43', '2019-05-21 09:45:45', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:45');
INSERT INTO `access_log` VALUES (5349, '62.84.15584031450260513', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-05-21 09:45:45', 2, 1002001015, '账号未登陆', '2019-05-21 09:45:45');
INSERT INTO `access_log` VALUES (5350, '48.56.15584031452150803', 0, 2, 'user-application', '/user-api/admins/user/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.25.223', '2019-05-21 09:45:45', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:45');
INSERT INTO `access_log` VALUES (5351, '50.48.15584031455130819', 0, 2, 'admin-application', '/admin-api/admins/role/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-05-21 09:45:46', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:46');
INSERT INTO `access_log` VALUES (5352, '62.85.15584031454950513', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-05-21 09:45:45', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:46');
INSERT INTO `access_log` VALUES (5353, '63.80.15584031455160509', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.97.43', '2019-05-21 09:45:46', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:46');
INSERT INTO `access_log` VALUES (5354, '63.77.15584031455150507', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-05-21 09:45:46', 0, 1002001015, '账号未登陆', '2019-05-21 09:45:46');
INSERT INTO `access_log` VALUES (5355, '62.86.15584031459700511', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', '', 'GET', 'Java/1.8.0_181', '117.50.16.248', '2019-05-21 09:45:46', 2, 1002001015, '账号未登陆', '2019-05-21 09:45:46');
INSERT INTO `access_log` VALUES (5356, '63.81.15584031459700507', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.97.43', '2019-05-21 09:45:46', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:46');
INSERT INTO `access_log` VALUES (5357, '63.82.15584031459950505', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-05-21 09:45:46', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:46');
INSERT INTO `access_log` VALUES (5358, '50.47.15584031459980823', 0, 2, 'admin-application', '/admin-api/admins/role/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-05-21 09:45:46', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:46');
INSERT INTO `access_log` VALUES (5359, '48.57.15584031457440799', 0, 2, 'user-application', '/user-api/admins/user/page', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.25.223', '2019-05-21 09:45:46', 6, 1002001015, '账号未登陆', '2019-05-21 09:45:46');
INSERT INTO `access_log` VALUES (5360, '63.81.15584031459700507', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.97.43', '2019-05-21 09:45:46', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:47');
INSERT INTO `access_log` VALUES (5361, '62.86.15584031459700511', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', '', 'GET', 'Java/1.8.0_181', '117.50.16.248', '2019-05-21 09:45:46', 2, 1002001015, '账号未登陆', '2019-05-21 09:45:47');
INSERT INTO `access_log` VALUES (5362, '63.82.15584031459950505', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-05-21 09:45:46', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:47');
INSERT INTO `access_log` VALUES (5363, '48.57.15584031457440799', 0, 2, 'user-application', '/user-api/admins/user/page', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.25.223', '2019-05-21 09:45:46', 6, 1002001015, '账号未登陆', '2019-05-21 09:45:47');
INSERT INTO `access_log` VALUES (5364, '50.53.15584031473270821', 0, 2, 'admin-application', '/admin-api/admins/role/page', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-05-21 09:45:47', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:47');
INSERT INTO `access_log` VALUES (5365, '63.84.15584031473470509', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Java/1.8.0_171', '106.75.97.43', '2019-05-21 09:45:47', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:47');
INSERT INTO `access_log` VALUES (5366, '63.83.15584031473450509', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-05-21 09:45:47', 2, 1002001015, '账号未登陆', '2019-05-21 09:45:47');
INSERT INTO `access_log` VALUES (5367, '48.51.15584031479350799', 0, 2, 'user-application', '/user-api/admins/user/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.25.223', '2019-05-21 09:45:48', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:48');
INSERT INTO `access_log` VALUES (5368, '63.84.15584031473470509', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Java/1.8.0_171', '106.75.97.43', '2019-05-21 09:45:47', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:48');
INSERT INTO `access_log` VALUES (5369, '63.83.15584031473450509', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-05-21 09:45:47', 2, 1002001015, '账号未登陆', '2019-05-21 09:45:48');
INSERT INTO `access_log` VALUES (5370, '48.51.15584031479350799', 0, 2, 'user-application', '/user-api/admins/user/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '106.75.25.223', '2019-05-21 09:45:48', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:49');
INSERT INTO `access_log` VALUES (5371, '63.83.15584031473450509', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-05-21 09:45:47', 2, 1002001015, '账号未登陆', '2019-05-21 09:45:49');
INSERT INTO `access_log` VALUES (5372, '63.84.15584031473470509', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Java/1.8.0_171', '106.75.97.43', '2019-05-21 09:45:47', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:49');
INSERT INTO `access_log` VALUES (5373, '50.54.15584031495170819', 0, 2, 'admin-application', '/admin-api/admins/role/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-05-21 09:45:50', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:50');
INSERT INTO `access_log` VALUES (5374, '48.55.15584031495370801', 0, 2, 'user-application', '/user-api/admins/user/page', '', 'GET', 'Java/1.8.0_181', '106.75.25.223', '2019-05-21 09:45:50', 2, 1002001015, '账号未登陆', '2019-05-21 09:45:50');
INSERT INTO `access_log` VALUES (5375, '63.85.15584031505210507', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Java/1.8.0_151', '120.132.59.70', '2019-05-21 09:45:51', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:51');
INSERT INTO `access_log` VALUES (5376, '48.55.15584031495370801', 0, 2, 'user-application', '/user-api/admins/user/page', '', 'GET', 'Java/1.8.0_181', '106.75.25.223', '2019-05-21 09:45:50', 2, 1002001015, '账号未登陆', '2019-05-21 09:45:51');
INSERT INTO `access_log` VALUES (5377, '50.46.15584031515000819', 0, 2, 'admin-application', '/admin-api/admins/role/page', '', 'GET', 'Java/1.8.0_181', '117.50.16.248', '2019-05-21 09:45:52', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:52');
INSERT INTO `access_log` VALUES (5378, '59.76.15584031576070567', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.19.93', '2019-05-21 09:45:58', 147, 1002001015, '账号未登陆', '2019-05-21 09:45:58');
INSERT INTO `access_log` VALUES (5379, '59.75.15584031581990569', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.19.93', '2019-05-21 09:45:58', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:58');
INSERT INTO `access_log` VALUES (5380, '59.77.15584031585810569', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.19.93', '2019-05-21 09:45:59', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:59');
INSERT INTO `access_log` VALUES (5381, '59.78.15584031593490569', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.19.93', '2019-05-21 09:45:59', 1, 1002001015, '账号未登陆', '2019-05-21 09:45:59');
INSERT INTO `access_log` VALUES (5382, '59.79.15584031599450569', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.19.93', '2019-05-21 09:46:00', 1, 1002001015, '账号未登陆', '2019-05-21 09:46:00');
INSERT INTO `access_log` VALUES (5383, '59.71.15584031602940571', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', '', 'GET', 'Java/1.8.0_212', '117.50.19.93', '2019-05-21 09:46:00', 1, 1002001015, '账号未登陆', '2019-05-21 09:46:00');
INSERT INTO `access_log` VALUES (5384, '50.46.15584044386410837', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:07:19', 2, 1002001015, '账号未登陆', '2019-05-21 10:07:19');
INSERT INTO `access_log` VALUES (5385, '50.49.15584044386700837', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:07:19', 1, 1002001015, '账号未登陆', '2019-05-21 10:07:19');
INSERT INTO `access_log` VALUES (5386, '50.55.15584044387170837', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:07:19', 0, 1002001015, '账号未登陆', '2019-05-21 10:07:19');
INSERT INTO `access_log` VALUES (5387, '50.51.15584044447030833', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:07:25', 327, 0, '', '2019-05-21 10:07:25');
INSERT INTO `access_log` VALUES (5388, '50.52.15584044460000831', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:07:26', 21, 0, '', '2019-05-21 10:07:26');
INSERT INTO `access_log` VALUES (5389, '50.48.15584044460130837', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:07:26', 15, 0, '', '2019-05-21 10:07:26');
INSERT INTO `access_log` VALUES (5390, '50.47.15584044460210843', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:07:26', 12, 0, '', '2019-05-21 10:07:26');
INSERT INTO `access_log` VALUES (5391, '62.85.15584044586070531', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:07:39', 55, 0, '', '2019-05-21 10:07:39');
INSERT INTO `access_log` VALUES (5392, '62.88.15584044788820531', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:07:59', 47, 0, '', '2019-05-21 10:07:59');
INSERT INTO `access_log` VALUES (5393, '62.87.15584044798370531', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:08:00', 27, 0, '', '2019-05-21 10:08:00');
INSERT INTO `access_log` VALUES (5394, '62.80.15584044804070531', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=4&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:08:00', 71, 0, '', '2019-05-21 10:08:00');
INSERT INTO `access_log` VALUES (5395, '62.81.15584044814060533', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=5&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:08:01', 25, 0, '', '2019-05-21 10:08:01');
INSERT INTO `access_log` VALUES (5396, '62.89.15584044829360531', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=6&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:08:03', 48, 0, '', '2019-05-21 10:08:03');
INSERT INTO `access_log` VALUES (5397, '62.82.15584044836780531', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=7&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:08:04', 50, 0, '', '2019-05-21 10:08:04');
INSERT INTO `access_log` VALUES (5398, '62.83.15584044848380533', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=8&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:08:05', 26, 0, '', '2019-05-21 10:08:05');
INSERT INTO `access_log` VALUES (5399, '62.84.15584044856690533', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:08:06', 46, 0, '', '2019-05-21 10:08:06');
INSERT INTO `access_log` VALUES (5400, '62.86.15584044941340531', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:08:14', 59, 0, '', '2019-05-21 10:08:14');
INSERT INTO `access_log` VALUES (5401, '63.78.15584045064670529', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:08:26', 521, 0, '', '2019-05-21 10:08:27');
INSERT INTO `access_log` VALUES (5402, '63.79.15584045064770527', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:08:26', 526, 0, '', '2019-05-21 10:08:27');
INSERT INTO `access_log` VALUES (5403, '63.83.15584045479230529', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:09:08', 19, 0, '', '2019-05-21 10:09:08');
INSERT INTO `access_log` VALUES (5404, '63.81.15584045479150527', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:09:08', 86, 0, '', '2019-05-21 10:09:08');
INSERT INTO `access_log` VALUES (5405, '63.76.15584045521100531', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:09:12', 42, 0, '', '2019-05-21 10:09:12');
INSERT INTO `access_log` VALUES (5406, '63.84.15584045521090529', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:09:12', 321, 0, '', '2019-05-21 10:09:12');
INSERT INTO `access_log` VALUES (5407, '63.85.15584045551860527', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:09:15', 45, 0, '', '2019-05-21 10:09:15');
INSERT INTO `access_log` VALUES (5408, '59.78.15584046069190589', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:10:07', 44, 0, '', '2019-05-21 10:10:07');
INSERT INTO `access_log` VALUES (5409, '59.79.15584046164620589', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:10:16', 404, 2001001000, '服务端发生异常', '2019-05-21 10:10:17');
INSERT INTO `access_log` VALUES (5410, '59.80.15584046217360589', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:10:22', 1614, 0, '', '2019-05-21 10:10:23');
INSERT INTO `access_log` VALUES (5411, '59.73.15584046277000591', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:10:28', 634, 0, '', '2019-05-21 10:10:28');
INSERT INTO `access_log` VALUES (5412, '59.72.15584046315360589', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:10:32', 34, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-21 10:10:32');
INSERT INTO `access_log` VALUES (5413, '50.49.15584046354950841', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:10:35', 28, 0, '', '2019-05-21 10:10:36');
INSERT INTO `access_log` VALUES (5414, '50.46.15584046395030841', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:10:40', 54, 0, '', '2019-05-21 10:10:40');
INSERT INTO `access_log` VALUES (5415, '50.50.15584046421140845', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:10:42', 36, 0, '', '2019-05-21 10:10:42');
INSERT INTO `access_log` VALUES (5416, '50.51.15584046450840837', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:10:45', 33, 0, '', '2019-05-21 10:10:45');
INSERT INTO `access_log` VALUES (5417, '50.52.15584046743660835', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:14', 40, 0, '', '2019-05-21 10:11:14');
INSERT INTO `access_log` VALUES (5418, '50.53.15584046752940845', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:15', 52, 0, '', '2019-05-21 10:11:15');
INSERT INTO `access_log` VALUES (5419, '50.54.15584046771650843', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:17', 48, 0, '', '2019-05-21 10:11:17');
INSERT INTO `access_log` VALUES (5420, '59.78.15584046776320591', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:18', 23, 0, '', '2019-05-21 10:11:18');
INSERT INTO `access_log` VALUES (5421, '59.77.15584046774580591', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:17', 337, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-21 10:11:18');
INSERT INTO `access_log` VALUES (5422, '59.79.15584046778410591', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:18', 19, 0, '', '2019-05-21 10:11:18');
INSERT INTO `access_log` VALUES (5423, '59.71.15584046780830593', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:18', 458, 2001001000, '服务端发生异常', '2019-05-21 10:11:19');
INSERT INTO `access_log` VALUES (5424, '59.71.15584046780830593', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:18', 458, 2001001000, '服务端发生异常', '2019-05-21 10:11:20');
INSERT INTO `access_log` VALUES (5425, '59.71.15584046780830593', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:18', 458, 2001001000, '服务端发生异常', '2019-05-21 10:11:21');
INSERT INTO `access_log` VALUES (5426, '59.80.15584046784900591', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:18', 4107, 0, '', '2019-05-21 10:11:23');
INSERT INTO `access_log` VALUES (5427, '63.85.15584046897550529', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:30', 70, 0, '', '2019-05-21 10:11:30');
INSERT INTO `access_log` VALUES (5428, '63.78.15584046901210533', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:30', 200, 0, '', '2019-05-21 10:11:30');
INSERT INTO `access_log` VALUES (5429, '63.77.15584046905350531', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:31', 19, 0, '', '2019-05-21 10:11:31');
INSERT INTO `access_log` VALUES (5430, '63.79.15584046905290531', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:31', 77, 0, '', '2019-05-21 10:11:31');
INSERT INTO `access_log` VALUES (5431, '63.80.15584046907410533', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:31', 87, 0, '', '2019-05-21 10:11:31');
INSERT INTO `access_log` VALUES (5432, '63.82.15584046912490529', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:31', 283, 0, '', '2019-05-21 10:11:32');
INSERT INTO `access_log` VALUES (5433, '50.48.15584086574290895', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.122.92.173', '2019-05-21 11:17:37', 1, 1002001015, '账号未登陆', '2019-05-21 11:17:37');
INSERT INTO `access_log` VALUES (5434, '50.47.15584086574300901', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.122.92.173', '2019-05-21 11:17:37', 1, 1002001015, '账号未登陆', '2019-05-21 11:17:37');
INSERT INTO `access_log` VALUES (5435, '50.52.15584086574330889', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.122.92.173', '2019-05-21 11:17:37', 0, 1002001015, '账号未登陆', '2019-05-21 11:17:37');
INSERT INTO `access_log` VALUES (5436, '50.54.15584086613390897', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.122.92.173', '2019-05-21 11:17:41', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 11:17:41');
INSERT INTO `access_log` VALUES (5437, '50.49.15584086694510897', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.122.92.173', '2019-05-21 11:17:49', 597, 0, '', '2019-05-21 11:17:50');
INSERT INTO `access_log` VALUES (5438, '50.50.15584086708280901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.122.92.173', '2019-05-21 11:17:51', 121, 0, '', '2019-05-21 11:17:51');
INSERT INTO `access_log` VALUES (5439, '50.46.15584086708240897', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.122.92.173', '2019-05-21 11:17:51', 125, 0, '', '2019-05-21 11:17:51');
INSERT INTO `access_log` VALUES (5440, '50.55.15584086708210897', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.122.92.173', '2019-05-21 11:17:51', 150, 0, '', '2019-05-21 11:17:51');
INSERT INTO `access_log` VALUES (5441, '62.84.15584086742600595', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.122.92.173', '2019-05-21 11:17:54', 521, 0, '', '2019-05-21 11:17:55');
INSERT INTO `access_log` VALUES (5442, '59.77.15584086806900645', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.122.92.173', '2019-05-21 11:18:01', 28, 0, '', '2019-05-21 11:18:01');
INSERT INTO `access_log` VALUES (5443, '59.71.15584086947060647', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.122.92.173', '2019-05-21 11:18:15', 36, 1002002009, NULL, '2019-05-21 11:18:15');
INSERT INTO `access_log` VALUES (5444, '50.49.15584094661030909', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:06', 0, 1002001015, '账号未登陆', '2019-05-21 11:31:06');
INSERT INTO `access_log` VALUES (5445, '50.53.15584094661020911', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:06', 1, 1002001015, '账号未登陆', '2019-05-21 11:31:06');
INSERT INTO `access_log` VALUES (5446, '50.54.15584094661030909', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:06', 1, 1002001015, '账号未登陆', '2019-05-21 11:31:06');
INSERT INTO `access_log` VALUES (5447, '50.55.15584094702040909', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:10', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 11:31:10');
INSERT INTO `access_log` VALUES (5448, '50.46.15584094724210907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:12', 66, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 11:31:12');
INSERT INTO `access_log` VALUES (5449, '50.51.15584094735340905', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:14', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 11:31:14');
INSERT INTO `access_log` VALUES (5450, '50.47.15584094744140915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:14', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 11:31:14');
INSERT INTO `access_log` VALUES (5451, '50.48.15584094845880909', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:25', 322, 0, '', '2019-05-21 11:31:25');
INSERT INTO `access_log` VALUES (5452, '50.53.15584094854200913', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:25', 797, 0, '', '2019-05-21 11:31:26');
INSERT INTO `access_log` VALUES (5453, '50.54.15584094854240911', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:25', 794, 0, '', '2019-05-21 11:31:26');
INSERT INTO `access_log` VALUES (5454, '50.49.15584094854280911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:25', 805, 0, '', '2019-05-21 11:31:26');
INSERT INTO `access_log` VALUES (5455, '62.81.15584094961710607', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:36', 25, 0, '', '2019-05-21 11:31:36');
INSERT INTO `access_log` VALUES (5456, '62.82.15584095064860605', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:46', 20, 0, '', '2019-05-21 11:31:47');
INSERT INTO `access_log` VALUES (5457, '62.83.15584095072910607', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:47', 44, 0, '', '2019-05-21 11:31:47');
INSERT INTO `access_log` VALUES (5458, '62.84.15584095082370607', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=4&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:48', 41, 0, '', '2019-05-21 11:31:48');
INSERT INTO `access_log` VALUES (5459, '62.85.15584095089960607', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=5&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:49', 105, 0, '', '2019-05-21 11:31:49');
INSERT INTO `access_log` VALUES (5460, '62.86.15584095096850605', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=6&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:50', 26, 0, '', '2019-05-21 11:31:50');
INSERT INTO `access_log` VALUES (5461, '62.88.15584095103610607', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=7&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:50', 21, 0, '', '2019-05-21 11:31:50');
INSERT INTO `access_log` VALUES (5462, '62.87.15584095109970607', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=8&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:51', 22, 0, '', '2019-05-21 11:31:51');
INSERT INTO `access_log` VALUES (5463, '62.89.15584095118400607', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:31:52', 19, 0, '', '2019-05-21 11:31:52');
INSERT INTO `access_log` VALUES (5464, '63.77.15584095207560597', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:32:01', 57, 0, '', '2019-05-21 11:32:01');
INSERT INTO `access_log` VALUES (5465, '63.78.15584095207540599', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:32:01', 88, 0, '', '2019-05-21 11:32:01');
INSERT INTO `access_log` VALUES (5466, '62.81.15584095258760609', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:32:06', 48, 0, '', '2019-05-21 11:32:06');
INSERT INTO `access_log` VALUES (5467, '50.51.15584095262030907', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '58.246.221.162', '2019-05-21 11:32:06', 1, 1002001015, '账号未登陆', '2019-05-21 11:32:06');
INSERT INTO `access_log` VALUES (5468, '50.46.15584095262030909', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '210.22.245.226', '2019-05-21 11:32:06', 1, 1002001015, '账号未登陆', '2019-05-21 11:32:06');
INSERT INTO `access_log` VALUES (5469, '50.48.15584095526970911', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:32:33', 28, 0, '', '2019-05-21 11:32:33');
INSERT INTO `access_log` VALUES (5470, '62.80.15584095561490609', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '58.246.221.162', '2019-05-21 11:32:36', 1, 1002001015, '账号未登陆', '2019-05-21 11:32:36');
INSERT INTO `access_log` VALUES (5471, '62.89.15584095670490609', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '58.246.221.162', '2019-05-21 11:32:47', 1, 1002001015, '账号未登陆', '2019-05-21 11:32:47');
INSERT INTO `access_log` VALUES (5472, '62.81.15584095681570611', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '223.167.152.53', '2019-05-21 11:32:48', 2, 1002001015, '账号未登陆', '2019-05-21 11:32:48');
INSERT INTO `access_log` VALUES (5473, '62.82.15584095691890609', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=6&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '58.246.221.61', '2019-05-21 11:32:49', 1, 1002001015, '账号未登陆', '2019-05-21 11:32:49');
INSERT INTO `access_log` VALUES (5474, '62.83.15584095692130611', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=5&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '58.247.204.63', '2019-05-21 11:32:49', 1, 1002001015, '账号未登陆', '2019-05-21 11:32:49');
INSERT INTO `access_log` VALUES (5475, '62.84.15584095701290611', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=7&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '58.246.221.162', '2019-05-21 11:32:50', 0, 1002001015, '账号未登陆', '2019-05-21 11:32:50');
INSERT INTO `access_log` VALUES (5476, '62.85.15584095701300611', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=8&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '223.166.151.197', '2019-05-21 11:32:50', 1, 1002001015, '账号未登陆', '2019-05-21 11:32:50');
INSERT INTO `access_log` VALUES (5477, '50.49.15584095705750913', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:32:51', 12, 0, '', '2019-05-21 11:32:51');
INSERT INTO `access_log` VALUES (5478, '62.86.15584095710840609', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '58.246.221.163', '2019-05-21 11:32:51', 1, 1002001015, '账号未登陆', '2019-05-21 11:32:51');
INSERT INTO `access_log` VALUES (5479, '50.50.15584095765960917', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:32:57', 153, 0, '', '2019-05-21 11:32:57');
INSERT INTO `access_log` VALUES (5480, '63.76.15584095800820599', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '210.22.245.226', '2019-05-21 11:33:00', 1, 1002001015, '账号未登陆', '2019-05-21 11:33:00');
INSERT INTO `access_log` VALUES (5481, '63.84.15584095802550599', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '223.166.151.197', '2019-05-21 11:33:00', 0, 1002001015, '账号未登陆', '2019-05-21 11:33:00');
INSERT INTO `access_log` VALUES (5482, '63.84.15584095802550599', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '223.166.151.197', '2019-05-21 11:33:00', 0, 1002001015, '账号未登陆', '2019-05-21 11:33:01');
INSERT INTO `access_log` VALUES (5483, '62.87.15584095851080611', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '223.167.152.70', '2019-05-21 11:33:05', 2, 1002001015, '账号未登陆', '2019-05-21 11:33:05');
INSERT INTO `access_log` VALUES (5484, '50.55.15584095867380913', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:33:07', 28, 0, '', '2019-05-21 11:33:07');
INSERT INTO `access_log` VALUES (5485, '50.46.15584096030920911', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:33:23', 13, 0, '', '2019-05-21 11:33:23');
INSERT INTO `access_log` VALUES (5486, '50.52.15584096046010907', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:33:25', 15, 0, '', '2019-05-21 11:33:25');
INSERT INTO `access_log` VALUES (5487, '50.48.15584096065000913', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:33:27', 26, 0, '', '2019-05-21 11:33:27');
INSERT INTO `access_log` VALUES (5488, '59.72.15584096110850657', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:33:31', 19, 0, '', '2019-05-21 11:33:31');
INSERT INTO `access_log` VALUES (5489, '50.53.15584096120730917', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '58.246.221.163', '2019-05-21 11:33:32', 1, 1002001015, '账号未登陆', '2019-05-21 11:33:32');
INSERT INTO `access_log` VALUES (5490, '59.76.15584096183230657', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:33:38', 448, 2001001000, '服务端发生异常', '2019-05-21 11:33:39');
INSERT INTO `access_log` VALUES (5491, '59.75.15584096224250659', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:33:42', 323, 0, '', '2019-05-21 11:33:43');
INSERT INTO `access_log` VALUES (5492, '59.78.15584096289280659', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:33:49', 33, 0, '', '2019-05-21 11:33:49');
INSERT INTO `access_log` VALUES (5493, '50.54.15584096302350915', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '223.166.151.199', '2019-05-21 11:33:50', 1, 1002001015, '账号未登陆', '2019-05-21 11:33:50');
INSERT INTO `access_log` VALUES (5494, '59.77.15584096329640659', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:33:53', 13, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-21 11:33:53');
INSERT INTO `access_log` VALUES (5495, '50.55.15584096362420915', 0, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '223.166.151.199', '2019-05-21 11:33:56', 1, 1002001015, '账号未登陆', '2019-05-21 11:33:56');
INSERT INTO `access_log` VALUES (5496, '48.54.15584096360410885', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:33:56', 911, 0, '', '2019-05-21 11:33:57');
INSERT INTO `access_log` VALUES (5497, '50.51.15584096473900911', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '58.246.221.61', '2019-05-21 11:34:07', 1, 1002001015, '账号未登陆', '2019-05-21 11:34:07');
INSERT INTO `access_log` VALUES (5498, '50.47.15584096632870921', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '223.167.152.70', '2019-05-21 11:34:23', 43, 1002001015, '账号未登陆', '2019-05-21 11:34:23');
INSERT INTO `access_log` VALUES (5499, '59.72.15584096780900659', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '58.246.221.61', '2019-05-21 11:34:38', 1, 1002001015, '账号未登陆', '2019-05-21 11:34:38');
INSERT INTO `access_log` VALUES (5500, '59.74.15584096797010661', 0, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '223.166.151.199', '2019-05-21 11:34:40', 1, 1002001015, '账号未登陆', '2019-05-21 11:34:40');
INSERT INTO `access_log` VALUES (5501, '59.76.15584096820730659', 0, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '58.246.221.61', '2019-05-21 11:34:42', 1, 1002001015, '账号未登陆', '2019-05-21 11:34:42');
INSERT INTO `access_log` VALUES (5502, '59.75.15584096882140661', 0, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '116.128.128.79', '2019-05-21 11:34:48', 0, 1002001015, '账号未登陆', '2019-05-21 11:34:48');
INSERT INTO `access_log` VALUES (5503, '59.78.15584096941510661', 0, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '223.166.151.191', '2019-05-21 11:34:54', 1, 1002001015, '账号未登陆', '2019-05-21 11:34:54');
INSERT INTO `access_log` VALUES (5504, '48.51.15584096960810887', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '210.22.245.226', '2019-05-21 11:34:56', 17, 1002001015, '账号未登陆', '2019-05-21 11:34:56');
INSERT INTO `access_log` VALUES (5505, '62.89.15584097141020613', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:14', 24, 0, '', '2019-05-21 11:35:14');
INSERT INTO `access_log` VALUES (5506, '62.81.15584097196400615', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:20', 32, 0, '', '2019-05-21 11:35:20');
INSERT INTO `access_log` VALUES (5507, '63.85.15584097218380599', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:22', 29, 0, '', '2019-05-21 11:35:22');
INSERT INTO `access_log` VALUES (5508, '63.77.15584097218390601', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:22', 44, 0, '', '2019-05-21 11:35:22');
INSERT INTO `access_log` VALUES (5509, '63.79.15584097235890601', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:24', 16, 0, '', '2019-05-21 11:35:24');
INSERT INTO `access_log` VALUES (5510, '63.78.15584097235880603', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:24', 33, 0, '', '2019-05-21 11:35:24');
INSERT INTO `access_log` VALUES (5511, '63.80.15584097256460601', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:26', 21, 0, '', '2019-05-21 11:35:26');
INSERT INTO `access_log` VALUES (5512, '63.81.15584097285050601', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:29', 21, 0, '', '2019-05-21 11:35:29');
INSERT INTO `access_log` VALUES (5513, '63.82.15584097285050599', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:29', 49, 0, '', '2019-05-21 11:35:29');
INSERT INTO `access_log` VALUES (5514, '63.83.15584097348190603', 27, 2, 'product-application', '/product-api/admins/spu/update_sort', 'id=36&sort=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:35', 36, 1002002009, NULL, '2019-05-21 11:35:35');
INSERT INTO `access_log` VALUES (5515, '63.85.15584097508830601', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:51', 2045, 0, '', '2019-05-21 11:35:53');
INSERT INTO `access_log` VALUES (5516, '63.77.15584097532090603', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:53', 562, 0, '', '2019-05-21 11:35:54');
INSERT INTO `access_log` VALUES (5517, '63.79.15584097538100603', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:54', 18, 0, '', '2019-05-21 11:35:54');
INSERT INTO `access_log` VALUES (5518, '63.78.15584097538730605', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:54', 20, 0, '', '2019-05-21 11:35:54');
INSERT INTO `access_log` VALUES (5519, '63.80.15584097539050603', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:54', 36, 0, '', '2019-05-21 11:35:54');
INSERT INTO `access_log` VALUES (5520, '63.81.15584097539080603', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:54', 36, 0, '', '2019-05-21 11:35:54');
INSERT INTO `access_log` VALUES (5521, '63.82.15584097540300601', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:54', 27, 0, '', '2019-05-21 11:35:54');
INSERT INTO `access_log` VALUES (5522, '63.83.15584097541780605', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:54', 21, 0, '', '2019-05-21 11:35:54');
INSERT INTO `access_log` VALUES (5523, '63.76.15584097543010605', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:54', 20, 0, '', '2019-05-21 11:35:54');
INSERT INTO `access_log` VALUES (5524, '63.84.15584097548360605', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:55', 24, 0, '', '2019-05-21 11:35:55');
INSERT INTO `access_log` VALUES (5525, '63.85.15584097574710603', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:35:57', 39, 0, '', '2019-05-21 11:35:58');
INSERT INTO `access_log` VALUES (5526, '50.46.15584097746710915', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:15', 14, 0, '', '2019-05-21 11:36:15');
INSERT INTO `access_log` VALUES (5527, '50.47.15584097746760923', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:15', 14, 0, '', '2019-05-21 11:36:15');
INSERT INTO `access_log` VALUES (5528, '50.52.15584097746760911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:15', 33, 0, '', '2019-05-21 11:36:15');
INSERT INTO `access_log` VALUES (5529, '50.48.15584097815700917', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:22', 13, 0, '', '2019-05-21 11:36:22');
INSERT INTO `access_log` VALUES (5530, '50.53.15584097815730921', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:22', 11, 0, '', '2019-05-21 11:36:22');
INSERT INTO `access_log` VALUES (5531, '50.49.15584097815770919', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:22', 13, 0, '', '2019-05-21 11:36:22');
INSERT INTO `access_log` VALUES (5532, '62.87.15584097840200615', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:24', 20, 0, '', '2019-05-21 11:36:24');
INSERT INTO `access_log` VALUES (5533, '406c86af-2602-4b2e-93e5-d829caad57be', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai', 'POST', 'PostmanRuntime/6.4.1', '127.0.0.1', '2019-05-21 11:36:22', 140, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 11:36:22');
INSERT INTO `access_log` VALUES (5534, '63.77.15584097850700605', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '210.22.245.219', '2019-05-21 11:36:25', 1, 1002001015, '账号未登陆', '2019-05-21 11:36:25');
INSERT INTO `access_log` VALUES (5535, '50.50.15584097903430923', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:30', 11, 0, '', '2019-05-21 11:36:30');
INSERT INTO `access_log` VALUES (5536, '50.55.15584097903460919', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:30', 12, 0, '', '2019-05-21 11:36:30');
INSERT INTO `access_log` VALUES (5537, '50.51.15584097903510915', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:30', 40, 0, '', '2019-05-21 11:36:30');
INSERT INTO `access_log` VALUES (5538, '62.80.15584097904540615', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:30', 16, 0, '', '2019-05-21 11:36:30');
INSERT INTO `access_log` VALUES (5539, '50.52.15584097958720913', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:36', 13, 0, '', '2019-05-21 11:36:36');
INSERT INTO `access_log` VALUES (5540, '50.47.15584097958720925', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:36', 16, 0, '', '2019-05-21 11:36:36');
INSERT INTO `access_log` VALUES (5541, '50.46.15584097958720917', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:36', 18, 0, '', '2019-05-21 11:36:36');
INSERT INTO `access_log` VALUES (5542, '62.89.15584097959840615', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:36', 29, 0, '', '2019-05-21 11:36:36');
INSERT INTO `access_log` VALUES (5543, '50.48.15584097987830919', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:39', 12, 0, '', '2019-05-21 11:36:39');
INSERT INTO `access_log` VALUES (5544, '50.49.15584097987840921', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:39', 15, 0, '', '2019-05-21 11:36:39');
INSERT INTO `access_log` VALUES (5545, '50.53.15584097987880923', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:39', 12, 0, '', '2019-05-21 11:36:39');
INSERT INTO `access_log` VALUES (5546, '62.82.15584097988970615', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:36:39', 19, 0, '', '2019-05-21 11:36:39');
INSERT INTO `access_log` VALUES (5547, '23f63ac1-b83c-4160-bc3b-3f864a16e165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai', 'POST', 'PostmanRuntime/6.4.1', '127.0.0.1', '2019-05-21 11:36:52', 4, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 11:36:52');
INSERT INTO `access_log` VALUES (5548, '63.82.15584098122260603', 0, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '58.246.221.163', '2019-05-21 11:36:52', 1, 1002001015, '账号未登陆', '2019-05-21 11:36:52');
INSERT INTO `access_log` VALUES (5549, '63.76.15584098228170607', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:37:03', 15, 0, '', '2019-05-21 11:37:03');
INSERT INTO `access_log` VALUES (5550, '63.83.15584098228140607', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:37:03', 20, 0, '', '2019-05-21 11:37:03');
INSERT INTO `access_log` VALUES (5551, '38155455-08a4-4bd5-bdea-16be40433796', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai', 'POST', 'PostmanRuntime/6.4.1', '127.0.0.1', '2019-05-21 11:37:29', 119, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 11:37:29');
INSERT INTO `access_log` VALUES (5552, '482927dc-d198-4eab-a209-d2c7741ae826', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai', 'POST', 'PostmanRuntime/6.4.1', '127.0.0.1', '2019-05-21 11:38:44', 114, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 11:38:44');
INSERT INTO `access_log` VALUES (5553, 'f76b8235-4eaa-415a-8fe8-a6525862e4c2', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai', 'POST', 'PostmanRuntime/6.4.1', '127.0.0.1', '2019-05-21 11:39:28', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 11:39:28');
INSERT INTO `access_log` VALUES (5554, '59.77.15584099965380665', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:39:57', 813, 0, '', '2019-05-21 11:39:57');
INSERT INTO `access_log` VALUES (5555, '48.52.15584100013570895', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:01', 842, 0, '', '2019-05-21 11:40:02');
INSERT INTO `access_log` VALUES (5556, '63.77.15584100095730609', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:10', 15, 0, '', '2019-05-21 11:40:10');
INSERT INTO `access_log` VALUES (5557, '63.79.15584100095680609', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:10', 22, 0, '', '2019-05-21 11:40:10');
INSERT INTO `access_log` VALUES (5558, '63.79.15584100095680609', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:10', 22, 0, '', '2019-05-21 11:40:11');
INSERT INTO `access_log` VALUES (5559, '63.77.15584100095730609', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:10', 15, 0, '', '2019-05-21 11:40:11');
INSERT INTO `access_log` VALUES (5560, '63.81.15584100115090609', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:12', 15, 0, '', '2019-05-21 11:40:12');
INSERT INTO `access_log` VALUES (5561, '63.80.15584100115030609', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:12', 24, 0, '', '2019-05-21 11:40:12');
INSERT INTO `access_log` VALUES (5562, '63.82.15584100175060607', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:18', 34, 0, '', '2019-05-21 11:40:18');
INSERT INTO `access_log` VALUES (5563, '63.85.15584100509300609', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:51', 6556, 2001001000, '服务端发生异常', '2019-05-21 11:40:57');
INSERT INTO `access_log` VALUES (5564, '63.77.15584100516430611', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:52', 5843, 2001001000, '服务端发生异常', '2019-05-21 11:40:57');
INSERT INTO `access_log` VALUES (5565, '63.78.15584100509350613', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:51', 7289, 2001001000, '服务端发生异常', '2019-05-21 11:40:58');
INSERT INTO `access_log` VALUES (5566, '63.77.15584100516430611', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:52', 5843, 2001001000, '服务端发生异常', '2019-05-21 11:40:59');
INSERT INTO `access_log` VALUES (5567, '63.85.15584100509300609', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:51', 6556, 2001001000, '服务端发生异常', '2019-05-21 11:40:59');
INSERT INTO `access_log` VALUES (5568, '63.77.15584100516430611', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:52', 5843, 2001001000, '服务端发生异常', '2019-05-21 11:41:00');
INSERT INTO `access_log` VALUES (5569, '63.85.15584100509300609', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:51', 6556, 2001001000, '服务端发生异常', '2019-05-21 11:41:00');
INSERT INTO `access_log` VALUES (5570, '63.79.15584100592690611', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:59', 706, 0, '', '2019-05-21 11:41:00');
INSERT INTO `access_log` VALUES (5571, '1c7bad1f-9f4f-45d8-b7ad-f6bd5e39cec8', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai', 'POST', 'PostmanRuntime/6.4.1', '127.0.0.1', '2019-05-21 11:40:19', 132624, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 11:42:32');
INSERT INTO `access_log` VALUES (5572, '06980731-feab-4f44-a291-1c7214d20c93', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin', 'POST', 'PostmanRuntime/6.4.1', '127.0.0.1', '2019-05-21 11:42:41', 3, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码不能为空', '2019-05-21 11:42:41');
INSERT INTO `access_log` VALUES (5573, '04121a75-1469-4b4e-b711-aea7aec1d8f8', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin', 'POST', 'PostmanRuntime/6.4.1', '127.0.0.1', '2019-05-21 11:42:48', 29995, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码不能为空', '2019-05-21 11:43:18');
INSERT INTO `access_log` VALUES (5574, '59.73.15584213471300815', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.117.163.66', '2019-05-21 14:49:07', 37, 0, '', '2019-05-21 14:49:07');
INSERT INTO `access_log` VALUES (5575, '59.71.15584213471310815', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.117.163.66', '2019-05-21 14:49:07', 211, 2001001000, '服务端发生异常', '2019-05-21 14:49:07');
INSERT INTO `access_log` VALUES (5576, '50.52.15584226018281083', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:10:02', 7, 1002001012, '访问令牌已过期', '2019-05-21 15:10:02');
INSERT INTO `access_log` VALUES (5577, '50.47.15584226018311095', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:10:02', 5, 1002001012, '访问令牌已过期', '2019-05-21 15:10:02');
INSERT INTO `access_log` VALUES (5578, '50.48.15584226018361087', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:10:02', 15, 1002001012, '访问令牌已过期', '2019-05-21 15:10:02');
INSERT INTO `access_log` VALUES (5579, '50.53.15584226079301093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:10:08', 116, 0, '', '2019-05-21 15:10:08');
INSERT INTO `access_log` VALUES (5580, '50.55.15584226086411089', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:10:09', 183, 0, '', '2019-05-21 15:10:09');
INSERT INTO `access_log` VALUES (5581, '50.49.15584226086381089', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:10:09', 184, 0, '', '2019-05-21 15:10:09');
INSERT INTO `access_log` VALUES (5582, '50.51.15584226086431085', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:10:09', 179, 0, '', '2019-05-21 15:10:09');
INSERT INTO `access_log` VALUES (5583, '50.50.15584226108481095', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:10:11', 888, 0, '', '2019-05-21 15:10:12');
INSERT INTO `access_log` VALUES (5584, '50.46.15584226132361087', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:10:13', 17, 0, '', '2019-05-21 15:10:13');
INSERT INTO `access_log` VALUES (5585, '50.52.15584226144941085', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:10:14', 13, 0, '', '2019-05-21 15:10:15');
INSERT INTO `access_log` VALUES (5586, '50.53.15584254550141119', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:57:35', 166, 0, '', '2019-05-21 15:57:35');
INSERT INTO `access_log` VALUES (5587, '50.54.15584254550201115', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:57:35', 161, 0, '', '2019-05-21 15:57:35');
INSERT INTO `access_log` VALUES (5588, '50.49.15584254550541115', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:57:35', 127, 0, '', '2019-05-21 15:57:35');
INSERT INTO `access_log` VALUES (5589, '64.85.15584254610160015', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:57:41', 735, 0, '', '2019-05-21 15:57:42');
INSERT INTO `access_log` VALUES (5590, '64.83.15584254610140015', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:57:41', 735, 0, '', '2019-05-21 15:57:42');
INSERT INTO `access_log` VALUES (5591, '64.77.15584254626430017', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:57:43', 74, 0, '', '2019-05-21 15:57:43');
INSERT INTO `access_log` VALUES (5592, '64.76.15584254626380017', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:57:43', 195, 0, '', '2019-05-21 15:57:43');
INSERT INTO `access_log` VALUES (5593, '64.79.15584254647340017', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:57:45', 86, 0, '', '2019-05-21 15:57:45');
INSERT INTO `access_log` VALUES (5594, '64.78.15584254647230017', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:57:45', 90, 0, '', '2019-05-21 15:57:45');
INSERT INTO `access_log` VALUES (5595, '64.80.15584254647250017', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:57:45', 141, 0, '', '2019-05-21 15:57:45');
INSERT INTO `access_log` VALUES (5596, '50.46.15584254925381113', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:58:13', 711, 0, '', '2019-05-21 15:58:13');
INSERT INTO `access_log` VALUES (5597, '50.52.15584254998701109', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:58:20', 6, 0, '', '2019-05-21 15:58:20');
INSERT INTO `access_log` VALUES (5598, '50.47.15584255068041123', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-21 15:58:27', 5, 0, '', '2019-05-21 15:58:27');
INSERT INTO `access_log` VALUES (5599, '59.78.15584260484320863', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '113.67.157.22', '2019-05-21 16:07:28', 55, 0, '', '2019-05-21 16:07:28');
INSERT INTO `access_log` VALUES (5600, '59.77.15584260484330863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '113.67.157.22', '2019-05-21 16:07:28', 154, 2001001000, '服务端发生异常', '2019-05-21 16:07:29');
INSERT INTO `access_log` VALUES (5601, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=123&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '113.67.157.22', '2019-05-21 16:07:38', 8455, 0, '', '2019-05-21 16:07:48');
INSERT INTO `access_log` VALUES (5602, 'dea6f590-60c9-4f01-abf7-93a7f004bede', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin', 'POST', 'PostmanRuntime/6.4.1', '127.0.0.1', '2019-05-21 16:20:41', 110, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码不能为空', '2019-05-21 16:20:41');
INSERT INTO `access_log` VALUES (5603, 'a27f79e3-4810-46a5-98cc-a64a46d46fec', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin', 'POST', 'PostmanRuntime/6.4.1', '127.0.0.1', '2019-05-21 16:20:43', 4, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码不能为空', '2019-05-21 16:20:43');
INSERT INTO `access_log` VALUES (5604, 'fdeeca52-6d83-42d9-9462-eb9dffeea625', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin', 'POST', 'PostmanRuntime/6.4.1', '127.0.0.1', '2019-05-21 16:20:50', 3, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码不能为空', '2019-05-21 16:20:50');
INSERT INTO `access_log` VALUES (5605, '50.49.15584269989191137', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:19', 30, 1002001012, '访问令牌已过期', '2019-05-21 16:23:19');
INSERT INTO `access_log` VALUES (5606, '50.47.15584269989191143', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:19', 31, 1002001012, '访问令牌已过期', '2019-05-21 16:23:19');
INSERT INTO `access_log` VALUES (5607, '50.53.15584269989211141', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:19', 28, 1002001012, '访问令牌已过期', '2019-05-21 16:23:19');
INSERT INTO `access_log` VALUES (5608, '50.51.15584270062561133', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:26', 196, 0, '', '2019-05-21 16:23:26');
INSERT INTO `access_log` VALUES (5609, '50.55.15584270066041137', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:27', 13, 0, '', '2019-05-21 16:23:27');
INSERT INTO `access_log` VALUES (5610, '50.50.15584270066071143', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:27', 12, 0, '', '2019-05-21 16:23:27');
INSERT INTO `access_log` VALUES (5611, '50.46.15584270066101135', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:27', 12, 0, '', '2019-05-21 16:23:27');
INSERT INTO `access_log` VALUES (5612, '50.52.15584270103151131', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:30', 35, 0, '', '2019-05-21 16:23:30');
INSERT INTO `access_log` VALUES (5613, '50.48.15584270144331137', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=yudaoyuanma', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:34', 211, 0, '', '2019-05-21 16:23:35');
INSERT INTO `access_log` VALUES (5614, '50.47.15584270166201145', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:37', 29, 0, '', '2019-05-21 16:23:37');
INSERT INTO `access_log` VALUES (5615, '50.53.15584270187981143', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:39', 54, 0, '', '2019-05-21 16:23:39');
INSERT INTO `access_log` VALUES (5616, '50.54.15584270209981139', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:41', 48, 0, '', '2019-05-21 16:23:41');
INSERT INTO `access_log` VALUES (5617, '50.51.15584270243181135', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:44', 27, 0, '', '2019-05-21 16:23:44');
INSERT INTO `access_log` VALUES (5618, '50.46.15584270265041137', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:47', 15, 0, '', '2019-05-21 16:23:47');
INSERT INTO `access_log` VALUES (5619, '62.86.15584270300950839', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:23:50', 61, 0, '', '2019-05-21 16:23:50');
INSERT INTO `access_log` VALUES (5620, '65.48.15584273668780003', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:29:27', 1104, 0, '', '2019-05-21 16:29:28');
INSERT INTO `access_log` VALUES (5621, '65.47.15584273668780003', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:29:27', 1104, 0, '', '2019-05-21 16:29:28');
INSERT INTO `access_log` VALUES (5622, '65.49.15584273668790003', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:29:27', 1104, 0, '', '2019-05-21 16:29:28');
INSERT INTO `access_log` VALUES (5623, '65.50.15584273708150003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:29:31', 69, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 16:29:31');
INSERT INTO `access_log` VALUES (5624, '65.51.15584273741820003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:29:34', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 16:29:34');
INSERT INTO `access_log` VALUES (5625, '65.53.15584273801390003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=ydym1024&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:29:40', 255, 0, '', '2019-05-21 16:29:40');
INSERT INTO `access_log` VALUES (5626, '65.54.15584273805350003', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:29:41', 40, 0, '', '2019-05-21 16:29:41');
INSERT INTO `access_log` VALUES (5627, '65.45.15584273805360005', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:29:41', 41, 0, '', '2019-05-21 16:29:41');
INSERT INTO `access_log` VALUES (5628, '65.46.15584273805410005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-21 16:29:41', 58, 0, '', '2019-05-21 16:29:41');
INSERT INTO `access_log` VALUES (5629, '59.72.15584280368320889', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:40:37', 182, 0, '', '2019-05-21 16:40:37');
INSERT INTO `access_log` VALUES (5630, '59.74.15584280368330891', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:40:37', 355, 2001001000, '服务端发生异常', '2019-05-21 16:40:37');
INSERT INTO `access_log` VALUES (5631, '64.84.15584280434130051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:40:43', 48, 0, '', '2019-05-21 16:40:44');
INSERT INTO `access_log` VALUES (5632, '64.83.15584280437170051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:40:44', 6, 0, '', '2019-05-21 16:40:44');
INSERT INTO `access_log` VALUES (5633, '64.85.15584280470760051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:40:47', 6, 0, '', '2019-05-21 16:40:47');
INSERT INTO `access_log` VALUES (5634, '64.77.15584280479950053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:40:48', 5, 0, '', '2019-05-21 16:40:48');
INSERT INTO `access_log` VALUES (5635, '64.76.15584280485900053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:40:49', 6, 0, '', '2019-05-21 16:40:49');
INSERT INTO `access_log` VALUES (5636, '64.79.15584280490690053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:40:49', 5, 0, '', '2019-05-21 16:40:49');
INSERT INTO `access_log` VALUES (5637, '65.52.15584280624230013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:02', 9, 1002001015, '账号未登陆', '2019-05-21 16:41:02');
INSERT INTO `access_log` VALUES (5638, '65.54.15584280624260013', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:02', 1, 1002001015, '账号未登陆', '2019-05-21 16:41:02');
INSERT INTO `access_log` VALUES (5639, '65.53.15584280624230013', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:02', 3, 1002001015, '账号未登陆', '2019-05-21 16:41:02');
INSERT INTO `access_log` VALUES (5640, '65.45.15584280676210015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 16:41:08');
INSERT INTO `access_log` VALUES (5641, '65.49.15584280737790015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:14', 131, 0, '', '2019-05-21 16:41:14');
INSERT INTO `access_log` VALUES (5642, '65.47.15584280744000015', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:14', 77, 0, '', '2019-05-21 16:41:14');
INSERT INTO `access_log` VALUES (5643, '65.48.15584280744060015', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:14', 83, 0, '', '2019-05-21 16:41:14');
INSERT INTO `access_log` VALUES (5644, '65.50.15584280744170015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:14', 75, 0, '', '2019-05-21 16:41:14');
INSERT INTO `access_log` VALUES (5645, '62.89.15584280827210857', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:23', 69, 0, '', '2019-05-21 16:41:23');
INSERT INTO `access_log` VALUES (5646, '62.83.15584280941040859', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:34', 58, 0, '', '2019-05-21 16:41:34');
INSERT INTO `access_log` VALUES (5647, '64.83.15584281006700053', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:41', 59, 0, '', '2019-05-21 16:41:41');
INSERT INTO `access_log` VALUES (5648, '64.84.15584281006570053', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:41', 94, 0, '', '2019-05-21 16:41:41');
INSERT INTO `access_log` VALUES (5649, '64.77.15584281046150055', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:45', 62, 0, '', '2019-05-21 16:41:45');
INSERT INTO `access_log` VALUES (5650, '64.85.15584281046100053', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:45', 81, 0, '', '2019-05-21 16:41:45');
INSERT INTO `access_log` VALUES (5651, '64.76.15584281083460055', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:48', 57, 0, '', '2019-05-21 16:41:48');
INSERT INTO `access_log` VALUES (5652, '59.73.15584281188190893', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:41:59', 48, 0, '', '2019-05-21 16:41:59');
INSERT INTO `access_log` VALUES (5653, '59.71.15584281221130893', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:42:02', 185, 2001001000, '服务端发生异常', '2019-05-21 16:42:02');
INSERT INTO `access_log` VALUES (5654, '59.74.15584281531630893', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:42:33', 68, 0, '', '2019-05-21 16:42:33');
INSERT INTO `access_log` VALUES (5655, '59.75.15584281595380893', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:42:40', 41, 0, '', '2019-05-21 16:42:40');
INSERT INTO `access_log` VALUES (5656, '59.79.15584281657840891', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:42:46', 89, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-21 16:42:46');
INSERT INTO `access_log` VALUES (5657, '65.49.15584281725400017', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:42:53', 229, 0, '', '2019-05-21 16:42:53');
INSERT INTO `access_log` VALUES (5658, '65.48.15584281787730017', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:42:59', 101, 0, '', '2019-05-21 16:42:59');
INSERT INTO `access_log` VALUES (5659, '65.50.15584281850600017', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:43:05', 45, 0, '', '2019-05-21 16:43:05');
INSERT INTO `access_log` VALUES (5660, '65.54.15584282007510017', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:43:21', 39, 0, '', '2019-05-21 16:43:21');
INSERT INTO `access_log` VALUES (5661, '65.53.15584282075560017', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:43:28', 37, 0, '', '2019-05-21 16:43:28');
INSERT INTO `access_log` VALUES (5662, '59.73.15584301383680921', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.224.23.179', '2019-05-21 17:15:38', 175, 0, '', '2019-05-21 17:15:39');
INSERT INTO `access_log` VALUES (5663, '59.71.15584301383840921', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.224.23.179', '2019-05-21 17:15:38', 256, 2001001000, '服务端发生异常', '2019-05-21 17:15:39');
INSERT INTO `access_log` VALUES (5664, '64.84.15584301484050081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.224.23.179', '2019-05-21 17:15:48', 374, 0, '', '2019-05-21 17:15:49');
INSERT INTO `access_log` VALUES (5665, '64.77.15584301497190083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.224.23.179', '2019-05-21 17:15:50', 5, 0, '', '2019-05-21 17:15:50');
INSERT INTO `access_log` VALUES (5666, '64.76.15584301534990083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.224.23.179', '2019-05-21 17:15:54', 5, 0, '', '2019-05-21 17:15:54');
INSERT INTO `access_log` VALUES (5667, '64.79.15584301546840083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.224.23.179', '2019-05-21 17:15:55', 9, 0, '', '2019-05-21 17:15:55');
INSERT INTO `access_log` VALUES (5668, '64.78.15584301560130083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.224.23.179', '2019-05-21 17:15:56', 4, 0, '', '2019-05-21 17:15:56');
INSERT INTO `access_log` VALUES (5669, '64.80.15584301585310083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.224.23.179', '2019-05-21 17:15:59', 5, 0, '', '2019-05-21 17:15:59');
INSERT INTO `access_log` VALUES (5670, '64.81.15584301600390083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.224.23.179', '2019-05-21 17:16:00', 5, 0, '', '2019-05-21 17:16:00');
INSERT INTO `access_log` VALUES (5671, '64.82.15584301616090083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.224.23.179', '2019-05-21 17:16:02', 4, 0, '', '2019-05-21 17:16:02');
INSERT INTO `access_log` VALUES (5672, '64.84.15584301735990083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.224.23.179', '2019-05-21 17:16:14', 5, 0, '', '2019-05-21 17:16:14');
INSERT INTO `access_log` VALUES (5673, '64.77.15584301745590085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.224.23.179', '2019-05-21 17:16:15', 334, 0, '', '2019-05-21 17:16:15');
INSERT INTO `access_log` VALUES (5674, '64.85.15584301764160083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.224.23.179', '2019-05-21 17:16:16', 5, 0, '', '2019-05-21 17:16:16');
INSERT INTO `access_log` VALUES (5675, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.224.23.179', '2019-05-21 17:16:16', 1907, 0, '', '2019-05-21 17:16:18');
INSERT INTO `access_log` VALUES (5676, '64.79.15584301850940085', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.224.23.179', '2019-05-21 17:16:25', 27, 0, '', '2019-05-21 17:16:25');
INSERT INTO `access_log` VALUES (5677, '59.78.15584311191680933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:31:59', 15, 0, '', '2019-05-21 17:31:59');
INSERT INTO `access_log` VALUES (5678, '59.79.15584311191680931', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:31:59', 86, 2001001000, '服务端发生异常', '2019-05-21 17:31:59');
INSERT INTO `access_log` VALUES (5679, '64.79.15584311218540099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:02', 6, 0, '', '2019-05-21 17:32:02');
INSERT INTO `access_log` VALUES (5680, '64.80.15584311219680097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:02', 4, 0, '', '2019-05-21 17:32:02');
INSERT INTO `access_log` VALUES (5681, '64.81.15584311231700097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:03', 5, 0, '', '2019-05-21 17:32:03');
INSERT INTO `access_log` VALUES (5682, '64.83.15584311235140097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:04', 4, 0, '', '2019-05-21 17:32:04');
INSERT INTO `access_log` VALUES (5683, '64.84.15584311259390099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:06', 4, 0, '', '2019-05-21 17:32:06');
INSERT INTO `access_log` VALUES (5684, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:07', 28, 0, '', '2019-05-21 17:32:07');
INSERT INTO `access_log` VALUES (5685, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:08', 76, 0, '', '2019-05-21 17:32:08');
INSERT INTO `access_log` VALUES (5686, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:08', 812, 0, '', '2019-05-21 17:32:08');
INSERT INTO `access_log` VALUES (5687, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:09', 84, 0, '', '2019-05-21 17:32:09');
INSERT INTO `access_log` VALUES (5688, '64.85.15584311288860099', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:09', 16, 0, '', '2019-05-21 17:32:09');
INSERT INTO `access_log` VALUES (5689, '66.51.15584311414310027', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=12345678901', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:21', 584, 0, '', '2019-05-21 17:32:22');
INSERT INTO `access_log` VALUES (5690, '66.52.15584311440250027', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678901&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:24', 103, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空', '2019-05-21 17:32:24');
INSERT INTO `access_log` VALUES (5691, '66.53.15584311492820027', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678901&code=123456', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:29', 99, 1001003003, '验证码不正确', '2019-05-21 17:32:29');
INSERT INTO `access_log` VALUES (5692, '66.55.15584311573790027', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678901&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:37', 418, 0, '', '2019-05-21 17:32:38');
INSERT INTO `access_log` VALUES (5693, '66.57.15584311591190027', 77, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:32:39', 100, 0, '', '2019-05-21 17:32:39');
INSERT INTO `access_log` VALUES (5694, '59.74.15584382377441029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.71.200.13', '2019-05-21 19:30:38', 13, 0, '', '2019-05-21 19:30:38');
INSERT INTO `access_log` VALUES (5695, '59.76.15584382377481025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.150.36.6', '2019-05-21 19:30:38', 119, 2001001000, '服务端发生异常', '2019-05-21 19:30:38');
INSERT INTO `access_log` VALUES (5696, '64.80.15584382418750193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.150.36.6', '2019-05-21 19:30:42', 18, 0, '', '2019-05-21 19:30:42');
INSERT INTO `access_log` VALUES (5697, '64.81.15584382420350193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.150.36.6', '2019-05-21 19:30:42', 4, 0, '', '2019-05-21 19:30:42');
INSERT INTO `access_log` VALUES (5698, '64.83.15584382457470193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.150.36.6', '2019-05-21 19:30:46', 5, 0, '', '2019-05-21 19:30:46');
INSERT INTO `access_log` VALUES (5699, '64.82.15584382459100195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.150.36.6', '2019-05-21 19:30:46', 4, 0, '', '2019-05-21 19:30:46');
INSERT INTO `access_log` VALUES (5700, '59.78.15584382465801029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.150.36.6', '2019-05-21 19:30:47', 553, 0, '', '2019-05-21 19:30:47');
INSERT INTO `access_log` VALUES (5701, '59.75.15584382465791029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.71.200.13', '2019-05-21 19:30:47', 719, 2001001000, '服务端发生异常', '2019-05-21 19:30:47');
INSERT INTO `access_log` VALUES (5702, '65.52.15584436898200225', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:01:30', 2, 1002001015, '账号未登陆', '2019-05-21 21:01:30');
INSERT INTO `access_log` VALUES (5703, '65.54.15584436898200225', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:01:30', 2, 1002001015, '账号未登陆', '2019-05-21 21:01:30');
INSERT INTO `access_log` VALUES (5704, '65.51.15584436898200225', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:01:30', 7, 1002001015, '账号未登陆', '2019-05-21 21:01:30');
INSERT INTO `access_log` VALUES (5705, '65.53.15584437127360223', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:01:53', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 21:01:53');
INSERT INTO `access_log` VALUES (5706, '65.49.15584437188650231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai1111&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:01:59', 69, 0, '', '2019-05-21 21:01:59');
INSERT INTO `access_log` VALUES (5707, '65.48.15584437193110227', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:01:59', 193, 0, '', '2019-05-21 21:02:00');
INSERT INTO `access_log` VALUES (5708, '65.47.15584437193110227', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:01:59', 190, 0, '', '2019-05-21 21:02:00');
INSERT INTO `access_log` VALUES (5709, '65.50.15584437193430229', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:01:59', 168, 0, '', '2019-05-21 21:02:00');
INSERT INTO `access_log` VALUES (5710, '62.81.15584437240141063', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:02:04', 81, 0, '', '2019-05-21 21:02:04');
INSERT INTO `access_log` VALUES (5711, '64.80.15584437321140267', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:02:12', 61, 0, '', '2019-05-21 21:02:12');
INSERT INTO `access_log` VALUES (5712, '64.81.15584437321140267', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:02:12', 68, 0, '', '2019-05-21 21:02:12');
INSERT INTO `access_log` VALUES (5713, '59.76.15584438948371101', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.63.15', '2019-05-21 21:04:55', 59, 0, '', '2019-05-21 21:04:55');
INSERT INTO `access_log` VALUES (5714, '59.78.15584438948441105', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.63.15', '2019-05-21 21:04:55', 130, 2001001000, '服务端发生异常', '2019-05-21 21:04:55');
INSERT INTO `access_log` VALUES (5715, '64.85.15584439284360271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.63.15', '2019-05-21 21:05:28', 6, 0, '', '2019-05-21 21:05:28');
INSERT INTO `access_log` VALUES (5716, '64.77.15584439286760273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.63.15', '2019-05-21 21:05:29', 5, 0, '', '2019-05-21 21:05:29');
INSERT INTO `access_log` VALUES (5717, '64.78.15584439358540271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.63.15', '2019-05-21 21:05:36', 5, 0, '', '2019-05-21 21:05:36');
INSERT INTO `access_log` VALUES (5718, '64.79.15584439360740273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.63.15', '2019-05-21 21:05:36', 6, 0, '', '2019-05-21 21:05:36');
INSERT INTO `access_log` VALUES (5719, '59.73.15584439480741107', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.63.15', '2019-05-21 21:05:48', 6, 0, '', '2019-05-21 21:05:48');
INSERT INTO `access_log` VALUES (5720, '59.71.15584439480751107', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.63.15', '2019-05-21 21:05:48', 167, 2001001000, '服务端发生异常', '2019-05-21 21:05:48');
INSERT INTO `access_log` VALUES (5721, '65.47.15584439648050231', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-21 21:06:05', 6, 1002001012, '访问令牌已过期', '2019-05-21 21:06:05');
INSERT INTO `access_log` VALUES (5722, '65.49.15584439648030235', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-21 21:06:05', 13, 1002001012, '访问令牌已过期', '2019-05-21 21:06:05');
INSERT INTO `access_log` VALUES (5723, '65.50.15584439648140233', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-21 21:06:05', 6, 1002001012, '访问令牌已过期', '2019-05-21 21:06:05');
INSERT INTO `access_log` VALUES (5724, '65.48.15584439676150231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-21 21:06:08', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 21:06:08');
INSERT INTO `access_log` VALUES (5725, '65.54.15584439885680231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-21 21:06:29', 71, 0, '', '2019-05-21 21:06:29');
INSERT INTO `access_log` VALUES (5726, '65.53.15584439889390229', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-21 21:06:29', 24, 0, '', '2019-05-21 21:06:29');
INSERT INTO `access_log` VALUES (5727, '65.45.15584439889450237', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-21 21:06:29', 19, 0, '', '2019-05-21 21:06:29');
INSERT INTO `access_log` VALUES (5728, '65.46.15584439889320235', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-21 21:06:29', 25, 0, '', '2019-05-21 21:06:29');
INSERT INTO `access_log` VALUES (5729, '65.47.15584439943470233', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-21 21:06:34', 20, 0, '', '2019-05-21 21:06:34');
INSERT INTO `access_log` VALUES (5730, '65.52.15584440450340233', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-21 21:07:25', 711, 0, '', '2019-05-21 21:07:26');
INSERT INTO `access_log` VALUES (5731, '65.54.15584440494800233', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-21 21:07:29', 25, 0, '', '2019-05-21 21:07:30');
INSERT INTO `access_log` VALUES (5732, '65.46.15584440564910237', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-21 21:07:36', 33, 0, '', '2019-05-21 21:07:37');
INSERT INTO `access_log` VALUES (5733, '65.49.15584442757370243', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:11:16', 20, 0, '', '2019-05-21 21:11:16');
INSERT INTO `access_log` VALUES (5734, '65.48.15584442877260239', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:11:28', 20, 0, '', '2019-05-21 21:11:28');
INSERT INTO `access_log` VALUES (5735, '65.51.15584442904490237', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:11:30', 57, 0, '', '2019-05-21 21:11:31');
INSERT INTO `access_log` VALUES (5736, '65.54.15584443051290235', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:11:45', 36, 0, '', '2019-05-21 21:11:45');
INSERT INTO `access_log` VALUES (5737, '65.46.15584443084570243', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:11:48', 20, 0, '', '2019-05-21 21:11:48');
INSERT INTO `access_log` VALUES (5738, '65.45.15584443105650245', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:11:51', 21, 0, '', '2019-05-21 21:11:51');
INSERT INTO `access_log` VALUES (5739, '62.84.15584445714981079', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:16:11', 54, 0, '', '2019-05-21 21:16:12');
INSERT INTO `access_log` VALUES (5740, '65.46.15584445789780247', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.15', '2019-05-21 21:16:19', 33, 0, '', '2019-05-21 21:16:19');
INSERT INTO `access_log` VALUES (5741, '65.50.15584458424190263', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '103.107.216.231', '2019-05-21 21:37:22', 1, 1002001015, '账号未登陆', '2019-05-21 21:37:22');
INSERT INTO `access_log` VALUES (5742, '65.48.15584458424530261', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '103.107.216.231', '2019-05-21 21:37:22', 1, 1002001015, '账号未登陆', '2019-05-21 21:37:22');
INSERT INTO `access_log` VALUES (5743, '65.51.15584458424610259', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '103.107.216.231', '2019-05-21 21:37:22', 1, 1002001015, '账号未登陆', '2019-05-21 21:37:22');
INSERT INTO `access_log` VALUES (5744, '65.54.15584458454850257', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '103.107.216.231', '2019-05-21 21:37:25', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 21:37:25');
INSERT INTO `access_log` VALUES (5745, '65.46.15584458497920265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '103.107.216.231', '2019-05-21 21:37:30', 177, 0, '', '2019-05-21 21:37:30');
INSERT INTO `access_log` VALUES (5746, '65.53.15584458502450259', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '103.107.216.231', '2019-05-21 21:37:30', 20, 0, '', '2019-05-21 21:37:30');
INSERT INTO `access_log` VALUES (5747, '65.45.15584458502440267', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '103.107.216.231', '2019-05-21 21:37:30', 27, 0, '', '2019-05-21 21:37:30');
INSERT INTO `access_log` VALUES (5748, '65.47.15584458502460263', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '103.107.216.231', '2019-05-21 21:37:30', 22, 0, '', '2019-05-21 21:37:30');
INSERT INTO `access_log` VALUES (5749, '64.78.15584458598550297', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '103.107.216.231', '2019-05-21 21:37:40', 52, 0, '', '2019-05-21 21:37:40');
INSERT INTO `access_log` VALUES (5750, '64.79.15584458598580299', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '103.107.216.231', '2019-05-21 21:37:40', 67, 0, '', '2019-05-21 21:37:40');
INSERT INTO `access_log` VALUES (5751, '59.71.15584458757791133', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '103.107.216.231', '2019-05-21 21:37:56', 57, 0, '', '2019-05-21 21:37:56');
INSERT INTO `access_log` VALUES (5752, '65.47.15584501411690321', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.216', '2019-05-21 22:49:01', 42, 1002001012, '访问令牌已过期', '2019-05-21 22:49:01');
INSERT INTO `access_log` VALUES (5753, '65.46.15584501411590323', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.216', '2019-05-21 22:49:01', 56, 1002001012, '访问令牌已过期', '2019-05-21 22:49:01');
INSERT INTO `access_log` VALUES (5754, '65.45.15584501411590325', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.216', '2019-05-21 22:49:01', 51, 1002001012, '访问令牌已过期', '2019-05-21 22:49:01');
INSERT INTO `access_log` VALUES (5755, '65.53.15584501450980317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.216', '2019-05-21 22:49:05', 183, 0, '', '2019-05-21 22:49:05');
INSERT INTO `access_log` VALUES (5756, '65.50.15584501455270323', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.216', '2019-05-21 22:49:06', 23, 0, '', '2019-05-21 22:49:06');
INSERT INTO `access_log` VALUES (5757, '65.48.15584501455320321', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.216', '2019-05-21 22:49:06', 22, 0, '', '2019-05-21 22:49:06');
INSERT INTO `access_log` VALUES (5758, '65.49.15584501455250325', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.216', '2019-05-21 22:49:06', 24, 0, '', '2019-05-21 22:49:06');
INSERT INTO `access_log` VALUES (5759, '66.54.15584501509380281', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.216', '2019-05-21 22:49:11', 293, 0, '', '2019-05-21 22:49:11');
INSERT INTO `access_log` VALUES (5760, '64.76.15584501539100355', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.216', '2019-05-21 22:49:14', 76, 0, '', '2019-05-21 22:49:14');
INSERT INTO `access_log` VALUES (5761, '64.77.15584501539080357', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.216', '2019-05-21 22:49:14', 84, 0, '', '2019-05-21 22:49:14');
INSERT INTO `access_log` VALUES (5762, '65.54.15584501744500317', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.216', '2019-05-21 22:49:34', 591, 0, '', '2019-05-21 22:49:35');
INSERT INTO `access_log` VALUES (5763, '65.52.15584529921700355', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:36:32', 2, 1002001015, '账号未登陆', '2019-05-21 23:36:32');
INSERT INTO `access_log` VALUES (5764, '65.54.15584529921770355', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:36:32', 1, 1002001015, '账号未登陆', '2019-05-21 23:36:32');
INSERT INTO `access_log` VALUES (5765, '65.47.15584529922560361', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:36:32', 1, 1002001015, '账号未登陆', '2019-05-21 23:36:32');
INSERT INTO `access_log` VALUES (5766, '65.45.15584529959330365', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:36:36', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-21 23:36:36');
INSERT INTO `access_log` VALUES (5767, '65.53.15584530109750357', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:36:51', 104, 0, '', '2019-05-21 23:36:51');
INSERT INTO `access_log` VALUES (5768, '65.50.15584530114060363', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:36:51', 23, 0, '', '2019-05-21 23:36:51');
INSERT INTO `access_log` VALUES (5769, '65.48.15584530114170361', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:36:51', 23, 0, '', '2019-05-21 23:36:51');
INSERT INTO `access_log` VALUES (5770, '65.49.15584530114300365', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:36:51', 21, 0, '', '2019-05-21 23:36:51');
INSERT INTO `access_log` VALUES (5771, '62.89.15584530249281191', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:37:05', 124, 0, '', '2019-05-21 23:37:05');
INSERT INTO `access_log` VALUES (5772, '62.83.15584530377561193', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:37:18', 44, 0, '', '2019-05-21 23:37:18');
INSERT INTO `access_log` VALUES (5773, '64.83.15584530420750393', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:37:22', 32, 0, '', '2019-05-21 23:37:22');
INSERT INTO `access_log` VALUES (5774, '64.80.15584530420630393', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:37:22', 65, 0, '', '2019-05-21 23:37:22');
INSERT INTO `access_log` VALUES (5775, '64.85.15584530580680395', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:37:38', 24, 0, '', '2019-05-21 23:37:38');
INSERT INTO `access_log` VALUES (5776, '64.84.15584530580620395', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:37:38', 53, 0, '', '2019-05-21 23:37:38');
INSERT INTO `access_log` VALUES (5777, '64.77.15584530690210397', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:37:49', 30, 0, '', '2019-05-21 23:37:49');
INSERT INTO `access_log` VALUES (5778, '64.76.15584530690300395', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:37:49', 23, 0, '', '2019-05-21 23:37:49');
INSERT INTO `access_log` VALUES (5779, '64.79.15584530736250397', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:37:54', 25, 0, '', '2019-05-21 23:37:54');
INSERT INTO `access_log` VALUES (5780, '59.72.15584530951971227', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:38:15', 30, 0, '', '2019-05-21 23:38:15');
INSERT INTO `access_log` VALUES (5781, '66.52.15584531023930321', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:38:22', 79, 0, '', '2019-05-21 23:38:22');
INSERT INTO `access_log` VALUES (5782, '59.76.15584531067221225', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:38:27', 21, 0, '', '2019-05-21 23:38:27');
INSERT INTO `access_log` VALUES (5783, '65.50.15584531091300365', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:38:29', 45, 0, '', '2019-05-21 23:38:29');
INSERT INTO `access_log` VALUES (5784, '65.48.15584531114550363', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.174.150.146', '2019-05-21 23:38:31', 25, 0, '', '2019-05-21 23:38:31');
INSERT INTO `access_log` VALUES (5785, '59.75.15584571680191283', 0, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=run&activitytype=1&pageno=1&pagesize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36 QIHU 360SE/Nutch-1.13', '61.129.39.81', '2019-05-22 00:46:08', 1, 1002001015, '账号未登陆', '2019-05-22 00:46:08');
INSERT INTO `access_log` VALUES (5786, '65.52.15584876665520821', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:14:27', 1, 1002001015, '账号未登陆', '2019-05-22 09:14:27');
INSERT INTO `access_log` VALUES (5787, '65.51.15584876665520821', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:14:27', 1, 1002001015, '账号未登陆', '2019-05-22 09:14:27');
INSERT INTO `access_log` VALUES (5788, '65.48.15584876665520823', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:14:27', 1, 1002001015, '账号未登陆', '2019-05-22 09:14:27');
INSERT INTO `access_log` VALUES (5789, '65.47.15584876696000827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:14:30', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 09:14:30');
INSERT INTO `access_log` VALUES (5790, '65.50.15584876768290827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai344444444444&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:14:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 09:14:37');
INSERT INTO `access_log` VALUES (5791, '65.53.15584876902550821', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:14:50', 446, 0, '', '2019-05-22 09:14:51');
INSERT INTO `access_log` VALUES (5792, '65.45.15584876913140831', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:14:51', 754, 0, '', '2019-05-22 09:14:52');
INSERT INTO `access_log` VALUES (5793, '65.49.15584876913260831', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:14:51', 743, 0, '', '2019-05-22 09:14:52');
INSERT INTO `access_log` VALUES (5794, '65.54.15584876913110825', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:14:51', 755, 0, '', '2019-05-22 09:14:52');
INSERT INTO `access_log` VALUES (5795, '62.88.15584877010051655', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:15:01', 40, 0, '', '2019-05-22 09:15:01');
INSERT INTO `access_log` VALUES (5796, '62.86.15584877201721651', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:15:20', 33, 0, '', '2019-05-22 09:15:20');
INSERT INTO `access_log` VALUES (5797, '62.89.15584877247671655', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:15:25', 63, 0, '', '2019-05-22 09:15:25');
INSERT INTO `access_log` VALUES (5798, '65.47.15584877262440829', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.89.239.120', '2019-05-22 09:15:26', 1, 1002001015, '账号未登陆', '2019-05-22 09:15:26');
INSERT INTO `access_log` VALUES (5799, '64.83.15584877398740857', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:15:40', 37, 0, '', '2019-05-22 09:15:40');
INSERT INTO `access_log` VALUES (5800, '64.80.15584877398700857', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:15:40', 47, 0, '', '2019-05-22 09:15:40');
INSERT INTO `access_log` VALUES (5801, '64.82.15584877445060859', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:15:45', 64, 0, '', '2019-05-22 09:15:45');
INSERT INTO `access_log` VALUES (5802, '64.85.15584877445160859', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:15:45', 62, 0, '', '2019-05-22 09:15:45');
INSERT INTO `access_log` VALUES (5803, '64.84.15584877445220859', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:15:45', 75, 0, '', '2019-05-22 09:15:45');
INSERT INTO `access_log` VALUES (5804, '66.53.15584877576380783', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:15:58', 68, 0, '', '2019-05-22 09:15:58');
INSERT INTO `access_log` VALUES (5805, '59.75.15584877628981691', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:16:03', 51, 0, '', '2019-05-22 09:16:03');
INSERT INTO `access_log` VALUES (5806, '62.84.15584877630761657', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.89.239.120', '2019-05-22 09:16:03', 54, 1002001015, '账号未登陆', '2019-05-22 09:16:03');
INSERT INTO `access_log` VALUES (5807, '59.77.15584877670611691', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:16:07', 19, 0, '', '2019-05-22 09:16:07');
INSERT INTO `access_log` VALUES (5808, '65.54.15584877810450827', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:16:21', 23, 0, '', '2019-05-22 09:16:21');
INSERT INTO `access_log` VALUES (5809, '65.45.15584877810480833', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:16:21', 22, 0, '', '2019-05-22 09:16:21');
INSERT INTO `access_log` VALUES (5810, '65.49.15584877810600833', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:16:21', 16, 0, '', '2019-05-22 09:16:21');
INSERT INTO `access_log` VALUES (5811, '65.52.15584877926600825', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:16:33', 43, 0, '', '2019-05-22 09:16:33');
INSERT INTO `access_log` VALUES (5812, '65.48.15584877983580827', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:16:38', 34, 0, '', '2019-05-22 09:16:38');
INSERT INTO `access_log` VALUES (5813, '64.81.15584878010070859', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.178.236', '2019-05-22 09:16:41', 58, 1002001015, '账号未登陆', '2019-05-22 09:16:41');
INSERT INTO `access_log` VALUES (5814, '64.80.15584878017240859', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.179.84', '2019-05-22 09:16:42', 4, 1002001015, '账号未登陆', '2019-05-22 09:16:42');
INSERT INTO `access_log` VALUES (5815, '65.50.15584878040590831', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:16:44', 14, 0, '', '2019-05-22 09:16:44');
INSERT INTO `access_log` VALUES (5816, '64.83.15584878041460859', 0, 2, 'product-application', '/product-api/admins/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.60.104', '2019-05-22 09:16:44', 1, 1002001015, '账号未登陆', '2019-05-22 09:16:44');
INSERT INTO `access_log` VALUES (5817, '64.85.15584878043640861', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.151.178.217', '2019-05-22 09:16:44', 3, 1002001015, '账号未登陆', '2019-05-22 09:16:44');
INSERT INTO `access_log` VALUES (5818, '65.46.15584878099780833', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:16:50', 25, 0, '', '2019-05-22 09:16:50');
INSERT INTO `access_log` VALUES (5819, '66.48.15584878175620785', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.91.60.105', '2019-05-22 09:16:58', 5, 1002001015, '账号未登陆', '2019-05-22 09:16:58');
INSERT INTO `access_log` VALUES (5820, '59.72.15584878222131691', 0, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.91.60.105', '2019-05-22 09:17:02', 1, 1002001015, '账号未登陆', '2019-05-22 09:17:02');
INSERT INTO `access_log` VALUES (5821, '66.49.15584878402220785', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.127.99.32', '2019-05-22 09:17:20', 71, 0, '', '2019-05-22 09:17:20');
INSERT INTO `access_log` VALUES (5822, '65.51.15584878646060827', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.91.60.110', '2019-05-22 09:17:45', 2, 1002001015, '账号未登陆', '2019-05-22 09:17:45');
INSERT INTO `access_log` VALUES (5823, '59.76.15584905383351725', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:02:18', 172, 0, '', '2019-05-22 10:02:19');
INSERT INTO `access_log` VALUES (5824, '59.78.15584905383351729', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:02:18', 254, 2001001000, '服务端发生异常', '2019-05-22 10:02:19');
INSERT INTO `access_log` VALUES (5825, '65.45.15584905428220873', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:02:23', 1, 1002001015, '账号未登陆', '2019-05-22 10:02:23');
INSERT INTO `access_log` VALUES (5826, '65.54.15584905428220867', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:02:23', 1, 1002001015, '账号未登陆', '2019-05-22 10:02:23');
INSERT INTO `access_log` VALUES (5827, '65.49.15584905428310871', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:02:23', 1, 1002001015, '账号未登陆', '2019-05-22 10:02:23');
INSERT INTO `access_log` VALUES (5828, '65.52.15584905475530863', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:02:28', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 10:02:28');
INSERT INTO `access_log` VALUES (5829, '65.48.15584905574700867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:02:37', 74, 0, '', '2019-05-22 10:02:38');
INSERT INTO `access_log` VALUES (5830, '65.47.15584905578040869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:02:38', 20, 0, '', '2019-05-22 10:02:38');
INSERT INTO `access_log` VALUES (5831, '65.50.15584905578040869', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:02:38', 22, 0, '', '2019-05-22 10:02:38');
INSERT INTO `access_log` VALUES (5832, '65.46.15584905578120873', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:02:38', 16, 0, '', '2019-05-22 10:02:38');
INSERT INTO `access_log` VALUES (5833, '65.54.15584905751700869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:02:55', 20, 0, '', '2019-05-22 10:02:55');
INSERT INTO `access_log` VALUES (5834, '65.49.15584905751820873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:02:55', 15, 0, '', '2019-05-22 10:02:55');
INSERT INTO `access_log` VALUES (5835, '65.51.15584905751850865', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:02:55', 19, 0, '', '2019-05-22 10:02:55');
INSERT INTO `access_log` VALUES (5836, '62.84.15584905806551707', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:03:01', 30, 0, '', '2019-05-22 10:03:01');
INSERT INTO `access_log` VALUES (5837, '62.81.15584905934131701', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:03:13', 23, 0, '', '2019-05-22 10:03:13');
INSERT INTO `access_log` VALUES (5838, '64.80.15584906002730897', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:03:20', 94, 0, '', '2019-05-22 10:03:20');
INSERT INTO `access_log` VALUES (5839, '64.81.15584906002710897', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:03:20', 103, 0, '', '2019-05-22 10:03:20');
INSERT INTO `access_log` VALUES (5840, '64.82.15584906037630899', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:03:24', 16, 0, '', '2019-05-22 10:03:24');
INSERT INTO `access_log` VALUES (5841, '64.85.15584906037600899', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:03:24', 34, 0, '', '2019-05-22 10:03:24');
INSERT INTO `access_log` VALUES (5842, '64.77.15584906079930901', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:03:28', 36, 0, '', '2019-05-22 10:03:28');
INSERT INTO `access_log` VALUES (5843, '64.84.15584906079920899', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:03:28', 37, 0, '', '2019-05-22 10:03:28');
INSERT INTO `access_log` VALUES (5844, '64.76.15584906079960899', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:03:28', 56, 0, '', '2019-05-22 10:03:28');
INSERT INTO `access_log` VALUES (5845, '66.57.15584906180420821', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:03:38', 52, 0, '', '2019-05-22 10:03:38');
INSERT INTO `access_log` VALUES (5846, '59.72.15584906257311729', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:03:46', 18, 0, '', '2019-05-22 10:03:46');
INSERT INTO `access_log` VALUES (5847, '59.76.15584906368551727', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:03:57', 12, 1002002009, NULL, '2019-05-22 10:03:57');
INSERT INTO `access_log` VALUES (5848, '59.78.15584906435641731', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:04:04', 93, 2001001000, '服务端发生异常', '2019-05-22 10:04:04');
INSERT INTO `access_log` VALUES (5849, '59.79.15584906513021729', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:04:11', 27, 0, '', '2019-05-22 10:04:11');
INSERT INTO `access_log` VALUES (5850, '59.73.15584906618211733', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:04:22', 27, 0, '', '2019-05-22 10:04:22');
INSERT INTO `access_log` VALUES (5851, '59.71.15584906650261733', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:04:25', 55, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-22 10:04:25');
INSERT INTO `access_log` VALUES (5852, '65.45.15584906700270877', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:04:30', 40, 0, '', '2019-05-22 10:04:30');
INSERT INTO `access_log` VALUES (5853, '65.54.15584906730860871', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:04:33', 25, 0, '', '2019-05-22 10:04:33');
INSERT INTO `access_log` VALUES (5854, '65.49.15584906814360875', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:04:41', 148, 0, '', '2019-05-22 10:04:42');
INSERT INTO `access_log` VALUES (5855, '65.52.15584906842650867', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:04:44', 15, 0, '', '2019-05-22 10:04:44');
INSERT INTO `access_log` VALUES (5856, '65.48.15584906884730871', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:04:48', 22, 0, '', '2019-05-22 10:04:48');
INSERT INTO `access_log` VALUES (5857, '59.74.15584907033281733', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:05:03', 5, 0, '', '2019-05-22 10:05:03');
INSERT INTO `access_log` VALUES (5858, '59.76.15584907033281729', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:05:03', 148, 2001001000, '服务端发生异常', '2019-05-22 10:05:03');
INSERT INTO `access_log` VALUES (5859, '64.77.15584907104270903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:05:10', 5, 0, '', '2019-05-22 10:05:10');
INSERT INTO `access_log` VALUES (5860, '64.84.15584907105360901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:05:11', 4, 0, '', '2019-05-22 10:05:11');
INSERT INTO `access_log` VALUES (5861, '64.76.15584907118440901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:05:12', 4, 0, '', '2019-05-22 10:05:12');
INSERT INTO `access_log` VALUES (5862, '64.78.15584907126340901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:05:13', 3, 0, '', '2019-05-22 10:05:13');
INSERT INTO `access_log` VALUES (5863, '59.75.15584907139961733', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:05:14', 6, 0, '', '2019-05-22 10:05:14');
INSERT INTO `access_log` VALUES (5864, '59.79.15584907139971731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:05:14', 68, 2001001000, '服务端发生异常', '2019-05-22 10:05:14');
INSERT INTO `access_log` VALUES (5865, '65.52.15584909505160871', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-22 10:09:11', 244, 0, '', '2019-05-22 10:09:11');
INSERT INTO `access_log` VALUES (5866, '65.50.15584909511620877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-22 10:09:11', 16, 0, '', '2019-05-22 10:09:11');
INSERT INTO `access_log` VALUES (5867, '65.48.15584909511610875', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-22 10:09:11', 16, 0, '', '2019-05-22 10:09:11');
INSERT INTO `access_log` VALUES (5868, '65.46.15584909511630881', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-22 10:09:11', 33, 0, '', '2019-05-22 10:09:11');
INSERT INTO `access_log` VALUES (5869, '62.82.15584909565731709', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-22 10:09:17', 983, 0, '', '2019-05-22 10:09:18');
INSERT INTO `access_log` VALUES (5870, '62.85.15584909589961711', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-22 10:09:19', 26, 0, '', '2019-05-22 10:09:19');
INSERT INTO `access_log` VALUES (5871, '64.84.15584909613210905', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-22 10:09:21', 32, 0, '', '2019-05-22 10:09:21');
INSERT INTO `access_log` VALUES (5872, '64.76.15584909613210905', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-22 10:09:21', 25, 0, '', '2019-05-22 10:09:21');
INSERT INTO `access_log` VALUES (5873, '64.78.15584909650330905', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-22 10:09:25', 15, 0, '', '2019-05-22 10:09:25');
INSERT INTO `access_log` VALUES (5874, '59.78.15584909700601737', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-05-22 10:09:30', 21, 0, '', '2019-05-22 10:09:30');
INSERT INTO `access_log` VALUES (5875, '65.51.15584946289530921', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:10:29', 1, 1002001015, '账号未登陆', '2019-05-22 11:10:29');
INSERT INTO `access_log` VALUES (5876, '65.49.15584946289540931', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:10:29', 1, 1002001015, '账号未登陆', '2019-05-22 11:10:29');
INSERT INTO `access_log` VALUES (5877, '65.54.15584946289590925', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:10:29', 0, 1002001015, '账号未登陆', '2019-05-22 11:10:29');
INSERT INTO `access_log` VALUES (5878, '65.52.15584946309190921', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:10:31', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 11:10:31');
INSERT INTO `access_log` VALUES (5879, '65.48.15584946378030925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:10:38', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 11:10:38');
INSERT INTO `access_log` VALUES (5880, '65.50.15584946488540929', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:10:49', 106, 0, '', '2019-05-22 11:10:49');
INSERT INTO `access_log` VALUES (5881, '65.47.15584946492350927', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:10:49', 19, 0, '', '2019-05-22 11:10:49');
INSERT INTO `access_log` VALUES (5882, '65.45.15584946492430935', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:10:49', 18, 0, '', '2019-05-22 11:10:49');
INSERT INTO `access_log` VALUES (5883, '65.53.15584946492390925', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:10:49', 20, 0, '', '2019-05-22 11:10:49');
INSERT INTO `access_log` VALUES (5884, '62.83.15584946581301761', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:10:58', 35, 0, '', '2019-05-22 11:10:58');
INSERT INTO `access_log` VALUES (5885, '64.76.15584946664790955', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:11:06', 27, 0, '', '2019-05-22 11:11:07');
INSERT INTO `access_log` VALUES (5886, '64.84.15584946664790955', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:11:06', 42, 0, '', '2019-05-22 11:11:07');
INSERT INTO `access_log` VALUES (5887, '65.51.15584946760110923', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:11:16', 7, 0, '', '2019-05-22 11:11:16');
INSERT INTO `access_log` VALUES (5888, '64.82.15584947479450957', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:12:28', 33, 0, '', '2019-05-22 11:12:28');
INSERT INTO `access_log` VALUES (5889, '64.85.15584947479430957', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:12:28', 50, 0, '', '2019-05-22 11:12:28');
INSERT INTO `access_log` VALUES (5890, '64.77.15584947508300959', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:12:31', 20, 0, '', '2019-05-22 11:12:31');
INSERT INTO `access_log` VALUES (5891, '64.84.15584947518010957', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:12:32', 18, 0, '', '2019-05-22 11:12:32');
INSERT INTO `access_log` VALUES (5892, '64.76.15584947525920957', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:12:33', 21, 0, '', '2019-05-22 11:12:33');
INSERT INTO `access_log` VALUES (5893, '64.78.15584947531910957', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:12:33', 24, 0, '', '2019-05-22 11:12:33');
INSERT INTO `access_log` VALUES (5894, '64.81.15584947544730957', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:12:34', 18, 0, '', '2019-05-22 11:12:34');
INSERT INTO `access_log` VALUES (5895, '64.79.15584947544730959', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:12:34', 47, 0, '', '2019-05-22 11:12:35');
INSERT INTO `access_log` VALUES (5896, '64.85.15584947580890959', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:12:38', 18, 0, '', '2019-05-22 11:12:38');
INSERT INTO `access_log` VALUES (5897, '64.83.15584947580850957', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:12:38', 21, 0, '', '2019-05-22 11:12:38');
INSERT INTO `access_log` VALUES (5898, '64.77.15584947610150961', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:12:41', 18, 0, '', '2019-05-22 11:12:41');
INSERT INTO `access_log` VALUES (5899, '64.82.15584947610140959', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:12:41', 22, 0, '', '2019-05-22 11:12:41');
INSERT INTO `access_log` VALUES (5900, '66.54.15584947661190877', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:12:46', 71, 0, '', '2019-05-22 11:12:46');
INSERT INTO `access_log` VALUES (5901, '59.80.15584947932471787', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:13', 36, 0, '', '2019-05-22 11:13:13');
INSERT INTO `access_log` VALUES (5902, '59.72.15584947961261787', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:16', 125, 2001001000, '服务端发生异常', '2019-05-22 11:13:16');
INSERT INTO `access_log` VALUES (5903, '59.76.15584948023391785', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:22', 20, 0, '', '2019-05-22 11:13:22');
INSERT INTO `access_log` VALUES (5904, '59.78.15584948048621789', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:25', 25, 0, '', '2019-05-22 11:13:25');
INSERT INTO `access_log` VALUES (5905, '59.79.15584948158711787', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:36', 65, 0, '', '2019-05-22 11:13:36');
INSERT INTO `access_log` VALUES (5906, '59.77.15584948166571789', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:37', 18, 0, '', '2019-05-22 11:13:37');
INSERT INTO `access_log` VALUES (5907, '59.73.15584948173601791', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:37', 23, 0, '', '2019-05-22 11:13:37');
INSERT INTO `access_log` VALUES (5908, '59.71.15584948179711791', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=INVALID&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:38', 17, 0, '', '2019-05-22 11:13:38');
INSERT INTO `access_log` VALUES (5909, '59.80.15584948187111789', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:39', 19, 0, '', '2019-05-22 11:13:39');
INSERT INTO `access_log` VALUES (5910, '59.72.15584948191001789', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:39', 19, 0, '', '2019-05-22 11:13:39');
INSERT INTO `access_log` VALUES (5911, '59.74.15584948195391791', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:40', 17, 0, '', '2019-05-22 11:13:40');
INSERT INTO `access_log` VALUES (5912, '59.76.15584948199691787', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:40', 18, 0, '', '2019-05-22 11:13:40');
INSERT INTO `access_log` VALUES (5913, '59.78.15584948204551791', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:40', 16, 0, '', '2019-05-22 11:13:40');
INSERT INTO `access_log` VALUES (5914, '59.75.15584948209931791', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:41', 20, 0, '', '2019-05-22 11:13:41');
INSERT INTO `access_log` VALUES (5915, '59.79.15584948219851789', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:42', 20, 0, '', '2019-05-22 11:13:42');
INSERT INTO `access_log` VALUES (5916, '59.77.15584948225421791', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:43', 17, 0, '', '2019-05-22 11:13:43');
INSERT INTO `access_log` VALUES (5917, '59.75.15584949316191793', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:15:32', 74, 0, '', '2019-05-22 11:15:32');
INSERT INTO `access_log` VALUES (5918, '59.72.15584953080711797', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:21:48', 9, 0, '', '2019-05-22 11:21:48');
INSERT INTO `access_log` VALUES (5919, '59.74.15584953080721799', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:21:48', 115, 2001001000, '服务端发生异常', '2019-05-22 11:21:48');
INSERT INTO `access_log` VALUES (5920, '64.85.15584953165950967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:21:57', 5, 0, '', '2019-05-22 11:21:57');
INSERT INTO `access_log` VALUES (5921, '64.82.15584953167230967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:21:57', 4, 0, '', '2019-05-22 11:21:57');
INSERT INTO `access_log` VALUES (5922, '64.77.15584953214940969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:01', 8, 0, '', '2019-05-22 11:22:02');
INSERT INTO `access_log` VALUES (5923, '64.84.15584953216510967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:02', 4, 0, '', '2019-05-22 11:22:02');
INSERT INTO `access_log` VALUES (5924, '59.78.15584953224501799', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:02', 46, 0, '', '2019-05-22 11:22:02');
INSERT INTO `access_log` VALUES (5925, '59.75.15584953224501799', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:02', 462, 2001001000, '服务端发生异常', '2019-05-22 11:22:03');
INSERT INTO `access_log` VALUES (5926, '64.76.15584953249450967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:05', 4, 0, '', '2019-05-22 11:22:05');
INSERT INTO `access_log` VALUES (5927, '64.78.15584953250710967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:05', 4, 0, '', '2019-05-22 11:22:05');
INSERT INTO `access_log` VALUES (5928, '59.77.15584953269051799', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:07', 5, 0, '', '2019-05-22 11:22:07');
INSERT INTO `access_log` VALUES (5929, '59.73.15584953269051801', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:07', 26, 2001001000, '服务端发生异常', '2019-05-22 11:22:07');
INSERT INTO `access_log` VALUES (5930, '64.79.15584953286620969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:09', 3, 0, '', '2019-05-22 11:22:09');
INSERT INTO `access_log` VALUES (5931, '64.80.15584953287590967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:09', 3, 0, '', '2019-05-22 11:22:09');
INSERT INTO `access_log` VALUES (5932, '64.83.15584953300700967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:10', 4, 0, '', '2019-05-22 11:22:10');
INSERT INTO `access_log` VALUES (5933, '64.85.15584953308550969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:11', 4, 0, '', '2019-05-22 11:22:11');
INSERT INTO `access_log` VALUES (5934, '64.82.15584953315420969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:12', 4, 0, '', '2019-05-22 11:22:12');
INSERT INTO `access_log` VALUES (5935, '64.77.15584953322240971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:12', 4, 0, '', '2019-05-22 11:22:12');
INSERT INTO `access_log` VALUES (5936, '64.84.15584953328180969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:13', 4, 0, '', '2019-05-22 11:22:13');
INSERT INTO `access_log` VALUES (5937, '64.76.15584953336020969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:14', 3, 0, '', '2019-05-22 11:22:14');
INSERT INTO `access_log` VALUES (5938, '64.78.15584953339530969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:14', 3, 0, '', '2019-05-22 11:22:14');
INSERT INTO `access_log` VALUES (5939, '64.81.15584953342810969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:14', 4, 0, '', '2019-05-22 11:22:14');
INSERT INTO `access_log` VALUES (5940, '64.79.15584953350210971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:15', 4, 0, '', '2019-05-22 11:22:15');
INSERT INTO `access_log` VALUES (5941, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:15', 42, 0, '', '2019-05-22 11:22:15');
INSERT INTO `access_log` VALUES (5942, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:17', 7, 0, '', '2019-05-22 11:22:17');
INSERT INTO `access_log` VALUES (5943, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:18', 49, 0, '', '2019-05-22 11:22:18');
INSERT INTO `access_log` VALUES (5944, '64.83.15584953407540969', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.161.16.164', '2019-05-22 11:22:21', 15, 0, '', '2019-05-22 11:22:21');
INSERT INTO `access_log` VALUES (5945, '59.74.15584953795291801', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:23:00', 19, 0, '', '2019-05-22 11:23:00');
INSERT INTO `access_log` VALUES (5946, '64.77.15584953811470973', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:23:01', 23, 0, '', '2019-05-22 11:23:01');
INSERT INTO `access_log` VALUES (5947, '64.76.15584953883280971', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:23:08', 16, 0, '', '2019-05-22 11:23:08');
INSERT INTO `access_log` VALUES (5948, '64.78.15584953897880971', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:23:10', 15, 0, '', '2019-05-22 11:23:10');
INSERT INTO `access_log` VALUES (5949, '64.81.15584953913380971', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:23:11', 424, 0, '', '2019-05-22 11:23:12');
INSERT INTO `access_log` VALUES (5950, '66.57.15584953930270885', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:23:13', 50, 0, '', '2019-05-22 11:23:13');
INSERT INTO `access_log` VALUES (5951, '66.48.15584953942740887', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:23:14', 42, 0, '', '2019-05-22 11:23:14');
INSERT INTO `access_log` VALUES (5952, '62.82.15584953999711769', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:23:20', 51, 0, '', '2019-05-22 11:23:20');
INSERT INTO `access_log` VALUES (5953, '62.86.15584954020301767', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:23:22', 22, 0, '', '2019-05-22 11:23:22');
INSERT INTO `access_log` VALUES (5954, '64.80.15584954042370971', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:23:24', 16, 0, '', '2019-05-22 11:23:24');
INSERT INTO `access_log` VALUES (5955, '65.49.15584954160420945', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:23:36', 27, 0, '', '2019-05-22 11:23:36');
INSERT INTO `access_log` VALUES (5956, '65.52.15584954204550935', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:23:40', 15, 0, '', '2019-05-22 11:23:40');
INSERT INTO `access_log` VALUES (5957, '65.48.15584954242080939', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:23:44', 15, 0, '', '2019-05-22 11:23:44');
INSERT INTO `access_log` VALUES (5958, '65.47.15584954426620937', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:24:03', 21, 0, '', '2019-05-22 11:24:03');
INSERT INTO `access_log` VALUES (5959, '65.54.15584954702590941', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:24:30', 15, 0, '', '2019-05-22 11:24:30');
INSERT INTO `access_log` VALUES (5960, '59.73.15584975373561831', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 11:58:57', 34, 0, '', '2019-05-22 11:58:57');
INSERT INTO `access_log` VALUES (5961, '59.77.15584975373561829', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 11:58:57', 56, 2001001000, '服务端发生异常', '2019-05-22 11:58:57');
INSERT INTO `access_log` VALUES (5962, '65.54.15584975538370969', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 11:59:14', 1, 1002001015, '账号未登陆', '2019-05-22 11:59:14');
INSERT INTO `access_log` VALUES (5963, '65.53.15584975538380967', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 11:59:14', 1, 1002001015, '账号未登陆', '2019-05-22 11:59:14');
INSERT INTO `access_log` VALUES (5964, '65.49.15584975538420975', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 11:59:14', 1, 1002001015, '账号未登陆', '2019-05-22 11:59:14');
INSERT INTO `access_log` VALUES (5965, '65.51.15584975582990963', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 11:59:18', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 11:59:18');
INSERT INTO `access_log` VALUES (5966, '65.48.15584975657220969', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 11:59:26', 315, 0, '', '2019-05-22 11:59:26');
INSERT INTO `access_log` VALUES (5967, '65.46.15584975663490977', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 11:59:26', 17, 0, '', '2019-05-22 11:59:26');
INSERT INTO `access_log` VALUES (5968, '65.47.15584975663520967', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 11:59:26', 17, 0, '', '2019-05-22 11:59:26');
INSERT INTO `access_log` VALUES (5969, '65.50.15584975663540971', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 11:59:26', 16, 0, '', '2019-05-22 11:59:26');
INSERT INTO `access_log` VALUES (5970, '62.80.15584975740181801', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 11:59:34', 30, 0, '', '2019-05-22 11:59:34');
INSERT INTO `access_log` VALUES (5971, '62.83.15584975798251801', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 11:59:40', 26, 0, '', '2019-05-22 11:59:40');
INSERT INTO `access_log` VALUES (5972, '64.81.15584976166471001', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 12:00:17', 28, 0, '', '2019-05-22 12:00:17');
INSERT INTO `access_log` VALUES (5973, '59.75.15584976191271831', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 12:00:19', 18, 0, '', '2019-05-22 12:00:19');
INSERT INTO `access_log` VALUES (5974, '59.79.15584976264921829', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 12:00:26', 88, 2001001000, '服务端发生异常', '2019-05-22 12:00:27');
INSERT INTO `access_log` VALUES (5975, '65.51.15584976305910965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 12:00:31', 19, 0, '', '2019-05-22 12:00:31');
INSERT INTO `access_log` VALUES (5976, '66.50.15584976398230917', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 12:00:40', 32, 0, '', '2019-05-22 12:00:40');
INSERT INTO `access_log` VALUES (5977, '64.85.15584976529631003', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 12:00:53', 17, 0, '', '2019-05-22 12:00:53');
INSERT INTO `access_log` VALUES (5978, '62.81.15584976566801797', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 12:00:57', 51, 0, '', '2019-05-22 12:00:57');
INSERT INTO `access_log` VALUES (5979, '62.80.15584976666821803', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 12:01:07', 22, 0, '', '2019-05-22 12:01:07');
INSERT INTO `access_log` VALUES (5980, '64.77.15584976674351005', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 12:01:07', 15, 0, '', '2019-05-22 12:01:07');
INSERT INTO `access_log` VALUES (5981, '59.78.15584998160131861', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.95.144.62', '2019-05-22 12:36:56', 30, 2001001000, '服务端发生异常', '2019-05-22 12:36:56');
INSERT INTO `access_log` VALUES (5982, '59.76.15584998160131857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.95.144.62', '2019-05-22 12:36:56', 97, 0, '', '2019-05-22 12:36:56');
INSERT INTO `access_log` VALUES (5983, '64.81.15584998197411031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.95.144.62', '2019-05-22 12:37:00', 13, 0, '', '2019-05-22 12:37:00');
INSERT INTO `access_log` VALUES (5984, '64.79.15584998198671033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.95.144.62', '2019-05-22 12:37:00', 4, 0, '', '2019-05-22 12:37:00');
INSERT INTO `access_log` VALUES (5985, '64.80.15584998208691031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.95.144.62', '2019-05-22 12:37:01', 4, 0, '', '2019-05-22 12:37:01');
INSERT INTO `access_log` VALUES (5986, '64.83.15584998222031031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.95.144.62', '2019-05-22 12:37:02', 4, 0, '', '2019-05-22 12:37:02');
INSERT INTO `access_log` VALUES (5987, '64.85.15584998227651033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.95.144.62', '2019-05-22 12:37:03', 3, 0, '', '2019-05-22 12:37:03');
INSERT INTO `access_log` VALUES (5988, '64.82.15584998231081033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.95.144.62', '2019-05-22 12:37:03', 5, 0, '', '2019-05-22 12:37:03');
INSERT INTO `access_log` VALUES (5989, '59.79.15584998240361859', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.95.144.62', '2019-05-22 12:37:04', 5, 0, '', '2019-05-22 12:37:04');
INSERT INTO `access_log` VALUES (5990, '59.75.15584998240361861', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.95.144.62', '2019-05-22 12:37:04', 24, 2001001000, '服务端发生异常', '2019-05-22 12:37:04');
INSERT INTO `access_log` VALUES (5991, '64.84.15584998359771033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.95.144.62', '2019-05-22 12:37:16', 4, 0, '', '2019-05-22 12:37:16');
INSERT INTO `access_log` VALUES (5992, '64.76.15584998360921033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.95.144.62', '2019-05-22 12:37:16', 3, 0, '', '2019-05-22 12:37:16');
INSERT INTO `access_log` VALUES (5993, '59.78.15585000548271865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:40:55', 8, 0, '', '2019-05-22 12:40:55');
INSERT INTO `access_log` VALUES (5994, '59.76.15585000548271861', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:40:55', 26, 2001001000, '服务端发生异常', '2019-05-22 12:40:55');
INSERT INTO `access_log` VALUES (5995, '64.85.15585000581021037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:40:58', 5, 0, '', '2019-05-22 12:40:58');
INSERT INTO `access_log` VALUES (5996, '64.82.15585000583281037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:40:58', 4, 0, '', '2019-05-22 12:40:58');
INSERT INTO `access_log` VALUES (5997, '64.77.15585000593061039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:40:59', 560, 0, '', '2019-05-22 12:41:00');
INSERT INTO `access_log` VALUES (5998, '64.84.15585000600701037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:41:00', 3, 0, '', '2019-05-22 12:41:00');
INSERT INTO `access_log` VALUES (5999, '64.76.15585000624661037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:41:02', 4, 0, '', '2019-05-22 12:41:02');
INSERT INTO `access_log` VALUES (6000, '64.78.15585000632021037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:41:03', 4, 0, '', '2019-05-22 12:41:03');
INSERT INTO `access_log` VALUES (6001, '64.81.15585000638281037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:41:04', 4, 0, '', '2019-05-22 12:41:04');
INSERT INTO `access_log` VALUES (6002, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=手机&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:41:12', 84, 0, '', '2019-05-22 12:41:12');
INSERT INTO `access_log` VALUES (6003, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=手机', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:41:12', 157, 0, '', '2019-05-22 12:41:12');
INSERT INTO `access_log` VALUES (6004, '64.80.15585000762791037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:41:16', 4, 0, '', '2019-05-22 12:41:16');
INSERT INTO `access_log` VALUES (6005, '64.83.15585000763771037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:41:16', 4, 0, '', '2019-05-22 12:41:16');
INSERT INTO `access_log` VALUES (6006, '59.79.15585000769251863', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:41:17', 4, 0, '', '2019-05-22 12:41:17');
INSERT INTO `access_log` VALUES (6007, '59.75.15585000769251865', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.84', '2019-05-22 12:41:17', 15, 2001001000, '服务端发生异常', '2019-05-22 12:41:17');
INSERT INTO `access_log` VALUES (6008, '59.74.15585032697001909', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5603.400 QQBrowser/10.1.1775.400', '116.238.34.200', '2019-05-22 13:34:30', 26, 2001001000, '服务端发生异常', '2019-05-22 13:34:30');
INSERT INTO `access_log` VALUES (6009, '59.72.15585032696991907', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5603.400 QQBrowser/10.1.1775.400', '116.238.34.200', '2019-05-22 13:34:30', 789, 0, '', '2019-05-22 13:34:30');
INSERT INTO `access_log` VALUES (6010, '59.74.15585032697001909', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5603.400 QQBrowser/10.1.1775.400', '116.238.34.200', '2019-05-22 13:34:30', 26, 2001001000, '服务端发生异常', '2019-05-22 13:34:31');
INSERT INTO `access_log` VALUES (6011, '59.78.15585047705641929', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:31', 6, 0, '', '2019-05-22 13:59:31');
INSERT INTO `access_log` VALUES (6012, '59.76.15585047705691925', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:31', 21, 2001001000, '服务端发生异常', '2019-05-22 13:59:31');
INSERT INTO `access_log` VALUES (6013, '64.85.15585047733421101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:33', 13, 0, '', '2019-05-22 13:59:33');
INSERT INTO `access_log` VALUES (6014, '64.83.15585047734811099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:33', 4, 0, '', '2019-05-22 13:59:33');
INSERT INTO `access_log` VALUES (6015, '64.84.15585047745361103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:35', 4, 0, '', '2019-05-22 13:59:35');
INSERT INTO `access_log` VALUES (6016, '64.77.15585047750521105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:35', 4, 0, '', '2019-05-22 13:59:35');
INSERT INTO `access_log` VALUES (6017, '64.76.15585047754591103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:35', 4, 0, '', '2019-05-22 13:59:35');
INSERT INTO `access_log` VALUES (6018, '64.78.15585047758031103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:36', 3, 0, '', '2019-05-22 13:59:36');
INSERT INTO `access_log` VALUES (6019, '64.81.15585047762851103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:36', 6, 0, '', '2019-05-22 13:59:36');
INSERT INTO `access_log` VALUES (6020, '64.79.15585047765561105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:37', 3, 0, '', '2019-05-22 13:59:37');
INSERT INTO `access_log` VALUES (6021, '64.80.15585047770801103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:37', 4, 0, '', '2019-05-22 13:59:37');
INSERT INTO `access_log` VALUES (6022, '64.85.15585047772911103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:37', 4, 0, '', '2019-05-22 13:59:37');
INSERT INTO `access_log` VALUES (6023, '59.79.15585047780881927', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:38', 4, 0, '', '2019-05-22 13:59:38');
INSERT INTO `access_log` VALUES (6024, '59.75.15585047780881929', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:38', 25, 2001001000, '服务端发生异常', '2019-05-22 13:59:38');
INSERT INTO `access_log` VALUES (6025, '64.83.15585047805241101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:41', 36, 0, '', '2019-05-22 13:59:41');
INSERT INTO `access_log` VALUES (6026, '64.84.15585047807181105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:41', 195, 0, '', '2019-05-22 13:59:41');
INSERT INTO `access_log` VALUES (6027, '64.77.15585047819381107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:42', 3, 0, '', '2019-05-22 13:59:42');
INSERT INTO `access_log` VALUES (6028, '64.82.15585047826211103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:43', 4, 0, '', '2019-05-22 13:59:43');
INSERT INTO `access_log` VALUES (6029, '64.76.15585047833721105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:43', 132, 0, '', '2019-05-22 13:59:44');
INSERT INTO `access_log` VALUES (6030, '64.78.15585047837291105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:44', 3, 0, '', '2019-05-22 13:59:44');
INSERT INTO `access_log` VALUES (6031, '59.77.15585047847931929', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:45', 46, 0, '', '2019-05-22 13:59:45');
INSERT INTO `access_log` VALUES (6032, '59.71.15585047847931931', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:45', 79, 2001001000, '服务端发生异常', '2019-05-22 13:59:45');
INSERT INTO `access_log` VALUES (6033, '64.81.15585047878211105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:48', 4, 0, '', '2019-05-22 13:59:48');
INSERT INTO `access_log` VALUES (6034, '64.79.15585047879521107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.129.212.54', '2019-05-22 13:59:48', 4, 0, '', '2019-05-22 13:59:48');
INSERT INTO `access_log` VALUES (6035, '59.76.15585055954241937', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.61.172.52', '2019-05-22 14:13:15', 5, 0, '', '2019-05-22 14:13:15');
INSERT INTO `access_log` VALUES (6036, '59.73.15585055954251943', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.61.172.52', '2019-05-22 14:13:15', 55, 2001001000, '服务端发生异常', '2019-05-22 14:13:15');
INSERT INTO `access_log` VALUES (6037, '59.77.15585056015141941', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.61.172.52', '2019-05-22 14:13:22', 14, 2001001000, '服务端发生异常', '2019-05-22 14:13:22');
INSERT INTO `access_log` VALUES (6038, '59.75.15585056015141941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.61.172.52', '2019-05-22 14:13:22', 186, 0, '', '2019-05-22 14:13:22');
INSERT INTO `access_log` VALUES (6039, '65.46.15585056070481087', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.61.172.52', '2019-05-22 14:13:27', 1, 1002001015, '账号未登陆', '2019-05-22 14:13:27');
INSERT INTO `access_log` VALUES (6040, '65.51.15585056070481073', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.61.172.52', '2019-05-22 14:13:27', 1, 1002001015, '账号未登陆', '2019-05-22 14:13:27');
INSERT INTO `access_log` VALUES (6041, '65.47.15585056070601079', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.61.172.52', '2019-05-22 14:13:27', 0, 1002001015, '账号未登陆', '2019-05-22 14:13:27');
INSERT INTO `access_log` VALUES (6042, '65.52.15585056085041077', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.61.172.52', '2019-05-22 14:13:29', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 14:13:29');
INSERT INTO `access_log` VALUES (6043, '65.45.15585066518291097', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:30:52', 0, 1002001015, '账号未登陆', '2019-05-22 14:30:52');
INSERT INTO `access_log` VALUES (6044, '65.50.15585066518291093', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:30:52', 0, 1002001015, '账号未登陆', '2019-05-22 14:30:52');
INSERT INTO `access_log` VALUES (6045, '65.52.15585066518291091', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:30:52', 1, 1002001015, '账号未登陆', '2019-05-22 14:30:52');
INSERT INTO `access_log` VALUES (6046, '65.48.15585066583861095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:30:58', 99, 0, '', '2019-05-22 14:30:58');
INSERT INTO `access_log` VALUES (6047, '65.54.15585066589081095', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:30:59', 246, 0, '', '2019-05-22 14:30:59');
INSERT INTO `access_log` VALUES (6048, '65.46.15585066589311103', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:30:59', 226, 0, '', '2019-05-22 14:30:59');
INSERT INTO `access_log` VALUES (6049, '65.49.15585066589121099', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:30:59', 246, 0, '', '2019-05-22 14:30:59');
INSERT INTO `access_log` VALUES (6050, '62.89.15585066731941921', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:31:13', 55, 0, '', '2019-05-22 14:31:13');
INSERT INTO `access_log` VALUES (6051, '62.83.15585066800521923', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:31:20', 26, 0, '', '2019-05-22 14:31:20');
INSERT INTO `access_log` VALUES (6052, '62.82.15585066809941921', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:31:21', 19, 0, '', '2019-05-22 14:31:21');
INSERT INTO `access_log` VALUES (6053, '62.86.15585066817221919', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=4&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:31:22', 19, 0, '', '2019-05-22 14:31:22');
INSERT INTO `access_log` VALUES (6054, '62.84.15585066823411925', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=5&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:31:22', 19, 0, '', '2019-05-22 14:31:22');
INSERT INTO `access_log` VALUES (6055, '62.88.15585066830871925', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=6&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:31:23', 17, 0, '', '2019-05-22 14:31:23');
INSERT INTO `access_log` VALUES (6056, '62.87.15585067024901925', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:31:42', 21, 0, '', '2019-05-22 14:31:43');
INSERT INTO `access_log` VALUES (6057, '64.80.15585067136691131', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:31:54', 26, 0, '', '2019-05-22 14:31:54');
INSERT INTO `access_log` VALUES (6058, '64.79.15585067136641133', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:31:54', 33, 0, '', '2019-05-22 14:31:54');
INSERT INTO `access_log` VALUES (6059, '64.84.15585067314821133', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:32:11', 23, 0, '', '2019-05-22 14:32:12');
INSERT INTO `access_log` VALUES (6060, '64.83.15585067314801129', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:32:11', 30, 0, '', '2019-05-22 14:32:12');
INSERT INTO `access_log` VALUES (6061, '64.77.15585067354421135', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:32:15', 78, 0, '', '2019-05-22 14:32:16');
INSERT INTO `access_log` VALUES (6062, '64.82.15585067365831131', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:32:17', 16, 0, '', '2019-05-22 14:32:17');
INSERT INTO `access_log` VALUES (6063, '64.76.15585067393491133', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:32:19', 20, 0, '', '2019-05-22 14:32:19');
INSERT INTO `access_log` VALUES (6064, '59.79.15585067589991955', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:32:39', 380, 0, '', '2019-05-22 14:32:39');
INSERT INTO `access_log` VALUES (6065, '65.49.15585067645201101', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:32:45', 27, 0, '', '2019-05-22 14:32:45');
INSERT INTO `access_log` VALUES (6066, '65.54.15585067709931097', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:32:51', 19, 0, '', '2019-05-22 14:32:51');
INSERT INTO `access_log` VALUES (6067, '65.51.15585067753371091', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-05-22 14:32:55', 17, 0, '', '2019-05-22 14:32:55');
INSERT INTO `access_log` VALUES (6068, '59.79.15585070308211959', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:11', 5, 0, '', '2019-05-22 14:37:11');
INSERT INTO `access_log` VALUES (6069, '59.73.15585070308201963', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:11', 15, 2001001000, '服务端发生异常', '2019-05-22 14:37:11');
INSERT INTO `access_log` VALUES (6070, '64.78.15585070370251137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:17', 4, 0, '', '2019-05-22 14:37:17');
INSERT INTO `access_log` VALUES (6071, '64.81.15585070371441137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:17', 4, 0, '', '2019-05-22 14:37:17');
INSERT INTO `access_log` VALUES (6072, '64.80.15585070382341137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:18', 4, 0, '', '2019-05-22 14:37:18');
INSERT INTO `access_log` VALUES (6073, '64.79.15585070387431139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:19', 4, 0, '', '2019-05-22 14:37:19');
INSERT INTO `access_log` VALUES (6074, '59.77.15585070400051961', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:20', 5, 0, '', '2019-05-22 14:37:20');
INSERT INTO `access_log` VALUES (6075, '59.71.15585070400071963', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:20', 66, 2001001000, '服务端发生异常', '2019-05-22 14:37:20');
INSERT INTO `access_log` VALUES (6076, '64.84.15585070546591139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:35', 35, 0, '', '2019-05-22 14:37:35');
INSERT INTO `access_log` VALUES (6077, '64.83.15585070548341135', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:35', 4, 0, '', '2019-05-22 14:37:35');
INSERT INTO `access_log` VALUES (6078, '59.72.15585070576231961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:38', 16, 2001001000, '服务端发生异常', '2019-05-22 14:37:38');
INSERT INTO `access_log` VALUES (6079, '59.74.15585070576231963', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:38', 403, 0, '', '2019-05-22 14:37:38');
INSERT INTO `access_log` VALUES (6080, '64.82.15585070603481137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:40', 4, 0, '', '2019-05-22 14:37:40');
INSERT INTO `access_log` VALUES (6081, '64.76.15585070604771139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:40', 3, 0, '', '2019-05-22 14:37:40');
INSERT INTO `access_log` VALUES (6082, '59.78.15585070632461963', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:43', 4, 0, '', '2019-05-22 14:37:43');
INSERT INTO `access_log` VALUES (6083, '59.76.15585070632481959', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:43', 15, 2001001000, '服务端发生异常', '2019-05-22 14:37:43');
INSERT INTO `access_log` VALUES (6084, '64.78.15585070639891139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:44', 289, 0, '', '2019-05-22 14:37:44');
INSERT INTO `access_log` VALUES (6085, '64.81.15585070644491139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:44', 4, 0, '', '2019-05-22 14:37:44');
INSERT INTO `access_log` VALUES (6086, '59.79.15585070645831961', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:45', 4, 0, '', '2019-05-22 14:37:45');
INSERT INTO `access_log` VALUES (6087, '59.73.15585070646181965', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:45', 14, 2001001000, '服务端发生异常', '2019-05-22 14:37:45');
INSERT INTO `access_log` VALUES (6088, '65.47.15585070740951101', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:54', 0, 1002001015, '账号未登陆', '2019-05-22 14:37:54');
INSERT INTO `access_log` VALUES (6089, '65.45.15585070740951105', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:54', 0, 1002001015, '账号未登陆', '2019-05-22 14:37:54');
INSERT INTO `access_log` VALUES (6090, '65.50.15585070741031101', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:37:54', 1, 1002001015, '账号未登陆', '2019-05-22 14:37:54');
INSERT INTO `access_log` VALUES (6091, '65.52.15585070853151099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:38:05', 119, 0, '', '2019-05-22 14:38:05');
INSERT INTO `access_log` VALUES (6092, '65.48.15585070856871103', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:38:06', 62, 0, '', '2019-05-22 14:38:06');
INSERT INTO `access_log` VALUES (6093, '65.53.15585070856831099', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:38:06', 66, 0, '', '2019-05-22 14:38:06');
INSERT INTO `access_log` VALUES (6094, '65.49.15585070856881107', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:38:06', 60, 0, '', '2019-05-22 14:38:06');
INSERT INTO `access_log` VALUES (6095, '62.81.15585070918761925', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:38:12', 20, 0, '', '2019-05-22 14:38:12');
INSERT INTO `access_log` VALUES (6096, '64.84.15585070996661141', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:38:20', 219, 0, '', '2019-05-22 14:38:20');
INSERT INTO `access_log` VALUES (6097, '64.85.15585070996611139', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:38:20', 223, 0, '', '2019-05-22 14:38:20');
INSERT INTO `access_log` VALUES (6098, '59.74.15585071231611965', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:38:43', 271, 0, '', '2019-05-22 14:38:43');
INSERT INTO `access_log` VALUES (6099, '59.78.15585071317921965', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:38:52', 137, 2001001000, '服务端发生异常', '2019-05-22 14:38:52');
INSERT INTO `access_log` VALUES (6100, '59.76.15585071374431961', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:38:57', 17, 0, '', '2019-05-22 14:38:57');
INSERT INTO `access_log` VALUES (6101, '65.47.15585071501411103', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:39:10', 31, 0, '', '2019-05-22 14:39:10');
INSERT INTO `access_log` VALUES (6102, '65.52.15585071537421101', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:39:14', 84, 0, '', '2019-05-22 14:39:14');
INSERT INTO `access_log` VALUES (6103, '65.48.15585071652221105', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:39:25', 41, 0, '', '2019-05-22 14:39:25');
INSERT INTO `access_log` VALUES (6104, '65.53.15585071664761101', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:39:26', 140, 0, '', '2019-05-22 14:39:27');
INSERT INTO `access_log` VALUES (6105, '65.54.15585071682971105', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:39:28', 24, 0, '', '2019-05-22 14:39:28');
INSERT INTO `access_log` VALUES (6106, '65.46.15585071704221113', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:39:30', 49, 0, '', '2019-05-22 14:39:30');
INSERT INTO `access_log` VALUES (6107, '65.51.15585071761601099', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:39:36', 19, 0, '', '2019-05-22 14:39:36');
INSERT INTO `access_log` VALUES (6108, '65.47.15585071990171105', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:39:59', 12, 0, '', '2019-05-22 14:39:59');
INSERT INTO `access_log` VALUES (6109, '65.49.15585072158381111', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:40:16', 14, 0, '', '2019-05-22 14:40:16');
INSERT INTO `access_log` VALUES (6110, '65.48.15585072185501107', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:40:19', 26, 0, '', '2019-05-22 14:40:19');
INSERT INTO `access_log` VALUES (6111, '65.51.15585072569101101', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:40:57', 12, 0, '', '2019-05-22 14:40:57');
INSERT INTO `access_log` VALUES (6112, '65.50.15585072569181107', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:40:57', 11, 0, '', '2019-05-22 14:40:57');
INSERT INTO `access_log` VALUES (6113, '65.45.15585072569281111', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:40:57', 10, 0, '', '2019-05-22 14:40:57');
INSERT INTO `access_log` VALUES (6114, '65.47.15585072614161107', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:41:01', 12, 0, '', '2019-05-22 14:41:01');
INSERT INTO `access_log` VALUES (6115, '65.52.15585072614181105', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:41:01', 12, 0, '', '2019-05-22 14:41:01');
INSERT INTO `access_log` VALUES (6116, '65.49.15585072614231113', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:41:01', 12, 0, '', '2019-05-22 14:41:01');
INSERT INTO `access_log` VALUES (6117, '62.83.15585072646911933', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:41:05', 93, 0, '', '2019-05-22 14:41:05');
INSERT INTO `access_log` VALUES (6118, '59.72.15585073872521967', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-22 14:43:07', 5, 0, '', '2019-05-22 14:43:07');
INSERT INTO `access_log` VALUES (6119, '59.78.15585073872551969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-22 14:43:07', 15, 2001001000, '服务端发生异常', '2019-05-22 14:43:07');
INSERT INTO `access_log` VALUES (6120, '64.85.15585073986091143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:19', 4, 0, '', '2019-05-22 14:43:19');
INSERT INTO `access_log` VALUES (6121, '64.77.15585073991001147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:19', 3, 0, '', '2019-05-22 14:43:19');
INSERT INTO `access_log` VALUES (6122, '59.79.15585074085051967', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:29', 4, 0, '', '2019-05-22 14:43:29');
INSERT INTO `access_log` VALUES (6123, '59.73.15585074085091971', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:29', 20, 2001001000, '服务端发生异常', '2019-05-22 14:43:29');
INSERT INTO `access_log` VALUES (6124, '64.76.15585074153021145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:35', 4, 0, '', '2019-05-22 14:43:35');
INSERT INTO `access_log` VALUES (6125, '64.78.15585074154471145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:35', 4, 0, '', '2019-05-22 14:43:35');
INSERT INTO `access_log` VALUES (6126, '64.80.15585074184231145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:38', 3, 0, '', '2019-05-22 14:43:38');
INSERT INTO `access_log` VALUES (6127, '64.79.15585074185131147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:39', 3, 0, '', '2019-05-22 14:43:39');
INSERT INTO `access_log` VALUES (6128, '59.80.15585074310291969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:51', 40, 2001001000, '服务端发生异常', '2019-05-22 14:43:51');
INSERT INTO `access_log` VALUES (6129, '59.71.15585074310271971', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:51', 149, 0, '', '2019-05-22 14:43:51');
INSERT INTO `access_log` VALUES (6130, '64.84.15585074333651147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:53', 4, 0, '', '2019-05-22 14:43:53');
INSERT INTO `access_log` VALUES (6131, '64.85.15585074335021145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:54', 4, 0, '', '2019-05-22 14:43:54');
INSERT INTO `access_log` VALUES (6132, '64.77.15585074345061149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:55', 4, 0, '', '2019-05-22 14:43:55');
INSERT INTO `access_log` VALUES (6133, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:55', 27, 0, '', '2019-05-22 14:43:55');
INSERT INTO `access_log` VALUES (6134, '64.82.15585074393611145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:59', 3, 0, '', '2019-05-22 14:43:59');
INSERT INTO `access_log` VALUES (6135, '64.76.15585074394591147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:43:59', 10, 0, '', '2019-05-22 14:43:59');
INSERT INTO `access_log` VALUES (6136, '59.72.15585074500441969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:44:10', 22, 2001001000, '服务端发生异常', '2019-05-22 14:44:10');
INSERT INTO `access_log` VALUES (6137, '59.78.15585074500441971', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:44:10', 179, 0, '', '2019-05-22 14:44:10');
INSERT INTO `access_log` VALUES (6138, '59.76.15585074514121967', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '223.166.151.191', '2019-05-22 14:44:11', 15, 2001001000, '服务端发生异常', '2019-05-22 14:44:11');
INSERT INTO `access_log` VALUES (6139, '59.79.15585074520461969', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '223.166.151.197', '2019-05-22 14:44:12', 124, 0, '', '2019-05-22 14:44:12');
INSERT INTO `access_log` VALUES (6140, '64.78.15585074550551147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:44:15', 53, 0, '', '2019-05-22 14:44:15');
INSERT INTO `access_log` VALUES (6141, '64.80.15585074552331147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:44:15', 4, 0, '', '2019-05-22 14:44:15');
INSERT INTO `access_log` VALUES (6142, '64.79.15585074600821149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '210.22.245.226', '2019-05-22 14:44:20', 4, 0, '', '2019-05-22 14:44:20');
INSERT INTO `access_log` VALUES (6143, '64.84.15585074660821149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '223.167.152.70', '2019-05-22 14:44:26', 5, 0, '', '2019-05-22 14:44:26');
INSERT INTO `access_log` VALUES (6144, '59.77.15585074727501971', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:44:33', 29, 2001001000, '服务端发生异常', '2019-05-22 14:44:33');
INSERT INTO `access_log` VALUES (6145, '59.75.15585074727461971', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:44:33', 177, 0, '', '2019-05-22 14:44:33');
INSERT INTO `access_log` VALUES (6146, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '210.22.245.226', '2019-05-22 14:44:54', 9, 0, '', '2019-05-22 14:44:54');
INSERT INTO `access_log` VALUES (6147, '64.85.15585077726801151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:49:33', 4, 0, '', '2019-05-22 14:49:33');
INSERT INTO `access_log` VALUES (6148, '64.77.15585077729401155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:49:33', 3, 0, '', '2019-05-22 14:49:33');
INSERT INTO `access_log` VALUES (6149, '64.76.15585077759621153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:49:36', 106, 0, '', '2019-05-22 14:49:36');
INSERT INTO `access_log` VALUES (6150, '64.81.15585077762371153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:49:36', 3, 0, '', '2019-05-22 14:49:36');
INSERT INTO `access_log` VALUES (6151, '64.83.15585078342931151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:50:34', 4, 0, '', '2019-05-22 14:50:34');
INSERT INTO `access_log` VALUES (6152, '64.84.15585078344361155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.162.244.190', '2019-05-22 14:50:34', 3, 0, '', '2019-05-22 14:50:34');
INSERT INTO `access_log` VALUES (6153, '65.52.15585080969071117', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:54:57', 0, 1002001015, '账号未登陆', '2019-05-22 14:54:57');
INSERT INTO `access_log` VALUES (6154, '65.50.15585080969001119', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:54:57', 1, 1002001015, '账号未登陆', '2019-05-22 14:54:57');
INSERT INTO `access_log` VALUES (6155, '65.49.15585080969031125', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:54:57', 0, 1002001015, '账号未登陆', '2019-05-22 14:54:57');
INSERT INTO `access_log` VALUES (6156, '65.47.15585080993551119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:54:59', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 14:54:59');
INSERT INTO `access_log` VALUES (6157, '65.48.15585081039411121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:55:04', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 14:55:04');
INSERT INTO `access_log` VALUES (6158, '65.54.15585081178371121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:55:18', 110, 0, '', '2019-05-22 14:55:18');
INSERT INTO `access_log` VALUES (6159, '65.46.15585081185061129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:55:19', 23, 0, '', '2019-05-22 14:55:19');
INSERT INTO `access_log` VALUES (6160, '65.51.15585081185191115', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:55:19', 13, 0, '', '2019-05-22 14:55:19');
INSERT INTO `access_log` VALUES (6161, '65.45.15585081185101125', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:55:19', 20, 0, '', '2019-05-22 14:55:19');
INSERT INTO `access_log` VALUES (6162, '62.89.15585081311791943', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:55:31', 18, 0, '', '2019-05-22 14:55:31');
INSERT INTO `access_log` VALUES (6163, '62.82.15585081474851943', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&status=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:55:47', 44, 0, '', '2019-05-22 14:55:48');
INSERT INTO `access_log` VALUES (6164, '65.47.15585081634621121', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:03', 25, 0, '', '2019-05-22 14:56:03');
INSERT INTO `access_log` VALUES (6165, '65.53.15585081708761119', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:11', 109, 0, '', '2019-05-22 14:56:11');
INSERT INTO `access_log` VALUES (6166, '65.54.15585081739251123', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:14', 14, 0, '', '2019-05-22 14:56:14');
INSERT INTO `access_log` VALUES (6167, '65.46.15585081757801131', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:16', 18, 0, '', '2019-05-22 14:56:16');
INSERT INTO `access_log` VALUES (6168, '62.81.15585081907241941', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:31', 20, 0, '', '2019-05-22 14:56:31');
INSERT INTO `access_log` VALUES (6169, '64.78.15585081924071159', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:32', 253, 0, '', '2019-05-22 14:56:33');
INSERT INTO `access_log` VALUES (6170, '64.81.15585081924031159', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:32', 262, 0, '', '2019-05-22 14:56:33');
INSERT INTO `access_log` VALUES (6171, '64.79.15585081956961161', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:36', 242, 0, '', '2019-05-22 14:56:36');
INSERT INTO `access_log` VALUES (6172, '64.83.15585081956971157', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:36', 241, 0, '', '2019-05-22 14:56:36');
INSERT INTO `access_log` VALUES (6173, '64.84.15585082052281161', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:45', 26, 0, '', '2019-05-22 14:56:45');
INSERT INTO `access_log` VALUES (6174, '64.85.15585082052291159', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:45', 34, 0, '', '2019-05-22 14:56:45');
INSERT INTO `access_log` VALUES (6175, '64.77.15585082052331163', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:45', 42, 0, '', '2019-05-22 14:56:45');
INSERT INTO `access_log` VALUES (6176, '65.52.15585082125141121', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:53', 5, 0, '', '2019-05-22 14:56:53');
INSERT INTO `access_log` VALUES (6177, '64.76.15585082168431161', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=测试商品&sellPoint=又大又长&cid=638&visible=true&id=28&picUrls=https://user-gold-cdn.xitu.io/2019/4/1/169d694b02ef0df7?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1,http://static.shop.iocoder.cn/49ace70a-bebc-4d1c-b4e7-2115cedbf2a8,http://static.shop.iocoder.cn/17a8da2c-9716-4be9-b802-74da3d74682d&skuStr=[{\"attrs\":[1],\"price\":10000,\"quantity\":100},{\"attrs\":[2],\"price\":20000,\"quantity\":200}]&description=<p>厮大牛逼</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:57', 1366, 1002002009, NULL, '2019-05-22 14:56:58');
INSERT INTO `access_log` VALUES (6178, '64.81.15585082185071161', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=测试商品&sellPoint=又大又长&cid=638&visible=true&id=28&picUrls=https://user-gold-cdn.xitu.io/2019/4/1/169d694b02ef0df7?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1,http://static.shop.iocoder.cn/49ace70a-bebc-4d1c-b4e7-2115cedbf2a8,http://static.shop.iocoder.cn/17a8da2c-9716-4be9-b802-74da3d74682d&skuStr=[{\"attrs\":[1],\"price\":10000,\"quantity\":100},{\"attrs\":[2],\"price\":20000,\"quantity\":200}]&description=<p>厮大牛逼</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:56:59', 289, 1002002009, NULL, '2019-05-22 14:56:59');
INSERT INTO `access_log` VALUES (6179, '64.80.15585082270171161', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=测试商品66&sellPoint=又大又长66&cid=638&visible=true&id=28&picUrls=https://user-gold-cdn.xitu.io/2019/4/1/169d694b02ef0df7?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1,http://static.shop.iocoder.cn/49ace70a-bebc-4d1c-b4e7-2115cedbf2a8,http://static.shop.iocoder.cn/17a8da2c-9716-4be9-b802-74da3d74682d&skuStr=[{\"attrs\":[1],\"price\":10000,\"quantity\":100},{\"attrs\":[2],\"price\":20000,\"quantity\":200}]&description=<p>厮大牛逼</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:57:07', 11, 1002002009, NULL, '2019-05-22 14:57:07');
INSERT INTO `access_log` VALUES (6180, '64.79.15585082325441163', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=测试商品66&sellPoint=又大又长66&cid=638&visible=false&id=28&picUrls=https://user-gold-cdn.xitu.io/2019/4/1/169d694b02ef0df7?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1,http://static.shop.iocoder.cn/49ace70a-bebc-4d1c-b4e7-2115cedbf2a8,http://static.shop.iocoder.cn/17a8da2c-9716-4be9-b802-74da3d74682d&skuStr=[{\"attrs\":[1],\"price\":10000,\"quantity\":100},{\"attrs\":[2],\"price\":20000,\"quantity\":200}]&description=<p>厮大牛逼</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:57:13', 11, 1002002009, NULL, '2019-05-22 14:57:13');
INSERT INTO `access_log` VALUES (6181, '64.83.15585082396371159', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=测试商品66&sellPoint=又大又长66&cid=638&visible=true&id=28&picUrls=http://static.shop.iocoder.cn/49ace70a-bebc-4d1c-b4e7-2115cedbf2a8,http://static.shop.iocoder.cn/17a8da2c-9716-4be9-b802-74da3d74682d&skuStr=[{\"attrs\":[1],\"price\":10000,\"quantity\":100},{\"attrs\":[2],\"price\":20000,\"quantity\":200}]&description=<p>厮大牛逼</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:57:20', 222, 1002002009, NULL, '2019-05-22 14:57:20');
INSERT INTO `access_log` VALUES (6182, '59.74.15585082504141983', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:57:30', 17, 0, '', '2019-05-22 14:57:30');
INSERT INTO `access_log` VALUES (6183, '65.53.15585082686811121', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:57:49', 4, 0, '', '2019-05-22 14:57:49');
INSERT INTO `access_log` VALUES (6184, '59.73.15585083139171985', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.57.167.42', '2019-05-22 14:58:34', 37, 0, '', '2019-05-22 14:58:34');
INSERT INTO `access_log` VALUES (6185, '59.71.15585093686431999', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:16:09', 41, 2001001000, '服务端发生异常', '2019-05-22 15:16:09');
INSERT INTO `access_log` VALUES (6186, '59.77.15585093686421997', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:16:09', 457, 0, '', '2019-05-22 15:16:09');
INSERT INTO `access_log` VALUES (6187, '65.45.15585093763531145', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:16:16', 1, 1002001015, '账号未登陆', '2019-05-22 15:16:16');
INSERT INTO `access_log` VALUES (6188, '65.46.15585093763531149', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:16:16', 1, 1002001015, '账号未登陆', '2019-05-22 15:16:16');
INSERT INTO `access_log` VALUES (6189, '65.54.15585093763531141', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:16:16', 1, 1002001015, '账号未登陆', '2019-05-22 15:16:16');
INSERT INTO `access_log` VALUES (6190, '65.47.15585094576871139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:17:38', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 15:17:38');
INSERT INTO `access_log` VALUES (6191, '64.81.15585096599341181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:21:00', 14, 0, '', '2019-05-22 15:21:00');
INSERT INTO `access_log` VALUES (6192, '64.78.15585096600971181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:21:00', 3, 0, '', '2019-05-22 15:21:00');
INSERT INTO `access_log` VALUES (6193, '64.80.15585096615781181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:21:02', 3, 0, '', '2019-05-22 15:21:02');
INSERT INTO `access_log` VALUES (6194, '64.79.15585096624361183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:21:02', 3, 0, '', '2019-05-22 15:21:02');
INSERT INTO `access_log` VALUES (6195, '64.83.15585096630281179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:21:03', 3, 0, '', '2019-05-22 15:21:03');
INSERT INTO `access_log` VALUES (6196, '64.85.15585096668361181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:21:07', 3, 0, '', '2019-05-22 15:21:07');
INSERT INTO `access_log` VALUES (6197, '64.77.15585096672511185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:21:07', 3, 0, '', '2019-05-22 15:21:07');
INSERT INTO `access_log` VALUES (6198, '59.80.15585096703792001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:21:10', 5, 0, '', '2019-05-22 15:21:10');
INSERT INTO `access_log` VALUES (6199, '59.74.15585096704852003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:21:10', 14, 2001001000, '服务端发生异常', '2019-05-22 15:21:11');
INSERT INTO `access_log` VALUES (6200, '65.50.15585096863661145', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:21:26', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 15:21:26');
INSERT INTO `access_log` VALUES (6201, '59.75.15585097392252003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:19', 6, 0, '', '2019-05-22 15:22:19');
INSERT INTO `access_log` VALUES (6202, '59.71.15585097392282005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:19', 48, 2001001000, '服务端发生异常', '2019-05-22 15:22:19');
INSERT INTO `access_log` VALUES (6203, '64.79.15585097435391185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:24', 4, 0, '', '2019-05-22 15:22:24');
INSERT INTO `access_log` VALUES (6204, '64.83.15585097437101181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:24', 3, 0, '', '2019-05-22 15:22:24');
INSERT INTO `access_log` VALUES (6205, '64.84.15585097449981185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:25', 4, 0, '', '2019-05-22 15:22:25');
INSERT INTO `access_log` VALUES (6206, '64.85.15585097458001183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:26', 4, 0, '', '2019-05-22 15:22:26');
INSERT INTO `access_log` VALUES (6207, '64.77.15585097465041187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:27', 4, 0, '', '2019-05-22 15:22:27');
INSERT INTO `access_log` VALUES (6208, '64.82.15585097511361183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:31', 3, 0, '', '2019-05-22 15:22:31');
INSERT INTO `access_log` VALUES (6209, '64.76.15585097512621185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:31', 3, 0, '', '2019-05-22 15:22:31');
INSERT INTO `access_log` VALUES (6210, '59.74.15585097571252005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:37', 36, 0, '', '2019-05-22 15:22:37');
INSERT INTO `access_log` VALUES (6211, '59.80.15585097571242003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:37', 44, 2001001000, '服务端发生异常', '2019-05-22 15:22:37');
INSERT INTO `access_log` VALUES (6212, '64.78.15585097668071185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:47', 4, 0, '', '2019-05-22 15:22:47');
INSERT INTO `access_log` VALUES (6213, '64.80.15585097669351185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:47', 3, 0, '', '2019-05-22 15:22:47');
INSERT INTO `access_log` VALUES (6214, '59.78.15585097677212005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:48', 4, 0, '', '2019-05-22 15:22:48');
INSERT INTO `access_log` VALUES (6215, '59.72.15585097677202003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:22:48', 15, 2001001000, '服务端发生异常', '2019-05-22 15:22:48');
INSERT INTO `access_log` VALUES (6216, '65.46.15585097876251155', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '222.128.95.44', '2019-05-22 15:23:08', 1, 1002001015, '账号未登陆', '2019-05-22 15:23:08');
INSERT INTO `access_log` VALUES (6217, '65.51.15585097876281139', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '222.128.95.44', '2019-05-22 15:23:08', 0, 1002001015, '账号未登陆', '2019-05-22 15:23:08');
INSERT INTO `access_log` VALUES (6218, '65.52.15585097876491143', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:23:08', 1, 1002001015, '账号未登陆', '2019-05-22 15:23:08');
INSERT INTO `access_log` VALUES (6219, '65.48.15585097918091149', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:23:12', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 15:23:12');
INSERT INTO `access_log` VALUES (6220, '65.47.15585098063831145', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:23:26', 75, 0, '', '2019-05-22 15:23:26');
INSERT INTO `access_log` VALUES (6221, '65.49.15585098067551153', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '222.128.95.44', '2019-05-22 15:23:27', 12, 0, '', '2019-05-22 15:23:27');
INSERT INTO `access_log` VALUES (6222, '65.45.15585098067641153', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:23:27', 12, 0, '', '2019-05-22 15:23:27');
INSERT INTO `access_log` VALUES (6223, '65.54.15585098067701149', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:23:27', 11, 0, '', '2019-05-22 15:23:27');
INSERT INTO `access_log` VALUES (6224, '62.85.15585098180341983', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '222.128.95.44', '2019-05-22 15:23:38', 27, 0, '', '2019-05-22 15:23:38');
INSERT INTO `access_log` VALUES (6225, '64.82.15585098230421185', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '222.128.95.44', '2019-05-22 15:23:43', 11, 0, '', '2019-05-22 15:23:43');
INSERT INTO `access_log` VALUES (6226, '64.77.15585098230401189', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:23:43', 21, 0, '', '2019-05-22 15:23:43');
INSERT INTO `access_log` VALUES (6227, '59.77.15585098322482005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:23:52', 5, 0, '', '2019-05-22 15:23:52');
INSERT INTO `access_log` VALUES (6228, '59.80.15585098322502005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:23:52', 15, 2001001000, '服务端发生异常', '2019-05-22 15:23:52');
INSERT INTO `access_log` VALUES (6229, '65.52.15585098349351145', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '222.128.95.44', '2019-05-22 15:23:55', 4, 0, '', '2019-05-22 15:23:55');
INSERT INTO `access_log` VALUES (6230, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=kafka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:23:58', 38, 0, '', '2019-05-22 15:23:58');
INSERT INTO `access_log` VALUES (6231, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kafka', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:23:58', 36, 0, '', '2019-05-22 15:23:58');
INSERT INTO `access_log` VALUES (6232, '64.81.15585098404751187', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:24:00', 13, 0, '', '2019-05-22 15:24:00');
INSERT INTO `access_log` VALUES (6233, '65.53.15585098680991147', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:24:28', 81, 0, '', '2019-05-22 15:24:28');
INSERT INTO `access_log` VALUES (6234, '65.47.15585098685871147', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:24:29', 12, 0, '', '2019-05-22 15:24:29');
INSERT INTO `access_log` VALUES (6235, '65.49.15585098685991155', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:24:29', 12, 0, '', '2019-05-22 15:24:29');
INSERT INTO `access_log` VALUES (6236, '65.54.15585098686041151', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:24:29', 13, 0, '', '2019-05-22 15:24:29');
INSERT INTO `access_log` VALUES (6237, '62.81.15585098727991979', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:24:33', 19, 0, '', '2019-05-22 15:24:33');
INSERT INTO `access_log` VALUES (6238, '62.87.15585098759811985', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:24:36', 27, 0, '', '2019-05-22 15:24:36');
INSERT INTO `access_log` VALUES (6239, '59.79.15585098938732005', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:24:54', 16, 0, '', '2019-05-22 15:24:54');
INSERT INTO `access_log` VALUES (6240, '59.73.15585099040222009', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:25:04', 18, 0, '', '2019-05-22 15:25:04');
INSERT INTO `access_log` VALUES (6241, '64.84.15585099050361189', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=我的免费隧道&sellPoint=便宜&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/1550a4e8-ff01-46d1-bc64-608e5e5de98e&skuStr=[{\"attrs\":[3,2],\"price\":2200,\"quantity\":11},{\"attrs\":[3,11],\"price\":3300,\"quantity\":22},{\"attrs\":[3,13],\"price\":4400,\"quantity\":33}]&description=<p>啊啊啊啊啊啊</p>', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:05', 12, 1002002009, NULL, '2019-05-22 15:25:05');
INSERT INTO `access_log` VALUES (6242, '59.71.15585099125262009', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:25:13', 138, 0, '', '2019-05-22 15:25:13');
INSERT INTO `access_log` VALUES (6243, '64.82.15585099137771187', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:14', 13, 0, '', '2019-05-22 15:25:14');
INSERT INTO `access_log` VALUES (6244, '64.77.15585099137711191', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:14', 21, 0, '', '2019-05-22 15:25:14');
INSERT INTO `access_log` VALUES (6245, '64.81.15585099182891189', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:18', 16, 0, '', '2019-05-22 15:25:18');
INSERT INTO `access_log` VALUES (6246, '64.76.15585099182791189', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:18', 27, 0, '', '2019-05-22 15:25:18');
INSERT INTO `access_log` VALUES (6247, '64.78.15585099183191189', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:18', 12, 0, '', '2019-05-22 15:25:18');
INSERT INTO `access_log` VALUES (6248, '64.83.15585099242241187', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:24', 13, 0, '', '2019-05-22 15:25:24');
INSERT INTO `access_log` VALUES (6249, '64.79.15585099242201191', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:24', 28, 0, '', '2019-05-22 15:25:24');
INSERT INTO `access_log` VALUES (6250, '64.85.15585099270161189', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:27', 14, 0, '', '2019-05-22 15:25:27');
INSERT INTO `access_log` VALUES (6251, '64.84.15585099270161191', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:27', 19, 0, '', '2019-05-22 15:25:27');
INSERT INTO `access_log` VALUES (6252, '59.80.15585099311582007', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:25:31', 13, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-22 15:25:31');
INSERT INTO `access_log` VALUES (6253, '65.50.15585099359531151', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:25:36', 26, 0, '', '2019-05-22 15:25:36');
INSERT INTO `access_log` VALUES (6254, '66.48.15585099369841081', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:37', 62, 0, '', '2019-05-22 15:25:37');
INSERT INTO `access_log` VALUES (6255, '65.53.15585099427441149', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:25:43', 23, 0, '', '2019-05-22 15:25:43');
INSERT INTO `access_log` VALUES (6256, '66.49.15585099453851083', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:45', 20, 0, '', '2019-05-22 15:25:45');
INSERT INTO `access_log` VALUES (6257, '66.57.15585099463271079', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=3&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:46', 45, 0, '', '2019-05-22 15:25:46');
INSERT INTO `access_log` VALUES (6258, '65.54.15585099508821153', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:25:51', 29, 0, '', '2019-05-22 15:25:51');
INSERT INTO `access_log` VALUES (6259, '66.52.15585099530411083', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10&status=2', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:53', 25, 0, '', '2019-05-22 15:25:53');
INSERT INTO `access_log` VALUES (6260, '65.49.15585099539961157', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:25:54', 26, 0, '', '2019-05-22 15:25:54');
INSERT INTO `access_log` VALUES (6261, '66.53.15585099569801081', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:25:57', 38, 0, '', '2019-05-22 15:25:57');
INSERT INTO `access_log` VALUES (6262, '65.45.15585099570371157', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:25:57', 12, 0, '', '2019-05-22 15:25:57');
INSERT INTO `access_log` VALUES (6263, '65.46.15585099586241161', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:25:59', 12, 0, '', '2019-05-22 15:25:59');
INSERT INTO `access_log` VALUES (6264, '59.78.15585099614062009', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:26:01', 16, 0, '', '2019-05-22 15:26:01');
INSERT INTO `access_log` VALUES (6265, '65.52.15585099731221149', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:26:13', 18, 0, '', '2019-05-22 15:26:13');
INSERT INTO `access_log` VALUES (6266, '59.79.15585099770862007', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:26:17', 262, 2001001000, '服务端发生异常', '2019-05-22 15:26:17');
INSERT INTO `access_log` VALUES (6267, '59.73.15585099819912011', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:26:22', 24, 0, '', '2019-05-22 15:26:22');
INSERT INTO `access_log` VALUES (6268, '65.48.15585099839871155', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:26:24', 12, 0, '', '2019-05-22 15:26:24');
INSERT INTO `access_log` VALUES (6269, '64.78.15585099849371191', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:26:25', 15, 0, '', '2019-05-22 15:26:25');
INSERT INTO `access_log` VALUES (6270, '62.83.15585099886571987', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:26:29', 19, 0, '', '2019-05-22 15:26:29');
INSERT INTO `access_log` VALUES (6271, '62.82.15585099913011985', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:26:31', 23, 0, '', '2019-05-22 15:26:31');
INSERT INTO `access_log` VALUES (6272, '64.79.15585100077291193', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:26:48', 14, 0, '', '2019-05-22 15:26:48');
INSERT INTO `access_log` VALUES (6273, '59.80.15585100115042009', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:26:52', 17, 0, '', '2019-05-22 15:26:52');
INSERT INTO `access_log` VALUES (6274, '62.84.15585100118471989', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:26:52', 65, 0, '', '2019-05-22 15:26:52');
INSERT INTO `access_log` VALUES (6275, '59.72.15585100270272009', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:27:07', 12, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-22 15:27:07');
INSERT INTO `access_log` VALUES (6276, '65.54.15585100339041157', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:27:14', 24, 0, '', '2019-05-22 15:27:14');
INSERT INTO `access_log` VALUES (6277, '64.77.15585100360531195', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:27:16', 17, 0, '', '2019-05-22 15:27:16');
INSERT INTO `access_log` VALUES (6278, '64.84.15585100360531193', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:27:16', 26, 0, '', '2019-05-22 15:27:16');
INSERT INTO `access_log` VALUES (6279, '65.49.15585100405871159', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:27:21', 15, 0, '', '2019-05-22 15:27:21');
INSERT INTO `access_log` VALUES (6280, '65.51.15585100442141149', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:27:24', 15, 0, '', '2019-05-22 15:27:24');
INSERT INTO `access_log` VALUES (6281, '65.46.15585100467781163', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:27:27', 12, 0, '', '2019-05-22 15:27:27');
INSERT INTO `access_log` VALUES (6282, '65.50.15585100619091157', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:27:42', 18, 0, '', '2019-05-22 15:27:42');
INSERT INTO `access_log` VALUES (6283, '64.81.15585100642921193', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=6&name=1', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:27:44', 10, 1002002009, NULL, '2019-05-22 15:27:44');
INSERT INTO `access_log` VALUES (6284, '64.78.15585100666591193', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=6&name=1', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '101.254.182.38', '2019-05-22 15:27:47', 12, 1002002009, NULL, '2019-05-22 15:27:47');
INSERT INTO `access_log` VALUES (6285, '64.79.15585100739621195', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:27:54', 23, 0, '', '2019-05-22 15:27:54');
INSERT INTO `access_log` VALUES (6286, '64.83.15585100739641191', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:27:54', 18, 0, '', '2019-05-22 15:27:54');
INSERT INTO `access_log` VALUES (6287, '65.47.15585100957691151', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:28:16', 5, 0, '', '2019-05-22 15:28:16');
INSERT INTO `access_log` VALUES (6288, '64.82.15585101227481193', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=我的免费隧道&sellPoint=便宜&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/be7170ce-7083-4512-b3da-552a4e0b17a7&skuStr=[{\"attrs\":[3],\"price\":2200,\"quantity\":33}]&description=<p>aaaaaaaaaaa</p>', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:28:43', 11, 1002002009, NULL, '2019-05-22 15:28:43');
INSERT INTO `access_log` VALUES (6289, '64.83.15585101781621193', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=我的免费隧道&sellPoint=便宜&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/be7170ce-7083-4512-b3da-552a4e0b17a7&skuStr=[{\"attrs\":[3],\"price\":2200,\"quantity\":33}]&description=<p>aaaaaaaaaaa</p>', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:29:38', 12, 1002002009, NULL, '2019-05-22 15:29:38');
INSERT INTO `access_log` VALUES (6290, '65.53.15585104993901159', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.167.151.210', '2019-05-22 15:34:59', 1, 1002001015, '账号未登陆', '2019-05-22 15:34:59');
INSERT INTO `access_log` VALUES (6291, '65.48.15585104993901163', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.167.151.210', '2019-05-22 15:34:59', 1, 1002001015, '账号未登陆', '2019-05-22 15:34:59');
INSERT INTO `access_log` VALUES (6292, '65.47.15585104993931157', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.167.151.210', '2019-05-22 15:34:59', 1, 1002001015, '账号未登陆', '2019-05-22 15:34:59');
INSERT INTO `access_log` VALUES (6293, '65.54.15585105037221165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.167.151.210', '2019-05-22 15:35:04', 939, 0, '', '2019-05-22 15:35:05');
INSERT INTO `access_log` VALUES (6294, '65.51.15585105052211157', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.167.151.210', '2019-05-22 15:35:05', 15, 0, '', '2019-05-22 15:35:05');
INSERT INTO `access_log` VALUES (6295, '65.45.15585105052201169', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.167.151.210', '2019-05-22 15:35:05', 17, 0, '', '2019-05-22 15:35:05');
INSERT INTO `access_log` VALUES (6296, '65.49.15585105052201167', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.167.151.210', '2019-05-22 15:35:05', 13, 0, '', '2019-05-22 15:35:05');
INSERT INTO `access_log` VALUES (6297, '62.80.15585105166361995', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.167.151.210', '2019-05-22 15:35:17', 21, 0, '', '2019-05-22 15:35:17');
INSERT INTO `access_log` VALUES (6298, '62.89.15585105200881993', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.167.151.210', '2019-05-22 15:35:20', 22, 0, '', '2019-05-22 15:35:20');
INSERT INTO `access_log` VALUES (6299, '62.82.15585105216831993', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.167.151.210', '2019-05-22 15:35:22', 398, 0, '', '2019-05-22 15:35:22');
INSERT INTO `access_log` VALUES (6300, '65.50.15585105348301165', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:35:35', 4, 0, '', '2019-05-22 15:35:35');
INSERT INTO `access_log` VALUES (6301, '64.82.15585105391771199', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=我的免费隧道&sellPoint=便宜&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/be7170ce-7083-4512-b3da-552a4e0b17a7&skuStr=[{\"attrs\":[3],\"price\":2200,\"quantity\":33}]&description=<p>aaaaaaaaaaa</p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/5db9452e-53ef-483a-9596-43d5e0df0d8c\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:35:39', 11, 1002002009, NULL, '2019-05-22 15:35:39');
INSERT INTO `access_log` VALUES (6302, '59.79.15585113708752027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:31', 52, 0, '', '2019-05-22 15:49:31');
INSERT INTO `access_log` VALUES (6303, '59.75.15585113709192029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:31', 32, 2001001000, '服务端发生异常', '2019-05-22 15:49:31');
INSERT INTO `access_log` VALUES (6304, '59.71.15585113773332031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:37', 4, 0, '', '2019-05-22 15:49:37');
INSERT INTO `access_log` VALUES (6305, '59.77.15585113773312029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:37', 16, 2001001000, '服务端发生异常', '2019-05-22 15:49:37');
INSERT INTO `access_log` VALUES (6306, '64.85.15585113840381211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:44', 4, 0, '', '2019-05-22 15:49:44');
INSERT INTO `access_log` VALUES (6307, '64.77.15585113844141215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:44', 3, 0, '', '2019-05-22 15:49:44');
INSERT INTO `access_log` VALUES (6308, '64.84.15585113871511213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:47', 4, 0, '', '2019-05-22 15:49:47');
INSERT INTO `access_log` VALUES (6309, '64.82.15585113875941211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:48', 3, 0, '', '2019-05-22 15:49:48');
INSERT INTO `access_log` VALUES (6310, '64.76.15585113882011213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:48', 4, 0, '', '2019-05-22 15:49:48');
INSERT INTO `access_log` VALUES (6311, '64.81.15585113887451213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:49', 3, 0, '', '2019-05-22 15:49:49');
INSERT INTO `access_log` VALUES (6312, '59.72.15585113902312027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:50', 5, 0, '', '2019-05-22 15:49:50');
INSERT INTO `access_log` VALUES (6313, '59.74.15585113902302031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:50', 15, 2001001000, '服务端发生异常', '2019-05-22 15:49:50');
INSERT INTO `access_log` VALUES (6314, '64.80.15585113934771213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:53', 4, 0, '', '2019-05-22 15:49:53');
INSERT INTO `access_log` VALUES (6315, '64.83.15585113938781211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:54', 3, 0, '', '2019-05-22 15:49:54');
INSERT INTO `access_log` VALUES (6316, '59.76.15585113960622027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:56', 5, 0, '', '2019-05-22 15:49:56');
INSERT INTO `access_log` VALUES (6317, '59.78.15585113960652031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:56', 12, 2001001000, '服务端发生异常', '2019-05-22 15:49:56');
INSERT INTO `access_log` VALUES (6318, '64.79.15585113987311215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:59', 3, 0, '', '2019-05-22 15:49:59');
INSERT INTO `access_log` VALUES (6319, '64.85.15585113991141213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:49:59', 3, 0, '', '2019-05-22 15:49:59');
INSERT INTO `access_log` VALUES (6320, '64.77.15585114000651217', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:50:00', 832, 0, '', '2019-05-22 15:50:01');
INSERT INTO `access_log` VALUES (6321, '64.84.15585114006421215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:50:01', 1057, 0, '', '2019-05-22 15:50:02');
INSERT INTO `access_log` VALUES (6322, '66.52.15585114280001103', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18500235981&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:50:28', 23, 1001003000, '验证码不存在', '2019-05-22 15:50:28');
INSERT INTO `access_log` VALUES (6323, '66.53.15585114315591101', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18500235981', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:50:32', 76, 0, '', '2019-05-22 15:50:32');
INSERT INTO `access_log` VALUES (6324, '66.56.15585114398381103', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15652958958', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:50:40', 129, 0, '', '2019-05-22 15:50:40');
INSERT INTO `access_log` VALUES (6325, '66.50.15585114612171103', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15652958958&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:01', 210, 0, '', '2019-05-22 15:51:01');
INSERT INTO `access_log` VALUES (6326, '64.79.15585114694131217', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:09', 9, 0, '', '2019-05-22 15:51:09');
INSERT INTO `access_log` VALUES (6327, '64.77.15585114697421219', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:10', 8, 0, '', '2019-05-22 15:51:10');
INSERT INTO `access_log` VALUES (6328, '64.82.15585114711881215', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:11', 358, 0, '', '2019-05-22 15:51:12');
INSERT INTO `access_log` VALUES (6329, '64.81.15585114719641217', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:12', 1011, 0, '', '2019-05-22 15:51:13');
INSERT INTO `access_log` VALUES (6330, '64.78.15585114723451217', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:12', 631, 0, '', '2019-05-22 15:51:13');
INSERT INTO `access_log` VALUES (6331, '66.57.15585114737731101', 78, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:14', 33, 0, '', '2019-05-22 15:51:14');
INSERT INTO `access_log` VALUES (6332, '66.52.15585114874791105', 78, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:27', 13, 0, '', '2019-05-22 15:51:27');
INSERT INTO `access_log` VALUES (6333, '66.53.15585114906511103', 78, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:31', 14, 0, '', '2019-05-22 15:51:31');
INSERT INTO `access_log` VALUES (6334, '66.55.15585114942941105', 78, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:34', 29, 0, '', '2019-05-22 15:51:34');
INSERT INTO `access_log` VALUES (6335, '66.54.15585114982901103', 78, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:38', 13, 0, '', '2019-05-22 15:51:38');
INSERT INTO `access_log` VALUES (6336, '59.78.15585115026972033', 78, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:43', 167, 0, '', '2019-05-22 15:51:43');
INSERT INTO `access_log` VALUES (6337, '59.79.15585115044102031', 78, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:44', 9, 0, '', '2019-05-22 15:51:44');
INSERT INTO `access_log` VALUES (6338, '59.73.15585115051472035', 78, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:45', 9, 0, '', '2019-05-22 15:51:45');
INSERT INTO `access_log` VALUES (6339, '66.48.15585115190761105', 78, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:51:59', 30, 0, '', '2019-05-22 15:51:59');
INSERT INTO `access_log` VALUES (6340, '66.57.15585115219231103', 78, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:52:02', 33, 0, '', '2019-05-22 15:52:02');
INSERT INTO `access_log` VALUES (6341, '66.56.15585115615911107', 78, 1, 'user-application', '/user-api/users/address/add', 'name=zs&tel=18500020583&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=gsfdgdsg&isDefault=true&address=gsfdgdsg&areaNo=110101&mobile=18500020583&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:52:42', 328, 2001001000, '服务端发生异常', '2019-05-22 15:52:42');
INSERT INTO `access_log` VALUES (6342, '66.48.15585115825611107', 78, 1, 'user-application', '/user-api/users/address/add', 'name=zs&tel=18500020583&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=皮套胡同&isDefault=true&address=皮套胡同&areaNo=110101&mobile=18500020583&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:53:03', 93, 2001001000, '服务端发生异常', '2019-05-22 15:53:03');
INSERT INTO `access_log` VALUES (6343, '66.51.15585116045181109', 78, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:53:25', 302, 0, '', '2019-05-22 15:53:25');
INSERT INTO `access_log` VALUES (6344, '66.52.15585116114151109', 78, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:53:31', 10, 0, '', '2019-05-22 15:53:31');
INSERT INTO `access_log` VALUES (6345, '64.78.15585116153611219', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:53:35', 9, 0, '', '2019-05-22 15:53:35');
INSERT INTO `access_log` VALUES (6346, '64.83.15585116155081217', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:53:36', 9, 0, '', '2019-05-22 15:53:36');
INSERT INTO `access_log` VALUES (6347, '64.79.15585116172401221', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:53:37', 8, 0, '', '2019-05-22 15:53:37');
INSERT INTO `access_log` VALUES (6348, 'N/A', 78, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:53:37', 308, 0, '', '2019-05-22 15:53:38');
INSERT INTO `access_log` VALUES (6349, '64.77.15585116189121223', 78, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:53:39', 16, 0, '', '2019-05-22 15:53:39');
INSERT INTO `access_log` VALUES (6350, '66.56.15585116219791109', 78, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:53:42', 9, 0, '', '2019-05-22 15:53:42');
INSERT INTO `access_log` VALUES (6351, '66.54.15585116279131107', 78, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:53:48', 8, 0, '', '2019-05-22 15:53:48');
INSERT INTO `access_log` VALUES (6352, '66.49.15585116397111111', 78, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=18500020583&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=来来来&isDefault=false&address=来来来&areaNo=110101&mobile=18500020583&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:00', 103, 2001001000, '服务端发生异常', '2019-05-22 15:54:00');
INSERT INTO `access_log` VALUES (6353, '66.51.15585116432111111', 78, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=18500020583&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=来来来&isDefault=true&address=来来来&areaNo=110101&mobile=18500020583&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:03', 225, 2001001000, '服务端发生异常', '2019-05-22 15:54:03');
INSERT INTO `access_log` VALUES (6354, '66.53.15585116458451109', 78, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:06', 9, 0, '', '2019-05-22 15:54:06');
INSERT INTO `access_log` VALUES (6355, '66.55.15585116472171111', 78, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:07', 9, 0, '', '2019-05-22 15:54:07');
INSERT INTO `access_log` VALUES (6356, '66.54.15585116625961109', 78, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:23', 8, 0, '', '2019-05-22 15:54:23');
INSERT INTO `access_log` VALUES (6357, '66.50.15585116637601111', 78, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:24', 8, 0, '', '2019-05-22 15:54:24');
INSERT INTO `access_log` VALUES (6358, '64.81.15585116655281221', 78, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:26', 16, 0, '', '2019-05-22 15:54:26');
INSERT INTO `access_log` VALUES (6359, '64.78.15585116730781221', 78, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:33', 15, 0, '', '2019-05-22 15:54:33');
INSERT INTO `access_log` VALUES (6360, '64.80.15585116738751221', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:34', 9, 0, '', '2019-05-22 15:54:34');
INSERT INTO `access_log` VALUES (6361, 'N/A', 78, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:34', 48, 0, '', '2019-05-22 15:54:34');
INSERT INTO `access_log` VALUES (6362, '64.79.15585116750721223', 78, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:35', 17, 0, '', '2019-05-22 15:54:35');
INSERT INTO `access_log` VALUES (6363, '64.77.15585116896061225', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:50', 7, 0, '', '2019-05-22 15:54:50');
INSERT INTO `access_log` VALUES (6364, 'N/A', 78, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:50', 296, 0, '', '2019-05-22 15:54:50');
INSERT INTO `access_log` VALUES (6365, '64.82.15585116921031221', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:52', 8, 0, '', '2019-05-22 15:54:52');
INSERT INTO `access_log` VALUES (6366, '64.76.15585116922701223', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:52', 8, 0, '', '2019-05-22 15:54:52');
INSERT INTO `access_log` VALUES (6367, '65.52.15585116959011177', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.34.210', '2019-05-22 15:54:56', 0, 1002001015, '账号未登陆', '2019-05-22 15:54:56');
INSERT INTO `access_log` VALUES (6368, '65.50.15585116959011181', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.34.210', '2019-05-22 15:54:56', 0, 1002001015, '账号未登陆', '2019-05-22 15:54:56');
INSERT INTO `access_log` VALUES (6369, '65.47.15585116959031175', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.34.210', '2019-05-22 15:54:56', 1, 1002001015, '账号未登陆', '2019-05-22 15:54:56');
INSERT INTO `access_log` VALUES (6370, '65.53.15585116985691177', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.34.210', '2019-05-22 15:54:59', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 15:54:59');
INSERT INTO `access_log` VALUES (6371, '64.81.15585116997401223', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:00', 8, 0, '', '2019-05-22 15:55:00');
INSERT INTO `access_log` VALUES (6372, '64.78.15585116998611223', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:00', 7, 0, '', '2019-05-22 15:55:00');
INSERT INTO `access_log` VALUES (6373, '59.78.15585117010602037', 78, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:01', 12, 0, '', '2019-05-22 15:55:01');
INSERT INTO `access_log` VALUES (6374, '59.76.15585117010612033', 78, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:01', 20, 2001001000, '服务端发生异常', '2019-05-22 15:55:01');
INSERT INTO `access_log` VALUES (6375, '64.80.15585117031001223', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:03', 56, 0, '', '2019-05-22 15:55:03');
INSERT INTO `access_log` VALUES (6376, '64.83.15585117034091221', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:03', 7, 0, '', '2019-05-22 15:55:03');
INSERT INTO `access_log` VALUES (6377, '64.79.15585117046911225', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:05', 8, 0, '', '2019-05-22 15:55:05');
INSERT INTO `access_log` VALUES (6378, '64.77.15585117071031227', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:07', 159, 0, '', '2019-05-22 15:55:07');
INSERT INTO `access_log` VALUES (6379, 'N/A', 78, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:07', 130, 0, '', '2019-05-22 15:55:07');
INSERT INTO `access_log` VALUES (6380, '64.82.15585117122791223', 78, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:12', 17, 0, '', '2019-05-22 15:55:12');
INSERT INTO `access_log` VALUES (6381, '66.51.15585117165221113', 78, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:17', 13, 0, '', '2019-05-22 15:55:17');
INSERT INTO `access_log` VALUES (6382, '64.76.15585117192851225', 78, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:19', 18, 0, '', '2019-05-22 15:55:19');
INSERT INTO `access_log` VALUES (6383, '64.81.15585117200751225', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:20', 8, 0, '', '2019-05-22 15:55:20');
INSERT INTO `access_log` VALUES (6384, 'N/A', 78, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:20', 64, 0, '', '2019-05-22 15:55:20');
INSERT INTO `access_log` VALUES (6385, '64.80.15585117219021225', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:22', 8, 0, '', '2019-05-22 15:55:22');
INSERT INTO `access_log` VALUES (6386, '64.83.15585117220341223', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:22', 7, 0, '', '2019-05-22 15:55:22');
INSERT INTO `access_log` VALUES (6387, '64.79.15585117232911227', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:23', 198, 0, '', '2019-05-22 15:55:23');
INSERT INTO `access_log` VALUES (6388, '64.85.15585117237561225', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:24', 7, 0, '', '2019-05-22 15:55:24');
INSERT INTO `access_log` VALUES (6389, '64.77.15585117252731229', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:25', 183, 0, '', '2019-05-22 15:55:25');
INSERT INTO `access_log` VALUES (6390, 'N/A', 78, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:25', 147, 0, '', '2019-05-22 15:55:25');
INSERT INTO `access_log` VALUES (6391, '64.84.15585117275321227', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:28', 8, 0, '', '2019-05-22 15:55:28');
INSERT INTO `access_log` VALUES (6392, '64.82.15585117276471225', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:28', 7, 0, '', '2019-05-22 15:55:28');
INSERT INTO `access_log` VALUES (6393, '64.76.15585117320021227', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:32', 7, 0, '', '2019-05-22 15:55:32');
INSERT INTO `access_log` VALUES (6394, 'N/A', 78, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:32', 298, 0, '', '2019-05-22 15:55:32');
INSERT INTO `access_log` VALUES (6395, '59.77.15585117361202037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.34.210', '2019-05-22 15:55:36', 4, 0, '', '2019-05-22 15:55:36');
INSERT INTO `access_log` VALUES (6396, '59.71.15585117361202039', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.34.210', '2019-05-22 15:55:36', 39, 2001001000, '服务端发生异常', '2019-05-22 15:55:36');
INSERT INTO `access_log` VALUES (6397, '64.78.15585117367361227', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:37', 8, 0, '', '2019-05-22 15:55:37');
INSERT INTO `access_log` VALUES (6398, '64.80.15585117368561227', 78, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:37', 8, 0, '', '2019-05-22 15:55:37');
INSERT INTO `access_log` VALUES (6399, '64.83.15585117397891225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.34.210', '2019-05-22 15:55:40', 165, 0, '', '2019-05-22 15:55:40');
INSERT INTO `access_log` VALUES (6400, '64.79.15585117400781229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.34.210', '2019-05-22 15:55:40', 3, 0, '', '2019-05-22 15:55:40');
INSERT INTO `access_log` VALUES (6401, '64.85.15585117413181227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.34.210', '2019-05-22 15:55:41', 3, 0, '', '2019-05-22 15:55:41');
INSERT INTO `access_log` VALUES (6402, '59.80.15585117424092035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.34.210', '2019-05-22 15:55:42', 4, 0, '', '2019-05-22 15:55:42');
INSERT INTO `access_log` VALUES (6403, '59.72.15585117424092035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.34.210', '2019-05-22 15:55:42', 14, 2001001000, '服务端发生异常', '2019-05-22 15:55:42');
INSERT INTO `access_log` VALUES (6404, 'N/A', 78, 1, 'search-application', '/search-api/users/product/page', 'keyword=kafka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:46', 55, 0, '', '2019-05-22 15:55:46');
INSERT INTO `access_log` VALUES (6405, 'N/A', 78, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kafka', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:47', 73, 0, '', '2019-05-22 15:55:47');
INSERT INTO `access_log` VALUES (6406, '64.77.15585117478331231', 78, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:48', 17, 0, '', '2019-05-22 15:55:48');
INSERT INTO `access_log` VALUES (6407, '66.55.15585117500911113', 78, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:55:50', 9, 0, '', '2019-05-22 15:55:50');
INSERT INTO `access_log` VALUES (6408, '64.76.15585117783081229', 78, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:56:18', 17, 0, '', '2019-05-22 15:56:18');
INSERT INTO `access_log` VALUES (6409, '65.47.15585118225161177', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:57:03', 12, 0, '', '2019-05-22 15:57:03');
INSERT INTO `access_log` VALUES (6410, '65.48.15585118225501183', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:57:03', 13, 0, '', '2019-05-22 15:57:03');
INSERT INTO `access_log` VALUES (6411, '65.53.15585118225501179', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:57:03', 13, 0, '', '2019-05-22 15:57:03');
INSERT INTO `access_log` VALUES (6412, '65.54.15585118257461185', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:57:06', 11, 0, '', '2019-05-22 15:57:06');
INSERT INTO `access_log` VALUES (6413, '65.45.15585118257521189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:57:06', 11, 0, '', '2019-05-22 15:57:06');
INSERT INTO `access_log` VALUES (6414, '65.51.15585118257581177', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:57:06', 10, 0, '', '2019-05-22 15:57:06');
INSERT INTO `access_log` VALUES (6415, '62.84.15585118899962015', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:58:10', 18, 0, '', '2019-05-22 15:58:10');
INSERT INTO `access_log` VALUES (6416, '62.88.15585118922852013', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:58:12', 457, 0, '', '2019-05-22 15:58:13');
INSERT INTO `access_log` VALUES (6417, '62.80.15585119211722015', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:58:41', 18, 0, '', '2019-05-22 15:58:41');
INSERT INTO `access_log` VALUES (6418, '62.89.15585119246932013', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:58:45', 24, 0, '', '2019-05-22 15:58:45');
INSERT INTO `access_log` VALUES (6419, '64.78.15585119464171233', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:59:06', 17, 0, '', '2019-05-22 15:59:06');
INSERT INTO `access_log` VALUES (6420, '64.81.15585119464171231', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:59:06', 22, 0, '', '2019-05-22 15:59:06');
INSERT INTO `access_log` VALUES (6421, '64.80.15585119497311231', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:59:10', 18, 0, '', '2019-05-22 15:59:10');
INSERT INTO `access_log` VALUES (6422, '64.83.15585119497341231', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:59:10', 13, 0, '', '2019-05-22 15:59:10');
INSERT INTO `access_log` VALUES (6423, '62.86.15585125806252019', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 16:09:41', 24, 0, '', '2019-05-22 16:09:41');
INSERT INTO `access_log` VALUES (6424, '59.71.15585133332972061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.92.195', '2019-05-22 16:22:13', 5, 0, '', '2019-05-22 16:22:13');
INSERT INTO `access_log` VALUES (6425, '59.77.15585133332972059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.92.195', '2019-05-22 16:22:13', 15, 2001001000, '服务端发生异常', '2019-05-22 16:22:13');
INSERT INTO `access_log` VALUES (6426, '64.77.15585133364641255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.92.195', '2019-05-22 16:22:16', 5, 0, '', '2019-05-22 16:22:16');
INSERT INTO `access_log` VALUES (6427, '64.76.15585133366041251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.92.195', '2019-05-22 16:22:17', 3, 0, '', '2019-05-22 16:22:17');
INSERT INTO `access_log` VALUES (6428, '64.84.15585133380271251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.92.195', '2019-05-22 16:22:18', 4, 0, '', '2019-05-22 16:22:18');
INSERT INTO `access_log` VALUES (6429, '65.53.15585134334591203', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.159.61', '2019-05-22 16:23:53', 7, 1002001012, '访问令牌已过期', '2019-05-22 16:23:53');
INSERT INTO `access_log` VALUES (6430, '65.45.15585134334651213', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.159.61', '2019-05-22 16:23:53', 5, 1002001012, '访问令牌已过期', '2019-05-22 16:23:53');
INSERT INTO `access_log` VALUES (6431, '65.48.15585134334651205', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.94.226.60', '2019-05-22 16:23:53', 6, 1002001012, '访问令牌已过期', '2019-05-22 16:23:53');
INSERT INTO `access_log` VALUES (6432, '65.54.15585134353571207', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.92.195', '2019-05-22 16:23:55', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 16:23:55');
INSERT INTO `access_log` VALUES (6433, '65.51.15585134560551199', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.159.61', '2019-05-22 16:24:16', 169, 0, '', '2019-05-22 16:24:16');
INSERT INTO `access_log` VALUES (6434, '65.50.15585134567311209', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.159.61', '2019-05-22 16:24:17', 13, 0, '', '2019-05-22 16:24:17');
INSERT INTO `access_log` VALUES (6435, '65.52.15585134567331203', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.159.61', '2019-05-22 16:24:17', 12, 0, '', '2019-05-22 16:24:17');
INSERT INTO `access_log` VALUES (6436, '65.47.15585134567631203', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.159.61', '2019-05-22 16:24:17', 13, 0, '', '2019-05-22 16:24:17');
INSERT INTO `access_log` VALUES (6437, '65.45.15585134660821215', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.159.61', '2019-05-22 16:24:26', 10, 0, '', '2019-05-22 16:24:26');
INSERT INTO `access_log` VALUES (6438, '65.49.15585134660851213', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.63.83.26', '2019-05-22 16:24:26', 11, 0, '', '2019-05-22 16:24:26');
INSERT INTO `access_log` VALUES (6439, '65.48.15585134660851207', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.159.61', '2019-05-22 16:24:26', 16, 0, '', '2019-05-22 16:24:26');
INSERT INTO `access_log` VALUES (6440, '62.86.15585134754162031', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.63.83.26', '2019-05-22 16:24:35', 25, 0, '', '2019-05-22 16:24:35');
INSERT INTO `access_log` VALUES (6441, '62.88.15585134836502037', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.92.195', '2019-05-22 16:24:44', 20, 0, '', '2019-05-22 16:24:44');
INSERT INTO `access_log` VALUES (6442, '64.82.15585134901151253', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.159.61', '2019-05-22 16:24:50', 18, 0, '', '2019-05-22 16:24:50');
INSERT INTO `access_log` VALUES (6443, '64.84.15585136011571255', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.92.195', '2019-05-22 16:26:41', 16, 0, '', '2019-05-22 16:26:41');
INSERT INTO `access_log` VALUES (6444, '64.82.15585136011571255', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.92.195', '2019-05-22 16:26:41', 19, 0, '', '2019-05-22 16:26:41');
INSERT INTO `access_log` VALUES (6445, '62.84.15585136018282039', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.92.195', '2019-05-22 16:26:42', 124, 0, '', '2019-05-22 16:26:42');
INSERT INTO `access_log` VALUES (6446, '62.88.15585136023952039', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.92.195', '2019-05-22 16:26:42', 17, 0, '', '2019-05-22 16:26:42');
INSERT INTO `access_log` VALUES (6447, '65.49.15585137375561217', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.19.124.149', '2019-05-22 16:28:58', 1, 1002001015, '账号未登陆', '2019-05-22 16:28:58');
INSERT INTO `access_log` VALUES (6448, '65.48.15585137375561211', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.19.124.149', '2019-05-22 16:28:58', 1, 1002001015, '账号未登陆', '2019-05-22 16:28:58');
INSERT INTO `access_log` VALUES (6449, '65.54.15585137375621213', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.19.124.149', '2019-05-22 16:28:58', 1, 1002001015, '账号未登陆', '2019-05-22 16:28:58');
INSERT INTO `access_log` VALUES (6450, '65.51.15585137561221205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.19.124.149', '2019-05-22 16:29:16', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 16:29:16');
INSERT INTO `access_log` VALUES (6451, '65.52.15585137617941209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.19.124.149', '2019-05-22 16:29:22', 246, 0, '', '2019-05-22 16:29:22');
INSERT INTO `access_log` VALUES (6452, '65.50.15585137622531215', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.19.124.149', '2019-05-22 16:29:22', 12, 0, '', '2019-05-22 16:29:22');
INSERT INTO `access_log` VALUES (6453, '65.47.15585137622541209', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.19.124.149', '2019-05-22 16:29:22', 13, 0, '', '2019-05-22 16:29:22');
INSERT INTO `access_log` VALUES (6454, '65.53.15585137622581211', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.19.124.149', '2019-05-22 16:29:22', 11, 0, '', '2019-05-22 16:29:22');
INSERT INTO `access_log` VALUES (6455, '62.87.15585137702412043', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.19.124.149', '2019-05-22 16:29:30', 18, 0, '', '2019-05-22 16:29:30');
INSERT INTO `access_log` VALUES (6456, '59.72.15585137809172063', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.19.124.149', '2019-05-22 16:29:41', 16, 0, '', '2019-05-22 16:29:41');
INSERT INTO `access_log` VALUES (6457, '65.54.15585137860541215', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.19.124.149', '2019-05-22 16:29:46', 26, 0, '', '2019-05-22 16:29:46');
INSERT INTO `access_log` VALUES (6458, '65.48.15585137887071213', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.19.124.149', '2019-05-22 16:29:49', 596, 0, '', '2019-05-22 16:29:49');
INSERT INTO `access_log` VALUES (6459, '65.46.15585137914791221', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.19.124.149', '2019-05-22 16:29:51', 251, 0, '', '2019-05-22 16:29:52');
INSERT INTO `access_log` VALUES (6460, '65.52.15585137979871211', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.19.124.149', '2019-05-22 16:29:58', 35, 0, '', '2019-05-22 16:29:58');
INSERT INTO `access_log` VALUES (6461, '62.86.15585145524652047', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 16:42:32', 43, 1002001012, '访问令牌已过期', '2019-05-22 16:42:33');
INSERT INTO `access_log` VALUES (6462, '65.53.15585145563141223', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 16:42:36', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 16:42:36');
INSERT INTO `access_log` VALUES (6463, '65.45.15585145746311233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 16:42:55', 7, 1002002000, '账号不存在', '2019-05-22 16:42:55');
INSERT INTO `access_log` VALUES (6464, '65.48.15585146043351225', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 16:43:24', 62, 0, '', '2019-05-22 16:43:24');
INSERT INTO `access_log` VALUES (6465, '65.46.15585146048431233', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 16:43:25', 13, 0, '', '2019-05-22 16:43:25');
INSERT INTO `access_log` VALUES (6466, '65.51.15585146048481219', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 16:43:25', 12, 0, '', '2019-05-22 16:43:25');
INSERT INTO `access_log` VALUES (6467, '65.52.15585146048541223', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 16:43:25', 12, 0, '', '2019-05-22 16:43:25');
INSERT INTO `access_log` VALUES (6468, '64.82.15585146271691269', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 16:43:47', 89, 0, '', '2019-05-22 16:43:47');
INSERT INTO `access_log` VALUES (6469, '64.84.15585146271641269', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 16:43:47', 97, 0, '', '2019-05-22 16:43:47');
INSERT INTO `access_log` VALUES (6470, '65.45.15585148104121237', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 16:46:50', 4, 0, '', '2019-05-22 16:46:50');
INSERT INTO `access_log` VALUES (6471, '65.54.15585148270161231', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 16:47:07', 4, 0, '', '2019-05-22 16:47:07');
INSERT INTO `access_log` VALUES (6472, '59.76.15585148782362077', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:47:58', 5, 0, '', '2019-05-22 16:47:58');
INSERT INTO `access_log` VALUES (6473, '59.79.15585148782362079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:47:58', 15, 2001001000, '服务端发生异常', '2019-05-22 16:47:58');
INSERT INTO `access_log` VALUES (6474, '64.76.15585148833551273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:03', 354, 0, '', '2019-05-22 16:48:04');
INSERT INTO `access_log` VALUES (6475, '64.84.15585148838251273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:04', 4, 0, '', '2019-05-22 16:48:04');
INSERT INTO `access_log` VALUES (6476, '64.82.15585148852511273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:05', 4, 0, '', '2019-05-22 16:48:05');
INSERT INTO `access_log` VALUES (6477, '64.78.15585148857621275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:06', 3, 0, '', '2019-05-22 16:48:06');
INSERT INTO `access_log` VALUES (6478, '64.80.15585148861481273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:06', 3, 0, '', '2019-05-22 16:48:06');
INSERT INTO `access_log` VALUES (6479, '59.71.15585148881452083', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:08', 4, 0, '', '2019-05-22 16:48:08');
INSERT INTO `access_log` VALUES (6480, '59.73.15585148881452083', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:08', 21, 2001001000, '服务端发生异常', '2019-05-22 16:48:08');
INSERT INTO `access_log` VALUES (6481, '64.83.15585148922551273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:12', 4, 0, '', '2019-05-22 16:48:12');
INSERT INTO `access_log` VALUES (6482, '64.85.15585148923351275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:12', 3, 0, '', '2019-05-22 16:48:12');
INSERT INTO `access_log` VALUES (6483, '64.79.15585148982211275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:18', 4, 0, '', '2019-05-22 16:48:18');
INSERT INTO `access_log` VALUES (6484, '64.77.15585148982961279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:18', 3, 0, '', '2019-05-22 16:48:18');
INSERT INTO `access_log` VALUES (6485, '59.72.15585149098672079', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:30', 34, 0, '', '2019-05-22 16:48:30');
INSERT INTO `access_log` VALUES (6486, '59.80.15585149098672079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:30', 35, 2001001000, '服务端发生异常', '2019-05-22 16:48:30');
INSERT INTO `access_log` VALUES (6487, '64.82.15585149177231275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:38', 3, 0, '', '2019-05-22 16:48:38');
INSERT INTO `access_log` VALUES (6488, '64.81.15585149178481275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:38', 3, 0, '', '2019-05-22 16:48:38');
INSERT INTO `access_log` VALUES (6489, '59.78.15585149186402083', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:39', 4, 0, '', '2019-05-22 16:48:39');
INSERT INTO `access_log` VALUES (6490, '59.76.15585149186432079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.72.156.142', '2019-05-22 16:48:39', 14, 2001001000, '服务端发生异常', '2019-05-22 16:48:39');
INSERT INTO `access_log` VALUES (6491, '59.72.15585152807282085', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.15.181.199', '2019-05-22 16:54:41', 5, 0, '', '2019-05-22 16:54:41');
INSERT INTO `access_log` VALUES (6492, '59.77.15585152807252087', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.15.181.199', '2019-05-22 16:54:41', 18, 2001001000, '服务端发生异常', '2019-05-22 16:54:41');
INSERT INTO `access_log` VALUES (6493, '64.77.15585152922231285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.15.181.199', '2019-05-22 16:54:52', 162, 0, '', '2019-05-22 16:54:52');
INSERT INTO `access_log` VALUES (6494, '64.76.15585152925151281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.15.181.199', '2019-05-22 16:54:53', 3, 0, '', '2019-05-22 16:54:53');
INSERT INTO `access_log` VALUES (6495, '64.84.15585152936341281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.15.181.199', '2019-05-22 16:54:54', 974, 0, '', '2019-05-22 16:54:55');
INSERT INTO `access_log` VALUES (6496, '64.82.15585152942331281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.15.181.199', '2019-05-22 16:54:54', 375, 0, '', '2019-05-22 16:54:55');
INSERT INTO `access_log` VALUES (6497, '59.78.15585152958182089', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.15.181.199', '2019-05-22 16:54:56', 15, 2001001000, '服务端发生异常', '2019-05-22 16:54:56');
INSERT INTO `access_log` VALUES (6498, '59.74.15585152958172089', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.15.181.199', '2019-05-22 16:54:56', 174, 0, '', '2019-05-22 16:54:56');
INSERT INTO `access_log` VALUES (6499, '59.76.15585153004282085', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.15.181.199', '2019-05-22 16:55:00', 4, 0, '', '2019-05-22 16:55:00');
INSERT INTO `access_log` VALUES (6500, '59.79.15585153004292087', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.15.181.199', '2019-05-22 16:55:00', 15, 2001001000, '服务端发生异常', '2019-05-22 16:55:00');
INSERT INTO `access_log` VALUES (6501, '64.83.15585156221091285', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 17:00:22', 1120, 0, '', '2019-05-22 17:00:23');
INSERT INTO `access_log` VALUES (6502, '64.80.15585156221091285', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 17:00:22', 1125, 0, '', '2019-05-22 17:00:23');
INSERT INTO `access_log` VALUES (6503, '65.48.15585157197831241', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 17:02:00', 5, 0, '', '2019-05-22 17:02:00');
INSERT INTO `access_log` VALUES (6504, '65.46.15585157454061249', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 17:02:25', 5, 0, '', '2019-05-22 17:02:25');
INSERT INTO `access_log` VALUES (6505, '64.83.15585157533441287', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=我的免费隧道&sellPoint=便宜&cid=794&visible=true&picUrls=http://static.shop.iocoder.cn/634181bb-c311-475d-89ce-e34f60582b05&skuStr=[{\"attrs\":[3],\"price\":2200,\"quantity\":2222222222222},{\"attrs\":[4],\"price\":3300,\"quantity\":2.2222222222222223e+22}]&description=<p>gggggggggggggggggggggggggggggggggggggggg</p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/92129a6f-d92c-45ca-8261-52b9e250710d\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 17:02:33', 12, 1002002009, NULL, '2019-05-22 17:02:33');
INSERT INTO `access_log` VALUES (6506, '59.71.15585162168742103', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:17', 5, 0, '', '2019-05-22 17:10:17');
INSERT INTO `access_log` VALUES (6507, '59.73.15585162168742103', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:17', 16, 2001001000, '服务端发生异常', '2019-05-22 17:10:17');
INSERT INTO `access_log` VALUES (6508, '64.85.15585162198741295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:20', 4, 0, '', '2019-05-22 17:10:20');
INSERT INTO `access_log` VALUES (6509, '64.79.15585162199971295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:20', 4, 0, '', '2019-05-22 17:10:20');
INSERT INTO `access_log` VALUES (6510, '66.52.15585162227861175', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:23', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-05-22 17:10:23');
INSERT INTO `access_log` VALUES (6511, '64.76.15585162251001295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:25', 4, 0, '', '2019-05-22 17:10:25');
INSERT INTO `access_log` VALUES (6512, '64.84.15585162252081295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:25', 3, 0, '', '2019-05-22 17:10:25');
INSERT INTO `access_log` VALUES (6513, '59.80.15585162262032099', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:26', 4, 0, '', '2019-05-22 17:10:26');
INSERT INTO `access_log` VALUES (6514, '59.72.15585162262032099', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:26', 14, 2001001000, '服务端发生异常', '2019-05-22 17:10:26');
INSERT INTO `access_log` VALUES (6515, '64.82.15585162284251295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:28', 4, 0, '', '2019-05-22 17:10:28');
INSERT INTO `access_log` VALUES (6516, '64.81.15585162285081295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:29', 3, 0, '', '2019-05-22 17:10:29');
INSERT INTO `access_log` VALUES (6517, '64.78.15585162293551297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:29', 3, 0, '', '2019-05-22 17:10:29');
INSERT INTO `access_log` VALUES (6518, '64.83.15585162297801295', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 17:10:30', 19, 0, '', '2019-05-22 17:10:30');
INSERT INTO `access_log` VALUES (6519, '64.80.15585162297891295', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 17:10:30', 13, 0, '', '2019-05-22 17:10:30');
INSERT INTO `access_log` VALUES (6520, '64.85.15585162299161297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:30', 3, 0, '', '2019-05-22 17:10:30');
INSERT INTO `access_log` VALUES (6521, '64.77.15585162340111301', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 17:10:34', 11, 0, '', '2019-05-22 17:10:34');
INSERT INTO `access_log` VALUES (6522, '64.79.15585162340081297', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 17:10:34', 16, 0, '', '2019-05-22 17:10:34');
INSERT INTO `access_log` VALUES (6523, '65.50.15585162355781251', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:36', 0, 1002001015, '账号未登陆', '2019-05-22 17:10:36');
INSERT INTO `access_log` VALUES (6524, '65.45.15585162355881257', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:36', 1, 1002001015, '账号未登陆', '2019-05-22 17:10:36');
INSERT INTO `access_log` VALUES (6525, '65.49.15585162356111255', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.221.114', '2019-05-22 17:10:36', 1, 1002001015, '账号未登陆', '2019-05-22 17:10:36');
INSERT INTO `access_log` VALUES (6526, '66.50.15585164064171175', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 17:13:26', 27, 0, '', '2019-05-22 17:13:26');
INSERT INTO `access_log` VALUES (6527, '59.72.15585236939322199', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:14:54', 15, 0, '', '2019-05-22 19:14:54');
INSERT INTO `access_log` VALUES (6528, '59.80.15585236939332199', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:14:54', 20, 2001001000, '服务端发生异常', '2019-05-22 19:14:54');
INSERT INTO `access_log` VALUES (6529, '64.79.15585237119241397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:12', 13, 0, '', '2019-05-22 19:15:12');
INSERT INTO `access_log` VALUES (6530, '64.76.15585237120471397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:12', 3, 0, '', '2019-05-22 19:15:12');
INSERT INTO `access_log` VALUES (6531, '64.84.15585237147651397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:15', 3, 0, '', '2019-05-22 19:15:15');
INSERT INTO `access_log` VALUES (6532, '64.82.15585237157561397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:16', 1311, 0, '', '2019-05-22 19:15:17');
INSERT INTO `access_log` VALUES (6533, '59.74.15585237184352203', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:18', 5, 0, '', '2019-05-22 19:15:18');
INSERT INTO `access_log` VALUES (6534, '59.79.15585237184352201', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:18', 15, 2001001000, '服务端发生异常', '2019-05-22 19:15:18');
INSERT INTO `access_log` VALUES (6535, '64.78.15585237234281399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:23', 3, 0, '', '2019-05-22 19:15:23');
INSERT INTO `access_log` VALUES (6536, '64.83.15585237235511397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:24', 3, 0, '', '2019-05-22 19:15:24');
INSERT INTO `access_log` VALUES (6537, '59.75.15585237267282203', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:27', 4, 0, '', '2019-05-22 19:15:27');
INSERT INTO `access_log` VALUES (6538, '59.71.15585237267292205', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:27', 64, 2001001000, '服务端发生异常', '2019-05-22 19:15:27');
INSERT INTO `access_log` VALUES (6539, '64.80.15585237304481397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:30', 3, 0, '', '2019-05-22 19:15:30');
INSERT INTO `access_log` VALUES (6540, '64.85.15585237305721399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:31', 3, 0, '', '2019-05-22 19:15:31');
INSERT INTO `access_log` VALUES (6541, '64.77.15585237336721403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:34', 4, 0, '', '2019-05-22 19:15:34');
INSERT INTO `access_log` VALUES (6542, '64.79.15585237338591399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:34', 3, 0, '', '2019-05-22 19:15:34');
INSERT INTO `access_log` VALUES (6543, '64.76.15585237346411399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:35', 3, 0, '', '2019-05-22 19:15:35');
INSERT INTO `access_log` VALUES (6544, '64.84.15585237348671399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:35', 3, 0, '', '2019-05-22 19:15:35');
INSERT INTO `access_log` VALUES (6545, '64.81.15585237357841399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:36', 81, 0, '', '2019-05-22 19:15:36');
INSERT INTO `access_log` VALUES (6546, '64.78.15585237360231401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:36', 3, 0, '', '2019-05-22 19:15:36');
INSERT INTO `access_log` VALUES (6547, '64.83.15585237382531399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:38', 3, 0, '', '2019-05-22 19:15:38');
INSERT INTO `access_log` VALUES (6548, '59.77.15585237402312203', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:40', 4, 0, '', '2019-05-22 19:15:40');
INSERT INTO `access_log` VALUES (6549, '64.80.15585237444911399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:44', 3, 0, '', '2019-05-22 19:15:44');
INSERT INTO `access_log` VALUES (6550, '64.85.15585237446321401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:45', 4, 0, '', '2019-05-22 19:15:45');
INSERT INTO `access_log` VALUES (6551, '59.77.15585237402312203', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:40', 4, 0, '', '2019-05-22 19:15:51');
INSERT INTO `access_log` VALUES (6552, '59.80.15585237402312201', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:15:40', 11098, 2001001000, '服务端发生异常', '2019-05-22 19:15:51');
INSERT INTO `access_log` VALUES (6553, '65.53.15585238002881351', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:16:40', 0, 1002001015, '账号未登陆', '2019-05-22 19:16:40');
INSERT INTO `access_log` VALUES (6554, '65.51.15585238002881345', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:16:40', 0, 1002001015, '账号未登陆', '2019-05-22 19:16:40');
INSERT INTO `access_log` VALUES (6555, '65.54.15585238002881351', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:16:40', 0, 1002001015, '账号未登陆', '2019-05-22 19:16:40');
INSERT INTO `access_log` VALUES (6556, '65.46.15585238196881359', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:17:00', 91, 0, '', '2019-05-22 19:17:00');
INSERT INTO `access_log` VALUES (6557, '65.47.15585238200681347', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:17:00', 14, 0, '', '2019-05-22 19:17:00');
INSERT INTO `access_log` VALUES (6558, '65.50.15585238200711355', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:17:00', 13, 0, '', '2019-05-22 19:17:00');
INSERT INTO `access_log` VALUES (6559, '65.49.15585238200651357', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:17:00', 23, 0, '', '2019-05-22 19:17:00');
INSERT INTO `access_log` VALUES (6560, '62.86.15585238394252171', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:17:19', 217, 0, '', '2019-05-22 19:17:20');
INSERT INTO `access_log` VALUES (6561, '62.86.15585242711742177', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:24:31', 24, 0, '', '2019-05-22 19:24:31');
INSERT INTO `access_log` VALUES (6562, '64.80.15585242976921407', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:24:58', 16, 0, '', '2019-05-22 19:24:58');
INSERT INTO `access_log` VALUES (6563, '64.83.15585242976921407', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:24:58', 21, 0, '', '2019-05-22 19:24:58');
INSERT INTO `access_log` VALUES (6564, '66.49.15585243365321285', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:25:37', 36, 0, '', '2019-05-22 19:25:37');
INSERT INTO `access_log` VALUES (6565, '59.80.15585243471952209', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:25:47', 65, 0, '', '2019-05-22 19:25:47');
INSERT INTO `access_log` VALUES (6566, '65.47.15585250020131363', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:36:42', 19, 0, '', '2019-05-22 19:36:42');
INSERT INTO `access_log` VALUES (6567, '65.45.15585250082061379', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:36:48', 12, 0, '', '2019-05-22 19:36:48');
INSERT INTO `access_log` VALUES (6568, '65.49.15585254088521379', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:43:29', 26, 0, '', '2019-05-22 19:43:29');
INSERT INTO `access_log` VALUES (6569, '65.47.15585254152151369', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:43:35', 13, 0, '', '2019-05-22 19:43:35');
INSERT INTO `access_log` VALUES (6570, '65.48.15585254261521377', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:43:46', 12, 0, '', '2019-05-22 19:43:46');
INSERT INTO `access_log` VALUES (6571, '65.54.15585254473031375', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:44:07', 18, 0, '', '2019-05-22 19:44:07');
INSERT INTO `access_log` VALUES (6572, '62.87.15585256483002203', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.160.225.135', '2019-05-22 19:47:28', 21, 0, '', '2019-05-22 19:47:28');
INSERT INTO `access_log` VALUES (6573, '65.48.15585285575591421', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:35:58', 24, 1002001012, '访问令牌已过期', '2019-05-22 20:35:58');
INSERT INTO `access_log` VALUES (6574, '65.45.15585285575591429', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:35:58', 25, 1002001012, '访问令牌已过期', '2019-05-22 20:35:58');
INSERT INTO `access_log` VALUES (6575, '65.51.15585285575601413', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:35:58', 27, 1002001012, '访问令牌已过期', '2019-05-22 20:35:58');
INSERT INTO `access_log` VALUES (6576, '65.54.15585285602171419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:00', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 20:36:00');
INSERT INTO `access_log` VALUES (6577, '65.52.15585285635461417', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:04', 122, 0, '', '2019-05-22 20:36:04');
INSERT INTO `access_log` VALUES (6578, '65.53.15585285639781417', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:04', 15, 0, '', '2019-05-22 20:36:04');
INSERT INTO `access_log` VALUES (6579, '65.46.15585285639801425', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:04', 14, 0, '', '2019-05-22 20:36:04');
INSERT INTO `access_log` VALUES (6580, '65.50.15585285639881419', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:04', 11, 0, '', '2019-05-22 20:36:04');
INSERT INTO `access_log` VALUES (6581, '65.47.15585285725511415', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:13', 24, 0, '', '2019-05-22 20:36:13');
INSERT INTO `access_log` VALUES (6582, '65.51.15585285747961415', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:15', 14, 0, '', '2019-05-22 20:36:15');
INSERT INTO `access_log` VALUES (6583, '65.45.15585285780051431', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:18', 14, 0, '', '2019-05-22 20:36:18');
INSERT INTO `access_log` VALUES (6584, '65.48.15585285794431423', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:19', 16, 0, '', '2019-05-22 20:36:19');
INSERT INTO `access_log` VALUES (6585, '65.54.15585285818401421', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:22', 12, 0, '', '2019-05-22 20:36:22');
INSERT INTO `access_log` VALUES (6586, '65.53.15585285870501419', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:27', 26, 0, '', '2019-05-22 20:36:27');
INSERT INTO `access_log` VALUES (6587, '59.76.15585285895132265', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:30', 29, 0, '', '2019-05-22 20:36:30');
INSERT INTO `access_log` VALUES (6588, '65.50.15585286117551421', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:52', 4, 0, '', '2019-05-22 20:36:52');
INSERT INTO `access_log` VALUES (6589, '59.73.15585286175452271', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:58', 64, 0, '', '2019-05-22 20:36:58');
INSERT INTO `access_log` VALUES (6590, '59.72.15585286192892267', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:36:59', 28, 0, '', '2019-05-22 20:36:59');
INSERT INTO `access_log` VALUES (6591, '59.80.15585286254352267', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:37:05', 12, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-22 20:37:05');
INSERT INTO `access_log` VALUES (6592, '65.51.15585286290331417', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:37:09', 18, 0, '', '2019-05-22 20:37:09');
INSERT INTO `access_log` VALUES (6593, '64.85.15585286314111467', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:37:11', 30, 0, '', '2019-05-22 20:37:11');
INSERT INTO `access_log` VALUES (6594, '64.83.15585286314061465', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:37:11', 36, 0, '', '2019-05-22 20:37:11');
INSERT INTO `access_log` VALUES (6595, '64.79.15585286337031467', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:37:14', 25, 0, '', '2019-05-22 20:37:14');
INSERT INTO `access_log` VALUES (6596, '64.77.15585286337031471', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:37:14', 29, 0, '', '2019-05-22 20:37:14');
INSERT INTO `access_log` VALUES (6597, '64.76.15585286352291467', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:37:15', 23, 0, '', '2019-05-22 20:37:15');
INSERT INTO `access_log` VALUES (6598, '64.84.15585286352291467', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:37:15', 20, 0, '', '2019-05-22 20:37:15');
INSERT INTO `access_log` VALUES (6599, '64.82.15585286352731467', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:37:15', 13, 0, '', '2019-05-22 20:37:15');
INSERT INTO `access_log` VALUES (6600, '65.53.15585286978481421', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:18', 5, 0, '', '2019-05-22 20:38:18');
INSERT INTO `access_log` VALUES (6601, '65.50.15585287097351423', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:30', 12, 0, '', '2019-05-22 20:38:30');
INSERT INTO `access_log` VALUES (6602, '65.49.15585287097361429', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:30', 11, 0, '', '2019-05-22 20:38:30');
INSERT INTO `access_log` VALUES (6603, '65.47.15585287097601419', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:30', 11, 0, '', '2019-05-22 20:38:30');
INSERT INTO `access_log` VALUES (6604, '64.77.15585287099541473', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:30', 35, 0, '', '2019-05-22 20:38:30');
INSERT INTO `access_log` VALUES (6605, '64.79.15585287099531469', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:30', 37, 0, '', '2019-05-22 20:38:30');
INSERT INTO `access_log` VALUES (6606, '64.76.15585287099981469', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:30', 12, 0, '', '2019-05-22 20:38:30');
INSERT INTO `access_log` VALUES (6607, '65.51.15585287153021419', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:35', 12, 0, '', '2019-05-22 20:38:35');
INSERT INTO `access_log` VALUES (6608, '65.45.15585287153041435', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:35', 12, 0, '', '2019-05-22 20:38:35');
INSERT INTO `access_log` VALUES (6609, '65.48.15585287153081427', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:35', 12, 0, '', '2019-05-22 20:38:35');
INSERT INTO `access_log` VALUES (6610, '64.81.15585287154181469', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:35', 18, 0, '', '2019-05-22 20:38:35');
INSERT INTO `access_log` VALUES (6611, '64.82.15585287154171469', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:35', 25, 0, '', '2019-05-22 20:38:35');
INSERT INTO `access_log` VALUES (6612, '64.84.15585287154161469', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:35', 26, 0, '', '2019-05-22 20:38:35');
INSERT INTO `access_log` VALUES (6613, '65.46.15585287190701431', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:39', 18, 0, '', '2019-05-22 20:38:39');
INSERT INTO `access_log` VALUES (6614, '65.53.15585287190701423', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:39', 20, 0, '', '2019-05-22 20:38:39');
INSERT INTO `access_log` VALUES (6615, '65.52.15585287190681423', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:39', 27, 0, '', '2019-05-22 20:38:39');
INSERT INTO `access_log` VALUES (6616, '64.83.15585287191971469', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:39', 15, 0, '', '2019-05-22 20:38:39');
INSERT INTO `access_log` VALUES (6617, '64.85.15585287192011471', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:39', 12, 0, '', '2019-05-22 20:38:39');
INSERT INTO `access_log` VALUES (6618, '64.80.15585287191921469', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:39', 24, 0, '', '2019-05-22 20:38:39');
INSERT INTO `access_log` VALUES (6619, '65.47.15585287221771421', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:42', 10, 0, '', '2019-05-22 20:38:42');
INSERT INTO `access_log` VALUES (6620, '65.50.15585287221811425', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:42', 9, 0, '', '2019-05-22 20:38:42');
INSERT INTO `access_log` VALUES (6621, '65.49.15585287221841431', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:42', 9, 0, '', '2019-05-22 20:38:42');
INSERT INTO `access_log` VALUES (6622, '64.76.15585287223071471', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:42', 17, 0, '', '2019-05-22 20:38:42');
INSERT INTO `access_log` VALUES (6623, '64.77.15585287223041475', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:42', 20, 0, '', '2019-05-22 20:38:42');
INSERT INTO `access_log` VALUES (6624, '64.79.15585287223021471', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:38:42', 28, 0, '', '2019-05-22 20:38:42');
INSERT INTO `access_log` VALUES (6625, '59.74.15585289473972275', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:42:27', 20, 0, '', '2019-05-22 20:42:27');
INSERT INTO `access_log` VALUES (6626, '59.79.15585289478302273', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:42:28', 105, 2001001000, '服务端发生异常', '2019-05-22 20:42:28');
INSERT INTO `access_log` VALUES (6627, '59.76.15585289502622271', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:42:30', 17, 0, '', '2019-05-22 20:42:30');
INSERT INTO `access_log` VALUES (6628, '64.85.15585289565301475', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:42:37', 15, 0, '', '2019-05-22 20:42:37');
INSERT INTO `access_log` VALUES (6629, '64.77.15585289590971479', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:42:39', 13, 0, '', '2019-05-22 20:42:39');
INSERT INTO `access_log` VALUES (6630, '59.71.15585289668882277', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:42:47', 96, 2001001000, '服务端发生异常', '2019-05-22 20:42:47');
INSERT INTO `access_log` VALUES (6631, '66.50.15585289704521343', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:42:50', 35, 0, '', '2019-05-22 20:42:50');
INSERT INTO `access_log` VALUES (6632, '66.55.15585289792831347', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:42:59', 37, 0, '', '2019-05-22 20:42:59');
INSERT INTO `access_log` VALUES (6633, '65.45.15585293341831445', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:48:54', 19, 0, '', '2019-05-22 20:48:54');
INSERT INTO `access_log` VALUES (6634, '65.51.15585293350801429', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:48:55', 13, 0, '', '2019-05-22 20:48:55');
INSERT INTO `access_log` VALUES (6635, '65.54.15585293359421435', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:48:56', 23, 0, '', '2019-05-22 20:48:56');
INSERT INTO `access_log` VALUES (6636, '65.53.15585293373491433', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:48:57', 12, 0, '', '2019-05-22 20:48:57');
INSERT INTO `access_log` VALUES (6637, '65.47.15585298470021437', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.98.16', '2019-05-22 20:57:27', 0, 1002001015, '账号未登陆', '2019-05-22 20:57:27');
INSERT INTO `access_log` VALUES (6638, '65.48.15585298470081445', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.98.16', '2019-05-22 20:57:27', 1, 1002001015, '账号未登陆', '2019-05-22 20:57:27');
INSERT INTO `access_log` VALUES (6639, '65.45.15585298472261453', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.98.16', '2019-05-22 20:57:27', 0, 1002001015, '账号未登陆', '2019-05-22 20:57:27');
INSERT INTO `access_log` VALUES (6640, '65.51.15585298499201437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.98.16', '2019-05-22 20:57:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 20:57:30');
INSERT INTO `access_log` VALUES (6641, '65.54.15585298580521443', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.98.16', '2019-05-22 20:57:38', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 20:57:38');
INSERT INTO `access_log` VALUES (6642, '65.46.15585298689671449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.98.16', '2019-05-22 20:57:49', 90, 0, '', '2019-05-22 20:57:49');
INSERT INTO `access_log` VALUES (6643, '65.52.15585298694821441', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.98.16', '2019-05-22 20:57:49', 12, 0, '', '2019-05-22 20:57:49');
INSERT INTO `access_log` VALUES (6644, '65.50.15585298694871443', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.98.16', '2019-05-22 20:57:49', 10, 0, '', '2019-05-22 20:57:49');
INSERT INTO `access_log` VALUES (6645, '65.49.15585298694981449', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.98.16', '2019-05-22 20:57:49', 23, 0, '', '2019-05-22 20:57:50');
INSERT INTO `access_log` VALUES (6646, '62.80.15585298775692257', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.98.16', '2019-05-22 20:57:58', 29, 0, '', '2019-05-22 20:57:58');
INSERT INTO `access_log` VALUES (6647, '66.54.15585298892281355', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.98.16', '2019-05-22 20:58:09', 37, 0, '', '2019-05-22 20:58:09');
INSERT INTO `access_log` VALUES (6648, '59.77.15585298942372287', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.98.16', '2019-05-22 20:58:14', 17, 0, '', '2019-05-22 20:58:14');
INSERT INTO `access_log` VALUES (6649, '65.47.15585364487011529', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.28.181.219', '2019-05-22 22:47:29', 1, 1002001015, '账号未登陆', '2019-05-22 22:47:29');
INSERT INTO `access_log` VALUES (6650, '65.45.15585364487021545', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.28.181.219', '2019-05-22 22:47:29', 1, 1002001015, '账号未登陆', '2019-05-22 22:47:29');
INSERT INTO `access_log` VALUES (6651, '65.51.15585364487061529', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.28.181.219', '2019-05-22 22:47:29', 1, 1002001015, '账号未登陆', '2019-05-22 22:47:29');
INSERT INTO `access_log` VALUES (6652, '65.53.15585364513491531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.28.181.219', '2019-05-22 22:47:31', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-22 22:47:31');
INSERT INTO `access_log` VALUES (6653, '65.52.15585364687221531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.28.181.219', '2019-05-22 22:47:49', 6, 1002002000, '账号不存在', '2019-05-22 22:47:49');
INSERT INTO `access_log` VALUES (6654, '65.46.15585364896551539', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.28.181.219', '2019-05-22 22:48:10', 106, 0, '', '2019-05-22 22:48:10');
INSERT INTO `access_log` VALUES (6655, '65.48.15585364899821539', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.28.181.219', '2019-05-22 22:48:10', 16, 0, '', '2019-05-22 22:48:10');
INSERT INTO `access_log` VALUES (6656, '65.51.15585364899831531', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.28.181.219', '2019-05-22 22:48:10', 17, 0, '', '2019-05-22 22:48:10');
INSERT INTO `access_log` VALUES (6657, '65.45.15585364899901547', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.28.181.219', '2019-05-22 22:48:10', 13, 0, '', '2019-05-22 22:48:10');
INSERT INTO `access_log` VALUES (6658, '65.53.15585365095311533', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.28.181.219', '2019-05-22 22:48:30', 24, 0, '', '2019-05-22 22:48:30');
INSERT INTO `access_log` VALUES (6659, '65.51.15585498511921711', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '139.226.106.153', '2019-05-23 02:30:51', 1, 1002001015, '账号未登陆', '2019-05-23 02:30:51');
INSERT INTO `access_log` VALUES (6660, '65.48.15585498512571719', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '139.226.106.153', '2019-05-23 02:30:51', 1, 1002001015, '账号未登陆', '2019-05-23 02:30:51');
INSERT INTO `access_log` VALUES (6661, '65.49.15585498513941725', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '139.226.106.153', '2019-05-23 02:30:51', 1, 1002001015, '账号未登陆', '2019-05-23 02:30:51');
INSERT INTO `access_log` VALUES (6662, '65.47.15585727921532017', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.137.2.52', '2019-05-23 08:53:12', 17, 1002001012, '访问令牌已过期', '2019-05-23 08:53:12');
INSERT INTO `access_log` VALUES (6663, '65.46.15585727921532025', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.137.2.52', '2019-05-23 08:53:12', 21, 1002001012, '访问令牌已过期', '2019-05-23 08:53:12');
INSERT INTO `access_log` VALUES (6664, '65.53.15585727921532019', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.137.2.52', '2019-05-23 08:53:12', 18, 1002001012, '访问令牌已过期', '2019-05-23 08:53:12');
INSERT INTO `access_log` VALUES (6665, '65.50.15585727924182017', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.137.2.52', '2019-05-23 08:53:12', 5, 1002001012, '访问令牌已过期', '2019-05-23 08:53:12');
INSERT INTO `access_log` VALUES (6666, '59.78.15585738509962875', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.232.77', '2019-05-23 09:10:51', 27, 2001001000, '服务端发生异常', '2019-05-23 09:10:51');
INSERT INTO `access_log` VALUES (6667, '59.74.15585738509972875', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.232.77', '2019-05-23 09:10:51', 19, 0, '', '2019-05-23 09:10:51');
INSERT INTO `access_log` VALUES (6668, '64.82.15585738551692073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.232.77', '2019-05-23 09:10:55', 13, 0, '', '2019-05-23 09:10:55');
INSERT INTO `access_log` VALUES (6669, '64.81.15585738553892073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.232.77', '2019-05-23 09:10:55', 4, 0, '', '2019-05-23 09:10:55');
INSERT INTO `access_log` VALUES (6670, '64.84.15585738574252073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.232.77', '2019-05-23 09:10:57', 4, 0, '', '2019-05-23 09:10:57');
INSERT INTO `access_log` VALUES (6671, '64.80.15585738583642073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.232.77', '2019-05-23 09:10:58', 4, 0, '', '2019-05-23 09:10:58');
INSERT INTO `access_log` VALUES (6672, '64.83.15585738590542073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.232.77', '2019-05-23 09:10:59', 3, 0, '', '2019-05-23 09:10:59');
INSERT INTO `access_log` VALUES (6673, '59.79.15585738604592873', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.232.77', '2019-05-23 09:11:00', 4, 0, '', '2019-05-23 09:11:00');
INSERT INTO `access_log` VALUES (6674, '59.76.15585738604592871', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.232.77', '2019-05-23 09:11:00', 38, 2001001000, '服务端发生异常', '2019-05-23 09:11:00');
INSERT INTO `access_log` VALUES (6675, '65.47.15585794608462107', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.110.36.241', '2019-05-23 10:44:21', 0, 1002001015, '账号未登陆', '2019-05-23 10:44:21');
INSERT INTO `access_log` VALUES (6676, '65.48.15585794608462115', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.110.36.241', '2019-05-23 10:44:21', 1, 1002001015, '账号未登陆', '2019-05-23 10:44:21');
INSERT INTO `access_log` VALUES (6677, '65.49.15585794608462121', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.110.36.241', '2019-05-23 10:44:21', 0, 1002001015, '账号未登陆', '2019-05-23 10:44:21');
INSERT INTO `access_log` VALUES (6678, '65.53.15585794644732109', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.110.36.241', '2019-05-23 10:44:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 10:44:24');
INSERT INTO `access_log` VALUES (6679, '65.50.15585794688532107', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.110.36.241', '2019-05-23 10:44:29', 75, 0, '', '2019-05-23 10:44:29');
INSERT INTO `access_log` VALUES (6680, '65.52.15585794692602107', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.110.36.241', '2019-05-23 10:44:29', 13, 0, '', '2019-05-23 10:44:29');
INSERT INTO `access_log` VALUES (6681, '65.54.15585794692692107', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.110.36.241', '2019-05-23 10:44:29', 12, 0, '', '2019-05-23 10:44:29');
INSERT INTO `access_log` VALUES (6682, '65.45.15585794692742123', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.110.36.241', '2019-05-23 10:44:29', 11, 0, '', '2019-05-23 10:44:29');
INSERT INTO `access_log` VALUES (6683, '62.81.15585794737782913', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.110.36.241', '2019-05-23 10:44:34', 28, 0, '', '2019-05-23 10:44:34');
INSERT INTO `access_log` VALUES (6684, '59.80.15585794806122947', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.110.36.241', '2019-05-23 10:44:41', 28, 0, '', '2019-05-23 10:44:41');
INSERT INTO `access_log` VALUES (6685, '64.80.15585794894102149', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.110.36.241', '2019-05-23 10:44:49', 17, 0, '', '2019-05-23 10:44:49');
INSERT INTO `access_log` VALUES (6686, '64.81.15585794894012151', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.110.36.241', '2019-05-23 10:44:49', 29, 0, '', '2019-05-23 10:44:49');
INSERT INTO `access_log` VALUES (6687, '59.71.15585803076402963', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.220.50.177', '2019-05-23 10:58:28', 21, 2001001000, '服务端发生异常', '2019-05-23 10:58:28');
INSERT INTO `access_log` VALUES (6688, '59.73.15585803076402963', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.220.50.177', '2019-05-23 10:58:28', 138, 0, '', '2019-05-23 10:58:28');
INSERT INTO `access_log` VALUES (6689, '64.77.15585803121462169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.220.50.177', '2019-05-23 10:58:32', 6, 0, '', '2019-05-23 10:58:32');
INSERT INTO `access_log` VALUES (6690, '64.84.15585803122712163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.220.50.177', '2019-05-23 10:58:32', 3, 0, '', '2019-05-23 10:58:32');
INSERT INTO `access_log` VALUES (6691, '59.75.15585808494142969', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:07:29', 5, 0, '', '2019-05-23 11:07:29');
INSERT INTO `access_log` VALUES (6692, '59.76.15585808494142965', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:07:29', 29, 2001001000, '服务端发生异常', '2019-05-23 11:07:29');
INSERT INTO `access_log` VALUES (6693, '64.79.15585808552542169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:07:35', 816, 0, '', '2019-05-23 11:07:36');
INSERT INTO `access_log` VALUES (6694, '64.77.15585808562142177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:07:36', 4, 0, '', '2019-05-23 11:07:36');
INSERT INTO `access_log` VALUES (6695, '64.84.15585808580622171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:07:38', 3, 0, '', '2019-05-23 11:07:38');
INSERT INTO `access_log` VALUES (6696, '64.78.15585808586232171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:07:39', 3, 0, '', '2019-05-23 11:07:39');
INSERT INTO `access_log` VALUES (6697, '65.46.15585808819252135', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:08:02', 1, 1002001015, '账号未登陆', '2019-05-23 11:08:02');
INSERT INTO `access_log` VALUES (6698, '65.53.15585808819282129', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:08:02', 1, 1002001015, '账号未登陆', '2019-05-23 11:08:02');
INSERT INTO `access_log` VALUES (6699, '65.50.15585808819502127', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:08:02', 1, 1002001015, '账号未登陆', '2019-05-23 11:08:02');
INSERT INTO `access_log` VALUES (6700, '65.52.15585808859502127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:08:06', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 11:08:06');
INSERT INTO `access_log` VALUES (6701, '65.45.15585809015172143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:08:22', 208, 0, '', '2019-05-23 11:08:22');
INSERT INTO `access_log` VALUES (6702, '65.51.15585809019922129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:08:22', 13, 0, '', '2019-05-23 11:08:22');
INSERT INTO `access_log` VALUES (6703, '65.48.15585809019992137', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:08:22', 11, 0, '', '2019-05-23 11:08:22');
INSERT INTO `access_log` VALUES (6704, '65.47.15585809020022129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:08:22', 11, 0, '', '2019-05-23 11:08:22');
INSERT INTO `access_log` VALUES (6705, '62.87.15585809098092945', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:08:30', 19, 0, '', '2019-05-23 11:08:30');
INSERT INTO `access_log` VALUES (6706, '62.80.15585809435122941', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:09:04', 22, 0, '', '2019-05-23 11:09:04');
INSERT INTO `access_log` VALUES (6707, '65.52.15585809555712129', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:16', 5, 1002001012, '访问令牌已过期', '2019-05-23 11:09:16');
INSERT INTO `access_log` VALUES (6708, '65.54.15585809555902129', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:16', 4, 1002001012, '访问令牌已过期', '2019-05-23 11:09:16');
INSERT INTO `access_log` VALUES (6709, '65.45.15585809556172145', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:16', 4, 1002001012, '访问令牌已过期', '2019-05-23 11:09:16');
INSERT INTO `access_log` VALUES (6710, '66.52.15585809616612037', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:09:22', 483, 0, '', '2019-05-23 11:09:22');
INSERT INTO `access_log` VALUES (6711, '65.47.15585809648152131', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:25', 5, 1002001012, '访问令牌已过期', '2019-05-23 11:09:25');
INSERT INTO `access_log` VALUES (6712, '65.48.15585809648292139', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:25', 3, 1002001012, '访问令牌已过期', '2019-05-23 11:09:25');
INSERT INTO `access_log` VALUES (6713, '65.49.15585809648442145', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:25', 4, 1002001012, '访问令牌已过期', '2019-05-23 11:09:25');
INSERT INTO `access_log` VALUES (6714, '59.76.15585809687302967', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:09:29', 21, 0, '', '2019-05-23 11:09:29');
INSERT INTO `access_log` VALUES (6715, '65.46.15585809703502139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 11:09:30');
INSERT INTO `access_log` VALUES (6716, '65.50.15585809767652131', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:37', 132, 0, '', '2019-05-23 11:09:37');
INSERT INTO `access_log` VALUES (6717, '65.53.15585809774302133', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:37', 12, 0, '', '2019-05-23 11:09:37');
INSERT INTO `access_log` VALUES (6718, '65.54.15585809774392131', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:37', 10, 0, '', '2019-05-23 11:09:37');
INSERT INTO `access_log` VALUES (6719, '65.52.15585809774572131', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:37', 10, 0, '', '2019-05-23 11:09:37');
INSERT INTO `access_log` VALUES (6720, '59.71.15585809794942973', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:09:39', 27, 0, '', '2019-05-23 11:09:40');
INSERT INTO `access_log` VALUES (6721, '64.84.15585809850572173', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:45', 16, 0, '', '2019-05-23 11:09:45');
INSERT INTO `access_log` VALUES (6722, '64.78.15585809850652173', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:45', 11, 0, '', '2019-05-23 11:09:45');
INSERT INTO `access_log` VALUES (6723, '64.81.15585809872062173', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:09:47', 13, 0, '', '2019-05-23 11:09:47');
INSERT INTO `access_log` VALUES (6724, '64.80.15585809894142171', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:49', 17, 0, '', '2019-05-23 11:09:49');
INSERT INTO `access_log` VALUES (6725, '64.83.15585809894342171', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-23 11:09:49', 11, 0, '', '2019-05-23 11:09:49');
INSERT INTO `access_log` VALUES (6726, '64.82.15585809901412173', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:09:50', 932, 0, '', '2019-05-23 11:09:51');
INSERT INTO `access_log` VALUES (6727, '64.79.15585809961542173', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:09:56', 483, 0, '', '2019-05-23 11:09:57');
INSERT INTO `access_log` VALUES (6728, '64.76.15585809961522171', 27, 2, 'product-application', '/product-api/admins/spu/list', 'ids=29,32,36', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:09:56', 1110, 0, '', '2019-05-23 11:09:57');
INSERT INTO `access_log` VALUES (6729, '59.72.15585810029732969', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/update_card', 'id=6&title=优惠劵C&description=优惠劵C&quota=1&total=1000&rangeType=20&rangeValues=29,32,36', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:10:03', 15, 1002002009, NULL, '2019-05-23 11:10:03');
INSERT INTO `access_log` VALUES (6730, '64.77.15585810048352181', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:10:05', 13, 0, '', '2019-05-23 11:10:05');
INSERT INTO `access_log` VALUES (6731, '65.47.15585810067232133', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:10:07', 23, 0, '', '2019-05-23 11:10:07');
INSERT INTO `access_log` VALUES (6732, '65.48.15585810120682141', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:10:12', 15, 0, '', '2019-05-23 11:10:12');
INSERT INTO `access_log` VALUES (6733, '65.46.15585810160392141', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:10:16', 14, 0, '', '2019-05-23 11:10:16');
INSERT INTO `access_log` VALUES (6734, '65.54.15585810257242133', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:10:26', 11, 0, '', '2019-05-23 11:10:26');
INSERT INTO `access_log` VALUES (6735, '65.53.15585810434342135', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:10:43', 13, 0, '', '2019-05-23 11:10:43');
INSERT INTO `access_log` VALUES (6736, '65.45.15585810440372149', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:10:44', 21, 0, '', '2019-05-23 11:10:44');
INSERT INTO `access_log` VALUES (6737, '62.83.15585810472102945', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.54', '2019-05-23 11:10:47', 17, 0, '', '2019-05-23 11:10:47');
INSERT INTO `access_log` VALUES (6738, '65.49.15585818338872159', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:23:54', 0, 1002001015, '账号未登陆', '2019-05-23 11:23:54');
INSERT INTO `access_log` VALUES (6739, '65.48.15585818338912153', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:23:54', 0, 1002001015, '账号未登陆', '2019-05-23 11:23:54');
INSERT INTO `access_log` VALUES (6740, '65.46.15585818338942153', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:23:54', 1, 1002001015, '账号未登陆', '2019-05-23 11:23:54');
INSERT INTO `access_log` VALUES (6741, '65.54.15585818364812145', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:23:56', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 11:23:56');
INSERT INTO `access_log` VALUES (6742, '65.52.15585818391982145', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:23:59', 88, 0, '', '2019-05-23 11:23:59');
INSERT INTO `access_log` VALUES (6743, '65.53.15585818395012147', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:00', 11, 0, '', '2019-05-23 11:24:00');
INSERT INTO `access_log` VALUES (6744, '65.45.15585818395012161', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:00', 12, 0, '', '2019-05-23 11:24:00');
INSERT INTO `access_log` VALUES (6745, '65.51.15585818395062147', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:00', 11, 0, '', '2019-05-23 11:24:00');
INSERT INTO `access_log` VALUES (6746, '62.88.15585818433512957', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:03', 20, 0, '', '2019-05-23 11:24:03');
INSERT INTO `access_log` VALUES (6747, '62.87.15585818467512959', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:07', 27, 0, '', '2019-05-23 11:24:07');
INSERT INTO `access_log` VALUES (6748, '65.50.15585818572982147', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:17', 23, 0, '', '2019-05-23 11:24:17');
INSERT INTO `access_log` VALUES (6749, '65.46.15585818600742155', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:20', 13, 0, '', '2019-05-23 11:24:20');
INSERT INTO `access_log` VALUES (6750, '65.49.15585818610342161', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:21', 23, 0, '', '2019-05-23 11:24:21');
INSERT INTO `access_log` VALUES (6751, '65.48.15585818635142155', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:24', 17, 0, '', '2019-05-23 11:24:24');
INSERT INTO `access_log` VALUES (6752, '65.52.15585818652632147', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:25', 28, 0, '', '2019-05-23 11:24:25');
INSERT INTO `access_log` VALUES (6753, '65.45.15585818679272163', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=9', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:28', 13, 0, '', '2019-05-23 11:24:28');
INSERT INTO `access_log` VALUES (6754, '65.53.15585818724022149', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:32', 12, 0, '', '2019-05-23 11:24:32');
INSERT INTO `access_log` VALUES (6755, '65.51.15585818759072149', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:36', 65, 0, '', '2019-05-23 11:24:36');
INSERT INTO `access_log` VALUES (6756, '65.50.15585818810932149', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:41', 11, 0, '', '2019-05-23 11:24:41');
INSERT INTO `access_log` VALUES (6757, '59.77.15585818933002983', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:53', 56, 0, '', '2019-05-23 11:24:53');
INSERT INTO `access_log` VALUES (6758, '66.50.15585818961082049', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:56', 41, 0, '', '2019-05-23 11:24:56');
INSERT INTO `access_log` VALUES (6759, '62.83.15585818979142957', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:24:58', 22, 0, '', '2019-05-23 11:24:58');
INSERT INTO `access_log` VALUES (6760, '59.80.15585819010012981', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:25:01', 22, 0, '', '2019-05-23 11:25:01');
INSERT INTO `access_log` VALUES (6761, '65.49.15585819038462163', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:25:04', 11, 0, '', '2019-05-23 11:25:04');
INSERT INTO `access_log` VALUES (6762, '65.48.15585819049312157', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:25:05', 24, 0, '', '2019-05-23 11:25:05');
INSERT INTO `access_log` VALUES (6763, '64.81.15585819121212187', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:25:12', 21, 0, '', '2019-05-23 11:25:12');
INSERT INTO `access_log` VALUES (6764, '64.84.15585819121172187', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:25:12', 27, 0, '', '2019-05-23 11:25:12');
INSERT INTO `access_log` VALUES (6765, '65.52.15585819219192149', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:25:22', 4, 0, '', '2019-05-23 11:25:22');
INSERT INTO `access_log` VALUES (6766, '62.84.15585820966842957', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:28:17', 55, 0, '', '2019-05-23 11:28:17');
INSERT INTO `access_log` VALUES (6767, '62.87.15585820984762963', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:28:18', 19, 0, '', '2019-05-23 11:28:18');
INSERT INTO `access_log` VALUES (6768, '66.51.15585821026662055', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:28:23', 23, 0, '', '2019-05-23 11:28:23');
INSERT INTO `access_log` VALUES (6769, '59.71.15585821168422989', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:28:37', 100, 2001001000, '服务端发生异常', '2019-05-23 11:28:37');
INSERT INTO `access_log` VALUES (6770, '65.50.15585821212682153', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:28:41', 24, 0, '', '2019-05-23 11:28:41');
INSERT INTO `access_log` VALUES (6771, '65.46.15585821246832161', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:28:45', 17, 0, '', '2019-05-23 11:28:45');
INSERT INTO `access_log` VALUES (6772, '65.48.15585821423222161', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:29:02', 13, 0, '', '2019-05-23 11:29:02');
INSERT INTO `access_log` VALUES (6773, '65.54.15585821428632153', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:29:03', 11, 0, '', '2019-05-23 11:29:03');
INSERT INTO `access_log` VALUES (6774, '65.52.15585821439512153', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:29:04', 21, 0, '', '2019-05-23 11:29:04');
INSERT INTO `access_log` VALUES (6775, '62.85.15585821687382959', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:29:29', 21, 0, '', '2019-05-23 11:29:29');
INSERT INTO `access_log` VALUES (6776, '64.84.15585821763282191', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:29:36', 17, 0, '', '2019-05-23 11:29:36');
INSERT INTO `access_log` VALUES (6777, '64.81.15585821763692191', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:29:36', 13, 0, '', '2019-05-23 11:29:36');
INSERT INTO `access_log` VALUES (6778, '62.87.15585821882642965', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:29:48', 17, 0, '', '2019-05-23 11:29:48');
INSERT INTO `access_log` VALUES (6779, '64.80.15585821954772189', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:29:55', 13, 0, '', '2019-05-23 11:29:55');
INSERT INTO `access_log` VALUES (6780, '64.85.15585821954772191', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:29:55', 15, 0, '', '2019-05-23 11:29:55');
INSERT INTO `access_log` VALUES (6781, '64.82.15585821969922191', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:29:57', 13, 0, '', '2019-05-23 11:29:57');
INSERT INTO `access_log` VALUES (6782, '64.79.15585821969932191', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:29:57', 16, 0, '', '2019-05-23 11:29:57');
INSERT INTO `access_log` VALUES (6783, '64.77.15585821998032199', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:30:00', 12, 0, '', '2019-05-23 11:30:00');
INSERT INTO `access_log` VALUES (6784, '64.76.15585821997972189', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:30:00', 19, 0, '', '2019-05-23 11:30:00');
INSERT INTO `access_log` VALUES (6785, '64.78.15585821998442193', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:30:00', 12, 0, '', '2019-05-23 11:30:00');
INSERT INTO `access_log` VALUES (6786, '65.49.15585822097832169', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 11:30:10', 3, 1002001012, '访问令牌已过期', '2019-05-23 11:30:10');
INSERT INTO `access_log` VALUES (6787, '65.48.15585822097922163', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 11:30:10', 3, 1002001012, '访问令牌已过期', '2019-05-23 11:30:10');
INSERT INTO `access_log` VALUES (6788, '65.46.15585822097802163', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 11:30:10', 4, 1002001012, '访问令牌已过期', '2019-05-23 11:30:10');
INSERT INTO `access_log` VALUES (6789, '65.47.15585822899052157', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 11:31:30', 78, 0, '', '2019-05-23 11:31:30');
INSERT INTO `access_log` VALUES (6790, '65.50.15585822904752157', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 11:31:30', 11, 0, '', '2019-05-23 11:31:30');
INSERT INTO `access_log` VALUES (6791, '65.49.15585822904852171', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 11:31:30', 11, 0, '', '2019-05-23 11:31:30');
INSERT INTO `access_log` VALUES (6792, '65.48.15585822905132165', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 11:31:31', 11, 0, '', '2019-05-23 11:31:31');
INSERT INTO `access_log` VALUES (6793, '62.85.15585883529883041', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:12:33', 19, 1002001012, '访问令牌已过期', '2019-05-23 13:12:33');
INSERT INTO `access_log` VALUES (6794, '65.52.15585890685262247', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:24:29', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 13:24:29');
INSERT INTO `access_log` VALUES (6795, '65.53.15585890903862249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:24:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 13:24:50');
INSERT INTO `access_log` VALUES (6796, '65.52.15585891163452249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:25:16', 1220, 0, '', '2019-05-23 13:25:18');
INSERT INTO `access_log` VALUES (6797, '65.46.15585891182262257', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:25:18', 192, 0, '', '2019-05-23 13:25:18');
INSERT INTO `access_log` VALUES (6798, '65.49.15585891182302263', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:25:18', 189, 0, '', '2019-05-23 13:25:18');
INSERT INTO `access_log` VALUES (6799, '65.53.15585891182612251', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:25:18', 167, 0, '', '2019-05-23 13:25:18');
INSERT INTO `access_log` VALUES (6800, '65.54.15585894763572255', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '61.153.7.60', '2019-05-23 13:31:16', 0, 1002001015, '账号未登陆', '2019-05-23 13:31:16');
INSERT INTO `access_log` VALUES (6801, '65.48.15585894763612263', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '61.153.7.60', '2019-05-23 13:31:16', 0, 1002001015, '账号未登陆', '2019-05-23 13:31:16');
INSERT INTO `access_log` VALUES (6802, '65.52.15585894763642255', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '61.153.7.60', '2019-05-23 13:31:16', 0, 1002001015, '账号未登陆', '2019-05-23 13:31:16');
INSERT INTO `access_log` VALUES (6803, '65.49.15585894790842269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '61.153.7.60', '2019-05-23 13:31:19', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 13:31:19');
INSERT INTO `access_log` VALUES (6804, '65.47.15585895260602255', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.153.7.60', '2019-05-23 13:32:06', 0, 1002001015, '账号未登陆', '2019-05-23 13:32:06');
INSERT INTO `access_log` VALUES (6805, '65.51.15585895260632257', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.153.7.60', '2019-05-23 13:32:06', 1, 1002001015, '账号未登陆', '2019-05-23 13:32:06');
INSERT INTO `access_log` VALUES (6806, '65.50.15585895260672257', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.153.7.60', '2019-05-23 13:32:06', 1, 1002001015, '账号未登陆', '2019-05-23 13:32:06');
INSERT INTO `access_log` VALUES (6807, '65.48.15585895382282265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.153.7.60', '2019-05-23 13:32:18', 93, 0, '', '2019-05-23 13:32:18');
INSERT INTO `access_log` VALUES (6808, '65.49.15585895584232271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.153.7.60', '2019-05-23 13:32:38', 170, 0, '', '2019-05-23 13:32:39');
INSERT INTO `access_log` VALUES (6809, '65.53.15585895683052259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.153.7.60', '2019-05-23 13:32:48', 83, 0, '', '2019-05-23 13:32:48');
INSERT INTO `access_log` VALUES (6810, '65.45.15585895731282273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.153.7.60', '2019-05-23 13:32:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 13:32:53');
INSERT INTO `access_log` VALUES (6811, '65.51.15585895759602259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.153.7.60', '2019-05-23 13:32:56', 136, 0, '', '2019-05-23 13:32:56');
INSERT INTO `access_log` VALUES (6812, '65.50.15585895861102259', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.151.207.205', '2019-05-23 13:33:06', 1, 1002001015, '账号未登陆', '2019-05-23 13:33:06');
INSERT INTO `access_log` VALUES (6813, '65.52.15585895861902259', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.207.186', '2019-05-23 13:33:06', 1, 1002001015, '账号未登陆', '2019-05-23 13:33:06');
INSERT INTO `access_log` VALUES (6814, '65.48.15585895867202267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:33:07', 91, 0, '', '2019-05-23 13:33:07');
INSERT INTO `access_log` VALUES (6815, '65.49.15585895870672273', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:33:07', 15, 0, '', '2019-05-23 13:33:07');
INSERT INTO `access_log` VALUES (6816, '65.54.15585895870642259', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:33:07', 19, 0, '', '2019-05-23 13:33:07');
INSERT INTO `access_log` VALUES (6817, '65.46.15585895870692267', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:33:07', 15, 0, '', '2019-05-23 13:33:07');
INSERT INTO `access_log` VALUES (6818, '65.53.15585895874472261', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.129.8.179', '2019-05-23 13:33:07', 1, 1002001015, '账号未登陆', '2019-05-23 13:33:07');
INSERT INTO `access_log` VALUES (6819, '62.87.15585895942553065', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:33:14', 27, 0, '', '2019-05-23 13:33:14');
INSERT INTO `access_log` VALUES (6820, '62.81.15585896024993053', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:33:23', 23, 0, '', '2019-05-23 13:33:23');
INSERT INTO `access_log` VALUES (6821, '66.48.15585896058962155', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:33:26', 46, 0, '', '2019-05-23 13:33:26');
INSERT INTO `access_log` VALUES (6822, '59.71.15585896126233089', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:33:33', 25, 0, '', '2019-05-23 13:33:33');
INSERT INTO `access_log` VALUES (6823, '59.72.15585896152113085', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:33:35', 133, 2001001000, '服务端发生异常', '2019-05-23 13:33:35');
INSERT INTO `access_log` VALUES (6824, '59.77.15585896178493087', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:33:38', 17, 0, '', '2019-05-23 13:33:38');
INSERT INTO `access_log` VALUES (6825, '59.80.15585896208903085', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:33:41', 17, 0, '', '2019-05-23 13:33:41');
INSERT INTO `access_log` VALUES (6826, '65.50.15585896229662261', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:33:43', 24, 0, '', '2019-05-23 13:33:43');
INSERT INTO `access_log` VALUES (6827, '65.48.15585896360092269', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:33:56', 11, 0, '', '2019-05-23 13:33:56');
INSERT INTO `access_log` VALUES (6828, '65.49.15585896457862275', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:34:06', 16, 0, '', '2019-05-23 13:34:06');
INSERT INTO `access_log` VALUES (6829, '62.85.15585896544873059', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.166', '2019-05-23 13:34:14', 0, 1002001015, '账号未登陆', '2019-05-23 13:34:14');
INSERT INTO `access_log` VALUES (6830, '62.84.15585896621383061', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.129.6.251', '2019-05-23 13:34:22', 1, 1002001015, '账号未登陆', '2019-05-23 13:34:22');
INSERT INTO `access_log` VALUES (6831, '62.88.15585896629343065', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:34:23', 17, 0, '', '2019-05-23 13:34:23');
INSERT INTO `access_log` VALUES (6832, '62.87.15585896653333067', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:34:25', 21, 0, '', '2019-05-23 13:34:25');
INSERT INTO `access_log` VALUES (6833, '59.75.15585896751113089', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.89.29.94', '2019-05-23 13:34:35', 1, 1002001015, '账号未登陆', '2019-05-23 13:34:35');
INSERT INTO `access_log` VALUES (6834, '59.71.15585896784953091', 0, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.129.6.159', '2019-05-23 13:34:38', 1, 1002001015, '账号未登陆', '2019-05-23 13:34:38');
INSERT INTO `access_log` VALUES (6835, '59.73.15585896803743091', 0, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '180.97.118.223', '2019-05-23 13:34:40', 1, 1002001015, '账号未登陆', '2019-05-23 13:34:40');
INSERT INTO `access_log` VALUES (6836, '65.45.15585896821212277', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.129.6.251', '2019-05-23 13:34:42', 1, 1002001015, '账号未登陆', '2019-05-23 13:34:42');
INSERT INTO `access_log` VALUES (6837, '65.51.15585896967362263', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.89.19.197', '2019-05-23 13:34:57', 1, 1002001015, '账号未登陆', '2019-05-23 13:34:57');
INSERT INTO `access_log` VALUES (6838, '65.50.15585897077852263', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.174', '2019-05-23 13:35:08', 1, 1002001015, '账号未登陆', '2019-05-23 13:35:08');
INSERT INTO `access_log` VALUES (6839, '62.80.15585897252313063', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.89.19.197', '2019-05-23 13:35:25', 1, 1002001015, '账号未登陆', '2019-05-23 13:35:25');
INSERT INTO `access_log` VALUES (6840, '65.53.15585897783002265', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:36:18', 1, 1002001015, '账号未登陆', '2019-05-23 13:36:18');
INSERT INTO `access_log` VALUES (6841, '65.45.15585897784352279', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:36:18', 0, 1002001015, '账号未登陆', '2019-05-23 13:36:18');
INSERT INTO `access_log` VALUES (6842, '65.47.15585897784362263', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:36:18', 1, 1002001015, '账号未登陆', '2019-05-23 13:36:18');
INSERT INTO `access_log` VALUES (6843, '65.52.15585898065762265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:36:47', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 13:36:47');
INSERT INTO `access_log` VALUES (6844, '59.73.15585898158133093', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:36:56', 4, 0, '', '2019-05-23 13:36:56');
INSERT INTO `access_log` VALUES (6845, '59.72.15585898158163089', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:36:56', 15, 2001001000, '服务端发生异常', '2019-05-23 13:36:56');
INSERT INTO `access_log` VALUES (6846, '64.77.15585898189392301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:36:59', 84, 0, '', '2019-05-23 13:36:59');
INSERT INTO `access_log` VALUES (6847, '64.78.15585898191622295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:36:59', 4, 0, '', '2019-05-23 13:36:59');
INSERT INTO `access_log` VALUES (6848, '64.84.15585898201422295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:37:00', 3, 0, '', '2019-05-23 13:37:00');
INSERT INTO `access_log` VALUES (6849, '64.81.15585898205502295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:37:01', 3, 0, '', '2019-05-23 13:37:01');
INSERT INTO `access_log` VALUES (6850, '65.46.15585898363292273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:37:16', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 13:37:16');
INSERT INTO `access_log` VALUES (6851, '65.53.15585898443712267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:37:24', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 13:37:24');
INSERT INTO `access_log` VALUES (6852, '65.45.15585898645282281', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:37:45', 84, 0, '', '2019-05-23 13:37:45');
INSERT INTO `access_log` VALUES (6853, '65.51.15585898650292267', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:37:45', 11, 0, '', '2019-05-23 13:37:45');
INSERT INTO `access_log` VALUES (6854, '65.50.15585898650352267', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:37:45', 10, 0, '', '2019-05-23 13:37:45');
INSERT INTO `access_log` VALUES (6855, '65.52.15585898650752267', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:37:45', 11, 0, '', '2019-05-23 13:37:45');
INSERT INTO `access_log` VALUES (6856, '62.80.15585898709223065', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:37:51', 17, 0, '', '2019-05-23 13:37:51');
INSERT INTO `access_log` VALUES (6857, '59.79.15585898758293091', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:37:56', 20, 0, '', '2019-05-23 13:37:56');
INSERT INTO `access_log` VALUES (6858, '59.76.15585898787603089', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:37:59', 226, 2001001000, '服务端发生异常', '2019-05-23 13:37:59');
INSERT INTO `access_log` VALUES (6859, '59.75.15585898804603093', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:38:00', 27, 0, '', '2019-05-23 13:38:00');
INSERT INTO `access_log` VALUES (6860, '59.71.15585898827663095', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:38:03', 16, 0, '', '2019-05-23 13:38:03');
INSERT INTO `access_log` VALUES (6861, '59.72.15585898842673091', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:38:04', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-23 13:38:04');
INSERT INTO `access_log` VALUES (6862, '65.49.15585898886522281', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:38:09', 23, 0, '', '2019-05-23 13:38:09');
INSERT INTO `access_log` VALUES (6863, '65.54.15585898970352267', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:38:17', 21, 0, '', '2019-05-23 13:38:17');
INSERT INTO `access_log` VALUES (6864, '65.53.15585899002382269', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:38:20', 21, 0, '', '2019-05-23 13:38:20');
INSERT INTO `access_log` VALUES (6865, '65.45.15585899048992283', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:38:25', 16, 0, '', '2019-05-23 13:38:25');
INSERT INTO `access_log` VALUES (6866, '65.51.15585899057132269', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:38:26', 11, 0, '', '2019-05-23 13:38:26');
INSERT INTO `access_log` VALUES (6867, '62.88.15585899102453069', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:38:30', 17, 0, '', '2019-05-23 13:38:30');
INSERT INTO `access_log` VALUES (6868, '62.87.15585899124253071', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:38:32', 19, 0, '', '2019-05-23 13:38:32');
INSERT INTO `access_log` VALUES (6869, '64.78.15585899138332297', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:38:34', 19, 0, '', '2019-05-23 13:38:34');
INSERT INTO `access_log` VALUES (6870, '64.77.15585899138302303', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:38:34', 121, 0, '', '2019-05-23 13:38:34');
INSERT INTO `access_log` VALUES (6871, '64.80.15585901180562297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:41:58', 4, 0, '', '2019-05-23 13:41:58');
INSERT INTO `access_log` VALUES (6872, '64.82.15585901184452299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:41:58', 3, 0, '', '2019-05-23 13:41:58');
INSERT INTO `access_log` VALUES (6873, '59.76.15585901216643093', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:42:02', 4, 0, '', '2019-05-23 13:42:02');
INSERT INTO `access_log` VALUES (6874, '59.75.15585901216983097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:42:02', 15, 2001001000, '服务端发生异常', '2019-05-23 13:42:02');
INSERT INTO `access_log` VALUES (6875, '65.46.15585901230002279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:42:03', 105, 0, '', '2019-05-23 13:42:03');
INSERT INTO `access_log` VALUES (6876, '65.54.15585901232802271', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:42:03', 11, 0, '', '2019-05-23 13:42:03');
INSERT INTO `access_log` VALUES (6877, '65.53.15585901233112273', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:42:03', 11, 0, '', '2019-05-23 13:42:03');
INSERT INTO `access_log` VALUES (6878, '65.47.15585901233132271', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:42:03', 10, 0, '', '2019-05-23 13:42:03');
INSERT INTO `access_log` VALUES (6879, '64.76.15585901261512297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:42:06', 3, 0, '', '2019-05-23 13:42:06');
INSERT INTO `access_log` VALUES (6880, '64.78.15585901262722301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:42:06', 4, 0, '', '2019-05-23 13:42:06');
INSERT INTO `access_log` VALUES (6881, '62.86.15585901459433063', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:42:26', 433, 0, '', '2019-05-23 13:42:26');
INSERT INTO `access_log` VALUES (6882, '64.81.15585901473292301', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:42:27', 12, 0, '', '2019-05-23 13:42:27');
INSERT INTO `access_log` VALUES (6883, '64.84.15585901473292301', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:42:27', 19, 0, '', '2019-05-23 13:42:27');
INSERT INTO `access_log` VALUES (6884, '64.85.15585901488992301', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:42:29', 13, 0, '', '2019-05-23 13:42:29');
INSERT INTO `access_log` VALUES (6885, '64.83.15585901488962299', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:42:29', 22, 0, '', '2019-05-23 13:42:29');
INSERT INTO `access_log` VALUES (6886, '64.80.15585901538482299', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:42:34', 12, 0, '', '2019-05-23 13:42:34');
INSERT INTO `access_log` VALUES (6887, '62.84.15585901561893069', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:42:36', 16, 0, '', '2019-05-23 13:42:36');
INSERT INTO `access_log` VALUES (6888, '65.52.15585903101532275', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:45:10', 23, 0, '', '2019-05-23 13:45:10');
INSERT INTO `access_log` VALUES (6889, '65.54.15585905066692277', 27, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=ceshiceshiceshi&nickname=测试测试测试&password=111111', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:48:27', 8, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-23 13:48:27');
INSERT INTO `access_log` VALUES (6890, '65.53.15585905131742279', 27, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=ceshiceshiceshi&nickname=测试测试测试&password=111111', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:48:33', 7, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-23 13:48:33');
INSERT INTO `access_log` VALUES (6891, '59.78.15585906449113105', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:50:45', 26, 0, '', '2019-05-23 13:50:45');
INSERT INTO `access_log` VALUES (6892, '59.79.15585906577573103', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:50:58', 52, 2001001000, '服务端发生异常', '2019-05-23 13:50:58');
INSERT INTO `access_log` VALUES (6893, '59.75.15585906723033105', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:51:12', 14, 0, '', '2019-05-23 13:51:12');
INSERT INTO `access_log` VALUES (6894, '59.73.15585906848513107', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:51:25', 15, 0, '', '2019-05-23 13:51:25');
INSERT INTO `access_log` VALUES (6895, '66.52.15585906947872167', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 13:51:35', 23, 0, '', '2019-05-23 13:51:35');
INSERT INTO `access_log` VALUES (6896, '65.45.15585915748992307', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 14:06:15', 5, 1002001012, '访问令牌已过期', '2019-05-23 14:06:15');
INSERT INTO `access_log` VALUES (6897, '65.51.15585915748992293', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 14:06:15', 6, 1002001012, '访问令牌已过期', '2019-05-23 14:06:15');
INSERT INTO `access_log` VALUES (6898, '65.50.15585915749042293', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 14:06:15', 4, 1002001012, '访问令牌已过期', '2019-05-23 14:06:15');
INSERT INTO `access_log` VALUES (6899, '65.48.15585915861322301', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 14:06:26', 118, 0, '', '2019-05-23 14:06:26');
INSERT INTO `access_log` VALUES (6900, '65.46.15585915864822301', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 14:06:26', 11, 0, '', '2019-05-23 14:06:26');
INSERT INTO `access_log` VALUES (6901, '65.49.15585915864822307', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 14:06:26', 13, 0, '', '2019-05-23 14:06:26');
INSERT INTO `access_log` VALUES (6902, '65.54.15585915864852293', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 14:06:26', 14, 0, '', '2019-05-23 14:06:27');
INSERT INTO `access_log` VALUES (6903, '62.87.15585923658383105', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-23 14:19:26', 33, 0, '', '2019-05-23 14:19:26');
INSERT INTO `access_log` VALUES (6904, '59.77.15585926435203131', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:04', 17, 2001001000, '服务端发生异常', '2019-05-23 14:24:04');
INSERT INTO `access_log` VALUES (6905, '59.77.15585926435203131', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:04', 17, 2001001000, '服务端发生异常', '2019-05-23 14:24:05');
INSERT INTO `access_log` VALUES (6906, '59.72.15585926435193129', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:04', 1378, 0, '', '2019-05-23 14:24:05');
INSERT INTO `access_log` VALUES (6907, '65.48.15585926474612319', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:07', 1, 1002001015, '账号未登陆', '2019-05-23 14:24:07');
INSERT INTO `access_log` VALUES (6908, '65.46.15585926474662317', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:07', 0, 1002001015, '账号未登陆', '2019-05-23 14:24:07');
INSERT INTO `access_log` VALUES (6909, '65.53.15585926474722309', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:07', 0, 1002001015, '账号未登陆', '2019-05-23 14:24:07');
INSERT INTO `access_log` VALUES (6910, '65.45.15585926535712327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:14', 68, 0, '', '2019-05-23 14:24:14');
INSERT INTO `access_log` VALUES (6911, '65.54.15585926539072307', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:14', 11, 0, '', '2019-05-23 14:24:14');
INSERT INTO `access_log` VALUES (6912, '65.51.15585926539382309', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:14', 11, 0, '', '2019-05-23 14:24:14');
INSERT INTO `access_log` VALUES (6913, '65.50.15585926539382309', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:14', 12, 0, '', '2019-05-23 14:24:14');
INSERT INTO `access_log` VALUES (6914, '62.89.15585926623693105', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:22', 17, 0, '', '2019-05-23 14:24:22');
INSERT INTO `access_log` VALUES (6915, '62.81.15585926661743097', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:26', 21, 0, '', '2019-05-23 14:24:26');
INSERT INTO `access_log` VALUES (6916, '64.85.15585926680252337', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:28', 23, 0, '', '2019-05-23 14:24:28');
INSERT INTO `access_log` VALUES (6917, '64.81.15585926680232335', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:28', 30, 0, '', '2019-05-23 14:24:28');
INSERT INTO `access_log` VALUES (6918, '64.78.15585926706442337', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:31', 14, 0, '', '2019-05-23 14:24:31');
INSERT INTO `access_log` VALUES (6919, '64.76.15585926706442335', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:31', 17, 0, '', '2019-05-23 14:24:31');
INSERT INTO `access_log` VALUES (6920, '64.82.15585926730022335', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:33', 13, 0, '', '2019-05-23 14:24:33');
INSERT INTO `access_log` VALUES (6921, '66.55.15585926851082203', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:45', 33, 0, '', '2019-05-23 14:24:45');
INSERT INTO `access_log` VALUES (6922, '59.79.15585926881383131', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:48', 14, 0, '', '2019-05-23 14:24:48');
INSERT INTO `access_log` VALUES (6923, '59.75.15585926903253133', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:50', 22, 2001001000, '服务端发生异常', '2019-05-23 14:24:50');
INSERT INTO `access_log` VALUES (6924, '59.71.15585926924433135', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:52', 15, 0, '', '2019-05-23 14:24:52');
INSERT INTO `access_log` VALUES (6925, '59.73.15585926948673135', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:55', 16, 0, '', '2019-05-23 14:24:55');
INSERT INTO `access_log` VALUES (6926, '59.80.15585926971923131', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:24:57', 380, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-23 14:24:58');
INSERT INTO `access_log` VALUES (6927, '65.48.15585926996882321', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:25:00', 23, 0, '', '2019-05-23 14:25:00');
INSERT INTO `access_log` VALUES (6928, '65.53.15585927010082311', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:25:01', 280, 0, '', '2019-05-23 14:25:01');
INSERT INTO `access_log` VALUES (6929, '65.47.15585927024062309', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:25:02', 11, 0, '', '2019-05-23 14:25:02');
INSERT INTO `access_log` VALUES (6930, '65.45.15585927039292329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:25:04', 25, 0, '', '2019-05-23 14:25:04');
INSERT INTO `access_log` VALUES (6931, '65.50.15585927101242311', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:25:10', 22, 0, '', '2019-05-23 14:25:10');
INSERT INTO `access_log` VALUES (6932, '65.51.15585927114282311', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:25:11', 12, 0, '', '2019-05-23 14:25:11');
INSERT INTO `access_log` VALUES (6933, '65.52.15585927177512313', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:25:18', 14, 0, '', '2019-05-23 14:25:18');
INSERT INTO `access_log` VALUES (6934, '65.46.15585927253182321', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:25:25', 15, 0, '', '2019-05-23 14:25:25');
INSERT INTO `access_log` VALUES (6935, '65.48.15585927331562323', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:25:33', 11, 0, '', '2019-05-23 14:25:33');
INSERT INTO `access_log` VALUES (6936, '65.45.15585927566122331', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:25:57', 23, 0, '', '2019-05-23 14:25:57');
INSERT INTO `access_log` VALUES (6937, '65.54.15585927583202311', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:25:58', 15, 0, '', '2019-05-23 14:25:58');
INSERT INTO `access_log` VALUES (6938, '65.50.15585927627102313', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:26:03', 12, 0, '', '2019-05-23 14:26:03');
INSERT INTO `access_log` VALUES (6939, '65.51.15585927649022313', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:26:05', 11, 0, '', '2019-05-23 14:26:05');
INSERT INTO `access_log` VALUES (6940, '65.52.15585927683622315', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-23 14:26:08', 41, 0, '', '2019-05-23 14:26:08');
INSERT INTO `access_log` VALUES (6941, '64.78.15585927883362339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:26:28', 4, 0, '', '2019-05-23 14:26:28');
INSERT INTO `access_log` VALUES (6942, '64.82.15585927884252337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:26:28', 4, 0, '', '2019-05-23 14:26:28');
INSERT INTO `access_log` VALUES (6943, '64.79.15585927935922337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:26:34', 3, 0, '', '2019-05-23 14:26:34');
INSERT INTO `access_log` VALUES (6944, '64.84.15585927936822341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:26:34', 3, 0, '', '2019-05-23 14:26:34');
INSERT INTO `access_log` VALUES (6945, '59.71.15585927984013137', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:26:38', 5, 0, '', '2019-05-23 14:26:38');
INSERT INTO `access_log` VALUES (6946, '59.73.15585927984103137', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:26:38', 15, 2001001000, '服务端发生异常', '2019-05-23 14:26:38');
INSERT INTO `access_log` VALUES (6947, '64.77.15585928092642345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:26:49', 3, 0, '', '2019-05-23 14:26:49');
INSERT INTO `access_log` VALUES (6948, '64.80.15585928093502339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:26:49', 3, 0, '', '2019-05-23 14:26:49');
INSERT INTO `access_log` VALUES (6949, '64.81.15585928107722339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:26:51', 3, 0, '', '2019-05-23 14:26:51');
INSERT INTO `access_log` VALUES (6950, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:26:51', 10, 0, '', '2019-05-23 14:26:51');
INSERT INTO `access_log` VALUES (6951, '64.76.15585928130472339', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:26:53', 22, 0, '', '2019-05-23 14:26:53');
INSERT INTO `access_log` VALUES (6952, '65.47.15585928177102313', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:26:58', 1, 1002001015, '账号未登陆', '2019-05-23 14:26:58');
INSERT INTO `access_log` VALUES (6953, '65.45.15585928177152333', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:26:58', 0, 1002001015, '账号未登陆', '2019-05-23 14:26:58');
INSERT INTO `access_log` VALUES (6954, '65.54.15585928177152313', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:26:58', 0, 1002001015, '账号未登陆', '2019-05-23 14:26:58');
INSERT INTO `access_log` VALUES (6955, '65.50.15585928232782315', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:03', 73, 0, '', '2019-05-23 14:27:03');
INSERT INTO `access_log` VALUES (6956, '65.51.15585928235912315', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:04', 11, 0, '', '2019-05-23 14:27:04');
INSERT INTO `access_log` VALUES (6957, '65.52.15585928235952317', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:04', 10, 0, '', '2019-05-23 14:27:04');
INSERT INTO `access_log` VALUES (6958, '65.49.15585928235962329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:04', 11, 0, '', '2019-05-23 14:27:04');
INSERT INTO `access_log` VALUES (6959, '62.85.15585928280383103', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:08', 18, 0, '', '2019-05-23 14:27:08');
INSERT INTO `access_log` VALUES (6960, '64.79.15585928331052339', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:13', 19, 0, '', '2019-05-23 14:27:13');
INSERT INTO `access_log` VALUES (6961, '64.82.15585928331042339', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:13', 22, 0, '', '2019-05-23 14:27:13');
INSERT INTO `access_log` VALUES (6962, '59.78.15585928428043137', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:23', 19, 0, '', '2019-05-23 14:27:23');
INSERT INTO `access_log` VALUES (6963, '65.53.15585928468652317', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:27', 22, 0, '', '2019-05-23 14:27:27');
INSERT INTO `access_log` VALUES (6964, '65.54.15585928478382315', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:28', 12, 0, '', '2019-05-23 14:27:28');
INSERT INTO `access_log` VALUES (6965, '65.47.15585928498382315', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:30', 11, 0, '', '2019-05-23 14:27:30');
INSERT INTO `access_log` VALUES (6966, '65.45.15585928504392335', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:30', 15, 0, '', '2019-05-23 14:27:30');
INSERT INTO `access_log` VALUES (6967, '66.54.15585928530512195', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13838382438&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:27:33', 21, 1001003000, '验证码不存在', '2019-05-23 14:27:33');
INSERT INTO `access_log` VALUES (6968, '65.49.15585928602372331', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:40', 16, 0, '', '2019-05-23 14:27:40');
INSERT INTO `access_log` VALUES (6969, '65.51.15585928613682317', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:41', 11, 0, '', '2019-05-23 14:27:41');
INSERT INTO `access_log` VALUES (6970, '65.52.15585928621082319', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:42', 13, 0, '', '2019-05-23 14:27:42');
INSERT INTO `access_log` VALUES (6971, '66.51.15585928622122199', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13838382438', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:27:42', 69, 0, '', '2019-05-23 14:27:42');
INSERT INTO `access_log` VALUES (6972, '65.46.15585928623262327', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:42', 24, 0, '', '2019-05-23 14:27:42');
INSERT INTO `access_log` VALUES (6973, '59.79.15585928625803135', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:43', 19, 0, '', '2019-05-23 14:27:43');
INSERT INTO `access_log` VALUES (6974, '64.77.15585928634492347', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:43', 14, 0, '', '2019-05-23 14:27:43');
INSERT INTO `access_log` VALUES (6975, '64.80.15585928634822341', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:43', 12, 0, '', '2019-05-23 14:27:43');
INSERT INTO `access_log` VALUES (6976, '62.89.15585928635803109', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.172.32.91', '2019-05-23 14:27:44', 17, 0, '', '2019-05-23 14:27:44');
INSERT INTO `access_log` VALUES (6977, '66.53.15585928645782201', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13838382438&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:27:45', 215, 0, '', '2019-05-23 14:27:45');
INSERT INTO `access_log` VALUES (6978, '66.56.15585928691432199', 79, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:27:49', 13, 0, '', '2019-05-23 14:27:49');
INSERT INTO `access_log` VALUES (6979, '66.55.15585928724932207', 79, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:27:52', 11, 0, '', '2019-05-23 14:27:53');
INSERT INTO `access_log` VALUES (6980, '66.57.15585928768322203', 79, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:27:57', 10, 0, '', '2019-05-23 14:27:57');
INSERT INTO `access_log` VALUES (6981, '66.54.15585928789412197', 79, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:27:59', 15, 0, '', '2019-05-23 14:27:59');
INSERT INTO `access_log` VALUES (6982, '64.78.15585928970742343', 79, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:28:17', 17, 0, '', '2019-05-23 14:28:17');
INSERT INTO `access_log` VALUES (6983, '64.79.15585928985632341', 79, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:28:19', 10, 0, '', '2019-05-23 14:28:19');
INSERT INTO `access_log` VALUES (6984, 'N/A', 79, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:28:19', 32, 0, '', '2019-05-23 14:28:19');
INSERT INTO `access_log` VALUES (6985, '64.83.15585928997632339', 79, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:28:20', 7, 0, '', '2019-05-23 14:28:20');
INSERT INTO `access_log` VALUES (6986, '64.77.15585928998482349', 79, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:28:20', 6, 0, '', '2019-05-23 14:28:20');
INSERT INTO `access_log` VALUES (6987, '59.77.15585929033493137', 79, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:28:23', 41, 0, '', '2019-05-23 14:28:23');
INSERT INTO `access_log` VALUES (6988, '59.72.15585929033493135', 79, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:28:23', 57, 2001001000, '服务端发生异常', '2019-05-23 14:28:23');
INSERT INTO `access_log` VALUES (6989, '59.78.15585929076493139', 79, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:28:28', 7, 0, '', '2019-05-23 14:28:28');
INSERT INTO `access_log` VALUES (6990, '59.74.15585929076523139', 79, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.177.121.93', '2019-05-23 14:28:28', 16, 2001001000, '服务端发生异常', '2019-05-23 14:28:28');
INSERT INTO `access_log` VALUES (6991, '65.51.15585931248962321', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:32:05', 5, 1002001012, '访问令牌已过期', '2019-05-23 14:32:05');
INSERT INTO `access_log` VALUES (6992, '65.52.15585931249002323', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:32:05', 4, 1002001012, '访问令牌已过期', '2019-05-23 14:32:05');
INSERT INTO `access_log` VALUES (6993, '65.46.15585931249102331', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:32:05', 4, 1002001012, '访问令牌已过期', '2019-05-23 14:32:05');
INSERT INTO `access_log` VALUES (6994, '65.54.15585931466002321', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:32:27', 69, 0, '', '2019-05-23 14:32:27');
INSERT INTO `access_log` VALUES (6995, '65.47.15585931471492321', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:32:27', 13, 0, '', '2019-05-23 14:32:27');
INSERT INTO `access_log` VALUES (6996, '65.45.15585931471562341', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:32:27', 17, 0, '', '2019-05-23 14:32:27');
INSERT INTO `access_log` VALUES (6997, '65.50.15585931471582323', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:32:27', 17, 0, '', '2019-05-23 14:32:27');
INSERT INTO `access_log` VALUES (6998, '64.80.15585931725982347', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:32:53', 12, 0, '', '2019-05-23 14:32:53');
INSERT INTO `access_log` VALUES (6999, '64.77.15585931725972353', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:32:53', 16, 0, '', '2019-05-23 14:32:53');
INSERT INTO `access_log` VALUES (7000, '65.48.15585932140672335', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:33:34', 4, 0, '', '2019-05-23 14:33:34');
INSERT INTO `access_log` VALUES (7001, '59.71.15585932261993145', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:33:46', 60, 0, '', '2019-05-23 14:33:46');
INSERT INTO `access_log` VALUES (7002, '59.73.15585932262003145', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:33:46', 70, 2001001000, '服务端发生异常', '2019-05-23 14:33:46');
INSERT INTO `access_log` VALUES (7003, '64.82.15585932294492347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:33:49', 39, 0, '', '2019-05-23 14:33:49');
INSERT INTO `access_log` VALUES (7004, '64.84.15585932298092351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:33:50', 12, 0, '', '2019-05-23 14:33:50');
INSERT INTO `access_log` VALUES (7005, '59.77.15585932341823143', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:33:54', 11, 0, '', '2019-05-23 14:33:54');
INSERT INTO `access_log` VALUES (7006, '59.72.15585932341863141', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:33:54', 21, 2001001000, '服务端发生异常', '2019-05-23 14:33:54');
INSERT INTO `access_log` VALUES (7007, '66.48.15585933298152207', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:35:30', 21, 0, '', '2019-05-23 14:35:30');
INSERT INTO `access_log` VALUES (7008, '59.71.15585933317843147', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:35:32', 1247, 0, '', '2019-05-23 14:35:33');
INSERT INTO `access_log` VALUES (7009, '59.77.15585933363343145', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:35:36', 23, 2001001000, '服务端发生异常', '2019-05-23 14:35:36');
INSERT INTO `access_log` VALUES (7010, '59.72.15585933387693143', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:35:39', 16, 0, '', '2019-05-23 14:35:39');
INSERT INTO `access_log` VALUES (7011, '59.78.15585933419893147', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:35:42', 18, 0, '', '2019-05-23 14:35:42');
INSERT INTO `access_log` VALUES (7012, '59.74.15585933448533147', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:35:45', 12, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-23 14:35:45');
INSERT INTO `access_log` VALUES (7013, '64.83.15585933510662347', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:35:51', 12, 0, '', '2019-05-23 14:35:51');
INSERT INTO `access_log` VALUES (7014, '64.84.15585933510642353', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:35:51', 17, 0, '', '2019-05-23 14:35:51');
INSERT INTO `access_log` VALUES (7015, '64.80.15585933692342351', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:36:09', 13, 0, '', '2019-05-23 14:36:09');
INSERT INTO `access_log` VALUES (7016, '64.85.15585935156582355', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:38:36', 16, 0, '', '2019-05-23 14:38:36');
INSERT INTO `access_log` VALUES (7017, '64.81.15585935156592353', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-23 14:38:36', 19, 0, '', '2019-05-23 14:38:36');
INSERT INTO `access_log` VALUES (7018, '65.50.15585946032822343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.140.163.111', '2019-05-23 14:56:43', 74, 1002002001, '密码不正确', '2019-05-23 14:56:43');
INSERT INTO `access_log` VALUES (7019, '59.79.15585981420883209', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-23 15:55:42', 13, 0, '', '2019-05-23 15:55:42');
INSERT INTO `access_log` VALUES (7020, '59.76.15585981420913207', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-23 15:55:42', 24, 2001001000, '服务端发生异常', '2019-05-23 15:55:42');
INSERT INTO `access_log` VALUES (7021, '64.85.15585981451122417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-23 15:55:45', 13, 0, '', '2019-05-23 15:55:45');
INSERT INTO `access_log` VALUES (7022, '64.81.15585981454302415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-23 15:55:45', 4, 0, '', '2019-05-23 15:55:45');
INSERT INTO `access_log` VALUES (7023, '64.76.15585981475732415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-23 15:55:48', 191, 0, '', '2019-05-23 15:55:48');
INSERT INTO `access_log` VALUES (7024, '59.75.15585981477493211', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-23 15:55:48', 16, 0, '', '2019-05-23 15:55:48');
INSERT INTO `access_log` VALUES (7025, '59.73.15585981477753213', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-23 15:55:48', 13, 2001001000, '服务端发生异常', '2019-05-23 15:55:48');
INSERT INTO `access_log` VALUES (7026, '64.78.15585981479132417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.87.81.174', '2019-05-23 15:55:48', 4, 0, '', '2019-05-23 15:55:48');
INSERT INTO `access_log` VALUES (7027, '65.46.15585988381092411', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:07:18', 1, 1002001015, '账号未登陆', '2019-05-23 16:07:18');
INSERT INTO `access_log` VALUES (7028, '65.52.15585988381092401', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:07:18', 0, 1002001015, '账号未登陆', '2019-05-23 16:07:18');
INSERT INTO `access_log` VALUES (7029, '65.51.15585988381202399', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:07:18', 0, 1002001015, '账号未登陆', '2019-05-23 16:07:18');
INSERT INTO `access_log` VALUES (7030, '59.75.15585990290303223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:10:29', 4, 0, '', '2019-05-23 16:10:29');
INSERT INTO `access_log` VALUES (7031, '59.71.15585990290353225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:10:29', 21, 2001001000, '服务端发生异常', '2019-05-23 16:10:29');
INSERT INTO `access_log` VALUES (7032, '64.78.15585990345632429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:10:35', 6, 0, '', '2019-05-23 16:10:35');
INSERT INTO `access_log` VALUES (7033, '64.82.15585990346822427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:10:35', 4, 0, '', '2019-05-23 16:10:35');
INSERT INTO `access_log` VALUES (7034, '64.84.15585990360862431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:10:36', 3, 0, '', '2019-05-23 16:10:36');
INSERT INTO `access_log` VALUES (7035, '64.83.15585990366932425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:10:37', 3, 0, '', '2019-05-23 16:10:37');
INSERT INTO `access_log` VALUES (7036, '65.49.15585990493382415', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:10:49', 1, 1002001015, '账号未登陆', '2019-05-23 16:10:49');
INSERT INTO `access_log` VALUES (7037, '65.50.15585990493372405', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:10:49', 1, 1002001015, '账号未登陆', '2019-05-23 16:10:49');
INSERT INTO `access_log` VALUES (7038, '65.45.15585990493372419', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:10:49', 1, 1002001015, '账号未登陆', '2019-05-23 16:10:49');
INSERT INTO `access_log` VALUES (7039, '65.52.15585990520402405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:10:52', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 16:10:52');
INSERT INTO `access_log` VALUES (7040, '65.46.15585990566562415', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:10:57', 69, 0, '', '2019-05-23 16:10:57');
INSERT INTO `access_log` VALUES (7041, '65.48.15585990570162417', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:10:57', 12, 0, '', '2019-05-23 16:10:57');
INSERT INTO `access_log` VALUES (7042, '65.53.15585990570202407', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:10:57', 11, 0, '', '2019-05-23 16:10:57');
INSERT INTO `access_log` VALUES (7043, '65.47.15585990570252405', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:10:57', 13, 0, '', '2019-05-23 16:10:57');
INSERT INTO `access_log` VALUES (7044, '64.80.15585990631672429', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:11:03', 20, 0, '', '2019-05-23 16:11:03');
INSERT INTO `access_log` VALUES (7045, '64.85.15585990631672431', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:11:03', 24, 0, '', '2019-05-23 16:11:03');
INSERT INTO `access_log` VALUES (7046, '59.78.15585990750473225', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:11:15', 11, 0, '', '2019-05-23 16:11:15');
INSERT INTO `access_log` VALUES (7047, '65.50.15585990849832407', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:11:25', 24, 0, '', '2019-05-23 16:11:25');
INSERT INTO `access_log` VALUES (7048, '65.45.15585990859652421', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:11:26', 13, 0, '', '2019-05-23 16:11:26');
INSERT INTO `access_log` VALUES (7049, '65.52.15585990871522407', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:11:27', 21, 0, '', '2019-05-23 16:11:27');
INSERT INTO `access_log` VALUES (7050, '65.51.15585990881512405', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.2.3000', '183.238.58.22', '2019-05-23 16:11:28', 11, 0, '', '2019-05-23 16:11:28');
INSERT INTO `access_log` VALUES (7051, '59.79.15585990892453223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '183.192.164.85', '2019-05-23 16:11:29', 4, 0, '', '2019-05-23 16:11:29');
INSERT INTO `access_log` VALUES (7052, '64.82.15585990962622429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '120.204.17.73', '2019-05-23 16:11:36', 3, 0, '', '2019-05-23 16:11:36');
INSERT INTO `access_log` VALUES (7053, '64.79.15585990963422429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '183.192.164.71', '2019-05-23 16:11:36', 3, 0, '', '2019-05-23 16:11:36');
INSERT INTO `access_log` VALUES (7054, '64.84.15585990973152433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '183.192.164.85', '2019-05-23 16:11:37', 3, 0, '', '2019-05-23 16:11:37');
INSERT INTO `access_log` VALUES (7055, '64.77.15585991138442437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '121.51.32.144', '2019-05-23 16:11:54', 3, 0, '', '2019-05-23 16:11:54');
INSERT INTO `access_log` VALUES (7056, '65.47.15585991209902407', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '120.204.17.73', '2019-05-23 16:12:01', 1, 1002001015, '账号未登陆', '2019-05-23 16:12:01');
INSERT INTO `access_log` VALUES (7057, '64.85.15585991234372433', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '120.204.17.73', '2019-05-23 16:12:03', 0, 1002001015, '账号未登陆', '2019-05-23 16:12:03');
INSERT INTO `access_log` VALUES (7058, '64.81.15585991280502431', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '183.192.164.56', '2019-05-23 16:12:08', 1, 1002001015, '账号未登陆', '2019-05-23 16:12:08');
INSERT INTO `access_log` VALUES (7059, '59.77.15585991439343225', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:12:24', 4, 0, '', '2019-05-23 16:12:24');
INSERT INTO `access_log` VALUES (7060, '59.80.15585991439303223', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:12:24', 14, 2001001000, '服务端发生异常', '2019-05-23 16:12:24');
INSERT INTO `access_log` VALUES (7061, '65.49.15585991441242419', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '183.192.164.56', '2019-05-23 16:12:24', 0, 1002001015, '账号未登陆', '2019-05-23 16:12:24');
INSERT INTO `access_log` VALUES (7062, '65.50.15585991451222409', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '183.192.164.85', '2019-05-23 16:12:25', 2, 1002001015, '账号未登陆', '2019-05-23 16:12:25');
INSERT INTO `access_log` VALUES (7063, '65.45.15585991464592423', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:12:26', 103, 0, '', '2019-05-23 16:12:27');
INSERT INTO `access_log` VALUES (7064, '65.52.15585991468962409', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:12:27', 14, 0, '', '2019-05-23 16:12:27');
INSERT INTO `access_log` VALUES (7065, '65.51.15585991469022407', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:12:27', 14, 0, '', '2019-05-23 16:12:27');
INSERT INTO `access_log` VALUES (7066, '65.46.15585991469062419', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:12:27', 15, 0, '', '2019-05-23 16:12:27');
INSERT INTO `access_log` VALUES (7067, '62.85.15585991496753189', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:12:30', 29, 0, '', '2019-05-23 16:12:30');
INSERT INTO `access_log` VALUES (7068, '65.48.15585991874902421', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:13:07', 24, 0, '', '2019-05-23 16:13:08');
INSERT INTO `access_log` VALUES (7069, '65.49.15585991954862421', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:13:15', 130, 0, '', '2019-05-23 16:13:16');
INSERT INTO `access_log` VALUES (7070, '65.50.15585991987452411', 27, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:13:19', 8, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-23 16:13:19');
INSERT INTO `access_log` VALUES (7071, '65.53.15586000114962423', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:26:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 16:26:52');
INSERT INTO `access_log` VALUES (7072, '65.47.15586000128402421', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:26:53', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 16:26:53');
INSERT INTO `access_log` VALUES (7073, '65.48.15586000134262433', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:26:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 16:26:53');
INSERT INTO `access_log` VALUES (7074, '65.49.15586000195592433', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:27:00', 474, 0, '', '2019-05-23 16:27:00');
INSERT INTO `access_log` VALUES (7075, '65.50.15586000203492423', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:27:00', 11, 0, '', '2019-05-23 16:27:00');
INSERT INTO `access_log` VALUES (7076, '65.45.15586000203522437', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:27:00', 11, 0, '', '2019-05-23 16:27:00');
INSERT INTO `access_log` VALUES (7077, '65.46.15586000203572433', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:27:00', 10, 0, '', '2019-05-23 16:27:00');
INSERT INTO `access_log` VALUES (7078, '64.84.15586002497652449', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:30:50', 22, 0, '', '2019-05-23 16:30:50');
INSERT INTO `access_log` VALUES (7079, '64.83.15586002497682443', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:30:50', 19, 0, '', '2019-05-23 16:30:50');
INSERT INTO `access_log` VALUES (7080, '64.84.15586009438002459', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:42:24', 15, 0, '', '2019-05-23 16:42:24');
INSERT INTO `access_log` VALUES (7081, '64.85.15586009611502457', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:42:41', 13, 0, '', '2019-05-23 16:42:41');
INSERT INTO `access_log` VALUES (7082, '64.83.15586009611462455', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:42:41', 17, 0, '', '2019-05-23 16:42:41');
INSERT INTO `access_log` VALUES (7083, '64.80.15586009650182457', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:42:45', 11, 0, '', '2019-05-23 16:42:45');
INSERT INTO `access_log` VALUES (7084, '64.77.15586009650162465', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.10', '2019-05-23 16:42:45', 17, 0, '', '2019-05-23 16:42:45');
INSERT INTO `access_log` VALUES (7085, '65.49.15586046463382495', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:44:06', 1, 1002001015, '账号未登陆', '2019-05-23 17:44:06');
INSERT INTO `access_log` VALUES (7086, '65.48.15586046463402495', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:44:06', 0, 1002001015, '账号未登陆', '2019-05-23 17:44:06');
INSERT INTO `access_log` VALUES (7087, '65.47.15586046465602487', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:44:07', 1, 1002001015, '账号未登陆', '2019-05-23 17:44:07');
INSERT INTO `access_log` VALUES (7088, '65.50.15586046492922485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:44:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 17:44:09');
INSERT INTO `access_log` VALUES (7089, '65.53.15586046660752489', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:44:26', 92, 0, '', '2019-05-23 17:44:26');
INSERT INTO `access_log` VALUES (7090, '65.52.15586046665202489', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:44:27', 17, 0, '', '2019-05-23 17:44:27');
INSERT INTO `access_log` VALUES (7091, '65.51.15586046665232487', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:44:27', 16, 0, '', '2019-05-23 17:44:27');
INSERT INTO `access_log` VALUES (7092, '65.46.15586046665232499', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:44:27', 23, 0, '', '2019-05-23 17:44:27');
INSERT INTO `access_log` VALUES (7093, '62.81.15586047130853261', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:45:13', 28, 0, '', '2019-05-23 17:45:13');
INSERT INTO `access_log` VALUES (7094, '62.82.15586047250743269', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:45:25', 15, 0, '', '2019-05-23 17:45:25');
INSERT INTO `access_log` VALUES (7095, '62.80.15586047320873269', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:45:32', 393, 0, '', '2019-05-23 17:45:32');
INSERT INTO `access_log` VALUES (7096, '64.76.15586047410212509', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:45:41', 24, 0, '', '2019-05-23 17:45:41');
INSERT INTO `access_log` VALUES (7097, '64.79.15586047410162509', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:45:41', 32, 0, '', '2019-05-23 17:45:41');
INSERT INTO `access_log` VALUES (7098, '65.49.15586052767032505', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:54:37', 24, 0, '', '2019-05-23 17:54:37');
INSERT INTO `access_log` VALUES (7099, '65.47.15586052793762497', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:54:39', 12, 0, '', '2019-05-23 17:54:39');
INSERT INTO `access_log` VALUES (7100, '65.54.15586052818472491', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:54:42', 11, 0, '', '2019-05-23 17:54:42');
INSERT INTO `access_log` VALUES (7101, '65.50.15586052861162495', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '1.202.237.155', '2019-05-23 17:54:46', 16, 0, '', '2019-05-23 17:54:46');
INSERT INTO `access_log` VALUES (7102, '65.45.15586052919052513', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '1.202.237.155', '2019-05-23 17:54:52', 11, 0, '', '2019-05-23 17:54:52');
INSERT INTO `access_log` VALUES (7103, '65.51.15586053273602497', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:55:27', 13, 0, '', '2019-05-23 17:55:27');
INSERT INTO `access_log` VALUES (7104, '59.79.15586053287863307', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.251.8.210', '2019-05-23 17:55:29', 23, 0, '', '2019-05-23 17:55:29');
INSERT INTO `access_log` VALUES (7105, '59.74.15586053287853309', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.251.8.210', '2019-05-23 17:55:29', 24, 2001001000, '服务端发生异常', '2019-05-23 17:55:29');
INSERT INTO `access_log` VALUES (7106, '59.73.15586053361323311', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:55:36', 14, 0, '', '2019-05-23 17:55:36');
INSERT INTO `access_log` VALUES (7107, '59.75.15586053362653309', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:55:36', 4, 0, '', '2019-05-23 17:55:36');
INSERT INTO `access_log` VALUES (7108, '59.71.15586053362653311', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:55:36', 15, 2001001000, '服务端发生异常', '2019-05-23 17:55:36');
INSERT INTO `access_log` VALUES (7109, '59.80.15586053452373307', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:55:45', 16, 0, '', '2019-05-23 17:55:45');
INSERT INTO `access_log` VALUES (7110, '66.53.15586053454102369', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17620370300', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:55:45', 96, 0, '', '2019-05-23 17:55:46');
INSERT INTO `access_log` VALUES (7111, '64.84.15586053479622519', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:55:48', 16, 0, '', '2019-05-23 17:55:48');
INSERT INTO `access_log` VALUES (7112, '64.83.15586053512112515', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:55:51', 12, 0, '', '2019-05-23 17:55:51');
INSERT INTO `access_log` VALUES (7113, '66.56.15586053537262367', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-23 17:55:54', 18, 0, '', '2019-05-23 17:55:54');
INSERT INTO `access_log` VALUES (7114, '66.49.15586053575132369', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17620370300&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:55:58', 225, 0, '', '2019-05-23 17:55:58');
INSERT INTO `access_log` VALUES (7115, '66.55.15586053589272375', 80, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:55:59', 11, 0, '', '2019-05-23 17:55:59');
INSERT INTO `access_log` VALUES (7116, '66.57.15586053649412371', 80, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:05', 13, 0, '', '2019-05-23 17:56:05');
INSERT INTO `access_log` VALUES (7117, '66.48.15586053656732369', 80, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:06', 11, 0, '', '2019-05-23 17:56:06');
INSERT INTO `access_log` VALUES (7118, '66.51.15586053682212369', 80, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:08', 8, 0, '', '2019-05-23 17:56:08');
INSERT INTO `access_log` VALUES (7119, '66.53.15586053700462371', 80, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:10', 12, 0, '', '2019-05-23 17:56:10');
INSERT INTO `access_log` VALUES (7120, '66.52.15586053715512367', 80, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:12', 11, 0, '', '2019-05-23 17:56:12');
INSERT INTO `access_log` VALUES (7121, '66.56.15586053743992369', 80, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:14', 128, 0, '', '2019-05-23 17:56:15');
INSERT INTO `access_log` VALUES (7122, '64.80.15586053755032517', 80, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:16', 724, 0, '', '2019-05-23 17:56:16');
INSERT INTO `access_log` VALUES (7123, '64.81.15586053764702519', 80, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:16', 6, 0, '', '2019-05-23 17:56:16');
INSERT INTO `access_log` VALUES (7124, '64.76.15586053783902519', 80, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:18', 7, 0, '', '2019-05-23 17:56:18');
INSERT INTO `access_log` VALUES (7125, '64.78.15586053792652519', 80, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:19', 7, 0, '', '2019-05-23 17:56:19');
INSERT INTO `access_log` VALUES (7126, '64.85.15586053808192519', 80, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:21', 7, 0, '', '2019-05-23 17:56:21');
INSERT INTO `access_log` VALUES (7127, '64.77.15586053816182527', 80, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:22', 7, 0, '', '2019-05-23 17:56:22');
INSERT INTO `access_log` VALUES (7128, '64.80.15586053822432519', 80, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:22', 7, 0, '', '2019-05-23 17:56:22');
INSERT INTO `access_log` VALUES (7129, '64.82.15586053829262521', 80, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:23', 7, 0, '', '2019-05-23 17:56:23');
INSERT INTO `access_log` VALUES (7130, 'N/A', 80, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:23', 24, 0, '', '2019-05-23 17:56:23');
INSERT INTO `access_log` VALUES (7131, '64.81.15586053847392521', 80, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:25', 9, 0, '', '2019-05-23 17:56:25');
INSERT INTO `access_log` VALUES (7132, '64.79.15586053848782521', 80, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:25', 7, 0, '', '2019-05-23 17:56:25');
INSERT INTO `access_log` VALUES (7133, '59.76.15586053857453307', 80, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:26', 8, 0, '', '2019-05-23 17:56:26');
INSERT INTO `access_log` VALUES (7134, '59.73.15586053857463313', 80, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.251.8.210', '2019-05-23 17:56:26', 18, 2001001000, '服务端发生异常', '2019-05-23 17:56:26');
INSERT INTO `access_log` VALUES (7135, '59.78.15586090567123361', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/4.0 (compatible;)', '219.233.201.34', '2019-05-23 18:57:37', 13, 0, '', '2019-05-23 18:57:37');
INSERT INTO `access_log` VALUES (7136, '65.46.15586120363322599', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:47:16', 0, 1002001015, '账号未登陆', '2019-05-23 19:47:16');
INSERT INTO `access_log` VALUES (7137, '65.45.15586120363322605', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:47:16', 0, 1002001015, '账号未登陆', '2019-05-23 19:47:16');
INSERT INTO `access_log` VALUES (7138, '65.51.15586120363322589', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:47:16', 0, 1002001015, '账号未登陆', '2019-05-23 19:47:16');
INSERT INTO `access_log` VALUES (7139, '65.52.15586120488592589', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:47:29', 107, 0, '', '2019-05-23 19:47:29');
INSERT INTO `access_log` VALUES (7140, '65.49.15586120491922597', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:47:29', 14, 0, '', '2019-05-23 19:47:29');
INSERT INTO `access_log` VALUES (7141, '65.47.15586120491932591', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:47:29', 14, 0, '', '2019-05-23 19:47:29');
INSERT INTO `access_log` VALUES (7142, '65.48.15586120491932599', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:47:29', 17, 0, '', '2019-05-23 19:47:29');
INSERT INTO `access_log` VALUES (7143, '62.86.15586120758173361', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:47:56', 27, 0, '', '2019-05-23 19:47:56');
INSERT INTO `access_log` VALUES (7144, '59.76.15586120873713397', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:48:07', 12, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-23 19:48:07');
INSERT INTO `access_log` VALUES (7145, '59.73.15586120920613403', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:48:12', 23, 0, '', '2019-05-23 19:48:12');
INSERT INTO `access_log` VALUES (7146, '62.87.15586121076863373', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:48:28', 16, 0, '', '2019-05-23 19:48:28');
INSERT INTO `access_log` VALUES (7147, '65.51.15586121140602591', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:48:34', 13, 0, '', '2019-05-23 19:48:34');
INSERT INTO `access_log` VALUES (7148, '65.53.15586121152522591', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:48:35', 32, 0, '', '2019-05-23 19:48:35');
INSERT INTO `access_log` VALUES (7149, '65.52.15586121178512591', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:48:38', 14, 0, '', '2019-05-23 19:48:38');
INSERT INTO `access_log` VALUES (7150, '65.48.15586121203832601', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:48:40', 12, 0, '', '2019-05-23 19:48:40');
INSERT INTO `access_log` VALUES (7151, '65.47.15586121215992593', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:48:42', 11, 0, '', '2019-05-23 19:48:42');
INSERT INTO `access_log` VALUES (7152, '65.50.15586121355082591', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:48:56', 17, 0, '', '2019-05-23 19:48:56');
INSERT INTO `access_log` VALUES (7153, '65.45.15586121608132609', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:49:21', 25, 0, '', '2019-05-23 19:49:21');
INSERT INTO `access_log` VALUES (7154, '65.51.15586121614582593', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:49:21', 12, 0, '', '2019-05-23 19:49:21');
INSERT INTO `access_log` VALUES (7155, '65.53.15586121622342593', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:49:22', 11, 0, '', '2019-05-23 19:49:22');
INSERT INTO `access_log` VALUES (7156, '65.49.15586121677532601', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:49:28', 23, 0, '', '2019-05-23 19:49:28');
INSERT INTO `access_log` VALUES (7157, '65.48.15586121715132603', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:49:32', 11, 0, '', '2019-05-23 19:49:32');
INSERT INTO `access_log` VALUES (7158, '65.47.15586121735462595', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:49:34', 15, 0, '', '2019-05-23 19:49:34');
INSERT INTO `access_log` VALUES (7159, '65.50.15586121829032593', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:49:43', 167, 0, '', '2019-05-23 19:49:43');
INSERT INTO `access_log` VALUES (7160, '65.46.15586121930872605', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:49:53', 10, 0, '', '2019-05-23 19:49:53');
INSERT INTO `access_log` VALUES (7161, '65.51.15586121939482595', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:49:54', 11, 0, '', '2019-05-23 19:49:54');
INSERT INTO `access_log` VALUES (7162, '65.53.15586121945962595', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:49:55', 23, 0, '', '2019-05-23 19:49:55');
INSERT INTO `access_log` VALUES (7163, '65.52.15586121968172595', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:49:57', 11, 0, '', '2019-05-23 19:49:57');
INSERT INTO `access_log` VALUES (7164, '65.48.15586122106212605', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:11', 23, 0, '', '2019-05-23 19:50:11');
INSERT INTO `access_log` VALUES (7165, '65.47.15586122111232597', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:11', 13, 0, '', '2019-05-23 19:50:11');
INSERT INTO `access_log` VALUES (7166, '65.54.15586122115762589', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:12', 11, 0, '', '2019-05-23 19:50:12');
INSERT INTO `access_log` VALUES (7167, '65.50.15586122121522595', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:12', 12, 0, '', '2019-05-23 19:50:12');
INSERT INTO `access_log` VALUES (7168, '65.46.15586122127532607', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:13', 22, 0, '', '2019-05-23 19:50:13');
INSERT INTO `access_log` VALUES (7169, '65.45.15586122132142613', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:13', 11, 0, '', '2019-05-23 19:50:13');
INSERT INTO `access_log` VALUES (7170, '65.51.15586122136502597', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:14', 12, 0, '', '2019-05-23 19:50:14');
INSERT INTO `access_log` VALUES (7171, '65.53.15586122140982597', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:14', 9, 0, '', '2019-05-23 19:50:14');
INSERT INTO `access_log` VALUES (7172, '65.52.15586122144432597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:14', 16, 0, '', '2019-05-23 19:50:14');
INSERT INTO `access_log` VALUES (7173, '65.49.15586122146572605', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:15', 11, 0, '', '2019-05-23 19:50:15');
INSERT INTO `access_log` VALUES (7174, '65.48.15586122150012607', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:15', 21, 0, '', '2019-05-23 19:50:15');
INSERT INTO `access_log` VALUES (7175, '65.47.15586122153442599', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:15', 21, 0, '', '2019-05-23 19:50:15');
INSERT INTO `access_log` VALUES (7176, '65.54.15586122156392591', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:16', 12, 0, '', '2019-05-23 19:50:16');
INSERT INTO `access_log` VALUES (7177, '62.88.15586122178483371', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:18', 35, 0, '', '2019-05-23 19:50:18');
INSERT INTO `access_log` VALUES (7178, '59.73.15586122195833405', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:20', 16, 0, '', '2019-05-23 19:50:20');
INSERT INTO `access_log` VALUES (7179, '59.71.15586122200333405', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:20', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-23 19:50:20');
INSERT INTO `access_log` VALUES (7180, '62.84.15586122205203369', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.105.191', '2019-05-23 19:50:21', 16, 0, '', '2019-05-23 19:50:21');
INSERT INTO `access_log` VALUES (7181, '65.49.15586132039102619', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:06:44', 1, 1002001015, '账号未登陆', '2019-05-23 20:06:44');
INSERT INTO `access_log` VALUES (7182, '65.48.15586132039142621', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:06:44', 1, 1002001015, '账号未登陆', '2019-05-23 20:06:44');
INSERT INTO `access_log` VALUES (7183, '65.47.15586132039182613', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:06:44', 1, 1002001015, '账号未登陆', '2019-05-23 20:06:44');
INSERT INTO `access_log` VALUES (7184, '65.54.15586132054812605', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:06:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 20:06:45');
INSERT INTO `access_log` VALUES (7185, '65.50.15586132078272611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:06:48', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 20:06:48');
INSERT INTO `access_log` VALUES (7186, '65.45.15586132175532629', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:06:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-23 20:06:58');
INSERT INTO `access_log` VALUES (7187, '65.51.15586132232852613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:03', 108, 0, '', '2019-05-23 20:07:03');
INSERT INTO `access_log` VALUES (7188, '65.53.15586132237972613', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:04', 12, 0, '', '2019-05-23 20:07:04');
INSERT INTO `access_log` VALUES (7189, '65.52.15586132238042613', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:04', 11, 0, '', '2019-05-23 20:07:04');
INSERT INTO `access_log` VALUES (7190, '65.49.15586132238092621', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:04', 10, 0, '', '2019-05-23 20:07:04');
INSERT INTO `access_log` VALUES (7191, '62.88.15586132298533385', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:10', 17, 0, '', '2019-05-23 20:07:10');
INSERT INTO `access_log` VALUES (7192, '62.84.15586132355123383', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:16', 16, 0, '', '2019-05-23 20:07:16');
INSERT INTO `access_log` VALUES (7193, '62.89.15586132527933385', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:33', 129, 0, '', '2019-05-23 20:07:33');
INSERT INTO `access_log` VALUES (7194, '64.85.15586132608562625', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:41', 25, 0, '', '2019-05-23 20:07:41');
INSERT INTO `access_log` VALUES (7195, '64.83.15586132608542625', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:41', 31, 0, '', '2019-05-23 20:07:41');
INSERT INTO `access_log` VALUES (7196, '64.82.15586132641712629', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:44', 11, 0, '', '2019-05-23 20:07:44');
INSERT INTO `access_log` VALUES (7197, '64.77.15586132641662635', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:44', 17, 0, '', '2019-05-23 20:07:44');
INSERT INTO `access_log` VALUES (7198, '66.51.15586132693372475', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:49', 28, 0, '', '2019-05-23 20:07:49');
INSERT INTO `access_log` VALUES (7199, '65.50.15586132709822613', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:51', 23, 0, '', '2019-05-23 20:07:51');
INSERT INTO `access_log` VALUES (7200, '65.46.15586132723552625', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:52', 12, 0, '', '2019-05-23 20:07:52');
INSERT INTO `access_log` VALUES (7201, '65.51.15586132740532615', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:54', 9, 0, '', '2019-05-23 20:07:54');
INSERT INTO `access_log` VALUES (7202, '65.53.15586132757582615', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:56', 16, 0, '', '2019-05-23 20:07:56');
INSERT INTO `access_log` VALUES (7203, '65.49.15586132768612623', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:07:57', 10, 0, '', '2019-05-23 20:07:57');
INSERT INTO `access_log` VALUES (7204, '65.52.15586132795992615', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:08:00', 12, 0, '', '2019-05-23 20:08:00');
INSERT INTO `access_log` VALUES (7205, '65.47.15586132806002617', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:08:01', 22, 0, '', '2019-05-23 20:08:01');
INSERT INTO `access_log` VALUES (7206, '59.75.15586132827953417', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:08:03', 441, 0, '', '2019-05-23 20:08:03');
INSERT INTO `access_log` VALUES (7207, '59.77.15586132894303417', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:08:09', 23, 2001001000, '服务端发生异常', '2019-05-23 20:08:09');
INSERT INTO `access_log` VALUES (7208, '62.85.15586133035833381', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:08:24', 18, 0, '', '2019-05-23 20:08:24');
INSERT INTO `access_log` VALUES (7209, '66.49.15586133092012477', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:08:29', 20, 0, '', '2019-05-23 20:08:29');
INSERT INTO `access_log` VALUES (7210, '59.78.15586133125883419', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:08:33', 14, 0, '', '2019-05-23 20:08:33');
INSERT INTO `access_log` VALUES (7211, '59.74.15586133145143419', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:08:35', 22, 2001001000, '服务端发生异常', '2019-05-23 20:08:35');
INSERT INTO `access_log` VALUES (7212, '59.76.15586133202853415', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:08:40', 15, 0, '', '2019-05-23 20:08:40');
INSERT INTO `access_log` VALUES (7213, '65.46.15586133246292627', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:08:45', 12, 0, '', '2019-05-23 20:08:45');
INSERT INTO `access_log` VALUES (7214, '62.83.15586135314593391', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:12:11', 24, 0, '', '2019-05-23 20:12:11');
INSERT INTO `access_log` VALUES (7215, '66.51.15586135338722479', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:12:14', 18, 0, '', '2019-05-23 20:12:14');
INSERT INTO `access_log` VALUES (7216, '65.52.15586135353402619', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:12:15', 23, 0, '', '2019-05-23 20:12:15');
INSERT INTO `access_log` VALUES (7217, '65.47.15586135361432621', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:12:16', 19, 0, '', '2019-05-23 20:12:16');
INSERT INTO `access_log` VALUES (7218, '65.48.15586135378132629', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:12:18', 11, 0, '', '2019-05-23 20:12:18');
INSERT INTO `access_log` VALUES (7219, '65.54.15586135393862613', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:12:19', 16, 0, '', '2019-05-23 20:12:19');
INSERT INTO `access_log` VALUES (7220, '65.50.15586135420772619', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:12:22', 11, 0, '', '2019-05-23 20:12:22');
INSERT INTO `access_log` VALUES (7221, '65.46.15586135432672631', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:12:23', 21, 0, '', '2019-05-23 20:12:23');
INSERT INTO `access_log` VALUES (7222, '65.45.15586135438982637', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:12:24', 12, 0, '', '2019-05-23 20:12:24');
INSERT INTO `access_log` VALUES (7223, '59.72.15586135465163419', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:12:27', 18, 0, '', '2019-05-23 20:12:27');
INSERT INTO `access_log` VALUES (7224, '62.80.15586135512073389', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-23 20:12:31', 17, 0, '', '2019-05-23 20:12:31');
INSERT INTO `access_log` VALUES (7225, '59.73.15586227639513547', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.201.193', '2019-05-23 22:46:04', 14, 0, '', '2019-05-23 22:46:04');
INSERT INTO `access_log` VALUES (7226, '59.71.15586227639513547', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.201.193', '2019-05-23 22:46:04', 24, 2001001000, '服务端发生异常', '2019-05-23 22:46:04');
INSERT INTO `access_log` VALUES (7227, '64.84.15586227706512755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.201.193', '2019-05-23 22:46:11', 505, 0, '', '2019-05-23 22:46:11');
INSERT INTO `access_log` VALUES (7228, '64.78.15586227713502755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.201.193', '2019-05-23 22:46:11', 4, 0, '', '2019-05-23 22:46:11');
INSERT INTO `access_log` VALUES (7229, '64.85.15586227729542753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.201.193', '2019-05-23 22:46:13', 3, 0, '', '2019-05-23 22:46:13');
INSERT INTO `access_log` VALUES (7230, '64.83.15586227734482753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.201.193', '2019-05-23 22:46:13', 3, 0, '', '2019-05-23 22:46:13');
INSERT INTO `access_log` VALUES (7231, '66.54.15586227911522599', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13333333333', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.201.193', '2019-05-23 22:46:31', 114, 0, '', '2019-05-23 22:46:31');
INSERT INTO `access_log` VALUES (7232, '66.51.15586227957672603', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13333333333&code=1234', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.201.193', '2019-05-23 22:46:36', 16, 1001003003, '验证码不正确', '2019-05-23 22:46:36');
INSERT INTO `access_log` VALUES (7233, '65.48.15586232104162759', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.180.4.91', '2019-05-23 22:53:30', 1, 1002001015, '账号未登陆', '2019-05-23 22:53:30');
INSERT INTO `access_log` VALUES (7234, '65.54.15586232104322743', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.180.4.91', '2019-05-23 22:53:30', 0, 1002001015, '账号未登陆', '2019-05-23 22:53:30');
INSERT INTO `access_log` VALUES (7235, '65.50.15586232104542749', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.180.4.91', '2019-05-23 22:53:30', 0, 1002001015, '账号未登陆', '2019-05-23 22:53:30');
INSERT INTO `access_log` VALUES (7236, '65.51.15586232317412751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yuanmayuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.180.4.91', '2019-05-23 22:53:52', 6, 1002002000, '账号不存在', '2019-05-23 22:53:52');
INSERT INTO `access_log` VALUES (7237, '65.54.15586233235152745', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.180.4.91', '2019-05-23 22:55:24', 725, 0, '', '2019-05-23 22:55:24');
INSERT INTO `access_log` VALUES (7238, '65.46.15586233257442763', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.180.4.91', '2019-05-23 22:55:26', 13, 0, '', '2019-05-23 22:55:26');
INSERT INTO `access_log` VALUES (7239, '65.51.15586233257562753', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.180.4.91', '2019-05-23 22:55:26', 10, 0, '', '2019-05-23 22:55:26');
INSERT INTO `access_log` VALUES (7240, '65.45.15586233257672769', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.180.4.91', '2019-05-23 22:55:26', 10, 0, '', '2019-05-23 22:55:26');
INSERT INTO `access_log` VALUES (7241, '62.87.15586233445423525', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.180.4.91', '2019-05-23 22:55:45', 30, 0, '', '2019-05-23 22:55:45');
INSERT INTO `access_log` VALUES (7242, '64.83.15586233646302761', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.180.4.91', '2019-05-23 22:56:05', 15, 0, '', '2019-05-23 22:56:05');
INSERT INTO `access_log` VALUES (7243, '59.80.15586233740593551', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.180.4.91', '2019-05-23 22:56:14', 16, 0, '', '2019-05-23 22:56:14');
INSERT INTO `access_log` VALUES (7244, '65.50.15586237293232757', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.180.4.91', '2019-05-23 23:02:09', 1, 1002001015, '账号未登陆', '2019-05-23 23:02:09');
INSERT INTO `access_log` VALUES (7245, '65.48.15586238351872769', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.99.174', '2019-05-23 23:03:55', 147, 0, '', '2019-05-23 23:03:55');
INSERT INTO `access_log` VALUES (7246, '65.54.15586238356272755', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.99.174', '2019-05-23 23:03:56', 167, 0, '', '2019-05-23 23:03:56');
INSERT INTO `access_log` VALUES (7247, '65.50.15586238356332759', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.99.174', '2019-05-23 23:03:56', 164, 0, '', '2019-05-23 23:03:56');
INSERT INTO `access_log` VALUES (7248, '65.46.15586238357172773', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.99.174', '2019-05-23 23:03:56', 81, 0, '', '2019-05-23 23:03:56');
INSERT INTO `access_log` VALUES (7249, '65.51.15586238461362761', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '223.72.99.174', '2019-05-23 23:04:06', 22, 0, '', '2019-05-23 23:04:06');
INSERT INTO `access_log` VALUES (7250, '65.51.15586628196373281', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-24 09:53:40', 14, 1002001012, '访问令牌已过期', '2019-05-24 09:53:40');
INSERT INTO `access_log` VALUES (7251, '65.45.15586628196383297', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-24 09:53:40', 17, 1002001012, '访问令牌已过期', '2019-05-24 09:53:40');
INSERT INTO `access_log` VALUES (7252, '65.53.15586628196403281', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-24 09:53:40', 17, 1002001012, '访问令牌已过期', '2019-05-24 09:53:40');
INSERT INTO `access_log` VALUES (7253, '65.49.15586628223333291', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-24 09:53:42', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 09:53:42');
INSERT INTO `access_log` VALUES (7254, '65.47.15586628442243285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.202.237.155', '2019-05-24 09:54:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 09:54:04');
INSERT INTO `access_log` VALUES (7255, '65.48.15586658292493331', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:43:49', 1, 1002001015, '账号未登陆', '2019-05-24 10:43:49');
INSERT INTO `access_log` VALUES (7256, '65.47.15586658292493325', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:43:49', 1, 1002001015, '账号未登陆', '2019-05-24 10:43:49');
INSERT INTO `access_log` VALUES (7257, '65.50.15586658292763321', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:43:49', 1, 1002001015, '账号未登陆', '2019-05-24 10:43:49');
INSERT INTO `access_log` VALUES (7258, '65.54.15586658438633317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:04', 77, 0, '', '2019-05-24 10:44:04');
INSERT INTO `access_log` VALUES (7259, '65.45.15586658446603339', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:05', 16, 0, '', '2019-05-24 10:44:05');
INSERT INTO `access_log` VALUES (7260, '65.53.15586658446613323', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:05', 18, 0, '', '2019-05-24 10:44:05');
INSERT INTO `access_log` VALUES (7261, '65.51.15586658446703323', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:05', 12, 0, '', '2019-05-24 10:44:05');
INSERT INTO `access_log` VALUES (7262, '62.86.15586658515164081', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:12', 26, 0, '', '2019-05-24 10:44:12');
INSERT INTO `access_log` VALUES (7263, '64.77.15586658590423337', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:19', 26, 0, '', '2019-05-24 10:44:19');
INSERT INTO `access_log` VALUES (7264, '64.81.15586658590423331', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:19', 31, 0, '', '2019-05-24 10:44:19');
INSERT INTO `access_log` VALUES (7265, '59.79.15586658681124119', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:28', 23, 0, '', '2019-05-24 10:44:28');
INSERT INTO `access_log` VALUES (7266, '59.76.15586658834314117', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:43', 42, 0, '', '2019-05-24 10:44:43');
INSERT INTO `access_log` VALUES (7267, '64.76.15586658875323331', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:48', 12, 0, '', '2019-05-24 10:44:48');
INSERT INTO `access_log` VALUES (7268, '64.78.15586658905333333', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:51', 12, 0, '', '2019-05-24 10:44:51');
INSERT INTO `access_log` VALUES (7269, '59.73.15586658937724123', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:54', 14, 0, '', '2019-05-24 10:44:54');
INSERT INTO `access_log` VALUES (7270, '64.83.15586658940463331', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:54', 25, 0, '', '2019-05-24 10:44:54');
INSERT INTO `access_log` VALUES (7271, '64.85.15586658940503333', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:54', 20, 0, '', '2019-05-24 10:44:54');
INSERT INTO `access_log` VALUES (7272, '62.89.15586658947764089', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '180.168.188.103', '2019-05-24 10:44:55', 17, 0, '', '2019-05-24 10:44:55');
INSERT INTO `access_log` VALUES (7273, '59.80.15586678459424145', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.221.185.200', '2019-05-24 11:17:26', 17, 2001001000, '服务端发生异常', '2019-05-24 11:17:26');
INSERT INTO `access_log` VALUES (7274, '59.71.15586678459424149', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.221.185.200', '2019-05-24 11:17:26', 231, 0, '', '2019-05-24 11:17:26');
INSERT INTO `access_log` VALUES (7275, '64.82.15586678500373359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.221.185.200', '2019-05-24 11:17:30', 11, 0, '', '2019-05-24 11:17:30');
INSERT INTO `access_log` VALUES (7276, '64.77.15586678501723365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.221.185.200', '2019-05-24 11:17:30', 4, 0, '', '2019-05-24 11:17:30');
INSERT INTO `access_log` VALUES (7277, '59.76.15586686699204155', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 11:31:10', 5, 0, '', '2019-05-24 11:31:10');
INSERT INTO `access_log` VALUES (7278, '59.75.15586686699274159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 11:31:10', 14, 2001001000, '服务端发生异常', '2019-05-24 11:31:10');
INSERT INTO `access_log` VALUES (7279, '64.78.15586686732673371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 11:31:13', 5, 0, '', '2019-05-24 11:31:13');
INSERT INTO `access_log` VALUES (7280, '64.85.15586686733983371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 11:31:13', 3, 0, '', '2019-05-24 11:31:13');
INSERT INTO `access_log` VALUES (7281, '64.83.15586686744543369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 11:31:14', 4, 0, '', '2019-05-24 11:31:14');
INSERT INTO `access_log` VALUES (7282, '64.82.15586686749133371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 11:31:15', 3, 0, '', '2019-05-24 11:31:15');
INSERT INTO `access_log` VALUES (7283, '59.73.15586686756894161', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 11:31:16', 10, 0, '', '2019-05-24 11:31:16');
INSERT INTO `access_log` VALUES (7284, '59.71.15586686756894161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 11:31:16', 20, 2001001000, '服务端发生异常', '2019-05-24 11:31:16');
INSERT INTO `access_log` VALUES (7285, '66.53.15586687008883217', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18810797024&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 11:31:41', 31, 1001003000, '验证码不存在', '2019-05-24 11:31:41');
INSERT INTO `access_log` VALUES (7286, '66.52.15586687033773213', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18810797024', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 11:31:43', 120, 0, '', '2019-05-24 11:31:43');
INSERT INTO `access_log` VALUES (7287, '66.56.15586687052593215', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18810797024&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 11:31:45', 184, 0, '', '2019-05-24 11:31:45');
INSERT INTO `access_log` VALUES (7288, '59.78.15586687064904161', 81, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 11:31:46', 73, 0, '', '2019-05-24 11:31:47');
INSERT INTO `access_log` VALUES (7289, '59.74.15586687085514161', 81, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 11:31:49', 78, 0, '', '2019-05-24 11:31:49');
INSERT INTO `access_log` VALUES (7290, '59.75.15586687090374161', 81, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 11:31:49', 9, 0, '', '2019-05-24 11:31:49');
INSERT INTO `access_log` VALUES (7291, '66.55.15586687132773223', 81, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.171.135.53', '2019-05-24 11:31:53', 12, 0, '', '2019-05-24 11:31:53');
INSERT INTO `access_log` VALUES (7292, '66.57.15586687165913219', 81, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.171.135.53', '2019-05-24 11:31:57', 13, 0, '', '2019-05-24 11:31:57');
INSERT INTO `access_log` VALUES (7293, '66.54.15586687187303213', 81, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.171.135.53', '2019-05-24 11:31:59', 11, 0, '', '2019-05-24 11:31:59');
INSERT INTO `access_log` VALUES (7294, '66.48.15586687195923217', 81, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.171.135.53', '2019-05-24 11:32:00', 8, 0, '', '2019-05-24 11:32:00');
INSERT INTO `access_log` VALUES (7295, '66.51.15586687239523217', 81, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.171.135.53', '2019-05-24 11:32:04', 134, 0, '', '2019-05-24 11:32:04');
INSERT INTO `access_log` VALUES (7296, '66.52.15586687266743215', 81, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.171.135.53', '2019-05-24 11:32:07', 240, 0, '', '2019-05-24 11:32:07');
INSERT INTO `access_log` VALUES (7297, '59.78.15586687288794163', 81, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.171.135.53', '2019-05-24 11:32:09', 6, 0, '', '2019-05-24 11:32:09');
INSERT INTO `access_log` VALUES (7298, '59.72.15586687288774159', 81, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.171.135.53', '2019-05-24 11:32:09', 17, 2001001000, '服务端发生异常', '2019-05-24 11:32:09');
INSERT INTO `access_log` VALUES (7299, '59.79.15586687303314161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.89.29.97', '2019-05-24 11:32:10', 14, 2001001000, '服务端发生异常', '2019-05-24 11:32:10');
INSERT INTO `access_log` VALUES (7300, '64.84.15586687309703371', 81, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.171.135.53', '2019-05-24 11:32:11', 8, 0, '', '2019-05-24 11:32:11');
INSERT INTO `access_log` VALUES (7301, '64.85.15586687311243373', 81, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.171.135.53', '2019-05-24 11:32:11', 7, 0, '', '2019-05-24 11:32:11');
INSERT INTO `access_log` VALUES (7302, '64.83.15586687322823371', 81, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.171.135.53', '2019-05-24 11:32:12', 7, 0, '', '2019-05-24 11:32:12');
INSERT INTO `access_log` VALUES (7303, 'N/A', 81, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.171.135.53', '2019-05-24 11:32:12', 37, 0, '', '2019-05-24 11:32:12');
INSERT INTO `access_log` VALUES (7304, '64.82.15586687331813373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.91.60.105', '2019-05-24 11:32:13', 3, 0, '', '2019-05-24 11:32:13');
INSERT INTO `access_log` VALUES (7305, '64.77.15586687332663379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.129.6.227', '2019-05-24 11:32:13', 2, 0, '', '2019-05-24 11:32:13');
INSERT INTO `access_log` VALUES (7306, '64.81.15586687341313373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.207.186', '2019-05-24 11:32:14', 4, 0, '', '2019-05-24 11:32:14');
INSERT INTO `access_log` VALUES (7307, '64.79.15586687347963371', 81, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.171.135.53', '2019-05-24 11:32:15', 14, 0, '', '2019-05-24 11:32:15');
INSERT INTO `access_log` VALUES (7308, '64.76.15586687350503373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.19.149', '2019-05-24 11:32:15', 2, 0, '', '2019-05-24 11:32:15');
INSERT INTO `access_log` VALUES (7309, '66.50.15586687436103215', 81, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.171.135.53', '2019-05-24 11:32:24', 9, 0, '', '2019-05-24 11:32:24');
INSERT INTO `access_log` VALUES (7310, '59.71.15586687661704165', 0, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.91.60.11', '2019-05-24 11:32:46', 5, 0, '', '2019-05-24 11:32:46');
INSERT INTO `access_log` VALUES (7311, '59.75.15586687687024163', 0, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.89.239.216', '2019-05-24 11:32:49', 11, 0, '', '2019-05-24 11:32:49');
INSERT INTO `access_log` VALUES (7312, '66.54.15586687731463215', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.178.164', '2019-05-24 11:32:53', 1, 1002001015, '账号未登陆', '2019-05-24 11:32:53');
INSERT INTO `access_log` VALUES (7313, '59.80.15586687764864161', 0, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.166', '2019-05-24 11:32:56', 5, 0, '', '2019-05-24 11:32:56');
INSERT INTO `access_log` VALUES (7314, '64.82.15586687959503375', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.178.197', '2019-05-24 11:33:16', 106, 0, '', '2019-05-24 11:33:16');
INSERT INTO `access_log` VALUES (7315, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.129.6.151', '2019-05-24 11:33:18', 26, 0, '', '2019-05-24 11:33:18');
INSERT INTO `access_log` VALUES (7316, '66.53.15586688047983221', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.178.177', '2019-05-24 11:33:25', 5, 0, '', '2019-05-24 11:33:25');
INSERT INTO `access_log` VALUES (7317, '59.80.15586698015704175', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:02', 5, 0, '', '2019-05-24 11:50:02');
INSERT INTO `access_log` VALUES (7318, '59.73.15586698015704179', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:02', 16, 2001001000, '服务端发生异常', '2019-05-24 11:50:02');
INSERT INTO `access_log` VALUES (7319, '64.85.15586698054723389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:05', 4, 0, '', '2019-05-24 11:50:05');
INSERT INTO `access_log` VALUES (7320, '64.82.15586698055943389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:06', 3, 0, '', '2019-05-24 11:50:06');
INSERT INTO `access_log` VALUES (7321, '64.77.15586698068023395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:07', 5, 0, '', '2019-05-24 11:50:07');
INSERT INTO `access_log` VALUES (7322, '64.81.15586698073773389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:07', 2, 0, '', '2019-05-24 11:50:07');
INSERT INTO `access_log` VALUES (7323, '64.80.15586698083293385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:08', 4, 0, '', '2019-05-24 11:50:08');
INSERT INTO `access_log` VALUES (7324, '64.79.15586698087543387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:09', 3, 0, '', '2019-05-24 11:50:09');
INSERT INTO `access_log` VALUES (7325, '64.76.15586698090343389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:09', 3, 0, '', '2019-05-24 11:50:09');
INSERT INTO `access_log` VALUES (7326, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:11', 31, 0, '', '2019-05-24 11:50:11');
INSERT INTO `access_log` VALUES (7327, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:11', 6, 0, '', '2019-05-24 11:50:11');
INSERT INTO `access_log` VALUES (7328, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:11', 36, 0, '', '2019-05-24 11:50:11');
INSERT INTO `access_log` VALUES (7329, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:11', 13, 0, '', '2019-05-24 11:50:11');
INSERT INTO `access_log` VALUES (7330, '64.84.15586698143893389', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:14', 438, 0, '', '2019-05-24 11:50:15');
INSERT INTO `access_log` VALUES (7331, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:20', 13, 0, '', '2019-05-24 11:50:20');
INSERT INTO `access_log` VALUES (7332, '59.79.15586698207654177', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:21', 14, 2001001000, '服务端发生异常', '2019-05-24 11:50:21');
INSERT INTO `access_log` VALUES (7333, '64.83.15586698205663389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:21', 551, 0, '', '2019-05-24 11:50:21');
INSERT INTO `access_log` VALUES (7334, '59.72.15586698207654175', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.222.126.135', '2019-05-24 11:50:21', 352, 0, '', '2019-05-24 11:50:21');
INSERT INTO `access_log` VALUES (7335, '65.48.15586723354563419', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:32:15', 0, 1002001015, '账号未登陆', '2019-05-24 12:32:15');
INSERT INTO `access_log` VALUES (7336, '65.50.15586723354783409', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:32:15', 0, 1002001015, '账号未登陆', '2019-05-24 12:32:15');
INSERT INTO `access_log` VALUES (7337, '65.46.15586723354813423', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:32:15', 0, 1002001015, '账号未登陆', '2019-05-24 12:32:15');
INSERT INTO `access_log` VALUES (7338, '65.54.15586723396333405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:32:20', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 12:32:20');
INSERT INTO `access_log` VALUES (7339, '65.51.15586723546013411', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:32:35', 95, 0, '', '2019-05-24 12:32:35');
INSERT INTO `access_log` VALUES (7340, '65.52.15586723550953411', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:32:35', 245, 0, '', '2019-05-24 12:32:35');
INSERT INTO `access_log` VALUES (7341, '65.49.15586723550823421', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:32:35', 257, 0, '', '2019-05-24 12:32:35');
INSERT INTO `access_log` VALUES (7342, '65.53.15586723550743411', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:32:35', 264, 0, '', '2019-05-24 12:32:35');
INSERT INTO `access_log` VALUES (7343, '62.82.15586723713024175', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:32:51', 24, 0, '', '2019-05-24 12:32:51');
INSERT INTO `access_log` VALUES (7344, '62.85.15586723967374171', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:33:17', 20, 0, '', '2019-05-24 12:33:17');
INSERT INTO `access_log` VALUES (7345, '64.81.15586724037993425', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:33:24', 18, 0, '', '2019-05-24 12:33:24');
INSERT INTO `access_log` VALUES (7346, '64.77.15586724037923431', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:33:24', 27, 0, '', '2019-05-24 12:33:24');
INSERT INTO `access_log` VALUES (7347, '65.51.15586724412963413', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:34:01', 23, 0, '', '2019-05-24 12:34:01');
INSERT INTO `access_log` VALUES (7348, '65.49.15586724502413423', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:34:10', 21, 0, '', '2019-05-24 12:34:10');
INSERT INTO `access_log` VALUES (7349, '65.52.15586724510183413', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:34:11', 21, 0, '', '2019-05-24 12:34:11');
INSERT INTO `access_log` VALUES (7350, '65.47.15586724526123417', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:34:13', 15, 0, '', '2019-05-24 12:34:13');
INSERT INTO `access_log` VALUES (7351, '65.50.15586724797373413', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:34:40', 11, 0, '', '2019-05-24 12:34:40');
INSERT INTO `access_log` VALUES (7352, '65.45.15586724974453431', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:34:57', 16, 0, '', '2019-05-24 12:34:57');
INSERT INTO `access_log` VALUES (7353, '65.51.15586725002233415', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:35:00', 15, 0, '', '2019-05-24 12:35:00');
INSERT INTO `access_log` VALUES (7354, '65.49.15586725111683425', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:35:11', 1243, 0, '', '2019-05-24 12:35:12');
INSERT INTO `access_log` VALUES (7355, '65.52.15586725165473415', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:35:17', 14, 0, '', '2019-05-24 12:35:17');
INSERT INTO `access_log` VALUES (7356, '59.74.15586725211114215', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:35:21', 22, 0, '', '2019-05-24 12:35:21');
INSERT INTO `access_log` VALUES (7357, '59.71.15586725352494217', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:35:35', 23, 2001001000, '服务端发生异常', '2019-05-24 12:35:35');
INSERT INTO `access_log` VALUES (7358, '59.75.15586725417354215', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:35:42', 16, 0, '', '2019-05-24 12:35:42');
INSERT INTO `access_log` VALUES (7359, '59.73.15586725572674217', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:35:57', 12, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-24 12:35:57');
INSERT INTO `access_log` VALUES (7360, '59.79.15586725890764215', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:36:29', 11, 2001001000, '服务端发生异常', '2019-05-24 12:36:29');
INSERT INTO `access_log` VALUES (7361, '59.72.15586725890744213', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:36:29', 262, 0, '', '2019-05-24 12:36:29');
INSERT INTO `access_log` VALUES (7362, '59.71.15586726183104219', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:36:58', 14, 0, '', '2019-05-24 12:36:58');
INSERT INTO `access_log` VALUES (7363, '64.85.15586726503723429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:37:30', 6, 0, '', '2019-05-24 12:37:30');
INSERT INTO `access_log` VALUES (7364, '64.82.15586726505313429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:37:31', 3, 0, '', '2019-05-24 12:37:31');
INSERT INTO `access_log` VALUES (7365, '64.81.15586726630983429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:37:43', 4, 0, '', '2019-05-24 12:37:43');
INSERT INTO `access_log` VALUES (7366, '59.77.15586726653404217', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:37:45', 4, 0, '', '2019-05-24 12:37:45');
INSERT INTO `access_log` VALUES (7367, '59.78.15586726664504219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:37:46', 14, 2001001000, '服务端发生异常', '2019-05-24 12:37:46');
INSERT INTO `access_log` VALUES (7368, '64.80.15586726696003425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:37:50', 3, 0, '', '2019-05-24 12:37:50');
INSERT INTO `access_log` VALUES (7369, '64.79.15586726702313427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:37:50', 3, 0, '', '2019-05-24 12:37:50');
INSERT INTO `access_log` VALUES (7370, '64.84.15586726743853429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:37:54', 3, 0, '', '2019-05-24 12:37:54');
INSERT INTO `access_log` VALUES (7371, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:37:54', 10, 0, '', '2019-05-24 12:37:54');
INSERT INTO `access_log` VALUES (7372, '64.78.15586726778163431', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:37:58', 14, 0, '', '2019-05-24 12:37:58');
INSERT INTO `access_log` VALUES (7373, '64.81.15586727175923431', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:38:38', 13, 0, '', '2019-05-24 12:38:38');
INSERT INTO `access_log` VALUES (7374, '64.77.15586727175903437', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:38:38', 18, 0, '', '2019-05-24 12:38:38');
INSERT INTO `access_log` VALUES (7375, '64.79.15586727242343429', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:38:44', 10, 0, '', '2019-05-24 12:38:44');
INSERT INTO `access_log` VALUES (7376, '64.80.15586727242293427', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:38:44', 16, 0, '', '2019-05-24 12:38:44');
INSERT INTO `access_log` VALUES (7377, '64.76.15586727263383431', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:38:46', 15, 0, '', '2019-05-24 12:38:46');
INSERT INTO `access_log` VALUES (7378, '64.84.15586727294463431', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:38:49', 14, 0, '', '2019-05-24 12:38:49');
INSERT INTO `access_log` VALUES (7379, '64.85.15586727325293433', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:38:53', 14, 0, '', '2019-05-24 12:38:53');
INSERT INTO `access_log` VALUES (7380, '64.83.15586727325253431', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:38:53', 25, 0, '', '2019-05-24 12:38:53');
INSERT INTO `access_log` VALUES (7381, '64.82.15586727325493433', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:38:53', 11, 0, '', '2019-05-24 12:38:53');
INSERT INTO `access_log` VALUES (7382, '64.81.15586727407483433', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:39:01', 13, 0, '', '2019-05-24 12:39:01');
INSERT INTO `access_log` VALUES (7383, '64.77.15586727407483439', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:39:01', 15, 0, '', '2019-05-24 12:39:01');
INSERT INTO `access_log` VALUES (7384, '64.79.15586727445383431', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:39:05', 13, 0, '', '2019-05-24 12:39:05');
INSERT INTO `access_log` VALUES (7385, '64.80.15586727445373429', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:39:05', 15, 0, '', '2019-05-24 12:39:05');
INSERT INTO `access_log` VALUES (7386, '64.84.15586727464673433', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:39:06', 12, 0, '', '2019-05-24 12:39:06');
INSERT INTO `access_log` VALUES (7387, '65.47.15586728121783423', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:40:12', 12, 0, '', '2019-05-24 12:40:12');
INSERT INTO `access_log` VALUES (7388, '65.48.15586728121903429', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:40:12', 12, 0, '', '2019-05-24 12:40:12');
INSERT INTO `access_log` VALUES (7389, '65.46.15586728121943433', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:40:12', 11, 0, '', '2019-05-24 12:40:12');
INSERT INTO `access_log` VALUES (7390, '65.50.15586728183583419', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:40:18', 11, 0, '', '2019-05-24 12:40:18');
INSERT INTO `access_log` VALUES (7391, '65.54.15586728183683415', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:40:18', 10, 0, '', '2019-05-24 12:40:18');
INSERT INTO `access_log` VALUES (7392, '65.45.15586728183803437', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.101.22', '2019-05-24 12:40:18', 10, 0, '', '2019-05-24 12:40:18');
INSERT INTO `access_log` VALUES (7393, '66.53.15586728481113275', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17612184394', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:40:48', 86, 0, '', '2019-05-24 12:40:48');
INSERT INTO `access_log` VALUES (7394, '66.56.15586728529713273', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17612184394&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:40:53', 226, 0, '', '2019-05-24 12:40:53');
INSERT INTO `access_log` VALUES (7395, '66.50.15586728546063271', 82, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:40:55', 11, 0, '', '2019-05-24 12:40:55');
INSERT INTO `access_log` VALUES (7396, '66.57.15586728564223277', 82, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:40:56', 11, 0, '', '2019-05-24 12:40:56');
INSERT INTO `access_log` VALUES (7397, '66.53.15586728854423277', 82, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=17612184394&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=滴滴滴&isDefault=true&address=滴滴滴&areaNo=110101&mobile=17612184394&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:41:25', 141, 2001001000, '服务端发生异常', '2019-05-24 12:41:26');
INSERT INTO `access_log` VALUES (7398, '66.52.15586728881273273', 82, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=17612184394&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=滴滴滴&isDefault=true&address=滴滴滴&areaNo=110101&mobile=17612184394&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:41:28', 91, 2001001000, '服务端发生异常', '2019-05-24 12:41:28');
INSERT INTO `access_log` VALUES (7399, '66.56.15586728902273275', 82, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:41:30', 8, 0, '', '2019-05-24 12:41:30');
INSERT INTO `access_log` VALUES (7400, '66.49.15586728918933277', 82, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:41:32', 8, 0, '', '2019-05-24 12:41:32');
INSERT INTO `access_log` VALUES (7401, '64.83.15586729024403435', 82, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:41:42', 16, 0, '', '2019-05-24 12:41:42');
INSERT INTO `access_log` VALUES (7402, '66.55.15586729059093283', 82, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:41:46', 11, 0, '', '2019-05-24 12:41:46');
INSERT INTO `access_log` VALUES (7403, '64.82.15586729077903437', 82, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:41:48', 15, 0, '', '2019-05-24 12:41:48');
INSERT INTO `access_log` VALUES (7404, '64.81.15586729233973437', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:03', 8, 0, '', '2019-05-24 12:42:03');
INSERT INTO `access_log` VALUES (7405, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:03', 36, 0, '', '2019-05-24 12:42:03');
INSERT INTO `access_log` VALUES (7406, '64.76.15586729258273437', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:06', 6, 0, '', '2019-05-24 12:42:06');
INSERT INTO `access_log` VALUES (7407, '64.84.15586729259683437', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:06', 6, 0, '', '2019-05-24 12:42:06');
INSERT INTO `access_log` VALUES (7408, '64.83.15586729286093437', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:09', 135, 0, '', '2019-05-24 12:42:09');
INSERT INTO `access_log` VALUES (7409, '64.82.15586729313123439', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:11', 7, 0, '', '2019-05-24 12:42:11');
INSERT INTO `access_log` VALUES (7410, '64.85.15586729314023439', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:11', 6, 0, '', '2019-05-24 12:42:11');
INSERT INTO `access_log` VALUES (7411, '64.77.15586729350513445', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:15', 13, 0, '', '2019-05-24 12:42:15');
INSERT INTO `access_log` VALUES (7412, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:15', 13, 0, '', '2019-05-24 12:42:15');
INSERT INTO `access_log` VALUES (7413, '64.81.15586729360533439', 82, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:16', 15, 0, '', '2019-05-24 12:42:16');
INSERT INTO `access_log` VALUES (7414, '66.48.15586729384483277', 82, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:18', 11, 0, '', '2019-05-24 12:42:18');
INSERT INTO `access_log` VALUES (7415, '66.51.15586729396263277', 82, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:20', 9, 0, '', '2019-05-24 12:42:20');
INSERT INTO `access_log` VALUES (7416, '66.49.15586729561413279', 82, 1, 'user-application', '/user-api/users/address/add', 'name=订单&tel=17612184394&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=滴滴滴&isDefault=true&address=滴滴滴&areaNo=110101&mobile=17612184394&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:36', 336, 2001001000, '服务端发生异常', '2019-05-24 12:42:36');
INSERT INTO `access_log` VALUES (7417, '66.50.15586729641293275', 82, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:44', 10, 0, '', '2019-05-24 12:42:44');
INSERT INTO `access_log` VALUES (7418, '66.55.15586729647543285', 82, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:45', 8, 0, '', '2019-05-24 12:42:45');
INSERT INTO `access_log` VALUES (7419, '64.76.15586729652043439', 82, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:45', 14, 0, '', '2019-05-24 12:42:45');
INSERT INTO `access_log` VALUES (7420, '64.78.15586729712663441', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:51', 7, 0, '', '2019-05-24 12:42:51');
INSERT INTO `access_log` VALUES (7421, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:51', 14, 0, '', '2019-05-24 12:42:51');
INSERT INTO `access_log` VALUES (7422, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:53', 13, 0, '', '2019-05-24 12:42:53');
INSERT INTO `access_log` VALUES (7423, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:54', 14, 0, '', '2019-05-24 12:42:54');
INSERT INTO `access_log` VALUES (7424, '64.83.15586729743843439', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:54', 6, 0, '', '2019-05-24 12:42:54');
INSERT INTO `access_log` VALUES (7425, '64.82.15586729744773441', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:54', 6, 0, '', '2019-05-24 12:42:54');
INSERT INTO `access_log` VALUES (7426, '64.77.15586729755673447', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:56', 7, 0, '', '2019-05-24 12:42:56');
INSERT INTO `access_log` VALUES (7427, '64.81.15586729763473441', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:56', 6, 0, '', '2019-05-24 12:42:56');
INSERT INTO `access_log` VALUES (7428, '64.79.15586729768023439', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:57', 7, 0, '', '2019-05-24 12:42:57');
INSERT INTO `access_log` VALUES (7429, '64.80.15586729772673437', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:57', 7, 0, '', '2019-05-24 12:42:57');
INSERT INTO `access_log` VALUES (7430, '64.76.15586729779853441', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:58', 7, 0, '', '2019-05-24 12:42:58');
INSERT INTO `access_log` VALUES (7431, '64.84.15586729784063441', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:58', 7, 0, '', '2019-05-24 12:42:58');
INSERT INTO `access_log` VALUES (7432, '64.78.15586729788463443', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:59', 232, 0, '', '2019-05-24 12:42:59');
INSERT INTO `access_log` VALUES (7433, '64.83.15586729794423441', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:59', 7, 0, '', '2019-05-24 12:42:59');
INSERT INTO `access_log` VALUES (7434, '64.82.15586729799843443', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:00', 6, 0, '', '2019-05-24 12:43:00');
INSERT INTO `access_log` VALUES (7435, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:00', 39, 0, '', '2019-05-24 12:43:00');
INSERT INTO `access_log` VALUES (7436, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:01', 12, 0, '', '2019-05-24 12:43:01');
INSERT INTO `access_log` VALUES (7437, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:02', 12, 0, '', '2019-05-24 12:43:02');
INSERT INTO `access_log` VALUES (7438, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:02', 36, 0, '', '2019-05-24 12:43:02');
INSERT INTO `access_log` VALUES (7439, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:03', 13, 0, '', '2019-05-24 12:43:03');
INSERT INTO `access_log` VALUES (7440, '64.85.15586729833513443', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:03', 6, 0, '', '2019-05-24 12:43:03');
INSERT INTO `access_log` VALUES (7441, '64.77.15586729834743449', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:03', 6, 0, '', '2019-05-24 12:43:03');
INSERT INTO `access_log` VALUES (7442, '64.81.15586729843233443', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:04', 8, 0, '', '2019-05-24 12:43:04');
INSERT INTO `access_log` VALUES (7443, '64.79.15586729850943441', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:05', 6, 0, '', '2019-05-24 12:43:05');
INSERT INTO `access_log` VALUES (7444, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:05', 30, 0, '', '2019-05-24 12:43:05');
INSERT INTO `access_log` VALUES (7445, '64.76.15586729882923443', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:08', 6, 0, '', '2019-05-24 12:43:08');
INSERT INTO `access_log` VALUES (7446, '64.84.15586729884323443', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:08', 6, 0, '', '2019-05-24 12:43:08');
INSERT INTO `access_log` VALUES (7447, '59.71.15586729902054225', 82, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:10', 8, 0, '', '2019-05-24 12:43:10');
INSERT INTO `access_log` VALUES (7448, '59.75.15586729902064223', 82, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:10', 18, 2001001000, '服务端发生异常', '2019-05-24 12:43:10');
INSERT INTO `access_log` VALUES (7449, '64.78.15586729986293445', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:19', 6, 0, '', '2019-05-24 12:43:19');
INSERT INTO `access_log` VALUES (7450, '64.83.15586729987513443', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:19', 7, 0, '', '2019-05-24 12:43:19');
INSERT INTO `access_log` VALUES (7451, '59.73.15586730006094225', 82, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:21', 7, 0, '', '2019-05-24 12:43:21');
INSERT INTO `access_log` VALUES (7452, '59.77.15586730006104223', 82, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:21', 17, 2001001000, '服务端发生异常', '2019-05-24 12:43:21');
INSERT INTO `access_log` VALUES (7453, '64.85.15586730031333445', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:23', 6, 0, '', '2019-05-24 12:43:23');
INSERT INTO `access_log` VALUES (7454, '64.77.15586730032703451', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:23', 7, 0, '', '2019-05-24 12:43:23');
INSERT INTO `access_log` VALUES (7455, '59.78.15586730047154225', 82, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:25', 7, 0, '', '2019-05-24 12:43:25');
INSERT INTO `access_log` VALUES (7456, '59.79.15586730047154223', 82, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:25', 17, 2001001000, '服务端发生异常', '2019-05-24 12:43:25');
INSERT INTO `access_log` VALUES (7457, '64.81.15586730066553445', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:27', 7, 0, '', '2019-05-24 12:43:27');
INSERT INTO `access_log` VALUES (7458, '64.79.15586730067833443', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:27', 6, 0, '', '2019-05-24 12:43:27');
INSERT INTO `access_log` VALUES (7459, '59.72.15586730077394221', 82, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:28', 8, 0, '', '2019-05-24 12:43:28');
INSERT INTO `access_log` VALUES (7460, '59.74.15586730077404225', 82, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:28', 24, 2001001000, '服务端发生异常', '2019-05-24 12:43:28');
INSERT INTO `access_log` VALUES (7461, '64.80.15586730091893441', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:29', 6, 0, '', '2019-05-24 12:43:29');
INSERT INTO `access_log` VALUES (7462, '64.76.15586730093003445', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:29', 6, 0, '', '2019-05-24 12:43:29');
INSERT INTO `access_log` VALUES (7463, '64.84.15586730103233445', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:30', 13, 0, '', '2019-05-24 12:43:30');
INSERT INTO `access_log` VALUES (7464, '64.78.15586730106633447', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:31', 7, 0, '', '2019-05-24 12:43:31');
INSERT INTO `access_log` VALUES (7465, '59.76.15586730121104221', 82, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:32', 7, 0, '', '2019-05-24 12:43:32');
INSERT INTO `access_log` VALUES (7466, '59.71.15586730121104227', 82, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:32', 18, 2001001000, '服务端发生异常', '2019-05-24 12:43:32');
INSERT INTO `access_log` VALUES (7467, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'keyword=手机&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:42', 13, 0, '', '2019-05-24 12:43:42');
INSERT INTO `access_log` VALUES (7468, 'N/A', 82, 1, 'search-application', '/search-api/users/product/condition', 'keyword=手机', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:42', 44, 0, '', '2019-05-24 12:43:42');
INSERT INTO `access_log` VALUES (7469, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'keyword=Kafka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:51', 14, 0, '', '2019-05-24 12:43:51');
INSERT INTO `access_log` VALUES (7470, 'N/A', 82, 1, 'search-application', '/search-api/users/product/condition', 'keyword=Kafka', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:52', 18, 0, '', '2019-05-24 12:43:52');
INSERT INTO `access_log` VALUES (7471, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'keyword=Kafka&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=desc', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:57', 39, 0, '', '2019-05-24 12:43:57');
INSERT INTO `access_log` VALUES (7472, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'keyword=Kafka&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=asc', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:43:59', 14, 0, '', '2019-05-24 12:43:59');
INSERT INTO `access_log` VALUES (7473, 'N/A', 82, 1, 'search-application', '/search-api/users/product/page', 'cid=637&keyword=Kafka&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=asc', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:44:02', 13, 0, '', '2019-05-24 12:44:02');
INSERT INTO `access_log` VALUES (7474, '59.73.15586730470144227', 82, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:44:07', 7, 0, '', '2019-05-24 12:44:07');
INSERT INTO `access_log` VALUES (7475, '59.78.15586730470144227', 82, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:44:07', 18, 2001001000, '服务端发生异常', '2019-05-24 12:44:07');
INSERT INTO `access_log` VALUES (7476, '64.77.15586730495263453', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:44:10', 7, 0, '', '2019-05-24 12:44:10');
INSERT INTO `access_log` VALUES (7477, '64.81.15586730496273447', 82, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:44:10', 7, 0, '', '2019-05-24 12:44:10');
INSERT INTO `access_log` VALUES (7478, '59.79.15586730502804225', 82, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:44:10', 7, 0, '', '2019-05-24 12:44:10');
INSERT INTO `access_log` VALUES (7479, '59.74.15586730502864227', 82, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:44:10', 17, 2001001000, '服务端发生异常', '2019-05-24 12:44:10');
INSERT INTO `access_log` VALUES (7480, '65.49.15586759781913471', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '39.155.212.34', '2019-05-24 13:32:58', 0, 1002001015, '账号未登陆', '2019-05-24 13:32:58');
INSERT INTO `access_log` VALUES (7481, '65.48.15586759781923473', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '39.155.212.34', '2019-05-24 13:32:58', 1, 1002001015, '账号未登陆', '2019-05-24 13:32:58');
INSERT INTO `access_log` VALUES (7482, '65.46.15586759781913477', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '39.155.212.34', '2019-05-24 13:32:58', 0, 1002001015, '账号未登陆', '2019-05-24 13:32:58');
INSERT INTO `access_log` VALUES (7483, '65.52.15586759802793463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '39.155.212.34', '2019-05-24 13:33:00', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 13:33:00');
INSERT INTO `access_log` VALUES (7484, '65.50.15586759855293465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '39.155.212.34', '2019-05-24 13:33:06', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 13:33:06');
INSERT INTO `access_log` VALUES (7485, '65.54.15586759867993461', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '39.155.212.34', '2019-05-24 13:33:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 13:33:07');
INSERT INTO `access_log` VALUES (7486, '65.45.15586759876173485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '39.155.212.34', '2019-05-24 13:33:08', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 13:33:08');
INSERT INTO `access_log` VALUES (7487, '59.73.15586760015524267', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '39.155.212.34', '2019-05-24 13:33:22', 16, 2001001000, '服务端发生异常', '2019-05-24 13:33:22');
INSERT INTO `access_log` VALUES (7488, '59.74.15586760015564267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '39.155.212.34', '2019-05-24 13:33:22', 12, 0, '', '2019-05-24 13:33:22');
INSERT INTO `access_log` VALUES (7489, '1b0dfd5f-e1a6-494f-9bdd-401f9de78e4f', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 13:34:40', 571, 1002001012, '访问令牌已过期', '2019-05-24 13:34:40');
INSERT INTO `access_log` VALUES (7490, '3c513006-12c0-4ecb-91dd-d54700eb2b7d', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 13:34:40', 571, 1002001012, '访问令牌已过期', '2019-05-24 13:34:40');
INSERT INTO `access_log` VALUES (7491, 'bf511b1b-79b7-4376-949c-caa28978f40c', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 13:34:40', 571, 1002001012, '访问令牌已过期', '2019-05-24 13:34:40');
INSERT INTO `access_log` VALUES (7492, '59.79.15586760112854265', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '39.155.212.34', '2019-05-24 13:33:31', 4, 0, '', '2019-05-24 13:33:31');
INSERT INTO `access_log` VALUES (7493, '59.72.15586760112894263', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '39.155.212.34', '2019-05-24 13:33:31', 19, 2001001000, '服务端发生异常', '2019-05-24 13:33:31');
INSERT INTO `access_log` VALUES (7494, '64.85.15586760136093487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '39.155.212.34', '2019-05-24 13:33:34', 13, 0, '', '2019-05-24 13:33:34');
INSERT INTO `access_log` VALUES (7495, '64.77.15586760137193493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '39.155.212.34', '2019-05-24 13:33:34', 3, 0, '', '2019-05-24 13:33:34');
INSERT INTO `access_log` VALUES (7496, '64.79.15586760166203485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '39.155.212.34', '2019-05-24 13:33:37', 3, 0, '', '2019-05-24 13:33:37');
INSERT INTO `access_log` VALUES (7497, '64.80.15586760169603483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '39.155.212.34', '2019-05-24 13:33:37', 3, 0, '', '2019-05-24 13:33:37');
INSERT INTO `access_log` VALUES (7498, '59.76.15586760245794263', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '39.155.212.34', '2019-05-24 13:33:45', 4, 0, '', '2019-05-24 13:33:45');
INSERT INTO `access_log` VALUES (7499, '59.75.15586760245834267', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '39.155.212.34', '2019-05-24 13:33:45', 14, 2001001000, '服务端发生异常', '2019-05-24 13:33:45');
INSERT INTO `access_log` VALUES (7500, '64.76.15586760299713487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '39.155.212.34', '2019-05-24 13:33:50', 3, 0, '', '2019-05-24 13:33:50');
INSERT INTO `access_log` VALUES (7501, '64.84.15586760301183487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '39.155.212.34', '2019-05-24 13:33:50', 3, 0, '', '2019-05-24 13:33:50');
INSERT INTO `access_log` VALUES (7502, '59.77.15586760306434267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '39.155.212.34', '2019-05-24 13:33:51', 4, 0, '', '2019-05-24 13:33:51');
INSERT INTO `access_log` VALUES (7503, '59.78.15586760306454269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '39.155.212.34', '2019-05-24 13:33:51', 13, 2001001000, '服务端发生异常', '2019-05-24 13:33:51');
INSERT INTO `access_log` VALUES (7504, '7c51fb3e-af85-4764-8286-0f92bbc9eae1', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 13:35:13', 170, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 13:35:13');
INSERT INTO `access_log` VALUES (7505, 'e597239f-1e76-40ff-b5a8-4eee0f8b8814', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 13:37:12', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 13:37:12');
INSERT INTO `access_log` VALUES (7506, '39cf50c9-455c-4c62-96b9-366e415d3544', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 13:38:18', 233, 0, '', '2019-05-24 13:38:18');
INSERT INTO `access_log` VALUES (7507, '2c239a40-78e0-4b9c-9895-2f3be4de3596', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 13:38:18', 127, 0, '', '2019-05-24 13:38:18');
INSERT INTO `access_log` VALUES (7508, '1624ba8b-5da6-4a1a-b826-92685cff0ec7', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 13:38:18', 70, 0, '', '2019-05-24 13:38:19');
INSERT INTO `access_log` VALUES (7509, '2a7de33a-b983-4ad9-94a1-1b9484c69335', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 13:38:19', 161, 0, '', '2019-05-24 13:38:19');
INSERT INTO `access_log` VALUES (7510, '32b6c2f3-076c-49be-8653-fcff5deea6c7', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 13:40:52', 1257, 0, '', '2019-05-24 13:40:53');
INSERT INTO `access_log` VALUES (7511, '6dc1cb36-20b9-42a2-8e11-c54b4a3dafbc', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 13:40:52', 1257, 0, '', '2019-05-24 13:40:53');
INSERT INTO `access_log` VALUES (7512, 'd8f1035d-6586-49ec-a43b-6417a3ed8eae', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 13:40:54', 149, 0, '', '2019-05-24 13:40:54');
INSERT INTO `access_log` VALUES (7513, 'f8a7f149-18d8-440e-9a09-e3c7f2fd5320', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 13:40:54', 40, 0, '', '2019-05-24 13:40:54');
INSERT INTO `access_log` VALUES (7514, '59.80.15586771759904281', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.76.170.73', '2019-05-24 13:52:56', 5, 0, '', '2019-05-24 13:52:56');
INSERT INTO `access_log` VALUES (7515, '59.76.15586771759894279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.76.170.73', '2019-05-24 13:52:56', 14, 2001001000, '服务端发生异常', '2019-05-24 13:52:56');
INSERT INTO `access_log` VALUES (7516, '65.49.15586772281493489', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.144.172.123', '2019-05-24 13:53:48', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 13:53:48');
INSERT INTO `access_log` VALUES (7517, '65.48.15586773808653493', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.83.211', '2019-05-24 13:56:21', 1, 1002001015, '账号未登陆', '2019-05-24 13:56:21');
INSERT INTO `access_log` VALUES (7518, '65.46.15586773808663497', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.83.211', '2019-05-24 13:56:21', 1, 1002001015, '账号未登陆', '2019-05-24 13:56:21');
INSERT INTO `access_log` VALUES (7519, '65.52.15586773808673483', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.83.211', '2019-05-24 13:56:21', 0, 1002001015, '账号未登陆', '2019-05-24 13:56:21');
INSERT INTO `access_log` VALUES (7520, '65.50.15586773825923485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.83.211', '2019-05-24 13:56:23', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 13:56:23');
INSERT INTO `access_log` VALUES (7521, '59.78.15586780792974297', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '106.38.78.233', '2019-05-24 14:07:59', 14, 2001001000, '服务端发生异常', '2019-05-24 14:07:59');
INSERT INTO `access_log` VALUES (7522, '59.77.15586780792974295', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '106.38.78.233', '2019-05-24 14:07:59', 132, 0, '', '2019-05-24 14:07:59');
INSERT INTO `access_log` VALUES (7523, '64.76.15586780914753515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '106.38.78.233', '2019-05-24 14:08:11', 12, 0, '', '2019-05-24 14:08:11');
INSERT INTO `access_log` VALUES (7524, '64.84.15586780916003515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '106.38.78.233', '2019-05-24 14:08:12', 5, 0, '', '2019-05-24 14:08:12');
INSERT INTO `access_log` VALUES (7525, '64.78.15586780937463517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '106.38.78.233', '2019-05-24 14:08:14', 3, 0, '', '2019-05-24 14:08:14');
INSERT INTO `access_log` VALUES (7526, '64.83.15586780944493515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '106.38.78.233', '2019-05-24 14:08:14', 3, 0, '', '2019-05-24 14:08:14');
INSERT INTO `access_log` VALUES (7527, '59.72.15586781008174293', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '106.38.78.233', '2019-05-24 14:08:21', 4, 0, '', '2019-05-24 14:08:21');
INSERT INTO `access_log` VALUES (7528, '59.79.15586781008184295', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '106.38.78.233', '2019-05-24 14:08:21', 13, 2001001000, '服务端发生异常', '2019-05-24 14:08:21');
INSERT INTO `access_log` VALUES (7529, '59.77.15586783073804299', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.211.249', '2019-05-24 14:11:47', 14, 2001001000, '服务端发生异常', '2019-05-24 14:11:47');
INSERT INTO `access_log` VALUES (7530, '59.76.15586783073804295', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.65.211.249', '2019-05-24 14:11:47', 161, 0, '', '2019-05-24 14:11:48');
INSERT INTO `access_log` VALUES (7531, '59.74.15586783131314301', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:11:53', 4, 0, '', '2019-05-24 14:11:53');
INSERT INTO `access_log` VALUES (7532, '59.73.15586783131314301', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:11:53', 19, 2001001000, '服务端发生异常', '2019-05-24 14:11:53');
INSERT INTO `access_log` VALUES (7533, '64.80.15586783163023515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:11:56', 4, 0, '', '2019-05-24 14:11:56');
INSERT INTO `access_log` VALUES (7534, '64.76.15586783164213519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:11:56', 3, 0, '', '2019-05-24 14:11:56');
INSERT INTO `access_log` VALUES (7535, '64.84.15586783176703519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:11:58', 4, 0, '', '2019-05-24 14:11:58');
INSERT INTO `access_log` VALUES (7536, '64.78.15586783180913521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:11:58', 3, 0, '', '2019-05-24 14:11:58');
INSERT INTO `access_log` VALUES (7537, '59.79.15586783188934299', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:11:59', 5, 0, '', '2019-05-24 14:11:59');
INSERT INTO `access_log` VALUES (7538, '59.72.15586783188934297', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:11:59', 14, 2001001000, '服务端发生异常', '2019-05-24 14:11:59');
INSERT INTO `access_log` VALUES (7539, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:12:27', 11, 0, '', '2019-05-24 14:12:27');
INSERT INTO `access_log` VALUES (7540, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:12:27', 16, 0, '', '2019-05-24 14:12:27');
INSERT INTO `access_log` VALUES (7541, '64.85.15586783501513521', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:12:30', 11, 0, '', '2019-05-24 14:12:30');
INSERT INTO `access_log` VALUES (7542, '64.81.15586783649533521', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:12:45', 10, 0, '', '2019-05-24 14:12:45');
INSERT INTO `access_log` VALUES (7543, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:13:22', 13, 0, '', '2019-05-24 14:13:22');
INSERT INTO `access_log` VALUES (7544, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:13:22', 16, 0, '', '2019-05-24 14:13:22');
INSERT INTO `access_log` VALUES (7545, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:13:23', 8, 0, '', '2019-05-24 14:13:23');
INSERT INTO `access_log` VALUES (7546, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:13:23', 42, 0, '', '2019-05-24 14:13:23');
INSERT INTO `access_log` VALUES (7547, '64.84.15586784058463521', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:13:26', 12, 0, '', '2019-05-24 14:13:26');
INSERT INTO `access_log` VALUES (7548, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:13:35', 10, 0, '', '2019-05-24 14:13:35');
INSERT INTO `access_log` VALUES (7549, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:13:36', 14, 0, '', '2019-05-24 14:13:36');
INSERT INTO `access_log` VALUES (7550, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=desc', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:13:47', 11, 0, '', '2019-05-24 14:13:47');
INSERT INTO `access_log` VALUES (7551, '59.72.15586784293704299', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:13:49', 42, 2001001000, '服务端发生异常', '2019-05-24 14:13:49');
INSERT INTO `access_log` VALUES (7552, '59.79.15586784293374301', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '113.65.211.249', '2019-05-24 14:13:49', 605, 0, '', '2019-05-24 14:13:50');
INSERT INTO `access_log` VALUES (7553, '39d15db7-f080-4674-b158-c8e3ac7308d9', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:21:19', 209, 0, '', '2019-05-24 14:21:19');
INSERT INTO `access_log` VALUES (7554, '80ab38c5-4339-4c90-b4f9-ae46eb7ef6f2', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:21:19', 215, 0, '', '2019-05-24 14:21:19');
INSERT INTO `access_log` VALUES (7555, '78a2ba8b-051c-4e76-a90d-a68a3b2a5184', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:21:27', 40, 0, '', '2019-05-24 14:21:27');
INSERT INTO `access_log` VALUES (7556, 'd4e65f21-77f1-46e8-83f7-f74b35e9c7ae', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:21:30', 54, 0, '', '2019-05-24 14:21:30');
INSERT INTO `access_log` VALUES (7557, '4aa1141e-ca76-4e92-a9b8-9d7f2f336a8a', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:21:30', 65, 0, '', '2019-05-24 14:21:30');
INSERT INTO `access_log` VALUES (7558, 'dcd882ec-e92e-4514-aeb8-e1a6c71bffaa', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:23:25', 72, 0, '', '2019-05-24 14:23:25');
INSERT INTO `access_log` VALUES (7559, 'e580e101-d69c-4247-9259-f9934822f172', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:23:25', 90, 0, '', '2019-05-24 14:23:25');
INSERT INTO `access_log` VALUES (7560, '6ea8dd99-98bb-4f7b-a621-fa0ca8411de9', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:23:27', 64, 0, '', '2019-05-24 14:23:27');
INSERT INTO `access_log` VALUES (7561, 'f3cb4da2-e3ba-4f7e-a5fa-829c9ec6d381', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:23:28', 36, 0, '', '2019-05-24 14:23:28');
INSERT INTO `access_log` VALUES (7562, 'efefb7f1-125e-48d0-84a4-f53e1da3ece9', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:23:30', 38, 0, '', '2019-05-24 14:23:30');
INSERT INTO `access_log` VALUES (7563, '71e3cac3-0ca4-4859-8203-e7d41a6547fe', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:24:34', 52, 0, '', '2019-05-24 14:24:34');
INSERT INTO `access_log` VALUES (7564, '7cf09de5-cb20-4ff8-8b01-ed164a30bc80', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:24:34', 57, 0, '', '2019-05-24 14:24:34');
INSERT INTO `access_log` VALUES (7565, '81776990-4c13-4776-aec4-bc5c00a425b4', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:24:34', 58, 0, '', '2019-05-24 14:24:34');
INSERT INTO `access_log` VALUES (7566, '72cdb07a-875c-4fb2-ac5b-790dba7aaa67', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:24:35', 48, 0, '', '2019-05-24 14:24:35');
INSERT INTO `access_log` VALUES (7567, '533e2ce8-da19-4c5a-b0fa-5cfe828eff21', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:24:43', 115, 0, '', '2019-05-24 14:24:44');
INSERT INTO `access_log` VALUES (7568, '829bdcae-ed9c-412d-99a2-7f47d1deba29', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:24:43', 151, 0, '', '2019-05-24 14:24:44');
INSERT INTO `access_log` VALUES (7569, '75745596-3aef-4707-bed2-0475e9444804', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:24:43', 157, 0, '', '2019-05-24 14:24:44');
INSERT INTO `access_log` VALUES (7570, 'f06bf55a-bab4-47bd-bd9b-395babb68db2', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:24:43', 115, 0, '', '2019-05-24 14:24:44');
INSERT INTO `access_log` VALUES (7571, '2c864564-fa4d-4199-afc3-40559ea86c27', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:24:48', 39, 0, '', '2019-05-24 14:24:48');
INSERT INTO `access_log` VALUES (7572, '467975a4-640e-40ff-8353-fe4323858cf4', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:24:48', 41, 0, '', '2019-05-24 14:24:48');
INSERT INTO `access_log` VALUES (7573, '3b70ab35-081b-483b-9423-4f6520c8a3d0', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:24:48', 42, 0, '', '2019-05-24 14:24:48');
INSERT INTO `access_log` VALUES (7574, '310873b7-c177-4699-84fc-2e0298f915a4', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:24:49', 54, 0, '', '2019-05-24 14:24:49');
INSERT INTO `access_log` VALUES (7575, 'df5ade5f-e2dc-418f-b7f9-b0741b545f05', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:09', 48, 0, '', '2019-05-24 14:25:09');
INSERT INTO `access_log` VALUES (7576, '96926468-5228-408f-9844-0c5a2daf8ec5', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:09', 54, 0, '', '2019-05-24 14:25:09');
INSERT INTO `access_log` VALUES (7577, '9dd65374-1766-4ea7-a6c3-6debd65b3b61', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:10', 46, 0, '', '2019-05-24 14:25:10');
INSERT INTO `access_log` VALUES (7578, '4b634285-1884-483d-ac61-0e3d172f6630', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:10', 48, 0, '', '2019-05-24 14:25:10');
INSERT INTO `access_log` VALUES (7579, '98693fab-e505-4f8c-9042-fc87e9be74d5', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:13', 42, 0, '', '2019-05-24 14:25:13');
INSERT INTO `access_log` VALUES (7580, 'b39311d7-4902-48f5-9381-abf94cfea6a1', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:14', 420, 0, '', '2019-05-24 14:25:14');
INSERT INTO `access_log` VALUES (7581, '6ab1809f-c378-42c5-81c3-443845fa71e9', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:14', 422, 0, '', '2019-05-24 14:25:14');
INSERT INTO `access_log` VALUES (7582, '68a42d85-3548-445d-a12d-935022af2187', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:14', 49, 0, '', '2019-05-24 14:25:14');
INSERT INTO `access_log` VALUES (7583, '4bd5c62d-c73c-4198-bec9-2a4a7b2aa877', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:16', 285, 0, '', '2019-05-24 14:25:16');
INSERT INTO `access_log` VALUES (7584, '90090f8e-3a4d-4554-a238-de78230d8a7f', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:16', 42, 0, '', '2019-05-24 14:25:16');
INSERT INTO `access_log` VALUES (7585, '0ebde0c2-4052-4f4c-bba1-adaaa2eed6f8', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:16', 59, 0, '', '2019-05-24 14:25:16');
INSERT INTO `access_log` VALUES (7586, '73e3ca27-8f13-48cb-a549-60d9d7d4614f', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:17', 82, 0, '', '2019-05-24 14:25:17');
INSERT INTO `access_log` VALUES (7587, 'e7308716-8ca5-4132-b4d6-664355a99874', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:25', 37, 0, '', '2019-05-24 14:25:26');
INSERT INTO `access_log` VALUES (7588, '18c9ff11-ae16-40d1-b0dc-f4ecb8c83e03', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:26', 38, 0, '', '2019-05-24 14:25:26');
INSERT INTO `access_log` VALUES (7589, 'de54beea-c8d1-4082-b979-d31a6aeafe6f', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:26', 48, 0, '', '2019-05-24 14:25:26');
INSERT INTO `access_log` VALUES (7590, '01f2623f-032a-434e-b079-90930c1a931d', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:25:26', 42, 0, '', '2019-05-24 14:25:26');
INSERT INTO `access_log` VALUES (7591, '59.77.15586790820884311', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:24:42', 5, 0, '', '2019-05-24 14:24:42');
INSERT INTO `access_log` VALUES (7592, '59.76.15586790820884307', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:24:42', 14, 2001001000, '服务端发生异常', '2019-05-24 14:24:42');
INSERT INTO `access_log` VALUES (7593, '64.81.15586790858073531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:24:46', 5, 0, '', '2019-05-24 14:24:46');
INSERT INTO `access_log` VALUES (7594, '64.79.15586790859313529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:24:46', 3, 0, '', '2019-05-24 14:24:46');
INSERT INTO `access_log` VALUES (7595, '64.80.15586790869323527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:24:47', 4, 0, '', '2019-05-24 14:24:47');
INSERT INTO `access_log` VALUES (7596, '64.76.15586790873683531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:24:47', 3, 0, '', '2019-05-24 14:24:47');
INSERT INTO `access_log` VALUES (7597, '64.84.15586790876833531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:24:48', 3, 0, '', '2019-05-24 14:24:48');
INSERT INTO `access_log` VALUES (7598, '64.78.15586790880903533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:24:48', 3, 0, '', '2019-05-24 14:24:48');
INSERT INTO `access_log` VALUES (7599, 'c35727c6-91df-4911-821b-cf87c84ef477', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:12', 35, 0, '', '2019-05-24 14:26:12');
INSERT INTO `access_log` VALUES (7600, 'ed753688-3582-453f-a057-a75c8c5e04a4', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:12', 34, 0, '', '2019-05-24 14:26:12');
INSERT INTO `access_log` VALUES (7601, 'bc0cb1dd-f7ae-4363-b267-568110845deb', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:12', 38, 0, '', '2019-05-24 14:26:12');
INSERT INTO `access_log` VALUES (7602, '2d01bc3f-e7fb-47d1-b63d-4aa982d7638c', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:12', 46, 0, '', '2019-05-24 14:26:12');
INSERT INTO `access_log` VALUES (7603, '69fc317d-0feb-4fa1-ab3f-5ed21d40b9cf', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:12', 58, 0, '', '2019-05-24 14:26:12');
INSERT INTO `access_log` VALUES (7604, '1bb30c16-97ea-4941-815c-29e36604b570', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:12', 52, 0, '', '2019-05-24 14:26:12');
INSERT INTO `access_log` VALUES (7605, 'f2b181c4-5c51-4f26-a0c7-dcbdf1fd9225', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:12', 46, 0, '', '2019-05-24 14:26:12');
INSERT INTO `access_log` VALUES (7606, 'd8bffa9b-c374-4067-9fb1-c666907e6042', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:12', 126, 0, '', '2019-05-24 14:26:13');
INSERT INTO `access_log` VALUES (7607, '9904aff3-8d49-4a1c-8bf9-6f229ac470fd', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:14', 34, 0, '', '2019-05-24 14:26:14');
INSERT INTO `access_log` VALUES (7608, '5c5c8886-1bb8-44f9-b8a1-4189a4e81cae', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:14', 38, 0, '', '2019-05-24 14:26:14');
INSERT INTO `access_log` VALUES (7609, '48396089-0e76-48da-9668-ecf220c1e86c', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:14', 70, 0, '', '2019-05-24 14:26:14');
INSERT INTO `access_log` VALUES (7610, '77a75c70-0187-4dcc-a9eb-b4c68e57c34a', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:14', 53, 0, '', '2019-05-24 14:26:14');
INSERT INTO `access_log` VALUES (7611, '5289568b-fddb-4a4c-a9d6-a634acc0ef12', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:19', 12, 1002001012, '访问令牌已过期', '2019-05-24 14:26:19');
INSERT INTO `access_log` VALUES (7612, '933ede30-7e32-4167-bf29-27192877d797', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:19', 13, 1002001012, '访问令牌已过期', '2019-05-24 14:26:19');
INSERT INTO `access_log` VALUES (7613, '191e49d3-05ca-4ea1-a194-42b249237448', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:20', 13, 1002001012, '访问令牌已过期', '2019-05-24 14:26:20');
INSERT INTO `access_log` VALUES (7614, 'e7cccffd-10ba-4ec5-9adf-212ba58a991b', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:21', 58, 1002001012, '访问令牌已过期', '2019-05-24 14:26:21');
INSERT INTO `access_log` VALUES (7615, '2d3a070e-23ce-4672-8ad2-723fed786ea3', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:21', 12, 1002001012, '访问令牌已过期', '2019-05-24 14:26:21');
INSERT INTO `access_log` VALUES (7616, '7e3716cd-3dc7-4547-82d6-b40e7582574a', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:21', 15, 1002001012, '访问令牌已过期', '2019-05-24 14:26:21');
INSERT INTO `access_log` VALUES (7617, '090af7ff-13af-4f09-b6b0-07a85b31653c', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:22', 13, 1002001012, '访问令牌已过期', '2019-05-24 14:26:22');
INSERT INTO `access_log` VALUES (7618, '0d7b1df1-93c4-4841-8101-07ec1e6dc117', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:26:22', 23, 1002001012, '访问令牌已过期', '2019-05-24 14:26:22');
INSERT INTO `access_log` VALUES (7619, '65.46.15586791189963521', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.113.132.119', '2019-05-24 14:25:19', 1, 1002001015, '账号未登陆', '2019-05-24 14:25:19');
INSERT INTO `access_log` VALUES (7620, '65.48.15586791189973517', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:25:19', 0, 1002001015, '账号未登陆', '2019-05-24 14:25:19');
INSERT INTO `access_log` VALUES (7621, '65.50.15586791295133509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:25:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 14:25:30');
INSERT INTO `access_log` VALUES (7622, '65.54.15586791332553505', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:25:33', 119, 0, '', '2019-05-24 14:25:33');
INSERT INTO `access_log` VALUES (7623, '65.53.15586791336433509', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:25:34', 18, 0, '', '2019-05-24 14:25:34');
INSERT INTO `access_log` VALUES (7624, '65.51.15586791336413507', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:25:34', 22, 0, '', '2019-05-24 14:25:34');
INSERT INTO `access_log` VALUES (7625, '65.45.15586791336403529', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:25:34', 23, 0, '', '2019-05-24 14:25:34');
INSERT INTO `access_log` VALUES (7626, '62.84.15586791415414265', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:25:42', 25, 0, '', '2019-05-24 14:25:42');
INSERT INTO `access_log` VALUES (7627, '64.79.15586791440173531', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:25:44', 13, 0, '', '2019-05-24 14:25:44');
INSERT INTO `access_log` VALUES (7628, '64.81.15586791440163533', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:25:44', 20, 0, '', '2019-05-24 14:25:44');
INSERT INTO `access_log` VALUES (7629, '66.57.15586791480373365', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:25:48', 23, 0, '', '2019-05-24 14:25:48');
INSERT INTO `access_log` VALUES (7630, '59.71.15586791501594315', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.135.84.66', '2019-05-24 14:25:50', 138, 0, '', '2019-05-24 14:25:50');
INSERT INTO `access_log` VALUES (7631, 'a42ad190-646a-476a-8303-07e8829976db', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:27:29', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 14:27:29');
INSERT INTO `access_log` VALUES (7632, '13254557-d79e-4acd-a4c4-d86cf26f2da9', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:27:39', 217, 0, '', '2019-05-24 14:27:39');
INSERT INTO `access_log` VALUES (7633, 'd00ed575-f7d0-4509-bca4-e5d9faa01d71', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:27:40', 36, 0, '', '2019-05-24 14:27:40');
INSERT INTO `access_log` VALUES (7634, '4492a5cd-86c8-4f99-b1d9-1c7daf4d5789', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:27:40', 43, 0, '', '2019-05-24 14:27:40');
INSERT INTO `access_log` VALUES (7635, 'c52090db-a4b8-4e1f-8cda-8e87562bb3c6', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:27:40', 36, 0, '', '2019-05-24 14:27:40');
INSERT INTO `access_log` VALUES (7636, '36e1f8d6-de6d-4911-9ae8-6c95371f47b0', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:27:43', 61, 0, '', '2019-05-24 14:27:43');
INSERT INTO `access_log` VALUES (7637, 'c8e6110d-69d0-421f-859c-482520132d8d', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:27:58', 44, 0, '', '2019-05-24 14:27:58');
INSERT INTO `access_log` VALUES (7638, '0cee0f18-58e9-4b9f-9c42-f0b52a4a3ae4', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:27:58', 73, 0, '', '2019-05-24 14:27:58');
INSERT INTO `access_log` VALUES (7639, 'fec0aff8-10b4-4324-a59d-0b479620c648', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:28:04', 37, 0, '', '2019-05-24 14:28:04');
INSERT INTO `access_log` VALUES (7640, '128a5c8b-5501-4a5a-9f7a-5e22831d06c6', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:28:06', 54, 0, '', '2019-05-24 14:28:07');
INSERT INTO `access_log` VALUES (7641, '3f3c0697-8fd7-4f77-a33a-c9137d5ac524', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:28:06', 62, 0, '', '2019-05-24 14:28:07');
INSERT INTO `access_log` VALUES (7642, '6bf772cc-bff8-4d6a-8828-cc7a514d001a', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:28:08', 44, 0, '', '2019-05-24 14:28:08');
INSERT INTO `access_log` VALUES (7643, '8488af87-31a1-45be-bb03-01295ac4d840', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:28:08', 46, 0, '', '2019-05-24 14:28:08');
INSERT INTO `access_log` VALUES (7644, '2d842b30-21dc-41cb-9a27-4e7de003e421', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:28:12', 33, 0, '', '2019-05-24 14:28:12');
INSERT INTO `access_log` VALUES (7645, '0333b3cd-6c82-4f8c-bda5-04c501332cd3', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:28:12', 42, 0, '', '2019-05-24 14:28:12');
INSERT INTO `access_log` VALUES (7646, 'fd6dddfb-0b2a-4b15-b8db-9b8ef16c24c8', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:28:15', 52, 0, '', '2019-05-24 14:28:15');
INSERT INTO `access_log` VALUES (7647, 'e36f403b-1e1d-4c77-b47c-374f196fd100', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:28:48', 54, 0, '', '2019-05-24 14:28:48');
INSERT INTO `access_log` VALUES (7648, '31e4818e-d981-4b17-8c3c-4b47c70c47f2', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:28:52', 68, 0, '', '2019-05-24 14:28:53');
INSERT INTO `access_log` VALUES (7649, '1226cc35-916c-42a6-933b-5516bbd4da3c', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:28:59', 39, 0, '', '2019-05-24 14:28:59');
INSERT INTO `access_log` VALUES (7650, '74348cf9-3039-4222-909c-de9e2de1235a', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:28:59', 54, 0, '', '2019-05-24 14:28:59');
INSERT INTO `access_log` VALUES (7651, '5c46865c-f067-48cc-95cd-e383292c8a86', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:29:03', 40, 0, '', '2019-05-24 14:29:03');
INSERT INTO `access_log` VALUES (7652, '3968a64f-5bf9-4421-ab13-522dcc90a362', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:29:04', 55, 0, '', '2019-05-24 14:29:04');
INSERT INTO `access_log` VALUES (7653, '190bc500-f422-460a-a585-0f835d7682e6', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:29:04', 39, 0, '', '2019-05-24 14:29:04');
INSERT INTO `access_log` VALUES (7654, '06556bf6-2142-44e0-ba20-f2dfde15ad6d', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:29:07', 39, 0, '', '2019-05-24 14:29:07');
INSERT INTO `access_log` VALUES (7655, 'f44c31cd-4a74-47bf-8bfa-7f4fde68311b', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:29:13', 40, 0, '', '2019-05-24 14:29:13');
INSERT INTO `access_log` VALUES (7656, '502f4e6b-fc62-41ca-b7b6-7e3d4271ad67', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:30:05', 35, 0, '', '2019-05-24 14:30:05');
INSERT INTO `access_log` VALUES (7657, 'bd08dc8b-13bc-47ab-ade2-ae2a09a21664', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:30:05', 48, 0, '', '2019-05-24 14:30:05');
INSERT INTO `access_log` VALUES (7658, '0a739cae-e4d0-45a9-b5a2-03021a5cf734', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:30:07', 54, 0, '', '2019-05-24 14:30:07');
INSERT INTO `access_log` VALUES (7659, '7d856d58-e61d-44f0-83a9-7faaa18a0391', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:30:08', 38, 0, '', '2019-05-24 14:30:08');
INSERT INTO `access_log` VALUES (7660, '4e186f39-e80e-4490-9186-3fdcb134af69', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:30:09', 38, 0, '', '2019-05-24 14:30:09');
INSERT INTO `access_log` VALUES (7661, '71a598fa-a97a-4830-a298-76c8e5eb70f9', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:30:10', 33, 0, '', '2019-05-24 14:30:10');
INSERT INTO `access_log` VALUES (7662, 'bb8607ae-3c13-4660-a13f-59c9f3ab8af5', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:30:12', 51, 0, '', '2019-05-24 14:30:12');
INSERT INTO `access_log` VALUES (7663, '29f3bc7e-f0ed-4731-9534-fabe876a48c9', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:30:14', 36, 0, '', '2019-05-24 14:30:14');
INSERT INTO `access_log` VALUES (7664, '2fbddaa4-bfa9-4b54-be73-4f4f127bf655', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:32:43', 71, 0, '', '2019-05-24 14:32:43');
INSERT INTO `access_log` VALUES (7665, 'aea7fd67-d1ca-4110-892d-b0fe7fac704d', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:33:49', 53, 0, '', '2019-05-24 14:33:49');
INSERT INTO `access_log` VALUES (7666, '507d29e9-0ab8-4cc7-8f0e-6160716f6670', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:33:52', 61, 0, '', '2019-05-24 14:33:52');
INSERT INTO `access_log` VALUES (7667, '82faed32-a737-4bd8-9972-dfac091e9980', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:33:52', 30, 0, '', '2019-05-24 14:33:52');
INSERT INTO `access_log` VALUES (7668, '31c618fe-a007-4792-a980-b27bcb47c5fb', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:34:23', 37, 0, '', '2019-05-24 14:34:23');
INSERT INTO `access_log` VALUES (7669, '0f094836-dafb-44a6-a966-26905de0048e', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:34:23', 39, 0, '', '2019-05-24 14:34:23');
INSERT INTO `access_log` VALUES (7670, 'dae0dac9-2f31-41bf-9de9-609a4fe57fb4', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:34:23', 37, 0, '', '2019-05-24 14:34:23');
INSERT INTO `access_log` VALUES (7671, 'c25072d1-b436-4586-a5bb-d70bb31f9ad0', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:34:23', 54, 0, '', '2019-05-24 14:34:23');
INSERT INTO `access_log` VALUES (7672, '43d27dab-863a-4b80-b239-e51eac3f9b1a', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:34:26', 39, 0, '', '2019-05-24 14:34:26');
INSERT INTO `access_log` VALUES (7673, '0df5b019-c6e6-4689-8cd2-1b292766441d', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:35:15', 56, 0, '', '2019-05-24 14:35:15');
INSERT INTO `access_log` VALUES (7674, '09d068af-c978-49e6-89ea-8d18bc9c3aa9', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:35:15', 68, 0, '', '2019-05-24 14:35:15');
INSERT INTO `access_log` VALUES (7675, 'aec20866-4a8e-46c7-a98e-2ad212df9ea0', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:36:30', 57, 0, '', '2019-05-24 14:36:30');
INSERT INTO `access_log` VALUES (7676, '97b6ac56-4371-416d-b0a5-d7805210befb', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:36:47', 34, 0, '', '2019-05-24 14:36:47');
INSERT INTO `access_log` VALUES (7677, '301e9e1d-5d9d-4158-a04f-ace7e5bc563a', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:36:47', 37, 0, '', '2019-05-24 14:36:47');
INSERT INTO `access_log` VALUES (7678, '248a5c95-3131-48d4-997c-708e809d1e1a', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:36:47', 36, 0, '', '2019-05-24 14:36:47');
INSERT INTO `access_log` VALUES (7679, '38a2162c-0a9b-4d48-a92c-fdae471daf2a', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:36:47', 43, 0, '', '2019-05-24 14:36:47');
INSERT INTO `access_log` VALUES (7680, '85d8b23c-526b-421a-bcc1-fc46c154a101', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:36:47', 54, 0, '', '2019-05-24 14:36:47');
INSERT INTO `access_log` VALUES (7681, 'd3421272-46a3-428e-b5db-326191f989af', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:40:52', 39, 0, '', '2019-05-24 14:40:52');
INSERT INTO `access_log` VALUES (7682, 'e8d6a43e-80ae-4e7f-9397-e4380524750c', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:40:52', 39, 0, '', '2019-05-24 14:40:52');
INSERT INTO `access_log` VALUES (7683, '667049a9-e356-40d6-84ef-ce1bc3e0dd7b', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:40:54', 40, 0, '', '2019-05-24 14:40:54');
INSERT INTO `access_log` VALUES (7684, '8d4ed3e0-17b9-46f7-a721-11078a65a808', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:40:54', 81, 0, '', '2019-05-24 14:40:54');
INSERT INTO `access_log` VALUES (7685, '58d8567d-1dc7-4d76-9d14-5b55cb520f6f', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:40:54', 89, 0, '', '2019-05-24 14:40:54');
INSERT INTO `access_log` VALUES (7686, '20b38266-12fb-41b6-81a2-9506c9e7854c', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:40:59', 33, 0, '', '2019-05-24 14:40:59');
INSERT INTO `access_log` VALUES (7687, '6f462d7d-c11f-451f-8d6b-1376a2f0dcdd', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:40:59', 35, 0, '', '2019-05-24 14:40:59');
INSERT INTO `access_log` VALUES (7688, '80978c31-6fbc-42a7-b330-64acdfa9d04b', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:40:59', 36, 0, '', '2019-05-24 14:40:59');
INSERT INTO `access_log` VALUES (7689, '21da1105-47b6-4d91-970c-1af9d31f96c1', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:40:59', 49, 0, '', '2019-05-24 14:40:59');
INSERT INTO `access_log` VALUES (7690, '426288f8-31d1-4fb3-bd71-3400272633b4', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:40:59', 62, 0, '', '2019-05-24 14:40:59');
INSERT INTO `access_log` VALUES (7691, '28289b73-5ed2-451c-a680-7fed163ca8f6', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:41:03', 34, 0, '', '2019-05-24 14:41:03');
INSERT INTO `access_log` VALUES (7692, '4c3e2e02-e8a2-4401-b082-49a6f5ab6ca2', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:41:03', 39, 0, '', '2019-05-24 14:41:03');
INSERT INTO `access_log` VALUES (7693, 'f5733833-0781-4d7c-bc43-6faed6126def', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:41:03', 30, 0, '', '2019-05-24 14:41:03');
INSERT INTO `access_log` VALUES (7694, '2a1ba221-16da-472b-a5df-b204ce0974de', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:41:03', 30, 0, '', '2019-05-24 14:41:03');
INSERT INTO `access_log` VALUES (7695, 'e6b339e2-b19a-4a65-8a10-5fa419305991', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:41:03', 32, 0, '', '2019-05-24 14:41:03');
INSERT INTO `access_log` VALUES (7696, '1c063f4b-73eb-44a1-ac8d-f55b0903f774', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:41:13', 609, 0, '', '2019-05-24 14:41:13');
INSERT INTO `access_log` VALUES (7697, '160d31cf-c325-4b91-ba1b-6b09be0f6530', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:41:14', 58, 0, '', '2019-05-24 14:41:14');
INSERT INTO `access_log` VALUES (7698, '094d9747-6af3-4aa0-8ab2-35a55252f081', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:41:14', 61, 0, '', '2019-05-24 14:41:14');
INSERT INTO `access_log` VALUES (7699, 'fdb41ba3-c34d-446b-8254-3b1afe7c82ca', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:41:14', 69, 0, '', '2019-05-24 14:41:14');
INSERT INTO `access_log` VALUES (7700, '5888dd3b-23c6-4b7f-9fe8-e89d73f1b886', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:41:14', 79, 0, '', '2019-05-24 14:41:14');
INSERT INTO `access_log` VALUES (7701, '8065427b-acab-44f7-b63b-40921e7ff499', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:42:02', 36, 0, '', '2019-05-24 14:42:02');
INSERT INTO `access_log` VALUES (7702, '0abe9465-e971-4a14-9982-876c84cc7338', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:42:35', 36, 0, '', '2019-05-24 14:42:35');
INSERT INTO `access_log` VALUES (7703, '3bbf7cdc-61dd-4834-b8cb-942bec90b6ac', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:42:35', 49, 0, '', '2019-05-24 14:42:35');
INSERT INTO `access_log` VALUES (7704, 'e8fa2f9e-46f8-4f7b-8ead-5631adb0a9b8', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:42:36', 44, 0, '', '2019-05-24 14:42:36');
INSERT INTO `access_log` VALUES (7705, '77aab006-c62d-4c32-9d6d-5b941613c6b4', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:42:36', 50, 0, '', '2019-05-24 14:42:36');
INSERT INTO `access_log` VALUES (7706, '5ad30973-ef39-4674-9785-5662c930e62e', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:45:06', 67, 0, '', '2019-05-24 14:45:06');
INSERT INTO `access_log` VALUES (7707, '5787ad08-cc0f-4a2c-b8aa-9e57abf94977', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:45:06', 98, 0, '', '2019-05-24 14:45:06');
INSERT INTO `access_log` VALUES (7708, 'a592dd76-b4ce-44f5-a898-5213775bea6e', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:45:15', 62, 0, '', '2019-05-24 14:45:15');
INSERT INTO `access_log` VALUES (7709, '36656120-15f2-4568-ad8d-19fe2f47d0c0', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:45:16', 40, 0, '', '2019-05-24 14:45:16');
INSERT INTO `access_log` VALUES (7710, 'dc4baf4c-acdc-49f1-8063-0f902883593f', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:45:25', 41, 0, '', '2019-05-24 14:45:25');
INSERT INTO `access_log` VALUES (7711, 'dcdd221c-0fdb-4d8f-91b2-283341cb9952', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:47:49', 40, 0, '', '2019-05-24 14:47:49');
INSERT INTO `access_log` VALUES (7712, '23a3d8f2-fd6f-4c45-860e-bcd732afab7c', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:47:49', 39, 0, '', '2019-05-24 14:47:49');
INSERT INTO `access_log` VALUES (7713, '6b3a5700-d632-47bf-aa19-f33e61c162e5', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:47:49', 41, 0, '', '2019-05-24 14:47:49');
INSERT INTO `access_log` VALUES (7714, 'cd4c4aa6-3702-4ac8-ab5c-45bb75902ec5', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:47:49', 80, 0, '', '2019-05-24 14:47:49');
INSERT INTO `access_log` VALUES (7715, 'f573e615-26b4-4e31-8477-ee8154dee215', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:47:49', 34, 0, '', '2019-05-24 14:47:49');
INSERT INTO `access_log` VALUES (7716, 'cab89468-4dee-4a28-90f6-0592eb7ed34b', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:47:49', 40, 0, '', '2019-05-24 14:47:49');
INSERT INTO `access_log` VALUES (7717, '7ea628ee-6a2d-454d-96ce-d53736377856', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:47:49', 114, 0, '', '2019-05-24 14:47:49');
INSERT INTO `access_log` VALUES (7718, '9b911c16-c1d9-4eda-92bd-eb8b73ef07c6', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:47:49', 32, 0, '', '2019-05-24 14:47:49');
INSERT INTO `access_log` VALUES (7719, '069bb6b9-b8bc-44e2-b9de-e09f41c58d81', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:47:54', 32, 0, '', '2019-05-24 14:47:54');
INSERT INTO `access_log` VALUES (7720, '7cfbb322-f2b6-4e1f-8d5c-2ec89abf9a0e', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 14:47:54', 47, 0, '', '2019-05-24 14:47:54');
INSERT INTO `access_log` VALUES (7721, 'b662b6c4-315a-459b-98a4-12e598ee9c15', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:20:26', 68, 1002001012, '访问令牌已过期', '2019-05-24 15:20:26');
INSERT INTO `access_log` VALUES (7722, 'f52413aa-63fe-4838-8758-683985eb806d', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:20:26', 80, 1002001012, '访问令牌已过期', '2019-05-24 15:20:26');
INSERT INTO `access_log` VALUES (7723, '3a7ebeb3-6071-4425-95c9-e5a6612302c2', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:20:27', 9, 1002001012, '访问令牌已过期', '2019-05-24 15:20:27');
INSERT INTO `access_log` VALUES (7724, '314412d3-255a-4724-92f9-137c55377503', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:20:53', 101, 0, '', '2019-05-24 15:20:53');
INSERT INTO `access_log` VALUES (7725, '0137682c-4da3-4895-93a8-433638b20fe8', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:20:53', 38, 0, '', '2019-05-24 15:20:53');
INSERT INTO `access_log` VALUES (7726, 'b227a948-23c6-4058-924d-4394fe2b9881', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:20:53', 57, 0, '', '2019-05-24 15:20:53');
INSERT INTO `access_log` VALUES (7727, '691e1339-77d2-4239-9778-f660088fe912', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:20:53', 63, 0, '', '2019-05-24 15:20:53');
INSERT INTO `access_log` VALUES (7728, '65bd7d40-bdeb-4fda-b94b-b51bf5ea435a', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:23:32', 59, 0, '', '2019-05-24 15:23:32');
INSERT INTO `access_log` VALUES (7729, '2ac2fb1b-b036-4fc3-acba-1330713e0532', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:23:32', 54, 0, '', '2019-05-24 15:23:32');
INSERT INTO `access_log` VALUES (7730, '5a547737-efb3-4176-9c57-c1a2b26d90b4', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:23:32', 52, 0, '', '2019-05-24 15:23:32');
INSERT INTO `access_log` VALUES (7731, '5ad79194-3558-4660-90e3-2529c29c9e89', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:23:33', 181, 0, '', '2019-05-24 15:23:33');
INSERT INTO `access_log` VALUES (7732, '5b8ed89e-6a19-4cea-8fb6-bbb4a28ca4d2', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:23:33', 169, 0, '', '2019-05-24 15:23:33');
INSERT INTO `access_log` VALUES (7733, 'a9f58aa8-6e03-4431-956c-d3123c4e6e98', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:23:44', 42, 0, '', '2019-05-24 15:23:44');
INSERT INTO `access_log` VALUES (7734, '6d984fd8-3bfa-4539-b049-5c0f1908ad81', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:23:44', 54, 0, '', '2019-05-24 15:23:44');
INSERT INTO `access_log` VALUES (7735, '61d6a9b1-8f32-4612-b641-78550915cb00', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:23:45', 48, 0, '', '2019-05-24 15:23:45');
INSERT INTO `access_log` VALUES (7736, '2a5f2bcf-5e14-4fc0-89ca-63f5fb0c49ab', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:25:42', 44, 0, '', '2019-05-24 15:25:42');
INSERT INTO `access_log` VALUES (7737, '1b7e97ed-8960-45ec-8854-e4bdeefe3cfb', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:25:42', 46, 0, '', '2019-05-24 15:25:42');
INSERT INTO `access_log` VALUES (7738, 'e22902e8-5129-4b08-9a0b-205aca6edc37', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:25:42', 53, 0, '', '2019-05-24 15:25:43');
INSERT INTO `access_log` VALUES (7739, '08dd5eb6-19e5-4e08-acfd-5388b0ee66f5', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:25:44', 30, 0, '', '2019-05-24 15:25:44');
INSERT INTO `access_log` VALUES (7740, '885847dc-2fef-457b-b72d-e3bfc5f49e90', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:25:46', 44, 0, '', '2019-05-24 15:25:46');
INSERT INTO `access_log` VALUES (7741, '1761b5e8-f687-4fd7-b106-4e184d2d28fb', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:25:46', 45, 0, '', '2019-05-24 15:25:46');
INSERT INTO `access_log` VALUES (7742, '3f6e73d5-acd7-482a-a8f5-c59fa751d1e7', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:25:46', 103, 0, '', '2019-05-24 15:25:46');
INSERT INTO `access_log` VALUES (7743, 'cdc2dafe-68f3-410e-b727-d74701d7c630', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:25:46', 113, 0, '', '2019-05-24 15:25:46');
INSERT INTO `access_log` VALUES (7744, '45b343e0-7b38-4bcb-b0be-c4bd45933209', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:25:46', 31, 0, '', '2019-05-24 15:25:46');
INSERT INTO `access_log` VALUES (7745, '5988d709-f387-4198-8ff2-06f10ca94d99', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:25:46', 28, 0, '', '2019-05-24 15:25:46');
INSERT INTO `access_log` VALUES (7746, 'a3a6d807-f25e-4ee7-b799-a2383abf0586', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:25:46', 42, 0, '', '2019-05-24 15:25:46');
INSERT INTO `access_log` VALUES (7747, '14d0007f-3beb-4a2b-96c4-c15461431974', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:48', 38, 0, '', '2019-05-24 15:26:48');
INSERT INTO `access_log` VALUES (7748, '5a3927bf-e2cd-4483-aadf-0a364538ddba', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:48', 41, 0, '', '2019-05-24 15:26:48');
INSERT INTO `access_log` VALUES (7749, 'cf5811eb-2e64-4ccf-9cbe-ad0a34da7547', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:48', 48, 0, '', '2019-05-24 15:26:48');
INSERT INTO `access_log` VALUES (7750, 'e9ee8d49-e352-41aa-8111-a9b5bfa552fd', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:48', 77, 0, '', '2019-05-24 15:26:48');
INSERT INTO `access_log` VALUES (7751, 'b1ddb8d0-556e-4b53-b734-b3323d7a2123', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:48', 92, 0, '', '2019-05-24 15:26:48');
INSERT INTO `access_log` VALUES (7752, '3be881d7-4256-4bf5-b1b0-30edd33148a9', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:50', 37, 0, '', '2019-05-24 15:26:50');
INSERT INTO `access_log` VALUES (7753, '2bdd22bb-268d-43e9-b896-98f8d0537db9', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:50', 35, 0, '', '2019-05-24 15:26:50');
INSERT INTO `access_log` VALUES (7754, 'f001cc9a-727f-4403-a3fe-3cf60a5bbb60', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:50', 44, 0, '', '2019-05-24 15:26:50');
INSERT INTO `access_log` VALUES (7755, '90543574-0428-41bf-8620-2c0ec82f33e1', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:51', 41, 0, '', '2019-05-24 15:26:51');
INSERT INTO `access_log` VALUES (7756, '6f5a926d-782a-4048-90f7-8148e335b3ec', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:51', 37, 0, '', '2019-05-24 15:26:51');
INSERT INTO `access_log` VALUES (7757, '307c7bf9-b18a-44ce-b5e5-f3afe0092189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:56', 33, 0, '', '2019-05-24 15:26:56');
INSERT INTO `access_log` VALUES (7758, '3a740f30-de98-47ca-9d8c-a27a12324640', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:56', 30, 0, '', '2019-05-24 15:26:56');
INSERT INTO `access_log` VALUES (7759, 'fdffdc9c-440f-4ab8-b1bb-d375a6dd6415', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:56', 34, 0, '', '2019-05-24 15:26:56');
INSERT INTO `access_log` VALUES (7760, 'f784c2c9-5cde-4340-9d4c-a4207499bd84', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:56', 45, 0, '', '2019-05-24 15:26:56');
INSERT INTO `access_log` VALUES (7761, '605dde7f-eb6c-42e9-a4df-2a306cb3d2ae', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:26:56', 31, 0, '', '2019-05-24 15:26:57');
INSERT INTO `access_log` VALUES (7762, '89881381-1f1a-462e-aa84-9275595abb0d', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:27:15', 39, 0, '', '2019-05-24 15:27:15');
INSERT INTO `access_log` VALUES (7763, '9916b46f-4141-401d-8fc2-695208711844', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:27:15', 48, 0, '', '2019-05-24 15:27:15');
INSERT INTO `access_log` VALUES (7764, 'bd6dc2a8-3a0e-4a40-8d69-4301d8efce75', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:27:15', 63, 0, '', '2019-05-24 15:27:16');
INSERT INTO `access_log` VALUES (7765, '52eaf9ea-61a4-4ed7-a2e9-4fdf7306a518', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:27:15', 58, 0, '', '2019-05-24 15:27:16');
INSERT INTO `access_log` VALUES (7766, '7c8be1c1-ca35-4285-8344-5fb08f8e40d4', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:27:15', 67, 0, '', '2019-05-24 15:27:16');
INSERT INTO `access_log` VALUES (7767, 'b4173291-5dd4-4447-acb7-d20979874531', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:28:01', 29, 0, '', '2019-05-24 15:28:01');
INSERT INTO `access_log` VALUES (7768, 'af8ba782-bcc7-4243-9da8-599ff6d6576b', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:28:01', 40, 0, '', '2019-05-24 15:28:01');
INSERT INTO `access_log` VALUES (7769, '6add590c-8e97-48f6-9f07-452e75ae39ee', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:28:02', 463, 0, '', '2019-05-24 15:28:03');
INSERT INTO `access_log` VALUES (7770, '83c6cd0a-d173-4eb5-8ba5-5f8054cfc984', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:28:02', 472, 0, '', '2019-05-24 15:28:03');
INSERT INTO `access_log` VALUES (7771, '65bc4e4a-fc2d-465b-b6c5-47822341d7bf', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:28:02', 485, 0, '', '2019-05-24 15:28:03');
INSERT INTO `access_log` VALUES (7772, '70c7cc3d-f6a9-43df-ad5f-92a0cb90aa40', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:28:06', 66, 0, '', '2019-05-24 15:28:06');
INSERT INTO `access_log` VALUES (7773, 'c533e1af-6d2f-46f9-85db-d8f7913cde24', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:28:06', 39, 0, '', '2019-05-24 15:28:06');
INSERT INTO `access_log` VALUES (7774, 'e1a91064-1fa3-4ada-b2f5-196b3ead42a8', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:28:06', 41, 0, '', '2019-05-24 15:28:06');
INSERT INTO `access_log` VALUES (7775, '398010a7-34b9-4fb6-8fc6-3708a7ed3a0f', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:28:07', 43, 0, '', '2019-05-24 15:28:07');
INSERT INTO `access_log` VALUES (7776, '43877b03-15f8-44fd-80cb-9bc0b57fd47c', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-24 15:28:07', 55, 0, '', '2019-05-24 15:28:07');
INSERT INTO `access_log` VALUES (7777, '65.47.15586854293963601', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '117.175.169.59', '2019-05-24 16:10:29', 3, 1002001015, '账号未登陆', '2019-05-24 16:10:29');
INSERT INTO `access_log` VALUES (7778, '65.51.15586854293953591', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '117.175.169.59', '2019-05-24 16:10:29', 1, 1002001015, '账号未登陆', '2019-05-24 16:10:29');
INSERT INTO `access_log` VALUES (7779, '65.53.15586854293953595', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '117.175.169.59', '2019-05-24 16:10:29', 3, 1002001015, '账号未登陆', '2019-05-24 16:10:29');
INSERT INTO `access_log` VALUES (7780, '59.77.15586854305944397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '117.175.169.59', '2019-05-24 16:10:31', 12, 0, '', '2019-05-24 16:10:31');
INSERT INTO `access_log` VALUES (7781, '59.76.15586854305954393', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '117.175.169.59', '2019-05-24 16:10:31', 15, 2001001000, '服务端发生异常', '2019-05-24 16:10:31');
INSERT INTO `access_log` VALUES (7782, '64.79.15586854464443617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '117.175.169.59', '2019-05-24 16:10:46', 13, 0, '', '2019-05-24 16:10:46');
INSERT INTO `access_log` VALUES (7783, '64.84.15586854465523619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '117.175.169.59', '2019-05-24 16:10:47', 4, 0, '', '2019-05-24 16:10:47');
INSERT INTO `access_log` VALUES (7784, '64.85.15586854476633619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '117.175.169.59', '2019-05-24 16:10:48', 4, 0, '', '2019-05-24 16:10:48');
INSERT INTO `access_log` VALUES (7785, '64.78.15586854484993621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '117.175.169.59', '2019-05-24 16:10:49', 3, 0, '', '2019-05-24 16:10:49');
INSERT INTO `access_log` VALUES (7786, '59.72.15586854496854393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '117.175.169.59', '2019-05-24 16:10:50', 5, 0, '', '2019-05-24 16:10:50');
INSERT INTO `access_log` VALUES (7787, '59.73.15586854496854399', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '117.175.169.59', '2019-05-24 16:10:50', 15, 2001001000, '服务端发生异常', '2019-05-24 16:10:50');
INSERT INTO `access_log` VALUES (7788, '65.47.15586867205423619', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:32:01', 0, 1002001015, '账号未登陆', '2019-05-24 16:32:01');
INSERT INTO `access_log` VALUES (7789, '65.51.15586867205423609', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:32:01', 0, 1002001015, '账号未登陆', '2019-05-24 16:32:01');
INSERT INTO `access_log` VALUES (7790, '65.45.15586867205423633', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:32:01', 0, 1002001015, '账号未登陆', '2019-05-24 16:32:01');
INSERT INTO `access_log` VALUES (7791, '65.48.15586867808703621', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '180.97.118.219', '2019-05-24 16:33:01', 1, 1002001015, '账号未登陆', '2019-05-24 16:33:01');
INSERT INTO `access_log` VALUES (7792, '65.48.15586869093063623', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:35:09', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 16:35:09');
INSERT INTO `access_log` VALUES (7793, '65.50.15586869235293615', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:35:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 16:35:24');
INSERT INTO `access_log` VALUES (7794, '65.53.15586869836893617', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:36:24', 100, 0, '', '2019-05-24 16:36:24');
INSERT INTO `access_log` VALUES (7795, '65.52.15586869840443615', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:36:24', 14, 0, '', '2019-05-24 16:36:24');
INSERT INTO `access_log` VALUES (7796, '65.46.15586869840403631', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:36:24', 19, 0, '', '2019-05-24 16:36:24');
INSERT INTO `access_log` VALUES (7797, '65.48.15586869840793625', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:36:24', 13, 0, '', '2019-05-24 16:36:24');
INSERT INTO `access_log` VALUES (7798, '62.85.15586869918634367', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:36:32', 30, 0, '', '2019-05-24 16:36:32');
INSERT INTO `access_log` VALUES (7799, '65.54.15586869993443615', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:36:39', 42, 0, '', '2019-05-24 16:36:39');
INSERT INTO `access_log` VALUES (7800, '65.51.15586870145223615', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:36:55', 77, 0, '', '2019-05-24 16:36:55');
INSERT INTO `access_log` VALUES (7801, '65.47.15586870147723625', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:36:55', 10, 0, '', '2019-05-24 16:36:55');
INSERT INTO `access_log` VALUES (7802, '65.53.15586870147783619', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:36:55', 10, 0, '', '2019-05-24 16:36:55');
INSERT INTO `access_log` VALUES (7803, '65.49.15586870147823627', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:36:55', 11, 0, '', '2019-05-24 16:36:55');
INSERT INTO `access_log` VALUES (7804, '62.84.15586870218854369', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:37:02', 16, 0, '', '2019-05-24 16:37:02');
INSERT INTO `access_log` VALUES (7805, '62.89.15586870330164373', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:37:13', 20, 0, '', '2019-05-24 16:37:13');
INSERT INTO `access_log` VALUES (7806, '62.83.15586870533484375', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.163', '2019-05-24 16:37:33', 1, 1002001015, '账号未登陆', '2019-05-24 16:37:33');
INSERT INTO `access_log` VALUES (7807, '62.80.15586870646464373', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:37:45', 17, 0, '', '2019-05-24 16:37:45');
INSERT INTO `access_log` VALUES (7808, '62.85.15586870654514369', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:37:45', 15, 0, '', '2019-05-24 16:37:45');
INSERT INTO `access_log` VALUES (7809, '62.86.15586870660774365', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:37:46', 13, 0, '', '2019-05-24 16:37:46');
INSERT INTO `access_log` VALUES (7810, '62.84.15586870756744371', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:37:56', 18, 0, '', '2019-05-24 16:37:56');
INSERT INTO `access_log` VALUES (7811, '64.78.15586870795413643', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:00', 31, 0, '', '2019-05-24 16:38:00');
INSERT INTO `access_log` VALUES (7812, '64.76.15586870795443643', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:00', 21, 0, '', '2019-05-24 16:38:00');
INSERT INTO `access_log` VALUES (7813, '64.83.15586870819133639', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:02', 13, 0, '', '2019-05-24 16:38:02');
INSERT INTO `access_log` VALUES (7814, '64.77.15586870819113647', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:02', 16, 0, '', '2019-05-24 16:38:02');
INSERT INTO `access_log` VALUES (7815, '64.80.15586870858753637', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:06', 19, 0, '', '2019-05-24 16:38:06');
INSERT INTO `access_log` VALUES (7816, '64.82.15586870858803643', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:06', 14, 0, '', '2019-05-24 16:38:06');
INSERT INTO `access_log` VALUES (7817, '64.79.15586870859163641', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:06', 10, 0, '', '2019-05-24 16:38:06');
INSERT INTO `access_log` VALUES (7818, '66.54.15586870911933465', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:11', 30, 0, '', '2019-05-24 16:38:11');
INSERT INTO `access_log` VALUES (7819, '66.51.15586871027143467', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=7&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:23', 16, 0, '', '2019-05-24 16:38:23');
INSERT INTO `access_log` VALUES (7820, '66.53.15586871103213469', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:30', 18, 0, '', '2019-05-24 16:38:30');
INSERT INTO `access_log` VALUES (7821, '59.79.15586871138354417', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:34', 15, 0, '', '2019-05-24 16:38:34');
INSERT INTO `access_log` VALUES (7822, '65.47.15586871219773627', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:42', 16, 0, '', '2019-05-24 16:38:42');
INSERT INTO `access_log` VALUES (7823, '65.49.15586871233683629', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:43', 11, 0, '', '2019-05-24 16:38:43');
INSERT INTO `access_log` VALUES (7824, '65.53.15586871244663621', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:44', 46, 0, '', '2019-05-24 16:38:45');
INSERT INTO `access_log` VALUES (7825, '65.52.15586871274333619', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:47', 20, 0, '', '2019-05-24 16:38:47');
INSERT INTO `access_log` VALUES (7826, '65.46.15586871318413635', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:38:52', 12, 0, '', '2019-05-24 16:38:52');
INSERT INTO `access_log` VALUES (7827, '64.78.15586871393473645', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.129.6.203', '2019-05-24 16:38:59', 1, 1002001015, '账号未登陆', '2019-05-24 16:38:59');
INSERT INTO `access_log` VALUES (7828, '64.83.15586871396113641', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.129.6.147', '2019-05-24 16:39:00', 1, 1002001015, '账号未登陆', '2019-05-24 16:39:00');
INSERT INTO `access_log` VALUES (7829, '64.77.15586871411483649', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.165', '2019-05-24 16:39:01', 1, 1002001015, '账号未登陆', '2019-05-24 16:39:01');
INSERT INTO `access_log` VALUES (7830, '64.81.15586871451603643', 0, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.89.239.238', '2019-05-24 16:39:05', 1, 1002001015, '账号未登陆', '2019-05-24 16:39:05');
INSERT INTO `access_log` VALUES (7831, '66.50.15586871552173465', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.151.178.174', '2019-05-24 16:39:15', 1, 1002001015, '账号未登陆', '2019-05-24 16:39:15');
INSERT INTO `access_log` VALUES (7832, '66.57.15586871624253473', 0, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=7&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.166', '2019-05-24 16:39:22', 1, 1002001015, '账号未登陆', '2019-05-24 16:39:22');
INSERT INTO `access_log` VALUES (7833, '66.54.15586871705523467', 0, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.29.97', '2019-05-24 16:39:31', 1, 1002001015, '账号未登陆', '2019-05-24 16:39:31');
INSERT INTO `access_log` VALUES (7834, '65.51.15586871832123619', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.89.239.232', '2019-05-24 16:39:43', 1, 1002001015, '账号未登陆', '2019-05-24 16:39:43');
INSERT INTO `access_log` VALUES (7835, '65.47.15586871841323629', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.163', '2019-05-24 16:39:44', 0, 1002001015, '账号未登陆', '2019-05-24 16:39:44');
INSERT INTO `access_log` VALUES (7836, '65.54.15586872713343621', 0, 2, 'admin-application', '/admin-api/admins/admin/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:41:11', 1, 1002001015, '账号未登陆', '2019-05-24 16:41:11');
INSERT INTO `access_log` VALUES (7837, '62.81.15586876916464377', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'createBeginTime=&createEndTime=&finishBeginTime=&finishEndTime=&pageNo=1&pageSize=10&payChannel=&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:48:12', 1, 1002001015, '账号未登陆', '2019-05-24 16:48:12');
INSERT INTO `access_log` VALUES (7838, '62.89.15586876919674383', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'createBeginTime=&createEndTime=&finishBeginTime=&finishEndTime=&pageNo=1&pageSize=10&payChannel=&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:48:12', 1, 1002001015, '账号未登陆', '2019-05-24 16:48:12');
INSERT INTO `access_log` VALUES (7839, '62.83.15586876928904387', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'createBeginTime=&createEndTime=&finishBeginTime=&finishEndTime=&pageNo=1&pageSize=10&payChannel=&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '115.171.135.53', '2019-05-24 16:48:13', 1, 1002001015, '账号未登陆', '2019-05-24 16:48:13');
INSERT INTO `access_log` VALUES (7840, '62.88.15586877511564387', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'createBeginTime=&createEndTime=&finishBeginTime=&finishEndTime=&pageNo=1&pageSize=10&payChannel=&status=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.60.11', '2019-05-24 16:49:11', 1, 1002001015, '账号未登陆', '2019-05-24 16:49:11');
INSERT INTO `access_log` VALUES (7841, '59.79.15586881422634431', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:55:42', 4, 0, '', '2019-05-24 16:55:42');
INSERT INTO `access_log` VALUES (7842, '59.78.15586881422784437', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:55:42', 14, 2001001000, '服务端发生异常', '2019-05-24 16:55:42');
INSERT INTO `access_log` VALUES (7843, '64.83.15586881491723655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:55:49', 4, 0, '', '2019-05-24 16:55:49');
INSERT INTO `access_log` VALUES (7844, '64.77.15586881493833663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:55:49', 3, 0, '', '2019-05-24 16:55:49');
INSERT INTO `access_log` VALUES (7845, '64.79.15586881511033657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:55:51', 2, 0, '', '2019-05-24 16:55:51');
INSERT INTO `access_log` VALUES (7846, '64.82.15586881517923659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:55:52', 3, 0, '', '2019-05-24 16:55:52');
INSERT INTO `access_log` VALUES (7847, '64.80.15586881527923653', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:55:53', 3, 0, '', '2019-05-24 16:55:53');
INSERT INTO `access_log` VALUES (7848, '64.84.15586881535423659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:55:54', 3, 0, '', '2019-05-24 16:55:54');
INSERT INTO `access_log` VALUES (7849, '64.85.15586881538123659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:55:54', 3, 0, '', '2019-05-24 16:55:54');
INSERT INTO `access_log` VALUES (7850, '59.76.15586881734534431', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:56:13', 30, 0, '', '2019-05-24 16:56:13');
INSERT INTO `access_log` VALUES (7851, '59.77.15586881734534435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:56:13', 40, 2001001000, '服务端发生异常', '2019-05-24 16:56:13');
INSERT INTO `access_log` VALUES (7852, '59.73.15586882008314437', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:56:41', 4, 0, '', '2019-05-24 16:56:41');
INSERT INTO `access_log` VALUES (7853, '59.72.15586882008314431', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:56:41', 14, 2001001000, '服务端发生异常', '2019-05-24 16:56:41');
INSERT INTO `access_log` VALUES (7854, '64.77.15586882094043665', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:56:49', 3, 0, '', '2019-05-24 16:56:49');
INSERT INTO `access_log` VALUES (7855, '64.81.15586882096143659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:56:50', 3, 0, '', '2019-05-24 16:56:50');
INSERT INTO `access_log` VALUES (7856, '66.48.15586882229453485', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15619505221', 'POST', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:57:03', 97, 0, '', '2019-05-24 16:57:03');
INSERT INTO `access_log` VALUES (7857, '65.50.15586882563493637', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:57:36', 1, 1002001015, '账号未登陆', '2019-05-24 16:57:36');
INSERT INTO `access_log` VALUES (7858, '65.47.15586882563493643', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:57:36', 0, 1002001015, '账号未登陆', '2019-05-24 16:57:36');
INSERT INTO `access_log` VALUES (7859, '65.51.15586882563493639', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:57:36', 0, 1002001015, '账号未登陆', '2019-05-24 16:57:36');
INSERT INTO `access_log` VALUES (7860, '65.48.15586882792403651', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:57:59', 63, 0, '', '2019-05-24 16:57:59');
INSERT INTO `access_log` VALUES (7861, '65.52.15586882800093641', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:58:00', 11, 0, '', '2019-05-24 16:58:00');
INSERT INTO `access_log` VALUES (7862, '65.54.15586882800273641', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:58:00', 18, 0, '', '2019-05-24 16:58:00');
INSERT INTO `access_log` VALUES (7863, '65.46.15586882800273649', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:58:00', 18, 0, '', '2019-05-24 16:58:00');
INSERT INTO `access_log` VALUES (7864, '65.47.15586882896903645', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:58:10', 582, 0, '', '2019-05-24 16:58:10');
INSERT INTO `access_log` VALUES (7865, '65.50.15586882897073639', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:58:10', 567, 0, '', '2019-05-24 16:58:10');
INSERT INTO `access_log` VALUES (7866, '65.51.15586882897033641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:58:10', 572, 0, '', '2019-05-24 16:58:10');
INSERT INTO `access_log` VALUES (7867, '65.49.15586882957103647', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:58:16', 10, 0, '', '2019-05-24 16:58:16');
INSERT INTO `access_log` VALUES (7868, '65.53.15586882957103639', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:58:16', 10, 0, '', '2019-05-24 16:58:16');
INSERT INTO `access_log` VALUES (7869, '65.48.15586882957483653', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:58:16', 11, 0, '', '2019-05-24 16:58:16');
INSERT INTO `access_log` VALUES (7870, '62.80.15586882961394391', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:58:16', 17, 0, '', '2019-05-24 16:58:16');
INSERT INTO `access_log` VALUES (7871, '62.88.15586883019004397', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:58:22', 22, 0, '', '2019-05-24 16:58:22');
INSERT INTO `access_log` VALUES (7872, '62.86.15586883025194383', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:58:23', 15, 0, '', '2019-05-24 16:58:23');
INSERT INTO `access_log` VALUES (7873, '65.50.15586883528723641', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:59:13', 11, 0, '', '2019-05-24 16:59:13');
INSERT INTO `access_log` VALUES (7874, '65.47.15586883531653647', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:59:13', 11, 0, '', '2019-05-24 16:59:13');
INSERT INTO `access_log` VALUES (7875, '65.51.15586883532153643', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:59:13', 11, 0, '', '2019-05-24 16:59:13');
INSERT INTO `access_log` VALUES (7876, '64.79.15586883543993661', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:59:14', 16, 0, '', '2019-05-24 16:59:14');
INSERT INTO `access_log` VALUES (7877, '64.82.15586883545863663', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:59:15', 12, 0, '', '2019-05-24 16:59:15');
INSERT INTO `access_log` VALUES (7878, '65.48.15586883886643655', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:59:49', 10, 0, '', '2019-05-24 16:59:49');
INSERT INTO `access_log` VALUES (7879, '65.52.15586883887193645', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:59:49', 11, 0, '', '2019-05-24 16:59:49');
INSERT INTO `access_log` VALUES (7880, '65.46.15586883888053653', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:59:49', 10, 0, '', '2019-05-24 16:59:49');
INSERT INTO `access_log` VALUES (7881, '65.54.15586883891783645', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 16:59:49', 15, 0, '', '2019-05-24 16:59:49');
INSERT INTO `access_log` VALUES (7882, '65.50.15586884079503643', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 17:00:08', 10, 0, '', '2019-05-24 17:00:08');
INSERT INTO `access_log` VALUES (7883, '65.47.15586884081623649', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 17:00:08', 10, 0, '', '2019-05-24 17:00:08');
INSERT INTO `access_log` VALUES (7884, '65.51.15586884084533645', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 17:00:08', 10, 0, '', '2019-05-24 17:00:08');
INSERT INTO `access_log` VALUES (7885, '65.49.15586884088543651', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 17:00:09', 12, 0, '', '2019-05-24 17:00:09');
INSERT INTO `access_log` VALUES (7886, '65.52.15586884339553647', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 17:00:34', 14, 0, '', '2019-05-24 17:00:34');
INSERT INTO `access_log` VALUES (7887, '65.45.15586884578703667', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 17:00:58', 10, 0, '', '2019-05-24 17:00:58');
INSERT INTO `access_log` VALUES (7888, '65.50.15586884578733645', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 17:00:58', 10, 0, '', '2019-05-24 17:00:58');
INSERT INTO `access_log` VALUES (7889, '65.47.15586884578783651', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 17:00:58', 10, 0, '', '2019-05-24 17:00:58');
INSERT INTO `access_log` VALUES (7890, '66.55.15586884585143495', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; CLT-AL01 Build/HUAWEICLT-AL01; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.1 SearchCraft/3.6.1 (Baidu; P1 9)', '123.139.86.168', '2019-05-24 17:00:59', 18, 0, '', '2019-05-24 17:00:59');
INSERT INTO `access_log` VALUES (7891, '65.50.15586885731243647', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.6', '2019-05-24 17:02:53', 1, 1002001015, '账号未登陆', '2019-05-24 17:02:53');
INSERT INTO `access_log` VALUES (7892, '65.45.15586885731233669', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.7', '2019-05-24 17:02:53', 0, 1002001015, '账号未登陆', '2019-05-24 17:02:53');
INSERT INTO `access_log` VALUES (7893, '65.47.15586885731283653', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.8', '2019-05-24 17:02:53', 1, 1002001015, '账号未登陆', '2019-05-24 17:02:53');
INSERT INTO `access_log` VALUES (7894, '65.49.15586885759843655', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.8', '2019-05-24 17:02:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 17:02:56');
INSERT INTO `access_log` VALUES (7895, '65.54.15586886392493651', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.8', '2019-05-24 17:03:59', 123, 0, '', '2019-05-24 17:03:59');
INSERT INTO `access_log` VALUES (7896, '65.45.15586886399033671', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.9', '2019-05-24 17:04:00', 11, 0, '', '2019-05-24 17:04:00');
INSERT INTO `access_log` VALUES (7897, '65.50.15586886399053649', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.8', '2019-05-24 17:04:00', 10, 0, '', '2019-05-24 17:04:00');
INSERT INTO `access_log` VALUES (7898, '65.47.15586886400093655', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.8', '2019-05-24 17:04:00', 10, 0, '', '2019-05-24 17:04:00');
INSERT INTO `access_log` VALUES (7899, '62.83.15586886567944405', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.8', '2019-05-24 17:04:17', 17, 0, '', '2019-05-24 17:04:17');
INSERT INTO `access_log` VALUES (7900, '62.82.15586886641444397', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.8', '2019-05-24 17:04:24', 21, 0, '', '2019-05-24 17:04:24');
INSERT INTO `access_log` VALUES (7901, '64.84.15586886702673667', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.9', '2019-05-24 17:04:30', 15, 0, '', '2019-05-24 17:04:30');
INSERT INTO `access_log` VALUES (7902, '64.85.15586886702683667', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.8', '2019-05-24 17:04:30', 15, 0, '', '2019-05-24 17:04:30');
INSERT INTO `access_log` VALUES (7903, '64.78.15586886735993669', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.8', '2019-05-24 17:04:34', 11, 0, '', '2019-05-24 17:04:34');
INSERT INTO `access_log` VALUES (7904, '64.76.15586886735983669', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.9', '2019-05-24 17:04:34', 15, 0, '', '2019-05-24 17:04:34');
INSERT INTO `access_log` VALUES (7905, '64.77.15586886761053673', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.9', '2019-05-24 17:04:36', 10, 0, '', '2019-05-24 17:04:36');
INSERT INTO `access_log` VALUES (7906, '64.81.15586886812413667', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.8', '2019-05-24 17:04:41', 14, 0, '', '2019-05-24 17:04:41');
INSERT INTO `access_log` VALUES (7907, '66.49.15586887112853491', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.9', '2019-05-24 17:05:11', 18, 0, '', '2019-05-24 17:05:11');
INSERT INTO `access_log` VALUES (7908, '59.76.15586887142974439', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.9', '2019-05-24 17:05:14', 15, 0, '', '2019-05-24 17:05:14');
INSERT INTO `access_log` VALUES (7909, '59.77.15586887178434443', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.9', '2019-05-24 17:05:18', 22, 2001001000, '服务端发生异常', '2019-05-24 17:05:18');
INSERT INTO `access_log` VALUES (7910, '59.74.15586887209214445', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.8', '2019-05-24 17:05:21', 14, 0, '', '2019-05-24 17:05:21');
INSERT INTO `access_log` VALUES (7911, '59.73.15586887234364445', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.8', '2019-05-24 17:05:23', 767, 0, '', '2019-05-24 17:05:24');
INSERT INTO `access_log` VALUES (7912, '59.72.15586887262944439', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.9', '2019-05-24 17:05:26', 12, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-24 17:05:26');
INSERT INTO `access_log` VALUES (7913, '65.52.15586887286283653', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.8', '2019-05-24 17:05:29', 22, 0, '', '2019-05-24 17:05:29');
INSERT INTO `access_log` VALUES (7914, '65.50.15586887299963653', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.9', '2019-05-24 17:05:30', 12, 0, '', '2019-05-24 17:05:30');
INSERT INTO `access_log` VALUES (7915, '65.54.15586887310743653', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.9', '2019-05-24 17:05:31', 9, 0, '', '2019-05-24 17:05:31');
INSERT INTO `access_log` VALUES (7916, '65.46.15586887321893661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.9', '2019-05-24 17:05:32', 16, 0, '', '2019-05-24 17:05:32');
INSERT INTO `access_log` VALUES (7917, '59.79.15586887353364441', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '183.131.110.9', '2019-05-24 17:05:35', 22, 2001001000, '服务端发生异常', '2019-05-24 17:05:35');
INSERT INTO `access_log` VALUES (7918, '59.80.15586900067094459', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.64.18.192', '2019-05-24 17:26:47', 4, 0, '', '2019-05-24 17:26:47');
INSERT INTO `access_log` VALUES (7919, '59.74.15586900067384463', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.64.18.192', '2019-05-24 17:26:47', 15, 2001001000, '服务端发生异常', '2019-05-24 17:26:47');
INSERT INTO `access_log` VALUES (7920, '59.78.15586903294654469', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '203.218.252.209', '2019-05-24 17:32:09', 5, 0, '', '2019-05-24 17:32:09');
INSERT INTO `access_log` VALUES (7921, '59.79.15586903294654463', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '203.218.252.209', '2019-05-24 17:32:09', 14, 2001001000, '服务端发生异常', '2019-05-24 17:32:09');
INSERT INTO `access_log` VALUES (7922, '65.53.15586905931143677', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:36:33', 0, 1002001015, '账号未登陆', '2019-05-24 17:36:33');
INSERT INTO `access_log` VALUES (7923, '65.48.15586905931143691', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:36:33', 0, 1002001015, '账号未登陆', '2019-05-24 17:36:33');
INSERT INTO `access_log` VALUES (7924, '65.52.15586905931223679', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:36:33', 1, 1002001015, '账号未登陆', '2019-05-24 17:36:33');
INSERT INTO `access_log` VALUES (7925, '65.53.15586910060923683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:43:26', 879, 0, '', '2019-05-24 17:43:27');
INSERT INTO `access_log` VALUES (7926, '65.52.15586910072733685', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:43:27', 12, 0, '', '2019-05-24 17:43:27');
INSERT INTO `access_log` VALUES (7927, '65.54.15586910072763685', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:43:27', 9, 0, '', '2019-05-24 17:43:27');
INSERT INTO `access_log` VALUES (7928, '65.50.15586910072743685', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:43:27', 16, 0, '', '2019-05-24 17:43:27');
INSERT INTO `access_log` VALUES (7929, '62.80.15586910112504435', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:43:31', 26, 0, '', '2019-05-24 17:43:31');
INSERT INTO `access_log` VALUES (7930, '62.87.15586910147404437', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:43:35', 20, 0, '', '2019-05-24 17:43:35');
INSERT INTO `access_log` VALUES (7931, '64.83.15586910169133697', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:43:37', 22, 0, '', '2019-05-24 17:43:37');
INSERT INTO `access_log` VALUES (7932, '64.78.15586910169103701', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:43:37', 27, 0, '', '2019-05-24 17:43:37');
INSERT INTO `access_log` VALUES (7933, '64.81.15586910191183699', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:43:39', 12, 0, '', '2019-05-24 17:43:39');
INSERT INTO `access_log` VALUES (7934, '64.77.15586910191163705', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:43:39', 15, 0, '', '2019-05-24 17:43:39');
INSERT INTO `access_log` VALUES (7935, '64.79.15586910216753699', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:43:42', 65, 0, '', '2019-05-24 17:43:42');
INSERT INTO `access_log` VALUES (7936, '66.51.15586910372813521', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:43:57', 536, 0, '', '2019-05-24 17:43:58');
INSERT INTO `access_log` VALUES (7937, '59.72.15586910414714471', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:44:01', 14, 0, '', '2019-05-24 17:44:01');
INSERT INTO `access_log` VALUES (7938, '59.79.15586910442334473', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:44:04', 22, 2001001000, '服务端发生异常', '2019-05-24 17:44:04');
INSERT INTO `access_log` VALUES (7939, '59.71.15586910460484477', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:44:06', 14, 0, '', '2019-05-24 17:44:06');
INSERT INTO `access_log` VALUES (7940, '59.75.15586910482604477', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:44:08', 14, 0, '', '2019-05-24 17:44:08');
INSERT INTO `access_log` VALUES (7941, '65.49.15586910744613691', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:44:34', 22, 0, '', '2019-05-24 17:44:34');
INSERT INTO `access_log` VALUES (7942, '65.48.15586910769943699', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:44:37', 12, 0, '', '2019-05-24 17:44:37');
INSERT INTO `access_log` VALUES (7943, '65.53.15586910784003685', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:44:38', 10, 0, '', '2019-05-24 17:44:38');
INSERT INTO `access_log` VALUES (7944, '65.52.15586910790073687', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:44:39', 16, 0, '', '2019-05-24 17:44:39');
INSERT INTO `access_log` VALUES (7945, '64.83.15586910861053699', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:44:46', 20, 0, '', '2019-05-24 17:44:46');
INSERT INTO `access_log` VALUES (7946, '64.76.15586910861033703', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:44:46', 24, 0, '', '2019-05-24 17:44:46');
INSERT INTO `access_log` VALUES (7947, '59.74.15586911000604479', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:45:00', 4, 0, '', '2019-05-24 17:45:00');
INSERT INTO `access_log` VALUES (7948, '59.73.15586911000624479', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:45:00', 21, 2001001000, '服务端发生异常', '2019-05-24 17:45:00');
INSERT INTO `access_log` VALUES (7949, '64.81.15586911062963701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:06', 3, 0, '', '2019-05-24 17:45:06');
INSERT INTO `access_log` VALUES (7950, '64.79.15586911064193701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:06', 10, 0, '', '2019-05-24 17:45:06');
INSERT INTO `access_log` VALUES (7951, '64.82.15586911080833703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:08', 537, 0, '', '2019-05-24 17:45:09');
INSERT INTO `access_log` VALUES (7952, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:09', 9, 0, '', '2019-05-24 17:45:09');
INSERT INTO `access_log` VALUES (7953, '64.80.15586911090723697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:09', 164, 0, '', '2019-05-24 17:45:09');
INSERT INTO `access_log` VALUES (7954, '64.85.15586911103113703', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:10', 10, 0, '', '2019-05-24 17:45:10');
INSERT INTO `access_log` VALUES (7955, '64.84.15586911177953703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:18', 9, 0, '', '2019-05-24 17:45:18');
INSERT INTO `access_log` VALUES (7956, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:18', 9, 0, '', '2019-05-24 17:45:18');
INSERT INTO `access_log` VALUES (7957, '64.83.15586911195573701', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:20', 10, 0, '', '2019-05-24 17:45:20');
INSERT INTO `access_log` VALUES (7958, '64.78.15586911207883705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:21', 3, 0, '', '2019-05-24 17:45:21');
INSERT INTO `access_log` VALUES (7959, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:21', 16, 0, '', '2019-05-24 17:45:21');
INSERT INTO `access_log` VALUES (7960, '64.77.15586911235753709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:24', 3, 0, '', '2019-05-24 17:45:24');
INSERT INTO `access_log` VALUES (7961, '64.81.15586911237273703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:24', 3, 0, '', '2019-05-24 17:45:24');
INSERT INTO `access_log` VALUES (7962, '66.54.15586911433053521', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13666666666', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:43', 190, 0, '', '2019-05-24 17:45:43');
INSERT INTO `access_log` VALUES (7963, '66.48.15586911475713525', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13666666666&code=1222', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:45:48', 557, 1001003003, '验证码不正确', '2019-05-24 17:45:48');
INSERT INTO `access_log` VALUES (7964, '59.76.15586911731824475', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:46:13', 4, 0, '', '2019-05-24 17:46:13');
INSERT INTO `access_log` VALUES (7965, '59.77.15586911731844479', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:46:13', 14, 2001001000, '服务端发生异常', '2019-05-24 17:46:13');
INSERT INTO `access_log` VALUES (7966, '64.85.15586911785933705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:46:19', 3, 0, '', '2019-05-24 17:46:19');
INSERT INTO `access_log` VALUES (7967, '64.84.15586911787113705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:46:19', 3, 0, '', '2019-05-24 17:46:19');
INSERT INTO `access_log` VALUES (7968, '59.74.15586911801814481', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:46:20', 13, 2001001000, '服务端发生异常', '2019-05-24 17:46:20');
INSERT INTO `access_log` VALUES (7969, '59.73.15586911801784481', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:46:20', 435, 0, '', '2019-05-24 17:46:21');
INSERT INTO `access_log` VALUES (7970, '66.50.15586912185253521', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13555556666', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:46:59', 52, 0, '', '2019-05-24 17:46:59');
INSERT INTO `access_log` VALUES (7971, '66.55.15586912201413533', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13555556666&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:00', 231, 0, '', '2019-05-24 17:47:00');
INSERT INTO `access_log` VALUES (7972, '66.54.15586912217583523', 83, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:02', 8, 0, '', '2019-05-24 17:47:02');
INSERT INTO `access_log` VALUES (7973, '66.48.15586912246823527', 83, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:05', 13, 0, '', '2019-05-24 17:47:05');
INSERT INTO `access_log` VALUES (7974, '65.52.15586912249303689', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:47:05', 1, 1002001015, '账号未登陆', '2019-05-24 17:47:05');
INSERT INTO `access_log` VALUES (7975, '65.54.15586912249333689', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:47:05', 1, 1002001015, '账号未登陆', '2019-05-24 17:47:05');
INSERT INTO `access_log` VALUES (7976, '65.46.15586912249423697', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:47:05', 0, 1002001015, '账号未登陆', '2019-05-24 17:47:05');
INSERT INTO `access_log` VALUES (7977, '66.53.15586912260263527', 83, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:06', 9, 0, '', '2019-05-24 17:47:06');
INSERT INTO `access_log` VALUES (7978, '66.52.15586912294973525', 83, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:09', 7, 0, '', '2019-05-24 17:47:10');
INSERT INTO `access_log` VALUES (7979, '65.45.15586912299953709', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.93.217', '2019-05-24 17:47:10', 70, 0, '', '2019-05-24 17:47:10');
INSERT INTO `access_log` VALUES (7980, '65.51.15586912302553691', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.93.217', '2019-05-24 17:47:10', 11, 0, '', '2019-05-24 17:47:10');
INSERT INTO `access_log` VALUES (7981, '65.48.15586912302633703', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:47:10', 9, 0, '', '2019-05-24 17:47:10');
INSERT INTO `access_log` VALUES (7982, '65.49.15586912302573695', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:47:10', 18, 0, '', '2019-05-24 17:47:10');
INSERT INTO `access_log` VALUES (7983, '59.76.15586912311584477', 83, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:11', 8, 0, '', '2019-05-24 17:47:11');
INSERT INTO `access_log` VALUES (7984, '59.77.15586912311884481', 83, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:11', 16, 2001001000, '服务端发生异常', '2019-05-24 17:47:11');
INSERT INTO `access_log` VALUES (7985, '64.79.15586912341633705', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:14', 297, 0, '', '2019-05-24 17:47:14');
INSERT INTO `access_log` VALUES (7986, '64.80.15586912346223701', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:15', 6, 0, '', '2019-05-24 17:47:15');
INSERT INTO `access_log` VALUES (7987, '64.85.15586912360773707', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:16', 6, 0, '', '2019-05-24 17:47:16');
INSERT INTO `access_log` VALUES (7988, 'N/A', 83, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:16', 11, 0, '', '2019-05-24 17:47:16');
INSERT INTO `access_log` VALUES (7989, 'N/A', 83, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:17', 12, 0, '', '2019-05-24 17:47:17');
INSERT INTO `access_log` VALUES (7990, '64.83.15586912386003705', 83, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:19', 14, 0, '', '2019-05-24 17:47:19');
INSERT INTO `access_log` VALUES (7991, '62.80.15586912408784439', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.93.217', '2019-05-24 17:47:21', 18, 0, '', '2019-05-24 17:47:21');
INSERT INTO `access_log` VALUES (7992, '66.50.15586912416413523', 83, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:22', 10, 0, '', '2019-05-24 17:47:22');
INSERT INTO `access_log` VALUES (7993, '66.57.15586912452903531', 83, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:25', 8, 0, '', '2019-05-24 17:47:25');
INSERT INTO `access_log` VALUES (7994, '62.82.15586912479604437', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:47:28', 18, 0, '', '2019-05-24 17:47:28');
INSERT INTO `access_log` VALUES (7995, '64.77.15586912537673713', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:47:34', 12, 0, '', '2019-05-24 17:47:34');
INSERT INTO `access_log` VALUES (7996, '64.78.15586912537673709', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.93.217', '2019-05-24 17:47:34', 15, 0, '', '2019-05-24 17:47:34');
INSERT INTO `access_log` VALUES (7997, '66.51.15586912642613527', 83, 1, 'user-application', '/user-api/users/address/add', 'name=adfa&tel=13456565656&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=dadsfa&isDefault=false&address=dadsfa&areaNo=110101&mobile=13456565656&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:44', 548, 2001001000, '服务端发生异常', '2019-05-24 17:47:45');
INSERT INTO `access_log` VALUES (7998, '66.53.15586912671813529', 83, 1, 'user-application', '/user-api/users/address/add', 'name=adfa&tel=13456565656&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=dadsfa&isDefault=false&address=dadsfa&areaNo=110101&mobile=13456565656&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:47', 131, 2001001000, '服务端发生异常', '2019-05-24 17:47:47');
INSERT INTO `access_log` VALUES (7999, '66.49.15586912753123529', 83, 1, 'user-application', '/user-api/users/address/add', 'name=adfa&tel=13522225555&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=dadsfa&isDefault=false&address=dadsfa&areaNo=110101&mobile=13522225555&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:55', 136, 2001001000, '服务端发生异常', '2019-05-24 17:47:55');
INSERT INTO `access_log` VALUES (8000, '66.50.15586912772193525', 83, 1, 'user-application', '/user-api/users/address/add', 'name=adfa&tel=13522225555&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=dadsfa&isDefault=false&address=dadsfa&areaNo=110101&mobile=13522225555&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:57', 97, 2001001000, '服务端发生异常', '2019-05-24 17:47:57');
INSERT INTO `access_log` VALUES (8001, '66.55.15586912797883537', 83, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:48:00', 9, 0, '', '2019-05-24 17:48:00');
INSERT INTO `access_log` VALUES (8002, '66.57.15586912846713533', 83, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:48:05', 7, 0, '', '2019-05-24 17:48:05');
INSERT INTO `access_log` VALUES (8003, '64.80.15586912859743703', 83, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:48:06', 13, 0, '', '2019-05-24 17:48:06');
INSERT INTO `access_log` VALUES (8004, '64.85.15586912867313709', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=红色', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:48:07', 10, 1002002009, NULL, '2019-05-24 17:48:07');
INSERT INTO `access_log` VALUES (8005, '64.83.15586913012463707', 83, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:48:21', 13, 0, '', '2019-05-24 17:48:21');
INSERT INTO `access_log` VALUES (8006, '62.87.15586913068524443', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:48:27', 16, 0, '', '2019-05-24 17:48:27');
INSERT INTO `access_log` VALUES (8007, '65.51.15586913371603693', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:48:57', 4, 0, '', '2019-05-24 17:48:57');
INSERT INTO `access_log` VALUES (8008, '62.85.15586913412004439', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:49:01', 18, 0, '', '2019-05-24 17:49:01');
INSERT INTO `access_log` VALUES (8009, '62.86.15586913433004431', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:49:03', 18, 0, '', '2019-05-24 17:49:03');
INSERT INTO `access_log` VALUES (8010, '64.81.15586913457513709', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:49:06', 14, 0, '', '2019-05-24 17:49:06');
INSERT INTO `access_log` VALUES (8011, '64.79.15586913457843709', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:49:06', 12, 0, '', '2019-05-24 17:49:06');
INSERT INTO `access_log` VALUES (8012, '64.80.15586913475193705', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:49:08', 44, 0, '', '2019-05-24 17:49:08');
INSERT INTO `access_log` VALUES (8013, '64.82.15586913475173711', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:49:08', 49, 0, '', '2019-05-24 17:49:08');
INSERT INTO `access_log` VALUES (8014, '65.48.15586913478723705', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:49:08', 4, 0, '', '2019-05-24 17:49:08');
INSERT INTO `access_log` VALUES (8015, '64.85.15586913500783711', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=iphone8手机&sellPoint=新款&cid=783&visible=true&picUrls=http://static.shop.iocoder.cn/056c0aaa-12b5-415e-85b1-c1f0ee5d4d59&skuStr=[{\"attrs\":[1,3],\"price\":100000,\"quantity\":100}]&description=<p>2312312312</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:49:10', 8, 1002002009, NULL, '2019-05-24 17:49:10');
INSERT INTO `access_log` VALUES (8016, '66.56.15586913570783529', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:49:17', 30, 0, '', '2019-05-24 17:49:17');
INSERT INTO `access_log` VALUES (8017, '59.77.15586913599674483', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:49:20', 14, 0, '', '2019-05-24 17:49:20');
INSERT INTO `access_log` VALUES (8018, '59.80.15586913631044481', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:49:23', 11, 0, '', '2019-05-24 17:49:23');
INSERT INTO `access_log` VALUES (8019, '59.74.15586913659304485', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:49:26', 21, 2001001000, '服务端发生异常', '2019-05-24 17:49:26');
INSERT INTO `access_log` VALUES (8020, '59.73.15586913679714485', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:49:28', 14, 0, '', '2019-05-24 17:49:28');
INSERT INTO `access_log` VALUES (8021, '64.83.15586913698773709', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:49:30', 11, 0, '', '2019-05-24 17:49:30');
INSERT INTO `access_log` VALUES (8022, '64.76.15586913734763713', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:49:33', 12, 0, '', '2019-05-24 17:49:33');
INSERT INTO `access_log` VALUES (8023, '65.50.15586913754073693', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:49:35', 22, 0, '', '2019-05-24 17:49:35');
INSERT INTO `access_log` VALUES (8024, '65.46.15586913767603701', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:49:37', 11, 0, '', '2019-05-24 17:49:37');
INSERT INTO `access_log` VALUES (8025, '64.81.15586913772103711', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:49:37', 10, 0, '', '2019-05-24 17:49:37');
INSERT INTO `access_log` VALUES (8026, '64.78.15586913772103713', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:49:37', 12, 0, '', '2019-05-24 17:49:37');
INSERT INTO `access_log` VALUES (8027, '65.52.15586913779243693', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:49:38', 10, 0, '', '2019-05-24 17:49:38');
INSERT INTO `access_log` VALUES (8028, '65.54.15586913785063693', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.237.92.109', '2019-05-24 17:49:39', 15, 0, '', '2019-05-24 17:49:39');
INSERT INTO `access_log` VALUES (8029, '64.82.15586913791073713', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:49:39', 10, 0, '', '2019-05-24 17:49:39');
INSERT INTO `access_log` VALUES (8030, '64.79.15586913791053711', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.65.68', '2019-05-24 17:49:39', 13, 0, '', '2019-05-24 17:49:39');
INSERT INTO `access_log` VALUES (8031, '64.80.15586913858393707', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:46', 7, 0, '', '2019-05-24 17:49:46');
INSERT INTO `access_log` VALUES (8032, 'N/A', 83, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:46', 28, 0, '', '2019-05-24 17:49:46');
INSERT INTO `access_log` VALUES (8033, 'N/A', 83, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:47', 12, 0, '', '2019-05-24 17:49:47');
INSERT INTO `access_log` VALUES (8034, '64.85.15586913877423713', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:48', 6, 0, '', '2019-05-24 17:49:48');
INSERT INTO `access_log` VALUES (8035, '64.84.15586913878683713', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:48', 6, 0, '', '2019-05-24 17:49:48');
INSERT INTO `access_log` VALUES (8036, '64.76.15586913889173715', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:49', 6, 0, '', '2019-05-24 17:49:49');
INSERT INTO `access_log` VALUES (8037, '64.77.15586913897343719', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:50', 7, 0, '', '2019-05-24 17:49:50');
INSERT INTO `access_log` VALUES (8038, 'N/A', 83, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:50', 22, 0, '', '2019-05-24 17:49:50');
INSERT INTO `access_log` VALUES (8039, '64.81.15586913914803713', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:51', 8, 0, '', '2019-05-24 17:49:51');
INSERT INTO `access_log` VALUES (8040, '64.82.15586913916283715', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:52', 6, 0, '', '2019-05-24 17:49:52');
INSERT INTO `access_log` VALUES (8041, '64.80.15586913922633709', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:52', 7, 0, '', '2019-05-24 17:49:52');
INSERT INTO `access_log` VALUES (8042, '64.85.15586913932293715', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:53', 6, 0, '', '2019-05-24 17:49:53');
INSERT INTO `access_log` VALUES (8043, 'N/A', 83, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:53', 11, 0, '', '2019-05-24 17:49:53');
INSERT INTO `access_log` VALUES (8044, '64.84.15586913948313715', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:55', 6, 0, '', '2019-05-24 17:49:55');
INSERT INTO `access_log` VALUES (8045, '64.83.15586913949613713', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:55', 6, 0, '', '2019-05-24 17:49:55');
INSERT INTO `access_log` VALUES (8046, '64.76.15586913958123717', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:56', 7, 0, '', '2019-05-24 17:49:56');
INSERT INTO `access_log` VALUES (8047, '64.77.15586913961583721', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:56', 7, 0, '', '2019-05-24 17:49:56');
INSERT INTO `access_log` VALUES (8048, '64.78.15586913966763717', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:57', 7, 0, '', '2019-05-24 17:49:57');
INSERT INTO `access_log` VALUES (8049, '64.81.15586913975313715', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:58', 7, 0, '', '2019-05-24 17:49:58');
INSERT INTO `access_log` VALUES (8050, 'N/A', 83, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:49:58', 12, 0, '', '2019-05-24 17:49:58');
INSERT INTO `access_log` VALUES (8051, 'N/A', 83, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:52:38', 77, 0, '', '2019-05-24 17:52:38');
INSERT INTO `access_log` VALUES (8052, '64.79.15586915595733717', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:52:40', 7, 0, '', '2019-05-24 17:52:40');
INSERT INTO `access_log` VALUES (8053, '64.80.15586915597143713', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:52:40', 6, 0, '', '2019-05-24 17:52:40');
INSERT INTO `access_log` VALUES (8054, '59.71.15586915622944487', 83, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:52:42', 8, 0, '', '2019-05-24 17:52:42');
INSERT INTO `access_log` VALUES (8055, '59.75.15586915623244487', 83, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:52:42', 17, 2001001000, '服务端发生异常', '2019-05-24 17:52:42');
INSERT INTO `access_log` VALUES (8056, '64.85.15586915654133719', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:52:45', 6, 0, '', '2019-05-24 17:52:45');
INSERT INTO `access_log` VALUES (8057, '64.84.15586915655623719', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:52:46', 6, 0, '', '2019-05-24 17:52:46');
INSERT INTO `access_log` VALUES (8058, '64.83.15586915686143717', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:52:49', 6, 0, '', '2019-05-24 17:52:49');
INSERT INTO `access_log` VALUES (8059, '64.76.15586915687693721', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:52:49', 6, 0, '', '2019-05-24 17:52:49');
INSERT INTO `access_log` VALUES (8060, '64.78.15586915715183721', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:52:52', 6, 0, '', '2019-05-24 17:52:52');
INSERT INTO `access_log` VALUES (8061, '64.81.15586915716533719', 83, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:52:52', 7, 0, '', '2019-05-24 17:52:52');
INSERT INTO `access_log` VALUES (8062, '59.77.15586915724934487', 83, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:52:52', 7, 0, '', '2019-05-24 17:52:53');
INSERT INTO `access_log` VALUES (8063, '59.80.15586915724934485', 83, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:52:52', 23, 2001001000, '服务端发生异常', '2019-05-24 17:52:53');
INSERT INTO `access_log` VALUES (8064, '59.78.15586917756834493', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:56:16', 4, 0, '', '2019-05-24 17:56:16');
INSERT INTO `access_log` VALUES (8065, '59.79.15586917756994487', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:56:16', 13, 2001001000, '服务端发生异常', '2019-05-24 17:56:16');
INSERT INTO `access_log` VALUES (8066, '64.84.15586917816313723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:56:22', 3, 0, '', '2019-05-24 17:56:22');
INSERT INTO `access_log` VALUES (8067, '64.83.15586917817613721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:56:22', 3, 0, '', '2019-05-24 17:56:22');
INSERT INTO `access_log` VALUES (8068, '64.76.15586917829493725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:56:23', 3, 0, '', '2019-05-24 17:56:23');
INSERT INTO `access_log` VALUES (8069, '64.77.15586917835013729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:56:24', 2, 0, '', '2019-05-24 17:56:24');
INSERT INTO `access_log` VALUES (8070, '65.52.15586919340283701', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:58:54', 1, 1002001015, '账号未登陆', '2019-05-24 17:58:54');
INSERT INTO `access_log` VALUES (8071, '65.54.15586919340333701', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:58:54', 0, 1002001015, '账号未登陆', '2019-05-24 17:58:54');
INSERT INTO `access_log` VALUES (8072, '65.47.15586919340423707', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.17.194.86', '2019-05-24 17:58:54', 1, 1002001015, '账号未登陆', '2019-05-24 17:58:54');
INSERT INTO `access_log` VALUES (8073, '59.74.15586919991254495', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 17:59:59', 14, 2001001000, '服务端发生异常', '2019-05-24 17:59:59');
INSERT INTO `access_log` VALUES (8074, '59.73.15586919991254495', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 17:59:59', 88, 0, '', '2019-05-24 17:59:59');
INSERT INTO `access_log` VALUES (8075, '64.80.15586920051653721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 18:00:05', 4, 0, '', '2019-05-24 18:00:05');
INSERT INTO `access_log` VALUES (8076, '64.85.15586920052733727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 18:00:05', 3, 0, '', '2019-05-24 18:00:05');
INSERT INTO `access_log` VALUES (8077, '64.83.15586920064993725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 18:00:07', 3, 0, '', '2019-05-24 18:00:07');
INSERT INTO `access_log` VALUES (8078, '64.76.15586920070933729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 18:00:07', 2, 0, '', '2019-05-24 18:00:07');
INSERT INTO `access_log` VALUES (8079, '64.77.15586920077723733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 18:00:08', 2, 0, '', '2019-05-24 18:00:08');
INSERT INTO `access_log` VALUES (8080, '59.78.15586920098664497', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 18:00:10', 4, 0, '', '2019-05-24 18:00:10');
INSERT INTO `access_log` VALUES (8081, '59.79.15586920098684491', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 18:00:10', 14, 2001001000, '服务端发生异常', '2019-05-24 18:00:10');
INSERT INTO `access_log` VALUES (8082, '59.75.15586920172274495', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 18:00:17', 3, 0, '', '2019-05-24 18:00:17');
INSERT INTO `access_log` VALUES (8083, '59.71.15586920172284495', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 18:00:17', 13, 2001001000, '服务端发生异常', '2019-05-24 18:00:17');
INSERT INTO `access_log` VALUES (8084, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 18:00:25', 11, 0, '', '2019-05-24 18:00:25');
INSERT INTO `access_log` VALUES (8085, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 18:00:25', 9, 0, '', '2019-05-24 18:00:25');
INSERT INTO `access_log` VALUES (8086, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 18:00:25', 18, 0, '', '2019-05-24 18:00:25');
INSERT INTO `access_log` VALUES (8087, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.254.182.38', '2019-05-24 18:00:25', 15, 0, '', '2019-05-24 18:00:25');
INSERT INTO `access_log` VALUES (8088, '59.79.15586920659124493', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:01:06', 17, 0, '', '2019-05-24 18:01:06');
INSERT INTO `access_log` VALUES (8089, '59.78.15586920659114499', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:01:06', 23, 2001001000, '服务端发生异常', '2019-05-24 18:01:06');
INSERT INTO `access_log` VALUES (8090, '64.85.15586922245353731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:03:45', 12, 0, '', '2019-05-24 18:03:45');
INSERT INTO `access_log` VALUES (8091, '64.83.15586922246633729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:03:45', 9, 0, '', '2019-05-24 18:03:45');
INSERT INTO `access_log` VALUES (8092, '64.77.15586922266813737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:03:47', 9, 0, '', '2019-05-24 18:03:47');
INSERT INTO `access_log` VALUES (8093, '64.81.15586922280353731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:03:48', 9, 0, '', '2019-05-24 18:03:48');
INSERT INTO `access_log` VALUES (8094, '59.71.15586922305054499', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:03:51', 12, 0, '', '2019-05-24 18:03:51');
INSERT INTO `access_log` VALUES (8095, '59.76.15586922305254495', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:03:51', 19, 2001001000, '服务端发生异常', '2019-05-24 18:03:51');
INSERT INTO `access_log` VALUES (8096, '64.79.15586922342113731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:03:54', 9, 0, '', '2019-05-24 18:03:54');
INSERT INTO `access_log` VALUES (8097, '64.80.15586922343433727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:03:54', 8, 0, '', '2019-05-24 18:03:54');
INSERT INTO `access_log` VALUES (8098, '64.85.15586922360923733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:03:56', 232, 0, '', '2019-05-24 18:03:56');
INSERT INTO `access_log` VALUES (8099, '64.84.15586922375343733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:03:58', 9, 0, '', '2019-05-24 18:03:58');
INSERT INTO `access_log` VALUES (8100, '64.78.15586922790693735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:04:39', 9, 0, '', '2019-05-24 18:04:39');
INSERT INTO `access_log` VALUES (8101, '64.81.15586922798393733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:04:40', 9, 0, '', '2019-05-24 18:04:40');
INSERT INTO `access_log` VALUES (8102, '64.82.15586922804023735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:04:40', 9, 0, '', '2019-05-24 18:04:40');
INSERT INTO `access_log` VALUES (8103, '59.74.15586922816134501', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:04:42', 10, 0, '', '2019-05-24 18:04:42');
INSERT INTO `access_log` VALUES (8104, '59.72.15586922816164495', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:04:42', 19, 2001001000, '服务端发生异常', '2019-05-24 18:04:42');
INSERT INTO `access_log` VALUES (8105, '64.79.15586922836863733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:04:44', 9, 0, '', '2019-05-24 18:04:44');
INSERT INTO `access_log` VALUES (8106, '64.80.15586922839033729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:04:44', 9, 0, '', '2019-05-24 18:04:44');
INSERT INTO `access_log` VALUES (8107, '64.85.15586922849713735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:04:45', 9, 0, '', '2019-05-24 18:04:45');
INSERT INTO `access_log` VALUES (8108, '64.84.15586922859033735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:04:46', 9, 0, '', '2019-05-24 18:04:46');
INSERT INTO `access_log` VALUES (8109, '59.78.15586922879724503', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:04:48', 11, 0, '', '2019-05-24 18:04:48');
INSERT INTO `access_log` VALUES (8110, '59.79.15586922879724497', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:04:48', 19, 2001001000, '服务端发生异常', '2019-05-24 18:04:48');
INSERT INTO `access_log` VALUES (8111, '64.77.15586923192253741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:19', 15, 0, '', '2019-05-24 18:05:19');
INSERT INTO `access_log` VALUES (8112, '64.78.15586923193443737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:19', 9, 0, '', '2019-05-24 18:05:19');
INSERT INTO `access_log` VALUES (8113, '59.80.15586923204644499', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:20', 10, 0, '', '2019-05-24 18:05:20');
INSERT INTO `access_log` VALUES (8114, '59.77.15586923204664501', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:20', 29, 2001001000, '服务端发生异常', '2019-05-24 18:05:20');
INSERT INTO `access_log` VALUES (8115, '64.82.15586923241233737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:24', 718, 0, '', '2019-05-24 18:05:25');
INSERT INTO `access_log` VALUES (8116, '64.79.15586923250523735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:25', 285, 0, '', '2019-05-24 18:05:25');
INSERT INTO `access_log` VALUES (8117, '64.80.15586923291093731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:29', 8, 0, '', '2019-05-24 18:05:29');
INSERT INTO `access_log` VALUES (8118, '64.85.15586923292113737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:29', 8, 0, '', '2019-05-24 18:05:29');
INSERT INTO `access_log` VALUES (8119, '66.51.15586923328423543', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:33', 17, 1002001012, '访问令牌已过期', '2019-05-24 18:05:33');
INSERT INTO `access_log` VALUES (8120, '66.53.15586923329463545', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=246657b443064cdcae2d65fb078cb241', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:33', 16, 1002001018, '访问令牌已过期', '2019-05-24 18:05:33');
INSERT INTO `access_log` VALUES (8121, '64.76.15586923510223739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:51', 9, 0, '', '2019-05-24 18:05:51');
INSERT INTO `access_log` VALUES (8122, '64.77.15586923512863743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:51', 9, 0, '', '2019-05-24 18:05:51');
INSERT INTO `access_log` VALUES (8123, '59.72.15586923529484497', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:53', 12, 0, '', '2019-05-24 18:05:53');
INSERT INTO `access_log` VALUES (8124, '59.79.15586923529484499', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:53', 19, 2001001000, '服务端发生异常', '2019-05-24 18:05:53');
INSERT INTO `access_log` VALUES (8125, '59.78.15586923576564505', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:58', 10, 0, '', '2019-05-24 18:05:58');
INSERT INTO `access_log` VALUES (8126, '59.75.15586923576574503', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:05:58', 21, 2001001000, '服务端发生异常', '2019-05-24 18:05:58');
INSERT INTO `access_log` VALUES (8127, '64.78.15586923610763739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:01', 90, 0, '', '2019-05-24 18:06:01');
INSERT INTO `access_log` VALUES (8128, '64.81.15586923612743737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:01', 8, 0, '', '2019-05-24 18:06:01');
INSERT INTO `access_log` VALUES (8129, '66.49.15586923637333545', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:04', 7, 1002001012, '访问令牌已过期', '2019-05-24 18:06:04');
INSERT INTO `access_log` VALUES (8130, '66.50.15586923638413541', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=246657b443064cdcae2d65fb078cb241', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:04', 13, 1002001018, '访问令牌已过期', '2019-05-24 18:06:04');
INSERT INTO `access_log` VALUES (8131, '59.76.15586923685104499', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:09', 11, 0, '', '2019-05-24 18:06:09');
INSERT INTO `access_log` VALUES (8132, '59.80.15586923685124501', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:09', 20, 2001001000, '服务端发生异常', '2019-05-24 18:06:09');
INSERT INTO `access_log` VALUES (8133, '66.57.15586923742283549', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:14', 9, 1002001012, '访问令牌已过期', '2019-05-24 18:06:14');
INSERT INTO `access_log` VALUES (8134, '66.54.15586923743173543', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=246657b443064cdcae2d65fb078cb241', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:14', 10, 1002001018, '访问令牌已过期', '2019-05-24 18:06:14');
INSERT INTO `access_log` VALUES (8135, '64.79.15586923777553737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:18', 9, 0, '', '2019-05-24 18:06:18');
INSERT INTO `access_log` VALUES (8136, '64.80.15586923778453733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:18', 14, 0, '', '2019-05-24 18:06:18');
INSERT INTO `access_log` VALUES (8137, '59.77.15586923784444503', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:18', 11, 0, '', '2019-05-24 18:06:18');
INSERT INTO `access_log` VALUES (8138, '59.73.15586923784454505', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:18', 18, 2001001000, '服务端发生异常', '2019-05-24 18:06:18');
INSERT INTO `access_log` VALUES (8139, '64.85.15586923789853739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:19', 11, 0, '', '2019-05-24 18:06:19');
INSERT INTO `access_log` VALUES (8140, '64.84.15586923792353739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:19', 68, 0, '', '2019-05-24 18:06:19');
INSERT INTO `access_log` VALUES (8141, '59.72.15586923795434499', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:20', 10, 0, '', '2019-05-24 18:06:20');
INSERT INTO `access_log` VALUES (8142, '59.79.15586923795434501', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:20', 20, 2001001000, '服务端发生异常', '2019-05-24 18:06:20');
INSERT INTO `access_log` VALUES (8143, '64.83.15586923800553737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:20', 9, 0, '', '2019-05-24 18:06:20');
INSERT INTO `access_log` VALUES (8144, '64.76.15586923801673741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:20', 8, 0, '', '2019-05-24 18:06:20');
INSERT INTO `access_log` VALUES (8145, '59.78.15586923805044507', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:21', 10, 0, '', '2019-05-24 18:06:21');
INSERT INTO `access_log` VALUES (8146, '59.75.15586923805064505', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:21', 20, 2001001000, '服务端发生异常', '2019-05-24 18:06:21');
INSERT INTO `access_log` VALUES (8147, '64.78.15586923809133741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:21', 9, 0, '', '2019-05-24 18:06:21');
INSERT INTO `access_log` VALUES (8148, '64.81.15586923810383739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:21', 8, 0, '', '2019-05-24 18:06:21');
INSERT INTO `access_log` VALUES (8149, '59.71.15586923811814505', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:21', 10, 0, '', '2019-05-24 18:06:21');
INSERT INTO `access_log` VALUES (8150, '59.80.15586923811814503', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:21', 25, 2001001000, '服务端发生异常', '2019-05-24 18:06:21');
INSERT INTO `access_log` VALUES (8151, '64.82.15586923814953741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:21', 7, 0, '', '2019-05-24 18:06:22');
INSERT INTO `access_log` VALUES (8152, '64.79.15586923816033739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:22', 7, 0, '', '2019-05-24 18:06:22');
INSERT INTO `access_log` VALUES (8153, '59.76.15586923817234501', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:22', 13, 0, '', '2019-05-24 18:06:22');
INSERT INTO `access_log` VALUES (8154, '59.77.15586923817234505', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:22', 21, 2001001000, '服务端发生异常', '2019-05-24 18:06:22');
INSERT INTO `access_log` VALUES (8155, '64.80.15586923819153735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:22', 8, 0, '', '2019-05-24 18:06:22');
INSERT INTO `access_log` VALUES (8156, '64.85.15586923821173741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:22', 8, 0, '', '2019-05-24 18:06:22');
INSERT INTO `access_log` VALUES (8157, '59.73.15586923821424507', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:22', 9, 0, '', '2019-05-24 18:06:22');
INSERT INTO `access_log` VALUES (8158, '59.74.15586923821584507', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:22', 18, 2001001000, '服务端发生异常', '2019-05-24 18:06:22');
INSERT INTO `access_log` VALUES (8159, '65.45.15586923915963727', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:32', 5, 1002001012, '访问令牌已过期', '2019-05-24 18:06:32');
INSERT INTO `access_log` VALUES (8160, '65.51.15586923915993709', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:32', 3, 1002001012, '访问令牌已过期', '2019-05-24 18:06:32');
INSERT INTO `access_log` VALUES (8161, '65.48.15586923916063721', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:32', 3, 1002001012, '访问令牌已过期', '2019-05-24 18:06:32');
INSERT INTO `access_log` VALUES (8162, '65.49.15586923969683713', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:37', 943, 0, '', '2019-05-24 18:06:38');
INSERT INTO `access_log` VALUES (8163, '65.53.15586923981863707', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:38', 11, 0, '', '2019-05-24 18:06:38');
INSERT INTO `access_log` VALUES (8164, '65.50.15586923981933709', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:38', 12, 0, '', '2019-05-24 18:06:38');
INSERT INTO `access_log` VALUES (8165, '65.46.15586923981953717', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:38', 12, 0, '', '2019-05-24 18:06:38');
INSERT INTO `access_log` VALUES (8166, '65.54.15586924166783709', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:06:57', 22, 0, '', '2019-05-24 18:06:57');
INSERT INTO `access_log` VALUES (8167, '65.45.15586924212913729', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:07:01', 11, 0, '', '2019-05-24 18:07:01');
INSERT INTO `access_log` VALUES (8168, '65.51.15586924234653711', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:07:03', 10, 0, '', '2019-05-24 18:07:03');
INSERT INTO `access_log` VALUES (8169, '65.48.15586924253933723', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:07:05', 22, 0, '', '2019-05-24 18:07:05');
INSERT INTO `access_log` VALUES (8170, '65.46.15586924310123719', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:07:11', 10, 0, '', '2019-05-24 18:07:11');
INSERT INTO `access_log` VALUES (8171, '65.53.15586924310143709', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:07:11', 10, 0, '', '2019-05-24 18:07:11');
INSERT INTO `access_log` VALUES (8172, '65.50.15586924310193711', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:07:11', 10, 0, '', '2019-05-24 18:07:11');
INSERT INTO `access_log` VALUES (8173, '65.52.15586924310883711', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:07:11', 24, 0, '', '2019-05-24 18:07:11');
INSERT INTO `access_log` VALUES (8174, '59.78.15586924380454509', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:07:18', 13, 0, '', '2019-05-24 18:07:18');
INSERT INTO `access_log` VALUES (8175, '59.80.15586924452124505', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:07:25', 21, 2001001000, '服务端发生异常', '2019-05-24 18:07:25');
INSERT INTO `access_log` VALUES (8176, '62.89.15586924558374453', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:07:36', 18, 0, '', '2019-05-24 18:07:36');
INSERT INTO `access_log` VALUES (8177, '59.79.15586925151534505', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:08:35', 22, 2001001000, '服务端发生异常', '2019-05-24 18:08:35');
INSERT INTO `access_log` VALUES (8178, '59.75.15586925165184509', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:08:37', 13, 0, '', '2019-05-24 18:08:37');
INSERT INTO `access_log` VALUES (8179, '65.49.15586925178813717', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:08:38', 52, 0, '', '2019-05-24 18:08:38');
INSERT INTO `access_log` VALUES (8180, '65.52.15586925193023713', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:08:39', 10, 0, '', '2019-05-24 18:08:39');
INSERT INTO `access_log` VALUES (8181, '65.52.15586932631593723', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:21:03', 13, 0, '', '2019-05-24 18:21:03');
INSERT INTO `access_log` VALUES (8182, '65.53.15586932631593721', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:21:03', 15, 0, '', '2019-05-24 18:21:03');
INSERT INTO `access_log` VALUES (8183, '65.47.15586932631653729', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:21:03', 9, 0, '', '2019-05-24 18:21:03');
INSERT INTO `access_log` VALUES (8184, '65.50.15586932631613723', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-24 18:21:03', 11, 0, '', '2019-05-24 18:21:03');
INSERT INTO `access_log` VALUES (8185, '65.49.15586934667703731', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:24:27', 1, 1002001015, '账号未登陆', '2019-05-24 18:24:27');
INSERT INTO `access_log` VALUES (8186, '65.46.15586934667713735', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:24:27', 1, 1002001015, '账号未登陆', '2019-05-24 18:24:27');
INSERT INTO `access_log` VALUES (8187, '65.50.15586934667773727', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:24:27', 1, 1002001015, '账号未登陆', '2019-05-24 18:24:27');
INSERT INTO `access_log` VALUES (8188, '65.53.15586934804173725', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:24:40', 100, 0, '', '2019-05-24 18:24:41');
INSERT INTO `access_log` VALUES (8189, '65.52.15586934808423727', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:24:41', 11, 0, '', '2019-05-24 18:24:41');
INSERT INTO `access_log` VALUES (8190, '65.54.15586934808423727', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:24:41', 11, 0, '', '2019-05-24 18:24:41');
INSERT INTO `access_log` VALUES (8191, '65.45.15586934808513747', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:24:41', 10, 0, '', '2019-05-24 18:24:41');
INSERT INTO `access_log` VALUES (8192, '66.49.15586934947013561', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:24:55', 25, 0, '', '2019-05-24 18:24:55');
INSERT INTO `access_log` VALUES (8193, '65.48.15586935065603741', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:25:07', 21, 0, '', '2019-05-24 18:25:07');
INSERT INTO `access_log` VALUES (8194, '65.46.15586935174103737', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:25:17', 11, 0, '', '2019-05-24 18:25:17');
INSERT INTO `access_log` VALUES (8195, '65.49.15586935222683733', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:25:22', 11, 0, '', '2019-05-24 18:25:22');
INSERT INTO `access_log` VALUES (8196, '65.45.15586935439483749', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:25:44', 16, 0, '', '2019-05-24 18:25:44');
INSERT INTO `access_log` VALUES (8197, '65.50.15586936098973731', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:26:50', 16, 0, '', '2019-05-24 18:26:50');
INSERT INTO `access_log` VALUES (8198, '65.46.15586936100973739', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:26:50', 9, 0, '', '2019-05-24 18:26:50');
INSERT INTO `access_log` VALUES (8199, '65.49.15586936102463735', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:26:50', 85, 0, '', '2019-05-24 18:26:50');
INSERT INTO `access_log` VALUES (8200, '65.47.15586936105983737', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:26:51', 20, 0, '', '2019-05-24 18:26:51');
INSERT INTO `access_log` VALUES (8201, '66.56.15586936110243561', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 18:26:51', 23, 0, '', '2019-05-24 18:26:51');
INSERT INTO `access_log` VALUES (8202, '65.51.15586963607393769', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.167.7.82', '2019-05-24 19:12:41', 1, 1002001015, '账号未登陆', '2019-05-24 19:12:41');
INSERT INTO `access_log` VALUES (8203, '65.49.15586995455993815', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.119.117.133', '2019-05-24 20:05:46', 0, 1002001015, '账号未登陆', '2019-05-24 20:05:46');
INSERT INTO `access_log` VALUES (8204, '65.46.15586995455993821', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.119.117.133', '2019-05-24 20:05:46', 0, 1002001015, '账号未登陆', '2019-05-24 20:05:46');
INSERT INTO `access_log` VALUES (8205, '65.53.15586995455993807', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.119.117.133', '2019-05-24 20:05:46', 0, 1002001015, '账号未登陆', '2019-05-24 20:05:46');
INSERT INTO `access_log` VALUES (8206, '65.45.15586995483053831', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.119.117.133', '2019-05-24 20:05:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 20:05:48');
INSERT INTO `access_log` VALUES (8207, '65.47.15586995534393819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.119.117.133', '2019-05-24 20:05:53', 223, 0, '', '2019-05-24 20:05:54');
INSERT INTO `access_log` VALUES (8208, '65.52.15586995539093813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.119.117.133', '2019-05-24 20:05:54', 12, 0, '', '2019-05-24 20:05:54');
INSERT INTO `access_log` VALUES (8209, '65.54.15586995539133811', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.119.117.133', '2019-05-24 20:05:54', 11, 0, '', '2019-05-24 20:05:54');
INSERT INTO `access_log` VALUES (8210, '65.51.15586995539223813', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.119.117.133', '2019-05-24 20:05:54', 10, 0, '', '2019-05-24 20:05:54');
INSERT INTO `access_log` VALUES (8211, '62.88.15586995624484559', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.119.117.133', '2019-05-24 20:06:02', 25, 0, '', '2019-05-24 20:06:02');
INSERT INTO `access_log` VALUES (8212, '65.46.15586995708483823', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.119.117.133', '2019-05-24 20:06:11', 21, 0, '', '2019-05-24 20:06:11');
INSERT INTO `access_log` VALUES (8213, '65.49.15586995731603817', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '34.228.240.168', '2019-05-24 20:06:13', 1, 1002001015, '账号未登陆', '2019-05-24 20:06:13');
INSERT INTO `access_log` VALUES (8214, '65.45.15586995870663833', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '34.230.59.192', '2019-05-24 20:06:27', 0, 1002001015, '账号未登陆', '2019-05-24 20:06:27');
INSERT INTO `access_log` VALUES (8215, '65.50.15586995920633815', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '18.212.42.148', '2019-05-24 20:06:32', 0, 1002001015, '账号未登陆', '2019-05-24 20:06:32');
INSERT INTO `access_log` VALUES (8216, '62.87.15586996407824557', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '3.86.228.214', '2019-05-24 20:07:21', 1, 1002001015, '账号未登陆', '2019-05-24 20:07:21');
INSERT INTO `access_log` VALUES (8217, '65.48.15586996418133829', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '35.174.137.101', '2019-05-24 20:07:22', 0, 1002001015, '账号未登陆', '2019-05-24 20:07:22');
INSERT INTO `access_log` VALUES (8218, '59.80.15587027253764643', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 20:58:45', 37, 0, '', '2019-05-24 20:58:45');
INSERT INTO `access_log` VALUES (8219, '59.77.15587027253824645', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 20:58:45', 31, 2001001000, '服务端发生异常', '2019-05-24 20:58:45');
INSERT INTO `access_log` VALUES (8220, '59.73.15587027362464647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:58:56', 10, 0, '', '2019-05-24 20:58:56');
INSERT INTO `access_log` VALUES (8221, '59.74.15587027362494647', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:58:56', 17, 2001001000, '服务端发生异常', '2019-05-24 20:58:56');
INSERT INTO `access_log` VALUES (8222, '64.83.15587027420203877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:02', 391, 0, '', '2019-05-24 20:59:02');
INSERT INTO `access_log` VALUES (8223, '64.77.15587027425963885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:03', 9, 0, '', '2019-05-24 20:59:03');
INSERT INTO `access_log` VALUES (8224, '64.81.15587027437843879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:04', 8, 0, '', '2019-05-24 20:59:04');
INSERT INTO `access_log` VALUES (8225, '64.79.15587027444483879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:04', 9, 0, '', '2019-05-24 20:59:04');
INSERT INTO `access_log` VALUES (8226, '64.80.15587027451463875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:05', 9, 0, '', '2019-05-24 20:59:05');
INSERT INTO `access_log` VALUES (8227, '64.84.15587027456143881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:06', 9, 0, '', '2019-05-24 20:59:06');
INSERT INTO `access_log` VALUES (8228, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:06', 58, 0, '', '2019-05-24 20:59:06');
INSERT INTO `access_log` VALUES (8229, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:07', 15, 0, '', '2019-05-24 20:59:07');
INSERT INTO `access_log` VALUES (8230, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:07', 21, 0, '', '2019-05-24 20:59:07');
INSERT INTO `access_log` VALUES (8231, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:11', 16, 0, '', '2019-05-24 20:59:11');
INSERT INTO `access_log` VALUES (8232, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:11', 16, 0, '', '2019-05-24 20:59:11');
INSERT INTO `access_log` VALUES (8233, '64.83.15587027528513879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:13', 9, 0, '', '2019-05-24 20:59:13');
INSERT INTO `access_log` VALUES (8234, '64.76.15587027530003883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:13', 8, 0, '', '2019-05-24 20:59:13');
INSERT INTO `access_log` VALUES (8235, '64.77.15587027548463887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:15', 9, 0, '', '2019-05-24 20:59:15');
INSERT INTO `access_log` VALUES (8236, '64.78.15587027549593883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:15', 8, 0, '', '2019-05-24 20:59:15');
INSERT INTO `access_log` VALUES (8237, '66.49.15587027556393685', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:16', 10, 1002001011, '访问令牌不存在', '2019-05-24 20:59:16');
INSERT INTO `access_log` VALUES (8238, '66.55.15587027630253693', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:23', 7, 1002001011, '访问令牌不存在', '2019-05-24 20:59:23');
INSERT INTO `access_log` VALUES (8239, '64.82.15587027645533883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:25', 9, 0, '', '2019-05-24 20:59:25');
INSERT INTO `access_log` VALUES (8240, '64.79.15587027646913881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:25', 8, 0, '', '2019-05-24 20:59:25');
INSERT INTO `access_log` VALUES (8241, '59.75.15587027650284647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:25', 10, 0, '', '2019-05-24 20:59:25');
INSERT INTO `access_log` VALUES (8242, '59.78.15587027650304649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:25', 19, 2001001000, '服务端发生异常', '2019-05-24 20:59:25');
INSERT INTO `access_log` VALUES (8243, '64.80.15587027669783877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:27', 9, 0, '', '2019-05-24 20:59:27');
INSERT INTO `access_log` VALUES (8244, '64.85.15587027670843883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:27', 7, 0, '', '2019-05-24 20:59:27');
INSERT INTO `access_log` VALUES (8245, '64.84.15587027678023883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:28', 9, 0, '', '2019-05-24 20:59:28');
INSERT INTO `access_log` VALUES (8246, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:28', 14, 0, '', '2019-05-24 20:59:28');
INSERT INTO `access_log` VALUES (8247, '64.76.15587027736693885', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:34', 18, 0, '', '2019-05-24 20:59:34');
INSERT INTO `access_log` VALUES (8248, '66.48.15587027824493687', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:42', 19, 0, '', '2019-05-24 20:59:42');
INSERT INTO `access_log` VALUES (8249, '66.53.15587027857403687', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:46', 9, 0, '', '2019-05-24 20:59:46');
INSERT INTO `access_log` VALUES (8250, '66.52.15587027870183685', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:47', 13, 0, '', '2019-05-24 20:59:47');
INSERT INTO `access_log` VALUES (8251, '66.49.15587027932903687', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:53', 23, 0, '', '2019-05-24 20:59:53');
INSERT INTO `access_log` VALUES (8252, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:57', 17, 0, '', '2019-05-24 20:59:57');
INSERT INTO `access_log` VALUES (8253, '64.82.15587027969873885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:57', 418, 0, '', '2019-05-24 20:59:57');
INSERT INTO `access_log` VALUES (8254, '66.50.15587027964843683', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:56', 920, 0, '', '2019-05-24 20:59:57');
INSERT INTO `access_log` VALUES (8255, '64.79.15587027972083883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:57', 198, 0, '', '2019-05-24 20:59:57');
INSERT INTO `access_log` VALUES (8256, '64.81.15587027967413883', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:57', 671, 0, '', '2019-05-24 20:59:57');
INSERT INTO `access_log` VALUES (8257, '64.80.15587027976043879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:58', 67, 0, '', '2019-05-24 20:59:58');
INSERT INTO `access_log` VALUES (8258, '59.77.15587027989044647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:59', 10, 0, '', '2019-05-24 20:59:59');
INSERT INTO `access_log` VALUES (8259, '59.76.15587027989054643', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.219.199', '2019-05-24 20:59:59', 19, 2001001000, '服务端发生异常', '2019-05-24 20:59:59');
INSERT INTO `access_log` VALUES (8260, '65.47.15587028152693865', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:15', 6, 1002001012, '访问令牌已过期', '2019-05-24 21:00:15');
INSERT INTO `access_log` VALUES (8261, '65.50.15587028152713859', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:15', 4, 1002001012, '访问令牌已过期', '2019-05-24 21:00:15');
INSERT INTO `access_log` VALUES (8262, '65.45.15587028152693877', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:15', 7, 1002001012, '访问令牌已过期', '2019-05-24 21:00:15');
INSERT INTO `access_log` VALUES (8263, '65.52.15587028174463859', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:17', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 21:00:17');
INSERT INTO `access_log` VALUES (8264, '65.51.15587028249303859', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:25', 77, 0, '', '2019-05-24 21:00:25');
INSERT INTO `access_log` VALUES (8265, '65.48.15587028252823873', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:25', 11, 0, '', '2019-05-24 21:00:25');
INSERT INTO `access_log` VALUES (8266, '65.46.15587028252883869', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:25', 11, 0, '', '2019-05-24 21:00:25');
INSERT INTO `access_log` VALUES (8267, '65.49.15587028252953863', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:25', 10, 0, '', '2019-05-24 21:00:25');
INSERT INTO `access_log` VALUES (8268, '62.86.15587028282114587', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:28', 24, 0, '', '2019-05-24 21:00:28');
INSERT INTO `access_log` VALUES (8269, '59.72.15587028300744643', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:30', 691, 0, '', '2019-05-24 21:00:31');
INSERT INTO `access_log` VALUES (8270, '65.50.15587028404823861', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:40', 4, 0, '', '2019-05-24 21:00:40');
INSERT INTO `access_log` VALUES (8271, '65.45.15587028447513879', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:45', 3, 0, '', '2019-05-24 21:00:45');
INSERT INTO `access_log` VALUES (8272, '59.78.15587028461734651', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update', 'id=1&title=百度是最棒的&url=https://user-gold-cdn.xitu.io/2019/3/30/169cdcbb93d48ff1?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1&sort=0&memo=哈哈哈哈&picUrl=http://static.shop.iocoder.cn/807e0eb8-ccf1-4198-b9b9-510894d2741a', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:46', 9, 1002002009, NULL, '2019-05-24 21:00:46');
INSERT INTO `access_log` VALUES (8273, '59.71.15587028514704649', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:51', 22, 2001001000, '服务端发生异常', '2019-05-24 21:00:51');
INSERT INTO `access_log` VALUES (8274, '65.47.15587028537823867', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:54', 22, 0, '', '2019-05-24 21:00:54');
INSERT INTO `access_log` VALUES (8275, '65.54.15587028545303859', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:55', 12, 0, '', '2019-05-24 21:00:55');
INSERT INTO `access_log` VALUES (8276, '65.51.15587028552813861', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:55', 11, 0, '', '2019-05-24 21:00:55');
INSERT INTO `access_log` VALUES (8277, '65.49.15587028558383865', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-24 21:00:56', 15, 0, '', '2019-05-24 21:00:56');
INSERT INTO `access_log` VALUES (8278, '65.48.15587062495973921', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:57:30', 1, 1002001015, '账号未登陆', '2019-05-24 21:57:30');
INSERT INTO `access_log` VALUES (8279, '65.46.15587062495973915', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:57:30', 1, 1002001015, '账号未登陆', '2019-05-24 21:57:30');
INSERT INTO `access_log` VALUES (8280, '65.50.15587062495973909', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:57:30', 0, 1002001015, '账号未登陆', '2019-05-24 21:57:30');
INSERT INTO `access_log` VALUES (8281, '65.53.15587062557153901', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:57:36', 73, 0, '', '2019-05-24 21:57:36');
INSERT INTO `access_log` VALUES (8282, '65.45.15587062561583927', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:57:36', 77, 0, '', '2019-05-24 21:57:36');
INSERT INTO `access_log` VALUES (8283, '65.47.15587062561763915', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:57:36', 63, 0, '', '2019-05-24 21:57:36');
INSERT INTO `access_log` VALUES (8284, '65.52.15587062561933909', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:57:36', 46, 0, '', '2019-05-24 21:57:36');
INSERT INTO `access_log` VALUES (8285, '62.86.15587062629934633', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:57:43', 26, 0, '', '2019-05-24 21:57:43');
INSERT INTO `access_log` VALUES (8286, '64.76.15587062721303933', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:57:52', 20, 0, '', '2019-05-24 21:57:52');
INSERT INTO `access_log` VALUES (8287, '64.83.15587062721273929', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:57:52', 25, 0, '', '2019-05-24 21:57:52');
INSERT INTO `access_log` VALUES (8288, '64.78.15587062778403933', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:57:58', 13, 0, '', '2019-05-24 21:57:58');
INSERT INTO `access_log` VALUES (8289, '64.77.15587062778373937', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:57:58', 17, 0, '', '2019-05-24 21:57:58');
INSERT INTO `access_log` VALUES (8290, '66.48.15587062886723735', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:58:09', 29, 0, '', '2019-05-24 21:58:09');
INSERT INTO `access_log` VALUES (8291, '59.71.15587062927794695', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:58:13', 22, 0, '', '2019-05-24 21:58:13');
INSERT INTO `access_log` VALUES (8292, '59.80.15587062966324693', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:58:17', 22, 2001001000, '服务端发生异常', '2019-05-24 21:58:17');
INSERT INTO `access_log` VALUES (8293, '59.76.15587063004804691', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:58:20', 47, 0, '', '2019-05-24 21:58:21');
INSERT INTO `access_log` VALUES (8294, '65.50.15587063032603911', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:58:23', 611, 0, '', '2019-05-24 21:58:24');
INSERT INTO `access_log` VALUES (8295, '65.48.15587063057623923', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:58:26', 11, 0, '', '2019-05-24 21:58:26');
INSERT INTO `access_log` VALUES (8296, '65.53.15587063082853903', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:58:28', 10, 0, '', '2019-05-24 21:58:28');
INSERT INTO `access_log` VALUES (8297, '65.52.15587063104863911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.85.181.40', '2019-05-24 21:58:30', 15, 0, '', '2019-05-24 21:58:31');
INSERT INTO `access_log` VALUES (8298, '65.54.15587064869833911', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:01:27', 5, 1002001012, '访问令牌已过期', '2019-05-24 22:01:27');
INSERT INTO `access_log` VALUES (8299, '65.49.15587064870213917', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:01:27', 4, 1002001012, '访问令牌已过期', '2019-05-24 22:01:27');
INSERT INTO `access_log` VALUES (8300, '65.51.15587064870273913', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:01:27', 4, 1002001012, '访问令牌已过期', '2019-05-24 22:01:27');
INSERT INTO `access_log` VALUES (8301, '65.46.15587064933333921', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:01:33', 122, 0, '', '2019-05-24 22:01:33');
INSERT INTO `access_log` VALUES (8302, '65.48.15587064938153927', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:01:34', 21, 0, '', '2019-05-24 22:01:34');
INSERT INTO `access_log` VALUES (8303, '65.50.15587064938133915', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:01:34', 25, 0, '', '2019-05-24 22:01:34');
INSERT INTO `access_log` VALUES (8304, '65.53.15587064938243907', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:01:34', 14, 0, '', '2019-05-24 22:01:34');
INSERT INTO `access_log` VALUES (8305, '66.50.15587065213363733', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:02:01', 18, 0, '', '2019-05-24 22:02:01');
INSERT INTO `access_log` VALUES (8306, '65.51.15587065407653915', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:02:21', 11, 0, '', '2019-05-24 22:02:21');
INSERT INTO `access_log` VALUES (8307, '65.54.15587065491753913', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:02:29', 257, 0, '', '2019-05-24 22:02:29');
INSERT INTO `access_log` VALUES (8308, '65.48.15587065905723929', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:03:11', 12, 0, '', '2019-05-24 22:03:11');
INSERT INTO `access_log` VALUES (8309, '65.45.15587066084103935', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:03:28', 10, 0, '', '2019-05-24 22:03:28');
INSERT INTO `access_log` VALUES (8310, '64.83.15587066482643935', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:04:08', 12, 0, '', '2019-05-24 22:04:08');
INSERT INTO `access_log` VALUES (8311, '64.84.15587066482623937', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:04:08', 17, 0, '', '2019-05-24 22:04:08');
INSERT INTO `access_log` VALUES (8312, '64.78.15587066538273939', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:04:14', 9, 0, '', '2019-05-24 22:04:14');
INSERT INTO `access_log` VALUES (8313, '64.76.15587066538243939', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:04:14', 13, 0, '', '2019-05-24 22:04:14');
INSERT INTO `access_log` VALUES (8314, '65.46.15587066748863925', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:04:35', 22, 0, '', '2019-05-24 22:04:35');
INSERT INTO `access_log` VALUES (8315, '65.53.15587066868053911', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:04:47', 13, 0, '', '2019-05-24 22:04:47');
INSERT INTO `access_log` VALUES (8316, '65.48.15587066922523931', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=9', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:04:52', 11, 0, '', '2019-05-24 22:04:52');
INSERT INTO `access_log` VALUES (8317, '65.45.15587066985763937', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:04:59', 11, 0, '', '2019-05-24 22:04:59');
INSERT INTO `access_log` VALUES (8318, '65.47.15587067061113925', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:05:06', 613, 0, '', '2019-05-24 22:05:07');
INSERT INTO `access_log` VALUES (8319, '65.49.15587068729813925', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:07:53', 16, 0, '', '2019-05-24 22:07:53');
INSERT INTO `access_log` VALUES (8320, '65.47.15587069758293929', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:09:36', 12, 0, '', '2019-05-24 22:09:36');
INSERT INTO `access_log` VALUES (8321, '65.46.15587070197463931', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:10:20', 21, 0, '', '2019-05-24 22:10:20');
INSERT INTO `access_log` VALUES (8322, '64.77.15587070914703949', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:11:31', 14, 0, '', '2019-05-24 22:11:31');
INSERT INTO `access_log` VALUES (8323, '64.76.15587070914703945', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:11:31', 18, 0, '', '2019-05-24 22:11:31');
INSERT INTO `access_log` VALUES (8324, '65.51.15587071100593925', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:11:50', 10, 0, '', '2019-05-24 22:11:50');
INSERT INTO `access_log` VALUES (8325, '65.49.15587071127373929', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:11:53', 20, 0, '', '2019-05-24 22:11:53');
INSERT INTO `access_log` VALUES (8326, '65.46.15587071142323933', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:11:54', 10, 0, '', '2019-05-24 22:11:54');
INSERT INTO `access_log` VALUES (8327, '65.53.15587072926563921', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:14:53', 21, 0, '', '2019-05-24 22:14:53');
INSERT INTO `access_log` VALUES (8328, '65.45.15587073091893947', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:15:09', 11, 0, '', '2019-05-24 22:15:09');
INSERT INTO `access_log` VALUES (8329, '65.47.15587073101323935', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:15:10', 9, 0, '', '2019-05-24 22:15:10');
INSERT INTO `access_log` VALUES (8330, '65.51.15587073118963929', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:15:12', 15, 0, '', '2019-05-24 22:15:12');
INSERT INTO `access_log` VALUES (8331, '65.49.15587073136973933', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:15:14', 10, 0, '', '2019-05-24 22:15:14');
INSERT INTO `access_log` VALUES (8332, '65.49.15587074550043935', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:17:35', 779, 0, '', '2019-05-24 22:17:36');
INSERT INTO `access_log` VALUES (8333, '65.46.15587074627313939', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:17:43', 11, 0, '', '2019-05-24 22:17:43');
INSERT INTO `access_log` VALUES (8334, '65.50.15587074653293933', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:17:45', 21, 0, '', '2019-05-24 22:17:45');
INSERT INTO `access_log` VALUES (8335, '65.53.15587074674283925', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:17:47', 15, 0, '', '2019-05-24 22:17:47');
INSERT INTO `access_log` VALUES (8336, '65.48.15587074690963945', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:17:49', 11, 0, '', '2019-05-24 22:17:49');
INSERT INTO `access_log` VALUES (8337, '65.52.15587074716213933', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:17:52', 10, 0, '', '2019-05-24 22:17:52');
INSERT INTO `access_log` VALUES (8338, '65.47.15587074759643939', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:17:56', 20, 0, '', '2019-05-24 22:17:56');
INSERT INTO `access_log` VALUES (8339, '65.51.15587074829033933', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:18:03', 12, 0, '', '2019-05-24 22:18:03');
INSERT INTO `access_log` VALUES (8340, '65.47.15587075939943941', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-24 22:19:54', 15, 0, '', '2019-05-24 22:19:54');
INSERT INTO `access_log` VALUES (8341, '65.54.15587091299773953', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:45:30', 1, 1002001015, '账号未登陆', '2019-05-24 22:45:30');
INSERT INTO `access_log` VALUES (8342, '65.46.15587091299773963', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:45:30', 0, 1002001015, '账号未登陆', '2019-05-24 22:45:30');
INSERT INTO `access_log` VALUES (8343, '65.50.15587091301683957', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:45:30', 1, 1002001015, '账号未登陆', '2019-05-24 22:45:30');
INSERT INTO `access_log` VALUES (8344, '65.53.15587091345423949', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:45:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 22:45:35');
INSERT INTO `access_log` VALUES (8345, '65.52.15587091422793957', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:45:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-24 22:45:42');
INSERT INTO `access_log` VALUES (8346, '65.51.15587091723683957', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:46:12', 949, 0, '', '2019-05-24 22:46:13');
INSERT INTO `access_log` VALUES (8347, '65.49.15587091738293961', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:46:14', 15, 0, '', '2019-05-24 22:46:14');
INSERT INTO `access_log` VALUES (8348, '65.46.15587091738303965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:46:14', 15, 0, '', '2019-05-24 22:46:14');
INSERT INTO `access_log` VALUES (8349, '65.54.15587091738303955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:46:14', 15, 0, '', '2019-05-24 22:46:14');
INSERT INTO `access_log` VALUES (8350, '62.82.15587091788124681', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:46:19', 25, 0, '', '2019-05-24 22:46:19');
INSERT INTO `access_log` VALUES (8351, '62.86.15587092061904673', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:46:46', 21, 0, '', '2019-05-24 22:46:46');
INSERT INTO `access_log` VALUES (8352, '64.80.15587092191643967', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:46:59', 23, 0, '', '2019-05-24 22:46:59');
INSERT INTO `access_log` VALUES (8353, '64.81.15587092191553971', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:46:59', 34, 0, '', '2019-05-24 22:46:59');
INSERT INTO `access_log` VALUES (8354, '64.83.15587092284603971', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:47:08', 17, 0, '', '2019-05-24 22:47:08');
INSERT INTO `access_log` VALUES (8355, '64.84.15587092284583973', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:47:08', 19, 0, '', '2019-05-24 22:47:08');
INSERT INTO `access_log` VALUES (8356, '64.78.15587092372753975', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:47:17', 17, 0, '', '2019-05-24 22:47:17');
INSERT INTO `access_log` VALUES (8357, '64.77.15587092372793979', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:47:17', 23, 0, '', '2019-05-24 22:47:17');
INSERT INTO `access_log` VALUES (8358, '64.82.15587092536893975', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:47:34', 12, 0, '', '2019-05-24 22:47:34');
INSERT INTO `access_log` VALUES (8359, '66.48.15587092694533775', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:47:49', 26, 0, '', '2019-05-24 22:47:49');
INSERT INTO `access_log` VALUES (8360, '65.49.15587092830903963', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:48:03', 8, 0, '', '2019-05-24 22:48:03');
INSERT INTO `access_log` VALUES (8361, '65.46.15587092831443967', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:48:03', 9, 0, '', '2019-05-24 22:48:03');
INSERT INTO `access_log` VALUES (8362, '65.54.15587092831443957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:48:03', 9, 0, '', '2019-05-24 22:48:03');
INSERT INTO `access_log` VALUES (8363, '66.53.15587092832083775', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:48:03', 16, 0, '', '2019-05-24 22:48:03');
INSERT INTO `access_log` VALUES (8364, '59.76.15587092900104731', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:48:10', 20, 0, '', '2019-05-24 22:48:10');
INSERT INTO `access_log` VALUES (8365, '65.53.15587092962423953', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '221.218.90.90', '2019-05-24 22:48:16', 22, 0, '', '2019-05-24 22:48:16');
INSERT INTO `access_log` VALUES (8366, '59.71.15587156794524821', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:34:39', 13, 0, '', '2019-05-25 00:34:39');
INSERT INTO `access_log` VALUES (8367, '59.80.15587156794534819', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:34:39', 17, 2001001000, '服务端发生异常', '2019-05-25 00:34:39');
INSERT INTO `access_log` VALUES (8368, '65.47.15587160849094057', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.223.198.147', '2019-05-25 00:41:25', 0, 1002001015, '账号未登陆', '2019-05-25 00:41:25');
INSERT INTO `access_log` VALUES (8369, '65.51.15587160849094051', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.223.198.147', '2019-05-25 00:41:25', 0, 1002001015, '账号未登陆', '2019-05-25 00:41:25');
INSERT INTO `access_log` VALUES (8370, '65.49.15587160849314055', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.223.198.147', '2019-05-25 00:41:25', 0, 1002001015, '账号未登陆', '2019-05-25 00:41:25');
INSERT INTO `access_log` VALUES (8371, '65.54.15587160877044049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.223.198.147', '2019-05-25 00:41:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-25 00:41:28');
INSERT INTO `access_log` VALUES (8372, '65.46.15587160934784059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.223.198.147', '2019-05-25 00:41:33', 72, 0, '', '2019-05-25 00:41:34');
INSERT INTO `access_log` VALUES (8373, '65.50.15587160938314053', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.223.198.147', '2019-05-25 00:41:34', 12, 0, '', '2019-05-25 00:41:34');
INSERT INTO `access_log` VALUES (8374, '65.53.15587160938364045', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.223.198.147', '2019-05-25 00:41:34', 10, 0, '', '2019-05-25 00:41:34');
INSERT INTO `access_log` VALUES (8375, '65.48.15587160938404065', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.223.198.147', '2019-05-25 00:41:34', 10, 0, '', '2019-05-25 00:41:34');
INSERT INTO `access_log` VALUES (8376, '62.81.15587161122674765', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.223.198.147', '2019-05-25 00:41:52', 26, 0, '', '2019-05-25 00:41:52');
INSERT INTO `access_log` VALUES (8377, '65.50.15587164981024059', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:48:18', 1, 1002001015, '账号未登陆', '2019-05-25 00:48:18');
INSERT INTO `access_log` VALUES (8378, '65.48.15587164981054071', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:48:18', 0, 1002001015, '账号未登陆', '2019-05-25 00:48:18');
INSERT INTO `access_log` VALUES (8379, '65.53.15587164981114051', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:48:18', 0, 1002001015, '账号未登陆', '2019-05-25 00:48:18');
INSERT INTO `access_log` VALUES (8380, '65.45.15587165089444077', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:48:29', 88, 0, '', '2019-05-25 00:48:29');
INSERT INTO `access_log` VALUES (8381, '65.49.15587165092704063', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:48:29', 18, 0, '', '2019-05-25 00:48:29');
INSERT INTO `access_log` VALUES (8382, '65.51.15587165092764059', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:48:29', 17, 0, '', '2019-05-25 00:48:29');
INSERT INTO `access_log` VALUES (8383, '65.47.15587165092774065', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:48:29', 17, 0, '', '2019-05-25 00:48:29');
INSERT INTO `access_log` VALUES (8384, '62.85.15587165142964779', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:48:34', 17, 0, '', '2019-05-25 00:48:34');
INSERT INTO `access_log` VALUES (8385, '59.78.15587165199654835', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:48:40', 416, 0, '', '2019-05-25 00:48:40');
INSERT INTO `access_log` VALUES (8386, '65.46.15587165272594067', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:48:47', 20, 0, '', '2019-05-25 00:48:47');
INSERT INTO `access_log` VALUES (8387, '65.50.15587165318294061', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:48:52', 12, 0, '', '2019-05-25 00:48:52');
INSERT INTO `access_log` VALUES (8388, '65.48.15587165336544073', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:48:54', 10, 0, '', '2019-05-25 00:48:54');
INSERT INTO `access_log` VALUES (8389, '65.52.15587165363574061', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:48:56', 15, 0, '', '2019-05-25 00:48:56');
INSERT INTO `access_log` VALUES (8390, '65.49.15587165861494065', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:49:46', 16, 0, '', '2019-05-25 00:49:46');
INSERT INTO `access_log` VALUES (8391, '65.54.15587165863514059', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:49:46', 10, 0, '', '2019-05-25 00:49:46');
INSERT INTO `access_log` VALUES (8392, '65.46.15587165864554069', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:49:46', 11, 0, '', '2019-05-25 00:49:46');
INSERT INTO `access_log` VALUES (8393, '65.50.15587165866354063', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:49:47', 20, 0, '', '2019-05-25 00:49:47');
INSERT INTO `access_log` VALUES (8394, '59.76.15587165868194829', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:49:47', 13, 0, '', '2019-05-25 00:49:47');
INSERT INTO `access_log` VALUES (8395, '62.80.15587165877864783', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.217.84.130', '2019-05-25 00:49:48', 143, 0, '', '2019-05-25 00:49:48');
INSERT INTO `access_log` VALUES (8396, '59.73.15587459745265227', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.165.130.225', '2019-05-25 08:59:35', 25, 2001001000, '服务端发生异常', '2019-05-25 08:59:35');
INSERT INTO `access_log` VALUES (8397, '59.74.15587459745255227', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.165.130.225', '2019-05-25 08:59:35', 109, 0, '', '2019-05-25 08:59:35');
INSERT INTO `access_log` VALUES (8398, '65.48.15587459937874467', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.165.130.225', '2019-05-25 08:59:54', 997, 0, '', '2019-05-25 08:59:55');
INSERT INTO `access_log` VALUES (8399, '65.45.15587459951204473', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.165.130.225', '2019-05-25 08:59:55', 16, 0, '', '2019-05-25 08:59:55');
INSERT INTO `access_log` VALUES (8400, '65.51.15587459951224455', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.165.130.225', '2019-05-25 08:59:55', 13, 0, '', '2019-05-25 08:59:55');
INSERT INTO `access_log` VALUES (8401, '65.52.15587459951194455', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.165.130.225', '2019-05-25 08:59:55', 17, 0, '', '2019-05-25 08:59:55');
INSERT INTO `access_log` VALUES (8402, '62.82.15587459987275173', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.165.130.225', '2019-05-25 08:59:59', 267, 0, '', '2019-05-25 08:59:59');
INSERT INTO `access_log` VALUES (8403, '66.51.15587460046234263', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.165.130.225', '2019-05-25 09:00:05', 24, 0, '', '2019-05-25 09:00:05');
INSERT INTO `access_log` VALUES (8404, '59.78.15587460073085229', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.165.130.225', '2019-05-25 09:00:07', 14, 0, '', '2019-05-25 09:00:07');
INSERT INTO `access_log` VALUES (8405, '65.53.15587472829664465', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.47.37.174', '2019-05-25 09:21:23', 7, 1002001012, '访问令牌已过期', '2019-05-25 09:21:23');
INSERT INTO `access_log` VALUES (8406, '65.48.15587472829664485', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.47.37.174', '2019-05-25 09:21:23', 7, 1002001012, '访问令牌已过期', '2019-05-25 09:21:23');
INSERT INTO `access_log` VALUES (8407, '65.51.15587472829674473', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.47.37.174', '2019-05-25 09:21:23', 7, 1002001012, '访问令牌已过期', '2019-05-25 09:21:23');
INSERT INTO `access_log` VALUES (8408, '59.74.15587472831855245', 0, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.47.37.174', '2019-05-25 09:21:23', 7, 1002001012, '访问令牌已过期', '2019-05-25 09:21:23');
INSERT INTO `access_log` VALUES (8409, '59.77.15587476974365249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:17', 4, 0, '', '2019-05-25 09:28:17');
INSERT INTO `access_log` VALUES (8410, '59.76.15587476974365245', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:17', 13, 2001001000, '服务端发生异常', '2019-05-25 09:28:17');
INSERT INTO `access_log` VALUES (8411, '59.72.15587477162925245', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:36', 7, 0, '', '2019-05-25 09:28:36');
INSERT INTO `access_log` VALUES (8412, '59.79.15587477162935247', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:36', 12, 2001001000, '服务端发生异常', '2019-05-25 09:28:36');
INSERT INTO `access_log` VALUES (8413, '64.83.15587477186894485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:39', 16, 0, '', '2019-05-25 09:28:39');
INSERT INTO `access_log` VALUES (8414, '64.77.15587477188874493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:39', 3, 0, '', '2019-05-25 09:28:39');
INSERT INTO `access_log` VALUES (8415, '64.78.15587477202484489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:40', 3, 0, '', '2019-05-25 09:28:40');
INSERT INTO `access_log` VALUES (8416, '64.82.15587477212974489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:41', 950, 0, '', '2019-05-25 09:28:42');
INSERT INTO `access_log` VALUES (8417, '64.76.15587477208534489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:41', 1395, 0, '', '2019-05-25 09:28:42');
INSERT INTO `access_log` VALUES (8418, '64.79.15587477288494487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:49', 4, 0, '', '2019-05-25 09:28:49');
INSERT INTO `access_log` VALUES (8419, '64.80.15587477290514483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:49', 4, 0, '', '2019-05-25 09:28:49');
INSERT INTO `access_log` VALUES (8420, '59.75.15587477306475251', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:51', 3, 0, '', '2019-05-25 09:28:51');
INSERT INTO `access_log` VALUES (8421, '59.80.15587477306475249', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:51', 13, 2001001000, '服务端发生异常', '2019-05-25 09:28:51');
INSERT INTO `access_log` VALUES (8422, '59.71.15587477323325251', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:52', 4, 0, '', '2019-05-25 09:28:52');
INSERT INTO `access_log` VALUES (8423, '59.77.15587477323375251', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:28:52', 13, 2001001000, '服务端发生异常', '2019-05-25 09:28:52');
INSERT INTO `access_log` VALUES (8424, '65.54.15587477720224477', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:29:32', 1, 1002001015, '账号未登陆', '2019-05-25 09:29:32');
INSERT INTO `access_log` VALUES (8425, '65.49.15587477720224483', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:29:32', 1, 1002001015, '账号未登陆', '2019-05-25 09:29:32');
INSERT INTO `access_log` VALUES (8426, '65.46.15587477720234487', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:29:32', 0, 1002001015, '账号未登陆', '2019-05-25 09:29:32');
INSERT INTO `access_log` VALUES (8427, '65.50.15587477766994481', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:29:37', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-25 09:29:37');
INSERT INTO `access_log` VALUES (8428, '65.53.15587477903424473', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:29:50', 1045, 0, '', '2019-05-25 09:29:51');
INSERT INTO `access_log` VALUES (8429, '65.48.15587477918514493', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:29:52', 92, 0, '', '2019-05-25 09:29:52');
INSERT INTO `access_log` VALUES (8430, '65.52.15587477918574481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:29:52', 89, 0, '', '2019-05-25 09:29:52');
INSERT INTO `access_log` VALUES (8431, '65.45.15587477918574499', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:29:52', 90, 0, '', '2019-05-25 09:29:52');
INSERT INTO `access_log` VALUES (8432, '62.85.15587477966215197', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:29:57', 26, 0, '', '2019-05-25 09:29:57');
INSERT INTO `access_log` VALUES (8433, '64.78.15587478023014491', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:30:02', 22, 0, '', '2019-05-25 09:30:02');
INSERT INTO `access_log` VALUES (8434, '64.82.15587478023014491', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:30:02', 20, 0, '', '2019-05-25 09:30:02');
INSERT INTO `access_log` VALUES (8435, '64.80.15587478085644485', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:30:09', 14, 0, '', '2019-05-25 09:30:09');
INSERT INTO `access_log` VALUES (8436, '64.79.15587478085634489', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:30:09', 31, 0, '', '2019-05-25 09:30:09');
INSERT INTO `access_log` VALUES (8437, '59.80.15587478293025251', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:30:29', 304, 0, '', '2019-05-25 09:30:30');
INSERT INTO `access_log` VALUES (8438, '64.83.15587478355724489', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:30:36', 15, 0, '', '2019-05-25 09:30:36');
INSERT INTO `access_log` VALUES (8439, '64.84.15587478355724491', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:30:36', 19, 0, '', '2019-05-25 09:30:36');
INSERT INTO `access_log` VALUES (8440, '64.77.15587478361824497', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:30:36', 13, 0, '', '2019-05-25 09:30:36');
INSERT INTO `access_log` VALUES (8441, '64.78.15587478361954493', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:30:36', 10, 0, '', '2019-05-25 09:30:36');
INSERT INTO `access_log` VALUES (8442, '62.89.15587478380135195', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.24.79', '2019-05-25 09:30:38', 15, 0, '', '2019-05-25 09:30:38');
INSERT INTO `access_log` VALUES (8443, '59.74.15587495424515277', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.178.101', '2019-05-25 09:59:02', 5, 0, '', '2019-05-25 09:59:02');
INSERT INTO `access_log` VALUES (8444, '59.73.15587495424885277', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.178.101', '2019-05-25 09:59:02', 13, 2001001000, '服务端发生异常', '2019-05-25 09:59:03');
INSERT INTO `access_log` VALUES (8445, '64.81.15587495484074513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.178.101', '2019-05-25 09:59:08', 138, 0, '', '2019-05-25 09:59:09');
INSERT INTO `access_log` VALUES (8446, '64.85.15587495487514515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.178.101', '2019-05-25 09:59:09', 3, 0, '', '2019-05-25 09:59:09');
INSERT INTO `access_log` VALUES (8447, '65.48.15587660277454739', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:33:48', 15, 1002001012, '访问令牌已过期', '2019-05-25 14:33:48');
INSERT INTO `access_log` VALUES (8448, '65.50.15587660277464729', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:33:48', 16, 1002001012, '访问令牌已过期', '2019-05-25 14:33:48');
INSERT INTO `access_log` VALUES (8449, '65.47.15587660277454735', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:33:48', 15, 1002001012, '访问令牌已过期', '2019-05-25 14:33:48');
INSERT INTO `access_log` VALUES (8450, '65.46.15587660301004733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:33:50', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-25 14:33:50');
INSERT INTO `access_log` VALUES (8451, '65.54.15587660359284721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:33:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-25 14:33:56');
INSERT INTO `access_log` VALUES (8452, '65.49.15587660483634731', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:34:08', 88, 0, '', '2019-05-25 14:34:08');
INSERT INTO `access_log` VALUES (8453, '65.53.15587660487554721', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:34:09', 77, 0, '', '2019-05-25 14:34:09');
INSERT INTO `access_log` VALUES (8454, '65.45.15587660487524743', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:34:09', 82, 0, '', '2019-05-25 14:34:09');
INSERT INTO `access_log` VALUES (8455, '65.52.15587660487464729', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:34:09', 85, 0, '', '2019-05-25 14:34:09');
INSERT INTO `access_log` VALUES (8456, '65.46.15587660845884735', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:34:45', 23, 0, '', '2019-05-25 14:34:45');
INSERT INTO `access_log` VALUES (8457, '65.49.15587661104144733', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:35:10', 835, 0, '', '2019-05-25 14:35:11');
INSERT INTO `access_log` VALUES (8458, '65.53.15587661197724723', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:35:20', 11, 0, '', '2019-05-25 14:35:20');
INSERT INTO `access_log` VALUES (8459, '64.78.15587661450784737', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:35:45', 185, 0, '', '2019-05-25 14:35:45');
INSERT INTO `access_log` VALUES (8460, '64.82.15587661450724739', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:35:45', 197, 0, '', '2019-05-25 14:35:45');
INSERT INTO `access_log` VALUES (8461, '64.79.15587661588014735', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:35:59', 12, 0, '', '2019-05-25 14:35:59');
INSERT INTO `access_log` VALUES (8462, '64.76.15587661587974739', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:35:59', 19, 0, '', '2019-05-25 14:35:59');
INSERT INTO `access_log` VALUES (8463, '62.86.15587661921425435', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:36:32', 28, 0, '', '2019-05-25 14:36:32');
INSERT INTO `access_log` VALUES (8464, '62.82.15587662754125443', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:37:55', 21, 0, '', '2019-05-25 14:37:55');
INSERT INTO `access_log` VALUES (8465, '64.76.15587662769594741', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:37:57', 19, 0, '', '2019-05-25 14:37:57');
INSERT INTO `access_log` VALUES (8466, '64.79.15587662769594737', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:37:57', 19, 0, '', '2019-05-25 14:37:57');
INSERT INTO `access_log` VALUES (8467, '64.80.15587662778974735', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:37:58', 10, 0, '', '2019-05-25 14:37:58');
INSERT INTO `access_log` VALUES (8468, '64.81.15587662778894739', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:37:58', 18, 0, '', '2019-05-25 14:37:58');
INSERT INTO `access_log` VALUES (8469, '65.52.15587662790684733', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:37:59', 12, 0, '', '2019-05-25 14:37:59');
INSERT INTO `access_log` VALUES (8470, '65.45.15587662805744747', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.160.227.225', '2019-05-25 14:38:01', 19, 0, '', '2019-05-25 14:38:01');
INSERT INTO `access_log` VALUES (8471, '59.72.15587703929255549', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.184.232', '2019-05-25 15:46:33', 16, 0, '', '2019-05-25 15:46:33');
INSERT INTO `access_log` VALUES (8472, '59.79.15587703929265551', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.184.232', '2019-05-25 15:46:33', 20, 2001001000, '服务端发生异常', '2019-05-25 15:46:33');
INSERT INTO `access_log` VALUES (8473, '65.49.15587703974374791', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.226.184.216', '2019-05-25 15:46:37', 0, 1002001015, '账号未登陆', '2019-05-25 15:46:37');
INSERT INTO `access_log` VALUES (8474, '65.54.15587703974374781', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.226.184.232', '2019-05-25 15:46:37', 0, 1002001015, '账号未登陆', '2019-05-25 15:46:37');
INSERT INTO `access_log` VALUES (8475, '65.53.15587703974554781', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.226.184.216', '2019-05-25 15:46:37', 1, 1002001015, '账号未登陆', '2019-05-25 15:46:37');
INSERT INTO `access_log` VALUES (8476, '59.74.15587704542935557', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.184.232', '2019-05-25 15:47:34', 5, 0, '', '2019-05-25 15:47:34');
INSERT INTO `access_log` VALUES (8477, '59.76.15587704542925551', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.184.232', '2019-05-25 15:47:34', 15, 2001001000, '服务端发生异常', '2019-05-25 15:47:34');
INSERT INTO `access_log` VALUES (8478, '65.46.15587704602094795', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.226.184.232', '2019-05-25 15:47:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-25 15:47:40');
INSERT INTO `access_log` VALUES (8479, '65.47.15587762269984875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.56.97', '2019-05-25 17:23:47', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-25 17:23:47');
INSERT INTO `access_log` VALUES (8480, '65.52.15587762300684867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.56.97', '2019-05-25 17:23:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-25 17:23:50');
INSERT INTO `access_log` VALUES (8481, '65.50.15587762340804869', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.56.97', '2019-05-25 17:23:54', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-25 17:23:54');
INSERT INTO `access_log` VALUES (8482, '65.45.15587817588014957', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '122.234.157.206', '2019-05-25 18:55:59', 1, 1002001015, '账号未登陆', '2019-05-25 18:55:59');
INSERT INTO `access_log` VALUES (8483, '65.51.15587817948794941', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '122.234.157.206', '2019-05-25 18:56:35', 1, 1002001015, '账号未登陆', '2019-05-25 18:56:35');
INSERT INTO `access_log` VALUES (8484, '65.53.15587817959454937', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '122.234.157.206', '2019-05-25 18:56:36', 1, 1002001015, '账号未登陆', '2019-05-25 18:56:36');
INSERT INTO `access_log` VALUES (8485, '65.48.15587817966954959', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '122.234.157.206', '2019-05-25 18:56:37', 0, 1002001015, '账号未登陆', '2019-05-25 18:56:37');
INSERT INTO `access_log` VALUES (8486, '59.72.15587950786785879', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.39.216.124', '2019-05-25 22:37:59', 14, 2001001000, '服务端发生异常', '2019-05-25 22:37:59');
INSERT INTO `access_log` VALUES (8487, '59.79.15587950787475881', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.194.160', '2019-05-25 22:37:59', 11, 0, '', '2019-05-25 22:37:59');
INSERT INTO `access_log` VALUES (8488, '64.83.15587950824475123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.194.160', '2019-05-25 22:38:02', 12, 0, '', '2019-05-25 22:38:02');
INSERT INTO `access_log` VALUES (8489, '64.85.15587950826025125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.194.160', '2019-05-25 22:38:03', 3, 0, '', '2019-05-25 22:38:03');
INSERT INTO `access_log` VALUES (8490, '64.84.15587950836345125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.194.160', '2019-05-25 22:38:04', 3, 0, '', '2019-05-25 22:38:04');
INSERT INTO `access_log` VALUES (8491, '64.82.15587950842735127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.194.160', '2019-05-25 22:38:04', 3, 0, '', '2019-05-25 22:38:04');
INSERT INTO `access_log` VALUES (8492, '64.78.15587950846545125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.194.160', '2019-05-25 22:38:05', 4, 0, '', '2019-05-25 22:38:05');
INSERT INTO `access_log` VALUES (8493, '64.77.15587950849405129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.194.160', '2019-05-25 22:38:05', 3, 0, '', '2019-05-25 22:38:05');
INSERT INTO `access_log` VALUES (8494, '65.45.15588005561475209', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:16', 13, 1002001012, '访问令牌已过期', '2019-05-26 00:09:16');
INSERT INTO `access_log` VALUES (8495, '65.54.15588005561485185', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:16', 16, 1002001012, '访问令牌已过期', '2019-05-26 00:09:16');
INSERT INTO `access_log` VALUES (8496, '65.50.15588005561485195', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:16', 18, 1002001012, '访问令牌已过期', '2019-05-26 00:09:16');
INSERT INTO `access_log` VALUES (8497, '65.53.15588005654695189', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:25', 66, 0, '', '2019-05-26 00:09:26');
INSERT INTO `access_log` VALUES (8498, '65.48.15588005657695213', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:26', 12, 0, '', '2019-05-26 00:09:26');
INSERT INTO `access_log` VALUES (8499, '65.52.15588005657725201', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:26', 14, 0, '', '2019-05-26 00:09:26');
INSERT INTO `access_log` VALUES (8500, '65.49.15588005657755199', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:26', 12, 0, '', '2019-05-26 00:09:26');
INSERT INTO `access_log` VALUES (8501, '62.81.15588005695525893', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:30', 26, 0, '', '2019-05-26 00:09:30');
INSERT INTO `access_log` VALUES (8502, '62.89.15588005726555901', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:33', 38, 0, '', '2019-05-26 00:09:33');
INSERT INTO `access_log` VALUES (8503, '64.84.15588005746495199', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:35', 24, 0, '', '2019-05-26 00:09:35');
INSERT INTO `access_log` VALUES (8504, '64.82.15588005746485201', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:35', 28, 0, '', '2019-05-26 00:09:35');
INSERT INTO `access_log` VALUES (8505, '59.73.15588005777475959', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:38', 22, 0, '', '2019-05-26 00:09:38');
INSERT INTO `access_log` VALUES (8506, '65.46.15588005835285205', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:44', 21, 0, '', '2019-05-26 00:09:44');
INSERT INTO `access_log` VALUES (8507, '65.45.15588005858815211', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:46', 10, 0, '', '2019-05-26 00:09:46');
INSERT INTO `access_log` VALUES (8508, '65.54.15588005875145187', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:48', 19, 0, '', '2019-05-26 00:09:48');
INSERT INTO `access_log` VALUES (8509, '65.50.15588005931065197', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:53', 10, 0, '', '2019-05-26 00:09:53');
INSERT INTO `access_log` VALUES (8510, '65.51.15588005939255197', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:09:54', 41, 0, '', '2019-05-26 00:09:54');
INSERT INTO `access_log` VALUES (8511, '66.50.15588006306884989', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:10:31', 25, 0, '', '2019-05-26 00:10:31');
INSERT INTO `access_log` VALUES (8512, '62.84.15588006424015903', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:10:42', 21, 0, '', '2019-05-26 00:10:42');
INSERT INTO `access_log` VALUES (8513, '59.75.15588006455765959', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-26 00:10:46', 17, 0, '', '2019-05-26 00:10:46');
INSERT INTO `access_log` VALUES (8514, '93b59081-0763-4c7e-92a9-496edfd17e2d', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:47:14', 287, 1002001012, '访问令牌已过期', '2019-05-26 11:47:15');
INSERT INTO `access_log` VALUES (8515, '55564314-24f1-44d8-983a-ec95592d6450', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:47:14', 284, 1002001012, '访问令牌已过期', '2019-05-26 11:47:15');
INSERT INTO `access_log` VALUES (8516, 'fb0d2e8f-bba1-4a3a-bd20-ffaf92dbf510', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:47:14', 321, 1002001012, '访问令牌已过期', '2019-05-26 11:47:15');
INSERT INTO `access_log` VALUES (8517, 'f9a7e8eb-318a-42da-a6e3-db40407a6fad', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:51:16', 51, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-26 11:51:16');
INSERT INTO `access_log` VALUES (8518, 'cd4b4275-1720-4850-ad63-8206854055c2', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:51:21', 4, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-26 11:51:21');
INSERT INTO `access_log` VALUES (8519, 'da34a254-f96b-4f98-99e1-2ff2c0a67e73', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:52:29', 3, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-26 11:52:29');
INSERT INTO `access_log` VALUES (8520, 'ce052ff1-e231-4535-9883-5f8d7bd0bce5', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:53:50', 3, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-26 11:53:50');
INSERT INTO `access_log` VALUES (8521, '5e707f3f-82ca-4a36-98df-09bc684c3df2', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:54:05', 3, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-26 11:54:05');
INSERT INTO `access_log` VALUES (8522, '77b5f962-f3cb-4354-a465-afd62ac687c1', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:54:59', 104, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-26 11:54:59');
INSERT INTO `access_log` VALUES (8523, 'a8fd3403-eb57-4db3-965f-c08c913deb72', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:55:02', 4, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-26 11:55:02');
INSERT INTO `access_log` VALUES (8524, '609f788c-c898-40ce-ae6f-718c26b60915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:55:04', 4, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-26 11:55:04');
INSERT INTO `access_log` VALUES (8525, '5c6fc63f-48b7-4b18-bf5c-4305a7919d96', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:57:44', 684, 0, '', '2019-05-26 11:57:45');
INSERT INTO `access_log` VALUES (8526, 'da6924d1-fccd-4fd2-a361-4a99c3a5a5a5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:57:45', 414, 0, '', '2019-05-26 11:57:45');
INSERT INTO `access_log` VALUES (8527, 'f4dda2f6-ee5b-4b48-a94c-addd8c0d5313', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:57:45', 420, 0, '', '2019-05-26 11:57:45');
INSERT INTO `access_log` VALUES (8528, '94a68c2e-1459-4e43-a105-1570a5af8fbd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:57:45', 462, 0, '', '2019-05-26 11:57:45');
INSERT INTO `access_log` VALUES (8529, 'ea51664f-06e1-4d31-9104-cfc80ab10065', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:57:57', 157, 0, '', '2019-05-26 11:57:57');
INSERT INTO `access_log` VALUES (8530, '2e0964dc-680a-490e-90bf-2620759c0961', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:57:57', 158, 0, '', '2019-05-26 11:57:57');
INSERT INTO `access_log` VALUES (8531, '10ae3b3c-13db-4dd0-b559-6cbdccb7feab', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:57:57', 155, 0, '', '2019-05-26 11:57:57');
INSERT INTO `access_log` VALUES (8532, '028bc7ff-03df-4bc6-8003-bbb6b502a73f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:59:02', 191, 0, '', '2019-05-26 11:59:02');
INSERT INTO `access_log` VALUES (8533, '57f070ea-3545-4d7f-b286-604a27f894eb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:59:02', 191, 0, '', '2019-05-26 11:59:02');
INSERT INTO `access_log` VALUES (8534, '2f51bf20-f2a9-4bb2-bbaa-a4f6ac252002', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:59:02', 187, 0, '', '2019-05-26 11:59:02');
INSERT INTO `access_log` VALUES (8535, '4de21597-6f0d-41a6-9880-24b3716706c8', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 11:59:11', 160, 0, '', '2019-05-26 11:59:11');
INSERT INTO `access_log` VALUES (8536, '12050ab7-b4af-4902-94f9-abab7edfac47', 1, 2, 'admin-application', '/admin-api/admins/resource/add', 'type=1&displayName=短信服务&pid=0&sort=-1&icon=user', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:00:31', 446, 0, '', '2019-05-26 12:00:32');
INSERT INTO `access_log` VALUES (8537, 'da1673c7-0428-4913-8dbd-b35ff8007f6f', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:00:32', 149, 0, '', '2019-05-26 12:00:32');
INSERT INTO `access_log` VALUES (8538, '0388d604-6ff6-42ee-9868-1abfc8b2d307', 1, 2, 'admin-application', '/admin-api/admins/resource/add', 'type=1&displayName=短信签名&pid=51&sort=1&icon=user&handler=/sms/sign-list', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:01:56', 446, 0, '', '2019-05-26 12:01:56');
INSERT INTO `access_log` VALUES (8539, 'f38045ad-2623-4327-910e-428363b2fb29', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:01:57', 1341, 0, '', '2019-05-26 12:01:58');
INSERT INTO `access_log` VALUES (8540, '24d884df-2772-4013-b96d-f4fae2f446e9', 1, 2, 'admin-application', '/admin-api/admins/resource/add', 'type=1&displayName=短信模板&pid=51&sort=2&icon=user&handler=/sms/template-list', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:02:19', 328, 0, '', '2019-05-26 12:02:19');
INSERT INTO `access_log` VALUES (8541, '254dfd1a-406b-4d1d-843c-24a65912a074', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:02:19', 422, 0, '', '2019-05-26 12:02:19');
INSERT INTO `access_log` VALUES (8542, 'a9935393-084e-49d0-843c-56e341dbf5c5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:02:27', 288, 0, '', '2019-05-26 12:02:27');
INSERT INTO `access_log` VALUES (8543, 'e12ca437-3f07-44f3-8e77-3c743c3be57b', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:02:31', 1680, 0, '', '2019-05-26 12:02:32');
INSERT INTO `access_log` VALUES (8544, '4cb3119b-aee6-447f-8f06-df4cc1195de7', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:02:32', 409, 0, '', '2019-05-26 12:02:33');
INSERT INTO `access_log` VALUES (8545, 'f0f2bc5e-dfb1-4941-b356-72794bbe0f12', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:02:40', 283, 0, '', '2019-05-26 12:02:41');
INSERT INTO `access_log` VALUES (8546, 'eab71342-2c1d-4499-b0b1-647b09a50b4e', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:02:43', 179, 0, '', '2019-05-26 12:02:44');
INSERT INTO `access_log` VALUES (8547, 'd9341e53-d5d8-4e30-9766-ac9d5d7affd3', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:02:47', 195, 0, '', '2019-05-26 12:02:47');
INSERT INTO `access_log` VALUES (8548, '1bdb9219-7b73-428f-843b-40a9a2b7a0e8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:03:01', 169, 0, '', '2019-05-26 12:03:01');
INSERT INTO `access_log` VALUES (8549, 'dce0294e-66fe-472b-b7b2-77f0a96cf034', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:03:01', 166, 0, '', '2019-05-26 12:03:01');
INSERT INTO `access_log` VALUES (8550, '73a9ac60-eecc-4ef1-8650-eaebf3baf08b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:03:01', 193, 0, '', '2019-05-26 12:03:01');
INSERT INTO `access_log` VALUES (8551, '6b801c4a-58b7-40a5-b6f6-3ec6ec4c727f', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:03:01', 273, 0, '', '2019-05-26 12:03:02');
INSERT INTO `access_log` VALUES (8552, 'c26be830-5fab-4901-8ebf-1c547817e04b', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:03:03', 181, 0, '', '2019-05-26 12:03:03');
INSERT INTO `access_log` VALUES (8553, 'd12b569a-882c-4ae7-8917-dcdcf9aad854', 1, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=6&resourceIds=13,14,15,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,41,42,43,44,45,46,47,48,49,50,51,52,53', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:03:10', 564, 0, '', '2019-05-26 12:03:10');
INSERT INTO `access_log` VALUES (8554, '1166e16d-b060-420c-bee5-796123188333', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:03:13', 158, 0, '', '2019-05-26 12:03:13');
INSERT INTO `access_log` VALUES (8555, '501cc875-de13-4782-a9a6-18405217affb', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:03:13', 151, 0, '', '2019-05-26 12:03:13');
INSERT INTO `access_log` VALUES (8556, '64b69ce3-2601-4f4f-8632-8856251f8ecd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:03:13', 157, 0, '', '2019-05-26 12:03:13');
INSERT INTO `access_log` VALUES (8557, 'de07097a-d2c9-401c-bfbd-416a3060994a', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:03:13', 179, 0, '', '2019-05-26 12:03:13');
INSERT INTO `access_log` VALUES (8558, '4bb2751e-d8eb-4df2-bc0d-18cea8430c0b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:03:44', 141, 0, '', '2019-05-26 12:03:44');
INSERT INTO `access_log` VALUES (8559, '893d5c03-1f24-401b-8f1b-8a7ef309c58a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:03:44', 144, 0, '', '2019-05-26 12:03:44');
INSERT INTO `access_log` VALUES (8560, 'cc1e1867-fbb7-41df-a384-f0350e883f3c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:03:44', 144, 0, '', '2019-05-26 12:03:44');
INSERT INTO `access_log` VALUES (8561, 'fa2c9d67-1215-4caa-acef-a2a826995c27', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:04:06', 145, 0, '', '2019-05-26 12:04:06');
INSERT INTO `access_log` VALUES (8562, '9f1f4424-71c5-4569-b8b3-6de931919f46', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:04:06', 147, 0, '', '2019-05-26 12:04:06');
INSERT INTO `access_log` VALUES (8563, 'a887c696-ec32-44fd-9c68-cb4b789d2891', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:04:06', 424, 2001001000, '服务端发生异常', '2019-05-26 12:04:07');
INSERT INTO `access_log` VALUES (8564, '9e6af35c-6d94-4649-a8eb-d581e88901e5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:04:07', 183, 0, '', '2019-05-26 12:04:08');
INSERT INTO `access_log` VALUES (8565, 'e8ff83e0-c8ef-4041-9e81-a716388094ed', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:04:07', 187, 0, '', '2019-05-26 12:04:08');
INSERT INTO `access_log` VALUES (8566, '0718b989-0de1-4186-905c-5d7ebcb9b62a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:04:07', 180, 0, '', '2019-05-26 12:04:08');
INSERT INTO `access_log` VALUES (8567, 'd7c1093c-5c67-4d45-a098-2199a8ad9fc5', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:05:08', 1464, 0, '', '2019-05-26 12:05:09');
INSERT INTO `access_log` VALUES (8568, 'cdd5ee4a-3c4c-4109-99a3-84195f15a1a3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:05:07', 2184, 0, '', '2019-05-26 12:05:09');
INSERT INTO `access_log` VALUES (8569, '9eb095a4-1f97-4854-82c0-60a2f096dfcf', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:05:09', 1529, 0, '', '2019-05-26 12:05:11');
INSERT INTO `access_log` VALUES (8570, '808ac1c5-179d-4e93-a436-31465fd25cc7', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:05:10', 779, 0, '', '2019-05-26 12:05:11');
INSERT INTO `access_log` VALUES (8571, 'd747a063-d7ff-4524-9e18-38f09b9d9ab5', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:05:12', 180, 0, '', '2019-05-26 12:05:12');
INSERT INTO `access_log` VALUES (8572, 'b662281a-db6f-4084-9d41-272c542a0916', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:05:13', 323, 0, '', '2019-05-26 12:05:13');
INSERT INTO `access_log` VALUES (8573, 'b958ce41-1e70-43e5-b452-3b7483c68c9c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:05:14', 252, 0, '', '2019-05-26 12:05:15');
INSERT INTO `access_log` VALUES (8574, '5f0e064b-0083-43d3-a501-b0078555fb97', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:05:17', 144, 0, '', '2019-05-26 12:05:17');
INSERT INTO `access_log` VALUES (8575, 'd59d5279-a616-43f9-960d-4528861b4915', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:06:26', 218, 0, '', '2019-05-26 12:06:26');
INSERT INTO `access_log` VALUES (8576, 'a8fdae70-0915-4c58-9ebd-b9fba5785d52', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:06:27', 455, 0, '', '2019-05-26 12:06:28');
INSERT INTO `access_log` VALUES (8577, 'c7f33c8a-7e0c-469b-b57c-ed4b52db59ed', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:06:30', 225, 0, '', '2019-05-26 12:06:30');
INSERT INTO `access_log` VALUES (8578, '25989e0b-8412-4cd9-a336-7927628cd0c9', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:06:47', 152, 0, '', '2019-05-26 12:06:47');
INSERT INTO `access_log` VALUES (8579, '4e994089-7899-484b-ab4e-4d49664a8e95', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:07:03', 183, 0, '', '2019-05-26 12:07:03');
INSERT INTO `access_log` VALUES (8580, '6aabb71b-1e68-4d63-a1b4-70a208c79266', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:07:05', 334, 0, '', '2019-05-26 12:07:05');
INSERT INTO `access_log` VALUES (8581, 'b097f7ad-77b2-40ae-9874-bb987460e1c6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:16:56', 1703, 0, '', '2019-05-26 12:16:58');
INSERT INTO `access_log` VALUES (8582, '3453ad62-395a-414b-9019-fb59b46c0fe3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:16:56', 1721, 0, '', '2019-05-26 12:16:58');
INSERT INTO `access_log` VALUES (8583, '887fa987-10ea-4321-9698-16242929fb9a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:16:56', 1735, 0, '', '2019-05-26 12:16:58');
INSERT INTO `access_log` VALUES (8584, '2835a4ab-b2dd-4756-831a-8a165640c663', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:16:56', 1899, 0, '', '2019-05-26 12:16:58');
INSERT INTO `access_log` VALUES (8585, '5ba5850a-3776-4b7d-81cd-316c704d9b67', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:17:59', 169, 0, '', '2019-05-26 12:17:59');
INSERT INTO `access_log` VALUES (8586, '4d2b3719-28c4-497d-a7c4-0189556cef6b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:17:59', 169, 0, '', '2019-05-26 12:17:59');
INSERT INTO `access_log` VALUES (8587, 'd5b8ce33-3654-4f77-a103-fecdff5abeab', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:18:00', 136, 0, '', '2019-05-26 12:18:00');
INSERT INTO `access_log` VALUES (8588, 'c6fbd0d7-a4f7-4740-a0af-c81ee2bc3745', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:18:35', 142, 0, '', '2019-05-26 12:18:35');
INSERT INTO `access_log` VALUES (8589, 'e060f693-1efe-461e-b7e8-648ec2752838', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:18:35', 138, 0, '', '2019-05-26 12:18:35');
INSERT INTO `access_log` VALUES (8590, 'a3bdee6a-2c7f-464c-b1aa-6385f501727c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:18:35', 188, 0, '', '2019-05-26 12:18:35');
INSERT INTO `access_log` VALUES (8591, 'bf3badf6-89fb-43d8-af68-0bc3404bf2c2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:18:39', 138, 0, '', '2019-05-26 12:18:39');
INSERT INTO `access_log` VALUES (8592, 'dac30ebc-100d-4cca-a5bb-4e6f6ca1f51d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:18:39', 134, 0, '', '2019-05-26 12:18:39');
INSERT INTO `access_log` VALUES (8593, '9a616df5-7f37-43e8-bcb2-dfbb1f7f2d64', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:18:39', 152, 0, '', '2019-05-26 12:18:39');
INSERT INTO `access_log` VALUES (8594, '87043e7f-639a-4f86-841f-1afac239dfdd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:19:16', 141, 0, '', '2019-05-26 12:19:16');
INSERT INTO `access_log` VALUES (8595, '4a44eb54-c58a-4c52-a746-b146f3e05a1f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:19:16', 142, 0, '', '2019-05-26 12:19:16');
INSERT INTO `access_log` VALUES (8596, '60575861-0027-4eac-940c-93960bf09f92', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:19:16', 157, 0, '', '2019-05-26 12:19:16');
INSERT INTO `access_log` VALUES (8597, '3e0d3031-c215-4b60-9ade-8aaf87346a2b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:21:14', 161, 0, '', '2019-05-26 12:21:15');
INSERT INTO `access_log` VALUES (8598, '6fda516c-b7b9-41a0-aed1-fafd5b1f7872', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:21:14', 164, 0, '', '2019-05-26 12:21:15');
INSERT INTO `access_log` VALUES (8599, '1a577846-ab23-49e5-9af2-430fb489d7d0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:21:14', 197, 0, '', '2019-05-26 12:21:15');
INSERT INTO `access_log` VALUES (8600, 'b5933fd2-73b7-4c8d-b7df-2a5159d64559', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:21:26', 163, 0, '', '2019-05-26 12:21:27');
INSERT INTO `access_log` VALUES (8601, '73bad641-11f7-4efb-ae03-60953ab81b7d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:21:26', 163, 0, '', '2019-05-26 12:21:27');
INSERT INTO `access_log` VALUES (8602, '22bbb636-dfa1-4e74-8b7e-e955ed87dbdf', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:21:26', 198, 0, '', '2019-05-26 12:21:27');
INSERT INTO `access_log` VALUES (8603, 'ac659cef-6f5c-43e7-a4c3-4bf65a8e8c71', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:21:28', 166, 0, '', '2019-05-26 12:21:29');
INSERT INTO `access_log` VALUES (8604, '783324df-d2be-4ca7-9b65-cb8b6a4a010b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:21:28', 160, 0, '', '2019-05-26 12:21:29');
INSERT INTO `access_log` VALUES (8605, 'f99fd8a5-d299-4021-8ff5-632297b1cb0a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:21:28', 192, 0, '', '2019-05-26 12:21:29');
INSERT INTO `access_log` VALUES (8606, '893a698c-653e-4edd-aa88-3fdd8714a70f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:22:59', 197, 0, '', '2019-05-26 12:22:59');
INSERT INTO `access_log` VALUES (8607, '93f7f1d1-a51b-44f4-b77a-919c7fa608f0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:22:59', 229, 0, '', '2019-05-26 12:22:59');
INSERT INTO `access_log` VALUES (8608, '53fc9c95-cf6e-48bf-b230-572a8487b5ca', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:23:00', 612, 2001001000, '服务端发生异常', '2019-05-26 12:23:00');
INSERT INTO `access_log` VALUES (8609, '1faa6621-09a6-4d58-9849-e8d0299c7cf8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:23:01', 224, 0, '', '2019-05-26 12:23:01');
INSERT INTO `access_log` VALUES (8610, '7b653b20-7d61-4ade-8a15-befd588408b8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:23:01', 258, 0, '', '2019-05-26 12:23:02');
INSERT INTO `access_log` VALUES (8611, '2ce01d21-13ed-4a51-8343-194f3911f47c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:23:01', 423, 0, '', '2019-05-26 12:23:02');
INSERT INTO `access_log` VALUES (8612, '049e40a8-17c8-4a65-8c0e-c72c867d3f10', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:28', 413, 0, '', '2019-05-26 12:24:28');
INSERT INTO `access_log` VALUES (8613, '58eb0c4e-855f-49aa-8864-f23d71a9fcda', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:28', 495, 0, '', '2019-05-26 12:24:29');
INSERT INTO `access_log` VALUES (8614, '687ad267-26df-4f27-90f1-ce8df45c8274', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:28', 497, 0, '', '2019-05-26 12:24:29');
INSERT INTO `access_log` VALUES (8615, '99da1d4b-c66f-4a25-83d2-42fb95ea0369', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:29', 133, 0, '', '2019-05-26 12:24:29');
INSERT INTO `access_log` VALUES (8616, 'f7411486-415a-4554-a0e6-dfea4bd5bf37', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:29', 134, 0, '', '2019-05-26 12:24:29');
INSERT INTO `access_log` VALUES (8617, '516d1fa3-1c84-4fdc-8819-6cf78ac7b638', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:29', 151, 0, '', '2019-05-26 12:24:29');
INSERT INTO `access_log` VALUES (8618, '6187a678-77a7-4fab-95cf-3f69cb5462df', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:37', 135, 0, '', '2019-05-26 12:24:37');
INSERT INTO `access_log` VALUES (8619, 'a74fd254-bd50-429d-93c8-68ad211e8c65', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:37', 135, 0, '', '2019-05-26 12:24:37');
INSERT INTO `access_log` VALUES (8620, 'a3d67323-426a-4ecd-a82c-f643247f5251', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:37', 137, 0, '', '2019-05-26 12:24:37');
INSERT INTO `access_log` VALUES (8621, '970303c2-781e-4704-b4c2-0b73187ee36b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:39', 197, 0, '', '2019-05-26 12:24:39');
INSERT INTO `access_log` VALUES (8622, '20286c81-1925-4b9a-9a01-888043f071f7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:39', 193, 0, '', '2019-05-26 12:24:39');
INSERT INTO `access_log` VALUES (8623, '57c7c383-7151-48a2-8d3c-301f0489b48d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:39', 206, 0, '', '2019-05-26 12:24:39');
INSERT INTO `access_log` VALUES (8624, '84df3fb8-8e62-4628-a0be-ada69e30f786', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:58', 141, 0, '', '2019-05-26 12:24:58');
INSERT INTO `access_log` VALUES (8625, '8a65f0ee-fa6e-4b41-847d-1007646a2063', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:58', 139, 0, '', '2019-05-26 12:24:58');
INSERT INTO `access_log` VALUES (8626, '761108f7-1946-4efa-a00a-a7b67d6cb8cb', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:24:58', 146, 0, '', '2019-05-26 12:24:58');
INSERT INTO `access_log` VALUES (8627, 'd75fcbaa-9180-4902-b4e9-7596f86fa956', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:25:00', 2114, 0, '', '2019-05-26 12:25:02');
INSERT INTO `access_log` VALUES (8628, '3b3e10ba-eca7-4a99-bfb4-831e2df6137b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:25:00', 2114, 0, '', '2019-05-26 12:25:02');
INSERT INTO `access_log` VALUES (8629, '01e89e67-e433-470f-ad55-9db86d31d267', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:25:00', 2857, 0, '', '2019-05-26 12:25:03');
INSERT INTO `access_log` VALUES (8630, 'aa2c16bb-7b65-4d3a-aff4-1898f7e2c53a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:25:04', 127, 0, '', '2019-05-26 12:25:04');
INSERT INTO `access_log` VALUES (8631, 'f548c90e-2219-4aa7-9f39-921ebd819c2d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:25:04', 133, 0, '', '2019-05-26 12:25:04');
INSERT INTO `access_log` VALUES (8632, '576d0fe1-b3a0-495b-8c2e-3b194070d4c0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:25:04', 144, 0, '', '2019-05-26 12:25:04');
INSERT INTO `access_log` VALUES (8633, '34a5eb4a-04d6-4d68-a82f-a0856adebb6a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:25:06', 131, 0, '', '2019-05-26 12:25:06');
INSERT INTO `access_log` VALUES (8634, 'd52e2832-8755-4659-9037-2b07f92897b7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:25:06', 131, 0, '', '2019-05-26 12:25:06');
INSERT INTO `access_log` VALUES (8635, 'e3988b0e-dbd9-4fee-b5bf-c9bcae9d8313', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:25:06', 139, 0, '', '2019-05-26 12:25:06');
INSERT INTO `access_log` VALUES (8636, '74c9cbd0-ae7f-498c-89f8-40ac2628d66b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:25:41', 140, 0, '', '2019-05-26 12:25:41');
INSERT INTO `access_log` VALUES (8637, '630bd640-6a35-4701-9ec8-189f1cdfb5d0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:25:41', 132, 0, '', '2019-05-26 12:25:41');
INSERT INTO `access_log` VALUES (8638, 'a3ca7261-00d7-4ab7-8da1-ff58e47f1b22', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:25:41', 150, 0, '', '2019-05-26 12:25:41');
INSERT INTO `access_log` VALUES (8639, '1e10a569-207f-45d0-91e2-1333fe737f01', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:26:05', 132, 0, '', '2019-05-26 12:26:05');
INSERT INTO `access_log` VALUES (8640, 'b612e6a7-3c1b-48b3-b607-d44382ca7fac', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:26:05', 132, 0, '', '2019-05-26 12:26:05');
INSERT INTO `access_log` VALUES (8641, '5d2e1b57-a784-435f-aa57-5a0c4abffdfc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:26:05', 139, 0, '', '2019-05-26 12:26:05');
INSERT INTO `access_log` VALUES (8642, '59.79.15588463256886565', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.226.88.209', '2019-05-26 12:52:06', 15, 0, '', '2019-05-26 12:52:06');
INSERT INTO `access_log` VALUES (8643, '59.78.15588463256896571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.226.88.209', '2019-05-26 12:52:06', 17, 2001001000, '服务端发生异常', '2019-05-26 12:52:06');
INSERT INTO `access_log` VALUES (8644, '64.77.15588463367275813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.226.88.209', '2019-05-26 12:52:17', 12, 0, '', '2019-05-26 12:52:17');
INSERT INTO `access_log` VALUES (8645, '64.76.15588463368365811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.226.88.209', '2019-05-26 12:52:17', 3, 0, '', '2019-05-26 12:52:17');
INSERT INTO `access_log` VALUES (8646, '64.79.15588463383535807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.226.88.209', '2019-05-26 12:52:18', 3, 0, '', '2019-05-26 12:52:18');
INSERT INTO `access_log` VALUES (8647, '64.80.15588463389865805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.226.88.209', '2019-05-26 12:52:19', 3, 0, '', '2019-05-26 12:52:19');
INSERT INTO `access_log` VALUES (8648, '59.77.15588463570276569', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.226.88.209', '2019-05-26 12:52:37', 8, 0, '', '2019-05-26 12:52:37');
INSERT INTO `access_log` VALUES (8649, '59.71.15588463570276569', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.226.88.209', '2019-05-26 12:52:37', 16, 2001001000, '服务端发生异常', '2019-05-26 12:52:37');
INSERT INTO `access_log` VALUES (8650, '64.85.15588463618335811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.226.88.209', '2019-05-26 12:52:42', 3, 0, '', '2019-05-26 12:52:42');
INSERT INTO `access_log` VALUES (8651, '64.82.15588463619385813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.226.88.209', '2019-05-26 12:52:42', 3, 0, '', '2019-05-26 12:52:42');
INSERT INTO `access_log` VALUES (8652, '59.79.15588464018326567', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.226.88.209', '2019-05-26 12:53:22', 7, 0, '', '2019-05-26 12:53:22');
INSERT INTO `access_log` VALUES (8653, '59.72.15588464018326565', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.226.88.209', '2019-05-26 12:53:22', 15, 2001001000, '服务端发生异常', '2019-05-26 12:53:22');
INSERT INTO `access_log` VALUES (8654, '64.79.15588489945685843', 0, 2, 'product-application', '/product-api/admins/attr/add', 'name=颜色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '116.22.53.7', '2019-05-26 13:36:35', 0, 1002001015, '账号未登陆', '2019-05-26 13:36:35');
INSERT INTO `access_log` VALUES (8655, 'cec34be7-4fc4-41d0-a2e0-f109f7d803ec', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 13:59:42', 708, 1002001012, '访问令牌已过期', '2019-05-26 13:59:42');
INSERT INTO `access_log` VALUES (8656, 'df4a3cba-8699-44ce-8b59-d5d5068f6733', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 13:59:41', 715, 1002001012, '访问令牌已过期', '2019-05-26 13:59:42');
INSERT INTO `access_log` VALUES (8657, '94c69423-8733-44f8-9ee4-a84e0da74bb2', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 13:59:42', 739, 1002001012, '访问令牌已过期', '2019-05-26 13:59:42');
INSERT INTO `access_log` VALUES (8658, 'aed1fd1f-e257-4ca9-8593-55f2bf2e4634', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:02:44', 776, 0, '', '2019-05-26 14:02:44');
INSERT INTO `access_log` VALUES (8659, 'b3f3b10a-f8fc-41e7-95a2-af5ccd8cef63', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:02:45', 413, 0, '', '2019-05-26 14:02:45');
INSERT INTO `access_log` VALUES (8660, '36d89e04-6e07-4e5a-98f9-5ca297710204', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:02:45', 428, 0, '', '2019-05-26 14:02:45');
INSERT INTO `access_log` VALUES (8661, '964a9e77-d759-41f7-be0a-c8c352effe56', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:02:45', 460, 0, '', '2019-05-26 14:02:45');
INSERT INTO `access_log` VALUES (8662, '890a3d19-f0bd-45ef-8f8f-8ec45b956227', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:02:50', 155, 0, '', '2019-05-26 14:02:50');
INSERT INTO `access_log` VALUES (8663, '9ffebbe7-de3f-40e4-bd5d-cd73f83b983b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:02:50', 159, 0, '', '2019-05-26 14:02:50');
INSERT INTO `access_log` VALUES (8664, '5540571f-99a8-4879-985c-787a99521450', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:02:50', 170, 0, '', '2019-05-26 14:02:50');
INSERT INTO `access_log` VALUES (8665, '994373c8-86e2-41e9-b5f3-94ba42690aed', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:14', 148, 0, '', '2019-05-26 14:03:14');
INSERT INTO `access_log` VALUES (8666, 'e8edb7a7-a353-4148-8652-01b88a11eda6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:14', 150, 0, '', '2019-05-26 14:03:14');
INSERT INTO `access_log` VALUES (8667, 'c7ce1e7f-bc53-4ec6-9712-7710cd85b175', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:14', 324, 2001001000, '服务端发生异常', '2019-05-26 14:03:14');
INSERT INTO `access_log` VALUES (8668, 'ca18388d-11de-4753-9d0b-1594fa804bb9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:15', 150, 0, '', '2019-05-26 14:03:15');
INSERT INTO `access_log` VALUES (8669, 'b9c9c97f-dcfb-4fc9-92fe-ab6ffc74de5d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:15', 155, 0, '', '2019-05-26 14:03:15');
INSERT INTO `access_log` VALUES (8670, '647d3996-92ca-494b-a94d-3f69dbabea35', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:15', 152, 0, '', '2019-05-26 14:03:15');
INSERT INTO `access_log` VALUES (8671, '3d6c909b-a167-4912-92a4-637a4b469841', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:20', 151, 0, '', '2019-05-26 14:03:21');
INSERT INTO `access_log` VALUES (8672, 'cd904a95-1ab3-4647-b95b-1aa629abc5ae', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:20', 166, 0, '', '2019-05-26 14:03:21');
INSERT INTO `access_log` VALUES (8673, '2d0bf021-f299-4868-ad3d-0dbe433c500c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:20', 163, 0, '', '2019-05-26 14:03:21');
INSERT INTO `access_log` VALUES (8674, '9a59279b-2570-4a66-958b-36a450430d15', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:53', 156, 0, '', '2019-05-26 14:03:53');
INSERT INTO `access_log` VALUES (8675, 'feea29c8-e730-420e-bb14-1d4aff8a58b4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:53', 165, 0, '', '2019-05-26 14:03:53');
INSERT INTO `access_log` VALUES (8676, 'e2150a3b-0069-4ef3-8356-4b80bbfe7ac3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:53', 175, 0, '', '2019-05-26 14:03:53');
INSERT INTO `access_log` VALUES (8677, '14ae2988-6721-4d3b-adfa-118c06fe80f0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:57', 228, 0, '', '2019-05-26 14:03:58');
INSERT INTO `access_log` VALUES (8678, '2a586df6-c9f5-4fb1-ab13-a97a04414d57', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:57', 230, 0, '', '2019-05-26 14:03:58');
INSERT INTO `access_log` VALUES (8679, 'a31d45de-6897-4ea4-b565-94ab2809b62b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:57', 227, 0, '', '2019-05-26 14:03:58');
INSERT INTO `access_log` VALUES (8680, '0b6e918e-7de1-4a68-9da3-64eeaaa09c16', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:04:27', 144, 0, '', '2019-05-26 14:04:27');
INSERT INTO `access_log` VALUES (8681, 'cc1feead-4ba2-495f-b5d0-3d6a7530bf12', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:04:27', 143, 0, '', '2019-05-26 14:04:27');
INSERT INTO `access_log` VALUES (8682, '553165ef-e7e6-4e3d-b6cf-246a0b7682b8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:04:27', 149, 0, '', '2019-05-26 14:04:27');
INSERT INTO `access_log` VALUES (8683, '7304574c-e91c-4040-8f85-85b0528c77b8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:04:38', 145, 0, '', '2019-05-26 14:04:38');
INSERT INTO `access_log` VALUES (8684, 'd60455de-d302-4751-b9b7-0172d2e97143', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:04:38', 146, 0, '', '2019-05-26 14:04:38');
INSERT INTO `access_log` VALUES (8685, 'ccc7743a-4432-4d61-8c68-def23af9b2ea', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:04:38', 145, 0, '', '2019-05-26 14:04:38');
INSERT INTO `access_log` VALUES (8686, '1946ed56-edcf-4e88-b304-5ac916c9fd1d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:04:43', 182, 0, '', '2019-05-26 14:04:43');
INSERT INTO `access_log` VALUES (8687, '9d807ab9-bb99-4f3d-a249-9800f89f218a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:04:43', 175, 0, '', '2019-05-26 14:04:43');
INSERT INTO `access_log` VALUES (8688, 'f81e72cb-d250-4fe4-b6f4-075d4e5d7647', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:04:43', 171, 0, '', '2019-05-26 14:04:43');
INSERT INTO `access_log` VALUES (8689, '0b50e1ca-dc3b-484d-8547-a6ca647a2ab2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:06:14', 179, 0, '', '2019-05-26 14:06:14');
INSERT INTO `access_log` VALUES (8690, '0e6f0686-b0a3-48d4-bf09-34fb43294523', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:06:14', 177, 0, '', '2019-05-26 14:06:14');
INSERT INTO `access_log` VALUES (8691, '4409a2e0-4a7f-4e47-9373-f396195c1f52', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:06:14', 183, 0, '', '2019-05-26 14:06:14');
INSERT INTO `access_log` VALUES (8692, '6ded37b6-a9f7-4cf8-ae7f-a67463148cd9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:06:18', 869, 0, '', '2019-05-26 14:06:19');
INSERT INTO `access_log` VALUES (8693, '0ef4230a-faac-46ab-bdaf-2679a1ac62fd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:06:18', 902, 0, '', '2019-05-26 14:06:19');
INSERT INTO `access_log` VALUES (8694, '5c4d2573-6afd-4b7b-b0aa-997233b5126c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:06:18', 902, 0, '', '2019-05-26 14:06:19');
INSERT INTO `access_log` VALUES (8695, '8708a089-09bf-43cc-a88c-bb452f5d3b0c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:06:20', 143, 0, '', '2019-05-26 14:06:20');
INSERT INTO `access_log` VALUES (8696, '7a80579a-b900-44e0-9c4c-021fb2fe9aae', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:06:20', 142, 0, '', '2019-05-26 14:06:20');
INSERT INTO `access_log` VALUES (8697, 'f9e0f9c1-dff8-442b-8f35-d7c8ff4a1d1e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:06:20', 291, 2001001000, '服务端发生异常', '2019-05-26 14:06:20');
INSERT INTO `access_log` VALUES (8698, '5ef0701c-b838-4d28-9f12-da22c79b61d7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:06:21', 301, 0, '', '2019-05-26 14:06:22');
INSERT INTO `access_log` VALUES (8699, 'a49458d1-cc6e-4e35-b060-6e081947f47b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:06:21', 297, 0, '', '2019-05-26 14:06:22');
INSERT INTO `access_log` VALUES (8700, '1a078df9-2d08-4a07-b81d-970d37a0d367', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:06:21', 306, 0, '', '2019-05-26 14:06:22');
INSERT INTO `access_log` VALUES (8701, 'aa274ab9-8dae-4f10-9527-05da8ea6acf6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:07:28', 174, 0, '', '2019-05-26 14:07:28');
INSERT INTO `access_log` VALUES (8702, 'c4af1c12-b785-4c7a-883d-393204906eb0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:07:28', 174, 0, '', '2019-05-26 14:07:28');
INSERT INTO `access_log` VALUES (8703, 'dc2906eb-673d-479a-b6ba-14c35d3e3031', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:07:28', 180, 0, '', '2019-05-26 14:07:28');
INSERT INTO `access_log` VALUES (8704, 'c99b4e0a-6d93-4d3e-9294-9a1622dcce81', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:07:30', 174, 0, '', '2019-05-26 14:07:30');
INSERT INTO `access_log` VALUES (8705, 'aa49f2dd-8cf1-47fb-a035-fb1cfc6b1794', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:07:30', 170, 0, '', '2019-05-26 14:07:30');
INSERT INTO `access_log` VALUES (8706, 'ac0a802b-c7ad-4f5a-a399-6ab8e0309aab', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:07:30', 175, 0, '', '2019-05-26 14:07:30');
INSERT INTO `access_log` VALUES (8707, '0f13f545-af7c-44e6-87b5-415aa45a2cf1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:07:50', 146, 0, '', '2019-05-26 14:07:50');
INSERT INTO `access_log` VALUES (8708, '388eaea7-d60e-45b0-97a1-d81a5c303f2c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:07:50', 145, 0, '', '2019-05-26 14:07:50');
INSERT INTO `access_log` VALUES (8709, '815062e6-043b-4b38-8e27-14710590831e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:07:50', 143, 0, '', '2019-05-26 14:07:50');
INSERT INTO `access_log` VALUES (8710, 'ee348ead-205e-45f3-88ed-3ebd903acfa3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:07:52', 147, 0, '', '2019-05-26 14:07:52');
INSERT INTO `access_log` VALUES (8711, '6795132b-1cae-403d-9e36-96c914437c13', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:07:52', 142, 0, '', '2019-05-26 14:07:52');
INSERT INTO `access_log` VALUES (8712, '55f98371-a97f-4fad-b4ce-e68146f76632', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:07:52', 145, 0, '', '2019-05-26 14:07:52');
INSERT INTO `access_log` VALUES (8713, '826a9d26-c04f-4d74-9f4a-c527db329d51', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:08:03', 150, 0, '', '2019-05-26 14:08:03');
INSERT INTO `access_log` VALUES (8714, 'b3512c79-b3d9-4e8e-8a74-e69fa1f72970', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:08:03', 147, 0, '', '2019-05-26 14:08:03');
INSERT INTO `access_log` VALUES (8715, '378113e1-aa15-4ff7-9ae9-738bee172875', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:08:03', 150, 0, '', '2019-05-26 14:08:03');
INSERT INTO `access_log` VALUES (8716, '6cd270c5-2c66-4e4d-932b-749b7fcc6530', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:07', 185, 0, '', '2019-05-26 14:09:07');
INSERT INTO `access_log` VALUES (8717, 'faa1d24c-cd70-41e1-af00-aa0a54e74424', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:07', 183, 0, '', '2019-05-26 14:09:07');
INSERT INTO `access_log` VALUES (8718, 'c0df7d30-facc-49e3-ba63-8d2eb8299751', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:07', 183, 0, '', '2019-05-26 14:09:07');
INSERT INTO `access_log` VALUES (8719, 'de32063d-d5dc-4f6d-be3c-70f7283d314c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:10', 983, 0, '', '2019-05-26 14:09:11');
INSERT INTO `access_log` VALUES (8720, 'bb62aabd-efd4-485e-a21f-cd72233249a7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:10', 986, 0, '', '2019-05-26 14:09:11');
INSERT INTO `access_log` VALUES (8721, 'ffb70834-ad02-408b-9342-94524580ad1a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:10', 979, 0, '', '2019-05-26 14:09:11');
INSERT INTO `access_log` VALUES (8722, 'f818f7b3-02b0-494e-be27-501cb061f568', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:31', 409, 0, '', '2019-05-26 14:09:31');
INSERT INTO `access_log` VALUES (8723, 'c2396ebd-27ab-416f-9505-d2f6ecd22df8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:31', 411, 0, '', '2019-05-26 14:09:31');
INSERT INTO `access_log` VALUES (8724, '1a835ace-539b-4ee8-9ac0-8fc256350369', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:31', 411, 0, '', '2019-05-26 14:09:31');
INSERT INTO `access_log` VALUES (8725, '1bba5b58-487e-4cea-b8e1-939d8754519a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:44', 144, 0, '', '2019-05-26 14:09:44');
INSERT INTO `access_log` VALUES (8726, '7b452948-654b-477d-8abc-7fdd9e2334ef', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:44', 146, 0, '', '2019-05-26 14:09:44');
INSERT INTO `access_log` VALUES (8727, '6fa49974-a2a2-4ad6-9cd0-0721ef6c1728', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:44', 349, 2001001000, '服务端发生异常', '2019-05-26 14:09:44');
INSERT INTO `access_log` VALUES (8728, '20868b4b-d5e7-4508-b423-7aa633a9968c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:45', 147, 0, '', '2019-05-26 14:09:46');
INSERT INTO `access_log` VALUES (8729, '45a24c53-a60c-4962-ac0a-79008f9d4042', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:45', 143, 0, '', '2019-05-26 14:09:46');
INSERT INTO `access_log` VALUES (8730, 'a8f528c6-4d15-4891-85ac-856f0a10307b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:45', 146, 0, '', '2019-05-26 14:09:46');
INSERT INTO `access_log` VALUES (8731, 'c272a4aa-ffea-42b2-9294-b70cef947bc4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:00', 145, 0, '', '2019-05-26 14:10:00');
INSERT INTO `access_log` VALUES (8732, 'f298c86d-a852-4d1c-bc83-ccec739eef01', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:00', 146, 0, '', '2019-05-26 14:10:00');
INSERT INTO `access_log` VALUES (8733, '096c6227-957c-4c99-ad3c-f7f34b61e8c3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:00', 147, 0, '', '2019-05-26 14:10:00');
INSERT INTO `access_log` VALUES (8734, '129a219b-ac1c-45e2-8652-ad462e8f8228', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:02', 144, 0, '', '2019-05-26 14:10:02');
INSERT INTO `access_log` VALUES (8735, '942635b1-df5a-4f5b-a865-4c771d646366', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:02', 142, 0, '', '2019-05-26 14:10:02');
INSERT INTO `access_log` VALUES (8736, '2b9fcfd3-a3fe-47a5-8553-27188cc831be', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:02', 143, 0, '', '2019-05-26 14:10:02');
INSERT INTO `access_log` VALUES (8737, '0e346a87-cc51-4f26-b261-6848e5d0b917', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:37', 153, 0, '', '2019-05-26 14:10:37');
INSERT INTO `access_log` VALUES (8738, '6e0eb4e1-caea-49a2-a45e-b1ab7fca361f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:37', 152, 0, '', '2019-05-26 14:10:37');
INSERT INTO `access_log` VALUES (8739, '50de662a-568a-4321-a89b-98cc0262a24e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:37', 151, 0, '', '2019-05-26 14:10:37');
INSERT INTO `access_log` VALUES (8740, 'df09db36-19fa-418b-a838-bb508070ad06', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:41', 144, 0, '', '2019-05-26 14:10:41');
INSERT INTO `access_log` VALUES (8741, '1190f34d-5099-4cc4-b4ce-a07cca7eea41', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:41', 146, 0, '', '2019-05-26 14:10:41');
INSERT INTO `access_log` VALUES (8742, 'ebb28a9b-9a83-40c3-9206-29a0e30aaab4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:41', 149, 0, '', '2019-05-26 14:10:41');
INSERT INTO `access_log` VALUES (8743, '6827261e-c511-476d-b925-f6cb6675563c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:52', 151, 0, '', '2019-05-26 14:10:52');
INSERT INTO `access_log` VALUES (8744, '3543c76f-6248-4b76-8fd9-bf1c7d0cc8ab', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:52', 151, 0, '', '2019-05-26 14:10:52');
INSERT INTO `access_log` VALUES (8745, '8b48426a-699e-46f8-8d7a-0efee0d8bb8d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:52', 151, 0, '', '2019-05-26 14:10:52');
INSERT INTO `access_log` VALUES (8746, '7694aaf6-12d1-49d1-828a-d8213be74dae', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:58', 146, 0, '', '2019-05-26 14:10:58');
INSERT INTO `access_log` VALUES (8747, '8aa64007-0291-4959-a36c-6549a7954053', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:58', 146, 0, '', '2019-05-26 14:10:58');
INSERT INTO `access_log` VALUES (8748, 'f5bf0f24-53b2-4450-8337-fda07b7c2637', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:10:58', 149, 0, '', '2019-05-26 14:10:58');
INSERT INTO `access_log` VALUES (8749, '8329fb07-0065-4038-a82e-50518db12046', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:11:08', 536, 0, '', '2019-05-26 14:11:09');
INSERT INTO `access_log` VALUES (8750, '4884e2ca-d48e-491f-9ee1-8ed974fe89b2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:11:08', 537, 0, '', '2019-05-26 14:11:09');
INSERT INTO `access_log` VALUES (8751, 'a0172507-3678-42e3-8706-f020a414b543', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:11:08', 537, 0, '', '2019-05-26 14:11:09');
INSERT INTO `access_log` VALUES (8752, '5686844d-bb8d-418e-afac-4a0535219bbf', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:11:11', 144, 0, '', '2019-05-26 14:11:11');
INSERT INTO `access_log` VALUES (8753, 'bc213b87-1c18-4a1d-b63d-eb1183b900f3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:11:11', 149, 0, '', '2019-05-26 14:11:11');
INSERT INTO `access_log` VALUES (8754, 'b8160339-bf48-4936-9024-8169b28e1739', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:11:11', 146, 0, '', '2019-05-26 14:11:11');
INSERT INTO `access_log` VALUES (8755, '3c17e5f1-24f0-4649-8e03-538d563a4074', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:11:13', 142, 0, '', '2019-05-26 14:11:13');
INSERT INTO `access_log` VALUES (8756, 'dc481ae5-b3fe-4bc1-a093-45bb0b4ccfe8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:11:13', 149, 0, '', '2019-05-26 14:11:13');
INSERT INTO `access_log` VALUES (8757, 'b2d184aa-80df-4731-badb-eba0acd229b1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:11:13', 144, 0, '', '2019-05-26 14:11:13');
INSERT INTO `access_log` VALUES (8758, '1e6d988a-5c43-46a2-a427-7c15825d6909', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:11:53', 142, 0, '', '2019-05-26 14:11:53');
INSERT INTO `access_log` VALUES (8759, '03eb7643-cfc6-47f2-b773-2dd826c50b87', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:11:53', 141, 0, '', '2019-05-26 14:11:53');
INSERT INTO `access_log` VALUES (8760, '827ed155-1d3a-4775-b328-2578a1d398be', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:11:53', 144, 0, '', '2019-05-26 14:11:53');
INSERT INTO `access_log` VALUES (8761, '705e6e2b-7de6-4b27-a322-d63fd178d670', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:12:05', 145, 0, '', '2019-05-26 14:12:05');
INSERT INTO `access_log` VALUES (8762, 'f78dc33a-51a6-4d68-9c93-40129ffbb933', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:12:05', 153, 0, '', '2019-05-26 14:12:05');
INSERT INTO `access_log` VALUES (8763, '1616af41-f10e-42d1-a453-ef3354fa13ec', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:12:05', 155, 0, '', '2019-05-26 14:12:05');
INSERT INTO `access_log` VALUES (8764, '02d5001f-54fa-4376-936d-76bc252238d0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:12:23', 144, 0, '', '2019-05-26 14:12:23');
INSERT INTO `access_log` VALUES (8765, 'b1cd3c1e-5089-4955-96bd-7025cdd96970', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:12:23', 145, 0, '', '2019-05-26 14:12:23');
INSERT INTO `access_log` VALUES (8766, 'ea8bfcb3-35f6-44f8-89de-0b48b6f72d11', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:12:23', 142, 0, '', '2019-05-26 14:12:23');
INSERT INTO `access_log` VALUES (8767, '8bfd0855-21cf-4201-b27f-d2c61f495caa', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:12:28', 143, 0, '', '2019-05-26 14:12:28');
INSERT INTO `access_log` VALUES (8768, 'a5490bbe-74be-4841-8bd7-14f2f0dfce89', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:12:28', 142, 0, '', '2019-05-26 14:12:28');
INSERT INTO `access_log` VALUES (8769, '8fbbeb78-2172-4335-a4f2-4529101c0bd1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:12:28', 144, 0, '', '2019-05-26 14:12:28');
INSERT INTO `access_log` VALUES (8770, 'e75a7631-bcd5-43bc-8607-de08ba2574ce', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:12:36', 172, 0, '', '2019-05-26 14:12:36');
INSERT INTO `access_log` VALUES (8771, '357a5ad0-b4cc-440d-9841-bfaccdb992a9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:12:36', 167, 0, '', '2019-05-26 14:12:36');
INSERT INTO `access_log` VALUES (8772, 'dd5f299b-dd73-40f6-a00d-e5bdd48c27a2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:12:36', 172, 0, '', '2019-05-26 14:12:36');
INSERT INTO `access_log` VALUES (8773, 'e76dce56-0d21-4c77-89ce-8954eda1039d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:13:25', 144, 0, '', '2019-05-26 14:13:26');
INSERT INTO `access_log` VALUES (8774, '7aceb709-f805-4ab3-8dc8-d1192c195de7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:13:25', 144, 0, '', '2019-05-26 14:13:26');
INSERT INTO `access_log` VALUES (8775, '06bcbf70-6cd0-4cc0-991e-bd615bbf5f76', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:13:26', 235, 0, '', '2019-05-26 14:13:26');
INSERT INTO `access_log` VALUES (8776, '1587ddaf-7ace-4e23-8b24-3f66edd228a2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:13:48', 141, 0, '', '2019-05-26 14:13:48');
INSERT INTO `access_log` VALUES (8777, '05d1b634-8e0c-485f-98d2-afdd8ac9b004', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:13:48', 143, 0, '', '2019-05-26 14:13:48');
INSERT INTO `access_log` VALUES (8778, '58014f02-61b6-474a-bc63-b12a23ed8f8c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:13:48', 171, 0, '', '2019-05-26 14:13:48');
INSERT INTO `access_log` VALUES (8779, '96589530-f054-42dd-80d2-b6a9f90f328d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:15:19', 176, 0, '', '2019-05-26 14:15:19');
INSERT INTO `access_log` VALUES (8780, '29b7fd06-52a3-44b5-8636-d13f488bf0b9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:15:19', 177, 0, '', '2019-05-26 14:15:19');
INSERT INTO `access_log` VALUES (8781, '0ea0a373-59fb-4b91-be45-47bdff97a2a2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:15:19', 171, 0, '', '2019-05-26 14:15:19');
INSERT INTO `access_log` VALUES (8782, 'dd6ebb63-3e78-4c9b-9fda-2dd7c6b27c5f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:15:22', 156, 0, '', '2019-05-26 14:15:23');
INSERT INTO `access_log` VALUES (8783, 'b22c7c92-1daa-447d-b03d-ad9fa94dd2a7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:15:22', 160, 0, '', '2019-05-26 14:15:23');
INSERT INTO `access_log` VALUES (8784, '20b3e82b-e791-4573-af14-55f3447f5fc9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:15:22', 145, 0, '', '2019-05-26 14:15:23');
INSERT INTO `access_log` VALUES (8785, 'c8cdfef5-e686-49fb-9219-509cb6c689c9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:15:33', 221, 0, '', '2019-05-26 14:15:33');
INSERT INTO `access_log` VALUES (8786, '10d3d9bd-5454-461e-bf2e-9158de4c2502', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:15:33', 222, 0, '', '2019-05-26 14:15:33');
INSERT INTO `access_log` VALUES (8787, 'da09fbbf-5821-4071-aa2b-8920c1aec711', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:15:33', 222, 0, '', '2019-05-26 14:15:33');
INSERT INTO `access_log` VALUES (8788, 'dbbbb935-0073-4bd4-947c-c6b687d51e38', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:17', 144, 0, '', '2019-05-26 14:16:17');
INSERT INTO `access_log` VALUES (8789, '4c28d0dc-f8a7-423a-8614-2c42183e0fd9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:17', 145, 0, '', '2019-05-26 14:16:17');
INSERT INTO `access_log` VALUES (8790, '2edf2351-2609-41a0-b4de-f9b9bab570ba', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:17', 149, 0, '', '2019-05-26 14:16:17');
INSERT INTO `access_log` VALUES (8791, '232ff6bf-67e4-4a6f-9a3e-68bcdabbd2f4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:18', 144, 0, '', '2019-05-26 14:16:18');
INSERT INTO `access_log` VALUES (8792, '483da2b8-c36d-44d9-ae3c-a69f84483961', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:18', 144, 0, '', '2019-05-26 14:16:18');
INSERT INTO `access_log` VALUES (8793, '68b1db4c-e0d7-487e-8495-373ce6bc6eb7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:18', 139, 0, '', '2019-05-26 14:16:18');
INSERT INTO `access_log` VALUES (8794, 'a0e3c87f-91df-4f64-8ee9-6d3f40d19bdd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:23', 140, 0, '', '2019-05-26 14:16:23');
INSERT INTO `access_log` VALUES (8795, '94426299-b294-4f52-a458-f8a1418d3698', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:23', 142, 0, '', '2019-05-26 14:16:23');
INSERT INTO `access_log` VALUES (8796, 'a16d681b-452a-4038-9182-9d368ed6b476', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:23', 146, 0, '', '2019-05-26 14:16:23');
INSERT INTO `access_log` VALUES (8797, '3428fff7-298e-4883-b0ac-a00507a779e9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:25', 139, 0, '', '2019-05-26 14:16:25');
INSERT INTO `access_log` VALUES (8798, '18ee82a2-5223-4198-95fc-3d425c5fd8ed', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:25', 145, 0, '', '2019-05-26 14:16:25');
INSERT INTO `access_log` VALUES (8799, 'c59c988b-78a0-4573-a904-5c1bc6f025fa', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:25', 143, 0, '', '2019-05-26 14:16:25');
INSERT INTO `access_log` VALUES (8800, 'da4ac983-e1ec-4927-a943-a0191e091aea', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:45', 144, 0, '', '2019-05-26 14:16:45');
INSERT INTO `access_log` VALUES (8801, 'cf2bef2d-9743-4388-9bf6-39cabcd42756', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:45', 144, 0, '', '2019-05-26 14:16:45');
INSERT INTO `access_log` VALUES (8802, '4d069e04-4ee0-4d37-83a8-b4b9be1d0973', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:45', 144, 0, '', '2019-05-26 14:16:45');
INSERT INTO `access_log` VALUES (8803, 'cc686b52-ded9-47ea-82d6-0f3cc57cbdaa', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:58', 181, 0, '', '2019-05-26 14:16:58');
INSERT INTO `access_log` VALUES (8804, '27b7bd2a-0a04-44e1-bf6c-6c632a468d42', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:58', 183, 0, '', '2019-05-26 14:16:58');
INSERT INTO `access_log` VALUES (8805, '47d5eaff-c4c6-4035-b431-05295781bfc2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:16:58', 183, 0, '', '2019-05-26 14:16:58');
INSERT INTO `access_log` VALUES (8806, 'ba7ca5f9-a5d7-4de3-8f82-0020497ed85d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:04', 139, 0, '', '2019-05-26 14:17:04');
INSERT INTO `access_log` VALUES (8807, '6eef61bf-4066-4d65-a784-96c7b1486d26', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:04', 140, 0, '', '2019-05-26 14:17:04');
INSERT INTO `access_log` VALUES (8808, '5bb8c5f1-095c-46a6-b6ef-ed33aa6db2af', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:04', 140, 0, '', '2019-05-26 14:17:04');
INSERT INTO `access_log` VALUES (8809, 'a81f844b-f982-494c-a871-2f73ee494bdd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:06', 146, 0, '', '2019-05-26 14:17:06');
INSERT INTO `access_log` VALUES (8810, '514039c8-8af4-451e-bce1-8ffeec382439', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:06', 144, 0, '', '2019-05-26 14:17:06');
INSERT INTO `access_log` VALUES (8811, 'd2d367f8-1360-4fd6-a4b4-4ecf99451ef3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:06', 142, 0, '', '2019-05-26 14:17:06');
INSERT INTO `access_log` VALUES (8812, '992f4b7a-038c-47d9-9832-2a43a34a847c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:21', 145, 0, '', '2019-05-26 14:17:21');
INSERT INTO `access_log` VALUES (8813, '181385b0-cdfb-430d-acf7-600c43d7bcfd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:21', 148, 0, '', '2019-05-26 14:17:21');
INSERT INTO `access_log` VALUES (8814, '503ad9a6-1294-44f0-b723-6875cefa7c42', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:21', 195, 0, '', '2019-05-26 14:17:21');
INSERT INTO `access_log` VALUES (8815, 'a6a78397-4872-4139-88d7-c256de23a26f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:42', 138, 0, '', '2019-05-26 14:17:42');
INSERT INTO `access_log` VALUES (8816, 'b7c9d639-3fe4-4fbb-9121-04ed8a3064dc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:42', 145, 0, '', '2019-05-26 14:17:42');
INSERT INTO `access_log` VALUES (8817, '925a0e5a-26f0-48f9-9b0e-38a3795801f7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:42', 147, 0, '', '2019-05-26 14:17:42');
INSERT INTO `access_log` VALUES (8818, 'e2d2f604-a72c-4abb-9a1d-f86c6ee41be5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:44', 140, 0, '', '2019-05-26 14:17:44');
INSERT INTO `access_log` VALUES (8819, 'a22d610f-e343-4c82-9403-81282ce97be7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:44', 140, 0, '', '2019-05-26 14:17:44');
INSERT INTO `access_log` VALUES (8820, '5dff6b85-3bc7-45bd-aa06-9ef8006f71f8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:17:44', 141, 0, '', '2019-05-26 14:17:44');
INSERT INTO `access_log` VALUES (8821, '016866e9-8afa-4db1-a130-e2d43b273c9e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:18:01', 142, 0, '', '2019-05-26 14:18:01');
INSERT INTO `access_log` VALUES (8822, 'fb07656e-cc01-4113-8feb-195177c1bd1d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:18:01', 143, 0, '', '2019-05-26 14:18:01');
INSERT INTO `access_log` VALUES (8823, 'd8fd5a66-7e71-4a5b-8edb-49fa4c1ed614', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:18:01', 146, 0, '', '2019-05-26 14:18:01');
INSERT INTO `access_log` VALUES (8824, 'fef3d0a1-cf09-43b5-994f-bda1d39ca82e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:18:07', 143, 0, '', '2019-05-26 14:18:07');
INSERT INTO `access_log` VALUES (8825, '67ac6399-058a-414c-8288-06a493f6e6ae', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:18:07', 144, 0, '', '2019-05-26 14:18:07');
INSERT INTO `access_log` VALUES (8826, '753e595d-5b75-47f2-a9da-7a051a0f0381', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:18:07', 138, 0, '', '2019-05-26 14:18:07');
INSERT INTO `access_log` VALUES (8827, '19218098-4257-4c80-8337-690725539e91', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:20:41', 635, 0, '', '2019-05-26 14:20:42');
INSERT INTO `access_log` VALUES (8828, 'b989fef1-e67f-414e-a363-bdcaa925e921', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:20:41', 666, 0, '', '2019-05-26 14:20:42');
INSERT INTO `access_log` VALUES (8829, 'b9ad7857-8ee6-4633-ae4f-b999576bdcf6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:20:41', 635, 0, '', '2019-05-26 14:20:42');
INSERT INTO `access_log` VALUES (8830, '034f3918-d331-409e-a4fb-55b8f8fff2a3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:21:02', 149, 0, '', '2019-05-26 14:21:02');
INSERT INTO `access_log` VALUES (8831, '019e06f0-f18c-4c53-9c85-d2eb1b81405f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:21:02', 158, 0, '', '2019-05-26 14:21:02');
INSERT INTO `access_log` VALUES (8832, '707a8c43-bc49-490b-a446-d1bf319fe5d9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:21:02', 153, 0, '', '2019-05-26 14:21:02');
INSERT INTO `access_log` VALUES (8833, '29550624-4ab5-48e3-8d72-dc775b51e04d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:21:08', 162, 0, '', '2019-05-26 14:21:08');
INSERT INTO `access_log` VALUES (8834, '732a002c-e1f0-4d11-8f26-f5497be05946', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:21:08', 159, 0, '', '2019-05-26 14:21:08');
INSERT INTO `access_log` VALUES (8835, '9a7f6c45-8668-430f-a41f-0f38ce4b3196', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:21:08', 164, 0, '', '2019-05-26 14:21:08');
INSERT INTO `access_log` VALUES (8836, 'c06817a8-8bfb-4482-af72-4a190c61e7d4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:21:21', 154, 0, '', '2019-05-26 14:21:21');
INSERT INTO `access_log` VALUES (8837, '12cbc86a-d184-41e1-8e25-460c4bf85092', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:21:21', 162, 0, '', '2019-05-26 14:21:21');
INSERT INTO `access_log` VALUES (8838, '809983d6-f140-4f42-a207-375930628f8e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:21:21', 160, 0, '', '2019-05-26 14:21:21');
INSERT INTO `access_log` VALUES (8839, 'dd7a14af-25a7-4874-8637-d23ccae3abd1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:22:20', 328, 0, '', '2019-05-26 14:22:20');
INSERT INTO `access_log` VALUES (8840, 'fee8829c-7ab7-4529-ac4d-e038d847726e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:22:20', 330, 0, '', '2019-05-26 14:22:20');
INSERT INTO `access_log` VALUES (8841, '2fa6f330-f727-4e05-ad57-c29a52a2ec63', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:22:20', 330, 0, '', '2019-05-26 14:22:20');
INSERT INTO `access_log` VALUES (8842, '5d90c597-6a6d-470a-9909-d846bd71bdd3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:23:17', 148, 0, '', '2019-05-26 14:23:17');
INSERT INTO `access_log` VALUES (8843, 'e71abc19-f876-4d6d-acce-ad8ae2ee3fce', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:23:17', 153, 0, '', '2019-05-26 14:23:17');
INSERT INTO `access_log` VALUES (8844, '6d17a190-1c84-4874-86bf-adb32394b65a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:23:17', 154, 0, '', '2019-05-26 14:23:17');
INSERT INTO `access_log` VALUES (8845, 'f4caca0a-ad41-4069-bd89-46cfc3485c40', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=0&total=0&size=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:23:40', 289, 2001001000, '服务端发生异常', '2019-05-26 14:23:40');
INSERT INTO `access_log` VALUES (8846, '4026a978-9401-42e2-b8c8-2350e244dfab', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:28:52', 754, 0, '', '2019-05-26 14:28:53');
INSERT INTO `access_log` VALUES (8847, '75e7744e-d7cc-4ec1-ab08-6c6742894591', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:28:52', 754, 0, '', '2019-05-26 14:28:53');
INSERT INTO `access_log` VALUES (8848, '2afc9ae6-5a72-41df-8b22-4f133a45a04c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:28:52', 754, 0, '', '2019-05-26 14:28:53');
INSERT INTO `access_log` VALUES (8849, 'c4a39d6a-42ed-4009-a55d-908aa4dfc82b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:29:10', 211, 0, '', '2019-05-26 14:29:10');
INSERT INTO `access_log` VALUES (8850, '803be73a-f68f-4a8f-bb47-513dcf7ba1f8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:29:10', 217, 0, '', '2019-05-26 14:29:10');
INSERT INTO `access_log` VALUES (8851, '150e9595-fccc-4d4d-8efa-fad90d005142', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:29:10', 243, 0, '', '2019-05-26 14:29:10');
INSERT INTO `access_log` VALUES (8852, '1fafa3f3-dec8-49a9-a25f-480912172e8d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:29:41', 304, 0, '', '2019-05-26 14:29:41');
INSERT INTO `access_log` VALUES (8853, '9962df5c-e7e9-4514-ba6d-59ae0396dc73', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:29:41', 304, 0, '', '2019-05-26 14:29:41');
INSERT INTO `access_log` VALUES (8854, 'd0975811-0c7b-4712-b195-e5f1a869143b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:29:41', 330, 0, '', '2019-05-26 14:29:41');
INSERT INTO `access_log` VALUES (8855, '3bec3a0b-4350-4156-b3f5-6caab271e528', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:29:41', 212, 0, '', '2019-05-26 14:29:41');
INSERT INTO `access_log` VALUES (8856, 'e7b2230e-9b7d-4431-82ca-9991fdc8437f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:29:41', 247, 0, '', '2019-05-26 14:29:41');
INSERT INTO `access_log` VALUES (8857, '21497ed7-5e44-4404-986c-6854cb409c4a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:29:41', 246, 0, '', '2019-05-26 14:29:41');
INSERT INTO `access_log` VALUES (8858, '34b31485-02c2-47b3-89e9-db9417bec848', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:29:44', 151, 0, '', '2019-05-26 14:29:44');
INSERT INTO `access_log` VALUES (8859, 'd7f696fc-7288-4553-93f1-9929ea7d1c8f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:29:44', 149, 0, '', '2019-05-26 14:29:44');
INSERT INTO `access_log` VALUES (8860, '1236f775-5a20-439d-97be-f3e0400dcdbf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:29:44', 146, 0, '', '2019-05-26 14:29:44');
INSERT INTO `access_log` VALUES (8861, '2543a9b4-4bde-462e-a7e5-5fab86c879ae', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:30:00', 289, 0, '', '2019-05-26 14:30:00');
INSERT INTO `access_log` VALUES (8862, 'f787a279-d174-4849-89ad-d8f59b811083', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:30:00', 292, 0, '', '2019-05-26 14:30:00');
INSERT INTO `access_log` VALUES (8863, 'd07d820f-17c1-4d8d-bff7-7e13ae8c4d32', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:30:00', 299, 0, '', '2019-05-26 14:30:00');
INSERT INTO `access_log` VALUES (8864, 'f93ed1a4-8c5f-4db1-8109-14078237545a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:31:59', 742, 0, '', '2019-05-26 14:32:00');
INSERT INTO `access_log` VALUES (8865, '52d1e723-2cf1-4278-8f9d-3d3b52343d72', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:31:59', 739, 0, '', '2019-05-26 14:32:00');
INSERT INTO `access_log` VALUES (8866, '510feda8-a031-4ef2-ab5e-72451d7b938f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:31:59', 794, 0, '', '2019-05-26 14:32:00');
INSERT INTO `access_log` VALUES (8867, '3b4d8392-ddd7-461f-9eeb-7bbf4e7126e9', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:32:59', 705, 0, '', '2019-05-26 14:33:00');
INSERT INTO `access_log` VALUES (8868, '045420ca-2b3a-4062-b6c2-ffb0031bdbb6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:32:59', 705, 0, '', '2019-05-26 14:33:00');
INSERT INTO `access_log` VALUES (8869, 'cd2c4fd5-432f-4e3f-a616-58b7c4529f18', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:32:59', 705, 0, '', '2019-05-26 14:33:00');
INSERT INTO `access_log` VALUES (8870, 'c18b2799-ee29-4c1f-a4c0-43ff6c6dbe10', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:32:59', 717, 0, '', '2019-05-26 14:33:00');
INSERT INTO `access_log` VALUES (8871, '75a54f54-5ff3-4e4f-81a7-17dea86a7894', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:38:54', 282, 0, '', '2019-05-26 14:38:54');
INSERT INTO `access_log` VALUES (8872, '02974da6-174b-4852-a3c4-6fbef0aac9ae', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:38:54', 285, 0, '', '2019-05-26 14:38:54');
INSERT INTO `access_log` VALUES (8873, '4c85301e-902d-4787-aef1-b25b218eaae7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:38:54', 291, 0, '', '2019-05-26 14:38:54');
INSERT INTO `access_log` VALUES (8874, '0ca51000-9678-47fb-9479-f577d508de6e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:38:54', 220, 0, '', '2019-05-26 14:38:54');
INSERT INTO `access_log` VALUES (8875, 'a6ad1afe-beec-4e5b-b5ce-f5b4dae656c8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:38:57', 208, 0, '', '2019-05-26 14:38:57');
INSERT INTO `access_log` VALUES (8876, '8b151570-a2dd-4dc3-aa01-81bd3e6c26ca', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:38:57', 208, 0, '', '2019-05-26 14:38:57');
INSERT INTO `access_log` VALUES (8877, 'b9562288-bf0c-4f5e-bad3-354123a73f5d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:38:57', 206, 0, '', '2019-05-26 14:38:57');
INSERT INTO `access_log` VALUES (8878, '9dc3641e-2e89-4e84-8f04-8434d35049b6', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:38:57', 174, 0, '', '2019-05-26 14:38:57');
INSERT INTO `access_log` VALUES (8879, 'b2270dad-6527-45ad-b404-50cb17f32be3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:39:21', 155, 0, '', '2019-05-26 14:39:21');
INSERT INTO `access_log` VALUES (8880, 'f12a5b6d-82eb-451d-a3f9-dd0256d67204', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:39:21', 165, 0, '', '2019-05-26 14:39:21');
INSERT INTO `access_log` VALUES (8881, '61d25790-1cfa-4fb4-9f79-592c203af572', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:39:21', 163, 0, '', '2019-05-26 14:39:21');
INSERT INTO `access_log` VALUES (8882, '85fc83a9-41a1-4620-b4e4-f6c0469cbcaf', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:39:21', 181, 0, '', '2019-05-26 14:39:21');
INSERT INTO `access_log` VALUES (8883, '6c3f4320-4659-4946-96e7-b510d7e37523', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:39:49', 145, 0, '', '2019-05-26 14:39:49');
INSERT INTO `access_log` VALUES (8884, '5895ed28-ec06-4f32-bb7d-d95197952cd0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:39:49', 146, 0, '', '2019-05-26 14:39:49');
INSERT INTO `access_log` VALUES (8885, '2b460004-3f69-4aac-9653-ad9f306d8070', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:39:49', 148, 0, '', '2019-05-26 14:39:49');
INSERT INTO `access_log` VALUES (8886, 'ba0e6a03-1f2f-4d0f-8f10-a3d17a194054', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:39:49', 172, 0, '', '2019-05-26 14:39:50');
INSERT INTO `access_log` VALUES (8887, 'ce81edfd-0a35-449a-9b24-dd6930df6ec8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:39:53', 154, 0, '', '2019-05-26 14:39:53');
INSERT INTO `access_log` VALUES (8888, '62e0ec2c-0b66-4fc2-bd5d-0143803a9ba5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:39:53', 152, 0, '', '2019-05-26 14:39:53');
INSERT INTO `access_log` VALUES (8889, '41d49f77-581f-4b3c-b862-c67caf9c3613', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:39:53', 148, 0, '', '2019-05-26 14:39:53');
INSERT INTO `access_log` VALUES (8890, 'c5c6a967-a906-4e24-a29c-10a4f32835ad', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:39:54', 188, 0, '', '2019-05-26 14:39:54');
INSERT INTO `access_log` VALUES (8891, 'f426e8ee-2aff-4e67-8838-79b4f6084506', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:02', 824, 0, '', '2019-05-26 14:40:02');
INSERT INTO `access_log` VALUES (8892, '5a6e4362-7c9e-4232-9f8a-541affc9a88c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:02', 814, 0, '', '2019-05-26 14:40:02');
INSERT INTO `access_log` VALUES (8893, '89be61c6-4e10-4fb5-baee-f3004e8ee793', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:02', 820, 0, '', '2019-05-26 14:40:02');
INSERT INTO `access_log` VALUES (8894, 'cfd72aef-7aca-4fb8-9ef5-7941fae48ccc', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:02', 671, 0, '', '2019-05-26 14:40:02');
INSERT INTO `access_log` VALUES (8895, 'fef84114-ecb1-498f-b2c4-2aade468bbee', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:11', 140, 0, '', '2019-05-26 14:40:12');
INSERT INTO `access_log` VALUES (8896, '5db95cdd-a269-4214-9014-9c330f4f5d4b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:11', 146, 0, '', '2019-05-26 14:40:12');
INSERT INTO `access_log` VALUES (8897, '0c0a5be8-42bb-40f3-8867-6889e9451704', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:11', 144, 0, '', '2019-05-26 14:40:12');
INSERT INTO `access_log` VALUES (8898, 'da50c9d4-b5e0-4a79-8445-f1f1e987f859', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:12', 168, 0, '', '2019-05-26 14:40:12');
INSERT INTO `access_log` VALUES (8899, 'aecf59d2-88da-400b-a40a-07d2c1465f8d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:17', 138, 0, '', '2019-05-26 14:40:17');
INSERT INTO `access_log` VALUES (8900, '875e7303-2c90-46c5-bc46-24fa1bd62675', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:17', 147, 0, '', '2019-05-26 14:40:17');
INSERT INTO `access_log` VALUES (8901, 'c4ad098b-7798-4062-a3f5-7e07341ae597', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:17', 141, 0, '', '2019-05-26 14:40:17');
INSERT INTO `access_log` VALUES (8902, '5bcbcc69-7bfe-460b-a668-7067abecec75', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:17', 183, 0, '', '2019-05-26 14:40:17');
INSERT INTO `access_log` VALUES (8903, '16b85f1c-ac46-4540-a404-6f2ae9efebd5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:41', 320, 0, '', '2019-05-26 14:40:41');
INSERT INTO `access_log` VALUES (8904, '1975be0a-ab5b-4092-a47c-db0e0ac8ae3d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:41', 319, 0, '', '2019-05-26 14:40:41');
INSERT INTO `access_log` VALUES (8905, 'af2305aa-1fdb-4838-a9bf-e226ffa9ef67', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:41', 320, 0, '', '2019-05-26 14:40:41');
INSERT INTO `access_log` VALUES (8906, '97e1b3d7-313b-4597-86a2-3ad76a823a3f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:43', 147, 0, '', '2019-05-26 14:40:43');
INSERT INTO `access_log` VALUES (8907, 'c1171b52-8423-4db4-b8d2-46c020f69349', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:43', 143, 0, '', '2019-05-26 14:40:43');
INSERT INTO `access_log` VALUES (8908, '89cd5148-e7d0-41e6-86c4-115174269599', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:43', 149, 0, '', '2019-05-26 14:40:43');
INSERT INTO `access_log` VALUES (8909, '8115183e-6259-4d7a-93a0-da980d05e97c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:43', 165, 0, '', '2019-05-26 14:40:43');
INSERT INTO `access_log` VALUES (8910, '80c43e8b-7332-4e71-8e6a-1823387b05fc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:57', 530, 0, '', '2019-05-26 14:40:58');
INSERT INTO `access_log` VALUES (8911, '275ad958-36db-4bda-a732-8a1e77183268', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:57', 600, 0, '', '2019-05-26 14:40:58');
INSERT INTO `access_log` VALUES (8912, '139f22ff-3761-426b-95eb-cfbfcc10ce48', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:57', 1347, 2001001000, '服务端发生异常', '2019-05-26 14:40:58');
INSERT INTO `access_log` VALUES (8913, '553380c1-e438-4deb-b060-a8fa65b06de0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:58', 956, 0, '', '2019-05-26 14:40:59');
INSERT INTO `access_log` VALUES (8914, '23995a27-76dd-4251-bcce-e08110b44430', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:58', 962, 0, '', '2019-05-26 14:40:59');
INSERT INTO `access_log` VALUES (8915, 'a94c6247-f7ba-4c3e-92df-454dbdc1a3a8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:58', 959, 0, '', '2019-05-26 14:40:59');
INSERT INTO `access_log` VALUES (8916, '81426725-3097-45b1-9ee3-601dda7c3a94', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:58', 860, 0, '', '2019-05-26 14:40:59');
INSERT INTO `access_log` VALUES (8917, '0da8c9e4-9b83-4dc6-add9-74f164df8886', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:07', 137, 0, '', '2019-05-26 14:41:07');
INSERT INTO `access_log` VALUES (8918, '5f71e003-2aa4-458a-8b7b-8b1c7405f478', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:07', 148, 0, '', '2019-05-26 14:41:07');
INSERT INTO `access_log` VALUES (8919, 'a6296a9c-e01d-41bb-869a-a810ff249dcf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:07', 281, 2001001000, '服务端发生异常', '2019-05-26 14:41:08');
INSERT INTO `access_log` VALUES (8920, '19ce17ca-7d04-4bac-8f72-f57a29363f5c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:09', 139, 0, '', '2019-05-26 14:41:09');
INSERT INTO `access_log` VALUES (8921, '1756c360-9613-4d0f-aeaa-9f31ee1fe59f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:09', 141, 0, '', '2019-05-26 14:41:09');
INSERT INTO `access_log` VALUES (8922, '6b462ca0-8c47-4f40-9341-b6943affea0f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:09', 158, 0, '', '2019-05-26 14:41:09');
INSERT INTO `access_log` VALUES (8923, '4b172cd6-c8ec-4734-a7f8-019f1cee68f6', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:09', 169, 0, '', '2019-05-26 14:41:09');
INSERT INTO `access_log` VALUES (8924, '439284ac-f98e-4dc0-a313-663a471bc1d8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:12', 137, 0, '', '2019-05-26 14:41:12');
INSERT INTO `access_log` VALUES (8925, '599239b9-4206-48ff-a2ef-8c104a25ebc9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:12', 145, 0, '', '2019-05-26 14:41:12');
INSERT INTO `access_log` VALUES (8926, '74bdcbe8-3691-4c37-8f40-3767476180bc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:12', 147, 0, '', '2019-05-26 14:41:12');
INSERT INTO `access_log` VALUES (8927, '7e532d12-c86b-4392-b8c6-dc75b02b9b70', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:30', 136, 0, '', '2019-05-26 14:41:31');
INSERT INTO `access_log` VALUES (8928, '9f4a171c-2dda-4efc-adcb-76dfe6af04ec', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:30', 142, 0, '', '2019-05-26 14:41:31');
INSERT INTO `access_log` VALUES (8929, 'c1565211-c98e-4277-8f8a-e44647b1fd9e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:30', 146, 0, '', '2019-05-26 14:41:31');
INSERT INTO `access_log` VALUES (8930, '93103fdc-48af-49b0-9bc5-3de8363d6da5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:33', 153, 0, '', '2019-05-26 14:41:33');
INSERT INTO `access_log` VALUES (8931, '5e492665-a055-4e57-9906-2de8a34fc9e9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:33', 142, 0, '', '2019-05-26 14:41:33');
INSERT INTO `access_log` VALUES (8932, '5b776819-78de-4a98-a461-3508d8c47312', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:33', 158, 0, '', '2019-05-26 14:41:33');
INSERT INTO `access_log` VALUES (8933, '6726bf65-8382-436e-a940-e2797274d774', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:33', 178, 0, '', '2019-05-26 14:41:33');
INSERT INTO `access_log` VALUES (8934, '723e14f2-d659-4f52-8f17-2d5972356cbc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:34', 177, 0, '', '2019-05-26 14:41:35');
INSERT INTO `access_log` VALUES (8935, 'b1179c59-f15c-470d-84aa-1e8b25196bd1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:35', 142, 0, '', '2019-05-26 14:41:35');
INSERT INTO `access_log` VALUES (8936, 'bf90ac93-cfca-419b-b409-94a3b113a740', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:35', 265, 2001001000, '服务端发生异常', '2019-05-26 14:41:36');
INSERT INTO `access_log` VALUES (8937, 'e682913d-6b4f-40b8-9be5-0ba8a49edcc8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:36', 130, 0, '', '2019-05-26 14:41:37');
INSERT INTO `access_log` VALUES (8938, 'd950d54b-75e2-4d30-99b7-31eac8c3706a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:36', 137, 0, '', '2019-05-26 14:41:37');
INSERT INTO `access_log` VALUES (8939, '14ab4c5a-f4c7-488e-9564-33472f83b14d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:36', 136, 0, '', '2019-05-26 14:41:37');
INSERT INTO `access_log` VALUES (8940, 'd48224ba-fac5-450f-a902-0856b7d34271', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:37', 168, 0, '', '2019-05-26 14:41:37');
INSERT INTO `access_log` VALUES (8941, 'd9d3f904-cebf-46ab-86d1-71eeddfbb299', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:42:59', 167, 0, '', '2019-05-26 14:42:59');
INSERT INTO `access_log` VALUES (8942, 'dc77b328-7aa1-40df-8777-12a08f593460', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:42:59', 171, 0, '', '2019-05-26 14:42:59');
INSERT INTO `access_log` VALUES (8943, 'd4500c3b-7d37-4b4c-9ea6-f9c749db2f50', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:42:59', 180, 0, '', '2019-05-26 14:43:00');
INSERT INTO `access_log` VALUES (8944, '85af2743-6276-437e-935a-c1ad080ef035', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:02', 306, 0, '', '2019-05-26 14:43:02');
INSERT INTO `access_log` VALUES (8945, 'a1f20285-559b-4bf1-a036-5c2356c0f0cf', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:02', 313, 0, '', '2019-05-26 14:43:02');
INSERT INTO `access_log` VALUES (8946, '4d761379-e66a-4e49-bc22-1939d9863bd5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:02', 315, 0, '', '2019-05-26 14:43:02');
INSERT INTO `access_log` VALUES (8947, 'fdf47225-50d7-432c-936f-c7ece99ed2b2', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:02', 222, 0, '', '2019-05-26 14:43:02');
INSERT INTO `access_log` VALUES (8948, '9fe93467-c9f8-4086-926c-a8767f212f62', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:16', 139, 0, '', '2019-05-26 14:43:16');
INSERT INTO `access_log` VALUES (8949, 'f626fde5-dc08-4813-a1bc-b42f21afb28f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:16', 139, 0, '', '2019-05-26 14:43:16');
INSERT INTO `access_log` VALUES (8950, '63d16962-e417-4e17-96e1-56defd076b8e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:16', 262, 2001001000, '服务端发生异常', '2019-05-26 14:43:16');
INSERT INTO `access_log` VALUES (8951, '838b38ab-b585-42ae-b07a-051d4f5f2a8b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:17', 137, 0, '', '2019-05-26 14:43:17');
INSERT INTO `access_log` VALUES (8952, '51a637ab-7d80-4402-a17e-408753024f03', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:17', 143, 0, '', '2019-05-26 14:43:17');
INSERT INTO `access_log` VALUES (8953, '12057147-f50b-4a85-a224-045150a9e0b7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:17', 135, 0, '', '2019-05-26 14:43:17');
INSERT INTO `access_log` VALUES (8954, 'd9793cf3-6aec-4b62-a84d-7e2a8afffeb8', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:17', 167, 0, '', '2019-05-26 14:43:18');
INSERT INTO `access_log` VALUES (8955, '8ef100b5-d2ec-4775-be6d-45dc9a8b6311', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:29', 132, 0, '', '2019-05-26 14:43:29');
INSERT INTO `access_log` VALUES (8956, '8f838c33-5b30-4955-a8fa-d7950d0ac6dc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:29', 132, 0, '', '2019-05-26 14:43:29');
INSERT INTO `access_log` VALUES (8957, 'ab236e6f-e360-40ce-b9f3-842492687bbb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:29', 141, 0, '', '2019-05-26 14:43:29');
INSERT INTO `access_log` VALUES (8958, 'fa6568cc-1d99-4534-938b-628d109d766b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:31', 132, 0, '', '2019-05-26 14:43:31');
INSERT INTO `access_log` VALUES (8959, 'b0cd592a-2e22-4e63-8db0-36a3604c2b3f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:31', 139, 0, '', '2019-05-26 14:43:31');
INSERT INTO `access_log` VALUES (8960, '7d0d292c-d45e-4297-ba85-eadfc1e88039', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:31', 148, 0, '', '2019-05-26 14:43:31');
INSERT INTO `access_log` VALUES (8961, '4b0b4be8-f548-40de-bf7a-8386b06e0b86', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:31', 176, 0, '', '2019-05-26 14:43:31');
INSERT INTO `access_log` VALUES (8962, 'f1d8bd87-c21a-4302-8111-3884cadaff19', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:56', 148, 0, '', '2019-05-26 14:43:56');
INSERT INTO `access_log` VALUES (8963, 'b415142f-861e-40b0-87ba-9a5f1b33410a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:56', 148, 0, '', '2019-05-26 14:43:56');
INSERT INTO `access_log` VALUES (8964, 'b7d412f6-c1cf-4b76-ae87-0ac6a8d6d0b5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:56', 147, 0, '', '2019-05-26 14:43:56');
INSERT INTO `access_log` VALUES (8965, '1384dbde-beae-439c-91ac-4699f078722c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:56', 171, 0, '', '2019-05-26 14:43:56');
INSERT INTO `access_log` VALUES (8966, '6b94f32d-3a74-4e0a-abd1-fb16a94df014', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:45:32', 726, 0, '', '2019-05-26 14:45:33');
INSERT INTO `access_log` VALUES (8967, '810bf229-ba75-400c-84e6-7d5eea9e5901', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:45:32', 726, 0, '', '2019-05-26 14:45:33');
INSERT INTO `access_log` VALUES (8968, 'a47d8f03-b1af-4bc7-9057-0ffcccfba00a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:45:32', 726, 0, '', '2019-05-26 14:45:33');
INSERT INTO `access_log` VALUES (8969, '91818845-e2c1-40dc-ab62-dffbf5aace14', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:45:32', 781, 0, '', '2019-05-26 14:45:33');
INSERT INTO `access_log` VALUES (8970, '456df9d4-df02-4a04-af96-472e602dd02a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:45:38', 161, 0, '', '2019-05-26 14:45:38');
INSERT INTO `access_log` VALUES (8971, '5ca899b4-b4c3-4b2e-9c53-e748e0a984a2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:45:38', 163, 0, '', '2019-05-26 14:45:39');
INSERT INTO `access_log` VALUES (8972, '2dd48078-c0c2-4b9b-a805-8d7660bc88ab', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:45:38', 160, 0, '', '2019-05-26 14:45:38');
INSERT INTO `access_log` VALUES (8973, 'ae096542-d545-4c6e-9b28-f51e2f33c320', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:45:39', 320, 0, '', '2019-05-26 14:45:39');
INSERT INTO `access_log` VALUES (8974, '7ebe9bfa-cc51-4501-bd2e-436260ded159', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:03', 724, 0, '', '2019-05-26 14:47:04');
INSERT INTO `access_log` VALUES (8975, 'bce9e6c6-e12e-4127-be05-b9e141614be8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:03', 750, 0, '', '2019-05-26 14:47:04');
INSERT INTO `access_log` VALUES (8976, '09f9292f-ed69-40bf-905d-628aadfc4221', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:03', 724, 0, '', '2019-05-26 14:47:04');
INSERT INTO `access_log` VALUES (8977, 'fd2fecb8-c868-4088-bb7f-4036d7db1176', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:03', 724, 0, '', '2019-05-26 14:47:04');
INSERT INTO `access_log` VALUES (8978, 'fe34a426-d0e0-49ee-893f-8428427875a4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:53', 139, 0, '', '2019-05-26 14:47:53');
INSERT INTO `access_log` VALUES (8979, 'b0c6473a-2f99-44d1-8e22-72c7775c1fd6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:53', 149, 0, '', '2019-05-26 14:47:53');
INSERT INTO `access_log` VALUES (8980, 'a66a4de9-292c-4dfb-8d0c-f4eb608a8dbf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:53', 146, 0, '', '2019-05-26 14:47:53');
INSERT INTO `access_log` VALUES (8981, '2dd90155-2310-40d4-b609-47e90ccf92e0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:53', 169, 0, '', '2019-05-26 14:47:53');
INSERT INTO `access_log` VALUES (8982, '2fbde709-9939-4761-802d-c781473b4e39', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:54', 134, 0, '', '2019-05-26 14:47:54');
INSERT INTO `access_log` VALUES (8983, 'c2b99064-9ff3-46cb-998e-9bf455975b81', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:54', 151, 0, '', '2019-05-26 14:47:54');
INSERT INTO `access_log` VALUES (8984, '220dfca8-b0ba-4c5e-a4ff-5cceb4b44aa6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:54', 148, 0, '', '2019-05-26 14:47:54');
INSERT INTO `access_log` VALUES (8985, 'baf3975f-2392-4f20-ad8f-0fd87556f1c5', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:54', 175, 0, '', '2019-05-26 14:47:55');
INSERT INTO `access_log` VALUES (8986, 'ef6feb53-a234-440a-a8a5-dcf22569c5eb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:59', 138, 0, '', '2019-05-26 14:47:59');
INSERT INTO `access_log` VALUES (8987, '1a65b0bd-d3ec-4c48-aa41-7f66a04751e7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:59', 149, 0, '', '2019-05-26 14:47:59');
INSERT INTO `access_log` VALUES (8988, '6b399036-4d9f-48cc-882a-e3068963768c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:59', 149, 0, '', '2019-05-26 14:47:59');
INSERT INTO `access_log` VALUES (8989, '305d10e4-536d-4281-90c2-29e8faa50aa5', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:47:59', 173, 0, '', '2019-05-26 14:47:59');
INSERT INTO `access_log` VALUES (8990, '01f66141-3be8-418f-86bc-b33f5a9332eb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:48:13', 136, 0, '', '2019-05-26 14:48:13');
INSERT INTO `access_log` VALUES (8991, 'f62110ac-5b26-4642-b958-f5e0a351591f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:48:13', 152, 0, '', '2019-05-26 14:48:13');
INSERT INTO `access_log` VALUES (8992, '95bf4372-d8de-4279-b9ca-4352571f336e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:48:13', 154, 0, '', '2019-05-26 14:48:13');
INSERT INTO `access_log` VALUES (8993, '32b2ba15-81a1-453a-a1c0-bb039fbbdf8b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:48:13', 166, 0, '', '2019-05-26 14:48:13');
INSERT INTO `access_log` VALUES (8994, '728bd317-7545-4f81-9e53-f819bfb84cf2', 0, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:52:25', 492, 1002001012, '访问令牌已过期', '2019-05-26 14:52:26');
INSERT INTO `access_log` VALUES (8995, '16566446-cabb-477e-9113-63742347e74f', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:52:25', 459, 1002001012, '访问令牌已过期', '2019-05-26 14:52:26');
INSERT INTO `access_log` VALUES (8996, 'd55419f4-d790-4a25-800c-c4cc25c7267f', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:52:25', 459, 1002001012, '访问令牌已过期', '2019-05-26 14:52:26');
INSERT INTO `access_log` VALUES (8997, '59bfcc86-979b-4c7d-a022-9a2071f6d0a7', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:52:25', 527, 1002001012, '访问令牌已过期', '2019-05-26 14:52:26');
INSERT INTO `access_log` VALUES (8998, '7b7f5dd6-69f3-42f8-b83b-bcb650fed3a6', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:52:29', 438, 0, '', '2019-05-26 14:52:30');
INSERT INTO `access_log` VALUES (8999, '9cee6044-cc4b-4004-9b99-258eff230cfa', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:52:30', 190, 0, '', '2019-05-26 14:52:30');
INSERT INTO `access_log` VALUES (9000, 'fdc078d0-74b4-4d60-bf3b-cac9ccdc6f15', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:52:30', 203, 0, '', '2019-05-26 14:52:30');
INSERT INTO `access_log` VALUES (9001, '2862836a-a0c5-4267-a8dc-9a24a03552e7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:52:30', 207, 0, '', '2019-05-26 14:52:30');
INSERT INTO `access_log` VALUES (9002, 'c318d901-7613-4628-9dd5-f9469e4ead7e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:52:32', 231, 0, '', '2019-05-26 14:52:32');
INSERT INTO `access_log` VALUES (9003, '74beca84-1115-4584-a97d-e4b6e1829130', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:59:40', 707, 0, '', '2019-05-26 14:59:40');
INSERT INTO `access_log` VALUES (9004, '5d5adc02-cb90-4fd7-b948-43316ef42636', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:59:40', 764, 0, '', '2019-05-26 14:59:41');
INSERT INTO `access_log` VALUES (9005, '4d439db1-a221-4bdb-a0c2-a1cd073a027e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:59:40', 707, 0, '', '2019-05-26 14:59:41');
INSERT INTO `access_log` VALUES (9006, '73e517e3-c9fc-4bcc-9179-688f13a349d0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:59:40', 789, 0, '', '2019-05-26 14:59:41');
INSERT INTO `access_log` VALUES (9007, '3722a35d-2e89-44ab-a988-f0c4813d8193', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:04:50', 2010, 0, '', '2019-05-26 15:04:52');
INSERT INTO `access_log` VALUES (9008, '8a4c15f9-33a2-4c6a-9518-54eee28f2624', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:04:50', 2010, 0, '', '2019-05-26 15:04:52');
INSERT INTO `access_log` VALUES (9009, 'da29a0e0-c665-4bea-873b-a6de8e649c90', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:04:50', 2010, 0, '', '2019-05-26 15:04:52');
INSERT INTO `access_log` VALUES (9010, '2b7de833-b393-4b76-892d-12d24854b5a1', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:04:50', 2016, 0, '', '2019-05-26 15:04:52');
INSERT INTO `access_log` VALUES (9011, '31126dbc-4832-4f97-b93c-606d929abe7f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:05:58', 788, 0, '', '2019-05-26 15:05:58');
INSERT INTO `access_log` VALUES (9012, '0a0b3224-7b91-4340-8d58-87b49a96e457', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:05:58', 775, 0, '', '2019-05-26 15:05:58');
INSERT INTO `access_log` VALUES (9013, '95ef8043-bd21-4fdc-a042-52b6b7242483', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:05:58', 775, 0, '', '2019-05-26 15:05:58');
INSERT INTO `access_log` VALUES (9014, '3c955fed-acc4-4ab1-8496-aef9809e315d', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:06:00', 236, 0, '', '2019-05-26 15:06:00');
INSERT INTO `access_log` VALUES (9015, 'a10717cc-1112-48da-ac7c-ceb66ecca56b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:06:22', 148, 0, '', '2019-05-26 15:06:23');
INSERT INTO `access_log` VALUES (9016, '5a4d4fa5-0b1c-4957-a0c7-c4a376f12fed', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:06:22', 151, 0, '', '2019-05-26 15:06:23');
INSERT INTO `access_log` VALUES (9017, 'd4f41eab-f256-4458-8cc9-8fc39c95d8d5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:06:22', 151, 0, '', '2019-05-26 15:06:23');
INSERT INTO `access_log` VALUES (9018, 'bc3c6257-b4e9-43a9-8514-c0f6edf7ea49', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:06:23', 184, 0, '', '2019-05-26 15:06:23');
INSERT INTO `access_log` VALUES (9019, '125c5974-149d-4d62-997f-b9b24bbf5c54', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:06:42', 314, 0, '', '2019-05-26 15:06:42');
INSERT INTO `access_log` VALUES (9020, 'b602c18c-484b-442d-acc6-a5289072aadb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:06:42', 327, 0, '', '2019-05-26 15:06:42');
INSERT INTO `access_log` VALUES (9021, '46ac9522-8e95-423d-aeea-7520d36a8e2b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:06:42', 352, 0, '', '2019-05-26 15:06:42');
INSERT INTO `access_log` VALUES (9022, '705c757c-f4aa-4161-aee8-5636d0b30ef0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:06:42', 425, 0, '', '2019-05-26 15:06:42');
INSERT INTO `access_log` VALUES (9023, '90a04499-c4fd-4b3b-ba9f-8d21460ab895', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:07:14', 232, 0, '', '2019-05-26 15:07:14');
INSERT INTO `access_log` VALUES (9024, '6528ce05-8a40-4d3d-84c3-cb29b43ba2be', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:07:14', 237, 0, '', '2019-05-26 15:07:14');
INSERT INTO `access_log` VALUES (9025, '40bf5107-abd6-4a9e-8482-4c6572d857b4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:07:14', 218, 0, '', '2019-05-26 15:07:14');
INSERT INTO `access_log` VALUES (9026, '8e2cdae7-9ecc-45b9-8acc-93f0f80cb7ae', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:07:14', 201, 0, '', '2019-05-26 15:07:14');
INSERT INTO `access_log` VALUES (9027, 'fbbd792d-d428-4388-a3af-3d6719857422', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:19', 564, 0, '', '2019-05-26 15:08:20');
INSERT INTO `access_log` VALUES (9028, '9f4d8a96-3683-4c3e-96a1-0bc782e87615', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:19', 577, 0, '', '2019-05-26 15:08:20');
INSERT INTO `access_log` VALUES (9029, 'fe24596b-bc67-4fda-9d02-c1d8e036304a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:19', 608, 0, '', '2019-05-26 15:08:20');
INSERT INTO `access_log` VALUES (9030, '31dd9117-31c8-417e-a556-6ab1784abd4a', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:19', 607, 0, '', '2019-05-26 15:08:20');
INSERT INTO `access_log` VALUES (9031, '525575e3-4797-4e7a-a6d0-3642d98eee5e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:26', 139, 0, '', '2019-05-26 15:08:26');
INSERT INTO `access_log` VALUES (9032, '00cf3393-8db8-48f1-9010-211f3e0e1a24', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:26', 141, 0, '', '2019-05-26 15:08:26');
INSERT INTO `access_log` VALUES (9033, '79a1ca4a-ef47-4dd6-8a68-a8cc25955a5a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:26', 235, 0, '', '2019-05-26 15:08:26');
INSERT INTO `access_log` VALUES (9034, '1cf2ff53-0fd3-41ff-8cf1-4d965e89fd7c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:26', 174, 0, '', '2019-05-26 15:08:27');
INSERT INTO `access_log` VALUES (9035, 'b9484414-a153-4c17-874f-55f8f5a24d7b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:33', 140, 0, '', '2019-05-26 15:08:33');
INSERT INTO `access_log` VALUES (9036, '5077d3f7-9199-4375-863d-fed52ed6e8f3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:33', 140, 0, '', '2019-05-26 15:08:33');
INSERT INTO `access_log` VALUES (9037, 'f05f11a3-f04d-42b4-b6f0-1f253cd1cd88', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:33', 140, 0, '', '2019-05-26 15:08:33');
INSERT INTO `access_log` VALUES (9038, 'fd356059-1443-4f7f-824b-431ab84c4288', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:33', 168, 0, '', '2019-05-26 15:08:33');
INSERT INTO `access_log` VALUES (9039, '5ecbd51c-5fd6-48d0-af63-4c1fbcb3b44b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:34', 140, 0, '', '2019-05-26 15:08:34');
INSERT INTO `access_log` VALUES (9040, '832aa0c5-c29c-46fb-b928-4e2fe6f7e75a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:34', 138, 0, '', '2019-05-26 15:08:34');
INSERT INTO `access_log` VALUES (9041, '6072b525-13be-436b-aae6-1df210b38da4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:34', 139, 0, '', '2019-05-26 15:08:34');
INSERT INTO `access_log` VALUES (9042, '10158373-84c8-4e07-80dd-80632f14a92a', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:34', 176, 0, '', '2019-05-26 15:08:34');
INSERT INTO `access_log` VALUES (9043, 'b3c3eec2-ac37-4ccb-b757-d63d754bb298', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:43', 168, 0, '', '2019-05-26 15:08:44');
INSERT INTO `access_log` VALUES (9044, '0a501219-10cb-4ac7-b4f6-418be41967cd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:43', 159, 0, '', '2019-05-26 15:08:44');
INSERT INTO `access_log` VALUES (9045, '28e72375-6500-4e60-bdb2-aa28172374e0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:43', 170, 0, '', '2019-05-26 15:08:44');
INSERT INTO `access_log` VALUES (9046, 'a26f3cb6-4838-4a60-96d2-30f8503a6f06', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:44', 176, 0, '', '2019-05-26 15:08:44');
INSERT INTO `access_log` VALUES (9047, 'fbc80442-fff1-48dd-b3af-08349d7b7c1e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:54', 139, 0, '', '2019-05-26 15:08:55');
INSERT INTO `access_log` VALUES (9048, '442d3518-62d1-4b89-a09b-fcdd874f633d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:55', 139, 0, '', '2019-05-26 15:08:55');
INSERT INTO `access_log` VALUES (9049, '9c9f3aa0-856a-4096-bb73-f79a0eca8473', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:55', 149, 0, '', '2019-05-26 15:08:55');
INSERT INTO `access_log` VALUES (9050, '87f6c627-93b1-48c2-8988-e4d22b11d8c9', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:08:56', 186, 0, '', '2019-05-26 15:08:56');
INSERT INTO `access_log` VALUES (9051, '79cbe584-aba4-4649-ba65-ceaa0fdc1e16', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:09:06', 222, 0, '', '2019-05-26 15:09:06');
INSERT INTO `access_log` VALUES (9052, 'c1968978-6fc0-4668-9dbc-264b3c21f41e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'enumValue=sms_platform&value=1&displayName=云片&sort=1&memo=短信服务云片', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:09:37', 382, 0, '', '2019-05-26 15:09:37');
INSERT INTO `access_log` VALUES (9053, '772adbbb-56b5-47d0-b53e-654009c9e0ce', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:09:37', 212, 0, '', '2019-05-26 15:09:38');
INSERT INTO `access_log` VALUES (9054, 'd9dd27ff-a68d-4d67-a5eb-38b18f2a4691', 1, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'enumValue=sms_platform&value=2&displayName=阿里云&sort=2&memo=阿里云短信服务', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:09:56', 528, 0, '', '2019-05-26 15:09:57');
INSERT INTO `access_log` VALUES (9055, 'edf6fdad-b2c3-47f1-8362-e15ba76a3c22', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:09:57', 212, 0, '', '2019-05-26 15:09:57');
INSERT INTO `access_log` VALUES (9056, '3dd7e0e2-1c69-4fd3-93a0-dbd9480a1a80', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:10:08', 143, 0, '', '2019-05-26 15:10:08');
INSERT INTO `access_log` VALUES (9057, '97949c19-6e0b-4052-8984-f5465c29624c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:10:08', 163, 0, '', '2019-05-26 15:10:08');
INSERT INTO `access_log` VALUES (9058, 'f5d389e3-63d0-436b-b80c-6d7c391eed71', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:10:08', 177, 0, '', '2019-05-26 15:10:08');
INSERT INTO `access_log` VALUES (9059, '66f93567-a609-4135-a62d-48fc4b51218e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:10:08', 249, 0, '', '2019-05-26 15:10:09');
INSERT INTO `access_log` VALUES (9060, 'ab17b600-2c75-4501-a76f-66967d43ea89', 1, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'enumValue=sms_apply_status&value=1&displayName=审核中&sort=1&memo=审核中', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:11:26', 637, 0, '', '2019-05-26 15:11:27');
INSERT INTO `access_log` VALUES (9061, '35602700-1229-446d-b1a5-e2eaa3a9c52d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:11:27', 202, 0, '', '2019-05-26 15:11:27');
INSERT INTO `access_log` VALUES (9062, '900016bd-31c3-4662-a230-5758daf60132', 1, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'enumValue=sms_apply_status&value=2&displayName=审核成功&sort=2&memo=审核成功', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:11:40', 346, 0, '', '2019-05-26 15:11:40');
INSERT INTO `access_log` VALUES (9063, '241d26af-cd59-42e0-acb8-7e0af6305b3f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:11:41', 498, 0, '', '2019-05-26 15:11:41');
INSERT INTO `access_log` VALUES (9064, 'c73ab893-553b-48e4-94d8-9c35e26f5442', 1, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'enumValue=sms_apply_status&value=10&displayName=审核失败&sort=10&memo=审核失败', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:12:10', 326, 0, '', '2019-05-26 15:12:10');
INSERT INTO `access_log` VALUES (9065, '147be2ef-7cc0-4dd2-9bf4-e68bd4134c5d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:12:10', 205, 0, '', '2019-05-26 15:12:11');
INSERT INTO `access_log` VALUES (9066, '49268205-b865-438e-9bad-af115d545a6a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:15:36', 167, 0, '', '2019-05-26 15:15:36');
INSERT INTO `access_log` VALUES (9067, 'dfd567aa-7509-4087-a28a-242ba2dc87f3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:15:36', 172, 0, '', '2019-05-26 15:15:36');
INSERT INTO `access_log` VALUES (9068, '163cc4cc-d638-4d4f-89ac-207ef0d88b3f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:15:36', 162, 0, '', '2019-05-26 15:15:36');
INSERT INTO `access_log` VALUES (9069, '23b01539-8271-40e9-8ea7-94714ebbcbf9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:15:37', 211, 0, '', '2019-05-26 15:15:37');
INSERT INTO `access_log` VALUES (9070, '8e9d4d8f-b80b-4d7e-82d3-ada3b1dc145a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:15:37', 137, 0, '', '2019-05-26 15:15:38');
INSERT INTO `access_log` VALUES (9071, 'dff9a93f-959f-4a30-8830-83220346297a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:15:37', 313, 0, '', '2019-05-26 15:15:38');
INSERT INTO `access_log` VALUES (9072, 'd3b4fd37-c765-4dde-b03d-5c83e8ccf39a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:15:37', 318, 0, '', '2019-05-26 15:15:38');
INSERT INTO `access_log` VALUES (9073, '8938d089-0b02-4c3e-8e0e-d9e973eb635d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:15:38', 310, 0, '', '2019-05-26 15:15:38');
INSERT INTO `access_log` VALUES (9074, 'b46f81c8-037a-4e2c-855d-809d8f61c3de', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:15:52', 143, 0, '', '2019-05-26 15:15:52');
INSERT INTO `access_log` VALUES (9075, '9008c536-cfde-473e-8b03-58ce100f8fe2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:15:52', 140, 0, '', '2019-05-26 15:15:52');
INSERT INTO `access_log` VALUES (9076, '1da084fa-c94f-4ba4-ab6d-ed59e783a373', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:15:52', 136, 0, '', '2019-05-26 15:15:52');
INSERT INTO `access_log` VALUES (9077, '99cadcd1-f3b8-4d4a-8903-16f3813d65de', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:15:52', 378, 0, '', '2019-05-26 15:15:52');
INSERT INTO `access_log` VALUES (9078, '40c2e8ab-f47d-4120-adaf-a26b4751bab2', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:15:55', 364, 0, '', '2019-05-26 15:15:55');
INSERT INTO `access_log` VALUES (9079, 'a9e727a7-0f0c-4a63-9219-83f385286117', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:16:46', 738, 0, '', '2019-05-26 15:16:47');
INSERT INTO `access_log` VALUES (9080, '08704398-18f3-4020-8573-9cf07170ab7b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:16:46', 737, 0, '', '2019-05-26 15:16:47');
INSERT INTO `access_log` VALUES (9081, '8d2a1625-9fa4-4df3-b7d8-3ed42491fce7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:16:46', 735, 0, '', '2019-05-26 15:16:47');
INSERT INTO `access_log` VALUES (9082, '6666eadc-4132-463c-b522-1fe0af4b672c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:16:49', 232, 0, '', '2019-05-26 15:16:49');
INSERT INTO `access_log` VALUES (9083, 'e7683837-de4f-43cb-b1d4-2a267e37607e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:17:44', 771, 0, '', '2019-05-26 15:17:44');
INSERT INTO `access_log` VALUES (9084, '25e628a3-7b32-4474-8919-e52a30b0de38', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:17:44', 696, 0, '', '2019-05-26 15:17:44');
INSERT INTO `access_log` VALUES (9085, 'aee3de25-7515-49db-a836-f333d0a81ff2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:17:44', 696, 0, '', '2019-05-26 15:17:44');
INSERT INTO `access_log` VALUES (9086, 'befdd85c-c625-447d-a941-cc525382bb5b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:17:44', 727, 0, '', '2019-05-26 15:17:44');
INSERT INTO `access_log` VALUES (9087, '9b8b4a0a-7d7c-4336-b84d-9e8e4832c6b1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:19:11', 189, 0, '', '2019-05-26 15:19:11');
INSERT INTO `access_log` VALUES (9088, '4765aa96-fa93-4e55-8774-945dadc9b232', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:19:11', 189, 0, '', '2019-05-26 15:19:11');
INSERT INTO `access_log` VALUES (9089, 'a2ec5226-ed94-46a2-9908-7550a4d094ee', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:19:11', 191, 0, '', '2019-05-26 15:19:11');
INSERT INTO `access_log` VALUES (9090, '57cf467a-d205-4255-8c84-abc3d08e8ae8', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:19:12', 188, 0, '', '2019-05-26 15:19:12');
INSERT INTO `access_log` VALUES (9091, '7d37de5d-1ec1-41e1-a2f6-6cb51444b4af', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:19:18', 305, 0, '', '2019-05-26 15:19:18');
INSERT INTO `access_log` VALUES (9092, 'b5bb0ea4-a88c-4154-8d94-082e3792641a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:19:18', 304, 0, '', '2019-05-26 15:19:18');
INSERT INTO `access_log` VALUES (9093, '3defa400-c04a-4b39-ba81-8d45c612508f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:19:18', 306, 0, '', '2019-05-26 15:19:18');
INSERT INTO `access_log` VALUES (9094, '3de026db-5760-49e1-a85d-e3b825194de7', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:19:18', 357, 0, '', '2019-05-26 15:19:18');
INSERT INTO `access_log` VALUES (9095, '072de2b0-a739-4fb9-9dfa-18dc6ab9b888', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:21:05', 169, 0, '', '2019-05-26 15:21:05');
INSERT INTO `access_log` VALUES (9096, 'fbbc3abb-4e92-420c-8098-dc3c8690ede3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:21:05', 183, 0, '', '2019-05-26 15:21:05');
INSERT INTO `access_log` VALUES (9097, '25bdbb0c-86c9-43f8-9e18-9a7ffc8c78e8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:21:05', 183, 0, '', '2019-05-26 15:21:05');
INSERT INTO `access_log` VALUES (9098, 'adf55dfd-3791-4b39-a7a9-c4d986967560', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:21:05', 218, 0, '', '2019-05-26 15:21:06');
INSERT INTO `access_log` VALUES (9099, 'ef4a3709-f26e-46da-8d96-3d4cdd5776ba', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:23:13', 187, 0, '', '2019-05-26 15:23:13');
INSERT INTO `access_log` VALUES (9100, 'c2ebe9e4-df04-4408-bf70-d4492eaf805a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:23:13', 386, 0, '', '2019-05-26 15:23:14');
INSERT INTO `access_log` VALUES (9101, '93408966-cfe6-470b-aeda-e6b6203751f3', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:23:13', 221, 0, '', '2019-05-26 15:23:14');
INSERT INTO `access_log` VALUES (9102, '8703c830-26d1-4cb8-86c6-abcc257d4c2f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:23:13', 493, 0, '', '2019-05-26 15:23:14');
INSERT INTO `access_log` VALUES (9103, 'a3e9dffe-e71c-4c19-ae20-5a45ec0fa20a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:23:21', 137, 0, '', '2019-05-26 15:23:21');
INSERT INTO `access_log` VALUES (9104, '0d168e86-f7d9-43bd-9589-c1f7b513d24e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:23:21', 143, 0, '', '2019-05-26 15:23:21');
INSERT INTO `access_log` VALUES (9105, '60777e38-4b8e-4790-9830-c4192620a53b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:23:21', 142, 0, '', '2019-05-26 15:23:21');
INSERT INTO `access_log` VALUES (9106, '2b029dbb-cd3b-48d4-93e0-2beb2172ba34', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:23:21', 182, 0, '', '2019-05-26 15:23:21');
INSERT INTO `access_log` VALUES (9107, 'ccfa57e5-17d4-4d24-9e83-be2c82e2f590', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:25:28', 179, 0, '', '2019-05-26 15:25:28');
INSERT INTO `access_log` VALUES (9108, '20fd899b-e6a9-4a65-8816-2d60b0e28e27', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:25:28', 180, 0, '', '2019-05-26 15:25:28');
INSERT INTO `access_log` VALUES (9109, '917e0f19-a962-4f4a-b542-456f51233324', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:25:28', 181, 0, '', '2019-05-26 15:25:28');
INSERT INTO `access_log` VALUES (9110, 'ea40f318-17d3-4669-aef0-4171e4b85673', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:25:28', 170, 0, '', '2019-05-26 15:25:28');
INSERT INTO `access_log` VALUES (9111, '842aaf17-064b-4751-8b92-22bd26bb5018', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:25:37', 143, 0, '', '2019-05-26 15:25:37');
INSERT INTO `access_log` VALUES (9112, '404b8b87-8ba3-4ae5-bfab-4b9d5944c8f0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:25:37', 139, 0, '', '2019-05-26 15:25:37');
INSERT INTO `access_log` VALUES (9113, '0337b286-6bc4-4515-af7e-2874468e89f7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:25:37', 141, 0, '', '2019-05-26 15:25:37');
INSERT INTO `access_log` VALUES (9114, '66bdc052-6cb5-47e1-9fad-5963176cbcac', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:25:37', 200, 0, '', '2019-05-26 15:25:37');
INSERT INTO `access_log` VALUES (9115, '1bc91144-0d1a-4f95-9339-6f8734a93d8f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:07', 143, 0, '', '2019-05-26 15:26:07');
INSERT INTO `access_log` VALUES (9116, 'cdb7703a-4b48-4e67-880a-578752cbc276', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:07', 143, 0, '', '2019-05-26 15:26:07');
INSERT INTO `access_log` VALUES (9117, 'eb7e0c1a-ac42-452a-968a-4512c2cb96ed', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:07', 150, 0, '', '2019-05-26 15:26:07');
INSERT INTO `access_log` VALUES (9118, '6cf4fbb2-a5a5-4b42-9cb8-92678082b12d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:08', 145, 0, '', '2019-05-26 15:26:08');
INSERT INTO `access_log` VALUES (9119, 'c73193c0-d5cc-4eec-b944-8c57b9ed3625', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:08', 147, 0, '', '2019-05-26 15:26:08');
INSERT INTO `access_log` VALUES (9120, 'df24a694-81b7-457b-84c3-b094ce354a94', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:08', 146, 0, '', '2019-05-26 15:26:08');
INSERT INTO `access_log` VALUES (9121, 'e25e146f-bdfa-43b8-83f0-3fe4e2ece909', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:08', 172, 0, '', '2019-05-26 15:26:08');
INSERT INTO `access_log` VALUES (9122, '615ff04d-cf3a-4fdf-b952-a8574ea4f6fd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:31', 139, 0, '', '2019-05-26 15:26:31');
INSERT INTO `access_log` VALUES (9123, '606a23a8-9555-42e1-af00-2fcf3caccec9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:31', 142, 0, '', '2019-05-26 15:26:31');
INSERT INTO `access_log` VALUES (9124, '4f6abdb3-016a-4156-8021-a53628d67b7f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:31', 144, 0, '', '2019-05-26 15:26:31');
INSERT INTO `access_log` VALUES (9125, 'b883193f-7941-49d3-b9e3-8741c386b738', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:31', 179, 0, '', '2019-05-26 15:26:31');
INSERT INTO `access_log` VALUES (9126, '74b2ee73-7206-4739-b1e0-398bf52b085b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:34', 213, 0, '', '2019-05-26 15:26:35');
INSERT INTO `access_log` VALUES (9127, '2b4db17b-e801-4933-aa29-85030bdb493f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:34', 218, 0, '', '2019-05-26 15:26:35');
INSERT INTO `access_log` VALUES (9128, '9ea09a37-3758-49f3-9133-1e1c0cc30ab1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:34', 209, 0, '', '2019-05-26 15:26:35');
INSERT INTO `access_log` VALUES (9129, '3d2f8663-0676-40ee-be3d-2c0ed103c9ec', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:35', 177, 0, '', '2019-05-26 15:26:35');
INSERT INTO `access_log` VALUES (9130, '306e0063-1afe-4799-83fa-b765baf4411e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:56', 135, 0, '', '2019-05-26 15:26:56');
INSERT INTO `access_log` VALUES (9131, '75862ab1-8de8-4238-bc43-fdf5a777f88c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:56', 138, 0, '', '2019-05-26 15:26:56');
INSERT INTO `access_log` VALUES (9132, '679d6397-155e-453d-9c2a-7cbeaa40cf30', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:26:56', 141, 0, '', '2019-05-26 15:26:56');
INSERT INTO `access_log` VALUES (9133, 'dfd143ac-4f63-4b8e-ac46-e22de9a2532d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:01', 158, 0, '', '2019-05-26 15:27:02');
INSERT INTO `access_log` VALUES (9134, 'f166e72e-6d9d-4e6a-aca0-a8438e13a3b7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:01', 162, 0, '', '2019-05-26 15:27:02');
INSERT INTO `access_log` VALUES (9135, '61fb2db1-33db-4749-ba12-514b07b7693b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:01', 157, 0, '', '2019-05-26 15:27:02');
INSERT INTO `access_log` VALUES (9136, 'e3b9f89c-423f-46a8-a5cb-e42de3b60e64', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:02', 175, 0, '', '2019-05-26 15:27:02');
INSERT INTO `access_log` VALUES (9137, 'c211a33a-dc9a-438c-a3c4-2edcaa7459e8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:04', 140, 0, '', '2019-05-26 15:27:04');
INSERT INTO `access_log` VALUES (9138, '128ec0d2-2299-486c-9fe4-2a9d78c1cd8b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:04', 147, 0, '', '2019-05-26 15:27:04');
INSERT INTO `access_log` VALUES (9139, 'f3979e6c-a51e-4e15-a07c-4c8bfb14e858', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:04', 143, 0, '', '2019-05-26 15:27:04');
INSERT INTO `access_log` VALUES (9140, '2dc31811-5f56-4536-a8e8-2cc9fb5b4599', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:04', 166, 0, '', '2019-05-26 15:27:04');
INSERT INTO `access_log` VALUES (9141, '96ea1ce1-9372-4564-929d-30dfd8df1a6a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:09', 134, 0, '', '2019-05-26 15:27:09');
INSERT INTO `access_log` VALUES (9142, 'ce1c2661-1eec-41a9-9842-e06055de29a4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:09', 139, 0, '', '2019-05-26 15:27:09');
INSERT INTO `access_log` VALUES (9143, '2b97ab61-4b13-4bbd-b43b-1c8d4318effe', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:09', 147, 0, '', '2019-05-26 15:27:09');
INSERT INTO `access_log` VALUES (9144, '1edc6ed9-a625-45ab-9c3b-cdd4c2986f20', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:09', 175, 0, '', '2019-05-26 15:27:09');
INSERT INTO `access_log` VALUES (9145, '9cc0fddf-4229-4c44-8ee5-3d5362c633e2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:57', 137, 0, '', '2019-05-26 15:27:57');
INSERT INTO `access_log` VALUES (9146, 'ca96917f-296e-4a26-b4a3-1a73e62084ee', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:57', 141, 0, '', '2019-05-26 15:27:57');
INSERT INTO `access_log` VALUES (9147, '151834d4-bb38-4210-8c51-d2c3fae46040', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:57', 143, 0, '', '2019-05-26 15:27:57');
INSERT INTO `access_log` VALUES (9148, '1286344d-45a8-47de-9bef-9e10320ad0ad', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:27:57', 175, 0, '', '2019-05-26 15:27:57');
INSERT INTO `access_log` VALUES (9149, '390ae6c3-c090-46c7-ba09-bfc65b65f830', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:26', 139, 0, '', '2019-05-26 15:28:26');
INSERT INTO `access_log` VALUES (9150, 'b9628f7f-7a1b-4a31-99b3-15eb42904502', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:26', 132, 0, '', '2019-05-26 15:28:26');
INSERT INTO `access_log` VALUES (9151, '1b3d499d-f58d-46b7-b6bc-e5cb85a7f5af', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:26', 146, 0, '', '2019-05-26 15:28:26');
INSERT INTO `access_log` VALUES (9152, '611b0732-8fdc-4667-a342-f4c907212b80', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:26', 213, 0, '', '2019-05-26 15:28:26');
INSERT INTO `access_log` VALUES (9153, 'c7ea38b7-30f0-409c-b571-139d5d17206d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:39', 145, 0, '', '2019-05-26 15:28:39');
INSERT INTO `access_log` VALUES (9154, '8106f7e4-1b6f-4a4b-8c11-590678acb526', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:39', 146, 0, '', '2019-05-26 15:28:39');
INSERT INTO `access_log` VALUES (9155, '41f4fe2d-80ea-448b-ae63-531f533c1548', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:39', 146, 0, '', '2019-05-26 15:28:39');
INSERT INTO `access_log` VALUES (9156, 'ce072656-537f-495e-ac34-22b4cedafb18', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:39', 190, 0, '', '2019-05-26 15:28:39');
INSERT INTO `access_log` VALUES (9157, '658db5d5-8457-4083-97fb-fd114986a4ee', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:43', 138, 0, '', '2019-05-26 15:28:44');
INSERT INTO `access_log` VALUES (9158, 'f2f839d5-52b1-49e5-9214-76ba87c68830', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:43', 139, 0, '', '2019-05-26 15:28:44');
INSERT INTO `access_log` VALUES (9159, 'b92bad46-8845-4a65-bf52-7ade43625ef7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:43', 138, 0, '', '2019-05-26 15:28:44');
INSERT INTO `access_log` VALUES (9160, '3f20090e-4e81-41f6-8683-ca578c5be1cf', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:43', 167, 0, '', '2019-05-26 15:28:44');
INSERT INTO `access_log` VALUES (9161, '50fb154e-a46b-42ca-8e80-2e30127b1dc5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:52', 156, 0, '', '2019-05-26 15:28:52');
INSERT INTO `access_log` VALUES (9162, '853bb870-c7f7-423e-ad67-d00450c13959', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:52', 208, 0, '', '2019-05-26 15:28:53');
INSERT INTO `access_log` VALUES (9163, '260ef9df-c4e2-40cc-9010-d9120ef63d60', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:52', 208, 0, '', '2019-05-26 15:28:53');
INSERT INTO `access_log` VALUES (9164, '9505751f-20c3-465c-a57c-0b93cbee9961', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:28:52', 240, 0, '', '2019-05-26 15:28:53');
INSERT INTO `access_log` VALUES (9165, '75975214-eda3-43aa-8f5e-efc048329cd1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:29:45', 139, 0, '', '2019-05-26 15:29:45');
INSERT INTO `access_log` VALUES (9166, 'ef8a01e7-3799-4538-91ce-2dcb1d489768', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:29:45', 141, 0, '', '2019-05-26 15:29:45');
INSERT INTO `access_log` VALUES (9167, '0173b970-e045-494f-85e7-1d986403a00a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:29:45', 139, 0, '', '2019-05-26 15:29:45');
INSERT INTO `access_log` VALUES (9168, 'fa736760-1bb7-4d83-b21d-98caa6384849', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:29:45', 198, 0, '', '2019-05-26 15:29:45');
INSERT INTO `access_log` VALUES (9169, '2eb69d25-d5cc-4a76-9a1c-98d46085166c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:19', 165, 0, '', '2019-05-26 15:33:19');
INSERT INTO `access_log` VALUES (9170, 'f12736fd-1c49-4629-aab9-deee2fb91ba7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:19', 169, 0, '', '2019-05-26 15:33:19');
INSERT INTO `access_log` VALUES (9171, '6e9f2f93-077c-4c18-b601-d90a0e66017a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:19', 170, 0, '', '2019-05-26 15:33:19');
INSERT INTO `access_log` VALUES (9172, '335466a8-ce9e-453b-8692-c8b6c658dd47', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:44', 136, 0, '', '2019-05-26 15:33:44');
INSERT INTO `access_log` VALUES (9173, 'd46478be-296e-4a99-94fc-140be0beb110', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:44', 131, 0, '', '2019-05-26 15:33:44');
INSERT INTO `access_log` VALUES (9174, 'e3161866-da2b-4470-9b4c-46916b09c187', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:44', 141, 0, '', '2019-05-26 15:33:44');
INSERT INTO `access_log` VALUES (9175, 'd5047335-df09-46ad-b148-cce011394fd1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:46', 137, 0, '', '2019-05-26 15:33:46');
INSERT INTO `access_log` VALUES (9176, '12417205-04cc-482a-a361-eefd06c0ce25', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:46', 135, 0, '', '2019-05-26 15:33:46');
INSERT INTO `access_log` VALUES (9177, 'd7a9ab58-8e0a-403e-a4cf-f2761f4c561e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:46', 141, 0, '', '2019-05-26 15:33:46');
INSERT INTO `access_log` VALUES (9178, '64119512-dd32-46d7-a1db-09bc9642a4a7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:58', 138, 0, '', '2019-05-26 15:33:58');
INSERT INTO `access_log` VALUES (9179, 'a7e2e6e2-d63f-4120-9493-c37dc9da62dc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:58', 131, 0, '', '2019-05-26 15:33:58');
INSERT INTO `access_log` VALUES (9180, '8fc0ef7a-90eb-4944-ac84-061e005cd6e1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:58', 142, 0, '', '2019-05-26 15:33:58');
INSERT INTO `access_log` VALUES (9181, '48949931-f00b-4804-aa40-a9812f8ec674', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:59', 138, 0, '', '2019-05-26 15:34:00');
INSERT INTO `access_log` VALUES (9182, '1d1f5dc8-acd3-47c6-8d9d-dbd3778c1901', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:59', 147, 0, '', '2019-05-26 15:34:00');
INSERT INTO `access_log` VALUES (9183, '050fddfa-5f0a-4193-8d10-e912c56d2b6c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:33:59', 145, 0, '', '2019-05-26 15:34:00');
INSERT INTO `access_log` VALUES (9184, 'd235dd44-8bb0-41b2-9467-9fe83ac8526e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:37:41', 570, 0, '', '2019-05-26 15:37:42');
INSERT INTO `access_log` VALUES (9185, '77b16e96-358b-4a29-bd95-7106ea6a68ca', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:37:41', 573, 0, '', '2019-05-26 15:37:42');
INSERT INTO `access_log` VALUES (9186, '394a3200-9c98-4698-9652-d9017e6d0faa', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:37:41', 570, 0, '', '2019-05-26 15:37:42');
INSERT INTO `access_log` VALUES (9187, '33b50585-3331-4cbb-bf92-b2b241d9bfeb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:01', 161, 0, '', '2019-05-26 15:38:01');
INSERT INTO `access_log` VALUES (9188, 'd6a83755-7edd-4a56-9ea1-1fa67b952c36', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:01', 164, 0, '', '2019-05-26 15:38:01');
INSERT INTO `access_log` VALUES (9189, '1022a5d4-edad-4814-a303-292063a77c27', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:01', 164, 0, '', '2019-05-26 15:38:01');
INSERT INTO `access_log` VALUES (9190, '65b790ae-040e-4a3f-b7f4-3d0cd37183b6', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:01', 382, 0, '', '2019-05-26 15:38:01');
INSERT INTO `access_log` VALUES (9191, '0fd5197d-5b57-4340-9849-f1098cbba32f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:03', 155, 0, '', '2019-05-26 15:38:03');
INSERT INTO `access_log` VALUES (9192, '974d649e-7c24-448b-b38d-1bc67d61d567', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:03', 157, 0, '', '2019-05-26 15:38:03');
INSERT INTO `access_log` VALUES (9193, '8701e8bd-1f14-4bba-99b2-85c413793b5d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:03', 154, 0, '', '2019-05-26 15:38:03');
INSERT INTO `access_log` VALUES (9194, '28e70bac-0fe4-45cd-96a3-cc15f172fa90', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:03', 184, 0, '', '2019-05-26 15:38:03');
INSERT INTO `access_log` VALUES (9195, 'ceb3a30a-03ed-42c4-864b-368d8692532b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:36', 154, 0, '', '2019-05-26 15:38:36');
INSERT INTO `access_log` VALUES (9196, 'd2411374-54e7-402b-8baa-9b803b767970', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:36', 154, 0, '', '2019-05-26 15:38:36');
INSERT INTO `access_log` VALUES (9197, '32ffd38d-f546-4303-9b62-c4ef33f81b13', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:36', 153, 0, '', '2019-05-26 15:38:36');
INSERT INTO `access_log` VALUES (9198, 'c6f525b2-9cc3-4a89-9b23-9d7f622e3784', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:36', 197, 0, '', '2019-05-26 15:38:36');
INSERT INTO `access_log` VALUES (9199, '132d217e-46e6-4316-bed2-2d7a77ee1783', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:38', 174, 0, '', '2019-05-26 15:38:39');
INSERT INTO `access_log` VALUES (9200, 'c249046c-d987-40b0-86d9-28bf92a227f5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:38', 171, 0, '', '2019-05-26 15:38:39');
INSERT INTO `access_log` VALUES (9201, 'c396bfde-b479-422e-8e30-b7b5ee4a96d3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:38', 185, 0, '', '2019-05-26 15:38:39');
INSERT INTO `access_log` VALUES (9202, '53aded5a-99a9-4872-8d98-5c874b785c11', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:38:39', 192, 0, '', '2019-05-26 15:38:39');
INSERT INTO `access_log` VALUES (9203, 'b7ccc477-9064-4152-88be-c24e06425777', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:40:07', 184, 0, '', '2019-05-26 15:40:08');
INSERT INTO `access_log` VALUES (9204, '7da55d66-c9cc-4b17-98cf-35741d82e187', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:40:07', 183, 0, '', '2019-05-26 15:40:08');
INSERT INTO `access_log` VALUES (9205, 'b96c40b3-cb7d-402a-9d9b-c5d969f6f282', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:40:07', 184, 0, '', '2019-05-26 15:40:08');
INSERT INTO `access_log` VALUES (9206, 'd06f061d-f7e9-44e5-a9cd-d26d0e87479a', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:40:08', 215, 0, '', '2019-05-26 15:40:08');
INSERT INTO `access_log` VALUES (9207, 'f17287ef-b622-48e1-bd44-8d756b811fcc', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:40:34', 38, 1002001012, '访问令牌已过期', '2019-05-26 15:40:34');
INSERT INTO `access_log` VALUES (9208, '5810cfd5-33f1-4ca8-813d-94c8a415c2ec', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:40:34', 37, 1002001012, '访问令牌已过期', '2019-05-26 15:40:34');
INSERT INTO `access_log` VALUES (9209, '09c394d8-8aab-4c53-a3b8-47cc58afb800', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:40:34', 41, 1002001012, '访问令牌已过期', '2019-05-26 15:40:34');
INSERT INTO `access_log` VALUES (9210, 'cd2a4986-456f-4be4-85f1-b7c943954010', 0, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:40:34', 36, 1002001012, '访问令牌已过期', '2019-05-26 15:40:34');
INSERT INTO `access_log` VALUES (9211, '368ddecf-3cae-4990-8cdb-5349db398f0a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:41:37', 460, 0, '', '2019-05-26 15:41:38');
INSERT INTO `access_log` VALUES (9212, '4884a422-2dad-4a88-abc7-dfe1622dc44d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:41:38', 143, 0, '', '2019-05-26 15:41:38');
INSERT INTO `access_log` VALUES (9213, 'c25b893b-1c1b-460f-a9e2-046b56b09db2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:41:38', 180, 0, '', '2019-05-26 15:41:38');
INSERT INTO `access_log` VALUES (9214, '4f4bf759-712e-4d98-8c7e-7974fa8ca91d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:41:38', 177, 0, '', '2019-05-26 15:41:38');
INSERT INTO `access_log` VALUES (9215, 'c5c2c8ea-a034-4be1-bfb9-25329e1d9f09', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:41:40', 186, 0, '', '2019-05-26 15:41:40');
INSERT INTO `access_log` VALUES (9216, '08b48f53-2b4c-47d6-9aef-d3c7687ab69d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:41:57', 155, 0, '', '2019-05-26 15:41:57');
INSERT INTO `access_log` VALUES (9217, '2c52f6d5-8648-433d-9ce4-bc098012c61d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:41:57', 152, 0, '', '2019-05-26 15:41:57');
INSERT INTO `access_log` VALUES (9218, '8b9fbd81-ef99-4d1e-a3be-fed55c04d931', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:41:57', 155, 0, '', '2019-05-26 15:41:57');
INSERT INTO `access_log` VALUES (9219, 'f95a88f6-31a5-4c59-a066-e3deeb297288', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:41:57', 219, 0, '', '2019-05-26 15:41:57');
INSERT INTO `access_log` VALUES (9220, 'a8b9a142-f349-40b3-b82b-73f0f2aacf62', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:42:01', 154, 0, '', '2019-05-26 15:42:01');
INSERT INTO `access_log` VALUES (9221, '29d79e97-29d2-4469-8a4e-65818e4dcd43', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:42:01', 145, 0, '', '2019-05-26 15:42:01');
INSERT INTO `access_log` VALUES (9222, '4f1a77ba-e63a-438c-b069-8d1b6a195466', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:42:01', 151, 0, '', '2019-05-26 15:42:01');
INSERT INTO `access_log` VALUES (9223, '1020d163-0664-41fc-a701-b21acea986c1', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:42:01', 191, 0, '', '2019-05-26 15:42:01');
INSERT INTO `access_log` VALUES (9224, '5b18aef5-49c9-42a6-83c2-0f48abad7081', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:18', 177, 0, '', '2019-05-26 15:43:18');
INSERT INTO `access_log` VALUES (9225, '100d456e-9225-4f35-830f-ed8cc76bbc92', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:18', 179, 0, '', '2019-05-26 15:43:18');
INSERT INTO `access_log` VALUES (9226, '22f9e745-e4c1-4cc5-8935-25703c554045', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:18', 177, 0, '', '2019-05-26 15:43:18');
INSERT INTO `access_log` VALUES (9227, 'c9995ee4-c3c2-4a1b-98ea-34e338663353', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:33', 149, 0, '', '2019-05-26 15:43:33');
INSERT INTO `access_log` VALUES (9228, '871ff175-3d4b-470f-a3ce-625acf5d4243', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:33', 154, 0, '', '2019-05-26 15:43:33');
INSERT INTO `access_log` VALUES (9229, 'fc22e3b3-9ae3-4f8e-bcec-d0464e1517ab', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:33', 148, 0, '', '2019-05-26 15:43:33');
INSERT INTO `access_log` VALUES (9230, '084d01a7-7f76-4b47-901c-a4500a552c5b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:33', 230, 0, '', '2019-05-26 15:43:34');
INSERT INTO `access_log` VALUES (9231, '2edc6349-6651-4226-ad18-fba626931570', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:36', 149, 0, '', '2019-05-26 15:43:37');
INSERT INTO `access_log` VALUES (9232, '4d085ce9-2fe4-46b5-9718-30d11e004b78', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:36', 147, 0, '', '2019-05-26 15:43:37');
INSERT INTO `access_log` VALUES (9233, 'b5dd6f61-860b-49c3-ac92-46d2988927f3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:36', 141, 0, '', '2019-05-26 15:43:37');
INSERT INTO `access_log` VALUES (9234, '2bd09730-659a-4cd3-a47b-3c588f91fe20', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:37', 182, 0, '', '2019-05-26 15:43:37');
INSERT INTO `access_log` VALUES (9235, '729343e0-1652-4a2f-8a51-a69bfec040e2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:47', 186, 0, '', '2019-05-26 15:43:47');
INSERT INTO `access_log` VALUES (9236, '720f04d4-82c3-4dc8-bb82-ac5ad052dd44', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:47', 183, 0, '', '2019-05-26 15:43:47');
INSERT INTO `access_log` VALUES (9237, '6b5e9e24-5dc7-4e62-a56b-5cb8f189d56f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:47', 179, 0, '', '2019-05-26 15:43:47');
INSERT INTO `access_log` VALUES (9238, '4bceb106-630c-4065-8a8a-619662b5a50e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:43:47', 197, 0, '', '2019-05-26 15:43:47');
INSERT INTO `access_log` VALUES (9239, '500d38be-89a6-41ff-8ae8-d3c1562dd790', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:02', 146, 0, '', '2019-05-26 15:44:02');
INSERT INTO `access_log` VALUES (9240, '183e464c-3f4c-4dfe-819d-3d6388e46e0b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:02', 145, 0, '', '2019-05-26 15:44:02');
INSERT INTO `access_log` VALUES (9241, '67ab0a06-b8b1-4906-bc90-4eb091bb3fce', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:02', 144, 0, '', '2019-05-26 15:44:02');
INSERT INTO `access_log` VALUES (9242, 'ec3f8d72-0b65-4a0e-8a24-5f8525ab2651', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:02', 177, 0, '', '2019-05-26 15:44:02');
INSERT INTO `access_log` VALUES (9243, 'e29830c9-e5fb-47b4-b735-6d1642f40aad', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:27', 150, 0, '', '2019-05-26 15:44:27');
INSERT INTO `access_log` VALUES (9244, 'd9515d31-2be6-43e9-9cf7-ae6a5a9dc10d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:27', 153, 0, '', '2019-05-26 15:44:27');
INSERT INTO `access_log` VALUES (9245, '1e501aff-1af0-4f24-9fab-b554081af572', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:27', 152, 0, '', '2019-05-26 15:44:27');
INSERT INTO `access_log` VALUES (9246, 'e7ae4b03-b0a3-4116-ad65-ba993edcea6e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:27', 183, 0, '', '2019-05-26 15:44:27');
INSERT INTO `access_log` VALUES (9247, '2201fdea-fadd-405e-9aae-329aa28b88ad', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:30', 150, 0, '', '2019-05-26 15:44:31');
INSERT INTO `access_log` VALUES (9248, 'cbd078d9-18b1-4917-b412-a42aeb73dbd1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:30', 150, 0, '', '2019-05-26 15:44:31');
INSERT INTO `access_log` VALUES (9249, 'bafb7f5f-dbf2-4532-bfcd-73a490d5b604', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:30', 181, 0, '', '2019-05-26 15:44:31');
INSERT INTO `access_log` VALUES (9250, '2f81ac10-227c-4df4-a1e5-b4395bc5625e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:30', 309, 0, '', '2019-05-26 15:44:31');
INSERT INTO `access_log` VALUES (9251, '612b608a-9b84-4448-8f41-64eb4ce02408', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:32', 146, 0, '', '2019-05-26 15:44:32');
INSERT INTO `access_log` VALUES (9252, '82efcec2-ce07-4682-81d2-f9afbdcd30dd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:32', 146, 0, '', '2019-05-26 15:44:32');
INSERT INTO `access_log` VALUES (9253, 'c4b27be4-8662-47d8-96cf-610a5d5b2dc7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:32', 149, 0, '', '2019-05-26 15:44:32');
INSERT INTO `access_log` VALUES (9254, '808355ed-cac1-46e6-bf10-f2ea565244af', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:32', 187, 0, '', '2019-05-26 15:44:32');
INSERT INTO `access_log` VALUES (9255, '4120efa3-8662-436f-86e7-8e82c5c3dfb4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:36', 145, 0, '', '2019-05-26 15:44:36');
INSERT INTO `access_log` VALUES (9256, '9334b9cb-61c4-4196-b5f8-d74f419e2c55', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:36', 146, 0, '', '2019-05-26 15:44:36');
INSERT INTO `access_log` VALUES (9257, '949c16d5-a5af-4832-aeeb-58f774f0c55a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:36', 145, 0, '', '2019-05-26 15:44:36');
INSERT INTO `access_log` VALUES (9258, 'd1014a8c-78dd-4fff-b18f-130d1f860eea', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:36', 184, 0, '', '2019-05-26 15:44:37');
INSERT INTO `access_log` VALUES (9259, 'a52d37af-a314-420f-ae8e-6b7285bcf9a9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:53', 383, 0, '', '2019-05-26 15:44:54');
INSERT INTO `access_log` VALUES (9260, '0affac95-b414-4a49-9fea-8fb47c58616a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:53', 384, 0, '', '2019-05-26 15:44:54');
INSERT INTO `access_log` VALUES (9261, 'aa75fb17-a1dd-45a3-bac1-0d4ffe86dabe', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:53', 383, 0, '', '2019-05-26 15:44:54');
INSERT INTO `access_log` VALUES (9262, '9d0b5c7c-4adc-49a3-ba6a-cd084fcac1cf', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:44:54', 362, 0, '', '2019-05-26 15:44:54');
INSERT INTO `access_log` VALUES (9263, 'f35b0a94-ed2d-4d84-83a0-9978da2e1ddd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:45:08', 147, 0, '', '2019-05-26 15:45:09');
INSERT INTO `access_log` VALUES (9264, 'be2f7bf2-66ee-4168-ae12-8a0d26bd7bfc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:45:08', 144, 0, '', '2019-05-26 15:45:09');
INSERT INTO `access_log` VALUES (9265, '83d71cd5-ce0d-4812-9cc1-5c0c4e25d1b7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:45:08', 144, 0, '', '2019-05-26 15:45:09');
INSERT INTO `access_log` VALUES (9266, 'c12806b6-32dc-49c2-a8dd-6a1628cbfa95', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:45:08', 183, 0, '', '2019-05-26 15:45:09');
INSERT INTO `access_log` VALUES (9267, '0b820b04-fe39-4f26-b3ce-b09b029524ed', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:03', 406, 0, '', '2019-05-26 15:46:03');
INSERT INTO `access_log` VALUES (9268, '09fbce54-6b1b-4dab-a46a-eda92a83e180', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:03', 404, 0, '', '2019-05-26 15:46:03');
INSERT INTO `access_log` VALUES (9269, '71177f40-f9e0-4ee9-95b8-ee596ae955a6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:03', 405, 0, '', '2019-05-26 15:46:03');
INSERT INTO `access_log` VALUES (9270, '6409a6b2-309c-42b6-9f47-e0cc9ae2b4b7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:13', 141, 0, '', '2019-05-26 15:46:13');
INSERT INTO `access_log` VALUES (9271, 'e8db43b7-cbb2-4fc3-aa36-16bc6cd8dde2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:13', 143, 0, '', '2019-05-26 15:46:13');
INSERT INTO `access_log` VALUES (9272, '9a28311d-df63-439e-8799-664d92e77524', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:13', 214, 0, '', '2019-05-26 15:46:14');
INSERT INTO `access_log` VALUES (9273, '7eb60e09-95f6-4319-bd70-083f2d0d1daa', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:13', 300, 2001001000, '服务端发生异常', '2019-05-26 15:46:14');
INSERT INTO `access_log` VALUES (9274, '070193f5-1e5a-48a4-944e-03234f25e970', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:15', 150, 0, '', '2019-05-26 15:46:15');
INSERT INTO `access_log` VALUES (9275, 'a1014037-84a4-4bde-9813-55187d9782c5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:15', 144, 0, '', '2019-05-26 15:46:15');
INSERT INTO `access_log` VALUES (9276, 'e351af54-560e-41ae-b75d-117747380794', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:15', 147, 0, '', '2019-05-26 15:46:15');
INSERT INTO `access_log` VALUES (9277, 'f8ee4f11-aa10-41c6-a473-87ff5aab62dc', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:15', 181, 0, '', '2019-05-26 15:46:15');
INSERT INTO `access_log` VALUES (9278, '0406a8c4-9c35-43f2-baa2-e8db5844ef67', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:23', 146, 0, '', '2019-05-26 15:46:23');
INSERT INTO `access_log` VALUES (9279, '63d0ec20-690a-4d9b-b1cb-282aa7f1959c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:23', 148, 0, '', '2019-05-26 15:46:23');
INSERT INTO `access_log` VALUES (9280, 'a80ad145-a108-40d0-930d-eb71c0001a5b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:23', 147, 0, '', '2019-05-26 15:46:23');
INSERT INTO `access_log` VALUES (9281, '6f02add0-13ea-4a9d-ace9-b39f23881621', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:23', 180, 0, '', '2019-05-26 15:46:23');
INSERT INTO `access_log` VALUES (9282, 'b50d5647-c35e-4b31-9d46-34e031515d8f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:39', 139, 0, '', '2019-05-26 15:46:39');
INSERT INTO `access_log` VALUES (9283, '21763ed0-bacf-48c4-98de-c5fceca9754c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:39', 139, 0, '', '2019-05-26 15:46:39');
INSERT INTO `access_log` VALUES (9284, '907cda82-9583-47a3-88e9-c35d3ec585b7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:39', 146, 0, '', '2019-05-26 15:46:39');
INSERT INTO `access_log` VALUES (9285, 'f283ff12-9293-4814-a8fd-18a92f9ea855', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:39', 180, 0, '', '2019-05-26 15:46:39');
INSERT INTO `access_log` VALUES (9286, 'eb9d42c5-a58b-492c-95d3-35d3f58adfdd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:44', 141, 0, '', '2019-05-26 15:46:44');
INSERT INTO `access_log` VALUES (9287, '3c7e60f1-a4dc-4c1e-978b-5ab5dafc85a0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:44', 142, 0, '', '2019-05-26 15:46:44');
INSERT INTO `access_log` VALUES (9288, 'bebbe4b1-22a8-4580-aab6-e0e9fed7a2e1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:44', 142, 0, '', '2019-05-26 15:46:44');
INSERT INTO `access_log` VALUES (9289, '08a65694-2bed-4b48-ae8a-46304e04dd86', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:44', 176, 0, '', '2019-05-26 15:46:44');
INSERT INTO `access_log` VALUES (9290, '0c16a622-3e27-4153-b3c4-193768d009de', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:50:05', 188, 0, '', '2019-05-26 15:50:05');
INSERT INTO `access_log` VALUES (9291, 'c8924292-c86b-4dda-ae61-3e8b58b64589', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:50:05', 190, 0, '', '2019-05-26 15:50:05');
INSERT INTO `access_log` VALUES (9292, 'ae704e1f-3d43-48d5-a71d-6e63fb3d8b89', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:50:05', 185, 0, '', '2019-05-26 15:50:05');
INSERT INTO `access_log` VALUES (9293, 'cdcf20b9-0510-4aa5-9753-78d5faf2804b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:50:06', 186, 0, '', '2019-05-26 15:50:06');
INSERT INTO `access_log` VALUES (9294, '8c2aa7a3-65c1-4708-89fa-f831b5d94160', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:59:56', 1627, 0, '', '2019-05-26 15:59:57');
INSERT INTO `access_log` VALUES (9295, 'cb90857f-c3d0-49be-aa93-c3fded9568ea', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:59:56', 1660, 0, '', '2019-05-26 15:59:57');
INSERT INTO `access_log` VALUES (9296, 'e008dc87-9c11-4bc3-a1c9-cc7de5f4acca', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:59:56', 2171, 0, '', '2019-05-26 15:59:58');
INSERT INTO `access_log` VALUES (9297, '3b92aa47-a00b-4b22-b283-a86efdd21bc0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:22', 148, 0, '', '2019-05-26 16:00:22');
INSERT INTO `access_log` VALUES (9298, 'cfaa3ccd-472c-48f6-9a6b-30df526a9678', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:22', 148, 0, '', '2019-05-26 16:00:22');
INSERT INTO `access_log` VALUES (9299, '0cb19ff4-5f7a-4bda-970c-34552c369cd8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:22', 151, 0, '', '2019-05-26 16:00:22');
INSERT INTO `access_log` VALUES (9300, '40cb4035-9824-4abf-be78-ca7fda1ab65a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:24', 213, 0, '', '2019-05-26 16:00:25');
INSERT INTO `access_log` VALUES (9301, 'd011d9d4-00a1-495f-aa23-04b22d44b161', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:24', 207, 0, '', '2019-05-26 16:00:25');
INSERT INTO `access_log` VALUES (9302, '348e0206-9b20-4812-9384-035801ae06af', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:24', 211, 0, '', '2019-05-26 16:00:25');
INSERT INTO `access_log` VALUES (9303, '59.79.15588576312326717', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36 QIHU 360SE/Nutch-1.13', '61.129.39.82', '2019-05-26 16:00:31', 14, 2001001000, '服务端发生异常', '2019-05-26 16:00:31');
INSERT INTO `access_log` VALUES (9304, 'a586f003-cd0d-4567-92a4-1d3daadee27d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:46', 148, 0, '', '2019-05-26 16:00:46');
INSERT INTO `access_log` VALUES (9305, '48bad089-7161-40f7-93d1-08fd7ea51817', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:46', 148, 0, '', '2019-05-26 16:00:46');
INSERT INTO `access_log` VALUES (9306, '9f32135a-067d-4c8d-bbd7-f1d1d470401d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:46', 148, 0, '', '2019-05-26 16:00:46');
INSERT INTO `access_log` VALUES (9307, '855801f5-e811-45a8-a9ed-f96a0879a597', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:47', 149, 0, '', '2019-05-26 16:00:47');
INSERT INTO `access_log` VALUES (9308, '84afd113-68fd-4900-9050-d9a2a9c7f569', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:47', 153, 0, '', '2019-05-26 16:00:47');
INSERT INTO `access_log` VALUES (9309, '4188a702-79c3-4792-a90e-304302e1073d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:47', 146, 0, '', '2019-05-26 16:00:47');
INSERT INTO `access_log` VALUES (9310, 'a616b03c-7965-4475-8ff6-8f7e00a0e5e1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:55', 145, 0, '', '2019-05-26 16:00:55');
INSERT INTO `access_log` VALUES (9311, '1ee77021-56de-423b-91d4-b9f25a8ff48c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:55', 143, 0, '', '2019-05-26 16:00:55');
INSERT INTO `access_log` VALUES (9312, 'fd3699ab-dc3a-41a9-916b-bf8946e4a24c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:55', 146, 0, '', '2019-05-26 16:00:55');
INSERT INTO `access_log` VALUES (9313, '8deec186-dd4b-43a9-b1b9-7bbf863888e6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:57', 148, 0, '', '2019-05-26 16:00:57');
INSERT INTO `access_log` VALUES (9314, 'e09d2b79-b711-4a6e-96be-4960f3c2c386', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:57', 151, 0, '', '2019-05-26 16:00:57');
INSERT INTO `access_log` VALUES (9315, '2286dc38-947d-49a7-9573-98ffa70939b6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:00:57', 151, 0, '', '2019-05-26 16:00:57');
INSERT INTO `access_log` VALUES (9316, '1f874642-09a7-4a8e-ac37-4ff80646731b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:01:24', 155, 0, '', '2019-05-26 16:01:25');
INSERT INTO `access_log` VALUES (9317, '309ac3f0-bf61-4667-8c7a-649c2b7bf02f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:01:24', 154, 0, '', '2019-05-26 16:01:25');
INSERT INTO `access_log` VALUES (9318, 'c4683f51-5d92-4808-bea8-1af6b8405a71', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:01:24', 155, 0, '', '2019-05-26 16:01:25');
INSERT INTO `access_log` VALUES (9319, '635111b0-395a-4697-9d7e-391a8ef51f32', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:01:27', 152, 0, '', '2019-05-26 16:01:27');
INSERT INTO `access_log` VALUES (9320, '592c532e-3115-4bee-ac0b-9a363ec2fc9b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:01:27', 147, 0, '', '2019-05-26 16:01:27');
INSERT INTO `access_log` VALUES (9321, '62fa5f71-8d42-4b63-8e7e-140cd7668c16', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:01:27', 152, 0, '', '2019-05-26 16:01:27');
INSERT INTO `access_log` VALUES (9322, '06b85b32-d16f-4d02-8f9a-5d89dcd9ee41', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:10:03', 1812, 0, '', '2019-05-26 16:10:05');
INSERT INTO `access_log` VALUES (9323, '6d2ad7da-bf6b-461d-a0af-798da3a8ea34', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:10:03', 1885, 0, '', '2019-05-26 16:10:05');
INSERT INTO `access_log` VALUES (9324, '14f9647c-d8eb-4a53-ba3e-389e2310d0e1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:10:05', 385, 0, '', '2019-05-26 16:10:05');
INSERT INTO `access_log` VALUES (9325, 'b71208aa-1846-4962-be46-6b968323cbf1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:10:05', 561, 0, '', '2019-05-26 16:10:05');
INSERT INTO `access_log` VALUES (9326, 'a516f2d3-2803-4233-a3b6-b1e073a01681', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:10:05', 709, 0, '', '2019-05-26 16:10:05');
INSERT INTO `access_log` VALUES (9327, '21f90587-dd4c-4b2b-b8fe-cdb0419e0abf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:10:03', 2291, 2001001000, '服务端发生异常', '2019-05-26 16:10:05');
INSERT INTO `access_log` VALUES (9328, '58f58aab-de8a-4766-9e27-4ff87eac5096', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:10:14', 962, 0, '', '2019-05-26 16:10:15');
INSERT INTO `access_log` VALUES (9329, 'b5dac47e-0574-4d0c-9591-c9b01a18d9c3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:10:14', 957, 0, '', '2019-05-26 16:10:15');
INSERT INTO `access_log` VALUES (9330, 'a1561c56-e69e-46a2-b16b-3d4739737ec0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:10:14', 960, 0, '', '2019-05-26 16:10:15');
INSERT INTO `access_log` VALUES (9331, '88cbaaa0-62d0-4e0a-81d4-5168abffeff3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:10:39', 140, 0, '', '2019-05-26 16:10:39');
INSERT INTO `access_log` VALUES (9332, '2b5366da-e191-4686-a9b2-e168fd53d7e7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:10:39', 149, 0, '', '2019-05-26 16:10:39');
INSERT INTO `access_log` VALUES (9333, '58610f5c-562c-4a48-bee7-0c398bdd7658', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:10:39', 145, 0, '', '2019-05-26 16:10:39');
INSERT INTO `access_log` VALUES (9334, 'dcdc1c32-a81d-4228-b83d-257b5f1171ec', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:11:00', 143, 0, '', '2019-05-26 16:11:00');
INSERT INTO `access_log` VALUES (9335, 'f4e67c6d-b556-4c17-a38b-f5dfdc81f4d5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:11:00', 143, 0, '', '2019-05-26 16:11:00');
INSERT INTO `access_log` VALUES (9336, '790f4471-9e15-4176-ba74-aa48f02edabf', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:11:00', 144, 0, '', '2019-05-26 16:11:00');
INSERT INTO `access_log` VALUES (9337, 'ed38d1b1-f529-4b7c-a337-e13301536c79', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:11:00', 180, 0, '', '2019-05-26 16:11:00');
INSERT INTO `access_log` VALUES (9338, '3328a14f-382c-46d8-adb6-7f3535cbd93e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:11:02', 228, 0, '', '2019-05-26 16:11:02');
INSERT INTO `access_log` VALUES (9339, '70313fa7-ee8d-44c9-85eb-12f1a30c4cd9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:11:02', 229, 0, '', '2019-05-26 16:11:02');
INSERT INTO `access_log` VALUES (9340, '1da48bdc-dca8-4940-9cda-ac456ded43c3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:11:02', 227, 0, '', '2019-05-26 16:11:02');
INSERT INTO `access_log` VALUES (9341, 'dcf1daff-5304-4d1b-a20c-fbf92dd12494', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:11:02', 174, 0, '', '2019-05-26 16:11:02');
INSERT INTO `access_log` VALUES (9342, '7a949468-250f-4b30-948b-e89a8ac2df76', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:11:14', 140, 0, '', '2019-05-26 16:11:14');
INSERT INTO `access_log` VALUES (9343, '3ea9f053-c43b-4ab9-95fc-6d816b4ea818', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:11:14', 141, 0, '', '2019-05-26 16:11:14');
INSERT INTO `access_log` VALUES (9344, '084713ec-cdce-4c4b-bfdb-91e31d266cae', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:11:14', 147, 0, '', '2019-05-26 16:11:14');
INSERT INTO `access_log` VALUES (9345, 'fabeee30-6c3f-4ce3-abdf-27796faa20d1', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:11:14', 182, 0, '', '2019-05-26 16:11:14');
INSERT INTO `access_log` VALUES (9346, '2f6842ba-afa8-41d2-bf27-cb15e0cf1b41', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:12:04', 938, 0, '', '2019-05-26 16:12:05');
INSERT INTO `access_log` VALUES (9347, '4d112406-725f-4c6b-96e6-7070f082b17b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:12:04', 934, 0, '', '2019-05-26 16:12:05');
INSERT INTO `access_log` VALUES (9348, '9741bfc8-562a-4920-a586-c8bb8aff571e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:12:04', 938, 0, '', '2019-05-26 16:12:05');
INSERT INTO `access_log` VALUES (9349, 'd3f0fcf7-55c7-4b77-b7e1-3e29f86e759f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:12:04', 970, 0, '', '2019-05-26 16:12:05');
INSERT INTO `access_log` VALUES (9350, '0c555002-feb7-4e80-aee9-a268ed06154d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:12:56', 535, 0, '', '2019-05-26 16:12:57');
INSERT INTO `access_log` VALUES (9351, 'b17e46b6-5236-4b1b-b0e1-f03a17db7b1e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:12:56', 541, 0, '', '2019-05-26 16:12:57');
INSERT INTO `access_log` VALUES (9352, '38223348-a824-4ab4-be75-8a9e21d8d573', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:12:56', 541, 0, '', '2019-05-26 16:12:57');
INSERT INTO `access_log` VALUES (9353, '5c64d333-51ec-409a-9424-a53a19f39d36', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:12:57', 234, 0, '', '2019-05-26 16:12:58');
INSERT INTO `access_log` VALUES (9354, '59ced7ae-55ec-4211-b8c8-54086aceb373', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:12:59', 164, 0, '', '2019-05-26 16:12:59');
INSERT INTO `access_log` VALUES (9355, 'fd336fb4-afaa-486b-ba11-2bceec31a6d4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:12:59', 166, 0, '', '2019-05-26 16:12:59');
INSERT INTO `access_log` VALUES (9356, '1ce4058a-a706-4ff9-af49-93ae6b7f275d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:12:59', 161, 0, '', '2019-05-26 16:12:59');
INSERT INTO `access_log` VALUES (9357, '20f13a5d-0f42-47ff-8c67-961eafea98d8', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:12:59', 175, 0, '', '2019-05-26 16:12:59');
INSERT INTO `access_log` VALUES (9358, 'f52fcd3c-d6a7-48cf-b7da-bda595b7397d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:13:19', 248, 0, '', '2019-05-26 16:13:19');
INSERT INTO `access_log` VALUES (9359, 'c1bdf3c5-f00b-407d-b98e-27f40af4198b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:13:19', 246, 0, '', '2019-05-26 16:13:19');
INSERT INTO `access_log` VALUES (9360, '84cbb552-bcd4-4b5a-aa22-1a3cbe251591', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:13:19', 247, 0, '', '2019-05-26 16:13:19');
INSERT INTO `access_log` VALUES (9361, '11c1cecd-b27c-4426-9dc8-8dc83c4ef6b4', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:13:20', 178, 0, '', '2019-05-26 16:13:20');
INSERT INTO `access_log` VALUES (9362, 'd04c1f28-0bb1-496b-9d56-5a3b8a5f9720', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:13:55', 141, 0, '', '2019-05-26 16:13:55');
INSERT INTO `access_log` VALUES (9363, '682c6040-9bff-444e-b88d-28ea021edd83', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:13:55', 142, 0, '', '2019-05-26 16:13:55');
INSERT INTO `access_log` VALUES (9364, '554bee13-f7eb-4004-a7ad-dacb69f83bd9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:13:55', 163, 0, '', '2019-05-26 16:13:55');
INSERT INTO `access_log` VALUES (9365, '5369f0ad-b835-47f4-8c6d-70fd4d465aaf', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:13:55', 179, 0, '', '2019-05-26 16:13:55');
INSERT INTO `access_log` VALUES (9366, '9d252087-1f9f-49b5-8d48-8a2d3bf33c4d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:14:02', 204, 0, '', '2019-05-26 16:14:02');
INSERT INTO `access_log` VALUES (9367, '19c3fe81-a71b-4088-b309-e35a59ecdb82', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:14:02', 205, 0, '', '2019-05-26 16:14:02');
INSERT INTO `access_log` VALUES (9368, '81daa285-7899-4fcf-a8d1-fdd914d29e33', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:14:02', 203, 0, '', '2019-05-26 16:14:02');
INSERT INTO `access_log` VALUES (9369, '7be592d4-4e6e-4d8c-b03a-38e04f10c5e4', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:14:02', 173, 0, '', '2019-05-26 16:14:02');
INSERT INTO `access_log` VALUES (9370, '5a333169-cabc-4646-8a98-38eb0efa63d7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:14:05', 144, 0, '', '2019-05-26 16:14:06');
INSERT INTO `access_log` VALUES (9371, '26601c77-bc51-4c01-b564-a8ceade6f811', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:14:05', 149, 0, '', '2019-05-26 16:14:06');
INSERT INTO `access_log` VALUES (9372, '26918ca1-e5d7-49a5-9796-3e0847cb2c78', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:14:05', 150, 0, '', '2019-05-26 16:14:06');
INSERT INTO `access_log` VALUES (9373, 'a2d63afe-bf2d-4288-b9e8-f9e58e341d12', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:14:06', 183, 0, '', '2019-05-26 16:14:06');
INSERT INTO `access_log` VALUES (9374, '797f3cfa-1c5c-4e71-be40-89b6f0c3b1fd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:15:31', 179, 0, '', '2019-05-26 16:15:32');
INSERT INTO `access_log` VALUES (9375, '5baca51e-13ce-445a-93ee-306137f412aa', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:15:31', 178, 0, '', '2019-05-26 16:15:32');
INSERT INTO `access_log` VALUES (9376, '3d0d826d-b308-45a1-98e7-bdd547902a9e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:15:31', 179, 0, '', '2019-05-26 16:15:32');
INSERT INTO `access_log` VALUES (9377, '98875cc0-aa41-4205-9ad1-318f96fa44f2', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:15:32', 178, 0, '', '2019-05-26 16:15:32');
INSERT INTO `access_log` VALUES (9378, 'c9e16a48-7537-4fba-b597-9282fc22d8fd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:15:40', 258, 0, '', '2019-05-26 16:15:41');
INSERT INTO `access_log` VALUES (9379, '6a3f5532-cd98-4bab-806d-d586cbfa50a6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:15:40', 263, 0, '', '2019-05-26 16:15:41');
INSERT INTO `access_log` VALUES (9380, '79424078-f419-4e79-b9b2-c3510fc5b8ff', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:15:40', 265, 0, '', '2019-05-26 16:15:41');
INSERT INTO `access_log` VALUES (9381, '1dab13f8-7070-4d22-a5cd-4dfe9339801c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:15:40', 264, 0, '', '2019-05-26 16:15:41');
INSERT INTO `access_log` VALUES (9382, 'a7f1f439-206d-4e20-baf8-1b6670215dda', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:16:27', 144, 0, '', '2019-05-26 16:16:27');
INSERT INTO `access_log` VALUES (9383, 'b8063e7e-a8eb-4f50-8315-4becef41fca3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:16:27', 141, 0, '', '2019-05-26 16:16:27');
INSERT INTO `access_log` VALUES (9384, '4f25d43b-7493-4c4e-a92f-8bb5ce30eb31', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:16:27', 145, 0, '', '2019-05-26 16:16:27');
INSERT INTO `access_log` VALUES (9385, '72d59d17-0c14-4acf-a19a-086df0fea7ba', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:16:27', 180, 0, '', '2019-05-26 16:16:28');
INSERT INTO `access_log` VALUES (9386, '08328e91-9d8f-45f5-b84b-d5f54e104b0f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:19:37', 183, 0, '', '2019-05-26 16:19:38');
INSERT INTO `access_log` VALUES (9387, '23ce3cfa-c437-4244-8a50-532eabadfb13', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:19:37', 181, 0, '', '2019-05-26 16:19:38');
INSERT INTO `access_log` VALUES (9388, '6b1d389c-e68e-4875-a6b4-c6a99866f1fe', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:19:37', 184, 0, '', '2019-05-26 16:19:38');
INSERT INTO `access_log` VALUES (9389, 'f8ae83c4-f902-40ef-b913-91d37f2babf4', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:19:38', 211, 0, '', '2019-05-26 16:19:38');
INSERT INTO `access_log` VALUES (9390, '3890f1a6-abd1-46bc-98c4-eb797d2d7070', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:21', 148, 0, '', '2019-05-26 16:20:21');
INSERT INTO `access_log` VALUES (9391, '271705fe-28cf-4c49-ba4c-e47f182811bc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:21', 148, 0, '', '2019-05-26 16:20:21');
INSERT INTO `access_log` VALUES (9392, 'b9f3ad3b-e388-4a04-bd0f-dfd835066518', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:21', 149, 0, '', '2019-05-26 16:20:21');
INSERT INTO `access_log` VALUES (9393, 'd429d73e-1b37-4c06-99f3-b337c595f8c3', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:21', 183, 0, '', '2019-05-26 16:20:21');
INSERT INTO `access_log` VALUES (9394, '18380115-0221-4186-9e51-4f908d1c066e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:22', 146, 0, '', '2019-05-26 16:20:22');
INSERT INTO `access_log` VALUES (9395, '89592ee7-da22-4a8e-9895-b3e343e827b9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:22', 142, 0, '', '2019-05-26 16:20:22');
INSERT INTO `access_log` VALUES (9396, '8daa0a99-0054-46f9-8cb8-4a6afa6d2faf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:22', 145, 0, '', '2019-05-26 16:20:22');
INSERT INTO `access_log` VALUES (9397, 'b0fd67c7-667b-4632-ad26-5d7cdf5fd3f9', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:22', 183, 0, '', '2019-05-26 16:20:23');
INSERT INTO `access_log` VALUES (9398, '5f4006a7-3ace-4908-87fb-619b23852b95', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:36', 141, 0, '', '2019-05-26 16:20:36');
INSERT INTO `access_log` VALUES (9399, 'e3e9a859-ee27-4644-ab9b-80c7848d2bc7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:36', 148, 0, '', '2019-05-26 16:20:36');
INSERT INTO `access_log` VALUES (9400, '21d1209b-b0aa-435f-9200-82550cf50a96', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:36', 146, 0, '', '2019-05-26 16:20:36');
INSERT INTO `access_log` VALUES (9401, '36ba9ab1-b424-4446-86af-77f8c6956cb0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:36', 186, 0, '', '2019-05-26 16:20:37');
INSERT INTO `access_log` VALUES (9402, 'ff3e6069-8fb6-46d5-a643-6a5f4f0d6b49', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:51', 145, 0, '', '2019-05-26 16:20:52');
INSERT INTO `access_log` VALUES (9403, 'e515ddf6-97d3-425e-a1bf-d897438a3351', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:51', 142, 0, '', '2019-05-26 16:20:52');
INSERT INTO `access_log` VALUES (9404, '5184355c-1b37-4bb3-93b4-69caf15e1a2b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:51', 140, 0, '', '2019-05-26 16:20:52');
INSERT INTO `access_log` VALUES (9405, '41b6cdb0-1726-4088-ae5a-9f15bef2b63e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:20:51', 179, 0, '', '2019-05-26 16:20:52');
INSERT INTO `access_log` VALUES (9406, 'e64e54a5-2b1e-4d6f-9066-619f637a5a75', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:21:55', 169, 0, '', '2019-05-26 16:21:55');
INSERT INTO `access_log` VALUES (9407, 'b3d846e1-241a-4166-8945-b3afbec2651d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:21:55', 171, 0, '', '2019-05-26 16:21:55');
INSERT INTO `access_log` VALUES (9408, '1c41d1fd-1012-4077-bca2-02c41a14b018', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:21:55', 177, 0, '', '2019-05-26 16:21:55');
INSERT INTO `access_log` VALUES (9409, 'c266cd86-78c0-46eb-90b6-e368c138b949', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:21:55', 205, 0, '', '2019-05-26 16:21:55');
INSERT INTO `access_log` VALUES (9410, '74cf4a61-036e-45ff-bba5-605a841710b0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:22:10', 236, 0, '', '2019-05-26 16:22:10');
INSERT INTO `access_log` VALUES (9411, '2934573b-5bd7-4e16-b2db-709286720146', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:22:10', 232, 0, '', '2019-05-26 16:22:10');
INSERT INTO `access_log` VALUES (9412, 'f61776ee-7c02-435c-9d55-181809fea5e3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:22:10', 238, 0, '', '2019-05-26 16:22:10');
INSERT INTO `access_log` VALUES (9413, 'b044284f-a53d-4236-9bad-c49051ca4845', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:22:10', 176, 0, '', '2019-05-26 16:22:10');
INSERT INTO `access_log` VALUES (9414, '61834d29-186e-434a-a47b-d10471e3db7f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:22:42', 139, 0, '', '2019-05-26 16:22:42');
INSERT INTO `access_log` VALUES (9415, 'acbfa6e2-1375-418c-89f7-f7ef270e0811', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:22:42', 142, 0, '', '2019-05-26 16:22:42');
INSERT INTO `access_log` VALUES (9416, '89b7874b-45bc-4b6f-be45-988723262feb', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:22:42', 141, 0, '', '2019-05-26 16:22:42');
INSERT INTO `access_log` VALUES (9417, 'e66dde96-a463-4848-bc78-421329e327b0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:22:42', 178, 0, '', '2019-05-26 16:22:42');
INSERT INTO `access_log` VALUES (9418, '2671fd23-bd76-495a-9190-66414fc46f90', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:22:59', 323, 0, '', '2019-05-26 16:22:59');
INSERT INTO `access_log` VALUES (9419, 'fc9149f1-74d9-418f-a1f7-3e953588dcaa', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:22:59', 323, 0, '', '2019-05-26 16:22:59');
INSERT INTO `access_log` VALUES (9420, '8e5d87ed-c89d-441c-812e-16efb1546481', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:22:59', 321, 0, '', '2019-05-26 16:22:59');
INSERT INTO `access_log` VALUES (9421, '4fbcdb38-9fb9-4dc8-8b6b-db1f6a938f5b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:22:59', 623, 0, '', '2019-05-26 16:23:00');
INSERT INTO `access_log` VALUES (9422, 'c07426ed-3efc-46a1-a9b4-47673e4bc565', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:23:04', 136, 0, '', '2019-05-26 16:23:04');
INSERT INTO `access_log` VALUES (9423, '6b88e4fe-1d41-4aed-87a1-2af10f61ff1d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:23:04', 139, 0, '', '2019-05-26 16:23:04');
INSERT INTO `access_log` VALUES (9424, 'ddc0f6d7-1acf-4420-baed-28de39cfdcec', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:23:04', 141, 0, '', '2019-05-26 16:23:04');
INSERT INTO `access_log` VALUES (9425, '3375059f-b11a-4b4b-87fd-0faba8f01128', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:23:04', 451, 0, '', '2019-05-26 16:23:04');
INSERT INTO `access_log` VALUES (9426, '8f21e276-94ae-442c-848d-c8811f8b204b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:23:44', 142, 0, '', '2019-05-26 16:23:44');
INSERT INTO `access_log` VALUES (9427, 'a3779edf-2c96-4118-af4c-3bbb8ec6ca0f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:23:44', 144, 0, '', '2019-05-26 16:23:44');
INSERT INTO `access_log` VALUES (9428, '754ac092-94eb-4b80-89cc-1beb433c5c57', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:23:44', 147, 0, '', '2019-05-26 16:23:44');
INSERT INTO `access_log` VALUES (9429, 'ad04d933-5930-4497-8420-746ba9d66d73', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:23:44', 192, 0, '', '2019-05-26 16:23:44');
INSERT INTO `access_log` VALUES (9430, '8aa898be-28d0-4797-8442-912d53c7da4e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:23:47', 143, 0, '', '2019-05-26 16:23:47');
INSERT INTO `access_log` VALUES (9431, 'bc5258da-ae54-4a10-b736-f36c5d71dbe0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:23:47', 142, 0, '', '2019-05-26 16:23:47');
INSERT INTO `access_log` VALUES (9432, '11d4a482-2626-46e6-8850-6f191a0210a3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:23:47', 145, 0, '', '2019-05-26 16:23:47');
INSERT INTO `access_log` VALUES (9433, '7b9622d0-8fd1-4514-8e1d-bb809105f506', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:23:47', 177, 0, '', '2019-05-26 16:23:47');
INSERT INTO `access_log` VALUES (9434, 'f1a700da-fb46-47e8-a929-cdb3b19337e9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:02', 141, 0, '', '2019-05-26 16:24:02');
INSERT INTO `access_log` VALUES (9435, 'e0c3a1b4-4c07-43ba-bcf1-dc9f91fb5850', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:02', 140, 0, '', '2019-05-26 16:24:02');
INSERT INTO `access_log` VALUES (9436, '29cf1392-fa40-428d-b404-e91a294514cb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:02', 141, 0, '', '2019-05-26 16:24:02');
INSERT INTO `access_log` VALUES (9437, '4f22bfae-da6d-41e7-ad17-11219807bba9', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:02', 183, 0, '', '2019-05-26 16:24:02');
INSERT INTO `access_log` VALUES (9438, 'fa113929-6514-4cd1-9c82-5f3008aee0b5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:24', 136, 0, '', '2019-05-26 16:24:24');
INSERT INTO `access_log` VALUES (9439, '2016d531-1a73-4e95-a89b-caebcbe4101a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:24', 140, 0, '', '2019-05-26 16:24:24');
INSERT INTO `access_log` VALUES (9440, 'bef9359b-6b58-4429-9727-ff99c4386e73', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:24', 141, 0, '', '2019-05-26 16:24:24');
INSERT INTO `access_log` VALUES (9441, '3ef4da02-5c8a-4949-842b-8575c438ff5a', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:24', 178, 0, '', '2019-05-26 16:24:24');
INSERT INTO `access_log` VALUES (9442, '573df4c1-df1d-4952-b619-8f4e8181959e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:55', 139, 0, '', '2019-05-26 16:24:55');
INSERT INTO `access_log` VALUES (9443, '7ccf2b98-070c-4fb7-8f92-d977bbb6ca01', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:55', 141, 0, '', '2019-05-26 16:24:55');
INSERT INTO `access_log` VALUES (9444, 'f4ef7325-5d8c-46ef-9418-e333f48355f2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:55', 140, 0, '', '2019-05-26 16:24:55');
INSERT INTO `access_log` VALUES (9445, '986beaf0-a94b-4bb2-bb5e-1cfab63c0cec', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:55', 173, 0, '', '2019-05-26 16:24:55');
INSERT INTO `access_log` VALUES (9446, '0d556ad0-a98a-4828-9199-8a570e87a664', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:57', 181, 0, '', '2019-05-26 16:24:58');
INSERT INTO `access_log` VALUES (9447, '8801a25c-a2f9-41bd-b17e-01f6c179db1b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:57', 178, 0, '', '2019-05-26 16:24:58');
INSERT INTO `access_log` VALUES (9448, '2cfd8f9d-800d-4956-af62-e6d6bdd3bced', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:57', 184, 0, '', '2019-05-26 16:24:58');
INSERT INTO `access_log` VALUES (9449, '6a606128-e12a-4699-b110-9601616d6a3a', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:24:58', 173, 0, '', '2019-05-26 16:24:58');
INSERT INTO `access_log` VALUES (9450, '4434a80a-3125-4a1a-8c8f-baed8111b8d5', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=123&platform=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:25:59', 276, 1002006002, '短信签名已存在', '2019-05-26 16:26:00');
INSERT INTO `access_log` VALUES (9451, '8cc5717d-b172-4e5b-82b9-0fa7232fc08d', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=123&platform=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:26:14', 25832, 1002006002, '短信签名已存在', '2019-05-26 16:26:39');
INSERT INTO `access_log` VALUES (9452, '1ee1c2f5-0f2e-4eca-8233-38b65089e1c0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=123&platform=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:29:03', 515, 1002006002, '短信签名已存在', '2019-05-26 16:29:04');
INSERT INTO `access_log` VALUES (9453, '3e84273f-56e1-450e-a4e0-7f796f2442e6', 0, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=123&platform=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:30:34', 189, 1002001012, '访问令牌已过期', '2019-05-26 16:30:34');
INSERT INTO `access_log` VALUES (9454, 'fea5c481-7379-4b61-b7ff-094516def6ca', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:30:37', 448, 0, '', '2019-05-26 16:30:38');
INSERT INTO `access_log` VALUES (9455, 'abcf9b1c-0447-406e-8c08-75267e6efb34', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:30:38', 331, 0, '', '2019-05-26 16:30:38');
INSERT INTO `access_log` VALUES (9456, 'da07f8b6-5891-4a63-bfaf-b830442e1210', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:30:38', 361, 0, '', '2019-05-26 16:30:38');
INSERT INTO `access_log` VALUES (9457, 'a2a6ccda-db05-4ab3-b4f4-10902acc5c9f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:30:38', 534, 0, '', '2019-05-26 16:30:38');
INSERT INTO `access_log` VALUES (9458, '1830aeb5-7c54-40b8-955b-16c1c9903663', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:30:40', 212, 0, '', '2019-05-26 16:30:40');
INSERT INTO `access_log` VALUES (9459, '61e33a44-731b-41dc-b108-493ad37fa45d', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=1&platform=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:30:52', 515, 0, '', '2019-05-26 16:30:52');
INSERT INTO `access_log` VALUES (9460, 'c1642814-c024-4777-89de-ad63691c7096', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:30:52', 170, 0, '', '2019-05-26 16:30:52');
INSERT INTO `access_log` VALUES (9461, '36bfc39a-58cc-499e-a8fe-05242ac10c2e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=1&platform=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:30:54', 258, 1002006002, '短信签名已存在', '2019-05-26 16:30:54');
INSERT INTO `access_log` VALUES (9462, '9d91c77f-ad4a-4eb6-8001-da7fb5d7c9aa', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=1&platform=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:30:55', 260, 1002006002, '短信签名已存在', '2019-05-26 16:30:56');
INSERT INTO `access_log` VALUES (9463, 'f490f33f-077f-49aa-a69a-d4e69282ae3a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:31:24', 228, 0, '', '2019-05-26 16:31:24');
INSERT INTO `access_log` VALUES (9464, 'f076954d-b3c0-4270-94ec-fb4407a37411', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:31:24', 227, 0, '', '2019-05-26 16:31:24');
INSERT INTO `access_log` VALUES (9465, 'a5665853-302f-4fe3-afba-288713fff94c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:31:24', 229, 0, '', '2019-05-26 16:31:24');
INSERT INTO `access_log` VALUES (9466, '96f12d04-c46c-48aa-aaec-ae09ed9a2ab7', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:31:25', 190, 0, '', '2019-05-26 16:31:25');
INSERT INTO `access_log` VALUES (9467, 'e742949b-7f91-45eb-ac2b-3d7cf40b1f44', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=2&platform=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:31:33', 401, 0, '', '2019-05-26 16:31:33');
INSERT INTO `access_log` VALUES (9468, 'c2f8ad78-bd09-458f-904d-d1c4b4698fd9', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:31:34', 180, 0, '', '2019-05-26 16:31:34');
INSERT INTO `access_log` VALUES (9469, '7bc215fd-c20a-4fd6-8e36-447fa937b10b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:31:46', 145, 0, '', '2019-05-26 16:31:46');
INSERT INTO `access_log` VALUES (9470, '34c79005-197b-4ff9-93d9-0761e54fbbdd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:31:46', 142, 0, '', '2019-05-26 16:31:46');
INSERT INTO `access_log` VALUES (9471, '4a99b50a-1625-4a27-bfe3-225d70c525ff', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:31:46', 177, 0, '', '2019-05-26 16:31:46');
INSERT INTO `access_log` VALUES (9472, 'f432c139-9659-4479-a59f-ba90d51239c8', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:31:46', 298, 0, '', '2019-05-26 16:31:46');
INSERT INTO `access_log` VALUES (9473, '7488ab24-450d-45cb-a85e-9ceacf34a5bb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:32:21', 146, 0, '', '2019-05-26 16:32:21');
INSERT INTO `access_log` VALUES (9474, '4b4f0b22-76eb-41c2-b41a-1780533988bf', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:32:21', 159, 0, '', '2019-05-26 16:32:21');
INSERT INTO `access_log` VALUES (9475, 'a9537e2d-d0d9-4e9d-ba53-52fa3e4ca10b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:32:21', 156, 0, '', '2019-05-26 16:32:21');
INSERT INTO `access_log` VALUES (9476, 'a4006b24-694c-4b7f-932d-861901db460b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:32:21', 181, 0, '', '2019-05-26 16:32:21');
INSERT INTO `access_log` VALUES (9477, 'fd355b73-e023-4985-ab8e-4dfa3d7bd035', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:32:28', 143, 0, '', '2019-05-26 16:32:28');
INSERT INTO `access_log` VALUES (9478, 'd64fb816-8324-4814-8a7e-6aa0a6d74356', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:32:28', 149, 0, '', '2019-05-26 16:32:28');
INSERT INTO `access_log` VALUES (9479, 'd91ac772-665c-4372-9867-387a4720663f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:32:28', 147, 0, '', '2019-05-26 16:32:28');
INSERT INTO `access_log` VALUES (9480, 'ba886cee-7600-4c5b-baf0-99b0a6b9db73', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:32:28', 182, 0, '', '2019-05-26 16:32:29');
INSERT INTO `access_log` VALUES (9481, '96e3286e-0e1d-4a81-b59f-7a378b30c74c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', '', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:32:35', 685, 2001001001, '参数缺失:Required Integer parameter \'id\' is not present', '2019-05-26 16:32:36');
INSERT INTO `access_log` VALUES (9482, '7aee8fce-93f4-4576-8667-c597682d0321', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', '', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:32:54', 250, 2001001001, '参数缺失:Required Integer parameter \'id\' is not present', '2019-05-26 16:32:54');
INSERT INTO `access_log` VALUES (9483, 'c68420b1-9210-410c-88a0-6d39a09ad39c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:33:23', 144, 0, '', '2019-05-26 16:33:23');
INSERT INTO `access_log` VALUES (9484, '90f1f65b-b3bb-4d9e-9e7d-b8295eb981b7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:33:23', 154, 0, '', '2019-05-26 16:33:23');
INSERT INTO `access_log` VALUES (9485, '4093092f-2ed6-4b67-b187-e8fcf7bd5667', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:33:23', 154, 0, '', '2019-05-26 16:33:23');
INSERT INTO `access_log` VALUES (9486, '3cda56b6-1bd7-4533-97cd-de5faa717055', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:33:24', 187, 0, '', '2019-05-26 16:33:24');
INSERT INTO `access_log` VALUES (9487, '67795294-8527-431f-a2dd-da81d5cd6174', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:33:37', 134, 0, '', '2019-05-26 16:33:37');
INSERT INTO `access_log` VALUES (9488, '961fc628-3843-4398-b989-75c6e1efa00d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:33:37', 138, 0, '', '2019-05-26 16:33:37');
INSERT INTO `access_log` VALUES (9489, '1f8c9b0c-ad70-4e38-bf2c-dbf15a0f8529', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:33:37', 145, 0, '', '2019-05-26 16:33:37');
INSERT INTO `access_log` VALUES (9490, '03048893-d011-495c-a59c-c6d919f5e838', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:33:37', 208, 0, '', '2019-05-26 16:33:37');
INSERT INTO `access_log` VALUES (9491, '8591c656-5bc1-4a2a-b9dd-a06bca674d35', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:04', 146, 0, '', '2019-05-26 16:34:04');
INSERT INTO `access_log` VALUES (9492, '7d6d3fd2-6f9f-456f-acfa-e8029ae22fb6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:04', 147, 0, '', '2019-05-26 16:34:04');
INSERT INTO `access_log` VALUES (9493, '9c0865b4-db4f-45e6-93e4-7081809f9d12', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:04', 174, 0, '', '2019-05-26 16:34:04');
INSERT INTO `access_log` VALUES (9494, '77d558f2-14e8-4edf-b791-23b693c4172f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:04', 172, 0, '', '2019-05-26 16:34:04');
INSERT INTO `access_log` VALUES (9495, '8cfb4900-3547-4a19-9cea-c1b821b5540b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:12', 141, 0, '', '2019-05-26 16:34:13');
INSERT INTO `access_log` VALUES (9496, 'd3d4abdf-ae76-4f6f-985c-e0a415bd6b1a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:12', 141, 0, '', '2019-05-26 16:34:13');
INSERT INTO `access_log` VALUES (9497, '5e6a910c-a641-4d69-8ecc-a1c5efce5fed', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:12', 139, 0, '', '2019-05-26 16:34:13');
INSERT INTO `access_log` VALUES (9498, 'd251bd97-e5b2-45ec-97cb-6235d48e9de1', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:13', 190, 0, '', '2019-05-26 16:34:13');
INSERT INTO `access_log` VALUES (9499, '20fb7e97-282a-4ebd-ac35-76ac26aaee55', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:33', 140, 0, '', '2019-05-26 16:34:34');
INSERT INTO `access_log` VALUES (9500, 'bd9986d0-7f39-42f4-9bf1-6f3123848f86', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:33', 142, 0, '', '2019-05-26 16:34:34');
INSERT INTO `access_log` VALUES (9501, '556d4cc8-094d-4dc3-8a7a-2d76c56841bf', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:33', 142, 0, '', '2019-05-26 16:34:34');
INSERT INTO `access_log` VALUES (9502, '98b3692a-7681-4278-b5f0-a3078e152284', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:34', 161, 0, '', '2019-05-26 16:34:34');
INSERT INTO `access_log` VALUES (9503, '8dffe009-679a-4963-9e36-0974320cf756', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:38', 146, 0, '', '2019-05-26 16:34:38');
INSERT INTO `access_log` VALUES (9504, '78526e5a-5cc3-4d06-aa00-d6fb59466af7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:38', 149, 0, '', '2019-05-26 16:34:38');
INSERT INTO `access_log` VALUES (9505, '7718dace-4b1d-4b1f-9909-2b754f1a346c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:38', 146, 0, '', '2019-05-26 16:34:38');
INSERT INTO `access_log` VALUES (9506, 'a63c97fd-dcfa-4466-a0cc-dc0b09ed6358', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:34:38', 170, 0, '', '2019-05-26 16:34:38');
INSERT INTO `access_log` VALUES (9507, 'e572ba54-863b-44b9-b908-d1d5307b70a3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:35:03', 137, 0, '', '2019-05-26 16:35:03');
INSERT INTO `access_log` VALUES (9508, '3f32add1-5421-4af6-ae94-fe517a5adfd8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:35:03', 142, 0, '', '2019-05-26 16:35:03');
INSERT INTO `access_log` VALUES (9509, 'ee13b711-9308-45e2-a716-0f14a7dae36a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:35:03', 145, 0, '', '2019-05-26 16:35:03');
INSERT INTO `access_log` VALUES (9510, '209200fd-d2a2-417f-ba36-3144c8d8ec1c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:35:03', 237, 0, '', '2019-05-26 16:35:04');
INSERT INTO `access_log` VALUES (9511, 'cdb54b0d-fb54-4b86-a9f2-6ac16841f8a0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=123&platform=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:35:10', 2160, 0, '', '2019-05-26 16:35:12');
INSERT INTO `access_log` VALUES (9512, '6185b1af-f20e-4dbe-892a-58db18a9cb03', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:35:12', 544, 0, '', '2019-05-26 16:35:13');
INSERT INTO `access_log` VALUES (9513, 'f7307952-eae9-4594-bc8a-d596c143c3a6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:35:33', 145, 0, '', '2019-05-26 16:35:33');
INSERT INTO `access_log` VALUES (9514, '27b15977-cad9-4fe2-ba3e-1ab57eab8b4e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:35:33', 139, 0, '', '2019-05-26 16:35:33');
INSERT INTO `access_log` VALUES (9515, '6dfb140c-d33c-4637-9591-dfca633c5d44', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:35:33', 142, 0, '', '2019-05-26 16:35:33');
INSERT INTO `access_log` VALUES (9516, 'edc96483-9e19-49ae-b4ad-2873623b40eb', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:35:33', 180, 0, '', '2019-05-26 16:35:33');
INSERT INTO `access_log` VALUES (9517, 'c5528354-5b3a-4465-9102-565395987573', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=123&platform=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:35:40', 409, 0, '', '2019-05-26 16:35:40');
INSERT INTO `access_log` VALUES (9518, '6394a73b-59e0-414b-9108-8b5c16d553dd', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:35:40', 199, 0, '', '2019-05-26 16:35:41');
INSERT INTO `access_log` VALUES (9519, 'e3e8e9a8-ead0-4b56-ba02-ab3d65b1eaa6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:36:46', 771, 0, '', '2019-05-26 16:36:47');
INSERT INTO `access_log` VALUES (9520, '3cb0b3e0-40e0-4d3d-8335-343674ff95df', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:36:46', 771, 0, '', '2019-05-26 16:36:47');
INSERT INTO `access_log` VALUES (9521, '45eca060-1eb6-424f-885b-09eb5ded65bf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:36:46', 790, 0, '', '2019-05-26 16:36:47');
INSERT INTO `access_log` VALUES (9522, '891d2455-ad90-4bf3-ab96-9222d866f6b4', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:36:46', 849, 0, '', '2019-05-26 16:36:47');
INSERT INTO `access_log` VALUES (9523, 'c612b2a4-76d2-41d7-8c12-8b580a351f98', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:37:07', 156, 0, '', '2019-05-26 16:37:07');
INSERT INTO `access_log` VALUES (9524, 'dd401ae0-b315-4d26-a414-6d0801a8d377', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:37:07', 157, 0, '', '2019-05-26 16:37:07');
INSERT INTO `access_log` VALUES (9525, 'd08f1c00-4103-47c9-b43c-4dbf039a6856', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:37:07', 19321, 2001001000, '服务端发生异常', '2019-05-26 16:37:26');
INSERT INTO `access_log` VALUES (9526, '7b3eec7c-f07e-4aa8-b1f1-4f6898a024d6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:19', 156, 0, '', '2019-05-26 16:38:20');
INSERT INTO `access_log` VALUES (9527, '68400084-2290-4c7a-a916-5fe94c5e46a0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:19', 158, 0, '', '2019-05-26 16:38:20');
INSERT INTO `access_log` VALUES (9528, '1f8c32e7-32d6-45ef-ba0e-4ddede316953', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:19', 193, 0, '', '2019-05-26 16:38:20');
INSERT INTO `access_log` VALUES (9529, '6590d759-0d7d-4f3c-98b1-5447ac0945a0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:22', 150, 0, '', '2019-05-26 16:38:22');
INSERT INTO `access_log` VALUES (9530, '95613cef-6e65-4964-a67e-8768467f65af', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:22', 150, 0, '', '2019-05-26 16:38:22');
INSERT INTO `access_log` VALUES (9531, '37e3bcaf-bcac-480d-9d7f-a1a2c0503bb2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:22', 175, 0, '', '2019-05-26 16:38:22');
INSERT INTO `access_log` VALUES (9532, 'af00e55c-b354-49a0-94ff-9689109e1c41', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:32', 156, 0, '', '2019-05-26 16:38:32');
INSERT INTO `access_log` VALUES (9533, '6fca7a8f-837c-4acd-9648-aefe7a965efa', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:32', 157, 0, '', '2019-05-26 16:38:32');
INSERT INTO `access_log` VALUES (9534, 'a42ff803-b858-4272-8f13-201a46815a85', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:32', 334, 2001001000, '服务端发生异常', '2019-05-26 16:38:32');
INSERT INTO `access_log` VALUES (9535, 'aae0f56e-1d38-487b-82e0-f096173ffa20', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:33', 149, 0, '', '2019-05-26 16:38:33');
INSERT INTO `access_log` VALUES (9536, '45dfcdb1-d53c-4704-9924-fb621e8c3a65', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:33', 157, 0, '', '2019-05-26 16:38:33');
INSERT INTO `access_log` VALUES (9537, '1e0a78ea-be73-4caa-a46a-64e274547f34', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:33', 153, 0, '', '2019-05-26 16:38:33');
INSERT INTO `access_log` VALUES (9538, '6006d0ea-0faf-47bc-8ca1-bac8839c079e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:42', 144, 0, '', '2019-05-26 16:38:42');
INSERT INTO `access_log` VALUES (9539, '3b72fb45-1a6e-4d85-9527-c75ebabd7d7f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:42', 144, 0, '', '2019-05-26 16:38:42');
INSERT INTO `access_log` VALUES (9540, 'a5443388-4750-4e97-a631-8aa06fddded8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:42', 267, 2001001000, '服务端发生异常', '2019-05-26 16:38:42');
INSERT INTO `access_log` VALUES (9541, '633eb0f0-1fdc-466c-a810-a4d8a8ffd4b1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:44', 161, 0, '', '2019-05-26 16:38:44');
INSERT INTO `access_log` VALUES (9542, 'f66b2aea-52d4-416c-992e-e15b0956ea69', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:44', 152, 0, '', '2019-05-26 16:38:44');
INSERT INTO `access_log` VALUES (9543, 'ef3db80b-ce4a-4a6f-9242-7b0453d1660e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:44', 156, 0, '', '2019-05-26 16:38:44');
INSERT INTO `access_log` VALUES (9544, 'b11e8630-d2b9-40d2-bcf4-9a4f0be0eabd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:03', 148, 0, '', '2019-05-26 16:39:03');
INSERT INTO `access_log` VALUES (9545, 'e6baea20-6e05-4937-b15e-c7ced2fb45b3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:03', 146, 0, '', '2019-05-26 16:39:03');
INSERT INTO `access_log` VALUES (9546, 'a7d1cc97-aa72-4dbe-8ac1-d3afaffb58d1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:03', 153, 0, '', '2019-05-26 16:39:03');
INSERT INTO `access_log` VALUES (9547, 'dc85b18a-9acc-40c8-baad-37d08eea3da2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:05', 148, 0, '', '2019-05-26 16:39:05');
INSERT INTO `access_log` VALUES (9548, 'bbad6035-4ecb-4363-b158-bbcfa5809879', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:05', 148, 0, '', '2019-05-26 16:39:05');
INSERT INTO `access_log` VALUES (9549, 'ac254c76-699e-45bd-9d62-0dd4c98107a9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:05', 144, 0, '', '2019-05-26 16:39:05');
INSERT INTO `access_log` VALUES (9550, 'bdc37eba-ae29-4f86-902b-b20c79b2e5c2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:23', 145, 0, '', '2019-05-26 16:39:23');
INSERT INTO `access_log` VALUES (9551, '76e6e0e8-3cd6-4996-868d-7e1028742ac7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:23', 144, 0, '', '2019-05-26 16:39:23');
INSERT INTO `access_log` VALUES (9552, '6b442f0f-1eac-49c6-84a1-8feca87e7898', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:23', 141, 0, '', '2019-05-26 16:39:23');
INSERT INTO `access_log` VALUES (9553, '3da5e621-4a95-4632-b6a8-786900146dda', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:25', 146, 0, '', '2019-05-26 16:39:25');
INSERT INTO `access_log` VALUES (9554, '526f8366-61a0-475b-8fad-046f4db5674e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:25', 143, 0, '', '2019-05-26 16:39:25');
INSERT INTO `access_log` VALUES (9555, 'ab69a340-4610-44cf-ba73-fc76df00c309', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:25', 148, 0, '', '2019-05-26 16:39:25');
INSERT INTO `access_log` VALUES (9556, 'c5c567b0-ba0c-4322-ab86-2b4df630ba41', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:38', 528, 0, '', '2019-05-26 16:39:39');
INSERT INTO `access_log` VALUES (9557, '8c5cb834-1cbc-4980-87a0-2506aa3a9e21', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:38', 528, 0, '', '2019-05-26 16:39:39');
INSERT INTO `access_log` VALUES (9558, 'e1963340-0fea-4999-a969-d8260855c353', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:39', 432, 0, '', '2019-05-26 16:39:39');
INSERT INTO `access_log` VALUES (9559, '32faf951-e030-43af-aeec-b4fd0120922f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:38', 742, 2001001000, '服务端发生异常', '2019-05-26 16:39:39');
INSERT INTO `access_log` VALUES (9560, '06042e68-e828-4413-815e-14ed58451c13', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:40', 301, 0, '', '2019-05-26 16:39:40');
INSERT INTO `access_log` VALUES (9561, '055e633e-1b00-43e4-9b40-e5e62a394651', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:40', 301, 0, '', '2019-05-26 16:39:40');
INSERT INTO `access_log` VALUES (9562, 'b1c8096a-4a45-41fe-a0e1-f559f72e22fb', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:40', 297, 0, '', '2019-05-26 16:39:40');
INSERT INTO `access_log` VALUES (9563, '799719b7-8687-4c7e-9e66-b90f86a08198', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:40', 189, 0, '', '2019-05-26 16:39:40');
INSERT INTO `access_log` VALUES (9564, '7c0e97d9-baa8-488b-8be2-ad41023851ab', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:12', 146, 0, '', '2019-05-26 16:40:13');
INSERT INTO `access_log` VALUES (9565, 'ab322ca0-c273-4a25-a4a6-0910522cd4dc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:12', 146, 0, '', '2019-05-26 16:40:13');
INSERT INTO `access_log` VALUES (9566, '9d05146d-ebba-4186-94ff-fcfc09619ab9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:12', 144, 0, '', '2019-05-26 16:40:13');
INSERT INTO `access_log` VALUES (9567, '08fe959a-a75e-4f6d-921c-ec6d68afd212', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:12', 179, 0, '', '2019-05-26 16:40:13');
INSERT INTO `access_log` VALUES (9568, '4fa13036-e016-405d-87e9-0fbfea6f9bfe', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:14', 144, 0, '', '2019-05-26 16:40:14');
INSERT INTO `access_log` VALUES (9569, '9ab67f22-dba4-473c-893f-d304ea82ff51', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:14', 145, 0, '', '2019-05-26 16:40:14');
INSERT INTO `access_log` VALUES (9570, '2b33ced9-e945-4bd6-b83c-e1d5c5d95488', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:14', 147, 0, '', '2019-05-26 16:40:14');
INSERT INTO `access_log` VALUES (9571, 'df2b62d6-90a2-42ed-8e1f-0ea7b11c3ccc', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:15', 173, 0, '', '2019-05-26 16:40:15');
INSERT INTO `access_log` VALUES (9572, 'b0e0394d-bf30-4402-b0ec-2ff8adc706b7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:20', 145, 0, '', '2019-05-26 16:40:20');
INSERT INTO `access_log` VALUES (9573, '8e357ee1-3cdc-4ff7-a314-3783b2ec3df9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:20', 142, 0, '', '2019-05-26 16:40:20');
INSERT INTO `access_log` VALUES (9574, '6feb4452-3e58-4146-9643-50b08d583e38', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:20', 148, 0, '', '2019-05-26 16:40:20');
INSERT INTO `access_log` VALUES (9575, '160449d6-5dce-44c1-94c0-89b0608173a9', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:20', 177, 0, '', '2019-05-26 16:40:20');
INSERT INTO `access_log` VALUES (9576, 'ce9fd25b-665a-47fc-a31d-c85033fcad60', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:55', 143, 0, '', '2019-05-26 16:40:55');
INSERT INTO `access_log` VALUES (9577, 'c16d84df-03e9-48c9-a522-a470b09f5986', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:55', 142, 0, '', '2019-05-26 16:40:55');
INSERT INTO `access_log` VALUES (9578, '40d174a3-7e75-4a69-8ff8-d6ca2864710a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:55', 146, 0, '', '2019-05-26 16:40:55');
INSERT INTO `access_log` VALUES (9579, '55f94848-9294-42e0-acf0-163de1aba04a', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:40:55', 179, 0, '', '2019-05-26 16:40:55');
INSERT INTO `access_log` VALUES (9580, 'c5660813-642a-4f2b-97f6-dce74832e110', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:41:12', 140, 0, '', '2019-05-26 16:41:12');
INSERT INTO `access_log` VALUES (9581, 'f3d03362-a3fd-4002-8efa-a3976e367fda', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:41:12', 143, 0, '', '2019-05-26 16:41:12');
INSERT INTO `access_log` VALUES (9582, 'a69ad10f-ce99-43dc-bc0d-d544369a084d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:41:12', 142, 0, '', '2019-05-26 16:41:12');
INSERT INTO `access_log` VALUES (9583, '8e5c9e3b-d2a3-4ca1-bc10-f3791557f499', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:41:12', 178, 0, '', '2019-05-26 16:41:12');
INSERT INTO `access_log` VALUES (9584, 'd1356824-a6c6-44ff-9631-4157d54b2100', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:41:25', 606, 0, '', '2019-05-26 16:41:25');
INSERT INTO `access_log` VALUES (9585, '5f588d3d-d0b2-4005-a133-9e838e069a23', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:41:25', 608, 0, '', '2019-05-26 16:41:25');
INSERT INTO `access_log` VALUES (9586, '84eae2d8-bcdd-43ea-9f1c-46460978b54c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:41:25', 608, 0, '', '2019-05-26 16:41:25');
INSERT INTO `access_log` VALUES (9587, '7b86cac3-dec9-45d4-8d13-12d97b6390f4', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:41:25', 573, 0, '', '2019-05-26 16:41:25');
INSERT INTO `access_log` VALUES (9588, 'b70794fa-c2ff-4010-b708-d310efdb31b5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:43:12', 176, 0, '', '2019-05-26 16:43:12');
INSERT INTO `access_log` VALUES (9589, '807f0fa5-7be0-48c3-8828-d6d0c014051f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:43:12', 174, 0, '', '2019-05-26 16:43:12');
INSERT INTO `access_log` VALUES (9590, '4e39f410-60b7-4083-b732-92545a6763c7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:43:12', 195, 0, '', '2019-05-26 16:43:12');
INSERT INTO `access_log` VALUES (9591, '21f77f46-ccf3-49cb-b59c-e8c6196302ae', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:43:12', 271, 0, '', '2019-05-26 16:43:12');
INSERT INTO `access_log` VALUES (9592, '725ba5b4-98d6-4796-8003-5fd33c172138', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:44:01', 143, 0, '', '2019-05-26 16:44:01');
INSERT INTO `access_log` VALUES (9593, '56277925-c347-4591-9696-1e387719be1b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:44:01', 147, 0, '', '2019-05-26 16:44:01');
INSERT INTO `access_log` VALUES (9594, 'a09602ba-75eb-40b8-bf9c-8c398aac6dc4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:44:01', 145, 0, '', '2019-05-26 16:44:01');
INSERT INTO `access_log` VALUES (9595, '21e1e7ae-c39a-4f03-979a-edbda984b948', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:44:01', 177, 0, '', '2019-05-26 16:44:01');
INSERT INTO `access_log` VALUES (9596, 'c5272ff4-d498-4c06-aeab-3305f5382dd9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:44:24', 702, 0, '', '2019-05-26 16:44:24');
INSERT INTO `access_log` VALUES (9597, '903fe8cd-04ad-4175-b647-2053d217817a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:44:24', 701, 0, '', '2019-05-26 16:44:24');
INSERT INTO `access_log` VALUES (9598, '7550cece-5652-49d5-b840-e324cc07dddc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:44:24', 701, 0, '', '2019-05-26 16:44:24');
INSERT INTO `access_log` VALUES (9599, '9c8615c8-a156-4cb6-85d7-f313acde8400', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:44:25', 179, 0, '', '2019-05-26 16:44:25');
INSERT INTO `access_log` VALUES (9600, 'ddec11cc-3802-48c3-8778-86c478dcb579', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:44:31', 142, 0, '', '2019-05-26 16:44:31');
INSERT INTO `access_log` VALUES (9601, '55cf17fc-cf50-4226-9d89-b70b450fe249', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:44:31', 143, 0, '', '2019-05-26 16:44:31');
INSERT INTO `access_log` VALUES (9602, '7ad51845-f57a-49ba-953f-801d4d9e4bf5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:44:31', 147, 0, '', '2019-05-26 16:44:31');
INSERT INTO `access_log` VALUES (9603, '4b59ac38-5d7b-43c4-9749-ceaf32363a9f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:44:31', 182, 0, '', '2019-05-26 16:44:32');
INSERT INTO `access_log` VALUES (9604, '13c76ef6-b4d0-4532-868d-2e2cd0dee2e2', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=tst&platform=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:44:37', 518, 0, '', '2019-05-26 16:44:38');
INSERT INTO `access_log` VALUES (9605, '9a82a2fa-ab25-465d-895e-8b4da8aef672', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:44:38', 176, 0, '', '2019-05-26 16:44:38');
INSERT INTO `access_log` VALUES (9606, '8e583848-c899-45f7-b975-8577331d802d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:45:34', 146, 0, '', '2019-05-26 16:45:34');
INSERT INTO `access_log` VALUES (9607, 'd02ebaf8-c705-4559-bc2a-f10aa0965fdd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:45:34', 171, 0, '', '2019-05-26 16:45:34');
INSERT INTO `access_log` VALUES (9608, '04bf5a41-b808-457e-af45-826c6e56a505', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:45:34', 175, 0, '', '2019-05-26 16:45:34');
INSERT INTO `access_log` VALUES (9609, '3b53eafa-68c7-482c-96d3-33bbc2ec3839', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:45:34', 208, 0, '', '2019-05-26 16:45:34');
INSERT INTO `access_log` VALUES (9610, '94ea2c07-c4a6-49ff-ab57-da8885531d03', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:01', 146, 0, '', '2019-05-26 16:46:01');
INSERT INTO `access_log` VALUES (9611, 'fc993d2f-da0d-4b75-b02d-72670a452f80', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:01', 140, 0, '', '2019-05-26 16:46:01');
INSERT INTO `access_log` VALUES (9612, '0c61d15c-90b2-4a89-bf35-8d37255b1d78', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:01', 317, 0, '', '2019-05-26 16:46:01');
INSERT INTO `access_log` VALUES (9613, '8d39a2d3-c855-471f-84cf-e73ad86ffbc5', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:01', 188, 0, '', '2019-05-26 16:46:01');
INSERT INTO `access_log` VALUES (9614, '4b30be4e-4975-41ea-a0be-09e535d08996', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:04', 155, 0, '', '2019-05-26 16:46:04');
INSERT INTO `access_log` VALUES (9615, 'f8168ccc-f7fd-4f7c-bdba-5a340d48a815', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:04', 156, 0, '', '2019-05-26 16:46:04');
INSERT INTO `access_log` VALUES (9616, '6e4b2816-7987-459b-83aa-da4d80ca19f9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:04', 156, 0, '', '2019-05-26 16:46:04');
INSERT INTO `access_log` VALUES (9617, 'df5678e0-3060-4d62-9a7d-bb13f2f1ed84', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:04', 185, 0, '', '2019-05-26 16:46:04');
INSERT INTO `access_log` VALUES (9618, '33b026a7-ae69-4829-a5dc-55c0c6e34119', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:35', 194, 0, '', '2019-05-26 16:46:35');
INSERT INTO `access_log` VALUES (9619, '497ef82d-d14d-411a-8ad4-141a3e087ae4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:35', 195, 0, '', '2019-05-26 16:46:35');
INSERT INTO `access_log` VALUES (9620, '6a2f0100-5927-4626-aa18-275425dfceaa', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:35', 174, 0, '', '2019-05-26 16:46:35');
INSERT INTO `access_log` VALUES (9621, '81a8a7d4-d811-4c78-b673-c4f7674883b4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:35', 379, 0, '', '2019-05-26 16:46:35');
INSERT INTO `access_log` VALUES (9622, '618fb821-90c5-4bf5-bb9e-cf0c1ecc8698', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:37', 140, 0, '', '2019-05-26 16:46:37');
INSERT INTO `access_log` VALUES (9623, 'bf5dfb0e-cb9d-405a-b33d-14926898078d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:37', 139, 0, '', '2019-05-26 16:46:37');
INSERT INTO `access_log` VALUES (9624, '8d0308f0-2507-4dc6-9034-eaf8af53ddf3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:37', 143, 0, '', '2019-05-26 16:46:37');
INSERT INTO `access_log` VALUES (9625, '1062a521-d343-425d-b781-ce8467c4cc8d', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:37', 182, 0, '', '2019-05-26 16:46:37');
INSERT INTO `access_log` VALUES (9626, '5c1c100f-a5be-4628-8bc4-6d57da14444d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:51', 140, 0, '', '2019-05-26 16:46:51');
INSERT INTO `access_log` VALUES (9627, '6de11fbd-996a-41d1-ae4a-d8fc0710c072', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:51', 142, 0, '', '2019-05-26 16:46:51');
INSERT INTO `access_log` VALUES (9628, 'cdb6df32-f2b1-4662-85d0-0f07c9e0cad2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:51', 140, 0, '', '2019-05-26 16:46:51');
INSERT INTO `access_log` VALUES (9629, '121d5fd0-a212-4f43-8415-e1122b86940e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:51', 172, 0, '', '2019-05-26 16:46:51');
INSERT INTO `access_log` VALUES (9630, '02fc1daf-2a8a-4e33-925d-018a6f6b989d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:52', 144, 0, '', '2019-05-26 16:46:53');
INSERT INTO `access_log` VALUES (9631, '9f582660-e79b-4b26-99a2-10363cf90aab', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:52', 148, 0, '', '2019-05-26 16:46:53');
INSERT INTO `access_log` VALUES (9632, 'ac8b3d19-5d43-4e3b-972c-0f8451ee2a7f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:52', 145, 0, '', '2019-05-26 16:46:53');
INSERT INTO `access_log` VALUES (9633, '78cc93bb-0c27-44ad-98f4-06e08df373cc', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:46:53', 175, 0, '', '2019-05-26 16:46:53');
INSERT INTO `access_log` VALUES (9634, '005b1a4a-4918-4460-80b0-644d377c3466', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:47:06', 684, 0, '', '2019-05-26 16:47:06');
INSERT INTO `access_log` VALUES (9635, 'd18b9760-a5f4-4e43-8c96-f5f179c78c47', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:47:06', 684, 0, '', '2019-05-26 16:47:06');
INSERT INTO `access_log` VALUES (9636, 'a1019471-8a71-4dd2-be4e-68bf78ebac35', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:47:06', 687, 0, '', '2019-05-26 16:47:06');
INSERT INTO `access_log` VALUES (9637, '976b8fce-d904-4a1b-8f7f-b2302c574688', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:47:06', 623, 0, '', '2019-05-26 16:47:06');
INSERT INTO `access_log` VALUES (9638, '9fa70673-d74f-4337-883c-d0c2a55e8439', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:47:07', 141, 0, '', '2019-05-26 16:47:07');
INSERT INTO `access_log` VALUES (9639, '3d15cb28-3dae-49ed-8890-a410b7d7b982', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:47:07', 145, 0, '', '2019-05-26 16:47:07');
INSERT INTO `access_log` VALUES (9640, '5da4918d-543c-49a9-8703-42379e1b7b1d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:47:07', 145, 0, '', '2019-05-26 16:47:07');
INSERT INTO `access_log` VALUES (9641, '1b2a3657-6cbe-486f-8ab7-4d44a2fae9fd', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:47:07', 172, 0, '', '2019-05-26 16:47:07');
INSERT INTO `access_log` VALUES (9642, '1187f23c-7159-4852-befb-14b3ba0c2aef', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:47:37', 146, 0, '', '2019-05-26 16:47:37');
INSERT INTO `access_log` VALUES (9643, 'ce5c9a65-186c-429e-908d-a2850294c52e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:47:37', 142, 0, '', '2019-05-26 16:47:37');
INSERT INTO `access_log` VALUES (9644, '7cf0ed9e-247e-4d1a-824a-870f365a6fdc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:47:37', 145, 0, '', '2019-05-26 16:47:37');
INSERT INTO `access_log` VALUES (9645, 'f6b6399b-1ab6-49f3-b24c-e48e5a6b4ac3', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:47:37', 177, 0, '', '2019-05-26 16:47:37');
INSERT INTO `access_log` VALUES (9646, 'f72e601d-21ef-4ac2-8797-2c032672c3df', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:18', 142, 0, '', '2019-05-26 16:48:18');
INSERT INTO `access_log` VALUES (9647, 'e34846d0-9c5e-4488-9824-d652eae0d497', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:18', 141, 0, '', '2019-05-26 16:48:18');
INSERT INTO `access_log` VALUES (9648, '74187fb1-a52c-404c-8474-309700dd94c3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:18', 142, 0, '', '2019-05-26 16:48:18');
INSERT INTO `access_log` VALUES (9649, '6822ad0e-6230-4343-aa50-d4be100cf96c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:18', 176, 0, '', '2019-05-26 16:48:18');
INSERT INTO `access_log` VALUES (9650, '6987e043-608b-4507-bf35-ff1ff526ea33', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:20', 243, 0, '', '2019-05-26 16:48:20');
INSERT INTO `access_log` VALUES (9651, 'cfa259ef-f8f2-48ca-b3d5-6e029a99249f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:20', 238, 0, '', '2019-05-26 16:48:20');
INSERT INTO `access_log` VALUES (9652, 'e789008e-935c-43a7-bf8c-dc72a7d4a4de', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:20', 241, 0, '', '2019-05-26 16:48:20');
INSERT INTO `access_log` VALUES (9653, 'c845a30b-589e-47b1-bd56-8dc0d0120763', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:20', 177, 0, '', '2019-05-26 16:48:20');
INSERT INTO `access_log` VALUES (9654, '41bfd090-f356-4edd-8864-a9507c48935c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:30', 167, 0, '', '2019-05-26 16:48:30');
INSERT INTO `access_log` VALUES (9655, '1f661979-df4d-4656-8ec9-a24631451377', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:30', 168, 0, '', '2019-05-26 16:48:30');
INSERT INTO `access_log` VALUES (9656, 'db863c8b-1ac0-4c75-837a-698f192d944d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:30', 168, 0, '', '2019-05-26 16:48:30');
INSERT INTO `access_log` VALUES (9657, 'a7bccfba-366b-42e8-b3a5-6b94f3ead492', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:30', 182, 0, '', '2019-05-26 16:48:30');
INSERT INTO `access_log` VALUES (9658, '9302824d-7a68-4a1b-811a-e1d133e3420b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:34', 138, 0, '', '2019-05-26 16:48:34');
INSERT INTO `access_log` VALUES (9659, 'e167510f-daa3-4534-9527-2e8612be2116', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:34', 150, 0, '', '2019-05-26 16:48:34');
INSERT INTO `access_log` VALUES (9660, 'f8ad2a84-78ff-41bd-8adc-92271bd8f225', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:34', 148, 0, '', '2019-05-26 16:48:34');
INSERT INTO `access_log` VALUES (9661, '637e1601-f3de-4d1c-a3bb-ae23d0ec48d2', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:34', 175, 0, '', '2019-05-26 16:48:34');
INSERT INTO `access_log` VALUES (9662, '392a8510-7699-42fd-9516-e645f45f2f11', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:36', 148, 0, '', '2019-05-26 16:48:37');
INSERT INTO `access_log` VALUES (9663, 'f1eabc3a-7fc9-4c52-a28c-6d44d464c6a8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:36', 148, 0, '', '2019-05-26 16:48:37');
INSERT INTO `access_log` VALUES (9664, 'd5862ae8-6df1-4024-a414-87ea3f590548', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:36', 147, 0, '', '2019-05-26 16:48:37');
INSERT INTO `access_log` VALUES (9665, '80e7a1bf-8904-47b4-9158-f439e15de042', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:36', 177, 0, '', '2019-05-26 16:48:37');
INSERT INTO `access_log` VALUES (9666, '3a0b18e3-3447-4525-9141-ba91fb5727a5', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=mid&platform=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:41', 489, 0, '', '2019-05-26 16:48:42');
INSERT INTO `access_log` VALUES (9667, '150844df-a828-4877-a0b1-38d426f95280', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:42', 177, 0, '', '2019-05-26 16:48:42');
INSERT INTO `access_log` VALUES (9668, '28959450-8b49-4d84-932b-e9af4daedf5c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:59', 145, 0, '', '2019-05-26 16:48:59');
INSERT INTO `access_log` VALUES (9669, '6b902530-cfbe-4b8d-aa87-3003bd0f0e02', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:59', 143, 0, '', '2019-05-26 16:48:59');
INSERT INTO `access_log` VALUES (9670, 'a6c0760b-b407-49cc-b047-295767e238d5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:59', 144, 0, '', '2019-05-26 16:48:59');
INSERT INTO `access_log` VALUES (9671, '0136f4c0-0c63-4cb0-b8dd-e410567e998a', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:48:59', 182, 0, '', '2019-05-26 16:48:59');
INSERT INTO `access_log` VALUES (9672, 'd39afd23-c2ea-49ce-af21-8d7798d453ee', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:50:14', 174, 0, '', '2019-05-26 16:50:14');
INSERT INTO `access_log` VALUES (9673, '53f8d1f4-07d9-4972-beb7-5d6bdffb0fab', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:50:14', 177, 0, '', '2019-05-26 16:50:14');
INSERT INTO `access_log` VALUES (9674, '68fbd896-eb31-4c51-a998-024a43b7f29b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:50:14', 176, 0, '', '2019-05-26 16:50:14');
INSERT INTO `access_log` VALUES (9675, '0cc6aa8d-1e5a-4839-b5bf-ba6c888bc562', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:50:14', 211, 0, '', '2019-05-26 16:50:14');
INSERT INTO `access_log` VALUES (9676, '4a432c02-d3a7-4ea1-aa9e-22e971115a17', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:19', 255, 0, '', '2019-05-26 16:51:19');
INSERT INTO `access_log` VALUES (9677, '26ce1152-08d3-4838-9408-86b1573f46b9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:19', 252, 0, '', '2019-05-26 16:51:19');
INSERT INTO `access_log` VALUES (9678, '6660f99b-0846-4e9e-941d-3cfa2edd371c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:19', 254, 0, '', '2019-05-26 16:51:19');
INSERT INTO `access_log` VALUES (9679, '9b5c2705-5eba-4c0b-9afd-3ecfe12220c5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:22', 142, 0, '', '2019-05-26 16:51:22');
INSERT INTO `access_log` VALUES (9680, '6d11ff5b-cd8f-484d-88b5-dc24bbeb3269', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:22', 141, 0, '', '2019-05-26 16:51:22');
INSERT INTO `access_log` VALUES (9681, 'a45314c1-4fe1-4af3-9f5f-13c8eaa2c0eb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:22', 145, 0, '', '2019-05-26 16:51:22');
INSERT INTO `access_log` VALUES (9682, 'cc288442-1831-41d4-b13e-186bcb0ee291', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:25', 142, 0, '', '2019-05-26 16:51:25');
INSERT INTO `access_log` VALUES (9683, 'ebc89276-ee48-457d-8a07-bef2f107f703', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:25', 138, 0, '', '2019-05-26 16:51:25');
INSERT INTO `access_log` VALUES (9684, '9f1861a6-1be0-444d-ac46-90931b00fdd7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:25', 144, 0, '', '2019-05-26 16:51:25');
INSERT INTO `access_log` VALUES (9685, '073485a3-5d3c-495f-befe-1f4d39a7c761', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:39', 136, 0, '', '2019-05-26 16:51:39');
INSERT INTO `access_log` VALUES (9686, '62e307ee-f14d-4c96-b6bd-2b3f247543a9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:39', 136, 0, '', '2019-05-26 16:51:39');
INSERT INTO `access_log` VALUES (9687, 'c50eb52c-3a81-4300-ac46-dead7f49c3ac', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:39', 139, 0, '', '2019-05-26 16:51:39');
INSERT INTO `access_log` VALUES (9688, 'd4946ba6-4b71-423b-9d7e-18f969f71b62', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:39', 211, 0, '', '2019-05-26 16:51:39');
INSERT INTO `access_log` VALUES (9689, '768a0ae1-060c-4256-9316-0b18ca5978e1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:40', 144, 0, '', '2019-05-26 16:51:41');
INSERT INTO `access_log` VALUES (9690, 'caa826fa-d36b-4237-afb0-b9b261b4c950', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:40', 136, 0, '', '2019-05-26 16:51:41');
INSERT INTO `access_log` VALUES (9691, '16751117-831b-49ea-8627-a404806eeb99', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:40', 142, 0, '', '2019-05-26 16:51:41');
INSERT INTO `access_log` VALUES (9692, 'ca432e25-63bc-47a8-b7ce-70e3b6da975d', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:51:41', 167, 0, '', '2019-05-26 16:51:41');
INSERT INTO `access_log` VALUES (9693, 'a885b28d-b639-4534-b490-61a84e7fdaf7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:55:55', 172, 0, '', '2019-05-26 16:55:55');
INSERT INTO `access_log` VALUES (9694, '5b9fb308-3d57-48cd-841a-e805eeee3b63', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:55:55', 172, 0, '', '2019-05-26 16:55:55');
INSERT INTO `access_log` VALUES (9695, '80c82050-a56e-4038-bab8-4e49c594bd23', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:55:55', 143, 0, '', '2019-05-26 16:55:55');
INSERT INTO `access_log` VALUES (9696, '7ec85c17-f278-434b-a348-1f45f62cf2ac', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:55:55', 170, 0, '', '2019-05-26 16:55:55');
INSERT INTO `access_log` VALUES (9697, '9bc907d6-7b30-4a58-b904-9c0e64a95208', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:55:57', 141, 0, '', '2019-05-26 16:55:58');
INSERT INTO `access_log` VALUES (9698, 'f8671784-f337-4e0e-8f2d-4e3e9f1ee030', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:55:57', 139, 0, '', '2019-05-26 16:55:58');
INSERT INTO `access_log` VALUES (9699, '5914a0c8-ce93-497e-abba-37da812d25d9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:55:57', 170, 0, '', '2019-05-26 16:55:58');
INSERT INTO `access_log` VALUES (9700, '1dbfe1b3-308c-4bd1-be99-2792e42fb2ee', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:55:58', 210, 0, '', '2019-05-26 16:55:58');
INSERT INTO `access_log` VALUES (9701, '68f69cda-2d7a-4ff5-94a6-3f8c34380ac2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:56:19', 142, 0, '', '2019-05-26 16:56:19');
INSERT INTO `access_log` VALUES (9702, 'a66abcdd-8432-4a89-b025-9125ba59470f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:56:19', 140, 0, '', '2019-05-26 16:56:19');
INSERT INTO `access_log` VALUES (9703, '414a2002-aeea-48ae-8c93-724de645765c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:56:19', 143, 0, '', '2019-05-26 16:56:19');
INSERT INTO `access_log` VALUES (9704, 'f8db814b-f969-408c-88d5-be9b100607df', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:56:19', 172, 0, '', '2019-05-26 16:56:20');
INSERT INTO `access_log` VALUES (9705, '08ed6581-b494-4872-bb2c-4e871ad514c6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:56:21', 315, 0, '', '2019-05-26 16:56:22');
INSERT INTO `access_log` VALUES (9706, '5d8baadd-b22e-4450-96f1-0003290c5adf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:56:22', 311, 0, '', '2019-05-26 16:56:22');
INSERT INTO `access_log` VALUES (9707, 'edb2b798-1968-4a7c-b2a5-bd15e88a877d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:56:21', 313, 0, '', '2019-05-26 16:56:22');
INSERT INTO `access_log` VALUES (9708, '3689df24-4984-463f-94ec-039d537c9f9f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:56:22', 219, 0, '', '2019-05-26 16:56:22');
INSERT INTO `access_log` VALUES (9709, '1c1e171b-afcf-4ef9-8059-758b15b400fe', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=10', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:57:07', 397, 0, '', '2019-05-26 16:57:07');
INSERT INTO `access_log` VALUES (9710, 'a5bf1271-2c18-4f60-9857-9996926dd4e4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:57:11', 140, 0, '', '2019-05-26 16:57:12');
INSERT INTO `access_log` VALUES (9711, 'a99c3501-a021-4874-a18f-5e6aafc4d8a8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:57:11', 139, 0, '', '2019-05-26 16:57:12');
INSERT INTO `access_log` VALUES (9712, '54f8c376-3980-41e0-ac97-741afe78688a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:57:11', 135, 0, '', '2019-05-26 16:57:12');
INSERT INTO `access_log` VALUES (9713, '86a57a47-7053-4aaf-ba71-12a26c0a1163', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:57:12', 173, 0, '', '2019-05-26 16:57:12');
INSERT INTO `access_log` VALUES (9714, 'fdedf361-80ed-4a2a-b1dd-f3f8f4c4b963', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/update', 'id=11&sign=mid&platform=2', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:57:18', 281, 1002006002, '短信签名已存在', '2019-05-26 16:57:19');
INSERT INTO `access_log` VALUES (9715, '1af99010-4e9e-4f9b-ac2e-f2baced8c2ee', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/update', 'id=11&sign=mid&platform=2', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:57:26', 283, 1002006002, '短信签名已存在', '2019-05-26 16:57:26');
INSERT INTO `access_log` VALUES (9716, 'b5093f98-435e-43e2-b1f3-100acdfff9f6', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/update', 'id=11&sign=mid&platform=1', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:57:29', 414, 0, '', '2019-05-26 16:57:30');
INSERT INTO `access_log` VALUES (9717, 'b9167747-3705-4b2a-a0ef-0436b9dfba65', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:57:30', 173, 0, '', '2019-05-26 16:57:30');
INSERT INTO `access_log` VALUES (9718, 'd7a9cbb8-1f4f-43dd-ae39-08a483178c46', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:33', 171, 0, '', '2019-05-26 16:58:33');
INSERT INTO `access_log` VALUES (9719, 'c49aa9fa-6702-4dec-a852-da192b19d98f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:33', 172, 0, '', '2019-05-26 16:58:33');
INSERT INTO `access_log` VALUES (9720, '30f0832a-3e72-485f-a2bd-11429421b7b1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:33', 177, 0, '', '2019-05-26 16:58:34');
INSERT INTO `access_log` VALUES (9721, '4edf0f97-da0b-41a9-b318-f23a62233c86', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:34', 136, 0, '', '2019-05-26 16:58:34');
INSERT INTO `access_log` VALUES (9722, 'f054fed2-f5a5-4ea3-aa5e-dbe511f5256a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:34', 233, 0, '', '2019-05-26 16:58:35');
INSERT INTO `access_log` VALUES (9723, '88eafa83-4dcc-4cd4-97c7-e118184697e0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:34', 235, 0, '', '2019-05-26 16:58:35');
INSERT INTO `access_log` VALUES (9724, 'e6c73281-844a-48e6-a590-0042a870eda1', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:34', 265, 0, '', '2019-05-26 16:58:35');
INSERT INTO `access_log` VALUES (9725, 'bf8f7dbc-7917-4577-8c1d-d3740e9381ad', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:38', 166, 0, '', '2019-05-26 16:58:38');
INSERT INTO `access_log` VALUES (9726, 'e5982f37-8181-4f1f-b59a-8ebd11bdbe1d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:38', 162, 0, '', '2019-05-26 16:58:38');
INSERT INTO `access_log` VALUES (9727, '284ec299-d51f-47fa-ade2-411ce1dd77ea', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:38', 165, 0, '', '2019-05-26 16:58:38');
INSERT INTO `access_log` VALUES (9728, '3925eda8-ddb2-4e5d-a486-789a524a4f67', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:38', 173, 0, '', '2019-05-26 16:58:38');
INSERT INTO `access_log` VALUES (9729, '244150b1-653e-4cba-be78-e80d6e485b1c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:45', 142, 0, '', '2019-05-26 16:58:45');
INSERT INTO `access_log` VALUES (9730, '882d3af9-fa81-4687-ae5d-1aa7bc9e88fb', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:45', 141, 0, '', '2019-05-26 16:58:45');
INSERT INTO `access_log` VALUES (9731, '64e3e713-18bd-4c76-9940-91698f77f329', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:45', 143, 0, '', '2019-05-26 16:58:45');
INSERT INTO `access_log` VALUES (9732, 'fa1801b9-64d4-4056-91f2-318c8708506c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:45', 173, 0, '', '2019-05-26 16:58:46');
INSERT INTO `access_log` VALUES (9733, '0959a316-8065-46a2-8bcc-46c9a9434921', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:59', 142, 0, '', '2019-05-26 16:58:59');
INSERT INTO `access_log` VALUES (9734, 'bee1dee3-80c4-4f0e-ad40-bc54e12d091f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:59', 138, 0, '', '2019-05-26 16:58:59');
INSERT INTO `access_log` VALUES (9735, '30985fbc-c22e-4414-8380-010bd899b575', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:59', 142, 0, '', '2019-05-26 16:58:59');
INSERT INTO `access_log` VALUES (9736, '677d54a4-9d91-4cdd-8098-3efe0fe9cc31', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:58:59', 176, 0, '', '2019-05-26 16:58:59');
INSERT INTO `access_log` VALUES (9737, 'c750265d-adec-4b12-a488-bf5bd7b74a5a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:02:28', 177, 0, '', '2019-05-26 17:02:29');
INSERT INTO `access_log` VALUES (9738, '1818b6f6-00af-4734-ad0e-6e833fd8775d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:02:28', 173, 0, '', '2019-05-26 17:02:29');
INSERT INTO `access_log` VALUES (9739, '4681dcc4-77cd-4178-af65-8ea0b1cd7778', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:02:28', 177, 0, '', '2019-05-26 17:02:29');
INSERT INTO `access_log` VALUES (9740, '790dcb4c-fd6c-4be2-944c-cdf69169cad1', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:02:29', 205, 0, '', '2019-05-26 17:02:29');
INSERT INTO `access_log` VALUES (9741, '8d214c52-daed-423f-b398-e6f968234071', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:03:19', 137, 0, '', '2019-05-26 17:03:19');
INSERT INTO `access_log` VALUES (9742, '6962f99f-e926-4cde-bd2f-29544cd967c9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:03:19', 137, 0, '', '2019-05-26 17:03:19');
INSERT INTO `access_log` VALUES (9743, '84a29eed-71eb-43f7-960d-f538927c8ee4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:03:19', 140, 0, '', '2019-05-26 17:03:19');
INSERT INTO `access_log` VALUES (9744, 'd38d1964-0048-4500-8798-cc23c00f2761', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:03:19', 176, 0, '', '2019-05-26 17:03:19');
INSERT INTO `access_log` VALUES (9745, 'a26b002c-699e-4d17-abcc-b8e0f3eddbc6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:03:34', 137, 0, '', '2019-05-26 17:03:35');
INSERT INTO `access_log` VALUES (9746, 'f7089692-e5b7-4321-b961-396846bd5f2d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:03:34', 134, 0, '', '2019-05-26 17:03:35');
INSERT INTO `access_log` VALUES (9747, 'ffcd9c89-e2c0-4f84-a7d8-826d0918c561', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:03:34', 137, 0, '', '2019-05-26 17:03:35');
INSERT INTO `access_log` VALUES (9748, '2762fab0-a3de-4be5-afa1-fa1eb1337102', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:03:35', 172, 0, '', '2019-05-26 17:03:35');
INSERT INTO `access_log` VALUES (9749, 'ce7eba22-7e27-42f3-9ec1-1427a1750d12', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:04:03', 141, 0, '', '2019-05-26 17:04:03');
INSERT INTO `access_log` VALUES (9750, '80302871-8046-4c48-9a83-10ce327afda6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:04:03', 137, 0, '', '2019-05-26 17:04:03');
INSERT INTO `access_log` VALUES (9751, '80571c63-273c-4fe8-8e20-e8802b3056e6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:04:03', 206, 0, '', '2019-05-26 17:04:03');
INSERT INTO `access_log` VALUES (9752, 'a86ccd08-6425-4410-bf40-7862c2107d65', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:04:03', 175, 0, '', '2019-05-26 17:04:03');
INSERT INTO `access_log` VALUES (9753, 'ae254c8d-6944-477b-b16c-189f718e8322', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:04:09', 140, 0, '', '2019-05-26 17:04:09');
INSERT INTO `access_log` VALUES (9754, 'bc4f8da0-21d3-4379-b141-20542bc9865b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:04:09', 137, 0, '', '2019-05-26 17:04:09');
INSERT INTO `access_log` VALUES (9755, '1f772d9d-8382-4e16-b1a6-8f7c76067f99', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:04:09', 144, 0, '', '2019-05-26 17:04:09');
INSERT INTO `access_log` VALUES (9756, '83c096d7-3adb-4c4b-9765-0a0d3d695265', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:04:09', 173, 0, '', '2019-05-26 17:04:10');
INSERT INTO `access_log` VALUES (9757, '635b1f57-9c7b-42ed-a9b5-5d5809c2e1b4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:06', 174, 0, '', '2019-05-26 17:07:06');
INSERT INTO `access_log` VALUES (9758, '2353323c-294c-40d5-ac22-0842f3cfe36c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:06', 173, 0, '', '2019-05-26 17:07:06');
INSERT INTO `access_log` VALUES (9759, 'e912f74f-d673-4ade-80aa-6ef669b19e17', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:06', 174, 0, '', '2019-05-26 17:07:06');
INSERT INTO `access_log` VALUES (9760, '73958337-9d23-4b8f-94cb-f0587f0b6cde', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:06', 201, 0, '', '2019-05-26 17:07:06');
INSERT INTO `access_log` VALUES (9761, '2deb5825-e53e-4da0-8f70-0e97e2b653aa', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:11', 136, 0, '', '2019-05-26 17:07:11');
INSERT INTO `access_log` VALUES (9762, 'ecd0d028-b1ec-4237-9f4d-17d254879459', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:11', 139, 0, '', '2019-05-26 17:07:11');
INSERT INTO `access_log` VALUES (9763, '227bfdc2-56f6-44ed-9913-725fa539dce4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:11', 134, 0, '', '2019-05-26 17:07:11');
INSERT INTO `access_log` VALUES (9764, '8406fd5b-3f38-41bc-95d6-12850fa233cc', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:11', 172, 0, '', '2019-05-26 17:07:11');
INSERT INTO `access_log` VALUES (9765, '5dd75a2b-6dbf-4266-aab7-e3e8375e5a42', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:33', 139, 0, '', '2019-05-26 17:07:33');
INSERT INTO `access_log` VALUES (9766, 'b583fcd3-f7e2-47f3-922b-bf751aca252b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:33', 139, 0, '', '2019-05-26 17:07:33');
INSERT INTO `access_log` VALUES (9767, '0e6231b5-5f57-4b5b-9917-0991ff088ede', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:33', 138, 0, '', '2019-05-26 17:07:33');
INSERT INTO `access_log` VALUES (9768, '87e66a5c-6ead-4297-9f20-4110db1d5462', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:33', 169, 0, '', '2019-05-26 17:07:33');
INSERT INTO `access_log` VALUES (9769, '814d29bf-935f-4443-b5e7-62111f57d0a6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:37', 251, 0, '', '2019-05-26 17:07:37');
INSERT INTO `access_log` VALUES (9770, '0a5f38d3-c0c3-4126-b126-91ec14fd108c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:37', 249, 0, '', '2019-05-26 17:07:37');
INSERT INTO `access_log` VALUES (9771, 'c50f194a-3097-4578-af12-9823f850d635', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:37', 259, 0, '', '2019-05-26 17:07:37');
INSERT INTO `access_log` VALUES (9772, 'dc423e8e-6cd6-4f57-9f2f-ecce49abe0c9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:07:37', 466, 0, '', '2019-05-26 17:07:37');
INSERT INTO `access_log` VALUES (9773, 'e9a6052b-c3b4-4763-97ce-3c80554336b2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:08:15', 178, 0, '', '2019-05-26 17:08:15');
INSERT INTO `access_log` VALUES (9774, 'abfc019a-e153-4bed-8c14-d2329dae3cbd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:08:15', 182, 0, '', '2019-05-26 17:08:15');
INSERT INTO `access_log` VALUES (9775, 'a061b708-ac95-4e03-b5a1-5463c866fbe9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:08:15', 179, 0, '', '2019-05-26 17:08:15');
INSERT INTO `access_log` VALUES (9776, '1be9ab49-1e8f-4ad8-9ca3-4cb4d282f5db', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:08:15', 170, 0, '', '2019-05-26 17:08:15');
INSERT INTO `access_log` VALUES (9777, 'e06896a8-2583-46f5-8f72-69cf67ded6cd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:09:05', 141, 0, '', '2019-05-26 17:09:05');
INSERT INTO `access_log` VALUES (9778, '3c8508eb-29dc-4116-8ecc-cd931f3beabb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:09:05', 143, 0, '', '2019-05-26 17:09:05');
INSERT INTO `access_log` VALUES (9779, 'dec87759-7f9b-4ab6-8165-a93cf5927b84', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:09:05', 142, 0, '', '2019-05-26 17:09:05');
INSERT INTO `access_log` VALUES (9780, 'd699e6f8-b75a-4b20-8003-8e1d700299b1', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:09:05', 173, 0, '', '2019-05-26 17:09:06');
INSERT INTO `access_log` VALUES (9781, 'e8a48a28-209d-4986-bf24-bf17b6121611', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:09:07', 146, 0, '', '2019-05-26 17:09:08');
INSERT INTO `access_log` VALUES (9782, 'bb0a8a37-0e4b-4f45-8f51-98482585421a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:09:07', 145, 0, '', '2019-05-26 17:09:08');
INSERT INTO `access_log` VALUES (9783, '8c2eb033-9ce1-4233-8daf-9fe1f0186818', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:09:07', 142, 0, '', '2019-05-26 17:09:08');
INSERT INTO `access_log` VALUES (9784, '675338d0-1271-4670-b07a-46717ed43c0e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:09:08', 171, 0, '', '2019-05-26 17:09:08');
INSERT INTO `access_log` VALUES (9785, '0ce340f3-f107-43da-a022-7b9951717979', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:09:26', 137, 0, '', '2019-05-26 17:09:26');
INSERT INTO `access_log` VALUES (9786, 'e623d6b7-6cc9-4988-bf55-8d7e2af3d337', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:09:26', 142, 0, '', '2019-05-26 17:09:26');
INSERT INTO `access_log` VALUES (9787, '3e50a6ad-91e8-4faf-99d0-caf346e2b3ba', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:09:26', 138, 0, '', '2019-05-26 17:09:26');
INSERT INTO `access_log` VALUES (9788, '5f733c43-20f1-4e84-a76e-d8483ba13d10', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:09:26', 170, 0, '', '2019-05-26 17:09:26');
INSERT INTO `access_log` VALUES (9789, 'a629f058-48de-4be9-b6d8-1325ab6438b2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:11:55', 165, 0, '', '2019-05-26 17:11:55');
INSERT INTO `access_log` VALUES (9790, 'e336d506-20c2-4221-92a1-a9c98d8fe046', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:11:55', 168, 0, '', '2019-05-26 17:11:55');
INSERT INTO `access_log` VALUES (9791, '60e85fda-e488-4f95-b899-e5622f95d9e8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:11:55', 172, 0, '', '2019-05-26 17:11:55');
INSERT INTO `access_log` VALUES (9792, 'd9bd86f3-b73d-46b6-aaa4-321cb74f2cd5', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:11:55', 207, 0, '', '2019-05-26 17:11:56');
INSERT INTO `access_log` VALUES (9793, '1f055a23-921e-45e2-b563-3816e586241f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:12:00', 137, 0, '', '2019-05-26 17:12:01');
INSERT INTO `access_log` VALUES (9794, 'e58be2a0-406e-43c4-93ad-445dd9ed5727', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:12:00', 138, 0, '', '2019-05-26 17:12:01');
INSERT INTO `access_log` VALUES (9795, '80ac5e7c-5c9f-463a-939b-acb77a0bd7fc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:12:00', 138, 0, '', '2019-05-26 17:12:01');
INSERT INTO `access_log` VALUES (9796, '56ae8422-aab4-41b7-94e0-01e9fa244cf7', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:12:01', 170, 0, '', '2019-05-26 17:12:01');
INSERT INTO `access_log` VALUES (9797, 'ea439c0c-d107-49fb-8bee-26934f8ab21e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:12:44', 135, 0, '', '2019-05-26 17:12:44');
INSERT INTO `access_log` VALUES (9798, 'b90eb56e-5865-4380-b434-89eba01f7eee', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:12:44', 134, 0, '', '2019-05-26 17:12:44');
INSERT INTO `access_log` VALUES (9799, 'ea592ad7-e727-4268-81da-e36d5321f151', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:12:44', 142, 0, '', '2019-05-26 17:12:44');
INSERT INTO `access_log` VALUES (9800, '2179baf4-3f6b-4261-ad34-b01637ea5f2b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:12:44', 173, 0, '', '2019-05-26 17:12:44');
INSERT INTO `access_log` VALUES (9801, 'cd210ada-395c-4ddd-9900-49e8ac72e002', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:12:57', 440, 0, '', '2019-05-26 17:12:57');
INSERT INTO `access_log` VALUES (9802, '841adbd8-a515-4887-9150-6c902a61abe9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:12:57', 441, 0, '', '2019-05-26 17:12:57');
INSERT INTO `access_log` VALUES (9803, '08974a15-9f68-4e4b-8259-1d412e3feafe', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:12:57', 443, 0, '', '2019-05-26 17:12:57');
INSERT INTO `access_log` VALUES (9804, 'fda73e7a-8026-4594-8b24-f726c35dfa16', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:12:57', 396, 0, '', '2019-05-26 17:12:57');
INSERT INTO `access_log` VALUES (9805, '0bb0d0d7-f50f-4a29-9720-362be074e4bd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:14:37', 171, 0, '', '2019-05-26 17:14:38');
INSERT INTO `access_log` VALUES (9806, 'd0638ac0-e555-4ace-8312-0f17facc87fb', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:14:37', 170, 0, '', '2019-05-26 17:14:38');
INSERT INTO `access_log` VALUES (9807, 'd1359c12-0f22-4914-86ab-85b1f11e26f5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:14:37', 171, 0, '', '2019-05-26 17:14:38');
INSERT INTO `access_log` VALUES (9808, '8ae0f819-08b4-499b-8e59-542dbb113e66', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:14:38', 212, 0, '', '2019-05-26 17:14:38');
INSERT INTO `access_log` VALUES (9809, '04b74fd4-2d33-49a4-bf3f-4745deec8ea5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:14:46', 136, 0, '', '2019-05-26 17:14:46');
INSERT INTO `access_log` VALUES (9810, 'a652ca85-7a93-4f87-971b-45081f7ac4a3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:14:46', 135, 0, '', '2019-05-26 17:14:46');
INSERT INTO `access_log` VALUES (9811, '98f93fe7-c11e-4425-8ec5-5a8bbb5af254', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:14:46', 135, 0, '', '2019-05-26 17:14:46');
INSERT INTO `access_log` VALUES (9812, '660862e0-ecbd-49f1-ab68-7542877f6bb0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:14:46', 166, 0, '', '2019-05-26 17:14:46');
INSERT INTO `access_log` VALUES (9813, '7d04cfd2-eb32-4232-a64f-984c0e5e0889', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:14:50', 140, 0, '', '2019-05-26 17:14:50');
INSERT INTO `access_log` VALUES (9814, 'ca806d06-6375-4704-86da-c27df5975d83', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:14:50', 141, 0, '', '2019-05-26 17:14:50');
INSERT INTO `access_log` VALUES (9815, 'c5a2aec4-31a0-4c9b-ad30-7fc5c1a0580c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:14:50', 138, 0, '', '2019-05-26 17:14:50');
INSERT INTO `access_log` VALUES (9816, '9c52a8bd-071d-4a27-8d83-7e28c6674087', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:14:50', 174, 0, '', '2019-05-26 17:14:50');
INSERT INTO `access_log` VALUES (9817, 'f80e21e0-0496-456d-8bd6-d36eddb3d1f4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:15:11', 146, 0, '', '2019-05-26 17:15:11');
INSERT INTO `access_log` VALUES (9818, '32812fe4-0487-469a-a430-c02d4462c345', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:15:11', 148, 0, '', '2019-05-26 17:15:11');
INSERT INTO `access_log` VALUES (9819, 'c28bc9fe-9450-41bd-95a2-35e9c440129b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:15:11', 148, 0, '', '2019-05-26 17:15:11');
INSERT INTO `access_log` VALUES (9820, '3dd19920-6038-4360-b435-8eada2000978', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:15:12', 181, 0, '', '2019-05-26 17:15:12');
INSERT INTO `access_log` VALUES (9821, 'c88d7f56-bd52-4ddf-a4f1-0aa740c45514', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:15:13', 138, 0, '', '2019-05-26 17:15:13');
INSERT INTO `access_log` VALUES (9822, 'ea308a5f-8643-477e-829a-05e4cdae6fba', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:15:13', 135, 0, '', '2019-05-26 17:15:13');
INSERT INTO `access_log` VALUES (9823, '68164594-b350-401c-a89d-264055c26d59', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:15:13', 139, 0, '', '2019-05-26 17:15:13');
INSERT INTO `access_log` VALUES (9824, 'd1385a26-a910-46bc-86cf-f8704827d0de', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:15:13', 172, 0, '', '2019-05-26 17:15:13');
INSERT INTO `access_log` VALUES (9825, 'd70af17d-9543-4487-9850-52bf44676ff0', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:18:51', 68, 1002001012, '访问令牌已过期', '2019-05-26 17:18:51');
INSERT INTO `access_log` VALUES (9826, '2d61f60e-0cc7-4bb8-a782-d9fbb21eb7a1', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:18:51', 67, 1002001012, '访问令牌已过期', '2019-05-26 17:18:51');
INSERT INTO `access_log` VALUES (9827, '03fa066d-0290-4e54-9bd1-641356de8ad3', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:18:51', 66, 1002001012, '访问令牌已过期', '2019-05-26 17:18:51');
INSERT INTO `access_log` VALUES (9828, 'faa65012-b0e0-4e86-990b-a7147dcc04fb', 0, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:18:52', 69, 1002001012, '访问令牌已过期', '2019-05-26 17:18:52');
INSERT INTO `access_log` VALUES (9829, '92a29a25-9ff4-4b01-bdc4-f492afe40958', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:18:59', 417, 0, '', '2019-05-26 17:18:59');
INSERT INTO `access_log` VALUES (9830, '21d1f123-97f8-4fe3-892b-dde2fb5ca4bd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:18:59', 137, 0, '', '2019-05-26 17:18:59');
INSERT INTO `access_log` VALUES (9831, 'e006b6bd-432b-4479-b3f6-5532e37bf76e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:18:59', 140, 0, '', '2019-05-26 17:18:59');
INSERT INTO `access_log` VALUES (9832, 'd17554f8-9709-4ec3-a4fe-aece2552f00b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:18:59', 140, 0, '', '2019-05-26 17:18:59');
INSERT INTO `access_log` VALUES (9833, 'db1f1b9b-e996-4e61-ba1b-1bf444b92dc7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:02', 143, 0, '', '2019-05-26 17:19:03');
INSERT INTO `access_log` VALUES (9834, '65233f57-e75e-47e4-938a-46095cad7f45', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:02', 141, 0, '', '2019-05-26 17:19:03');
INSERT INTO `access_log` VALUES (9835, '42964a90-238b-428b-bf6c-9216ce4052fa', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:02', 146, 0, '', '2019-05-26 17:19:03');
INSERT INTO `access_log` VALUES (9836, '92ad3dca-42f4-482c-994e-3322e0dfaf79', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:08', 205, 0, '', '2019-05-26 17:19:08');
INSERT INTO `access_log` VALUES (9837, '9999e1d9-bafe-4af6-b2f1-52deed0b39f3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:08', 210, 0, '', '2019-05-26 17:19:08');
INSERT INTO `access_log` VALUES (9838, '59291010-32fb-47bf-a223-fa1ee131e972', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:08', 208, 0, '', '2019-05-26 17:19:08');
INSERT INTO `access_log` VALUES (9839, 'ec1b6ba9-e0a1-4427-84ec-d2ff133270dd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:45', 142, 0, '', '2019-05-26 17:19:45');
INSERT INTO `access_log` VALUES (9840, '5060e905-eed4-4b82-91b9-3c8ee811e761', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:45', 137, 0, '', '2019-05-26 17:19:45');
INSERT INTO `access_log` VALUES (9841, 'd88a7b6e-06b0-4f1d-99fc-ea0b02330a30', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:45', 140, 0, '', '2019-05-26 17:19:45');
INSERT INTO `access_log` VALUES (9842, '99e2dfa1-110f-4e30-b600-3ab680f38377', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:56', 146, 0, '', '2019-05-26 17:19:56');
INSERT INTO `access_log` VALUES (9843, 'b07819fb-d17f-4436-89e9-e30b69646a72', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:56', 141, 0, '', '2019-05-26 17:19:56');
INSERT INTO `access_log` VALUES (9844, '0a63e9a8-fc50-4caa-a6ec-51eb0bee64fb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:56', 144, 0, '', '2019-05-26 17:19:56');
INSERT INTO `access_log` VALUES (9845, '390f42c2-470d-4087-8238-632f8d97095a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:59', 141, 0, '', '2019-05-26 17:19:59');
INSERT INTO `access_log` VALUES (9846, 'f4840731-2619-4681-910e-a3cfb23914bd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:59', 142, 0, '', '2019-05-26 17:19:59');
INSERT INTO `access_log` VALUES (9847, '906a69a9-fdcf-4c2b-94f3-7e10f0f5e8a6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:19:59', 144, 0, '', '2019-05-26 17:19:59');
INSERT INTO `access_log` VALUES (9848, '5c5f699f-f2d8-4963-a692-eeeb650aace3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:20:10', 200, 0, '', '2019-05-26 17:20:10');
INSERT INTO `access_log` VALUES (9849, '52326503-9ab5-4cfb-86f1-86b735e5f66a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:20:10', 203, 0, '', '2019-05-26 17:20:10');
INSERT INTO `access_log` VALUES (9850, 'f978f312-5550-4b17-b151-1b9db1b30010', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:20:10', 203, 0, '', '2019-05-26 17:20:10');
INSERT INTO `access_log` VALUES (9851, '73c49b00-763d-451a-9cd8-113f4f090378', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:20:13', 337, 0, '', '2019-05-26 17:20:13');
INSERT INTO `access_log` VALUES (9852, 'd9618d01-27ed-42e8-bee8-92b83a3488b9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:20:13', 333, 0, '', '2019-05-26 17:20:13');
INSERT INTO `access_log` VALUES (9853, '69ec3a13-6a25-4877-96df-6af6b62119ac', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:20:13', 330, 0, '', '2019-05-26 17:20:13');
INSERT INTO `access_log` VALUES (9854, 'f97b3f9d-1c7e-4aa7-8c3f-905a82cd6ab2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:20:38', 1002, 0, '', '2019-05-26 17:20:39');
INSERT INTO `access_log` VALUES (9855, 'fc6e20a5-79dc-4824-852b-76658161e301', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:20:38', 1002, 0, '', '2019-05-26 17:20:39');
INSERT INTO `access_log` VALUES (9856, 'bc6572be-fa54-45d4-b7c0-1307e30ea30a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:20:38', 1003, 0, '', '2019-05-26 17:20:39');
INSERT INTO `access_log` VALUES (9857, 'ca27ae80-34e2-4593-9e6c-41bfa1108147', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:20:43', 174, 0, '', '2019-05-26 17:20:43');
INSERT INTO `access_log` VALUES (9858, '36a94222-d7d3-42aa-8e82-096b9164a171', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:20:53', 138, 0, '', '2019-05-26 17:20:53');
INSERT INTO `access_log` VALUES (9859, '663073b4-bfa1-4fdb-9844-185f169359ec', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:20:53', 142, 0, '', '2019-05-26 17:20:53');
INSERT INTO `access_log` VALUES (9860, 'c90f4363-be97-40a6-886c-6c45da3a0b9e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:20:53', 203, 0, '', '2019-05-26 17:20:53');
INSERT INTO `access_log` VALUES (9861, '9a9921ce-d3db-461f-b5ac-421c26ff43f2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:20:53', 301, 0, '', '2019-05-26 17:20:53');
INSERT INTO `access_log` VALUES (9862, 'd0eca4b6-8710-439b-8df4-c3b77a85d8c3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:04', 141, 0, '', '2019-05-26 17:21:05');
INSERT INTO `access_log` VALUES (9863, 'ae09d215-47c7-48a9-84fc-434c6dd79604', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:04', 139, 0, '', '2019-05-26 17:21:05');
INSERT INTO `access_log` VALUES (9864, '6657394d-5527-4e1f-a724-4e540ea8ee78', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:04', 138, 0, '', '2019-05-26 17:21:05');
INSERT INTO `access_log` VALUES (9865, '4df40efb-e2df-4a1a-8365-77c24d2a2c4a', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:04', 171, 0, '', '2019-05-26 17:21:05');
INSERT INTO `access_log` VALUES (9866, 'a199eb4d-53d7-4d4c-8adb-5403e3ea837f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:11', 135, 0, '', '2019-05-26 17:21:11');
INSERT INTO `access_log` VALUES (9867, '44674e27-d0e3-497a-b4ef-76174513dd81', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:11', 138, 0, '', '2019-05-26 17:21:11');
INSERT INTO `access_log` VALUES (9868, '37c6aac6-75d0-4eff-a66d-cf985b93e9c4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:11', 138, 0, '', '2019-05-26 17:21:11');
INSERT INTO `access_log` VALUES (9869, '5fd6b599-7c42-40a5-8042-7007ededf35f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:11', 171, 0, '', '2019-05-26 17:21:11');
INSERT INTO `access_log` VALUES (9870, '1c01d0e1-3d14-4661-b439-5293bc561b12', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:35', 139, 0, '', '2019-05-26 17:21:35');
INSERT INTO `access_log` VALUES (9871, 'b68c89b2-b645-4182-b52a-15840dae57de', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:35', 138, 0, '', '2019-05-26 17:21:35');
INSERT INTO `access_log` VALUES (9872, '60b8b639-7ad9-48d3-b9bb-bdff5cbd1910', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:35', 139, 0, '', '2019-05-26 17:21:35');
INSERT INTO `access_log` VALUES (9873, 'e55756bc-5f42-43fa-9df3-f6a525e413ac', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:35', 213, 0, '', '2019-05-26 17:21:36');
INSERT INTO `access_log` VALUES (9874, '5cee73d2-70ed-4f2c-8d6a-01ea5d567064', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:41', 178, 0, '', '2019-05-26 17:21:41');
INSERT INTO `access_log` VALUES (9875, 'e7100271-ede3-4e42-bbeb-76a4553d4246', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:41', 187, 0, '', '2019-05-26 17:21:41');
INSERT INTO `access_log` VALUES (9876, 'ca383d25-653b-43a9-9306-3082b2e495b6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:41', 184, 0, '', '2019-05-26 17:21:41');
INSERT INTO `access_log` VALUES (9877, 'fbbfad6d-8bee-4be7-a09d-4aa8a5f6a89e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:41', 223, 0, '', '2019-05-26 17:21:41');
INSERT INTO `access_log` VALUES (9878, '853e55b1-0ee9-4e04-bddb-65f1bdb1c12e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:43', 138, 0, '', '2019-05-26 17:21:43');
INSERT INTO `access_log` VALUES (9879, '99eb531e-a883-43eb-b017-06d3d036cce4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:43', 136, 0, '', '2019-05-26 17:21:43');
INSERT INTO `access_log` VALUES (9880, 'aed5f4ca-7214-4f4d-8ef6-66ccf79b6c33', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:43', 139, 0, '', '2019-05-26 17:21:43');
INSERT INTO `access_log` VALUES (9881, '12459326-f243-4eae-b3f7-ce0af961c8fb', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:43', 167, 0, '', '2019-05-26 17:21:43');
INSERT INTO `access_log` VALUES (9882, '253e56f9-f114-4474-876b-a66051460259', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:45', 139, 0, '', '2019-05-26 17:21:45');
INSERT INTO `access_log` VALUES (9883, 'ae379875-d20b-4c9f-8044-8aaa57285864', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:45', 138, 0, '', '2019-05-26 17:21:45');
INSERT INTO `access_log` VALUES (9884, '62c04194-b837-4f20-b634-c85790156a85', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:45', 141, 0, '', '2019-05-26 17:21:45');
INSERT INTO `access_log` VALUES (9885, '5ba6899a-0194-4da3-96b8-1ae4e88bddf1', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:21:45', 174, 0, '', '2019-05-26 17:21:46');
INSERT INTO `access_log` VALUES (9886, '665e9e3a-ccc6-45a6-b7ba-67669e305cb7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:22:06', 137, 0, '', '2019-05-26 17:22:06');
INSERT INTO `access_log` VALUES (9887, 'ba138f1a-243c-4e62-a540-32d950c1d55b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:22:06', 137, 0, '', '2019-05-26 17:22:06');
INSERT INTO `access_log` VALUES (9888, '167eedce-6664-4171-a333-4b5ae8bc3bed', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:22:06', 137, 0, '', '2019-05-26 17:22:06');
INSERT INTO `access_log` VALUES (9889, 'b04731ce-9f02-4564-8c2a-f7b7c72d1394', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:22:06', 171, 0, '', '2019-05-26 17:22:06');
INSERT INTO `access_log` VALUES (9890, 'd2690153-79e3-4e64-be37-097429d6120c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:22:08', 185, 0, '', '2019-05-26 17:22:08');
INSERT INTO `access_log` VALUES (9891, '4fd8a438-b8a0-45dc-92ec-b38369ea9605', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:22:08', 178, 0, '', '2019-05-26 17:22:08');
INSERT INTO `access_log` VALUES (9892, 'ec224e5a-a322-41ab-8c75-e41e54d1ed5c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:22:08', 181, 0, '', '2019-05-26 17:22:08');
INSERT INTO `access_log` VALUES (9893, 'c9acfb2c-0775-4716-bd62-611ba70c4563', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:22:08', 176, 0, '', '2019-05-26 17:22:09');
INSERT INTO `access_log` VALUES (9894, 'e62f09c7-712a-4530-aca1-5b52579e293e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/update', 'id=11&sign=mid&platform=2', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:24:14', 528, 0, '', '2019-05-26 17:24:15');
INSERT INTO `access_log` VALUES (9895, '71d8e696-72a2-49ea-9b2e-15c0050bd88a', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:24:15', 175, 0, '', '2019-05-26 17:24:15');
INSERT INTO `access_log` VALUES (9896, '2349adf3-4283-42e3-b7a5-c2aab65ecd1e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/update', 'id=11&sign=mid&platform=1', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:24:21', 479, 0, '', '2019-05-26 17:24:22');
INSERT INTO `access_log` VALUES (9897, '12850a7a-2d8d-41eb-ae3f-ecbda95d83df', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:24:22', 175, 0, '', '2019-05-26 17:24:22');
INSERT INTO `access_log` VALUES (9898, 'fc3b94cb-40e0-40f0-b454-b59e43fd6515', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/update', 'id=11&sign=mid&platform=2', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:24:38', 419, 0, '', '2019-05-26 17:24:38');
INSERT INTO `access_log` VALUES (9899, '90064def-d2ad-4657-a5aa-45ad37e1a049', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:24:38', 176, 0, '', '2019-05-26 17:24:39');
INSERT INTO `access_log` VALUES (9900, 'fe322d3d-a102-444b-a838-3b54f50b9f98', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=11', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:24:41', 302, 0, '', '2019-05-26 17:24:42');
INSERT INTO `access_log` VALUES (9901, '47d721b9-5c45-4191-8c83-07d5babfa048', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:24:58', 146, 0, '', '2019-05-26 17:24:58');
INSERT INTO `access_log` VALUES (9902, '53cfd513-1cc0-4a70-8911-01fde2bb99bc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:24:58', 179, 0, '', '2019-05-26 17:24:58');
INSERT INTO `access_log` VALUES (9903, '35cf87cc-1a38-4430-b974-732717811b6c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:24:58', 179, 0, '', '2019-05-26 17:24:58');
INSERT INTO `access_log` VALUES (9904, 'd2d6c19a-27d0-4d4e-9142-12ff82397e16', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:24:59', 177, 0, '', '2019-05-26 17:24:59');
INSERT INTO `access_log` VALUES (9905, '92d40f59-1b16-4a19-a8fd-3700fb539321', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:26:06', 173, 0, '', '2019-05-26 17:26:06');
INSERT INTO `access_log` VALUES (9906, '660d9f70-18c0-499c-bb5c-49f2414efb18', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:26:06', 175, 0, '', '2019-05-26 17:26:06');
INSERT INTO `access_log` VALUES (9907, '460d6192-4834-44cf-a8fc-d4df3cfef3b8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:26:06', 175, 0, '', '2019-05-26 17:26:06');
INSERT INTO `access_log` VALUES (9908, 'b690dcc7-77bb-48f1-83e4-93a13fc95efa', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:26:07', 188, 0, '', '2019-05-26 17:26:07');
INSERT INTO `access_log` VALUES (9909, 'cf84e519-0935-40e3-9dd4-4aab6ce002e9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:26:48', 140, 0, '', '2019-05-26 17:26:48');
INSERT INTO `access_log` VALUES (9910, '43ddbeda-5d3f-49e3-b9f9-4b7f34c63da5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:26:48', 290, 0, '', '2019-05-26 17:26:48');
INSERT INTO `access_log` VALUES (9911, '42629970-7bf2-4bb8-aff5-03cd59bfa9ef', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:26:48', 201, 0, '', '2019-05-26 17:26:48');
INSERT INTO `access_log` VALUES (9912, '60725367-2191-405e-9ac5-bca1a86b4496', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:26:48', 397, 0, '', '2019-05-26 17:26:48');
INSERT INTO `access_log` VALUES (9913, '50f9acd7-68fe-4275-b307-3678abf42622', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:27:53', 168, 0, '', '2019-05-26 17:27:53');
INSERT INTO `access_log` VALUES (9914, '64aa418c-0426-4a41-a5b4-f0f05d888896', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:27:53', 168, 0, '', '2019-05-26 17:27:53');
INSERT INTO `access_log` VALUES (9915, 'd52510eb-fbd3-42a9-a08a-d277ae46a112', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:27:53', 170, 0, '', '2019-05-26 17:27:53');
INSERT INTO `access_log` VALUES (9916, '1d74fc0f-960f-4554-a4be-86acfe6bebe5', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:27:53', 203, 0, '', '2019-05-26 17:27:53');
INSERT INTO `access_log` VALUES (9917, 'bc384c3f-0e84-43b9-90e5-096b3949b149', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:28:17', 474, 0, '', '2019-05-26 17:28:17');
INSERT INTO `access_log` VALUES (9918, '957857da-642d-40ff-b0a3-46ccc0134f25', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:28:17', 471, 0, '', '2019-05-26 17:28:17');
INSERT INTO `access_log` VALUES (9919, 'b775df54-f4fb-42a1-84a8-59b7fc1cea74', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:28:17', 473, 0, '', '2019-05-26 17:28:17');
INSERT INTO `access_log` VALUES (9920, 'c27f93e5-0e6a-4e1b-965a-532a8612f366', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:28:17', 559, 0, '', '2019-05-26 17:28:17');
INSERT INTO `access_log` VALUES (9921, '0faf2ad3-cb5a-453d-bc2e-f6d06d684f2f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:28:41', 234, 0, '', '2019-05-26 17:28:41');
INSERT INTO `access_log` VALUES (9922, 'f22321e2-6ad7-4ec2-bf98-de7bd3f4ebff', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:28:41', 234, 0, '', '2019-05-26 17:28:41');
INSERT INTO `access_log` VALUES (9923, '92654f8b-79de-4020-bb98-9424bc289d52', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:28:41', 230, 0, '', '2019-05-26 17:28:41');
INSERT INTO `access_log` VALUES (9924, '1724ce79-4b4f-4e38-8150-dccd14c2fe39', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:28:41', 196, 0, '', '2019-05-26 17:28:41');
INSERT INTO `access_log` VALUES (9925, 'b076ff65-de8a-46d9-95f8-0a9d991a1aa4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:29:24', 139, 0, '', '2019-05-26 17:29:24');
INSERT INTO `access_log` VALUES (9926, '092115d1-4a5e-4f45-ba57-5fba8b296ae0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:29:24', 136, 0, '', '2019-05-26 17:29:24');
INSERT INTO `access_log` VALUES (9927, '83957fca-0cf8-4f6c-accc-2337d5bdc8fc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:29:24', 141, 0, '', '2019-05-26 17:29:24');
INSERT INTO `access_log` VALUES (9928, 'cd2efd74-dac1-4fa9-9ca0-dbf9c3967d78', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:29:24', 171, 0, '', '2019-05-26 17:29:24');
INSERT INTO `access_log` VALUES (9929, 'c2239877-b281-4785-beed-0d6bd06e50ba', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:29:25', 146, 0, '', '2019-05-26 17:29:25');
INSERT INTO `access_log` VALUES (9930, '552c61df-9b23-4605-915b-d2600c58aed8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:29:25', 152, 0, '', '2019-05-26 17:29:25');
INSERT INTO `access_log` VALUES (9931, '446d6ce1-d38f-4045-910a-91d04b659648', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:29:25', 147, 0, '', '2019-05-26 17:29:25');
INSERT INTO `access_log` VALUES (9932, '8819d7f8-4cda-4087-9139-6441ce6094e0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:29:25', 186, 0, '', '2019-05-26 17:29:26');
INSERT INTO `access_log` VALUES (9933, '03de8836-4cf2-40c6-8205-274baa87c194', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:24', 138, 0, '', '2019-05-26 17:30:24');
INSERT INTO `access_log` VALUES (9934, '563de4ab-761a-490c-bb13-c3bb7efafcda', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:24', 138, 0, '', '2019-05-26 17:30:24');
INSERT INTO `access_log` VALUES (9935, '9a0a8326-1380-4273-94d2-efd4621c9856', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:24', 138, 0, '', '2019-05-26 17:30:24');
INSERT INTO `access_log` VALUES (9936, '455ac46b-7365-4a31-b8fe-886fa773d351', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:24', 181, 0, '', '2019-05-26 17:30:24');
INSERT INTO `access_log` VALUES (9937, 'db8f2919-f70e-4842-acec-ca516f3e6d3c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:37', 137, 0, '', '2019-05-26 17:30:37');
INSERT INTO `access_log` VALUES (9938, '7517bc95-3ed4-4b41-95fe-d1ed44e3a360', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:37', 136, 0, '', '2019-05-26 17:30:37');
INSERT INTO `access_log` VALUES (9939, 'a629ce4b-b3f8-4f2a-9ad0-c41f43c1a3a9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:37', 140, 0, '', '2019-05-26 17:30:37');
INSERT INTO `access_log` VALUES (9940, '78905cf5-a60e-4b45-9850-be8b31dbce21', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:37', 207, 0, '', '2019-05-26 17:30:37');
INSERT INTO `access_log` VALUES (9941, 'b6ae6246-2264-4298-82c6-a772bc087218', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:49', 140, 0, '', '2019-05-26 17:30:49');
INSERT INTO `access_log` VALUES (9942, '72b87a08-9160-47b0-bae9-9696a95d5991', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:49', 140, 0, '', '2019-05-26 17:30:49');
INSERT INTO `access_log` VALUES (9943, 'ad019a07-bafe-41d8-bd27-9f268c4f257c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:49', 140, 0, '', '2019-05-26 17:30:49');
INSERT INTO `access_log` VALUES (9944, '4d6faab9-d832-48bd-80cb-bcce76c872c6', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:49', 171, 0, '', '2019-05-26 17:30:49');
INSERT INTO `access_log` VALUES (9945, '0aac68b9-a995-4aae-b684-9c7d83303332', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:50', 140, 0, '', '2019-05-26 17:30:50');
INSERT INTO `access_log` VALUES (9946, '506556ff-770e-4dbb-aa96-7d3a730eb74b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:50', 137, 0, '', '2019-05-26 17:30:50');
INSERT INTO `access_log` VALUES (9947, 'e9f2bcb7-bc89-426f-8778-5754adcac137', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:50', 139, 0, '', '2019-05-26 17:30:50');
INSERT INTO `access_log` VALUES (9948, '1c84076b-945f-4910-99e0-524b7fe07112', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:50', 169, 0, '', '2019-05-26 17:30:50');
INSERT INTO `access_log` VALUES (9949, '1809af08-e5be-4f64-8189-dd08a6c2d438', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:52', 138, 0, '', '2019-05-26 17:30:53');
INSERT INTO `access_log` VALUES (9950, '037f99a2-7c65-4970-a2c8-159f9b7c452a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:52', 147, 0, '', '2019-05-26 17:30:53');
INSERT INTO `access_log` VALUES (9951, 'a699871d-6199-4191-8bbd-34f59082394d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:52', 142, 0, '', '2019-05-26 17:30:53');
INSERT INTO `access_log` VALUES (9952, 'a871f334-47ea-4b75-903d-c2efce395028', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:30:53', 177, 0, '', '2019-05-26 17:30:53');
INSERT INTO `access_log` VALUES (9953, 'c3be9114-29ac-4a15-be0d-147df0a307c0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:31:08', 137, 0, '', '2019-05-26 17:31:08');
INSERT INTO `access_log` VALUES (9954, '98e37a54-51b7-4610-8470-949f94d857f8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:31:08', 138, 0, '', '2019-05-26 17:31:08');
INSERT INTO `access_log` VALUES (9955, 'a1bedd48-17f9-484d-a1b8-51f0a3ca0263', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:31:08', 140, 0, '', '2019-05-26 17:31:08');
INSERT INTO `access_log` VALUES (9956, '705e8883-14c8-4fab-a701-f04200c56b2c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:31:08', 171, 0, '', '2019-05-26 17:31:08');
INSERT INTO `access_log` VALUES (9957, 'c153df4e-ae16-4002-95b4-85f8187f387e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:31:10', 136, 0, '', '2019-05-26 17:31:11');
INSERT INTO `access_log` VALUES (9958, 'ad1e7eb3-76d5-4f50-9fdb-de894603cd8a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:31:10', 139, 0, '', '2019-05-26 17:31:11');
INSERT INTO `access_log` VALUES (9959, 'fd9225d7-7e4a-44bc-861a-5fb8a747a003', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:31:10', 137, 0, '', '2019-05-26 17:31:11');
INSERT INTO `access_log` VALUES (9960, '40affb65-8060-448a-9cb1-471ea3874083', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:31:10', 170, 0, '', '2019-05-26 17:31:11');
INSERT INTO `access_log` VALUES (9961, '8b3171ed-3024-4eb0-aa29-dfc1f01f35ac', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:31:14', 145, 0, '', '2019-05-26 17:31:14');
INSERT INTO `access_log` VALUES (9962, '0f61a2e4-0992-48c4-8bdb-8e15723b0bb5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:31:14', 141, 0, '', '2019-05-26 17:31:14');
INSERT INTO `access_log` VALUES (9963, '4438107c-4959-473d-84f7-cdc0b6c86f32', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:31:14', 145, 0, '', '2019-05-26 17:31:14');
INSERT INTO `access_log` VALUES (9964, '928f1996-384e-4d8a-af4f-250c9865dd7e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:31:14', 183, 0, '', '2019-05-26 17:31:14');
INSERT INTO `access_log` VALUES (9965, '95f2be3f-350a-41a5-8ead-f995ff0a5225', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=SIM', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:31:24', 113, 2001001001, '参数缺失:Required Integer parameter \'platform\' is not present', '2019-05-26 17:31:24');
INSERT INTO `access_log` VALUES (9966, 'ef6c2bd4-2489-4684-a341-e6dfd28ea7b2', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=MKD', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:31:34', 137, 2001001001, '参数缺失:Required Integer parameter \'platform\' is not present', '2019-05-26 17:31:34');
INSERT INTO `access_log` VALUES (9967, '91023759-cb07-406a-ad19-151382d82b61', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:32:38', 181, 0, '', '2019-05-26 17:32:38');
INSERT INTO `access_log` VALUES (9968, '814e20b6-8c52-4fac-9a54-0e47603b8914', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:32:38', 183, 0, '', '2019-05-26 17:32:38');
INSERT INTO `access_log` VALUES (9969, 'a235eca1-ae59-4ae4-9e11-bdd094c42e37', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:32:38', 178, 0, '', '2019-05-26 17:32:38');
INSERT INTO `access_log` VALUES (9970, 'a38cfa67-266b-40da-a761-25dbffe4649c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:32:38', 213, 0, '', '2019-05-26 17:32:38');
INSERT INTO `access_log` VALUES (9971, '44a0565b-2c0c-4f15-8e4c-b3f7e4adde0d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:32:40', 134, 0, '', '2019-05-26 17:32:40');
INSERT INTO `access_log` VALUES (9972, 'c06ea48a-c289-4b11-980a-b74b41b149ae', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:32:40', 134, 0, '', '2019-05-26 17:32:40');
INSERT INTO `access_log` VALUES (9973, '27e4f208-8cb9-4b9b-8d6e-fea85ed6666d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:32:40', 134, 0, '', '2019-05-26 17:32:40');
INSERT INTO `access_log` VALUES (9974, 'f721fdcf-b73a-474f-ab86-af6e320f5cf7', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:32:40', 172, 0, '', '2019-05-26 17:32:41');
INSERT INTO `access_log` VALUES (9975, 'ad2fdb3b-4302-4e4a-ad21-be995568d188', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:32:48', 136, 0, '', '2019-05-26 17:32:48');
INSERT INTO `access_log` VALUES (9976, 'c0ebe1b8-b8df-47d1-91d0-32324fffa356', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:32:48', 139, 0, '', '2019-05-26 17:32:48');
INSERT INTO `access_log` VALUES (9977, '416da92d-3eca-412b-8827-71acd8fe9144', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:32:48', 141, 0, '', '2019-05-26 17:32:48');
INSERT INTO `access_log` VALUES (9978, '8b716af9-e812-413f-98d7-adf8484940d3', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:32:48', 179, 0, '', '2019-05-26 17:32:48');
INSERT INTO `access_log` VALUES (9979, '02b6526e-c499-4453-804b-1722dd963e13', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=ff', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:32:53', 110, 2001001001, '参数缺失:Required Integer parameter \'platform\' is not present', '2019-05-26 17:32:53');
INSERT INTO `access_log` VALUES (9980, '3c6621c9-224b-4192-9a43-5c732d9a3bff', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:13', 138, 0, '', '2019-05-26 17:33:13');
INSERT INTO `access_log` VALUES (9981, 'bf344c3c-bb92-418d-857b-69b0113911d0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:13', 139, 0, '', '2019-05-26 17:33:13');
INSERT INTO `access_log` VALUES (9982, 'ac727d26-073a-45db-a2d2-38a106d44e78', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:13', 134, 0, '', '2019-05-26 17:33:13');
INSERT INTO `access_log` VALUES (9983, '10961a58-1c0a-4898-b732-d0e3bab3254b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:13', 174, 0, '', '2019-05-26 17:33:14');
INSERT INTO `access_log` VALUES (9984, 'f9c7d255-89be-48d9-8af7-5c2ff6c0f08e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:19', 144, 0, '', '2019-05-26 17:33:19');
INSERT INTO `access_log` VALUES (9985, '37e7381f-51ca-4a0a-ae9b-6e52dcc2d2c1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:19', 148, 0, '', '2019-05-26 17:33:19');
INSERT INTO `access_log` VALUES (9986, 'e178f2bd-b81e-495c-a699-649e12362bde', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:19', 150, 0, '', '2019-05-26 17:33:19');
INSERT INTO `access_log` VALUES (9987, '8675e0aa-b375-478d-86ea-17c67c27a5c6', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:19', 244, 0, '', '2019-05-26 17:33:19');
INSERT INTO `access_log` VALUES (9988, 'a8b7dec4-463e-4c4e-953e-ba442e9a8f97', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:21', 1095, 0, '', '2019-05-26 17:33:22');
INSERT INTO `access_log` VALUES (9989, '2a019d06-c3f9-48d6-9113-31fb11b7102c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:21', 1096, 0, '', '2019-05-26 17:33:22');
INSERT INTO `access_log` VALUES (9990, '1bf35123-e5c4-4ecd-bd2a-03f47d770784', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:21', 1096, 0, '', '2019-05-26 17:33:22');
INSERT INTO `access_log` VALUES (9991, '0b257c17-9f02-417d-91fc-498580e5e2bf', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:21', 1060, 0, '', '2019-05-26 17:33:22');
INSERT INTO `access_log` VALUES (9992, '2f4ce4dd-0c2d-4d90-ac0c-d0b16ad5ff9e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:24', 136, 0, '', '2019-05-26 17:33:24');
INSERT INTO `access_log` VALUES (9993, '6688291f-5aa9-49b2-a9c5-cace9aafffb1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:24', 145, 0, '', '2019-05-26 17:33:24');
INSERT INTO `access_log` VALUES (9994, '928e4952-2d51-41c5-b038-b12f161a7b28', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:24', 141, 0, '', '2019-05-26 17:33:24');
INSERT INTO `access_log` VALUES (9995, '15041c20-6531-4918-a17b-db01f129a4ca', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:33:24', 180, 0, '', '2019-05-26 17:33:25');
INSERT INTO `access_log` VALUES (9996, 'a0418232-fdf1-49bd-a071-53c4f854544f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=MM&platform=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:34:12', 418, 0, '', '2019-05-26 17:34:12');
INSERT INTO `access_log` VALUES (9997, 'b07bc36f-8ce6-46fb-b508-ce4b342e24c8', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:34:12', 175, 0, '', '2019-05-26 17:34:12');
INSERT INTO `access_log` VALUES (9998, '83e40162-057f-4a16-acc0-30efe29899ee', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:36:09', 168, 0, '', '2019-05-26 17:36:09');
INSERT INTO `access_log` VALUES (9999, 'b469c79f-3d35-4a1a-86c6-47a91b427794', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:36:09', 169, 0, '', '2019-05-26 17:36:09');
INSERT INTO `access_log` VALUES (10000, '03f751b1-ec92-44ea-8d98-a0fd7f136ffc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:36:09', 170, 0, '', '2019-05-26 17:36:09');
INSERT INTO `access_log` VALUES (10001, '672486ec-e4a9-4c59-965a-112f0547c77f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:36:09', 257, 0, '', '2019-05-26 17:36:09');
INSERT INTO `access_log` VALUES (10002, 'e5058426-8049-4c36-b992-ffe9a959bbe1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:36:12', 135, 0, '', '2019-05-26 17:36:12');
INSERT INTO `access_log` VALUES (10003, 'a65f1ada-9a4e-46d7-9d40-c03cd9e31c77', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:36:12', 137, 0, '', '2019-05-26 17:36:12');
INSERT INTO `access_log` VALUES (10004, '9f8d0dd1-af0a-413d-88b2-13323690da62', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:36:12', 137, 0, '', '2019-05-26 17:36:12');
INSERT INTO `access_log` VALUES (10005, '6a65f6bb-d991-4b91-b2b5-c2bd2017afeb', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:36:12', 172, 0, '', '2019-05-26 17:36:12');
INSERT INTO `access_log` VALUES (10006, 'e027e7c3-d29c-4ecd-8bbb-9e258d9dd273', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:36:19', 138, 0, '', '2019-05-26 17:36:19');
INSERT INTO `access_log` VALUES (10007, 'f8e1e6ba-c6b8-4034-8b9a-9b69cbc689d8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:36:19', 141, 0, '', '2019-05-26 17:36:19');
INSERT INTO `access_log` VALUES (10008, 'ccaf24b5-4262-4071-afc8-e6158a4c2224', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:36:19', 141, 0, '', '2019-05-26 17:36:19');
INSERT INTO `access_log` VALUES (10009, '74a41c30-6405-474b-8648-ae6c340d6330', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:36:19', 175, 0, '', '2019-05-26 17:36:19');
INSERT INTO `access_log` VALUES (10010, '27a788e5-efbf-43b3-bfb5-f0b5238114cf', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=gg', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:36:25', 290, 2001001001, '参数缺失:Required Integer parameter \'platform\' is not present', '2019-05-26 17:36:25');
INSERT INTO `access_log` VALUES (10011, 'cb335464-1722-4230-888f-710df335a45b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:08', 138, 0, '', '2019-05-26 17:37:08');
INSERT INTO `access_log` VALUES (10012, '41706095-7045-4841-af8d-364448dced6d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:08', 138, 0, '', '2019-05-26 17:37:08');
INSERT INTO `access_log` VALUES (10013, '5228b245-bbb7-4ae4-a537-cfa42608d18f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:08', 139, 0, '', '2019-05-26 17:37:08');
INSERT INTO `access_log` VALUES (10014, '73ccc870-9503-41fd-bbce-daa0a5227264', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:08', 176, 0, '', '2019-05-26 17:37:08');
INSERT INTO `access_log` VALUES (10015, '415b49ed-cda9-4fdf-8e5d-1514b01bff42', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:16', 375, 0, '', '2019-05-26 17:37:16');
INSERT INTO `access_log` VALUES (10016, 'aee1e1a4-ace7-46c0-8573-4ba4b4dc8203', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:16', 371, 0, '', '2019-05-26 17:37:16');
INSERT INTO `access_log` VALUES (10017, 'a6d7354a-27c9-4b27-8c57-c182e6e4902d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:16', 367, 0, '', '2019-05-26 17:37:16');
INSERT INTO `access_log` VALUES (10018, '57804e3e-13b0-4aa3-afd0-9280064f0e02', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:16', 196, 0, '', '2019-05-26 17:37:16');
INSERT INTO `access_log` VALUES (10019, '4c48cfd5-c805-4c0c-ac4b-90d87d4ebca2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:22', 153, 0, '', '2019-05-26 17:37:22');
INSERT INTO `access_log` VALUES (10020, '7c44ebf6-ee40-4780-b1d2-8949d557e6d7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:22', 146, 0, '', '2019-05-26 17:37:22');
INSERT INTO `access_log` VALUES (10021, '187e8489-4ad6-4fc3-8d54-a1306d03538c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:22', 148, 0, '', '2019-05-26 17:37:22');
INSERT INTO `access_log` VALUES (10022, 'ad23df5f-46f2-4105-903b-f6370644b60f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:24', 180, 0, '', '2019-05-26 17:37:24');
INSERT INTO `access_log` VALUES (10023, '50d3332e-b1f7-49da-82d5-1186a5341f40', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:51', 139, 0, '', '2019-05-26 17:37:51');
INSERT INTO `access_log` VALUES (10024, '93ee03ca-4df0-44cd-931a-b6c888da7090', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:51', 143, 0, '', '2019-05-26 17:37:51');
INSERT INTO `access_log` VALUES (10025, 'eaf8b33a-8dff-4a75-82a6-2321c4fd7eff', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:51', 173, 0, '', '2019-05-26 17:37:51');
INSERT INTO `access_log` VALUES (10026, 'd64b5ea0-b5e1-43fb-9088-b74c20ac0375', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:51', 314, 2001001000, '服务端发生异常', '2019-05-26 17:37:51');
INSERT INTO `access_log` VALUES (10027, '9513f6b1-8532-47a7-9799-e80a62e3baf4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:52', 178, 0, '', '2019-05-26 17:37:53');
INSERT INTO `access_log` VALUES (10028, '780f6d30-4784-447d-8de5-8fcfdc224693', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:52', 180, 0, '', '2019-05-26 17:37:53');
INSERT INTO `access_log` VALUES (10029, 'fd716cee-a405-4984-81b6-f940d561ec3e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:52', 181, 0, '', '2019-05-26 17:37:53');
INSERT INTO `access_log` VALUES (10030, 'b5373f66-e661-46c7-92a5-f96f0389479f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:53', 171, 0, '', '2019-05-26 17:37:53');
INSERT INTO `access_log` VALUES (10031, '451b49bf-7ddf-429e-a389-1b5cdaa308c5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:08', 140, 0, '', '2019-05-26 17:38:08');
INSERT INTO `access_log` VALUES (10032, 'ca313488-0177-4c61-b1fb-837a68640b23', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:08', 141, 0, '', '2019-05-26 17:38:08');
INSERT INTO `access_log` VALUES (10033, 'b3fef006-ce35-41b4-b7e1-7ae4a9ed0b3e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:08', 145, 0, '', '2019-05-26 17:38:08');
INSERT INTO `access_log` VALUES (10034, 'a3fc2da2-e312-4ca8-a111-0394a68e1924', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:08', 176, 0, '', '2019-05-26 17:38:09');
INSERT INTO `access_log` VALUES (10035, 'c87fedc9-4b2e-45ae-b1e9-94635cab5492', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:16', 149, 0, '', '2019-05-26 17:38:16');
INSERT INTO `access_log` VALUES (10036, '72d03ef7-941f-44b8-86b0-6add2a4e94c5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:16', 147, 0, '', '2019-05-26 17:38:17');
INSERT INTO `access_log` VALUES (10037, '6045a0f9-23ba-4b33-b047-45000e11bc1d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:16', 147, 0, '', '2019-05-26 17:38:17');
INSERT INTO `access_log` VALUES (10038, '790fe53a-aedb-4312-88ed-be3767845b10', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:17', 180, 0, '', '2019-05-26 17:38:17');
INSERT INTO `access_log` VALUES (10039, '154e07c1-a9e8-47fc-9b9a-77e31abae423', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:34', 139, 0, '', '2019-05-26 17:38:34');
INSERT INTO `access_log` VALUES (10040, '4a8f4f6f-cc14-421f-a277-d6a7a6dfcdaf', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:34', 137, 0, '', '2019-05-26 17:38:34');
INSERT INTO `access_log` VALUES (10041, '39027d18-aa73-450f-953a-adbf3b16791b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:34', 141, 0, '', '2019-05-26 17:38:34');
INSERT INTO `access_log` VALUES (10042, '1fff986e-8bda-4aae-91f2-82b79d809f9b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:34', 173, 0, '', '2019-05-26 17:38:34');
INSERT INTO `access_log` VALUES (10043, '7ef7f272-0a43-4dc8-9f55-0f61c7ffc0d9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:36', 145, 0, '', '2019-05-26 17:38:36');
INSERT INTO `access_log` VALUES (10044, '113a8fa3-8c68-4949-a88f-51bcdd417f20', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:36', 138, 0, '', '2019-05-26 17:38:36');
INSERT INTO `access_log` VALUES (10045, '7dce8dd2-c44e-4a6e-a511-eb6f6310184f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:36', 252, 0, '', '2019-05-26 17:38:36');
INSERT INTO `access_log` VALUES (10046, '4a465609-461d-4efc-a94d-dfcf9c168c16', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:36', 178, 0, '', '2019-05-26 17:38:36');
INSERT INTO `access_log` VALUES (10047, 'c80bdcc4-1882-4635-9c25-511a1e2ec601', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:58', 146, 0, '', '2019-05-26 17:38:58');
INSERT INTO `access_log` VALUES (10048, '19bd838a-4d4c-44b6-81cc-aa806752ce2a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:58', 146, 0, '', '2019-05-26 17:38:58');
INSERT INTO `access_log` VALUES (10049, 'c57b96ea-cdda-45cb-a17b-200175cab600', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:58', 139, 0, '', '2019-05-26 17:38:58');
INSERT INTO `access_log` VALUES (10050, '51b5ab52-3038-43d7-b618-a98cf43881f8', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:38:58', 175, 0, '', '2019-05-26 17:38:58');
INSERT INTO `access_log` VALUES (10051, 'c8d32503-faad-44d0-8be2-d129d4e59fdc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:30', 138, 0, '', '2019-05-26 17:39:30');
INSERT INTO `access_log` VALUES (10052, '55695eb1-13c3-4fb3-b859-ff57c65b4a66', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:30', 140, 0, '', '2019-05-26 17:39:30');
INSERT INTO `access_log` VALUES (10053, 'ced53f22-6d12-4308-856c-055c1ec50f31', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:30', 142, 0, '', '2019-05-26 17:39:30');
INSERT INTO `access_log` VALUES (10054, 'fd32de2f-15da-45b7-90de-0b1cac3cbe9f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:30', 174, 0, '', '2019-05-26 17:39:30');
INSERT INTO `access_log` VALUES (10055, '7d986d30-2f2f-461e-ac30-47553feb32e9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:31', 142, 0, '', '2019-05-26 17:39:31');
INSERT INTO `access_log` VALUES (10056, 'e71c5e3b-9944-4580-bbe5-b27fa5dde5d1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:31', 142, 0, '', '2019-05-26 17:39:31');
INSERT INTO `access_log` VALUES (10057, 'a7b6aace-6552-4b38-8352-05fbb0382a85', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:31', 137, 0, '', '2019-05-26 17:39:31');
INSERT INTO `access_log` VALUES (10058, '41200fca-2cdb-43be-9730-41c98a0643fb', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:31', 172, 0, '', '2019-05-26 17:39:32');
INSERT INTO `access_log` VALUES (10059, '22d3b35b-5215-4a2d-ac04-a27373504829', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:36', 475, 0, '', '2019-05-26 17:39:37');
INSERT INTO `access_log` VALUES (10060, 'de9d489c-9957-4638-8470-c0171a86617b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:36', 474, 0, '', '2019-05-26 17:39:37');
INSERT INTO `access_log` VALUES (10061, 'd052fefe-8020-413d-8131-0d556421a641', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:37', 429, 0, '', '2019-05-26 17:39:37');
INSERT INTO `access_log` VALUES (10062, 'cc8be46a-97a5-4432-b697-df79d0eee44f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:36', 564, 0, '', '2019-05-26 17:39:37');
INSERT INTO `access_log` VALUES (10063, '0cef2d2c-48f9-4b85-9ad1-42b46f5bd4d6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:41', 141, 0, '', '2019-05-26 17:39:41');
INSERT INTO `access_log` VALUES (10064, 'c3cc7ef2-d7b2-40cb-9dd7-6b600253707f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:41', 146, 0, '', '2019-05-26 17:39:41');
INSERT INTO `access_log` VALUES (10065, '1ed607cb-0ed9-4089-97f1-7abe5f1ac1c8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:41', 147, 0, '', '2019-05-26 17:39:41');
INSERT INTO `access_log` VALUES (10066, '9dfc1f5d-d964-491e-b0aa-2c1e249cdb1a', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:41', 177, 0, '', '2019-05-26 17:39:41');
INSERT INTO `access_log` VALUES (10067, 'd5b1181e-b181-4ca4-8f47-86143506e4bc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:48', 189, 0, '', '2019-05-26 17:39:48');
INSERT INTO `access_log` VALUES (10068, '46b21a3f-e411-4ab2-a380-3795b7963c8e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:48', 198, 0, '', '2019-05-26 17:39:48');
INSERT INTO `access_log` VALUES (10069, '4e8a3db8-c460-44e4-af43-817d464fcb2b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:48', 185, 0, '', '2019-05-26 17:39:48');
INSERT INTO `access_log` VALUES (10070, '1de888d3-c85f-44dd-a6df-463e93ea797f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:48', 316, 0, '', '2019-05-26 17:39:48');
INSERT INTO `access_log` VALUES (10071, '9d9f0bee-b488-4afc-8fdd-10783bceeddd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:51', 139, 0, '', '2019-05-26 17:39:51');
INSERT INTO `access_log` VALUES (10072, 'b6241da7-5a65-40a9-8c13-dbb62713ca24', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:51', 137, 0, '', '2019-05-26 17:39:51');
INSERT INTO `access_log` VALUES (10073, '2f2c371e-d846-42eb-9dc7-9c9a5a5ee141', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:51', 142, 0, '', '2019-05-26 17:39:51');
INSERT INTO `access_log` VALUES (10074, '01d86be0-0cdd-48d7-b992-c28e4db7168e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:39:51', 178, 0, '', '2019-05-26 17:39:51');
INSERT INTO `access_log` VALUES (10075, '9cde2b31-000d-48b9-b437-42f7a33e5d65', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:27', 578, 0, '', '2019-05-26 17:43:27');
INSERT INTO `access_log` VALUES (10076, '487cdb39-7b7c-4b41-af2e-5fbbcd0a18f2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:27', 579, 0, '', '2019-05-26 17:43:27');
INSERT INTO `access_log` VALUES (10077, 'a86aa8ec-e4f3-4751-9cde-5e5be71c7264', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:27', 464, 0, '', '2019-05-26 17:43:27');
INSERT INTO `access_log` VALUES (10078, 'da6597d2-6683-4bc0-ba4d-7591f6f7d21d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:27', 379, 0, '', '2019-05-26 17:43:27');
INSERT INTO `access_log` VALUES (10079, 'c32656f8-27cb-4f5b-816e-7ea82636cb5b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:27', 613, 0, '', '2019-05-26 17:43:27');
INSERT INTO `access_log` VALUES (10080, '51ad63bd-7819-45be-b78f-6f23e21dff99', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:27', 494, 0, '', '2019-05-26 17:43:27');
INSERT INTO `access_log` VALUES (10081, 'f4fbbb2c-16c7-4d6a-a0c6-42be4b2b90f6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:28', 244, 0, '', '2019-05-26 17:43:28');
INSERT INTO `access_log` VALUES (10082, '10766fb2-b128-4758-928a-94689dcd359d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:28', 242, 0, '', '2019-05-26 17:43:28');
INSERT INTO `access_log` VALUES (10083, 'b81be75f-bbac-4ce9-ac51-a1b7f633a4e5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:28', 239, 0, '', '2019-05-26 17:43:28');
INSERT INTO `access_log` VALUES (10084, '02768dd5-19df-49e5-be4d-cb88e1573fec', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:28', 169, 0, '', '2019-05-26 17:43:28');
INSERT INTO `access_log` VALUES (10085, '13200855-e6a9-44e5-9dcc-bd42d8da67cc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:30', 135, 0, '', '2019-05-26 17:43:31');
INSERT INTO `access_log` VALUES (10086, '55319953-7793-4d9d-b83c-3d263a62bf6b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:30', 135, 0, '', '2019-05-26 17:43:31');
INSERT INTO `access_log` VALUES (10087, '6b36ad65-aff4-4ce2-b4fe-edcc9722eb63', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:30', 137, 0, '', '2019-05-26 17:43:31');
INSERT INTO `access_log` VALUES (10088, 'ae25a2d3-a40f-4890-8dfe-96079bc444c0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:31', 169, 0, '', '2019-05-26 17:43:31');
INSERT INTO `access_log` VALUES (10089, '979d0e21-6701-4321-adcc-a626327e6378', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:32', 145, 0, '', '2019-05-26 17:43:32');
INSERT INTO `access_log` VALUES (10090, 'c46fc50e-ed7b-409c-b170-7bab03482c67', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:32', 142, 0, '', '2019-05-26 17:43:32');
INSERT INTO `access_log` VALUES (10091, 'b7d9cdc7-2da0-4906-98d5-56e4e48943f2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:32', 135, 0, '', '2019-05-26 17:43:32');
INSERT INTO `access_log` VALUES (10092, '394ef47c-1109-4ad6-bfea-a4d7d73e6ac4', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:32', 175, 0, '', '2019-05-26 17:43:32');
INSERT INTO `access_log` VALUES (10093, '2cce66dd-82e3-4b28-966b-7442b7873841', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:41', 137, 0, '', '2019-05-26 17:43:41');
INSERT INTO `access_log` VALUES (10094, '26973ac7-63e0-426f-a034-1aa733f7e910', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:41', 142, 0, '', '2019-05-26 17:43:41');
INSERT INTO `access_log` VALUES (10095, 'f5d445ad-abcf-4c5b-9bea-c1ad5193300d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:41', 143, 0, '', '2019-05-26 17:43:41');
INSERT INTO `access_log` VALUES (10096, '3a0b640f-0531-49a5-bcd0-6bca0faee144', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:43:41', 174, 0, '', '2019-05-26 17:43:41');
INSERT INTO `access_log` VALUES (10097, '4297b45c-ce16-455d-bec3-2582dc65be67', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:44:35', 138, 0, '', '2019-05-26 17:44:35');
INSERT INTO `access_log` VALUES (10098, 'fc95a5a0-d560-461c-a812-7ec88c29e9d4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:44:35', 135, 0, '', '2019-05-26 17:44:35');
INSERT INTO `access_log` VALUES (10099, '987c8346-7b28-44f3-8245-9b0baf78af0d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:44:35', 140, 0, '', '2019-05-26 17:44:35');
INSERT INTO `access_log` VALUES (10100, 'db2f3125-52a3-49e4-81bd-163167b14d77', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:44:35', 172, 0, '', '2019-05-26 17:44:35');
INSERT INTO `access_log` VALUES (10101, '5d3cdabc-225b-4c2a-bd26-1e5df68c9429', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:44:39', 138, 0, '', '2019-05-26 17:44:40');
INSERT INTO `access_log` VALUES (10102, '07aad836-4002-4db7-8bf8-815f752666c9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:44:39', 139, 0, '', '2019-05-26 17:44:40');
INSERT INTO `access_log` VALUES (10103, 'd9857520-8a7d-4de0-a6d6-801f72c7449b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:44:39', 142, 0, '', '2019-05-26 17:44:40');
INSERT INTO `access_log` VALUES (10104, '9a0d8cc3-0f90-4954-86ce-f9f463be84c7', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:44:40', 248, 0, '', '2019-05-26 17:44:40');
INSERT INTO `access_log` VALUES (10105, '90f11567-036f-4b39-8798-abb6d482a458', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:46:46', 172, 0, '', '2019-05-26 17:46:46');
INSERT INTO `access_log` VALUES (10106, 'e1a52124-3645-4f13-b3fb-a890354fec1b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:46:46', 174, 0, '', '2019-05-26 17:46:46');
INSERT INTO `access_log` VALUES (10107, '0ae2038a-9249-45b0-9a99-fec011b5430b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:46:46', 176, 0, '', '2019-05-26 17:46:46');
INSERT INTO `access_log` VALUES (10108, 'f830e148-7d19-4caf-a5c4-5e9f82afb7c2', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:46:47', 184, 0, '', '2019-05-26 17:46:47');
INSERT INTO `access_log` VALUES (10109, 'e5f859ca-fb9e-455c-9ee1-deb0980bdb80', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:46:47', 143, 0, '', '2019-05-26 17:46:48');
INSERT INTO `access_log` VALUES (10110, '2cf6b98f-7be8-462b-a751-9a7fbb4557ad', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:46:47', 141, 0, '', '2019-05-26 17:46:48');
INSERT INTO `access_log` VALUES (10111, '2120da0d-e817-470b-9068-08092773377a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:46:47', 173, 0, '', '2019-05-26 17:46:48');
INSERT INTO `access_log` VALUES (10112, '5e2e9716-8093-4d73-8b8a-5efb0b81e7b9', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:46:48', 179, 0, '', '2019-05-26 17:46:48');
INSERT INTO `access_log` VALUES (10113, '1e64cdc6-0480-4164-820a-c362fc4ba049', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:27', 139, 0, '', '2019-05-26 17:47:27');
INSERT INTO `access_log` VALUES (10114, '42632273-82f9-4f6c-82f8-6f467e5d0835', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:27', 137, 0, '', '2019-05-26 17:47:27');
INSERT INTO `access_log` VALUES (10115, 'b7ca6f03-653e-4d67-960c-07efd55c6a2e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:27', 135, 0, '', '2019-05-26 17:47:27');
INSERT INTO `access_log` VALUES (10116, '26f97ab7-16cd-4b3f-aded-313542a37356', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:27', 173, 0, '', '2019-05-26 17:47:27');
INSERT INTO `access_log` VALUES (10117, 'f0764580-02bf-4e9a-b73c-c2384d0a9b58', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:38', 137, 0, '', '2019-05-26 17:47:38');
INSERT INTO `access_log` VALUES (10118, 'b16003aa-6221-416b-b870-371957f2b757', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:38', 137, 0, '', '2019-05-26 17:47:38');
INSERT INTO `access_log` VALUES (10119, '05dbc642-3691-4c51-bda7-ea0ad8baa23a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:38', 138, 0, '', '2019-05-26 17:47:38');
INSERT INTO `access_log` VALUES (10120, '2dca1f1d-869a-4504-aa3f-b1f5feada450', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:38', 170, 0, '', '2019-05-26 17:47:38');
INSERT INTO `access_log` VALUES (10121, 'c170cb32-480e-46bb-8810-e358701a9161', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:40', 315, 0, '', '2019-05-26 17:47:41');
INSERT INTO `access_log` VALUES (10122, '3b56bf98-d48e-471d-bee5-bb0c7b591d25', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:40', 313, 0, '', '2019-05-26 17:47:41');
INSERT INTO `access_log` VALUES (10123, '06592e5d-8f7d-4484-a5ed-49c133ec3c1d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:40', 315, 0, '', '2019-05-26 17:47:41');
INSERT INTO `access_log` VALUES (10124, 'd378a13a-7217-4e85-bb4d-ea2b398ba13c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:40', 280, 0, '', '2019-05-26 17:47:41');
INSERT INTO `access_log` VALUES (10125, '5f25636f-376f-42f6-83c1-a5ddf42ff0ac', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:42', 136, 0, '', '2019-05-26 17:47:43');
INSERT INTO `access_log` VALUES (10126, 'ee771ff3-0e75-4145-b2da-b72d23afd1ed', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:42', 134, 0, '', '2019-05-26 17:47:43');
INSERT INTO `access_log` VALUES (10127, '37ee5d9b-ed06-4663-9800-6434f5626d0b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:42', 140, 0, '', '2019-05-26 17:47:43');
INSERT INTO `access_log` VALUES (10128, '12c273d6-5ba1-45ba-90c2-793667f70f0e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:43', 176, 0, '', '2019-05-26 17:47:43');
INSERT INTO `access_log` VALUES (10129, '8309110e-4bde-49e2-a9d5-c3c348b05ed3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:57', 136, 0, '', '2019-05-26 17:47:57');
INSERT INTO `access_log` VALUES (10130, 'd36e2752-0a9b-4864-a1cd-da524558becd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:57', 137, 0, '', '2019-05-26 17:47:57');
INSERT INTO `access_log` VALUES (10131, 'e97be26c-20fd-4670-ace7-8d9f8423e671', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:57', 135, 0, '', '2019-05-26 17:47:57');
INSERT INTO `access_log` VALUES (10132, 'fd5f9fb2-316b-4bcc-8304-8408118d674b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:57', 170, 0, '', '2019-05-26 17:47:57');
INSERT INTO `access_log` VALUES (10133, '6b6f939d-2eb1-42c8-8ca2-8a9650146c37', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:59', 136, 0, '', '2019-05-26 17:47:59');
INSERT INTO `access_log` VALUES (10134, '785e8328-1809-4982-ac6c-292f1c8f11cd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:59', 138, 0, '', '2019-05-26 17:47:59');
INSERT INTO `access_log` VALUES (10135, '40fdebc1-4259-4144-8e60-21def90fefec', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:59', 137, 0, '', '2019-05-26 17:47:59');
INSERT INTO `access_log` VALUES (10136, '637d1ce2-aa74-44bf-ab23-df9c1d3ca311', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:47:59', 170, 0, '', '2019-05-26 17:47:59');
INSERT INTO `access_log` VALUES (10137, 'ed8e6de7-7c65-4033-98a5-b043467486bc', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=gg&platform=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:48:05', 391, 0, '', '2019-05-26 17:48:05');
INSERT INTO `access_log` VALUES (10138, '8f074336-7a04-4433-a4da-6b8d61296b4a', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:48:05', 170, 0, '', '2019-05-26 17:48:05');
INSERT INTO `access_log` VALUES (10139, 'e1765469-09b3-4717-be9d-dbdae2775ab2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:50:40', 172, 0, '', '2019-05-26 17:50:40');
INSERT INTO `access_log` VALUES (10140, '073b239c-da93-45f9-893a-8e07bc0973a8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:50:40', 175, 0, '', '2019-05-26 17:50:40');
INSERT INTO `access_log` VALUES (10141, '9c8aadf7-2461-41fe-b213-9e8f7993e86d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:50:40', 173, 0, '', '2019-05-26 17:50:40');
INSERT INTO `access_log` VALUES (10142, '49509b2f-a02d-4cfc-9bf1-07b9c8b72840', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:50:40', 206, 0, '', '2019-05-26 17:50:41');
INSERT INTO `access_log` VALUES (10143, 'ca53d5c2-580b-4198-b6c3-c8873c2ad617', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:50:59', 142, 0, '', '2019-05-26 17:50:59');
INSERT INTO `access_log` VALUES (10144, 'b5b8e8c4-5d34-4642-88aa-c2f28b2ac753', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:50:59', 140, 0, '', '2019-05-26 17:50:59');
INSERT INTO `access_log` VALUES (10145, '94d9639b-f3b4-4e45-8483-00fb2c298718', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:50:59', 143, 0, '', '2019-05-26 17:50:59');
INSERT INTO `access_log` VALUES (10146, '5bf0b94c-5cb4-4a67-9bd2-b681fb53fc04', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:50:59', 177, 0, '', '2019-05-26 17:50:59');
INSERT INTO `access_log` VALUES (10147, 'c4d04e76-4710-4db3-b79c-a72cda604b44', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:05', 138, 0, '', '2019-05-26 17:51:05');
INSERT INTO `access_log` VALUES (10148, 'dc08102f-3404-4a0f-a06c-d7a53389834f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:05', 139, 0, '', '2019-05-26 17:51:05');
INSERT INTO `access_log` VALUES (10149, '21699845-5a4e-474f-a6c0-9a006330c39b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:05', 140, 0, '', '2019-05-26 17:51:05');
INSERT INTO `access_log` VALUES (10150, 'ba80625d-2fa5-4932-a48e-0be01b881f98', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:05', 172, 0, '', '2019-05-26 17:51:05');
INSERT INTO `access_log` VALUES (10151, 'ddbdad85-fd66-439a-9d48-6d5c7f9dabc9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:20', 136, 0, '', '2019-05-26 17:51:21');
INSERT INTO `access_log` VALUES (10152, 'bcd5e34c-f764-4f0f-83d7-f47d5fc3b339', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:20', 139, 0, '', '2019-05-26 17:51:21');
INSERT INTO `access_log` VALUES (10153, 'ae57f9b0-1f57-4797-a5d6-ecc3c9c7f846', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:20', 140, 0, '', '2019-05-26 17:51:21');
INSERT INTO `access_log` VALUES (10154, '58a8e419-8d85-443a-8f95-8a5679094111', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:21', 172, 0, '', '2019-05-26 17:51:21');
INSERT INTO `access_log` VALUES (10155, '8244d4d5-fc7d-4e70-9f79-c542c7bf1a5d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:29', 135, 0, '', '2019-05-26 17:51:29');
INSERT INTO `access_log` VALUES (10156, 'bb535b42-eb19-427b-bfba-2be3e91970be', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:29', 135, 0, '', '2019-05-26 17:51:29');
INSERT INTO `access_log` VALUES (10157, '55fc038f-1de6-457d-9598-ad096bb2dfc1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:29', 137, 0, '', '2019-05-26 17:51:29');
INSERT INTO `access_log` VALUES (10158, '5919dc59-80d3-423c-a858-bf5e77c5626b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:29', 168, 0, '', '2019-05-26 17:51:29');
INSERT INTO `access_log` VALUES (10159, 'e590078d-03ba-4147-8a4f-71159ba881d8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:35', 143, 0, '', '2019-05-26 17:51:35');
INSERT INTO `access_log` VALUES (10160, 'e12d0f7e-4e37-49ae-9d66-af46002a91bb', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:35', 135, 0, '', '2019-05-26 17:51:35');
INSERT INTO `access_log` VALUES (10161, 'c5424742-4435-4d4d-9a5e-1466af4be0a4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:35', 139, 0, '', '2019-05-26 17:51:35');
INSERT INTO `access_log` VALUES (10162, 'c800871e-3dab-41a7-b505-dbd48c073adc', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:35', 174, 0, '', '2019-05-26 17:51:35');
INSERT INTO `access_log` VALUES (10163, '2cf01f3a-d1fa-41bc-b63e-0ecb34a707fd', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=PP&platform=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:45', 1282, 0, '', '2019-05-26 17:51:46');
INSERT INTO `access_log` VALUES (10164, 'df421210-6f17-427a-813e-dc5efe6f5992', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:46', 172, 0, '', '2019-05-26 17:51:46');
INSERT INTO `access_log` VALUES (10165, 'c6fd9bb1-d66b-4722-a0de-5a89dc3c9d2f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=13', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:49', 259, 0, '', '2019-05-26 17:51:50');
INSERT INTO `access_log` VALUES (10166, '28b7d4c4-cb13-46a0-bc5f-3f1ee6efe06e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:53', 139, 0, '', '2019-05-26 17:51:53');
INSERT INTO `access_log` VALUES (10167, '4da697ce-4044-460f-85ec-67fe62c8b8f8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:53', 139, 0, '', '2019-05-26 17:51:53');
INSERT INTO `access_log` VALUES (10168, '7dd74ef9-98bc-4f79-88f4-9648c7584c5e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:53', 138, 0, '', '2019-05-26 17:51:53');
INSERT INTO `access_log` VALUES (10169, '5c252b8c-8164-4dbf-91a1-7fa95024a65c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:53', 167, 0, '', '2019-05-26 17:51:53');
INSERT INTO `access_log` VALUES (10170, '8b4a885a-f490-4293-bdc3-65224b5cbff9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:58', 135, 0, '', '2019-05-26 17:51:58');
INSERT INTO `access_log` VALUES (10171, '12d4cdc7-7ae9-4ad9-b487-baa286897247', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:58', 136, 0, '', '2019-05-26 17:51:58');
INSERT INTO `access_log` VALUES (10172, '3c4b254f-d5ad-46f9-b739-81d7f5fea2d6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:58', 135, 0, '', '2019-05-26 17:51:58');
INSERT INTO `access_log` VALUES (10173, 'c8cd51df-975a-4274-b3d2-c2942cab00d6', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:51:58', 171, 0, '', '2019-05-26 17:51:59');
INSERT INTO `access_log` VALUES (10174, 'df89a464-a74b-4314-af96-78f2aa2cbb6f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:58:46', 1585, 0, '', '2019-05-26 17:58:48');
INSERT INTO `access_log` VALUES (10175, '45b7eb74-f2ec-4389-83fd-f5ac5b718fcd', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:58:47', 1536, 0, '', '2019-05-26 17:58:48');
INSERT INTO `access_log` VALUES (10176, '3d8c4a4f-c3ad-48d1-93d5-3a41d945f262', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:58:46', 2151, 0, '', '2019-05-26 17:58:49');
INSERT INTO `access_log` VALUES (10177, '3f8faa78-3df0-48dd-a142-5b33269901cf', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:58:46', 2150, 0, '', '2019-05-26 17:58:49');
INSERT INTO `access_log` VALUES (10178, 'bb053afc-e5a6-44b8-95a8-e04c1bc535fe', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=14', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:58:53', 275, 0, '', '2019-05-26 17:58:53');
INSERT INTO `access_log` VALUES (10179, '8845e848-07ea-465c-a2bf-ea24f079450b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:03', 174, 0, '', '2019-05-26 18:02:03');
INSERT INTO `access_log` VALUES (10180, '5094d530-e829-4b50-9c42-38a170006f44', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:03', 174, 0, '', '2019-05-26 18:02:03');
INSERT INTO `access_log` VALUES (10181, '4d27f472-3c97-453a-8ac2-56f027b6433d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:03', 176, 0, '', '2019-05-26 18:02:03');
INSERT INTO `access_log` VALUES (10182, 'd2161174-3ecb-4078-88d7-942805cb7a18', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:03', 205, 0, '', '2019-05-26 18:02:04');
INSERT INTO `access_log` VALUES (10183, 'ba842b5e-8a2c-4364-a6e0-dd4626555668', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:09', 144, 0, '', '2019-05-26 18:02:09');
INSERT INTO `access_log` VALUES (10184, '45ea7b9c-ca12-4bd4-8979-ec1822d73c30', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:09', 138, 0, '', '2019-05-26 18:02:09');
INSERT INTO `access_log` VALUES (10185, '31b4ee91-c8a8-4ed2-9db3-7d766e0fc435', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:09', 142, 0, '', '2019-05-26 18:02:09');
INSERT INTO `access_log` VALUES (10186, '703c057d-9db0-4315-8071-ef9351fa05ec', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:09', 180, 0, '', '2019-05-26 18:02:09');
INSERT INTO `access_log` VALUES (10187, '85b7aac4-8ec3-4a29-a838-b83ee420be33', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=12', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:12', 257, 0, '', '2019-05-26 18:02:12');
INSERT INTO `access_log` VALUES (10188, '8bbe6d85-e184-4c9a-916b-6079a5063d56', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:34', 141, 0, '', '2019-05-26 18:02:35');
INSERT INTO `access_log` VALUES (10189, 'c8cfbba2-1733-42aa-bb3c-4e6236d73980', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:34', 140, 0, '', '2019-05-26 18:02:35');
INSERT INTO `access_log` VALUES (10190, '92c5a4d6-e684-4aff-8276-ab57e0d04ad7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:34', 143, 0, '', '2019-05-26 18:02:35');
INSERT INTO `access_log` VALUES (10191, '16168077-d858-43ae-9d8f-f6d46ce8ff9c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:35', 177, 0, '', '2019-05-26 18:02:35');
INSERT INTO `access_log` VALUES (10192, '898c1a6f-75df-47b4-bf61-67c3f205daee', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=gg&platform=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:39', 745, 0, '', '2019-05-26 18:02:40');
INSERT INTO `access_log` VALUES (10193, 'c8610780-3389-4b20-821f-b3f829abe073', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:40', 174, 0, '', '2019-05-26 18:02:40');
INSERT INTO `access_log` VALUES (10194, 'da03ec67-0edb-4d4d-9c9d-252eefe0d259', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:43', 146, 0, '', '2019-05-26 18:02:43');
INSERT INTO `access_log` VALUES (10195, '27ed4923-bb02-40ab-944c-d80971bfec6b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:43', 143, 0, '', '2019-05-26 18:02:43');
INSERT INTO `access_log` VALUES (10196, '0e29e46d-a66a-484d-b086-633479974a86', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:43', 138, 0, '', '2019-05-26 18:02:43');
INSERT INTO `access_log` VALUES (10197, '2d35f537-404d-410e-9733-65239aa2c526', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:43', 186, 0, '', '2019-05-26 18:02:43');
INSERT INTO `access_log` VALUES (10198, '558020ea-93fa-457a-a196-2f51a883afd5', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=15', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:02:49', 406, 0, '', '2019-05-26 18:02:50');
INSERT INTO `access_log` VALUES (10199, '1cb9eccb-6147-4943-8d8e-a0acbd3e0c65', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:03:50', 139, 0, '', '2019-05-26 18:03:50');
INSERT INTO `access_log` VALUES (10200, 'dcd5ceaa-4eb5-4bc9-8dbc-0f03f3d535b5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:03:50', 174, 0, '', '2019-05-26 18:03:50');
INSERT INTO `access_log` VALUES (10201, 'ee45350f-e1f2-41c7-8c6a-22f7906212f3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:03:50', 178, 0, '', '2019-05-26 18:03:50');
INSERT INTO `access_log` VALUES (10202, '6d78416b-d71d-4eeb-b4a8-6d30f4f11398', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:03:50', 207, 0, '', '2019-05-26 18:03:50');
INSERT INTO `access_log` VALUES (10203, 'c646fc12-5648-410e-98d1-5069e5c34831', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:00', 140, 0, '', '2019-05-26 18:04:00');
INSERT INTO `access_log` VALUES (10204, '7af0c540-be15-42ab-8da1-273a8d9c4bba', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:00', 137, 0, '', '2019-05-26 18:04:00');
INSERT INTO `access_log` VALUES (10205, '5575b1ab-8b40-4edc-bad5-dab6f3ecaa9b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:00', 140, 0, '', '2019-05-26 18:04:00');
INSERT INTO `access_log` VALUES (10206, '3c3a3bdb-7975-48e8-a214-13031b7eb7ca', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:00', 177, 0, '', '2019-05-26 18:04:00');
INSERT INTO `access_log` VALUES (10207, '604d3623-a8af-4ca1-a881-8be01ad61452', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:03', 142, 0, '', '2019-05-26 18:04:03');
INSERT INTO `access_log` VALUES (10208, '7e4c483b-ca9e-4de6-a1fe-0917bab01355', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:03', 143, 0, '', '2019-05-26 18:04:03');
INSERT INTO `access_log` VALUES (10209, '944429d5-5bea-4f45-a7ef-f91d9acb5b17', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:03', 144, 0, '', '2019-05-26 18:04:03');
INSERT INTO `access_log` VALUES (10210, '6a866c55-1562-44f0-9064-46cc20d15159', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:03', 175, 0, '', '2019-05-26 18:04:03');
INSERT INTO `access_log` VALUES (10211, '96355519-8bc6-427c-92aa-ca3b40922422', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:08', 140, 0, '', '2019-05-26 18:04:08');
INSERT INTO `access_log` VALUES (10212, '06e65dcc-6391-4c96-b8b1-83b3115a64e1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:08', 139, 0, '', '2019-05-26 18:04:08');
INSERT INTO `access_log` VALUES (10213, '3e789f9f-9799-44a3-893f-80e40b8ffb3e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:08', 138, 0, '', '2019-05-26 18:04:08');
INSERT INTO `access_log` VALUES (10214, '0fed23ed-866d-46bc-bf9f-66aa4fecc5f5', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:08', 173, 0, '', '2019-05-26 18:04:09');
INSERT INTO `access_log` VALUES (10215, 'db2bb723-d97b-4999-9423-669ef943e24d', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/add', 'sign=ga&platform=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:12', 409, 0, '', '2019-05-26 18:04:13');
INSERT INTO `access_log` VALUES (10216, 'ce8fceee-c78c-44ce-8427-506b1f12a469', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:13', 174, 0, '', '2019-05-26 18:04:13');
INSERT INTO `access_log` VALUES (10217, '0d8c5f0a-105f-4327-ab21-7ed357e5820c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:16', 141, 0, '', '2019-05-26 18:04:16');
INSERT INTO `access_log` VALUES (10218, 'edd7284c-7a2c-4a96-b4b5-c6b0f02defae', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:16', 146, 0, '', '2019-05-26 18:04:16');
INSERT INTO `access_log` VALUES (10219, '658137ad-7a31-458b-bdcf-3001294c2521', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:16', 141, 0, '', '2019-05-26 18:04:16');
INSERT INTO `access_log` VALUES (10220, '57ba020c-0486-43f8-a604-4066fe0b951c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:16', 186, 0, '', '2019-05-26 18:04:17');
INSERT INTO `access_log` VALUES (10221, 'a7b18f45-5bf3-4779-9041-d1cf9581bf27', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=16', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:04:23', 387, 0, '', '2019-05-26 18:04:23');
INSERT INTO `access_log` VALUES (10222, '8bf212de-c027-4079-a63b-c618f71f6559', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:05:00', 708, 0, '', '2019-05-26 18:05:01');
INSERT INTO `access_log` VALUES (10223, 'bdc6dd46-217a-435e-8aae-f44cb896da49', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:05:00', 706, 0, '', '2019-05-26 18:05:01');
INSERT INTO `access_log` VALUES (10224, 'ebf64e29-cf6d-45e4-9ecd-5b9ecf761897', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:05:00', 704, 0, '', '2019-05-26 18:05:01');
INSERT INTO `access_log` VALUES (10225, 'd947b307-edf6-4993-ba1d-0b1e8c94f611', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:05:00', 583, 0, '', '2019-05-26 18:05:01');
INSERT INTO `access_log` VALUES (10226, '5f600afb-2018-495c-b3de-b30e231192c8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:05:29', 147, 0, '', '2019-05-26 18:05:29');
INSERT INTO `access_log` VALUES (10227, '8245fea2-805c-410d-885c-7f79935188bc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:05:29', 142, 0, '', '2019-05-26 18:05:29');
INSERT INTO `access_log` VALUES (10228, 'b24a797f-c872-4280-b725-946c7bb1b1f5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:05:29', 145, 0, '', '2019-05-26 18:05:29');
INSERT INTO `access_log` VALUES (10229, 'e8c69262-0bf2-457e-a3f3-62fe063959f1', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:05:29', 177, 0, '', '2019-05-26 18:05:29');
INSERT INTO `access_log` VALUES (10230, '9dfe4c0a-698b-407a-8e88-c0ad511c1e48', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=14', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:05:33', 280, 0, '', '2019-05-26 18:05:33');
INSERT INTO `access_log` VALUES (10231, 'd7c3ab73-f49d-4688-89e8-e007124c69fb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:01', 391, 0, '', '2019-05-26 18:06:01');
INSERT INTO `access_log` VALUES (10232, '461afe8e-af70-427e-b0ed-7b29c04c4b46', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:01', 390, 0, '', '2019-05-26 18:06:01');
INSERT INTO `access_log` VALUES (10233, '06d4498c-4878-4dc9-ae5e-b2d63261f33f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:01', 390, 0, '', '2019-05-26 18:06:01');
INSERT INTO `access_log` VALUES (10234, '06055a6b-026d-47ae-b1b0-4ea454682a52', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:01', 269, 0, '', '2019-05-26 18:06:01');
INSERT INTO `access_log` VALUES (10235, 'ac0b82b2-07e3-4413-b506-f93992901c32', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=12', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:04', 282, 0, '', '2019-05-26 18:06:04');
INSERT INTO `access_log` VALUES (10236, 'cdc7d982-2715-4fdb-868f-a9416f1c2b75', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=16', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:11', 281, 0, '', '2019-05-26 18:06:11');
INSERT INTO `access_log` VALUES (10237, 'a8cae43f-8d69-4aa0-9ff9-712aa86e4bbe', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:29', 148, 0, '', '2019-05-26 18:06:29');
INSERT INTO `access_log` VALUES (10238, 'e3675538-952d-4a78-b6b4-61ab980d2e59', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:29', 144, 0, '', '2019-05-26 18:06:29');
INSERT INTO `access_log` VALUES (10239, 'ed937d40-c55c-4ec7-aa19-08983521fae4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:29', 152, 0, '', '2019-05-26 18:06:29');
INSERT INTO `access_log` VALUES (10240, 'a10900a0-c47d-4c64-9877-55cd4605969b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:29', 179, 0, '', '2019-05-26 18:06:29');
INSERT INTO `access_log` VALUES (10241, '699c4573-928c-4e82-98ea-fd2be06f2143', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=15', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:33', 304, 0, '', '2019-05-26 18:06:34');
INSERT INTO `access_log` VALUES (10242, 'e2ef7768-9c55-44e8-82bd-a71a9f795aac', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:54', 137, 0, '', '2019-05-26 18:06:54');
INSERT INTO `access_log` VALUES (10243, '0bdb79f9-58fa-466a-966e-18931a63f833', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:54', 139, 0, '', '2019-05-26 18:06:54');
INSERT INTO `access_log` VALUES (10244, '4ceabd94-5d06-40b5-8529-99ca9afc03df', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:54', 138, 0, '', '2019-05-26 18:06:54');
INSERT INTO `access_log` VALUES (10245, '1929f6d1-645f-4311-b3f5-1b897170cc8e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:54', 177, 0, '', '2019-05-26 18:06:54');
INSERT INTO `access_log` VALUES (10246, '109f2f5a-7eaa-4772-ba9e-5360e0d55a52', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=9', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:06:57', 260, 0, '', '2019-05-26 18:06:57');
INSERT INTO `access_log` VALUES (10247, 'a62fcd23-9c5b-4bec-adba-942a246ef569', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:07:34', 39, 1002001012, '访问令牌已过期', '2019-05-26 18:07:34');
INSERT INTO `access_log` VALUES (10248, '321da640-332d-4457-ab1d-f612193b5650', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:07:34', 34, 1002001012, '访问令牌已过期', '2019-05-26 18:07:34');
INSERT INTO `access_log` VALUES (10249, '0313f048-6678-4278-82fa-016cd667bbf6', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:07:34', 43, 1002001012, '访问令牌已过期', '2019-05-26 18:07:34');
INSERT INTO `access_log` VALUES (10250, '0db212fe-dbfc-4392-966a-8314c7a38717', 0, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:07:34', 36, 1002001012, '访问令牌已过期', '2019-05-26 18:07:34');
INSERT INTO `access_log` VALUES (10251, 'b583ab9b-6a4a-4b6c-958c-1d6c6ff7c496', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:07:37', 386, 0, '', '2019-05-26 18:07:37');
INSERT INTO `access_log` VALUES (10252, '400f7d8d-1a16-479c-be0e-c0ded185d977', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:07:37', 146, 0, '', '2019-05-26 18:07:38');
INSERT INTO `access_log` VALUES (10253, '5999aedf-43c8-46d6-bf63-8660ea7ee0fe', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:07:37', 146, 0, '', '2019-05-26 18:07:38');
INSERT INTO `access_log` VALUES (10254, '38172677-f956-4a02-8e71-0a15858a9dfc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:07:37', 143, 0, '', '2019-05-26 18:07:38');
INSERT INTO `access_log` VALUES (10255, '0f380629-1f1b-49b6-839c-91b76c5cf0a4', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:07:39', 181, 0, '', '2019-05-26 18:07:39');
INSERT INTO `access_log` VALUES (10256, '36e088e5-3ea6-4ff4-9ab3-f370d18889f5', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=7', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:07:42', 632, 0, '', '2019-05-26 18:07:43');
INSERT INTO `access_log` VALUES (10257, 'db02fda0-c110-4d9d-a57b-3b079a131d35', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/update', 'id=7&sign=22222&platform=1', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:05', 345, 0, '', '2019-05-26 18:08:05');
INSERT INTO `access_log` VALUES (10258, '7e38889d-5ee7-42bf-a6c6-8ffd6fc7f5e7', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:05', 176, 0, '', '2019-05-26 18:08:05');
INSERT INTO `access_log` VALUES (10259, '315efc3a-61ab-4474-9316-cb3e9e77f77b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/update', 'id=8&sign=123333&platform=2', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:10', 398, 0, '', '2019-05-26 18:08:11');
INSERT INTO `access_log` VALUES (10260, '3a2423f0-6b4c-4e19-acdf-e9fba1450ea9', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:11', 175, 0, '', '2019-05-26 18:08:11');
INSERT INTO `access_log` VALUES (10261, '000524a0-5376-425f-b659-4410f57d581f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/update', 'id=5&sign=123222&platform=2', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:15', 534, 0, '', '2019-05-26 18:08:16');
INSERT INTO `access_log` VALUES (10262, '1c18aa17-1f8a-43f1-873b-1de617d171ba', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:16', 173, 0, '', '2019-05-26 18:08:16');
INSERT INTO `access_log` VALUES (10263, 'c6c9bf0d-7da7-4c51-be7a-1d3f329770b6', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/update', 'id=5&sign=gggg&platform=2', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:23', 446, 0, '', '2019-05-26 18:08:24');
INSERT INTO `access_log` VALUES (10264, 'd4ec7e06-fd3e-407a-9fea-083c7481b8e3', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:24', 177, 0, '', '2019-05-26 18:08:24');
INSERT INTO `access_log` VALUES (10265, '93f0daa7-dd4c-41ba-9c74-3440816f1330', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:43', 202, 0, '', '2019-05-26 18:08:43');
INSERT INTO `access_log` VALUES (10266, '6fdf4360-09a0-4f18-824f-3854ad4ca894', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:43', 239, 0, '', '2019-05-26 18:08:43');
INSERT INTO `access_log` VALUES (10267, 'ea58c85e-f016-40cb-895d-8c23560300e2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:43', 237, 0, '', '2019-05-26 18:08:43');
INSERT INTO `access_log` VALUES (10268, 'f9131a49-1e66-4a20-84c7-b8f826123458', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:43', 211, 0, '', '2019-05-26 18:08:44');
INSERT INTO `access_log` VALUES (10269, '8462da0f-165f-4ff1-a139-ea8997f4fd7b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:45', 168, 0, '', '2019-05-26 18:08:46');
INSERT INTO `access_log` VALUES (10270, '3262c83b-35bf-4851-9a01-6967dd1cbeea', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:45', 171, 0, '', '2019-05-26 18:08:46');
INSERT INTO `access_log` VALUES (10271, 'da1a8eb6-5b0b-4195-961f-ce0a63037f01', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:45', 164, 0, '', '2019-05-26 18:08:46');
INSERT INTO `access_log` VALUES (10272, '66f43549-60a5-41c5-a62f-cad35c75b761', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:46', 175, 0, '', '2019-05-26 18:08:46');
INSERT INTO `access_log` VALUES (10273, '86ab0477-b65c-4ac2-ae49-5ae0ead92896', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/update', 'id=8&sign=123333&platform=1', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:50', 496, 0, '', '2019-05-26 18:08:51');
INSERT INTO `access_log` VALUES (10274, 'b6a94ef1-b3b9-460c-8fdc-cd356a9e771f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:51', 174, 0, '', '2019-05-26 18:08:51');
INSERT INTO `access_log` VALUES (10275, '29a75866-e1bd-471b-ae43-81d0a6850e56', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/update', 'id=5&sign=ggggff&platform=2', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:56', 405, 0, '', '2019-05-26 18:08:56');
INSERT INTO `access_log` VALUES (10276, 'a4f6e5ed-8837-423c-93ed-2462fb4280cd', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:08:56', 176, 0, '', '2019-05-26 18:08:57');
INSERT INTO `access_log` VALUES (10277, '6c2be4f3-0600-42ea-9a6e-6e84f15fc157', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=8', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:09:25', 402, 0, '', '2019-05-26 18:09:26');
INSERT INTO `access_log` VALUES (10278, 'c2bd6ef5-7fda-43b8-8dd3-535da79bbe52', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:09:39', 212, 0, '', '2019-05-26 18:09:40');
INSERT INTO `access_log` VALUES (10279, '32eed0c7-33aa-4184-9093-b2707cbc7f9c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:09:39', 216, 0, '', '2019-05-26 18:09:40');
INSERT INTO `access_log` VALUES (10280, '66015725-654e-43bb-ac07-f4eb71ed01d5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:09:39', 217, 0, '', '2019-05-26 18:09:40');
INSERT INTO `access_log` VALUES (10281, 'f8bd67c5-8af6-4e72-9d77-9ed43381e568', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:09:40', 177, 0, '', '2019-05-26 18:09:40');
INSERT INTO `access_log` VALUES (10282, '16e52dea-7f36-430d-93c3-050038ccd012', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:09:42', 144, 0, '', '2019-05-26 18:09:42');
INSERT INTO `access_log` VALUES (10283, '95a46ee8-3ce5-49ec-a38d-9c07421d0caf', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:09:42', 143, 0, '', '2019-05-26 18:09:42');
INSERT INTO `access_log` VALUES (10284, '0eb79d93-8ad2-4b74-846d-4d383a17b80d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:09:42', 141, 0, '', '2019-05-26 18:09:42');
INSERT INTO `access_log` VALUES (10285, '241ba850-2d31-433b-82d7-923e95785295', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:09:42', 176, 0, '', '2019-05-26 18:09:42');
INSERT INTO `access_log` VALUES (10286, '028889fb-89f1-4b26-8068-f237ec2a57f6', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=5', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:09:45', 283, 0, '', '2019-05-26 18:09:45');
INSERT INTO `access_log` VALUES (10287, '4a28fd83-35e2-4c40-8c28-d6a99c909423', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:10:12', 168, 0, '', '2019-05-26 18:10:12');
INSERT INTO `access_log` VALUES (10288, '24ab7d1a-8f45-4f89-8715-a1288e329bf3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:10:12', 161, 0, '', '2019-05-26 18:10:12');
INSERT INTO `access_log` VALUES (10289, '912d4b67-70ed-4351-9d97-631816f35d1d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:10:12', 165, 0, '', '2019-05-26 18:10:12');
INSERT INTO `access_log` VALUES (10290, '87b5fe26-8528-4dee-8a7e-a28eda022cd1', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:10:12', 191, 0, '', '2019-05-26 18:10:13');
INSERT INTO `access_log` VALUES (10291, '2d7eb611-a255-447b-b456-3c9387f836af', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:10:21', 149, 0, '', '2019-05-26 18:10:21');
INSERT INTO `access_log` VALUES (10292, 'ef841829-37a6-4fe7-bae3-1acb57770dff', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:10:21', 146, 0, '', '2019-05-26 18:10:21');
INSERT INTO `access_log` VALUES (10293, '063ba156-5ec7-4b77-9f55-b8d15821e88c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:10:21', 142, 0, '', '2019-05-26 18:10:21');
INSERT INTO `access_log` VALUES (10294, '7b333807-20e1-4f9f-91a7-93cbcd08f1c0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:10:21', 185, 0, '', '2019-05-26 18:10:21');
INSERT INTO `access_log` VALUES (10295, '8cb4c6d9-1cd5-4c84-9be8-ffc6a3088a54', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=13', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:10:25', 599, 0, '', '2019-05-26 18:10:26');
INSERT INTO `access_log` VALUES (10296, 'e6303d9a-710e-4fdd-afcd-833991f03916', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:10:26', 174, 0, '', '2019-05-26 18:10:26');
INSERT INTO `access_log` VALUES (10297, '169c954e-ef2f-4b4e-9684-501dedb11698', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:10:40', 889, 0, '', '2019-05-26 18:10:41');
INSERT INTO `access_log` VALUES (10298, 'a1e8f521-1896-4c33-9945-0087f178b997', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:10:40', 869, 0, '', '2019-05-26 18:10:41');
INSERT INTO `access_log` VALUES (10299, '6c792563-be4f-47da-8731-e441237333f9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:10:40', 873, 0, '', '2019-05-26 18:10:41');
INSERT INTO `access_log` VALUES (10300, '6388e57d-e73c-45d9-918e-1b7d63936bc0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:10:41', 637, 0, '', '2019-05-26 18:10:41');
INSERT INTO `access_log` VALUES (10301, '6292ac58-2122-454b-823d-f37ab67f18a1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:19', 147, 0, '', '2019-05-26 18:11:19');
INSERT INTO `access_log` VALUES (10302, '3b696c12-598d-4739-8ae4-664baa2655c5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:20', 151, 0, '', '2019-05-26 18:11:20');
INSERT INTO `access_log` VALUES (10303, '4f19e346-d0aa-49ba-8902-fba37bc69842', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:20', 151, 0, '', '2019-05-26 18:11:20');
INSERT INTO `access_log` VALUES (10304, 'dda63e23-1bcb-47cb-bda2-f7a64e7e0553', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:20', 181, 0, '', '2019-05-26 18:11:20');
INSERT INTO `access_log` VALUES (10305, 'fe46db94-8039-4ca7-b5af-8b09ba7cbdb4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:52', 140, 0, '', '2019-05-26 18:11:53');
INSERT INTO `access_log` VALUES (10306, 'fb50cdb2-f837-4f20-8f80-2a0d82e191d7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:52', 139, 0, '', '2019-05-26 18:11:53');
INSERT INTO `access_log` VALUES (10307, '41fccf6a-7e6b-48b2-9c3b-7dd082128763', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:52', 144, 0, '', '2019-05-26 18:11:53');
INSERT INTO `access_log` VALUES (10308, '62f400cb-7c6b-43a5-9f85-8481a8977ed8', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:53', 209, 0, '', '2019-05-26 18:11:53');
INSERT INTO `access_log` VALUES (10309, '7b6114df-4a20-4284-98ae-82ba5f03f72b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:55', 138, 0, '', '2019-05-26 18:11:55');
INSERT INTO `access_log` VALUES (10310, '4feb480b-3a0f-4a7f-9528-2de5e39d6bfc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:55', 139, 0, '', '2019-05-26 18:11:55');
INSERT INTO `access_log` VALUES (10311, '2e88377b-060d-49a3-9cdc-40f470016b93', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:55', 139, 0, '', '2019-05-26 18:11:55');
INSERT INTO `access_log` VALUES (10312, 'd73f7761-cf38-4c55-b7f8-4c3b1c35fe2f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:55', 175, 0, '', '2019-05-26 18:11:56');
INSERT INTO `access_log` VALUES (10313, 'dc624a1a-aee0-4074-b2d9-05ad7e0a9f0a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:58', 148, 0, '', '2019-05-26 18:11:58');
INSERT INTO `access_log` VALUES (10314, 'bf6f306c-f6dd-42cf-ab0a-61d2e6fc8c40', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:58', 142, 0, '', '2019-05-26 18:11:58');
INSERT INTO `access_log` VALUES (10315, '9c27a668-27c2-4177-9e07-96446803ad3c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:58', 142, 0, '', '2019-05-26 18:11:58');
INSERT INTO `access_log` VALUES (10316, '7e5976b4-2122-4776-ab9f-99e75ea7d465', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:11:58', 182, 0, '', '2019-05-26 18:11:58');
INSERT INTO `access_log` VALUES (10317, '3677bc95-2cff-4160-9148-8e7a0921c3fb', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:12:03', 225, 0, '', '2019-05-26 18:12:03');
INSERT INTO `access_log` VALUES (10318, '6243db90-2501-4ff6-b306-28ebb1651f19', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20&id=test', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:12:06', 178, 0, '', '2019-05-26 18:12:07');
INSERT INTO `access_log` VALUES (10319, '3e25dd23-6e5b-42bf-b171-9f17e56ac340', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20&sign=tt', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:12:12', 832, 0, '', '2019-05-26 18:12:12');
INSERT INTO `access_log` VALUES (10320, '50964e25-3691-47f4-827f-225f6387cd97', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20&id=11&sign=tt', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:12:20', 201, 0, '', '2019-05-26 18:12:20');
INSERT INTO `access_log` VALUES (10321, '09872c7a-d894-4845-92a5-122725afe5c2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:13:10', 142, 0, '', '2019-05-26 18:13:10');
INSERT INTO `access_log` VALUES (10322, '68975d17-6a93-4eb9-9212-1768f105b64b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:13:10', 175, 0, '', '2019-05-26 18:13:11');
INSERT INTO `access_log` VALUES (10323, '52c73b1d-3eeb-4a81-a754-ce6f5d9eef26', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:13:10', 177, 0, '', '2019-05-26 18:13:11');
INSERT INTO `access_log` VALUES (10324, 'a9e6c008-1925-43bc-8c4a-67dd99fce04e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:13:11', 214, 0, '', '2019-05-26 18:13:11');
INSERT INTO `access_log` VALUES (10325, '4ea1cec2-2332-4fe0-8bc8-75c85e188be0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20&id=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:13:13', 181, 0, '', '2019-05-26 18:13:13');
INSERT INTO `access_log` VALUES (10326, '0b06aac2-a2f1-46dd-bbb9-10d5a801fd3a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:14:20', 843, 0, '', '2019-05-26 18:14:20');
INSERT INTO `access_log` VALUES (10327, '9514b29c-07b1-465d-9d3a-553261da583d', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:14:20', 843, 0, '', '2019-05-26 18:14:20');
INSERT INTO `access_log` VALUES (10328, '04792d88-6340-4367-bb1f-c966a20f291d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:14:20', 844, 0, '', '2019-05-26 18:14:20');
INSERT INTO `access_log` VALUES (10329, 'f1216117-0d1a-41a5-a40d-23f8db124e9c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:14:20', 844, 0, '', '2019-05-26 18:14:21');
INSERT INTO `access_log` VALUES (10330, '69c7b8ba-52ac-4e67-b9b2-fb00143f48bd', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/deleted', 'id=10', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:14:26', 309, 0, '', '2019-05-26 18:14:26');
INSERT INTO `access_log` VALUES (10331, '41116db2-2e41-4104-87a6-10b484278867', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:14:26', 185, 0, '', '2019-05-26 18:14:27');
INSERT INTO `access_log` VALUES (10332, '114b84d5-a971-4e75-9d38-bd3a4e739a77', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/update', 'id=7&sign=tttt&platform=1', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:14:30', 430, 0, '', '2019-05-26 18:14:31');
INSERT INTO `access_log` VALUES (10333, '8141d0f2-1636-4a3e-877b-792135cbc9f3', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:14:31', 691, 0, '', '2019-05-26 18:14:32');
INSERT INTO `access_log` VALUES (10334, 'af6b1938-032e-426a-8d8b-5f97aca6367e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/update', 'id=6&sign=asdfasf&platform=1', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:14:40', 419, 0, '', '2019-05-26 18:14:41');
INSERT INTO `access_log` VALUES (10335, 'd80848e9-428e-4038-91bb-676ef2a3b784', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:14:41', 182, 0, '', '2019-05-26 18:14:41');
INSERT INTO `access_log` VALUES (10336, '998e07ca-9301-44ef-9ab9-c2a93669ca5f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20&id=9', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:14:51', 608, 0, '', '2019-05-26 18:14:51');
INSERT INTO `access_log` VALUES (10337, '2d6bf704-cfb8-4f63-8f3b-d57b31d7bf46', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:14:54', 188, 0, '', '2019-05-26 18:14:54');
INSERT INTO `access_log` VALUES (10338, 'c6855c0e-21c1-4269-a261-1e1202bf24c6', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20&sign=a', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:14:57', 184, 0, '', '2019-05-26 18:14:57');
INSERT INTO `access_log` VALUES (10339, '4b0817d4-2624-4996-9f04-ff3bad76da6e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20&sign=云', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:15:01', 187, 0, '', '2019-05-26 18:15:01');
INSERT INTO `access_log` VALUES (10340, 'd6a7b10e-dea1-48b4-9561-6cff1409c010', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:15:05', 185, 0, '', '2019-05-26 18:15:05');
INSERT INTO `access_log` VALUES (10341, '5ebcce1d-8c4d-4bc6-b6b7-bf282dc00121', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:15:25', 160, 0, '', '2019-05-26 18:15:25');
INSERT INTO `access_log` VALUES (10342, 'a731aef0-1887-4f63-aa2a-f220fd026eba', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:15:25', 179, 0, '', '2019-05-26 18:15:25');
INSERT INTO `access_log` VALUES (10343, 'f56390de-c095-452a-beae-effb71e4469b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:15:25', 185, 0, '', '2019-05-26 18:15:25');
INSERT INTO `access_log` VALUES (10344, 'cb005b99-bb1a-492b-a4e0-3cf4803a2e07', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:15:25', 225, 0, '', '2019-05-26 18:15:26');
INSERT INTO `access_log` VALUES (10345, 'f14c9084-28c4-45f9-bc25-c179e9ae4824', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=2&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:15:29', 179, 0, '', '2019-05-26 18:15:29');
INSERT INTO `access_log` VALUES (10346, '3946d0f3-7277-48ce-a6d1-25376027ea07', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:15:40', 172, 0, '', '2019-05-26 18:15:40');
INSERT INTO `access_log` VALUES (10347, 'f47e179a-8eec-495f-9eeb-f869d0bc6491', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:19:37', 174, 0, '', '2019-05-26 18:19:37');
INSERT INTO `access_log` VALUES (10348, '3d96e720-b68d-4bee-af0d-3c67964c1411', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:19:37', 181, 0, '', '2019-05-26 18:19:37');
INSERT INTO `access_log` VALUES (10349, '1088aafe-9855-4625-bcc1-c5efb016eb43', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:19:37', 181, 0, '', '2019-05-26 18:19:37');
INSERT INTO `access_log` VALUES (10350, '33459249-d8cf-4266-ad0f-ca7063794aa6', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:19:40', 182, 0, '', '2019-05-26 18:19:40');
INSERT INTO `access_log` VALUES (10351, 'd9c6991a-0924-44b8-9df0-de31c3800800', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:22:00', 715, 0, '', '2019-05-26 18:22:01');
INSERT INTO `access_log` VALUES (10352, '913e5ab2-fdfb-4c09-bc10-e07f555e2b20', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:22:00', 715, 0, '', '2019-05-26 18:22:01');
INSERT INTO `access_log` VALUES (10353, '3a7f4469-4b76-4071-9cd8-68329ff3c993', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:22:00', 714, 0, '', '2019-05-26 18:22:01');
INSERT INTO `access_log` VALUES (10354, '42f01027-3267-4e46-8e4a-d41b7ee85750', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:22:00', 1434, 0, '', '2019-05-26 18:22:02');
INSERT INTO `access_log` VALUES (10355, '82fb94e8-4de1-4358-bffd-f36e5b737d10', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:22:29', 217, 0, '', '2019-05-26 18:22:30');
INSERT INTO `access_log` VALUES (10356, '7be6a59b-6be6-466f-a19d-e561741237db', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:22:29', 219, 0, '', '2019-05-26 18:22:30');
INSERT INTO `access_log` VALUES (10357, '19fcca6c-7354-4a86-bcc6-e0b45f0b7e95', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:22:29', 215, 0, '', '2019-05-26 18:22:30');
INSERT INTO `access_log` VALUES (10358, '0090dee1-b0bf-4cf3-b7ef-e21dce37991a', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:22:29', 176, 0, '', '2019-05-26 18:22:30');
INSERT INTO `access_log` VALUES (10359, '5c11e86a-9ef2-40b9-9c0d-54550e144d3c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:24:39', 172, 0, '', '2019-05-26 18:24:39');
INSERT INTO `access_log` VALUES (10360, '676e07ef-4fc9-49e2-81d6-c99f1302e843', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:24:39', 174, 0, '', '2019-05-26 18:24:39');
INSERT INTO `access_log` VALUES (10361, '3ee169a0-ad86-4bb8-bc64-1acd460834b6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:24:39', 178, 0, '', '2019-05-26 18:24:39');
INSERT INTO `access_log` VALUES (10362, '826ef7bd-cf23-42f1-a087-bfec184689b2', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:24:39', 221, 0, '', '2019-05-26 18:24:39');
INSERT INTO `access_log` VALUES (10363, 'e2e316af-fcac-4af6-8afd-375f62765905', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:24:48', 146, 0, '', '2019-05-26 18:24:48');
INSERT INTO `access_log` VALUES (10364, '126fa649-40c7-41db-9ef8-ff7ef32c2257', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:24:48', 237, 0, '', '2019-05-26 18:24:48');
INSERT INTO `access_log` VALUES (10365, '2472f20f-84ff-4967-9fce-25fec1240124', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:24:48', 272, 0, '', '2019-05-26 18:24:48');
INSERT INTO `access_log` VALUES (10366, 'c1e2c990-698e-4153-8336-2d85defa4416', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:24:48', 170, 0, '', '2019-05-26 18:24:48');
INSERT INTO `access_log` VALUES (10367, '19e5721c-0e47-4180-9924-1b39c770f49c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:26:12', 372, 0, '', '2019-05-26 18:26:12');
INSERT INTO `access_log` VALUES (10368, 'bdbfb187-0c75-417b-95be-c20bb062dd97', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:26:12', 371, 0, '', '2019-05-26 18:26:12');
INSERT INTO `access_log` VALUES (10369, 'dd9ad6bf-5316-4dd9-ade7-e630501fb971', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:26:12', 371, 0, '', '2019-05-26 18:26:12');
INSERT INTO `access_log` VALUES (10370, '47d1aac6-ee3d-477e-870c-2e4c7d1ccc02', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:26:12', 307, 0, '', '2019-05-26 18:26:12');
INSERT INTO `access_log` VALUES (10371, 'e3e9f178-7330-4885-a3bd-8e301de7355b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:26:36', 143, 0, '', '2019-05-26 18:26:37');
INSERT INTO `access_log` VALUES (10372, '4b04e46a-6f8e-4f2f-898d-21ea600ee967', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:26:36', 145, 0, '', '2019-05-26 18:26:37');
INSERT INTO `access_log` VALUES (10373, 'c254d177-b029-4ca7-bcf4-5cf59184b96a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:26:36', 141, 0, '', '2019-05-26 18:26:37');
INSERT INTO `access_log` VALUES (10374, 'be0668e6-3698-42a0-a3e4-1f4f6ae526eb', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:26:37', 174, 0, '', '2019-05-26 18:26:37');
INSERT INTO `access_log` VALUES (10375, '78d32392-2c13-4cf7-b2bb-4f97ff1492aa', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:27:04', 139, 0, '', '2019-05-26 18:27:05');
INSERT INTO `access_log` VALUES (10376, '714452e0-ce1f-4856-9388-e272ca0ea1c2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:27:04', 141, 0, '', '2019-05-26 18:27:05');
INSERT INTO `access_log` VALUES (10377, 'ba243540-551b-445f-b015-02c547e209cc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:27:04', 142, 0, '', '2019-05-26 18:27:05');
INSERT INTO `access_log` VALUES (10378, 'f051b394-1eb8-45c9-bed5-270262b5bdb9', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:27:05', 175, 0, '', '2019-05-26 18:27:05');
INSERT INTO `access_log` VALUES (10379, '637f63b7-aec1-4763-81e8-30595b9d13f1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:27:36', 169, 0, '', '2019-05-26 18:27:36');
INSERT INTO `access_log` VALUES (10380, '53948594-5db6-4b46-8488-b2a3af8494a2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:27:36', 174, 0, '', '2019-05-26 18:27:36');
INSERT INTO `access_log` VALUES (10381, 'ddbe26aa-eabd-484c-be66-ec62cd4c47fe', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:27:36', 211, 0, '', '2019-05-26 18:27:36');
INSERT INTO `access_log` VALUES (10382, 'ad333d01-2cc8-420a-aad0-d7a80154a864', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:27:36', 173, 0, '', '2019-05-26 18:27:36');
INSERT INTO `access_log` VALUES (10383, '19e8be8a-2173-404e-828d-59b0cea188ec', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:29:23', 173, 0, '', '2019-05-26 18:29:23');
INSERT INTO `access_log` VALUES (10384, '9ffe0944-d44e-4c8e-99b1-d6e33b7979da', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:29:23', 176, 0, '', '2019-05-26 18:29:23');
INSERT INTO `access_log` VALUES (10385, 'c7c2718b-4370-4213-accc-e8534dbb3875', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:29:23', 176, 0, '', '2019-05-26 18:29:23');
INSERT INTO `access_log` VALUES (10386, 'c71685e2-9a8e-452f-9522-b3074df41e18', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:29:24', 175, 0, '', '2019-05-26 18:29:24');
INSERT INTO `access_log` VALUES (10387, '55d5d5b4-c14a-4089-85c1-e588e9b625b2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:29:51', 145, 0, '', '2019-05-26 18:29:52');
INSERT INTO `access_log` VALUES (10388, 'fe3fefa6-3b9c-45e9-aa5e-723766d59e55', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:29:51', 143, 0, '', '2019-05-26 18:29:52');
INSERT INTO `access_log` VALUES (10389, 'f3738ffc-e47d-453e-99d2-0d5c1e447753', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:29:51', 146, 0, '', '2019-05-26 18:29:52');
INSERT INTO `access_log` VALUES (10390, '95292e42-8774-45e9-9122-6cbb557576b4', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:29:51', 207, 0, '', '2019-05-26 18:29:52');
INSERT INTO `access_log` VALUES (10391, '9f12bf34-5a60-4138-a057-0f43635da189', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:31:06', 182, 0, '', '2019-05-26 18:31:06');
INSERT INTO `access_log` VALUES (10392, '993af965-b202-45a1-bf64-4499c7475bae', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:31:06', 184, 0, '', '2019-05-26 18:31:06');
INSERT INTO `access_log` VALUES (10393, '7b848a2d-2492-49fa-a31e-d627a429d0dc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:31:06', 182, 0, '', '2019-05-26 18:31:06');
INSERT INTO `access_log` VALUES (10394, '5bd3c257-e491-4735-a48d-f9e6743a18f2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:31:08', 365, 0, '', '2019-05-26 18:31:09');
INSERT INTO `access_log` VALUES (10395, 'af2a4704-4040-4baf-bf3d-09bd0a38db00', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:31:08', 364, 0, '', '2019-05-26 18:31:09');
INSERT INTO `access_log` VALUES (10396, '7434cb63-9932-4c88-8899-7e8af2264e32', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:31:08', 364, 0, '', '2019-05-26 18:31:09');
INSERT INTO `access_log` VALUES (10397, '6322d66f-4940-465a-9e13-6aa385c51350', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:31:09', 173, 0, '', '2019-05-26 18:31:09');
INSERT INTO `access_log` VALUES (10398, 'fa71c64e-f5ea-4522-bde9-a23db5ef174f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:31:25', 148, 0, '', '2019-05-26 18:31:25');
INSERT INTO `access_log` VALUES (10399, '22dc0990-54ef-49a2-ace4-8db1d20ce0a4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:31:25', 149, 0, '', '2019-05-26 18:31:25');
INSERT INTO `access_log` VALUES (10400, '5ff8158d-b522-441a-ae9d-ac214299a601', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:31:25', 256, 0, '', '2019-05-26 18:31:26');
INSERT INTO `access_log` VALUES (10401, 'b52c04eb-92c3-47c3-bae7-2206646b17aa', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:31:25', 299, 0, '', '2019-05-26 18:31:26');
INSERT INTO `access_log` VALUES (10402, '3ccaf29e-932b-4df5-af02-13647f46406f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:34:12', 610, 0, '', '2019-05-26 18:34:12');
INSERT INTO `access_log` VALUES (10403, '84a7afaa-bf12-4c1c-b63e-b15c1dca64b4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:34:12', 576, 0, '', '2019-05-26 18:34:12');
INSERT INTO `access_log` VALUES (10404, '0d690078-0cb1-4f0b-8185-e5e94c03cef4', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:34:12', 598, 0, '', '2019-05-26 18:34:12');
INSERT INTO `access_log` VALUES (10405, 'cc5e0f87-8f2e-4b1b-b37d-d1b6bf97cd6d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:34:12', 648, 0, '', '2019-05-26 18:34:12');
INSERT INTO `access_log` VALUES (10406, 'c7b93eff-88ab-4f57-be43-57d2bd620d24', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:34:23', 539, 0, '', '2019-05-26 18:34:23');
INSERT INTO `access_log` VALUES (10407, '979216dd-12f0-4dac-a94f-0bcc505de089', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:34:23', 614, 0, '', '2019-05-26 18:34:23');
INSERT INTO `access_log` VALUES (10408, 'c5b76624-afb1-4af5-b8f3-08e5c4f0c198', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:34:23', 612, 0, '', '2019-05-26 18:34:23');
INSERT INTO `access_log` VALUES (10409, 'd9ac3488-b58b-4ef3-8afe-fac95a7e21d1', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:34:23', 575, 0, '', '2019-05-26 18:34:23');
INSERT INTO `access_log` VALUES (10410, 'e39d9c84-7575-4218-9028-aa6f78680218', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:25', 599, 0, '', '2019-05-26 18:35:26');
INSERT INTO `access_log` VALUES (10411, '21f826a7-373f-4c78-84eb-a75ae22e2aeb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:25', 623, 0, '', '2019-05-26 18:35:26');
INSERT INTO `access_log` VALUES (10412, 'cd87cda2-07ba-4343-ae36-f27ba0a8c0b0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:25', 641, 0, '', '2019-05-26 18:35:26');
INSERT INTO `access_log` VALUES (10413, '51edc1b5-85fd-4a98-8e83-9a01770ecdc5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:25', 676, 0, '', '2019-05-26 18:35:26');
INSERT INTO `access_log` VALUES (10414, '8b824753-7bfd-47f4-abd4-3d815efb8021', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:33', 190, 0, '', '2019-05-26 18:35:33');
INSERT INTO `access_log` VALUES (10415, '896e6515-881a-4ea1-9301-39e7d636d159', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:41', 155, 0, '', '2019-05-26 18:35:41');
INSERT INTO `access_log` VALUES (10416, '891aff40-ae89-4310-b610-0834eb868399', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:41', 155, 0, '', '2019-05-26 18:35:41');
INSERT INTO `access_log` VALUES (10417, '441f63e2-c188-4686-bae0-d047128781f4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:41', 154, 0, '', '2019-05-26 18:35:41');
INSERT INTO `access_log` VALUES (10418, '754676e0-585c-474a-863d-4db5ed466e93', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:41', 310, 0, '', '2019-05-26 18:35:42');
INSERT INTO `access_log` VALUES (10419, '5dfea76f-50d2-42c7-a7ad-9f268dfd25e9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:56', 145, 0, '', '2019-05-26 18:35:56');
INSERT INTO `access_log` VALUES (10420, 'e124f0e8-3a95-48c3-81dc-e80f9971c58f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:56', 151, 0, '', '2019-05-26 18:35:56');
INSERT INTO `access_log` VALUES (10421, 'c8c659c8-c786-4b99-94d7-06bcb356af2c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:56', 153, 0, '', '2019-05-26 18:35:56');
INSERT INTO `access_log` VALUES (10422, '73479954-d7e0-4f92-97b3-94a073976026', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:56', 194, 0, '', '2019-05-26 18:35:56');
INSERT INTO `access_log` VALUES (10423, 'bc0283c2-1935-48f5-b32e-f1bacac05d44', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:58', 147, 0, '', '2019-05-26 18:35:58');
INSERT INTO `access_log` VALUES (10424, '39da6630-7505-4dea-bea2-e70ec4a0b708', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:58', 146, 0, '', '2019-05-26 18:35:58');
INSERT INTO `access_log` VALUES (10425, '7a92be74-cf44-4f10-9d89-6de86a87e05e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:58', 141, 0, '', '2019-05-26 18:35:58');
INSERT INTO `access_log` VALUES (10426, '53bea1d1-eb92-43ad-ab09-7626dd4b98fb', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:35:58', 177, 0, '', '2019-05-26 18:35:58');
INSERT INTO `access_log` VALUES (10427, 'd073bd33-6228-471a-88aa-39a839e85510', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:36:19', 141, 0, '', '2019-05-26 18:36:19');
INSERT INTO `access_log` VALUES (10428, '993422b6-389f-4472-8a0b-adf80e95e50c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:36:19', 144, 0, '', '2019-05-26 18:36:19');
INSERT INTO `access_log` VALUES (10429, 'cf8b0f26-ff98-49bd-9358-5baa216083e4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:36:19', 146, 0, '', '2019-05-26 18:36:19');
INSERT INTO `access_log` VALUES (10430, '056811b3-ff8a-403e-8696-ac3254087ab0', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:36:19', 175, 0, '', '2019-05-26 18:36:19');
INSERT INTO `access_log` VALUES (10431, 'ac8ee92b-5c48-468a-993a-085d33095039', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:36:39', 136, 0, '', '2019-05-26 18:36:39');
INSERT INTO `access_log` VALUES (10432, 'a35361e1-d2db-4156-b980-916029ba3534', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:36:39', 140, 0, '', '2019-05-26 18:36:39');
INSERT INTO `access_log` VALUES (10433, '19bd52b2-4453-4a7c-9ca0-06e96bf2571d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:36:39', 140, 0, '', '2019-05-26 18:36:39');
INSERT INTO `access_log` VALUES (10434, '827ee010-9f20-4242-8859-8915ed669056', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:36:39', 177, 0, '', '2019-05-26 18:36:39');
INSERT INTO `access_log` VALUES (10435, '1b6a412f-e4fc-493e-a289-4f63ab354ed5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:38:39', 548, 0, '', '2019-05-26 18:38:39');
INSERT INTO `access_log` VALUES (10436, '40d2bf9c-3f7e-42f7-9688-27a2534e1cd2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:38:39', 548, 0, '', '2019-05-26 18:38:39');
INSERT INTO `access_log` VALUES (10437, '3377bfc2-4b5f-4552-b795-36a908039b67', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:38:39', 553, 0, '', '2019-05-26 18:38:39');
INSERT INTO `access_log` VALUES (10438, 'fa981327-ce70-4e7f-9acf-9bc796636524', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 18:38:42', 225, 0, '', '2019-05-26 18:38:42');
INSERT INTO `access_log` VALUES (10439, '65.52.15588728348796169', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.10.95.168', '2019-05-26 20:13:55', 1, 1002001015, '账号未登陆', '2019-05-26 20:13:55');
INSERT INTO `access_log` VALUES (10440, '65.48.15588728348796181', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.10.95.168', '2019-05-26 20:13:55', 0, 1002001015, '账号未登陆', '2019-05-26 20:13:55');
INSERT INTO `access_log` VALUES (10441, '65.47.15588728348796171', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.10.95.168', '2019-05-26 20:13:55', 0, 1002001015, '账号未登陆', '2019-05-26 20:13:55');
INSERT INTO `access_log` VALUES (10442, '65.45.15588728415006175', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.10.95.168', '2019-05-26 20:14:02', 55, 0, '', '2019-05-26 20:14:02');
INSERT INTO `access_log` VALUES (10443, '65.46.15588728417506171', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.10.95.168', '2019-05-26 20:14:02', 14, 0, '', '2019-05-26 20:14:02');
INSERT INTO `access_log` VALUES (10444, '65.50.15588728417566161', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.10.95.168', '2019-05-26 20:14:02', 11, 0, '', '2019-05-26 20:14:02');
INSERT INTO `access_log` VALUES (10445, '65.54.15588728417556155', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.10.95.168', '2019-05-26 20:14:02', 12, 0, '', '2019-05-26 20:14:02');
INSERT INTO `access_log` VALUES (10446, '65.49.15588728715726165', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.10.95.168', '2019-05-26 20:14:32', 20, 0, '', '2019-05-26 20:14:32');
INSERT INTO `access_log` VALUES (10447, '65.52.15588728729946171', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.10.95.168', '2019-05-26 20:14:33', 16, 0, '', '2019-05-26 20:14:33');
INSERT INTO `access_log` VALUES (10448, '65.48.15588728740626183', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.10.95.168', '2019-05-26 20:14:34', 10, 0, '', '2019-05-26 20:14:34');
INSERT INTO `access_log` VALUES (10449, '65.47.15588728749076173', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.10.95.168', '2019-05-26 20:14:35', 15, 0, '', '2019-05-26 20:14:35');
INSERT INTO `access_log` VALUES (10450, '62.85.15588728799586869', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.10.95.168', '2019-05-26 20:14:40', 24, 0, '', '2019-05-26 20:14:40');
INSERT INTO `access_log` VALUES (10451, '62.88.15588728831136873', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.10.95.168', '2019-05-26 20:14:43', 20, 0, '', '2019-05-26 20:14:43');
INSERT INTO `access_log` VALUES (10452, '59.78.15588758808246967', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.87.150.2', '2019-05-26 21:04:41', 12, 0, '', '2019-05-26 21:04:41');
INSERT INTO `access_log` VALUES (10453, '59.72.15588758808256959', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.87.150.2', '2019-05-26 21:04:41', 16, 2001001000, '服务端发生异常', '2019-05-26 21:04:41');
INSERT INTO `access_log` VALUES (10454, '64.85.15588758965906207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.87.150.2', '2019-05-26 21:04:57', 57, 0, '', '2019-05-26 21:04:57');
INSERT INTO `access_log` VALUES (10455, '64.81.15588758968936203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.87.150.2', '2019-05-26 21:04:57', 4, 0, '', '2019-05-26 21:04:57');
INSERT INTO `access_log` VALUES (10456, '64.78.15588758984526209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.87.150.2', '2019-05-26 21:04:58', 4, 0, '', '2019-05-26 21:04:58');
INSERT INTO `access_log` VALUES (10457, '64.82.15588758992316209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.87.150.2', '2019-05-26 21:04:59', 3, 0, '', '2019-05-26 21:04:59');
INSERT INTO `access_log` VALUES (10458, '59.71.15588759009156965', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.87.150.2', '2019-05-26 21:05:01', 4, 0, '', '2019-05-26 21:05:01');
INSERT INTO `access_log` VALUES (10459, '59.77.15588759009156963', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.87.150.2', '2019-05-26 21:05:01', 14, 2001001000, '服务端发生异常', '2019-05-26 21:05:01');
INSERT INTO `access_log` VALUES (10460, '59.79.15588775992726985', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 21:33:19', 4, 0, '', '2019-05-26 21:33:19');
INSERT INTO `access_log` VALUES (10461, '59.72.15588775992726983', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 21:33:19', 15, 2001001000, '服务端发生异常', '2019-05-26 21:33:19');
INSERT INTO `access_log` VALUES (10462, '64.83.15588776031116229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 21:33:23', 4, 0, '', '2019-05-26 21:33:23');
INSERT INTO `access_log` VALUES (10463, '64.80.15588776032106225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 21:33:23', 3, 0, '', '2019-05-26 21:33:23');
INSERT INTO `access_log` VALUES (10464, '64.85.15588776046816231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 21:33:25', 3, 0, '', '2019-05-26 21:33:25');
INSERT INTO `access_log` VALUES (10465, '64.81.15588776050766227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 21:33:25', 3, 0, '', '2019-05-26 21:33:25');
INSERT INTO `access_log` VALUES (10466, '64.78.15588776053836233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 21:33:25', 3, 0, '', '2019-05-26 21:33:25');
INSERT INTO `access_log` VALUES (10467, '59.78.15588776073976991', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 21:33:27', 3, 0, '', '2019-05-26 21:33:27');
INSERT INTO `access_log` VALUES (10468, '59.80.15588776073976987', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 21:33:27', 14, 2001001000, '服务端发生异常', '2019-05-26 21:33:27');
INSERT INTO `access_log` VALUES (10469, '65.52.15588782222116243', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:43:42', 5, 1002001012, '访问令牌已过期', '2019-05-26 21:43:42');
INSERT INTO `access_log` VALUES (10470, '65.48.15588782222726255', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:43:42', 6, 1002001012, '访问令牌已过期', '2019-05-26 21:43:42');
INSERT INTO `access_log` VALUES (10471, '65.47.15588782222726245', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:43:42', 7, 1002001012, '访问令牌已过期', '2019-05-26 21:43:42');
INSERT INTO `access_log` VALUES (10472, '65.54.15588782449096229', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:44:05', 106, 0, '', '2019-05-26 21:44:05');
INSERT INTO `access_log` VALUES (10473, '65.50.15588782452996235', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:44:05', 12, 0, '', '2019-05-26 21:44:05');
INSERT INTO `access_log` VALUES (10474, '65.46.15588782453046245', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:44:05', 11, 0, '', '2019-05-26 21:44:05');
INSERT INTO `access_log` VALUES (10475, '65.51.15588782453046237', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:44:05', 10, 0, '', '2019-05-26 21:44:05');
INSERT INTO `access_log` VALUES (10476, '65.49.15588782494726239', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:44:09', 20, 0, '', '2019-05-26 21:44:09');
INSERT INTO `access_log` VALUES (10477, '65.52.15588782519106245', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:44:12', 10, 0, '', '2019-05-26 21:44:12');
INSERT INTO `access_log` VALUES (10478, '65.47.15588782533116247', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:44:13', 12, 0, '', '2019-05-26 21:44:13');
INSERT INTO `access_log` VALUES (10479, '65.48.15588782563966257', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:44:16', 10, 0, '', '2019-05-26 21:44:16');
INSERT INTO `access_log` VALUES (10480, '65.53.15588784785686237', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:47:59', 22, 0, '', '2019-05-26 21:47:59');
INSERT INTO `access_log` VALUES (10481, '65.49.15588784843736243', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:48:04', 10, 0, '', '2019-05-26 21:48:04');
INSERT INTO `access_log` VALUES (10482, '65.46.15588785651116251', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:49:25', 18, 0, '', '2019-05-26 21:49:25');
INSERT INTO `access_log` VALUES (10483, '65.51.15588785707106243', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.32.216.11', '2019-05-26 21:49:31', 10, 0, '', '2019-05-26 21:49:31');
INSERT INTO `access_log` VALUES (10484, '59.79.15588790681037005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.92.219.185', '2019-05-26 21:57:48', 4, 0, '', '2019-05-26 21:57:48');
INSERT INTO `access_log` VALUES (10485, '59.80.15588790681037007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.92.219.185', '2019-05-26 21:57:48', 11, 2001001000, '服务端发生异常', '2019-05-26 21:57:48');
INSERT INTO `access_log` VALUES (10486, '65.50.15588792452326251', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.92.219.185', '2019-05-26 22:00:45', 53, 1002001012, '访问令牌已过期', '2019-05-26 22:00:45');
INSERT INTO `access_log` VALUES (10487, '65.54.15588792452256245', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.92.219.185', '2019-05-26 22:00:45', 60, 1002001012, '访问令牌已过期', '2019-05-26 22:00:45');
INSERT INTO `access_log` VALUES (10488, '65.45.15588792452176265', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.92.219.185', '2019-05-26 22:00:45', 68, 1002001012, '访问令牌已过期', '2019-05-26 22:00:45');
INSERT INTO `access_log` VALUES (10489, '65.46.15588792506276261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.92.219.185', '2019-05-26 22:00:51', 55, 0, '', '2019-05-26 22:00:51');
INSERT INTO `access_log` VALUES (10490, '65.51.15588792509556253', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.92.219.185', '2019-05-26 22:00:51', 106, 0, '', '2019-05-26 22:00:51');
INSERT INTO `access_log` VALUES (10491, '65.49.15588792509636255', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.92.219.185', '2019-05-26 22:00:51', 99, 0, '', '2019-05-26 22:00:51');
INSERT INTO `access_log` VALUES (10492, '65.53.15588792509586249', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.92.219.185', '2019-05-26 22:00:51', 104, 0, '', '2019-05-26 22:00:51');
INSERT INTO `access_log` VALUES (10493, '62.87.15588792568086959', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.92.219.185', '2019-05-26 22:00:57', 28, 0, '', '2019-05-26 22:00:57');
INSERT INTO `access_log` VALUES (10494, '62.82.15588792611776953', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.92.219.185', '2019-05-26 22:01:01', 60, 0, '', '2019-05-26 22:01:01');
INSERT INTO `access_log` VALUES (10495, '59.75.15588792737047011', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.92.219.185', '2019-05-26 22:01:14', 107, 0, '', '2019-05-26 22:01:14');
INSERT INTO `access_log` VALUES (10496, '65.48.15588792787216273', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.92.219.185', '2019-05-26 22:01:19', 16, 0, '', '2019-05-26 22:01:19');
INSERT INTO `access_log` VALUES (10497, '65.50.15588813431036281', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:35:43', 1, 1002001015, '账号未登陆', '2019-05-26 22:35:43');
INSERT INTO `access_log` VALUES (10498, '65.47.15588813431036291', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:35:43', 1, 1002001015, '账号未登陆', '2019-05-26 22:35:43');
INSERT INTO `access_log` VALUES (10499, '65.48.15588813431036301', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:35:43', 1, 1002001015, '账号未登陆', '2019-05-26 22:35:43');
INSERT INTO `access_log` VALUES (10500, '65.45.15588813444636295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:35:44', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-26 22:35:44');
INSERT INTO `access_log` VALUES (10501, '65.54.15588813513316275', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:35:51', 147, 0, '', '2019-05-26 22:35:51');
INSERT INTO `access_log` VALUES (10502, '65.46.15588813518066291', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:35:52', 15, 0, '', '2019-05-26 22:35:52');
INSERT INTO `access_log` VALUES (10503, '65.51.15588813518086283', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:35:52', 14, 0, '', '2019-05-26 22:35:52');
INSERT INTO `access_log` VALUES (10504, '65.49.15588813518126285', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:35:52', 14, 0, '', '2019-05-26 22:35:52');
INSERT INTO `access_log` VALUES (10505, '62.88.15588813692196987', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:36:09', 242, 0, '', '2019-05-26 22:36:09');
INSERT INTO `access_log` VALUES (10506, '62.86.15588813731516973', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:36:13', 47, 0, '', '2019-05-26 22:36:13');
INSERT INTO `access_log` VALUES (10507, '64.77.15588813791116285', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:36:19', 74, 0, '', '2019-05-26 22:36:19');
INSERT INTO `access_log` VALUES (10508, '64.84.15588813791106283', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:36:19', 77, 0, '', '2019-05-26 22:36:19');
INSERT INTO `access_log` VALUES (10509, '66.53.15588813978286071', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:36:38', 30, 0, '', '2019-05-26 22:36:38');
INSERT INTO `access_log` VALUES (10510, '65.48.15588814065526303', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:36:47', 21, 0, '', '2019-05-26 22:36:47');
INSERT INTO `access_log` VALUES (10511, '65.54.15588814191286277', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:36:59', 14, 0, '', '2019-05-26 22:36:59');
INSERT INTO `access_log` VALUES (10512, '65.51.15588814373186285', 0, 2, 'admin-application', '/admin-api/admins/data_dict/update', 'id=1&enumValue=gender&value=2&displayName=男&sort=1&memo=性别 - 男（嗨）&createTime=2019-03-03T05:03:46.000+0000&index=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:37:17', 11, 1002002007, '没有该操作权限', '2019-05-26 22:37:17');
INSERT INTO `access_log` VALUES (10513, '65.49.15588814375056287', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.202.165', '2019-05-26 22:37:18', 28, 0, '', '2019-05-26 22:37:18');
INSERT INTO `access_log` VALUES (10514, '59.74.15588825917237057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.179.177.82', '2019-05-26 22:56:32', 13, 0, '', '2019-05-26 22:56:32');
INSERT INTO `access_log` VALUES (10515, '59.72.15588825917237051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.179.177.82', '2019-05-26 22:56:32', 17, 2001001000, '服务端发生异常', '2019-05-26 22:56:32');
INSERT INTO `access_log` VALUES (10516, '65.49.15588826108826303', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.179.177.82', '2019-05-26 22:56:51', 0, 1002001015, '账号未登陆', '2019-05-26 22:56:51');
INSERT INTO `access_log` VALUES (10517, '65.51.15588826108826301', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.179.177.82', '2019-05-26 22:56:51', 0, 1002001015, '账号未登陆', '2019-05-26 22:56:51');
INSERT INTO `access_log` VALUES (10518, '65.53.15588826108836297', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.179.177.82', '2019-05-26 22:56:51', 0, 1002001015, '账号未登陆', '2019-05-26 22:56:51');
INSERT INTO `access_log` VALUES (10519, '65.52.15588826133836309', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.179.177.82', '2019-05-26 22:56:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-26 22:56:53');
INSERT INTO `access_log` VALUES (10520, '65.47.15588826190586311', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.179.177.82', '2019-05-26 22:56:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-26 22:56:59');
INSERT INTO `access_log` VALUES (10521, 'ac1966ef-58de-41d5-800d-07631e1163dc', 0, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:04:23', 312, 1002001012, '访问令牌已过期', '2019-05-26 23:04:24');
INSERT INTO `access_log` VALUES (10522, '7696068a-e88a-486f-9ea5-6414b366e76b', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:04:23', 377, 1002001012, '访问令牌已过期', '2019-05-26 23:04:24');
INSERT INTO `access_log` VALUES (10523, '002f4f51-01b5-4758-bdb2-eee54c369032', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:04:23', 340, 1002001012, '访问令牌已过期', '2019-05-26 23:04:24');
INSERT INTO `access_log` VALUES (10524, '0c448702-9f42-407b-bb03-f9c034c183a3', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:04:23', 312, 1002001012, '访问令牌已过期', '2019-05-26 23:04:24');
INSERT INTO `access_log` VALUES (10525, '25a375df-24cd-450b-8521-e0797500e2e1', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:04:26', 489, 0, '', '2019-05-26 23:04:27');
INSERT INTO `access_log` VALUES (10526, 'f7c0a85e-61c2-46ad-ba04-55864717b47a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:04:27', 235, 0, '', '2019-05-26 23:04:27');
INSERT INTO `access_log` VALUES (10527, '8da37bd3-e9fb-479e-9b0a-a6ea3ca36fad', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:04:27', 247, 0, '', '2019-05-26 23:04:27');
INSERT INTO `access_log` VALUES (10528, '3fe9250b-4718-4aab-96f4-fd782c546163', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:04:27', 250, 0, '', '2019-05-26 23:04:27');
INSERT INTO `access_log` VALUES (10529, '388ea12d-00e5-4f5a-8afc-6e364b02f8dc', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:04:29', 407, 0, '', '2019-05-26 23:04:29');
INSERT INTO `access_log` VALUES (10530, '8f70a117-fa8e-405c-bb74-cb8fb7a79840', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:04:43', 195, 0, '', '2019-05-26 23:04:43');
INSERT INTO `access_log` VALUES (10531, '6fb65f73-3a21-4edf-8e4b-4a4e701b2353', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&id=7', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:04:45', 210, 0, '', '2019-05-26 23:04:45');
INSERT INTO `access_log` VALUES (10532, '6b32b464-c0ce-499d-8bbb-2ed45f90673f', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:04:48', 222, 0, '', '2019-05-26 23:04:48');
INSERT INTO `access_log` VALUES (10533, 'e3433d76-7de7-4b3d-b3fd-b352419bb68e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:21', 260, 0, '', '2019-05-26 23:05:21');
INSERT INTO `access_log` VALUES (10534, '4b347775-5ce2-43fa-8c45-36e307f92317', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:21', 262, 0, '', '2019-05-26 23:05:21');
INSERT INTO `access_log` VALUES (10535, '02334dcd-c3d1-4a58-904d-a3e7ea10f628', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:21', 263, 0, '', '2019-05-26 23:05:21');
INSERT INTO `access_log` VALUES (10536, 'b9449d35-d3c9-419a-aae3-7abddcf429d5', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:21', 274, 0, '', '2019-05-26 23:05:21');
INSERT INTO `access_log` VALUES (10537, '8eff1489-11c9-491f-b3d2-a607cd221e19', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:43', 149, 0, '', '2019-05-26 23:05:43');
INSERT INTO `access_log` VALUES (10538, '1d6dd41e-6003-4ffc-8b55-b56b31adc00a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:43', 148, 0, '', '2019-05-26 23:05:43');
INSERT INTO `access_log` VALUES (10539, 'dc1a86fd-6392-489c-9a60-964aa9529a1e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:43', 151, 0, '', '2019-05-26 23:05:43');
INSERT INTO `access_log` VALUES (10540, '2b9d901b-76d8-4332-b722-d8b61b69d952', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:43', 189, 0, '', '2019-05-26 23:05:43');
INSERT INTO `access_log` VALUES (10541, '77e6af5f-359c-4ac3-b59e-59faee8b25c2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:47', 146, 0, '', '2019-05-26 23:05:47');
INSERT INTO `access_log` VALUES (10542, '67d3715c-10ee-4d71-8a41-07360c3e5e74', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:47', 151, 0, '', '2019-05-26 23:05:47');
INSERT INTO `access_log` VALUES (10543, '5b8a7af5-14d5-48e7-b38c-e1934350cd5f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:47', 155, 0, '', '2019-05-26 23:05:47');
INSERT INTO `access_log` VALUES (10544, 'f92304e3-4180-4bf1-a0d0-bf1ac8239d23', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:47', 181, 0, '', '2019-05-26 23:05:47');
INSERT INTO `access_log` VALUES (10545, 'd787915a-a978-47f1-88fa-fcac5b6f667c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:54', 144, 0, '', '2019-05-26 23:05:54');
INSERT INTO `access_log` VALUES (10546, '01908c52-5e69-47f7-bb1f-a9ee22094a31', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:54', 151, 0, '', '2019-05-26 23:05:54');
INSERT INTO `access_log` VALUES (10547, '05d9229e-5994-4a4e-b96d-cd64c9e4ceb6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:54', 147, 0, '', '2019-05-26 23:05:54');
INSERT INTO `access_log` VALUES (10548, '9d7db69f-807a-49bf-a1e1-13ac0ac0ca77', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:05:54', 178, 0, '', '2019-05-26 23:05:55');
INSERT INTO `access_log` VALUES (10549, 'dd29d969-0d49-4b9c-ad8d-6a670d5c2396', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:06:25', 154, 0, '', '2019-05-26 23:06:25');
INSERT INTO `access_log` VALUES (10550, '392ddc31-4dea-4d3d-a62f-f1f6925aa796', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:06:25', 150, 0, '', '2019-05-26 23:06:25');
INSERT INTO `access_log` VALUES (10551, '10fbcfd6-f74c-44a6-af50-41a4ee11048c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:06:25', 149, 0, '', '2019-05-26 23:06:25');
INSERT INTO `access_log` VALUES (10552, '0fa5a5ef-342e-4a2c-9ef6-90d2ba8f12f1', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:06:25', 181, 0, '', '2019-05-26 23:06:25');
INSERT INTO `access_log` VALUES (10553, '314d1948-a0a9-4b3c-b915-bb3b76eb8821', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:06:27', 149, 0, '', '2019-05-26 23:06:27');
INSERT INTO `access_log` VALUES (10554, 'ad718986-ae0f-403d-8123-9fa4136fc6bf', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:06:27', 149, 0, '', '2019-05-26 23:06:27');
INSERT INTO `access_log` VALUES (10555, '582ce116-c8d5-426b-a077-c288b63c7973', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:06:27', 156, 0, '', '2019-05-26 23:06:27');
INSERT INTO `access_log` VALUES (10556, '1ea5db4e-5633-4e97-a3e7-2f18cf67ade7', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:06:27', 183, 0, '', '2019-05-26 23:06:27');
INSERT INTO `access_log` VALUES (10557, 'f6b3dbed-6f84-40b6-b1ed-c4bfb313f8a1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:05', 188, 0, '', '2019-05-26 23:11:05');
INSERT INTO `access_log` VALUES (10558, '45ae0b07-fc9a-46e2-91b8-c07579df4086', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:05', 185, 0, '', '2019-05-26 23:11:05');
INSERT INTO `access_log` VALUES (10559, '6c1a36a2-ac96-4b86-a02b-863e4785eecc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:05', 191, 0, '', '2019-05-26 23:11:05');
INSERT INTO `access_log` VALUES (10560, '423ca9c2-70a9-4a73-a726-ee2d2ba82d2f', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:05', 222, 0, '', '2019-05-26 23:11:05');
INSERT INTO `access_log` VALUES (10561, '4466b4ce-2e66-4697-a835-78fa45f91562', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:10', 154, 0, '', '2019-05-26 23:11:10');
INSERT INTO `access_log` VALUES (10562, '910b5a46-2d05-4c29-ad39-5bd7e7ce6c2f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:10', 158, 0, '', '2019-05-26 23:11:10');
INSERT INTO `access_log` VALUES (10563, '913465b5-969e-48a9-8dc3-9aca2b1b09c9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:10', 153, 0, '', '2019-05-26 23:11:10');
INSERT INTO `access_log` VALUES (10564, '2a50ec14-5146-4a3a-87a3-c482e1c82224', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:10', 182, 0, '', '2019-05-26 23:11:11');
INSERT INTO `access_log` VALUES (10565, 'df9af9ea-6ec3-4e79-8b72-21f075263c19', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:49', 147, 0, '', '2019-05-26 23:11:49');
INSERT INTO `access_log` VALUES (10566, 'dd076f19-2425-4748-ac9a-9b1f3b608ed8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:49', 146, 0, '', '2019-05-26 23:11:49');
INSERT INTO `access_log` VALUES (10567, 'e73b5894-88ce-4647-be26-2cabb9204002', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:49', 150, 0, '', '2019-05-26 23:11:49');
INSERT INTO `access_log` VALUES (10568, '6ca87557-c692-410e-9096-97ce2d3191a6', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:50', 531, 0, '', '2019-05-26 23:11:50');
INSERT INTO `access_log` VALUES (10569, '360087c6-2d54-4b69-bfee-fdaff165e68f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:52', 172, 0, '', '2019-05-26 23:11:52');
INSERT INTO `access_log` VALUES (10570, '719de98e-507b-45c5-932c-d5dcb36751b4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:52', 171, 0, '', '2019-05-26 23:11:52');
INSERT INTO `access_log` VALUES (10571, '6186f20a-d42e-4fb6-bc04-6ebaf760fe24', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:52', 170, 0, '', '2019-05-26 23:11:52');
INSERT INTO `access_log` VALUES (10572, '03d02c07-1e23-459d-b7e6-c36b990ae5cd', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:52', 1133, 0, '', '2019-05-26 23:11:53');
INSERT INTO `access_log` VALUES (10573, '8c35e1c7-29a4-4e1d-9911-df07d9b68dfb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:59', 146, 0, '', '2019-05-26 23:11:59');
INSERT INTO `access_log` VALUES (10574, 'dca341e7-156b-4196-8153-fff50e99cbbb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:59', 150, 0, '', '2019-05-26 23:11:59');
INSERT INTO `access_log` VALUES (10575, '1d43093d-3edc-471e-b335-44cf940600e0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:59', 148, 0, '', '2019-05-26 23:11:59');
INSERT INTO `access_log` VALUES (10576, '069ccf8d-21af-4067-abc1-6f531029d058', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:11:59', 181, 0, '', '2019-05-26 23:11:59');
INSERT INTO `access_log` VALUES (10577, 'd7b05b8a-f9e0-4e97-8cd1-b8aab7d49348', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:12:05', 145, 0, '', '2019-05-26 23:12:05');
INSERT INTO `access_log` VALUES (10578, '9bcc1594-d682-4e8a-91b9-cc0fdc46c680', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:12:05', 148, 0, '', '2019-05-26 23:12:05');
INSERT INTO `access_log` VALUES (10579, 'f74b30ef-c131-421e-b6cf-58daaa5f47fc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:12:05', 153, 0, '', '2019-05-26 23:12:05');
INSERT INTO `access_log` VALUES (10580, 'c00334fc-33cf-4c5d-9102-db0c93ecb02c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:12:05', 192, 0, '', '2019-05-26 23:12:05');
INSERT INTO `access_log` VALUES (10581, 'f7a49c3b-4a23-45b7-b5f3-e7b2e2745141', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:12:38', 148, 0, '', '2019-05-26 23:12:38');
INSERT INTO `access_log` VALUES (10582, 'b8effffb-4dea-46e0-bed1-39f1935cc75b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:12:38', 147, 0, '', '2019-05-26 23:12:38');
INSERT INTO `access_log` VALUES (10583, '06bb236e-f142-41fd-b819-1aabf65a2118', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:12:38', 149, 0, '', '2019-05-26 23:12:38');
INSERT INTO `access_log` VALUES (10584, 'e63f5417-8f12-4929-b546-ac830b37c504', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:12:38', 181, 0, '', '2019-05-26 23:12:39');
INSERT INTO `access_log` VALUES (10585, 'e4169556-fdd6-4925-9bfe-3009e6b2fbf8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:02', 150, 0, '', '2019-05-26 23:13:02');
INSERT INTO `access_log` VALUES (10586, 'ba07a33b-263c-4af7-bc9b-463e1a675141', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:02', 147, 0, '', '2019-05-26 23:13:02');
INSERT INTO `access_log` VALUES (10587, '1f7e1730-9642-431a-a012-a0547d9ab520', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:02', 146, 0, '', '2019-05-26 23:13:02');
INSERT INTO `access_log` VALUES (10588, 'edf1ad96-febb-4a68-b439-6dac33517524', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:02', 179, 0, '', '2019-05-26 23:13:02');
INSERT INTO `access_log` VALUES (10589, 'aa4e3bf5-5c42-4e80-8b09-6caa3be6ecfa', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:05', 147, 0, '', '2019-05-26 23:13:05');
INSERT INTO `access_log` VALUES (10590, 'e5d2603c-3645-44a3-8ec0-56221deac96c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:05', 148, 0, '', '2019-05-26 23:13:05');
INSERT INTO `access_log` VALUES (10591, '505f47a4-9678-4364-b35f-cf246dcb8f52', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:05', 150, 0, '', '2019-05-26 23:13:05');
INSERT INTO `access_log` VALUES (10592, '809e0e39-fc46-4945-afad-4e1f6b647d2f', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:05', 191, 0, '', '2019-05-26 23:13:05');
INSERT INTO `access_log` VALUES (10593, '4e80b8ba-5d8d-4ab0-af6d-3aac9d9ad955', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:25', 156, 0, '', '2019-05-26 23:13:25');
INSERT INTO `access_log` VALUES (10594, '7d48d995-c086-4d0a-a6f1-eb44ecaa3072', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:25', 150, 0, '', '2019-05-26 23:13:25');
INSERT INTO `access_log` VALUES (10595, '0dbb9ef4-c44a-4c5b-a66d-d214b47b69d3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:25', 151, 0, '', '2019-05-26 23:13:25');
INSERT INTO `access_log` VALUES (10596, 'de2800c5-d955-453e-b28e-a5ea1a9da8cc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:31', 145, 0, '', '2019-05-26 23:13:31');
INSERT INTO `access_log` VALUES (10597, '219f3c36-c25e-4499-bc45-63640848011f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:31', 146, 0, '', '2019-05-26 23:13:31');
INSERT INTO `access_log` VALUES (10598, 'a7e35186-efbe-4c74-8e24-ce3a528daa01', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:31', 148, 0, '', '2019-05-26 23:13:31');
INSERT INTO `access_log` VALUES (10599, '8032e0b6-8d5f-47af-889d-e2abcdad52d4', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:31', 187, 0, '', '2019-05-26 23:13:31');
INSERT INTO `access_log` VALUES (10600, 'a1911a67-6d53-45e5-9a48-3b2e584bccf8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:33', 147, 0, '', '2019-05-26 23:13:33');
INSERT INTO `access_log` VALUES (10601, 'e290bc12-7f4f-4704-a611-7e9d4e6b205f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:33', 149, 0, '', '2019-05-26 23:13:33');
INSERT INTO `access_log` VALUES (10602, '5115672a-b4e4-49cb-9086-29fc678dcda0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:33', 145, 0, '', '2019-05-26 23:13:33');
INSERT INTO `access_log` VALUES (10603, '8da087c2-5681-45fb-82b6-47f30d8113ff', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:33', 185, 0, '', '2019-05-26 23:13:33');
INSERT INTO `access_log` VALUES (10604, '2e5d7245-2ee6-4985-a011-a77a65ce60e5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:39', 181, 0, '', '2019-05-26 23:13:39');
INSERT INTO `access_log` VALUES (10605, '47640cbd-7776-4ead-ba2f-e71c1c5c1bfd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:39', 183, 0, '', '2019-05-26 23:13:39');
INSERT INTO `access_log` VALUES (10606, 'b0bebb56-d704-41dd-8b4e-1e4c942e9511', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:39', 184, 0, '', '2019-05-26 23:13:39');
INSERT INTO `access_log` VALUES (10607, '10cb97b8-3aab-4b1d-bdaf-495b5abfc012', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:13:39', 183, 0, '', '2019-05-26 23:13:39');
INSERT INTO `access_log` VALUES (10608, '0deaf8b7-b9e1-4bb2-bc7d-f72c640f98a8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:14:03', 146, 0, '', '2019-05-26 23:14:03');
INSERT INTO `access_log` VALUES (10609, '9eb5bc53-28cd-4733-b18a-673d895bec5c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:14:03', 145, 0, '', '2019-05-26 23:14:03');
INSERT INTO `access_log` VALUES (10610, '320eefc3-090d-4380-89b4-07f97695e0a6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:14:03', 146, 0, '', '2019-05-26 23:14:03');
INSERT INTO `access_log` VALUES (10611, 'b5a5ac25-e1c8-4462-a29a-ef034aa65998', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:14:03', 182, 0, '', '2019-05-26 23:14:03');
INSERT INTO `access_log` VALUES (10612, '59675774-897e-4ebe-9997-6d3f01fe6889', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:14:13', 698, 0, '', '2019-05-26 23:14:14');
INSERT INTO `access_log` VALUES (10613, 'e4a3115f-fe66-4c44-8443-9b4634ba055f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:14:13', 704, 0, '', '2019-05-26 23:14:14');
INSERT INTO `access_log` VALUES (10614, '9e3181c7-6ab3-4e1f-918d-d8d97e5e8d4c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:14:13', 657, 0, '', '2019-05-26 23:14:14');
INSERT INTO `access_log` VALUES (10615, '2a595a69-32c8-4154-815f-269db9cbe544', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:14:13', 1463, 0, '', '2019-05-26 23:14:14');
INSERT INTO `access_log` VALUES (10616, '17c38544-f017-4f69-b1b1-64b7b4308ca0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:14:32', 146, 0, '', '2019-05-26 23:14:32');
INSERT INTO `access_log` VALUES (10617, 'e6ba3954-cd37-4cc4-af47-b70fc8d0d391', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:14:32', 141, 0, '', '2019-05-26 23:14:32');
INSERT INTO `access_log` VALUES (10618, 'ffef1dbf-d1b5-4b7d-8e8f-6e8b90f47602', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:14:32', 143, 0, '', '2019-05-26 23:14:32');
INSERT INTO `access_log` VALUES (10619, 'a77ad001-e0d3-46c5-93d2-279115ffe38d', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:14:32', 186, 0, '', '2019-05-26 23:14:32');
INSERT INTO `access_log` VALUES (10620, '18df210f-0cc4-472d-b476-77f9eae60599', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:16:04', 298, 0, '', '2019-05-26 23:16:04');
INSERT INTO `access_log` VALUES (10621, '4077a5db-7d7c-43b8-af21-7fa85e89c273', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:16:04', 298, 0, '', '2019-05-26 23:16:04');
INSERT INTO `access_log` VALUES (10622, 'a1741574-288b-4c58-b8eb-3c1ce71666e2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:16:04', 297, 0, '', '2019-05-26 23:16:04');
INSERT INTO `access_log` VALUES (10623, '930a54af-d67a-48f3-918e-1953e0a9b1a2', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:16:04', 367, 0, '', '2019-05-26 23:16:04');
INSERT INTO `access_log` VALUES (10624, '8a91fe94-0f91-435c-a3d3-ee719b5829ec', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:16:39', 142, 0, '', '2019-05-26 23:16:39');
INSERT INTO `access_log` VALUES (10625, '723c9849-5528-43f9-a679-33edfafed1b2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:16:39', 142, 0, '', '2019-05-26 23:16:39');
INSERT INTO `access_log` VALUES (10626, 'e53a4180-9ed7-4f3c-aa54-2a3fd5476df7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:16:39', 140, 0, '', '2019-05-26 23:16:39');
INSERT INTO `access_log` VALUES (10627, 'b5b767b5-1a12-41d9-b25e-68fcbe19109c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:16:39', 183, 0, '', '2019-05-26 23:16:39');
INSERT INTO `access_log` VALUES (10628, '41e50355-5d4c-45fb-a769-ab6e0300a206', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:05', 145, 0, '', '2019-05-26 23:17:05');
INSERT INTO `access_log` VALUES (10629, '3ca1f1cb-f1af-4046-a0c2-4c23f4ff0fb9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:05', 148, 0, '', '2019-05-26 23:17:05');
INSERT INTO `access_log` VALUES (10630, '39fc9f4f-23da-4cfc-b0da-595641dab8da', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:05', 149, 0, '', '2019-05-26 23:17:05');
INSERT INTO `access_log` VALUES (10631, '37b95d9f-d384-4fbe-95bf-a679548b972f', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:05', 179, 0, '', '2019-05-26 23:17:05');
INSERT INTO `access_log` VALUES (10632, '86e20a37-908c-4549-be0a-436ae334ac68', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:16', 179, 0, '', '2019-05-26 23:17:16');
INSERT INTO `access_log` VALUES (10633, 'ebdb597a-43fb-4765-a075-e87b7653d6bc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:16', 181, 0, '', '2019-05-26 23:17:16');
INSERT INTO `access_log` VALUES (10634, '4268f114-5b48-4f81-8b22-58bf0d7409ed', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:16', 180, 0, '', '2019-05-26 23:17:16');
INSERT INTO `access_log` VALUES (10635, '867dbbf8-fd24-4f82-9213-507de1a53579', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:16', 189, 0, '', '2019-05-26 23:17:16');
INSERT INTO `access_log` VALUES (10636, '9352dc75-b65f-4486-9cfb-8a4c5fc54f79', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:20', 152, 0, '', '2019-05-26 23:17:20');
INSERT INTO `access_log` VALUES (10637, '406cbea6-2d72-40ce-a970-2471d4a0ade9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:20', 150, 0, '', '2019-05-26 23:17:20');
INSERT INTO `access_log` VALUES (10638, 'f2df6fa3-3fc1-4d95-a321-af481e5bf50d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:20', 154, 0, '', '2019-05-26 23:17:20');
INSERT INTO `access_log` VALUES (10639, 'a60e7cae-803a-4828-8dfd-9193ccf16119', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:20', 188, 0, '', '2019-05-26 23:17:20');
INSERT INTO `access_log` VALUES (10640, 'c3fa64a3-1c20-4c6e-8600-fbbe9d7900aa', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:22', 142, 0, '', '2019-05-26 23:17:22');
INSERT INTO `access_log` VALUES (10641, '55c4f290-ee12-40c5-978c-853242525a12', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:22', 146, 0, '', '2019-05-26 23:17:22');
INSERT INTO `access_log` VALUES (10642, '04d5c4ab-da0d-4af2-abe7-ac66d17777d3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:22', 148, 0, '', '2019-05-26 23:17:22');
INSERT INTO `access_log` VALUES (10643, '2fdde3d1-146a-48dd-9a86-8060f9f6b6bd', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:22', 178, 0, '', '2019-05-26 23:17:22');
INSERT INTO `access_log` VALUES (10644, 'fb165ca9-f730-4c73-bc4e-59f8b1fc8c57', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:45', 140, 0, '', '2019-05-26 23:17:45');
INSERT INTO `access_log` VALUES (10645, 'fc3f39ee-cd50-406b-af29-30e557de3a83', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:45', 145, 0, '', '2019-05-26 23:17:45');
INSERT INTO `access_log` VALUES (10646, '2ff6e6dd-76b8-4a91-9b7f-42e32ab0d44f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:45', 146, 0, '', '2019-05-26 23:17:45');
INSERT INTO `access_log` VALUES (10647, '4fd0bacf-8285-41d2-bbde-bca9adae3dca', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:45', 181, 0, '', '2019-05-26 23:17:45');
INSERT INTO `access_log` VALUES (10648, 'd71069cd-c86b-418e-b6c0-b9e783c09743', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:52', 144, 0, '', '2019-05-26 23:17:53');
INSERT INTO `access_log` VALUES (10649, '8014325d-eae2-4547-8b7e-27378c250846', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:52', 145, 0, '', '2019-05-26 23:17:53');
INSERT INTO `access_log` VALUES (10650, 'edfb4174-57f1-4677-84cd-2fd26a53bade', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:52', 144, 0, '', '2019-05-26 23:17:53');
INSERT INTO `access_log` VALUES (10651, 'bf30b857-3433-46b9-a141-90f77eca7c22', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:17:53', 176, 0, '', '2019-05-26 23:17:53');
INSERT INTO `access_log` VALUES (10652, '4d1e2f6a-641c-4b1d-8b14-ff30b73acd69', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:18:27', 146, 0, '', '2019-05-26 23:18:27');
INSERT INTO `access_log` VALUES (10653, '83434b78-6165-4503-9d2e-6dde485ed8b1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:18:27', 147, 0, '', '2019-05-26 23:18:27');
INSERT INTO `access_log` VALUES (10654, '31051c01-62e6-4e3a-a975-284d85b0cad8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:18:27', 190, 0, '', '2019-05-26 23:18:27');
INSERT INTO `access_log` VALUES (10655, '378dcefa-5ed7-4334-a03d-b651d645bc46', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:18:27', 182, 0, '', '2019-05-26 23:18:27');
INSERT INTO `access_log` VALUES (10656, '62ec9582-e4f4-494e-9d2b-29c5561ca104', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:18:31', 194, 0, '', '2019-05-26 23:18:32');
INSERT INTO `access_log` VALUES (10657, '622378dd-25bb-4402-a258-d95e3177af5a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:18:31', 192, 0, '', '2019-05-26 23:18:32');
INSERT INTO `access_log` VALUES (10658, 'c40d85bc-6999-4579-b487-873e066de8e5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:18:31', 190, 0, '', '2019-05-26 23:18:32');
INSERT INTO `access_log` VALUES (10659, '44cc919d-410c-4a96-8edb-244598dc9006', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:18:32', 179, 0, '', '2019-05-26 23:18:32');
INSERT INTO `access_log` VALUES (10660, 'ba966b23-67eb-4979-b3c5-d7a8e62c22bc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:33:07', 739, 0, '', '2019-05-26 23:33:07');
INSERT INTO `access_log` VALUES (10661, '34be49f4-402f-45bf-ad47-4e582a27329e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:33:07', 682, 0, '', '2019-05-26 23:33:07');
INSERT INTO `access_log` VALUES (10662, '13149ba2-cbc7-41f0-8585-23a09f3c7620', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:33:07', 733, 0, '', '2019-05-26 23:33:07');
INSERT INTO `access_log` VALUES (10663, '180ca19d-a75c-4050-afb3-99e689eb6595', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:33:07', 682, 0, '', '2019-05-26 23:33:07');
INSERT INTO `access_log` VALUES (10664, '8ee6dfd2-dd53-4813-a52e-7ccb6b79f45a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:34:08', 535, 0, '', '2019-05-26 23:34:08');
INSERT INTO `access_log` VALUES (10665, '9fe8f92a-1a47-41d7-a679-849303df0435', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:34:08', 535, 0, '', '2019-05-26 23:34:08');
INSERT INTO `access_log` VALUES (10666, '4107620c-cd8c-4b18-b661-78649bb75d8c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:34:08', 567, 0, '', '2019-05-26 23:34:08');
INSERT INTO `access_log` VALUES (10667, 'c108e008-666c-4368-bbd4-c6dc464588be', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:34:11', 280, 0, '', '2019-05-26 23:34:11');
INSERT INTO `access_log` VALUES (10668, '8e580ae4-c127-440c-bcb2-391cfcf2ad30', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:08', 154, 0, '', '2019-05-26 23:35:08');
INSERT INTO `access_log` VALUES (10669, 'd1d6531c-951e-4aac-a95e-9e2cba00505a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:08', 158, 0, '', '2019-05-26 23:35:08');
INSERT INTO `access_log` VALUES (10670, '26fbf4f9-e8fd-40e9-98aa-50aa247675b8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:08', 158, 0, '', '2019-05-26 23:35:08');
INSERT INTO `access_log` VALUES (10671, '892584fa-6f6a-441f-8835-31adc390b59a', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:09', 227, 0, '', '2019-05-26 23:35:09');
INSERT INTO `access_log` VALUES (10672, '5d436d42-0d13-425e-a612-4550c3f445de', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:19', 158, 0, '', '2019-05-26 23:35:19');
INSERT INTO `access_log` VALUES (10673, '7d08174d-5ff6-4ff2-a3db-e07cf0b6f78f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:19', 162, 0, '', '2019-05-26 23:35:19');
INSERT INTO `access_log` VALUES (10674, 'a65f5016-c0c8-4e13-8c66-dc37c58a60cb', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:19', 153, 0, '', '2019-05-26 23:35:19');
INSERT INTO `access_log` VALUES (10675, '8b3671e3-ed47-417e-90bd-4aab51b4aa5c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:19', 350, 0, '', '2019-05-26 23:35:19');
INSERT INTO `access_log` VALUES (10676, '8d539c3f-08b1-4538-9b3e-95d8a543a4b7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:35', 152, 0, '', '2019-05-26 23:35:35');
INSERT INTO `access_log` VALUES (10677, '78c058cb-0666-4561-b07f-60572b79436a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:35', 152, 0, '', '2019-05-26 23:35:35');
INSERT INTO `access_log` VALUES (10678, 'fc45323a-7bfb-4797-8266-7acab90a4471', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:35', 150, 0, '', '2019-05-26 23:35:35');
INSERT INTO `access_log` VALUES (10679, '3669c762-ed9e-4a55-b703-101bbb76aa6e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:38', 508, 0, '', '2019-05-26 23:35:38');
INSERT INTO `access_log` VALUES (10680, '916d2c0e-926d-470d-bf66-0de180710db5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:38', 508, 0, '', '2019-05-26 23:35:38');
INSERT INTO `access_log` VALUES (10681, '9d5c0354-43a9-4ca9-8e79-0525bdbedd66', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:38', 508, 0, '', '2019-05-26 23:35:38');
INSERT INTO `access_log` VALUES (10682, '8121d657-f3e6-4d61-abc4-f90a006576e3', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:38', 252, 0, '', '2019-05-26 23:35:38');
INSERT INTO `access_log` VALUES (10683, '8c55551f-f39b-417e-a325-c6836e5baae9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:50', 144, 0, '', '2019-05-26 23:35:50');
INSERT INTO `access_log` VALUES (10684, 'c415d5e3-5dee-4d4d-8eba-538a1abb316d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:50', 150, 0, '', '2019-05-26 23:35:50');
INSERT INTO `access_log` VALUES (10685, '0ad19c59-0728-485d-8835-8c37fe9f3593', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:50', 223, 0, '', '2019-05-26 23:35:50');
INSERT INTO `access_log` VALUES (10686, 'ee456d38-26c4-4399-a0cb-7a66f3c5d192', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:50', 393, 2001001000, '服务端发生异常', '2019-05-26 23:35:51');
INSERT INTO `access_log` VALUES (10687, '6a8b2d1d-d3d8-4689-8ab1-f7858a547a5b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:52', 153, 0, '', '2019-05-26 23:35:52');
INSERT INTO `access_log` VALUES (10688, '39664856-21ea-4cf9-a73a-8d3dbdfa829a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:52', 159, 0, '', '2019-05-26 23:35:52');
INSERT INTO `access_log` VALUES (10689, '74d0504d-b6d4-4a8b-a084-6d81291182f3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:52', 156, 0, '', '2019-05-26 23:35:52');
INSERT INTO `access_log` VALUES (10690, '80ca0119-0438-41c8-a0d9-b8c6d2a6e318', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:52', 226, 0, '', '2019-05-26 23:35:52');
INSERT INTO `access_log` VALUES (10691, 'd0efb119-afe3-4e47-b8f3-0563a64e89f8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:39:13', 594, 0, '', '2019-05-26 23:39:14');
INSERT INTO `access_log` VALUES (10692, 'a95d6d7e-51dc-4f4d-a7fc-2830ee0ea2f5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:39:13', 558, 0, '', '2019-05-26 23:39:14');
INSERT INTO `access_log` VALUES (10693, '54518d3c-055c-4e3d-a961-8fd010e20624', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:39:13', 558, 0, '', '2019-05-26 23:39:14');
INSERT INTO `access_log` VALUES (10694, '1702d1eb-80c7-41f3-b45d-03a9c2e059c6', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:39:15', 254, 0, '', '2019-05-26 23:39:16');
INSERT INTO `access_log` VALUES (10695, '65.51.15588852761676337', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:41:16', 1, 1002001015, '账号未登陆', '2019-05-26 23:41:16');
INSERT INTO `access_log` VALUES (10696, '65.50.15588852761706339', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:41:16', 1, 1002001015, '账号未登陆', '2019-05-26 23:41:16');
INSERT INTO `access_log` VALUES (10697, '65.49.15588852761996341', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:41:16', 0, 1002001015, '账号未登陆', '2019-05-26 23:41:16');
INSERT INTO `access_log` VALUES (10698, '65.48.15588852863306357', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:41:26', 95, 0, '', '2019-05-26 23:41:26');
INSERT INTO `access_log` VALUES (10699, '65.46.15588852867486345', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:41:27', 11, 0, '', '2019-05-26 23:41:27');
INSERT INTO `access_log` VALUES (10700, '65.45.15588852867616353', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:41:27', 12, 0, '', '2019-05-26 23:41:27');
INSERT INTO `access_log` VALUES (10701, '65.54.15588852867606331', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:41:27', 12, 0, '', '2019-05-26 23:41:27');
INSERT INTO `access_log` VALUES (10702, '64.80.15588852984926329', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:41:38', 19, 0, '', '2019-05-26 23:41:39');
INSERT INTO `access_log` VALUES (10703, '64.83.15588852984866333', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:41:38', 27, 0, '', '2019-05-26 23:41:39');
INSERT INTO `access_log` VALUES (10704, '64.81.15588853091946331', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:41:49', 15, 0, '', '2019-05-26 23:41:49');
INSERT INTO `access_log` VALUES (10705, '64.78.15588853091996337', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:41:49', 14, 0, '', '2019-05-26 23:41:49');
INSERT INTO `access_log` VALUES (10706, '64.85.15588853091886335', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:41:49', 27, 0, '', '2019-05-26 23:41:49');
INSERT INTO `access_log` VALUES (10707, '66.50.15588853431256119', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:42:23', 195, 0, '', '2019-05-26 23:42:23');
INSERT INTO `access_log` VALUES (10708, '59.76.15588853635747087', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:42:44', 23, 0, '', '2019-05-26 23:42:44');
INSERT INTO `access_log` VALUES (10709, '59.73.15588853795927095', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:43:00', 22, 2001001000, '服务端发生异常', '2019-05-26 23:43:00');
INSERT INTO `access_log` VALUES (10710, '4816bc2a-870e-4771-8946-9333f7599195', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:43:01', 176, 0, '', '2019-05-26 23:43:02');
INSERT INTO `access_log` VALUES (10711, 'a2cf0c1f-c76d-4b6c-8221-84808c2076e0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:43:01', 192, 0, '', '2019-05-26 23:43:02');
INSERT INTO `access_log` VALUES (10712, '0aee1b07-540a-4800-afbb-df3bc8822747', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:43:01', 193, 0, '', '2019-05-26 23:43:02');
INSERT INTO `access_log` VALUES (10713, '1a8dfd28-55b7-4c8a-a682-8164ee077f80', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:43:02', 348, 0, '', '2019-05-26 23:43:02');
INSERT INTO `access_log` VALUES (10714, '59.74.15588853863027095', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:43:06', 86, 0, '', '2019-05-26 23:43:06');
INSERT INTO `access_log` VALUES (10715, '59.79.15588853966577091', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:43:17', 69, 0, '', '2019-05-26 23:43:17');
INSERT INTO `access_log` VALUES (10716, '59.78.15588854017777097', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:43:22', 12, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-26 23:43:22');
INSERT INTO `access_log` VALUES (10717, '65.54.15588854050406333', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:43:25', 22, 0, '', '2019-05-26 23:43:25');
INSERT INTO `access_log` VALUES (10718, '39909b86-3741-4fae-8490-c467de4fd61b', 1, 2, 'admin-application', '/admin-api/admins/sms/template/add', 'sign=4&platform=1&templateCode=SM_002392&template=发送模板#code#哈哈测试', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:43:32', 601, 1002006001, '短信签名不存在', '2019-05-26 23:43:32');
INSERT INTO `access_log` VALUES (10719, '65.45.15588854124376355', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:43:32', 11, 0, '', '2019-05-26 23:43:32');
INSERT INTO `access_log` VALUES (10720, '65.52.15588854147006351', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:43:35', 9, 0, '', '2019-05-26 23:43:35');
INSERT INTO `access_log` VALUES (10721, '65.53.15588854172636339', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:43:37', 14, 0, '', '2019-05-26 23:43:37');
INSERT INTO `access_log` VALUES (10722, 'b7294729-b9e7-4d5a-8d3a-33ff01eafdb1', 1, 2, 'admin-application', '/admin-api/admins/sms/template/add', 'sign=6&platform=2&templateCode=SM_0023&template=放大的阿斯蒂芬拉的说法', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:43:55', 255, 1002006001, '短信签名不存在', '2019-05-26 23:43:55');
INSERT INTO `access_log` VALUES (10723, '65.47.15588854519666351', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:44:12', 10, 0, '', '2019-05-26 23:44:12');
INSERT INTO `access_log` VALUES (10724, '65.46.15588854519776349', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:44:12', 10, 0, '', '2019-05-26 23:44:12');
INSERT INTO `access_log` VALUES (10725, '65.48.15588854519776361', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:44:12', 10, 0, '', '2019-05-26 23:44:12');
INSERT INTO `access_log` VALUES (10726, '62.89.15588854547457035', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-26 23:44:15', 23, 0, '', '2019-05-26 23:44:15');
INSERT INTO `access_log` VALUES (10727, 'a457f00b-dff4-4e03-a4bc-47a17d86f66e', 1, 2, 'admin-application', '/admin-api/admins/sms/template/add', 'sign=6&platform=1&templateCode=12311&template=2321', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:46:25', 294, 1002006001, '短信签名不存在', '2019-05-26 23:46:26');
INSERT INTO `access_log` VALUES (10728, '488c0413-f182-4a88-8c84-87b936fdaee8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:47:26', 136, 0, '', '2019-05-26 23:47:26');
INSERT INTO `access_log` VALUES (10729, '690a1bad-6972-4cdf-854b-02896dd5584a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:47:26', 189, 0, '', '2019-05-26 23:47:26');
INSERT INTO `access_log` VALUES (10730, 'f7f07fea-84f4-46e7-a93a-4f58685329ce', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:47:26', 186, 0, '', '2019-05-26 23:47:26');
INSERT INTO `access_log` VALUES (10731, '0be9b8da-bb7f-4a4f-b53f-55cc8d4a3191', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:47:26', 348, 0, '', '2019-05-26 23:47:26');
INSERT INTO `access_log` VALUES (10732, '868681db-51ea-4ffc-a9c3-71806f4d6489', 1, 2, 'admin-application', '/admin-api/admins/sms/template/add', 'sign=7&platform=1&templateCode=1231&template=23', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:47:37', 297, 1002006001, '短信签名不存在', '2019-05-26 23:47:37');
INSERT INTO `access_log` VALUES (10733, '183da779-5cde-4ce7-8152-f59e4f4a27dc', 1, 2, 'admin-application', '/admin-api/admins/sms/template/add', 'sign=444&platform=1&templateCode=23&template=123', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:48:04', 288, 1002006001, '短信签名不存在', '2019-05-26 23:48:04');
INSERT INTO `access_log` VALUES (10734, '7139eb57-6944-498a-8c26-56703ce1baf0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:48:41', 156, 0, '', '2019-05-26 23:48:41');
INSERT INTO `access_log` VALUES (10735, 'a5f11306-79ef-4961-8ea4-6eb8820ddebd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:48:42', 151, 0, '', '2019-05-26 23:48:42');
INSERT INTO `access_log` VALUES (10736, 'a0b99d01-7d3c-49ff-981e-a02c8f049878', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:48:42', 185, 0, '', '2019-05-26 23:48:42');
INSERT INTO `access_log` VALUES (10737, 'b0202ebf-a252-4bfc-bc79-ba173c1f9b35', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:48:42', 255, 0, '', '2019-05-26 23:48:42');
INSERT INTO `access_log` VALUES (10738, '3f3d81d5-f471-453a-8dd8-873e15b91ee6', 1, 2, 'admin-application', '/admin-api/admins/sms/template/add', 'smsSignId=6&platform=1&templateCode=SM_0023&template=dafa', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:48:52', 639, 2001001000, '服务端发生异常', '2019-05-26 23:48:53');
INSERT INTO `access_log` VALUES (10739, 'ec7f3b9e-b72c-4797-b10f-e445063628d1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:50:32', 183, 0, '', '2019-05-26 23:50:33');
INSERT INTO `access_log` VALUES (10740, 'c29368de-a887-4aad-9f46-8dfa39e24be0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:50:32', 182, 0, '', '2019-05-26 23:50:33');
INSERT INTO `access_log` VALUES (10741, '4910f1cd-1f20-44f0-a465-7239064fa0fc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:50:32', 184, 0, '', '2019-05-26 23:50:33');
INSERT INTO `access_log` VALUES (10742, '4b008ba9-26e5-4a9d-bbba-486fc0a18e0a', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:50:33', 229, 0, '', '2019-05-26 23:50:33');
INSERT INTO `access_log` VALUES (10743, '84faf9d2-8223-4c33-ba36-288339ce07ec', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:50:47', 131, 0, '', '2019-05-26 23:50:47');
INSERT INTO `access_log` VALUES (10744, '2c99993f-9dad-4364-9032-86c228f85788', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:50:47', 146, 0, '', '2019-05-26 23:50:47');
INSERT INTO `access_log` VALUES (10745, 'b26bdfaa-f97c-4454-9085-40fefb73f68d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:50:47', 146, 0, '', '2019-05-26 23:50:47');
INSERT INTO `access_log` VALUES (10746, '6b44e646-daa1-49e6-9822-bd32ca2c476d', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:50:47', 219, 0, '', '2019-05-26 23:50:47');
INSERT INTO `access_log` VALUES (10747, '00a86eae-1f42-4a2f-92a1-4bd5489d7550', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:50:49', 269, 0, '', '2019-05-26 23:50:50');
INSERT INTO `access_log` VALUES (10748, '50211780-5ec4-41b1-ad28-560fb2e6f76f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'enumValue=sms_type&value=1&displayName=验证码&sort=1&memo=验证码', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:51:15', 398, 0, '', '2019-05-26 23:51:15');
INSERT INTO `access_log` VALUES (10749, '044aaab9-d6e9-4b73-b3dc-742ea247e84a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:51:16', 217, 0, '', '2019-05-26 23:51:16');
INSERT INTO `access_log` VALUES (10750, '85839402-5e15-4dd3-9ee9-5de56b4f0e14', 1, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'enumValue=sms_type&value=2&displayName=通知&sort=2&memo=通知', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:51:28', 356, 0, '', '2019-05-26 23:51:29');
INSERT INTO `access_log` VALUES (10751, '72eb43cc-36fa-43dd-aff1-9727d1d2bf37', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:51:29', 318, 0, '', '2019-05-26 23:51:29');
INSERT INTO `access_log` VALUES (10752, 'b166fc03-a764-4501-b44a-3bf68405f3c6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'enumValue=sms_type&value=3&displayName=营销&sort=3&memo=营销', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:51:46', 350, 0, '', '2019-05-26 23:51:47');
INSERT INTO `access_log` VALUES (10753, '42fbf7c9-1b96-4659-aea5-2d1afbbf160c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:51:47', 220, 0, '', '2019-05-26 23:51:47');
INSERT INTO `access_log` VALUES (10754, 'f576f288-72e2-4d34-97be-3d332f30aeaa', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:52:18', 142, 0, '', '2019-05-26 23:52:19');
INSERT INTO `access_log` VALUES (10755, 'e21e92c3-97d0-4f63-93e6-e6f3ebacd584', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:52:18', 179, 0, '', '2019-05-26 23:52:19');
INSERT INTO `access_log` VALUES (10756, '09762b78-8cfa-4155-87dc-a6a7430a2b36', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:52:18', 181, 0, '', '2019-05-26 23:52:19');
INSERT INTO `access_log` VALUES (10757, '6f49a04b-dddf-4675-928a-a48d648991d4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:52:19', 431, 0, '', '2019-05-26 23:52:19');
INSERT INTO `access_log` VALUES (10758, 'f67d0593-1857-4b34-9359-37b337b94019', 0, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:52:51', 42, 1002001012, '访问令牌已过期', '2019-05-26 23:52:51');
INSERT INTO `access_log` VALUES (10759, '9bf0980d-c1bf-4998-a123-be20fae66365', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:52:53', 428, 0, '', '2019-05-26 23:52:54');
INSERT INTO `access_log` VALUES (10760, '78eb5734-c82b-4d8e-97af-12298ffb2156', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:52:54', 142, 0, '', '2019-05-26 23:52:54');
INSERT INTO `access_log` VALUES (10761, 'f2ae5233-e6db-4a81-b200-2db094c517e8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:52:54', 142, 0, '', '2019-05-26 23:52:54');
INSERT INTO `access_log` VALUES (10762, 'e685f984-128e-41a7-a9aa-d86edb1a0f9a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:52:54', 147, 0, '', '2019-05-26 23:52:54');
INSERT INTO `access_log` VALUES (10763, 'fcb0c8c9-29a1-49d1-89cd-6e03ae789522', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:52:56', 221, 0, '', '2019-05-26 23:52:56');
INSERT INTO `access_log` VALUES (10764, 'cdf3035c-ad72-4700-808b-1d57ef6ea8f1', 1, 2, 'admin-application', '/admin-api/admins/sms/template/add', 'smsSignId=6&smsType=2&platform=1&templateCode=SM_2323&template=asdfasdf', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:53:52', 621, 0, '', '2019-05-26 23:53:52');
INSERT INTO `access_log` VALUES (10765, '6e1e69d7-692f-4494-90b3-06b617a5a988', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:53:52', 220, 0, '', '2019-05-26 23:53:53');
INSERT INTO `access_log` VALUES (10766, 'c47f6cbc-c04d-4690-91d5-b3a59b84adf1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:54:50', 1869, 0, '', '2019-05-26 23:54:52');
INSERT INTO `access_log` VALUES (10767, '947363d7-687f-43bd-af5e-f832cbbce3c5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:54:50', 1869, 0, '', '2019-05-26 23:54:52');
INSERT INTO `access_log` VALUES (10768, '3946214b-6ada-47ee-988c-c88c1b566f94', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:54:50', 1869, 0, '', '2019-05-26 23:54:52');
INSERT INTO `access_log` VALUES (10769, '6fa1e642-299e-487a-b594-28ea5d9768e8', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:54:50', 3195, 0, '', '2019-05-26 23:54:53');
INSERT INTO `access_log` VALUES (10770, 'e64c6ef1-a695-417b-bd2b-d49db5089e07', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:55:45', 716, 0, '', '2019-05-26 23:55:46');
INSERT INTO `access_log` VALUES (10771, 'bbb4fcb7-5e62-4b4b-bb9e-1de9015b948f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:55:45', 739, 0, '', '2019-05-26 23:55:46');
INSERT INTO `access_log` VALUES (10772, 'fbb8e9b2-d26b-4e67-b47e-d3260870e514', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:55:45', 784, 0, '', '2019-05-26 23:55:46');
INSERT INTO `access_log` VALUES (10773, 'f702a2bd-1dd3-4737-b253-0d38e1ab1c3d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:55:45', 819, 0, '', '2019-05-26 23:55:46');
INSERT INTO `access_log` VALUES (10774, '49b46925-fe4f-4eb2-a50a-0465243b92fb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:56:36', 154, 0, '', '2019-05-26 23:56:36');
INSERT INTO `access_log` VALUES (10775, '34d74ce1-83f5-42ec-9e82-bed67d826d8f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:56:36', 161, 0, '', '2019-05-26 23:56:36');
INSERT INTO `access_log` VALUES (10776, '04f9a589-d0eb-4a4a-8a74-939c62d60c01', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:56:36', 158, 0, '', '2019-05-26 23:56:36');
INSERT INTO `access_log` VALUES (10777, '9342f1b7-eb01-4944-aa28-6809c8fc854d', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:56:36', 225, 0, '', '2019-05-26 23:56:37');
INSERT INTO `access_log` VALUES (10778, 'c2b2a1a0-6990-4365-bb8d-ef93136a2d20', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:56:43', 150, 0, '', '2019-05-26 23:56:43');
INSERT INTO `access_log` VALUES (10779, 'b20a59b2-16a9-4dd7-b2ea-4353b448d789', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:56:43', 153, 0, '', '2019-05-26 23:56:43');
INSERT INTO `access_log` VALUES (10780, '179c4259-dfc8-47b5-9391-c2d340285277', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:56:43', 152, 0, '', '2019-05-26 23:56:43');
INSERT INTO `access_log` VALUES (10781, '1c5365de-fae0-44ce-bb36-16a59836fc60', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:56:43', 224, 0, '', '2019-05-26 23:56:43');
INSERT INTO `access_log` VALUES (10782, 'cc9a4965-7ff0-455e-b6a1-542ffb223d8b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:56:49', 203, 0, '', '2019-05-26 23:56:49');
INSERT INTO `access_log` VALUES (10783, 'b9934a06-3024-44ee-abe8-fe11f3ee7242', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:56:49', 201, 0, '', '2019-05-26 23:56:49');
INSERT INTO `access_log` VALUES (10784, '2ce493a9-396a-4461-9529-682262b540dd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:56:49', 204, 0, '', '2019-05-26 23:56:49');
INSERT INTO `access_log` VALUES (10785, '77848fcf-b870-4428-9e19-5015bf476ce6', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:56:49', 233, 0, '', '2019-05-26 23:56:49');
INSERT INTO `access_log` VALUES (10786, 'f264d540-5c93-467d-8303-11e6a82bfe9b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:57:29', 152, 0, '', '2019-05-26 23:57:29');
INSERT INTO `access_log` VALUES (10787, '427eb0ce-3c95-4aae-bf23-3bba9ad3fbe8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:57:29', 150, 0, '', '2019-05-26 23:57:29');
INSERT INTO `access_log` VALUES (10788, '05b3e0f2-bb60-407c-ba95-ae861e7891b4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:57:29', 153, 0, '', '2019-05-26 23:57:29');
INSERT INTO `access_log` VALUES (10789, 'd2d63639-0c2d-477d-ab5c-0cafefc5b966', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:57:30', 222, 0, '', '2019-05-26 23:57:30');
INSERT INTO `access_log` VALUES (10790, '7e2b20bb-c289-47f0-bdc6-cd714380f5a8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:57:30', 151, 0, '', '2019-05-26 23:57:30');
INSERT INTO `access_log` VALUES (10791, 'ea20f9ff-2811-4c5e-a1f4-41c98e19bdff', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:57:30', 151, 0, '', '2019-05-26 23:57:30');
INSERT INTO `access_log` VALUES (10792, 'b354d3b1-e4c2-4c08-9de5-ab0863700045', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:57:30', 158, 0, '', '2019-05-26 23:57:30');
INSERT INTO `access_log` VALUES (10793, '12449bfb-a32d-4973-96d9-b86913cc41a9', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:57:31', 228, 0, '', '2019-05-26 23:57:31');
INSERT INTO `access_log` VALUES (10794, 'e7dd75fc-bb3b-46dc-96bf-5e12382aa35d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:57:39', 157, 0, '', '2019-05-26 23:57:40');
INSERT INTO `access_log` VALUES (10795, '0ff3b8da-33a8-4337-8d2d-72108e5ac011', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:57:39', 158, 0, '', '2019-05-26 23:57:40');
INSERT INTO `access_log` VALUES (10796, '4aded1dc-9f34-4da9-a4ed-007fd8805b35', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:57:39', 155, 0, '', '2019-05-26 23:57:40');
INSERT INTO `access_log` VALUES (10797, '05dd0701-3da7-4b63-8469-48e41b7f54eb', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:57:40', 226, 0, '', '2019-05-26 23:57:40');
INSERT INTO `access_log` VALUES (10798, '787e7367-df9e-4caf-8d4f-1dcede35b0e7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:01:04', 634, 0, '', '2019-05-27 00:01:04');
INSERT INTO `access_log` VALUES (10799, 'd5cb1818-32de-4aa2-89ee-4f0fa9fb755a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:01:04', 633, 0, '', '2019-05-27 00:01:04');
INSERT INTO `access_log` VALUES (10800, 'f608cecc-dbd5-4c3b-89b8-68d1d88d0b26', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:01:04', 630, 0, '', '2019-05-27 00:01:04');
INSERT INTO `access_log` VALUES (10801, '4ed488a9-25fd-431e-b93f-b948f1347e37', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:01:04', 669, 0, '', '2019-05-27 00:01:05');
INSERT INTO `access_log` VALUES (10802, 'f8e4855e-24d7-47d7-9321-c0619336e97f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:01:19', 222, 0, '', '2019-05-27 00:01:19');
INSERT INTO `access_log` VALUES (10803, 'a87841da-ee5b-4079-8024-02102aa3cd27', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:01:19', 217, 0, '', '2019-05-27 00:01:19');
INSERT INTO `access_log` VALUES (10804, '28164ba7-a5cd-4592-b201-6902982ff154', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:01:19', 222, 0, '', '2019-05-27 00:01:19');
INSERT INTO `access_log` VALUES (10805, '43ac634b-32c4-4b9e-9e02-6b6c6703f797', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:01:19', 222, 0, '', '2019-05-27 00:01:19');
INSERT INTO `access_log` VALUES (10806, '6a97f2c4-68da-4f9c-b872-fc0818f467fe', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:37', 179, 0, '', '2019-05-27 00:02:37');
INSERT INTO `access_log` VALUES (10807, '81ebadc8-33ab-4a44-8850-d553ebc945a5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:37', 179, 0, '', '2019-05-27 00:02:37');
INSERT INTO `access_log` VALUES (10808, 'd0115284-bc8e-4fe5-bf9f-982a0c60ffa4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:37', 217, 0, '', '2019-05-27 00:02:37');
INSERT INTO `access_log` VALUES (10809, 'c2b17199-eebf-4ec9-a1d2-01dd4f0ece13', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:37', 217, 0, '', '2019-05-27 00:02:37');
INSERT INTO `access_log` VALUES (10810, '939a93f4-12ee-4ca5-85d9-6e3da08047ae', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:42', 213, 0, '', '2019-05-27 00:02:43');
INSERT INTO `access_log` VALUES (10811, 'e3bf7c8f-92ae-4d5c-ac0d-a35a12fd1f15', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:42', 210, 0, '', '2019-05-27 00:02:43');
INSERT INTO `access_log` VALUES (10812, 'abb3872f-87a2-469d-9b8b-00e495f9c0c3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:42', 214, 0, '', '2019-05-27 00:02:43');
INSERT INTO `access_log` VALUES (10813, 'd53f4f3b-5fef-4a1c-afaa-5796fc2e87f0', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:43', 223, 0, '', '2019-05-27 00:02:43');
INSERT INTO `access_log` VALUES (10814, '983e25fd-b27a-4f1f-bd11-7a4c3c8507a3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:53', 151, 0, '', '2019-05-27 00:02:53');
INSERT INTO `access_log` VALUES (10815, '39ca3220-6322-41e4-9ad5-e86cf34cfb93', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:53', 151, 0, '', '2019-05-27 00:02:53');
INSERT INTO `access_log` VALUES (10816, '3dd492a1-823c-4d1b-b8d5-a822ce626dfe', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:53', 149, 0, '', '2019-05-27 00:02:53');
INSERT INTO `access_log` VALUES (10817, '6bf8d066-e18b-41bd-8bca-18fc60dcffaa', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:53', 220, 0, '', '2019-05-27 00:02:53');
INSERT INTO `access_log` VALUES (10818, '1318a6e9-9226-406a-838e-bedcb846cea7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:55', 150, 0, '', '2019-05-27 00:02:55');
INSERT INTO `access_log` VALUES (10819, 'd4f70e5e-e718-49b1-ae31-07dca25cacf4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:55', 151, 0, '', '2019-05-27 00:02:55');
INSERT INTO `access_log` VALUES (10820, '46b5a10d-f6cb-43b5-85e7-1b4e5f2d096e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:55', 153, 0, '', '2019-05-27 00:02:55');
INSERT INTO `access_log` VALUES (10821, '05c0bada-e6c0-456b-84e3-30409bccca95', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:55', 220, 0, '', '2019-05-27 00:02:55');
INSERT INTO `access_log` VALUES (10822, '009cbc4e-a0dd-4b46-8169-9be4cd303f11', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:59', 146, 0, '', '2019-05-27 00:03:00');
INSERT INTO `access_log` VALUES (10823, '56b44e28-ddc7-4ebb-9028-02bc1918f13d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:59', 142, 0, '', '2019-05-27 00:03:00');
INSERT INTO `access_log` VALUES (10824, 'ea194378-877c-4cc6-b308-60f131cfea9c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:02:59', 148, 0, '', '2019-05-27 00:03:00');
INSERT INTO `access_log` VALUES (10825, 'a0160e6a-1522-4e32-9a2f-faddff8a01d1', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:03:00', 216, 0, '', '2019-05-27 00:03:00');
INSERT INTO `access_log` VALUES (10826, '891b525e-4a79-44dd-9ea3-af468289c062', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:06', 179, 0, '', '2019-05-27 00:05:06');
INSERT INTO `access_log` VALUES (10827, '62b836eb-6dda-49fd-8e4e-c4ca4323bdab', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:06', 181, 0, '', '2019-05-27 00:05:06');
INSERT INTO `access_log` VALUES (10828, '6f2de95d-f862-4534-b391-e89d64943b86', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:06', 178, 0, '', '2019-05-27 00:05:06');
INSERT INTO `access_log` VALUES (10829, 'b387691f-6ebe-4eda-8e84-42d535ef089c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:06', 259, 0, '', '2019-05-27 00:05:06');
INSERT INTO `access_log` VALUES (10830, '5320383a-e5ea-427d-a1f1-d175879d7759', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:07', 154, 0, '', '2019-05-27 00:05:07');
INSERT INTO `access_log` VALUES (10831, 'dd6846ba-411c-4a7a-8b11-9cf06e125e1b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:07', 147, 0, '', '2019-05-27 00:05:07');
INSERT INTO `access_log` VALUES (10832, 'd8e54647-1f30-40da-8de6-c3fbc8220ae0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:07', 151, 0, '', '2019-05-27 00:05:07');
INSERT INTO `access_log` VALUES (10833, '569472d0-d913-4d87-837f-3b2585091a7a', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:08', 223, 0, '', '2019-05-27 00:05:09');
INSERT INTO `access_log` VALUES (10834, '7bbb8f1c-22aa-4f16-9a83-6a67ec27815e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:09', 144, 0, '', '2019-05-27 00:05:09');
INSERT INTO `access_log` VALUES (10835, 'e1146184-deaf-4cea-a718-eb1e782365d3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:09', 152, 0, '', '2019-05-27 00:05:09');
INSERT INTO `access_log` VALUES (10836, '4336ef63-b3c1-4f0a-94ef-1a3af90a0a48', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:09', 180, 0, '', '2019-05-27 00:05:09');
INSERT INTO `access_log` VALUES (10837, 'e1d19b3c-76c7-42ca-9e8b-7c1a3528e6af', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:09', 247, 0, '', '2019-05-27 00:05:09');
INSERT INTO `access_log` VALUES (10838, '04e2e71e-187b-4a78-a10b-ace0deb85b79', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:13', 145, 0, '', '2019-05-27 00:05:13');
INSERT INTO `access_log` VALUES (10839, '096f4f2b-5f2f-439a-bb9a-de8910b02cc5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:13', 148, 0, '', '2019-05-27 00:05:13');
INSERT INTO `access_log` VALUES (10840, 'be517e30-e741-4820-b442-5a8737a901f2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:13', 144, 0, '', '2019-05-27 00:05:13');
INSERT INTO `access_log` VALUES (10841, '02bc020f-4886-4529-b5f0-0dcadce6d98b', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:13', 220, 0, '', '2019-05-27 00:05:13');
INSERT INTO `access_log` VALUES (10842, 'cc5bcf11-824a-4881-a943-b364fe5546d2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:32', 144, 0, '', '2019-05-27 00:05:32');
INSERT INTO `access_log` VALUES (10843, 'be33bea1-4026-459e-bce5-ddf605f574c9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:32', 148, 0, '', '2019-05-27 00:05:32');
INSERT INTO `access_log` VALUES (10844, '097909f3-ca4a-4659-9d78-75febfab7b8c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:32', 147, 0, '', '2019-05-27 00:05:32');
INSERT INTO `access_log` VALUES (10845, '31e0b9e8-9949-4e53-b00b-b9f0de32f69c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:32', 364, 0, '', '2019-05-27 00:05:32');
INSERT INTO `access_log` VALUES (10846, 'f4ad1529-3841-4c74-92c8-8454ecf11cf4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:58', 144, 0, '', '2019-05-27 00:05:59');
INSERT INTO `access_log` VALUES (10847, '4496a618-daa3-4c50-aa86-de4e05390cf0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:58', 146, 0, '', '2019-05-27 00:05:59');
INSERT INTO `access_log` VALUES (10848, '44cac655-c2d6-44f1-8578-09d618168fc3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:58', 141, 0, '', '2019-05-27 00:05:59');
INSERT INTO `access_log` VALUES (10849, '3a69d662-a638-4750-9e3a-b87eee737a6d', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:05:59', 271, 0, '', '2019-05-27 00:05:59');
INSERT INTO `access_log` VALUES (10850, '1598d021-6fb4-45c3-89c0-44ed3dfd5684', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:00', 382, 0, '', '2019-05-27 00:06:00');
INSERT INTO `access_log` VALUES (10851, '1d36a5aa-ad1b-40e9-96c8-88e75f433293', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:00', 379, 0, '', '2019-05-27 00:06:00');
INSERT INTO `access_log` VALUES (10852, '7c6a5f55-efb7-4d66-8e21-ac668efb4129', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:00', 391, 0, '', '2019-05-27 00:06:00');
INSERT INTO `access_log` VALUES (10853, '23cbb9c2-397c-44ec-bc96-2409b1adaae1', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:00', 345, 0, '', '2019-05-27 00:06:00');
INSERT INTO `access_log` VALUES (10854, '1928f7ad-b0d4-4b34-a489-de459ededa93', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:34', 145, 0, '', '2019-05-27 00:06:34');
INSERT INTO `access_log` VALUES (10855, '85c0a144-81ad-45c6-9686-a9fe51f4dd86', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:34', 143, 0, '', '2019-05-27 00:06:34');
INSERT INTO `access_log` VALUES (10856, '1f3e2128-2739-4ffe-9eec-7812fec4dec2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:34', 148, 0, '', '2019-05-27 00:06:34');
INSERT INTO `access_log` VALUES (10857, 'eae8da51-ada2-46ba-8cf0-5e39604c8eb2', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:34', 218, 0, '', '2019-05-27 00:06:35');
INSERT INTO `access_log` VALUES (10858, '6c00b1a8-2b32-41a8-9934-fd1cd60b6c21', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:36', 250, 0, '', '2019-05-27 00:06:36');
INSERT INTO `access_log` VALUES (10859, 'b927b129-50ba-4e97-8b25-41295fa4c251', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:36', 246, 0, '', '2019-05-27 00:06:36');
INSERT INTO `access_log` VALUES (10860, '36519294-6b3d-4821-bf6d-f719f055398a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:36', 324, 0, '', '2019-05-27 00:06:36');
INSERT INTO `access_log` VALUES (10861, 'dc9bcf27-6179-4e25-8f63-aee5a55e00a1', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:36', 223, 0, '', '2019-05-27 00:06:36');
INSERT INTO `access_log` VALUES (10862, 'b19d2f71-90a8-4121-8ff5-68700ed505e9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:38', 152, 0, '', '2019-05-27 00:06:38');
INSERT INTO `access_log` VALUES (10863, '119dd188-f020-4edc-8aa8-957038fa7efd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:38', 147, 0, '', '2019-05-27 00:06:38');
INSERT INTO `access_log` VALUES (10864, '246af5c8-c9f9-4679-9e01-9e26fa487ec6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:38', 151, 0, '', '2019-05-27 00:06:38');
INSERT INTO `access_log` VALUES (10865, '2def0000-6045-49c0-a26a-6d951d210af0', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:38', 217, 0, '', '2019-05-27 00:06:38');
INSERT INTO `access_log` VALUES (10866, 'b76c7d04-c48c-44a1-9e36-1b2e26c07929', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:47', 152, 0, '', '2019-05-27 00:06:48');
INSERT INTO `access_log` VALUES (10867, '743fe86e-e9ed-4f6c-ad28-2b9fac3f4736', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:47', 149, 0, '', '2019-05-27 00:06:48');
INSERT INTO `access_log` VALUES (10868, '56457545-ae2e-4b6e-87b7-5be394388c0b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:47', 152, 0, '', '2019-05-27 00:06:48');
INSERT INTO `access_log` VALUES (10869, '95e41517-e80e-4aeb-9550-2a37ade7677f', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:48', 221, 0, '', '2019-05-27 00:06:48');
INSERT INTO `access_log` VALUES (10870, 'ff10388f-c1f1-443f-b328-5aa832a7438b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:06:54', 199, 0, '', '2019-05-27 00:06:55');
INSERT INTO `access_log` VALUES (10871, '202aece5-efa7-472c-92ef-eadd42814d0b', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:07:02', 241, 0, '', '2019-05-27 00:07:02');
INSERT INTO `access_log` VALUES (10872, '533e1209-fc1e-4399-931b-40d29667ce49', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:07:32', 147, 0, '', '2019-05-27 00:07:32');
INSERT INTO `access_log` VALUES (10873, '6657ef9a-76ef-4149-a964-43d2f6749f92', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:07:32', 146, 0, '', '2019-05-27 00:07:32');
INSERT INTO `access_log` VALUES (10874, '0dc067a1-7483-4a21-980c-26c934db79e1', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:07:32', 217, 0, '', '2019-05-27 00:07:32');
INSERT INTO `access_log` VALUES (10875, '375a9124-b263-4c3b-99af-ad822c1d4d02', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:07:32', 316, 2001001000, '服务端发生异常', '2019-05-27 00:07:32');
INSERT INTO `access_log` VALUES (10876, '5e316c82-bf55-4146-8f9f-62d87a5d3f04', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:07:33', 150, 0, '', '2019-05-27 00:07:34');
INSERT INTO `access_log` VALUES (10877, 'c4b958c6-d22a-4e64-ac1e-3f8e331f6a70', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:07:33', 145, 0, '', '2019-05-27 00:07:34');
INSERT INTO `access_log` VALUES (10878, '53d31fb5-0a99-4b72-9ddc-bd737b6a09d2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:07:33', 149, 0, '', '2019-05-27 00:07:34');
INSERT INTO `access_log` VALUES (10879, '48e0716d-3b0d-4c2f-add4-edc4954b5abb', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:07:34', 217, 0, '', '2019-05-27 00:07:34');
INSERT INTO `access_log` VALUES (10880, 'c37ee685-c5d4-4a64-b095-f3b861e92e69', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:01', 144, 0, '', '2019-05-27 00:08:01');
INSERT INTO `access_log` VALUES (10881, 'cdd4eb00-c1a7-44ea-bbde-29e76a568757', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:01', 143, 0, '', '2019-05-27 00:08:01');
INSERT INTO `access_log` VALUES (10882, '41dad5e0-7ea0-46c6-b1ff-3ae28bf2e961', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:01', 145, 0, '', '2019-05-27 00:08:01');
INSERT INTO `access_log` VALUES (10883, '51ae9733-165d-462b-b7e8-c0d4a5e81324', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:01', 629, 0, '', '2019-05-27 00:08:02');
INSERT INTO `access_log` VALUES (10884, '0eed0b08-db56-4dfb-b23f-488f58c2a315', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:09', 147, 0, '', '2019-05-27 00:08:09');
INSERT INTO `access_log` VALUES (10885, '75918aa5-dfbf-4148-8a38-e847da52f009', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:09', 149, 0, '', '2019-05-27 00:08:09');
INSERT INTO `access_log` VALUES (10886, '0eb8ec29-0229-4fa2-b555-3f40a1117871', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:09', 148, 0, '', '2019-05-27 00:08:09');
INSERT INTO `access_log` VALUES (10887, '4d6453a9-d846-4061-a849-94a56f86f703', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:09', 220, 0, '', '2019-05-27 00:08:09');
INSERT INTO `access_log` VALUES (10888, 'ac6acb7d-3760-4b76-8130-60df842ab1e7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:25', 152, 0, '', '2019-05-27 00:08:26');
INSERT INTO `access_log` VALUES (10889, '54422b6d-12b1-482e-845c-44b8b2781252', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:25', 153, 0, '', '2019-05-27 00:08:26');
INSERT INTO `access_log` VALUES (10890, 'c34a86b5-aeed-4849-b731-29cf2c340d1b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:25', 151, 0, '', '2019-05-27 00:08:26');
INSERT INTO `access_log` VALUES (10891, 'fe97ac6c-c278-40c1-af98-024d544790db', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:25', 226, 0, '', '2019-05-27 00:08:26');
INSERT INTO `access_log` VALUES (10892, '580918b5-8ba4-4839-892a-e0b76a409633', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:31', 145, 0, '', '2019-05-27 00:08:31');
INSERT INTO `access_log` VALUES (10893, '95c7530f-8421-4720-97dc-331c41216adb', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:31', 148, 0, '', '2019-05-27 00:08:31');
INSERT INTO `access_log` VALUES (10894, '14812ec1-8d81-42ba-a6ea-e338eda7e890', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:31', 146, 0, '', '2019-05-27 00:08:31');
INSERT INTO `access_log` VALUES (10895, '4e8c3ec2-8472-4e4a-9c08-325eca33b8a0', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:31', 218, 0, '', '2019-05-27 00:08:31');
INSERT INTO `access_log` VALUES (10896, '421229c2-1114-412e-8d1d-e4ed09c5a71c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:45', 164, 0, '', '2019-05-27 00:08:45');
INSERT INTO `access_log` VALUES (10897, '80f295fa-18cd-4f41-a202-55a0a6a95d43', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:45', 162, 0, '', '2019-05-27 00:08:45');
INSERT INTO `access_log` VALUES (10898, '79cd63dd-1807-45d6-8d74-679d83139b96', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:45', 165, 0, '', '2019-05-27 00:08:45');
INSERT INTO `access_log` VALUES (10899, '232a7d0a-276b-4941-ac94-d3338fdbb076', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:08:45', 222, 0, '', '2019-05-27 00:08:45');
INSERT INTO `access_log` VALUES (10900, '960adac0-0983-49fe-9d87-53002f777abe', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:10', 145, 0, '', '2019-05-27 00:09:10');
INSERT INTO `access_log` VALUES (10901, '996e61b9-ed71-464c-8314-cfecf82a075b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:10', 146, 0, '', '2019-05-27 00:09:10');
INSERT INTO `access_log` VALUES (10902, '4be1c344-3326-4819-8d8c-fa7b5971e74e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:10', 144, 0, '', '2019-05-27 00:09:10');
INSERT INTO `access_log` VALUES (10903, 'd18516f4-02f4-45d5-a277-c0c31653a94b', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:10', 212, 0, '', '2019-05-27 00:09:10');
INSERT INTO `access_log` VALUES (10904, '5a8615db-1d8f-478d-bf2e-49eee572263d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:17', 143, 0, '', '2019-05-27 00:09:17');
INSERT INTO `access_log` VALUES (10905, '453c8e57-bf2a-4c52-a6dc-71e582411552', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:17', 144, 0, '', '2019-05-27 00:09:17');
INSERT INTO `access_log` VALUES (10906, '59cdb13c-cfa7-4a56-87a6-c8d0365d07af', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:17', 141, 0, '', '2019-05-27 00:09:17');
INSERT INTO `access_log` VALUES (10907, '70c4c9d2-190d-44a5-b7d3-32cbff9a9816', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:17', 223, 0, '', '2019-05-27 00:09:17');
INSERT INTO `access_log` VALUES (10908, 'c9d03c54-095b-4c64-ad0f-43dcc437403b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:31', 229, 0, '', '2019-05-27 00:09:31');
INSERT INTO `access_log` VALUES (10909, '388c461e-3afd-4fe9-8376-31ff7b8ba57f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:31', 228, 0, '', '2019-05-27 00:09:31');
INSERT INTO `access_log` VALUES (10910, '3ce16cc7-c854-4b88-8192-cb44332eec01', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:31', 231, 0, '', '2019-05-27 00:09:31');
INSERT INTO `access_log` VALUES (10911, '594fdece-c67c-44b8-ad78-e4ef0c12ca06', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:31', 237, 0, '', '2019-05-27 00:09:31');
INSERT INTO `access_log` VALUES (10912, '9e29de17-6052-460e-ba24-e111ca393223', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:33', 145, 0, '', '2019-05-27 00:09:33');
INSERT INTO `access_log` VALUES (10913, '40faa6ac-85b4-4ee1-ac61-e331ea943d8e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:33', 144, 0, '', '2019-05-27 00:09:33');
INSERT INTO `access_log` VALUES (10914, '7ef119f1-3d78-401f-8c72-4f3638b3386e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:33', 143, 0, '', '2019-05-27 00:09:33');
INSERT INTO `access_log` VALUES (10915, '0bfd7235-2afc-4235-ad9a-678f44ec9e8c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:33', 222, 0, '', '2019-05-27 00:09:34');
INSERT INTO `access_log` VALUES (10916, '1a24837e-aad1-44c9-b3b2-c03865a3c3e8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:53', 171, 0, '', '2019-05-27 00:09:53');
INSERT INTO `access_log` VALUES (10917, 'b161f83c-4707-4640-97f4-0f6199016b68', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:53', 173, 0, '', '2019-05-27 00:09:53');
INSERT INTO `access_log` VALUES (10918, '651f094c-fa2b-4963-ab78-9038c10b18fa', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:53', 167, 0, '', '2019-05-27 00:09:53');
INSERT INTO `access_log` VALUES (10919, '319b93c1-5e9a-4d30-9be3-833ff87b62b5', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:53', 230, 0, '', '2019-05-27 00:09:53');
INSERT INTO `access_log` VALUES (10920, '92073747-02d1-485d-9af4-38646f15d2f2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:54', 155, 0, '', '2019-05-27 00:09:55');
INSERT INTO `access_log` VALUES (10921, '99a423a9-8469-408b-8473-d9e664bca002', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:54', 159, 0, '', '2019-05-27 00:09:55');
INSERT INTO `access_log` VALUES (10922, '827d3baa-dcca-4752-aace-283928f5d9f2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:54', 162, 0, '', '2019-05-27 00:09:55');
INSERT INTO `access_log` VALUES (10923, '3c22ccaa-70a9-41dd-8a42-fa93a6e672b0', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:55', 223, 0, '', '2019-05-27 00:09:55');
INSERT INTO `access_log` VALUES (10924, 'a08c85d5-ce09-4a26-b952-ad154a2f295c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:58', 159, 0, '', '2019-05-27 00:09:58');
INSERT INTO `access_log` VALUES (10925, '85964f11-c46d-4ebd-83cf-9d6a0a14fa76', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:58', 157, 0, '', '2019-05-27 00:09:58');
INSERT INTO `access_log` VALUES (10926, 'ef80e139-775e-4b26-ac21-ef43cd89d65d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:58', 159, 0, '', '2019-05-27 00:09:58');
INSERT INTO `access_log` VALUES (10927, '4bfc2058-a39b-4ad2-805f-6f58f8d705c5', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:09:58', 229, 0, '', '2019-05-27 00:09:58');
INSERT INTO `access_log` VALUES (10928, '34fe447b-1d95-43e4-9e9b-5d83e6eafe4c', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:10:22', 209, 0, '', '2019-05-27 00:10:22');
INSERT INTO `access_log` VALUES (10929, '1b254997-1922-4cb7-a379-a665620a61ec', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:10:27', 229, 0, '', '2019-05-27 00:10:27');
INSERT INTO `access_log` VALUES (10930, '9ce4dd2f-5f5e-491a-850a-29e58e0eea7e', 1, 2, 'admin-application', '/admin-api/admins/sms/template/update', 'id=8&smsSignId=7&smsType=2&platform=1&templateCode=SM_2323&template=短信模板#code#测试啊！', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:10:51', 490, 0, '', '2019-05-27 00:10:52');
INSERT INTO `access_log` VALUES (10931, '957f362d-f458-4a16-b975-bc5398d2c0ed', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:10:52', 222, 0, '', '2019-05-27 00:10:52');
INSERT INTO `access_log` VALUES (10932, '3b7c068f-c38b-48a9-bb89-a7fa9f2fc3fb', 1, 2, 'admin-application', '/admin-api/admins/sms/template/update', 'id=8&smsSignId=6&smsType=2&platform=1&templateCode=SM_2323&template=短信模板#code#测试，不要', 'PUT', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:11:18', 491, 0, '', '2019-05-27 00:11:18');
INSERT INTO `access_log` VALUES (10933, 'd3e6cb99-9584-4722-be6e-241d4223b0d9', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:11:18', 220, 0, '', '2019-05-27 00:11:19');
INSERT INTO `access_log` VALUES (10934, '318f9bc1-ed1f-46af-9f4e-c20c9ae26fc0', 1, 2, 'admin-application', '/admin-api/admins/sms/template/deleted', 'id=8', 'DELETE', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:11:27', 472, 0, '', '2019-05-27 00:11:27');
INSERT INTO `access_log` VALUES (10935, '4dda2c38-2940-42b1-8d9f-11f5fadde155', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:11:27', 221, 0, '', '2019-05-27 00:11:27');
INSERT INTO `access_log` VALUES (10936, 'a37bdd03-8383-4f44-98a3-0bc6053a0902', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&sign=sign', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:11:41', 379, 0, '', '2019-05-27 00:11:41');
INSERT INTO `access_log` VALUES (10937, 'f2b152b6-ffb1-4a54-acee-35794e39e54c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&sign=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:12:37', 277, 0, '', '2019-05-27 00:12:37');
INSERT INTO `access_log` VALUES (10938, '6972f951-274d-468e-b10d-e4e7158b4019', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&sign=7', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:12:41', 329, 0, '', '2019-05-27 00:12:41');
INSERT INTO `access_log` VALUES (10939, '96bb05f6-189e-4bfb-bb87-98fd510705d6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:12:52', 322, 0, '', '2019-05-27 00:12:52');
INSERT INTO `access_log` VALUES (10940, '392b9d2d-aedc-4e9a-849f-821f0125059e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:12:52', 361, 0, '', '2019-05-27 00:12:52');
INSERT INTO `access_log` VALUES (10941, 'f8398f48-b22f-487a-9ddd-f271b3af4604', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:12:52', 357, 0, '', '2019-05-27 00:12:52');
INSERT INTO `access_log` VALUES (10942, '8d7012d5-296f-47c9-ae84-6e0d725a2fef', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:12:52', 350, 0, '', '2019-05-27 00:12:53');
INSERT INTO `access_log` VALUES (10943, '36b6d2b5-0443-424d-b073-8f8743d3b1ef', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:12:55', 421, 2001001000, '服务端发生异常', '2019-05-27 00:12:56');
INSERT INTO `access_log` VALUES (10944, '6f262756-5c86-4940-9820-7a7996f164a2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:12:59', 157, 0, '', '2019-05-27 00:12:59');
INSERT INTO `access_log` VALUES (10945, 'a18ed1c9-2370-4dbd-a24f-fc229b7b4ea6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:12:59', 151, 0, '', '2019-05-27 00:12:59');
INSERT INTO `access_log` VALUES (10946, '9adbbc16-357b-4800-a5f4-6d127cccd07e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:12:59', 154, 0, '', '2019-05-27 00:12:59');
INSERT INTO `access_log` VALUES (10947, '8be307d1-feaa-4e95-aed1-7b231fed956e', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:12:59', 217, 0, '', '2019-05-27 00:13:00');
INSERT INTO `access_log` VALUES (10948, '5a0b6566-dad9-4fd1-9750-9cd02fb25867', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:13:03', 271, 0, '', '2019-05-27 00:13:03');
INSERT INTO `access_log` VALUES (10949, '3e130805-720f-40e5-adff-cd8a1250227c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:13:05', 320, 2001001000, '服务端发生异常', '2019-05-27 00:13:05');
INSERT INTO `access_log` VALUES (10950, '5c09363f-0089-468c-ac0e-71ed3854e793', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:13:06', 402, 2001001000, '服务端发生异常', '2019-05-27 00:13:07');
INSERT INTO `access_log` VALUES (10951, '983124d7-fa45-4c84-8865-1618910b32c2', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:13:08', 685, 2001001000, '服务端发生异常', '2019-05-27 00:13:08');
INSERT INTO `access_log` VALUES (10952, '6cd6cdd1-5556-4606-93c6-cd3f0e00ff3b', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:13:09', 438, 2001001000, '服务端发生异常', '2019-05-27 00:13:10');
INSERT INTO `access_log` VALUES (10953, 'c5453cb0-df15-4116-ab18-001c11d01c39', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:14:25', 216, 0, '', '2019-05-27 00:14:25');
INSERT INTO `access_log` VALUES (10954, '2bb548d2-be52-4e5b-81fc-a6e2fd754197', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:14:25', 223, 0, '', '2019-05-27 00:14:25');
INSERT INTO `access_log` VALUES (10955, '796fe38c-420e-4126-9fc2-4f5de3cd4aef', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:14:25', 221, 0, '', '2019-05-27 00:14:25');
INSERT INTO `access_log` VALUES (10956, '1cd67ab0-7ca5-42f6-82e1-0109fbfffd92', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:14:25', 368, 0, '', '2019-05-27 00:14:25');
INSERT INTO `access_log` VALUES (10957, '65.45.15588872714066381', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-27 00:14:31', 27, 0, '', '2019-05-27 00:14:31');
INSERT INTO `access_log` VALUES (10958, '3921a7b5-6b8f-466e-aaac-7c4c8fe36fba', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=4', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:14:31', 219, 0, '', '2019-05-27 00:14:31');
INSERT INTO `access_log` VALUES (10959, '65.52.15588872717456377', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-27 00:14:32', 13, 0, '', '2019-05-27 00:14:32');
INSERT INTO `access_log` VALUES (10960, '65.53.15588872721666365', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-27 00:14:32', 19, 0, '', '2019-05-27 00:14:32');
INSERT INTO `access_log` VALUES (10961, '59.73.15588872728207121', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-27 00:14:33', 21, 2001001000, '服务端发生异常', '2019-05-27 00:14:33');
INSERT INTO `access_log` VALUES (10962, '59.72.15588872730457115', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-27 00:14:33', 21, 0, '', '2019-05-27 00:14:33');
INSERT INTO `access_log` VALUES (10963, '66.56.15588872732326145', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.123.254.3', '2019-05-27 00:14:33', 24, 0, '', '2019-05-27 00:14:33');
INSERT INTO `access_log` VALUES (10964, '92c643e7-bd05-46e5-ae99-30e6c3ad233a', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:14:35', 1005, 2001001000, '服务端发生异常', '2019-05-27 00:14:36');
INSERT INTO `access_log` VALUES (10965, 'e383604b-1996-47c6-a37e-dc7fd67e8134', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:14:58', 502, 2001001000, '服务端发生异常', '2019-05-27 00:14:59');
INSERT INTO `access_log` VALUES (10966, '9113fef7-facd-47fc-ad6a-233ae5060d19', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:15:09', 633, 2001001000, '服务端发生异常', '2019-05-27 00:15:10');
INSERT INTO `access_log` VALUES (10967, 'bca3a071-27b8-41b8-a58a-e70c05c69f48', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:15:38', 440, 0, '', '2019-05-27 00:15:38');
INSERT INTO `access_log` VALUES (10968, '866f8a57-3b88-49e8-b9f2-b41119be6147', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:16:29', 1093, 0, '', '2019-05-27 00:16:30');
INSERT INTO `access_log` VALUES (10969, '64bc46a5-a153-4f8e-9cbf-f41dd999fe2f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:16:29', 1083, 0, '', '2019-05-27 00:16:30');
INSERT INTO `access_log` VALUES (10970, 'e2ce4f0e-3663-4d6b-a6cb-2f636beae88e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:16:29', 1083, 0, '', '2019-05-27 00:16:30');
INSERT INTO `access_log` VALUES (10971, '0d88d84a-7613-44b3-a917-297bbe14ac19', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:16:29', 1139, 0, '', '2019-05-27 00:16:30');
INSERT INTO `access_log` VALUES (10972, '6b187891-76de-4f85-845f-a80db6afd52e', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:16:33', 159, 0, '', '2019-05-27 00:16:33');
INSERT INTO `access_log` VALUES (10973, 'dc977d14-d143-4334-a94e-0469dd696f85', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:16:37', 160, 0, '', '2019-05-27 00:16:37');
INSERT INTO `access_log` VALUES (10974, '262328f7-ebd1-4cae-b001-a3ff4afa86eb', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=4', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:16:40', 233, 0, '', '2019-05-27 00:16:40');
INSERT INTO `access_log` VALUES (10975, '6e74ffcb-0ce6-4760-89ec-a55c1d6cc7c1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:17:19', 154, 0, '', '2019-05-27 00:17:20');
INSERT INTO `access_log` VALUES (10976, '5c045d87-36e7-4462-bfcf-af7f76ca2336', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:17:19', 153, 0, '', '2019-05-27 00:17:20');
INSERT INTO `access_log` VALUES (10977, '21ab9cb0-94fc-4cce-8c56-43fed2c9b82a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:17:19', 155, 0, '', '2019-05-27 00:17:20');
INSERT INTO `access_log` VALUES (10978, 'fb7fae49-7e82-4657-90fc-be3e25d0c07a', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:17:20', 718, 0, '', '2019-05-27 00:17:20');
INSERT INTO `access_log` VALUES (10979, '3bf3f692-d0e8-483d-9db8-08cfca6c3c28', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:17:56', 178, 0, '', '2019-05-27 00:17:56');
INSERT INTO `access_log` VALUES (10980, '2764ef87-26c7-4633-97c3-d561fd161ebc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:17:56', 183, 0, '', '2019-05-27 00:17:56');
INSERT INTO `access_log` VALUES (10981, 'f263217d-e19f-4af3-8665-ec1bf596c910', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:17:56', 186, 0, '', '2019-05-27 00:17:56');
INSERT INTO `access_log` VALUES (10982, '1375e96b-5d9a-49eb-a43d-d8bb3ba61e6f', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:17:56', 221, 0, '', '2019-05-27 00:17:56');
INSERT INTO `access_log` VALUES (10983, 'a204dfa6-6b7f-4f13-b2af-755b6bda240e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:18:09', 147, 0, '', '2019-05-27 00:18:09');
INSERT INTO `access_log` VALUES (10984, 'a95524d0-4b8b-43d0-8ad9-a98b25bf3ddf', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:18:09', 145, 0, '', '2019-05-27 00:18:09');
INSERT INTO `access_log` VALUES (10985, '1857b56e-2a41-4980-9d24-0ef2ba0db95d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:18:09', 147, 0, '', '2019-05-27 00:18:10');
INSERT INTO `access_log` VALUES (10986, '9d7b9efa-cc17-4ea8-a63e-777c2553e9e3', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:18:09', 199, 0, '', '2019-05-27 00:18:10');
INSERT INTO `access_log` VALUES (10987, '5a576ef1-ace1-4811-a28f-577d87b4311b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:18:56', 386, 0, '', '2019-05-27 00:18:57');
INSERT INTO `access_log` VALUES (10988, 'a1b09149-504a-4b86-85ce-0adbab62fd78', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:18:57', 386, 0, '', '2019-05-27 00:18:57');
INSERT INTO `access_log` VALUES (10989, '842cf546-e42f-458e-bce2-b470ea6f8173', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:18:57', 384, 0, '', '2019-05-27 00:18:57');
INSERT INTO `access_log` VALUES (10990, '72d96857-4cb0-4141-957d-76a8a73ca705', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:18:57', 359, 0, '', '2019-05-27 00:18:57');
INSERT INTO `access_log` VALUES (10991, '552a681e-7db0-4db2-beee-99ce1b75fceb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:19:01', 143, 0, '', '2019-05-27 00:19:01');
INSERT INTO `access_log` VALUES (10992, '84bf4c59-6d01-41db-9c8f-30f848defa63', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:19:01', 153, 0, '', '2019-05-27 00:19:01');
INSERT INTO `access_log` VALUES (10993, 'e21d9c38-af09-4575-b04f-5ee714815656', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:19:01', 150, 0, '', '2019-05-27 00:19:01');
INSERT INTO `access_log` VALUES (10994, '5fddba94-4dd1-4c70-abca-5ceaa0be5dbf', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:19:01', 224, 0, '', '2019-05-27 00:19:02');
INSERT INTO `access_log` VALUES (10995, 'a141ffa0-6cba-4a50-9024-d67fa96a11f0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:19:47', 151, 0, '', '2019-05-27 00:19:48');
INSERT INTO `access_log` VALUES (10996, 'a7430256-565e-4e81-8738-e2e97c407cb2', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:19:48', 400, 0, '', '2019-05-27 00:19:48');
INSERT INTO `access_log` VALUES (10997, '0d23053f-0260-4616-a777-ebca4fe65e3d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:19:47', 566, 0, '', '2019-05-27 00:19:48');
INSERT INTO `access_log` VALUES (10998, 'c953ff2d-469d-4572-91c5-dbaea4bd86a4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:19:47', 802, 2001001000, '服务端发生异常', '2019-05-27 00:19:48');
INSERT INTO `access_log` VALUES (10999, 'bb7af500-34e1-4dfd-a89c-5584c6a43d68', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:19:49', 140, 0, '', '2019-05-27 00:19:49');
INSERT INTO `access_log` VALUES (11000, '0ce64ba4-42e3-45d3-b9eb-b9505cb43225', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:19:49', 155, 0, '', '2019-05-27 00:19:49');
INSERT INTO `access_log` VALUES (11001, '8dd9a167-eec5-4601-9bca-2a4fdddeaba7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:19:49', 149, 0, '', '2019-05-27 00:19:49');
INSERT INTO `access_log` VALUES (11002, '982b0fd3-536d-4e7f-a154-a01554986f5f', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:19:49', 227, 0, '', '2019-05-27 00:19:49');
INSERT INTO `access_log` VALUES (11003, '7815937d-db44-41e2-8c47-ccd744a5da2f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:20:14', 1964, 0, '', '2019-05-27 00:20:16');
INSERT INTO `access_log` VALUES (11004, '9c3e2c98-73cd-4ccb-a57e-694e13c31ab0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:20:14', 1978, 0, '', '2019-05-27 00:20:16');
INSERT INTO `access_log` VALUES (11005, '2d6994c4-932d-49d0-a01b-79a8de006ae6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:20:15', 782, 0, '', '2019-05-27 00:20:16');
INSERT INTO `access_log` VALUES (11006, '941b8e70-a7c8-4c60-95d0-0cd4e77af352', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:20:15', 819, 0, '', '2019-05-27 00:20:16');
INSERT INTO `access_log` VALUES (11007, '3af88b8c-cda6-46f8-b7ba-6c6e730c4bb5', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:20:14', 2014, 0, '', '2019-05-27 00:20:16');
INSERT INTO `access_log` VALUES (11008, '528511bb-4eea-4471-a1ac-a4a26a7dac19', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:20:15', 902, 0, '', '2019-05-27 00:20:16');
INSERT INTO `access_log` VALUES (11009, '1ff17ccf-0dad-4425-9713-cc3cb1cbec96', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:20:14', 2144, 2001001000, '服务端发生异常', '2019-05-27 00:20:16');
INSERT INTO `access_log` VALUES (11010, 'f95902c1-bce7-44c0-a119-4af86bbaeb96', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:20:15', 784, 0, '', '2019-05-27 00:20:16');
INSERT INTO `access_log` VALUES (11011, 'c31e8f9f-38cb-44b0-bcf4-f3a27f5f0b84', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:04', 131, 0, '', '2019-05-27 00:21:05');
INSERT INTO `access_log` VALUES (11012, 'e28b731b-2176-425a-825e-0e7fd3c11822', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:04', 150, 0, '', '2019-05-27 00:21:05');
INSERT INTO `access_log` VALUES (11013, 'd7abf7f5-19ad-4745-8cbb-c0dfe1f99bf3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:04', 151, 0, '', '2019-05-27 00:21:05');
INSERT INTO `access_log` VALUES (11014, '1134e9d3-b4d4-487e-8259-c0a2ff37b86e', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:04', 224, 0, '', '2019-05-27 00:21:05');
INSERT INTO `access_log` VALUES (11015, 'c05fa8c9-4d47-40e9-ac24-521c1908ef1c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:11', 148, 0, '', '2019-05-27 00:21:11');
INSERT INTO `access_log` VALUES (11016, '63dc4dc9-d1da-46eb-9613-6f262780a7e7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:11', 147, 0, '', '2019-05-27 00:21:11');
INSERT INTO `access_log` VALUES (11017, '479121e0-71e9-4bbf-84ac-5844068b538b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:11', 149, 0, '', '2019-05-27 00:21:11');
INSERT INTO `access_log` VALUES (11018, 'd0666914-8903-4e1c-a451-4bbca61923a3', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:11', 195, 0, '', '2019-05-27 00:21:12');
INSERT INTO `access_log` VALUES (11019, '11c31aaa-ef97-4802-8bb5-76ebbd00bae4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:13', 261, 0, '', '2019-05-27 00:21:13');
INSERT INTO `access_log` VALUES (11020, 'd758da02-3b80-41a0-9360-30830e4f9f52', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:13', 270, 0, '', '2019-05-27 00:21:13');
INSERT INTO `access_log` VALUES (11021, 'eed1e316-9832-426e-b902-6b49389375d9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:13', 273, 0, '', '2019-05-27 00:21:13');
INSERT INTO `access_log` VALUES (11022, 'dd07e4ed-77f9-44a4-ba40-57fab80ec627', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:13', 227, 0, '', '2019-05-27 00:21:13');
INSERT INTO `access_log` VALUES (11023, 'b5c6bd45-7861-4564-b6f4-b51ffcbf4511', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:40', 155, 0, '', '2019-05-27 00:21:40');
INSERT INTO `access_log` VALUES (11024, 'e1bab54c-b289-4651-91ca-33754d144c92', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:40', 154, 0, '', '2019-05-27 00:21:40');
INSERT INTO `access_log` VALUES (11025, 'c9a409f5-8996-4a57-92f5-c52150109b31', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:40', 151, 0, '', '2019-05-27 00:21:40');
INSERT INTO `access_log` VALUES (11026, '60b3963c-95ed-4df2-aaa5-367a44d90b66', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:21:40', 193, 0, '', '2019-05-27 00:21:41');
INSERT INTO `access_log` VALUES (11027, '37c21fb5-af48-404a-8dfd-772f1c12f324', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:08', 130, 0, '', '2019-05-27 00:22:08');
INSERT INTO `access_log` VALUES (11028, '505e066d-eee0-4c40-97b0-4596ad708b91', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:08', 144, 0, '', '2019-05-27 00:22:08');
INSERT INTO `access_log` VALUES (11029, '55bdc2b7-b696-449e-bb01-92a720bd8eb7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:08', 147, 0, '', '2019-05-27 00:22:08');
INSERT INTO `access_log` VALUES (11030, 'd1b1b362-6e8c-4b21-a8e5-20f456ac7c3c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:08', 221, 0, '', '2019-05-27 00:22:09');
INSERT INTO `access_log` VALUES (11031, '35c69b3f-cc40-4888-9f08-8d3b474490a2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:15', 151, 0, '', '2019-05-27 00:22:15');
INSERT INTO `access_log` VALUES (11032, '2953affe-bb6f-4744-9133-84031e5e86bd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:15', 146, 0, '', '2019-05-27 00:22:15');
INSERT INTO `access_log` VALUES (11033, 'c53bcd38-e6be-41e3-ae04-59d5cccf3a66', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:15', 149, 0, '', '2019-05-27 00:22:15');
INSERT INTO `access_log` VALUES (11034, 'f93279e8-0f0d-4ead-a440-1bfe96571055', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:15', 195, 0, '', '2019-05-27 00:22:15');
INSERT INTO `access_log` VALUES (11035, '74128506-bf0d-4901-94cc-a511d30dac23', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:38', 131, 0, '', '2019-05-27 00:22:38');
INSERT INTO `access_log` VALUES (11036, '731c8c5d-c8f0-4a5f-926b-9d88a9751781', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:38', 147, 0, '', '2019-05-27 00:22:38');
INSERT INTO `access_log` VALUES (11037, 'e545eb68-bd63-4cd9-b55b-dbf6f7f286c4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:38', 152, 0, '', '2019-05-27 00:22:38');
INSERT INTO `access_log` VALUES (11038, '0c3eefb4-7e52-436f-ac4c-08c9bd5f3a33', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:38', 219, 0, '', '2019-05-27 00:22:38');
INSERT INTO `access_log` VALUES (11039, '1591dcb0-dad1-4a02-afcf-1ff47614d0b0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:43', 147, 0, '', '2019-05-27 00:22:44');
INSERT INTO `access_log` VALUES (11040, 'c2aba0cb-e3bd-4ada-8575-14fa1936a57e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:43', 146, 0, '', '2019-05-27 00:22:44');
INSERT INTO `access_log` VALUES (11041, '966768da-e451-473f-bd32-bad3b16cbc78', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:43', 145, 0, '', '2019-05-27 00:22:44');
INSERT INTO `access_log` VALUES (11042, 'cc6832fc-f5b3-428d-9a1c-e69876cb2d29', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:44', 189, 0, '', '2019-05-27 00:22:44');
INSERT INTO `access_log` VALUES (11043, '70d99331-f870-4173-949e-d52344dda7e1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:47', 133, 0, '', '2019-05-27 00:22:47');
INSERT INTO `access_log` VALUES (11044, '0b7f06a9-871f-4ac2-9612-2781d6d69b73', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:47', 151, 0, '', '2019-05-27 00:22:47');
INSERT INTO `access_log` VALUES (11045, '471ab591-9d7a-4ff3-ba13-35f81a2aa771', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:47', 148, 0, '', '2019-05-27 00:22:47');
INSERT INTO `access_log` VALUES (11046, 'b6c53b35-a7a4-43b3-b691-f99e1c31b9a5', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:47', 218, 0, '', '2019-05-27 00:22:47');
INSERT INTO `access_log` VALUES (11047, '3adb700b-44aa-40f4-bc7b-d332ae8d3742', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:56', 144, 0, '', '2019-05-27 00:22:56');
INSERT INTO `access_log` VALUES (11048, '39eac180-70c3-4b86-97ae-ea70d2e0ced8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:56', 145, 0, '', '2019-05-27 00:22:56');
INSERT INTO `access_log` VALUES (11049, 'a8d9addb-14aa-4a00-bb62-7c69ac30d737', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:56', 149, 0, '', '2019-05-27 00:22:56');
INSERT INTO `access_log` VALUES (11050, '041c1cf1-a196-4ec2-82b2-7eaf0c7aff09', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:22:56', 197, 0, '', '2019-05-27 00:22:57');
INSERT INTO `access_log` VALUES (11051, 'b20814cf-059e-403b-b01a-4c40c4d926c0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:24:43', 186, 0, '', '2019-05-27 00:24:43');
INSERT INTO `access_log` VALUES (11052, 'b461f78d-2c2a-4b35-b369-b719cec760f5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:24:43', 183, 0, '', '2019-05-27 00:24:43');
INSERT INTO `access_log` VALUES (11053, '817c8f0a-7048-48d0-b6fa-abb880452bde', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:24:43', 163, 0, '', '2019-05-27 00:24:43');
INSERT INTO `access_log` VALUES (11054, '0a2d1f0c-3764-4034-b90a-c6617fdd0aae', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:24:43', 260, 0, '', '2019-05-27 00:24:43');
INSERT INTO `access_log` VALUES (11055, '5e5d8f69-9d62-4a2b-b452-d053ec38a66a', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:24:52', 199, 0, '', '2019-05-27 00:24:52');
INSERT INTO `access_log` VALUES (11056, '8d98790d-a131-4290-ab75-ae268bfc9902', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:26:19', 163, 0, '', '2019-05-27 00:26:19');
INSERT INTO `access_log` VALUES (11057, '205b1289-0888-40d0-8f12-f182f7610e03', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:26:19', 182, 0, '', '2019-05-27 00:26:19');
INSERT INTO `access_log` VALUES (11058, '81324650-0e6a-4f94-8dc7-fe014b5b39f5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:26:19', 184, 0, '', '2019-05-27 00:26:19');
INSERT INTO `access_log` VALUES (11059, '8504e6c0-4cd4-4092-91d4-0d91720c0abe', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:26:19', 273, 0, '', '2019-05-27 00:26:20');
INSERT INTO `access_log` VALUES (11060, '59.76.15589203629927555', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.47.47.235', '2019-05-27 09:26:03', 13, 0, '', '2019-05-27 09:26:03');
INSERT INTO `access_log` VALUES (11061, '59.75.15589203629957561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:26:03', 16, 2001001000, '服务端发生异常', '2019-05-27 09:26:03');
INSERT INTO `access_log` VALUES (11062, '65.54.15589203670286801', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:26:07', 0, 1002001015, '账号未登陆', '2019-05-27 09:26:07');
INSERT INTO `access_log` VALUES (11063, '65.46.15589203670286815', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:26:07', 0, 1002001015, '账号未登陆', '2019-05-27 09:26:07');
INSERT INTO `access_log` VALUES (11064, '65.45.15589203670296823', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:26:07', 0, 1002001015, '账号未登陆', '2019-05-27 09:26:07');
INSERT INTO `access_log` VALUES (11065, '65.53.15589203766556809', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:26:17', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 09:26:17');
INSERT INTO `access_log` VALUES (11066, '65.50.15589203928266813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:26:33', 82, 0, '', '2019-05-27 09:26:33');
INSERT INTO `access_log` VALUES (11067, '65.47.15589203932406819', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:26:33', 11, 0, '', '2019-05-27 09:26:33');
INSERT INTO `access_log` VALUES (11068, '65.49.15589203932436813', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:26:33', 11, 0, '', '2019-05-27 09:26:33');
INSERT INTO `access_log` VALUES (11069, '65.48.15589203932476831', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:26:33', 9, 0, '', '2019-05-27 09:26:33');
INSERT INTO `access_log` VALUES (11070, '62.83.15589204002527509', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:26:40', 27, 0, '', '2019-05-27 09:26:40');
INSERT INTO `access_log` VALUES (11071, '62.80.15589204059097505', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:26:46', 201, 0, '', '2019-05-27 09:26:46');
INSERT INTO `access_log` VALUES (11072, '64.77.15589204099336807', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:26:50', 22, 0, '', '2019-05-27 09:26:50');
INSERT INTO `access_log` VALUES (11073, '64.82.15589204099336805', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:26:50', 27, 0, '', '2019-05-27 09:26:50');
INSERT INTO `access_log` VALUES (11074, '64.79.15589204290196799', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.54.170', '2019-05-27 09:27:09', 14, 0, '', '2019-05-27 09:27:09');
INSERT INTO `access_log` VALUES (11075, '64.83.15589204290306803', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.54.170', '2019-05-27 09:27:09', 17, 0, '', '2019-05-27 09:27:09');
INSERT INTO `access_log` VALUES (11076, '64.78.15589204359216807', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:27:16', 17, 0, '', '2019-05-27 09:27:16');
INSERT INTO `access_log` VALUES (11077, '64.81.15589204359236801', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:27:16', 14, 0, '', '2019-05-27 09:27:16');
INSERT INTO `access_log` VALUES (11078, '64.80.15589204359196799', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:27:16', 34, 0, '', '2019-05-27 09:27:16');
INSERT INTO `access_log` VALUES (11079, '66.57.15589204439736595', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:27:24', 656, 0, '', '2019-05-27 09:27:25');
INSERT INTO `access_log` VALUES (11080, '59.71.15589204483837563', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:27:28', 16, 0, '', '2019-05-27 09:27:28');
INSERT INTO `access_log` VALUES (11081, '59.77.15589204522297561', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:27:32', 15, 0, '', '2019-05-27 09:27:32');
INSERT INTO `access_log` VALUES (11082, '65.53.15589204546166811', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:27:35', 21, 0, '', '2019-05-27 09:27:35');
INSERT INTO `access_log` VALUES (11083, '65.51.15589204554766813', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.225', '2019-05-27 09:27:35', 11, 0, '', '2019-05-27 09:27:35');
INSERT INTO `access_log` VALUES (11084, '59.78.15589215831727581', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.9.251', '2019-05-27 09:46:23', 4, 0, '', '2019-05-27 09:46:23');
INSERT INTO `access_log` VALUES (11085, '59.80.15589215831727577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.9.251', '2019-05-27 09:46:23', 14, 2001001000, '服务端发生异常', '2019-05-27 09:46:23');
INSERT INTO `access_log` VALUES (11086, '64.78.15589215876846823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.9.251', '2019-05-27 09:46:28', 230, 0, '', '2019-05-27 09:46:28');
INSERT INTO `access_log` VALUES (11087, '64.81.15589215882646817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.9.251', '2019-05-27 09:46:28', 2, 0, '', '2019-05-27 09:46:28');
INSERT INTO `access_log` VALUES (11088, '64.80.15589215930836815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:33', 3, 0, '', '2019-05-27 09:46:33');
INSERT INTO `access_log` VALUES (11089, '64.85.15589215937566821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:34', 3, 0, '', '2019-05-27 09:46:34');
INSERT INTO `access_log` VALUES (11090, '59.76.15589215967867573', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:37', 4, 0, '', '2019-05-27 09:46:37');
INSERT INTO `access_log` VALUES (11091, '59.77.15589215967867577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:37', 15, 2001001000, '服务端发生异常', '2019-05-27 09:46:37');
INSERT INTO `access_log` VALUES (11092, '64.77.15589215994296825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:39', 3, 0, '', '2019-05-27 09:46:39');
INSERT INTO `access_log` VALUES (11093, '64.84.15589215995186823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:40', 3, 0, '', '2019-05-27 09:46:40');
INSERT INTO `access_log` VALUES (11094, '64.76.15589216052836821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:45', 3, 0, '', '2019-05-27 09:46:45');
INSERT INTO `access_log` VALUES (11095, '64.83.15589216054286821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:45', 3, 0, '', '2019-05-27 09:46:45');
INSERT INTO `access_log` VALUES (11096, '59.73.15589216063727581', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:46', 3, 0, '', '2019-05-27 09:46:46');
INSERT INTO `access_log` VALUES (11097, '59.75.15589216063727579', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:46', 13, 2001001000, '服务端发生异常', '2019-05-27 09:46:46');
INSERT INTO `access_log` VALUES (11098, '64.78.15589216124126825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:52', 2, 0, '', '2019-05-27 09:46:52');
INSERT INTO `access_log` VALUES (11099, '64.81.15589216125076819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:53', 3, 0, '', '2019-05-27 09:46:53');
INSERT INTO `access_log` VALUES (11100, '64.80.15589216138546817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:54', 2, 0, '', '2019-05-27 09:46:54');
INSERT INTO `access_log` VALUES (11101, '64.85.15589216145776823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:55', 2, 0, '', '2019-05-27 09:46:55');
INSERT INTO `access_log` VALUES (11102, '64.82.15589216153796825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:55', 3, 0, '', '2019-05-27 09:46:55');
INSERT INTO `access_log` VALUES (11103, '64.77.15589216159236827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:56', 3, 0, '', '2019-05-27 09:46:56');
INSERT INTO `access_log` VALUES (11104, '64.84.15589216172316825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.128.9.251', '2019-05-27 09:46:57', 3, 0, '', '2019-05-27 09:46:57');
INSERT INTO `access_log` VALUES (11105, '59.71.15589222593557589', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:57:39', 5, 0, '', '2019-05-27 09:57:39');
INSERT INTO `access_log` VALUES (11106, '59.80.15589222593557587', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:57:39', 15, 2001001000, '服务端发生异常', '2019-05-27 09:57:39');
INSERT INTO `access_log` VALUES (11107, '64.78.15589222666536835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:57:47', 3, 0, '', '2019-05-27 09:57:47');
INSERT INTO `access_log` VALUES (11108, '64.81.15589222669036829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:57:47', 3, 0, '', '2019-05-27 09:57:47');
INSERT INTO `access_log` VALUES (11109, '59.76.15589222676687583', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:57:48', 3, 0, '', '2019-05-27 09:57:48');
INSERT INTO `access_log` VALUES (11110, '59.77.15589222676697587', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:57:48', 14, 2001001000, '服务端发生异常', '2019-05-27 09:57:48');
INSERT INTO `access_log` VALUES (11111, '64.80.15589222695916827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:57:50', 2, 0, '', '2019-05-27 09:57:50');
INSERT INTO `access_log` VALUES (11112, '64.85.15589222698246833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:57:50', 3, 0, '', '2019-05-27 09:57:50');
INSERT INTO `access_log` VALUES (11113, '64.77.15589222716746837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:57:52', 5, 0, '', '2019-05-27 09:57:52');
INSERT INTO `access_log` VALUES (11114, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:57:52', 70, 0, '', '2019-05-27 09:57:52');
INSERT INTO `access_log` VALUES (11115, '64.84.15589222753036835', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:57:55', 11, 0, '', '2019-05-27 09:57:55');
INSERT INTO `access_log` VALUES (11116, '66.53.15589222930636617', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18398263215&code=9999', 'POST', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:58:13', 35, 1001003000, '验证码不存在', '2019-05-27 09:58:13');
INSERT INTO `access_log` VALUES (11117, '66.52.15589222947986617', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18398263215', 'POST', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:58:15', 54, 0, '', '2019-05-27 09:58:15');
INSERT INTO `access_log` VALUES (11118, '66.49.15589222966186617', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18398263215&code=9999', 'POST', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:58:17', 196, 0, '', '2019-05-27 09:58:17');
INSERT INTO `access_log` VALUES (11119, '65.46.15589223338016843', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:58:54', 0, 1002001015, '账号未登陆', '2019-05-27 09:58:54');
INSERT INTO `access_log` VALUES (11120, '65.52.15589223339926847', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:58:54', 1, 1002001015, '账号未登陆', '2019-05-27 09:58:54');
INSERT INTO `access_log` VALUES (11121, '65.53.15589223340046837', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:58:54', 1, 1002001015, '账号未登陆', '2019-05-27 09:58:54');
INSERT INTO `access_log` VALUES (11122, '65.51.15589223377006839', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:58:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 09:58:58');
INSERT INTO `access_log` VALUES (11123, '65.50.15589223396856841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:59:00', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 09:59:00');
INSERT INTO `access_log` VALUES (11124, '65.47.15589223634186847', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:59:23', 107, 0, '', '2019-05-27 09:59:24');
INSERT INTO `access_log` VALUES (11125, '65.54.15589223643426831', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:59:24', 10, 0, '', '2019-05-27 09:59:24');
INSERT INTO `access_log` VALUES (11126, '65.45.15589223643626853', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:59:24', 9, 0, '', '2019-05-27 09:59:24');
INSERT INTO `access_log` VALUES (11127, '65.46.15589223643536845', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:59:24', 22, 0, '', '2019-05-27 09:59:24');
INSERT INTO `access_log` VALUES (11128, '65.53.15589223693836839', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:59:29', 10, 0, '', '2019-05-27 09:59:29');
INSERT INTO `access_log` VALUES (11129, '65.52.15589223693926849', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:59:29', 10, 0, '', '2019-05-27 09:59:29');
INSERT INTO `access_log` VALUES (11130, '65.51.15589223694036841', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-CN; MI MAX 2 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.2.0.107 Mobile Safari/537.36', '112.224.69.55', '2019-05-27 09:59:29', 9, 0, '', '2019-05-27 09:59:29');
INSERT INTO `access_log` VALUES (11131, '65.52.15589227876016855', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:06:28', 0, 1002001015, '账号未登陆', '2019-05-27 10:06:28');
INSERT INTO `access_log` VALUES (11132, '65.51.15589227875996847', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:06:28', 1, 1002001015, '账号未登陆', '2019-05-27 10:06:28');
INSERT INTO `access_log` VALUES (11133, '65.50.15589227876046849', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:06:28', 0, 1002001015, '账号未登陆', '2019-05-27 10:06:28');
INSERT INTO `access_log` VALUES (11134, '65.47.15589227891426855', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-27 10:06:29', 14, 1002001012, '访问令牌已过期', '2019-05-27 10:06:29');
INSERT INTO `access_log` VALUES (11135, '65.49.15589227891396849', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-27 10:06:29', 16, 1002001012, '访问令牌已过期', '2019-05-27 10:06:29');
INSERT INTO `access_log` VALUES (11136, '65.48.15589227891756867', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-27 10:06:29', 12, 1002001012, '访问令牌已过期', '2019-05-27 10:06:29');
INSERT INTO `access_log` VALUES (11137, '65.54.15589227896556839', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:06:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 10:06:30');
INSERT INTO `access_log` VALUES (11138, '65.45.15589227897516861', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-27 10:06:30', 3, 1002001012, '访问令牌已过期', '2019-05-27 10:06:30');
INSERT INTO `access_log` VALUES (11139, '65.53.15589228020876847', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:06:42', 68, 0, '', '2019-05-27 10:06:42');
INSERT INTO `access_log` VALUES (11140, '65.52.15589228023456857', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:06:42', 10, 0, '', '2019-05-27 10:06:42');
INSERT INTO `access_log` VALUES (11141, '65.51.15589228023486849', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:06:42', 9, 0, '', '2019-05-27 10:06:42');
INSERT INTO `access_log` VALUES (11142, '65.50.15589228023526851', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:06:42', 9, 0, '', '2019-05-27 10:06:42');
INSERT INTO `access_log` VALUES (11143, '65.47.15589228060036857', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:06:46', 16, 0, '', '2019-05-27 10:06:46');
INSERT INTO `access_log` VALUES (11144, '65.48.15589228148936869', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:06:55', 10, 0, '', '2019-05-27 10:06:55');
INSERT INTO `access_log` VALUES (11145, '65.54.15589228170556841', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:06:57', 12, 0, '', '2019-05-27 10:06:57');
INSERT INTO `access_log` VALUES (11146, '65.45.15589228182196863', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:06:58', 20, 0, '', '2019-05-27 10:06:58');
INSERT INTO `access_log` VALUES (11147, '62.88.15589228273177541', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:07:07', 34, 0, '', '2019-05-27 10:07:07');
INSERT INTO `access_log` VALUES (11148, '62.86.15589228314347527', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:07:11', 20, 0, '', '2019-05-27 10:07:11');
INSERT INTO `access_log` VALUES (11149, '66.49.15589228399796625', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:07:20', 17, 0, '', '2019-05-27 10:07:20');
INSERT INTO `access_log` VALUES (11150, '66.50.15589228470706621', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:07:27', 16, 0, '', '2019-05-27 10:07:27');
INSERT INTO `access_log` VALUES (11151, '59.74.15589228504677599', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:07:30', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-27 10:07:30');
INSERT INTO `access_log` VALUES (11152, '59.79.15589228531427595', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:07:33', 18, 2001001000, '服务端发生异常', '2019-05-27 10:07:33');
INSERT INTO `access_log` VALUES (11153, '59.71.15589228551107599', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:07:35', 510, 0, '', '2019-05-27 10:07:36');
INSERT INTO `access_log` VALUES (11154, '64.85.15589228976366843', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:08:18', 14, 0, '', '2019-05-27 10:08:18');
INSERT INTO `access_log` VALUES (11155, '64.80.15589228976356837', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:08:18', 17, 0, '', '2019-05-27 10:08:18');
INSERT INTO `access_log` VALUES (11156, '59.73.15589229070707601', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:08:27', 49, 0, '', '2019-05-27 10:08:27');
INSERT INTO `access_log` VALUES (11157, '59.75.15589229091717599', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:08:29', 20, 2001001000, '服务端发生异常', '2019-05-27 10:08:29');
INSERT INTO `access_log` VALUES (11158, '59.72.15589229117577595', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.184.112.110', '2019-05-27 10:08:32', 14, 0, '', '2019-05-27 10:08:32');
INSERT INTO `access_log` VALUES (11159, '65.53.15589231298286853', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.96.184', '2019-05-27 10:12:10', 1, 1002001015, '账号未登陆', '2019-05-27 10:12:10');
INSERT INTO `access_log` VALUES (11160, '65.51.15589231298416855', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.96.184', '2019-05-27 10:12:10', 1, 1002001015, '账号未登陆', '2019-05-27 10:12:10');
INSERT INTO `access_log` VALUES (11161, '65.52.15589231298556863', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.96.184', '2019-05-27 10:12:10', 0, 1002001015, '账号未登陆', '2019-05-27 10:12:10');
INSERT INTO `access_log` VALUES (11162, '65.50.15589231418586857', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.96.184', '2019-05-27 10:12:22', 96, 0, '', '2019-05-27 10:12:22');
INSERT INTO `access_log` VALUES (11163, '65.47.15589231425376863', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.96.184', '2019-05-27 10:12:23', 11, 0, '', '2019-05-27 10:12:23');
INSERT INTO `access_log` VALUES (11164, '65.48.15589231425456875', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.96.184', '2019-05-27 10:12:23', 10, 0, '', '2019-05-27 10:12:23');
INSERT INTO `access_log` VALUES (11165, '65.49.15589231425416857', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.96.184', '2019-05-27 10:12:23', 13, 0, '', '2019-05-27 10:12:23');
INSERT INTO `access_log` VALUES (11166, '62.89.15589231488547539', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.96.184', '2019-05-27 10:12:29', 15, 0, '', '2019-05-27 10:12:29');
INSERT INTO `access_log` VALUES (11167, '64.84.15589232154146849', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.96.184', '2019-05-27 10:13:35', 17, 0, '', '2019-05-27 10:13:35');
INSERT INTO `access_log` VALUES (11168, '64.77.15589232154146851', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.96.184', '2019-05-27 10:13:35', 20, 0, '', '2019-05-27 10:13:35');
INSERT INTO `access_log` VALUES (11169, '64.79.15589232251416843', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.96.184', '2019-05-27 10:13:45', 8, 0, '', '2019-05-27 10:13:45');
INSERT INTO `access_log` VALUES (11170, '64.83.15589232251366847', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.96.184', '2019-05-27 10:13:45', 12, 0, '', '2019-05-27 10:13:45');
INSERT INTO `access_log` VALUES (11171, '65.47.15589238364966873', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.86.57.234', '2019-05-27 10:23:56', 1, 1002001015, '账号未登陆', '2019-05-27 10:23:56');
INSERT INTO `access_log` VALUES (11172, '65.48.15589238364996885', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.86.57.234', '2019-05-27 10:23:57', 0, 1002001015, '账号未登陆', '2019-05-27 10:23:57');
INSERT INTO `access_log` VALUES (11173, '65.49.15589238364966867', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.86.57.234', '2019-05-27 10:23:56', 1, 1002001015, '账号未登陆', '2019-05-27 10:23:56');
INSERT INTO `access_log` VALUES (11174, '59.77.15589247878857623', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:39:48', 14, 2001001000, '服务端发生异常', '2019-05-27 10:39:48');
INSERT INTO `access_log` VALUES (11175, '59.76.15589247878857619', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:39:48', 107, 0, '', '2019-05-27 10:39:48');
INSERT INTO `access_log` VALUES (11176, '65.52.15589247944646887', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:39:54', 0, 1002001015, '账号未登陆', '2019-05-27 10:39:54');
INSERT INTO `access_log` VALUES (11177, '65.51.15589247944646879', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:39:54', 0, 1002001015, '账号未登陆', '2019-05-27 10:39:54');
INSERT INTO `access_log` VALUES (11178, '65.50.15589247944726881', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:39:54', 1, 1002001015, '账号未登陆', '2019-05-27 10:39:54');
INSERT INTO `access_log` VALUES (11179, '64.84.15589248050636871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:05', 4, 0, '', '2019-05-27 10:40:05');
INSERT INTO `access_log` VALUES (11180, '64.76.15589248051656869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:05', 2, 0, '', '2019-05-27 10:40:05');
INSERT INTO `access_log` VALUES (11181, '64.83.15589248062166869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:06', 3, 0, '', '2019-05-27 10:40:06');
INSERT INTO `access_log` VALUES (11182, '64.79.15589248067016865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:07', 3, 0, '', '2019-05-27 10:40:07');
INSERT INTO `access_log` VALUES (11183, '64.78.15589248070146873', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:07', 3, 0, '', '2019-05-27 10:40:07');
INSERT INTO `access_log` VALUES (11184, '64.81.15589248072816867', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:07', 3, 0, '', '2019-05-27 10:40:07');
INSERT INTO `access_log` VALUES (11185, '65.48.15589248179886899', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:18', 73, 0, '', '2019-05-27 10:40:18');
INSERT INTO `access_log` VALUES (11186, '65.54.15589248182466871', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:18', 10, 0, '', '2019-05-27 10:40:18');
INSERT INTO `access_log` VALUES (11187, '65.49.15589248182456881', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:18', 10, 0, '', '2019-05-27 10:40:18');
INSERT INTO `access_log` VALUES (11188, '65.45.15589248182506893', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:18', 9, 0, '', '2019-05-27 10:40:18');
INSERT INTO `access_log` VALUES (11189, '62.82.15589248239387563', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:24', 15, 0, '', '2019-05-27 10:40:24');
INSERT INTO `access_log` VALUES (11190, '59.74.15589248285547627', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:29', 14, 0, '', '2019-05-27 10:40:29');
INSERT INTO `access_log` VALUES (11191, '62.88.15589248332237569', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:33', 17, 0, '', '2019-05-27 10:40:33');
INSERT INTO `access_log` VALUES (11192, '66.54.15589248350386649', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:35', 22, 0, '', '2019-05-27 10:40:35');
INSERT INTO `access_log` VALUES (11193, '65.53.15589248365056879', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.195.13.14', '2019-05-27 10:40:37', 20, 0, '', '2019-05-27 10:40:37');
INSERT INTO `access_log` VALUES (11194, '65.51.15589249766916883', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:42:57', 1, 1002001015, '账号未登陆', '2019-05-27 10:42:57');
INSERT INTO `access_log` VALUES (11195, '65.50.15589249766916885', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:42:57', 1, 1002001015, '账号未登陆', '2019-05-27 10:42:57');
INSERT INTO `access_log` VALUES (11196, '65.52.15589249766966891', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:42:57', 1, 1002001015, '账号未登陆', '2019-05-27 10:42:57');
INSERT INTO `access_log` VALUES (11197, '65.47.15589249794296891', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:42:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 10:42:59');
INSERT INTO `access_log` VALUES (11198, '65.48.15589249884676903', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma &password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:43:08', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号格式为数字以及字母', '2019-05-27 10:43:08');
INSERT INTO `access_log` VALUES (11199, '65.49.15589250144316885', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:43:34', 74, 0, '', '2019-05-27 10:43:35');
INSERT INTO `access_log` VALUES (11200, '65.46.15589250147396889', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:43:35', 11, 0, '', '2019-05-27 10:43:35');
INSERT INTO `access_log` VALUES (11201, '65.53.15589250147426883', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:43:35', 10, 0, '', '2019-05-27 10:43:35');
INSERT INTO `access_log` VALUES (11202, '65.52.15589250147426893', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:43:35', 9, 0, '', '2019-05-27 10:43:35');
INSERT INTO `access_log` VALUES (11203, '62.89.15589250187147565', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:43:39', 15, 0, '', '2019-05-27 10:43:39');
INSERT INTO `access_log` VALUES (11204, '64.83.15589250381406873', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:43:58', 12, 0, '', '2019-05-27 10:43:58');
INSERT INTO `access_log` VALUES (11205, '64.77.15589250381406877', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:43:58', 14, 0, '', '2019-05-27 10:43:58');
INSERT INTO `access_log` VALUES (11206, '64.79.15589250419676869', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:02', 11, 0, '', '2019-05-27 10:44:02');
INSERT INTO `access_log` VALUES (11207, '64.78.15589250419676877', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:02', 13, 0, '', '2019-05-27 10:44:02');
INSERT INTO `access_log` VALUES (11208, '64.80.15589250467146869', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:07', 10, 0, '', '2019-05-27 10:44:07');
INSERT INTO `access_log` VALUES (11209, '64.85.15589250467126875', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:07', 23, 0, '', '2019-05-27 10:44:07');
INSERT INTO `access_log` VALUES (11210, '64.82.15589250567346877', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:17', 11, 0, '', '2019-05-27 10:44:17');
INSERT INTO `access_log` VALUES (11211, '59.73.15589250634497631', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:23', 113, 0, '', '2019-05-27 10:44:24');
INSERT INTO `access_log` VALUES (11212, '64.76.15589250648166875', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:25', 11, 0, '', '2019-05-27 10:44:25');
INSERT INTO `access_log` VALUES (11213, '64.77.15589250714826879', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:31', 11, 0, '', '2019-05-27 10:44:31');
INSERT INTO `access_log` VALUES (11214, '59.79.15589250911147627', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:51', 4, 0, '', '2019-05-27 10:44:51');
INSERT INTO `access_log` VALUES (11215, '59.74.15589250911147631', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:51', 16, 2001001000, '服务端发生异常', '2019-05-27 10:44:51');
INSERT INTO `access_log` VALUES (11216, '64.78.15589250948746879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:55', 2, 0, '', '2019-05-27 10:44:55');
INSERT INTO `access_log` VALUES (11217, '64.81.15589250950716873', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:55', 3, 0, '', '2019-05-27 10:44:55');
INSERT INTO `access_log` VALUES (11218, '64.80.15589250961476871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:56', 2, 0, '', '2019-05-27 10:44:56');
INSERT INTO `access_log` VALUES (11219, '64.85.15589250969906877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:57', 2, 0, '', '2019-05-27 10:44:57');
INSERT INTO `access_log` VALUES (11220, '64.85.15589250969906877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:57', 2, 0, '', '2019-05-27 10:44:58');
INSERT INTO `access_log` VALUES (11221, '59.71.15589250986457631', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:59', 14, 2001001000, '服务端发生异常', '2019-05-27 10:44:59');
INSERT INTO `access_log` VALUES (11222, '64.85.15589250969906877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:57', 2, 0, '', '2019-05-27 10:44:59');
INSERT INTO `access_log` VALUES (11223, '59.78.15589250986177633', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:44:59', 597, 0, '', '2019-05-27 10:44:59');
INSERT INTO `access_log` VALUES (11224, '64.82.15589251017746879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:45:02', 3, 0, '', '2019-05-27 10:45:02');
INSERT INTO `access_log` VALUES (11225, '64.84.15589251018886879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:45:02', 3, 0, '', '2019-05-27 10:45:02');
INSERT INTO `access_log` VALUES (11226, '64.76.15589251029956877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.23.37', '2019-05-27 10:45:03', 3, 0, '', '2019-05-27 10:45:03');
INSERT INTO `access_log` VALUES (11227, '65.51.15589251396036887', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:45:40', 0, 1002001015, '账号未登陆', '2019-05-27 10:45:40');
INSERT INTO `access_log` VALUES (11228, '65.53.15589251396036885', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:45:40', 0, 1002001015, '账号未登陆', '2019-05-27 10:45:40');
INSERT INTO `access_log` VALUES (11229, '65.50.15589251396106889', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:45:40', 0, 1002001015, '账号未登陆', '2019-05-27 10:45:40');
INSERT INTO `access_log` VALUES (11230, '65.47.15589251421126895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:45:42', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 10:45:42');
INSERT INTO `access_log` VALUES (11231, '65.54.15589251564876879', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:45:56', 329, 0, '', '2019-05-27 10:45:57');
INSERT INTO `access_log` VALUES (11232, '65.45.15589251570926901', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:45:57', 9, 0, '', '2019-05-27 10:45:57');
INSERT INTO `access_log` VALUES (11233, '65.49.15589251570926889', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:45:57', 9, 0, '', '2019-05-27 10:45:57');
INSERT INTO `access_log` VALUES (11234, '65.46.15589251570946893', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:45:57', 15, 0, '', '2019-05-27 10:45:57');
INSERT INTO `access_log` VALUES (11235, '62.83.15589251625207575', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:46:03', 16, 0, '', '2019-05-27 10:46:03');
INSERT INTO `access_log` VALUES (11236, '59.72.15589251693057627', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:46:09', 13, 0, '', '2019-05-27 10:46:09');
INSERT INTO `access_log` VALUES (11237, '65.51.15589251805536889', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:46:21', 19, 0, '', '2019-05-27 10:46:21');
INSERT INTO `access_log` VALUES (11238, '65.53.15589251831766887', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=9', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:46:23', 11, 0, '', '2019-05-27 10:46:23');
INSERT INTO `access_log` VALUES (11239, '65.47.15589251856876897', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:46:26', 11, 0, '', '2019-05-27 10:46:26');
INSERT INTO `access_log` VALUES (11240, '65.48.15589251874746909', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:46:27', 10, 0, '', '2019-05-27 10:46:27');
INSERT INTO `access_log` VALUES (11241, '59.75.15589252778877633', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:47:58', 4, 0, '', '2019-05-27 10:47:58');
INSERT INTO `access_log` VALUES (11242, '59.73.15589252778877635', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '171.217.88.156', '2019-05-27 10:47:58', 14, 2001001000, '服务端发生异常', '2019-05-27 10:47:58');
INSERT INTO `access_log` VALUES (11243, '64.77.15589252852146883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '171.217.88.156', '2019-05-27 10:48:05', 3, 0, '', '2019-05-27 10:48:05');
INSERT INTO `access_log` VALUES (11244, '64.83.15589252853806879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '171.217.88.156', '2019-05-27 10:48:05', 3, 0, '', '2019-05-27 10:48:05');
INSERT INTO `access_log` VALUES (11245, '64.78.15589252871386883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '171.217.88.156', '2019-05-27 10:48:07', 3, 0, '', '2019-05-27 10:48:07');
INSERT INTO `access_log` VALUES (11246, '64.81.15589252876006879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '171.217.88.156', '2019-05-27 10:48:08', 3, 0, '', '2019-05-27 10:48:08');
INSERT INTO `access_log` VALUES (11247, '64.80.15589252885706875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '171.217.88.156', '2019-05-27 10:48:09', 3, 0, '', '2019-05-27 10:48:09');
INSERT INTO `access_log` VALUES (11248, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '171.217.88.156', '2019-05-27 10:48:09', 22, 0, '', '2019-05-27 10:48:09');
INSERT INTO `access_log` VALUES (11249, '64.85.15589252899836881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '171.217.88.156', '2019-05-27 10:48:10', 3, 0, '', '2019-05-27 10:48:10');
INSERT INTO `access_log` VALUES (11250, '64.82.15589252900866885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '171.217.88.156', '2019-05-27 10:48:10', 2, 0, '', '2019-05-27 10:48:10');
INSERT INTO `access_log` VALUES (11251, '64.84.15589252983576885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '171.217.88.156', '2019-05-27 10:48:18', 3, 0, '', '2019-05-27 10:48:18');
INSERT INTO `access_log` VALUES (11252, '64.76.15589252984546883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '171.217.88.156', '2019-05-27 10:48:18', 3, 0, '', '2019-05-27 10:48:18');
INSERT INTO `access_log` VALUES (11253, '59.74.15589252990887635', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '171.217.88.156', '2019-05-27 10:48:19', 3, 0, '', '2019-05-27 10:48:19');
INSERT INTO `access_log` VALUES (11254, '59.78.15589252990897637', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '171.217.88.156', '2019-05-27 10:48:19', 13, 2001001000, '服务端发生异常', '2019-05-27 10:48:19');
INSERT INTO `access_log` VALUES (11255, '65.52.15589261420986911', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 11:02:22', 4, 1002001012, '访问令牌已过期', '2019-05-27 11:02:22');
INSERT INTO `access_log` VALUES (11256, '65.46.15589261420986907', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 11:02:22', 5, 1002001012, '访问令牌已过期', '2019-05-27 11:02:22');
INSERT INTO `access_log` VALUES (11257, '65.51.15589261421056903', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 11:02:22', 3, 1002001012, '访问令牌已过期', '2019-05-27 11:02:22');
INSERT INTO `access_log` VALUES (11258, '64.82.15589261421956897', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 11:02:22', 8, 1002001012, '访问令牌已过期', '2019-05-27 11:02:22');
INSERT INTO `access_log` VALUES (11259, '64.84.15589261421976897', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 11:02:22', 6, 1002001012, '访问令牌已过期', '2019-05-27 11:02:22');
INSERT INTO `access_log` VALUES (11260, '59.73.15589264267007651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '49.90.185.134', '2019-05-27 11:07:07', 7, 0, '', '2019-05-27 11:07:07');
INSERT INTO `access_log` VALUES (11261, '59.72.15589264267057645', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '49.90.185.134', '2019-05-27 11:07:07', 14, 2001001000, '服务端发生异常', '2019-05-27 11:07:07');
INSERT INTO `access_log` VALUES (11262, '59.78.15589264612617653', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.90.185.134', '2019-05-27 11:07:41', 4, 0, '', '2019-05-27 11:07:41');
INSERT INTO `access_log` VALUES (11263, '59.71.15589264612627651', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.90.185.134', '2019-05-27 11:07:41', 14, 2001001000, '服务端发生异常', '2019-05-27 11:07:41');
INSERT INTO `access_log` VALUES (11264, '64.83.15589264715666897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.90.185.134', '2019-05-27 11:07:52', 4, 0, '', '2019-05-27 11:07:52');
INSERT INTO `access_log` VALUES (11265, '64.79.15589264717096895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.90.185.134', '2019-05-27 11:07:52', 4, 0, '', '2019-05-27 11:07:52');
INSERT INTO `access_log` VALUES (11266, '59.75.15589283040147675', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.154.20.193', '2019-05-27 11:38:24', 12, 0, '', '2019-05-27 11:38:24');
INSERT INTO `access_log` VALUES (11267, '59.72.15589283040167671', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.154.20.193', '2019-05-27 11:38:24', 16, 2001001000, '服务端发生异常', '2019-05-27 11:38:24');
INSERT INTO `access_log` VALUES (11268, '64.80.15589283086766917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.154.20.193', '2019-05-27 11:38:29', 12, 0, '', '2019-05-27 11:38:29');
INSERT INTO `access_log` VALUES (11269, '64.85.15589283088056923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.154.20.193', '2019-05-27 11:38:29', 4, 0, '', '2019-05-27 11:38:29');
INSERT INTO `access_log` VALUES (11270, '65.50.15589295769916951', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '58.132.171.202', '2019-05-27 11:59:37', 0, 1002001015, '账号未登陆', '2019-05-27 11:59:37');
INSERT INTO `access_log` VALUES (11271, '65.53.15589295769906947', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '58.132.171.202', '2019-05-27 11:59:37', 1, 1002001015, '账号未登陆', '2019-05-27 11:59:37');
INSERT INTO `access_log` VALUES (11272, '65.46.15589295769906953', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '58.132.171.202', '2019-05-27 11:59:37', 1, 1002001015, '账号未登陆', '2019-05-27 11:59:37');
INSERT INTO `access_log` VALUES (11273, '65.45.15589296113706963', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:00:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 12:00:11');
INSERT INTO `access_log` VALUES (11274, '65.49.15589296118546951', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:00:12', 1, 1002001015, '账号未登陆', '2019-05-27 12:00:12');
INSERT INTO `access_log` VALUES (11275, '65.51.15589296118646951', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:00:12', 0, 1002001015, '账号未登陆', '2019-05-27 12:00:12');
INSERT INTO `access_log` VALUES (11276, '65.52.15589296118656959', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:00:12', 0, 1002001015, '账号未登陆', '2019-05-27 12:00:12');
INSERT INTO `access_log` VALUES (11277, '65.53.15589296354446949', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:00:35', 338, 0, '', '2019-05-27 12:00:36');
INSERT INTO `access_log` VALUES (11278, '65.46.15589296361696955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:00:36', 11, 0, '', '2019-05-27 12:00:36');
INSERT INTO `access_log` VALUES (11279, '65.47.15589296361826959', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:00:36', 11, 0, '', '2019-05-27 12:00:36');
INSERT INTO `access_log` VALUES (11280, '65.48.15589296361826971', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:00:36', 10, 0, '', '2019-05-27 12:00:36');
INSERT INTO `access_log` VALUES (11281, '65.52.15589296563796961', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:00:56', 9, 0, '', '2019-05-27 12:00:56');
INSERT INTO `access_log` VALUES (11282, '65.49.15589296563786953', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:00:56', 11, 0, '', '2019-05-27 12:00:56');
INSERT INTO `access_log` VALUES (11283, '65.51.15589296563866953', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:00:56', 9, 0, '', '2019-05-27 12:00:56');
INSERT INTO `access_log` VALUES (11284, '64.82.15589296565976945', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:00:57', 12, 0, '', '2019-05-27 12:00:57');
INSERT INTO `access_log` VALUES (11285, '64.84.15589296565976945', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:00:57', 16, 0, '', '2019-05-27 12:00:57');
INSERT INTO `access_log` VALUES (11286, '65.50.15589296628326955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:03', 9, 0, '', '2019-05-27 12:01:03');
INSERT INTO `access_log` VALUES (11287, '65.53.15589296628356951', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:03', 9, 0, '', '2019-05-27 12:01:03');
INSERT INTO `access_log` VALUES (11288, '65.47.15589296628366961', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:03', 8, 0, '', '2019-05-27 12:01:03');
INSERT INTO `access_log` VALUES (11289, '64.77.15589296629946945', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:03', 11, 0, '', '2019-05-27 12:01:03');
INSERT INTO `access_log` VALUES (11290, '64.76.15589296629886943', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:03', 17, 0, '', '2019-05-27 12:01:03');
INSERT INTO `access_log` VALUES (11291, '64.78.15589296741476945', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:14', 92, 0, '', '2019-05-27 12:01:14');
INSERT INTO `access_log` VALUES (11292, '64.79.15589296741446939', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:14', 95, 0, '', '2019-05-27 12:01:14');
INSERT INTO `access_log` VALUES (11293, '65.54.15589296956536945', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:36', 10, 0, '', '2019-05-27 12:01:36');
INSERT INTO `access_log` VALUES (11294, '65.51.15589296956586955', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:36', 9, 0, '', '2019-05-27 12:01:36');
INSERT INTO `access_log` VALUES (11295, '65.45.15589296956586967', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:36', 9, 0, '', '2019-05-27 12:01:36');
INSERT INTO `access_log` VALUES (11296, '65.50.15589297032766957', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:43', 8, 0, '', '2019-05-27 12:01:43');
INSERT INTO `access_log` VALUES (11297, '65.49.15589297032756955', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:43', 11, 0, '', '2019-05-27 12:01:43');
INSERT INTO `access_log` VALUES (11298, '65.53.15589297032776953', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:43', 9, 0, '', '2019-05-27 12:01:43');
INSERT INTO `access_log` VALUES (11299, '62.86.15589297034137621', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:43', 25, 0, '', '2019-05-27 12:01:43');
INSERT INTO `access_log` VALUES (11300, '65.48.15589297140566975', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:54', 8, 0, '', '2019-05-27 12:01:54');
INSERT INTO `access_log` VALUES (11301, '65.46.15589297140636959', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:54', 8, 0, '', '2019-05-27 12:01:54');
INSERT INTO `access_log` VALUES (11302, '65.51.15589297140716957', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:54', 7, 0, '', '2019-05-27 12:01:54');
INSERT INTO `access_log` VALUES (11303, '64.82.15589297142216947', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:01:54', 11, 0, '', '2019-05-27 12:01:54');
INSERT INTO `access_log` VALUES (11304, '65.52.15589297254496965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:05', 733, 0, '', '2019-05-27 12:02:06');
INSERT INTO `access_log` VALUES (11305, '65.45.15589297254296969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:05', 750, 0, '', '2019-05-27 12:02:06');
INSERT INTO `access_log` VALUES (11306, '64.77.15589297256456947', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:06', 538, 0, '', '2019-05-27 12:02:06');
INSERT INTO `access_log` VALUES (11307, '65.54.15589297254326947', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:05', 754, 0, '', '2019-05-27 12:02:06');
INSERT INTO `access_log` VALUES (11308, '64.76.15589297256566945', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:06', 529, 0, '', '2019-05-27 12:02:06');
INSERT INTO `access_log` VALUES (11309, '65.53.15589297422746955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:22', 10, 0, '', '2019-05-27 12:02:22');
INSERT INTO `access_log` VALUES (11310, '65.49.15589297422776957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:22', 10, 0, '', '2019-05-27 12:02:22');
INSERT INTO `access_log` VALUES (11311, '65.47.15589297422806965', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:22', 9, 0, '', '2019-05-27 12:02:22');
INSERT INTO `access_log` VALUES (11312, '64.78.15589297424106947', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:22', 10, 0, '', '2019-05-27 12:02:22');
INSERT INTO `access_log` VALUES (11313, '64.79.15589297424076941', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:22', 13, 0, '', '2019-05-27 12:02:22');
INSERT INTO `access_log` VALUES (11314, '65.51.15589297515956959', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:32', 18, 0, '', '2019-05-27 12:02:32');
INSERT INTO `access_log` VALUES (11315, '65.46.15589297516026961', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:32', 12, 0, '', '2019-05-27 12:02:32');
INSERT INTO `access_log` VALUES (11316, '65.54.15589297516106949', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:32', 9, 0, '', '2019-05-27 12:02:32');
INSERT INTO `access_log` VALUES (11317, '64.81.15589297517116943', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:32', 11, 0, '', '2019-05-27 12:02:32');
INSERT INTO `access_log` VALUES (11318, '65.52.15589297624646967', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:42', 9, 0, '', '2019-05-27 12:02:42');
INSERT INTO `access_log` VALUES (11319, '65.50.15589297624666961', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:42', 9, 0, '', '2019-05-27 12:02:42');
INSERT INTO `access_log` VALUES (11320, '65.53.15589297624666957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:42', 8, 0, '', '2019-05-27 12:02:42');
INSERT INTO `access_log` VALUES (11321, '64.85.15589297626906945', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:43', 11, 0, '', '2019-05-27 12:02:43');
INSERT INTO `access_log` VALUES (11322, '64.82.15589297626916949', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:02:43', 12, 0, '', '2019-05-27 12:02:43');
INSERT INTO `access_log` VALUES (11323, '65.47.15589297806866967', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:01', 10, 0, '', '2019-05-27 12:03:01');
INSERT INTO `access_log` VALUES (11324, '65.54.15589297806956951', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:01', 8, 0, '', '2019-05-27 12:03:01');
INSERT INTO `access_log` VALUES (11325, '65.48.15589297806926979', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:01', 14, 0, '', '2019-05-27 12:03:01');
INSERT INTO `access_log` VALUES (11326, '64.76.15589297808606947', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:01', 9, 0, '', '2019-05-27 12:03:01');
INSERT INTO `access_log` VALUES (11327, '64.77.15589297808556949', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:01', 13, 0, '', '2019-05-27 12:03:01');
INSERT INTO `access_log` VALUES (11328, '65.46.15589298006776963', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:21', 9, 0, '', '2019-05-27 12:03:21');
INSERT INTO `access_log` VALUES (11329, '65.45.15589298006856973', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:21', 8, 0, '', '2019-05-27 12:03:21');
INSERT INTO `access_log` VALUES (11330, '65.53.15589298006866959', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:21', 8, 0, '', '2019-05-27 12:03:21');
INSERT INTO `access_log` VALUES (11331, '66.53.15589298008046719', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:21', 27, 0, '', '2019-05-27 12:03:21');
INSERT INTO `access_log` VALUES (11332, '65.52.15589298128716969', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:33', 9, 0, '', '2019-05-27 12:03:33');
INSERT INTO `access_log` VALUES (11333, '65.49.15589298128736961', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:33', 9, 0, '', '2019-05-27 12:03:33');
INSERT INTO `access_log` VALUES (11334, '65.47.15589298128796969', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:33', 9, 0, '', '2019-05-27 12:03:33');
INSERT INTO `access_log` VALUES (11335, '65.48.15589298130046981', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:33', 18, 0, '', '2019-05-27 12:03:33');
INSERT INTO `access_log` VALUES (11336, '65.51.15589298235826963', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:44', 13, 0, '', '2019-05-27 12:03:44');
INSERT INTO `access_log` VALUES (11337, '65.46.15589298306086965', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:51', 81, 0, '', '2019-05-27 12:03:51');
INSERT INTO `access_log` VALUES (11338, '65.53.15589298306136961', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:51', 77, 0, '', '2019-05-27 12:03:51');
INSERT INTO `access_log` VALUES (11339, '65.45.15589298306226975', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:51', 69, 0, '', '2019-05-27 12:03:51');
INSERT INTO `access_log` VALUES (11340, '65.50.15589298307506965', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:03:51', 9, 0, '', '2019-05-27 12:03:51');
INSERT INTO `access_log` VALUES (11341, '65.48.15589298719596983', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:04:32', 10, 0, '', '2019-05-27 12:04:32');
INSERT INTO `access_log` VALUES (11342, '65.54.15589298719626955', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:04:32', 9, 0, '', '2019-05-27 12:04:32');
INSERT INTO `access_log` VALUES (11343, '65.51.15589298719686965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:04:32', 9, 0, '', '2019-05-27 12:04:32');
INSERT INTO `access_log` VALUES (11344, '65.45.15589298720876977', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:04:32', 12, 0, '', '2019-05-27 12:04:32');
INSERT INTO `access_log` VALUES (11345, '65.50.15589298839226967', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:04:44', 266, 0, '', '2019-05-27 12:04:44');
INSERT INTO `access_log` VALUES (11346, '65.53.15589298839166963', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:04:44', 278, 0, '', '2019-05-27 12:04:44');
INSERT INTO `access_log` VALUES (11347, '65.49.15589298839236965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:04:44', 270, 0, '', '2019-05-27 12:04:44');
INSERT INTO `access_log` VALUES (11348, '59.80.15589298841337695', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:04:44', 63, 0, '', '2019-05-27 12:04:44');
INSERT INTO `access_log` VALUES (11349, '64.84.15589298866706951', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:04:47', 190, 0, '', '2019-05-27 12:04:47');
INSERT INTO `access_log` VALUES (11350, '64.76.15589299029316949', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:05:03', 1379, 0, '', '2019-05-27 12:05:04');
INSERT INTO `access_log` VALUES (11351, '65.54.15589299123906957', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:05:12', 10, 0, '', '2019-05-27 12:05:12');
INSERT INTO `access_log` VALUES (11352, '65.48.15589299124016985', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:05:12', 9, 0, '', '2019-05-27 12:05:12');
INSERT INTO `access_log` VALUES (11353, '65.51.15589299124146967', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:05:12', 9, 0, '', '2019-05-27 12:05:12');
INSERT INTO `access_log` VALUES (11354, '59.75.15589299125157697', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:05:13', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-27 12:05:13');
INSERT INTO `access_log` VALUES (11355, '65.54.15589312175016975', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:26:58', 73, 0, '', '2019-05-27 12:26:58');
INSERT INTO `access_log` VALUES (11356, '65.48.15589312179017003', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:26:58', 9, 0, '', '2019-05-27 12:26:58');
INSERT INTO `access_log` VALUES (11357, '65.51.15589312179036985', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:26:58', 9, 0, '', '2019-05-27 12:26:58');
INSERT INTO `access_log` VALUES (11358, '65.45.15589312179116997', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5674 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '58.132.171.202', '2019-05-27 12:26:58', 10, 0, '', '2019-05-27 12:26:58');
INSERT INTO `access_log` VALUES (11359, '59.78.15589317503907725', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:35:50', 12, 0, '', '2019-05-27 12:35:50');
INSERT INTO `access_log` VALUES (11360, '59.74.15589317503907723', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:35:50', 16, 2001001000, '服务端发生异常', '2019-05-27 12:35:50');
INSERT INTO `access_log` VALUES (11361, '64.80.15589317539476967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:35:54', 11, 0, '', '2019-05-27 12:35:54');
INSERT INTO `access_log` VALUES (11362, '64.82.15589317540706977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:35:54', 3, 0, '', '2019-05-27 12:35:54');
INSERT INTO `access_log` VALUES (11363, '64.85.15589317626126973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:03', 22, 0, '', '2019-05-27 12:36:03');
INSERT INTO `access_log` VALUES (11364, '64.84.15589317628916977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:03', 3, 0, '', '2019-05-27 12:36:03');
INSERT INTO `access_log` VALUES (11365, '64.76.15589317657436975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:06', 3, 0, '', '2019-05-27 12:36:06');
INSERT INTO `access_log` VALUES (11366, '64.83.15589317658686973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:06', 2, 0, '', '2019-05-27 12:36:06');
INSERT INTO `access_log` VALUES (11367, '59.80.15589317728917721', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:13', 4, 0, '', '2019-05-27 12:36:13');
INSERT INTO `access_log` VALUES (11368, '59.76.15589317728997717', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:13', 13, 2001001000, '服务端发生异常', '2019-05-27 12:36:13');
INSERT INTO `access_log` VALUES (11369, '64.78.15589317750096977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:15', 2, 0, '', '2019-05-27 12:36:15');
INSERT INTO `access_log` VALUES (11370, '64.79.15589317751426971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:15', 4, 0, '', '2019-05-27 12:36:15');
INSERT INTO `access_log` VALUES (11371, '64.81.15589317761266973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:16', 3, 0, '', '2019-05-27 12:36:16');
INSERT INTO `access_log` VALUES (11372, '64.80.15589317774266969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:17', 3, 0, '', '2019-05-27 12:36:17');
INSERT INTO `access_log` VALUES (11373, '64.82.15589317781536979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:18', 4, 0, '', '2019-05-27 12:36:18');
INSERT INTO `access_log` VALUES (11374, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:19', 21, 0, '', '2019-05-27 12:36:19');
INSERT INTO `access_log` VALUES (11375, '64.85.15589317787596975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:19', 848, 0, '', '2019-05-27 12:36:20');
INSERT INTO `access_log` VALUES (11376, '64.84.15589317797196979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:20', 2, 0, '', '2019-05-27 12:36:20');
INSERT INTO `access_log` VALUES (11377, '64.76.15589317808426977', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:36:21', 11, 0, '', '2019-05-27 12:36:21');
INSERT INTO `access_log` VALUES (11378, '64.81.15589319890846977', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:49', 397, 0, '', '2019-05-27 12:39:49');
INSERT INTO `access_log` VALUES (11379, '64.80.15589319896096973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:50', 3, 0, '', '2019-05-27 12:39:50');
INSERT INTO `access_log` VALUES (11380, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:50', 9, 0, '', '2019-05-27 12:39:50');
INSERT INTO `access_log` VALUES (11381, '64.85.15589319928076979', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:53', 294, 0, '', '2019-05-27 12:39:53');
INSERT INTO `access_log` VALUES (11382, '64.84.15589319956166983', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:56', 10, 0, '', '2019-05-27 12:39:56');
INSERT INTO `access_log` VALUES (11383, '64.77.15589319958336983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:56', 2, 0, '', '2019-05-27 12:39:56');
INSERT INTO `access_log` VALUES (11384, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:56', 10, 0, '', '2019-05-27 12:39:56');
INSERT INTO `access_log` VALUES (11385, '64.76.15589319960676981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:56', 3, 0, '', '2019-05-27 12:39:56');
INSERT INTO `access_log` VALUES (11386, '64.83.15589319963056979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:56', 2, 0, '', '2019-05-27 12:39:56');
INSERT INTO `access_log` VALUES (11387, '59.78.15589319964677729', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:56', 5, 0, '', '2019-05-27 12:39:56');
INSERT INTO `access_log` VALUES (11388, '59.74.15589319964677727', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:56', 15, 2001001000, '服务端发生异常', '2019-05-27 12:39:56');
INSERT INTO `access_log` VALUES (11389, '64.78.15589319968956983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:57', 4, 0, '', '2019-05-27 12:39:57');
INSERT INTO `access_log` VALUES (11390, '64.79.15589319970046977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:57', 3, 0, '', '2019-05-27 12:39:57');
INSERT INTO `access_log` VALUES (11391, '59.71.15589319979467727', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:58', 4, 0, '', '2019-05-27 12:39:58');
INSERT INTO `access_log` VALUES (11392, '59.80.15589319979477725', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.247.170.236', '2019-05-27 12:39:58', 12, 2001001000, '服务端发生异常', '2019-05-27 12:39:58');
INSERT INTO `access_log` VALUES (11393, '65.54.15589377602287063', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:00', 0, 1002001015, '账号未登陆', '2019-05-27 14:16:00');
INSERT INTO `access_log` VALUES (11394, '65.51.15589377602287073', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:00', 0, 1002001015, '账号未登陆', '2019-05-27 14:16:00');
INSERT INTO `access_log` VALUES (11395, '65.45.15589377602297085', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:00', 0, 1002001015, '账号未登陆', '2019-05-27 14:16:00');
INSERT INTO `access_log` VALUES (11396, '65.48.15589377644067091', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:04', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 14:16:04');
INSERT INTO `access_log` VALUES (11397, '65.53.15589377705607071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:11', 55, 0, '', '2019-05-27 14:16:11');
INSERT INTO `access_log` VALUES (11398, '65.49.15589377709577073', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:11', 12, 0, '', '2019-05-27 14:16:11');
INSERT INTO `access_log` VALUES (11399, '65.50.15589377709657075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:11', 10, 0, '', '2019-05-27 14:16:11');
INSERT INTO `access_log` VALUES (11400, '65.47.15589377709717081', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:11', 12, 0, '', '2019-05-27 14:16:11');
INSERT INTO `access_log` VALUES (11401, '62.88.15589377808537743', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:21', 24, 0, '', '2019-05-27 14:16:21');
INSERT INTO `access_log` VALUES (11402, '64.83.15589377887247057', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:29', 20, 0, '', '2019-05-27 14:16:29');
INSERT INTO `access_log` VALUES (11403, '64.76.15589377887207059', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:29', 25, 0, '', '2019-05-27 14:16:29');
INSERT INTO `access_log` VALUES (11404, '64.79.15589377926247055', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:33', 13, 0, '', '2019-05-27 14:16:33');
INSERT INTO `access_log` VALUES (11405, '64.78.15589377926237061', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:33', 16, 0, '', '2019-05-27 14:16:33');
INSERT INTO `access_log` VALUES (11406, '64.85.15589378042917059', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:44', 10, 0, '', '2019-05-27 14:16:44');
INSERT INTO `access_log` VALUES (11407, '64.82.15589378042877063', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:44', 14, 0, '', '2019-05-27 14:16:44');
INSERT INTO `access_log` VALUES (11408, '64.80.15589378042857053', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:16:44', 29, 0, '', '2019-05-27 14:16:44');
INSERT INTO `access_log` VALUES (11409, '64.76.15589378461027061', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:17:26', 13, 0, '', '2019-05-27 14:17:26');
INSERT INTO `access_log` VALUES (11410, '64.79.15589378461027057', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:17:26', 15, 0, '', '2019-05-27 14:17:26');
INSERT INTO `access_log` VALUES (11411, '65.46.15589378510807077', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:17:31', 377, 0, '', '2019-05-27 14:17:31');
INSERT INTO `access_log` VALUES (11412, '65.50.15589378628827077', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:17:43', 19, 0, '', '2019-05-27 14:17:43');
INSERT INTO `access_log` VALUES (11413, '65.47.15589378644337083', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:17:44', 19, 0, '', '2019-05-27 14:17:44');
INSERT INTO `access_log` VALUES (11414, '65.49.15589378686737075', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:17:49', 11, 0, '', '2019-05-27 14:17:49');
INSERT INTO `access_log` VALUES (11415, '65.52.15589378708517083', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:17:51', 19, 0, '', '2019-05-27 14:17:51');
INSERT INTO `access_log` VALUES (11416, '65.45.15589378900677089', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:18:10', 13, 0, '', '2019-05-27 14:18:10');
INSERT INTO `access_log` VALUES (11417, '65.53.15589379293057075', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:18:49', 12, 0, '', '2019-05-27 14:18:49');
INSERT INTO `access_log` VALUES (11418, '59.74.15589379336367807', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:18:54', 22, 0, '', '2019-05-27 14:18:54');
INSERT INTO `access_log` VALUES (11419, '59.78.15589379381877809', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:18:58', 21, 2001001000, '服务端发生异常', '2019-05-27 14:18:58');
INSERT INTO `access_log` VALUES (11420, '59.71.15589379421527807', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:19:02', 88, 0, '', '2019-05-27 14:19:02');
INSERT INTO `access_log` VALUES (11421, '59.76.15589379508777801', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:19:11', 14, 0, '', '2019-05-27 14:19:11');
INSERT INTO `access_log` VALUES (11422, '66.55.15589379649896835', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:19:25', 29, 0, '', '2019-05-27 14:19:25');
INSERT INTO `access_log` VALUES (11423, '64.79.15589379806917059', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.38.227.194', '2019-05-27 14:19:41', 12, 0, '', '2019-05-27 14:19:41');
INSERT INTO `access_log` VALUES (11424, '65.49.15589400463967105', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.86.234.2', '2019-05-27 14:54:06', 1, 1002001015, '账号未登陆', '2019-05-27 14:54:06');
INSERT INTO `access_log` VALUES (11425, '65.47.15589400463977113', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.86.234.2', '2019-05-27 14:54:06', 1, 1002001015, '账号未登陆', '2019-05-27 14:54:06');
INSERT INTO `access_log` VALUES (11426, '65.52.15589400464057113', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.86.234.2', '2019-05-27 14:54:06', 3, 1002001015, '账号未登陆', '2019-05-27 14:54:06');
INSERT INTO `access_log` VALUES (11427, '65.51.15589400500557107', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.86.234.2', '2019-05-27 14:54:10', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 14:54:10');
INSERT INTO `access_log` VALUES (11428, '65.45.15589400573507119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yyudaoyuanma&password=yyudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.86.234.2', '2019-05-27 14:54:17', 276, 1002002000, '账号不存在', '2019-05-27 14:54:18');
INSERT INTO `access_log` VALUES (11429, '65.54.15589417045997121', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:21:45', 0, 1002001015, '账号未登陆', '2019-05-27 15:21:45');
INSERT INTO `access_log` VALUES (11430, '65.47.15589417045997135', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:21:45', 1, 1002001015, '账号未登陆', '2019-05-27 15:21:45');
INSERT INTO `access_log` VALUES (11431, '65.51.15589417046107131', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:21:45', 0, 1002001015, '账号未登陆', '2019-05-27 15:21:45');
INSERT INTO `access_log` VALUES (11432, '65.48.15589417147307149', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:21:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 15:21:55');
INSERT INTO `access_log` VALUES (11433, '65.46.15589417242297131', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:22:04', 71, 0, '', '2019-05-27 15:22:04');
INSERT INTO `access_log` VALUES (11434, '65.50.15589417247997133', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:22:05', 16, 0, '', '2019-05-27 15:22:05');
INSERT INTO `access_log` VALUES (11435, '65.53.15589417247997127', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:22:05', 16, 0, '', '2019-05-27 15:22:05');
INSERT INTO `access_log` VALUES (11436, '65.52.15589417248017139', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:22:05', 14, 0, '', '2019-05-27 15:22:05');
INSERT INTO `access_log` VALUES (11437, '62.80.15589417320227793', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:22:12', 24, 0, '', '2019-05-27 15:22:12');
INSERT INTO `access_log` VALUES (11438, '62.87.15589417390837797', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:22:19', 16, 0, '', '2019-05-27 15:22:19');
INSERT INTO `access_log` VALUES (11439, '62.85.15589417464087793', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:22:26', 14, 0, '', '2019-05-27 15:22:26');
INSERT INTO `access_log` VALUES (11440, '64.82.15589417521157117', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:22:32', 25, 0, '', '2019-05-27 15:22:32');
INSERT INTO `access_log` VALUES (11441, '64.81.15589417521127111', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:22:32', 29, 0, '', '2019-05-27 15:22:32');
INSERT INTO `access_log` VALUES (11442, '64.84.15589417662317117', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:22:46', 12, 0, '', '2019-05-27 15:22:46');
INSERT INTO `access_log` VALUES (11443, '64.85.15589417662297113', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:22:46', 17, 0, '', '2019-05-27 15:22:46');
INSERT INTO `access_log` VALUES (11444, '59.74.15589417790867859', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:22:59', 21, 0, '', '2019-05-27 15:22:59');
INSERT INTO `access_log` VALUES (11445, '59.71.15589417924417859', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:23:12', 376, 2001001000, '服务端发生异常', '2019-05-27 15:23:13');
INSERT INTO `access_log` VALUES (11446, '65.48.15589417955747151', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:23:16', 20, 0, '', '2019-05-27 15:23:16');
INSERT INTO `access_log` VALUES (11447, '65.46.15589417985377133', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:23:19', 11, 0, '', '2019-05-27 15:23:19');
INSERT INTO `access_log` VALUES (11448, '65.50.15589418014347135', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:23:21', 10, 0, '', '2019-05-27 15:23:21');
INSERT INTO `access_log` VALUES (11449, '65.52.15589418047137141', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Safari/604.1.38', '119.123.128.149', '2019-05-27 15:23:25', 15, 0, '', '2019-05-27 15:23:25');
INSERT INTO `access_log` VALUES (11450, '65.46.15589444556287169', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:07:36', 1, 1002001015, '账号未登陆', '2019-05-27 16:07:36');
INSERT INTO `access_log` VALUES (11451, '65.50.15589444556297171', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:07:36', 0, 1002001015, '账号未登陆', '2019-05-27 16:07:36');
INSERT INTO `access_log` VALUES (11452, '65.53.15589444556297165', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:07:36', 0, 1002001015, '账号未登陆', '2019-05-27 16:07:36');
INSERT INTO `access_log` VALUES (11453, '65.49.15589444661427169', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:07:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 16:07:46');
INSERT INTO `access_log` VALUES (11454, '65.51.15589444720207171', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:07:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 16:07:52');
INSERT INTO `access_log` VALUES (11455, '65.54.15589444798067161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:08:00', 183, 0, '', '2019-05-27 16:08:00');
INSERT INTO `access_log` VALUES (11456, '65.45.15589444802567183', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:08:00', 11, 0, '', '2019-05-27 16:08:00');
INSERT INTO `access_log` VALUES (11457, '65.48.15589444802657189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:08:00', 9, 0, '', '2019-05-27 16:08:00');
INSERT INTO `access_log` VALUES (11458, '65.46.15589444802747171', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:08:00', 9, 0, '', '2019-05-27 16:08:00');
INSERT INTO `access_log` VALUES (11459, '64.79.15589444868277147', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:08:07', 23, 0, '', '2019-05-27 16:08:07');
INSERT INTO `access_log` VALUES (11460, '64.76.15589444868267151', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:08:07', 27, 0, '', '2019-05-27 16:08:07');
INSERT INTO `access_log` VALUES (11461, '64.82.15589444958847155', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:08:16', 20, 0, '', '2019-05-27 16:08:16');
INSERT INTO `access_log` VALUES (11462, '64.78.15589444958837153', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:08:16', 22, 0, '', '2019-05-27 16:08:16');
INSERT INTO `access_log` VALUES (11463, '64.80.15589444998347145', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:08:20', 14, 0, '', '2019-05-27 16:08:20');
INSERT INTO `access_log` VALUES (11464, '64.81.15589444998307149', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:08:20', 18, 0, '', '2019-05-27 16:08:20');
INSERT INTO `access_log` VALUES (11465, '64.85.15589444998397151', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:08:20', 17, 0, '', '2019-05-27 16:08:20');
INSERT INTO `access_log` VALUES (11466, '64.83.15589445105127151', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:08:31', 12, 0, '', '2019-05-27 16:08:31');
INSERT INTO `access_log` VALUES (11467, '64.77.15589445105117155', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:08:31', 13, 0, '', '2019-05-27 16:08:31');
INSERT INTO `access_log` VALUES (11468, '64.81.15589445700927151', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:09:30', 11, 0, '', '2019-05-27 16:09:30');
INSERT INTO `access_log` VALUES (11469, '59.79.15589445859697893', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:09:46', 21, 0, '', '2019-05-27 16:09:46');
INSERT INTO `access_log` VALUES (11470, '59.78.15589446037287899', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.188.103', '2019-05-27 16:10:04', 4, 0, '', '2019-05-27 16:10:04');
INSERT INTO `access_log` VALUES (11471, '59.71.15589446037287897', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.188.103', '2019-05-27 16:10:04', 14, 2001001000, '服务端发生异常', '2019-05-27 16:10:04');
INSERT INTO `access_log` VALUES (11472, '65.47.15589446194937179', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.188.103', '2019-05-27 16:10:19', 415, 1002001012, '访问令牌已过期', '2019-05-27 16:10:20');
INSERT INTO `access_log` VALUES (11473, '65.51.15589446194947175', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.188.103', '2019-05-27 16:10:19', 415, 1002001012, '访问令牌已过期', '2019-05-27 16:10:20');
INSERT INTO `access_log` VALUES (11474, '65.49.15589446194937173', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.188.103', '2019-05-27 16:10:19', 415, 1002001012, '访问令牌已过期', '2019-05-27 16:10:20');
INSERT INTO `access_log` VALUES (11475, '65.46.15589446249867173', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.188.103', '2019-05-27 16:10:25', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 16:10:25');
INSERT INTO `access_log` VALUES (11476, '59.75.15589446348467897', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:10:35', 4, 0, '', '2019-05-27 16:10:35');
INSERT INTO `access_log` VALUES (11477, '59.72.15589446348517893', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 16:10:35', 13, 2001001000, '服务端发生异常', '2019-05-27 16:10:35');
INSERT INTO `access_log` VALUES (11478, '59.74.15589446585837899', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.188.103', '2019-05-27 16:10:59', 14, 2001001000, '服务端发生异常', '2019-05-27 16:10:59');
INSERT INTO `access_log` VALUES (11479, '59.79.15589446585837895', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.188.103', '2019-05-27 16:10:59', 171, 0, '', '2019-05-27 16:10:59');
INSERT INTO `access_log` VALUES (11480, '59.79.15589447771637897', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '42.101.64.102', '2019-05-27 16:12:57', 4, 0, '', '2019-05-27 16:12:57');
INSERT INTO `access_log` VALUES (11481, '59.74.15589447771657901', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '42.101.64.102', '2019-05-27 16:12:57', 11, 2001001000, '服务端发生异常', '2019-05-27 16:12:57');
INSERT INTO `access_log` VALUES (11482, '59.71.15589447863627901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:13:06', 4, 0, '', '2019-05-27 16:13:06');
INSERT INTO `access_log` VALUES (11483, '59.80.15589447863627899', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:13:06', 20, 2001001000, '服务端发生异常', '2019-05-27 16:13:06');
INSERT INTO `access_log` VALUES (11484, '64.84.15589448925277161', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageno=1&pagesize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36 QIHU 360SE/Nutch-1.13', '61.129.39.81', '2019-05-27 16:14:53', 1, 1002001015, '账号未登陆', '2019-05-27 16:14:53');
INSERT INTO `access_log` VALUES (11485, '64.83.15589449184537157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:18', 3, 0, '', '2019-05-27 16:15:18');
INSERT INTO `access_log` VALUES (11486, '64.76.15589449185987159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:19', 3, 0, '', '2019-05-27 16:15:19');
INSERT INTO `access_log` VALUES (11487, '64.79.15589449201997155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:20', 3, 0, '', '2019-05-27 16:15:20');
INSERT INTO `access_log` VALUES (11488, '64.78.15589449209007161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:21', 3, 0, '', '2019-05-27 16:15:21');
INSERT INTO `access_log` VALUES (11489, '64.81.15589449216597157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:22', 3, 0, '', '2019-05-27 16:15:22');
INSERT INTO `access_log` VALUES (11490, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:22', 19, 0, '', '2019-05-27 16:15:22');
INSERT INTO `access_log` VALUES (11491, '64.85.15589449242347159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:24', 2, 0, '', '2019-05-27 16:15:24');
INSERT INTO `access_log` VALUES (11492, '64.80.15589449245507153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:25', 2, 0, '', '2019-05-27 16:15:25');
INSERT INTO `access_log` VALUES (11493, '64.84.15589449260337163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:26', 2, 0, '', '2019-05-27 16:15:26');
INSERT INTO `access_log` VALUES (11494, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:26', 9, 0, '', '2019-05-27 16:15:26');
INSERT INTO `access_log` VALUES (11495, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:29', 9, 0, '', '2019-05-27 16:15:29');
INSERT INTO `access_log` VALUES (11496, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:30', 9, 0, '', '2019-05-27 16:15:30');
INSERT INTO `access_log` VALUES (11497, '64.77.15589449308337163', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:31', 11, 0, '', '2019-05-27 16:15:31');
INSERT INTO `access_log` VALUES (11498, '64.76.15589449442027161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:44', 3, 0, '', '2019-05-27 16:15:44');
INSERT INTO `access_log` VALUES (11499, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:44', 8, 0, '', '2019-05-27 16:15:44');
INSERT INTO `access_log` VALUES (11500, '64.79.15589449451467157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:45', 2, 0, '', '2019-05-27 16:15:45');
INSERT INTO `access_log` VALUES (11501, '64.82.15589449454537165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:15:45', 2, 0, '', '2019-05-27 16:15:45');
INSERT INTO `access_log` VALUES (11502, '66.49.15589451327416923', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13333333333&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:18:53', 24, 1001003001, '验证码已过期', '2019-05-27 16:18:53');
INSERT INTO `access_log` VALUES (11503, '66.50.15589451355896921', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13333333333', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:18:56', 80, 0, '', '2019-05-27 16:18:56');
INSERT INTO `access_log` VALUES (11504, '66.56.15589451377956921', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13333333333&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:18:58', 403, 0, '', '2019-05-27 16:18:58');
INSERT INTO `access_log` VALUES (11505, '64.84.15589451429287167', 66, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:19:03', 6, 0, '', '2019-05-27 16:19:03');
INSERT INTO `access_log` VALUES (11506, '64.83.15589451431967163', 66, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:19:03', 6, 0, '', '2019-05-27 16:19:03');
INSERT INTO `access_log` VALUES (11507, '66.57.15589451445116927', 66, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:19:05', 8, 0, '', '2019-05-27 16:19:05');
INSERT INTO `access_log` VALUES (11508, '66.48.15589451531766927', 66, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:19:13', 8, 0, '', '2019-05-27 16:19:13');
INSERT INTO `access_log` VALUES (11509, '59.79.15589451569277903', 66, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:19:17', 14, 0, '', '2019-05-27 16:19:17');
INSERT INTO `access_log` VALUES (11510, '59.78.15589451579707909', 66, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:19:18', 8, 0, '', '2019-05-27 16:19:18');
INSERT INTO `access_log` VALUES (11511, '59.80.15589451585067905', 66, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:19:19', 8, 0, '', '2019-05-27 16:19:19');
INSERT INTO `access_log` VALUES (11512, '66.53.15589451647766927', 66, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:19:25', 7, 0, '', '2019-05-27 16:19:25');
INSERT INTO `access_log` VALUES (11513, '64.82.15589451669437169', 66, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:19:27', 7, 0, '', '2019-05-27 16:19:27');
INSERT INTO `access_log` VALUES (11514, '64.78.15589451671377167', 66, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:19:27', 10, 0, '', '2019-05-27 16:19:27');
INSERT INTO `access_log` VALUES (11515, '59.73.15589451693697909', 66, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:19:29', 16, 2001001000, '服务端发生异常', '2019-05-27 16:19:29');
INSERT INTO `access_log` VALUES (11516, '59.75.15589451692937907', 66, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:19:29', 100, 0, '', '2019-05-27 16:19:29');
INSERT INTO `access_log` VALUES (11517, '64.81.15589453211117165', 66, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:22:01', 8, 0, '', '2019-05-27 16:22:01');
INSERT INTO `access_log` VALUES (11518, '64.85.15589453212767167', 66, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:22:01', 6, 0, '', '2019-05-27 16:22:01');
INSERT INTO `access_log` VALUES (11519, '66.52.15589453219266927', 66, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:22:02', 11, 0, '', '2019-05-27 16:22:02');
INSERT INTO `access_log` VALUES (11520, '64.80.15589453223527161', 66, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:22:02', 6, 0, '', '2019-05-27 16:22:02');
INSERT INTO `access_log` VALUES (11521, '64.84.15589453225537171', 66, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:22:03', 6, 0, '', '2019-05-27 16:22:03');
INSERT INTO `access_log` VALUES (11522, '59.79.15589453227777907', 66, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:22:03', 7, 0, '', '2019-05-27 16:22:03');
INSERT INTO `access_log` VALUES (11523, '59.74.15589453228497911', 66, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '42.101.64.102', '2019-05-27 16:22:03', 23, 2001001000, '服务端发生异常', '2019-05-27 16:22:03');
INSERT INTO `access_log` VALUES (11524, '65.54.15589458815887181', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:31:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 16:31:22');
INSERT INTO `access_log` VALUES (11525, '65.46.15589458911017191', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:31:31', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 16:31:31');
INSERT INTO `access_log` VALUES (11526, '65.48.15589458968057209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:31:37', 86, 0, '', '2019-05-27 16:31:37');
INSERT INTO `access_log` VALUES (11527, '65.53.15589458971827187', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:31:37', 11, 0, '', '2019-05-27 16:31:37');
INSERT INTO `access_log` VALUES (11528, '65.50.15589458971867195', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:31:37', 11, 0, '', '2019-05-27 16:31:37');
INSERT INTO `access_log` VALUES (11529, '65.52.15589458972217199', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:31:37', 11, 0, '', '2019-05-27 16:31:37');
INSERT INTO `access_log` VALUES (11530, '65.51.15589459057987195', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:31:46', 9, 0, '', '2019-05-27 16:31:46');
INSERT INTO `access_log` VALUES (11531, '65.49.15589459058017193', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:31:46', 10, 0, '', '2019-05-27 16:31:46');
INSERT INTO `access_log` VALUES (11532, '65.54.15589459058047183', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:31:46', 10, 0, '', '2019-05-27 16:31:46');
INSERT INTO `access_log` VALUES (11533, '65.45.15589459101757205', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:31:50', 9, 0, '', '2019-05-27 16:31:50');
INSERT INTO `access_log` VALUES (11534, '65.46.15589459101787193', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:31:50', 10, 0, '', '2019-05-27 16:31:50');
INSERT INTO `access_log` VALUES (11535, '65.48.15589459101817211', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:31:50', 9, 0, '', '2019-05-27 16:31:50');
INSERT INTO `access_log` VALUES (11536, '62.86.15589459266047839', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:32:07', 26, 0, '', '2019-05-27 16:32:07');
INSERT INTO `access_log` VALUES (11537, '64.76.15589459333707177', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:32:13', 13, 0, '', '2019-05-27 16:32:13');
INSERT INTO `access_log` VALUES (11538, '64.83.15589459333707175', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:32:13', 14, 0, '', '2019-05-27 16:32:13');
INSERT INTO `access_log` VALUES (11539, '66.50.15589459389966933', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:32:19', 20, 0, '', '2019-05-27 16:32:19');
INSERT INTO `access_log` VALUES (11540, '59.80.15589459417497917', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:32:22', 15, 0, '', '2019-05-27 16:32:22');
INSERT INTO `access_log` VALUES (11541, '59.76.15589459446177913', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:32:25', 21, 2001001000, '服务端发生异常', '2019-05-27 16:32:25');
INSERT INTO `access_log` VALUES (11542, '65.47.15589459465707201', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:32:27', 639, 0, '', '2019-05-27 16:32:27');
INSERT INTO `access_log` VALUES (11543, '65.54.15589459476647185', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:32:28', 11, 0, '', '2019-05-27 16:32:28');
INSERT INTO `access_log` VALUES (11544, '65.49.15589459486917195', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:32:29', 10, 0, '', '2019-05-27 16:32:29');
INSERT INTO `access_log` VALUES (11545, '65.51.15589459503607197', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:32:30', 16, 0, '', '2019-05-27 16:32:30');
INSERT INTO `access_log` VALUES (11546, '59.77.15589459535867917', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.176.50', '2019-05-27 16:32:34', 13, 0, '', '2019-05-27 16:32:34');
INSERT INTO `access_log` VALUES (11547, '65.49.15589460563177197', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:34:16', 0, 1002001015, '账号未登陆', '2019-05-27 16:34:16');
INSERT INTO `access_log` VALUES (11548, '65.54.15589460563177187', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:34:16', 0, 1002001015, '账号未登陆', '2019-05-27 16:34:16');
INSERT INTO `access_log` VALUES (11549, '65.51.15589460563317199', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:34:16', 0, 1002001015, '账号未登陆', '2019-05-27 16:34:16');
INSERT INTO `access_log` VALUES (11550, '65.45.15589460587287209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:34:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 16:34:19');
INSERT INTO `access_log` VALUES (11551, '65.46.15589460643477197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:34:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 16:34:24');
INSERT INTO `access_log` VALUES (11552, '65.49.15589461480427199', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:35:48', 75, 0, '', '2019-05-27 16:35:48');
INSERT INTO `access_log` VALUES (11553, '65.54.15589461493797189', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:35:49', 125, 0, '', '2019-05-27 16:35:50');
INSERT INTO `access_log` VALUES (11554, '65.45.15589461493807211', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:35:49', 122, 0, '', '2019-05-27 16:35:50');
INSERT INTO `access_log` VALUES (11555, '65.48.15589461493807217', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:35:49', 126, 0, '', '2019-05-27 16:35:50');
INSERT INTO `access_log` VALUES (11556, '62.82.15589461577517851', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:35:58', 15, 0, '', '2019-05-27 16:35:58');
INSERT INTO `access_log` VALUES (11557, '64.80.15589461617107173', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:36:02', 14, 0, '', '2019-05-27 16:36:02');
INSERT INTO `access_log` VALUES (11558, '64.84.15589461617237183', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:36:02', 10, 0, '', '2019-05-27 16:36:02');
INSERT INTO `access_log` VALUES (11559, '64.76.15589461663797181', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:36:06', 10, 0, '', '2019-05-27 16:36:06');
INSERT INTO `access_log` VALUES (11560, '64.83.15589461663777179', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:36:06', 14, 0, '', '2019-05-27 16:36:06');
INSERT INTO `access_log` VALUES (11561, '64.79.15589461740837177', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:36:14', 40, 0, '', '2019-05-27 16:36:14');
INSERT INTO `access_log` VALUES (11562, '59.71.15589461881177923', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:36:28', 14, 0, '', '2019-05-27 16:36:28');
INSERT INTO `access_log` VALUES (11563, '59.80.15589461917707921', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-27 16:36:32', 39, 2001001000, '服务端发生异常', '2019-05-27 16:36:32');
INSERT INTO `access_log` VALUES (11564, '64.78.15589494861877227', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:31:26', 739, 1002001012, '访问令牌已过期', '2019-05-27 17:31:27');
INSERT INTO `access_log` VALUES (11565, '65.46.15589494911947243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:31:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 17:31:31');
INSERT INTO `access_log` VALUES (11566, '65.51.15589495178007249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:31:58', 92, 0, '', '2019-05-27 17:31:58');
INSERT INTO `access_log` VALUES (11567, '65.47.15589495181627253', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:31:58', 17, 0, '', '2019-05-27 17:31:58');
INSERT INTO `access_log` VALUES (11568, '65.49.15589495181677247', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:31:58', 21, 0, '', '2019-05-27 17:31:58');
INSERT INTO `access_log` VALUES (11569, '65.48.15589495181687263', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:31:58', 21, 0, '', '2019-05-27 17:31:58');
INSERT INTO `access_log` VALUES (11570, '62.89.15589495290317895', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:32:09', 26, 0, '', '2019-05-27 17:32:09');
INSERT INTO `access_log` VALUES (11571, '62.83.15589495403807903', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:32:20', 25, 0, '', '2019-05-27 17:32:20');
INSERT INTO `access_log` VALUES (11572, '66.55.15589495538596993', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:32:34', 23, 0, '', '2019-05-27 17:32:34');
INSERT INTO `access_log` VALUES (11573, '59.79.15589495630757965', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:32:43', 22, 0, '', '2019-05-27 17:32:43');
INSERT INTO `access_log` VALUES (11574, '59.74.15589495685387969', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:32:49', 21, 2001001000, '服务端发生异常', '2019-05-27 17:32:49');
INSERT INTO `access_log` VALUES (11575, '59.71.15589495764987969', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:32:56', 48, 0, '', '2019-05-27 17:32:57');
INSERT INTO `access_log` VALUES (11576, '65.53.15589495859547243', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:33:06', 20, 0, '', '2019-05-27 17:33:06');
INSERT INTO `access_log` VALUES (11577, '65.52.15589495883747253', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:33:08', 11, 0, '', '2019-05-27 17:33:08');
INSERT INTO `access_log` VALUES (11578, '65.49.15589495903197249', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:33:10', 20, 0, '', '2019-05-27 17:33:10');
INSERT INTO `access_log` VALUES (11579, '65.47.15589495952177255', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:33:15', 11, 0, '', '2019-05-27 17:33:15');
INSERT INTO `access_log` VALUES (11580, '65.48.15589495974257265', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:33:17', 9, 0, '', '2019-05-27 17:33:17');
INSERT INTO `access_log` VALUES (11581, '65.45.15589495988177261', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-27 17:33:19', 15, 0, '', '2019-05-27 17:33:19');
INSERT INTO `access_log` VALUES (11582, '65.45.15589503179717271', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.80.43.14', '2019-05-27 17:45:18', 1, 1002001015, '账号未登陆', '2019-05-27 17:45:18');
INSERT INTO `access_log` VALUES (11583, '65.54.15589503179797247', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.80.43.14', '2019-05-27 17:45:18', 0, 1002001015, '账号未登陆', '2019-05-27 17:45:18');
INSERT INTO `access_log` VALUES (11584, '65.48.15589503179717275', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.80.43.14', '2019-05-27 17:45:18', 1, 1002001015, '账号未登陆', '2019-05-27 17:45:18');
INSERT INTO `access_log` VALUES (11585, '65.51.15589503724087263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.80.43.14', '2019-05-27 17:46:12', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 17:46:12');
INSERT INTO `access_log` VALUES (11586, '65.47.15589503858317267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.80.43.14', '2019-05-27 17:46:26', 129, 0, '', '2019-05-27 17:46:26');
INSERT INTO `access_log` VALUES (11587, '65.54.15589503867367249', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.80.43.14', '2019-05-27 17:46:27', 10, 0, '', '2019-05-27 17:46:27');
INSERT INTO `access_log` VALUES (11588, '65.48.15589503867357277', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.80.43.14', '2019-05-27 17:46:27', 11, 0, '', '2019-05-27 17:46:27');
INSERT INTO `access_log` VALUES (11589, '65.45.15589503867847273', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.80.43.14', '2019-05-27 17:46:27', 10, 0, '', '2019-05-27 17:46:27');
INSERT INTO `access_log` VALUES (11590, '62.83.15589503917697917', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.80.43.14', '2019-05-27 17:46:32', 16, 0, '', '2019-05-27 17:46:32');
INSERT INTO `access_log` VALUES (11591, '62.89.15589504074507909', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.80.43.14', '2019-05-27 17:46:47', 17, 0, '', '2019-05-27 17:46:47');
INSERT INTO `access_log` VALUES (11592, '66.56.15589504121256993', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.80.43.14', '2019-05-27 17:46:52', 14, 0, '', '2019-05-27 17:46:52');
INSERT INTO `access_log` VALUES (11593, '59.79.15589504177937977', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.80.43.14', '2019-05-27 17:46:58', 14, 0, '', '2019-05-27 17:46:58');
INSERT INTO `access_log` VALUES (11594, '65.51.15589506038187267', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.80.43.14', '2019-05-27 17:50:04', 20, 0, '', '2019-05-27 17:50:04');
INSERT INTO `access_log` VALUES (11595, '65.49.15589506052187265', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.80.43.14', '2019-05-27 17:50:05', 10, 0, '', '2019-05-27 17:50:05');
INSERT INTO `access_log` VALUES (11596, '65.45.15589506424037277', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:50:42', 1, 1002001015, '账号未登陆', '2019-05-27 17:50:42');
INSERT INTO `access_log` VALUES (11597, '65.50.15589506424077267', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:50:42', 0, 1002001015, '账号未登陆', '2019-05-27 17:50:42');
INSERT INTO `access_log` VALUES (11598, '65.46.15589506424147263', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:50:42', 0, 1002001015, '账号未登陆', '2019-05-27 17:50:42');
INSERT INTO `access_log` VALUES (11599, '65.53.15589506449487261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:50:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 17:50:45');
INSERT INTO `access_log` VALUES (11600, '65.51.15589506575087269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:50:58', 819, 0, '', '2019-05-27 17:50:58');
INSERT INTO `access_log` VALUES (11601, '65.49.15589506587037267', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:50:59', 10, 0, '', '2019-05-27 17:50:59');
INSERT INTO `access_log` VALUES (11602, '65.47.15589506587107273', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:50:59', 8, 0, '', '2019-05-27 17:50:59');
INSERT INTO `access_log` VALUES (11603, '65.54.15589506587147255', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:50:59', 9, 0, '', '2019-05-27 17:50:59');
INSERT INTO `access_log` VALUES (11604, '62.86.15589506669797905', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:51:07', 16, 0, '', '2019-05-27 17:51:07');
INSERT INTO `access_log` VALUES (11605, '65.46.15589506898857265', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:51:30', 20, 0, '', '2019-05-27 17:51:30');
INSERT INTO `access_log` VALUES (11606, '65.50.15589506910927269', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:51:31', 11, 0, '', '2019-05-27 17:51:31');
INSERT INTO `access_log` VALUES (11607, '65.53.15589506922807263', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:51:32', 555, 0, '', '2019-05-27 17:51:33');
INSERT INTO `access_log` VALUES (11608, '65.52.15589506932547273', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:51:33', 13, 0, '', '2019-05-27 17:51:33');
INSERT INTO `access_log` VALUES (11609, '59.79.15589506963547981', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:51:36', 14, 0, '', '2019-05-27 17:51:36');
INSERT INTO `access_log` VALUES (11610, '59.74.15589507003987985', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:51:40', 15, 0, '', '2019-05-27 17:51:40');
INSERT INTO `access_log` VALUES (11611, '59.78.15589507053587987', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:51:45', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-27 17:51:45');
INSERT INTO `access_log` VALUES (11612, '66.56.15589507106466997', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:51:51', 55, 0, '', '2019-05-27 17:51:51');
INSERT INTO `access_log` VALUES (11613, '64.84.15589507215847245', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:02', 20, 0, '', '2019-05-27 17:52:02');
INSERT INTO `access_log` VALUES (11614, '64.80.15589507215847235', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:02', 26, 0, '', '2019-05-27 17:52:02');
INSERT INTO `access_log` VALUES (11615, '64.76.15589507253797243', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:05', 13, 0, '', '2019-05-27 17:52:05');
INSERT INTO `access_log` VALUES (11616, '64.77.15589507253797245', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:05', 16, 0, '', '2019-05-27 17:52:05');
INSERT INTO `access_log` VALUES (11617, '64.78.15589507302347245', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:10', 55, 0, '', '2019-05-27 17:52:10');
INSERT INTO `access_log` VALUES (11618, '64.82.15589507302297247', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:10', 63, 0, '', '2019-05-27 17:52:10');
INSERT INTO `access_log` VALUES (11619, '64.79.15589507302277239', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:10', 67, 0, '', '2019-05-27 17:52:10');
INSERT INTO `access_log` VALUES (11620, '64.84.15589507586897247', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=6&name=XL', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:39', 9, 1002002009, NULL, '2019-05-27 17:52:39');
INSERT INTO `access_log` VALUES (11621, '62.83.15589507677857923', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:48', 15, 0, '', '2019-05-27 17:52:48');
INSERT INTO `access_log` VALUES (11622, '64.83.15589507710547243', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:51', 12, 0, '', '2019-05-27 17:52:51');
INSERT INTO `access_log` VALUES (11623, '64.76.15589507710537245', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:51', 16, 0, '', '2019-05-27 17:52:51');
INSERT INTO `access_log` VALUES (11624, '64.77.15589507710537247', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:51', 22, 0, '', '2019-05-27 17:52:51');
INSERT INTO `access_log` VALUES (11625, '64.82.15589507715377249', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:52', 12, 0, '', '2019-05-27 17:52:52');
INSERT INTO `access_log` VALUES (11626, '64.78.15589507715377247', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:52', 14, 0, '', '2019-05-27 17:52:52');
INSERT INTO `access_log` VALUES (11627, '66.53.15589507718887003', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:52', 16, 0, '', '2019-05-27 17:52:52');
INSERT INTO `access_log` VALUES (11628, '59.73.15589507720837987', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:52', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-27 17:52:52');
INSERT INTO `access_log` VALUES (11629, '59.75.15589507722317985', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:52', 14, 0, '', '2019-05-27 17:52:52');
INSERT INTO `access_log` VALUES (11630, '59.79.15589507725507983', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:53', 13, 0, '', '2019-05-27 17:52:53');
INSERT INTO `access_log` VALUES (11631, '65.45.15589507729007281', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:53', 15, 0, '', '2019-05-27 17:52:53');
INSERT INTO `access_log` VALUES (11632, '65.46.15589507732607267', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:53', 9, 0, '', '2019-05-27 17:52:53');
INSERT INTO `access_log` VALUES (11633, '65.50.15589507736867271', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:54', 11, 0, '', '2019-05-27 17:52:54');
INSERT INTO `access_log` VALUES (11634, '65.52.15589507740697275', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:52:54', 19, 0, '', '2019-05-27 17:52:54');
INSERT INTO `access_log` VALUES (11635, '62.84.15589507882637919', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:53:08', 14, 0, '', '2019-05-27 17:53:08');
INSERT INTO `access_log` VALUES (11636, '62.80.15589507884297923', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.240.160.119', '2019-05-27 17:53:08', 13, 0, '', '2019-05-27 17:53:08');
INSERT INTO `access_log` VALUES (11637, '59.76.15589514295447989', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:03:50', 4, 0, '', '2019-05-27 18:03:50');
INSERT INTO `access_log` VALUES (11638, '59.77.15589514295457993', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:03:50', 14, 2001001000, '服务端发生异常', '2019-05-27 18:03:50');
INSERT INTO `access_log` VALUES (11639, '64.80.15589514339247247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:03:54', 3, 0, '', '2019-05-27 18:03:54');
INSERT INTO `access_log` VALUES (11640, '64.83.15589514340937253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:03:54', 2, 0, '', '2019-05-27 18:03:54');
INSERT INTO `access_log` VALUES (11641, '65.48.15589514410847295', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:01', 3, 1002001012, '访问令牌已过期', '2019-05-27 18:04:01');
INSERT INTO `access_log` VALUES (11642, '65.46.15589514410857277', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:01', 3, 1002001012, '访问令牌已过期', '2019-05-27 18:04:01');
INSERT INTO `access_log` VALUES (11643, '65.45.15589514410847291', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:01', 3, 1002001012, '访问令牌已过期', '2019-05-27 18:04:01');
INSERT INTO `access_log` VALUES (11644, '65.50.15589514470677281', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:07', 314, 0, '', '2019-05-27 18:04:07');
INSERT INTO `access_log` VALUES (11645, '65.53.15589514476767275', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:08', 11, 0, '', '2019-05-27 18:04:08');
INSERT INTO `access_log` VALUES (11646, '65.52.15589514476827285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:08', 10, 0, '', '2019-05-27 18:04:08');
INSERT INTO `access_log` VALUES (11647, '65.51.15589514476837283', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:08', 9, 0, '', '2019-05-27 18:04:08');
INSERT INTO `access_log` VALUES (11648, '62.83.15589514586567939', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:19', 16, 0, '', '2019-05-27 18:04:19');
INSERT INTO `access_log` VALUES (11649, '62.89.15589514739797931', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 18:04:18&createEndTime=2019-05-21 18:04:18&paymentBeginTime=2019-06-27 18:04:18&paymentEndTime=2019-06-27 18:04:18&orderSubject=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:34', 714, 2001001000, '服务端发生异常', '2019-05-27 18:04:35');
INSERT INTO `access_log` VALUES (11650, '62.84.15589514814117929', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:41', 16, 0, '', '2019-05-27 18:04:41');
INSERT INTO `access_log` VALUES (11651, '62.80.15589514817237933', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:42', 14, 0, '', '2019-05-27 18:04:42');
INSERT INTO `access_log` VALUES (11652, '62.88.15589514902847939', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 18:04:18&createEndTime=2019-06-30 18:04:18', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:50', 18, 0, '', '2019-05-27 18:04:50');
INSERT INTO `access_log` VALUES (11653, '62.87.15589514977707941', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 18:04:18&createEndTime=2019-06-30 18:04:18&orderSubject=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:58', 167, 2001001000, '服务端发生异常', '2019-05-27 18:04:58');
INSERT INTO `access_log` VALUES (11654, '62.80.15589515837207935', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 18:04:18&createEndTime=2019-06-30 18:04:18&payChannel=9999', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:06:24', 465, 0, '', '2019-05-27 18:06:24');
INSERT INTO `access_log` VALUES (11655, '62.88.15589515864187941', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 18:04:18&createEndTime=2019-06-30 18:04:18&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:06:26', 15, 0, '', '2019-05-27 18:06:26');
INSERT INTO `access_log` VALUES (11656, '62.85.15589515887797935', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 18:04:18&createEndTime=2019-06-30 18:04:18&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:06:29', 14, 0, '', '2019-05-27 18:06:29');
INSERT INTO `access_log` VALUES (11657, '62.87.15589515922937943', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 18:04:18&createEndTime=2019-06-30 18:04:18&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:06:32', 26, 0, '', '2019-05-27 18:06:32');
INSERT INTO `access_log` VALUES (11658, '62.82.15589515943377937', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 18:04:18&createEndTime=2019-06-30 18:04:18&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:06:34', 24, 0, '', '2019-05-27 18:06:34');
INSERT INTO `access_log` VALUES (11659, '62.89.15589516223057935', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 18:04:18&createEndTime=2019-06-30 18:04:18', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:07:02', 16, 0, '', '2019-05-27 18:07:02');
INSERT INTO `access_log` VALUES (11660, '64.79.15589516262027253', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:07:06', 306, 0, '', '2019-05-27 18:07:07');
INSERT INTO `access_log` VALUES (11661, '64.78.15589516261997259', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:07:06', 313, 0, '', '2019-05-27 18:07:07');
INSERT INTO `access_log` VALUES (11662, '65.46.15589516329587281', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:07:13', 4, 0, '', '2019-05-27 18:07:13');
INSERT INTO `access_log` VALUES (11663, '65.48.15589516402257299', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:07:20', 3, 0, '', '2019-05-27 18:07:20');
INSERT INTO `access_log` VALUES (11664, '64.83.15589516894257257', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=111', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:08:09', 9, 1002002009, NULL, '2019-05-27 18:08:09');
INSERT INTO `access_log` VALUES (11665, '64.82.15589517285807263', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=123123&sellPoint=1&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/a9c6a5c0-3854-4c2d-bbfe-01f7bf4479b2,http://static.shop.iocoder.cn/6f095caf-9032-482d-890f-4f633fae3760&skuStr=[{\"attrs\":[4,29],\"price\":100,\"quantity\":1},{\"attrs\":[4,28],\"price\":100,\"quantity\":1},{\"attrs\":[4,31],\"price\":100,\"quantity\":1},{\"attrs\":[4,34],\"price\":100,\"quantity\":1}]&description=<p>sadddddddddddddddddddddd</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:08:49', 9, 1002002009, NULL, '2019-05-27 18:08:49');
INSERT INTO `access_log` VALUES (11666, '64.81.15589517598517257', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=123123&sellPoint=1&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/a9c6a5c0-3854-4c2d-bbfe-01f7bf4479b2,http://static.shop.iocoder.cn/6f095caf-9032-482d-890f-4f633fae3760&skuStr=[{\"attrs\":[4,29],\"price\":100,\"quantity\":1},{\"attrs\":[4,28],\"price\":100,\"quantity\":1},{\"attrs\":[4,31],\"price\":100,\"quantity\":1},{\"attrs\":[4,34],\"price\":100,\"quantity\":1}]&description=<p>sadddddddddddddddddddddd</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:09:20', 8, 1002002009, NULL, '2019-05-27 18:09:20');
INSERT INTO `access_log` VALUES (11667, '65.48.15589517771347301', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:09:37', 11, 0, '', '2019-05-27 18:09:37');
INSERT INTO `access_log` VALUES (11668, '65.45.15589517771397297', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:09:37', 9, 0, '', '2019-05-27 18:09:37');
INSERT INTO `access_log` VALUES (11669, '65.50.15589517771407287', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:09:37', 9, 0, '', '2019-05-27 18:09:37');
INSERT INTO `access_log` VALUES (11670, '64.83.15589517773267259', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:09:37', 24, 0, '', '2019-05-27 18:09:37');
INSERT INTO `access_log` VALUES (11671, '64.80.15589517773217253', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:09:37', 32, 0, '', '2019-05-27 18:09:37');
INSERT INTO `access_log` VALUES (11672, '65.53.15589519385507283', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:12:19', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 18:12:19');
INSERT INTO `access_log` VALUES (11673, '65.52.15589519413857293', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:12:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 18:12:21');
INSERT INTO `access_log` VALUES (11674, '65.49.15589519533697289', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:12:33', 71, 0, '', '2019-05-27 18:12:33');
INSERT INTO `access_log` VALUES (11675, '65.54.15589519537457277', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:12:34', 10, 0, '', '2019-05-27 18:12:34');
INSERT INTO `access_log` VALUES (11676, '65.46.15589519537507287', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:12:34', 10, 0, '', '2019-05-27 18:12:34');
INSERT INTO `access_log` VALUES (11677, '65.48.15589519537517305', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:12:34', 10, 0, '', '2019-05-27 18:12:34');
INSERT INTO `access_log` VALUES (11678, '65.45.15589525661477309', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:22:46', 0, 1002001015, '账号未登陆', '2019-05-27 18:22:46');
INSERT INTO `access_log` VALUES (11679, '65.51.15589525661497301', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:22:46', 0, 1002001015, '账号未登陆', '2019-05-27 18:22:46');
INSERT INTO `access_log` VALUES (11680, '65.53.15589525661517293', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:22:46', 0, 1002001015, '账号未登陆', '2019-05-27 18:22:46');
INSERT INTO `access_log` VALUES (11681, '65.46.15589527658697299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:26:06', 65, 0, '', '2019-05-27 18:26:06');
INSERT INTO `access_log` VALUES (11682, '65.48.15589527664247317', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:26:06', 10, 0, '', '2019-05-27 18:26:06');
INSERT INTO `access_log` VALUES (11683, '65.54.15589527664247289', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:26:06', 11, 0, '', '2019-05-27 18:26:06');
INSERT INTO `access_log` VALUES (11684, '65.50.15589527664247303', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:26:06', 11, 0, '', '2019-05-27 18:26:06');
INSERT INTO `access_log` VALUES (11685, '64.85.15589527754217273', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:26:15', 13, 0, '', '2019-05-27 18:26:15');
INSERT INTO `access_log` VALUES (11686, '64.84.15589527754217277', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:26:15', 15, 0, '', '2019-05-27 18:26:15');
INSERT INTO `access_log` VALUES (11687, '59.73.15589527961828015', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:26:36', 13, 0, '', '2019-05-27 18:26:36');
INSERT INTO `access_log` VALUES (11688, '65.52.15589528019417307', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:26:42', 21, 0, '', '2019-05-27 18:26:42');
INSERT INTO `access_log` VALUES (11689, '65.47.15589528083877309', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:26:48', 11, 0, '', '2019-05-27 18:26:48');
INSERT INTO `access_log` VALUES (11690, '65.49.15589528098617303', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:26:50', 9, 0, '', '2019-05-27 18:26:50');
INSERT INTO `access_log` VALUES (11691, '59.77.15589529032238013', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:28:23', 13, 0, '', '2019-05-27 18:28:23');
INSERT INTO `access_log` VALUES (11692, '59.72.15589529059428011', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:28:26', 21, 2001001000, '服务端发生异常', '2019-05-27 18:28:26');
INSERT INTO `access_log` VALUES (11693, '59.73.15589529127878017', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:28:33', 14, 0, '', '2019-05-27 18:28:33');
INSERT INTO `access_log` VALUES (11694, '65.47.15589529224237311', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:28:42', 10, 0, '', '2019-05-27 18:28:42');
INSERT INTO `access_log` VALUES (11695, '65.49.15589529225827305', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:28:43', 11, 0, '', '2019-05-27 18:28:43');
INSERT INTO `access_log` VALUES (11696, '65.46.15589529227037303', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:28:43', 19, 0, '', '2019-05-27 18:28:43');
INSERT INTO `access_log` VALUES (11697, '59.79.15589529233828013', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:28:43', 12, 0, '', '2019-05-27 18:28:43');
INSERT INTO `access_log` VALUES (11698, '64.80.15589529279427269', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:28:48', 11, 0, '', '2019-05-27 18:28:48');
INSERT INTO `access_log` VALUES (11699, '64.83.15589529279427275', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '117.136.79.120', '2019-05-27 18:28:48', 13, 0, '', '2019-05-27 18:28:48');
INSERT INTO `access_log` VALUES (11700, '65.46.15589563645337349', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:05', 0, 1002001015, '账号未登陆', '2019-05-27 19:26:05');
INSERT INTO `access_log` VALUES (11701, '65.50.15589563645427353', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:05', 2, 1002001015, '账号未登陆', '2019-05-27 19:26:05');
INSERT INTO `access_log` VALUES (11702, '65.54.15589563645397339', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:05', 0, 1002001015, '账号未登陆', '2019-05-27 19:26:05');
INSERT INTO `access_log` VALUES (11703, '65.48.15589563686147367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:09', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 19:26:09');
INSERT INTO `access_log` VALUES (11704, '65.45.15589563813847363', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:21', 321, 0, '', '2019-05-27 19:26:22');
INSERT INTO `access_log` VALUES (11705, '65.51.15589563821667355', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:22', 675, 0, '', '2019-05-27 19:26:23');
INSERT INTO `access_log` VALUES (11706, '65.47.15589563821847359', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:22', 659, 0, '', '2019-05-27 19:26:23');
INSERT INTO `access_log` VALUES (11707, '65.52.15589563821717357', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:22', 672, 0, '', '2019-05-27 19:26:23');
INSERT INTO `access_log` VALUES (11708, '65.54.15589563912777341', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:31', 9, 0, '', '2019-05-27 19:26:31');
INSERT INTO `access_log` VALUES (11709, '65.46.15589563912927351', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:31', 10, 0, '', '2019-05-27 19:26:31');
INSERT INTO `access_log` VALUES (11710, '65.50.15589563912927355', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:31', 9, 0, '', '2019-05-27 19:26:31');
INSERT INTO `access_log` VALUES (11711, '64.82.15589563915077327', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:32', 18, 0, '', '2019-05-27 19:26:32');
INSERT INTO `access_log` VALUES (11712, '64.77.15589563915017325', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:32', 24, 0, '', '2019-05-27 19:26:32');
INSERT INTO `access_log` VALUES (11713, '64.81.15589563996637321', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:40', 10, 0, '', '2019-05-27 19:26:40');
INSERT INTO `access_log` VALUES (11714, '64.78.15589563996587325', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:40', 71, 0, '', '2019-05-27 19:26:40');
INSERT INTO `access_log` VALUES (11715, '65.53.15589564118077349', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:52', 9, 0, '', '2019-05-27 19:26:52');
INSERT INTO `access_log` VALUES (11716, '65.45.15589564118107365', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:52', 9, 0, '', '2019-05-27 19:26:52');
INSERT INTO `access_log` VALUES (11717, '65.51.15589564118277357', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:52', 9, 0, '', '2019-05-27 19:26:52');
INSERT INTO `access_log` VALUES (11718, '65.52.15589564119177359', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:26:52', 10, 0, '', '2019-05-27 19:26:52');
INSERT INTO `access_log` VALUES (11719, '65.54.15589564361267343', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:27:16', 10, 0, '', '2019-05-27 19:27:16');
INSERT INTO `access_log` VALUES (11720, '65.50.15589564361327357', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:27:16', 9, 0, '', '2019-05-27 19:27:16');
INSERT INTO `access_log` VALUES (11721, '65.46.15589564361447353', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:27:16', 8, 0, '', '2019-05-27 19:27:16');
INSERT INTO `access_log` VALUES (11722, '62.89.15589564362988005', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16E227 UCBrowser/12.4.3.1168 Mobile  AliApp(TUnionSDK/0.1.20.3)', '171.216.69.205', '2019-05-27 19:27:16', 24, 0, '', '2019-05-27 19:27:16');
INSERT INTO `access_log` VALUES (11723, '65.46.15589577751627371', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-27 19:49:35', 95, 0, '', '2019-05-27 19:49:35');
INSERT INTO `access_log` VALUES (11724, '65.48.15589577757037389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-27 19:49:36', 10, 0, '', '2019-05-27 19:49:36');
INSERT INTO `access_log` VALUES (11725, '65.45.15589577757037385', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-27 19:49:36', 11, 0, '', '2019-05-27 19:49:36');
INSERT INTO `access_log` VALUES (11726, '65.51.15589577757127377', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-27 19:49:36', 10, 0, '', '2019-05-27 19:49:36');
INSERT INTO `access_log` VALUES (11727, '65.52.15589577928327379', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-27 19:49:53', 61, 0, '', '2019-05-27 19:49:53');
INSERT INTO `access_log` VALUES (11728, '65.47.15589577931277381', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-27 19:49:53', 8, 0, '', '2019-05-27 19:49:53');
INSERT INTO `access_log` VALUES (11729, '65.49.15589577931357375', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-27 19:49:53', 7, 0, '', '2019-05-27 19:49:53');
INSERT INTO `access_log` VALUES (11730, '65.54.15589577931417363', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-27 19:49:53', 7, 0, '', '2019-05-27 19:49:53');
INSERT INTO `access_log` VALUES (11731, '65.53.15589578643447371', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-27 19:51:04', 11, 0, '', '2019-05-27 19:51:04');
INSERT INTO `access_log` VALUES (11732, '59.71.15589676584338213', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.248.41.230', '2019-05-27 22:34:18', 13, 0, '', '2019-05-27 22:34:18');
INSERT INTO `access_log` VALUES (11733, '59.80.15589676584368211', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.248.41.230', '2019-05-27 22:34:18', 16, 2001001000, '服务端发生异常', '2019-05-27 22:34:18');
INSERT INTO `access_log` VALUES (11734, '64.85.15589676698847473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.248.41.230', '2019-05-27 22:34:30', 14, 0, '', '2019-05-27 22:34:30');
INSERT INTO `access_log` VALUES (11735, '64.80.15589676700227467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.248.41.230', '2019-05-27 22:34:30', 5, 0, '', '2019-05-27 22:34:30');
INSERT INTO `access_log` VALUES (11736, '64.83.15589676711497473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.248.41.230', '2019-05-27 22:34:31', 4, 0, '', '2019-05-27 22:34:31');
INSERT INTO `access_log` VALUES (11737, '64.76.15589676717627475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.248.41.230', '2019-05-27 22:34:32', 2, 0, '', '2019-05-27 22:34:32');
INSERT INTO `access_log` VALUES (11738, '64.77.15589676722867477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.248.41.230', '2019-05-27 22:34:32', 3, 0, '', '2019-05-27 22:34:32');
INSERT INTO `access_log` VALUES (11739, '59.77.15589676729238211', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.248.41.230', '2019-05-27 22:34:33', 4, 0, '', '2019-05-27 22:34:33');
INSERT INTO `access_log` VALUES (11740, '59.72.15589676729258209', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.248.41.230', '2019-05-27 22:34:33', 14, 2001001000, '服务端发生异常', '2019-05-27 22:34:33');
INSERT INTO `access_log` VALUES (11741, '64.79.15589676778177471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.248.41.230', '2019-05-27 22:34:38', 3, 0, '', '2019-05-27 22:34:38');
INSERT INTO `access_log` VALUES (11742, '64.81.15589676779317473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '114.248.41.230', '2019-05-27 22:34:38', 15, 0, '', '2019-05-27 22:34:38');
INSERT INTO `access_log` VALUES (11743, '65.49.15589678201647511', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '153.99.183.165', '2019-05-27 22:37:00', 0, 1002001015, '账号未登陆', '2019-05-27 22:37:00');
INSERT INTO `access_log` VALUES (11744, '59.71.15589685115818225', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.176.227.9', '2019-05-27 22:48:32', 11, 0, '', '2019-05-27 22:48:32');
INSERT INTO `access_log` VALUES (11745, '59.76.15589685115818219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.176.227.9', '2019-05-27 22:48:32', 20, 2001001000, '服务端发生异常', '2019-05-27 22:48:32');
INSERT INTO `access_log` VALUES (11746, '64.76.15589685153947487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.176.227.9', '2019-05-27 22:48:35', 4, 0, '', '2019-05-27 22:48:35');
INSERT INTO `access_log` VALUES (11747, '64.82.15589685155547491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.176.227.9', '2019-05-27 22:48:36', 3, 0, '', '2019-05-27 22:48:36');
INSERT INTO `access_log` VALUES (11748, '64.79.15589685166137483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.176.227.9', '2019-05-27 22:48:37', 2, 0, '', '2019-05-27 22:48:37');
INSERT INTO `access_log` VALUES (11749, '59.72.15589685177038221', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.176.227.9', '2019-05-27 22:48:38', 4, 0, '', '2019-05-27 22:48:38');
INSERT INTO `access_log` VALUES (11750, '59.73.15589685177048227', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.176.227.9', '2019-05-27 22:48:38', 14, 2001001000, '服务端发生异常', '2019-05-27 22:48:38');
INSERT INTO `access_log` VALUES (11751, '64.81.15589685260517485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.176.227.9', '2019-05-27 22:48:46', 3, 0, '', '2019-05-27 22:48:46');
INSERT INTO `access_log` VALUES (11752, '64.78.15589685261977489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.176.227.9', '2019-05-27 22:48:46', 2, 0, '', '2019-05-27 22:48:46');
INSERT INTO `access_log` VALUES (11753, '65.49.15589685358437521', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.176.227.9', '2019-05-27 22:48:56', 1, 1002001015, '账号未登陆', '2019-05-27 22:48:56');
INSERT INTO `access_log` VALUES (11754, '65.54.15589685358437507', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.176.227.9', '2019-05-27 22:48:56', 1, 1002001015, '账号未登陆', '2019-05-27 22:48:56');
INSERT INTO `access_log` VALUES (11755, '65.50.15589685358437521', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.176.227.9', '2019-05-27 22:48:56', 0, 1002001015, '账号未登陆', '2019-05-27 22:48:56');
INSERT INTO `access_log` VALUES (11756, '65.49.15589724721027575', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.70.177', '2019-05-27 23:54:32', 14, 1002001012, '访问令牌已过期', '2019-05-27 23:54:32');
INSERT INTO `access_log` VALUES (11757, '65.50.15589724721037575', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.70.177', '2019-05-27 23:54:32', 16, 1002001012, '访问令牌已过期', '2019-05-27 23:54:32');
INSERT INTO `access_log` VALUES (11758, '65.53.15589724721207569', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.70.177', '2019-05-27 23:54:32', 13, 1002001012, '访问令牌已过期', '2019-05-27 23:54:32');
INSERT INTO `access_log` VALUES (11759, '65.46.15589724744807573', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.70.177', '2019-05-27 23:54:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-27 23:54:34');
INSERT INTO `access_log` VALUES (11760, '65.48.15589724804367591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.70.177', '2019-05-27 23:54:40', 89, 0, '', '2019-05-27 23:54:41');
INSERT INTO `access_log` VALUES (11761, '65.45.15589724807707585', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.70.177', '2019-05-27 23:54:41', 11, 0, '', '2019-05-27 23:54:41');
INSERT INTO `access_log` VALUES (11762, '65.51.15589724807717575', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.70.177', '2019-05-27 23:54:41', 12, 0, '', '2019-05-27 23:54:41');
INSERT INTO `access_log` VALUES (11763, '65.52.15589724807777577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.70.177', '2019-05-27 23:54:41', 9, 0, '', '2019-05-27 23:54:41');
INSERT INTO `access_log` VALUES (11764, '62.83.15589724883328227', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.70.177', '2019-05-27 23:54:48', 24, 0, '', '2019-05-27 23:54:48');
INSERT INTO `access_log` VALUES (11765, '62.89.15589724949598219', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=5&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.70.177', '2019-05-27 23:54:55', 16, 0, '', '2019-05-27 23:54:55');
INSERT INTO `access_log` VALUES (11766, '59.78.15589799621458381', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:22', 13, 0, '', '2019-05-28 01:59:22');
INSERT INTO `access_log` VALUES (11767, '59.80.15589799621458377', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:22', 17, 2001001000, '服务端发生异常', '2019-05-28 01:59:22');
INSERT INTO `access_log` VALUES (11768, '64.83.15589799669187639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:27', 12, 0, '', '2019-05-28 01:59:27');
INSERT INTO `access_log` VALUES (11769, '64.76.15589799671707641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:27', 4, 0, '', '2019-05-28 01:59:27');
INSERT INTO `access_log` VALUES (11770, '59.71.15589799682818379', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:28', 4, 0, '', '2019-05-28 01:59:28');
INSERT INTO `access_log` VALUES (11771, '59.76.15589799682818373', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:28', 15, 2001001000, '服务端发生异常', '2019-05-28 01:59:28');
INSERT INTO `access_log` VALUES (11772, '59.73.15589799761978381', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:36', 10, 0, '', '2019-05-28 01:59:36');
INSERT INTO `access_log` VALUES (11773, '59.72.15589799761978375', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:36', 20, 2001001000, '服务端发生异常', '2019-05-28 01:59:36');
INSERT INTO `access_log` VALUES (11774, '59.75.15589799852868379', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:45', 4, 0, '', '2019-05-28 01:59:45');
INSERT INTO `access_log` VALUES (11775, '59.79.15589799852888377', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:45', 13, 2001001000, '服务端发生异常', '2019-05-28 01:59:45');
INSERT INTO `access_log` VALUES (11776, '64.82.15589799872417645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:47', 2, 0, '', '2019-05-28 01:59:47');
INSERT INTO `access_log` VALUES (11777, '64.79.15589799875617637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:48', 3, 0, '', '2019-05-28 01:59:48');
INSERT INTO `access_log` VALUES (11778, '64.81.15589799886797639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:49', 3, 0, '', '2019-05-28 01:59:49');
INSERT INTO `access_log` VALUES (11779, '64.78.15589799892347643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:49', 3, 0, '', '2019-05-28 01:59:49');
INSERT INTO `access_log` VALUES (11780, '59.80.15589799902438379', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:50', 4, 0, '', '2019-05-28 01:59:50');
INSERT INTO `access_log` VALUES (11781, '59.78.15589799902468383', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:50', 12, 2001001000, '服务端发生异常', '2019-05-28 01:59:50');
INSERT INTO `access_log` VALUES (11782, '64.78.15589799892347643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:49', 3, 0, '', '2019-05-28 01:59:50');
INSERT INTO `access_log` VALUES (11783, '59.71.15589799933178381', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:53', 4, 0, '', '2019-05-28 01:59:53');
INSERT INTO `access_log` VALUES (11784, '59.76.15589799933208375', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:53', 14, 2001001000, '服务端发生异常', '2019-05-28 01:59:53');
INSERT INTO `access_log` VALUES (11785, '64.85.15589799936437641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:54', 128, 0, '', '2019-05-28 01:59:54');
INSERT INTO `access_log` VALUES (11786, '64.80.15589799940727635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:54', 450, 0, '', '2019-05-28 01:59:55');
INSERT INTO `access_log` VALUES (11787, '59.77.15589799952258379', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:55', 3, 0, '', '2019-05-28 01:59:55');
INSERT INTO `access_log` VALUES (11788, '59.72.15589799952348377', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 01:59:55', 12, 2001001000, '服务端发生异常', '2019-05-28 01:59:55');
INSERT INTO `access_log` VALUES (11789, '65.48.15589800599607693', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:00', 0, 1002001015, '账号未登陆', '2019-05-28 02:01:00');
INSERT INTO `access_log` VALUES (11790, '65.47.15589800599607681', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:00', 0, 1002001015, '账号未登陆', '2019-05-28 02:01:00');
INSERT INTO `access_log` VALUES (11791, '65.45.15589800600057687', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:00', 1, 1002001015, '账号未登陆', '2019-05-28 02:01:00');
INSERT INTO `access_log` VALUES (11792, '65.54.15589800882457665', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:28', 264, 0, '', '2019-05-28 02:01:29');
INSERT INTO `access_log` VALUES (11793, '65.49.15589800893217679', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:29', 10, 0, '', '2019-05-28 02:01:29');
INSERT INTO `access_log` VALUES (11794, '65.53.15589800893197673', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:29', 13, 0, '', '2019-05-28 02:01:29');
INSERT INTO `access_log` VALUES (11795, '65.50.15589800893277679', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:29', 9, 0, '', '2019-05-28 02:01:29');
INSERT INTO `access_log` VALUES (11796, '65.46.15589800946047677', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:35', 12, 0, '', '2019-05-28 02:01:35');
INSERT INTO `access_log` VALUES (11797, '65.47.15589800946047683', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:35', 12, 0, '', '2019-05-28 02:01:35');
INSERT INTO `access_log` VALUES (11798, '65.48.15589800946167695', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:35', 9, 0, '', '2019-05-28 02:01:35');
INSERT INTO `access_log` VALUES (11799, '65.52.15589801095657681', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:50', 10, 0, '', '2019-05-28 02:01:50');
INSERT INTO `access_log` VALUES (11800, '65.51.15589801095657679', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:50', 11, 0, '', '2019-05-28 02:01:50');
INSERT INTO `access_log` VALUES (11801, '65.54.15589801095757667', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:50', 9, 0, '', '2019-05-28 02:01:50');
INSERT INTO `access_log` VALUES (11802, '65.50.15589801162027681', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:56', 11, 0, '', '2019-05-28 02:01:56');
INSERT INTO `access_log` VALUES (11803, '65.49.15589801162027681', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:56', 11, 0, '', '2019-05-28 02:01:56');
INSERT INTO `access_log` VALUES (11804, '65.48.15589801162057697', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:01:56', 10, 0, '', '2019-05-28 02:01:56');
INSERT INTO `access_log` VALUES (11805, '65.47.15589801236487685', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:02:04', 10, 0, '', '2019-05-28 02:02:04');
INSERT INTO `access_log` VALUES (11806, '65.46.15589801236487679', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:02:04', 10, 0, '', '2019-05-28 02:02:04');
INSERT INTO `access_log` VALUES (11807, '65.45.15589801236507691', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:02:04', 8, 0, '', '2019-05-28 02:02:04');
INSERT INTO `access_log` VALUES (11808, '62.86.15589801242118313', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:02:04', 22, 0, '', '2019-05-28 02:02:04');
INSERT INTO `access_log` VALUES (11809, '65.54.15589801310067669', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:02:11', 9, 0, '', '2019-05-28 02:02:11');
INSERT INTO `access_log` VALUES (11810, '65.53.15589801310167677', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:02:11', 10, 0, '', '2019-05-28 02:02:11');
INSERT INTO `access_log` VALUES (11811, '65.52.15589801310167683', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:02:11', 9, 0, '', '2019-05-28 02:02:11');
INSERT INTO `access_log` VALUES (11812, '59.72.15589801316458379', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:02:12', 14, 0, '', '2019-05-28 02:02:12');
INSERT INTO `access_log` VALUES (11813, '65.50.15589801407697683', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:02:21', 10, 0, '', '2019-05-28 02:02:21');
INSERT INTO `access_log` VALUES (11814, '65.49.15589801407697683', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:02:21', 10, 0, '', '2019-05-28 02:02:21');
INSERT INTO `access_log` VALUES (11815, '65.48.15589801407737699', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:02:21', 8, 0, '', '2019-05-28 02:02:21');
INSERT INTO `access_log` VALUES (11816, '65.45.15589801411887693', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:02:21', 9, 0, '', '2019-05-28 02:02:21');
INSERT INTO `access_log` VALUES (11817, '65.53.15589801997087679', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:03:20', 11, 0, '', '2019-05-28 02:03:20');
INSERT INTO `access_log` VALUES (11818, '65.54.15589801997207671', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:03:20', 10, 0, '', '2019-05-28 02:03:20');
INSERT INTO `access_log` VALUES (11819, '65.50.15589801997237685', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:03:20', 8, 0, '', '2019-05-28 02:03:20');
INSERT INTO `access_log` VALUES (11820, '59.78.15589802002258387', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:03:20', 29, 2001001000, '服务端发生异常', '2019-05-28 02:03:20');
INSERT INTO `access_log` VALUES (11821, '65.48.15589802061827701', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:03:26', 9, 0, '', '2019-05-28 02:03:26');
INSERT INTO `access_log` VALUES (11822, '65.45.15589802062037695', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:03:26', 10, 0, '', '2019-05-28 02:03:26');
INSERT INTO `access_log` VALUES (11823, '65.47.15589802062167689', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:03:26', 9, 0, '', '2019-05-28 02:03:26');
INSERT INTO `access_log` VALUES (11824, '59.71.15589802268218385', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.1; MI 8 Lite Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/4.0.0', '117.136.41.52', '2019-05-28 02:03:47', 221, 0, '', '2019-05-28 02:03:47');
INSERT INTO `access_log` VALUES (11825, '65.54.15590038369377987', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-28 08:37:17', 13, 1002001012, '访问令牌已过期', '2019-05-28 08:37:17');
INSERT INTO `access_log` VALUES (11826, '65.45.15590044815528019', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:48:02', 5, 1002001012, '访问令牌已过期', '2019-05-28 08:48:02');
INSERT INTO `access_log` VALUES (11827, '65.46.15590044815688007', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:48:02', 15, 1002001012, '访问令牌已过期', '2019-05-28 08:48:02');
INSERT INTO `access_log` VALUES (11828, '65.51.15590044815718009', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:48:02', 15, 1002001012, '访问令牌已过期', '2019-05-28 08:48:02');
INSERT INTO `access_log` VALUES (11829, '65.53.15590044945828005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:48:15', 67, 0, '', '2019-05-28 08:48:15');
INSERT INTO `access_log` VALUES (11830, '65.50.15590044950638011', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:48:15', 9, 0, '', '2019-05-28 08:48:15');
INSERT INTO `access_log` VALUES (11831, '65.54.15590044950727997', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:48:15', 9, 0, '', '2019-05-28 08:48:15');
INSERT INTO `access_log` VALUES (11832, '65.49.15590044950778011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:48:15', 9, 0, '', '2019-05-28 08:48:15');
INSERT INTO `access_log` VALUES (11833, '62.83.15590045011918655', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:48:21', 23, 0, '', '2019-05-28 08:48:21');
INSERT INTO `access_log` VALUES (11834, '62.89.15590045062238647', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:48:26', 152, 0, '', '2019-05-28 08:48:26');
INSERT INTO `access_log` VALUES (11835, '64.81.15590045142237967', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:48:34', 31, 0, '', '2019-05-28 08:48:34');
INSERT INTO `access_log` VALUES (11836, '64.79.15590045142227965', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:48:34', 34, 0, '', '2019-05-28 08:48:34');
INSERT INTO `access_log` VALUES (11837, '64.83.15590045556167969', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:49:16', 16, 0, '', '2019-05-28 08:49:16');
INSERT INTO `access_log` VALUES (11838, '64.80.15590045556167963', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:49:16', 21, 0, '', '2019-05-28 08:49:16');
INSERT INTO `access_log` VALUES (11839, '65.54.15590046044067999', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:50:04', 12, 0, '', '2019-05-28 08:50:04');
INSERT INTO `access_log` VALUES (11840, '65.50.15590046062088013', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:50:06', 11, 0, '', '2019-05-28 08:50:06');
INSERT INTO `access_log` VALUES (11841, '65.49.15590046083428013', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:50:08', 15, 0, '', '2019-05-28 08:50:08');
INSERT INTO `access_log` VALUES (11842, '59.78.15590046283518713', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:50:28', 22, 0, '', '2019-05-28 08:50:28');
INSERT INTO `access_log` VALUES (11843, '66.52.15590046595547719', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-05-28 08:51:00', 27, 0, '', '2019-05-28 08:51:00');
INSERT INTO `access_log` VALUES (11844, '59.73.15590055888738725', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:06:29', 5, 0, '', '2019-05-28 09:06:29');
INSERT INTO `access_log` VALUES (11845, '59.75.15590055888748723', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:06:29', 16, 2001001000, '服务端发生异常', '2019-05-28 09:06:29');
INSERT INTO `access_log` VALUES (11846, '65.50.15590056115138027', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:06:52', 1, 1002001015, '账号未登陆', '2019-05-28 09:06:52');
INSERT INTO `access_log` VALUES (11847, '65.49.15590056115138027', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:06:52', 1, 1002001015, '账号未登陆', '2019-05-28 09:06:52');
INSERT INTO `access_log` VALUES (11848, '65.54.15590056115128013', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:06:52', 1, 1002001015, '账号未登陆', '2019-05-28 09:06:52');
INSERT INTO `access_log` VALUES (11849, '65.50.15590057124838029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:08:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 09:08:32');
INSERT INTO `access_log` VALUES (11850, '65.49.15590057240078029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:08:44', 98, 0, '', '2019-05-28 09:08:44');
INSERT INTO `access_log` VALUES (11851, '65.48.15590057244338045', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:08:44', 13, 0, '', '2019-05-28 09:08:44');
INSERT INTO `access_log` VALUES (11852, '65.47.15590057244398033', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:08:44', 12, 0, '', '2019-05-28 09:08:44');
INSERT INTO `access_log` VALUES (11853, '65.45.15590057244848039', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:08:44', 12, 0, '', '2019-05-28 09:08:44');
INSERT INTO `access_log` VALUES (11854, '59.75.15590057245098725', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:08:45', 4, 0, '', '2019-05-28 09:08:45');
INSERT INTO `access_log` VALUES (11855, '59.79.15590057245098723', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:08:45', 12, 2001001000, '服务端发生异常', '2019-05-28 09:08:45');
INSERT INTO `access_log` VALUES (11856, '62.86.15590057311448657', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:08:51', 15, 0, '', '2019-05-28 09:08:51');
INSERT INTO `access_log` VALUES (11857, '64.76.15590057396897987', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:09:00', 14, 0, '', '2019-05-28 09:09:00');
INSERT INTO `access_log` VALUES (11858, '64.80.15590057396857979', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:09:00', 17, 0, '', '2019-05-28 09:09:00');
INSERT INTO `access_log` VALUES (11859, '64.82.15590057421617991', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:09:02', 10, 0, '', '2019-05-28 09:09:02');
INSERT INTO `access_log` VALUES (11860, '64.77.15590057421607989', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:09:02', 14, 0, '', '2019-05-28 09:09:02');
INSERT INTO `access_log` VALUES (11861, '64.81.15590057519497985', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:09:12', 14, 0, '', '2019-05-28 09:09:12');
INSERT INTO `access_log` VALUES (11862, '66.57.15590057530927739', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17621922840', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:13', 108, 0, '', '2019-05-28 09:09:13');
INSERT INTO `access_log` VALUES (11863, '64.78.15590057562547989', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:09:16', 19, 0, '', '2019-05-28 09:09:16');
INSERT INTO `access_log` VALUES (11864, '66.51.15590057579447735', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17621922840&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:18', 221, 0, '', '2019-05-28 09:09:18');
INSERT INTO `access_log` VALUES (11865, '66.56.15590057648797731', 85, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:25', 8, 0, '', '2019-05-28 09:09:25');
INSERT INTO `access_log` VALUES (11866, '59.77.15590057682658725', 85, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:28', 7, 0, '', '2019-05-28 09:09:28');
INSERT INTO `access_log` VALUES (11867, '59.72.15590057682658723', 85, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:28', 18, 2001001000, '服务端发生异常', '2019-05-28 09:09:28');
INSERT INTO `access_log` VALUES (11868, '66.53.15590057702987737', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:09:30', 16, 0, '', '2019-05-28 09:09:30');
INSERT INTO `access_log` VALUES (11869, '64.83.15590057710357987', 85, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:31', 9, 0, '', '2019-05-28 09:09:31');
INSERT INTO `access_log` VALUES (11870, '64.76.15590057711547989', 85, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:31', 8, 0, '', '2019-05-28 09:09:31');
INSERT INTO `access_log` VALUES (11871, '64.77.15590057728707991', 85, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:33', 6, 0, '', '2019-05-28 09:09:33');
INSERT INTO `access_log` VALUES (11872, '64.81.15590057743037987', 85, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:34', 8, 0, '', '2019-05-28 09:09:34');
INSERT INTO `access_log` VALUES (11873, '64.84.15590057766947993', 85, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:37', 6, 0, '', '2019-05-28 09:09:37');
INSERT INTO `access_log` VALUES (11874, '64.85.15590057776237989', 85, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:38', 9, 0, '', '2019-05-28 09:09:38');
INSERT INTO `access_log` VALUES (11875, '64.83.15590057812067989', 85, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:41', 386, 0, '', '2019-05-28 09:09:42');
INSERT INTO `access_log` VALUES (11876, '64.80.15590057818697983', 85, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:42', 17, 0, '', '2019-05-28 09:09:42');
INSERT INTO `access_log` VALUES (11877, '59.75.15590057831848727', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:09:43', 11, 0, '', '2019-05-28 09:09:43');
INSERT INTO `access_log` VALUES (11878, '59.79.15590057837118725', 85, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:44', 7, 0, '', '2019-05-28 09:09:44');
INSERT INTO `access_log` VALUES (11879, '59.74.15590057837248729', 85, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:09:44', 16, 2001001000, '服务端发生异常', '2019-05-28 09:09:44');
INSERT INTO `access_log` VALUES (11880, '59.78.15590057901308731', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:09:50', 22, 2001001000, '服务端发生异常', '2019-05-28 09:09:50');
INSERT INTO `access_log` VALUES (11881, '59.76.15590057929458723', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:09:53', 13, 0, '', '2019-05-28 09:09:53');
INSERT INTO `access_log` VALUES (11882, '64.82.15590058033427995', 85, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:10:03', 7, 0, '', '2019-05-28 09:10:03');
INSERT INTO `access_log` VALUES (11883, '64.77.15590058034597993', 85, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:10:03', 5, 0, '', '2019-05-28 09:10:03');
INSERT INTO `access_log` VALUES (11884, '64.79.15590058049587987', 85, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:10:05', 8, 0, '', '2019-05-28 09:10:05');
INSERT INTO `access_log` VALUES (11885, '64.78.15590058057657993', 85, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:10:06', 6, 0, '', '2019-05-28 09:10:06');
INSERT INTO `access_log` VALUES (11886, '64.84.15590058062537995', 85, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:10:06', 6, 0, '', '2019-05-28 09:10:06');
INSERT INTO `access_log` VALUES (11887, '59.77.15590058082738727', 85, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:10:08', 7, 0, '', '2019-05-28 09:10:08');
INSERT INTO `access_log` VALUES (11888, '59.72.15590058082738725', 85, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.32.189.46', '2019-05-28 09:10:08', 17, 2001001000, '服务端发生异常', '2019-05-28 09:10:08');
INSERT INTO `access_log` VALUES (11889, '65.45.15590058598048041', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:11:00', 21, 0, '', '2019-05-28 09:11:00');
INSERT INTO `access_log` VALUES (11890, '65.51.15590058646508031', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:11:05', 14, 0, '', '2019-05-28 09:11:05');
INSERT INTO `access_log` VALUES (11891, '65.52.15590058716948033', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:11:12', 11, 0, '', '2019-05-28 09:11:12');
INSERT INTO `access_log` VALUES (11892, '65.53.15590058739578027', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:11:14', 13, 0, '', '2019-05-28 09:11:14');
INSERT INTO `access_log` VALUES (11893, '65.50.15590058762228033', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:11:16', 332, 0, '', '2019-05-28 09:11:17');
INSERT INTO `access_log` VALUES (11894, '65.49.15590058871768033', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.225.162', '2019-05-28 09:11:27', 14, 0, '', '2019-05-28 09:11:27');
INSERT INTO `access_log` VALUES (11895, '59.71.15590063679198737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:19:28', 5, 0, '', '2019-05-28 09:19:28');
INSERT INTO `access_log` VALUES (11896, '59.77.15590063679358735', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:19:28', 14, 2001001000, '服务端发生异常', '2019-05-28 09:19:28');
INSERT INTO `access_log` VALUES (11897, '65.50.15590063845198041', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:19:45', 1, 1002001015, '账号未登陆', '2019-05-28 09:19:45');
INSERT INTO `access_log` VALUES (11898, '65.46.15590063845198037', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:19:45', 0, 1002001015, '账号未登陆', '2019-05-28 09:19:45');
INSERT INTO `access_log` VALUES (11899, '65.49.15590063845228041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:19:45', 1, 1002001015, '账号未登陆', '2019-05-28 09:19:45');
INSERT INTO `access_log` VALUES (11900, '65.47.15590063919068045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:19:52', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 09:19:52');
INSERT INTO `access_log` VALUES (11901, '65.46.15590064205298039', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:20:21', 87, 0, '', '2019-05-28 09:20:21');
INSERT INTO `access_log` VALUES (11902, '65.49.15590064212478043', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:20:21', 66, 0, '', '2019-05-28 09:20:21');
INSERT INTO `access_log` VALUES (11903, '65.47.15590064212478047', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:20:21', 68, 0, '', '2019-05-28 09:20:21');
INSERT INTO `access_log` VALUES (11904, '65.50.15590064212468043', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:20:21', 68, 0, '', '2019-05-28 09:20:21');
INSERT INTO `access_log` VALUES (11905, '62.87.15590064267268683', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:20:27', 16, 0, '', '2019-05-28 09:20:27');
INSERT INTO `access_log` VALUES (11906, '66.57.15590064315987749', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:20:32', 17, 0, '', '2019-05-28 09:20:32');
INSERT INTO `access_log` VALUES (11907, '59.80.15590064384778737', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:20:38', 13, 0, '', '2019-05-28 09:20:38');
INSERT INTO `access_log` VALUES (11908, '59.78.15590064455468741', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:20:46', 22, 2001001000, '服务端发生异常', '2019-05-28 09:20:46');
INSERT INTO `access_log` VALUES (11909, '59.71.15590064498668739', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.104.5.242', '2019-05-28 09:20:50', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-28 09:20:50');
INSERT INTO `access_log` VALUES (11910, '65.47.15590092159658085', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:06:56', 0, 1002001015, '账号未登陆', '2019-05-28 10:06:56');
INSERT INTO `access_log` VALUES (11911, '65.50.15590092159658081', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:06:56', 0, 1002001015, '账号未登陆', '2019-05-28 10:06:56');
INSERT INTO `access_log` VALUES (11912, '65.49.15590092159668081', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:06:56', 1, 1002001015, '账号未登陆', '2019-05-28 10:06:56');
INSERT INTO `access_log` VALUES (11913, '65.51.15590092486028081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:07:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 10:07:29');
INSERT INTO `access_log` VALUES (11914, '65.54.15590092549508067', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:07:35', 80, 0, '', '2019-05-28 10:07:35');
INSERT INTO `access_log` VALUES (11915, '65.53.15590092552218075', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:07:35', 13, 0, '', '2019-05-28 10:07:35');
INSERT INTO `access_log` VALUES (11916, '65.52.15590092552288083', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:07:35', 13, 0, '', '2019-05-28 10:07:35');
INSERT INTO `access_log` VALUES (11917, '65.46.15590092552328079', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:07:35', 12, 0, '', '2019-05-28 10:07:35');
INSERT INTO `access_log` VALUES (11918, '62.87.15590092581168721', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:07:38', 27, 0, '', '2019-05-28 10:07:38');
INSERT INTO `access_log` VALUES (11919, '64.83.15590092621638037', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:07:42', 17, 0, '', '2019-05-28 10:07:42');
INSERT INTO `access_log` VALUES (11920, '64.85.15590092621618037', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:07:42', 21, 0, '', '2019-05-28 10:07:42');
INSERT INTO `access_log` VALUES (11921, '64.76.15590092667378039', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:07:47', 13, 0, '', '2019-05-28 10:07:47');
INSERT INTO `access_log` VALUES (11922, '64.80.15590092667358031', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:07:47', 16, 0, '', '2019-05-28 10:07:47');
INSERT INTO `access_log` VALUES (11923, '64.79.15590092692048035', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:07:49', 12, 0, '', '2019-05-28 10:07:49');
INSERT INTO `access_log` VALUES (11924, '64.77.15590092692018041', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:07:49', 17, 0, '', '2019-05-28 10:07:49');
INSERT INTO `access_log` VALUES (11925, '64.82.15590092692008043', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:07:49', 22, 0, '', '2019-05-28 10:07:49');
INSERT INTO `access_log` VALUES (11926, '65.50.15590092778938083', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.207.186', '2019-05-28 10:07:58', 1, 1002001015, '账号未登陆', '2019-05-28 10:07:58');
INSERT INTO `access_log` VALUES (11927, '65.48.15590092779708097', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.236', '2019-05-28 10:07:58', 0, 1002001015, '账号未登陆', '2019-05-28 10:07:58');
INSERT INTO `access_log` VALUES (11928, '65.45.15590092779948089', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.89.239.232', '2019-05-28 10:07:58', 1, 1002001015, '账号未登陆', '2019-05-28 10:07:58');
INSERT INTO `access_log` VALUES (11929, '64.83.15590092966258039', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:08:17', 13, 0, '', '2019-05-28 10:08:17');
INSERT INTO `access_log` VALUES (11930, '64.84.15590092966248043', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:08:17', 15, 0, '', '2019-05-28 10:08:17');
INSERT INTO `access_log` VALUES (11931, '64.76.15590092985068041', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:08:19', 11, 0, '', '2019-05-28 10:08:19');
INSERT INTO `access_log` VALUES (11932, '64.85.15590092985068039', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:08:19', 13, 0, '', '2019-05-28 10:08:19');
INSERT INTO `access_log` VALUES (11933, '64.79.15590093007688037', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:08:21', 75, 0, '', '2019-05-28 10:08:21');
INSERT INTO `access_log` VALUES (11934, '66.54.15590093043297779', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:08:24', 27, 0, '', '2019-05-28 10:08:24');
INSERT INTO `access_log` VALUES (11935, '59.77.15590093116358775', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:08:32', 25, 0, '', '2019-05-28 10:08:32');
INSERT INTO `access_log` VALUES (11936, '64.82.15590093230118045', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.239.216', '2019-05-28 10:08:43', 1, 1002001015, '账号未登陆', '2019-05-28 10:08:43');
INSERT INTO `access_log` VALUES (11937, '64.81.15590093259308039', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.227.139.161', '2019-05-28 10:08:46', 1, 1002001015, '账号未登陆', '2019-05-28 10:08:46');
INSERT INTO `access_log` VALUES (11938, '64.78.15590093267598043', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.197', '2019-05-28 10:08:47', 0, 1002001015, '账号未登陆', '2019-05-28 10:08:47');
INSERT INTO `access_log` VALUES (11939, '64.84.15590093291268045', 0, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.91.60.11', '2019-05-28 10:08:49', 1, 1002001015, '账号未登陆', '2019-05-28 10:08:49');
INSERT INTO `access_log` VALUES (11940, '59.75.15590093315098777', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update', 'id=2&title=芋道源码&url=http://static.shop.iocoder.cn/c3e1f77d-df16-48dd-8ed5-26950dff3944&sort=10&memo=你猜呀哈哈哈哈&picUrl=http://static.shop.iocoder.cn/c3e1f77d-df16-48dd-8ed5-26950dff3944', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:08:52', 9, 1002002009, NULL, '2019-05-28 10:08:52');
INSERT INTO `access_log` VALUES (11941, '59.79.15590093332398775', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update', 'id=2&title=芋道源码&url=http://static.shop.iocoder.cn/c3e1f77d-df16-48dd-8ed5-26950dff3944&sort=10&memo=你猜呀哈哈哈哈&picUrl=http://static.shop.iocoder.cn/c3e1f77d-df16-48dd-8ed5-26950dff3944', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:08:53', 8, 1002002009, NULL, '2019-05-28 10:08:53');
INSERT INTO `access_log` VALUES (11942, '59.74.15590093338168779', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update', 'id=2&title=芋道源码&url=http://static.shop.iocoder.cn/c3e1f77d-df16-48dd-8ed5-26950dff3944&sort=10&memo=你猜呀哈哈哈哈&picUrl=http://static.shop.iocoder.cn/c3e1f77d-df16-48dd-8ed5-26950dff3944', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:08:54', 8, 1002002009, NULL, '2019-05-28 10:08:54');
INSERT INTO `access_log` VALUES (11943, '65.52.15590093384838085', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:08:58', 127, 0, '', '2019-05-28 10:08:59');
INSERT INTO `access_log` VALUES (11944, '65.47.15590093407878089', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:09:01', 12, 0, '', '2019-05-28 10:09:01');
INSERT INTO `access_log` VALUES (11945, '65.50.15590093502598085', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:09:10', 10, 0, '', '2019-05-28 10:09:10');
INSERT INTO `access_log` VALUES (11946, '65.48.15590093524678099', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:09:12', 13, 0, '', '2019-05-28 10:09:12');
INSERT INTO `access_log` VALUES (11947, '65.45.15590093592068091', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:09:19', 10, 0, '', '2019-05-28 10:09:19');
INSERT INTO `access_log` VALUES (11948, '65.51.15590093632978085', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:09:23', 14, 0, '', '2019-05-28 10:09:23');
INSERT INTO `access_log` VALUES (11949, '66.50.15590093640847781', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.227.139.161', '2019-05-28 10:09:24', 1, 1002001015, '账号未登陆', '2019-05-28 10:09:24');
INSERT INTO `access_log` VALUES (11950, '59.76.15590093720268773', 0, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.129.7.235', '2019-05-28 10:09:32', 0, 1002001015, '账号未登陆', '2019-05-28 10:09:32');
INSERT INTO `access_log` VALUES (11951, '65.52.15590093998548087', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '58.247.206.146', '2019-05-28 10:10:00', 0, 1002001015, '账号未登陆', '2019-05-28 10:10:00');
INSERT INTO `access_log` VALUES (11952, '65.47.15590094005378091', 0, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.227.139.161', '2019-05-28 10:10:01', 1, 1002001015, '账号未登陆', '2019-05-28 10:10:01');
INSERT INTO `access_log` VALUES (11953, '65.50.15590094101398087', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.178.166', '2019-05-28 10:10:10', 0, 1002001015, '账号未登陆', '2019-05-28 10:10:10');
INSERT INTO `access_log` VALUES (11954, '65.48.15590094123228101', 0, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.91.60.107', '2019-05-28 10:10:12', 1, 1002001015, '账号未登陆', '2019-05-28 10:10:12');
INSERT INTO `access_log` VALUES (11955, '65.45.15590094193978093', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.178.197', '2019-05-28 10:10:19', 1, 1002001015, '账号未登陆', '2019-05-28 10:10:19');
INSERT INTO `access_log` VALUES (11956, '65.51.15590094231898087', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.91.60.110', '2019-05-28 10:10:23', 0, 1002001015, '账号未登陆', '2019-05-28 10:10:23');
INSERT INTO `access_log` VALUES (11957, '59.79.15590095964628779', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:13:16', 6, 0, '', '2019-05-28 10:13:16');
INSERT INTO `access_log` VALUES (11958, '59.74.15590095964638783', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:13:16', 15, 2001001000, '服务端发生异常', '2019-05-28 10:13:16');
INSERT INTO `access_log` VALUES (11959, '64.84.15590096033398049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:13:23', 4, 0, '', '2019-05-28 10:13:23');
INSERT INTO `access_log` VALUES (11960, '64.83.15590096034298045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:13:23', 2, 0, '', '2019-05-28 10:13:23');
INSERT INTO `access_log` VALUES (11961, '64.76.15590096052178047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:13:25', 3, 0, '', '2019-05-28 10:13:25');
INSERT INTO `access_log` VALUES (11962, '64.85.15590096059148045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:13:26', 3, 0, '', '2019-05-28 10:13:26');
INSERT INTO `access_log` VALUES (11963, '64.80.15590096062908039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:13:26', 3, 0, '', '2019-05-28 10:13:26');
INSERT INTO `access_log` VALUES (11964, '66.52.15590096171617787', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17637900215', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:13:37', 502, 0, '', '2019-05-28 10:13:38');
INSERT INTO `access_log` VALUES (11965, '64.82.15590096434098051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:03', 3, 0, '', '2019-05-28 10:14:03');
INSERT INTO `access_log` VALUES (11966, '64.81.15590096435168045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:04', 2, 0, '', '2019-05-28 10:14:04');
INSERT INTO `access_log` VALUES (11967, '64.78.15590096448298049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:05', 3, 0, '', '2019-05-28 10:14:05');
INSERT INTO `access_log` VALUES (11968, '64.83.15590096456358047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:06', 3, 0, '', '2019-05-28 10:14:06');
INSERT INTO `access_log` VALUES (11969, '64.76.15590096460988049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:06', 2, 0, '', '2019-05-28 10:14:06');
INSERT INTO `access_log` VALUES (11970, '64.85.15590096464678047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:06', 3, 0, '', '2019-05-28 10:14:06');
INSERT INTO `access_log` VALUES (11971, '64.80.15590096468438041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:07', 3, 0, '', '2019-05-28 10:14:07');
INSERT INTO `access_log` VALUES (11972, '64.79.15590096472348045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:07', 4, 0, '', '2019-05-28 10:14:07');
INSERT INTO `access_log` VALUES (11973, '64.77.15590096476458051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:08', 3, 0, '', '2019-05-28 10:14:08');
INSERT INTO `access_log` VALUES (11974, '64.82.15590096480438053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:08', 3, 0, '', '2019-05-28 10:14:08');
INSERT INTO `access_log` VALUES (11975, '64.81.15590096483868047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:08', 3, 0, '', '2019-05-28 10:14:08');
INSERT INTO `access_log` VALUES (11976, '64.78.15590096487478051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:09', 3, 0, '', '2019-05-28 10:14:09');
INSERT INTO `access_log` VALUES (11977, '64.84.15590096490588053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:09', 2, 0, '', '2019-05-28 10:14:09');
INSERT INTO `access_log` VALUES (11978, '64.83.15590096500628049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:10', 3, 0, '', '2019-05-28 10:14:10');
INSERT INTO `access_log` VALUES (11979, '64.76.15590096503548051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:10', 3, 0, '', '2019-05-28 10:14:10');
INSERT INTO `access_log` VALUES (11980, '64.85.15590096506448049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:11', 3, 0, '', '2019-05-28 10:14:11');
INSERT INTO `access_log` VALUES (11981, '64.80.15590096510418043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:11', 3, 0, '', '2019-05-28 10:14:11');
INSERT INTO `access_log` VALUES (11982, '64.79.15590096515548047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:12', 3, 0, '', '2019-05-28 10:14:12');
INSERT INTO `access_log` VALUES (11983, '64.77.15590096519158053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:12', 3, 0, '', '2019-05-28 10:14:12');
INSERT INTO `access_log` VALUES (11984, '64.82.15590096523798055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:12', 3, 0, '', '2019-05-28 10:14:12');
INSERT INTO `access_log` VALUES (11985, '64.81.15590096529708049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:13', 3, 0, '', '2019-05-28 10:14:13');
INSERT INTO `access_log` VALUES (11986, '64.78.15590096534268053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:13', 3, 0, '', '2019-05-28 10:14:13');
INSERT INTO `access_log` VALUES (11987, '64.84.15590096541398055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:14', 2, 0, '', '2019-05-28 10:14:14');
INSERT INTO `access_log` VALUES (11988, '64.83.15590096546668051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:15', 3, 0, '', '2019-05-28 10:14:15');
INSERT INTO `access_log` VALUES (11989, '64.76.15590096551548053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:15', 3, 0, '', '2019-05-28 10:14:15');
INSERT INTO `access_log` VALUES (11990, '64.85.15590096558028051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:16', 3, 0, '', '2019-05-28 10:14:16');
INSERT INTO `access_log` VALUES (11991, '64.80.15590096560828045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:16', 2, 0, '', '2019-05-28 10:14:16');
INSERT INTO `access_log` VALUES (11992, '64.79.15590096597588049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:20', 5, 0, '', '2019-05-28 10:14:20');
INSERT INTO `access_log` VALUES (11993, '64.77.15590096601348055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:20', 2, 0, '', '2019-05-28 10:14:20');
INSERT INTO `access_log` VALUES (11994, '59.72.15590096602208779', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:20', 4, 0, '', '2019-05-28 10:14:20');
INSERT INTO `access_log` VALUES (11995, '59.73.15590096602318785', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:20', 13, 2001001000, '服务端发生异常', '2019-05-28 10:14:20');
INSERT INTO `access_log` VALUES (11996, '64.81.15590096623668051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:22', 2, 0, '', '2019-05-28 10:14:22');
INSERT INTO `access_log` VALUES (11997, '64.78.15590096625178055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:23', 3, 0, '', '2019-05-28 10:14:23');
INSERT INTO `access_log` VALUES (11998, '59.74.15590096656918785', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:26', 4, 0, '', '2019-05-28 10:14:26');
INSERT INTO `access_log` VALUES (11999, '59.75.15590096656908783', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:26', 14, 2001001000, '服务端发生异常', '2019-05-28 10:14:26');
INSERT INTO `access_log` VALUES (12000, '64.84.15590096675048057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:28', 2, 0, '', '2019-05-28 10:14:28');
INSERT INTO `access_log` VALUES (12001, '64.83.15590096676048053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:28', 2, 0, '', '2019-05-28 10:14:28');
INSERT INTO `access_log` VALUES (12002, '59.80.15590096693778783', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:29', 3, 0, '', '2019-05-28 10:14:29');
INSERT INTO `access_log` VALUES (12003, '59.79.15590096693778781', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:29', 15, 2001001000, '服务端发生异常', '2019-05-28 10:14:29');
INSERT INTO `access_log` VALUES (12004, '64.76.15590096718778055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:32', 3, 0, '', '2019-05-28 10:14:32');
INSERT INTO `access_log` VALUES (12005, '64.85.15590096719678053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:32', 2, 0, '', '2019-05-28 10:14:32');
INSERT INTO `access_log` VALUES (12006, '64.80.15590096752068047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:35', 2, 0, '', '2019-05-28 10:14:35');
INSERT INTO `access_log` VALUES (12007, '64.79.15590096753468051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:35', 2, 0, '', '2019-05-28 10:14:35');
INSERT INTO `access_log` VALUES (12008, '64.82.15590096799898059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:40', 3, 0, '', '2019-05-28 10:14:40');
INSERT INTO `access_log` VALUES (12009, '64.81.15590096801858053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:40', 2, 0, '', '2019-05-28 10:14:40');
INSERT INTO `access_log` VALUES (12010, '59.71.15590096805158785', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:41', 10, 0, '', '2019-05-28 10:14:41');
INSERT INTO `access_log` VALUES (12011, '59.76.15590096805158779', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:41', 20, 2001001000, '服务端发生异常', '2019-05-28 10:14:41');
INSERT INTO `access_log` VALUES (12012, '65.51.15590096990948091', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:59', 0, 1002001015, '账号未登陆', '2019-05-28 10:14:59');
INSERT INTO `access_log` VALUES (12013, '65.54.15590096990968077', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:59', 1, 1002001015, '账号未登陆', '2019-05-28 10:14:59');
INSERT INTO `access_log` VALUES (12014, '65.53.15590096990968085', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:14:59', 0, 1002001015, '账号未登陆', '2019-05-28 10:14:59');
INSERT INTO `access_log` VALUES (12015, '65.52.15590097134078093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:13', 340, 0, '', '2019-05-28 10:15:14');
INSERT INTO `access_log` VALUES (12016, '65.47.15590097139138097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:14', 11, 0, '', '2019-05-28 10:15:14');
INSERT INTO `access_log` VALUES (12017, '65.49.15590097139188093', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:14', 9, 0, '', '2019-05-28 10:15:14');
INSERT INTO `access_log` VALUES (12018, '65.50.15590097139198093', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:14', 10, 0, '', '2019-05-28 10:15:14');
INSERT INTO `access_log` VALUES (12019, '62.82.15590097182148723', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:18', 20, 0, '', '2019-05-28 10:15:18');
INSERT INTO `access_log` VALUES (12020, '66.54.15590097191887785', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:19', 15, 0, '', '2019-05-28 10:15:19');
INSERT INTO `access_log` VALUES (12021, '65.48.15590097211918107', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:21', 20, 0, '', '2019-05-28 10:15:21');
INSERT INTO `access_log` VALUES (12022, '65.45.15590097216328099', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:22', 10, 0, '', '2019-05-28 10:15:22');
INSERT INTO `access_log` VALUES (12023, '65.53.15590097222268087', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:22', 10, 0, '', '2019-05-28 10:15:22');
INSERT INTO `access_log` VALUES (12024, '65.46.15590097244608091', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:24', 216, 0, '', '2019-05-28 10:15:25');
INSERT INTO `access_log` VALUES (12025, '65.51.15590097237978093', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:24', 884, 0, '', '2019-05-28 10:15:25');
INSERT INTO `access_log` VALUES (12026, '62.86.15590097360198711', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:36', 16, 0, '', '2019-05-28 10:15:36');
INSERT INTO `access_log` VALUES (12027, '64.80.15590097377758049', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:38', 10, 0, '', '2019-05-28 10:15:38');
INSERT INTO `access_log` VALUES (12028, '64.85.15590097377758055', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:38', 14, 0, '', '2019-05-28 10:15:38');
INSERT INTO `access_log` VALUES (12029, '64.79.15590097395868053', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:40', 14, 0, '', '2019-05-28 10:15:40');
INSERT INTO `access_log` VALUES (12030, '64.77.15590097395868059', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:40', 16, 0, '', '2019-05-28 10:15:40');
INSERT INTO `access_log` VALUES (12031, '64.82.15590097471518061', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:15:47', 145, 0, '', '2019-05-28 10:15:47');
INSERT INTO `access_log` VALUES (12032, '64.78.15590097621588059', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:16:02', 11, 0, '', '2019-05-28 10:16:02');
INSERT INTO `access_log` VALUES (12033, '64.83.15590097623728057', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:16:02', 11, 0, '', '2019-05-28 10:16:02');
INSERT INTO `access_log` VALUES (12034, '64.84.15590097623718061', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:16:02', 12, 0, '', '2019-05-28 10:16:02');
INSERT INTO `access_log` VALUES (12035, '64.85.15590097627448057', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:16:03', 19, 0, '', '2019-05-28 10:16:03');
INSERT INTO `access_log` VALUES (12036, '64.76.15590097627448059', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:16:03', 20, 0, '', '2019-05-28 10:16:03');
INSERT INTO `access_log` VALUES (12037, '62.84.15590097629458713', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '122.234.130.134', '2019-05-28 10:16:03', 17, 0, '', '2019-05-28 10:16:03');
INSERT INTO `access_log` VALUES (12038, '65.52.15590115320928119', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:45:32', 22, 0, '', '2019-05-28 10:45:32');
INSERT INTO `access_log` VALUES (12039, '59.80.15590115515098809', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:45:52', 21, 0, '', '2019-05-28 10:45:52');
INSERT INTO `access_log` VALUES (12040, '65.47.15590115553268123', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:45:55', 14, 0, '', '2019-05-28 10:45:55');
INSERT INTO `access_log` VALUES (12041, '59.79.15590115575028807', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:45:58', 21, 2001001000, '服务端发生异常', '2019-05-28 10:45:58');
INSERT INTO `access_log` VALUES (12042, '59.78.15590115617278813', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 10:46:02', 21, 2001001000, '服务端发生异常', '2019-05-28 10:46:02');
INSERT INTO `access_log` VALUES (12043, '59.73.15590116082718813', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-28 10:46:48', 4, 0, '', '2019-05-28 10:46:48');
INSERT INTO `access_log` VALUES (12044, '59.72.15590116082718807', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-28 10:46:48', 14, 2001001000, '服务端发生异常', '2019-05-28 10:46:48');
INSERT INTO `access_log` VALUES (12045, '64.81.15590116114918081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-28 10:46:51', 12, 0, '', '2019-05-28 10:46:52');
INSERT INTO `access_log` VALUES (12046, '64.78.15590116117718085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-28 10:46:52', 3, 0, '', '2019-05-28 10:46:52');
INSERT INTO `access_log` VALUES (12047, '65.51.15590116152618119', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.129.8.179', '2019-05-28 10:46:55', 1, 1002001015, '账号未登陆', '2019-05-28 10:46:55');
INSERT INTO `access_log` VALUES (12048, '64.84.15590116156228087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-28 10:46:56', 3, 0, '', '2019-05-28 10:46:56');
INSERT INTO `access_log` VALUES (12049, '64.83.15590116168728083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-28 10:46:57', 3, 0, '', '2019-05-28 10:46:57');
INSERT INTO `access_log` VALUES (12050, '64.76.15590116175838085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-28 10:46:58', 2, 0, '', '2019-05-28 10:46:58');
INSERT INTO `access_log` VALUES (12051, '59.75.15590116191458811', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-28 10:46:59', 3, 0, '', '2019-05-28 10:46:59');
INSERT INTO `access_log` VALUES (12052, '59.80.15590116191508811', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-28 10:46:59', 13, 2001001000, '服务端发生异常', '2019-05-28 10:46:59');
INSERT INTO `access_log` VALUES (12053, '59.79.15590116237338809', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.151.178.197', '2019-05-28 10:47:04', 1, 1002001015, '账号未登陆', '2019-05-28 10:47:04');
INSERT INTO `access_log` VALUES (12054, '64.80.15590116304938077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-28 10:47:10', 3, 0, '', '2019-05-28 10:47:10');
INSERT INTO `access_log` VALUES (12055, '64.77.15590116305928087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-28 10:47:11', 2, 0, '', '2019-05-28 10:47:11');
INSERT INTO `access_log` VALUES (12056, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-28 10:47:12', 26, 0, '', '2019-05-28 10:47:12');
INSERT INTO `access_log` VALUES (12057, '64.79.15590116321378081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-28 10:47:12', 292, 0, '', '2019-05-28 10:47:12');
INSERT INTO `access_log` VALUES (12058, '64.82.15590116342348089', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-28 10:47:14', 11, 0, '', '2019-05-28 10:47:14');
INSERT INTO `access_log` VALUES (12059, '64.81.15590116387008083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-28 10:47:19', 3, 0, '', '2019-05-28 10:47:19');
INSERT INTO `access_log` VALUES (12060, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-28 10:47:19', 44, 0, '', '2019-05-28 10:47:19');
INSERT INTO `access_log` VALUES (12061, '64.78.15590116391378087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-28 10:47:19', 3, 0, '', '2019-05-28 10:47:19');
INSERT INTO `access_log` VALUES (12062, '64.84.15590116393308089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-28 10:47:19', 2, 0, '', '2019-05-28 10:47:19');
INSERT INTO `access_log` VALUES (12063, '59.76.15590116396758807', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-28 10:47:20', 4, 0, '', '2019-05-28 10:47:20');
INSERT INTO `access_log` VALUES (12064, '59.77.15590116396798811', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-28 10:47:20', 13, 2001001000, '服务端发生异常', '2019-05-28 10:47:20');
INSERT INTO `access_log` VALUES (12065, '65.50.15590116608038121', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-28 10:47:41', 1, 1002001015, '账号未登陆', '2019-05-28 10:47:41');
INSERT INTO `access_log` VALUES (12066, '65.47.15590116608068125', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-28 10:47:41', 1, 1002001015, '账号未登陆', '2019-05-28 10:47:41');
INSERT INTO `access_log` VALUES (12067, '65.48.15590116608198135', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-28 10:47:41', 0, 1002001015, '账号未登陆', '2019-05-28 10:47:41');
INSERT INTO `access_log` VALUES (12068, '65.45.15590116632618127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-28 10:47:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 10:47:43');
INSERT INTO `access_log` VALUES (12069, '65.54.15590121326618113', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:55:33', 0, 1002001015, '账号未登陆', '2019-05-28 10:55:33');
INSERT INTO `access_log` VALUES (12070, '65.51.15590121326858127', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:55:33', 1, 1002001015, '账号未登陆', '2019-05-28 10:55:33');
INSERT INTO `access_log` VALUES (12071, '65.46.15590121326898125', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:55:33', 1, 1002001015, '账号未登陆', '2019-05-28 10:55:33');
INSERT INTO `access_log` VALUES (12072, '65.52.15590121345508129', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:55:35', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 10:55:35');
INSERT INTO `access_log` VALUES (12073, '65.50.15590121525798129', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudanyuanma&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:55:53', 70, 0, '', '2019-05-28 10:55:53');
INSERT INTO `access_log` VALUES (12074, '65.48.15590121531088143', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:55:53', 10, 0, '', '2019-05-28 10:55:53');
INSERT INTO `access_log` VALUES (12075, '65.47.15590121531318133', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:55:53', 8, 0, '', '2019-05-28 10:55:53');
INSERT INTO `access_log` VALUES (12076, '65.45.15590121531478135', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:55:53', 9, 0, '', '2019-05-28 10:55:53');
INSERT INTO `access_log` VALUES (12077, '65.46.15590121625918127', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:56:03', 11, 0, '', '2019-05-28 10:56:03');
INSERT INTO `access_log` VALUES (12078, '65.54.15590121625928115', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:56:03', 10, 0, '', '2019-05-28 10:56:03');
INSERT INTO `access_log` VALUES (12079, '65.51.15590121625928129', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:56:03', 12, 0, '', '2019-05-28 10:56:03');
INSERT INTO `access_log` VALUES (12080, '65.49.15590121732618131', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:56:13', 9, 0, '', '2019-05-28 10:56:13');
INSERT INTO `access_log` VALUES (12081, '65.50.15590121732658131', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:56:13', 10, 0, '', '2019-05-28 10:56:13');
INSERT INTO `access_log` VALUES (12082, '65.47.15590121732998135', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:56:13', 79, 0, '', '2019-05-28 10:56:13');
INSERT INTO `access_log` VALUES (12083, '64.81.15590121735108091', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:56:14', 68, 0, '', '2019-05-28 10:56:14');
INSERT INTO `access_log` VALUES (12084, '64.82.15590121735108097', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:56:14', 71, 0, '', '2019-05-28 10:56:14');
INSERT INTO `access_log` VALUES (12085, '65.48.15590121779858145', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:56:18', 10, 0, '', '2019-05-28 10:56:18');
INSERT INTO `access_log` VALUES (12086, '65.45.15590121780098137', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:56:18', 9, 0, '', '2019-05-28 10:56:18');
INSERT INTO `access_log` VALUES (12087, '65.53.15590121780108125', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:56:18', 9, 0, '', '2019-05-28 10:56:18');
INSERT INTO `access_log` VALUES (12088, '65.51.15590121797068131', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:56:20', 11, 0, '', '2019-05-28 10:56:20');
INSERT INTO `access_log` VALUES (12089, '65.46.15590121797068129', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:56:20', 11, 0, '', '2019-05-28 10:56:20');
INSERT INTO `access_log` VALUES (12090, '65.54.15590121797088117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '112.64.68.157', '2019-05-28 10:56:20', 9, 0, '', '2019-05-28 10:56:20');
INSERT INTO `access_log` VALUES (12091, '59.72.15590125542808821', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:02:34', 4, 0, '', '2019-05-28 11:02:34');
INSERT INTO `access_log` VALUES (12092, '59.74.15590125542808827', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:02:34', 14, 2001001000, '服务端发生异常', '2019-05-28 11:02:34');
INSERT INTO `access_log` VALUES (12093, '64.77.15590125657188101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:02:46', 3, 0, '', '2019-05-28 11:02:46');
INSERT INTO `access_log` VALUES (12094, '64.79.15590125659198095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:02:46', 2, 0, '', '2019-05-28 11:02:46');
INSERT INTO `access_log` VALUES (12095, '64.81.15590125689118097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:02:49', 2, 0, '', '2019-05-28 11:02:49');
INSERT INTO `access_log` VALUES (12096, '64.82.15590125698118103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:02:50', 2, 0, '', '2019-05-28 11:02:50');
INSERT INTO `access_log` VALUES (12097, '64.78.15590125701598101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:02:50', 2, 0, '', '2019-05-28 11:02:50');
INSERT INTO `access_log` VALUES (12098, '64.83.15590125705678099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:02:51', 2, 0, '', '2019-05-28 11:02:51');
INSERT INTO `access_log` VALUES (12099, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=kafak&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:03:02', 31, 0, '', '2019-05-28 11:03:02');
INSERT INTO `access_log` VALUES (12100, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kafak', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:03:03', 23, 0, '', '2019-05-28 11:03:03');
INSERT INTO `access_log` VALUES (12101, '64.85.15590125913918099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:03:11', 2, 0, '', '2019-05-28 11:03:11');
INSERT INTO `access_log` VALUES (12102, '64.80.15590125915948093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:03:12', 3, 0, '', '2019-05-28 11:03:12');
INSERT INTO `access_log` VALUES (12103, '64.77.15590125929988103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:03:13', 2, 0, '', '2019-05-28 11:03:13');
INSERT INTO `access_log` VALUES (12104, '64.79.15590125938478097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:03:14', 2, 0, '', '2019-05-28 11:03:14');
INSERT INTO `access_log` VALUES (12105, '64.81.15590125944158099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:03:14', 2, 0, '', '2019-05-28 11:03:14');
INSERT INTO `access_log` VALUES (12106, '64.82.15590125947588105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:03:15', 2, 0, '', '2019-05-28 11:03:15');
INSERT INTO `access_log` VALUES (12107, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:03:16', 10, 0, '', '2019-05-28 11:03:16');
INSERT INTO `access_log` VALUES (12108, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:03:16', 6, 0, '', '2019-05-28 11:03:16');
INSERT INTO `access_log` VALUES (12109, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:03:16', 175, 0, '', '2019-05-28 11:03:16');
INSERT INTO `access_log` VALUES (12110, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:03:17', 13, 0, '', '2019-05-28 11:03:17');
INSERT INTO `access_log` VALUES (12111, '64.78.15590125992798103', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:03:19', 171, 0, '', '2019-05-28 11:03:19');
INSERT INTO `access_log` VALUES (12112, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:04:05', 10, 0, '', '2019-05-28 11:04:05');
INSERT INTO `access_log` VALUES (12113, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:04:05', 6, 0, '', '2019-05-28 11:04:05');
INSERT INTO `access_log` VALUES (12114, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:04:05', 13, 0, '', '2019-05-28 11:04:05');
INSERT INTO `access_log` VALUES (12115, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:04:05', 13, 0, '', '2019-05-28 11:04:05');
INSERT INTO `access_log` VALUES (12116, '64.80.15590126491998095', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:04:09', 8, 0, '', '2019-05-28 11:04:09');
INSERT INTO `access_log` VALUES (12117, '66.49.15590126772067829', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17331053325&code=9999', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:04:37', 23, 1001003000, '验证码不存在', '2019-05-28 11:04:37');
INSERT INTO `access_log` VALUES (12118, '66.56.15590126830157825', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17331053325', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.98.59.140', '2019-05-28 11:04:43', 83, 0, '', '2019-05-28 11:04:43');
INSERT INTO `access_log` VALUES (12119, '65.47.15590127898918147', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:06:30', 0, 1002001015, '账号未登陆', '2019-05-28 11:06:30');
INSERT INTO `access_log` VALUES (12120, '65.45.15590127899078149', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:06:30', 0, 1002001015, '账号未登陆', '2019-05-28 11:06:30');
INSERT INTO `access_log` VALUES (12121, '65.53.15590127899158135', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:06:30', 0, 1002001015, '账号未登陆', '2019-05-28 11:06:30');
INSERT INTO `access_log` VALUES (12122, '65.48.15590127944028155', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:06:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 11:06:34');
INSERT INTO `access_log` VALUES (12123, '65.46.15590128059228139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yundaoyuanma&password=yundaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:06:46', 6, 1002002000, '账号不存在', '2019-05-28 11:06:46');
INSERT INTO `access_log` VALUES (12124, '65.54.15590128170748127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yundaoyuanma&password=yundaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:06:57', 4, 1002002000, '账号不存在', '2019-05-28 11:06:57');
INSERT INTO `access_log` VALUES (12125, '59.74.15590128377418831', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:07:18', 4, 0, '', '2019-05-28 11:07:18');
INSERT INTO `access_log` VALUES (12126, '59.72.15590128377448825', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:07:18', 14, 2001001000, '服务端发生异常', '2019-05-28 11:07:18');
INSERT INTO `access_log` VALUES (12127, '65.47.15590128579718149', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:07:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 11:07:38');
INSERT INTO `access_log` VALUES (12128, '65.45.15590128638178151', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:07:44', 89, 0, '', '2019-05-28 11:07:44');
INSERT INTO `access_log` VALUES (12129, '65.48.15590128644208157', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:07:44', 756, 0, '', '2019-05-28 11:07:45');
INSERT INTO `access_log` VALUES (12130, '65.51.15590128644218143', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:07:44', 757, 0, '', '2019-05-28 11:07:45');
INSERT INTO `access_log` VALUES (12131, '65.46.15590128644278141', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:07:44', 750, 0, '', '2019-05-28 11:07:45');
INSERT INTO `access_log` VALUES (12132, '62.81.15590128740098755', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:07:54', 21, 0, '', '2019-05-28 11:07:54');
INSERT INTO `access_log` VALUES (12133, '64.84.15590128781878109', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:07:58', 88, 0, '', '2019-05-28 11:07:58');
INSERT INTO `access_log` VALUES (12134, '64.83.15590128781898105', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:07:58', 90, 0, '', '2019-05-28 11:07:58');
INSERT INTO `access_log` VALUES (12135, '65.54.15590128839028129', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:08:04', 799, 0, '', '2019-05-28 11:08:05');
INSERT INTO `access_log` VALUES (12136, '65.50.15590128854508147', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:08:05', 10, 0, '', '2019-05-28 11:08:05');
INSERT INTO `access_log` VALUES (12137, '65.49.15590128867738147', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:08:07', 15, 0, '', '2019-05-28 11:08:07');
INSERT INTO `access_log` VALUES (12138, '65.47.15590128887598151', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '221.192.178.129', '2019-05-28 11:08:09', 10, 0, '', '2019-05-28 11:08:09');
INSERT INTO `access_log` VALUES (12139, '65.48.15590133596028165', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:16:00', 1, 1002001015, '账号未登陆', '2019-05-28 11:16:00');
INSERT INTO `access_log` VALUES (12140, '65.46.15590133596018149', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:16:00', 0, 1002001015, '账号未登陆', '2019-05-28 11:16:00');
INSERT INTO `access_log` VALUES (12141, '65.51.15590133596048151', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:16:00', 0, 1002001015, '账号未登陆', '2019-05-28 11:16:00');
INSERT INTO `access_log` VALUES (12142, '65.52.15590133642168151', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:16:04', 104, 0, '', '2019-05-28 11:16:04');
INSERT INTO `access_log` VALUES (12143, '65.54.15590133646148137', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:16:05', 11, 0, '', '2019-05-28 11:16:05');
INSERT INTO `access_log` VALUES (12144, '65.49.15590133646178155', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:16:05', 10, 0, '', '2019-05-28 11:16:05');
INSERT INTO `access_log` VALUES (12145, '65.50.15590133646168155', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:16:05', 10, 0, '', '2019-05-28 11:16:05');
INSERT INTO `access_log` VALUES (12146, '62.85.15590133745908771', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:16:15', 16, 0, '', '2019-05-28 11:16:15');
INSERT INTO `access_log` VALUES (12147, '62.82.15590133916978773', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:16:32', 14, 0, '', '2019-05-28 11:16:32');
INSERT INTO `access_log` VALUES (12148, '62.86.15590134044778761', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=6&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:16:44', 16, 0, '', '2019-05-28 11:16:44');
INSERT INTO `access_log` VALUES (12149, '62.80.15590134502678771', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:17:30', 19, 0, '', '2019-05-28 11:17:30');
INSERT INTO `access_log` VALUES (12150, '64.83.15590134532028113', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:17:33', 9, 0, '', '2019-05-28 11:17:33');
INSERT INTO `access_log` VALUES (12151, '64.84.15590134531988117', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:17:33', 14, 0, '', '2019-05-28 11:17:33');
INSERT INTO `access_log` VALUES (12152, '64.79.15590134886828111', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:18:09', 11, 0, '', '2019-05-28 11:18:09');
INSERT INTO `access_log` VALUES (12153, '64.77.15590134886818117', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:18:09', 13, 0, '', '2019-05-28 11:18:09');
INSERT INTO `access_log` VALUES (12154, '64.82.15590134918238119', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:18:12', 11, 0, '', '2019-05-28 11:18:12');
INSERT INTO `access_log` VALUES (12155, '64.78.15590134918248117', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:18:12', 13, 0, '', '2019-05-28 11:18:12');
INSERT INTO `access_log` VALUES (12156, '64.81.15590134918238113', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:18:12', 16, 0, '', '2019-05-28 11:18:12');
INSERT INTO `access_log` VALUES (12157, '66.54.15590135248167837', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:18:45', 17, 0, '', '2019-05-28 11:18:45');
INSERT INTO `access_log` VALUES (12158, '66.49.15590135397417841', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:19:00', 17, 0, '', '2019-05-28 11:19:00');
INSERT INTO `access_log` VALUES (12159, '66.56.15590135406167837', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:19:01', 14, 0, '', '2019-05-28 11:19:01');
INSERT INTO `access_log` VALUES (12160, '66.57.15590135410397847', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:19:01', 13, 0, '', '2019-05-28 11:19:01');
INSERT INTO `access_log` VALUES (12161, '66.50.15590135413097839', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:19:01', 17, 0, '', '2019-05-28 11:19:01');
INSERT INTO `access_log` VALUES (12162, '66.51.15590135433307843', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10&status=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:19:03', 15, 0, '', '2019-05-28 11:19:03');
INSERT INTO `access_log` VALUES (12163, '66.48.15590135453987847', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.134.5', '2019-05-28 11:19:05', 14, 0, '', '2019-05-28 11:19:05');
INSERT INTO `access_log` VALUES (12164, '65.47.15590207501688259', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:19:10', 13, 1002001012, '访问令牌已过期', '2019-05-28 13:19:10');
INSERT INTO `access_log` VALUES (12165, '65.49.15590207501698255', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:19:10', 16, 1002001012, '访问令牌已过期', '2019-05-28 13:19:10');
INSERT INTO `access_log` VALUES (12166, '65.48.15590207501918267', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:19:10', 12, 1002001012, '访问令牌已过期', '2019-05-28 13:19:10');
INSERT INTO `access_log` VALUES (12167, '65.54.15590207994078239', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:19:59', 400, 0, '', '2019-05-28 13:20:00');
INSERT INTO `access_log` VALUES (12168, '65.45.15590208002438261', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:20:00', 11, 0, '', '2019-05-28 13:20:00');
INSERT INTO `access_log` VALUES (12169, '65.50.15590208002558255', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:20:00', 8, 0, '', '2019-05-28 13:20:00');
INSERT INTO `access_log` VALUES (12170, '65.53.15590208002988247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:20:00', 10, 0, '', '2019-05-28 13:20:00');
INSERT INTO `access_log` VALUES (12171, '64.82.15590208226618217', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:20:23', 23, 0, '', '2019-05-28 13:20:23');
INSERT INTO `access_log` VALUES (12172, '64.84.15590208226768217', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:20:23', 13, 0, '', '2019-05-28 13:20:23');
INSERT INTO `access_log` VALUES (12173, '65.51.15590208515508253', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:20:52', 4, 0, '', '2019-05-28 13:20:52');
INSERT INTO `access_log` VALUES (12174, '64.84.15590209441828219', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=黄瓜&sellPoint=新鲜&cid=794&visible=true&picUrls=http://static.shop.iocoder.cn/99b3f68e-f86c-4839-8519-fa3cf20f5a2b&skuStr=[{\"attrs\":[4],\"price\":400,\"quantity\":1000}]&description=<p>北京延庆A区黄瓜生产基地</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:22:24', 9, 1002002009, NULL, '2019-05-28 13:22:24');
INSERT INTO `access_log` VALUES (12175, '64.82.15590209526188219', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=黄瓜&sellPoint=新鲜&cid=794&visible=true&picUrls=http://static.shop.iocoder.cn/99b3f68e-f86c-4839-8519-fa3cf20f5a2b&skuStr=[{\"attrs\":[4],\"price\":400,\"quantity\":1001}]&description=<p>北京延庆A区黄瓜生产基地</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:22:33', 15, 1002002009, NULL, '2019-05-28 13:22:33');
INSERT INTO `access_log` VALUES (12176, '64.76.15590209624268217', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=黄瓜&sellPoint=新鲜&cid=794&visible=true&picUrls=http://static.shop.iocoder.cn/99b3f68e-f86c-4839-8519-fa3cf20f5a2b&skuStr=[{\"attrs\":[4],\"price\":400,\"quantity\":1001}]&description=<p>北京延庆A区黄瓜生产基地</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:22:42', 8, 1002002009, NULL, '2019-05-28 13:22:42');
INSERT INTO `access_log` VALUES (12177, '64.85.15590209690588215', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:22:49', 15, 0, '', '2019-05-28 13:22:49');
INSERT INTO `access_log` VALUES (12178, '64.80.15590209690658209', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:22:49', 10, 0, '', '2019-05-28 13:22:49');
INSERT INTO `access_log` VALUES (12179, '64.79.15590209832728213', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:03', 15, 0, '', '2019-05-28 13:23:03');
INSERT INTO `access_log` VALUES (12180, '59.71.15590209908998939', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:11', 21, 2001001000, '服务端发生异常', '2019-05-28 13:23:11');
INSERT INTO `access_log` VALUES (12181, '64.84.15590210041708221', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=k', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:24', 17, 0, '', '2019-05-28 13:23:24');
INSERT INTO `access_log` VALUES (12182, '64.82.15590210043518221', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=ku', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:24', 11, 0, '', '2019-05-28 13:23:24');
INSERT INTO `access_log` VALUES (12183, '64.83.15590210044578217', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=kua', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:24', 11, 0, '', '2019-05-28 13:23:24');
INSERT INTO `access_log` VALUES (12184, '64.76.15590210045828219', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=kuan', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:25', 11, 0, '', '2019-05-28 13:23:25');
INSERT INTO `access_log` VALUES (12185, '64.85.15590210046678217', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=kuang', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:25', 10, 0, '', '2019-05-28 13:23:25');
INSERT INTO `access_log` VALUES (12186, '64.80.15590210048608211', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=kuangq', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:25', 11, 0, '', '2019-05-28 13:23:25');
INSERT INTO `access_log` VALUES (12187, '64.77.15590210050078221', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=kuangqu', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:25', 17, 0, '', '2019-05-28 13:23:25');
INSERT INTO `access_log` VALUES (12188, '64.79.15590210051348215', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=kuangqua', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:25', 10, 0, '', '2019-05-28 13:23:25');
INSERT INTO `access_log` VALUES (12189, '64.78.15590210052838221', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=kuangquan', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:25', 10, 0, '', '2019-05-28 13:23:25');
INSERT INTO `access_log` VALUES (12190, '64.81.15590210053828217', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=kuangquans', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:25', 10, 0, '', '2019-05-28 13:23:25');
INSERT INTO `access_log` VALUES (12191, '64.84.15590210055968223', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=kuangquansh', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:26', 10, 0, '', '2019-05-28 13:23:26');
INSERT INTO `access_log` VALUES (12192, '64.82.15590210057358223', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=kuangquanshu', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:26', 11, 0, '', '2019-05-28 13:23:26');
INSERT INTO `access_log` VALUES (12193, '64.83.15590210058308219', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=kuangquanshui', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:26', 10, 0, '', '2019-05-28 13:23:26');
INSERT INTO `access_log` VALUES (12194, '64.76.15590210059428221', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=矿泉水', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:26', 10, 0, '', '2019-05-28 13:23:26');
INSERT INTO `access_log` VALUES (12195, '64.80.15590210232358213', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:43', 12, 0, '', '2019-05-28 13:23:43');
INSERT INTO `access_log` VALUES (12196, '64.77.15590210232388223', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:43', 9, 0, '', '2019-05-28 13:23:43');
INSERT INTO `access_log` VALUES (12197, '64.78.15590210262168223', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:46', 9, 0, '', '2019-05-28 13:23:46');
INSERT INTO `access_log` VALUES (12198, '64.79.15590210262138217', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:46', 12, 0, '', '2019-05-28 13:23:46');
INSERT INTO `access_log` VALUES (12199, '66.52.15590210347607941', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:23:55', 24, 0, '', '2019-05-28 13:23:55');
INSERT INTO `access_log` VALUES (12200, '65.50.15590210413778259', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:24:01', 19, 0, '', '2019-05-28 13:24:01');
INSERT INTO `access_log` VALUES (12201, '65.53.15590210432308251', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:24:03', 11, 0, '', '2019-05-28 13:24:03');
INSERT INTO `access_log` VALUES (12202, '65.45.15590210454058265', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:24:05', 10, 0, '', '2019-05-28 13:24:05');
INSERT INTO `access_log` VALUES (12203, '65.49.15590210466718261', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:24:07', 16, 0, '', '2019-05-28 13:24:07');
INSERT INTO `access_log` VALUES (12204, '64.83.15590210561628221', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:24:16', 9, 0, '', '2019-05-28 13:24:16');
INSERT INTO `access_log` VALUES (12205, '64.82.15590210561608225', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:24:16', 13, 0, '', '2019-05-28 13:24:16');
INSERT INTO `access_log` VALUES (12206, '64.85.15590210684738221', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:24:28', 10, 0, '', '2019-05-28 13:24:28');
INSERT INTO `access_log` VALUES (12207, '59.80.15590210887858939', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:24:49', 27, 2001001000, '服务端发生异常', '2019-05-28 13:24:49');
INSERT INTO `access_log` VALUES (12208, '64.78.15590210984488225', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=农夫山泉', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:24:58', 11, 0, '', '2019-05-28 13:24:58');
INSERT INTO `access_log` VALUES (12209, '59.71.15590211048108941', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/add', 'type=1&productSpuId=32&sort=0', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:25:05', 8, 1002002009, NULL, '2019-05-28 13:25:05');
INSERT INTO `access_log` VALUES (12210, '59.76.15590211175258935', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:25:18', 21, 0, '', '2019-05-28 13:25:18');
INSERT INTO `access_log` VALUES (12211, '59.75.15590211657308941', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '123.56.217.133', '2019-05-28 13:26:06', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-28 13:26:06');
INSERT INTO `access_log` VALUES (12212, '59.74.15590229096538967', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:10', 5, 0, '', '2019-05-28 13:55:10');
INSERT INTO `access_log` VALUES (12213, '59.73.15590229096538967', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:10', 14, 2001001000, '服务端发生异常', '2019-05-28 13:55:10');
INSERT INTO `access_log` VALUES (12214, '64.84.15590229211078251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:21', 465, 0, '', '2019-05-28 13:55:22');
INSERT INTO `access_log` VALUES (12215, '64.82.15590229217098251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:22', 3, 0, '', '2019-05-28 13:55:22');
INSERT INTO `access_log` VALUES (12216, '64.83.15590229239468247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:24', 3, 0, '', '2019-05-28 13:55:24');
INSERT INTO `access_log` VALUES (12217, '64.76.15590229247068249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:25', 3, 0, '', '2019-05-28 13:55:25');
INSERT INTO `access_log` VALUES (12218, '64.85.15590229250748247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:25', 69, 0, '', '2019-05-28 13:55:25');
INSERT INTO `access_log` VALUES (12219, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=abc&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:29', 18, 0, '', '2019-05-28 13:55:29');
INSERT INTO `access_log` VALUES (12220, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=abc', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:29', 10, 0, '', '2019-05-28 13:55:29');
INSERT INTO `access_log` VALUES (12221, '64.77.15590229345908251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:35', 2, 0, '', '2019-05-28 13:55:35');
INSERT INTO `access_log` VALUES (12222, '64.80.15590229347088241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:35', 2, 0, '', '2019-05-28 13:55:35');
INSERT INTO `access_log` VALUES (12223, '59.79.15590229363998963', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:36', 4, 0, '', '2019-05-28 13:55:36');
INSERT INTO `access_log` VALUES (12224, '59.80.15590229363988965', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:36', 14, 2001001000, '服务端发生异常', '2019-05-28 13:55:36');
INSERT INTO `access_log` VALUES (12225, '65.54.15590229484188269', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:48', 1, 1002001015, '账号未登陆', '2019-05-28 13:55:48');
INSERT INTO `access_log` VALUES (12226, '65.50.15590229484188287', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:48', 0, 1002001015, '账号未登陆', '2019-05-28 13:55:48');
INSERT INTO `access_log` VALUES (12227, '65.53.15590229484188277', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:48', 0, 1002001015, '账号未登陆', '2019-05-28 13:55:48');
INSERT INTO `access_log` VALUES (12228, '65.45.15590229505298295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:55:51', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 13:55:51');
INSERT INTO `access_log` VALUES (12229, '65.48.15590229667348299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:56:07', 103, 0, '', '2019-05-28 13:56:07');
INSERT INTO `access_log` VALUES (12230, '65.51.15590229670938285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:56:07', 11, 0, '', '2019-05-28 13:56:07');
INSERT INTO `access_log` VALUES (12231, '65.47.15590229670938291', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:56:07', 9, 0, '', '2019-05-28 13:56:07');
INSERT INTO `access_log` VALUES (12232, '65.46.15590229670968283', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:56:07', 11, 0, '', '2019-05-28 13:56:07');
INSERT INTO `access_log` VALUES (12233, '65.45.15590230144198297', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:56:54', 20, 0, '', '2019-05-28 13:56:54');
INSERT INTO `access_log` VALUES (12234, '65.49.15590230229118289', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:57:03', 11, 0, '', '2019-05-28 13:57:03');
INSERT INTO `access_log` VALUES (12235, '65.48.15590230240278301', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:57:04', 9, 0, '', '2019-05-28 13:57:04');
INSERT INTO `access_log` VALUES (12236, '65.47.15590230250158293', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.51', '2019-05-28 13:57:05', 15, 0, '', '2019-05-28 13:57:05');
INSERT INTO `access_log` VALUES (12237, '59.79.15590233635348969', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.105.118', '2019-05-28 14:02:44', 4, 0, '', '2019-05-28 14:02:44');
INSERT INTO `access_log` VALUES (12238, '59.80.15590233635448971', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.105.118', '2019-05-28 14:02:44', 13, 2001001000, '服务端发生异常', '2019-05-28 14:02:44');
INSERT INTO `access_log` VALUES (12239, '64.80.15590233663898247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.105.118', '2019-05-28 14:02:46', 3, 0, '', '2019-05-28 14:02:46');
INSERT INTO `access_log` VALUES (12240, '64.78.15590233665848257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.105.118', '2019-05-28 14:02:47', 2, 0, '', '2019-05-28 14:02:47');
INSERT INTO `access_log` VALUES (12241, '64.79.15590233679398251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.105.118', '2019-05-28 14:02:48', 2, 0, '', '2019-05-28 14:02:48');
INSERT INTO `access_log` VALUES (12242, '64.81.15590233682748253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.105.118', '2019-05-28 14:02:48', 2, 0, '', '2019-05-28 14:02:48');
INSERT INTO `access_log` VALUES (12243, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.105.118', '2019-05-28 14:02:49', 10, 0, '', '2019-05-28 14:02:49');
INSERT INTO `access_log` VALUES (12244, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.105.118', '2019-05-28 14:02:49', 13, 0, '', '2019-05-28 14:02:49');
INSERT INTO `access_log` VALUES (12245, '64.82.15590233705298259', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.105.118', '2019-05-28 14:02:51', 9, 0, '', '2019-05-28 14:02:51');
INSERT INTO `access_log` VALUES (12246, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.105.118', '2019-05-28 14:03:00', 17, 0, '', '2019-05-28 14:03:00');
INSERT INTO `access_log` VALUES (12247, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.136.105.118', '2019-05-28 14:03:00', 14, 0, '', '2019-05-28 14:03:00');
INSERT INTO `access_log` VALUES (12248, '65.49.15590234101698295', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '223.71.74.17', '2019-05-28 14:03:30', 8, 0, '', '2019-05-28 14:03:30');
INSERT INTO `access_log` VALUES (12249, '65.45.15590234101678303', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '223.71.74.17', '2019-05-28 14:03:30', 10, 0, '', '2019-05-28 14:03:30');
INSERT INTO `access_log` VALUES (12250, '65.48.15590234101828307', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '223.71.74.17', '2019-05-28 14:03:30', 10, 0, '', '2019-05-28 14:03:30');
INSERT INTO `access_log` VALUES (12251, '59.77.15590234111878971', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '223.71.74.17', '2019-05-28 14:03:31', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-28 14:03:31');
INSERT INTO `access_log` VALUES (12252, '65.48.15590237629868313', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:23', 95, 1002001012, '访问令牌已过期', '2019-05-28 14:09:23');
INSERT INTO `access_log` VALUES (12253, '65.47.15590237630948305', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:23', 12, 1002001012, '访问令牌已过期', '2019-05-28 14:09:23');
INSERT INTO `access_log` VALUES (12254, '65.45.15590237629918309', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:23', 91, 1002001012, '访问令牌已过期', '2019-05-28 14:09:23');
INSERT INTO `access_log` VALUES (12255, '65.49.15590237629868301', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:23', 95, 1002001012, '访问令牌已过期', '2019-05-28 14:09:23');
INSERT INTO `access_log` VALUES (12256, '59.71.15590237755978979', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:36', 11, 0, '', '2019-05-28 14:09:36');
INSERT INTO `access_log` VALUES (12257, '59.76.15590237755988973', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:36', 24, 2001001000, '服务端发生异常', '2019-05-28 14:09:36');
INSERT INTO `access_log` VALUES (12258, '64.84.15590237793078265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:39', 14, 0, '', '2019-05-28 14:09:39');
INSERT INTO `access_log` VALUES (12259, '64.83.15590237794358261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:39', 7, 0, '', '2019-05-28 14:09:39');
INSERT INTO `access_log` VALUES (12260, '64.76.15590237854128263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:45', 8, 0, '', '2019-05-28 14:09:45');
INSERT INTO `access_log` VALUES (12261, '64.85.15590237854988261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:45', 8, 0, '', '2019-05-28 14:09:46');
INSERT INTO `access_log` VALUES (12262, '59.73.15590237903188981', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:50', 19, 2001001000, '服务端发生异常', '2019-05-28 14:09:50');
INSERT INTO `access_log` VALUES (12263, '59.74.15590237903148981', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:50', 85, 0, '', '2019-05-28 14:09:50');
INSERT INTO `access_log` VALUES (12264, '64.80.15590237927728255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:53', 9, 0, '', '2019-05-28 14:09:53');
INSERT INTO `access_log` VALUES (12265, '64.78.15590237928778265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:53', 8, 0, '', '2019-05-28 14:09:53');
INSERT INTO `access_log` VALUES (12266, '59.75.15590237952138979', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:55', 17, 2001001000, '服务端发生异常', '2019-05-28 14:09:55');
INSERT INTO `access_log` VALUES (12267, '59.72.15590237952108975', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:55', 1292, 0, '', '2019-05-28 14:09:57');
INSERT INTO `access_log` VALUES (12268, '64.79.15590237981948259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:58', 9, 0, '', '2019-05-28 14:09:58');
INSERT INTO `access_log` VALUES (12269, '64.81.15590237982888261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:58', 8, 0, '', '2019-05-28 14:09:58');
INSERT INTO `access_log` VALUES (12270, '64.82.15590237994828267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:09:59', 8, 0, '', '2019-05-28 14:09:59');
INSERT INTO `access_log` VALUES (12271, '64.76.15590238000968265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:00', 6, 0, '', '2019-05-28 14:10:00');
INSERT INTO `access_log` VALUES (12272, '59.79.15590238017988977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:02', 10, 0, '', '2019-05-28 14:10:02');
INSERT INTO `access_log` VALUES (12273, '59.80.15590238017998979', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:02', 20, 2001001000, '服务端发生异常', '2019-05-28 14:10:02');
INSERT INTO `access_log` VALUES (12274, '64.77.15590238057308267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:06', 8, 0, '', '2019-05-28 14:10:06');
INSERT INTO `access_log` VALUES (12275, '64.80.15590238058368257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:06', 9, 0, '', '2019-05-28 14:10:06');
INSERT INTO `access_log` VALUES (12276, '64.78.15590238074168267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:07', 8, 0, '', '2019-05-28 14:10:07');
INSERT INTO `access_log` VALUES (12277, '64.79.15590238079868261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:08', 8, 0, '', '2019-05-28 14:10:08');
INSERT INTO `access_log` VALUES (12278, '64.81.15590238162858263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:16', 9, 0, '', '2019-05-28 14:10:16');
INSERT INTO `access_log` VALUES (12279, '64.84.15590238163868269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:16', 8, 0, '', '2019-05-28 14:10:16');
INSERT INTO `access_log` VALUES (12280, '66.50.15590238178127977', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:18', 7, 1002001012, '访问令牌已过期', '2019-05-28 14:10:18');
INSERT INTO `access_log` VALUES (12281, '66.51.15590238179317981', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=246657b443064cdcae2d65fb078cb241', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:18', 11, 1002001018, '访问令牌已过期', '2019-05-28 14:10:18');
INSERT INTO `access_log` VALUES (12282, '66.52.15590238342827979', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13133333333', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:34', 76, 0, '', '2019-05-28 14:10:34');
INSERT INTO `access_log` VALUES (12283, '66.54.15590238391467977', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13133333333&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:39', 195, 0, '', '2019-05-28 14:10:39');
INSERT INTO `access_log` VALUES (12284, '66.53.15590238409457983', 86, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:41', 8, 0, '', '2019-05-28 14:10:41');
INSERT INTO `access_log` VALUES (12285, '66.49.15590238478657981', 86, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:10:48', 7, 0, '', '2019-05-28 14:10:48');
INSERT INTO `access_log` VALUES (12286, '66.57.15590238597807987', 86, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:11:00', 7, 0, '', '2019-05-28 14:11:00');
INSERT INTO `access_log` VALUES (12287, '66.51.15590238713647983', 86, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:11:11', 10, 0, '', '2019-05-28 14:11:11');
INSERT INTO `access_log` VALUES (12288, '59.74.15590238747288983', 86, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:11:15', 7, 0, '', '2019-05-28 14:11:15');
INSERT INTO `access_log` VALUES (12289, '59.75.15590238747438981', 86, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:11:15', 16, 2001001000, '服务端发生异常', '2019-05-28 14:11:15');
INSERT INTO `access_log` VALUES (12290, '59.80.15590238961958981', 86, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:11:36', 7, 0, '', '2019-05-28 14:11:36');
INSERT INTO `access_log` VALUES (12291, '59.78.15590238961968985', 86, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:11:36', 17, 2001001000, '服务端发生异常', '2019-05-28 14:11:36');
INSERT INTO `access_log` VALUES (12292, '66.55.15590238987387991', 86, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:11:39', 7, 0, '', '2019-05-28 14:11:39');
INSERT INTO `access_log` VALUES (12293, '59.76.15590239026878977', 86, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:11:43', 7, 0, '', '2019-05-28 14:11:43');
INSERT INTO `access_log` VALUES (12294, '59.71.15590239026878983', 86, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:11:43', 16, 2001001000, '服务端发生异常', '2019-05-28 14:11:43');
INSERT INTO `access_log` VALUES (12295, '64.85.15590240077378267', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:13:28', 8, 0, '', '2019-05-28 14:13:28');
INSERT INTO `access_log` VALUES (12296, '64.77.15590240079868271', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:13:28', 5, 0, '', '2019-05-28 14:13:28');
INSERT INTO `access_log` VALUES (12297, '64.80.15590240129028261', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:13:33', 6, 0, '', '2019-05-28 14:13:33');
INSERT INTO `access_log` VALUES (12298, '64.78.15590240129938271', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:13:33', 5, 0, '', '2019-05-28 14:13:33');
INSERT INTO `access_log` VALUES (12299, '66.48.15590240143307989', 86, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:13:34', 8, 0, '', '2019-05-28 14:13:34');
INSERT INTO `access_log` VALUES (12300, '59.71.15590240405278985', 86, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:14:01', 8, 0, '', '2019-05-28 14:14:01');
INSERT INTO `access_log` VALUES (12301, '59.77.15590240405408983', 86, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:14:01', 16, 2001001000, '服务端发生异常', '2019-05-28 14:14:01');
INSERT INTO `access_log` VALUES (12302, '66.49.15590240651187985', 86, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:14:25', 7, 0, '', '2019-05-28 14:14:25');
INSERT INTO `access_log` VALUES (12303, '64.76.15590240789678271', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:14:39', 7, 0, '', '2019-05-28 14:14:39');
INSERT INTO `access_log` VALUES (12304, '64.85.15590240790668269', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:14:39', 5, 0, '', '2019-05-28 14:14:39');
INSERT INTO `access_log` VALUES (12305, '66.50.15590240940417983', 86, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:14:54', 705, 0, '', '2019-05-28 14:14:55');
INSERT INTO `access_log` VALUES (12306, '59.79.15590240954828983', 86, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:14:55', 7, 0, '', '2019-05-28 14:14:55');
INSERT INTO `access_log` VALUES (12307, '59.78.15590240954838989', 86, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:14:55', 16, 2001001000, '服务端发生异常', '2019-05-28 14:14:56');
INSERT INTO `access_log` VALUES (12308, '66.51.15590240983727987', 86, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:14:58', 612, 0, '', '2019-05-28 14:14:59');
INSERT INTO `access_log` VALUES (12309, '66.51.15590240983727987', 86, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:14:58', 612, 0, '', '2019-05-28 14:15:00');
INSERT INTO `access_log` VALUES (12310, '64.80.15590240995238263', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:00', 731, 0, '', '2019-05-28 14:15:00');
INSERT INTO `access_log` VALUES (12311, '64.78.15590241004498273', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:00', 138, 0, '', '2019-05-28 14:15:01');
INSERT INTO `access_log` VALUES (12312, '59.80.15590241007388985', 86, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:01', 6, 0, '', '2019-05-28 14:15:01');
INSERT INTO `access_log` VALUES (12313, '59.76.15590241007418981', 86, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:01', 16, 2001001000, '服务端发生异常', '2019-05-28 14:15:01');
INSERT INTO `access_log` VALUES (12314, '66.48.15590241035447991', 86, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:04', 7, 0, '', '2019-05-28 14:15:04');
INSERT INTO `access_log` VALUES (12315, '59.71.15590241042308987', 86, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:04', 7, 0, '', '2019-05-28 14:15:04');
INSERT INTO `access_log` VALUES (12316, '59.73.15590241042408989', 86, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:04', 21, 2001001000, '服务端发生异常', '2019-05-28 14:15:04');
INSERT INTO `access_log` VALUES (12317, '66.52.15590241050037985', 86, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:05', 7, 0, '', '2019-05-28 14:15:05');
INSERT INTO `access_log` VALUES (12318, '64.81.15590241077758269', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:08', 6, 0, '', '2019-05-28 14:15:08');
INSERT INTO `access_log` VALUES (12319, '64.84.15590241078558275', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:08', 5, 0, '', '2019-05-28 14:15:08');
INSERT INTO `access_log` VALUES (12320, '59.74.15590241080708989', 86, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:08', 6, 0, '', '2019-05-28 14:15:08');
INSERT INTO `access_log` VALUES (12321, '59.75.15590241080738987', 86, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:08', 12, 2001001000, '服务端发生异常', '2019-05-28 14:15:08');
INSERT INTO `access_log` VALUES (12322, '64.82.15590241082878275', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:08', 5, 0, '', '2019-05-28 14:15:08');
INSERT INTO `access_log` VALUES (12323, '64.83.15590241084008271', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:08', 5, 0, '', '2019-05-28 14:15:08');
INSERT INTO `access_log` VALUES (12324, '59.72.15590241085048983', 86, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:09', 6, 0, '', '2019-05-28 14:15:09');
INSERT INTO `access_log` VALUES (12325, '59.78.15590241085078991', 86, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:09', 16, 2001001000, '服务端发生异常', '2019-05-28 14:15:09');
INSERT INTO `access_log` VALUES (12326, '64.76.15590241088048273', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:09', 6, 0, '', '2019-05-28 14:15:09');
INSERT INTO `access_log` VALUES (12327, '64.85.15590241088808271', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:09', 5, 0, '', '2019-05-28 14:15:09');
INSERT INTO `access_log` VALUES (12328, '59.79.15590241090208985', 86, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:09', 6, 0, '', '2019-05-28 14:15:09');
INSERT INTO `access_log` VALUES (12329, '59.80.15590241090218987', 86, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:09', 15, 2001001000, '服务端发生异常', '2019-05-28 14:15:09');
INSERT INTO `access_log` VALUES (12330, '64.77.15590241092088275', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:09', 5, 0, '', '2019-05-28 14:15:09');
INSERT INTO `access_log` VALUES (12331, '64.80.15590241092978265', 86, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:09', 5, 0, '', '2019-05-28 14:15:09');
INSERT INTO `access_log` VALUES (12332, '59.76.15590241094038983', 86, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:09', 6, 0, '', '2019-05-28 14:15:09');
INSERT INTO `access_log` VALUES (12333, '59.77.15590241094038987', 86, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:09', 17, 2001001000, '服务端发生异常', '2019-05-28 14:15:09');
INSERT INTO `access_log` VALUES (12334, '65.50.15590241222398307', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:22', 61, 0, '', '2019-05-28 14:15:22');
INSERT INTO `access_log` VALUES (12335, '65.53.15590241226048295', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:23', 11, 0, '', '2019-05-28 14:15:23');
INSERT INTO `access_log` VALUES (12336, '65.47.15590241226108311', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:23', 11, 0, '', '2019-05-28 14:15:23');
INSERT INTO `access_log` VALUES (12337, '65.48.15590241226148319', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:23', 10, 0, '', '2019-05-28 14:15:23');
INSERT INTO `access_log` VALUES (12338, '62.86.15590241255338903', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:26', 37, 0, '', '2019-05-28 14:15:26');
INSERT INTO `access_log` VALUES (12339, '62.89.15590241339368913', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:34', 26, 0, '', '2019-05-28 14:15:34');
INSERT INTO `access_log` VALUES (12340, '62.84.15590241366058907', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:37', 21, 0, '', '2019-05-28 14:15:37');
INSERT INTO `access_log` VALUES (12341, '62.80.15590241391068915', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:39', 18, 0, '', '2019-05-28 14:15:39');
INSERT INTO `access_log` VALUES (12342, '64.81.15590241417138271', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:42', 13, 0, '', '2019-05-28 14:15:42');
INSERT INTO `access_log` VALUES (12343, '64.84.15590241417298277', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:42', 10, 0, '', '2019-05-28 14:15:42');
INSERT INTO `access_log` VALUES (12344, '64.76.15590241538808275', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:54', 11, 0, '', '2019-05-28 14:15:54');
INSERT INTO `access_log` VALUES (12345, '64.83.15590241538778273', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:15:54', 14, 0, '', '2019-05-28 14:15:54');
INSERT INTO `access_log` VALUES (12346, '64.85.15590241598698273', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:16:00', 14, 0, '', '2019-05-28 14:16:00');
INSERT INTO `access_log` VALUES (12347, '64.80.15590241727118267', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:16:13', 13, 0, '', '2019-05-28 14:16:13');
INSERT INTO `access_log` VALUES (12348, '64.76.15590242684118277', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:17:48', 12, 0, '', '2019-05-28 14:17:48');
INSERT INTO `access_log` VALUES (12349, '64.85.15590242685788275', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:17:49', 11, 0, '', '2019-05-28 14:17:49');
INSERT INTO `access_log` VALUES (12350, '65.49.15590242724838309', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:17:52', 279, 0, '', '2019-05-28 14:17:53');
INSERT INTO `access_log` VALUES (12351, '65.51.15590242725008307', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:17:53', 271, 0, '', '2019-05-28 14:17:53');
INSERT INTO `access_log` VALUES (12352, '65.45.15590242724878317', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:17:52', 284, 0, '', '2019-05-28 14:17:53');
INSERT INTO `access_log` VALUES (12353, '64.80.15590242773238269', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:17:57', 11, 0, '', '2019-05-28 14:17:57');
INSERT INTO `access_log` VALUES (12354, '64.79.15590242775828273', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:17:58', 10, 0, '', '2019-05-28 14:17:58');
INSERT INTO `access_log` VALUES (12355, '64.78.15590242775818279', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:17:58', 13, 0, '', '2019-05-28 14:17:58');
INSERT INTO `access_log` VALUES (12356, '64.84.15590242780828281', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:17:58', 9, 0, '', '2019-05-28 14:17:58');
INSERT INTO `access_log` VALUES (12357, '64.81.15590242780808275', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:17:58', 12, 0, '', '2019-05-28 14:17:58');
INSERT INTO `access_log` VALUES (12358, '62.83.15590242782948929', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:17:58', 20, 0, '', '2019-05-28 14:17:58');
INSERT INTO `access_log` VALUES (12359, '62.86.15590242784158911', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:17:58', 18, 0, '', '2019-05-28 14:17:58');
INSERT INTO `access_log` VALUES (12360, '62.89.15590242789228921', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:17:59', 21, 0, '', '2019-05-28 14:17:59');
INSERT INTO `access_log` VALUES (12361, '62.81.15590242790898915', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:17:59', 16, 0, '', '2019-05-28 14:17:59');
INSERT INTO `access_log` VALUES (12362, '65.54.15590244478578295', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:20:48', 10, 0, '', '2019-05-28 14:20:48');
INSERT INTO `access_log` VALUES (12363, '65.50.15590244478598313', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:20:48', 10, 0, '', '2019-05-28 14:20:48');
INSERT INTO `access_log` VALUES (12364, '65.48.15590244478698325', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:20:48', 9, 0, '', '2019-05-28 14:20:48');
INSERT INTO `access_log` VALUES (12365, '62.88.15590244594928929', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.177.121.93', '2019-05-28 14:20:59', 16, 0, '', '2019-05-28 14:21:00');
INSERT INTO `access_log` VALUES (12366, '59.78.15590244832178997', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 14:21:23', 4, 0, '', '2019-05-28 14:21:23');
INSERT INTO `access_log` VALUES (12367, '59.79.15590244832178991', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 14:21:23', 14, 2001001000, '服务端发生异常', '2019-05-28 14:21:23');
INSERT INTO `access_log` VALUES (12368, '64.77.15590244895728283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 14:21:30', 3, 0, '', '2019-05-28 14:21:30');
INSERT INTO `access_log` VALUES (12369, '64.80.15590244896778273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 14:21:30', 3, 0, '', '2019-05-28 14:21:30');
INSERT INTO `access_log` VALUES (12370, '64.79.15590244906478277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 14:21:31', 3, 0, '', '2019-05-28 14:21:31');
INSERT INTO `access_log` VALUES (12371, '64.78.15590244910528283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 14:21:31', 2, 0, '', '2019-05-28 14:21:31');
INSERT INTO `access_log` VALUES (12372, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 14:21:32', 10, 0, '', '2019-05-28 14:21:32');
INSERT INTO `access_log` VALUES (12373, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 14:21:32', 7, 0, '', '2019-05-28 14:21:32');
INSERT INTO `access_log` VALUES (12374, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 14:21:32', 16, 0, '', '2019-05-28 14:21:32');
INSERT INTO `access_log` VALUES (12375, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 14:21:32', 47, 0, '', '2019-05-28 14:21:32');
INSERT INTO `access_log` VALUES (12376, '65.54.15590248520848301', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:27:32', 1, 1002001015, '账号未登陆', '2019-05-28 14:27:32');
INSERT INTO `access_log` VALUES (12377, '65.50.15590248520848319', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:27:32', 1, 1002001015, '账号未登陆', '2019-05-28 14:27:32');
INSERT INTO `access_log` VALUES (12378, '65.48.15590248520878331', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:27:32', 0, 1002001015, '账号未登陆', '2019-05-28 14:27:32');
INSERT INTO `access_log` VALUES (12379, '65.47.15590248591068323', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.104.198', '2019-05-28 14:27:39', 0, 1002001015, '账号未登陆', '2019-05-28 14:27:39');
INSERT INTO `access_log` VALUES (12380, '65.45.15590248591088327', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.104.198', '2019-05-28 14:27:39', 0, 1002001015, '账号未登陆', '2019-05-28 14:27:39');
INSERT INTO `access_log` VALUES (12381, '65.51.15590248591098317', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.104.198', '2019-05-28 14:27:39', 1, 1002001015, '账号未登陆', '2019-05-28 14:27:39');
INSERT INTO `access_log` VALUES (12382, '65.49.15590248608028319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.104.198', '2019-05-28 14:27:41', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 14:27:41');
INSERT INTO `access_log` VALUES (12383, '65.46.15590248685458315', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.104.198', '2019-05-28 14:27:49', 104, 0, '', '2019-05-28 14:27:49');
INSERT INTO `access_log` VALUES (12384, '65.52.15590248688838315', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.104.198', '2019-05-28 14:27:49', 10, 0, '', '2019-05-28 14:27:49');
INSERT INTO `access_log` VALUES (12385, '65.50.15590248688838321', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.104.198', '2019-05-28 14:27:49', 10, 0, '', '2019-05-28 14:27:49');
INSERT INTO `access_log` VALUES (12386, '65.48.15590248688878333', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.104.198', '2019-05-28 14:27:49', 9, 0, '', '2019-05-28 14:27:49');
INSERT INTO `access_log` VALUES (12387, '62.80.15590248738148931', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.104.198', '2019-05-28 14:27:54', 15, 0, '', '2019-05-28 14:27:54');
INSERT INTO `access_log` VALUES (12388, '62.88.15590248832698935', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.104.198', '2019-05-28 14:28:03', 54, 0, '', '2019-05-28 14:28:03');
INSERT INTO `access_log` VALUES (12389, '65.53.15590248843968309', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:28:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 14:28:04');
INSERT INTO `access_log` VALUES (12390, '59.79.15590249037308997', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.104.198', '2019-05-28 14:28:24', 13, 0, '', '2019-05-28 14:28:24');
INSERT INTO `access_log` VALUES (12391, '59.78.15590249114969003', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update_status', 'id=4&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.104.198', '2019-05-28 14:28:31', 9, 1002002009, NULL, '2019-05-28 14:28:32');
INSERT INTO `access_log` VALUES (12392, '65.50.15590249561798323', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:29:16', 69, 0, '', '2019-05-28 14:29:16');
INSERT INTO `access_log` VALUES (12393, '65.52.15590249589938317', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:29:19', 10, 0, '', '2019-05-28 14:29:19');
INSERT INTO `access_log` VALUES (12394, '65.48.15590249589978335', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:29:19', 10, 0, '', '2019-05-28 14:29:19');
INSERT INTO `access_log` VALUES (12395, '65.54.15590249590008305', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:29:19', 9, 0, '', '2019-05-28 14:29:19');
INSERT INTO `access_log` VALUES (12396, '62.87.15590249627388949', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:29:23', 18, 0, '', '2019-05-28 14:29:23');
INSERT INTO `access_log` VALUES (12397, '65.45.15590249671348331', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:29:27', 21, 0, '', '2019-05-28 14:29:27');
INSERT INTO `access_log` VALUES (12398, '59.73.15590249725239003', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:29:33', 13, 0, '', '2019-05-28 14:29:33');
INSERT INTO `access_log` VALUES (12399, '62.83.15590249791398949', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:29:39', 15, 0, '', '2019-05-28 14:29:39');
INSERT INTO `access_log` VALUES (12400, '62.86.15590249954228933', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:29:55', 14, 0, '', '2019-05-28 14:29:55');
INSERT INTO `access_log` VALUES (12401, '59.72.15590249956718997', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:29:56', 12, 0, '', '2019-05-28 14:29:56');
INSERT INTO `access_log` VALUES (12402, '65.49.15590249959398323', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:29:56', 19, 0, '', '2019-05-28 14:29:56');
INSERT INTO `access_log` VALUES (12403, '62.89.15590249962918943', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:29:56', 18, 0, '', '2019-05-28 14:29:56');
INSERT INTO `access_log` VALUES (12404, '59.76.15590250353578997', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:30:35', 3, 0, '', '2019-05-28 14:30:35');
INSERT INTO `access_log` VALUES (12405, '64.80.15590250390968281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:30:39', 3, 0, '', '2019-05-28 14:30:39');
INSERT INTO `access_log` VALUES (12406, '64.79.15590250392228285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:30:39', 3, 0, '', '2019-05-28 14:30:39');
INSERT INTO `access_log` VALUES (12407, '64.78.15590250409138291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:30:41', 3, 0, '', '2019-05-28 14:30:41');
INSERT INTO `access_log` VALUES (12408, '64.81.15590250420348287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:30:42', 2, 0, '', '2019-05-28 14:30:42');
INSERT INTO `access_log` VALUES (12409, '59.77.15590250447879001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:30:45', 14, 2001001000, '服务端发生异常', '2019-05-28 14:30:45');
INSERT INTO `access_log` VALUES (12410, '64.84.15590250459498293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:30:46', 3, 0, '', '2019-05-28 14:30:46');
INSERT INTO `access_log` VALUES (12411, '64.82.15590250460728293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:30:46', 2, 0, '', '2019-05-28 14:30:46');
INSERT INTO `access_log` VALUES (12412, '59.71.15590250466929003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:30:47', 3, 0, '', '2019-05-28 14:30:47');
INSERT INTO `access_log` VALUES (12413, '59.73.15590250466949005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.57.91.170', '2019-05-28 14:30:47', 13, 2001001000, '服务端发生异常', '2019-05-28 14:30:47');
INSERT INTO `access_log` VALUES (12414, '64.84.15590253117828297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 14:35:12', 3, 0, '', '2019-05-28 14:35:12');
INSERT INTO `access_log` VALUES (12415, '64.82.15590253118688297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 14:35:12', 3, 0, '', '2019-05-28 14:35:12');
INSERT INTO `access_log` VALUES (12416, '59.73.15590253178079009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 14:35:18', 4, 0, '', '2019-05-28 14:35:18');
INSERT INTO `access_log` VALUES (12417, '59.71.15590253178209007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 14:35:18', 14, 2001001000, '服务端发生异常', '2019-05-28 14:35:18');
INSERT INTO `access_log` VALUES (12418, '62.85.15590256580108955', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:40:58', 9, 1002001012, '访问令牌已过期', '2019-05-28 14:40:58');
INSERT INTO `access_log` VALUES (12419, '65.48.15590256598598343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:00', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 14:41:00');
INSERT INTO `access_log` VALUES (12420, '65.45.15590256621748343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 14:41:02');
INSERT INTO `access_log` VALUES (12421, '65.49.15590256714218335', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:11', 54, 0, '', '2019-05-28 14:41:11');
INSERT INTO `access_log` VALUES (12422, '65.50.15590256716988335', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:12', 10, 0, '', '2019-05-28 14:41:12');
INSERT INTO `access_log` VALUES (12423, '65.52.15590256717108333', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:12', 9, 0, '', '2019-05-28 14:41:12');
INSERT INTO `access_log` VALUES (12424, '65.53.15590256717118321', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:12', 9, 0, '', '2019-05-28 14:41:12');
INSERT INTO `access_log` VALUES (12425, '65.48.15590256861938345', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:26', 205, 0, '', '2019-05-28 14:41:26');
INSERT INTO `access_log` VALUES (12426, '65.45.15590256866378345', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:27', 9, 0, '', '2019-05-28 14:41:27');
INSERT INTO `access_log` VALUES (12427, '65.51.15590256866408331', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:27', 9, 0, '', '2019-05-28 14:41:27');
INSERT INTO `access_log` VALUES (12428, '65.47.15590256866478343', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:27', 9, 0, '', '2019-05-28 14:41:27');
INSERT INTO `access_log` VALUES (12429, '62.86.15590256966258943', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:37', 15, 0, '', '2019-05-28 14:41:37');
INSERT INTO `access_log` VALUES (12430, '64.84.15590257136568303', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:54', 10, 0, '', '2019-05-28 14:41:54');
INSERT INTO `access_log` VALUES (12431, '64.81.15590257136548297', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:54', 14, 0, '', '2019-05-28 14:41:54');
INSERT INTO `access_log` VALUES (12432, '64.76.15590257161818301', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:56', 10, 0, '', '2019-05-28 14:41:56');
INSERT INTO `access_log` VALUES (12433, '64.83.15590257161808299', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:56', 20, 0, '', '2019-05-28 14:41:56');
INSERT INTO `access_log` VALUES (12434, '64.82.15590257161768303', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:41:56', 27, 0, '', '2019-05-28 14:41:56');
INSERT INTO `access_log` VALUES (12435, '62.81.15590257181648947', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.129.6.251', '2019-05-28 14:41:58', 1, 1002001015, '账号未登陆', '2019-05-28 14:41:58');
INSERT INTO `access_log` VALUES (12436, '65.46.15590257213458329', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.204.78.42', '2019-05-28 14:42:01', 1, 1002001015, '账号未登陆', '2019-05-28 14:42:01');
INSERT INTO `access_log` VALUES (12437, '65.54.15590257213628319', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.204.78.42', '2019-05-28 14:42:01', 0, 1002001015, '账号未登陆', '2019-05-28 14:42:01');
INSERT INTO `access_log` VALUES (12438, '65.48.15590257213798347', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.204.78.42', '2019-05-28 14:42:01', 0, 1002001015, '账号未登陆', '2019-05-28 14:42:01');
INSERT INTO `access_log` VALUES (12439, '64.78.15590257747818303', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '58.247.206.141', '2019-05-28 14:42:55', 0, 1002001015, '账号未登陆', '2019-05-28 14:42:55');
INSERT INTO `access_log` VALUES (12440, '64.81.15590257754098299', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.89.19.149', '2019-05-28 14:42:55', 1, 1002001015, '账号未登陆', '2019-05-28 14:42:55');
INSERT INTO `access_log` VALUES (12441, '64.84.15590257763698305', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '180.97.118.223', '2019-05-28 14:42:56', 1, 1002001015, '账号未登陆', '2019-05-28 14:42:56');
INSERT INTO `access_log` VALUES (12442, '64.83.15590257782998301', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":1000,\"quantity\":100},{\"attrs\":[1,4],\"price\":500,\"quantity\":1000}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:42:58', 8, 1002002009, NULL, '2019-05-28 14:42:58');
INSERT INTO `access_log` VALUES (12443, '64.82.15590257802748305', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":1000,\"quantity\":100},{\"attrs\":[1,4],\"price\":500,\"quantity\":1000}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:43:00', 9, 1002002009, NULL, '2019-05-28 14:43:00');
INSERT INTO `access_log` VALUES (12444, '64.76.15590257843278303', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":1000,\"quantity\":100},{\"attrs\":[1,4],\"price\":500,\"quantity\":1000}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:43:04', 8, 1002002009, NULL, '2019-05-28 14:43:04');
INSERT INTO `access_log` VALUES (12445, '64.77.15590257898888305', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":1000,\"quantity\":100},{\"attrs\":[1,4],\"price\":500,\"quantity\":1000}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:43:10', 8, 1002002009, NULL, '2019-05-28 14:43:10');
INSERT INTO `access_log` VALUES (12446, '65.54.15590257901688321', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.204.78.42', '2019-05-28 14:43:10', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 14:43:10');
INSERT INTO `access_log` VALUES (12447, '65.48.15590257937018349', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.204.78.42', '2019-05-28 14:43:14', 374, 0, '', '2019-05-28 14:43:14');
INSERT INTO `access_log` VALUES (12448, '65.51.15590258005908335', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.204.78.42', '2019-05-28 14:43:21', 86, 0, '', '2019-05-28 14:43:21');
INSERT INTO `access_log` VALUES (12449, '65.45.15590258055458349', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.204.78.42', '2019-05-28 14:43:26', 79, 0, '', '2019-05-28 14:43:26');
INSERT INTO `access_log` VALUES (12450, '64.79.15590258135568299', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:43:34', 11, 0, '', '2019-05-28 14:43:34');
INSERT INTO `access_log` VALUES (12451, '66.57.15590258303098015', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:43:50', 16, 0, '', '2019-05-28 14:43:50');
INSERT INTO `access_log` VALUES (12452, '59.80.15590258404849013', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:44:00', 12, 0, '', '2019-05-28 14:44:00');
INSERT INTO `access_log` VALUES (12453, '62.88.15590258743928961', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-05-28 14:44:34', 14, 0, '', '2019-05-28 14:44:34');
INSERT INTO `access_log` VALUES (12454, '66.55.15590258903218019', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.151.178.165', '2019-05-28 14:44:50', 1, 1002001015, '账号未登陆', '2019-05-28 14:44:50');
INSERT INTO `access_log` VALUES (12455, '59.74.15590259021419017', 0, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.163', '2019-05-28 14:45:02', 1, 1002001015, '账号未登陆', '2019-05-28 14:45:02');
INSERT INTO `access_log` VALUES (12456, '59.78.15590260891469021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '101.95.103.182', '2019-05-28 14:48:09', 4, 0, '', '2019-05-28 14:48:09');
INSERT INTO `access_log` VALUES (12457, '59.80.15590260891469017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '101.95.103.182', '2019-05-28 14:48:09', 11, 2001001000, '服务端发生异常', '2019-05-28 14:48:09');
INSERT INTO `access_log` VALUES (12458, '64.79.15590260925528303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '101.95.103.182', '2019-05-28 14:48:13', 4, 0, '', '2019-05-28 14:48:13');
INSERT INTO `access_log` VALUES (12459, '64.78.15590260926258309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '101.95.103.182', '2019-05-28 14:48:13', 2, 0, '', '2019-05-28 14:48:13');
INSERT INTO `access_log` VALUES (12460, '64.81.15590260938678305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '101.95.103.182', '2019-05-28 14:48:14', 3, 0, '', '2019-05-28 14:48:14');
INSERT INTO `access_log` VALUES (12461, '64.84.15590260942628311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '101.95.103.182', '2019-05-28 14:48:14', 3, 0, '', '2019-05-28 14:48:14');
INSERT INTO `access_log` VALUES (12462, '59.76.15590265484499019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:55:48', 4, 0, '', '2019-05-28 14:55:48');
INSERT INTO `access_log` VALUES (12463, '59.77.15590265484749023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:55:48', 13, 2001001000, '服务端发生异常', '2019-05-28 14:55:48');
INSERT INTO `access_log` VALUES (12464, '64.85.15590265805418315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:21', 3, 0, '', '2019-05-28 14:56:21');
INSERT INTO `access_log` VALUES (12465, '64.80.15590265806738307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:21', 3, 0, '', '2019-05-28 14:56:21');
INSERT INTO `access_log` VALUES (12466, '64.76.15590265829558315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:23', 3, 0, '', '2019-05-28 14:56:23');
INSERT INTO `access_log` VALUES (12467, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:23', 19, 0, '', '2019-05-28 14:56:23');
INSERT INTO `access_log` VALUES (12468, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:27', 7, 0, '', '2019-05-28 14:56:27');
INSERT INTO `access_log` VALUES (12469, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:27', 9, 0, '', '2019-05-28 14:56:27');
INSERT INTO `access_log` VALUES (12470, '64.83.15590265882008313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:28', 3, 0, '', '2019-05-28 14:56:28');
INSERT INTO `access_log` VALUES (12471, '64.84.15590265883878319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:28', 2, 0, '', '2019-05-28 14:56:28');
INSERT INTO `access_log` VALUES (12472, '64.77.15590265894848319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:29', 2, 0, '', '2019-05-28 14:56:29');
INSERT INTO `access_log` VALUES (12473, '64.79.15590265909678311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:31', 2, 0, '', '2019-05-28 14:56:31');
INSERT INTO `access_log` VALUES (12474, '64.78.15590265926548319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:33', 2, 0, '', '2019-05-28 14:56:33');
INSERT INTO `access_log` VALUES (12475, '64.81.15590265936318315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:34', 2, 0, '', '2019-05-28 14:56:34');
INSERT INTO `access_log` VALUES (12476, '64.85.15590265968888317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:37', 2, 0, '', '2019-05-28 14:56:37');
INSERT INTO `access_log` VALUES (12477, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:37', 28, 0, '', '2019-05-28 14:56:37');
INSERT INTO `access_log` VALUES (12478, '64.80.15590265983618309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:38', 273, 0, '', '2019-05-28 14:56:39');
INSERT INTO `access_log` VALUES (12479, '64.76.15590265988418317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:39', 2, 0, '', '2019-05-28 14:56:39');
INSERT INTO `access_log` VALUES (12480, '64.83.15590266002228315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:40', 3, 0, '', '2019-05-28 14:56:40');
INSERT INTO `access_log` VALUES (12481, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:40', 6, 0, '', '2019-05-28 14:56:40');
INSERT INTO `access_log` VALUES (12482, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:41', 9, 0, '', '2019-05-28 14:56:41');
INSERT INTO `access_log` VALUES (12483, '64.84.15590266024678321', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:56:42', 10, 0, '', '2019-05-28 14:56:42');
INSERT INTO `access_log` VALUES (12484, '64.79.15590266236798313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:04', 2, 0, '', '2019-05-28 14:57:04');
INSERT INTO `access_log` VALUES (12485, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:04', 8, 0, '', '2019-05-28 14:57:04');
INSERT INTO `access_log` VALUES (12486, '64.78.15590266244088321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:04', 3, 0, '', '2019-05-28 14:57:04');
INSERT INTO `access_log` VALUES (12487, '64.81.15590266245388317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:05', 3, 0, '', '2019-05-28 14:57:05');
INSERT INTO `access_log` VALUES (12488, '59.78.15590266261249029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:06', 4, 0, '', '2019-05-28 14:57:06');
INSERT INTO `access_log` VALUES (12489, '59.80.15590266261269025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:06', 14, 2001001000, '服务端发生异常', '2019-05-28 14:57:06');
INSERT INTO `access_log` VALUES (12490, '64.85.15590266306468319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:11', 275, 0, '', '2019-05-28 14:57:11');
INSERT INTO `access_log` VALUES (12491, '64.80.15590266311368311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:11', 2, 0, '', '2019-05-28 14:57:11');
INSERT INTO `access_log` VALUES (12492, '64.84.15590266619208323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:42', 3, 0, '', '2019-05-28 14:57:42');
INSERT INTO `access_log` VALUES (12493, '64.77.15590266620848323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:42', 2, 0, '', '2019-05-28 14:57:42');
INSERT INTO `access_log` VALUES (12494, '59.71.15590266624009027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:42', 4, 0, '', '2019-05-28 14:57:42');
INSERT INTO `access_log` VALUES (12495, '59.73.15590266624019029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:42', 49, 2001001000, '服务端发生异常', '2019-05-28 14:57:42');
INSERT INTO `access_log` VALUES (12496, '64.79.15590266629098315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:43', 2, 0, '', '2019-05-28 14:57:43');
INSERT INTO `access_log` VALUES (12497, '64.78.15590266630838323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:43', 2, 0, '', '2019-05-28 14:57:43');
INSERT INTO `access_log` VALUES (12498, '59.74.15590266641059029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:44', 2, 0, '', '2019-05-28 14:57:44');
INSERT INTO `access_log` VALUES (12499, '59.75.15590266641069027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.198.98.226', '2019-05-28 14:57:44', 10, 2001001000, '服务端发生异常', '2019-05-28 14:57:44');
INSERT INTO `access_log` VALUES (12500, '093c5164-c140-46cd-b582-532c226db2e8', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:02:11', 559, 1002001012, '访问令牌已过期', '2019-05-28 15:02:12');
INSERT INTO `access_log` VALUES (12501, '6fa1b3ed-dfc2-41b5-bb3a-b3d820aae80c', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:02:11', 558, 1002001012, '访问令牌已过期', '2019-05-28 15:02:12');
INSERT INTO `access_log` VALUES (12502, 'bdb54e10-07a0-4f30-8c4b-107fa7bb81df', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:02:11', 558, 1002001012, '访问令牌已过期', '2019-05-28 15:02:12');
INSERT INTO `access_log` VALUES (12503, 'acb54b3e-1ca7-42e9-9aa5-f1f69aebaa2a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:02:15', 189, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 15:02:15');
INSERT INTO `access_log` VALUES (12504, '078082bc-6619-4832-a48d-72734412099b', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:02:24', 264, 0, '', '2019-05-28 15:02:24');
INSERT INTO `access_log` VALUES (12505, 'd6ad9d66-dd97-4451-8878-8bcd1fc68732', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:02:25', 232, 0, '', '2019-05-28 15:02:25');
INSERT INTO `access_log` VALUES (12506, '952425cf-cafa-4ecd-bdc1-62e19efbe210', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:02:25', 66, 0, '', '2019-05-28 15:02:25');
INSERT INTO `access_log` VALUES (12507, '206352ab-6dcd-4c97-ac8b-a0f5f1fb85ee', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:02:25', 149, 0, '', '2019-05-28 15:02:25');
INSERT INTO `access_log` VALUES (12508, '1941015a-630e-4d2b-82f1-2683864dfafe', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:02:33', 804, 0, '', '2019-05-28 15:02:34');
INSERT INTO `access_log` VALUES (12509, '915baa10-fce2-4122-8bc8-b188753fe93f', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:02:33', 804, 0, '', '2019-05-28 15:02:34');
INSERT INTO `access_log` VALUES (12510, '968c1aad-e9a7-49ab-883d-6a8b928a5600', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:02:48', 61, 0, '', '2019-05-28 15:02:48');
INSERT INTO `access_log` VALUES (12511, 'b2d5825f-84e6-40c6-b6ff-1318e0300152', 0, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:03:09', 27, 1002001015, '账号未登陆', '2019-05-28 15:03:09');
INSERT INTO `access_log` VALUES (12512, 'd149a65a-58d8-4372-9cb8-237a0eed3b1b', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:50', 4894, 0, '', '2019-05-28 15:04:56');
INSERT INTO `access_log` VALUES (12513, 'd149a65a-58d8-4372-9cb8-237a0eed3b1b', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:50', 4894, 0, '', '2019-05-28 15:04:56');
INSERT INTO `access_log` VALUES (12514, 'bcfac0a6-930c-49e6-a077-d067f61b52be', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:50', 5280, 0, '', '2019-05-28 15:04:56');
INSERT INTO `access_log` VALUES (12515, '1d03bd46-dc61-4684-a039-c5c70c095287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:55', 497, 0, '', '2019-05-28 15:04:56');
INSERT INTO `access_log` VALUES (12516, '0b11a7c0-2ea4-4fec-a2af-41cdc2d67d28', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:56', 11, 0, '', '2019-05-28 15:04:56');
INSERT INTO `access_log` VALUES (12517, '5927306a-f1c8-48a7-bf19-7de60af8de21', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:56', 51, 0, '', '2019-05-28 15:04:56');
INSERT INTO `access_log` VALUES (12518, '89e637f7-a8c3-4fbb-8f38-a58fc44ec0fc', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:57', 17, 0, '', '2019-05-28 15:04:57');
INSERT INTO `access_log` VALUES (12519, 'bcfac0a6-930c-49e6-a077-d067f61b52be', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:50', 5280, 0, '', '2019-05-28 15:04:57');
INSERT INTO `access_log` VALUES (12520, 'bcfac0a6-930c-49e6-a077-d067f61b52be', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:50', 5280, 0, '', '2019-05-28 15:04:56');
INSERT INTO `access_log` VALUES (12521, 'd83580c8-94cc-45ee-b44c-751f1b0b7cd8', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:57', 10, 0, '', '2019-05-28 15:04:57');
INSERT INTO `access_log` VALUES (12522, 'e1fea063-fa03-4d5a-bdf2-3b28751e9a39', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:57', 12, 0, '', '2019-05-28 15:04:57');
INSERT INTO `access_log` VALUES (12523, 'c57cbb6a-2c43-4f4b-890c-223490e3554c', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:58', 10, 0, '', '2019-05-28 15:04:58');
INSERT INTO `access_log` VALUES (12524, 'aba3461b-bea2-4b6f-a506-fbb9476513f4', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:58', 30, 0, '', '2019-05-28 15:04:58');
INSERT INTO `access_log` VALUES (12525, '4ad8ae18-6aa8-4929-8b93-101fe9435bcc', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:59', 12, 0, '', '2019-05-28 15:04:59');
INSERT INTO `access_log` VALUES (12526, '3f30650e-f902-4d62-862e-00a8eb9347f7', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:04:59', 10, 0, '', '2019-05-28 15:04:59');
INSERT INTO `access_log` VALUES (12527, '50cc6f41-a2c2-428b-a617-2bb3d5d55a74', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:05:03', 1008, 0, '', '2019-05-28 15:05:04');
INSERT INTO `access_log` VALUES (12528, '50cc6f41-a2c2-428b-a617-2bb3d5d55a74', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:05:03', 1008, 0, '', '2019-05-28 15:05:05');
INSERT INTO `access_log` VALUES (12529, '0f90ade0-92eb-4b21-b39f-0a208b9ebfaf', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:05:05', 105, 0, '', '2019-05-28 15:05:05');
INSERT INTO `access_log` VALUES (12530, '8456ab7c-2533-4a83-843b-86e6fbdcf880', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:05:16', 12, 0, '', '2019-05-28 15:05:16');
INSERT INTO `access_log` VALUES (12531, 'd700660c-d783-489c-807c-03d86dac754d', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:05:16', 29, 0, '', '2019-05-28 15:05:16');
INSERT INTO `access_log` VALUES (12532, '65.53.15590277958928355', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:16:36', 4, 1002001012, '访问令牌已过期', '2019-05-28 15:16:36');
INSERT INTO `access_log` VALUES (12533, '65.52.15590277958978363', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:16:36', 3, 1002001012, '访问令牌已过期', '2019-05-28 15:16:36');
INSERT INTO `access_log` VALUES (12534, '65.54.15590277959028349', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:16:36', 12, 1002001012, '访问令牌已过期', '2019-05-28 15:16:36');
INSERT INTO `access_log` VALUES (12535, '65.46.15590277987078361', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:16:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 15:16:39');
INSERT INTO `access_log` VALUES (12536, '65.47.15590278234858375', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:17:03', 64, 0, '', '2019-05-28 15:17:04');
INSERT INTO `access_log` VALUES (12537, '65.49.15590278238638365', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:17:04', 463, 0, '', '2019-05-28 15:17:04');
INSERT INTO `access_log` VALUES (12538, '65.45.15590278238608377', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:17:04', 466, 0, '', '2019-05-28 15:17:04');
INSERT INTO `access_log` VALUES (12539, '65.50.15590278238688369', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:17:04', 458, 0, '', '2019-05-28 15:17:04');
INSERT INTO `access_log` VALUES (12540, '64.78.15590278267338339', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:17:07', 115, 0, '', '2019-05-28 15:17:07');
INSERT INTO `access_log` VALUES (12541, '64.79.15590278267338331', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:17:07', 118, 0, '', '2019-05-28 15:17:07');
INSERT INTO `access_log` VALUES (12542, '64.82.15590278298538341', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:17:10', 12, 0, '', '2019-05-28 15:17:10');
INSERT INTO `access_log` VALUES (12543, '64.81.15590278298518335', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:17:10', 15, 0, '', '2019-05-28 15:17:10');
INSERT INTO `access_log` VALUES (12544, '64.85.15590278350048337', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:17:15', 11, 0, '', '2019-05-28 15:17:15');
INSERT INTO `access_log` VALUES (12545, '64.80.15590278399478329', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:17:20', 13, 0, '', '2019-05-28 15:17:20');
INSERT INTO `access_log` VALUES (12546, '64.76.15590278399518337', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:17:20', 9, 0, '', '2019-05-28 15:17:20');
INSERT INTO `access_log` VALUES (12547, '64.77.15590278426508341', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:17:23', 108, 0, '', '2019-05-28 15:17:23');
INSERT INTO `access_log` VALUES (12548, '64.84.15590278426488341', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:17:23', 110, 0, '', '2019-05-28 15:17:23');
INSERT INTO `access_log` VALUES (12549, '59.72.15590278570929039', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-28 15:17:37', 200, 2001001000, '服务端发生异常', '2019-05-28 15:17:37');
INSERT INTO `access_log` VALUES (12550, '59.72.15590281274159043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:07', 4, 0, '', '2019-05-28 15:22:07');
INSERT INTO `access_log` VALUES (12551, '59.74.15590281274109049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:07', 14, 2001001000, '服务端发生异常', '2019-05-28 15:22:07');
INSERT INTO `access_log` VALUES (12552, '64.84.15590281300028345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:10', 3, 0, '', '2019-05-28 15:22:10');
INSERT INTO `access_log` VALUES (12553, '64.78.15590281300968345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:10', 2, 0, '', '2019-05-28 15:22:10');
INSERT INTO `access_log` VALUES (12554, '64.79.15590281320968337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:12', 252, 0, '', '2019-05-28 15:22:12');
INSERT INTO `access_log` VALUES (12555, '64.82.15590281333718347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:13', 3, 0, '', '2019-05-28 15:22:13');
INSERT INTO `access_log` VALUES (12556, '64.81.15590281340928341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:14', 2, 0, '', '2019-05-28 15:22:14');
INSERT INTO `access_log` VALUES (12557, '59.79.15590281355309045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:16', 13, 0, '', '2019-05-28 15:22:16');
INSERT INTO `access_log` VALUES (12558, '59.78.15590281355329051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:16', 20, 2001001000, '服务端发生异常', '2019-05-28 15:22:16');
INSERT INTO `access_log` VALUES (12559, '64.76.15590281450838343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:25', 2, 0, '', '2019-05-28 15:22:25');
INSERT INTO `access_log` VALUES (12560, '64.80.15590281451888335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:25', 2, 0, '', '2019-05-28 15:22:25');
INSERT INTO `access_log` VALUES (12561, '64.83.15590281506128341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:31', 3, 0, '', '2019-05-28 15:22:31');
INSERT INTO `access_log` VALUES (12562, '64.77.15590281506948347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:31', 3, 0, '', '2019-05-28 15:22:31');
INSERT INTO `access_log` VALUES (12563, '59.77.15590281550359047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:35', 3, 0, '', '2019-05-28 15:22:35');
INSERT INTO `access_log` VALUES (12564, '59.71.15590281550379049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:22:35', 14, 2001001000, '服务端发生异常', '2019-05-28 15:22:35');
INSERT INTO `access_log` VALUES (12565, 'd069144a-5d49-4c55-9812-44e296d3de48', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Apache-HttpClient/4.5.6 (Java/1.8.0_152-release)', '127.0.0.1', '2019-05-28 15:23:57', 136, 0, '', '2019-05-28 15:23:57');
INSERT INTO `access_log` VALUES (12566, '64.83.15590282673118343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:24:27', 5, 0, '', '2019-05-28 15:24:27');
INSERT INTO `access_log` VALUES (12567, '64.77.15590282674158349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:24:27', 2, 0, '', '2019-05-28 15:24:27');
INSERT INTO `access_log` VALUES (12568, '59.76.15590282706839045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:24:31', 3, 0, '', '2019-05-28 15:24:31');
INSERT INTO `access_log` VALUES (12569, '59.77.15590282707019049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:24:31', 14, 2001001000, '服务端发生异常', '2019-05-28 15:24:31');
INSERT INTO `access_log` VALUES (12570, 'b4c55fae-86f9-4a98-bff3-6ee211ebdd30', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Apache-HttpClient/4.5.6 (Java/1.8.0_152-release)', '127.0.0.1', '2019-05-28 15:32:22', 48, 0, '', '2019-05-28 15:32:22');
INSERT INTO `access_log` VALUES (12571, '7c48f622-87c5-4841-a16c-c3c1354238a6', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', '', 'POST', 'Apache-HttpClient/4.5.6 (Java/1.8.0_152-release)', '127.0.0.1', '2019-05-28 15:32:36', 19, 2001001001, '参数缺失:Required String parameter \'refreshToken\' is not present', '2019-05-28 15:32:36');
INSERT INTO `access_log` VALUES (12572, 'b3efa59d-aa77-4594-b67a-bed8d676069d', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:35:14', 127, 1002001015, '账号未登陆', '2019-05-28 15:35:15');
INSERT INTO `access_log` VALUES (12573, 'dc5c879e-692a-44a0-8013-08dea8ad67a1', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:35:14', 128, 1002001015, '账号未登陆', '2019-05-28 15:35:15');
INSERT INTO `access_log` VALUES (12574, '9104ad8b-2862-437c-a5f1-78f4b4b3572b', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:35:14', 128, 1002001015, '账号未登陆', '2019-05-28 15:35:15');
INSERT INTO `access_log` VALUES (12575, '31f48fb3-b3f6-43e3-a1f0-ccd72ab9385d', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:37:49', 486, 0, '', '2019-05-28 15:37:49');
INSERT INTO `access_log` VALUES (12576, 'c874ba10-8233-4e6b-8704-3dd748064cbb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:37:50', 344, 0, '', '2019-05-28 15:37:50');
INSERT INTO `access_log` VALUES (12577, 'd9fdfc67-44ac-40f7-8556-198771133c53', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:37:50', 331, 0, '', '2019-05-28 15:37:50');
INSERT INTO `access_log` VALUES (12578, 'f8d1a722-051d-483c-aa4c-c26058dc29cd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:37:50', 367, 0, '', '2019-05-28 15:37:50');
INSERT INTO `access_log` VALUES (12579, 'b18173f8-7445-458a-a53f-e92e375e1875', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:37:55', 1057, 0, '', '2019-05-28 15:37:56');
INSERT INTO `access_log` VALUES (12580, '9d66d3ef-bcbe-4d32-a481-e66cb4a38286', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:37:58', 1365, 0, '', '2019-05-28 15:37:59');
INSERT INTO `access_log` VALUES (12581, 'a19cae32-895d-4fa4-b920-af4f086f82a8', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:38:01', 642, 0, '', '2019-05-28 15:38:02');
INSERT INTO `access_log` VALUES (12582, '026a4ce6-d79e-4d26-a623-e46a149cbf8c', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:38:03', 578, 0, '', '2019-05-28 15:38:04');
INSERT INTO `access_log` VALUES (12583, 'c4d0333d-3849-4b24-9b87-7c09b1cb3748', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:38:06', 75, 0, '', '2019-05-28 15:38:06');
INSERT INTO `access_log` VALUES (12584, 'ce013714-6c51-40ff-9a3d-8fb10d7254d8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:38:08', 93, 0, '', '2019-05-28 15:38:08');
INSERT INTO `access_log` VALUES (12585, '6c47bb35-4174-48fd-9ccf-99b7897b3998', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:38:09', 40, 0, '', '2019-05-28 15:38:10');
INSERT INTO `access_log` VALUES (12586, '40efe80e-f662-44e3-974e-2fcd2800686f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:39:23', 194, 0, '', '2019-05-28 15:39:23');
INSERT INTO `access_log` VALUES (12587, '3f85a23b-07e6-4f1c-af72-81cd844388ad', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-28 15:39:26', 254, 0, '', '2019-05-28 15:39:26');
INSERT INTO `access_log` VALUES (12588, '83242c0c-6ced-4653-9c40-e76da7873cd2', 0, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:45:22', 20, 1002001015, '账号未登陆', '2019-05-28 15:45:22');
INSERT INTO `access_log` VALUES (12589, '24a52c8a-f80b-47d0-a18c-815f6fa0af1b', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 15:44:29', 71, 1002001015, '账号未登陆', '2019-05-28 15:44:29');
INSERT INTO `access_log` VALUES (12590, '4a180e2f-33db-4dab-97da-3398bad60938', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 15:44:29', 71, 1002001015, '账号未登陆', '2019-05-28 15:44:29');
INSERT INTO `access_log` VALUES (12591, 'b7c88fee-dbfa-4976-8322-6b6d5b656daa', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 15:44:29', 71, 1002001015, '账号未登陆', '2019-05-28 15:44:29');
INSERT INTO `access_log` VALUES (12592, 'c09ff7a0-6ebe-44c6-b1ab-2da59685b99e', 0, 2, 'product-application', '/product-api/admins/brand/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:48:18', 1, 1002001015, '账号未登陆', '2019-05-28 15:48:18');
INSERT INTO `access_log` VALUES (12593, '59.73.15590296299649071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:47:10', 4, 0, '', '2019-05-28 15:47:10');
INSERT INTO `access_log` VALUES (12594, '59.75.15590296299679069', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 15:47:10', 13, 2001001000, '服务端发生异常', '2019-05-28 15:47:10');
INSERT INTO `access_log` VALUES (12595, 'c18c925f-abb8-4442-9850-ed73b9e289df', 0, 2, 'product-application', '/product-api/admins/brand/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:49:53', 0, 1002001015, '账号未登陆', '2019-05-28 15:49:53');
INSERT INTO `access_log` VALUES (12596, '32bc033b-4e46-4f94-82ae-bf580a29f6fe', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:50:59', 182, 1002001012, '访问令牌已过期', '2019-05-28 15:50:59');
INSERT INTO `access_log` VALUES (12597, 'dbeabd7f-2826-4a51-b6b1-c41b085e5d52', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:50:59', 182, 1002001012, '访问令牌已过期', '2019-05-28 15:50:59');
INSERT INTO `access_log` VALUES (12598, '37ce0cee-b12c-400f-ad64-023c443b13e2', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:50:59', 182, 1002001012, '访问令牌已过期', '2019-05-28 15:51:00');
INSERT INTO `access_log` VALUES (12599, '00488046-eda9-44da-92c7-9e675a933bdc', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:52:04', 252, 0, '', '2019-05-28 15:52:04');
INSERT INTO `access_log` VALUES (12600, 'c8e5ce61-6941-4437-85fd-6ee1777bec71', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:52:05', 96, 0, '', '2019-05-28 15:52:05');
INSERT INTO `access_log` VALUES (12601, '9f25ebfe-4751-4c66-8045-ec987603b7c8', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:52:05', 52, 0, '', '2019-05-28 15:52:05');
INSERT INTO `access_log` VALUES (12602, '116863c3-0180-40c9-b832-130076c969c3', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:52:05', 142, 0, '', '2019-05-28 15:52:05');
INSERT INTO `access_log` VALUES (12603, '9c7edbeb-ca04-45a2-b3aa-fa2fb1016bfb', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:52:16', 347, 0, '', '2019-05-28 15:52:17');
INSERT INTO `access_log` VALUES (12604, 'b0ad3c3b-675c-4c8c-8dd1-cc7d3f998786', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:52:16', 353, 0, '', '2019-05-28 15:52:17');
INSERT INTO `access_log` VALUES (12605, '37bd83a6-c840-40de-8ddb-4a83b1a6194b', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:52:29', 101, 0, '', '2019-05-28 15:52:29');
INSERT INTO `access_log` VALUES (12606, '21def2ba-bacf-405b-a340-3113e85b041e', 0, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:52:49', 2, 1002001015, '账号未登陆', '2019-05-28 15:52:49');
INSERT INTO `access_log` VALUES (12607, '6dbeb0a9-9958-498c-b0e2-854604930b82', 0, 2, 'product-application', '/product-api/admins/brand/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:52:55', 1, 1002001015, '账号未登陆', '2019-05-28 15:52:55');
INSERT INTO `access_log` VALUES (12608, '66f10244-0555-4e57-b8a1-b29581ca462f', 0, 2, 'product-application', '/product-api/admins/brand/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:53:26', 1, 1002001015, '账号未登陆', '2019-05-28 15:53:26');
INSERT INTO `access_log` VALUES (12609, '2df88bd1-4e21-482c-a609-00cfe15dee6a', 0, 2, 'product-application', '/product-api/admins/brand/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:54:14', 1, 1002001015, '账号未登陆', '2019-05-28 15:54:14');
INSERT INTO `access_log` VALUES (12610, '380b1a2b-1452-4bdc-9836-e7dd942099fa', 0, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:56:33', 0, 1002001015, '账号未登陆', '2019-05-28 15:56:33');
INSERT INTO `access_log` VALUES (12611, 'b4de9d23-60c1-451b-9ad0-bba896c04bb3', 27, 2, 'product-application', '/product-api/admins/brand/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:57:13', 37, 1002002009, NULL, '2019-05-28 15:57:13');
INSERT INTO `access_log` VALUES (12612, 'fde254da-91ef-41dc-8d1f-f0785b7dde1c', 27, 2, 'product-application', '/product-api/admins/brand/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:57:42', 36, 1002002009, NULL, '2019-05-28 15:57:42');
INSERT INTO `access_log` VALUES (12613, '14ed0201-c14a-41c8-acff-cbc20f65a3ae', 27, 2, 'product-application', '/product-api/admins/brand/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:58:43', 198, 1002002009, NULL, '2019-05-28 15:58:43');
INSERT INTO `access_log` VALUES (12614, 'bb3ae62d-bb28-4815-9b7e-34e18ec00cae', 27, 2, 'product-application', '/product-api/admins/brand/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 15:59:51', 69, 1002002009, NULL, '2019-05-28 15:59:51');
INSERT INTO `access_log` VALUES (12615, '8f62dcc9-01d7-422c-8100-122a18e04ed9', 27, 2, 'product-application', '/product-api/admins/brand/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:00:06', 56, 1002002009, NULL, '2019-05-28 16:00:06');
INSERT INTO `access_log` VALUES (12616, 'dcb310aa-f578-4de9-98e9-78459248dd30', 27, 2, 'product-application', '/product-api/admins/brand/add', '', 'POST', 'PostmanRuntime/7.6.0', '127.0.0.1', '2019-05-28 16:01:18', 43, 1002002009, NULL, '2019-05-28 16:01:18');
INSERT INTO `access_log` VALUES (12617, '242ddcd2-6ff1-4122-af71-903f12ee65b5', 27, 2, 'product-application', '/product-api/admins/brand/add', '', 'POST', 'PostmanRuntime/7.6.0', '127.0.0.1', '2019-05-28 16:01:24', 30, 1002002009, NULL, '2019-05-28 16:01:24');
INSERT INTO `access_log` VALUES (12618, '718cb53e-3da9-4254-9356-686f1b4f6c84', 27, 2, 'product-application', '/product-api/admins/brand/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:03:13', 63, 1002002009, NULL, '2019-05-28 16:03:13');
INSERT INTO `access_log` VALUES (12619, 'a6ea6d67-5ce0-4ab8-83e3-89a5280455cc', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:03:02', 288, 0, '', '2019-05-28 16:03:02');
INSERT INTO `access_log` VALUES (12620, 'ca7318bc-40bb-4fc4-9102-e7bb47ef150d', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:03:02', 626, 0, '', '2019-05-28 16:03:03');
INSERT INTO `access_log` VALUES (12621, '2b589643-8d84-4984-9ea5-cc7a86bd1f86', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:03:34', 74, 0, '', '2019-05-28 16:03:34');
INSERT INTO `access_log` VALUES (12622, '1ac1ceee-2424-49b6-b25f-dc98b8edf4ae', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:03:34', 25, 0, '', '2019-05-28 16:03:34');
INSERT INTO `access_log` VALUES (12623, '497cc86c-6605-403a-88b1-6a8fa0711e8e', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:03:39', 36, 0, '', '2019-05-28 16:03:39');
INSERT INTO `access_log` VALUES (12624, '2fa84472-9613-4911-a0f9-fda8a8009cd5', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:03:40', 24, 0, '', '2019-05-28 16:03:40');
INSERT INTO `access_log` VALUES (12625, '0e8e6bf3-b0ce-4fa1-8dd8-6ab5139c4e61', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:03:41', 24, 0, '', '2019-05-28 16:03:41');
INSERT INTO `access_log` VALUES (12626, 'e62dca93-514a-4a38-a9cc-ad695ef37149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:03:49', 24, 0, '', '2019-05-28 16:03:49');
INSERT INTO `access_log` VALUES (12627, 'c3461f47-8694-4106-9890-28987c16abb2', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:03:50', 23, 0, '', '2019-05-28 16:03:50');
INSERT INTO `access_log` VALUES (12628, '56eb7588-beaa-49de-93ce-3d9a815f62d3', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:03:52', 25, 0, '', '2019-05-28 16:03:52');
INSERT INTO `access_log` VALUES (12629, '16af1c61-2bb7-4d7a-b848-9ee688bd934d', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:04:00', 181, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机验证码长度为 4-6 位\n手机验证码必须都是数字', '2019-05-28 16:04:00');
INSERT INTO `access_log` VALUES (12630, '454f4318-63dd-4ea0-8683-ae1207555011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13080612932&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:04:30', 536, 1001003000, '验证码不存在', '2019-05-28 16:04:30');
INSERT INTO `access_log` VALUES (12631, 'c7758de9-dcd9-4a33-a5c4-853aed12a763', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13080612932&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:04:38', 102, 1001003000, '验证码不存在', '2019-05-28 16:04:38');
INSERT INTO `access_log` VALUES (12632, '965a6e93-daf2-4ee4-b3a6-8165890c0a5f', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:08', 47, 0, '', '2019-05-28 16:06:08');
INSERT INTO `access_log` VALUES (12633, 'e9f44335-4f30-4c49-aeed-3d1d49560a21', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:08', 24, 0, '', '2019-05-28 16:06:08');
INSERT INTO `access_log` VALUES (12634, '6e8971b2-23c7-4a9c-9545-7d13fa5a4909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:11', 74, 0, '', '2019-05-28 16:06:11');
INSERT INTO `access_log` VALUES (12635, '7cc6fbfc-b0cb-43f8-9912-488f6e9338ab', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:22', 24, 0, '', '2019-05-28 16:06:22');
INSERT INTO `access_log` VALUES (12636, 'eda4152e-1bf3-4342-8512-ec044b2c2a44', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:22', 25, 0, '', '2019-05-28 16:06:22');
INSERT INTO `access_log` VALUES (12637, 'ee6696f2-8dc6-4d41-968e-42ff4a0aa4c1', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:24', 24, 0, '', '2019-05-28 16:06:24');
INSERT INTO `access_log` VALUES (12638, 'fc429cb9-b275-467b-9960-8926cc83aacb', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:36', 25, 0, '', '2019-05-28 16:06:36');
INSERT INTO `access_log` VALUES (12639, '1874ff42-b21f-4da2-b18e-b13f068c5a2a', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:36', 27, 0, '', '2019-05-28 16:06:36');
INSERT INTO `access_log` VALUES (12640, '409bb270-926c-45c3-8f17-6e8dd2544da3', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:38', 51, 0, '', '2019-05-28 16:06:38');
INSERT INTO `access_log` VALUES (12641, '1ae05832-e279-4f0a-8a42-c36cc87ef0da', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:38', 81, 0, '', '2019-05-28 16:06:38');
INSERT INTO `access_log` VALUES (12642, 'bd891cb2-8cfa-4752-9de5-60723c3a8ccd', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:40', 56, 0, '', '2019-05-28 16:06:40');
INSERT INTO `access_log` VALUES (12643, 'e8bbff24-21da-4386-b8fa-3266fbb29f6f', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:40', 28, 0, '', '2019-05-28 16:06:40');
INSERT INTO `access_log` VALUES (12644, '491faa43-78e9-48cb-917c-1644e2830035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:42', 26, 0, '', '2019-05-28 16:06:42');
INSERT INTO `access_log` VALUES (12645, 'd2658b0c-8b7c-4ef6-b661-9b150f3a8d11', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:42', 54, 0, '', '2019-05-28 16:06:42');
INSERT INTO `access_log` VALUES (12646, '28b3f9ae-7f45-4f33-9f7c-98a7b4a3f4ef', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:44', 24, 0, '', '2019-05-28 16:06:44');
INSERT INTO `access_log` VALUES (12647, 'ca29ed04-61b7-4587-b2a7-c3a6de1e5ff7', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:44', 25, 0, '', '2019-05-28 16:06:44');
INSERT INTO `access_log` VALUES (12648, 'e30817d7-a434-472e-82ca-1f2d5a0a0da7', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:58', 23, 0, '', '2019-05-28 16:06:58');
INSERT INTO `access_log` VALUES (12649, 'f092d5d4-32a5-45ee-b64f-1d8f3f47f25f', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:06:59', 23, 0, '', '2019-05-28 16:06:59');
INSERT INTO `access_log` VALUES (12650, '2ea3da8b-b14a-4d26-bba6-7ece1f4f483d', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:07:00', 25, 0, '', '2019-05-28 16:07:00');
INSERT INTO `access_log` VALUES (12651, 'd46caa36-92e3-4652-ab2d-5b72156008d5', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:07:00', 50, 0, '', '2019-05-28 16:07:00');
INSERT INTO `access_log` VALUES (12652, '65.50.15590309008208413', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-28 16:08:21', 4, 1002001012, '访问令牌已过期', '2019-05-28 16:08:21');
INSERT INTO `access_log` VALUES (12653, '65.47.15590309008208417', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-28 16:08:21', 5, 1002001012, '访问令牌已过期', '2019-05-28 16:08:21');
INSERT INTO `access_log` VALUES (12654, '65.51.15590309008218409', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-28 16:08:21', 6, 1002001012, '访问令牌已过期', '2019-05-28 16:08:21');
INSERT INTO `access_log` VALUES (12655, '65.52.15590309078618407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-28 16:08:28', 93, 0, '', '2019-05-28 16:08:28');
INSERT INTO `access_log` VALUES (12656, '65.45.15590309081378419', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-28 16:08:28', 10, 0, '', '2019-05-28 16:08:28');
INSERT INTO `access_log` VALUES (12657, '65.49.15590309081408409', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-28 16:08:28', 12, 0, '', '2019-05-28 16:08:28');
INSERT INTO `access_log` VALUES (12658, '65.53.15590309081478399', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-28 16:08:28', 14, 0, '', '2019-05-28 16:08:28');
INSERT INTO `access_log` VALUES (12659, '64.82.15590309145908387', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-28 16:08:35', 19, 0, '', '2019-05-28 16:08:35');
INSERT INTO `access_log` VALUES (12660, '64.79.15590309145878375', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-28 16:08:35', 23, 0, '', '2019-05-28 16:08:35');
INSERT INTO `access_log` VALUES (12661, '64.76.15590309169788383', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-28 16:08:37', 11, 0, '', '2019-05-28 16:08:37');
INSERT INTO `access_log` VALUES (12662, '64.85.15590309169778383', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-28 16:08:37', 15, 0, '', '2019-05-28 16:08:37');
INSERT INTO `access_log` VALUES (12663, '90ab68e2-0896-475d-aa1f-0587437c15b1', 27, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:12:46', 74, 1002002009, NULL, '2019-05-28 16:12:46');
INSERT INTO `access_log` VALUES (12664, '143bf4bd-fdf9-4816-9d64-d9074a5eae63', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:13:07', 67, 0, '', '2019-05-28 16:13:07');
INSERT INTO `access_log` VALUES (12665, 'c55725b5-3c95-4f50-9b9a-14a23d454134', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:13:15', 74, 0, '', '2019-05-28 16:13:15');
INSERT INTO `access_log` VALUES (12666, '200c8cfd-14d4-43ef-99a1-36616d67c473', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:13:22', 49, 0, '', '2019-05-28 16:13:22');
INSERT INTO `access_log` VALUES (12667, 'efe650e6-d2c4-4436-a4d9-474ae6d46c86', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:13:41', 61, 0, '', '2019-05-28 16:13:41');
INSERT INTO `access_log` VALUES (12668, 'b8e48df1-8583-433e-aa66-f7992a3baa7d', 27, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:13:55', 37, 1002002009, NULL, '2019-05-28 16:13:55');
INSERT INTO `access_log` VALUES (12669, '2782f8be-af2f-4d3b-b531-813cdc34a64f', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:13:07', 45, 0, '', '2019-05-28 16:13:07');
INSERT INTO `access_log` VALUES (12670, 'e4dbb28c-c190-45e2-8390-3b2de52f7d50', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:13:07', 24, 0, '', '2019-05-28 16:13:07');
INSERT INTO `access_log` VALUES (12671, '24e30899-d9f1-401d-9d3d-4797d781ceb4', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:13:10', 48, 0, '', '2019-05-28 16:13:10');
INSERT INTO `access_log` VALUES (12672, '063ca828-a2b8-4605-93b3-73a4f0a0ed93', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:13:10', 75, 0, '', '2019-05-28 16:13:10');
INSERT INTO `access_log` VALUES (12673, 'c376b6c8-b897-446d-abe0-b358b48e946a', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:13:17', 26, 0, '', '2019-05-28 16:13:17');
INSERT INTO `access_log` VALUES (12674, '466bafef-e55c-419b-97d7-f92273c6961c', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:13:17', 54, 0, '', '2019-05-28 16:13:17');
INSERT INTO `access_log` VALUES (12675, 'a33d2f09-566c-4fe1-85d2-cd28be71bec4', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:14:36', 4, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机验证码长度为 4-6 位\n手机验证码必须都是数字\n手机号必须都是数字\n手机号不能为空\n账号长度为 11 位', '2019-05-28 16:14:36');
INSERT INTO `access_log` VALUES (12676, '2663de99-d74a-42ff-aafd-04c3563e963e', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13080612932&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:14:48', 321, 1001003000, '验证码不存在', '2019-05-28 16:14:49');
INSERT INTO `access_log` VALUES (12677, '68615257-742d-4901-9c53-987598d821a6', 27, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:16:53', 304, 1002002009, NULL, '2019-05-28 16:16:53');
INSERT INTO `access_log` VALUES (12678, 'e88022a9-f556-45fe-8b12-5ba56e41dfda', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13080612932&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:15:46', 166, 1001003000, '验证码不存在', '2019-05-28 16:15:46');
INSERT INTO `access_log` VALUES (12679, '8085b35d-6fe1-4f3e-866a-a44086f828db', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:18:17', 419, 0, '', '2019-05-28 16:18:17');
INSERT INTO `access_log` VALUES (12680, '4498396c-ebaf-4c98-9601-9eafce09f78e', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13080612932', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:17:57', 199, 0, '', '2019-05-28 16:17:57');
INSERT INTO `access_log` VALUES (12681, '24e052f7-eb37-465b-a4fe-9af9ebc7400a', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13080612932&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:18:00', 699, 0, '', '2019-05-28 16:18:00');
INSERT INTO `access_log` VALUES (12682, '2e33fffc-7cce-4813-972b-16a619bc0a47', 87, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:18:02', 197, 0, '', '2019-05-28 16:18:02');
INSERT INTO `access_log` VALUES (12683, '279202e0-6a35-4b35-91b8-cf8eb574b772', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:19:16', 7926, 0, '', '2019-05-28 16:19:24');
INSERT INTO `access_log` VALUES (12684, '8a37e94d-0f0a-4988-b00d-41ed77327ae4', 87, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:18:21', 73, 0, '', '2019-05-28 16:18:21');
INSERT INTO `access_log` VALUES (12685, '30908d01-7da7-43d3-aa4c-7f77e3ca38d1', 87, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:18:22', 71, 0, '', '2019-05-28 16:18:22');
INSERT INTO `access_log` VALUES (12686, '7e568df9-a915-4327-86f6-56ea046912ed', 87, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:18:44', 63, 0, '', '2019-05-28 16:18:44');
INSERT INTO `access_log` VALUES (12687, '7cba20a5-c355-4fdd-a4d3-61c67a8bf2c0', 87, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:18:46', 49, 0, '', '2019-05-28 16:18:46');
INSERT INTO `access_log` VALUES (12688, 'fee8ee95-2bed-40d9-815d-b5d84496adf5', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageSize=10&cid=10&name=小王&pageNo=1&status=可选值：1-在售中；2-已售罄；3-仓库中；', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:20:15', 245, 2001001000, '服务端发生异常', '2019-05-28 16:20:16');
INSERT INTO `access_log` VALUES (12689, '64.83.15590315419278387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 16:19:02', 3, 0, '', '2019-05-28 16:19:02');
INSERT INTO `access_log` VALUES (12690, '64.77.15590315420158393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 16:19:02', 2, 0, '', '2019-05-28 16:19:02');
INSERT INTO `access_log` VALUES (12691, '93a67cba-d68b-475d-add4-ad443441042a', 87, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:19:03', 49, 0, '', '2019-05-28 16:19:03');
INSERT INTO `access_log` VALUES (12692, '64.78.15590315456238393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 16:19:06', 3, 0, '', '2019-05-28 16:19:06');
INSERT INTO `access_log` VALUES (12693, '64.79.15590315463978385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 16:19:06', 2, 0, '', '2019-05-28 16:19:06');
INSERT INTO `access_log` VALUES (12694, 'b753cadf-0633-445e-94f0-fb5d6031d55d', 87, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:19:05', 48, 0, '', '2019-05-28 16:19:05');
INSERT INTO `access_log` VALUES (12695, '98863b24-fed1-4376-8c93-12e17007dcc8', 87, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:19:05', 118, 0, '', '2019-05-28 16:19:05');
INSERT INTO `access_log` VALUES (12696, '0cfa99fa-8af2-4b77-9f58-be8dc12c6b6e', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=小王', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:20:29', 78, 0, '', '2019-05-28 16:20:29');
INSERT INTO `access_log` VALUES (12697, '96727bda-fc6f-486e-8636-773c8263050e', 87, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:19:12', 50, 0, '', '2019-05-28 16:19:12');
INSERT INTO `access_log` VALUES (12698, 'a76e6343-9662-4cce-8458-9cbae869b8f0', 87, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:19:12', 97, 0, '', '2019-05-28 16:19:12');
INSERT INTO `access_log` VALUES (12699, 'f5ab772c-8ff2-488e-8d8e-fc3502ce79f4', 87, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:19:13', 47, 0, '', '2019-05-28 16:19:13');
INSERT INTO `access_log` VALUES (12700, '404b4370-da4d-424e-b490-962f464aec7a', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageSize=10&cid=10&name=小王&pageNo=1&status=可选值：1-在售中；2-已售罄；3-仓库中；', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:20:37', 120, 2001001000, '服务端发生异常', '2019-05-28 16:20:37');
INSERT INTO `access_log` VALUES (12701, '19db42b8-0670-4d24-9771-9c7ddc70bcd6', 27, 2, 'product-application', '/product-api/admins/spu/page', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:20:55', 87, 2001001001, '参数缺失:Required Integer parameter \'status\' is not present', '2019-05-28 16:20:55');
INSERT INTO `access_log` VALUES (12702, '74d34a02-4d21-422a-bac2-da0900eb3d44', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:21:05', 7751, 0, '', '2019-05-28 16:21:13');
INSERT INTO `access_log` VALUES (12703, '0c70b950-9c1c-4989-b65f-9638320f9f68', 27, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:21:30', 29, 1002002009, NULL, '2019-05-28 16:21:30');
INSERT INTO `access_log` VALUES (12704, 'badffe62-2e65-401c-92c3-3140959c28c3', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:22:41', 19, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 16:22:41');
INSERT INTO `access_log` VALUES (12705, '47f09309-4609-498e-af05-8962ab644234', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:22:47', 103, 0, '', '2019-05-28 16:22:47');
INSERT INTO `access_log` VALUES (12706, 'be5f5a9f-7c92-4e58-b081-0ff86929a47a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:22:47', 41, 0, '', '2019-05-28 16:22:47');
INSERT INTO `access_log` VALUES (12707, 'f8b1270d-33ef-4942-9f51-66acbbad6401', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:22:47', 53, 0, '', '2019-05-28 16:22:47');
INSERT INTO `access_log` VALUES (12708, '36d07fa3-2606-4a36-9abd-133848c74ff9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:22:47', 55, 0, '', '2019-05-28 16:22:47');
INSERT INTO `access_log` VALUES (12709, '40a5cead-a9fd-4dad-ba6c-45c03abbcebc', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:22:56', 5814, 0, '', '2019-05-28 16:23:02');
INSERT INTO `access_log` VALUES (12710, 'ada89310-a07c-44cf-8a1a-e076a5778a5c', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:22:56', 5859, 0, '', '2019-05-28 16:23:02');
INSERT INTO `access_log` VALUES (12711, 'f8d4b3ae-e8cd-452e-9c78-3c24e18cbcbf', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:23:06', 64, 0, '', '2019-05-28 16:23:06');
INSERT INTO `access_log` VALUES (12712, '01c93201-c76a-4449-a700-79657fc44793', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:23:33', 15605, 2001001000, '服务端发生异常', '2019-05-28 16:23:49');
INSERT INTO `access_log` VALUES (12713, '9b4a42fd-5d3f-4eb6-b391-42469eb307e2', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:24:21', 14908, 2001001000, '服务端发生异常', '2019-05-28 16:24:36');
INSERT INTO `access_log` VALUES (12714, '22c56042-e7df-453d-b8ef-9d387e200aa9', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:26:43', 6821, 2001001000, '服务端发生异常', '2019-05-28 16:26:50');
INSERT INTO `access_log` VALUES (12715, '59.72.15590320332219097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.220', '2019-05-28 16:27:13', 13, 2001001000, '服务端发生异常', '2019-05-28 16:27:13');
INSERT INTO `access_log` VALUES (12716, '59.74.15590320332219103', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.220', '2019-05-28 16:27:13', 20, 0, '', '2019-05-28 16:27:13');
INSERT INTO `access_log` VALUES (12717, '64.76.15590320365678399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.220', '2019-05-28 16:27:17', 3, 0, '', '2019-05-28 16:27:17');
INSERT INTO `access_log` VALUES (12718, '64.85.15590320366958399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.220', '2019-05-28 16:27:17', 2, 0, '', '2019-05-28 16:27:17');
INSERT INTO `access_log` VALUES (12719, '64.80.15590320378888391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.220', '2019-05-28 16:27:18', 2, 0, '', '2019-05-28 16:27:18');
INSERT INTO `access_log` VALUES (12720, '64.83.15590320384108395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.91.199.220', '2019-05-28 16:27:18', 2, 0, '', '2019-05-28 16:27:18');
INSERT INTO `access_log` VALUES (12721, '78e0bf86-3b83-4b7d-a380-a1ab6a98cb2e', 87, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:27:20', 95, 0, '', '2019-05-28 16:27:20');
INSERT INTO `access_log` VALUES (12722, '64.84.15590320441078401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:27:24', 2, 0, '', '2019-05-28 16:27:24');
INSERT INTO `access_log` VALUES (12723, '64.78.15590320445878401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:27:25', 2, 0, '', '2019-05-28 16:27:25');
INSERT INTO `access_log` VALUES (12724, '3e9e6eea-50f8-4e59-8979-5d3dbfe53a8e', 87, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:27:28', 282, 0, '', '2019-05-28 16:27:28');
INSERT INTO `access_log` VALUES (12725, '52ba697a-f3a0-41f8-a0ed-4788005c6ad0', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:08', 43929, 2001001000, '服务端发生异常', '2019-05-28 16:28:52');
INSERT INTO `access_log` VALUES (12726, '66.49.15590320637188093', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13088776654&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:27:44', 104, 1001003000, '验证码不存在', '2019-05-28 16:27:44');
INSERT INTO `access_log` VALUES (12727, '66.56.15590320676138089', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13088776654&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:27:48', 9, 1001003000, '验证码不存在', '2019-05-28 16:27:48');
INSERT INTO `access_log` VALUES (12728, 'daa06e4d-de9b-4636-9317-ddf73b7f2825', 87, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:27:48', 50, 0, '', '2019-05-28 16:27:48');
INSERT INTO `access_log` VALUES (12729, '64.81.15590320730158397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:27:53', 139, 0, '', '2019-05-28 16:27:53');
INSERT INTO `access_log` VALUES (12730, '64.76.15590320733108401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:27:53', 2, 0, '', '2019-05-28 16:27:53');
INSERT INTO `access_log` VALUES (12731, '4f447af1-ee8f-40ac-8562-9e26ec7b2638', 87, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:27:52', 134, 0, '', '2019-05-28 16:27:52');
INSERT INTO `access_log` VALUES (12732, 'cb9ca55a-7613-4329-9a90-1cc1979e8118', 87, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:27:56', 53, 0, '', '2019-05-28 16:27:56');
INSERT INTO `access_log` VALUES (12733, '59.77.15590320820719101', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:02', 4, 0, '', '2019-05-28 16:28:02');
INSERT INTO `access_log` VALUES (12734, '59.76.15590320820729097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:02', 11, 2001001000, '服务端发生异常', '2019-05-28 16:28:02');
INSERT INTO `access_log` VALUES (12735, '64.80.15590320863008393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:06', 2, 0, '', '2019-05-28 16:28:06');
INSERT INTO `access_log` VALUES (12736, '64.83.15590320864368397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:06', 2, 0, '', '2019-05-28 16:28:06');
INSERT INTO `access_log` VALUES (12737, '64.77.15590320878468403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:08', 2, 0, '', '2019-05-28 16:28:08');
INSERT INTO `access_log` VALUES (12738, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:08', 27, 0, '', '2019-05-28 16:28:08');
INSERT INTO `access_log` VALUES (12739, '64.84.15590320911908403', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:11', 420, 0, '', '2019-05-28 16:28:12');
INSERT INTO `access_log` VALUES (12740, 'bc036bc0-8e82-4d7d-93cb-44f70e92b1cf', 87, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:11', 91, 0, '', '2019-05-28 16:28:11');
INSERT INTO `access_log` VALUES (12741, 'fe83b07c-9c19-469a-ac00-023ef09c7893', 87, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:11', 96, 0, '', '2019-05-28 16:28:11');
INSERT INTO `access_log` VALUES (12742, '64.79.15590321095108395', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:30', 8, 0, '', '2019-05-28 16:28:30');
INSERT INTO `access_log` VALUES (12743, '64.82.15590321102808407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:30', 3, 0, '', '2019-05-28 16:28:30');
INSERT INTO `access_log` VALUES (12744, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:30', 8, 0, '', '2019-05-28 16:28:30');
INSERT INTO `access_log` VALUES (12745, '64.81.15590321107378399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:31', 3, 0, '', '2019-05-28 16:28:31');
INSERT INTO `access_log` VALUES (12746, '64.76.15590321108558403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:31', 2, 0, '', '2019-05-28 16:28:31');
INSERT INTO `access_log` VALUES (12747, '59.74.15590321151159105', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:35', 3, 0, '', '2019-05-28 16:28:35');
INSERT INTO `access_log` VALUES (12748, '59.72.15590321151159099', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:35', 13, 2001001000, '服务端发生异常', '2019-05-28 16:28:35');
INSERT INTO `access_log` VALUES (12749, '64.80.15590321158748395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:36', 3, 0, '', '2019-05-28 16:28:36');
INSERT INTO `access_log` VALUES (12750, '64.83.15590321159938399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:36', 3, 0, '', '2019-05-28 16:28:36');
INSERT INTO `access_log` VALUES (12751, '59.78.15590321160619107', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:36', 3, 0, '', '2019-05-28 16:28:36');
INSERT INTO `access_log` VALUES (12752, '59.79.15590321160989101', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '222.91.199.220', '2019-05-28 16:28:36', 16, 2001001000, '服务端发生异常', '2019-05-28 16:28:36');
INSERT INTO `access_log` VALUES (12753, 'd30ba992-2fc7-4ffb-b646-e0e510504fb9', 87, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:39', 51, 0, '', '2019-05-28 16:28:39');
INSERT INTO `access_log` VALUES (12754, '29f65a5e-91e1-432b-975a-7e1d8adce20a', 87, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:39', 77, 0, '', '2019-05-28 16:28:39');
INSERT INTO `access_log` VALUES (12755, 'e1a46eca-baf5-4543-ace9-0f15f2a36073', 87, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:41', 74, 0, '', '2019-05-28 16:28:41');
INSERT INTO `access_log` VALUES (12756, '38aca7ab-80af-4522-8ba3-4480359d82af', 87, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:41', 50, 0, '', '2019-05-28 16:28:41');
INSERT INTO `access_log` VALUES (12757, '4b22c9a5-ee5c-4d6a-8be4-dd5c6f5ab01e', 87, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:45', 164, 0, '', '2019-05-28 16:28:45');
INSERT INTO `access_log` VALUES (12758, 'a4c113c0-6fdb-4f95-8efb-3289508c1ba2', 87, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:45', 187, 0, '', '2019-05-28 16:28:45');
INSERT INTO `access_log` VALUES (12759, '4eb6a01b-d6d2-4e4b-b289-2eafc6864164', 87, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:46', 104, 0, '', '2019-05-28 16:28:47');
INSERT INTO `access_log` VALUES (12760, '524a94da-a960-4cb2-b0bd-6ba078e1e7b3', 87, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:49', 46, 0, '', '2019-05-28 16:28:49');
INSERT INTO `access_log` VALUES (12761, '5673bf54-29b5-4f15-93b8-1ba81d1211cd', 87, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:49', 73, 0, '', '2019-05-28 16:28:49');
INSERT INTO `access_log` VALUES (12762, 'cc0761c8-22be-4cec-9b03-fefee031a81f', 87, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:51', 48, 0, '', '2019-05-28 16:28:52');
INSERT INTO `access_log` VALUES (12763, '88862cde-cc2c-4d1a-b855-559148e2dace', 87, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:52', 49, 0, '', '2019-05-28 16:28:52');
INSERT INTO `access_log` VALUES (12764, '77aeb330-588c-4eb4-b5cd-9628deb38243', 87, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:53', 46, 0, '', '2019-05-28 16:28:53');
INSERT INTO `access_log` VALUES (12765, 'd3950818-99dc-4b1c-8e77-1f5334df5f05', 87, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:53', 46, 0, '', '2019-05-28 16:28:53');
INSERT INTO `access_log` VALUES (12766, '204c434b-0c15-4bcb-805e-b06f6fb03daf', 87, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:54', 48, 0, '', '2019-05-28 16:28:54');
INSERT INTO `access_log` VALUES (12767, 'f797f0a6-7c67-45ef-88e6-c2ad881035da', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:32:31', 12698, 0, '', '2019-05-28 16:32:44');
INSERT INTO `access_log` VALUES (12768, '65.50.15590323546498433', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:32:35', 1, 1002001015, '账号未登陆', '2019-05-28 16:32:35');
INSERT INTO `access_log` VALUES (12769, '65.48.15590323546508439', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:32:35', 1, 1002001015, '账号未登陆', '2019-05-28 16:32:35');
INSERT INTO `access_log` VALUES (12770, '65.52.15590323546508429', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:32:35', 1, 1002001015, '账号未登陆', '2019-05-28 16:32:35');
INSERT INTO `access_log` VALUES (12771, '65.49.15590323798628431', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:33:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 16:33:00');
INSERT INTO `access_log` VALUES (12772, '65.54.15590323850628417', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:33:05', 92, 0, '', '2019-05-28 16:33:05');
INSERT INTO `access_log` VALUES (12773, '65.46.15590323854798425', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:33:05', 116, 0, '', '2019-05-28 16:33:06');
INSERT INTO `access_log` VALUES (12774, '65.47.15590323854898441', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:33:05', 109, 0, '', '2019-05-28 16:33:06');
INSERT INTO `access_log` VALUES (12775, '65.51.15590323854828431', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:33:05', 116, 0, '', '2019-05-28 16:33:06');
INSERT INTO `access_log` VALUES (12776, '62.80.15590323878579045', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:33:08', 24, 0, '', '2019-05-28 16:33:08');
INSERT INTO `access_log` VALUES (12777, '62.88.15590323976599049', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:33:18', 20, 0, '', '2019-05-28 16:33:18');
INSERT INTO `access_log` VALUES (12778, '64.77.15590324018138409', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:33:22', 10, 0, '', '2019-05-28 16:33:22');
INSERT INTO `access_log` VALUES (12779, '64.83.15590324018108403', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:33:22', 14, 0, '', '2019-05-28 16:33:22');
INSERT INTO `access_log` VALUES (12780, '59.76.15590324503839103', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:34:10', 406, 0, '', '2019-05-28 16:34:11');
INSERT INTO `access_log` VALUES (12781, '65.49.15590324532238433', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:34:13', 20, 0, '', '2019-05-28 16:34:13');
INSERT INTO `access_log` VALUES (12782, '65.54.15590324568588419', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:34:17', 19, 0, '', '2019-05-28 16:34:17');
INSERT INTO `access_log` VALUES (12783, '65.47.15590324576268443', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:34:18', 19, 0, '', '2019-05-28 16:34:18');
INSERT INTO `access_log` VALUES (12784, '65.46.15590324596358427', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:34:20', 11, 0, '', '2019-05-28 16:34:20');
INSERT INTO `access_log` VALUES (12785, '65.51.15590324602748433', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.38.97', '2019-05-28 16:34:20', 10, 0, '', '2019-05-28 16:34:20');
INSERT INTO `access_log` VALUES (12786, '65.54.15590325395658421', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:35:40', 0, 1002001015, '账号未登陆', '2019-05-28 16:35:40');
INSERT INTO `access_log` VALUES (12787, '65.47.15590325395678445', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:35:40', 0, 1002001015, '账号未登陆', '2019-05-28 16:35:40');
INSERT INTO `access_log` VALUES (12788, '65.46.15590325395718429', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:35:40', 0, 1002001015, '账号未登陆', '2019-05-28 16:35:40');
INSERT INTO `access_log` VALUES (12789, '65.51.15590325423898435', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:35:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 16:35:42');
INSERT INTO `access_log` VALUES (12790, '65.50.15590325496288439', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:35:50', 84, 0, '', '2019-05-28 16:35:50');
INSERT INTO `access_log` VALUES (12791, '65.48.15590325499148445', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:35:50', 10, 0, '', '2019-05-28 16:35:50');
INSERT INTO `access_log` VALUES (12792, '65.52.15590325499178435', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:35:50', 9, 0, '', '2019-05-28 16:35:50');
INSERT INTO `access_log` VALUES (12793, '65.45.15590325499288447', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:35:50', 9, 0, '', '2019-05-28 16:35:50');
INSERT INTO `access_log` VALUES (12794, '62.86.15590325602999037', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:36:00', 370, 0, '', '2019-05-28 16:36:01');
INSERT INTO `access_log` VALUES (12795, '64.78.15590325678688411', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:36:08', 13, 0, '', '2019-05-28 16:36:08');
INSERT INTO `access_log` VALUES (12796, '64.79.15590325678718403', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:36:08', 9, 0, '', '2019-05-28 16:36:08');
INSERT INTO `access_log` VALUES (12797, '66.55.15590325861438109', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:36:26', 13, 0, '', '2019-05-28 16:36:26');
INSERT INTO `access_log` VALUES (12798, '66.54.15590325889528097', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:36:29', 21, 0, '', '2019-05-28 16:36:29');
INSERT INTO `access_log` VALUES (12799, '66.53.15590325895808103', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=3&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:36:30', 15, 0, '', '2019-05-28 16:36:30');
INSERT INTO `access_log` VALUES (12800, '66.49.15590325899858101', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=4&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:36:30', 14, 0, '', '2019-05-28 16:36:30');
INSERT INTO `access_log` VALUES (12801, '59.76.15590325918409105', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:36:32', 13, 0, '', '2019-05-28 16:36:32');
INSERT INTO `access_log` VALUES (12802, '65.46.15590325970518431', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '115.199.199.20', '2019-05-28 16:36:37', 19, 0, '', '2019-05-28 16:36:37');
INSERT INTO `access_log` VALUES (12803, 'cdc037fc-1703-4738-a19a-da264ecb4c8c', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋1&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:38:27', 11392, 0, '', '2019-05-28 16:38:39');
INSERT INTO `access_log` VALUES (12804, 'e7bce0ec-f5e9-45a5-996e-5f8319ec9f54', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋1&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:39:43', 14750, 0, '', '2019-05-28 16:39:58');
INSERT INTO `access_log` VALUES (12805, '64.76.15590332052688419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 16:46:45', 4, 0, '', '2019-05-28 16:46:45');
INSERT INTO `access_log` VALUES (12806, '64.85.15590332054028419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 16:46:45', 2, 0, '', '2019-05-28 16:46:45');
INSERT INTO `access_log` VALUES (12807, '64.80.15590332075248411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 16:46:48', 2, 0, '', '2019-05-28 16:46:48');
INSERT INTO `access_log` VALUES (12808, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 16:46:48', 8, 0, '', '2019-05-28 16:46:48');
INSERT INTO `access_log` VALUES (12809, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 16:46:51', 8, 0, '', '2019-05-28 16:46:51');
INSERT INTO `access_log` VALUES (12810, '64.77.15590332117838421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 16:46:52', 2, 0, '', '2019-05-28 16:46:52');
INSERT INTO `access_log` VALUES (12811, '64.84.15590332121218421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-28 16:46:52', 2, 0, '', '2019-05-28 16:46:52');
INSERT INTO `access_log` VALUES (12812, 'fb3cf2c8-449f-42e4-bb88-a1589f6cfde4', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋1&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:49:27', 4506, 0, '', '2019-05-28 16:49:31');
INSERT INTO `access_log` VALUES (12813, 'f4ed4204-26fb-43b8-8282-4908a4633486', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋1&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:50:42', 2550, 0, '', '2019-05-28 16:50:44');
INSERT INTO `access_log` VALUES (12814, 'a07d10d4-3d13-4c16-864f-958b609a17bf', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋1&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:51:13', 15396, 2001001000, '服务端发生异常', '2019-05-28 16:51:28');
INSERT INTO `access_log` VALUES (12815, 'ab79a788-b8ce-4300-9582-8325b14df6a2', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋1&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:51:43', 8878, 1003004000, '品牌值已经存在', '2019-05-28 16:51:52');
INSERT INTO `access_log` VALUES (12816, '3b22b12d-4934-4ae2-aa97-25df3e07d313', 1, 2, 'product-application', '/product-api/admins/brand/get', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:52:53', 51, 0, '', '2019-05-28 16:52:53');
INSERT INTO `access_log` VALUES (12817, '63f1c56c-ea5f-42c3-9546-dfb8e2ff6452', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:53:07', 342, 2001001000, '服务端发生异常', '2019-05-28 16:53:07');
INSERT INTO `access_log` VALUES (12818, '8a4f0b1e-1e74-421a-a227-bc8489e26ade', 1, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:53:28', 168, 2001001000, '服务端发生异常', '2019-05-28 16:53:28');
INSERT INTO `access_log` VALUES (12819, '649be74c-6e4a-46e4-8e9d-35f5b5f8b4dd', 1, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:53:38', 325, 2001001000, '服务端发生异常', '2019-05-28 16:53:38');
INSERT INTO `access_log` VALUES (12820, '9c48ae49-121d-4011-81ed-366545e68ca3', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:54:45', 180, 2001001000, '服务端发生异常', '2019-05-28 16:54:45');
INSERT INTO `access_log` VALUES (12821, '59.72.15590337018669121', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.3.210', '2019-05-28 16:55:02', 4, 0, '', '2019-05-28 16:55:02');
INSERT INTO `access_log` VALUES (12822, '59.78.15590337018679129', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.3.210', '2019-05-28 16:55:02', 14, 2001001000, '服务端发生异常', '2019-05-28 16:55:02');
INSERT INTO `access_log` VALUES (12823, '6a9fc4d3-a365-4bba-86e5-94997ba03baf', 87, 1, 'search-application', '/search-api/users/product/page', 'keyword=77777777&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:55:01', 404, 0, '', '2019-05-28 16:55:02');
INSERT INTO `access_log` VALUES (12824, 'c95ca6eb-cabb-4982-b31b-c937027f2ccf', 87, 1, 'search-application', '/search-api/users/product/condition', 'keyword=77777777', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:55:02', 221, 2001001000, '服务端发生异常', '2019-05-28 16:55:02');
INSERT INTO `access_log` VALUES (12825, '64.81.15590337084448423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:55:08', 4, 0, '', '2019-05-28 16:55:08');
INSERT INTO `access_log` VALUES (12826, '64.76.15590337085228427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:55:09', 3, 0, '', '2019-05-28 16:55:09');
INSERT INTO `access_log` VALUES (12827, '64.85.15590337099098427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:55:10', 3, 0, '', '2019-05-28 16:55:10');
INSERT INTO `access_log` VALUES (12828, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:55:10', 12, 0, '', '2019-05-28 16:55:10');
INSERT INTO `access_log` VALUES (12829, '64.80.15590337112608419', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:55:11', 631, 0, '', '2019-05-28 16:55:12');
INSERT INTO `access_log` VALUES (12830, '66.55.15590337295768125', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17682306666', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:55:30', 77, 0, '', '2019-05-28 16:55:30');
INSERT INTO `access_log` VALUES (12831, '66.53.15590337362768119', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17682306666&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:55:36', 184, 0, '', '2019-05-28 16:55:36');
INSERT INTO `access_log` VALUES (12832, '66.56.15590337382818113', 88, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:55:38', 8, 0, '', '2019-05-28 16:55:38');
INSERT INTO `access_log` VALUES (12833, '64.78.15590337441028429', 88, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:55:44', 11, 0, '', '2019-05-28 16:55:44');
INSERT INTO `access_log` VALUES (12834, '66.57.15590337468328123', 88, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:55:47', 6, 0, '', '2019-05-28 16:55:47');
INSERT INTO `access_log` VALUES (12835, '64.81.15590337674728425', 88, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:56:07', 525, 0, '', '2019-05-28 16:56:08');
INSERT INTO `access_log` VALUES (12836, '65.47.15590337763528463', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.109.214.182', '2019-05-28 16:56:16', 0, 1002001015, '账号未登陆', '2019-05-28 16:56:16');
INSERT INTO `access_log` VALUES (12837, '65.46.15590337776028447', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.109.214.182', '2019-05-28 16:56:18', 0, 1002001015, '账号未登陆', '2019-05-28 16:56:18');
INSERT INTO `access_log` VALUES (12838, '65.54.15590337778758441', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.109.214.182', '2019-05-28 16:56:18', 0, 1002001015, '账号未登陆', '2019-05-28 16:56:18');
INSERT INTO `access_log` VALUES (12839, '65.51.15590337781108455', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.109.214.182', '2019-05-28 16:56:18', 0, 1002001015, '账号未登陆', '2019-05-28 16:56:18');
INSERT INTO `access_log` VALUES (12840, '65.50.15590337786068457', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.109.214.182', '2019-05-28 16:56:19', 1, 1002001015, '账号未登陆', '2019-05-28 16:56:19');
INSERT INTO `access_log` VALUES (12841, '65.48.15590337823328463', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王1&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.109.214.182', '2019-05-28 16:56:22', 0, 1002001015, '账号未登陆', '2019-05-28 16:56:22');
INSERT INTO `access_log` VALUES (12842, '65.45.15590337830038467', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王1&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.109.214.182', '2019-05-28 16:56:23', 1, 1002001015, '账号未登陆', '2019-05-28 16:56:23');
INSERT INTO `access_log` VALUES (12843, '64.80.15590337860018421', 88, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:56:26', 6, 0, '', '2019-05-28 16:56:26');
INSERT INTO `access_log` VALUES (12844, 'N/A', 88, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:56:26', 16, 0, '', '2019-05-28 16:56:26');
INSERT INTO `access_log` VALUES (12845, '64.77.15590337872478431', 88, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:56:27', 6, 0, '', '2019-05-28 16:56:27');
INSERT INTO `access_log` VALUES (12846, '64.84.15590337876198431', 88, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:56:28', 28, 0, '', '2019-05-28 16:56:28');
INSERT INTO `access_log` VALUES (12847, '59.72.15590337907509123', 88, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:56:31', 6, 0, '', '2019-05-28 16:56:31');
INSERT INTO `access_log` VALUES (12848, '59.78.15590337907499131', 88, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:56:31', 16, 2001001000, '服务端发生异常', '2019-05-28 16:56:31');
INSERT INTO `access_log` VALUES (12849, '59.77.15590337966359127', 88, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:56:37', 6, 0, '', '2019-05-28 16:56:37');
INSERT INTO `access_log` VALUES (12850, '59.80.15590337966349127', 88, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:56:37', 18, 2001001000, '服务端发生异常', '2019-05-28 16:56:37');
INSERT INTO `access_log` VALUES (12851, '66.54.15590337987818115', 88, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:56:39', 7, 0, '', '2019-05-28 16:56:39');
INSERT INTO `access_log` VALUES (12852, '66.53.15590338025208121', 88, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:56:43', 1074, 0, '', '2019-05-28 16:56:44');
INSERT INTO `access_log` VALUES (12853, '59.76.15590338055989123', 88, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:56:46', 6, 0, '', '2019-05-28 16:56:46');
INSERT INTO `access_log` VALUES (12854, '59.71.15590338055999129', 88, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.191.3.210', '2019-05-28 16:56:46', 17, 2001001000, '服务端发生异常', '2019-05-28 16:56:46');
INSERT INTO `access_log` VALUES (12855, 'ca9f52ea-e3a5-46d1-94ce-e1907a5a7da8', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:09:26', 952, 2001001000, '服务端发生异常', '2019-05-28 17:09:27');
INSERT INTO `access_log` VALUES (12856, '4dc77dc5-6de5-4da7-9b07-e9016477727d', 1, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:09:53', 210, 2001001000, '服务端发生异常', '2019-05-28 17:09:54');
INSERT INTO `access_log` VALUES (12857, '788b1386-4daf-4b62-a27e-30f52c30a179', 1, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:10:04', 155, 2001001000, '服务端发生异常', '2019-05-28 17:10:04');
INSERT INTO `access_log` VALUES (12858, '6067df34-3ec7-424f-8b00-6d9f5b792800', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:10:37', 126, 2001001000, '服务端发生异常', '2019-05-28 17:10:37');
INSERT INTO `access_log` VALUES (12859, '70b1f281-a724-46a9-a209-e7baad7fbfaf', 0, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:10:56', 28, 1002001012, '访问令牌已过期', '2019-05-28 17:10:56');
INSERT INTO `access_log` VALUES (12860, 'b8ea2e4d-80ca-4a17-929d-faf6df55e786', 0, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:11:14', 15, 1002001012, '访问令牌已过期', '2019-05-28 17:11:14');
INSERT INTO `access_log` VALUES (12861, '7fb2971d-40d1-43e2-b5d8-b9661e97e77c', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:11:20', 136, 0, '', '2019-05-28 17:11:20');
INSERT INTO `access_log` VALUES (12862, 'dc8223b1-6ca0-4072-aabc-765d9883d891', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:11:20', 34, 0, '', '2019-05-28 17:11:20');
INSERT INTO `access_log` VALUES (12863, '160873ab-2213-4fb7-985f-9f94a22580f8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:11:20', 40, 0, '', '2019-05-28 17:11:20');
INSERT INTO `access_log` VALUES (12864, '377ce15b-fb17-4ab4-8c9b-028a47c23078', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:11:20', 48, 0, '', '2019-05-28 17:11:20');
INSERT INTO `access_log` VALUES (12865, 'e5490b69-28a0-4f04-8cb5-bed598daeda1', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:11:26', 252, 0, '', '2019-05-28 17:11:26');
INSERT INTO `access_log` VALUES (12866, 'a6507fe6-6254-4ec6-91d7-4cdb8078eaeb', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:11:26', 254, 0, '', '2019-05-28 17:11:26');
INSERT INTO `access_log` VALUES (12867, 'f057ea9e-468a-402f-80cd-f3407b79327e', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:11:29', 986, 0, '', '2019-05-28 17:11:30');
INSERT INTO `access_log` VALUES (12868, 'baa586e1-4e5f-41d5-9790-2b3a6ba17061', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:11:47', 74064, 2001001000, '服务端发生异常', '2019-05-28 17:13:01');
INSERT INTO `access_log` VALUES (12869, '2f70c835-2d89-4b0e-9a60-ba2c7e6f400c', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:14:39', 11748, 2001001000, '服务端发生异常', '2019-05-28 17:14:50');
INSERT INTO `access_log` VALUES (12870, 'e6cd6036-112b-4fdb-a888-a620c6d4744e', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:15:24', 31857, 2001001000, '服务端发生异常', '2019-05-28 17:15:56');
INSERT INTO `access_log` VALUES (12871, '59.75.15590353123419149', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:21:52', 4, 0, '', '2019-05-28 17:21:52');
INSERT INTO `access_log` VALUES (12872, '59.74.15590353123419151', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:21:52', 15, 2001001000, '服务端发生异常', '2019-05-28 17:21:52');
INSERT INTO `access_log` VALUES (12873, '59.72.15590353166719145', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:21:57', 3, 0, '', '2019-05-28 17:21:57');
INSERT INTO `access_log` VALUES (12874, '59.78.15590353166719153', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:21:57', 14, 2001001000, '服务端发生异常', '2019-05-28 17:21:57');
INSERT INTO `access_log` VALUES (12875, '59.77.15590353311969149', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:22:11', 4, 0, '', '2019-05-28 17:22:11');
INSERT INTO `access_log` VALUES (12876, '59.80.15590353311979149', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:22:11', 13, 2001001000, '服务端发生异常', '2019-05-28 17:22:11');
INSERT INTO `access_log` VALUES (12877, '64.83.15590353905088447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:11', 3, 0, '', '2019-05-28 17:23:11');
INSERT INTO `access_log` VALUES (12878, '64.77.15590353906088453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:11', 2, 0, '', '2019-05-28 17:23:11');
INSERT INTO `access_log` VALUES (12879, '64.84.15590353918298453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:12', 2, 0, '', '2019-05-28 17:23:12');
INSERT INTO `access_log` VALUES (12880, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:12', 9, 0, '', '2019-05-28 17:23:12');
INSERT INTO `access_log` VALUES (12881, '64.78.15590353928908453', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:13', 9, 0, '', '2019-05-28 17:23:13');
INSERT INTO `access_log` VALUES (12882, '64.82.15590354044248457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:24', 3, 0, '', '2019-05-28 17:23:24');
INSERT INTO `access_log` VALUES (12883, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:24', 11, 0, '', '2019-05-28 17:23:24');
INSERT INTO `access_log` VALUES (12884, '64.81.15590354050188449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:25', 2, 0, '', '2019-05-28 17:23:25');
INSERT INTO `access_log` VALUES (12885, '64.76.15590354051468453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:25', 2, 0, '', '2019-05-28 17:23:25');
INSERT INTO `access_log` VALUES (12886, '59.78.15590354056889155', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:26', 6, 0, '', '2019-05-28 17:23:26');
INSERT INTO `access_log` VALUES (12887, '59.72.15590354056899147', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:26', 23, 2001001000, '服务端发生异常', '2019-05-28 17:23:26');
INSERT INTO `access_log` VALUES (12888, '64.80.15590354158248445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:36', 88, 0, '', '2019-05-28 17:23:36');
INSERT INTO `access_log` VALUES (12889, '64.83.15590354160268449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:36', 2, 0, '', '2019-05-28 17:23:36');
INSERT INTO `access_log` VALUES (12890, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:55', 6, 0, '', '2019-05-28 17:23:55');
INSERT INTO `access_log` VALUES (12891, '64.84.15590354353338455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:55', 113, 0, '', '2019-05-28 17:23:55');
INSERT INTO `access_log` VALUES (12892, '64.78.15590354363518455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:56', 2, 0, '', '2019-05-28 17:23:56');
INSERT INTO `access_log` VALUES (12893, '64.79.15590354364578447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:56', 2, 0, '', '2019-05-28 17:23:56');
INSERT INTO `access_log` VALUES (12894, '64.82.15590354373678459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:57', 2, 0, '', '2019-05-28 17:23:57');
INSERT INTO `access_log` VALUES (12895, '64.81.15590354380548451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:58', 3, 0, '', '2019-05-28 17:23:58');
INSERT INTO `access_log` VALUES (12896, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:23:58', 7, 0, '', '2019-05-28 17:23:58');
INSERT INTO `access_log` VALUES (12897, '64.76.15590354396368455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:00', 3, 0, '', '2019-05-28 17:24:00');
INSERT INTO `access_log` VALUES (12898, '64.85.15590354397428455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:00', 2, 0, '', '2019-05-28 17:24:00');
INSERT INTO `access_log` VALUES (12899, '64.80.15590354405038447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:01', 2, 0, '', '2019-05-28 17:24:01');
INSERT INTO `access_log` VALUES (12900, '64.83.15590354412078451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:01', 2, 0, '', '2019-05-28 17:24:01');
INSERT INTO `access_log` VALUES (12901, '64.77.15590354417678457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:02', 2, 0, '', '2019-05-28 17:24:02');
INSERT INTO `access_log` VALUES (12902, '64.84.15590354424878457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:02', 2, 0, '', '2019-05-28 17:24:02');
INSERT INTO `access_log` VALUES (12903, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:02', 7, 0, '', '2019-05-28 17:24:03');
INSERT INTO `access_log` VALUES (12904, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:03', 7, 0, '', '2019-05-28 17:24:03');
INSERT INTO `access_log` VALUES (12905, '64.79.15590354462518449', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:06', 8, 0, '', '2019-05-28 17:24:06');
INSERT INTO `access_log` VALUES (12906, '64.82.15590354486878461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:09', 2, 0, '', '2019-05-28 17:24:09');
INSERT INTO `access_log` VALUES (12907, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:09', 6, 0, '', '2019-05-28 17:24:09');
INSERT INTO `access_log` VALUES (12908, '64.81.15590354496228453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:10', 3, 0, '', '2019-05-28 17:24:10');
INSERT INTO `access_log` VALUES (12909, '64.76.15590354497578457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:10', 2, 0, '', '2019-05-28 17:24:10');
INSERT INTO `access_log` VALUES (12910, '64.85.15590354506548457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:11', 3, 0, '', '2019-05-28 17:24:11');
INSERT INTO `access_log` VALUES (12911, '64.80.15590354600148449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:20', 3, 0, '', '2019-05-28 17:24:20');
INSERT INTO `access_log` VALUES (12912, '64.83.15590354601668453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:20', 2, 0, '', '2019-05-28 17:24:20');
INSERT INTO `access_log` VALUES (12913, '59.71.15590354608279153', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:21', 4, 0, '', '2019-05-28 17:24:21');
INSERT INTO `access_log` VALUES (12914, '59.73.15590354608299155', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:21', 20, 2001001000, '服务端发生异常', '2019-05-28 17:24:21');
INSERT INTO `access_log` VALUES (12915, '64.84.15590354723988459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:32', 2, 0, '', '2019-05-28 17:24:32');
INSERT INTO `access_log` VALUES (12916, '64.78.15590354724908459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:32', 2, 0, '', '2019-05-28 17:24:32');
INSERT INTO `access_log` VALUES (12917, '64.82.15590354881588463', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:48', 2, 0, '', '2019-05-28 17:24:48');
INSERT INTO `access_log` VALUES (12918, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:48', 7, 0, '', '2019-05-28 17:24:48');
INSERT INTO `access_log` VALUES (12919, '64.81.15590354894398455', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:49', 8, 0, '', '2019-05-28 17:24:49');
INSERT INTO `access_log` VALUES (12920, '64.85.15590354930388459', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:53', 7, 0, '', '2019-05-28 17:24:53');
INSERT INTO `access_log` VALUES (12921, '64.80.15590354934618451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:53', 3, 0, '', '2019-05-28 17:24:53');
INSERT INTO `access_log` VALUES (12922, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:53', 8, 0, '', '2019-05-28 17:24:53');
INSERT INTO `access_log` VALUES (12923, '64.83.15590354946398455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:55', 3, 0, '', '2019-05-28 17:24:55');
INSERT INTO `access_log` VALUES (12924, '64.77.15590354947668461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:24:55', 3, 0, '', '2019-05-28 17:24:55');
INSERT INTO `access_log` VALUES (12925, '59.78.15590355000469157', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:25:00', 4, 0, '', '2019-05-28 17:25:00');
INSERT INTO `access_log` VALUES (12926, '59.72.15590355000469149', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.75.38.97', '2019-05-28 17:25:00', 15, 2001001000, '服务端发生异常', '2019-05-28 17:25:00');
INSERT INTO `access_log` VALUES (12927, '65.46.15590355936288473', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:26:34', 0, 1002001015, '账号未登陆', '2019-05-28 17:26:34');
INSERT INTO `access_log` VALUES (12928, '65.47.15590355936288489', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:26:34', 1, 1002001015, '账号未登陆', '2019-05-28 17:26:34');
INSERT INTO `access_log` VALUES (12929, '65.54.15590355936518467', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:26:34', 0, 1002001015, '账号未登陆', '2019-05-28 17:26:34');
INSERT INTO `access_log` VALUES (12930, 'fbd622fb-5e88-4b8e-82bc-ce25342b6fd5', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:27:36', 16628, 0, '', '2019-05-28 17:27:53');
INSERT INTO `access_log` VALUES (12931, '65.50.15590356036608483', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:26:44', 79, 0, '', '2019-05-28 17:26:44');
INSERT INTO `access_log` VALUES (12932, '65.53.15590356040148469', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:26:44', 11, 0, '', '2019-05-28 17:26:44');
INSERT INTO `access_log` VALUES (12933, '65.48.15590356040148489', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:26:44', 12, 0, '', '2019-05-28 17:26:44');
INSERT INTO `access_log` VALUES (12934, '65.45.15590356040148493', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:26:44', 12, 0, '', '2019-05-28 17:26:44');
INSERT INTO `access_log` VALUES (12935, '65.49.15590356163098481', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:26:56', 20, 0, '', '2019-05-28 17:26:56');
INSERT INTO `access_log` VALUES (12936, '65.46.15590356174008475', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:26:57', 10, 0, '', '2019-05-28 17:26:57');
INSERT INTO `access_log` VALUES (12937, '65.47.15590356183548491', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:26:58', 136, 0, '', '2019-05-28 17:26:58');
INSERT INTO `access_log` VALUES (12938, '65.54.15590356189138469', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:26:59', 13, 0, '', '2019-05-28 17:26:59');
INSERT INTO `access_log` VALUES (12939, '65.51.15590356195678483', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:00', 19, 0, '', '2019-05-28 17:27:00');
INSERT INTO `access_log` VALUES (12940, '65.50.15590356267068485', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:07', 9, 0, '', '2019-05-28 17:27:07');
INSERT INTO `access_log` VALUES (12941, '65.45.15590356267088495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:07', 11, 0, '', '2019-05-28 17:27:07');
INSERT INTO `access_log` VALUES (12942, '65.53.15590356267128471', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:07', 9, 0, '', '2019-05-28 17:27:07');
INSERT INTO `access_log` VALUES (12943, '65.48.15590356267838491', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:07', 30, 0, '', '2019-05-28 17:27:07');
INSERT INTO `access_log` VALUES (12944, '65.52.15590356281748483', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:08', 11, 0, '', '2019-05-28 17:27:08');
INSERT INTO `access_log` VALUES (12945, '65.49.15590356281788483', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:08', 9, 0, '', '2019-05-28 17:27:08');
INSERT INTO `access_log` VALUES (12946, '65.46.15590356281818477', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:08', 9, 0, '', '2019-05-28 17:27:08');
INSERT INTO `access_log` VALUES (12947, '65.47.15590356282348493', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:08', 18, 0, '', '2019-05-28 17:27:08');
INSERT INTO `access_log` VALUES (12948, '65.53.15590356474078473', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:27', 10, 0, '', '2019-05-28 17:27:27');
INSERT INTO `access_log` VALUES (12949, '65.45.15590356481918497', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:28', 10, 0, '', '2019-05-28 17:27:28');
INSERT INTO `access_log` VALUES (12950, '65.50.15590356548368487', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:35', 19, 0, '', '2019-05-28 17:27:35');
INSERT INTO `access_log` VALUES (12951, '65.49.15590356602818485', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:40', 13, 0, '', '2019-05-28 17:27:40');
INSERT INTO `access_log` VALUES (12952, '65.52.15590356625128485', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:43', 14, 0, '', '2019-05-28 17:27:43');
INSERT INTO `access_log` VALUES (12953, '65.47.15590356641108495', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:44', 11, 0, '', '2019-05-28 17:27:44');
INSERT INTO `access_log` VALUES (12954, '65.46.15590356658318479', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:46', 19, 0, '', '2019-05-28 17:27:46');
INSERT INTO `access_log` VALUES (12955, '65.54.15590356674178473', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=14', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:47', 11, 0, '', '2019-05-28 17:27:47');
INSERT INTO `access_log` VALUES (12956, '65.51.15590356692168487', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:49', 9, 0, '', '2019-05-28 17:27:49');
INSERT INTO `access_log` VALUES (12957, '65.53.15590356707958475', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:27:51', 15, 0, '', '2019-05-28 17:27:51');
INSERT INTO `access_log` VALUES (12958, '65.48.15590357020318495', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:28:22', 10, 0, '', '2019-05-28 17:28:22');
INSERT INTO `access_log` VALUES (12959, '65.52.15590357144738487', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:28:34', 12, 0, '', '2019-05-28 17:28:34');
INSERT INTO `access_log` VALUES (12960, '65.47.15590357144838497', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:28:34', 10, 0, '', '2019-05-28 17:28:34');
INSERT INTO `access_log` VALUES (12961, '65.46.15590357144878481', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:28:34', 9, 0, '', '2019-05-28 17:28:34');
INSERT INTO `access_log` VALUES (12962, '65.54.15590357146088475', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:28:35', 10, 0, '', '2019-05-28 17:28:35');
INSERT INTO `access_log` VALUES (12963, '65.45.15590357421728501', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:29:02', 9, 0, '', '2019-05-28 17:29:02');
INSERT INTO `access_log` VALUES (12964, '65.50.15590357421748491', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:29:02', 8, 0, '', '2019-05-28 17:29:02');
INSERT INTO `access_log` VALUES (12965, '65.48.15590357421798497', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:29:02', 9, 0, '', '2019-05-28 17:29:02');
INSERT INTO `access_log` VALUES (12966, '65.49.15590357423198489', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:29:02', 9, 0, '', '2019-05-28 17:29:02');
INSERT INTO `access_log` VALUES (12967, '59.72.15590357620789153', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '114.86.224.172', '2019-05-28 17:29:22', 13, 2001001000, '服务端发生异常', '2019-05-28 17:29:22');
INSERT INTO `access_log` VALUES (12968, '59.78.15590357620769161', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '114.86.224.172', '2019-05-28 17:29:22', 203, 0, '', '2019-05-28 17:29:22');
INSERT INTO `access_log` VALUES (12969, '64.83.15590357654578459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '114.86.224.172', '2019-05-28 17:29:25', 3, 0, '', '2019-05-28 17:29:25');
INSERT INTO `access_log` VALUES (12970, '64.77.15590357656198465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '114.86.224.172', '2019-05-28 17:29:26', 3, 0, '', '2019-05-28 17:29:26');
INSERT INTO `access_log` VALUES (12971, '64.84.15590357664948465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '114.86.224.172', '2019-05-28 17:29:26', 2, 0, '', '2019-05-28 17:29:26');
INSERT INTO `access_log` VALUES (12972, '64.78.15590357669738465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '114.86.224.172', '2019-05-28 17:29:27', 2, 0, '', '2019-05-28 17:29:27');
INSERT INTO `access_log` VALUES (12973, '64.79.15590357673658457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '114.86.224.172', '2019-05-28 17:29:27', 3, 0, '', '2019-05-28 17:29:27');
INSERT INTO `access_log` VALUES (12974, '59.79.15590357738199155', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '114.86.224.172', '2019-05-28 17:29:34', 3, 0, '', '2019-05-28 17:29:34');
INSERT INTO `access_log` VALUES (12975, '59.80.15590357738209157', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '114.86.224.172', '2019-05-28 17:29:34', 19, 2001001000, '服务端发生异常', '2019-05-28 17:29:34');
INSERT INTO `access_log` VALUES (12976, '59.75.15590358221859159', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.239.120', '2019-05-28 17:30:22', 4, 0, '', '2019-05-28 17:30:22');
INSERT INTO `access_log` VALUES (12977, '64.80.15590358251318457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.91.60.110', '2019-05-28 17:30:25', 2, 0, '', '2019-05-28 17:30:25');
INSERT INTO `access_log` VALUES (12978, '64.83.15590358261068461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.129.6.251', '2019-05-28 17:30:26', 3, 0, '', '2019-05-28 17:30:26');
INSERT INTO `access_log` VALUES (12979, '64.77.15590358262048467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.129.6.227', '2019-05-28 17:30:26', 3, 0, '', '2019-05-28 17:30:26');
INSERT INTO `access_log` VALUES (12980, '64.84.15590358262298467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.89.19.197', '2019-05-28 17:30:26', 2, 0, '', '2019-05-28 17:30:26');
INSERT INTO `access_log` VALUES (12981, '24a04648-3a12-4443-9dee-c14dff631c6d', 0, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:32:39', 59, 1002001012, '访问令牌已过期', '2019-05-28 17:32:39');
INSERT INTO `access_log` VALUES (12982, 'a0270ce1-26a3-422b-8fcd-272de3578d36', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:32:45', 174, 0, '', '2019-05-28 17:32:45');
INSERT INTO `access_log` VALUES (12983, '869d690a-a108-4bee-9463-b1bebb5b0f82', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:32:51', 83, 0, '', '2019-05-28 17:32:51');
INSERT INTO `access_log` VALUES (12984, '65.52.15590359031298491', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:31:43', 282, 0, '', '2019-05-28 17:31:43');
INSERT INTO `access_log` VALUES (12985, 'e63c1903-9629-4035-be0e-70524ebff7c4', 1, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:33:04', 55, 0, '', '2019-05-28 17:33:04');
INSERT INTO `access_log` VALUES (12986, '5175c4d9-5b16-4c5a-9b7d-044c4471213c', 1, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:34:19', 22162, 0, '', '2019-05-28 17:34:41');
INSERT INTO `access_log` VALUES (12987, 'c4041a57-74d1-4c44-8b72-698997cd9d10', 1, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:42:39', 733, 2001001001, '参数缺失:Required Integer parameter \'id\' is not present', '2019-05-28 17:42:40');
INSERT INTO `access_log` VALUES (12988, 'fd5a4b27-b2ba-45b7-90b0-1d3d8a080d76', 1, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&id=1&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:43:09', 5804, 0, '', '2019-05-28 17:43:15');
INSERT INTO `access_log` VALUES (12989, 'ab30f3e4-c1b6-498f-bdfa-69615c977b37', 1, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&id=1&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:43:25', 31225, 0, '', '2019-05-28 17:43:56');
INSERT INTO `access_log` VALUES (12990, '65.52.15590366452418501', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.38.97', '2019-05-28 17:44:05', 10, 0, '', '2019-05-28 17:44:05');
INSERT INTO `access_log` VALUES (12991, 'bb01ac49-0032-4ea6-bbad-4443a438aca9', 1, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&id=1&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:46:59', 3102, 0, '', '2019-05-28 17:47:02');
INSERT INTO `access_log` VALUES (12992, '668a1b44-7298-482f-8213-65d7af3e83b6', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=77777777&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 17:49:23', 575, 0, '', '2019-05-28 17:49:24');
INSERT INTO `access_log` VALUES (12993, '4f9eb3d3-abca-4a55-acb4-716b3dd3b9da', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=77777777', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 17:49:24', 252, 2001001000, '服务端发生异常', '2019-05-28 17:49:24');
INSERT INTO `access_log` VALUES (12994, '65.49.15590370744958509', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; V1824BA Build/PKQ1.181216.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6988 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '124.64.16.122', '2019-05-28 17:51:14', 0, 1002001015, '账号未登陆', '2019-05-28 17:51:14');
INSERT INTO `access_log` VALUES (12995, '65.47.15590370744958519', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; V1824BA Build/PKQ1.181216.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6988 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '124.64.16.122', '2019-05-28 17:51:14', 0, 1002001015, '账号未登陆', '2019-05-28 17:51:14');
INSERT INTO `access_log` VALUES (12996, '65.52.15590370745548507', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; V1824BA Build/PKQ1.181216.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6988 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '124.64.16.122', '2019-05-28 17:51:15', 1, 1002001015, '账号未登陆', '2019-05-28 17:51:15');
INSERT INTO `access_log` VALUES (12997, '65.46.15590370769348501', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; V1824BA Build/PKQ1.181216.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6988 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '124.64.16.122', '2019-05-28 17:51:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 17:51:17');
INSERT INTO `access_log` VALUES (12998, '65.51.15590370858348511', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; V1824BA Build/PKQ1.181216.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6988 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '124.64.16.122', '2019-05-28 17:51:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 17:51:26');
INSERT INTO `access_log` VALUES (12999, '40b9519d-0577-425c-a80a-043760b865ba', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=77777777&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:03:09', 271, 2001001000, '服务端发生异常', '2019-05-28 18:03:09');
INSERT INTO `access_log` VALUES (13000, 'eb2f15c4-9797-4a1c-b0f6-16eee18106d5', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=77777777&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:04:01', 303, 0, '', '2019-05-28 18:04:02');
INSERT INTO `access_log` VALUES (13001, '18f71d8d-7ef0-4713-9658-77ab6f635451', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=77777777', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:04:02', 239, 2001001000, '服务端发生异常', '2019-05-28 18:04:02');
INSERT INTO `access_log` VALUES (13002, 'a0f7dfb2-2305-4313-8b27-bbbfc7f1cd46', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:06:15', 317, 0, '', '2019-05-28 18:06:16');
INSERT INTO `access_log` VALUES (13003, '0be60b89-64b5-4163-9979-a0c6aad5568d', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:06:16', 50, 0, '', '2019-05-28 18:06:16');
INSERT INTO `access_log` VALUES (13004, '447f1146-55bc-4e47-8099-a3b1dac225f7', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:06:21', 49, 0, '', '2019-05-28 18:06:21');
INSERT INTO `access_log` VALUES (13005, 'd6e3d51b-6d76-4d7c-8ad9-b7083f66740f', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:06:22', 48, 0, '', '2019-05-28 18:06:22');
INSERT INTO `access_log` VALUES (13006, 'ea921755-74da-44ec-a8f6-42cf2e2b0b3d', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:06:23', 50, 0, '', '2019-05-28 18:06:23');
INSERT INTO `access_log` VALUES (13007, '09544943-fa05-44c1-bd55-8d013a653701', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:06:23', 267, 2001001000, '服务端发生异常', '2019-05-28 18:06:23');
INSERT INTO `access_log` VALUES (13008, '9c2ca6f0-171e-4cc2-9ed0-58127270c365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:06:26', 50, 0, '', '2019-05-28 18:06:26');
INSERT INTO `access_log` VALUES (13009, '4e6dae03-6993-4c16-9506-33190e628074', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:06:26', 48, 0, '', '2019-05-28 18:06:26');
INSERT INTO `access_log` VALUES (13010, '6bca1f20-3f2b-4a66-9cff-100cce5494f7', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=7777777777&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:06:30', 34, 0, '', '2019-05-28 18:06:30');
INSERT INTO `access_log` VALUES (13011, '46fd958b-59c9-4682-a671-016a449ff9d5', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=7777777777', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:06:30', 144, 2001001000, '服务端发生异常', '2019-05-28 18:06:30');
INSERT INTO `access_log` VALUES (13012, '451d9865-0d8e-4336-9d50-263b503218ae', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:29:57', 176, 0, '', '2019-05-28 18:29:57');
INSERT INTO `access_log` VALUES (13013, 'a2229e57-cf07-461e-8af8-f5f561a03997', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:29:57', 53, 0, '', '2019-05-28 18:29:58');
INSERT INTO `access_log` VALUES (13014, '1c1d025d-11cf-45e6-9f42-c50bc9f46a1f', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:29:59', 308, 0, '', '2019-05-28 18:29:59');
INSERT INTO `access_log` VALUES (13015, '2064f9e9-b464-4b52-b07f-058cb8a418c1', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:29:59', 330, 0, '', '2019-05-28 18:29:59');
INSERT INTO `access_log` VALUES (13016, 'cb4310cd-f2c5-490a-a111-e4781a661269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:06', 1008, 0, '', '2019-05-28 18:30:07');
INSERT INTO `access_log` VALUES (13017, 'c6f78e49-f1f0-49b8-b047-fbcca5db78c0', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:07', 201, 0, '', '2019-05-28 18:30:07');
INSERT INTO `access_log` VALUES (13018, '83fb609a-4da8-4fcb-bc4d-edd3d529ba44', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:08', 404, 0, '', '2019-05-28 18:30:08');
INSERT INTO `access_log` VALUES (13019, '9d3fa173-64a8-4a9f-aa16-36ee960c8fed', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:07', 202, 0, '', '2019-05-28 18:30:07');
INSERT INTO `access_log` VALUES (13020, '49d98913-6e3f-41c3-b329-7adcf57aced8', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:17', 172, 0, '', '2019-05-28 18:30:17');
INSERT INTO `access_log` VALUES (13021, '4a262f73-ed66-43d7-90dc-1ffb5bd2ee5d', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:17', 329, 0, '', '2019-05-28 18:30:17');
INSERT INTO `access_log` VALUES (13022, 'd5793dca-33d3-43d3-bb75-751492ebb258', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:17', 264, 0, '', '2019-05-28 18:30:17');
INSERT INTO `access_log` VALUES (13023, '4c489e00-3e9b-42f9-996b-cc0473fcbc52', 0, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:31', 54, 0, '', '2019-05-28 18:30:31');
INSERT INTO `access_log` VALUES (13024, '3871421c-c959-4d7b-a402-3cafc3f99ce7', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:34', 47, 0, '', '2019-05-28 18:30:34');
INSERT INTO `access_log` VALUES (13025, '9cb6bf30-776e-42df-b71a-dbcf66b2eb52', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:34', 130, 0, '', '2019-05-28 18:30:34');
INSERT INTO `access_log` VALUES (13026, '690f3e1e-dfd0-45f4-9651-52d85b4f7d19', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:34', 86, 0, '', '2019-05-28 18:30:34');
INSERT INTO `access_log` VALUES (13027, 'c4ec7866-d494-4324-b439-9901600d5939', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:38', 53, 0, '', '2019-05-28 18:30:38');
INSERT INTO `access_log` VALUES (13028, '1e681a6b-d7e3-4ce2-ac94-77db2adc0c4e', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:38', 78, 0, '', '2019-05-28 18:30:38');
INSERT INTO `access_log` VALUES (13029, 'cb71650d-fdae-497b-a7a1-d8f65cf67e46', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:40', 48, 0, '', '2019-05-28 18:30:40');
INSERT INTO `access_log` VALUES (13030, 'd122e991-8e4b-40b2-ae74-9bb53f48a4da', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:40', 135, 0, '', '2019-05-28 18:30:40');
INSERT INTO `access_log` VALUES (13031, '331f3737-3843-4377-b487-24e35d7963f7', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=50', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:30:41', 77, 0, '', '2019-05-28 18:30:41');
INSERT INTO `access_log` VALUES (13032, '59.76.15590444542509269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:14', 13, 2001001000, '服务端发生异常', '2019-05-28 19:54:14');
INSERT INTO `access_log` VALUES (13033, '59.77.15590444542409273', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:14', 74, 0, '', '2019-05-28 19:54:14');
INSERT INTO `access_log` VALUES (13034, '64.85.15590444571848581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:17', 11, 0, '', '2019-05-28 19:54:17');
INSERT INTO `access_log` VALUES (13035, '64.80.15590444574748573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:17', 3, 0, '', '2019-05-28 19:54:17');
INSERT INTO `access_log` VALUES (13036, '64.83.15590444595748577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:20', 2, 0, '', '2019-05-28 19:54:20');
INSERT INTO `access_log` VALUES (13037, '64.77.15590444600848583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:20', 2, 0, '', '2019-05-28 19:54:20');
INSERT INTO `access_log` VALUES (13038, '59.75.15590444632429275', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:23', 4, 0, '', '2019-05-28 19:54:23');
INSERT INTO `access_log` VALUES (13039, '59.73.15590444632429277', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:23', 14, 2001001000, '服务端发生异常', '2019-05-28 19:54:23');
INSERT INTO `access_log` VALUES (13040, '64.78.15590444697408583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:30', 3, 0, '', '2019-05-28 19:54:30');
INSERT INTO `access_log` VALUES (13041, '64.79.15590444699888575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:30', 2, 0, '', '2019-05-28 19:54:30');
INSERT INTO `access_log` VALUES (13042, '64.82.15590444709198587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:31', 2, 0, '', '2019-05-28 19:54:31');
INSERT INTO `access_log` VALUES (13043, '64.81.15590444712538579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:31', 363, 0, '', '2019-05-28 19:54:32');
INSERT INTO `access_log` VALUES (13044, '59.72.15590444753719271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:35', 3, 0, '', '2019-05-28 19:54:35');
INSERT INTO `access_log` VALUES (13045, '59.78.15590444753729279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:35', 14, 2001001000, '服务端发生异常', '2019-05-28 19:54:35');
INSERT INTO `access_log` VALUES (13046, '64.85.15590444771428583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:37', 3, 0, '', '2019-05-28 19:54:37');
INSERT INTO `access_log` VALUES (13047, '64.80.15590444773998575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:37', 2, 0, '', '2019-05-28 19:54:37');
INSERT INTO `access_log` VALUES (13048, '59.79.15590444775319273', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:38', 4, 0, '', '2019-05-28 19:54:38');
INSERT INTO `access_log` VALUES (13049, '59.80.15590444776439275', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:38', 19, 2001001000, '服务端发生异常', '2019-05-28 19:54:38');
INSERT INTO `access_log` VALUES (13050, '59.76.15590444832009271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:43', 3, 0, '', '2019-05-28 19:54:43');
INSERT INTO `access_log` VALUES (13051, '59.77.15590444832009275', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.84.194.68', '2019-05-28 19:54:43', 14, 2001001000, '服务端发生异常', '2019-05-28 19:54:43');
INSERT INTO `access_log` VALUES (13052, '59.73.15590444981369279', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.84.194.68', '2019-05-28 19:54:58', 4, 0, '', '2019-05-28 19:54:58');
INSERT INTO `access_log` VALUES (13053, '59.75.15590444981359277', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.84.194.68', '2019-05-28 19:54:58', 14, 2001001000, '服务端发生异常', '2019-05-28 19:54:58');
INSERT INTO `access_log` VALUES (13054, '64.84.15590445104258585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.84.194.68', '2019-05-28 19:55:10', 3, 0, '', '2019-05-28 19:55:10');
INSERT INTO `access_log` VALUES (13055, '64.78.15590445106778585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.84.194.68', '2019-05-28 19:55:11', 3, 0, '', '2019-05-28 19:55:11');
INSERT INTO `access_log` VALUES (13056, '64.79.15590445116698577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.84.194.68', '2019-05-28 19:55:12', 2, 0, '', '2019-05-28 19:55:12');
INSERT INTO `access_log` VALUES (13057, '64.82.15590445124108589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.84.194.68', '2019-05-28 19:55:12', 384, 0, '', '2019-05-28 19:55:13');
INSERT INTO `access_log` VALUES (13058, '64.81.15590445160888581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.84.194.68', '2019-05-28 19:55:16', 2, 0, '', '2019-05-28 19:55:16');
INSERT INTO `access_log` VALUES (13059, '64.76.15590445163738585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.84.194.68', '2019-05-28 19:55:16', 2, 0, '', '2019-05-28 19:55:16');
INSERT INTO `access_log` VALUES (13060, '59.72.15590445186999273', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.84.194.68', '2019-05-28 19:55:19', 4, 0, '', '2019-05-28 19:55:19');
INSERT INTO `access_log` VALUES (13061, '59.78.15590445187019281', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.84.194.68', '2019-05-28 19:55:19', 19, 2001001000, '服务端发生异常', '2019-05-28 19:55:19');
INSERT INTO `access_log` VALUES (13062, '59.77.15590461972599299', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '114.87.128.147', '2019-05-28 20:23:17', 4, 0, '', '2019-05-28 20:23:17');
INSERT INTO `access_log` VALUES (13063, '59.76.15590461972639295', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '114.87.128.147', '2019-05-28 20:23:17', 14, 2001001000, '服务端发生异常', '2019-05-28 20:23:17');
INSERT INTO `access_log` VALUES (13064, '64.78.15590462091058611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '114.87.128.147', '2019-05-28 20:23:29', 4, 0, '', '2019-05-28 20:23:29');
INSERT INTO `access_log` VALUES (13065, '64.79.15590462108988603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '114.87.128.147', '2019-05-28 20:23:31', 2, 0, '', '2019-05-28 20:23:31');
INSERT INTO `access_log` VALUES (13066, '64.82.15590462137638615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '114.87.128.147', '2019-05-28 20:23:34', 2, 0, '', '2019-05-28 20:23:34');
INSERT INTO `access_log` VALUES (13067, '64.76.15590462158578609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '114.87.128.147', '2019-05-28 20:23:36', 2, 0, '', '2019-05-28 20:23:36');
INSERT INTO `access_log` VALUES (13068, '59.79.15590464036119301', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.51.62.116', '2019-05-28 20:26:44', 4, 0, '', '2019-05-28 20:26:44');
INSERT INTO `access_log` VALUES (13069, '59.78.15590464036109307', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.51.62.116', '2019-05-28 20:26:44', 13, 2001001000, '服务端发生异常', '2019-05-28 20:26:44');
INSERT INTO `access_log` VALUES (13070, '59.72.15590464036109299', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.51.62.116', '2019-05-28 20:26:44', 17, 2001001000, '服务端发生异常', '2019-05-28 20:26:44');
INSERT INTO `access_log` VALUES (13071, '59.80.15590464037149303', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.51.62.116', '2019-05-28 20:26:44', 3, 0, '', '2019-05-28 20:26:44');
INSERT INTO `access_log` VALUES (13072, '65.50.15590464306318637', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.51.62.116', '2019-05-28 20:27:11', 1, 1002001015, '账号未登陆', '2019-05-28 20:27:11');
INSERT INTO `access_log` VALUES (13073, '65.48.15590464306328645', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.51.62.116', '2019-05-28 20:27:11', 1, 1002001015, '账号未登陆', '2019-05-28 20:27:11');
INSERT INTO `access_log` VALUES (13074, '65.49.15590464306358637', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.51.62.116', '2019-05-28 20:27:11', 0, 1002001015, '账号未登陆', '2019-05-28 20:27:11');
INSERT INTO `access_log` VALUES (13075, '65.45.15590464414408647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.51.62.116', '2019-05-28 20:27:21', 65, 0, '', '2019-05-28 20:27:22');
INSERT INTO `access_log` VALUES (13076, '65.47.15590464481538647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.51.62.116', '2019-05-28 20:27:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 20:27:28');
INSERT INTO `access_log` VALUES (13077, '65.46.15590464534808627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.51.62.116', '2019-05-28 20:27:33', 90, 0, '', '2019-05-28 20:27:34');
INSERT INTO `access_log` VALUES (13078, '59.77.15590465472339305', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '114.87.128.147', '2019-05-28 20:29:07', 4, 0, '', '2019-05-28 20:29:07');
INSERT INTO `access_log` VALUES (13079, '59.76.15590465472339301', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '114.87.128.147', '2019-05-28 20:29:07', 13, 2001001000, '服务端发生异常', '2019-05-28 20:29:07');
INSERT INTO `access_log` VALUES (13080, '64.83.15590465672168611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '114.87.128.147', '2019-05-28 20:29:27', 3, 0, '', '2019-05-28 20:29:27');
INSERT INTO `access_log` VALUES (13081, '64.84.15590465674458617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '114.87.128.147', '2019-05-28 20:29:27', 2, 0, '', '2019-05-28 20:29:27');
INSERT INTO `access_log` VALUES (13082, '64.85.15590467997498619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '114.87.128.147', '2019-05-28 20:33:20', 3, 0, '', '2019-05-28 20:33:20');
INSERT INTO `access_log` VALUES (13083, '64.77.15590468003038617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '114.87.128.147', '2019-05-28 20:33:20', 2, 0, '', '2019-05-28 20:33:20');
INSERT INTO `access_log` VALUES (13084, '70f3252d-9b93-4a9f-ba7a-11fed9d669a4', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:33:50', 1667, 0, '', '2019-05-28 20:33:52');
INSERT INTO `access_log` VALUES (13085, 'ff1958d1-1d65-40fd-94d7-c5495720c919', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:33:50', 2555, 0, '', '2019-05-28 20:33:52');
INSERT INTO `access_log` VALUES (13086, '74b48c34-1385-4107-a072-dacb58330b6f', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=50', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:33:52', 651, 0, '', '2019-05-28 20:33:53');
INSERT INTO `access_log` VALUES (13087, '5ca0749b-49db-4f82-8186-139c5803b9d1', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:37:01', 179, 0, '', '2019-05-28 20:37:01');
INSERT INTO `access_log` VALUES (13088, '97588f1c-e0ed-49ba-94bb-db6d5562bca2', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:37:01', 1286, 0, '', '2019-05-28 20:37:03');
INSERT INTO `access_log` VALUES (13089, 'a4fa4718-c480-48c3-8cdf-ea09a102a024', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=50', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:37:03', 587, 2001001000, '服务端发生异常', '2019-05-28 20:37:04');
INSERT INTO `access_log` VALUES (13090, '95e24be6-2d74-4339-a0fa-01e56dc50db4', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:23', 1779, 0, '', '2019-05-28 20:58:25');
INSERT INTO `access_log` VALUES (13091, '122580f1-ab9f-40e3-b436-d07669dfa76c', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=50', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:25', 193, 0, '', '2019-05-28 20:58:26');
INSERT INTO `access_log` VALUES (13092, 'af50d941-79a2-4712-9feb-4ab77ba9e9b7', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:23', 3156, 0, '', '2019-05-28 20:58:26');
INSERT INTO `access_log` VALUES (13093, '42596328-6690-4ffb-9829-362a7225d641', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:35', 107, 0, '', '2019-05-28 20:58:35');
INSERT INTO `access_log` VALUES (13094, '4f0b07ad-f9b7-4298-baf5-c8d24e75803f', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:35', 210, 0, '', '2019-05-28 20:58:36');
INSERT INTO `access_log` VALUES (13095, '333dc80c-677d-4bc7-b55f-4970fb5b6e6e', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:38', 106, 0, '', '2019-05-28 20:58:38');
INSERT INTO `access_log` VALUES (13096, 'e7940b61-ec83-444f-882a-4e957998f5e3', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:38', 100, 0, '', '2019-05-28 20:58:38');
INSERT INTO `access_log` VALUES (13097, '46689b59-6e9a-4cde-a40d-8b8d3e4e0b80', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:40', 97, 0, '', '2019-05-28 20:58:40');
INSERT INTO `access_log` VALUES (13098, '2e56cc39-5360-4cd4-ad92-ab0fbe28893d', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:41', 413, 0, '', '2019-05-28 20:58:41');
INSERT INTO `access_log` VALUES (13099, '1d0243a2-8fe1-4464-b2fb-b840b728ac37', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:42', 130, 0, '', '2019-05-28 20:58:43');
INSERT INTO `access_log` VALUES (13100, 'f172b12d-3d5d-4ee4-b52e-3253b5ad204e', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:43', 382, 0, '', '2019-05-28 20:58:43');
INSERT INTO `access_log` VALUES (13101, 'ecf73058-7a1b-42aa-ab2d-57256382f33a', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:46', 71, 0, '', '2019-05-28 20:58:46');
INSERT INTO `access_log` VALUES (13102, '1797905f-f6e0-4f11-b0f4-b994a84fc1d7', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:46', 97, 0, '', '2019-05-28 20:58:46');
INSERT INTO `access_log` VALUES (13103, '052aa46d-5115-45a0-8562-cc9b71cf94dd', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:48', 102, 0, '', '2019-05-28 20:58:48');
INSERT INTO `access_log` VALUES (13104, '84d3a1ae-da71-4a4d-bc99-cd472400fa1a', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:48', 666, 0, '', '2019-05-28 20:58:49');
INSERT INTO `access_log` VALUES (13105, 'f5f5b484-5da1-4db6-a0b2-6be8d600d095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:49', 102, 0, '', '2019-05-28 20:58:49');
INSERT INTO `access_log` VALUES (13106, '63a78a1e-1f6a-4e03-8459-4f2f4d6b9a44', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:49', 86, 0, '', '2019-05-28 20:58:49');
INSERT INTO `access_log` VALUES (13107, 'f4a98c24-3a7f-4f6a-a5be-ec3b68038049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:52', 95, 0, '', '2019-05-28 20:58:52');
INSERT INTO `access_log` VALUES (13108, '9ed4fe7e-35d0-4a26-80cb-f55cace330cc', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:52', 104, 0, '', '2019-05-28 20:58:52');
INSERT INTO `access_log` VALUES (13109, '6e21d45b-43a4-408b-bcf9-7fff78df882e', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:55', 87, 0, '', '2019-05-28 20:58:55');
INSERT INTO `access_log` VALUES (13110, '5ed51113-1c09-4985-b652-47d2151133d5', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:55', 109, 0, '', '2019-05-28 20:58:55');
INSERT INTO `access_log` VALUES (13111, 'ffabfca4-d281-4d7e-b1a1-ac622fab4cce', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:57', 100, 0, '', '2019-05-28 20:58:57');
INSERT INTO `access_log` VALUES (13112, 'acd1b6af-3f73-417a-ae63-98b4a3f133fc', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:58', 107, 0, '', '2019-05-28 20:58:58');
INSERT INTO `access_log` VALUES (13113, 'd0dfb409-3c25-444f-a58e-50884222822d', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:59', 59, 0, '', '2019-05-28 20:58:59');
INSERT INTO `access_log` VALUES (13114, 'e2aa9006-10d0-43e9-9760-94c9fbac9b3f', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:58:59', 96, 0, '', '2019-05-28 20:58:59');
INSERT INTO `access_log` VALUES (13115, '2c69160f-56f4-43c0-8986-4b1ec818bc80', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:01', 95, 0, '', '2019-05-28 20:59:01');
INSERT INTO `access_log` VALUES (13116, '93c3ebab-567f-474f-9ae0-ca170558f58d', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:01', 105, 0, '', '2019-05-28 20:59:01');
INSERT INTO `access_log` VALUES (13117, 'd7721d1b-6933-4325-bf9e-f961426541d3', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:04', 70, 0, '', '2019-05-28 20:59:04');
INSERT INTO `access_log` VALUES (13118, 'ee314dc2-ba3c-4196-8f1b-acf278080b19', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:04', 94, 0, '', '2019-05-28 20:59:04');
INSERT INTO `access_log` VALUES (13119, 'c1eb133b-e43a-48ff-88ba-51f9e51acffb', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:07', 95, 0, '', '2019-05-28 20:59:08');
INSERT INTO `access_log` VALUES (13120, '02b04554-4cee-4572-99d1-515bf5527a1b', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:08', 108, 0, '', '2019-05-28 20:59:08');
INSERT INTO `access_log` VALUES (13121, 'bc8654a8-0cc8-4e79-b38d-d47c41482f5d', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:09', 60, 0, '', '2019-05-28 20:59:10');
INSERT INTO `access_log` VALUES (13122, '7f2fcd89-07cb-4cec-a25e-958f34ed5f26', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:09', 97, 0, '', '2019-05-28 20:59:10');
INSERT INTO `access_log` VALUES (13123, '407044a7-5f41-4ee8-8e68-dfdd753beaa2', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:13', 97, 0, '', '2019-05-28 20:59:13');
INSERT INTO `access_log` VALUES (13124, 'cd5ebe21-15cd-488e-8e7f-1ff2f63a916e', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:13', 273, 0, '', '2019-05-28 20:59:13');
INSERT INTO `access_log` VALUES (13125, '1c5652a3-a4e4-457c-acb5-eeca2bca710c', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:14', 145, 0, '', '2019-05-28 20:59:14');
INSERT INTO `access_log` VALUES (13126, '154df36f-b53a-493e-9702-ce5800b830cf', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:18', 57, 0, '', '2019-05-28 20:59:18');
INSERT INTO `access_log` VALUES (13127, '8ed82b88-d470-4404-9153-07a5439b8529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:18', 96, 0, '', '2019-05-28 20:59:18');
INSERT INTO `access_log` VALUES (13128, '9b0fc762-5e84-46dd-84ad-b1104478f765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:19', 97, 0, '', '2019-05-28 20:59:19');
INSERT INTO `access_log` VALUES (13129, '738a4a88-07a5-4b20-9675-bd6ac570a0e1', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:19', 100, 0, '', '2019-05-28 20:59:19');
INSERT INTO `access_log` VALUES (13130, '9029f080-6e0f-4935-a07b-c0f6de7fce18', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:21', 90, 1002001012, '访问令牌已过期', '2019-05-28 20:59:21');
INSERT INTO `access_log` VALUES (13131, '2a2b21ba-d195-4954-9436-6aac68729ada', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=276dfecc04b44981b0d695909dfcd16f', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:22', 662, 0, '', '2019-05-28 20:59:22');
INSERT INTO `access_log` VALUES (13132, '76e75eeb-a2b6-47ea-94cf-480964419a21', 87, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:23', 577, 0, '', '2019-05-28 20:59:23');
INSERT INTO `access_log` VALUES (13133, '71164eed-ff9e-4755-931f-0608b5f38d79', 87, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:26', 171, 0, '', '2019-05-28 20:59:26');
INSERT INTO `access_log` VALUES (13134, '055fbefd-ee82-45ee-98bc-57b5446743e0', 87, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:27', 95, 0, '', '2019-05-28 20:59:27');
INSERT INTO `access_log` VALUES (13135, '6f884994-5529-4256-af66-e04fd7bbf577', 87, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:29', 134, 0, '', '2019-05-28 20:59:29');
INSERT INTO `access_log` VALUES (13136, '75ac8aaf-1c9d-4e05-ac1e-4ac30c513136', 87, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:32', 102, 0, '', '2019-05-28 20:59:32');
INSERT INTO `access_log` VALUES (13137, '14718fb1-8edf-48ab-b01c-90426aff41de', 87, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:35', 94, 0, '', '2019-05-28 20:59:35');
INSERT INTO `access_log` VALUES (13138, 'f95e5f8a-4193-46a0-983b-e74e42cd18f7', 87, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:37', 94, 0, '', '2019-05-28 20:59:37');
INSERT INTO `access_log` VALUES (13139, '7c0c23c5-ba76-4a18-8f14-e38ba7240004', 87, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:38', 100, 0, '', '2019-05-28 20:59:38');
INSERT INTO `access_log` VALUES (13140, 'fa677eaa-a5a5-4c69-b41b-2913cf82db41', 87, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:38', 191, 0, '', '2019-05-28 20:59:39');
INSERT INTO `access_log` VALUES (13141, '8c531787-6312-40e5-9cb0-7c6c3b27d451', 87, 1, 'search-application', '/search-api/users/product/page', 'keyword=rrr&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:49', 83, 0, '', '2019-05-28 20:59:49');
INSERT INTO `access_log` VALUES (13142, '874cc250-e3a0-4e4d-8dd2-bbaa2964b716', 87, 1, 'search-application', '/search-api/users/product/condition', 'keyword=rrr', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:59:49', 194, 0, '', '2019-05-28 20:59:49');
INSERT INTO `access_log` VALUES (13143, '59.79.15590509632799363', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5332 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '111.201.148.227', '2019-05-28 21:42:43', 12, 0, '', '2019-05-28 21:42:43');
INSERT INTO `access_log` VALUES (13144, '59.78.15590509632809369', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5332 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '111.201.148.227', '2019-05-28 21:42:43', 17, 2001001000, '服务端发生异常', '2019-05-28 21:42:43');
INSERT INTO `access_log` VALUES (13145, '59.71.15590510149379367', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:43:35', 4, 0, '', '2019-05-28 21:43:35');
INSERT INTO `access_log` VALUES (13146, '59.73.15590510149409369', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:43:35', 15, 2001001000, '服务端发生异常', '2019-05-28 21:43:35');
INSERT INTO `access_log` VALUES (13147, '64.84.15590510211588677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:43:41', 11, 0, '', '2019-05-28 21:43:41');
INSERT INTO `access_log` VALUES (13148, '64.78.15590510213628677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:43:41', 2, 0, '', '2019-05-28 21:43:41');
INSERT INTO `access_log` VALUES (13149, '64.79.15590510233538669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:43:43', 3, 0, '', '2019-05-28 21:43:43');
INSERT INTO `access_log` VALUES (13150, '64.82.15590510240158681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:43:44', 3, 0, '', '2019-05-28 21:43:44');
INSERT INTO `access_log` VALUES (13151, '64.76.15590510324878675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:43:52', 62, 0, '', '2019-05-28 21:43:53');
INSERT INTO `access_log` VALUES (13152, '64.85.15590510327168677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:43:53', 2, 0, '', '2019-05-28 21:43:53');
INSERT INTO `access_log` VALUES (13153, '65.49.15590510492668701', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:44:09', 0, 1002001015, '账号未登陆', '2019-05-28 21:44:09');
INSERT INTO `access_log` VALUES (13154, '65.51.15590510492668699', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:44:09', 1, 1002001015, '账号未登陆', '2019-05-28 21:44:09');
INSERT INTO `access_log` VALUES (13155, '65.48.15590510492668709', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:44:09', 0, 1002001015, '账号未登陆', '2019-05-28 21:44:09');
INSERT INTO `access_log` VALUES (13156, '65.53.15590510551788685', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:44:15', 1, 1002001015, '账号未登陆', '2019-05-28 21:44:15');
INSERT INTO `access_log` VALUES (13157, '65.45.15590510551838711', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:44:15', 0, 1002001015, '账号未登陆', '2019-05-28 21:44:15');
INSERT INTO `access_log` VALUES (13158, '65.52.15590510552018697', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:44:15', 1, 1002001015, '账号未登陆', '2019-05-28 21:44:15');
INSERT INTO `access_log` VALUES (13159, '65.47.15590510686348711', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:44:29', 137, 0, '', '2019-05-28 21:44:29');
INSERT INTO `access_log` VALUES (13160, '65.46.15590510691658691', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:44:29', 292, 0, '', '2019-05-28 21:44:29');
INSERT INTO `access_log` VALUES (13161, '65.54.15590510691678685', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:44:29', 290, 0, '', '2019-05-28 21:44:29');
INSERT INTO `access_log` VALUES (13162, '65.51.15590510691728701', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:44:29', 290, 0, '', '2019-05-28 21:44:29');
INSERT INTO `access_log` VALUES (13163, '62.89.15590510863559295', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:44:46', 356, 0, '', '2019-05-28 21:44:47');
INSERT INTO `access_log` VALUES (13164, '59.80.15590510964329367', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:44:56', 13, 0, '', '2019-05-28 21:44:56');
INSERT INTO `access_log` VALUES (13165, '65.53.15590511090698687', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:45:09', 15, 0, '', '2019-05-28 21:45:09');
INSERT INTO `access_log` VALUES (13166, '59.76.15590511143019363', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '124.34.124.47', '2019-05-28 21:45:14', 14, 0, '', '2019-05-28 21:45:14');
INSERT INTO `access_log` VALUES (13167, '65.45.15590531893108741', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '223.71.74.17', '2019-05-28 22:19:49', 404, 0, '', '2019-05-28 22:19:50');
INSERT INTO `access_log` VALUES (13168, '65.53.15590531903678715', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '223.71.74.17', '2019-05-28 22:19:50', 18, 0, '', '2019-05-28 22:19:50');
INSERT INTO `access_log` VALUES (13169, '65.52.15590531903728727', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '223.71.74.17', '2019-05-28 22:19:50', 15, 0, '', '2019-05-28 22:19:50');
INSERT INTO `access_log` VALUES (13170, '65.50.15590531903838731', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '223.71.74.17', '2019-05-28 22:19:50', 14, 0, '', '2019-05-28 22:19:50');
INSERT INTO `access_log` VALUES (13171, '59.77.15590534325719399', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:23:53', 18, 0, '', '2019-05-28 22:23:53');
INSERT INTO `access_log` VALUES (13172, '59.80.15590534325709399', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:23:53', 21, 2001001000, '服务端发生异常', '2019-05-28 22:23:53');
INSERT INTO `access_log` VALUES (13173, '65.52.15590534473998731', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:07', 4, 1002001012, '访问令牌已过期', '2019-05-28 22:24:07');
INSERT INTO `access_log` VALUES (13174, '65.53.15590534474058719', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:07', 4, 1002001012, '访问令牌已过期', '2019-05-28 22:24:07');
INSERT INTO `access_log` VALUES (13175, '65.50.15590534474218735', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:07', 4, 1002001012, '访问令牌已过期', '2019-05-28 22:24:07');
INSERT INTO `access_log` VALUES (13176, '65.46.15590534537238725', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:14', 59, 0, '', '2019-05-28 22:24:14');
INSERT INTO `access_log` VALUES (13177, '65.54.15590534540728719', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:14', 10, 0, '', '2019-05-28 22:24:14');
INSERT INTO `access_log` VALUES (13178, '65.51.15590534540788735', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:14', 9, 0, '', '2019-05-28 22:24:14');
INSERT INTO `access_log` VALUES (13179, '65.49.15590534540848737', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:14', 9, 0, '', '2019-05-28 22:24:14');
INSERT INTO `access_log` VALUES (13180, '65.48.15590534576198745', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:18', 20, 0, '', '2019-05-28 22:24:18');
INSERT INTO `access_log` VALUES (13181, '65.45.15590534588828747', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:19', 10, 0, '', '2019-05-28 22:24:19');
INSERT INTO `access_log` VALUES (13182, '65.53.15590534606338721', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:21', 20, 0, '', '2019-05-28 22:24:21');
INSERT INTO `access_log` VALUES (13183, '65.50.15590534614508737', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:21', 12, 0, '', '2019-05-28 22:24:21');
INSERT INTO `access_log` VALUES (13184, '59.73.15590534672059403', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:27', 14, 0, '', '2019-05-28 22:24:27');
INSERT INTO `access_log` VALUES (13185, '59.75.15590534696019401', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:30', 21, 2001001000, '服务端发生异常', '2019-05-28 22:24:30');
INSERT INTO `access_log` VALUES (13186, '66.55.15590534740708391', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:34', 25, 0, '', '2019-05-28 22:24:34');
INSERT INTO `access_log` VALUES (13187, '64.78.15590534821708711', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:42', 23, 0, '', '2019-05-28 22:24:42');
INSERT INTO `access_log` VALUES (13188, '64.84.15590534821708711', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:24:42', 27, 0, '', '2019-05-28 22:24:42');
INSERT INTO `access_log` VALUES (13189, '64.81.15590535025128703', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:25:03', 11, 0, '', '2019-05-28 22:25:03');
INSERT INTO `access_log` VALUES (13190, '64.82.15590535025118715', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:25:03', 15, 0, '', '2019-05-28 22:25:03');
INSERT INTO `access_log` VALUES (13191, '64.77.15590535047678709', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:25:05', 949, 0, '', '2019-05-28 22:25:06');
INSERT INTO `access_log` VALUES (13192, '64.85.15590535047668711', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:25:05', 1951, 0, '', '2019-05-28 22:25:07');
INSERT INTO `access_log` VALUES (13193, '64.76.15590535047658709', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:25:05', 1956, 0, '', '2019-05-28 22:25:07');
INSERT INTO `access_log` VALUES (13194, '65.51.15590535252338737', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:25:25', 4, 0, '', '2019-05-28 22:25:25');
INSERT INTO `access_log` VALUES (13195, '62.84.15590536116109323', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-28 22:26:52', 141, 0, '', '2019-05-28 22:26:52');
INSERT INTO `access_log` VALUES (13196, '65.51.15590536610268739', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:27:41', 1, 1002001015, '账号未登陆', '2019-05-28 22:27:41');
INSERT INTO `access_log` VALUES (13197, '65.48.15590536610338749', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:27:41', 1, 1002001015, '账号未登陆', '2019-05-28 22:27:41');
INSERT INTO `access_log` VALUES (13198, '65.45.15590536612928751', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:27:41', 0, 1002001015, '账号未登陆', '2019-05-28 22:27:41');
INSERT INTO `access_log` VALUES (13199, '65.53.15590536641918725', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:27:44', 71, 0, '', '2019-05-28 22:27:44');
INSERT INTO `access_log` VALUES (13200, '65.50.15590536647528741', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:27:45', 9, 0, '', '2019-05-28 22:27:45');
INSERT INTO `access_log` VALUES (13201, '65.52.15590536647568737', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:27:45', 9, 0, '', '2019-05-28 22:27:45');
INSERT INTO `access_log` VALUES (13202, '65.47.15590536647578751', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:27:45', 10, 0, '', '2019-05-28 22:27:45');
INSERT INTO `access_log` VALUES (13203, '65.46.15590536679708731', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:27:48', 14, 0, '', '2019-05-28 22:27:48');
INSERT INTO `access_log` VALUES (13204, '65.48.15590536914658751', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:28:11', 10, 0, '', '2019-05-28 22:28:11');
INSERT INTO `access_log` VALUES (13205, '65.45.15590537069298753', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:28:27', 11, 0, '', '2019-05-28 22:28:27');
INSERT INTO `access_log` VALUES (13206, '65.53.15590537076528727', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:28:28', 9, 0, '', '2019-05-28 22:28:28');
INSERT INTO `access_log` VALUES (13207, '65.47.15590537177918753', 27, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=32&type=1&sort=1&displayName=数据分析&pid=0&icon=money-collect&createTime=2019-05-02T16:02:08.000+0000', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:28:38', 7, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-28 22:28:38');
INSERT INTO `access_log` VALUES (13208, '65.52.15590537180598739', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:28:38', 8, 0, '', '2019-05-28 22:28:38');
INSERT INTO `access_log` VALUES (13209, '65.46.15590537254488733', 27, 2, 'admin-application', '/admin-api/admins/resource/delete', 'id=32', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:28:45', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-28 22:28:45');
INSERT INTO `access_log` VALUES (13210, '65.54.15590537256248727', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:28:46', 10, 0, '', '2019-05-28 22:28:46');
INSERT INTO `access_log` VALUES (13211, '65.48.15590537276828753', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:28:48', 9, 0, '', '2019-05-28 22:28:48');
INSERT INTO `access_log` VALUES (13212, '65.49.15590537276828745', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:28:48', 10, 0, '', '2019-05-28 22:28:48');
INSERT INTO `access_log` VALUES (13213, '65.51.15590537276868743', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:28:48', 9, 0, '', '2019-05-28 22:28:48');
INSERT INTO `access_log` VALUES (13214, '65.45.15590537278368755', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:28:48', 9, 0, '', '2019-05-28 22:28:48');
INSERT INTO `access_log` VALUES (13215, '65.53.15590537321288729', 27, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=32&type=1&sort=1&displayName=数据分析&pid=0&icon=money-collect&createTime=2019-05-02T16:02:08.000+0000', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:28:52', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-28 22:28:52');
INSERT INTO `access_log` VALUES (13216, '65.47.15590537323088755', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:28:52', 9, 0, '', '2019-05-28 22:28:52');
INSERT INTO `access_log` VALUES (13217, '65.46.15590537581648735', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:29:18', 11, 0, '', '2019-05-28 22:29:18');
INSERT INTO `access_log` VALUES (13218, '65.54.15590537594028729', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:29:19', 19, 0, '', '2019-05-28 22:29:19');
INSERT INTO `access_log` VALUES (13219, '65.49.15590537605468747', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:29:21', 9, 0, '', '2019-05-28 22:29:21');
INSERT INTO `access_log` VALUES (13220, '65.48.15590537683578755', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:29:28', 13, 0, '', '2019-05-28 22:29:28');
INSERT INTO `access_log` VALUES (13221, 'c988e266-9489-474c-aa0a-5a0bef9d3171', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 22:34:25', 12, 1002001015, '账号未登陆', '2019-05-28 22:34:25');
INSERT INTO `access_log` VALUES (13222, '883e93fd-af4b-42ad-aa73-9a39de28193b', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 22:34:25', 12, 1002001015, '账号未登陆', '2019-05-28 22:34:25');
INSERT INTO `access_log` VALUES (13223, 'e2e60def-c631-4d79-b46c-a9c7f978946f', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 22:34:25', 18, 1002001015, '账号未登陆', '2019-05-28 22:34:25');
INSERT INTO `access_log` VALUES (13224, '8fa503ba-8e90-429f-8590-d2d0f377602e', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 22:35:14', 1, 1002001015, '账号未登陆', '2019-05-28 22:35:14');
INSERT INTO `access_log` VALUES (13225, '12d4b0ca-4193-4ebe-856f-c65df3f57f96', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 22:35:14', 2, 1002001015, '账号未登陆', '2019-05-28 22:35:14');
INSERT INTO `access_log` VALUES (13226, '2e9ada47-c65a-4ae7-9e6e-876a58e14d1f', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 22:35:14', 3, 1002001015, '账号未登陆', '2019-05-28 22:35:14');
INSERT INTO `access_log` VALUES (13227, '59.79.15590542400569409', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.37.172.209', '2019-05-28 22:37:20', 4, 0, '', '2019-05-28 22:37:20');
INSERT INTO `access_log` VALUES (13228, '59.72.15590542402079407', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.37.172.209', '2019-05-28 22:37:20', 13, 2001001000, '服务端发生异常', '2019-05-28 22:37:20');
INSERT INTO `access_log` VALUES (13229, '64.78.15590542712598723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:37:51', 3, 0, '', '2019-05-28 22:37:51');
INSERT INTO `access_log` VALUES (13230, '64.84.15590542714398723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:37:51', 2, 0, '', '2019-05-28 22:37:51');
INSERT INTO `access_log` VALUES (13231, '64.79.15590542733228715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:37:53', 2, 0, '', '2019-05-28 22:37:53');
INSERT INTO `access_log` VALUES (13232, '64.81.15590542745028715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:37:55', 3, 0, '', '2019-05-28 22:37:55');
INSERT INTO `access_log` VALUES (13233, '64.82.15590542750948727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:37:55', 3, 0, '', '2019-05-28 22:37:55');
INSERT INTO `access_log` VALUES (13234, '64.80.15590542765228715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:37:57', 2, 0, '', '2019-05-28 22:37:57');
INSERT INTO `access_log` VALUES (13235, 'ef5b6445-1c03-4087-9438-002fcede94d1', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 22:37:56', 2, 1002001015, '账号未登陆', '2019-05-28 22:37:56');
INSERT INTO `access_log` VALUES (13236, '1d46b9fd-765c-47c8-bf1f-0311e4298f5d', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 22:37:56', 3, 1002001015, '账号未登陆', '2019-05-28 22:37:56');
INSERT INTO `access_log` VALUES (13237, 'd8667492-eb40-43d6-88bf-4b967ec7d17c', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 22:37:56', 1, 1002001015, '账号未登陆', '2019-05-28 22:37:56');
INSERT INTO `access_log` VALUES (13238, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=菜鸡&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:05', 18, 0, '', '2019-05-28 22:38:05');
INSERT INTO `access_log` VALUES (13239, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=菜鸡', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:05', 12, 0, '', '2019-05-28 22:38:05');
INSERT INTO `access_log` VALUES (13240, '64.85.15590542906848723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:11', 2, 0, '', '2019-05-28 22:38:11');
INSERT INTO `access_log` VALUES (13241, '64.76.15590542908408721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:11', 2, 0, '', '2019-05-28 22:38:11');
INSERT INTO `access_log` VALUES (13242, '64.83.15590542927298719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:13', 2, 0, '', '2019-05-28 22:38:13');
INSERT INTO `access_log` VALUES (13243, '64.78.15590542940388725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:14', 2, 0, '', '2019-05-28 22:38:14');
INSERT INTO `access_log` VALUES (13244, '64.84.15590542964628725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:16', 2, 0, '', '2019-05-28 22:38:16');
INSERT INTO `access_log` VALUES (13245, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:20', 9, 0, '', '2019-05-28 22:38:20');
INSERT INTO `access_log` VALUES (13246, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=java', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:20', 13, 0, '', '2019-05-28 22:38:20');
INSERT INTO `access_log` VALUES (13247, '64.81.15590543017748717', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:22', 9, 0, '', '2019-05-28 22:38:22');
INSERT INTO `access_log` VALUES (13248, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:42', 10, 0, '', '2019-05-28 22:38:42');
INSERT INTO `access_log` VALUES (13249, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:42', 12, 0, '', '2019-05-28 22:38:42');
INSERT INTO `access_log` VALUES (13250, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:42', 6, 0, '', '2019-05-28 22:38:42');
INSERT INTO `access_log` VALUES (13251, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:43', 13, 0, '', '2019-05-28 22:38:43');
INSERT INTO `access_log` VALUES (13252, '64.80.15590543232958717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:43', 2, 0, '', '2019-05-28 22:38:43');
INSERT INTO `access_log` VALUES (13253, '64.77.15590543234398723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:38:43', 2, 0, '', '2019-05-28 22:38:43');
INSERT INTO `access_log` VALUES (13254, '66.55.15590543498538403', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13033339999&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:39:10', 12, 1001003000, '验证码不存在', '2019-05-28 22:39:10');
INSERT INTO `access_log` VALUES (13255, '66.52.15590543543228393', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13033339999&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:39:14', 16, 1001003000, '验证码不存在', '2019-05-28 22:39:14');
INSERT INTO `access_log` VALUES (13256, '66.54.15590543568558391', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13033339999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:39:17', 85, 0, '', '2019-05-28 22:39:17');
INSERT INTO `access_log` VALUES (13257, '66.56.15590543618028391', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13033339999&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:39:22', 229, 0, '', '2019-05-28 22:39:22');
INSERT INTO `access_log` VALUES (13258, '66.57.15590543640578397', 89, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:39:24', 7, 0, '', '2019-05-28 22:39:24');
INSERT INTO `access_log` VALUES (13259, '66.51.15590543775908397', 89, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:39:38', 7, 0, '', '2019-05-28 22:39:38');
INSERT INTO `access_log` VALUES (13260, '66.52.15590543789688395', 89, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:39:39', 7, 0, '', '2019-05-28 22:39:39');
INSERT INTO `access_log` VALUES (13261, '66.53.15590543858058399', 89, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:39:46', 394, 0, '', '2019-05-28 22:39:46');
INSERT INTO `access_log` VALUES (13262, '66.49.15590543888628397', 89, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:39:49', 310, 0, '', '2019-05-28 22:39:49');
INSERT INTO `access_log` VALUES (13263, '66.48.15590543995398403', 89, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:00', 7, 0, '', '2019-05-28 22:40:00');
INSERT INTO `access_log` VALUES (13264, '66.55.15590544011508407', 89, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:01', 7, 0, '', '2019-05-28 22:40:01');
INSERT INTO `access_log` VALUES (13265, '66.53.15590544087288401', 89, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:09', 7, 0, '', '2019-05-28 22:40:09');
INSERT INTO `access_log` VALUES (13266, '64.82.15590544100848731', 89, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:10', 6, 0, '', '2019-05-28 22:40:10');
INSERT INTO `access_log` VALUES (13267, '64.77.15590544105058725', 89, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:11', 5, 0, '', '2019-05-28 22:40:11');
INSERT INTO `access_log` VALUES (13268, '64.76.15590544119498725', 89, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:12', 6, 0, '', '2019-05-28 22:40:12');
INSERT INTO `access_log` VALUES (13269, '64.78.15590544126648729', 89, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:13', 5, 0, '', '2019-05-28 22:40:13');
INSERT INTO `access_log` VALUES (13270, '59.71.15590544144879415', 89, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:14', 7, 0, '', '2019-05-28 22:40:14');
INSERT INTO `access_log` VALUES (13271, '59.73.15590544145639417', 89, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:15', 17, 2001001000, '服务端发生异常', '2019-05-28 22:40:15');
INSERT INTO `access_log` VALUES (13272, '66.57.15590544273438401', 89, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:27', 7, 0, '', '2019-05-28 22:40:27');
INSERT INTO `access_log` VALUES (13273, '66.48.15590544325188405', 89, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:33', 6, 0, '', '2019-05-28 22:40:33');
INSERT INTO `access_log` VALUES (13274, '64.81.15590544341778721', 89, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:34', 6, 0, '', '2019-05-28 22:40:34');
INSERT INTO `access_log` VALUES (13275, '64.80.15590544344018721', 89, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:34', 5, 0, '', '2019-05-28 22:40:34');
INSERT INTO `access_log` VALUES (13276, '59.72.15590544368369411', 89, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:37', 10, 0, '', '2019-05-28 22:40:37');
INSERT INTO `access_log` VALUES (13277, '59.77.15590544368369415', 89, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:37', 17, 2001001000, '服务端发生异常', '2019-05-28 22:40:37');
INSERT INTO `access_log` VALUES (13278, '64.76.15590544468058727', 89, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:47', 5, 0, '', '2019-05-28 22:40:47');
INSERT INTO `access_log` VALUES (13279, '64.78.15590544470458731', 89, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:47', 5, 0, '', '2019-05-28 22:40:47');
INSERT INTO `access_log` VALUES (13280, '66.52.15590544480338399', 89, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:48', 7, 0, '', '2019-05-28 22:40:48');
INSERT INTO `access_log` VALUES (13281, '59.73.15590544483319419', 89, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:48', 6, 0, '', '2019-05-28 22:40:48');
INSERT INTO `access_log` VALUES (13282, '59.71.15590544483319417', 89, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:48', 17, 2001001000, '服务端发生异常', '2019-05-28 22:40:48');
INSERT INTO `access_log` VALUES (13283, '64.79.15590544485638723', 89, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:49', 5, 0, '', '2019-05-28 22:40:49');
INSERT INTO `access_log` VALUES (13284, '66.53.15590544488158403', 89, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:49', 6, 0, '', '2019-05-28 22:40:49');
INSERT INTO `access_log` VALUES (13285, '64.82.15590544488798735', 89, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:49', 5, 0, '', '2019-05-28 22:40:49');
INSERT INTO `access_log` VALUES (13286, '64.77.15590544489508729', 89, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:49', 5, 0, '', '2019-05-28 22:40:49');
INSERT INTO `access_log` VALUES (13287, '64.76.15590544493048729', 89, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:49', 5, 0, '', '2019-05-28 22:40:49');
INSERT INTO `access_log` VALUES (13288, '59.77.15590544495089417', 89, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:50', 6, 0, '', '2019-05-28 22:40:50');
INSERT INTO `access_log` VALUES (13289, '59.78.15590544495089421', 89, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.37.172.209', '2019-05-28 22:40:50', 16, 2001001000, '服务端发生异常', '2019-05-28 22:40:50');
INSERT INTO `access_log` VALUES (13290, '65.52.15590545645528753', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:42:45', 21, 0, '', '2019-05-28 22:42:45');
INSERT INTO `access_log` VALUES (13291, '65.50.15590545687818757', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:42:49', 12, 0, '', '2019-05-28 22:42:49');
INSERT INTO `access_log` VALUES (13292, '65.46.15590545711338747', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:42:51', 12, 0, '', '2019-05-28 22:42:51');
INSERT INTO `access_log` VALUES (13293, '65.49.15590545761398759', 27, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=14&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 22:42:56', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-28 22:42:56');
INSERT INTO `access_log` VALUES (13294, '59.75.15590554348889431', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:15', 5, 0, '', '2019-05-28 22:57:15');
INSERT INTO `access_log` VALUES (13295, '59.79.15590554348889429', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:15', 14, 2001001000, '服务端发生异常', '2019-05-28 22:57:15');
INSERT INTO `access_log` VALUES (13296, '64.77.15590554387788743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:19', 3, 0, '', '2019-05-28 22:57:19');
INSERT INTO `access_log` VALUES (13297, '64.82.15590554389278749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:19', 2, 0, '', '2019-05-28 22:57:19');
INSERT INTO `access_log` VALUES (13298, '64.76.15590554409118743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:21', 3, 0, '', '2019-05-28 22:57:21');
INSERT INTO `access_log` VALUES (13299, '64.83.15590554416028741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:22', 3, 0, '', '2019-05-28 22:57:22');
INSERT INTO `access_log` VALUES (13300, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:22', 11, 0, '', '2019-05-28 22:57:22');
INSERT INTO `access_log` VALUES (13301, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:23', 7, 0, '', '2019-05-28 22:57:23');
INSERT INTO `access_log` VALUES (13302, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:24', 8, 0, '', '2019-05-28 22:57:24');
INSERT INTO `access_log` VALUES (13303, '64.78.15590554454968747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:25', 2, 0, '', '2019-05-28 22:57:26');
INSERT INTO `access_log` VALUES (13304, '64.84.15590554456278747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:26', 3, 0, '', '2019-05-28 22:57:26');
INSERT INTO `access_log` VALUES (13305, '59.78.15590554465839435', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:27', 3, 0, '', '2019-05-28 22:57:27');
INSERT INTO `access_log` VALUES (13306, '59.77.15590554465739431', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:27', 20, 2001001000, '服务端发生异常', '2019-05-28 22:57:27');
INSERT INTO `access_log` VALUES (13307, '65.49.15590554559808771', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:36', 0, 1002001015, '账号未登陆', '2019-05-28 22:57:36');
INSERT INTO `access_log` VALUES (13308, '65.54.15590554559808753', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:36', 0, 1002001015, '账号未登陆', '2019-05-28 22:57:36');
INSERT INTO `access_log` VALUES (13309, '65.51.15590554559878769', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:36', 1, 1002001015, '账号未登陆', '2019-05-28 22:57:36');
INSERT INTO `access_log` VALUES (13310, '65.48.15590554588418779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.71.9', '2019-05-28 22:57:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-28 22:57:39');
INSERT INTO `access_log` VALUES (13311, '65.54.15590558663708761', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:04:26', 501, 1002001012, '访问令牌已过期', '2019-05-28 23:04:27');
INSERT INTO `access_log` VALUES (13312, '65.47.15590558663728787', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:04:26', 498, 1002001012, '访问令牌已过期', '2019-05-28 23:04:27');
INSERT INTO `access_log` VALUES (13313, '65.46.15590558663708767', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:04:26', 501, 1002001012, '访问令牌已过期', '2019-05-28 23:04:27');
INSERT INTO `access_log` VALUES (13314, '65.53.15590558782918763', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:04:38', 106, 0, '', '2019-05-28 23:04:38');
INSERT INTO `access_log` VALUES (13315, '65.48.15590558797248785', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:04:40', 10, 0, '', '2019-05-28 23:04:40');
INSERT INTO `access_log` VALUES (13316, '65.52.15590558797268773', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:04:40', 10, 0, '', '2019-05-28 23:04:40');
INSERT INTO `access_log` VALUES (13317, '65.45.15590558797298787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:04:40', 9, 0, '', '2019-05-28 23:04:40');
INSERT INTO `access_log` VALUES (13318, '62.88.15590558839659365', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:04:44', 22, 0, '', '2019-05-28 23:04:44');
INSERT INTO `access_log` VALUES (13319, '62.85.15590558863069361', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:04:46', 39, 0, '', '2019-05-28 23:04:46');
INSERT INTO `access_log` VALUES (13320, '59.72.15590558982039433', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:04:58', 14, 0, '', '2019-05-28 23:04:58');
INSERT INTO `access_log` VALUES (13321, '65.49.15590559021808779', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:02', 1007, 0, '', '2019-05-28 23:05:03');
INSERT INTO `access_log` VALUES (13322, '59.76.15590559051189433', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:05', 616, 0, '', '2019-05-28 23:05:06');
INSERT INTO `access_log` VALUES (13323, '59.75.15590559234879439', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:23', 13, 2001001000, '服务端发生异常', '2019-05-28 23:05:24');
INSERT INTO `access_log` VALUES (13324, '59.71.15590559234879439', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:23', 820, 0, '', '2019-05-28 23:05:24');
INSERT INTO `access_log` VALUES (13325, '64.80.15590559296598745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:30', 4, 0, '', '2019-05-28 23:05:30');
INSERT INTO `access_log` VALUES (13326, '64.77.15590559297808751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:30', 2, 0, '', '2019-05-28 23:05:30');
INSERT INTO `access_log` VALUES (13327, '64.82.15590559314958757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:31', 2, 0, '', '2019-05-28 23:05:31');
INSERT INTO `access_log` VALUES (13328, '64.85.15590559320648753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:32', 2, 0, '', '2019-05-28 23:05:32');
INSERT INTO `access_log` VALUES (13329, '64.76.15590559354768751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:35', 2, 0, '', '2019-05-28 23:05:35');
INSERT INTO `access_log` VALUES (13330, '64.78.15590559355578755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:36', 3, 0, '', '2019-05-28 23:05:36');
INSERT INTO `access_log` VALUES (13331, '59.74.15590559372339441', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:37', 4, 0, '', '2019-05-28 23:05:37');
INSERT INTO `access_log` VALUES (13332, '59.77.15590559372339439', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:37', 13, 2001001000, '服务端发生异常', '2019-05-28 23:05:37');
INSERT INTO `access_log` VALUES (13333, '64.79.15590559520228747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:52', 2, 0, '', '2019-05-28 23:05:52');
INSERT INTO `access_log` VALUES (13334, '64.81.15590559521028747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:52', 2, 0, '', '2019-05-28 23:05:52');
INSERT INTO `access_log` VALUES (13335, '59.72.15590559526269435', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:53', 4, 0, '', '2019-05-28 23:05:53');
INSERT INTO `access_log` VALUES (13336, '59.80.15590559526269439', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:53', 13, 2001001000, '服务端发生异常', '2019-05-28 23:05:53');
INSERT INTO `access_log` VALUES (13337, '64.80.15590559553018747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:55', 3, 0, '', '2019-05-28 23:05:55');
INSERT INTO `access_log` VALUES (13338, '64.77.15590559553798753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:55', 2, 0, '', '2019-05-28 23:05:55');
INSERT INTO `access_log` VALUES (13339, '59.76.15590559564249435', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:56', 3, 0, '', '2019-05-28 23:05:56');
INSERT INTO `access_log` VALUES (13340, '59.73.15590559564259443', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.116.228', '2019-05-28 23:05:56', 14, 2001001000, '服务端发生异常', '2019-05-28 23:05:56');
INSERT INTO `access_log` VALUES (13341, '65.46.15590561969788773', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 23:09:57', 11, 0, '', '2019-05-28 23:09:57');
INSERT INTO `access_log` VALUES (13342, '65.54.15590561969788767', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 23:09:57', 11, 0, '', '2019-05-28 23:09:57');
INSERT INTO `access_log` VALUES (13343, '65.47.15590561971198793', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 23:09:57', 8, 0, '', '2019-05-28 23:09:57');
INSERT INTO `access_log` VALUES (13344, '65.53.15590561972238769', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 23:09:57', 19, 0, '', '2019-05-28 23:09:57');
INSERT INTO `access_log` VALUES (13345, '65.51.15590562065048781', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 23:10:07', 9, 0, '', '2019-05-28 23:10:07');
INSERT INTO `access_log` VALUES (13346, '65.48.15590562065078791', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 23:10:07', 8, 0, '', '2019-05-28 23:10:07');
INSERT INTO `access_log` VALUES (13347, '65.52.15590562065128779', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 23:10:07', 9, 0, '', '2019-05-28 23:10:07');
INSERT INTO `access_log` VALUES (13348, '65.49.15590562267178785', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 23:10:27', 10, 0, '', '2019-05-28 23:10:27');
INSERT INTO `access_log` VALUES (13349, '65.46.15590562267218775', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 23:10:27', 10, 0, '', '2019-05-28 23:10:27');
INSERT INTO `access_log` VALUES (13350, '65.54.15590562267228769', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.61.223', '2019-05-28 23:10:27', 9, 0, '', '2019-05-28 23:10:27');
INSERT INTO `access_log` VALUES (13351, '4dab2596-3cd7-4641-b8ae-e51fbc56ee87', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-29 08:26:47', 663, 0, '', '2019-05-29 08:26:47');
INSERT INTO `access_log` VALUES (13352, 'e0e28e6b-2777-48bd-b29a-dcdabf047e9c', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-29 08:26:47', 998, 0, '', '2019-05-29 08:26:48');
INSERT INTO `access_log` VALUES (13353, '124403e0-8b4b-4b78-88fd-5e155abe7113', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-29 08:27:01', 174, 0, '', '2019-05-29 08:27:02');
INSERT INTO `access_log` VALUES (13354, '51cfd01d-98a9-4515-9cea-557b63e8e05c', 0, 1, 'order-application', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-29 08:27:01', 299, 0, '', '2019-05-29 08:27:02');
INSERT INTO `access_log` VALUES (13355, '930d13d6-6a48-45a1-b7cb-45fa0e2b5dca', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-29 08:27:02', 361, 0, '', '2019-05-29 08:27:02');
INSERT INTO `access_log` VALUES (13356, '59.78.15590915868149919', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 08:59:47', 21, 0, '', '2019-05-29 08:59:47');
INSERT INTO `access_log` VALUES (13357, '59.72.15590915868189911', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 08:59:47', 33, 2001001000, '服务端发生异常', '2019-05-29 08:59:47');
INSERT INTO `access_log` VALUES (13358, '64.79.15590915918069223', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 08:59:52', 35, 0, '', '2019-05-29 08:59:52');
INSERT INTO `access_log` VALUES (13359, '64.81.15590915919859223', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 08:59:52', 4, 0, '', '2019-05-29 08:59:52');
INSERT INTO `access_log` VALUES (13360, '59.76.15590915935119911', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 08:59:54', 4, 0, '', '2019-05-29 08:59:54');
INSERT INTO `access_log` VALUES (13361, '59.73.15590915935099919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 08:59:54', 22, 2001001000, '服务端发生异常', '2019-05-29 08:59:54');
INSERT INTO `access_log` VALUES (13362, '59.71.15590916020019917', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 09:00:02', 3, 0, '', '2019-05-29 09:00:02');
INSERT INTO `access_log` VALUES (13363, '59.75.15590916020039917', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 09:00:02', 35, 2001001000, '服务端发生异常', '2019-05-29 09:00:02');
INSERT INTO `access_log` VALUES (13364, '65.46.15590916172959249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 09:00:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 09:00:17');
INSERT INTO `access_log` VALUES (13365, '65.54.15590916233379241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 09:00:23', 100, 0, '', '2019-05-29 09:00:23');
INSERT INTO `access_log` VALUES (13366, '65.47.15590916237409269', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 09:00:24', 71, 0, '', '2019-05-29 09:00:24');
INSERT INTO `access_log` VALUES (13367, '65.49.15590916237479257', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 09:00:24', 66, 0, '', '2019-05-29 09:00:24');
INSERT INTO `access_log` VALUES (13368, '65.48.15590916237479265', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 09:00:24', 67, 0, '', '2019-05-29 09:00:24');
INSERT INTO `access_log` VALUES (13369, '65.52.15590916439819255', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 09:00:44', 22, 0, '', '2019-05-29 09:00:44');
INSERT INTO `access_log` VALUES (13370, '65.45.15590916473829267', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 09:00:47', 11, 0, '', '2019-05-29 09:00:47');
INSERT INTO `access_log` VALUES (13371, '65.50.15590916527889261', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 09:00:53', 10, 0, '', '2019-05-29 09:00:53');
INSERT INTO `access_log` VALUES (13372, '65.49.15590916733979259', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.164.98', '2019-05-29 09:01:13', 14, 0, '', '2019-05-29 09:01:13');
INSERT INTO `access_log` VALUES (13373, '65.51.15590930690049277', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:24:29', 1, 1002001015, '账号未登陆', '2019-05-29 09:24:29');
INSERT INTO `access_log` VALUES (13374, '65.53.15590930690039265', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:24:29', 1, 1002001015, '账号未登陆', '2019-05-29 09:24:29');
INSERT INTO `access_log` VALUES (13375, '65.52.15590930690089275', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:24:29', 0, 1002001015, '账号未登陆', '2019-05-29 09:24:29');
INSERT INTO `access_log` VALUES (13376, '65.45.15590930714219289', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:24:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 09:24:31');
INSERT INTO `access_log` VALUES (13377, '65.54.15590931030889265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:25:03', 78, 0, '', '2019-05-29 09:25:03');
INSERT INTO `access_log` VALUES (13378, '65.47.15590931034499291', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:25:03', 12, 0, '', '2019-05-29 09:25:03');
INSERT INTO `access_log` VALUES (13379, '65.49.15590931034479279', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:25:03', 16, 0, '', '2019-05-29 09:25:03');
INSERT INTO `access_log` VALUES (13380, '65.48.15590931034569289', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:25:03', 10, 0, '', '2019-05-29 09:25:03');
INSERT INTO `access_log` VALUES (13381, '62.82.15590931200169865', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:25:20', 23, 0, '', '2019-05-29 09:25:20');
INSERT INTO `access_log` VALUES (13382, '62.89.15590931449899861', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:25:45', 14, 0, '', '2019-05-29 09:25:45');
INSERT INTO `access_log` VALUES (13383, '62.81.15590931504229851', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:25:50', 13, 0, '', '2019-05-29 09:25:50');
INSERT INTO `access_log` VALUES (13384, '64.76.15590931548259249', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:25:55', 63, 0, '', '2019-05-29 09:25:55');
INSERT INTO `access_log` VALUES (13385, '64.83.15590931548259247', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:25:55', 65, 0, '', '2019-05-29 09:25:55');
INSERT INTO `access_log` VALUES (13386, '64.84.15590931595809253', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:26:00', 17, 0, '', '2019-05-29 09:26:00');
INSERT INTO `access_log` VALUES (13387, '64.78.15590931595809253', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:26:00', 19, 0, '', '2019-05-29 09:26:00');
INSERT INTO `access_log` VALUES (13388, '64.80.15590931946309245', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:26:35', 12, 0, '', '2019-05-29 09:26:35');
INSERT INTO `access_log` VALUES (13389, '64.82.15590931996829257', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:26:40', 10, 0, '', '2019-05-29 09:26:40');
INSERT INTO `access_log` VALUES (13390, '59.75.15590932272489939', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:27:07', 17, 0, '', '2019-05-29 09:27:07');
INSERT INTO `access_log` VALUES (13391, '59.77.15590932416579939', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:27:22', 21, 0, '', '2019-05-29 09:27:22');
INSERT INTO `access_log` VALUES (13392, '59.78.15590932542009943', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:27:34', 23, 0, '', '2019-05-29 09:27:34');
INSERT INTO `access_log` VALUES (13393, '59.72.15590932614439935', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:27:41', 13, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-29 09:27:41');
INSERT INTO `access_log` VALUES (13394, '65.52.15590932653129279', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:27:45', 20, 0, '', '2019-05-29 09:27:45');
INSERT INTO `access_log` VALUES (13395, '65.45.15590932780809293', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:27:58', 118, 0, '', '2019-05-29 09:27:58');
INSERT INTO `access_log` VALUES (13396, '65.50.15590932887709285', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:28:09', 12, 0, '', '2019-05-29 09:28:09');
INSERT INTO `access_log` VALUES (13397, '65.54.15590932933619269', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:28:13', 9, 0, '', '2019-05-29 09:28:13');
INSERT INTO `access_log` VALUES (13398, '65.50.15590933978529287', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:29:58', 4, 1002001012, '访问令牌已过期', '2019-05-29 09:29:58');
INSERT INTO `access_log` VALUES (13399, '65.54.15590933978549271', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:29:58', 3, 1002001012, '访问令牌已过期', '2019-05-29 09:29:58');
INSERT INTO `access_log` VALUES (13400, '65.46.15590933978539277', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:29:58', 4, 1002001012, '访问令牌已过期', '2019-05-29 09:29:58');
INSERT INTO `access_log` VALUES (13401, '65.49.15590934026619285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:03', 89, 0, '', '2019-05-29 09:30:03');
INSERT INTO `access_log` VALUES (13402, '65.48.15590934030119295', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:03', 10, 0, '', '2019-05-29 09:30:03');
INSERT INTO `access_log` VALUES (13403, '65.47.15590934030159297', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:03', 9, 0, '', '2019-05-29 09:30:03');
INSERT INTO `access_log` VALUES (13404, '65.51.15590934030169285', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:03', 9, 0, '', '2019-05-29 09:30:03');
INSERT INTO `access_log` VALUES (13405, '65.53.15590934059419273', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:06', 2589, 0, '', '2019-05-29 09:30:09');
INSERT INTO `access_log` VALUES (13406, '65.52.15590934052529283', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:05', 3657, 0, '', '2019-05-29 09:30:09');
INSERT INTO `access_log` VALUES (13407, '65.50.15590934090819289', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:09', 303, 0, '', '2019-05-29 09:30:09');
INSERT INTO `access_log` VALUES (13408, '65.54.15590934167469273', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:17', 11, 0, '', '2019-05-29 09:30:17');
INSERT INTO `access_log` VALUES (13409, '65.46.15590934187859279', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:19', 12, 0, '', '2019-05-29 09:30:19');
INSERT INTO `access_log` VALUES (13410, '65.49.15590934209039287', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=8', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:21', 11, 0, '', '2019-05-29 09:30:21');
INSERT INTO `access_log` VALUES (13411, '65.47.15590934257459299', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:26', 17, 0, '', '2019-05-29 09:30:26');
INSERT INTO `access_log` VALUES (13412, '65.48.15590934268719297', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:27', 18, 0, '', '2019-05-29 09:30:27');
INSERT INTO `access_log` VALUES (13413, '65.53.15590934286189275', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:29', 19, 0, '', '2019-05-29 09:30:29');
INSERT INTO `access_log` VALUES (13414, '65.45.15590934343369299', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:34', 12, 0, '', '2019-05-29 09:30:34');
INSERT INTO `access_log` VALUES (13415, '65.52.15590934363209285', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:36', 13, 0, '', '2019-05-29 09:30:36');
INSERT INTO `access_log` VALUES (13416, '65.54.15590934463659275', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:46', 9, 0, '', '2019-05-29 09:30:46');
INSERT INTO `access_log` VALUES (13417, '65.46.15590934463679281', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:46', 8, 0, '', '2019-05-29 09:30:46');
INSERT INTO `access_log` VALUES (13418, '65.49.15590934463699289', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:46', 9, 0, '', '2019-05-29 09:30:46');
INSERT INTO `access_log` VALUES (13419, '65.51.15590934465349289', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:30:47', 18, 0, '', '2019-05-29 09:30:47');
INSERT INTO `access_log` VALUES (13420, '65.48.15590934631489299', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:31:03', 12, 0, '', '2019-05-29 09:31:03');
INSERT INTO `access_log` VALUES (13421, '65.53.15590934665389277', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:31:07', 13, 0, '', '2019-05-29 09:31:07');
INSERT INTO `access_log` VALUES (13422, '65.45.15590934688489301', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=9', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:31:09', 10, 0, '', '2019-05-29 09:31:09');
INSERT INTO `access_log` VALUES (13423, '65.50.15590934718079293', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:31:12', 11, 0, '', '2019-05-29 09:31:12');
INSERT INTO `access_log` VALUES (13424, '65.51.15590935278179291', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:32:08', 12, 0, '', '2019-05-29 09:32:08');
INSERT INTO `access_log` VALUES (13425, '65.46.15590936087779285', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:33:29', 11, 0, '', '2019-05-29 09:33:29');
INSERT INTO `access_log` VALUES (13426, '65.54.15590936113119279', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:33:31', 13, 0, '', '2019-05-29 09:33:31');
INSERT INTO `access_log` VALUES (13427, '65.49.15590936127669293', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:33:33', 12, 0, '', '2019-05-29 09:33:33');
INSERT INTO `access_log` VALUES (13428, '65.51.15590936144059293', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:33:34', 12, 0, '', '2019-05-29 09:33:34');
INSERT INTO `access_log` VALUES (13429, '65.48.15590936208069303', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:33:41', 12, 0, '', '2019-05-29 09:33:41');
INSERT INTO `access_log` VALUES (13430, '65.53.15590936232629281', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:33:43', 15, 0, '', '2019-05-29 09:33:43');
INSERT INTO `access_log` VALUES (13431, '65.54.15590941359779287', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:42:16', 10, 0, '', '2019-05-29 09:42:16');
INSERT INTO `access_log` VALUES (13432, '65.49.15590941359799301', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:42:16', 10, 0, '', '2019-05-29 09:42:16');
INSERT INTO `access_log` VALUES (13433, '65.51.15590941359939301', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:42:16', 11, 0, '', '2019-05-29 09:42:16');
INSERT INTO `access_log` VALUES (13434, '65.47.15590941360479313', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:42:16', 16, 0, '', '2019-05-29 09:42:16');
INSERT INTO `access_log` VALUES (13435, '65.48.15590941414989311', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:42:21', 10, 0, '', '2019-05-29 09:42:22');
INSERT INTO `access_log` VALUES (13436, '65.53.15590941415019289', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:42:22', 10, 0, '', '2019-05-29 09:42:22');
INSERT INTO `access_log` VALUES (13437, '65.45.15590941415029313', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:42:22', 9, 0, '', '2019-05-29 09:42:22');
INSERT INTO `access_log` VALUES (13438, '65.52.15590941415449299', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:42:22', 9, 0, '', '2019-05-29 09:42:22');
INSERT INTO `access_log` VALUES (13439, '65.52.15590942683409301', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:44:28', 10, 0, '', '2019-05-29 09:44:28');
INSERT INTO `access_log` VALUES (13440, '65.50.15590942701569307', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:44:30', 9, 0, '', '2019-05-29 09:44:30');
INSERT INTO `access_log` VALUES (13441, '65.46.15590942708869297', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:44:31', 19, 0, '', '2019-05-29 09:44:31');
INSERT INTO `access_log` VALUES (13442, '59.74.15590942715919955', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:44:32', 13, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-29 09:44:32');
INSERT INTO `access_log` VALUES (13443, '59.78.15590942723339957', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.222.181', '2019-05-29 09:44:32', 14, 0, '', '2019-05-29 09:44:32');
INSERT INTO `access_log` VALUES (13444, '65.48.15590944978989319', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:48:18', 0, 1002001015, '账号未登陆', '2019-05-29 09:48:18');
INSERT INTO `access_log` VALUES (13445, '65.47.15590944978989321', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:48:18', 1, 1002001015, '账号未登陆', '2019-05-29 09:48:18');
INSERT INTO `access_log` VALUES (13446, '65.45.15590944979099319', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:48:18', 0, 1002001015, '账号未登陆', '2019-05-29 09:48:18');
INSERT INTO `access_log` VALUES (13447, '65.50.15590945262899313', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:48:46', 124, 0, '', '2019-05-29 09:48:46');
INSERT INTO `access_log` VALUES (13448, '65.54.15590945270619295', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:48:47', 11, 0, '', '2019-05-29 09:48:47');
INSERT INTO `access_log` VALUES (13449, '65.46.15590945270609301', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:48:47', 10, 0, '', '2019-05-29 09:48:47');
INSERT INTO `access_log` VALUES (13450, '65.51.15590945270639311', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:48:47', 10, 0, '', '2019-05-29 09:48:47');
INSERT INTO `access_log` VALUES (13451, '65.49.15590945333289309', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:48:53', 19, 0, '', '2019-05-29 09:48:53');
INSERT INTO `access_log` VALUES (13452, '65.53.15590945730479299', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:49:33', 10, 0, '', '2019-05-29 09:49:33');
INSERT INTO `access_log` VALUES (13453, '65.50.15590945818229315', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:49:42', 12, 0, '', '2019-05-29 09:49:42');
INSERT INTO `access_log` VALUES (13454, '65.54.15590945841329297', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:49:44', 10, 0, '', '2019-05-29 09:49:44');
INSERT INTO `access_log` VALUES (13455, '65.46.15590945880319303', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:49:48', 1876, 0, '', '2019-05-29 09:49:50');
INSERT INTO `access_log` VALUES (13456, '65.51.15590945915599313', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 09:49:52', 9, 0, '', '2019-05-29 09:49:52');
INSERT INTO `access_log` VALUES (13457, '59.71.15590946316169959', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:50:32', 16, 0, '', '2019-05-29 09:50:32');
INSERT INTO `access_log` VALUES (13458, '66.53.15590946412408941', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:50:41', 23, 0, '', '2019-05-29 09:50:41');
INSERT INTO `access_log` VALUES (13459, '64.81.15590946463279265', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:50:46', 11, 0, '', '2019-05-29 09:50:46');
INSERT INTO `access_log` VALUES (13460, '64.80.15590946463329265', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.164.79.243', '2019-05-29 09:50:46', 12, 0, '', '2019-05-29 09:50:46');
INSERT INTO `access_log` VALUES (13461, '65.49.15590969747819343', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:29:35', 11, 1002001012, '访问令牌已过期', '2019-05-29 10:29:35');
INSERT INTO `access_log` VALUES (13462, '65.51.15590969747769345', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:29:35', 13, 1002001012, '访问令牌已过期', '2019-05-29 10:29:35');
INSERT INTO `access_log` VALUES (13463, '65.48.15590969747949355', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:29:35', 13, 1002001012, '访问令牌已过期', '2019-05-29 10:29:35');
INSERT INTO `access_log` VALUES (13464, '65.45.15590969823369355', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:29:42', 62, 0, '', '2019-05-29 10:29:42');
INSERT INTO `access_log` VALUES (13465, '65.53.15590969826409333', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:29:43', 11, 0, '', '2019-05-29 10:29:43');
INSERT INTO `access_log` VALUES (13466, '65.52.15590969826419341', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:29:43', 11, 0, '', '2019-05-29 10:29:43');
INSERT INTO `access_log` VALUES (13467, '65.50.15590969826449349', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:29:43', 11, 0, '', '2019-05-29 10:29:43');
INSERT INTO `access_log` VALUES (13468, '65.54.15590969847439331', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:29:45', 21, 0, '', '2019-05-29 10:29:45');
INSERT INTO `access_log` VALUES (13469, '65.46.15590969861829337', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:29:46', 566, 0, '', '2019-05-29 10:29:47');
INSERT INTO `access_log` VALUES (13470, '65.49.15590969905309345', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:29:51', 21, 0, '', '2019-05-29 10:29:51');
INSERT INTO `access_log` VALUES (13471, '59.73.15590970012359993', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:30:01', 21, 0, '', '2019-05-29 10:30:01');
INSERT INTO `access_log` VALUES (13472, '62.80.15590970300019915', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:30:30', 24, 0, '', '2019-05-29 10:30:30');
INSERT INTO `access_log` VALUES (13473, '62.82.15590975278579925', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:38:48', 79, 0, '', '2019-05-29 10:38:48');
INSERT INTO `access_log` VALUES (13474, '62.83.15590975287649927', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:38:49', 14, 0, '', '2019-05-29 10:38:49');
INSERT INTO `access_log` VALUES (13475, '62.86.15590975293949911', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=4&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:38:49', 15, 0, '', '2019-05-29 10:38:49');
INSERT INTO `access_log` VALUES (13476, '62.89.15590975307719921', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=5&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:38:51', 13, 0, '', '2019-05-29 10:38:51');
INSERT INTO `access_log` VALUES (13477, '62.80.15590975527309923', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=101', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:39:13', 13, 0, '', '2019-05-29 10:39:13');
INSERT INTO `access_log` VALUES (13478, '62.88.15590975554139927', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=200', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:39:15', 16, 0, '', '2019-05-29 10:39:15');
INSERT INTO `access_log` VALUES (13479, '62.85.15590975572369923', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:39:17', 13, 0, '', '2019-05-29 10:39:17');
INSERT INTO `access_log` VALUES (13480, '62.87.15590975590759931', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=9999', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:39:19', 11, 0, '', '2019-05-29 10:39:19');
INSERT INTO `access_log` VALUES (13481, '62.82.15590975610429927', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=200', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:39:21', 180, 0, '', '2019-05-29 10:39:21');
INSERT INTO `access_log` VALUES (13482, '62.86.15590975631479913', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:39:23', 13, 0, '', '2019-05-29 10:39:23');
INSERT INTO `access_log` VALUES (13483, '59.73.15590975690320001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-29 10:39:29', 5, 0, '', '2019-05-29 10:39:29');
INSERT INTO `access_log` VALUES (13484, '59.76.15590975690309993', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-29 10:39:29', 14, 2001001000, '服务端发生异常', '2019-05-29 10:39:29');
INSERT INTO `access_log` VALUES (13485, '64.84.15590975716849313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-29 10:39:32', 11, 0, '', '2019-05-29 10:39:32');
INSERT INTO `access_log` VALUES (13486, '64.78.15590975718029313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.93', '2019-05-29 10:39:32', 3, 0, '', '2019-05-29 10:39:32');
INSERT INTO `access_log` VALUES (13487, '62.81.15590975782699913', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=9999', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:39:38', 42, 0, '', '2019-05-29 10:39:38');
INSERT INTO `access_log` VALUES (13488, '65.49.15590984670009365', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:54:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 10:54:27');
INSERT INTO `access_log` VALUES (13489, '65.51.15590984745759367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:54:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 10:54:35');
INSERT INTO `access_log` VALUES (13490, '65.47.15590984855629379', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 10:54:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 10:54:46');
INSERT INTO `access_log` VALUES (13491, '59.74.15590991108480021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.2', '2019-05-29 11:05:11', 6, 0, '', '2019-05-29 11:05:11');
INSERT INTO `access_log` VALUES (13492, '59.77.15590991108470019', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.2', '2019-05-29 11:05:11', 14, 2001001000, '服务端发生异常', '2019-05-29 11:05:11');
INSERT INTO `access_log` VALUES (13493, '64.82.15590991252729337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '103.88.46.2', '2019-05-29 11:05:25', 4, 0, '', '2019-05-29 11:05:25');
INSERT INTO `access_log` VALUES (13494, '64.85.15590991255589333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '103.88.46.2', '2019-05-29 11:05:26', 2, 0, '', '2019-05-29 11:05:26');
INSERT INTO `access_log` VALUES (13495, '64.83.15590991335379329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '103.88.46.2', '2019-05-29 11:05:34', 3, 0, '', '2019-05-29 11:05:34');
INSERT INTO `access_log` VALUES (13496, '64.76.15590991338289331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '103.88.46.2', '2019-05-29 11:05:34', 3, 0, '', '2019-05-29 11:05:34');
INSERT INTO `access_log` VALUES (13497, '59.80.15590991342230019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '103.88.46.2', '2019-05-29 11:05:34', 4, 0, '', '2019-05-29 11:05:34');
INSERT INTO `access_log` VALUES (13498, '59.73.15590991342240023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '103.88.46.2', '2019-05-29 11:05:34', 13, 2001001000, '服务端发生异常', '2019-05-29 11:05:34');
INSERT INTO `access_log` VALUES (13499, '65.51.15590996436689383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:14:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 11:14:04');
INSERT INTO `access_log` VALUES (13500, '65.47.15590996611909395', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:14:21', 61, 0, '', '2019-05-29 11:14:21');
INSERT INTO `access_log` VALUES (13501, '65.45.15590996615239393', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:14:22', 14, 0, '', '2019-05-29 11:14:22');
INSERT INTO `access_log` VALUES (13502, '65.53.15590996615239371', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:14:22', 16, 0, '', '2019-05-29 11:14:22');
INSERT INTO `access_log` VALUES (13503, '65.50.15590996615249387', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:14:22', 14, 0, '', '2019-05-29 11:14:22');
INSERT INTO `access_log` VALUES (13504, '65.54.15590996729789369', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:14:33', 12, 0, '', '2019-05-29 11:14:33');
INSERT INTO `access_log` VALUES (13505, '65.46.15590996729819375', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:14:33', 9, 0, '', '2019-05-29 11:14:33');
INSERT INTO `access_log` VALUES (13506, '65.49.15590996729859383', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:14:33', 9, 0, '', '2019-05-29 11:14:33');
INSERT INTO `access_log` VALUES (13507, '65.48.15590996836499395', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:14:44', 10, 0, '', '2019-05-29 11:14:44');
INSERT INTO `access_log` VALUES (13508, '65.45.15590996836509395', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:14:44', 9, 0, '', '2019-05-29 11:14:44');
INSERT INTO `access_log` VALUES (13509, '65.47.15590996836509397', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:14:44', 14, 0, '', '2019-05-29 11:14:44');
INSERT INTO `access_log` VALUES (13510, '65.50.15590996962049389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:14:56', 10, 0, '', '2019-05-29 11:14:56');
INSERT INTO `access_log` VALUES (13511, '65.52.15590996962059381', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:14:56', 9, 0, '', '2019-05-29 11:14:56');
INSERT INTO `access_log` VALUES (13512, '65.54.15590996962069371', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:14:56', 10, 0, '', '2019-05-29 11:14:56');
INSERT INTO `access_log` VALUES (13513, '65.46.15590997156219377', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:15:16', 19, 0, '', '2019-05-29 11:15:16');
INSERT INTO `access_log` VALUES (13514, '65.51.15590997226159387', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:15:23', 10, 0, '', '2019-05-29 11:15:23');
INSERT INTO `access_log` VALUES (13515, '65.48.15590998880719399', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:18:08', 10, 0, '', '2019-05-29 11:18:08');
INSERT INTO `access_log` VALUES (13516, '65.52.15590999235379385', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 11:18:44', 11, 0, '', '2019-05-29 11:18:44');
INSERT INTO `access_log` VALUES (13517, '59.74.15591009859250047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.107.7.204', '2019-05-29 11:36:26', 42, 0, '', '2019-05-29 11:36:26');
INSERT INTO `access_log` VALUES (13518, '59.79.15591009859250043', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.107.7.204', '2019-05-29 11:36:26', 42, 2001001000, '服务端发生异常', '2019-05-29 11:36:26');
INSERT INTO `access_log` VALUES (13519, '59.73.15591055284330109', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.130.102', '2019-05-29 12:52:08', 12, 0, '', '2019-05-29 12:52:08');
INSERT INTO `access_log` VALUES (13520, '59.80.15591055284360105', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.130.102', '2019-05-29 12:52:08', 20, 2001001000, '服务端发生异常', '2019-05-29 12:52:08');
INSERT INTO `access_log` VALUES (13521, '64.85.15591055378259419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.130.102', '2019-05-29 12:52:18', 12, 0, '', '2019-05-29 12:52:18');
INSERT INTO `access_log` VALUES (13522, '64.83.15591055382109415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.130.102', '2019-05-29 12:52:18', 3, 0, '', '2019-05-29 12:52:18');
INSERT INTO `access_log` VALUES (13523, '64.76.15591055399969417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.130.102', '2019-05-29 12:52:20', 2, 0, '', '2019-05-29 12:52:20');
INSERT INTO `access_log` VALUES (13524, '64.78.15591055406219421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.130.102', '2019-05-29 12:52:21', 2, 0, '', '2019-05-29 12:52:21');
INSERT INTO `access_log` VALUES (13525, '64.79.15591055484899413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.130.102', '2019-05-29 12:52:28', 2, 0, '', '2019-05-29 12:52:28');
INSERT INTO `access_log` VALUES (13526, '64.81.15591055485869413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.130.102', '2019-05-29 12:52:29', 2, 0, '', '2019-05-29 12:52:29');
INSERT INTO `access_log` VALUES (13527, '59.71.15591055486490107', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.130.102', '2019-05-29 12:52:29', 4, 0, '', '2019-05-29 12:52:29');
INSERT INTO `access_log` VALUES (13528, '59.75.15591055486640107', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.130.102', '2019-05-29 12:52:29', 12, 2001001000, '服务端发生异常', '2019-05-29 12:52:29');
INSERT INTO `access_log` VALUES (13529, '65.51.15591062528689475', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:04:13', 0, 1002001015, '账号未登陆', '2019-05-29 13:04:13');
INSERT INTO `access_log` VALUES (13530, '65.46.15591062528689465', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:04:13', 0, 1002001015, '账号未登陆', '2019-05-29 13:04:13');
INSERT INTO `access_log` VALUES (13531, '65.47.15591062528699487', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:04:13', 0, 1002001015, '账号未登陆', '2019-05-29 13:04:13');
INSERT INTO `access_log` VALUES (13532, '65.48.15591062545499485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:04:15', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 13:04:15');
INSERT INTO `access_log` VALUES (13533, '65.45.15591062588829485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:04:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 13:04:19');
INSERT INTO `access_log` VALUES (13534, '65.50.15591062696869479', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:04:30', 129, 0, '', '2019-05-29 13:04:30');
INSERT INTO `access_log` VALUES (13535, '65.52.15591062702339471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:04:30', 11, 0, '', '2019-05-29 13:04:30');
INSERT INTO `access_log` VALUES (13536, '65.54.15591062702379461', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:04:30', 10, 0, '', '2019-05-29 13:04:30');
INSERT INTO `access_log` VALUES (13537, '65.49.15591062702419475', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:04:30', 11, 0, '', '2019-05-29 13:04:30');
INSERT INTO `access_log` VALUES (13538, '62.84.15591062792580033', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:04:39', 23, 0, '', '2019-05-29 13:04:39');
INSERT INTO `access_log` VALUES (13539, '64.80.15591062834399423', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:04:43', 9, 0, '', '2019-05-29 13:04:43');
INSERT INTO `access_log` VALUES (13540, '64.81.15591062834359423', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:04:43', 14, 0, '', '2019-05-29 13:04:43');
INSERT INTO `access_log` VALUES (13541, '64.82.15591062901739435', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:04:50', 9, 0, '', '2019-05-29 13:04:50');
INSERT INTO `access_log` VALUES (13542, '64.77.15591062901699429', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:04:50', 15, 0, '', '2019-05-29 13:04:50');
INSERT INTO `access_log` VALUES (13543, '64.83.15591063035569427', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:05:04', 3046, 0, '', '2019-05-29 13:05:07');
INSERT INTO `access_log` VALUES (13544, '66.52.15591063196279093', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.192.161.32', '2019-05-29 13:05:20', 25, 0, '', '2019-05-29 13:05:20');
INSERT INTO `access_log` VALUES (13545, '59.71.15591079153880139', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:31:55', 13, 0, '', '2019-05-29 13:31:55');
INSERT INTO `access_log` VALUES (13546, '59.75.15591079153890139', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:31:55', 16, 2001001000, '服务端发生异常', '2019-05-29 13:31:55');
INSERT INTO `access_log` VALUES (13547, '65.51.15591079308649499', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:32:11', 1, 1002001015, '账号未登陆', '2019-05-29 13:32:11');
INSERT INTO `access_log` VALUES (13548, '65.47.15591079308649511', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:32:11', 1, 1002001015, '账号未登陆', '2019-05-29 13:32:11');
INSERT INTO `access_log` VALUES (13549, '65.48.15591079308669509', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:32:11', 0, 1002001015, '账号未登陆', '2019-05-29 13:32:11');
INSERT INTO `access_log` VALUES (13550, '65.45.15591079332139509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:32:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 13:32:13');
INSERT INTO `access_log` VALUES (13551, '65.53.15591079437999487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:32:24', 136, 0, '', '2019-05-29 13:32:24');
INSERT INTO `access_log` VALUES (13552, '65.52.15591079448319495', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:32:25', 122, 0, '', '2019-05-29 13:32:25');
INSERT INTO `access_log` VALUES (13553, '65.49.15591079448029499', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:32:25', 148, 0, '', '2019-05-29 13:32:25');
INSERT INTO `access_log` VALUES (13554, '65.54.15591079448309485', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:32:25', 122, 0, '', '2019-05-29 13:32:25');
INSERT INTO `access_log` VALUES (13555, '62.80.15591079542730067', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:32:34', 16, 0, '', '2019-05-29 13:32:34');
INSERT INTO `access_log` VALUES (13556, '64.78.15591079642059455', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:32:44', 11, 0, '', '2019-05-29 13:32:44');
INSERT INTO `access_log` VALUES (13557, '64.84.15591079642059455', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:32:44', 13, 0, '', '2019-05-29 13:32:44');
INSERT INTO `access_log` VALUES (13558, '66.57.15591079883149119', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:33:08', 17, 0, '', '2019-05-29 13:33:08');
INSERT INTO `access_log` VALUES (13559, '65.51.15591079888319501', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.174.74', '2019-05-29 13:33:09', 1, 1002001015, '账号未登陆', '2019-05-29 13:33:09');
INSERT INTO `access_log` VALUES (13560, '65.47.15591079888389513', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.173.34.245', '2019-05-29 13:33:09', 0, 1002001015, '账号未登陆', '2019-05-29 13:33:09');
INSERT INTO `access_log` VALUES (13561, '65.45.15591079888649511', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.174.74', '2019-05-29 13:33:09', 0, 1002001015, '账号未登陆', '2019-05-29 13:33:09');
INSERT INTO `access_log` VALUES (13562, '65.53.15591079928319489', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:33:13', 21, 0, '', '2019-05-29 13:33:13');
INSERT INTO `access_log` VALUES (13563, '65.49.15591079934809501', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.173.34.245', '2019-05-29 13:33:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 13:33:13');
INSERT INTO `access_log` VALUES (13564, '65.54.15591079945189487', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.212.197', '2019-05-29 13:33:15', 9, 0, '', '2019-05-29 13:33:15');
INSERT INTO `access_log` VALUES (13565, '65.52.15591079953389497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.173.34.245', '2019-05-29 13:33:15', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 13:33:15');
INSERT INTO `access_log` VALUES (13566, '65.48.15591080102729513', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.173.34.245', '2019-05-29 13:33:30', 133, 0, '', '2019-05-29 13:33:30');
INSERT INTO `access_log` VALUES (13567, '65.47.15591080106809515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.173.34.245', '2019-05-29 13:33:31', 9, 0, '', '2019-05-29 13:33:31');
INSERT INTO `access_log` VALUES (13568, '65.45.15591080106919513', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.173.34.245', '2019-05-29 13:33:31', 8, 0, '', '2019-05-29 13:33:31');
INSERT INTO `access_log` VALUES (13569, '65.51.15591080106959503', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.173.34.245', '2019-05-29 13:33:31', 9, 0, '', '2019-05-29 13:33:31');
INSERT INTO `access_log` VALUES (13570, '62.89.15591080168570067', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.173.34.245', '2019-05-29 13:33:37', 15, 0, '', '2019-05-29 13:33:37');
INSERT INTO `access_log` VALUES (13571, '64.77.15591080190629453', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.173.34.245', '2019-05-29 13:33:39', 12, 0, '', '2019-05-29 13:33:39');
INSERT INTO `access_log` VALUES (13572, '64.85.15591080190729455', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.173.34.245', '2019-05-29 13:33:39', 9, 0, '', '2019-05-29 13:33:39');
INSERT INTO `access_log` VALUES (13573, '59.76.15591080254440135', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.173.34.245', '2019-05-29 13:33:45', 16, 0, '', '2019-05-29 13:33:45');
INSERT INTO `access_log` VALUES (13574, '59.80.15591090324900153', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.219.198', '2019-05-29 13:50:32', 4, 0, '', '2019-05-29 13:50:32');
INSERT INTO `access_log` VALUES (13575, '59.73.15591090324890157', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.219.198', '2019-05-29 13:50:32', 20, 2001001000, '服务端发生异常', '2019-05-29 13:50:33');
INSERT INTO `access_log` VALUES (13576, '64.77.15591090396059467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.219.198', '2019-05-29 13:50:40', 4, 0, '', '2019-05-29 13:50:40');
INSERT INTO `access_log` VALUES (13577, '64.85.15591090402039469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.219.198', '2019-05-29 13:50:40', 2, 0, '', '2019-05-29 13:50:40');
INSERT INTO `access_log` VALUES (13578, '64.76.15591090424199467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.219.198', '2019-05-29 13:50:42', 3, 0, '', '2019-05-29 13:50:42');
INSERT INTO `access_log` VALUES (13579, '64.83.15591090434489465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.219.198', '2019-05-29 13:50:43', 3, 0, '', '2019-05-29 13:50:43');
INSERT INTO `access_log` VALUES (13580, '59.72.15591095747040157', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:35', 3, 0, '', '2019-05-29 13:59:35');
INSERT INTO `access_log` VALUES (13581, '59.73.15591095747250165', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:35', 14, 2001001000, '服务端发生异常', '2019-05-29 13:59:35');
INSERT INTO `access_log` VALUES (13582, '64.77.15591095797639475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:40', 3, 0, '', '2019-05-29 13:59:40');
INSERT INTO `access_log` VALUES (13583, '64.85.15591095798969477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:40', 3, 0, '', '2019-05-29 13:59:40');
INSERT INTO `access_log` VALUES (13584, '64.76.15591095810629475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:41', 2, 0, '', '2019-05-29 13:59:41');
INSERT INTO `access_log` VALUES (13585, '64.83.15591095817249473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:42', 3, 0, '', '2019-05-29 13:59:42');
INSERT INTO `access_log` VALUES (13586, '64.84.15591095823729479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:42', 3, 0, '', '2019-05-29 13:59:42');
INSERT INTO `access_log` VALUES (13587, '59.80.15591095836700161', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:44', 3, 0, '', '2019-05-29 13:59:44');
INSERT INTO `access_log` VALUES (13588, '59.76.15591095836720157', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:44', 14, 2001001000, '服务端发生异常', '2019-05-29 13:59:44');
INSERT INTO `access_log` VALUES (13589, '64.78.15591095855059479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:46', 3, 0, '', '2019-05-29 13:59:46');
INSERT INTO `access_log` VALUES (13590, '64.79.15591095856459471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:46', 2, 0, '', '2019-05-29 13:59:46');
INSERT INTO `access_log` VALUES (13591, '64.80.15591095865699471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:47', 3, 0, '', '2019-05-29 13:59:47');
INSERT INTO `access_log` VALUES (13592, '64.81.15591095871809471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:47', 2, 0, '', '2019-05-29 13:59:47');
INSERT INTO `access_log` VALUES (13593, '59.75.15591095887710163', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:49', 3, 0, '', '2019-05-29 13:59:49');
INSERT INTO `access_log` VALUES (13594, '59.71.15591095887710163', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:49', 14, 2001001000, '服务端发生异常', '2019-05-29 13:59:49');
INSERT INTO `access_log` VALUES (13595, '64.77.15591095906149477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:51', 106, 0, '', '2019-05-29 13:59:51');
INSERT INTO `access_log` VALUES (13596, '64.85.15591095908889479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:51', 3, 0, '', '2019-05-29 13:59:51');
INSERT INTO `access_log` VALUES (13597, '64.76.15591095921779477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:52', 2, 0, '', '2019-05-29 13:59:52');
INSERT INTO `access_log` VALUES (13598, '64.83.15591095925709475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:53', 3, 0, '', '2019-05-29 13:59:53');
INSERT INTO `access_log` VALUES (13599, '59.77.15591095935230163', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:54', 20, 2001001000, '服务端发生异常', '2019-05-29 13:59:54');
INSERT INTO `access_log` VALUES (13600, '59.79.15591095935200161', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '114.242.34.95', '2019-05-29 13:59:54', 119, 0, '', '2019-05-29 13:59:54');
INSERT INTO `access_log` VALUES (13601, '59.73.15591111277300187', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:28', 4, 0, '', '2019-05-29 14:25:28');
INSERT INTO `access_log` VALUES (13602, '59.76.15591111277710179', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:28', 18, 2001001000, '服务端发生异常', '2019-05-29 14:25:28');
INSERT INTO `access_log` VALUES (13603, '64.79.15591111332079493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:33', 3, 0, '', '2019-05-29 14:25:33');
INSERT INTO `access_log` VALUES (13604, '64.80.15591111333679493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:33', 2, 0, '', '2019-05-29 14:25:33');
INSERT INTO `access_log` VALUES (13605, '64.81.15591111346949493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:35', 3, 0, '', '2019-05-29 14:25:35');
INSERT INTO `access_log` VALUES (13606, '64.77.15591111356969499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:36', 3, 0, '', '2019-05-29 14:25:36');
INSERT INTO `access_log` VALUES (13607, '59.71.15591111364780185', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:36', 13, 2001001000, '服务端发生异常', '2019-05-29 14:25:36');
INSERT INTO `access_log` VALUES (13608, '59.75.15591111364930185', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:36', 356, 0, '', '2019-05-29 14:25:37');
INSERT INTO `access_log` VALUES (13609, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=非&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:41', 18, 0, '', '2019-05-29 14:25:41');
INSERT INTO `access_log` VALUES (13610, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=非', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:41', 10, 0, '', '2019-05-29 14:25:41');
INSERT INTO `access_log` VALUES (13611, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=啊&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:44', 7, 0, '', '2019-05-29 14:25:44');
INSERT INTO `access_log` VALUES (13612, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=啊', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:44', 7, 0, '', '2019-05-29 14:25:44');
INSERT INTO `access_log` VALUES (13613, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:47', 9, 0, '', '2019-05-29 14:25:48');
INSERT INTO `access_log` VALUES (13614, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:48', 9, 0, '', '2019-05-29 14:25:48');
INSERT INTO `access_log` VALUES (13615, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:48', 12, 0, '', '2019-05-29 14:25:48');
INSERT INTO `access_log` VALUES (13616, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:48', 14, 0, '', '2019-05-29 14:25:48');
INSERT INTO `access_log` VALUES (13617, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=sql&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:55', 8, 0, '', '2019-05-29 14:25:55');
INSERT INTO `access_log` VALUES (13618, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=sql', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:55', 7, 0, '', '2019-05-29 14:25:55');
INSERT INTO `access_log` VALUES (13619, '59.77.15591111589680185', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:59', 14, 2001001000, '服务端发生异常', '2019-05-29 14:25:59');
INSERT INTO `access_log` VALUES (13620, '59.79.15591111589820183', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-05-29 14:25:59', 169, 0, '', '2019-05-29 14:25:59');
INSERT INTO `access_log` VALUES (13621, '59.71.15591125812560205', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-29 14:49:41', 4, 0, '', '2019-05-29 14:49:41');
INSERT INTO `access_log` VALUES (13622, '59.75.15591125812560205', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-29 14:49:41', 13, 2001001000, '服务端发生异常', '2019-05-29 14:49:41');
INSERT INTO `access_log` VALUES (13623, '64.81.15591125979419513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-29 14:49:58', 3, 0, '', '2019-05-29 14:49:58');
INSERT INTO `access_log` VALUES (13624, '64.82.15591125984059525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-29 14:49:58', 3, 0, '', '2019-05-29 14:49:58');
INSERT INTO `access_log` VALUES (13625, '64.77.15591125995949519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-29 14:50:00', 3, 0, '', '2019-05-29 14:50:00');
INSERT INTO `access_log` VALUES (13626, '64.85.15591126006379521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-29 14:50:01', 2, 0, '', '2019-05-29 14:50:01');
INSERT INTO `access_log` VALUES (13627, '64.76.15591126012589519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-29 14:50:01', 3, 0, '', '2019-05-29 14:50:01');
INSERT INTO `access_log` VALUES (13628, '59.79.15591126021770203', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-29 14:50:02', 3, 0, '', '2019-05-29 14:50:02');
INSERT INTO `access_log` VALUES (13629, '59.77.15591126021890205', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-29 14:50:02', 13, 2001001000, '服务端发生异常', '2019-05-29 14:50:02');
INSERT INTO `access_log` VALUES (13630, '64.84.15591126056309523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-29 14:50:06', 2, 0, '', '2019-05-29 14:50:06');
INSERT INTO `access_log` VALUES (13631, '64.78.15591126057359523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-29 14:50:06', 3, 0, '', '2019-05-29 14:50:06');
INSERT INTO `access_log` VALUES (13632, '59.72.15591126075870201', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-29 14:50:08', 3, 0, '', '2019-05-29 14:50:08');
INSERT INTO `access_log` VALUES (13633, '59.73.15591126075870209', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.252.36.239', '2019-05-29 14:50:08', 13, 2001001000, '服务端发生异常', '2019-05-29 14:50:08');
INSERT INTO `access_log` VALUES (13634, '64.79.15591126140519515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-29 14:50:14', 2, 0, '', '2019-05-29 14:50:14');
INSERT INTO `access_log` VALUES (13635, '64.80.15591126141769515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-29 14:50:14', 3, 0, '', '2019-05-29 14:50:14');
INSERT INTO `access_log` VALUES (13636, '64.81.15591126175789515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-29 14:50:18', 109, 0, '', '2019-05-29 14:50:18');
INSERT INTO `access_log` VALUES (13637, '59.80.15591126272810205', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-29 14:50:27', 9, 0, '', '2019-05-29 14:50:27');
INSERT INTO `access_log` VALUES (13638, '59.75.15591126272810207', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.252.36.239', '2019-05-29 14:50:27', 20, 2001001000, '服务端发生异常', '2019-05-29 14:50:27');
INSERT INTO `access_log` VALUES (13639, '59.78.15591165792740263', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '61.160.9.46', '2019-05-29 15:56:19', 12, 0, '', '2019-05-29 15:56:19');
INSERT INTO `access_log` VALUES (13640, '59.72.15591165792740255', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '61.160.9.46', '2019-05-29 15:56:19', 16, 2001001000, '服务端发生异常', '2019-05-29 15:56:19');
INSERT INTO `access_log` VALUES (13641, '59.80.15591167462070261', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 15:59:06', 12, 2001001000, '服务端发生异常', '2019-05-29 15:59:06');
INSERT INTO `access_log` VALUES (13642, '59.76.15591167462050257', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 15:59:06', 817, 0, '', '2019-05-29 15:59:07');
INSERT INTO `access_log` VALUES (13643, '59.76.15591167462050257', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 15:59:06', 817, 0, '', '2019-05-29 15:59:08');
INSERT INTO `access_log` VALUES (13644, '59.75.15591167579110263', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 15:59:18', 3, 0, '', '2019-05-29 15:59:18');
INSERT INTO `access_log` VALUES (13645, '59.71.15591167579140263', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 15:59:18', 13, 2001001000, '服务端发生异常', '2019-05-29 15:59:18');
INSERT INTO `access_log` VALUES (13646, '64.79.15591167615609571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 15:59:22', 13, 0, '', '2019-05-29 15:59:22');
INSERT INTO `access_log` VALUES (13647, '64.80.15591167617039571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 15:59:22', 4, 0, '', '2019-05-29 15:59:22');
INSERT INTO `access_log` VALUES (13648, '64.81.15591167654519571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 15:59:25', 2, 0, '', '2019-05-29 15:59:25');
INSERT INTO `access_log` VALUES (13649, '64.82.15591167655829583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 15:59:26', 2, 0, '', '2019-05-29 15:59:26');
INSERT INTO `access_log` VALUES (13650, '59.79.15591167692180261', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 15:59:29', 3, 0, '', '2019-05-29 15:59:29');
INSERT INTO `access_log` VALUES (13651, '59.77.15591167692230263', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 15:59:29', 14, 2001001000, '服务端发生异常', '2019-05-29 15:59:29');
INSERT INTO `access_log` VALUES (13652, '65.45.15591168264839633', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 16:00:26', 0, 1002001015, '账号未登陆', '2019-05-29 16:00:26');
INSERT INTO `access_log` VALUES (13653, '65.51.15591168264839623', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 16:00:26', 0, 1002001015, '账号未登陆', '2019-05-29 16:00:26');
INSERT INTO `access_log` VALUES (13654, '65.47.15591168264859633', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 16:00:26', 1, 1002001015, '账号未登陆', '2019-05-29 16:00:26');
INSERT INTO `access_log` VALUES (13655, '65.50.15591168289099623', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 16:00:29', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 16:00:29');
INSERT INTO `access_log` VALUES (13656, '65.49.15591168425869623', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 16:00:43', 82, 0, '', '2019-05-29 16:00:43');
INSERT INTO `access_log` VALUES (13657, '65.54.15591168429499607', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 16:00:43', 11, 0, '', '2019-05-29 16:00:43');
INSERT INTO `access_log` VALUES (13658, '65.52.15591168429539619', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 16:00:43', 9, 0, '', '2019-05-29 16:00:43');
INSERT INTO `access_log` VALUES (13659, '65.46.15591168429659615', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 16:00:43', 9, 0, '', '2019-05-29 16:00:43');
INSERT INTO `access_log` VALUES (13660, '62.84.15591168527330179', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 16:00:53', 25, 0, '', '2019-05-29 16:00:53');
INSERT INTO `access_log` VALUES (13661, '66.50.15591168620279231', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.24.65.51', '2019-05-29 16:01:02', 282, 0, '', '2019-05-29 16:01:02');
INSERT INTO `access_log` VALUES (13662, '64.81.15591170198899575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.67.237', '2019-05-29 16:03:40', 10, 0, '', '2019-05-29 16:03:40');
INSERT INTO `access_log` VALUES (13663, '64.77.15591170200519581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.67.237', '2019-05-29 16:03:40', 7, 0, '', '2019-05-29 16:03:40');
INSERT INTO `access_log` VALUES (13664, '64.76.15591170211809581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.67.237', '2019-05-29 16:03:41', 7, 0, '', '2019-05-29 16:03:41');
INSERT INTO `access_log` VALUES (13665, '64.84.15591170216819585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.67.237', '2019-05-29 16:03:42', 8, 0, '', '2019-05-29 16:03:42');
INSERT INTO `access_log` VALUES (13666, '64.78.15591170225379585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.67.237', '2019-05-29 16:03:43', 8, 0, '', '2019-05-29 16:03:43');
INSERT INTO `access_log` VALUES (13667, '64.80.15591177821229587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:16:22', 63, 0, '', '2019-05-29 16:16:22');
INSERT INTO `access_log` VALUES (13668, '64.81.15591177824159587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:16:22', 2, 0, '', '2019-05-29 16:16:22');
INSERT INTO `access_log` VALUES (13669, '65.50.15591180972829641', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:21:37', 0, 1002001015, '账号未登陆', '2019-05-29 16:21:37');
INSERT INTO `access_log` VALUES (13670, '65.53.15591180972839627', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:21:37', 0, 1002001015, '账号未登陆', '2019-05-29 16:21:37');
INSERT INTO `access_log` VALUES (13671, '65.49.15591180972839641', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:21:37', 1, 1002001015, '账号未登陆', '2019-05-29 16:21:37');
INSERT INTO `access_log` VALUES (13672, '65.52.15591181011849635', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:21:41', 91, 0, '', '2019-05-29 16:21:41');
INSERT INTO `access_log` VALUES (13673, '65.46.15591181015639633', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:21:42', 10, 0, '', '2019-05-29 16:21:42');
INSERT INTO `access_log` VALUES (13674, '65.45.15591181015909653', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:21:42', 11, 0, '', '2019-05-29 16:21:42');
INSERT INTO `access_log` VALUES (13675, '65.48.15591181015909651', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:21:42', 12, 0, '', '2019-05-29 16:21:42');
INSERT INTO `access_log` VALUES (13676, '62.89.15591181203880203', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:22:00', 16, 0, '', '2019-05-29 16:22:00');
INSERT INTO `access_log` VALUES (13677, '62.84.15591181267510197', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=6&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:22:07', 148, 0, '', '2019-05-29 16:22:07');
INSERT INTO `access_log` VALUES (13678, '62.80.15591181307460205', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:22:11', 18, 0, '', '2019-05-29 16:22:11');
INSERT INTO `access_log` VALUES (13679, '64.76.15591181397409597', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:22:20', 13, 0, '', '2019-05-29 16:22:20');
INSERT INTO `access_log` VALUES (13680, '64.83.15591181397469595', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:22:20', 10, 0, '', '2019-05-29 16:22:20');
INSERT INTO `access_log` VALUES (13681, '59.73.15591181480620285', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:22:28', 16, 0, '', '2019-05-29 16:22:28');
INSERT INTO `access_log` VALUES (13682, '59.80.15591181511900281', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:22:31', 48, 0, '', '2019-05-29 16:22:31');
INSERT INTO `access_log` VALUES (13683, '64.78.15591181532409601', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:22:33', 9, 0, '', '2019-05-29 16:22:33');
INSERT INTO `access_log` VALUES (13684, '64.80.15591181650569593', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:22:45', 143, 0, '', '2019-05-29 16:22:45');
INSERT INTO `access_log` VALUES (13685, '65.50.15591181719809643', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:22:52', 20, 0, '', '2019-05-29 16:22:52');
INSERT INTO `access_log` VALUES (13686, '59.74.15591181963990285', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:23:16', 13, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-29 16:23:16');
INSERT INTO `access_log` VALUES (13687, '64.76.15591182076599599', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:23:28', 12, 0, '', '2019-05-29 16:23:28');
INSERT INTO `access_log` VALUES (13688, '64.85.15591182076579601', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:23:28', 15, 0, '', '2019-05-29 16:23:28');
INSERT INTO `access_log` VALUES (13689, '64.83.15591182091459597', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:23:29', 11, 0, '', '2019-05-29 16:23:29');
INSERT INTO `access_log` VALUES (13690, '64.84.15591182091459603', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:23:29', 11, 0, '', '2019-05-29 16:23:29');
INSERT INTO `access_log` VALUES (13691, '64.79.15591182112649595', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:23:31', 9, 0, '', '2019-05-29 16:23:31');
INSERT INTO `access_log` VALUES (13692, '64.78.15591182112639603', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:23:31', 13, 0, '', '2019-05-29 16:23:31');
INSERT INTO `access_log` VALUES (13693, '59.72.15591182148490279', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:23:35', 24, 2001001000, '服务端发生异常', '2019-05-29 16:23:35');
INSERT INTO `access_log` VALUES (13694, '66.51.15591182174229251', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:23:37', 17, 0, '', '2019-05-29 16:23:37');
INSERT INTO `access_log` VALUES (13695, '62.84.15591182248980199', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.98', '2019-05-29 16:23:45', 17, 0, '', '2019-05-29 16:23:45');
INSERT INTO `access_log` VALUES (13696, '59.72.15591183588530281', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:25:59', 4, 0, '', '2019-05-29 16:25:59');
INSERT INTO `access_log` VALUES (13697, '59.78.15591183588530289', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:25:59', 15, 2001001000, '服务端发生异常', '2019-05-29 16:25:59');
INSERT INTO `access_log` VALUES (13698, '64.81.15591183683309597', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:26:08', 6, 1003002003, 'Spu 只能添加在二级分类下', '2019-05-29 16:26:08');
INSERT INTO `access_log` VALUES (13699, '62.80.15591183691790209', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=20', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.99', '2019-05-29 16:26:09', 16, 0, '', '2019-05-29 16:26:09');
INSERT INTO `access_log` VALUES (13700, '64.82.15591183796699609', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:26:20', 4, 1003002003, 'Spu 只能添加在二级分类下', '2019-05-29 16:26:20');
INSERT INTO `access_log` VALUES (13701, '62.87.15591183994340215', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10&status=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.99', '2019-05-29 16:26:39', 13, 0, '', '2019-05-29 16:26:39');
INSERT INTO `access_log` VALUES (13702, '62.83.15591184024410215', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.99', '2019-05-29 16:26:42', 16, 0, '', '2019-05-29 16:26:42');
INSERT INTO `access_log` VALUES (13703, '62.86.15591184124670199', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=20&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '61.177.21.99', '2019-05-29 16:26:52', 17, 0, '', '2019-05-29 16:26:52');
INSERT INTO `access_log` VALUES (13704, '65.49.15591184224749647', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:02', 0, 1002001015, '账号未登陆', '2019-05-29 16:27:02');
INSERT INTO `access_log` VALUES (13705, '65.53.15591184224749633', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:02', 1, 1002001015, '账号未登陆', '2019-05-29 16:27:02');
INSERT INTO `access_log` VALUES (13706, '65.50.15591184224779647', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:02', 1, 1002001015, '账号未登陆', '2019-05-29 16:27:02');
INSERT INTO `access_log` VALUES (13707, '65.54.15591184244219631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 16:27:04');
INSERT INTO `access_log` VALUES (13708, '65.52.15591184283989641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:08', 82, 0, '', '2019-05-29 16:27:08');
INSERT INTO `access_log` VALUES (13709, '65.45.15591184289609659', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:09', 10, 0, '', '2019-05-29 16:27:09');
INSERT INTO `access_log` VALUES (13710, '65.48.15591184289599657', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:09', 11, 0, '', '2019-05-29 16:27:09');
INSERT INTO `access_log` VALUES (13711, '65.51.15591184289669649', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:09', 9, 0, '', '2019-05-29 16:27:09');
INSERT INTO `access_log` VALUES (13712, '64.83.15591184333389601', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:13', 12, 0, '', '2019-05-29 16:27:13');
INSERT INTO `access_log` VALUES (13713, '64.78.15591184333409607', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:13', 9, 0, '', '2019-05-29 16:27:13');
INSERT INTO `access_log` VALUES (13714, '64.80.15591184373329599', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:17', 10, 0, '', '2019-05-29 16:27:17');
INSERT INTO `access_log` VALUES (13715, '64.79.15591184373319599', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:17', 13, 0, '', '2019-05-29 16:27:17');
INSERT INTO `access_log` VALUES (13716, '62.84.15591184448550203', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:25', 14, 0, '', '2019-05-29 16:27:25');
INSERT INTO `access_log` VALUES (13717, '62.80.15591184465430211', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:27', 17, 0, '', '2019-05-29 16:27:27');
INSERT INTO `access_log` VALUES (13718, '64.77.15591184539249605', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:34', 9, 0, '', '2019-05-29 16:27:34');
INSERT INTO `access_log` VALUES (13719, '64.82.15591184539239611', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:34', 11, 0, '', '2019-05-29 16:27:34');
INSERT INTO `access_log` VALUES (13720, '59.77.15591184688410287', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:49', 46, 0, '', '2019-05-29 16:27:49');
INSERT INTO `access_log` VALUES (13721, '59.72.15591184752570283', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:27:55', 28, 2001001000, '服务端发生异常', '2019-05-29 16:27:55');
INSERT INTO `access_log` VALUES (13722, '59.73.15591184796900291', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:28:00', 13, 0, '', '2019-05-29 16:28:00');
INSERT INTO `access_log` VALUES (13723, '59.76.15591184877450283', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:28:08', 13, 0, '', '2019-05-29 16:28:08');
INSERT INTO `access_log` VALUES (13724, '59.71.15591184937460289', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:28:14', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-29 16:28:14');
INSERT INTO `access_log` VALUES (13725, '64.79.15591185149639601', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:28:35', 10, 0, '', '2019-05-29 16:28:35');
INSERT INTO `access_log` VALUES (13726, '64.78.15591185149629609', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:28:35', 12, 0, '', '2019-05-29 16:28:35');
INSERT INTO `access_log` VALUES (13727, '64.81.15591185265829601', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:28:47', 10, 0, '', '2019-05-29 16:28:47');
INSERT INTO `access_log` VALUES (13728, '64.85.15591186885349611', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:31:29', 10, 0, '', '2019-05-29 16:31:29');
INSERT INTO `access_log` VALUES (13729, '64.77.15591186885289609', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:31:29', 15, 0, '', '2019-05-29 16:31:29');
INSERT INTO `access_log` VALUES (13730, '64.84.15591186929869613', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:31:33', 10, 0, '', '2019-05-29 16:31:33');
INSERT INTO `access_log` VALUES (13731, '64.76.15591186929869609', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:31:33', 12, 0, '', '2019-05-29 16:31:33');
INSERT INTO `access_log` VALUES (13732, '64.79.15591186960439605', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:31:36', 11, 0, '', '2019-05-29 16:31:36');
INSERT INTO `access_log` VALUES (13733, '64.78.15591186960429613', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:31:36', 12, 0, '', '2019-05-29 16:31:36');
INSERT INTO `access_log` VALUES (13734, '64.81.15591186969829605', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:31:37', 10, 0, '', '2019-05-29 16:31:37');
INSERT INTO `access_log` VALUES (13735, '64.80.15591186969819605', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:31:37', 11, 0, '', '2019-05-29 16:31:37');
INSERT INTO `access_log` VALUES (13736, '64.82.15591187002229617', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:31:40', 10, 0, '', '2019-05-29 16:31:40');
INSERT INTO `access_log` VALUES (13737, '66.53.15591187108499263', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:31:51', 16, 0, '', '2019-05-29 16:31:51');
INSERT INTO `access_log` VALUES (13738, '66.56.15591187197999255', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:32:00', 13, 0, '', '2019-05-29 16:32:00');
INSERT INTO `access_log` VALUES (13739, '62.80.15591187525550217', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:32:33', 15, 0, '', '2019-05-29 16:32:33');
INSERT INTO `access_log` VALUES (13740, '64.83.15591187639689609', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:32:44', 11, 0, '', '2019-05-29 16:32:44');
INSERT INTO `access_log` VALUES (13741, '64.81.15591187979279607', 27, 2, 'product-application', '/product-api/admins/category/add', 'name=一个&pid=0&sort=1&description= i', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:33:18', 8, 1002002009, NULL, '2019-05-29 16:33:18');
INSERT INTO `access_log` VALUES (13742, '62.85.15591190606660221', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:37:41', 16, 0, '', '2019-05-29 16:37:41');
INSERT INTO `access_log` VALUES (13743, '62.87.15591190658910227', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:37:46', 20, 0, '', '2019-05-29 16:37:46');
INSERT INTO `access_log` VALUES (13744, '64.78.15591190684639619', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:37:48', 13, 0, '', '2019-05-29 16:37:48');
INSERT INTO `access_log` VALUES (13745, '64.81.15591190684809611', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:37:48', 9, 0, '', '2019-05-29 16:37:48');
INSERT INTO `access_log` VALUES (13746, '62.82.15591190826940225', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:38:03', 351, 0, '', '2019-05-29 16:38:03');
INSERT INTO `access_log` VALUES (13747, '62.89.15591190905400221', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:38:11', 17, 0, '', '2019-05-29 16:38:11');
INSERT INTO `access_log` VALUES (13748, '62.84.15591191060450215', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:38:26', 30, 0, '', '2019-05-29 16:38:26');
INSERT INTO `access_log` VALUES (13749, '62.85.15591192859490227', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:41:26', 16, 0, '', '2019-05-29 16:41:26');
INSERT INTO `access_log` VALUES (13750, '62.87.15591192927580229', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:41:33', 16, 0, '', '2019-05-29 16:41:33');
INSERT INTO `access_log` VALUES (13751, '64.82.15591193610049627', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:42:41', 12, 0, '', '2019-05-29 16:42:41');
INSERT INTO `access_log` VALUES (13752, '64.80.15591193610039615', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:42:41', 16, 0, '', '2019-05-29 16:42:41');
INSERT INTO `access_log` VALUES (13753, '64.83.15591195742399621', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:46:14', 14, 0, '', '2019-05-29 16:46:14');
INSERT INTO `access_log` VALUES (13754, '64.79.15591195750559619', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:46:15', 10, 0, '', '2019-05-29 16:46:15');
INSERT INTO `access_log` VALUES (13755, '64.78.15591195757519627', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 16:46:16', 12, 0, '', '2019-05-29 16:46:16');
INSERT INTO `access_log` VALUES (13756, '64.82.15591204828179643', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:01:23', 23, 0, '', '2019-05-29 17:01:23');
INSERT INTO `access_log` VALUES (13757, '64.85.15591204828199639', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:01:23', 21, 0, '', '2019-05-29 17:01:23');
INSERT INTO `access_log` VALUES (13758, '64.80.15591204828199631', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:01:23', 21, 0, '', '2019-05-29 17:01:23');
INSERT INTO `access_log` VALUES (13759, '62.83.15591204879690245', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:01:28', 80, 0, '', '2019-05-29 17:01:28');
INSERT INTO `access_log` VALUES (13760, '64.84.15591204914689641', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:01:31', 13, 0, '', '2019-05-29 17:01:31');
INSERT INTO `access_log` VALUES (13761, '64.77.15591204914679637', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:01:31', 13, 0, '', '2019-05-29 17:01:31');
INSERT INTO `access_log` VALUES (13762, '64.78.15591205374899641', 27, 2, 'product-application', '/product-api/admins/spu/update_sort', 'id=32&sort=-5', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:02:17', 9, 1002002009, NULL, '2019-05-29 17:02:18');
INSERT INTO `access_log` VALUES (13763, '59.72.15591206625080313', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.249.92.218', '2019-05-29 17:04:23', 11, 0, '', '2019-05-29 17:04:23');
INSERT INTO `access_log` VALUES (13764, '59.73.15591206625080321', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.249.92.218', '2019-05-29 17:04:23', 16, 2001001000, '服务端发生异常', '2019-05-29 17:04:23');
INSERT INTO `access_log` VALUES (13765, '64.78.15591206667199643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.249.92.218', '2019-05-29 17:04:27', 3, 0, '', '2019-05-29 17:04:27');
INSERT INTO `access_log` VALUES (13766, '64.81.15591206668159635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.249.92.218', '2019-05-29 17:04:27', 2, 0, '', '2019-05-29 17:04:27');
INSERT INTO `access_log` VALUES (13767, '64.82.15591206683439647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.249.92.218', '2019-05-29 17:04:28', 2, 0, '', '2019-05-29 17:04:28');
INSERT INTO `access_log` VALUES (13768, '64.85.15591206689299643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.249.92.218', '2019-05-29 17:04:29', 2, 0, '', '2019-05-29 17:04:29');
INSERT INTO `access_log` VALUES (13769, '64.80.15591206695899635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.249.92.218', '2019-05-29 17:04:30', 2, 0, '', '2019-05-29 17:04:30');
INSERT INTO `access_log` VALUES (13770, '64.77.15591206700129641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.249.92.218', '2019-05-29 17:04:30', 2, 0, '', '2019-05-29 17:04:30');
INSERT INTO `access_log` VALUES (13771, '59.80.15591206706940317', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.249.92.218', '2019-05-29 17:04:31', 4, 0, '', '2019-05-29 17:04:31');
INSERT INTO `access_log` VALUES (13772, '59.76.15591206706980313', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.249.92.218', '2019-05-29 17:04:31', 19, 2001001000, '服务端发生异常', '2019-05-29 17:04:31');
INSERT INTO `access_log` VALUES (13773, '64.84.15591206732199645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.249.92.218', '2019-05-29 17:04:33', 2, 0, '', '2019-05-29 17:04:33');
INSERT INTO `access_log` VALUES (13774, '64.76.15591206733749641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.249.92.218', '2019-05-29 17:04:33', 2, 0, '', '2019-05-29 17:04:33');
INSERT INTO `access_log` VALUES (13775, '64.79.15591206755959637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.249.92.218', '2019-05-29 17:04:36', 3, 0, '', '2019-05-29 17:04:36');
INSERT INTO `access_log` VALUES (13776, '64.78.15591206757379645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.249.92.218', '2019-05-29 17:04:36', 2, 0, '', '2019-05-29 17:04:36');
INSERT INTO `access_log` VALUES (13777, '65.51.15591209444459683', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:09:04', 0, 1002001015, '账号未登陆', '2019-05-29 17:09:04');
INSERT INTO `access_log` VALUES (13778, '65.48.15591209444489691', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:09:04', 1, 1002001015, '账号未登陆', '2019-05-29 17:09:04');
INSERT INTO `access_log` VALUES (13779, '65.45.15591209444619693', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:09:04', 0, 1002001015, '账号未登陆', '2019-05-29 17:09:04');
INSERT INTO `access_log` VALUES (13780, '65.49.15591209561789683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:09:16', 60, 0, '', '2019-05-29 17:09:16');
INSERT INTO `access_log` VALUES (13781, '65.53.15591209565029669', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:09:17', 11, 0, '', '2019-05-29 17:09:17');
INSERT INTO `access_log` VALUES (13782, '65.50.15591209565089683', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:09:17', 9, 0, '', '2019-05-29 17:09:17');
INSERT INTO `access_log` VALUES (13783, '65.54.15591209565129667', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:09:17', 9, 0, '', '2019-05-29 17:09:17');
INSERT INTO `access_log` VALUES (13784, '62.89.15591209647660251', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:09:25', 15, 0, '', '2019-05-29 17:09:25');
INSERT INTO `access_log` VALUES (13785, '64.81.15591209690489641', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:09:29', 11, 0, '', '2019-05-29 17:09:29');
INSERT INTO `access_log` VALUES (13786, '64.78.15591209690489649', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:09:29', 13, 0, '', '2019-05-29 17:09:29');
INSERT INTO `access_log` VALUES (13787, '59.74.15591209928510325', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:09:53', 220, 0, '', '2019-05-29 17:09:53');
INSERT INTO `access_log` VALUES (13788, '65.45.15591210085339695', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:10:09', 18, 0, '', '2019-05-29 17:10:09');
INSERT INTO `access_log` VALUES (13789, '65.47.15591210100309695', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:10:10', 9, 0, '', '2019-05-29 17:10:10');
INSERT INTO `access_log` VALUES (13790, '65.49.15591210111779685', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:10:11', 10, 0, '', '2019-05-29 17:10:11');
INSERT INTO `access_log` VALUES (13791, '65.50.15591210122829685', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '117.28.98.158', '2019-05-29 17:10:12', 14, 0, '', '2019-05-29 17:10:12');
INSERT INTO `access_log` VALUES (13792, '64.79.15591212026129645', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:13:23', 11, 0, '', '2019-05-29 17:13:23');
INSERT INTO `access_log` VALUES (13793, '64.83.15591212026129647', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:13:23', 13, 0, '', '2019-05-29 17:13:23');
INSERT INTO `access_log` VALUES (13794, '64.82.15591212198259657', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:13:40', 9, 0, '', '2019-05-29 17:13:40');
INSERT INTO `access_log` VALUES (13795, '64.81.15591212198239645', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:13:40', 12, 0, '', '2019-05-29 17:13:40');
INSERT INTO `access_log` VALUES (13796, '64.80.15591212215839645', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:13:42', 9, 0, '', '2019-05-29 17:13:42');
INSERT INTO `access_log` VALUES (13797, '64.85.15591212215829653', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:13:42', 11, 0, '', '2019-05-29 17:13:42');
INSERT INTO `access_log` VALUES (13798, '64.77.15591212245619651', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:13:45', 12, 0, '', '2019-05-29 17:13:45');
INSERT INTO `access_log` VALUES (13799, '64.76.15591212356089651', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:13:56', 12, 0, '', '2019-05-29 17:13:56');
INSERT INTO `access_log` VALUES (13800, '64.83.15591212366089649', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:13:57', 11, 0, '', '2019-05-29 17:13:57');
INSERT INTO `access_log` VALUES (13801, '64.79.15591212373189647', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:13:57', 87, 0, '', '2019-05-29 17:13:57');
INSERT INTO `access_log` VALUES (13802, '64.78.15591212385789655', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:13:59', 12, 0, '', '2019-05-29 17:13:59');
INSERT INTO `access_log` VALUES (13803, '64.81.15591212391279647', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:13:59', 12, 0, '', '2019-05-29 17:13:59');
INSERT INTO `access_log` VALUES (13804, '64.82.15591212402199659', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:14:00', 11, 0, '', '2019-05-29 17:14:00');
INSERT INTO `access_log` VALUES (13805, '64.85.15591212410389655', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:14:01', 10, 0, '', '2019-05-29 17:14:01');
INSERT INTO `access_log` VALUES (13806, '64.80.15591212430429647', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:14:03', 12, 0, '', '2019-05-29 17:14:03');
INSERT INTO `access_log` VALUES (13807, '64.77.15591213888519655', 0, 2, 'product-application', '/product-api/admins/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:16:29', 7, 1002001012, '访问令牌已过期', '2019-05-29 17:16:29');
INSERT INTO `access_log` VALUES (13808, '64.84.15591213888519659', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:16:29', 127, 1002001012, '访问令牌已过期', '2019-05-29 17:16:29');
INSERT INTO `access_log` VALUES (13809, '64.76.15591213888529655', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:16:29', 126, 1002001012, '访问令牌已过期', '2019-05-29 17:16:29');
INSERT INTO `access_log` VALUES (13810, '65.45.15591213910599701', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:16:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 17:16:31');
INSERT INTO `access_log` VALUES (13811, '59.72.15591214696410325', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:17:50', 10, 0, '', '2019-05-29 17:17:50');
INSERT INTO `access_log` VALUES (13812, '59.78.15591214696400333', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:17:50', 19, 2001001000, '服务端发生异常', '2019-05-29 17:17:50');
INSERT INTO `access_log` VALUES (13813, '65.46.15591214983889683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:18:18', 60, 0, '', '2019-05-29 17:18:18');
INSERT INTO `access_log` VALUES (13814, '65.48.15591214989349701', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:18:19', 10, 0, '', '2019-05-29 17:18:19');
INSERT INTO `access_log` VALUES (13815, '65.45.15591214989359703', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:18:19', 11, 0, '', '2019-05-29 17:18:19');
INSERT INTO `access_log` VALUES (13816, '65.51.15591214989529693', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:18:19', 11, 0, '', '2019-05-29 17:18:19');
INSERT INTO `access_log` VALUES (13817, '64.76.15591215022409657', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:18:22', 11, 0, '', '2019-05-29 17:18:22');
INSERT INTO `access_log` VALUES (13818, '64.84.15591215022389661', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:18:22', 14, 0, '', '2019-05-29 17:18:22');
INSERT INTO `access_log` VALUES (13819, '64.82.15591215589549665', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:19:19', 10, 0, '', '2019-05-29 17:19:19');
INSERT INTO `access_log` VALUES (13820, '64.81.15591215589539653', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:19:19', 13, 0, '', '2019-05-29 17:19:19');
INSERT INTO `access_log` VALUES (13821, '64.85.15591215604239661', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:19:20', 12, 0, '', '2019-05-29 17:19:20');
INSERT INTO `access_log` VALUES (13822, '64.76.15591215769269659', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:19:37', 13, 0, '', '2019-05-29 17:19:37');
INSERT INTO `access_log` VALUES (13823, '64.84.15591215769259663', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:19:37', 16, 0, '', '2019-05-29 17:19:37');
INSERT INTO `access_log` VALUES (13824, '64.83.15591215769429657', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:19:37', 9, 0, '', '2019-05-29 17:19:37');
INSERT INTO `access_log` VALUES (13825, '64.79.15591218902129659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:24:50', 43, 0, '', '2019-05-29 17:24:50');
INSERT INTO `access_log` VALUES (13826, '64.78.15591218904059667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:24:50', 2, 0, '', '2019-05-29 17:24:50');
INSERT INTO `access_log` VALUES (13827, '64.81.15591218920959659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:24:52', 2, 0, '', '2019-05-29 17:24:52');
INSERT INTO `access_log` VALUES (13828, '64.81.15591226252849669', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:37:05', 10, 0, '', '2019-05-29 17:37:05');
INSERT INTO `access_log` VALUES (13829, '64.78.15591226252809677', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:37:05', 14, 0, '', '2019-05-29 17:37:05');
INSERT INTO `access_log` VALUES (13830, '64.85.15591226284659677', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:37:08', 10, 0, '', '2019-05-29 17:37:08');
INSERT INTO `access_log` VALUES (13831, '64.80.15591227451069671', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:39:05', 9, 0, '', '2019-05-29 17:39:05');
INSERT INTO `access_log` VALUES (13832, '64.78.15591227451059679', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-29 17:39:05', 12, 0, '', '2019-05-29 17:39:05');
INSERT INTO `access_log` VALUES (13833, '65.54.15591233673799701', 0, 2, 'admin-application', '/admin-api/admins/role/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 17:49:27', 1, 1002001015, '账号未登陆', '2019-05-29 17:49:27');
INSERT INTO `access_log` VALUES (13834, '65.53.15591234833919709', 0, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'resourceIds=&id=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 17:51:23', 0, 1002001015, '账号未登陆', '2019-05-29 17:51:23');
INSERT INTO `access_log` VALUES (13835, '65.46.15591234942339713', 0, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'resourceIds=1&id=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 17:51:34', 1, 1002001015, '账号未登陆', '2019-05-29 17:51:34');
INSERT INTO `access_log` VALUES (13836, '65.51.15591235038869721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.36.171', '2019-05-29 17:51:44', 5, 1002002001, '密码不正确', '2019-05-29 17:51:44');
INSERT INTO `access_log` VALUES (13837, '65.46.15591237535369717', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:55:54', 1, 1002001015, '账号未登陆', '2019-05-29 17:55:54');
INSERT INTO `access_log` VALUES (13838, '65.48.15591237535369733', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:55:54', 0, 1002001015, '账号未登陆', '2019-05-29 17:55:54');
INSERT INTO `access_log` VALUES (13839, '65.52.15591237535369717', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:55:54', 1, 1002001015, '账号未登陆', '2019-05-29 17:55:54');
INSERT INTO `access_log` VALUES (13840, '65.45.15591237560199739', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:55:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 17:55:56');
INSERT INTO `access_log` VALUES (13841, '65.49.15591237776879727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:56:18', 60, 0, '', '2019-05-29 17:56:18');
INSERT INTO `access_log` VALUES (13842, '65.54.15591237780439709', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:56:18', 11, 0, '', '2019-05-29 17:56:18');
INSERT INTO `access_log` VALUES (13843, '65.50.15591237780479725', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:56:18', 8, 0, '', '2019-05-29 17:56:18');
INSERT INTO `access_log` VALUES (13844, '65.53.15591237780489715', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:56:18', 8, 0, '', '2019-05-29 17:56:18');
INSERT INTO `access_log` VALUES (13845, '62.81.15591237928330277', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:56:33', 401, 0, '', '2019-05-29 17:56:33');
INSERT INTO `access_log` VALUES (13846, '64.83.15591237957459689', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:56:36', 9, 0, '', '2019-05-29 17:56:36');
INSERT INTO `access_log` VALUES (13847, '64.77.15591237957429691', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:56:36', 12, 0, '', '2019-05-29 17:56:36');
INSERT INTO `access_log` VALUES (13848, '62.88.15591237981260293', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:56:38', 13, 0, '', '2019-05-29 17:56:38');
INSERT INTO `access_log` VALUES (13849, '64.76.15591238047979691', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:56:45', 10, 0, '', '2019-05-29 17:56:45');
INSERT INTO `access_log` VALUES (13850, '65.45.15591238369849741', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:57:17', 15, 0, '', '2019-05-29 17:57:17');
INSERT INTO `access_log` VALUES (13851, '65.53.15591238788609717', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:57:59', 14, 0, '', '2019-05-29 17:57:59');
INSERT INTO `access_log` VALUES (13852, '64.80.15591238792259687', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:57:59', 11, 0, '', '2019-05-29 17:57:59');
INSERT INTO `access_log` VALUES (13853, '62.89.15591238796410291', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:58:00', 15, 0, '', '2019-05-29 17:58:00');
INSERT INTO `access_log` VALUES (13854, '64.77.15591238801239693', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:58:00', 8, 0, '', '2019-05-29 17:58:00');
INSERT INTO `access_log` VALUES (13855, '64.85.15591238801239695', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:58:00', 189, 0, '', '2019-05-29 17:58:00');
INSERT INTO `access_log` VALUES (13856, '62.84.15591238807930283', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:58:01', 13, 0, '', '2019-05-29 17:58:01');
INSERT INTO `access_log` VALUES (13857, '59.80.15591238876500361', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:58:08', 13, 0, '', '2019-05-29 17:58:08');
INSERT INTO `access_log` VALUES (13858, '59.76.15591238876510357', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:58:08', 15, 2001001000, '服务端发生异常', '2019-05-29 17:58:08');
INSERT INTO `access_log` VALUES (13859, '64.76.15591238935649693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:58:14', 42, 0, '', '2019-05-29 17:58:14');
INSERT INTO `access_log` VALUES (13860, '64.84.15591238937089697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:58:14', 2, 0, '', '2019-05-29 17:58:14');
INSERT INTO `access_log` VALUES (13861, '64.79.15591238982749689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:58:18', 2, 0, '', '2019-05-29 17:58:18');
INSERT INTO `access_log` VALUES (13862, '64.82.15591238984089701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:58:18', 2, 0, '', '2019-05-29 17:58:18');
INSERT INTO `access_log` VALUES (13863, '64.81.15591239001629689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:58:20', 2, 0, '', '2019-05-29 17:58:20');
INSERT INTO `access_log` VALUES (13864, '64.80.15591239011849689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:58:21', 2, 0, '', '2019-05-29 17:58:21');
INSERT INTO `access_log` VALUES (13865, '59.75.15591239020670363', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:58:22', 3, 0, '', '2019-05-29 17:58:22');
INSERT INTO `access_log` VALUES (13866, '59.74.15591239020670365', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.118.231.194', '2019-05-29 17:58:22', 13, 2001001000, '服务端发生异常', '2019-05-29 17:58:22');
INSERT INTO `access_log` VALUES (13867, '59.72.15591258898890385', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:31:30', 15, 0, '', '2019-05-29 18:31:30');
INSERT INTO `access_log` VALUES (13868, '59.78.15591258898910393', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:31:30', 17, 2001001000, '服务端发生异常', '2019-05-29 18:31:30');
INSERT INTO `access_log` VALUES (13869, '64.83.15591258937689719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:31:34', 11, 0, '', '2019-05-29 18:31:34');
INSERT INTO `access_log` VALUES (13870, '64.76.15591258939119721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:31:34', 3, 0, '', '2019-05-29 18:31:34');
INSERT INTO `access_log` VALUES (13871, '64.84.15591258954429725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:31:35', 3, 0, '', '2019-05-29 18:31:35');
INSERT INTO `access_log` VALUES (13872, '64.82.15591258961349729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:31:36', 280, 0, '', '2019-05-29 18:31:36');
INSERT INTO `access_log` VALUES (13873, '64.81.15591258966729717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:31:37', 3, 0, '', '2019-05-29 18:31:37');
INSERT INTO `access_log` VALUES (13874, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:31:37', 17, 0, '', '2019-05-29 18:31:37');
INSERT INTO `access_log` VALUES (13875, '64.78.15591258984979725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:31:38', 3, 0, '', '2019-05-29 18:31:39');
INSERT INTO `access_log` VALUES (13876, '64.80.15591258993569717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:31:39', 2, 0, '', '2019-05-29 18:31:39');
INSERT INTO `access_log` VALUES (13877, '64.77.15591259031649723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:31:43', 3, 0, '', '2019-05-29 18:31:43');
INSERT INTO `access_log` VALUES (13878, '64.85.15591259034119725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:31:43', 2, 0, '', '2019-05-29 18:31:43');
INSERT INTO `access_log` VALUES (13879, '66.57.15591259136969359', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18846916971', 'POST', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:31:54', 138, 0, '', '2019-05-29 18:31:54');
INSERT INTO `access_log` VALUES (13880, '66.49.15591259191239355', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18846916971&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:31:59', 184, 0, '', '2019-05-29 18:31:59');
INSERT INTO `access_log` VALUES (13881, '66.48.15591259210479361', 90, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:01', 9, 0, '', '2019-05-29 18:32:01');
INSERT INTO `access_log` VALUES (13882, '66.52.15591259408749357', 90, 1, 'user-application', '/user-api/users/user/update_nickname', 'nickname=唐老鸭', 'POST', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:21', 66, 0, '', '2019-05-29 18:32:21');
INSERT INTO `access_log` VALUES (13883, '66.53.15591259496409361', 90, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:30', 7, 0, '', '2019-05-29 18:32:30');
INSERT INTO `access_log` VALUES (13884, '66.56.15591259513399353', 90, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:31', 7, 0, '', '2019-05-29 18:32:31');
INSERT INTO `access_log` VALUES (13885, '66.49.15591259560399357', 90, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:36', 7, 0, '', '2019-05-29 18:32:36');
INSERT INTO `access_log` VALUES (13886, '59.78.15591259573600395', 90, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:37', 7, 0, '', '2019-05-29 18:32:37');
INSERT INTO `access_log` VALUES (13887, '59.77.15591259573550391', 90, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:37', 17, 2001001000, '服务端发生异常', '2019-05-29 18:32:37');
INSERT INTO `access_log` VALUES (13888, '64.81.15591259605529719', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:41', 169, 0, '', '2019-05-29 18:32:41');
INSERT INTO `access_log` VALUES (13889, '64.80.15591259609749719', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:41', 5, 0, '', '2019-05-29 18:32:41');
INSERT INTO `access_log` VALUES (13890, '64.85.15591259619719727', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:42', 5, 0, '', '2019-05-29 18:32:42');
INSERT INTO `access_log` VALUES (13891, '64.83.15591259624839723', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:42', 6, 0, '', '2019-05-29 18:32:42');
INSERT INTO `access_log` VALUES (13892, 'N/A', 90, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:43', 18, 0, '', '2019-05-29 18:32:43');
INSERT INTO `access_log` VALUES (13893, '64.79.15591259653259721', 90, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:45', 13, 0, '', '2019-05-29 18:32:45');
INSERT INTO `access_log` VALUES (13894, '66.51.15591259710589357', 90, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:51', 7, 0, '', '2019-05-29 18:32:51');
INSERT INTO `access_log` VALUES (13895, '66.54.15591259715509357', 90, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:32:52', 6, 0, '', '2019-05-29 18:32:52');
INSERT INTO `access_log` VALUES (13896, '66.56.15591259886989355', 90, 1, 'user-application', '/user-api/users/address/add', 'name=手&tel=15555555555&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=老婆婆给你信咯lol明您了lol&isDefault=true&address=老婆婆给你信咯lol明您了lol&areaNo=110101&mobile=15555555555&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:09', 113, 0, '', '2019-05-29 18:33:09');
INSERT INTO `access_log` VALUES (13897, '66.57.15591259891579363', 90, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:09', 8, 0, '', '2019-05-29 18:33:09');
INSERT INTO `access_log` VALUES (13898, '66.49.15591259916459359', 90, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:12', 7, 0, '', '2019-05-29 18:33:12');
INSERT INTO `access_log` VALUES (13899, '64.81.15591259993009721', 90, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:19', 11, 0, '', '2019-05-29 18:33:19');
INSERT INTO `access_log` VALUES (13900, '64.80.15591260013809721', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:21', 6, 0, '', '2019-05-29 18:33:21');
INSERT INTO `access_log` VALUES (13901, 'N/A', 90, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:21', 18, 0, '', '2019-05-29 18:33:21');
INSERT INTO `access_log` VALUES (13902, 'N/A', 90, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:25', 14, 0, '', '2019-05-29 18:33:25');
INSERT INTO `access_log` VALUES (13903, '64.85.15591260077089729', 90, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:28', 11, 0, '', '2019-05-29 18:33:28');
INSERT INTO `access_log` VALUES (13904, '66.48.15591260099489365', 90, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:30', 8, 0, '', '2019-05-29 18:33:30');
INSERT INTO `access_log` VALUES (13905, '64.76.15591260202769727', 90, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:40', 11, 0, '', '2019-05-29 18:33:40');
INSERT INTO `access_log` VALUES (13906, '64.79.15591260232779723', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:43', 6, 0, '', '2019-05-29 18:33:43');
INSERT INTO `access_log` VALUES (13907, 'N/A', 90, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:43', 12, 0, '', '2019-05-29 18:33:43');
INSERT INTO `access_log` VALUES (13908, '64.84.15591260257649731', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:46', 7, 0, '', '2019-05-29 18:33:46');
INSERT INTO `access_log` VALUES (13909, '64.82.15591260259589735', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:46', 5, 0, '', '2019-05-29 18:33:46');
INSERT INTO `access_log` VALUES (13910, '64.81.15591260274239723', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:47', 6, 0, '', '2019-05-29 18:33:47');
INSERT INTO `access_log` VALUES (13911, '64.80.15591260280389723', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:48', 5, 0, '', '2019-05-29 18:33:48');
INSERT INTO `access_log` VALUES (13912, '64.77.15591260283659729', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:48', 5, 0, '', '2019-05-29 18:33:48');
INSERT INTO `access_log` VALUES (13913, '64.85.15591260291969731', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:49', 5, 0, '', '2019-05-29 18:33:49');
INSERT INTO `access_log` VALUES (13914, 'N/A', 90, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:49', 12, 0, '', '2019-05-29 18:33:49');
INSERT INTO `access_log` VALUES (13915, '64.79.15591260310069725', 90, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:51', 11, 0, '', '2019-05-29 18:33:51');
INSERT INTO `access_log` VALUES (13916, '66.54.15591260330639359', 90, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:53', 7, 0, '', '2019-05-29 18:33:53');
INSERT INTO `access_log` VALUES (13917, '64.84.15591260354069733', 90, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:55', 10, 0, '', '2019-05-29 18:33:55');
INSERT INTO `access_log` VALUES (13918, '64.82.15591260360139737', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:56', 5, 0, '', '2019-05-29 18:33:56');
INSERT INTO `access_log` VALUES (13919, 'N/A', 90, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:56', 13, 0, '', '2019-05-29 18:33:56');
INSERT INTO `access_log` VALUES (13920, '64.81.15591260366149725', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:57', 5, 0, '', '2019-05-29 18:33:57');
INSERT INTO `access_log` VALUES (13921, '64.78.15591260368469733', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:33:57', 6, 0, '', '2019-05-29 18:33:57');
INSERT INTO `access_log` VALUES (13922, '64.80.15591260407629725', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:34:01', 5, 0, '', '2019-05-29 18:34:01');
INSERT INTO `access_log` VALUES (13923, '64.77.15591260409949731', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:34:01', 60, 0, '', '2019-05-29 18:34:01');
INSERT INTO `access_log` VALUES (13924, '59.74.15591260427940395', 90, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:34:03', 8, 0, '', '2019-05-29 18:34:03');
INSERT INTO `access_log` VALUES (13925, '59.75.15591260427940393', 90, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:34:03', 18, 2001001000, '服务端发生异常', '2019-05-29 18:34:03');
INSERT INTO `access_log` VALUES (13926, '64.83.15591260473329729', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:34:07', 5, 0, '', '2019-05-29 18:34:07');
INSERT INTO `access_log` VALUES (13927, '64.76.15591260474849731', 90, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:34:07', 5, 0, '', '2019-05-29 18:34:07');
INSERT INTO `access_log` VALUES (13928, '59.78.15591260482640397', 90, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:34:08', 10, 0, '', '2019-05-29 18:34:08');
INSERT INTO `access_log` VALUES (13929, '59.77.15591260482740393', 90, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 9 Build/PKQ1.181121.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 xiaomiquan/4.0.0', '124.64.16.141', '2019-05-29 18:34:08', 21, 2001001000, '服务端发生异常', '2019-05-29 18:34:08');
INSERT INTO `access_log` VALUES (13930, '65.52.15591273736139767', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-05-29 18:56:14', 0, 1002001015, '账号未登陆', '2019-05-29 18:56:14');
INSERT INTO `access_log` VALUES (13931, '65.51.15591273736139775', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-05-29 18:56:14', 0, 1002001015, '账号未登陆', '2019-05-29 18:56:14');
INSERT INTO `access_log` VALUES (13932, '65.45.15591273736359789', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-05-29 18:56:14', 0, 1002001015, '账号未登陆', '2019-05-29 18:56:14');
INSERT INTO `access_log` VALUES (13933, '65.47.15591273755989787', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-05-29 18:56:16', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-29 18:56:16');
INSERT INTO `access_log` VALUES (13934, '59.77.15591273847430411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-05-29 18:56:25', 4, 0, '', '2019-05-29 18:56:25');
INSERT INTO `access_log` VALUES (13935, '59.72.15591273847440407', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-05-29 18:56:25', 21, 2001001000, '服务端发生异常', '2019-05-29 18:56:25');
INSERT INTO `access_log` VALUES (13936, '64.76.15591273914669749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-05-29 18:56:31', 3, 0, '', '2019-05-29 18:56:31');
INSERT INTO `access_log` VALUES (13937, '64.79.15591273915539745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-05-29 18:56:32', 2, 0, '', '2019-05-29 18:56:32');
INSERT INTO `access_log` VALUES (13938, '64.84.15591273931179753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-05-29 18:56:33', 218, 0, '', '2019-05-29 18:56:33');
INSERT INTO `access_log` VALUES (13939, '64.82.15591273938949757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-05-29 18:56:34', 2, 0, '', '2019-05-29 18:56:34');
INSERT INTO `access_log` VALUES (13940, '64.81.15591273949369745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-05-29 18:56:35', 2, 0, '', '2019-05-29 18:56:35');
INSERT INTO `access_log` VALUES (13941, '64.78.15591273953319753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-05-29 18:56:35', 3, 0, '', '2019-05-29 18:56:35');
INSERT INTO `access_log` VALUES (13942, '65.47.15591375412249923', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:45:41', 0, 1002001015, '账号未登陆', '2019-05-29 21:45:41');
INSERT INTO `access_log` VALUES (13943, '65.52.15591375412249903', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:45:41', 0, 1002001015, '账号未登陆', '2019-05-29 21:45:41');
INSERT INTO `access_log` VALUES (13944, '65.49.15591375412259913', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:45:41', 1, 1002001015, '账号未登陆', '2019-05-29 21:45:41');
INSERT INTO `access_log` VALUES (13945, '65.50.15591375507799911', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:45:51', 289, 0, '', '2019-05-29 21:45:51');
INSERT INTO `access_log` VALUES (13946, '65.53.15591375514209901', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:45:51', 1265, 0, '', '2019-05-29 21:45:53');
INSERT INTO `access_log` VALUES (13947, '65.54.15591375514219895', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:45:51', 1264, 0, '', '2019-05-29 21:45:53');
INSERT INTO `access_log` VALUES (13948, '65.46.15591375514289905', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:45:51', 1258, 0, '', '2019-05-29 21:45:53');
INSERT INTO `access_log` VALUES (13949, '62.85.15591375585110473', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:45:59', 26, 0, '', '2019-05-29 21:45:59');
INSERT INTO `access_log` VALUES (13950, '66.54.15591375699379513', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:46:10', 24, 0, '', '2019-05-29 21:46:10');
INSERT INTO `access_log` VALUES (13951, '59.80.15591375783920547', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:46:18', 45, 0, '', '2019-05-29 21:46:18');
INSERT INTO `access_log` VALUES (13952, '65.49.15591375858109915', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:46:26', 21, 0, '', '2019-05-29 21:46:26');
INSERT INTO `access_log` VALUES (13953, '65.52.15591375876369905', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:46:28', 10, 0, '', '2019-05-29 21:46:28');
INSERT INTO `access_log` VALUES (13954, '65.47.15591375893139925', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:46:29', 9, 0, '', '2019-05-29 21:46:29');
INSERT INTO `access_log` VALUES (13955, '65.50.15591375913709913', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:46:31', 507, 0, '', '2019-05-29 21:46:32');
INSERT INTO `access_log` VALUES (13956, '65.46.15591375925839907', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:46:33', 81, 0, '', '2019-05-29 21:46:33');
INSERT INTO `access_log` VALUES (13957, '62.89.15591376009630475', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:46:41', 15, 0, '', '2019-05-29 21:46:41');
INSERT INTO `access_log` VALUES (13958, '62.84.15591376034640467', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.97.50.43', '2019-05-29 21:46:43', 17, 0, '', '2019-05-29 21:46:43');
INSERT INTO `access_log` VALUES (13959, '65.54.15591386408199911', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:01', 1, 1002001015, '账号未登陆', '2019-05-29 22:04:01');
INSERT INTO `access_log` VALUES (13960, '65.53.15591386408189917', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:01', 1, 1002001015, '账号未登陆', '2019-05-29 22:04:01');
INSERT INTO `access_log` VALUES (13961, '65.48.15591386408239937', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:01', 1, 1002001015, '账号未登陆', '2019-05-29 22:04:01');
INSERT INTO `access_log` VALUES (13962, '65.51.15591386510449929', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:11', 418, 0, '', '2019-05-29 22:04:11');
INSERT INTO `access_log` VALUES (13963, '65.49.15591386516609931', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:12', 10, 0, '', '2019-05-29 22:04:12');
INSERT INTO `access_log` VALUES (13964, '65.52.15591386516629921', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:12', 8, 0, '', '2019-05-29 22:04:12');
INSERT INTO `access_log` VALUES (13965, '65.47.15591386516669941', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:12', 9, 0, '', '2019-05-29 22:04:12');
INSERT INTO `access_log` VALUES (13966, '62.80.15591386650830487', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:25', 14, 0, '', '2019-05-29 22:04:25');
INSERT INTO `access_log` VALUES (13967, '64.83.15591386706669899', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:31', 25, 0, '', '2019-05-29 22:04:31');
INSERT INTO `access_log` VALUES (13968, '64.85.15591386706659903', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:31', 29, 0, '', '2019-05-29 22:04:31');
INSERT INTO `access_log` VALUES (13969, '59.78.15591386773400567', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:37', 16, 0, '', '2019-05-29 22:04:37');
INSERT INTO `access_log` VALUES (13970, '65.53.15591386793079919', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:39', 21, 0, '', '2019-05-29 22:04:39');
INSERT INTO `access_log` VALUES (13971, '65.54.15591386800519913', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:40', 9, 0, '', '2019-05-29 22:04:40');
INSERT INTO `access_log` VALUES (13972, '65.48.15591386810509939', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:41', 9, 0, '', '2019-05-29 22:04:41');
INSERT INTO `access_log` VALUES (13973, '65.45.15591386822869945', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:42', 13, 0, '', '2019-05-29 22:04:42');
INSERT INTO `access_log` VALUES (13974, '65.51.15591386833729931', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:04:43', 10, 0, '', '2019-05-29 22:04:43');
INSERT INTO `access_log` VALUES (13975, '59.73.15591387167990565', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:05:17', 4, 0, '', '2019-05-29 22:05:17');
INSERT INTO `access_log` VALUES (13976, '59.71.15591387168000565', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:05:17', 13, 2001001000, '服务端发生异常', '2019-05-29 22:05:17');
INSERT INTO `access_log` VALUES (13977, '64.81.15591387229709897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:05:23', 4, 0, '', '2019-05-29 22:05:23');
INSERT INTO `access_log` VALUES (13978, '64.78.15591387230529905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:05:23', 3, 0, '', '2019-05-29 22:05:23');
INSERT INTO `access_log` VALUES (13979, '64.80.15591387285929897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:05:29', 3, 0, '', '2019-05-29 22:05:29');
INSERT INTO `access_log` VALUES (13980, '64.77.15591387287089903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.72.104.192', '2019-05-29 22:05:29', 2, 0, '', '2019-05-29 22:05:29');
INSERT INTO `access_log` VALUES (13981, '6350bdf0-30b9-4488-850c-0dd5809924a7', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:08:30', 221, 1002001012, '访问令牌已过期', '2019-05-29 23:08:30');
INSERT INTO `access_log` VALUES (13982, '5126e056-2ca0-40e9-bc7a-e43a2363fcec', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:08:30', 250, 1002001012, '访问令牌已过期', '2019-05-29 23:08:30');
INSERT INTO `access_log` VALUES (13983, 'befd82f4-57ac-487f-a591-e9b6497744ad', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:08:30', 221, 1002001012, '访问令牌已过期', '2019-05-29 23:08:30');
INSERT INTO `access_log` VALUES (13984, '1f8399d5-e559-4aba-85af-ad98ffc9849b', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:08:32', 511, 0, '', '2019-05-29 23:08:33');
INSERT INTO `access_log` VALUES (13985, 'a74bd311-f133-491c-95e7-98339d31c0fe', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:08:33', 216, 0, '', '2019-05-29 23:08:33');
INSERT INTO `access_log` VALUES (13986, '43faf078-eca4-45bb-94ad-9f1b7c1259c4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:08:33', 233, 0, '', '2019-05-29 23:08:33');
INSERT INTO `access_log` VALUES (13987, '0886ee60-0015-4c2e-aad6-2b06e59d877f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:08:33', 264, 0, '', '2019-05-29 23:08:33');
INSERT INTO `access_log` VALUES (13988, '3ec9b3af-54b4-4a15-b939-9ae96a7e0568', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:08:35', 237, 0, '', '2019-05-29 23:08:35');
INSERT INTO `access_log` VALUES (13989, 'f39fca8c-f48b-4974-bf98-7e2936be996b', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:08:46', 231, 0, '', '2019-05-29 23:08:46');
INSERT INTO `access_log` VALUES (13990, '54a32e3a-f099-4690-b4ae-3a4210b3f333', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:09:00', 152, 0, '', '2019-05-29 23:09:00');
INSERT INTO `access_log` VALUES (13991, '4804ba39-e1af-4048-b69e-e36196f50159', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:09:00', 154, 0, '', '2019-05-29 23:09:00');
INSERT INTO `access_log` VALUES (13992, '021e3602-3c10-461e-ad18-e9bfc9e1a454', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:09:00', 184, 0, '', '2019-05-29 23:09:00');
INSERT INTO `access_log` VALUES (13993, '4d2c1124-f108-405b-8d73-4040cce715d4', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:09:00', 283, 0, '', '2019-05-29 23:09:00');
INSERT INTO `access_log` VALUES (13994, '1f9af1f2-4bbf-4e4c-83f5-041d4fbb93b0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:09:49', 151, 0, '', '2019-05-29 23:09:50');
INSERT INTO `access_log` VALUES (13995, 'de240174-563e-41fe-86d1-ee27a48068ff', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:09:49', 155, 0, '', '2019-05-29 23:09:50');
INSERT INTO `access_log` VALUES (13996, '8a7f05c3-0957-45a1-a1f6-c420f0627c7c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:09:49', 469, 0, '', '2019-05-29 23:09:50');
INSERT INTO `access_log` VALUES (13997, '14a8a22f-ce78-4d21-b890-0bdc470c1b61', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:09:50', 285, 0, '', '2019-05-29 23:09:51');
INSERT INTO `access_log` VALUES (13998, 'c5f30c60-1042-4ed2-b6f4-65949d38065a', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:09:57', 184, 0, '', '2019-05-29 23:09:57');
INSERT INTO `access_log` VALUES (13999, 'c1dd91a6-929b-41ad-8e96-d48e56f48e39', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:10:24', 169, 0, '', '2019-05-29 23:10:25');
INSERT INTO `access_log` VALUES (14000, '8b7f89bc-ccaf-48cb-b671-dff5050f5959', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:10:24', 169, 0, '', '2019-05-29 23:10:25');
INSERT INTO `access_log` VALUES (14001, '961fb974-cb12-4714-8de2-4b3351719d25', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:10:24', 175, 0, '', '2019-05-29 23:10:25');
INSERT INTO `access_log` VALUES (14002, 'ae307baa-404d-450a-a559-c1cbf20b2def', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:10:25', 191, 0, '', '2019-05-29 23:10:25');
INSERT INTO `access_log` VALUES (14003, '9f84521c-1a89-4c48-9ce3-c01dc9e1f6f4', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:11:16', 217, 0, '', '2019-05-29 23:11:16');
INSERT INTO `access_log` VALUES (14004, 'ea46cecb-b201-422d-bf58-157fc210bfe9', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:11:27', 790, 0, '', '2019-05-29 23:11:27');
INSERT INTO `access_log` VALUES (14005, '9b726519-ac29-41ab-bfa1-f1deb1788617', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&id=7', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:11:31', 221, 0, '', '2019-05-29 23:11:31');
INSERT INTO `access_log` VALUES (14006, '2841aeb9-c7f6-4060-8d73-bf4dc081ac61', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:11:35', 274, 0, '', '2019-05-29 23:11:35');
INSERT INTO `access_log` VALUES (14007, '8b095b66-a5f4-40fb-9273-f8c8ebce764c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:12:06', 150, 0, '', '2019-05-29 23:12:06');
INSERT INTO `access_log` VALUES (14008, 'f7298b23-5be5-4818-9e86-d2413ac39b89', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:12:10', 217, 0, '', '2019-05-29 23:12:10');
INSERT INTO `access_log` VALUES (14009, 'c5472ce3-e6f9-474e-a49b-25cbc375c8b5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:16:53', 368, 0, '', '2019-05-29 23:16:53');
INSERT INTO `access_log` VALUES (14010, '24b6bb3d-6b51-4290-82bf-8e492950c22c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:16:53', 1261, 0, '', '2019-05-29 23:16:54');
INSERT INTO `access_log` VALUES (14011, '3f1b8408-bc08-444c-9147-feb8576b916c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:16:54', 541, 0, '', '2019-05-29 23:16:54');
INSERT INTO `access_log` VALUES (14012, '3664c787-f593-4068-bb7b-3ac520a3ac30', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:16:53', 2172, 0, '', '2019-05-29 23:16:55');
INSERT INTO `access_log` VALUES (14013, '68a74efd-2a41-488a-bd67-ca0119311288', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:16:55', 160, 0, '', '2019-05-29 23:16:55');
INSERT INTO `access_log` VALUES (14014, '836b8ce3-0e3a-44f3-8e43-1ba0731e0661', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:16:55', 160, 0, '', '2019-05-29 23:16:55');
INSERT INTO `access_log` VALUES (14015, 'e7ffc34d-b461-46d3-ad9b-58957d0b23b1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:16:55', 268, 0, '', '2019-05-29 23:16:55');
INSERT INTO `access_log` VALUES (14016, '8808f22d-7247-45e5-b34c-0a6b315c8c4c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:16:55', 329, 0, '', '2019-05-29 23:16:55');
INSERT INTO `access_log` VALUES (14017, 'ee029c33-5871-4744-8946-97db9dd36373', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:17:14', 164, 0, '', '2019-05-29 23:17:14');
INSERT INTO `access_log` VALUES (14018, '96dcb649-2f72-4fa6-8c9e-f0317e5ae5f0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:17:14', 181, 0, '', '2019-05-29 23:17:14');
INSERT INTO `access_log` VALUES (14019, '59acd3f5-23d8-4f43-bf35-b620d927a994', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:17:14', 208, 0, '', '2019-05-29 23:17:14');
INSERT INTO `access_log` VALUES (14020, '8e1b1822-4b19-4d50-82ae-25e2c868b9e1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:17:14', 210, 0, '', '2019-05-29 23:17:14');
INSERT INTO `access_log` VALUES (14021, 'ad78d438-2618-4dc2-98c7-021f29b54f3c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:17:14', 487, 0, '', '2019-05-29 23:17:15');
INSERT INTO `access_log` VALUES (14022, '5fc411b5-c0ed-4cf8-9818-bce71cae1b20', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:18:21', 178, 0, '', '2019-05-29 23:18:21');
INSERT INTO `access_log` VALUES (14023, '08cf1566-4d76-4052-9e62-2da33c0bf75c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:18:21', 178, 0, '', '2019-05-29 23:18:21');
INSERT INTO `access_log` VALUES (14024, '32853612-3fb4-47fa-9206-bac23f110398', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:18:21', 180, 0, '', '2019-05-29 23:18:21');
INSERT INTO `access_log` VALUES (14025, '770fd77b-e2e1-4fc2-9569-21666e061e9b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:18:21', 213, 0, '', '2019-05-29 23:18:21');
INSERT INTO `access_log` VALUES (14026, '593af7ee-f6fe-424c-a660-7d4b2b3e4c47', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:18:21', 251, 0, '', '2019-05-29 23:18:21');
INSERT INTO `access_log` VALUES (14027, 'e823b7c9-d173-4ff5-88c0-6b7c0355d7d8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:19:24', 183, 0, '', '2019-05-29 23:19:24');
INSERT INTO `access_log` VALUES (14028, 'b1cbdfca-0353-451b-a546-500bf3082a3f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:19:24', 184, 0, '', '2019-05-29 23:19:24');
INSERT INTO `access_log` VALUES (14029, '01670a15-c0f3-4990-90eb-8300c4568204', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:19:24', 184, 0, '', '2019-05-29 23:19:24');
INSERT INTO `access_log` VALUES (14030, 'bb5e49f6-c7b4-4c20-8bf0-cf33cb17c04e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:19:24', 180, 0, '', '2019-05-29 23:19:24');
INSERT INTO `access_log` VALUES (14031, 'ae40bbac-49c5-4f6d-8cfc-8a29b2664d57', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:19:24', 214, 0, '', '2019-05-29 23:19:24');
INSERT INTO `access_log` VALUES (14032, '139a8230-35b8-42b4-85e2-da66d5194f6d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:21:07', 176, 0, '', '2019-05-29 23:21:07');
INSERT INTO `access_log` VALUES (14033, '5bcd17d1-95be-4ba1-9cbf-8b702675d862', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:21:07', 176, 0, '', '2019-05-29 23:21:07');
INSERT INTO `access_log` VALUES (14034, 'f8cee0e4-7ec1-4edf-a7d9-e84daee0b4fc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:21:07', 175, 0, '', '2019-05-29 23:21:07');
INSERT INTO `access_log` VALUES (14035, '33656470-1961-4081-bcba-3918b0458fbf', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:21:07', 207, 0, '', '2019-05-29 23:21:07');
INSERT INTO `access_log` VALUES (14036, '9cb05a01-4f9b-47fc-bf7a-0df7a26e3c1c', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:21:07', 249, 0, '', '2019-05-29 23:21:07');
INSERT INTO `access_log` VALUES (14037, '551443b8-3b3a-4d18-a033-a2afdebe961c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:21:35', 224, 0, '', '2019-05-29 23:21:36');
INSERT INTO `access_log` VALUES (14038, 'ea94ee5b-7404-499c-82ef-9cc9f1d4c4b7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:21:35', 216, 0, '', '2019-05-29 23:21:36');
INSERT INTO `access_log` VALUES (14039, '573bc5be-0081-4835-af28-ee844ef63661', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:21:35', 217, 0, '', '2019-05-29 23:21:36');
INSERT INTO `access_log` VALUES (14040, 'fcaf8b11-5732-457c-8a15-848cf0576047', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:45', 212, 0, '', '2019-05-29 23:23:45');
INSERT INTO `access_log` VALUES (14041, 'dc444d9c-6e79-4c81-85dd-2a9dd3b7067d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:45', 214, 0, '', '2019-05-29 23:23:45');
INSERT INTO `access_log` VALUES (14042, '6d48630d-f790-47c1-a76f-5abae8158e66', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:45', 211, 0, '', '2019-05-29 23:23:45');
INSERT INTO `access_log` VALUES (14043, 'c7083721-4dde-464c-9f71-c2d56534f75e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:46', 291, 0, '', '2019-05-29 23:23:46');
INSERT INTO `access_log` VALUES (14044, 'd5c3b23a-6e9e-4f56-8331-83a519e91e4d', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:46', 492, 0, '', '2019-05-29 23:23:46');
INSERT INTO `access_log` VALUES (14045, '452277ad-d9fe-431b-bbd6-843f6f597870', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:46', 273, 0, '', '2019-05-29 23:23:47');
INSERT INTO `access_log` VALUES (14046, '06d9ebc8-6615-4dee-85f1-409c303a8964', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:46', 271, 0, '', '2019-05-29 23:23:47');
INSERT INTO `access_log` VALUES (14047, '69d9eb63-768b-4b3b-84d8-d8911f074b36', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:46', 276, 0, '', '2019-05-29 23:23:47');
INSERT INTO `access_log` VALUES (14048, '62f98c38-7c46-42a8-b2c9-d001f5315bc4', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:47', 288, 0, '', '2019-05-29 23:23:47');
INSERT INTO `access_log` VALUES (14049, 'af48cab5-77e1-407d-91af-d78f4eb690a4', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:47', 323, 0, '', '2019-05-29 23:23:47');
INSERT INTO `access_log` VALUES (14050, 'f020efe1-8719-4baa-bc42-e9d0e8d12572', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:56', 142, 0, '', '2019-05-29 23:23:56');
INSERT INTO `access_log` VALUES (14051, '0a333910-96d2-4ecd-8cdf-cea00e0a0aed', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:56', 142, 0, '', '2019-05-29 23:23:56');
INSERT INTO `access_log` VALUES (14052, '26dcf70d-ca2f-4849-80ba-7fb519d243c7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:56', 143, 0, '', '2019-05-29 23:23:56');
INSERT INTO `access_log` VALUES (14053, '119245c9-6ae7-45d5-9cb8-7ee51ebfd400', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:56', 173, 0, '', '2019-05-29 23:23:57');
INSERT INTO `access_log` VALUES (14054, 'c3905bde-4186-4a90-9d0e-f6d0d7dd1302', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:23:56', 208, 0, '', '2019-05-29 23:23:57');
INSERT INTO `access_log` VALUES (14055, '77898eb0-53e4-4de7-b3f0-4486758e91c0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:24:20', 145, 0, '', '2019-05-29 23:24:20');
INSERT INTO `access_log` VALUES (14056, 'd152f84a-87e3-4c5f-95f5-1d644865886f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:24:20', 145, 0, '', '2019-05-29 23:24:20');
INSERT INTO `access_log` VALUES (14057, '50b7fab6-c1df-4b4b-a690-6e08b105819f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:24:20', 144, 0, '', '2019-05-29 23:24:20');
INSERT INTO `access_log` VALUES (14058, '90b8972f-e18c-4c0a-bd66-60d934eafa76', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:24:20', 178, 0, '', '2019-05-29 23:24:21');
INSERT INTO `access_log` VALUES (14059, '2c32611e-4dd1-4c08-acdc-bd2af525c4eb', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:24:20', 213, 0, '', '2019-05-29 23:24:21');
INSERT INTO `access_log` VALUES (14060, '877f1258-55c8-4387-9c81-e5b0e05343f9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:25:23', 243, 0, '', '2019-05-29 23:25:23');
INSERT INTO `access_log` VALUES (14061, 'a364acc6-c5e3-44a0-b809-73638d0dcae3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:25:23', 237, 0, '', '2019-05-29 23:25:23');
INSERT INTO `access_log` VALUES (14062, '48485497-307f-4f9e-9eb7-38e7da754e30', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:25:23', 240, 0, '', '2019-05-29 23:25:23');
INSERT INTO `access_log` VALUES (14063, 'ae78f887-ffae-428e-befc-c109d8aee031', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:25:23', 176, 0, '', '2019-05-29 23:25:23');
INSERT INTO `access_log` VALUES (14064, 'c5618996-cae5-4781-99b4-e7b7f490c03d', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:25:23', 210, 0, '', '2019-05-29 23:25:23');
INSERT INTO `access_log` VALUES (14065, '192d08cc-810f-4689-b6af-7ae712c50901', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:25:27', 144, 0, '', '2019-05-29 23:25:27');
INSERT INTO `access_log` VALUES (14066, '972362af-3635-471d-a158-3d6ca1db0d5c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:25:27', 150, 0, '', '2019-05-29 23:25:27');
INSERT INTO `access_log` VALUES (14067, 'a8279477-dee9-4d9c-a3bd-cb541db6dba5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:25:27', 151, 0, '', '2019-05-29 23:25:27');
INSERT INTO `access_log` VALUES (14068, '5f9696e9-9c58-44a0-bf53-109ca6774d09', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:25:27', 205, 0, '', '2019-05-29 23:25:27');
INSERT INTO `access_log` VALUES (14069, 'ff5d5c62-e31b-4250-8cf3-7da417ebc753', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:25:27', 241, 0, '', '2019-05-29 23:25:27');
INSERT INTO `access_log` VALUES (14070, '0445d96a-f7dd-4630-a893-f6083d6db9ce', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:27:22', 355, 0, '', '2019-05-29 23:27:22');
INSERT INTO `access_log` VALUES (14071, '3d6b869a-aec4-4c52-a7f3-6984b5bcfb27', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:28:55', 245, 0, '', '2019-05-29 23:28:55');
INSERT INTO `access_log` VALUES (14072, '80e214e1-c1ee-4157-95ec-44ff01ad0cc1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:28:55', 244, 0, '', '2019-05-29 23:28:55');
INSERT INTO `access_log` VALUES (14073, '05286864-3ad5-467a-9053-c6a8a003c925', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:28:55', 246, 0, '', '2019-05-29 23:28:55');
INSERT INTO `access_log` VALUES (14074, '557043ca-5746-4fb7-91ec-bb781780344b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:28:55', 180, 0, '', '2019-05-29 23:28:56');
INSERT INTO `access_log` VALUES (14075, '4412120e-583c-499b-8d47-67494ad45f9e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:29:12', 146, 0, '', '2019-05-29 23:29:12');
INSERT INTO `access_log` VALUES (14076, '51e1b07e-aad1-48c6-aa9b-172c28f5eac1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:29:12', 140, 0, '', '2019-05-29 23:29:12');
INSERT INTO `access_log` VALUES (14077, 'bbb3f87f-43d7-4951-97d0-f6a1272920e1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:29:12', 145, 0, '', '2019-05-29 23:29:12');
INSERT INTO `access_log` VALUES (14078, 'd2bc9244-239b-4ef4-a15f-12a3b888f00d', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:29:12', 207, 0, '', '2019-05-29 23:29:12');
INSERT INTO `access_log` VALUES (14079, 'ece447b5-c93d-442a-9b06-856a66f15dbd', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:29:15', 170, 0, '', '2019-05-29 23:29:15');
INSERT INTO `access_log` VALUES (14080, 'b57ce057-ce84-49b7-88df-f5361554862e', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:29:15', 207, 0, '', '2019-05-29 23:29:15');
INSERT INTO `access_log` VALUES (14081, '35de9bcb-1ec1-4797-98d4-ba5e5c844486', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=15', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:29:17', 142, 0, '', '2019-05-29 23:29:18');
INSERT INTO `access_log` VALUES (14082, '821cca18-b67c-40a5-b1b9-17f57b06f822', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=4', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-29 23:29:21', 211, 0, '', '2019-05-29 23:29:22');
INSERT INTO `access_log` VALUES (14083, '65.50.15591447418810013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.228.89.5', '2019-05-29 23:45:42', 14, 1002002001, '密码不正确', '2019-05-29 23:45:42');
INSERT INTO `access_log` VALUES (14084, '65.50.15591511613500099', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:32:41', 0, 1002001015, '账号未登陆', '2019-05-30 01:32:41');
INSERT INTO `access_log` VALUES (14085, '65.46.15591511613510093', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:32:41', 0, 1002001015, '账号未登陆', '2019-05-30 01:32:41');
INSERT INTO `access_log` VALUES (14086, '65.47.15591511613500107', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:32:41', 1, 1002001015, '账号未登陆', '2019-05-30 01:32:41');
INSERT INTO `access_log` VALUES (14087, '65.54.15591511634010081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:32:43', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-30 01:32:43');
INSERT INTO `access_log` VALUES (14088, '65.53.15591511661090087', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:32:46', 62, 0, '', '2019-05-30 01:32:46');
INSERT INTO `access_log` VALUES (14089, '65.48.15591511663990109', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:32:46', 11, 0, '', '2019-05-30 01:32:46');
INSERT INTO `access_log` VALUES (14090, '65.45.15591511664020113', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:32:46', 13, 0, '', '2019-05-30 01:32:46');
INSERT INTO `access_log` VALUES (14091, '65.51.15591511664070101', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:32:46', 14, 0, '', '2019-05-30 01:32:46');
INSERT INTO `access_log` VALUES (14092, '62.86.15591511728780645', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:32:53', 23, 0, '', '2019-05-30 01:32:53');
INSERT INTO `access_log` VALUES (14093, '62.89.15591511804650657', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:33:00', 15, 0, '', '2019-05-30 01:33:00');
INSERT INTO `access_log` VALUES (14094, '62.84.15591511818840649', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:33:02', 12, 0, '', '2019-05-30 01:33:02');
INSERT INTO `access_log` VALUES (14095, '64.76.15591511878290069', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:33:08', 19, 0, '', '2019-05-30 01:33:08');
INSERT INTO `access_log` VALUES (14096, '64.83.15591511878280067', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:33:08', 22, 0, '', '2019-05-30 01:33:08');
INSERT INTO `access_log` VALUES (14097, '62.85.15591512200580657', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:33:40', 13, 0, '', '2019-05-30 01:33:40');
INSERT INTO `access_log` VALUES (14098, '64.81.15591512227590065', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:33:43', 14, 0, '', '2019-05-30 01:33:43');
INSERT INTO `access_log` VALUES (14099, '64.82.15591512227590077', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:33:43', 16, 0, '', '2019-05-30 01:33:43');
INSERT INTO `access_log` VALUES (14100, '64.80.15591512249490065', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:33:45', 13, 0, '', '2019-05-30 01:33:45');
INSERT INTO `access_log` VALUES (14101, '64.77.15591512249500071', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:33:45', 16, 0, '', '2019-05-30 01:33:45');
INSERT INTO `access_log` VALUES (14102, '64.78.15591512249480073', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:33:45', 23, 0, '', '2019-05-30 01:33:45');
INSERT INTO `access_log` VALUES (14103, '62.87.15591512267470659', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:33:47', 15, 0, '', '2019-05-30 01:33:47');
INSERT INTO `access_log` VALUES (14104, '64.85.15591512295900073', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:33:50', 9, 0, '', '2019-05-30 01:33:50');
INSERT INTO `access_log` VALUES (14105, '64.79.15591512453890067', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:34:05', 12, 0, '', '2019-05-30 01:34:05');
INSERT INTO `access_log` VALUES (14106, '64.76.15591512453890071', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:34:05', 15, 0, '', '2019-05-30 01:34:05');
INSERT INTO `access_log` VALUES (14107, '66.53.15591512740989701', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:34:34', 23, 0, '', '2019-05-30 01:34:34');
INSERT INTO `access_log` VALUES (14108, '59.73.15591512812540733', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:34:41', 21, 0, '', '2019-05-30 01:34:41');
INSERT INTO `access_log` VALUES (14109, '59.76.15591512890140727', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:34:49', 20, 2001001000, '服务端发生异常', '2019-05-30 01:34:49');
INSERT INTO `access_log` VALUES (14110, '59.79.15591512942330731', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:34:54', 21, 2001001000, '服务端发生异常', '2019-05-30 01:34:54');
INSERT INTO `access_log` VALUES (14111, '59.78.15591513008170739', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:35:01', 13, 0, '', '2019-05-30 01:35:01');
INSERT INTO `access_log` VALUES (14112, '64.80.15591513033410067', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:35:03', 12, 0, '', '2019-05-30 01:35:03');
INSERT INTO `access_log` VALUES (14113, '64.85.15591513171050075', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:35:17', 10, 0, '', '2019-05-30 01:35:17');
INSERT INTO `access_log` VALUES (14114, '59.72.15591513180030727', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:35:18', 13, 0, '', '2019-05-30 01:35:18');
INSERT INTO `access_log` VALUES (14115, '64.76.15591513363630073', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:35:36', 10, 0, '', '2019-05-30 01:35:36');
INSERT INTO `access_log` VALUES (14116, '65.47.15591513535370111', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:35:54', 10, 0, '', '2019-05-30 01:35:54');
INSERT INTO `access_log` VALUES (14117, '65.46.15591513535410097', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:35:54', 10, 0, '', '2019-05-30 01:35:54');
INSERT INTO `access_log` VALUES (14118, '65.50.15591513535450103', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:35:54', 9, 0, '', '2019-05-30 01:35:54');
INSERT INTO `access_log` VALUES (14119, '59.73.15591513564510735', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:35:56', 13, 0, '', '2019-05-30 01:35:56');
INSERT INTO `access_log` VALUES (14120, '59.75.15591513603040735', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:36:00', 13, 0, '', '2019-05-30 01:36:00');
INSERT INTO `access_log` VALUES (14121, '59.76.15591513627810729', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:36:03', 12, 0, '', '2019-05-30 01:36:03');
INSERT INTO `access_log` VALUES (14122, '59.79.15591513636990733', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:36:04', 13, 0, '', '2019-05-30 01:36:04');
INSERT INTO `access_log` VALUES (14123, '59.77.15591513708560731', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:36:11', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-30 01:36:11');
INSERT INTO `access_log` VALUES (14124, '65.45.15591513787650117', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:36:19', 19, 0, '', '2019-05-30 01:36:19');
INSERT INTO `access_log` VALUES (14125, '65.48.15591513825980113', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:36:23', 12, 0, '', '2019-05-30 01:36:23');
INSERT INTO `access_log` VALUES (14126, '65.49.15591513849310107', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:36:25', 12, 0, '', '2019-05-30 01:36:25');
INSERT INTO `access_log` VALUES (14127, '65.52.15591513867660095', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:36:27', 10, 0, '', '2019-05-30 01:36:27');
INSERT INTO `access_log` VALUES (14128, '65.50.15591513896150105', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:36:30', 13, 0, '', '2019-05-30 01:36:30');
INSERT INTO `access_log` VALUES (14129, '65.46.15591513961700099', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:36:36', 9, 0, '', '2019-05-30 01:36:36');
INSERT INTO `access_log` VALUES (14130, '65.54.15591514055780087', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:36:46', 203, 0, '', '2019-05-30 01:36:46');
INSERT INTO `access_log` VALUES (14131, '59.80.15591519841390743', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:24', 4, 0, '', '2019-05-30 01:46:24');
INSERT INTO `access_log` VALUES (14132, '59.74.15591519841400745', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:24', 17, 2001001000, '服务端发生异常', '2019-05-30 01:46:24');
INSERT INTO `access_log` VALUES (14133, '64.77.15591519868690083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:27', 4, 0, '', '2019-05-30 01:46:27');
INSERT INTO `access_log` VALUES (14134, '64.80.15591519869930077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:27', 3, 0, '', '2019-05-30 01:46:27');
INSERT INTO `access_log` VALUES (14135, '64.78.15591519882780085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:28', 2, 0, '', '2019-05-30 01:46:28');
INSERT INTO `access_log` VALUES (14136, '64.85.15591519886390085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:29', 2, 0, '', '2019-05-30 01:46:29');
INSERT INTO `access_log` VALUES (14137, '59.71.15591519898430745', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:30', 4, 0, '', '2019-05-30 01:46:30');
INSERT INTO `access_log` VALUES (14138, '59.73.15591519898430745', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:30', 13, 2001001000, '服务端发生异常', '2019-05-30 01:46:30');
INSERT INTO `access_log` VALUES (14139, '64.83.15591519921730081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:32', 2, 0, '', '2019-05-30 01:46:32');
INSERT INTO `access_log` VALUES (14140, '64.79.15591519923060079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:32', 3, 0, '', '2019-05-30 01:46:32');
INSERT INTO `access_log` VALUES (14141, '59.75.15591519929580745', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:33', 3, 0, '', '2019-05-30 01:46:33');
INSERT INTO `access_log` VALUES (14142, '59.76.15591519929580739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:33', 13, 2001001000, '服务端发生异常', '2019-05-30 01:46:33');
INSERT INTO `access_log` VALUES (14143, '64.76.15591519947670083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:35', 2, 0, '', '2019-05-30 01:46:35');
INSERT INTO `access_log` VALUES (14144, '64.84.15591519948840087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:35', 2, 0, '', '2019-05-30 01:46:35');
INSERT INTO `access_log` VALUES (14145, '66.53.15591519972309711', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:37', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空', '2019-05-30 01:46:37');
INSERT INTO `access_log` VALUES (14146, '64.82.15591520027650091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:43', 2, 0, '', '2019-05-30 01:46:43');
INSERT INTO `access_log` VALUES (14147, '64.77.15591520028860085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:43', 2, 0, '', '2019-05-30 01:46:43');
INSERT INTO `access_log` VALUES (14148, '64.78.15591520167520087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:57', 2, 0, '', '2019-05-30 01:46:57');
INSERT INTO `access_log` VALUES (14149, '64.85.15591520168860087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:57', 2, 0, '', '2019-05-30 01:46:57');
INSERT INTO `access_log` VALUES (14150, '59.77.15591520185660741', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:59', 4, 0, '', '2019-05-30 01:46:59');
INSERT INTO `access_log` VALUES (14151, '59.72.15591520185660739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.188.93.90', '2019-05-30 01:46:59', 13, 2001001000, '服务端发生异常', '2019-05-30 01:46:59');
INSERT INTO `access_log` VALUES (14152, '59.76.15591772803011077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:48:00', 14, 2001001000, '服务端发生异常', '2019-05-30 08:48:00');
INSERT INTO `access_log` VALUES (14153, '59.75.15591772802881083', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:48:00', 33, 0, '', '2019-05-30 08:48:00');
INSERT INTO `access_log` VALUES (14154, '64.77.15591773025470423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:48:23', 15, 0, '', '2019-05-30 08:48:23');
INSERT INTO `access_log` VALUES (14155, '64.80.15591773027610417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:48:23', 3, 0, '', '2019-05-30 08:48:23');
INSERT INTO `access_log` VALUES (14156, '65.53.15591773505430439', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:49:11', 1, 1002001015, '账号未登陆', '2019-05-30 08:49:11');
INSERT INTO `access_log` VALUES (14157, '65.45.15591773505440465', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:49:11', 1, 1002001015, '账号未登陆', '2019-05-30 08:49:11');
INSERT INTO `access_log` VALUES (14158, '65.48.15591773505540461', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:49:11', 0, 1002001015, '账号未登陆', '2019-05-30 08:49:11');
INSERT INTO `access_log` VALUES (14159, '65.46.15591774164440447', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:50:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-30 08:50:16');
INSERT INTO `access_log` VALUES (14160, '65.54.15591774352760435', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:50:35', 97, 0, '', '2019-05-30 08:50:35');
INSERT INTO `access_log` VALUES (14161, '65.45.15591774358840467', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:50:36', 78, 0, '', '2019-05-30 08:50:36');
INSERT INTO `access_log` VALUES (14162, '65.48.15591774358840463', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:50:36', 81, 0, '', '2019-05-30 08:50:36');
INSERT INTO `access_log` VALUES (14163, '65.53.15591774359220441', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:50:36', 43, 0, '', '2019-05-30 08:50:36');
INSERT INTO `access_log` VALUES (14164, '62.89.15591774444931009', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:50:44', 24, 0, '', '2019-05-30 08:50:45');
INSERT INTO `access_log` VALUES (14165, '62.80.15591774689071007', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:51:09', 15, 0, '', '2019-05-30 08:51:09');
INSERT INTO `access_log` VALUES (14166, '62.88.15591774706351011', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:51:11', 14, 0, '', '2019-05-30 08:51:11');
INSERT INTO `access_log` VALUES (14167, '62.85.15591774728561009', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:51:13', 13, 0, '', '2019-05-30 08:51:13');
INSERT INTO `access_log` VALUES (14168, '62.87.15591774791221011', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:51:19', 16, 0, '', '2019-05-30 08:51:19');
INSERT INTO `access_log` VALUES (14169, '59.74.15591774950471087', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:51:35', 12, 0, '', '2019-05-30 08:51:35');
INSERT INTO `access_log` VALUES (14170, '65.54.15591775190010437', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:51:59', 20, 0, '', '2019-05-30 08:51:59');
INSERT INTO `access_log` VALUES (14171, '65.53.15591775222210443', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:52:02', 10, 0, '', '2019-05-30 08:52:02');
INSERT INTO `access_log` VALUES (14172, '65.45.15591775250680469', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:52:05', 10, 0, '', '2019-05-30 08:52:05');
INSERT INTO `access_log` VALUES (14173, '65.51.15591775329640457', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:52:13', 10, 0, '', '2019-05-30 08:52:13');
INSERT INTO `access_log` VALUES (14174, '65.49.15591775329720459', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:52:13', 10, 0, '', '2019-05-30 08:52:13');
INSERT INTO `access_log` VALUES (14175, '65.52.15591775329780447', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:52:13', 9, 0, '', '2019-05-30 08:52:13');
INSERT INTO `access_log` VALUES (14176, '65.50.15591775331100457', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:52:13', 10, 0, '', '2019-05-30 08:52:13');
INSERT INTO `access_log` VALUES (14177, '65.46.15591775404340451', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:52:20', 15, 0, '', '2019-05-30 08:52:20');
INSERT INTO `access_log` VALUES (14178, '59.72.15591776053741081', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:53:25', 9, 0, '', '2019-05-30 08:53:25');
INSERT INTO `access_log` VALUES (14179, '59.80.15591776053751087', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:53:25', 12, 2001001000, '服务端发生异常', '2019-05-30 08:53:25');
INSERT INTO `access_log` VALUES (14180, '64.78.15591776094940429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:53:29', 3, 0, '', '2019-05-30 08:53:29');
INSERT INTO `access_log` VALUES (14181, '64.85.15591776096080429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:53:30', 2, 0, '', '2019-05-30 08:53:30');
INSERT INTO `access_log` VALUES (14182, '64.83.15591776132540425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:53:33', 3, 0, '', '2019-05-30 08:53:33');
INSERT INTO `access_log` VALUES (14183, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:53:33', 18, 0, '', '2019-05-30 08:53:33');
INSERT INTO `access_log` VALUES (14184, '64.79.15591776148640423', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:53:35', 1059, 0, '', '2019-05-30 08:53:36');
INSERT INTO `access_log` VALUES (14185, '64.84.15591776286330431', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '39.91.107.37', '2019-05-30 08:53:49', 8, 0, '', '2019-05-30 08:53:49');
INSERT INTO `access_log` VALUES (14186, '59.79.15591791817021107', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:19:42', 4, 0, '', '2019-05-30 09:19:42');
INSERT INTO `access_log` VALUES (14187, '59.78.15591791817041115', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:19:42', 13, 2001001000, '服务端发生异常', '2019-05-30 09:19:42');
INSERT INTO `access_log` VALUES (14188, '59.72.15591792016221103', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:02', 3, 0, '', '2019-05-30 09:20:02');
INSERT INTO `access_log` VALUES (14189, '59.80.15591792016241109', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:02', 13, 2001001000, '服务端发生异常', '2019-05-30 09:20:02');
INSERT INTO `access_log` VALUES (14190, '64.83.15591792110750447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:11', 3, 0, '', '2019-05-30 09:20:11');
INSERT INTO `access_log` VALUES (14191, '64.76.15591792111810449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:11', 2, 0, '', '2019-05-30 09:20:11');
INSERT INTO `access_log` VALUES (14192, '64.79.15591792148220445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:15', 37, 0, '', '2019-05-30 09:20:15');
INSERT INTO `access_log` VALUES (14193, '64.84.15591792150370453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:15', 2, 0, '', '2019-05-30 09:20:15');
INSERT INTO `access_log` VALUES (14194, '64.81.15591792158110445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:16', 2, 0, '', '2019-05-30 09:20:16');
INSERT INTO `access_log` VALUES (14195, '64.82.15591792163330457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:16', 112, 0, '', '2019-05-30 09:20:16');
INSERT INTO `access_log` VALUES (14196, '65.45.15591792295060493', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:30', 1, 1002001015, '账号未登陆', '2019-05-30 09:20:30');
INSERT INTO `access_log` VALUES (14197, '65.51.15591792295060481', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:30', 0, 1002001015, '账号未登陆', '2019-05-30 09:20:30');
INSERT INTO `access_log` VALUES (14198, '65.48.15591792295060489', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:30', 1, 1002001015, '账号未登陆', '2019-05-30 09:20:30');
INSERT INTO `access_log` VALUES (14199, '65.49.15591792315710483', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-30 09:20:32');
INSERT INTO `access_log` VALUES (14200, '65.52.15591792335430471', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-30 09:20:34');
INSERT INTO `access_log` VALUES (14201, '65.50.15591792344470481', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-30 09:20:34');
INSERT INTO `access_log` VALUES (14202, '65.46.15591792348520475', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-30 09:20:35');
INSERT INTO `access_log` VALUES (14203, '65.47.15591792350440489', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:35', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-30 09:20:35');
INSERT INTO `access_log` VALUES (14204, '65.53.15591792505790469', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:51', 65, 0, '', '2019-05-30 09:20:51');
INSERT INTO `access_log` VALUES (14205, '65.51.15591792509110483', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:51', 10, 0, '', '2019-05-30 09:20:51');
INSERT INTO `access_log` VALUES (14206, '65.48.15591792509110491', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:51', 9, 0, '', '2019-05-30 09:20:51');
INSERT INTO `access_log` VALUES (14207, '65.45.15591792509100495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:20:51', 10, 0, '', '2019-05-30 09:20:51');
INSERT INTO `access_log` VALUES (14208, '62.82.15591792639421033', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:21:04', 15, 0, '', '2019-05-30 09:21:04');
INSERT INTO `access_log` VALUES (14209, '62.89.15591792684761035', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:21:08', 795, 0, '', '2019-05-30 09:21:09');
INSERT INTO `access_log` VALUES (14210, '65.50.15591792721420483', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:21:12', 3, 1002001012, '访问令牌已过期', '2019-05-30 09:21:12');
INSERT INTO `access_log` VALUES (14211, '65.46.15591792721550477', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:21:12', 3, 1002001012, '访问令牌已过期', '2019-05-30 09:21:12');
INSERT INTO `access_log` VALUES (14212, '65.47.15591792721650491', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:21:12', 3, 1002001012, '访问令牌已过期', '2019-05-30 09:21:12');
INSERT INTO `access_log` VALUES (14213, '64.76.15591792727760451', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:21:13', 9, 1002001012, '访问令牌已过期', '2019-05-30 09:21:13');
INSERT INTO `access_log` VALUES (14214, '64.83.15591792727760449', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:21:13', 9, 1002001012, '访问令牌已过期', '2019-05-30 09:21:13');
INSERT INTO `access_log` VALUES (14215, '65.54.15591792812210465', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:21:21', 19, 0, '', '2019-05-30 09:21:21');
INSERT INTO `access_log` VALUES (14216, '65.53.15591792829540471', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:21:23', 11, 0, '', '2019-05-30 09:21:23');
INSERT INTO `access_log` VALUES (14217, '65.51.15591792845780485', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:21:25', 9, 0, '', '2019-05-30 09:21:25');
INSERT INTO `access_log` VALUES (14218, '65.45.15591792859760497', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:21:26', 14, 0, '', '2019-05-30 09:21:26');
INSERT INTO `access_log` VALUES (14219, '65.49.15591792866930487', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.233.220.36', '2019-05-30 09:21:27', 229, 0, '', '2019-05-30 09:21:27');
INSERT INTO `access_log` VALUES (14220, '65.51.15591801432130497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:35:43', 94, 0, '', '2019-05-30 09:35:43');
INSERT INTO `access_log` VALUES (14221, '65.45.15591801436090509', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:35:44', 9, 0, '', '2019-05-30 09:35:44');
INSERT INTO `access_log` VALUES (14222, '65.49.15591801436100499', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:35:44', 8, 0, '', '2019-05-30 09:35:44');
INSERT INTO `access_log` VALUES (14223, '65.52.15591801436290487', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:35:44', 9, 0, '', '2019-05-30 09:35:44');
INSERT INTO `access_log` VALUES (14224, '64.82.15591802122140471', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:36:52', 12, 0, '', '2019-05-30 09:36:52');
INSERT INTO `access_log` VALUES (14225, '59.74.15591802421901125', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.65', '2019-05-30 09:37:22', 5, 0, '', '2019-05-30 09:37:22');
INSERT INTO `access_log` VALUES (14226, '59.71.15591802421901125', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.65', '2019-05-30 09:37:22', 15, 2001001000, '服务端发生异常', '2019-05-30 09:37:22');
INSERT INTO `access_log` VALUES (14227, '64.78.15591802450310467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.65', '2019-05-30 09:37:25', 3, 0, '', '2019-05-30 09:37:25');
INSERT INTO `access_log` VALUES (14228, '64.85.15591802452100467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.65', '2019-05-30 09:37:25', 2, 0, '', '2019-05-30 09:37:25');
INSERT INTO `access_log` VALUES (14229, '64.83.15591802470990463', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.65', '2019-05-30 09:37:27', 3, 0, '', '2019-05-30 09:37:27');
INSERT INTO `access_log` VALUES (14230, '64.76.15591802480500465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.65', '2019-05-30 09:37:28', 2, 0, '', '2019-05-30 09:37:28');
INSERT INTO `access_log` VALUES (14231, '64.79.15591802487060461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.65', '2019-05-30 09:37:29', 3, 0, '', '2019-05-30 09:37:29');
INSERT INTO `access_log` VALUES (14232, '64.81.15591802682010461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; PAR-AL00 Build/HUAWEIPAR-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3327 MicroMessenger/7.0.4.1420(0x27000481) Process/tools NetType/WIFI Language/zh_CN', '219.147.98.65', '2019-05-30 09:37:48', 2, 0, '', '2019-05-30 09:37:48');
INSERT INTO `access_log` VALUES (14233, '64.82.15591802683850473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; PAR-AL00 Build/HUAWEIPAR-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3327 MicroMessenger/7.0.4.1420(0x27000481) Process/tools NetType/WIFI Language/zh_CN', '219.147.98.65', '2019-05-30 09:37:48', 2, 0, '', '2019-05-30 09:37:48');
INSERT INTO `access_log` VALUES (14234, '64.77.15591802701290467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; PAR-AL00 Build/HUAWEIPAR-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3327 MicroMessenger/7.0.4.1420(0x27000481) Process/tools NetType/WIFI Language/zh_CN', '219.147.98.65', '2019-05-30 09:37:50', 2, 0, '', '2019-05-30 09:37:50');
INSERT INTO `access_log` VALUES (14235, '64.78.15591802711050469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; PAR-AL00 Build/HUAWEIPAR-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3327 MicroMessenger/7.0.4.1420(0x27000481) Process/tools NetType/WIFI Language/zh_CN', '219.147.98.65', '2019-05-30 09:37:51', 2, 0, '', '2019-05-30 09:37:51');
INSERT INTO `access_log` VALUES (14236, '64.85.15591802722710469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; PAR-AL00 Build/HUAWEIPAR-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3327 MicroMessenger/7.0.4.1420(0x27000481) Process/tools NetType/WIFI Language/zh_CN', '219.147.98.65', '2019-05-30 09:37:52', 2, 0, '', '2019-05-30 09:37:52');
INSERT INTO `access_log` VALUES (14237, '64.83.15591802731160465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; PAR-AL00 Build/HUAWEIPAR-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3327 MicroMessenger/7.0.4.1420(0x27000481) Process/tools NetType/WIFI Language/zh_CN', '219.147.98.65', '2019-05-30 09:37:53', 2, 0, '', '2019-05-30 09:37:53');
INSERT INTO `access_log` VALUES (14238, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; PAR-AL00 Build/HUAWEIPAR-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3327 MicroMessenger/7.0.4.1420(0x27000481) Process/tools NetType/WIFI Language/zh_CN', '219.147.98.65', '2019-05-30 09:37:53', 18, 0, '', '2019-05-30 09:37:53');
INSERT INTO `access_log` VALUES (14239, '64.76.15591802749330467', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; PAR-AL00 Build/HUAWEIPAR-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3327 MicroMessenger/7.0.4.1420(0x27000481) Process/tools NetType/WIFI Language/zh_CN', '219.147.98.65', '2019-05-30 09:37:55', 9, 0, '', '2019-05-30 09:37:55');
INSERT INTO `access_log` VALUES (14240, '66.54.15591802892140083', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15611861576', 'POST', 'Mozilla/5.0 (Linux; Android 9; PAR-AL00 Build/HUAWEIPAR-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3327 MicroMessenger/7.0.4.1420(0x27000481) Process/tools NetType/WIFI Language/zh_CN', '219.147.98.65', '2019-05-30 09:38:09', 103, 0, '', '2019-05-30 09:38:09');
INSERT INTO `access_log` VALUES (14241, '66.55.15591803060850097', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15611861576', 'POST', 'Mozilla/5.0 (Linux; Android 9; PAR-AL00 Build/HUAWEIPAR-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3327 MicroMessenger/7.0.4.1420(0x27000481) Process/tools NetType/WIFI Language/zh_CN', '219.147.98.65', '2019-05-30 09:38:26', 508, 1001003005, '短信发送过于频率', '2019-05-30 09:38:27');
INSERT INTO `access_log` VALUES (14242, '66.53.15591803136990093', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15611861576&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; PAR-AL00 Build/HUAWEIPAR-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3327 MicroMessenger/7.0.4.1420(0x27000481) Process/tools NetType/WIFI Language/zh_CN', '219.147.98.65', '2019-05-30 09:38:34', 192, 0, '', '2019-05-30 09:38:34');
INSERT INTO `access_log` VALUES (14243, '66.57.15591803152170089', 91, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; PAR-AL00 Build/HUAWEIPAR-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3327 MicroMessenger/7.0.4.1420(0x27000481) Process/tools NetType/WIFI Language/zh_CN', '219.147.98.65', '2019-05-30 09:38:35', 7, 0, '', '2019-05-30 09:38:35');
INSERT INTO `access_log` VALUES (14244, '64.85.15591805244610473', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:42:04', 11, 0, '', '2019-05-30 09:42:04');
INSERT INTO `access_log` VALUES (14245, '64.78.15591805244600473', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:42:04', 16, 0, '', '2019-05-30 09:42:04');
INSERT INTO `access_log` VALUES (14246, '64.76.15591805290520471', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:42:09', 14, 0, '', '2019-05-30 09:42:09');
INSERT INTO `access_log` VALUES (14247, '64.82.15591805692430479', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:42:49', 12, 0, '', '2019-05-30 09:42:49');
INSERT INTO `access_log` VALUES (14248, '64.81.15591805692430467', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:42:49', 16, 0, '', '2019-05-30 09:42:49');
INSERT INTO `access_log` VALUES (14249, '64.77.15591805692810473', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:42:49', 9, 0, '', '2019-05-30 09:42:49');
INSERT INTO `access_log` VALUES (14250, '64.83.15591805905130471', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:43:11', 9, 0, '', '2019-05-30 09:43:11');
INSERT INTO `access_log` VALUES (14251, '64.85.15591805905110475', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:43:11', 17, 0, '', '2019-05-30 09:43:11');
INSERT INTO `access_log` VALUES (14252, '59.78.15591806080121135', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:43:28', 4, 0, '', '2019-05-30 09:43:28');
INSERT INTO `access_log` VALUES (14253, '59.77.15591806080191125', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:43:28', 12, 2001001000, '服务端发生异常', '2019-05-30 09:43:28');
INSERT INTO `access_log` VALUES (14254, '64.79.15591806127180469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:43:33', 2, 0, '', '2019-05-30 09:43:33');
INSERT INTO `access_log` VALUES (14255, '64.84.15591806128440477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:43:33', 3, 0, '', '2019-05-30 09:43:33');
INSERT INTO `access_log` VALUES (14256, '64.82.15591806150660481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:43:35', 3, 0, '', '2019-05-30 09:43:35');
INSERT INTO `access_log` VALUES (14257, '64.77.15591806159860475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:43:36', 2, 0, '', '2019-05-30 09:43:36');
INSERT INTO `access_log` VALUES (14258, '64.80.15591806168330469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:43:37', 2, 0, '', '2019-05-30 09:43:37');
INSERT INTO `access_log` VALUES (14259, '64.78.15591806178980477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:43:38', 3, 0, '', '2019-05-30 09:43:38');
INSERT INTO `access_log` VALUES (14260, '64.85.15591806182900477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:43:38', 2, 0, '', '2019-05-30 09:43:38');
INSERT INTO `access_log` VALUES (14261, '64.83.15591806197690473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:43:40', 2, 0, '', '2019-05-30 09:43:40');
INSERT INTO `access_log` VALUES (14262, '66.50.15591806245360093', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:43:45', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机号不能为空\n手机验证码长度为 4-6 位', '2019-05-30 09:43:45');
INSERT INTO `access_log` VALUES (14263, '64.84.15591806402100479', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:44:00', 12, 0, '', '2019-05-30 09:44:00');
INSERT INTO `access_log` VALUES (14264, '64.79.15591806402100471', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:44:00', 17, 0, '', '2019-05-30 09:44:00');
INSERT INTO `access_log` VALUES (14265, '64.82.15591806402270483', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:44:00', 10, 0, '', '2019-05-30 09:44:00');
INSERT INTO `access_log` VALUES (14266, '66.51.15591806409280093', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13366669999&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:01', 10, 1001003000, '验证码不存在', '2019-05-30 09:44:01');
INSERT INTO `access_log` VALUES (14267, '66.52.15591806503510091', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:10', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号必须都是数字\n手机号不能为空', '2019-05-30 09:44:10');
INSERT INTO `access_log` VALUES (14268, '64.80.15591806528410471', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:44:13', 10, 0, '', '2019-05-30 09:44:13');
INSERT INTO `access_log` VALUES (14269, '64.77.15591806528410477', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:44:13', 12, 0, '', '2019-05-30 09:44:13');
INSERT INTO `access_log` VALUES (14270, '64.78.15591806562960479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:16', 2, 0, '', '2019-05-30 09:44:16');
INSERT INTO `access_log` VALUES (14271, '64.85.15591806564030479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:16', 2, 0, '', '2019-05-30 09:44:16');
INSERT INTO `access_log` VALUES (14272, '59.73.15591806577661131', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:18', 3, 0, '', '2019-05-30 09:44:18');
INSERT INTO `access_log` VALUES (14273, '59.74.15591806577661131', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:18', 14, 2001001000, '服务端发生异常', '2019-05-30 09:44:18');
INSERT INTO `access_log` VALUES (14274, '64.83.15591806602940475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:20', 2, 0, '', '2019-05-30 09:44:20');
INSERT INTO `access_log` VALUES (14275, '64.76.15591806603910477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:20', 2, 0, '', '2019-05-30 09:44:20');
INSERT INTO `access_log` VALUES (14276, '59.79.15591806623311129', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:22', 3, 0, '', '2019-05-30 09:44:22');
INSERT INTO `access_log` VALUES (14277, '59.75.15591806623311131', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:22', 13, 2001001000, '服务端发生异常', '2019-05-30 09:44:22');
INSERT INTO `access_log` VALUES (14278, '64.84.15591806642210481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:24', 3, 0, '', '2019-05-30 09:44:24');
INSERT INTO `access_log` VALUES (14279, '64.82.15591806643280485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:24', 2, 0, '', '2019-05-30 09:44:24');
INSERT INTO `access_log` VALUES (14280, '64.81.15591806659700473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:26', 3, 0, '', '2019-05-30 09:44:26');
INSERT INTO `access_log` VALUES (14281, '64.80.15591806664730473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:26', 2, 0, '', '2019-05-30 09:44:26');
INSERT INTO `access_log` VALUES (14282, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:27', 15, 0, '', '2019-05-30 09:44:27');
INSERT INTO `access_log` VALUES (14283, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:27', 15, 0, '', '2019-05-30 09:44:28');
INSERT INTO `access_log` VALUES (14284, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:29', 7, 0, '', '2019-05-30 09:44:29');
INSERT INTO `access_log` VALUES (14285, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:29', 68, 0, '', '2019-05-30 09:44:29');
INSERT INTO `access_log` VALUES (14286, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:29', 11, 0, '', '2019-05-30 09:44:29');
INSERT INTO `access_log` VALUES (14287, '64.77.15591806702410479', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:30', 7, 0, '', '2019-05-30 09:44:30');
INSERT INTO `access_log` VALUES (14288, '66.56.15591806836230089', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:44:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-05-30 09:44:44');
INSERT INTO `access_log` VALUES (14289, '64.83.15591806865300477', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:44:47', 12, 0, '', '2019-05-30 09:44:47');
INSERT INTO `access_log` VALUES (14290, '64.85.15591806865290481', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:44:47', 14, 0, '', '2019-05-30 09:44:47');
INSERT INTO `access_log` VALUES (14291, '64.76.15591806866230479', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:44:47', 10, 0, '', '2019-05-30 09:44:47');
INSERT INTO `access_log` VALUES (14292, '64.81.15591807210700475', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:45:21', 9, 0, '', '2019-05-30 09:45:21');
INSERT INTO `access_log` VALUES (14293, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:45:22', 10, 0, '', '2019-05-30 09:45:22');
INSERT INTO `access_log` VALUES (14294, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:45:22', 6, 0, '', '2019-05-30 09:45:22');
INSERT INTO `access_log` VALUES (14295, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:45:22', 12, 0, '', '2019-05-30 09:45:22');
INSERT INTO `access_log` VALUES (14296, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:45:22', 14, 0, '', '2019-05-30 09:45:22');
INSERT INTO `access_log` VALUES (14297, '64.80.15591807224070475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:45:22', 2, 0, '', '2019-05-30 09:45:22');
INSERT INTO `access_log` VALUES (14298, '64.77.15591807225410481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:45:23', 2, 0, '', '2019-05-30 09:45:23');
INSERT INTO `access_log` VALUES (14299, '59.73.15591807233721133', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:45:23', 4, 0, '', '2019-05-30 09:45:23');
INSERT INTO `access_log` VALUES (14300, '59.71.15591807233711133', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:45:23', 15, 2001001000, '服务端发生异常', '2019-05-30 09:45:23');
INSERT INTO `access_log` VALUES (14301, '65.46.15591807608160499', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:46:01', 0, 1002001015, '账号未登陆', '2019-05-30 09:46:01');
INSERT INTO `access_log` VALUES (14302, '65.47.15591807608170513', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:46:01', 1, 1002001015, '账号未登陆', '2019-05-30 09:46:01');
INSERT INTO `access_log` VALUES (14303, '65.54.15591807608200487', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:46:01', 0, 1002001015, '账号未登陆', '2019-05-30 09:46:01');
INSERT INTO `access_log` VALUES (14304, '65.53.15591807632460493', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:46:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-30 09:46:03');
INSERT INTO `access_log` VALUES (14305, '65.51.15591807768720507', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:46:17', 72, 0, '', '2019-05-30 09:46:17');
INSERT INTO `access_log` VALUES (14306, '65.52.15591807771870497', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:46:17', 9, 0, '', '2019-05-30 09:46:17');
INSERT INTO `access_log` VALUES (14307, '65.45.15591807771910519', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:46:17', 9, 0, '', '2019-05-30 09:46:17');
INSERT INTO `access_log` VALUES (14308, '65.49.15591807771940509', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:46:17', 9, 0, '', '2019-05-30 09:46:17');
INSERT INTO `access_log` VALUES (14309, '62.88.15591808126951057', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:46:53', 16, 0, '', '2019-05-30 09:46:53');
INSERT INTO `access_log` VALUES (14310, '62.85.15591808222011055', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:47:02', 13, 0, '', '2019-05-30 09:47:02');
INSERT INTO `access_log` VALUES (14311, '62.82.15591808458091055', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:47:26', 16, 0, '', '2019-05-30 09:47:26');
INSERT INTO `access_log` VALUES (14312, '62.84.15591808817581049', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 09:47:26&createEndTime=2019-05-11 09:47:26', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:48:02', 14, 0, '', '2019-05-30 09:48:02');
INSERT INTO `access_log` VALUES (14313, '62.80.15591808930501055', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10&createBeginTime=2019-04-02 09:47:26&createEndTime=2019-04-29 09:47:26', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:48:13', 18, 0, '', '2019-05-30 09:48:13');
INSERT INTO `access_log` VALUES (14314, '62.85.15591809098841057', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10&createBeginTime=2019-04-02 09:47:26&createEndTime=2019-04-29 09:47:26&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:48:30', 17, 0, '', '2019-05-30 09:48:30');
INSERT INTO `access_log` VALUES (14315, '62.87.15591809130811059', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10&createBeginTime=2019-04-02 09:47:26&createEndTime=2019-04-29 09:47:26&status=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:48:33', 13, 0, '', '2019-05-30 09:48:33');
INSERT INTO `access_log` VALUES (14316, '62.82.15591809163211057', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10&createBeginTime=2019-04-02 09:47:26&createEndTime=2019-04-29 09:47:26&status=3', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:48:36', 16, 0, '', '2019-05-30 09:48:36');
INSERT INTO `access_log` VALUES (14317, '64.79.15591809209300479', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:48:41', 42, 0, '', '2019-05-30 09:48:41');
INSERT INTO `access_log` VALUES (14318, '64.76.15591809209280483', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:48:41', 44, 0, '', '2019-05-30 09:48:41');
INSERT INTO `access_log` VALUES (14319, '65.51.15591810105930511', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:50:11', 4, 0, '', '2019-05-30 09:50:11');
INSERT INTO `access_log` VALUES (14320, '64.76.15591810433540485', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=第一次体验老奶奶的商城&sellPoint=全面 专业 感觉不错&cid=794&visible=true&picUrls=http://static.shop.iocoder.cn/8a5d4f76-760f-401a-a1ee-dd35bf44a24e&skuStr=[{\"attrs\":[4],\"price\":66600,\"quantity\":666}]&description=<p><span style=\"color:#000000\"><span style=\"font-size:14px\"><span style=\"background-color:#ffffff\">建议尺寸：800*800PX，单张大小不超过 2M，最多可上传 10 张</span></span></span></p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:50:43', 9, 1002002009, NULL, '2019-05-30 09:50:43');
INSERT INTO `access_log` VALUES (14321, '64.84.15591810565480489', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=第一次体验老奶奶的商城&sellPoint=全面 专业 感觉不错&cid=794&visible=true&picUrls=http://static.shop.iocoder.cn/8a5d4f76-760f-401a-a1ee-dd35bf44a24e&skuStr=[{\"attrs\":[4],\"price\":66600,\"quantity\":666}]&description=<p><span style=\"color:#000000\"><span style=\"font-size:14px\"><span style=\"background-color:#ffffff\">建议尺寸：800*800PX，单张大小不超过 2M，最多可上传 10 张</span></span></span></p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:50:57', 8, 1002002009, NULL, '2019-05-30 09:50:57');
INSERT INTO `access_log` VALUES (14322, '64.80.15591810921610481', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=第一次体验老奶奶的商城&sellPoint=全面 专业 感觉不错&cid=794&visible=true&picUrls=http://static.shop.iocoder.cn/8a5d4f76-760f-401a-a1ee-dd35bf44a24e&skuStr=[{\"attrs\":[4],\"price\":66600,\"quantity\":666}]&description=<p><span style=\"color:#000000\"><span style=\"font-size:14px\"><span style=\"background-color:#ffffff\">建议尺寸：800*800PX，单张大小不超过 2M，最多可上传 10 张</span></span></span></p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:51:32', 9, 1002002009, NULL, '2019-05-30 09:51:32');
INSERT INTO `access_log` VALUES (14323, '64.78.15591811000680489', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=第一次体验老奶奶的商城&sellPoint=全面 专业 感觉不错&cid=794&visible=true&picUrls=http://static.shop.iocoder.cn/8a5d4f76-760f-401a-a1ee-dd35bf44a24e&skuStr=[{\"attrs\":[4],\"price\":66600,\"quantity\":666}]&description=<p><span style=\"color:#000000\"><span style=\"font-size:14px\"><span style=\"background-color:#ffffff\">建议尺寸：800*800PX，单张大小不超过 2M，最多可上传 10 张</span></span></span></p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:51:40', 7, 1002002009, NULL, '2019-05-30 09:51:40');
INSERT INTO `access_log` VALUES (14324, '64.85.15591811018260489', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=第一次体验老奶奶的商城&sellPoint=全面 专业 感觉不错&cid=794&visible=true&picUrls=http://static.shop.iocoder.cn/8a5d4f76-760f-401a-a1ee-dd35bf44a24e&skuStr=[{\"attrs\":[4],\"price\":66600,\"quantity\":666}]&description=<p><span style=\"color:#000000\"><span style=\"font-size:14px\"><span style=\"background-color:#ffffff\">建议尺寸：800*800PX，单张大小不超过 2M，最多可上传 10 张</span></span></span></p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:51:42', 8, 1002002009, NULL, '2019-05-30 09:51:42');
INSERT INTO `access_log` VALUES (14325, '64.79.15591811108440483', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:51:51', 9, 0, '', '2019-05-30 09:51:51');
INSERT INTO `access_log` VALUES (14326, '64.76.15591811108440487', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:51:51', 12, 0, '', '2019-05-30 09:51:51');
INSERT INTO `access_log` VALUES (14327, '64.82.15591811363690495', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:52:16', 13, 0, '', '2019-05-30 09:52:16');
INSERT INTO `access_log` VALUES (14328, '64.81.15591811396450483', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:52:20', 13, 0, '', '2019-05-30 09:52:20');
INSERT INTO `access_log` VALUES (14329, '64.78.15591811439360491', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:52:24', 13, 0, '', '2019-05-30 09:52:24');
INSERT INTO `access_log` VALUES (14330, '64.85.15591811439360491', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:52:24', 14, 0, '', '2019-05-30 09:52:24');
INSERT INTO `access_log` VALUES (14331, '64.77.15591811439360489', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:52:24', 16, 0, '', '2019-05-30 09:52:24');
INSERT INTO `access_log` VALUES (14332, '65.51.15591811528730513', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:52:33', 3, 0, '', '2019-05-30 09:52:33');
INSERT INTO `access_log` VALUES (14333, '64.76.15591811562230489', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg,http://static.shop.iocoder.cn/70bf28c5-f136-4592-ba71-dca7180d1e1a&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:52:36', 8, 1002002009, NULL, '2019-05-30 09:52:36');
INSERT INTO `access_log` VALUES (14334, '64.84.15591811613200493', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:52:41', 12, 0, '', '2019-05-30 09:52:41');
INSERT INTO `access_log` VALUES (14335, '64.79.15591811613190485', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:52:41', 14, 0, '', '2019-05-30 09:52:41');
INSERT INTO `access_log` VALUES (14336, '64.82.15591811683360497', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:52:48', 10, 0, '', '2019-05-30 09:52:48');
INSERT INTO `access_log` VALUES (14337, '64.80.15591811792070485', 27, 2, 'product-application', '/product-api/admins/category/update_status', 'id=784&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:52:59', 8, 1002002009, NULL, '2019-05-30 09:52:59');
INSERT INTO `access_log` VALUES (14338, '66.52.15591812237370099', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:53:44', 15, 0, '', '2019-05-30 09:53:44');
INSERT INTO `access_log` VALUES (14339, '66.53.15591812382960107', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10&nickname=123', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:53:58', 14, 0, '', '2019-05-30 09:53:58');
INSERT INTO `access_log` VALUES (14340, '66.57.15591812505410103', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10&status=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:54:11', 56, 0, '', '2019-05-30 09:54:11');
INSERT INTO `access_log` VALUES (14341, '59.77.15591812548051135', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:54:15', 13, 0, '', '2019-05-30 09:54:15');
INSERT INTO `access_log` VALUES (14342, '59.80.15591812649811139', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:54:25', 9, 1002002009, NULL, '2019-05-30 09:54:25');
INSERT INTO `access_log` VALUES (14343, '59.73.15591812691811141', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update', 'id=1&title=百度是最棒的&url=https://user-gold-cdn.xitu.io/2019/3/30/169cdcbb93d48ff1?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1&sort=0&memo=哈哈哈哈&picUrl=https://user-gold-cdn.xitu.io/2019/3/30/169cdcbb93d48ff1?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:54:29', 8, 1002002009, NULL, '2019-05-30 09:54:29');
INSERT INTO `access_log` VALUES (14344, '59.71.15591812697851141', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update', 'id=1&title=百度是最棒的&url=https://user-gold-cdn.xitu.io/2019/3/30/169cdcbb93d48ff1?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1&sort=0&memo=哈哈哈哈&picUrl=https://user-gold-cdn.xitu.io/2019/3/30/169cdcbb93d48ff1?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:54:30', 8, 1002002009, NULL, '2019-05-30 09:54:30');
INSERT INTO `access_log` VALUES (14345, '59.76.15591812782551135', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:54:38', 22, 2001001000, '服务端发生异常', '2019-05-30 09:54:38');
INSERT INTO `access_log` VALUES (14346, '59.79.15591812845871139', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:54:45', 12, 0, '', '2019-05-30 09:54:45');
INSERT INTO `access_log` VALUES (14347, '59.78.15591812954931147', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/update_status', 'id=6&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:54:55', 8, 1002002009, NULL, '2019-05-30 09:54:56');
INSERT INTO `access_log` VALUES (14348, '64.80.15591812976840487', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:54:58', 13, 0, '', '2019-05-30 09:54:58');
INSERT INTO `access_log` VALUES (14349, '64.81.15591812976840487', 27, 2, 'product-application', '/product-api/admins/spu/list', 'ids=29,32,36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:54:58', 19, 0, '', '2019-05-30 09:54:58');
INSERT INTO `access_log` VALUES (14350, '59.77.15591813000901137', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/update_card', 'id=6&title=优惠劵C&description=优惠劵C&quota=1&total=1000&rangeType=20&rangeValues=29,32,36', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:55:00', 7, 1002002009, NULL, '2019-05-30 09:55:00');
INSERT INTO `access_log` VALUES (14351, '64.77.15591813011780493', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:55:01', 11, 0, '', '2019-05-30 09:55:01');
INSERT INTO `access_log` VALUES (14352, '59.80.15591813044051141', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:55:04', 422, 0, '', '2019-05-30 09:55:05');
INSERT INTO `access_log` VALUES (14353, '59.73.15591813120291143', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:55:12', 12, 0, '', '2019-05-30 09:55:12');
INSERT INTO `access_log` VALUES (14354, '59.71.15591813166501143', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:55:17', 12, 0, '', '2019-05-30 09:55:17');
INSERT INTO `access_log` VALUES (14355, '59.76.15591813203471137', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:55:20', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-30 09:55:20');
INSERT INTO `access_log` VALUES (14356, '65.49.15591813279020517', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:55:28', 20, 0, '', '2019-05-30 09:55:28');
INSERT INTO `access_log` VALUES (14357, '64.84.15591813433180497', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:55:43', 371, 0, '', '2019-05-30 09:55:44');
INSERT INTO `access_log` VALUES (14358, '64.82.15591813443580501', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:55:44', 142, 0, '', '2019-05-30 09:55:45');
INSERT INTO `access_log` VALUES (14359, '64.76.15591813433180493', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:55:43', 1226, 0, '', '2019-05-30 09:55:45');
INSERT INTO `access_log` VALUES (14360, '64.79.15591813443420489', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:55:44', 202, 0, '', '2019-05-30 09:55:45');
INSERT INTO `access_log` VALUES (14361, '64.80.15591813469850489', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:55:47', 9, 0, '', '2019-05-30 09:55:47');
INSERT INTO `access_log` VALUES (14362, '64.81.15591813469820489', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:55:47', 13, 0, '', '2019-05-30 09:55:47');
INSERT INTO `access_log` VALUES (14363, '64.85.15591813479280497', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:55:48', 9, 0, '', '2019-05-30 09:55:48');
INSERT INTO `access_log` VALUES (14364, '64.77.15591813479270495', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:55:48', 12, 0, '', '2019-05-30 09:55:48');
INSERT INTO `access_log` VALUES (14365, '64.83.15591813499650493', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:55:50', 46, 0, '', '2019-05-30 09:55:50');
INSERT INTO `access_log` VALUES (14366, '64.78.15591813499630497', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:55:50', 58, 0, '', '2019-05-30 09:55:50');
INSERT INTO `access_log` VALUES (14367, '65.47.15591813510310523', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=erati', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:55:51', 57, 0, '', '2019-05-30 09:55:51');
INSERT INTO `access_log` VALUES (14368, '64.79.15591813515480491', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:55:52', 11, 0, '', '2019-05-30 09:55:52');
INSERT INTO `access_log` VALUES (14369, '65.54.15591813570920497', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:55:57', 18, 0, '', '2019-05-30 09:55:57');
INSERT INTO `access_log` VALUES (14370, '65.53.15591813619380503', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:56:02', 11, 0, '', '2019-05-30 09:56:02');
INSERT INTO `access_log` VALUES (14371, '65.48.15591813634910525', 27, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=1,2,6', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:56:03', 7, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-30 09:56:04');
INSERT INTO `access_log` VALUES (14372, '65.52.15591813701540507', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:56:10', 10, 0, '', '2019-05-30 09:56:10');
INSERT INTO `access_log` VALUES (14373, '65.45.15591813723760529', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:56:12', 11, 0, '', '2019-05-30 09:56:12');
INSERT INTO `access_log` VALUES (14374, '65.49.15591813765760519', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:56:17', 10, 0, '', '2019-05-30 09:56:17');
INSERT INTO `access_log` VALUES (14375, '65.50.15591813774670517', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.61.2.18', '2019-05-30 09:56:17', 15, 0, '', '2019-05-30 09:56:17');
INSERT INTO `access_log` VALUES (14376, '65.46.15591813959100511', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:56:36', 1, 1002001015, '账号未登陆', '2019-05-30 09:56:36');
INSERT INTO `access_log` VALUES (14377, '65.54.15591813959180499', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:56:36', 1, 1002001015, '账号未登陆', '2019-05-30 09:56:36');
INSERT INTO `access_log` VALUES (14378, '65.53.15591813959250505', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:56:36', 1, 1002001015, '账号未登陆', '2019-05-30 09:56:36');
INSERT INTO `access_log` VALUES (14379, '65.51.15591814023360519', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:56:42', 125, 0, '', '2019-05-30 09:56:42');
INSERT INTO `access_log` VALUES (14380, '65.45.15591814027040531', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:56:43', 10, 0, '', '2019-05-30 09:56:43');
INSERT INTO `access_log` VALUES (14381, '65.52.15591814027020509', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:56:43', 20, 0, '', '2019-05-30 09:56:43');
INSERT INTO `access_log` VALUES (14382, '65.49.15591814027120521', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:56:43', 11, 0, '', '2019-05-30 09:56:43');
INSERT INTO `access_log` VALUES (14383, '62.88.15591814198011067', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:57:00', 18, 0, '', '2019-05-30 09:57:00');
INSERT INTO `access_log` VALUES (14384, '62.87.15591814285841067', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:57:09', 17, 0, '', '2019-05-30 09:57:09');
INSERT INTO `access_log` VALUES (14385, '64.83.15591814316750495', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:57:12', 18, 0, '', '2019-05-30 09:57:12');
INSERT INTO `access_log` VALUES (14386, '64.85.15591814316720499', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:57:12', 21, 0, '', '2019-05-30 09:57:12');
INSERT INTO `access_log` VALUES (14387, '64.78.15591814359950499', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:57:16', 17, 0, '', '2019-05-30 09:57:16');
INSERT INTO `access_log` VALUES (14388, '64.84.15591814359960501', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:57:16', 9, 0, '', '2019-05-30 09:57:16');
INSERT INTO `access_log` VALUES (14389, '64.76.15591814419890497', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:57:22', 10, 0, '', '2019-05-30 09:57:22');
INSERT INTO `access_log` VALUES (14390, '59.76.15591814600401139', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:57:40', 13, 0, '', '2019-05-30 09:57:40');
INSERT INTO `access_log` VALUES (14391, '59.79.15591814648041143', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:57:45', 20, 2001001000, '服务端发生异常', '2019-05-30 09:57:45');
INSERT INTO `access_log` VALUES (14392, '59.78.15591814703561151', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:57:50', 13, 0, '', '2019-05-30 09:57:50');
INSERT INTO `access_log` VALUES (14393, '59.77.15591814732811141', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:57:53', 13, 0, '', '2019-05-30 09:57:53');
INSERT INTO `access_log` VALUES (14394, '59.72.15591814757541139', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:57:56', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-30 09:57:56');
INSERT INTO `access_log` VALUES (14395, '65.48.15591814782840529', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:57:58', 19, 0, '', '2019-05-30 09:57:58');
INSERT INTO `access_log` VALUES (14396, '64.83.15591814959130497', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:58:16', 11, 0, '', '2019-05-30 09:58:16');
INSERT INTO `access_log` VALUES (14397, '64.77.15591814959120499', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:58:16', 13, 0, '', '2019-05-30 09:58:16');
INSERT INTO `access_log` VALUES (14398, '65.52.15591814965270511', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:58:17', 130, 0, '', '2019-05-30 09:58:17');
INSERT INTO `access_log` VALUES (14399, '64.85.15591814969200501', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:58:17', 11, 0, '', '2019-05-30 09:58:17');
INSERT INTO `access_log` VALUES (14400, '64.78.15591814987460501', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:58:19', 11, 0, '', '2019-05-30 09:58:19');
INSERT INTO `access_log` VALUES (14401, '64.84.15591814987460503', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:58:19', 15, 0, '', '2019-05-30 09:58:19');
INSERT INTO `access_log` VALUES (14402, '64.79.15591814987630495', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:58:19', 9, 0, '', '2019-05-30 09:58:19');
INSERT INTO `access_log` VALUES (14403, '65.49.15591814999090523', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:58:20', 10, 0, '', '2019-05-30 09:58:20');
INSERT INTO `access_log` VALUES (14404, '65.50.15591815066210521', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:58:27', 15, 0, '', '2019-05-30 09:58:27');
INSERT INTO `access_log` VALUES (14405, '64.82.15591815108720507', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=我和僵尸有个约会&sellPoint=有点甜&cid=637&visible=true&id=42&picUrls=http://static.shop.iocoder.cn/e3904ca3-d37c-47ae-b53f-3b46c5916e41&skuStr=[{\"attrs\":[28],\"price\":100000,\"quantity\":20},{\"attrs\":[35],\"price\":300000,\"quantity\":40}]&description=<p>我就是描述</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:58:31', 9, 1002002009, NULL, '2019-05-30 09:58:31');
INSERT INTO `access_log` VALUES (14406, '64.81.15591815126380495', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=我和僵尸有个约会&sellPoint=有点甜&cid=637&visible=true&id=42&picUrls=http://static.shop.iocoder.cn/e3904ca3-d37c-47ae-b53f-3b46c5916e41&skuStr=[{\"attrs\":[28],\"price\":100000,\"quantity\":20},{\"attrs\":[35],\"price\":300000,\"quantity\":40}]&description=<p>我就是描述</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:58:33', 8, 1002002009, NULL, '2019-05-30 09:58:33');
INSERT INTO `access_log` VALUES (14407, '64.80.15591815135690495', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=我和僵尸有个约会&sellPoint=有点甜&cid=637&visible=true&id=42&picUrls=http://static.shop.iocoder.cn/e3904ca3-d37c-47ae-b53f-3b46c5916e41&skuStr=[{\"attrs\":[28],\"price\":100000,\"quantity\":20},{\"attrs\":[35],\"price\":300000,\"quantity\":40}]&description=<p>我就是描述</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 09:58:34', 8, 1002002009, NULL, '2019-05-30 09:58:34');
INSERT INTO `access_log` VALUES (14408, '59.79.15591815491691145', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:59:09', 4, 0, '', '2019-05-30 09:59:09');
INSERT INTO `access_log` VALUES (14409, '59.75.15591815491691147', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:59:09', 13, 2001001000, '服务端发生异常', '2019-05-30 09:59:09');
INSERT INTO `access_log` VALUES (14410, '64.84.15591815548950505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:59:15', 3, 0, '', '2019-05-30 09:59:15');
INSERT INTO `access_log` VALUES (14411, '64.78.15591815550620503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.132.9.178', '2019-05-30 09:59:15', 2, 0, '', '2019-05-30 09:59:15');
INSERT INTO `access_log` VALUES (14412, '59.71.15591815949591149', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 09:59:55', 10, 0, '', '2019-05-30 09:59:55');
INSERT INTO `access_log` VALUES (14413, '59.74.15591815949601149', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 09:59:55', 19, 2001001000, '服务端发生异常', '2019-05-30 09:59:55');
INSERT INTO `access_log` VALUES (14414, '64.80.15591815979240497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 09:59:58', 8, 0, '', '2019-05-30 09:59:58');
INSERT INTO `access_log` VALUES (14415, '64.83.15591815981130501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 09:59:58', 7, 0, '', '2019-05-30 09:59:58');
INSERT INTO `access_log` VALUES (14416, '64.84.15591816120590507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:00:12', 8, 0, '', '2019-05-30 10:00:12');
INSERT INTO `access_log` VALUES (14417, '64.78.15591816124280505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:00:12', 8, 0, '', '2019-05-30 10:00:12');
INSERT INTO `access_log` VALUES (14418, '66.52.15591816133140105', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:00:13', 8, 1002001012, '访问令牌已过期', '2019-05-30 10:00:13');
INSERT INTO `access_log` VALUES (14419, '66.55.15591816134240117', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=8af28a5716b342dd9b712c32e5c45dca', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:00:13', 10, 1002001018, '访问令牌已过期', '2019-05-30 10:00:13');
INSERT INTO `access_log` VALUES (14420, '64.82.15591816372140511', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:00:37', 11, 0, '', '2019-05-30 10:00:37');
INSERT INTO `access_log` VALUES (14421, '64.81.15591816372150499', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:00:37', 12, 0, '', '2019-05-30 10:00:37');
INSERT INTO `access_log` VALUES (14422, '64.80.15591816383280499', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:00:38', 11, 0, '', '2019-05-30 10:00:38');
INSERT INTO `access_log` VALUES (14423, '66.50.15591816784930109', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15136212594', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:01:18', 86, 0, '', '2019-05-30 10:01:19');
INSERT INTO `access_log` VALUES (14424, '66.52.15591817233980107', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15136212594&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:03', 207, 0, '', '2019-05-30 10:02:04');
INSERT INTO `access_log` VALUES (14425, '66.55.15591817251270119', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:05', 7, 0, '', '2019-05-30 10:02:05');
INSERT INTO `access_log` VALUES (14426, '66.56.15591817323650105', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:12', 7, 0, '', '2019-05-30 10:02:12');
INSERT INTO `access_log` VALUES (14427, '59.71.15591817334671151', 74, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:13', 17, 2001001000, '服务端发生异常', '2019-05-30 10:02:13');
INSERT INTO `access_log` VALUES (14428, '59.76.15591817334841145', 74, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:13', 6, 0, '', '2019-05-30 10:02:13');
INSERT INTO `access_log` VALUES (14429, '64.81.15591817455460501', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:26', 178, 0, '', '2019-05-30 10:02:26');
INSERT INTO `access_log` VALUES (14430, '64.82.15591817458980513', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:26', 6, 0, '', '2019-05-30 10:02:26');
INSERT INTO `access_log` VALUES (14431, '64.80.15591817491080501', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:29', 5, 0, '', '2019-05-30 10:02:29');
INSERT INTO `access_log` VALUES (14432, 'N/A', 74, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:29', 11, 0, '', '2019-05-30 10:02:29');
INSERT INTO `access_log` VALUES (14433, 'N/A', 74, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:31', 15, 0, '', '2019-05-30 10:02:31');
INSERT INTO `access_log` VALUES (14434, '64.83.15591817532150505', 74, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:33', 69, 0, '', '2019-05-30 10:02:33');
INSERT INTO `access_log` VALUES (14435, '66.48.15591817612690115', 74, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:41', 7, 0, '', '2019-05-30 10:02:41');
INSERT INTO `access_log` VALUES (14436, '64.84.15591817655680511', 74, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:46', 10, 0, '', '2019-05-30 10:02:46');
INSERT INTO `access_log` VALUES (14437, '66.51.15591817675040111', 74, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:48', 7, 0, '', '2019-05-30 10:02:48');
INSERT INTO `access_log` VALUES (14438, '66.52.15591817705830109', 74, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:02:51', 7, 0, '', '2019-05-30 10:02:51');
INSERT INTO `access_log` VALUES (14439, '66.56.15591817875120107', 74, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:08', 7, 0, '', '2019-05-30 10:03:08');
INSERT INTO `access_log` VALUES (14440, '66.57.15591817880210113', 74, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:08', 6, 0, '', '2019-05-30 10:03:08');
INSERT INTO `access_log` VALUES (14441, '64.76.15591817894980507', 74, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:09', 10, 0, '', '2019-05-30 10:03:10');
INSERT INTO `access_log` VALUES (14442, '64.81.15591817904880503', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:10', 6, 0, '', '2019-05-30 10:03:10');
INSERT INTO `access_log` VALUES (14443, 'N/A', 74, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:10', 14, 0, '', '2019-05-30 10:03:11');
INSERT INTO `access_log` VALUES (14444, '64.82.15591817918590515', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:12', 6, 0, '', '2019-05-30 10:03:12');
INSERT INTO `access_log` VALUES (14445, '64.80.15591817920020503', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:12', 5, 0, '', '2019-05-30 10:03:12');
INSERT INTO `access_log` VALUES (14446, '64.77.15591817950620509', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:15', 5, 0, '', '2019-05-30 10:03:15');
INSERT INTO `access_log` VALUES (14447, '64.83.15591817952050507', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:15', 5, 0, '', '2019-05-30 10:03:15');
INSERT INTO `access_log` VALUES (14448, '66.49.15591817959580113', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:16', 7, 0, '', '2019-05-30 10:03:16');
INSERT INTO `access_log` VALUES (14449, '66.48.15591818046620117', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:25', 7, 0, '', '2019-05-30 10:03:25');
INSERT INTO `access_log` VALUES (14450, '66.51.15591818075140113', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:28', 6, 0, '', '2019-05-30 10:03:28');
INSERT INTO `access_log` VALUES (14451, '59.80.15591818114921151', 74, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:31', 12, 0, '', '2019-05-30 10:03:32');
INSERT INTO `access_log` VALUES (14452, '66.55.15591818166780123', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:37', 108, 0, '', '2019-05-30 10:03:37');
INSERT INTO `access_log` VALUES (14453, '59.71.15591818180811153', 74, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:38', 6, 0, '', '2019-05-30 10:03:38');
INSERT INTO `access_log` VALUES (14454, '66.52.15591818226270111', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:43', 13, 0, '', '2019-05-30 10:03:43');
INSERT INTO `access_log` VALUES (14455, '59.76.15591818252331147', 74, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:45', 8, 0, '', '2019-05-30 10:03:45');
INSERT INTO `access_log` VALUES (14456, '59.79.15591818258891151', 74, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:46', 10, 0, '', '2019-05-30 10:03:46');
INSERT INTO `access_log` VALUES (14457, '59.77.15591818279751149', 74, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:48', 8, 0, '', '2019-05-30 10:03:48');
INSERT INTO `access_log` VALUES (14458, '66.53.15591818287950119', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:49', 7, 0, '', '2019-05-30 10:03:49');
INSERT INTO `access_log` VALUES (14459, '59.73.15591818314051155', 74, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:51', 7, 0, '', '2019-05-30 10:03:51');
INSERT INTO `access_log` VALUES (14460, '66.57.15591818325160115', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:53', 7, 0, '', '2019-05-30 10:03:53');
INSERT INTO `access_log` VALUES (14461, '66.49.15591818346400115', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:55', 7, 0, '', '2019-05-30 10:03:55');
INSERT INTO `access_log` VALUES (14462, '64.79.15591818355550505', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:03:56', 11, 0, '', '2019-05-30 10:03:56');
INSERT INTO `access_log` VALUES (14463, '66.50.15591818362150115', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:56', 7, 0, '', '2019-05-30 10:03:56');
INSERT INTO `access_log` VALUES (14464, '66.48.15591818375380119', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:58', 7, 0, '', '2019-05-30 10:03:58');
INSERT INTO `access_log` VALUES (14465, '64.81.15591818391420505', 74, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:03:59', 6, 1003002003, 'Spu 只能添加在二级分类下', '2019-05-30 10:03:59');
INSERT INTO `access_log` VALUES (14466, '66.54.15591818467920111', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:04:07', 6, 0, '', '2019-05-30 10:04:07');
INSERT INTO `access_log` VALUES (14467, '66.55.15591818509210125', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:04:11', 275, 0, '', '2019-05-30 10:04:11');
INSERT INTO `access_log` VALUES (14468, '66.52.15591818539910113', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:04:14', 7, 0, '', '2019-05-30 10:04:14');
INSERT INTO `access_log` VALUES (14469, '64.80.15591818576950505', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:04:18', 5, 0, '', '2019-05-30 10:04:18');
INSERT INTO `access_log` VALUES (14470, '64.77.15591818578090511', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:04:18', 5, 0, '', '2019-05-30 10:04:18');
INSERT INTO `access_log` VALUES (14471, '59.71.15591818598341155', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:04:20', 4, 0, '', '2019-05-30 10:04:20');
INSERT INTO `access_log` VALUES (14472, '59.76.15591818598341149', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:04:20', 14, 2001001000, '服务端发生异常', '2019-05-30 10:04:20');
INSERT INTO `access_log` VALUES (14473, '64.85.15591818598590513', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:04:20', 6, 0, '', '2019-05-30 10:04:20');
INSERT INTO `access_log` VALUES (14474, '64.78.15591818604920513', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:04:20', 5, 0, '', '2019-05-30 10:04:20');
INSERT INTO `access_log` VALUES (14475, '64.76.15591818619930511', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:04:22', 6, 0, '', '2019-05-30 10:04:22');
INSERT INTO `access_log` VALUES (14476, 'N/A', 74, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:04:22', 12, 0, '', '2019-05-30 10:04:22');
INSERT INTO `access_log` VALUES (14477, '64.81.15591818638450507', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:04:24', 5, 0, '', '2019-05-30 10:04:24');
INSERT INTO `access_log` VALUES (14478, '64.82.15591818640120519', 74, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:04:24', 6, 0, '', '2019-05-30 10:04:24');
INSERT INTO `access_log` VALUES (14479, '59.79.15591818650901153', 74, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:04:25', 5, 0, '', '2019-05-30 10:04:25');
INSERT INTO `access_log` VALUES (14480, '59.75.15591818650881155', 74, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/WIFI Language/zh_CN', '122.233.212.238', '2019-05-30 10:04:25', 17, 2001001000, '服务端发生异常', '2019-05-30 10:04:25');
INSERT INTO `access_log` VALUES (14481, '64.80.15591818734940507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:04:33', 2, 0, '', '2019-05-30 10:04:33');
INSERT INTO `access_log` VALUES (14482, '64.77.15591818736280513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:04:34', 2, 0, '', '2019-05-30 10:04:34');
INSERT INTO `access_log` VALUES (14483, '64.83.15591818754580511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:04:35', 3, 0, '', '2019-05-30 10:04:35');
INSERT INTO `access_log` VALUES (14484, '64.84.15591818762130517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:04:36', 2, 0, '', '2019-05-30 10:04:36');
INSERT INTO `access_log` VALUES (14485, '64.79.15591818771720509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:04:37', 2, 0, '', '2019-05-30 10:04:37');
INSERT INTO `access_log` VALUES (14486, '64.78.15591818777710515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:04:38', 2, 0, '', '2019-05-30 10:04:38');
INSERT INTO `access_log` VALUES (14487, '64.76.15591818787270513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:04:39', 2, 0, '', '2019-05-30 10:04:39');
INSERT INTO `access_log` VALUES (14488, '64.81.15591818793550509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:04:39', 2, 0, '', '2019-05-30 10:04:39');
INSERT INTO `access_log` VALUES (14489, '64.82.15591818843500521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:04:44', 2, 0, '', '2019-05-30 10:04:44');
INSERT INTO `access_log` VALUES (14490, '64.80.15591818844660509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:04:44', 2, 0, '', '2019-05-30 10:04:44');
INSERT INTO `access_log` VALUES (14491, '59.77.15591818860421151', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:04:46', 3, 0, '', '2019-05-30 10:04:46');
INSERT INTO `access_log` VALUES (14492, '59.72.15591818860431149', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:04:46', 14, 2001001000, '服务端发生异常', '2019-05-30 10:04:46');
INSERT INTO `access_log` VALUES (14493, '64.85.15591819048990517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:05:05', 2, 0, '', '2019-05-30 10:05:05');
INSERT INTO `access_log` VALUES (14494, '64.83.15591819050520513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:05:05', 2, 0, '', '2019-05-30 10:05:05');
INSERT INTO `access_log` VALUES (14495, '64.79.15591819064940511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:05:06', 3, 0, '', '2019-05-30 10:05:06');
INSERT INTO `access_log` VALUES (14496, '64.78.15591819072440517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:05:07', 2, 0, '', '2019-05-30 10:05:07');
INSERT INTO `access_log` VALUES (14497, '64.78.15591819072440517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:05:07', 2, 0, '', '2019-05-30 10:05:08');
INSERT INTO `access_log` VALUES (14498, '59.76.15591819089211151', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:05:09', 13, 2001001000, '服务端发生异常', '2019-05-30 10:05:09');
INSERT INTO `access_log` VALUES (14499, '59.74.15591819089201157', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.68.98', '2019-05-30 10:05:09', 304, 0, '', '2019-05-30 10:05:09');
INSERT INTO `access_log` VALUES (14500, '59.71.15591819140151157', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:05:14', 4, 0, '', '2019-05-30 10:05:14');
INSERT INTO `access_log` VALUES (14501, '59.79.15591819140151155', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:05:14', 14, 2001001000, '服务端发生异常', '2019-05-30 10:05:14');
INSERT INTO `access_log` VALUES (14502, '59.78.15591822271931167', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:27', 4, 0, '', '2019-05-30 10:10:27');
INSERT INTO `access_log` VALUES (14503, '59.72.15591822271931155', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:27', 13, 2001001000, '服务端发生异常', '2019-05-30 10:10:27');
INSERT INTO `access_log` VALUES (14504, '64.81.15591822324180515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:32', 3, 0, '', '2019-05-30 10:10:32');
INSERT INTO `access_log` VALUES (14505, '64.82.15591822325300527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:33', 2, 0, '', '2019-05-30 10:10:33');
INSERT INTO `access_log` VALUES (14506, '64.80.15591822340700515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:34', 3, 0, '', '2019-05-30 10:10:34');
INSERT INTO `access_log` VALUES (14507, '64.77.15591822347490521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:35', 2, 0, '', '2019-05-30 10:10:35');
INSERT INTO `access_log` VALUES (14508, '59.73.15591822375591163', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:38', 3, 0, '', '2019-05-30 10:10:38');
INSERT INTO `access_log` VALUES (14509, '59.80.15591822375611161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:38', 14, 2001001000, '服务端发生异常', '2019-05-30 10:10:38');
INSERT INTO `access_log` VALUES (14510, '64.83.15591822402930519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:40', 2, 0, '', '2019-05-30 10:10:40');
INSERT INTO `access_log` VALUES (14511, '64.84.15591822404530525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:40', 2, 0, '', '2019-05-30 10:10:40');
INSERT INTO `access_log` VALUES (14512, '64.79.15591822448120517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:45', 3, 0, '', '2019-05-30 10:10:45');
INSERT INTO `access_log` VALUES (14513, '64.78.15591822449340523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:45', 3, 0, '', '2019-05-30 10:10:45');
INSERT INTO `access_log` VALUES (14514, '64.76.15591822492030521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:49', 2, 0, '', '2019-05-30 10:10:49');
INSERT INTO `access_log` VALUES (14515, '64.81.15591822493200517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:49', 2, 0, '', '2019-05-30 10:10:49');
INSERT INTO `access_log` VALUES (14516, '59.74.15591822550151163', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:55', 3, 0, '', '2019-05-30 10:10:55');
INSERT INTO `access_log` VALUES (14517, '59.79.15591822550481161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.58', '2019-05-30 10:10:55', 10, 2001001000, '服务端发生异常', '2019-05-30 10:10:55');
INSERT INTO `access_log` VALUES (14518, '64.82.15591832967720543', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:28:17', 8, 1002001012, '访问令牌已过期', '2019-05-30 10:28:17');
INSERT INTO `access_log` VALUES (14519, '65.47.15591833042130553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:28:24', 82, 0, '', '2019-05-30 10:28:24');
INSERT INTO `access_log` VALUES (14520, '65.54.15591833044880527', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:28:24', 10, 0, '', '2019-05-30 10:28:24');
INSERT INTO `access_log` VALUES (14521, '65.53.15591833044910533', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:28:24', 9, 0, '', '2019-05-30 10:28:25');
INSERT INTO `access_log` VALUES (14522, '65.46.15591833044900539', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:28:24', 13, 0, '', '2019-05-30 10:28:25');
INSERT INTO `access_log` VALUES (14523, '64.85.15591833079020539', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:28:28', 10, 0, '', '2019-05-30 10:28:28');
INSERT INTO `access_log` VALUES (14524, '64.77.15591833079000537', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:28:28', 12, 0, '', '2019-05-30 10:28:28');
INSERT INTO `access_log` VALUES (14525, '64.84.15591833109790541', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:28:31', 24, 0, '', '2019-05-30 10:28:31');
INSERT INTO `access_log` VALUES (14526, '64.83.15591833109780535', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:28:31', 26, 0, '', '2019-05-30 10:28:31');
INSERT INTO `access_log` VALUES (14527, '62.80.15591833791061091', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:29:39', 19, 0, '', '2019-05-30 10:29:39');
INSERT INTO `access_log` VALUES (14528, '62.87.15591835647251097', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:32:45', 18, 0, '', '2019-05-30 10:32:45');
INSERT INTO `access_log` VALUES (14529, '62.82.15591835729611095', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:32:53', 808, 0, '', '2019-05-30 10:32:54');
INSERT INTO `access_log` VALUES (14530, '62.83.15591845814531111', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:49:41', 16, 0, '', '2019-05-30 10:49:41');
INSERT INTO `access_log` VALUES (14531, '59.73.15591845845901195', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:49:45', 20, 0, '', '2019-05-30 10:49:45');
INSERT INTO `access_log` VALUES (14532, '59.80.15591845880171193', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:49:48', 410, 2001001000, '服务端发生异常', '2019-05-30 10:49:48');
INSERT INTO `access_log` VALUES (14533, '62.89.15591845925481111', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:49:53', 305, 0, '', '2019-05-30 10:49:53');
INSERT INTO `access_log` VALUES (14534, '59.78.15591850971531207', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:58:17', 4, 0, '', '2019-05-30 10:58:17');
INSERT INTO `access_log` VALUES (14535, '59.75.15591850971521201', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:58:17', 14, 2001001000, '服务端发生异常', '2019-05-30 10:58:17');
INSERT INTO `access_log` VALUES (14536, '64.79.15591851023230557', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 10:58:22', 4, 1003002003, 'Spu 只能添加在二级分类下', '2019-05-30 10:58:22');
INSERT INTO `access_log` VALUES (14537, '59.75.15591900123191267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.126.197.160', '2019-05-30 12:20:12', 13, 0, '', '2019-05-30 12:20:12');
INSERT INTO `access_log` VALUES (14538, '59.78.15591900123191273', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.126.197.160', '2019-05-30 12:20:12', 17, 2001001000, '服务端发生异常', '2019-05-30 12:20:12');
INSERT INTO `access_log` VALUES (14539, '64.83.15591900307430625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.126.197.160', '2019-05-30 12:20:31', 11, 0, '', '2019-05-30 12:20:31');
INSERT INTO `access_log` VALUES (14540, '64.79.15591900310440623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.126.197.160', '2019-05-30 12:20:31', 2, 0, '', '2019-05-30 12:20:31');
INSERT INTO `access_log` VALUES (14541, '65.47.15591923866080677', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 12:59:47', 0, 1002001015, '账号未登陆', '2019-05-30 12:59:47');
INSERT INTO `access_log` VALUES (14542, '65.48.15591923866080677', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 12:59:47', 0, 1002001015, '账号未登陆', '2019-05-30 12:59:47');
INSERT INTO `access_log` VALUES (14543, '65.45.15591923866090681', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 12:59:47', 1, 1002001015, '账号未登陆', '2019-05-30 12:59:47');
INSERT INTO `access_log` VALUES (14544, '65.46.15591923906120661', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 12:59:51', 246, 0, '', '2019-05-30 12:59:51');
INSERT INTO `access_log` VALUES (14545, '65.53.15591923911760655', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 12:59:51', 11, 0, '', '2019-05-30 12:59:51');
INSERT INTO `access_log` VALUES (14546, '65.50.15591923911790669', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 12:59:51', 10, 0, '', '2019-05-30 12:59:51');
INSERT INTO `access_log` VALUES (14547, '65.52.15591923911820661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 12:59:51', 10, 0, '', '2019-05-30 12:59:51');
INSERT INTO `access_log` VALUES (14548, '62.84.15591923990661207', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 12:59:59', 23, 0, '', '2019-05-30 12:59:59');
INSERT INTO `access_log` VALUES (14549, '62.80.15591924143291213', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 13:00:14', 18, 0, '', '2019-05-30 13:00:14');
INSERT INTO `access_log` VALUES (14550, '59.73.15591924346231301', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 13:00:35', 21, 0, '', '2019-05-30 13:00:35');
INSERT INTO `access_log` VALUES (14551, '59.80.15591924389781299', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 13:00:39', 22, 2001001000, '服务端发生异常', '2019-05-30 13:00:39');
INSERT INTO `access_log` VALUES (14552, '59.76.15591924433481295', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 13:00:43', 13, 0, '', '2019-05-30 13:00:43');
INSERT INTO `access_log` VALUES (14553, '59.79.15591924463561299', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 13:00:46', 13, 0, '', '2019-05-30 13:00:46');
INSERT INTO `access_log` VALUES (14554, '59.74.15591924488411301', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 13:00:49', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-30 13:00:49');
INSERT INTO `access_log` VALUES (14555, '65.48.15591924533800679', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 13:00:53', 19, 0, '', '2019-05-30 13:00:53');
INSERT INTO `access_log` VALUES (14556, '65.46.15591924556890663', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 13:00:56', 10, 0, '', '2019-05-30 13:00:56');
INSERT INTO `access_log` VALUES (14557, '65.50.15591924567630671', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 13:00:57', 9, 0, '', '2019-05-30 13:00:57');
INSERT INTO `access_log` VALUES (14558, '65.53.15591924585440657', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.229.5', '2019-05-30 13:00:59', 14, 0, '', '2019-05-30 13:00:59');
INSERT INTO `access_log` VALUES (14559, '59.75.15591930538351309', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.71.196.18', '2019-05-30 13:10:54', 5, 0, '', '2019-05-30 13:10:54');
INSERT INTO `access_log` VALUES (14560, '59.78.15591930538351315', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.71.196.18', '2019-05-30 13:10:54', 14, 2001001000, '服务端发生异常', '2019-05-30 13:10:54');
INSERT INTO `access_log` VALUES (14561, '62.89.15591944401761243', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.174.74', '2019-05-30 13:34:00', 8, 1002001012, '访问令牌已过期', '2019-05-30 13:34:00');
INSERT INTO `access_log` VALUES (14562, '65.51.15591944485770699', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.173.34.245', '2019-05-30 13:34:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-30 13:34:09');
INSERT INTO `access_log` VALUES (14563, '64.79.15591946420590685', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 13:37:22', 145, 1002001012, '访问令牌已过期', '2019-05-30 13:37:22');
INSERT INTO `access_log` VALUES (14564, '64.83.15591946420580687', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 13:37:22', 147, 1002001012, '访问令牌已过期', '2019-05-30 13:37:22');
INSERT INTO `access_log` VALUES (14565, '65.46.15591946463810693', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 13:37:26', 82, 0, '', '2019-05-30 13:37:26');
INSERT INTO `access_log` VALUES (14566, '65.50.15591946466450701', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 13:37:27', 11, 0, '', '2019-05-30 13:37:27');
INSERT INTO `access_log` VALUES (14567, '65.53.15591946466450687', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 13:37:27', 21, 0, '', '2019-05-30 13:37:27');
INSERT INTO `access_log` VALUES (14568, '65.52.15591946466500693', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 13:37:27', 27, 0, '', '2019-05-30 13:37:27');
INSERT INTO `access_log` VALUES (14569, '62.85.15591946494261245', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 13:37:29', 23, 0, '', '2019-05-30 13:37:29');
INSERT INTO `access_log` VALUES (14570, '62.87.15591946534931247', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 13:37:33', 17, 0, '', '2019-05-30 13:37:34');
INSERT INTO `access_log` VALUES (14571, '62.82.15591956728481259', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 13:54:33', 17, 0, '', '2019-05-30 13:54:33');
INSERT INTO `access_log` VALUES (14572, '62.89.15591956777881261', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 13:54:38', 19, 0, '', '2019-05-30 13:54:38');
INSERT INTO `access_log` VALUES (14573, '59.74.15591956928621345', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 13:54:53', 22, 0, '', '2019-05-30 13:54:53');
INSERT INTO `access_log` VALUES (14574, '59.71.15591958404311347', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 13:57:20', 21, 2001001000, '服务端发生异常', '2019-05-30 13:57:20');
INSERT INTO `access_log` VALUES (14575, '64.81.15591975316600723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.174.74', '2019-05-30 14:25:32', 11, 0, '', '2019-05-30 14:25:32');
INSERT INTO `access_log` VALUES (14576, '64.82.15591975317860735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.174.74', '2019-05-30 14:25:32', 3, 0, '', '2019-05-30 14:25:32');
INSERT INTO `access_log` VALUES (14577, 'ea7d804c-06f7-44a6-b10a-d6533a8165ad', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:26:35', 4019, 1002001015, '账号未登陆', '2019-05-30 14:26:40');
INSERT INTO `access_log` VALUES (14578, '3aa1ed9e-76e5-4cb4-b2f9-d92755c5a0d4', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:26:35', 4019, 1002001015, '账号未登陆', '2019-05-30 14:26:40');
INSERT INTO `access_log` VALUES (14579, 'c06f1a97-3ff5-4a8e-8b32-d7370b9264f2', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:26:35', 4019, 1002001015, '账号未登陆', '2019-05-30 14:26:40');
INSERT INTO `access_log` VALUES (14580, 'a2dbe81b-74dd-457f-8e15-347b05ca7290', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:26:46', 2268, 0, '', '2019-05-30 14:26:48');
INSERT INTO `access_log` VALUES (14581, '0faa20f9-939d-4ab1-895c-6447b045dad9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:26:50', 1830, 0, '', '2019-05-30 14:26:52');
INSERT INTO `access_log` VALUES (14582, '276911ec-e61d-493f-aeeb-9aedb73fc237', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:26:50', 1976, 0, '', '2019-05-30 14:26:52');
INSERT INTO `access_log` VALUES (14583, 'b869150d-06b0-4eee-9cf9-84092a15026a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:26:49', 2316, 0, '', '2019-05-30 14:26:52');
INSERT INTO `access_log` VALUES (14584, '9b0b4377-3bbb-44b3-b8a4-16204a94250a', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:26:56', 1637, 0, '', '2019-05-30 14:26:58');
INSERT INTO `access_log` VALUES (14585, '1a0e86fe-fc89-407f-9d61-7decb06e84ac', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:26:58', 1617, 0, '', '2019-05-30 14:26:59');
INSERT INTO `access_log` VALUES (14586, '64ab087d-7d9c-40dd-97e3-fdb0a4080a91', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:27:04', 191, 0, '', '2019-05-30 14:27:04');
INSERT INTO `access_log` VALUES (14587, 'ffb41a12-a03d-4a2c-b05b-f809fee0eba3', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:27:09', 3130, 0, '', '2019-05-30 14:27:12');
INSERT INTO `access_log` VALUES (14588, '11e1bb44-b9f4-4b99-8968-9fb5b5819f73', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:27:21', 783, 0, '', '2019-05-30 14:27:22');
INSERT INTO `access_log` VALUES (14589, '19f5ddf2-b3ad-4ccf-83df-1ee507ec73aa', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:27:24', 897, 0, '', '2019-05-30 14:27:25');
INSERT INTO `access_log` VALUES (14590, '27bca44a-623d-4911-a9ed-b9ec1eb1cc22', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:27:28', 152, 0, '', '2019-05-30 14:27:28');
INSERT INTO `access_log` VALUES (14591, '20aa4394-2586-4644-ab67-30916ab62cda', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:27:32', 1593, 0, '', '2019-05-30 14:27:34');
INSERT INTO `access_log` VALUES (14592, '0b09f2d5-3251-4632-af80-6f44c6564f0b', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:27:34', 300, 0, '', '2019-05-30 14:27:35');
INSERT INTO `access_log` VALUES (14593, 'd89ca501-340f-435e-b0b0-6d9e85a7dae6', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:27:41', 247, 0, '', '2019-05-30 14:27:41');
INSERT INTO `access_log` VALUES (14594, '38bf10f8-1afd-4dce-be8e-6a2afdd1f384', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '127.0.0.1', '2019-05-30 14:28:39', 417, 0, '', '2019-05-30 14:28:40');
INSERT INTO `access_log` VALUES (14595, '64.77.15591981426690737', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 14:35:43', 6, 1003002003, 'Spu 只能添加在二级分类下', '2019-05-30 14:35:43');
INSERT INTO `access_log` VALUES (14596, '65.52.15591992395590755', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:00', 1, 1002001015, '账号未登陆', '2019-05-30 14:54:00');
INSERT INTO `access_log` VALUES (14597, '65.48.15591992395610773', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:00', 0, 1002001015, '账号未登陆', '2019-05-30 14:54:00');
INSERT INTO `access_log` VALUES (14598, '65.54.15591992395610745', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:00', 0, 1002001015, '账号未登陆', '2019-05-30 14:54:00');
INSERT INTO `access_log` VALUES (14599, '65.51.15591992428590765', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-30 14:54:03');
INSERT INTO `access_log` VALUES (14600, '65.45.15591992488680777', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:09', 64, 0, '', '2019-05-30 14:54:09');
INSERT INTO `access_log` VALUES (14601, '65.46.15591992491590755', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:09', 11, 0, '', '2019-05-30 14:54:09');
INSERT INTO `access_log` VALUES (14602, '65.50.15591992491600765', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:09', 11, 0, '', '2019-05-30 14:54:09');
INSERT INTO `access_log` VALUES (14603, '65.49.15591992491620769', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:09', 9, 0, '', '2019-05-30 14:54:09');
INSERT INTO `access_log` VALUES (14604, '62.86.15591992611831297', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:21', 23, 0, '', '2019-05-30 14:54:21');
INSERT INTO `access_log` VALUES (14605, '64.81.15591992660340747', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:26', 12, 0, '', '2019-05-30 14:54:26');
INSERT INTO `access_log` VALUES (14606, '64.76.15591992660330751', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:26', 15, 0, '', '2019-05-30 14:54:26');
INSERT INTO `access_log` VALUES (14607, '64.82.15591992695480759', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:30', 14, 0, '', '2019-05-30 14:54:30');
INSERT INTO `access_log` VALUES (14608, '64.80.15591992695490747', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:30', 16, 0, '', '2019-05-30 14:54:30');
INSERT INTO `access_log` VALUES (14609, '64.77.15591992714800753', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:31', 133, 0, '', '2019-05-30 14:54:32');
INSERT INTO `access_log` VALUES (14610, '59.71.15591992799421393', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:40', 127, 0, '', '2019-05-30 14:54:40');
INSERT INTO `access_log` VALUES (14611, '65.54.15591992836040747', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '121.34.253.189', '2019-05-30 14:54:44', 20, 0, '', '2019-05-30 14:54:44');
INSERT INTO `access_log` VALUES (14612, '59.72.15591996150791391', 0, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 15:00:15', 7, 1002001012, '访问令牌已过期', '2019-05-30 15:00:15');
INSERT INTO `access_log` VALUES (14613, '65.48.15591996210010781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 15:00:21', 92, 0, '', '2019-05-30 15:00:21');
INSERT INTO `access_log` VALUES (14614, '65.45.15591996213190783', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 15:00:21', 9, 0, '', '2019-05-30 15:00:21');
INSERT INTO `access_log` VALUES (14615, '65.49.15591996213200775', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 15:00:21', 10, 0, '', '2019-05-30 15:00:21');
INSERT INTO `access_log` VALUES (14616, '65.50.15591996213220773', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 15:00:21', 9, 0, '', '2019-05-30 15:00:21');
INSERT INTO `access_log` VALUES (14617, '59.73.15591996233301399', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 15:00:23', 13, 0, '', '2019-05-30 15:00:23');
INSERT INTO `access_log` VALUES (14618, '59.74.15591998179031401', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:03:38', 3, 0, '', '2019-05-30 15:03:38');
INSERT INTO `access_log` VALUES (14619, '59.71.15591998179031401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:03:38', 14, 2001001000, '服务端发生异常', '2019-05-30 15:03:38');
INSERT INTO `access_log` VALUES (14620, '64.80.15591998259480755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:03:46', 3, 0, '', '2019-05-30 15:03:46');
INSERT INTO `access_log` VALUES (14621, '64.82.15591998260980767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:03:46', 5, 0, '', '2019-05-30 15:03:46');
INSERT INTO `access_log` VALUES (14622, '64.77.15591998277360761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:03:48', 2, 0, '', '2019-05-30 15:03:48');
INSERT INTO `access_log` VALUES (14623, '64.85.15591998292680763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:03:49', 2, 0, '', '2019-05-30 15:03:49');
INSERT INTO `access_log` VALUES (14624, '64.83.15591998332860759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:03:53', 3, 0, '', '2019-05-30 15:03:53');
INSERT INTO `access_log` VALUES (14625, '64.79.15591998334080757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:03:53', 2, 0, '', '2019-05-30 15:03:53');
INSERT INTO `access_log` VALUES (14626, '59.78.15591998364691407', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:03:56', 4, 0, '', '2019-05-30 15:03:56');
INSERT INTO `access_log` VALUES (14627, '59.72.15591998364691395', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:03:56', 13, 2001001000, '服务端发生异常', '2019-05-30 15:03:56');
INSERT INTO `access_log` VALUES (14628, '65.45.15591998558250787', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:04:16', 0, 1002001015, '账号未登陆', '2019-05-30 15:04:16');
INSERT INTO `access_log` VALUES (14629, '65.48.15591998558240785', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:04:16', 0, 1002001015, '账号未登陆', '2019-05-30 15:04:16');
INSERT INTO `access_log` VALUES (14630, '65.49.15591998558290779', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:04:16', 0, 1002001015, '账号未登陆', '2019-05-30 15:04:16');
INSERT INTO `access_log` VALUES (14631, '65.47.15591998651210783', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:04:25', 79, 0, '', '2019-05-30 15:04:25');
INSERT INTO `access_log` VALUES (14632, '65.46.15591998654840767', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:04:25', 9, 0, '', '2019-05-30 15:04:25');
INSERT INTO `access_log` VALUES (14633, '65.54.15591998654880757', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:04:25', 9, 0, '', '2019-05-30 15:04:25');
INSERT INTO `access_log` VALUES (14634, '65.53.15591998654940759', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:04:25', 9, 0, '', '2019-05-30 15:04:26');
INSERT INTO `access_log` VALUES (14635, '62.84.15591998750581309', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:04:35', 16, 0, '', '2019-05-30 15:04:35');
INSERT INTO `access_log` VALUES (14636, '64.82.15591998856340769', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:04:46', 178, 0, '', '2019-05-30 15:04:46');
INSERT INTO `access_log` VALUES (14637, '64.80.15591998856290757', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:04:46', 186, 0, '', '2019-05-30 15:04:46');
INSERT INTO `access_log` VALUES (14638, '59.79.15591998934531401', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:04:53', 12, 0, '', '2019-05-30 15:04:53');
INSERT INTO `access_log` VALUES (14639, '65.49.15591999027800781', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:05:03', 3643, 0, '', '2019-05-30 15:05:06');
INSERT INTO `access_log` VALUES (14640, '65.45.15591999064030789', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:05:06', 27, 0, '', '2019-05-30 15:05:06');
INSERT INTO `access_log` VALUES (14641, '65.48.15591999053220787', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:05:05', 1109, 0, '', '2019-05-30 15:05:06');
INSERT INTO `access_log` VALUES (14642, '65.47.15591999136810785', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.207.218.246', '2019-05-30 15:05:14', 15, 0, '', '2019-05-30 15:05:14');
INSERT INTO `access_log` VALUES (14643, '64.82.15592002992430775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.174.74', '2019-05-30 15:11:39', 4, 0, '', '2019-05-30 15:11:39');
INSERT INTO `access_log` VALUES (14644, '59.76.15592022647491429', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.105.74', '2019-05-30 15:44:25', 11, 0, '', '2019-05-30 15:44:25');
INSERT INTO `access_log` VALUES (14645, '59.79.15592022647501433', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.105.74', '2019-05-30 15:44:25', 15, 2001001000, '服务端发生异常', '2019-05-30 15:44:25');
INSERT INTO `access_log` VALUES (14646, '64.82.15592022676000801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.105.74', '2019-05-30 15:44:28', 12, 0, '', '2019-05-30 15:44:28');
INSERT INTO `access_log` VALUES (14647, '64.80.15592022677060789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.105.74', '2019-05-30 15:44:28', 3, 0, '', '2019-05-30 15:44:28');
INSERT INTO `access_log` VALUES (14648, '64.85.15592022688800799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.105.74', '2019-05-30 15:44:29', 3, 0, '', '2019-05-30 15:44:29');
INSERT INTO `access_log` VALUES (14649, '64.77.15592022694870797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.105.74', '2019-05-30 15:44:29', 2, 0, '', '2019-05-30 15:44:29');
INSERT INTO `access_log` VALUES (14650, '59.74.15592022726471435', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.105.74', '2019-05-30 15:44:33', 4, 0, '', '2019-05-30 15:44:33');
INSERT INTO `access_log` VALUES (14651, '59.71.15592022726481435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.105.74', '2019-05-30 15:44:33', 16, 2001001000, '服务端发生异常', '2019-05-30 15:44:33');
INSERT INTO `access_log` VALUES (14652, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=sqsq', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.69.140.67', '2019-05-30 15:57:55', 11, 0, '', '2019-05-30 15:57:55');
INSERT INTO `access_log` VALUES (14653, '59.73.15592038267391457', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:27', 4, 0, '', '2019-05-30 16:10:27');
INSERT INTO `access_log` VALUES (14654, '59.80.15592038267421455', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:27', 14, 2001001000, '服务端发生异常', '2019-05-30 16:10:27');
INSERT INTO `access_log` VALUES (14655, '64.81.15592038317520811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:32', 650, 0, '', '2019-05-30 16:10:32');
INSERT INTO `access_log` VALUES (14656, '64.76.15592038325280817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:33', 3, 0, '', '2019-05-30 16:10:33');
INSERT INTO `access_log` VALUES (14657, '64.82.15592038337190823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:34', 24, 0, '', '2019-05-30 16:10:34');
INSERT INTO `access_log` VALUES (14658, '64.80.15592038341210811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:34', 3, 0, '', '2019-05-30 16:10:34');
INSERT INTO `access_log` VALUES (14659, '64.85.15592038347170821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:35', 5, 0, '', '2019-05-30 16:10:35');
INSERT INTO `access_log` VALUES (14660, '64.77.15592038348830819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:35', 2, 0, '', '2019-05-30 16:10:35');
INSERT INTO `access_log` VALUES (14661, '64.84.15592038353360823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:35', 2, 0, '', '2019-05-30 16:10:35');
INSERT INTO `access_log` VALUES (14662, '64.79.15592038356900813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:36', 3, 0, '', '2019-05-30 16:10:36');
INSERT INTO `access_log` VALUES (14663, '64.78.15592038359170821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:36', 2, 0, '', '2019-05-30 16:10:36');
INSERT INTO `access_log` VALUES (14664, '59.79.15592038364831455', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:36', 3, 0, '', '2019-05-30 16:10:36');
INSERT INTO `access_log` VALUES (14665, '59.74.15592038364831457', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:36', 13, 2001001000, '服务端发生异常', '2019-05-30 16:10:36');
INSERT INTO `access_log` VALUES (14666, '65.54.15592038518430813', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:52', 1, 1002001015, '账号未登陆', '2019-05-30 16:10:52');
INSERT INTO `access_log` VALUES (14667, '65.53.15592038518440813', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:52', 0, 1002001015, '账号未登陆', '2019-05-30 16:10:52');
INSERT INTO `access_log` VALUES (14668, '65.52.15592038518460823', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:10:52', 0, 1002001015, '账号未登陆', '2019-05-30 16:10:52');
INSERT INTO `access_log` VALUES (14669, '65.49.15592038607750837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:11:01', 85, 0, '', '2019-05-30 16:11:01');
INSERT INTO `access_log` VALUES (14670, '65.48.15592038610510841', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:11:01', 180, 0, '', '2019-05-30 16:11:01');
INSERT INTO `access_log` VALUES (14671, '65.45.15592038610540843', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:11:01', 179, 0, '', '2019-05-30 16:11:01');
INSERT INTO `access_log` VALUES (14672, '65.50.15592038610660835', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:11:01', 169, 0, '', '2019-05-30 16:11:01');
INSERT INTO `access_log` VALUES (14673, '62.89.15592038651721371', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 16:11:05', 23, 0, '', '2019-05-30 16:11:05');
INSERT INTO `access_log` VALUES (14674, '65.47.15592081988110897', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.140.62.164', '2019-05-30 17:23:19', 13, 1002001012, '访问令牌已过期', '2019-05-30 17:23:19');
INSERT INTO `access_log` VALUES (14675, '65.48.15592081988110899', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.140.62.164', '2019-05-30 17:23:19', 15, 1002001012, '访问令牌已过期', '2019-05-30 17:23:19');
INSERT INTO `access_log` VALUES (14676, '65.46.15592081988120883', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.140.62.164', '2019-05-30 17:23:19', 27, 1002001012, '访问令牌已过期', '2019-05-30 17:23:19');
INSERT INTO `access_log` VALUES (14677, '65.54.15592082093580873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.140.62.164', '2019-05-30 17:23:29', 59, 0, '', '2019-05-30 17:23:29');
INSERT INTO `access_log` VALUES (14678, '65.52.15592082106150883', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.140.62.164', '2019-05-30 17:23:31', 10, 0, '', '2019-05-30 17:23:31');
INSERT INTO `access_log` VALUES (14679, '65.51.15592082106300891', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.140.62.164', '2019-05-30 17:23:31', 9, 0, '', '2019-05-30 17:23:31');
INSERT INTO `access_log` VALUES (14680, '65.49.15592082106380897', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.140.62.164', '2019-05-30 17:23:31', 10, 0, '', '2019-05-30 17:23:31');
INSERT INTO `access_log` VALUES (14681, 'e942d285-140b-4a50-9f97-df84799d82e2', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:24:01', 269, 0, '', '2019-05-30 17:24:02');
INSERT INTO `access_log` VALUES (14682, '3650f776-fb6b-42cc-a31f-432dd0660fb2', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:24:01', 578, 0, '', '2019-05-30 17:24:02');
INSERT INTO `access_log` VALUES (14683, '8a6b0cb6-0a31-4ee4-ab3f-b462a232add8', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:24:08', 61, 0, '', '2019-05-30 17:24:08');
INSERT INTO `access_log` VALUES (14684, '465ba431-b146-4e19-b5d9-83c1d7e19b2c', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:24:08', 13, 0, '', '2019-05-30 17:24:08');
INSERT INTO `access_log` VALUES (14685, '65.48.15592085631570905', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.140.62.164', '2019-05-30 17:29:23', 20, 0, '', '2019-05-30 17:29:23');
INSERT INTO `access_log` VALUES (14686, '65.53.15592085645750879', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.140.62.164', '2019-05-30 17:29:25', 11, 0, '', '2019-05-30 17:29:25');
INSERT INTO `access_log` VALUES (14687, '65.54.15592085702570879', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.140.62.164', '2019-05-30 17:29:30', 18, 0, '', '2019-05-30 17:29:30');
INSERT INTO `access_log` VALUES (14688, '65.52.15592085771350889', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.140.62.164', '2019-05-30 17:29:37', 11, 0, '', '2019-05-30 17:29:37');
INSERT INTO `access_log` VALUES (14689, '65.49.15592085789170903', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.140.62.164', '2019-05-30 17:29:39', 46, 0, '', '2019-05-30 17:29:39');
INSERT INTO `access_log` VALUES (14690, '65.50.15592085799430901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.140.62.164', '2019-05-30 17:29:40', 14, 0, '', '2019-05-30 17:29:40');
INSERT INTO `access_log` VALUES (14691, '64.81.15592090948440883', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:15', 10, 1002001012, '访问令牌已过期', '2019-05-30 17:38:15');
INSERT INTO `access_log` VALUES (14692, '64.76.15592090948440889', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:15', 9, 1002001012, '访问令牌已过期', '2019-05-30 17:38:15');
INSERT INTO `access_log` VALUES (14693, '65.53.15592090986260887', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:19', 62, 0, '', '2019-05-30 17:38:19');
INSERT INTO `access_log` VALUES (14694, '65.54.15592090988650887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:19', 9, 0, '', '2019-05-30 17:38:19');
INSERT INTO `access_log` VALUES (14695, '65.52.15592090988660897', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:19', 9, 0, '', '2019-05-30 17:38:19');
INSERT INTO `access_log` VALUES (14696, '65.51.15592090988670905', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:19', 10, 0, '', '2019-05-30 17:38:19');
INSERT INTO `access_log` VALUES (14697, '64.85.15592091015910893', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:22', 18, 0, '', '2019-05-30 17:38:22');
INSERT INTO `access_log` VALUES (14698, '64.80.15592091015900883', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:22', 26, 0, '', '2019-05-30 17:38:22');
INSERT INTO `access_log` VALUES (14699, '64.77.15592091061430891', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:26', 12, 0, '', '2019-05-30 17:38:26');
INSERT INTO `access_log` VALUES (14700, '64.84.15592091068610895', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:27', 13, 0, '', '2019-05-30 17:38:27');
INSERT INTO `access_log` VALUES (14701, '64.83.15592091075370887', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:28', 15, 0, '', '2019-05-30 17:38:28');
INSERT INTO `access_log` VALUES (14702, '64.79.15592091150700885', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1&cid=637', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:35', 14, 0, '', '2019-05-30 17:38:35');
INSERT INTO `access_log` VALUES (14703, '64.81.15592091170110885', 27, 2, 'product-application', '/product-api/admins/spu/page', 'cid=637&status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:37', 14, 0, '', '2019-05-30 17:38:37');
INSERT INTO `access_log` VALUES (14704, '64.76.15592091226490891', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=2&cid=637', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:43', 56, 0, '', '2019-05-30 17:38:43');
INSERT INTO `access_log` VALUES (14705, '64.82.15592091234330897', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=2&cid=637', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:43', 12, 0, '', '2019-05-30 17:38:43');
INSERT INTO `access_log` VALUES (14706, '64.85.15592091242670895', 27, 2, 'product-application', '/product-api/admins/spu/page', 'cid=637&status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:44', 14, 0, '', '2019-05-30 17:38:44');
INSERT INTO `access_log` VALUES (14707, '64.80.15592091257990885', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1&cid=637', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:46', 12, 0, '', '2019-05-30 17:38:46');
INSERT INTO `access_log` VALUES (14708, '64.77.15592091273040893', 27, 2, 'product-application', '/product-api/admins/spu/page', 'cid=637&status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:47', 15, 0, '', '2019-05-30 17:38:47');
INSERT INTO `access_log` VALUES (14709, '64.84.15592091300030897', 27, 2, 'product-application', '/product-api/admins/spu/page', 'cid=637&status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:50', 12, 0, '', '2019-05-30 17:38:50');
INSERT INTO `access_log` VALUES (14710, '64.83.15592091304210889', 27, 2, 'product-application', '/product-api/admins/spu/page', 'cid=637&status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-30 17:38:50', 13, 0, '', '2019-05-30 17:38:50');
INSERT INTO `access_log` VALUES (14711, '24cec4e0-d71e-4a42-bce4-901ac1f8cc21', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:39:48', 56, 1002001015, '账号未登陆', '2019-05-30 17:39:48');
INSERT INTO `access_log` VALUES (14712, '615c2058-853f-4fe4-a0ba-405ddabfc92b', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:39:48', 56, 1002001015, '账号未登陆', '2019-05-30 17:39:48');
INSERT INTO `access_log` VALUES (14713, 'f76c5da1-5764-48e4-a726-bc1ff4457b71', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:39:48', 56, 1002001015, '账号未登陆', '2019-05-30 17:39:48');
INSERT INTO `access_log` VALUES (14714, '7da2f476-faff-4037-b7d2-f4507a5a604a', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:40:14', 1, 1002001015, '账号未登陆', '2019-05-30 17:40:14');
INSERT INTO `access_log` VALUES (14715, 'ece8260e-d1cd-441b-a806-50c45700569b', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:40:14', 1, 1002001015, '账号未登陆', '2019-05-30 17:40:14');
INSERT INTO `access_log` VALUES (14716, 'fa19b474-6d9a-468f-b6cb-2ee8188a5d35', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:40:14', 1, 1002001015, '账号未登陆', '2019-05-30 17:40:14');
INSERT INTO `access_log` VALUES (14717, '5322a787-6d68-4d41-901e-6433d2503c43', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:40:36', 2, 1002001015, '账号未登陆', '2019-05-30 17:40:36');
INSERT INTO `access_log` VALUES (14718, '2c3e5024-2073-4b53-951e-97f600fc4db7', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:40:36', 1, 1002001015, '账号未登陆', '2019-05-30 17:40:36');
INSERT INTO `access_log` VALUES (14719, 'ae10c52f-52a1-436d-8520-134e172c8a30', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:40:36', 1, 1002001015, '账号未登陆', '2019-05-30 17:40:36');
INSERT INTO `access_log` VALUES (14720, '596e8008-bb10-48e6-887e-96ddf87b2c52', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:42:33', 296, 0, '', '2019-05-30 17:42:33');
INSERT INTO `access_log` VALUES (14721, 'c6826eb1-a8f6-452f-83e4-8774bb7a5d42', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:42:33', 174, 0, '', '2019-05-30 17:42:34');
INSERT INTO `access_log` VALUES (14722, '3de1eba0-eeaf-48fe-9fa6-671cc3136cc6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:42:33', 184, 0, '', '2019-05-30 17:42:34');
INSERT INTO `access_log` VALUES (14723, 'dab7fe04-2e81-438f-9c5e-936369de6841', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:42:33', 191, 0, '', '2019-05-30 17:42:34');
INSERT INTO `access_log` VALUES (14724, '0809b2d0-439e-4f05-8edf-41cc793d1620', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:42:39', 898, 0, '', '2019-05-30 17:42:40');
INSERT INTO `access_log` VALUES (14725, 'd6458fad-5e7f-461d-a2d0-98a314d7f5b9', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:42:42', 655, 0, '', '2019-05-30 17:42:43');
INSERT INTO `access_log` VALUES (14726, 'f919b9bc-56cf-4055-b0c4-bc4b7cbd5020', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:42:44', 845, 0, '', '2019-05-30 17:42:44');
INSERT INTO `access_log` VALUES (14727, '304bdc3f-11b5-4e7f-94f1-a1de4fe54537', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:42:46', 175, 0, '', '2019-05-30 17:42:47');
INSERT INTO `access_log` VALUES (14728, '1e56d0dd-07c9-41d5-aa75-76da52f9051a', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:42:49', 229, 0, '', '2019-05-30 17:42:49');
INSERT INTO `access_log` VALUES (14729, 'bfc91d69-67f4-4599-bca0-6d68ef506dbf', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:42:55', 141, 0, '', '2019-05-30 17:42:55');
INSERT INTO `access_log` VALUES (14730, '8c3573fd-8cd4-4a9e-b395-ea1f544914b7', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:42:59', 70, 0, '', '2019-05-30 17:42:59');
INSERT INTO `access_log` VALUES (14731, '6cb4ed87-be23-4186-b951-b1711f853d0a', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:42:59', 88, 0, '', '2019-05-30 17:42:59');
INSERT INTO `access_log` VALUES (14732, '4aaddef4-d607-4e99-aa4b-27dab661fa00', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:43:01', 52, 0, '', '2019-05-30 17:43:01');
INSERT INTO `access_log` VALUES (14733, 'f9f73160-4a22-476c-ac88-946b5a367551', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:43:29', 764, 0, '', '2019-05-30 17:43:30');
INSERT INTO `access_log` VALUES (14734, 'df40309c-d4e2-498c-8f46-add2154dc8f6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:43:29', 761, 0, '', '2019-05-30 17:43:30');
INSERT INTO `access_log` VALUES (14735, 'd50a171d-8818-415f-9d3c-3ae86f63b45c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:43:29', 765, 0, '', '2019-05-30 17:43:30');
INSERT INTO `access_log` VALUES (14736, '59.78.15592094112671537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.186.194', '2019-05-30 17:43:31', 10, 0, '', '2019-05-30 17:43:31');
INSERT INTO `access_log` VALUES (14737, '59.75.15592094112661531', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.186.194', '2019-05-30 17:43:31', 20, 2001001000, '服务端发生异常', '2019-05-30 17:43:31');
INSERT INTO `access_log` VALUES (14738, '06524277-9157-4a7b-8b83-ed3b7d8e7846', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:43:34', 58, 0, '', '2019-05-30 17:43:34');
INSERT INTO `access_log` VALUES (14739, '0ba49e62-ec38-40fb-9666-75e3ef372831', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:43:34', 53, 0, '', '2019-05-30 17:43:34');
INSERT INTO `access_log` VALUES (14740, '2c1334da-67e0-4a77-beb5-7e1e57ec4bfa', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:43:34', 58, 0, '', '2019-05-30 17:43:34');
INSERT INTO `access_log` VALUES (14741, '6e8f16e1-3bdd-4b57-b51c-d9f7307eeec5', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:43:45', 227, 0, '', '2019-05-30 17:43:45');
INSERT INTO `access_log` VALUES (14742, '6029cfb4-cc26-46fb-b3f1-1abf2a0f0a12', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:43:45', 279, 2001001000, '服务端发生异常', '2019-05-30 17:43:45');
INSERT INTO `access_log` VALUES (14743, '1498731e-897f-4599-b853-2057e22217f5', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:43:45', 122, 0, '', '2019-05-30 17:43:45');
INSERT INTO `access_log` VALUES (14744, 'd04e0762-01ac-499b-a877-0314b653e62a', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:43:45', 145, 2001001000, '服务端发生异常', '2019-05-30 17:43:45');
INSERT INTO `access_log` VALUES (14745, 'a01eac4f-88fd-4257-b436-e13c9378e176', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:45:17', 132, 0, '', '2019-05-30 17:45:17');
INSERT INTO `access_log` VALUES (14746, 'a2cb067e-642f-4afb-a587-29281bf65beb', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:45:17', 189, 0, '', '2019-05-30 17:45:17');
INSERT INTO `access_log` VALUES (14747, '56f717b0-918c-4431-9499-da414efe0759', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:45:17', 196, 2001001000, '服务端发生异常', '2019-05-30 17:45:18');
INSERT INTO `access_log` VALUES (14748, '42e38735-e27b-4e5c-81d4-56c117027929', 1, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=false&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:45:33', 210, 2001001000, '服务端发生异常', '2019-05-30 17:45:34');
INSERT INTO `access_log` VALUES (14749, 'a32bcecd-afc2-4194-8a95-3b10b5abc4e4', 1, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:45:54', 161, 2001001000, '服务端发生异常', '2019-05-30 17:45:54');
INSERT INTO `access_log` VALUES (14750, '7b1ced5a-e0aa-457d-a95b-37ee46ef05b2', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:46:03', 102, 0, '', '2019-05-30 17:46:04');
INSERT INTO `access_log` VALUES (14751, 'd23721f4-4f23-4fa1-818b-f64973105d78', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=8&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:46:17', 153, 0, '', '2019-05-30 17:46:17');
INSERT INTO `access_log` VALUES (14752, '790ad484-2872-44ee-849b-5aebb5f818f1', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:46:21', 79, 0, '', '2019-05-30 17:46:21');
INSERT INTO `access_log` VALUES (14753, '5485192d-1246-4d9c-9e06-b10428300833', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:46:22', 67, 0, '', '2019-05-30 17:46:22');
INSERT INTO `access_log` VALUES (14754, '2f6b991c-a351-4d3d-b889-e953085bf8c4', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:46:22', 166, 0, '', '2019-05-30 17:46:23');
INSERT INTO `access_log` VALUES (14755, 'db060796-971f-4969-9826-3929f24be59c', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:46:44', 24, 0, '', '2019-05-30 17:46:44');
INSERT INTO `access_log` VALUES (14756, 'e50d25a1-9c01-49c5-91f4-d9876f614a50', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:46:44', 54, 0, '', '2019-05-30 17:46:44');
INSERT INTO `access_log` VALUES (14757, '0e7c4187-ea73-41d0-a2d6-1c0bced8049b', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:46:46', 60, 0, '', '2019-05-30 17:46:46');
INSERT INTO `access_log` VALUES (14758, '66c097c0-0b3c-447d-a652-ce7200735dde', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:46:46', 187, 0, '', '2019-05-30 17:46:46');
INSERT INTO `access_log` VALUES (14759, 'e5aeabd9-db7f-4772-8f40-cf9369acee49', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18616392909&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:47:03', 127, 1001003000, '验证码不存在', '2019-05-30 17:47:03');
INSERT INTO `access_log` VALUES (14760, 'c4e788d9-a928-4539-9f03-6d95cc1787e8', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18616392909', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:47:08', 315, 0, '', '2019-05-30 17:47:09');
INSERT INTO `access_log` VALUES (14761, '6e579931-72d3-4826-a573-7187e3ecdce4', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18616392909&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '127.0.0.1', '2019-05-30 17:47:11', 635, 0, '', '2019-05-30 17:47:12');
INSERT INTO `access_log` VALUES (14762, 'fd09ec87-c2ce-4b1b-a4f4-486e52c7d469', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18616392909', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:49:28', 234, 0, '', '2019-05-30 17:49:28');
INSERT INTO `access_log` VALUES (14763, '77510aa1-05ff-489d-ba2b-514c92decc9a', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18616392909&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:49:37', 595, 0, '', '2019-05-30 17:49:38');
INSERT INTO `access_log` VALUES (14764, 'd326befd-9f4f-466a-bc87-5ba930cac82a', 92, 1, 'user-application', '/user-api/users/address/add', 'name=333&tel=13511111111&country=&province=北京市&city=北京市&county=西城区&areaCode=110102&postalCode=&addressDetail=333&isDefault=true&address=333&areaNo=110102&mobile=13511111111&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:49:58', 168, 2001001000, '服务端发生异常', '2019-05-30 17:49:58');
INSERT INTO `access_log` VALUES (14765, '5fa2f972-70b5-49f6-bdd0-c9445662255d', 92, 1, 'user-application', '/user-api/users/address/add', 'name=333&tel=13511111111&country=&province=北京市&city=北京市&county=西城区&areaCode=110102&postalCode=&addressDetail=1&isDefault=true&address=1&areaNo=110102&mobile=13511111111&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:50:39', 111, 2001001000, '服务端发生异常', '2019-05-30 17:50:39');
INSERT INTO `access_log` VALUES (14766, '3aeb8965-521c-44d7-bffd-e67c14f23761', 92, 1, 'user-application', '/user-api/users/address/add', 'name=333&tel=13511111111&country=&province=北京市&city=北京市&county=西城区&areaCode=110102&postalCode=&addressDetail=北京市商城测试地址&isDefault=true&address=北京市商城测试地址&areaNo=110102&mobile=13511111111&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:50:51', 107, 2001001000, '服务端发生异常', '2019-05-30 17:50:51');
INSERT INTO `access_log` VALUES (14767, '3c37b446-d9de-4e1e-b99a-c890767a03bc', 92, 1, 'user-application', '/user-api/users/address/add', 'name=333&tel=13511111111&country=&province=北京市&city=北京市&county=西城区&areaCode=110102&postalCode=&addressDetail=北京市商城测试地址3335666&isDefault=true&address=北京市商城测试地址3335666&areaNo=110102&mobile=13511111111&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:50:55', 185, 0, '', '2019-05-30 17:50:55');
INSERT INTO `access_log` VALUES (14768, 'd7489f52-5cc8-4838-ae32-71016922bb2a', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18616392909', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:51:07', 88, 0, '', '2019-05-30 17:51:07');
INSERT INTO `access_log` VALUES (14769, 'bde4e210-c6f6-40d5-8684-ecf9d0c21a0c', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18616392909&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:51:15', 430, 0, '', '2019-05-30 17:51:16');
INSERT INTO `access_log` VALUES (14770, '6f931003-7939-4359-80a3-9cdbfcd96085', 92, 1, 'user-application', '/user-api/users/address/add', 'name=测&tel= 13666666660&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=35466777777777&isDefault=true&address=35466777777777&areaNo=110101&mobile= 13666666660&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:51:46', 96, 2001001000, '服务端发生异常', '2019-05-30 17:51:46');
INSERT INTO `access_log` VALUES (14771, '23592718-c287-4b56-84d5-816dac705e94', 92, 1, 'user-application', '/user-api/users/address/add', 'name=测&tel= 13666666660&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=3546677777&isDefault=true&address=3546677777&areaNo=110101&mobile= 13666666660&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:51:59', 124, 2001001000, '服务端发生异常', '2019-05-30 17:51:59');
INSERT INTO `access_log` VALUES (14772, 'fa53c0b8-cd51-432c-90cc-29ecd7e7be82', 92, 1, 'user-application', '/user-api/users/address/add', 'name=测&tel= 13666666660&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=3测大声道是546677777&isDefault=true&address=3测大声道是546677777&areaNo=110101&mobile= 13666666660&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:52:05', 100, 2001001000, '服务端发生异常', '2019-05-30 17:52:05');
INSERT INTO `access_log` VALUES (14773, '6a9dfe34-f5e4-4a19-a7ce-836ee9d2bfc3', 92, 1, 'user-application', '/user-api/users/address/add', 'name=测&tel= 13612345678&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=测试地址的打对方 13666&isDefault=true&address=测试地址的打对方 13666&areaNo=110101&mobile= 13612345678&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:52:29', 107, 2001001000, '服务端发生异常', '2019-05-30 17:52:29');
INSERT INTO `access_log` VALUES (14774, 'd149af61-3aef-4095-b7d5-0a3e90bb11d6', 92, 1, 'user-application', '/user-api/users/address/add', 'name=测&tel= 13612345678&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=测试地址的打对方 13666&isDefault=true&address=测试地址的打对方 13666&areaNo=110101&mobile= 13612345678&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:52:49', 140, 2001001000, '服务端发生异常', '2019-05-30 17:52:49');
INSERT INTO `access_log` VALUES (14775, '2dfecf59-e934-4c1d-9b1e-de9e7c67f650', 92, 1, 'user-application', '/user-api/users/address/add', 'name=测&tel=13612345678&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=测试地址的打对方 13666&isDefault=true&address=测试地址的打对方 13666&areaNo=110101&mobile=13612345678&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:52:53', 326, 0, '', '2019-05-30 17:52:54');
INSERT INTO `access_log` VALUES (14776, '5eea20a3-1a8c-47d5-838d-37c319fa0730', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:59:36', 120, 0, '', '2019-05-30 17:59:36');
INSERT INTO `access_log` VALUES (14777, '08aab763-6c28-46d7-a41d-18f0317940f7', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:59:42', 71, 0, '', '2019-05-30 17:59:42');
INSERT INTO `access_log` VALUES (14778, '822885b2-129e-47e2-9842-13ee9c31976e', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:59:50', 167, 0, '', '2019-05-30 17:59:50');
INSERT INTO `access_log` VALUES (14779, 'daa1b828-68e8-421a-b6a2-ae8103bc13f6', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:59:50', 306, 2001001000, '服务端发生异常', '2019-05-30 17:59:50');
INSERT INTO `access_log` VALUES (14780, '97107ebd-e825-469a-ad1c-3f10ef4fd5ca', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 18:00:00', 125, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-30 18:00:00');
INSERT INTO `access_log` VALUES (14781, '5a25fe59-dcc1-45ed-9a79-6860f4d31c8c', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 18:00:03', 43, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-30 18:00:03');
INSERT INTO `access_log` VALUES (14782, '9d34a408-6c5d-4950-9f19-11613846fb4c', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 18:00:04', 59, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-30 18:00:04');
INSERT INTO `access_log` VALUES (14783, 'f19eb7d1-623a-480b-9a3c-9fbf92a29d43', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 18:00:08', 43, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-30 18:00:08');
INSERT INTO `access_log` VALUES (14784, '8ca6dea5-8e3e-41fa-8c94-b56aca25e15d', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 18:00:09', 988, 0, '', '2019-05-30 18:00:10');
INSERT INTO `access_log` VALUES (14785, '95693692-c672-48ce-a42f-32fd9cedae06', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 18:00:17', 105, 0, '', '2019-05-30 18:00:17');
INSERT INTO `access_log` VALUES (14786, 'a0847d29-1265-4190-bd0b-f1fa81e4f4be', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 18:00:18', 184, 0, '', '2019-05-30 18:00:18');
INSERT INTO `access_log` VALUES (14787, '0fdf9819-eb3b-429b-abd3-538466f56530', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 18:00:21', 71, 0, '', '2019-05-30 18:00:21');
INSERT INTO `access_log` VALUES (14788, '59.80.15592169407301631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:01', 12, 0, '', '2019-05-30 19:49:01');
INSERT INTO `access_log` VALUES (14789, '59.72.15592169407301629', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:01', 16, 2001001000, '服务端发生异常', '2019-05-30 19:49:01');
INSERT INTO `access_log` VALUES (14790, '64.78.15592169444260999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:04', 118, 0, '', '2019-05-30 19:49:05');
INSERT INTO `access_log` VALUES (14791, '64.81.15592169448570991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:05', 3, 0, '', '2019-05-30 19:49:05');
INSERT INTO `access_log` VALUES (14792, '59.76.15592169453061629', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:05', 4, 0, '', '2019-05-30 19:49:05');
INSERT INTO `access_log` VALUES (14793, '59.74.15592169453201633', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:05', 19, 2001001000, '服务端发生异常', '2019-05-30 19:49:05');
INSERT INTO `access_log` VALUES (14794, '64.82.15592169474721003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:07', 2, 0, '', '2019-05-30 19:49:07');
INSERT INTO `access_log` VALUES (14795, '64.85.15592169477681001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:08', 2, 0, '', '2019-05-30 19:49:08');
INSERT INTO `access_log` VALUES (14796, '64.80.15592169489580991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:09', 358, 0, '', '2019-05-30 19:49:09');
INSERT INTO `access_log` VALUES (14797, '64.77.15592169494280999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:09', 2, 0, '', '2019-05-30 19:49:09');
INSERT INTO `access_log` VALUES (14798, '64.84.15592169500751003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:10', 3, 0, '', '2019-05-30 19:49:10');
INSERT INTO `access_log` VALUES (14799, '64.83.15592169541080995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:14', 2, 0, '', '2019-05-30 19:49:14');
INSERT INTO `access_log` VALUES (14800, '64.79.15592169543440993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:14', 2, 0, '', '2019-05-30 19:49:14');
INSERT INTO `access_log` VALUES (14801, '59.79.15592169572531631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:17', 3, 0, '', '2019-05-30 19:49:17');
INSERT INTO `access_log` VALUES (14802, '59.77.15592169572571629', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:17', 12, 2001001000, '服务端发生异常', '2019-05-30 19:49:17');
INSERT INTO `access_log` VALUES (14803, '59.71.15592169592841635', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:19', 3, 0, '', '2019-05-30 19:49:19');
INSERT INTO `access_log` VALUES (14804, '59.78.15592169592851639', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:19', 13, 2001001000, '服务端发生异常', '2019-05-30 19:49:19');
INSERT INTO `access_log` VALUES (14805, '64.81.15592169608200993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:21', 3, 0, '', '2019-05-30 19:49:21');
INSERT INTO `access_log` VALUES (14806, '64.76.15592169610960999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:21', 2, 0, '', '2019-05-30 19:49:21');
INSERT INTO `access_log` VALUES (14807, '59.80.15592169614651633', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:21', 3, 0, '', '2019-05-30 19:49:21');
INSERT INTO `access_log` VALUES (14808, '59.72.15592169614651631', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/6490 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '106.16.133.242', '2019-05-30 19:49:21', 13, 2001001000, '服务端发生异常', '2019-05-30 19:49:21');
INSERT INTO `access_log` VALUES (14809, '64.82.15592169645051005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:25', 3, 0, '', '2019-05-30 19:49:25');
INSERT INTO `access_log` VALUES (14810, '64.85.15592169646861003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:25', 3, 0, '', '2019-05-30 19:49:25');
INSERT INTO `access_log` VALUES (14811, '64.80.15592169670940993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:27', 311, 0, '', '2019-05-30 19:49:27');
INSERT INTO `access_log` VALUES (14812, '64.77.15592169686411001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:29', 2, 0, '', '2019-05-30 19:49:29');
INSERT INTO `access_log` VALUES (14813, '64.84.15592169702831005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:30', 3, 0, '', '2019-05-30 19:49:30');
INSERT INTO `access_log` VALUES (14814, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:30', 17, 0, '', '2019-05-30 19:49:30');
INSERT INTO `access_log` VALUES (14815, '64.83.15592169719040997', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:32', 2, 0, '', '2019-05-30 19:49:32');
INSERT INTO `access_log` VALUES (14816, '64.79.15592169720880995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:32', 2, 0, '', '2019-05-30 19:49:32');
INSERT INTO `access_log` VALUES (14817, '59.76.15592169852691631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:45', 3, 0, '', '2019-05-30 19:49:45');
INSERT INTO `access_log` VALUES (14818, '59.74.15592169852751635', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:45', 14, 2001001000, '服务端发生异常', '2019-05-30 19:49:45');
INSERT INTO `access_log` VALUES (14819, '64.76.15592169973481001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:57', 2, 0, '', '2019-05-30 19:49:57');
INSERT INTO `access_log` VALUES (14820, '64.82.15592169975251007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:58', 2, 0, '', '2019-05-30 19:49:58');
INSERT INTO `access_log` VALUES (14821, '59.77.15592169989351631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:59', 3, 0, '', '2019-05-30 19:49:59');
INSERT INTO `access_log` VALUES (14822, '59.75.15592169989511635', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:49:59', 13, 2001001000, '服务端发生异常', '2019-05-30 19:49:59');
INSERT INTO `access_log` VALUES (14823, '64.85.15592170011891005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:50:01', 2, 0, '', '2019-05-30 19:50:01');
INSERT INTO `access_log` VALUES (14824, '64.80.15592170013840995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:50:01', 2, 0, '', '2019-05-30 19:50:01');
INSERT INTO `access_log` VALUES (14825, '59.78.15592170025171641', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:50:03', 14, 2001001000, '服务端发生异常', '2019-05-30 19:50:03');
INSERT INTO `access_log` VALUES (14826, '59.71.15592170025041637', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; NX595J Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5718 MicroMessenger/7.0.4.1420(0x27000437) Process/tools NetType/4G Language/zh_CN', '223.104.212.71', '2019-05-30 19:50:03', 647, 0, '', '2019-05-30 19:50:03');
INSERT INTO `access_log` VALUES (14827, '59.71.15592187695251661', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:19:30', 5, 0, '', '2019-05-30 20:19:30');
INSERT INTO `access_log` VALUES (14828, '59.78.15592187695251665', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:19:30', 17, 2001001000, '服务端发生异常', '2019-05-30 20:19:30');
INSERT INTO `access_log` VALUES (14829, '64.80.15592187766481019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:19:37', 4, 0, '', '2019-05-30 20:19:37');
INSERT INTO `access_log` VALUES (14830, '64.77.15592187768391027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:19:37', 2, 0, '', '2019-05-30 20:19:37');
INSERT INTO `access_log` VALUES (14831, '64.84.15592187843971031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:19:44', 3, 0, '', '2019-05-30 20:19:44');
INSERT INTO `access_log` VALUES (14832, '64.83.15592187845501023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:19:45', 3, 0, '', '2019-05-30 20:19:45');
INSERT INTO `access_log` VALUES (14833, '59.72.15592187848961657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:19:45', 4, 0, '', '2019-05-30 20:19:45');
INSERT INTO `access_log` VALUES (14834, '59.73.15592187848961661', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:19:45', 20, 2001001000, '服务端发生异常', '2019-05-30 20:19:45');
INSERT INTO `access_log` VALUES (14835, '65.46.15592187971201029', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:19:57', 0, 1002001015, '账号未登陆', '2019-05-30 20:19:57');
INSERT INTO `access_log` VALUES (14836, '65.53.15592187971201019', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:19:57', 0, 1002001015, '账号未登陆', '2019-05-30 20:19:57');
INSERT INTO `access_log` VALUES (14837, '65.52.15592187971261027', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:19:57', 0, 1002001015, '账号未登陆', '2019-05-30 20:19:57');
INSERT INTO `access_log` VALUES (14838, '65.51.15592187993171035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:19:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-30 20:19:59');
INSERT INTO `access_log` VALUES (14839, '65.45.15592188209711047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:20:21', 99, 0, '', '2019-05-30 20:20:21');
INSERT INTO `access_log` VALUES (14840, '65.54.15592188215071019', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:20:22', 11, 0, '', '2019-05-30 20:20:22');
INSERT INTO `access_log` VALUES (14841, '65.49.15592188215091043', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:20:22', 10, 0, '', '2019-05-30 20:20:22');
INSERT INTO `access_log` VALUES (14842, '65.47.15592188215121043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:20:22', 10, 0, '', '2019-05-30 20:20:22');
INSERT INTO `access_log` VALUES (14843, '62.83.15592188305591571', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:20:31', 23, 0, '', '2019-05-30 20:20:31');
INSERT INTO `access_log` VALUES (14844, '59.71.15592188504181663', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:20:50', 12, 0, '', '2019-05-30 20:20:50');
INSERT INTO `access_log` VALUES (14845, '59.80.15592188656921661', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:21:06', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-30 20:21:06');
INSERT INTO `access_log` VALUES (14846, '59.72.15592188705441659', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:21:11', 21, 2001001000, '服务端发生异常', '2019-05-30 20:21:11');
INSERT INTO `access_log` VALUES (14847, '65.51.15592188731671037', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:21:13', 20, 0, '', '2019-05-30 20:21:13');
INSERT INTO `access_log` VALUES (14848, '65.50.15592188795241043', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:21:20', 265, 0, '', '2019-05-30 20:21:20');
INSERT INTO `access_log` VALUES (14849, '65.47.15592188847431045', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:21:25', 9, 0, '', '2019-05-30 20:21:25');
INSERT INTO `access_log` VALUES (14850, '65.49.15592189015791045', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:21:42', 16, 0, '', '2019-05-30 20:21:42');
INSERT INTO `access_log` VALUES (14851, '65.52.15592189467031031', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:22:27', 14, 0, '', '2019-05-30 20:22:27');
INSERT INTO `access_log` VALUES (14852, '65.51.15592189472071039', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:22:27', 9, 0, '', '2019-05-30 20:22:27');
INSERT INTO `access_log` VALUES (14853, '65.50.15592189483401045', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:22:28', 11, 0, '', '2019-05-30 20:22:28');
INSERT INTO `access_log` VALUES (14854, '65.45.15592189491111051', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:22:29', 19, 0, '', '2019-05-30 20:22:29');
INSERT INTO `access_log` VALUES (14855, '59.75.15592189497591663', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:22:30', 21, 2001001000, '服务端发生异常', '2019-05-30 20:22:30');
INSERT INTO `access_log` VALUES (14856, '59.71.15592189513111665', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:22:31', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-30 20:22:31');
INSERT INTO `access_log` VALUES (14857, '59.78.15592189520471669', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:22:32', 12, 0, '', '2019-05-30 20:22:32');
INSERT INTO `access_log` VALUES (14858, '62.83.15592189703181573', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-05-30 20:22:50', 13, 0, '', '2019-05-30 20:22:50');
INSERT INTO `access_log` VALUES (14859, '65.52.15592190274971033', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:23:47', 0, 1002001015, '账号未登陆', '2019-05-30 20:23:47');
INSERT INTO `access_log` VALUES (14860, '65.53.15592190274971025', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:23:47', 0, 1002001015, '账号未登陆', '2019-05-30 20:23:47');
INSERT INTO `access_log` VALUES (14861, '65.51.15592190275351041', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:23:48', 0, 1002001015, '账号未登陆', '2019-05-30 20:23:48');
INSERT INTO `access_log` VALUES (14862, '65.50.15592190313891047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:23:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-30 20:23:51');
INSERT INTO `access_log` VALUES (14863, '65.47.15592190395271049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:24:00', 68, 0, '', '2019-05-30 20:24:00');
INSERT INTO `access_log` VALUES (14864, '65.49.15592190400381049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:24:00', 198, 0, '', '2019-05-30 20:24:00');
INSERT INTO `access_log` VALUES (14865, '65.54.15592190400281025', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:24:00', 208, 0, '', '2019-05-30 20:24:00');
INSERT INTO `access_log` VALUES (14866, '65.48.15592190400511051', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:24:00', 185, 0, '', '2019-05-30 20:24:00');
INSERT INTO `access_log` VALUES (14867, '62.88.15592190477041577', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:24:08', 16, 0, '', '2019-05-30 20:24:08');
INSERT INTO `access_log` VALUES (14868, '65.53.15592190774761027', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:24:37', 18, 0, '', '2019-05-30 20:24:37');
INSERT INTO `access_log` VALUES (14869, '65.45.15592190974341055', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:24:57', 591, 0, '', '2019-05-30 20:24:58');
INSERT INTO `access_log` VALUES (14870, '65.47.15592191026161051', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=14', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:25:03', 11, 0, '', '2019-05-30 20:25:03');
INSERT INTO `access_log` VALUES (14871, '65.54.15592191068681027', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:25:07', 11, 0, '', '2019-05-30 20:25:07');
INSERT INTO `access_log` VALUES (14872, '65.48.15592191114871053', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:25:11', 9, 0, '', '2019-05-30 20:25:11');
INSERT INTO `access_log` VALUES (14873, '65.45.15592191853791057', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:26:25', 147, 0, '', '2019-05-30 20:26:26');
INSERT INTO `access_log` VALUES (14874, '59.72.15592192585331665', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:27:39', 13, 0, '', '2019-05-30 20:27:39');
INSERT INTO `access_log` VALUES (14875, '62.81.15592192937161565', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.24.149', '2019-05-30 20:28:14', 19, 0, '', '2019-05-30 20:28:14');
INSERT INTO `access_log` VALUES (14876, '65.47.15592224824521097', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 21:21:22', 20, 1002001012, '访问令牌已过期', '2019-05-30 21:21:22');
INSERT INTO `access_log` VALUES (14877, '65.45.15592224824521101', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 21:21:22', 23, 1002001012, '访问令牌已过期', '2019-05-30 21:21:22');
INSERT INTO `access_log` VALUES (14878, '65.54.15592224824531073', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-30 21:21:22', 23, 1002001012, '访问令牌已过期', '2019-05-30 21:21:22');
INSERT INTO `access_log` VALUES (14879, '59.77.15592226252091709', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '124.78.24.33', '2019-05-30 21:23:45', 13, 0, '', '2019-05-30 21:23:45');
INSERT INTO `access_log` VALUES (14880, '59.75.15592226252101713', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '124.78.24.33', '2019-05-30 21:23:45', 18, 2001001000, '服务端发生异常', '2019-05-30 21:23:45');
INSERT INTO `access_log` VALUES (14881, '64.80.15592226296611071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '124.78.24.33', '2019-05-30 21:23:50', 26, 0, '', '2019-05-30 21:23:50');
INSERT INTO `access_log` VALUES (14882, '64.77.15592226297931079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '124.78.24.33', '2019-05-30 21:23:50', 3, 0, '', '2019-05-30 21:23:50');
INSERT INTO `access_log` VALUES (14883, '64.83.15592226315421075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '124.78.24.33', '2019-05-30 21:23:52', 2, 0, '', '2019-05-30 21:23:52');
INSERT INTO `access_log` VALUES (14884, '64.79.15592226324191073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '124.78.24.33', '2019-05-30 21:23:52', 2, 0, '', '2019-05-30 21:23:52');
INSERT INTO `access_log` VALUES (14885, '59.78.15592226335831719', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '124.78.24.33', '2019-05-30 21:23:54', 4, 0, '', '2019-05-30 21:23:54');
INSERT INTO `access_log` VALUES (14886, '59.80.15592226335831713', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '124.78.24.33', '2019-05-30 21:23:54', 15, 2001001000, '服务端发生异常', '2019-05-30 21:23:54');
INSERT INTO `access_log` VALUES (14887, '65.49.15592274122881163', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:43:32', 0, 1002001015, '账号未登陆', '2019-05-30 22:43:32');
INSERT INTO `access_log` VALUES (14888, '65.47.15592274122881163', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:43:32', 0, 1002001015, '账号未登陆', '2019-05-30 22:43:32');
INSERT INTO `access_log` VALUES (14889, '65.48.15592274122881165', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:43:32', 0, 1002001015, '账号未登陆', '2019-05-30 22:43:32');
INSERT INTO `access_log` VALUES (14890, '65.46.15592274149331151', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:43:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-30 22:43:35');
INSERT INTO `access_log` VALUES (14891, '65.53.15592274268281141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:43:47', 82, 0, '', '2019-05-30 22:43:47');
INSERT INTO `access_log` VALUES (14892, '65.51.15592274271231157', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:43:47', 140, 0, '', '2019-05-30 22:43:47');
INSERT INTO `access_log` VALUES (14893, '65.45.15592274271391169', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:43:47', 127, 0, '', '2019-05-30 22:43:47');
INSERT INTO `access_log` VALUES (14894, '65.50.15592274271361163', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:43:47', 130, 0, '', '2019-05-30 22:43:47');
INSERT INTO `access_log` VALUES (14895, '62.83.15592274330161687', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:43:53', 22, 0, '', '2019-05-30 22:43:53');
INSERT INTO `access_log` VALUES (14896, '62.89.15592274399391685', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:00', 17, 0, '', '2019-05-30 22:44:00');
INSERT INTO `access_log` VALUES (14897, '64.81.15592274422111137', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:02', 15, 0, '', '2019-05-30 22:44:02');
INSERT INTO `access_log` VALUES (14898, '64.78.15592274422041145', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:02', 23, 0, '', '2019-05-30 22:44:02');
INSERT INTO `access_log` VALUES (14899, '64.82.15592274449301149', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:05', 11, 0, '', '2019-05-30 22:44:05');
INSERT INTO `access_log` VALUES (14900, '64.76.15592274449261143', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:05', 16, 0, '', '2019-05-30 22:44:05');
INSERT INTO `access_log` VALUES (14901, '64.84.15592274508701149', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:11', 10, 0, '', '2019-05-30 22:44:11');
INSERT INTO `access_log` VALUES (14902, '64.80.15592274508691137', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:11', 13, 0, '', '2019-05-30 22:44:11');
INSERT INTO `access_log` VALUES (14903, '64.77.15592274508701145', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:11', 18, 0, '', '2019-05-30 22:44:11');
INSERT INTO `access_log` VALUES (14904, '65.47.15592274644051165', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:24', 9, 0, '', '2019-05-30 22:44:24');
INSERT INTO `access_log` VALUES (14905, '65.46.15592274644081153', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:24', 9, 0, '', '2019-05-30 22:44:24');
INSERT INTO `access_log` VALUES (14906, '65.52.15592274644131151', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:24', 9, 0, '', '2019-05-30 22:44:24');
INSERT INTO `access_log` VALUES (14907, '64.81.15592274645601139', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:25', 11, 0, '', '2019-05-30 22:44:25');
INSERT INTO `access_log` VALUES (14908, '64.79.15592274645541139', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:25', 18, 0, '', '2019-05-30 22:44:25');
INSERT INTO `access_log` VALUES (14909, '64.78.15592274645601147', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:25', 15, 0, '', '2019-05-30 22:44:25');
INSERT INTO `access_log` VALUES (14910, '65.53.15592274676951143', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:28', 9, 0, '', '2019-05-30 22:44:28');
INSERT INTO `access_log` VALUES (14911, '65.45.15592274676981171', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:28', 9, 0, '', '2019-05-30 22:44:28');
INSERT INTO `access_log` VALUES (14912, '65.50.15592274677011165', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:28', 8, 0, '', '2019-05-30 22:44:28');
INSERT INTO `access_log` VALUES (14913, '64.76.15592274678071145', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:28', 79, 0, '', '2019-05-30 22:44:28');
INSERT INTO `access_log` VALUES (14914, '64.85.15592274678071149', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:28', 80, 0, '', '2019-05-30 22:44:28');
INSERT INTO `access_log` VALUES (14915, '64.82.15592274677851151', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:28', 106, 0, '', '2019-05-30 22:44:28');
INSERT INTO `access_log` VALUES (14916, '65.51.15592274705571159', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:31', 19, 0, '', '2019-05-30 22:44:31');
INSERT INTO `access_log` VALUES (14917, '65.54.15592274752611143', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:35', 11, 0, '', '2019-05-30 22:44:35');
INSERT INTO `access_log` VALUES (14918, '65.49.15592274764901167', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:36', 9, 0, '', '2019-05-30 22:44:37');
INSERT INTO `access_log` VALUES (14919, '65.48.15592274789071169', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:39', 15, 0, '', '2019-05-30 22:44:39');
INSERT INTO `access_log` VALUES (14920, '59.76.15592274811111775', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:41', 20, 0, '', '2019-05-30 22:44:41');
INSERT INTO `access_log` VALUES (14921, '65.47.15592274952931167', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:44:55', 19, 0, '', '2019-05-30 22:44:55');
INSERT INTO `access_log` VALUES (14922, '65.48.15592276128301171', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:46:53', 11, 0, '', '2019-05-30 22:46:53');
INSERT INTO `access_log` VALUES (14923, '65.46.15592276128321157', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:46:53', 19, 0, '', '2019-05-30 22:46:53');
INSERT INTO `access_log` VALUES (14924, '65.47.15592276128381169', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-05-30 22:46:53', 17, 0, '', '2019-05-30 22:46:53');
INSERT INTO `access_log` VALUES (14925, '65.53.15592591175901567', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.218.33.189', '2019-05-31 07:31:58', 1, 1002001015, '账号未登陆', '2019-05-31 07:31:58');
INSERT INTO `access_log` VALUES (14926, '65.50.15592591175901589', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.218.33.189', '2019-05-31 07:31:58', 1, 1002001015, '账号未登陆', '2019-05-31 07:31:58');
INSERT INTO `access_log` VALUES (14927, '65.51.15592591176011583', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.218.33.189', '2019-05-31 07:31:58', 1, 1002001015, '账号未登陆', '2019-05-31 07:31:58');
INSERT INTO `access_log` VALUES (14928, '65.54.15592591193091567', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.218.33.189', '2019-05-31 07:31:59', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 07:31:59');
INSERT INTO `access_log` VALUES (14929, '65.48.15592617321391627', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.42.142', '2019-05-31 08:15:32', 15, 1002001012, '访问令牌已过期', '2019-05-31 08:15:32');
INSERT INTO `access_log` VALUES (14930, '65.45.15592617321391631', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.42.142', '2019-05-31 08:15:32', 16, 1002001012, '访问令牌已过期', '2019-05-31 08:15:32');
INSERT INTO `access_log` VALUES (14931, '65.51.15592617321401619', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.42.142', '2019-05-31 08:15:32', 28, 1002001012, '访问令牌已过期', '2019-05-31 08:15:32');
INSERT INTO `access_log` VALUES (14932, '65.50.15592617338311625', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.42.142', '2019-05-31 08:15:34', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 08:15:34');
INSERT INTO `access_log` VALUES (14933, '65.54.15592617472751603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.42.142', '2019-05-31 08:15:47', 62, 0, '', '2019-05-31 08:15:47');
INSERT INTO `access_log` VALUES (14934, '65.49.15592617476071627', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.42.142', '2019-05-31 08:15:48', 11, 0, '', '2019-05-31 08:15:48');
INSERT INTO `access_log` VALUES (14935, '65.52.15592617476111613', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.42.142', '2019-05-31 08:15:48', 11, 0, '', '2019-05-31 08:15:48');
INSERT INTO `access_log` VALUES (14936, '65.46.15592617476151615', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.42.142', '2019-05-31 08:15:48', 12, 0, '', '2019-05-31 08:15:48');
INSERT INTO `access_log` VALUES (14937, '65.45.15592617559581633', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.42.142', '2019-05-31 08:15:56', 15, 0, '', '2019-05-31 08:15:56');
INSERT INTO `access_log` VALUES (14938, '65.48.15592617565211629', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.42.142', '2019-05-31 08:15:57', 397, 0, '', '2019-05-31 08:15:57');
INSERT INTO `access_log` VALUES (14939, '65.51.15592617598871621', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.42.142', '2019-05-31 08:16:00', 10, 0, '', '2019-05-31 08:16:00');
INSERT INTO `access_log` VALUES (14940, '65.53.15592653812871653', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.68.57', '2019-05-31 09:16:21', 117, 1002001012, '访问令牌已过期', '2019-05-31 09:16:21');
INSERT INTO `access_log` VALUES (14941, '65.54.15592653812871653', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.68.57', '2019-05-31 09:16:21', 117, 1002001012, '访问令牌已过期', '2019-05-31 09:16:21');
INSERT INTO `access_log` VALUES (14942, '65.52.15592653813051663', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.68.57', '2019-05-31 09:16:21', 98, 1002001012, '访问令牌已过期', '2019-05-31 09:16:21');
INSERT INTO `access_log` VALUES (14943, '65.49.15592653840371677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.68.57', '2019-05-31 09:16:24', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 09:16:24');
INSERT INTO `access_log` VALUES (14944, '65.47.15592653861381677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.68.57', '2019-05-31 09:16:26', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 09:16:26');
INSERT INTO `access_log` VALUES (14945, '65.45.15592653883521683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.68.57', '2019-05-31 09:16:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 09:16:28');
INSERT INTO `access_log` VALUES (14946, '65.48.15592653944701679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.68.57', '2019-05-31 09:16:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 09:16:34');
INSERT INTO `access_log` VALUES (14947, '65.51.15592653962491671', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.68.57', '2019-05-31 09:16:36', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 09:16:36');
INSERT INTO `access_log` VALUES (14948, '65.50.15592653974691677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.68.57', '2019-05-31 09:16:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 09:16:37');
INSERT INTO `access_log` VALUES (14949, '65.52.15592654051281665', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.68.57', '2019-05-31 09:16:45', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 09:16:45');
INSERT INTO `access_log` VALUES (14950, '65.53.15592656678371659', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 09:21:08', 560, 1002001012, '访问令牌已过期', '2019-05-31 09:21:08');
INSERT INTO `access_log` VALUES (14951, '65.50.15592656678341681', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 09:21:08', 563, 1002001012, '访问令牌已过期', '2019-05-31 09:21:08');
INSERT INTO `access_log` VALUES (14952, '65.52.15592656678511669', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 09:21:08', 550, 1002001012, '访问令牌已过期', '2019-05-31 09:21:08');
INSERT INTO `access_log` VALUES (14953, '64.82.15592656682801661', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 09:21:08', 123, 1002001012, '访问令牌已过期', '2019-05-31 09:21:08');
INSERT INTO `access_log` VALUES (14954, '64.76.15592656682791655', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 09:21:08', 123, 1002001012, '访问令牌已过期', '2019-05-31 09:21:08');
INSERT INTO `access_log` VALUES (14955, 'd3674856-2ab2-40f7-9101-3aa683932193', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 09:51:03', 738, 1002001012, '访问令牌已过期', '2019-05-31 09:51:04');
INSERT INTO `access_log` VALUES (14956, '5adaf546-0137-4a54-895e-c50d691811f4', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 09:51:03', 738, 1002001012, '访问令牌已过期', '2019-05-31 09:51:04');
INSERT INTO `access_log` VALUES (14957, '88f1089b-b1d5-4e58-8157-a9873d8961df', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 09:51:03', 738, 1002001012, '访问令牌已过期', '2019-05-31 09:51:04');
INSERT INTO `access_log` VALUES (14958, '0e2e9208-6dc7-4d53-984b-cda78cfda991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 09:52:47', 387, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 09:52:47');
INSERT INTO `access_log` VALUES (14959, 'e2f7168e-ce03-46c3-b342-0a1fe549f276', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 09:52:53', 521, 0, '', '2019-05-31 09:52:54');
INSERT INTO `access_log` VALUES (14960, 'cd5a624d-5fec-4bb1-98ae-1ba65cd45d24', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 09:52:55', 263, 0, '', '2019-05-31 09:52:55');
INSERT INTO `access_log` VALUES (14961, 'efe4e850-d78d-4753-aa8b-6d54e570b29d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 09:52:55', 306, 0, '', '2019-05-31 09:52:55');
INSERT INTO `access_log` VALUES (14962, '51e78be6-95b9-4a65-85ec-55d7812c95f0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 09:52:55', 341, 0, '', '2019-05-31 09:52:55');
INSERT INTO `access_log` VALUES (14963, '1b163034-2a3c-471d-a0db-c0718e86594d', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 09:55:14', 1623, 0, '', '2019-05-31 09:55:15');
INSERT INTO `access_log` VALUES (14964, '84282ead-a09b-44c8-a3d9-202c9be71f5c', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 09:55:14', 1623, 0, '', '2019-05-31 09:55:15');
INSERT INTO `access_log` VALUES (14965, '5e8cf8b1-2424-4031-bc73-00d429ebb8fb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:13:41', 71, 0, '', '2019-05-31 10:13:41');
INSERT INTO `access_log` VALUES (14966, '120e57c8-4fad-43aa-a033-4b23d4e0a818', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:13:41', 60, 0, '', '2019-05-31 10:13:41');
INSERT INTO `access_log` VALUES (14967, '920cd9a8-d8c8-4919-b8ba-7ee1bc295de2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:13:41', 82, 0, '', '2019-05-31 10:13:41');
INSERT INTO `access_log` VALUES (14968, '58576857-4dbf-4391-881e-46bd2370b951', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:13:41', 242, 0, '', '2019-05-31 10:13:42');
INSERT INTO `access_log` VALUES (14969, 'd780b9f5-b313-4964-906f-d196a350af8f', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:13:41', 294, 0, '', '2019-05-31 10:13:42');
INSERT INTO `access_log` VALUES (14970, '10ad7c5e-43c1-484b-8c1f-6882f7f78472', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:13:52', 50, 0, '', '2019-05-31 10:13:52');
INSERT INTO `access_log` VALUES (14971, '75657130-5765-4f86-95bb-5560028c47ed', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:13:52', 60, 0, '', '2019-05-31 10:13:52');
INSERT INTO `access_log` VALUES (14972, '5352609d-e836-4696-9e6f-518af011eae2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:13:52', 64, 0, '', '2019-05-31 10:13:52');
INSERT INTO `access_log` VALUES (14973, '4cfe5f3c-80df-46a0-90af-e5012d1e4ae0', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:13:53', 59, 0, '', '2019-05-31 10:13:53');
INSERT INTO `access_log` VALUES (14974, '908bf774-5652-4755-9a70-fab4140e9ab7', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:13:53', 614, 0, '', '2019-05-31 10:13:54');
INSERT INTO `access_log` VALUES (14975, '51bedfc5-2fa5-4ee7-b6cb-5846f846cc2c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:15:54', 66, 0, '', '2019-05-31 10:15:54');
INSERT INTO `access_log` VALUES (14976, '375ccf3e-d28e-4fdb-a616-625b822704ab', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:15:54', 63, 0, '', '2019-05-31 10:15:54');
INSERT INTO `access_log` VALUES (14977, '0d90d68d-686c-45ed-a1b4-3247b2ec072e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:15:54', 67, 0, '', '2019-05-31 10:15:54');
INSERT INTO `access_log` VALUES (14978, 'f2d2e1cc-3c4d-4ca4-951a-26dba70c4726', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:15:54', 157, 0, '', '2019-05-31 10:15:54');
INSERT INTO `access_log` VALUES (14979, 'e2c48c6c-8f48-423a-aa1a-e20b933c9672', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:15:54', 175, 0, '', '2019-05-31 10:15:54');
INSERT INTO `access_log` VALUES (14980, '63ca968f-5a37-4324-b8b7-9bd897328d88', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:15:58', 36, 0, '', '2019-05-31 10:15:58');
INSERT INTO `access_log` VALUES (14981, '724d3100-2224-4adb-bbbb-8e33e4baee6b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:15:58', 42, 0, '', '2019-05-31 10:15:59');
INSERT INTO `access_log` VALUES (14982, 'd3180bc6-3f3c-4076-9dd0-d6dcba2db760', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:15:58', 49, 0, '', '2019-05-31 10:15:59');
INSERT INTO `access_log` VALUES (14983, 'ec6ebbbf-30ea-4260-9bef-7463cb5a44d2', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:15:59', 78, 0, '', '2019-05-31 10:15:59');
INSERT INTO `access_log` VALUES (14984, '88508380-053f-44eb-9625-7c9ec2789472', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:15:59', 96, 0, '', '2019-05-31 10:15:59');
INSERT INTO `access_log` VALUES (14985, '65.52.15592690210561713', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.119.152.198', '2019-05-31 10:17:01', 15, 1002001012, '访问令牌已过期', '2019-05-31 10:17:01');
INSERT INTO `access_log` VALUES (14986, '65.46.15592690210561715', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.119.152.198', '2019-05-31 10:17:01', 13, 1002001012, '访问令牌已过期', '2019-05-31 10:17:01');
INSERT INTO `access_log` VALUES (14987, '65.51.15592690210581719', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.119.152.198', '2019-05-31 10:17:01', 24, 1002001012, '访问令牌已过期', '2019-05-31 10:17:01');
INSERT INTO `access_log` VALUES (14988, '65.45.15592690283121733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.119.152.198', '2019-05-31 10:17:08', 61, 0, '', '2019-05-31 10:17:08');
INSERT INTO `access_log` VALUES (14989, '65.48.15592690286241731', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.119.152.198', '2019-05-31 10:17:09', 13, 0, '', '2019-05-31 10:17:09');
INSERT INTO `access_log` VALUES (14990, '65.53.15592690286271707', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.119.152.198', '2019-05-31 10:17:09', 15, 0, '', '2019-05-31 10:17:09');
INSERT INTO `access_log` VALUES (14991, '65.54.15592690286321707', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.119.152.198', '2019-05-31 10:17:09', 11, 0, '', '2019-05-31 10:17:09');
INSERT INTO `access_log` VALUES (14992, '62.81.15592690361182229', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.119.152.198', '2019-05-31 10:17:16', 99, 0, '', '2019-05-31 10:17:16');
INSERT INTO `access_log` VALUES (14993, '7b612a1f-0094-4ea8-bfed-0fff58284b53', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:21:02', 51, 0, '', '2019-05-31 10:21:02');
INSERT INTO `access_log` VALUES (14994, 'a445fda7-d35b-4bff-8263-18edb0a809d3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:21:02', 53, 0, '', '2019-05-31 10:21:02');
INSERT INTO `access_log` VALUES (14995, 'd9115dab-9aeb-46bf-9059-0779b8ced249', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:21:02', 61, 0, '', '2019-05-31 10:21:02');
INSERT INTO `access_log` VALUES (14996, '08725b3d-bc46-4d2d-bb66-0f55584cc81b', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:21:02', 177, 0, '', '2019-05-31 10:21:02');
INSERT INTO `access_log` VALUES (14997, '1b3dbc36-297e-462b-a3b5-d95376086c49', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:21:02', 168, 0, '', '2019-05-31 10:21:02');
INSERT INTO `access_log` VALUES (14998, 'c339e5d6-f8fa-43a8-b931-e7b4ee8d7cfd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:11', 155, 0, '', '2019-05-31 10:22:12');
INSERT INTO `access_log` VALUES (14999, 'fc745cb5-29cc-4a07-976e-49bd630db3c5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:11', 164, 0, '', '2019-05-31 10:22:12');
INSERT INTO `access_log` VALUES (15000, '1d26a2ee-6372-4fc9-ad01-85af8d17d924', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:11', 175, 0, '', '2019-05-31 10:22:12');
INSERT INTO `access_log` VALUES (15001, 'db50eb97-b3ed-422a-b1e2-2b04750adb0d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:17', 43, 0, '', '2019-05-31 10:22:17');
INSERT INTO `access_log` VALUES (15002, '055449b3-ee1c-4834-9c35-60556c7c0471', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:17', 45, 0, '', '2019-05-31 10:22:17');
INSERT INTO `access_log` VALUES (15003, 'ad11ac55-6afa-4dbc-a0ab-980e8105dcd0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:17', 58, 0, '', '2019-05-31 10:22:17');
INSERT INTO `access_log` VALUES (15004, '753a00a9-e395-469b-b39f-5e8ad7dfbb03', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:17', 107, 0, '', '2019-05-31 10:22:17');
INSERT INTO `access_log` VALUES (15005, '5d5c3e26-3c59-4af6-a6bf-83d3d7d8847d', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:17', 134, 0, '', '2019-05-31 10:22:17');
INSERT INTO `access_log` VALUES (15006, '83fb5bfe-661c-4af4-9933-831b5a128261', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:19', 47, 0, '', '2019-05-31 10:22:19');
INSERT INTO `access_log` VALUES (15007, '9ee98010-db50-4b9e-8445-bf0425776478', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:19', 52, 0, '', '2019-05-31 10:22:19');
INSERT INTO `access_log` VALUES (15008, 'ed237dc6-2003-403e-937a-1cf8c88034ab', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:19', 49, 0, '', '2019-05-31 10:22:19');
INSERT INTO `access_log` VALUES (15009, '1ca7ec85-a892-43b0-b37e-5672e30b769f', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:20', 66, 0, '', '2019-05-31 10:22:20');
INSERT INTO `access_log` VALUES (15010, '4cf56bc3-5a9d-4023-a2ef-7d14504d9639', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:20', 77, 0, '', '2019-05-31 10:22:20');
INSERT INTO `access_log` VALUES (15011, '920bf119-0636-4ee6-b4df-2f78799764ad', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:40', 50, 0, '', '2019-05-31 10:22:40');
INSERT INTO `access_log` VALUES (15012, 'a2c7728f-f372-4d8a-82d1-2df8b506ce3e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:40', 54, 0, '', '2019-05-31 10:22:40');
INSERT INTO `access_log` VALUES (15013, '0cf3eb53-127f-4f6d-9ff9-6513229035d3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:40', 49, 0, '', '2019-05-31 10:22:40');
INSERT INTO `access_log` VALUES (15014, '13292457-ca47-4ac3-a619-1bfa6c7079d0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:43', 36, 0, '', '2019-05-31 10:22:43');
INSERT INTO `access_log` VALUES (15015, 'db94f3dd-2b69-43a2-a210-e7f7c5636e9e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:43', 36, 0, '', '2019-05-31 10:22:43');
INSERT INTO `access_log` VALUES (15016, '522f808e-0b48-4241-9b95-fe6a7707cb04', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:43', 37, 0, '', '2019-05-31 10:22:43');
INSERT INTO `access_log` VALUES (15017, '3c9f34f0-1455-465f-addd-ce536abb440a', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:44', 63, 0, '', '2019-05-31 10:22:44');
INSERT INTO `access_log` VALUES (15018, '544153f0-bcff-46fb-8f82-296890f008b0', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:22:44', 69, 0, '', '2019-05-31 10:22:44');
INSERT INTO `access_log` VALUES (15019, 'b29986ec-ed6f-4659-a5e8-e9dae5da7522', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:06', 43, 0, '', '2019-05-31 10:24:06');
INSERT INTO `access_log` VALUES (15020, '093dd65b-cd25-4a60-bdfd-6121e417a6af', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:06', 49, 0, '', '2019-05-31 10:24:06');
INSERT INTO `access_log` VALUES (15021, '088a5339-ee12-4143-8221-465139bc8852', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:07', 50, 0, '', '2019-05-31 10:24:07');
INSERT INTO `access_log` VALUES (15022, '8a37902b-518f-4cbc-94b4-a0d1787c1303', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:09', 68, 0, '', '2019-05-31 10:24:09');
INSERT INTO `access_log` VALUES (15023, '3fa71b0b-d059-4772-b625-ba085cb218a3', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:09', 78, 0, '', '2019-05-31 10:24:09');
INSERT INTO `access_log` VALUES (15024, '09a641b4-53cd-40ef-bc4b-72d8afa9655a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:12', 44, 0, '', '2019-05-31 10:24:12');
INSERT INTO `access_log` VALUES (15025, 'b9d79b25-1500-465f-86db-9bf2af1fa128', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:12', 54, 0, '', '2019-05-31 10:24:12');
INSERT INTO `access_log` VALUES (15026, '2089e7bb-06ed-4f56-af4b-ce9ee39a46f0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:12', 62, 0, '', '2019-05-31 10:24:12');
INSERT INTO `access_log` VALUES (15027, '7bb7dacf-2d98-4fb3-b554-8c2a256f1ab7', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:12', 97, 0, '', '2019-05-31 10:24:12');
INSERT INTO `access_log` VALUES (15028, '5d39d650-f6bb-4ef2-b3b5-7e8c0f10744e', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:12', 144, 0, '', '2019-05-31 10:24:12');
INSERT INTO `access_log` VALUES (15029, '28a224a0-3984-44e3-ab92-b38c5bbe1c46', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:38', 234, 0, '', '2019-05-31 10:24:38');
INSERT INTO `access_log` VALUES (15030, '89df91d6-eee2-4d56-bced-eeb2dfe4d20f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:38', 243, 0, '', '2019-05-31 10:24:38');
INSERT INTO `access_log` VALUES (15031, '86aa9b87-e34f-44ce-b930-5e8c0f9ac0ea', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:38', 244, 0, '', '2019-05-31 10:24:38');
INSERT INTO `access_log` VALUES (15032, '96f83136-c5dc-413d-8e0c-9dce455a6add', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:40', 58, 0, '', '2019-05-31 10:24:40');
INSERT INTO `access_log` VALUES (15033, 'a594e184-d0aa-4ff7-9de9-c570c4e05c32', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:24:40', 67, 0, '', '2019-05-31 10:24:40');
INSERT INTO `access_log` VALUES (15034, '65.52.15592698453901725', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:30:45', 0, 1002001015, '账号未登陆', '2019-05-31 10:30:45');
INSERT INTO `access_log` VALUES (15035, '65.45.15592698453901745', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:30:45', 0, 1002001015, '账号未登陆', '2019-05-31 10:30:45');
INSERT INTO `access_log` VALUES (15036, '65.48.15592698453941743', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:30:45', 1, 1002001015, '账号未登陆', '2019-05-31 10:30:45');
INSERT INTO `access_log` VALUES (15037, '65.54.15592698685941719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:31:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 10:31:09');
INSERT INTO `access_log` VALUES (15038, '65.47.15592698732141743', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:31:13', 375, 0, '', '2019-05-31 10:31:14');
INSERT INTO `access_log` VALUES (15039, '65.50.15592698738641741', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:31:14', 9, 0, '', '2019-05-31 10:31:14');
INSERT INTO `access_log` VALUES (15040, '65.51.15592698738761733', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:31:14', 9, 0, '', '2019-05-31 10:31:14');
INSERT INTO `access_log` VALUES (15041, '65.46.15592698738761729', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:31:14', 9, 0, '', '2019-05-31 10:31:14');
INSERT INTO `access_log` VALUES (15042, '62.84.15592699061282247', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:31:46', 20, 0, '', '2019-05-31 10:31:46');
INSERT INTO `access_log` VALUES (15043, '64.78.15592699103541717', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:31:50', 12, 0, '', '2019-05-31 10:31:50');
INSERT INTO `access_log` VALUES (15044, '64.85.15592699103441717', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:31:50', 23, 0, '', '2019-05-31 10:31:50');
INSERT INTO `access_log` VALUES (15045, '64.83.15592699136241709', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:31:54', 10, 0, '', '2019-05-31 10:31:54');
INSERT INTO `access_log` VALUES (15046, '64.77.15592699136231715', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:31:54', 12, 0, '', '2019-05-31 10:31:54');
INSERT INTO `access_log` VALUES (15047, '64.81.15592699173271707', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:31:57', 216, 0, '', '2019-05-31 10:31:58');
INSERT INTO `access_log` VALUES (15048, '64.79.15592699173251707', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:31:57', 222, 0, '', '2019-05-31 10:31:58');
INSERT INTO `access_log` VALUES (15049, '64.84.15592699173251717', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:31:57', 224, 0, '', '2019-05-31 10:31:58');
INSERT INTO `access_log` VALUES (15050, '65.53.15592699260411721', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:32:06', 19, 0, '', '2019-05-31 10:32:06');
INSERT INTO `access_log` VALUES (15051, '65.54.15592699269931721', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:32:07', 19, 0, '', '2019-05-31 10:32:07');
INSERT INTO `access_log` VALUES (15052, '65.49.15592699280221745', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:32:08', 8, 0, '', '2019-05-31 10:32:08');
INSERT INTO `access_log` VALUES (15053, '65.46.15592699298061731', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.37.140.28', '2019-05-31 10:32:10', 14, 0, '', '2019-05-31 10:32:10');
INSERT INTO `access_log` VALUES (15054, 'fd0aa316-665c-48b3-8f73-85c9c164af21', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:52:24', 19, 1002001012, '访问令牌已过期', '2019-05-31 10:52:24');
INSERT INTO `access_log` VALUES (15055, 'ae508d1f-a1af-48be-b32a-daa1534d09ca', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:52:24', 20, 1002001012, '访问令牌已过期', '2019-05-31 10:52:24');
INSERT INTO `access_log` VALUES (15056, 'daa712cb-396c-4fba-a3cf-efa29d8bed8e', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:52:24', 20, 1002001012, '访问令牌已过期', '2019-05-31 10:52:24');
INSERT INTO `access_log` VALUES (15057, 'b1ce090b-1f7b-4867-9126-b0219f85225f', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:52:25', 16, 1002001012, '访问令牌已过期', '2019-05-31 10:52:25');
INSERT INTO `access_log` VALUES (15058, '9ca6f486-8366-43c3-bc55-d84ee7192dfe', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:52:25', 16, 1002001012, '访问令牌已过期', '2019-05-31 10:52:25');
INSERT INTO `access_log` VALUES (15059, 'b8db1983-51c0-4368-9ac6-1da024b61100', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:52:25', 917, 1002001012, '访问令牌已过期', '2019-05-31 10:52:26');
INSERT INTO `access_log` VALUES (15060, 'b949b26b-865d-46bf-b073-75f660b7cdda', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:52:39', 157, 0, '', '2019-05-31 10:52:39');
INSERT INTO `access_log` VALUES (15061, 'a2ecf7d3-d472-4870-bb4a-2ed32b65f59b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:52:39', 227, 0, '', '2019-05-31 10:52:40');
INSERT INTO `access_log` VALUES (15062, '72a6a557-f512-4c60-9cdc-ea98c938e4c2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:52:40', 34, 0, '', '2019-05-31 10:52:40');
INSERT INTO `access_log` VALUES (15063, '787d9797-29e5-4f28-9ace-7cad0f606203', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:52:40', 50, 0, '', '2019-05-31 10:52:40');
INSERT INTO `access_log` VALUES (15064, '2076be15-2b6a-4a6c-833a-6dbb01d42ac8', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:52:43', 132, 0, '', '2019-05-31 10:52:43');
INSERT INTO `access_log` VALUES (15065, '2045bbf0-7044-40b2-b1a9-84b1c6c4dfc5', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 10:52:43', 141, 0, '', '2019-05-31 10:52:43');
INSERT INTO `access_log` VALUES (15066, '65.52.15592713781031749', 0, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'displayName=男&enumValue=gender&sort=123&value=1&memo=你猜我猜不猜', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '183.237.4.219', '2019-05-31 10:56:18', 1, 1002001015, '账号未登陆', '2019-05-31 10:56:18');
INSERT INTO `access_log` VALUES (15067, '65.54.15592713792121745', 0, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'displayName=男&enumValue=gender&sort=123&value=1&memo=你猜我猜不猜', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '183.237.4.219', '2019-05-31 10:56:19', 0, 1002001015, '账号未登陆', '2019-05-31 10:56:19');
INSERT INTO `access_log` VALUES (15068, '65.49.15592713866521765', 0, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'displayName=男&enumValue=gender&sort=123&value=1&memo=1111', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '183.237.4.219', '2019-05-31 10:56:27', 1, 1002001015, '账号未登陆', '2019-05-31 10:56:27');
INSERT INTO `access_log` VALUES (15069, '65.46.15592713872041749', 0, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'displayName=男&enumValue=gender&sort=123&value=1&memo=1111', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '183.237.4.219', '2019-05-31 10:56:27', 0, 1002001015, '账号未登陆', '2019-05-31 10:56:27');
INSERT INTO `access_log` VALUES (15070, '65.50.15592713874921767', 0, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'displayName=男&enumValue=gender&sort=123&value=1&memo=1111', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '183.237.4.219', '2019-05-31 10:56:27', 1, 1002001015, '账号未登陆', '2019-05-31 10:56:27');
INSERT INTO `access_log` VALUES (15071, '65.48.15592714148351769', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '183.237.4.219', '2019-05-31 10:56:55', 5, 1002002001, '密码不正确', '2019-05-31 10:56:55');
INSERT INTO `access_log` VALUES (15072, 'a1f1c499-f92f-4694-9329-c0effb45e902', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1&cid=784', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:08:38', 98, 0, '', '2019-05-31 11:08:38');
INSERT INTO `access_log` VALUES (15073, '30a4f5c1-cb23-4cfe-ae3f-08576bdeb221', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:12:23', 45, 0, '', '2019-05-31 11:12:23');
INSERT INTO `access_log` VALUES (15074, '147d0a3e-01df-41f1-a47b-55996caf2752', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:12:23', 47, 0, '', '2019-05-31 11:12:23');
INSERT INTO `access_log` VALUES (15075, 'adbc3443-d7fc-4552-aa9b-9b02fe9fce35', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:12:23', 47, 0, '', '2019-05-31 11:12:23');
INSERT INTO `access_log` VALUES (15076, 'a9034e36-de9f-4c22-bbab-b2fb69f41d5d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:12:24', 40, 0, '', '2019-05-31 11:12:24');
INSERT INTO `access_log` VALUES (15077, 'd5571c8e-98a3-4029-8334-f5f0bed01e1f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:12:24', 47, 0, '', '2019-05-31 11:12:24');
INSERT INTO `access_log` VALUES (15078, '0d4cefb4-2fc9-498d-9fb4-4f74f8ec03ee', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:12:24', 49, 0, '', '2019-05-31 11:12:24');
INSERT INTO `access_log` VALUES (15079, 'dd7ce867-5126-4fd5-b8a0-133d78557a2a', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:12:24', 156, 0, '', '2019-05-31 11:12:24');
INSERT INTO `access_log` VALUES (15080, '2f88e2c4-2856-489f-b7a7-5f048f7cceaf', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:12:24', 167, 0, '', '2019-05-31 11:12:24');
INSERT INTO `access_log` VALUES (15081, '3773e067-7805-43db-8190-8ab0754a39b5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:27:08', 46, 0, '', '2019-05-31 11:27:08');
INSERT INTO `access_log` VALUES (15082, 'a2a485d9-bfbc-4a83-befd-98e1489960ad', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:27:08', 39, 0, '', '2019-05-31 11:27:08');
INSERT INTO `access_log` VALUES (15083, 'e690a177-082a-41ef-9628-b1dfebf7ce4e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:27:08', 59, 0, '', '2019-05-31 11:27:08');
INSERT INTO `access_log` VALUES (15084, '0ec9c774-d0c9-4ae0-af0a-80488fc5eba6', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:27:09', 377, 0, '', '2019-05-31 11:27:09');
INSERT INTO `access_log` VALUES (15085, '3a7f10f5-b68d-43b5-88cf-619b0f9463ca', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:27:08', 700, 0, '', '2019-05-31 11:27:09');
INSERT INTO `access_log` VALUES (15086, '8b7188a4-1269-448e-9ca0-1c964aef134e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:27:17', 35, 0, '', '2019-05-31 11:27:17');
INSERT INTO `access_log` VALUES (15087, 'c4f7c14c-8596-44d0-9ac1-9a7db77e4a07', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:27:17', 36, 0, '', '2019-05-31 11:27:17');
INSERT INTO `access_log` VALUES (15088, 'cd4ba01f-8376-4c5b-b3cd-1b03a5d926c6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:27:17', 33, 0, '', '2019-05-31 11:27:17');
INSERT INTO `access_log` VALUES (15089, '95f8f723-2742-4fe1-9598-a4c19f12d01a', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:27:17', 54, 0, '', '2019-05-31 11:27:17');
INSERT INTO `access_log` VALUES (15090, '7a8278e5-89e2-4376-bfa8-4236a930f900', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:27:18', 58, 0, '', '2019-05-31 11:27:18');
INSERT INTO `access_log` VALUES (15091, '65.51.15592731830411781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 11:26:23', 89, 0, '', '2019-05-31 11:26:23');
INSERT INTO `access_log` VALUES (15092, '65.48.15592731834231791', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 11:26:23', 15, 0, '', '2019-05-31 11:26:23');
INSERT INTO `access_log` VALUES (15093, '65.45.15592731834241797', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 11:26:23', 17, 0, '', '2019-05-31 11:26:23');
INSERT INTO `access_log` VALUES (15094, '65.49.15592731834391791', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 11:26:23', 16, 0, '', '2019-05-31 11:26:23');
INSERT INTO `access_log` VALUES (15095, '64.84.15592731859271761', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 11:26:26', 223, 0, '', '2019-05-31 11:26:26');
INSERT INTO `access_log` VALUES (15096, '64.79.15592731859251751', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 11:26:26', 228, 0, '', '2019-05-31 11:26:26');
INSERT INTO `access_log` VALUES (15097, '64.76.15592731892201757', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 11:26:29', 9, 0, '', '2019-05-31 11:26:29');
INSERT INTO `access_log` VALUES (15098, '64.82.15592731892201765', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 11:26:29', 13, 0, '', '2019-05-31 11:26:29');
INSERT INTO `access_log` VALUES (15099, '49e55150-7b9c-4ff2-b143-c67f21362356', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:31:16', 44, 0, '', '2019-05-31 11:31:16');
INSERT INTO `access_log` VALUES (15100, 'd405bbbe-b826-4724-8d8c-05adcd27471b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:31:16', 46, 0, '', '2019-05-31 11:31:16');
INSERT INTO `access_log` VALUES (15101, '9b6e7525-913b-480a-aef9-f33551c0dacf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:31:16', 45, 0, '', '2019-05-31 11:31:16');
INSERT INTO `access_log` VALUES (15102, '68e6fa3c-5dba-4cd2-8c93-ae0cd434ae64', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:31:16', 148, 0, '', '2019-05-31 11:31:17');
INSERT INTO `access_log` VALUES (15103, '51f3caf8-6015-4235-b129-211eb845e06a', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:31:17', 45, 0, '', '2019-05-31 11:31:17');
INSERT INTO `access_log` VALUES (15104, 'fe50621e-3fc9-4207-91d4-77965b049e47', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:02', 42, 0, '', '2019-05-31 11:32:02');
INSERT INTO `access_log` VALUES (15105, '39f66e90-4129-4805-82eb-01d14910a1ba', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:02', 40, 0, '', '2019-05-31 11:32:02');
INSERT INTO `access_log` VALUES (15106, '8ef042ed-da31-4f63-82b7-6f64373a68a9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:02', 52, 0, '', '2019-05-31 11:32:02');
INSERT INTO `access_log` VALUES (15107, '925bf886-479b-4520-9b8c-a62fa7299dea', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:03', 159, 0, '', '2019-05-31 11:32:03');
INSERT INTO `access_log` VALUES (15108, '8fb11935-22f0-42c7-9a41-4a705562ca52', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:03', 40, 0, '', '2019-05-31 11:32:03');
INSERT INTO `access_log` VALUES (15109, '3392e211-5221-434d-8652-086e6625a071', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:20', 692, 0, '', '2019-05-31 11:32:21');
INSERT INTO `access_log` VALUES (15110, '548486f9-13aa-4851-b1c4-6fd89d6ddd74', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:20', 1014, 0, '', '2019-05-31 11:32:21');
INSERT INTO `access_log` VALUES (15111, 'b86c9342-1a63-474e-97a6-9cfc725ee08d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:20', 1012, 0, '', '2019-05-31 11:32:21');
INSERT INTO `access_log` VALUES (15112, '7c302463-e3ba-41e7-8d4a-5052888da8d0', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:24', 65, 0, '', '2019-05-31 11:32:24');
INSERT INTO `access_log` VALUES (15113, 'd3fd6daf-53ff-48e4-bd80-7ef9106bbc57', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:24', 55, 0, '', '2019-05-31 11:32:24');
INSERT INTO `access_log` VALUES (15114, '99fcd447-476e-46f0-9e25-77736d2db676', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:44', 39, 0, '', '2019-05-31 11:32:45');
INSERT INTO `access_log` VALUES (15115, 'b78769b6-8f44-4eae-a392-96baacfa6a0f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:46', 43, 0, '', '2019-05-31 11:32:46');
INSERT INTO `access_log` VALUES (15116, 'e004a2ef-0b2b-4394-842e-f8f55d9f133e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:46', 43, 0, '', '2019-05-31 11:32:46');
INSERT INTO `access_log` VALUES (15117, '62284939-fd31-42e9-8ed0-bb2683b78925', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:49', 197, 0, '', '2019-05-31 11:32:49');
INSERT INTO `access_log` VALUES (15118, 'e025a147-af98-4f3f-aa92-0c3b36a55fe9', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:32:49', 198, 0, '', '2019-05-31 11:32:49');
INSERT INTO `access_log` VALUES (15119, 'd3cbad36-050e-4a83-a763-9fc4f8f04380', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:34:19', 47, 0, '', '2019-05-31 11:34:19');
INSERT INTO `access_log` VALUES (15120, '70ff0f6f-c441-4e70-9947-812ec26b254c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:34:19', 48, 0, '', '2019-05-31 11:34:19');
INSERT INTO `access_log` VALUES (15121, '40ed92a8-1616-4a77-b064-82cbe1203b0f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:34:19', 49, 0, '', '2019-05-31 11:34:19');
INSERT INTO `access_log` VALUES (15122, '58f612c4-5e37-49bf-8b3b-067340242355', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:34:20', 223, 0, '', '2019-05-31 11:34:20');
INSERT INTO `access_log` VALUES (15123, '86750bbb-4821-4dbf-8301-41b6434d1d73', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:34:20', 83, 0, '', '2019-05-31 11:34:21');
INSERT INTO `access_log` VALUES (15124, '65.47.15592741421111805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 11:42:22', 126, 0, '', '2019-05-31 11:42:22');
INSERT INTO `access_log` VALUES (15125, '65.50.15592741424311807', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 11:42:22', 10, 0, '', '2019-05-31 11:42:22');
INSERT INTO `access_log` VALUES (15126, '65.51.15592741424331795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 11:42:22', 9, 0, '', '2019-05-31 11:42:22');
INSERT INTO `access_log` VALUES (15127, '65.48.15592741424461805', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 11:42:22', 9, 0, '', '2019-05-31 11:42:22');
INSERT INTO `access_log` VALUES (15128, '62.83.15592741722722311', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 11:42:52', 36, 0, '', '2019-05-31 11:42:52');
INSERT INTO `access_log` VALUES (15129, '74753249-4dff-4746-8702-7790d1035f0c', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:52:11', 20, 1002001012, '访问令牌已过期', '2019-05-31 11:52:11');
INSERT INTO `access_log` VALUES (15130, '5e993649-01e6-46a8-81f8-a9128ed2430e', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:52:11', 18, 1002001012, '访问令牌已过期', '2019-05-31 11:52:11');
INSERT INTO `access_log` VALUES (15131, 'f56e2209-bad1-49fd-a73e-162917f29d9c', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:52:12', 12, 1002001012, '访问令牌已过期', '2019-05-31 11:52:12');
INSERT INTO `access_log` VALUES (15132, '3c61e038-433a-416f-8f7a-8588fda69d66', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:52:17', 12, 1002001012, '访问令牌已过期', '2019-05-31 11:52:17');
INSERT INTO `access_log` VALUES (15133, '35032ba8-1194-4721-a0aa-bb1a11c8a73a', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:52:17', 12, 1002001012, '访问令牌已过期', '2019-05-31 11:52:17');
INSERT INTO `access_log` VALUES (15134, '98d27ede-c740-435c-91cf-0be07212fa16', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:52:18', 10, 1002001012, '访问令牌已过期', '2019-05-31 11:52:18');
INSERT INTO `access_log` VALUES (15135, 'a81807f1-0db7-4969-9c04-82839fb7b386', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:52:27', 272, 0, '', '2019-05-31 11:52:27');
INSERT INTO `access_log` VALUES (15136, '29d184dd-05d0-4cbf-aac7-3e2d51455d32', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:52:27', 35, 0, '', '2019-05-31 11:52:27');
INSERT INTO `access_log` VALUES (15137, 'a99e19aa-a2fe-4aa7-9f49-ccbfc3c83436', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:52:27', 43, 0, '', '2019-05-31 11:52:27');
INSERT INTO `access_log` VALUES (15138, '7282accf-53f4-4fbd-8d22-22d122a44c84', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:52:27', 40, 0, '', '2019-05-31 11:52:27');
INSERT INTO `access_log` VALUES (15139, '9e7799f3-5739-42b0-b8b4-5cf8291ad0a5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:04', 44, 0, '', '2019-05-31 11:53:04');
INSERT INTO `access_log` VALUES (15140, '5998e201-b849-4b79-b6a8-3d36ad54ec32', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:04', 51, 0, '', '2019-05-31 11:53:04');
INSERT INTO `access_log` VALUES (15141, 'bd9dd1a2-326c-44ed-b6e0-24faf76c65d0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:05', 46, 0, '', '2019-05-31 11:53:05');
INSERT INTO `access_log` VALUES (15142, '5e1401cc-f4ff-4aa5-9123-a67802e8a091', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:09', 40, 0, '', '2019-05-31 11:53:09');
INSERT INTO `access_log` VALUES (15143, '0ed8014b-2c03-4d9b-9cee-4cdabc361432', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:09', 44, 0, '', '2019-05-31 11:53:09');
INSERT INTO `access_log` VALUES (15144, '69217c43-60fc-491d-b480-73f420c825b4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:09', 42, 0, '', '2019-05-31 11:53:09');
INSERT INTO `access_log` VALUES (15145, '97199608-817b-4ff5-a25a-d124243a107a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:42', 43, 0, '', '2019-05-31 11:53:42');
INSERT INTO `access_log` VALUES (15146, '3c7d43d6-3578-4e25-99a3-bf4c3f87ed20', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:42', 44, 0, '', '2019-05-31 11:53:42');
INSERT INTO `access_log` VALUES (15147, '3e7fedc9-f5f0-4050-bed9-61ab3e6c7ab2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:42', 44, 0, '', '2019-05-31 11:53:42');
INSERT INTO `access_log` VALUES (15148, '79453d5c-3d96-437b-97c9-cb4b3e8639ad', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:45', 42, 0, '', '2019-05-31 11:53:45');
INSERT INTO `access_log` VALUES (15149, '75d9ef20-d1d6-42c9-94f5-c6a5516a83b1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:45', 38, 0, '', '2019-05-31 11:53:45');
INSERT INTO `access_log` VALUES (15150, '43bdb3ce-c843-486d-86f6-5670e97e5b00', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:45', 38, 0, '', '2019-05-31 11:53:45');
INSERT INTO `access_log` VALUES (15151, 'f0634d95-7aa7-46f2-984e-ff96c6ba4867', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:52', 64, 0, '', '2019-05-31 11:53:52');
INSERT INTO `access_log` VALUES (15152, '7aa0cec6-0ff3-405d-963b-a32189ff1038', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:52', 76, 0, '', '2019-05-31 11:53:52');
INSERT INTO `access_log` VALUES (15153, '686e326e-3e59-4236-8c66-bfe806cb33cc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:53', 50, 0, '', '2019-05-31 11:53:53');
INSERT INTO `access_log` VALUES (15154, '3a398a4e-b544-4aa1-a412-7befc3357bce', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:56', 35, 0, '', '2019-05-31 11:53:56');
INSERT INTO `access_log` VALUES (15155, '99ca601f-50a3-4c6e-8122-6ca3d85141ac', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:56', 42, 0, '', '2019-05-31 11:53:56');
INSERT INTO `access_log` VALUES (15156, '258a877e-7711-4923-a0f3-736a2ee9a109', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:53:56', 36, 0, '', '2019-05-31 11:53:56');
INSERT INTO `access_log` VALUES (15157, '116c4f66-44d3-4bac-ad4d-95dd231ba706', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:54:18', 41, 0, '', '2019-05-31 11:54:18');
INSERT INTO `access_log` VALUES (15158, 'f0d56e05-6ab9-4e9c-9823-485def5c336e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:54:18', 44, 0, '', '2019-05-31 11:54:18');
INSERT INTO `access_log` VALUES (15159, '94fd66d1-59b7-4b61-889b-b52699256e10', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:54:19', 47, 0, '', '2019-05-31 11:54:19');
INSERT INTO `access_log` VALUES (15160, 'eba7be0e-0a29-4eaf-99fc-4aa74bfef572', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:54:19', 192, 0, '', '2019-05-31 11:54:19');
INSERT INTO `access_log` VALUES (15161, 'e08d279a-8992-48bc-845e-f66953456672', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:54:19', 204, 0, '', '2019-05-31 11:54:19');
INSERT INTO `access_log` VALUES (15162, 'ba4798f1-2e8b-4efd-b182-4a53aa94c9a7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:54:23', 38, 0, '', '2019-05-31 11:54:23');
INSERT INTO `access_log` VALUES (15163, 'f9b4a028-ee3c-4f5b-b150-a7d1b1bbffeb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:54:23', 33, 0, '', '2019-05-31 11:54:23');
INSERT INTO `access_log` VALUES (15164, 'cfd2f287-e633-4efd-86dd-4a76234fb0b8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:54:23', 33, 0, '', '2019-05-31 11:54:23');
INSERT INTO `access_log` VALUES (15165, '35e78572-6725-443d-b9f4-e1677a7914b0', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:54:24', 60, 0, '', '2019-05-31 11:54:24');
INSERT INTO `access_log` VALUES (15166, '4fe1081e-ecc8-4971-b375-318560319f47', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:54:24', 54, 0, '', '2019-05-31 11:54:24');
INSERT INTO `access_log` VALUES (15167, '03feb70f-e4ca-48b1-9aef-f18553797eb0', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:55:40', 85, 0, '', '2019-05-31 11:55:40');
INSERT INTO `access_log` VALUES (15168, 'c8c269dc-4bf8-40be-99f3-450fad9207be', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:56:37', 88, 0, '', '2019-05-31 11:56:37');
INSERT INTO `access_log` VALUES (15169, '45350d1b-e8a3-46a0-8259-7e43de01bc4f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:56:37', 96, 0, '', '2019-05-31 11:56:37');
INSERT INTO `access_log` VALUES (15170, 'ec667bc7-053a-4390-9e24-b4e6a8533ed4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:56:37', 102, 0, '', '2019-05-31 11:56:37');
INSERT INTO `access_log` VALUES (15171, 'ca4f5f7f-84f9-4997-9126-e30be98f480f', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:56:37', 101, 0, '', '2019-05-31 11:56:37');
INSERT INTO `access_log` VALUES (15172, '35186d01-eeb5-43f9-9333-40db8b0d5520', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:56:38', 43, 0, '', '2019-05-31 11:56:38');
INSERT INTO `access_log` VALUES (15173, '18108069-68e4-4b8b-9904-7a9364a51f31', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:58:54', 53, 0, '', '2019-05-31 11:58:54');
INSERT INTO `access_log` VALUES (15174, '96baedb3-1d77-44c3-bb5c-1226771b13c3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:58:56', 60, 0, '', '2019-05-31 11:58:56');
INSERT INTO `access_log` VALUES (15175, 'c1178a39-dc55-49aa-b0c3-4d0a3723b30c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:58:56', 66, 0, '', '2019-05-31 11:58:56');
INSERT INTO `access_log` VALUES (15176, 'dd124e3b-f868-49be-a0a0-a813cf97c0ec', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:58:56', 192, 0, '', '2019-05-31 11:58:56');
INSERT INTO `access_log` VALUES (15177, '7c8d6f1c-dd7b-4f84-b068-42d06109355b', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:58:56', 224, 0, '', '2019-05-31 11:58:56');
INSERT INTO `access_log` VALUES (15178, '9ae37460-7a7a-475c-8ec0-031044c8b4c0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:59:01', 43, 0, '', '2019-05-31 11:59:01');
INSERT INTO `access_log` VALUES (15179, '0d0bfc7b-d063-410e-a49a-bec6500b2846', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:59:01', 41, 0, '', '2019-05-31 11:59:01');
INSERT INTO `access_log` VALUES (15180, '09b2b708-80da-4165-b398-d2376f7c41d3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:59:01', 57, 0, '', '2019-05-31 11:59:01');
INSERT INTO `access_log` VALUES (15181, '338282f2-fd4a-4b28-88c8-f2ee8e0c2df5', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:59:01', 56, 0, '', '2019-05-31 11:59:01');
INSERT INTO `access_log` VALUES (15182, '657bd945-e98e-4574-a313-510a8a24ebc5', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:59:01', 72, 0, '', '2019-05-31 11:59:01');
INSERT INTO `access_log` VALUES (15183, '2493ef09-7da2-4258-a656-771ab8bcddde', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:59:49', 45, 0, '', '2019-05-31 11:59:49');
INSERT INTO `access_log` VALUES (15184, '0a345e58-63e1-486f-8596-ed55ab3e9fa8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:59:49', 48, 0, '', '2019-05-31 11:59:49');
INSERT INTO `access_log` VALUES (15185, 'dc22254a-5ba1-463a-bac7-6e0ccd840c28', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:59:49', 45, 0, '', '2019-05-31 11:59:49');
INSERT INTO `access_log` VALUES (15186, '43588acd-3850-45cf-a4fb-e3637568838c', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:59:50', 57, 0, '', '2019-05-31 11:59:50');
INSERT INTO `access_log` VALUES (15187, 'dad0a30d-4c74-4c96-9352-81a28ec98e43', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 11:59:50', 75, 0, '', '2019-05-31 11:59:50');
INSERT INTO `access_log` VALUES (15188, 'ab720ce4-ed29-4098-b4fd-993e23028516', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 12:01:29', 145, 0, '', '2019-05-31 12:01:29');
INSERT INTO `access_log` VALUES (15189, '36009ab8-4c3a-44e8-b639-ba873c74ea63', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 12:01:29', 133, 0, '', '2019-05-31 12:01:29');
INSERT INTO `access_log` VALUES (15190, '381e2193-dba0-40fc-905d-57ade1b7f81e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 12:01:29', 146, 0, '', '2019-05-31 12:01:29');
INSERT INTO `access_log` VALUES (15191, 'fc7cfe8b-fae8-47f9-8886-639a72b203d3', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 12:01:30', 687, 0, '', '2019-05-31 12:01:31');
INSERT INTO `access_log` VALUES (15192, '8ae683cb-9993-4e42-8261-23d64c7c3ef3', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 12:01:30', 1344, 0, '', '2019-05-31 12:01:32');
INSERT INTO `access_log` VALUES (15193, '611501e6-9c3c-4fd7-9753-caaf9a2b4739', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:31:48', 244, 1002001012, '访问令牌已过期', '2019-05-31 13:31:48');
INSERT INTO `access_log` VALUES (15194, '7e39ace6-5cb5-4d36-85e3-9cb53b88214e', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:31:48', 247, 1002001012, '访问令牌已过期', '2019-05-31 13:31:48');
INSERT INTO `access_log` VALUES (15195, '2f8b3ef3-6bb8-470b-b4dd-40307760acb6', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:31:48', 237, 1002001012, '访问令牌已过期', '2019-05-31 13:31:48');
INSERT INTO `access_log` VALUES (15196, 'cec59d47-ab96-4f38-b3f7-93b5f5768488', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:31:49', 156, 1002001012, '访问令牌已过期', '2019-05-31 13:31:49');
INSERT INTO `access_log` VALUES (15197, 'd5599bc3-3027-41bb-b54d-b31db3a2761d', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:31:49', 146, 1002001012, '访问令牌已过期', '2019-05-31 13:31:49');
INSERT INTO `access_log` VALUES (15198, '54de67ea-6627-4aae-a223-0610667a4053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:32:01', 106, 0, '', '2019-05-31 13:32:01');
INSERT INTO `access_log` VALUES (15199, '83c91a14-a720-43de-8825-6ea186621b3c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:32:01', 42, 0, '', '2019-05-31 13:32:01');
INSERT INTO `access_log` VALUES (15200, 'bbec1d88-bf33-4561-884b-29fcee9fbad1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:32:01', 37, 0, '', '2019-05-31 13:32:01');
INSERT INTO `access_log` VALUES (15201, '728e6c89-c2f4-417b-9010-c3e6714d5fd9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:32:01', 37, 0, '', '2019-05-31 13:32:01');
INSERT INTO `access_log` VALUES (15202, '5130a2b7-b6a9-48f9-b644-e38c0a0b0047', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:32:07', 237, 0, '', '2019-05-31 13:32:07');
INSERT INTO `access_log` VALUES (15203, '0347f6e2-6645-4251-9378-2ba87ef45ed1', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:32:07', 254, 0, '', '2019-05-31 13:32:07');
INSERT INTO `access_log` VALUES (15204, '60f23832-254e-4201-ae5a-cae2cddd3465', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:32:21', 573, 0, '', '2019-05-31 13:32:22');
INSERT INTO `access_log` VALUES (15205, '6af15b14-8838-4d2b-8057-b7509cec0fd1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:32:21', 570, 0, '', '2019-05-31 13:32:22');
INSERT INTO `access_log` VALUES (15206, '0f14c18b-bc03-4ef7-941a-6c157f5833c5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:32:21', 581, 0, '', '2019-05-31 13:32:22');
INSERT INTO `access_log` VALUES (15207, '58260fd9-068f-4820-a359-56f9c78dc7fe', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:32:22', 47, 0, '', '2019-05-31 13:32:22');
INSERT INTO `access_log` VALUES (15208, '0e925829-a36e-461b-ad73-90f2cf511008', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:32:21', 358, 0, '', '2019-05-31 13:32:22');
INSERT INTO `access_log` VALUES (15209, '0af306e0-d85f-4210-9d0b-d0e8cdc82adb', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:36:27', 27826, 0, '', '2019-05-31 13:36:55');
INSERT INTO `access_log` VALUES (15210, 'c6035919-c846-436f-a84a-6fa461163ca4', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:37:02', 4028, 0, '', '2019-05-31 13:37:06');
INSERT INTO `access_log` VALUES (15211, '614671bd-b95f-48b6-ab0f-d98cbb930c44', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:38:20', 118621, 0, '', '2019-05-31 13:40:19');
INSERT INTO `access_log` VALUES (15212, '6ce80b25-180a-44fc-8896-ec31fd24d966', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:40:24', 215136, 0, '', '2019-05-31 13:43:59');
INSERT INTO `access_log` VALUES (15213, '9a24ade7-0ca3-4ce2-b830-8f7a31091ade', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:44:08', 85275, 0, '', '2019-05-31 13:45:33');
INSERT INTO `access_log` VALUES (15214, '65.49.15592814761771903', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:44:36', 572, 1002001012, '访问令牌已过期', '2019-05-31 13:44:37');
INSERT INTO `access_log` VALUES (15215, '65.45.15592814761711909', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:44:36', 578, 1002001012, '访问令牌已过期', '2019-05-31 13:44:37');
INSERT INTO `access_log` VALUES (15216, '65.48.15592814761711903', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:44:36', 578, 1002001012, '访问令牌已过期', '2019-05-31 13:44:37');
INSERT INTO `access_log` VALUES (15217, '65.53.15592814799561883', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:44:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 13:44:40');
INSERT INTO `access_log` VALUES (15218, '65.54.15592814992461883', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma1&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:44:59', 167, 0, '', '2019-05-31 13:44:59');
INSERT INTO `access_log` VALUES (15219, '65.47.15592814995941905', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:00', 11, 0, '', '2019-05-31 13:45:00');
INSERT INTO `access_log` VALUES (15220, '65.50.15592814995941907', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:00', 11, 0, '', '2019-05-31 13:45:00');
INSERT INTO `access_log` VALUES (15221, '65.51.15592814996141895', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:00', 10, 0, '', '2019-05-31 13:45:00');
INSERT INTO `access_log` VALUES (15222, '65.49.15592815153581905', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=qwe2qeqw&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:15', 82, 0, '', '2019-05-31 13:45:15');
INSERT INTO `access_log` VALUES (15223, '65.45.15592815155971911', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:16', 8, 0, '', '2019-05-31 13:45:16');
INSERT INTO `access_log` VALUES (15224, '65.46.15592815156081889', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:16', 8, 0, '', '2019-05-31 13:45:16');
INSERT INTO `access_log` VALUES (15225, '65.53.15592815156121885', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:16', 9, 0, '', '2019-05-31 13:45:16');
INSERT INTO `access_log` VALUES (15226, '62.83.15592815189462409', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:19', 41, 0, '', '2019-05-31 13:45:19');
INSERT INTO `access_log` VALUES (15227, '62.86.15592815340942399', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:34', 16, 0, '', '2019-05-31 13:45:34');
INSERT INTO `access_log` VALUES (15228, '62.82.15592815351132407', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:35', 15, 0, '', '2019-05-31 13:45:35');
INSERT INTO `access_log` VALUES (15229, '62.84.15592815355472403', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:36', 16, 0, '', '2019-05-31 13:45:36');
INSERT INTO `access_log` VALUES (15230, '62.80.15592815363202405', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:36', 16, 0, '', '2019-05-31 13:45:36');
INSERT INTO `access_log` VALUES (15231, '62.88.15592815366682411', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:37', 16, 0, '', '2019-05-31 13:45:37');
INSERT INTO `access_log` VALUES (15232, '62.85.15592815374992411', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:37', 15, 0, '', '2019-05-31 13:45:38');
INSERT INTO `access_log` VALUES (15233, '62.87.15592815378152413', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:38', 59, 0, '', '2019-05-31 13:45:38');
INSERT INTO `access_log` VALUES (15234, '64.76.15592815400551869', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:40', 90, 0, '', '2019-05-31 13:45:40');
INSERT INTO `access_log` VALUES (15235, '64.79.15592815400541863', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:40', 94, 0, '', '2019-05-31 13:45:40');
INSERT INTO `access_log` VALUES (15236, '62.83.15592815433762411', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:43', 18, 0, '', '2019-05-31 13:45:43');
INSERT INTO `access_log` VALUES (15237, '62.86.15592815571162401', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 13:45:41&createEndTime=2019-05-03 13:45:41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:45:57', 14, 0, '', '2019-05-31 13:45:57');
INSERT INTO `access_log` VALUES (15238, '62.82.15592815627332409', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 13:45:41&createEndTime=2019-05-03 13:45:41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:46:03', 16, 0, '', '2019-05-31 13:46:03');
INSERT INTO `access_log` VALUES (15239, '62.81.15592815705382399', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 13:45:41&createEndTime=2019-05-03 13:45:41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:46:11', 13, 0, '', '2019-05-31 13:46:11');
INSERT INTO `access_log` VALUES (15240, '62.88.15592815813692413', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-31 13:45:41&createEndTime=2019-06-01 13:45:41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:46:21', 13, 0, '', '2019-05-31 13:46:21');
INSERT INTO `access_log` VALUES (15241, '6afc5555-38a5-4b58-a66d-491f85588396', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:45:52', 114480, 0, '', '2019-05-31 13:47:47');
INSERT INTO `access_log` VALUES (15242, '62.85.15592815922592413', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2016-05-05 13:45:41&createEndTime=2019-05-31 13:45:41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:46:32', 14, 0, '', '2019-05-31 13:46:32');
INSERT INTO `access_log` VALUES (15243, '64.77.15592816013211873', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:46:41', 13, 0, '', '2019-05-31 13:46:41');
INSERT INTO `access_log` VALUES (15244, '64.83.15592816013211867', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:46:41', 14, 0, '', '2019-05-31 13:46:41');
INSERT INTO `access_log` VALUES (15245, '60b8ed33-8055-4e2a-ad6a-3bdbbf3e05c5', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:47:58', 7806, 0, '', '2019-05-31 13:48:06');
INSERT INTO `access_log` VALUES (15246, '66.51.15592816060841447', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:46:46', 322, 0, '', '2019-05-31 13:46:46');
INSERT INTO `access_log` VALUES (15247, '66.54.15592816165771443', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:46:57', 15, 0, '', '2019-05-31 13:46:57');
INSERT INTO `access_log` VALUES (15248, '59.76.15592816184652497', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:46:58', 32, 0, '', '2019-05-31 13:46:59');
INSERT INTO `access_log` VALUES (15249, 'e1ee008c-9275-4376-bdec-f4e062fab57d', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:48:10', 8546, 0, '', '2019-05-31 13:48:19');
INSERT INTO `access_log` VALUES (15250, '64.84.15592816203471875', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:47:00', 10, 0, '', '2019-05-31 13:47:00');
INSERT INTO `access_log` VALUES (15251, '59.75.15592816267312501', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/update_card', 'id=1&title=优惠劵A&description=一个有味道的哈哈哈哈&quota=10&total=1000&rangeType=10', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:47:07', 52, 1002002009, NULL, '2019-05-31 13:47:07');
INSERT INTO `access_log` VALUES (15252, '64.76.15592816374401871', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=4', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:47:17', 15, 0, '', '2019-05-31 13:47:17');
INSERT INTO `access_log` VALUES (15253, '64.82.15592816376461879', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:47:18', 9, 0, '', '2019-05-31 13:47:18');
INSERT INTO `access_log` VALUES (15254, '64.85.15592816379211877', 27, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=414', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:47:18', 10, 0, '', '2019-05-31 13:47:18');
INSERT INTO `access_log` VALUES (15255, '59.71.15592816441252503', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/update_card', 'id=1&title=优惠劵A&description=一个有味道的哈哈哈哈&quota=10&total=1000&rangeType=10', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:47:24', 10, 1002002009, NULL, '2019-05-31 13:47:24');
INSERT INTO `access_log` VALUES (15256, '64.80.15592816469871867', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:47:27', 10, 0, '', '2019-05-31 13:47:27');
INSERT INTO `access_log` VALUES (15257, '1cd64aff-0581-4d8d-aa29-f40ff5feffeb', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:48:44', 4005, 0, '', '2019-05-31 13:48:48');
INSERT INTO `access_log` VALUES (15258, '59.78.15592816501112507', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:47:30', 11, 1002002009, NULL, '2019-05-31 13:47:30');
INSERT INTO `access_log` VALUES (15259, '65.46.15592816545971891', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:47:35', 20, 0, '', '2019-05-31 13:47:35');
INSERT INTO `access_log` VALUES (15260, '65.54.15592816608491887', 27, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:47:41', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-31 13:47:41');
INSERT INTO `access_log` VALUES (15261, '65.51.15592816680771899', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:47:48', 11, 0, '', '2019-05-31 13:47:48');
INSERT INTO `access_log` VALUES (15262, '65.47.15592816703981909', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:47:50', 11, 0, '', '2019-05-31 13:47:50');
INSERT INTO `access_log` VALUES (15263, '65.50.15592816733071911', 27, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=1&resourceIds=14,15,16,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,41,42,43,44,45,46,47,51,52,53', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:47:53', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-31 13:47:53');
INSERT INTO `access_log` VALUES (15264, '62.80.15592816805772409', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'createBeginTime=2016-05-05 13:45:41&createEndTime=2019-05-31 13:45:41&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.209.189', '2019-05-31 13:48:01', 12, 0, '', '2019-05-31 13:48:01');
INSERT INTO `access_log` VALUES (15265, '43d850d7-8f4e-49c7-b0bc-7750fefe3a94', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:51:09', 19898, 0, '', '2019-05-31 13:51:29');
INSERT INTO `access_log` VALUES (15266, '73df5251-9347-4d36-bcf0-f12410525531', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 13:53:51', 11441, 0, '', '2019-05-31 13:54:02');
INSERT INTO `access_log` VALUES (15267, '9c1ae5b7-65a1-4438-9460-1346d6ac85a2', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:09:17', 11942, 0, '', '2019-05-31 14:09:29');
INSERT INTO `access_log` VALUES (15268, '14182c00-e341-46f5-8dce-bf99a5f6df27', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:09:33', 63609, 0, '', '2019-05-31 14:10:36');
INSERT INTO `access_log` VALUES (15269, '9a353125-7697-4bb8-ae39-1d2d8266d8fd', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:11:09', 404, 0, '', '2019-05-31 14:11:09');
INSERT INTO `access_log` VALUES (15270, '6d2bc695-2a63-4a00-aa40-65bc744e8860', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:11:09', 279, 0, '', '2019-05-31 14:11:09');
INSERT INTO `access_log` VALUES (15271, 'e57eebf6-3b1b-4025-b1ad-9ea99d9dea2b', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:11:13', 2281, 0, '', '2019-05-31 14:11:15');
INSERT INTO `access_log` VALUES (15272, '65.46.15592830696941913', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:11:10', 3, 1002001012, '访问令牌已过期', '2019-05-31 14:11:10');
INSERT INTO `access_log` VALUES (15273, '65.45.15592830696931935', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:11:10', 4, 1002001012, '访问令牌已过期', '2019-05-31 14:11:10');
INSERT INTO `access_log` VALUES (15274, '65.53.15592830696931907', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:11:10', 3, 1002001012, '访问令牌已过期', '2019-05-31 14:11:10');
INSERT INTO `access_log` VALUES (15275, '65.52.15592830735381913', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:11:14', 88, 0, '', '2019-05-31 14:11:14');
INSERT INTO `access_log` VALUES (15276, '65.54.15592830738031907', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:11:14', 9, 0, '', '2019-05-31 14:11:14');
INSERT INTO `access_log` VALUES (15277, '65.51.15592830738041919', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:11:14', 9, 0, '', '2019-05-31 14:11:14');
INSERT INTO `access_log` VALUES (15278, '65.47.15592830738071931', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:11:14', 8, 0, '', '2019-05-31 14:11:14');
INSERT INTO `access_log` VALUES (15279, '64.82.15592830788531899', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:11:19', 12, 0, '', '2019-05-31 14:11:19');
INSERT INTO `access_log` VALUES (15280, '64.76.15592830788531891', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:11:19', 14, 0, '', '2019-05-31 14:11:19');
INSERT INTO `access_log` VALUES (15281, '64.80.15592831054401887', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=6&name=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:11:45', 9, 1002002009, NULL, '2019-05-31 14:11:45');
INSERT INTO `access_log` VALUES (15282, '64.77.15592831087011895', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=6&name=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:11:49', 6, 1002002009, NULL, '2019-05-31 14:11:49');
INSERT INTO `access_log` VALUES (15283, 'd5951300-092f-4c4f-85d1-b83dbb7f0fb7', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:14:59', 1244, 0, '', '2019-05-31 14:15:00');
INSERT INTO `access_log` VALUES (15284, 'fd9bdc4b-ba46-46de-ba88-974ada9cce55', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:14:59', 1268, 0, '', '2019-05-31 14:15:00');
INSERT INTO `access_log` VALUES (15285, '2e89fe43-b56c-4fb5-9e31-d041ea90be24', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:15:01', 6070, 0, '', '2019-05-31 14:15:07');
INSERT INTO `access_log` VALUES (15286, 'c8478588-4a1e-4d18-a1f3-7f785752df41', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:17:33', 649, 0, '', '2019-05-31 14:17:34');
INSERT INTO `access_log` VALUES (15287, 'b174f4e8-b79b-4850-96af-e748955d01fa', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:17:33', 646, 0, '', '2019-05-31 14:17:34');
INSERT INTO `access_log` VALUES (15288, 'c3649405-4f4f-424b-b7e6-1212de86403d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:17:33', 686, 0, '', '2019-05-31 14:17:34');
INSERT INTO `access_log` VALUES (15289, 'd6d80b81-4971-4ec4-94b1-3bc985777054', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:17:33', 1134, 0, '', '2019-05-31 14:17:34');
INSERT INTO `access_log` VALUES (15290, '90cfd273-7869-47fd-83b2-889f12ac9f0a', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:17:33', 1152, 0, '', '2019-05-31 14:17:34');
INSERT INTO `access_log` VALUES (15291, '52d02289-bb0a-446e-92f6-84a9fd5327c9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:17:42', 35, 0, '', '2019-05-31 14:17:42');
INSERT INTO `access_log` VALUES (15292, 'b841523f-4ef0-4d96-8c38-9973dbb3b3ce', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:17:42', 41, 0, '', '2019-05-31 14:17:42');
INSERT INTO `access_log` VALUES (15293, 'a102b8ba-c0f6-4b78-a70f-8599c080cadb', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:17:43', 70, 0, '', '2019-05-31 14:17:43');
INSERT INTO `access_log` VALUES (15294, 'ba5e6c85-5a7f-473e-8d32-31a9a084ec01', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:17:43', 554, 0, '', '2019-05-31 14:17:43');
INSERT INTO `access_log` VALUES (15295, 'bbf162ff-9f69-4e1d-b0bd-e11c55b2a153', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:17:43', 569, 0, '', '2019-05-31 14:17:43');
INSERT INTO `access_log` VALUES (15296, '64.82.15592834616061905', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:17:42', 11, 0, '', '2019-05-31 14:17:42');
INSERT INTO `access_log` VALUES (15297, '64.78.15592834748611903', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:17:55', 10, 0, '', '2019-05-31 14:17:55');
INSERT INTO `access_log` VALUES (15298, '64.85.15592834748591903', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:17:55', 17, 0, '', '2019-05-31 14:17:55');
INSERT INTO `access_log` VALUES (15299, 'e8648d82-15d4-4046-b91f-e1029d2b482a', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:19:19', 7367, 0, '', '2019-05-31 14:19:26');
INSERT INTO `access_log` VALUES (15300, '64.77.15592834876401901', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:18:08', 10, 0, '', '2019-05-31 14:18:08');
INSERT INTO `access_log` VALUES (15301, '64.81.15592834902201893', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:18:10', 8, 0, '', '2019-05-31 14:18:10');
INSERT INTO `access_log` VALUES (15302, '64.83.15592834902181895', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:18:10', 11, 0, '', '2019-05-31 14:18:10');
INSERT INTO `access_log` VALUES (15303, '64.80.15592835878611895', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:19:48', 12, 0, '', '2019-05-31 14:19:48');
INSERT INTO `access_log` VALUES (15304, '64.81.15592835928951895', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:19:53', 12, 0, '', '2019-05-31 14:19:53');
INSERT INTO `access_log` VALUES (15305, '64.83.15592835939121897', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.177.121.186', '2019-05-31 14:19:54', 10, 0, '', '2019-05-31 14:19:54');
INSERT INTO `access_log` VALUES (15306, '3a081617-baa4-4505-a62e-dffaf59e510c', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:23:32', 19, 1002001012, '访问令牌已过期', '2019-05-31 14:23:32');
INSERT INTO `access_log` VALUES (15307, 'b96dd406-6b0d-4768-a49c-d80f0a64db42', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:23:32', 13, 1002001012, '访问令牌已过期', '2019-05-31 14:23:32');
INSERT INTO `access_log` VALUES (15308, '9f998cc0-c111-4a03-ab09-2c4415221a33', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:23:32', 26, 1002001012, '访问令牌已过期', '2019-05-31 14:23:32');
INSERT INTO `access_log` VALUES (15309, '09625030-02f6-4e7b-a5aa-b1befe4b5954', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:23:33', 310, 1002001012, '访问令牌已过期', '2019-05-31 14:23:33');
INSERT INTO `access_log` VALUES (15310, '6e939424-ecca-45b5-b084-15246b6b2895', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:23:33', 310, 1002001012, '访问令牌已过期', '2019-05-31 14:23:34');
INSERT INTO `access_log` VALUES (15311, '9e4ae855-bb5c-42fe-a176-6b78eba677af', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:23:37', 114, 0, '', '2019-05-31 14:23:37');
INSERT INTO `access_log` VALUES (15312, '599edbfd-5ccd-4e2c-a1f5-61514a6914d7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:23:37', 36, 0, '', '2019-05-31 14:23:37');
INSERT INTO `access_log` VALUES (15313, '74c624bb-6393-416b-bbe5-fbf1b6eda44d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:23:37', 44, 0, '', '2019-05-31 14:23:37');
INSERT INTO `access_log` VALUES (15314, 'b3f00338-3af5-45f4-9bb1-d529df17ee55', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:23:37', 43, 0, '', '2019-05-31 14:23:37');
INSERT INTO `access_log` VALUES (15315, '2deca62b-251a-4635-b3b6-d920ee44db2d', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:23:42', 103, 0, '', '2019-05-31 14:23:42');
INSERT INTO `access_log` VALUES (15316, '8b9a605b-5fb4-4845-a787-534423cb847d', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:23:42', 132, 0, '', '2019-05-31 14:23:42');
INSERT INTO `access_log` VALUES (15317, '478545aa-8e60-4c74-be6c-8a955638d0b7', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:23:55', 1058, 0, '', '2019-05-31 14:23:56');
INSERT INTO `access_log` VALUES (15318, '478545aa-8e60-4c74-be6c-8a955638d0b7', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:23:55', 1058, 0, '', '2019-05-31 14:23:57');
INSERT INTO `access_log` VALUES (15319, '478545aa-8e60-4c74-be6c-8a955638d0b7', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:23:55', 1058, 0, '', '2019-05-31 14:23:58');
INSERT INTO `access_log` VALUES (15320, '1e4235af-5863-4555-815c-3c060c4719d8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:24:59', 42, 0, '', '2019-05-31 14:24:59');
INSERT INTO `access_log` VALUES (15321, '31e00000-63b6-4757-aa5a-5ab3636626ba', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:24:59', 52, 0, '', '2019-05-31 14:24:59');
INSERT INTO `access_log` VALUES (15322, '0e80900c-62ae-438d-ad03-89c3df6d2ac0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:01', 42, 0, '', '2019-05-31 14:25:01');
INSERT INTO `access_log` VALUES (15323, '3aab04af-5cec-4e8f-8613-726a37669c18', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:01', 66, 0, '', '2019-05-31 14:25:01');
INSERT INTO `access_log` VALUES (15324, '323e09c9-7335-4412-971c-c0f00f4c6fed', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:01', 80, 0, '', '2019-05-31 14:25:01');
INSERT INTO `access_log` VALUES (15325, '4db15909-bbe1-41b5-9ecc-e3e3a09d1018', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:04', 38, 0, '', '2019-05-31 14:25:04');
INSERT INTO `access_log` VALUES (15326, '5c66bb3d-6b91-4d38-a9ea-150b5a74ac7e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:04', 42, 0, '', '2019-05-31 14:25:04');
INSERT INTO `access_log` VALUES (15327, 'd684e22c-0049-47a2-a0b9-3e274c972170', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:04', 41, 0, '', '2019-05-31 14:25:04');
INSERT INTO `access_log` VALUES (15328, '18173048-f68f-4ef6-b4e2-5bdb066924ec', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:05', 56, 0, '', '2019-05-31 14:25:05');
INSERT INTO `access_log` VALUES (15329, '3c5c38c5-9f27-43ce-8f2f-dc90836e68ca', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:05', 66, 0, '', '2019-05-31 14:25:05');
INSERT INTO `access_log` VALUES (15330, '09f74572-d4f4-4d9a-8898-5d1306b791d8', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:09', 54, 0, '', '2019-05-31 14:25:09');
INSERT INTO `access_log` VALUES (15331, '6ff5e449-9dc4-40e4-9948-34058732d532', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:45', 40, 0, '', '2019-05-31 14:25:45');
INSERT INTO `access_log` VALUES (15332, '31223af6-5c71-439f-b382-02547d0fbe93', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:45', 43, 0, '', '2019-05-31 14:25:45');
INSERT INTO `access_log` VALUES (15333, 'c8f5c047-e27a-494e-ac1c-5a91d8436ca7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:45', 50, 0, '', '2019-05-31 14:25:45');
INSERT INTO `access_log` VALUES (15334, '14f7f8e5-ed6c-47e6-b8d8-e5ea9fed81d8', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:49', 65, 0, '', '2019-05-31 14:25:49');
INSERT INTO `access_log` VALUES (15335, 'e7ca58e4-41a6-4f5c-a6d3-ab8b85645503', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:49', 78, 0, '', '2019-05-31 14:25:49');
INSERT INTO `access_log` VALUES (15336, 'd7502c36-13d7-4f95-ad23-5f30fa79b6a1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:57', 44, 0, '', '2019-05-31 14:25:57');
INSERT INTO `access_log` VALUES (15337, '14f304ea-ba06-4d5a-8ef9-9d465cf90a9e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:57', 49, 0, '', '2019-05-31 14:25:57');
INSERT INTO `access_log` VALUES (15338, '396c2cf6-be66-479a-9d9e-1a1c57865c6b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:25:57', 46, 0, '', '2019-05-31 14:25:57');
INSERT INTO `access_log` VALUES (15339, 'e96274f5-3fc7-4ebe-90ea-7fa3e2021f92', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:26:01', 47, 0, '', '2019-05-31 14:26:01');
INSERT INTO `access_log` VALUES (15340, 'd3180e4d-4ff3-4338-8788-d6f58a523503', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:26:01', 97, 0, '', '2019-05-31 14:26:01');
INSERT INTO `access_log` VALUES (15341, '394c57a2-d14d-417c-b031-f9d4ed8ae37f', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:26:06', 177, 0, '', '2019-05-31 14:26:06');
INSERT INTO `access_log` VALUES (15342, '65.49.15592839997641943', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-31 14:26:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 14:26:40');
INSERT INTO `access_log` VALUES (15343, '65.46.15592840102101927', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-31 14:26:50', 219, 0, '', '2019-05-31 14:26:50');
INSERT INTO `access_log` VALUES (15344, '65.45.15592840109341949', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-31 14:26:51', 9, 0, '', '2019-05-31 14:26:51');
INSERT INTO `access_log` VALUES (15345, '65.53.15592840109391921', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-31 14:26:51', 9, 0, '', '2019-05-31 14:26:51');
INSERT INTO `access_log` VALUES (15346, '65.52.15592840109391927', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-31 14:26:51', 11, 0, '', '2019-05-31 14:26:51');
INSERT INTO `access_log` VALUES (15347, '62.81.15592840144372433', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-31 14:26:54', 166, 0, '', '2019-05-31 14:26:55');
INSERT INTO `access_log` VALUES (15348, '64.83.15592840168651903', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-31 14:26:57', 9, 0, '', '2019-05-31 14:26:57');
INSERT INTO `access_log` VALUES (15349, '64.81.15592840168641901', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-31 14:26:57', 12, 0, '', '2019-05-31 14:26:57');
INSERT INTO `access_log` VALUES (15350, '59.78.15592840293352539', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-31 14:27:09', 25, 0, '', '2019-05-31 14:27:09');
INSERT INTO `access_log` VALUES (15351, '59.80.15592840319592533', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.80.192.93', '2019-05-31 14:27:12', 60, 2001001000, '服务端发生异常', '2019-05-31 14:27:12');
INSERT INTO `access_log` VALUES (15352, '36592072-5f07-45dc-9215-d0f3997dd68c', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:51:43', 99, 0, '', '2019-05-31 14:51:43');
INSERT INTO `access_log` VALUES (15353, '36742629-f656-4b46-b67a-1e64a7a311af', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:51:43', 704, 0, '', '2019-05-31 14:51:44');
INSERT INTO `access_log` VALUES (15354, '3a2b27ce-cb02-452d-96c1-ebecc5473d20', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:58:32', 40, 0, '', '2019-05-31 14:58:32');
INSERT INTO `access_log` VALUES (15355, '1ddcaef7-7202-4155-8400-3236de022723', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:58:32', 55, 0, '', '2019-05-31 14:58:32');
INSERT INTO `access_log` VALUES (15356, 'ef42d1f1-4410-4875-91e9-84af5e5e3136', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:58:32', 93, 0, '', '2019-05-31 14:58:32');
INSERT INTO `access_log` VALUES (15357, '4a97e805-6feb-47f5-bf87-d3186039055e', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:58:33', 218, 0, '', '2019-05-31 14:58:33');
INSERT INTO `access_log` VALUES (15358, 'aea61e10-8561-42f5-b1f7-a707a50f8e75', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 14:58:33', 244, 0, '', '2019-05-31 14:58:33');
INSERT INTO `access_log` VALUES (15359, 'af11abad-9ec2-4e65-9207-4c39f22b88d3', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:05:30', 588, 0, '', '2019-05-31 15:05:30');
INSERT INTO `access_log` VALUES (15360, 'c0212ff8-5448-442b-bdbf-ecf371958254', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:05:30', 714, 0, '', '2019-05-31 15:05:30');
INSERT INTO `access_log` VALUES (15361, '3a6ad507-e3a5-45c4-ad2b-2d5033f73a31', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:05:36', 40, 0, '', '2019-05-31 15:05:36');
INSERT INTO `access_log` VALUES (15362, 'c4b3a42f-b84b-435c-9403-9e0f827eb20a', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:05:39', 49, 0, '', '2019-05-31 15:05:39');
INSERT INTO `access_log` VALUES (15363, '41afb612-82e3-4a2a-81e8-81542e545779', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:05:39', 57, 0, '', '2019-05-31 15:05:39');
INSERT INTO `access_log` VALUES (15364, '31322ddf-5c2c-47a1-90ac-17ed1ef4ee85', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:05:46', 45, 0, '', '2019-05-31 15:05:46');
INSERT INTO `access_log` VALUES (15365, 'a7581051-e327-49b1-8541-a61a074b723c', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:05:46', 58, 0, '', '2019-05-31 15:05:46');
INSERT INTO `access_log` VALUES (15366, 'b20ccb16-091c-4c86-be7c-99cad6cf7aec', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:05:49', 54, 0, '', '2019-05-31 15:05:49');
INSERT INTO `access_log` VALUES (15367, 'e53b45b6-f3f4-4003-8670-5d2e8f33eed2', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:05:49', 48, 0, '', '2019-05-31 15:05:49');
INSERT INTO `access_log` VALUES (15368, 'bcb6b906-0966-4334-811e-e7522513cdef', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:05:58', 55, 0, '', '2019-05-31 15:05:58');
INSERT INTO `access_log` VALUES (15369, '25115f60-ef6e-4616-b1a0-08e5a4d6d759', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:08:26', 477, 0, '', '2019-05-31 15:08:26');
INSERT INTO `access_log` VALUES (15370, '322725a5-a166-49db-bbad-7df8d54b7996', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:08:26', 481, 0, '', '2019-05-31 15:08:26');
INSERT INTO `access_log` VALUES (15371, '172316b5-ef29-45b7-815c-152781ebc8cc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:08:27', 45, 0, '', '2019-05-31 15:08:27');
INSERT INTO `access_log` VALUES (15372, 'eebd1ae7-01f6-4e80-9145-13de8990a10a', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:08:27', 171, 0, '', '2019-05-31 15:08:28');
INSERT INTO `access_log` VALUES (15373, '59.76.15592869050912569', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.101.191.115', '2019-05-31 15:15:05', 10, 0, '', '2019-05-31 15:15:05');
INSERT INTO `access_log` VALUES (15374, '59.74.15592869050912573', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.101.191.115', '2019-05-31 15:15:05', 20, 2001001000, '服务端发生异常', '2019-05-31 15:15:05');
INSERT INTO `access_log` VALUES (15375, '64.76.15592869078881945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.101.191.115', '2019-05-31 15:15:08', 12, 0, '', '2019-05-31 15:15:08');
INSERT INTO `access_log` VALUES (15376, '64.85.15592869080281951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.101.191.115', '2019-05-31 15:15:08', 3, 0, '', '2019-05-31 15:15:08');
INSERT INTO `access_log` VALUES (15377, '64.78.15592869090891951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.101.191.115', '2019-05-31 15:15:09', 2, 0, '', '2019-05-31 15:15:09');
INSERT INTO `access_log` VALUES (15378, '64.80.15592869095831941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.101.191.115', '2019-05-31 15:15:10', 2, 0, '', '2019-05-31 15:15:10');
INSERT INTO `access_log` VALUES (15379, '4a05e289-3c2a-439f-8940-c580e4a2f067', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:20:23', 20, 1002001012, '访问令牌已过期', '2019-05-31 15:20:23');
INSERT INTO `access_log` VALUES (15380, '20b7470d-3201-4052-af3a-c583bc3d0d02', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:20:23', 21, 1002001012, '访问令牌已过期', '2019-05-31 15:20:23');
INSERT INTO `access_log` VALUES (15381, 'e43a7759-d579-47a0-8e3f-6603b451584d', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:20:23', 20, 1002001012, '访问令牌已过期', '2019-05-31 15:20:23');
INSERT INTO `access_log` VALUES (15382, 'bceb4237-26a3-427a-a053-de9c9a432a9a', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:20:25', 10, 1002001012, '访问令牌已过期', '2019-05-31 15:20:25');
INSERT INTO `access_log` VALUES (15383, 'fc60ecbd-ba4b-4739-aad6-b9a4f525ce3a', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:20:25', 11, 1002001012, '访问令牌已过期', '2019-05-31 15:20:25');
INSERT INTO `access_log` VALUES (15384, 'dc188717-ffad-4b87-ac14-d35a7b9e48bb', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:20:25', 9, 1002001012, '访问令牌已过期', '2019-05-31 15:20:25');
INSERT INTO `access_log` VALUES (15385, '952484a2-802f-415e-9c1d-4ba4939ee85f', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:20:44', 148, 0, '', '2019-05-31 15:20:44');
INSERT INTO `access_log` VALUES (15386, '3f5a4621-6ad6-4223-b169-60c5c97f5e90', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:20:49', 36, 0, '', '2019-05-31 15:20:49');
INSERT INTO `access_log` VALUES (15387, '4f8a8c15-67a7-4aea-9158-5e556cdcb93c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:20:49', 42, 0, '', '2019-05-31 15:20:49');
INSERT INTO `access_log` VALUES (15388, '3c195a93-7be7-44eb-aa4e-411e671a4b62', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:20:50', 43, 0, '', '2019-05-31 15:20:50');
INSERT INTO `access_log` VALUES (15389, 'cf11aa0b-9a72-4831-be2a-1315001e15b2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:22:12', 40, 0, '', '2019-05-31 15:22:12');
INSERT INTO `access_log` VALUES (15390, '98108608-f722-4c37-940e-90c568b34748', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:22:13', 42, 0, '', '2019-05-31 15:22:13');
INSERT INTO `access_log` VALUES (15391, 'ecf059c6-07b5-42ea-acad-e60298a8e8bc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:22:13', 48, 0, '', '2019-05-31 15:22:13');
INSERT INTO `access_log` VALUES (15392, 'f33c2d16-6a46-47eb-a032-4e8d40347b14', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:22:15', 34, 0, '', '2019-05-31 15:22:15');
INSERT INTO `access_log` VALUES (15393, '2c010bd1-de91-4c01-8d77-ac9e1aa56b57', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:22:15', 36, 0, '', '2019-05-31 15:22:15');
INSERT INTO `access_log` VALUES (15394, '99995f19-5d27-46c1-b8bd-c094a579ebe5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:22:15', 139, 0, '', '2019-05-31 15:22:15');
INSERT INTO `access_log` VALUES (15395, '7452bf90-c189-45d0-88bd-20e65d9d6b7f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:23:55', 47, 0, '', '2019-05-31 15:23:55');
INSERT INTO `access_log` VALUES (15396, 'b3d23c52-6656-41e4-ab1f-6bfa388f6fc1', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:23:55', 45, 0, '', '2019-05-31 15:23:55');
INSERT INTO `access_log` VALUES (15397, '7fa0b1ce-569a-493d-8696-d17012502709', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:23:55', 53, 0, '', '2019-05-31 15:23:55');
INSERT INTO `access_log` VALUES (15398, '9795ae38-4025-4fe4-9cc1-7449996a74f8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:24:06', 39, 0, '', '2019-05-31 15:24:06');
INSERT INTO `access_log` VALUES (15399, 'aacbc27b-60e6-446a-8b2f-85783b581fca', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:24:06', 42, 0, '', '2019-05-31 15:24:06');
INSERT INTO `access_log` VALUES (15400, '43fbab0c-74b0-417d-b1a7-74ea44dcb7ca', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:24:06', 135, 0, '', '2019-05-31 15:24:06');
INSERT INTO `access_log` VALUES (15401, '0d9039fd-5e9f-43dd-a667-46faea5aafb4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:26:35', 231, 0, '', '2019-05-31 15:26:35');
INSERT INTO `access_log` VALUES (15402, 'b648a15f-a39b-4a3a-9597-0321999ee8cf', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:26:35', 234, 0, '', '2019-05-31 15:26:35');
INSERT INTO `access_log` VALUES (15403, '3c091256-edd7-449c-84df-68c220862e63', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:26:35', 236, 0, '', '2019-05-31 15:26:35');
INSERT INTO `access_log` VALUES (15404, '10e9a55d-e90d-4634-a9e0-51a3efa363fd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:26:38', 34, 0, '', '2019-05-31 15:26:38');
INSERT INTO `access_log` VALUES (15405, '05f7d413-bdac-4b61-acff-3c2e57a1ca52', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:26:38', 36, 0, '', '2019-05-31 15:26:38');
INSERT INTO `access_log` VALUES (15406, '0e8e065c-31d6-424a-b018-9429037adda2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:26:38', 44, 0, '', '2019-05-31 15:26:38');
INSERT INTO `access_log` VALUES (15407, '6fe6b5ff-886d-4b0d-b5b5-9e5693db0ced', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:27:02', 40, 0, '', '2019-05-31 15:27:02');
INSERT INTO `access_log` VALUES (15408, '8f8f7582-08d6-4ee3-9877-c0b3453721cb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:27:02', 43, 0, '', '2019-05-31 15:27:02');
INSERT INTO `access_log` VALUES (15409, 'a3f4754b-df19-496c-bcc7-8e296dc7f1b6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:27:02', 48, 0, '', '2019-05-31 15:27:03');
INSERT INTO `access_log` VALUES (15410, '8a4c1f41-3d00-486c-a77f-6df7c1409207', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:27:10', 207, 0, '', '2019-05-31 15:27:10');
INSERT INTO `access_log` VALUES (15411, '007de24a-76d0-4fee-acd4-33f91717cec8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:27:10', 194, 0, '', '2019-05-31 15:27:10');
INSERT INTO `access_log` VALUES (15412, 'e8bb59d3-7174-406d-b9a2-5138173f0798', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:27:10', 200, 0, '', '2019-05-31 15:27:10');
INSERT INTO `access_log` VALUES (15413, 'ea837e32-b279-417e-9599-f35bb5ddc215', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:27:57', 47, 0, '', '2019-05-31 15:27:57');
INSERT INTO `access_log` VALUES (15414, '164ed5b1-b335-4569-b9b3-455049c5731d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:27:57', 42, 0, '', '2019-05-31 15:27:57');
INSERT INTO `access_log` VALUES (15415, 'a633a0d7-fe6b-4bbf-a62f-c9bb60922781', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:27:58', 49, 0, '', '2019-05-31 15:27:58');
INSERT INTO `access_log` VALUES (15416, '40e9ce2e-689f-4dbf-b9ee-9cfa1a058604', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:28:18', 45, 0, '', '2019-05-31 15:28:18');
INSERT INTO `access_log` VALUES (15417, '0a8ce91b-5abf-40cc-a72f-7f5a5d707a30', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:28:18', 50, 0, '', '2019-05-31 15:28:18');
INSERT INTO `access_log` VALUES (15418, '74fe75a8-5b78-4280-9d97-0cf180077603', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:28:18', 55, 0, '', '2019-05-31 15:28:18');
INSERT INTO `access_log` VALUES (15419, 'c9f4a906-37b5-4793-9630-54e0eb925e3e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:29:16', 43, 0, '', '2019-05-31 15:29:16');
INSERT INTO `access_log` VALUES (15420, 'e81e955f-c2c5-4c60-b92f-a9e8c3c65d51', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:29:16', 45, 0, '', '2019-05-31 15:29:16');
INSERT INTO `access_log` VALUES (15421, '19f72e76-3ead-4b85-a64b-8166179541ac', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:29:16', 41, 0, '', '2019-05-31 15:29:16');
INSERT INTO `access_log` VALUES (15422, '1732e270-e845-4c0b-b286-66449adcbefa', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:29:38', 41, 0, '', '2019-05-31 15:29:38');
INSERT INTO `access_log` VALUES (15423, 'bb57ba6f-4382-4195-80f9-57dc7480fffa', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:29:38', 41, 0, '', '2019-05-31 15:29:38');
INSERT INTO `access_log` VALUES (15424, '1a1b5cf0-22a2-4f7b-a50a-371b9493b0e4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:29:38', 41, 0, '', '2019-05-31 15:29:38');
INSERT INTO `access_log` VALUES (15425, 'f2f56c67-a59f-4348-930d-f42017ce6886', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:33:13', 45, 0, '', '2019-05-31 15:33:13');
INSERT INTO `access_log` VALUES (15426, '4357e5ea-d55c-4374-a064-1ec1219af5db', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:33:13', 87, 0, '', '2019-05-31 15:33:13');
INSERT INTO `access_log` VALUES (15427, '2183cc7e-6596-4f7a-a8dc-24f874749bff', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:33:14', 47, 0, '', '2019-05-31 15:33:14');
INSERT INTO `access_log` VALUES (15428, 'c4bed0b6-812a-4ba1-bd5c-9db27771caa6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:33:19', 36, 0, '', '2019-05-31 15:33:19');
INSERT INTO `access_log` VALUES (15429, 'd59d71aa-009a-4704-8ce7-9b2255e34c7a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:33:19', 41, 0, '', '2019-05-31 15:33:19');
INSERT INTO `access_log` VALUES (15430, '3adb25ed-585c-4349-bf92-a4596d7604ac', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:33:19', 39, 0, '', '2019-05-31 15:33:19');
INSERT INTO `access_log` VALUES (15431, '66a2f1d2-752c-441c-959b-b603b8ad31db', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:34:47', 37, 0, '', '2019-05-31 15:34:47');
INSERT INTO `access_log` VALUES (15432, 'c134bb77-7275-4899-9b07-5cf45f89d13b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:34:47', 59, 0, '', '2019-05-31 15:34:47');
INSERT INTO `access_log` VALUES (15433, '0175b2a9-9f11-4ce1-95de-37f3662dfd47', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:34:47', 39, 0, '', '2019-05-31 15:34:47');
INSERT INTO `access_log` VALUES (15434, '2ac45f3d-ca83-4c7f-85bc-689a1a277656', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:34:53', 38, 0, '', '2019-05-31 15:34:53');
INSERT INTO `access_log` VALUES (15435, '856ad51c-932a-4ab0-9f9c-19b482b8387a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:34:53', 33, 0, '', '2019-05-31 15:34:53');
INSERT INTO `access_log` VALUES (15436, '3c9f1a4f-f1b2-467f-891b-40c02c3b672d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:34:53', 33, 0, '', '2019-05-31 15:34:53');
INSERT INTO `access_log` VALUES (15437, 'a7ad214e-9cf0-4a41-a495-309f1d1d0fa8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:35:36', 169, 0, '', '2019-05-31 15:35:36');
INSERT INTO `access_log` VALUES (15438, '9191f9dd-8f9e-4c70-b5a7-b1777d0d88c5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:35:36', 171, 0, '', '2019-05-31 15:35:36');
INSERT INTO `access_log` VALUES (15439, '33a1f618-5321-4513-aa05-a963f8a27fb7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:35:36', 172, 0, '', '2019-05-31 15:35:36');
INSERT INTO `access_log` VALUES (15440, 'd91017a7-972c-4701-a05b-48a443b89c7a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:35:42', 38, 0, '', '2019-05-31 15:35:42');
INSERT INTO `access_log` VALUES (15441, '8182957c-0ac7-4c71-88ea-ae41bc345025', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:35:42', 47, 0, '', '2019-05-31 15:35:42');
INSERT INTO `access_log` VALUES (15442, 'b1022795-d272-4801-8332-7e12928c58ee', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:35:42', 54, 0, '', '2019-05-31 15:35:42');
INSERT INTO `access_log` VALUES (15443, '65.49.15592880658411999', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:26', 0, 1002001015, '账号未登陆', '2019-05-31 15:34:26');
INSERT INTO `access_log` VALUES (15444, '65.46.15592880658411983', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:26', 0, 1002001015, '账号未登陆', '2019-05-31 15:34:26');
INSERT INTO `access_log` VALUES (15445, '65.52.15592880658421983', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:26', 1, 1002001015, '账号未登陆', '2019-05-31 15:34:26');
INSERT INTO `access_log` VALUES (15446, '65.53.15592880708551977', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 15:34:31');
INSERT INTO `access_log` VALUES (15447, '65.45.15592880749462005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:35', 63, 0, '', '2019-05-31 15:34:35');
INSERT INTO `access_log` VALUES (15448, '65.51.15592880751721989', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:35', 14, 0, '', '2019-05-31 15:34:35');
INSERT INTO `access_log` VALUES (15449, '65.47.15592880751732001', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:35', 14, 0, '', '2019-05-31 15:34:35');
INSERT INTO `access_log` VALUES (15450, '65.54.15592880751781977', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:35', 13, 0, '', '2019-05-31 15:34:35');
INSERT INTO `access_log` VALUES (15451, '62.88.15592880805862501', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:41', 23, 0, '', '2019-05-31 15:34:41');
INSERT INTO `access_log` VALUES (15452, '62.85.15592880841342501', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:44', 24, 0, '', '2019-05-31 15:34:44');
INSERT INTO `access_log` VALUES (15453, '64.78.15592880860901967', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:46', 18, 0, '', '2019-05-31 15:34:46');
INSERT INTO `access_log` VALUES (15454, '64.80.15592880860941957', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:46', 15, 0, '', '2019-05-31 15:34:46');
INSERT INTO `access_log` VALUES (15455, '64.83.15592880896041959', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:50', 9, 0, '', '2019-05-31 15:34:50');
INSERT INTO `access_log` VALUES (15456, '64.77.15592880896041965', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:50', 14, 0, '', '2019-05-31 15:34:50');
INSERT INTO `access_log` VALUES (15457, '64.84.15592880914341967', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:51', 11, 0, '', '2019-05-31 15:34:51');
INSERT INTO `access_log` VALUES (15458, '65.48.15592880934822001', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:53', 507, 0, '', '2019-05-31 15:34:54');
INSERT INTO `access_log` VALUES (15459, '65.52.15592880941551985', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:54', 10, 0, '', '2019-05-31 15:34:54');
INSERT INTO `access_log` VALUES (15460, '65.49.15592880954342001', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:55', 9, 0, '', '2019-05-31 15:34:55');
INSERT INTO `access_log` VALUES (15461, '65.53.15592880971571979', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:57', 14, 0, '', '2019-05-31 15:34:57');
INSERT INTO `access_log` VALUES (15462, '59.74.15592880990422589', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:34:59', 20, 0, '', '2019-05-31 15:34:59');
INSERT INTO `access_log` VALUES (15463, '59.79.15592881009172587', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:35:01', 34, 2001001000, '服务端发生异常', '2019-05-31 15:35:01');
INSERT INTO `access_log` VALUES (15464, '923baf3e-f2d4-43c0-908b-3d40afc1f1e3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:36:26', 37, 0, '', '2019-05-31 15:36:26');
INSERT INTO `access_log` VALUES (15465, 'e291b33c-c36a-4e36-9978-c943d067593b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:36:26', 35, 0, '', '2019-05-31 15:36:26');
INSERT INTO `access_log` VALUES (15466, 'a128826a-9334-4a43-be93-2d7c4fad676c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:36:26', 46, 0, '', '2019-05-31 15:36:26');
INSERT INTO `access_log` VALUES (15467, 'bf6688f1-c368-4832-abca-b4df8b617453', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:36:27', 2565, 0, '', '2019-05-31 15:36:30');
INSERT INTO `access_log` VALUES (15468, '66.57.15592881117061533', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:35:12', 21, 0, '', '2019-05-31 15:35:12');
INSERT INTO `access_log` VALUES (15469, '41f09233-999a-449a-8faa-3f8a0632f556', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:36:31', 34, 0, '', '2019-05-31 15:36:31');
INSERT INTO `access_log` VALUES (15470, 'dff3e80b-3a78-4f42-bf75-3ec4d6bbfd7c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:36:31', 40, 0, '', '2019-05-31 15:36:31');
INSERT INTO `access_log` VALUES (15471, '16d01ec8-9c0c-4904-8acd-f5ab7b1d0eea', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:36:31', 40, 0, '', '2019-05-31 15:36:31');
INSERT INTO `access_log` VALUES (15472, 'dbf1a76d-8b46-43e6-8020-27626ae776e4', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:36:32', 66, 0, '', '2019-05-31 15:36:32');
INSERT INTO `access_log` VALUES (15473, '64.76.15592881184971963', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:35:18', 10, 0, '', '2019-05-31 15:35:19');
INSERT INTO `access_log` VALUES (15474, '64.82.15592881184971971', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:35:18', 12, 0, '', '2019-05-31 15:35:19');
INSERT INTO `access_log` VALUES (15475, '65.51.15592881254041991', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.91.60.104', '2019-05-31 15:35:25', 1, 1002001015, '账号未登陆', '2019-05-31 15:35:25');
INSERT INTO `access_log` VALUES (15476, '62.84.15592881294102495', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:35:29', 86, 0, '', '2019-05-31 15:35:29');
INSERT INTO `access_log` VALUES (15477, '65.47.15592881349032003', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '58.247.206.153', '2019-05-31 15:35:35', 1, 1002001015, '账号未登陆', '2019-05-31 15:35:35');
INSERT INTO `access_log` VALUES (15478, '65.50.15592881380122003', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.151.207.141', '2019-05-31 15:35:38', 1, 1002001015, '账号未登陆', '2019-05-31 15:35:38');
INSERT INTO `access_log` VALUES (15479, '62.80.15592881404812497', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.129.7.235', '2019-05-31 15:35:40', 1, 1002001015, '账号未登陆', '2019-05-31 15:35:40');
INSERT INTO `access_log` VALUES (15480, '62.88.15592881441952503', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.129.6.174', '2019-05-31 15:35:44', 0, 1002001015, '账号未登陆', '2019-05-31 15:35:44');
INSERT INTO `access_log` VALUES (15481, '64.80.15592881461351959', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.89.29.97', '2019-05-31 15:35:46', 1, 1002001015, '账号未登陆', '2019-05-31 15:35:46');
INSERT INTO `access_log` VALUES (15482, '64.83.15592881492381961', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '180.97.118.219', '2019-05-31 15:35:49', 1, 1002001015, '账号未登陆', '2019-05-31 15:35:49');
INSERT INTO `access_log` VALUES (15483, '64.81.15592881505981959', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.89.239.120', '2019-05-31 15:35:51', 1, 1002001015, '账号未登陆', '2019-05-31 15:35:51');
INSERT INTO `access_log` VALUES (15484, '65.48.15592881534612003', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.89.29.86', '2019-05-31 15:35:53', 1, 1002001015, '账号未登陆', '2019-05-31 15:35:53');
INSERT INTO `access_log` VALUES (15485, '65.49.15592881554702003', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.227.139.178', '2019-05-31 15:35:55', 1, 1002001015, '账号未登陆', '2019-05-31 15:35:55');
INSERT INTO `access_log` VALUES (15486, '65.53.15592881562891981', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.62.99', '2019-05-31 15:35:56', 1, 1002001015, '账号未登陆', '2019-05-31 15:35:56');
INSERT INTO `access_log` VALUES (15487, '65.45.15592881571812009', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.89.239.232', '2019-05-31 15:35:57', 1, 1002001015, '账号未登陆', '2019-05-31 15:35:57');
INSERT INTO `access_log` VALUES (15488, '59.80.15592881594962589', 0, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.129.6.203', '2019-05-31 15:35:59', 1, 1002001015, '账号未登陆', '2019-05-31 15:35:59');
INSERT INTO `access_log` VALUES (15489, '65.54.15592881614021981', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:01', 11, 0, '', '2019-05-31 15:36:01');
INSERT INTO `access_log` VALUES (15490, '65.51.15592881614031993', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:01', 11, 0, '', '2019-05-31 15:36:01');
INSERT INTO `access_log` VALUES (15491, '65.47.15592881614042005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:01', 10, 0, '', '2019-05-31 15:36:01');
INSERT INTO `access_log` VALUES (15492, '59.72.15592881624232587', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.178.177', '2019-05-31 15:36:02', 1, 1002001015, '账号未登陆', '2019-05-31 15:36:02');
INSERT INTO `access_log` VALUES (15493, '65.50.15592881658672005', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:06', 10, 0, '', '2019-05-31 15:36:06');
INSERT INTO `access_log` VALUES (15494, '65.46.15592881658691989', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:06', 9, 0, '', '2019-05-31 15:36:06');
INSERT INTO `access_log` VALUES (15495, '65.48.15592881658722005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:06', 9, 0, '', '2019-05-31 15:36:06');
INSERT INTO `access_log` VALUES (15496, '65.49.15592881690042005', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:09', 11, 0, '', '2019-05-31 15:36:09');
INSERT INTO `access_log` VALUES (15497, '65.45.15592881690062011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:09', 10, 0, '', '2019-05-31 15:36:09');
INSERT INTO `access_log` VALUES (15498, '65.53.15592881690061983', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:09', 15, 0, '', '2019-05-31 15:36:09');
INSERT INTO `access_log` VALUES (15499, '66.55.15592881711281543', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.129.6.227', '2019-05-31 15:36:11', 1, 1002001015, '账号未登陆', '2019-05-31 15:36:11');
INSERT INTO `access_log` VALUES (15500, '65.51.15592881724231995', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:12', 9, 0, '', '2019-05-31 15:36:12');
INSERT INTO `access_log` VALUES (15501, '65.54.15592881724231983', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:12', 11, 0, '', '2019-05-31 15:36:12');
INSERT INTO `access_log` VALUES (15502, '65.47.15592881724252007', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:12', 10, 0, '', '2019-05-31 15:36:12');
INSERT INTO `access_log` VALUES (15503, '65.50.15592881758842007', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:16', 9, 0, '', '2019-05-31 15:36:16');
INSERT INTO `access_log` VALUES (15504, '65.46.15592881758851991', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:16', 9, 0, '', '2019-05-31 15:36:16');
INSERT INTO `access_log` VALUES (15505, '65.48.15592881758872007', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:16', 8, 0, '', '2019-05-31 15:36:16');
INSERT INTO `access_log` VALUES (15506, '59.74.15592881835842591', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:24', 4, 0, '', '2019-05-31 15:36:24');
INSERT INTO `access_log` VALUES (15507, '59.79.15592881835852589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:24', 20, 2001001000, '服务端发生异常', '2019-05-31 15:36:24');
INSERT INTO `access_log` VALUES (15508, '64.76.15592881862221965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:26', 4, 0, '', '2019-05-31 15:36:26');
INSERT INTO `access_log` VALUES (15509, '64.82.15592881863551973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:26', 2, 0, '', '2019-05-31 15:36:26');
INSERT INTO `access_log` VALUES (15510, '64.85.15592881877591971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:28', 3, 0, '', '2019-05-31 15:36:28');
INSERT INTO `access_log` VALUES (15511, '64.78.15592881881471971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:28', 2, 0, '', '2019-05-31 15:36:28');
INSERT INTO `access_log` VALUES (15512, '64.80.15592881930601961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:33', 2, 0, '', '2019-05-31 15:36:33');
INSERT INTO `access_log` VALUES (15513, '64.83.15592881931451963', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.231.198.26', '2019-05-31 15:36:33', 2, 0, '', '2019-05-31 15:36:33');
INSERT INTO `access_log` VALUES (15514, '59.80.15592882432052591', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.129.7.235', '2019-05-31 15:37:23', 4, 0, '', '2019-05-31 15:37:23');
INSERT INTO `access_log` VALUES (15515, '59.72.15592882432672589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '58.247.206.156', '2019-05-31 15:37:23', 19, 2001001000, '服务端发生异常', '2019-05-31 15:37:23');
INSERT INTO `access_log` VALUES (15516, '64.76.15592882471031967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '180.97.118.223', '2019-05-31 15:37:27', 2, 0, '', '2019-05-31 15:37:27');
INSERT INTO `access_log` VALUES (15517, '64.82.15592882471291975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.197', '2019-05-31 15:37:27', 2, 0, '', '2019-05-31 15:37:27');
INSERT INTO `access_log` VALUES (15518, '64.85.15592882487761973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.129.6.151', '2019-05-31 15:37:29', 2, 0, '', '2019-05-31 15:37:29');
INSERT INTO `access_log` VALUES (15519, 'd56ab90c-cae7-4056-9d73-52ece9d67411', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:39:38', 41, 0, '', '2019-05-31 15:39:38');
INSERT INTO `access_log` VALUES (15520, 'c86852a4-3d39-484e-bb20-18c04096b8a5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:39:38', 43, 0, '', '2019-05-31 15:39:38');
INSERT INTO `access_log` VALUES (15521, '425fedfc-1512-4827-80c4-d70e7a8528c9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:39:38', 47, 0, '', '2019-05-31 15:39:38');
INSERT INTO `access_log` VALUES (15522, '4ebc2446-bbbc-47e6-b845-12b8b95384fd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:24', 561, 0, '', '2019-05-31 15:46:24');
INSERT INTO `access_log` VALUES (15523, '3161a276-7c40-45ea-90da-47c2582e38e9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:24', 565, 0, '', '2019-05-31 15:46:24');
INSERT INTO `access_log` VALUES (15524, '621cf223-8cc6-46f6-9398-b6f6b4f74851', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:24', 529, 0, '', '2019-05-31 15:46:24');
INSERT INTO `access_log` VALUES (15525, 'baf8273b-8d34-466d-acd0-185e48b43133', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:24', 58, 0, '', '2019-05-31 15:46:24');
INSERT INTO `access_log` VALUES (15526, '3dfe2a63-1efb-41a5-81b5-c75b5a4b260f', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:24', 196, 0, '', '2019-05-31 15:46:24');
INSERT INTO `access_log` VALUES (15527, 'c8448e6c-607b-4cfe-aba9-a700e69347a7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:24', 109, 0, '', '2019-05-31 15:46:24');
INSERT INTO `access_log` VALUES (15528, '27d81453-270f-4fe9-a1cc-70f5c395af94', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:25', 48, 0, '', '2019-05-31 15:46:25');
INSERT INTO `access_log` VALUES (15529, 'ef961053-db12-464d-a4e5-099d376b72f4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:26', 32, 0, '', '2019-05-31 15:46:26');
INSERT INTO `access_log` VALUES (15530, '0915ce23-c8c7-416a-bd66-3bc2a3916399', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:26', 33, 0, '', '2019-05-31 15:46:26');
INSERT INTO `access_log` VALUES (15531, '27e2c773-f02c-46e6-be2e-419cb6a94093', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:26', 36, 0, '', '2019-05-31 15:46:26');
INSERT INTO `access_log` VALUES (15532, 'd3e5a55f-b7d0-4fe2-add5-caae792e5544', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:26', 63, 0, '', '2019-05-31 15:46:27');
INSERT INTO `access_log` VALUES (15533, 'fd6b9558-3edf-473d-b198-46f02a3daa3c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:28', 41, 0, '', '2019-05-31 15:46:28');
INSERT INTO `access_log` VALUES (15534, '97e69d27-4ed7-4e01-aaf7-63b8d1d3d0a2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:28', 47, 0, '', '2019-05-31 15:46:28');
INSERT INTO `access_log` VALUES (15535, 'ff97a458-e644-4e32-b44c-958de76e5371', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:28', 39, 0, '', '2019-05-31 15:46:28');
INSERT INTO `access_log` VALUES (15536, '5597ce31-3c26-4c3e-9ffb-fcb1dc26fb19', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:46:28', 66, 0, '', '2019-05-31 15:46:28');
INSERT INTO `access_log` VALUES (15537, '703cf380-4f7f-4344-aa66-8aec523260fb', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:48:28', 727, 0, '', '2019-05-31 15:48:29');
INSERT INTO `access_log` VALUES (15538, '9752eed3-f8a9-41b1-b81c-23906d86cacd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:48:28', 746, 0, '', '2019-05-31 15:48:29');
INSERT INTO `access_log` VALUES (15539, 'd44b9307-1981-492b-9a78-df519b49d1c3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:48:28', 749, 0, '', '2019-05-31 15:48:29');
INSERT INTO `access_log` VALUES (15540, 'ff5ed89f-3791-4b89-a74c-e6eb3d2bad6d', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:48:28', 1259, 0, '', '2019-05-31 15:48:30');
INSERT INTO `access_log` VALUES (15541, '4ee52424-cd86-4a34-9901-25e562d312bc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:48:39', 54, 0, '', '2019-05-31 15:48:39');
INSERT INTO `access_log` VALUES (15542, 'b71ce0b3-ef5d-4ef0-b0a0-6c3ecd660668', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:48:39', 62, 0, '', '2019-05-31 15:48:39');
INSERT INTO `access_log` VALUES (15543, '69b1ff68-7d57-4b06-b4ba-46e45dbad7e3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:48:39', 66, 0, '', '2019-05-31 15:48:39');
INSERT INTO `access_log` VALUES (15544, '4e633334-b89c-4704-ab89-bd9878c3effe', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:48:40', 61, 0, '', '2019-05-31 15:48:40');
INSERT INTO `access_log` VALUES (15545, 'd2f15e0b-9f29-4bfd-996b-c791413624d6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:51:37', 51, 0, '', '2019-05-31 15:51:37');
INSERT INTO `access_log` VALUES (15546, 'e04a6fc8-2493-4350-9c74-5b96e5f72983', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:51:37', 53, 0, '', '2019-05-31 15:51:37');
INSERT INTO `access_log` VALUES (15547, '000e04ac-cdae-44d1-b048-e2e782bc3616', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:51:37', 54, 0, '', '2019-05-31 15:51:37');
INSERT INTO `access_log` VALUES (15548, '4039c513-d71a-426c-8460-4424ea52c0cf', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:51:38', 1931, 0, '', '2019-05-31 15:51:40');
INSERT INTO `access_log` VALUES (15549, 'f1501cff-2e77-4cab-aeb9-bd66a58516b4', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:51:46', 54, 0, '', '2019-05-31 15:51:46');
INSERT INTO `access_log` VALUES (15550, '9529cde7-4e4c-4b2b-96c1-b79d5ea191da', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:56:55', 43, 0, '', '2019-05-31 15:56:55');
INSERT INTO `access_log` VALUES (15551, '4120f627-baba-4dec-84ec-3f59b7bbaa4c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:56:55', 45, 0, '', '2019-05-31 15:56:55');
INSERT INTO `access_log` VALUES (15552, '3f0a135b-c00d-4652-a2c1-ca607a8e5d4b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:56:55', 45, 0, '', '2019-05-31 15:56:55');
INSERT INTO `access_log` VALUES (15553, '67416fd6-e256-4d99-97df-f8c96da033a0', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:56:55', 106, 0, '', '2019-05-31 15:56:56');
INSERT INTO `access_log` VALUES (15554, '2a9be717-3c5d-4739-bb51-68f15899741e', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&name=安踏&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:57:07', 54, 0, '', '2019-05-31 15:57:07');
INSERT INTO `access_log` VALUES (15555, '2dc829d6-c5d9-42ec-a407-1a9d9e774316', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:57:46', 421, 0, '', '2019-05-31 15:57:46');
INSERT INTO `access_log` VALUES (15556, '73d67533-a923-4e90-99e9-2b4edd3c3d6d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:57:46', 532, 0, '', '2019-05-31 15:57:47');
INSERT INTO `access_log` VALUES (15557, 'fe8dd7bd-c435-4e00-9946-12236390b3ad', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:57:46', 535, 0, '', '2019-05-31 15:57:47');
INSERT INTO `access_log` VALUES (15558, '54371e40-e57d-43c5-b716-98c27bb61e72', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:57:46', 655, 2001001001, '参数缺失:Required Integer parameter \'status\' is not present', '2019-05-31 15:57:47');
INSERT INTO `access_log` VALUES (15559, '09a2786b-12fa-46d6-b728-64cdc3dbdc12', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:57:50', 47, 0, '', '2019-05-31 15:57:50');
INSERT INTO `access_log` VALUES (15560, 'baae28e1-9783-4425-afd5-c6c9de179ca7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:57:50', 43, 0, '', '2019-05-31 15:57:50');
INSERT INTO `access_log` VALUES (15561, '660eb5c5-0e5d-4460-bc49-4c60b0d1f0a5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:57:50', 51, 0, '', '2019-05-31 15:57:50');
INSERT INTO `access_log` VALUES (15562, 'ebe23209-fb67-43ec-b759-5f58d8df6066', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:57:50', 39, 2001001001, '参数缺失:Required Integer parameter \'status\' is not present', '2019-05-31 15:57:50');
INSERT INTO `access_log` VALUES (15563, '606b012f-78aa-4edf-bd18-ada746501f89', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:58:02', 37, 0, '', '2019-05-31 15:58:02');
INSERT INTO `access_log` VALUES (15564, '7697d17a-bac7-4273-a852-f669ca140c9a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:58:02', 43, 0, '', '2019-05-31 15:58:02');
INSERT INTO `access_log` VALUES (15565, '08e00c7e-a662-4b66-92f7-7474fc43037e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:58:02', 45, 0, '', '2019-05-31 15:58:02');
INSERT INTO `access_log` VALUES (15566, '10f3c77f-71a0-4f0f-ada1-e36547d0cc6d', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:58:02', 52, 2001001001, '参数缺失:Required Integer parameter \'status\' is not present', '2019-05-31 15:58:02');
INSERT INTO `access_log` VALUES (15567, '5697c18e-c134-4c78-975b-8feda495f384', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:58:14', 54, 0, '', '2019-05-31 15:58:14');
INSERT INTO `access_log` VALUES (15568, '6d30ec7f-34ea-4f32-a79e-76aa3b55f304', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 15:58:32', 52, 0, '', '2019-05-31 15:58:32');
INSERT INTO `access_log` VALUES (15569, '59.79.15592896455652609', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:00:46', 4, 0, '', '2019-05-31 16:00:46');
INSERT INTO `access_log` VALUES (15570, '59.75.15592896455652611', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:00:46', 19, 2001001000, '服务端发生异常', '2019-05-31 16:00:46');
INSERT INTO `access_log` VALUES (15571, '64.77.15592896490341989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:00:49', 3, 0, '', '2019-05-31 16:00:49');
INSERT INTO `access_log` VALUES (15572, '64.81.15592896491561981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:00:49', 2, 0, '', '2019-05-31 16:00:49');
INSERT INTO `access_log` VALUES (15573, '64.84.15592896502421991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:00:50', 2, 0, '', '2019-05-31 16:00:50');
INSERT INTO `access_log` VALUES (15574, '64.76.15592896507671987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:00:51', 3, 0, '', '2019-05-31 16:00:51');
INSERT INTO `access_log` VALUES (15575, '59.78.15592896526982617', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:00:53', 3, 0, '', '2019-05-31 16:00:53');
INSERT INTO `access_log` VALUES (15576, '59.71.15592896526982613', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:00:53', 19, 2001001000, '服务端发生异常', '2019-05-31 16:00:53');
INSERT INTO `access_log` VALUES (15577, '64.82.15592896556311995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:00:56', 2, 0, '', '2019-05-31 16:00:56');
INSERT INTO `access_log` VALUES (15578, '64.85.15592896557481993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:00:56', 2, 0, '', '2019-05-31 16:00:56');
INSERT INTO `access_log` VALUES (15579, '64.78.15592896567981993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:00:57', 2, 0, '', '2019-05-31 16:00:57');
INSERT INTO `access_log` VALUES (15580, '59.80.15592896576342611', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:00:58', 3, 0, '', '2019-05-31 16:00:58');
INSERT INTO `access_log` VALUES (15581, '59.72.15592896576602609', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:00:58', 42, 2001001000, '服务端发生异常', '2019-05-31 16:00:58');
INSERT INTO `access_log` VALUES (15582, '64.80.15592896603131983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:00', 2, 0, '', '2019-05-31 16:01:00');
INSERT INTO `access_log` VALUES (15583, '64.83.15592896604271985', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:00', 2, 0, '', '2019-05-31 16:01:00');
INSERT INTO `access_log` VALUES (15584, '64.77.15592896613861991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:01', 2, 0, '', '2019-05-31 16:01:01');
INSERT INTO `access_log` VALUES (15585, '64.81.15592896619361983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:02', 3, 0, '', '2019-05-31 16:01:02');
INSERT INTO `access_log` VALUES (15586, '59.76.15592896661932609', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:06', 3, 0, '', '2019-05-31 16:01:06');
INSERT INTO `access_log` VALUES (15587, '59.74.15592896661932613', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:06', 15, 2001001000, '服务端发生异常', '2019-05-31 16:01:06');
INSERT INTO `access_log` VALUES (15588, '65.52.15592896798852011', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:20', 1, 1002001015, '账号未登陆', '2019-05-31 16:01:20');
INSERT INTO `access_log` VALUES (15589, '65.49.15592896798862027', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:20', 0, 1002001015, '账号未登陆', '2019-05-31 16:01:20');
INSERT INTO `access_log` VALUES (15590, '65.53.15592896798862005', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:20', 0, 1002001015, '账号未登陆', '2019-05-31 16:01:20');
INSERT INTO `access_log` VALUES (15591, '65.45.15592896822562033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 16:01:22');
INSERT INTO `access_log` VALUES (15592, '65.51.15592896865672017', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicaisd&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:27', 269, 0, '', '2019-05-31 16:01:27');
INSERT INTO `access_log` VALUES (15593, '65.47.15592896873392029', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:27', 10, 0, '', '2019-05-31 16:01:27');
INSERT INTO `access_log` VALUES (15594, '65.48.15592896873402029', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:27', 11, 0, '', '2019-05-31 16:01:27');
INSERT INTO `access_log` VALUES (15595, '65.46.15592896873672013', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:27', 10, 0, '', '2019-05-31 16:01:27');
INSERT INTO `access_log` VALUES (15596, '62.82.15592896913312521', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:31', 14, 0, '', '2019-05-31 16:01:31');
INSERT INTO `access_log` VALUES (15597, '66.53.15592896972751561', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.249.43.2', '2019-05-31 16:01:37', 51, 0, '', '2019-05-31 16:01:37');
INSERT INTO `access_log` VALUES (15598, 'bee71cc8-0717-49c0-a406-5390b4b0e9c2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:03:46', 49, 0, '', '2019-05-31 16:03:46');
INSERT INTO `access_log` VALUES (15599, 'b5c3ea04-0f10-4ccd-b3f6-16846e2b1850', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:03:46', 47, 0, '', '2019-05-31 16:03:46');
INSERT INTO `access_log` VALUES (15600, '334aed2e-2d23-4345-af24-9ec1ae710e73', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:03:46', 40, 0, '', '2019-05-31 16:03:46');
INSERT INTO `access_log` VALUES (15601, '9624ae57-3bfa-49a5-b908-9fef9bac3aa4', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:03:46', 157, 0, '', '2019-05-31 16:03:47');
INSERT INTO `access_log` VALUES (15602, '6a04a1c8-b91c-4688-8a4b-d307813fd5d7', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:06:12', 906, 0, '', '2019-05-31 16:06:13');
INSERT INTO `access_log` VALUES (15603, '7dbf3740-a9c7-4eaf-bb31-b3fe1f582f43', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:06:21', 31, 0, '', '2019-05-31 16:06:21');
INSERT INTO `access_log` VALUES (15604, 'f16cebbb-b791-42de-94e7-18a8a86695d1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:06:21', 37, 0, '', '2019-05-31 16:06:21');
INSERT INTO `access_log` VALUES (15605, '54b54983-1146-47ac-a803-b641e9623064', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:06:21', 58, 0, '', '2019-05-31 16:06:21');
INSERT INTO `access_log` VALUES (15606, 'add6a487-b763-4dee-a70b-9ba33a0b9b3e', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:06:21', 40, 0, '', '2019-05-31 16:06:22');
INSERT INTO `access_log` VALUES (15607, 'f3c8154e-f571-4782-9ccd-41c6a72dc6ce', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:06:32', 2158, 0, '', '2019-05-31 16:06:34');
INSERT INTO `access_log` VALUES (15608, '3345c058-761a-4136-9530-d0626bc12a4a', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&description=特步', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:06:47', 43, 0, '', '2019-05-31 16:06:47');
INSERT INTO `access_log` VALUES (15609, 'a58724ab-d438-4a6d-9a1b-db7625da6a5f', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:06:49', 46, 0, '', '2019-05-31 16:06:49');
INSERT INTO `access_log` VALUES (15610, '544420e0-03d3-4f2e-9e73-b6d1ddd9d3eb', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:07:31', 45, 0, '', '2019-05-31 16:07:31');
INSERT INTO `access_log` VALUES (15611, '3ef17a05-91c4-4ede-ae22-414acae0320b', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:09:41', 17, 1002001012, '访问令牌已过期', '2019-05-31 16:09:41');
INSERT INTO `access_log` VALUES (15612, 'afdfee27-2d3d-442c-90c1-8e3de7400b8b', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:09:41', 21, 1002001012, '访问令牌已过期', '2019-05-31 16:09:41');
INSERT INTO `access_log` VALUES (15613, 'a82b49c7-d40c-4c6e-a0ac-d6390fef522d', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:09:41', 19, 1002001012, '访问令牌已过期', '2019-05-31 16:09:41');
INSERT INTO `access_log` VALUES (15614, '2af37fb7-01fe-4f53-9c5f-e2b4f26b6a72', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:09:41', 82, 1002001012, '访问令牌已过期', '2019-05-31 16:09:41');
INSERT INTO `access_log` VALUES (15615, '65.48.15592901106912035', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:08:31', 0, 1002001015, '账号未登陆', '2019-05-31 16:08:31');
INSERT INTO `access_log` VALUES (15616, '65.46.15592901106942019', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:08:31', 0, 1002001015, '账号未登陆', '2019-05-31 16:08:31');
INSERT INTO `access_log` VALUES (15617, '65.50.15592901106952035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:08:31', 1, 1002001015, '账号未登陆', '2019-05-31 16:08:31');
INSERT INTO `access_log` VALUES (15618, '65.52.15592901129962019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:08:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 16:08:33');
INSERT INTO `access_log` VALUES (15619, '65.49.15592901324802035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:08:52', 76, 0, '', '2019-05-31 16:08:53');
INSERT INTO `access_log` VALUES (15620, '65.54.15592901328662013', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:08:53', 66, 0, '', '2019-05-31 16:08:53');
INSERT INTO `access_log` VALUES (15621, '65.51.15592901328702025', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:08:53', 62, 0, '', '2019-05-31 16:08:53');
INSERT INTO `access_log` VALUES (15622, '65.45.15592901328652041', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:08:53', 67, 0, '', '2019-05-31 16:08:53');
INSERT INTO `access_log` VALUES (15623, '64.82.15592901417072003', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:09:02', 9, 0, '', '2019-05-31 16:09:02');
INSERT INTO `access_log` VALUES (15624, '64.76.15592901417031995', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:09:02', 14, 0, '', '2019-05-31 16:09:02');
INSERT INTO `access_log` VALUES (15625, '64.78.15592901439872001', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:09:04', 9, 0, '', '2019-05-31 16:09:04');
INSERT INTO `access_log` VALUES (15626, '64.85.15592901439822001', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:09:04', 15, 0, '', '2019-05-31 16:09:04');
INSERT INTO `access_log` VALUES (15627, '64.83.15592901493861993', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:09:09', 11, 0, '', '2019-05-31 16:09:09');
INSERT INTO `access_log` VALUES (15628, '64.77.15592901493861999', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:09:09', 12, 0, '', '2019-05-31 16:09:09');
INSERT INTO `access_log` VALUES (15629, '65.48.15592901539252037', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:09:14', 21, 0, '', '2019-05-31 16:09:14');
INSERT INTO `access_log` VALUES (15630, '65.50.15592901565352037', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:09:17', 13, 0, '', '2019-05-31 16:09:17');
INSERT INTO `access_log` VALUES (15631, '65.53.15592901670952015', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:09:27', 8, 0, '', '2019-05-31 16:09:27');
INSERT INTO `access_log` VALUES (15632, 'cd729432-7e17-4784-a6ec-b8e90b79f859', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:10:48', 117, 0, '', '2019-05-31 16:10:48');
INSERT INTO `access_log` VALUES (15633, '65.49.15592901699992037', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:09:30', 12, 0, '', '2019-05-31 16:09:30');
INSERT INTO `access_log` VALUES (15634, 'ec0e77b8-7404-4287-a81c-bd20d37e5436', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:10:51', 43, 0, '', '2019-05-31 16:10:51');
INSERT INTO `access_log` VALUES (15635, 'f4dbe0ce-df79-45d1-a106-4d8d3bcfac0d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:10:51', 39, 0, '', '2019-05-31 16:10:51');
INSERT INTO `access_log` VALUES (15636, 'a92c39c8-0f48-43d9-b1a0-781bb337cc7a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:10:51', 51, 0, '', '2019-05-31 16:10:51');
INSERT INTO `access_log` VALUES (15637, '65.51.15592901771772027', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:09:37', 10, 0, '', '2019-05-31 16:09:37');
INSERT INTO `access_log` VALUES (15638, '5476cc05-fc28-47e2-a817-0ec3b0f750de', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:10:57', 105, 0, '', '2019-05-31 16:10:57');
INSERT INTO `access_log` VALUES (15639, '65.45.15592901929072043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:09:53', 15, 0, '', '2019-05-31 16:09:53');
INSERT INTO `access_log` VALUES (15640, '62.81.15592902890132519', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:11:29', 15, 0, '', '2019-05-31 16:11:29');
INSERT INTO `access_log` VALUES (15641, '65.51.15592902918972029', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:11:32', 19, 0, '', '2019-05-31 16:11:32');
INSERT INTO `access_log` VALUES (15642, '65.54.15592902943772017', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:11:34', 10, 0, '', '2019-05-31 16:11:34');
INSERT INTO `access_log` VALUES (15643, '65.45.15592902950222045', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:11:35', 10, 0, '', '2019-05-31 16:11:35');
INSERT INTO `access_log` VALUES (15644, '64.84.15592903003122003', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:11:40', 10, 0, '', '2019-05-31 16:11:40');
INSERT INTO `access_log` VALUES (15645, '64.81.15592903003081993', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.66.223', '2019-05-31 16:11:40', 13, 0, '', '2019-05-31 16:11:40');
INSERT INTO `access_log` VALUES (15646, '4541cb75-9623-434f-874a-a88491c8febc', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:14:23', 47, 0, '', '2019-05-31 16:14:23');
INSERT INTO `access_log` VALUES (15647, '59cd55bd-b137-4eea-a2c9-099df4936f42', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:14:23', 50, 0, '', '2019-05-31 16:14:23');
INSERT INTO `access_log` VALUES (15648, '3febf3c1-4ae0-487b-9c64-7240c7ebe90e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:14:23', 50, 0, '', '2019-05-31 16:14:23');
INSERT INTO `access_log` VALUES (15649, '2b110911-b645-4258-895d-abcd4df7847d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:15:32', 48, 0, '', '2019-05-31 16:15:32');
INSERT INTO `access_log` VALUES (15650, 'bfb45477-90f3-4257-b5c4-edbf10fb5c0b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:15:32', 49, 0, '', '2019-05-31 16:15:32');
INSERT INTO `access_log` VALUES (15651, 'c1fbb047-4db0-4966-b29e-086f212b4230', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:15:32', 49, 0, '', '2019-05-31 16:15:32');
INSERT INTO `access_log` VALUES (15652, '70408fd6-8780-4657-ae5a-81b425a53622', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:15:32', 138, 0, '', '2019-05-31 16:15:32');
INSERT INTO `access_log` VALUES (15653, '6765e116-f06d-4226-a446-aa13186f9129', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:15:34', 34, 0, '', '2019-05-31 16:15:34');
INSERT INTO `access_log` VALUES (15654, '41490bc0-fa0b-4174-89d3-8a83a2cce0ab', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:15:34', 43, 0, '', '2019-05-31 16:15:34');
INSERT INTO `access_log` VALUES (15655, '82fe0c2f-3dd3-4d54-90dd-454101e1ed34', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:15:34', 37, 0, '', '2019-05-31 16:15:34');
INSERT INTO `access_log` VALUES (15656, 'c91aed0a-1a99-4fc6-8793-5a70f6f9820d', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:15:34', 224, 0, '', '2019-05-31 16:15:35');
INSERT INTO `access_log` VALUES (15657, '64ad3421-e70c-4108-8422-a93184243757', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:17:48', 246, 0, '', '2019-05-31 16:17:48');
INSERT INTO `access_log` VALUES (15658, '61e66116-c6d1-4c15-836d-351696e55758', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:17:48', 248, 0, '', '2019-05-31 16:17:48');
INSERT INTO `access_log` VALUES (15659, '594d2608-38d5-4ef6-99f8-a69d66df28cf', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:17:48', 247, 0, '', '2019-05-31 16:17:48');
INSERT INTO `access_log` VALUES (15660, 'b440cf5c-82fd-45da-9809-962d112ecb69', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:18:16', 39, 0, '', '2019-05-31 16:18:16');
INSERT INTO `access_log` VALUES (15661, '27b6417b-5a2d-4700-9d9a-1fd3caf00fcd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:18:16', 42, 0, '', '2019-05-31 16:18:16');
INSERT INTO `access_log` VALUES (15662, 'd5e4f71f-459a-45fe-942c-ec0afb2b310b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:18:16', 51, 0, '', '2019-05-31 16:18:16');
INSERT INTO `access_log` VALUES (15663, '8bc8b115-4cbd-4777-aca5-0aaed5c74d4e', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:18:16', 123, 0, '', '2019-05-31 16:18:16');
INSERT INTO `access_log` VALUES (15664, '1337208a-f3c1-4a8f-aa6b-cbc2175b965a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:18:20', 41, 0, '', '2019-05-31 16:18:20');
INSERT INTO `access_log` VALUES (15665, 'eb3ff5a7-291c-4728-9b98-8eafaf76cb46', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:18:20', 36, 0, '', '2019-05-31 16:18:20');
INSERT INTO `access_log` VALUES (15666, '46762d18-4e7f-462b-9552-454ecc9295ad', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:18:20', 102, 0, '', '2019-05-31 16:18:20');
INSERT INTO `access_log` VALUES (15667, '274e2277-a1c1-4723-aff0-795d1af280c5', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:18:20', 56, 0, '', '2019-05-31 16:18:21');
INSERT INTO `access_log` VALUES (15668, '65.50.15592906403992045', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:17:20', 1, 1002001015, '账号未登陆', '2019-05-31 16:17:20');
INSERT INTO `access_log` VALUES (15669, '65.52.15592906404092029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:17:20', 0, 1002001015, '账号未登陆', '2019-05-31 16:17:20');
INSERT INTO `access_log` VALUES (15670, '65.53.15592906404232023', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:17:20', 0, 1002001015, '账号未登陆', '2019-05-31 16:17:20');
INSERT INTO `access_log` VALUES (15671, '65.49.15592906438202045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:17:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 16:17:24');
INSERT INTO `access_log` VALUES (15672, '65.54.15592906481422023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:17:28', 91, 0, '', '2019-05-31 16:17:28');
INSERT INTO `access_log` VALUES (15673, '65.45.15592906489152051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:17:29', 10, 0, '', '2019-05-31 16:17:29');
INSERT INTO `access_log` VALUES (15674, '65.47.15592906489182047', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:17:29', 9, 0, '', '2019-05-31 16:17:29');
INSERT INTO `access_log` VALUES (15675, '65.46.15592906489222031', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:17:29', 10, 0, '', '2019-05-31 16:17:29');
INSERT INTO `access_log` VALUES (15676, '62.89.15592906548732535', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:17:35', 14, 0, '', '2019-05-31 16:17:35');
INSERT INTO `access_log` VALUES (15677, '64.85.15592906596352009', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:17:40', 13, 0, '', '2019-05-31 16:17:40');
INSERT INTO `access_log` VALUES (15678, '64.80.15592906596391999', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:17:40', 9, 0, '', '2019-05-31 16:17:40');
INSERT INTO `access_log` VALUES (15679, '65.50.15592906673272047', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:17:47', 20, 0, '', '2019-05-31 16:17:47');
INSERT INTO `access_log` VALUES (15680, '65.52.15592906715342031', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:17:52', 150, 0, '', '2019-05-31 16:17:52');
INSERT INTO `access_log` VALUES (15681, '65.49.15592906739892047', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:17:54', 49, 0, '', '2019-05-31 16:17:54');
INSERT INTO `access_log` VALUES (15682, '65.51.15592906839992037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:18:04', 14, 0, '', '2019-05-31 16:18:04');
INSERT INTO `access_log` VALUES (15683, '59.76.15592906905152623', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:18:11', 14, 0, '', '2019-05-31 16:18:11');
INSERT INTO `access_log` VALUES (15684, '59.74.15592906929062627', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:18:13', 27, 2001001000, '服务端发生异常', '2019-05-31 16:18:13');
INSERT INTO `access_log` VALUES (15685, '65.46.15592906953112033', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:18:15', 10, 0, '', '2019-05-31 16:18:15');
INSERT INTO `access_log` VALUES (15686, '65.45.15592906968592053', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:18:17', 9, 0, '', '2019-05-31 16:18:17');
INSERT INTO `access_log` VALUES (15687, '65.47.15592906988142049', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:18:19', 15, 0, '', '2019-05-31 16:18:19');
INSERT INTO `access_log` VALUES (15688, '64.79.15592907029601999', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:18:23', 9, 0, '', '2019-05-31 16:18:23');
INSERT INTO `access_log` VALUES (15689, '64.81.15592907029581999', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.92.11.171', '2019-05-31 16:18:23', 11, 0, '', '2019-05-31 16:18:23');
INSERT INTO `access_log` VALUES (15690, '0e0b946d-c60e-426d-ae1e-549b381b0342', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:25:12', 92, 0, '', '2019-05-31 16:25:12');
INSERT INTO `access_log` VALUES (15691, '59.71.15592910426192633', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.249.137.230', '2019-05-31 16:24:03', 5, 0, '', '2019-05-31 16:24:03');
INSERT INTO `access_log` VALUES (15692, '59.78.15592910426192637', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.249.137.230', '2019-05-31 16:24:03', 14, 2001001000, '服务端发生异常', '2019-05-31 16:24:03');
INSERT INTO `access_log` VALUES (15693, '64.85.15592910498072015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.249.137.230', '2019-05-31 16:24:10', 3, 0, '', '2019-05-31 16:24:10');
INSERT INTO `access_log` VALUES (15694, '64.80.15592910499612005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.249.137.230', '2019-05-31 16:24:10', 3, 0, '', '2019-05-31 16:24:10');
INSERT INTO `access_log` VALUES (15695, '64.77.15592910556922013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.249.137.230', '2019-05-31 16:24:16', 2, 0, '', '2019-05-31 16:24:16');
INSERT INTO `access_log` VALUES (15696, '64.83.15592910558412007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.249.137.230', '2019-05-31 16:24:16', 2, 0, '', '2019-05-31 16:24:16');
INSERT INTO `access_log` VALUES (15697, '59.72.15592910572282629', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.249.137.230', '2019-05-31 16:24:17', 3, 0, '', '2019-05-31 16:24:17');
INSERT INTO `access_log` VALUES (15698, '59.73.15592910572282633', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.249.137.230', '2019-05-31 16:24:17', 13, 2001001000, '服务端发生异常', '2019-05-31 16:24:17');
INSERT INTO `access_log` VALUES (15699, '64.84.15592910603262015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.249.137.230', '2019-05-31 16:24:20', 2, 0, '', '2019-05-31 16:24:20');
INSERT INTO `access_log` VALUES (15700, '64.79.15592910604882005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.249.137.230', '2019-05-31 16:24:20', 2, 0, '', '2019-05-31 16:24:20');
INSERT INTO `access_log` VALUES (15701, '64.82.15592910616292019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.249.137.230', '2019-05-31 16:24:22', 3, 0, '', '2019-05-31 16:24:22');
INSERT INTO `access_log` VALUES (15702, '64.76.15592910625022011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.249.137.230', '2019-05-31 16:24:23', 12, 0, '', '2019-05-31 16:24:23');
INSERT INTO `access_log` VALUES (15703, 'd7f76b06-e6b3-47d0-ab6c-2f16b9dc5ebd', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:26:12', 47, 0, '', '2019-05-31 16:26:12');
INSERT INTO `access_log` VALUES (15704, '8ff96933-7dcf-4659-86a7-6b2f03eff1bd', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:26:35', 39, 0, '', '2019-05-31 16:26:35');
INSERT INTO `access_log` VALUES (15705, 'c2290bf5-7792-442f-970c-3b635b0e851a', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:26:36', 407, 0, '', '2019-05-31 16:26:37');
INSERT INTO `access_log` VALUES (15706, '51433863-fa20-4e6a-9100-6fe0243a5836', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:26:42', 35, 0, '', '2019-05-31 16:26:42');
INSERT INTO `access_log` VALUES (15707, '9a7a65df-5378-477e-910b-daf3f073c54f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:26:42', 36, 0, '', '2019-05-31 16:26:42');
INSERT INTO `access_log` VALUES (15708, 'a8341861-2470-4e09-a475-7c39a18f5144', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:26:42', 37, 0, '', '2019-05-31 16:26:42');
INSERT INTO `access_log` VALUES (15709, '1d73833f-73b5-4822-8c09-acb34766648d', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:26:42', 44, 0, '', '2019-05-31 16:26:42');
INSERT INTO `access_log` VALUES (15710, '59.76.15592911971142631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.4.40.69', '2019-05-31 16:26:37', 4, 0, '', '2019-05-31 16:26:37');
INSERT INTO `access_log` VALUES (15711, '59.74.15592911971142635', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.4.40.69', '2019-05-31 16:26:37', 17, 2001001000, '服务端发生异常', '2019-05-31 16:26:37');
INSERT INTO `access_log` VALUES (15712, '59.79.15592912033172633', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.4.40.69', '2019-05-31 16:26:43', 7, 0, '', '2019-05-31 16:26:43');
INSERT INTO `access_log` VALUES (15713, '59.75.15592912033172635', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.4.40.69', '2019-05-31 16:26:43', 16, 2001001000, '服务端发生异常', '2019-05-31 16:26:43');
INSERT INTO `access_log` VALUES (15714, '64.76.15592912057642013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.4.40.69', '2019-05-31 16:26:46', 272, 0, '', '2019-05-31 16:26:46');
INSERT INTO `access_log` VALUES (15715, '64.78.15592912061802019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.4.40.69', '2019-05-31 16:26:46', 2, 0, '', '2019-05-31 16:26:46');
INSERT INTO `access_log` VALUES (15716, '64.85.15592912092602019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.4.40.69', '2019-05-31 16:26:49', 3, 0, '', '2019-05-31 16:26:49');
INSERT INTO `access_log` VALUES (15717, '64.80.15592912094112009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.4.40.69', '2019-05-31 16:26:49', 3, 0, '', '2019-05-31 16:26:49');
INSERT INTO `access_log` VALUES (15718, '90d2d861-2af0-4121-ba90-5860128d386a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:31:50', 269, 0, '', '2019-05-31 16:31:50');
INSERT INTO `access_log` VALUES (15719, 'd9f3ae97-27ac-46d9-82af-e6f5a7d951ab', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:31:50', 265, 0, '', '2019-05-31 16:31:50');
INSERT INTO `access_log` VALUES (15720, 'f2fac16d-081b-4e8c-b397-57cb153f8017', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:31:50', 285, 0, '', '2019-05-31 16:31:50');
INSERT INTO `access_log` VALUES (15721, 'f748128b-596d-4f4a-b34d-ea00e24db82b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:35:29', 41, 0, '', '2019-05-31 16:35:29');
INSERT INTO `access_log` VALUES (15722, '76701849-6459-45dc-a00d-c7e04950ce75', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:35:29', 44, 0, '', '2019-05-31 16:35:29');
INSERT INTO `access_log` VALUES (15723, '3c0c1c44-0bc2-4e79-838c-9885b55bf5b0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:35:29', 53, 0, '', '2019-05-31 16:35:29');
INSERT INTO `access_log` VALUES (15724, '3e5fc6c2-0295-41d5-a488-305b7a18b035', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:35:30', 41, 0, '', '2019-05-31 16:35:30');
INSERT INTO `access_log` VALUES (15725, '2d4b88d4-be17-45f9-b23b-3fcb0c9589da', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:35:30', 48, 0, '', '2019-05-31 16:35:30');
INSERT INTO `access_log` VALUES (15726, '17852c28-c311-4104-8f05-491bf418538e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:35:30', 55, 0, '', '2019-05-31 16:35:30');
INSERT INTO `access_log` VALUES (15727, '41265147-467f-4d7d-865b-8d789c7303ca', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:35:30', 119, 0, '', '2019-05-31 16:35:30');
INSERT INTO `access_log` VALUES (15728, '978a9ac0-74ce-42d6-b2f6-39a92347d2f8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:35:30', 30, 0, '', '2019-05-31 16:35:30');
INSERT INTO `access_log` VALUES (15729, '0bc3d857-a663-445d-b491-b990fd7eaa72', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:35:30', 35, 0, '', '2019-05-31 16:35:31');
INSERT INTO `access_log` VALUES (15730, '3962d04f-99eb-4c39-8049-6f56aebd2618', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:35:30', 40, 0, '', '2019-05-31 16:35:31');
INSERT INTO `access_log` VALUES (15731, 'b408a0d7-0c72-451c-ac4d-3faceaaf8d5a', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:35:31', 57, 0, '', '2019-05-31 16:35:31');
INSERT INTO `access_log` VALUES (15732, '4c26746e-e331-4d8e-9b88-4bfa45ea5106', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:35:31', 35, 0, '', '2019-05-31 16:35:31');
INSERT INTO `access_log` VALUES (15733, '702bf245-ac50-42d3-b7a3-c62229269eb6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:35:31', 37, 0, '', '2019-05-31 16:35:31');
INSERT INTO `access_log` VALUES (15734, 'ef997922-ada6-4b15-b23b-b9f5be5d2918', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:35:31', 35, 0, '', '2019-05-31 16:35:31');
INSERT INTO `access_log` VALUES (15735, '18821593-6c16-4498-8dd8-231e771365bb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:37:10', 48, 0, '', '2019-05-31 16:37:10');
INSERT INTO `access_log` VALUES (15736, '5254b898-d596-4563-88f2-3f63ead13993', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:37:10', 55, 0, '', '2019-05-31 16:37:10');
INSERT INTO `access_log` VALUES (15737, '3e801a65-ae39-48c9-a17d-f272f793e29c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:37:10', 55, 0, '', '2019-05-31 16:37:10');
INSERT INTO `access_log` VALUES (15738, '4a0c0765-472a-4d3e-90d5-24653323ccc9', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:37:11', 122, 0, '', '2019-05-31 16:37:11');
INSERT INTO `access_log` VALUES (15739, '210903f8-7cc3-435c-adba-c7588404bbe5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:37:28', 38, 0, '', '2019-05-31 16:37:28');
INSERT INTO `access_log` VALUES (15740, '5170e18a-3062-4a5a-845b-0567e2448553', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:37:28', 42, 0, '', '2019-05-31 16:37:28');
INSERT INTO `access_log` VALUES (15741, '89995cee-8d35-4987-b16c-d36c6a4c65aa', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:37:28', 38, 0, '', '2019-05-31 16:37:28');
INSERT INTO `access_log` VALUES (15742, '3eb94f17-8511-46e2-8579-218e6ee42108', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:37:28', 56, 0, '', '2019-05-31 16:37:29');
INSERT INTO `access_log` VALUES (15743, '10d6aefc-b36a-4347-b46f-acf64f1d4e15', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:38:19', 36, 0, '', '2019-05-31 16:38:19');
INSERT INTO `access_log` VALUES (15744, 'e3bf0446-c068-4213-ba72-b8c815f30ab7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:38:19', 37, 0, '', '2019-05-31 16:38:19');
INSERT INTO `access_log` VALUES (15745, '80220b60-9c73-4f72-b43d-114732f07eab', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:38:19', 34, 0, '', '2019-05-31 16:38:19');
INSERT INTO `access_log` VALUES (15746, '15b5e40d-c268-4b75-9628-b3e93016c5f1', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:38:20', 67, 0, '', '2019-05-31 16:38:20');
INSERT INTO `access_log` VALUES (15747, '4cac2f1c-729e-4241-a720-5b2884ebaeeb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:38:21', 35, 0, '', '2019-05-31 16:38:21');
INSERT INTO `access_log` VALUES (15748, 'ac6bca68-46e6-4ac3-b6a1-f355c67f8121', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:38:21', 40, 0, '', '2019-05-31 16:38:21');
INSERT INTO `access_log` VALUES (15749, 'fa151df3-5267-4ee2-8155-7ea907772b47', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:38:21', 34, 0, '', '2019-05-31 16:38:21');
INSERT INTO `access_log` VALUES (15750, '7d24dc11-d96f-4df9-8d80-a8fe5c760c92', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:38:21', 50, 0, '', '2019-05-31 16:38:21');
INSERT INTO `access_log` VALUES (15751, '4e8e6dd0-c094-48d0-a23c-ac260492e23f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:38:38', 34, 0, '', '2019-05-31 16:38:38');
INSERT INTO `access_log` VALUES (15752, 'a112b66e-e913-4108-a3ad-a989be9bfedd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:38:38', 44, 0, '', '2019-05-31 16:38:38');
INSERT INTO `access_log` VALUES (15753, 'b9d5b7b3-1c26-4fe2-986a-24e985677f36', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:38:38', 56, 0, '', '2019-05-31 16:38:38');
INSERT INTO `access_log` VALUES (15754, '9215347d-5c9e-4c90-86c8-eb8c4ec6018a', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:38:39', 49, 0, '', '2019-05-31 16:38:39');
INSERT INTO `access_log` VALUES (15755, '3e00d9b1-9f82-4ca5-83c3-bd246b30a640', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:39:02', 42, 0, '', '2019-05-31 16:39:02');
INSERT INTO `access_log` VALUES (15756, '312521e6-ad88-45e1-b1e2-6ceab3029b51', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:39:02', 44, 0, '', '2019-05-31 16:39:02');
INSERT INTO `access_log` VALUES (15757, '1dcc73c1-8195-49f6-87a5-f45c5356b20a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:39:02', 49, 0, '', '2019-05-31 16:39:02');
INSERT INTO `access_log` VALUES (15758, '48d39d48-8b5c-4cfa-ad6c-c5f4afe6c6c4', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:39:02', 85, 0, '', '2019-05-31 16:39:02');
INSERT INTO `access_log` VALUES (15759, 'b4cdbea3-1698-485e-83d4-1189dc8ea015', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:39:10', 46, 0, '', '2019-05-31 16:39:10');
INSERT INTO `access_log` VALUES (15760, '818aefc9-5ba7-43aa-8fb9-de585d0d41c6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:39:30', 46, 0, '', '2019-05-31 16:39:30');
INSERT INTO `access_log` VALUES (15761, 'e1964baf-a5e4-4b3b-bda8-229daeb537bf', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:39:30', 46, 0, '', '2019-05-31 16:39:30');
INSERT INTO `access_log` VALUES (15762, 'd7ec77d0-92db-49c3-8aae-825ed6da30d0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:39:33', 47, 0, '', '2019-05-31 16:39:33');
INSERT INTO `access_log` VALUES (15763, '631b2886-d5f9-4d22-b489-074632299fe8', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:39:33', 75, 0, '', '2019-05-31 16:39:33');
INSERT INTO `access_log` VALUES (15764, '7af69b04-3fa3-4280-afe7-3301436ae68d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:39:36', 50, 0, '', '2019-05-31 16:39:36');
INSERT INTO `access_log` VALUES (15765, '7eb9f2e6-acda-4829-8145-014e15c06328', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:39:36', 50, 0, '', '2019-05-31 16:39:36');
INSERT INTO `access_log` VALUES (15766, 'c828849d-d03b-4505-b324-78aa8eadb718', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:39:36', 54, 0, '', '2019-05-31 16:39:36');
INSERT INTO `access_log` VALUES (15767, '49336447-9fa4-43ca-a701-efac8f57136a', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:39:36', 83, 0, '', '2019-05-31 16:39:36');
INSERT INTO `access_log` VALUES (15768, '65.51.15592919358932055', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.97.217.187', '2019-05-31 16:38:56', 1, 1002001015, '账号未登陆', '2019-05-31 16:38:56');
INSERT INTO `access_log` VALUES (15769, '65.49.15592919358942067', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.97.217.187', '2019-05-31 16:38:56', 1, 1002001015, '账号未登陆', '2019-05-31 16:38:56');
INSERT INTO `access_log` VALUES (15770, '65.47.15592919359252067', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.97.217.187', '2019-05-31 16:38:56', 0, 1002001015, '账号未登陆', '2019-05-31 16:38:56');
INSERT INTO `access_log` VALUES (15771, '65.46.15592919393962053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.97.217.187', '2019-05-31 16:38:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 16:38:59');
INSERT INTO `access_log` VALUES (15772, '65.48.15592919426702067', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.97.217.187', '2019-05-31 16:39:03', 103, 0, '', '2019-05-31 16:39:03');
INSERT INTO `access_log` VALUES (15773, '65.52.15592919430162049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.97.217.187', '2019-05-31 16:39:03', 9, 0, '', '2019-05-31 16:39:03');
INSERT INTO `access_log` VALUES (15774, '65.45.15592919430172073', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.97.217.187', '2019-05-31 16:39:03', 8, 0, '', '2019-05-31 16:39:03');
INSERT INTO `access_log` VALUES (15775, '65.50.15592919430212067', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.97.217.187', '2019-05-31 16:39:03', 11, 0, '', '2019-05-31 16:39:03');
INSERT INTO `access_log` VALUES (15776, '64.77.15592919468372027', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.97.217.187', '2019-05-31 16:39:07', 13, 0, '', '2019-05-31 16:39:07');
INSERT INTO `access_log` VALUES (15777, '64.83.15592919468412021', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.97.217.187', '2019-05-31 16:39:07', 10, 0, '', '2019-05-31 16:39:07');
INSERT INTO `access_log` VALUES (15778, 'bead4058-0fda-457d-989e-eb60204d6470', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:40:31', 50, 0, '', '2019-05-31 16:40:31');
INSERT INTO `access_log` VALUES (15779, '64.81.15592919704742019', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.97.217.187', '2019-05-31 16:39:30', 7, 1002002009, NULL, '2019-05-31 16:39:30');
INSERT INTO `access_log` VALUES (15780, '3246f9cb-25f1-4367-ac2d-2e8179d603ff', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:41:08', 45, 0, '', '2019-05-31 16:41:08');
INSERT INTO `access_log` VALUES (15781, '76ebea4e-b2c8-4393-aca5-9e5d03ae5da7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:41:08', 46, 0, '', '2019-05-31 16:41:08');
INSERT INTO `access_log` VALUES (15782, '058d1537-4335-4a09-ad7b-51951ef5f197', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:41:08', 50, 0, '', '2019-05-31 16:41:08');
INSERT INTO `access_log` VALUES (15783, '78574e1a-113e-4bcd-bd30-f7799f701ac4', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:41:08', 64, 0, '', '2019-05-31 16:41:08');
INSERT INTO `access_log` VALUES (15784, '59.72.15592920221552643', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:40:22', 4, 0, '', '2019-05-31 16:40:22');
INSERT INTO `access_log` VALUES (15785, '59.74.15592920221552647', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:40:22', 12, 2001001000, '服务端发生异常', '2019-05-31 16:40:22');
INSERT INTO `access_log` VALUES (15786, '64.85.15592920244142031', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=444', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.97.217.187', '2019-05-31 16:40:24', 8, 1002002009, NULL, '2019-05-31 16:40:24');
INSERT INTO `access_log` VALUES (15787, '64.80.15592920253652021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:40:25', 2, 0, '', '2019-05-31 16:40:25');
INSERT INTO `access_log` VALUES (15788, '64.77.15592920254572029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:40:25', 2, 0, '', '2019-05-31 16:40:25');
INSERT INTO `access_log` VALUES (15789, '64.83.15592920267832023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:40:27', 2, 0, '', '2019-05-31 16:40:27');
INSERT INTO `access_log` VALUES (15790, '64.81.15592920275522021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:40:28', 162, 0, '', '2019-05-31 16:40:28');
INSERT INTO `access_log` VALUES (15791, '64.84.15592920275232031', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=555', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.97.217.187', '2019-05-31 16:40:28', 196, 1002002009, NULL, '2019-05-31 16:40:28');
INSERT INTO `access_log` VALUES (15792, '64.79.15592920282722021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:40:28', 2, 0, '', '2019-05-31 16:40:28');
INSERT INTO `access_log` VALUES (15793, '64.82.15592920315842035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-05-31 16:40:32', 3, 0, '', '2019-05-31 16:40:32');
INSERT INTO `access_log` VALUES (15794, '59.76.15592920328802643', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-05-31 16:40:33', 4, 0, '', '2019-05-31 16:40:33');
INSERT INTO `access_log` VALUES (15795, '59.79.15592920328802645', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-05-31 16:40:33', 65, 2001001000, '服务端发生异常', '2019-05-31 16:40:33');
INSERT INTO `access_log` VALUES (15796, '59.77.15592920383902643', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-05-31 16:40:38', 3, 0, '', '2019-05-31 16:40:38');
INSERT INTO `access_log` VALUES (15797, '59.71.15592920383902649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-05-31 16:40:38', 15, 2001001000, '服务端发生异常', '2019-05-31 16:40:38');
INSERT INTO `access_log` VALUES (15798, '59.80.15592920467232647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:40:47', 3, 0, '', '2019-05-31 16:40:47');
INSERT INTO `access_log` VALUES (15799, '59.78.15592920467222653', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:40:47', 13, 2001001000, '服务端发生异常', '2019-05-31 16:40:47');
INSERT INTO `access_log` VALUES (15800, '65.45.15592920482042075', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:40:48', 0, 1002001015, '账号未登陆', '2019-05-31 16:40:48');
INSERT INTO `access_log` VALUES (15801, '65.52.15592920482142051', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:40:48', 1, 1002001015, '账号未登陆', '2019-05-31 16:40:48');
INSERT INTO `access_log` VALUES (15802, '65.50.15592920482192069', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:40:48', 0, 1002001015, '账号未登陆', '2019-05-31 16:40:48');
INSERT INTO `access_log` VALUES (15803, '65.54.15592920505662047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:40:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 16:40:51');
INSERT INTO `access_log` VALUES (15804, '64.85.15592920524342033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '125.46.74.93', '2019-05-31 16:40:52', 3, 0, '', '2019-05-31 16:40:52');
INSERT INTO `access_log` VALUES (15805, '64.80.15592920525322023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '125.46.74.93', '2019-05-31 16:40:53', 3, 0, '', '2019-05-31 16:40:53');
INSERT INTO `access_log` VALUES (15806, '65.53.15592920533942049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:40:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 16:40:53');
INSERT INTO `access_log` VALUES (15807, '64.77.15592920547042031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '125.46.74.93', '2019-05-31 16:40:55', 2, 0, '', '2019-05-31 16:40:55');
INSERT INTO `access_log` VALUES (15808, '64.83.15592920548292025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '125.46.74.93', '2019-05-31 16:40:55', 3, 0, '', '2019-05-31 16:40:55');
INSERT INTO `access_log` VALUES (15809, '59.72.15592920563702645', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '125.46.74.93', '2019-05-31 16:40:56', 3, 0, '', '2019-05-31 16:40:56');
INSERT INTO `access_log` VALUES (15810, '59.74.15592920564122649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '125.46.74.93', '2019-05-31 16:40:56', 13, 2001001000, '服务端发生异常', '2019-05-31 16:40:56');
INSERT INTO `access_log` VALUES (15811, '64.81.15592920630642023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:03', 2, 0, '', '2019-05-31 16:41:03');
INSERT INTO `access_log` VALUES (15812, '65.47.15592920656442071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:41:06', 213, 0, '', '2019-05-31 16:41:06');
INSERT INTO `access_log` VALUES (15813, '65.51.15592920661902059', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:41:06', 10, 0, '', '2019-05-31 16:41:06');
INSERT INTO `access_log` VALUES (15814, '65.46.15592920661952057', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:41:06', 9, 0, '', '2019-05-31 16:41:06');
INSERT INTO `access_log` VALUES (15815, '65.48.15592920662032071', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:41:06', 8, 0, '', '2019-05-31 16:41:06');
INSERT INTO `access_log` VALUES (15816, '62.88.15592920704012557', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:41:10', 105, 0, '', '2019-05-31 16:41:11');
INSERT INTO `access_log` VALUES (15817, '65.52.15592920759522053', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:16', 1, 1002001015, '账号未登陆', '2019-05-31 16:41:16');
INSERT INTO `access_log` VALUES (15818, '65.50.15592920759562071', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:16', 1, 1002001015, '账号未登陆', '2019-05-31 16:41:16');
INSERT INTO `access_log` VALUES (15819, '65.54.15592920759562049', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:16', 1, 1002001015, '账号未登陆', '2019-05-31 16:41:16');
INSERT INTO `access_log` VALUES (15820, '65.53.15592920760002051', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:41:16', 29, 0, '', '2019-05-31 16:41:16');
INSERT INTO `access_log` VALUES (15821, '65.49.15592920783942073', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:18', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 16:41:18');
INSERT INTO `access_log` VALUES (15822, '65.47.15592920785032073', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:41:19', 11, 0, '', '2019-05-31 16:41:19');
INSERT INTO `access_log` VALUES (15823, '65.51.15592920808762061', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:41:21', 8, 0, '', '2019-05-31 16:41:21');
INSERT INTO `access_log` VALUES (15824, '65.48.15592920831292073', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:41:23', 13, 0, '', '2019-05-31 16:41:23');
INSERT INTO `access_log` VALUES (15825, '65.45.15592920843192079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 16:41:24');
INSERT INTO `access_log` VALUES (15826, '65.54.15592920847412051', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:41:25', 3, 1002001012, '访问令牌已过期', '2019-05-31 16:41:25');
INSERT INTO `access_log` VALUES (15827, '65.50.15592920847632073', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:41:25', 3, 1002001012, '访问令牌已过期', '2019-05-31 16:41:25');
INSERT INTO `access_log` VALUES (15828, '65.52.15592920847662055', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:41:25', 3, 1002001012, '访问令牌已过期', '2019-05-31 16:41:25');
INSERT INTO `access_log` VALUES (15829, '65.53.15592920886882053', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:41:29', 10, 0, '', '2019-05-31 16:41:29');
INSERT INTO `access_log` VALUES (15830, '65.49.15592920896742075', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.245.2', '2019-05-31 16:41:30', 11, 0, '', '2019-05-31 16:41:30');
INSERT INTO `access_log` VALUES (15831, '65.47.15592920901672075', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:41:30', 68, 0, '', '2019-05-31 16:41:30');
INSERT INTO `access_log` VALUES (15832, '65.51.15592920904412063', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:41:30', 9, 0, '', '2019-05-31 16:41:30');
INSERT INTO `access_log` VALUES (15833, '65.48.15592920904482075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:41:30', 9, 0, '', '2019-05-31 16:41:30');
INSERT INTO `access_log` VALUES (15834, '65.46.15592920904512061', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:41:30', 8, 0, '', '2019-05-31 16:41:30');
INSERT INTO `access_log` VALUES (15835, '65.45.15592920910292081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:31', 107, 0, '', '2019-05-31 16:41:31');
INSERT INTO `access_log` VALUES (15836, '65.54.15592920915252053', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:32', 10, 0, '', '2019-05-31 16:41:32');
INSERT INTO `access_log` VALUES (15837, '65.50.15592920915352075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:32', 8, 0, '', '2019-05-31 16:41:32');
INSERT INTO `access_log` VALUES (15838, '65.52.15592920915682057', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:32', 10, 0, '', '2019-05-31 16:41:32');
INSERT INTO `access_log` VALUES (15839, '65.53.15592920958312055', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:36', 19, 0, '', '2019-05-31 16:41:36');
INSERT INTO `access_log` VALUES (15840, '65.49.15592920971912077', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:37', 10, 0, '', '2019-05-31 16:41:37');
INSERT INTO `access_log` VALUES (15841, '65.47.15592920982652077', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:38', 9, 0, '', '2019-05-31 16:41:38');
INSERT INTO `access_log` VALUES (15842, '62.89.15592920989082555', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:41:39', 45, 0, '', '2019-05-31 16:41:39');
INSERT INTO `access_log` VALUES (15843, '65.51.15592920988982065', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:39', 59, 0, '', '2019-05-31 16:41:39');
INSERT INTO `access_log` VALUES (15844, '59.71.15592921038132651', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:44', 20, 0, '', '2019-05-31 16:41:44');
INSERT INTO `access_log` VALUES (15845, '66.56.15592921062871583', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:46', 22, 0, '', '2019-05-31 16:41:46');
INSERT INTO `access_log` VALUES (15846, '64.78.15592921074592035', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:41:47', 9, 0, '', '2019-05-31 16:41:47');
INSERT INTO `access_log` VALUES (15847, '64.76.15592921074572029', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:41:47', 13, 0, '', '2019-05-31 16:41:47');
INSERT INTO `access_log` VALUES (15848, '64.77.15592921121432033', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:52', 10, 0, '', '2019-05-31 16:41:52');
INSERT INTO `access_log` VALUES (15849, '64.80.15592921121422025', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:41:52', 12, 0, '', '2019-05-31 16:41:52');
INSERT INTO `access_log` VALUES (15850, '65.45.15592921146772083', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-05-31 16:41:55', 19, 0, '', '2019-05-31 16:41:55');
INSERT INTO `access_log` VALUES (15851, '64.81.15592921262192025', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:42:06', 10, 0, '', '2019-05-31 16:42:06');
INSERT INTO `access_log` VALUES (15852, '64.82.15592921432162039', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:42:23', 9, 0, '', '2019-05-31 16:42:23');
INSERT INTO `access_log` VALUES (15853, '64.79.15592921432162025', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.3.6000', '125.46.74.93', '2019-05-31 16:42:23', 13, 0, '', '2019-05-31 16:42:23');
INSERT INTO `access_log` VALUES (15854, '69d66901-6e7d-46e1-a3f2-66645a031d73', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:43:46', 104, 0, '', '2019-05-31 16:43:46');
INSERT INTO `access_log` VALUES (15855, '2c658915-1b32-4491-aace-a7569c3a8baa', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:43:51', 65, 0, '', '2019-05-31 16:43:51');
INSERT INTO `access_log` VALUES (15856, '95d8ad5a-6aac-4467-bdd8-954028a64028', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:43:52', 51, 0, '', '2019-05-31 16:43:52');
INSERT INTO `access_log` VALUES (15857, 'e76b1d17-5161-4743-8d1a-50e9fc0f585c', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:43:53', 178, 0, '', '2019-05-31 16:43:53');
INSERT INTO `access_log` VALUES (15858, 'd543d349-41ff-4ab6-ba4b-ce04721c132b', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:43:53', 212, 0, '', '2019-05-31 16:43:53');
INSERT INTO `access_log` VALUES (15859, '0f117e7f-787e-410f-b239-d07e881cc8a2', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:43:57', 60, 0, '', '2019-05-31 16:43:57');
INSERT INTO `access_log` VALUES (15860, 'f91b86a2-f6d2-415e-be81-5cdfc59f73e7', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:44:03', 55, 0, '', '2019-05-31 16:44:03');
INSERT INTO `access_log` VALUES (15861, '59.76.15592921869002647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:43:07', 4, 0, '', '2019-05-31 16:43:07');
INSERT INTO `access_log` VALUES (15862, '59.79.15592921869002649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:43:07', 14, 2001001000, '服务端发生异常', '2019-05-31 16:43:07');
INSERT INTO `access_log` VALUES (15863, '65.47.15592922035432079', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:43:24', 1, 1002001015, '账号未登陆', '2019-05-31 16:43:24');
INSERT INTO `access_log` VALUES (15864, '65.48.15592922035492079', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:43:24', 1, 1002001015, '账号未登陆', '2019-05-31 16:43:24');
INSERT INTO `access_log` VALUES (15865, '65.51.15592922035502067', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:43:24', 0, 1002001015, '账号未登陆', '2019-05-31 16:43:24');
INSERT INTO `access_log` VALUES (15866, '65.45.15592922054702085', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:43:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 16:43:25');
INSERT INTO `access_log` VALUES (15867, '65.54.15592922163852057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:43:36', 101, 0, '', '2019-05-31 16:43:36');
INSERT INTO `access_log` VALUES (15868, '65.50.15592922166902079', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:43:37', 9, 0, '', '2019-05-31 16:43:37');
INSERT INTO `access_log` VALUES (15869, '65.52.15592922166932061', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:43:37', 9, 0, '', '2019-05-31 16:43:37');
INSERT INTO `access_log` VALUES (15870, '65.53.15592922166952059', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:43:37', 10, 0, '', '2019-05-31 16:43:37');
INSERT INTO `access_log` VALUES (15871, '62.86.15592922278772549', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:43:48', 15, 0, '', '2019-05-31 16:43:48');
INSERT INTO `access_log` VALUES (15872, '62.84.15592922334282553', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:43:53', 19, 0, '', '2019-05-31 16:43:53');
INSERT INTO `access_log` VALUES (15873, '64.84.15592922405142037', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:44:01', 10, 0, '', '2019-05-31 16:44:01');
INSERT INTO `access_log` VALUES (15874, '64.81.15592922405122027', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:44:01', 170, 0, '', '2019-05-31 16:44:01');
INSERT INTO `access_log` VALUES (15875, '64.78.15592922755672039', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:44:36', 10, 0, '', '2019-05-31 16:44:36');
INSERT INTO `access_log` VALUES (15876, '64.85.15592922755682039', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:44:36', 11, 0, '', '2019-05-31 16:44:36');
INSERT INTO `access_log` VALUES (15877, '64.77.15592922778002037', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:44:38', 11, 0, '', '2019-05-31 16:44:38');
INSERT INTO `access_log` VALUES (15878, '64.83.15592922778032031', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:44:38', 10, 0, '', '2019-05-31 16:44:38');
INSERT INTO `access_log` VALUES (15879, '64.80.15592922778002029', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:44:38', 15, 0, '', '2019-05-31 16:44:38');
INSERT INTO `access_log` VALUES (15880, '66.48.15592923015421595', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:45:02', 15, 0, '', '2019-05-31 16:45:02');
INSERT INTO `access_log` VALUES (15881, '59.76.15592923043912649', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:45:04', 14, 0, '', '2019-05-31 16:45:04');
INSERT INTO `access_log` VALUES (15882, '59.79.15592923083862651', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:45:08', 12, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-31 16:45:08');
INSERT INTO `access_log` VALUES (15883, '65.50.15592923114992081', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:45:12', 17, 0, '', '2019-05-31 16:45:12');
INSERT INTO `access_log` VALUES (15884, '65.52.15592923162062063', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:45:16', 11, 0, '', '2019-05-31 16:45:16');
INSERT INTO `access_log` VALUES (15885, '65.53.15592923172552061', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:45:17', 18, 0, '', '2019-05-31 16:45:17');
INSERT INTO `access_log` VALUES (15886, '65.47.15592923268112083', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:45:27', 14, 0, '', '2019-05-31 16:45:27');
INSERT INTO `access_log` VALUES (15887, '65.46.15592923521942069', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:45:52', 187, 0, '', '2019-05-31 16:45:52');
INSERT INTO `access_log` VALUES (15888, '65.51.15592923519162071', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:45:52', 465, 0, '', '2019-05-31 16:45:52');
INSERT INTO `access_log` VALUES (15889, '59.80.15592923526162653', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:45:53', 660, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-31 16:45:53');
INSERT INTO `access_log` VALUES (15890, '59.78.15592923527102659', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:45:53', 568, 0, '', '2019-05-31 16:45:53');
INSERT INTO `access_log` VALUES (15891, '66.53.15592923529021597', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:45:53', 381, 0, '', '2019-05-31 16:45:53');
INSERT INTO `access_log` VALUES (15892, '65.45.15592923522632089', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.233.54.255', '2019-05-31 16:45:52', 1022, 0, '', '2019-05-31 16:45:53');
INSERT INTO `access_log` VALUES (15893, '59.74.15592925331722657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.17.224.180', '2019-05-31 16:48:53', 3, 0, '', '2019-05-31 16:48:53');
INSERT INTO `access_log` VALUES (15894, '59.76.15592925331722653', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.17.224.180', '2019-05-31 16:48:53', 13, 2001001000, '服务端发生异常', '2019-05-31 16:48:53');
INSERT INTO `access_log` VALUES (15895, '65.49.15592925603032087', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.26.61', '2019-05-31 16:49:20', 1, 1002001015, '账号未登陆', '2019-05-31 16:49:20');
INSERT INTO `access_log` VALUES (15896, '65.47.15592925603052087', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.26.61', '2019-05-31 16:49:20', 0, 1002001015, '账号未登陆', '2019-05-31 16:49:20');
INSERT INTO `access_log` VALUES (15897, '65.48.15592925603062087', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.26.61', '2019-05-31 16:49:20', 0, 1002001015, '账号未登陆', '2019-05-31 16:49:20');
INSERT INTO `access_log` VALUES (15898, '65.46.15592925641942073', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.26.61', '2019-05-31 16:49:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 16:49:24');
INSERT INTO `access_log` VALUES (15899, '65.45.15592925710472093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.26.61', '2019-05-31 16:49:31', 85, 0, '', '2019-05-31 16:49:31');
INSERT INTO `access_log` VALUES (15900, '65.54.15592925713912065', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.26.61', '2019-05-31 16:49:31', 10, 0, '', '2019-05-31 16:49:31');
INSERT INTO `access_log` VALUES (15901, '65.50.15592925713932087', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.26.61', '2019-05-31 16:49:31', 10, 0, '', '2019-05-31 16:49:31');
INSERT INTO `access_log` VALUES (15902, '65.52.15592925713982069', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.26.61', '2019-05-31 16:49:31', 9, 0, '', '2019-05-31 16:49:31');
INSERT INTO `access_log` VALUES (15903, '62.80.15592925831642565', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.26.61', '2019-05-31 16:49:43', 15, 0, '', '2019-05-31 16:49:43');
INSERT INTO `access_log` VALUES (15904, '59.80.15592926056362657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:50:06', 4, 0, '', '2019-05-31 16:50:06');
INSERT INTO `access_log` VALUES (15905, '59.73.15592926056392659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:50:06', 12, 2001001000, '服务端发生异常', '2019-05-31 16:50:06');
INSERT INTO `access_log` VALUES (15906, '7d293f0b-535e-429c-9d6c-2d56867a715a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:51:25', 42, 0, '', '2019-05-31 16:51:25');
INSERT INTO `access_log` VALUES (15907, '90cebb18-3ac2-4c57-b0ff-dcc2d9762fdf', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:51:25', 43, 0, '', '2019-05-31 16:51:25');
INSERT INTO `access_log` VALUES (15908, '36ea473b-07d4-464b-8192-55c29f7c8304', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:51:25', 48, 0, '', '2019-05-31 16:51:25');
INSERT INTO `access_log` VALUES (15909, '53942331-1e32-4b3e-9e08-f9bbd0120757', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:51:25', 256, 0, '', '2019-05-31 16:51:25');
INSERT INTO `access_log` VALUES (15910, '64.79.15592926102742033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:50:10', 3, 0, '', '2019-05-31 16:50:10');
INSERT INTO `access_log` VALUES (15911, '64.82.15592926103642047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:50:10', 2, 0, '', '2019-05-31 16:50:10');
INSERT INTO `access_log` VALUES (15912, '64.76.15592926115082039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:50:12', 3, 0, '', '2019-05-31 16:50:12');
INSERT INTO `access_log` VALUES (15913, '64.78.15592926121392045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:50:12', 5, 0, '', '2019-05-31 16:50:12');
INSERT INTO `access_log` VALUES (15914, '64.85.15592926156432045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:50:16', 109, 0, '', '2019-05-31 16:50:16');
INSERT INTO `access_log` VALUES (15915, '64.77.15592926161512043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:50:16', 2, 0, '', '2019-05-31 16:50:16');
INSERT INTO `access_log` VALUES (15916, '3a98dcd3-eebb-4487-ab99-73383c68eb45', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:51:41', 52, 0, '', '2019-05-31 16:51:41');
INSERT INTO `access_log` VALUES (15917, '64.80.15592926257842035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '59.61.175.248', '2019-05-31 16:50:26', 2, 0, '', '2019-05-31 16:50:26');
INSERT INTO `access_log` VALUES (15918, '64.84.15592926259022045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '59.61.175.248', '2019-05-31 16:50:26', 3, 0, '', '2019-05-31 16:50:26');
INSERT INTO `access_log` VALUES (15919, '64.81.15592926281112035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '59.61.175.248', '2019-05-31 16:50:28', 3, 0, '', '2019-05-31 16:50:28');
INSERT INTO `access_log` VALUES (15920, '64.79.15592926287512035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '59.61.175.248', '2019-05-31 16:50:29', 3, 0, '', '2019-05-31 16:50:29');
INSERT INTO `access_log` VALUES (15921, '59.74.15592926297402659', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '59.61.175.248', '2019-05-31 16:50:30', 3, 0, '', '2019-05-31 16:50:30');
INSERT INTO `access_log` VALUES (15922, '59.76.15592926297422655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '59.61.175.248', '2019-05-31 16:50:30', 13, 2001001000, '服务端发生异常', '2019-05-31 16:50:30');
INSERT INTO `access_log` VALUES (15923, '64.76.15592926420912041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.61.175.248', '2019-05-31 16:50:42', 2, 0, '', '2019-05-31 16:50:42');
INSERT INTO `access_log` VALUES (15924, '64.78.15592926422172047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.61.175.248', '2019-05-31 16:50:42', 2, 0, '', '2019-05-31 16:50:42');
INSERT INTO `access_log` VALUES (15925, '64.85.15592926431432047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.61.175.248', '2019-05-31 16:50:43', 2, 0, '', '2019-05-31 16:50:43');
INSERT INTO `access_log` VALUES (15926, '64.77.15592926438982045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.61.175.248', '2019-05-31 16:50:44', 3, 0, '', '2019-05-31 16:50:44');
INSERT INTO `access_log` VALUES (15927, '59.71.15592926472462661', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:50:47', 3, 0, '', '2019-05-31 16:50:47');
INSERT INTO `access_log` VALUES (15928, '59.75.15592926472412659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:50:47', 15, 2001001000, '服务端发生异常', '2019-05-31 16:50:47');
INSERT INTO `access_log` VALUES (15929, '64.83.15592926492662039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:50:49', 2, 0, '', '2019-05-31 16:50:49');
INSERT INTO `access_log` VALUES (15930, '64.80.15592926493632037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:50:49', 1, 0, '', '2019-05-31 16:50:49');
INSERT INTO `access_log` VALUES (15931, '65.45.15592926614732095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:51:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 16:51:01');
INSERT INTO `access_log` VALUES (15932, '65.52.15592926659452071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:51:06', 89, 0, '', '2019-05-31 16:51:06');
INSERT INTO `access_log` VALUES (15933, '65.54.15592926660502067', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.247.203.12', '2019-05-31 16:51:06', 0, 1002001015, '账号未登陆', '2019-05-31 16:51:06');
INSERT INTO `access_log` VALUES (15934, '65.50.15592926660582089', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.247.203.12', '2019-05-31 16:51:06', 0, 1002001015, '账号未登陆', '2019-05-31 16:51:06');
INSERT INTO `access_log` VALUES (15935, '65.53.15592926660592069', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.247.203.12', '2019-05-31 16:51:06', 0, 1002001015, '账号未登陆', '2019-05-31 16:51:06');
INSERT INTO `access_log` VALUES (15936, '65.47.15592926663082091', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:51:06', 77, 0, '', '2019-05-31 16:51:06');
INSERT INTO `access_log` VALUES (15937, '65.48.15592926663082091', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:51:06', 78, 0, '', '2019-05-31 16:51:06');
INSERT INTO `access_log` VALUES (15938, '65.49.15592926662992091', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:51:06', 91, 0, '', '2019-05-31 16:51:06');
INSERT INTO `access_log` VALUES (15939, '65.51.15592926685832079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.247.203.12', '2019-05-31 16:51:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 16:51:09');
INSERT INTO `access_log` VALUES (15940, '62.81.15592926723252561', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:51:12', 17, 0, '', '2019-05-31 16:51:12');
INSERT INTO `access_log` VALUES (15941, '65.45.15592926733782097', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.247.203.12', '2019-05-31 16:51:13', 64, 0, '', '2019-05-31 16:51:13');
INSERT INTO `access_log` VALUES (15942, '65.53.15592926736772071', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.247.203.12', '2019-05-31 16:51:14', 9, 0, '', '2019-05-31 16:51:14');
INSERT INTO `access_log` VALUES (15943, '65.50.15592926736822091', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.247.203.12', '2019-05-31 16:51:14', 9, 0, '', '2019-05-31 16:51:14');
INSERT INTO `access_log` VALUES (15944, '65.52.15592926736852073', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.247.203.12', '2019-05-31 16:51:14', 9, 0, '', '2019-05-31 16:51:14');
INSERT INTO `access_log` VALUES (15945, '62.88.15592926816702575', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.247.203.12', '2019-05-31 16:51:22', 15, 0, '', '2019-05-31 16:51:22');
INSERT INTO `access_log` VALUES (15946, '64.76.15592926846082043', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:51:25', 8, 0, '', '2019-05-31 16:51:25');
INSERT INTO `access_log` VALUES (15947, '64.82.15592926846082051', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:51:25', 10, 0, '', '2019-05-31 16:51:25');
INSERT INTO `access_log` VALUES (15948, '59.72.15592926859662657', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.62.14.36', '2019-05-31 16:51:26', 19, 2001001000, '服务端发生异常', '2019-05-31 16:51:26');
INSERT INTO `access_log` VALUES (15949, '59.80.15592926859522659', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.62.14.36', '2019-05-31 16:51:26', 93, 0, '', '2019-05-31 16:51:26');
INSERT INTO `access_log` VALUES (15950, '59.76.15592926971112657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.14.36', '2019-05-31 16:51:37', 4, 0, '', '2019-05-31 16:51:37');
INSERT INTO `access_log` VALUES (15951, '59.79.15592926971212659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.14.36', '2019-05-31 16:51:37', 14, 2001001000, '服务端发生异常', '2019-05-31 16:51:37');
INSERT INTO `access_log` VALUES (15952, '59.75.15592927003692661', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.14.36', '2019-05-31 16:51:40', 4, 0, '', '2019-05-31 16:51:40');
INSERT INTO `access_log` VALUES (15953, '59.71.15592927003822663', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.14.36', '2019-05-31 16:51:40', 12, 2001001000, '服务端发生异常', '2019-05-31 16:51:40');
INSERT INTO `access_log` VALUES (15954, '65.47.15592927053072093', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '61.144.225.5', '2019-05-31 16:51:45', 0, 1002001015, '账号未登陆', '2019-05-31 16:51:45');
INSERT INTO `access_log` VALUES (15955, '65.49.15592927053162093', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '61.144.225.5', '2019-05-31 16:51:45', 0, 1002001015, '账号未登陆', '2019-05-31 16:51:45');
INSERT INTO `access_log` VALUES (15956, '65.51.15592927053232081', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '61.144.225.5', '2019-05-31 16:51:45', 0, 1002001015, '账号未登陆', '2019-05-31 16:51:45');
INSERT INTO `access_log` VALUES (15957, '64.85.15592927067812049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.14.36', '2019-05-31 16:51:47', 343, 0, '', '2019-05-31 16:51:47');
INSERT INTO `access_log` VALUES (15958, '64.77.15592927072712047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.14.36', '2019-05-31 16:51:47', 2, 0, '', '2019-05-31 16:51:47');
INSERT INTO `access_log` VALUES (15959, '64.83.15592927090922041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.14.36', '2019-05-31 16:51:49', 3, 0, '', '2019-05-31 16:51:49');
INSERT INTO `access_log` VALUES (15960, '64.80.15592927096002039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.14.36', '2019-05-31 16:51:50', 2, 0, '', '2019-05-31 16:51:50');
INSERT INTO `access_log` VALUES (15961, '64.81.15592927106852039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.14.36', '2019-05-31 16:51:51', 3, 0, '', '2019-05-31 16:51:51');
INSERT INTO `access_log` VALUES (15962, '64.79.15592927113632039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.14.36', '2019-05-31 16:51:51', 2, 0, '', '2019-05-31 16:51:51');
INSERT INTO `access_log` VALUES (15963, '64.76.15592927121952045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.14.36', '2019-05-31 16:51:52', 3, 0, '', '2019-05-31 16:51:52');
INSERT INTO `access_log` VALUES (15964, '64.82.15592927127072053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.14.36', '2019-05-31 16:51:53', 2, 0, '', '2019-05-31 16:51:53');
INSERT INTO `access_log` VALUES (15965, '64.78.15592927134272051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.14.36', '2019-05-31 16:51:53', 3, 0, '', '2019-05-31 16:51:53');
INSERT INTO `access_log` VALUES (15966, '64.85.15592927137632051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.14.36', '2019-05-31 16:51:54', 2, 0, '', '2019-05-31 16:51:54');
INSERT INTO `access_log` VALUES (15967, 'b22b22f7-28f2-4eff-9bef-b9645c06cab5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:18', 46, 0, '', '2019-05-31 16:53:18');
INSERT INTO `access_log` VALUES (15968, '7d92046b-b13a-40af-9e3d-dc5e9905aff3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:18', 53, 0, '', '2019-05-31 16:53:18');
INSERT INTO `access_log` VALUES (15969, 'e8bb931b-d76f-4b4f-a687-2f824c44e185', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:18', 54, 0, '', '2019-05-31 16:53:18');
INSERT INTO `access_log` VALUES (15970, '97b26025-37e0-4df2-a87c-2b72333a382c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:20', 51, 0, '', '2019-05-31 16:53:20');
INSERT INTO `access_log` VALUES (15971, 'f111e4a6-8922-41ac-ab10-f04b4ec1e378', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:20', 249, 0, '', '2019-05-31 16:53:20');
INSERT INTO `access_log` VALUES (15972, 'db8d5b63-888a-43e5-83b5-b2621b35ff3e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:20', 253, 0, '', '2019-05-31 16:53:20');
INSERT INTO `access_log` VALUES (15973, '150a4348-2b77-4e56-a5ba-9454edf2bc23', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:20', 36, 0, '', '2019-05-31 16:53:20');
INSERT INTO `access_log` VALUES (15974, '5ffa33bd-4af4-40e3-a097-4bb2f31fbf80', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:20', 38, 0, '', '2019-05-31 16:53:20');
INSERT INTO `access_log` VALUES (15975, 'e423f73d-f4b8-4ef6-8f30-9c156c7254d5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:20', 44, 0, '', '2019-05-31 16:53:20');
INSERT INTO `access_log` VALUES (15976, 'c78c0abf-b4fa-45c4-9d4f-b5da5727c49f', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:20', 134, 0, '', '2019-05-31 16:53:21');
INSERT INTO `access_log` VALUES (15977, 'ef775ded-0cef-4e8e-892d-905665377d76', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:34', 44, 0, '', '2019-05-31 16:53:34');
INSERT INTO `access_log` VALUES (15978, '9252987f-1608-456b-a7f8-6c9b27845e35', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:34', 48, 0, '', '2019-05-31 16:53:34');
INSERT INTO `access_log` VALUES (15979, 'e4a4b6b1-fc89-41bf-bb72-d7b8fa6b18a8', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:34', 54, 0, '', '2019-05-31 16:53:34');
INSERT INTO `access_log` VALUES (15980, 'a648d510-9c51-4070-a55b-c6608cf5ec91', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:36', 149, 0, '', '2019-05-31 16:53:36');
INSERT INTO `access_log` VALUES (15981, '59.72.15592927427952659', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:23', 3, 0, '', '2019-05-31 16:52:23');
INSERT INTO `access_log` VALUES (15982, '59.80.15592927427962661', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:23', 13, 2001001000, '服务端发生异常', '2019-05-31 16:52:23');
INSERT INTO `access_log` VALUES (15983, 'fdb4a30c-dbb3-4dd4-918d-b92e5f60a7ba', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:43', 312, 0, '', '2019-05-31 16:53:43');
INSERT INTO `access_log` VALUES (15984, '25f101d8-02a6-4edd-a863-0c312e7491c1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:43', 314, 0, '', '2019-05-31 16:53:43');
INSERT INTO `access_log` VALUES (15985, '72f2f030-6e31-4ba7-b84e-0032854874a1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:43', 319, 0, '', '2019-05-31 16:53:43');
INSERT INTO `access_log` VALUES (15986, '3b21f7e9-72d9-4ac5-adad-ebdde6d98aae', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:53:43', 75, 0, '', '2019-05-31 16:53:43');
INSERT INTO `access_log` VALUES (15987, '59.74.15592927509382663', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:31', 4, 0, '', '2019-05-31 16:52:31');
INSERT INTO `access_log` VALUES (15988, '59.76.15592927509382659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:31', 13, 2001001000, '服务端发生异常', '2019-05-31 16:52:31');
INSERT INTO `access_log` VALUES (15989, '64.84.15592927559892051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:36', 2, 0, '', '2019-05-31 16:52:36');
INSERT INTO `access_log` VALUES (15990, '64.81.15592927561132041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:36', 2, 0, '', '2019-05-31 16:52:36');
INSERT INTO `access_log` VALUES (15991, '64.79.15592927570752041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:37', 91, 0, '', '2019-05-31 16:52:37');
INSERT INTO `access_log` VALUES (15992, '64.76.15592927574562047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:37', 283, 0, '', '2019-05-31 16:52:38');
INSERT INTO `access_log` VALUES (15993, '64.82.15592927577222055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:38', 17, 0, '', '2019-05-31 16:52:38');
INSERT INTO `access_log` VALUES (15994, '64.78.15592927580902053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:38', 2, 0, '', '2019-05-31 16:52:38');
INSERT INTO `access_log` VALUES (15995, '64.85.15592927619902053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:42', 2, 0, '', '2019-05-31 16:52:42');
INSERT INTO `access_log` VALUES (15996, '64.77.15592927622612051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:42', 3, 0, '', '2019-05-31 16:52:42');
INSERT INTO `access_log` VALUES (15997, '5102bcd4-09bd-40b0-b460-3db550882c41', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:02', 42, 0, '', '2019-05-31 16:54:02');
INSERT INTO `access_log` VALUES (15998, '7f970681-7c57-4961-a4e2-48f4e13d1b1a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:02', 47, 0, '', '2019-05-31 16:54:02');
INSERT INTO `access_log` VALUES (15999, '8e98152c-4634-4a74-9a04-fbe8bb7bc72d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:02', 51, 0, '', '2019-05-31 16:54:02');
INSERT INTO `access_log` VALUES (16000, '81c7e8b1-00c3-4c07-9682-84570608f219', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:02', 74, 0, '', '2019-05-31 16:54:02');
INSERT INTO `access_log` VALUES (16001, '59.71.15592927635152665', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:44', 3, 0, '', '2019-05-31 16:52:44');
INSERT INTO `access_log` VALUES (16002, '59.75.15592927635142663', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:44', 13, 2001001000, '服务端发生异常', '2019-05-31 16:52:44');
INSERT INTO `access_log` VALUES (16003, '98f3f1df-a567-4072-be9e-1bcc8d19b908', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:08', 48, 0, '', '2019-05-31 16:54:08');
INSERT INTO `access_log` VALUES (16004, 'ee44dc1b-01ab-4a6f-86e7-5dcc5c3fe408', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:08', 34, 0, '', '2019-05-31 16:54:08');
INSERT INTO `access_log` VALUES (16005, '0f2ddf5b-76a1-41c7-aaec-8105db5ede57', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:08', 52, 0, '', '2019-05-31 16:54:08');
INSERT INTO `access_log` VALUES (16006, '417f831d-b8c7-4159-ac35-cd0a4a551b45', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:08', 67, 0, '', '2019-05-31 16:54:08');
INSERT INTO `access_log` VALUES (16007, '64.83.15592927699942045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:50', 2, 0, '', '2019-05-31 16:52:50');
INSERT INTO `access_log` VALUES (16008, '64.80.15592927701602043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:50', 2, 0, '', '2019-05-31 16:52:50');
INSERT INTO `access_log` VALUES (16009, '59.78.15592927716642669', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:52', 3, 0, '', '2019-05-31 16:52:52');
INSERT INTO `access_log` VALUES (16010, '59.73.15592927716662665', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:52:52', 19, 2001001000, '服务端发生异常', '2019-05-31 16:52:52');
INSERT INTO `access_log` VALUES (16011, 'f17458a8-0532-4be5-95cb-0529ba1cf850', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:13', 1250, 0, '', '2019-05-31 16:54:15');
INSERT INTO `access_log` VALUES (16012, 'ce66b214-af87-4971-8a47-f9376f127ca6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:13', 1250, 0, '', '2019-05-31 16:54:15');
INSERT INTO `access_log` VALUES (16013, 'b6b7fa43-d086-4b84-a1c1-7d1f64208e2c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:15', 42, 0, '', '2019-05-31 16:54:15');
INSERT INTO `access_log` VALUES (16014, 'b6fc28ff-42b6-4808-995f-bfeacee4a192', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:15', 61, 0, '', '2019-05-31 16:54:15');
INSERT INTO `access_log` VALUES (16015, '76af2904-e839-4f8c-9bb7-08bb62953fe7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:21', 589, 0, '', '2019-05-31 16:54:22');
INSERT INTO `access_log` VALUES (16016, 'b217423e-59bb-4228-b02e-35d2e2a44337', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:21', 653, 0, '', '2019-05-31 16:54:22');
INSERT INTO `access_log` VALUES (16017, 'b18c0525-7d14-43a8-b94e-e5b9e10a8b5e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:21', 663, 0, '', '2019-05-31 16:54:22');
INSERT INTO `access_log` VALUES (16018, '50c1218c-572f-4da9-8908-e6a00cd7b2fe', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:21', 689, 0, '', '2019-05-31 16:54:22');
INSERT INTO `access_log` VALUES (16019, '7b070bdf-9c2d-41f7-b8c3-1abc60527d0a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:26', 40, 0, '', '2019-05-31 16:54:26');
INSERT INTO `access_log` VALUES (16020, 'b7e0717e-4489-4e05-9ad3-77f25babaf09', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:26', 47, 0, '', '2019-05-31 16:54:26');
INSERT INTO `access_log` VALUES (16021, 'a5a2b83d-8844-4834-b59c-ac077a87df2d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:27', 41, 0, '', '2019-05-31 16:54:27');
INSERT INTO `access_log` VALUES (16022, '794e231b-a426-475f-9004-962f8aeba418', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 16:54:27', 61, 0, '', '2019-05-31 16:54:27');
INSERT INTO `access_log` VALUES (16023, '65.48.15592927956642095', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:53:16', 1, 1002001015, '账号未登陆', '2019-05-31 16:53:16');
INSERT INTO `access_log` VALUES (16024, '65.49.15592927956662095', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:53:16', 0, 1002001015, '账号未登陆', '2019-05-31 16:53:16');
INSERT INTO `access_log` VALUES (16025, '65.51.15592927956662083', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:53:16', 0, 1002001015, '账号未登陆', '2019-05-31 16:53:16');
INSERT INTO `access_log` VALUES (16026, '65.47.15592928022122095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:53:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 16:53:22');
INSERT INTO `access_log` VALUES (16027, '65.45.15592928070722101', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:53:27', 54, 0, '', '2019-05-31 16:53:27');
INSERT INTO `access_log` VALUES (16028, '65.53.15592928074122075', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:53:27', 9, 0, '', '2019-05-31 16:53:27');
INSERT INTO `access_log` VALUES (16029, '65.50.15592928074232095', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:53:27', 9, 0, '', '2019-05-31 16:53:27');
INSERT INTO `access_log` VALUES (16030, '65.52.15592928074782077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:53:27', 223, 0, '', '2019-05-31 16:53:28');
INSERT INTO `access_log` VALUES (16031, '62.80.15592928137232571', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:53:34', 14, 0, '', '2019-05-31 16:53:34');
INSERT INTO `access_log` VALUES (16032, '62.88.15592928155482577', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:53:36', 13, 0, '', '2019-05-31 16:53:36');
INSERT INTO `access_log` VALUES (16033, '62.87.15592928238182579', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:53:44', 16, 0, '', '2019-05-31 16:53:44');
INSERT INTO `access_log` VALUES (16034, '64.78.15592928265672055', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:53:47', 9, 0, '', '2019-05-31 16:53:47');
INSERT INTO `access_log` VALUES (16035, '64.82.15592928265672057', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:53:47', 12, 0, '', '2019-05-31 16:53:47');
INSERT INTO `access_log` VALUES (16036, '65.51.15592928351292085', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:53:55', 3, 0, '', '2019-05-31 16:53:55');
INSERT INTO `access_log` VALUES (16037, '66.50.15592928486461599', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:54:09', 15, 0, '', '2019-05-31 16:54:09');
INSERT INTO `access_log` VALUES (16038, '59.71.15592928541212667', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:54:14', 12, 0, '', '2019-05-31 16:54:14');
INSERT INTO `access_log` VALUES (16039, '59.77.15592928689532661', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:54:29', 13, 0, '', '2019-05-31 16:54:29');
INSERT INTO `access_log` VALUES (16040, '64.80.15592928714412045', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:54:31', 10, 0, '', '2019-05-31 16:54:31');
INSERT INTO `access_log` VALUES (16041, '64.84.15592928748652055', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:54:35', 10, 0, '', '2019-05-31 16:54:35');
INSERT INTO `access_log` VALUES (16042, '64.79.15592928757442045', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:54:36', 10, 0, '', '2019-05-31 16:54:36');
INSERT INTO `access_log` VALUES (16043, '64.76.15592928812452051', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:54:41', 10, 0, '', '2019-05-31 16:54:41');
INSERT INTO `access_log` VALUES (16044, '59.73.15592928833442667', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:54:43', 18, 0, '', '2019-05-31 16:54:43');
INSERT INTO `access_log` VALUES (16045, '59.74.15592928956812667', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '119.145.170.74', '2019-05-31 16:54:56', 14, 2001001000, '服务端发生异常', '2019-05-31 16:54:56');
INSERT INTO `access_log` VALUES (16046, '59.80.15592928956802665', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '119.145.170.74', '2019-05-31 16:54:56', 161, 0, '', '2019-05-31 16:54:56');
INSERT INTO `access_log` VALUES (16047, '65.53.15592928965322077', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:54:57', 188, 0, '', '2019-05-31 16:54:57');
INSERT INTO `access_log` VALUES (16048, '65.50.15592928983302097', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:54:58', 11, 0, '', '2019-05-31 16:54:58');
INSERT INTO `access_log` VALUES (16049, '65.52.15592928994092079', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:54:59', 20, 0, '', '2019-05-31 16:54:59');
INSERT INTO `access_log` VALUES (16050, '65.48.15592929008202099', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:55:01', 13, 0, '', '2019-05-31 16:55:01');
INSERT INTO `access_log` VALUES (16051, '65.46.15592929016032085', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '119.145.170.74', '2019-05-31 16:55:02', 1, 1002001015, '账号未登陆', '2019-05-31 16:55:02');
INSERT INTO `access_log` VALUES (16052, '65.45.15592929016082105', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '119.145.170.74', '2019-05-31 16:55:02', 0, 1002001015, '账号未登陆', '2019-05-31 16:55:02');
INSERT INTO `access_log` VALUES (16053, '65.50.15592929016752099', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '119.145.170.74', '2019-05-31 16:55:02', 0, 1002001015, '账号未登陆', '2019-05-31 16:55:02');
INSERT INTO `access_log` VALUES (16054, '65.53.15592929039892079', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=8', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:55:04', 10, 0, '', '2019-05-31 16:55:04');
INSERT INTO `access_log` VALUES (16055, '65.54.15592929076962075', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:55:08', 11, 0, '', '2019-05-31 16:55:08');
INSERT INTO `access_log` VALUES (16056, '65.46.15592929147752087', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '119.145.170.74', '2019-05-31 16:55:15', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 16:55:15');
INSERT INTO `access_log` VALUES (16057, '65.45.15592929150272107', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:55:15', 8, 0, '', '2019-05-31 16:55:15');
INSERT INTO `access_log` VALUES (16058, '65.50.15592929160692101', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:55:16', 9, 0, '', '2019-05-31 16:55:16');
INSERT INTO `access_log` VALUES (16059, '65.53.15592929177102081', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:55:18', 13, 0, '', '2019-05-31 16:55:18');
INSERT INTO `access_log` VALUES (16060, '65.54.15592929224652077', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '119.145.170.74', '2019-05-31 16:55:22', 89, 0, '', '2019-05-31 16:55:23');
INSERT INTO `access_log` VALUES (16061, '65.52.15592929229212081', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '119.145.170.74', '2019-05-31 16:55:23', 9, 0, '', '2019-05-31 16:55:23');
INSERT INTO `access_log` VALUES (16062, '65.51.15592929229292087', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '119.145.170.74', '2019-05-31 16:55:23', 9, 0, '', '2019-05-31 16:55:23');
INSERT INTO `access_log` VALUES (16063, '65.49.15592929229392103', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '119.145.170.74', '2019-05-31 16:55:23', 9, 0, '', '2019-05-31 16:55:23');
INSERT INTO `access_log` VALUES (16064, '65.48.15592929277122103', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 16:55:28', 9, 0, '', '2019-05-31 16:55:28');
INSERT INTO `access_log` VALUES (16065, '62.88.15592929287812579', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '119.145.170.74', '2019-05-31 16:55:29', 14, 0, '', '2019-05-31 16:55:29');
INSERT INTO `access_log` VALUES (16066, '64.77.15592929328762055', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '119.145.170.74', '2019-05-31 16:55:33', 12, 0, '', '2019-05-31 16:55:33');
INSERT INTO `access_log` VALUES (16067, '64.83.15592929331372049', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '119.145.170.74', '2019-05-31 16:55:33', 10, 0, '', '2019-05-31 16:55:33');
INSERT INTO `access_log` VALUES (16068, '59.77.15592929490852663', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '119.145.170.74', '2019-05-31 16:55:49', 13, 0, '', '2019-05-31 16:55:49');
INSERT INTO `access_log` VALUES (16069, '65.48.15592930697082105', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:57:50', 3, 0, '', '2019-05-31 16:57:50');
INSERT INTO `access_log` VALUES (16070, '64.80.15592930753122049', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=商品名ssaaadfads&sellPoint=商品卖点111111&cid=794&visible=false&picUrls=http://static.shop.iocoder.cn/029edd11-a72b-4e81-9f0a-225f7dd86319&skuStr=[{\"attrs\":[3,6,2],\"price\":10000,\"quantity\":1000},{\"attrs\":[3,6,2],\"price\":20000,\"quantity\":132}]&description=<p>efa</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:57:55', 9, 1002002009, NULL, '2019-05-31 16:57:55');
INSERT INTO `access_log` VALUES (16071, '64.81.15592930966732049', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=商品名ssaaadfads&sellPoint=商品卖点111111&cid=794&visible=false&picUrls=http://static.shop.iocoder.cn/029edd11-a72b-4e81-9f0a-225f7dd86319&skuStr=[{\"attrs\":[3,6,2],\"price\":10000,\"quantity\":1000},{\"attrs\":[3,6,2],\"price\":20000,\"quantity\":132}]&description=<p>efa</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:58:17', 8, 1002002009, NULL, '2019-05-31 16:58:17');
INSERT INTO `access_log` VALUES (16072, '64.82.15592931274052063', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=商品名ssaaadfads&sellPoint=商品卖点111111&cid=794&visible=false&picUrls=http://static.shop.iocoder.cn/029edd11-a72b-4e81-9f0a-225f7dd86319&skuStr=[{\"attrs\":[3,6,2],\"price\":10000,\"quantity\":1000},{\"attrs\":[3,6,2],\"price\":20000,\"quantity\":132},{\"attrs\":[3,6,2],\"price\":200,\"quantity\":3},{\"attrs\":[3,6,2],\"price\":200,\"quantity\":321},{\"attrs\":[3,6,2],\"price\":200,\"quantity\":213},{\"attrs\":[3,6,2],\"price\":200,\"quantity\":21},{\"attrs\":[3,7,5],\"price\":200,\"quantity\":321},{\"attrs\":[3,7,5],\"price\":200,\"quantity\":21},{\"attrs\":[3,7,5],\"price\":200,\"quantity\":213},{\"attrs\":[4,7,5],\"price\":200,\"quantity\":12},{\"attrs\":[4,7,5],\"price\":200,\"quantity\":213},{\"attrs\":[4,7,5],\"price\":200,\"quantity\":213},{\"attrs\":[4,8,12],\"price\":200,\"quantity\":2131},{\"attrs\":[4,8,12],\"price\":200,\"quantity\":312},{\"attrs\":[4,8,12],\"price\":200,\"quantity\":123},{\"attrs\":[4,8,12],\"price\":200,\"quantity\":213},{\"attrs\":[4,8,12],\"price\":10000,\"quantity\":111},{\"attrs\":[4,8,12],\"price\":1200,\"quantity\":222}]&description=<p>efa</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 16:58:47', 8, 1002002009, NULL, '2019-05-31 16:58:47');
INSERT INTO `access_log` VALUES (16073, '65.52.15592931485912085', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 16:59:09', 1, 1002001015, '账号未登陆', '2019-05-31 16:59:09');
INSERT INTO `access_log` VALUES (16074, '65.51.15592931485912091', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 16:59:09', 0, 1002001015, '账号未登陆', '2019-05-31 16:59:09');
INSERT INTO `access_log` VALUES (16075, '65.49.15592931486632107', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 16:59:09', 0, 1002001015, '账号未登陆', '2019-05-31 16:59:09');
INSERT INTO `access_log` VALUES (16076, 'c491e8bd-d841-49f7-b754-bccdfde70959', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:01:21', 17, 1002001012, '访问令牌已过期', '2019-05-31 17:01:21');
INSERT INTO `access_log` VALUES (16077, '1a644371-2d9d-4fc2-b1f0-79fc96230a0d', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:01:21', 15, 1002001012, '访问令牌已过期', '2019-05-31 17:01:21');
INSERT INTO `access_log` VALUES (16078, '2e851ed7-8844-4840-8e7d-5a5364021925', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:01:21', 15, 1002001012, '访问令牌已过期', '2019-05-31 17:01:21');
INSERT INTO `access_log` VALUES (16079, 'b5052c23-0a0a-4635-8d73-40e5cb44fa42', 0, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:01:22', 171, 1002001012, '访问令牌已过期', '2019-05-31 17:01:22');
INSERT INTO `access_log` VALUES (16080, 'e5636ac5-3881-433f-8e2a-fe04c297eab5', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:02:15', 116, 0, '', '2019-05-31 17:02:15');
INSERT INTO `access_log` VALUES (16081, '7ebdd0b2-2d23-4790-85cf-582ab751d6a0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:02:15', 44, 0, '', '2019-05-31 17:02:15');
INSERT INTO `access_log` VALUES (16082, '241daedf-5571-498d-91f9-475ad701263b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:02:15', 49, 0, '', '2019-05-31 17:02:15');
INSERT INTO `access_log` VALUES (16083, 'b4dbc40f-26e1-48be-9912-f5a09edc804b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:02:15', 55, 0, '', '2019-05-31 17:02:16');
INSERT INTO `access_log` VALUES (16084, '59.73.15592932649972673', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.84.223.66', '2019-05-31 17:01:05', 4, 0, '', '2019-05-31 17:01:05');
INSERT INTO `access_log` VALUES (16085, '59.72.15592932649972669', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.84.223.66', '2019-05-31 17:01:05', 30, 2001001000, '服务端发生异常', '2019-05-31 17:01:05');
INSERT INTO `access_log` VALUES (16086, '93a2d274-4ed7-4ae7-86ad-fd9a78aec9ac', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:02:24', 59, 0, '', '2019-05-31 17:02:24');
INSERT INTO `access_log` VALUES (16087, '1fc532c1-657f-4afe-afde-dd9446611eb8', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:03:07', 158, 0, '', '2019-05-31 17:03:07');
INSERT INTO `access_log` VALUES (16088, '3682dd2b-1bb6-4e8a-8658-0786f60333ea', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:03:09', 41, 0, '', '2019-05-31 17:03:09');
INSERT INTO `access_log` VALUES (16089, '5109efe9-f71e-4115-883c-65e3c218c99e', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:03:14', 52, 0, '', '2019-05-31 17:03:14');
INSERT INTO `access_log` VALUES (16090, '59.77.15592933614642669', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 17:02:41', 13, 0, '', '2019-05-31 17:02:41');
INSERT INTO `access_log` VALUES (16091, '59.78.15592933670772679', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 17:02:47', 20, 2001001000, '服务端发生异常', '2019-05-31 17:02:47');
INSERT INTO `access_log` VALUES (16092, '59.72.15592933700912671', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 17:02:50', 9, 0, '', '2019-05-31 17:02:50');
INSERT INTO `access_log` VALUES (16093, '59.74.15592933783552675', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 17:02:58', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-31 17:02:58');
INSERT INTO `access_log` VALUES (16094, 'b9157aef-8980-4d8d-8c7a-613bbc9aa1ee', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:04:24', 44, 0, '', '2019-05-31 17:04:24');
INSERT INTO `access_log` VALUES (16095, '6d02e409-38ef-4466-b79d-ab5d9409833c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:04:24', 48, 0, '', '2019-05-31 17:04:24');
INSERT INTO `access_log` VALUES (16096, 'a7256ac2-2a52-4f17-9759-3da27730736b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:04:24', 42, 0, '', '2019-05-31 17:04:24');
INSERT INTO `access_log` VALUES (16097, '9320700f-ba69-4a90-9666-c78e279a2222', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:04:24', 148, 0, '', '2019-05-31 17:04:25');
INSERT INTO `access_log` VALUES (16098, 'c3bac26e-af5b-4285-b22d-78c4625a4cca', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:04:34', 35, 0, '', '2019-05-31 17:04:34');
INSERT INTO `access_log` VALUES (16099, '2705153a-a2cc-465c-bc76-db735a6ba819', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:04:34', 35, 0, '', '2019-05-31 17:04:34');
INSERT INTO `access_log` VALUES (16100, '5ca8094e-40a0-4e84-bc8a-8e0ad902464e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:04:34', 34, 0, '', '2019-05-31 17:04:34');
INSERT INTO `access_log` VALUES (16101, 'd6a52c23-728d-4f53-9ea8-82e73e286a3f', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:04:34', 55, 0, '', '2019-05-31 17:04:34');
INSERT INTO `access_log` VALUES (16102, 'bed5f09c-3b41-4ca2-9df9-cb90a376bfb8', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:04:40', 57, 0, '', '2019-05-31 17:04:40');
INSERT INTO `access_log` VALUES (16103, '62.86.15592934217582575', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:42', 14, 0, '', '2019-05-31 17:03:42');
INSERT INTO `access_log` VALUES (16104, '65.49.15592934227462111', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:03:43', 0, 1002001015, '账号未登陆', '2019-05-31 17:03:43');
INSERT INTO `access_log` VALUES (16105, '65.47.15592934227612109', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:03:43', 0, 1002001015, '账号未登陆', '2019-05-31 17:03:43');
INSERT INTO `access_log` VALUES (16106, '65.48.15592934227702111', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:03:43', 0, 1002001015, '账号未登陆', '2019-05-31 17:03:43');
INSERT INTO `access_log` VALUES (16107, '65.46.15592934257102097', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:03:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:03:46');
INSERT INTO `access_log` VALUES (16108, 'd6349d04-4200-47d1-9b0a-b787824d93b0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:05:06', 42, 0, '', '2019-05-31 17:05:06');
INSERT INTO `access_log` VALUES (16109, '4adb844d-e339-46f6-b08d-857d6762cdcb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:05:06', 44, 0, '', '2019-05-31 17:05:06');
INSERT INTO `access_log` VALUES (16110, 'f9a73b69-3174-411b-81bc-486775f7d654', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:05:06', 44, 0, '', '2019-05-31 17:05:06');
INSERT INTO `access_log` VALUES (16111, 'd9d38caf-8f49-4c49-88cc-bc84984f0b59', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:05:07', 54, 0, '', '2019-05-31 17:05:07');
INSERT INTO `access_log` VALUES (16112, '65.45.15592934296772117', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:50', 10, 0, '', '2019-05-31 17:03:50');
INSERT INTO `access_log` VALUES (16113, '65.50.15592934298232111', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:50', 11, 0, '', '2019-05-31 17:03:50');
INSERT INTO `access_log` VALUES (16114, '65.53.15592934299642091', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:50', 10, 0, '', '2019-05-31 17:03:50');
INSERT INTO `access_log` VALUES (16115, '65.54.15592934303442087', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:50', 19, 0, '', '2019-05-31 17:03:50');
INSERT INTO `access_log` VALUES (16116, '65.52.15592934311942091', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:51', 11, 0, '', '2019-05-31 17:03:51');
INSERT INTO `access_log` VALUES (16117, '65.51.15592934314522097', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:03:51', 72, 0, '', '2019-05-31 17:03:52');
INSERT INTO `access_log` VALUES (16118, '65.49.15592934317092113', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:52', 19, 0, '', '2019-05-31 17:03:52');
INSERT INTO `access_log` VALUES (16119, '65.47.15592934319792111', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:03:52', 9, 0, '', '2019-05-31 17:03:52');
INSERT INTO `access_log` VALUES (16120, '65.48.15592934319802113', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:03:52', 10, 0, '', '2019-05-31 17:03:52');
INSERT INTO `access_log` VALUES (16121, '65.46.15592934319872099', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:03:52', 9, 0, '', '2019-05-31 17:03:52');
INSERT INTO `access_log` VALUES (16122, '59.75.15592934322612675', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:52', 15, 0, '', '2019-05-31 17:03:52');
INSERT INTO `access_log` VALUES (16123, '59.77.15592934326882671', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:53', 13, 0, '', '2019-05-31 17:03:53');
INSERT INTO `access_log` VALUES (16124, '59.78.15592934328582681', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:53', 12, 0, '', '2019-05-31 17:03:53');
INSERT INTO `access_log` VALUES (16125, '66.50.15592934332261607', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:53', 12, 0, '', '2019-05-31 17:03:53');
INSERT INTO `access_log` VALUES (16126, '64.85.15592934335802065', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:54', 11, 0, '', '2019-05-31 17:03:54');
INSERT INTO `access_log` VALUES (16127, '64.77.15592934335842063', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:54', 7, 0, '', '2019-05-31 17:03:54');
INSERT INTO `access_log` VALUES (16128, '62.84.15592934337962579', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:54', 16, 0, '', '2019-05-31 17:03:54');
INSERT INTO `access_log` VALUES (16129, '62.81.15592934339722573', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:03:54', 13, 0, '', '2019-05-31 17:03:54');
INSERT INTO `access_log` VALUES (16130, '62.80.15592934369792581', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:03:57', 13, 0, '', '2019-05-31 17:03:57');
INSERT INTO `access_log` VALUES (16131, '62.85.15592934596862587', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&status=2&hasRefund=false&payChannel=101', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:04:20', 48, 0, '', '2019-05-31 17:04:20');
INSERT INTO `access_log` VALUES (16132, '59.74.15592934628752677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.255.90', '2019-05-31 17:04:23', 3, 0, '', '2019-05-31 17:04:23');
INSERT INTO `access_log` VALUES (16133, '59.80.15592934628762675', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.255.90', '2019-05-31 17:04:23', 12, 2001001000, '服务端发生异常', '2019-05-31 17:04:23');
INSERT INTO `access_log` VALUES (16134, '5c985abc-4185-4739-a7f6-bbd6db791550', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:05:43', 34, 0, '', '2019-05-31 17:05:43');
INSERT INTO `access_log` VALUES (16135, 'e52d039f-5e95-4494-9352-33ead4dee4d6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:05:43', 32, 0, '', '2019-05-31 17:05:43');
INSERT INTO `access_log` VALUES (16136, 'a2d21c5d-e9da-494a-8db1-3a41f85b3266', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:05:43', 51, 0, '', '2019-05-31 17:05:43');
INSERT INTO `access_log` VALUES (16137, 'a57f8be6-ee0c-4fcd-8465-abc4f95602b7', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:05:43', 84, 0, '', '2019-05-31 17:05:43');
INSERT INTO `access_log` VALUES (16138, '64.84.15592934664952065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.255.90', '2019-05-31 17:04:26', 2, 0, '', '2019-05-31 17:04:26');
INSERT INTO `access_log` VALUES (16139, '64.81.15592934666162055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.255.90', '2019-05-31 17:04:27', 2, 0, '', '2019-05-31 17:04:27');
INSERT INTO `access_log` VALUES (16140, '59.76.15592934682602673', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.255.90', '2019-05-31 17:04:28', 6, 0, '', '2019-05-31 17:04:28');
INSERT INTO `access_log` VALUES (16141, '59.79.15592934682612675', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.255.90', '2019-05-31 17:04:28', 11, 2001001000, '服务端发生异常', '2019-05-31 17:04:28');
INSERT INTO `access_log` VALUES (16142, '62.83.15592934727522587', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:04:33', 162, 0, '', '2019-05-31 17:04:33');
INSERT INTO `access_log` VALUES (16143, '62.89.15592934746182585', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:04:35', 14, 0, '', '2019-05-31 17:04:35');
INSERT INTO `access_log` VALUES (16144, '62.82.15592934818162585', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:04:42', 16, 0, '', '2019-05-31 17:04:42');
INSERT INTO `access_log` VALUES (16145, '62.84.15592934829882581', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:04:43', 13, 0, '', '2019-05-31 17:04:43');
INSERT INTO `access_log` VALUES (16146, '62.81.15592934850432575', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=40', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:04:45', 11, 0, '', '2019-05-31 17:04:45');
INSERT INTO `access_log` VALUES (16147, '64.76.15592934861262061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.63.255.90', '2019-05-31 17:04:46', 3, 0, '', '2019-05-31 17:04:46');
INSERT INTO `access_log` VALUES (16148, '64.82.15592934862422069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.63.255.90', '2019-05-31 17:04:46', 2, 0, '', '2019-05-31 17:04:46');
INSERT INTO `access_log` VALUES (16149, '64.78.15592934873462067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.63.255.90', '2019-05-31 17:04:47', 2, 0, '', '2019-05-31 17:04:47');
INSERT INTO `access_log` VALUES (16150, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.63.255.90', '2019-05-31 17:04:47', 19, 0, '', '2019-05-31 17:04:47');
INSERT INTO `access_log` VALUES (16151, '64.77.15592934883282065', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.63.255.90', '2019-05-31 17:04:48', 9, 0, '', '2019-05-31 17:04:48');
INSERT INTO `access_log` VALUES (16152, '62.80.15592934897022583', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=40', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:04:50', 16, 0, '', '2019-05-31 17:04:50');
INSERT INTO `access_log` VALUES (16153, '64.83.15592934946152059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.63.255.90', '2019-05-31 17:04:55', 2, 0, '', '2019-05-31 17:04:55');
INSERT INTO `access_log` VALUES (16154, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.63.255.90', '2019-05-31 17:04:55', 7, 0, '', '2019-05-31 17:04:55');
INSERT INTO `access_log` VALUES (16155, '64.80.15592934953162057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.63.255.90', '2019-05-31 17:04:55', 54, 0, '', '2019-05-31 17:04:55');
INSERT INTO `access_log` VALUES (16156, '64.84.15592934960752067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.63.255.90', '2019-05-31 17:04:56', 2, 0, '', '2019-05-31 17:04:56');
INSERT INTO `access_log` VALUES (16157, '64.81.15592934973732057', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:04:57', 11, 0, '', '2019-05-31 17:04:57');
INSERT INTO `access_log` VALUES (16158, '64.79.15592934973872057', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:04:57', 8, 0, '', '2019-05-31 17:04:57');
INSERT INTO `access_log` VALUES (16159, '65.51.15592935076392099', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.255.90', '2019-05-31 17:05:08', 0, 1002001015, '账号未登陆', '2019-05-31 17:05:08');
INSERT INTO `access_log` VALUES (16160, '65.49.15592935076422115', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.255.90', '2019-05-31 17:05:08', 1, 1002001015, '账号未登陆', '2019-05-31 17:05:08');
INSERT INTO `access_log` VALUES (16161, '65.46.15592935076432101', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.255.90', '2019-05-31 17:05:08', 1, 1002001015, '账号未登陆', '2019-05-31 17:05:08');
INSERT INTO `access_log` VALUES (16162, '1eefc22f-be75-4779-a7ef-76f7f0bab7a7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:06:27', 33, 0, '', '2019-05-31 17:06:27');
INSERT INTO `access_log` VALUES (16163, '5b386a4f-2573-489f-b5a7-fdea386f461b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:06:27', 45, 0, '', '2019-05-31 17:06:27');
INSERT INTO `access_log` VALUES (16164, '7ded565f-73b8-4541-bde9-1db2a2c7049c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:06:27', 42, 0, '', '2019-05-31 17:06:27');
INSERT INTO `access_log` VALUES (16165, '80735165-2428-4319-acf8-7cbda4daa382', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:06:28', 61, 0, '', '2019-05-31 17:06:28');
INSERT INTO `access_log` VALUES (16166, '65.48.15592935094472115', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.255.90', '2019-05-31 17:05:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:05:09');
INSERT INTO `access_log` VALUES (16167, '3ba5641b-d515-4a87-be96-e4be6a64b62e', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:06:35', 39, 0, '', '2019-05-31 17:06:35');
INSERT INTO `access_log` VALUES (16168, '482d76cc-2fca-4595-885f-a60592917b45', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10&name=安踏', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:06:37', 280, 0, '', '2019-05-31 17:06:38');
INSERT INTO `access_log` VALUES (16169, '59.72.15592935394682675', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.112.104.44', '2019-05-31 17:05:39', 3, 0, '', '2019-05-31 17:05:39');
INSERT INTO `access_log` VALUES (16170, '59.80.15592935394682677', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.112.104.44', '2019-05-31 17:05:39', 15, 2001001000, '服务端发生异常', '2019-05-31 17:05:39');
INSERT INTO `access_log` VALUES (16171, '59.79.15592935539972677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.112.104.44', '2019-05-31 17:05:54', 3, 0, '', '2019-05-31 17:05:54');
INSERT INTO `access_log` VALUES (16172, '59.76.15592935539972675', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.112.104.44', '2019-05-31 17:05:54', 12, 2001001000, '服务端发生异常', '2019-05-31 17:05:54');
INSERT INTO `access_log` VALUES (16173, '64.83.15592935592052061', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:05:59', 9, 0, '', '2019-05-31 17:05:59');
INSERT INTO `access_log` VALUES (16174, '64.85.15592935592052069', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:05:59', 11, 0, '', '2019-05-31 17:05:59');
INSERT INTO `access_log` VALUES (16175, '64.80.15592935611562059', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:06:01', 16, 0, '', '2019-05-31 17:06:01');
INSERT INTO `access_log` VALUES (16176, '64.84.15592935611662069', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:06:01', 10, 0, '', '2019-05-31 17:06:01');
INSERT INTO `access_log` VALUES (16177, '64.81.15592935612132059', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.115.174', '2019-05-31 17:06:01', 9, 0, '', '2019-05-31 17:06:01');
INSERT INTO `access_log` VALUES (16178, '64.76.15592935707262065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.84.223.66', '2019-05-31 17:06:11', 2, 0, '', '2019-05-31 17:06:11');
INSERT INTO `access_log` VALUES (16179, '64.82.15592935708202073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.84.223.66', '2019-05-31 17:06:11', 2, 0, '', '2019-05-31 17:06:11');
INSERT INTO `access_log` VALUES (16180, '64.78.15592935724022071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.84.223.66', '2019-05-31 17:06:12', 85, 0, '', '2019-05-31 17:06:12');
INSERT INTO `access_log` VALUES (16181, '64.77.15592935729532069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.84.223.66', '2019-05-31 17:06:13', 2, 0, '', '2019-05-31 17:06:13');
INSERT INTO `access_log` VALUES (16182, '64.85.15592935762502071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.84.223.66', '2019-05-31 17:06:16', 2, 0, '', '2019-05-31 17:06:16');
INSERT INTO `access_log` VALUES (16183, '64.83.15592935763792063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.84.223.66', '2019-05-31 17:06:16', 2, 0, '', '2019-05-31 17:06:16');
INSERT INTO `access_log` VALUES (16184, '64.84.15592935786872071', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:06:19', 10, 0, '', '2019-05-31 17:06:19');
INSERT INTO `access_log` VALUES (16185, '66.48.15592935887241613', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:06:29', 14, 0, '', '2019-05-31 17:06:29');
INSERT INTO `access_log` VALUES (16186, '59.78.15592935959662685', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:06:36', 12, 0, '', '2019-05-31 17:06:36');
INSERT INTO `access_log` VALUES (16187, '59.73.15592936034582681', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:06:43', 21, 2001001000, '服务端发生异常', '2019-05-31 17:06:43');
INSERT INTO `access_log` VALUES (16188, '65.49.15592936279392119', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:07:08', 20, 0, '', '2019-05-31 17:07:08');
INSERT INTO `access_log` VALUES (16189, '65.46.15592936301362105', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:07:10', 10, 0, '', '2019-05-31 17:07:10');
INSERT INTO `access_log` VALUES (16190, '65.48.15592936346632117', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.255.90', '2019-05-31 17:07:15', 1, 1002001015, '账号未登陆', '2019-05-31 17:07:15');
INSERT INTO `access_log` VALUES (16191, '65.50.15592936350262119', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:07:15', 12, 0, '', '2019-05-31 17:07:15');
INSERT INTO `access_log` VALUES (16192, '65.53.15592936422912097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.237', '2019-05-31 17:07:22', 15, 0, '', '2019-05-31 17:07:22');
INSERT INTO `access_log` VALUES (16193, '59.79.15592937935382681', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '114.216.22.216', '2019-05-31 17:09:54', 4, 0, '', '2019-05-31 17:09:54');
INSERT INTO `access_log` VALUES (16194, '59.76.15592937935392679', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '114.216.22.216', '2019-05-31 17:09:54', 14, 2001001000, '服务端发生异常', '2019-05-31 17:09:54');
INSERT INTO `access_log` VALUES (16195, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=5&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:06', 7, 0, '', '2019-05-31 17:10:06');
INSERT INTO `access_log` VALUES (16196, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:06', 11, 0, '', '2019-05-31 17:10:06');
INSERT INTO `access_log` VALUES (16197, '59.75.15592938136032683', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:14', 4, 0, '', '2019-05-31 17:10:14');
INSERT INTO `access_log` VALUES (16198, '64.77.15592938149832073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:15', 2010, 0, '', '2019-05-31 17:10:17');
INSERT INTO `access_log` VALUES (16199, '64.85.15592938171232075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:17', 2, 0, '', '2019-05-31 17:10:17');
INSERT INTO `access_log` VALUES (16200, '66.56.15592938178091607', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:18', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空', '2019-05-31 17:10:18');
INSERT INTO `access_log` VALUES (16201, '59.73.15592938351252685', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:35', 17, 2001001000, '服务端发生异常', '2019-05-31 17:10:35');
INSERT INTO `access_log` VALUES (16202, '66.50.15592938371431613', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18962222222', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:37', 240, 0, '', '2019-05-31 17:10:37');
INSERT INTO `access_log` VALUES (16203, '66.48.15592938443691617', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18962222222&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:44', 206, 0, '', '2019-05-31 17:10:45');
INSERT INTO `access_log` VALUES (16204, '64.81.15592938499922065', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:50', 6, 0, '', '2019-05-31 17:10:50');
INSERT INTO `access_log` VALUES (16205, '64.76.15592938501282071', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:50', 5, 0, '', '2019-05-31 17:10:50');
INSERT INTO `access_log` VALUES (16206, '64.78.15592938531922077', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:53', 5, 0, '', '2019-05-31 17:10:53');
INSERT INTO `access_log` VALUES (16207, '64.77.15592938532812075', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:53', 4, 0, '', '2019-05-31 17:10:53');
INSERT INTO `access_log` VALUES (16208, '65.51.15592938535312105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:10:54', 8, 0, '', '2019-05-31 17:10:54');
INSERT INTO `access_log` VALUES (16209, '65.46.15592938535472109', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:10:54', 8, 0, '', '2019-05-31 17:10:54');
INSERT INTO `access_log` VALUES (16210, '65.47.15592938535482119', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:10:54', 10, 0, '', '2019-05-31 17:10:54');
INSERT INTO `access_log` VALUES (16211, '64.83.15592938547292069', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:55', 6, 0, '', '2019-05-31 17:10:55');
INSERT INTO `access_log` VALUES (16212, '64.80.15592938554002067', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:55', 785, 0, '', '2019-05-31 17:10:56');
INSERT INTO `access_log` VALUES (16213, '64.81.15592938562532067', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:56', 5, 0, '', '2019-05-31 17:10:56');
INSERT INTO `access_log` VALUES (16214, '64.79.15592938568122067', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:57', 6, 0, '', '2019-05-31 17:10:57');
INSERT INTO `access_log` VALUES (16215, '64.76.15592938572062073', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:57', 5, 0, '', '2019-05-31 17:10:57');
INSERT INTO `access_log` VALUES (16216, '64.82.15592938574682081', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:57', 5, 0, '', '2019-05-31 17:10:57');
INSERT INTO `access_log` VALUES (16217, '64.78.15592938580322079', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:58', 5, 0, '', '2019-05-31 17:10:58');
INSERT INTO `access_log` VALUES (16218, 'N/A', 93, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:10:58', 11, 0, '', '2019-05-31 17:10:58');
INSERT INTO `access_log` VALUES (16219, '65.50.15592938586142123', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:10:59', 9, 0, '', '2019-05-31 17:10:59');
INSERT INTO `access_log` VALUES (16220, '65.53.15592938586192101', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:10:59', 8, 0, '', '2019-05-31 17:10:59');
INSERT INTO `access_log` VALUES (16221, '65.45.15592938586252127', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:10:59', 8, 0, '', '2019-05-31 17:10:59');
INSERT INTO `access_log` VALUES (16222, '64.77.15592938601302077', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:11:00', 5, 0, '', '2019-05-31 17:11:00');
INSERT INTO `access_log` VALUES (16223, '64.85.15592938602352079', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:11:00', 4, 0, '', '2019-05-31 17:11:00');
INSERT INTO `access_log` VALUES (16224, '64.83.15592938608442071', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:11:01', 6, 0, '', '2019-05-31 17:11:01');
INSERT INTO `access_log` VALUES (16225, '64.84.15592938612932079', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:11:01', 5, 0, '', '2019-05-31 17:11:01');
INSERT INTO `access_log` VALUES (16226, '64.80.15592938620122069', 93, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:11:02', 5, 0, '', '2019-05-31 17:11:02');
INSERT INTO `access_log` VALUES (16227, 'N/A', 93, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:11:02', 15, 0, '', '2019-05-31 17:11:02');
INSERT INTO `access_log` VALUES (16228, '64.79.15592938630992069', 93, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:11:03', 10, 0, '', '2019-05-31 17:11:03');
INSERT INTO `access_log` VALUES (16229, '65.54.15592938680172099', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.190.113.250', '2019-05-31 17:11:08', 1, 1002001015, '账号未登陆', '2019-05-31 17:11:08');
INSERT INTO `access_log` VALUES (16230, '65.52.15592938680212101', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.190.113.250', '2019-05-31 17:11:08', 1, 1002001015, '账号未登陆', '2019-05-31 17:11:08');
INSERT INTO `access_log` VALUES (16231, '65.49.15592938680292125', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.190.113.250', '2019-05-31 17:11:08', 0, 1002001015, '账号未登陆', '2019-05-31 17:11:08');
INSERT INTO `access_log` VALUES (16232, '65.46.15592938713682111', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.190.113.250', '2019-05-31 17:11:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:11:11');
INSERT INTO `access_log` VALUES (16233, '66.52.15592938797151611', 93, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:11:20', 7, 0, '', '2019-05-31 17:11:20');
INSERT INTO `access_log` VALUES (16234, '65.47.15592938816042121', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:11:22', 9, 0, '', '2019-05-31 17:11:22');
INSERT INTO `access_log` VALUES (16235, '65.48.15592938816082123', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:11:22', 8, 0, '', '2019-05-31 17:11:22');
INSERT INTO `access_log` VALUES (16236, '65.50.15592938816282125', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:11:22', 8, 0, '', '2019-05-31 17:11:22');
INSERT INTO `access_log` VALUES (16237, '66.57.15592938827351613', 93, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:11:23', 7, 0, '', '2019-05-31 17:11:23');
INSERT INTO `access_log` VALUES (16238, '65.45.15592938938932129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:11:34', 10, 0, '', '2019-05-31 17:11:34');
INSERT INTO `access_log` VALUES (16239, '65.54.15592938938972101', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:11:34', 9, 0, '', '2019-05-31 17:11:34');
INSERT INTO `access_log` VALUES (16240, '65.52.15592938939022103', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:11:34', 9, 0, '', '2019-05-31 17:11:34');
INSERT INTO `access_log` VALUES (16241, '65.51.15592939057192109', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.190.113.250', '2019-05-31 17:11:46', 64, 0, '', '2019-05-31 17:11:46');
INSERT INTO `access_log` VALUES (16242, '65.46.15592939062072113', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.190.113.250', '2019-05-31 17:11:46', 8, 0, '', '2019-05-31 17:11:46');
INSERT INTO `access_log` VALUES (16243, '65.48.15592939062162125', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.190.113.250', '2019-05-31 17:11:46', 9, 0, '', '2019-05-31 17:11:46');
INSERT INTO `access_log` VALUES (16244, '65.47.15592939062202123', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.190.113.250', '2019-05-31 17:11:46', 8, 0, '', '2019-05-31 17:11:46');
INSERT INTO `access_log` VALUES (16245, '66.48.15592939078391619', 93, 1, 'user-application', '/user-api/users/address/add', 'name=1&tel=18962222222&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=3&isDefault=true&address=3&areaNo=110101&mobile=18962222222&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:11:48', 87, 2001001000, '服务端发生异常', '2019-05-31 17:11:48');
INSERT INTO `access_log` VALUES (16246, '65.53.15592939169612105', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.190.113.250', '2019-05-31 17:11:57', 19, 0, '', '2019-05-31 17:11:57');
INSERT INTO `access_log` VALUES (16247, '65.52.15592939331652105', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.190.113.250', '2019-05-31 17:12:13', 17, 0, '', '2019-05-31 17:12:13');
INSERT INTO `access_log` VALUES (16248, '59.77.15592939470392681', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:27', 3, 0, '', '2019-05-31 17:12:27');
INSERT INTO `access_log` VALUES (16249, '59.78.15592939470412691', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:27', 11, 2001001000, '服务端发生异常', '2019-05-31 17:12:27');
INSERT INTO `access_log` VALUES (16250, '64.84.15592939527662081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:33', 3, 0, '', '2019-05-31 17:12:33');
INSERT INTO `access_log` VALUES (16251, '64.80.15592939528682071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:33', 2, 0, '', '2019-05-31 17:12:33');
INSERT INTO `access_log` VALUES (16252, '64.81.15592939538932071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:34', 2, 0, '', '2019-05-31 17:12:34');
INSERT INTO `access_log` VALUES (16253, '64.79.15592939544322071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:34', 2, 0, '', '2019-05-31 17:12:34');
INSERT INTO `access_log` VALUES (16254, '64.76.15592939548762077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:35', 3, 0, '', '2019-05-31 17:12:35');
INSERT INTO `access_log` VALUES (16255, '59.72.15592939549102683', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.190.113.250', '2019-05-31 17:12:35', 3, 0, '', '2019-05-31 17:12:35');
INSERT INTO `access_log` VALUES (16256, '59.80.15592939549112685', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.190.113.250', '2019-05-31 17:12:35', 13, 2001001000, '服务端发生异常', '2019-05-31 17:12:35');
INSERT INTO `access_log` VALUES (16257, '64.82.15592939551902085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:35', 3, 0, '', '2019-05-31 17:12:35');
INSERT INTO `access_log` VALUES (16258, '66.53.15592939574021621', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:37', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空\n账号长度为 11 位', '2019-05-31 17:12:37');
INSERT INTO `access_log` VALUES (16259, '64.77.15592939601292081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:40', 2, 0, '', '2019-05-31 17:12:40');
INSERT INTO `access_log` VALUES (16260, '64.85.15592939602332083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:40', 2, 0, '', '2019-05-31 17:12:40');
INSERT INTO `access_log` VALUES (16261, '64.83.15592939631412075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:43', 2, 0, '', '2019-05-31 17:12:43');
INSERT INTO `access_log` VALUES (16262, '64.84.15592939634872083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:43', 3, 0, '', '2019-05-31 17:12:43');
INSERT INTO `access_log` VALUES (16263, '64.80.15592939638442073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:44', 2, 0, '', '2019-05-31 17:12:44');
INSERT INTO `access_log` VALUES (16264, '64.81.15592939641942073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.140.74.155', '2019-05-31 17:12:44', 2, 0, '', '2019-05-31 17:12:44');
INSERT INTO `access_log` VALUES (16265, '59.78.15592940503922693', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:14:10', 4, 0, '', '2019-05-31 17:14:10');
INSERT INTO `access_log` VALUES (16266, '59.73.15592940505382689', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:14:11', 14, 2001001000, '服务端发生异常', '2019-05-31 17:14:11');
INSERT INTO `access_log` VALUES (16267, '64.83.15592940538082077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:14:14', 75, 0, '', '2019-05-31 17:14:14');
INSERT INTO `access_log` VALUES (16268, '64.84.15592940540192085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:14:14', 2, 0, '', '2019-05-31 17:14:14');
INSERT INTO `access_log` VALUES (16269, '65.54.15592940610682105', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:14:21', 0, 1002001015, '账号未登陆', '2019-05-31 17:14:21');
INSERT INTO `access_log` VALUES (16270, '65.52.15592940610692107', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.33', '2019-05-31 17:14:21', 0, 1002001015, '账号未登陆', '2019-05-31 17:14:21');
INSERT INTO `access_log` VALUES (16271, '65.45.15592940610882133', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.30', '2019-05-31 17:14:21', 0, 1002001015, '账号未登陆', '2019-05-31 17:14:21');
INSERT INTO `access_log` VALUES (16272, '65.51.15592940682142113', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.33', '2019-05-31 17:14:28', 87, 0, '', '2019-05-31 17:14:28');
INSERT INTO `access_log` VALUES (16273, '65.46.15592940685882117', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.33', '2019-05-31 17:14:29', 9, 0, '', '2019-05-31 17:14:29');
INSERT INTO `access_log` VALUES (16274, '65.48.15592940685902129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:14:29', 8, 0, '', '2019-05-31 17:14:29');
INSERT INTO `access_log` VALUES (16275, '65.47.15592940685882127', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:14:29', 92, 0, '', '2019-05-31 17:14:29');
INSERT INTO `access_log` VALUES (16276, '64.79.15592940705232075', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:14:31', 8, 0, '', '2019-05-31 17:14:31');
INSERT INTO `access_log` VALUES (16277, '64.81.15592940705232075', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:14:31', 11, 0, '', '2019-05-31 17:14:31');
INSERT INTO `access_log` VALUES (16278, '65.50.15592940734122131', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:14:33', 19, 0, '', '2019-05-31 17:14:33');
INSERT INTO `access_log` VALUES (16279, '65.53.15592940748672109', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:14:35', 10, 0, '', '2019-05-31 17:14:35');
INSERT INTO `access_log` VALUES (16280, '65.54.15592940758242107', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:14:36', 10, 0, '', '2019-05-31 17:14:36');
INSERT INTO `access_log` VALUES (16281, '65.52.15592940769362109', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:14:37', 15, 0, '', '2019-05-31 17:14:37');
INSERT INTO `access_log` VALUES (16282, '62.88.15592941037122597', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:15:04', 16, 0, '', '2019-05-31 17:15:04');
INSERT INTO `access_log` VALUES (16283, '62.87.15592941078522599', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.223.185.23', '2019-05-31 17:15:08', 17, 0, '', '2019-05-31 17:15:08');
INSERT INTO `access_log` VALUES (16284, '65.50.15592944610702137', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:21:01', 110, 0, '', '2019-05-31 17:21:01');
INSERT INTO `access_log` VALUES (16285, '65.53.15592944615142115', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:21:02', 10, 0, '', '2019-05-31 17:21:02');
INSERT INTO `access_log` VALUES (16286, '65.54.15592944615232113', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:21:02', 9, 0, '', '2019-05-31 17:21:02');
INSERT INTO `access_log` VALUES (16287, '65.52.15592944615232115', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:21:02', 8, 0, '', '2019-05-31 17:21:02');
INSERT INTO `access_log` VALUES (16288, '62.82.15592944675282603', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:21:08', 14, 0, '', '2019-05-31 17:21:08');
INSERT INTO `access_log` VALUES (16289, '62.86.15592944720002593', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:21:12', 16, 0, '', '2019-05-31 17:21:12');
INSERT INTO `access_log` VALUES (16290, '65.49.15592944799522139', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:21:20', 21, 0, '', '2019-05-31 17:21:20');
INSERT INTO `access_log` VALUES (16291, '65.48.15592944860992137', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:21:26', 10, 0, '', '2019-05-31 17:21:26');
INSERT INTO `access_log` VALUES (16292, '59.73.15592944863342695', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:21:26', 4, 0, '', '2019-05-31 17:21:26');
INSERT INTO `access_log` VALUES (16293, '59.80.15592944863402693', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.124.214', '2019-05-31 17:21:26', 14, 2001001000, '服务端发生异常', '2019-05-31 17:21:26');
INSERT INTO `access_log` VALUES (16294, '65.46.15592944910162125', 27, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:21:31', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-31 17:21:31');
INSERT INTO `access_log` VALUES (16295, '65.50.15592945009732139', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:21:41', 10, 0, '', '2019-05-31 17:21:41');
INSERT INTO `access_log` VALUES (16296, '65.53.15592945058992117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:21:46', 14, 0, '', '2019-05-31 17:21:46');
INSERT INTO `access_log` VALUES (16297, '65.47.15592945190452137', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:21:59', 8, 0, '', '2019-05-31 17:21:59');
INSERT INTO `access_log` VALUES (16298, '65.54.15592945281912115', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:22:08', 15, 0, '', '2019-05-31 17:22:08');
INSERT INTO `access_log` VALUES (16299, '65.51.15592945297552125', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:22:10', 10, 0, '', '2019-05-31 17:22:10');
INSERT INTO `access_log` VALUES (16300, '65.49.15592945304602143', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:22:10', 19, 0, '', '2019-05-31 17:22:10');
INSERT INTO `access_log` VALUES (16301, '62.85.15592945312082605', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:22:11', 15, 0, '', '2019-05-31 17:22:11');
INSERT INTO `access_log` VALUES (16302, '62.87.15592945316232607', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '58.63.60.83', '2019-05-31 17:22:12', 74, 0, '', '2019-05-31 17:22:12');
INSERT INTO `access_log` VALUES (16303, '59.77.15592945831092691', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:23:03', 3, 0, '', '2019-05-31 17:23:03');
INSERT INTO `access_log` VALUES (16304, '59.78.15592945831092701', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:23:03', 13, 2001001000, '服务端发生异常', '2019-05-31 17:23:03');
INSERT INTO `access_log` VALUES (16305, '64.83.15592945871962085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:23:07', 3, 0, '', '2019-05-31 17:23:07');
INSERT INTO `access_log` VALUES (16306, '64.84.15592945873062093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:23:07', 2, 0, '', '2019-05-31 17:23:07');
INSERT INTO `access_log` VALUES (16307, '64.80.15592945887432083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:23:09', 2, 0, '', '2019-05-31 17:23:09');
INSERT INTO `access_log` VALUES (16308, '64.81.15592945900812083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:23:10', 2, 0, '', '2019-05-31 17:23:10');
INSERT INTO `access_log` VALUES (16309, 'c2ef4f55-1a25-4eb9-a43f-8cc145dbd11b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:24:35', 51, 0, '', '2019-05-31 17:24:35');
INSERT INTO `access_log` VALUES (16310, 'a7a8b69b-a2b2-4a5b-8d55-8f74c59fcb92', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:24:35', 53, 0, '', '2019-05-31 17:24:35');
INSERT INTO `access_log` VALUES (16311, '08a80161-fdc7-4121-8677-c05f4eaa79d5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:24:35', 55, 0, '', '2019-05-31 17:24:35');
INSERT INTO `access_log` VALUES (16312, 'c8516bd9-a562-45ca-9092-793257e335fd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:24:39', 40, 0, '', '2019-05-31 17:24:39');
INSERT INTO `access_log` VALUES (16313, 'c2762f03-c4bc-426c-b871-4db8ed897786', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:24:39', 43, 0, '', '2019-05-31 17:24:39');
INSERT INTO `access_log` VALUES (16314, '65cd2a1b-5fc7-4bd2-b8e9-466d97687a6e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:24:39', 49, 0, '', '2019-05-31 17:24:39');
INSERT INTO `access_log` VALUES (16315, '73c7c204-4c5d-4fbc-b2b7-4eb3faebda64', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:24:40', 230, 0, '', '2019-05-31 17:24:40');
INSERT INTO `access_log` VALUES (16316, '64.76.15592946010732089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:23:21', 3, 0, '', '2019-05-31 17:23:21');
INSERT INTO `access_log` VALUES (16317, '64.82.15592946011842097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:23:21', 2, 0, '', '2019-05-31 17:23:21');
INSERT INTO `access_log` VALUES (16318, 'a6e68e3e-b7eb-4376-9001-bc6fccc601fe', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:24:56', 140, 0, '', '2019-05-31 17:24:56');
INSERT INTO `access_log` VALUES (16319, '65.54.15592946174062117', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:23:37', 0, 1002001015, '账号未登陆', '2019-05-31 17:23:37');
INSERT INTO `access_log` VALUES (16320, '65.52.15592946174122121', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:23:37', 1, 1002001015, '账号未登陆', '2019-05-31 17:23:37');
INSERT INTO `access_log` VALUES (16321, '65.51.15592946174182127', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:23:37', 0, 1002001015, '账号未登陆', '2019-05-31 17:23:37');
INSERT INTO `access_log` VALUES (16322, '65.48.15592946194082139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:23:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:23:39');
INSERT INTO `access_log` VALUES (16323, '0fc6e688-8753-4d22-baac-40a06b68156d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:24:59', 34, 0, '', '2019-05-31 17:24:59');
INSERT INTO `access_log` VALUES (16324, '0c14849c-6cf1-4378-8495-0b0c864132e7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:24:59', 37, 0, '', '2019-05-31 17:24:59');
INSERT INTO `access_log` VALUES (16325, 'da6c2ea0-e3a4-4b3b-a41d-ed4152c05322', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:24:59', 35, 0, '', '2019-05-31 17:24:59');
INSERT INTO `access_log` VALUES (16326, '794dcb4f-da88-46b2-9a68-73974eebdcf0', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:25:00', 56, 0, '', '2019-05-31 17:25:00');
INSERT INTO `access_log` VALUES (16327, '2d1dd061-7261-48ab-9db8-e31a81c56fa8', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 17:25:05', 45, 0, '', '2019-05-31 17:25:05');
INSERT INTO `access_log` VALUES (16328, '65.47.15592946260232141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:23:46', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:23:46');
INSERT INTO `access_log` VALUES (16329, '65.45.15592946345852145', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:23:55', 175, 0, '', '2019-05-31 17:23:55');
INSERT INTO `access_log` VALUES (16330, '65.53.15592946350172121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:23:55', 10, 0, '', '2019-05-31 17:23:55');
INSERT INTO `access_log` VALUES (16331, '65.50.15592946350152145', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:23:55', 9, 0, '', '2019-05-31 17:23:55');
INSERT INTO `access_log` VALUES (16332, '65.54.15592946350172119', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:23:55', 10, 0, '', '2019-05-31 17:23:55');
INSERT INTO `access_log` VALUES (16333, '62.88.15592946399362605', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:24:00', 16, 0, '', '2019-05-31 17:24:00');
INSERT INTO `access_log` VALUES (16334, '65.52.15592946413972123', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:24:01', 0, 1002001015, '账号未登陆', '2019-05-31 17:24:01');
INSERT INTO `access_log` VALUES (16335, '65.51.15592946414022129', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:24:01', 0, 1002001015, '账号未登陆', '2019-05-31 17:24:01');
INSERT INTO `access_log` VALUES (16336, '65.49.15592946414082147', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:24:01', 0, 1002001015, '账号未登陆', '2019-05-31 17:24:01');
INSERT INTO `access_log` VALUES (16337, '65.48.15592946432492141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:24:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:24:03');
INSERT INTO `access_log` VALUES (16338, '65.47.15592946460392143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:24:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:24:06');
INSERT INTO `access_log` VALUES (16339, '65.46.15592946470352131', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:24:07', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:24:07');
INSERT INTO `access_log` VALUES (16340, '65.45.15592946475062147', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:24:08', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:24:08');
INSERT INTO `access_log` VALUES (16341, '65.53.15592946478822123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:24:08', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:24:08');
INSERT INTO `access_log` VALUES (16342, '65.54.15592946482272121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:24:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:24:08');
INSERT INTO `access_log` VALUES (16343, '64.84.15592946501102095', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:24:10', 9, 0, '', '2019-05-31 17:24:10');
INSERT INTO `access_log` VALUES (16344, '64.83.15592946501102087', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:24:10', 11, 0, '', '2019-05-31 17:24:10');
INSERT INTO `access_log` VALUES (16345, '65.51.15592946534902131', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.65.239.150', '2019-05-31 17:24:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:24:14');
INSERT INTO `access_log` VALUES (16346, '66.55.15592946555611633', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:24:16', 16, 0, '', '2019-05-31 17:24:16');
INSERT INTO `access_log` VALUES (16347, '59.71.15592946622052699', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:24:22', 234, 0, '', '2019-05-31 17:24:22');
INSERT INTO `access_log` VALUES (16348, '65.52.15592946663712125', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:24:26', 19, 0, '', '2019-05-31 17:24:26');
INSERT INTO `access_log` VALUES (16349, '59.75.15592946731342697', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:24:33', 10, 0, '', '2019-05-31 17:24:33');
INSERT INTO `access_log` VALUES (16350, '66.52.15592946739151623', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:24:34', 13, 0, '', '2019-05-31 17:24:34');
INSERT INTO `access_log` VALUES (16351, '65.46.15592947086972133', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.233.219', '2019-05-31 17:25:09', 1, 1002001015, '账号未登陆', '2019-05-31 17:25:09');
INSERT INTO `access_log` VALUES (16352, '65.45.15592947087052149', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.233.219', '2019-05-31 17:25:09', 0, 1002001015, '账号未登陆', '2019-05-31 17:25:09');
INSERT INTO `access_log` VALUES (16353, '65.53.15592947087102125', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.233.219', '2019-05-31 17:25:09', 0, 1002001015, '账号未登陆', '2019-05-31 17:25:09');
INSERT INTO `access_log` VALUES (16354, '59.80.15592947088782697', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:25:09', 3, 0, '', '2019-05-31 17:25:09');
INSERT INTO `access_log` VALUES (16355, '59.72.15592947088792695', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.65.152.237', '2019-05-31 17:25:09', 12, 2001001000, '服务端发生异常', '2019-05-31 17:25:09');
INSERT INTO `access_log` VALUES (16356, '59.79.15592947130862697', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:25:13', 13, 2001001000, '服务端发生异常', '2019-05-31 17:25:13');
INSERT INTO `access_log` VALUES (16357, '59.74.15592947130842699', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:25:13', 860, 0, '', '2019-05-31 17:25:14');
INSERT INTO `access_log` VALUES (16358, '64.82.15592947174522099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:25:17', 28, 0, '', '2019-05-31 17:25:17');
INSERT INTO `access_log` VALUES (16359, '64.78.15592947175682097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:25:18', 2, 0, '', '2019-05-31 17:25:18');
INSERT INTO `access_log` VALUES (16360, '64.77.15592947189542095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:25:19', 2, 0, '', '2019-05-31 17:25:19');
INSERT INTO `access_log` VALUES (16361, '64.85.15592947195622097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:25:20', 2, 0, '', '2019-05-31 17:25:20');
INSERT INTO `access_log` VALUES (16362, '64.83.15592947210352089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:25:21', 2, 0, '', '2019-05-31 17:25:21');
INSERT INTO `access_log` VALUES (16363, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:25:21', 7, 0, '', '2019-05-31 17:25:21');
INSERT INTO `access_log` VALUES (16364, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:25:23', 7, 0, '', '2019-05-31 17:25:23');
INSERT INTO `access_log` VALUES (16365, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:25:24', 7, 0, '', '2019-05-31 17:25:24');
INSERT INTO `access_log` VALUES (16366, '59.71.15592947246232701', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:25:25', 3, 0, '', '2019-05-31 17:25:25');
INSERT INTO `access_log` VALUES (16367, '59.75.15592947246282699', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:25:25', 13, 2001001000, '服务端发生异常', '2019-05-31 17:25:25');
INSERT INTO `access_log` VALUES (16368, '64.80.15592947253332087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:25:25', 4, 0, '', '2019-05-31 17:25:25');
INSERT INTO `access_log` VALUES (16369, '64.81.15592947254372087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:25:25', 3, 0, '', '2019-05-31 17:25:25');
INSERT INTO `access_log` VALUES (16370, '64.79.15592947338072087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:25:34', 2, 0, '', '2019-05-31 17:25:34');
INSERT INTO `access_log` VALUES (16371, '64.76.15592947339032093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:25:34', 2, 0, '', '2019-05-31 17:25:34');
INSERT INTO `access_log` VALUES (16372, '65.51.15592947368942133', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:25:37', 0, 1002001015, '账号未登陆', '2019-05-31 17:25:37');
INSERT INTO `access_log` VALUES (16373, '65.49.15592947368972151', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:25:37', 0, 1002001015, '账号未登陆', '2019-05-31 17:25:37');
INSERT INTO `access_log` VALUES (16374, '65.52.15592947369002127', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:25:37', 0, 1002001015, '账号未登陆', '2019-05-31 17:25:37');
INSERT INTO `access_log` VALUES (16375, '64.78.15592947379632099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:25:38', 3, 0, '', '2019-05-31 17:25:38');
INSERT INTO `access_log` VALUES (16376, '59.73.15592947394562701', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:25:39', 3, 0, '', '2019-05-31 17:25:39');
INSERT INTO `access_log` VALUES (16377, '59.78.15592947394562705', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:25:39', 15, 2001001000, '服务端发生异常', '2019-05-31 17:25:39');
INSERT INTO `access_log` VALUES (16378, '65.47.15592947445842147', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.233.219', '2019-05-31 17:25:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:25:45');
INSERT INTO `access_log` VALUES (16379, '59.72.15592947481022697', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/603.3.8 (KHTML, like Gecko) Version/10.1.2 Safari/603.3.8', '58.243.254.176', '2019-05-31 17:25:48', 3, 0, '', '2019-05-31 17:25:48');
INSERT INTO `access_log` VALUES (16380, '59.80.15592947481012699', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/603.3.8 (KHTML, like Gecko) Version/10.1.2 Safari/603.3.8', '58.243.254.176', '2019-05-31 17:25:48', 14, 2001001000, '服务端发生异常', '2019-05-31 17:25:48');
INSERT INTO `access_log` VALUES (16381, '65.46.15592947481262135', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.233.219', '2019-05-31 17:25:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:25:48');
INSERT INTO `access_log` VALUES (16382, '65.53.15592947489772127', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.61.175.248', '2019-05-31 17:25:49', 20, 0, '', '2019-05-31 17:25:49');
INSERT INTO `access_log` VALUES (16383, '64.85.15592947506142099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:25:51', 3, 0, '', '2019-05-31 17:25:51');
INSERT INTO `access_log` VALUES (16384, '64.84.15592947506922099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:25:51', 2, 0, '', '2019-05-31 17:25:51');
INSERT INTO `access_log` VALUES (16385, '64.83.15592947560172091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/603.3.8 (KHTML, like Gecko) Version/10.1.2 Safari/603.3.8', '58.243.254.176', '2019-05-31 17:25:56', 2, 0, '', '2019-05-31 17:25:56');
INSERT INTO `access_log` VALUES (16386, '64.80.15592947561132089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/603.3.8 (KHTML, like Gecko) Version/10.1.2 Safari/603.3.8', '58.243.254.176', '2019-05-31 17:25:56', 2, 0, '', '2019-05-31 17:25:56');
INSERT INTO `access_log` VALUES (16387, '59.74.15592947588822701', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/603.3.8 (KHTML, like Gecko) Version/10.1.2 Safari/603.3.8', '58.243.254.176', '2019-05-31 17:25:59', 3, 0, '', '2019-05-31 17:25:59');
INSERT INTO `access_log` VALUES (16388, '59.76.15592947588822697', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/603.3.8 (KHTML, like Gecko) Version/10.1.2 Safari/603.3.8', '58.243.254.176', '2019-05-31 17:25:59', 13, 2001001000, '服务端发生异常', '2019-05-31 17:25:59');
INSERT INTO `access_log` VALUES (16389, '59.75.15592947596542701', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:26:00', 3, 0, '', '2019-05-31 17:26:00');
INSERT INTO `access_log` VALUES (16390, '59.71.15592947596542703', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:26:00', 14, 2001001000, '服务端发生异常', '2019-05-31 17:26:00');
INSERT INTO `access_log` VALUES (16391, '65.54.15592947619652125', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:26:02', 0, 1002001015, '账号未登陆', '2019-05-31 17:26:02');
INSERT INTO `access_log` VALUES (16392, '65.50.15592947619672151', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:26:02', 1, 1002001015, '账号未登陆', '2019-05-31 17:26:02');
INSERT INTO `access_log` VALUES (16393, '65.49.15592947619722153', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:26:02', 1, 1002001015, '账号未登陆', '2019-05-31 17:26:02');
INSERT INTO `access_log` VALUES (16394, '65.51.15592947660582135', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:26:06', 63, 0, '', '2019-05-31 17:26:06');
INSERT INTO `access_log` VALUES (16395, '65.52.15592947663062129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:26:06', 10, 0, '', '2019-05-31 17:26:06');
INSERT INTO `access_log` VALUES (16396, '65.48.15592947663092147', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:26:06', 9, 0, '', '2019-05-31 17:26:06');
INSERT INTO `access_log` VALUES (16397, '65.47.15592947663192149', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:26:06', 8, 0, '', '2019-05-31 17:26:06');
INSERT INTO `access_log` VALUES (16398, '64.79.15592947702772089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:26:10', 88, 0, '', '2019-05-31 17:26:10');
INSERT INTO `access_log` VALUES (16399, '64.76.15592947704912095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:26:10', 2, 0, '', '2019-05-31 17:26:10');
INSERT INTO `access_log` VALUES (16400, '66.55.15592947741591635', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:26:14', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-05-31 17:26:14');
INSERT INTO `access_log` VALUES (16401, '65.53.15592947794182129', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:26:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:26:19');
INSERT INTO `access_log` VALUES (16402, '64.78.15592947821042101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:26:22', 3, 0, '', '2019-05-31 17:26:22');
INSERT INTO `access_log` VALUES (16403, '64.77.15592947822062099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:26:22', 2, 0, '', '2019-05-31 17:26:22');
INSERT INTO `access_log` VALUES (16404, '64.85.15592947857732101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:26:26', 3, 0, '', '2019-05-31 17:26:26');
INSERT INTO `access_log` VALUES (16405, '64.84.15592947858622101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:26:26', 2, 0, '', '2019-05-31 17:26:26');
INSERT INTO `access_log` VALUES (16406, '66.52.15592947887611625', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:26:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空', '2019-05-31 17:26:29');
INSERT INTO `access_log` VALUES (16407, '65.50.15592947912492153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.233.219', '2019-05-31 17:26:31', 69, 0, '', '2019-05-31 17:26:31');
INSERT INTO `access_log` VALUES (16408, '64.83.15592947914712093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:26:31', 2, 0, '', '2019-05-31 17:26:31');
INSERT INTO `access_log` VALUES (16409, '64.80.15592947916082091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_1_2 like Mac OS X) AppleWebKit/537.51.2 (KHTML, like Gecko) Version/7.0 Mobile/11D257 Safari/9537.53', '113.65.152.237', '2019-05-31 17:26:32', 2, 0, '', '2019-05-31 17:26:32');
INSERT INTO `access_log` VALUES (16410, '65.49.15592947918522155', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.233.219', '2019-05-31 17:26:32', 10, 0, '', '2019-05-31 17:26:32');
INSERT INTO `access_log` VALUES (16411, '65.54.15592947918552127', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.233.219', '2019-05-31 17:26:32', 9, 0, '', '2019-05-31 17:26:32');
INSERT INTO `access_log` VALUES (16412, '65.51.15592947918622137', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.233.219', '2019-05-31 17:26:32', 9, 0, '', '2019-05-31 17:26:32');
INSERT INTO `access_log` VALUES (16413, '59.80.15592947959102701', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.237.23.109', '2019-05-31 17:26:36', 3, 0, '', '2019-05-31 17:26:36');
INSERT INTO `access_log` VALUES (16414, '59.72.15592947959122699', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.237.23.109', '2019-05-31 17:26:36', 14, 2001001000, '服务端发生异常', '2019-05-31 17:26:36');
INSERT INTO `access_log` VALUES (16415, '64.79.15592947989742091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.237.23.109', '2019-05-31 17:26:39', 2, 0, '', '2019-05-31 17:26:39');
INSERT INTO `access_log` VALUES (16416, '64.76.15592947991042097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.237.23.109', '2019-05-31 17:26:39', 2, 0, '', '2019-05-31 17:26:39');
INSERT INTO `access_log` VALUES (16417, '62.86.15592947995412603', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.233.219', '2019-05-31 17:26:40', 14, 0, '', '2019-05-31 17:26:40');
INSERT INTO `access_log` VALUES (16418, '64.82.15592948005782105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.237.23.109', '2019-05-31 17:26:41', 3, 0, '', '2019-05-31 17:26:41');
INSERT INTO `access_log` VALUES (16419, '64.78.15592948015532103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.237.23.109', '2019-05-31 17:26:42', 2, 0, '', '2019-05-31 17:26:42');
INSERT INTO `access_log` VALUES (16420, '64.77.15592948021942101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.237.23.109', '2019-05-31 17:26:42', 3, 0, '', '2019-05-31 17:26:42');
INSERT INTO `access_log` VALUES (16421, '64.85.15592948060752103', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.233.219', '2019-05-31 17:26:46', 10, 0, '', '2019-05-31 17:26:46');
INSERT INTO `access_log` VALUES (16422, '64.84.15592948060832103', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.233.219', '2019-05-31 17:26:46', 8, 0, '', '2019-05-31 17:26:46');
INSERT INTO `access_log` VALUES (16423, '62.81.15592948066082601', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:26:47', 14, 0, '', '2019-05-31 17:26:47');
INSERT INTO `access_log` VALUES (16424, '64.80.15592948103402093', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:26:50', 9, 0, '', '2019-05-31 17:26:50');
INSERT INTO `access_log` VALUES (16425, '64.83.15592948103382095', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:26:50', 11, 0, '', '2019-05-31 17:26:50');
INSERT INTO `access_log` VALUES (16426, '64.79.15592948133462093', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:26:53', 10, 0, '', '2019-05-31 17:26:53');
INSERT INTO `access_log` VALUES (16427, '66.57.15592948157231627', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:26:56', 14, 0, '', '2019-05-31 17:26:56');
INSERT INTO `access_log` VALUES (16428, '59.74.15592948196652703', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.233.219', '2019-05-31 17:27:00', 24, 0, '', '2019-05-31 17:27:00');
INSERT INTO `access_log` VALUES (16429, '59.76.15592948196682699', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:27:00', 23, 0, '', '2019-05-31 17:27:00');
INSERT INTO `access_log` VALUES (16430, '65.47.15592948225072151', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:27:03', 714, 0, '', '2019-05-31 17:27:03');
INSERT INTO `access_log` VALUES (16431, '65.46.15592948238642139', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:27:04', 10, 0, '', '2019-05-31 17:27:04');
INSERT INTO `access_log` VALUES (16432, '65.53.15592948253462131', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:27:05', 10, 0, '', '2019-05-31 17:27:05');
INSERT INTO `access_log` VALUES (16433, '65.45.15592948283732155', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:27:08', 14, 0, '', '2019-05-31 17:27:08');
INSERT INTO `access_log` VALUES (16434, '65.54.15592948451712129', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:27:25', 10, 0, '', '2019-05-31 17:27:25');
INSERT INTO `access_log` VALUES (16435, '65.48.15592948747862151', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:27:55', 10, 0, '', '2019-05-31 17:27:55');
INSERT INTO `access_log` VALUES (16436, '65.47.15592948747882153', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:27:55', 9, 0, '', '2019-05-31 17:27:55');
INSERT INTO `access_log` VALUES (16437, '65.46.15592948747912141', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.222.51', '2019-05-31 17:27:55', 10, 0, '', '2019-05-31 17:27:55');
INSERT INTO `access_log` VALUES (16438, '65.50.15592950686912159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:31:09', 79, 0, '', '2019-05-31 17:31:09');
INSERT INTO `access_log` VALUES (16439, '65.54.15592950691232133', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:31:09', 10, 0, '', '2019-05-31 17:31:09');
INSERT INTO `access_log` VALUES (16440, '65.51.15592950691292143', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:31:09', 10, 0, '', '2019-05-31 17:31:09');
INSERT INTO `access_log` VALUES (16441, '65.52.15592950691922137', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:31:09', 10, 0, '', '2019-05-31 17:31:09');
INSERT INTO `access_log` VALUES (16442, '62.84.15592950898542613', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:31:30', 14, 0, '', '2019-05-31 17:31:30');
INSERT INTO `access_log` VALUES (16443, '62.80.15592950926722615', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:31:33', 14, 0, '', '2019-05-31 17:31:33');
INSERT INTO `access_log` VALUES (16444, '62.85.15592950981632619', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:31:38', 12, 0, '', '2019-05-31 17:31:38');
INSERT INTO `access_log` VALUES (16445, '64.79.15592951049772097', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:31:45', 13, 0, '', '2019-05-31 17:31:45');
INSERT INTO `access_log` VALUES (16446, '64.76.15592951049852103', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:31:45', 9, 0, '', '2019-05-31 17:31:45');
INSERT INTO `access_log` VALUES (16447, '65.46.15592951093592145', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:31:49', 19, 0, '', '2019-05-31 17:31:49');
INSERT INTO `access_log` VALUES (16448, '59.71.15592951139182709', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:31:54', 14, 0, '', '2019-05-31 17:31:54');
INSERT INTO `access_log` VALUES (16449, '59.75.15592951193922707', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:31:59', 289, 2001001000, '服务端发生异常', '2019-05-31 17:32:00');
INSERT INTO `access_log` VALUES (16450, '59.77.15592951239962703', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:32:04', 14, 0, '', '2019-05-31 17:32:04');
INSERT INTO `access_log` VALUES (16451, '59.78.15592951270472713', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:32:07', 10, 0, '', '2019-05-31 17:32:07');
INSERT INTO `access_log` VALUES (16452, '59.72.15592951290282705', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:32:09', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-31 17:32:09');
INSERT INTO `access_log` VALUES (16453, '62.86.15592951382892609', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.143.206.106', '2019-05-31 17:32:18', 13, 0, '', '2019-05-31 17:32:18');
INSERT INTO `access_log` VALUES (16454, '65.52.15592951996582139', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:33:20', 0, 1002001015, '账号未登陆', '2019-05-31 17:33:20');
INSERT INTO `access_log` VALUES (16455, '65.47.15592951996612159', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:33:20', 0, 1002001015, '账号未登陆', '2019-05-31 17:33:20');
INSERT INTO `access_log` VALUES (16456, '65.48.15592951996672157', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:33:20', 1, 1002001015, '账号未登陆', '2019-05-31 17:33:20');
INSERT INTO `access_log` VALUES (16457, '65.53.15592952068462139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:33:27', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:33:27');
INSERT INTO `access_log` VALUES (16458, '65.50.15592952237822163', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:33:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:33:44');
INSERT INTO `access_log` VALUES (16459, '59.72.15592952618732707', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.194.106.90', '2019-05-31 17:34:22', 10, 0, '', '2019-05-31 17:34:22');
INSERT INTO `access_log` VALUES (16460, '59.80.15592952618742709', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.194.106.90', '2019-05-31 17:34:22', 13, 2001001000, '服务端发生异常', '2019-05-31 17:34:22');
INSERT INTO `access_log` VALUES (16461, '64.78.15592952642992111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.194.106.90', '2019-05-31 17:34:24', 3, 0, '', '2019-05-31 17:34:24');
INSERT INTO `access_log` VALUES (16462, '64.77.15592952643952109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.194.106.90', '2019-05-31 17:34:24', 3, 0, '', '2019-05-31 17:34:24');
INSERT INTO `access_log` VALUES (16463, '64.84.15592952657692111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.194.106.90', '2019-05-31 17:34:26', 3, 0, '', '2019-05-31 17:34:26');
INSERT INTO `access_log` VALUES (16464, '65.49.15592953892162167', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '112.112.102.55', '2019-05-31 17:36:29', 1, 1002001015, '账号未登陆', '2019-05-31 17:36:29');
INSERT INTO `access_log` VALUES (16465, '65.51.15592953892182147', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '112.112.102.55', '2019-05-31 17:36:29', 0, 1002001015, '账号未登陆', '2019-05-31 17:36:29');
INSERT INTO `access_log` VALUES (16466, '65.54.15592953892232139', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '112.112.102.55', '2019-05-31 17:36:29', 0, 1002001015, '账号未登陆', '2019-05-31 17:36:29');
INSERT INTO `access_log` VALUES (16467, '65.47.15592953921932165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '112.112.102.55', '2019-05-31 17:36:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:36:32');
INSERT INTO `access_log` VALUES (16468, '65.48.15592953986772163', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '112.112.102.55', '2019-05-31 17:36:39', 191, 0, '', '2019-05-31 17:36:39');
INSERT INTO `access_log` VALUES (16469, '65.53.15592953992732145', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '112.112.102.55', '2019-05-31 17:36:39', 334, 0, '', '2019-05-31 17:36:40');
INSERT INTO `access_log` VALUES (16470, '65.46.15592953992732151', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '112.112.102.55', '2019-05-31 17:36:39', 335, 0, '', '2019-05-31 17:36:40');
INSERT INTO `access_log` VALUES (16471, '65.45.15592953992792169', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '112.112.102.55', '2019-05-31 17:36:39', 330, 0, '', '2019-05-31 17:36:40');
INSERT INTO `access_log` VALUES (16472, '64.84.15592954065332113', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '112.112.102.55', '2019-05-31 17:36:47', 14, 0, '', '2019-05-31 17:36:47');
INSERT INTO `access_log` VALUES (16473, '64.85.15592954065402113', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '112.112.102.55', '2019-05-31 17:36:47', 11, 0, '', '2019-05-31 17:36:47');
INSERT INTO `access_log` VALUES (16474, '65.49.15592954263142169', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '112.112.102.55', '2019-05-31 17:37:06', 11, 0, '', '2019-05-31 17:37:06');
INSERT INTO `access_log` VALUES (16475, '65.54.15592954279962141', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '112.112.102.55', '2019-05-31 17:37:08', 14, 0, '', '2019-05-31 17:37:08');
INSERT INTO `access_log` VALUES (16476, '59.75.15592954724592713', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:37:52', 4, 0, '', '2019-05-31 17:37:52');
INSERT INTO `access_log` VALUES (16477, '59.77.15592954724622711', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:37:52', 12, 2001001000, '服务端发生异常', '2019-05-31 17:37:52');
INSERT INTO `access_log` VALUES (16478, '64.82.15592954776802117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:37:58', 3, 0, '', '2019-05-31 17:37:58');
INSERT INTO `access_log` VALUES (16479, '64.78.15592954778262115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:37:58', 2, 0, '', '2019-05-31 17:37:58');
INSERT INTO `access_log` VALUES (16480, '64.77.15592954816942113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:38:02', 3, 0, '', '2019-05-31 17:38:02');
INSERT INTO `access_log` VALUES (16481, '64.85.15592954818232115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:38:02', 3, 0, '', '2019-05-31 17:38:02');
INSERT INTO `access_log` VALUES (16482, '64.84.15592954826852115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:38:03', 2, 0, '', '2019-05-31 17:38:03');
INSERT INTO `access_log` VALUES (16483, '64.83.15592954834202107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:38:03', 2, 0, '', '2019-05-31 17:38:03');
INSERT INTO `access_log` VALUES (16484, '59.73.15592954845312715', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:38:05', 2, 0, '', '2019-05-31 17:38:05');
INSERT INTO `access_log` VALUES (16485, '59.71.15592954845312715', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.65.186.186', '2019-05-31 17:38:05', 10, 2001001000, '服务端发生异常', '2019-05-31 17:38:05');
INSERT INTO `access_log` VALUES (16486, '59.77.15592955857232713', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.156.152.197', '2019-05-31 17:39:46', 3, 0, '', '2019-05-31 17:39:46');
INSERT INTO `access_log` VALUES (16487, '59.76.15592955857242713', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.156.152.197', '2019-05-31 17:39:46', 14, 2001001000, '服务端发生异常', '2019-05-31 17:39:46');
INSERT INTO `access_log` VALUES (16488, '59.74.15592956498592717', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.194.246.217', '2019-05-31 17:40:50', 10, 0, '', '2019-05-31 17:40:50');
INSERT INTO `access_log` VALUES (16489, '59.79.15592956498592717', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.194.246.217', '2019-05-31 17:40:50', 14, 2001001000, '服务端发生异常', '2019-05-31 17:40:50');
INSERT INTO `access_log` VALUES (16490, '59.75.15592956616222717', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.194.246.217', '2019-05-31 17:41:02', 3, 0, '', '2019-05-31 17:41:02');
INSERT INTO `access_log` VALUES (16491, '59.77.15592956616222715', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.194.246.217', '2019-05-31 17:41:02', 20, 2001001000, '服务端发生异常', '2019-05-31 17:41:02');
INSERT INTO `access_log` VALUES (16492, '64.76.15592956642672113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.194.246.217', '2019-05-31 17:41:04', 2, 0, '', '2019-05-31 17:41:04');
INSERT INTO `access_log` VALUES (16493, '64.79.15592956643672107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.194.246.217', '2019-05-31 17:41:04', 2, 0, '', '2019-05-31 17:41:04');
INSERT INTO `access_log` VALUES (16494, '64.78.15592956660322119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.194.246.217', '2019-05-31 17:41:06', 2, 0, '', '2019-05-31 17:41:06');
INSERT INTO `access_log` VALUES (16495, '64.77.15592956666642117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.194.246.217', '2019-05-31 17:41:07', 2, 0, '', '2019-05-31 17:41:07');
INSERT INTO `access_log` VALUES (16496, '64.85.15592956674292119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.194.246.217', '2019-05-31 17:41:07', 3, 0, '', '2019-05-31 17:41:07');
INSERT INTO `access_log` VALUES (16497, '64.84.15592956680162119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.194.246.217', '2019-05-31 17:41:08', 2, 0, '', '2019-05-31 17:41:08');
INSERT INTO `access_log` VALUES (16498, '64.83.15592956690352111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.194.246.217', '2019-05-31 17:41:09', 3, 0, '', '2019-05-31 17:41:09');
INSERT INTO `access_log` VALUES (16499, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.194.246.217', '2019-05-31 17:41:09', 7, 0, '', '2019-05-31 17:41:09');
INSERT INTO `access_log` VALUES (16500, '64.80.15592956706992109', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.194.246.217', '2019-05-31 17:41:11', 9, 0, '', '2019-05-31 17:41:11');
INSERT INTO `access_log` VALUES (16501, '66.53.15592956747741645', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.194.246.217', '2019-05-31 17:41:15', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-05-31 17:41:15');
INSERT INTO `access_log` VALUES (16502, '66.57.15592956920431639', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18911958691&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.194.246.217', '2019-05-31 17:41:32', 10, 1001003000, '验证码不存在', '2019-05-31 17:41:32');
INSERT INTO `access_log` VALUES (16503, '59.77.15592965376322727', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.22.27.195', '2019-05-31 17:55:38', 4, 0, '', '2019-05-31 17:55:38');
INSERT INTO `access_log` VALUES (16504, '59.76.15592965376322727', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.22.27.195', '2019-05-31 17:55:38', 13, 2001001000, '服务端发生异常', '2019-05-31 17:55:38');
INSERT INTO `access_log` VALUES (16505, '64.83.15592965425052123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.22.27.195', '2019-05-31 17:55:43', 3, 0, '', '2019-05-31 17:55:43');
INSERT INTO `access_log` VALUES (16506, '64.80.15592965429812121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.22.27.195', '2019-05-31 17:55:43', 3, 0, '', '2019-05-31 17:55:43');
INSERT INTO `access_log` VALUES (16507, '64.81.15592965451972121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.22.27.195', '2019-05-31 17:55:45', 2, 0, '', '2019-05-31 17:55:45');
INSERT INTO `access_log` VALUES (16508, '64.76.15592965462742127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.22.27.195', '2019-05-31 17:55:46', 2, 0, '', '2019-05-31 17:55:46');
INSERT INTO `access_log` VALUES (16509, '65.47.15592965923882183', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:56:32', 0, 1002001015, '账号未登陆', '2019-05-31 17:56:32');
INSERT INTO `access_log` VALUES (16510, '65.45.15592965923892187', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:56:32', 0, 1002001015, '账号未登陆', '2019-05-31 17:56:32');
INSERT INTO `access_log` VALUES (16511, '65.51.15592965923892165', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:56:32', 0, 1002001015, '账号未登陆', '2019-05-31 17:56:32');
INSERT INTO `access_log` VALUES (16512, '65.46.15592965966132167', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:56:37', 5, 1002002000, '账号不存在', '2019-05-31 17:56:37');
INSERT INTO `access_log` VALUES (16513, '65.49.15592966041582187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:56:44', 99, 0, '', '2019-05-31 17:56:44');
INSERT INTO `access_log` VALUES (16514, '65.54.15592966046712157', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:56:45', 9, 0, '', '2019-05-31 17:56:45');
INSERT INTO `access_log` VALUES (16515, '65.50.15592966046802185', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:56:45', 8, 0, '', '2019-05-31 17:56:45');
INSERT INTO `access_log` VALUES (16516, '65.52.15592966046812165', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:56:45', 8, 0, '', '2019-05-31 17:56:45');
INSERT INTO `access_log` VALUES (16517, '64.85.15592966071642133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '223.167.152.70', '2019-05-31 17:56:47', 3, 0, '', '2019-05-31 17:56:47');
INSERT INTO `access_log` VALUES (16518, '62.89.15592966135522641', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:56:54', 14, 0, '', '2019-05-31 17:56:54');
INSERT INTO `access_log` VALUES (16519, '62.82.15592966166862643', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:56:57', 13, 0, '', '2019-05-31 17:56:57');
INSERT INTO `access_log` VALUES (16520, '62.86.15592966193292633', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:56:59', 17, 0, '', '2019-05-31 17:56:59');
INSERT INTO `access_log` VALUES (16521, '62.84.15592966281422639', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:57:08', 11, 0, '', '2019-05-31 17:57:08');
INSERT INTO `access_log` VALUES (16522, '64.81.15592966321312123', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:57:12', 9, 0, '', '2019-05-31 17:57:12');
INSERT INTO `access_log` VALUES (16523, '64.80.15592966321312123', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:57:12', 13, 0, '', '2019-05-31 17:57:12');
INSERT INTO `access_log` VALUES (16524, '64.76.15592966355112129', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:57:16', 16, 0, '', '2019-05-31 17:57:16');
INSERT INTO `access_log` VALUES (16525, '64.79.15592966355132123', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:57:16', 12, 0, '', '2019-05-31 17:57:16');
INSERT INTO `access_log` VALUES (16526, '64.77.15592966415852133', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:57:22', 8, 0, '', '2019-05-31 17:57:22');
INSERT INTO `access_log` VALUES (16527, '64.78.15592966415822135', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:57:22', 13, 0, '', '2019-05-31 17:57:22');
INSERT INTO `access_log` VALUES (16528, '59.75.15592966475252731', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '125.41.206.65', '2019-05-31 17:57:28', 13, 0, '', '2019-05-31 17:57:28');
INSERT INTO `access_log` VALUES (16529, '65.53.15592966755232165', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-05-31 17:57:56', 1, 1002001015, '账号未登陆', '2019-05-31 17:57:56');
INSERT INTO `access_log` VALUES (16530, '65.49.15592966755232189', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-05-31 17:57:56', 0, 1002001015, '账号未登陆', '2019-05-31 17:57:56');
INSERT INTO `access_log` VALUES (16531, '65.54.15592966755272159', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-05-31 17:57:56', 0, 1002001015, '账号未登陆', '2019-05-31 17:57:56');
INSERT INTO `access_log` VALUES (16532, '65.50.15592966775452187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-05-31 17:57:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 17:57:58');
INSERT INTO `access_log` VALUES (16533, '65.45.15592967278602191', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.177.20.132', '2019-05-31 17:58:48', 0, 1002001015, '账号未登陆', '2019-05-31 17:58:48');
INSERT INTO `access_log` VALUES (16534, '65.51.15592967278652169', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.177.20.132', '2019-05-31 17:58:48', 0, 1002001015, '账号未登陆', '2019-05-31 17:58:48');
INSERT INTO `access_log` VALUES (16535, '65.46.15592967278732171', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.177.20.132', '2019-05-31 17:58:48', 0, 1002001015, '账号未登陆', '2019-05-31 17:58:48');
INSERT INTO `access_log` VALUES (16536, '65.53.15592967356472167', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.177.20.132', '2019-05-31 17:58:56', 85, 0, '', '2019-05-31 17:58:56');
INSERT INTO `access_log` VALUES (16537, '65.50.15592967390042191', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.177.20.132', '2019-05-31 17:58:59', 278, 0, '', '2019-05-31 17:58:59');
INSERT INTO `access_log` VALUES (16538, '65.54.15592967390042161', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.177.20.132', '2019-05-31 17:58:59', 278, 0, '', '2019-05-31 17:58:59');
INSERT INTO `access_log` VALUES (16539, '65.48.15592967390072187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.177.20.132', '2019-05-31 17:58:59', 275, 0, '', '2019-05-31 17:58:59');
INSERT INTO `access_log` VALUES (16540, '62.84.15592967539962641', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.177.20.132', '2019-05-31 17:59:14', 14, 0, '', '2019-05-31 17:59:14');
INSERT INTO `access_log` VALUES (16541, '62.80.15592967570412643', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.177.20.132', '2019-05-31 17:59:17', 79, 0, '', '2019-05-31 17:59:17');
INSERT INTO `access_log` VALUES (16542, '59.74.15592967665782733', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.177.20.132', '2019-05-31 17:59:27', 14, 0, '', '2019-05-31 17:59:27');
INSERT INTO `access_log` VALUES (16543, '65.53.15592967705072169', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.177.20.132', '2019-05-31 17:59:31', 21, 0, '', '2019-05-31 17:59:31');
INSERT INTO `access_log` VALUES (16544, '65.52.15592967717622169', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.177.20.132', '2019-05-31 17:59:32', 9, 0, '', '2019-05-31 17:59:32');
INSERT INTO `access_log` VALUES (16545, '65.54.15592967727112163', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 17:59:33', 1, 1002001015, '账号未登陆', '2019-05-31 17:59:33');
INSERT INTO `access_log` VALUES (16546, '65.50.15592967727142193', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 17:59:33', 0, 1002001015, '账号未登陆', '2019-05-31 17:59:33');
INSERT INTO `access_log` VALUES (16547, '65.48.15592967727252189', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 17:59:33', 1, 1002001015, '账号未登陆', '2019-05-31 17:59:33');
INSERT INTO `access_log` VALUES (16548, '59.80.15592968422232733', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.32.152.214', '2019-05-31 18:00:42', 3, 0, '', '2019-05-31 18:00:42');
INSERT INTO `access_log` VALUES (16549, '59.78.15592968422232739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.32.152.214', '2019-05-31 18:00:42', 10, 2001001000, '服务端发生异常', '2019-05-31 18:00:42');
INSERT INTO `access_log` VALUES (16550, '65.50.15592968789862195', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:01:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 18:01:19');
INSERT INTO `access_log` VALUES (16551, '65.48.15592968922482191', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:01:32', 107, 0, '', '2019-05-31 18:01:32');
INSERT INTO `access_log` VALUES (16552, '65.47.15592968927862193', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:01:33', 8, 0, '', '2019-05-31 18:01:33');
INSERT INTO `access_log` VALUES (16553, '65.46.15592968928502179', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:01:33', 40, 0, '', '2019-05-31 18:01:33');
INSERT INTO `access_log` VALUES (16554, '65.45.15592968927862197', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:01:33', 109, 0, '', '2019-05-31 18:01:33');
INSERT INTO `access_log` VALUES (16555, '59.76.15592968952512733', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.22.114.132', '2019-05-31 18:01:35', 3, 0, '', '2019-05-31 18:01:35');
INSERT INTO `access_log` VALUES (16556, '59.77.15592968952622733', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '58.22.114.132', '2019-05-31 18:01:35', 13, 2001001000, '服务端发生异常', '2019-05-31 18:01:35');
INSERT INTO `access_log` VALUES (16557, '59.80.15592969209902735', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:01', 13, 2001001000, '服务端发生异常', '2019-05-31 18:02:01');
INSERT INTO `access_log` VALUES (16558, '59.71.15592969209902737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:01', 241, 0, '', '2019-05-31 18:02:01');
INSERT INTO `access_log` VALUES (16559, '64.78.15592969279122139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:08', 6, 0, '', '2019-05-31 18:02:08');
INSERT INTO `access_log` VALUES (16560, '64.85.15592969280232139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:08', 3, 0, '', '2019-05-31 18:02:08');
INSERT INTO `access_log` VALUES (16561, '59.72.15592969351012733', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:15', 3, 0, '', '2019-05-31 18:02:15');
INSERT INTO `access_log` VALUES (16562, '59.79.15592969351022737', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:15', 13, 2001001000, '服务端发生异常', '2019-05-31 18:02:15');
INSERT INTO `access_log` VALUES (16563, '64.84.15592969374002139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:17', 2, 0, '', '2019-05-31 18:02:17');
INSERT INTO `access_log` VALUES (16564, '64.83.15592969375362131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:18', 2, 0, '', '2019-05-31 18:02:18');
INSERT INTO `access_log` VALUES (16565, '64.81.15592969390442129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:19', 2, 0, '', '2019-05-31 18:02:19');
INSERT INTO `access_log` VALUES (16566, '64.80.15592969400042129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:20', 5, 0, '', '2019-05-31 18:02:20');
INSERT INTO `access_log` VALUES (16567, '59.75.15592969414532737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:21', 3, 0, '', '2019-05-31 18:02:21');
INSERT INTO `access_log` VALUES (16568, '59.77.15592969414542735', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:21', 13, 2001001000, '服务端发生异常', '2019-05-31 18:02:21');
INSERT INTO `access_log` VALUES (16569, '64.79.15592969445482129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:25', 2, 0, '', '2019-05-31 18:02:25');
INSERT INTO `access_log` VALUES (16570, '64.82.15592969446272143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:25', 2, 0, '', '2019-05-31 18:02:25');
INSERT INTO `access_log` VALUES (16571, '59.76.15592969470962735', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:27', 2, 0, '', '2019-05-31 18:02:27');
INSERT INTO `access_log` VALUES (16572, '59.73.15592969470962739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.167.178.154', '2019-05-31 18:02:27', 15, 2001001000, '服务端发生异常', '2019-05-31 18:02:27');
INSERT INTO `access_log` VALUES (16573, '65.50.15592971080762199', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:05:08', 4, 1002001012, '访问令牌已过期', '2019-05-31 18:05:08');
INSERT INTO `access_log` VALUES (16574, '65.54.15592971080762169', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:05:08', 4, 1002001012, '访问令牌已过期', '2019-05-31 18:05:08');
INSERT INTO `access_log` VALUES (16575, '65.48.15592971080852195', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:05:08', 2, 1002001012, '访问令牌已过期', '2019-05-31 18:05:08');
INSERT INTO `access_log` VALUES (16576, '65.46.15592971113572183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:05:11', 737, 0, '', '2019-05-31 18:05:12');
INSERT INTO `access_log` VALUES (16577, '65.45.15592971135492201', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:05:14', 1169, 0, '', '2019-05-31 18:05:15');
INSERT INTO `access_log` VALUES (16578, '65.49.15592971135502199', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:05:14', 1168, 0, '', '2019-05-31 18:05:15');
INSERT INTO `access_log` VALUES (16579, '65.51.15592971135502179', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:05:14', 1170, 0, '', '2019-05-31 18:05:15');
INSERT INTO `access_log` VALUES (16580, '62.86.15592971244782641', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:05:24', 14, 0, '', '2019-05-31 18:05:24');
INSERT INTO `access_log` VALUES (16581, '62.84.15592971374592647', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:05:37', 147, 0, '', '2019-05-31 18:05:38');
INSERT INTO `access_log` VALUES (16582, '64.83.15592971408492135', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:05:41', 32, 0, '', '2019-05-31 18:05:41');
INSERT INTO `access_log` VALUES (16583, '64.84.15592971408462143', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:05:41', 37, 0, '', '2019-05-31 18:05:41');
INSERT INTO `access_log` VALUES (16584, '64.76.15592971672752139', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:06:07', 12, 0, '', '2019-05-31 18:06:07');
INSERT INTO `access_log` VALUES (16585, '64.79.15592971672902133', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:06:07', 9, 0, '', '2019-05-31 18:06:07');
INSERT INTO `access_log` VALUES (16586, '64.82.15592971702712147', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:06:10', 10, 0, '', '2019-05-31 18:06:10');
INSERT INTO `access_log` VALUES (16587, '59.75.15592971907562741', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:06:31', 57, 0, '', '2019-05-31 18:06:31');
INSERT INTO `access_log` VALUES (16588, '59.77.15592971935312739', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:06:34', 22, 2001001000, '服务端发生异常', '2019-05-31 18:06:34');
INSERT INTO `access_log` VALUES (16589, '59.73.15592971966672743', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:06:37', 13, 0, '', '2019-05-31 18:06:37');
INSERT INTO `access_log` VALUES (16590, '59.71.15592971993272743', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:06:39', 10, 0, '', '2019-05-31 18:06:39');
INSERT INTO `access_log` VALUES (16591, '65.50.15592972034472203', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:06:43', 19, 0, '', '2019-05-31 18:06:43');
INSERT INTO `access_log` VALUES (16592, '65.47.15592972042532201', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:06:44', 10, 0, '', '2019-05-31 18:06:44');
INSERT INTO `access_log` VALUES (16593, '65.46.15592972050272187', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:06:45', 9, 0, '', '2019-05-31 18:06:45');
INSERT INTO `access_log` VALUES (16594, '65.45.15592972060492203', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:06:46', 11, 0, '', '2019-05-31 18:06:46');
INSERT INTO `access_log` VALUES (16595, '65.49.15592972074482201', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:06:47', 9, 0, '', '2019-05-31 18:06:47');
INSERT INTO `access_log` VALUES (16596, '65.53.15592972079532179', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:06:48', 10, 0, '', '2019-05-31 18:06:48');
INSERT INTO `access_log` VALUES (16597, '65.51.15592972083612183', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.39.210', '2019-05-31 18:06:48', 18, 0, '', '2019-05-31 18:06:48');
INSERT INTO `access_log` VALUES (16598, '65.54.15592972424992175', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.224.19.194', '2019-05-31 18:07:23', 0, 1002001015, '账号未登陆', '2019-05-31 18:07:23');
INSERT INTO `access_log` VALUES (16599, '65.47.15592972425042203', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.224.19.194', '2019-05-31 18:07:23', 1, 1002001015, '账号未登陆', '2019-05-31 18:07:23');
INSERT INTO `access_log` VALUES (16600, '65.50.15592972425042205', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.224.19.194', '2019-05-31 18:07:23', 1, 1002001015, '账号未登陆', '2019-05-31 18:07:23');
INSERT INTO `access_log` VALUES (16601, '65.45.15592972449422205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.224.19.194', '2019-05-31 18:07:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 18:07:25');
INSERT INTO `access_log` VALUES (16602, '65.49.15592972507022203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.224.19.194', '2019-05-31 18:07:31', 96, 0, '', '2019-05-31 18:07:31');
INSERT INTO `access_log` VALUES (16603, '65.51.15592972511202185', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.224.19.194', '2019-05-31 18:07:31', 18, 0, '', '2019-05-31 18:07:31');
INSERT INTO `access_log` VALUES (16604, '65.53.15592972511192181', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.224.19.194', '2019-05-31 18:07:31', 18, 0, '', '2019-05-31 18:07:31');
INSERT INTO `access_log` VALUES (16605, '65.52.15592972511262181', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.224.19.194', '2019-05-31 18:07:31', 20, 0, '', '2019-05-31 18:07:31');
INSERT INTO `access_log` VALUES (16606, '64.80.15592972580292135', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.224.19.194', '2019-05-31 18:07:38', 12, 0, '', '2019-05-31 18:07:38');
INSERT INTO `access_log` VALUES (16607, '64.79.15592972580372135', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.224.19.194', '2019-05-31 18:07:38', 7, 0, '', '2019-05-31 18:07:38');
INSERT INTO `access_log` VALUES (16608, '64.76.15592972684032141', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.224.19.194', '2019-05-31 18:07:48', 12, 0, '', '2019-05-31 18:07:48');
INSERT INTO `access_log` VALUES (16609, '64.82.15592972684072149', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.224.19.194', '2019-05-31 18:07:48', 9, 0, '', '2019-05-31 18:07:48');
INSERT INTO `access_log` VALUES (16610, '64.85.15592972938082147', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.224.19.194', '2019-05-31 18:08:14', 1, 1002001015, '账号未登陆', '2019-05-31 18:08:14');
INSERT INTO `access_log` VALUES (16611, '59.80.15592973537272743', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.97.237.20', '2019-05-31 18:09:14', 3, 0, '', '2019-05-31 18:09:14');
INSERT INTO `access_log` VALUES (16612, '59.78.15592973537392749', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.97.237.20', '2019-05-31 18:09:14', 10, 2001001000, '服务端发生异常', '2019-05-31 18:09:14');
INSERT INTO `access_log` VALUES (16613, '64.76.15592973608172143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.97.237.20', '2019-05-31 18:09:21', 3, 0, '', '2019-05-31 18:09:21');
INSERT INTO `access_log` VALUES (16614, '64.82.15592973609052151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.97.237.20', '2019-05-31 18:09:21', 2, 0, '', '2019-05-31 18:09:21');
INSERT INTO `access_log` VALUES (16615, '65.53.15592975438822185', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:12:24', 10, 0, '', '2019-05-31 18:12:24');
INSERT INTO `access_log` VALUES (16616, '65.48.15592975438832205', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:12:24', 10, 0, '', '2019-05-31 18:12:24');
INSERT INTO `access_log` VALUES (16617, '65.50.15592975438832211', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:12:24', 9, 0, '', '2019-05-31 18:12:24');
INSERT INTO `access_log` VALUES (16618, '65.54.15592975486612181', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:12:29', 19, 0, '', '2019-05-31 18:12:29');
INSERT INTO `access_log` VALUES (16619, '65.46.15592975486612195', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:12:29', 20, 0, '', '2019-05-31 18:12:29');
INSERT INTO `access_log` VALUES (16620, '65.45.15592975486632211', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:12:29', 18, 0, '', '2019-05-31 18:12:29');
INSERT INTO `access_log` VALUES (16621, '65.49.15592975535042209', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:12:34', 10, 0, '', '2019-05-31 18:12:34');
INSERT INTO `access_log` VALUES (16622, '65.52.15592975535092187', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:12:34', 11, 0, '', '2019-05-31 18:12:34');
INSERT INTO `access_log` VALUES (16623, '65.51.15592975535142191', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:12:34', 9, 0, '', '2019-05-31 18:12:34');
INSERT INTO `access_log` VALUES (16624, '62.80.15592975569322655', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:12:37', 14, 0, '', '2019-05-31 18:12:37');
INSERT INTO `access_log` VALUES (16625, '65.50.15592975665792213', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:12:47', 20, 0, '', '2019-05-31 18:12:47');
INSERT INTO `access_log` VALUES (16626, '65.53.15592975716612187', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:12:52', 11, 0, '', '2019-05-31 18:12:52');
INSERT INTO `access_log` VALUES (16627, '65.45.15592975747562213', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:12:55', 9, 0, '', '2019-05-31 18:12:55');
INSERT INTO `access_log` VALUES (16628, '65.54.15592975892982183', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:13:09', 10, 0, '', '2019-05-31 18:13:09');
INSERT INTO `access_log` VALUES (16629, '65.49.15592975917632211', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:13:12', 12, 0, '', '2019-05-31 18:13:12');
INSERT INTO `access_log` VALUES (16630, '64.79.15592976031872141', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:13:23', 13, 0, '', '2019-05-31 18:13:23');
INSERT INTO `access_log` VALUES (16631, '64.80.15592976035002141', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:13:24', 10, 0, '', '2019-05-31 18:13:24');
INSERT INTO `access_log` VALUES (16632, '64.76.15592976154512147', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:13:35', 138, 0, '', '2019-05-31 18:13:36');
INSERT INTO `access_log` VALUES (16633, '65.47.15592976209132213', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:13:41', 11, 0, '', '2019-05-31 18:13:41');
INSERT INTO `access_log` VALUES (16634, '65.50.15592976239362215', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:13:44', 13, 0, '', '2019-05-31 18:13:44');
INSERT INTO `access_log` VALUES (16635, '65.48.15592976414062209', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:14:01', 10, 0, '', '2019-05-31 18:14:01');
INSERT INTO `access_log` VALUES (16636, '65.54.15592978167172187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '115.194.169.201', '2019-05-31 18:16:57', 16, 0, '', '2019-05-31 18:16:57');
INSERT INTO `access_log` VALUES (16637, '65.52.15592978393912193', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.208.15.212', '2019-05-31 18:17:19', 0, 1002001015, '账号未登陆', '2019-05-31 18:17:19');
INSERT INTO `access_log` VALUES (16638, '65.51.15592978393942197', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.208.15.212', '2019-05-31 18:17:19', 1, 1002001015, '账号未登陆', '2019-05-31 18:17:19');
INSERT INTO `access_log` VALUES (16639, '65.47.15592978393992217', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.208.15.212', '2019-05-31 18:17:19', 0, 1002001015, '账号未登陆', '2019-05-31 18:17:19');
INSERT INTO `access_log` VALUES (16640, '65.50.15592978414812219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.208.15.212', '2019-05-31 18:17:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 18:17:21');
INSERT INTO `access_log` VALUES (16641, '65.48.15592978465032213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.208.15.212', '2019-05-31 18:17:27', 71, 0, '', '2019-05-31 18:17:27');
INSERT INTO `access_log` VALUES (16642, '65.45.15592978468002219', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.208.15.212', '2019-05-31 18:17:27', 9, 0, '', '2019-05-31 18:17:27');
INSERT INTO `access_log` VALUES (16643, '65.46.15592978468022203', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.208.15.212', '2019-05-31 18:17:27', 9, 0, '', '2019-05-31 18:17:27');
INSERT INTO `access_log` VALUES (16644, '65.54.15592978468062189', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.208.15.212', '2019-05-31 18:17:27', 8, 0, '', '2019-05-31 18:17:27');
INSERT INTO `access_log` VALUES (16645, '7ed99f02-9647-43c5-8e0c-362fbf1deffa', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 18:18:48', 1009, 1002001012, '访问令牌已过期', '2019-05-31 18:18:49');
INSERT INTO `access_log` VALUES (16646, '75946f7c-a6bc-436c-ba4f-940814f88d8e', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 18:18:48', 1009, 1002001012, '访问令牌已过期', '2019-05-31 18:18:49');
INSERT INTO `access_log` VALUES (16647, '1055c4d2-7d88-40f2-b6c0-4b05d7969207', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 18:18:48', 1009, 1002001012, '访问令牌已过期', '2019-05-31 18:18:49');
INSERT INTO `access_log` VALUES (16648, '62.80.15592978529642659', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.208.15.212', '2019-05-31 18:17:33', 14, 0, '', '2019-05-31 18:17:33');
INSERT INTO `access_log` VALUES (16649, '7463aef4-c5fa-455e-95f5-18a17f59d29f', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 18:18:53', 836, 0, '', '2019-05-31 18:18:53');
INSERT INTO `access_log` VALUES (16650, 'c15bf296-47b6-44bf-bdbf-3da99b7a2588', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 18:18:54', 433, 0, '', '2019-05-31 18:18:54');
INSERT INTO `access_log` VALUES (16651, 'ed2914c4-41a0-40d9-b18c-8665e3be255c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 18:18:54', 493, 0, '', '2019-05-31 18:18:54');
INSERT INTO `access_log` VALUES (16652, 'f3baba4f-80ae-49d2-a9a6-6aa482ed590e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 18:18:54', 595, 0, '', '2019-05-31 18:18:54');
INSERT INTO `access_log` VALUES (16653, '59.77.15592978614042749', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.208.15.212', '2019-05-31 18:17:41', 12, 0, '', '2019-05-31 18:17:41');
INSERT INTO `access_log` VALUES (16654, 'e94b5f14-791a-4891-b813-0a9d38096645', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 18:19:01', 1812, 0, '', '2019-05-31 18:19:03');
INSERT INTO `access_log` VALUES (16655, '65.52.15592979036732195', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '59.173.219.13', '2019-05-31 18:18:24', 0, 1002001015, '账号未登陆', '2019-05-31 18:18:24');
INSERT INTO `access_log` VALUES (16656, '65.50.15592979036792221', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '59.173.219.13', '2019-05-31 18:18:24', 1, 1002001015, '账号未登陆', '2019-05-31 18:18:24');
INSERT INTO `access_log` VALUES (16657, '65.53.15592979036802195', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '59.173.219.13', '2019-05-31 18:18:24', 1, 1002001015, '账号未登陆', '2019-05-31 18:18:24');
INSERT INTO `access_log` VALUES (16658, '65.54.15592979055842191', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '59.173.219.13', '2019-05-31 18:18:26', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 18:18:26');
INSERT INTO `access_log` VALUES (16659, '65.45.15592979077112221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '59.173.219.13', '2019-05-31 18:18:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 18:18:28');
INSERT INTO `access_log` VALUES (16660, '65.46.15592979183822205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '59.173.219.13', '2019-05-31 18:18:38', 117, 0, '', '2019-05-31 18:18:39');
INSERT INTO `access_log` VALUES (16661, '65.51.15592979187412201', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '59.173.219.13', '2019-05-31 18:18:39', 10, 0, '', '2019-05-31 18:18:39');
INSERT INTO `access_log` VALUES (16662, '65.49.15592979187412219', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '59.173.219.13', '2019-05-31 18:18:39', 9, 0, '', '2019-05-31 18:18:39');
INSERT INTO `access_log` VALUES (16663, '65.47.15592979187422221', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '59.173.219.13', '2019-05-31 18:18:39', 10, 0, '', '2019-05-31 18:18:39');
INSERT INTO `access_log` VALUES (16664, '62.84.15592979239592659', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '59.173.219.13', '2019-05-31 18:18:44', 14, 0, '', '2019-05-31 18:18:44');
INSERT INTO `access_log` VALUES (16665, '65.52.15592979249172197', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.47.161.160', '2019-05-31 18:18:45', 0, 1002001015, '账号未登陆', '2019-05-31 18:18:45');
INSERT INTO `access_log` VALUES (16666, '65.53.15592979249232197', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.47.161.160', '2019-05-31 18:18:45', 0, 1002001015, '账号未登陆', '2019-05-31 18:18:45');
INSERT INTO `access_log` VALUES (16667, '65.48.15592979249372217', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.47.161.160', '2019-05-31 18:18:45', 1, 1002001015, '账号未登陆', '2019-05-31 18:18:45');
INSERT INTO `access_log` VALUES (16668, '62.88.15592979313382663', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '59.173.219.13', '2019-05-31 18:18:51', 16, 0, '', '2019-05-31 18:18:51');
INSERT INTO `access_log` VALUES (16669, '64.85.15592979343732157', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '59.173.219.13', '2019-05-31 18:18:54', 9, 0, '', '2019-05-31 18:18:54');
INSERT INTO `access_log` VALUES (16670, '64.78.15592979343722157', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '59.173.219.13', '2019-05-31 18:18:54', 11, 0, '', '2019-05-31 18:18:54');
INSERT INTO `access_log` VALUES (16671, '65.45.15592979348612223', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.47.161.160', '2019-05-31 18:18:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 18:18:55');
INSERT INTO `access_log` VALUES (16672, '65.46.15592979418512207', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.47.161.160', '2019-05-31 18:19:02', 78, 0, '', '2019-05-31 18:19:02');
INSERT INTO `access_log` VALUES (16673, '65.49.15592979422722221', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.47.161.160', '2019-05-31 18:19:02', 9, 0, '', '2019-05-31 18:19:02');
INSERT INTO `access_log` VALUES (16674, '65.51.15592979422802203', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.47.161.160', '2019-05-31 18:19:02', 9, 0, '', '2019-05-31 18:19:02');
INSERT INTO `access_log` VALUES (16675, '65.47.15592979422882223', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.47.161.160', '2019-05-31 18:19:02', 8, 0, '', '2019-05-31 18:19:02');
INSERT INTO `access_log` VALUES (16676, '66.49.15592979423951669', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '59.173.219.13', '2019-05-31 18:19:02', 22, 0, '', '2019-05-31 18:19:02');
INSERT INTO `access_log` VALUES (16677, '62.87.15592979489052667', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.47.161.160', '2019-05-31 18:19:09', 15, 0, '', '2019-05-31 18:19:09');
INSERT INTO `access_log` VALUES (16678, '62.83.15592979527012661', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.47.161.160', '2019-05-31 18:19:13', 15, 0, '', '2019-05-31 18:19:13');
INSERT INTO `access_log` VALUES (16679, '66.48.15592979555781675', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.47.161.160', '2019-05-31 18:19:16', 11, 0, '', '2019-05-31 18:19:16');
INSERT INTO `access_log` VALUES (16680, '59.74.15592979652322753', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.47.161.160', '2019-05-31 18:19:25', 13, 0, '', '2019-05-31 18:19:25');
INSERT INTO `access_log` VALUES (16681, '59.75.15592979705652753', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.47.161.160', '2019-05-31 18:19:31', 21, 2001001000, '服务端发生异常', '2019-05-31 18:19:31');
INSERT INTO `access_log` VALUES (16682, '59.76.15592982719552755', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '112.64.1.208', '2019-05-31 18:24:32', 3, 0, '', '2019-05-31 18:24:32');
INSERT INTO `access_log` VALUES (16683, '59.77.15592982719542755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '112.64.1.208', '2019-05-31 18:24:32', 14, 2001001000, '服务端发生异常', '2019-05-31 18:24:32');
INSERT INTO `access_log` VALUES (16684, '64.79.15592982813872151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '112.64.1.208', '2019-05-31 18:24:41', 3, 0, '', '2019-05-31 18:24:41');
INSERT INTO `access_log` VALUES (16685, '64.80.15592982815372151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '112.64.1.208', '2019-05-31 18:24:42', 3, 0, '', '2019-05-31 18:24:42');
INSERT INTO `access_log` VALUES (16686, '59.71.15592982853252759', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '112.64.1.208', '2019-05-31 18:24:45', 3, 0, '', '2019-05-31 18:24:45');
INSERT INTO `access_log` VALUES (16687, '59.80.15592982853282757', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '112.64.1.208', '2019-05-31 18:24:45', 13, 2001001000, '服务端发生异常', '2019-05-31 18:24:45');
INSERT INTO `access_log` VALUES (16688, '64.82.15592982876222165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '112.64.1.208', '2019-05-31 18:24:48', 2, 0, '', '2019-05-31 18:24:48');
INSERT INTO `access_log` VALUES (16689, '64.76.15592982878462157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '112.64.1.208', '2019-05-31 18:24:48', 2, 0, '', '2019-05-31 18:24:48');
INSERT INTO `access_log` VALUES (16690, '59.72.15592982894942755', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '112.64.1.208', '2019-05-31 18:24:49', 3, 0, '', '2019-05-31 18:24:49');
INSERT INTO `access_log` VALUES (16691, '59.79.15592982894932759', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '112.64.1.208', '2019-05-31 18:24:49', 19, 2001001000, '服务端发生异常', '2019-05-31 18:24:50');
INSERT INTO `access_log` VALUES (16692, '59.75.15592984629152761', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:27:43', 4, 0, '', '2019-05-31 18:27:43');
INSERT INTO `access_log` VALUES (16693, '59.76.15592984629152759', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:27:43', 13, 2001001000, '服务端发生异常', '2019-05-31 18:27:43');
INSERT INTO `access_log` VALUES (16694, '65.46.15592984819172215', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:02', 1, 1002001015, '账号未登陆', '2019-05-31 18:28:02');
INSERT INTO `access_log` VALUES (16695, '65.51.15592984819242211', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:02', 0, 1002001015, '账号未登陆', '2019-05-31 18:28:02');
INSERT INTO `access_log` VALUES (16696, '65.47.15592984821522231', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:02', 1, 1002001015, '账号未登陆', '2019-05-31 18:28:02');
INSERT INTO `access_log` VALUES (16697, '65.50.15592984955352233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:16', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 18:28:16');
INSERT INTO `access_log` VALUES (16698, '65.48.15592985017642227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:22', 66, 0, '', '2019-05-31 18:28:22');
INSERT INTO `access_log` VALUES (16699, '65.53.15592985023542207', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:22', 9, 0, '', '2019-05-31 18:28:22');
INSERT INTO `access_log` VALUES (16700, '65.52.15592985023562207', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:22', 9, 0, '', '2019-05-31 18:28:22');
INSERT INTO `access_log` VALUES (16701, '65.54.15592985023602203', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:22', 9, 0, '', '2019-05-31 18:28:22');
INSERT INTO `access_log` VALUES (16702, '62.83.15592985082382669', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:28', 12, 0, '', '2019-05-31 18:28:28');
INSERT INTO `access_log` VALUES (16703, '64.81.15592985125542155', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:33', 14, 0, '', '2019-05-31 18:28:33');
INSERT INTO `access_log` VALUES (16704, '64.79.15592985125592155', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:33', 11, 0, '', '2019-05-31 18:28:33');
INSERT INTO `access_log` VALUES (16705, '66.50.15592985170841679', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:37', 15, 0, '', '2019-05-31 18:28:37');
INSERT INTO `access_log` VALUES (16706, '59.78.15592985198122767', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:40', 12, 0, '', '2019-05-31 18:28:40');
INSERT INTO `access_log` VALUES (16707, '65.51.15592985228912213', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:43', 18, 0, '', '2019-05-31 18:28:43');
INSERT INTO `access_log` VALUES (16708, '65.47.15592985246872233', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:45', 10, 0, '', '2019-05-31 18:28:45');
INSERT INTO `access_log` VALUES (16709, '65.49.15592985259022231', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:46', 72, 0, '', '2019-05-31 18:28:46');
INSERT INTO `access_log` VALUES (16710, '65.50.15592985269042235', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '123.124.21.173', '2019-05-31 18:28:47', 15, 0, '', '2019-05-31 18:28:47');
INSERT INTO `access_log` VALUES (16711, '59.75.15592988882692767', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.248.115.21', '2019-05-31 18:34:48', 4, 0, '', '2019-05-31 18:34:48');
INSERT INTO `access_log` VALUES (16712, '59.77.15592988882742765', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.248.115.21', '2019-05-31 18:34:48', 14, 2001001000, '服务端发生异常', '2019-05-31 18:34:48');
INSERT INTO `access_log` VALUES (16713, '59.72.15592989474192765', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:35:47', 3, 0, '', '2019-05-31 18:35:47');
INSERT INTO `access_log` VALUES (16714, '59.79.15592989474202769', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:35:47', 13, 2001001000, '服务端发生异常', '2019-05-31 18:35:47');
INSERT INTO `access_log` VALUES (16715, '64.80.15592989522822161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:35:52', 3, 0, '', '2019-05-31 18:35:52');
INSERT INTO `access_log` VALUES (16716, '64.82.15592989524212175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:35:52', 2, 0, '', '2019-05-31 18:35:52');
INSERT INTO `access_log` VALUES (16717, '64.76.15592989535872167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:35:54', 2, 0, '', '2019-05-31 18:35:54');
INSERT INTO `access_log` VALUES (16718, '64.77.15592989542282171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:35:54', 2, 0, '', '2019-05-31 18:35:54');
INSERT INTO `access_log` VALUES (16719, '64.85.15592989552502173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:35:55', 2, 0, '', '2019-05-31 18:35:55');
INSERT INTO `access_log` VALUES (16720, '64.78.15592989587872173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:35:59', 358, 0, '', '2019-05-31 18:35:59');
INSERT INTO `access_log` VALUES (16721, '64.84.15592989592522173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:35:59', 2, 0, '', '2019-05-31 18:35:59');
INSERT INTO `access_log` VALUES (16722, '59.75.15592989642032769', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:04', 3, 0, '', '2019-05-31 18:36:04');
INSERT INTO `access_log` VALUES (16723, '59.77.15592989642032767', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:04', 13, 2001001000, '服务端发生异常', '2019-05-31 18:36:04');
INSERT INTO `access_log` VALUES (16724, '64.79.15592989693672163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:09', 3, 0, '', '2019-05-31 18:36:09');
INSERT INTO `access_log` VALUES (16725, '64.81.15592989694462163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:09', 2, 0, '', '2019-05-31 18:36:09');
INSERT INTO `access_log` VALUES (16726, '64.80.15592989721882163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:12', 2, 0, '', '2019-05-31 18:36:12');
INSERT INTO `access_log` VALUES (16727, '64.82.15592989722912177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:12', 2, 0, '', '2019-05-31 18:36:12');
INSERT INTO `access_log` VALUES (16728, '64.76.15592989733312169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:13', 3, 0, '', '2019-05-31 18:36:13');
INSERT INTO `access_log` VALUES (16729, '64.77.15592989738112173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:14', 166, 0, '', '2019-05-31 18:36:14');
INSERT INTO `access_log` VALUES (16730, '64.85.15592989744432175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:14', 2, 0, '', '2019-05-31 18:36:14');
INSERT INTO `access_log` VALUES (16731, '64.84.15592989878282175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:28', 2, 0, '', '2019-05-31 18:36:28');
INSERT INTO `access_log` VALUES (16732, '64.83.15592989880102167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:28', 2, 0, '', '2019-05-31 18:36:28');
INSERT INTO `access_log` VALUES (16733, '59.80.15592989888472769', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:29', 3, 0, '', '2019-05-31 18:36:29');
INSERT INTO `access_log` VALUES (16734, '59.71.15592989888482771', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:29', 13, 2001001000, '服务端发生异常', '2019-05-31 18:36:29');
INSERT INTO `access_log` VALUES (16735, '64.81.15592990050212165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:45', 2, 0, '', '2019-05-31 18:36:45');
INSERT INTO `access_log` VALUES (16736, '64.80.15592990051052165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:45', 1, 0, '', '2019-05-31 18:36:45');
INSERT INTO `access_log` VALUES (16737, '64.82.15592990060202179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:46', 2, 0, '', '2019-05-31 18:36:46');
INSERT INTO `access_log` VALUES (16738, '64.76.15592990061332171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:46', 2, 0, '', '2019-05-31 18:36:46');
INSERT INTO `access_log` VALUES (16739, '59.79.15592990062232771', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:46', 3, 0, '', '2019-05-31 18:36:46');
INSERT INTO `access_log` VALUES (16740, '59.72.15592990062272767', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:46', 10, 2001001000, '服务端发生异常', '2019-05-31 18:36:46');
INSERT INTO `access_log` VALUES (16741, '64.77.15592990065312175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:47', 2, 0, '', '2019-05-31 18:36:47');
INSERT INTO `access_log` VALUES (16742, '64.85.15592990066342177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:47', 2, 0, '', '2019-05-31 18:36:47');
INSERT INTO `access_log` VALUES (16743, '59.74.15592990067002771', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:47', 3, 0, '', '2019-05-31 18:36:47');
INSERT INTO `access_log` VALUES (16744, '59.76.15592990067002769', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.167.95.222', '2019-05-31 18:36:47', 15, 2001001000, '服务端发生异常', '2019-05-31 18:36:47');
INSERT INTO `access_log` VALUES (16745, '65.53.15592990124052215', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:36:52', 0, 1002001015, '账号未登陆', '2019-05-31 18:36:52');
INSERT INTO `access_log` VALUES (16746, '65.54.15592990124042211', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:36:52', 0, 1002001015, '账号未登陆', '2019-05-31 18:36:52');
INSERT INTO `access_log` VALUES (16747, '65.45.15592990124102241', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:36:52', 0, 1002001015, '账号未登陆', '2019-05-31 18:36:52');
INSERT INTO `access_log` VALUES (16748, '65.51.15592990186722221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:36:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 18:36:59');
INSERT INTO `access_log` VALUES (16749, '65.47.15592990229782241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:03', 86, 0, '', '2019-05-31 18:37:03');
INSERT INTO `access_log` VALUES (16750, '65.49.15592990232562239', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:03', 142, 0, '', '2019-05-31 18:37:03');
INSERT INTO `access_log` VALUES (16751, '65.50.15592990232582243', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:03', 140, 0, '', '2019-05-31 18:37:03');
INSERT INTO `access_log` VALUES (16752, '65.48.15592990232612237', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:03', 138, 0, '', '2019-05-31 18:37:03');
INSERT INTO `access_log` VALUES (16753, '64.79.15592990311852167', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:11', 10, 0, '', '2019-05-31 18:37:11');
INSERT INTO `access_log` VALUES (16754, '64.83.15592990311842169', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:11', 12, 0, '', '2019-05-31 18:37:11');
INSERT INTO `access_log` VALUES (16755, '64.80.15592990347862167', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:15', 10, 0, '', '2019-05-31 18:37:15');
INSERT INTO `access_log` VALUES (16756, '64.81.15592990347852167', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:15', 12, 0, '', '2019-05-31 18:37:15');
INSERT INTO `access_log` VALUES (16757, '64.76.15592990368912173', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:17', 11, 0, '', '2019-05-31 18:37:17');
INSERT INTO `access_log` VALUES (16758, '64.77.15592990368932177', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:17', 8, 0, '', '2019-05-31 18:37:17');
INSERT INTO `access_log` VALUES (16759, '64.82.15592990368902181', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:17', 17, 0, '', '2019-05-31 18:37:17');
INSERT INTO `access_log` VALUES (16760, '62.85.15592990457742681', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:26', 13, 0, '', '2019-05-31 18:37:26');
INSERT INTO `access_log` VALUES (16761, '62.87.15592990486162683', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:29', 13, 0, '', '2019-05-31 18:37:29');
INSERT INTO `access_log` VALUES (16762, '62.83.15592990502082677', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:30', 13, 0, '', '2019-05-31 18:37:30');
INSERT INTO `access_log` VALUES (16763, '66.53.15592990551911691', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.5.158.177', '2019-05-31 18:37:35', 15, 0, '', '2019-05-31 18:37:35');
INSERT INTO `access_log` VALUES (16764, '2f627d88-a4d7-44d2-ac30-3851b6634ea3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 18:49:44', 996, 0, '', '2019-05-31 18:49:45');
INSERT INTO `access_log` VALUES (16765, '7fea2163-83cf-4210-9dd9-0a0c1a85b533', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 18:49:44', 996, 0, '', '2019-05-31 18:49:45');
INSERT INTO `access_log` VALUES (16766, '51fdc217-8b09-4c1d-992a-25d747061cd9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 18:49:44', 996, 0, '', '2019-05-31 18:49:45');
INSERT INTO `access_log` VALUES (16767, 'de8b00d0-654f-4d34-9021-d53f27751e07', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-31 18:50:10', 980, 0, '', '2019-05-31 18:50:11');
INSERT INTO `access_log` VALUES (16768, '65.47.15593000430922257', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:54:03', 0, 1002001015, '账号未登陆', '2019-05-31 18:54:03');
INSERT INTO `access_log` VALUES (16769, '65.48.15593000430922253', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:54:03', 0, 1002001015, '账号未登陆', '2019-05-31 18:54:03');
INSERT INTO `access_log` VALUES (16770, '65.49.15593000430942253', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:54:03', 0, 1002001015, '账号未登陆', '2019-05-31 18:54:03');
INSERT INTO `access_log` VALUES (16771, '65.50.15593000447722259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:54:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 18:54:05');
INSERT INTO `access_log` VALUES (16772, '65.52.15593000489072231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:54:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 18:54:09');
INSERT INTO `access_log` VALUES (16773, '65.54.15593000549232227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=13213212332&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:54:15', 77, 0, '', '2019-05-31 18:54:15');
INSERT INTO `access_log` VALUES (16774, '65.53.15593000552262233', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:54:15', 9, 0, '', '2019-05-31 18:54:15');
INSERT INTO `access_log` VALUES (16775, '65.46.15593000552342243', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:54:15', 8, 0, '', '2019-05-31 18:54:15');
INSERT INTO `access_log` VALUES (16776, '65.51.15593000552352237', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:54:15', 8, 0, '', '2019-05-31 18:54:15');
INSERT INTO `access_log` VALUES (16777, '62.86.15593000728942685', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:54:33', 14, 0, '', '2019-05-31 18:54:33');
INSERT INTO `access_log` VALUES (16778, '62.81.15593000827142679', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=4&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:54:43', 13, 0, '', '2019-05-31 18:54:43');
INSERT INTO `access_log` VALUES (16779, '62.84.15593000860062691', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:54:46', 13, 0, '', '2019-05-31 18:54:46');
INSERT INTO `access_log` VALUES (16780, '62.80.15593000872312693', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:54:47', 13, 0, '', '2019-05-31 18:54:47');
INSERT INTO `access_log` VALUES (16781, '62.83.15593000922512693', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:54:52', 13, 0, '', '2019-05-31 18:54:52');
INSERT INTO `access_log` VALUES (16782, '62.89.15593001176572695', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&status=1&hasRefund=false&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:55:18', 583, 0, '', '2019-05-31 18:55:18');
INSERT INTO `access_log` VALUES (16783, '62.82.15593001203102695', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:55:20', 15, 0, '', '2019-05-31 18:55:20');
INSERT INTO `access_log` VALUES (16784, '64.83.15593001314752185', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:55:31', 13, 0, '', '2019-05-31 18:55:31');
INSERT INTO `access_log` VALUES (16785, '64.79.15593001314742183', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:55:31', 14, 0, '', '2019-05-31 18:55:31');
INSERT INTO `access_log` VALUES (16786, '64.81.15593001457662183', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'name=111', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:55:46', 53, 2001001001, '参数缺失:Required Integer parameter \'attrId\' is not present', '2019-05-31 18:55:46');
INSERT INTO `access_log` VALUES (16787, '64.76.15593001558772189', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=6&name=111', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:55:56', 185, 0, '', '2019-05-31 18:55:56');
INSERT INTO `access_log` VALUES (16788, '64.82.15593001562032197', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:55:56', 16, 0, '', '2019-05-31 18:55:56');
INSERT INTO `access_log` VALUES (16789, '64.85.15593001589482195', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=3&name=22', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:55:59', 92, 0, '', '2019-05-31 18:55:59');
INSERT INTO `access_log` VALUES (16790, '64.78.15593001591622195', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:55:59', 12, 0, '', '2019-05-31 18:55:59');
INSERT INTO `access_log` VALUES (16791, '64.79.15593001655192185', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=112', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:56:06', 89, 0, '', '2019-05-31 18:56:06');
INSERT INTO `access_log` VALUES (16792, '64.83.15593001657322187', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:56:06', 11, 0, '', '2019-05-31 18:56:06');
INSERT INTO `access_log` VALUES (16793, '64.80.15593001677472185', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=111', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:56:08', 11, 1003003004, '商品规格值已经存在', '2019-05-31 18:56:08');
INSERT INTO `access_log` VALUES (16794, '65.53.15593001709962235', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:56:11', 0, 1002001015, '账号未登陆', '2019-05-31 18:56:11');
INSERT INTO `access_log` VALUES (16795, '65.46.15593001710032245', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:56:11', 0, 1002001015, '账号未登陆', '2019-05-31 18:56:11');
INSERT INTO `access_log` VALUES (16796, '65.49.15593001710052257', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:56:11', 0, 1002001015, '账号未登陆', '2019-05-31 18:56:11');
INSERT INTO `access_log` VALUES (16797, '65.48.15593001730932257', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:56:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 18:56:13');
INSERT INTO `access_log` VALUES (16798, '65.47.15593001783702261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:56:18', 69, 0, '', '2019-05-31 18:56:18');
INSERT INTO `access_log` VALUES (16799, '65.50.15593001786692263', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:56:19', 205, 0, '', '2019-05-31 18:56:19');
INSERT INTO `access_log` VALUES (16800, '65.45.15593001786702261', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:56:19', 205, 0, '', '2019-05-31 18:56:19');
INSERT INTO `access_log` VALUES (16801, '65.52.15593001786712235', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:56:19', 205, 0, '', '2019-05-31 18:56:19');
INSERT INTO `access_log` VALUES (16802, '62.85.15593001839782699', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:56:24', 14, 0, '', '2019-05-31 18:56:24');
INSERT INTO `access_log` VALUES (16803, '66.54.15593001957641697', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:56:36', 688, 0, '', '2019-05-31 18:56:36');
INSERT INTO `access_log` VALUES (16804, '66.53.15593002161781707', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=7&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:56:56', 11, 0, '', '2019-05-31 18:56:56');
INSERT INTO `access_log` VALUES (16805, '66.56.15593002169511697', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=6&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:56:57', 15, 0, '', '2019-05-31 18:56:57');
INSERT INTO `access_log` VALUES (16806, '66.57.15593002174911701', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=3&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:56:57', 13, 0, '', '2019-05-31 18:56:58');
INSERT INTO `access_log` VALUES (16807, '59.77.15593002222102785', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:57:02', 14, 0, '', '2019-05-31 18:57:02');
INSERT INTO `access_log` VALUES (16808, '65.46.15593002297282247', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:57:10', 131, 0, '', '2019-05-31 18:57:10');
INSERT INTO `access_log` VALUES (16809, '64.78.15593002318812197', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:57:12', 11, 0, '', '2019-05-31 18:57:12');
INSERT INTO `access_log` VALUES (16810, '64.85.15593002318802197', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:57:12', 13, 0, '', '2019-05-31 18:57:12');
INSERT INTO `access_log` VALUES (16811, '59.80.15593002323442787', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update', 'id=1&title=百度是最棒的&url=https://user-gold-cdn.xitu.io/2019/3/30/169cdcbb93d48ff1?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1&sort=0&memo=哈哈哈哈&picUrl=http://static.shop.iocoder.cn/6fc725fc-637a-4df7-a78d-4bb701132967', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:57:12', 8, 1002002009, NULL, '2019-05-31 18:57:12');
INSERT INTO `access_log` VALUES (16812, '64.79.15593002335932187', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:57:14', 9, 0, '', '2019-05-31 18:57:14');
INSERT INTO `access_log` VALUES (16813, '64.84.15593002335892197', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:57:14', 12, 0, '', '2019-05-31 18:57:14');
INSERT INTO `access_log` VALUES (16814, '64.81.15593002380362187', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:57:18', 9, 0, '', '2019-05-31 18:57:18');
INSERT INTO `access_log` VALUES (16815, '64.80.15593002380082187', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:57:18', 58, 0, '', '2019-05-31 18:57:18');
INSERT INTO `access_log` VALUES (16816, '64.83.15593002380082189', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:57:18', 61, 0, '', '2019-05-31 18:57:18');
INSERT INTO `access_log` VALUES (16817, '59.71.15593002380882789', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:57:18', 17, 0, '', '2019-05-31 18:57:18');
INSERT INTO `access_log` VALUES (16818, '59.79.15593002391212789', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:57:19', 12, 0, '', '2019-05-31 18:57:19');
INSERT INTO `access_log` VALUES (16819, '59.72.15593002394402785', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:57:19', 11, 0, '', '2019-05-31 18:57:19');
INSERT INTO `access_log` VALUES (16820, '64.82.15593002431692201', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:57:23', 11, 0, '', '2019-05-31 18:57:23');
INSERT INTO `access_log` VALUES (16821, '64.76.15593002431682193', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:57:23', 12, 0, '', '2019-05-31 18:57:23');
INSERT INTO `access_log` VALUES (16822, '64.78.15593002477692199', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:57:28', 13, 0, '', '2019-05-31 18:57:28');
INSERT INTO `access_log` VALUES (16823, '64.85.15593002477692199', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:57:28', 9, 0, '', '2019-05-31 18:57:28');
INSERT INTO `access_log` VALUES (16824, '64.84.15593002495922199', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:57:30', 10, 0, '', '2019-05-31 18:57:30');
INSERT INTO `access_log` VALUES (16825, '64.79.15593002495912189', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:57:30', 12, 0, '', '2019-05-31 18:57:30');
INSERT INTO `access_log` VALUES (16826, '65.47.15593002504882263', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:57:30', 19, 0, '', '2019-05-31 18:57:31');
INSERT INTO `access_log` VALUES (16827, '64.81.15593002523242189', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:57:32', 10, 0, '', '2019-05-31 18:57:32');
INSERT INTO `access_log` VALUES (16828, '65.52.15593002566962237', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:57:37', 10, 0, '', '2019-05-31 18:57:37');
INSERT INTO `access_log` VALUES (16829, '65.50.15593002586382265', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:57:39', 12, 0, '', '2019-05-31 18:57:39');
INSERT INTO `access_log` VALUES (16830, '62.80.15593002744192697', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.17.228.216', '2019-05-31 18:57:54', 14, 0, '', '2019-05-31 18:57:54');
INSERT INTO `access_log` VALUES (16831, '59.77.15593002896362787', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:58:10', 13, 0, '', '2019-05-31 18:58:10');
INSERT INTO `access_log` VALUES (16832, '59.73.15593002935762791', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:58:14', 17, 2001001000, '服务端发生异常', '2019-05-31 18:58:14');
INSERT INTO `access_log` VALUES (16833, '59.71.15593002993932791', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:58:19', 12, 0, '', '2019-05-31 18:58:19');
INSERT INTO `access_log` VALUES (16834, '65.49.15593003041702261', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:58:24', 19, 0, '', '2019-05-31 18:58:24');
INSERT INTO `access_log` VALUES (16835, '65.46.15593003086102249', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:58:29', 11, 0, '', '2019-05-31 18:58:29');
INSERT INTO `access_log` VALUES (16836, '65.48.15593003116292261', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:58:32', 10, 0, '', '2019-05-31 18:58:32');
INSERT INTO `access_log` VALUES (16837, '65.50.15593003346912267', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.109.125.124', '2019-05-31 18:58:55', 86, 0, '', '2019-05-31 18:58:55');
INSERT INTO `access_log` VALUES (16838, '59.72.15593013902712801', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:16:30', 4, 0, '', '2019-05-31 19:16:30');
INSERT INTO `access_log` VALUES (16839, '59.76.15593013902752803', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:16:30', 13, 2001001000, '服务端发生异常', '2019-05-31 19:16:30');
INSERT INTO `access_log` VALUES (16840, '64.85.15593013936132215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:16:34', 3, 0, '', '2019-05-31 19:16:34');
INSERT INTO `access_log` VALUES (16841, '64.79.15593013937932205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:16:34', 2, 0, '', '2019-05-31 19:16:34');
INSERT INTO `access_log` VALUES (16842, '64.84.15593013954532215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:16:35', 3, 0, '', '2019-05-31 19:16:35');
INSERT INTO `access_log` VALUES (16843, '64.83.15593013966512207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:16:37', 201, 0, '', '2019-05-31 19:16:37');
INSERT INTO `access_log` VALUES (16844, '64.80.15593014006142205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:16:41', 2, 0, '', '2019-05-31 19:16:41');
INSERT INTO `access_log` VALUES (16845, '64.77.15593014008042215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:16:41', 2, 0, '', '2019-05-31 19:16:41');
INSERT INTO `access_log` VALUES (16846, '65.51.15593014113182259', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:16:51', 0, 1002001015, '账号未登陆', '2019-05-31 19:16:51');
INSERT INTO `access_log` VALUES (16847, '65.54.15593014113182249', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:16:51', 0, 1002001015, '账号未登陆', '2019-05-31 19:16:51');
INSERT INTO `access_log` VALUES (16848, '65.53.15593014113222255', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:16:51', 1, 1002001015, '账号未登陆', '2019-05-31 19:16:51');
INSERT INTO `access_log` VALUES (16849, '65.46.15593014146172265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:16:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 19:16:55');
INSERT INTO `access_log` VALUES (16850, '59.77.15593014186492803', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.10.24.7', '2019-05-31 19:16:59', 3, 0, '', '2019-05-31 19:16:59');
INSERT INTO `access_log` VALUES (16851, '59.73.15593014186492807', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.10.24.7', '2019-05-31 19:16:59', 13, 2001001000, '服务端发生异常', '2019-05-31 19:16:59');
INSERT INTO `access_log` VALUES (16852, '64.76.15593014227652211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.10.24.7', '2019-05-31 19:17:03', 2, 0, '', '2019-05-31 19:17:03');
INSERT INTO `access_log` VALUES (16853, '64.78.15593014228722217', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.10.24.7', '2019-05-31 19:17:03', 2, 0, '', '2019-05-31 19:17:03');
INSERT INTO `access_log` VALUES (16854, '64.85.15593014240172217', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.10.24.7', '2019-05-31 19:17:04', 2, 0, '', '2019-05-31 19:17:04');
INSERT INTO `access_log` VALUES (16855, '64.79.15593014245732207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.10.24.7', '2019-05-31 19:17:05', 2, 0, '', '2019-05-31 19:17:05');
INSERT INTO `access_log` VALUES (16856, '65.47.15593014388892281', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:17:19', 83, 0, '', '2019-05-31 19:17:19');
INSERT INTO `access_log` VALUES (16857, '65.52.15593014395942255', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:17:20', 9, 0, '', '2019-05-31 19:17:20');
INSERT INTO `access_log` VALUES (16858, '65.50.15593014396072283', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:17:20', 9, 0, '', '2019-05-31 19:17:20');
INSERT INTO `access_log` VALUES (16859, '65.45.15593014396232281', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:17:20', 9, 0, '', '2019-05-31 19:17:20');
INSERT INTO `access_log` VALUES (16860, '65.54.15593014501032251', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:17:30', 10, 0, '', '2019-05-31 19:17:30');
INSERT INTO `access_log` VALUES (16861, '65.53.15593014501052257', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:17:30', 9, 0, '', '2019-05-31 19:17:30');
INSERT INTO `access_log` VALUES (16862, '65.49.15593014501122279', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:17:30', 9, 0, '', '2019-05-31 19:17:30');
INSERT INTO `access_log` VALUES (16863, '62.85.15593014503892717', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:17:30', 14, 0, '', '2019-05-31 19:17:30');
INSERT INTO `access_log` VALUES (16864, '62.83.15593014546692713', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; Nokia X6 Build/OPR1.170623.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 Mobile Safari/537.36', '223.104.3.252', '2019-05-31 19:17:35', 12, 0, '', '2019-05-31 19:17:35');
INSERT INTO `access_log` VALUES (16865, '65.49.15593015697002281', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.64.16.34', '2019-05-31 19:19:30', 0, 1002001015, '账号未登陆', '2019-05-31 19:19:30');
INSERT INTO `access_log` VALUES (16866, '65.54.15593015697652253', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.64.16.34', '2019-05-31 19:19:30', 1, 1002001015, '账号未登陆', '2019-05-31 19:19:30');
INSERT INTO `access_log` VALUES (16867, '65.46.15593015697682269', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.64.16.34', '2019-05-31 19:19:30', 0, 1002001015, '账号未登陆', '2019-05-31 19:19:30');
INSERT INTO `access_log` VALUES (16868, '65.45.15593016124862285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.64.16.34', '2019-05-31 19:20:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 19:20:12');
INSERT INTO `access_log` VALUES (16869, '59.79.15593018973352813', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.7.3', '36.23.190.136', '2019-05-31 19:24:57', 14, 2001001000, '服务端发生异常', '2019-05-31 19:24:57');
INSERT INTO `access_log` VALUES (16870, '59.78.15593018973352817', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.7.3', '36.23.190.136', '2019-05-31 19:24:57', 375, 0, '', '2019-05-31 19:24:58');
INSERT INTO `access_log` VALUES (16871, '65.50.15593019098622291', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.7.3', '36.23.190.136', '2019-05-31 19:25:10', 0, 1002001015, '账号未登陆', '2019-05-31 19:25:10');
INSERT INTO `access_log` VALUES (16872, '65.51.15593019098632269', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.7.3', '36.23.190.136', '2019-05-31 19:25:10', 0, 1002001015, '账号未登陆', '2019-05-31 19:25:10');
INSERT INTO `access_log` VALUES (16873, '65.53.15593019098722265', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.7.3', '36.23.190.136', '2019-05-31 19:25:10', 0, 1002001015, '账号未登陆', '2019-05-31 19:25:10');
INSERT INTO `access_log` VALUES (16874, '65.49.15593019128352287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.7.3', '36.23.190.136', '2019-05-31 19:25:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 19:25:13');
INSERT INTO `access_log` VALUES (16875, '65.53.15593020387232267', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6) NetType/WIFI QBWebViewType/1 WKType/1', '115.212.20.88', '2019-05-31 19:27:19', 1, 1002001015, '账号未登陆', '2019-05-31 19:27:19');
INSERT INTO `access_log` VALUES (16876, '65.49.15593020387452289', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6) NetType/WIFI QBWebViewType/1 WKType/1', '115.212.20.88', '2019-05-31 19:27:19', 1, 1002001015, '账号未登陆', '2019-05-31 19:27:19');
INSERT INTO `access_log` VALUES (16877, '65.54.15593020387832261', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6) NetType/WIFI QBWebViewType/1 WKType/1', '115.212.20.88', '2019-05-31 19:27:19', 0, 1002001015, '账号未登陆', '2019-05-31 19:27:19');
INSERT INTO `access_log` VALUES (16878, '65.46.15593020433752277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6) NetType/WIFI QBWebViewType/1 WKType/1', '115.212.20.88', '2019-05-31 19:27:23', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 19:27:23');
INSERT INTO `access_log` VALUES (16879, '65.52.15593020610972267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6) NetType/WIFI QBWebViewType/1 WKType/1', '115.212.20.88', '2019-05-31 19:27:41', 212, 0, '', '2019-05-31 19:27:41');
INSERT INTO `access_log` VALUES (16880, '65.45.15593020624862293', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6) NetType/WIFI QBWebViewType/1 WKType/1', '115.212.20.88', '2019-05-31 19:27:42', 11, 0, '', '2019-05-31 19:27:42');
INSERT INTO `access_log` VALUES (16881, '65.51.15593020625062273', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6) NetType/WIFI QBWebViewType/1 WKType/1', '115.212.20.88', '2019-05-31 19:27:43', 9, 0, '', '2019-05-31 19:27:43');
INSERT INTO `access_log` VALUES (16882, '65.50.15593020625302295', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6) NetType/WIFI QBWebViewType/1 WKType/1', '115.212.20.88', '2019-05-31 19:27:43', 10, 0, '', '2019-05-31 19:27:43');
INSERT INTO `access_log` VALUES (16883, '65.53.15593020822232269', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6) NetType/WIFI QBWebViewType/1 WKType/1', '115.212.20.88', '2019-05-31 19:28:02', 9, 0, '', '2019-05-31 19:28:02');
INSERT INTO `access_log` VALUES (16884, '65.54.15593020822552263', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6) NetType/WIFI QBWebViewType/1 WKType/1', '115.212.20.88', '2019-05-31 19:28:02', 9, 0, '', '2019-05-31 19:28:02');
INSERT INTO `access_log` VALUES (16885, '65.46.15593020822562279', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6) NetType/WIFI QBWebViewType/1 WKType/1', '115.212.20.88', '2019-05-31 19:28:02', 8, 0, '', '2019-05-31 19:28:02');
INSERT INTO `access_log` VALUES (16886, '64.77.15593020828482225', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6) NetType/WIFI QBWebViewType/1 WKType/1', '115.212.20.88', '2019-05-31 19:28:03', 13, 0, '', '2019-05-31 19:28:03');
INSERT INTO `access_log` VALUES (16887, '64.82.15593020828542229', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6) NetType/WIFI QBWebViewType/1 WKType/1', '115.212.20.88', '2019-05-31 19:28:03', 9, 0, '', '2019-05-31 19:28:03');
INSERT INTO `access_log` VALUES (16888, '59.77.15593020999462813', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; vivo Y67A Build/MRA58K; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 V1_AND_SQ_8.0.0_1024_YYB_D QQ/8.0.0.4000 NetType/4G WebP/0.3.0 Pixel/720 StatusBarHeight/48', '183.42.31.114', '2019-05-31 19:28:20', 4, 0, '', '2019-05-31 19:28:20');
INSERT INTO `access_log` VALUES (16889, '59.73.15593020999462817', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; vivo Y67A Build/MRA58K; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 V1_AND_SQ_8.0.0_1024_YYB_D QQ/8.0.0.4000 NetType/4G WebP/0.3.0 Pixel/720 StatusBarHeight/48', '183.42.31.114', '2019-05-31 19:28:20', 14, 2001001000, '服务端发生异常', '2019-05-31 19:28:20');
INSERT INTO `access_log` VALUES (16890, '59.72.15593033824582829', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.168.209.130', '2019-05-31 19:49:42', 3, 0, '', '2019-05-31 19:49:42');
INSERT INTO `access_log` VALUES (16891, '59.74.15593033824612833', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.168.209.130', '2019-05-31 19:49:42', 13, 2001001000, '服务端发生异常', '2019-05-31 19:49:42');
INSERT INTO `access_log` VALUES (16892, '64.80.15593033851412233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.168.209.130', '2019-05-31 19:49:45', 311, 0, '', '2019-05-31 19:49:45');
INSERT INTO `access_log` VALUES (16893, '64.77.15593033856092243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.168.209.130', '2019-05-31 19:49:46', 3, 0, '', '2019-05-31 19:49:46');
INSERT INTO `access_log` VALUES (16894, '65.48.15593034012672309', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.168.209.130', '2019-05-31 19:50:01', 0, 1002001015, '账号未登陆', '2019-05-31 19:50:01');
INSERT INTO `access_log` VALUES (16895, '65.51.15593034012672293', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.168.209.130', '2019-05-31 19:50:01', 1, 1002001015, '账号未登陆', '2019-05-31 19:50:01');
INSERT INTO `access_log` VALUES (16896, '65.45.15593034012702313', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.168.209.130', '2019-05-31 19:50:01', 0, 1002001015, '账号未登陆', '2019-05-31 19:50:01');
INSERT INTO `access_log` VALUES (16897, '65.53.15593034412482287', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:50:41', 0, 1002001015, '账号未登陆', '2019-05-31 19:50:41');
INSERT INTO `access_log` VALUES (16898, '65.46.15593034412482299', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:50:41', 0, 1002001015, '账号未登陆', '2019-05-31 19:50:41');
INSERT INTO `access_log` VALUES (16899, '65.52.15593034412512289', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:50:41', 0, 1002001015, '账号未登陆', '2019-05-31 19:50:41');
INSERT INTO `access_log` VALUES (16900, '65.47.15593034496322315', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:50:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 19:50:50');
INSERT INTO `access_log` VALUES (16901, '65.48.15593034563282311', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:50:56', 78, 0, '', '2019-05-31 19:50:56');
INSERT INTO `access_log` VALUES (16902, '65.50.15593034566122317', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:50:57', 14, 0, '', '2019-05-31 19:50:57');
INSERT INTO `access_log` VALUES (16903, '65.45.15593034566122315', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:50:57', 15, 0, '', '2019-05-31 19:50:57');
INSERT INTO `access_log` VALUES (16904, '65.49.15593034566152313', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:50:57', 13, 0, '', '2019-05-31 19:50:57');
INSERT INTO `access_log` VALUES (16905, '64.84.15593034598962245', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:51:00', 32, 0, '', '2019-05-31 19:51:00');
INSERT INTO `access_log` VALUES (16906, '64.81.15593034598922235', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:51:00', 39, 0, '', '2019-05-31 19:51:00');
INSERT INTO `access_log` VALUES (16907, '64.78.15593035358842247', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:52:16', 14, 0, '', '2019-05-31 19:52:16');
INSERT INTO `access_log` VALUES (16908, '64.85.15593035358842247', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:52:16', 16, 0, '', '2019-05-31 19:52:16');
INSERT INTO `access_log` VALUES (16909, '64.84.15593035405642247', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:52:21', 11, 0, '', '2019-05-31 19:52:21');
INSERT INTO `access_log` VALUES (16910, '64.81.15593035415562237', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:52:22', 9, 0, '', '2019-05-31 19:52:22');
INSERT INTO `access_log` VALUES (16911, '64.83.15593035424402239', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:52:22', 11, 0, '', '2019-05-31 19:52:22');
INSERT INTO `access_log` VALUES (16912, '64.80.15593035443082237', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:52:24', 11, 0, '', '2019-05-31 19:52:24');
INSERT INTO `access_log` VALUES (16913, '64.77.15593035452082247', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:52:25', 11, 0, '', '2019-05-31 19:52:25');
INSERT INTO `access_log` VALUES (16914, '64.82.15593035459202251', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:52:26', 12, 0, '', '2019-05-31 19:52:26');
INSERT INTO `access_log` VALUES (16915, '64.78.15593035478972249', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:52:28', 12, 0, '', '2019-05-31 19:52:28');
INSERT INTO `access_log` VALUES (16916, '64.76.15593035478962243', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:52:28', 15, 0, '', '2019-05-31 19:52:28');
INSERT INTO `access_log` VALUES (16917, '64.85.15593035479082249', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:52:28', 9, 0, '', '2019-05-31 19:52:28');
INSERT INTO `access_log` VALUES (16918, '64.81.15593035808012239', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=7&name=kk', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:53:01', 107, 0, '', '2019-05-31 19:53:01');
INSERT INTO `access_log` VALUES (16919, '64.83.15593035810122241', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:53:01', 10, 0, '', '2019-05-31 19:53:01');
INSERT INTO `access_log` VALUES (16920, '64.80.15593035846002239', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=7&name=nm', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:53:05', 71, 0, '', '2019-05-31 19:53:05');
INSERT INTO `access_log` VALUES (16921, '64.77.15593035848042249', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:53:05', 11, 0, '', '2019-05-31 19:53:05');
INSERT INTO `access_log` VALUES (16922, '64.78.15593035935322251', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:53:14', 10, 0, '', '2019-05-31 19:53:14');
INSERT INTO `access_log` VALUES (16923, '62.88.15593036096202743', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.204.209.43', '2019-05-31 19:53:30', 47, 0, '', '2019-05-31 19:53:30');
INSERT INTO `access_log` VALUES (16924, '59.78.15593037601102843', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.209.32.47', '2019-05-31 19:56:00', 4, 0, '', '2019-05-31 19:56:00');
INSERT INTO `access_log` VALUES (16925, '59.79.15593037601162839', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.209.32.47', '2019-05-31 19:56:00', 13, 2001001000, '服务端发生异常', '2019-05-31 19:56:00');
INSERT INTO `access_log` VALUES (16926, '59.76.15593037636022837', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:04', 3, 0, '', '2019-05-31 19:56:04');
INSERT INTO `access_log` VALUES (16927, '59.72.15593037636022835', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:04', 14, 2001001000, '服务端发生异常', '2019-05-31 19:56:04');
INSERT INTO `access_log` VALUES (16928, '64.79.15593037704872243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:10', 3, 0, '', '2019-05-31 19:56:10');
INSERT INTO `access_log` VALUES (16929, '64.84.15593037707072253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:11', 2, 0, '', '2019-05-31 19:56:11');
INSERT INTO `access_log` VALUES (16930, '59.75.15593037734672839', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.209.32.47', '2019-05-31 19:56:13', 3, 0, '', '2019-05-31 19:56:13');
INSERT INTO `access_log` VALUES (16931, '59.73.15593037734702841', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.209.32.47', '2019-05-31 19:56:13', 13, 2001001000, '服务端发生异常', '2019-05-31 19:56:13');
INSERT INTO `access_log` VALUES (16932, '64.81.15593037787232243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:19', 2, 0, '', '2019-05-31 19:56:19');
INSERT INTO `access_log` VALUES (16933, '64.83.15593037789722245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:19', 3, 0, '', '2019-05-31 19:56:19');
INSERT INTO `access_log` VALUES (16934, '59.71.15593037823232841', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:22', 3, 0, '', '2019-05-31 19:56:22');
INSERT INTO `access_log` VALUES (16935, '59.80.15593037823232839', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:22', 14, 2001001000, '服务端发生异常', '2019-05-31 19:56:22');
INSERT INTO `access_log` VALUES (16936, '64.77.15593037845622253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:25', 3, 0, '', '2019-05-31 19:56:25');
INSERT INTO `access_log` VALUES (16937, '64.82.15593037847222257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:25', 3, 0, '', '2019-05-31 19:56:25');
INSERT INTO `access_log` VALUES (16938, '64.78.15593037860822255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:26', 2, 0, '', '2019-05-31 19:56:26');
INSERT INTO `access_log` VALUES (16939, '64.85.15593037884072255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:28', 2, 0, '', '2019-05-31 19:56:28');
INSERT INTO `access_log` VALUES (16940, '64.76.15593037898422249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:30', 2, 0, '', '2019-05-31 19:56:30');
INSERT INTO `access_log` VALUES (16941, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:30', 15, 0, '', '2019-05-31 19:56:30');
INSERT INTO `access_log` VALUES (16942, '64.79.15593037920822245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:32', 2, 0, '', '2019-05-31 19:56:32');
INSERT INTO `access_log` VALUES (16943, '64.84.15593037922432255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:32', 2, 0, '', '2019-05-31 19:56:32');
INSERT INTO `access_log` VALUES (16944, '64.81.15593037935572245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:34', 2, 0, '', '2019-05-31 19:56:34');
INSERT INTO `access_log` VALUES (16945, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:34', 7, 0, '', '2019-05-31 19:56:34');
INSERT INTO `access_log` VALUES (16946, '64.80.15593037977622245', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; NX616J Build/PKQ1.180929.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.158 Mobile Safari/537.36', '223.104.63.95', '2019-05-31 19:56:38', 8, 0, '', '2019-05-31 19:56:38');
INSERT INTO `access_log` VALUES (16947, '59.71.15593052538472861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:20:54', 4, 0, '', '2019-05-31 20:20:54');
INSERT INTO `access_log` VALUES (16948, '59.80.15593052538542859', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:20:54', 18, 2001001000, '服务端发生异常', '2019-05-31 20:20:54');
INSERT INTO `access_log` VALUES (16949, '64.81.15593052591622265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:20:59', 3, 0, '', '2019-05-31 20:20:59');
INSERT INTO `access_log` VALUES (16950, '64.83.15593052593032267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:20:59', 2, 0, '', '2019-05-31 20:20:59');
INSERT INTO `access_log` VALUES (16951, '64.80.15593052610532265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:01', 3, 0, '', '2019-05-31 20:21:01');
INSERT INTO `access_log` VALUES (16952, '64.77.15593052621032275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:02', 2, 0, '', '2019-05-31 20:21:02');
INSERT INTO `access_log` VALUES (16953, '59.79.15593052631022861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:03', 3, 0, '', '2019-05-31 20:21:03');
INSERT INTO `access_log` VALUES (16954, '59.78.15593052631012865', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:03', 13, 2001001000, '服务端发生异常', '2019-05-31 20:21:03');
INSERT INTO `access_log` VALUES (16955, '64.78.15593052660912277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:06', 2, 0, '', '2019-05-31 20:21:06');
INSERT INTO `access_log` VALUES (16956, '64.85.15593052662502277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:06', 37, 0, '', '2019-05-31 20:21:06');
INSERT INTO `access_log` VALUES (16957, '59.72.15593052676502857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:08', 3, 0, '', '2019-05-31 20:21:08');
INSERT INTO `access_log` VALUES (16958, '59.74.15593052676522861', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:08', 13, 2001001000, '服务端发生异常', '2019-05-31 20:21:08');
INSERT INTO `access_log` VALUES (16959, '64.76.15593052759392271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:16', 3, 0, '', '2019-05-31 20:21:16');
INSERT INTO `access_log` VALUES (16960, '64.79.15593052762622267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:16', 2, 0, '', '2019-05-31 20:21:16');
INSERT INTO `access_log` VALUES (16961, '64.84.15593052775002277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:18', 2, 0, '', '2019-05-31 20:21:18');
INSERT INTO `access_log` VALUES (16962, '64.81.15593052780042267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:18', 2, 0, '', '2019-05-31 20:21:18');
INSERT INTO `access_log` VALUES (16963, '59.75.15593052788812861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:19', 3, 0, '', '2019-05-31 20:21:19');
INSERT INTO `access_log` VALUES (16964, '59.73.15593052788802863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:19', 13, 2001001000, '服务端发生异常', '2019-05-31 20:21:19');
INSERT INTO `access_log` VALUES (16965, '64.80.15593052812212267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:21', 2, 0, '', '2019-05-31 20:21:21');
INSERT INTO `access_log` VALUES (16966, '64.77.15593052813622277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:21', 2, 0, '', '2019-05-31 20:21:21');
INSERT INTO `access_log` VALUES (16967, '59.71.15593052825902863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:23', 19, 2001001000, '服务端发生异常', '2019-05-31 20:21:23');
INSERT INTO `access_log` VALUES (16968, '59.80.15593052825902861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:23', 292, 0, '', '2019-05-31 20:21:23');
INSERT INTO `access_log` VALUES (16969, '64.78.15593053013132279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:41', 968, 0, '', '2019-05-31 20:21:42');
INSERT INTO `access_log` VALUES (16970, '64.85.15593053024472279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:42', 71, 0, '', '2019-05-31 20:21:43');
INSERT INTO `access_log` VALUES (16971, '59.78.15593053030082867', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:43', 3, 0, '', '2019-05-31 20:21:43');
INSERT INTO `access_log` VALUES (16972, '59.76.15593053030132861', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:21:43', 14, 2001001000, '服务端发生异常', '2019-05-31 20:21:43');
INSERT INTO `access_log` VALUES (16973, '59.77.15593053600582861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:22:40', 4, 0, '', '2019-05-31 20:22:40');
INSERT INTO `access_log` VALUES (16974, '59.71.15593053600622865', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:22:40', 13, 2001001000, '服务端发生异常', '2019-05-31 20:22:40');
INSERT INTO `access_log` VALUES (16975, '64.83.15593053629142271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:22:43', 3, 0, '', '2019-05-31 20:22:43');
INSERT INTO `access_log` VALUES (16976, '64.80.15593053630122269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:22:43', 3, 0, '', '2019-05-31 20:22:43');
INSERT INTO `access_log` VALUES (16977, '59.79.15593053639322865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:22:44', 3, 0, '', '2019-05-31 20:22:44');
INSERT INTO `access_log` VALUES (16978, '59.80.15593053639302863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 20:22:44', 13, 2001001000, '服务端发生异常', '2019-05-31 20:22:44');
INSERT INTO `access_log` VALUES (16979, '59.72.15593053875362861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:08', 3, 0, '', '2019-05-31 20:23:08');
INSERT INTO `access_log` VALUES (16980, '59.74.15593053875412865', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:08', 13, 2001001000, '服务端发生异常', '2019-05-31 20:23:08');
INSERT INTO `access_log` VALUES (16981, '64.78.15593053903142281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:10', 2, 0, '', '2019-05-31 20:23:10');
INSERT INTO `access_log` VALUES (16982, '64.85.15593053904712281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:10', 2, 0, '', '2019-05-31 20:23:10');
INSERT INTO `access_log` VALUES (16983, '64.76.15593053934112275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:13', 2, 0, '', '2019-05-31 20:23:13');
INSERT INTO `access_log` VALUES (16984, '64.79.15593053936382271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:14', 2, 0, '', '2019-05-31 20:23:14');
INSERT INTO `access_log` VALUES (16985, '59.75.15593053998582865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:20', 3, 0, '', '2019-05-31 20:23:20');
INSERT INTO `access_log` VALUES (16986, '59.71.15593053998712867', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:20', 14, 2001001000, '服务端发生异常', '2019-05-31 20:23:20');
INSERT INTO `access_log` VALUES (16987, '64.81.15593054016452271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:22', 3, 0, '', '2019-05-31 20:23:22');
INSERT INTO `access_log` VALUES (16988, '64.83.15593054017992273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:22', 3, 0, '', '2019-05-31 20:23:22');
INSERT INTO `access_log` VALUES (16989, '64.80.15593054029892271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:23', 3, 0, '', '2019-05-31 20:23:23');
INSERT INTO `access_log` VALUES (16990, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:23', 9, 0, '', '2019-05-31 20:23:23');
INSERT INTO `access_log` VALUES (16991, '64.77.15593054040862281', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:24', 8, 0, '', '2019-05-31 20:23:24');
INSERT INTO `access_log` VALUES (16992, '64.82.15593054153722285', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:35', 8, 0, '', '2019-05-31 20:23:35');
INSERT INTO `access_log` VALUES (16993, '64.85.15593054161062283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:36', 2, 0, '', '2019-05-31 20:23:36');
INSERT INTO `access_log` VALUES (16994, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:36', 8, 0, '', '2019-05-31 20:23:36');
INSERT INTO `access_log` VALUES (16995, '64.76.15593054169732277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:37', 2, 0, '', '2019-05-31 20:23:37');
INSERT INTO `access_log` VALUES (16996, '64.79.15593054171762273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:37', 2, 0, '', '2019-05-31 20:23:37');
INSERT INTO `access_log` VALUES (16997, '59.79.15593054180982867', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:38', 2, 0, '', '2019-05-31 20:23:38');
INSERT INTO `access_log` VALUES (16998, '59.80.15593054180982865', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.1', '114.242.250.242', '2019-05-31 20:23:38', 16, 2001001000, '服务端发生异常', '2019-05-31 20:23:38');
INSERT INTO `access_log` VALUES (16999, '65.49.15593062523882351', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.194.162', '2019-05-31 20:37:32', 1, 1002001015, '账号未登陆', '2019-05-31 20:37:32');
INSERT INTO `access_log` VALUES (17000, '65.48.15593062523872349', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.184.238', '2019-05-31 20:37:32', 1, 1002001015, '账号未登陆', '2019-05-31 20:37:32');
INSERT INTO `access_log` VALUES (17001, '65.50.15593062524062355', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.223.4', '2019-05-31 20:37:32', 0, 1002001015, '账号未登陆', '2019-05-31 20:37:32');
INSERT INTO `access_log` VALUES (17002, '65.54.15593062591972321', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.223.26', '2019-05-31 20:37:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 20:37:39');
INSERT INTO `access_log` VALUES (17003, '65.46.15593062708902339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.223.26', '2019-05-31 20:37:51', 67, 0, '', '2019-05-31 20:37:51');
INSERT INTO `access_log` VALUES (17004, '65.53.15593062713222327', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.223.4', '2019-05-31 20:37:51', 9, 0, '', '2019-05-31 20:37:51');
INSERT INTO `access_log` VALUES (17005, '65.52.15593062713252329', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.223.26', '2019-05-31 20:37:51', 9, 0, '', '2019-05-31 20:37:51');
INSERT INTO `access_log` VALUES (17006, '65.47.15593062713312355', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.223.26', '2019-05-31 20:37:51', 8, 0, '', '2019-05-31 20:37:51');
INSERT INTO `access_log` VALUES (17007, '62.81.15593062899762765', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.223.26', '2019-05-31 20:38:10', 24, 0, '', '2019-05-31 20:38:10');
INSERT INTO `access_log` VALUES (17008, '65.45.15593063214162355', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.223.26', '2019-05-31 20:38:41', 19, 0, '', '2019-05-31 20:38:41');
INSERT INTO `access_log` VALUES (17009, '65.54.15593063281722323', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.223.26', '2019-05-31 20:38:48', 11, 0, '', '2019-05-31 20:38:48');
INSERT INTO `access_log` VALUES (17010, '65.46.15593063327892341', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.223.26', '2019-05-31 20:38:53', 12, 0, '', '2019-05-31 20:38:53');
INSERT INTO `access_log` VALUES (17011, '65.53.15593063466542329', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.223.26', '2019-05-31 20:39:07', 10, 0, '', '2019-05-31 20:39:07');
INSERT INTO `access_log` VALUES (17012, '65.51.15593063522792337', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.223.26', '2019-05-31 20:39:12', 14, 0, '', '2019-05-31 20:39:12');
INSERT INTO `access_log` VALUES (17013, '59.80.15593067620712883', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:02', 3, 0, '', '2019-05-31 20:46:02');
INSERT INTO `access_log` VALUES (17014, '59.78.15593067620722889', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:02', 10, 2001001000, '服务端发生异常', '2019-05-31 20:46:02');
INSERT INTO `access_log` VALUES (17015, '64.82.15593067681132305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:08', 2, 0, '', '2019-05-31 20:46:08');
INSERT INTO `access_log` VALUES (17016, '64.80.15593067683712291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:08', 2, 0, '', '2019-05-31 20:46:08');
INSERT INTO `access_log` VALUES (17017, '64.84.15593067697782301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:10', 2, 0, '', '2019-05-31 20:46:10');
INSERT INTO `access_log` VALUES (17018, '64.77.15593067709142301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:11', 3, 0, '', '2019-05-31 20:46:11');
INSERT INTO `access_log` VALUES (17019, '64.76.15593067725082295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:13', 3, 0, '', '2019-05-31 20:46:13');
INSERT INTO `access_log` VALUES (17020, '64.79.15593067735292291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:14', 2, 0, '', '2019-05-31 20:46:14');
INSERT INTO `access_log` VALUES (17021, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:14', 8, 0, '', '2019-05-31 20:46:14');
INSERT INTO `access_log` VALUES (17022, '64.85.15593067755412305', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:16', 8, 0, '', '2019-05-31 20:46:16');
INSERT INTO `access_log` VALUES (17023, '64.81.15593067790672293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:19', 2, 0, '', '2019-05-31 20:46:19');
INSERT INTO `access_log` VALUES (17024, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:19', 8, 0, '', '2019-05-31 20:46:19');
INSERT INTO `access_log` VALUES (17025, '64.78.15593067807982305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:21', 2, 0, '', '2019-05-31 20:46:21');
INSERT INTO `access_log` VALUES (17026, '64.82.15593067809682307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:21', 3, 0, '', '2019-05-31 20:46:21');
INSERT INTO `access_log` VALUES (17027, '59.73.15593067828992887', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:23', 3, 0, '', '2019-05-31 20:46:23');
INSERT INTO `access_log` VALUES (17028, '59.74.15593067828982885', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:23', 19, 2001001000, '服务端发生异常', '2019-05-31 20:46:23');
INSERT INTO `access_log` VALUES (17029, '65.51.15593067913332343', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:31', 0, 1002001015, '账号未登陆', '2019-05-31 20:46:31');
INSERT INTO `access_log` VALUES (17030, '65.50.15593067913742365', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:31', 1, 1002001015, '账号未登陆', '2019-05-31 20:46:31');
INSERT INTO `access_log` VALUES (17031, '65.49.15593067913742361', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:46:31', 0, 1002001015, '账号未登陆', '2019-05-31 20:46:31');
INSERT INTO `access_log` VALUES (17032, '65.50.15593069318772367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:48:52', 71, 0, '', '2019-05-31 20:48:52');
INSERT INTO `access_log` VALUES (17033, '65.48.15593069323502361', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:48:52', 10, 0, '', '2019-05-31 20:48:52');
INSERT INTO `access_log` VALUES (17034, '65.45.15593069323592365', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:48:52', 10, 0, '', '2019-05-31 20:48:52');
INSERT INTO `access_log` VALUES (17035, '65.54.15593069323622333', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:48:52', 10, 0, '', '2019-05-31 20:48:52');
INSERT INTO `access_log` VALUES (17036, '65.52.15593069386202341', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:48:59', 10, 0, '', '2019-05-31 20:48:59');
INSERT INTO `access_log` VALUES (17037, '65.53.15593069386222339', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:48:59', 9, 0, '', '2019-05-31 20:48:59');
INSERT INTO `access_log` VALUES (17038, '65.47.15593069386252367', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:48:59', 10, 0, '', '2019-05-31 20:48:59');
INSERT INTO `access_log` VALUES (17039, '65.51.15593069446462347', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:49:05', 105, 0, '', '2019-05-31 20:49:05');
INSERT INTO `access_log` VALUES (17040, '65.49.15593069446482365', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:49:05', 104, 0, '', '2019-05-31 20:49:05');
INSERT INTO `access_log` VALUES (17041, '65.50.15593069446482369', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:49:05', 104, 0, '', '2019-05-31 20:49:05');
INSERT INTO `access_log` VALUES (17042, '62.87.15593069448962791', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.6.1026', '49.65.117.70', '2019-05-31 20:49:05', 16, 0, '', '2019-05-31 20:49:05');
INSERT INTO `access_log` VALUES (17043, '59.74.15593070638142889', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '171.217.51.214', '2019-05-31 20:51:04', 4, 0, '', '2019-05-31 20:51:04');
INSERT INTO `access_log` VALUES (17044, '59.73.15593070638172891', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '171.217.51.214', '2019-05-31 20:51:04', 13, 2001001000, '服务端发生异常', '2019-05-31 20:51:04');
INSERT INTO `access_log` VALUES (17045, '65.49.15593071370762369', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:17', 0, 1002001015, '账号未登陆', '2019-05-31 20:52:17');
INSERT INTO `access_log` VALUES (17046, '65.50.15593071370822371', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:17', 0, 1002001015, '账号未登陆', '2019-05-31 20:52:17');
INSERT INTO `access_log` VALUES (17047, '65.45.15593071370912369', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:17', 0, 1002001015, '账号未登陆', '2019-05-31 20:52:17');
INSERT INTO `access_log` VALUES (17048, '65.48.15593071400852367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:20', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 20:52:20');
INSERT INTO `access_log` VALUES (17049, '65.46.15593071454052355', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:25', 58, 0, '', '2019-05-31 20:52:25');
INSERT INTO `access_log` VALUES (17050, '65.47.15593071458542373', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:26', 10, 0, '', '2019-05-31 20:52:26');
INSERT INTO `access_log` VALUES (17051, '65.54.15593071458582339', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:26', 9, 0, '', '2019-05-31 20:52:26');
INSERT INTO `access_log` VALUES (17052, '65.52.15593071458682347', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:26', 9, 0, '', '2019-05-31 20:52:26');
INSERT INTO `access_log` VALUES (17053, '62.81.15593071529442777', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:33', 15, 0, '', '2019-05-31 20:52:33');
INSERT INTO `access_log` VALUES (17054, '62.80.15593071652932791', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:45', 17, 0, '', '2019-05-31 20:52:45');
INSERT INTO `access_log` VALUES (17055, '64.81.15593071682712299', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:48', 9, 0, '', '2019-05-31 20:52:48');
INSERT INTO `access_log` VALUES (17056, '64.85.15593071682682311', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:48', 13, 0, '', '2019-05-31 20:52:48');
INSERT INTO `access_log` VALUES (17057, '64.82.15593071716202313', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:52', 10, 0, '', '2019-05-31 20:52:52');
INSERT INTO `access_log` VALUES (17058, '64.78.15593071716152311', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:52', 15, 0, '', '2019-05-31 20:52:52');
INSERT INTO `access_log` VALUES (17059, '64.84.15593071791322309', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:59', 48, 0, '', '2019-05-31 20:52:59');
INSERT INTO `access_log` VALUES (17060, '64.80.15593071791312299', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:52:59', 62, 0, '', '2019-05-31 20:52:59');
INSERT INTO `access_log` VALUES (17061, '64.85.15593072305642313', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:53:51', 10, 0, '', '2019-05-31 20:53:51');
INSERT INTO `access_log` VALUES (17062, '64.83.15593072305722303', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:53:51', 8, 0, '', '2019-05-31 20:53:51');
INSERT INTO `access_log` VALUES (17063, '64.78.15593072342482313', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:53:54', 12, 0, '', '2019-05-31 20:53:54');
INSERT INTO `access_log` VALUES (17064, '64.82.15593072342672315', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:53:54', 9, 0, '', '2019-05-31 20:53:54');
INSERT INTO `access_log` VALUES (17065, '64.84.15593072369902311', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:53:57', 10, 0, '', '2019-05-31 20:53:57');
INSERT INTO `access_log` VALUES (17066, '66.55.15593072665191805', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:54:27', 23, 0, '', '2019-05-31 20:54:27');
INSERT INTO `access_log` VALUES (17067, '59.78.15593072694452897', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:54:29', 13, 0, '', '2019-05-31 20:54:29');
INSERT INTO `access_log` VALUES (17068, '59.80.15593072719472891', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:54:32', 142, 2001001000, '服务端发生异常', '2019-05-31 20:54:32');
INSERT INTO `access_log` VALUES (17069, '59.72.15593072746592889', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:54:35', 12, 0, '', '2019-05-31 20:54:35');
INSERT INTO `access_log` VALUES (17070, '59.74.15593072872622893', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:54:47', 13, 0, '', '2019-05-31 20:54:47');
INSERT INTO `access_log` VALUES (17071, '59.71.15593072903182895', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:54:50', 626, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-31 20:54:51');
INSERT INTO `access_log` VALUES (17072, '65.48.15593072937012369', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:54:54', 16, 0, '', '2019-05-31 20:54:54');
INSERT INTO `access_log` VALUES (17073, '65.46.15593072945962359', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:54:55', 67, 0, '', '2019-05-31 20:54:55');
INSERT INTO `access_log` VALUES (17074, '65.54.15593072954052343', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:54:55', 826, 0, '', '2019-05-31 20:54:56');
INSERT INTO `access_log` VALUES (17075, '65.47.15593072966962377', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:54:57', 10, 0, '', '2019-05-31 20:54:57');
INSERT INTO `access_log` VALUES (17076, '65.52.15593072973212351', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:54:57', 20, 0, '', '2019-05-31 20:54:57');
INSERT INTO `access_log` VALUES (17077, '65.51.15593072986352357', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:54:59', 10, 0, '', '2019-05-31 20:54:59');
INSERT INTO `access_log` VALUES (17078, '59.78.15593073411512899', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:55:41', 3, 0, '', '2019-05-31 20:55:41');
INSERT INTO `access_log` VALUES (17079, '59.80.15593073411542893', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:55:41', 20, 2001001000, '服务端发生异常', '2019-05-31 20:55:41');
INSERT INTO `access_log` VALUES (17080, '64.78.15593073437532315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:55:44', 3, 0, '', '2019-05-31 20:55:44');
INSERT INTO `access_log` VALUES (17081, '64.82.15593073438872317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:55:44', 2, 0, '', '2019-05-31 20:55:44');
INSERT INTO `access_log` VALUES (17082, '64.84.15593073451222313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:55:45', 2, 0, '', '2019-05-31 20:55:45');
INSERT INTO `access_log` VALUES (17083, '64.80.15593073456982303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:55:46', 2, 0, '', '2019-05-31 20:55:46');
INSERT INTO `access_log` VALUES (17084, '59.76.15593073470732893', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:55:47', 3, 0, '', '2019-05-31 20:55:47');
INSERT INTO `access_log` VALUES (17085, '59.72.15593073470762891', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.248.153.160', '2019-05-31 20:55:47', 13, 2001001000, '服务端发生异常', '2019-05-31 20:55:47');
INSERT INTO `access_log` VALUES (17086, '59.79.15593077147072901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:01:55', 4, 0, '', '2019-05-31 21:01:55');
INSERT INTO `access_log` VALUES (17087, '59.78.15593077147082905', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:01:55', 20, 2001001000, '服务端发生异常', '2019-05-31 21:01:55');
INSERT INTO `access_log` VALUES (17088, '64.85.15593077219672321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:02:02', 3, 0, '', '2019-05-31 21:02:02');
INSERT INTO `access_log` VALUES (17089, '64.78.15593077221282321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:02:02', 2, 0, '', '2019-05-31 21:02:02');
INSERT INTO `access_log` VALUES (17090, '64.82.15593077234492323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:02:03', 2, 0, '', '2019-05-31 21:02:03');
INSERT INTO `access_log` VALUES (17091, '64.84.15593077244882319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:02:04', 2, 0, '', '2019-05-31 21:02:04');
INSERT INTO `access_log` VALUES (17092, '59.72.15593077262352897', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:02:06', 3, 0, '', '2019-05-31 21:02:06');
INSERT INTO `access_log` VALUES (17093, '59.76.15593077262352899', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:02:06', 13, 2001001000, '服务端发生异常', '2019-05-31 21:02:06');
INSERT INTO `access_log` VALUES (17094, '65.50.15593077531212381', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:02:33', 1, 1002001015, '账号未登陆', '2019-05-31 21:02:33');
INSERT INTO `access_log` VALUES (17095, '65.49.15593077531202381', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:02:33', 0, 1002001015, '账号未登陆', '2019-05-31 21:02:33');
INSERT INTO `access_log` VALUES (17096, '65.45.15593077531232379', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:02:33', 1, 1002001015, '账号未登陆', '2019-05-31 21:02:33');
INSERT INTO `access_log` VALUES (17097, '65.48.15593077559302377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:02:36', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:02:36');
INSERT INTO `access_log` VALUES (17098, '65.46.15593077700892367', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.213.10.222', '2019-05-31 21:02:50', 1, 1002001015, '账号未登陆', '2019-05-31 21:02:50');
INSERT INTO `access_log` VALUES (17099, '65.54.15593077700932351', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.213.10.222', '2019-05-31 21:02:50', 0, 1002001015, '账号未登陆', '2019-05-31 21:02:50');
INSERT INTO `access_log` VALUES (17100, '65.47.15593077701012385', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.213.10.222', '2019-05-31 21:02:50', 0, 1002001015, '账号未登陆', '2019-05-31 21:02:50');
INSERT INTO `access_log` VALUES (17101, '65.52.15593077723812359', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.213.10.222', '2019-05-31 21:02:52', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:02:52');
INSERT INTO `access_log` VALUES (17102, '65.49.15593078075112383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:03:28', 66, 0, '', '2019-05-31 21:03:28');
INSERT INTO `access_log` VALUES (17103, '65.48.15593078079912379', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:03:28', 10, 0, '', '2019-05-31 21:03:28');
INSERT INTO `access_log` VALUES (17104, '65.47.15593078079922387', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:03:28', 11, 0, '', '2019-05-31 21:03:28');
INSERT INTO `access_log` VALUES (17105, '65.53.15593078079912357', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:03:28', 11, 0, '', '2019-05-31 21:03:28');
INSERT INTO `access_log` VALUES (17106, '62.88.15593078187292801', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:03:39', 12, 0, '', '2019-05-31 21:03:39');
INSERT INTO `access_log` VALUES (17107, '65.54.15593078187912353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.213.10.222', '2019-05-31 21:03:39', 63, 0, '', '2019-05-31 21:03:39');
INSERT INTO `access_log` VALUES (17108, '65.52.15593078194582361', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.213.10.222', '2019-05-31 21:03:39', 9, 0, '', '2019-05-31 21:03:39');
INSERT INTO `access_log` VALUES (17109, '65.51.15593078194632367', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.213.10.222', '2019-05-31 21:03:39', 9, 0, '', '2019-05-31 21:03:39');
INSERT INTO `access_log` VALUES (17110, '65.45.15593078194822383', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.213.10.222', '2019-05-31 21:03:39', 9, 0, '', '2019-05-31 21:03:39');
INSERT INTO `access_log` VALUES (17111, '64.78.15593078252382323', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:03:45', 11, 0, '', '2019-05-31 21:03:45');
INSERT INTO `access_log` VALUES (17112, '64.82.15593078252502325', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:03:45', 7, 0, '', '2019-05-31 21:03:45');
INSERT INTO `access_log` VALUES (17113, '62.81.15593078257672787', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.213.10.222', '2019-05-31 21:03:46', 12, 0, '', '2019-05-31 21:03:46');
INSERT INTO `access_log` VALUES (17114, '62.85.15593078313542805', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.87.132.119', '2019-05-31 21:03:51', 68, 0, '', '2019-05-31 21:03:51');
INSERT INTO `access_log` VALUES (17115, '65.48.15593078476922381', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-05-31 21:04:08', 4, 1002001012, '访问令牌已过期', '2019-05-31 21:04:08');
INSERT INTO `access_log` VALUES (17116, '65.49.15593078476912385', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-05-31 21:04:08', 4, 1002001012, '访问令牌已过期', '2019-05-31 21:04:08');
INSERT INTO `access_log` VALUES (17117, '65.53.15593078476952359', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-05-31 21:04:08', 3, 1002001012, '访问令牌已过期', '2019-05-31 21:04:08');
INSERT INTO `access_log` VALUES (17118, '65.46.15593078509262371', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-05-31 21:04:11', 190, 0, '', '2019-05-31 21:04:11');
INSERT INTO `access_log` VALUES (17119, '65.54.15593078514162355', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-05-31 21:04:11', 8, 0, '', '2019-05-31 21:04:11');
INSERT INTO `access_log` VALUES (17120, '65.51.15593078514162369', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-05-31 21:04:11', 8, 0, '', '2019-05-31 21:04:11');
INSERT INTO `access_log` VALUES (17121, '65.52.15593078514522363', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-05-31 21:04:11', 9, 0, '', '2019-05-31 21:04:11');
INSERT INTO `access_log` VALUES (17122, '65.45.15593078538932385', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-05-31 21:04:14', 19, 0, '', '2019-05-31 21:04:14');
INSERT INTO `access_log` VALUES (17123, '65.50.15593078550522387', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-05-31 21:04:15', 10, 0, '', '2019-05-31 21:04:15');
INSERT INTO `access_log` VALUES (17124, '59.76.15593080030942903', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:06:43', 3, 0, '', '2019-05-31 21:06:43');
INSERT INTO `access_log` VALUES (17125, '59.72.15593080030942901', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:06:43', 10, 2001001000, '服务端发生异常', '2019-05-31 21:06:43');
INSERT INTO `access_log` VALUES (17126, '64.79.15593080394232313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:07:19', 3, 0, '', '2019-05-31 21:07:19');
INSERT INTO `access_log` VALUES (17127, '64.81.15593080396192315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:07:20', 2, 0, '', '2019-05-31 21:07:20');
INSERT INTO `access_log` VALUES (17128, '64.85.15593080414092327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:07:21', 2, 0, '', '2019-05-31 21:07:21');
INSERT INTO `access_log` VALUES (17129, '64.82.15593080421232329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:07:22', 2, 0, '', '2019-05-31 21:07:22');
INSERT INTO `access_log` VALUES (17130, '59.75.15593080456802905', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:07:26', 3, 0, '', '2019-05-31 21:07:26');
INSERT INTO `access_log` VALUES (17131, '59.77.15593080456812903', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:07:26', 14, 2001001000, '服务端发生异常', '2019-05-31 21:07:26');
INSERT INTO `access_log` VALUES (17132, '59.79.15593080508282907', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:07:31', 3, 0, '', '2019-05-31 21:07:31');
INSERT INTO `access_log` VALUES (17133, '59.78.15593080508352911', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:07:31', 13, 2001001000, '服务端发生异常', '2019-05-31 21:07:31');
INSERT INTO `access_log` VALUES (17134, '64.78.15593080526632327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:07:33', 2, 0, '', '2019-05-31 21:07:33');
INSERT INTO `access_log` VALUES (17135, '64.84.15593080528002325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:07:33', 2, 0, '', '2019-05-31 21:07:33');
INSERT INTO `access_log` VALUES (17136, '64.80.15593080551532315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:07:35', 2, 0, '', '2019-05-31 21:07:35');
INSERT INTO `access_log` VALUES (17137, '64.77.15593080553482325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:07:35', 2, 0, '', '2019-05-31 21:07:35');
INSERT INTO `access_log` VALUES (17138, '64.79.15593080565102315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:07:37', 2, 0, '', '2019-05-31 21:07:37');
INSERT INTO `access_log` VALUES (17139, '64.81.15593080571912317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:07:37', 2, 0, '', '2019-05-31 21:07:37');
INSERT INTO `access_log` VALUES (17140, '66.56.15593080591881803', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:07:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-05-31 21:07:39');
INSERT INTO `access_log` VALUES (17141, '66.57.15593080614441807', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:07:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空\n账号长度为 11 位', '2019-05-31 21:07:41');
INSERT INTO `access_log` VALUES (17142, '65.46.15593080618382375', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:07:42', 1, 1002001015, '账号未登陆', '2019-05-31 21:07:42');
INSERT INTO `access_log` VALUES (17143, '65.54.15593080618492359', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:07:42', 1, 1002001015, '账号未登陆', '2019-05-31 21:07:42');
INSERT INTO `access_log` VALUES (17144, '65.51.15593080618532373', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:07:42', 1, 1002001015, '账号未登陆', '2019-05-31 21:07:42');
INSERT INTO `access_log` VALUES (17145, '65.52.15593080641712367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:07:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:07:44');
INSERT INTO `access_log` VALUES (17146, '65.50.15593080813992391', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:08:01', 95, 0, '', '2019-05-31 21:08:01');
INSERT INTO `access_log` VALUES (17147, '65.48.15593080818702387', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:08:02', 75, 0, '', '2019-05-31 21:08:02');
INSERT INTO `access_log` VALUES (17148, '65.49.15593080818752391', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:08:02', 71, 0, '', '2019-05-31 21:08:02');
INSERT INTO `access_log` VALUES (17149, '65.53.15593080818792365', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:08:02', 67, 0, '', '2019-05-31 21:08:02');
INSERT INTO `access_log` VALUES (17150, '65.47.15593080862362395', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:06', 0, 1002001015, '账号未登陆', '2019-05-31 21:08:06');
INSERT INTO `access_log` VALUES (17151, '65.46.15593080862422377', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:06', 0, 1002001015, '账号未登陆', '2019-05-31 21:08:06');
INSERT INTO `access_log` VALUES (17152, '65.54.15593080862492361', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:06', 1, 1002001015, '账号未登陆', '2019-05-31 21:08:06');
INSERT INTO `access_log` VALUES (17153, '65.52.15593080943732369', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:08:14');
INSERT INTO `access_log` VALUES (17154, '65.45.15593080966742391', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:08:17');
INSERT INTO `access_log` VALUES (17155, '65.50.15593080976012393', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:18', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:08:18');
INSERT INTO `access_log` VALUES (17156, '65.49.15593080979882393', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:08:18');
INSERT INTO `access_log` VALUES (17157, '65.53.15593080986382367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:19', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:08:19');
INSERT INTO `access_log` VALUES (17158, '62.80.15593081023342805', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:08:22', 14, 0, '', '2019-05-31 21:08:22');
INSERT INTO `access_log` VALUES (17159, '64.78.15593081084572329', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:08:28', 11, 0, '', '2019-05-31 21:08:28');
INSERT INTO `access_log` VALUES (17160, '64.84.15593081084602327', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:08:28', 8, 0, '', '2019-05-31 21:08:28');
INSERT INTO `access_log` VALUES (17161, '65.46.15593081106532379', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:31', 376, 0, '', '2019-05-31 21:08:31');
INSERT INTO `access_log` VALUES (17162, '65.54.15593081112712363', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:31', 10, 0, '', '2019-05-31 21:08:31');
INSERT INTO `access_log` VALUES (17163, '65.47.15593081112772397', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:31', 8, 0, '', '2019-05-31 21:08:31');
INSERT INTO `access_log` VALUES (17164, '65.51.15593081112802377', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:31', 8, 0, '', '2019-05-31 21:08:31');
INSERT INTO `access_log` VALUES (17165, '65.52.15593081138682371', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '59.63.204.59', '2019-05-31 21:08:34', 19, 0, '', '2019-05-31 21:08:34');
INSERT INTO `access_log` VALUES (17166, '62.85.15593081145242809', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:35', 14, 0, '', '2019-05-31 21:08:35');
INSERT INTO `access_log` VALUES (17167, '66.55.15593081193211817', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:39', 13, 0, '', '2019-05-31 21:08:39');
INSERT INTO `access_log` VALUES (17168, '65.50.15593081244832395', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:44', 19, 0, '', '2019-05-31 21:08:45');
INSERT INTO `access_log` VALUES (17169, '65.49.15593081261362395', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:46', 9, 0, '', '2019-05-31 21:08:46');
INSERT INTO `access_log` VALUES (17170, '65.53.15593081273602369', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:47', 34, 0, '', '2019-05-31 21:08:47');
INSERT INTO `access_log` VALUES (17171, '65.48.15593081284342391', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:48', 15, 0, '', '2019-05-31 21:08:48');
INSERT INTO `access_log` VALUES (17172, '65.46.15593081292772381', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:49', 12, 0, '', '2019-05-31 21:08:49');
INSERT INTO `access_log` VALUES (17173, '65.51.15593081382562379', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:58', 12, 0, '', '2019-05-31 21:08:58');
INSERT INTO `access_log` VALUES (17174, '65.47.15593081382572399', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:58', 13, 0, '', '2019-05-31 21:08:58');
INSERT INTO `access_log` VALUES (17175, '65.52.15593081382632373', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:58', 9, 0, '', '2019-05-31 21:08:58');
INSERT INTO `access_log` VALUES (17176, '65.45.15593081383582395', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-05-31 21:08:58', 12, 0, '', '2019-05-31 21:08:58');
INSERT INTO `access_log` VALUES (17177, '59.76.15593083676662909', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:12:48', 3, 0, '', '2019-05-31 21:12:48');
INSERT INTO `access_log` VALUES (17178, '59.72.15593083676662907', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:12:48', 13, 2001001000, '服务端发生异常', '2019-05-31 21:12:48');
INSERT INTO `access_log` VALUES (17179, '59.73.15593083677712913', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:12:48', 3, 0, '', '2019-05-31 21:12:48');
INSERT INTO `access_log` VALUES (17180, '59.74.15593083677702911', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:12:48', 12, 2001001000, '服务端发生异常', '2019-05-31 21:12:48');
INSERT INTO `access_log` VALUES (17181, '64.78.15593083710642333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:12:51', 2, 0, '', '2019-05-31 21:12:51');
INSERT INTO `access_log` VALUES (17182, '64.84.15593083711622331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:12:51', 2, 0, '', '2019-05-31 21:12:51');
INSERT INTO `access_log` VALUES (17183, '64.80.15593083740722321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:12:54', 2, 0, '', '2019-05-31 21:12:54');
INSERT INTO `access_log` VALUES (17184, '64.77.15593083749102331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:12:55', 3, 0, '', '2019-05-31 21:12:55');
INSERT INTO `access_log` VALUES (17185, '59.75.15593083772842911', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:12:57', 4, 0, '', '2019-05-31 21:12:57');
INSERT INTO `access_log` VALUES (17186, '59.77.15593083772842909', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:12:57', 13, 2001001000, '服务端发生异常', '2019-05-31 21:12:57');
INSERT INTO `access_log` VALUES (17187, '64.76.15593083797762325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:13:00', 3, 0, '', '2019-05-31 21:13:00');
INSERT INTO `access_log` VALUES (17188, '64.79.15593083798652321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:13:00', 2, 0, '', '2019-05-31 21:13:00');
INSERT INTO `access_log` VALUES (17189, '65.45.15593084290122399', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:13:49', 0, 1002001015, '账号未登陆', '2019-05-31 21:13:49');
INSERT INTO `access_log` VALUES (17190, '65.50.15593084290172401', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:13:49', 0, 1002001015, '账号未登陆', '2019-05-31 21:13:49');
INSERT INTO `access_log` VALUES (17191, '65.49.15593084290222401', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:13:49', 0, 1002001015, '账号未登陆', '2019-05-31 21:13:49');
INSERT INTO `access_log` VALUES (17192, '65.46.15593084543322387', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:14:14', 93, 0, '', '2019-05-31 21:14:14');
INSERT INTO `access_log` VALUES (17193, '65.54.15593084546742371', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:14:15', 10, 0, '', '2019-05-31 21:14:15');
INSERT INTO `access_log` VALUES (17194, '65.51.15593084546752385', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:14:15', 9, 0, '', '2019-05-31 21:14:15');
INSERT INTO `access_log` VALUES (17195, '65.47.15593084546812405', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:14:15', 9, 0, '', '2019-05-31 21:14:15');
INSERT INTO `access_log` VALUES (17196, '62.88.15593084631142811', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:14:23', 11, 0, '', '2019-05-31 21:14:23');
INSERT INTO `access_log` VALUES (17197, '64.77.15593084861102333', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:14:46', 11, 0, '', '2019-05-31 21:14:46');
INSERT INTO `access_log` VALUES (17198, '64.76.15593084861142327', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:14:46', 7, 0, '', '2019-05-31 21:14:46');
INSERT INTO `access_log` VALUES (17199, '64.78.15593085376372337', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:15:38', 75, 0, '', '2019-05-31 21:15:38');
INSERT INTO `access_log` VALUES (17200, '64.82.15593085376342339', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:15:38', 87, 0, '', '2019-05-31 21:15:38');
INSERT INTO `access_log` VALUES (17201, '64.84.15593085413702335', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:15:41', 12, 0, '', '2019-05-31 21:15:41');
INSERT INTO `access_log` VALUES (17202, '64.80.15593085427902325', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:15:43', 11, 0, '', '2019-05-31 21:15:43');
INSERT INTO `access_log` VALUES (17203, '64.77.15593085440082335', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:15:44', 10, 0, '', '2019-05-31 21:15:44');
INSERT INTO `access_log` VALUES (17204, '64.76.15593085450082329', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:15:45', 12, 0, '', '2019-05-31 21:15:45');
INSERT INTO `access_log` VALUES (17205, '64.79.15593085459172325', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:15:46', 11, 0, '', '2019-05-31 21:15:46');
INSERT INTO `access_log` VALUES (17206, '64.81.15593085466942327', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:15:47', 8, 0, '', '2019-05-31 21:15:47');
INSERT INTO `access_log` VALUES (17207, '64.83.15593085476072329', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:15:48', 12, 0, '', '2019-05-31 21:15:48');
INSERT INTO `access_log` VALUES (17208, '64.85.15593085483672339', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:15:48', 12, 0, '', '2019-05-31 21:15:48');
INSERT INTO `access_log` VALUES (17209, '64.82.15593085545052341', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:15:55', 13, 0, '', '2019-05-31 21:15:55');
INSERT INTO `access_log` VALUES (17210, '64.84.15593085552572337', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:15:55', 10, 0, '', '2019-05-31 21:15:55');
INSERT INTO `access_log` VALUES (17211, '64.80.15593085561542327', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:15:56', 11, 0, '', '2019-05-31 21:15:56');
INSERT INTO `access_log` VALUES (17212, '64.77.15593085573362337', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:15:57', 18, 0, '', '2019-05-31 21:15:57');
INSERT INTO `access_log` VALUES (17213, '64.76.15593085617632331', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:16:02', 72, 0, '', '2019-05-31 21:16:02');
INSERT INTO `access_log` VALUES (17214, '66.53.15593086104071821', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:16:50', 15, 0, '', '2019-05-31 21:16:50');
INSERT INTO `access_log` VALUES (17215, '59.74.15593086174392915', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:16:57', 14, 0, '', '2019-05-31 21:16:57');
INSERT INTO `access_log` VALUES (17216, '59.71.15593086212592917', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:17:01', 26, 2001001000, '服务端发生异常', '2019-05-31 21:17:01');
INSERT INTO `access_log` VALUES (17217, '59.77.15593086341792913', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:17:14', 537, 0, '', '2019-05-31 21:17:15');
INSERT INTO `access_log` VALUES (17218, '64.82.15593086371442343', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:17:17', 9, 0, '', '2019-05-31 21:17:17');
INSERT INTO `access_log` VALUES (17219, '64.77.15593086556482339', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:17:36', 10, 0, '', '2019-05-31 21:17:36');
INSERT INTO `access_log` VALUES (17220, '59.80.15593086583052915', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:17:38', 10, 0, '', '2019-05-31 21:17:38');
INSERT INTO `access_log` VALUES (17221, '59.72.15593086614412913', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:17:41', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-31 21:17:41');
INSERT INTO `access_log` VALUES (17222, '65.53.15593086632672379', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:17:43', 20, 0, '', '2019-05-31 21:17:43');
INSERT INTO `access_log` VALUES (17223, '65.46.15593086750552391', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:17:55', 10, 0, '', '2019-05-31 21:17:55');
INSERT INTO `access_log` VALUES (17224, '65.51.15593086819862389', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:18:02', 10, 0, '', '2019-05-31 21:18:02');
INSERT INTO `access_log` VALUES (17225, '65.47.15593086959512409', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:18:16', 9, 0, '', '2019-05-31 21:18:16');
INSERT INTO `access_log` VALUES (17226, '65.49.15593087076522407', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.83.32.200', '2019-05-31 21:18:28', 13, 0, '', '2019-05-31 21:18:28');
INSERT INTO `access_log` VALUES (17227, '59.75.15593087227812917', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.151.51.139', '2019-05-31 21:18:43', 3, 0, '', '2019-05-31 21:18:43');
INSERT INTO `access_log` VALUES (17228, '59.77.15593087228262915', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.151.51.139', '2019-05-31 21:18:43', 14, 2001001000, '服务端发生异常', '2019-05-31 21:18:43');
INSERT INTO `access_log` VALUES (17229, '59.80.15593087403832917', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.151.51.139', '2019-05-31 21:19:00', 3, 0, '', '2019-05-31 21:19:00');
INSERT INTO `access_log` VALUES (17230, '59.78.15593087403832923', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.151.51.139', '2019-05-31 21:19:00', 12, 2001001000, '服务端发生异常', '2019-05-31 21:19:00');
INSERT INTO `access_log` VALUES (17231, '64.78.15593087445112343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.151.51.139', '2019-05-31 21:19:05', 3, 0, '', '2019-05-31 21:19:05');
INSERT INTO `access_log` VALUES (17232, '64.82.15593087446112345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.151.51.139', '2019-05-31 21:19:05', 3, 0, '', '2019-05-31 21:19:05');
INSERT INTO `access_log` VALUES (17233, '65.47.15593088120642411', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.116.129', '2019-05-31 21:20:12', 1, 1002001015, '账号未登陆', '2019-05-31 21:20:12');
INSERT INTO `access_log` VALUES (17234, '65.52.15593088120692385', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.116.129', '2019-05-31 21:20:12', 0, 1002001015, '账号未登陆', '2019-05-31 21:20:12');
INSERT INTO `access_log` VALUES (17235, '65.49.15593088120692409', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.116.129', '2019-05-31 21:20:12', 0, 1002001015, '账号未登陆', '2019-05-31 21:20:12');
INSERT INTO `access_log` VALUES (17236, '65.45.15593088250582407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=youdaoyuanma&password=youdaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.116.129', '2019-05-31 21:20:25', 5, 1002002000, '账号不存在', '2019-05-31 21:20:25');
INSERT INTO `access_log` VALUES (17237, '65.53.15593088294762383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.116.129', '2019-05-31 21:20:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:20:29');
INSERT INTO `access_log` VALUES (17238, '65.46.15593088463432395', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.116.129', '2019-05-31 21:20:46', 81, 0, '', '2019-05-31 21:20:46');
INSERT INTO `access_log` VALUES (17239, '65.47.15593088467182413', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.116.129', '2019-05-31 21:20:47', 359, 0, '', '2019-05-31 21:20:47');
INSERT INTO `access_log` VALUES (17240, '65.51.15593088467142393', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.116.129', '2019-05-31 21:20:47', 447, 0, '', '2019-05-31 21:20:47');
INSERT INTO `access_log` VALUES (17241, '65.54.15593088467172379', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.116.129', '2019-05-31 21:20:47', 447, 0, '', '2019-05-31 21:20:47');
INSERT INTO `access_log` VALUES (17242, '62.81.15593088499982803', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.116.129', '2019-05-31 21:20:50', 14, 0, '', '2019-05-31 21:20:50');
INSERT INTO `access_log` VALUES (17243, '64.82.15593088538122347', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.116.129', '2019-05-31 21:20:54', 9, 0, '', '2019-05-31 21:20:54');
INSERT INTO `access_log` VALUES (17244, '64.78.15593088538092345', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.116.129', '2019-05-31 21:20:54', 13, 0, '', '2019-05-31 21:20:54');
INSERT INTO `access_log` VALUES (17245, '66.54.15593088556091815', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.116.129', '2019-05-31 21:20:56', 15, 0, '', '2019-05-31 21:20:56');
INSERT INTO `access_log` VALUES (17246, '65.53.15593089031982385', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:21:43', 1, 1002001015, '账号未登陆', '2019-05-31 21:21:43');
INSERT INTO `access_log` VALUES (17247, '65.48.15593089032002407', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:21:43', 0, 1002001015, '账号未登陆', '2019-05-31 21:21:43');
INSERT INTO `access_log` VALUES (17248, '65.46.15593089032072397', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:21:43', 0, 1002001015, '账号未登陆', '2019-05-31 21:21:43');
INSERT INTO `access_log` VALUES (17249, '65.51.15593089190212395', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.7.1027', '49.65.117.70', '2019-05-31 21:21:59', 0, 1002001015, '账号未登陆', '2019-05-31 21:21:59');
INSERT INTO `access_log` VALUES (17250, '65.54.15593089190492381', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.7.1027', '49.65.117.70', '2019-05-31 21:21:59', 0, 1002001015, '账号未登陆', '2019-05-31 21:21:59');
INSERT INTO `access_log` VALUES (17251, '65.49.15593089190592413', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.7.1027', '49.65.117.70', '2019-05-31 21:21:59', 1, 1002001015, '账号未登陆', '2019-05-31 21:21:59');
INSERT INTO `access_log` VALUES (17252, '62.89.15593089196512819', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.7.1027', '49.65.117.70', '2019-05-31 21:22:00', 1, 1002001015, '账号未登陆', '2019-05-31 21:22:00');
INSERT INTO `access_log` VALUES (17253, '65.50.15593089335992413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:22:14', 198, 0, '', '2019-05-31 21:22:14');
INSERT INTO `access_log` VALUES (17254, '65.45.15593089340802411', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:22:14', 9, 0, '', '2019-05-31 21:22:14');
INSERT INTO `access_log` VALUES (17255, '65.46.15593089340872399', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:22:14', 7, 0, '', '2019-05-31 21:22:14');
INSERT INTO `access_log` VALUES (17256, '65.48.15593089340882409', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:22:14', 7, 0, '', '2019-05-31 21:22:14');
INSERT INTO `access_log` VALUES (17257, '62.86.15593089411382811', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:22:21', 13, 0, '', '2019-05-31 21:22:21');
INSERT INTO `access_log` VALUES (17258, '62.81.15593089488992805', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:22:29', 16, 0, '', '2019-05-31 21:22:29');
INSERT INTO `access_log` VALUES (17259, '64.85.15593089608322347', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:22:41', 10, 0, '', '2019-05-31 21:22:41');
INSERT INTO `access_log` VALUES (17260, '64.78.15593089608322347', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:22:41', 12, 0, '', '2019-05-31 21:22:41');
INSERT INTO `access_log` VALUES (17261, '64.81.15593090442302337', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:24:04', 11, 0, '', '2019-05-31 21:24:04');
INSERT INTO `access_log` VALUES (17262, '64.79.15593090442302335', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:24:04', 13, 0, '', '2019-05-31 21:24:04');
INSERT INTO `access_log` VALUES (17263, '64.85.15593090485902349', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:24:09', 10, 0, '', '2019-05-31 21:24:09');
INSERT INTO `access_log` VALUES (17264, '64.82.15593090517712351', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:24:12', 10, 0, '', '2019-05-31 21:24:12');
INSERT INTO `access_log` VALUES (17265, '64.78.15593090517712349', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:24:12', 11, 0, '', '2019-05-31 21:24:12');
INSERT INTO `access_log` VALUES (17266, '59.73.15593090591402925', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:24:19', 20, 2001001000, '服务端发生异常', '2019-05-31 21:24:19');
INSERT INTO `access_log` VALUES (17267, '59.74.15593090631992923', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:24:23', 14, 0, '', '2019-05-31 21:24:23');
INSERT INTO `access_log` VALUES (17268, '59.71.15593090684132925', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:24:28', 13, 0, '', '2019-05-31 21:24:28');
INSERT INTO `access_log` VALUES (17269, '59.75.15593090725312923', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:24:33', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-05-31 21:24:33');
INSERT INTO `access_log` VALUES (17270, '65.53.15593090816012389', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.92.47.242', '2019-05-31 21:24:42', 11, 0, '', '2019-05-31 21:24:42');
INSERT INTO `access_log` VALUES (17271, '65.47.15593096784122427', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.7.1027', '49.65.117.70', '2019-05-31 21:34:38', 1, 1002001015, '账号未登陆', '2019-05-31 21:34:38');
INSERT INTO `access_log` VALUES (17272, '65.53.15593096784122397', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.7.1027', '49.65.117.70', '2019-05-31 21:34:38', 1, 1002001015, '账号未登陆', '2019-05-31 21:34:38');
INSERT INTO `access_log` VALUES (17273, '65.51.15593096784152407', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.4.7.1027', '49.65.117.70', '2019-05-31 21:34:38', 0, 1002001015, '账号未登陆', '2019-05-31 21:34:38');
INSERT INTO `access_log` VALUES (17274, '59.72.15593100257002933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:26', 4, 0, '', '2019-05-31 21:40:26');
INSERT INTO `access_log` VALUES (17275, '59.76.15593100257012935', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:26', 20, 2001001000, '服务端发生异常', '2019-05-31 21:40:26');
INSERT INTO `access_log` VALUES (17276, '64.79.15593100291732349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:29', 4, 0, '', '2019-05-31 21:40:29');
INSERT INTO `access_log` VALUES (17277, '64.83.15593100293112353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:29', 2, 0, '', '2019-05-31 21:40:29');
INSERT INTO `access_log` VALUES (17278, '64.85.15593100311372363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:31', 2, 0, '', '2019-05-31 21:40:31');
INSERT INTO `access_log` VALUES (17279, '64.78.15593100319342363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:32', 2, 0, '', '2019-05-31 21:40:32');
INSERT INTO `access_log` VALUES (17280, '64.82.15593100324252365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:32', 3, 0, '', '2019-05-31 21:40:32');
INSERT INTO `access_log` VALUES (17281, '64.80.15593100360492351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:36', 3, 0, '', '2019-05-31 21:40:36');
INSERT INTO `access_log` VALUES (17282, '64.77.15593100364302361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:36', 2, 0, '', '2019-05-31 21:40:36');
INSERT INTO `access_log` VALUES (17283, '59.74.15593100367992937', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '183.229.44.133', '2019-05-31 21:40:37', 3, 0, '', '2019-05-31 21:40:37');
INSERT INTO `access_log` VALUES (17284, '59.71.15593100368202939', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '183.229.44.133', '2019-05-31 21:40:37', 15, 2001001000, '服务端发生异常', '2019-05-31 21:40:37');
INSERT INTO `access_log` VALUES (17285, '64.76.15593100368492355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:37', 2, 0, '', '2019-05-31 21:40:37');
INSERT INTO `access_log` VALUES (17286, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:38', 25, 0, '', '2019-05-31 21:40:38');
INSERT INTO `access_log` VALUES (17287, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:38', 15, 0, '', '2019-05-31 21:40:38');
INSERT INTO `access_log` VALUES (17288, '64.81.15593100393172353', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:39', 8, 0, '', '2019-05-31 21:40:39');
INSERT INTO `access_log` VALUES (17289, '65.45.15593100592892427', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:59', 0, 1002001015, '账号未登陆', '2019-05-31 21:40:59');
INSERT INTO `access_log` VALUES (17290, '65.47.15593100592902433', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:59', 1, 1002001015, '账号未登陆', '2019-05-31 21:40:59');
INSERT INTO `access_log` VALUES (17291, '65.53.15593100592952403', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:40:59', 1, 1002001015, '账号未登陆', '2019-05-31 21:40:59');
INSERT INTO `access_log` VALUES (17292, '65.51.15593100609352413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:41:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:41:01');
INSERT INTO `access_log` VALUES (17293, '65.54.15593100634752399', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:41:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:41:03');
INSERT INTO `access_log` VALUES (17294, '64.85.15593100692402365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '183.229.44.133', '2019-05-31 21:41:09', 2, 0, '', '2019-05-31 21:41:09');
INSERT INTO `access_log` VALUES (17295, '64.78.15593100693692365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '183.229.44.133', '2019-05-31 21:41:09', 2, 0, '', '2019-05-31 21:41:09');
INSERT INTO `access_log` VALUES (17296, '65.52.15593100744922407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:41:14', 89, 0, '', '2019-05-31 21:41:15');
INSERT INTO `access_log` VALUES (17297, '65.50.15593100747782431', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:41:15', 10, 0, '', '2019-05-31 21:41:15');
INSERT INTO `access_log` VALUES (17298, '65.48.15593100747802427', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:41:15', 9, 0, '', '2019-05-31 21:41:15');
INSERT INTO `access_log` VALUES (17299, '65.46.15593100747812417', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:41:15', 10, 0, '', '2019-05-31 21:41:15');
INSERT INTO `access_log` VALUES (17300, '64.82.15593100772952367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '183.229.44.133', '2019-05-31 21:41:17', 3, 0, '', '2019-05-31 21:41:17');
INSERT INTO `access_log` VALUES (17301, '64.84.15593100774192363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '183.229.44.133', '2019-05-31 21:41:17', 2, 0, '', '2019-05-31 21:41:17');
INSERT INTO `access_log` VALUES (17302, '62.88.15593100824942835', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:41:22', 15, 0, '', '2019-05-31 21:41:23');
INSERT INTO `access_log` VALUES (17303, '64.77.15593100884252363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '183.229.44.133', '2019-05-31 21:41:28', 3, 0, '', '2019-05-31 21:41:28');
INSERT INTO `access_log` VALUES (17304, '64.76.15593100885982357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '183.229.44.133', '2019-05-31 21:41:29', 53, 0, '', '2019-05-31 21:41:29');
INSERT INTO `access_log` VALUES (17305, '64.81.15593100899092355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '183.229.44.133', '2019-05-31 21:41:30', 2, 0, '', '2019-05-31 21:41:30');
INSERT INTO `access_log` VALUES (17306, '64.83.15593100906682357', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:41:31', 10, 0, '', '2019-05-31 21:41:31');
INSERT INTO `access_log` VALUES (17307, '64.79.15593100906682353', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:41:31', 11, 0, '', '2019-05-31 21:41:31');
INSERT INTO `access_log` VALUES (17308, '64.85.15593100908872367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '183.229.44.133', '2019-05-31 21:41:31', 2, 0, '', '2019-05-31 21:41:31');
INSERT INTO `access_log` VALUES (17309, '64.78.15593100913842367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '183.229.44.133', '2019-05-31 21:41:31', 2, 0, '', '2019-05-31 21:41:31');
INSERT INTO `access_log` VALUES (17310, '64.82.15593100946342369', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:41:35', 12, 0, '', '2019-05-31 21:41:35');
INSERT INTO `access_log` VALUES (17311, '64.84.15593100946502365', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:41:35', 8, 0, '', '2019-05-31 21:41:35');
INSERT INTO `access_log` VALUES (17312, '59.76.15593100967192937', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '183.229.44.133', '2019-05-31 21:41:37', 4, 0, '', '2019-05-31 21:41:37');
INSERT INTO `access_log` VALUES (17313, '59.78.15593100967182943', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '183.229.44.133', '2019-05-31 21:41:37', 13, 2001001000, '服务端发生异常', '2019-05-31 21:41:37');
INSERT INTO `access_log` VALUES (17314, '64.77.15593100976822365', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:41:38', 10, 0, '', '2019-05-31 21:41:38');
INSERT INTO `access_log` VALUES (17315, '64.76.15593101035792359', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:41:44', 10, 0, '', '2019-05-31 21:41:44');
INSERT INTO `access_log` VALUES (17316, '59.74.15593101255962939', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:42:06', 12, 0, '', '2019-05-31 21:42:06');
INSERT INTO `access_log` VALUES (17317, '59.71.15593101293212941', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:42:09', 27, 2001001000, '服务端发生异常', '2019-05-31 21:42:09');
INSERT INTO `access_log` VALUES (17318, '65.54.15593101319042401', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:42:12', 19, 0, '', '2019-05-31 21:42:12');
INSERT INTO `access_log` VALUES (17319, '65.49.15593101331112433', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:42:13', 10, 0, '', '2019-05-31 21:42:13');
INSERT INTO `access_log` VALUES (17320, '65.52.15593101338312409', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:42:14', 18, 0, '', '2019-05-31 21:42:14');
INSERT INTO `access_log` VALUES (17321, '65.48.15593101346662429', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:42:15', 11, 0, '', '2019-05-31 21:42:15');
INSERT INTO `access_log` VALUES (17322, '65.46.15593101377772419', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:42:18', 13, 0, '', '2019-05-31 21:42:18');
INSERT INTO `access_log` VALUES (17323, '65.45.15593101447982431', 27, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=1&resourceIds=14,15,16,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,41,42,43,44,45,46,47,51,52,53', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:42:25', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-05-31 21:42:25');
INSERT INTO `access_log` VALUES (17324, '65.47.15593101516342437', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:42:32', 10, 0, '', '2019-05-31 21:42:32');
INSERT INTO `access_log` VALUES (17325, '65.53.15593101526442407', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:42:33', 14, 0, '', '2019-05-31 21:42:33');
INSERT INTO `access_log` VALUES (17326, '65.51.15593101546862417', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:42:35', 18, 0, '', '2019-05-31 21:42:35');
INSERT INTO `access_log` VALUES (17327, '65.49.15593101632732435', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:42:43', 8, 0, '', '2019-05-31 21:42:43');
INSERT INTO `access_log` VALUES (17328, '65.52.15593101652542411', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:42:45', 9, 0, '', '2019-05-31 21:42:45');
INSERT INTO `access_log` VALUES (17329, '65.46.15593101744102421', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.121.16.29', '2019-05-31 21:42:54', 1, 1002001015, '账号未登陆', '2019-05-31 21:42:54');
INSERT INTO `access_log` VALUES (17330, '65.50.15593101744132435', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.121.16.29', '2019-05-31 21:42:54', 0, 1002001015, '账号未登陆', '2019-05-31 21:42:54');
INSERT INTO `access_log` VALUES (17331, '65.45.15593101744282433', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.121.16.29', '2019-05-31 21:42:54', 1, 1002001015, '账号未登陆', '2019-05-31 21:42:54');
INSERT INTO `access_log` VALUES (17332, '65.47.15593101784702439', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.121.16.29', '2019-05-31 21:42:58', 150, 0, '', '2019-05-31 21:42:59');
INSERT INTO `access_log` VALUES (17333, '65.53.15593101788782409', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.121.16.29', '2019-05-31 21:42:59', 9, 0, '', '2019-05-31 21:42:59');
INSERT INTO `access_log` VALUES (17334, '65.51.15593101788832419', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.121.16.29', '2019-05-31 21:42:59', 8, 0, '', '2019-05-31 21:42:59');
INSERT INTO `access_log` VALUES (17335, '65.54.15593101788972405', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.121.16.29', '2019-05-31 21:42:59', 8, 0, '', '2019-05-31 21:42:59');
INSERT INTO `access_log` VALUES (17336, '62.87.15593101831402839', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.121.16.29', '2019-05-31 21:43:03', 13, 0, '', '2019-05-31 21:43:03');
INSERT INTO `access_log` VALUES (17337, '64.84.15593101854202367', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.121.16.29', '2019-05-31 21:43:05', 13, 0, '', '2019-05-31 21:43:05');
INSERT INTO `access_log` VALUES (17338, '64.82.15593101854232371', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.121.16.29', '2019-05-31 21:43:05', 9, 0, '', '2019-05-31 21:43:05');
INSERT INTO `access_log` VALUES (17339, '62.89.15593101858132837', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:06', 12, 0, '', '2019-05-31 21:43:06');
INSERT INTO `access_log` VALUES (17340, '64.77.15593101880592367', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.121.16.29', '2019-05-31 21:43:08', 13, 0, '', '2019-05-31 21:43:08');
INSERT INTO `access_log` VALUES (17341, '64.76.15593101880652361', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.121.16.29', '2019-05-31 21:43:08', 10, 0, '', '2019-05-31 21:43:08');
INSERT INTO `access_log` VALUES (17342, '65.52.15593101911862413', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:11', 8, 0, '', '2019-05-31 21:43:11');
INSERT INTO `access_log` VALUES (17343, '65.48.15593101911892433', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:11', 8, 0, '', '2019-05-31 21:43:11');
INSERT INTO `access_log` VALUES (17344, '65.46.15593101911922423', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:11', 8, 0, '', '2019-05-31 21:43:11');
INSERT INTO `access_log` VALUES (17345, '62.88.15593101912832837', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:11', 11, 0, '', '2019-05-31 21:43:11');
INSERT INTO `access_log` VALUES (17346, '59.76.15593101933672939', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.121.16.29', '2019-05-31 21:43:13', 13, 0, '', '2019-05-31 21:43:13');
INSERT INTO `access_log` VALUES (17347, '65.50.15593101946952437', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:15', 9, 0, '', '2019-05-31 21:43:15');
INSERT INTO `access_log` VALUES (17348, '65.45.15593101947082435', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:15', 10, 0, '', '2019-05-31 21:43:15');
INSERT INTO `access_log` VALUES (17349, '65.47.15593101947092441', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:15', 8, 0, '', '2019-05-31 21:43:15');
INSERT INTO `access_log` VALUES (17350, '62.86.15593101947732829', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:15', 22, 0, '', '2019-05-31 21:43:15');
INSERT INTO `access_log` VALUES (17351, '59.78.15593101964892945', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.121.16.29', '2019-05-31 21:43:16', 129, 0, '', '2019-05-31 21:43:17');
INSERT INTO `access_log` VALUES (17352, '65.51.15593102040092421', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:24', 8, 0, '', '2019-05-31 21:43:24');
INSERT INTO `access_log` VALUES (17353, '65.53.15593102040102411', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:24', 8, 0, '', '2019-05-31 21:43:24');
INSERT INTO `access_log` VALUES (17354, '65.49.15593102040112439', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:24', 9, 0, '', '2019-05-31 21:43:24');
INSERT INTO `access_log` VALUES (17355, '62.84.15593102040742835', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:24', 12, 0, '', '2019-05-31 21:43:24');
INSERT INTO `access_log` VALUES (17356, '65.48.15593102066502435', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:27', 11, 0, '', '2019-05-31 21:43:27');
INSERT INTO `access_log` VALUES (17357, '65.52.15593102066502415', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:27', 12, 0, '', '2019-05-31 21:43:27');
INSERT INTO `access_log` VALUES (17358, '65.46.15593102066612425', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:27', 8, 0, '', '2019-05-31 21:43:27');
INSERT INTO `access_log` VALUES (17359, '62.80.15593102067212837', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.8', '2019-05-31 21:43:27', 12, 0, '', '2019-05-31 21:43:27');
INSERT INTO `access_log` VALUES (17360, '59.71.15593105295552947', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.93.34.65', '2019-05-31 21:48:50', 4, 0, '', '2019-05-31 21:48:50');
INSERT INTO `access_log` VALUES (17361, '59.75.15593105295552945', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.93.34.65', '2019-05-31 21:48:50', 13, 2001001000, '服务端发生异常', '2019-05-31 21:48:50');
INSERT INTO `access_log` VALUES (17362, '65.45.15593105324532441', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.56.15.58', '2019-05-31 21:48:52', 0, 1002001015, '账号未登陆', '2019-05-31 21:48:52');
INSERT INTO `access_log` VALUES (17363, '65.47.15593105324532447', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.56.15.58', '2019-05-31 21:48:52', 0, 1002001015, '账号未登陆', '2019-05-31 21:48:52');
INSERT INTO `access_log` VALUES (17364, '65.54.15593105324572413', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.56.15.58', '2019-05-31 21:48:52', 1, 1002001015, '账号未登陆', '2019-05-31 21:48:52');
INSERT INTO `access_log` VALUES (17365, '59.77.15593105338542943', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.93.34.65', '2019-05-31 21:48:54', 3, 0, '', '2019-05-31 21:48:54');
INSERT INTO `access_log` VALUES (17366, '59.79.15593105338552947', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.93.34.65', '2019-05-31 21:48:54', 14, 2001001000, '服务端发生异常', '2019-05-31 21:48:54');
INSERT INTO `access_log` VALUES (17367, '65.53.15593105345792417', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.56.15.58', '2019-05-31 21:48:55', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:48:55');
INSERT INTO `access_log` VALUES (17368, '65.49.15593105372262445', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.56.15.58', '2019-05-31 21:48:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:48:57');
INSERT INTO `access_log` VALUES (17369, '64.85.15593105396472375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.93.34.65', '2019-05-31 21:49:00', 3, 0, '', '2019-05-31 21:49:00');
INSERT INTO `access_log` VALUES (17370, '64.78.15593105397702375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.93.34.65', '2019-05-31 21:49:00', 2, 0, '', '2019-05-31 21:49:00');
INSERT INTO `access_log` VALUES (17371, '65.48.15593105414162441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.56.15.58', '2019-05-31 21:49:01', 4, 1002002000, '账号不存在', '2019-05-31 21:49:01');
INSERT INTO `access_log` VALUES (17372, '64.84.15593105414532373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.93.34.65', '2019-05-31 21:49:01', 3, 0, '', '2019-05-31 21:49:01');
INSERT INTO `access_log` VALUES (17373, '64.82.15593105423202377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.93.34.65', '2019-05-31 21:49:02', 2, 0, '', '2019-05-31 21:49:02');
INSERT INTO `access_log` VALUES (17374, '65.52.15593105462422421', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.56.15.58', '2019-05-31 21:49:06', 73, 0, '', '2019-05-31 21:49:06');
INSERT INTO `access_log` VALUES (17375, '65.46.15593105465882431', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.56.15.58', '2019-05-31 21:49:07', 9, 0, '', '2019-05-31 21:49:07');
INSERT INTO `access_log` VALUES (17376, '65.50.15593105465972445', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.56.15.58', '2019-05-31 21:49:07', 9, 0, '', '2019-05-31 21:49:07');
INSERT INTO `access_log` VALUES (17377, '65.47.15593105465982449', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.56.15.58', '2019-05-31 21:49:07', 9, 0, '', '2019-05-31 21:49:07');
INSERT INTO `access_log` VALUES (17378, '65.54.15593105493462415', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.93.34.65', '2019-05-31 21:49:09', 0, 1002001015, '账号未登陆', '2019-05-31 21:49:09');
INSERT INTO `access_log` VALUES (17379, '65.51.15593105493512429', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.93.34.65', '2019-05-31 21:49:09', 1, 1002001015, '账号未登陆', '2019-05-31 21:49:09');
INSERT INTO `access_log` VALUES (17380, '65.53.15593105493602419', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.93.34.65', '2019-05-31 21:49:09', 1, 1002001015, '账号未登陆', '2019-05-31 21:49:09');
INSERT INTO `access_log` VALUES (17381, '62.80.15593105496852843', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.56.15.58', '2019-05-31 21:49:10', 14, 0, '', '2019-05-31 21:49:10');
INSERT INTO `access_log` VALUES (17382, '65.49.15593105538052447', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.93.34.65', '2019-05-31 21:49:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:49:14');
INSERT INTO `access_log` VALUES (17383, '64.76.15593105574932367', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.56.15.58', '2019-05-31 21:49:17', 12, 0, '', '2019-05-31 21:49:18');
INSERT INTO `access_log` VALUES (17384, '64.77.15593105574962373', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.56.15.58', '2019-05-31 21:49:17', 9, 0, '', '2019-05-31 21:49:18');
INSERT INTO `access_log` VALUES (17385, '65.52.15593105679912423', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.56.15.58', '2019-05-31 21:49:28', 19, 0, '', '2019-05-31 21:49:28');
INSERT INTO `access_log` VALUES (17386, '65.53.15593106593262421', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.125.129.229', '2019-05-31 21:50:59', 0, 1002001015, '账号未登陆', '2019-05-31 21:50:59');
INSERT INTO `access_log` VALUES (17387, '65.49.15593106593302449', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.125.129.229', '2019-05-31 21:50:59', 1, 1002001015, '账号未登陆', '2019-05-31 21:50:59');
INSERT INTO `access_log` VALUES (17388, '65.48.15593106593352445', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.125.129.229', '2019-05-31 21:50:59', 1, 1002001015, '账号未登陆', '2019-05-31 21:50:59');
INSERT INTO `access_log` VALUES (17389, '65.52.15593106622252425', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.125.129.229', '2019-05-31 21:51:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:51:02');
INSERT INTO `access_log` VALUES (17390, '65.50.15593106687672449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.125.129.229', '2019-05-31 21:51:09', 274, 0, '', '2019-05-31 21:51:09');
INSERT INTO `access_log` VALUES (17391, '65.46.15593106693202435', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.125.129.229', '2019-05-31 21:51:09', 9, 0, '', '2019-05-31 21:51:09');
INSERT INTO `access_log` VALUES (17392, '65.45.15593106693242447', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.125.129.229', '2019-05-31 21:51:09', 9, 0, '', '2019-05-31 21:51:09');
INSERT INTO `access_log` VALUES (17393, '65.54.15593106693252419', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.125.129.229', '2019-05-31 21:51:09', 8, 0, '', '2019-05-31 21:51:09');
INSERT INTO `access_log` VALUES (17394, '62.87.15593106793512847', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.125.129.229', '2019-05-31 21:51:19', 16, 0, '', '2019-05-31 21:51:19');
INSERT INTO `access_log` VALUES (17395, '65.48.15593106876412447', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.125.129.229', '2019-05-31 21:51:28', 18, 0, '', '2019-05-31 21:51:28');
INSERT INTO `access_log` VALUES (17396, '65.49.15593106895882451', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.125.129.229', '2019-05-31 21:51:30', 11, 0, '', '2019-05-31 21:51:30');
INSERT INTO `access_log` VALUES (17397, '65.53.15593106976912423', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.125.129.229', '2019-05-31 21:51:38', 19, 0, '', '2019-05-31 21:51:38');
INSERT INTO `access_log` VALUES (17398, '62.85.15593109361412855', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.125.129.229', '2019-05-31 21:55:36', 13, 0, '', '2019-05-31 21:55:36');
INSERT INTO `access_log` VALUES (17399, '65.48.15593110954682453', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.24.24.195', '2019-05-31 21:58:15', 0, 1002001015, '账号未登陆', '2019-05-31 21:58:15');
INSERT INTO `access_log` VALUES (17400, '65.49.15593110954692457', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.24.24.195', '2019-05-31 21:58:15', 1, 1002001015, '账号未登陆', '2019-05-31 21:58:15');
INSERT INTO `access_log` VALUES (17401, '65.53.15593110954752429', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.24.24.195', '2019-05-31 21:58:15', 0, 1002001015, '账号未登陆', '2019-05-31 21:58:15');
INSERT INTO `access_log` VALUES (17402, '65.52.15593110976672433', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.24.24.195', '2019-05-31 21:58:18', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:58:18');
INSERT INTO `access_log` VALUES (17403, '65.50.15593111049632457', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.24.24.195', '2019-05-31 21:58:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:58:25');
INSERT INTO `access_log` VALUES (17404, '65.45.15593111202892455', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.24.24.195', '2019-05-31 21:58:40', 5, 1002002000, '账号不存在', '2019-05-31 21:58:40');
INSERT INTO `access_log` VALUES (17405, '65.46.15593111319272443', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.24.24.195', '2019-05-31 21:58:52', 4, 1002002000, '账号不存在', '2019-05-31 21:58:52');
INSERT INTO `access_log` VALUES (17406, '65.49.15593111661812459', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 21:59:26', 1, 1002001015, '账号未登陆', '2019-05-31 21:59:26');
INSERT INTO `access_log` VALUES (17407, '65.52.15593111661812435', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 21:59:26', 1, 1002001015, '账号未登陆', '2019-05-31 21:59:26');
INSERT INTO `access_log` VALUES (17408, '65.47.15593111661862463', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 21:59:26', 0, 1002001015, '账号未登陆', '2019-05-31 21:59:26');
INSERT INTO `access_log` VALUES (17409, '65.50.15593111663832459', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 21:59:26', 0, 1002001015, '账号未登陆', '2019-05-31 21:59:26');
INSERT INTO `access_log` VALUES (17410, '65.54.15593111663882429', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 21:59:26', 0, 1002001015, '账号未登陆', '2019-05-31 21:59:26');
INSERT INTO `access_log` VALUES (17411, '65.45.15593111663952457', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 21:59:26', 1, 1002001015, '账号未登陆', '2019-05-31 21:59:26');
INSERT INTO `access_log` VALUES (17412, '65.46.15593111686232445', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 21:59:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 21:59:29');
INSERT INTO `access_log` VALUES (17413, '65.51.15593111723842443', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 21:59:32', 70, 0, '', '2019-05-31 21:59:32');
INSERT INTO `access_log` VALUES (17414, '65.48.15593111727122457', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 21:59:33', 10, 0, '', '2019-05-31 21:59:33');
INSERT INTO `access_log` VALUES (17415, '65.53.15593111727162433', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 21:59:33', 10, 0, '', '2019-05-31 21:59:33');
INSERT INTO `access_log` VALUES (17416, '65.47.15593111727202465', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 21:59:33', 9, 0, '', '2019-05-31 21:59:33');
INSERT INTO `access_log` VALUES (17417, '65.52.15593111829302437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 21:59:43', 96, 0, '', '2019-05-31 21:59:43');
INSERT INTO `access_log` VALUES (17418, '65.54.15593111832902431', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 21:59:43', 9, 0, '', '2019-05-31 21:59:43');
INSERT INTO `access_log` VALUES (17419, '65.50.15593111832902461', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 21:59:43', 10, 0, '', '2019-05-31 21:59:43');
INSERT INTO `access_log` VALUES (17420, '65.45.15593111832922459', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 21:59:43', 9, 0, '', '2019-05-31 21:59:43');
INSERT INTO `access_log` VALUES (17421, '62.88.15593111884532857', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 21:59:48', 14, 0, '', '2019-05-31 21:59:48');
INSERT INTO `access_log` VALUES (17422, '62.81.15593111920132845', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 21:59:52', 14, 0, '', '2019-05-31 21:59:52');
INSERT INTO `access_log` VALUES (17423, '62.86.15593111955752851', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 21:59:56', 14, 0, '', '2019-05-31 21:59:56');
INSERT INTO `access_log` VALUES (17424, '62.89.15593112015732857', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 22:00:02', 21, 0, '', '2019-05-31 22:00:02');
INSERT INTO `access_log` VALUES (17425, '62.85.15593112025392859', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 22:00:03', 16, 0, '', '2019-05-31 22:00:03');
INSERT INTO `access_log` VALUES (17426, '64.84.15593112061202383', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 22:00:06', 25, 0, '', '2019-05-31 22:00:06');
INSERT INTO `access_log` VALUES (17427, '64.78.15593112061192385', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 22:00:06', 27, 0, '', '2019-05-31 22:00:06');
INSERT INTO `access_log` VALUES (17428, '59.74.15593112148252955', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 22:00:15', 12, 0, '', '2019-05-31 22:00:15');
INSERT INTO `access_log` VALUES (17429, '64.80.15593112198632373', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 22:00:20', 8, 0, '', '2019-05-31 22:00:20');
INSERT INTO `access_log` VALUES (17430, '64.82.15593112198582387', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 22:00:20', 102, 0, '', '2019-05-31 22:00:20');
INSERT INTO `access_log` VALUES (17431, '65.53.15593112224252435', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 22:00:22', 4, 0, '', '2019-05-31 22:00:22');
INSERT INTO `access_log` VALUES (17432, '64.83.15593112241652377', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 22:00:24', 9, 0, '', '2019-05-31 22:00:24');
INSERT INTO `access_log` VALUES (17433, '64.77.15593112241642383', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 22:00:24', 12, 0, '', '2019-05-31 22:00:24');
INSERT INTO `access_log` VALUES (17434, '64.81.15593112241642375', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 22:00:24', 15, 0, '', '2019-05-31 22:00:24');
INSERT INTO `access_log` VALUES (17435, '59.71.15593112274702957', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update', 'id=1&title=百度是最棒的&url=https://user-gold-cdn.xitu.io/2019/3/30/169cdcbb93d48ff1?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1&sort=0&memo=哈哈哈哈&picUrl=http://static.shop.iocoder.cn/4f835595-b519-4dab-b741-b60e3a4f708d', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 22:00:27', 7, 1002002009, NULL, '2019-05-31 22:00:27');
INSERT INTO `access_log` VALUES (17436, '59.79.15593112280292957', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update', 'id=1&title=百度是最棒的&url=https://user-gold-cdn.xitu.io/2019/3/30/169cdcbb93d48ff1?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1&sort=0&memo=哈哈哈哈&picUrl=http://static.shop.iocoder.cn/4f835595-b519-4dab-b741-b60e3a4f708d', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 22:00:28', 7, 1002002009, NULL, '2019-05-31 22:00:28');
INSERT INTO `access_log` VALUES (17437, '59.77.15593112291062953', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update', 'id=1&title=百度是最棒的&url=https://user-gold-cdn.xitu.io/2019/3/30/169cdcbb93d48ff1?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1&sort=0&memo=哈哈哈哈&picUrl=http://static.shop.iocoder.cn/4f835595-b519-4dab-b741-b60e3a4f708d', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 22:00:29', 8, 1002002009, NULL, '2019-05-31 22:00:29');
INSERT INTO `access_log` VALUES (17438, '59.80.15593112293192955', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update', 'id=1&title=百度是最棒的&url=https://user-gold-cdn.xitu.io/2019/3/30/169cdcbb93d48ff1?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1&sort=0&memo=哈哈哈哈&picUrl=http://static.shop.iocoder.cn/4f835595-b519-4dab-b741-b60e3a4f708d', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 22:00:29', 8, 1002002009, NULL, '2019-05-31 22:00:29');
INSERT INTO `access_log` VALUES (17439, '64.79.15593112316832373', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 22:00:32', 12, 0, '', '2019-05-31 22:00:32');
INSERT INTO `access_log` VALUES (17440, '65.47.15593112337332467', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 22:00:34', 19, 0, '', '2019-05-31 22:00:34');
INSERT INTO `access_log` VALUES (17441, '65.49.15593112378232463', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '125.70.204.106', '2019-05-31 22:00:38', 11, 0, '', '2019-05-31 22:00:38');
INSERT INTO `access_log` VALUES (17442, '66.54.15593112453621847', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 22:00:45', 23, 0, '', '2019-05-31 22:00:45');
INSERT INTO `access_log` VALUES (17443, '59.78.15593112470202961', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 22:00:47', 11, 0, '', '2019-05-31 22:00:47');
INSERT INTO `access_log` VALUES (17444, '59.72.15593112488762953', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.0.16', '2019-05-31 22:00:49', 13, 0, '', '2019-05-31 22:00:49');
INSERT INTO `access_log` VALUES (17445, '65.50.15593121650902475', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 22:16:05', 1, 1002001015, '账号未登陆', '2019-05-31 22:16:05');
INSERT INTO `access_log` VALUES (17446, '65.45.15593121650952473', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 22:16:05', 1, 1002001015, '账号未登陆', '2019-05-31 22:16:05');
INSERT INTO `access_log` VALUES (17447, '65.46.15593121651052461', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.113', '2019-05-31 22:16:05', 0, 1002001015, '账号未登陆', '2019-05-31 22:16:05');
INSERT INTO `access_log` VALUES (17448, '65.52.15593125389342457', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:19', 0, 1002001015, '账号未登陆', '2019-05-31 22:22:19');
INSERT INTO `access_log` VALUES (17449, '65.54.15593125389402451', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:19', 0, 1002001015, '账号未登陆', '2019-05-31 22:22:19');
INSERT INTO `access_log` VALUES (17450, '65.50.15593125389442481', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:19', 1, 1002001015, '账号未登陆', '2019-05-31 22:22:19');
INSERT INTO `access_log` VALUES (17451, '65.45.15593125418102479', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 22:22:22');
INSERT INTO `access_log` VALUES (17452, '65.51.15593125457322465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:26', 53, 0, '', '2019-05-31 22:22:26');
INSERT INTO `access_log` VALUES (17453, '65.48.15593125459922479', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:26', 10, 0, '', '2019-05-31 22:22:26');
INSERT INTO `access_log` VALUES (17454, '65.53.15593125459922455', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:26', 11, 0, '', '2019-05-31 22:22:26');
INSERT INTO `access_log` VALUES (17455, '65.47.15593125459962487', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:26', 8, 0, '', '2019-05-31 22:22:26');
INSERT INTO `access_log` VALUES (17456, '62.88.15593125527562877', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:33', 14, 0, '', '2019-05-31 22:22:33');
INSERT INTO `access_log` VALUES (17457, '62.81.15593125572962865', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:37', 11, 0, '', '2019-05-31 22:22:37');
INSERT INTO `access_log` VALUES (17458, '62.86.15593125582592871', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:38', 12, 0, '', '2019-05-31 22:22:38');
INSERT INTO `access_log` VALUES (17459, '62.89.15593125642612877', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:44', 470, 0, '', '2019-05-31 22:22:45');
INSERT INTO `access_log` VALUES (17460, '64.85.15593125717912405', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:52', 14, 0, '', '2019-05-31 22:22:52');
INSERT INTO `access_log` VALUES (17461, '64.84.15593125717942403', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:52', 13, 0, '', '2019-05-31 22:22:52');
INSERT INTO `access_log` VALUES (17462, '64.78.15593125787062405', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:59', 10, 0, '', '2019-05-31 22:22:59');
INSERT INTO `access_log` VALUES (17463, '64.80.15593125787182393', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:22:59', 8, 0, '', '2019-05-31 22:22:59');
INSERT INTO `access_log` VALUES (17464, '64.76.15593125822472397', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:23:02', 543, 0, '', '2019-05-31 22:23:03');
INSERT INTO `access_log` VALUES (17465, '64.82.15593125822442407', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:23:02', 548, 0, '', '2019-05-31 22:23:03');
INSERT INTO `access_log` VALUES (17466, '64.77.15593125822482403', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:23:02', 548, 0, '', '2019-05-31 22:23:03');
INSERT INTO `access_log` VALUES (17467, '64.83.15593125854332397', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:23:05', 7, 1002002009, NULL, '2019-05-31 22:23:05');
INSERT INTO `access_log` VALUES (17468, '66.52.15593125908291867', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:23:11', 16, 0, '', '2019-05-31 22:23:11');
INSERT INTO `access_log` VALUES (17469, '65.54.15593125946372453', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:23:15', 19, 0, '', '2019-05-31 22:23:15');
INSERT INTO `access_log` VALUES (17470, '65.45.15593125958522481', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:23:16', 10, 0, '', '2019-05-31 22:23:16');
INSERT INTO `access_log` VALUES (17471, '65.46.15593125968772469', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:23:17', 9, 0, '', '2019-05-31 22:23:17');
INSERT INTO `access_log` VALUES (17472, '65.51.15593126029912467', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:23:23', 15, 0, '', '2019-05-31 22:23:23');
INSERT INTO `access_log` VALUES (17473, '65.53.15593126143712457', 0, 2, 'admin-application', '/admin-api/admins/data_dict/update', 'id=10&enumValue=order_status&value=1&displayName=等待付款&sort=1&memo=订单状态&createTime=2019-03-24T08:17:55.000+0000&index=10', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:23:34', 10, 1002002007, '没有该操作权限', '2019-05-31 22:23:34');
INSERT INTO `access_log` VALUES (17474, '65.48.15593126147352481', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:23:35', 15, 0, '', '2019-05-31 22:23:35');
INSERT INTO `access_log` VALUES (17475, '59.75.15593126224072975', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:23:42', 4, 0, '', '2019-05-31 22:23:42');
INSERT INTO `access_log` VALUES (17476, '59.71.15593126224082977', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.130.50.204', '2019-05-31 22:23:42', 13, 2001001000, '服务端发生异常', '2019-05-31 22:23:42');
INSERT INTO `access_log` VALUES (17477, '64.78.15593126348502407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.130.50.204', '2019-05-31 22:23:55', 2, 0, '', '2019-05-31 22:23:55');
INSERT INTO `access_log` VALUES (17478, '64.80.15593126349792395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.130.50.204', '2019-05-31 22:23:55', 2, 0, '', '2019-05-31 22:23:55');
INSERT INTO `access_log` VALUES (17479, '64.82.15593126367802409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.130.50.204', '2019-05-31 22:23:57', 3, 0, '', '2019-05-31 22:23:57');
INSERT INTO `access_log` VALUES (17480, '64.76.15593126375342399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.130.50.204', '2019-05-31 22:23:58', 2, 0, '', '2019-05-31 22:23:58');
INSERT INTO `access_log` VALUES (17481, '64.77.15593126383592405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.130.50.204', '2019-05-31 22:23:58', 2, 0, '', '2019-05-31 22:23:58');
INSERT INTO `access_log` VALUES (17482, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.130.50.204', '2019-05-31 22:23:58', 15, 0, '', '2019-05-31 22:23:58');
INSERT INTO `access_log` VALUES (17483, '64.81.15593126398752397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.130.50.204', '2019-05-31 22:24:00', 2, 0, '', '2019-05-31 22:24:00');
INSERT INTO `access_log` VALUES (17484, '64.83.15593126399772399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.130.50.204', '2019-05-31 22:24:00', 2, 0, '', '2019-05-31 22:24:00');
INSERT INTO `access_log` VALUES (17485, '64.79.15593126437402395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.130.50.204', '2019-05-31 22:24:04', 2, 0, '', '2019-05-31 22:24:04');
INSERT INTO `access_log` VALUES (17486, '64.84.15593126438252407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.130.50.204', '2019-05-31 22:24:04', 2, 0, '', '2019-05-31 22:24:04');
INSERT INTO `access_log` VALUES (17487, '66.50.15593126494571871', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.130.50.204', '2019-05-31 22:24:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位', '2019-05-31 22:24:09');
INSERT INTO `access_log` VALUES (17488, '59.74.15593127201572977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:20', 4, 0, '', '2019-05-31 22:25:20');
INSERT INTO `access_log` VALUES (17489, '59.75.15593127201572977', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:20', 13, 2001001000, '服务端发生异常', '2019-05-31 22:25:20');
INSERT INTO `access_log` VALUES (17490, '64.81.15593127233882399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:23', 3, 0, '', '2019-05-31 22:25:23');
INSERT INTO `access_log` VALUES (17491, '64.83.15593127235132401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:24', 2, 0, '', '2019-05-31 22:25:24');
INSERT INTO `access_log` VALUES (17492, '64.79.15593127247842397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:25', 2, 0, '', '2019-05-31 22:25:25');
INSERT INTO `access_log` VALUES (17493, '64.84.15593127253522409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:25', 2, 0, '', '2019-05-31 22:25:25');
INSERT INTO `access_log` VALUES (17494, '59.79.15593127282252979', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:28', 3, 0, '', '2019-05-31 22:25:28');
INSERT INTO `access_log` VALUES (17495, '59.71.15593127282252979', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:28', 12, 2001001000, '服务端发生异常', '2019-05-31 22:25:28');
INSERT INTO `access_log` VALUES (17496, '64.85.15593127302882411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:30', 2, 0, '', '2019-05-31 22:25:30');
INSERT INTO `access_log` VALUES (17497, '64.78.15593127304012411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:30', 2, 0, '', '2019-05-31 22:25:30');
INSERT INTO `access_log` VALUES (17498, '66.53.15593127336681877', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位', '2019-05-31 22:25:34');
INSERT INTO `access_log` VALUES (17499, '64.82.15593127361332413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:36', 2, 0, '', '2019-05-31 22:25:36');
INSERT INTO `access_log` VALUES (17500, '64.76.15593127362332403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:36', 2, 0, '', '2019-05-31 22:25:36');
INSERT INTO `access_log` VALUES (17501, '59.80.15593127372212977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:37', 3, 0, '', '2019-05-31 22:25:37');
INSERT INTO `access_log` VALUES (17502, '59.76.15593127372212977', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:37', 13, 2001001000, '服务端发生异常', '2019-05-31 22:25:37');
INSERT INTO `access_log` VALUES (17503, '59.78.15593127440092983', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:44', 3, 0, '', '2019-05-31 22:25:44');
INSERT INTO `access_log` VALUES (17504, '59.72.15593127440092975', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:44', 13, 2001001000, '服务端发生异常', '2019-05-31 22:25:44');
INSERT INTO `access_log` VALUES (17505, '64.77.15593127449002409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:45', 2, 0, '', '2019-05-31 22:25:45');
INSERT INTO `access_log` VALUES (17506, '64.81.15593127451482401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:45', 2, 0, '', '2019-05-31 22:25:45');
INSERT INTO `access_log` VALUES (17507, '59.73.15593127467992981', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:47', 3, 0, '', '2019-05-31 22:25:47');
INSERT INTO `access_log` VALUES (17508, '59.74.15593127468002979', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.156.119.224', '2019-05-31 22:25:47', 13, 2001001000, '服务端发生异常', '2019-05-31 22:25:47');
INSERT INTO `access_log` VALUES (17509, '59.72.15593134387922985', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '58.101.146.1', '2019-05-31 22:37:19', 13, 2001001000, '服务端发生异常', '2019-05-31 22:37:19');
INSERT INTO `access_log` VALUES (17510, '59.78.15593134387902993', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '58.101.146.1', '2019-05-31 22:37:19', 32, 0, '', '2019-05-31 22:37:19');
INSERT INTO `access_log` VALUES (17511, '65.48.15593134607202493', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.135.102.14', '2019-05-31 22:37:41', 0, 1002001015, '账号未登陆', '2019-05-31 22:37:41');
INSERT INTO `access_log` VALUES (17512, '65.47.15593134607192501', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.135.102.14', '2019-05-31 22:37:41', 0, 1002001015, '账号未登陆', '2019-05-31 22:37:41');
INSERT INTO `access_log` VALUES (17513, '65.53.15593134607192469', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.135.102.14', '2019-05-31 22:37:41', 0, 1002001015, '账号未登陆', '2019-05-31 22:37:41');
INSERT INTO `access_log` VALUES (17514, '65.49.15593134729342497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.135.102.14', '2019-05-31 22:37:53', 1376, 0, '', '2019-05-31 22:37:54');
INSERT INTO `access_log` VALUES (17515, '65.52.15593134759292473', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.135.102.14', '2019-05-31 22:37:56', 10, 0, '', '2019-05-31 22:37:56');
INSERT INTO `access_log` VALUES (17516, '65.54.15593134759522467', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.135.102.14', '2019-05-31 22:37:56', 9, 0, '', '2019-05-31 22:37:56');
INSERT INTO `access_log` VALUES (17517, '65.45.15593134769672495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.135.102.14', '2019-05-31 22:37:57', 10, 0, '', '2019-05-31 22:37:57');
INSERT INTO `access_log` VALUES (17518, '59.76.15593135242452989', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.184.65.40', '2019-05-31 22:38:44', 14, 2001001000, '服务端发生异常', '2019-05-31 22:38:44');
INSERT INTO `access_log` VALUES (17519, '59.80.15593135242442989', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.184.65.40', '2019-05-31 22:38:44', 407, 0, '', '2019-05-31 22:38:45');
INSERT INTO `access_log` VALUES (17520, '64.84.15593135289352421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.184.65.40', '2019-05-31 22:38:49', 3, 0, '', '2019-05-31 22:38:49');
INSERT INTO `access_log` VALUES (17521, '64.85.15593135290682423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '110.184.65.40', '2019-05-31 22:38:49', 2, 0, '', '2019-05-31 22:38:49');
INSERT INTO `access_log` VALUES (17522, '65.53.15593136620892473', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.170.242.159', '2019-05-31 22:41:02', 0, 1002001015, '账号未登陆', '2019-05-31 22:41:02');
INSERT INTO `access_log` VALUES (17523, '65.47.15593136620902505', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.170.242.159', '2019-05-31 22:41:02', 1, 1002001015, '账号未登陆', '2019-05-31 22:41:02');
INSERT INTO `access_log` VALUES (17524, '65.48.15593136620992497', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.170.242.159', '2019-05-31 22:41:02', 1, 1002001015, '账号未登陆', '2019-05-31 22:41:02');
INSERT INTO `access_log` VALUES (17525, '65.49.15593136721742501', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.170.242.159', '2019-05-31 22:41:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 22:41:12');
INSERT INTO `access_log` VALUES (17526, '65.54.15593136808532471', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.170.242.159', '2019-05-31 22:41:21', 76, 0, '', '2019-05-31 22:41:21');
INSERT INTO `access_log` VALUES (17527, '65.52.15593136838752477', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.170.242.159', '2019-05-31 22:41:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 22:41:24');
INSERT INTO `access_log` VALUES (17528, '65.46.15593136897522487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.170.242.159', '2019-05-31 22:41:30', 456, 0, '', '2019-05-31 22:41:30');
INSERT INTO `access_log` VALUES (17529, '65.51.15593136980372485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.170.242.159', '2019-05-31 22:41:38', 81, 0, '', '2019-05-31 22:41:38');
INSERT INTO `access_log` VALUES (17530, '65.46.15593138183012489', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:43:38', 0, 1002001015, '账号未登陆', '2019-05-31 22:43:38');
INSERT INTO `access_log` VALUES (17531, '65.51.15593138183072487', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:43:38', 1, 1002001015, '账号未登陆', '2019-05-31 22:43:38');
INSERT INTO `access_log` VALUES (17532, '65.47.15593138183122509', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:43:38', 0, 1002001015, '账号未登陆', '2019-05-31 22:43:38');
INSERT INTO `access_log` VALUES (17533, '59.73.15593138216752997', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:43:42', 4, 0, '', '2019-05-31 22:43:42');
INSERT INTO `access_log` VALUES (17534, '59.72.15593138216762991', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:43:42', 14, 2001001000, '服务端发生异常', '2019-05-31 22:43:42');
INSERT INTO `access_log` VALUES (17535, '64.80.15593138351942415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:43:55', 3, 0, '', '2019-05-31 22:43:55');
INSERT INTO `access_log` VALUES (17536, '64.82.15593138353332429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:43:55', 2, 0, '', '2019-05-31 22:43:55');
INSERT INTO `access_log` VALUES (17537, '64.76.15593138369392419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:43:57', 2, 0, '', '2019-05-31 22:43:57');
INSERT INTO `access_log` VALUES (17538, '64.77.15593138376302425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:43:58', 2, 0, '', '2019-05-31 22:43:58');
INSERT INTO `access_log` VALUES (17539, '59.74.15593138394282995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:43:59', 3, 0, '', '2019-05-31 22:43:59');
INSERT INTO `access_log` VALUES (17540, '59.75.15593138394302995', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:43:59', 14, 2001001000, '服务端发生异常', '2019-05-31 22:43:59');
INSERT INTO `access_log` VALUES (17541, '65.50.15593138459982505', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:44:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 22:44:06');
INSERT INTO `access_log` VALUES (17542, '65.54.15593138555002475', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:44:16', 109, 0, '', '2019-05-31 22:44:16');
INSERT INTO `access_log` VALUES (17543, '65.45.15593138559252503', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:44:16', 10, 0, '', '2019-05-31 22:44:16');
INSERT INTO `access_log` VALUES (17544, '65.52.15593138559272481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:44:16', 10, 0, '', '2019-05-31 22:44:16');
INSERT INTO `access_log` VALUES (17545, '65.46.15593138559302491', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:44:16', 9, 0, '', '2019-05-31 22:44:16');
INSERT INTO `access_log` VALUES (17546, '62.80.15593138654772897', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:44:25', 14, 0, '', '2019-05-31 22:44:25');
INSERT INTO `access_log` VALUES (17547, '62.87.15593138701042897', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:44:30', 256, 0, '', '2019-05-31 22:44:30');
INSERT INTO `access_log` VALUES (17548, '64.85.15593138789632429', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:44:39', 10, 0, '', '2019-05-31 22:44:39');
INSERT INTO `access_log` VALUES (17549, '64.84.15593138789622427', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.154.107', '2019-05-31 22:44:39', 11, 0, '', '2019-05-31 22:44:39');
INSERT INTO `access_log` VALUES (17550, '65.47.15593139957582513', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '35.181.27.12', '2019-05-31 22:46:36', 0, 1002001015, '账号未登陆', '2019-05-31 22:46:36');
INSERT INTO `access_log` VALUES (17551, '65.46.15593139957562493', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '35.181.27.12', '2019-05-31 22:46:36', 0, 1002001015, '账号未登陆', '2019-05-31 22:46:36');
INSERT INTO `access_log` VALUES (17552, '65.51.15593139957562491', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '35.181.27.12', '2019-05-31 22:46:36', 0, 1002001015, '账号未登陆', '2019-05-31 22:46:36');
INSERT INTO `access_log` VALUES (17553, '65.50.15593141747132511', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:49:35', 0, 1002001015, '账号未登陆', '2019-05-31 22:49:35');
INSERT INTO `access_log` VALUES (17554, '65.49.15593141747212511', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:49:35', 0, 1002001015, '账号未登陆', '2019-05-31 22:49:35');
INSERT INTO `access_log` VALUES (17555, '65.54.15593141747312481', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:49:35', 0, 1002001015, '账号未登陆', '2019-05-31 22:49:35');
INSERT INTO `access_log` VALUES (17556, '65.52.15593141789152487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:49:39', 76, 0, '', '2019-05-31 22:49:39');
INSERT INTO `access_log` VALUES (17557, '65.51.15593141793222495', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:49:39', 91, 0, '', '2019-05-31 22:49:39');
INSERT INTO `access_log` VALUES (17558, '65.46.15593141793452497', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:49:39', 71, 0, '', '2019-05-31 22:49:39');
INSERT INTO `access_log` VALUES (17559, '65.47.15593141793312517', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:49:39', 86, 0, '', '2019-05-31 22:49:39');
INSERT INTO `access_log` VALUES (17560, '62.88.15593141846882901', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:49:45', 14, 0, '', '2019-05-31 22:49:45');
INSERT INTO `access_log` VALUES (17561, '64.78.15593141884732433', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:49:48', 226, 0, '', '2019-05-31 22:49:49');
INSERT INTO `access_log` VALUES (17562, '64.80.15593141884812421', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:49:48', 216, 0, '', '2019-05-31 22:49:49');
INSERT INTO `access_log` VALUES (17563, '64.77.15593141916592431', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:49:52', 506, 0, '', '2019-05-31 22:49:52');
INSERT INTO `access_log` VALUES (17564, '64.76.15593141916552425', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:49:52', 511, 0, '', '2019-05-31 22:49:52');
INSERT INTO `access_log` VALUES (17565, '59.80.15593141971902999', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:49:57', 14, 0, '', '2019-05-31 22:49:57');
INSERT INTO `access_log` VALUES (17566, '64.81.15593142003842423', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:50:00', 10, 0, '', '2019-05-31 22:50:00');
INSERT INTO `access_log` VALUES (17567, '64.79.15593142114242421', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:50:11', 963, 0, '', '2019-05-31 22:50:12');
INSERT INTO `access_log` VALUES (17568, '65.53.15593143365632487', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:52:17', 1, 1002001015, '账号未登陆', '2019-05-31 22:52:17');
INSERT INTO `access_log` VALUES (17569, '65.48.15593143365622511', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:52:17', 1, 1002001015, '账号未登陆', '2019-05-31 22:52:17');
INSERT INTO `access_log` VALUES (17570, '65.54.15593143365722485', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:52:17', 0, 1002001015, '账号未登陆', '2019-05-31 22:52:17');
INSERT INTO `access_log` VALUES (17571, '65.45.15593143677392513', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:52:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 22:52:48');
INSERT INTO `access_log` VALUES (17572, '65.52.15593143722632491', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:52:52', 93, 0, '', '2019-05-31 22:52:52');
INSERT INTO `access_log` VALUES (17573, '65.47.15593143726442521', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:52:53', 9, 0, '', '2019-05-31 22:52:53');
INSERT INTO `access_log` VALUES (17574, '65.46.15593143726522501', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:52:53', 8, 0, '', '2019-05-31 22:52:53');
INSERT INTO `access_log` VALUES (17575, '65.51.15593143726552499', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:52:53', 8, 0, '', '2019-05-31 22:52:53');
INSERT INTO `access_log` VALUES (17576, '62.80.15593144036162905', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:53:24', 15, 0, '', '2019-05-31 22:53:24');
INSERT INTO `access_log` VALUES (17577, '62.83.15593144203762905', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:53:40', 16, 0, '', '2019-05-31 22:53:40');
INSERT INTO `access_log` VALUES (17578, '64.77.15593144283782435', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:53:48', 9, 0, '', '2019-05-31 22:53:48');
INSERT INTO `access_log` VALUES (17579, '64.82.15593144283742439', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:53:48', 13, 0, '', '2019-05-31 22:53:48');
INSERT INTO `access_log` VALUES (17580, '64.83.15593144399392429', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:54:00', 10, 0, '', '2019-05-31 22:54:00');
INSERT INTO `access_log` VALUES (17581, '64.81.15593144399392427', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:54:00', 11, 0, '', '2019-05-31 22:54:00');
INSERT INTO `access_log` VALUES (17582, '65.52.15593144492292493', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:54:09', 0, 1002001015, '账号未登陆', '2019-05-31 22:54:09');
INSERT INTO `access_log` VALUES (17583, '65.46.15593144492352503', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:54:09', 0, 1002001015, '账号未登陆', '2019-05-31 22:54:09');
INSERT INTO `access_log` VALUES (17584, '65.47.15593144492442523', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:54:09', 0, 1002001015, '账号未登陆', '2019-05-31 22:54:09');
INSERT INTO `access_log` VALUES (17585, '64.84.15593144514302437', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:54:11', 10, 0, '', '2019-05-31 22:54:11');
INSERT INTO `access_log` VALUES (17586, '66.51.15593144561911893', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:54:16', 24, 0, '', '2019-05-31 22:54:16');
INSERT INTO `access_log` VALUES (17587, '65.51.15593144565862501', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:54:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 22:54:17');
INSERT INTO `access_log` VALUES (17588, '64.85.15593144604192439', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:54:20', 9, 0, '', '2019-05-31 22:54:20');
INSERT INTO `access_log` VALUES (17589, '59.76.15593144613643003', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:54:21', 10, 0, '', '2019-05-31 22:54:21');
INSERT INTO `access_log` VALUES (17590, '65.53.15593144637572491', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:54:24', 20, 0, '', '2019-05-31 22:54:24');
INSERT INTO `access_log` VALUES (17591, '65.48.15593144651272515', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:54:25', 58, 0, '', '2019-05-31 22:54:25');
INSERT INTO `access_log` VALUES (17592, '65.50.15593144655032519', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:54:26', 10, 0, '', '2019-05-31 22:54:26');
INSERT INTO `access_log` VALUES (17593, '65.49.15593144655062519', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:54:26', 10, 0, '', '2019-05-31 22:54:26');
INSERT INTO `access_log` VALUES (17594, '65.45.15593144655142517', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:54:26', 9, 0, '', '2019-05-31 22:54:26');
INSERT INTO `access_log` VALUES (17595, '65.46.15593144674612505', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:54:27', 20, 0, '', '2019-05-31 22:54:27');
INSERT INTO `access_log` VALUES (17596, '65.47.15593144691052525', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:54:29', 9, 0, '', '2019-05-31 22:54:29');
INSERT INTO `access_log` VALUES (17597, '59.80.15593144697193003', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.2.31', '2019-05-31 22:54:30', 13, 0, '', '2019-05-31 22:54:30');
INSERT INTO `access_log` VALUES (17598, '65.52.15593144715852495', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:54:32', 10, 0, '', '2019-05-31 22:54:32');
INSERT INTO `access_log` VALUES (17599, '65.51.15593144759452503', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '125.70.58.107', '2019-05-31 22:54:36', 13, 0, '', '2019-05-31 22:54:36');
INSERT INTO `access_log` VALUES (17600, '62.85.15593144857642905', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:54:46', 13, 0, '', '2019-05-31 22:54:46');
INSERT INTO `access_log` VALUES (17601, '64.77.15593144984982437', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:54:58', 11, 0, '', '2019-05-31 22:54:59');
INSERT INTO `access_log` VALUES (17602, '64.76.15593144985042431', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:54:59', 8, 0, '', '2019-05-31 22:54:59');
INSERT INTO `access_log` VALUES (17603, '64.82.15593145844262443', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:56:24', 10, 0, '', '2019-05-31 22:56:24');
INSERT INTO `access_log` VALUES (17604, '64.78.15593145844232441', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:56:24', 13, 0, '', '2019-05-31 22:56:24');
INSERT INTO `access_log` VALUES (17605, '64.77.15593145889042439', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:56:29', 10, 0, '', '2019-05-31 22:56:29');
INSERT INTO `access_log` VALUES (17606, '64.76.15593145889042433', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:56:29', 11, 0, '', '2019-05-31 22:56:29');
INSERT INTO `access_log` VALUES (17607, '64.83.15593145927032433', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:56:33', 10, 0, '', '2019-05-31 22:56:33');
INSERT INTO `access_log` VALUES (17608, '66.54.15593146162461893', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:56:56', 15, 0, '', '2019-05-31 22:56:56');
INSERT INTO `access_log` VALUES (17609, '65.53.15593146201652495', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:57:00', 20, 0, '', '2019-05-31 22:57:00');
INSERT INTO `access_log` VALUES (17610, '64.84.15593146237532441', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:57:04', 11, 0, '', '2019-05-31 22:57:04');
INSERT INTO `access_log` VALUES (17611, '64.80.15593146237532431', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:57:04', 13, 0, '', '2019-05-31 22:57:04');
INSERT INTO `access_log` VALUES (17612, '64.82.15593146272862445', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:57:07', 28, 0, '', '2019-05-31 22:57:07');
INSERT INTO `access_log` VALUES (17613, '64.78.15593146272832443', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:57:07', 33, 0, '', '2019-05-31 22:57:07');
INSERT INTO `access_log` VALUES (17614, '64.76.15593146335742435', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:57:14', 12, 0, '', '2019-05-31 22:57:14');
INSERT INTO `access_log` VALUES (17615, '64.77.15593146335772441', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:57:14', 12, 0, '', '2019-05-31 22:57:14');
INSERT INTO `access_log` VALUES (17616, '65.48.15593146343452519', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:57:14', 20, 0, '', '2019-05-31 22:57:14');
INSERT INTO `access_log` VALUES (17617, '66.53.15593146345991903', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '219.140.32.19', '2019-05-31 22:57:15', 15, 0, '', '2019-05-31 22:57:15');
INSERT INTO `access_log` VALUES (17618, '65.52.15593148608022501', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.246.218.85', '2019-05-31 23:01:01', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 23:01:01');
INSERT INTO `access_log` VALUES (17619, '65.53.15593148708242499', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '103.246.218.85', '2019-05-31 23:01:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 23:01:11');
INSERT INTO `access_log` VALUES (17620, '59.80.15593155021773017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:11:42', 3, 0, '', '2019-05-31 23:11:42');
INSERT INTO `access_log` VALUES (17621, '59.73.15593155021773021', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:11:42', 11, 2001001000, '服务端发生异常', '2019-05-31 23:11:42');
INSERT INTO `access_log` VALUES (17622, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=旅途&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:11:53', 16, 0, '', '2019-05-31 23:11:53');
INSERT INTO `access_log` VALUES (17623, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=旅途', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:11:53', 7, 0, '', '2019-05-31 23:11:53');
INSERT INTO `access_log` VALUES (17624, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:11:57', 9, 0, '', '2019-05-31 23:11:57');
INSERT INTO `access_log` VALUES (17625, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:11:57', 14, 0, '', '2019-05-31 23:11:57');
INSERT INTO `access_log` VALUES (17626, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:11:58', 8, 0, '', '2019-05-31 23:11:58');
INSERT INTO `access_log` VALUES (17627, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:11:59', 16, 0, '', '2019-05-31 23:11:59');
INSERT INTO `access_log` VALUES (17628, '64.76.15593155248802447', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:12:05', 8, 0, '', '2019-05-31 23:12:05');
INSERT INTO `access_log` VALUES (17629, '64.84.15593155814762455', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:01', 6, 0, '', '2019-05-31 23:13:01');
INSERT INTO `access_log` VALUES (17630, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:03', 8, 0, '', '2019-05-31 23:13:03');
INSERT INTO `access_log` VALUES (17631, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:03', 38, 0, '', '2019-05-31 23:13:03');
INSERT INTO `access_log` VALUES (17632, '59.79.15593155838073021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:04', 5, 0, '', '2019-05-31 23:13:04');
INSERT INTO `access_log` VALUES (17633, '59.77.15593155838143017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:04', 13, 2001001000, '服务端发生异常', '2019-05-31 23:13:04');
INSERT INTO `access_log` VALUES (17634, '64.78.15593155869822457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:07', 2, 0, '', '2019-05-31 23:13:07');
INSERT INTO `access_log` VALUES (17635, '64.82.15593155870872459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:07', 2, 0, '', '2019-05-31 23:13:07');
INSERT INTO `access_log` VALUES (17636, '64.77.15593155903462455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:10', 2, 0, '', '2019-05-31 23:13:10');
INSERT INTO `access_log` VALUES (17637, '64.76.15593155921412449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:12', 7, 0, '', '2019-05-31 23:13:12');
INSERT INTO `access_log` VALUES (17638, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:15', 7, 0, '', '2019-05-31 23:13:15');
INSERT INTO `access_log` VALUES (17639, '64.83.15593155954152449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:15', 109, 0, '', '2019-05-31 23:13:16');
INSERT INTO `access_log` VALUES (17640, '64.81.15593155985262447', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:19', 8, 0, '', '2019-05-31 23:13:19');
INSERT INTO `access_log` VALUES (17641, '64.80.15593156049582447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:25', 2, 0, '', '2019-05-31 23:13:25');
INSERT INTO `access_log` VALUES (17642, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:25', 7, 0, '', '2019-05-31 23:13:25');
INSERT INTO `access_log` VALUES (17643, '64.84.15593156058452457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:26', 3, 0, '', '2019-05-31 23:13:26');
INSERT INTO `access_log` VALUES (17644, '64.85.15593156059952459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:26', 2, 0, '', '2019-05-31 23:13:26');
INSERT INTO `access_log` VALUES (17645, '59.78.15593156200913025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:40', 4, 0, '', '2019-05-31 23:13:40');
INSERT INTO `access_log` VALUES (17646, '59.72.15593156200913017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:40', 14, 2001001000, '服务端发生异常', '2019-05-31 23:13:40');
INSERT INTO `access_log` VALUES (17647, '64.82.15593156214282461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:41', 3, 0, '', '2019-05-31 23:13:41');
INSERT INTO `access_log` VALUES (17648, '64.77.15593156215432457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:42', 3, 0, '', '2019-05-31 23:13:42');
INSERT INTO `access_log` VALUES (17649, '59.75.15593156219653021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:42', 3, 0, '', '2019-05-31 23:13:42');
INSERT INTO `access_log` VALUES (17650, '59.74.15593156219673021', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:13:42', 20, 2001001000, '服务端发生异常', '2019-05-31 23:13:42');
INSERT INTO `access_log` VALUES (17651, '59.80.15593156882633021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.137', '2019-05-31 23:14:48', 3, 0, '', '2019-05-31 23:14:48');
INSERT INTO `access_log` VALUES (17652, '59.73.15593156882683025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.137', '2019-05-31 23:14:48', 13, 2001001000, '服务端发生异常', '2019-05-31 23:14:48');
INSERT INTO `access_log` VALUES (17653, '64.84.15593156944712459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.137', '2019-05-31 23:14:54', 2, 0, '', '2019-05-31 23:14:54');
INSERT INTO `access_log` VALUES (17654, '64.85.15593156946042461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.137', '2019-05-31 23:14:55', 2, 0, '', '2019-05-31 23:14:55');
INSERT INTO `access_log` VALUES (17655, '59.74.15593156980893023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:14:58', 15, 2001001000, '服务端发生异常', '2019-05-31 23:14:58');
INSERT INTO `access_log` VALUES (17656, '64.78.15593156971542461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.137', '2019-05-31 23:14:57', 1009, 0, '', '2019-05-31 23:14:58');
INSERT INTO `access_log` VALUES (17657, '59.72.15593156980873019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:14:58', 77, 0, '', '2019-05-31 23:14:58');
INSERT INTO `access_log` VALUES (17658, '64.82.15593156983622463', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.137', '2019-05-31 23:14:58', 3, 0, '', '2019-05-31 23:14:58');
INSERT INTO `access_log` VALUES (17659, '64.77.15593156985792459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.137', '2019-05-31 23:14:59', 2, 0, '', '2019-05-31 23:14:59');
INSERT INTO `access_log` VALUES (17660, '64.83.15593157120052453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.137', '2019-05-31 23:15:12', 2, 0, '', '2019-05-31 23:15:12');
INSERT INTO `access_log` VALUES (17661, '64.81.15593157123892451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.137', '2019-05-31 23:15:12', 2, 0, '', '2019-05-31 23:15:12');
INSERT INTO `access_log` VALUES (17662, '64.79.15593157126472449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.236.56.224', '2019-05-31 23:15:13', 2, 0, '', '2019-05-31 23:15:13');
INSERT INTO `access_log` VALUES (17663, '64.80.15593157127852451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.236.56.224', '2019-05-31 23:15:13', 2, 0, '', '2019-05-31 23:15:13');
INSERT INTO `access_log` VALUES (17664, '59.71.15593157129693025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.137', '2019-05-31 23:15:13', 3, 0, '', '2019-05-31 23:15:13');
INSERT INTO `access_log` VALUES (17665, '59.79.15593157129753025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.137', '2019-05-31 23:15:13', 13, 2001001000, '服务端发生异常', '2019-05-31 23:15:13');
INSERT INTO `access_log` VALUES (17666, '64.84.15593157147012461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.236.56.224', '2019-05-31 23:15:15', 2, 0, '', '2019-05-31 23:15:15');
INSERT INTO `access_log` VALUES (17667, '64.85.15593157163052463', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.236.56.224', '2019-05-31 23:15:16', 3, 0, '', '2019-05-31 23:15:16');
INSERT INTO `access_log` VALUES (17668, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.236.56.224', '2019-05-31 23:15:16', 8, 0, '', '2019-05-31 23:15:16');
INSERT INTO `access_log` VALUES (17669, '64.78.15593157188612463', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.236.56.224', '2019-05-31 23:15:19', 215, 0, '', '2019-05-31 23:15:19');
INSERT INTO `access_log` VALUES (17670, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.236.56.224', '2019-05-31 23:15:25', 8, 0, '', '2019-05-31 23:15:25');
INSERT INTO `access_log` VALUES (17671, '64.77.15593157252622461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.236.56.224', '2019-05-31 23:15:25', 54, 0, '', '2019-05-31 23:15:25');
INSERT INTO `access_log` VALUES (17672, '64.76.15593157263702455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.236.56.224', '2019-05-31 23:15:26', 2, 0, '', '2019-05-31 23:15:26');
INSERT INTO `access_log` VALUES (17673, '64.83.15593157265192455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.236.56.224', '2019-05-31 23:15:27', 2, 0, '', '2019-05-31 23:15:27');
INSERT INTO `access_log` VALUES (17674, '59.73.15593157308113027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.236.56.224', '2019-05-31 23:15:31', 3, 0, '', '2019-05-31 23:15:31');
INSERT INTO `access_log` VALUES (17675, '59.76.15593157308113023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.236.56.224', '2019-05-31 23:15:31', 13, 2001001000, '服务端发生异常', '2019-05-31 23:15:31');
INSERT INTO `access_log` VALUES (17676, '65.46.15593157318632525', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:15:32', 0, 1002001015, '账号未登陆', '2019-05-31 23:15:32');
INSERT INTO `access_log` VALUES (17677, '65.47.15593157318642545', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:15:32', 1, 1002001015, '账号未登陆', '2019-05-31 23:15:32');
INSERT INTO `access_log` VALUES (17678, '65.52.15593157318642513', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:15:32', 1, 1002001015, '账号未登陆', '2019-05-31 23:15:32');
INSERT INTO `access_log` VALUES (17679, '65.51.15593157360432523', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:15:36', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 23:15:36');
INSERT INTO `access_log` VALUES (17680, '65.54.15593157443162509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicairff&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:15:44', 73, 0, '', '2019-05-31 23:15:44');
INSERT INTO `access_log` VALUES (17681, '65.48.15593157446282537', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:15:45', 12, 0, '', '2019-05-31 23:15:45');
INSERT INTO `access_log` VALUES (17682, '65.50.15593157446332537', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:15:45', 11, 0, '', '2019-05-31 23:15:45');
INSERT INTO `access_log` VALUES (17683, '65.49.15593157446402541', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; OPPO R11 Build/OPM1.171019.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/68.0.3440.85 Mobile Safari/537.36', '58.35.56.182', '2019-05-31 23:15:45', 9, 0, '', '2019-05-31 23:15:45');
INSERT INTO `access_log` VALUES (17684, '65.47.15593157599852547', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:00', 1, 1002001015, '账号未登陆', '2019-05-31 23:16:00');
INSERT INTO `access_log` VALUES (17685, '65.46.15593157599882527', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:00', 0, 1002001015, '账号未登陆', '2019-05-31 23:16:00');
INSERT INTO `access_log` VALUES (17686, '65.52.15593157599942515', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:00', 1, 1002001015, '账号未登陆', '2019-05-31 23:16:00');
INSERT INTO `access_log` VALUES (17687, '65.51.15593157674572525', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:07', 92, 0, '', '2019-05-31 23:16:08');
INSERT INTO `access_log` VALUES (17688, '65.53.15593157677932513', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:08', 9, 0, '', '2019-05-31 23:16:08');
INSERT INTO `access_log` VALUES (17689, '65.54.15593157677962511', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:08', 10, 0, '', '2019-05-31 23:16:08');
INSERT INTO `access_log` VALUES (17690, '65.49.15593157677982543', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:08', 8, 0, '', '2019-05-31 23:16:08');
INSERT INTO `access_log` VALUES (17691, '65.48.15593157802492539', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:20', 10, 0, '', '2019-05-31 23:16:20');
INSERT INTO `access_log` VALUES (17692, '65.45.15593157802532541', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:20', 9, 0, '', '2019-05-31 23:16:20');
INSERT INTO `access_log` VALUES (17693, '65.52.15593157802542517', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:20', 9, 0, '', '2019-05-31 23:16:20');
INSERT INTO `access_log` VALUES (17694, '62.85.15593157875952935', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:28', 14, 0, '', '2019-05-31 23:16:28');
INSERT INTO `access_log` VALUES (17695, '64.78.15593157937052465', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:34', 10, 0, '', '2019-05-31 23:16:34');
INSERT INTO `access_log` VALUES (17696, '64.85.15593157937022465', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:34', 13, 0, '', '2019-05-31 23:16:34');
INSERT INTO `access_log` VALUES (17697, '66.52.15593158077401911', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:48', 14, 0, '', '2019-05-31 23:16:48');
INSERT INTO `access_log` VALUES (17698, '59.79.15593158094963027', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:49', 13, 0, '', '2019-05-31 23:16:50');
INSERT INTO `access_log` VALUES (17699, '65.54.15593158186012513', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:16:59', 19, 0, '', '2019-05-31 23:16:59');
INSERT INTO `access_log` VALUES (17700, '65.53.15593158209282515', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:17:01', 14, 0, '', '2019-05-31 23:17:01');
INSERT INTO `access_log` VALUES (17701, '65.49.15593158240682545', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:17:04', 10, 0, '', '2019-05-31 23:17:04');
INSERT INTO `access_log` VALUES (17702, '65.50.15593158274702541', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.236.56.224', '2019-05-31 23:17:07', 12, 0, '', '2019-05-31 23:17:07');
INSERT INTO `access_log` VALUES (17703, '59.75.15593159283433027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '221.232.57.42', '2019-05-31 23:18:48', 4, 0, '', '2019-05-31 23:18:48');
INSERT INTO `access_log` VALUES (17704, '59.71.15593159283503029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '221.232.57.42', '2019-05-31 23:18:48', 12, 2001001000, '服务端发生异常', '2019-05-31 23:18:48');
INSERT INTO `access_log` VALUES (17705, '64.82.15593159315682469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '221.232.57.42', '2019-05-31 23:18:52', 2, 0, '', '2019-05-31 23:18:52');
INSERT INTO `access_log` VALUES (17706, '64.77.15593159316782465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '221.232.57.42', '2019-05-31 23:18:52', 2, 0, '', '2019-05-31 23:18:52');
INSERT INTO `access_log` VALUES (17707, '64.76.15593159330512459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '221.232.57.42', '2019-05-31 23:18:53', 2, 0, '', '2019-05-31 23:18:53');
INSERT INTO `access_log` VALUES (17708, '64.83.15593159336032459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '221.232.57.42', '2019-05-31 23:18:54', 2, 0, '', '2019-05-31 23:18:54');
INSERT INTO `access_log` VALUES (17709, '59.77.15593159345893025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '221.232.57.42', '2019-05-31 23:18:55', 3, 0, '', '2019-05-31 23:18:55');
INSERT INTO `access_log` VALUES (17710, '59.73.15593159345893031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '221.232.57.42', '2019-05-31 23:18:55', 14, 2001001000, '服务端发生异常', '2019-05-31 23:18:55');
INSERT INTO `access_log` VALUES (17711, '59.72.15593159882303025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.129.6.174', '2019-05-31 23:19:48', 13, 2001001000, '服务端发生异常', '2019-05-31 23:19:48');
INSERT INTO `access_log` VALUES (17712, '59.74.15593159882303029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.129.6.251', '2019-05-31 23:19:48', 624, 0, '', '2019-05-31 23:19:49');
INSERT INTO `access_log` VALUES (17713, '64.78.15593159911752469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.227', '2019-05-31 23:19:51', 2, 0, '', '2019-05-31 23:19:51');
INSERT INTO `access_log` VALUES (17714, '64.85.15593159931482469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.151.178.197', '2019-05-31 23:19:53', 2, 0, '', '2019-05-31 23:19:53');
INSERT INTO `access_log` VALUES (17715, '59.79.15593164651563037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.88.81.188', '2019-05-31 23:27:45', 4, 0, '', '2019-05-31 23:27:45');
INSERT INTO `access_log` VALUES (17716, '59.77.15593164651693033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.88.81.188', '2019-05-31 23:27:45', 20, 2001001000, '服务端发生异常', '2019-05-31 23:27:45');
INSERT INTO `access_log` VALUES (17717, '64.76.15593164797952467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.88.81.188', '2019-05-31 23:28:00', 3, 0, '', '2019-05-31 23:28:00');
INSERT INTO `access_log` VALUES (17718, '64.83.15593164799552467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.88.81.188', '2019-05-31 23:28:00', 2, 0, '', '2019-05-31 23:28:00');
INSERT INTO `access_log` VALUES (17719, '64.81.15593164813992465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.88.81.188', '2019-05-31 23:28:01', 2, 0, '', '2019-05-31 23:28:01');
INSERT INTO `access_log` VALUES (17720, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.88.81.188', '2019-05-31 23:28:01', 28, 0, '', '2019-05-31 23:28:01');
INSERT INTO `access_log` VALUES (17721, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.88.81.188', '2019-05-31 23:28:03', 7, 0, '', '2019-05-31 23:28:03');
INSERT INTO `access_log` VALUES (17722, '64.79.15593164842872463', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.88.81.188', '2019-05-31 23:28:04', 8, 0, '', '2019-05-31 23:28:04');
INSERT INTO `access_log` VALUES (17723, '65.49.15593166686982557', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.226.192', '2019-05-31 23:31:09', 5, 1002001012, '访问令牌已过期', '2019-05-31 23:31:09');
INSERT INTO `access_log` VALUES (17724, '65.53.15593166686982527', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.226.192', '2019-05-31 23:31:09', 5, 1002001012, '访问令牌已过期', '2019-05-31 23:31:09');
INSERT INTO `access_log` VALUES (17725, '65.54.15593166686982525', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.226.192', '2019-05-31 23:31:09', 5, 1002001012, '访问令牌已过期', '2019-05-31 23:31:09');
INSERT INTO `access_log` VALUES (17726, '65.52.15593166888632531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.226.192', '2019-05-31 23:31:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 23:31:29');
INSERT INTO `access_log` VALUES (17727, '65.48.15593166926132553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.226.192', '2019-05-31 23:31:33', 77, 0, '', '2019-05-31 23:31:33');
INSERT INTO `access_log` VALUES (17728, '65.46.15593166929522543', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.226.192', '2019-05-31 23:31:33', 126, 0, '', '2019-05-31 23:31:33');
INSERT INTO `access_log` VALUES (17729, '65.51.15593166929822541', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.226.192', '2019-05-31 23:31:33', 96, 0, '', '2019-05-31 23:31:33');
INSERT INTO `access_log` VALUES (17730, '65.47.15593166929822563', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.226.192', '2019-05-31 23:31:33', 96, 0, '', '2019-05-31 23:31:33');
INSERT INTO `access_log` VALUES (17731, '64.76.15593166971732471', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.226.192', '2019-05-31 23:31:37', 10, 0, '', '2019-05-31 23:31:37');
INSERT INTO `access_log` VALUES (17732, '64.77.15593166971732477', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.226.192', '2019-05-31 23:31:37', 11, 0, '', '2019-05-31 23:31:37');
INSERT INTO `access_log` VALUES (17733, '59.75.15593166997493039', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.226.192', '2019-05-31 23:31:40', 20, 2001001000, '服务端发生异常', '2019-05-31 23:31:40');
INSERT INTO `access_log` VALUES (17734, '65.53.15593167014442529', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.226.192', '2019-05-31 23:31:41', 170, 0, '', '2019-05-31 23:31:42');
INSERT INTO `access_log` VALUES (17735, '65.45.15593167420682557', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:32:22', 1, 1002001015, '账号未登陆', '2019-05-31 23:32:22');
INSERT INTO `access_log` VALUES (17736, '65.52.15593167421362533', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:32:22', 0, 1002001015, '账号未登陆', '2019-05-31 23:32:22');
INSERT INTO `access_log` VALUES (17737, '65.48.15593167421362555', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:32:22', 1, 1002001015, '账号未登陆', '2019-05-31 23:32:22');
INSERT INTO `access_log` VALUES (17738, '65.46.15593167454162545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:32:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 23:32:25');
INSERT INTO `access_log` VALUES (17739, '65.47.15593167560762565', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:32:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 23:32:36');
INSERT INTO `access_log` VALUES (17740, '65.54.15593167814202529', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:33:01', 123, 0, '', '2019-05-31 23:33:02');
INSERT INTO `access_log` VALUES (17741, '65.50.15593167820772557', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:33:02', 9, 0, '', '2019-05-31 23:33:02');
INSERT INTO `access_log` VALUES (17742, '65.45.15593167820772559', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:33:02', 8, 0, '', '2019-05-31 23:33:02');
INSERT INTO `access_log` VALUES (17743, '65.52.15593167821282535', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:33:02', 9, 0, '', '2019-05-31 23:33:02');
INSERT INTO `access_log` VALUES (17744, '65.46.15593168037812547', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:33:24', 9, 0, '', '2019-05-31 23:33:24');
INSERT INTO `access_log` VALUES (17745, '65.51.15593168037812545', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:33:24', 10, 0, '', '2019-05-31 23:33:24');
INSERT INTO `access_log` VALUES (17746, '65.47.15593168037952567', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:33:24', 8, 0, '', '2019-05-31 23:33:24');
INSERT INTO `access_log` VALUES (17747, '65.53.15593168040292533', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:33:24', 14, 0, '', '2019-05-31 23:33:24');
INSERT INTO `access_log` VALUES (17748, '65.52.15593168489452537', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:34:09', 13, 0, '', '2019-05-31 23:34:09');
INSERT INTO `access_log` VALUES (17749, '65.46.15593168489502549', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:34:09', 9, 0, '', '2019-05-31 23:34:09');
INSERT INTO `access_log` VALUES (17750, '65.48.15593168489452559', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:34:09', 13, 0, '', '2019-05-31 23:34:09');
INSERT INTO `access_log` VALUES (17751, '65.51.15593168565962547', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:34:17', 9, 0, '', '2019-05-31 23:34:17');
INSERT INTO `access_log` VALUES (17752, '65.47.15593168566032569', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:34:17', 8, 0, '', '2019-05-31 23:34:17');
INSERT INTO `access_log` VALUES (17753, '65.49.15593168566192565', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:34:17', 8, 0, '', '2019-05-31 23:34:17');
INSERT INTO `access_log` VALUES (17754, '65.53.15593168568202535', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:34:17', 9, 0, '', '2019-05-31 23:34:17');
INSERT INTO `access_log` VALUES (17755, '65.45.15593168642852563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:34:24', 9, 0, '', '2019-05-31 23:34:24');
INSERT INTO `access_log` VALUES (17756, '65.52.15593168642862539', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:34:24', 9, 0, '', '2019-05-31 23:34:24');
INSERT INTO `access_log` VALUES (17757, '65.50.15593168642852561', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '183.37.155.152', '2019-05-31 23:34:24', 9, 0, '', '2019-05-31 23:34:24');
INSERT INTO `access_log` VALUES (17758, '59.76.15593175126273049', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3610.2 Safari/537.36', '223.87.204.57', '2019-05-31 23:45:13', 4, 0, '', '2019-05-31 23:45:13');
INSERT INTO `access_log` VALUES (17759, '59.80.15593175126413049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3610.2 Safari/537.36', '223.87.204.57', '2019-05-31 23:45:13', 14, 2001001000, '服务端发生异常', '2019-05-31 23:45:13');
INSERT INTO `access_log` VALUES (17760, '64.78.15593175208922491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3610.2 Safari/537.36', '223.87.204.57', '2019-05-31 23:45:21', 3, 0, '', '2019-05-31 23:45:21');
INSERT INTO `access_log` VALUES (17761, '64.85.15593175210452491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3610.2 Safari/537.36', '223.87.204.57', '2019-05-31 23:45:21', 2, 0, '', '2019-05-31 23:45:21');
INSERT INTO `access_log` VALUES (17762, '64.82.15593175232132493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3610.2 Safari/537.36', '223.87.204.57', '2019-05-31 23:45:23', 3, 0, '', '2019-05-31 23:45:23');
INSERT INTO `access_log` VALUES (17763, '64.76.15593175237522483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3610.2 Safari/537.36', '223.87.204.57', '2019-05-31 23:45:24', 2, 0, '', '2019-05-31 23:45:24');
INSERT INTO `access_log` VALUES (17764, '65.51.15593176393442559', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.29.158', '2019-05-31 23:47:19', 0, 1002001015, '账号未登陆', '2019-05-31 23:47:19');
INSERT INTO `access_log` VALUES (17765, '65.48.15593176393432571', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.29.158', '2019-05-31 23:47:19', 0, 1002001015, '账号未登陆', '2019-05-31 23:47:19');
INSERT INTO `access_log` VALUES (17766, '65.47.15593176393562581', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.29.158', '2019-05-31 23:47:19', 1, 1002001015, '账号未登陆', '2019-05-31 23:47:19');
INSERT INTO `access_log` VALUES (17767, '65.49.15593176408742577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.29.158', '2019-05-31 23:47:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-05-31 23:47:21');
INSERT INTO `access_log` VALUES (17768, '59.76.15593176426483051', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.123.71.104', '2019-05-31 23:47:23', 4, 0, '', '2019-05-31 23:47:23');
INSERT INTO `access_log` VALUES (17769, '59.78.15593176426513057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.123.71.104', '2019-05-31 23:47:23', 12, 2001001000, '服务端发生异常', '2019-05-31 23:47:23');
INSERT INTO `access_log` VALUES (17770, '65.47.15593177237702583', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.123.71.104', '2019-05-31 23:48:44', 0, 1002001015, '账号未登陆', '2019-05-31 23:48:44');
INSERT INTO `access_log` VALUES (17771, '65.48.15593177237682573', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.123.71.104', '2019-05-31 23:48:44', 1, 1002001015, '账号未登陆', '2019-05-31 23:48:44');
INSERT INTO `access_log` VALUES (17772, '65.51.15593177237642561', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.123.71.104', '2019-05-31 23:48:44', 1, 1002001015, '账号未登陆', '2019-05-31 23:48:44');
INSERT INTO `access_log` VALUES (17773, '65.49.15593177305602579', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.123.71.104', '2019-05-31 23:48:51', 343, 0, '', '2019-05-31 23:48:51');
INSERT INTO `access_log` VALUES (17774, '65.54.15593177312782547', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.123.71.104', '2019-05-31 23:48:51', 188, 0, '', '2019-05-31 23:48:51');
INSERT INTO `access_log` VALUES (17775, '65.53.15593177312782549', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.123.71.104', '2019-05-31 23:48:51', 189, 0, '', '2019-05-31 23:48:51');
INSERT INTO `access_log` VALUES (17776, '65.45.15593177312792577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.123.71.104', '2019-05-31 23:48:51', 190, 0, '', '2019-05-31 23:48:51');
INSERT INTO `access_log` VALUES (17777, '62.83.15593177369102963', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.123.71.104', '2019-05-31 23:48:57', 23, 0, '', '2019-05-31 23:48:57');
INSERT INTO `access_log` VALUES (17778, '64.84.15593177471342493', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.123.71.104', '2019-05-31 23:49:07', 11, 0, '', '2019-05-31 23:49:07');
INSERT INTO `access_log` VALUES (17779, '64.78.15593177471672495', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.123.71.104', '2019-05-31 23:49:07', 9, 0, '', '2019-05-31 23:49:07');
INSERT INTO `access_log` VALUES (17780, '66.53.15593177558821945', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.123.71.104', '2019-05-31 23:49:16', 22, 0, '', '2019-05-31 23:49:16');
INSERT INTO `access_log` VALUES (17781, '59.77.15593183201693059', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.201.246.255', '2019-05-31 23:58:40', 4, 0, '', '2019-05-31 23:58:40');
INSERT INTO `access_log` VALUES (17782, '59.73.15593183201693065', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.201.246.255', '2019-05-31 23:58:40', 13, 2001001000, '服务端发生异常', '2019-05-31 23:58:40');
INSERT INTO `access_log` VALUES (17783, '64.84.15593183264012501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.201.246.255', '2019-05-31 23:58:46', 4, 0, '', '2019-05-31 23:58:46');
INSERT INTO `access_log` VALUES (17784, '64.78.15593183265202503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.201.246.255', '2019-05-31 23:58:47', 2, 0, '', '2019-05-31 23:58:47');
INSERT INTO `access_log` VALUES (17785, '64.82.15593183305512505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.201.246.255', '2019-05-31 23:58:51', 2, 0, '', '2019-05-31 23:58:51');
INSERT INTO `access_log` VALUES (17786, '64.76.15593183306732495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.201.246.255', '2019-05-31 23:58:51', 3, 0, '', '2019-05-31 23:58:51');
INSERT INTO `access_log` VALUES (17787, '59.76.15593183379543061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.201.246.255', '2019-05-31 23:58:58', 3, 0, '', '2019-05-31 23:58:58');
INSERT INTO `access_log` VALUES (17788, '59.78.15593183379543067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.201.246.255', '2019-05-31 23:58:58', 13, 2001001000, '服务端发生异常', '2019-05-31 23:58:58');
INSERT INTO `access_log` VALUES (17789, '64.83.15593183519722495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.201.246.255', '2019-05-31 23:59:12', 2, 0, '', '2019-05-31 23:59:12');
INSERT INTO `access_log` VALUES (17790, '64.81.15593183520682493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.201.246.255', '2019-05-31 23:59:12', 2, 0, '', '2019-05-31 23:59:12');
INSERT INTO `access_log` VALUES (17791, '59.75.15593187977313069', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3004.3 Safari/537.36', '113.104.200.82', '2019-06-01 00:06:38', 13, 2001001000, '服务端发生异常', '2019-06-01 00:06:38');
INSERT INTO `access_log` VALUES (17792, '59.74.15593187977303069', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3004.3 Safari/537.36', '113.104.200.82', '2019-06-01 00:06:38', 257, 0, '', '2019-06-01 00:06:38');
INSERT INTO `access_log` VALUES (17793, '64.79.15593188020812497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3004.3 Safari/537.36', '113.104.200.82', '2019-06-01 00:06:42', 3, 0, '', '2019-06-01 00:06:42');
INSERT INTO `access_log` VALUES (17794, '64.80.15593188022122499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3004.3 Safari/537.36', '113.104.200.82', '2019-06-01 00:06:42', 2, 0, '', '2019-06-01 00:06:42');
INSERT INTO `access_log` VALUES (17795, '64.84.15593188033992509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3004.3 Safari/537.36', '113.104.200.82', '2019-06-01 00:06:43', 2, 0, '', '2019-06-01 00:06:43');
INSERT INTO `access_log` VALUES (17796, '59.79.15593188048613071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3004.3 Safari/537.36', '113.104.200.82', '2019-06-01 00:06:45', 3, 0, '', '2019-06-01 00:06:45');
INSERT INTO `access_log` VALUES (17797, '59.71.15593188048613071', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3004.3 Safari/537.36', '113.104.200.82', '2019-06-01 00:06:45', 18, 2001001000, '服务端发生异常', '2019-06-01 00:06:45');
INSERT INTO `access_log` VALUES (17798, '64.78.15593188082562511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3004.3 Safari/537.36', '113.104.200.82', '2019-06-01 00:06:48', 2, 0, '', '2019-06-01 00:06:48');
INSERT INTO `access_log` VALUES (17799, '64.85.15593188083992511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3004.3 Safari/537.36', '113.104.200.82', '2019-06-01 00:06:48', 2, 0, '', '2019-06-01 00:06:48');
INSERT INTO `access_log` VALUES (17800, '64.82.15593188095662513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3004.3 Safari/537.36', '113.104.200.82', '2019-06-01 00:06:50', 2, 0, '', '2019-06-01 00:06:50');
INSERT INTO `access_log` VALUES (17801, '64.76.15593188102292503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3004.3 Safari/537.36', '113.104.200.82', '2019-06-01 00:06:50', 2, 0, '', '2019-06-01 00:06:50');
INSERT INTO `access_log` VALUES (17802, '65.50.15593189078712591', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.231.182.216', '2019-06-01 00:08:28', 0, 1002001015, '账号未登陆', '2019-06-01 00:08:28');
INSERT INTO `access_log` VALUES (17803, '65.52.15593189078712569', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.231.182.216', '2019-06-01 00:08:28', 1, 1002001015, '账号未登陆', '2019-06-01 00:08:28');
INSERT INTO `access_log` VALUES (17804, '65.53.15593189078712565', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.231.182.216', '2019-06-01 00:08:28', 1, 1002001015, '账号未登陆', '2019-06-01 00:08:28');
INSERT INTO `access_log` VALUES (17805, '65.50.15593189591722593', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:09:19', 1, 1002001015, '账号未登陆', '2019-06-01 00:09:19');
INSERT INTO `access_log` VALUES (17806, '65.52.15593189591812571', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:09:19', 0, 1002001015, '账号未登陆', '2019-06-01 00:09:19');
INSERT INTO `access_log` VALUES (17807, '65.53.15593189591882567', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:09:19', 1, 1002001015, '账号未登陆', '2019-06-01 00:09:19');
INSERT INTO `access_log` VALUES (17808, '65.46.15593189618932583', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:09:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 00:09:22');
INSERT INTO `access_log` VALUES (17809, '65.51.15593189822102581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:09:42', 79, 0, '', '2019-06-01 00:09:42');
INSERT INTO `access_log` VALUES (17810, '65.49.15593189826342599', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:09:43', 10, 0, '', '2019-06-01 00:09:43');
INSERT INTO `access_log` VALUES (17811, '65.45.15593189826422595', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:09:43', 8, 0, '', '2019-06-01 00:09:43');
INSERT INTO `access_log` VALUES (17812, '65.54.15593189826522567', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:09:43', 9, 0, '', '2019-06-01 00:09:43');
INSERT INTO `access_log` VALUES (17813, '62.85.15593190197802979', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:10:20', 16, 0, '', '2019-06-01 00:10:20');
INSERT INTO `access_log` VALUES (17814, '65.46.15593190386732585', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '120.230.128.159', '2019-06-01 00:10:39', 1, 1002001015, '账号未登陆', '2019-06-01 00:10:39');
INSERT INTO `access_log` VALUES (17815, '65.48.15593190386782595', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '120.230.128.159', '2019-06-01 00:10:39', 0, 1002001015, '账号未登陆', '2019-06-01 00:10:39');
INSERT INTO `access_log` VALUES (17816, '65.47.15593190386852603', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '120.230.128.159', '2019-06-01 00:10:39', 0, 1002001015, '账号未登陆', '2019-06-01 00:10:39');
INSERT INTO `access_log` VALUES (17817, '62.83.15593190394532981', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:10:39', 14, 0, '', '2019-06-01 00:10:39');
INSERT INTO `access_log` VALUES (17818, '65.45.15593190422052597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '120.230.128.159', '2019-06-01 00:10:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 00:10:42');
INSERT INTO `access_log` VALUES (17819, '65.49.15593190483022601', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '120.230.128.159', '2019-06-01 00:10:48', 86, 0, '', '2019-06-01 00:10:48');
INSERT INTO `access_log` VALUES (17820, '65.54.15593190487152569', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '120.230.128.159', '2019-06-01 00:10:49', 10, 0, '', '2019-06-01 00:10:49');
INSERT INTO `access_log` VALUES (17821, '65.52.15593190487172575', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '120.230.128.159', '2019-06-01 00:10:49', 9, 0, '', '2019-06-01 00:10:49');
INSERT INTO `access_log` VALUES (17822, '65.53.15593190487312571', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '120.230.128.159', '2019-06-01 00:10:49', 9, 0, '', '2019-06-01 00:10:49');
INSERT INTO `access_log` VALUES (17823, '64.78.15593190494732515', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:10:49', 13, 0, '', '2019-06-01 00:10:49');
INSERT INTO `access_log` VALUES (17824, '64.85.15593190494792515', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:10:49', 9, 0, '', '2019-06-01 00:10:49');
INSERT INTO `access_log` VALUES (17825, '62.88.15593190557652981', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '120.230.128.159', '2019-06-01 00:10:56', 13, 0, '', '2019-06-01 00:10:56');
INSERT INTO `access_log` VALUES (17826, '59.74.15593190625893073', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '120.230.128.159', '2019-06-01 00:11:03', 13, 0, '', '2019-06-01 00:11:03');
INSERT INTO `access_log` VALUES (17827, '65.48.15593190669952597', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '120.230.128.159', '2019-06-01 00:11:07', 29, 0, '', '2019-06-01 00:11:07');
INSERT INTO `access_log` VALUES (17828, '65.47.15593190679852605', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '120.230.128.159', '2019-06-01 00:11:08', 10, 0, '', '2019-06-01 00:11:08');
INSERT INTO `access_log` VALUES (17829, '62.86.15593190790532975', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '120.230.128.159', '2019-06-01 00:11:19', 13, 0, '', '2019-06-01 00:11:19');
INSERT INTO `access_log` VALUES (17830, '65.45.15593190869992599', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.231.182.216', '2019-06-01 00:11:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 00:11:27');
INSERT INTO `access_log` VALUES (17831, '65.52.15593190994192577', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '183.192.164.56', '2019-06-01 00:11:39', 0, 1002001015, '账号未登陆', '2019-06-01 00:11:39');
INSERT INTO `access_log` VALUES (17832, '62.87.15593191151162983', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '183.192.164.85', '2019-06-01 00:11:55', 1, 1002001015, '账号未登陆', '2019-06-01 00:11:55');
INSERT INTO `access_log` VALUES (17833, '59.80.15593191224223073', 0, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '183.192.164.85', '2019-06-01 00:12:02', 1, 1002001015, '账号未登陆', '2019-06-01 00:12:02');
INSERT INTO `access_log` VALUES (17834, '65.46.15593191270832589', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '183.192.164.214', '2019-06-01 00:12:07', 1, 1002001015, '账号未登陆', '2019-06-01 00:12:07');
INSERT INTO `access_log` VALUES (17835, '64.77.15593192286292515', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:13:49', 12, 0, '', '2019-06-01 00:13:49');
INSERT INTO `access_log` VALUES (17836, '64.83.15593192286332509', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:13:49', 9, 0, '', '2019-06-01 00:13:49');
INSERT INTO `access_log` VALUES (17837, '64.79.15593192334032505', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:13:53', 14, 0, '', '2019-06-01 00:13:53');
INSERT INTO `access_log` VALUES (17838, '64.80.15593192343102507', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:13:54', 12, 0, '', '2019-06-01 00:13:54');
INSERT INTO `access_log` VALUES (17839, '64.84.15593192369712517', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:13:57', 87, 0, '', '2019-06-01 00:13:57');
INSERT INTO `access_log` VALUES (17840, '64.78.15593192380292519', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:13:58', 10, 0, '', '2019-06-01 00:13:58');
INSERT INTO `access_log` VALUES (17841, '64.82.15593192412812521', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:14:01', 9, 0, '', '2019-06-01 00:14:01');
INSERT INTO `access_log` VALUES (17842, '64.85.15593192412812519', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:14:01', 11, 0, '', '2019-06-01 00:14:01');
INSERT INTO `access_log` VALUES (17843, '64.83.15593192581462511', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:14:18', 10, 0, '', '2019-06-01 00:14:18');
INSERT INTO `access_log` VALUES (17844, '66.48.15593193070661965', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:07', 494, 0, '', '2019-06-01 00:15:08');
INSERT INTO `access_log` VALUES (17845, '65.50.15593193166972603', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:17', 10, 0, '', '2019-06-01 00:15:17');
INSERT INTO `access_log` VALUES (17846, '65.48.15593193167232601', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:17', 10, 0, '', '2019-06-01 00:15:17');
INSERT INTO `access_log` VALUES (17847, '65.47.15593193167252611', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:17', 9, 0, '', '2019-06-01 00:15:17');
INSERT INTO `access_log` VALUES (17848, '66.51.15593193168041959', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:17', 22, 0, '', '2019-06-01 00:15:17');
INSERT INTO `access_log` VALUES (17849, '65.46.15593193234042593', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:23', 10, 0, '', '2019-06-01 00:15:23');
INSERT INTO `access_log` VALUES (17850, '65.51.15593193234072591', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:23', 9, 0, '', '2019-06-01 00:15:23');
INSERT INTO `access_log` VALUES (17851, '65.45.15593193234112603', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:23', 9, 0, '', '2019-06-01 00:15:23');
INSERT INTO `access_log` VALUES (17852, '66.54.15593193234831957', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:23', 13, 0, '', '2019-06-01 00:15:23');
INSERT INTO `access_log` VALUES (17853, '65.52.15593193288312581', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:29', 9, 0, '', '2019-06-01 00:15:29');
INSERT INTO `access_log` VALUES (17854, '65.54.15593193288342577', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:29', 9, 0, '', '2019-06-01 00:15:29');
INSERT INTO `access_log` VALUES (17855, '65.53.15593193288582579', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:29', 9, 0, '', '2019-06-01 00:15:29');
INSERT INTO `access_log` VALUES (17856, '66.52.15593193289291959', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:29', 381, 0, '', '2019-06-01 00:15:29');
INSERT INTO `access_log` VALUES (17857, '59.74.15593193337723077', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:34', 12, 0, '', '2019-06-01 00:15:34');
INSERT INTO `access_log` VALUES (17858, '59.71.15593193398533079', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:40', 20, 2001001000, '服务端发生异常', '2019-06-01 00:15:40');
INSERT INTO `access_log` VALUES (17859, '59.73.15593193442273081', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:44', 12, 0, '', '2019-06-01 00:15:44');
INSERT INTO `access_log` VALUES (17860, '64.82.15593193479652523', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:48', 11, 0, '', '2019-06-01 00:15:48');
INSERT INTO `access_log` VALUES (17861, '64.76.15593193507502513', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:51', 10, 0, '', '2019-06-01 00:15:51');
INSERT INTO `access_log` VALUES (17862, '59.80.15593193533663077', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:53', 13, 0, '', '2019-06-01 00:15:53');
INSERT INTO `access_log` VALUES (17863, '59.76.15593193559283077', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:56', 13, 0, '', '2019-06-01 00:15:56');
INSERT INTO `access_log` VALUES (17864, '59.78.15593193566023083', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:57', 12, 0, '', '2019-06-01 00:15:57');
INSERT INTO `access_log` VALUES (17865, '59.72.15593193570813075', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:57', 9, 0, '', '2019-06-01 00:15:57');
INSERT INTO `access_log` VALUES (17866, '59.75.15593193579313079', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:15:58', 13, 0, '', '2019-06-01 00:15:58');
INSERT INTO `access_log` VALUES (17867, '59.79.15593193662773081', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:06', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-01 00:16:06');
INSERT INTO `access_log` VALUES (17868, '65.45.15593193762962605', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:16', 19, 0, '', '2019-06-01 00:16:16');
INSERT INTO `access_log` VALUES (17869, '65.51.15593193805622593', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:21', 12, 0, '', '2019-06-01 00:16:21');
INSERT INTO `access_log` VALUES (17870, '65.49.15593193841932609', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:24', 9, 0, '', '2019-06-01 00:16:24');
INSERT INTO `access_log` VALUES (17871, '65.52.15593193860922583', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:26', 9, 0, '', '2019-06-01 00:16:26');
INSERT INTO `access_log` VALUES (17872, '65.53.15593193872552581', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:27', 10, 0, '', '2019-06-01 00:16:27');
INSERT INTO `access_log` VALUES (17873, '65.54.15593193888732579', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:29', 12, 0, '', '2019-06-01 00:16:29');
INSERT INTO `access_log` VALUES (17874, '65.48.15593194005492605', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:41', 9, 0, '', '2019-06-01 00:16:41');
INSERT INTO `access_log` VALUES (17875, '65.50.15593194073472607', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:47', 15, 0, '', '2019-06-01 00:16:47');
INSERT INTO `access_log` VALUES (17876, '65.45.15593194100322607', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:50', 17, 0, '', '2019-06-01 00:16:50');
INSERT INTO `access_log` VALUES (17877, '65.51.15593194106582595', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:51', 8, 0, '', '2019-06-01 00:16:51');
INSERT INTO `access_log` VALUES (17878, '65.46.15593194112602597', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:51', 9, 0, '', '2019-06-01 00:16:51');
INSERT INTO `access_log` VALUES (17879, '65.49.15593194118462611', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:52', 14, 0, '', '2019-06-01 00:16:52');
INSERT INTO `access_log` VALUES (17880, '65.52.15593194133402585', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:53', 9, 0, '', '2019-06-01 00:16:53');
INSERT INTO `access_log` VALUES (17881, '65.54.15593194141272581', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:16:54', 13, 0, '', '2019-06-01 00:16:54');
INSERT INTO `access_log` VALUES (17882, '59.78.15593194370723085', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:17', 3, 0, '', '2019-06-01 00:17:17');
INSERT INTO `access_log` VALUES (17883, '59.76.15593194370723079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:17', 13, 2001001000, '服务端发生异常', '2019-06-01 00:17:17');
INSERT INTO `access_log` VALUES (17884, '64.84.15593194398812521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:20', 3, 0, '', '2019-06-01 00:17:20');
INSERT INTO `access_log` VALUES (17885, '64.78.15593194401012523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:20', 3, 0, '', '2019-06-01 00:17:20');
INSERT INTO `access_log` VALUES (17886, '64.85.15593194416392523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:22', 3, 0, '', '2019-06-01 00:17:22');
INSERT INTO `access_log` VALUES (17887, '64.76.15593194428532515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:23', 3, 0, '', '2019-06-01 00:17:23');
INSERT INTO `access_log` VALUES (17888, '64.83.15593194433882515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:23', 2, 0, '', '2019-06-01 00:17:23');
INSERT INTO `access_log` VALUES (17889, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:24', 36, 0, '', '2019-06-01 00:17:24');
INSERT INTO `access_log` VALUES (17890, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:25', 6, 0, '', '2019-06-01 00:17:25');
INSERT INTO `access_log` VALUES (17891, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:25', 16, 0, '', '2019-06-01 00:17:25');
INSERT INTO `access_log` VALUES (17892, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:25', 12, 0, '', '2019-06-01 00:17:25');
INSERT INTO `access_log` VALUES (17893, '64.77.15593194492212521', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:29', 7, 0, '', '2019-06-01 00:17:29');
INSERT INTO `access_log` VALUES (17894, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:33', 9, 0, '', '2019-06-01 00:17:33');
INSERT INTO `access_log` VALUES (17895, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:33', 5, 0, '', '2019-06-01 00:17:33');
INSERT INTO `access_log` VALUES (17896, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:33', 11, 0, '', '2019-06-01 00:17:33');
INSERT INTO `access_log` VALUES (17897, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-01 00:17:33', 11, 0, '', '2019-06-01 00:17:33');
INSERT INTO `access_log` VALUES (17898, '65.54.15593198555032587', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:24:16', 1, 1002001015, '账号未登陆', '2019-06-01 00:24:16');
INSERT INTO `access_log` VALUES (17899, '65.47.15593198555032623', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:24:16', 1, 1002001015, '账号未登陆', '2019-06-01 00:24:16');
INSERT INTO `access_log` VALUES (17900, '65.48.15593198555082613', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:24:16', 1, 1002001015, '账号未登陆', '2019-06-01 00:24:16');
INSERT INTO `access_log` VALUES (17901, '65.45.15593198651022615', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:24:25', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 00:24:25');
INSERT INTO `access_log` VALUES (17902, '65.51.15593198682622603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:24:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 00:24:28');
INSERT INTO `access_log` VALUES (17903, '65.46.15593198774372605', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:24:37', 93, 0, '', '2019-06-01 00:24:38');
INSERT INTO `access_log` VALUES (17904, '65.49.15593198778212619', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:24:38', 190, 0, '', '2019-06-01 00:24:38');
INSERT INTO `access_log` VALUES (17905, '65.52.15593198778252593', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:24:38', 188, 0, '', '2019-06-01 00:24:38');
INSERT INTO `access_log` VALUES (17906, '65.53.15593198778282591', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:24:38', 185, 0, '', '2019-06-01 00:24:38');
INSERT INTO `access_log` VALUES (17907, '62.81.15593198822572981', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:24:42', 14, 0, '', '2019-06-01 00:24:42');
INSERT INTO `access_log` VALUES (17908, '62.89.15593198926622991', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:24:53', 13, 0, '', '2019-06-01 00:24:53');
INSERT INTO `access_log` VALUES (17909, '62.85.15593198948582993', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:24:55', 16, 0, '', '2019-06-01 00:24:55');
INSERT INTO `access_log` VALUES (17910, '62.80.15593198994352995', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:24:59', 14, 0, '', '2019-06-01 00:24:59');
INSERT INTO `access_log` VALUES (17911, '64.79.15593199019372517', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:02', 253, 0, '', '2019-06-01 00:25:02');
INSERT INTO `access_log` VALUES (17912, '64.81.15593199019372519', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:02', 254, 0, '', '2019-06-01 00:25:02');
INSERT INTO `access_log` VALUES (17913, '64.84.15593199098962529', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:10', 10, 0, '', '2019-06-01 00:25:10');
INSERT INTO `access_log` VALUES (17914, '64.78.15593199098962531', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:10', 12, 0, '', '2019-06-01 00:25:10');
INSERT INTO `access_log` VALUES (17915, '64.85.15593199124152531', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:12', 11, 0, '', '2019-06-01 00:25:12');
INSERT INTO `access_log` VALUES (17916, '64.76.15593199124182523', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:12', 11, 0, '', '2019-06-01 00:25:12');
INSERT INTO `access_log` VALUES (17917, '64.82.15593199124132533', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:12', 18, 0, '', '2019-06-01 00:25:12');
INSERT INTO `access_log` VALUES (17918, '64.79.15593199231232519', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:23', 11, 0, '', '2019-06-01 00:25:23');
INSERT INTO `access_log` VALUES (17919, '64.77.15593199231212529', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:23', 14, 0, '', '2019-06-01 00:25:23');
INSERT INTO `access_log` VALUES (17920, '62.84.15593199254472991', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:25', 14, 0, '', '2019-06-01 00:25:25');
INSERT INTO `access_log` VALUES (17921, '64.80.15593199284472521', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:28', 9, 0, '', '2019-06-01 00:25:28');
INSERT INTO `access_log` VALUES (17922, '64.81.15593199284472521', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:28', 10, 0, '', '2019-06-01 00:25:28');
INSERT INTO `access_log` VALUES (17923, '64.78.15593199308312533', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:31', 10, 0, '', '2019-06-01 00:25:31');
INSERT INTO `access_log` VALUES (17924, '66.56.15593199364771965', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:36', 17, 0, '', '2019-06-01 00:25:36');
INSERT INTO `access_log` VALUES (17925, '59.71.15593199395923089', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:40', 12, 0, '', '2019-06-01 00:25:40');
INSERT INTO `access_log` VALUES (17926, '59.73.15593199414503091', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:41', 20, 2001001000, '服务端发生异常', '2019-06-01 00:25:41');
INSERT INTO `access_log` VALUES (17927, '59.77.15593199446383085', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:45', 13, 0, '', '2019-06-01 00:25:45');
INSERT INTO `access_log` VALUES (17928, '64.82.15593199499152535', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:50', 10, 0, '', '2019-06-01 00:25:50');
INSERT INTO `access_log` VALUES (17929, '64.76.15593199522862525', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:52', 10, 0, '', '2019-06-01 00:25:52');
INSERT INTO `access_log` VALUES (17930, '59.78.15593199545813093', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:55', 13, 0, '', '2019-06-01 00:25:55');
INSERT INTO `access_log` VALUES (17931, '59.76.15593199559143087', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10&status=ALL&activityType=1', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:25:56', 12, 0, '', '2019-06-01 00:25:56');
INSERT INTO `access_log` VALUES (17932, '59.75.15593199669853089', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:26:07', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-01 00:26:07');
INSERT INTO `access_log` VALUES (17933, '65.53.15593199723112593', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:26:12', 10, 0, '', '2019-06-01 00:26:12');
INSERT INTO `access_log` VALUES (17934, '65.52.15593199734482595', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:26:13', 14, 0, '', '2019-06-01 00:26:13');
INSERT INTO `access_log` VALUES (17935, '65.49.15593199743722621', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:26:14', 9, 0, '', '2019-06-01 00:26:14');
INSERT INTO `access_log` VALUES (17936, '65.54.15593199758162591', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:26:16', 11, 0, '', '2019-06-01 00:26:16');
INSERT INTO `access_log` VALUES (17937, '65.47.15593199766042627', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.231.225.10', '2019-06-01 00:26:17', 19, 0, '', '2019-06-01 00:26:17');
INSERT INTO `access_log` VALUES (17938, '65.52.15593212619362613', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:47:42', 1, 1002001015, '账号未登陆', '2019-06-01 00:47:42');
INSERT INTO `access_log` VALUES (17939, '65.49.15593212619372639', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:47:42', 1, 1002001015, '账号未登陆', '2019-06-01 00:47:42');
INSERT INTO `access_log` VALUES (17940, '65.54.15593212619392609', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:47:42', 1, 1002001015, '账号未登陆', '2019-06-01 00:47:42');
INSERT INTO `access_log` VALUES (17941, '65.45.15593213072292637', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:48:27', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 00:48:27');
INSERT INTO `access_log` VALUES (17942, '65.51.15593213131352625', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:48:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 00:48:33');
INSERT INTO `access_log` VALUES (17943, '65.53.15593213198132613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:48:40', 62, 0, '', '2019-06-01 00:48:40');
INSERT INTO `access_log` VALUES (17944, '65.54.15593213205252611', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:48:41', 158, 0, '', '2019-06-01 00:48:41');
INSERT INTO `access_log` VALUES (17945, '65.52.15593213205612615', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:48:41', 122, 0, '', '2019-06-01 00:48:41');
INSERT INTO `access_log` VALUES (17946, '65.49.15593213205442641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:48:41', 144, 0, '', '2019-06-01 00:48:41');
INSERT INTO `access_log` VALUES (17947, '62.85.15593213294973013', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:48:49', 14, 0, '', '2019-06-01 00:48:50');
INSERT INTO `access_log` VALUES (17948, '64.77.15593213351062549', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:48:55', 14, 0, '', '2019-06-01 00:48:55');
INSERT INTO `access_log` VALUES (17949, '64.80.15593213351152541', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:48:55', 8, 0, '', '2019-06-01 00:48:55');
INSERT INTO `access_log` VALUES (17950, '59.79.15593213434443109', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:49:03', 14, 0, '', '2019-06-01 00:49:03');
INSERT INTO `access_log` VALUES (17951, '64.78.15593213482162553', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:49:08', 10, 0, '', '2019-06-01 00:49:08');
INSERT INTO `access_log` VALUES (17952, '64.84.15593213543992551', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:49:14', 10, 0, '', '2019-06-01 00:49:14');
INSERT INTO `access_log` VALUES (17953, '65.50.15593213587062639', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:49:19', 8, 0, '', '2019-06-01 00:49:19');
INSERT INTO `access_log` VALUES (17954, '59.77.15593213690623105', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.4.166', '2019-06-01 00:49:29', 11, 0, '', '2019-06-01 00:49:29');
INSERT INTO `access_log` VALUES (17955, '65.51.15593218275942633', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:57:08', 0, 1002001015, '账号未登陆', '2019-06-01 00:57:08');
INSERT INTO `access_log` VALUES (17956, '65.46.15593218276032635', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:57:08', 1, 1002001015, '账号未登陆', '2019-06-01 00:57:08');
INSERT INTO `access_log` VALUES (17957, '65.53.15593218276112621', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:57:08', 0, 1002001015, '账号未登陆', '2019-06-01 00:57:08');
INSERT INTO `access_log` VALUES (17958, '65.49.15593218361892649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:57:16', 62, 0, '', '2019-06-01 00:57:16');
INSERT INTO `access_log` VALUES (17959, '65.54.15593218365412619', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:57:17', 10, 0, '', '2019-06-01 00:57:17');
INSERT INTO `access_log` VALUES (17960, '65.47.15593218365462655', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:57:17', 9, 0, '', '2019-06-01 00:57:17');
INSERT INTO `access_log` VALUES (17961, '65.48.15593218365512645', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:57:17', 9, 0, '', '2019-06-01 00:57:17');
INSERT INTO `access_log` VALUES (17962, '62.84.15593218422763019', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:57:22', 14, 0, '', '2019-06-01 00:57:22');
INSERT INTO `access_log` VALUES (17963, '65.45.15593218537802647', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:57:34', 11, 0, '', '2019-06-01 00:57:34');
INSERT INTO `access_log` VALUES (17964, '65.46.15593218548462637', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:57:35', 55, 0, '', '2019-06-01 00:57:35');
INSERT INTO `access_log` VALUES (17965, '65.53.15593218625572623', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:57:43', 10, 0, '', '2019-06-01 00:57:43');
INSERT INTO `access_log` VALUES (17966, '65.52.15593218665732625', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:57:47', 12, 0, '', '2019-06-01 00:57:47');
INSERT INTO `access_log` VALUES (17967, '65.49.15593218733562651', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:57:53', 10, 0, '', '2019-06-01 00:57:53');
INSERT INTO `access_log` VALUES (17968, '62.83.15593218821343025', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:58:02', 11, 0, '', '2019-06-01 00:58:02');
INSERT INTO `access_log` VALUES (17969, '64.77.15593218840152557', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:58:04', 87, 0, '', '2019-06-01 00:58:04');
INSERT INTO `access_log` VALUES (17970, '64.80.15593218840112549', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 00:58:04', 94, 0, '', '2019-06-01 00:58:04');
INSERT INTO `access_log` VALUES (17971, '59.72.15593245644103147', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.230', '2019-06-01 01:42:44', 14, 0, '', '2019-06-01 01:42:44');
INSERT INTO `access_log` VALUES (17972, '59.75.15593245644243151', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.229', '2019-06-01 01:42:44', 18, 2001001000, '服务端发生异常', '2019-06-01 01:42:44');
INSERT INTO `access_log` VALUES (17973, '64.81.15593245737402585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.229', '2019-06-01 01:42:54', 11, 0, '', '2019-06-01 01:42:54');
INSERT INTO `access_log` VALUES (17974, '64.78.15593245738982597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.229', '2019-06-01 01:42:54', 3, 0, '', '2019-06-01 01:42:54');
INSERT INTO `access_log` VALUES (17975, '64.84.15593245797482595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.229', '2019-06-01 01:43:00', 2, 0, '', '2019-06-01 01:43:00');
INSERT INTO `access_log` VALUES (17976, '64.82.15593245798892599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.229', '2019-06-01 01:43:00', 2, 0, '', '2019-06-01 01:43:00');
INSERT INTO `access_log` VALUES (17977, '64.85.15593245811752597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.229', '2019-06-01 01:43:01', 3, 0, '', '2019-06-01 01:43:01');
INSERT INTO `access_log` VALUES (17978, '64.76.15593245820332589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.229', '2019-06-01 01:43:02', 2, 0, '', '2019-06-01 01:43:02');
INSERT INTO `access_log` VALUES (17979, '64.83.15593245832142589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.229', '2019-06-01 01:43:03', 2, 0, '', '2019-06-01 01:43:03');
INSERT INTO `access_log` VALUES (17980, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.229', '2019-06-01 01:43:04', 16, 0, '', '2019-06-01 01:43:04');
INSERT INTO `access_log` VALUES (17981, '64.79.15593245841802585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.230', '2019-06-01 01:43:04', 368, 0, '', '2019-06-01 01:43:05');
INSERT INTO `access_log` VALUES (17982, '64.80.15593245887072587', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.229', '2019-06-01 01:43:09', 8, 0, '', '2019-06-01 01:43:09');
INSERT INTO `access_log` VALUES (17983, '66.57.15593245952612031', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.229', '2019-06-01 01:43:15', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空\n账号长度为 11 位', '2019-06-01 01:43:15');
INSERT INTO `access_log` VALUES (17984, '64.82.15593295914432667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.195.46.91', '2019-06-01 03:06:31', 11, 0, '', '2019-06-01 03:06:31');
INSERT INTO `access_log` VALUES (17985, '59.80.15593295914423217', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.195.46.91', '2019-06-01 03:06:31', 12, 0, '', '2019-06-01 03:06:31');
INSERT INTO `access_log` VALUES (17986, '59.78.15593295914433223', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.195.46.91', '2019-06-01 03:06:31', 16, 2001001000, '服务端发生异常', '2019-06-01 03:06:31');
INSERT INTO `access_log` VALUES (17987, '64.85.15593295916942665', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.195.46.91', '2019-06-01 03:06:32', 3, 0, '', '2019-06-01 03:06:32');
INSERT INTO `access_log` VALUES (17988, '64.76.15593295951812657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.195.46.91', '2019-06-01 03:06:35', 3, 0, '', '2019-06-01 03:06:35');
INSERT INTO `access_log` VALUES (17989, '64.83.15593295953942657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.195.46.91', '2019-06-01 03:06:35', 126, 0, '', '2019-06-01 03:06:36');
INSERT INTO `access_log` VALUES (17990, '59.72.15593295981643215', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.195.46.91', '2019-06-01 03:06:38', 3, 0, '', '2019-06-01 03:06:38');
INSERT INTO `access_log` VALUES (17991, '59.75.15593295981643219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.195.46.91', '2019-06-01 03:06:38', 13, 2001001000, '服务端发生异常', '2019-06-01 03:06:38');
INSERT INTO `access_log` VALUES (17992, '59.79.15593296147863221', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.195.46.91', '2019-06-01 03:06:55', 3, 0, '', '2019-06-01 03:06:55');
INSERT INTO `access_log` VALUES (17993, '59.71.15593296147863221', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.195.46.91', '2019-06-01 03:06:55', 13, 2001001000, '服务端发生异常', '2019-06-01 03:06:55');
INSERT INTO `access_log` VALUES (17994, '64.80.15593296156472655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.195.46.91', '2019-06-01 03:06:56', 2, 0, '', '2019-06-01 03:06:56');
INSERT INTO `access_log` VALUES (17995, '64.81.15593296160622655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.195.46.91', '2019-06-01 03:06:56', 1, 0, '', '2019-06-01 03:06:56');
INSERT INTO `access_log` VALUES (17996, '59.73.15593296165953223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.195.46.91', '2019-06-01 03:06:57', 2, 0, '', '2019-06-01 03:06:57');
INSERT INTO `access_log` VALUES (17997, '59.77.15593296166053217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.195.46.91', '2019-06-01 03:06:57', 11, 2001001000, '服务端发生异常', '2019-06-01 03:06:57');
INSERT INTO `access_log` VALUES (17998, '65.54.15593331342202771', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '139.226.106.153', '2019-06-01 04:05:34', 1, 1002001015, '账号未登陆', '2019-06-01 04:05:34');
INSERT INTO `access_log` VALUES (17999, '65.50.15593331342472799', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '139.226.106.153', '2019-06-01 04:05:34', 1, 1002001015, '账号未登陆', '2019-06-01 04:05:34');
INSERT INTO `access_log` VALUES (18000, '65.48.15593331342422797', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '139.226.106.153', '2019-06-01 04:05:34', 1, 1002001015, '账号未登陆', '2019-06-01 04:05:34');
INSERT INTO `access_log` VALUES (18001, '65.45.15593331387522799', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '139.226.106.153', '2019-06-01 04:05:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 04:05:39');
INSERT INTO `access_log` VALUES (18002, '65.51.15593331514412787', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '139.226.106.153', '2019-06-01 04:05:51', 88, 0, '', '2019-06-01 04:05:52');
INSERT INTO `access_log` VALUES (18003, '59.80.15593385568903339', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '121.237.229.156', '2019-06-01 05:35:57', 13, 0, '', '2019-06-01 05:35:57');
INSERT INTO `access_log` VALUES (18004, '59.77.15593385568913337', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '121.237.229.156', '2019-06-01 05:35:57', 17, 2001001000, '服务端发生异常', '2019-06-01 05:35:57');
INSERT INTO `access_log` VALUES (18005, '64.83.15593385598872777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '121.237.229.156', '2019-06-01 05:36:00', 11, 0, '', '2019-06-01 05:36:00');
INSERT INTO `access_log` VALUES (18006, '64.77.15593385599962783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '121.237.229.156', '2019-06-01 05:36:00', 3, 0, '', '2019-06-01 05:36:00');
INSERT INTO `access_log` VALUES (18007, '64.80.15593385618452775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '121.237.229.156', '2019-06-01 05:36:02', 3, 0, '', '2019-06-01 05:36:02');
INSERT INTO `access_log` VALUES (18008, '64.81.15593385624282775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '121.237.229.156', '2019-06-01 05:36:02', 2, 0, '', '2019-06-01 05:36:02');
INSERT INTO `access_log` VALUES (18009, '59.76.15593385633583337', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '121.237.229.156', '2019-06-01 05:36:03', 4, 0, '', '2019-06-01 05:36:03');
INSERT INTO `access_log` VALUES (18010, '59.78.15593385633583345', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '121.237.229.156', '2019-06-01 05:36:03', 14, 2001001000, '服务端发生异常', '2019-06-01 05:36:03');
INSERT INTO `access_log` VALUES (18011, '59.74.15593421569413389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.62.15', '2019-06-01 06:35:57', 12, 0, '', '2019-06-01 06:35:57');
INSERT INTO `access_log` VALUES (18012, '59.71.15593421569413391', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.62.15', '2019-06-01 06:35:57', 15, 2001001000, '服务端发生异常', '2019-06-01 06:35:57');
INSERT INTO `access_log` VALUES (18013, '64.82.15593421659982837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:06', 12, 0, '', '2019-06-01 06:36:06');
INSERT INTO `access_log` VALUES (18014, '64.85.15593421661442835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:06', 3, 0, '', '2019-06-01 06:36:06');
INSERT INTO `access_log` VALUES (18015, '64.76.15593421678292827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:08', 2, 0, '', '2019-06-01 06:36:08');
INSERT INTO `access_log` VALUES (18016, '64.79.15593421688252821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:09', 2, 0, '', '2019-06-01 06:36:09');
INSERT INTO `access_log` VALUES (18017, '64.83.15593421699232827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:10', 68, 0, '', '2019-06-01 06:36:10');
INSERT INTO `access_log` VALUES (18018, '64.77.15593421710502833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:11', 2, 0, '', '2019-06-01 06:36:11');
INSERT INTO `access_log` VALUES (18019, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:11', 16, 0, '', '2019-06-01 06:36:11');
INSERT INTO `access_log` VALUES (18020, '64.80.15593421724512825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:12', 157, 0, '', '2019-06-01 06:36:13');
INSERT INTO `access_log` VALUES (18021, '64.81.15593421727912825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:13', 2, 0, '', '2019-06-01 06:36:13');
INSERT INTO `access_log` VALUES (18022, '64.78.15593421734842837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:13', 3, 0, '', '2019-06-01 06:36:13');
INSERT INTO `access_log` VALUES (18023, '64.84.15593421740492835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:14', 2, 0, '', '2019-06-01 06:36:14');
INSERT INTO `access_log` VALUES (18024, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:14', 11, 0, '', '2019-06-01 06:36:14');
INSERT INTO `access_log` VALUES (18025, '64.82.15593421768682839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:17', 3, 0, '', '2019-06-01 06:36:17');
INSERT INTO `access_log` VALUES (18026, '64.85.15593421769712837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:17', 2, 0, '', '2019-06-01 06:36:17');
INSERT INTO `access_log` VALUES (18027, '64.76.15593421778352829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:18', 2, 0, '', '2019-06-01 06:36:18');
INSERT INTO `access_log` VALUES (18028, '64.79.15593421784872823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:18', 3, 0, '', '2019-06-01 06:36:18');
INSERT INTO `access_log` VALUES (18029, '64.77.15593421810532835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:21', 2, 0, '', '2019-06-01 06:36:21');
INSERT INTO `access_log` VALUES (18030, '64.80.15593421818442827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:22', 2, 0, '', '2019-06-01 06:36:22');
INSERT INTO `access_log` VALUES (18031, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:22', 11, 0, '', '2019-06-01 06:36:22');
INSERT INTO `access_log` VALUES (18032, '64.81.15593421841762827', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:24', 8, 0, '', '2019-06-01 06:36:24');
INSERT INTO `access_log` VALUES (18033, '64.78.15593421858392839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:26', 2, 0, '', '2019-06-01 06:36:26');
INSERT INTO `access_log` VALUES (18034, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:26', 8, 0, '', '2019-06-01 06:36:26');
INSERT INTO `access_log` VALUES (18035, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:27', 7, 0, '', '2019-06-01 06:36:27');
INSERT INTO `access_log` VALUES (18036, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:28', 7, 0, '', '2019-06-01 06:36:28');
INSERT INTO `access_log` VALUES (18037, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:28', 6, 0, '', '2019-06-01 06:36:28');
INSERT INTO `access_log` VALUES (18038, '64.84.15593421891702837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:29', 2, 0, '', '2019-06-01 06:36:29');
INSERT INTO `access_log` VALUES (18039, '64.82.15593421892772841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:29', 2, 0, '', '2019-06-01 06:36:29');
INSERT INTO `access_log` VALUES (18040, '59.75.15593421910233389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:31', 4, 0, '', '2019-06-01 06:36:31');
INSERT INTO `access_log` VALUES (18041, '59.77.15593421910233385', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:31', 12, 2001001000, '服务端发生异常', '2019-06-01 06:36:31');
INSERT INTO `access_log` VALUES (18042, '64.85.15593421932842839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:33', 2, 0, '', '2019-06-01 06:36:33');
INSERT INTO `access_log` VALUES (18043, '64.76.15593421934332831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:33', 2, 0, '', '2019-06-01 06:36:33');
INSERT INTO `access_log` VALUES (18044, '59.76.15593422015313387', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:42', 3, 0, '', '2019-06-01 06:36:42');
INSERT INTO `access_log` VALUES (18045, '59.78.15593422015313395', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:42', 13, 2001001000, '服务端发生异常', '2019-06-01 06:36:42');
INSERT INTO `access_log` VALUES (18046, '64.83.15593422021012831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:42', 2, 0, '', '2019-06-01 06:36:42');
INSERT INTO `access_log` VALUES (18047, '64.77.15593422022132837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:42', 2, 0, '', '2019-06-01 06:36:42');
INSERT INTO `access_log` VALUES (18048, '59.79.15593422046453391', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:45', 14, 2001001000, '服务端发生异常', '2019-06-01 06:36:45');
INSERT INTO `access_log` VALUES (18049, '59.71.15593422046453393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.64.62.15', '2019-06-01 06:36:45', 242, 0, '', '2019-06-01 06:36:45');
INSERT INTO `access_log` VALUES (18050, '59.78.15593454428263439', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '117.44.162.227', '2019-06-01 07:30:43', 17, 2001001000, '服务端发生异常', '2019-06-01 07:30:43');
INSERT INTO `access_log` VALUES (18051, '59.76.15593454428253431', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '117.44.162.227', '2019-06-01 07:30:43', 368, 0, '', '2019-06-01 07:30:43');
INSERT INTO `access_log` VALUES (18052, '65.47.15593454690582973', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '117.44.162.227', '2019-06-01 07:31:09', 1, 1002001015, '账号未登陆', '2019-06-01 07:31:09');
INSERT INTO `access_log` VALUES (18053, '65.50.15593454690582965', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '117.44.162.227', '2019-06-01 07:31:09', 0, 1002001015, '账号未登陆', '2019-06-01 07:31:09');
INSERT INTO `access_log` VALUES (18054, '65.54.15593454690592937', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '117.44.162.227', '2019-06-01 07:31:09', 0, 1002001015, '账号未登陆', '2019-06-01 07:31:09');
INSERT INTO `access_log` VALUES (18055, '65.48.15593454722592961', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '117.44.162.227', '2019-06-01 07:31:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 07:31:12');
INSERT INTO `access_log` VALUES (18056, '65.45.15593454798582965', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '117.44.162.227', '2019-06-01 07:31:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 07:31:20');
INSERT INTO `access_log` VALUES (18057, '65.53.15593455060012941', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '117.44.162.227', '2019-06-01 07:31:46', 64, 0, '', '2019-06-01 07:31:46');
INSERT INTO `access_log` VALUES (18058, '65.52.15593455063822943', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '117.44.162.227', '2019-06-01 07:31:46', 9, 0, '', '2019-06-01 07:31:46');
INSERT INTO `access_log` VALUES (18059, '65.49.15593455063852969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '117.44.162.227', '2019-06-01 07:31:46', 9, 0, '', '2019-06-01 07:31:46');
INSERT INTO `access_log` VALUES (18060, '65.54.15593455063882939', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '117.44.162.227', '2019-06-01 07:31:46', 10, 0, '', '2019-06-01 07:31:46');
INSERT INTO `access_log` VALUES (18061, '62.84.15593455161703335', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '117.44.162.227', '2019-06-01 07:31:56', 22, 0, '', '2019-06-01 07:31:56');
INSERT INTO `access_log` VALUES (18062, '65.46.15593458600582961', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '116.23.81.217', '2019-06-01 07:37:40', 1, 1002001015, '账号未登陆', '2019-06-01 07:37:40');
INSERT INTO `access_log` VALUES (18063, '65.51.15593458600612959', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '116.23.81.217', '2019-06-01 07:37:40', 0, 1002001015, '账号未登陆', '2019-06-01 07:37:40');
INSERT INTO `access_log` VALUES (18064, '65.53.15593458600652947', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '116.23.81.217', '2019-06-01 07:37:40', 0, 1002001015, '账号未登陆', '2019-06-01 07:37:40');
INSERT INTO `access_log` VALUES (18065, '65.50.15593459170862973', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '116.23.81.217', '2019-06-01 07:38:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 07:38:37');
INSERT INTO `access_log` VALUES (18066, '65.48.15593459236542969', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '116.23.81.217', '2019-06-01 07:38:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 07:38:44');
INSERT INTO `access_log` VALUES (18067, '59.74.15593471026103457', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:58:23', 5, 0, '', '2019-06-01 07:58:23');
INSERT INTO `access_log` VALUES (18068, '59.79.15593471026093457', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:58:23', 13, 2001001000, '服务端发生异常', '2019-06-01 07:58:23');
INSERT INTO `access_log` VALUES (18069, '64.79.15593471069232891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:58:27', 11, 0, '', '2019-06-01 07:58:27');
INSERT INTO `access_log` VALUES (18070, '64.83.15593471071242897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:58:27', 3, 0, '', '2019-06-01 07:58:27');
INSERT INTO `access_log` VALUES (18071, '64.77.15593471088922903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:58:29', 2, 0, '', '2019-06-01 07:58:29');
INSERT INTO `access_log` VALUES (18072, '64.80.15593471101012895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:58:30', 2, 0, '', '2019-06-01 07:58:30');
INSERT INTO `access_log` VALUES (18073, '64.81.15593471114602895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:58:31', 2, 0, '', '2019-06-01 07:58:31');
INSERT INTO `access_log` VALUES (18074, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=小米&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:58:40', 18, 0, '', '2019-06-01 07:58:40');
INSERT INTO `access_log` VALUES (18075, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=小米', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:58:41', 21, 0, '', '2019-06-01 07:58:41');
INSERT INTO `access_log` VALUES (18076, '64.84.15593471240892905', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:58:44', 7, 0, '', '2019-06-01 07:58:44');
INSERT INTO `access_log` VALUES (18077, '64.76.15593471546212899', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:59:15', 7, 0, '', '2019-06-01 07:59:15');
INSERT INTO `access_log` VALUES (18078, '64.83.15593471664872899', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:59:26', 7, 0, '', '2019-06-01 07:59:26');
INSERT INTO `access_log` VALUES (18079, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:59:32', 8, 0, '', '2019-06-01 07:59:32');
INSERT INTO `access_log` VALUES (18080, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:59:32', 57, 0, '', '2019-06-01 07:59:32');
INSERT INTO `access_log` VALUES (18081, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:59:34', 6, 0, '', '2019-06-01 07:59:34');
INSERT INTO `access_log` VALUES (18082, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:59:35', 12, 0, '', '2019-06-01 07:59:35');
INSERT INTO `access_log` VALUES (18083, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=desc', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:59:49', 11, 0, '', '2019-06-01 07:59:49');
INSERT INTO `access_log` VALUES (18084, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:59:53', 7, 0, '', '2019-06-01 07:59:53');
INSERT INTO `access_log` VALUES (18085, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=asc', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 07:59:59', 9, 0, '', '2019-06-01 07:59:59');
INSERT INTO `access_log` VALUES (18086, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=asc', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:18', 7, 0, '', '2019-06-01 08:00:18');
INSERT INTO `access_log` VALUES (18087, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=asc', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:20', 8, 0, '', '2019-06-01 08:00:20');
INSERT INTO `access_log` VALUES (18088, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=asc', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:22', 7, 0, '', '2019-06-01 08:00:22');
INSERT INTO `access_log` VALUES (18089, '64.84.15593472271622907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:27', 642, 0, '', '2019-06-01 08:00:28');
INSERT INTO `access_log` VALUES (18090, '64.82.15593472281032911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:28', 2, 0, '', '2019-06-01 08:00:28');
INSERT INTO `access_log` VALUES (18091, '64.85.15593472323952909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:32', 129, 0, '', '2019-06-01 08:00:33');
INSERT INTO `access_log` VALUES (18092, '64.76.15593472328342901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:33', 3, 0, '', '2019-06-01 08:00:33');
INSERT INTO `access_log` VALUES (18093, '59.74.15593472487223459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:49', 14, 2001001000, '服务端发生异常', '2019-06-01 08:00:49');
INSERT INTO `access_log` VALUES (18094, '59.72.15593472487533455', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:49', 4, 0, '', '2019-06-01 08:00:49');
INSERT INTO `access_log` VALUES (18095, '64.77.15593472516992907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:52', 3, 0, '', '2019-06-01 08:00:52');
INSERT INTO `access_log` VALUES (18096, '64.80.15593472519132899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:52', 2, 0, '', '2019-06-01 08:00:52');
INSERT INTO `access_log` VALUES (18097, '59.77.15593472530193455', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:53', 2, 0, '', '2019-06-01 08:00:53');
INSERT INTO `access_log` VALUES (18098, '59.75.15593472530193459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:53', 12, 2001001000, '服务端发生异常', '2019-06-01 08:00:53');
INSERT INTO `access_log` VALUES (18099, '59.76.15593472575563457', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:58', 3, 0, '', '2019-06-01 08:00:58');
INSERT INTO `access_log` VALUES (18100, '59.80.15593472575563459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:00:58', 13, 2001001000, '服务端发生异常', '2019-06-01 08:00:58');
INSERT INTO `access_log` VALUES (18101, '64.81.15593472618932899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:01:02', 3, 0, '', '2019-06-01 08:01:02');
INSERT INTO `access_log` VALUES (18102, '64.78.15593472620972911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:01:02', 2, 0, '', '2019-06-01 08:01:02');
INSERT INTO `access_log` VALUES (18103, '59.71.15593472627713463', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:01:03', 3, 0, '', '2019-06-01 08:01:03');
INSERT INTO `access_log` VALUES (18104, '59.78.15593472627713465', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-CN; vivo X6S A Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '27.191.196.35', '2019-06-01 08:01:03', 13, 2001001000, '服务端发生异常', '2019-06-01 08:01:03');
INSERT INTO `access_log` VALUES (18105, '65.48.15593474064052989', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:03:26', 0, 1002001015, '账号未登陆', '2019-06-01 08:03:26');
INSERT INTO `access_log` VALUES (18106, '65.45.15593474064082993', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:03:26', 0, 1002001015, '账号未登陆', '2019-06-01 08:03:26');
INSERT INTO `access_log` VALUES (18107, '65.51.15593474064182981', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:03:26', 0, 1002001015, '账号未登陆', '2019-06-01 08:03:26');
INSERT INTO `access_log` VALUES (18108, '65.53.15593474124612969', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:03:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 08:03:32');
INSERT INTO `access_log` VALUES (18109, '59.74.15593474216583463', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:03:42', 3, 0, '', '2019-06-01 08:03:42');
INSERT INTO `access_log` VALUES (18110, '59.72.15593474216613459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:03:42', 13, 2001001000, '服务端发生异常', '2019-06-01 08:03:42');
INSERT INTO `access_log` VALUES (18111, '66.53.15593474850202341', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18701351232&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '211.152.0.131', '2019-06-01 08:04:45', 18, 1001003000, '验证码不存在', '2019-06-01 08:04:45');
INSERT INTO `access_log` VALUES (18112, '66.57.15593474918442337', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18701351232', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '211.152.0.131', '2019-06-01 08:04:52', 88, 0, '', '2019-06-01 08:04:52');
INSERT INTO `access_log` VALUES (18113, '66.49.15593474955102335', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18701351232&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '211.152.0.131', '2019-06-01 08:04:56', 4226, 0, '', '2019-06-01 08:05:00');
INSERT INTO `access_log` VALUES (18114, '59.74.15593475143803465', 94, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:05:14', 7, 0, '', '2019-06-01 08:05:14');
INSERT INTO `access_log` VALUES (18115, '59.72.15593475143923461', 94, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:05:14', 16, 2001001000, '服务端发生异常', '2019-06-01 08:05:14');
INSERT INTO `access_log` VALUES (18116, '66.51.15593475174762337', 94, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:05:17', 8, 0, '', '2019-06-01 08:05:17');
INSERT INTO `access_log` VALUES (18117, '66.54.15593475251822335', 94, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:05:25', 6, 0, '', '2019-06-01 08:05:25');
INSERT INTO `access_log` VALUES (18118, '66.52.15593475314792337', 94, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:05:31', 6, 0, '', '2019-06-01 08:05:31');
INSERT INTO `access_log` VALUES (18119, '64.78.15593475315232915', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:05:32', 6, 0, '', '2019-06-01 08:05:32');
INSERT INTO `access_log` VALUES (18120, '64.82.15593475317072917', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:05:32', 5, 0, '', '2019-06-01 08:05:32');
INSERT INTO `access_log` VALUES (18121, '64.85.15593475334492915', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:05:33', 6, 0, '', '2019-06-01 08:05:33');
INSERT INTO `access_log` VALUES (18122, '64.79.15593475341552901', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:05:34', 6, 0, '', '2019-06-01 08:05:34');
INSERT INTO `access_log` VALUES (18123, '64.77.15593475350042913', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:05:35', 6, 0, '', '2019-06-01 08:05:35');
INSERT INTO `access_log` VALUES (18124, '59.77.15593475365233461', 94, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:05:37', 5, 0, '', '2019-06-01 08:05:37');
INSERT INTO `access_log` VALUES (18125, '59.80.15593475365253465', 94, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:05:37', 12, 2001001000, '服务端发生异常', '2019-06-01 08:05:37');
INSERT INTO `access_log` VALUES (18126, '65.52.15593475872122973', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:06:27', 59, 0, '', '2019-06-01 08:06:27');
INSERT INTO `access_log` VALUES (18127, '65.54.15593475875972969', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:06:28', 10, 0, '', '2019-06-01 08:06:28');
INSERT INTO `access_log` VALUES (18128, '65.50.15593475876032997', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:06:28', 10, 0, '', '2019-06-01 08:06:28');
INSERT INTO `access_log` VALUES (18129, '65.47.15593475876473005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:06:28', 11, 0, '', '2019-06-01 08:06:28');
INSERT INTO `access_log` VALUES (18130, '62.84.15593475985973363', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:06:39', 30, 0, '', '2019-06-01 08:06:39');
INSERT INTO `access_log` VALUES (18131, '64.76.15593476047572909', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:06:45', 10, 0, '', '2019-06-01 08:06:45');
INSERT INTO `access_log` VALUES (18132, '64.85.15593476047542917', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:06:45', 15, 0, '', '2019-06-01 08:06:45');
INSERT INTO `access_log` VALUES (18133, '64.77.15593476111142915', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:06:51', 10, 0, '', '2019-06-01 08:06:51');
INSERT INTO `access_log` VALUES (18134, '64.83.15593476111112909', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:06:51', 15, 0, '', '2019-06-01 08:06:51');
INSERT INTO `access_log` VALUES (18135, '64.78.15593476174022919', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:06:57', 11, 0, '', '2019-06-01 08:06:57');
INSERT INTO `access_log` VALUES (18136, '64.81.15593476174012907', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:06:57', 19, 0, '', '2019-06-01 08:06:57');
INSERT INTO `access_log` VALUES (18137, '64.80.15593476174012907', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:06:57', 23, 0, '', '2019-06-01 08:06:57');
INSERT INTO `access_log` VALUES (18138, '59.73.15593476249363471', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:07:05', 12, 0, '', '2019-06-01 08:07:05');
INSERT INTO `access_log` VALUES (18139, '59.75.15593476312803467', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:07:11', 13, 0, '', '2019-06-01 08:07:11');
INSERT INTO `access_log` VALUES (18140, '59.75.15593477734093469', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:09:33', 5, 0, '', '2019-06-01 08:09:33');
INSERT INTO `access_log` VALUES (18141, '59.77.15593477736503465', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:09:34', 13, 2001001000, '服务端发生异常', '2019-06-01 08:09:34');
INSERT INTO `access_log` VALUES (18142, '65.51.15593477769212987', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:09:37', 1, 1002001015, '账号未登陆', '2019-06-01 08:09:37');
INSERT INTO `access_log` VALUES (18143, '65.53.15593477769272975', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:09:37', 1, 1002001015, '账号未登陆', '2019-06-01 08:09:37');
INSERT INTO `access_log` VALUES (18144, '65.46.15593477769312989', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:09:37', 0, 1002001015, '账号未登陆', '2019-06-01 08:09:37');
INSERT INTO `access_log` VALUES (18145, '65.52.15593477812322977', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:09:41', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 08:09:41');
INSERT INTO `access_log` VALUES (18146, '65.50.15593477885533001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:09:49', 56, 0, '', '2019-06-01 08:09:49');
INSERT INTO `access_log` VALUES (18147, '65.47.15593477888283009', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:09:49', 284, 0, '', '2019-06-01 08:09:49');
INSERT INTO `access_log` VALUES (18148, '65.45.15593477888293001', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:09:49', 284, 0, '', '2019-06-01 08:09:49');
INSERT INTO `access_log` VALUES (18149, '65.54.15593477888252973', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:09:49', 289, 0, '', '2019-06-01 08:09:49');
INSERT INTO `access_log` VALUES (18150, '62.85.15593477938433369', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:09:54', 16, 0, '', '2019-06-01 08:09:54');
INSERT INTO `access_log` VALUES (18151, '62.83.15593477976993373', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:09:58', 18, 0, '', '2019-06-01 08:09:58');
INSERT INTO `access_log` VALUES (18152, '64.85.15593477994192921', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:09:59', 12, 0, '', '2019-06-01 08:09:59');
INSERT INTO `access_log` VALUES (18153, '64.76.15593477994172913', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:09:59', 15, 0, '', '2019-06-01 08:09:59');
INSERT INTO `access_log` VALUES (18154, '64.77.15593478043502919', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:10:04', 9, 0, '', '2019-06-01 08:10:04');
INSERT INTO `access_log` VALUES (18155, '64.79.15593478043472907', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:10:04', 13, 0, '', '2019-06-01 08:10:04');
INSERT INTO `access_log` VALUES (18156, '66.52.15593478104302341', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:10:10', 454, 0, '', '2019-06-01 08:10:11');
INSERT INTO `access_log` VALUES (18157, '59.78.15593478116293475', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:10:12', 525, 0, '', '2019-06-01 08:10:12');
INSERT INTO `access_log` VALUES (18158, '65.46.15593478135122991', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:10:14', 16, 0, '', '2019-06-01 08:10:14');
INSERT INTO `access_log` VALUES (18159, '65.53.15593478141502977', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:10:14', 9, 0, '', '2019-06-01 08:10:14');
INSERT INTO `access_log` VALUES (18160, '65.49.15593478146993005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:10:15', 13, 0, '', '2019-06-01 08:10:15');
INSERT INTO `access_log` VALUES (18161, '65.52.15593478153202979', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:10:15', 10, 0, '', '2019-06-01 08:10:15');
INSERT INTO `access_log` VALUES (18162, '65.50.15593478161543003', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.227.23.52', '2019-06-01 08:10:16', 364, 0, '', '2019-06-01 08:10:17');
INSERT INTO `access_log` VALUES (18163, '59.73.15593499486713503', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.69.74', '2019-06-01 08:45:49', 12, 0, '', '2019-06-01 08:45:49');
INSERT INTO `access_log` VALUES (18164, '59.72.15593499486713495', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.69.74', '2019-06-01 08:45:49', 16, 2001001000, '服务端发生异常', '2019-06-01 08:45:49');
INSERT INTO `access_log` VALUES (18165, '64.84.15593499524462949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.69.74', '2019-06-01 08:45:52', 12, 0, '', '2019-06-01 08:45:52');
INSERT INTO `access_log` VALUES (18166, '64.82.15593499525952953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.69.74', '2019-06-01 08:45:53', 3, 0, '', '2019-06-01 08:45:53');
INSERT INTO `access_log` VALUES (18167, '64.76.15593499538022943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.69.74', '2019-06-01 08:45:54', 2, 0, '', '2019-06-01 08:45:54');
INSERT INTO `access_log` VALUES (18168, '59.77.15593499551383495', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.69.74', '2019-06-01 08:45:55', 4, 0, '', '2019-06-01 08:45:55');
INSERT INTO `access_log` VALUES (18169, '59.80.15593499551763499', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.69.74', '2019-06-01 08:45:55', 13, 2001001000, '服务端发生异常', '2019-06-01 08:45:55');
INSERT INTO `access_log` VALUES (18170, '59.71.15593499594023503', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.57.2', '2019-06-01 08:45:59', 12, 2001001000, '服务端发生异常', '2019-06-01 08:45:59');
INSERT INTO `access_log` VALUES (18171, '59.76.15593499594023497', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.57.2', '2019-06-01 08:45:59', 327, 0, '', '2019-06-01 08:46:00');
INSERT INTO `access_log` VALUES (18172, '66.49.15593499599602369', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.69.74', '2019-06-01 08:46:00', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-06-01 08:46:00');
INSERT INTO `access_log` VALUES (18173, '59.78.15593499618393505', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.69.74', '2019-06-01 08:46:02', 3, 0, '', '2019-06-01 08:46:02');
INSERT INTO `access_log` VALUES (18174, '59.79.15593499618393501', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.69.74', '2019-06-01 08:46:02', 14, 2001001000, '服务端发生异常', '2019-06-01 08:46:02');
INSERT INTO `access_log` VALUES (18175, '64.85.15593499623212951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.69.74', '2019-06-01 08:46:02', 3, 0, '', '2019-06-01 08:46:02');
INSERT INTO `access_log` VALUES (18176, '64.79.15593499624342937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.69.74', '2019-06-01 08:46:02', 2, 0, '', '2019-06-01 08:46:02');
INSERT INTO `access_log` VALUES (18177, '64.77.15593499626402949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.57.2', '2019-06-01 08:46:03', 2, 0, '', '2019-06-01 08:46:03');
INSERT INTO `access_log` VALUES (18178, '64.83.15593499627592943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.57.2', '2019-06-01 08:46:03', 3, 0, '', '2019-06-01 08:46:03');
INSERT INTO `access_log` VALUES (18179, '59.72.15593499628973497', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.69.74', '2019-06-01 08:46:03', 3, 0, '', '2019-06-01 08:46:03');
INSERT INTO `access_log` VALUES (18180, '59.74.15593499628973501', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.69.74', '2019-06-01 08:46:03', 19, 2001001000, '服务端发生异常', '2019-06-01 08:46:03');
INSERT INTO `access_log` VALUES (18181, '64.80.15593499641452941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.57.2', '2019-06-01 08:46:04', 3, 0, '', '2019-06-01 08:46:04');
INSERT INTO `access_log` VALUES (18182, '59.80.15593502727973505', 94, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:51:13', 8, 0, '', '2019-06-01 08:51:13');
INSERT INTO `access_log` VALUES (18183, '59.71.15593502727973509', 94, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:51:13', 18, 2001001000, '服务端发生异常', '2019-06-01 08:51:13');
INSERT INTO `access_log` VALUES (18184, '64.84.15593502792882955', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:51:19', 6, 0, '', '2019-06-01 08:51:19');
INSERT INTO `access_log` VALUES (18185, '64.76.15593502796712949', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:51:20', 6, 0, '', '2019-06-01 08:51:20');
INSERT INTO `access_log` VALUES (18186, '64.77.15593502812942955', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:51:21', 6, 0, '', '2019-06-01 08:51:21');
INSERT INTO `access_log` VALUES (18187, '64.80.15593502824452947', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:51:22', 6, 0, '', '2019-06-01 08:51:22');
INSERT INTO `access_log` VALUES (18188, '64.78.15593502829392959', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:51:23', 6, 0, '', '2019-06-01 08:51:23');
INSERT INTO `access_log` VALUES (18189, '64.81.15593502836372947', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:51:24', 6, 0, '', '2019-06-01 08:51:24');
INSERT INTO `access_log` VALUES (18190, '64.84.15593502844042957', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:51:24', 5, 0, '', '2019-06-01 08:51:24');
INSERT INTO `access_log` VALUES (18191, '64.82.15593502849282961', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:51:25', 5, 0, '', '2019-06-01 08:51:25');
INSERT INTO `access_log` VALUES (18192, '64.76.15593502853402951', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:51:25', 5, 0, '', '2019-06-01 08:51:25');
INSERT INTO `access_log` VALUES (18193, '64.85.15593502857012959', 94, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:51:26', 5, 0, '', '2019-06-01 08:51:26');
INSERT INTO `access_log` VALUES (18194, '59.78.15593502875443511', 94, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:51:28', 123, 0, '', '2019-06-01 08:51:28');
INSERT INTO `access_log` VALUES (18195, '59.79.15593502875453507', 94, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.152.0.131', '2019-06-01 08:51:28', 132, 2001001000, '服务端发生异常', '2019-06-01 08:51:28');
INSERT INTO `access_log` VALUES (18196, '59.73.15593502969623511', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '115.206.42.211', '2019-06-01 08:51:37', 3, 0, '', '2019-06-01 08:51:37');
INSERT INTO `access_log` VALUES (18197, '59.74.15593502969623507', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '115.206.42.211', '2019-06-01 08:51:37', 12, 2001001000, '服务端发生异常', '2019-06-01 08:51:37');
INSERT INTO `access_log` VALUES (18198, '64.77.15593503060472957', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.206.42.211', '2019-06-01 08:51:46', 3, 0, '', '2019-06-01 08:51:46');
INSERT INTO `access_log` VALUES (18199, '64.83.15593503061772951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.206.42.211', '2019-06-01 08:51:46', 2, 0, '', '2019-06-01 08:51:46');
INSERT INTO `access_log` VALUES (18200, '59.77.15593503155003503', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.206.42.211', '2019-06-01 08:51:56', 3, 0, '', '2019-06-01 08:51:56');
INSERT INTO `access_log` VALUES (18201, '59.71.15593503155013511', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.206.42.211', '2019-06-01 08:51:56', 10, 2001001000, '服务端发生异常', '2019-06-01 08:51:56');
INSERT INTO `access_log` VALUES (18202, '59.76.15593503217133505', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.206.42.211', '2019-06-01 08:52:02', 4, 0, '', '2019-06-01 08:52:02');
INSERT INTO `access_log` VALUES (18203, '59.80.15593503217133507', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.206.42.211', '2019-06-01 08:52:02', 13, 2001001000, '服务端发生异常', '2019-06-01 08:52:02');
INSERT INTO `access_log` VALUES (18204, '64.81.15593503334042949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.206.42.211', '2019-06-01 08:52:13', 2, 0, '', '2019-06-01 08:52:13');
INSERT INTO `access_log` VALUES (18205, '64.84.15593503335082959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.206.42.211', '2019-06-01 08:52:14', 2, 0, '', '2019-06-01 08:52:14');
INSERT INTO `access_log` VALUES (18206, '59.78.15593503339723513', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.206.42.211', '2019-06-01 08:52:14', 3, 0, '', '2019-06-01 08:52:14');
INSERT INTO `access_log` VALUES (18207, '59.72.15593503339733505', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.206.42.211', '2019-06-01 08:52:14', 12, 2001001000, '服务端发生异常', '2019-06-01 08:52:14');
INSERT INTO `access_log` VALUES (18208, '65.50.15593503451783037', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; 16 X) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '223.104.66.179', '2019-06-01 08:52:25', 0, 1002001015, '账号未登陆', '2019-06-01 08:52:25');
INSERT INTO `access_log` VALUES (18209, '65.47.15593503451793045', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; 16 X) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '223.104.66.179', '2019-06-01 08:52:25', 0, 1002001015, '账号未登陆', '2019-06-01 08:52:25');
INSERT INTO `access_log` VALUES (18210, '65.45.15593503451923037', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; 16 X) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '223.104.66.179', '2019-06-01 08:52:25', 0, 1002001015, '账号未登陆', '2019-06-01 08:52:25');
INSERT INTO `access_log` VALUES (18211, '65.54.15593503527273009', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1.0; 16 X) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '223.104.66.179', '2019-06-01 08:52:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 08:52:33');
INSERT INTO `access_log` VALUES (18212, '65.51.15593503619963025', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1.0; 16 X) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '223.104.66.179', '2019-06-01 08:52:42', 78, 0, '', '2019-06-01 08:52:42');
INSERT INTO `access_log` VALUES (18213, '65.46.15593503625913027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; 16 X) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '223.104.66.179', '2019-06-01 08:52:43', 13, 0, '', '2019-06-01 08:52:43');
INSERT INTO `access_log` VALUES (18214, '65.53.15593503625933013', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; 16 X) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '223.104.66.179', '2019-06-01 08:52:43', 11, 0, '', '2019-06-01 08:52:43');
INSERT INTO `access_log` VALUES (18215, '65.49.15593503625933041', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; 16 X) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '223.104.66.179', '2019-06-01 08:52:43', 13, 0, '', '2019-06-01 08:52:43');
INSERT INTO `access_log` VALUES (18216, '65.45.15593503839513039', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; 16 X) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '223.104.66.179', '2019-06-01 08:53:04', 11, 0, '', '2019-06-01 08:53:04');
INSERT INTO `access_log` VALUES (18217, '65.47.15593503840313047', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; 16 X) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '223.104.66.179', '2019-06-01 08:53:04', 9, 0, '', '2019-06-01 08:53:04');
INSERT INTO `access_log` VALUES (18218, '59.77.15593503841913505', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; 16 X) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '223.104.66.179', '2019-06-01 08:53:04', 13, 0, '', '2019-06-01 08:53:04');
INSERT INTO `access_log` VALUES (18219, '65.50.15593503842123039', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; 16 X) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '223.104.66.179', '2019-06-01 08:53:04', 8, 0, '', '2019-06-01 08:53:04');
INSERT INTO `access_log` VALUES (18220, '64.77.15593503887162959', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; 16 X) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '223.104.66.179', '2019-06-01 08:53:09', 11, 0, '', '2019-06-01 08:53:09');
INSERT INTO `access_log` VALUES (18221, '65.51.15593504128163027', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '59.34.17.45', '2019-06-01 08:53:33', 0, 1002001015, '账号未登陆', '2019-06-01 08:53:33');
INSERT INTO `access_log` VALUES (18222, '65.53.15593504128193015', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '59.34.17.45', '2019-06-01 08:53:33', 0, 1002001015, '账号未登陆', '2019-06-01 08:53:33');
INSERT INTO `access_log` VALUES (18223, '65.46.15593504128193029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '59.34.17.45', '2019-06-01 08:53:33', 1, 1002001015, '账号未登陆', '2019-06-01 08:53:33');
INSERT INTO `access_log` VALUES (18224, '64.78.15593504157652963', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; 16 X) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '223.104.66.179', '2019-06-01 08:53:36', 186, 0, '', '2019-06-01 08:53:36');
INSERT INTO `access_log` VALUES (18225, '59.80.15593505566643511', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '221.192.178.208', '2019-06-01 08:55:57', 4, 0, '', '2019-06-01 08:55:57');
INSERT INTO `access_log` VALUES (18226, '59.79.15593505566863513', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '221.192.178.208', '2019-06-01 08:55:57', 13, 2001001000, '服务端发生异常', '2019-06-01 08:55:57');
INSERT INTO `access_log` VALUES (18227, '64.78.15593505640132965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '221.192.178.208', '2019-06-01 08:56:04', 3, 0, '', '2019-06-01 08:56:04');
INSERT INTO `access_log` VALUES (18228, '64.81.15593505642722953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '221.192.178.208', '2019-06-01 08:56:04', 2, 0, '', '2019-06-01 08:56:04');
INSERT INTO `access_log` VALUES (18229, '64.84.15593505652962963', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '221.192.178.208', '2019-06-01 08:56:05', 2, 0, '', '2019-06-01 08:56:05');
INSERT INTO `access_log` VALUES (18230, '64.76.15593505660072957', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '221.192.178.208', '2019-06-01 08:56:06', 2, 0, '', '2019-06-01 08:56:06');
INSERT INTO `access_log` VALUES (18231, '64.85.15593505664912965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '221.192.178.208', '2019-06-01 08:56:06', 2, 0, '', '2019-06-01 08:56:06');
INSERT INTO `access_log` VALUES (18232, '64.79.15593505665552951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '221.192.178.208', '2019-06-01 08:56:07', 2, 0, '', '2019-06-01 08:56:07');
INSERT INTO `access_log` VALUES (18233, '59.78.15593505674113517', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '221.192.178.208', '2019-06-01 08:56:07', 10, 2001001000, '服务端发生异常', '2019-06-01 08:56:07');
INSERT INTO `access_log` VALUES (18234, '59.73.15593505674363517', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '221.192.178.208', '2019-06-01 08:56:07', 2, 0, '', '2019-06-01 08:56:07');
INSERT INTO `access_log` VALUES (18235, '65.46.15593509907613037', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:03:11', 517, 1002001012, '访问令牌已过期', '2019-06-01 09:03:11');
INSERT INTO `access_log` VALUES (18236, '65.51.15593509907603035', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:03:11', 518, 1002001012, '访问令牌已过期', '2019-06-01 09:03:11');
INSERT INTO `access_log` VALUES (18237, '65.53.15593509907633025', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:03:11', 515, 1002001012, '访问令牌已过期', '2019-06-01 09:03:11');
INSERT INTO `access_log` VALUES (18238, '65.49.15593509944903051', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:03:14', 194, 0, '', '2019-06-01 09:03:15');
INSERT INTO `access_log` VALUES (18239, '65.47.15593509949663059', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:03:15', 10, 0, '', '2019-06-01 09:03:15');
INSERT INTO `access_log` VALUES (18240, '65.45.15593509949663051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:03:15', 9, 0, '', '2019-06-01 09:03:15');
INSERT INTO `access_log` VALUES (18241, '65.52.15593509949653025', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:03:15', 11, 0, '', '2019-06-01 09:03:15');
INSERT INTO `access_log` VALUES (18242, '59.77.15593510069533515', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:03:27', 13, 0, '', '2019-06-01 09:03:27');
INSERT INTO `access_log` VALUES (18243, '65.50.15593510119033051', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:03:32', 11, 0, '', '2019-06-01 09:03:32');
INSERT INTO `access_log` VALUES (18244, '65.54.15593510132143021', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:03:33', 65, 0, '', '2019-06-01 09:03:33');
INSERT INTO `access_log` VALUES (18245, '65.46.15593510287813039', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:03:49', 373, 0, '', '2019-06-01 09:03:49');
INSERT INTO `access_log` VALUES (18246, '62.82.15593510406863413', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:04:01', 21, 0, '', '2019-06-01 09:04:01');
INSERT INTO `access_log` VALUES (18247, '64.77.15593510440502969', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:04:04', 11, 0, '', '2019-06-01 09:04:04');
INSERT INTO `access_log` VALUES (18248, '64.79.15593510440502959', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:04:04', 13, 0, '', '2019-06-01 09:04:04');
INSERT INTO `access_log` VALUES (18249, '65.50.15593511114463053', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:11', 1, 1002001015, '账号未登陆', '2019-06-01 09:05:11');
INSERT INTO `access_log` VALUES (18250, '65.54.15593511114593023', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:11', 1, 1002001015, '账号未登陆', '2019-06-01 09:05:11');
INSERT INTO `access_log` VALUES (18251, '65.51.15593511114633039', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:11', 1, 1002001015, '账号未登陆', '2019-06-01 09:05:11');
INSERT INTO `access_log` VALUES (18252, '65.46.15593511156453041', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 09:05:16');
INSERT INTO `access_log` VALUES (18253, '65.53.15593511196593029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:20', 423, 0, '', '2019-06-01 09:05:20');
INSERT INTO `access_log` VALUES (18254, '65.49.15593511204383055', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:20', 9, 0, '', '2019-06-01 09:05:20');
INSERT INTO `access_log` VALUES (18255, '65.45.15593511204433055', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:20', 9, 0, '', '2019-06-01 09:05:20');
INSERT INTO `access_log` VALUES (18256, '65.52.15593511204453029', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:20', 7, 0, '', '2019-06-01 09:05:20');
INSERT INTO `access_log` VALUES (18257, '62.85.15593511266603415', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:27', 39, 0, '', '2019-06-01 09:05:27');
INSERT INTO `access_log` VALUES (18258, '64.85.15593511372742975', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:37', 15, 0, '', '2019-06-01 09:05:37');
INSERT INTO `access_log` VALUES (18259, '64.77.15593511372902971', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:37', 10, 0, '', '2019-06-01 09:05:37');
INSERT INTO `access_log` VALUES (18260, '64.83.15593511418932965', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:42', 9, 0, '', '2019-06-01 09:05:42');
INSERT INTO `access_log` VALUES (18261, '64.79.15593511418892961', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:42', 13, 0, '', '2019-06-01 09:05:42');
INSERT INTO `access_log` VALUES (18262, '64.81.15593511493422965', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:49', 11, 0, '', '2019-06-01 09:05:49');
INSERT INTO `access_log` VALUES (18263, '64.84.15593511493422975', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:49', 10, 0, '', '2019-06-01 09:05:49');
INSERT INTO `access_log` VALUES (18264, '64.80.15593511493382965', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:05:49', 17, 0, '', '2019-06-01 09:05:49');
INSERT INTO `access_log` VALUES (18265, '65.50.15593511670123055', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:06:07', 523, 0, '', '2019-06-01 09:06:08');
INSERT INTO `access_log` VALUES (18266, '66.48.15593511765552393', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:06:17', 18, 0, '', '2019-06-01 09:06:17');
INSERT INTO `access_log` VALUES (18267, '66.51.15593511796302387', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:06:20', 16, 0, '', '2019-06-01 09:06:20');
INSERT INTO `access_log` VALUES (18268, '59.79.15593511845563523', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:06:25', 13, 0, '', '2019-06-01 09:06:25');
INSERT INTO `access_log` VALUES (18269, '64.85.15593511910882977', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=嘻嘻&sellPoint=aa&cid=783&visible=true&picUrls=http://static.shop.iocoder.cn/9de08760-67fb-40ee-9499-a547a5b89387&skuStr=[{\"attrs\":[29,3],\"price\":1000,\"quantity\":100},{\"attrs\":[29,3],\"price\":1100,\"quantity\":110},{\"attrs\":[29,3],\"price\":1200,\"quantity\":120},{\"attrs\":[28,3],\"price\":1300,\"quantity\":130},{\"attrs\":[28,4],\"price\":1400,\"quantity\":140},{\"attrs\":[28,4],\"price\":1500,\"quantity\":150},{\"attrs\":[31,4],\"price\":1600,\"quantity\":160},{\"attrs\":[31,4],\"price\":1700,\"quantity\":170},{\"attrs\":[31,39],\"price\":1800,\"quantity\":180},{\"attrs\":[34,39],\"price\":1900,\"quantity\":190},{\"attrs\":[34,39],\"price\":2000,\"quantity\":200},{\"attrs\":[34,39],\"price\":2100,\"quantity\":210}]&description=<p>aaaaaaaa</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.159.203', '2019-06-01 09:06:31', 7, 1002002009, NULL, '2019-06-01 09:06:31');
INSERT INTO `access_log` VALUES (18270, '59.80.15593511928383521', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:06:33', 23, 2001001000, '服务端发生异常', '2019-06-01 09:06:33');
INSERT INTO `access_log` VALUES (18271, '59.78.15593511985973525', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:06:39', 13, 0, '', '2019-06-01 09:06:39');
INSERT INTO `access_log` VALUES (18272, '64.83.15593512007552967', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:06:41', 11, 0, '', '2019-06-01 09:06:41');
INSERT INTO `access_log` VALUES (18273, '64.79.15593512046982963', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:06:45', 8, 0, '', '2019-06-01 09:06:45');
INSERT INTO `access_log` VALUES (18274, '59.73.15593512077063527', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:06:48', 13, 0, '', '2019-06-01 09:06:48');
INSERT INTO `access_log` VALUES (18275, '59.75.15593512150543523', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:06:55', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-01 09:06:55');
INSERT INTO `access_log` VALUES (18276, '65.45.15593512189893057', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:06:59', 25, 0, '', '2019-06-01 09:06:59');
INSERT INTO `access_log` VALUES (18277, '65.49.15593512200983057', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:07:00', 10, 0, '', '2019-06-01 09:07:00');
INSERT INTO `access_log` VALUES (18278, '65.47.15593512245033065', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:07:05', 12, 0, '', '2019-06-01 09:07:05');
INSERT INTO `access_log` VALUES (18279, '65.48.15593512281893053', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:07:08', 9, 0, '', '2019-06-01 09:07:08');
INSERT INTO `access_log` VALUES (18280, '65.51.15593512475053043', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:07:28', 14, 0, '', '2019-06-01 09:07:28');
INSERT INTO `access_log` VALUES (18281, '59.80.15593512813213523', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:08:01', 3, 0, '', '2019-06-01 09:08:01');
INSERT INTO `access_log` VALUES (18282, '59.72.15593512813233521', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:08:01', 10, 2001001000, '服务端发生异常', '2019-06-01 09:08:01');
INSERT INTO `access_log` VALUES (18283, '64.76.15593512849602969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:08:05', 4, 0, '', '2019-06-01 09:08:05');
INSERT INTO `access_log` VALUES (18284, '64.85.15593512850792979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '182.89.96.226', '2019-06-01 09:08:05', 2, 0, '', '2019-06-01 09:08:05');
INSERT INTO `access_log` VALUES (18285, '59.73.15593512961873529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.89.96.226', '2019-06-01 09:08:16', 3, 0, '', '2019-06-01 09:08:16');
INSERT INTO `access_log` VALUES (18286, '59.74.15593512961873523', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.89.96.226', '2019-06-01 09:08:16', 14, 2001001000, '服务端发生异常', '2019-06-01 09:08:16');
INSERT INTO `access_log` VALUES (18287, '64.83.15593512993862969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.89.96.226', '2019-06-01 09:08:19', 3, 0, '', '2019-06-01 09:08:19');
INSERT INTO `access_log` VALUES (18288, '64.79.15593512995222965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.89.96.226', '2019-06-01 09:08:20', 2, 0, '', '2019-06-01 09:08:20');
INSERT INTO `access_log` VALUES (18289, '64.80.15593513007682969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.89.96.226', '2019-06-01 09:08:21', 3, 0, '', '2019-06-01 09:08:21');
INSERT INTO `access_log` VALUES (18290, '64.81.15593513015982969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.89.96.226', '2019-06-01 09:08:22', 3, 0, '', '2019-06-01 09:08:22');
INSERT INTO `access_log` VALUES (18291, '64.82.15593513185292981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.89.96.226', '2019-06-01 09:08:39', 2, 0, '', '2019-06-01 09:08:39');
INSERT INTO `access_log` VALUES (18292, '64.76.15593513186632971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.89.96.226', '2019-06-01 09:08:39', 2, 0, '', '2019-06-01 09:08:39');
INSERT INTO `access_log` VALUES (18293, '65.53.15593514116733035', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:10:12', 0, 1002001015, '账号未登陆', '2019-06-01 09:10:12');
INSERT INTO `access_log` VALUES (18294, '65.52.15593514116833035', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:10:12', 0, 1002001015, '账号未登陆', '2019-06-01 09:10:12');
INSERT INTO `access_log` VALUES (18295, '65.45.15593514116943061', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:10:12', 0, 1002001015, '账号未登陆', '2019-06-01 09:10:12');
INSERT INTO `access_log` VALUES (18296, '65.49.15593514136993061', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:10:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 09:10:14');
INSERT INTO `access_log` VALUES (18297, '59.73.15593514243333531', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.25.172.106', '2019-06-01 09:10:24', 4, 0, '', '2019-06-01 09:10:24');
INSERT INTO `access_log` VALUES (18298, '59.75.15593514243413527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.25.172.106', '2019-06-01 09:10:24', 13, 2001001000, '服务端发生异常', '2019-06-01 09:10:24');
INSERT INTO `access_log` VALUES (18299, '64.78.15593514280172981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.25.172.106', '2019-06-01 09:10:28', 125, 0, '', '2019-06-01 09:10:28');
INSERT INTO `access_log` VALUES (18300, '64.82.15593514282562983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.25.172.106', '2019-06-01 09:10:28', 2, 0, '', '2019-06-01 09:10:28');
INSERT INTO `access_log` VALUES (18301, '64.76.15593514295942973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.25.172.106', '2019-06-01 09:10:30', 2, 0, '', '2019-06-01 09:10:30');
INSERT INTO `access_log` VALUES (18302, '64.85.15593514301202983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.25.172.106', '2019-06-01 09:10:30', 2, 0, '', '2019-06-01 09:10:30');
INSERT INTO `access_log` VALUES (18303, '64.77.15593514305142979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.25.172.106', '2019-06-01 09:10:31', 2, 0, '', '2019-06-01 09:10:31');
INSERT INTO `access_log` VALUES (18304, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.25.172.106', '2019-06-01 09:10:32', 17, 0, '', '2019-06-01 09:10:32');
INSERT INTO `access_log` VALUES (18305, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.25.172.106', '2019-06-01 09:10:32', 6, 0, '', '2019-06-01 09:10:32');
INSERT INTO `access_log` VALUES (18306, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.25.172.106', '2019-06-01 09:10:32', 18, 0, '', '2019-06-01 09:10:32');
INSERT INTO `access_log` VALUES (18307, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.25.172.106', '2019-06-01 09:10:32', 16, 0, '', '2019-06-01 09:10:32');
INSERT INTO `access_log` VALUES (18308, '64.83.15593514336352973', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.25.172.106', '2019-06-01 09:10:34', 8, 0, '', '2019-06-01 09:10:34');
INSERT INTO `access_log` VALUES (18309, '65.48.15593514356243057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:10:36', 121, 0, '', '2019-06-01 09:10:36');
INSERT INTO `access_log` VALUES (18310, '65.50.15593514360723061', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:10:36', 8, 0, '', '2019-06-01 09:10:36');
INSERT INTO `access_log` VALUES (18311, '65.54.15593514360723031', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:10:36', 8, 0, '', '2019-06-01 09:10:36');
INSERT INTO `access_log` VALUES (18312, '65.51.15593514360803047', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:10:36', 7, 0, '', '2019-06-01 09:10:36');
INSERT INTO `access_log` VALUES (18313, '62.87.15593514447703419', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:10:45', 14, 0, '', '2019-06-01 09:10:45');
INSERT INTO `access_log` VALUES (18314, '64.80.15593514531932973', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:10:53', 11, 0, '', '2019-06-01 09:10:53');
INSERT INTO `access_log` VALUES (18315, '64.81.15593514531982973', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:10:53', 9, 0, '', '2019-06-01 09:10:53');
INSERT INTO `access_log` VALUES (18316, '59.76.15593514620683525', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.217.58.2', '2019-06-01 09:11:02', 3, 0, '', '2019-06-01 09:11:02');
INSERT INTO `access_log` VALUES (18317, '59.79.15593514620683529', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.217.58.2', '2019-06-01 09:11:02', 13, 2001001000, '服务端发生异常', '2019-06-01 09:11:02');
INSERT INTO `access_log` VALUES (18318, '65.53.15593514625633037', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:11:03', 20, 0, '', '2019-06-01 09:11:03');
INSERT INTO `access_log` VALUES (18319, '65.45.15593514656553063', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:11:06', 10, 0, '', '2019-06-01 09:11:06');
INSERT INTO `access_log` VALUES (18320, '65.49.15593514680743063', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:11:08', 9, 0, '', '2019-06-01 09:11:08');
INSERT INTO `access_log` VALUES (18321, '65.48.15593514733023059', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-01 09:11:13', 703, 0, '', '2019-06-01 09:11:14');
INSERT INTO `access_log` VALUES (18322, '64.82.15593514781712985', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.217.58.2', '2019-06-01 09:11:18', 3, 0, '', '2019-06-01 09:11:18');
INSERT INTO `access_log` VALUES (18323, '64.76.15593514789012975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.217.58.2', '2019-06-01 09:11:19', 3, 0, '', '2019-06-01 09:11:19');
INSERT INTO `access_log` VALUES (18324, '64.85.15593514802792985', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.217.58.2', '2019-06-01 09:11:20', 90, 0, '', '2019-06-01 09:11:20');
INSERT INTO `access_log` VALUES (18325, '59.75.15593516874173531', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.157.196.77', '2019-06-01 09:14:47', 4, 0, '', '2019-06-01 09:14:47');
INSERT INTO `access_log` VALUES (18326, '59.77.15593516874173527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.157.196.77', '2019-06-01 09:14:47', 11, 2001001000, '服务端发生异常', '2019-06-01 09:14:47');
INSERT INTO `access_log` VALUES (18327, '65.54.15593517856773037', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.18.125', '2019-06-01 09:16:26', 1, 1002001015, '账号未登陆', '2019-06-01 09:16:26');
INSERT INTO `access_log` VALUES (18328, '65.50.15593517856873067', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.18.125', '2019-06-01 09:16:26', 0, 1002001015, '账号未登陆', '2019-06-01 09:16:26');
INSERT INTO `access_log` VALUES (18329, '65.46.15593517856943055', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.18.125', '2019-06-01 09:16:26', 0, 1002001015, '账号未登陆', '2019-06-01 09:16:26');
INSERT INTO `access_log` VALUES (18330, '65.52.15593517890643043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.18.125', '2019-06-01 09:16:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 09:16:29');
INSERT INTO `access_log` VALUES (18331, '65.45.15593518001243069', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.18.125', '2019-06-01 09:16:40', 53, 0, '', '2019-06-01 09:16:40');
INSERT INTO `access_log` VALUES (18332, '65.49.15593518007733069', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.18.125', '2019-06-01 09:16:41', 9, 0, '', '2019-06-01 09:16:41');
INSERT INTO `access_log` VALUES (18333, '65.47.15593518007833077', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.18.125', '2019-06-01 09:16:41', 9, 0, '', '2019-06-01 09:16:41');
INSERT INTO `access_log` VALUES (18334, '65.48.15593518007903065', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.18.125', '2019-06-01 09:16:41', 9, 0, '', '2019-06-01 09:16:41');
INSERT INTO `access_log` VALUES (18335, '62.85.15593518040253425', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.18.125', '2019-06-01 09:16:44', 14, 0, '', '2019-06-01 09:16:44');
INSERT INTO `access_log` VALUES (18336, '64.79.15593518100802975', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.18.125', '2019-06-01 09:16:50', 13, 0, '', '2019-06-01 09:16:50');
INSERT INTO `access_log` VALUES (18337, '64.84.15593518100922989', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.18.125', '2019-06-01 09:16:50', 9, 0, '', '2019-06-01 09:16:50');
INSERT INTO `access_log` VALUES (18338, '64.81.15593518138112979', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.18.125', '2019-06-01 09:16:54', 13, 0, '', '2019-06-01 09:16:54');
INSERT INTO `access_log` VALUES (18339, '64.78.15593518138192989', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.18.125', '2019-06-01 09:16:54', 8, 0, '', '2019-06-01 09:16:54');
INSERT INTO `access_log` VALUES (18340, '59.79.15593518667193535', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.204.33.9', '2019-06-01 09:17:47', 3, 0, '', '2019-06-01 09:17:47');
INSERT INTO `access_log` VALUES (18341, '59.72.15593518667283531', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.204.33.9', '2019-06-01 09:17:47', 13, 2001001000, '服务端发生异常', '2019-06-01 09:17:47');
INSERT INTO `access_log` VALUES (18342, '64.83.15593518720252981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.204.33.9', '2019-06-01 09:17:52', 2, 0, '', '2019-06-01 09:17:52');
INSERT INTO `access_log` VALUES (18343, '64.79.15593518721252977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.204.33.9', '2019-06-01 09:17:52', 2, 0, '', '2019-06-01 09:17:52');
INSERT INTO `access_log` VALUES (18344, '64.84.15593518762062991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.204.33.9', '2019-06-01 09:17:56', 2, 0, '', '2019-06-01 09:17:56');
INSERT INTO `access_log` VALUES (18345, '64.80.15593518763392981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.204.33.9', '2019-06-01 09:17:56', 2, 0, '', '2019-06-01 09:17:56');
INSERT INTO `access_log` VALUES (18346, '64.78.15593518773242991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.204.33.9', '2019-06-01 09:17:57', 3, 0, '', '2019-06-01 09:17:57');
INSERT INTO `access_log` VALUES (18347, '64.81.15593518781992981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.204.33.9', '2019-06-01 09:17:58', 2, 0, '', '2019-06-01 09:17:58');
INSERT INTO `access_log` VALUES (18348, '59.74.15593518793993533', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.204.33.9', '2019-06-01 09:17:59', 3, 0, '', '2019-06-01 09:17:59');
INSERT INTO `access_log` VALUES (18349, '59.78.15593518793983537', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.204.33.9', '2019-06-01 09:17:59', 14, 2001001000, '服务端发生异常', '2019-06-01 09:17:59');
INSERT INTO `access_log` VALUES (18350, '59.77.15593519103393531', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '110.88.209.211', '2019-06-01 09:18:30', 3, 0, '', '2019-06-01 09:18:30');
INSERT INTO `access_log` VALUES (18351, '59.71.15593519103403539', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '110.88.209.211', '2019-06-01 09:18:30', 13, 2001001000, '服务端发生异常', '2019-06-01 09:18:30');
INSERT INTO `access_log` VALUES (18352, '64.85.15593519139352993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '110.88.209.211', '2019-06-01 09:18:34', 3, 0, '', '2019-06-01 09:18:34');
INSERT INTO `access_log` VALUES (18353, '64.77.15593519142062989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '110.88.209.211', '2019-06-01 09:18:34', 2, 0, '', '2019-06-01 09:18:34');
INSERT INTO `access_log` VALUES (18354, '64.79.15593519202272979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '110.88.209.211', '2019-06-01 09:18:40', 2, 0, '', '2019-06-01 09:18:40');
INSERT INTO `access_log` VALUES (18355, '64.84.15593519203722993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '110.88.209.211', '2019-06-01 09:18:40', 2, 0, '', '2019-06-01 09:18:40');
INSERT INTO `access_log` VALUES (18356, '59.79.15593519219863537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '110.88.209.211', '2019-06-01 09:18:42', 3, 0, '', '2019-06-01 09:18:42');
INSERT INTO `access_log` VALUES (18357, '59.72.15593519219863533', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '110.88.209.211', '2019-06-01 09:18:42', 14, 2001001000, '服务端发生异常', '2019-06-01 09:18:42');
INSERT INTO `access_log` VALUES (18358, '65.48.15593519341513067', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '110.88.209.211', '2019-06-01 09:18:54', 1, 1002001015, '账号未登陆', '2019-06-01 09:18:54');
INSERT INTO `access_log` VALUES (18359, '65.51.15593519341523057', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '110.88.209.211', '2019-06-01 09:18:54', 0, 1002001015, '账号未登陆', '2019-06-01 09:18:54');
INSERT INTO `access_log` VALUES (18360, '65.46.15593519341543059', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '110.88.209.211', '2019-06-01 09:18:54', 0, 1002001015, '账号未登陆', '2019-06-01 09:18:54');
INSERT INTO `access_log` VALUES (18361, '65.50.15593519374763071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '110.88.209.211', '2019-06-01 09:18:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 09:18:57');
INSERT INTO `access_log` VALUES (18362, '65.54.15593519428283041', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '110.88.209.211', '2019-06-01 09:19:03', 77, 0, '', '2019-06-01 09:19:03');
INSERT INTO `access_log` VALUES (18363, '65.53.15593519537963047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '110.88.209.211', '2019-06-01 09:19:14', 467, 0, '', '2019-06-01 09:19:14');
INSERT INTO `access_log` VALUES (18364, '65.54.15593522049863045', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:23:25', 0, 1002001015, '账号未登陆', '2019-06-01 09:23:25');
INSERT INTO `access_log` VALUES (18365, '65.46.15593522049873063', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:23:25', 1, 1002001015, '账号未登陆', '2019-06-01 09:23:25');
INSERT INTO `access_log` VALUES (18366, '65.47.15593522049923087', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:23:25', 0, 1002001015, '账号未登陆', '2019-06-01 09:23:25');
INSERT INTO `access_log` VALUES (18367, '65.45.15593522069563077', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:23:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 09:23:27');
INSERT INTO `access_log` VALUES (18368, '65.52.15593522138243053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:23:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 09:23:34');
INSERT INTO `access_log` VALUES (18369, '65.49.15593522292043079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:23:49', 260, 0, '', '2019-06-01 09:23:49');
INSERT INTO `access_log` VALUES (18370, '65.48.15593522297923071', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:23:50', 9, 0, '', '2019-06-01 09:23:50');
INSERT INTO `access_log` VALUES (18371, '65.53.15593522297983053', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:23:50', 8, 0, '', '2019-06-01 09:23:50');
INSERT INTO `access_log` VALUES (18372, '65.51.15593522298033063', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:23:50', 8, 0, '', '2019-06-01 09:23:50');
INSERT INTO `access_log` VALUES (18373, '62.85.15593522372013431', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:23:57', 14, 0, '', '2019-06-01 09:23:57');
INSERT INTO `access_log` VALUES (18374, '64.81.15593522450152987', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:05', 10, 0, '', '2019-06-01 09:24:05');
INSERT INTO `access_log` VALUES (18375, '64.78.15593522450142997', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:05', 12, 0, '', '2019-06-01 09:24:05');
INSERT INTO `access_log` VALUES (18376, '66.53.15593522703732407', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:30', 16, 0, '', '2019-06-01 09:24:30');
INSERT INTO `access_log` VALUES (18377, '59.73.15593522731493545', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:33', 78, 0, '', '2019-06-01 09:24:33');
INSERT INTO `access_log` VALUES (18378, '59.77.15593522783953537', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:38', 21, 2001001000, '服务端发生异常', '2019-06-01 09:24:38');
INSERT INTO `access_log` VALUES (18379, '65.50.15593522844533081', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:44', 197, 0, '', '2019-06-01 09:24:45');
INSERT INTO `access_log` VALUES (18380, '65.49.15593522844543081', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:44', 196, 0, '', '2019-06-01 09:24:45');
INSERT INTO `access_log` VALUES (18381, '65.52.15593522844493055', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:44', 207, 0, '', '2019-06-01 09:24:45');
INSERT INTO `access_log` VALUES (18382, '59.71.15593522845313545', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:45', 127, 2001001000, '服务端发生异常', '2019-06-01 09:24:45');
INSERT INTO `access_log` VALUES (18383, '65.51.15593522883213065', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:48', 9, 0, '', '2019-06-01 09:24:48');
INSERT INTO `access_log` VALUES (18384, '65.48.15593522883213073', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:48', 10, 0, '', '2019-06-01 09:24:48');
INSERT INTO `access_log` VALUES (18385, '65.53.15593522883263055', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:48', 9, 0, '', '2019-06-01 09:24:48');
INSERT INTO `access_log` VALUES (18386, '59.76.15593522883723539', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:48', 20, 2001001000, '服务端发生异常', '2019-06-01 09:24:48');
INSERT INTO `access_log` VALUES (18387, '59.72.15593522962463539', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:56', 3, 0, '', '2019-06-01 09:24:56');
INSERT INTO `access_log` VALUES (18388, '59.80.15593522962473541', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '218.83.48.70', '2019-06-01 09:24:56', 10, 2001001000, '服务端发生异常', '2019-06-01 09:24:56');
INSERT INTO `access_log` VALUES (18389, '59.80.15593525878603545', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.191.94.118', '2019-06-01 09:29:48', 4, 0, '', '2019-06-01 09:29:48');
INSERT INTO `access_log` VALUES (18390, '59.74.15593525878613545', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.191.94.118', '2019-06-01 09:29:48', 13, 2001001000, '服务端发生异常', '2019-06-01 09:29:48');
INSERT INTO `access_log` VALUES (18391, '64.83.15593525948902993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.191.94.118', '2019-06-01 09:29:55', 138, 0, '', '2019-06-01 09:29:55');
INSERT INTO `access_log` VALUES (18392, '64.79.15593525951772989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.191.94.118', '2019-06-01 09:29:55', 3, 0, '', '2019-06-01 09:29:55');
INSERT INTO `access_log` VALUES (18393, '59.73.15593525970013551', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.191.94.118', '2019-06-01 09:29:57', 6, 0, '', '2019-06-01 09:29:57');
INSERT INTO `access_log` VALUES (18394, '59.75.15593525970033547', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.191.94.118', '2019-06-01 09:29:57', 13, 2001001000, '服务端发生异常', '2019-06-01 09:29:57');
INSERT INTO `access_log` VALUES (18395, '64.84.15593525984473003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.191.94.118', '2019-06-01 09:29:58', 3, 0, '', '2019-06-01 09:29:58');
INSERT INTO `access_log` VALUES (18396, '64.80.15593525985612993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.191.94.118', '2019-06-01 09:29:59', 2, 0, '', '2019-06-01 09:29:59');
INSERT INTO `access_log` VALUES (18397, '59.77.15593525995823543', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.191.94.118', '2019-06-01 09:30:00', 4, 0, '', '2019-06-01 09:30:00');
INSERT INTO `access_log` VALUES (18398, '59.71.15593525995843551', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '60.191.94.118', '2019-06-01 09:30:00', 19, 2001001000, '服务端发生异常', '2019-06-01 09:30:00');
INSERT INTO `access_log` VALUES (18399, '59.80.15593526390073547', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.192.8.167', '2019-06-01 09:30:39', 11, 0, '', '2019-06-01 09:30:39');
INSERT INTO `access_log` VALUES (18400, '59.74.15593526390073547', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.192.8.167', '2019-06-01 09:30:39', 21, 2001001000, '服务端发生异常', '2019-06-01 09:30:39');
INSERT INTO `access_log` VALUES (18401, '64.76.15593526419152995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.192.8.167', '2019-06-01 09:30:42', 2, 0, '', '2019-06-01 09:30:42');
INSERT INTO `access_log` VALUES (18402, '64.85.15593526420343005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.192.8.167', '2019-06-01 09:30:42', 2, 0, '', '2019-06-01 09:30:42');
INSERT INTO `access_log` VALUES (18403, '64.77.15593526452513001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.192.8.167', '2019-06-01 09:30:45', 3, 0, '', '2019-06-01 09:30:45');
INSERT INTO `access_log` VALUES (18404, '64.83.15593526453542995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.192.8.167', '2019-06-01 09:30:45', 2, 0, '', '2019-06-01 09:30:45');
INSERT INTO `access_log` VALUES (18405, '59.73.15593534536873565', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '58.240.83.67', '2019-06-01 09:44:14', 4, 0, '', '2019-06-01 09:44:14');
INSERT INTO `access_log` VALUES (18406, '59.79.15593534536873561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '58.240.83.67', '2019-06-01 09:44:14', 13, 2001001000, '服务端发生异常', '2019-06-01 09:44:14');
INSERT INTO `access_log` VALUES (18407, '65.51.15593536110223085', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '58.240.83.67', '2019-06-01 09:46:51', 1, 1002001015, '账号未登陆', '2019-06-01 09:46:51');
INSERT INTO `access_log` VALUES (18408, '65.53.15593536110233073', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '58.240.83.67', '2019-06-01 09:46:51', 1, 1002001015, '账号未登陆', '2019-06-01 09:46:51');
INSERT INTO `access_log` VALUES (18409, '65.49.15593536110403099', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '58.240.83.67', '2019-06-01 09:46:51', 1, 1002001015, '账号未登陆', '2019-06-01 09:46:51');
INSERT INTO `access_log` VALUES (18410, '65.54.15593536171573067', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '58.240.83.67', '2019-06-01 09:46:57', 78, 0, '', '2019-06-01 09:46:57');
INSERT INTO `access_log` VALUES (18411, '65.47.15593536178083109', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '58.240.83.67', '2019-06-01 09:46:58', 1553, 0, '', '2019-06-01 09:46:59');
INSERT INTO `access_log` VALUES (18412, '65.48.15593536178143095', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '58.240.83.67', '2019-06-01 09:46:58', 1549, 0, '', '2019-06-01 09:46:59');
INSERT INTO `access_log` VALUES (18413, '65.45.15593536178293101', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '58.240.83.67', '2019-06-01 09:46:58', 1532, 0, '', '2019-06-01 09:46:59');
INSERT INTO `access_log` VALUES (18414, '62.82.15593536336713455', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '58.240.83.67', '2019-06-01 09:47:14', 12, 0, '', '2019-06-01 09:47:14');
INSERT INTO `access_log` VALUES (18415, '65.53.15593536489663075', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '58.240.83.67', '2019-06-01 09:47:29', 20, 0, '', '2019-06-01 09:47:29');
INSERT INTO `access_log` VALUES (18416, '65.51.15593538182963089', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:50:18', 1, 1002001015, '账号未登陆', '2019-06-01 09:50:18');
INSERT INTO `access_log` VALUES (18417, '65.46.15593538183413089', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:50:18', 0, 1002001015, '账号未登陆', '2019-06-01 09:50:18');
INSERT INTO `access_log` VALUES (18418, '65.54.15593538183563071', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:50:18', 0, 1002001015, '账号未登陆', '2019-06-01 09:50:18');
INSERT INTO `access_log` VALUES (18419, '65.48.15593538253823099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:50:25', 77, 0, '', '2019-06-01 09:50:25');
INSERT INTO `access_log` VALUES (18420, '65.45.15593538257163105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:50:26', 9, 0, '', '2019-06-01 09:50:26');
INSERT INTO `access_log` VALUES (18421, '65.50.15593538257293105', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:50:26', 9, 0, '', '2019-06-01 09:50:26');
INSERT INTO `access_log` VALUES (18422, '65.52.15593538257383081', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:50:26', 9, 0, '', '2019-06-01 09:50:26');
INSERT INTO `access_log` VALUES (18423, '62.89.15593538334853453', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:50:33', 14, 0, '', '2019-06-01 09:50:34');
INSERT INTO `access_log` VALUES (18424, '62.84.15593538379503449', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:50:38', 17, 0, '', '2019-06-01 09:50:38');
INSERT INTO `access_log` VALUES (18425, '64.83.15593538474293011', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:50:47', 11, 0, '', '2019-06-01 09:50:47');
INSERT INTO `access_log` VALUES (18426, '64.79.15593538474293009', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:50:47', 13, 0, '', '2019-06-01 09:50:47');
INSERT INTO `access_log` VALUES (18427, '64.78.15593538968063023', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=黑色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:51:37', 8, 1002002009, NULL, '2019-06-01 09:51:37');
INSERT INTO `access_log` VALUES (18428, '65.53.15593539873843081', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:53:07', 19, 0, '', '2019-06-01 09:53:07');
INSERT INTO `access_log` VALUES (18429, '65.51.15593539930773093', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.69.11.110', '2019-06-01 09:53:13', 1, 1002001015, '账号未登陆', '2019-06-01 09:53:13');
INSERT INTO `access_log` VALUES (18430, '65.46.15593539930823093', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.69.11.110', '2019-06-01 09:53:13', 0, 1002001015, '账号未登陆', '2019-06-01 09:53:13');
INSERT INTO `access_log` VALUES (18431, '65.54.15593539931143075', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.69.11.110', '2019-06-01 09:53:13', 1, 1002001015, '账号未登陆', '2019-06-01 09:53:13');
INSERT INTO `access_log` VALUES (18432, '65.50.15593540016043109', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:53:22', 11, 0, '', '2019-06-01 09:53:22');
INSERT INTO `access_log` VALUES (18433, '65.51.15593540040433095', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:53:24', 8, 0, '', '2019-06-01 09:53:24');
INSERT INTO `access_log` VALUES (18434, '65.49.15593540111753109', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:53:31', 186, 0, '', '2019-06-01 09:53:31');
INSERT INTO `access_log` VALUES (18435, '65.54.15593540169753077', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.69.11.110', '2019-06-01 09:53:37', 94, 0, '', '2019-06-01 09:53:37');
INSERT INTO `access_log` VALUES (18436, '65.47.15593540219653117', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:53:42', 10, 0, '', '2019-06-01 09:53:42');
INSERT INTO `access_log` VALUES (18437, '65.53.15593540246243083', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.69.11.110', '2019-06-01 09:53:45', 99, 0, '', '2019-06-01 09:53:45');
INSERT INTO `access_log` VALUES (18438, '65.48.15593540357343105', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:53:56', 19, 0, '', '2019-06-01 09:53:56');
INSERT INTO `access_log` VALUES (18439, '65.51.15593540685253097', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.69.11.110', '2019-06-01 09:54:29', 53, 0, '', '2019-06-01 09:54:29');
INSERT INTO `access_log` VALUES (18440, '65.49.15593540685843111', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:54:29', 10, 0, '', '2019-06-01 09:54:29');
INSERT INTO `access_log` VALUES (18441, '65.54.15593540689213079', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.69.11.110', '2019-06-01 09:54:29', 10, 0, '', '2019-06-01 09:54:29');
INSERT INTO `access_log` VALUES (18442, '65.46.15593540689283097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.69.11.110', '2019-06-01 09:54:29', 9, 0, '', '2019-06-01 09:54:29');
INSERT INTO `access_log` VALUES (18443, '65.47.15593540689293119', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.69.11.110', '2019-06-01 09:54:29', 10, 0, '', '2019-06-01 09:54:29');
INSERT INTO `access_log` VALUES (18444, '62.88.15593540736813459', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.69.11.110', '2019-06-01 09:54:34', 14, 0, '', '2019-06-01 09:54:34');
INSERT INTO `access_log` VALUES (18445, '64.79.15593540804993013', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.69.11.110', '2019-06-01 09:54:41', 87, 0, '', '2019-06-01 09:54:41');
INSERT INTO `access_log` VALUES (18446, '64.76.15593540804963015', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.69.11.110', '2019-06-01 09:54:40', 91, 0, '', '2019-06-01 09:54:41');
INSERT INTO `access_log` VALUES (18447, '65.45.15593540803643113', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 09:54:40', 226, 0, '', '2019-06-01 09:54:41');
INSERT INTO `access_log` VALUES (18448, '64.83.15593540882503015', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.69.11.110', '2019-06-01 09:54:48', 10, 0, '', '2019-06-01 09:54:48');
INSERT INTO `access_log` VALUES (18449, '64.84.15593540924503025', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.69.11.110', '2019-06-01 09:54:52', 15, 0, '', '2019-06-01 09:54:52');
INSERT INTO `access_log` VALUES (18450, '65.52.15593541129683089', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:13', 1, 1002001015, '账号未登陆', '2019-06-01 09:55:13');
INSERT INTO `access_log` VALUES (18451, '65.51.15593541129713099', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:13', 0, 1002001015, '账号未登陆', '2019-06-01 09:55:13');
INSERT INTO `access_log` VALUES (18452, '65.49.15593541129733113', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:13', 0, 1002001015, '账号未登陆', '2019-06-01 09:55:13');
INSERT INTO `access_log` VALUES (18453, '64.81.15593541133903017', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:13', 1, 1002001015, '账号未登陆', '2019-06-01 09:55:13');
INSERT INTO `access_log` VALUES (18454, '64.78.15593541133933027', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:13', 0, 1002001015, '账号未登陆', '2019-06-01 09:55:13');
INSERT INTO `access_log` VALUES (18455, '65.54.15593541201733081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:20', 97, 0, '', '2019-06-01 09:55:20');
INSERT INTO `access_log` VALUES (18456, '65.46.15593541206343099', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:21', 10, 0, '', '2019-06-01 09:55:21');
INSERT INTO `access_log` VALUES (18457, '65.47.15593541206393121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:21', 8, 0, '', '2019-06-01 09:55:21');
INSERT INTO `access_log` VALUES (18458, '65.53.15593541206473087', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:21', 8, 0, '', '2019-06-01 09:55:21');
INSERT INTO `access_log` VALUES (18459, '65.48.15593541256433109', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:26', 19, 0, '', '2019-06-01 09:55:26');
INSERT INTO `access_log` VALUES (18460, '65.50.15593541281703115', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:28', 11, 0, '', '2019-06-01 09:55:28');
INSERT INTO `access_log` VALUES (18461, '65.52.15593541339013091', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:34', 10, 0, '', '2019-06-01 09:55:34');
INSERT INTO `access_log` VALUES (18462, '65.49.15593541362883115', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:36', 10, 0, '', '2019-06-01 09:55:36');
INSERT INTO `access_log` VALUES (18463, '65.54.15593541491833083', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:49', 14, 0, '', '2019-06-01 09:55:49');
INSERT INTO `access_log` VALUES (18464, '65.47.15593541584863123', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:55:58', 8, 0, '', '2019-06-01 09:55:58');
INSERT INTO `access_log` VALUES (18465, '65.53.15593541607533089', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:56:01', 12, 0, '', '2019-06-01 09:56:01');
INSERT INTO `access_log` VALUES (18466, '59.79.15593541835453571', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:56:24', 13, 0, '', '2019-06-01 09:56:24');
INSERT INTO `access_log` VALUES (18467, '66.53.15593542067602433', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:56:47', 22, 0, '', '2019-06-01 09:56:47');
INSERT INTO `access_log` VALUES (18468, '65.49.15593542150553117', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:56:55', 0, 1002001015, '账号未登陆', '2019-06-01 09:56:55');
INSERT INTO `access_log` VALUES (18469, '65.51.15593542150603103', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:56:55', 0, 1002001015, '账号未登陆', '2019-06-01 09:56:55');
INSERT INTO `access_log` VALUES (18470, '65.54.15593542150803085', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:56:55', 1, 1002001015, '账号未登陆', '2019-06-01 09:56:55');
INSERT INTO `access_log` VALUES (18471, '66.57.15593542155712429', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:56:56', 13, 0, '', '2019-06-01 09:56:56');
INSERT INTO `access_log` VALUES (18472, '65.46.15593542224743103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:57:02', 93, 0, '', '2019-06-01 09:57:03');
INSERT INTO `access_log` VALUES (18473, '65.47.15593542228313125', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:57:03', 8, 0, '', '2019-06-01 09:57:03');
INSERT INTO `access_log` VALUES (18474, '65.53.15593542228313091', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:57:03', 9, 0, '', '2019-06-01 09:57:03');
INSERT INTO `access_log` VALUES (18475, '65.45.15593542228523119', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:57:03', 8, 0, '', '2019-06-01 09:57:03');
INSERT INTO `access_log` VALUES (18476, '64.78.15593542317853029', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:57:12', 12, 0, '', '2019-06-01 09:57:12');
INSERT INTO `access_log` VALUES (18477, '59.75.15593542318003571', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:12', 3, 0, '', '2019-06-01 09:57:12');
INSERT INTO `access_log` VALUES (18478, '59.77.15593542318013567', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:12', 13, 2001001000, '服务端发生异常', '2019-06-01 09:57:12');
INSERT INTO `access_log` VALUES (18479, '62.84.15593542321543455', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:57:12', 14, 0, '', '2019-06-01 09:57:12');
INSERT INTO `access_log` VALUES (18480, '64.80.15593542410933019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:21', 2, 0, '', '2019-06-01 09:57:21');
INSERT INTO `access_log` VALUES (18481, '64.82.15593542412213031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:21', 3, 0, '', '2019-06-01 09:57:21');
INSERT INTO `access_log` VALUES (18482, '64.79.15593542426453017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:23', 2, 0, '', '2019-06-01 09:57:23');
INSERT INTO `access_log` VALUES (18483, '64.76.15593542433833019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:23', 2, 0, '', '2019-06-01 09:57:23');
INSERT INTO `access_log` VALUES (18484, '64.83.15593542437933019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:24', 359, 0, '', '2019-06-01 09:57:24');
INSERT INTO `access_log` VALUES (18485, '62.80.15593542438423465', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:57:24', 326, 0, '', '2019-06-01 09:57:24');
INSERT INTO `access_log` VALUES (18486, '64.84.15593542519573029', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:57:32', 9, 0, '', '2019-06-01 09:57:32');
INSERT INTO `access_log` VALUES (18487, '64.85.15593542519553031', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:57:32', 11, 0, '', '2019-06-01 09:57:32');
INSERT INTO `access_log` VALUES (18488, '62.85.15593542542073461', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:57:34', 15, 0, '', '2019-06-01 09:57:34');
INSERT INTO `access_log` VALUES (18489, '66.48.15593542553752435', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=111111111&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-06-01 09:57:35');
INSERT INTO `access_log` VALUES (18490, '64.78.15593542587773031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:39', 3, 0, '', '2019-06-01 09:57:39');
INSERT INTO `access_log` VALUES (18491, '64.81.15593542588713021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:39', 2, 0, '', '2019-06-01 09:57:39');
INSERT INTO `access_log` VALUES (18492, '62.87.15593542592453461', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 09:57:39', 12, 0, '', '2019-06-01 09:57:39');
INSERT INTO `access_log` VALUES (18493, '59.74.15593542595933569', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:40', 4, 0, '', '2019-06-01 09:57:40');
INSERT INTO `access_log` VALUES (18494, '59.73.15593542595953577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:40', 14, 2001001000, '服务端发生异常', '2019-06-01 09:57:40');
INSERT INTO `access_log` VALUES (18495, '64.82.15593542610643033', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:57:41', 9, 0, '', '2019-06-01 09:57:41');
INSERT INTO `access_log` VALUES (18496, '64.80.15593542610643021', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:57:41', 11, 0, '', '2019-06-01 09:57:41');
INSERT INTO `access_log` VALUES (18497, '64.76.15593542702163021', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:57:50', 12, 0, '', '2019-06-01 09:57:50');
INSERT INTO `access_log` VALUES (18498, '64.83.15593542702173021', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:57:50', 11, 0, '', '2019-06-01 09:57:50');
INSERT INTO `access_log` VALUES (18499, '64.79.15593542702143019', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:57:50', 19, 0, '', '2019-06-01 09:57:50');
INSERT INTO `access_log` VALUES (18500, '65.54.15593542764873087', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:56', 0, 1002001015, '账号未登陆', '2019-06-01 09:57:56');
INSERT INTO `access_log` VALUES (18501, '65.51.15593542764923105', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:56', 0, 1002001015, '账号未登陆', '2019-06-01 09:57:56');
INSERT INTO `access_log` VALUES (18502, '65.46.15593542764933105', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:57:56', 0, 1002001015, '账号未登陆', '2019-06-01 09:57:56');
INSERT INTO `access_log` VALUES (18503, '65.53.15593542800213093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:58:00', 116, 0, '', '2019-06-01 09:58:00');
INSERT INTO `access_log` VALUES (18504, '65.47.15593542808823127', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:58:01', 114, 0, '', '2019-06-01 09:58:01');
INSERT INTO `access_log` VALUES (18505, '65.48.15593542808893115', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:58:01', 109, 0, '', '2019-06-01 09:58:01');
INSERT INTO `access_log` VALUES (18506, '65.45.15593542808843121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:58:01', 114, 0, '', '2019-06-01 09:58:01');
INSERT INTO `access_log` VALUES (18507, '59.78.15593542828493575', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:58:03', 10, 0, '', '2019-06-01 09:58:03');
INSERT INTO `access_log` VALUES (18508, '59.80.15593542856043571', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:58:06', 3, 0, '', '2019-06-01 09:58:06');
INSERT INTO `access_log` VALUES (18509, '59.77.15593542856083569', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:58:06', 14, 2001001000, '服务端发生异常', '2019-06-01 09:58:06');
INSERT INTO `access_log` VALUES (18510, '62.89.15593542865043461', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:58:07', 38, 0, '', '2019-06-01 09:58:07');
INSERT INTO `access_log` VALUES (18511, '64.77.15593542893993029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:58:09', 6, 0, '', '2019-06-01 09:58:09');
INSERT INTO `access_log` VALUES (18512, '64.78.15593542895093033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:58:10', 4, 0, '', '2019-06-01 09:58:10');
INSERT INTO `access_log` VALUES (18513, '64.81.15593542910443023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:58:11', 2, 0, '', '2019-06-01 09:58:11');
INSERT INTO `access_log` VALUES (18514, '59.71.15593542913553577', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; STF-AL10 Build/HUAWEISTF-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.99 Mobile Safari/537.36', '117.30.139.26', '2019-06-01 09:58:11', 3, 0, '', '2019-06-01 09:58:11');
INSERT INTO `access_log` VALUES (18515, '59.75.15593542913553573', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; STF-AL10 Build/HUAWEISTF-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.99 Mobile Safari/537.36', '117.30.139.26', '2019-06-01 09:58:11', 11, 2001001000, '服务端发生异常', '2019-06-01 09:58:11');
INSERT INTO `access_log` VALUES (18516, '64.82.15593542915033035', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:58:12', 9, 0, '', '2019-06-01 09:58:12');
INSERT INTO `access_log` VALUES (18517, '64.80.15593542915053023', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:58:12', 6, 0, '', '2019-06-01 09:58:12');
INSERT INTO `access_log` VALUES (18518, '64.79.15593542916783021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:58:12', 2, 0, '', '2019-06-01 09:58:12');
INSERT INTO `access_log` VALUES (18519, '64.76.15593542936253023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; STF-AL10 Build/HUAWEISTF-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.99 Mobile Safari/537.36', '117.30.139.26', '2019-06-01 09:58:14', 2, 0, '', '2019-06-01 09:58:14');
INSERT INTO `access_log` VALUES (18520, '64.83.15593542937793023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; STF-AL10 Build/HUAWEISTF-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.99 Mobile Safari/537.36', '117.30.139.26', '2019-06-01 09:58:14', 2, 0, '', '2019-06-01 09:58:14');
INSERT INTO `access_log` VALUES (18521, '66.52.15593542941362429', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:58:14', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空', '2019-06-01 09:58:14');
INSERT INTO `access_log` VALUES (18522, '64.84.15593542948733033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; STF-AL10 Build/HUAWEISTF-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.99 Mobile Safari/537.36', '117.30.139.26', '2019-06-01 09:58:15', 2, 0, '', '2019-06-01 09:58:15');
INSERT INTO `access_log` VALUES (18523, '64.85.15593542953923035', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:58:15', 12, 0, '', '2019-06-01 09:58:15');
INSERT INTO `access_log` VALUES (18524, '64.77.15593542954103031', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:58:15', 9, 0, '', '2019-06-01 09:58:15');
INSERT INTO `access_log` VALUES (18525, '64.78.15593542957943035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; STF-AL10 Build/HUAWEISTF-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.99 Mobile Safari/537.36', '117.30.139.26', '2019-06-01 09:58:16', 2, 0, '', '2019-06-01 09:58:16');
INSERT INTO `access_log` VALUES (18526, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; STF-AL10 Build/HUAWEISTF-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.99 Mobile Safari/537.36', '117.30.139.26', '2019-06-01 09:58:16', 9, 0, '', '2019-06-01 09:58:16');
INSERT INTO `access_log` VALUES (18527, '64.81.15593542973093025', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 9; STF-AL10 Build/HUAWEISTF-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.99 Mobile Safari/537.36', '117.30.139.26', '2019-06-01 09:58:17', 7, 0, '', '2019-06-01 09:58:17');
INSERT INTO `access_log` VALUES (18528, '64.80.15593542981093025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:58:18', 2, 0, '', '2019-06-01 09:58:18');
INSERT INTO `access_log` VALUES (18529, '64.82.15593542982503037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:58:18', 1, 0, '', '2019-06-01 09:58:18');
INSERT INTO `access_log` VALUES (18530, '64.76.15593543040793025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; STF-AL10 Build/HUAWEISTF-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.99 Mobile Safari/537.36', '117.30.139.26', '2019-06-01 09:58:24', 3, 0, '', '2019-06-01 09:58:24');
INSERT INTO `access_log` VALUES (18531, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; STF-AL10 Build/HUAWEISTF-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.99 Mobile Safari/537.36', '117.30.139.26', '2019-06-01 09:58:24', 7, 0, '', '2019-06-01 09:58:24');
INSERT INTO `access_log` VALUES (18532, '64.83.15593543052113025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; STF-AL10 Build/HUAWEISTF-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.99 Mobile Safari/537.36', '117.30.139.26', '2019-06-01 09:58:25', 2, 0, '', '2019-06-01 09:58:25');
INSERT INTO `access_log` VALUES (18533, '64.84.15593543054413035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; STF-AL10 Build/HUAWEISTF-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.99 Mobile Safari/537.36', '117.30.139.26', '2019-06-01 09:58:25', 2, 0, '', '2019-06-01 09:58:25');
INSERT INTO `access_log` VALUES (18534, '59.74.15593543066913571', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; STF-AL10 Build/HUAWEISTF-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.99 Mobile Safari/537.36', '117.30.139.26', '2019-06-01 09:58:27', 3, 0, '', '2019-06-01 09:58:27');
INSERT INTO `access_log` VALUES (18535, '59.73.15593543066913579', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; STF-AL10 Build/HUAWEISTF-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.99 Mobile Safari/537.36', '117.30.139.26', '2019-06-01 09:58:27', 12, 2001001000, '服务端发生异常', '2019-06-01 09:58:27');
INSERT INTO `access_log` VALUES (18536, '59.78.15593543234223577', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.196', '2019-06-01 09:58:43', 12, 0, '', '2019-06-01 09:58:43');
INSERT INTO `access_log` VALUES (18537, '65.46.15593543245193107', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:58:45', 21, 0, '', '2019-06-01 09:58:45');
INSERT INTO `access_log` VALUES (18538, '65.51.15593543281953107', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:58:48', 0, 1002001015, '账号未登陆', '2019-06-01 09:58:48');
INSERT INTO `access_log` VALUES (18539, '65.54.15593543281953089', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:58:48', 0, 1002001015, '账号未登陆', '2019-06-01 09:58:48');
INSERT INTO `access_log` VALUES (18540, '65.53.15593543281983095', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:58:48', 1, 1002001015, '账号未登陆', '2019-06-01 09:58:48');
INSERT INTO `access_log` VALUES (18541, '65.48.15593543285683117', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:58:49', 10, 0, '', '2019-06-01 09:58:49');
INSERT INTO `access_log` VALUES (18542, '65.47.15593543298843129', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:58:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 09:58:50');
INSERT INTO `access_log` VALUES (18543, '65.45.15593543301053123', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:58:50', 9, 0, '', '2019-06-01 09:58:50');
INSERT INTO `access_log` VALUES (18544, '65.50.15593543322593123', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:58:52', 14, 0, '', '2019-06-01 09:58:52');
INSERT INTO `access_log` VALUES (18545, '65.49.15593543357073123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:58:56', 124, 0, '', '2019-06-01 09:58:56');
INSERT INTO `access_log` VALUES (18546, '65.46.15593543361463109', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:58:56', 8, 0, '', '2019-06-01 09:58:56');
INSERT INTO `access_log` VALUES (18547, '65.54.15593543361473091', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:58:56', 9, 0, '', '2019-06-01 09:58:56');
INSERT INTO `access_log` VALUES (18548, '65.51.15593543361493109', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:58:56', 10, 0, '', '2019-06-01 09:58:56');
INSERT INTO `access_log` VALUES (18549, '59.77.15593543388423571', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:58:59', 13, 0, '', '2019-06-01 09:58:59');
INSERT INTO `access_log` VALUES (18550, '65.53.15593543405763097', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:59:01', 16, 0, '', '2019-06-01 09:59:01');
INSERT INTO `access_log` VALUES (18551, '64.78.15593543409393037', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.51.129.198', '2019-06-01 09:59:01', 9, 0, '', '2019-06-01 09:59:01');
INSERT INTO `access_log` VALUES (18552, '65.48.15593543437653119', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:59:04', 13, 0, '', '2019-06-01 09:59:04');
INSERT INTO `access_log` VALUES (18553, '65.47.15593543467533131', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:59:07', 10, 0, '', '2019-06-01 09:59:07');
INSERT INTO `access_log` VALUES (18554, '65.50.15593543500813125', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:59:10', 253, 0, '', '2019-06-01 09:59:10');
INSERT INTO `access_log` VALUES (18555, '65.52.15593543550423101', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:59:15', 7, 0, '', '2019-06-01 09:59:15');
INSERT INTO `access_log` VALUES (18556, '65.49.15593543628703125', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:59:23', 0, 1002001015, '账号未登陆', '2019-06-01 09:59:23');
INSERT INTO `access_log` VALUES (18557, '65.46.15593543628823111', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:59:23', 1, 1002001015, '账号未登陆', '2019-06-01 09:59:23');
INSERT INTO `access_log` VALUES (18558, '65.51.15593543628823111', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:59:23', 0, 1002001015, '账号未登陆', '2019-06-01 09:59:23');
INSERT INTO `access_log` VALUES (18559, '65.53.15593543660533099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:59:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 09:59:26');
INSERT INTO `access_log` VALUES (18560, '65.48.15593543682263121', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:59:28', 11, 0, '', '2019-06-01 09:59:28');
INSERT INTO `access_log` VALUES (18561, '65.47.15593543710133133', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:59:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 09:59:31');
INSERT INTO `access_log` VALUES (18562, '65.50.15593543793563127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:59:39', 59, 0, '', '2019-06-01 09:59:39');
INSERT INTO `access_log` VALUES (18563, '65.52.15593543797083103', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:59:40', 9, 0, '', '2019-06-01 09:59:40');
INSERT INTO `access_log` VALUES (18564, '65.49.15593543797183127', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:59:40', 9, 0, '', '2019-06-01 09:59:40');
INSERT INTO `access_log` VALUES (18565, '65.51.15593543797243113', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:59:40', 8, 0, '', '2019-06-01 09:59:40');
INSERT INTO `access_log` VALUES (18566, '62.87.15593543851903463', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:59:45', 14, 0, '', '2019-06-01 09:59:45');
INSERT INTO `access_log` VALUES (18567, '62.81.15593543938903455', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:59:54', 13, 0, '', '2019-06-01 09:59:54');
INSERT INTO `access_log` VALUES (18568, '64.76.15593543972873027', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:59:57', 11, 0, '', '2019-06-01 09:59:57');
INSERT INTO `access_log` VALUES (18569, '64.83.15593543972913027', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 09:59:57', 8, 0, '', '2019-06-01 09:59:57');
INSERT INTO `access_log` VALUES (18570, '62.89.15593543983913463', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 09:59:58', 15, 0, '', '2019-06-01 09:59:58');
INSERT INTO `access_log` VALUES (18571, '64.85.15593544033473039', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:00:03', 8, 0, '', '2019-06-01 10:00:03');
INSERT INTO `access_log` VALUES (18572, '64.84.15593544033473037', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:00:03', 9, 0, '', '2019-06-01 10:00:03');
INSERT INTO `access_log` VALUES (18573, '64.81.15593544091733029', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:00:09', 9, 0, '', '2019-06-01 10:00:09');
INSERT INTO `access_log` VALUES (18574, '64.78.15593544091723039', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:00:09', 11, 0, '', '2019-06-01 10:00:09');
INSERT INTO `access_log` VALUES (18575, '64.80.15593544156093029', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:00:16', 10, 0, '', '2019-06-01 10:00:16');
INSERT INTO `access_log` VALUES (18576, '64.82.15593544160773041', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=ccc', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:00:16', 8, 1002002009, NULL, '2019-06-01 10:00:16');
INSERT INTO `access_log` VALUES (18577, '66.52.15593544284362431', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:00:28', 49, 0, '', '2019-06-01 10:00:28');
INSERT INTO `access_log` VALUES (18578, '59.78.15593544371043579', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:00:37', 63, 0, '', '2019-06-01 10:00:37');
INSERT INTO `access_log` VALUES (18579, '59.72.15593544435963573', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:00:44', 21, 2001001000, '服务端发生异常', '2019-06-01 10:00:44');
INSERT INTO `access_log` VALUES (18580, '59.77.15593544479423573', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:00:48', 12, 0, '', '2019-06-01 10:00:48');
INSERT INTO `access_log` VALUES (18581, '64.85.15593544532203041', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:00:53', 9, 0, '', '2019-06-01 10:00:53');
INSERT INTO `access_log` VALUES (18582, '64.84.15593544532203039', 1, 2, 'product-application', '/product-api/admins/spu/list', 'ids=29,32,36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:00:53', 11, 0, '', '2019-06-01 10:00:53');
INSERT INTO `access_log` VALUES (18583, '64.77.15593544645343037', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:01:05', 9, 0, '', '2019-06-01 10:01:05');
INSERT INTO `access_log` VALUES (18584, '65.53.15593544669403103', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:01:07', 20, 0, '', '2019-06-01 10:01:07');
INSERT INTO `access_log` VALUES (18585, '65.45.15593544684993129', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:01:09', 10, 0, '', '2019-06-01 10:01:09');
INSERT INTO `access_log` VALUES (18586, '65.54.15593544695273099', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:01:10', 10, 0, '', '2019-06-01 10:01:10');
INSERT INTO `access_log` VALUES (18587, '65.47.15593544707273135', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-01 10:01:11', 14, 0, '', '2019-06-01 10:01:11');
INSERT INTO `access_log` VALUES (18588, '59.80.15593545887883577', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:03:09', 13, 0, '', '2019-06-01 10:03:09');
INSERT INTO `access_log` VALUES (18589, '59.71.15593545924773583', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:03:12', 16, 2001001000, '服务端发生异常', '2019-06-01 10:03:12');
INSERT INTO `access_log` VALUES (18590, '65.47.15593545960503137', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:03:16', 19, 0, '', '2019-06-01 10:03:16');
INSERT INTO `access_log` VALUES (18591, '65.46.15593545978803117', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:03:18', 10, 0, '', '2019-06-01 10:03:18');
INSERT INTO `access_log` VALUES (18592, '64.78.15593546107763043', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:03:31', 10, 0, '', '2019-06-01 10:03:31');
INSERT INTO `access_log` VALUES (18593, '64.81.15593546107753033', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:03:31', 11, 0, '', '2019-06-01 10:03:31');
INSERT INTO `access_log` VALUES (18594, '65.45.15593546714303133', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:04:31', 0, 1002001015, '账号未登陆', '2019-06-01 10:04:31');
INSERT INTO `access_log` VALUES (18595, '65.48.15593546714363127', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:04:31', 0, 1002001015, '账号未登陆', '2019-06-01 10:04:31');
INSERT INTO `access_log` VALUES (18596, '65.54.15593546714403103', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:04:31', 0, 1002001015, '账号未登陆', '2019-06-01 10:04:31');
INSERT INTO `access_log` VALUES (18597, '65.47.15593546731763139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:04:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 10:04:33');
INSERT INTO `access_log` VALUES (18598, '65.46.15593546769323119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:04:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 10:04:37');
INSERT INTO `access_log` VALUES (18599, '65.49.15593546873843135', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:04:47', 254, 0, '', '2019-06-01 10:04:48');
INSERT INTO `access_log` VALUES (18600, '65.51.15593546878243119', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:04:48', 9, 0, '', '2019-06-01 10:04:48');
INSERT INTO `access_log` VALUES (18601, '65.52.15593546878323111', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:04:48', 10, 0, '', '2019-06-01 10:04:48');
INSERT INTO `access_log` VALUES (18602, '65.53.15593546878333109', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:04:48', 9, 0, '', '2019-06-01 10:04:48');
INSERT INTO `access_log` VALUES (18603, '62.80.15593546975033473', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:04:58', 155, 0, '', '2019-06-01 10:04:58');
INSERT INTO `access_log` VALUES (18604, '65.54.15593547019383105', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:05:02', 10, 0, '', '2019-06-01 10:05:02');
INSERT INTO `access_log` VALUES (18605, '59.71.15593547052043585', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.7.165', '2019-06-01 10:05:05', 4, 0, '', '2019-06-01 10:05:05');
INSERT INTO `access_log` VALUES (18606, '59.80.15593547051963579', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.7.165', '2019-06-01 10:05:05', 13, 2001001000, '服务端发生异常', '2019-06-01 10:05:05');
INSERT INTO `access_log` VALUES (18607, '65.46.15593547321853121', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.89.239.232', '2019-06-01 10:05:32', 1, 1002001015, '账号未登陆', '2019-06-01 10:05:32');
INSERT INTO `access_log` VALUES (18608, '65.50.15593547340863137', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.60.110', '2019-06-01 10:05:34', 1, 1002001015, '账号未登陆', '2019-06-01 10:05:34');
INSERT INTO `access_log` VALUES (18609, '64.78.15593547362443045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.7.165', '2019-06-01 10:05:36', 3, 0, '', '2019-06-01 10:05:36');
INSERT INTO `access_log` VALUES (18610, '64.80.15593547366153035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.7.165', '2019-06-01 10:05:37', 2, 0, '', '2019-06-01 10:05:37');
INSERT INTO `access_log` VALUES (18611, '64.82.15593547382223047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.7.165', '2019-06-01 10:05:38', 3, 0, '', '2019-06-01 10:05:38');
INSERT INTO `access_log` VALUES (18612, '64.79.15593547389903033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.7.165', '2019-06-01 10:05:39', 2, 0, '', '2019-06-01 10:05:39');
INSERT INTO `access_log` VALUES (18613, '64.76.15593547405263035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.7.165', '2019-06-01 10:05:41', 3, 0, '', '2019-06-01 10:05:41');
INSERT INTO `access_log` VALUES (18614, '64.83.15593547411023035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.7.165', '2019-06-01 10:05:41', 3, 0, '', '2019-06-01 10:05:41');
INSERT INTO `access_log` VALUES (18615, '65.51.15593547436463121', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:05:44', 11, 0, '', '2019-06-01 10:05:44');
INSERT INTO `access_log` VALUES (18616, '65.52.15593547436463113', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:05:44', 11, 0, '', '2019-06-01 10:05:44');
INSERT INTO `access_log` VALUES (18617, '65.53.15593547436483111', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:05:44', 9, 0, '', '2019-06-01 10:05:44');
INSERT INTO `access_log` VALUES (18618, '65.48.15593547438023131', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-06-01 10:05:44', 9, 0, '', '2019-06-01 10:05:44');
INSERT INTO `access_log` VALUES (18619, '66.56.15593547456662433', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.7.165', '2019-06-01 10:05:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位', '2019-06-01 10:05:46');
INSERT INTO `access_log` VALUES (18620, '65.51.15593547615593123', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.129.7.235', '2019-06-01 10:06:02', 1, 1002001015, '账号未登陆', '2019-06-01 10:06:02');
INSERT INTO `access_log` VALUES (18621, '65.47.15593548293713145', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:07:09', 1, 1002001015, '账号未登陆', '2019-06-01 10:07:09');
INSERT INTO `access_log` VALUES (18622, '65.45.15593548293793139', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:07:09', 1, 1002001015, '账号未登陆', '2019-06-01 10:07:09');
INSERT INTO `access_log` VALUES (18623, '65.50.15593548293923139', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:07:09', 0, 1002001015, '账号未登陆', '2019-06-01 10:07:09');
INSERT INTO `access_log` VALUES (18624, '65.49.15593548324373141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:07:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 10:07:12');
INSERT INTO `access_log` VALUES (18625, '65.51.15593548386033125', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:07:19', 54, 0, '', '2019-06-01 10:07:19');
INSERT INTO `access_log` VALUES (18626, '65.46.15593548390483125', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:07:19', 9, 0, '', '2019-06-01 10:07:19');
INSERT INTO `access_log` VALUES (18627, '65.53.15593548390543115', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:07:19', 8, 0, '', '2019-06-01 10:07:19');
INSERT INTO `access_log` VALUES (18628, '65.52.15593548390623117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:07:19', 8, 0, '', '2019-06-01 10:07:19');
INSERT INTO `access_log` VALUES (18629, '64.79.15593548481883035', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:07:28', 13, 0, '', '2019-06-01 10:07:28');
INSERT INTO `access_log` VALUES (18630, '64.76.15593548482043037', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:07:28', 9, 0, '', '2019-06-01 10:07:28');
INSERT INTO `access_log` VALUES (18631, '64.83.15593548540443037', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:07:34', 19, 0, '', '2019-06-01 10:07:34');
INSERT INTO `access_log` VALUES (18632, '64.85.15593548540553049', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:07:34', 9, 0, '', '2019-06-01 10:07:34');
INSERT INTO `access_log` VALUES (18633, '64.77.15593548575983045', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:07:38', 11, 0, '', '2019-06-01 10:07:38');
INSERT INTO `access_log` VALUES (18634, '64.81.15593548576063039', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:07:38', 13, 0, '', '2019-06-01 10:07:38');
INSERT INTO `access_log` VALUES (18635, '59.76.15593548639103579', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 10:07:44', 3, 0, '', '2019-06-01 10:07:44');
INSERT INTO `access_log` VALUES (18636, '59.75.15593548639103583', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.69.11.110', '2019-06-01 10:07:44', 21, 2001001000, '服务端发生异常', '2019-06-01 10:07:44');
INSERT INTO `access_log` VALUES (18637, '59.73.15593548735893589', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:07:54', 3, 0, '', '2019-06-01 10:07:54');
INSERT INTO `access_log` VALUES (18638, '59.79.15593548736043585', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:07:54', 14, 2001001000, '服务端发生异常', '2019-06-01 10:07:54');
INSERT INTO `access_log` VALUES (18639, '65.45.15593548798193141', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:08:00', 19, 0, '', '2019-06-01 10:08:00');
INSERT INTO `access_log` VALUES (18640, '65.50.15593548825973141', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:08:03', 13, 0, '', '2019-06-01 10:08:03');
INSERT INTO `access_log` VALUES (18641, '64.80.15593548836023039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:08:04', 2, 0, '', '2019-06-01 10:08:04');
INSERT INTO `access_log` VALUES (18642, '64.82.15593548837163051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:08:04', 2, 0, '', '2019-06-01 10:08:04');
INSERT INTO `access_log` VALUES (18643, '65.49.15593548850143143', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:08:05', 10, 0, '', '2019-06-01 10:08:05');
INSERT INTO `access_log` VALUES (18644, '64.76.15593548854063039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:08:05', 3, 0, '', '2019-06-01 10:08:05');
INSERT INTO `access_log` VALUES (18645, '64.83.15593548861773039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:08:06', 2, 0, '', '2019-06-01 10:08:06');
INSERT INTO `access_log` VALUES (18646, '65.46.15593548895483127', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:08:10', 25, 0, '', '2019-06-01 10:08:10');
INSERT INTO `access_log` VALUES (18647, '64.85.15593548921243051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:08:12', 2, 0, '', '2019-06-01 10:08:12');
INSERT INTO `access_log` VALUES (18648, '59.72.15593548921933581', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:08:12', 12, 0, '', '2019-06-01 10:08:12');
INSERT INTO `access_log` VALUES (18649, '64.84.15593548935313049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:08:14', 2, 0, '', '2019-06-01 10:08:14');
INSERT INTO `access_log` VALUES (18650, '64.77.15593548947933047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:08:15', 2, 0, '', '2019-06-01 10:08:15');
INSERT INTO `access_log` VALUES (18651, '59.77.15593548961683581', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:08:16', 20, 2001001000, '服务端发生异常', '2019-06-01 10:08:16');
INSERT INTO `access_log` VALUES (18652, '62.89.15593549053383471', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:08:25', 13, 0, '', '2019-06-01 10:08:25');
INSERT INTO `access_log` VALUES (18653, '66.50.15593549160262441', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18611741232&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:08:36', 25, 1001003000, '验证码不存在', '2019-06-01 10:08:36');
INSERT INTO `access_log` VALUES (18654, '66.48.15593549233212445', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18611741232', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:08:43', 95, 0, '', '2019-06-01 10:08:43');
INSERT INTO `access_log` VALUES (18655, '66.51.15593549296052439', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18611741231', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:08:50', 92, 0, '', '2019-06-01 10:08:50');
INSERT INTO `access_log` VALUES (18656, '59.75.15593549309243585', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.18.76.130', '2019-06-01 10:08:51', 3, 0, '', '2019-06-01 10:08:51');
INSERT INTO `access_log` VALUES (18657, '59.74.15593549309763583', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.18.76.130', '2019-06-01 10:08:51', 12, 2001001000, '服务端发生异常', '2019-06-01 10:08:51');
INSERT INTO `access_log` VALUES (18658, '64.82.15593549392333053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.18.76.130', '2019-06-01 10:08:59', 2, 0, '', '2019-06-01 10:08:59');
INSERT INTO `access_log` VALUES (18659, '64.76.15593549393943041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.18.76.130', '2019-06-01 10:08:59', 2, 0, '', '2019-06-01 10:08:59');
INSERT INTO `access_log` VALUES (18660, '64.79.15593549396853039', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:09:00', 11, 0, '', '2019-06-01 10:09:00');
INSERT INTO `access_log` VALUES (18661, '64.83.15593549396883041', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:09:00', 9, 0, '', '2019-06-01 10:09:00');
INSERT INTO `access_log` VALUES (18662, '64.85.15593549412543053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.18.76.130', '2019-06-01 10:09:01', 2, 0, '', '2019-06-01 10:09:01');
INSERT INTO `access_log` VALUES (18663, '64.77.15593549418343049', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:09:02', 11, 0, '', '2019-06-01 10:09:02');
INSERT INTO `access_log` VALUES (18664, '64.84.15593549418313051', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:09:02', 14, 0, '', '2019-06-01 10:09:02');
INSERT INTO `access_log` VALUES (18665, '64.81.15593549422553043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.18.76.130', '2019-06-01 10:09:02', 2, 0, '', '2019-06-01 10:09:02');
INSERT INTO `access_log` VALUES (18666, '64.78.15593549430063053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.18.76.130', '2019-06-01 10:09:03', 2, 0, '', '2019-06-01 10:09:03');
INSERT INTO `access_log` VALUES (18667, '59.79.15593549443073587', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.18.76.130', '2019-06-01 10:09:04', 3, 0, '', '2019-06-01 10:09:04');
INSERT INTO `access_log` VALUES (18668, '59.78.15593549443073589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.18.76.130', '2019-06-01 10:09:04', 13, 2001001000, '服务端发生异常', '2019-06-01 10:09:04');
INSERT INTO `access_log` VALUES (18669, '64.82.15593549474173055', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:09:07', 9, 0, '', '2019-06-01 10:09:07');
INSERT INTO `access_log` VALUES (18670, '66.52.15593549569272439', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18611741231&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:09:17', 621, 0, '', '2019-06-01 10:09:18');
INSERT INTO `access_log` VALUES (18671, '64.83.15593549661773043', 95, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:09:26', 6, 0, '', '2019-06-01 10:09:26');
INSERT INTO `access_log` VALUES (18672, '64.77.15593549663483051', 95, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:09:26', 4, 0, '', '2019-06-01 10:09:26');
INSERT INTO `access_log` VALUES (18673, '64.81.15593549667173045', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:09:27', 162, 0, '', '2019-06-01 10:09:27');
INSERT INTO `access_log` VALUES (18674, '64.84.15593549667123053', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:09:27', 168, 0, '', '2019-06-01 10:09:27');
INSERT INTO `access_log` VALUES (18675, '66.57.15593549676472441', 95, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:09:28', 6, 0, '', '2019-06-01 10:09:28');
INSERT INTO `access_log` VALUES (18676, '64.78.15593549697663055', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:09:30', 12, 0, '', '2019-06-01 10:09:30');
INSERT INTO `access_log` VALUES (18677, '64.80.15593549697793045', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:09:30', 8, 0, '', '2019-06-01 10:09:30');
INSERT INTO `access_log` VALUES (18678, '64.82.15593549724413057', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:09:32', 12, 0, '', '2019-06-01 10:09:32');
INSERT INTO `access_log` VALUES (18679, '64.76.15593549724503045', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '111.29.98.252', '2019-06-01 10:09:32', 9, 0, '', '2019-06-01 10:09:32');
INSERT INTO `access_log` VALUES (18680, '66.49.15593549749522439', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:09:35', 13, 0, '', '2019-06-01 10:09:35');
INSERT INTO `access_log` VALUES (18681, '62.82.15593549789693477', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:09:39', 13, 0, '', '2019-06-01 10:09:39');
INSERT INTO `access_log` VALUES (18682, '62.87.15593549834563473', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.67.10.207', '2019-06-01 10:09:43', 13, 0, '', '2019-06-01 10:09:43');
INSERT INTO `access_log` VALUES (18683, '66.48.15593549841752447', 95, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:09:44', 5, 0, '', '2019-06-01 10:09:44');
INSERT INTO `access_log` VALUES (18684, '64.81.15593550119143047', 95, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:10:12', 7, 1003002003, 'Spu 只能添加在二级分类下', '2019-06-01 10:10:12');
INSERT INTO `access_log` VALUES (18685, '66.53.15593550429012447', 95, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:10:43', 6, 0, '', '2019-06-01 10:10:43');
INSERT INTO `access_log` VALUES (18686, '59.73.15593550448493593', 95, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:10:45', 11, 0, '', '2019-06-01 10:10:45');
INSERT INTO `access_log` VALUES (18687, '59.78.15593550460033591', 95, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:10:46', 14, 0, '', '2019-06-01 10:10:46');
INSERT INTO `access_log` VALUES (18688, '59.77.15593550466103585', 95, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:10:47', 7, 0, '', '2019-06-01 10:10:47');
INSERT INTO `access_log` VALUES (18689, '66.56.15593550504302439', 95, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:10:50', 6, 0, '', '2019-06-01 10:10:50');
INSERT INTO `access_log` VALUES (18690, '66.49.15593550541672441', 95, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:10:54', 6, 0, '', '2019-06-01 10:10:54');
INSERT INTO `access_log` VALUES (18691, '66.48.15593550552542449', 95, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:10:55', 7, 0, '', '2019-06-01 10:10:55');
INSERT INTO `access_log` VALUES (18692, '66.51.15593550593542443', 95, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:10:59', 7, 0, '', '2019-06-01 10:10:59');
INSERT INTO `access_log` VALUES (18693, '66.55.15593550599242453', 95, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:11:00', 7, 0, '', '2019-06-01 10:11:00');
INSERT INTO `access_log` VALUES (18694, '66.54.15593550611142441', 95, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:11:01', 7, 0, '', '2019-06-01 10:11:01');
INSERT INTO `access_log` VALUES (18695, '66.52.15593550656382443', 95, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:11:06', 6, 0, '', '2019-06-01 10:11:06');
INSERT INTO `access_log` VALUES (18696, '59.74.15593550681623587', 95, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:11:08', 6, 0, '', '2019-06-01 10:11:08');
INSERT INTO `access_log` VALUES (18697, '59.73.15593550681883595', 95, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:11:08', 12, 2001001000, '服务端发生异常', '2019-06-01 10:11:08');
INSERT INTO `access_log` VALUES (18698, '64.77.15593551347103055', 95, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:12:15', 6, 0, '', '2019-06-01 10:12:15');
INSERT INTO `access_log` VALUES (18699, '64.81.15593551348353049', 95, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:12:15', 5, 0, '', '2019-06-01 10:12:15');
INSERT INTO `access_log` VALUES (18700, '64.84.15593551361273057', 95, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:12:16', 6, 0, '', '2019-06-01 10:12:16');
INSERT INTO `access_log` VALUES (18701, 'N/A', 95, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:12:16', 34, 0, '', '2019-06-01 10:12:16');
INSERT INTO `access_log` VALUES (18702, 'N/A', 95, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:12:18', 16, 0, '', '2019-06-01 10:12:18');
INSERT INTO `access_log` VALUES (18703, '64.78.15593551394193059', 95, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:12:19', 11, 0, '', '2019-06-01 10:12:19');
INSERT INTO `access_log` VALUES (18704, '66.54.15593551624782443', 95, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:12:42', 7, 0, '', '2019-06-01 10:12:42');
INSERT INTO `access_log` VALUES (18705, '64.79.15593553122833049', 95, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Mobile Safari/537.36', '218.69.11.110', '2019-06-01 10:15:12', 12, 0, '', '2019-06-01 10:15:12');
INSERT INTO `access_log` VALUES (18706, '59.75.15593556272183597', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:20:27', 4, 0, '', '2019-06-01 10:20:27');
INSERT INTO `access_log` VALUES (18707, '59.73.15593556273073603', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:20:27', 14, 2001001000, '服务端发生异常', '2019-06-01 10:20:27');
INSERT INTO `access_log` VALUES (18708, '64.77.15593556397823063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:20:40', 3, 0, '', '2019-06-01 10:20:40');
INSERT INTO `access_log` VALUES (18709, '64.81.15593556399863057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:20:40', 2, 0, '', '2019-06-01 10:20:40');
INSERT INTO `access_log` VALUES (18710, '64.84.15593556420323065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:20:42', 2, 0, '', '2019-06-01 10:20:42');
INSERT INTO `access_log` VALUES (18711, '64.80.15593556430233057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:20:43', 2, 0, '', '2019-06-01 10:20:43');
INSERT INTO `access_log` VALUES (18712, '65.52.15593556537363129', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:20:54', 1, 1002001015, '账号未登陆', '2019-06-01 10:20:54');
INSERT INTO `access_log` VALUES (18713, '65.53.15593556537383127', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:20:54', 0, 1002001015, '账号未登陆', '2019-06-01 10:20:54');
INSERT INTO `access_log` VALUES (18714, '65.54.15593556540353121', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:20:54', 1, 1002001015, '账号未登陆', '2019-06-01 10:20:54');
INSERT INTO `access_log` VALUES (18715, '65.47.15593556596553159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:21:00', 95, 0, '', '2019-06-01 10:21:00');
INSERT INTO `access_log` VALUES (18716, '65.50.15593556601183153', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:21:00', 285, 0, '', '2019-06-01 10:21:00');
INSERT INTO `access_log` VALUES (18717, '65.45.15593556601153153', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:21:00', 290, 0, '', '2019-06-01 10:21:00');
INSERT INTO `access_log` VALUES (18718, '65.49.15593556601223155', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:21:00', 284, 0, '', '2019-06-01 10:21:00');
INSERT INTO `access_log` VALUES (18719, '62.80.15593556660743487', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:21:06', 12, 0, '', '2019-06-01 10:21:06');
INSERT INTO `access_log` VALUES (18720, '62.82.15593556797953487', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:21:20', 16, 0, '', '2019-06-01 10:21:20');
INSERT INTO `access_log` VALUES (18721, '65.52.15593556874353131', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:21:27', 20, 0, '', '2019-06-01 10:21:27');
INSERT INTO `access_log` VALUES (18722, '65.53.15593556950953129', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.8.71', '2019-06-01 10:21:35', 10, 0, '', '2019-06-01 10:21:35');
INSERT INTO `access_log` VALUES (18723, '65.50.15593563361183163', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.161.149.246', '2019-06-01 10:32:16', 0, 1002001015, '账号未登陆', '2019-06-01 10:32:16');
INSERT INTO `access_log` VALUES (18724, '65.45.15593563361533163', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.161.149.246', '2019-06-01 10:32:16', 0, 1002001015, '账号未登陆', '2019-06-01 10:32:16');
INSERT INTO `access_log` VALUES (18725, '65.49.15593563362033165', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.161.149.246', '2019-06-01 10:32:16', 0, 1002001015, '账号未登陆', '2019-06-01 10:32:16');
INSERT INTO `access_log` VALUES (18726, '65.51.15593563396703149', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.161.149.246', '2019-06-01 10:32:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 10:32:20');
INSERT INTO `access_log` VALUES (18727, '65.52.15593563444703141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.161.149.246', '2019-06-01 10:32:24', 69, 0, '', '2019-06-01 10:32:25');
INSERT INTO `access_log` VALUES (18728, '65.53.15593563449093139', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.161.149.246', '2019-06-01 10:32:25', 11, 0, '', '2019-06-01 10:32:25');
INSERT INTO `access_log` VALUES (18729, '65.48.15593563449093159', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.161.149.246', '2019-06-01 10:32:25', 12, 0, '', '2019-06-01 10:32:25');
INSERT INTO `access_log` VALUES (18730, '65.54.15593563449153133', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.161.149.246', '2019-06-01 10:32:25', 9, 0, '', '2019-06-01 10:32:25');
INSERT INTO `access_log` VALUES (18731, '62.84.15593563501033487', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.161.149.246', '2019-06-01 10:32:30', 15, 0, '', '2019-06-01 10:32:30');
INSERT INTO `access_log` VALUES (18732, '59.73.15593563560153613', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.161.149.246', '2019-06-01 10:32:36', 23, 0, '', '2019-06-01 10:32:36');
INSERT INTO `access_log` VALUES (18733, '59.74.15593563591093605', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.161.149.246', '2019-06-01 10:32:39', 52, 0, '', '2019-06-01 10:32:39');
INSERT INTO `access_log` VALUES (18734, '64.84.15593563602053075', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.161.149.246', '2019-06-01 10:32:40', 11, 0, '', '2019-06-01 10:32:40');
INSERT INTO `access_log` VALUES (18735, '64.80.15593563659323067', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.161.149.246', '2019-06-01 10:32:46', 58, 0, '', '2019-06-01 10:32:46');
INSERT INTO `access_log` VALUES (18736, '65.50.15593563683843165', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.161.149.246', '2019-06-01 10:32:48', 20, 0, '', '2019-06-01 10:32:48');
INSERT INTO `access_log` VALUES (18737, '59.72.15593565389753607', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:35:39', 4, 0, '', '2019-06-01 10:35:39');
INSERT INTO `access_log` VALUES (18738, '59.77.15593565389773607', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:35:39', 12, 2001001000, '服务端发生异常', '2019-06-01 10:35:39');
INSERT INTO `access_log` VALUES (18739, '64.76.15593565466343069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:35:47', 3, 0, '', '2019-06-01 10:35:47');
INSERT INTO `access_log` VALUES (18740, '64.79.15593565467943067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:35:47', 2, 0, '', '2019-06-01 10:35:47');
INSERT INTO `access_log` VALUES (18741, '64.85.15593565515953081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:35:52', 2, 0, '', '2019-06-01 10:35:52');
INSERT INTO `access_log` VALUES (18742, '64.77.15593565517743077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:35:52', 2, 0, '', '2019-06-01 10:35:52');
INSERT INTO `access_log` VALUES (18743, '59.76.15593565521263607', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:35:52', 12, 2001001000, '服务端发生异常', '2019-06-01 10:35:52');
INSERT INTO `access_log` VALUES (18744, '59.71.15593565521243615', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:35:52', 93, 0, '', '2019-06-01 10:35:52');
INSERT INTO `access_log` VALUES (18745, '65.53.15593565739423143', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:36:14', 1, 1002001015, '账号未登陆', '2019-06-01 10:36:14');
INSERT INTO `access_log` VALUES (18746, '65.52.15593565739413145', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:36:14', 1, 1002001015, '账号未登陆', '2019-06-01 10:36:14');
INSERT INTO `access_log` VALUES (18747, '65.48.15593565739423163', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:36:14', 1, 1002001015, '账号未登陆', '2019-06-01 10:36:14');
INSERT INTO `access_log` VALUES (18748, '65.46.15593566591783155', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:37:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 10:37:39');
INSERT INTO `access_log` VALUES (18749, '65.53.15593566671813145', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:37:47', 90, 0, '', '2019-06-01 10:37:47');
INSERT INTO `access_log` VALUES (18750, '65.48.15593566679783165', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:37:48', 8, 0, '', '2019-06-01 10:37:48');
INSERT INTO `access_log` VALUES (18751, '65.52.15593566679773147', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:37:48', 11, 0, '', '2019-06-01 10:37:48');
INSERT INTO `access_log` VALUES (18752, '65.54.15593566681393139', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:37:48', 10, 0, '', '2019-06-01 10:37:48');
INSERT INTO `access_log` VALUES (18753, '62.82.15593566751403501', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:37:55', 15, 0, '', '2019-06-01 10:37:55');
INSERT INTO `access_log` VALUES (18754, '65.50.15593566765573171', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:37:57', 1, 1002001015, '账号未登陆', '2019-06-01 10:37:57');
INSERT INTO `access_log` VALUES (18755, '65.45.15593566765663171', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:37:57', 1, 1002001015, '账号未登陆', '2019-06-01 10:37:57');
INSERT INTO `access_log` VALUES (18756, '65.49.15593566765713173', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:37:57', 0, 1002001015, '账号未登陆', '2019-06-01 10:37:57');
INSERT INTO `access_log` VALUES (18757, '65.51.15593566835623157', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:38:04', 73, 0, '', '2019-06-01 10:38:04');
INSERT INTO `access_log` VALUES (18758, '65.46.15593566838273157', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:38:04', 10, 0, '', '2019-06-01 10:38:04');
INSERT INTO `access_log` VALUES (18759, '65.53.15593566838333147', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:38:04', 9, 0, '', '2019-06-01 10:38:04');
INSERT INTO `access_log` VALUES (18760, '65.52.15593566838453149', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:38:04', 9, 0, '', '2019-06-01 10:38:04');
INSERT INTO `access_log` VALUES (18761, '62.87.15593566853393497', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:38:05', 11, 0, '', '2019-06-01 10:38:05');
INSERT INTO `access_log` VALUES (18762, '62.88.15593566859993499', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:38:06', 14, 0, '', '2019-06-01 10:38:06');
INSERT INTO `access_log` VALUES (18763, '62.89.15593566882843497', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:38:08', 492, 0, '', '2019-06-01 10:38:09');
INSERT INTO `access_log` VALUES (18764, '64.81.15593566900593073', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:38:10', 10, 0, '', '2019-06-01 10:38:10');
INSERT INTO `access_log` VALUES (18765, '64.77.15593566900583079', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:38:10', 11, 0, '', '2019-06-01 10:38:10');
INSERT INTO `access_log` VALUES (18766, '66.56.15593566973932463', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:38:17', 14, 0, '', '2019-06-01 10:38:17');
INSERT INTO `access_log` VALUES (18767, '66.57.15593566980602467', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:38:18', 14, 0, '', '2019-06-01 10:38:18');
INSERT INTO `access_log` VALUES (18768, '59.75.15593567029923613', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:38:23', 13, 0, '', '2019-06-01 10:38:23');
INSERT INTO `access_log` VALUES (18769, '59.73.15593567053633619', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:38:25', 21, 2001001000, '服务端发生异常', '2019-06-01 10:38:25');
INSERT INTO `access_log` VALUES (18770, '59.74.15593567080923611', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:38:28', 12, 0, '', '2019-06-01 10:38:28');
INSERT INTO `access_log` VALUES (18771, '65.47.15593567104773179', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:38:30', 20, 0, '', '2019-06-01 10:38:30');
INSERT INTO `access_log` VALUES (18772, '59.79.15593567105393615', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '117.136.79.125', '2019-06-01 10:38:31', 17, 0, '', '2019-06-01 10:38:31');
INSERT INTO `access_log` VALUES (18773, '65.45.15593567115093173', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:38:32', 10, 0, '', '2019-06-01 10:38:32');
INSERT INTO `access_log` VALUES (18774, '65.50.15593567127933173', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:38:33', 9, 0, '', '2019-06-01 10:38:33');
INSERT INTO `access_log` VALUES (18775, '65.49.15593567148053175', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.155.186', '2019-06-01 10:38:35', 14, 0, '', '2019-06-01 10:38:35');
INSERT INTO `access_log` VALUES (18776, '59.78.15593570066413621', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '113.233.121.217', '2019-06-01 10:43:27', 4, 0, '', '2019-06-01 10:43:27');
INSERT INTO `access_log` VALUES (18777, '59.72.15593570066433615', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '113.233.121.217', '2019-06-01 10:43:27', 13, 2001001000, '服务端发生异常', '2019-06-01 10:43:27');
INSERT INTO `access_log` VALUES (18778, '59.74.15593575490553623', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.67.62.31', '2019-06-01 10:52:29', 4, 0, '', '2019-06-01 10:52:29');
INSERT INTO `access_log` VALUES (18779, '59.79.15593575490563627', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.67.62.31', '2019-06-01 10:52:29', 10, 2001001000, '服务端发生异常', '2019-06-01 10:52:29');
INSERT INTO `access_log` VALUES (18780, '64.85.15593575530473095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.67.62.31', '2019-06-01 10:52:33', 3, 0, '', '2019-06-01 10:52:33');
INSERT INTO `access_log` VALUES (18781, '64.77.15593575531833091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.67.62.31', '2019-06-01 10:52:33', 2, 0, '', '2019-06-01 10:52:33');
INSERT INTO `access_log` VALUES (18782, '59.78.15593576956093631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.147.138', '2019-06-01 10:54:56', 4, 0, '', '2019-06-01 10:54:56');
INSERT INTO `access_log` VALUES (18783, '59.72.15593576956103625', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.147.138', '2019-06-01 10:54:56', 13, 2001001000, '服务端发生异常', '2019-06-01 10:54:56');
INSERT INTO `access_log` VALUES (18784, '64.80.15593577206233087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.147.138', '2019-06-01 10:55:21', 8, 0, '', '2019-06-01 10:55:21');
INSERT INTO `access_log` VALUES (18785, '64.78.15593577207263097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.147.138', '2019-06-01 10:55:21', 2, 0, '', '2019-06-01 10:55:21');
INSERT INTO `access_log` VALUES (18786, '64.82.15593577216173099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.147.138', '2019-06-01 10:55:22', 19, 0, '', '2019-06-01 10:55:22');
INSERT INTO `access_log` VALUES (18787, '64.76.15593577220213087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.147.138', '2019-06-01 10:55:22', 2, 0, '', '2019-06-01 10:55:22');
INSERT INTO `access_log` VALUES (18788, '64.79.15593577225903085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.147.138', '2019-06-01 10:55:23', 2, 0, '', '2019-06-01 10:55:23');
INSERT INTO `access_log` VALUES (18789, '64.83.15593577229483087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.147.138', '2019-06-01 10:55:23', 2, 0, '', '2019-06-01 10:55:23');
INSERT INTO `access_log` VALUES (18790, '64.85.15593577232263099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.147.138', '2019-06-01 10:55:23', 2, 0, '', '2019-06-01 10:55:23');
INSERT INTO `access_log` VALUES (18791, '62.86.15593581439213513', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '58.240.83.67', '2019-06-01 11:02:24', 8, 1002001012, '访问令牌已过期', '2019-06-01 11:02:24');
INSERT INTO `access_log` VALUES (18792, '65.47.15593581538413199', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:02:34', 1, 1002001015, '账号未登陆', '2019-06-01 11:02:34');
INSERT INTO `access_log` VALUES (18793, '65.45.15593581538443193', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:02:34', 0, 1002001015, '账号未登陆', '2019-06-01 11:02:34');
INSERT INTO `access_log` VALUES (18794, '65.50.15593581538463193', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:02:34', 1, 1002001015, '账号未登陆', '2019-06-01 11:02:34');
INSERT INTO `access_log` VALUES (18795, '65.49.15593581565913195', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:02:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 11:02:37');
INSERT INTO `access_log` VALUES (18796, '65.46.15593581680113179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:02:48', 174, 0, '', '2019-06-01 11:02:48');
INSERT INTO `access_log` VALUES (18797, '65.53.15593581685393169', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:02:49', 10, 0, '', '2019-06-01 11:02:49');
INSERT INTO `access_log` VALUES (18798, '65.52.15593581685423171', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:02:49', 9, 0, '', '2019-06-01 11:02:49');
INSERT INTO `access_log` VALUES (18799, '65.48.15593581685453189', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:02:49', 8, 0, '', '2019-06-01 11:02:49');
INSERT INTO `access_log` VALUES (18800, '64.81.15593581745233095', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:02:55', 10, 0, '', '2019-06-01 11:02:55');
INSERT INTO `access_log` VALUES (18801, '64.77.15593581745203101', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:02:55', 13, 0, '', '2019-06-01 11:02:55');
INSERT INTO `access_log` VALUES (18802, '59.75.15593582024043635', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:03:22', 13, 0, '', '2019-06-01 11:03:22');
INSERT INTO `access_log` VALUES (18803, '65.45.15593582055843195', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:03:26', 20, 0, '', '2019-06-01 11:03:26');
INSERT INTO `access_log` VALUES (18804, '65.49.15593582081003197', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:03:28', 10, 0, '', '2019-06-01 11:03:28');
INSERT INTO `access_log` VALUES (18805, '65.51.15593582113603181', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:03:31', 11, 0, '', '2019-06-01 11:03:31');
INSERT INTO `access_log` VALUES (18806, '65.46.15593582174013181', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:03:37', 10, 0, '', '2019-06-01 11:03:37');
INSERT INTO `access_log` VALUES (18807, '65.48.15593582214823191', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.172.42', '2019-06-01 11:03:41', 44, 0, '', '2019-06-01 11:03:42');
INSERT INTO `access_log` VALUES (18808, '65.52.15593591313983185', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:18:51', 1, 1002001015, '账号未登陆', '2019-06-01 11:18:51');
INSERT INTO `access_log` VALUES (18809, '65.54.15593591313993177', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:18:51', 0, 1002001015, '账号未登陆', '2019-06-01 11:18:51');
INSERT INTO `access_log` VALUES (18810, '65.50.15593591314023209', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:18:51', 0, 1002001015, '账号未登陆', '2019-06-01 11:18:51');
INSERT INTO `access_log` VALUES (18811, '65.47.15593591333343215', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:18:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 11:18:53');
INSERT INTO `access_log` VALUES (18812, '65.49.15593591354263211', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:18:55', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 11:18:55');
INSERT INTO `access_log` VALUES (18813, '65.51.15593591362903195', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:18:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 11:18:56');
INSERT INTO `access_log` VALUES (18814, '65.46.15593591369583195', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:18:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 11:18:57');
INSERT INTO `access_log` VALUES (18815, '65.48.15593591494413205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:19:09', 57, 0, '', '2019-06-01 11:19:10');
INSERT INTO `access_log` VALUES (18816, '65.50.15593591497253211', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:19:10', 9, 0, '', '2019-06-01 11:19:10');
INSERT INTO `access_log` VALUES (18817, '65.54.15593591497263179', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:19:10', 10, 0, '', '2019-06-01 11:19:10');
INSERT INTO `access_log` VALUES (18818, '65.52.15593591497263187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:19:10', 12, 0, '', '2019-06-01 11:19:10');
INSERT INTO `access_log` VALUES (18819, '62.84.15593591677093527', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:19:28', 22, 0, '', '2019-06-01 11:19:28');
INSERT INTO `access_log` VALUES (18820, '64.85.15593591741143119', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:19:34', 10, 0, '', '2019-06-01 11:19:34');
INSERT INTO `access_log` VALUES (18821, '64.83.15593591741133107', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:19:34', 11, 0, '', '2019-06-01 11:19:34');
INSERT INTO `access_log` VALUES (18822, '64.84.15593591789363117', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:19:39', 12, 0, '', '2019-06-01 11:19:39');
INSERT INTO `access_log` VALUES (18823, '64.77.15593591789363115', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:19:39', 12, 0, '', '2019-06-01 11:19:39');
INSERT INTO `access_log` VALUES (18824, '64.80.15593591825273109', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:19:43', 10, 0, '', '2019-06-01 11:19:43');
INSERT INTO `access_log` VALUES (18825, '65.49.15593591861933213', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.86.218.30', '2019-06-01 11:19:46', 1, 1002001015, '账号未登陆', '2019-06-01 11:19:46');
INSERT INTO `access_log` VALUES (18826, '65.51.15593591862053197', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.86.218.30', '2019-06-01 11:19:46', 1, 1002001015, '账号未登陆', '2019-06-01 11:19:46');
INSERT INTO `access_log` VALUES (18827, '65.46.15593591862083197', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.86.218.30', '2019-06-01 11:19:46', 0, 1002001015, '账号未登陆', '2019-06-01 11:19:46');
INSERT INTO `access_log` VALUES (18828, '65.53.15593591879673187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.86.218.30', '2019-06-01 11:19:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 11:19:48');
INSERT INTO `access_log` VALUES (18829, '65.48.15593591915803207', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:19:52', 192, 0, '', '2019-06-01 11:19:52');
INSERT INTO `access_log` VALUES (18830, '65.54.15593591916353181', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.86.218.30', '2019-06-01 11:19:52', 225, 0, '', '2019-06-01 11:19:52');
INSERT INTO `access_log` VALUES (18831, '65.52.15593591920903189', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.86.218.30', '2019-06-01 11:19:52', 8, 0, '', '2019-06-01 11:19:52');
INSERT INTO `access_log` VALUES (18832, '65.47.15593591920963219', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.86.218.30', '2019-06-01 11:19:52', 7, 0, '', '2019-06-01 11:19:52');
INSERT INTO `access_log` VALUES (18833, '65.50.15593591920953213', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.86.218.30', '2019-06-01 11:19:52', 9, 0, '', '2019-06-01 11:19:52');
INSERT INTO `access_log` VALUES (18834, '65.45.15593591932993213', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:19:53', 10, 0, '', '2019-06-01 11:19:53');
INSERT INTO `access_log` VALUES (18835, '65.51.15593591954773199', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:19:55', 19, 0, '', '2019-06-01 11:19:55');
INSERT INTO `access_log` VALUES (18836, '64.82.15593591957953121', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.86.218.30', '2019-06-01 11:19:56', 9, 0, '', '2019-06-01 11:19:56');
INSERT INTO `access_log` VALUES (18837, '64.76.15593591957953109', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.86.218.30', '2019-06-01 11:19:56', 11, 0, '', '2019-06-01 11:19:56');
INSERT INTO `access_log` VALUES (18838, '65.46.15593592008513199', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:20:01', 10, 0, '', '2019-06-01 11:20:01');
INSERT INTO `access_log` VALUES (18839, '65.53.15593592030913189', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:20:03', 10, 0, '', '2019-06-01 11:20:03');
INSERT INTO `access_log` VALUES (18840, '65.48.15593592050233209', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:20:05', 14, 0, '', '2019-06-01 11:20:05');
INSERT INTO `access_log` VALUES (18841, '65.52.15593592230823191', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:20:23', 9, 0, '', '2019-06-01 11:20:23');
INSERT INTO `access_log` VALUES (18842, '65.50.15593592237843215', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:20:24', 10, 0, '', '2019-06-01 11:20:24');
INSERT INTO `access_log` VALUES (18843, '65.45.15593592244313215', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:20:24', 19, 0, '', '2019-06-01 11:20:24');
INSERT INTO `access_log` VALUES (18844, '65.49.15593592248563217', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:20:25', 10, 0, '', '2019-06-01 11:20:25');
INSERT INTO `access_log` VALUES (18845, '65.51.15593592254883201', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.128.33.170', '2019-06-01 11:20:25', 19, 0, '', '2019-06-01 11:20:26');
INSERT INTO `access_log` VALUES (18846, '65.53.15593595453703195', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.131.121', '2019-06-01 11:25:45', 1, 1002001015, '账号未登陆', '2019-06-01 11:25:45');
INSERT INTO `access_log` VALUES (18847, '65.48.15593595453703215', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.131.121', '2019-06-01 11:25:45', 0, 1002001015, '账号未登陆', '2019-06-01 11:25:45');
INSERT INTO `access_log` VALUES (18848, '65.54.15593595453783189', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.131.121', '2019-06-01 11:25:45', 0, 1002001015, '账号未登陆', '2019-06-01 11:25:45');
INSERT INTO `access_log` VALUES (18849, '65.52.15593595477693197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.131.121', '2019-06-01 11:25:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 11:25:48');
INSERT INTO `access_log` VALUES (18850, '65.45.15593595711213221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.131.121', '2019-06-01 11:26:11', 73, 0, '', '2019-06-01 11:26:11');
INSERT INTO `access_log` VALUES (18851, '65.49.15593595714423223', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.131.121', '2019-06-01 11:26:11', 10, 0, '', '2019-06-01 11:26:11');
INSERT INTO `access_log` VALUES (18852, '65.51.15593595714443207', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.131.121', '2019-06-01 11:26:11', 10, 0, '', '2019-06-01 11:26:11');
INSERT INTO `access_log` VALUES (18853, '65.46.15593595714503207', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.131.121', '2019-06-01 11:26:11', 9, 0, '', '2019-06-01 11:26:11');
INSERT INTO `access_log` VALUES (18854, '62.84.15593595794623533', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.131.121', '2019-06-01 11:26:19', 14, 0, '', '2019-06-01 11:26:19');
INSERT INTO `access_log` VALUES (18855, '62.80.15593595923243543', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.131.121', '2019-06-01 11:26:32', 17, 0, '', '2019-06-01 11:26:32');
INSERT INTO `access_log` VALUES (18856, '64.78.15593595954353125', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.131.121', '2019-06-01 11:26:35', 10, 0, '', '2019-06-01 11:26:35');
INSERT INTO `access_log` VALUES (18857, '64.80.15593595954353115', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.128.131.121', '2019-06-01 11:26:35', 12, 0, '', '2019-06-01 11:26:35');
INSERT INTO `access_log` VALUES (18858, '66.54.15593596137432505', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '14.23.183.173', '2019-06-01 11:26:54', 1, 1002001015, '账号未登陆', '2019-06-01 11:26:54');
INSERT INTO `access_log` VALUES (18859, '59.80.15593597885883655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.245.200.129', '2019-06-01 11:29:49', 14, 2001001000, '服务端发生异常', '2019-06-01 11:29:49');
INSERT INTO `access_log` VALUES (18860, '59.77.15593597885873653', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.245.200.129', '2019-06-01 11:29:49', 218, 0, '', '2019-06-01 11:29:49');
INSERT INTO `access_log` VALUES (18861, '59.73.15593598337443663', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:30:34', 3, 0, '', '2019-06-01 11:30:34');
INSERT INTO `access_log` VALUES (18862, '59.74.15593598337443655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:30:34', 13, 2001001000, '服务端发生异常', '2019-06-01 11:30:34');
INSERT INTO `access_log` VALUES (18863, '65.49.15593598435123227', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:30:44', 1, 1002001015, '账号未登陆', '2019-06-01 11:30:44');
INSERT INTO `access_log` VALUES (18864, '65.46.15593598435163211', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:30:44', 0, 1002001015, '账号未登陆', '2019-06-01 11:30:44');
INSERT INTO `access_log` VALUES (18865, '65.54.15593598435233195', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:30:44', 1, 1002001015, '账号未登陆', '2019-06-01 11:30:44');
INSERT INTO `access_log` VALUES (18866, '65.53.15593598450843201', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:30:45', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 11:30:45');
INSERT INTO `access_log` VALUES (18867, '65.48.15593598490173221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:30:49', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 11:30:49');
INSERT INTO `access_log` VALUES (18868, '65.52.15593598500283203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:30:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 11:30:50');
INSERT INTO `access_log` VALUES (18869, '65.47.15593598570673233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:30:57', 52, 0, '', '2019-06-01 11:30:57');
INSERT INTO `access_log` VALUES (18870, '65.45.15593598573203227', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:30:57', 10, 0, '', '2019-06-01 11:30:57');
INSERT INTO `access_log` VALUES (18871, '65.51.15593598573223213', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:30:57', 9, 0, '', '2019-06-01 11:30:57');
INSERT INTO `access_log` VALUES (18872, '65.49.15593598573243229', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:30:57', 10, 0, '', '2019-06-01 11:30:57');
INSERT INTO `access_log` VALUES (18873, '62.80.15593598624053547', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:31:02', 15, 0, '', '2019-06-01 11:31:02');
INSERT INTO `access_log` VALUES (18874, '64.82.15593598724503131', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:31:12', 9, 0, '', '2019-06-01 11:31:12');
INSERT INTO `access_log` VALUES (18875, '64.80.15593598724473119', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:31:12', 12, 0, '', '2019-06-01 11:31:12');
INSERT INTO `access_log` VALUES (18876, '64.79.15593598746133117', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:31:15', 8, 0, '', '2019-06-01 11:31:15');
INSERT INTO `access_log` VALUES (18877, '64.76.15593598746093119', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:31:15', 12, 0, '', '2019-06-01 11:31:15');
INSERT INTO `access_log` VALUES (18878, '64.83.15593598792623119', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:31:19', 11, 0, '', '2019-06-01 11:31:19');
INSERT INTO `access_log` VALUES (18879, '64.85.15593598792613131', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:31:19', 17, 0, '', '2019-06-01 11:31:19');
INSERT INTO `access_log` VALUES (18880, '64.81.15593598792873121', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:31:19', 9, 0, '', '2019-06-01 11:31:19');
INSERT INTO `access_log` VALUES (18881, '66.56.15593598852662509', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:31:25', 22, 0, '', '2019-06-01 11:31:25');
INSERT INTO `access_log` VALUES (18882, '59.77.15593598869223655', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:31:27', 12, 0, '', '2019-06-01 11:31:27');
INSERT INTO `access_log` VALUES (18883, '66.57.15593598894582511', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.109', '2019-06-01 11:31:29', 14, 0, '', '2019-06-01 11:31:29');
INSERT INTO `access_log` VALUES (18884, '65.46.15593618240953239', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.97.221', '2019-06-01 12:03:44', 1, 1002001015, '账号未登陆', '2019-06-01 12:03:44');
INSERT INTO `access_log` VALUES (18885, '65.53.15593618240953229', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.97.221', '2019-06-01 12:03:44', 1, 1002001015, '账号未登陆', '2019-06-01 12:03:44');
INSERT INTO `access_log` VALUES (18886, '65.48.15593618240973249', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.97.221', '2019-06-01 12:03:44', 0, 1002001015, '账号未登陆', '2019-06-01 12:03:44');
INSERT INTO `access_log` VALUES (18887, '65.52.15593618265893231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.97.221', '2019-06-01 12:03:47', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 12:03:47');
INSERT INTO `access_log` VALUES (18888, '65.47.15593618405783261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.97.221', '2019-06-01 12:04:01', 403, 0, '', '2019-06-01 12:04:01');
INSERT INTO `access_log` VALUES (18889, '65.49.15593618414143257', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.97.221', '2019-06-01 12:04:01', 11, 0, '', '2019-06-01 12:04:01');
INSERT INTO `access_log` VALUES (18890, '65.45.15593618414153255', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.97.221', '2019-06-01 12:04:01', 11, 0, '', '2019-06-01 12:04:01');
INSERT INTO `access_log` VALUES (18891, '65.51.15593618414163241', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.97.221', '2019-06-01 12:04:01', 12, 0, '', '2019-06-01 12:04:01');
INSERT INTO `access_log` VALUES (18892, '64.78.15593618488473157', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.97.221', '2019-06-01 12:04:09', 20, 0, '', '2019-06-01 12:04:09');
INSERT INTO `access_log` VALUES (18893, '64.82.15593618488473159', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.97.221', '2019-06-01 12:04:09', 24, 0, '', '2019-06-01 12:04:09');
INSERT INTO `access_log` VALUES (18894, '59.76.15593633172373701', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.131.110.11', '2019-06-01 12:28:37', 15, 2001001000, '服务端发生异常', '2019-06-01 12:28:37');
INSERT INTO `access_log` VALUES (18895, '59.77.15593633172363701', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.131.110.11', '2019-06-01 12:28:37', 406, 0, '', '2019-06-01 12:28:38');
INSERT INTO `access_log` VALUES (18896, '64.78.15593633222023177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.131.110.11', '2019-06-01 12:28:42', 5, 0, '', '2019-06-01 12:28:42');
INSERT INTO `access_log` VALUES (18897, '64.82.15593633223213179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.131.110.11', '2019-06-01 12:28:42', 3, 0, '', '2019-06-01 12:28:42');
INSERT INTO `access_log` VALUES (18898, '64.80.15593633248163167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.131.110.11', '2019-06-01 12:28:45', 2, 0, '', '2019-06-01 12:28:45');
INSERT INTO `access_log` VALUES (18899, '64.79.15593633254053165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.131.110.11', '2019-06-01 12:28:45', 3, 0, '', '2019-06-01 12:28:45');
INSERT INTO `access_log` VALUES (18900, '64.83.15593633312403167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.131.110.11', '2019-06-01 12:28:51', 114, 0, '', '2019-06-01 12:28:51');
INSERT INTO `access_log` VALUES (18901, '64.85.15593633314903179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.131.110.11', '2019-06-01 12:28:51', 2, 0, '', '2019-06-01 12:28:51');
INSERT INTO `access_log` VALUES (18902, '64.81.15593633323073169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.131.110.11', '2019-06-01 12:28:52', 2, 0, '', '2019-06-01 12:28:52');
INSERT INTO `access_log` VALUES (18903, '64.77.15593633328363175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.131.110.11', '2019-06-01 12:28:53', 267, 0, '', '2019-06-01 12:28:53');
INSERT INTO `access_log` VALUES (18904, '59.74.15593633543513703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.131.110.11', '2019-06-01 12:29:14', 4, 0, '', '2019-06-01 12:29:14');
INSERT INTO `access_log` VALUES (18905, '59.73.15593633543533711', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.131.110.11', '2019-06-01 12:29:14', 20, 2001001000, '服务端发生异常', '2019-06-01 12:29:14');
INSERT INTO `access_log` VALUES (18906, '65.48.15593636925033277', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:34:53', 1, 1002001015, '账号未登陆', '2019-06-01 12:34:53');
INSERT INTO `access_log` VALUES (18907, '65.53.15593636925093257', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:34:53', 0, 1002001015, '账号未登陆', '2019-06-01 12:34:53');
INSERT INTO `access_log` VALUES (18908, '65.50.15593636925113283', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:34:53', 1, 1002001015, '账号未登陆', '2019-06-01 12:34:53');
INSERT INTO `access_log` VALUES (18909, '65.52.15593636943663261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:34:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 12:34:54');
INSERT INTO `access_log` VALUES (18910, '65.47.15593637018613289', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:35:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 12:35:02');
INSERT INTO `access_log` VALUES (18911, '65.49.15593637235143281', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:35:24', 97, 1002002000, '账号不存在', '2019-06-01 12:35:24');
INSERT INTO `access_log` VALUES (18912, '65.46.15593637368353267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:35:37', 66, 0, '', '2019-06-01 12:35:37');
INSERT INTO `access_log` VALUES (18913, '65.53.15593637372533259', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:35:37', 14, 0, '', '2019-06-01 12:35:37');
INSERT INTO `access_log` VALUES (18914, '65.48.15593637372533279', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:35:37', 15, 0, '', '2019-06-01 12:35:37');
INSERT INTO `access_log` VALUES (18915, '65.50.15593637372593285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:35:37', 11, 0, '', '2019-06-01 12:35:37');
INSERT INTO `access_log` VALUES (18916, '62.88.15593637437403603', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:35:44', 22, 0, '', '2019-06-01 12:35:44');
INSERT INTO `access_log` VALUES (18917, '62.81.15593637472983593', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:35:47', 13, 0, '', '2019-06-01 12:35:47');
INSERT INTO `access_log` VALUES (18918, '62.86.15593637565333597', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:35:57', 508, 0, '', '2019-06-01 12:35:57');
INSERT INTO `access_log` VALUES (18919, '59.73.15593637666313717', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:07', 13, 0, '', '2019-06-01 12:36:07');
INSERT INTO `access_log` VALUES (18920, '59.74.15593637720303709', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=20', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:12', 11, 0, '', '2019-06-01 12:36:12');
INSERT INTO `access_log` VALUES (18921, '65.51.15593637743793269', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:14', 20, 0, '', '2019-06-01 12:36:14');
INSERT INTO `access_log` VALUES (18922, '65.49.15593637766593283', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:17', 9, 0, '', '2019-06-01 12:36:17');
INSERT INTO `access_log` VALUES (18923, '65.54.15593637780793253', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:18', 9, 0, '', '2019-06-01 12:36:18');
INSERT INTO `access_log` VALUES (18924, '65.46.15593637787053269', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:19', 277, 0, '', '2019-06-01 12:36:19');
INSERT INTO `access_log` VALUES (18925, '66.57.15593637802522563', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:20', 99, 0, '', '2019-06-01 12:36:20');
INSERT INTO `access_log` VALUES (18926, '59.78.15593637816613715', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:22', 26, 2001001000, '服务端发生异常', '2019-06-01 12:36:22');
INSERT INTO `access_log` VALUES (18927, '66.50.15593637848032565', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:25', 14, 0, '', '2019-06-01 12:36:25');
INSERT INTO `access_log` VALUES (18928, '65.50.15593637852573287', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:25', 15, 0, '', '2019-06-01 12:36:25');
INSERT INTO `access_log` VALUES (18929, '65.53.15593637854323261', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:25', 10, 0, '', '2019-06-01 12:36:25');
INSERT INTO `access_log` VALUES (18930, '65.45.15593637862073285', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:26', 10, 0, '', '2019-06-01 12:36:26');
INSERT INTO `access_log` VALUES (18931, '65.52.15593637869753265', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:27', 18, 0, '', '2019-06-01 12:36:27');
INSERT INTO `access_log` VALUES (18932, '59.72.15593637878893709', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:28', 11, 0, '', '2019-06-01 12:36:28');
INSERT INTO `access_log` VALUES (18933, '62.80.15593637895123607', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:30', 15, 0, '', '2019-06-01 12:36:30');
INSERT INTO `access_log` VALUES (18934, '62.85.15593637902923603', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:30', 10, 0, '', '2019-06-01 12:36:30');
INSERT INTO `access_log` VALUES (18935, '62.82.15593637925643607', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:33', 13, 0, '', '2019-06-01 12:36:33');
INSERT INTO `access_log` VALUES (18936, '59.77.15593638003203709', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:40', 3, 0, '', '2019-06-01 12:36:40');
INSERT INTO `access_log` VALUES (18937, '59.76.15593638003243709', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:36:40', 13, 2001001000, '服务端发生异常', '2019-06-01 12:36:40');
INSERT INTO `access_log` VALUES (18938, '64.80.15593638360333175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:37:16', 4, 0, '', '2019-06-01 12:37:16');
INSERT INTO `access_log` VALUES (18939, '64.79.15593638364003173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:37:16', 2, 0, '', '2019-06-01 12:37:16');
INSERT INTO `access_log` VALUES (18940, '64.76.15593638375903175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:37:18', 2, 0, '', '2019-06-01 12:37:18');
INSERT INTO `access_log` VALUES (18941, '64.83.15593638380613175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:37:18', 2, 0, '', '2019-06-01 12:37:18');
INSERT INTO `access_log` VALUES (18942, '64.81.15593638408633177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:37:21', 2, 0, '', '2019-06-01 12:37:21');
INSERT INTO `access_log` VALUES (18943, '64.77.15593638409823183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:37:21', 2, 0, '', '2019-06-01 12:37:21');
INSERT INTO `access_log` VALUES (18944, '64.84.15593638452723185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:37:25', 2, 0, '', '2019-06-01 12:37:25');
INSERT INTO `access_log` VALUES (18945, '64.78.15593638454223187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:37:25', 2, 0, '', '2019-06-01 12:37:25');
INSERT INTO `access_log` VALUES (18946, '59.74.15593638459093711', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:37:26', 3, 0, '', '2019-06-01 12:37:26');
INSERT INTO `access_log` VALUES (18947, '59.79.15593638459093715', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '211.143.72.146', '2019-06-01 12:37:26', 13, 2001001000, '服务端发生异常', '2019-06-01 12:37:26');
INSERT INTO `access_log` VALUES (18948, '65.51.15593647115683283', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:51:52', 0, 1002001015, '账号未登陆', '2019-06-01 12:51:52');
INSERT INTO `access_log` VALUES (18949, '65.49.15593647115683297', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:51:52', 0, 1002001015, '账号未登陆', '2019-06-01 12:51:52');
INSERT INTO `access_log` VALUES (18950, '65.54.15593647115703267', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:51:52', 1, 1002001015, '账号未登陆', '2019-06-01 12:51:52');
INSERT INTO `access_log` VALUES (18951, '65.46.15593647132773283', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:51:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 12:51:53');
INSERT INTO `access_log` VALUES (18952, '65.53.15593647319613275', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:12', 97, 0, '', '2019-06-01 12:52:12');
INSERT INTO `access_log` VALUES (18953, '65.45.15593647327203299', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:13', 9, 0, '', '2019-06-01 12:52:13');
INSERT INTO `access_log` VALUES (18954, '65.52.15593647327233279', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:13', 8, 0, '', '2019-06-01 12:52:13');
INSERT INTO `access_log` VALUES (18955, '65.47.15593647327323307', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:13', 10, 0, '', '2019-06-01 12:52:13');
INSERT INTO `access_log` VALUES (18956, '62.89.15593647409883615', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:21', 165, 0, '', '2019-06-01 12:52:21');
INSERT INTO `access_log` VALUES (18957, '59.78.15593647459553729', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:26', 13, 0, '', '2019-06-01 12:52:26');
INSERT INTO `access_log` VALUES (18958, '65.51.15593647488603285', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:29', 19, 0, '', '2019-06-01 12:52:29');
INSERT INTO `access_log` VALUES (18959, '65.54.15593647497383269', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:30', 167, 0, '', '2019-06-01 12:52:30');
INSERT INTO `access_log` VALUES (18960, '65.46.15593647520693285', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:32', 116, 0, '', '2019-06-01 12:52:32');
INSERT INTO `access_log` VALUES (18961, '65.48.15593647528943297', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:33', 14, 0, '', '2019-06-01 12:52:33');
INSERT INTO `access_log` VALUES (18962, '62.83.15593647558223617', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:36', 12, 0, '', '2019-06-01 12:52:36');
INSERT INTO `access_log` VALUES (18963, '62.85.15593647577353617', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:38', 13, 0, '', '2019-06-01 12:52:38');
INSERT INTO `access_log` VALUES (18964, '62.82.15593647586373621', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:39', 12, 0, '', '2019-06-01 12:52:39');
INSERT INTO `access_log` VALUES (18965, '62.87.15593647649313617', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:45', 13, 0, '', '2019-06-01 12:52:45');
INSERT INTO `access_log` VALUES (18966, '62.81.15593647714913609', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:51', 16, 0, '', '2019-06-01 12:52:52');
INSERT INTO `access_log` VALUES (18967, '64.79.15593647739243187', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:54', 13, 0, '', '2019-06-01 12:52:54');
INSERT INTO `access_log` VALUES (18968, '64.76.15593647739293189', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:52:54', 10, 0, '', '2019-06-01 12:52:54');
INSERT INTO `access_log` VALUES (18969, '64.81.15593648048383191', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:53:25', 13, 0, '', '2019-06-01 12:53:25');
INSERT INTO `access_log` VALUES (18970, '59.75.15593648220083727', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:53:42', 12, 0, '', '2019-06-01 12:53:42');
INSERT INTO `access_log` VALUES (18971, '59.73.15593648241663733', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:53:44', 21, 2001001000, '服务端发生异常', '2019-06-01 12:53:44');
INSERT INTO `access_log` VALUES (18972, '59.74.15593648276133725', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.200.209.49', '2019-06-01 12:53:48', 13, 0, '', '2019-06-01 12:53:48');
INSERT INTO `access_log` VALUES (18973, '65.49.15593652830773307', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.20.218', '2019-06-01 13:01:23', 1, 1002001015, '账号未登陆', '2019-06-01 13:01:23');
INSERT INTO `access_log` VALUES (18974, '65.54.15593652830793277', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.20.218', '2019-06-01 13:01:23', 0, 1002001015, '账号未登陆', '2019-06-01 13:01:23');
INSERT INTO `access_log` VALUES (18975, '65.51.15593652830793293', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.20.218', '2019-06-01 13:01:23', 0, 1002001015, '账号未登陆', '2019-06-01 13:01:23');
INSERT INTO `access_log` VALUES (18976, '65.48.15593652908803305', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.20.218', '2019-06-01 13:01:31', 95, 0, '', '2019-06-01 13:01:31');
INSERT INTO `access_log` VALUES (18977, '65.50.15593652912393311', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.20.218', '2019-06-01 13:01:31', 11, 0, '', '2019-06-01 13:01:31');
INSERT INTO `access_log` VALUES (18978, '65.53.15593652912463285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.20.218', '2019-06-01 13:01:31', 9, 0, '', '2019-06-01 13:01:31');
INSERT INTO `access_log` VALUES (18979, '65.45.15593652912463309', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.20.218', '2019-06-01 13:01:31', 9, 0, '', '2019-06-01 13:01:31');
INSERT INTO `access_log` VALUES (18980, '65.52.15593653104333289', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.20.218', '2019-06-01 13:01:50', 10, 0, '', '2019-06-01 13:01:50');
INSERT INTO `access_log` VALUES (18981, '65.51.15593653104383295', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.20.218', '2019-06-01 13:01:50', 8, 0, '', '2019-06-01 13:01:50');
INSERT INTO `access_log` VALUES (18982, '65.49.15593653104393309', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.20.218', '2019-06-01 13:01:50', 8, 0, '', '2019-06-01 13:01:50');
INSERT INTO `access_log` VALUES (18983, '65.50.15593653491633313', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.20.218', '2019-06-01 13:02:29', 11, 0, '', '2019-06-01 13:02:29');
INSERT INTO `access_log` VALUES (18984, '65.45.15593653491673311', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.20.218', '2019-06-01 13:02:29', 9, 0, '', '2019-06-01 13:02:29');
INSERT INTO `access_log` VALUES (18985, '65.53.15593653491693287', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.20.218', '2019-06-01 13:02:29', 9, 0, '', '2019-06-01 13:02:29');
INSERT INTO `access_log` VALUES (18986, '65.45.15593659134733319', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:11:53', 1, 1002001015, '账号未登陆', '2019-06-01 13:11:53');
INSERT INTO `access_log` VALUES (18987, '65.50.15593659135383321', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:11:54', 0, 1002001015, '账号未登陆', '2019-06-01 13:11:54');
INSERT INTO `access_log` VALUES (18988, '65.53.15593659137723295', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:11:54', 1, 1002001015, '账号未登陆', '2019-06-01 13:11:54');
INSERT INTO `access_log` VALUES (18989, '65.49.15593659196443319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:00', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 13:12:00');
INSERT INTO `access_log` VALUES (18990, '65.52.15593659352883299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:15', 64, 0, '', '2019-06-01 13:12:15');
INSERT INTO `access_log` VALUES (18991, '65.54.15593659369153289', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:17', 9, 0, '', '2019-06-01 13:12:17');
INSERT INTO `access_log` VALUES (18992, '65.46.15593659369723305', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:17', 10, 0, '', '2019-06-01 13:12:17');
INSERT INTO `access_log` VALUES (18993, '65.48.15593659369763317', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:17', 9, 0, '', '2019-06-01 13:12:17');
INSERT INTO `access_log` VALUES (18994, '65.50.15593659444733323', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:24', 9, 0, '', '2019-06-01 13:12:24');
INSERT INTO `access_log` VALUES (18995, '65.47.15593659445033329', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:25', 9, 0, '', '2019-06-01 13:12:25');
INSERT INTO `access_log` VALUES (18996, '65.53.15593659445203297', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:25', 9, 0, '', '2019-06-01 13:12:25');
INSERT INTO `access_log` VALUES (18997, '65.49.15593659518413321', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:32', 49, 0, '', '2019-06-01 13:12:32');
INSERT INTO `access_log` VALUES (18998, '65.51.15593659518783307', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:32', 17, 0, '', '2019-06-01 13:12:32');
INSERT INTO `access_log` VALUES (18999, '65.52.15593659518913301', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:32', 8, 0, '', '2019-06-01 13:12:32');
INSERT INTO `access_log` VALUES (19000, '62.83.15593659527983635', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:33', 204, 0, '', '2019-06-01 13:12:33');
INSERT INTO `access_log` VALUES (19001, '65.46.15593659640293307', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:44', 9, 0, '', '2019-06-01 13:12:44');
INSERT INTO `access_log` VALUES (19002, '65.48.15593659640813319', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:44', 9, 0, '', '2019-06-01 13:12:44');
INSERT INTO `access_log` VALUES (19003, '65.45.15593659642633323', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:44', 10, 0, '', '2019-06-01 13:12:44');
INSERT INTO `access_log` VALUES (19004, '64.83.15593659653403205', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:45', 14, 0, '', '2019-06-01 13:12:45');
INSERT INTO `access_log` VALUES (19005, '64.85.15593659653833217', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:45', 9, 0, '', '2019-06-01 13:12:45');
INSERT INTO `access_log` VALUES (19006, '65.47.15593659738473331', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:54', 9, 0, '', '2019-06-01 13:12:54');
INSERT INTO `access_log` VALUES (19007, '65.50.15593659739053325', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:54', 9, 0, '', '2019-06-01 13:12:54');
INSERT INTO `access_log` VALUES (19008, '65.51.15593659740033309', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:54', 10, 0, '', '2019-06-01 13:12:54');
INSERT INTO `access_log` VALUES (19009, '65.52.15593659743483303', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/61.0.3163.128 Safari/534.24 XiaoMi/MiuiBrowser/10.8.0', '124.64.16.100', '2019-06-01 13:12:54', 11, 0, '', '2019-06-01 13:12:54');
INSERT INTO `access_log` VALUES (19010, '65.51.15593660970923311', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:14:57', 141, 1002001012, '访问令牌已过期', '2019-06-01 13:14:57');
INSERT INTO `access_log` VALUES (19011, '65.52.15593660971043305', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:14:57', 129, 1002001012, '访问令牌已过期', '2019-06-01 13:14:57');
INSERT INTO `access_log` VALUES (19012, '65.49.15593660971223325', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:14:57', 111, 1002001012, '访问令牌已过期', '2019-06-01 13:14:57');
INSERT INTO `access_log` VALUES (19013, '65.54.15593660972613295', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:14:57', 14, 1002001012, '访问令牌已过期', '2019-06-01 13:14:57');
INSERT INTO `access_log` VALUES (19014, '65.46.15593661049283311', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:15:05', 80, 0, '', '2019-06-01 13:15:05');
INSERT INTO `access_log` VALUES (19015, '65.48.15593661052973323', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:15:05', 9, 0, '', '2019-06-01 13:15:05');
INSERT INTO `access_log` VALUES (19016, '65.47.15593661053023335', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:15:05', 9, 0, '', '2019-06-01 13:15:05');
INSERT INTO `access_log` VALUES (19017, '65.45.15593661053013327', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:15:05', 10, 0, '', '2019-06-01 13:15:05');
INSERT INTO `access_log` VALUES (19018, '65.53.15593661083113303', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:15:08', 19, 0, '', '2019-06-01 13:15:08');
INSERT INTO `access_log` VALUES (19019, '65.52.15593661162753307', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:15:16', 511, 0, '', '2019-06-01 13:15:17');
INSERT INTO `access_log` VALUES (19020, '65.49.15593661213393327', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:15:21', 31, 0, '', '2019-06-01 13:15:21');
INSERT INTO `access_log` VALUES (19021, '65.54.15593661288153297', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.168.23.23', '2019-06-01 13:15:29', 0, 1002001015, '账号未登陆', '2019-06-01 13:15:29');
INSERT INTO `access_log` VALUES (19022, '65.46.15593661288153313', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.168.23.23', '2019-06-01 13:15:29', 0, 1002001015, '账号未登陆', '2019-06-01 13:15:29');
INSERT INTO `access_log` VALUES (19023, '65.45.15593661288173329', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.168.23.23', '2019-06-01 13:15:29', 0, 1002001015, '账号未登陆', '2019-06-01 13:15:29');
INSERT INTO `access_log` VALUES (19024, '65.47.15593661449223337', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.168.23.23', '2019-06-01 13:15:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 13:15:45');
INSERT INTO `access_log` VALUES (19025, '65.53.15593661488503305', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.168.23.23', '2019-06-01 13:15:49', 65, 0, '', '2019-06-01 13:15:49');
INSERT INTO `access_log` VALUES (19026, '65.50.15593661493133331', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.168.23.23', '2019-06-01 13:15:49', 8, 0, '', '2019-06-01 13:15:49');
INSERT INTO `access_log` VALUES (19027, '65.52.15593661493293309', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.168.23.23', '2019-06-01 13:15:49', 8, 0, '', '2019-06-01 13:15:49');
INSERT INTO `access_log` VALUES (19028, '65.49.15593661493293329', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.168.23.23', '2019-06-01 13:15:49', 8, 0, '', '2019-06-01 13:15:49');
INSERT INTO `access_log` VALUES (19029, '65.54.15593661580403299', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:15:58', 12, 0, '', '2019-06-01 13:15:58');
INSERT INTO `access_log` VALUES (19030, '62.88.15593661612143639', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.168.23.23', '2019-06-01 13:16:01', 14, 0, '', '2019-06-01 13:16:01');
INSERT INTO `access_log` VALUES (19031, '65.45.15593661724263331', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:16:12', 20, 0, '', '2019-06-01 13:16:12');
INSERT INTO `access_log` VALUES (19032, '65.48.15593661738493327', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:16:14', 11, 0, '', '2019-06-01 13:16:14');
INSERT INTO `access_log` VALUES (19033, '65.47.15593661751463339', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:16:15', 13, 0, '', '2019-06-01 13:16:15');
INSERT INTO `access_log` VALUES (19034, '65.53.15593661771163307', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:16:17', 10, 0, '', '2019-06-01 13:16:17');
INSERT INTO `access_log` VALUES (19035, '65.49.15593661813143331', 27, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=2&resourceIds=31', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:16:21', 7, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-01 13:16:21');
INSERT INTO `access_log` VALUES (19036, '65.52.15593661873383311', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:16:27', 12, 0, '', '2019-06-01 13:16:27');
INSERT INTO `access_log` VALUES (19037, '65.51.15593661924043317', 27, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=2&resourceIds=29,30,31', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:16:32', 7, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-01 13:16:32');
INSERT INTO `access_log` VALUES (19038, '65.46.15593662042363317', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:16:44', 11, 0, '', '2019-06-01 13:16:44');
INSERT INTO `access_log` VALUES (19039, '65.48.15593662085443329', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.153.190', '2019-06-01 13:16:49', 0, 1002001015, '账号未登陆', '2019-06-01 13:16:49');
INSERT INTO `access_log` VALUES (19040, '65.45.15593662085433333', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.153.190', '2019-06-01 13:16:49', 0, 1002001015, '账号未登陆', '2019-06-01 13:16:49');
INSERT INTO `access_log` VALUES (19041, '65.47.15593662085523341', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.153.190', '2019-06-01 13:16:49', 1, 1002001015, '账号未登陆', '2019-06-01 13:16:49');
INSERT INTO `access_log` VALUES (19042, '65.49.15593662199473333', 27, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=6&resourceIds=13,14,15,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,41,42,43,44,45,46,47,48,49,50,51,52,53', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:17:00', 7, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-01 13:17:00');
INSERT INTO `access_log` VALUES (19043, '65.50.15593662278793335', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.153.190', '2019-06-01 13:17:08', 108, 0, '', '2019-06-01 13:17:08');
INSERT INTO `access_log` VALUES (19044, '65.51.15593662283043319', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.153.190', '2019-06-01 13:17:08', 9, 0, '', '2019-06-01 13:17:08');
INSERT INTO `access_log` VALUES (19045, '65.52.15593662283033313', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.153.190', '2019-06-01 13:17:08', 9, 0, '', '2019-06-01 13:17:08');
INSERT INTO `access_log` VALUES (19046, '65.54.15593662283083303', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.153.190', '2019-06-01 13:17:08', 9, 0, '', '2019-06-01 13:17:08');
INSERT INTO `access_log` VALUES (19047, '65.48.15593662350803331', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:17:15', 13, 0, '', '2019-06-01 13:17:15');
INSERT INTO `access_log` VALUES (19048, '65.45.15593662371053335', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:17:17', 11, 0, '', '2019-06-01 13:17:17');
INSERT INTO `access_log` VALUES (19049, '62.85.15593662376983639', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.153.190', '2019-06-01 13:17:18', 13, 0, '', '2019-06-01 13:17:18');
INSERT INTO `access_log` VALUES (19050, '65.47.15593662406753343', 27, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=2&resourceIds=20,21,22,29,30,31', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:17:21', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-01 13:17:21');
INSERT INTO `access_log` VALUES (19051, '64.81.15593662420903211', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.153.190', '2019-06-01 13:17:22', 9, 0, '', '2019-06-01 13:17:22');
INSERT INTO `access_log` VALUES (19052, '64.85.15593662420873221', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.153.190', '2019-06-01 13:17:22', 12, 0, '', '2019-06-01 13:17:22');
INSERT INTO `access_log` VALUES (19053, '65.49.15593662480183335', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:17:28', 8, 0, '', '2019-06-01 13:17:28');
INSERT INTO `access_log` VALUES (19054, '65.50.15593662480243337', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:17:28', 8, 0, '', '2019-06-01 13:17:28');
INSERT INTO `access_log` VALUES (19055, '65.54.15593662480643305', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:17:28', 8, 0, '', '2019-06-01 13:17:28');
INSERT INTO `access_log` VALUES (19056, '65.52.15593662481373315', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:17:28', 9, 0, '', '2019-06-01 13:17:28');
INSERT INTO `access_log` VALUES (19057, '65.51.15593662517783321', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:17:32', 12, 0, '', '2019-06-01 13:17:32');
INSERT INTO `access_log` VALUES (19058, '66.53.15593662523562599', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.153.190', '2019-06-01 13:17:32', 22, 0, '', '2019-06-01 13:17:32');
INSERT INTO `access_log` VALUES (19059, '59.71.15593662596613751', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.153.190', '2019-06-01 13:17:40', 319, 0, '', '2019-06-01 13:17:40');
INSERT INTO `access_log` VALUES (19060, '65.47.15593662950493345', 27, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=2&resourceIds=31,51,52,53', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:18:15', 475, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-01 13:18:16');
INSERT INTO `access_log` VALUES (19061, '65.53.15593663003663313', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:18:20', 12, 0, '', '2019-06-01 13:18:20');
INSERT INTO `access_log` VALUES (19062, '65.50.15593663179863339', 27, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=6&resourceIds=51,52,53', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:18:38', 7, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-01 13:18:38');
INSERT INTO `access_log` VALUES (19063, '65.52.15593663226243317', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:18:43', 14, 0, '', '2019-06-01 13:18:43');
INSERT INTO `access_log` VALUES (19064, '65.51.15593663266653323', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:18:47', 12, 0, '', '2019-06-01 13:18:47');
INSERT INTO `access_log` VALUES (19065, '65.48.15593663340903335', 27, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=2&resourceIds=31,51,52,53', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:18:54', 5, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-01 13:18:54');
INSERT INTO `access_log` VALUES (19066, '65.50.15593665572663343', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:22:37', 14, 0, '', '2019-06-01 13:22:37');
INSERT INTO `access_log` VALUES (19067, '65.54.15593665584403311', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-01 13:22:38', 110, 0, '', '2019-06-01 13:22:39');
INSERT INTO `access_log` VALUES (19068, '65.52.15593669865643327', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.4.3000', '171.83.55.71', '2019-06-01 13:29:47', 1, 1002001015, '账号未登陆', '2019-06-01 13:29:47');
INSERT INTO `access_log` VALUES (19069, '65.54.15593669865633317', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.4.3000', '171.83.55.71', '2019-06-01 13:29:47', 1, 1002001015, '账号未登陆', '2019-06-01 13:29:47');
INSERT INTO `access_log` VALUES (19070, '65.51.15593669865663333', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.4.3000', '171.83.55.71', '2019-06-01 13:29:47', 1, 1002001015, '账号未登陆', '2019-06-01 13:29:47');
INSERT INTO `access_log` VALUES (19071, '65.46.15593669888343333', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.4.3000', '171.83.55.71', '2019-06-01 13:29:49', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 13:29:49');
INSERT INTO `access_log` VALUES (19072, '65.45.15593670058663349', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36 Maxthon/5.2.4.3000', '171.83.55.71', '2019-06-01 13:30:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 13:30:06');
INSERT INTO `access_log` VALUES (19073, '65.48.15593675521453353', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.120', '2019-06-01 13:39:12', 1, 1002001015, '账号未登陆', '2019-06-01 13:39:12');
INSERT INTO `access_log` VALUES (19074, '65.46.15593675521453341', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.120', '2019-06-01 13:39:12', 0, 1002001015, '账号未登陆', '2019-06-01 13:39:12');
INSERT INTO `access_log` VALUES (19075, '65.45.15593675521513357', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.120', '2019-06-01 13:39:12', 1, 1002001015, '账号未登陆', '2019-06-01 13:39:12');
INSERT INTO `access_log` VALUES (19076, '65.47.15593675596543365', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.120', '2019-06-01 13:39:20', 54, 0, '', '2019-06-01 13:39:20');
INSERT INTO `access_log` VALUES (19077, '65.53.15593675601523333', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.120', '2019-06-01 13:39:20', 11, 0, '', '2019-06-01 13:39:20');
INSERT INTO `access_log` VALUES (19078, '65.49.15593675601623357', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.120', '2019-06-01 13:39:20', 9, 0, '', '2019-06-01 13:39:20');
INSERT INTO `access_log` VALUES (19079, '65.50.15593675601813359', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.120', '2019-06-01 13:39:20', 8, 0, '', '2019-06-01 13:39:20');
INSERT INTO `access_log` VALUES (19080, '62.87.15593675694863657', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.120', '2019-06-01 13:39:29', 17, 0, '', '2019-06-01 13:39:30');
INSERT INTO `access_log` VALUES (19081, '65.54.15593675824133327', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.120', '2019-06-01 13:39:42', 10, 0, '', '2019-06-01 13:39:42');
INSERT INTO `access_log` VALUES (19082, '65.45.15593675910543359', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.120', '2019-06-01 13:39:51', 11, 0, '', '2019-06-01 13:39:51');
INSERT INTO `access_log` VALUES (19083, '66.52.15593676043952615', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.120', '2019-06-01 13:40:04', 15, 0, '', '2019-06-01 13:40:04');
INSERT INTO `access_log` VALUES (19084, '64.84.15593676132703237', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.120', '2019-06-01 13:40:13', 10, 0, '', '2019-06-01 13:40:13');
INSERT INTO `access_log` VALUES (19085, '65.48.15593681883303363', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.246.105.137', '2019-06-01 13:49:48', 1, 1002001015, '账号未登陆', '2019-06-01 13:49:48');
INSERT INTO `access_log` VALUES (19086, '65.47.15593681883403375', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.246.105.137', '2019-06-01 13:49:48', 1, 1002001015, '账号未登陆', '2019-06-01 13:49:48');
INSERT INTO `access_log` VALUES (19087, '65.46.15593681883253351', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.246.105.137', '2019-06-01 13:49:48', 1, 1002001015, '账号未登陆', '2019-06-01 13:49:48');
INSERT INTO `access_log` VALUES (19088, '65.49.15593681923683367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.246.105.137', '2019-06-01 13:49:52', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 13:49:52');
INSERT INTO `access_log` VALUES (19089, '65.50.15593681961643369', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.246.105.137', '2019-06-01 13:49:56', 87, 0, '', '2019-06-01 13:49:56');
INSERT INTO `access_log` VALUES (19090, '65.51.15593681965233353', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.246.105.137', '2019-06-01 13:49:57', 18, 0, '', '2019-06-01 13:49:57');
INSERT INTO `access_log` VALUES (19091, '65.52.15593681965233347', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.246.105.137', '2019-06-01 13:49:57', 19, 0, '', '2019-06-01 13:49:57');
INSERT INTO `access_log` VALUES (19092, '65.54.15593681965353337', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.246.105.137', '2019-06-01 13:49:57', 9, 0, '', '2019-06-01 13:49:57');
INSERT INTO `access_log` VALUES (19093, '62.83.15593682021373665', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.246.105.137', '2019-06-01 13:50:02', 14, 0, '', '2019-06-01 13:50:02');
INSERT INTO `access_log` VALUES (19094, '64.78.15593682054503247', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.246.105.137', '2019-06-01 13:50:05', 10, 0, '', '2019-06-01 13:50:05');
INSERT INTO `access_log` VALUES (19095, '64.84.15593682054503245', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.246.105.137', '2019-06-01 13:50:05', 13, 0, '', '2019-06-01 13:50:05');
INSERT INTO `access_log` VALUES (19096, '64.79.15593682109923235', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.246.105.137', '2019-06-01 13:50:11', 23, 0, '', '2019-06-01 13:50:11');
INSERT INTO `access_log` VALUES (19097, '64.80.15593682109913237', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.246.105.137', '2019-06-01 13:50:11', 25, 0, '', '2019-06-01 13:50:11');
INSERT INTO `access_log` VALUES (19098, '65.45.15593683480953371', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '171.43.92.243', '2019-06-01 13:52:28', 0, 1002001015, '账号未登陆', '2019-06-01 13:52:28');
INSERT INTO `access_log` VALUES (19099, '65.46.15593683481043355', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '171.43.92.243', '2019-06-01 13:52:28', 0, 1002001015, '账号未登陆', '2019-06-01 13:52:28');
INSERT INTO `access_log` VALUES (19100, '65.48.15593683481093367', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '171.43.92.243', '2019-06-01 13:52:28', 0, 1002001015, '账号未登陆', '2019-06-01 13:52:28');
INSERT INTO `access_log` VALUES (19101, '65.47.15593683515333379', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '171.43.92.243', '2019-06-01 13:52:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 13:52:32');
INSERT INTO `access_log` VALUES (19102, '65.50.15593683800793373', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '171.43.92.243', '2019-06-01 13:53:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 13:53:00');
INSERT INTO `access_log` VALUES (19103, '65.51.15593683822373357', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '171.43.92.243', '2019-06-01 13:53:02', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 13:53:02');
INSERT INTO `access_log` VALUES (19104, '59.76.15593687863513777', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.221.122.26', '2019-06-01 13:59:46', 13, 0, '', '2019-06-01 13:59:46');
INSERT INTO `access_log` VALUES (19105, '59.71.15593687863523785', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.221.122.26', '2019-06-01 13:59:46', 16, 2001001000, '服务端发生异常', '2019-06-01 13:59:46');
INSERT INTO `access_log` VALUES (19106, '59.74.15593687950963779', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.221.122.26', '2019-06-01 13:59:55', 13, 2001001000, '服务端发生异常', '2019-06-01 13:59:55');
INSERT INTO `access_log` VALUES (19107, '59.73.15593687950963787', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.221.122.26', '2019-06-01 13:59:55', 3, 0, '', '2019-06-01 13:59:55');
INSERT INTO `access_log` VALUES (19108, '64.79.15593688013743243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.221.122.26', '2019-06-01 14:00:01', 3, 0, '', '2019-06-01 14:00:01');
INSERT INTO `access_log` VALUES (19109, '64.76.15593688014903245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.221.122.26', '2019-06-01 14:00:01', 3, 0, '', '2019-06-01 14:00:01');
INSERT INTO `access_log` VALUES (19110, '64.83.15593688029173245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.221.122.26', '2019-06-01 14:00:03', 2, 0, '', '2019-06-01 14:00:03');
INSERT INTO `access_log` VALUES (19111, '64.81.15593688036763247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.221.122.26', '2019-06-01 14:00:04', 3, 0, '', '2019-06-01 14:00:04');
INSERT INTO `access_log` VALUES (19112, '64.85.15593688045003257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.221.122.26', '2019-06-01 14:00:05', 2, 0, '', '2019-06-01 14:00:05');
INSERT INTO `access_log` VALUES (19113, '64.77.15593688048593253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.221.122.26', '2019-06-01 14:00:05', 2, 0, '', '2019-06-01 14:00:05');
INSERT INTO `access_log` VALUES (19114, '59.76.15593688522313779', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:00:52', 3, 0, '', '2019-06-01 14:00:52');
INSERT INTO `access_log` VALUES (19115, '59.77.15593688522303779', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:00:52', 12, 2001001000, '服务端发生异常', '2019-06-01 14:00:52');
INSERT INTO `access_log` VALUES (19116, '59.75.15593688698943783', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:01:10', 13, 2001001000, '服务端发生异常', '2019-06-01 14:01:10');
INSERT INTO `access_log` VALUES (19117, '59.74.15593688740783781', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:01:14', 3, 0, '', '2019-06-01 14:01:14');
INSERT INTO `access_log` VALUES (19118, '64.76.15593688773523247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:01:17', 3, 0, '', '2019-06-01 14:01:17');
INSERT INTO `access_log` VALUES (19119, '64.83.15593688774993247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:01:17', 3, 0, '', '2019-06-01 14:01:18');
INSERT INTO `access_log` VALUES (19120, '64.85.15593688805433259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:01:21', 2, 0, '', '2019-06-01 14:01:21');
INSERT INTO `access_log` VALUES (19121, '64.77.15593688811323255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:01:21', 2, 0, '', '2019-06-01 14:01:21');
INSERT INTO `access_log` VALUES (19122, '64.78.15593688817633259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:01:22', 2, 0, '', '2019-06-01 14:01:22');
INSERT INTO `access_log` VALUES (19123, '66.52.15593688876702633', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:01:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机号不能为空\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空', '2019-06-01 14:01:28');
INSERT INTO `access_log` VALUES (19124, '64.84.15593688907073257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:01:31', 247, 0, '', '2019-06-01 14:01:31');
INSERT INTO `access_log` VALUES (19125, '64.82.15593688911153261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:01:31', 2, 0, '', '2019-06-01 14:01:31');
INSERT INTO `access_log` VALUES (19126, '65.49.15593689104403379', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:01:50', 1, 1002001015, '账号未登陆', '2019-06-01 14:01:50');
INSERT INTO `access_log` VALUES (19127, '65.47.15593689104403387', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:01:50', 1, 1002001015, '账号未登陆', '2019-06-01 14:01:50');
INSERT INTO `access_log` VALUES (19128, '65.53.15593689104423355', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:01:50', 0, 1002001015, '账号未登陆', '2019-06-01 14:01:50');
INSERT INTO `access_log` VALUES (19129, '65.50.15593689131993381', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:01:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 14:01:53');
INSERT INTO `access_log` VALUES (19130, '65.54.15593689273923349', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:02:07', 151, 0, '', '2019-06-01 14:02:08');
INSERT INTO `access_log` VALUES (19131, '65.52.15593689281223359', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:02:08', 9, 0, '', '2019-06-01 14:02:08');
INSERT INTO `access_log` VALUES (19132, '65.46.15593689281233365', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:02:08', 8, 0, '', '2019-06-01 14:02:08');
INSERT INTO `access_log` VALUES (19133, '65.45.15593689281233381', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:02:08', 9, 0, '', '2019-06-01 14:02:08');
INSERT INTO `access_log` VALUES (19134, '62.83.15593689354353675', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:02:15', 12, 0, '', '2019-06-01 14:02:15');
INSERT INTO `access_log` VALUES (19135, '64.83.15593689400473249', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:02:20', 13, 0, '', '2019-06-01 14:02:20');
INSERT INTO `access_log` VALUES (19136, '64.81.15593689400513251', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:02:20', 11, 0, '', '2019-06-01 14:02:20');
INSERT INTO `access_log` VALUES (19137, '66.48.15593689431722637', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:02:23', 13, 0, '', '2019-06-01 14:02:23');
INSERT INTO `access_log` VALUES (19138, '59.76.15593689465433781', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:02:27', 12, 0, '', '2019-06-01 14:02:27');
INSERT INTO `access_log` VALUES (19139, '65.47.15593689571023389', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:02:37', 18, 0, '', '2019-06-01 14:02:37');
INSERT INTO `access_log` VALUES (19140, '65.50.15593689620363383', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '116.6.195.82', '2019-06-01 14:02:42', 10, 0, '', '2019-06-01 14:02:42');
INSERT INTO `access_log` VALUES (19141, '65.52.15593698925153373', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-01 14:18:13', 0, 1002001015, '账号未登陆', '2019-06-01 14:18:13');
INSERT INTO `access_log` VALUES (19142, '65.45.15593698925153395', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-01 14:18:13', 1, 1002001015, '账号未登陆', '2019-06-01 14:18:13');
INSERT INTO `access_log` VALUES (19143, '65.46.15593698925163379', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-01 14:18:13', 0, 1002001015, '账号未登陆', '2019-06-01 14:18:13');
INSERT INTO `access_log` VALUES (19144, '65.48.15593698955003391', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-01 14:18:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 14:18:16');
INSERT INTO `access_log` VALUES (19145, '65.53.15593700779813373', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:21:18', 1, 1002001015, '账号未登陆', '2019-06-01 14:21:18');
INSERT INTO `access_log` VALUES (19146, '65.50.15593700779813399', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:21:18', 1, 1002001015, '账号未登陆', '2019-06-01 14:21:18');
INSERT INTO `access_log` VALUES (19147, '65.51.15593700779843383', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:21:18', 1, 1002001015, '账号未登陆', '2019-06-01 14:21:18');
INSERT INTO `access_log` VALUES (19148, '65.54.15593700797313367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:21:20', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 14:21:20');
INSERT INTO `access_log` VALUES (19149, '65.46.15593700860503383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:21:26', 59, 0, '', '2019-06-01 14:21:26');
INSERT INTO `access_log` VALUES (19150, '65.45.15593700862993399', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:21:26', 19, 0, '', '2019-06-01 14:21:26');
INSERT INTO `access_log` VALUES (19151, '65.49.15593700863143399', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:21:26', 9, 0, '', '2019-06-01 14:21:26');
INSERT INTO `access_log` VALUES (19152, '65.48.15593700862993395', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:21:26', 24, 0, '', '2019-06-01 14:21:26');
INSERT INTO `access_log` VALUES (19153, '62.89.15593700931593693', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:21:33', 13, 0, '', '2019-06-01 14:21:33');
INSERT INTO `access_log` VALUES (19154, '62.83.15593700962333691', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:21:36', 15, 0, '', '2019-06-01 14:21:36');
INSERT INTO `access_log` VALUES (19155, '64.78.15593701001993277', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:21:40', 10, 0, '', '2019-06-01 14:21:40');
INSERT INTO `access_log` VALUES (19156, '64.77.15593701001973273', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:21:40', 12, 0, '', '2019-06-01 14:21:40');
INSERT INTO `access_log` VALUES (19157, '65.49.15593703442453403', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:25:44', 131, 0, '', '2019-06-01 14:25:44');
INSERT INTO `access_log` VALUES (19158, '65.46.15593703497283387', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:25:50', 10, 0, '', '2019-06-01 14:25:50');
INSERT INTO `access_log` VALUES (19159, '65.46.15593703555733389', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:25:56', 24, 0, '', '2019-06-01 14:25:56');
INSERT INTO `access_log` VALUES (19160, '65.49.15593703571273405', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:25:57', 8, 0, '', '2019-06-01 14:25:57');
INSERT INTO `access_log` VALUES (19161, '65.53.15593704846263381', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.159.242.58', '2019-06-01 14:28:05', 19, 0, '', '2019-06-01 14:28:05');
INSERT INTO `access_log` VALUES (19162, '59.75.15593705784443807', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:29:38', 12, 2001001000, '服务端发生异常', '2019-06-01 14:29:38');
INSERT INTO `access_log` VALUES (19163, '59.71.15593705784363811', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:29:38', 84, 0, '', '2019-06-01 14:29:39');
INSERT INTO `access_log` VALUES (19164, '59.73.15593705840323811', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:29:44', 3, 0, '', '2019-06-01 14:29:44');
INSERT INTO `access_log` VALUES (19165, '59.74.15593705840293807', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:29:44', 15, 2001001000, '服务端发生异常', '2019-06-01 14:29:44');
INSERT INTO `access_log` VALUES (19166, '64.80.15593705868123273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:29:47', 4, 0, '', '2019-06-01 14:29:47');
INSERT INTO `access_log` VALUES (19167, '64.79.15593705869273271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:29:47', 2, 0, '', '2019-06-01 14:29:47');
INSERT INTO `access_log` VALUES (19168, '64.76.15593705886893271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:29:49', 2, 0, '', '2019-06-01 14:29:49');
INSERT INTO `access_log` VALUES (19169, '64.83.15593705921843271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:29:52', 806, 0, '', '2019-06-01 14:29:53');
INSERT INTO `access_log` VALUES (19170, '64.85.15593705932723285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:29:53', 781, 0, '', '2019-06-01 14:29:54');
INSERT INTO `access_log` VALUES (19171, '59.78.15593706036903811', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:30:04', 3, 0, '', '2019-06-01 14:30:04');
INSERT INTO `access_log` VALUES (19172, '59.72.15593706036903805', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:30:04', 12, 2001001000, '服务端发生异常', '2019-06-01 14:30:04');
INSERT INTO `access_log` VALUES (19173, '64.78.15593706107303285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:30:11', 2, 0, '', '2019-06-01 14:30:11');
INSERT INTO `access_log` VALUES (19174, '64.84.15593706108823283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:30:11', 3, 0, '', '2019-06-01 14:30:11');
INSERT INTO `access_log` VALUES (19175, '65.53.15593706206803383', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:21', 0, 1002001015, '账号未登陆', '2019-06-01 14:30:21');
INSERT INTO `access_log` VALUES (19176, '65.54.15593706206853377', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:21', 1, 1002001015, '账号未登陆', '2019-06-01 14:30:21');
INSERT INTO `access_log` VALUES (19177, '65.52.15593706206863387', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:21', 0, 1002001015, '账号未登陆', '2019-06-01 14:30:21');
INSERT INTO `access_log` VALUES (19178, '65.48.15593706335223403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:34', 412, 0, '', '2019-06-01 14:30:34');
INSERT INTO `access_log` VALUES (19179, '65.49.15593706342163411', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:34', 199, 0, '', '2019-06-01 14:30:34');
INSERT INTO `access_log` VALUES (19180, '65.45.15593706342163409', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:34', 199, 0, '', '2019-06-01 14:30:34');
INSERT INTO `access_log` VALUES (19181, '65.47.15593706342213415', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:34', 195, 0, '', '2019-06-01 14:30:34');
INSERT INTO `access_log` VALUES (19182, '62.89.15593706379483701', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:38', 14, 0, '', '2019-06-01 14:30:38');
INSERT INTO `access_log` VALUES (19183, '62.84.15593706425543695', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:43', 24, 0, '', '2019-06-01 14:30:43');
INSERT INTO `access_log` VALUES (19184, '64.76.15593706457953273', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:46', 8, 0, '', '2019-06-01 14:30:46');
INSERT INTO `access_log` VALUES (19185, '64.79.15593706457923273', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:46', 11, 0, '', '2019-06-01 14:30:46');
INSERT INTO `access_log` VALUES (19186, '64.81.15593706496383275', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:50', 9, 0, '', '2019-06-01 14:30:50');
INSERT INTO `access_log` VALUES (19187, '64.83.15593706496383273', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:50', 12, 0, '', '2019-06-01 14:30:50');
INSERT INTO `access_log` VALUES (19188, '64.77.15593706554323283', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:55', 10, 0, '', '2019-06-01 14:30:55');
INSERT INTO `access_log` VALUES (19189, '65.53.15593706562453385', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:30:56', 3, 1002001012, '访问令牌已过期', '2019-06-01 14:30:56');
INSERT INTO `access_log` VALUES (19190, '65.54.15593706562453379', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:30:56', 5, 1002001012, '访问令牌已过期', '2019-06-01 14:30:56');
INSERT INTO `access_log` VALUES (19191, '65.52.15593706562553389', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:30:56', 3, 1002001012, '访问令牌已过期', '2019-06-01 14:30:56');
INSERT INTO `access_log` VALUES (19192, '64.78.15593706581143287', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:58', 9, 0, '', '2019-06-01 14:30:58');
INSERT INTO `access_log` VALUES (19193, '64.84.15593706581153285', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:30:58', 11, 0, '', '2019-06-01 14:30:58');
INSERT INTO `access_log` VALUES (19194, '65.46.15593706590413397', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:30:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 14:30:59');
INSERT INTO `access_log` VALUES (19195, '64.82.15593706627423293', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:31:03', 11, 0, '', '2019-06-01 14:31:03');
INSERT INTO `access_log` VALUES (19196, '64.79.15593706627463275', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:31:03', 8, 0, '', '2019-06-01 14:31:03');
INSERT INTO `access_log` VALUES (19197, '64.80.15593706627443277', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:31:03', 15, 0, '', '2019-06-01 14:31:03');
INSERT INTO `access_log` VALUES (19198, '64.81.15593706695423277', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:31:10', 9, 0, '', '2019-06-01 14:31:10');
INSERT INTO `access_log` VALUES (19199, '64.83.15593706797433275', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:31:20', 11, 0, '', '2019-06-01 14:31:20');
INSERT INTO `access_log` VALUES (19200, '64.85.15593706797433289', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:31:20', 15, 0, '', '2019-06-01 14:31:20');
INSERT INTO `access_log` VALUES (19201, '65.45.15593706822523411', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:31:22', 103, 0, '', '2019-06-01 14:31:22');
INSERT INTO `access_log` VALUES (19202, '64.84.15593706825633287', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:31:23', 12, 0, '', '2019-06-01 14:31:23');
INSERT INTO `access_log` VALUES (19203, '65.49.15593706831743413', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:31:23', 9, 0, '', '2019-06-01 14:31:23');
INSERT INTO `access_log` VALUES (19204, '65.50.15593706831743411', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:31:23', 10, 0, '', '2019-06-01 14:31:23');
INSERT INTO `access_log` VALUES (19205, '65.47.15593706831743417', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:31:23', 10, 0, '', '2019-06-01 14:31:23');
INSERT INTO `access_log` VALUES (19206, '64.78.15593706853103289', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:31:25', 10, 0, '', '2019-06-01 14:31:25');
INSERT INTO `access_log` VALUES (19207, '62.80.15593706873123703', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:31:27', 13, 0, '', '2019-06-01 14:31:27');
INSERT INTO `access_log` VALUES (19208, '64.79.15593706905013277', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:31:31', 8, 0, '', '2019-06-01 14:31:31');
INSERT INTO `access_log` VALUES (19209, '64.80.15593706904993279', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:31:31', 10, 0, '', '2019-06-01 14:31:31');
INSERT INTO `access_log` VALUES (19210, '64.82.15593706904993295', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:31:31', 13, 0, '', '2019-06-01 14:31:31');
INSERT INTO `access_log` VALUES (19211, '64.83.15593707159733277', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:31:56', 176, 0, '', '2019-06-01 14:31:56');
INSERT INTO `access_log` VALUES (19212, '64.85.15593707159733291', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:31:56', 178, 0, '', '2019-06-01 14:31:56');
INSERT INTO `access_log` VALUES (19213, '64.83.15593711332653283', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:38:53', 10, 0, '', '2019-06-01 14:38:53');
INSERT INTO `access_log` VALUES (19214, '64.85.15593711332643297', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:38:53', 13, 0, '', '2019-06-01 14:38:53');
INSERT INTO `access_log` VALUES (19215, '65.46.15593711931023405', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 14:39:53', 1, 1002001015, '账号未登陆', '2019-06-01 14:39:53');
INSERT INTO `access_log` VALUES (19216, '65.48.15593711931073413', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 14:39:53', 0, 1002001015, '账号未登陆', '2019-06-01 14:39:53');
INSERT INTO `access_log` VALUES (19217, '65.45.15593711931133419', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 14:39:53', 0, 1002001015, '账号未登陆', '2019-06-01 14:39:53');
INSERT INTO `access_log` VALUES (19218, '65.49.15593711966473421', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 14:39:57', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 14:39:57');
INSERT INTO `access_log` VALUES (19219, '65.51.15593712158103405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 14:40:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 14:40:16');
INSERT INTO `access_log` VALUES (19220, '65.52.15593712210453399', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 14:40:21', 100, 0, '', '2019-06-01 14:40:21');
INSERT INTO `access_log` VALUES (19221, '65.54.15593712214483389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 14:40:21', 9, 0, '', '2019-06-01 14:40:21');
INSERT INTO `access_log` VALUES (19222, '65.53.15593712214673395', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 14:40:21', 10, 0, '', '2019-06-01 14:40:21');
INSERT INTO `access_log` VALUES (19223, '65.48.15593712214673415', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 14:40:21', 10, 0, '', '2019-06-01 14:40:21');
INSERT INTO `access_log` VALUES (19224, '66.52.15593712271162665', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 14:40:27', 19, 0, '', '2019-06-01 14:40:27');
INSERT INTO `access_log` VALUES (19225, '66.53.15593713416122667', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:42:22', 19, 0, '', '2019-06-01 14:42:22');
INSERT INTO `access_log` VALUES (19226, '59.80.15593713471943817', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:42:27', 13, 0, '', '2019-06-01 14:42:27');
INSERT INTO `access_log` VALUES (19227, '59.76.15593713506513815', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:42:31', 21, 2001001000, '服务端发生异常', '2019-06-01 14:42:31');
INSERT INTO `access_log` VALUES (19228, '59.75.15593713543243819', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:42:34', 11, 0, '', '2019-06-01 14:42:34');
INSERT INTO `access_log` VALUES (19229, '64.82.15593713580093305', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:42:38', 99, 0, '', '2019-06-01 14:42:38');
INSERT INTO `access_log` VALUES (19230, '64.76.15593713599573287', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:42:40', 10, 0, '', '2019-06-01 14:42:40');
INSERT INTO `access_log` VALUES (19231, '59.71.15593713610373823', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:42:41', 12, 0, '', '2019-06-01 14:42:41');
INSERT INTO `access_log` VALUES (19232, '59.74.15593713634843819', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:42:43', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-01 14:42:43');
INSERT INTO `access_log` VALUES (19233, '65.46.15593713666843409', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:42:47', 18, 0, '', '2019-06-01 14:42:47');
INSERT INTO `access_log` VALUES (19234, '62.83.15593713837273709', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:43:04', 875, 0, '', '2019-06-01 14:43:05');
INSERT INTO `access_log` VALUES (19235, '64.77.15593713862413297', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:43:06', 15, 0, '', '2019-06-01 14:43:06');
INSERT INTO `access_log` VALUES (19236, '64.85.15593713862393301', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:43:06', 18, 0, '', '2019-06-01 14:43:06');
INSERT INTO `access_log` VALUES (19237, '65.52.15593713895603403', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:43:10', 15, 0, '', '2019-06-01 14:43:10');
INSERT INTO `access_log` VALUES (19238, '64.81.15593714236703291', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:43:44', 11, 0, '', '2019-06-01 14:43:44');
INSERT INTO `access_log` VALUES (19239, '64.83.15593714258423289', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:43:46', 11, 0, '', '2019-06-01 14:43:46');
INSERT INTO `access_log` VALUES (19240, '64.84.15593714301413301', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:43:50', 10, 0, '', '2019-06-01 14:43:50');
INSERT INTO `access_log` VALUES (19241, '59.75.15593714638403821', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:44:24', 4, 0, '', '2019-06-01 14:44:24');
INSERT INTO `access_log` VALUES (19242, '59.71.15593714638503825', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:44:24', 19, 2001001000, '服务端发生异常', '2019-06-01 14:44:24');
INSERT INTO `access_log` VALUES (19243, '59.73.15593714672993825', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:44:27', 2, 0, '', '2019-06-01 14:44:27');
INSERT INTO `access_log` VALUES (19244, '59.74.15593714672933821', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:44:27', 13, 2001001000, '服务端发生异常', '2019-06-01 14:44:27');
INSERT INTO `access_log` VALUES (19245, '64.79.15593714700413289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:44:30', 2, 0, '', '2019-06-01 14:44:30');
INSERT INTO `access_log` VALUES (19246, '64.82.15593714701713307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:44:30', 2, 0, '', '2019-06-01 14:44:30');
INSERT INTO `access_log` VALUES (19247, '64.77.15593714717263301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.46.78.82', '2019-06-01 14:44:32', 3, 0, '', '2019-06-01 14:44:32');
INSERT INTO `access_log` VALUES (19248, '65.45.15593715804783427', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.97.201.57', '2019-06-01 14:46:20', 1, 1002001015, '账号未登陆', '2019-06-01 14:46:20');
INSERT INTO `access_log` VALUES (19249, '65.48.15593715804783421', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.97.201.57', '2019-06-01 14:46:20', 1, 1002001015, '账号未登陆', '2019-06-01 14:46:20');
INSERT INTO `access_log` VALUES (19250, '65.47.15593715804793431', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.97.201.57', '2019-06-01 14:46:20', 0, 1002001015, '账号未登陆', '2019-06-01 14:46:20');
INSERT INTO `access_log` VALUES (19251, '65.53.15593716266213403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.97.201.57', '2019-06-01 14:47:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 14:47:07');
INSERT INTO `access_log` VALUES (19252, '65.52.15593716574783407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.97.201.57', '2019-06-01 14:47:37', 97, 0, '', '2019-06-01 14:47:38');
INSERT INTO `access_log` VALUES (19253, '65.48.15593716809153425', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.97.201.57', '2019-06-01 14:48:01', 55, 0, '', '2019-06-01 14:48:01');
INSERT INTO `access_log` VALUES (19254, '66.56.15593717505422669', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:49:11', 15, 0, '', '2019-06-01 14:49:11');
INSERT INTO `access_log` VALUES (19255, '59.79.15593717659223825', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:49:26', 13, 0, '', '2019-06-01 14:49:26');
INSERT INTO `access_log` VALUES (19256, '62.81.15593718464383707', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:50:46', 14, 0, '', '2019-06-01 14:50:46');
INSERT INTO `access_log` VALUES (19257, '59.76.15593719566993825', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:52:37', 4, 0, '', '2019-06-01 14:52:37');
INSERT INTO `access_log` VALUES (19258, '59.77.15593719566993825', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:52:37', 13, 2001001000, '服务端发生异常', '2019-06-01 14:52:37');
INSERT INTO `access_log` VALUES (19259, '64.76.15593719720193297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:52:52', 3, 0, '', '2019-06-01 14:52:52');
INSERT INTO `access_log` VALUES (19260, '64.81.15593719723713301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:52:52', 3, 0, '', '2019-06-01 14:52:52');
INSERT INTO `access_log` VALUES (19261, '64.80.15593719781193299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:52:58', 3, 0, '', '2019-06-01 14:52:58');
INSERT INTO `access_log` VALUES (19262, '64.78.15593719782913313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:52:58', 3, 0, '', '2019-06-01 14:52:58');
INSERT INTO `access_log` VALUES (19263, '59.73.15593719842793833', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:53:04', 3, 0, '', '2019-06-01 14:53:04');
INSERT INTO `access_log` VALUES (19264, '59.74.15593719842793829', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:53:04', 13, 2001001000, '服务端发生异常', '2019-06-01 14:53:04');
INSERT INTO `access_log` VALUES (19265, '64.85.15593719875313313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:53:08', 2, 0, '', '2019-06-01 14:53:08');
INSERT INTO `access_log` VALUES (19266, '64.83.15593719876913301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:53:08', 2, 0, '', '2019-06-01 14:53:08');
INSERT INTO `access_log` VALUES (19267, '64.77.15593719892993309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:53:09', 2, 0, '', '2019-06-01 14:53:09');
INSERT INTO `access_log` VALUES (19268, '64.84.15593719905393309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:53:11', 2, 0, '', '2019-06-01 14:53:11');
INSERT INTO `access_log` VALUES (19269, '64.82.15593719912313317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:53:11', 2, 0, '', '2019-06-01 14:53:11');
INSERT INTO `access_log` VALUES (19270, '64.76.15593719917593299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.142', '2019-06-01 14:53:12', 2, 0, '', '2019-06-01 14:53:12');
INSERT INTO `access_log` VALUES (19271, '65.47.15593719987283437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.97.201.57', '2019-06-01 14:53:19', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 14:53:19');
INSERT INTO `access_log` VALUES (19272, '65.50.15593720026643431', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.97.201.57', '2019-06-01 14:53:23', 64, 0, '', '2019-06-01 14:53:23');
INSERT INTO `access_log` VALUES (19273, '65.51.15593720121173419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.97.201.57', '2019-06-01 14:53:32', 130, 0, '', '2019-06-01 14:53:32');
INSERT INTO `access_log` VALUES (19274, '65.53.15593720127643411', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.97.201.57', '2019-06-01 14:53:33', 9, 0, '', '2019-06-01 14:53:33');
INSERT INTO `access_log` VALUES (19275, '65.52.15593720127683413', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.97.201.57', '2019-06-01 14:53:33', 9, 0, '', '2019-06-01 14:53:33');
INSERT INTO `access_log` VALUES (19276, '65.54.15593720127763403', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.97.201.57', '2019-06-01 14:53:33', 8, 0, '', '2019-06-01 14:53:33');
INSERT INTO `access_log` VALUES (19277, '62.84.15593720172423715', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.97.201.57', '2019-06-01 14:53:37', 14, 0, '', '2019-06-01 14:53:37');
INSERT INTO `access_log` VALUES (19278, '64.79.15593720202133301', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.97.201.57', '2019-06-01 14:53:40', 10, 0, '', '2019-06-01 14:53:40');
INSERT INTO `access_log` VALUES (19279, '64.78.15593720202133315', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.97.201.57', '2019-06-01 14:53:40', 12, 0, '', '2019-06-01 14:53:40');
INSERT INTO `access_log` VALUES (19280, '59.72.15593720232633827', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.97.201.57', '2019-06-01 14:53:43', 21, 2001001000, '服务端发生异常', '2019-06-01 14:53:43');
INSERT INTO `access_log` VALUES (19281, '65.48.15593720265343431', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.97.201.57', '2019-06-01 14:53:47', 19, 0, '', '2019-06-01 14:53:47');
INSERT INTO `access_log` VALUES (19282, '65.45.15593720271683437', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.97.201.57', '2019-06-01 14:53:47', 10, 0, '', '2019-06-01 14:53:47');
INSERT INTO `access_log` VALUES (19283, '59.71.15593723826773839', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 14:59:43', 4, 0, '', '2019-06-01 14:59:43');
INSERT INTO `access_log` VALUES (19284, '59.73.15593723826823839', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 14:59:43', 13, 2001001000, '服务端发生异常', '2019-06-01 14:59:43');
INSERT INTO `access_log` VALUES (19285, '64.82.15593723900853323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 14:59:50', 3, 0, '', '2019-06-01 14:59:50');
INSERT INTO `access_log` VALUES (19286, '64.76.15593723902413305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 14:59:50', 2, 0, '', '2019-06-01 14:59:50');
INSERT INTO `access_log` VALUES (19287, '59.79.15593723917893835', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 14:59:52', 3, 0, '', '2019-06-01 14:59:52');
INSERT INTO `access_log` VALUES (19288, '59.78.15593723917903839', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 14:59:52', 13, 2001001000, '服务端发生异常', '2019-06-01 14:59:52');
INSERT INTO `access_log` VALUES (19289, '59.72.15593723993133833', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 14:59:59', 3, 0, '', '2019-06-01 14:59:59');
INSERT INTO `access_log` VALUES (19290, '59.80.15593723993153835', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 14:59:59', 13, 2001001000, '服务端发生异常', '2019-06-01 14:59:59');
INSERT INTO `access_log` VALUES (19291, '64.80.15593724051543307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 15:00:05', 2, 0, '', '2019-06-01 15:00:05');
INSERT INTO `access_log` VALUES (19292, '64.79.15593724054173307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 15:00:05', 2, 0, '', '2019-06-01 15:00:05');
INSERT INTO `access_log` VALUES (19293, '64.85.15593724072213321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 15:00:07', 2, 0, '', '2019-06-01 15:00:07');
INSERT INTO `access_log` VALUES (19294, '64.83.15593724078723309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 15:00:08', 3, 0, '', '2019-06-01 15:00:08');
INSERT INTO `access_log` VALUES (19295, '64.77.15593724085493317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 15:00:09', 2, 0, '', '2019-06-01 15:00:09');
INSERT INTO `access_log` VALUES (19296, '64.84.15593724089493317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 15:00:09', 2, 0, '', '2019-06-01 15:00:09');
INSERT INTO `access_log` VALUES (19297, '59.77.15593724101943833', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 15:00:10', 3, 0, '', '2019-06-01 15:00:10');
INSERT INTO `access_log` VALUES (19298, '59.75.15593724101953837', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.44.163.226', '2019-06-01 15:00:10', 13, 2001001000, '服务端发生异常', '2019-06-01 15:00:10');
INSERT INTO `access_log` VALUES (19299, '65.49.15593725131223445', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:01:53', 1, 1002001015, '账号未登陆', '2019-06-01 15:01:53');
INSERT INTO `access_log` VALUES (19300, '65.51.15593725131343427', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:01:53', 0, 1002001015, '账号未登陆', '2019-06-01 15:01:53');
INSERT INTO `access_log` VALUES (19301, '65.53.15593725131373419', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:01:53', 0, 1002001015, '账号未登陆', '2019-06-01 15:01:53');
INSERT INTO `access_log` VALUES (19302, '59.75.15593725371633839', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '222.88.152.96', '2019-06-01 15:02:17', 4, 0, '', '2019-06-01 15:02:17');
INSERT INTO `access_log` VALUES (19303, '59.77.15593725371633835', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '222.88.152.96', '2019-06-01 15:02:17', 13, 2001001000, '服务端发生异常', '2019-06-01 15:02:17');
INSERT INTO `access_log` VALUES (19304, '64.80.15593725417663311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '222.88.152.96', '2019-06-01 15:02:22', 3, 0, '', '2019-06-01 15:02:22');
INSERT INTO `access_log` VALUES (19305, '64.79.15593725419033311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '222.88.152.96', '2019-06-01 15:02:22', 2, 0, '', '2019-06-01 15:02:22');
INSERT INTO `access_log` VALUES (19306, '64.76.15593725449153311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '222.88.152.96', '2019-06-01 15:02:25', 3, 0, '', '2019-06-01 15:02:25');
INSERT INTO `access_log` VALUES (19307, '64.85.15593725450503325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '222.88.152.96', '2019-06-01 15:02:25', 3, 0, '', '2019-06-01 15:02:25');
INSERT INTO `access_log` VALUES (19308, '59.74.15593725467473839', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '222.88.152.96', '2019-06-01 15:02:27', 3, 0, '', '2019-06-01 15:02:27');
INSERT INTO `access_log` VALUES (19309, '59.71.15593725467473843', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '222.88.152.96', '2019-06-01 15:02:27', 13, 2001001000, '服务端发生异常', '2019-06-01 15:02:27');
INSERT INTO `access_log` VALUES (19310, '64.83.15593725487923311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '222.88.152.96', '2019-06-01 15:02:29', 2, 0, '', '2019-06-01 15:02:29');
INSERT INTO `access_log` VALUES (19311, '64.77.15593725489133319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '222.88.152.96', '2019-06-01 15:02:29', 2, 0, '', '2019-06-01 15:02:29');
INSERT INTO `access_log` VALUES (19312, '64.84.15593725501173319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '222.88.152.96', '2019-06-01 15:02:30', 2, 0, '', '2019-06-01 15:02:30');
INSERT INTO `access_log` VALUES (19313, '64.82.15593725508753327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '222.88.152.96', '2019-06-01 15:02:31', 2, 0, '', '2019-06-01 15:02:31');
INSERT INTO `access_log` VALUES (19314, '65.48.15593725539453439', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:02:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 15:02:34');
INSERT INTO `access_log` VALUES (19315, '65.47.15593725591403447', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:02:39', 89, 0, '', '2019-06-01 15:02:39');
INSERT INTO `access_log` VALUES (19316, '65.50.15593725596743441', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:02:40', 10, 0, '', '2019-06-01 15:02:40');
INSERT INTO `access_log` VALUES (19317, '65.49.15593725596763447', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:02:40', 9, 0, '', '2019-06-01 15:02:40');
INSERT INTO `access_log` VALUES (19318, '65.51.15593725596793429', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:02:40', 9, 0, '', '2019-06-01 15:02:40');
INSERT INTO `access_log` VALUES (19319, '62.87.15593725674493731', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:02:47', 14, 0, '', '2019-06-01 15:02:47');
INSERT INTO `access_log` VALUES (19320, '64.78.15593725815723327', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:03:02', 10, 0, '', '2019-06-01 15:03:02');
INSERT INTO `access_log` VALUES (19321, '64.76.15593725815703313', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:03:02', 13, 0, '', '2019-06-01 15:03:02');
INSERT INTO `access_log` VALUES (19322, '64.79.15593725837403313', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:03:04', 12, 0, '', '2019-06-01 15:03:04');
INSERT INTO `access_log` VALUES (19323, '64.85.15593725837553329', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:03:04', 8, 0, '', '2019-06-01 15:03:04');
INSERT INTO `access_log` VALUES (19324, '64.84.15593725868523321', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:03:07', 8, 0, '', '2019-06-01 15:03:07');
INSERT INTO `access_log` VALUES (19325, '64.77.15593725868503321', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.136.61.84', '2019-06-01 15:03:07', 12, 0, '', '2019-06-01 15:03:07');
INSERT INTO `access_log` VALUES (19326, '59.73.15593726351453845', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:03:55', 3, 0, '', '2019-06-01 15:03:55');
INSERT INTO `access_log` VALUES (19327, '59.77.15593726351453837', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:03:55', 13, 2001001000, '服务端发生异常', '2019-06-01 15:03:55');
INSERT INTO `access_log` VALUES (19328, '65.45.15593726389693447', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 15:03:59', 151, 0, '', '2019-06-01 15:03:59');
INSERT INTO `access_log` VALUES (19329, '65.47.15593726389763449', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 15:03:59', 145, 0, '', '2019-06-01 15:03:59');
INSERT INTO `access_log` VALUES (19330, '65.50.15593726389853443', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 15:03:59', 141, 0, '', '2019-06-01 15:03:59');
INSERT INTO `access_log` VALUES (19331, '65.49.15593726434243449', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:03', 0, 1002001015, '账号未登陆', '2019-06-01 15:04:03');
INSERT INTO `access_log` VALUES (19332, '65.51.15593726434273431', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:03', 0, 1002001015, '账号未登陆', '2019-06-01 15:04:03');
INSERT INTO `access_log` VALUES (19333, '65.53.15593726434343423', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:03', 0, 1002001015, '账号未登陆', '2019-06-01 15:04:03');
INSERT INTO `access_log` VALUES (19334, '65.52.15593726434713425', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 15:04:03', 29, 0, '', '2019-06-01 15:04:04');
INSERT INTO `access_log` VALUES (19335, '65.54.15593726450963415', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:05', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 15:04:05');
INSERT INTO `access_log` VALUES (19336, '65.46.15593726464313435', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 15:04:06', 530, 0, '', '2019-06-01 15:04:07');
INSERT INTO `access_log` VALUES (19337, '65.50.15593726505943445', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 15:04:11', 11, 0, '', '2019-06-01 15:04:11');
INSERT INTO `access_log` VALUES (19338, '65.45.15593726521403449', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 15:04:12', 12, 0, '', '2019-06-01 15:04:12');
INSERT INTO `access_log` VALUES (19339, '65.47.15593726634433451', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 15:04:23', 13, 0, '', '2019-06-01 15:04:23');
INSERT INTO `access_log` VALUES (19340, '65.49.15593726650683451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:25', 116, 0, '', '2019-06-01 15:04:25');
INSERT INTO `access_log` VALUES (19341, '65.53.15593726654593425', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:25', 8, 0, '', '2019-06-01 15:04:25');
INSERT INTO `access_log` VALUES (19342, '65.52.15593726654643427', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:25', 8, 0, '', '2019-06-01 15:04:25');
INSERT INTO `access_log` VALUES (19343, '65.54.15593726654673417', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:25', 9, 0, '', '2019-06-01 15:04:25');
INSERT INTO `access_log` VALUES (19344, '62.80.15593726701143733', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:30', 14, 0, '', '2019-06-01 15:04:30');
INSERT INTO `access_log` VALUES (19345, '66.57.15593726763112685', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:36', 15, 0, '', '2019-06-01 15:04:36');
INSERT INTO `access_log` VALUES (19346, '65.46.15593726781813437', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 15:04:38', 9, 0, '', '2019-06-01 15:04:38');
INSERT INTO `access_log` VALUES (19347, '59.78.15593726805913845', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:41', 10, 0, '', '2019-06-01 15:04:41');
INSERT INTO `access_log` VALUES (19348, '65.50.15593726810303447', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.255', '2019-06-01 15:04:41', 13, 0, '', '2019-06-01 15:04:41');
INSERT INTO `access_log` VALUES (19349, '59.72.15593726943153839', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:54', 3, 0, '', '2019-06-01 15:04:54');
INSERT INTO `access_log` VALUES (19350, '59.76.15593726943163839', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:54', 10, 2001001000, '服务端发生异常', '2019-06-01 15:04:54');
INSERT INTO `access_log` VALUES (19351, '64.80.15593726980913315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:58', 176, 0, '', '2019-06-01 15:04:58');
INSERT INTO `access_log` VALUES (19352, '64.78.15593726983903329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:04:58', 2, 0, '', '2019-06-01 15:04:58');
INSERT INTO `access_log` VALUES (19353, '64.85.15593727001763333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:05:00', 591, 0, '', '2019-06-01 15:05:01');
INSERT INTO `access_log` VALUES (19354, '64.76.15593726997383315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '121.35.102.242', '2019-06-01 15:05:00', 1029, 0, '', '2019-06-01 15:05:01');
INSERT INTO `access_log` VALUES (19355, '59.75.15593728498653845', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '27.154.72.42', '2019-06-01 15:07:30', 3, 0, '', '2019-06-01 15:07:30');
INSERT INTO `access_log` VALUES (19356, '59.73.15593728498653849', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '27.154.72.42', '2019-06-01 15:07:30', 19, 2001001000, '服务端发生异常', '2019-06-01 15:07:30');
INSERT INTO `access_log` VALUES (19357, '65.51.15593730013583439', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.87', '2019-06-01 15:10:01', 0, 1002001015, '账号未登陆', '2019-06-01 15:10:01');
INSERT INTO `access_log` VALUES (19358, '65.47.15593730013583457', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.62', '2019-06-01 15:10:01', 0, 1002001015, '账号未登陆', '2019-06-01 15:10:01');
INSERT INTO `access_log` VALUES (19359, '65.49.15593730013633457', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.47', '2019-06-01 15:10:01', 1, 1002001015, '账号未登陆', '2019-06-01 15:10:01');
INSERT INTO `access_log` VALUES (19360, '65.52.15593730048023433', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.67', '2019-06-01 15:10:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 15:10:05');
INSERT INTO `access_log` VALUES (19361, '65.54.15593730118973423', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.67', '2019-06-01 15:10:12', 408, 0, '', '2019-06-01 15:10:12');
INSERT INTO `access_log` VALUES (19362, '65.46.15593730129673443', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.67', '2019-06-01 15:10:13', 10, 0, '', '2019-06-01 15:10:13');
INSERT INTO `access_log` VALUES (19363, '65.48.15593730129693451', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.47', '2019-06-01 15:10:13', 10, 0, '', '2019-06-01 15:10:13');
INSERT INTO `access_log` VALUES (19364, '65.50.15593730129703453', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.62', '2019-06-01 15:10:13', 9, 0, '', '2019-06-01 15:10:13');
INSERT INTO `access_log` VALUES (19365, '59.71.15593730261593851', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.67', '2019-06-01 15:10:26', 13, 0, '', '2019-06-01 15:10:26');
INSERT INTO `access_log` VALUES (19366, '65.49.15593730307633459', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.80.83.113', '2019-06-01 15:10:31', 1, 1002001015, '账号未登陆', '2019-06-01 15:10:31');
INSERT INTO `access_log` VALUES (19367, '65.47.15593730307713459', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.80.83.113', '2019-06-01 15:10:31', 1, 1002001015, '账号未登陆', '2019-06-01 15:10:31');
INSERT INTO `access_log` VALUES (19368, '65.51.15593730307873441', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.80.83.113', '2019-06-01 15:10:31', 1, 1002001015, '账号未登陆', '2019-06-01 15:10:31');
INSERT INTO `access_log` VALUES (19369, '65.52.15593730313593435', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.47', '2019-06-01 15:10:31', 21, 0, '', '2019-06-01 15:10:31');
INSERT INTO `access_log` VALUES (19370, '65.53.15593730317373433', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.14.134.184', '2019-06-01 15:10:32', 1, 1002001015, '账号未登陆', '2019-06-01 15:10:32');
INSERT INTO `access_log` VALUES (19371, '65.54.15593730317553425', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.14.134.184', '2019-06-01 15:10:32', 1, 1002001015, '账号未登陆', '2019-06-01 15:10:32');
INSERT INTO `access_log` VALUES (19372, '65.46.15593730317563445', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.14.134.184', '2019-06-01 15:10:32', 0, 1002001015, '账号未登陆', '2019-06-01 15:10:32');
INSERT INTO `access_log` VALUES (19373, '65.50.15593730344693455', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.47', '2019-06-01 15:10:34', 12, 0, '', '2019-06-01 15:10:34');
INSERT INTO `access_log` VALUES (19374, '65.48.15593730384813453', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.14.134.184', '2019-06-01 15:10:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 15:10:38');
INSERT INTO `access_log` VALUES (19375, '59.78.15593730407223851', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '1.80.83.113', '2019-06-01 15:10:41', 3, 0, '', '2019-06-01 15:10:41');
INSERT INTO `access_log` VALUES (19376, '59.80.15593730407233847', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '1.80.83.113', '2019-06-01 15:10:41', 13, 2001001000, '服务端发生异常', '2019-06-01 15:10:41');
INSERT INTO `access_log` VALUES (19377, '65.49.15593730417893461', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.67', '2019-06-01 15:10:42', 10, 0, '', '2019-06-01 15:10:42');
INSERT INTO `access_log` VALUES (19378, '64.84.15593730492393329', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.67', '2019-06-01 15:10:49', 10, 0, '', '2019-06-01 15:10:49');
INSERT INTO `access_log` VALUES (19379, '64.82.15593730492403337', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.47', '2019-06-01 15:10:49', 12, 0, '', '2019-06-01 15:10:49');
INSERT INTO `access_log` VALUES (19380, '65.51.15593730550793443', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.67', '2019-06-01 15:10:55', 15, 0, '', '2019-06-01 15:10:55');
INSERT INTO `access_log` VALUES (19381, '64.80.15593730567433321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '1.80.83.113', '2019-06-01 15:10:57', 57, 0, '', '2019-06-01 15:10:57');
INSERT INTO `access_log` VALUES (19382, '64.78.15593730569353335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '1.80.83.113', '2019-06-01 15:10:57', 2, 0, '', '2019-06-01 15:10:57');
INSERT INTO `access_log` VALUES (19383, '64.85.15593730619563339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '1.80.83.113', '2019-06-01 15:11:02', 2, 0, '', '2019-06-01 15:11:02');
INSERT INTO `access_log` VALUES (19384, '64.76.15593730625323321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '1.80.83.113', '2019-06-01 15:11:03', 2, 0, '', '2019-06-01 15:11:03');
INSERT INTO `access_log` VALUES (19385, '65.54.15593730727213427', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.67', '2019-06-01 15:11:13', 16, 0, '', '2019-06-01 15:11:13');
INSERT INTO `access_log` VALUES (19386, '65.53.15593730799153435', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.67', '2019-06-01 15:11:20', 12, 0, '', '2019-06-01 15:11:20');
INSERT INTO `access_log` VALUES (19387, '65.50.15593730853053457', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.67', '2019-06-01 15:11:25', 10, 0, '', '2019-06-01 15:11:25');
INSERT INTO `access_log` VALUES (19388, '62.86.15593730978753729', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.2.198.47', '2019-06-01 15:11:38', 14, 0, '', '2019-06-01 15:11:38');
INSERT INTO `access_log` VALUES (19389, '59.73.15593736800763861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '175.9.140.12', '2019-06-01 15:21:20', 4, 0, '', '2019-06-01 15:21:20');
INSERT INTO `access_log` VALUES (19390, '59.77.15593736800793853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '175.9.140.12', '2019-06-01 15:21:20', 14, 2001001000, '服务端发生异常', '2019-06-01 15:21:20');
INSERT INTO `access_log` VALUES (19391, '64.77.15593736832943339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '175.9.140.12', '2019-06-01 15:21:23', 3, 0, '', '2019-06-01 15:21:23');
INSERT INTO `access_log` VALUES (19392, '64.82.15593736834373347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '175.9.140.12', '2019-06-01 15:21:23', 2, 0, '', '2019-06-01 15:21:23');
INSERT INTO `access_log` VALUES (19393, '66.49.15593736877462697', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '175.9.140.12', '2019-06-01 15:21:28', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空', '2019-06-01 15:21:28');
INSERT INTO `access_log` VALUES (19394, '65.53.15593738320163445', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.80.83.113', '2019-06-01 15:23:52', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 15:23:52');
INSERT INTO `access_log` VALUES (19395, '65.47.15593740445393477', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:27:25', 0, 1002001015, '账号未登陆', '2019-06-01 15:27:25');
INSERT INTO `access_log` VALUES (19396, '65.51.15593740445423457', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:27:25', 0, 1002001015, '账号未登陆', '2019-06-01 15:27:25');
INSERT INTO `access_log` VALUES (19397, '65.52.15593740445503453', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:27:25', 0, 1002001015, '账号未登陆', '2019-06-01 15:27:25');
INSERT INTO `access_log` VALUES (19398, '65.54.15593740466863441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:27:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 15:27:27');
INSERT INTO `access_log` VALUES (19399, '65.53.15593740528073449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:27:33', 73, 0, '', '2019-06-01 15:27:33');
INSERT INTO `access_log` VALUES (19400, '65.50.15593740530913471', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:27:33', 9, 0, '', '2019-06-01 15:27:33');
INSERT INTO `access_log` VALUES (19401, '65.46.15593740530903463', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:27:33', 9, 0, '', '2019-06-01 15:27:33');
INSERT INTO `access_log` VALUES (19402, '65.48.15593740530973471', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:27:33', 8, 0, '', '2019-06-01 15:27:33');
INSERT INTO `access_log` VALUES (19403, '62.88.15593740571143755', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:27:37', 356, 0, '', '2019-06-01 15:27:37');
INSERT INTO `access_log` VALUES (19404, '62.80.15593740625053753', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:27:43', 16, 0, '', '2019-06-01 15:27:43');
INSERT INTO `access_log` VALUES (19405, '59.76.15593740728103859', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:27:53', 12, 0, '', '2019-06-01 15:27:53');
INSERT INTO `access_log` VALUES (19406, '66.51.15593740743182701', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:27:54', 14, 0, '', '2019-06-01 15:27:54');
INSERT INTO `access_log` VALUES (19407, '65.51.15593740769023459', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:27:57', 19, 0, '', '2019-06-01 15:27:57');
INSERT INTO `access_log` VALUES (19408, '65.47.15593740800963479', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:28:00', 7, 0, '', '2019-06-01 15:28:00');
INSERT INTO `access_log` VALUES (19409, '65.52.15593740855263455', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:28:06', 26, 0, '', '2019-06-01 15:28:06');
INSERT INTO `access_log` VALUES (19410, '66.56.15593740874982701', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:28:07', 11, 0, '', '2019-06-01 15:28:08');
INSERT INTO `access_log` VALUES (19411, '59.73.15593740877253867', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.237.227.126', '2019-06-01 15:28:08', 9, 0, '', '2019-06-01 15:28:08');
INSERT INTO `access_log` VALUES (19412, '65.50.15593744276393477', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '106.110.2.189', '2019-06-01 15:33:48', 1, 1002001015, '账号未登陆', '2019-06-01 15:33:48');
INSERT INTO `access_log` VALUES (19413, '65.46.15593744276403469', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '106.110.2.189', '2019-06-01 15:33:48', 1, 1002001015, '账号未登陆', '2019-06-01 15:33:48');
INSERT INTO `access_log` VALUES (19414, '65.45.15593744276513481', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '106.110.2.189', '2019-06-01 15:33:48', 0, 1002001015, '账号未登陆', '2019-06-01 15:33:48');
INSERT INTO `access_log` VALUES (19415, '65.51.15593744343593465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '106.110.2.189', '2019-06-01 15:33:54', 93, 0, '', '2019-06-01 15:33:54');
INSERT INTO `access_log` VALUES (19416, '65.47.15593744368763485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '106.110.2.189', '2019-06-01 15:33:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 15:33:57');
INSERT INTO `access_log` VALUES (19417, '65.52.15593744423393461', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '106.110.2.189', '2019-06-01 15:34:02', 64, 0, '', '2019-06-01 15:34:02');
INSERT INTO `access_log` VALUES (19418, '65.51.15593745469573467', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:35:47', 1, 1002001015, '账号未登陆', '2019-06-01 15:35:47');
INSERT INTO `access_log` VALUES (19419, '65.47.15593745469573487', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:35:47', 1, 1002001015, '账号未登陆', '2019-06-01 15:35:47');
INSERT INTO `access_log` VALUES (19420, '65.52.15593745469603463', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:35:47', 0, 1002001015, '账号未登陆', '2019-06-01 15:35:47');
INSERT INTO `access_log` VALUES (19421, '65.54.15593745496983451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:35:50', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 15:35:50');
INSERT INTO `access_log` VALUES (19422, '65.48.15593745557793481', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:35:56', 67, 0, '', '2019-06-01 15:35:56');
INSERT INTO `access_log` VALUES (19423, '65.46.15593745564933473', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:35:56', 9, 0, '', '2019-06-01 15:35:57');
INSERT INTO `access_log` VALUES (19424, '65.45.15593745564943485', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:35:56', 9, 0, '', '2019-06-01 15:35:57');
INSERT INTO `access_log` VALUES (19425, '65.50.15593745565343481', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:35:57', 8, 0, '', '2019-06-01 15:35:57');
INSERT INTO `access_log` VALUES (19426, '62.86.15593745628543755', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:36:03', 14, 0, '', '2019-06-01 15:36:03');
INSERT INTO `access_log` VALUES (19427, '62.84.15593745699343757', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:36:10', 16, 0, '', '2019-06-01 15:36:10');
INSERT INTO `access_log` VALUES (19428, '64.84.15593745774143351', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:36:17', 9, 0, '', '2019-06-01 15:36:17');
INSERT INTO `access_log` VALUES (19429, '64.82.15593745774133359', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:36:17', 10, 0, '', '2019-06-01 15:36:17');
INSERT INTO `access_log` VALUES (19430, '66.55.15593745942892719', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:36:34', 14, 0, '', '2019-06-01 15:36:34');
INSERT INTO `access_log` VALUES (19431, '59.80.15593746002203869', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:36:40', 22, 2001001000, '服务端发生异常', '2019-06-01 15:36:40');
INSERT INTO `access_log` VALUES (19432, '65.47.15593746105543489', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:36:51', 18, 0, '', '2019-06-01 15:36:51');
INSERT INTO `access_log` VALUES (19433, '65.54.15593746116043453', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:36:52', 10, 0, '', '2019-06-01 15:36:52');
INSERT INTO `access_log` VALUES (19434, '65.53.15593746132393461', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:36:53', 10, 0, '', '2019-06-01 15:36:53');
INSERT INTO `access_log` VALUES (19435, '65.46.15593746152893475', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:36:55', 22, 0, '', '2019-06-01 15:36:55');
INSERT INTO `access_log` VALUES (19436, '65.50.15593746188403483', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:36:59', 12, 0, '', '2019-06-01 15:36:59');
INSERT INTO `access_log` VALUES (19437, '65.45.15593746195363487', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:37:00', 9, 0, '', '2019-06-01 15:37:00');
INSERT INTO `access_log` VALUES (19438, '65.49.15593746201753491', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:37:00', 19, 0, '', '2019-06-01 15:37:00');
INSERT INTO `access_log` VALUES (19439, '59.72.15593746207343867', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:37:01', 21, 2001001000, '服务端发生异常', '2019-06-01 15:37:01');
INSERT INTO `access_log` VALUES (19440, '66.52.15593746241642713', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:37:04', 13, 0, '', '2019-06-01 15:37:04');
INSERT INTO `access_log` VALUES (19441, '66.51.15593746253942709', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:37:05', 238, 0, '', '2019-06-01 15:37:06');
INSERT INTO `access_log` VALUES (19442, '64.79.15593746267513345', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:37:07', 9, 0, '', '2019-06-01 15:37:07');
INSERT INTO `access_log` VALUES (19443, '64.76.15593746267513343', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:37:07', 10, 0, '', '2019-06-01 15:37:07');
INSERT INTO `access_log` VALUES (19444, '64.77.15593746271243353', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:37:07', 8, 0, '', '2019-06-01 15:37:07');
INSERT INTO `access_log` VALUES (19445, '64.83.15593746271233345', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:37:07', 9, 0, '', '2019-06-01 15:37:07');
INSERT INTO `access_log` VALUES (19446, '62.83.15593746274103763', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:37:07', 16, 0, '', '2019-06-01 15:37:07');
INSERT INTO `access_log` VALUES (19447, '62.85.15593746278743767', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.104.63.110', '2019-06-01 15:37:08', 13, 0, '', '2019-06-01 15:37:08');
INSERT INTO `access_log` VALUES (19448, '65.50.15593751712513491', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:46:11', 0, 1002001015, '账号未登陆', '2019-06-01 15:46:11');
INSERT INTO `access_log` VALUES (19449, '65.45.15593751712563495', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:46:11', 1, 1002001015, '账号未登陆', '2019-06-01 15:46:11');
INSERT INTO `access_log` VALUES (19450, '65.49.15593751712593499', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:46:11', 0, 1002001015, '账号未登陆', '2019-06-01 15:46:11');
INSERT INTO `access_log` VALUES (19451, '65.51.15593751746303479', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:46:15', 84, 0, '', '2019-06-01 15:46:15');
INSERT INTO `access_log` VALUES (19452, '65.52.15593751750603475', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:46:15', 175, 0, '', '2019-06-01 15:46:15');
INSERT INTO `access_log` VALUES (19453, '65.47.15593751750663499', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:46:15', 172, 0, '', '2019-06-01 15:46:15');
INSERT INTO `access_log` VALUES (19454, '65.54.15593751750713463', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:46:15', 168, 0, '', '2019-06-01 15:46:15');
INSERT INTO `access_log` VALUES (19455, '62.83.15593751966073771', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:46:37', 13, 0, '', '2019-06-01 15:46:37');
INSERT INTO `access_log` VALUES (19456, '62.85.15593752000803775', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:46:40', 64, 0, '', '2019-06-01 15:46:40');
INSERT INTO `access_log` VALUES (19457, '64.77.15593752016303361', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:46:42', 10, 0, '', '2019-06-01 15:46:42');
INSERT INTO `access_log` VALUES (19458, '64.83.15593752016303353', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:46:42', 13, 0, '', '2019-06-01 15:46:42');
INSERT INTO `access_log` VALUES (19459, '64.80.15593752531213353', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=6&name=14', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:47:33', 8, 1002002009, NULL, '2019-06-01 15:47:33');
INSERT INTO `access_log` VALUES (19460, '64.85.15593752566203371', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=3&name=2o', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:47:37', 8, 1002002009, NULL, '2019-06-01 15:47:37');
INSERT INTO `access_log` VALUES (19461, '64.79.15593752592013355', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=3&name=lkj', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:47:39', 8, 1002002009, NULL, '2019-06-01 15:47:39');
INSERT INTO `access_log` VALUES (19462, '64.76.15593752620483353', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=3&name=woca', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:47:42', 8, 1002002009, NULL, '2019-06-01 15:47:42');
INSERT INTO `access_log` VALUES (19463, '64.83.15593752637533355', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=3&name=wocao', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:47:44', 8, 1002002009, NULL, '2019-06-01 15:47:44');
INSERT INTO `access_log` VALUES (19464, '64.77.15593753957353365', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:49:56', 1646, 0, '', '2019-06-01 15:49:57');
INSERT INTO `access_log` VALUES (19465, '64.83.15593753957303357', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:49:56', 1650, 0, '', '2019-06-01 15:49:57');
INSERT INTO `access_log` VALUES (19466, '64.82.15593753995413373', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:50:00', 15, 0, '', '2019-06-01 15:50:00');
INSERT INTO `access_log` VALUES (19467, '64.81.15593753995773359', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:50:00', 7, 0, '', '2019-06-01 15:50:00');
INSERT INTO `access_log` VALUES (19468, '64.84.15593753995753365', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:50:00', 10, 0, '', '2019-06-01 15:50:00');
INSERT INTO `access_log` VALUES (19469, '64.85.15593754310533375', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:50:31', 8, 0, '', '2019-06-01 15:50:31');
INSERT INTO `access_log` VALUES (19470, '66.55.15593754484482731', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:50:48', 14, 0, '', '2019-06-01 15:50:48');
INSERT INTO `access_log` VALUES (19471, '59.79.15593754497943881', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:50:50', 13, 0, '', '2019-06-01 15:50:50');
INSERT INTO `access_log` VALUES (19472, '59.80.15593754513783881', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:50:51', 21, 2001001000, '服务端发生异常', '2019-06-01 15:50:51');
INSERT INTO `access_log` VALUES (19473, '59.78.15593754544193885', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:50:54', 12, 0, '', '2019-06-01 15:50:54');
INSERT INTO `access_log` VALUES (19474, '64.83.15593754572093359', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:50:57', 10, 0, '', '2019-06-01 15:50:57');
INSERT INTO `access_log` VALUES (19475, '64.77.15593754592033367', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:50:59', 8, 0, '', '2019-06-01 15:50:59');
INSERT INTO `access_log` VALUES (19476, '65.54.15593754615283467', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:51:02', 21, 0, '', '2019-06-01 15:51:02');
INSERT INTO `access_log` VALUES (19477, '65.53.15593754629033475', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:51:03', 11, 0, '', '2019-06-01 15:51:03');
INSERT INTO `access_log` VALUES (19478, '65.48.15593754636303497', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:51:04', 9, 0, '', '2019-06-01 15:51:04');
INSERT INTO `access_log` VALUES (19479, '65.46.15593754643163489', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 15:51:04', 15, 0, '', '2019-06-01 15:51:04');
INSERT INTO `access_log` VALUES (19480, '65.48.15593755838163499', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.159.146', '2019-06-01 15:53:04', 0, 1002001015, '账号未登陆', '2019-06-01 15:53:04');
INSERT INTO `access_log` VALUES (19481, '65.46.15593755838193491', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.159.146', '2019-06-01 15:53:04', 0, 1002001015, '账号未登陆', '2019-06-01 15:53:04');
INSERT INTO `access_log` VALUES (19482, '65.50.15593755838253499', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.159.146', '2019-06-01 15:53:04', 1, 1002001015, '账号未登陆', '2019-06-01 15:53:04');
INSERT INTO `access_log` VALUES (19483, '65.51.15593756188533487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.159.146', '2019-06-01 15:53:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 15:53:39');
INSERT INTO `access_log` VALUES (19484, '65.52.15593756261133483', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.159.146', '2019-06-01 15:53:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 15:53:46');
INSERT INTO `access_log` VALUES (19485, '65.54.15593756312933471', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.159.146', '2019-06-01 15:53:51', 310, 0, '', '2019-06-01 15:53:52');
INSERT INTO `access_log` VALUES (19486, '65.49.15593756986593509', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '182.242.186.173', '2019-06-01 15:54:59', 1, 1002001015, '账号未登陆', '2019-06-01 15:54:59');
INSERT INTO `access_log` VALUES (19487, '65.51.15593756986643489', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '182.242.186.173', '2019-06-01 15:54:59', 0, 1002001015, '账号未登陆', '2019-06-01 15:54:59');
INSERT INTO `access_log` VALUES (19488, '65.47.15593756986653509', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '182.242.186.173', '2019-06-01 15:54:59', 0, 1002001015, '账号未登陆', '2019-06-01 15:54:59');
INSERT INTO `access_log` VALUES (19489, '65.52.15593757019943485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '182.242.186.173', '2019-06-01 15:55:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 15:55:02');
INSERT INTO `access_log` VALUES (19490, '65.50.15593757269653503', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '182.242.186.173', '2019-06-01 15:55:27', 76, 0, '', '2019-06-01 15:55:27');
INSERT INTO `access_log` VALUES (19491, '65.48.15593757273393503', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '182.242.186.173', '2019-06-01 15:55:27', 10, 0, '', '2019-06-01 15:55:27');
INSERT INTO `access_log` VALUES (19492, '65.46.15593757273493495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '182.242.186.173', '2019-06-01 15:55:27', 18, 0, '', '2019-06-01 15:55:27');
INSERT INTO `access_log` VALUES (19493, '65.45.15593757273493507', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '182.242.186.173', '2019-06-01 15:55:27', 17, 0, '', '2019-06-01 15:55:27');
INSERT INTO `access_log` VALUES (19494, '62.83.15593757353903779', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '182.242.186.173', '2019-06-01 15:55:35', 14, 0, '', '2019-06-01 15:55:35');
INSERT INTO `access_log` VALUES (19495, '59.71.15593758481403891', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 15:57:28', 3, 0, '', '2019-06-01 15:57:28');
INSERT INTO `access_log` VALUES (19496, '59.79.15593758481443887', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 15:57:28', 13, 2001001000, '服务端发生异常', '2019-06-01 15:57:28');
INSERT INTO `access_log` VALUES (19497, '64.83.15593758829203365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:03', 3, 0, '', '2019-06-01 15:58:03');
INSERT INTO `access_log` VALUES (19498, '64.77.15593758830673373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:03', 3, 0, '', '2019-06-01 15:58:03');
INSERT INTO `access_log` VALUES (19499, '64.81.15593758842623367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:04', 2, 0, '', '2019-06-01 15:58:04');
INSERT INTO `access_log` VALUES (19500, '59.76.15593758842683885', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.211.157.222', '2019-06-01 15:58:04', 3, 0, '', '2019-06-01 15:58:04');
INSERT INTO `access_log` VALUES (19501, '59.75.15593758842683889', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.211.157.222', '2019-06-01 15:58:04', 13, 2001001000, '服务端发生异常', '2019-06-01 15:58:04');
INSERT INTO `access_log` VALUES (19502, '64.82.15593758846923381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:05', 2, 0, '', '2019-06-01 15:58:05');
INSERT INTO `access_log` VALUES (19503, '59.73.15593758924423893', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.211.157.222', '2019-06-01 15:58:12', 3, 0, '', '2019-06-01 15:58:12');
INSERT INTO `access_log` VALUES (19504, '59.77.15593758924423885', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.211.157.222', '2019-06-01 15:58:12', 12, 2001001000, '服务端发生异常', '2019-06-01 15:58:12');
INSERT INTO `access_log` VALUES (19505, '64.80.15593758951133365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.211.157.222', '2019-06-01 15:58:15', 2, 0, '', '2019-06-01 15:58:15');
INSERT INTO `access_log` VALUES (19506, '64.78.15593758952243379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.211.157.222', '2019-06-01 15:58:15', 2, 0, '', '2019-06-01 15:58:15');
INSERT INTO `access_log` VALUES (19507, '64.85.15593758965263383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.211.157.222', '2019-06-01 15:58:17', 2, 0, '', '2019-06-01 15:58:17');
INSERT INTO `access_log` VALUES (19508, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.211.157.222', '2019-06-01 15:58:17', 20, 0, '', '2019-06-01 15:58:17');
INSERT INTO `access_log` VALUES (19509, '64.79.15593758976253367', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.211.157.222', '2019-06-01 15:58:18', 8, 0, '', '2019-06-01 15:58:18');
INSERT INTO `access_log` VALUES (19510, '66.54.15593759116012731', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13666120326&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:32', 11, 1001003000, '验证码不存在', '2019-06-01 15:58:32');
INSERT INTO `access_log` VALUES (19511, '66.52.15593759143372731', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13666120326&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:34', 7, 1001003000, '验证码不存在', '2019-06-01 15:58:34');
INSERT INTO `access_log` VALUES (19512, '66.51.15593759158812727', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13666120326', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:36', 331, 0, '', '2019-06-01 15:58:36');
INSERT INTO `access_log` VALUES (19513, '66.56.15593759184412727', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13666120326&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:38', 157, 0, '', '2019-06-01 15:58:39');
INSERT INTO `access_log` VALUES (19514, '64.81.15593759234493369', 96, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:43', 5, 0, '', '2019-06-01 15:58:43');
INSERT INTO `access_log` VALUES (19515, '64.84.15593759236003375', 96, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:44', 4, 0, '', '2019-06-01 15:58:44');
INSERT INTO `access_log` VALUES (19516, '66.50.15593759247362733', 96, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:45', 6, 0, '', '2019-06-01 15:58:45');
INSERT INTO `access_log` VALUES (19517, '66.57.15593759272912731', 96, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:47', 7, 0, '', '2019-06-01 15:58:47');
INSERT INTO `access_log` VALUES (19518, '66.48.15593759321562735', 96, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:52', 7, 0, '', '2019-06-01 15:58:52');
INSERT INTO `access_log` VALUES (19519, '59.72.15593759333733887', 96, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:53', 7, 0, '', '2019-06-01 15:58:53');
INSERT INTO `access_log` VALUES (19520, '59.75.15593759334153891', 96, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:53', 16, 2001001000, '服务端发生异常', '2019-06-01 15:58:53');
INSERT INTO `access_log` VALUES (19521, '64.78.15593759354123381', 96, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:55', 4, 0, '', '2019-06-01 15:58:55');
INSERT INTO `access_log` VALUES (19522, '64.85.15593759357873385', 96, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:56', 5, 0, '', '2019-06-01 15:58:56');
INSERT INTO `access_log` VALUES (19523, '64.79.15593759374153369', 96, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:57', 5, 0, '', '2019-06-01 15:58:57');
INSERT INTO `access_log` VALUES (19524, 'N/A', 96, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:57', 14, 0, '', '2019-06-01 15:58:57');
INSERT INTO `access_log` VALUES (19525, '64.83.15593759387683369', 96, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:58:59', 18, 0, '', '2019-06-01 15:58:59');
INSERT INTO `access_log` VALUES (19526, '66.52.15593759453772733', 96, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.184.227.28', '2019-06-01 15:59:05', 7, 0, '', '2019-06-01 15:59:05');
INSERT INTO `access_log` VALUES (19527, '65.50.15593759662093507', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 15:59:26', 1, 1002001015, '账号未登陆', '2019-06-01 15:59:26');
INSERT INTO `access_log` VALUES (19528, '65.45.15593759662113511', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 15:59:26', 1, 1002001015, '账号未登陆', '2019-06-01 15:59:26');
INSERT INTO `access_log` VALUES (19529, '65.46.15593759662163499', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 15:59:26', 0, 1002001015, '账号未登陆', '2019-06-01 15:59:26');
INSERT INTO `access_log` VALUES (19530, '65.48.15593759702973507', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 15:59:30', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 15:59:30');
INSERT INTO `access_log` VALUES (19531, '65.49.15593759731973515', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 15:59:33', 98, 0, '', '2019-06-01 15:59:33');
INSERT INTO `access_log` VALUES (19532, '65.51.15593759735253495', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 15:59:34', 11, 0, '', '2019-06-01 15:59:34');
INSERT INTO `access_log` VALUES (19533, '65.52.15593759735273491', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 15:59:34', 9, 0, '', '2019-06-01 15:59:34');
INSERT INTO `access_log` VALUES (19534, '65.47.15593759735253515', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 15:59:34', 11, 0, '', '2019-06-01 15:59:34');
INSERT INTO `access_log` VALUES (19535, '62.89.15593759891513783', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 15:59:49', 111, 0, '', '2019-06-01 15:59:49');
INSERT INTO `access_log` VALUES (19536, '62.83.15593759981833783', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 15:59:58', 13, 0, '', '2019-06-01 15:59:58');
INSERT INTO `access_log` VALUES (19537, '66.50.15593760034772735', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 16:00:03', 14, 0, '', '2019-06-01 16:00:03');
INSERT INTO `access_log` VALUES (19538, '59.79.15593760077403891', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 16:00:08', 12, 0, '', '2019-06-01 16:00:08');
INSERT INTO `access_log` VALUES (19539, '64.85.15593760157073387', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 16:00:16', 11, 0, '', '2019-06-01 16:00:16');
INSERT INTO `access_log` VALUES (19540, '64.78.15593760157073383', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.184.227.28', '2019-06-01 16:00:16', 12, 0, '', '2019-06-01 16:00:16');
INSERT INTO `access_log` VALUES (19541, '59.80.15593763088383895', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:09', 4, 0, '', '2019-06-01 16:05:09');
INSERT INTO `access_log` VALUES (19542, '59.78.15593763088383899', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:09', 14, 2001001000, '服务端发生异常', '2019-06-01 16:05:09');
INSERT INTO `access_log` VALUES (19543, '65.45.15593763157353517', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:16', 1, 1002001015, '账号未登陆', '2019-06-01 16:05:16');
INSERT INTO `access_log` VALUES (19544, '65.46.15593763157353505', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:16', 1, 1002001015, '账号未登陆', '2019-06-01 16:05:16');
INSERT INTO `access_log` VALUES (19545, '65.48.15593763157403513', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:16', 0, 1002001015, '账号未登陆', '2019-06-01 16:05:16');
INSERT INTO `access_log` VALUES (19546, '64.76.15593763259943373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:26', 11, 0, '', '2019-06-01 16:05:26');
INSERT INTO `access_log` VALUES (19547, '64.83.15593763261463375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:26', 2, 0, '', '2019-06-01 16:05:26');
INSERT INTO `access_log` VALUES (19548, '64.77.15593763295613383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:30', 3, 0, '', '2019-06-01 16:05:30');
INSERT INTO `access_log` VALUES (19549, '64.81.15593763296873377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:30', 2, 0, '', '2019-06-01 16:05:30');
INSERT INTO `access_log` VALUES (19550, '59.75.15593763307323897', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:31', 3, 0, '', '2019-06-01 16:05:31');
INSERT INTO `access_log` VALUES (19551, '59.76.15593763307323893', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:31', 14, 2001001000, '服务端发生异常', '2019-06-01 16:05:31');
INSERT INTO `access_log` VALUES (19552, '64.82.15593763330493391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:33', 3, 0, '', '2019-06-01 16:05:33');
INSERT INTO `access_log` VALUES (19553, '64.84.15593763331503383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:33', 2, 0, '', '2019-06-01 16:05:33');
INSERT INTO `access_log` VALUES (19554, '65.51.15593763357253501', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:36', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 16:05:36');
INSERT INTO `access_log` VALUES (19555, '65.52.15593763383623497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 16:05:38');
INSERT INTO `access_log` VALUES (19556, '65.54.15593763392823485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 16:05:39');
INSERT INTO `access_log` VALUES (19557, '65.53.15593763418823493', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.51.129.198', '2019-06-01 16:05:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 16:05:42');
INSERT INTO `access_log` VALUES (19558, '59.79.15593766772343901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.229.64.212', '2019-06-01 16:11:17', 4, 0, '', '2019-06-01 16:11:17');
INSERT INTO `access_log` VALUES (19559, '59.71.15593766772333905', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.229.64.212', '2019-06-01 16:11:17', 17, 2001001000, '服务端发生异常', '2019-06-01 16:11:17');
INSERT INTO `access_log` VALUES (19560, '64.76.15593766832093379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.229.64.212', '2019-06-01 16:11:23', 3, 0, '', '2019-06-01 16:11:23');
INSERT INTO `access_log` VALUES (19561, '64.83.15593766834013381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.229.64.212', '2019-06-01 16:11:23', 2, 0, '', '2019-06-01 16:11:23');
INSERT INTO `access_log` VALUES (19562, '64.77.15593766854313389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.229.64.212', '2019-06-01 16:11:25', 2, 0, '', '2019-06-01 16:11:25');
INSERT INTO `access_log` VALUES (19563, '64.81.15593766867783383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.229.64.212', '2019-06-01 16:11:27', 2, 0, '', '2019-06-01 16:11:27');
INSERT INTO `access_log` VALUES (19564, '64.82.15593766905493397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.229.64.212', '2019-06-01 16:11:31', 2, 0, '', '2019-06-01 16:11:31');
INSERT INTO `access_log` VALUES (19565, '64.84.15593766915383389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.229.64.212', '2019-06-01 16:11:32', 2, 0, '', '2019-06-01 16:11:32');
INSERT INTO `access_log` VALUES (19566, '59.80.15593766924413901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.229.64.212', '2019-06-01 16:11:32', 3, 0, '', '2019-06-01 16:11:32');
INSERT INTO `access_log` VALUES (19567, '59.72.15593766924843899', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.229.64.212', '2019-06-01 16:11:32', 13, 2001001000, '服务端发生异常', '2019-06-01 16:11:32');
INSERT INTO `access_log` VALUES (19568, '64.85.15593766999883399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.229.64.212', '2019-06-01 16:11:40', 2, 0, '', '2019-06-01 16:11:40');
INSERT INTO `access_log` VALUES (19569, '59.76.15593767006363899', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.229.64.212', '2019-06-01 16:11:41', 3, 0, '', '2019-06-01 16:11:41');
INSERT INTO `access_log` VALUES (19570, '59.73.15593767006363907', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.229.64.212', '2019-06-01 16:11:41', 13, 2001001000, '服务端发生异常', '2019-06-01 16:11:41');
INSERT INTO `access_log` VALUES (19571, '64.78.15593767006993395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.229.64.212', '2019-06-01 16:11:41', 2, 0, '', '2019-06-01 16:11:41');
INSERT INTO `access_log` VALUES (19572, '59.71.15593767516473907', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.68.68.234', '2019-06-01 16:12:32', 2, 0, '', '2019-06-01 16:12:32');
INSERT INTO `access_log` VALUES (19573, '59.78.15593767516473907', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.68.68.234', '2019-06-01 16:12:32', 13, 2001001000, '服务端发生异常', '2019-06-01 16:12:32');
INSERT INTO `access_log` VALUES (19574, '59.80.15593770495813907', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.73.52.189', '2019-06-01 16:17:30', 3, 0, '', '2019-06-01 16:17:30');
INSERT INTO `access_log` VALUES (19575, '59.72.15593770495823905', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.73.52.189', '2019-06-01 16:17:30', 12, 2001001000, '服务端发生异常', '2019-06-01 16:17:30');
INSERT INTO `access_log` VALUES (19576, '59.76.15593770569783905', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.73.52.189', '2019-06-01 16:17:37', 7, 0, '', '2019-06-01 16:17:37');
INSERT INTO `access_log` VALUES (19577, '59.73.15593770569803913', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.73.52.189', '2019-06-01 16:17:37', 13, 2001001000, '服务端发生异常', '2019-06-01 16:17:37');
INSERT INTO `access_log` VALUES (19578, '65.50.15593773984023529', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:23:18', 10, 0, '', '2019-06-01 16:23:18');
INSERT INTO `access_log` VALUES (19579, '65.46.15593773984143521', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:23:18', 8, 0, '', '2019-06-01 16:23:18');
INSERT INTO `access_log` VALUES (19580, '65.48.15593773984243529', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:23:18', 9, 0, '', '2019-06-01 16:23:18');
INSERT INTO `access_log` VALUES (19581, '64.80.15593774032153391', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:23:23', 13, 0, '', '2019-06-01 16:23:23');
INSERT INTO `access_log` VALUES (19582, '64.85.15593774032203409', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:23:23', 10, 0, '', '2019-06-01 16:23:23');
INSERT INTO `access_log` VALUES (19583, '64.78.15593774129393405', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:23:33', 12, 0, '', '2019-06-01 16:23:33');
INSERT INTO `access_log` VALUES (19584, '64.76.15593774286383391', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:23:49', 15, 0, '', '2019-06-01 16:23:49');
INSERT INTO `access_log` VALUES (19585, '64.83.15593774286453393', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:23:49', 10, 0, '', '2019-06-01 16:23:49');
INSERT INTO `access_log` VALUES (19586, '64.77.15593774286523401', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:23:49', 8, 0, '', '2019-06-01 16:23:49');
INSERT INTO `access_log` VALUES (19587, '65.52.15593774449873513', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:24:05', 9, 0, '', '2019-06-01 16:24:05');
INSERT INTO `access_log` VALUES (19588, '65.47.15593774450003537', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:24:05', 8, 0, '', '2019-06-01 16:24:05');
INSERT INTO `access_log` VALUES (19589, '65.54.15593774450083501', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:24:05', 9, 0, '', '2019-06-01 16:24:05');
INSERT INTO `access_log` VALUES (19590, '64.82.15593774453193409', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:24:05', 14, 0, '', '2019-06-01 16:24:05');
INSERT INTO `access_log` VALUES (19591, '64.84.15593774453533401', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:24:05', 10, 0, '', '2019-06-01 16:24:05');
INSERT INTO `access_log` VALUES (19592, '64.85.15593774453633411', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:24:05', 11, 0, '', '2019-06-01 16:24:05');
INSERT INTO `access_log` VALUES (19593, '64.78.15593774490513407', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.248.197', '2019-06-01 16:24:09', 7, 1002002009, NULL, '2019-06-01 16:24:09');
INSERT INTO `access_log` VALUES (19594, '65.51.15593776781293521', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.239.254', '2019-06-01 16:27:58', 9, 0, '', '2019-06-01 16:27:58');
INSERT INTO `access_log` VALUES (19595, '65.54.15593776781363505', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.239.254', '2019-06-01 16:27:58', 9, 0, '', '2019-06-01 16:27:58');
INSERT INTO `access_log` VALUES (19596, '65.47.15593776781473541', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.239.254', '2019-06-01 16:27:58', 8, 0, '', '2019-06-01 16:27:58');
INSERT INTO `access_log` VALUES (19597, '64.82.15593776787863413', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.239.254', '2019-06-01 16:27:59', 14, 0, '', '2019-06-01 16:27:59');
INSERT INTO `access_log` VALUES (19598, '64.85.15593776788243415', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.239.254', '2019-06-01 16:27:59', 9, 0, '', '2019-06-01 16:27:59');
INSERT INTO `access_log` VALUES (19599, '64.84.15593776788363405', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.244.239.254', '2019-06-01 16:27:59', 8, 0, '', '2019-06-01 16:27:59');
INSERT INTO `access_log` VALUES (19600, '59.71.15593778631473923', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.62.207.166', '2019-06-01 16:31:03', 3, 0, '', '2019-06-01 16:31:03');
INSERT INTO `access_log` VALUES (19601, '59.78.15593778631473923', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.62.207.166', '2019-06-01 16:31:03', 10, 2001001000, '服务端发生异常', '2019-06-01 16:31:03');
INSERT INTO `access_log` VALUES (19602, '59.73.15593778975013925', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '112.96.173.165', '2019-06-01 16:31:38', 3, 0, '', '2019-06-01 16:31:38');
INSERT INTO `access_log` VALUES (19603, '59.76.15593778975013917', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '112.96.173.165', '2019-06-01 16:31:38', 13, 2001001000, '服务端发生异常', '2019-06-01 16:31:38');
INSERT INTO `access_log` VALUES (19604, '64.77.15593779029333409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '112.96.173.165', '2019-06-01 16:31:43', 3, 0, '', '2019-06-01 16:31:43');
INSERT INTO `access_log` VALUES (19605, '64.81.15593779032633403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '112.96.173.165', '2019-06-01 16:31:43', 3, 0, '', '2019-06-01 16:31:43');
INSERT INTO `access_log` VALUES (19606, '64.82.15593779045543417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '112.96.173.165', '2019-06-01 16:31:45', 245, 0, '', '2019-06-01 16:31:45');
INSERT INTO `access_log` VALUES (19607, '64.85.15593779053193419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '112.96.173.165', '2019-06-01 16:31:45', 3, 0, '', '2019-06-01 16:31:45');
INSERT INTO `access_log` VALUES (19608, '64.84.15593779082233409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '112.96.173.165', '2019-06-01 16:31:48', 2, 0, '', '2019-06-01 16:31:48');
INSERT INTO `access_log` VALUES (19609, '64.80.15593779084213401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '112.96.173.165', '2019-06-01 16:31:48', 2, 0, '', '2019-06-01 16:31:48');
INSERT INTO `access_log` VALUES (19610, '59.74.15593779118513921', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '112.96.173.165', '2019-06-01 16:31:52', 2, 0, '', '2019-06-01 16:31:52');
INSERT INTO `access_log` VALUES (19611, '59.79.15593779118513921', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '112.96.173.165', '2019-06-01 16:31:52', 12, 2001001000, '服务端发生异常', '2019-06-01 16:31:52');
INSERT INTO `access_log` VALUES (19612, '65.54.15593780983913511', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:34:58', 1, 1002001015, '账号未登陆', '2019-06-01 16:34:58');
INSERT INTO `access_log` VALUES (19613, '65.47.15593780983953547', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:34:58', 0, 1002001015, '账号未登陆', '2019-06-01 16:34:58');
INSERT INTO `access_log` VALUES (19614, '65.52.15593780983963523', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:34:58', 1, 1002001015, '账号未登陆', '2019-06-01 16:34:58');
INSERT INTO `access_log` VALUES (19615, '65.53.15593781009283519', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:35:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 16:35:01');
INSERT INTO `access_log` VALUES (19616, '65.45.15593782889663547', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:09', 0, 1002001015, '账号未登陆', '2019-06-01 16:38:09');
INSERT INTO `access_log` VALUES (19617, '65.51.15593782889673531', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:09', 0, 1002001015, '账号未登陆', '2019-06-01 16:38:09');
INSERT INTO `access_log` VALUES (19618, '65.49.15593782889673551', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:09', 0, 1002001015, '账号未登陆', '2019-06-01 16:38:09');
INSERT INTO `access_log` VALUES (19619, '65.54.15593782933563515', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 16:38:13');
INSERT INTO `access_log` VALUES (19620, '65.47.15593782971893551', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:17', 156, 0, '', '2019-06-01 16:38:17');
INSERT INTO `access_log` VALUES (19621, '65.53.15593782976053523', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:18', 9, 0, '', '2019-06-01 16:38:18');
INSERT INTO `access_log` VALUES (19622, '65.52.15593782976043527', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:18', 10, 0, '', '2019-06-01 16:38:18');
INSERT INTO `access_log` VALUES (19623, '65.50.15593782976063545', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:18', 9, 0, '', '2019-06-01 16:38:18');
INSERT INTO `access_log` VALUES (19624, '62.89.15593783028563815', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:23', 24, 0, '', '2019-06-01 16:38:23');
INSERT INTO `access_log` VALUES (19625, '62.84.15593783061033809', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:26', 16, 0, '', '2019-06-01 16:38:26');
INSERT INTO `access_log` VALUES (19626, '64.84.15593783089203415', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:29', 13, 0, '', '2019-06-01 16:38:29');
INSERT INTO `access_log` VALUES (19627, '64.85.15593783089193425', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:29', 15, 0, '', '2019-06-01 16:38:29');
INSERT INTO `access_log` VALUES (19628, '64.80.15593783121493407', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:32', 10, 0, '', '2019-06-01 16:38:32');
INSERT INTO `access_log` VALUES (19629, '64.78.15593783121503421', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:32', 12, 0, '', '2019-06-01 16:38:32');
INSERT INTO `access_log` VALUES (19630, '64.83.15593783135893409', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:34', 8, 0, '', '2019-06-01 16:38:34');
INSERT INTO `access_log` VALUES (19631, '64.79.15593783135863409', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:34', 11, 0, '', '2019-06-01 16:38:34');
INSERT INTO `access_log` VALUES (19632, '66.51.15593783310982761', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:51', 22, 0, '', '2019-06-01 16:38:51');
INSERT INTO `access_log` VALUES (19633, '66.56.15593783345312761', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:55', 14, 0, '', '2019-06-01 16:38:55');
INSERT INTO `access_log` VALUES (19634, '66.49.15593783354212763', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=3&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:55', 13, 0, '', '2019-06-01 16:38:55');
INSERT INTO `access_log` VALUES (19635, '66.50.15593783359972767', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=4&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:56', 22, 0, '', '2019-06-01 16:38:56');
INSERT INTO `access_log` VALUES (19636, '66.57.15593783363602765', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=5&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:56', 10, 0, '', '2019-06-01 16:38:56');
INSERT INTO `access_log` VALUES (19637, '66.55.15593783366562773', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=6&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:38:57', 11, 0, '', '2019-06-01 16:38:57');
INSERT INTO `access_log` VALUES (19638, '62.88.15593784658183825', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:06', 13, 0, '', '2019-06-01 16:41:06');
INSERT INTO `access_log` VALUES (19639, '62.82.15593784690403827', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:09', 10, 0, '', '2019-06-01 16:41:09');
INSERT INTO `access_log` VALUES (19640, '62.87.15593784722253823', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=101', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:12', 12, 0, '', '2019-06-01 16:41:12');
INSERT INTO `access_log` VALUES (19641, '62.81.15593784746223811', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=200', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:15', 12, 0, '', '2019-06-01 16:41:15');
INSERT INTO `access_log` VALUES (19642, '62.86.15593784767913813', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=9999', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:17', 13, 0, '', '2019-06-01 16:41:17');
INSERT INTO `access_log` VALUES (19643, '62.89.15593784794543819', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10&payChannel=9999', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:19', 13, 0, '', '2019-06-01 16:41:19');
INSERT INTO `access_log` VALUES (19644, '62.84.15593784802283813', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10&payChannel=9999', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:20', 13, 0, '', '2019-06-01 16:41:20');
INSERT INTO `access_log` VALUES (19645, '64.81.15593784863523413', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:26', 10, 0, '', '2019-06-01 16:41:26');
INSERT INTO `access_log` VALUES (19646, '64.82.15593784863533427', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:26', 11, 0, '', '2019-06-01 16:41:26');
INSERT INTO `access_log` VALUES (19647, '64.84.15593784879213419', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:28', 9, 0, '', '2019-06-01 16:41:28');
INSERT INTO `access_log` VALUES (19648, '64.85.15593784879183429', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:28', 12, 0, '', '2019-06-01 16:41:28');
INSERT INTO `access_log` VALUES (19649, '64.78.15593784891243425', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:29', 9, 0, '', '2019-06-01 16:41:29');
INSERT INTO `access_log` VALUES (19650, '64.80.15593784891253411', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:29', 11, 0, '', '2019-06-01 16:41:29');
INSERT INTO `access_log` VALUES (19651, '64.79.15593784937223413', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:34', 10, 0, '', '2019-06-01 16:41:34');
INSERT INTO `access_log` VALUES (19652, '64.83.15593784937213413', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:34', 12, 0, '', '2019-06-01 16:41:34');
INSERT INTO `access_log` VALUES (19653, '64.77.15593784962913421', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:36', 10, 0, '', '2019-06-01 16:41:36');
INSERT INTO `access_log` VALUES (19654, '64.81.15593784974433415', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:37', 9, 0, '', '2019-06-01 16:41:37');
INSERT INTO `access_log` VALUES (19655, '64.85.15593784992083431', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:39', 9, 0, '', '2019-06-01 16:41:39');
INSERT INTO `access_log` VALUES (19656, '64.82.15593784992073429', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:41:39', 11, 0, '', '2019-06-01 16:41:39');
INSERT INTO `access_log` VALUES (19657, '65.54.15593785283333519', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:42:08', 4, 0, '', '2019-06-01 16:42:08');
INSERT INTO `access_log` VALUES (19658, '64.79.15593785487053415', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=test&sellPoint=test&cid=784&visible=false&picUrls=http://static.shop.iocoder.cn/81457a0a-37c4-44f3-90a8-91b4b3742364&skuStr=[{\"attrs\":[3],\"price\":100,\"quantity\":1}]&description=<p>test</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:42:29', 7, 1002002009, NULL, '2019-06-01 16:42:29');
INSERT INTO `access_log` VALUES (19659, '65.48.15593787248563551', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:45:25', 1, 1002001015, '账号未登陆', '2019-06-01 16:45:25');
INSERT INTO `access_log` VALUES (19660, '65.46.15593787248563543', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:45:25', 1, 1002001015, '账号未登陆', '2019-06-01 16:45:25');
INSERT INTO `access_log` VALUES (19661, '65.51.15593787248643539', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:45:25', 0, 1002001015, '账号未登陆', '2019-06-01 16:45:25');
INSERT INTO `access_log` VALUES (19662, '65.49.15593787277933559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:45:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 16:45:28');
INSERT INTO `access_log` VALUES (19663, '65.45.15593787320393555', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:45:32', 1054, 0, '', '2019-06-01 16:45:33');
INSERT INTO `access_log` VALUES (19664, '65.47.15593787334573559', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:45:33', 181, 0, '', '2019-06-01 16:45:34');
INSERT INTO `access_log` VALUES (19665, '65.54.15593787334553523', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:45:33', 181, 0, '', '2019-06-01 16:45:34');
INSERT INTO `access_log` VALUES (19666, '65.50.15593787334623553', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:45:33', 176, 0, '', '2019-06-01 16:45:34');
INSERT INTO `access_log` VALUES (19667, '62.84.15593787394003817', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:45:39', 14, 0, '', '2019-06-01 16:45:39');
INSERT INTO `access_log` VALUES (19668, '64.81.15593787442823419', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:45:44', 12, 0, '', '2019-06-01 16:45:44');
INSERT INTO `access_log` VALUES (19669, '64.82.15593787442853433', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:45:44', 8, 0, '', '2019-06-01 16:45:44');
INSERT INTO `access_log` VALUES (19670, '62.85.15593787537663827', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:45:54', 12, 0, '', '2019-06-01 16:45:54');
INSERT INTO `access_log` VALUES (19671, '66.57.15593787576462771', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:45:58', 15, 0, '', '2019-06-01 16:45:58');
INSERT INTO `access_log` VALUES (19672, '59.76.15593787614753929', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:46:01', 12, 0, '', '2019-06-01 16:46:01');
INSERT INTO `access_log` VALUES (19673, '59.74.15593787662763933', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:46:06', 12, 0, '', '2019-06-01 16:46:06');
INSERT INTO `access_log` VALUES (19674, '65.51.15593787750173541', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:46:15', 19, 0, '', '2019-06-01 16:46:15');
INSERT INTO `access_log` VALUES (19675, '65.46.15593787772063545', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.87.181.226', '2019-06-01 16:46:17', 10, 0, '', '2019-06-01 16:46:17');
INSERT INTO `access_log` VALUES (19676, '65.50.15593788066883555', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.218.210.87', '2019-06-01 16:46:47', 0, 1002001015, '账号未登陆', '2019-06-01 16:46:47');
INSERT INTO `access_log` VALUES (19677, '65.47.15593788066933561', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.218.210.87', '2019-06-01 16:46:47', 1, 1002001015, '账号未登陆', '2019-06-01 16:46:47');
INSERT INTO `access_log` VALUES (19678, '65.54.15593788066993525', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.218.210.87', '2019-06-01 16:46:47', 0, 1002001015, '账号未登陆', '2019-06-01 16:46:47');
INSERT INTO `access_log` VALUES (19679, '65.53.15593788105173533', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.218.210.87', '2019-06-01 16:46:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 16:46:51');
INSERT INTO `access_log` VALUES (19680, '65.48.15593788181423555', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.218.210.87', '2019-06-01 16:46:58', 80, 0, '', '2019-06-01 16:46:58');
INSERT INTO `access_log` VALUES (19681, '65.51.15593788187463543', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.218.210.87', '2019-06-01 16:46:59', 9, 0, '', '2019-06-01 16:46:59');
INSERT INTO `access_log` VALUES (19682, '65.46.15593788187503547', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.218.210.87', '2019-06-01 16:46:59', 9, 0, '', '2019-06-01 16:46:59');
INSERT INTO `access_log` VALUES (19683, '65.49.15593788187583563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.218.210.87', '2019-06-01 16:46:59', 9, 0, '', '2019-06-01 16:46:59');
INSERT INTO `access_log` VALUES (19684, '59.80.15593788261023933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:47:06', 2, 0, '', '2019-06-01 16:47:06');
INSERT INTO `access_log` VALUES (19685, '59.75.15593788261033935', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:47:06', 12, 2001001000, '服务端发生异常', '2019-06-01 16:47:06');
INSERT INTO `access_log` VALUES (19686, '62.86.15593788280133819', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.218.210.87', '2019-06-01 16:47:08', 15, 0, '', '2019-06-01 16:47:08');
INSERT INTO `access_log` VALUES (19687, '64.76.15593788309633417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:47:11', 2, 0, '', '2019-06-01 16:47:11');
INSERT INTO `access_log` VALUES (19688, '64.77.15593788310683427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:47:11', 2, 0, '', '2019-06-01 16:47:11');
INSERT INTO `access_log` VALUES (19689, '64.82.15593788338123435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:47:14', 3, 0, '', '2019-06-01 16:47:14');
INSERT INTO `access_log` VALUES (19690, '64.81.15593788348943421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:47:15', 3, 0, '', '2019-06-01 16:47:15');
INSERT INTO `access_log` VALUES (19691, '59.73.15593788370573939', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.218.210.87', '2019-06-01 16:47:17', 11, 0, '', '2019-06-01 16:47:17');
INSERT INTO `access_log` VALUES (19692, '64.85.15593788392423437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:47:19', 2, 0, '', '2019-06-01 16:47:19');
INSERT INTO `access_log` VALUES (19693, '64.84.15593788393473427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:47:19', 2, 0, '', '2019-06-01 16:47:19');
INSERT INTO `access_log` VALUES (19694, '59.74.15593788414343935', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:47:21', 3, 0, '', '2019-06-01 16:47:21');
INSERT INTO `access_log` VALUES (19695, '59.77.15593788414343931', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:47:21', 21, 2001001000, '服务端发生异常', '2019-06-01 16:47:21');
INSERT INTO `access_log` VALUES (19696, '64.78.15593788457543433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:47:26', 2, 0, '', '2019-06-01 16:47:26');
INSERT INTO `access_log` VALUES (19697, '64.79.15593788458553421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:47:26', 3, 0, '', '2019-06-01 16:47:26');
INSERT INTO `access_log` VALUES (19698, '59.79.15593788465703935', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:47:27', 3, 0, '', '2019-06-01 16:47:27');
INSERT INTO `access_log` VALUES (19699, '59.78.15593788465703939', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.177.50', '2019-06-01 16:47:27', 14, 2001001000, '服务端发生异常', '2019-06-01 16:47:27');
INSERT INTO `access_log` VALUES (19700, '65.54.15593788482023527', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:28', 9, 0, '', '2019-06-01 16:47:28');
INSERT INTO `access_log` VALUES (19701, '65.50.15593788482043557', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:28', 9, 0, '', '2019-06-01 16:47:28');
INSERT INTO `access_log` VALUES (19702, '65.53.15593788482123535', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:28', 9, 0, '', '2019-06-01 16:47:28');
INSERT INTO `access_log` VALUES (19703, '59.72.15593788496653933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:30', 3, 0, '', '2019-06-01 16:47:30');
INSERT INTO `access_log` VALUES (19704, '59.71.15593788496653939', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:30', 12, 2001001000, '服务端发生异常', '2019-06-01 16:47:30');
INSERT INTO `access_log` VALUES (19705, '64.83.15593788543253421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:34', 2, 0, '', '2019-06-01 16:47:34');
INSERT INTO `access_log` VALUES (19706, '64.76.15593788544373419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:34', 8, 0, '', '2019-06-01 16:47:34');
INSERT INTO `access_log` VALUES (19707, '64.82.15593788555343437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:36', 2, 0, '', '2019-06-01 16:47:36');
INSERT INTO `access_log` VALUES (19708, '64.81.15593788562423423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:36', 2, 0, '', '2019-06-01 16:47:36');
INSERT INTO `access_log` VALUES (19709, '64.85.15593788567053439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:37', 2, 0, '', '2019-06-01 16:47:37');
INSERT INTO `access_log` VALUES (19710, '64.84.15593788569283429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:37', 2, 0, '', '2019-06-01 16:47:37');
INSERT INTO `access_log` VALUES (19711, '66.49.15593788590582771', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字', '2019-06-01 16:47:39');
INSERT INTO `access_log` VALUES (19712, '62.83.15593788653843823', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:45', 12, 0, '', '2019-06-01 16:47:45');
INSERT INTO `access_log` VALUES (19713, '64.79.15593788786553423', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:59', 17, 0, '', '2019-06-01 16:47:59');
INSERT INTO `access_log` VALUES (19714, '64.78.15593788786543435', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:47:59', 19, 0, '', '2019-06-01 16:47:59');
INSERT INTO `access_log` VALUES (19715, '64.83.15593788823533423', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:02', 11, 0, '', '2019-06-01 16:48:02');
INSERT INTO `access_log` VALUES (19716, '64.76.15593788823593421', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:02', 8, 0, '', '2019-06-01 16:48:02');
INSERT INTO `access_log` VALUES (19717, '64.82.15593788859213439', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:06', 11, 0, '', '2019-06-01 16:48:06');
INSERT INTO `access_log` VALUES (19718, '64.81.15593788916023425', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:12', 354, 0, '', '2019-06-01 16:48:12');
INSERT INTO `access_log` VALUES (19719, '64.85.15593788925793441', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:13', 74, 0, '', '2019-06-01 16:48:13');
INSERT INTO `access_log` VALUES (19720, '64.84.15593788934633431', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:13', 10, 0, '', '2019-06-01 16:48:13');
INSERT INTO `access_log` VALUES (19721, '64.78.15593788959403437', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:16', 9, 0, '', '2019-06-01 16:48:16');
INSERT INTO `access_log` VALUES (19722, '64.79.15593788959373425', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:16', 12, 0, '', '2019-06-01 16:48:16');
INSERT INTO `access_log` VALUES (19723, '64.80.15593788959373423', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:16', 15, 0, '', '2019-06-01 16:48:16');
INSERT INTO `access_log` VALUES (19724, '64.83.15593789011833425', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:21', 16, 0, '', '2019-06-01 16:48:21');
INSERT INTO `access_log` VALUES (19725, '64.77.15593789011923433', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:21', 12, 0, '', '2019-06-01 16:48:21');
INSERT INTO `access_log` VALUES (19726, '66.48.15593789031662777', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:23', 11, 0, '', '2019-06-01 16:48:23');
INSERT INTO `access_log` VALUES (19727, '65.51.15593789060673545', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:26', 16, 0, '', '2019-06-01 16:48:26');
INSERT INTO `access_log` VALUES (19728, '65.45.15593789070053561', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:27', 10, 0, '', '2019-06-01 16:48:27');
INSERT INTO `access_log` VALUES (19729, '65.47.15593789099343565', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:30', 95, 0, '', '2019-06-01 16:48:30');
INSERT INTO `access_log` VALUES (19730, '65.50.15593789221973559', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:42', 14, 0, '', '2019-06-01 16:48:42');
INSERT INTO `access_log` VALUES (19731, '65.53.15593789338483537', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:54', 11, 0, '', '2019-06-01 16:48:54');
INSERT INTO `access_log` VALUES (19732, '65.48.15593789347313559', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:55', 19, 0, '', '2019-06-01 16:48:55');
INSERT INTO `access_log` VALUES (19733, '65.49.15593789373723567', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:48:57', 17, 0, '', '2019-06-01 16:48:57');
INSERT INTO `access_log` VALUES (19734, '65.51.15593789561703547', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:16', 9, 0, '', '2019-06-01 16:49:16');
INSERT INTO `access_log` VALUES (19735, '65.45.15593789561703563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:16', 10, 0, '', '2019-06-01 16:49:16');
INSERT INTO `access_log` VALUES (19736, '65.47.15593789561723567', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:16', 10, 0, '', '2019-06-01 16:49:16');
INSERT INTO `access_log` VALUES (19737, '65.54.15593789572633531', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:17', 9, 0, '', '2019-06-01 16:49:17');
INSERT INTO `access_log` VALUES (19738, '65.50.15593789572653561', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:17', 9, 0, '', '2019-06-01 16:49:17');
INSERT INTO `access_log` VALUES (19739, '65.53.15593789572703539', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:17', 8, 0, '', '2019-06-01 16:49:17');
INSERT INTO `access_log` VALUES (19740, '65.52.15593789579623543', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:18', 9, 0, '', '2019-06-01 16:49:18');
INSERT INTO `access_log` VALUES (19741, '65.48.15593789579843561', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:18', 9, 0, '', '2019-06-01 16:49:18');
INSERT INTO `access_log` VALUES (19742, '65.49.15593789579853569', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:18', 9, 0, '', '2019-06-01 16:49:18');
INSERT INTO `access_log` VALUES (19743, '65.46.15593789587543553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:19', 9, 0, '', '2019-06-01 16:49:19');
INSERT INTO `access_log` VALUES (19744, '65.47.15593789587573569', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:19', 9, 0, '', '2019-06-01 16:49:19');
INSERT INTO `access_log` VALUES (19745, '65.45.15593789587593565', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:19', 8, 0, '', '2019-06-01 16:49:19');
INSERT INTO `access_log` VALUES (19746, '65.51.15593789595063549', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:20', 8, 0, '', '2019-06-01 16:49:20');
INSERT INTO `access_log` VALUES (19747, '65.54.15593789595073533', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:20', 7, 0, '', '2019-06-01 16:49:20');
INSERT INTO `access_log` VALUES (19748, '65.50.15593789595103563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:20', 7, 0, '', '2019-06-01 16:49:20');
INSERT INTO `access_log` VALUES (19749, '64.79.15593789631003427', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:23', 10, 0, '', '2019-06-01 16:49:23');
INSERT INTO `access_log` VALUES (19750, '64.78.15593789631013439', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:23', 11, 0, '', '2019-06-01 16:49:23');
INSERT INTO `access_log` VALUES (19751, '59.80.15593789964353937', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:56', 1211, 0, '', '2019-06-01 16:49:58');
INSERT INTO `access_log` VALUES (19752, '59.75.15593789985923939', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:49:59', 451, 2001001000, '服务端发生异常', '2019-06-01 16:49:59');
INSERT INTO `access_log` VALUES (19753, '59.73.15593790013143943', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:50:01', 40, 0, '', '2019-06-01 16:50:01');
INSERT INTO `access_log` VALUES (19754, '64.77.15593790050023435', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:50:05', 9, 0, '', '2019-06-01 16:50:05');
INSERT INTO `access_log` VALUES (19755, '59.77.15593790072893935', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/update_card', 'id=7&title=优惠劵D&description=优惠劵D&quota=2&total=10&rangeType=30&rangeValues=784,637', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:50:07', 8, 1002002009, NULL, '2019-06-01 16:50:07');
INSERT INTO `access_log` VALUES (19756, '59.74.15593790164483939', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/update_card', 'id=7&title=优惠劵D&description=优惠劵D&quota=2&total=10&rangeType=30&rangeValues=784,637', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:50:16', 8, 1002002009, NULL, '2019-06-01 16:50:16');
INSERT INTO `access_log` VALUES (19757, '59.78.15593790179063943', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/update_card', 'id=7&title=优惠劵D&description=优惠劵D&quota=2&total=10&rangeType=30&rangeValues=784,637', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 16:50:18', 718, 1002002009, NULL, '2019-06-01 16:50:19');
INSERT INTO `access_log` VALUES (19758, '59.76.15593795522403943', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:12', 3, 0, '', '2019-06-01 16:59:12');
INSERT INTO `access_log` VALUES (19759, '59.77.15593795522413943', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:12', 19, 2001001000, '服务端发生异常', '2019-06-01 16:59:12');
INSERT INTO `access_log` VALUES (19760, '64.80.15593795559633433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:16', 3, 0, '', '2019-06-01 16:59:16');
INSERT INTO `access_log` VALUES (19761, '64.76.15593795560463433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:16', 2, 0, '', '2019-06-01 16:59:16');
INSERT INTO `access_log` VALUES (19762, '59.74.15593795585433947', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:19', 4, 0, '', '2019-06-01 16:59:19');
INSERT INTO `access_log` VALUES (19763, '59.78.15593795585443951', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:19', 13, 2001001000, '服务端发生异常', '2019-06-01 16:59:19');
INSERT INTO `access_log` VALUES (19764, '59.71.15593795641373951', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:24', 3, 0, '', '2019-06-01 16:59:24');
INSERT INTO `access_log` VALUES (19765, '59.72.15593795641383945', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:24', 11, 2001001000, '服务端发生异常', '2019-06-01 16:59:24');
INSERT INTO `access_log` VALUES (19766, '59.75.15593795763573949', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:36', 3, 0, '', '2019-06-01 16:59:36');
INSERT INTO `access_log` VALUES (19767, '59.73.15593795763583953', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:36', 13, 2001001000, '服务端发生异常', '2019-06-01 16:59:36');
INSERT INTO `access_log` VALUES (19768, '64.82.15593795769053451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:37', 2, 0, '', '2019-06-01 16:59:37');
INSERT INTO `access_log` VALUES (19769, '64.81.15593795770073437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:37', 2, 0, '', '2019-06-01 16:59:37');
INSERT INTO `access_log` VALUES (19770, '59.76.15593795776283945', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:38', 3, 0, '', '2019-06-01 16:59:38');
INSERT INTO `access_log` VALUES (19771, '59.77.15593795776293945', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:38', 19, 2001001000, '服务端发生异常', '2019-06-01 16:59:38');
INSERT INTO `access_log` VALUES (19772, '59.78.15593795845403953', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 16:59:45', 3, 0, '', '2019-06-01 16:59:45');
INSERT INTO `access_log` VALUES (19773, '59.74.15593795845413949', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 16:59:45', 13, 2001001000, '服务端发生异常', '2019-06-01 16:59:45');
INSERT INTO `access_log` VALUES (19774, '65.45.15593795893973575', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:49', 1, 1002001015, '账号未登陆', '2019-06-01 16:59:49');
INSERT INTO `access_log` VALUES (19775, '65.47.15593795894023579', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:49', 0, 1002001015, '账号未登陆', '2019-06-01 16:59:49');
INSERT INTO `access_log` VALUES (19776, '65.50.15593795894063577', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:49', 0, 1002001015, '账号未登陆', '2019-06-01 16:59:49');
INSERT INTO `access_log` VALUES (19777, '65.51.15593795927943559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 16:59:53');
INSERT INTO `access_log` VALUES (19778, '65.54.15593795988983543', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:59', 282, 0, '', '2019-06-01 16:59:59');
INSERT INTO `access_log` VALUES (19779, '65.52.15593795994803553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:59', 10, 0, '', '2019-06-01 16:59:59');
INSERT INTO `access_log` VALUES (19780, '65.49.15593795994863579', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:59', 9, 0, '', '2019-06-01 16:59:59');
INSERT INTO `access_log` VALUES (19781, '65.48.15593795994973573', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 16:59:59', 10, 0, '', '2019-06-01 17:00:00');
INSERT INTO `access_log` VALUES (19782, '65.50.15593796137563579', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:14', 9, 0, '', '2019-06-01 17:00:14');
INSERT INTO `access_log` VALUES (19783, '65.47.15593796137593581', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:14', 8, 0, '', '2019-06-01 17:00:14');
INSERT INTO `access_log` VALUES (19784, '65.45.15593796137633577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:14', 9, 0, '', '2019-06-01 17:00:14');
INSERT INTO `access_log` VALUES (19785, '65.51.15593796185063561', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:00:19', 1, 1002001015, '账号未登陆', '2019-06-01 17:00:19');
INSERT INTO `access_log` VALUES (19786, '65.53.15593796185093555', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:00:19', 8, 1002001015, '账号未登陆', '2019-06-01 17:00:19');
INSERT INTO `access_log` VALUES (19787, '65.54.15593796185173545', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:00:19', 0, 1002001015, '账号未登陆', '2019-06-01 17:00:19');
INSERT INTO `access_log` VALUES (19788, '65.49.15593796189183581', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:19', 9, 0, '', '2019-06-01 17:00:19');
INSERT INTO `access_log` VALUES (19789, '65.48.15593796189263575', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:19', 9, 0, '', '2019-06-01 17:00:19');
INSERT INTO `access_log` VALUES (19790, '65.52.15593796189293555', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:19', 8, 0, '', '2019-06-01 17:00:19');
INSERT INTO `access_log` VALUES (19791, '65.46.15593796204643569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:00:20', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 17:00:20');
INSERT INTO `access_log` VALUES (19792, '62.88.15593796234183843', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:23', 14, 0, '', '2019-06-01 17:00:23');
INSERT INTO `access_log` VALUES (19793, '65.47.15593796235513583', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:00:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 17:00:24');
INSERT INTO `access_log` VALUES (19794, '65.53.15593796290833557', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:29', 251, 0, '', '2019-06-01 17:00:29');
INSERT INTO `access_log` VALUES (19795, '65.45.15593796290793579', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:29', 256, 0, '', '2019-06-01 17:00:29');
INSERT INTO `access_log` VALUES (19796, '64.78.15593796289323449', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:29', 403, 0, '', '2019-06-01 17:00:29');
INSERT INTO `access_log` VALUES (19797, '64.80.15593796289463435', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:29', 389, 0, '', '2019-06-01 17:00:29');
INSERT INTO `access_log` VALUES (19798, '65.51.15593796291013563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:29', 236, 0, '', '2019-06-01 17:00:29');
INSERT INTO `access_log` VALUES (19799, '64.76.15593796297783435', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:30', 57, 0, '', '2019-06-01 17:00:30');
INSERT INTO `access_log` VALUES (19800, '64.77.15593796297783445', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:30', 58, 0, '', '2019-06-01 17:00:30');
INSERT INTO `access_log` VALUES (19801, '62.80.15593796317433841', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:32', 11, 0, '', '2019-06-01 17:00:32');
INSERT INTO `access_log` VALUES (19802, '59.80.15593796317893949', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.23.253.11', '2019-06-01 17:00:32', 3, 0, '', '2019-06-01 17:00:32');
INSERT INTO `access_log` VALUES (19803, '59.75.15593796317933951', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.23.253.11', '2019-06-01 17:00:32', 12, 2001001000, '服务端发生异常', '2019-06-01 17:00:32');
INSERT INTO `access_log` VALUES (19804, '65.54.15593796367463547', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:37', 8, 0, '', '2019-06-01 17:00:37');
INSERT INTO `access_log` VALUES (19805, '65.49.15593796367463583', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:37', 9, 0, '', '2019-06-01 17:00:37');
INSERT INTO `access_log` VALUES (19806, '65.48.15593796367503577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:37', 8, 0, '', '2019-06-01 17:00:37');
INSERT INTO `access_log` VALUES (19807, '62.87.15593796369483841', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:37', 12, 0, '', '2019-06-01 17:00:37');
INSERT INTO `access_log` VALUES (19808, '65.46.15593796474993571', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:00:47', 492, 0, '', '2019-06-01 17:00:48');
INSERT INTO `access_log` VALUES (19809, '65.47.15593796482393585', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:00:48', 9, 0, '', '2019-06-01 17:00:48');
INSERT INTO `access_log` VALUES (19810, '65.50.15593796482433583', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:00:48', 8, 0, '', '2019-06-01 17:00:48');
INSERT INTO `access_log` VALUES (19811, '65.45.15593796482483581', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:00:48', 8, 0, '', '2019-06-01 17:00:48');
INSERT INTO `access_log` VALUES (19812, '65.53.15593796543813559', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:54', 10, 0, '', '2019-06-01 17:00:54');
INSERT INTO `access_log` VALUES (19813, '65.49.15593796543813585', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:54', 9, 0, '', '2019-06-01 17:00:54');
INSERT INTO `access_log` VALUES (19814, '65.48.15593796543833579', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:54', 11, 0, '', '2019-06-01 17:00:54');
INSERT INTO `access_log` VALUES (19815, '65.54.15593796545533549', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.95.202.69', '2019-06-01 17:00:55', 18, 0, '', '2019-06-01 17:00:55');
INSERT INTO `access_log` VALUES (19816, '62.86.15593796550913831', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:00:55', 10, 0, '', '2019-06-01 17:00:55');
INSERT INTO `access_log` VALUES (19817, '64.81.15593796603703439', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:01:00', 10, 0, '', '2019-06-01 17:01:00');
INSERT INTO `access_log` VALUES (19818, '64.85.15593796603703455', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:01:00', 12, 0, '', '2019-06-01 17:01:00');
INSERT INTO `access_log` VALUES (19819, '59.76.15593796637253947', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:01:04', 11, 0, '', '2019-06-01 17:01:04');
INSERT INTO `access_log` VALUES (19820, '65.46.15593796707353573', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:01:11', 24, 0, '', '2019-06-01 17:01:11');
INSERT INTO `access_log` VALUES (19821, '65.45.15593796764593583', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:01:16', 11, 0, '', '2019-06-01 17:01:16');
INSERT INTO `access_log` VALUES (19822, '64.78.15593796983173451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.23.253.11', '2019-06-01 17:01:38', 2, 0, '', '2019-06-01 17:01:38');
INSERT INTO `access_log` VALUES (19823, '64.76.15593796984623437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.23.253.11', '2019-06-01 17:01:38', 3, 0, '', '2019-06-01 17:01:38');
INSERT INTO `access_log` VALUES (19824, '64.77.15593796995773447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.23.253.11', '2019-06-01 17:01:40', 3, 0, '', '2019-06-01 17:01:40');
INSERT INTO `access_log` VALUES (19825, '64.83.15593797000793439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.23.253.11', '2019-06-01 17:01:40', 2, 0, '', '2019-06-01 17:01:40');
INSERT INTO `access_log` VALUES (19826, '65.53.15593797151053561', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:01:55', 8, 0, '', '2019-06-01 17:01:55');
INSERT INTO `access_log` VALUES (19827, '65.48.15593797151053581', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:01:55', 8, 0, '', '2019-06-01 17:01:55');
INSERT INTO `access_log` VALUES (19828, '65.49.15593797151053587', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:01:55', 9, 0, '', '2019-06-01 17:01:55');
INSERT INTO `access_log` VALUES (19829, '65.54.15593797151633551', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:01:55', 10, 0, '', '2019-06-01 17:01:55');
INSERT INTO `access_log` VALUES (19830, '64.81.15593797194373441', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:01:59', 12, 0, '', '2019-06-01 17:01:59');
INSERT INTO `access_log` VALUES (19831, '64.85.15593797194423457', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:01:59', 8, 0, '', '2019-06-01 17:01:59');
INSERT INTO `access_log` VALUES (19832, '65.52.15593797243033561', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:02:04', 8, 0, '', '2019-06-01 17:02:04');
INSERT INTO `access_log` VALUES (19833, '65.46.15593797243163575', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:02:04', 9, 0, '', '2019-06-01 17:02:04');
INSERT INTO `access_log` VALUES (19834, '65.45.15593797243163585', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:02:04', 7, 0, '', '2019-06-01 17:02:04');
INSERT INTO `access_log` VALUES (19835, '64.84.15593797244953447', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:02:04', 11, 0, '', '2019-06-01 17:02:05');
INSERT INTO `access_log` VALUES (19836, '64.79.15593797244993441', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:02:05', 8, 0, '', '2019-06-01 17:02:05');
INSERT INTO `access_log` VALUES (19837, '62.80.15593797274413843', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:02:07', 15, 0, '', '2019-06-01 17:02:07');
INSERT INTO `access_log` VALUES (19838, '66.49.15593797293362783', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '27.38.4.176', '2019-06-01 17:02:09', 12, 0, '', '2019-06-01 17:02:09');
INSERT INTO `access_log` VALUES (19839, '59.75.15593797374263953', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:17', 3, 0, '', '2019-06-01 17:02:17');
INSERT INTO `access_log` VALUES (19840, '59.80.15593797374213951', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:17', 20, 2001001000, '服务端发生异常', '2019-06-01 17:02:17');
INSERT INTO `access_log` VALUES (19841, '65.50.15593797409583587', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:21', 1, 1002001015, '账号未登陆', '2019-06-01 17:02:21');
INSERT INTO `access_log` VALUES (19842, '65.51.15593797409633569', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:21', 1, 1002001015, '账号未登陆', '2019-06-01 17:02:21');
INSERT INTO `access_log` VALUES (19843, '65.49.15593797409683589', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:21', 1, 1002001015, '账号未登陆', '2019-06-01 17:02:21');
INSERT INTO `access_log` VALUES (19844, '64.76.15593797434113439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:23', 2, 0, '', '2019-06-01 17:02:23');
INSERT INTO `access_log` VALUES (19845, '64.77.15593797435363449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:24', 2, 0, '', '2019-06-01 17:02:24');
INSERT INTO `access_log` VALUES (19846, '64.83.15593797447853441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:25', 2, 0, '', '2019-06-01 17:02:25');
INSERT INTO `access_log` VALUES (19847, '64.82.15593797452013457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:25', 2, 0, '', '2019-06-01 17:02:25');
INSERT INTO `access_log` VALUES (19848, '65.48.15593797519023583', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:32', 90, 0, '', '2019-06-01 17:02:32');
INSERT INTO `access_log` VALUES (19849, '65.54.15593797522993553', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:32', 10, 0, '', '2019-06-01 17:02:32');
INSERT INTO `access_log` VALUES (19850, '65.52.15593797523053563', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:32', 8, 0, '', '2019-06-01 17:02:32');
INSERT INTO `access_log` VALUES (19851, '65.45.15593797523073587', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:32', 9, 0, '', '2019-06-01 17:02:32');
INSERT INTO `access_log` VALUES (19852, '62.87.15593797552683843', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:35', 13, 0, '', '2019-06-01 17:02:35');
INSERT INTO `access_log` VALUES (19853, '64.81.15593797577973443', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:38', 18, 0, '', '2019-06-01 17:02:38');
INSERT INTO `access_log` VALUES (19854, '64.84.15593797577993449', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:38', 9, 0, '', '2019-06-01 17:02:38');
INSERT INTO `access_log` VALUES (19855, '65.47.15593797639433591', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:44', 4, 0, '', '2019-06-01 17:02:44');
INSERT INTO `access_log` VALUES (19856, '66.48.15593797747432789', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:55', 14, 0, '', '2019-06-01 17:02:55');
INSERT INTO `access_log` VALUES (19857, '59.74.15593797763483953', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:56', 11, 0, '', '2019-06-01 17:02:56');
INSERT INTO `access_log` VALUES (19858, '65.49.15593797779283591', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:02:58', 28, 0, '', '2019-06-01 17:02:58');
INSERT INTO `access_log` VALUES (19859, '62.89.15593797798333839', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:03:00', 13, 0, '', '2019-06-01 17:03:00');
INSERT INTO `access_log` VALUES (19860, '62.84.15593797818233833', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.64.16.233', '2019-06-01 17:03:02', 16, 0, '', '2019-06-01 17:03:02');
INSERT INTO `access_log` VALUES (19861, '65.54.15593812414853575', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:27:21', 1, 1002001015, '账号未登陆', '2019-06-01 17:27:21');
INSERT INTO `access_log` VALUES (19862, '65.47.15593812414853611', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:27:21', 0, 1002001015, '账号未登陆', '2019-06-01 17:27:21');
INSERT INTO `access_log` VALUES (19863, '65.46.15593812414893597', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:27:21', 0, 1002001015, '账号未登陆', '2019-06-01 17:27:21');
INSERT INTO `access_log` VALUES (19864, '65.49.15593812452473611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:27:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 17:27:25');
INSERT INTO `access_log` VALUES (19865, '65.50.15593812509523609', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:27:31', 67, 0, '', '2019-06-01 17:27:31');
INSERT INTO `access_log` VALUES (19866, '65.48.15593812515523607', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:27:32', 10, 0, '', '2019-06-01 17:27:32');
INSERT INTO `access_log` VALUES (19867, '65.53.15593812515523587', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:27:32', 10, 0, '', '2019-06-01 17:27:32');
INSERT INTO `access_log` VALUES (19868, '65.45.15593812515523609', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:27:32', 10, 0, '', '2019-06-01 17:27:32');
INSERT INTO `access_log` VALUES (19869, '62.84.15593812633133853', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:27:43', 15, 0, '', '2019-06-01 17:27:43');
INSERT INTO `access_log` VALUES (19870, '59.78.15593812834653977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:28:03', 3, 0, '', '2019-06-01 17:28:03');
INSERT INTO `access_log` VALUES (19871, '59.79.15593812834673973', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:28:03', 10, 2001001000, '服务端发生异常', '2019-06-01 17:28:03');
INSERT INTO `access_log` VALUES (19872, '64.78.15593812909553475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:28:11', 3, 0, '', '2019-06-01 17:28:11');
INSERT INTO `access_log` VALUES (19873, '64.76.15593812911503461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:28:11', 2, 0, '', '2019-06-01 17:28:11');
INSERT INTO `access_log` VALUES (19874, '64.77.15593812922803471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:28:12', 163, 0, '', '2019-06-01 17:28:12');
INSERT INTO `access_log` VALUES (19875, '64.83.15593812926843463', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:28:13', 135, 0, '', '2019-06-01 17:28:13');
INSERT INTO `access_log` VALUES (19876, '64.82.15593812933793479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:28:13', 2, 0, '', '2019-06-01 17:28:13');
INSERT INTO `access_log` VALUES (19877, '64.81.15593813056633465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:28:26', 2, 0, '', '2019-06-01 17:28:26');
INSERT INTO `access_log` VALUES (19878, '64.84.15593813058913471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.226.178', '2019-06-01 17:28:26', 2, 0, '', '2019-06-01 17:28:26');
INSERT INTO `access_log` VALUES (19879, '59.71.15593814208123979', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '112.10.235.180', '2019-06-01 17:30:21', 4, 0, '', '2019-06-01 17:30:21');
INSERT INTO `access_log` VALUES (19880, '59.72.15593814208133973', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '112.10.235.180', '2019-06-01 17:30:21', 13, 2001001000, '服务端发生异常', '2019-06-01 17:30:21');
INSERT INTO `access_log` VALUES (19881, '64.81.15593814239733467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '112.10.235.180', '2019-06-01 17:30:24', 3, 0, '', '2019-06-01 17:30:24');
INSERT INTO `access_log` VALUES (19882, '64.84.15593814241193473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '112.10.235.180', '2019-06-01 17:30:24', 2, 0, '', '2019-06-01 17:30:24');
INSERT INTO `access_log` VALUES (19883, '64.79.15593814255983467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '112.10.235.180', '2019-06-01 17:30:26', 3, 0, '', '2019-06-01 17:30:26');
INSERT INTO `access_log` VALUES (19884, '64.80.15593814266843465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '112.10.235.180', '2019-06-01 17:30:27', 2, 0, '', '2019-06-01 17:30:27');
INSERT INTO `access_log` VALUES (19885, '64.78.15593814274343479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '112.10.235.180', '2019-06-01 17:30:27', 3, 0, '', '2019-06-01 17:30:27');
INSERT INTO `access_log` VALUES (19886, '64.76.15593814278343465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '112.10.235.180', '2019-06-01 17:30:28', 3, 0, '', '2019-06-01 17:30:28');
INSERT INTO `access_log` VALUES (19887, '59.75.15593814298473977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '112.10.235.180', '2019-06-01 17:30:30', 3, 0, '', '2019-06-01 17:30:30');
INSERT INTO `access_log` VALUES (19888, '59.80.15593814298483975', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '112.10.235.180', '2019-06-01 17:30:30', 13, 2001001000, '服务端发生异常', '2019-06-01 17:30:30');
INSERT INTO `access_log` VALUES (19889, '66.54.15593814350072809', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '112.10.235.180', '2019-06-01 17:30:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-06-01 17:30:35');
INSERT INTO `access_log` VALUES (19890, '65.49.15593816204263617', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.83.51', '2019-06-01 17:33:40', 0, 1002001015, '账号未登陆', '2019-06-01 17:33:40');
INSERT INTO `access_log` VALUES (19891, '65.53.15593816204273593', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.83.51', '2019-06-01 17:33:40', 1, 1002001015, '账号未登陆', '2019-06-01 17:33:40');
INSERT INTO `access_log` VALUES (19892, '65.50.15593816204273615', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.83.51', '2019-06-01 17:33:40', 1, 1002001015, '账号未登陆', '2019-06-01 17:33:40');
INSERT INTO `access_log` VALUES (19893, '59.73.15593817306953985', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '119.86.137.227', '2019-06-01 17:35:31', 4, 0, '', '2019-06-01 17:35:31');
INSERT INTO `access_log` VALUES (19894, '59.77.15593817306983977', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '119.86.137.227', '2019-06-01 17:35:31', 13, 2001001000, '服务端发生异常', '2019-06-01 17:35:31');
INSERT INTO `access_log` VALUES (19895, '64.77.15593817351233479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '119.86.137.227', '2019-06-01 17:35:35', 3, 0, '', '2019-06-01 17:35:35');
INSERT INTO `access_log` VALUES (19896, '64.83.15593817352633471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '119.86.137.227', '2019-06-01 17:35:35', 2, 0, '', '2019-06-01 17:35:35');
INSERT INTO `access_log` VALUES (19897, '59.75.15593819696503985', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '112.10.235.180', '2019-06-01 17:39:30', 4, 0, '', '2019-06-01 17:39:30');
INSERT INTO `access_log` VALUES (19898, '59.80.15593819696513983', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '112.10.235.180', '2019-06-01 17:39:30', 10, 2001001000, '服务端发生异常', '2019-06-01 17:39:30');
INSERT INTO `access_log` VALUES (19899, '65.47.15593828633473635', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.33.103.222', '2019-06-01 17:54:23', 0, 1002001015, '账号未登陆', '2019-06-01 17:54:23');
INSERT INTO `access_log` VALUES (19900, '65.52.15593828633473609', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.33.103.222', '2019-06-01 17:54:23', 0, 1002001015, '账号未登陆', '2019-06-01 17:54:23');
INSERT INTO `access_log` VALUES (19901, '65.54.15593828633493599', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.33.103.222', '2019-06-01 17:54:23', 1, 1002001015, '账号未登陆', '2019-06-01 17:54:23');
INSERT INTO `access_log` VALUES (19902, '65.51.15593828648543617', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.33.103.222', '2019-06-01 17:54:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 17:54:25');
INSERT INTO `access_log` VALUES (19903, '65.47.15593829691623637', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.2.26.138', '2019-06-01 17:56:09', 1, 1002001015, '账号未登陆', '2019-06-01 17:56:09');
INSERT INTO `access_log` VALUES (19904, '65.46.15593829691733623', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.2.26.138', '2019-06-01 17:56:09', 1, 1002001015, '账号未登陆', '2019-06-01 17:56:09');
INSERT INTO `access_log` VALUES (19905, '65.51.15593829691873619', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.2.26.138', '2019-06-01 17:56:09', 0, 1002001015, '账号未登陆', '2019-06-01 17:56:09');
INSERT INTO `access_log` VALUES (19906, '65.49.15593829752243637', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.2.26.138', '2019-06-01 17:56:15', 383, 0, '', '2019-06-01 17:56:16');
INSERT INTO `access_log` VALUES (19907, '65.50.15593829759313635', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.2.26.138', '2019-06-01 17:56:16', 9, 0, '', '2019-06-01 17:56:16');
INSERT INTO `access_log` VALUES (19908, '65.53.15593829759393613', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.2.26.138', '2019-06-01 17:56:16', 16, 0, '', '2019-06-01 17:56:16');
INSERT INTO `access_log` VALUES (19909, '65.45.15593829759533635', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.2.26.138', '2019-06-01 17:56:16', 8, 0, '', '2019-06-01 17:56:16');
INSERT INTO `access_log` VALUES (19910, '65.48.15593829838063633', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.2.26.138', '2019-06-01 17:56:24', 11, 0, '', '2019-06-01 17:56:24');
INSERT INTO `access_log` VALUES (19911, '65.54.15593829852103603', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.2.26.138', '2019-06-01 17:56:25', 9, 0, '', '2019-06-01 17:56:25');
INSERT INTO `access_log` VALUES (19912, '65.46.15593829913013625', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.2.26.138', '2019-06-01 17:56:31', 9, 0, '', '2019-06-01 17:56:31');
INSERT INTO `access_log` VALUES (19913, '65.46.15593832836433629', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.1.240.5', '2019-06-01 18:01:24', 0, 1002001015, '账号未登陆', '2019-06-01 18:01:24');
INSERT INTO `access_log` VALUES (19914, '65.47.15593832841003643', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.1.240.5', '2019-06-01 18:01:24', 1, 1002001015, '账号未登陆', '2019-06-01 18:01:24');
INSERT INTO `access_log` VALUES (19915, '65.49.15593832841463643', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.1.240.5', '2019-06-01 18:01:24', 0, 1002001015, '账号未登陆', '2019-06-01 18:01:24');
INSERT INTO `access_log` VALUES (19916, '65.50.15593832891443641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.1.240.5', '2019-06-01 18:01:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 18:01:29');
INSERT INTO `access_log` VALUES (19917, '59.77.15593833163073999', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.202.231.78', '2019-06-01 18:01:56', 4, 0, '', '2019-06-01 18:01:56');
INSERT INTO `access_log` VALUES (19918, '59.73.15593833163074007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.202.231.78', '2019-06-01 18:01:56', 19, 2001001000, '服务端发生异常', '2019-06-01 18:01:56');
INSERT INTO `access_log` VALUES (19919, '64.78.15593833191223505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.202.231.78', '2019-06-01 18:01:59', 3, 0, '', '2019-06-01 18:01:59');
INSERT INTO `access_log` VALUES (19920, '64.76.15593833192513491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.202.231.78', '2019-06-01 18:01:59', 2, 0, '', '2019-06-01 18:01:59');
INSERT INTO `access_log` VALUES (19921, '64.77.15593833208673501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.202.231.78', '2019-06-01 18:02:01', 2, 0, '', '2019-06-01 18:02:01');
INSERT INTO `access_log` VALUES (19922, '64.83.15593833216433493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.202.231.78', '2019-06-01 18:02:02', 3, 0, '', '2019-06-01 18:02:02');
INSERT INTO `access_log` VALUES (19923, '66.55.15593833268662841', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.202.231.78', '2019-06-01 18:02:07', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空\n账号长度为 11 位', '2019-06-01 18:02:07');
INSERT INTO `access_log` VALUES (19924, '65.54.15593836353513613', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:07:15', 1, 1002001015, '账号未登陆', '2019-06-01 18:07:15');
INSERT INTO `access_log` VALUES (19925, '65.46.15593836353513635', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:07:15', 1, 1002001015, '账号未登陆', '2019-06-01 18:07:15');
INSERT INTO `access_log` VALUES (19926, '65.52.15593836353503623', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:07:15', 0, 1002001015, '账号未登陆', '2019-06-01 18:07:15');
INSERT INTO `access_log` VALUES (19927, '65.51.15593836422903631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:07:22', 90, 0, '', '2019-06-01 18:07:22');
INSERT INTO `access_log` VALUES (19928, '65.47.15593836425773649', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:07:23', 8, 0, '', '2019-06-01 18:07:23');
INSERT INTO `access_log` VALUES (19929, '65.49.15593836425783649', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:07:23', 9, 0, '', '2019-06-01 18:07:23');
INSERT INTO `access_log` VALUES (19930, '65.50.15593836425823647', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:07:23', 8, 0, '', '2019-06-01 18:07:23');
INSERT INTO `access_log` VALUES (19931, '62.83.15593836513333889', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:07:31', 22, 0, '', '2019-06-01 18:07:31');
INSERT INTO `access_log` VALUES (19932, '64.84.15593836595313505', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:07:40', 10, 0, '', '2019-06-01 18:07:40');
INSERT INTO `access_log` VALUES (19933, '64.78.15593836726303511', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:07:53', 9, 0, '', '2019-06-01 18:07:53');
INSERT INTO `access_log` VALUES (19934, '64.80.15593836726293497', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:07:53', 13, 0, '', '2019-06-01 18:07:53');
INSERT INTO `access_log` VALUES (19935, '66.49.15593837193442837', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:08:39', 18, 0, '', '2019-06-01 18:08:39');
INSERT INTO `access_log` VALUES (19936, '65.51.15593837262683633', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:08:46', 17, 0, '', '2019-06-01 18:08:46');
INSERT INTO `access_log` VALUES (19937, '65.49.15593837340193651', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:08:54', 9, 0, '', '2019-06-01 18:08:54');
INSERT INTO `access_log` VALUES (19938, '65.47.15593837419983651', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:09:02', 13, 0, '', '2019-06-01 18:09:02');
INSERT INTO `access_log` VALUES (19939, '65.53.15593837472583627', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.121.37.141', '2019-06-01 18:09:07', 7, 0, '', '2019-06-01 18:09:07');
INSERT INTO `access_log` VALUES (19940, '59.80.15593844713924017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.164.232.227', '2019-06-01 18:21:11', 4, 0, '', '2019-06-01 18:21:11');
INSERT INTO `access_log` VALUES (19941, '59.77.15593844713924015', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.164.232.227', '2019-06-01 18:21:11', 13, 2001001000, '服务端发生异常', '2019-06-01 18:21:11');
INSERT INTO `access_log` VALUES (19942, '64.85.15593844840723527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.164.232.227', '2019-06-01 18:21:24', 5, 0, '', '2019-06-01 18:21:24');
INSERT INTO `access_log` VALUES (19943, '64.81.15593844844273511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.164.232.227', '2019-06-01 18:21:24', 4, 0, '', '2019-06-01 18:21:24');
INSERT INTO `access_log` VALUES (19944, '64.84.15593844858373517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.164.232.227', '2019-06-01 18:21:26', 3, 0, '', '2019-06-01 18:21:26');
INSERT INTO `access_log` VALUES (19945, '64.79.15593844863023511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.164.232.227', '2019-06-01 18:21:26', 2, 0, '', '2019-06-01 18:21:26');
INSERT INTO `access_log` VALUES (19946, '64.78.15593844908283523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.164.232.227', '2019-06-01 18:21:31', 2, 0, '', '2019-06-01 18:21:31');
INSERT INTO `access_log` VALUES (19947, '64.80.15593844912513509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.164.232.227', '2019-06-01 18:21:31', 2, 0, '', '2019-06-01 18:21:31');
INSERT INTO `access_log` VALUES (19948, '66.55.15593845096852857', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13167143046&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.164.232.227', '2019-06-01 18:21:50', 10, 1001003000, '验证码不存在', '2019-06-01 18:21:50');
INSERT INTO `access_log` VALUES (19949, '66.54.15593845138582851', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13167143046', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.164.232.227', '2019-06-01 18:21:54', 69, 0, '', '2019-06-01 18:21:54');
INSERT INTO `access_log` VALUES (19950, '66.52.15593845165982851', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13167143046&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.164.232.227', '2019-06-01 18:21:57', 482, 0, '', '2019-06-01 18:21:57');
INSERT INTO `access_log` VALUES (19951, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:22:34', 17, 0, '', '2019-06-01 18:22:34');
INSERT INTO `access_log` VALUES (19952, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:22:35', 13, 0, '', '2019-06-01 18:22:35');
INSERT INTO `access_log` VALUES (19953, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:23:24', 8, 0, '', '2019-06-01 18:23:24');
INSERT INTO `access_log` VALUES (19954, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:23:24', 12, 0, '', '2019-06-01 18:23:24');
INSERT INTO `access_log` VALUES (19955, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=desc', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:23:28', 7, 0, '', '2019-06-01 18:23:28');
INSERT INTO `access_log` VALUES (19956, '64.80.15593846104093511', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:23:30', 9, 0, '', '2019-06-01 18:23:30');
INSERT INTO `access_log` VALUES (19957, '64.77.15593846203483521', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:23:40', 7, 0, '', '2019-06-01 18:23:40');
INSERT INTO `access_log` VALUES (19958, '66.52.15593846411202853', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13167143040&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:24:01', 8, 1001003000, '验证码不存在', '2019-06-01 18:24:01');
INSERT INTO `access_log` VALUES (19959, '66.53.15593846429232853', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13167143040&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:24:03', 14, 1001003000, '验证码不存在', '2019-06-01 18:24:03');
INSERT INTO `access_log` VALUES (19960, '66.51.15593846443842849', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13167143040', 'POST', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:24:04', 310, 0, '', '2019-06-01 18:24:05');
INSERT INTO `access_log` VALUES (19961, '66.49.15593846462332851', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13167143040&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:24:06', 882, 0, '', '2019-06-01 18:24:07');
INSERT INTO `access_log` VALUES (19962, '66.57.15593846484082853', 98, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:24:08', 6, 0, '', '2019-06-01 18:24:08');
INSERT INTO `access_log` VALUES (19963, '66.48.15593846518932857', 98, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:24:12', 6, 0, '', '2019-06-01 18:24:12');
INSERT INTO `access_log` VALUES (19964, '66.54.15593846541932855', 98, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:24:14', 7, 0, '', '2019-06-01 18:24:14');
INSERT INTO `access_log` VALUES (19965, '66.52.15593846554492855', 98, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:24:15', 6, 0, '', '2019-06-01 18:24:15');
INSERT INTO `access_log` VALUES (19966, '64.81.15593846578133515', 98, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:24:18', 10, 0, '', '2019-06-01 18:24:18');
INSERT INTO `access_log` VALUES (19967, 'N/A', 98, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:24:19', 16, 0, '', '2019-06-01 18:24:19');
INSERT INTO `access_log` VALUES (19968, 'N/A', 98, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:24:19', 22, 0, '', '2019-06-01 18:24:19');
INSERT INTO `access_log` VALUES (19969, 'N/A', 98, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:24:21', 13, 0, '', '2019-06-01 18:24:21');
INSERT INTO `access_log` VALUES (19970, 'N/A', 98, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:24:21', 27, 0, '', '2019-06-01 18:24:21');
INSERT INTO `access_log` VALUES (19971, '59.77.15593847003264019', 98, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:00', 93, 0, '', '2019-06-01 18:25:00');
INSERT INTO `access_log` VALUES (19972, '59.73.15593847003354027', 98, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:00', 95, 2001001000, '服务端发生异常', '2019-06-01 18:25:00');
INSERT INTO `access_log` VALUES (19973, '64.77.15593847062213523', 98, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:06', 5, 0, '', '2019-06-01 18:25:06');
INSERT INTO `access_log` VALUES (19974, '64.82.15593847065393531', 98, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:07', 5, 0, '', '2019-06-01 18:25:07');
INSERT INTO `access_log` VALUES (19975, '59.74.15593847067424023', 98, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:07', 5, 0, '', '2019-06-01 18:25:07');
INSERT INTO `access_log` VALUES (19976, '59.78.15593847067434027', 98, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:07', 11, 2001001000, '服务端发生异常', '2019-06-01 18:25:07');
INSERT INTO `access_log` VALUES (19977, '64.85.15593847084933533', 98, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:08', 6, 0, '', '2019-06-01 18:25:08');
INSERT INTO `access_log` VALUES (19978, '64.81.15593847086643517', 98, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:09', 5, 0, '', '2019-06-01 18:25:09');
INSERT INTO `access_log` VALUES (19979, '64.79.15593847099563517', 98, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:10', 5, 0, '', '2019-06-01 18:25:10');
INSERT INTO `access_log` VALUES (19980, '64.78.15593847152113529', 98, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:15', 6, 0, '', '2019-06-01 18:25:15');
INSERT INTO `access_log` VALUES (19981, '64.80.15593847158653515', 98, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:16', 5, 0, '', '2019-06-01 18:25:16');
INSERT INTO `access_log` VALUES (19982, '65.51.15593847167823647', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.67.216.240', '2019-06-01 18:25:17', 1, 1002001015, '账号未登陆', '2019-06-01 18:25:17');
INSERT INTO `access_log` VALUES (19983, '65.50.15593847167883663', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.67.216.240', '2019-06-01 18:25:17', 0, 1002001015, '账号未登陆', '2019-06-01 18:25:17');
INSERT INTO `access_log` VALUES (19984, '65.49.15593847167883665', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.67.216.240', '2019-06-01 18:25:17', 0, 1002001015, '账号未登陆', '2019-06-01 18:25:17');
INSERT INTO `access_log` VALUES (19985, '65.47.15593847186033665', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.67.216.240', '2019-06-01 18:25:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 18:25:19');
INSERT INTO `access_log` VALUES (19986, '64.76.15593847171883515', 98, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:17', 1509, 0, '', '2019-06-01 18:25:19');
INSERT INTO `access_log` VALUES (19987, 'N/A', 98, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:17', 1476, 0, '', '2019-06-01 18:25:19');
INSERT INTO `access_log` VALUES (19988, '64.83.15593847201373517', 98, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:20', 8, 0, '', '2019-06-01 18:25:20');
INSERT INTO `access_log` VALUES (19989, '66.57.15593847224822855', 98, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:22', 7, 0, '', '2019-06-01 18:25:22');
INSERT INTO `access_log` VALUES (19990, '64.85.15593847237503535', 98, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:24', 11, 0, '', '2019-06-01 18:25:24');
INSERT INTO `access_log` VALUES (19991, '65.45.15593847242303663', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:24', 1, 1002001015, '账号未登陆', '2019-06-01 18:25:24');
INSERT INTO `access_log` VALUES (19992, '65.48.15593847242323661', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:24', 0, 1002001015, '账号未登陆', '2019-06-01 18:25:24');
INSERT INTO `access_log` VALUES (19993, '65.54.15593847242363631', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:24', 0, 1002001015, '账号未登陆', '2019-06-01 18:25:24');
INSERT INTO `access_log` VALUES (19994, '59.71.15593847249744027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:25', 3, 0, '', '2019-06-01 18:25:25');
INSERT INTO `access_log` VALUES (19995, '59.72.15593847249774021', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:25', 14, 2001001000, '服务端发生异常', '2019-06-01 18:25:25');
INSERT INTO `access_log` VALUES (19996, '66.55.15593847252392863', 98, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:25', 6, 0, '', '2019-06-01 18:25:25');
INSERT INTO `access_log` VALUES (19997, '64.81.15593847274753519', 98, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:27', 9, 0, '', '2019-06-01 18:25:27');
INSERT INTO `access_log` VALUES (19998, '65.46.15593847279863653', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 18:25:28');
INSERT INTO `access_log` VALUES (19999, '65.52.15593847363003641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:36', 103, 0, '', '2019-06-01 18:25:36');
INSERT INTO `access_log` VALUES (20000, '65.51.15593847366233649', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:37', 20, 0, '', '2019-06-01 18:25:37');
INSERT INTO `access_log` VALUES (20001, '65.50.15593847366373665', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:37', 10, 0, '', '2019-06-01 18:25:37');
INSERT INTO `access_log` VALUES (20002, '65.49.15593847366373667', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:37', 10, 0, '', '2019-06-01 18:25:37');
INSERT INTO `access_log` VALUES (20003, '64.79.15593847413113519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:41', 3, 0, '', '2019-06-01 18:25:41');
INSERT INTO `access_log` VALUES (20004, '64.78.15593847414023531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:41', 2, 0, '', '2019-06-01 18:25:41');
INSERT INTO `access_log` VALUES (20005, '64.80.15593847424323517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:42', 3, 0, '', '2019-06-01 18:25:42');
INSERT INTO `access_log` VALUES (20006, '64.76.15593847429123517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:43', 2, 0, '', '2019-06-01 18:25:43');
INSERT INTO `access_log` VALUES (20007, '64.77.15593847432783527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:43', 2, 0, '', '2019-06-01 18:25:43');
INSERT INTO `access_log` VALUES (20008, '62.87.15593847518983911', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:52', 14, 0, '', '2019-06-01 18:25:52');
INSERT INTO `access_log` VALUES (20009, '64.82.15593847565293535', 98, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:57', 6, 0, '', '2019-06-01 18:25:57');
INSERT INTO `access_log` VALUES (20010, 'N/A', 98, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:57', 13, 0, '', '2019-06-01 18:25:57');
INSERT INTO `access_log` VALUES (20011, '64.81.15593847565863521', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:57', 9, 0, '', '2019-06-01 18:25:57');
INSERT INTO `access_log` VALUES (20012, '64.85.15593847565853537', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:25:57', 11, 0, '', '2019-06-01 18:25:57');
INSERT INTO `access_log` VALUES (20013, 'N/A', 98, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/1785 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/WIFI Language/zh_CN', '180.164.232.227', '2019-06-01 18:25:58', 11, 0, '', '2019-06-01 18:25:58');
INSERT INTO `access_log` VALUES (20014, '64.79.15593847787453521', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=4&name=123', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:26:19', 15, 1002002009, NULL, '2019-06-01 18:26:19');
INSERT INTO `access_log` VALUES (20015, '62.89.15593847911993907', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:26:31', 13, 0, '', '2019-06-01 18:26:31');
INSERT INTO `access_log` VALUES (20016, '62.84.15593847927463901', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:26:33', 112, 0, '', '2019-06-01 18:26:33');
INSERT INTO `access_log` VALUES (20017, '64.76.15593847944603519', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:26:34', 9, 0, '', '2019-06-01 18:26:34');
INSERT INTO `access_log` VALUES (20018, '64.80.15593847944593519', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:26:34', 11, 0, '', '2019-06-01 18:26:34');
INSERT INTO `access_log` VALUES (20019, '64.82.15593847959433537', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:26:36', 9, 0, '', '2019-06-01 18:26:36');
INSERT INTO `access_log` VALUES (20020, '64.83.15593847959413521', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:26:36', 11, 0, '', '2019-06-01 18:26:36');
INSERT INTO `access_log` VALUES (20021, '64.85.15593847976423539', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:26:38', 11, 0, '', '2019-06-01 18:26:38');
INSERT INTO `access_log` VALUES (20022, '65.46.15593848027793655', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.197.23.8', '2019-06-01 18:26:43', 20, 0, '', '2019-06-01 18:26:43');
INSERT INTO `access_log` VALUES (20023, '59.79.15593852854844031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.249.161.170', '2019-06-01 18:34:45', 3, 0, '', '2019-06-01 18:34:45');
INSERT INTO `access_log` VALUES (20024, '59.72.15593852854844029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.249.161.170', '2019-06-01 18:34:45', 13, 2001001000, '服务端发生异常', '2019-06-01 18:34:45');
INSERT INTO `access_log` VALUES (20025, '64.79.15593852896053529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.249.161.170', '2019-06-01 18:34:50', 3, 0, '', '2019-06-01 18:34:50');
INSERT INTO `access_log` VALUES (20026, '64.78.15593852897483541', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.249.161.170', '2019-06-01 18:34:50', 2, 0, '', '2019-06-01 18:34:50');
INSERT INTO `access_log` VALUES (20027, '64.76.15593852920093527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.249.161.170', '2019-06-01 18:34:52', 716, 0, '', '2019-06-01 18:34:53');
INSERT INTO `access_log` VALUES (20028, '64.77.15593852929403537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.249.161.170', '2019-06-01 18:34:53', 2, 0, '', '2019-06-01 18:34:53');
INSERT INTO `access_log` VALUES (20029, '64.83.15593852938553529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.249.161.170', '2019-06-01 18:34:54', 2, 0, '', '2019-06-01 18:34:54');
INSERT INTO `access_log` VALUES (20030, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.249.161.170', '2019-06-01 18:34:55', 12, 0, '', '2019-06-01 18:34:55');
INSERT INTO `access_log` VALUES (20031, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.249.161.170', '2019-06-01 18:34:55', 13, 0, '', '2019-06-01 18:34:55');
INSERT INTO `access_log` VALUES (20032, '64.82.15593852972023545', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '36.249.161.170', '2019-06-01 18:34:57', 610, 0, '', '2019-06-01 18:34:58');
INSERT INTO `access_log` VALUES (20033, '65.52.15593888921363699', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '220.197.188.221', '2019-06-01 19:34:52', 0, 1002001015, '账号未登陆', '2019-06-01 19:34:52');
INSERT INTO `access_log` VALUES (20034, '65.50.15593888921383719', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '220.197.188.221', '2019-06-01 19:34:52', 0, 1002001015, '账号未登陆', '2019-06-01 19:34:52');
INSERT INTO `access_log` VALUES (20035, '65.51.15593888921573707', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '220.197.188.221', '2019-06-01 19:34:52', 0, 1002001015, '账号未登陆', '2019-06-01 19:34:52');
INSERT INTO `access_log` VALUES (20036, '65.48.15593889215553721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '220.197.188.221', '2019-06-01 19:35:22', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 19:35:22');
INSERT INTO `access_log` VALUES (20037, '65.54.15593889381983689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '220.197.188.221', '2019-06-01 19:35:38', 111, 0, '', '2019-06-01 19:35:38');
INSERT INTO `access_log` VALUES (20038, '65.49.15593889398083725', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '220.197.188.221', '2019-06-01 19:35:40', 11, 0, '', '2019-06-01 19:35:40');
INSERT INTO `access_log` VALUES (20039, '65.52.15593889398253701', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '220.197.188.221', '2019-06-01 19:35:40', 9, 0, '', '2019-06-01 19:35:40');
INSERT INTO `access_log` VALUES (20040, '65.51.15593889398403709', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '220.197.188.221', '2019-06-01 19:35:40', 8, 0, '', '2019-06-01 19:35:40');
INSERT INTO `access_log` VALUES (20041, '65.46.15593893248483717', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:05', 5, 1002001012, '访问令牌已过期', '2019-06-01 19:42:05');
INSERT INTO `access_log` VALUES (20042, '65.54.15593893248473695', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:05', 5, 1002001012, '访问令牌已过期', '2019-06-01 19:42:05');
INSERT INTO `access_log` VALUES (20043, '65.49.15593893248573731', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:05', 3, 1002001012, '访问令牌已过期', '2019-06-01 19:42:05');
INSERT INTO `access_log` VALUES (20044, '65.51.15593893323913715', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:12', 172, 0, '', '2019-06-01 19:42:13');
INSERT INTO `access_log` VALUES (20045, '65.50.15593893327603727', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:13', 10, 0, '', '2019-06-01 19:42:13');
INSERT INTO `access_log` VALUES (20046, '65.53.15593893327663709', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:13', 9, 0, '', '2019-06-01 19:42:13');
INSERT INTO `access_log` VALUES (20047, '65.47.15593893327673731', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:13', 9, 0, '', '2019-06-01 19:42:13');
INSERT INTO `access_log` VALUES (20048, '65.48.15593893362833729', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:16', 20, 0, '', '2019-06-01 19:42:16');
INSERT INTO `access_log` VALUES (20049, '65.45.15593893370303731', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:17', 10, 0, '', '2019-06-01 19:42:17');
INSERT INTO `access_log` VALUES (20050, '65.54.15593893377503697', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:18', 10, 0, '', '2019-06-01 19:42:18');
INSERT INTO `access_log` VALUES (20051, '65.46.15593893384143719', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:18', 14, 0, '', '2019-06-01 19:42:18');
INSERT INTO `access_log` VALUES (20052, '59.76.15593893398524081', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:20', 20, 0, '', '2019-06-01 19:42:20');
INSERT INTO `access_log` VALUES (20053, '59.79.15593893471744087', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:27', 11, 0, '', '2019-06-01 19:42:27');
INSERT INTO `access_log` VALUES (20054, '59.78.15593893505914091', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:31', 12, 0, '', '2019-06-01 19:42:31');
INSERT INTO `access_log` VALUES (20055, '66.57.15593893522792917', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.0 Safari/537.36', '218.83.100.106', '2019-06-01 19:42:32', 23, 0, '', '2019-06-01 19:42:32');
INSERT INTO `access_log` VALUES (20056, '59.75.15593895339884091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '116.22.149.44', '2019-06-01 19:45:34', 3, 0, '', '2019-06-01 19:45:34');
INSERT INTO `access_log` VALUES (20057, '59.80.15593895339884089', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '116.22.149.44', '2019-06-01 19:45:34', 14, 2001001000, '服务端发生异常', '2019-06-01 19:45:34');
INSERT INTO `access_log` VALUES (20058, '59.73.15593895416404095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '116.22.149.44', '2019-06-01 19:45:42', 3, 0, '', '2019-06-01 19:45:42');
INSERT INTO `access_log` VALUES (20059, '59.74.15593895416404089', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '116.22.149.44', '2019-06-01 19:45:42', 13, 2001001000, '服务端发生异常', '2019-06-01 19:45:42');
INSERT INTO `access_log` VALUES (20060, '64.79.15593895444863587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '116.22.149.44', '2019-06-01 19:45:44', 11, 0, '', '2019-06-01 19:45:44');
INSERT INTO `access_log` VALUES (20061, '64.78.15593895446453599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '116.22.149.44', '2019-06-01 19:45:45', 2, 0, '', '2019-06-01 19:45:45');
INSERT INTO `access_log` VALUES (20062, '64.80.15593895464153585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '116.22.149.44', '2019-06-01 19:45:46', 2, 0, '', '2019-06-01 19:45:46');
INSERT INTO `access_log` VALUES (20063, '64.76.15593895469733585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '116.22.149.44', '2019-06-01 19:45:47', 2, 0, '', '2019-06-01 19:45:47');
INSERT INTO `access_log` VALUES (20064, '59.76.15593895484764085', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '116.22.149.44', '2019-06-01 19:45:48', 3, 0, '', '2019-06-01 19:45:48');
INSERT INTO `access_log` VALUES (20065, '59.79.15593895484774091', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '116.22.149.44', '2019-06-01 19:45:48', 21, 2001001000, '服务端发生异常', '2019-06-01 19:45:48');
INSERT INTO `access_log` VALUES (20066, '62.85.15593896077733975', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '220.197.188.221', '2019-06-01 19:46:48', 24, 0, '', '2019-06-01 19:46:48');
INSERT INTO `access_log` VALUES (20067, '59.77.15593896115734087', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '220.197.188.221', '2019-06-01 19:46:52', 12, 0, '', '2019-06-01 19:46:52');
INSERT INTO `access_log` VALUES (20068, '59.73.15593896155554097', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '220.197.188.221', '2019-06-01 19:46:56', 20, 2001001000, '服务端发生异常', '2019-06-01 19:46:56');
INSERT INTO `access_log` VALUES (20069, '65.46.15593896168313723', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '220.197.188.221', '2019-06-01 19:46:57', 19, 0, '', '2019-06-01 19:46:57');
INSERT INTO `access_log` VALUES (20070, '65.46.15593899077313727', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.2', '2019-06-01 19:51:48', 0, 1002001015, '账号未登陆', '2019-06-01 19:51:48');
INSERT INTO `access_log` VALUES (20071, '65.49.15593899077583741', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.5', '2019-06-01 19:51:48', 0, 1002001015, '账号未登陆', '2019-06-01 19:51:48');
INSERT INTO `access_log` VALUES (20072, '65.52.15593899077593717', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.3', '2019-06-01 19:51:48', 0, 1002001015, '账号未登陆', '2019-06-01 19:51:48');
INSERT INTO `access_log` VALUES (20073, '65.53.15593899125983719', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.2', '2019-06-01 19:51:53', 1, 1002001015, '账号未登陆', '2019-06-01 19:51:53');
INSERT INTO `access_log` VALUES (20074, '65.51.15593899125973725', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.5', '2019-06-01 19:51:53', 0, 1002001015, '账号未登陆', '2019-06-01 19:51:53');
INSERT INTO `access_log` VALUES (20075, '65.50.15593899126113737', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.3', '2019-06-01 19:51:53', 0, 1002001015, '账号未登陆', '2019-06-01 19:51:53');
INSERT INTO `access_log` VALUES (20076, '59.78.15593899684224101', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 19:52:48', 3, 0, '', '2019-06-01 19:52:48');
INSERT INTO `access_log` VALUES (20077, '59.71.15593899684234101', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 19:52:48', 20, 2001001000, '服务端发生异常', '2019-06-01 19:52:48');
INSERT INTO `access_log` VALUES (20078, '65.50.15593900453493739', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 19:54:05', 1, 1002001015, '账号未登陆', '2019-06-01 19:54:05');
INSERT INTO `access_log` VALUES (20079, '65.47.15593900458873743', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 19:54:06', 0, 1002001015, '账号未登陆', '2019-06-01 19:54:06');
INSERT INTO `access_log` VALUES (20080, '65.48.15593900459303741', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 19:54:06', 0, 1002001015, '账号未登陆', '2019-06-01 19:54:06');
INSERT INTO `access_log` VALUES (20081, '65.47.15593908979213755', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:08:18', 1, 1002001015, '账号未登陆', '2019-06-01 20:08:18');
INSERT INTO `access_log` VALUES (20082, '65.50.15593908979203751', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:08:18', 1, 1002001015, '账号未登陆', '2019-06-01 20:08:18');
INSERT INTO `access_log` VALUES (20083, '65.48.15593908979223753', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:08:18', 0, 1002001015, '账号未登陆', '2019-06-01 20:08:18');
INSERT INTO `access_log` VALUES (20084, '65.48.15593910120243755', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:10:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 20:10:12');
INSERT INTO `access_log` VALUES (20085, '65.47.15593910172343757', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:10:17', 108, 0, '', '2019-06-01 20:10:17');
INSERT INTO `access_log` VALUES (20086, '65.45.15593910179773757', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:10:18', 10, 0, '', '2019-06-01 20:10:18');
INSERT INTO `access_log` VALUES (20087, '65.54.15593910179843723', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:10:18', 9, 0, '', '2019-06-01 20:10:18');
INSERT INTO `access_log` VALUES (20088, '65.46.15593910180903745', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:10:18', 17, 0, '', '2019-06-01 20:10:18');
INSERT INTO `access_log` VALUES (20089, '62.89.15593910296713991', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:10:30', 15, 0, '', '2019-06-01 20:10:30');
INSERT INTO `access_log` VALUES (20090, '62.83.15593910370193989', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:10:37', 17, 0, '', '2019-06-01 20:10:37');
INSERT INTO `access_log` VALUES (20091, '64.83.15593910457663607', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:10:46', 16, 0, '', '2019-06-01 20:10:46');
INSERT INTO `access_log` VALUES (20092, '64.82.15593910457773623', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:10:46', 13, 0, '', '2019-06-01 20:10:46');
INSERT INTO `access_log` VALUES (20093, '66.52.15593910475882941', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:10:48', 15, 0, '', '2019-06-01 20:10:48');
INSERT INTO `access_log` VALUES (20094, '59.77.15593910500434107', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:10:50', 12, 0, '', '2019-06-01 20:10:50');
INSERT INTO `access_log` VALUES (20095, '59.73.15593910528524117', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:10:53', 20, 2001001000, '服务端发生异常', '2019-06-01 20:10:53');
INSERT INTO `access_log` VALUES (20096, '59.74.15593910621114111', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '202.117.56.112', '2019-06-01 20:11:02', 19, 0, '', '2019-06-01 20:11:02');
INSERT INTO `access_log` VALUES (20097, '65.53.15593913433813741', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:15:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 20:15:43');
INSERT INTO `access_log` VALUES (20098, '65.50.15593913547403759', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:15:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 20:15:55');
INSERT INTO `access_log` VALUES (20099, '65.47.15593913699603763', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:16:10', 333, 0, '', '2019-06-01 20:16:10');
INSERT INTO `access_log` VALUES (20100, '65.45.15593913713173763', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:16:11', 10, 0, '', '2019-06-01 20:16:11');
INSERT INTO `access_log` VALUES (20101, '65.54.15593913713953729', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:16:11', 10, 0, '', '2019-06-01 20:16:11');
INSERT INTO `access_log` VALUES (20102, '65.46.15593913714223751', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:16:11', 10, 0, '', '2019-06-01 20:16:11');
INSERT INTO `access_log` VALUES (20103, '65.49.15593913799423765', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:16:20', 19, 0, '', '2019-06-01 20:16:20');
INSERT INTO `access_log` VALUES (20104, '65.52.15593913830703741', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:16:23', 10, 0, '', '2019-06-01 20:16:23');
INSERT INTO `access_log` VALUES (20105, '59.71.15593913856124121', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:16:26', 12, 0, '', '2019-06-01 20:16:26');
INSERT INTO `access_log` VALUES (20106, '59.78.15593913914364121', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:16:31', 16, 2001001000, '服务端发生异常', '2019-06-01 20:16:31');
INSERT INTO `access_log` VALUES (20107, '59.75.15593913948764119', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:16:35', 12, 0, '', '2019-06-01 20:16:35');
INSERT INTO `access_log` VALUES (20108, '59.80.15593913997044117', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:16:40', 12, 0, '', '2019-06-01 20:16:40');
INSERT INTO `access_log` VALUES (20109, '62.89.15593914059133997', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:16:46', 13, 0, '', '2019-06-01 20:16:46');
INSERT INTO `access_log` VALUES (20110, '64.85.15593914166883629', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:16:57', 13, 0, '', '2019-06-01 20:16:57');
INSERT INTO `access_log` VALUES (20111, '64.84.15593914167203623', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.170 Safari/537.36', '117.154.45.220', '2019-06-01 20:16:57', 9, 0, '', '2019-06-01 20:16:57');
INSERT INTO `access_log` VALUES (20112, '59.75.15593915163384121', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.84.107.57', '2019-06-01 20:18:36', 3, 0, '', '2019-06-01 20:18:36');
INSERT INTO `access_log` VALUES (20113, '59.80.15593915163414119', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.84.107.57', '2019-06-01 20:18:36', 13, 2001001000, '服务端发生异常', '2019-06-01 20:18:36');
INSERT INTO `access_log` VALUES (20114, '64.79.15593915299333615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.84.107.57', '2019-06-01 20:18:50', 4, 0, '', '2019-06-01 20:18:50');
INSERT INTO `access_log` VALUES (20115, '64.85.15593915301803631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.84.107.57', '2019-06-01 20:18:50', 2, 0, '', '2019-06-01 20:18:50');
INSERT INTO `access_log` VALUES (20116, '65.47.15593945912113807', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.18.53.35', '2019-06-01 21:09:51', 1, 1002001015, '账号未登陆', '2019-06-01 21:09:51');
INSERT INTO `access_log` VALUES (20117, '65.45.15593945912113807', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.18.53.35', '2019-06-01 21:09:51', 0, 1002001015, '账号未登陆', '2019-06-01 21:09:51');
INSERT INTO `access_log` VALUES (20118, '65.54.15593945912133773', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.18.53.35', '2019-06-01 21:09:51', 1, 1002001015, '账号未登陆', '2019-06-01 21:09:51');
INSERT INTO `access_log` VALUES (20119, '65.49.15593945941493809', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.18.53.35', '2019-06-01 21:09:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 21:09:54');
INSERT INTO `access_log` VALUES (20120, '65.52.15593945978383785', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.18.53.35', '2019-06-01 21:09:58', 952, 0, '', '2019-06-01 21:09:59');
INSERT INTO `access_log` VALUES (20121, '65.53.15593945995763787', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.18.53.35', '2019-06-01 21:10:00', 11, 0, '', '2019-06-01 21:10:00');
INSERT INTO `access_log` VALUES (20122, '65.51.15593945995823793', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.18.53.35', '2019-06-01 21:10:00', 10, 0, '', '2019-06-01 21:10:00');
INSERT INTO `access_log` VALUES (20123, '65.50.15593945995863805', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.18.53.35', '2019-06-01 21:10:00', 11, 0, '', '2019-06-01 21:10:00');
INSERT INTO `access_log` VALUES (20124, '62.88.15593946028994047', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.18.53.35', '2019-06-01 21:10:03', 33, 0, '', '2019-06-01 21:10:03');
INSERT INTO `access_log` VALUES (20125, '62.85.15593948481904047', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'createBeginTime=&createEndTime=&finishBeginTime=&finishEndTime=&pageNo=1&pageSize=10&payChannel=&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.201.246.255', '2019-06-01 21:14:08', 1, 1002001015, '账号未登陆', '2019-06-01 21:14:08');
INSERT INTO `access_log` VALUES (20126, '62.82.15593948856924055', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.201.246.255', '2019-06-01 21:14:46', 73, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-01 21:14:46');
INSERT INTO `access_log` VALUES (20127, '65.49.15593956979523825', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '106.47.101.67', '2019-06-01 21:28:18', 0, 1002001015, '账号未登陆', '2019-06-01 21:28:18');
INSERT INTO `access_log` VALUES (20128, '65.45.15593956979523823', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '106.47.101.67', '2019-06-01 21:28:18', 1, 1002001015, '账号未登陆', '2019-06-01 21:28:18');
INSERT INTO `access_log` VALUES (20129, '65.46.15593956979523811', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '106.47.101.67', '2019-06-01 21:28:18', 1, 1002001015, '账号未登陆', '2019-06-01 21:28:18');
INSERT INTO `access_log` VALUES (20130, '65.52.15593957004693801', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '106.47.101.67', '2019-06-01 21:28:20', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 21:28:20');
INSERT INTO `access_log` VALUES (20131, '65.50.15593957092733821', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '106.47.101.67', '2019-06-01 21:28:29', 157, 0, '', '2019-06-01 21:28:29');
INSERT INTO `access_log` VALUES (20132, '65.51.15593957136343809', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '106.47.101.67', '2019-06-01 21:28:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 21:28:34');
INSERT INTO `access_log` VALUES (20133, '59.80.15593962931014183', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.229.37.34', '2019-06-01 21:38:13', 13, 0, '', '2019-06-01 21:38:13');
INSERT INTO `access_log` VALUES (20134, '59.75.15593962931794185', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.229.37.34', '2019-06-01 21:38:13', 14, 2001001000, '服务端发生异常', '2019-06-01 21:38:13');
INSERT INTO `access_log` VALUES (20135, '64.79.15593962976453679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.229.37.34', '2019-06-01 21:38:18', 10, 0, '', '2019-06-01 21:38:18');
INSERT INTO `access_log` VALUES (20136, '64.85.15593962978733695', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.229.37.34', '2019-06-01 21:38:18', 3, 0, '', '2019-06-01 21:38:18');
INSERT INTO `access_log` VALUES (20137, '59.76.15593972398924191', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '101.93.238.25', '2019-06-01 21:54:00', 6, 0, '', '2019-06-01 21:54:00');
INSERT INTO `access_log` VALUES (20138, '59.79.15593972398954197', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '101.93.238.25', '2019-06-01 21:54:00', 13, 2001001000, '服务端发生异常', '2019-06-01 21:54:00');
INSERT INTO `access_log` VALUES (20139, '64.83.15593972453913691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '101.93.238.25', '2019-06-01 21:54:05', 140, 0, '', '2019-06-01 21:54:06');
INSERT INTO `access_log` VALUES (20140, '64.80.15593972456383691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '101.93.238.25', '2019-06-01 21:54:06', 3, 0, '', '2019-06-01 21:54:06');
INSERT INTO `access_log` VALUES (20141, '65.52.15593974475583825', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '101.93.238.25', '2019-06-01 21:57:28', 0, 1002001015, '账号未登陆', '2019-06-01 21:57:28');
INSERT INTO `access_log` VALUES (20142, '65.53.15593974475603827', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '101.93.238.25', '2019-06-01 21:57:28', 1, 1002001015, '账号未登陆', '2019-06-01 21:57:28');
INSERT INTO `access_log` VALUES (20143, '65.50.15593974475603845', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '101.93.238.25', '2019-06-01 21:57:28', 0, 1002001015, '账号未登陆', '2019-06-01 21:57:28');
INSERT INTO `access_log` VALUES (20144, '59.77.15593974628254195', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '101.93.238.25', '2019-06-01 21:57:43', 3, 0, '', '2019-06-01 21:57:43');
INSERT INTO `access_log` VALUES (20145, '59.73.15593974628264205', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '101.93.238.25', '2019-06-01 21:57:43', 13, 2001001000, '服务端发生异常', '2019-06-01 21:57:43');
INSERT INTO `access_log` VALUES (20146, '65.45.15593988396333867', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.192', '2019-06-01 22:20:40', 0, 1002001015, '账号未登陆', '2019-06-01 22:20:40');
INSERT INTO `access_log` VALUES (20147, '65.54.15593988396333833', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.192', '2019-06-01 22:20:40', 0, 1002001015, '账号未登陆', '2019-06-01 22:20:40');
INSERT INTO `access_log` VALUES (20148, '65.46.15593988396353855', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.192', '2019-06-01 22:20:40', 0, 1002001015, '账号未登陆', '2019-06-01 22:20:40');
INSERT INTO `access_log` VALUES (20149, '65.49.15593988424783869', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.192', '2019-06-01 22:20:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 22:20:42');
INSERT INTO `access_log` VALUES (20150, '65.50.15593988534183865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.192', '2019-06-01 22:20:53', 68, 0, '', '2019-06-01 22:20:53');
INSERT INTO `access_log` VALUES (20151, '65.52.15593988538103845', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.192', '2019-06-01 22:20:54', 10, 0, '', '2019-06-01 22:20:54');
INSERT INTO `access_log` VALUES (20152, '65.53.15593988538143847', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.192', '2019-06-01 22:20:54', 8, 0, '', '2019-06-01 22:20:54');
INSERT INTO `access_log` VALUES (20153, '65.51.15593988538173853', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.192', '2019-06-01 22:20:54', 9, 0, '', '2019-06-01 22:20:54');
INSERT INTO `access_log` VALUES (20154, '62.83.15593988570994095', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.192', '2019-06-01 22:20:57', 24, 0, '', '2019-06-01 22:20:57');
INSERT INTO `access_log` VALUES (20155, '66.51.15593988605313041', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.192', '2019-06-01 22:21:01', 24, 0, '', '2019-06-01 22:21:01');
INSERT INTO `access_log` VALUES (20156, '65.54.15593989069023835', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:21:47', 1, 1002001015, '账号未登陆', '2019-06-01 22:21:47');
INSERT INTO `access_log` VALUES (20157, '65.49.15593989069053871', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:21:47', 0, 1002001015, '账号未登陆', '2019-06-01 22:21:47');
INSERT INTO `access_log` VALUES (20158, '65.50.15593989069363867', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:21:47', 0, 1002001015, '账号未登陆', '2019-06-01 22:21:47');
INSERT INTO `access_log` VALUES (20159, '65.52.15593989134683847', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:21:53', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 22:21:53');
INSERT INTO `access_log` VALUES (20160, '65.51.15593989183503855', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:21:58', 61, 0, '', '2019-06-01 22:21:58');
INSERT INTO `access_log` VALUES (20161, '65.48.15593989190983869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:21:59', 9, 0, '', '2019-06-01 22:21:59');
INSERT INTO `access_log` VALUES (20162, '65.47.15593989191043871', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:21:59', 8, 0, '', '2019-06-01 22:21:59');
INSERT INTO `access_log` VALUES (20163, '65.45.15593989191053871', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:21:59', 7, 0, '', '2019-06-01 22:21:59');
INSERT INTO `access_log` VALUES (20164, '65.54.15593989366013837', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:22:17', 20, 0, '', '2019-06-01 22:22:17');
INSERT INTO `access_log` VALUES (20165, '65.50.15593989456583869', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:22:26', 11, 0, '', '2019-06-01 22:22:26');
INSERT INTO `access_log` VALUES (20166, '65.52.15593989544843849', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:22:34', 20, 0, '', '2019-06-01 22:22:35');
INSERT INTO `access_log` VALUES (20167, '65.51.15593989615333857', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:22:42', 9, 0, '', '2019-06-01 22:22:42');
INSERT INTO `access_log` VALUES (20168, '65.48.15593989719053871', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:22:52', 16, 0, '', '2019-06-01 22:22:52');
INSERT INTO `access_log` VALUES (20169, '59.78.15593990159824225', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:23:36', 11, 0, '', '2019-06-01 22:23:36');
INSERT INTO `access_log` VALUES (20170, '59.80.15593990347984221', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:23:55', 20, 2001001000, '服务端发生异常', '2019-06-01 22:23:55');
INSERT INTO `access_log` VALUES (20171, '59.75.15593990412084223', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:24:01', 13, 0, '', '2019-06-01 22:24:01');
INSERT INTO `access_log` VALUES (20172, '64.80.15593990428863715', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:24:03', 11, 0, '', '2019-06-01 22:24:03');
INSERT INTO `access_log` VALUES (20173, '64.78.15593990448293729', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:24:05', 9, 0, '', '2019-06-01 22:24:05');
INSERT INTO `access_log` VALUES (20174, '59.73.15593990472034227', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:24:07', 12, 0, '', '2019-06-01 22:24:07');
INSERT INTO `access_log` VALUES (20175, '59.74.15593990500794221', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:24:10', 8, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-01 22:24:10');
INSERT INTO `access_log` VALUES (20176, '66.57.15593990537573047', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:24:14', 14, 0, '', '2019-06-01 22:24:14');
INSERT INTO `access_log` VALUES (20177, '62.86.15593990619494095', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:24:22', 14, 0, '', '2019-06-01 22:24:22');
INSERT INTO `access_log` VALUES (20178, '62.89.15593990644534101', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '58.37.163.26', '2019-06-01 22:24:24', 15, 0, '', '2019-06-01 22:24:24');
INSERT INTO `access_log` VALUES (20179, '64.77.15593996370013737', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 22:33:57', 8, 1002001012, '访问令牌已过期', '2019-06-01 22:33:57');
INSERT INTO `access_log` VALUES (20180, '65.50.15593996386843879', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.158.68.184', '2019-06-01 22:33:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 22:33:59');
INSERT INTO `access_log` VALUES (20181, '65.52.15594008432283875', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.232.186.74', '2019-06-01 22:54:03', 0, 1002001015, '账号未登陆', '2019-06-01 22:54:03');
INSERT INTO `access_log` VALUES (20182, '65.53.15594008432293877', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.232.186.74', '2019-06-01 22:54:03', 0, 1002001015, '账号未登陆', '2019-06-01 22:54:03');
INSERT INTO `access_log` VALUES (20183, '65.51.15594008432293883', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.232.186.74', '2019-06-01 22:54:03', 0, 1002001015, '账号未登陆', '2019-06-01 22:54:03');
INSERT INTO `access_log` VALUES (20184, '65.48.15594008455443897', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.232.186.74', '2019-06-01 22:54:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 22:54:06');
INSERT INTO `access_log` VALUES (20185, '65.47.15594008499033899', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.232.186.74', '2019-06-01 22:54:10', 311, 0, '', '2019-06-01 22:54:10');
INSERT INTO `access_log` VALUES (20186, '65.46.15594008510753887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.232.186.74', '2019-06-01 22:54:11', 9, 0, '', '2019-06-01 22:54:11');
INSERT INTO `access_log` VALUES (20187, '65.54.15594008510773865', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.232.186.74', '2019-06-01 22:54:11', 8, 0, '', '2019-06-01 22:54:11');
INSERT INTO `access_log` VALUES (20188, '65.49.15594008510863901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.232.186.74', '2019-06-01 22:54:11', 7, 0, '', '2019-06-01 22:54:11');
INSERT INTO `access_log` VALUES (20189, '65.50.15594008582063897', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.232.186.74', '2019-06-01 22:54:18', 11, 0, '', '2019-06-01 22:54:18');
INSERT INTO `access_log` VALUES (20190, '65.52.15594008601353877', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.232.186.74', '2019-06-01 22:54:20', 9, 0, '', '2019-06-01 22:54:20');
INSERT INTO `access_log` VALUES (20191, '59.72.15594019582854259', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '180.213.162.192', '2019-06-01 23:12:38', 11, 0, '', '2019-06-01 23:12:38');
INSERT INTO `access_log` VALUES (20192, '59.80.15594019582874261', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '180.213.162.192', '2019-06-01 23:12:38', 15, 2001001000, '服务端发生异常', '2019-06-01 23:12:38');
INSERT INTO `access_log` VALUES (20193, '59.79.15594020188854263', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.102.10.131', '2019-06-01 23:13:39', 4, 0, '', '2019-06-01 23:13:39');
INSERT INTO `access_log` VALUES (20194, '59.76.15594020188854257', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.102.10.131', '2019-06-01 23:13:39', 13, 2001001000, '服务端发生异常', '2019-06-01 23:13:39');
INSERT INTO `access_log` VALUES (20195, '64.79.15594020330863757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.102.10.131', '2019-06-01 23:13:53', 12, 0, '', '2019-06-01 23:13:53');
INSERT INTO `access_log` VALUES (20196, '64.85.15594020332573773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.102.10.131', '2019-06-01 23:13:53', 3, 0, '', '2019-06-01 23:13:53');
INSERT INTO `access_log` VALUES (20197, '64.84.15594020359303767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.102.10.131', '2019-06-01 23:13:56', 2, 0, '', '2019-06-01 23:13:56');
INSERT INTO `access_log` VALUES (20198, '64.76.15594020367323755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.102.10.131', '2019-06-01 23:13:57', 2, 0, '', '2019-06-01 23:13:57');
INSERT INTO `access_log` VALUES (20199, '64.82.15594020376523773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.102.10.131', '2019-06-01 23:13:58', 2, 0, '', '2019-06-01 23:13:58');
INSERT INTO `access_log` VALUES (20200, '59.78.15594020408044267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.102.10.131', '2019-06-01 23:14:01', 3, 0, '', '2019-06-01 23:14:01');
INSERT INTO `access_log` VALUES (20201, '59.72.15594020408614261', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.102.10.131', '2019-06-01 23:14:01', 13, 2001001000, '服务端发生异常', '2019-06-01 23:14:01');
INSERT INTO `access_log` VALUES (20202, '64.83.15594020464943757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.102.10.131', '2019-06-01 23:14:06', 2, 0, '', '2019-06-01 23:14:06');
INSERT INTO `access_log` VALUES (20203, '64.80.15594020466423757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.102.10.131', '2019-06-01 23:14:07', 3, 0, '', '2019-06-01 23:14:07');
INSERT INTO `access_log` VALUES (20204, '65.53.15594025259113901', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:06', 1, 1002001015, '账号未登陆', '2019-06-01 23:22:06');
INSERT INTO `access_log` VALUES (20205, '65.48.15594025259133921', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:06', 1, 1002001015, '账号未登陆', '2019-06-01 23:22:06');
INSERT INTO `access_log` VALUES (20206, '65.45.15594025259133923', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:06', 0, 1002001015, '账号未登陆', '2019-06-01 23:22:06');
INSERT INTO `access_log` VALUES (20207, '65.47.15594025288283923', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 23:22:09');
INSERT INTO `access_log` VALUES (20208, '65.49.15594025350973925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:15', 94, 0, '', '2019-06-01 23:22:15');
INSERT INTO `access_log` VALUES (20209, '65.50.15594025354493921', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:15', 9, 0, '', '2019-06-01 23:22:15');
INSERT INTO `access_log` VALUES (20210, '65.54.15594025354493889', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:15', 8, 0, '', '2019-06-01 23:22:15');
INSERT INTO `access_log` VALUES (20211, '65.52.15594025354523901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:15', 8, 0, '', '2019-06-01 23:22:15');
INSERT INTO `access_log` VALUES (20212, '62.84.15594025423474141', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:22', 18, 0, '', '2019-06-01 23:22:22');
INSERT INTO `access_log` VALUES (20213, '62.86.15594025542794143', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:34', 14, 0, '', '2019-06-01 23:22:34');
INSERT INTO `access_log` VALUES (20214, '59.79.15594025608194271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-01 23:22:41', 4, 0, '', '2019-06-01 23:22:41');
INSERT INTO `access_log` VALUES (20215, '59.76.15594025608214265', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-01 23:22:41', 12, 2001001000, '服务端发生异常', '2019-06-01 23:22:41');
INSERT INTO `access_log` VALUES (20216, '64.76.15594025648303763', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:45', 16, 0, '', '2019-06-01 23:22:45');
INSERT INTO `access_log` VALUES (20217, '64.84.15594025648263775', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:45', 18, 0, '', '2019-06-01 23:22:45');
INSERT INTO `access_log` VALUES (20218, '64.82.15594025694903781', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:49', 27, 0, '', '2019-06-01 23:22:50');
INSERT INTO `access_log` VALUES (20219, '64.81.15594025694913767', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:49', 14, 0, '', '2019-06-01 23:22:50');
INSERT INTO `access_log` VALUES (20220, '64.83.15594025700703765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-01 23:22:50', 3, 0, '', '2019-06-01 23:22:50');
INSERT INTO `access_log` VALUES (20221, '64.80.15594025702463765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-01 23:22:50', 2, 0, '', '2019-06-01 23:22:50');
INSERT INTO `access_log` VALUES (20222, '64.77.15594025729703779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-01 23:22:53', 3, 0, '', '2019-06-01 23:22:53');
INSERT INTO `access_log` VALUES (20223, '64.79.15594025738593767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-01 23:22:54', 3, 0, '', '2019-06-01 23:22:54');
INSERT INTO `access_log` VALUES (20224, '59.78.15594025753874275', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-01 23:22:55', 2, 0, '', '2019-06-01 23:22:55');
INSERT INTO `access_log` VALUES (20225, '59.72.15594025753924269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-01 23:22:55', 13, 2001001000, '服务端发生异常', '2019-06-01 23:22:55');
INSERT INTO `access_log` VALUES (20226, '64.76.15594025762393765', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:56', 12, 0, '', '2019-06-01 23:22:56');
INSERT INTO `access_log` VALUES (20227, '64.85.15594025762353783', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:56', 24, 0, '', '2019-06-01 23:22:56');
INSERT INTO `access_log` VALUES (20228, '64.84.15594025762443777', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:22:56', 15, 0, '', '2019-06-01 23:22:56');
INSERT INTO `access_log` VALUES (20229, '59.80.15594025821964271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-01 23:23:02', 3, 0, '', '2019-06-01 23:23:02');
INSERT INTO `access_log` VALUES (20230, '59.75.15594025822044273', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-01 23:23:02', 13, 2001001000, '服务端发生异常', '2019-06-01 23:23:02');
INSERT INTO `access_log` VALUES (20231, '66.51.15594025834643091', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:23:03', 22, 0, '', '2019-06-01 23:23:03');
INSERT INTO `access_log` VALUES (20232, '64.81.15594025870793769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-01 23:23:07', 2, 0, '', '2019-06-01 23:23:07');
INSERT INTO `access_log` VALUES (20233, '64.83.15594025872583767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-01 23:23:07', 2, 0, '', '2019-06-01 23:23:07');
INSERT INTO `access_log` VALUES (20234, '59.73.15594025888384277', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-01 23:23:09', 3, 0, '', '2019-06-01 23:23:09');
INSERT INTO `access_log` VALUES (20235, '59.74.15594025888384271', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-01 23:23:09', 13, 2001001000, '服务端发生异常', '2019-06-01 23:23:09');
INSERT INTO `access_log` VALUES (20236, '65.47.15594025989743925', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:23:19', 10, 0, '', '2019-06-01 23:23:19');
INSERT INTO `access_log` VALUES (20237, '65.49.15594026098383927', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:23:30', 15, 0, '', '2019-06-01 23:23:30');
INSERT INTO `access_log` VALUES (20238, '65.50.15594026108053923', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:23:31', 692, 0, '', '2019-06-01 23:23:31');
INSERT INTO `access_log` VALUES (20239, '65.52.15594026125413903', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-01 23:23:33', 14, 0, '', '2019-06-01 23:23:33');
INSERT INTO `access_log` VALUES (20240, '59.71.15594030745104283', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_2_1 like Mac OS X) AppleWebKit/602.4.6 (KHTML, like Gecko) Version/10.0 Mobile/14D27 Safari/602.1', '123.185.247.86', '2019-06-01 23:31:15', 4, 0, '', '2019-06-01 23:31:15');
INSERT INTO `access_log` VALUES (20241, '59.78.15594030745184283', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_2_1 like Mac OS X) AppleWebKit/602.4.6 (KHTML, like Gecko) Version/10.0 Mobile/14D27 Safari/602.1', '123.185.247.86', '2019-06-01 23:31:15', 10, 2001001000, '服务端发生异常', '2019-06-01 23:31:15');
INSERT INTO `access_log` VALUES (20242, '59.79.15594034559074285', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:37:36', 4, 0, '', '2019-06-01 23:37:36');
INSERT INTO `access_log` VALUES (20243, '59.76.15594034559074279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:37:36', 12, 2001001000, '服务端发生异常', '2019-06-01 23:37:36');
INSERT INTO `access_log` VALUES (20244, '64.81.15594034646353781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:37:45', 3, 0, '', '2019-06-01 23:37:45');
INSERT INTO `access_log` VALUES (20245, '64.83.15594034647303779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:37:45', 2, 0, '', '2019-06-01 23:37:45');
INSERT INTO `access_log` VALUES (20246, '64.80.15594034658183779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:37:46', 2, 0, '', '2019-06-01 23:37:46');
INSERT INTO `access_log` VALUES (20247, '64.78.15594034663693793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:37:46', 2, 0, '', '2019-06-01 23:37:46');
INSERT INTO `access_log` VALUES (20248, '64.77.15594034667853793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:37:47', 2, 0, '', '2019-06-01 23:37:47');
INSERT INTO `access_log` VALUES (20249, '59.71.15594034682314289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:37:48', 3, 0, '', '2019-06-01 23:37:48');
INSERT INTO `access_log` VALUES (20250, '59.78.15594034682324289', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:37:48', 17, 2001001000, '服务端发生异常', '2019-06-01 23:37:48');
INSERT INTO `access_log` VALUES (20251, '59.80.15594034784894285', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:37:58', 14, 2001001000, '服务端发生异常', '2019-06-01 23:37:59');
INSERT INTO `access_log` VALUES (20252, '59.75.15594034784904287', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:37:58', 39, 0, '', '2019-06-01 23:37:59');
INSERT INTO `access_log` VALUES (20253, '65.50.15594034877503935', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:08', 1, 1002001015, '账号未登陆', '2019-06-01 23:38:08');
INSERT INTO `access_log` VALUES (20254, '65.52.15594034877573915', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:08', 0, 1002001015, '账号未登陆', '2019-06-01 23:38:08');
INSERT INTO `access_log` VALUES (20255, '65.54.15594034877573903', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:08', 0, 1002001015, '账号未登陆', '2019-06-01 23:38:08');
INSERT INTO `access_log` VALUES (20256, '65.53.15594034924903917', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:12', 236, 0, '', '2019-06-01 23:38:13');
INSERT INTO `access_log` VALUES (20257, '65.47.15594034931743939', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:13', 446, 0, '', '2019-06-01 23:38:14');
INSERT INTO `access_log` VALUES (20258, '65.45.15594034931633939', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:13', 663, 0, '', '2019-06-01 23:38:14');
INSERT INTO `access_log` VALUES (20259, '65.48.15594034931703937', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:13', 656, 0, '', '2019-06-01 23:38:14');
INSERT INTO `access_log` VALUES (20260, '62.85.15594035015974163', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:22', 11, 0, '', '2019-06-01 23:38:22');
INSERT INTO `access_log` VALUES (20261, '64.82.15594035054193797', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:25', 9, 0, '', '2019-06-01 23:38:25');
INSERT INTO `access_log` VALUES (20262, '64.84.15594035054193791', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:25', 12, 0, '', '2019-06-01 23:38:25');
INSERT INTO `access_log` VALUES (20263, '66.50.15594035088223109', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:29', 14, 0, '', '2019-06-01 23:38:29');
INSERT INTO `access_log` VALUES (20264, '65.49.15594035126103941', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:33', 19, 0, '', '2019-06-01 23:38:33');
INSERT INTO `access_log` VALUES (20265, '65.52.15594035165293917', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:37', 133, 0, '', '2019-06-01 23:38:37');
INSERT INTO `access_log` VALUES (20266, '65.54.15594035234503905', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:43', 9, 0, '', '2019-06-01 23:38:43');
INSERT INTO `access_log` VALUES (20267, '65.53.15594035346283919', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:55', 10, 0, '', '2019-06-01 23:38:55');
INSERT INTO `access_log` VALUES (20268, '65.47.15594035372563941', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:38:57', 18, 0, '', '2019-06-01 23:38:57');
INSERT INTO `access_log` VALUES (20269, '65.45.15594035410843941', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:39:01', 11, 0, '', '2019-06-01 23:39:01');
INSERT INTO `access_log` VALUES (20270, '65.48.15594035416053939', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:39:02', 9, 0, '', '2019-06-01 23:39:02');
INSERT INTO `access_log` VALUES (20271, '65.46.15594035419543929', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:39:02', 14, 0, '', '2019-06-01 23:39:02');
INSERT INTO `access_log` VALUES (20272, '65.49.15594035420893943', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:39:02', 18, 0, '', '2019-06-01 23:39:02');
INSERT INTO `access_log` VALUES (20273, '66.48.15594035422973111', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:39:02', 13, 0, '', '2019-06-01 23:39:02');
INSERT INTO `access_log` VALUES (20274, '64.78.15594035425223795', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:39:03', 9, 0, '', '2019-06-01 23:39:03');
INSERT INTO `access_log` VALUES (20275, '64.80.15594035425213781', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:39:03', 11, 0, '', '2019-06-01 23:39:03');
INSERT INTO `access_log` VALUES (20276, '62.87.15594035429014169', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.101.145.243', '2019-06-01 23:39:03', 12, 0, '', '2019-06-01 23:39:03');
INSERT INTO `access_log` VALUES (20277, '64.76.15594035652253781', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '223.167.152.70', '2019-06-01 23:39:25', 1, 1002001015, '账号未登陆', '2019-06-01 23:39:25');
INSERT INTO `access_log` VALUES (20278, '65.54.15594035721183907', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '223.167.152.53', '2019-06-01 23:39:32', 0, 1002001015, '账号未登陆', '2019-06-01 23:39:32');
INSERT INTO `access_log` VALUES (20279, '65.48.15594036109333941', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.88.19', '2019-06-01 23:40:11', 1, 1002001015, '账号未登陆', '2019-06-01 23:40:11');
INSERT INTO `access_log` VALUES (20280, '65.45.15594036109333943', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.88.19', '2019-06-01 23:40:11', 1, 1002001015, '账号未登陆', '2019-06-01 23:40:11');
INSERT INTO `access_log` VALUES (20281, '65.46.15594036109333931', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.88.19', '2019-06-01 23:40:11', 1, 1002001015, '账号未登陆', '2019-06-01 23:40:11');
INSERT INTO `access_log` VALUES (20282, '65.49.15594036181403945', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.88.19', '2019-06-01 23:40:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 23:40:18');
INSERT INTO `access_log` VALUES (20283, '65.52.15594036223203921', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.88.19', '2019-06-01 23:40:22', 61, 0, '', '2019-06-01 23:40:22');
INSERT INTO `access_log` VALUES (20284, '65.50.15594036227803941', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.88.19', '2019-06-01 23:40:23', 1011, 0, '', '2019-06-01 23:40:24');
INSERT INTO `access_log` VALUES (20285, '65.51.15594036227893929', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.88.19', '2019-06-01 23:40:23', 1003, 0, '', '2019-06-01 23:40:24');
INSERT INTO `access_log` VALUES (20286, '65.54.15594036227813909', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.88.19', '2019-06-01 23:40:23', 1012, 0, '', '2019-06-01 23:40:24');
INSERT INTO `access_log` VALUES (20287, '62.85.15594036337214165', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.88.19', '2019-06-01 23:40:34', 14, 0, '', '2019-06-01 23:40:34');
INSERT INTO `access_log` VALUES (20288, '66.57.15594036383013109', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.88.19', '2019-06-01 23:40:38', 14, 0, '', '2019-06-01 23:40:38');
INSERT INTO `access_log` VALUES (20289, '59.78.15594036968704293', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:41:37', 3, 0, '', '2019-06-01 23:41:37');
INSERT INTO `access_log` VALUES (20290, '59.71.15594036968714293', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:41:37', 14, 2001001000, '服务端发生异常', '2019-06-01 23:41:37');
INSERT INTO `access_log` VALUES (20291, '64.76.15594037004703783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:41:40', 10, 0, '', '2019-06-01 23:41:40');
INSERT INTO `access_log` VALUES (20292, '64.85.15594037005773801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:41:41', 2, 0, '', '2019-06-01 23:41:41');
INSERT INTO `access_log` VALUES (20293, '64.82.15594037036313801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:41:44', 2, 0, '', '2019-06-01 23:41:44');
INSERT INTO `access_log` VALUES (20294, '64.84.15594037037483795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:41:44', 2, 0, '', '2019-06-01 23:41:44');
INSERT INTO `access_log` VALUES (20295, '65.52.15594037118813923', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:41:52', 1, 1002001015, '账号未登陆', '2019-06-01 23:41:52');
INSERT INTO `access_log` VALUES (20296, '65.50.15594037118843943', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:41:52', 1, 1002001015, '账号未登陆', '2019-06-01 23:41:52');
INSERT INTO `access_log` VALUES (20297, '65.51.15594037118923931', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:41:52', 1, 1002001015, '账号未登陆', '2019-06-01 23:41:52');
INSERT INTO `access_log` VALUES (20298, '65.53.15594037186813925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:41:59', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 23:41:59');
INSERT INTO `access_log` VALUES (20299, '65.47.15594037223673947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:42:02', 73, 0, '', '2019-06-01 23:42:02');
INSERT INTO `access_log` VALUES (20300, '65.46.15594037226933935', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:42:03', 10, 0, '', '2019-06-01 23:42:03');
INSERT INTO `access_log` VALUES (20301, '65.48.15594037226973945', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:42:03', 162, 0, '', '2019-06-01 23:42:03');
INSERT INTO `access_log` VALUES (20302, '65.45.15594037226953947', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:42:03', 167, 0, '', '2019-06-01 23:42:03');
INSERT INTO `access_log` VALUES (20303, '62.82.15594037351014175', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:42:15', 11, 0, '', '2019-06-01 23:42:15');
INSERT INTO `access_log` VALUES (20304, '59.77.15594037400664285', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:42:20', 10, 0, '', '2019-06-01 23:42:20');
INSERT INTO `access_log` VALUES (20305, '65.52.15594037421363925', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:42:22', 9, 0, '', '2019-06-01 23:42:22');
INSERT INTO `access_log` VALUES (20306, '65.51.15594037470093933', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:42:27', 82, 0, '', '2019-06-01 23:42:27');
INSERT INTO `access_log` VALUES (20307, '65.54.15594037508333913', 27, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=1&resourceIds=14,15,16,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,41,42,43,44,45,46,47,51,52,53', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:42:31', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-01 23:42:31');
INSERT INTO `access_log` VALUES (20308, '65.53.15594037573413927', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:42:37', 10, 0, '', '2019-06-01 23:42:37');
INSERT INTO `access_log` VALUES (20309, '65.46.15594037592703937', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:42:39', 14, 0, '', '2019-06-01 23:42:39');
INSERT INTO `access_log` VALUES (20310, '66.57.15594037744923111', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:42:54', 12, 0, '', '2019-06-01 23:42:55');
INSERT INTO `access_log` VALUES (20311, '62.87.15594037807644173', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:43:01', 13, 0, '', '2019-06-01 23:43:01');
INSERT INTO `access_log` VALUES (20312, '64.79.15594037836603787', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:43:04', 14, 0, '', '2019-06-01 23:43:04');
INSERT INTO `access_log` VALUES (20313, '64.76.15594037836663785', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.65.131.36', '2019-06-01 23:43:04', 9, 0, '', '2019-06-01 23:43:04');
INSERT INTO `access_log` VALUES (20314, '59.78.15594038090714295', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.157.188.197', '2019-06-01 23:43:29', 3, 0, '', '2019-06-01 23:43:29');
INSERT INTO `access_log` VALUES (20315, '59.71.15594038092084295', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.157.188.197', '2019-06-01 23:43:29', 10, 2001001000, '服务端发生异常', '2019-06-01 23:43:29');
INSERT INTO `access_log` VALUES (20316, '64.84.15594038144263797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.157.188.197', '2019-06-01 23:43:34', 2, 0, '', '2019-06-01 23:43:34');
INSERT INTO `access_log` VALUES (20317, '64.81.15594038147483789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.157.188.197', '2019-06-01 23:43:35', 3, 0, '', '2019-06-01 23:43:35');
INSERT INTO `access_log` VALUES (20318, '64.78.15594038167193801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.157.188.197', '2019-06-01 23:43:37', 2, 0, '', '2019-06-01 23:43:37');
INSERT INTO `access_log` VALUES (20319, '64.80.15594038174543787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.157.188.197', '2019-06-01 23:43:37', 2, 0, '', '2019-06-01 23:43:37');
INSERT INTO `access_log` VALUES (20320, '64.77.15594038179833801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.157.188.197', '2019-06-01 23:43:38', 14, 0, '', '2019-06-01 23:43:38');
INSERT INTO `access_log` VALUES (20321, '64.76.15594038205163787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.157.188.197', '2019-06-01 23:43:41', 2, 0, '', '2019-06-01 23:43:41');
INSERT INTO `access_log` VALUES (20322, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.157.188.197', '2019-06-01 23:43:41', 15, 0, '', '2019-06-01 23:43:41');
INSERT INTO `access_log` VALUES (20323, '64.79.15594038228763789', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.157.188.197', '2019-06-01 23:43:43', 8, 0, '', '2019-06-01 23:43:43');
INSERT INTO `access_log` VALUES (20324, '66.53.15594038407723113', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12313213123123&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.157.188.197', '2019-06-01 23:44:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-06-01 23:44:01');
INSERT INTO `access_log` VALUES (20325, '65.51.15594038471053935', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:07', 1, 1002001015, '账号未登陆', '2019-06-01 23:44:07');
INSERT INTO `access_log` VALUES (20326, '65.54.15594038471053915', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:07', 1, 1002001015, '账号未登陆', '2019-06-01 23:44:07');
INSERT INTO `access_log` VALUES (20327, '65.53.15594038471053929', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:07', 0, 1002001015, '账号未登陆', '2019-06-01 23:44:07');
INSERT INTO `access_log` VALUES (20328, '65.46.15594038490213939', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 23:44:09');
INSERT INTO `access_log` VALUES (20329, '66.56.15594038499893109', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345543322&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.157.188.197', '2019-06-01 23:44:10', 495, 1001003000, '验证码不存在', '2019-06-01 23:44:10');
INSERT INTO `access_log` VALUES (20330, '65.45.15594038524583951', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:12', 80, 0, '', '2019-06-01 23:44:13');
INSERT INTO `access_log` VALUES (20331, '65.48.15594038527473949', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:13', 9, 0, '', '2019-06-01 23:44:13');
INSERT INTO `access_log` VALUES (20332, '65.49.15594038527503953', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:13', 9, 0, '', '2019-06-01 23:44:13');
INSERT INTO `access_log` VALUES (20333, '65.52.15594038527573929', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:13', 10, 0, '', '2019-06-01 23:44:13');
INSERT INTO `access_log` VALUES (20334, '66.49.15594038571963111', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345543322&code=111111', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.157.188.197', '2019-06-01 23:44:17', 8, 1001003000, '验证码不存在', '2019-06-01 23:44:17');
INSERT INTO `access_log` VALUES (20335, '62.83.15594038590124165', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:19', 14, 0, '', '2019-06-01 23:44:19');
INSERT INTO `access_log` VALUES (20336, '62.88.15594038639214177', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:24', 13, 0, '', '2019-06-01 23:44:24');
INSERT INTO `access_log` VALUES (20337, '64.83.15594038713363789', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:31', 10, 0, '', '2019-06-01 23:44:31');
INSERT INTO `access_log` VALUES (20338, '64.81.15594038713363791', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:31', 12, 0, '', '2019-06-01 23:44:31');
INSERT INTO `access_log` VALUES (20339, '64.77.15594038787053803', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:39', 10, 0, '', '2019-06-01 23:44:39');
INSERT INTO `access_log` VALUES (20340, '64.80.15594038787043789', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:39', 12, 0, '', '2019-06-01 23:44:39');
INSERT INTO `access_log` VALUES (20341, '64.85.15594038829943807', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:43', 13, 0, '', '2019-06-01 23:44:43');
INSERT INTO `access_log` VALUES (20342, '64.76.15594038829933789', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:43', 16, 0, '', '2019-06-01 23:44:43');
INSERT INTO `access_log` VALUES (20343, '64.79.15594038829933791', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.111.47.174', '2019-06-01 23:44:43', 19, 0, '', '2019-06-01 23:44:43');
INSERT INTO `access_log` VALUES (20344, '65.52.15594041069893933', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:48:27', 0, 1002001015, '账号未登陆', '2019-06-01 23:48:27');
INSERT INTO `access_log` VALUES (20345, '65.48.15594041069913953', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:48:27', 0, 1002001015, '账号未登陆', '2019-06-01 23:48:27');
INSERT INTO `access_log` VALUES (20346, '65.49.15594041070003957', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:48:27', 1, 1002001015, '账号未登陆', '2019-06-01 23:48:27');
INSERT INTO `access_log` VALUES (20347, '65.50.15594041092203953', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:48:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 23:48:29');
INSERT INTO `access_log` VALUES (20348, '65.54.15594041255213921', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:48:46', 54, 0, '', '2019-06-01 23:48:46');
INSERT INTO `access_log` VALUES (20349, '65.51.15594041258643941', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:48:46', 11, 0, '', '2019-06-01 23:48:46');
INSERT INTO `access_log` VALUES (20350, '65.47.15594041258723957', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:48:46', 9, 0, '', '2019-06-01 23:48:46');
INSERT INTO `access_log` VALUES (20351, '65.46.15594041258733945', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:48:46', 9, 0, '', '2019-06-01 23:48:46');
INSERT INTO `access_log` VALUES (20352, '62.88.15594041337464181', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:48:54', 13, 0, '', '2019-06-01 23:48:54');
INSERT INTO `access_log` VALUES (20353, '64.76.15594041417493793', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:49:02', 10, 0, '', '2019-06-01 23:49:02');
INSERT INTO `access_log` VALUES (20354, '64.85.15594041417453811', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:49:02', 15, 0, '', '2019-06-01 23:49:02');
INSERT INTO `access_log` VALUES (20355, '65.48.15594041540623955', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:49:14', 4, 0, '', '2019-06-01 23:49:14');
INSERT INTO `access_log` VALUES (20356, '62.84.15594041627754165', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:49:23', 13, 0, '', '2019-06-01 23:49:23');
INSERT INTO `access_log` VALUES (20357, '59.73.15594041744264301', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:49:34', 328, 0, '', '2019-06-01 23:49:35');
INSERT INTO `access_log` VALUES (20358, '65.53.15594041823133937', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:49:42', 10, 0, '', '2019-06-01 23:49:42');
INSERT INTO `access_log` VALUES (20359, '65.54.15594041845583923', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:49:45', 19, 0, '', '2019-06-01 23:49:45');
INSERT INTO `access_log` VALUES (20360, '65.51.15594041897713943', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.121.400', '221.217.172.76', '2019-06-01 23:49:50', 12, 0, '', '2019-06-01 23:49:50');
INSERT INTO `access_log` VALUES (20361, '65.46.15594043523783949', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.228', '2019-06-01 23:52:32', 1, 1002001015, '账号未登陆', '2019-06-01 23:52:32');
INSERT INTO `access_log` VALUES (20362, '65.45.15594043523833961', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.227', '2019-06-01 23:52:32', 0, 1002001015, '账号未登陆', '2019-06-01 23:52:32');
INSERT INTO `access_log` VALUES (20363, '65.52.15594043523883939', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.225', '2019-06-01 23:52:32', 0, 1002001015, '账号未登陆', '2019-06-01 23:52:32');
INSERT INTO `access_log` VALUES (20364, '65.48.15594043548333959', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.227', '2019-06-01 23:52:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 23:52:35');
INSERT INTO `access_log` VALUES (20365, '65.50.15594043722833959', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.227', '2019-06-01 23:52:52', 179, 0, '', '2019-06-01 23:52:52');
INSERT INTO `access_log` VALUES (20366, '65.53.15594043727353941', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.228', '2019-06-01 23:52:53', 9, 0, '', '2019-06-01 23:52:53');
INSERT INTO `access_log` VALUES (20367, '65.54.15594043727373927', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.227', '2019-06-01 23:52:53', 8, 0, '', '2019-06-01 23:52:53');
INSERT INTO `access_log` VALUES (20368, '65.51.15594043727413947', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.227', '2019-06-01 23:52:53', 8, 0, '', '2019-06-01 23:52:53');
INSERT INTO `access_log` VALUES (20369, '62.83.15594043851114173', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.227', '2019-06-01 23:53:05', 15, 0, '', '2019-06-01 23:53:05');
INSERT INTO `access_log` VALUES (20370, '64.76.15594043935893797', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.227', '2019-06-01 23:53:14', 14, 0, '', '2019-06-01 23:53:14');
INSERT INTO `access_log` VALUES (20371, '64.77.15594043935883811', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.228', '2019-06-01 23:53:14', 15, 0, '', '2019-06-01 23:53:14');
INSERT INTO `access_log` VALUES (20372, '59.80.15594044092234299', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.227', '2019-06-01 23:53:29', 376, 0, '', '2019-06-01 23:53:30');
INSERT INTO `access_log` VALUES (20373, '65.53.15594045040143943', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.227', '2019-06-01 23:55:04', 22, 0, '', '2019-06-01 23:55:04');
INSERT INTO `access_log` VALUES (20374, '65.47.15594045071613965', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.227', '2019-06-01 23:55:07', 11, 0, '', '2019-06-01 23:55:07');
INSERT INTO `access_log` VALUES (20375, '65.52.15594045106803943', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.227', '2019-06-01 23:55:11', 17, 0, '', '2019-06-01 23:55:11');
INSERT INTO `access_log` VALUES (20376, '65.46.15594045128433953', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.229', '2019-06-01 23:55:13', 15, 0, '', '2019-06-01 23:55:13');
INSERT INTO `access_log` VALUES (20377, '62.87.15594045487204185', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.229', '2019-06-01 23:55:49', 14, 0, '', '2019-06-01 23:55:49');
INSERT INTO `access_log` VALUES (20378, '62.86.15594045525714173', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.227', '2019-06-01 23:55:53', 15, 0, '', '2019-06-01 23:55:53');
INSERT INTO `access_log` VALUES (20379, '59.74.15594045818234301', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.227', '2019-06-01 23:56:22', 4, 0, '', '2019-06-01 23:56:22');
INSERT INTO `access_log` VALUES (20380, '59.73.15594045818244307', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.226.184.231', '2019-06-01 23:56:22', 12, 2001001000, '服务端发生异常', '2019-06-01 23:56:22');
INSERT INTO `access_log` VALUES (20381, '64.84.15594045889243811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:56:29', 2, 0, '', '2019-06-01 23:56:29');
INSERT INTO `access_log` VALUES (20382, '64.83.15594045892243801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:56:29', 2, 0, '', '2019-06-01 23:56:29');
INSERT INTO `access_log` VALUES (20383, '59.79.15594046030644303', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:56:43', 3, 0, '', '2019-06-01 23:56:43');
INSERT INTO `access_log` VALUES (20384, '59.78.15594046030654307', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:56:43', 10, 2001001000, '服务端发生异常', '2019-06-01 23:56:43');
INSERT INTO `access_log` VALUES (20385, '66.50.15594046037823125', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17611060902', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:56:44', 81, 0, '', '2019-06-01 23:56:44');
INSERT INTO `access_log` VALUES (20386, '64.78.15594046080573815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:56:48', 2, 0, '', '2019-06-01 23:56:48');
INSERT INTO `access_log` VALUES (20387, '64.80.15594046081523801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:56:48', 2, 0, '', '2019-06-01 23:56:48');
INSERT INTO `access_log` VALUES (20388, '66.57.15594046086133123', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17611060902&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:56:49', 199, 0, '', '2019-06-01 23:56:49');
INSERT INTO `access_log` VALUES (20389, '64.77.15594046098643815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:56:50', 2, 0, '', '2019-06-01 23:56:50');
INSERT INTO `access_log` VALUES (20390, '64.85.15594046115213819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:56:52', 2, 0, '', '2019-06-01 23:56:52');
INSERT INTO `access_log` VALUES (20391, '64.79.15594046126023803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:56:53', 3, 0, '', '2019-06-01 23:56:53');
INSERT INTO `access_log` VALUES (20392, '64.84.15594046135723813', 99, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:56:54', 6, 0, '', '2019-06-01 23:56:54');
INSERT INTO `access_log` VALUES (20393, '64.81.15594046137643805', 99, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:56:54', 5, 0, '', '2019-06-01 23:56:54');
INSERT INTO `access_log` VALUES (20394, '66.54.15594046151093125', 99, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:56:55', 5, 0, '', '2019-06-01 23:56:55');
INSERT INTO `access_log` VALUES (20395, '64.78.15594046235773817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:57:04', 128, 0, '', '2019-06-01 23:57:04');
INSERT INTO `access_log` VALUES (20396, '64.80.15594046240883803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:57:04', 2, 0, '', '2019-06-01 23:57:04');
INSERT INTO `access_log` VALUES (20397, '66.53.15594046261903125', 99, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:57:06', 6, 0, '', '2019-06-01 23:57:06');
INSERT INTO `access_log` VALUES (20398, '66.51.15594046340883121', 99, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:57:14', 6, 0, '', '2019-06-01 23:57:14');
INSERT INTO `access_log` VALUES (20399, '64.76.15594046355683803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:57:16', 2, 0, '', '2019-06-01 23:57:16');
INSERT INTO `access_log` VALUES (20400, '64.85.15594046357133821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:57:16', 2, 0, '', '2019-06-01 23:57:16');
INSERT INTO `access_log` VALUES (20401, '59.80.15594046364464303', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:57:16', 3, 0, '', '2019-06-01 23:57:16');
INSERT INTO `access_log` VALUES (20402, '59.75.15594046364554305', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:57:16', 12, 2001001000, '服务端发生异常', '2019-06-01 23:57:16');
INSERT INTO `access_log` VALUES (20403, '66.49.15594046366203123', 99, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:57:17', 6, 0, '', '2019-06-01 23:57:17');
INSERT INTO `access_log` VALUES (20404, '66.50.15594046385173127', 99, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:57:19', 6, 0, '', '2019-06-01 23:57:19');
INSERT INTO `access_log` VALUES (20405, '66.55.15594046464613133', 99, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:57:26', 8, 0, '', '2019-06-01 23:57:26');
INSERT INTO `access_log` VALUES (20406, '64.82.15594046487413821', 99, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:57:29', 12, 0, '', '2019-06-01 23:57:29');
INSERT INTO `access_log` VALUES (20407, '64.84.15594046488733815', 99, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:57:29', 5, 0, '', '2019-06-01 23:57:29');
INSERT INTO `access_log` VALUES (20408, '64.83.15594046533283805', 99, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:57:33', 6, 0, '', '2019-06-01 23:57:33');
INSERT INTO `access_log` VALUES (20409, '64.81.15594046534453807', 99, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Mobile Safari/537.36', '122.226.184.227', '2019-06-01 23:57:33', 5, 0, '', '2019-06-01 23:57:33');
INSERT INTO `access_log` VALUES (20410, '65.46.15594046571343955', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:57:37', 1, 1002001015, '账号未登陆', '2019-06-01 23:57:37');
INSERT INTO `access_log` VALUES (20411, '65.48.15594046571363965', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:57:37', 1, 1002001015, '账号未登陆', '2019-06-01 23:57:37');
INSERT INTO `access_log` VALUES (20412, '65.49.15594046571393969', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:57:37', 0, 1002001015, '账号未登陆', '2019-06-01 23:57:37');
INSERT INTO `access_log` VALUES (20413, '65.50.15594046588983965', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '114.93.164.109', '2019-06-01 23:57:39', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-01 23:57:39');
INSERT INTO `access_log` VALUES (20414, '59.72.15594053430364311', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '116.252.6.66', '2019-06-02 00:09:03', 11, 2001001000, '服务端发生异常', '2019-06-02 00:09:03');
INSERT INTO `access_log` VALUES (20415, '59.75.15594053430384315', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '116.252.6.66', '2019-06-02 00:09:03', 8, 0, '', '2019-06-02 00:09:03');
INSERT INTO `access_log` VALUES (20416, '64.84.15594053535863825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '116.252.6.66', '2019-06-02 00:09:14', 34, 0, '', '2019-06-02 00:09:14');
INSERT INTO `access_log` VALUES (20417, '64.83.15594053537893815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '116.252.6.66', '2019-06-02 00:09:14', 2, 0, '', '2019-06-02 00:09:14');
INSERT INTO `access_log` VALUES (20418, '64.81.15594053589723817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '116.252.6.66', '2019-06-02 00:09:19', 415, 0, '', '2019-06-02 00:09:19');
INSERT INTO `access_log` VALUES (20419, '64.78.15594053595633829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '116.252.6.66', '2019-06-02 00:09:20', 3, 0, '', '2019-06-02 00:09:20');
INSERT INTO `access_log` VALUES (20420, '59.72.15594066726054329', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 00:31:13', 3, 0, '', '2019-06-02 00:31:13');
INSERT INTO `access_log` VALUES (20421, '59.80.15594066726084331', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 00:31:13', 10, 2001001000, '服务端发生异常', '2019-06-02 00:31:13');
INSERT INTO `access_log` VALUES (20422, '64.80.15594066992873833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 00:31:39', 130, 0, '', '2019-06-02 00:31:39');
INSERT INTO `access_log` VALUES (20423, '64.77.15594066997073847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 00:31:40', 2, 0, '', '2019-06-02 00:31:40');
INSERT INTO `access_log` VALUES (20424, '64.76.15594067029753833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 00:31:43', 3, 0, '', '2019-06-02 00:31:43');
INSERT INTO `access_log` VALUES (20425, '64.85.15594067056853851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 00:31:46', 2, 0, '', '2019-06-02 00:31:46');
INSERT INTO `access_log` VALUES (20426, '64.79.15594067079443835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 00:31:48', 2, 0, '', '2019-06-02 00:31:48');
INSERT INTO `access_log` VALUES (20427, '66.55.15594067320543161', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13303640911&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 00:32:12', 15, 1001003000, '验证码不存在', '2019-06-02 00:32:12');
INSERT INTO `access_log` VALUES (20428, '66.48.15594067373423157', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13303640911', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 00:32:17', 454, 0, '', '2019-06-02 00:32:18');
INSERT INTO `access_log` VALUES (20429, '64.82.15594068544423853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 00:34:14', 3, 0, '', '2019-06-02 00:34:14');
INSERT INTO `access_log` VALUES (20430, '64.84.15594068547003847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 00:34:15', 2, 0, '', '2019-06-02 00:34:15');
INSERT INTO `access_log` VALUES (20431, '59.77.15594119064524397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:26', 13, 0, '', '2019-06-02 01:58:26');
INSERT INTO `access_log` VALUES (20432, '59.80.15594119064514401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:26', 16, 2001001000, '服务端发生异常', '2019-06-02 01:58:26');
INSERT INTO `access_log` VALUES (20433, '64.79.15594119117583905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:32', 12, 0, '', '2019-06-02 01:58:32');
INSERT INTO `access_log` VALUES (20434, '64.82.15594119119103921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:32', 4, 0, '', '2019-06-02 01:58:32');
INSERT INTO `access_log` VALUES (20435, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=苹果&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:39', 14, 0, '', '2019-06-02 01:58:39');
INSERT INTO `access_log` VALUES (20436, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=苹果', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:39', 7, 0, '', '2019-06-02 01:58:39');
INSERT INTO `access_log` VALUES (20437, '64.83.15594119220573905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:42', 2, 0, '', '2019-06-02 01:58:42');
INSERT INTO `access_log` VALUES (20438, '64.81.15594119222603907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:42', 3, 0, '', '2019-06-02 01:58:42');
INSERT INTO `access_log` VALUES (20439, '64.78.15594119238583919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:44', 3, 0, '', '2019-06-02 01:58:44');
INSERT INTO `access_log` VALUES (20440, '64.80.15594119245543905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:45', 2, 0, '', '2019-06-02 01:58:45');
INSERT INTO `access_log` VALUES (20441, '64.77.15594119255753919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:46', 2, 0, '', '2019-06-02 01:58:46');
INSERT INTO `access_log` VALUES (20442, '64.76.15594119263683905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:46', 2, 0, '', '2019-06-02 01:58:46');
INSERT INTO `access_log` VALUES (20443, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:46', 8, 0, '', '2019-06-02 01:58:46');
INSERT INTO `access_log` VALUES (20444, '64.85.15594119280663923', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:48', 8, 0, '', '2019-06-02 01:58:48');
INSERT INTO `access_log` VALUES (20445, '59.76.15594119370294397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:57', 13, 0, '', '2019-06-02 01:58:57');
INSERT INTO `access_log` VALUES (20446, '59.79.15594119370314403', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '115.199.246.238', '2019-06-02 01:58:57', 16, 2001001000, '服务端发生异常', '2019-06-02 01:58:57');
INSERT INTO `access_log` VALUES (20447, '65.50.15594123017454069', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6721.400 QQBrowser/10.2.2243.400', '42.91.164.223', '2019-06-02 02:05:02', 0, 1002001015, '账号未登陆', '2019-06-02 02:05:02');
INSERT INTO `access_log` VALUES (20448, '65.54.15594123017454037', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6721.400 QQBrowser/10.2.2243.400', '42.91.164.223', '2019-06-02 02:05:02', 0, 1002001015, '账号未登陆', '2019-06-02 02:05:02');
INSERT INTO `access_log` VALUES (20449, '65.53.15594123017464049', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6721.400 QQBrowser/10.2.2243.400', '42.91.164.223', '2019-06-02 02:05:02', 0, 1002001015, '账号未登陆', '2019-06-02 02:05:02');
INSERT INTO `access_log` VALUES (20450, '65.47.15594123049884073', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6721.400 QQBrowser/10.2.2243.400', '42.91.164.223', '2019-06-02 02:05:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 02:05:05');
INSERT INTO `access_log` VALUES (20451, '65.51.15594123098184055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6721.400 QQBrowser/10.2.2243.400', '42.91.164.223', '2019-06-02 02:05:10', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 02:05:10');
INSERT INTO `access_log` VALUES (20452, '65.52.15594123110164049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6721.400 QQBrowser/10.2.2243.400', '42.91.164.223', '2019-06-02 02:05:11', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 02:05:11');
INSERT INTO `access_log` VALUES (20453, '65.46.15594123145194059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6721.400 QQBrowser/10.2.2243.400', '42.91.164.223', '2019-06-02 02:05:15', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 02:05:15');
INSERT INTO `access_log` VALUES (20454, '59.77.15594261044264587', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:04', 12, 0, '', '2019-06-02 05:55:04');
INSERT INTO `access_log` VALUES (20455, '59.73.15594261044284597', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:04', 19, 2001001000, '服务端发生异常', '2019-06-02 05:55:04');
INSERT INTO `access_log` VALUES (20456, '59.74.15594261085094591', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '42.236.10.114', '2019-06-02 05:55:09', 4, 0, '', '2019-06-02 05:55:09');
INSERT INTO `access_log` VALUES (20457, '59.76.15594261085154587', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '42.236.10.125', '2019-06-02 05:55:09', 12, 2001001000, '服务端发生异常', '2019-06-02 05:55:09');
INSERT INTO `access_log` VALUES (20458, '64.80.15594261107834095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:11', 11, 0, '', '2019-06-02 05:55:11');
INSERT INTO `access_log` VALUES (20459, '64.77.15594261108984109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:11', 2, 0, '', '2019-06-02 05:55:11');
INSERT INTO `access_log` VALUES (20460, '64.76.15594261130344095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:13', 2, 0, '', '2019-06-02 05:55:13');
INSERT INTO `access_log` VALUES (20461, '64.85.15594261139514113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:14', 3, 0, '', '2019-06-02 05:55:14');
INSERT INTO `access_log` VALUES (20462, '64.79.15594261146674097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:15', 2, 0, '', '2019-06-02 05:55:15');
INSERT INTO `access_log` VALUES (20463, '64.82.15594261186714113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:19', 3, 0, '', '2019-06-02 05:55:19');
INSERT INTO `access_log` VALUES (20464, '64.84.15594261188654107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:19', 2, 0, '', '2019-06-02 05:55:19');
INSERT INTO `access_log` VALUES (20465, '59.71.15594261244974597', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:24', 3, 0, '', '2019-06-02 05:55:25');
INSERT INTO `access_log` VALUES (20466, '59.78.15594261244954597', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:24', 18, 2001001000, '服务端发生异常', '2019-06-02 05:55:25');
INSERT INTO `access_log` VALUES (20467, '65.53.15594261402434235', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:40', 1, 1002001015, '账号未登陆', '2019-06-02 05:55:40');
INSERT INTO `access_log` VALUES (20468, '65.54.15594261402434223', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:40', 1, 1002001015, '账号未登陆', '2019-06-02 05:55:40');
INSERT INTO `access_log` VALUES (20469, '65.50.15594261402434255', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:40', 0, 1002001015, '账号未登陆', '2019-06-02 05:55:40');
INSERT INTO `access_log` VALUES (20470, '65.47.15594261450834259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 05:55:45');
INSERT INTO `access_log` VALUES (20471, '65.45.15594261487694259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:49', 65, 0, '', '2019-06-02 05:55:49');
INSERT INTO `access_log` VALUES (20472, '65.51.15594261492054241', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:49', 11, 0, '', '2019-06-02 05:55:49');
INSERT INTO `access_log` VALUES (20473, '65.52.15594261492794235', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:49', 11, 0, '', '2019-06-02 05:55:49');
INSERT INTO `access_log` VALUES (20474, '65.46.15594261492814245', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:49', 9, 0, '', '2019-06-02 05:55:49');
INSERT INTO `access_log` VALUES (20475, '62.81.15594261560394455', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:55:56', 18, 0, '', '2019-06-02 05:55:56');
INSERT INTO `access_log` VALUES (20476, '62.89.15594261612604467', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:56:01', 246, 0, '', '2019-06-02 05:56:02');
INSERT INTO `access_log` VALUES (20477, '64.77.15594261675054111', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:56:08', 9, 0, '', '2019-06-02 05:56:08');
INSERT INTO `access_log` VALUES (20478, '64.76.15594261675074097', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:56:08', 303, 0, '', '2019-06-02 05:56:08');
INSERT INTO `access_log` VALUES (20479, '64.85.15594261743664115', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:56:14', 11, 0, '', '2019-06-02 05:56:14');
INSERT INTO `access_log` VALUES (20480, '64.79.15594261743684099', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:56:14', 11, 0, '', '2019-06-02 05:56:14');
INSERT INTO `access_log` VALUES (20481, '66.57.15594261882953413', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:56:28', 19, 0, '', '2019-06-02 05:56:28');
INSERT INTO `access_log` VALUES (20482, '59.76.15594262042704589', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:56:44', 23, 0, '', '2019-06-02 05:56:44');
INSERT INTO `access_log` VALUES (20483, '59.79.15594262137914595', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:56:54', 16, 0, '', '2019-06-02 05:56:54');
INSERT INTO `access_log` VALUES (20484, '64.81.15594262179894101', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:56:58', 10, 0, '', '2019-06-02 05:56:58');
INSERT INTO `access_log` VALUES (20485, '64.78.15594262233344113', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:57:03', 8, 0, '', '2019-06-02 05:57:03');
INSERT INTO `access_log` VALUES (20486, '59.71.15594262247754599', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/4.0 (compatible;)', '219.233.201.34', '2019-06-02 05:57:05', 3, 0, '', '2019-06-02 05:57:05');
INSERT INTO `access_log` VALUES (20487, '59.75.15594262265934597', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:57:07', 28, 0, '', '2019-06-02 05:57:07');
INSERT INTO `access_log` VALUES (20488, '59.72.15594262319164593', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:57:12', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 05:57:12');
INSERT INTO `access_log` VALUES (20489, '65.45.15594262380624261', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:57:18', 8, 0, '', '2019-06-02 05:57:18');
INSERT INTO `access_log` VALUES (20490, '65.51.15594262391864243', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:57:19', 10, 0, '', '2019-06-02 05:57:19');
INSERT INTO `access_log` VALUES (20491, '65.52.15594262409274237', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 05:57:21', 12, 0, '', '2019-06-02 05:57:21');
INSERT INTO `access_log` VALUES (20492, '59.74.15594271696694607', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:12:50', 14, 2001001000, '服务端发生异常', '2019-06-02 06:12:50');
INSERT INTO `access_log` VALUES (20493, '59.76.15594271696684603', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:12:50', 171, 0, '', '2019-06-02 06:12:50');
INSERT INTO `access_log` VALUES (20494, '64.79.15594271826704113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Mobile Safari/537.36', '117.91.230.178', '2019-06-02 06:13:03', 4, 0, '', '2019-06-02 06:13:03');
INSERT INTO `access_log` VALUES (20495, '64.82.15594271827674129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Mobile Safari/537.36', '117.91.230.178', '2019-06-02 06:13:03', 2, 0, '', '2019-06-02 06:13:03');
INSERT INTO `access_log` VALUES (20496, '64.83.15594271888524113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Mobile Safari/537.36', '117.91.230.178', '2019-06-02 06:13:09', 2, 0, '', '2019-06-02 06:13:09');
INSERT INTO `access_log` VALUES (20497, '64.81.15594271889244115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Mobile Safari/537.36', '117.91.230.178', '2019-06-02 06:13:09', 2, 0, '', '2019-06-02 06:13:09');
INSERT INTO `access_log` VALUES (20498, '59.78.15594271941184613', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Mobile Safari/537.36', '117.91.230.178', '2019-06-02 06:13:14', 3, 0, '', '2019-06-02 06:13:14');
INSERT INTO `access_log` VALUES (20499, '59.71.15594271941184613', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Mobile Safari/537.36', '117.91.230.178', '2019-06-02 06:13:14', 20, 2001001000, '服务端发生异常', '2019-06-02 06:13:14');
INSERT INTO `access_log` VALUES (20500, '64.80.15594272126594113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Mobile Safari/537.36', '117.91.230.178', '2019-06-02 06:13:33', 2, 0, '', '2019-06-02 06:13:33');
INSERT INTO `access_log` VALUES (20501, '64.77.15594272127844127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Mobile Safari/537.36', '117.91.230.178', '2019-06-02 06:13:33', 3, 0, '', '2019-06-02 06:13:33');
INSERT INTO `access_log` VALUES (20502, '59.72.15594272133364607', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Mobile Safari/537.36', '117.91.230.178', '2019-06-02 06:13:33', 3, 0, '', '2019-06-02 06:13:33');
INSERT INTO `access_log` VALUES (20503, '59.80.15594272133374609', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Mobile Safari/537.36', '117.91.230.178', '2019-06-02 06:13:33', 14, 2001001000, '服务端发生异常', '2019-06-02 06:13:33');
INSERT INTO `access_log` VALUES (20504, '65.45.15594272396394275', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:14:00', 1, 1002001015, '账号未登陆', '2019-06-02 06:14:00');
INSERT INTO `access_log` VALUES (20505, '65.52.15594272396394251', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:14:00', 1, 1002001015, '账号未登陆', '2019-06-02 06:14:00');
INSERT INTO `access_log` VALUES (20506, '65.51.15594272396394257', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:14:00', 1, 1002001015, '账号未登陆', '2019-06-02 06:14:00');
INSERT INTO `access_log` VALUES (20507, '65.48.15594272518804271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:14:12', 100, 0, '', '2019-06-02 06:14:12');
INSERT INTO `access_log` VALUES (20508, '65.49.15594272522174275', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:14:12', 10, 0, '', '2019-06-02 06:14:12');
INSERT INTO `access_log` VALUES (20509, '65.50.15594272522184273', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:14:12', 9, 0, '', '2019-06-02 06:14:12');
INSERT INTO `access_log` VALUES (20510, '65.53.15594272522204253', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:14:12', 9, 0, '', '2019-06-02 06:14:12');
INSERT INTO `access_log` VALUES (20511, '62.87.15594272659764489', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:14:26', 13, 0, '', '2019-06-02 06:14:26');
INSERT INTO `access_log` VALUES (20512, '64.81.15594272755714117', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:14:36', 12, 0, '', '2019-06-02 06:14:36');
INSERT INTO `access_log` VALUES (20513, '64.83.15594272755704115', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:14:36', 15, 0, '', '2019-06-02 06:14:36');
INSERT INTO `access_log` VALUES (20514, '65.45.15594272952424277', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:14:55', 3, 0, '', '2019-06-02 06:14:55');
INSERT INTO `access_log` VALUES (20515, '64.85.15594273303714133', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:15:30', 11, 0, '', '2019-06-02 06:15:30');
INSERT INTO `access_log` VALUES (20516, '64.76.15594273303714115', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:15:30', 12, 0, '', '2019-06-02 06:15:30');
INSERT INTO `access_log` VALUES (20517, '64.84.15594273414674127', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:15:41', 10, 0, '', '2019-06-02 06:15:41');
INSERT INTO `access_log` VALUES (20518, '64.82.15594273414674133', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:15:41', 14, 0, '', '2019-06-02 06:15:41');
INSERT INTO `access_log` VALUES (20519, '64.83.15594273414804117', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:15:41', 7, 0, '', '2019-06-02 06:15:41');
INSERT INTO `access_log` VALUES (20520, '64.78.15594273594784131', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:15:59', 10, 0, '', '2019-06-02 06:15:59');
INSERT INTO `access_log` VALUES (20521, '66.57.15594273785703429', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:16:19', 79, 0, '', '2019-06-02 06:16:19');
INSERT INTO `access_log` VALUES (20522, '59.76.15594273846664607', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:16:25', 14, 0, '', '2019-06-02 06:16:25');
INSERT INTO `access_log` VALUES (20523, '59.79.15594273975874613', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:16:38', 23, 2001001000, '服务端发生异常', '2019-06-02 06:16:38');
INSERT INTO `access_log` VALUES (20524, '65.47.15594274016934279', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:16:42', 10, 0, '', '2019-06-02 06:16:42');
INSERT INTO `access_log` VALUES (20525, '65.51.15594274127454261', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:16:53', 12, 0, '', '2019-06-02 06:16:53');
INSERT INTO `access_log` VALUES (20526, '65.52.15594274169974255', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:16:57', 78, 0, '', '2019-06-02 06:16:57');
INSERT INTO `access_log` VALUES (20527, '65.48.15594274297394275', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:17:10', 11, 0, '', '2019-06-02 06:17:10');
INSERT INTO `access_log` VALUES (20528, '65.49.15594274305874279', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:17:11', 10, 0, '', '2019-06-02 06:17:11');
INSERT INTO `access_log` VALUES (20529, '59.75.15594274314034615', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:17:11', 224, 2001001000, '服务端发生异常', '2019-06-02 06:17:12');
INSERT INTO `access_log` VALUES (20530, '59.72.15594274320854611', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:17:12', 11, 0, '', '2019-06-02 06:17:12');
INSERT INTO `access_log` VALUES (20531, '66.53.15594274328973431', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.91.230.178', '2019-06-02 06:17:13', 122, 0, '', '2019-06-02 06:17:13');
INSERT INTO `access_log` VALUES (20532, '65.45.15594276553834283', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 06:20:55', 9, 0, '', '2019-06-02 06:20:55');
INSERT INTO `access_log` VALUES (20533, '65.46.15594276553864269', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 06:20:55', 9, 0, '', '2019-06-02 06:20:55');
INSERT INTO `access_log` VALUES (20534, '65.52.15594276553864259', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 06:20:55', 9, 0, '', '2019-06-02 06:20:55');
INSERT INTO `access_log` VALUES (20535, '65.48.15594276651094279', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 06:21:05', 19, 0, '', '2019-06-02 06:21:05');
INSERT INTO `access_log` VALUES (20536, '65.50.15594276705484281', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 06:21:11', 10, 0, '', '2019-06-02 06:21:11');
INSERT INTO `access_log` VALUES (20537, '65.53.15594276740234261', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 06:21:14', 10, 0, '', '2019-06-02 06:21:14');
INSERT INTO `access_log` VALUES (20538, '65.47.15594276849784285', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 06:21:25', 14, 0, '', '2019-06-02 06:21:25');
INSERT INTO `access_log` VALUES (20539, '59.73.15594310507814667', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:17:31', 20, 2001001000, '服务端发生异常', '2019-06-02 07:17:31');
INSERT INTO `access_log` VALUES (20540, '59.77.15594310507814657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:17:31', 208, 0, '', '2019-06-02 07:17:31');
INSERT INTO `access_log` VALUES (20541, '65.50.15594310827364327', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:18:03', 0, 1002001015, '账号未登陆', '2019-06-02 07:18:03');
INSERT INTO `access_log` VALUES (20542, '65.53.15594310827374307', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:18:03', 0, 1002001015, '账号未登陆', '2019-06-02 07:18:03');
INSERT INTO `access_log` VALUES (20543, '65.54.15594310827394295', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:18:03', 1, 1002001015, '账号未登陆', '2019-06-02 07:18:03');
INSERT INTO `access_log` VALUES (20544, '65.47.15594310855314331', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:18:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 07:18:06');
INSERT INTO `access_log` VALUES (20545, '65.45.15594310925214331', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:18:13', 136, 0, '', '2019-06-02 07:18:13');
INSERT INTO `access_log` VALUES (20546, '65.46.15594310929134317', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:18:13', 16, 0, '', '2019-06-02 07:18:13');
INSERT INTO `access_log` VALUES (20547, '65.48.15594310929134327', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:18:13', 15, 0, '', '2019-06-02 07:18:13');
INSERT INTO `access_log` VALUES (20548, '65.52.15594310929134307', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:18:13', 16, 0, '', '2019-06-02 07:18:13');
INSERT INTO `access_log` VALUES (20549, '62.83.15594311011114533', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:18:21', 23, 0, '', '2019-06-02 07:18:21');
INSERT INTO `access_log` VALUES (20550, '66.48.15594311160203483', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:18:36', 22, 0, '', '2019-06-02 07:18:36');
INSERT INTO `access_log` VALUES (20551, '65.53.15594311212414309', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:18:41', 27, 0, '', '2019-06-02 07:18:41');
INSERT INTO `access_log` VALUES (20552, '65.50.15594311246844329', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:18:45', 10, 0, '', '2019-06-02 07:18:45');
INSERT INTO `access_log` VALUES (20553, '65.47.15594311301214333', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:18:50', 7, 0, '', '2019-06-02 07:18:50');
INSERT INTO `access_log` VALUES (20554, '65.51.15594311309354315', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.7.177.66', '2019-06-02 07:18:51', 14, 0, '', '2019-06-02 07:18:51');
INSERT INTO `access_log` VALUES (20555, '59.78.15594321472314681', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '106.84.21.13', '2019-06-02 07:35:47', 4, 0, '', '2019-06-02 07:35:47');
INSERT INTO `access_log` VALUES (20556, '59.71.15594321472374681', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '106.84.21.13', '2019-06-02 07:35:47', 25, 2001001000, '服务端发生异常', '2019-06-02 07:35:47');
INSERT INTO `access_log` VALUES (20557, '64.80.15594321534204181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '106.84.21.13', '2019-06-02 07:35:53', 46, 0, '', '2019-06-02 07:35:53');
INSERT INTO `access_log` VALUES (20558, '64.77.15594321536704195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '106.84.21.13', '2019-06-02 07:35:54', 3, 0, '', '2019-06-02 07:35:54');
INSERT INTO `access_log` VALUES (20559, '64.85.15594321557084199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '106.84.21.13', '2019-06-02 07:35:56', 2, 0, '', '2019-06-02 07:35:56');
INSERT INTO `access_log` VALUES (20560, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '106.84.21.13', '2019-06-02 07:35:56', 32, 0, '', '2019-06-02 07:35:56');
INSERT INTO `access_log` VALUES (20561, '64.76.15594321571094181', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '106.84.21.13', '2019-06-02 07:35:57', 9, 0, '', '2019-06-02 07:35:57');
INSERT INTO `access_log` VALUES (20562, '64.84.15594321660704193', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '106.84.21.13', '2019-06-02 07:36:06', 6, 0, '', '2019-06-02 07:36:06');
INSERT INTO `access_log` VALUES (20563, '64.83.15594321721484183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '106.84.21.13', '2019-06-02 07:36:12', 3, 0, '', '2019-06-02 07:36:12');
INSERT INTO `access_log` VALUES (20564, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '106.84.21.13', '2019-06-02 07:36:12', 10, 0, '', '2019-06-02 07:36:12');
INSERT INTO `access_log` VALUES (20565, '64.82.15594321733264199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '106.84.21.13', '2019-06-02 07:36:13', 2, 0, '', '2019-06-02 07:36:13');
INSERT INTO `access_log` VALUES (20566, '64.81.15594321735264185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '106.84.21.13', '2019-06-02 07:36:14', 2, 0, '', '2019-06-02 07:36:14');
INSERT INTO `access_log` VALUES (20567, '59.77.15594321746144673', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '106.84.21.13', '2019-06-02 07:36:15', 3, 0, '', '2019-06-02 07:36:15');
INSERT INTO `access_log` VALUES (20568, '59.80.15594321746114677', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '106.84.21.13', '2019-06-02 07:36:15', 23, 2001001000, '服务端发生异常', '2019-06-02 07:36:15');
INSERT INTO `access_log` VALUES (20569, '62.85.15594348165264587', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.41.43', '2019-06-02 08:20:17', 18, 1002001012, '访问令牌已过期', '2019-06-02 08:20:17');
INSERT INTO `access_log` VALUES (20570, '65.53.15594348196354359', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.41.43', '2019-06-02 08:20:20', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 08:20:20');
INSERT INTO `access_log` VALUES (20571, '59.72.15594357097524723', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '39.130.58.120', '2019-06-02 08:35:10', 20, 2001001000, '服务端发生异常', '2019-06-02 08:35:10');
INSERT INTO `access_log` VALUES (20572, '59.75.15594357097484727', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '39.130.58.120', '2019-06-02 08:35:10', 37, 0, '', '2019-06-02 08:35:10');
INSERT INTO `access_log` VALUES (20573, '64.84.15594357151224241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '39.130.58.120', '2019-06-02 08:35:15', 10, 0, '', '2019-06-02 08:35:15');
INSERT INTO `access_log` VALUES (20574, '64.83.15594357153644231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '39.130.58.120', '2019-06-02 08:35:15', 2, 0, '', '2019-06-02 08:35:15');
INSERT INTO `access_log` VALUES (20575, '64.82.15594357166224247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '39.130.58.120', '2019-06-02 08:35:17', 2, 0, '', '2019-06-02 08:35:17');
INSERT INTO `access_log` VALUES (20576, '64.81.15594357176794233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '39.130.58.120', '2019-06-02 08:35:18', 3, 0, '', '2019-06-02 08:35:18');
INSERT INTO `access_log` VALUES (20577, '64.78.15594357181734245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '39.130.58.120', '2019-06-02 08:35:18', 2, 0, '', '2019-06-02 08:35:18');
INSERT INTO `access_log` VALUES (20578, '64.80.15594357195344231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '39.130.58.120', '2019-06-02 08:35:20', 2, 0, '', '2019-06-02 08:35:20');
INSERT INTO `access_log` VALUES (20579, '64.77.15594357202074245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '39.130.58.120', '2019-06-02 08:35:20', 3, 0, '', '2019-06-02 08:35:20');
INSERT INTO `access_log` VALUES (20580, '59.77.15594357232214721', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '39.130.58.120', '2019-06-02 08:35:23', 4, 0, '', '2019-06-02 08:35:23');
INSERT INTO `access_log` VALUES (20581, '59.73.15594357232224731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '39.130.58.120', '2019-06-02 08:35:23', 14, 2001001000, '服务端发生异常', '2019-06-02 08:35:23');
INSERT INTO `access_log` VALUES (20582, '64.76.15594357308754231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '39.130.58.120', '2019-06-02 08:35:31', 3, 0, '', '2019-06-02 08:35:31');
INSERT INTO `access_log` VALUES (20583, '64.79.15594357311004233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '39.130.58.120', '2019-06-02 08:35:31', 2, 0, '', '2019-06-02 08:35:31');
INSERT INTO `access_log` VALUES (20584, '64.84.15594357320564243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '39.130.58.120', '2019-06-02 08:35:32', 2, 0, '', '2019-06-02 08:35:32');
INSERT INTO `access_log` VALUES (20585, '65.53.15594359653684375', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.41.252.245', '2019-06-02 08:39:25', 0, 1002001015, '账号未登陆', '2019-06-02 08:39:25');
INSERT INTO `access_log` VALUES (20586, '65.49.15594359653684397', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.41.252.245', '2019-06-02 08:39:25', 0, 1002001015, '账号未登陆', '2019-06-02 08:39:25');
INSERT INTO `access_log` VALUES (20587, '65.54.15594359653684363', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.41.252.245', '2019-06-02 08:39:25', 0, 1002001015, '账号未登陆', '2019-06-02 08:39:25');
INSERT INTO `access_log` VALUES (20588, '65.50.15594359701924395', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.41.252.245', '2019-06-02 08:39:30', 96, 0, '', '2019-06-02 08:39:30');
INSERT INTO `access_log` VALUES (20589, '65.47.15594359705184399', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.41.252.245', '2019-06-02 08:39:31', 181, 0, '', '2019-06-02 08:39:31');
INSERT INTO `access_log` VALUES (20590, '65.45.15594359705234399', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.41.252.245', '2019-06-02 08:39:31', 176, 0, '', '2019-06-02 08:39:31');
INSERT INTO `access_log` VALUES (20591, '65.51.15594359705214381', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.41.252.245', '2019-06-02 08:39:31', 178, 0, '', '2019-06-02 08:39:31');
INSERT INTO `access_log` VALUES (20592, '62.89.15594359755954601', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.41.252.245', '2019-06-02 08:39:36', 26, 0, '', '2019-06-02 08:39:36');
INSERT INTO `access_log` VALUES (20593, '59.73.15594361466244737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:42:27', 3, 0, '', '2019-06-02 08:42:27');
INSERT INTO `access_log` VALUES (20594, '59.77.15594361466234727', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:42:27', 13, 2001001000, '服务端发生异常', '2019-06-02 08:42:27');
INSERT INTO `access_log` VALUES (20595, '64.79.15594361532324239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:42:33', 3, 0, '', '2019-06-02 08:42:33');
INSERT INTO `access_log` VALUES (20596, '64.84.15594361533834249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:42:33', 2, 0, '', '2019-06-02 08:42:33');
INSERT INTO `access_log` VALUES (20597, '64.82.15594361609864255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:42:41', 2, 0, '', '2019-06-02 08:42:41');
INSERT INTO `access_log` VALUES (20598, '64.81.15594361611244241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:42:41', 2, 0, '', '2019-06-02 08:42:41');
INSERT INTO `access_log` VALUES (20599, '59.79.15594361795814733', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:43:00', 3, 0, '', '2019-06-02 08:43:00');
INSERT INTO `access_log` VALUES (20600, '59.78.15594361796254737', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:43:00', 12, 2001001000, '服务端发生异常', '2019-06-02 08:43:00');
INSERT INTO `access_log` VALUES (20601, '64.80.15594361848184239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:43:05', 2, 0, '', '2019-06-02 08:43:05');
INSERT INTO `access_log` VALUES (20602, '64.77.15594361849364253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:43:05', 2, 0, '', '2019-06-02 08:43:05');
INSERT INTO `access_log` VALUES (20603, '59.75.15594361873444735', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:43:07', 3, 0, '', '2019-06-02 08:43:07');
INSERT INTO `access_log` VALUES (20604, '59.72.15594361873444731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:43:07', 12, 2001001000, '服务端发生异常', '2019-06-02 08:43:07');
INSERT INTO `access_log` VALUES (20605, '64.76.15594361966674239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:43:17', 3, 0, '', '2019-06-02 08:43:17');
INSERT INTO `access_log` VALUES (20606, '64.79.15594361969154241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:43:17', 829, 0, '', '2019-06-02 08:43:18');
INSERT INTO `access_log` VALUES (20607, '59.77.15594362006174729', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:43:21', 3, 0, '', '2019-06-02 08:43:21');
INSERT INTO `access_log` VALUES (20608, '59.73.15594362006174739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:43:21', 13, 2001001000, '服务端发生异常', '2019-06-02 08:43:21');
INSERT INTO `access_log` VALUES (20609, '64.83.15594362046284241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:43:25', 2, 0, '', '2019-06-02 08:43:25');
INSERT INTO `access_log` VALUES (20610, '64.82.15594362047434257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:43:25', 2, 0, '', '2019-06-02 08:43:25');
INSERT INTO `access_log` VALUES (20611, '59.76.15594362063574729', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:43:26', 13, 2001001000, '服务端发生异常', '2019-06-02 08:43:26');
INSERT INTO `access_log` VALUES (20612, '59.74.15594362063574733', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '223.74.154.65', '2019-06-02 08:43:26', 132, 0, '', '2019-06-02 08:43:26');
INSERT INTO `access_log` VALUES (20613, '59.71.15594384725914769', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '117.136.39.223', '2019-06-02 09:21:13', 17, 0, '', '2019-06-02 09:21:13');
INSERT INTO `access_log` VALUES (20614, '59.78.15594384725914769', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '117.136.39.223', '2019-06-02 09:21:13', 26, 2001001000, '服务端发生异常', '2019-06-02 09:21:13');
INSERT INTO `access_log` VALUES (20615, '64.78.15594384804984285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '117.136.39.223', '2019-06-02 09:21:20', 10, 0, '', '2019-06-02 09:21:21');
INSERT INTO `access_log` VALUES (20616, '64.77.15594384807384285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '117.136.39.223', '2019-06-02 09:21:21', 3, 0, '', '2019-06-02 09:21:21');
INSERT INTO `access_log` VALUES (20617, '64.85.15594384830614289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '117.136.39.223', '2019-06-02 09:21:23', 2, 0, '', '2019-06-02 09:21:23');
INSERT INTO `access_log` VALUES (20618, '64.76.15594384840314271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '117.136.39.223', '2019-06-02 09:21:24', 2, 0, '', '2019-06-02 09:21:24');
INSERT INTO `access_log` VALUES (20619, '64.79.15594384853014273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '117.136.39.223', '2019-06-02 09:21:25', 2, 0, '', '2019-06-02 09:21:25');
INSERT INTO `access_log` VALUES (20620, '64.84.15594384858114283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '117.136.39.223', '2019-06-02 09:21:26', 3, 0, '', '2019-06-02 09:21:26');
INSERT INTO `access_log` VALUES (20621, '64.82.15594384988204289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '117.136.39.223', '2019-06-02 09:21:39', 2, 0, '', '2019-06-02 09:21:39');
INSERT INTO `access_log` VALUES (20622, '64.81.15594384990594275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '117.136.39.223', '2019-06-02 09:21:39', 2, 0, '', '2019-06-02 09:21:39');
INSERT INTO `access_log` VALUES (20623, '59.80.15594385008164765', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '117.136.39.223', '2019-06-02 09:21:41', 4, 0, '', '2019-06-02 09:21:41');
INSERT INTO `access_log` VALUES (20624, '59.77.15594385008194761', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '117.136.39.223', '2019-06-02 09:21:41', 14, 2001001000, '服务端发生异常', '2019-06-02 09:21:41');
INSERT INTO `access_log` VALUES (20625, '59.79.15594385316114767', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:12', 2, 0, '', '2019-06-02 09:22:12');
INSERT INTO `access_log` VALUES (20626, '59.74.15594385316114765', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:12', 14, 2001001000, '服务端发生异常', '2019-06-02 09:22:12');
INSERT INTO `access_log` VALUES (20627, '64.85.15594385407344291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:21', 3, 0, '', '2019-06-02 09:22:21');
INSERT INTO `access_log` VALUES (20628, '64.76.15594385410374273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:21', 2, 0, '', '2019-06-02 09:22:21');
INSERT INTO `access_log` VALUES (20629, '64.79.15594385428904275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:23', 3, 0, '', '2019-06-02 09:22:23');
INSERT INTO `access_log` VALUES (20630, '64.84.15594385438134285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:24', 3, 0, '', '2019-06-02 09:22:24');
INSERT INTO `access_log` VALUES (20631, '64.83.15594385448704275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:25', 2, 0, '', '2019-06-02 09:22:25');
INSERT INTO `access_log` VALUES (20632, '64.82.15594385509164291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:31', 2, 0, '', '2019-06-02 09:22:31');
INSERT INTO `access_log` VALUES (20633, '64.81.15594385510864277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:31', 2, 0, '', '2019-06-02 09:22:31');
INSERT INTO `access_log` VALUES (20634, '59.72.15594385557834765', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:36', 2, 0, '', '2019-06-02 09:22:36');
INSERT INTO `access_log` VALUES (20635, '59.75.15594385557834769', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:36', 12, 2001001000, '服务端发生异常', '2019-06-02 09:22:36');
INSERT INTO `access_log` VALUES (20636, '64.77.15594385711954289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:51', 2, 0, '', '2019-06-02 09:22:51');
INSERT INTO `access_log` VALUES (20637, '64.85.15594385713434293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:51', 2, 0, '', '2019-06-02 09:22:51');
INSERT INTO `access_log` VALUES (20638, '64.76.15594385731314275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:53', 2, 0, '', '2019-06-02 09:22:53');
INSERT INTO `access_log` VALUES (20639, '64.79.15594385732974277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:53', 3, 0, '', '2019-06-02 09:22:53');
INSERT INTO `access_log` VALUES (20640, '59.73.15594385741864773', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:54', 2, 0, '', '2019-06-02 09:22:54');
INSERT INTO `access_log` VALUES (20641, '59.80.15594385741864767', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:54', 13, 2001001000, '服务端发生异常', '2019-06-02 09:22:54');
INSERT INTO `access_log` VALUES (20642, '64.84.15594385760554287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:56', 2, 0, '', '2019-06-02 09:22:56');
INSERT INTO `access_log` VALUES (20643, '64.83.15594385761874277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:56', 3, 0, '', '2019-06-02 09:22:56');
INSERT INTO `access_log` VALUES (20644, '59.79.15594385769234769', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:57', 2, 0, '', '2019-06-02 09:22:57');
INSERT INTO `access_log` VALUES (20645, '59.76.15594385769234763', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; MI MAX Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/46.0.2490.85 Mobile Safari/537.36 XiaoMi/MiuiBrowser/8.2.15', '218.92.226.197', '2019-06-02 09:22:57', 12, 2001001000, '服务端发生异常', '2019-06-02 09:22:57');
INSERT INTO `access_log` VALUES (20646, '59.71.15594392689684783', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 2S Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.246.152.42', '2019-06-02 09:34:29', 3, 0, '', '2019-06-02 09:34:29');
INSERT INTO `access_log` VALUES (20647, '59.76.15594392689764773', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 2S Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.246.152.42', '2019-06-02 09:34:29', 12, 2001001000, '服务端发生异常', '2019-06-02 09:34:29');
INSERT INTO `access_log` VALUES (20648, '64.79.15594392825854287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 2S Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.246.152.42', '2019-06-02 09:34:43', 47, 0, '', '2019-06-02 09:34:43');
INSERT INTO `access_log` VALUES (20649, '64.84.15594392829194297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 2S Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.246.152.42', '2019-06-02 09:34:43', 371, 0, '', '2019-06-02 09:34:43');
INSERT INTO `access_log` VALUES (20650, '59.75.15594397664314787', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:42:46', 3, 0, '', '2019-06-02 09:42:46');
INSERT INTO `access_log` VALUES (20651, '59.77.15594397664344779', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:42:46', 13, 2001001000, '服务端发生异常', '2019-06-02 09:42:46');
INSERT INTO `access_log` VALUES (20652, '64.80.15594397744264293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.193.234.233', '2019-06-02 09:42:54', 3, 0, '', '2019-06-02 09:42:54');
INSERT INTO `access_log` VALUES (20653, '64.78.15594397745384307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.193.234.233', '2019-06-02 09:42:55', 3, 0, '', '2019-06-02 09:42:55');
INSERT INTO `access_log` VALUES (20654, '64.77.15594397783164307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.193.234.233', '2019-06-02 09:42:58', 2, 0, '', '2019-06-02 09:42:58');
INSERT INTO `access_log` VALUES (20655, '64.85.15594397784294311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.193.234.233', '2019-06-02 09:42:58', 2, 0, '', '2019-06-02 09:42:58');
INSERT INTO `access_log` VALUES (20656, '59.79.15594397843034787', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.193.234.233', '2019-06-02 09:43:04', 3, 0, '', '2019-06-02 09:43:04');
INSERT INTO `access_log` VALUES (20657, '59.71.15594397843054791', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.193.234.233', '2019-06-02 09:43:04', 13, 2001001000, '服务端发生异常', '2019-06-02 09:43:04');
INSERT INTO `access_log` VALUES (20658, '64.79.15594397899924295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.193.234.233', '2019-06-02 09:43:10', 2, 0, '', '2019-06-02 09:43:10');
INSERT INTO `access_log` VALUES (20659, '64.84.15594397903534305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.193.234.233', '2019-06-02 09:43:10', 3, 0, '', '2019-06-02 09:43:10');
INSERT INTO `access_log` VALUES (20660, '64.83.15594397914304295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.193.234.233', '2019-06-02 09:43:11', 3, 0, '', '2019-06-02 09:43:11');
INSERT INTO `access_log` VALUES (20661, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.193.234.233', '2019-06-02 09:43:11', 15, 0, '', '2019-06-02 09:43:11');
INSERT INTO `access_log` VALUES (20662, '64.82.15594397930804311', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '111.193.234.233', '2019-06-02 09:43:13', 11, 0, '', '2019-06-02 09:43:13');
INSERT INTO `access_log` VALUES (20663, '65.53.15594398124084429', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:43:32', 1, 1002001015, '账号未登陆', '2019-06-02 09:43:32');
INSERT INTO `access_log` VALUES (20664, '65.49.15594398124104451', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:43:32', 1, 1002001015, '账号未登陆', '2019-06-02 09:43:32');
INSERT INTO `access_log` VALUES (20665, '65.54.15594398124254417', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:43:32', 1, 1002001015, '账号未登陆', '2019-06-02 09:43:32');
INSERT INTO `access_log` VALUES (20666, '65.45.15594398149174451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:43:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 09:43:35');
INSERT INTO `access_log` VALUES (20667, '65.47.15594398211594451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:43:41', 87, 0, '', '2019-06-02 09:43:41');
INSERT INTO `access_log` VALUES (20668, '65.51.15594398215384435', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:43:42', 11, 0, '', '2019-06-02 09:43:42');
INSERT INTO `access_log` VALUES (20669, '65.46.15594398215404439', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:43:42', 11, 0, '', '2019-06-02 09:43:42');
INSERT INTO `access_log` VALUES (20670, '65.48.15594398215484447', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:43:42', 11, 0, '', '2019-06-02 09:43:42');
INSERT INTO `access_log` VALUES (20671, '65.53.15594398479534431', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:08', 10, 0, '', '2019-06-02 09:44:08');
INSERT INTO `access_log` VALUES (20672, '65.54.15594398479594419', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:08', 10, 0, '', '2019-06-02 09:44:08');
INSERT INTO `access_log` VALUES (20673, '65.49.15594398479694453', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:08', 8, 0, '', '2019-06-02 09:44:08');
INSERT INTO `access_log` VALUES (20674, '65.50.15594398556994451', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:16', 9, 0, '', '2019-06-02 09:44:16');
INSERT INTO `access_log` VALUES (20675, '65.47.15594398557064453', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:16', 9, 0, '', '2019-06-02 09:44:16');
INSERT INTO `access_log` VALUES (20676, '65.51.15594398557164437', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:16', 8, 0, '', '2019-06-02 09:44:16');
INSERT INTO `access_log` VALUES (20677, '65.46.15594398600904441', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:20', 9, 0, '', '2019-06-02 09:44:20');
INSERT INTO `access_log` VALUES (20678, '65.48.15594398600934449', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:20', 8, 0, '', '2019-06-02 09:44:20');
INSERT INTO `access_log` VALUES (20679, '65.52.15594398600964435', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:20', 8, 0, '', '2019-06-02 09:44:20');
INSERT INTO `access_log` VALUES (20680, '65.49.15594398644554455', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:24', 9, 0, '', '2019-06-02 09:44:24');
INSERT INTO `access_log` VALUES (20681, '65.54.15594398644574421', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:24', 9, 0, '', '2019-06-02 09:44:24');
INSERT INTO `access_log` VALUES (20682, '65.45.15594398644614455', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:24', 9, 0, '', '2019-06-02 09:44:24');
INSERT INTO `access_log` VALUES (20683, '62.85.15594398670654655', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:27', 18, 0, '', '2019-06-02 09:44:27');
INSERT INTO `access_log` VALUES (20684, '65.50.15594398712974453', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:31', 10, 0, '', '2019-06-02 09:44:31');
INSERT INTO `access_log` VALUES (20685, '65.51.15594398712974439', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:31', 9, 0, '', '2019-06-02 09:44:31');
INSERT INTO `access_log` VALUES (20686, '65.47.15594398712974455', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:31', 9, 0, '', '2019-06-02 09:44:31');
INSERT INTO `access_log` VALUES (20687, '62.83.15594398714224651', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:31', 12, 0, '', '2019-06-02 09:44:31');
INSERT INTO `access_log` VALUES (20688, '64.84.15594398784344307', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:38', 10, 0, '', '2019-06-02 09:44:38');
INSERT INTO `access_log` VALUES (20689, '64.79.15594398784324297', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.193.234.233', '2019-06-02 09:44:38', 14, 0, '', '2019-06-02 09:44:38');
INSERT INTO `access_log` VALUES (20690, '59.80.15594403473134791', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '220.248.126.65', '2019-06-02 09:52:27', 3, 0, '', '2019-06-02 09:52:27');
INSERT INTO `access_log` VALUES (20691, '59.79.15594403473854795', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '220.248.126.65', '2019-06-02 09:52:27', 13, 2001001000, '服务端发生异常', '2019-06-02 09:52:27');
INSERT INTO `access_log` VALUES (20692, '64.81.15594403560494305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '220.248.126.65', '2019-06-02 09:52:36', 4, 0, '', '2019-06-02 09:52:36');
INSERT INTO `access_log` VALUES (20693, '64.80.15594403561834303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '220.248.126.65', '2019-06-02 09:52:36', 2, 0, '', '2019-06-02 09:52:36');
INSERT INTO `access_log` VALUES (20694, '64.78.15594403593434317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '220.248.126.65', '2019-06-02 09:52:39', 2, 0, '', '2019-06-02 09:52:39');
INSERT INTO `access_log` VALUES (20695, '59.76.15594403642834789', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '220.248.126.65', '2019-06-02 09:52:44', 3, 0, '', '2019-06-02 09:52:44');
INSERT INTO `access_log` VALUES (20696, '59.74.15594403642854793', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '220.248.126.65', '2019-06-02 09:52:44', 13, 2001001000, '服务端发生异常', '2019-06-02 09:52:44');
INSERT INTO `access_log` VALUES (20697, '59.78.15594406532734803', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.117.135.205', '2019-06-02 09:57:33', 3, 0, '', '2019-06-02 09:57:33');
INSERT INTO `access_log` VALUES (20698, '59.74.15594406532734797', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.117.135.205', '2019-06-02 09:57:33', 13, 2001001000, '服务端发生异常', '2019-06-02 09:57:33');
INSERT INTO `access_log` VALUES (20699, '64.77.15594406578374321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.117.135.205', '2019-06-02 09:57:38', 3, 0, '', '2019-06-02 09:57:38');
INSERT INTO `access_log` VALUES (20700, '64.85.15594406586984325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.117.135.205', '2019-06-02 09:57:39', 2, 0, '', '2019-06-02 09:57:39');
INSERT INTO `access_log` VALUES (20701, '64.84.15594406822154319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.117.135.205', '2019-06-02 09:58:02', 2, 0, '', '2019-06-02 09:58:02');
INSERT INTO `access_log` VALUES (20702, '64.79.15594406828624309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.117.135.205', '2019-06-02 09:58:03', 2, 0, '', '2019-06-02 09:58:03');
INSERT INTO `access_log` VALUES (20703, '64.83.15594406832204309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.117.135.205', '2019-06-02 09:58:03', 2, 0, '', '2019-06-02 09:58:03');
INSERT INTO `access_log` VALUES (20704, '65.48.15594421310934481', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:22:11', 0, 1002001015, '账号未登陆', '2019-06-02 10:22:11');
INSERT INTO `access_log` VALUES (20705, '65.46.15594421311314473', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:22:11', 1, 1002001015, '账号未登陆', '2019-06-02 10:22:11');
INSERT INTO `access_log` VALUES (20706, '65.52.15594421311634467', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:22:11', 1, 1002001015, '账号未登陆', '2019-06-02 10:22:11');
INSERT INTO `access_log` VALUES (20707, '65.53.15594421410224467', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:22:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 10:22:21');
INSERT INTO `access_log` VALUES (20708, '65.50.15594421923184485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=user&password=user&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:23:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位\n账号长度为 5-16 位', '2019-06-02 10:23:12');
INSERT INTO `access_log` VALUES (20709, '65.46.15594422150714475', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:23:35', 55, 0, '', '2019-06-02 10:23:35');
INSERT INTO `access_log` VALUES (20710, '65.48.15594422158134483', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:23:36', 11, 0, '', '2019-06-02 10:23:36');
INSERT INTO `access_log` VALUES (20711, '65.52.15594422158154469', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:23:36', 11, 0, '', '2019-06-02 10:23:36');
INSERT INTO `access_log` VALUES (20712, '65.53.15594422158344469', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:23:36', 10, 0, '', '2019-06-02 10:23:36');
INSERT INTO `access_log` VALUES (20713, '65.49.15594422325094491', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:23:53', 7, 0, '', '2019-06-02 10:23:53');
INSERT INTO `access_log` VALUES (20714, '65.45.15594422325094489', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:23:53', 8, 0, '', '2019-06-02 10:23:53');
INSERT INTO `access_log` VALUES (20715, '65.47.15594422325324489', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:23:53', 8, 0, '', '2019-06-02 10:23:53');
INSERT INTO `access_log` VALUES (20716, '64.85.15594422332774347', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:23:53', 11, 0, '', '2019-06-02 10:23:53');
INSERT INTO `access_log` VALUES (20717, '64.77.15594422332774343', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:23:53', 14, 0, '', '2019-06-02 10:23:53');
INSERT INTO `access_log` VALUES (20718, '65.46.15594422467294477', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:24:07', 6, 0, '', '2019-06-02 10:24:07');
INSERT INTO `access_log` VALUES (20719, '65.51.15594422467284475', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:24:07', 9, 0, '', '2019-06-02 10:24:07');
INSERT INTO `access_log` VALUES (20720, '65.48.15594422467504485', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; vivo Z1 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.7.1027 Mobile Safari/537.36', '223.104.24.122', '2019-06-02 10:24:07', 183, 0, '', '2019-06-02 10:24:07');
INSERT INTO `access_log` VALUES (20721, '65.45.15594427635564497', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:32:44', 1, 1002001015, '账号未登陆', '2019-06-02 10:32:44');
INSERT INTO `access_log` VALUES (20722, '65.50.15594427635664495', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:32:44', 1, 1002001015, '账号未登陆', '2019-06-02 10:32:44');
INSERT INTO `access_log` VALUES (20723, '65.51.15594427635724483', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:32:44', 1, 1002001015, '账号未登陆', '2019-06-02 10:32:44');
INSERT INTO `access_log` VALUES (20724, '65.48.15594427775134493', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:32:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 10:32:58');
INSERT INTO `access_log` VALUES (20725, '65.53.15594427832334479', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.86.38.119', '2019-06-02 10:33:03', 0, 1002001015, '账号未登陆', '2019-06-02 10:33:03');
INSERT INTO `access_log` VALUES (20726, '65.52.15594427832334479', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.86.38.119', '2019-06-02 10:33:03', 0, 1002001015, '账号未登陆', '2019-06-02 10:33:03');
INSERT INTO `access_log` VALUES (20727, '65.54.15594427832384467', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.86.38.119', '2019-06-02 10:33:03', 1, 1002001015, '账号未登陆', '2019-06-02 10:33:03');
INSERT INTO `access_log` VALUES (20728, '65.49.15594427849204501', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:33:05', 143, 0, '', '2019-06-02 10:33:05');
INSERT INTO `access_log` VALUES (20729, '65.47.15594427852294499', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.86.38.119', '2019-06-02 10:33:05', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 10:33:05');
INSERT INTO `access_log` VALUES (20730, '65.45.15594427854114499', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:33:05', 8, 0, '', '2019-06-02 10:33:05');
INSERT INTO `access_log` VALUES (20731, '65.51.15594427854164485', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:33:05', 7, 0, '', '2019-06-02 10:33:05');
INSERT INTO `access_log` VALUES (20732, '65.50.15594427854644497', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:33:05', 9, 0, '', '2019-06-02 10:33:05');
INSERT INTO `access_log` VALUES (20733, '65.46.15594427886664487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.86.38.119', '2019-06-02 10:33:09', 75, 0, '', '2019-06-02 10:33:09');
INSERT INTO `access_log` VALUES (20734, '65.53.15594427889644481', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.86.38.119', '2019-06-02 10:33:09', 10, 0, '', '2019-06-02 10:33:09');
INSERT INTO `access_log` VALUES (20735, '65.52.15594427889684481', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.86.38.119', '2019-06-02 10:33:09', 9, 0, '', '2019-06-02 10:33:09');
INSERT INTO `access_log` VALUES (20736, '65.54.15594427889684469', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.86.38.119', '2019-06-02 10:33:09', 8, 0, '', '2019-06-02 10:33:09');
INSERT INTO `access_log` VALUES (20737, '62.89.15594427907964697', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:33:11', 335, 0, '', '2019-06-02 10:33:11');
INSERT INTO `access_log` VALUES (20738, '62.83.15594427915224693', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.86.38.119', '2019-06-02 10:33:12', 12, 0, '', '2019-06-02 10:33:12');
INSERT INTO `access_log` VALUES (20739, '64.77.15594428003644351', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.86.38.119', '2019-06-02 10:33:20', 150, 0, '', '2019-06-02 10:33:21');
INSERT INTO `access_log` VALUES (20740, '64.78.15594428003644351', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.86.38.119', '2019-06-02 10:33:20', 152, 0, '', '2019-06-02 10:33:21');
INSERT INTO `access_log` VALUES (20741, '59.80.15594428062894825', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.86.38.119', '2019-06-02 10:33:26', 65, 0, '', '2019-06-02 10:33:26');
INSERT INTO `access_log` VALUES (20742, '59.79.15594428091594829', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.86.38.119', '2019-06-02 10:33:29', 22, 2001001000, '服务端发生异常', '2019-06-02 10:33:29');
INSERT INTO `access_log` VALUES (20743, '65.45.15594428218314501', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:33:42', 11, 0, '', '2019-06-02 10:33:42');
INSERT INTO `access_log` VALUES (20744, '65.51.15594428218334487', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:33:42', 9, 0, '', '2019-06-02 10:33:42');
INSERT INTO `access_log` VALUES (20745, '65.50.15594428218384499', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:33:42', 10, 0, '', '2019-06-02 10:33:42');
INSERT INTO `access_log` VALUES (20746, '65.49.15594428967974505', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:34:57', 1, 1002001015, '账号未登陆', '2019-06-02 10:34:57');
INSERT INTO `access_log` VALUES (20747, '65.47.15594428967974503', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:34:57', 0, 1002001015, '账号未登陆', '2019-06-02 10:34:57');
INSERT INTO `access_log` VALUES (20748, '65.45.15594428968024503', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:34:57', 0, 1002001015, '账号未登陆', '2019-06-02 10:34:57');
INSERT INTO `access_log` VALUES (20749, '65.51.15594429011844489', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:35:01', 1628, 0, '', '2019-06-02 10:35:03');
INSERT INTO `access_log` VALUES (20750, '65.46.15594429038774491', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:35:04', 17, 0, '', '2019-06-02 10:35:04');
INSERT INTO `access_log` VALUES (20751, '65.50.15594429038764501', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:35:04', 17, 0, '', '2019-06-02 10:35:04');
INSERT INTO `access_log` VALUES (20752, '65.48.15594429038874499', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:35:04', 7, 0, '', '2019-06-02 10:35:04');
INSERT INTO `access_log` VALUES (20753, '62.83.15594429183754695', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:35:18', 12, 0, '', '2019-06-02 10:35:18');
INSERT INTO `access_log` VALUES (20754, '64.78.15594429321494353', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:35:32', 9, 0, '', '2019-06-02 10:35:32');
INSERT INTO `access_log` VALUES (20755, '64.77.15594429321494353', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:35:32', 11, 0, '', '2019-06-02 10:35:32');
INSERT INTO `access_log` VALUES (20756, '64.76.15594429353114339', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:35:35', 10, 0, '', '2019-06-02 10:35:35');
INSERT INTO `access_log` VALUES (20757, '64.84.15594429353114351', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:35:35', 11, 0, '', '2019-06-02 10:35:35');
INSERT INTO `access_log` VALUES (20758, '66.57.15594429486503639', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:35:49', 22, 0, '', '2019-06-02 10:35:49');
INSERT INTO `access_log` VALUES (20759, '59.71.15594429530994835', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:35:53', 17, 0, '', '2019-06-02 10:35:53');
INSERT INTO `access_log` VALUES (20760, '59.76.15594429583024825', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:35:58', 22, 2001001000, '服务端发生异常', '2019-06-02 10:35:58');
INSERT INTO `access_log` VALUES (20761, '59.74.15594429624534829', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:36:02', 14, 0, '', '2019-06-02 10:36:02');
INSERT INTO `access_log` VALUES (20762, '59.72.15594429676514829', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:36:08', 7, 1002002009, NULL, '2019-06-02 10:36:08');
INSERT INTO `access_log` VALUES (20763, '64.81.15594429704404343', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:36:10', 9, 0, '', '2019-06-02 10:36:10');
INSERT INTO `access_log` VALUES (20764, '64.80.15594429728014341', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:36:13', 9, 0, '', '2019-06-02 10:36:13');
INSERT INTO `access_log` VALUES (20765, '65.47.15594429752004505', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:36:15', 20, 0, '', '2019-06-02 10:36:15');
INSERT INTO `access_log` VALUES (20766, '65.50.15594429852874503', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:36:25', 12, 0, '', '2019-06-02 10:36:25');
INSERT INTO `access_log` VALUES (20767, '65.46.15594429961574493', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:36:36', 10, 0, '', '2019-06-02 10:36:36');
INSERT INTO `access_log` VALUES (20768, '65.48.15594429979084501', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:36:38', 341, 0, '', '2019-06-02 10:36:38');
INSERT INTO `access_log` VALUES (20769, '65.52.15594429993274487', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:36:39', 14, 0, '', '2019-06-02 10:36:39');
INSERT INTO `access_log` VALUES (20770, '62.85.15594430032374701', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:36:43', 213, 0, '', '2019-06-02 10:36:43');
INSERT INTO `access_log` VALUES (20771, '62.89.15594430060804701', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:36:46', 12, 0, '', '2019-06-02 10:36:46');
INSERT INTO `access_log` VALUES (20772, '62.82.15594430192154709', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:36:59', 12, 0, '', '2019-06-02 10:36:59');
INSERT INTO `access_log` VALUES (20773, '62.88.15594430193754707', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:36:59', 14, 0, '', '2019-06-02 10:36:59');
INSERT INTO `access_log` VALUES (20774, '65.49.15594430196174509', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:37:00', 13, 0, '', '2019-06-02 10:37:00');
INSERT INTO `access_log` VALUES (20775, '65.45.15594430197554507', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:37:00', 8, 0, '', '2019-06-02 10:37:00');
INSERT INTO `access_log` VALUES (20776, '65.47.15594430198884507', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:37:00', 10, 0, '', '2019-06-02 10:37:00');
INSERT INTO `access_log` VALUES (20777, '65.51.15594430200544493', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:37:00', 18, 0, '', '2019-06-02 10:37:00');
INSERT INTO `access_log` VALUES (20778, '59.80.15594430202264829', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:37:00', 131, 0, '', '2019-06-02 10:37:00');
INSERT INTO `access_log` VALUES (20779, '59.79.15594430203994833', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:37:00', 21, 2001001000, '服务端发生异常', '2019-06-02 10:37:00');
INSERT INTO `access_log` VALUES (20780, '59.71.15594430206114837', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:37:01', 12, 0, '', '2019-06-02 10:37:01');
INSERT INTO `access_log` VALUES (20781, '66.51.15594430207653637', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.222.24.51', '2019-06-02 10:37:01', 14, 0, '', '2019-06-02 10:37:01');
INSERT INTO `access_log` VALUES (20782, '65.50.15594436180414513', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:46:58', 1, 1002001015, '账号未登陆', '2019-06-02 10:46:58');
INSERT INTO `access_log` VALUES (20783, '65.46.15594436180454503', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:46:58', 0, 1002001015, '账号未登陆', '2019-06-02 10:46:58');
INSERT INTO `access_log` VALUES (20784, '65.48.15594436180544511', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:46:58', 0, 1002001015, '账号未登陆', '2019-06-02 10:46:58');
INSERT INTO `access_log` VALUES (20785, '65.54.15594436201144485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:47:00', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 10:47:00');
INSERT INTO `access_log` VALUES (20786, '65.53.15594436352394497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:47:15', 115, 0, '', '2019-06-02 10:47:15');
INSERT INTO `access_log` VALUES (20787, '65.49.15594436356764519', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:47:16', 10, 0, '', '2019-06-02 10:47:16');
INSERT INTO `access_log` VALUES (20788, '65.45.15594436356804517', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:47:16', 9, 0, '', '2019-06-02 10:47:16');
INSERT INTO `access_log` VALUES (20789, '65.47.15594436356864517', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:47:16', 16, 0, '', '2019-06-02 10:47:16');
INSERT INTO `access_log` VALUES (20790, '65.51.15594436429864503', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:47:23', 9, 0, '', '2019-06-02 10:47:23');
INSERT INTO `access_log` VALUES (20791, '65.48.15594436429944513', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:47:23', 8, 0, '', '2019-06-02 10:47:23');
INSERT INTO `access_log` VALUES (20792, '65.46.15594436430014505', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:47:23', 8, 0, '', '2019-06-02 10:47:23');
INSERT INTO `access_log` VALUES (20793, '62.81.15594436506384697', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:47:31', 14, 0, '', '2019-06-02 10:47:31');
INSERT INTO `access_log` VALUES (20794, '64.83.15594436530284351', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:47:33', 14, 0, '', '2019-06-02 10:47:33');
INSERT INTO `access_log` VALUES (20795, '64.79.15594436530234351', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:47:33', 19, 0, '', '2019-06-02 10:47:33');
INSERT INTO `access_log` VALUES (20796, '59.77.15594436718984835', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:47:52', 12, 0, '', '2019-06-02 10:47:52');
INSERT INTO `access_log` VALUES (20797, '59.75.15594436761154843', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:47:56', 20, 2001001000, '服务端发生异常', '2019-06-02 10:47:56');
INSERT INTO `access_log` VALUES (20798, '65.53.15594436805744499', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:48:01', 157, 0, '', '2019-06-02 10:48:01');
INSERT INTO `access_log` VALUES (20799, '65.49.15594436824484521', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:48:02', 10, 0, '', '2019-06-02 10:48:02');
INSERT INTO `access_log` VALUES (20800, '65.47.15594436843834519', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:48:04', 9, 0, '', '2019-06-02 10:48:04');
INSERT INTO `access_log` VALUES (20801, '65.48.15594436998194515', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:48:20', 92, 0, '', '2019-06-02 10:48:20');
INSERT INTO `access_log` VALUES (20802, '62.87.15594437089714721', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:48:29', 13, 0, '', '2019-06-02 10:48:29');
INSERT INTO `access_log` VALUES (20803, '62.86.15594437112604705', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:48:31', 15, 0, '', '2019-06-02 10:48:31');
INSERT INTO `access_log` VALUES (20804, '62.84.15594437159104701', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:48:36', 16, 0, '', '2019-06-02 10:48:36');
INSERT INTO `access_log` VALUES (20805, '62.85.15594437238644717', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:48:44', 12, 0, '', '2019-06-02 10:48:44');
INSERT INTO `access_log` VALUES (20806, '65.50.15594437253124517', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:48:45', 14, 0, '', '2019-06-02 10:48:45');
INSERT INTO `access_log` VALUES (20807, '65.54.15594437255314489', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:48:46', 10, 0, '', '2019-06-02 10:48:46');
INSERT INTO `access_log` VALUES (20808, '65.52.15594437257454501', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:48:46', 9, 0, '', '2019-06-02 10:48:46');
INSERT INTO `access_log` VALUES (20809, '65.53.15594437259044501', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:48:46', 19, 0, '', '2019-06-02 10:48:46');
INSERT INTO `access_log` VALUES (20810, '59.71.15594437260974847', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:48:46', 16, 2001001000, '服务端发生异常', '2019-06-02 10:48:46');
INSERT INTO `access_log` VALUES (20811, '59.76.15594437263144837', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.30.125.178', '2019-06-02 10:48:46', 11, 0, '', '2019-06-02 10:48:46');
INSERT INTO `access_log` VALUES (20812, '59.77.15594437610654837', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:21', 3, 0, '', '2019-06-02 10:49:21');
INSERT INTO `access_log` VALUES (20813, '59.75.15594437610654845', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:21', 10, 2001001000, '服务端发生异常', '2019-06-02 10:49:21');
INSERT INTO `access_log` VALUES (20814, '64.83.15594437657654353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:26', 3, 0, '', '2019-06-02 10:49:26');
INSERT INTO `access_log` VALUES (20815, '64.79.15594437659074353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:26', 2, 0, '', '2019-06-02 10:49:26');
INSERT INTO `access_log` VALUES (20816, '64.82.15594437670024369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:27', 2, 0, '', '2019-06-02 10:49:27');
INSERT INTO `access_log` VALUES (20817, '64.81.15594437673054355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:27', 2, 0, '', '2019-06-02 10:49:27');
INSERT INTO `access_log` VALUES (20818, '59.73.15594437681734849', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:28', 3, 0, '', '2019-06-02 10:49:28');
INSERT INTO `access_log` VALUES (20819, '59.80.15594437681754841', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:28', 12, 2001001000, '服务端发生异常', '2019-06-02 10:49:28');
INSERT INTO `access_log` VALUES (20820, '64.80.15594437700724353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:30', 2, 0, '', '2019-06-02 10:49:30');
INSERT INTO `access_log` VALUES (20821, '64.85.15594437701944371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:30', 2, 0, '', '2019-06-02 10:49:30');
INSERT INTO `access_log` VALUES (20822, '64.77.15594437711564367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:31', 2, 0, '', '2019-06-02 10:49:31');
INSERT INTO `access_log` VALUES (20823, '64.78.15594437713884367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:31', 2, 0, '', '2019-06-02 10:49:31');
INSERT INTO `access_log` VALUES (20824, '59.79.15594437727754845', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:33', 3, 0, '', '2019-06-02 10:49:33');
INSERT INTO `access_log` VALUES (20825, '59.71.15594437727764849', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:33', 12, 2001001000, '服务端发生异常', '2019-06-02 10:49:33');
INSERT INTO `access_log` VALUES (20826, '64.76.15594437750294353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:35', 2, 0, '', '2019-06-02 10:49:35');
INSERT INTO `access_log` VALUES (20827, '64.84.15594437751934365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:35', 2, 0, '', '2019-06-02 10:49:35');
INSERT INTO `access_log` VALUES (20828, '64.79.15594437760134355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:36', 2, 0, '', '2019-06-02 10:49:36');
INSERT INTO `access_log` VALUES (20829, '64.82.15594437762544371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:36', 2, 0, '', '2019-06-02 10:49:36');
INSERT INTO `access_log` VALUES (20830, '59.74.15594437770764843', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:37', 3, 0, '', '2019-06-02 10:49:37');
INSERT INTO `access_log` VALUES (20831, '59.78.15594437770774849', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:37', 13, 2001001000, '服务端发生异常', '2019-06-02 10:49:37');
INSERT INTO `access_log` VALUES (20832, '65.51.15594437827314507', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:43', 1, 1002001015, '账号未登陆', '2019-06-02 10:49:43');
INSERT INTO `access_log` VALUES (20833, '65.46.15594437827354509', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:43', 0, 1002001015, '账号未登陆', '2019-06-02 10:49:43');
INSERT INTO `access_log` VALUES (20834, '65.50.15594437827444519', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:43', 0, 1002001015, '账号未登陆', '2019-06-02 10:49:43');
INSERT INTO `access_log` VALUES (20835, '65.54.15594437846414491', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 10:49:45');
INSERT INTO `access_log` VALUES (20836, '65.52.15594437904774503', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:49:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 10:49:50');
INSERT INTO `access_log` VALUES (20837, '65.47.15594438159404523', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:50:16', 62, 0, '', '2019-06-02 10:50:16');
INSERT INTO `access_log` VALUES (20838, '65.45.15594438163124523', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:50:16', 10, 0, '', '2019-06-02 10:50:16');
INSERT INTO `access_log` VALUES (20839, '65.48.15594438163184519', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:50:16', 9, 0, '', '2019-06-02 10:50:16');
INSERT INTO `access_log` VALUES (20840, '65.51.15594438163234509', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:50:16', 9, 0, '', '2019-06-02 10:50:16');
INSERT INTO `access_log` VALUES (20841, '62.89.15594438217114727', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:50:22', 11, 0, '', '2019-06-02 10:50:22');
INSERT INTO `access_log` VALUES (20842, '59.73.15594438262024851', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:50:26', 44, 0, '', '2019-06-02 10:50:26');
INSERT INTO `access_log` VALUES (20843, '65.46.15594438296304511', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:50:30', 20, 0, '', '2019-06-02 10:50:30');
INSERT INTO `access_log` VALUES (20844, '65.54.15594438306894493', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:50:31', 10, 0, '', '2019-06-02 10:50:31');
INSERT INTO `access_log` VALUES (20845, '65.52.15594438319044505', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:50:32', 10, 0, '', '2019-06-02 10:50:32');
INSERT INTO `access_log` VALUES (20846, '65.53.15594438326194505', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.132.114', '2019-06-02 10:50:33', 14, 0, '', '2019-06-02 10:50:33');
INSERT INTO `access_log` VALUES (20847, '65.46.15594442146154517', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:56:55', 1, 1002001015, '账号未登陆', '2019-06-02 10:56:55');
INSERT INTO `access_log` VALUES (20848, '65.54.15594442146164499', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:56:55', 0, 1002001015, '账号未登陆', '2019-06-02 10:56:55');
INSERT INTO `access_log` VALUES (20849, '65.52.15594442146184511', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:56:55', 1, 1002001015, '账号未登陆', '2019-06-02 10:56:55');
INSERT INTO `access_log` VALUES (20850, '65.53.15594442173034511', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:56:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 10:56:57');
INSERT INTO `access_log` VALUES (20851, '65.47.15594442337574531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:57:14', 69, 0, '', '2019-06-02 10:57:14');
INSERT INTO `access_log` VALUES (20852, '65.45.15594442340724531', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:57:14', 8, 0, '', '2019-06-02 10:57:14');
INSERT INTO `access_log` VALUES (20853, '65.51.15594442340784517', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:57:14', 7, 0, '', '2019-06-02 10:57:14');
INSERT INTO `access_log` VALUES (20854, '65.48.15594442340794527', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:57:14', 8, 0, '', '2019-06-02 10:57:14');
INSERT INTO `access_log` VALUES (20855, '62.89.15594442452004733', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:57:25', 14, 0, '', '2019-06-02 10:57:25');
INSERT INTO `access_log` VALUES (20856, '62.83.15594442508024729', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:57:31', 15, 0, '', '2019-06-02 10:57:31');
INSERT INTO `access_log` VALUES (20857, '64.77.15594442604194375', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:57:40', 83, 0, '', '2019-06-02 10:57:41');
INSERT INTO `access_log` VALUES (20858, '64.85.15594442604114379', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:57:40', 91, 0, '', '2019-06-02 10:57:41');
INSERT INTO `access_log` VALUES (20859, '64.78.15594442628084375', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:57:43', 10, 0, '', '2019-06-02 10:57:43');
INSERT INTO `access_log` VALUES (20860, '64.76.15594442628084361', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:57:43', 11, 0, '', '2019-06-02 10:57:43');
INSERT INTO `access_log` VALUES (20861, '64.84.15594442650524373', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:57:45', 8, 0, '', '2019-06-02 10:57:45');
INSERT INTO `access_log` VALUES (20862, '59.80.15594442769584849', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:57:57', 12, 0, '', '2019-06-02 10:57:57');
INSERT INTO `access_log` VALUES (20863, '65.53.15594442939634513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:58:14', 14, 0, '', '2019-06-02 10:58:14');
INSERT INTO `access_log` VALUES (20864, '65.49.15594442959214535', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.93.189.10', '2019-06-02 10:58:16', 0, 1002001015, '账号未登陆', '2019-06-02 10:58:16');
INSERT INTO `access_log` VALUES (20865, '65.47.15594442959304533', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.93.189.10', '2019-06-02 10:58:16', 1, 1002001015, '账号未登陆', '2019-06-02 10:58:16');
INSERT INTO `access_log` VALUES (20866, '65.51.15594442959414519', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.93.189.10', '2019-06-02 10:58:16', 0, 1002001015, '账号未登陆', '2019-06-02 10:58:16');
INSERT INTO `access_log` VALUES (20867, '65.48.15594443045764529', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.93.189.10', '2019-06-02 10:58:25', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 10:58:25');
INSERT INTO `access_log` VALUES (20868, '65.50.15594443094054531', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:58:29', 48, 0, '', '2019-06-02 10:58:29');
INSERT INTO `access_log` VALUES (20869, '65.54.15594443128084503', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.93.189.10', '2019-06-02 10:58:33', 183, 0, '', '2019-06-02 10:58:33');
INSERT INTO `access_log` VALUES (20870, '65.46.15594443133884521', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.93.189.10', '2019-06-02 10:58:33', 11, 0, '', '2019-06-02 10:58:33');
INSERT INTO `access_log` VALUES (20871, '65.52.15594443133904515', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.93.189.10', '2019-06-02 10:58:33', 16, 0, '', '2019-06-02 10:58:33');
INSERT INTO `access_log` VALUES (20872, '65.53.15594443133924515', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.93.189.10', '2019-06-02 10:58:33', 15, 0, '', '2019-06-02 10:58:33');
INSERT INTO `access_log` VALUES (20873, '65.47.15594443203114535', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:58:40', 19, 0, '', '2019-06-02 10:58:40');
INSERT INTO `access_log` VALUES (20874, '65.51.15594443219694521', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:58:42', 11, 0, '', '2019-06-02 10:58:42');
INSERT INTO `access_log` VALUES (20875, '65.45.15594443239364535', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:58:44', 9, 0, '', '2019-06-02 10:58:44');
INSERT INTO `access_log` VALUES (20876, '65.48.15594443268354531', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:58:47', 12, 0, '', '2019-06-02 10:58:47');
INSERT INTO `access_log` VALUES (20877, '59.78.15594443270194857', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:58:47', 11, 0, '', '2019-06-02 10:58:47');
INSERT INTO `access_log` VALUES (20878, '62.89.15594443317124735', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.93.189.10', '2019-06-02 10:58:52', 14, 0, '', '2019-06-02 10:58:52');
INSERT INTO `access_log` VALUES (20879, '66.53.15594443326313657', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:58:53', 12, 0, '', '2019-06-02 10:58:53');
INSERT INTO `access_log` VALUES (20880, '62.83.15594443372834731', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.93.189.10', '2019-06-02 10:58:57', 14, 0, '', '2019-06-02 10:58:57');
INSERT INTO `access_log` VALUES (20881, '64.85.15594443394894381', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.93.189.10', '2019-06-02 10:58:59', 10, 0, '', '2019-06-02 10:59:00');
INSERT INTO `access_log` VALUES (20882, '64.77.15594443395014377', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.93.189.10', '2019-06-02 10:59:00', 7, 0, '', '2019-06-02 10:59:00');
INSERT INTO `access_log` VALUES (20883, '59.72.15594443395224851', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:59:00', 16, 2001001000, '服务端发生异常', '2019-06-02 10:59:00');
INSERT INTO `access_log` VALUES (20884, '65.54.15594443418424505', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:59:02', 9, 0, '', '2019-06-02 10:59:02');
INSERT INTO `access_log` VALUES (20885, '65.46.15594443426434523', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:59:03', 17, 0, '', '2019-06-02 10:59:03');
INSERT INTO `access_log` VALUES (20886, '65.53.15594443439364517', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:59:04', 19, 0, '', '2019-06-02 10:59:04');
INSERT INTO `access_log` VALUES (20887, '59.77.15594443439974847', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:59:04', 13, 0, '', '2019-06-02 10:59:04');
INSERT INTO `access_log` VALUES (20888, '59.73.15594443476844859', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:59:08', 989, 0, '', '2019-06-02 10:59:09');
INSERT INTO `access_log` VALUES (20889, '59.80.15594443507584851', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:59:11', 12, 0, '', '2019-06-02 10:59:11');
INSERT INTO `access_log` VALUES (20890, '66.56.15594443593363653', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:59:19', 13, 0, '', '2019-06-02 10:59:19');
INSERT INTO `access_log` VALUES (20891, '66.50.15594443637583661', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:59:24', 12, 0, '', '2019-06-02 10:59:24');
INSERT INTO `access_log` VALUES (20892, '62.80.15594443648424741', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:59:25', 12, 0, '', '2019-06-02 10:59:25');
INSERT INTO `access_log` VALUES (20893, '62.86.15594443734744725', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 10:59:33', 13, 0, '', '2019-06-02 10:59:33');
INSERT INTO `access_log` VALUES (20894, '59.76.15594443823734849', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:59:42', 12, 0, '', '2019-06-02 10:59:42');
INSERT INTO `access_log` VALUES (20895, '59.74.15594443928594853', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 10:59:53', 12, 0, '', '2019-06-02 10:59:53');
INSERT INTO `access_log` VALUES (20896, '64.79.15594443995494365', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 11:00:00', 10, 0, '', '2019-06-02 11:00:00');
INSERT INTO `access_log` VALUES (20897, '64.82.15594443995504381', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.199.246.238', '2019-06-02 11:00:00', 11, 0, '', '2019-06-02 11:00:00');
INSERT INTO `access_log` VALUES (20898, '65.48.15594445726454535', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 11:02:53', 11, 0, '', '2019-06-02 11:02:53');
INSERT INTO `access_log` VALUES (20899, '65.50.15594445732524537', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 11:02:53', 10, 0, '', '2019-06-02 11:02:53');
INSERT INTO `access_log` VALUES (20900, '65.46.15594445752294527', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 11:02:55', 10, 0, '', '2019-06-02 11:02:55');
INSERT INTO `access_log` VALUES (20901, '65.53.15594445799244521', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 11:03:00', 151, 0, '', '2019-06-02 11:03:00');
INSERT INTO `access_log` VALUES (20902, '65.52.15594445847714521', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 11:03:05', 9, 0, '', '2019-06-02 11:03:05');
INSERT INTO `access_log` VALUES (20903, '59.75.15594447222554861', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16D57 main%2F1.0 baiduboxapp/11.9.0.12 (Baidu; P2 12.1.4)', '1.204.109.178', '2019-06-02 11:05:22', 13, 2001001000, '服务端发生异常', '2019-06-02 11:05:22');
INSERT INTO `access_log` VALUES (20904, '59.73.15594447228384865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16D57 main%2F1.0 baiduboxapp/11.9.0.12 (Baidu; P2 12.1.4)', '1.204.109.178', '2019-06-02 11:05:23', 3, 0, '', '2019-06-02 11:05:23');
INSERT INTO `access_log` VALUES (20905, '64.77.15594447279884383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16D57 main%2F1.0 baiduboxapp/11.9.0.12 (Baidu; P2 12.1.4)', '1.204.109.178', '2019-06-02 11:05:28', 187, 0, '', '2019-06-02 11:05:28');
INSERT INTO `access_log` VALUES (20906, '64.85.15594447283374387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16D57 main%2F1.0 baiduboxapp/11.9.0.12 (Baidu; P2 12.1.4)', '1.204.109.178', '2019-06-02 11:05:28', 2, 0, '', '2019-06-02 11:05:28');
INSERT INTO `access_log` VALUES (20907, '64.76.15594447300384369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16D57 main%2F1.0 baiduboxapp/11.9.0.12 (Baidu; P2 12.1.4)', '1.204.109.178', '2019-06-02 11:05:30', 3, 0, '', '2019-06-02 11:05:30');
INSERT INTO `access_log` VALUES (20908, '64.78.15594447305914383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16D57 main%2F1.0 baiduboxapp/11.9.0.12 (Baidu; P2 12.1.4)', '1.204.109.178', '2019-06-02 11:05:31', 2, 0, '', '2019-06-02 11:05:31');
INSERT INTO `access_log` VALUES (20909, '59.80.15594447316674857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16D57 main%2F1.0 baiduboxapp/11.9.0.12 (Baidu; P2 12.1.4)', '1.204.109.178', '2019-06-02 11:05:32', 3, 0, '', '2019-06-02 11:05:32');
INSERT INTO `access_log` VALUES (20910, '59.79.15594447316674861', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16D57 main%2F1.0 baiduboxapp/11.9.0.12 (Baidu; P2 12.1.4)', '1.204.109.178', '2019-06-02 11:05:32', 10, 2001001000, '服务端发生异常', '2019-06-02 11:05:32');
INSERT INTO `access_log` VALUES (20911, '59.76.15594447364324855', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16D57 main%2F1.0 baiduboxapp/11.9.0.12 (Baidu; P2 12.1.4)', '1.204.109.178', '2019-06-02 11:05:36', 2, 0, '', '2019-06-02 11:05:36');
INSERT INTO `access_log` VALUES (20912, '59.78.15594447364364865', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16D57 main%2F1.0 baiduboxapp/11.9.0.12 (Baidu; P2 12.1.4)', '1.204.109.178', '2019-06-02 11:05:36', 12, 2001001000, '服务端发生异常', '2019-06-02 11:05:36');
INSERT INTO `access_log` VALUES (20913, '59.74.15594447393944859', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16D57 main%2F1.0 baiduboxapp/11.9.0.12 (Baidu; P2 12.1.4)', '1.204.109.178', '2019-06-02 11:05:39', 3, 0, '', '2019-06-02 11:05:39');
INSERT INTO `access_log` VALUES (20914, '59.72.15594447393944859', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16D57 main%2F1.0 baiduboxapp/11.9.0.12 (Baidu; P2 12.1.4)', '1.204.109.178', '2019-06-02 11:05:39', 13, 2001001000, '服务端发生异常', '2019-06-02 11:05:39');
INSERT INTO `access_log` VALUES (20915, '64.83.15594447400974371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16D57 main%2F1.0 baiduboxapp/11.9.0.12 (Baidu; P2 12.1.4)', '1.204.109.178', '2019-06-02 11:05:40', 2, 0, '', '2019-06-02 11:05:40');
INSERT INTO `access_log` VALUES (20916, '64.82.15594447402514387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16D57 main%2F1.0 baiduboxapp/11.9.0.12 (Baidu; P2 12.1.4)', '1.204.109.178', '2019-06-02 11:05:40', 2, 0, '', '2019-06-02 11:05:40');
INSERT INTO `access_log` VALUES (20917, '59.73.15594447659704867', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '125.120.153.110', '2019-06-02 11:06:06', 3, 0, '', '2019-06-02 11:06:06');
INSERT INTO `access_log` VALUES (20918, '59.79.15594447659954863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '125.120.153.110', '2019-06-02 11:06:06', 14, 2001001000, '服务端发生异常', '2019-06-02 11:06:06');
INSERT INTO `access_log` VALUES (20919, '64.80.15594447763944371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '125.120.153.110', '2019-06-02 11:06:16', 3, 0, '', '2019-06-02 11:06:16');
INSERT INTO `access_log` VALUES (20920, '64.77.15594447765474385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '125.120.153.110', '2019-06-02 11:06:17', 2, 0, '', '2019-06-02 11:06:17');
INSERT INTO `access_log` VALUES (20921, '64.76.15594447867954371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '125.120.153.110', '2019-06-02 11:06:27', 3, 0, '', '2019-06-02 11:06:27');
INSERT INTO `access_log` VALUES (20922, '64.78.15594447870734385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '125.120.153.110', '2019-06-02 11:06:27', 2, 0, '', '2019-06-02 11:06:27');
INSERT INTO `access_log` VALUES (20923, '64.83.15594447986684373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '125.120.153.110', '2019-06-02 11:06:39', 2, 0, '', '2019-06-02 11:06:39');
INSERT INTO `access_log` VALUES (20924, '64.82.15594447988044389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '125.120.153.110', '2019-06-02 11:06:39', 2, 0, '', '2019-06-02 11:06:39');
INSERT INTO `access_log` VALUES (20925, '59.78.15594447991104867', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '125.120.153.110', '2019-06-02 11:06:39', 3, 0, '', '2019-06-02 11:06:39');
INSERT INTO `access_log` VALUES (20926, '59.76.15594447991414857', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '125.120.153.110', '2019-06-02 11:06:39', 13, 2001001000, '服务端发生异常', '2019-06-02 11:06:39');
INSERT INTO `access_log` VALUES (20927, '59.74.15594448226504861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:03', 3, 0, '', '2019-06-02 11:07:03');
INSERT INTO `access_log` VALUES (20928, '59.77.15594448226504857', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:03', 10, 2001001000, '服务端发生异常', '2019-06-02 11:07:03');
INSERT INTO `access_log` VALUES (20929, '65.46.15594448294084531', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '121.13.29.94', '2019-06-02 11:07:09', 1, 1002001015, '账号未登陆', '2019-06-02 11:07:09');
INSERT INTO `access_log` VALUES (20930, '65.53.15594448294144525', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '121.13.29.94', '2019-06-02 11:07:09', 0, 1002001015, '账号未登陆', '2019-06-02 11:07:09');
INSERT INTO `access_log` VALUES (20931, '65.52.15594448294204525', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '121.13.29.94', '2019-06-02 11:07:09', 0, 1002001015, '账号未登陆', '2019-06-02 11:07:09');
INSERT INTO `access_log` VALUES (20932, '65.49.15594448320874547', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '121.13.29.94', '2019-06-02 11:07:12', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 11:07:12');
INSERT INTO `access_log` VALUES (20933, '65.47.15594448369014545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '121.13.29.94', '2019-06-02 11:07:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 11:07:17');
INSERT INTO `access_log` VALUES (20934, '65.51.15594448383434531', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:18', 0, 1002001015, '账号未登陆', '2019-06-02 11:07:18');
INSERT INTO `access_log` VALUES (20935, '65.45.15594448383454545', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:18', 0, 1002001015, '账号未登陆', '2019-06-02 11:07:18');
INSERT INTO `access_log` VALUES (20936, '65.48.15594448383494541', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:18', 0, 1002001015, '账号未登陆', '2019-06-02 11:07:18');
INSERT INTO `access_log` VALUES (20937, '65.50.15594448404414543', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:20', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 11:07:20');
INSERT INTO `access_log` VALUES (20938, '65.53.15594448537504527', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:34', 91, 0, '', '2019-06-02 11:07:34');
INSERT INTO `access_log` VALUES (20939, '65.52.15594448540734527', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:34', 9, 0, '', '2019-06-02 11:07:34');
INSERT INTO `access_log` VALUES (20940, '65.46.15594448540754533', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:34', 18, 0, '', '2019-06-02 11:07:34');
INSERT INTO `access_log` VALUES (20941, '65.49.15594448540784549', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:34', 18, 0, '', '2019-06-02 11:07:34');
INSERT INTO `access_log` VALUES (20942, '62.82.15594448606094751', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:41', 13, 0, '', '2019-06-02 11:07:41');
INSERT INTO `access_log` VALUES (20943, '62.88.15594448633044749', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:43', 17, 0, '', '2019-06-02 11:07:43');
INSERT INTO `access_log` VALUES (20944, '64.76.15594448652064373', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:45', 8, 0, '', '2019-06-02 11:07:45');
INSERT INTO `access_log` VALUES (20945, '64.85.15594448652034391', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:45', 12, 0, '', '2019-06-02 11:07:45');
INSERT INTO `access_log` VALUES (20946, '64.84.15594448674784385', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:47', 9, 0, '', '2019-06-02 11:07:47');
INSERT INTO `access_log` VALUES (20947, '64.78.15594448674774387', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:47', 12, 0, '', '2019-06-02 11:07:47');
INSERT INTO `access_log` VALUES (20948, '66.52.15594448724573665', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:52', 14, 0, '', '2019-06-02 11:07:52');
INSERT INTO `access_log` VALUES (20949, '59.71.15594448742384869', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:07:54', 11, 0, '', '2019-06-02 11:07:54');
INSERT INTO `access_log` VALUES (20950, '59.78.15594448796234869', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:08:00', 20, 2001001000, '服务端发生异常', '2019-06-02 11:08:00');
INSERT INTO `access_log` VALUES (20951, '59.72.15594448866494863', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:08:07', 70, 0, '', '2019-06-02 11:08:07');
INSERT INTO `access_log` VALUES (20952, '64.79.15594448909654375', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:08:11', 10, 0, '', '2019-06-02 11:08:11');
INSERT INTO `access_log` VALUES (20953, '64.81.15594448942884377', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:08:14', 10, 0, '', '2019-06-02 11:08:14');
INSERT INTO `access_log` VALUES (20954, '59.74.15594448983874863', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.204.109.178', '2019-06-02 11:08:18', 14, 0, '', '2019-06-02 11:08:18');
INSERT INTO `access_log` VALUES (20955, '59.72.15594451597654867', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.69', '2019-06-02 11:12:40', 4, 0, '', '2019-06-02 11:12:40');
INSERT INTO `access_log` VALUES (20956, '59.74.15594451597734867', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.69', '2019-06-02 11:12:40', 24, 2001001000, '服务端发生异常', '2019-06-02 11:12:40');
INSERT INTO `access_log` VALUES (20957, '59.75.15594451729054871', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.66.88', '2019-06-02 11:12:53', 3, 0, '', '2019-06-02 11:12:53');
INSERT INTO `access_log` VALUES (20958, '59.73.15594451729134875', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.66.88', '2019-06-02 11:12:53', 13, 2001001000, '服务端发生异常', '2019-06-02 11:12:53');
INSERT INTO `access_log` VALUES (20959, '65.45.15594451743964551', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.69', '2019-06-02 11:12:54', 1, 1002001015, '账号未登陆', '2019-06-02 11:12:54');
INSERT INTO `access_log` VALUES (20960, '65.48.15594451743994547', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.69', '2019-06-02 11:12:54', 1, 1002001015, '账号未登陆', '2019-06-02 11:12:54');
INSERT INTO `access_log` VALUES (20961, '65.50.15594451744074549', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.69', '2019-06-02 11:12:54', 1, 1002001015, '账号未登陆', '2019-06-02 11:12:54');
INSERT INTO `access_log` VALUES (20962, '59.80.15594451791614867', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.66.88', '2019-06-02 11:12:59', 2, 0, '', '2019-06-02 11:12:59');
INSERT INTO `access_log` VALUES (20963, '59.79.15594451791614871', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.66.88', '2019-06-02 11:12:59', 12, 2001001000, '服务端发生异常', '2019-06-02 11:12:59');
INSERT INTO `access_log` VALUES (20964, '65.54.15594451861574521', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.66.88', '2019-06-02 11:13:06', 0, 1002001015, '账号未登陆', '2019-06-02 11:13:06');
INSERT INTO `access_log` VALUES (20965, '65.53.15594451862014533', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.66.88', '2019-06-02 11:13:06', 0, 1002001015, '账号未登陆', '2019-06-02 11:13:06');
INSERT INTO `access_log` VALUES (20966, '65.46.15594451862174539', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.66.88', '2019-06-02 11:13:06', 0, 1002001015, '账号未登陆', '2019-06-02 11:13:06');
INSERT INTO `access_log` VALUES (20967, '65.49.15594451883644555', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.66.88', '2019-06-02 11:13:08', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 11:13:08');
INSERT INTO `access_log` VALUES (20968, '65.47.15594451907904553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.69', '2019-06-02 11:13:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 11:13:11');
INSERT INTO `access_log` VALUES (20969, '65.51.15594451914124539', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.66.88', '2019-06-02 11:13:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 11:13:11');
INSERT INTO `access_log` VALUES (20970, '65.45.15594451918514553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.24.66.88', '2019-06-02 11:13:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 11:13:12');
INSERT INTO `access_log` VALUES (20971, '65.50.15594452079094551', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.69', '2019-06-02 11:13:28', 100, 0, '', '2019-06-02 11:13:28');
INSERT INTO `access_log` VALUES (20972, '65.46.15594452083794541', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.69', '2019-06-02 11:13:28', 10, 0, '', '2019-06-02 11:13:28');
INSERT INTO `access_log` VALUES (20973, '65.54.15594452083864523', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.69', '2019-06-02 11:13:28', 21, 0, '', '2019-06-02 11:13:28');
INSERT INTO `access_log` VALUES (20974, '65.53.15594452084034535', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.69', '2019-06-02 11:13:28', 9, 0, '', '2019-06-02 11:13:28');
INSERT INTO `access_log` VALUES (20975, '62.81.15594452132344731', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.69', '2019-06-02 11:13:33', 13, 0, '', '2019-06-02 11:13:33');
INSERT INTO `access_log` VALUES (20976, '59.74.15594452305884869', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.147.98.69', '2019-06-02 11:13:51', 21, 2001001000, '服务端发生异常', '2019-06-02 11:13:51');
INSERT INTO `access_log` VALUES (20977, '59.76.15594456478734871', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.104.1.108', '2019-06-02 11:20:48', 3, 0, '', '2019-06-02 11:20:48');
INSERT INTO `access_log` VALUES (20978, '59.72.15594456478734875', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.104.1.108', '2019-06-02 11:20:48', 13, 2001001000, '服务端发生异常', '2019-06-02 11:20:48');
INSERT INTO `access_log` VALUES (20979, '65.54.15594457941654531', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 11:23:14', 4, 1002001012, '访问令牌已过期', '2019-06-02 11:23:14');
INSERT INTO `access_log` VALUES (20980, '65.49.15594457953574565', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.64.10', '2019-06-02 11:23:15', 1, 1002001015, '账号未登陆', '2019-06-02 11:23:15');
INSERT INTO `access_log` VALUES (20981, '65.52.15594457953584543', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.64.10', '2019-06-02 11:23:15', 0, 1002001015, '账号未登陆', '2019-06-02 11:23:15');
INSERT INTO `access_log` VALUES (20982, '65.47.15594457953644563', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.64.10', '2019-06-02 11:23:15', 0, 1002001015, '账号未登陆', '2019-06-02 11:23:15');
INSERT INTO `access_log` VALUES (20983, '65.51.15594457960704549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.105.3', '2019-06-02 11:23:16', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 11:23:16');
INSERT INTO `access_log` VALUES (20984, '65.45.15594457985684563', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.64.10', '2019-06-02 11:23:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 11:23:19');
INSERT INTO `access_log` VALUES (20985, '65.50.15594458045234561', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.64.10', '2019-06-02 11:23:25', 98, 0, '', '2019-06-02 11:23:25');
INSERT INTO `access_log` VALUES (20986, '65.53.15594458048914545', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.64.10', '2019-06-02 11:23:25', 10, 0, '', '2019-06-02 11:23:25');
INSERT INTO `access_log` VALUES (20987, '65.54.15594458048944533', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.64.10', '2019-06-02 11:23:25', 9, 0, '', '2019-06-02 11:23:25');
INSERT INTO `access_log` VALUES (20988, '65.46.15594458048934551', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.64.10', '2019-06-02 11:23:25', 11, 0, '', '2019-06-02 11:23:25');
INSERT INTO `access_log` VALUES (20989, '64.76.15594458080044387', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.64.10', '2019-06-02 11:23:28', 10, 0, '', '2019-06-02 11:23:28');
INSERT INTO `access_log` VALUES (20990, '64.77.15594458080024401', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.64.10', '2019-06-02 11:23:28', 12, 0, '', '2019-06-02 11:23:28');
INSERT INTO `access_log` VALUES (20991, '66.56.15594458113803673', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.64.10', '2019-06-02 11:23:31', 14, 0, '', '2019-06-02 11:23:31');
INSERT INTO `access_log` VALUES (20992, '65.49.15594458245014567', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.64.10', '2019-06-02 11:23:45', 10, 0, '', '2019-06-02 11:23:45');
INSERT INTO `access_log` VALUES (20993, '65.47.15594458245024565', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.64.10', '2019-06-02 11:23:45', 10, 0, '', '2019-06-02 11:23:45');
INSERT INTO `access_log` VALUES (20994, '65.51.15594458245074551', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.64.10', '2019-06-02 11:23:45', 10, 0, '', '2019-06-02 11:23:45');
INSERT INTO `access_log` VALUES (20995, '65.46.15594461833874557', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:29:43', 0, 1002001015, '账号未登陆', '2019-06-02 11:29:43');
INSERT INTO `access_log` VALUES (20996, '65.54.15594461833874539', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:29:43', 0, 1002001015, '账号未登陆', '2019-06-02 11:29:43');
INSERT INTO `access_log` VALUES (20997, '65.52.15594461833914551', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:29:43', 1, 1002001015, '账号未登陆', '2019-06-02 11:29:43');
INSERT INTO `access_log` VALUES (20998, '65.51.15594461860204557', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:29:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 11:29:46');
INSERT INTO `access_log` VALUES (20999, '65.49.15594461953714573', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:29:55', 72, 0, '', '2019-06-02 11:29:55');
INSERT INTO `access_log` VALUES (21000, '65.45.15594461957074571', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:29:56', 10, 0, '', '2019-06-02 11:29:56');
INSERT INTO `access_log` VALUES (21001, '65.48.15594461957094567', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:29:56', 9, 0, '', '2019-06-02 11:29:56');
INSERT INTO `access_log` VALUES (21002, '65.50.15594461957144569', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:29:56', 9, 0, '', '2019-06-02 11:29:56');
INSERT INTO `access_log` VALUES (21003, '62.84.15594462299064747', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:30:30', 14, 0, '', '2019-06-02 11:30:30');
INSERT INTO `access_log` VALUES (21004, '62.85.15594462389914763', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:30:39', 15, 0, '', '2019-06-02 11:30:39');
INSERT INTO `access_log` VALUES (21005, '64.77.15594462499474407', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:30:50', 11, 0, '', '2019-06-02 11:30:50');
INSERT INTO `access_log` VALUES (21006, '64.85.15594462501724411', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:30:50', 10, 0, '', '2019-06-02 11:30:50');
INSERT INTO `access_log` VALUES (21007, '64.83.15594462592274395', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:30:59', 9, 0, '', '2019-06-02 11:30:59');
INSERT INTO `access_log` VALUES (21008, '64.78.15594462592254407', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:30:59', 13, 0, '', '2019-06-02 11:30:59');
INSERT INTO `access_log` VALUES (21009, '64.79.15594462656104395', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:31:06', 10, 0, '', '2019-06-02 11:31:06');
INSERT INTO `access_log` VALUES (21010, '64.81.15594462662784397', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:31:06', 11, 0, '', '2019-06-02 11:31:06');
INSERT INTO `access_log` VALUES (21011, '64.80.15594462668444395', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:31:07', 11, 0, '', '2019-06-02 11:31:07');
INSERT INTO `access_log` VALUES (21012, '64.77.15594462684054409', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:31:08', 10, 0, '', '2019-06-02 11:31:08');
INSERT INTO `access_log` VALUES (21013, '64.85.15594462684074413', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:31:08', 9, 0, '', '2019-06-02 11:31:08');
INSERT INTO `access_log` VALUES (21014, '64.76.15594462684054395', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:31:08', 15, 0, '', '2019-06-02 11:31:08');
INSERT INTO `access_log` VALUES (21015, '59.75.15594462793564887', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:31:19', 14, 0, '', '2019-06-02 11:31:19');
INSERT INTO `access_log` VALUES (21016, '65.47.15594462809014573', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:31:21', 18, 0, '', '2019-06-02 11:31:21');
INSERT INTO `access_log` VALUES (21017, '65.45.15594462891474573', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:31:29', 12, 0, '', '2019-06-02 11:31:29');
INSERT INTO `access_log` VALUES (21018, '65.48.15594462940034569', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:31:34', 11, 0, '', '2019-06-02 11:31:34');
INSERT INTO `access_log` VALUES (21019, '65.50.15594462987454571', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:31:39', 12, 0, '', '2019-06-02 11:31:39');
INSERT INTO `access_log` VALUES (21020, '65.46.15594463064194561', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:31:46', 8, 0, '', '2019-06-02 11:31:46');
INSERT INTO `access_log` VALUES (21021, '65.54.15594463190194543', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:31:59', 14, 0, '', '2019-06-02 11:31:59');
INSERT INTO `access_log` VALUES (21022, '59.78.15594463317194891', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:32:12', 12, 0, '', '2019-06-02 11:32:12');
INSERT INTO `access_log` VALUES (21023, '59.76.15594463322584881', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:12', 13, 2001001000, '服务端发生异常', '2019-06-02 11:32:12');
INSERT INTO `access_log` VALUES (21024, '59.72.15594463322574885', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:12', 317, 0, '', '2019-06-02 11:32:13');
INSERT INTO `access_log` VALUES (21025, '64.79.15594463340134397', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:32:14', 196, 0, '', '2019-06-02 11:32:14');
INSERT INTO `access_log` VALUES (21026, '59.74.15594463368084885', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/update_card', 'id=1&title=优惠劵A&description=一个有味道的哈哈哈哈&quota=10&total=100&rangeType=10', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:32:17', 8, 1002002009, NULL, '2019-06-02 11:32:17');
INSERT INTO `access_log` VALUES (21027, '64.81.15594463389014399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:19', 2, 0, '', '2019-06-02 11:32:19');
INSERT INTO `access_log` VALUES (21028, '64.80.15594463390084397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:19', 2, 0, '', '2019-06-02 11:32:19');
INSERT INTO `access_log` VALUES (21029, '64.85.15594463431634415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:23', 3, 0, '', '2019-06-02 11:32:23');
INSERT INTO `access_log` VALUES (21030, '64.76.15594463432714397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:23', 2, 0, '', '2019-06-02 11:32:23');
INSERT INTO `access_log` VALUES (21031, '64.84.15594463485094409', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:32:29', 8, 0, '', '2019-06-02 11:32:29');
INSERT INTO `access_log` VALUES (21032, '64.83.15594463490004399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:29', 2, 0, '', '2019-06-02 11:32:29');
INSERT INTO `access_log` VALUES (21033, '64.78.15594463491204411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:29', 2, 0, '', '2019-06-02 11:32:29');
INSERT INTO `access_log` VALUES (21034, '64.82.15594463503374415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:30', 2, 0, '', '2019-06-02 11:32:30');
INSERT INTO `access_log` VALUES (21035, '64.79.15594463510714399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:31', 322, 0, '', '2019-06-02 11:32:31');
INSERT INTO `access_log` VALUES (21036, '59.73.15594463518694893', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:32', 3, 0, '', '2019-06-02 11:32:32');
INSERT INTO `access_log` VALUES (21037, '59.75.15594463518704889', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:32', 13, 2001001000, '服务端发生异常', '2019-06-02 11:32:32');
INSERT INTO `access_log` VALUES (21038, '64.81.15594463542174401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:34', 2, 0, '', '2019-06-02 11:32:34');
INSERT INTO `access_log` VALUES (21039, '64.80.15594463543354399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:34', 2, 0, '', '2019-06-02 11:32:34');
INSERT INTO `access_log` VALUES (21040, '59.79.15594463562394889', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:36', 3, 0, '', '2019-06-02 11:32:36');
INSERT INTO `access_log` VALUES (21041, '59.71.15594463562404893', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:36', 12, 2001001000, '服务端发生异常', '2019-06-02 11:32:36');
INSERT INTO `access_log` VALUES (21042, '64.85.15594463628664417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:43', 2, 0, '', '2019-06-02 11:32:43');
INSERT INTO `access_log` VALUES (21043, '64.76.15594463629634399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.51.24.34', '2019-06-02 11:32:43', 2, 0, '', '2019-06-02 11:32:43');
INSERT INTO `access_log` VALUES (21044, '59.72.15594463916484887', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:33:12', 2, 0, '', '2019-06-02 11:33:12');
INSERT INTO `access_log` VALUES (21045, '59.74.15594463916494887', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.11.3.33', '2019-06-02 11:33:12', 14, 2001001000, '服务端发生异常', '2019-06-02 11:33:12');
INSERT INTO `access_log` VALUES (21046, '64.82.15594464012004417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:21', 4, 0, '', '2019-06-02 11:33:21');
INSERT INTO `access_log` VALUES (21047, '64.79.15594464013274401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:21', 3, 0, '', '2019-06-02 11:33:21');
INSERT INTO `access_log` VALUES (21048, '64.81.15594464025894403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:23', 3, 0, '', '2019-06-02 11:33:23');
INSERT INTO `access_log` VALUES (21049, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:23', 39, 0, '', '2019-06-02 11:33:23');
INSERT INTO `access_log` VALUES (21050, '64.80.15594464035024401', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:24', 14, 0, '', '2019-06-02 11:33:24');
INSERT INTO `access_log` VALUES (21051, '64.77.15594464150344415', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:35', 7, 0, '', '2019-06-02 11:33:35');
INSERT INTO `access_log` VALUES (21052, '64.76.15594464156774401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:36', 3, 0, '', '2019-06-02 11:33:36');
INSERT INTO `access_log` VALUES (21053, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:36', 6, 0, '', '2019-06-02 11:33:36');
INSERT INTO `access_log` VALUES (21054, '64.84.15594464165684413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:37', 2, 0, '', '2019-06-02 11:33:37');
INSERT INTO `access_log` VALUES (21055, '64.83.15594464167194403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:37', 2, 0, '', '2019-06-02 11:33:37');
INSERT INTO `access_log` VALUES (21056, '59.73.15594464180274895', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:38', 3, 0, '', '2019-06-02 11:33:38');
INSERT INTO `access_log` VALUES (21057, '59.80.15594464180274887', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:38', 15, 2001001000, '服务端发生异常', '2019-06-02 11:33:38');
INSERT INTO `access_log` VALUES (21058, '59.79.15594464219414891', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:42', 3, 0, '', '2019-06-02 11:33:42');
INSERT INTO `access_log` VALUES (21059, '59.71.15594464219414895', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:42', 19, 2001001000, '服务端发生异常', '2019-06-02 11:33:42');
INSERT INTO `access_log` VALUES (21060, '59.76.15594464319054885', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:52', 3, 0, '', '2019-06-02 11:33:52');
INSERT INTO `access_log` VALUES (21061, '59.72.15594464319054889', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:33:52', 12, 2001001000, '服务端发生异常', '2019-06-02 11:33:52');
INSERT INTO `access_log` VALUES (21062, '64.76.15594472706444413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:47:51', 3, 0, '', '2019-06-02 11:47:51');
INSERT INTO `access_log` VALUES (21063, '64.84.15594472707834425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '171.11.3.33', '2019-06-02 11:47:51', 2, 0, '', '2019-06-02 11:47:51');
INSERT INTO `access_log` VALUES (21064, '65.46.15594473209744575', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:48:41', 1, 1002001015, '账号未登陆', '2019-06-02 11:48:41');
INSERT INTO `access_log` VALUES (21065, '65.52.15594473209744569', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:48:41', 1, 1002001015, '账号未登陆', '2019-06-02 11:48:41');
INSERT INTO `access_log` VALUES (21066, '65.54.15594473209964557', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:48:41', 0, 1002001015, '账号未登陆', '2019-06-02 11:48:41');
INSERT INTO `access_log` VALUES (21067, '65.51.15594473278164575', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:48:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 11:48:48');
INSERT INTO `access_log` VALUES (21068, '65.49.15594473393364591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:48:59', 217, 0, '', '2019-06-02 11:49:00');
INSERT INTO `access_log` VALUES (21069, '65.48.15594473404924585', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:49:00', 10, 0, '', '2019-06-02 11:49:01');
INSERT INTO `access_log` VALUES (21070, '65.45.15594473404914589', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:49:00', 11, 0, '', '2019-06-02 11:49:01');
INSERT INTO `access_log` VALUES (21071, '65.50.15594473405034587', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:49:01', 9, 0, '', '2019-06-02 11:49:01');
INSERT INTO `access_log` VALUES (21072, '62.86.15594473474704767', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:49:07', 13, 0, '', '2019-06-02 11:49:07');
INSERT INTO `access_log` VALUES (21073, '64.77.15594473556674429', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:49:16', 13, 0, '', '2019-06-02 11:49:16');
INSERT INTO `access_log` VALUES (21074, '64.80.15594473556664415', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:49:16', 14, 0, '', '2019-06-02 11:49:16');
INSERT INTO `access_log` VALUES (21075, '64.76.15594473687384415', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=11', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:49:29', 7, 1002002009, NULL, '2019-06-02 11:49:29');
INSERT INTO `access_log` VALUES (21076, '66.53.15594474114053699', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:50:11', 15, 0, '', '2019-06-02 11:50:11');
INSERT INTO `access_log` VALUES (21077, '59.79.15594474146114905', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:50:15', 13, 0, '', '2019-06-02 11:50:15');
INSERT INTO `access_log` VALUES (21078, '59.78.15594474254854909', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:50:25', 21, 2001001000, '服务端发生异常', '2019-06-02 11:50:26');
INSERT INTO `access_log` VALUES (21079, '59.72.15594474354824903', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:50:35', 13, 0, '', '2019-06-02 11:50:35');
INSERT INTO `access_log` VALUES (21080, '64.81.15594474370524419', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:50:37', 10, 0, '', '2019-06-02 11:50:37');
INSERT INTO `access_log` VALUES (21081, '64.77.15594474392934431', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:50:39', 9, 0, '', '2019-06-02 11:50:39');
INSERT INTO `access_log` VALUES (21082, '64.80.15594474406124417', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:50:41', 238, 0, '', '2019-06-02 11:50:41');
INSERT INTO `access_log` VALUES (21083, '64.85.15594474440924435', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:50:44', 10, 0, '', '2019-06-02 11:50:44');
INSERT INTO `access_log` VALUES (21084, '59.74.15594474485664903', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:50:49', 11, 0, '', '2019-06-02 11:50:49');
INSERT INTO `access_log` VALUES (21085, '59.75.15594474504114907', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:50:50', 11, 0, '', '2019-06-02 11:50:50');
INSERT INTO `access_log` VALUES (21086, '59.80.15594474511114903', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:50:51', 11, 0, '', '2019-06-02 11:50:51');
INSERT INTO `access_log` VALUES (21087, '59.73.15594474557624911', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:50:56', 232, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 11:50:56');
INSERT INTO `access_log` VALUES (21088, '59.79.15594474572734907', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:50:57', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 11:50:57');
INSERT INTO `access_log` VALUES (21089, '65.48.15594474622134587', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:51:02', 19, 0, '', '2019-06-02 11:51:02');
INSERT INTO `access_log` VALUES (21090, '65.45.15594474655574591', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:51:06', 11, 0, '', '2019-06-02 11:51:06');
INSERT INTO `access_log` VALUES (21091, '65.53.15594474678024573', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:51:08', 11, 0, '', '2019-06-02 11:51:08');
INSERT INTO `access_log` VALUES (21092, '65.52.15594474738554573', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:51:14', 11, 0, '', '2019-06-02 11:51:14');
INSERT INTO `access_log` VALUES (21093, '65.54.15594474759714561', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:51:16', 11, 0, '', '2019-06-02 11:51:16');
INSERT INTO `access_log` VALUES (21094, '65.51.15594474824514579', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:51:22', 8, 0, '', '2019-06-02 11:51:22');
INSERT INTO `access_log` VALUES (21095, '65.49.15594474952364595', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.22.94', '2019-06-02 11:51:35', 279, 0, '', '2019-06-02 11:51:36');
INSERT INTO `access_log` VALUES (21096, '65.51.15594477516224583', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '121.13.29.94', '2019-06-02 11:55:52', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 11:55:52');
INSERT INTO `access_log` VALUES (21097, '65.47.15594479452104601', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.3.56.136', '2019-06-02 11:59:05', 1, 1002001015, '账号未登陆', '2019-06-02 11:59:05');
INSERT INTO `access_log` VALUES (21098, '65.50.15594479452344595', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.3.56.136', '2019-06-02 11:59:05', 0, 1002001015, '账号未登陆', '2019-06-02 11:59:05');
INSERT INTO `access_log` VALUES (21099, '65.48.15594479453984597', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.3.56.136', '2019-06-02 11:59:05', 1, 1002001015, '账号未登陆', '2019-06-02 11:59:05');
INSERT INTO `access_log` VALUES (21100, '65.45.15594479495054601', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.3.56.136', '2019-06-02 11:59:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 11:59:10');
INSERT INTO `access_log` VALUES (21101, '65.52.15594479566034585', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.3.56.136', '2019-06-02 11:59:17', 145, 0, '', '2019-06-02 11:59:17');
INSERT INTO `access_log` VALUES (21102, '65.53.15594479572174581', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.3.56.136', '2019-06-02 11:59:17', 9, 0, '', '2019-06-02 11:59:17');
INSERT INTO `access_log` VALUES (21103, '65.46.15594479572224587', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.3.56.136', '2019-06-02 11:59:17', 8, 0, '', '2019-06-02 11:59:17');
INSERT INTO `access_log` VALUES (21104, '65.54.15594479572414569', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.3.56.136', '2019-06-02 11:59:17', 9, 0, '', '2019-06-02 11:59:17');
INSERT INTO `access_log` VALUES (21105, '64.79.15594479703014425', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.3.56.136', '2019-06-02 11:59:30', 13, 0, '', '2019-06-02 11:59:30');
INSERT INTO `access_log` VALUES (21106, '64.81.15594479703214427', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.3.56.136', '2019-06-02 11:59:30', 9, 0, '', '2019-06-02 11:59:30');
INSERT INTO `access_log` VALUES (21107, '66.52.15594479877873707', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.3.56.136', '2019-06-02 11:59:48', 118, 0, '', '2019-06-02 11:59:48');
INSERT INTO `access_log` VALUES (21108, '59.75.15594479925704915', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.3.56.136', '2019-06-02 11:59:53', 534, 0, '', '2019-06-02 11:59:53');
INSERT INTO `access_log` VALUES (21109, '65.47.15594482657984607', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:04:26', 1, 1002001015, '账号未登陆', '2019-06-02 12:04:26');
INSERT INTO `access_log` VALUES (21110, '65.50.15594482658074601', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:04:26', 0, 1002001015, '账号未登陆', '2019-06-02 12:04:26');
INSERT INTO `access_log` VALUES (21111, '65.48.15594482658214603', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:04:26', 1, 1002001015, '账号未登陆', '2019-06-02 12:04:26');
INSERT INTO `access_log` VALUES (21112, '65.45.15594482797344607', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:04:40', 67, 0, '', '2019-06-02 12:04:40');
INSERT INTO `access_log` VALUES (21113, '65.53.15594482802524587', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:04:40', 7, 0, '', '2019-06-02 12:04:40');
INSERT INTO `access_log` VALUES (21114, '65.52.15594482802494591', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:04:40', 9, 0, '', '2019-06-02 12:04:40');
INSERT INTO `access_log` VALUES (21115, '65.46.15594482802624593', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:04:40', 8, 0, '', '2019-06-02 12:04:40');
INSERT INTO `access_log` VALUES (21116, '62.88.15594482920154797', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:04:52', 13, 0, '', '2019-06-02 12:04:52');
INSERT INTO `access_log` VALUES (21117, '62.80.15594482970494797', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:04:57', 13, 0, '', '2019-06-02 12:04:57');
INSERT INTO `access_log` VALUES (21118, '64.84.15594483108994441', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:05:11', 11, 0, '', '2019-06-02 12:05:11');
INSERT INTO `access_log` VALUES (21119, '64.76.15594483108984429', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:05:11', 12, 0, '', '2019-06-02 12:05:11');
INSERT INTO `access_log` VALUES (21120, '64.83.15594483149494431', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:05:15', 12, 0, '', '2019-06-02 12:05:15');
INSERT INTO `access_log` VALUES (21121, '64.78.15594483149804443', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:05:15', 8, 0, '', '2019-06-02 12:05:15');
INSERT INTO `access_log` VALUES (21122, '64.79.15594483212194431', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:05:21', 10, 0, '', '2019-06-02 12:05:21');
INSERT INTO `access_log` VALUES (21123, '59.79.15594483339864919', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:05:34', 12, 0, '', '2019-06-02 12:05:34');
INSERT INTO `access_log` VALUES (21124, '59.78.15594483401054923', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:05:40', 12, 0, '', '2019-06-02 12:05:40');
INSERT INTO `access_log` VALUES (21125, '65.50.15594483438344603', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:05:44', 20, 0, '', '2019-06-02 12:05:44');
INSERT INTO `access_log` VALUES (21126, '65.51.15594483449594595', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:05:45', 10, 0, '', '2019-06-02 12:05:45');
INSERT INTO `access_log` VALUES (21127, '65.45.15594483464034609', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:05:46', 10, 0, '', '2019-06-02 12:05:46');
INSERT INTO `access_log` VALUES (21128, '65.53.15594483475494589', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.96.47.219', '2019-06-02 12:05:48', 14, 0, '', '2019-06-02 12:05:48');
INSERT INTO `access_log` VALUES (21129, '59.79.15594491959194931', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:19:56', 4, 0, '', '2019-06-02 12:19:56');
INSERT INTO `access_log` VALUES (21130, '59.71.15594491959284935', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:19:56', 13, 2001001000, '服务端发生异常', '2019-06-02 12:19:56');
INSERT INTO `access_log` VALUES (21131, '65.47.15594492020784621', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:02', 0, 1002001015, '账号未登陆', '2019-06-02 12:20:02');
INSERT INTO `access_log` VALUES (21132, '65.51.15594492020794607', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:02', 0, 1002001015, '账号未登陆', '2019-06-02 12:20:02');
INSERT INTO `access_log` VALUES (21133, '65.45.15594492020794619', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:02', 1, 1002001015, '账号未登陆', '2019-06-02 12:20:02');
INSERT INTO `access_log` VALUES (21134, '64.79.15594492171484443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:17', 693, 0, '', '2019-06-02 12:20:18');
INSERT INTO `access_log` VALUES (21135, '64.81.15594492182694445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:18', 2, 0, '', '2019-06-02 12:20:18');
INSERT INTO `access_log` VALUES (21136, '64.80.15594492226994443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:23', 3, 0, '', '2019-06-02 12:20:23');
INSERT INTO `access_log` VALUES (21137, '64.85.15594492228294461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:23', 2, 0, '', '2019-06-02 12:20:23');
INSERT INTO `access_log` VALUES (21138, '64.84.15594492238344455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:24', 2, 0, '', '2019-06-02 12:20:24');
INSERT INTO `access_log` VALUES (21139, '64.76.15594492244654443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:24', 2, 0, '', '2019-06-02 12:20:24');
INSERT INTO `access_log` VALUES (21140, '59.72.15594492255824929', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:26', 2, 0, '', '2019-06-02 12:20:26');
INSERT INTO `access_log` VALUES (21141, '59.74.15594492257454929', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:26', 10, 2001001000, '服务端发生异常', '2019-06-02 12:20:26');
INSERT INTO `access_log` VALUES (21142, '65.46.15594492333874611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 12:20:33');
INSERT INTO `access_log` VALUES (21143, '65.49.15594492440944627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:44', 62, 0, '', '2019-06-02 12:20:44');
INSERT INTO `access_log` VALUES (21144, '65.48.15594492444834621', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:44', 27, 0, '', '2019-06-02 12:20:45');
INSERT INTO `access_log` VALUES (21145, '65.50.15594492444974615', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:44', 18, 0, '', '2019-06-02 12:20:45');
INSERT INTO `access_log` VALUES (21146, '65.45.15594492445034621', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:45', 13, 0, '', '2019-06-02 12:20:45');
INSERT INTO `access_log` VALUES (21147, '65.51.15594492451534609', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:20:45', 1, 1002001015, '账号未登陆', '2019-06-02 12:20:45');
INSERT INTO `access_log` VALUES (21148, '65.47.15594492451604623', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:20:45', 0, 1002001015, '账号未登陆', '2019-06-02 12:20:45');
INSERT INTO `access_log` VALUES (21149, '65.52.15594492451714607', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:20:45', 0, 1002001015, '账号未登陆', '2019-06-02 12:20:45');
INSERT INTO `access_log` VALUES (21150, '65.53.15594492479644603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:20:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 12:20:48');
INSERT INTO `access_log` VALUES (21151, '62.83.15594492533404801', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:20:53', 11, 0, '', '2019-06-02 12:20:53');
INSERT INTO `access_log` VALUES (21152, '65.54.15594492556954595', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:20:56', 77, 0, '', '2019-06-02 12:20:56');
INSERT INTO `access_log` VALUES (21153, '65.49.15594492560104629', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:20:56', 155, 0, '', '2019-06-02 12:20:56');
INSERT INTO `access_log` VALUES (21154, '65.50.15594492560144617', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:20:56', 151, 0, '', '2019-06-02 12:20:56');
INSERT INTO `access_log` VALUES (21155, '65.45.15594492560174623', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:20:56', 148, 0, '', '2019-06-02 12:20:56');
INSERT INTO `access_log` VALUES (21156, '64.82.15594492612574461', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:21:01', 11, 0, '', '2019-06-02 12:21:01');
INSERT INTO `access_log` VALUES (21157, '64.79.15594492612694445', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:21:01', 9, 0, '', '2019-06-02 12:21:01');
INSERT INTO `access_log` VALUES (21158, '62.82.15594492623264813', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:21:02', 12, 0, '', '2019-06-02 12:21:02');
INSERT INTO `access_log` VALUES (21159, '66.57.15594492645923725', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:21:05', 13, 0, '', '2019-06-02 12:21:05');
INSERT INTO `access_log` VALUES (21160, '59.73.15594492681754937', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:21:08', 11, 0, '', '2019-06-02 12:21:08');
INSERT INTO `access_log` VALUES (21161, '59.79.15594492755654933', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:21:16', 31, 2001001000, '服务端发生异常', '2019-06-02 12:21:16');
INSERT INTO `access_log` VALUES (21162, '59.71.15594492780404937', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:21:18', 12, 0, '', '2019-06-02 12:21:18');
INSERT INTO `access_log` VALUES (21163, '66.54.15594492787093725', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:21:19', 12, 0, '', '2019-06-02 12:21:19');
INSERT INTO `access_log` VALUES (21164, '64.77.15594492796254459', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:21:20', 10, 0, '', '2019-06-02 12:21:20');
INSERT INTO `access_log` VALUES (21165, '64.85.15594492891524463', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:21:29', 8, 0, '', '2019-06-02 12:21:29');
INSERT INTO `access_log` VALUES (21166, '64.84.15594492891534457', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:21:29', 9, 0, '', '2019-06-02 12:21:29');
INSERT INTO `access_log` VALUES (21167, '64.83.15594492995484447', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:21:40', 9, 0, '', '2019-06-02 12:21:40');
INSERT INTO `access_log` VALUES (21168, '65.52.15594493061084609', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:21:46', 10, 0, '', '2019-06-02 12:21:46');
INSERT INTO `access_log` VALUES (21169, '65.53.15594493079774605', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:21:48', 9, 0, '', '2019-06-02 12:21:48');
INSERT INTO `access_log` VALUES (21170, '64.82.15594493119274463', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:21:52', 194, 0, '', '2019-06-02 12:21:52');
INSERT INTO `access_log` VALUES (21171, '64.79.15594493119254447', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:21:52', 198, 0, '', '2019-06-02 12:21:52');
INSERT INTO `access_log` VALUES (21172, '65.46.15594493133694615', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:21:53', 10, 0, '', '2019-06-02 12:21:53');
INSERT INTO `access_log` VALUES (21173, '65.49.15594493151604631', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:21:55', 20, 0, '', '2019-06-02 12:21:55');
INSERT INTO `access_log` VALUES (21174, '64.77.15594493291314461', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:22:09', 10, 0, '', '2019-06-02 12:22:09');
INSERT INTO `access_log` VALUES (21175, '64.80.15594493331174447', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:22:13', 9, 0, '', '2019-06-02 12:22:13');
INSERT INTO `access_log` VALUES (21176, '64.84.15594493343054459', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:22:14', 11, 0, '', '2019-06-02 12:22:14');
INSERT INTO `access_log` VALUES (21177, '64.85.15594493375584465', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:22:18', 10, 0, '', '2019-06-02 12:22:18');
INSERT INTO `access_log` VALUES (21178, '64.79.15594493463494449', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:22:26', 16, 0, '', '2019-06-02 12:22:26');
INSERT INTO `access_log` VALUES (21179, '64.83.15594493463484449', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:22:26', 18, 0, '', '2019-06-02 12:22:26');
INSERT INTO `access_log` VALUES (21180, '64.78.15594493463484461', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:22:26', 21, 0, '', '2019-06-02 12:22:26');
INSERT INTO `access_log` VALUES (21181, '64.81.15594493636754451', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=6&name=sss', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:22:44', 166, 0, '', '2019-06-02 12:22:44');
INSERT INTO `access_log` VALUES (21182, '64.77.15594493640014463', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:22:44', 11, 0, '', '2019-06-02 12:22:44');
INSERT INTO `access_log` VALUES (21183, '64.80.15594493654964449', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=6&name=sds', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:22:45', 198, 0, '', '2019-06-02 12:22:46');
INSERT INTO `access_log` VALUES (21184, '64.84.15594493659804461', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '59.63.204.192', '2019-06-02 12:22:46', 11, 0, '', '2019-06-02 12:22:46');
INSERT INTO `access_log` VALUES (21185, '59.78.15594494271904939', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:23:47', 4, 0, '', '2019-06-02 12:23:47');
INSERT INTO `access_log` VALUES (21186, '59.76.15594494271904929', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:23:47', 13, 2001001000, '服务端发生异常', '2019-06-02 12:23:47');
INSERT INTO `access_log` VALUES (21187, '64.82.15594494323374467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:23:52', 4, 0, '', '2019-06-02 12:23:52');
INSERT INTO `access_log` VALUES (21188, '64.81.15594494324404453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:23:52', 2, 0, '', '2019-06-02 12:23:52');
INSERT INTO `access_log` VALUES (21189, '64.77.15594494337714465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:23:54', 3, 0, '', '2019-06-02 12:23:54');
INSERT INTO `access_log` VALUES (21190, '64.80.15594494350044451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:23:55', 2, 0, '', '2019-06-02 12:23:55');
INSERT INTO `access_log` VALUES (21191, '66.52.15594494378943727', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.133.63', '2019-06-02 12:23:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空', '2019-06-02 12:23:58');
INSERT INTO `access_log` VALUES (21192, '59.71.15594508832484959', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.73.89.80', '2019-06-02 12:48:03', 3, 0, '', '2019-06-02 12:48:03');
INSERT INTO `access_log` VALUES (21193, '59.78.15594508832514959', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.73.89.80', '2019-06-02 12:48:03', 12, 2001001000, '服务端发生异常', '2019-06-02 12:48:03');
INSERT INTO `access_log` VALUES (21194, '59.73.15594514240634967', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.47.1.66', '2019-06-02 12:57:04', 3, 0, '', '2019-06-02 12:57:04');
INSERT INTO `access_log` VALUES (21195, '59.79.15594514240634963', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.47.1.66', '2019-06-02 12:57:04', 10, 2001001000, '服务端发生异常', '2019-06-02 12:57:04');
INSERT INTO `access_log` VALUES (21196, '64.83.15594514359514479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.47.1.66', '2019-06-02 12:57:16', 14, 0, '', '2019-06-02 12:57:16');
INSERT INTO `access_log` VALUES (21197, '64.78.15594514360594491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.47.1.66', '2019-06-02 12:57:16', 2, 0, '', '2019-06-02 12:57:16');
INSERT INTO `access_log` VALUES (21198, '65.47.15594514536524655', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.47.1.66', '2019-06-02 12:57:34', 1, 1002001015, '账号未登陆', '2019-06-02 12:57:34');
INSERT INTO `access_log` VALUES (21199, '65.48.15594514536524653', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.47.1.66', '2019-06-02 12:57:34', 1, 1002001015, '账号未登陆', '2019-06-02 12:57:34');
INSERT INTO `access_log` VALUES (21200, '65.51.15594514536524641', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.47.1.66', '2019-06-02 12:57:34', 0, 1002001015, '账号未登陆', '2019-06-02 12:57:34');
INSERT INTO `access_log` VALUES (21201, '65.53.15594514591534635', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.47.1.66', '2019-06-02 12:57:39', 85, 0, '', '2019-06-02 12:57:39');
INSERT INTO `access_log` VALUES (21202, '65.54.15594514594924627', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.47.1.66', '2019-06-02 12:57:39', 11, 0, '', '2019-06-02 12:57:40');
INSERT INTO `access_log` VALUES (21203, '65.46.15594514594914645', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.47.1.66', '2019-06-02 12:57:39', 11, 0, '', '2019-06-02 12:57:40');
INSERT INTO `access_log` VALUES (21204, '65.49.15594514594924661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.47.1.66', '2019-06-02 12:57:39', 10, 0, '', '2019-06-02 12:57:40');
INSERT INTO `access_log` VALUES (21205, '62.88.15594514631474841', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.47.1.66', '2019-06-02 12:57:43', 23, 0, '', '2019-06-02 12:57:43');
INSERT INTO `access_log` VALUES (21206, '59.74.15594514775884961', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.47.1.66', '2019-06-02 12:57:58', 11, 0, '', '2019-06-02 12:57:58');
INSERT INTO `access_log` VALUES (21207, '59.77.15594514815894957', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.47.1.66', '2019-06-02 12:58:02', 20, 2001001000, '服务端发生异常', '2019-06-02 12:58:02');
INSERT INTO `access_log` VALUES (21208, '64.83.15594520002694487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-02 13:06:40', 3, 0, '', '2019-06-02 13:06:40');
INSERT INTO `access_log` VALUES (21209, '64.78.15594520004344499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-02 13:06:40', 2, 0, '', '2019-06-02 13:06:40');
INSERT INTO `access_log` VALUES (21210, '64.79.15594520025224487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-02 13:06:43', 2, 0, '', '2019-06-02 13:06:43');
INSERT INTO `access_log` VALUES (21211, '64.82.15594520026884503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-02 13:06:43', 3, 0, '', '2019-06-02 13:06:43');
INSERT INTO `access_log` VALUES (21212, '59.78.15594520034104975', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-02 13:06:43', 4, 0, '', '2019-06-02 13:06:43');
INSERT INTO `access_log` VALUES (21213, '59.76.15594520034534965', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.74.242.153', '2019-06-02 13:06:43', 13, 2001001000, '服务端发生异常', '2019-06-02 13:06:43');
INSERT INTO `access_log` VALUES (21214, '65.53.15594523028754647', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.87.83.244', '2019-06-02 13:11:43', 1, 1002001015, '账号未登陆', '2019-06-02 13:11:43');
INSERT INTO `access_log` VALUES (21215, '65.49.15594523028804673', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.87.83.244', '2019-06-02 13:11:43', 1, 1002001015, '账号未登陆', '2019-06-02 13:11:43');
INSERT INTO `access_log` VALUES (21216, '65.54.15594523028884639', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.87.83.244', '2019-06-02 13:11:43', 1, 1002001015, '账号未登陆', '2019-06-02 13:11:43');
INSERT INTO `access_log` VALUES (21217, '65.50.15594523269664661', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.87.83.244', '2019-06-02 13:12:07', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 13:12:07');
INSERT INTO `access_log` VALUES (21218, '65.48.15594523315544667', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.87.83.244', '2019-06-02 13:12:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 13:12:12');
INSERT INTO `access_log` VALUES (21219, '65.47.15594523461504669', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.87.83.244', '2019-06-02 13:12:26', 84, 0, '', '2019-06-02 13:12:26');
INSERT INTO `access_log` VALUES (21220, '65.52.15594523464904653', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.87.83.244', '2019-06-02 13:12:26', 9, 0, '', '2019-06-02 13:12:27');
INSERT INTO `access_log` VALUES (21221, '65.54.15594523464934641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.87.83.244', '2019-06-02 13:12:26', 9, 0, '', '2019-06-02 13:12:27');
INSERT INTO `access_log` VALUES (21222, '65.49.15594523464974675', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.87.83.244', '2019-06-02 13:12:26', 9, 0, '', '2019-06-02 13:12:27');
INSERT INTO `access_log` VALUES (21223, '62.86.15594523576664837', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.87.83.244', '2019-06-02 13:12:38', 14, 0, '', '2019-06-02 13:12:38');
INSERT INTO `access_log` VALUES (21224, '64.85.15594523615654509', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.87.83.244', '2019-06-02 13:12:42', 10, 0, '', '2019-06-02 13:12:42');
INSERT INTO `access_log` VALUES (21225, '64.76.15594523615724491', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.87.83.244', '2019-06-02 13:12:42', 7, 0, '', '2019-06-02 13:12:42');
INSERT INTO `access_log` VALUES (21226, '66.55.15594523764513773', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.87.83.244', '2019-06-02 13:12:56', 23, 0, '', '2019-06-02 13:12:56');
INSERT INTO `access_log` VALUES (21227, '65.52.15594530669504663', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:27', 0, 1002001015, '账号未登陆', '2019-06-02 13:24:27');
INSERT INTO `access_log` VALUES (21228, '65.50.15594530669594673', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:27', 1, 1002001015, '账号未登陆', '2019-06-02 13:24:27');
INSERT INTO `access_log` VALUES (21229, '65.48.15594530669934679', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:27', 0, 1002001015, '账号未登陆', '2019-06-02 13:24:27');
INSERT INTO `access_log` VALUES (21230, '59.74.15594530694044983', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:29', 5, 0, '', '2019-06-02 13:24:29');
INSERT INTO `access_log` VALUES (21231, '59.77.15594530694224979', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:29', 13, 2001001000, '服务端发生异常', '2019-06-02 13:24:29');
INSERT INTO `access_log` VALUES (21232, '65.51.15594530703824667', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 13:24:30');
INSERT INTO `access_log` VALUES (21233, '65.47.15594530746194679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 13:24:35');
INSERT INTO `access_log` VALUES (21234, '64.85.15594530811474519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:41', 3, 0, '', '2019-06-02 13:24:41');
INSERT INTO `access_log` VALUES (21235, '64.76.15594530813114501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:41', 2, 0, '', '2019-06-02 13:24:41');
INSERT INTO `access_log` VALUES (21236, '59.80.15594530820584983', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '118.81.55.94', '2019-06-02 13:24:42', 2, 0, '', '2019-06-02 13:24:42');
INSERT INTO `access_log` VALUES (21237, '59.71.15594530820614991', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '118.81.55.94', '2019-06-02 13:24:42', 19, 2001001000, '服务端发生异常', '2019-06-02 13:24:42');
INSERT INTO `access_log` VALUES (21238, '64.83.15594530824934503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:42', 2, 0, '', '2019-06-02 13:24:42');
INSERT INTO `access_log` VALUES (21239, '64.78.15594530832604515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:43', 2, 0, '', '2019-06-02 13:24:43');
INSERT INTO `access_log` VALUES (21240, '64.79.15594530837004503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:44', 3, 0, '', '2019-06-02 13:24:44');
INSERT INTO `access_log` VALUES (21241, '64.82.15594530841104519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:44', 2, 0, '', '2019-06-02 13:24:44');
INSERT INTO `access_log` VALUES (21242, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:46', 16, 0, '', '2019-06-02 13:24:46');
INSERT INTO `access_log` VALUES (21243, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:46', 15, 0, '', '2019-06-02 13:24:46');
INSERT INTO `access_log` VALUES (21244, '64.81.15594530862894505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '118.81.55.94', '2019-06-02 13:24:46', 2, 0, '', '2019-06-02 13:24:46');
INSERT INTO `access_log` VALUES (21245, '64.77.15594530864224517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '118.81.55.94', '2019-06-02 13:24:46', 2, 0, '', '2019-06-02 13:24:46');
INSERT INTO `access_log` VALUES (21246, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:47', 6, 0, '', '2019-06-02 13:24:47');
INSERT INTO `access_log` VALUES (21247, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:47', 12, 0, '', '2019-06-02 13:24:47');
INSERT INTO `access_log` VALUES (21248, '64.80.15594530880884503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '118.81.55.94', '2019-06-02 13:24:48', 2, 0, '', '2019-06-02 13:24:48');
INSERT INTO `access_log` VALUES (21249, '64.84.15594530888864515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '118.81.55.94', '2019-06-02 13:24:49', 2, 0, '', '2019-06-02 13:24:49');
INSERT INTO `access_log` VALUES (21250, '64.85.15594530891904521', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:24:49', 68, 0, '', '2019-06-02 13:24:49');
INSERT INTO `access_log` VALUES (21251, '64.76.15594530893394503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '118.81.55.94', '2019-06-02 13:24:49', 2, 0, '', '2019-06-02 13:24:49');
INSERT INTO `access_log` VALUES (21252, '65.53.15594531311284661', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:25:31', 63, 0, '', '2019-06-02 13:25:31');
INSERT INTO `access_log` VALUES (21253, '65.52.15594531315924665', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:25:32', 9, 0, '', '2019-06-02 13:25:32');
INSERT INTO `access_log` VALUES (21254, '65.48.15594531316054681', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:25:32', 16, 0, '', '2019-06-02 13:25:32');
INSERT INTO `access_log` VALUES (21255, '65.50.15594531316054675', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:25:32', 16, 0, '', '2019-06-02 13:25:32');
INSERT INTO `access_log` VALUES (21256, '62.83.15594531413424855', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:25:41', 14, 0, '', '2019-06-02 13:25:41');
INSERT INTO `access_log` VALUES (21257, '62.82.15594531442144867', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:25:44', 15, 0, '', '2019-06-02 13:25:44');
INSERT INTO `access_log` VALUES (21258, '62.88.15594531511444865', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:25:51', 15, 0, '', '2019-06-02 13:25:51');
INSERT INTO `access_log` VALUES (21259, '64.80.15594531577524505', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:25:58', 10, 0, '', '2019-06-02 13:25:58');
INSERT INTO `access_log` VALUES (21260, '64.77.15594531577494519', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.36.172.247', '2019-06-02 13:25:58', 13, 0, '', '2019-06-02 13:25:58');
INSERT INTO `access_log` VALUES (21261, '65.52.15594535363134671', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.191.127.169', '2019-06-02 13:32:16', 0, 1002001015, '账号未登陆', '2019-06-02 13:32:16');
INSERT INTO `access_log` VALUES (21262, '65.50.15594535363144681', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.191.127.169', '2019-06-02 13:32:16', 1, 1002001015, '账号未登陆', '2019-06-02 13:32:16');
INSERT INTO `access_log` VALUES (21263, '65.48.15594535363174687', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.191.127.169', '2019-06-02 13:32:16', 0, 1002001015, '账号未登陆', '2019-06-02 13:32:16');
INSERT INTO `access_log` VALUES (21264, '65.46.15594535804574679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.191.127.169', '2019-06-02 13:33:00', 78, 0, '', '2019-06-02 13:33:01');
INSERT INTO `access_log` VALUES (21265, '65.53.15594535808544669', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.191.127.169', '2019-06-02 13:33:01', 16, 0, '', '2019-06-02 13:33:01');
INSERT INTO `access_log` VALUES (21266, '65.45.15594535808524687', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.191.127.169', '2019-06-02 13:33:01', 20, 0, '', '2019-06-02 13:33:01');
INSERT INTO `access_log` VALUES (21267, '65.54.15594535808524661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.191.127.169', '2019-06-02 13:33:01', 20, 0, '', '2019-06-02 13:33:01');
INSERT INTO `access_log` VALUES (21268, '62.87.15594535962134871', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.191.127.169', '2019-06-02 13:33:16', 14, 0, '', '2019-06-02 13:33:16');
INSERT INTO `access_log` VALUES (21269, '59.76.15594537168324989', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.29.183.30', '2019-06-02 13:35:17', 13, 2001001000, '服务端发生异常', '2019-06-02 13:35:17');
INSERT INTO `access_log` VALUES (21270, '59.78.15594537168294999', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.29.183.30', '2019-06-02 13:35:17', 938, 0, '', '2019-06-02 13:35:18');
INSERT INTO `access_log` VALUES (21271, '59.76.15594537168324989', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.29.183.30', '2019-06-02 13:35:17', 13, 2001001000, '服务端发生异常', '2019-06-02 13:35:18');
INSERT INTO `access_log` VALUES (21272, '65.48.15594537252404691', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.29.183.30', '2019-06-02 13:35:25', 1, 1002001015, '账号未登陆', '2019-06-02 13:35:25');
INSERT INTO `access_log` VALUES (21273, '65.50.15594537252404685', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.29.183.30', '2019-06-02 13:35:25', 1, 1002001015, '账号未登陆', '2019-06-02 13:35:25');
INSERT INTO `access_log` VALUES (21274, '65.52.15594537252424675', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.29.183.30', '2019-06-02 13:35:25', 0, 1002001015, '账号未登陆', '2019-06-02 13:35:25');
INSERT INTO `access_log` VALUES (21275, '65.51.15594537272694679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.29.183.30', '2019-06-02 13:35:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 13:35:27');
INSERT INTO `access_log` VALUES (21276, '65.49.15594537422364699', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.29.183.30', '2019-06-02 13:35:42', 80, 0, '', '2019-06-02 13:35:42');
INSERT INTO `access_log` VALUES (21277, '65.46.15594537425894683', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.29.183.30', '2019-06-02 13:35:43', 10, 0, '', '2019-06-02 13:35:43');
INSERT INTO `access_log` VALUES (21278, '65.45.15594537425904691', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.29.183.30', '2019-06-02 13:35:43', 10, 0, '', '2019-06-02 13:35:43');
INSERT INTO `access_log` VALUES (21279, '65.53.15594537426034673', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.29.183.30', '2019-06-02 13:35:43', 9, 0, '', '2019-06-02 13:35:43');
INSERT INTO `access_log` VALUES (21280, '62.86.15594537476454857', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.29.183.30', '2019-06-02 13:35:48', 11, 0, '', '2019-06-02 13:35:48');
INSERT INTO `access_log` VALUES (21281, '65.54.15594541762144671', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:42:56', 0, 1002001015, '账号未登陆', '2019-06-02 13:42:56');
INSERT INTO `access_log` VALUES (21282, '65.53.15594541762144679', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:42:56', 0, 1002001015, '账号未登陆', '2019-06-02 13:42:56');
INSERT INTO `access_log` VALUES (21283, '65.48.15594541762144699', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:42:56', 0, 1002001015, '账号未登陆', '2019-06-02 13:42:56');
INSERT INTO `access_log` VALUES (21284, '65.52.15594541782304683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:42:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 13:42:58');
INSERT INTO `access_log` VALUES (21285, '65.51.15594541970724687', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:17', 76, 0, '', '2019-06-02 13:43:17');
INSERT INTO `access_log` VALUES (21286, '65.47.15594541975174699', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:18', 10, 0, '', '2019-06-02 13:43:18');
INSERT INTO `access_log` VALUES (21287, '65.49.15594541975184707', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:18', 10, 0, '', '2019-06-02 13:43:18');
INSERT INTO `access_log` VALUES (21288, '65.45.15594541975204699', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:18', 8, 0, '', '2019-06-02 13:43:18');
INSERT INTO `access_log` VALUES (21289, '62.88.15594542015424883', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:22', 13, 0, '', '2019-06-02 13:43:22');
INSERT INTO `access_log` VALUES (21290, '62.87.15594542069434883', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:27', 12, 0, '', '2019-06-02 13:43:27');
INSERT INTO `access_log` VALUES (21291, '62.86.15594542112284867', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-02 13:43:21&createEndTime=2019-06-09 13:43:21', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:31', 15, 0, '', '2019-06-02 13:43:31');
INSERT INTO `access_log` VALUES (21292, '62.84.15594542141814863', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-02 13:43:21&createEndTime=2019-06-09 13:43:21', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:34', 13, 0, '', '2019-06-02 13:43:34');
INSERT INTO `access_log` VALUES (21293, '62.81.15594542157954861', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-02 13:43:21&createEndTime=2019-06-09 13:43:21', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:36', 13, 0, '', '2019-06-02 13:43:36');
INSERT INTO `access_log` VALUES (21294, '62.85.15594542159814879', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-02 13:43:21&createEndTime=2019-06-09 13:43:21', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:36', 12, 0, '', '2019-06-02 13:43:36');
INSERT INTO `access_log` VALUES (21295, '62.89.15594542161564879', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-02 13:43:21&createEndTime=2019-06-09 13:43:21', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:36', 11, 0, '', '2019-06-02 13:43:36');
INSERT INTO `access_log` VALUES (21296, '62.82.15594542163454887', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-02 13:43:21&createEndTime=2019-06-09 13:43:21', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:36', 10, 0, '', '2019-06-02 13:43:36');
INSERT INTO `access_log` VALUES (21297, '62.80.15594542184454885', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:38', 15, 0, '', '2019-06-02 13:43:38');
INSERT INTO `access_log` VALUES (21298, '64.76.15594542236744519', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:44', 10, 0, '', '2019-06-02 13:43:44');
INSERT INTO `access_log` VALUES (21299, '64.85.15594542236744537', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:44', 12, 0, '', '2019-06-02 13:43:44');
INSERT INTO `access_log` VALUES (21300, '64.79.15594542327414521', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:53', 9, 0, '', '2019-06-02 13:43:53');
INSERT INTO `access_log` VALUES (21301, '64.78.15594542327384533', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:43:53', 13, 0, '', '2019-06-02 13:43:53');
INSERT INTO `access_log` VALUES (21302, '64.81.15594542473334523', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:44:07', 11, 0, '', '2019-06-02 13:44:07');
INSERT INTO `access_log` VALUES (21303, '64.77.15594542473364535', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:44:07', 11, 0, '', '2019-06-02 13:44:07');
INSERT INTO `access_log` VALUES (21304, '64.80.15594542473334521', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:44:07', 16, 0, '', '2019-06-02 13:44:07');
INSERT INTO `access_log` VALUES (21305, '66.57.15594543030733793', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:45:03', 21, 0, '', '2019-06-02 13:45:03');
INSERT INTO `access_log` VALUES (21306, '59.74.15594543396815001', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:45:40', 12, 0, '', '2019-06-02 13:45:40');
INSERT INTO `access_log` VALUES (21307, '65.46.15594543443304693', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '221.222.78.86', '2019-06-02 13:45:44', 0, 1002001015, '账号未登陆', '2019-06-02 13:45:44');
INSERT INTO `access_log` VALUES (21308, '65.53.15594543443364683', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '221.222.78.86', '2019-06-02 13:45:44', 1, 1002001015, '账号未登陆', '2019-06-02 13:45:44');
INSERT INTO `access_log` VALUES (21309, '65.48.15594543443424703', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '221.222.78.86', '2019-06-02 13:45:44', 0, 1002001015, '账号未登陆', '2019-06-02 13:45:44');
INSERT INTO `access_log` VALUES (21310, '65.54.15594543451404675', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:45:45', 9, 0, '', '2019-06-02 13:45:45');
INSERT INTO `access_log` VALUES (21311, '65.52.15594543467104687', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.243.218.93', '2019-06-02 13:45:47', 12, 0, '', '2019-06-02 13:45:47');
INSERT INTO `access_log` VALUES (21312, '65.50.15594543507504697', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '221.222.78.86', '2019-06-02 13:45:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 13:45:51');
INSERT INTO `access_log` VALUES (21313, '65.47.15594543560824703', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '221.222.78.86', '2019-06-02 13:45:56', 86, 0, '', '2019-06-02 13:45:56');
INSERT INTO `access_log` VALUES (21314, '65.49.15594543564764711', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '221.222.78.86', '2019-06-02 13:45:56', 8, 0, '', '2019-06-02 13:45:56');
INSERT INTO `access_log` VALUES (21315, '65.45.15594543564814703', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '221.222.78.86', '2019-06-02 13:45:56', 9, 0, '', '2019-06-02 13:45:56');
INSERT INTO `access_log` VALUES (21316, '65.46.15594543564864695', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '221.222.78.86', '2019-06-02 13:45:56', 8, 0, '', '2019-06-02 13:45:56');
INSERT INTO `access_log` VALUES (21317, '62.88.15594543616404887', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '221.222.78.86', '2019-06-02 13:46:02', 20, 0, '', '2019-06-02 13:46:02');
INSERT INTO `access_log` VALUES (21318, '64.80.15594543659624523', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '221.222.78.86', '2019-06-02 13:46:06', 9, 0, '', '2019-06-02 13:46:06');
INSERT INTO `access_log` VALUES (21319, '64.81.15594543659574525', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '221.222.78.86', '2019-06-02 13:46:06', 15, 0, '', '2019-06-02 13:46:06');
INSERT INTO `access_log` VALUES (21320, '65.51.15594560657694715', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:26', 0, 1002001015, '账号未登陆', '2019-06-02 14:14:26');
INSERT INTO `access_log` VALUES (21321, '65.50.15594560657694721', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:26', 1, 1002001015, '账号未登陆', '2019-06-02 14:14:26');
INSERT INTO `access_log` VALUES (21322, '65.47.15594560657704727', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:26', 0, 1002001015, '账号未登陆', '2019-06-02 14:14:26');
INSERT INTO `access_log` VALUES (21323, '59.78.15594560713285031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:31', 3, 0, '', '2019-06-02 14:14:31');
INSERT INTO `access_log` VALUES (21324, '59.76.15594560713285021', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:31', 10, 2001001000, '服务端发生异常', '2019-06-02 14:14:31');
INSERT INTO `access_log` VALUES (21325, '65.49.15594560776244735', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:38', 383, 0, '', '2019-06-02 14:14:38');
INSERT INTO `access_log` VALUES (21326, '65.46.15594560784484719', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:38', 9, 0, '', '2019-06-02 14:14:38');
INSERT INTO `access_log` VALUES (21327, '65.48.15594560784564729', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:38', 7, 0, '', '2019-06-02 14:14:38');
INSERT INTO `access_log` VALUES (21328, '65.45.15594560784564727', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:38', 8, 0, '', '2019-06-02 14:14:38');
INSERT INTO `access_log` VALUES (21329, '64.79.15594560824964547', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:42', 9, 0, '', '2019-06-02 14:14:43');
INSERT INTO `access_log` VALUES (21330, '64.78.15594560824934559', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:42', 13, 0, '', '2019-06-02 14:14:43');
INSERT INTO `access_log` VALUES (21331, '64.77.15594560855924561', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:46', 7, 0, '', '2019-06-02 14:14:46');
INSERT INTO `access_log` VALUES (21332, '64.82.15594560855904563', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:46', 11, 0, '', '2019-06-02 14:14:46');
INSERT INTO `access_log` VALUES (21333, '66.57.15594560905423817', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:51', 14, 0, '', '2019-06-02 14:14:51');
INSERT INTO `access_log` VALUES (21334, '65.54.15594560923284701', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:52', 17, 0, '', '2019-06-02 14:14:52');
INSERT INTO `access_log` VALUES (21335, '65.50.15594560942664723', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.101.192', '2019-06-02 14:14:54', 1118, 0, '', '2019-06-02 14:14:55');
INSERT INTO `access_log` VALUES (21336, '59.75.15594574463135047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.68.9.119', '2019-06-02 14:37:26', 14, 2001001000, '服务端发生异常', '2019-06-02 14:37:26');
INSERT INTO `access_log` VALUES (21337, '59.74.15594574463125043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.68.9.119', '2019-06-02 14:37:26', 23, 0, '', '2019-06-02 14:37:26');
INSERT INTO `access_log` VALUES (21338, '64.81.15594574489504567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.68.9.119', '2019-06-02 14:37:29', 3, 0, '', '2019-06-02 14:37:29');
INSERT INTO `access_log` VALUES (21339, '64.84.15594574490744577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.68.9.119', '2019-06-02 14:37:29', 2, 0, '', '2019-06-02 14:37:29');
INSERT INTO `access_log` VALUES (21340, '64.85.15594574502884583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.68.9.119', '2019-06-02 14:37:30', 2, 0, '', '2019-06-02 14:37:30');
INSERT INTO `access_log` VALUES (21341, '64.76.15594574505834565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.68.9.119', '2019-06-02 14:37:31', 2, 0, '', '2019-06-02 14:37:31');
INSERT INTO `access_log` VALUES (21342, '59.80.15594574514415043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.68.9.119', '2019-06-02 14:37:31', 3, 0, '', '2019-06-02 14:37:31');
INSERT INTO `access_log` VALUES (21343, '59.71.15594574514435051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.68.9.119', '2019-06-02 14:37:31', 14, 2001001000, '服务端发生异常', '2019-06-02 14:37:31');
INSERT INTO `access_log` VALUES (21344, '65.47.15594574758544747', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.76.1.133', '2019-06-02 14:37:56', 0, 1002001015, '账号未登陆', '2019-06-02 14:37:56');
INSERT INTO `access_log` VALUES (21345, '65.45.15594574758544749', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.76.1.133', '2019-06-02 14:37:56', 0, 1002001015, '账号未登陆', '2019-06-02 14:37:56');
INSERT INTO `access_log` VALUES (21346, '65.49.15594574758544753', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.76.1.133', '2019-06-02 14:37:56', 0, 1002001015, '账号未登陆', '2019-06-02 14:37:56');
INSERT INTO `access_log` VALUES (21347, '65.46.15594574821794741', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.76.1.133', '2019-06-02 14:38:02', 98, 0, '', '2019-06-02 14:38:02');
INSERT INTO `access_log` VALUES (21348, '65.48.15594574849144751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.76.1.133', '2019-06-02 14:38:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 14:38:05');
INSERT INTO `access_log` VALUES (21349, '65.50.15594574903644743', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.76.1.133', '2019-06-02 14:38:10', 80, 0, '', '2019-06-02 14:38:10');
INSERT INTO `access_log` VALUES (21350, '65.52.15594575037904733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 14:38:24', 51, 0, '', '2019-06-02 14:38:24');
INSERT INTO `access_log` VALUES (21351, '65.47.15594575041974749', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 14:38:24', 125, 0, '', '2019-06-02 14:38:24');
INSERT INTO `access_log` VALUES (21352, '65.54.15594575041944723', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 14:38:24', 128, 0, '', '2019-06-02 14:38:24');
INSERT INTO `access_log` VALUES (21353, '65.49.15594575041974755', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 14:38:24', 127, 0, '', '2019-06-02 14:38:24');
INSERT INTO `access_log` VALUES (21354, '59.72.15594575063895045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.89.19.149', '2019-06-02 14:38:26', 3, 0, '', '2019-06-02 14:38:26');
INSERT INTO `access_log` VALUES (21355, '59.77.15594575063935041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.91.60.104', '2019-06-02 14:38:26', 9, 2001001000, '服务端发生异常', '2019-06-02 14:38:26');
INSERT INTO `access_log` VALUES (21356, '62.88.15594575090804931', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 14:38:29', 18, 0, '', '2019-06-02 14:38:29');
INSERT INTO `access_log` VALUES (21357, '64.77.15594575091004581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.151.178.163', '2019-06-02 14:38:29', 2, 0, '', '2019-06-02 14:38:29');
INSERT INTO `access_log` VALUES (21358, '64.80.15594575101234567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.151.178.177', '2019-06-02 14:38:30', 2, 0, '', '2019-06-02 14:38:30');
INSERT INTO `access_log` VALUES (21359, '64.81.15594575102074569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.178.197', '2019-06-02 14:38:30', 2, 0, '', '2019-06-02 14:38:30');
INSERT INTO `access_log` VALUES (21360, '64.84.15594575102944579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '180.97.118.223', '2019-06-02 14:38:30', 2, 0, '', '2019-06-02 14:38:30');
INSERT INTO `access_log` VALUES (21361, '64.83.15594575186394569', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 14:38:39', 9, 0, '', '2019-06-02 14:38:39');
INSERT INTO `access_log` VALUES (21362, '64.76.15594575186394567', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 14:38:39', 13, 0, '', '2019-06-02 14:38:39');
INSERT INTO `access_log` VALUES (21363, '64.78.15594575392684581', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 14:38:59', 92, 0, '', '2019-06-02 14:38:59');
INSERT INTO `access_log` VALUES (21364, '66.50.15594575467823839', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 14:39:07', 14, 0, '', '2019-06-02 14:39:07');
INSERT INTO `access_log` VALUES (21365, '59.71.15594575559405053', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 14:39:16', 11, 0, '', '2019-06-02 14:39:16');
INSERT INTO `access_log` VALUES (21366, '59.79.15594575583505049', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 14:39:18', 13, 0, '', '2019-06-02 14:39:18');
INSERT INTO `access_log` VALUES (21367, '64.80.15594575614204569', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 14:39:21', 9, 0, '', '2019-06-02 14:39:21');
INSERT INTO `access_log` VALUES (21368, '64.81.15594575683344571', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 14:39:28', 10, 0, '', '2019-06-02 14:39:28');
INSERT INTO `access_log` VALUES (21369, '59.76.15594586120625057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:56:52', 13, 2001001000, '服务端发生异常', '2019-06-02 14:56:52');
INSERT INTO `access_log` VALUES (21370, '59.78.15594586120595067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:56:52', 334, 0, '', '2019-06-02 14:56:52');
INSERT INTO `access_log` VALUES (21371, '64.84.15594586187254595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:56:59', 3, 0, '', '2019-06-02 14:56:59');
INSERT INTO `access_log` VALUES (21372, '64.85.15594586188264601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:56:59', 2, 0, '', '2019-06-02 14:56:59');
INSERT INTO `access_log` VALUES (21373, '64.83.15594586257054585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:06', 2, 0, '', '2019-06-02 14:57:06');
INSERT INTO `access_log` VALUES (21374, '64.79.15594586258184585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:06', 2, 0, '', '2019-06-02 14:57:06');
INSERT INTO `access_log` VALUES (21375, '64.78.15594586269914597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:07', 219, 0, '', '2019-06-02 14:57:07');
INSERT INTO `access_log` VALUES (21376, '64.82.15594586278344601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:08', 2, 0, '', '2019-06-02 14:57:08');
INSERT INTO `access_log` VALUES (21377, '64.77.15594586285914599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:09', 2, 0, '', '2019-06-02 14:57:09');
INSERT INTO `access_log` VALUES (21378, '65.52.15594586427194749', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:23', 1, 1002001015, '账号未登陆', '2019-06-02 14:57:23');
INSERT INTO `access_log` VALUES (21379, '65.53.15594586427194745', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:23', 1, 1002001015, '账号未登陆', '2019-06-02 14:57:23');
INSERT INTO `access_log` VALUES (21380, '65.54.15594586427194739', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:23', 0, 1002001015, '账号未登陆', '2019-06-02 14:57:23');
INSERT INTO `access_log` VALUES (21381, '65.49.15594586457314771', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 14:57:26');
INSERT INTO `access_log` VALUES (21382, '65.45.15594586519884767', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:32', 90, 0, '', '2019-06-02 14:57:32');
INSERT INTO `access_log` VALUES (21383, '65.46.15594586525314759', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:33', 10, 0, '', '2019-06-02 14:57:33');
INSERT INTO `access_log` VALUES (21384, '65.48.15594586525444769', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:33', 9, 0, '', '2019-06-02 14:57:33');
INSERT INTO `access_log` VALUES (21385, '65.51.15594586525544757', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:33', 9, 0, '', '2019-06-02 14:57:33');
INSERT INTO `access_log` VALUES (21386, '62.82.15594586585674949', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:39', 15, 0, '', '2019-06-02 14:57:39');
INSERT INTO `access_log` VALUES (21387, '66.52.15594586611873851', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.131.76.61', '2019-06-02 14:57:41', 13, 0, '', '2019-06-02 14:57:41');
INSERT INTO `access_log` VALUES (21388, '59.80.15594588115835063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.49.100.65', '2019-06-02 15:00:12', 20, 2001001000, '服务端发生异常', '2019-06-02 15:00:12');
INSERT INTO `access_log` VALUES (21389, '59.75.15594588115835067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.49.100.65', '2019-06-02 15:00:12', 292, 0, '', '2019-06-02 15:00:12');
INSERT INTO `access_log` VALUES (21390, '64.84.15594588182594599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.49.100.65', '2019-06-02 15:00:18', 3, 0, '', '2019-06-02 15:00:18');
INSERT INTO `access_log` VALUES (21391, '64.85.15594588183864605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.49.100.65', '2019-06-02 15:00:18', 2, 0, '', '2019-06-02 15:00:18');
INSERT INTO `access_log` VALUES (21392, '64.76.15594588194324587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.49.100.65', '2019-06-02 15:00:19', 2, 0, '', '2019-06-02 15:00:19');
INSERT INTO `access_log` VALUES (21393, '64.83.15594588202414589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.49.100.65', '2019-06-02 15:00:20', 2, 0, '', '2019-06-02 15:00:20');
INSERT INTO `access_log` VALUES (21394, '59.79.15594589833735069', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:03:03', 2, 0, '', '2019-06-02 15:03:03');
INSERT INTO `access_log` VALUES (21395, '59.73.15594589833775073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:03:03', 10, 2001001000, '服务端发生异常', '2019-06-02 15:03:03');
INSERT INTO `access_log` VALUES (21396, '64.82.15594589888684607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:03:09', 3, 0, '', '2019-06-02 15:03:09');
INSERT INTO `access_log` VALUES (21397, '64.77.15594589900764605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:03:10', 2, 0, '', '2019-06-02 15:03:10');
INSERT INTO `access_log` VALUES (21398, '64.80.15594589943104591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:03:14', 3, 0, '', '2019-06-02 15:03:14');
INSERT INTO `access_log` VALUES (21399, '64.81.15594589946344593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:03:15', 2, 0, '', '2019-06-02 15:03:15');
INSERT INTO `access_log` VALUES (21400, '59.78.15594589974335073', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:03:17', 3, 0, '', '2019-06-02 15:03:17');
INSERT INTO `access_log` VALUES (21401, '59.72.15594589974335067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:03:17', 10, 2001001000, '服务端发生异常', '2019-06-02 15:03:17');
INSERT INTO `access_log` VALUES (21402, '65.49.15594590231884777', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:03:43', 0, 1002001015, '账号未登陆', '2019-06-02 15:03:43');
INSERT INTO `access_log` VALUES (21403, '65.45.15594590231894773', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:03:43', 1, 1002001015, '账号未登陆', '2019-06-02 15:03:43');
INSERT INTO `access_log` VALUES (21404, '65.46.15594590232054765', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:03:43', 1, 1002001015, '账号未登陆', '2019-06-02 15:03:43');
INSERT INTO `access_log` VALUES (21405, '65.50.15594590563694767', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:04:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 15:04:16');
INSERT INTO `access_log` VALUES (21406, '65.53.15594590811294753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:04:41', 89, 0, '', '2019-06-02 15:04:41');
INSERT INTO `access_log` VALUES (21407, '65.47.15594590815744773', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:04:42', 8, 0, '', '2019-06-02 15:04:42');
INSERT INTO `access_log` VALUES (21408, '65.49.15594590815774779', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:04:42', 14, 0, '', '2019-06-02 15:04:42');
INSERT INTO `access_log` VALUES (21409, '65.46.15594590816324767', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:04:42', 9, 0, '', '2019-06-02 15:04:42');
INSERT INTO `access_log` VALUES (21410, '62.80.15594591139174951', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:05:14', 14, 0, '', '2019-06-02 15:05:14');
INSERT INTO `access_log` VALUES (21411, '62.87.15594591308184953', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:05:31', 15, 0, '', '2019-06-02 15:05:31');
INSERT INTO `access_log` VALUES (21412, '64.85.15594591381944611', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:05:38', 11, 0, '', '2019-06-02 15:05:38');
INSERT INTO `access_log` VALUES (21413, '64.84.15594591381934605', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:05:38', 12, 0, '', '2019-06-02 15:05:38');
INSERT INTO `access_log` VALUES (21414, '64.76.15594591474304593', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:05:47', 213, 0, '', '2019-06-02 15:05:48');
INSERT INTO `access_log` VALUES (21415, '64.83.15594591474314595', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:05:47', 215, 0, '', '2019-06-02 15:05:48');
INSERT INTO `access_log` VALUES (21416, '64.78.15594591536144607', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:05:54', 11, 0, '', '2019-06-02 15:05:54');
INSERT INTO `access_log` VALUES (21417, '64.82.15594591557764611', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:05:56', 11, 0, '', '2019-06-02 15:05:56');
INSERT INTO `access_log` VALUES (21418, '64.77.15594591575934609', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:05:58', 12, 0, '', '2019-06-02 15:05:58');
INSERT INTO `access_log` VALUES (21419, '64.80.15594591593914595', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:05:59', 10, 0, '', '2019-06-02 15:05:59');
INSERT INTO `access_log` VALUES (21420, '64.85.15594591593924613', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:05:59', 11, 0, '', '2019-06-02 15:05:59');
INSERT INTO `access_log` VALUES (21421, '64.81.15594591593914597', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:05:59', 15, 0, '', '2019-06-02 15:05:59');
INSERT INTO `access_log` VALUES (21422, '64.81.15594592463604599', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:07:26', 14, 0, '', '2019-06-02 15:07:26');
INSERT INTO `access_log` VALUES (21423, '64.77.15594592463594611', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:07:26', 18, 0, '', '2019-06-02 15:07:26');
INSERT INTO `access_log` VALUES (21424, '64.85.15594592548604615', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:07:35', 114, 0, '', '2019-06-02 15:07:35');
INSERT INTO `access_log` VALUES (21425, '65.46.15594593690564771', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:09:29', 0, 1002001015, '账号未登陆', '2019-06-02 15:09:29');
INSERT INTO `access_log` VALUES (21426, '65.45.15594593690594779', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:09:29', 0, 1002001015, '账号未登陆', '2019-06-02 15:09:29');
INSERT INTO `access_log` VALUES (21427, '65.48.15594593690624781', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:09:29', 0, 1002001015, '账号未登陆', '2019-06-02 15:09:29');
INSERT INTO `access_log` VALUES (21428, '65.51.15594593722594769', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:09:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 15:09:32');
INSERT INTO `access_log` VALUES (21429, '66.54.15594593736773861', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:09:34', 15, 0, '', '2019-06-02 15:09:34');
INSERT INTO `access_log` VALUES (21430, '59.73.15594593830285079', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:09:43', 11, 0, '', '2019-06-02 15:09:43');
INSERT INTO `access_log` VALUES (21431, '65.54.15594593849434753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudayuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:09:45', 258, 0, '', '2019-06-02 15:09:45');
INSERT INTO `access_log` VALUES (21432, '65.52.15594593856784763', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:09:46', 9, 0, '', '2019-06-02 15:09:46');
INSERT INTO `access_log` VALUES (21433, '65.53.15594593856814759', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:09:46', 9, 0, '', '2019-06-02 15:09:46');
INSERT INTO `access_log` VALUES (21434, '65.49.15594593856844785', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:09:46', 8, 0, '', '2019-06-02 15:09:46');
INSERT INTO `access_log` VALUES (21435, '62.86.15594593948274939', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:09:55', 89, 0, '', '2019-06-02 15:09:55');
INSERT INTO `access_log` VALUES (21436, '62.84.15594594021414935', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:10:02', 16, 0, '', '2019-06-02 15:10:02');
INSERT INTO `access_log` VALUES (21437, '59.77.15594594206535069', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:10:21', 12, 0, '', '2019-06-02 15:10:21');
INSERT INTO `access_log` VALUES (21438, '59.74.15594594315015073', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:10:32', 16, 2001001000, '服务端发生异常', '2019-06-02 15:10:32');
INSERT INTO `access_log` VALUES (21439, '59.75.15594594361065077', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:10:36', 262, 0, '', '2019-06-02 15:10:36');
INSERT INTO `access_log` VALUES (21440, '59.71.15594594370075081', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:10:37', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 15:10:37');
INSERT INTO `access_log` VALUES (21441, '59.79.15594594421835077', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:10:42', 11, 0, '', '2019-06-02 15:10:42');
INSERT INTO `access_log` VALUES (21442, '64.83.15594594432304601', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:10:43', 11, 0, '', '2019-06-02 15:10:43');
INSERT INTO `access_log` VALUES (21443, '64.79.15594594486134601', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:10:49', 9, 0, '', '2019-06-02 15:10:49');
INSERT INTO `access_log` VALUES (21444, '64.82.15594594558744617', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:10:56', 9, 0, '', '2019-06-02 15:10:56');
INSERT INTO `access_log` VALUES (21445, '65.50.15594594597404775', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:11:00', 16, 0, '', '2019-06-02 15:11:00');
INSERT INTO `access_log` VALUES (21446, '65.54.15594594628904755', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:11:03', 10, 0, '', '2019-06-02 15:11:03');
INSERT INTO `access_log` VALUES (21447, '64.77.15594594629914615', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:11:03', 10, 0, '', '2019-06-02 15:11:03');
INSERT INTO `access_log` VALUES (21448, '65.53.15594594655544761', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '115.199.177.231', '2019-06-02 15:11:06', 8, 0, '', '2019-06-02 15:11:06');
INSERT INTO `access_log` VALUES (21449, '59.78.15594594660765081', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:11:06', 10, 0, '', '2019-06-02 15:11:06');
INSERT INTO `access_log` VALUES (21450, '59.72.15594594755515075', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:11:16', 19, 0, '', '2019-06-02 15:11:16');
INSERT INTO `access_log` VALUES (21451, '59.77.15594594763525071', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:11:16', 12, 0, '', '2019-06-02 15:11:16');
INSERT INTO `access_log` VALUES (21452, '59.80.15594594819765075', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:11:22', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 15:11:22');
INSERT INTO `access_log` VALUES (21453, '65.47.15594594872134781', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:11:27', 15, 0, '', '2019-06-02 15:11:27');
INSERT INTO `access_log` VALUES (21454, '65.46.15594594888674775', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:11:29', 10, 0, '', '2019-06-02 15:11:29');
INSERT INTO `access_log` VALUES (21455, '65.45.15594594907464783', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:11:31', 9, 0, '', '2019-06-02 15:11:31');
INSERT INTO `access_log` VALUES (21456, '65.51.15594595010484773', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.0.235.187', '2019-06-02 15:11:41', 12, 0, '', '2019-06-02 15:11:41');
INSERT INTO `access_log` VALUES (21457, '59.73.15594596774555085', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.25.247.22', '2019-06-02 15:14:37', 4, 0, '', '2019-06-02 15:14:37');
INSERT INTO `access_log` VALUES (21458, '59.76.15594596774555075', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.25.247.22', '2019-06-02 15:14:37', 12, 2001001000, '服务端发生异常', '2019-06-02 15:14:37');
INSERT INTO `access_log` VALUES (21459, '64.83.15594596894884605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.25.247.22', '2019-06-02 15:14:49', 139, 0, '', '2019-06-02 15:14:50');
INSERT INTO `access_log` VALUES (21460, '64.79.15594596897654605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.25.247.22', '2019-06-02 15:14:50', 2, 0, '', '2019-06-02 15:14:50');
INSERT INTO `access_log` VALUES (21461, '64.82.15594596913464621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.25.247.22', '2019-06-02 15:14:51', 3, 0, '', '2019-06-02 15:14:51');
INSERT INTO `access_log` VALUES (21462, '64.77.15594596919214619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.25.247.22', '2019-06-02 15:14:52', 2, 0, '', '2019-06-02 15:14:52');
INSERT INTO `access_log` VALUES (21463, '59.79.15594599157955085', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 5.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.111.171.95', '2019-06-02 15:18:36', 13, 2001001000, '服务端发生异常', '2019-06-02 15:18:36');
INSERT INTO `access_log` VALUES (21464, '59.71.15594599157925089', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 5.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.111.171.95', '2019-06-02 15:18:36', 31, 0, '', '2019-06-02 15:18:36');
INSERT INTO `access_log` VALUES (21465, '59.77.15594605748875087', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '42.101.65.200', '2019-06-02 15:29:35', 4, 0, '', '2019-06-02 15:29:35');
INSERT INTO `access_log` VALUES (21466, '59.74.15594605748925091', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3695.400 QQBrowser/10.4.3562.400', '42.101.65.200', '2019-06-02 15:29:35', 13, 2001001000, '服务端发生异常', '2019-06-02 15:29:35');
INSERT INTO `access_log` VALUES (21467, '59.78.15594606652045099', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.47.200', '2019-06-02 15:31:05', 3, 0, '', '2019-06-02 15:31:05');
INSERT INTO `access_log` VALUES (21468, '59.72.15594606652055093', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.47.200', '2019-06-02 15:31:05', 13, 2001001000, '服务端发生异常', '2019-06-02 15:31:05');
INSERT INTO `access_log` VALUES (21469, '64.83.15594606701204619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.47.200', '2019-06-02 15:31:10', 3, 0, '', '2019-06-02 15:31:10');
INSERT INTO `access_log` VALUES (21470, '64.79.15594606702314619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.47.200', '2019-06-02 15:31:10', 1, 0, '', '2019-06-02 15:31:10');
INSERT INTO `access_log` VALUES (21471, '64.78.15594606715724631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.47.200', '2019-06-02 15:31:12', 2, 0, '', '2019-06-02 15:31:12');
INSERT INTO `access_log` VALUES (21472, '64.82.15594606723714635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.47.200', '2019-06-02 15:31:12', 2, 0, '', '2019-06-02 15:31:12');
INSERT INTO `access_log` VALUES (21473, '64.77.15594606757174633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.47.200', '2019-06-02 15:31:16', 2, 0, '', '2019-06-02 15:31:16');
INSERT INTO `access_log` VALUES (21474, '64.81.15594606758124621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.47.200', '2019-06-02 15:31:16', 2, 0, '', '2019-06-02 15:31:16');
INSERT INTO `access_log` VALUES (21475, '59.74.15594606766535093', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.47.200', '2019-06-02 15:31:17', 3, 0, '', '2019-06-02 15:31:17');
INSERT INTO `access_log` VALUES (21476, '59.77.15594606766525089', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.47.200', '2019-06-02 15:31:17', 13, 2001001000, '服务端发生异常', '2019-06-02 15:31:17');
INSERT INTO `access_log` VALUES (21477, '64.85.15594606790064637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.47.200', '2019-06-02 15:31:19', 2, 0, '', '2019-06-02 15:31:19');
INSERT INTO `access_log` VALUES (21478, '64.80.15594606790914619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.47.200', '2019-06-02 15:31:19', 2, 0, '', '2019-06-02 15:31:19');
INSERT INTO `access_log` VALUES (21479, '59.75.15594606795975097', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.47.200', '2019-06-02 15:31:20', 2, 0, '', '2019-06-02 15:31:20');
INSERT INTO `access_log` VALUES (21480, '59.79.15594606795985097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.164.47.200', '2019-06-02 15:31:20', 13, 2001001000, '服务端发生异常', '2019-06-02 15:31:20');
INSERT INTO `access_log` VALUES (21481, '59.71.15594608330345103', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:33:53', 3, 0, '', '2019-06-02 15:33:53');
INSERT INTO `access_log` VALUES (21482, '59.76.15594608332125093', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:33:53', 13, 2001001000, '服务端发生异常', '2019-06-02 15:33:53');
INSERT INTO `access_log` VALUES (21483, '64.76.15594608378774621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:33:58', 3, 0, '', '2019-06-02 15:33:58');
INSERT INTO `access_log` VALUES (21484, '64.83.15594608380874623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:33:58', 2, 0, '', '2019-06-02 15:33:58');
INSERT INTO `access_log` VALUES (21485, '64.79.15594608400824623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:34:00', 2, 0, '', '2019-06-02 15:34:00');
INSERT INTO `access_log` VALUES (21486, '64.78.15594608413834635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:34:01', 2, 0, '', '2019-06-02 15:34:01');
INSERT INTO `access_log` VALUES (21487, '64.82.15594608423024639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:34:02', 2, 0, '', '2019-06-02 15:34:02');
INSERT INTO `access_log` VALUES (21488, '64.77.15594608427114637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:34:03', 3, 0, '', '2019-06-02 15:34:03');
INSERT INTO `access_log` VALUES (21489, '59.78.15594608441745103', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:34:04', 2, 0, '', '2019-06-02 15:34:04');
INSERT INTO `access_log` VALUES (21490, '59.72.15594608441715097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:34:04', 13, 2001001000, '服务端发生异常', '2019-06-02 15:34:04');
INSERT INTO `access_log` VALUES (21491, '59.74.15594610006845099', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.13.15.136', '2019-06-02 15:36:41', 3, 0, '', '2019-06-02 15:36:41');
INSERT INTO `access_log` VALUES (21492, '59.77.15594610006875095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.13.15.136', '2019-06-02 15:36:41', 13, 2001001000, '服务端发生异常', '2019-06-02 15:36:41');
INSERT INTO `access_log` VALUES (21493, '64.85.15594610030944643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.13.15.136', '2019-06-02 15:36:43', 3, 0, '', '2019-06-02 15:36:43');
INSERT INTO `access_log` VALUES (21494, '64.80.15594610032084625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.13.15.136', '2019-06-02 15:36:43', 2, 0, '', '2019-06-02 15:36:43');
INSERT INTO `access_log` VALUES (21495, '64.84.15594610072424637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.13.15.136', '2019-06-02 15:36:47', 2, 0, '', '2019-06-02 15:36:47');
INSERT INTO `access_log` VALUES (21496, '64.76.15594610073644625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.13.15.136', '2019-06-02 15:36:47', 2, 0, '', '2019-06-02 15:36:47');
INSERT INTO `access_log` VALUES (21497, '59.78.15594612536765109', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.13.15.136', '2019-06-02 15:40:54', 4, 0, '', '2019-06-02 15:40:54');
INSERT INTO `access_log` VALUES (21498, '59.74.15594612536785103', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.13.15.136', '2019-06-02 15:40:54', 15, 2001001000, '服务端发生异常', '2019-06-02 15:40:54');
INSERT INTO `access_log` VALUES (21499, '65.51.15594615358754799', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:45:36', 1, 1002001015, '账号未登陆', '2019-06-02 15:45:36');
INSERT INTO `access_log` VALUES (21500, '65.47.15594615358754811', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:45:36', 1, 1002001015, '账号未登陆', '2019-06-02 15:45:36');
INSERT INTO `access_log` VALUES (21501, '65.54.15594615358934785', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:45:36', 1, 1002001015, '账号未登陆', '2019-06-02 15:45:36');
INSERT INTO `access_log` VALUES (21502, '65.53.15594615525124791', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:45:53', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 15:45:53');
INSERT INTO `access_log` VALUES (21503, '65.48.15594615818864813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:46:22', 65, 0, '', '2019-06-02 15:46:22');
INSERT INTO `access_log` VALUES (21504, '65.46.15594615824544805', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:46:22', 146, 0, '', '2019-06-02 15:46:23');
INSERT INTO `access_log` VALUES (21505, '65.45.15594615824544813', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:46:22', 148, 0, '', '2019-06-02 15:46:23');
INSERT INTO `access_log` VALUES (21506, '65.47.15594615824544813', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:46:22', 147, 0, '', '2019-06-02 15:46:23');
INSERT INTO `access_log` VALUES (21507, '62.86.15594615893434969', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:46:29', 24, 0, '', '2019-06-02 15:46:29');
INSERT INTO `access_log` VALUES (21508, '66.54.15594615958003891', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:46:36', 21, 0, '', '2019-06-02 15:46:36');
INSERT INTO `access_log` VALUES (21509, '59.79.15594615979065111', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:46:38', 21, 2001001000, '服务端发生异常', '2019-06-02 15:46:38');
INSERT INTO `access_log` VALUES (21510, '65.52.15594615996754797', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:46:40', 142, 0, '', '2019-06-02 15:46:40');
INSERT INTO `access_log` VALUES (21511, '65.53.15594616021954793', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:46:42', 10, 0, '', '2019-06-02 15:46:42');
INSERT INTO `access_log` VALUES (21512, '65.49.15594616032404819', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:46:43', 10, 0, '', '2019-06-02 15:46:43');
INSERT INTO `access_log` VALUES (21513, '65.50.15594616051294807', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.239.251.83', '2019-06-02 15:46:45', 20, 0, '', '2019-06-02 15:46:45');
INSERT INTO `access_log` VALUES (21514, '65.52.15594618416124801', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 15:50:42', 1, 1002001015, '账号未登陆', '2019-06-02 15:50:42');
INSERT INTO `access_log` VALUES (21515, '65.53.15594618416514797', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 15:50:42', 1, 1002001015, '账号未登陆', '2019-06-02 15:50:42');
INSERT INTO `access_log` VALUES (21516, '65.49.15594618416984823', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 15:50:42', 1, 1002001015, '账号未登陆', '2019-06-02 15:50:42');
INSERT INTO `access_log` VALUES (21517, '65.50.15594618439344811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 15:50:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 15:50:44');
INSERT INTO `access_log` VALUES (21518, '65.48.15594618473284819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 15:50:47', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 15:50:47');
INSERT INTO `access_log` VALUES (21519, '65.49.15594620862834827', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:54:46', 1, 1002001015, '账号未登陆', '2019-06-02 15:54:46');
INSERT INTO `access_log` VALUES (21520, '65.53.15594620862814801', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:54:46', 0, 1002001015, '账号未登陆', '2019-06-02 15:54:46');
INSERT INTO `access_log` VALUES (21521, '65.50.15594620862844815', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:54:46', 0, 1002001015, '账号未登陆', '2019-06-02 15:54:46');
INSERT INTO `access_log` VALUES (21522, '65.48.15594620883644823', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:54:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 15:54:48');
INSERT INTO `access_log` VALUES (21523, '65.45.15594621096514823', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:55:10', 65, 0, '', '2019-06-02 15:55:10');
INSERT INTO `access_log` VALUES (21524, '65.54.15594621099864797', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:55:10', 17, 0, '', '2019-06-02 15:55:10');
INSERT INTO `access_log` VALUES (21525, '65.51.15594621099884811', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:55:10', 9, 0, '', '2019-06-02 15:55:10');
INSERT INTO `access_log` VALUES (21526, '65.52.15594621099974807', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:55:10', 8, 0, '', '2019-06-02 15:55:10');
INSERT INTO `access_log` VALUES (21527, '62.80.15594621190564993', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:55:19', 197, 0, '', '2019-06-02 15:55:19');
INSERT INTO `access_log` VALUES (21528, '62.87.15594621286524995', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:55:29', 15, 0, '', '2019-06-02 15:55:29');
INSERT INTO `access_log` VALUES (21529, '64.81.15594621327344643', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:55:33', 12, 0, '', '2019-06-02 15:55:33');
INSERT INTO `access_log` VALUES (21530, '64.85.15594621327424659', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:55:33', 9, 0, '', '2019-06-02 15:55:33');
INSERT INTO `access_log` VALUES (21531, '64.84.15594621350364653', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:55:35', 8, 0, '', '2019-06-02 15:55:35');
INSERT INTO `access_log` VALUES (21532, '64.80.15594621350354641', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:55:35', 12, 0, '', '2019-06-02 15:55:35');
INSERT INTO `access_log` VALUES (21533, '64.78.15594621455604655', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:55:46', 10, 0, '', '2019-06-02 15:55:46');
INSERT INTO `access_log` VALUES (21534, '64.79.15594621455594643', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:55:46', 14, 0, '', '2019-06-02 15:55:46');
INSERT INTO `access_log` VALUES (21535, '64.83.15594621455594643', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:55:46', 17, 0, '', '2019-06-02 15:55:46');
INSERT INTO `access_log` VALUES (21536, '66.55.15594621634913905', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:56:03', 15, 0, '', '2019-06-02 15:56:04');
INSERT INTO `access_log` VALUES (21537, '59.75.15594621647995119', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:56:05', 12, 0, '', '2019-06-02 15:56:05');
INSERT INTO `access_log` VALUES (21538, '65.48.15594621664174825', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:56:06', 19, 0, '', '2019-06-02 15:56:06');
INSERT INTO `access_log` VALUES (21539, '65.46.15594621673784817', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:56:07', 197, 0, '', '2019-06-02 15:56:08');
INSERT INTO `access_log` VALUES (21540, '65.47.15594621687614825', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:56:09', 8, 0, '', '2019-06-02 15:56:09');
INSERT INTO `access_log` VALUES (21541, '65.52.15594621789394809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:56:19', 14, 0, '', '2019-06-02 15:56:19');
INSERT INTO `access_log` VALUES (21542, '66.52.15594622080673899', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:56:48', 12, 0, '', '2019-06-02 15:56:48');
INSERT INTO `access_log` VALUES (21543, '65.50.15594622402174819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:57:20', 229, 0, '', '2019-06-02 15:57:20');
INSERT INTO `access_log` VALUES (21544, '65.48.15594622407804827', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:57:21', 9, 0, '', '2019-06-02 15:57:21');
INSERT INTO `access_log` VALUES (21545, '65.46.15594622407864819', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:57:21', 9, 0, '', '2019-06-02 15:57:21');
INSERT INTO `access_log` VALUES (21546, '65.47.15594622407874827', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:57:21', 8, 0, '', '2019-06-02 15:57:21');
INSERT INTO `access_log` VALUES (21547, '66.49.15594622523973897', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:57:32', 24, 0, '', '2019-06-02 15:57:32');
INSERT INTO `access_log` VALUES (21548, '65.52.15594622530564811', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:57:33', 12, 0, '', '2019-06-02 15:57:33');
INSERT INTO `access_log` VALUES (21549, '65.51.15594622536764815', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:57:34', 9, 0, '', '2019-06-02 15:57:34');
INSERT INTO `access_log` VALUES (21550, '65.54.15594622540934801', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:57:34', 10, 0, '', '2019-06-02 15:57:34');
INSERT INTO `access_log` VALUES (21551, '65.49.15594622544264833', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:57:34', 18, 0, '', '2019-06-02 15:57:34');
INSERT INTO `access_log` VALUES (21552, '59.78.15594622547725123', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:57:35', 12, 0, '', '2019-06-02 15:57:35');
INSERT INTO `access_log` VALUES (21553, '66.50.15594622550593903', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.115.140', '2019-06-02 15:57:35', 10, 0, '', '2019-06-02 15:57:35');
INSERT INTO `access_log` VALUES (21554, '59.75.15594634842465137', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:04', 3, 0, '', '2019-06-02 16:18:04');
INSERT INTO `access_log` VALUES (21555, '59.79.15594634842475137', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:04', 10, 2001001000, '服务端发生异常', '2019-06-02 16:18:04');
INSERT INTO `access_log` VALUES (21556, '64.82.15594634872094677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:07', 5, 0, '', '2019-06-02 16:18:07');
INSERT INTO `access_log` VALUES (21557, '64.77.15594634874834675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:07', 4, 0, '', '2019-06-02 16:18:07');
INSERT INTO `access_log` VALUES (21558, '64.85.15594634887764679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:09', 3, 0, '', '2019-06-02 16:18:09');
INSERT INTO `access_log` VALUES (21559, '64.81.15594634900454663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:10', 2, 0, '', '2019-06-02 16:18:10');
INSERT INTO `access_log` VALUES (21560, '64.84.15594634903614673', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:10', 2, 0, '', '2019-06-02 16:18:10');
INSERT INTO `access_log` VALUES (21561, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=ww&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:15', 14, 0, '', '2019-06-02 16:18:15');
INSERT INTO `access_log` VALUES (21562, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=ww', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:15', 8, 0, '', '2019-06-02 16:18:15');
INSERT INTO `access_log` VALUES (21563, '64.80.15594634990984661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:19', 2, 0, '', '2019-06-02 16:18:19');
INSERT INTO `access_log` VALUES (21564, '64.76.15594634992214661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:19', 2, 0, '', '2019-06-02 16:18:19');
INSERT INTO `access_log` VALUES (21565, '64.83.15594635002824663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:20', 2, 0, '', '2019-06-02 16:18:20');
INSERT INTO `access_log` VALUES (21566, '64.79.15594635008514663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:21', 2, 0, '', '2019-06-02 16:18:21');
INSERT INTO `access_log` VALUES (21567, '64.82.15594635055594679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:26', 2, 0, '', '2019-06-02 16:18:26');
INSERT INTO `access_log` VALUES (21568, '64.77.15594635057154677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:26', 2, 0, '', '2019-06-02 16:18:26');
INSERT INTO `access_log` VALUES (21569, '59.76.15594635086605131', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:29', 3, 0, '', '2019-06-02 16:18:29');
INSERT INTO `access_log` VALUES (21570, '59.73.15594635086615141', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:29', 13, 2001001000, '服务端发生异常', '2019-06-02 16:18:29');
INSERT INTO `access_log` VALUES (21571, '64.85.15594635110824681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:31', 3, 0, '', '2019-06-02 16:18:31');
INSERT INTO `access_log` VALUES (21572, '64.81.15594635112844665', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:31', 3, 0, '', '2019-06-02 16:18:31');
INSERT INTO `access_log` VALUES (21573, '65.46.15594635200334839', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:40', 4, 1002001012, '访问令牌已过期', '2019-06-02 16:18:40');
INSERT INTO `access_log` VALUES (21574, '65.52.15594635200334829', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:40', 4, 1002001012, '访问令牌已过期', '2019-06-02 16:18:40');
INSERT INTO `access_log` VALUES (21575, '65.45.15594635200354845', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:40', 3, 1002001012, '访问令牌已过期', '2019-06-02 16:18:40');
INSERT INTO `access_log` VALUES (21576, '65.51.15594635250504831', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 16:18:45');
INSERT INTO `access_log` VALUES (21577, '65.54.15594635318444821', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:52', 71, 0, '', '2019-06-02 16:18:52');
INSERT INTO `access_log` VALUES (21578, '65.49.15594635321994853', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:52', 10, 0, '', '2019-06-02 16:18:52');
INSERT INTO `access_log` VALUES (21579, '65.53.15594635322044825', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:52', 9, 0, '', '2019-06-02 16:18:52');
INSERT INTO `access_log` VALUES (21580, '65.48.15594635322094849', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:52', 8, 0, '', '2019-06-02 16:18:52');
INSERT INTO `access_log` VALUES (21581, '62.82.15594635380595021', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:18:58', 14, 0, '', '2019-06-02 16:18:58');
INSERT INTO `access_log` VALUES (21582, '65.50.15594635425024839', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:19:03', 135, 0, '', '2019-06-02 16:19:03');
INSERT INTO `access_log` VALUES (21583, '65.45.15594635453844847', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:19:05', 12, 0, '', '2019-06-02 16:19:05');
INSERT INTO `access_log` VALUES (21584, '65.46.15594635502994841', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:19:10', 11, 0, '', '2019-06-02 16:19:10');
INSERT INTO `access_log` VALUES (21585, '65.51.15594635524614833', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:19:12', 12, 0, '', '2019-06-02 16:19:12');
INSERT INTO `access_log` VALUES (21586, '65.54.15594635576394823', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:19:18', 10, 0, '', '2019-06-02 16:19:18');
INSERT INTO `access_log` VALUES (21587, '65.53.15594635717254827', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:19:32', 14, 0, '', '2019-06-02 16:19:32');
INSERT INTO `access_log` VALUES (21588, '59.75.15594635981455139', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:19:58', 12, 0, '', '2019-06-02 16:19:58');
INSERT INTO `access_log` VALUES (21589, '59.71.15594636008035143', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:20:01', 1161, 2001001000, '服务端发生异常', '2019-06-02 16:20:02');
INSERT INTO `access_log` VALUES (21590, '59.73.15594636046035143', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:20:05', 12, 0, '', '2019-06-02 16:20:05');
INSERT INTO `access_log` VALUES (21591, '64.77.15594636099274679', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:20:10', 11, 0, '', '2019-06-02 16:20:10');
INSERT INTO `access_log` VALUES (21592, '64.85.15594636160554683', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:20:16', 10, 0, '', '2019-06-02 16:20:16');
INSERT INTO `access_log` VALUES (21593, '64.84.15594636303044677', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:20:30', 11, 0, '', '2019-06-02 16:20:30');
INSERT INTO `access_log` VALUES (21594, '64.80.15594636303094665', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:20:30', 8, 0, '', '2019-06-02 16:20:30');
INSERT INTO `access_log` VALUES (21595, '64.79.15594636764294667', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:21:16', 12, 0, '', '2019-06-02 16:21:16');
INSERT INTO `access_log` VALUES (21596, '64.82.15594636764334683', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:21:16', 11, 0, '', '2019-06-02 16:21:16');
INSERT INTO `access_log` VALUES (21597, '64.85.15594636811214685', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:21:21', 9, 0, '', '2019-06-02 16:21:21');
INSERT INTO `access_log` VALUES (21598, '64.81.15594636818534669', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:21:22', 11, 0, '', '2019-06-02 16:21:22');
INSERT INTO `access_log` VALUES (21599, '64.80.15594636827684667', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:21:23', 11, 0, '', '2019-06-02 16:21:23');
INSERT INTO `access_log` VALUES (21600, '64.76.15594636847944667', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:21:25', 11, 0, '', '2019-06-02 16:21:25');
INSERT INTO `access_log` VALUES (21601, '64.84.15594636847944679', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:21:25', 15, 0, '', '2019-06-02 16:21:25');
INSERT INTO `access_log` VALUES (21602, '64.83.15594636848154669', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:21:25', 9, 0, '', '2019-06-02 16:21:25');
INSERT INTO `access_log` VALUES (21603, '64.79.15594637174654669', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:21:57', 11, 0, '', '2019-06-02 16:21:57');
INSERT INTO `access_log` VALUES (21604, '64.77.15594637174814683', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:21:57', 9, 0, '', '2019-06-02 16:21:57');
INSERT INTO `access_log` VALUES (21605, '64.85.15594637200964687', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:22:00', 10, 0, '', '2019-06-02 16:22:00');
INSERT INTO `access_log` VALUES (21606, '62.81.15594637318694997', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.63.204.192', '2019-06-02 16:22:12', 14, 0, '', '2019-06-02 16:22:12');
INSERT INTO `access_log` VALUES (21607, '59.74.15594646622225151', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.165.113.32', '2019-06-02 16:37:42', 4, 0, '', '2019-06-02 16:37:42');
INSERT INTO `access_log` VALUES (21608, '59.72.15594646622225151', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.165.113.32', '2019-06-02 16:37:42', 13, 2001001000, '服务端发生异常', '2019-06-02 16:37:42');
INSERT INTO `access_log` VALUES (21609, '65.45.15594646642414863', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.165.113.32', '2019-06-02 16:37:44', 0, 1002001015, '账号未登陆', '2019-06-02 16:37:44');
INSERT INTO `access_log` VALUES (21610, '65.52.15594646642444847', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.165.113.32', '2019-06-02 16:37:44', 0, 1002001015, '账号未登陆', '2019-06-02 16:37:44');
INSERT INTO `access_log` VALUES (21611, '65.46.15594646642514857', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.165.113.32', '2019-06-02 16:37:44', 1, 1002001015, '账号未登陆', '2019-06-02 16:37:44');
INSERT INTO `access_log` VALUES (21612, '64.83.15594646680294683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.165.113.32', '2019-06-02 16:37:48', 3, 0, '', '2019-06-02 16:37:48');
INSERT INTO `access_log` VALUES (21613, '64.84.15594646681274693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.165.113.32', '2019-06-02 16:37:48', 2, 0, '', '2019-06-02 16:37:48');
INSERT INTO `access_log` VALUES (21614, '64.78.15594646690824695', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.165.113.32', '2019-06-02 16:37:49', 2, 0, '', '2019-06-02 16:37:49');
INSERT INTO `access_log` VALUES (21615, '65.51.15594646718264849', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.165.113.32', '2019-06-02 16:37:52', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 16:37:52');
INSERT INTO `access_log` VALUES (21616, '65.49.15594646756154871', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.165.113.32', '2019-06-02 16:37:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 16:37:56');
INSERT INTO `access_log` VALUES (21617, '64.85.15594651489714707', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 16:45:49', 9, 1002001012, '访问令牌已过期', '2019-06-02 16:45:49');
INSERT INTO `access_log` VALUES (21618, '64.77.15594651489714703', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.76.1.133', '2019-06-02 16:45:49', 10, 1002001012, '访问令牌已过期', '2019-06-02 16:45:49');
INSERT INTO `access_log` VALUES (21619, '65.45.15594656429084877', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:54:03', 1, 1002001015, '账号未登陆', '2019-06-02 16:54:03');
INSERT INTO `access_log` VALUES (21620, '65.52.15594656429094861', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.4', '2019-06-02 16:54:03', 0, 1002001015, '账号未登陆', '2019-06-02 16:54:03');
INSERT INTO `access_log` VALUES (21621, '65.46.15594656429164871', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.5', '2019-06-02 16:54:03', 0, 1002001015, '账号未登陆', '2019-06-02 16:54:03');
INSERT INTO `access_log` VALUES (21622, '65.54.15594656573754853', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.4', '2019-06-02 16:54:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 16:54:17');
INSERT INTO `access_log` VALUES (21623, '65.49.15594656621614885', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.4', '2019-06-02 16:54:22', 66, 0, '', '2019-06-02 16:54:22');
INSERT INTO `access_log` VALUES (21624, '65.48.15594656625004881', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:54:23', 16, 0, '', '2019-06-02 16:54:23');
INSERT INTO `access_log` VALUES (21625, '65.53.15594656624974857', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.4', '2019-06-02 16:54:22', 19, 0, '', '2019-06-02 16:54:23');
INSERT INTO `access_log` VALUES (21626, '65.47.15594656625034881', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:54:23', 17, 0, '', '2019-06-02 16:54:23');
INSERT INTO `access_log` VALUES (21627, '62.85.15594656693135043', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:54:29', 21, 0, '', '2019-06-02 16:54:29');
INSERT INTO `access_log` VALUES (21628, '66.49.15594656739483943', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.4', '2019-06-02 16:54:34', 22, 0, '', '2019-06-02 16:54:34');
INSERT INTO `access_log` VALUES (21629, '59.74.15594656756725165', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.4', '2019-06-02 16:54:36', 10, 0, '', '2019-06-02 16:54:36');
INSERT INTO `access_log` VALUES (21630, '59.72.15594656777785165', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.4', '2019-06-02 16:54:38', 20, 2001001000, '服务端发生异常', '2019-06-02 16:54:38');
INSERT INTO `access_log` VALUES (21631, '65.45.15594656836414879', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:54:44', 20, 0, '', '2019-06-02 16:54:44');
INSERT INTO `access_log` VALUES (21632, '65.46.15594656848204873', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.4', '2019-06-02 16:54:45', 10, 0, '', '2019-06-02 16:54:45');
INSERT INTO `access_log` VALUES (21633, '65.51.15594656884354865', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.4', '2019-06-02 16:54:48', 11, 0, '', '2019-06-02 16:54:48');
INSERT INTO `access_log` VALUES (21634, '65.52.15594657778634865', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:56:18', 10, 0, '', '2019-06-02 16:56:18');
INSERT INTO `access_log` VALUES (21635, '65.54.15594658174934857', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:56:57', 556, 0, '', '2019-06-02 16:56:58');
INSERT INTO `access_log` VALUES (21636, '59.78.15594658299475173', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:57:10', 12, 0, '', '2019-06-02 16:57:10');
INSERT INTO `access_log` VALUES (21637, '59.77.15594658314105163', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:57:11', 27, 2001001000, '服务端发生异常', '2019-06-02 16:57:11');
INSERT INTO `access_log` VALUES (21638, '59.80.15594658332525167', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:57:13', 12, 0, '', '2019-06-02 16:57:13');
INSERT INTO `access_log` VALUES (21639, '59.79.15594658360695171', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:57:16', 9, 0, '', '2019-06-02 16:57:16');
INSERT INTO `access_log` VALUES (21640, '59.75.15594658384015171', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:57:18', 76, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 16:57:18');
INSERT INTO `access_log` VALUES (21641, '59.76.15594658415455165', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:57:22', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 16:57:22');
INSERT INTO `access_log` VALUES (21642, '59.73.15594658420585175', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:57:22', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 16:57:22');
INSERT INTO `access_log` VALUES (21643, '59.74.15594658427635169', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:57:23', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 16:57:23');
INSERT INTO `access_log` VALUES (21644, '59.72.15594658431625169', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=INVALID&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3493.3 Safari/537.36', '183.131.110.3', '2019-06-02 16:57:23', 8, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 16:57:23');
INSERT INTO `access_log` VALUES (21645, '65.52.15594661918924871', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.180.233', '2019-06-02 17:03:12', 140, 1002001012, '访问令牌已过期', '2019-06-02 17:03:12');
INSERT INTO `access_log` VALUES (21646, '65.45.15594666471584893', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:10:47', 0, 1002001015, '账号未登陆', '2019-06-02 17:10:47');
INSERT INTO `access_log` VALUES (21647, '65.46.15594666471604887', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:10:47', 0, 1002001015, '账号未登陆', '2019-06-02 17:10:47');
INSERT INTO `access_log` VALUES (21648, '65.51.15594666471724879', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:10:47', 1, 1002001015, '账号未登陆', '2019-06-02 17:10:47');
INSERT INTO `access_log` VALUES (21649, '65.54.15594666491344869', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:10:49', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 17:10:49');
INSERT INTO `access_log` VALUES (21650, '65.49.15594666518014901', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:10:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 17:10:52');
INSERT INTO `access_log` VALUES (21651, '65.47.15594666713584897', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:11:11', 83, 0, '', '2019-06-02 17:11:11');
INSERT INTO `access_log` VALUES (21652, '65.50.15594666717514887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:11:12', 10, 0, '', '2019-06-02 17:11:12');
INSERT INTO `access_log` VALUES (21653, '65.52.15594666717524879', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:11:12', 10, 0, '', '2019-06-02 17:11:12');
INSERT INTO `access_log` VALUES (21654, '65.45.15594666717574895', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:11:12', 10, 0, '', '2019-06-02 17:11:12');
INSERT INTO `access_log` VALUES (21655, '65.51.15594666809434881', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:11:21', 9, 0, '', '2019-06-02 17:11:21');
INSERT INTO `access_log` VALUES (21656, '65.46.15594666809434889', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:11:21', 9, 0, '', '2019-06-02 17:11:21');
INSERT INTO `access_log` VALUES (21657, '65.54.15594666809444871', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:11:21', 10, 0, '', '2019-06-02 17:11:21');
INSERT INTO `access_log` VALUES (21658, '65.48.15594666871314899', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:11:27', 9, 0, '', '2019-06-02 17:11:27');
INSERT INTO `access_log` VALUES (21659, '65.53.15594666871314875', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:11:27', 10, 0, '', '2019-06-02 17:11:27');
INSERT INTO `access_log` VALUES (21660, '65.47.15594666871364899', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:11:27', 15, 0, '', '2019-06-02 17:11:27');
INSERT INTO `access_log` VALUES (21661, '62.85.15594666876005057', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:11:28', 14, 0, '', '2019-06-02 17:11:28');
INSERT INTO `access_log` VALUES (21662, '62.89.15594667111965057', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:11:51', 50, 0, '', '2019-06-02 17:11:51');
INSERT INTO `access_log` VALUES (21663, '65.45.15594667247814897', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:05', 10, 0, '', '2019-06-02 17:12:05');
INSERT INTO `access_log` VALUES (21664, '65.46.15594667247884891', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:05', 9, 0, '', '2019-06-02 17:12:05');
INSERT INTO `access_log` VALUES (21665, '65.54.15594667247954873', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:05', 8, 0, '', '2019-06-02 17:12:05');
INSERT INTO `access_log` VALUES (21666, '62.80.15594667251945061', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:05', 15, 0, '', '2019-06-02 17:12:05');
INSERT INTO `access_log` VALUES (21667, '65.49.15594667342334905', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:14', 9, 0, '', '2019-06-02 17:12:14');
INSERT INTO `access_log` VALUES (21668, '65.48.15594667342364901', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:14', 9, 0, '', '2019-06-02 17:12:14');
INSERT INTO `access_log` VALUES (21669, '65.53.15594667342404877', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:14', 9, 0, '', '2019-06-02 17:12:14');
INSERT INTO `access_log` VALUES (21670, '64.81.15594667348674713', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:15', 16, 0, '', '2019-06-02 17:12:15');
INSERT INTO `access_log` VALUES (21671, '64.80.15594667348624711', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:15', 29, 0, '', '2019-06-02 17:12:15');
INSERT INTO `access_log` VALUES (21672, '65.50.15594667591814891', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:39', 10, 0, '', '2019-06-02 17:12:39');
INSERT INTO `access_log` VALUES (21673, '65.45.15594667591844899', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:39', 9, 0, '', '2019-06-02 17:12:39');
INSERT INTO `access_log` VALUES (21674, '65.46.15594667591904893', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:39', 9, 0, '', '2019-06-02 17:12:39');
INSERT INTO `access_log` VALUES (21675, '64.83.15594667597874713', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:40', 12, 0, '', '2019-06-02 17:12:40');
INSERT INTO `access_log` VALUES (21676, '64.82.15594667598054729', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:40', 9, 0, '', '2019-06-02 17:12:40');
INSERT INTO `access_log` VALUES (21677, '64.85.15594667668264731', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:47', 11, 0, '', '2019-06-02 17:12:47');
INSERT INTO `access_log` VALUES (21678, '64.77.15594667668304725', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:47', 9, 0, '', '2019-06-02 17:12:47');
INSERT INTO `access_log` VALUES (21679, '64.78.15594667668264725', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:12:47', 15, 0, '', '2019-06-02 17:12:47');
INSERT INTO `access_log` VALUES (21680, '65.51.15594667886774885', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:09', 8, 0, '', '2019-06-02 17:13:09');
INSERT INTO `access_log` VALUES (21681, '65.53.15594667886834879', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:09', 7, 0, '', '2019-06-02 17:13:09');
INSERT INTO `access_log` VALUES (21682, '65.48.15594667886904903', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:09', 7, 0, '', '2019-06-02 17:13:09');
INSERT INTO `access_log` VALUES (21683, '64.81.15594667895624715', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:10', 13, 0, '', '2019-06-02 17:13:10');
INSERT INTO `access_log` VALUES (21684, '65.47.15594668012204903', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:21', 10, 0, '', '2019-06-02 17:13:21');
INSERT INTO `access_log` VALUES (21685, '65.52.15594668012284885', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:21', 8, 0, '', '2019-06-02 17:13:21');
INSERT INTO `access_log` VALUES (21686, '65.50.15594668012364893', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:21', 9, 0, '', '2019-06-02 17:13:21');
INSERT INTO `access_log` VALUES (21687, '65.45.15594668100104901', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:30', 10, 0, '', '2019-06-02 17:13:30');
INSERT INTO `access_log` VALUES (21688, '65.54.15594668100134877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:30', 9, 0, '', '2019-06-02 17:13:30');
INSERT INTO `access_log` VALUES (21689, '65.51.15594668100224887', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:30', 9, 0, '', '2019-06-02 17:13:30');
INSERT INTO `access_log` VALUES (21690, '66.53.15594668104823961', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:30', 15, 0, '', '2019-06-02 17:13:30');
INSERT INTO `access_log` VALUES (21691, '65.48.15594668186064905', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:39', 10, 0, '', '2019-06-02 17:13:39');
INSERT INTO `access_log` VALUES (21692, '65.53.15594668186084881', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:39', 10, 0, '', '2019-06-02 17:13:39');
INSERT INTO `access_log` VALUES (21693, '65.49.15594668186124909', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:39', 9, 0, '', '2019-06-02 17:13:39');
INSERT INTO `access_log` VALUES (21694, '59.71.15594668189695189', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:39', 12, 0, '', '2019-06-02 17:13:39');
INSERT INTO `access_log` VALUES (21695, '62.80.15594668317335063', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-02 17:13:52', 7, 1002001012, '访问令牌已过期', '2019-06-02 17:13:52');
INSERT INTO `access_log` VALUES (21696, '65.52.15594668327454887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:53', 8, 0, '', '2019-06-02 17:13:53');
INSERT INTO `access_log` VALUES (21697, '65.50.15594668327484895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:53', 9, 0, '', '2019-06-02 17:13:53');
INSERT INTO `access_log` VALUES (21698, '65.46.15594668327514897', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:53', 8, 0, '', '2019-06-02 17:13:53');
INSERT INTO `access_log` VALUES (21699, '59.73.15594668330495189', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:13:53', 16, 2001001000, '服务端发生异常', '2019-06-02 17:13:53');
INSERT INTO `access_log` VALUES (21700, '65.45.15594668399144903', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:00', 9, 0, '', '2019-06-02 17:14:00');
INSERT INTO `access_log` VALUES (21701, '65.54.15594668399204879', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:00', 8, 0, '', '2019-06-02 17:14:00');
INSERT INTO `access_log` VALUES (21702, '65.49.15594668399254911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:00', 8, 0, '', '2019-06-02 17:14:00');
INSERT INTO `access_log` VALUES (21703, '59.74.15594668402845183', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:00', 12, 0, '', '2019-06-02 17:14:00');
INSERT INTO `access_log` VALUES (21704, '65.53.15594668412424883', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-02 17:14:01', 139, 0, '', '2019-06-02 17:14:01');
INSERT INTO `access_log` VALUES (21705, '65.48.15594668420024907', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-02 17:14:02', 18, 0, '', '2019-06-02 17:14:02');
INSERT INTO `access_log` VALUES (21706, '65.47.15594668420024907', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-02 17:14:02', 17, 0, '', '2019-06-02 17:14:02');
INSERT INTO `access_log` VALUES (21707, '65.46.15594668420034899', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.74.223.155', '2019-06-02 17:14:02', 17, 0, '', '2019-06-02 17:14:02');
INSERT INTO `access_log` VALUES (21708, '64.85.15594668473854733', 27, 2, 'product-application', '/product-api/admins/spu/list', 'ids=29,32,36', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:07', 12, 0, '', '2019-06-02 17:14:07');
INSERT INTO `access_log` VALUES (21709, '64.77.15594668473974727', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:07', 8, 0, '', '2019-06-02 17:14:07');
INSERT INTO `access_log` VALUES (21710, '64.79.15594668639854715', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:24', 10, 0, '', '2019-06-02 17:14:24');
INSERT INTO `access_log` VALUES (21711, '65.51.15594668700784891', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:30', 10, 0, '', '2019-06-02 17:14:30');
INSERT INTO `access_log` VALUES (21712, '65.54.15594668700834881', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:30', 9, 0, '', '2019-06-02 17:14:30');
INSERT INTO `access_log` VALUES (21713, '65.45.15594668700894905', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:30', 9, 0, '', '2019-06-02 17:14:30');
INSERT INTO `access_log` VALUES (21714, '59.77.15594668704755179', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:30', 12, 0, '', '2019-06-02 17:14:30');
INSERT INTO `access_log` VALUES (21715, '65.49.15594668766744913', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:37', 9, 0, '', '2019-06-02 17:14:37');
INSERT INTO `access_log` VALUES (21716, '65.53.15594668766774885', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:37', 8, 0, '', '2019-06-02 17:14:37');
INSERT INTO `access_log` VALUES (21717, '65.48.15594668766884909', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:37', 8, 0, '', '2019-06-02 17:14:37');
INSERT INTO `access_log` VALUES (21718, '59.79.15594668770085187', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:37', 12, 0, '', '2019-06-02 17:14:37');
INSERT INTO `access_log` VALUES (21719, '65.47.15594668920074909', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:52', 357, 0, '', '2019-06-02 17:14:52');
INSERT INTO `access_log` VALUES (21720, '65.50.15594668920164899', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:52', 349, 0, '', '2019-06-02 17:14:52');
INSERT INTO `access_log` VALUES (21721, '65.52.15594668920264891', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:52', 340, 0, '', '2019-06-02 17:14:52');
INSERT INTO `access_log` VALUES (21722, '59.71.15594668923335191', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:52', 31, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 17:14:53');
INSERT INTO `access_log` VALUES (21723, '59.71.15594668923335191', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:52', 31, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 17:14:52');
INSERT INTO `access_log` VALUES (21724, '65.54.15594668993964883', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:59', 34, 0, '', '2019-06-02 17:14:59');
INSERT INTO `access_log` VALUES (21725, '65.48.15594668994084911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:59', 36, 0, '', '2019-06-02 17:14:59');
INSERT INTO `access_log` VALUES (21726, '65.45.15594668994044907', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:14:59', 36, 0, '', '2019-06-02 17:14:59');
INSERT INTO `access_log` VALUES (21727, '65.53.15594668997404887', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:15:00', 19, 0, '', '2019-06-02 17:15:00');
INSERT INTO `access_log` VALUES (21728, '65.49.15594669048124915', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=13', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:15:05', 10, 0, '', '2019-06-02 17:15:05');
INSERT INTO `access_log` VALUES (21729, '65.50.15594669147234901', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:15:15', 7, 0, '', '2019-06-02 17:15:15');
INSERT INTO `access_log` VALUES (21730, '65.52.15594669147294893', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:15:15', 7, 0, '', '2019-06-02 17:15:15');
INSERT INTO `access_log` VALUES (21731, '65.47.15594669147354911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:15:15', 7, 0, '', '2019-06-02 17:15:15');
INSERT INTO `access_log` VALUES (21732, '65.51.15594669150094895', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:15:15', 206, 0, '', '2019-06-02 17:15:15');
INSERT INTO `access_log` VALUES (21733, '65.48.15594669320114913', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:15:32', 9, 0, '', '2019-06-02 17:15:32');
INSERT INTO `access_log` VALUES (21734, '65.45.15594669320184909', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:15:32', 10, 0, '', '2019-06-02 17:15:32');
INSERT INTO `access_log` VALUES (21735, '65.53.15594669320264889', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:15:32', 9, 0, '', '2019-06-02 17:15:32');
INSERT INTO `access_log` VALUES (21736, '65.49.15594669323704917', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:15:32', 8, 0, '', '2019-06-02 17:15:32');
INSERT INTO `access_log` VALUES (21737, '65.54.15594670106354887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:16:51', 10, 0, '', '2019-06-02 17:16:51');
INSERT INTO `access_log` VALUES (21738, '65.53.15594670106354891', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:16:51', 10, 0, '', '2019-06-02 17:16:51');
INSERT INTO `access_log` VALUES (21739, '65.45.15594670106444911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:16:51', 9, 0, '', '2019-06-02 17:16:51');
INSERT INTO `access_log` VALUES (21740, '65.49.15594670150254919', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:16:55', 10, 0, '', '2019-06-02 17:16:55');
INSERT INTO `access_log` VALUES (21741, '65.46.15594670150424907', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:16:55', 8, 0, '', '2019-06-02 17:16:55');
INSERT INTO `access_log` VALUES (21742, '65.52.15594670152704897', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:16:55', 10, 0, '', '2019-06-02 17:16:55');
INSERT INTO `access_log` VALUES (21743, '59.71.15594670362905193', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:16', 4, 0, '', '2019-06-02 17:17:16');
INSERT INTO `access_log` VALUES (21744, '59.76.15594670362935183', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:16', 18, 2001001000, '服务端发生异常', '2019-06-02 17:17:16');
INSERT INTO `access_log` VALUES (21745, '64.76.15594670457494715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:26', 3, 0, '', '2019-06-02 17:17:26');
INSERT INTO `access_log` VALUES (21746, '64.84.15594670459384729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:26', 2, 0, '', '2019-06-02 17:17:26');
INSERT INTO `access_log` VALUES (21747, '64.82.15594670473944735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:27', 2, 0, '', '2019-06-02 17:17:27');
INSERT INTO `access_log` VALUES (21748, '64.83.15594670482284719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:28', 2, 0, '', '2019-06-02 17:17:28');
INSERT INTO `access_log` VALUES (21749, '64.77.15594670493354731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:29', 2, 0, '', '2019-06-02 17:17:29');
INSERT INTO `access_log` VALUES (21750, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:29', 13, 0, '', '2019-06-02 17:17:29');
INSERT INTO `access_log` VALUES (21751, '64.85.15594670506794737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:31', 2, 0, '', '2019-06-02 17:17:31');
INSERT INTO `access_log` VALUES (21752, '64.78.15594670508274731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:31', 2, 0, '', '2019-06-02 17:17:31');
INSERT INTO `access_log` VALUES (21753, '64.79.15594670515234719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:32', 2, 0, '', '2019-06-02 17:17:32');
INSERT INTO `access_log` VALUES (21754, '64.80.15594670521774719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:32', 2, 0, '', '2019-06-02 17:17:32');
INSERT INTO `access_log` VALUES (21755, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:32', 8, 0, '', '2019-06-02 17:17:32');
INSERT INTO `access_log` VALUES (21756, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:33', 8, 0, '', '2019-06-02 17:17:33');
INSERT INTO `access_log` VALUES (21757, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:34', 6, 0, '', '2019-06-02 17:17:34');
INSERT INTO `access_log` VALUES (21758, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:35', 7, 0, '', '2019-06-02 17:17:35');
INSERT INTO `access_log` VALUES (21759, '64.76.15594670598764717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:40', 166, 0, '', '2019-06-02 17:17:40');
INSERT INTO `access_log` VALUES (21760, '64.84.15594670602064731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:40', 2, 0, '', '2019-06-02 17:17:40');
INSERT INTO `access_log` VALUES (21761, '64.83.15594670750014721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:55', 2, 0, '', '2019-06-02 17:17:55');
INSERT INTO `access_log` VALUES (21762, '64.77.15594670750874733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 3 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '112.10.85.82', '2019-06-02 17:17:55', 2, 0, '', '2019-06-02 17:17:55');
INSERT INTO `access_log` VALUES (21763, '65.49.15594681903224937', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:36:30', 1, 1002001015, '账号未登陆', '2019-06-02 17:36:30');
INSERT INTO `access_log` VALUES (21764, '65.48.15594681903214931', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:36:30', 1, 1002001015, '账号未登陆', '2019-06-02 17:36:30');
INSERT INTO `access_log` VALUES (21765, '65.46.15594681903234925', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:36:30', 0, 1002001015, '账号未登陆', '2019-06-02 17:36:30');
INSERT INTO `access_log` VALUES (21766, '65.51.15594681922854915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:36:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 17:36:32');
INSERT INTO `access_log` VALUES (21767, '65.54.15594681953704907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:36:35', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 17:36:35');
INSERT INTO `access_log` VALUES (21768, '65.45.15594682538944931', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:37:34', 56, 0, '', '2019-06-02 17:37:34');
INSERT INTO `access_log` VALUES (21769, '65.49.15594682541044939', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:37:34', 8, 0, '', '2019-06-02 17:37:34');
INSERT INTO `access_log` VALUES (21770, '65.46.15594682541094927', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:37:34', 8, 0, '', '2019-06-02 17:37:34');
INSERT INTO `access_log` VALUES (21771, '65.48.15594682541034933', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:37:34', 15, 0, '', '2019-06-02 17:37:34');
INSERT INTO `access_log` VALUES (21772, '62.85.15594682670235079', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:37:47', 14, 0, '', '2019-06-02 17:37:47');
INSERT INTO `access_log` VALUES (21773, '62.82.15594682716805089', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:37:52', 263, 0, '', '2019-06-02 17:37:52');
INSERT INTO `access_log` VALUES (21774, '64.78.15594682755394749', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:37:56', 12, 0, '', '2019-06-02 17:37:56');
INSERT INTO `access_log` VALUES (21775, '64.85.15594682755394755', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:37:56', 13, 0, '', '2019-06-02 17:37:56');
INSERT INTO `access_log` VALUES (21776, '64.79.15594682796074737', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:38:00', 10, 0, '', '2019-06-02 17:38:00');
INSERT INTO `access_log` VALUES (21777, '64.80.15594682796244737', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:38:00', 8, 0, '', '2019-06-02 17:38:00');
INSERT INTO `access_log` VALUES (21778, '64.81.15594682828754739', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:38:03', 9, 0, '', '2019-06-02 17:38:03');
INSERT INTO `access_log` VALUES (21779, '66.51.15594683033623979', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:38:23', 14, 0, '', '2019-06-02 17:38:23');
INSERT INTO `access_log` VALUES (21780, '59.80.15594683072305203', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:38:27', 148, 0, '', '2019-06-02 17:38:27');
INSERT INTO `access_log` VALUES (21781, '65.50.15594683146634923', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:38:35', 17, 0, '', '2019-06-02 17:38:35');
INSERT INTO `access_log` VALUES (21782, '65.53.15594683149864911', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:38:35', 10, 0, '', '2019-06-02 17:38:35');
INSERT INTO `access_log` VALUES (21783, '65.45.15594683156594933', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:38:36', 10, 0, '', '2019-06-02 17:38:36');
INSERT INTO `access_log` VALUES (21784, '65.49.15594683162574941', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:38:36', 14, 0, '', '2019-06-02 17:38:36');
INSERT INTO `access_log` VALUES (21785, '65.45.15594687285444939', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.12.54', '2019-06-02 17:45:29', 1, 1002001015, '账号未登陆', '2019-06-02 17:45:29');
INSERT INTO `access_log` VALUES (21786, '65.49.15594687285454947', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.12.54', '2019-06-02 17:45:29', 0, 1002001015, '账号未登陆', '2019-06-02 17:45:29');
INSERT INTO `access_log` VALUES (21787, '65.46.15594687285494935', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.12.54', '2019-06-02 17:45:29', 0, 1002001015, '账号未登陆', '2019-06-02 17:45:29');
INSERT INTO `access_log` VALUES (21788, '65.48.15594687302754941', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.12.54', '2019-06-02 17:45:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 17:45:30');
INSERT INTO `access_log` VALUES (21789, '65.51.15594687328984925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.12.54', '2019-06-02 17:45:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 17:45:33');
INSERT INTO `access_log` VALUES (21790, '65.52.15594687408914925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.12.54', '2019-06-02 17:45:41', 108, 0, '', '2019-06-02 17:45:41');
INSERT INTO `access_log` VALUES (21791, '65.50.15594687412544931', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.12.54', '2019-06-02 17:45:41', 9, 0, '', '2019-06-02 17:45:41');
INSERT INTO `access_log` VALUES (21792, '65.47.15594687412534941', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.12.54', '2019-06-02 17:45:41', 10, 0, '', '2019-06-02 17:45:41');
INSERT INTO `access_log` VALUES (21793, '65.53.15594687412574919', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.12.54', '2019-06-02 17:45:41', 8, 0, '', '2019-06-02 17:45:41');
INSERT INTO `access_log` VALUES (21794, '62.88.15594687515495091', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.12.54', '2019-06-02 17:45:52', 291, 0, '', '2019-06-02 17:45:52');
INSERT INTO `access_log` VALUES (21795, '59.79.15594687565805213', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.12.54', '2019-06-02 17:45:57', 13, 0, '', '2019-06-02 17:45:57');
INSERT INTO `access_log` VALUES (21796, '59.79.15594688882715215', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:08', 3, 0, '', '2019-06-02 17:48:08');
INSERT INTO `access_log` VALUES (21797, '59.75.15594688882715215', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:08', 10, 2001001000, '服务端发生异常', '2019-06-02 17:48:08');
INSERT INTO `access_log` VALUES (21798, '64.82.15594689033154763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:23', 4, 0, '', '2019-06-02 17:48:23');
INSERT INTO `access_log` VALUES (21799, '64.83.15594689033824747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:23', 2, 0, '', '2019-06-02 17:48:23');
INSERT INTO `access_log` VALUES (21800, '64.77.15594689090454759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:29', 2, 0, '', '2019-06-02 17:48:29');
INSERT INTO `access_log` VALUES (21801, '64.85.15594689091694765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:29', 2, 0, '', '2019-06-02 17:48:29');
INSERT INTO `access_log` VALUES (21802, '64.78.15594689105064759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:31', 3, 0, '', '2019-06-02 17:48:31');
INSERT INTO `access_log` VALUES (21803, '64.79.15594689115804747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:32', 2, 0, '', '2019-06-02 17:48:32');
INSERT INTO `access_log` VALUES (21804, '64.80.15594689123394747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:32', 132, 0, '', '2019-06-02 17:48:32');
INSERT INTO `access_log` VALUES (21805, '64.81.15594689133384749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:33', 2, 0, '', '2019-06-02 17:48:33');
INSERT INTO `access_log` VALUES (21806, '64.84.15594689169624759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:37', 3, 0, '', '2019-06-02 17:48:37');
INSERT INTO `access_log` VALUES (21807, '64.82.15594689170724765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:37', 2, 0, '', '2019-06-02 17:48:37');
INSERT INTO `access_log` VALUES (21808, '64.83.15594689267854749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:47', 2, 0, '', '2019-06-02 17:48:47');
INSERT INTO `access_log` VALUES (21809, '64.77.15594689268604761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:47', 2, 0, '', '2019-06-02 17:48:47');
INSERT INTO `access_log` VALUES (21810, '64.85.15594689283634767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:48', 2, 0, '', '2019-06-02 17:48:48');
INSERT INTO `access_log` VALUES (21811, '64.78.15594689294554761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:49', 2, 0, '', '2019-06-02 17:48:49');
INSERT INTO `access_log` VALUES (21812, '64.79.15594689302344749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:50', 8, 0, '', '2019-06-02 17:48:50');
INSERT INTO `access_log` VALUES (21813, '64.81.15594689311054751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:51', 2, 0, '', '2019-06-02 17:48:51');
INSERT INTO `access_log` VALUES (21814, '59.72.15594689330665213', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:53', 10, 2001001000, '服务端发生异常', '2019-06-02 17:48:53');
INSERT INTO `access_log` VALUES (21815, '59.74.15594689330665213', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:53', 805, 0, '', '2019-06-02 17:48:54');
INSERT INTO `access_log` VALUES (21816, '64.76.15594689377264747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:58', 2, 0, '', '2019-06-02 17:48:58');
INSERT INTO `access_log` VALUES (21817, '64.84.15594689378384761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:58', 2, 0, '', '2019-06-02 17:48:58');
INSERT INTO `access_log` VALUES (21818, '59.78.15594689393265219', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:59', 3, 0, '', '2019-06-02 17:48:59');
INSERT INTO `access_log` VALUES (21819, '59.77.15594689393265209', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:48:59', 13, 2001001000, '服务端发生异常', '2019-06-02 17:48:59');
INSERT INTO `access_log` VALUES (21820, '64.82.15594689414114767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:49:01', 2, 0, '', '2019-06-02 17:49:01');
INSERT INTO `access_log` VALUES (21821, '64.83.15594689414924751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:49:01', 2, 0, '', '2019-06-02 17:49:01');
INSERT INTO `access_log` VALUES (21822, '64.77.15594689426114763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:49:03', 3, 0, '', '2019-06-02 17:49:03');
INSERT INTO `access_log` VALUES (21823, '64.85.15594689431514769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:49:03', 2, 0, '', '2019-06-02 17:49:03');
INSERT INTO `access_log` VALUES (21824, '59.79.15594689444805217', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:49:04', 2, 0, '', '2019-06-02 17:49:04');
INSERT INTO `access_log` VALUES (21825, '59.75.15594689444805217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:49:04', 9, 2001001000, '服务端发生异常', '2019-06-02 17:49:04');
INSERT INTO `access_log` VALUES (21826, '64.79.15594689465794751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:49:07', 3, 0, '', '2019-06-02 17:49:07');
INSERT INTO `access_log` VALUES (21827, '64.80.15594689466654751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:49:07', 2, 0, '', '2019-06-02 17:49:07');
INSERT INTO `access_log` VALUES (21828, '59.71.15594689522645221', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:49:12', 3, 0, '', '2019-06-02 17:49:12');
INSERT INTO `access_log` VALUES (21829, '59.76.15594689522645211', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-02 17:49:12', 13, 2001001000, '服务端发生异常', '2019-06-02 17:49:12');
INSERT INTO `access_log` VALUES (21830, '59.75.15594690620435219', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:02', 3, 0, '', '2019-06-02 17:51:02');
INSERT INTO `access_log` VALUES (21831, '59.71.15594690620475223', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:02', 13, 2001001000, '服务端发生异常', '2019-06-02 17:51:02');
INSERT INTO `access_log` VALUES (21832, '66.50.15594690905473995', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13976239107&code=9999', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:31', 9, 1001003000, '验证码不存在', '2019-06-02 17:51:31');
INSERT INTO `access_log` VALUES (21833, '59.78.15594691027315223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:43', 3, 0, '', '2019-06-02 17:51:43');
INSERT INTO `access_log` VALUES (21834, '59.72.15594691027305217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:43', 13, 2001001000, '服务端发生异常', '2019-06-02 17:51:43');
INSERT INTO `access_log` VALUES (21835, '64.81.15594691073684755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:47', 3, 0, '', '2019-06-02 17:51:47');
INSERT INTO `access_log` VALUES (21836, '64.76.15594691075504751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:48', 2, 0, '', '2019-06-02 17:51:48');
INSERT INTO `access_log` VALUES (21837, '64.84.15594691093714765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:49', 2, 0, '', '2019-06-02 17:51:49');
INSERT INTO `access_log` VALUES (21838, '64.82.15594691101174771', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:50', 2, 0, '', '2019-06-02 17:51:50');
INSERT INTO `access_log` VALUES (21839, '64.77.15594691110734767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:51', 55, 0, '', '2019-06-02 17:51:51');
INSERT INTO `access_log` VALUES (21840, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:52', 6, 0, '', '2019-06-02 17:51:52');
INSERT INTO `access_log` VALUES (21841, '64.85.15594691123574773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:52', 159, 0, '', '2019-06-02 17:51:53');
INSERT INTO `access_log` VALUES (21842, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:57', 7, 0, '', '2019-06-02 17:51:57');
INSERT INTO `access_log` VALUES (21843, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:58', 7, 0, '', '2019-06-02 17:51:58');
INSERT INTO `access_log` VALUES (21844, '64.78.15594691188424767', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; STF-AL10 Build/HUAWEISTF-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '36.101.198.241', '2019-06-02 17:51:59', 153, 0, '', '2019-06-02 17:51:59');
INSERT INTO `access_log` VALUES (21845, '65.47.15594700604054961', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:07:40', 91, 0, '', '2019-06-02 18:07:40');
INSERT INTO `access_log` VALUES (21846, '65.54.15594700611184935', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:07:41', 10, 0, '', '2019-06-02 18:07:41');
INSERT INTO `access_log` VALUES (21847, '65.49.15594700611204967', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:07:41', 9, 0, '', '2019-06-02 18:07:41');
INSERT INTO `access_log` VALUES (21848, '65.51.15594700611814945', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:07:41', 10, 0, '', '2019-06-02 18:07:41');
INSERT INTO `access_log` VALUES (21849, '65.45.15594700870664959', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:08:07', 18, 0, '', '2019-06-02 18:08:07');
INSERT INTO `access_log` VALUES (21850, '65.48.15594700870694961', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:08:07', 15, 0, '', '2019-06-02 18:08:07');
INSERT INTO `access_log` VALUES (21851, '65.53.15594700871294941', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:08:07', 9, 0, '', '2019-06-02 18:08:07');
INSERT INTO `access_log` VALUES (21852, '65.50.15594700872924953', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:08:07', 9, 0, '', '2019-06-02 18:08:07');
INSERT INTO `access_log` VALUES (21853, '65.47.15594701021684963', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:08:22', 9, 0, '', '2019-06-02 18:08:22');
INSERT INTO `access_log` VALUES (21854, '65.49.15594701021884969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:08:22', 9, 0, '', '2019-06-02 18:08:22');
INSERT INTO `access_log` VALUES (21855, '65.54.15594701022484937', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:08:22', 9, 0, '', '2019-06-02 18:08:22');
INSERT INTO `access_log` VALUES (21856, '64.83.15594701023884769', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:08:22', 13, 0, '', '2019-06-02 18:08:22');
INSERT INTO `access_log` VALUES (21857, '64.77.15594701024084781', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:08:22', 9, 0, '', '2019-06-02 18:08:22');
INSERT INTO `access_log` VALUES (21858, '64.85.15594701141544787', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:08:34', 11, 0, '', '2019-06-02 18:08:34');
INSERT INTO `access_log` VALUES (21859, '59.80.15594701634915231', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:09:23', 4, 0, '', '2019-06-02 18:09:23');
INSERT INTO `access_log` VALUES (21860, '59.79.15594701650965235', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:09:25', 15, 2001001000, '服务端发生异常', '2019-06-02 18:09:25');
INSERT INTO `access_log` VALUES (21861, '64.84.15594701767654781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:09:37', 3, 0, '', '2019-06-02 18:09:37');
INSERT INTO `access_log` VALUES (21862, '64.82.15594701769604787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:09:37', 2, 0, '', '2019-06-02 18:09:37');
INSERT INTO `access_log` VALUES (21863, '64.83.15594701800614771', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:09:40', 2, 0, '', '2019-06-02 18:09:40');
INSERT INTO `access_log` VALUES (21864, '64.77.15594701800634783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:09:40', 1, 0, '', '2019-06-02 18:09:40');
INSERT INTO `access_log` VALUES (21865, '64.85.15594701822794789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:09:42', 2, 0, '', '2019-06-02 18:09:42');
INSERT INTO `access_log` VALUES (21866, '64.78.15594701838494783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:09:44', 2, 0, '', '2019-06-02 18:09:44');
INSERT INTO `access_log` VALUES (21867, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:09:44', 8, 0, '', '2019-06-02 18:09:44');
INSERT INTO `access_log` VALUES (21868, '64.79.15594701873054771', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:09:47', 8, 0, '', '2019-06-02 18:09:47');
INSERT INTO `access_log` VALUES (21869, '66.51.15594702222274005', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18613511637', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:10:22', 90, 0, '', '2019-06-02 18:10:22');
INSERT INTO `access_log` VALUES (21870, '66.56.15594702331904003', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18613511637&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:10:33', 583, 0, '', '2019-06-02 18:10:34');
INSERT INTO `access_log` VALUES (21871, '66.49.15594702349804005', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18613511637&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:10:35', 9, 1001003002, '验证码已使用', '2019-06-02 18:10:35');
INSERT INTO `access_log` VALUES (21872, '66.55.15594702360914015', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18613511637&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 QQ/8.0.6.432 V1_IPH_SQ_8.0.6_1_APP_A Pixel/750 Core/WKWebView Device/Apple(iPhone 6s) NetType/4G QBWebViewType/1 WKType/1', '117.136.38.38', '2019-06-02 18:10:36', 8, 1001003002, '验证码已使用', '2019-06-02 18:10:36');
INSERT INTO `access_log` VALUES (21873, '59.75.15594712229445249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:27:03', 3, 0, '', '2019-06-02 18:27:03');
INSERT INTO `access_log` VALUES (21874, '59.71.15594712229445253', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:27:03', 13, 2001001000, '服务端发生异常', '2019-06-02 18:27:03');
INSERT INTO `access_log` VALUES (21875, '64.80.15594712290444785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:27:09', 3, 0, '', '2019-06-02 18:27:09');
INSERT INTO `access_log` VALUES (21876, '64.81.15594712292244787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:27:09', 2, 0, '', '2019-06-02 18:27:09');
INSERT INTO `access_log` VALUES (21877, '64.76.15594712376544783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:27:18', 2, 0, '', '2019-06-02 18:27:18');
INSERT INTO `access_log` VALUES (21878, '64.84.15594712378544797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:27:18', 2, 0, '', '2019-06-02 18:27:18');
INSERT INTO `access_log` VALUES (21879, '59.78.15594712433945253', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:27:23', 3, 0, '', '2019-06-02 18:27:23');
INSERT INTO `access_log` VALUES (21880, '59.74.15594712433865247', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:27:23', 13, 2001001000, '服务端发生异常', '2019-06-02 18:27:23');
INSERT INTO `access_log` VALUES (21881, '65.48.15594713259404979', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:28:46', 0, 1002001015, '账号未登陆', '2019-06-02 18:28:46');
INSERT INTO `access_log` VALUES (21882, '65.45.15594713259404977', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:28:46', 0, 1002001015, '账号未登陆', '2019-06-02 18:28:46');
INSERT INTO `access_log` VALUES (21883, '65.53.15594713259654959', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:28:46', 1, 1002001015, '账号未登陆', '2019-06-02 18:28:46');
INSERT INTO `access_log` VALUES (21884, '65.50.15594713312124971', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:28:51', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 18:28:51');
INSERT INTO `access_log` VALUES (21885, '65.47.15594713502754981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:10', 72, 0, '', '2019-06-02 18:29:10');
INSERT INTO `access_log` VALUES (21886, '65.54.15594713507664955', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:11', 10, 0, '', '2019-06-02 18:29:11');
INSERT INTO `access_log` VALUES (21887, '65.51.15594713507744965', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:11', 8, 0, '', '2019-06-02 18:29:11');
INSERT INTO `access_log` VALUES (21888, '65.46.15594713508264975', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:11', 8, 0, '', '2019-06-02 18:29:11');
INSERT INTO `access_log` VALUES (21889, '65.53.15594713604894961', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:20', 9, 0, '', '2019-06-02 18:29:20');
INSERT INTO `access_log` VALUES (21890, '65.45.15594713604894979', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:20', 10, 0, '', '2019-06-02 18:29:20');
INSERT INTO `access_log` VALUES (21891, '65.48.15594713605474981', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:21', 9, 0, '', '2019-06-02 18:29:21');
INSERT INTO `access_log` VALUES (21892, '65.50.15594713605864973', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:21', 17, 0, '', '2019-06-02 18:29:21');
INSERT INTO `access_log` VALUES (21893, '65.49.15594713730674989', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:33', 8, 0, '', '2019-06-02 18:29:33');
INSERT INTO `access_log` VALUES (21894, '65.47.15594713730734983', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:33', 7, 0, '', '2019-06-02 18:29:33');
INSERT INTO `access_log` VALUES (21895, '65.54.15594713730804957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:33', 8, 0, '', '2019-06-02 18:29:33');
INSERT INTO `access_log` VALUES (21896, '65.45.15594713851774981', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:45', 16, 0, '', '2019-06-02 18:29:45');
INSERT INTO `access_log` VALUES (21897, '65.46.15594713851744977', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:45', 18, 0, '', '2019-06-02 18:29:45');
INSERT INTO `access_log` VALUES (21898, '65.53.15594713851774963', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:45', 17, 0, '', '2019-06-02 18:29:45');
INSERT INTO `access_log` VALUES (21899, '65.50.15594713917614975', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:52', 8, 0, '', '2019-06-02 18:29:52');
INSERT INTO `access_log` VALUES (21900, '65.48.15594713917614983', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:52', 329, 0, '', '2019-06-02 18:29:52');
INSERT INTO `access_log` VALUES (21901, '65.52.15594713918364967', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:52', 254, 0, '', '2019-06-02 18:29:52');
INSERT INTO `access_log` VALUES (21902, '62.86.15594713918685113', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:29:52', 236, 0, '', '2019-06-02 18:29:52');
INSERT INTO `access_log` VALUES (21903, '65.47.15594714008654985', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:30:01', 64, 0, '', '2019-06-02 18:30:01');
INSERT INTO `access_log` VALUES (21904, '65.54.15594714008624959', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:30:01', 68, 0, '', '2019-06-02 18:30:01');
INSERT INTO `access_log` VALUES (21905, '65.51.15594714009404969', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:30:01', 9, 0, '', '2019-06-02 18:30:01');
INSERT INTO `access_log` VALUES (21906, '64.83.15594714009894789', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:30:01', 12, 0, '', '2019-06-02 18:30:01');
INSERT INTO `access_log` VALUES (21907, '64.77.15594714014544801', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:30:01', 249, 0, '', '2019-06-02 18:30:02');
INSERT INTO `access_log` VALUES (21908, '65.53.15594714143394965', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:30:14', 10, 0, '', '2019-06-02 18:30:14');
INSERT INTO `access_log` VALUES (21909, '65.45.15594714143494983', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:30:14', 9, 0, '', '2019-06-02 18:30:14');
INSERT INTO `access_log` VALUES (21910, '65.50.15594714144104977', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:30:14', 10, 0, '', '2019-06-02 18:30:14');
INSERT INTO `access_log` VALUES (21911, '64.78.15594714144244801', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '61.148.244.154', '2019-06-02 18:30:14', 9, 0, '', '2019-06-02 18:30:14');
INSERT INTO `access_log` VALUES (21912, '59.80.15594720318445257', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 18:40:32', 4, 0, '', '2019-06-02 18:40:32');
INSERT INTO `access_log` VALUES (21913, '59.79.15594720318465261', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 18:40:32', 15, 2001001000, '服务端发生异常', '2019-06-02 18:40:32');
INSERT INTO `access_log` VALUES (21914, '59.73.15594720568115265', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 18:40:57', 3, 0, '', '2019-06-02 18:40:57');
INSERT INTO `access_log` VALUES (21915, '59.76.15594720568115255', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 18:40:57', 13, 2001001000, '服务端发生异常', '2019-06-02 18:40:57');
INSERT INTO `access_log` VALUES (21916, '64.84.15594720700844809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 18:41:10', 3, 0, '', '2019-06-02 18:41:10');
INSERT INTO `access_log` VALUES (21917, '64.82.15594720703744815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 18:41:10', 2, 0, '', '2019-06-02 18:41:10');
INSERT INTO `access_log` VALUES (21918, '64.77.15594720812654811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 18:41:21', 3, 0, '', '2019-06-02 18:41:21');
INSERT INTO `access_log` VALUES (21919, '64.85.15594720818674817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 18:41:22', 3, 0, '', '2019-06-02 18:41:22');
INSERT INTO `access_log` VALUES (21920, '64.78.15594720837344811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 18:41:24', 3, 0, '', '2019-06-02 18:41:24');
INSERT INTO `access_log` VALUES (21921, '64.79.15594720852574799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 18:41:25', 3, 0, '', '2019-06-02 18:41:25');
INSERT INTO `access_log` VALUES (21922, '64.80.15594720896894799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 18:41:30', 2, 0, '', '2019-06-02 18:41:30');
INSERT INTO `access_log` VALUES (21923, '64.81.15594720900384801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.100.229.86', '2019-06-02 18:41:30', 2, 0, '', '2019-06-02 18:41:30');
INSERT INTO `access_log` VALUES (21924, '65.52.15594723358084981', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '42.100.229.86', '2019-06-02 18:45:36', 1, 1002001015, '账号未登陆', '2019-06-02 18:45:36');
INSERT INTO `access_log` VALUES (21925, '65.51.15594723358144983', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '42.100.229.86', '2019-06-02 18:45:36', 0, 1002001015, '账号未登陆', '2019-06-02 18:45:36');
INSERT INTO `access_log` VALUES (21926, '65.49.15594723358085005', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '42.100.229.86', '2019-06-02 18:45:36', 0, 1002001015, '账号未登陆', '2019-06-02 18:45:36');
INSERT INTO `access_log` VALUES (21927, '65.54.15594723427134973', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '118.26.73.237', '2019-06-02 18:45:43', 0, 1002001015, '账号未登陆', '2019-06-02 18:45:43');
INSERT INTO `access_log` VALUES (21928, '65.46.15594723427204993', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '118.26.73.237', '2019-06-02 18:45:43', 1, 1002001015, '账号未登陆', '2019-06-02 18:45:43');
INSERT INTO `access_log` VALUES (21929, '65.45.15594723427204997', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '118.26.73.237', '2019-06-02 18:45:43', 0, 1002001015, '账号未登陆', '2019-06-02 18:45:43');
INSERT INTO `access_log` VALUES (21930, '65.53.15594723516044979', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '118.26.73.237', '2019-06-02 18:45:52', 1, 1002001015, '账号未登陆', '2019-06-02 18:45:52');
INSERT INTO `access_log` VALUES (21931, '65.50.15594723516124991', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '118.26.73.237', '2019-06-02 18:45:52', 1, 1002001015, '账号未登陆', '2019-06-02 18:45:52');
INSERT INTO `access_log` VALUES (21932, '65.48.15594723516174999', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '118.26.73.237', '2019-06-02 18:45:52', 0, 1002001015, '账号未登陆', '2019-06-02 18:45:52');
INSERT INTO `access_log` VALUES (21933, '65.49.15594723545265007', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '118.26.73.237', '2019-06-02 18:45:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 18:45:55');
INSERT INTO `access_log` VALUES (21934, '65.52.15594723618274983', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '118.26.73.237', '2019-06-02 18:46:02', 275, 0, '', '2019-06-02 18:46:02');
INSERT INTO `access_log` VALUES (21935, '65.47.15594723678715001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '118.26.73.237', '2019-06-02 18:46:08', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 18:46:08');
INSERT INTO `access_log` VALUES (21936, '65.45.15594723749784999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '118.26.73.237', '2019-06-02 18:46:15', 81, 0, '', '2019-06-02 18:46:15');
INSERT INTO `access_log` VALUES (21937, '65.53.15594723967114981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '118.26.73.237', '2019-06-02 18:46:37', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 18:46:37');
INSERT INTO `access_log` VALUES (21938, '65.48.15594724119405001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:46:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 18:46:52');
INSERT INTO `access_log` VALUES (21939, '65.51.15594724123344987', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:46:52', 1, 1002001015, '账号未登陆', '2019-06-02 18:46:52');
INSERT INTO `access_log` VALUES (21940, '65.49.15594724123405009', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:46:52', 0, 1002001015, '账号未登陆', '2019-06-02 18:46:52');
INSERT INTO `access_log` VALUES (21941, '65.52.15594724123434985', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:46:52', 0, 1002001015, '账号未登陆', '2019-06-02 18:46:52');
INSERT INTO `access_log` VALUES (21942, '65.46.15594724263424997', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:47:06', 98, 0, '', '2019-06-02 18:47:06');
INSERT INTO `access_log` VALUES (21943, '65.45.15594724268185001', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:47:07', 9, 0, '', '2019-06-02 18:47:07');
INSERT INTO `access_log` VALUES (21944, '65.53.15594724268284983', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:47:07', 8, 0, '', '2019-06-02 18:47:07');
INSERT INTO `access_log` VALUES (21945, '65.54.15594724268284977', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:47:07', 9, 0, '', '2019-06-02 18:47:07');
INSERT INTO `access_log` VALUES (21946, '62.86.15594724371865127', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:47:17', 11, 0, '', '2019-06-02 18:47:17');
INSERT INTO `access_log` VALUES (21947, '62.88.15594724442775145', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:47:24', 14, 0, '', '2019-06-02 18:47:24');
INSERT INTO `access_log` VALUES (21948, '65.49.15594724585365011', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '42.100.229.86', '2019-06-02 18:47:39', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 18:47:39');
INSERT INTO `access_log` VALUES (21949, '62.84.15594724605555125', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:47:41', 15, 0, '', '2019-06-02 18:47:41');
INSERT INTO `access_log` VALUES (21950, '64.78.15594724640434817', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:47:44', 75, 0, '', '2019-06-02 18:47:44');
INSERT INTO `access_log` VALUES (21951, '64.85.15594724640384823', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:47:44', 83, 0, '', '2019-06-02 18:47:44');
INSERT INTO `access_log` VALUES (21952, '64.81.15594724712844807', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:47:51', 11, 0, '', '2019-06-02 18:47:51');
INSERT INTO `access_log` VALUES (21953, '64.80.15594724712824805', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:47:51', 40, 0, '', '2019-06-02 18:47:51');
INSERT INTO `access_log` VALUES (21954, '65.47.15594724862885005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '42.100.229.86', '2019-06-02 18:48:06', 49, 0, '', '2019-06-02 18:48:06');
INSERT INTO `access_log` VALUES (21955, '65.46.15594724868234999', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '42.100.229.86', '2019-06-02 18:48:07', 8, 0, '', '2019-06-02 18:48:07');
INSERT INTO `access_log` VALUES (21956, '65.54.15594724868374979', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '42.100.229.86', '2019-06-02 18:48:07', 9, 0, '', '2019-06-02 18:48:07');
INSERT INTO `access_log` VALUES (21957, '65.45.15594724868465003', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '42.100.229.86', '2019-06-02 18:48:07', 8, 0, '', '2019-06-02 18:48:07');
INSERT INTO `access_log` VALUES (21958, '62.82.15594724938705149', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '42.100.229.86', '2019-06-02 18:48:14', 14, 0, '', '2019-06-02 18:48:14');
INSERT INTO `access_log` VALUES (21959, '64.84.15594724988634817', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:48:19', 11, 0, '', '2019-06-02 18:48:19');
INSERT INTO `access_log` VALUES (21960, '62.87.15594725029495147', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '42.100.229.86', '2019-06-02 18:48:23', 12, 0, '', '2019-06-02 18:48:23');
INSERT INTO `access_log` VALUES (21961, '64.77.15594725234794819', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '42.100.229.86', '2019-06-02 18:48:43', 11, 0, '', '2019-06-02 18:48:43');
INSERT INTO `access_log` VALUES (21962, '64.78.15594725234924819', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '42.100.229.86', '2019-06-02 18:48:43', 8, 0, '', '2019-06-02 18:48:44');
INSERT INTO `access_log` VALUES (21963, '66.53.15594725382424039', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:48:58', 23, 0, '', '2019-06-02 18:48:58');
INSERT INTO `access_log` VALUES (21964, '59.77.15594725489985261', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:49:09', 18, 0, '', '2019-06-02 18:49:09');
INSERT INTO `access_log` VALUES (21965, '59.80.15594725540855265', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:49:14', 20, 2001001000, '服务端发生异常', '2019-06-02 18:49:14');
INSERT INTO `access_log` VALUES (21966, '59.79.15594725590115269', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:49:19', 12, 0, '', '2019-06-02 18:49:19');
INSERT INTO `access_log` VALUES (21967, '64.80.15594725612144807', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:49:21', 10, 0, '', '2019-06-02 18:49:21');
INSERT INTO `access_log` VALUES (21968, '65.53.15594726168054987', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:17', 9, 0, '', '2019-06-02 18:50:17');
INSERT INTO `access_log` VALUES (21969, '65.54.15594726168054981', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:17', 10, 0, '', '2019-06-02 18:50:17');
INSERT INTO `access_log` VALUES (21970, '65.50.15594726168174999', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:17', 9, 0, '', '2019-06-02 18:50:17');
INSERT INTO `access_log` VALUES (21971, '59.74.15594726169045267', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:17', 19, 2001001000, '服务端发生异常', '2019-06-02 18:50:17');
INSERT INTO `access_log` VALUES (21972, '59.72.15594726210615267', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:21', 13, 0, '', '2019-06-02 18:50:21');
INSERT INTO `access_log` VALUES (21973, '59.77.15594726257965263', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:26', 9, 0, '', '2019-06-02 18:50:26');
INSERT INTO `access_log` VALUES (21974, '59.80.15594726264415267', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:26', 9, 0, '', '2019-06-02 18:50:26');
INSERT INTO `access_log` VALUES (21975, '59.75.15594726270355271', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:27', 48, 0, '', '2019-06-02 18:50:27');
INSERT INTO `access_log` VALUES (21976, '59.79.15594726275835271', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=INVALID&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:28', 10, 0, '', '2019-06-02 18:50:28');
INSERT INTO `access_log` VALUES (21977, '59.71.15594726284835275', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:28', 11, 0, '', '2019-06-02 18:50:28');
INSERT INTO `access_log` VALUES (21978, '59.73.15594726290805275', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:29', 10, 0, '', '2019-06-02 18:50:29');
INSERT INTO `access_log` VALUES (21979, '59.76.15594726338165265', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:34', 12, 0, '', '2019-06-02 18:50:34');
INSERT INTO `access_log` VALUES (21980, '59.78.15594726357075275', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:36', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 18:50:36');
INSERT INTO `access_log` VALUES (21981, '65.49.15594726385255015', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:39', 18, 0, '', '2019-06-02 18:50:39');
INSERT INTO `access_log` VALUES (21982, '65.52.15594726418534991', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:42', 12, 0, '', '2019-06-02 18:50:42');
INSERT INTO `access_log` VALUES (21983, '65.47.15594726447595009', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:45', 11, 0, '', '2019-06-02 18:50:45');
INSERT INTO `access_log` VALUES (21984, '65.46.15594726474785003', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:47', 11, 0, '', '2019-06-02 18:50:47');
INSERT INTO `access_log` VALUES (21985, '65.54.15594726562424983', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:50:56', 9, 0, '', '2019-06-02 18:50:56');
INSERT INTO `access_log` VALUES (21986, '65.53.15594726648294989', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:51:05', 13, 0, '', '2019-06-02 18:51:05');
INSERT INTO `access_log` VALUES (21987, '59.74.15594727626855271', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:52:43', 20, 2001001000, '服务端发生异常', '2019-06-02 18:52:43');
INSERT INTO `access_log` VALUES (21988, '65.45.15594727696235009', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:52:50', 28, 0, '', '2019-06-02 18:52:50');
INSERT INTO `access_log` VALUES (21989, '65.53.15594727741744991', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:52:54', 8, 0, '', '2019-06-02 18:52:54');
INSERT INTO `access_log` VALUES (21990, '65.50.15594727763275003', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:52:56', 19, 0, '', '2019-06-02 18:52:56');
INSERT INTO `access_log` VALUES (21991, '65.48.15594727851185011', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:53:05', 10, 0, '', '2019-06-02 18:53:05');
INSERT INTO `access_log` VALUES (21992, '65.51.15594727896764997', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.26.73.237', '2019-06-02 18:53:10', 102, 0, '', '2019-06-02 18:53:10');
INSERT INTO `access_log` VALUES (21993, '59.80.15594728076465271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.87.58.54', '2019-06-02 18:53:28', 3, 0, '', '2019-06-02 18:53:28');
INSERT INTO `access_log` VALUES (21994, '59.75.15594728076465275', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.87.58.54', '2019-06-02 18:53:28', 13, 2001001000, '服务端发生异常', '2019-06-02 18:53:28');
INSERT INTO `access_log` VALUES (21995, '64.79.15594728157234811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.87.58.54', '2019-06-02 18:53:36', 2, 0, '', '2019-06-02 18:53:36');
INSERT INTO `access_log` VALUES (21996, '64.81.15594728158394813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.87.58.54', '2019-06-02 18:53:36', 2, 0, '', '2019-06-02 18:53:36');
INSERT INTO `access_log` VALUES (21997, '64.80.15594728184884811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.87.58.54', '2019-06-02 18:53:38', 2, 0, '', '2019-06-02 18:53:38');
INSERT INTO `access_log` VALUES (21998, '64.76.15594728191384809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.87.58.54', '2019-06-02 18:53:39', 2, 0, '', '2019-06-02 18:53:39');
INSERT INTO `access_log` VALUES (21999, '64.84.15594728194864823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.87.58.54', '2019-06-02 18:53:39', 2, 0, '', '2019-06-02 18:53:39');
INSERT INTO `access_log` VALUES (22000, '64.82.15594728197384829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.87.58.54', '2019-06-02 18:53:40', 2, 0, '', '2019-06-02 18:53:40');
INSERT INTO `access_log` VALUES (22001, '65.54.15594737615644999', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-06-02 19:09:22', 0, 1002001015, '账号未登陆', '2019-06-02 19:09:22');
INSERT INTO `access_log` VALUES (22002, '65.53.15594737615745005', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-06-02 19:09:22', 0, 1002001015, '账号未登陆', '2019-06-02 19:09:22');
INSERT INTO `access_log` VALUES (22003, '65.50.15594737616005017', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-06-02 19:09:22', 0, 1002001015, '账号未登陆', '2019-06-02 19:09:22');
INSERT INTO `access_log` VALUES (22004, '65.49.15594737678705033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-06-02 19:09:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 19:09:28');
INSERT INTO `access_log` VALUES (22005, '65.51.15594737773055011', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-06-02 19:09:37', 78, 0, '', '2019-06-02 19:09:37');
INSERT INTO `access_log` VALUES (22006, '65.47.15594737884525027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-06-02 19:09:48', 130, 0, '', '2019-06-02 19:09:49');
INSERT INTO `access_log` VALUES (22007, '65.53.15594738400605007', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:10:40', 0, 1002001015, '账号未登陆', '2019-06-02 19:10:40');
INSERT INTO `access_log` VALUES (22008, '65.49.15594738400775035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:10:40', 1, 1002001015, '账号未登陆', '2019-06-02 19:10:40');
INSERT INTO `access_log` VALUES (22009, '65.48.15594738400775027', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:10:40', 1, 1002001015, '账号未登陆', '2019-06-02 19:10:40');
INSERT INTO `access_log` VALUES (22010, '65.51.15594738502705013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:10:50', 82, 0, '', '2019-06-02 19:10:50');
INSERT INTO `access_log` VALUES (22011, '65.52.15594738505345011', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:10:51', 10, 0, '', '2019-06-02 19:10:51');
INSERT INTO `access_log` VALUES (22012, '65.47.15594738505375029', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:10:51', 8, 0, '', '2019-06-02 19:10:51');
INSERT INTO `access_log` VALUES (22013, '65.46.15594738505575023', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:10:51', 9, 0, '', '2019-06-02 19:10:51');
INSERT INTO `access_log` VALUES (22014, '62.88.15594738571065165', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:10:57', 14, 0, '', '2019-06-02 19:10:57');
INSERT INTO `access_log` VALUES (22015, '64.83.15594738717894827', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:11:12', 12, 0, '', '2019-06-02 19:11:12');
INSERT INTO `access_log` VALUES (22016, '64.78.15594738717924839', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:11:12', 9, 0, '', '2019-06-02 19:11:12');
INSERT INTO `access_log` VALUES (22017, '64.85.15594738765644845', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:11:17', 8, 0, '', '2019-06-02 19:11:17');
INSERT INTO `access_log` VALUES (22018, '64.77.15594738765624839', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:11:17', 11, 0, '', '2019-06-02 19:11:17');
INSERT INTO `access_log` VALUES (22019, '64.80.15594738848064827', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:11:25', 11, 0, '', '2019-06-02 19:11:25');
INSERT INTO `access_log` VALUES (22020, '64.76.15594738848104825', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:11:25', 8, 0, '', '2019-06-02 19:11:25');
INSERT INTO `access_log` VALUES (22021, '64.81.15594738848054829', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.62.130', '2019-06-02 19:11:25', 14, 0, '', '2019-06-02 19:11:25');
INSERT INTO `access_log` VALUES (22022, '59.77.15594747029675293', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.98.116.233', '2019-06-02 19:25:03', 14, 2001001000, '服务端发生异常', '2019-06-02 19:25:03');
INSERT INTO `access_log` VALUES (22023, '59.72.15594747029665297', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.98.116.233', '2019-06-02 19:25:03', 33, 0, '', '2019-06-02 19:25:03');
INSERT INTO `access_log` VALUES (22024, '64.85.15594747093184857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.98.116.233', '2019-06-02 19:25:09', 7, 0, '', '2019-06-02 19:25:09');
INSERT INTO `access_log` VALUES (22025, '64.79.15594747094434839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.98.116.233', '2019-06-02 19:25:09', 4, 0, '', '2019-06-02 19:25:09');
INSERT INTO `access_log` VALUES (22026, '64.81.15594747109454841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.98.116.233', '2019-06-02 19:25:11', 2, 0, '', '2019-06-02 19:25:11');
INSERT INTO `access_log` VALUES (22027, '64.80.15594747115644839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.98.116.233', '2019-06-02 19:25:12', 2, 0, '', '2019-06-02 19:25:12');
INSERT INTO `access_log` VALUES (22028, '64.76.15594747121574837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.98.116.233', '2019-06-02 19:25:12', 3, 0, '', '2019-06-02 19:25:12');
INSERT INTO `access_log` VALUES (22029, '65.48.15594753737145049', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 19:36:14', 4, 1002001012, '访问令牌已过期', '2019-06-02 19:36:14');
INSERT INTO `access_log` VALUES (22030, '65.49.15594753737145057', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 19:36:14', 4, 1002001012, '访问令牌已过期', '2019-06-02 19:36:14');
INSERT INTO `access_log` VALUES (22031, '65.54.15594753737145023', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 19:36:14', 4, 1002001012, '访问令牌已过期', '2019-06-02 19:36:14');
INSERT INTO `access_log` VALUES (22032, '65.53.15594753763295029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 19:36:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 19:36:16');
INSERT INTO `access_log` VALUES (22033, '65.46.15594754085995045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 19:36:49', 141, 0, '', '2019-06-02 19:36:49');
INSERT INTO `access_log` VALUES (22034, '65.52.15594754090835033', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 19:36:49', 10, 0, '', '2019-06-02 19:36:49');
INSERT INTO `access_log` VALUES (22035, '65.45.15594754090905049', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 19:36:49', 9, 0, '', '2019-06-02 19:36:49');
INSERT INTO `access_log` VALUES (22036, '65.50.15594754090985043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 19:36:49', 8, 0, '', '2019-06-02 19:36:49');
INSERT INTO `access_log` VALUES (22037, '62.87.15594754496955187', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 19:37:30', 13, 0, '', '2019-06-02 19:37:30');
INSERT INTO `access_log` VALUES (22038, '62.88.15594754783995187', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=6&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 19:37:58', 12, 0, '', '2019-06-02 19:37:58');
INSERT INTO `access_log` VALUES (22039, '62.84.15594754916975167', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 19:38:12', 15, 0, '', '2019-06-02 19:38:12');
INSERT INTO `access_log` VALUES (22040, '66.52.15594755088664079', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 Edge/16.16299', '223.72.63.28', '2019-06-02 19:38:29', 22, 0, '', '2019-06-02 19:38:29');
INSERT INTO `access_log` VALUES (22041, '59.80.15594780000445341', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.90.92.106', '2019-06-02 20:20:00', 12, 0, '', '2019-06-02 20:20:00');
INSERT INTO `access_log` VALUES (22042, '59.75.15594780000445345', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.90.92.106', '2019-06-02 20:20:00', 15, 2001001000, '服务端发生异常', '2019-06-02 20:20:00');
INSERT INTO `access_log` VALUES (22043, '64.84.15594780184794895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '42.90.92.106', '2019-06-02 20:20:18', 11, 0, '', '2019-06-02 20:20:18');
INSERT INTO `access_log` VALUES (22044, '64.82.15594780188614901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '42.90.92.106', '2019-06-02 20:20:19', 3, 0, '', '2019-06-02 20:20:19');
INSERT INTO `access_log` VALUES (22045, '64.78.15594780214014897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '42.90.92.106', '2019-06-02 20:20:21', 2, 0, '', '2019-06-02 20:20:21');
INSERT INTO `access_log` VALUES (22046, '64.77.15594780221314897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '42.90.92.106', '2019-06-02 20:20:22', 2, 0, '', '2019-06-02 20:20:22');
INSERT INTO `access_log` VALUES (22047, '64.85.15594780243614903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '42.90.92.106', '2019-06-02 20:20:24', 2, 0, '', '2019-06-02 20:20:24');
INSERT INTO `access_log` VALUES (22048, '64.79.15594780252394885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '42.90.92.106', '2019-06-02 20:20:25', 2, 0, '', '2019-06-02 20:20:25');
INSERT INTO `access_log` VALUES (22049, '64.81.15594780265314887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '42.90.92.106', '2019-06-02 20:20:27', 2, 0, '', '2019-06-02 20:20:27');
INSERT INTO `access_log` VALUES (22050, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=人v&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '42.90.92.106', '2019-06-02 20:20:32', 17, 0, '', '2019-06-02 20:20:32');
INSERT INTO `access_log` VALUES (22051, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=人v', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '42.90.92.106', '2019-06-02 20:20:32', 9, 0, '', '2019-06-02 20:20:32');
INSERT INTO `access_log` VALUES (22052, '65.48.15594792380715105', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:40:38', 0, 1002001015, '账号未登陆', '2019-06-02 20:40:38');
INSERT INTO `access_log` VALUES (22053, '65.50.15594792380705095', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:40:38', 0, 1002001015, '账号未登陆', '2019-06-02 20:40:38');
INSERT INTO `access_log` VALUES (22054, '65.54.15594792380725077', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:40:38', 0, 1002001015, '账号未登陆', '2019-06-02 20:40:38');
INSERT INTO `access_log` VALUES (22055, '65.51.15594792416385087', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:40:42', 64, 0, '', '2019-06-02 20:40:42');
INSERT INTO `access_log` VALUES (22056, '65.53.15594792419295081', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:40:42', 13, 0, '', '2019-06-02 20:40:42');
INSERT INTO `access_log` VALUES (22057, '65.47.15594792419305105', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:40:42', 12, 0, '', '2019-06-02 20:40:42');
INSERT INTO `access_log` VALUES (22058, '65.46.15594792419305099', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:40:42', 12, 0, '', '2019-06-02 20:40:42');
INSERT INTO `access_log` VALUES (22059, '62.89.15594792652475233', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:41:05', 21, 0, '', '2019-06-02 20:41:05');
INSERT INTO `access_log` VALUES (22060, '62.80.15594792745155237', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:41:15', 17, 0, '', '2019-06-02 20:41:15');
INSERT INTO `access_log` VALUES (22061, '64.82.15594792791184919', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:41:19', 9, 0, '', '2019-06-02 20:41:19');
INSERT INTO `access_log` VALUES (22062, '64.83.15594792791184903', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:41:19', 13, 0, '', '2019-06-02 20:41:19');
INSERT INTO `access_log` VALUES (22063, '59.77.15594793021535355', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:41:42', 4, 0, '', '2019-06-02 20:41:42');
INSERT INTO `access_log` VALUES (22064, '59.75.15594793022815363', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:41:42', 20, 2001001000, '服务端发生异常', '2019-06-02 20:41:42');
INSERT INTO `access_log` VALUES (22065, '65.54.15594793073695079', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:41:47', 3, 0, '', '2019-06-02 20:41:47');
INSERT INTO `access_log` VALUES (22066, '64.81.15594793123744905', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:41:52', 12, 0, '', '2019-06-02 20:41:52');
INSERT INTO `access_log` VALUES (22067, '64.79.15594793123744903', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:41:52', 15, 0, '', '2019-06-02 20:41:52');
INSERT INTO `access_log` VALUES (22068, '64.80.15594793178084903', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:41:58', 11, 0, '', '2019-06-02 20:41:58');
INSERT INTO `access_log` VALUES (22069, '64.76.15594793185514901', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:41:59', 55, 0, '', '2019-06-02 20:41:59');
INSERT INTO `access_log` VALUES (22070, '64.84.15594793204064915', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:42:00', 10, 0, '', '2019-06-02 20:42:00');
INSERT INTO `access_log` VALUES (22071, '64.83.15594793211394905', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:42:01', 10, 0, '', '2019-06-02 20:42:01');
INSERT INTO `access_log` VALUES (22072, '64.82.15594793231874921', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:42:03', 11, 0, '', '2019-06-02 20:42:03');
INSERT INTO `access_log` VALUES (22073, '64.78.15594793232004917', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:42:03', 8, 0, '', '2019-06-02 20:42:03');
INSERT INTO `access_log` VALUES (22074, '64.85.15594793259504923', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:42:06', 9, 0, '', '2019-06-02 20:42:06');
INSERT INTO `access_log` VALUES (22075, '66.55.15594793353704137', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:42:15', 1024, 0, '', '2019-06-02 20:42:16');
INSERT INTO `access_log` VALUES (22076, '59.73.15594793394085367', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:42:19', 9, 0, '', '2019-06-02 20:42:19');
INSERT INTO `access_log` VALUES (22077, '59.76.15594793536995357', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:42:34', 20, 2001001000, '服务端发生异常', '2019-06-02 20:42:34');
INSERT INTO `access_log` VALUES (22078, '59.78.15594793572265367', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:42:37', 19, 0, '', '2019-06-02 20:42:37');
INSERT INTO `access_log` VALUES (22079, '64.80.15594793593894905', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.11', '2019-06-02 20:42:39', 10, 0, '', '2019-06-02 20:42:39');
INSERT INTO `access_log` VALUES (22080, '64.82.15594794079934923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:43:28', 3, 0, '', '2019-06-02 20:43:28');
INSERT INTO `access_log` VALUES (22081, '64.78.15594794081114919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:43:28', 2, 0, '', '2019-06-02 20:43:28');
INSERT INTO `access_log` VALUES (22082, '64.77.15594794108844919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:43:31', 2, 0, '', '2019-06-02 20:43:31');
INSERT INTO `access_log` VALUES (22083, '64.85.15594794110254925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:43:31', 2, 0, '', '2019-06-02 20:43:31');
INSERT INTO `access_log` VALUES (22084, '64.81.15594794136064909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:43:34', 2, 0, '', '2019-06-02 20:43:34');
INSERT INTO `access_log` VALUES (22085, '64.79.15594794140144907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:43:34', 3, 0, '', '2019-06-02 20:43:34');
INSERT INTO `access_log` VALUES (22086, '64.80.15594794145004907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:43:35', 3, 0, '', '2019-06-02 20:43:35');
INSERT INTO `access_log` VALUES (22087, '64.76.15594794155024905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:43:36', 2, 0, '', '2019-06-02 20:43:36');
INSERT INTO `access_log` VALUES (22088, '64.83.15594794162654909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:43:36', 2, 0, '', '2019-06-02 20:43:36');
INSERT INTO `access_log` VALUES (22089, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:43:37', 20, 0, '', '2019-06-02 20:43:37');
INSERT INTO `access_log` VALUES (22090, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:43:38', 8, 0, '', '2019-06-02 20:43:38');
INSERT INTO `access_log` VALUES (22091, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:43:38', 7, 0, '', '2019-06-02 20:43:38');
INSERT INTO `access_log` VALUES (22092, '64.82.15594794193054925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:43:39', 2, 0, '', '2019-06-02 20:43:39');
INSERT INTO `access_log` VALUES (22093, '64.78.15594794214364921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.131.110.11', '2019-06-02 20:43:41', 2, 0, '', '2019-06-02 20:43:41');
INSERT INTO `access_log` VALUES (22094, '65.53.15594796621965087', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '27.38.243.96', '2019-06-02 20:47:42', 1, 1002001015, '账号未登陆', '2019-06-02 20:47:42');
INSERT INTO `access_log` VALUES (22095, '65.45.15594796622015111', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '27.38.243.96', '2019-06-02 20:47:42', 0, 1002001015, '账号未登陆', '2019-06-02 20:47:42');
INSERT INTO `access_log` VALUES (22096, '65.52.15594796622025093', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '27.38.243.96', '2019-06-02 20:47:42', 8, 1002001015, '账号未登陆', '2019-06-02 20:47:42');
INSERT INTO `access_log` VALUES (22097, '65.50.15594796647415103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '27.38.243.96', '2019-06-02 20:47:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 20:47:45');
INSERT INTO `access_log` VALUES (22098, '65.47.15594796735135113', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '27.38.243.96', '2019-06-02 20:47:54', 97, 0, '', '2019-06-02 20:47:54');
INSERT INTO `access_log` VALUES (22099, '65.51.15594796745845097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '27.38.243.96', '2019-06-02 20:47:55', 11, 0, '', '2019-06-02 20:47:55');
INSERT INTO `access_log` VALUES (22100, '65.49.15594796745875119', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '27.38.243.96', '2019-06-02 20:47:55', 9, 0, '', '2019-06-02 20:47:55');
INSERT INTO `access_log` VALUES (22101, '65.54.15594796745855085', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '27.38.243.96', '2019-06-02 20:47:55', 11, 0, '', '2019-06-02 20:47:55');
INSERT INTO `access_log` VALUES (22102, '62.80.15594796877455243', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '27.38.243.96', '2019-06-02 20:48:08', 85, 0, '', '2019-06-02 20:48:08');
INSERT INTO `access_log` VALUES (22103, '65.45.15594796945995113', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '27.38.243.96', '2019-06-02 20:48:15', 19, 0, '', '2019-06-02 20:48:15');
INSERT INTO `access_log` VALUES (22104, '59.80.15594797000345365', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '27.38.243.96', '2019-06-02 20:48:20', 12, 0, '', '2019-06-02 20:48:20');
INSERT INTO `access_log` VALUES (22105, '59.79.15594797087765369', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '27.38.243.96', '2019-06-02 20:48:29', 8, 1002002009, NULL, '2019-06-02 20:48:29');
INSERT INTO `access_log` VALUES (22106, '59.73.15594806201805385', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.131.34', '2019-06-02 21:03:40', 3, 0, '', '2019-06-02 21:03:40');
INSERT INTO `access_log` VALUES (22107, '59.76.15594806201835375', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.131.34', '2019-06-02 21:03:40', 10, 2001001000, '服务端发生异常', '2019-06-02 21:03:40');
INSERT INTO `access_log` VALUES (22108, '59.78.15594806340085385', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.131.34', '2019-06-02 21:03:54', 2, 0, '', '2019-06-02 21:03:54');
INSERT INTO `access_log` VALUES (22109, '59.72.15594806340085379', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.131.34', '2019-06-02 21:03:54', 22, 2001001000, '服务端发生异常', '2019-06-02 21:03:54');
INSERT INTO `access_log` VALUES (22110, '59.80.15594812468285387', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:07', 4, 0, '', '2019-06-02 21:14:07');
INSERT INTO `access_log` VALUES (22111, '59.75.15594812468285391', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:07', 14, 2001001000, '服务端发生异常', '2019-06-02 21:14:07');
INSERT INTO `access_log` VALUES (22112, '64.81.15594812515014935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:12', 11, 0, '', '2019-06-02 21:14:12');
INSERT INTO `access_log` VALUES (22113, '64.79.15594812517484933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:12', 3, 0, '', '2019-06-02 21:14:12');
INSERT INTO `access_log` VALUES (22114, '64.80.15594812533734933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:13', 2, 0, '', '2019-06-02 21:14:13');
INSERT INTO `access_log` VALUES (22115, '64.84.15594812542274945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:14', 2, 0, '', '2019-06-02 21:14:14');
INSERT INTO `access_log` VALUES (22116, '64.76.15594812551334931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:15', 3, 0, '', '2019-06-02 21:14:15');
INSERT INTO `access_log` VALUES (22117, '64.83.15594812567394935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:17', 2, 0, '', '2019-06-02 21:14:17');
INSERT INTO `access_log` VALUES (22118, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:17', 31, 0, '', '2019-06-02 21:14:17');
INSERT INTO `access_log` VALUES (22119, '64.82.15594812587874951', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:19', 56, 0, '', '2019-06-02 21:14:19');
INSERT INTO `access_log` VALUES (22120, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:25', 7, 0, '', '2019-06-02 21:14:25');
INSERT INTO `access_log` VALUES (22121, '64.77.15594812650324947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:25', 70, 0, '', '2019-06-02 21:14:25');
INSERT INTO `access_log` VALUES (22122, '64.85.15594812661454953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:26', 2, 0, '', '2019-06-02 21:14:26');
INSERT INTO `access_log` VALUES (22123, '64.81.15594812663744937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:26', 2, 0, '', '2019-06-02 21:14:26');
INSERT INTO `access_log` VALUES (22124, '64.79.15594812693534935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:29', 2, 0, '', '2019-06-02 21:14:29');
INSERT INTO `access_log` VALUES (22125, '64.80.15594812695734935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:30', 3, 0, '', '2019-06-02 21:14:30');
INSERT INTO `access_log` VALUES (22126, '59.71.15594812725565395', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:33', 3, 0, '', '2019-06-02 21:14:33');
INSERT INTO `access_log` VALUES (22127, '59.76.15594812725565385', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:33', 13, 2001001000, '服务端发生异常', '2019-06-02 21:14:33');
INSERT INTO `access_log` VALUES (22128, '64.76.15594812761664933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:36', 2, 0, '', '2019-06-02 21:14:36');
INSERT INTO `access_log` VALUES (22129, '64.83.15594812763844937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:36', 2, 0, '', '2019-06-02 21:14:36');
INSERT INTO `access_log` VALUES (22130, '59.74.15594812773745389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:37', 3, 0, '', '2019-06-02 21:14:37');
INSERT INTO `access_log` VALUES (22131, '59.78.15594812773745395', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:37', 19, 2001001000, '服务端发生异常', '2019-06-02 21:14:37');
INSERT INTO `access_log` VALUES (22132, '64.82.15594812830494953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:43', 2, 0, '', '2019-06-02 21:14:43');
INSERT INTO `access_log` VALUES (22133, '64.78.15594812832674949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:43', 2, 0, '', '2019-06-02 21:14:43');
INSERT INTO `access_log` VALUES (22134, '59.72.15594812841955389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:44', 3, 0, '', '2019-06-02 21:14:44');
INSERT INTO `access_log` VALUES (22135, '59.77.15594812841975385', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:44', 13, 2001001000, '服务端发生异常', '2019-06-02 21:14:44');
INSERT INTO `access_log` VALUES (22136, '64.77.15594812880384949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:48', 2, 0, '', '2019-06-02 21:14:48');
INSERT INTO `access_log` VALUES (22137, '64.85.15594812882634955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:48', 2, 0, '', '2019-06-02 21:14:48');
INSERT INTO `access_log` VALUES (22138, '59.80.15594812885735389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:49', 2, 0, '', '2019-06-02 21:14:49');
INSERT INTO `access_log` VALUES (22139, '59.75.15594812885745393', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:14:49', 13, 2001001000, '服务端发生异常', '2019-06-02 21:14:49');
INSERT INTO `access_log` VALUES (22140, '65.46.15594813138265129', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:15:14', 1, 1002001015, '账号未登陆', '2019-06-02 21:15:14');
INSERT INTO `access_log` VALUES (22141, '65.45.15594813138275135', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:15:14', 1, 1002001015, '账号未登陆', '2019-06-02 21:15:14');
INSERT INTO `access_log` VALUES (22142, '65.52.15594813138285117', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:15:14', 0, 1002001015, '账号未登陆', '2019-06-02 21:15:14');
INSERT INTO `access_log` VALUES (22143, '65.50.15594813291095127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:15:29', 65, 0, '', '2019-06-02 21:15:29');
INSERT INTO `access_log` VALUES (22144, '65.47.15594813301895137', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:15:30', 10, 0, '', '2019-06-02 21:15:30');
INSERT INTO `access_log` VALUES (22145, '65.48.15594813301985137', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:15:30', 9, 0, '', '2019-06-02 21:15:30');
INSERT INTO `access_log` VALUES (22146, '65.51.15594813301995121', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:15:30', 8, 0, '', '2019-06-02 21:15:30');
INSERT INTO `access_log` VALUES (22147, '65.54.15594813390695109', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:15:39', 8, 0, '', '2019-06-02 21:15:39');
INSERT INTO `access_log` VALUES (22148, '65.45.15594813390775137', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:15:39', 9, 0, '', '2019-06-02 21:15:39');
INSERT INTO `access_log` VALUES (22149, '65.52.15594813390785119', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:15:39', 8, 0, '', '2019-06-02 21:15:39');
INSERT INTO `access_log` VALUES (22150, '65.46.15594813445575131', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:15:45', 9, 0, '', '2019-06-02 21:15:45');
INSERT INTO `access_log` VALUES (22151, '65.53.15594813445805113', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:15:45', 8, 0, '', '2019-06-02 21:15:45');
INSERT INTO `access_log` VALUES (22152, '65.50.15594813446425129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:15:45', 9, 0, '', '2019-06-02 21:15:45');
INSERT INTO `access_log` VALUES (22153, '62.86.15594813452495249', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:15:45', 15, 0, '', '2019-06-02 21:15:45');
INSERT INTO `access_log` VALUES (22154, '65.48.15594813607095139', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:01', 109, 0, '', '2019-06-02 21:16:01');
INSERT INTO `access_log` VALUES (22155, '65.47.15594813607205139', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:01', 99, 0, '', '2019-06-02 21:16:01');
INSERT INTO `access_log` VALUES (22156, '65.49.15594813607495145', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:01', 69, 0, '', '2019-06-02 21:16:01');
INSERT INTO `access_log` VALUES (22157, '65.45.15594813610885139', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:01', 18, 0, '', '2019-06-02 21:16:01');
INSERT INTO `access_log` VALUES (22158, '65.52.15594813687695121', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:09', 17, 0, '', '2019-06-02 21:16:09');
INSERT INTO `access_log` VALUES (22159, '65.46.15594813747785133', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:15', 8, 0, '', '2019-06-02 21:16:15');
INSERT INTO `access_log` VALUES (22160, '65.53.15594813747935115', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:15', 9, 0, '', '2019-06-02 21:16:15');
INSERT INTO `access_log` VALUES (22161, '65.50.15594813748075131', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:15', 9, 0, '', '2019-06-02 21:16:15');
INSERT INTO `access_log` VALUES (22162, '65.51.15594813751635125', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:15', 177, 0, '', '2019-06-02 21:16:15');
INSERT INTO `access_log` VALUES (22163, '65.48.15594813783965141', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:18', 13, 0, '', '2019-06-02 21:16:18');
INSERT INTO `access_log` VALUES (22164, '65.47.15594813915695141', 27, 2, 'admin-application', '/admin-api/admins/role/delete', 'id=6', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:32', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-02 21:16:32');
INSERT INTO `access_log` VALUES (22165, '65.45.15594813918405141', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:32', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-06-02 21:16:32');
INSERT INTO `access_log` VALUES (22166, '65.54.15594814014785113', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:41', 9, 0, '', '2019-06-02 21:16:41');
INSERT INTO `access_log` VALUES (22167, '65.53.15594814014925117', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:41', 9, 0, '', '2019-06-02 21:16:42');
INSERT INTO `access_log` VALUES (22168, '65.46.15594814015065135', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:42', 9, 0, '', '2019-06-02 21:16:42');
INSERT INTO `access_log` VALUES (22169, '59.80.15594814019295391', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:42', 12, 0, '', '2019-06-02 21:16:42');
INSERT INTO `access_log` VALUES (22170, '65.51.15594814141225127', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:54', 8, 0, '', '2019-06-02 21:16:54');
INSERT INTO `access_log` VALUES (22171, '65.48.15594814141245143', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:54', 7, 0, '', '2019-06-02 21:16:54');
INSERT INTO `access_log` VALUES (22172, '65.49.15594814141645149', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:54', 9, 0, '', '2019-06-02 21:16:54');
INSERT INTO `access_log` VALUES (22173, '59.79.15594814145325395', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:16:55', 19, 2001001000, '服务端发生异常', '2019-06-02 21:16:55');
INSERT INTO `access_log` VALUES (22174, '65.47.15594814201785143', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:17:00', 9, 0, '', '2019-06-02 21:17:00');
INSERT INTO `access_log` VALUES (22175, '65.45.15594814201895143', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:17:00', 9, 0, '', '2019-06-02 21:17:00');
INSERT INTO `access_log` VALUES (22176, '65.52.15594814201955125', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:17:00', 8, 0, '', '2019-06-02 21:17:00');
INSERT INTO `access_log` VALUES (22177, '66.52.15594814206014159', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:17:01', 22, 0, '', '2019-06-02 21:17:01');
INSERT INTO `access_log` VALUES (22178, '65.53.15594814285295119', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:17:09', 9, 0, '', '2019-06-02 21:17:09');
INSERT INTO `access_log` VALUES (22179, '65.46.15594814285315137', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:17:09', 9, 0, '', '2019-06-02 21:17:09');
INSERT INTO `access_log` VALUES (22180, '65.54.15594814285305115', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-Hans-CN; SM-G9500 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.0.110 Mobile Safari/537.36', '117.136.75.253', '2019-06-02 21:17:09', 9, 0, '', '2019-06-02 21:17:09');
INSERT INTO `access_log` VALUES (22181, '65.53.15594815370745121', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.170.185', '2019-06-02 21:18:57', 3, 1002001012, '访问令牌已过期', '2019-06-02 21:18:57');
INSERT INTO `access_log` VALUES (22182, '65.54.15594815370775117', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.170.185', '2019-06-02 21:18:57', 2, 1002001012, '访问令牌已过期', '2019-06-02 21:18:57');
INSERT INTO `access_log` VALUES (22183, '65.50.15594815370845137', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.170.185', '2019-06-02 21:18:57', 3, 1002001012, '访问令牌已过期', '2019-06-02 21:18:57');
INSERT INTO `access_log` VALUES (22184, '65.49.15594815663415153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.170.185', '2019-06-02 21:19:26', 99, 0, '', '2019-06-02 21:19:26');
INSERT INTO `access_log` VALUES (22185, '65.47.15594815666865147', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.170.185', '2019-06-02 21:19:27', 18, 0, '', '2019-06-02 21:19:27');
INSERT INTO `access_log` VALUES (22186, '65.45.15594815666885147', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.170.185', '2019-06-02 21:19:27', 8, 0, '', '2019-06-02 21:19:27');
INSERT INTO `access_log` VALUES (22187, '65.52.15594815666995129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.170.185', '2019-06-02 21:19:27', 9, 0, '', '2019-06-02 21:19:27');
INSERT INTO `access_log` VALUES (22188, '65.50.15594815794765139', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.170.185', '2019-06-02 21:19:39', 16, 0, '', '2019-06-02 21:19:39');
INSERT INTO `access_log` VALUES (22189, '65.53.15594815828605123', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.170.185', '2019-06-02 21:19:43', 12, 0, '', '2019-06-02 21:19:43');
INSERT INTO `access_log` VALUES (22190, '65.48.15594815953565149', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.170.185', '2019-06-02 21:19:55', 10, 0, '', '2019-06-02 21:19:55');
INSERT INTO `access_log` VALUES (22191, '65.51.15594815968355133', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.170.185', '2019-06-02 21:19:57', 10, 0, '', '2019-06-02 21:19:57');
INSERT INTO `access_log` VALUES (22192, '65.47.15594816229305149', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.170.185', '2019-06-02 21:20:23', 15, 0, '', '2019-06-02 21:20:23');
INSERT INTO `access_log` VALUES (22193, '59.74.15594816322925395', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '36.48.79.229', '2019-06-02 21:20:32', 4, 0, '', '2019-06-02 21:20:32');
INSERT INTO `access_log` VALUES (22194, '59.72.15594816322985395', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '36.48.79.229', '2019-06-02 21:20:32', 12, 2001001000, '服务端发生异常', '2019-06-02 21:20:32');
INSERT INTO `access_log` VALUES (22195, '64.76.15594816372154939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '36.48.79.229', '2019-06-02 21:20:37', 3, 0, '', '2019-06-02 21:20:37');
INSERT INTO `access_log` VALUES (22196, '64.83.15594816373684943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '36.48.79.229', '2019-06-02 21:20:37', 2, 0, '', '2019-06-02 21:20:37');
INSERT INTO `access_log` VALUES (22197, '64.82.15594816385164959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '36.48.79.229', '2019-06-02 21:20:39', 2, 0, '', '2019-06-02 21:20:39');
INSERT INTO `access_log` VALUES (22198, '64.78.15594816393984955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '36.48.79.229', '2019-06-02 21:20:39', 2, 0, '', '2019-06-02 21:20:39');
INSERT INTO `access_log` VALUES (22199, '65.54.15594816915225121', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '36.48.79.229', '2019-06-02 21:21:32', 0, 1002001015, '账号未登陆', '2019-06-02 21:21:32');
INSERT INTO `access_log` VALUES (22200, '65.48.15594816915225151', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '36.48.79.229', '2019-06-02 21:21:32', 0, 1002001015, '账号未登陆', '2019-06-02 21:21:32');
INSERT INTO `access_log` VALUES (22201, '65.51.15594816915265135', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '36.48.79.229', '2019-06-02 21:21:32', 0, 1002001015, '账号未登陆', '2019-06-02 21:21:32');
INSERT INTO `access_log` VALUES (22202, '65.45.15594817177705151', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '36.48.79.229', '2019-06-02 21:21:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 21:21:58');
INSERT INTO `access_log` VALUES (22203, '65.53.15594817595495127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '36.48.79.229', '2019-06-02 21:22:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 21:22:40');
INSERT INTO `access_log` VALUES (22204, '59.72.15594820496495401', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:27:30', 3, 0, '', '2019-06-02 21:27:30');
INSERT INTO `access_log` VALUES (22205, '59.74.15594820496515401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:27:30', 13, 2001001000, '服务端发生异常', '2019-06-02 21:27:30');
INSERT INTO `access_log` VALUES (22206, '64.82.15594820583194965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:27:38', 3, 0, '', '2019-06-02 21:27:38');
INSERT INTO `access_log` VALUES (22207, '64.78.15594820584034961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:27:38', 2, 0, '', '2019-06-02 21:27:38');
INSERT INTO `access_log` VALUES (22208, '64.77.15594820630194961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:27:43', 2, 0, '', '2019-06-02 21:27:43');
INSERT INTO `access_log` VALUES (22209, '64.81.15594820811494951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:01', 2, 0, '', '2019-06-02 21:28:01');
INSERT INTO `access_log` VALUES (22210, '64.79.15594820812724949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:01', 2, 0, '', '2019-06-02 21:28:01');
INSERT INTO `access_log` VALUES (22211, '59.75.15594820833495405', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:03', 2, 0, '', '2019-06-02 21:28:03');
INSERT INTO `access_log` VALUES (22212, '59.79.15594820833515405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:03', 9, 2001001000, '服务端发生异常', '2019-06-02 21:28:03');
INSERT INTO `access_log` VALUES (22213, '64.84.15594820876284961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:08', 2, 0, '', '2019-06-02 21:28:08');
INSERT INTO `access_log` VALUES (22214, '64.76.15594820877714947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:08', 2, 0, '', '2019-06-02 21:28:08');
INSERT INTO `access_log` VALUES (22215, '64.83.15594820910754951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:11', 2, 0, '', '2019-06-02 21:28:11');
INSERT INTO `access_log` VALUES (22216, '64.82.15594820911614967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:11', 2, 0, '', '2019-06-02 21:28:11');
INSERT INTO `access_log` VALUES (22217, '59.76.15594820912395399', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:11', 3, 0, '', '2019-06-02 21:28:11');
INSERT INTO `access_log` VALUES (22218, '59.73.15594820912515409', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:11', 13, 2001001000, '服务端发生异常', '2019-06-02 21:28:11');
INSERT INTO `access_log` VALUES (22219, '65.49.15594821067775163', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:27', 1, 1002001015, '账号未登陆', '2019-06-02 21:28:27');
INSERT INTO `access_log` VALUES (22220, '65.47.15594821067795157', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:27', 0, 1002001015, '账号未登陆', '2019-06-02 21:28:27');
INSERT INTO `access_log` VALUES (22221, '65.45.15594821068145157', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:27', 1, 1002001015, '账号未登陆', '2019-06-02 21:28:27');
INSERT INTO `access_log` VALUES (22222, '65.52.15594821102505139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 21:28:30');
INSERT INTO `access_log` VALUES (22223, '65.50.15594821193945149', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:28:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 21:28:39');
INSERT INTO `access_log` VALUES (22224, '65.48.15594821480395159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:29:08', 69, 0, '', '2019-06-02 21:29:08');
INSERT INTO `access_log` VALUES (22225, '65.54.15594821484245129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:29:08', 231, 0, '', '2019-06-02 21:29:09');
INSERT INTO `access_log` VALUES (22226, '65.47.15594821484325159', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:29:08', 225, 0, '', '2019-06-02 21:29:09');
INSERT INTO `access_log` VALUES (22227, '65.51.15594821484285143', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:29:08', 229, 0, '', '2019-06-02 21:29:09');
INSERT INTO `access_log` VALUES (22228, '62.83.15594821622145271', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:29:22', 13, 0, '', '2019-06-02 21:29:22');
INSERT INTO `access_log` VALUES (22229, '64.76.15594821798224949', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:29:40', 10, 0, '', '2019-06-02 21:29:40');
INSERT INTO `access_log` VALUES (22230, '64.84.15594821798194963', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:29:40', 14, 0, '', '2019-06-02 21:29:40');
INSERT INTO `access_log` VALUES (22231, '64.83.15594821843074953', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:29:44', 12, 0, '', '2019-06-02 21:29:44');
INSERT INTO `access_log` VALUES (22232, '62.84.15594821947865259', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:29:55', 12, 0, '', '2019-06-02 21:29:55');
INSERT INTO `access_log` VALUES (22233, '66.56.15594822247754165', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:30:25', 15, 0, '', '2019-06-02 21:30:25');
INSERT INTO `access_log` VALUES (22234, '59.74.15594822529435405', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:30:53', 13, 0, '', '2019-06-02 21:30:53');
INSERT INTO `access_log` VALUES (22235, '66.48.15594822761524173', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.26', '2019-06-02 21:31:16', 321, 0, '', '2019-06-02 21:31:16');
INSERT INTO `access_log` VALUES (22236, '65.49.15594824553735169', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '183.220.26.62', '2019-06-02 21:34:15', 1, 1002001015, '账号未登陆', '2019-06-02 21:34:15');
INSERT INTO `access_log` VALUES (22237, '65.52.15594824553865145', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '183.220.26.62', '2019-06-02 21:34:15', 1, 1002001015, '账号未登陆', '2019-06-02 21:34:15');
INSERT INTO `access_log` VALUES (22238, '65.46.15594824553875157', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '183.220.26.62', '2019-06-02 21:34:15', 1, 1002001015, '账号未登陆', '2019-06-02 21:34:15');
INSERT INTO `access_log` VALUES (22239, '65.50.15594824573935155', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '183.220.26.62', '2019-06-02 21:34:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 21:34:17');
INSERT INTO `access_log` VALUES (22240, '65.53.15594824586905139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '183.220.26.62', '2019-06-02 21:34:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 21:34:19');
INSERT INTO `access_log` VALUES (22241, '65.47.15594824705515165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '183.220.26.62', '2019-06-02 21:34:31', 4, 1002002000, '账号不存在', '2019-06-02 21:34:31');
INSERT INTO `access_log` VALUES (22242, '65.46.15594825195155159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '183.220.26.62', '2019-06-02 21:35:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 21:35:20');
INSERT INTO `access_log` VALUES (22243, '65.50.15594831492245165', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '36.57.170.185', '2019-06-02 21:45:49', 11, 0, '', '2019-06-02 21:45:49');
INSERT INTO `access_log` VALUES (22244, '65.54.15594833355155147', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:48:56', 1, 1002001015, '账号未登陆', '2019-06-02 21:48:56');
INSERT INTO `access_log` VALUES (22245, '65.51.15594833355195161', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:48:56', 0, 1002001015, '账号未登陆', '2019-06-02 21:48:56');
INSERT INTO `access_log` VALUES (22246, '65.45.15594833355235177', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:48:56', 0, 1002001015, '账号未登陆', '2019-06-02 21:48:56');
INSERT INTO `access_log` VALUES (22247, '65.46.15594833394155171', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:48:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 21:48:59');
INSERT INTO `access_log` VALUES (22248, '65.52.15594833474235159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:49:07', 89, 0, '', '2019-06-02 21:49:08');
INSERT INTO `access_log` VALUES (22249, '65.50.15594833478355169', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:49:08', 9, 0, '', '2019-06-02 21:49:08');
INSERT INTO `access_log` VALUES (22250, '65.49.15594833478335183', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:49:08', 10, 0, '', '2019-06-02 21:49:08');
INSERT INTO `access_log` VALUES (22251, '65.53.15594833478475153', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:49:08', 9, 0, '', '2019-06-02 21:49:08');
INSERT INTO `access_log` VALUES (22252, '62.84.15594833549615281', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:49:15', 13, 0, '', '2019-06-02 21:49:15');
INSERT INTO `access_log` VALUES (22253, '66.50.15594833570404187', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:49:17', 33, 0, '', '2019-06-02 21:49:17');
INSERT INTO `access_log` VALUES (22254, '64.76.15594833595604965', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:49:20', 13, 0, '', '2019-06-02 21:49:20');
INSERT INTO `access_log` VALUES (22255, '64.83.15594833595674969', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:49:20', 9, 0, '', '2019-06-02 21:49:20');
INSERT INTO `access_log` VALUES (22256, '62.89.15594833675545297', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:49:28', 12, 0, '', '2019-06-02 21:49:28');
INSERT INTO `access_log` VALUES (22257, '62.82.15594833716605305', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:49:32', 86, 0, '', '2019-06-02 21:49:32');
INSERT INTO `access_log` VALUES (22258, '66.53.15594833733704185', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:49:33', 26, 0, '', '2019-06-02 21:49:33');
INSERT INTO `access_log` VALUES (22259, '65.45.15594833762445179', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:49:36', 18, 0, '', '2019-06-02 21:49:36');
INSERT INTO `access_log` VALUES (22260, '65.54.15594833852865149', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:49:45', 10, 0, '', '2019-06-02 21:49:45');
INSERT INTO `access_log` VALUES (22261, '65.46.15594833892045173', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:49:49', 224, 0, '', '2019-06-02 21:49:49');
INSERT INTO `access_log` VALUES (22262, '65.50.15594834178895171', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:50:18', 15, 0, '', '2019-06-02 21:50:18');
INSERT INTO `access_log` VALUES (22263, '62.81.15594834370565279', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 21:50:37', 12, 0, '', '2019-06-02 21:50:37');
INSERT INTO `access_log` VALUES (22264, '65.51.15594834743365165', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '120.239.196.110', '2019-06-02 21:51:14', 1, 1002001015, '账号未登陆', '2019-06-02 21:51:14');
INSERT INTO `access_log` VALUES (22265, '65.54.15594834743425151', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '120.239.196.110', '2019-06-02 21:51:14', 0, 1002001015, '账号未登陆', '2019-06-02 21:51:14');
INSERT INTO `access_log` VALUES (22266, '65.46.15594834743475175', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '120.239.196.110', '2019-06-02 21:51:14', 0, 1002001015, '账号未登陆', '2019-06-02 21:51:14');
INSERT INTO `access_log` VALUES (22267, '65.53.15594834891365157', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '120.239.196.110', '2019-06-02 21:51:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 21:51:29');
INSERT INTO `access_log` VALUES (22268, '65.50.15594834978595173', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '120.239.196.110', '2019-06-02 21:51:38', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 21:51:38');
INSERT INTO `access_log` VALUES (22269, '65.48.15594835039335183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '120.239.196.110', '2019-06-02 21:51:44', 168, 0, '', '2019-06-02 21:51:44');
INSERT INTO `access_log` VALUES (22270, '65.46.15594835044065177', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '120.239.196.110', '2019-06-02 21:51:44', 7, 0, '', '2019-06-02 21:51:44');
INSERT INTO `access_log` VALUES (22271, '65.47.15594835043965183', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '120.239.196.110', '2019-06-02 21:51:44', 156, 0, '', '2019-06-02 21:51:45');
INSERT INTO `access_log` VALUES (22272, '65.45.15594835044065183', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '120.239.196.110', '2019-06-02 21:51:44', 151, 0, '', '2019-06-02 21:51:45');
INSERT INTO `access_log` VALUES (22273, '62.87.15594835188425305', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '120.239.196.110', '2019-06-02 21:51:59', 13, 0, '', '2019-06-02 21:51:59');
INSERT INTO `access_log` VALUES (22274, '66.56.15594835228534183', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '120.239.196.110', '2019-06-02 21:52:03', 29, 0, '', '2019-06-02 21:52:03');
INSERT INTO `access_log` VALUES (22275, '65.54.15594838107995157', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '182.138.182.110', '2019-06-02 21:56:51', 1, 1002001015, '账号未登陆', '2019-06-02 21:56:51');
INSERT INTO `access_log` VALUES (22276, '65.51.15594838107995171', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '182.138.182.110', '2019-06-02 21:56:51', 1, 1002001015, '账号未登陆', '2019-06-02 21:56:51');
INSERT INTO `access_log` VALUES (22277, '65.52.15594838108135169', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '182.138.182.110', '2019-06-02 21:56:51', 1, 1002001015, '账号未登陆', '2019-06-02 21:56:51');
INSERT INTO `access_log` VALUES (22278, '65.50.15594838147065179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '182.138.182.110', '2019-06-02 21:56:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 21:56:55');
INSERT INTO `access_log` VALUES (22279, '65.52.15594843299645177', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-06-02 22:05:30', 4, 1002001012, '访问令牌已过期', '2019-06-02 22:05:30');
INSERT INTO `access_log` VALUES (22280, '65.54.15594843299655165', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-06-02 22:05:30', 3, 1002001012, '访问令牌已过期', '2019-06-02 22:05:30');
INSERT INTO `access_log` VALUES (22281, '65.45.15594843299645195', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-06-02 22:05:30', 4, 1002001012, '访问令牌已过期', '2019-06-02 22:05:30');
INSERT INTO `access_log` VALUES (22282, '65.51.15594843314705179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-06-02 22:05:31', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 22:05:31');
INSERT INTO `access_log` VALUES (22283, '65.48.15594843828465197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.10.64.229', '2019-06-02 22:06:23', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 22:06:23');
INSERT INTO `access_log` VALUES (22284, '59.75.15594852907795449', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.66.14', '2019-06-02 22:21:31', 16, 2001001000, '服务端发生异常', '2019-06-02 22:21:31');
INSERT INTO `access_log` VALUES (22285, '59.80.15594852907785445', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.66.14', '2019-06-02 22:21:31', 155, 0, '', '2019-06-02 22:21:31');
INSERT INTO `access_log` VALUES (22286, '65.52.15594853005045191', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.66.14', '2019-06-02 22:21:41', 0, 1002001015, '账号未登陆', '2019-06-02 22:21:41');
INSERT INTO `access_log` VALUES (22287, '65.54.15594853005105179', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.66.14', '2019-06-02 22:21:41', 0, 1002001015, '账号未登陆', '2019-06-02 22:21:41');
INSERT INTO `access_log` VALUES (22288, '65.45.15594853005175209', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.66.14', '2019-06-02 22:21:41', 0, 1002001015, '账号未登陆', '2019-06-02 22:21:41');
INSERT INTO `access_log` VALUES (22289, '59.73.15594853228405453', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:22:03', 3, 0, '', '2019-06-02 22:22:03');
INSERT INTO `access_log` VALUES (22290, '59.76.15594853228405443', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:22:03', 15, 2001001000, '服务端发生异常', '2019-06-02 22:22:03');
INSERT INTO `access_log` VALUES (22291, '65.50.15594853420835201', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:22:22', 1, 1002001015, '账号未登陆', '2019-06-02 22:22:22');
INSERT INTO `access_log` VALUES (22292, '65.49.15594853420945215', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:22:22', 0, 1002001015, '账号未登陆', '2019-06-02 22:22:22');
INSERT INTO `access_log` VALUES (22293, '65.48.15594853421065211', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:22:22', 0, 1002001015, '账号未登陆', '2019-06-02 22:22:22');
INSERT INTO `access_log` VALUES (22294, '65.50.15594854470455203', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:24:07', 1, 1002001015, '账号未登陆', '2019-06-02 22:24:07');
INSERT INTO `access_log` VALUES (22295, '65.49.15594854471805217', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:24:07', 0, 1002001015, '账号未登陆', '2019-06-02 22:24:07');
INSERT INTO `access_log` VALUES (22296, '65.48.15594854471845213', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:24:07', 1, 1002001015, '账号未登陆', '2019-06-02 22:24:07');
INSERT INTO `access_log` VALUES (22297, '65.47.15594854506975213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:24:11', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 22:24:11');
INSERT INTO `access_log` VALUES (22298, '65.52.15594854557195195', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:24:16', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 22:24:16');
INSERT INTO `access_log` VALUES (22299, '65.54.15594854633425183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:24:23', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 22:24:23');
INSERT INTO `access_log` VALUES (22300, '65.46.15594854899515209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:24:50', 1068, 0, '', '2019-06-02 22:24:51');
INSERT INTO `access_log` VALUES (22301, '65.54.15594854912645185', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:24:51', 413, 0, '', '2019-06-02 22:24:52');
INSERT INTO `access_log` VALUES (22302, '65.47.15594854912715215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:24:51', 411, 0, '', '2019-06-02 22:24:52');
INSERT INTO `access_log` VALUES (22303, '65.45.15594854912875215', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:24:51', 395, 0, '', '2019-06-02 22:24:52');
INSERT INTO `access_log` VALUES (22304, '62.81.15594854997365307', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:25:00', 62, 0, '', '2019-06-02 22:25:00');
INSERT INTO `access_log` VALUES (22305, '65.54.15594855090125187', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '117.136.79.159', '2019-06-02 22:25:09', 0, 1002001015, '账号未登陆', '2019-06-02 22:25:09');
INSERT INTO `access_log` VALUES (22306, '66.48.15594855139494217', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:25:14', 21, 0, '', '2019-06-02 22:25:14');
INSERT INTO `access_log` VALUES (22307, '66.52.15594855168424215', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:25:17', 14, 0, '', '2019-06-02 22:25:17');
INSERT INTO `access_log` VALUES (22308, '59.75.15594855268445453', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:25:27', 12, 0, '', '2019-06-02 22:25:27');
INSERT INTO `access_log` VALUES (22309, '59.80.15594855302535449', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:25:30', 20, 2001001000, '服务端发生异常', '2019-06-02 22:25:30');
INSERT INTO `access_log` VALUES (22310, '59.71.15594855353945457', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:25:35', 12, 0, '', '2019-06-02 22:25:35');
INSERT INTO `access_log` VALUES (22311, '59.76.15594855388375447', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:25:39', 12, 0, '', '2019-06-02 22:25:39');
INSERT INTO `access_log` VALUES (22312, '59.73.15594855422905457', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:25:42', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 22:25:42');
INSERT INTO `access_log` VALUES (22313, '65.51.15594855450595201', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:25:45', 18, 0, '', '2019-06-02 22:25:45');
INSERT INTO `access_log` VALUES (22314, '65.52.15594855502705199', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:25:50', 12, 0, '', '2019-06-02 22:25:50');
INSERT INTO `access_log` VALUES (22315, '65.50.15594855543655207', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:25:54', 11, 0, '', '2019-06-02 22:25:54');
INSERT INTO `access_log` VALUES (22316, '65.49.15594855559455221', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:25:56', 10, 0, '', '2019-06-02 22:25:56');
INSERT INTO `access_log` VALUES (22317, '65.48.15594855580385217', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:25:58', 9, 0, '', '2019-06-02 22:25:58');
INSERT INTO `access_log` VALUES (22318, '65.46.15594855642735211', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:26:04', 12, 0, '', '2019-06-02 22:26:04');
INSERT INTO `access_log` VALUES (22319, '65.47.15594855717945219', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:26:12', 9, 0, '', '2019-06-02 22:26:12');
INSERT INTO `access_log` VALUES (22320, '65.45.15594855779905219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:26:18', 64, 0, '', '2019-06-02 22:26:18');
INSERT INTO `access_log` VALUES (22321, '65.51.15594855785595203', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:26:19', 9, 0, '', '2019-06-02 22:26:19');
INSERT INTO `access_log` VALUES (22322, '65.52.15594855785745201', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:26:19', 9, 0, '', '2019-06-02 22:26:19');
INSERT INTO `access_log` VALUES (22323, '65.53.15594855786235191', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:26:19', 11, 0, '', '2019-06-02 22:26:19');
INSERT INTO `access_log` VALUES (22324, '65.50.15594855822515209', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:26:22', 13, 0, '', '2019-06-02 22:26:22');
INSERT INTO `access_log` VALUES (22325, '59.77.15594855919535447', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:26:32', 87, 0, '', '2019-06-02 22:26:32');
INSERT INTO `access_log` VALUES (22326, '65.48.15594855956325219', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:26:36', 19, 0, '', '2019-06-02 22:26:36');
INSERT INTO `access_log` VALUES (22327, '64.82.15594855986305015', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:26:39', 23, 0, '', '2019-06-02 22:26:39');
INSERT INTO `access_log` VALUES (22328, '64.78.15594855986435011', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:26:39', 15, 0, '', '2019-06-02 22:26:39');
INSERT INTO `access_log` VALUES (22329, '66.57.15594856222044217', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:27:02', 14, 0, '', '2019-06-02 22:27:02');
INSERT INTO `access_log` VALUES (22330, '62.89.15594856264555329', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.41.129.229', '2019-06-02 22:27:06', 16, 0, '', '2019-06-02 22:27:06');
INSERT INTO `access_log` VALUES (22331, '65.45.15594856294425221', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:27:09', 9, 0, '', '2019-06-02 22:27:09');
INSERT INTO `access_log` VALUES (22332, '65.52.15594856294495203', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:27:09', 8, 0, '', '2019-06-02 22:27:09');
INSERT INTO `access_log` VALUES (22333, '65.51.15594856294575205', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:27:09', 9, 0, '', '2019-06-02 22:27:09');
INSERT INTO `access_log` VALUES (22334, '65.53.15594856348825193', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:27:15', 9, 0, '', '2019-06-02 22:27:15');
INSERT INTO `access_log` VALUES (22335, '65.50.15594856348865211', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:27:15', 8, 0, '', '2019-06-02 22:27:15');
INSERT INTO `access_log` VALUES (22336, '65.49.15594856348925225', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.128.154.107', '2019-06-02 22:27:15', 96, 0, '', '2019-06-02 22:27:15');
INSERT INTO `access_log` VALUES (22337, '9b355478-f5d7-4dfe-a49a-54e1e99fcbc3', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '127.0.0.1', '2019-06-02 22:30:12', 1295, 0, '', '2019-06-02 22:30:13');
INSERT INTO `access_log` VALUES (22338, '560d8a80-baa1-4ed1-a356-66e4285c912b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '127.0.0.1', '2019-06-02 22:30:14', 823, 0, '', '2019-06-02 22:30:14');
INSERT INTO `access_log` VALUES (22339, '2aaac426-f42d-4e55-8540-3e995fff5c95', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '127.0.0.1', '2019-06-02 22:30:14', 781, 0, '', '2019-06-02 22:30:15');
INSERT INTO `access_log` VALUES (22340, '74830b34-c808-4259-8f75-6d8c7a5dc820', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '127.0.0.1', '2019-06-02 22:30:14', 949, 0, '', '2019-06-02 22:30:15');
INSERT INTO `access_log` VALUES (22341, 'f4750972-4818-4510-8e0c-2ea1caf9b1df', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '127.0.0.1', '2019-06-02 22:32:59', 850, 0, '', '2019-06-02 22:33:00');
INSERT INTO `access_log` VALUES (22342, '7ca9a1af-2ab4-4daf-a25c-06f589cbd911', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '127.0.0.1', '2019-06-02 22:32:59', 1041, 0, '', '2019-06-02 22:33:00');
INSERT INTO `access_log` VALUES (22343, '357372b9-8d18-412c-a9b6-39412a0d644e', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '127.0.0.1', '2019-06-02 22:33:07', 483, 0, '', '2019-06-02 22:33:08');
INSERT INTO `access_log` VALUES (22344, '7b8bcc7e-19d0-4909-9724-07fd91a942be', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '127.0.0.1', '2019-06-02 22:33:08', 647, 0, '', '2019-06-02 22:33:08');
INSERT INTO `access_log` VALUES (22345, '9ffde8b7-6055-4ff4-a8d7-df2b290d782b', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '127.0.0.1', '2019-06-02 22:33:07', 1658, 0, '', '2019-06-02 22:33:09');
INSERT INTO `access_log` VALUES (22346, '59.77.15594861740365455', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:36:14', 12, 0, '', '2019-06-02 22:36:14');
INSERT INTO `access_log` VALUES (22347, '59.75.15594861772675463', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:36:17', 20, 2001001000, '服务端发生异常', '2019-06-02 22:36:17');
INSERT INTO `access_log` VALUES (22348, '59.79.15594861829735463', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:36:23', 12, 0, '', '2019-06-02 22:36:23');
INSERT INTO `access_log` VALUES (22349, '59.71.15594861855605467', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:36:26', 10, 0, '', '2019-06-02 22:36:26');
INSERT INTO `access_log` VALUES (22350, '59.76.15594861907475457', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:36:31', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 22:36:31');
INSERT INTO `access_log` VALUES (22351, '64.77.15594862028845019', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:36:43', 12, 0, '', '2019-06-02 22:36:43');
INSERT INTO `access_log` VALUES (22352, '64.85.15594862028935025', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:36:43', 8, 0, '', '2019-06-02 22:36:43');
INSERT INTO `access_log` VALUES (22353, '62.87.15594862112755343', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:36:51', 14, 0, '', '2019-06-02 22:36:51');
INSERT INTO `access_log` VALUES (22354, '62.86.15594862202785325', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:37:00', 10, 0, '', '2019-06-02 22:37:00');
INSERT INTO `access_log` VALUES (22355, '59.72.15594862319395461', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:37:12', 3, 0, '', '2019-06-02 22:37:12');
INSERT INTO `access_log` VALUES (22356, '59.77.15594862319395457', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:37:12', 13, 2001001000, '服务端发生异常', '2019-06-02 22:37:12');
INSERT INTO `access_log` VALUES (22357, '9cb9e58c-65fa-4626-8679-a3341c7f9573', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '127.0.0.1', '2019-06-02 22:37:15', 1581, 0, '', '2019-06-02 22:37:16');
INSERT INTO `access_log` VALUES (22358, '62.88.15594862368295343', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=101', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:37:17', 64, 1002001012, '访问令牌已过期', '2019-06-02 22:37:17');
INSERT INTO `access_log` VALUES (22359, '65.48.15594862419225229', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:37:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 22:37:22');
INSERT INTO `access_log` VALUES (22360, '64.84.15594862440085019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:37:24', 2, 0, '', '2019-06-02 22:37:24');
INSERT INTO `access_log` VALUES (22361, '65.54.15594862441215201', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:37:24', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 22:37:24');
INSERT INTO `access_log` VALUES (22362, '64.83.15594862441985009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:37:24', 2, 0, '', '2019-06-02 22:37:24');
INSERT INTO `access_log` VALUES (22363, '64.76.15594862463305005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:37:26', 2, 0, '', '2019-06-02 22:37:26');
INSERT INTO `access_log` VALUES (22364, '64.78.15594862472685021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:37:27', 2, 0, '', '2019-06-02 22:37:27');
INSERT INTO `access_log` VALUES (22365, '64.82.15594862483885025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:37:28', 1, 0, '', '2019-06-02 22:37:28');
INSERT INTO `access_log` VALUES (22366, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:37:28', 12, 0, '', '2019-06-02 22:37:28');
INSERT INTO `access_log` VALUES (22367, '64.77.15594862502025021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:37:30', 2, 0, '', '2019-06-02 22:37:30');
INSERT INTO `access_log` VALUES (22368, '64.85.15594862506385027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:37:31', 2, 0, '', '2019-06-02 22:37:31');
INSERT INTO `access_log` VALUES (22369, '64.81.15594862517765011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:37:32', 2, 0, '', '2019-06-02 22:37:32');
INSERT INTO `access_log` VALUES (22370, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:37:32', 7, 0, '', '2019-06-02 22:37:32');
INSERT INTO `access_log` VALUES (22371, '64.79.15594862534375009', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:37:33', 575, 0, '', '2019-06-02 22:37:34');
INSERT INTO `access_log` VALUES (22372, 'a7d50a23-d3b5-4912-a485-e1bc4c8deb20', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '127.0.0.1', '2019-06-02 22:37:49', 509, 0, '', '2019-06-02 22:37:49');
INSERT INTO `access_log` VALUES (22373, 'd8efdab2-24d2-4a43-9a2a-6334600f7974', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '127.0.0.1', '2019-06-02 22:37:49', 705, 0, '', '2019-06-02 22:37:49');
INSERT INTO `access_log` VALUES (22374, 'a240e8cc-2583-4d82-ae2f-4517063b5ace', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '127.0.0.1', '2019-06-02 22:37:49', 1213, 0, '', '2019-06-02 22:37:50');
INSERT INTO `access_log` VALUES (22375, 'c7793916-3243-4cee-8e2c-07fc0349c0dc', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '127.0.0.1', '2019-06-02 22:37:49', 948, 0, '', '2019-06-02 22:37:50');
INSERT INTO `access_log` VALUES (22376, '66.56.15594863033334221', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17798562099&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:38:23', 10, 1001003000, '验证码不存在', '2019-06-02 22:38:23');
INSERT INTO `access_log` VALUES (22377, '66.54.15594863054884227', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17798562099', 'POST', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:38:25', 172, 0, '', '2019-06-02 22:38:26');
INSERT INTO `access_log` VALUES (22378, '66.49.15594863077284223', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17798562099&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:38:28', 176, 0, '', '2019-06-02 22:38:28');
INSERT INTO `access_log` VALUES (22379, '66.48.15594863092294229', 101, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:38:29', 7, 0, '', '2019-06-02 22:38:29');
INSERT INTO `access_log` VALUES (22380, '64.85.15594863411385029', 101, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:01', 10, 0, '', '2019-06-02 22:39:01');
INSERT INTO `access_log` VALUES (22381, '59.72.15594863533455463', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:39:13', 10, 0, '', '2019-06-02 22:39:13');
INSERT INTO `access_log` VALUES (22382, '59.77.15594863533575459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:39:13', 10, 2001001000, '服务端发生异常', '2019-06-02 22:39:13');
INSERT INTO `access_log` VALUES (22383, '64.80.15594863546895011', 101, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:15', 13, 0, '', '2019-06-02 22:39:15');
INSERT INTO `access_log` VALUES (22384, 'N/A', 101, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:15', 13, 0, '', '2019-06-02 22:39:15');
INSERT INTO `access_log` VALUES (22385, '64.83.15594863565195013', 101, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:17', 11, 0, '', '2019-06-02 22:39:17');
INSERT INTO `access_log` VALUES (22386, '64.76.15594863569315009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:39:17', 2, 0, '', '2019-06-02 22:39:17');
INSERT INTO `access_log` VALUES (22387, '64.78.15594863570615025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:39:17', 2, 0, '', '2019-06-02 22:39:17');
INSERT INTO `access_log` VALUES (22388, '64.82.15594863582995029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:39:18', 3, 0, '', '2019-06-02 22:39:18');
INSERT INTO `access_log` VALUES (22389, '64.77.15594863591295025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:39:19', 3, 0, '', '2019-06-02 22:39:19');
INSERT INTO `access_log` VALUES (22390, '64.85.15594863597515031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:39:20', 3, 0, '', '2019-06-02 22:39:20');
INSERT INTO `access_log` VALUES (22391, '59.79.15594863613495467', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:39:21', 3, 0, '', '2019-06-02 22:39:21');
INSERT INTO `access_log` VALUES (22392, '59.80.15594863613425463', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '116.136.19.112', '2019-06-02 22:39:21', 12, 2001001000, '服务端发生异常', '2019-06-02 22:39:21');
INSERT INTO `access_log` VALUES (22393, '64.79.15594863677815013', 101, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:28', 10, 0, '', '2019-06-02 22:39:28');
INSERT INTO `access_log` VALUES (22394, '64.80.15594863690915013', 101, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:29', 5, 0, '', '2019-06-02 22:39:29');
INSERT INTO `access_log` VALUES (22395, 'N/A', 101, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:29', 14, 0, '', '2019-06-02 22:39:29');
INSERT INTO `access_log` VALUES (22396, '64.83.15594863706125015', 101, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:31', 5, 0, '', '2019-06-02 22:39:31');
INSERT INTO `access_log` VALUES (22397, '64.76.15594863708105011', 101, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:31', 5, 0, '', '2019-06-02 22:39:31');
INSERT INTO `access_log` VALUES (22398, '66.56.15594863733444223', 101, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:33', 6, 0, '', '2019-06-02 22:39:33');
INSERT INTO `access_log` VALUES (22399, '66.49.15594863814484225', 101, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:41', 5, 0, '', '2019-06-02 22:39:41');
INSERT INTO `access_log` VALUES (22400, '64.82.15594863824275031', 101, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:42', 5, 0, '', '2019-06-02 22:39:42');
INSERT INTO `access_log` VALUES (22401, '64.77.15594863826075027', 101, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:43', 5, 0, '', '2019-06-02 22:39:43');
INSERT INTO `access_log` VALUES (22402, '59.78.15594863836305471', 101, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:44', 5, 0, '', '2019-06-02 22:39:44');
INSERT INTO `access_log` VALUES (22403, '59.74.15594863836375465', 101, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:44', 16, 2001001000, '服务端发生异常', '2019-06-02 22:39:44');
INSERT INTO `access_log` VALUES (22404, '64.85.15594863862275033', 101, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:46', 5, 0, '', '2019-06-02 22:39:46');
INSERT INTO `access_log` VALUES (22405, '64.81.15594863864105017', 101, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:46', 4, 0, '', '2019-06-02 22:39:46');
INSERT INTO `access_log` VALUES (22406, '66.57.15594863871664229', 101, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:47', 6, 0, '', '2019-06-02 22:39:47');
INSERT INTO `access_log` VALUES (22407, '64.79.15594863876905015', 101, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:48', 5, 0, '', '2019-06-02 22:39:48');
INSERT INTO `access_log` VALUES (22408, '64.80.15594863878175015', 101, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:48', 5, 0, '', '2019-06-02 22:39:48');
INSERT INTO `access_log` VALUES (22409, '59.72.15594863885685465', 101, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:49', 11, 0, '', '2019-06-02 22:39:49');
INSERT INTO `access_log` VALUES (22410, '59.77.15594863885685461', 101, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; BKL-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '49.95.181.64', '2019-06-02 22:39:49', 13, 2001001000, '服务端发生异常', '2019-06-02 22:39:49');
INSERT INTO `access_log` VALUES (22411, '59.79.15594868519115475', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:47:32', 4, 0, '', '2019-06-02 22:47:32');
INSERT INTO `access_log` VALUES (22412, '59.80.15594868519125471', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:47:32', 13, 2001001000, '服务端发生异常', '2019-06-02 22:47:32');
INSERT INTO `access_log` VALUES (22413, '64.76.15594868573225019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:47:37', 3, 0, '', '2019-06-02 22:47:37');
INSERT INTO `access_log` VALUES (22414, '64.78.15594868574725035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:47:37', 2, 0, '', '2019-06-02 22:47:37');
INSERT INTO `access_log` VALUES (22415, '64.82.15594868589665039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:47:39', 3, 0, '', '2019-06-02 22:47:39');
INSERT INTO `access_log` VALUES (22416, '64.77.15594868597955035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:47:40', 2, 0, '', '2019-06-02 22:47:40');
INSERT INTO `access_log` VALUES (22417, '64.85.15594868627125041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:47:43', 2, 0, '', '2019-06-02 22:47:43');
INSERT INTO `access_log` VALUES (22418, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:47:43', 7, 0, '', '2019-06-02 22:47:43');
INSERT INTO `access_log` VALUES (22419, '64.81.15594868657225025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:47:46', 2, 0, '', '2019-06-02 22:47:46');
INSERT INTO `access_log` VALUES (22420, '64.79.15594868659445023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:47:46', 2, 0, '', '2019-06-02 22:47:46');
INSERT INTO `access_log` VALUES (22421, '64.84.15594868748185035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:47:55', 3, 0, '', '2019-06-02 22:47:55');
INSERT INTO `access_log` VALUES (22422, '64.83.15594868749445025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:47:55', 2, 0, '', '2019-06-02 22:47:55');
INSERT INTO `access_log` VALUES (22423, '64.76.15594868811425021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:48:01', 2, 0, '', '2019-06-02 22:48:01');
INSERT INTO `access_log` VALUES (22424, '64.78.15594868812535037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:48:01', 2, 0, '', '2019-06-02 22:48:01');
INSERT INTO `access_log` VALUES (22425, '64.82.15594868843505041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:48:04', 2, 0, '', '2019-06-02 22:48:04');
INSERT INTO `access_log` VALUES (22426, '64.77.15594868847625037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:48:05', 2, 0, '', '2019-06-02 22:48:05');
INSERT INTO `access_log` VALUES (22427, '65.52.15594869011095223', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:48:21', 1, 1002001015, '账号未登陆', '2019-06-02 22:48:21');
INSERT INTO `access_log` VALUES (22428, '65.51.15594869011115225', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:48:21', 1, 1002001015, '账号未登陆', '2019-06-02 22:48:21');
INSERT INTO `access_log` VALUES (22429, '65.50.15594869011135229', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:48:21', 0, 1002001015, '账号未登陆', '2019-06-02 22:48:21');
INSERT INTO `access_log` VALUES (22430, '65.46.15594869446865235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:49:05', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 22:49:05');
INSERT INTO `access_log` VALUES (22431, '65.54.15594869562225211', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=amidn&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:49:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 22:49:16');
INSERT INTO `access_log` VALUES (22432, '65.52.15594869721435225', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:49:32', 650, 0, '', '2019-06-02 22:49:33');
INSERT INTO `access_log` VALUES (22433, '65.50.15594869732385231', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:49:33', 119, 0, '', '2019-06-02 22:49:33');
INSERT INTO `access_log` VALUES (22434, '65.51.15594869732435227', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:49:33', 117, 0, '', '2019-06-02 22:49:33');
INSERT INTO `access_log` VALUES (22435, '65.53.15594869732975213', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:49:33', 63, 0, '', '2019-06-02 22:49:33');
INSERT INTO `access_log` VALUES (22436, '62.81.15594869866775329', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:49:47', 53, 0, '', '2019-06-02 22:49:47');
INSERT INTO `access_log` VALUES (22437, '62.84.15594869902535333', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:49:50', 560, 0, '', '2019-06-02 22:49:51');
INSERT INTO `access_log` VALUES (22438, '65.46.15594869964885237', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:49:56', 20, 0, '', '2019-06-02 22:49:57');
INSERT INTO `access_log` VALUES (22439, '65.47.15594870029875243', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:50:03', 17, 0, '', '2019-06-02 22:50:03');
INSERT INTO `access_log` VALUES (22440, '65.54.15594870038895213', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:50:04', 18, 0, '', '2019-06-02 22:50:04');
INSERT INTO `access_log` VALUES (22441, '65.45.15594870066515245', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:50:07', 10, 0, '', '2019-06-02 22:50:07');
INSERT INTO `access_log` VALUES (22442, '65.52.15594870084865227', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:50:08', 1375, 0, '', '2019-06-02 22:50:10');
INSERT INTO `access_log` VALUES (22443, '65.53.15594870105625215', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:50:11', 617, 0, '', '2019-06-02 22:50:11');
INSERT INTO `access_log` VALUES (22444, '59.73.15594870237015481', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:50:24', 12, 0, '', '2019-06-02 22:50:24');
INSERT INTO `access_log` VALUES (22445, '59.78.15594870278905481', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.75.37.61', '2019-06-02 22:50:28', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 22:50:28');
INSERT INTO `access_log` VALUES (22446, '65.49.15594871785595249', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.66.53.108', '2019-06-02 22:52:59', 1, 1002001015, '账号未登陆', '2019-06-02 22:52:59');
INSERT INTO `access_log` VALUES (22447, '65.48.15594871785655245', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.66.53.108', '2019-06-02 22:52:59', 1, 1002001015, '账号未登陆', '2019-06-02 22:52:59');
INSERT INTO `access_log` VALUES (22448, '65.46.15594871785725241', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.66.53.108', '2019-06-02 22:52:59', 0, 1002001015, '账号未登陆', '2019-06-02 22:52:59');
INSERT INTO `access_log` VALUES (22449, '65.47.15594871802735247', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.66.53.108', '2019-06-02 22:53:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 22:53:00');
INSERT INTO `access_log` VALUES (22450, '65.54.15594871830565217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.66.53.108', '2019-06-02 22:53:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 22:53:03');
INSERT INTO `access_log` VALUES (22451, '65.45.15594871841475249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.66.53.108', '2019-06-02 22:53:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 22:53:04');
INSERT INTO `access_log` VALUES (22452, '65.46.15594872640245243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.66.53.108', '2019-06-02 22:54:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 22:54:24');
INSERT INTO `access_log` VALUES (22453, '65.47.15594902766275289', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:44:37', 0, 1002001015, '账号未登陆', '2019-06-02 23:44:37');
INSERT INTO `access_log` VALUES (22454, '65.45.15594902766285291', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:44:37', 0, 1002001015, '账号未登陆', '2019-06-02 23:44:37');
INSERT INTO `access_log` VALUES (22455, '65.54.15594902766275259', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:44:37', 0, 1002001015, '账号未登陆', '2019-06-02 23:44:37');
INSERT INTO `access_log` VALUES (22456, '65.52.15594902803855273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:44:40', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-02 23:44:40');
INSERT INTO `access_log` VALUES (22457, '65.51.15594902965625275', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:44:57', 62, 0, '', '2019-06-02 23:44:57');
INSERT INTO `access_log` VALUES (22458, '65.48.15594902969785289', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:44:57', 10, 0, '', '2019-06-02 23:44:57');
INSERT INTO `access_log` VALUES (22459, '65.49.15594902969845293', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:44:57', 9, 0, '', '2019-06-02 23:44:57');
INSERT INTO `access_log` VALUES (22460, '65.46.15594902970415285', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:44:57', 8, 0, '', '2019-06-02 23:44:57');
INSERT INTO `access_log` VALUES (22461, '62.86.15594903074305381', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:45:07', 1591, 0, '', '2019-06-02 23:45:09');
INSERT INTO `access_log` VALUES (22462, '62.86.15594904482255383', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:47:28', 14, 0, '', '2019-06-02 23:47:28');
INSERT INTO `access_log` VALUES (22463, '64.84.15594905247435085', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:48:45', 17, 0, '', '2019-06-02 23:48:45');
INSERT INTO `access_log` VALUES (22464, '64.80.15594905247375073', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:48:45', 25, 0, '', '2019-06-02 23:48:45');
INSERT INTO `access_log` VALUES (22465, '64.78.15594905436865087', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:49:04', 12, 0, '', '2019-06-02 23:49:04');
INSERT INTO `access_log` VALUES (22466, '64.76.15594905436825071', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:49:04', 16, 0, '', '2019-06-02 23:49:04');
INSERT INTO `access_log` VALUES (22467, '66.49.15594905555204281', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:49:16', 22, 0, '', '2019-06-02 23:49:16');
INSERT INTO `access_log` VALUES (22468, '59.73.15594905937775529', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:49:54', 21, 0, '', '2019-06-02 23:49:54');
INSERT INTO `access_log` VALUES (22469, '64.78.15594906532815089', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:50:53', 11, 0, '', '2019-06-02 23:50:53');
INSERT INTO `access_log` VALUES (22470, '65.52.15594908072305281', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:53:27', 10, 0, '', '2019-06-02 23:53:27');
INSERT INTO `access_log` VALUES (22471, '65.53.15594908072455269', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:53:27', 9, 0, '', '2019-06-02 23:53:27');
INSERT INTO `access_log` VALUES (22472, '65.51.15594908072465283', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:53:27', 9, 0, '', '2019-06-02 23:53:27');
INSERT INTO `access_log` VALUES (22473, '66.56.15594908074284283', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:53:27', 14, 0, '', '2019-06-02 23:53:27');
INSERT INTO `access_log` VALUES (22474, '59.75.15594908123875529', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:53:32', 11, 0, '', '2019-06-02 23:53:32');
INSERT INTO `access_log` VALUES (22475, '64.76.15594908137995075', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:53:34', 11, 0, '', '2019-06-02 23:53:34');
INSERT INTO `access_log` VALUES (22476, '65.49.15594909751795303', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:56:15', 10, 0, '', '2019-06-02 23:56:15');
INSERT INTO `access_log` VALUES (22477, '65.46.15594909751855295', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:56:15', 10, 0, '', '2019-06-02 23:56:15');
INSERT INTO `access_log` VALUES (22478, '65.47.15594909751915301', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:56:15', 8, 0, '', '2019-06-02 23:56:15');
INSERT INTO `access_log` VALUES (22479, '66.49.15594909753894287', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:56:15', 13, 0, '', '2019-06-02 23:56:15');
INSERT INTO `access_log` VALUES (22480, '59.80.15594909781035527', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:56:18', 12, 0, '', '2019-06-02 23:56:18');
INSERT INTO `access_log` VALUES (22481, '64.77.15594909790435093', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:56:19', 18, 0, '', '2019-06-02 23:56:19');
INSERT INTO `access_log` VALUES (22482, '65.54.15594909880105271', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:56:28', 9, 0, '', '2019-06-02 23:56:28');
INSERT INTO `access_log` VALUES (22483, '65.50.15594909880215291', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:56:28', 8, 0, '', '2019-06-02 23:56:28');
INSERT INTO `access_log` VALUES (22484, '65.52.15594909880275285', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:56:28', 7, 0, '', '2019-06-02 23:56:28');
INSERT INTO `access_log` VALUES (22485, '66.48.15594909881574293', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:56:28', 11, 0, '', '2019-06-02 23:56:28');
INSERT INTO `access_log` VALUES (22486, '59.76.15594909901195525', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:30', 3, 0, '', '2019-06-02 23:56:30');
INSERT INTO `access_log` VALUES (22487, '59.73.15594909901235535', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:30', 9, 2001001000, '服务端发生异常', '2019-06-02 23:56:30');
INSERT INTO `access_log` VALUES (22488, '59.78.15594909925735535', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:56:33', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-02 23:56:33');
INSERT INTO `access_log` VALUES (22489, '64.81.15594909954015083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:35', 3, 0, '', '2019-06-02 23:56:35');
INSERT INTO `access_log` VALUES (22490, '64.80.15594909956175081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:36', 2, 0, '', '2019-06-02 23:56:36');
INSERT INTO `access_log` VALUES (22491, '64.84.15594909970535093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:37', 2, 0, '', '2019-06-02 23:56:37');
INSERT INTO `access_log` VALUES (22492, '64.83.15594909981235083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:38', 2, 0, '', '2019-06-02 23:56:38');
INSERT INTO `access_log` VALUES (22493, '59.72.15594909998485529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:40', 3, 0, '', '2019-06-02 23:56:40');
INSERT INTO `access_log` VALUES (22494, '59.77.15594909998585525', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:40', 13, 2001001000, '服务端发生异常', '2019-06-02 23:56:40');
INSERT INTO `access_log` VALUES (22495, '59.75.15594910016375533', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:56:42', 11, 0, '', '2019-06-02 23:56:42');
INSERT INTO `access_log` VALUES (22496, '64.78.15594910044835095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:44', 2, 0, '', '2019-06-02 23:56:44');
INSERT INTO `access_log` VALUES (22497, '64.76.15594910046915079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:45', 2, 0, '', '2019-06-02 23:56:45');
INSERT INTO `access_log` VALUES (22498, '64.82.15594910057235099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:46', 2, 0, '', '2019-06-02 23:56:46');
INSERT INTO `access_log` VALUES (22499, '64.77.15594910064135095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:46', 35, 0, '', '2019-06-02 23:56:46');
INSERT INTO `access_log` VALUES (22500, '64.85.15594910089805101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:49', 2, 0, '', '2019-06-02 23:56:49');
INSERT INTO `access_log` VALUES (22501, '64.81.15594910092415085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:49', 2, 0, '', '2019-06-02 23:56:49');
INSERT INTO `access_log` VALUES (22502, '59.71.15594910114515537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:51', 3, 0, '', '2019-06-02 23:56:51');
INSERT INTO `access_log` VALUES (22503, '59.80.15594910114495529', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:51', 13, 2001001000, '服务端发生异常', '2019-06-02 23:56:51');
INSERT INTO `access_log` VALUES (22504, '64.80.15594910132815083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:53', 2, 0, '', '2019-06-02 23:56:53');
INSERT INTO `access_log` VALUES (22505, '64.84.15594910135245095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:54', 2, 0, '', '2019-06-02 23:56:54');
INSERT INTO `access_log` VALUES (22506, '59.73.15594910142565537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:54', 3, 0, '', '2019-06-02 23:56:54');
INSERT INTO `access_log` VALUES (22507, '59.76.15594910142535527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:54', 14, 2001001000, '服务端发生异常', '2019-06-02 23:56:54');
INSERT INTO `access_log` VALUES (22508, '64.83.15594910149375085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:55', 3, 0, '', '2019-06-02 23:56:55');
INSERT INTO `access_log` VALUES (22509, '64.78.15594910151635097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:55', 1, 0, '', '2019-06-02 23:56:55');
INSERT INTO `access_log` VALUES (22510, '59.78.15594910154885537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:55', 3, 0, '', '2019-06-02 23:56:55');
INSERT INTO `access_log` VALUES (22511, '59.74.15594910154915531', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:56:55', 10, 2001001000, '服务端发生异常', '2019-06-02 23:56:56');
INSERT INTO `access_log` VALUES (22512, '65.46.15594910304145297', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:57:10', 85, 0, '', '2019-06-02 23:57:11');
INSERT INTO `access_log` VALUES (22513, '65.49.15594910342975305', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.218.214.191', '2019-06-02 23:57:14', 9, 0, '', '2019-06-02 23:57:14');
INSERT INTO `access_log` VALUES (22514, '65.45.15594910347425305', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:57:15', 1, 1002001015, '账号未登陆', '2019-06-02 23:57:15');
INSERT INTO `access_log` VALUES (22515, '65.47.15594910347415303', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:57:15', 1, 1002001015, '账号未登陆', '2019-06-02 23:57:15');
INSERT INTO `access_log` VALUES (22516, '65.54.15594910347685273', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; vivo X9s Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.84 Mobile Safari/537.36 VivoBrowser/6.2.7.2', '36.113.129.131', '2019-06-02 23:57:15', 0, 1002001015, '账号未登陆', '2019-06-02 23:57:15');
INSERT INTO `access_log` VALUES (22517, '65.52.15594920965495301', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:14:57', 0, 1002001015, '账号未登陆', '2019-06-03 00:14:57');
INSERT INTO `access_log` VALUES (22518, '65.53.15594920965545289', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:14:57', 0, 1002001015, '账号未登陆', '2019-06-03 00:14:57');
INSERT INTO `access_log` VALUES (22519, '65.51.15594920965665303', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:14:57', 0, 1002001015, '账号未登陆', '2019-06-03 00:14:57');
INSERT INTO `access_log` VALUES (22520, '65.48.15594921017325317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:15:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 00:15:02');
INSERT INTO `access_log` VALUES (22521, '65.46.15594921070015313', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:15:07', 1138, 0, '', '2019-06-03 00:15:08');
INSERT INTO `access_log` VALUES (22522, '65.49.15594921086845321', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:15:09', 10, 0, '', '2019-06-03 00:15:09');
INSERT INTO `access_log` VALUES (22523, '65.45.15594921086885321', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:15:09', 9, 0, '', '2019-06-03 00:15:09');
INSERT INTO `access_log` VALUES (22524, '65.47.15594921086925319', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:15:09', 9, 0, '', '2019-06-03 00:15:09');
INSERT INTO `access_log` VALUES (22525, '62.84.15594921145305403', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:15:15', 12, 0, '', '2019-06-03 00:15:15');
INSERT INTO `access_log` VALUES (22526, '59.71.15594921291605553', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:15:29', 11, 0, '', '2019-06-03 00:15:29');
INSERT INTO `access_log` VALUES (22527, '66.54.15594921341574307', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:15:34', 19, 0, '', '2019-06-03 00:15:34');
INSERT INTO `access_log` VALUES (22528, '66.57.15594921406564307', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=3&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:15:41', 12, 0, '', '2019-06-03 00:15:41');
INSERT INTO `access_log` VALUES (22529, '65.53.15594921427915291', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:15:43', 288, 0, '', '2019-06-03 00:15:43');
INSERT INTO `access_log` VALUES (22530, '65.51.15594921510385305', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:15:51', 9, 0, '', '2019-06-03 00:15:51');
INSERT INTO `access_log` VALUES (22531, '65.48.15594921518785319', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:15:52', 10, 0, '', '2019-06-03 00:15:52');
INSERT INTO `access_log` VALUES (22532, '65.46.15594921525935315', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:15:53', 19, 0, '', '2019-06-03 00:15:53');
INSERT INTO `access_log` VALUES (22533, '59.73.15594921597745553', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:16:00', 11, 0, '', '2019-06-03 00:16:00');
INSERT INTO `access_log` VALUES (22534, '59.78.15594921617755553', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:16:02', 449, 2001001000, '服务端发生异常', '2019-06-03 00:16:02');
INSERT INTO `access_log` VALUES (22535, '59.74.15594921638305547', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:16:04', 395, 0, '', '2019-06-03 00:16:04');
INSERT INTO `access_log` VALUES (22536, '59.72.15594921668285547', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:16:07', 12, 0, '', '2019-06-03 00:16:07');
INSERT INTO `access_log` VALUES (22537, '59.75.15594921701385551', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:16:10', 8, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 00:16:10');
INSERT INTO `access_log` VALUES (22538, '62.88.15594921730345425', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.60', '101.229.195.81', '2019-06-03 00:16:13', 19, 0, '', '2019-06-03 00:16:13');
INSERT INTO `access_log` VALUES (22539, '59.72.15594925713695553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.36.252.72', '2019-06-03 00:22:51', 4, 0, '', '2019-06-03 00:22:51');
INSERT INTO `access_log` VALUES (22540, '59.74.15594925713695553', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.36.252.72', '2019-06-03 00:22:51', 13, 2001001000, '服务端发生异常', '2019-06-03 00:22:51');
INSERT INTO `access_log` VALUES (22541, '59.73.15594926522195561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.229.229.140', '2019-06-03 00:24:12', 12, 2001001000, '服务端发生异常', '2019-06-03 00:24:12');
INSERT INTO `access_log` VALUES (22542, '59.78.15594926522305561', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.229.229.140', '2019-06-03 00:24:12', 14, 0, '', '2019-06-03 00:24:12');
INSERT INTO `access_log` VALUES (22543, '64.78.15594926567165119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.229.229.140', '2019-06-03 00:24:17', 156, 0, '', '2019-06-03 00:24:17');
INSERT INTO `access_log` VALUES (22544, '64.76.15594926570965103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.229.229.140', '2019-06-03 00:24:17', 2, 0, '', '2019-06-03 00:24:17');
INSERT INTO `access_log` VALUES (22545, '64.77.15594926616745119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.229.229.140', '2019-06-03 00:24:22', 2, 0, '', '2019-06-03 00:24:22');
INSERT INTO `access_log` VALUES (22546, '64.85.15594926620015125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.229.229.140', '2019-06-03 00:24:22', 3, 0, '', '2019-06-03 00:24:22');
INSERT INTO `access_log` VALUES (22547, '64.81.15594926647975109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.229.229.140', '2019-06-03 00:24:25', 2, 0, '', '2019-06-03 00:24:25');
INSERT INTO `access_log` VALUES (22548, '64.79.15594926650115107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.229.229.140', '2019-06-03 00:24:25', 2, 0, '', '2019-06-03 00:24:25');
INSERT INTO `access_log` VALUES (22549, '64.84.15594926765735119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.229.229.140', '2019-06-03 00:24:37', 3, 0, '', '2019-06-03 00:24:37');
INSERT INTO `access_log` VALUES (22550, '64.83.15594926767355109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.229.229.140', '2019-06-03 00:24:37', 2, 0, '', '2019-06-03 00:24:37');
INSERT INTO `access_log` VALUES (22551, '64.78.15594926869745121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.229.229.140', '2019-06-03 00:24:47', 2, 0, '', '2019-06-03 00:24:47');
INSERT INTO `access_log` VALUES (22552, '64.76.15594926874035105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.229.229.140', '2019-06-03 00:24:47', 2, 0, '', '2019-06-03 00:24:47');
INSERT INTO `access_log` VALUES (22553, '59.74.15594926881255555', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.229.229.140', '2019-06-03 00:24:48', 2, 0, '', '2019-06-03 00:24:48');
INSERT INTO `access_log` VALUES (22554, '59.75.15594926881635559', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.229.229.140', '2019-06-03 00:24:48', 10, 2001001000, '服务端发生异常', '2019-06-03 00:24:48');
INSERT INTO `access_log` VALUES (22555, '65.49.15594930461425335', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '110.152.58.217', '2019-06-03 00:30:46', 0, 1002001015, '账号未登陆', '2019-06-03 00:30:46');
INSERT INTO `access_log` VALUES (22556, '65.45.15594930461405335', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '110.152.58.217', '2019-06-03 00:30:46', 0, 1002001015, '账号未登陆', '2019-06-03 00:30:46');
INSERT INTO `access_log` VALUES (22557, '65.47.15594930461495333', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '110.152.58.217', '2019-06-03 00:30:46', 0, 1002001015, '账号未登陆', '2019-06-03 00:30:46');
INSERT INTO `access_log` VALUES (22558, '65.54.15594930491145303', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '110.152.58.217', '2019-06-03 00:30:49', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 00:30:49');
INSERT INTO `access_log` VALUES (22559, '65.52.15594930634995317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '110.152.58.217', '2019-06-03 00:31:04', 86, 0, '', '2019-06-03 00:31:04');
INSERT INTO `access_log` VALUES (22560, '65.53.15594930639845305', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '110.152.58.217', '2019-06-03 00:31:04', 9, 0, '', '2019-06-03 00:31:04');
INSERT INTO `access_log` VALUES (22561, '65.51.15594930639895319', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '110.152.58.217', '2019-06-03 00:31:04', 8, 0, '', '2019-06-03 00:31:04');
INSERT INTO `access_log` VALUES (22562, '65.48.15594930639955333', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '110.152.58.217', '2019-06-03 00:31:04', 8, 0, '', '2019-06-03 00:31:04');
INSERT INTO `access_log` VALUES (22563, '64.83.15594930715425115', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '110.152.58.217', '2019-06-03 00:31:12', 12, 0, '', '2019-06-03 00:31:12');
INSERT INTO `access_log` VALUES (22564, '64.84.15594930715325125', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '110.152.58.217', '2019-06-03 00:31:12', 24, 0, '', '2019-06-03 00:31:12');
INSERT INTO `access_log` VALUES (22565, '59.72.15594930831305561', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '110.152.58.217', '2019-06-03 00:31:23', 18, 2001001000, '服务端发生异常', '2019-06-03 00:31:23');
INSERT INTO `access_log` VALUES (22566, '59.74.15594930854765561', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '110.152.58.217', '2019-06-03 00:31:25', 12, 0, '', '2019-06-03 00:31:25');
INSERT INTO `access_log` VALUES (22567, '64.76.15594930897625111', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '110.152.58.217', '2019-06-03 00:31:30', 12, 0, '', '2019-06-03 00:31:30');
INSERT INTO `access_log` VALUES (22568, '64.82.15594930929675131', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '110.152.58.217', '2019-06-03 00:31:33', 11, 0, '', '2019-06-03 00:31:33');
INSERT INTO `access_log` VALUES (22569, '65.47.15594933882765339', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.36.252.72', '2019-06-03 00:36:28', 0, 1002001015, '账号未登陆', '2019-06-03 00:36:28');
INSERT INTO `access_log` VALUES (22570, '65.45.15594933882765341', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.36.252.72', '2019-06-03 00:36:28', 1, 1002001015, '账号未登陆', '2019-06-03 00:36:28');
INSERT INTO `access_log` VALUES (22571, '65.54.15594933882795309', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.36.252.72', '2019-06-03 00:36:28', 0, 1002001015, '账号未登陆', '2019-06-03 00:36:28');
INSERT INTO `access_log` VALUES (22572, '65.50.15594933904985329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.36.252.72', '2019-06-03 00:36:30', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 00:36:31');
INSERT INTO `access_log` VALUES (22573, '65.53.15594934227835311', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.36.252.72', '2019-06-03 00:37:03', 93, 0, '', '2019-06-03 00:37:03');
INSERT INTO `access_log` VALUES (22574, '65.51.15594934231625325', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.36.252.72', '2019-06-03 00:37:03', 9, 0, '', '2019-06-03 00:37:03');
INSERT INTO `access_log` VALUES (22575, '65.46.15594934231725335', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.36.252.72', '2019-06-03 00:37:03', 8, 0, '', '2019-06-03 00:37:03');
INSERT INTO `access_log` VALUES (22576, '65.47.15594934292765341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.36.252.72', '2019-06-03 00:37:09', 98, 0, '', '2019-06-03 00:37:09');
INSERT INTO `access_log` VALUES (22577, '65.45.15594934296935343', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.36.252.72', '2019-06-03 00:37:10', 9, 0, '', '2019-06-03 00:37:10');
INSERT INTO `access_log` VALUES (22578, '65.54.15594934297005311', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.36.252.72', '2019-06-03 00:37:10', 9, 0, '', '2019-06-03 00:37:10');
INSERT INTO `access_log` VALUES (22579, '65.50.15594934313485331', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.36.252.72', '2019-06-03 00:37:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 00:37:11');
INSERT INTO `access_log` VALUES (22580, '65.52.15594934406195325', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.36.252.72', '2019-06-03 00:37:21', 87, 0, '', '2019-06-03 00:37:21');
INSERT INTO `access_log` VALUES (22581, '65.48.15594934409975341', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.36.252.72', '2019-06-03 00:37:21', 17, 0, '', '2019-06-03 00:37:21');
INSERT INTO `access_log` VALUES (22582, '65.53.15594934410115313', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.36.252.72', '2019-06-03 00:37:21', 9, 0, '', '2019-06-03 00:37:21');
INSERT INTO `access_log` VALUES (22583, '65.53.15594944385235327', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.205.53.141', '2019-06-03 00:53:59', 0, 1002001015, '账号未登陆', '2019-06-03 00:53:59');
INSERT INTO `access_log` VALUES (22584, '65.48.15594944385445355', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.205.53.141', '2019-06-03 00:53:59', 0, 1002001015, '账号未登陆', '2019-06-03 00:53:59');
INSERT INTO `access_log` VALUES (22585, '65.52.15594944385235339', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.205.53.141', '2019-06-03 00:53:59', 0, 1002001015, '账号未登陆', '2019-06-03 00:53:59');
INSERT INTO `access_log` VALUES (22586, '65.51.15594944411025341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.205.53.141', '2019-06-03 00:54:01', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 00:54:01');
INSERT INTO `access_log` VALUES (22587, '65.49.15594944524465359', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.205.53.141', '2019-06-03 00:54:12', 201, 0, '', '2019-06-03 00:54:13');
INSERT INTO `access_log` VALUES (22588, '65.47.15594944529895357', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.205.53.141', '2019-06-03 00:54:13', 10, 0, '', '2019-06-03 00:54:13');
INSERT INTO `access_log` VALUES (22589, '65.45.15594944529935359', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.205.53.141', '2019-06-03 00:54:13', 9, 0, '', '2019-06-03 00:54:13');
INSERT INTO `access_log` VALUES (22590, '65.54.15594944529935327', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.205.53.141', '2019-06-03 00:54:13', 12, 0, '', '2019-06-03 00:54:13');
INSERT INTO `access_log` VALUES (22591, '62.85.15594944569525451', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.205.53.141', '2019-06-03 00:54:17', 518, 0, '', '2019-06-03 00:54:17');
INSERT INTO `access_log` VALUES (22592, '64.81.15594944593135135', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.205.53.141', '2019-06-03 00:54:19', 113, 0, '', '2019-06-03 00:54:19');
INSERT INTO `access_log` VALUES (22593, '64.85.15594944593105151', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.205.53.141', '2019-06-03 00:54:19', 117, 0, '', '2019-06-03 00:54:19');
INSERT INTO `access_log` VALUES (22594, '66.53.15594944714284337', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.205.53.141', '2019-06-03 00:54:31', 23, 0, '', '2019-06-03 00:54:31');
INSERT INTO `access_log` VALUES (22595, '64.76.15594945073445131', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.205.53.141', '2019-06-03 00:55:07', 9, 0, '', '2019-06-03 00:55:07');
INSERT INTO `access_log` VALUES (22596, '64.78.15594945073425147', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.205.53.141', '2019-06-03 00:55:07', 11, 0, '', '2019-06-03 00:55:07');
INSERT INTO `access_log` VALUES (22597, '59.74.15594975766125621', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.140.245.210', '2019-06-03 01:46:17', 11, 0, '', '2019-06-03 01:46:17');
INSERT INTO `access_log` VALUES (22598, '59.75.15594975766135625', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.140.245.210', '2019-06-03 01:46:17', 16, 2001001000, '服务端发生异常', '2019-06-03 01:46:17');
INSERT INTO `access_log` VALUES (22599, '64.80.15594975807805175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.140.245.210', '2019-06-03 01:46:21', 12, 0, '', '2019-06-03 01:46:21');
INSERT INTO `access_log` VALUES (22600, '64.83.15594975809385177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.140.245.210', '2019-06-03 01:46:21', 3, 0, '', '2019-06-03 01:46:21');
INSERT INTO `access_log` VALUES (22601, '64.84.15594975823745187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.140.245.210', '2019-06-03 01:46:22', 2, 0, '', '2019-06-03 01:46:22');
INSERT INTO `access_log` VALUES (22602, '59.77.15594978107245621', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.140.245.210', '2019-06-03 01:50:11', 4, 0, '', '2019-06-03 01:50:11');
INSERT INTO `access_log` VALUES (22603, '59.72.15594978107255625', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.140.245.210', '2019-06-03 01:50:11', 14, 2001001000, '服务端发生异常', '2019-06-03 01:50:11');
INSERT INTO `access_log` VALUES (22604, '65.48.15595018416205455', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.84.146.197', '2019-06-03 02:57:22', 1, 1002001015, '账号未登陆', '2019-06-03 02:57:22');
INSERT INTO `access_log` VALUES (22605, '65.52.15595018416205439', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.84.146.197', '2019-06-03 02:57:22', 0, 1002001015, '账号未登陆', '2019-06-03 02:57:22');
INSERT INTO `access_log` VALUES (22606, '65.51.15595018416435441', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.84.146.197', '2019-06-03 02:57:22', 1, 1002001015, '账号未登陆', '2019-06-03 02:57:22');
INSERT INTO `access_log` VALUES (22607, '65.46.15595018438395451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.84.146.197', '2019-06-03 02:57:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 02:57:24');
INSERT INTO `access_log` VALUES (22608, '65.47.15595018595115457', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.84.146.197', '2019-06-03 02:57:40', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 02:57:40');
INSERT INTO `access_log` VALUES (22609, '65.54.15595205206515677', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '223.104.212.214', '2019-06-03 08:08:41', 1, 1002001015, '账号未登陆', '2019-06-03 08:08:41');
INSERT INTO `access_log` VALUES (22610, '65.47.15595205207175705', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '223.104.212.214', '2019-06-03 08:08:41', 1, 1002001015, '账号未登陆', '2019-06-03 08:08:41');
INSERT INTO `access_log` VALUES (22611, '65.45.15595205207215709', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '223.104.212.214', '2019-06-03 08:08:41', 1, 1002001015, '账号未登陆', '2019-06-03 08:08:41');
INSERT INTO `access_log` VALUES (22612, '59.75.15595209309765937', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.148.107', '2019-06-03 08:15:31', 12, 0, '', '2019-06-03 08:15:31');
INSERT INTO `access_log` VALUES (22613, '59.79.15595209309765937', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.148.107', '2019-06-03 08:15:31', 22, 2001001000, '服务端发生异常', '2019-06-03 08:15:31');
INSERT INTO `access_log` VALUES (22614, '65.52.15595217418845707', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '115.215.42.95', '2019-06-03 08:29:02', 1, 1002001015, '账号未登陆', '2019-06-03 08:29:02');
INSERT INTO `access_log` VALUES (22615, '65.53.15595217418845693', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '115.215.42.95', '2019-06-03 08:29:02', 1, 1002001015, '账号未登陆', '2019-06-03 08:29:02');
INSERT INTO `access_log` VALUES (22616, '65.51.15595217419005709', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '115.215.42.95', '2019-06-03 08:29:02', 1, 1002001015, '账号未登陆', '2019-06-03 08:29:02');
INSERT INTO `access_log` VALUES (22617, '65.48.15595217454755723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '115.215.42.95', '2019-06-03 08:29:05', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 08:29:05');
INSERT INTO `access_log` VALUES (22618, '65.49.15595217524925727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '115.215.42.95', '2019-06-03 08:29:12', 53, 0, '', '2019-06-03 08:29:13');
INSERT INTO `access_log` VALUES (22619, '65.54.15595217527975695', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '115.215.42.95', '2019-06-03 08:29:13', 14, 0, '', '2019-06-03 08:29:13');
INSERT INTO `access_log` VALUES (22620, '65.45.15595217528055727', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '115.215.42.95', '2019-06-03 08:29:13', 11, 0, '', '2019-06-03 08:29:13');
INSERT INTO `access_log` VALUES (22621, '65.47.15595217528055723', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '115.215.42.95', '2019-06-03 08:29:13', 12, 0, '', '2019-06-03 08:29:13');
INSERT INTO `access_log` VALUES (22622, '59.76.15595221550775947', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.41.120.11', '2019-06-03 08:35:55', 5, 0, '', '2019-06-03 08:35:55');
INSERT INTO `access_log` VALUES (22623, '59.78.15595221550795957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.41.120.11', '2019-06-03 08:35:55', 19, 2001001000, '服务端发生异常', '2019-06-03 08:35:55');
INSERT INTO `access_log` VALUES (22624, '64.83.15595221587095505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.41.120.11', '2019-06-03 08:35:59', 10, 0, '', '2019-06-03 08:35:59');
INSERT INTO `access_log` VALUES (22625, '64.84.15595221588695515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.41.120.11', '2019-06-03 08:35:59', 3, 0, '', '2019-06-03 08:35:59');
INSERT INTO `access_log` VALUES (22626, '64.76.15595221601575501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.41.120.11', '2019-06-03 08:36:00', 2, 0, '', '2019-06-03 08:36:00');
INSERT INTO `access_log` VALUES (22627, '64.78.15595221608035517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.41.120.11', '2019-06-03 08:36:01', 2, 0, '', '2019-06-03 08:36:01');
INSERT INTO `access_log` VALUES (22628, '64.82.15595221613395521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.41.120.11', '2019-06-03 08:36:01', 2, 0, '', '2019-06-03 08:36:01');
INSERT INTO `access_log` VALUES (22629, '64.77.15595221616235517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.41.120.11', '2019-06-03 08:36:02', 2, 0, '', '2019-06-03 08:36:02');
INSERT INTO `access_log` VALUES (22630, '59.73.15595221625335957', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.41.120.11', '2019-06-03 08:36:03', 3, 0, '', '2019-06-03 08:36:03');
INSERT INTO `access_log` VALUES (22631, '59.77.15595221625345947', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.41.120.11', '2019-06-03 08:36:03', 14, 2001001000, '服务端发生异常', '2019-06-03 08:36:03');
INSERT INTO `access_log` VALUES (22632, '59.76.15595222410325949', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.199.147', '2019-06-03 08:37:21', 13, 2001001000, '服务端发生异常', '2019-06-03 08:37:21');
INSERT INTO `access_log` VALUES (22633, '59.78.15595222410315959', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.199.147', '2019-06-03 08:37:21', 109, 0, '', '2019-06-03 08:37:21');
INSERT INTO `access_log` VALUES (22634, '64.76.15595222528625503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:37:33', 3, 0, '', '2019-06-03 08:37:33');
INSERT INTO `access_log` VALUES (22635, '64.78.15595222530425519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:37:33', 2, 0, '', '2019-06-03 08:37:33');
INSERT INTO `access_log` VALUES (22636, '64.77.15595222644625519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:37:44', 2, 0, '', '2019-06-03 08:37:44');
INSERT INTO `access_log` VALUES (22637, '59.77.15595222644635949', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:37:44', 3, 0, '', '2019-06-03 08:37:44');
INSERT INTO `access_log` VALUES (22638, '64.81.15595222645575509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:37:45', 2, 0, '', '2019-06-03 08:37:45');
INSERT INTO `access_log` VALUES (22639, '59.72.15595222645535953', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:37:45', 14, 2001001000, '服务端发生异常', '2019-06-03 08:37:45');
INSERT INTO `access_log` VALUES (22640, '64.79.15595222728865507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:37:53', 2, 0, '', '2019-06-03 08:37:53');
INSERT INTO `access_log` VALUES (22641, '64.80.15595222729765507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:37:53', 2, 0, '', '2019-06-03 08:37:53');
INSERT INTO `access_log` VALUES (22642, '64.83.15595222742365509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:37:54', 2, 0, '', '2019-06-03 08:37:54');
INSERT INTO `access_log` VALUES (22643, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:37:54', 14, 0, '', '2019-06-03 08:37:54');
INSERT INTO `access_log` VALUES (22644, '64.84.15595222759065519', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:37:56', 328, 0, '', '2019-06-03 08:37:56');
INSERT INTO `access_log` VALUES (22645, '64.76.15595222787735505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:37:59', 2, 0, '', '2019-06-03 08:37:59');
INSERT INTO `access_log` VALUES (22646, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:37:59', 7, 0, '', '2019-06-03 08:37:59');
INSERT INTO `access_log` VALUES (22647, '64.78.15595222789745521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:37:59', 2, 0, '', '2019-06-03 08:37:59');
INSERT INTO `access_log` VALUES (22648, '64.82.15595222796785525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:38:00', 73, 0, '', '2019-06-03 08:38:00');
INSERT INTO `access_log` VALUES (22649, '64.77.15595222807675521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:38:01', 2, 0, '', '2019-06-03 08:38:01');
INSERT INTO `access_log` VALUES (22650, '64.81.15595222813175511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:38:01', 2, 0, '', '2019-06-03 08:38:01');
INSERT INTO `access_log` VALUES (22651, '59.75.15595222865635957', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:38:07', 3, 0, '', '2019-06-03 08:38:07');
INSERT INTO `access_log` VALUES (22652, '59.71.15595222865635961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:38:07', 13, 2001001000, '服务端发生异常', '2019-06-03 08:38:07');
INSERT INTO `access_log` VALUES (22653, '64.79.15595222873695509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:38:07', 2, 0, '', '2019-06-03 08:38:07');
INSERT INTO `access_log` VALUES (22654, '64.80.15595222875115509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:38:08', 2, 0, '', '2019-06-03 08:38:08');
INSERT INTO `access_log` VALUES (22655, '59.80.15595222876875953', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:38:08', 3, 0, '', '2019-06-03 08:38:08');
INSERT INTO `access_log` VALUES (22656, '59.76.15595222876895951', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '223.223.199.147', '2019-06-03 08:38:08', 13, 2001001000, '服务端发生异常', '2019-06-03 08:38:08');
INSERT INTO `access_log` VALUES (22657, '59.78.15595222931935961', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '112.224.1.254', '2019-06-03 08:38:13', 3, 0, '', '2019-06-03 08:38:13');
INSERT INTO `access_log` VALUES (22658, '59.73.15595222932105961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '112.224.1.254', '2019-06-03 08:38:13', 12, 2001001000, '服务端发生异常', '2019-06-03 08:38:13');
INSERT INTO `access_log` VALUES (22659, '64.83.15595222998555511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '112.224.1.254', '2019-06-03 08:38:20', 3, 0, '', '2019-06-03 08:38:20');
INSERT INTO `access_log` VALUES (22660, '64.84.15595223000555521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '112.224.1.254', '2019-06-03 08:38:20', 2, 0, '', '2019-06-03 08:38:20');
INSERT INTO `access_log` VALUES (22661, '64.78.15595223065435523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '112.224.1.254', '2019-06-03 08:38:27', 3, 0, '', '2019-06-03 08:38:27');
INSERT INTO `access_log` VALUES (22662, '64.82.15595223067115527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '112.224.1.254', '2019-06-03 08:38:27', 2, 0, '', '2019-06-03 08:38:27');
INSERT INTO `access_log` VALUES (22663, '59.72.15595223084765955', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '112.224.1.254', '2019-06-03 08:38:28', 2, 0, '', '2019-06-03 08:38:28');
INSERT INTO `access_log` VALUES (22664, '59.74.15595223084775955', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '112.224.1.254', '2019-06-03 08:38:28', 13, 2001001000, '服务端发生异常', '2019-06-03 08:38:28');
INSERT INTO `access_log` VALUES (22665, '65.45.15595224242765739', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '157.61.96.61', '2019-06-03 08:40:24', 0, 1002001015, '账号未登陆', '2019-06-03 08:40:24');
INSERT INTO `access_log` VALUES (22666, '59.74.15595224439525957', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:40:44', 2, 0, '', '2019-06-03 08:40:44');
INSERT INTO `access_log` VALUES (22667, '59.79.15595224439735961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:40:44', 13, 2001001000, '服务端发生异常', '2019-06-03 08:40:44');
INSERT INTO `access_log` VALUES (22668, '64.82.15595224480785529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:40:48', 2, 0, '', '2019-06-03 08:40:48');
INSERT INTO `access_log` VALUES (22669, '64.77.15595224482645525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:40:48', 2, 0, '', '2019-06-03 08:40:48');
INSERT INTO `access_log` VALUES (22670, '64.81.15595224502725515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:40:50', 2, 0, '', '2019-06-03 08:40:50');
INSERT INTO `access_log` VALUES (22671, '64.79.15595224549645513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:40:55', 3, 0, '', '2019-06-03 08:40:55');
INSERT INTO `access_log` VALUES (22672, '64.80.15595224551585513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:40:55', 2, 0, '', '2019-06-03 08:40:55');
INSERT INTO `access_log` VALUES (22673, '65.47.15595224729415731', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:41:13', 0, 1002001015, '账号未登陆', '2019-06-03 08:41:13');
INSERT INTO `access_log` VALUES (22674, '65.54.15595224729505705', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:41:13', 1, 1002001015, '账号未登陆', '2019-06-03 08:41:13');
INSERT INTO `access_log` VALUES (22675, '65.52.15595224729625719', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:41:13', 0, 1002001015, '账号未登陆', '2019-06-03 08:41:13');
INSERT INTO `access_log` VALUES (22676, '65.50.15595224765235725', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:41:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 08:41:17');
INSERT INTO `access_log` VALUES (22677, '65.51.15595224812245723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:41:21', 115, 0, '', '2019-06-03 08:41:21');
INSERT INTO `access_log` VALUES (22678, '65.53.15595224818375705', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:41:22', 974, 0, '', '2019-06-03 08:41:23');
INSERT INTO `access_log` VALUES (22679, '65.45.15595224818405741', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:41:22', 972, 0, '', '2019-06-03 08:41:23');
INSERT INTO `access_log` VALUES (22680, '65.48.15595224818475737', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:41:22', 966, 0, '', '2019-06-03 08:41:23');
INSERT INTO `access_log` VALUES (22681, '62.82.15595224877545833', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:41:28', 20, 0, '', '2019-06-03 08:41:28');
INSERT INTO `access_log` VALUES (22682, '65.46.15595224921455733', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:41:32', 19, 0, '', '2019-06-03 08:41:32');
INSERT INTO `access_log` VALUES (22683, '65.47.15595224957985733', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:41:36', 17, 0, '', '2019-06-03 08:41:36');
INSERT INTO `access_log` VALUES (22684, '65.52.15595225061245721', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:41:46', 10, 0, '', '2019-06-03 08:41:46');
INSERT INTO `access_log` VALUES (22685, '65.50.15595225105725727', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.204.41.212', '2019-06-03 08:41:51', 12, 0, '', '2019-06-03 08:41:51');
INSERT INTO `access_log` VALUES (22686, '59.73.15595226672965967', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.102.83', '2019-06-03 08:44:27', 4, 0, '', '2019-06-03 08:44:27');
INSERT INTO `access_log` VALUES (22687, '59.77.15595226672965957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.102.83', '2019-06-03 08:44:27', 13, 2001001000, '服务端发生异常', '2019-06-03 08:44:27');
INSERT INTO `access_log` VALUES (22688, '59.74.15595226723535961', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.111.103.3', '2019-06-03 08:44:32', 3, 0, '', '2019-06-03 08:44:32');
INSERT INTO `access_log` VALUES (22689, '59.72.15595226723535961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.111.103.3', '2019-06-03 08:44:32', 13, 2001001000, '服务端发生异常', '2019-06-03 08:44:32');
INSERT INTO `access_log` VALUES (22690, '59.75.15595226794465965', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '117.136.79.31', '2019-06-03 08:44:39', 3, 0, '', '2019-06-03 08:44:39');
INSERT INTO `access_log` VALUES (22691, '59.71.15595226794455969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '117.136.79.31', '2019-06-03 08:44:39', 12, 2001001000, '服务端发生异常', '2019-06-03 08:44:39');
INSERT INTO `access_log` VALUES (22692, '59.80.15595226913905961', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.4.237.235', '2019-06-03 08:44:51', 3, 0, '', '2019-06-03 08:44:51');
INSERT INTO `access_log` VALUES (22693, '59.78.15595226913955969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.4.237.235', '2019-06-03 08:44:51', 13, 2001001000, '服务端发生异常', '2019-06-03 08:44:51');
INSERT INTO `access_log` VALUES (22694, '65.47.15595227416115737', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.232.58.16', '2019-06-03 08:45:42', 0, 1002001015, '账号未登陆', '2019-06-03 08:45:42');
INSERT INTO `access_log` VALUES (22695, '65.54.15595227416235711', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.232.58.16', '2019-06-03 08:45:42', 1, 1002001015, '账号未登陆', '2019-06-03 08:45:42');
INSERT INTO `access_log` VALUES (22696, '65.52.15595227416245725', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.232.58.16', '2019-06-03 08:45:42', 1, 1002001015, '账号未登陆', '2019-06-03 08:45:42');
INSERT INTO `access_log` VALUES (22697, '65.47.15595228576965739', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.232.58.16', '2019-06-03 08:47:38', 69, 0, '', '2019-06-03 08:47:38');
INSERT INTO `access_log` VALUES (22698, '65.52.15595228714605727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.232.58.16', '2019-06-03 08:47:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 08:47:51');
INSERT INTO `access_log` VALUES (22699, '65.51.15595228771925731', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.232.58.16', '2019-06-03 08:47:57', 60, 0, '', '2019-06-03 08:47:57');
INSERT INTO `access_log` VALUES (22700, '65.45.15595231972085753', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 08:53:17', 1, 1002001015, '账号未登陆', '2019-06-03 08:53:17');
INSERT INTO `access_log` VALUES (22701, '65.48.15595231984305749', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 08:53:18', 0, 1002001015, '账号未登陆', '2019-06-03 08:53:18');
INSERT INTO `access_log` VALUES (22702, '65.49.15595231984335753', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 08:53:18', 1, 1002001015, '账号未登陆', '2019-06-03 08:53:18');
INSERT INTO `access_log` VALUES (22703, '65.46.15595232025195745', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 08:53:23', 68, 0, '', '2019-06-03 08:53:23');
INSERT INTO `access_log` VALUES (22704, '65.47.15595232028635745', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 08:53:23', 9, 0, '', '2019-06-03 08:53:23');
INSERT INTO `access_log` VALUES (22705, '65.54.15595232028675719', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 08:53:23', 9, 0, '', '2019-06-03 08:53:23');
INSERT INTO `access_log` VALUES (22706, '65.52.15595232028685733', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 08:53:23', 9, 0, '', '2019-06-03 08:53:23');
INSERT INTO `access_log` VALUES (22707, '62.89.15595232063055833', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 08:53:26', 15, 0, '', '2019-06-03 08:53:26');
INSERT INTO `access_log` VALUES (22708, '59.79.15595232098175973', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 08:53:30', 17, 0, '', '2019-06-03 08:53:30');
INSERT INTO `access_log` VALUES (22709, '59.71.15595232180805977', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 08:53:38', 7, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 08:53:38');
INSERT INTO `access_log` VALUES (22710, '65.54.15595234588975723', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '49.77.184.164', '2019-06-03 08:57:39', 1, 1002001015, '账号未登陆', '2019-06-03 08:57:39');
INSERT INTO `access_log` VALUES (22711, '65.52.15595234589065737', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '49.77.184.164', '2019-06-03 08:57:39', 0, 1002001015, '账号未登陆', '2019-06-03 08:57:39');
INSERT INTO `access_log` VALUES (22712, '65.47.15595234588965749', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '49.77.184.164', '2019-06-03 08:57:39', 1, 1002001015, '账号未登陆', '2019-06-03 08:57:39');
INSERT INTO `access_log` VALUES (22713, '65.51.15595234624735741', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '49.77.184.164', '2019-06-03 08:57:42', 99, 0, '', '2019-06-03 08:57:43');
INSERT INTO `access_log` VALUES (22714, '65.53.15595234628495723', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '49.77.184.164', '2019-06-03 08:57:43', 9, 0, '', '2019-06-03 08:57:43');
INSERT INTO `access_log` VALUES (22715, '65.45.15595234628525759', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '49.77.184.164', '2019-06-03 08:57:43', 9, 0, '', '2019-06-03 08:57:43');
INSERT INTO `access_log` VALUES (22716, '65.49.15595234628585759', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '49.77.184.164', '2019-06-03 08:57:43', 9, 0, '', '2019-06-03 08:57:43');
INSERT INTO `access_log` VALUES (22717, '62.84.15595234665035823', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '49.77.184.164', '2019-06-03 08:57:47', 13, 0, '', '2019-06-03 08:57:47');
INSERT INTO `access_log` VALUES (22718, '64.80.15595234748155527', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '49.77.184.164', '2019-06-03 08:57:55', 9, 0, '', '2019-06-03 08:57:55');
INSERT INTO `access_log` VALUES (22719, '64.79.15595234748125527', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '49.77.184.164', '2019-06-03 08:57:55', 14, 0, '', '2019-06-03 08:57:55');
INSERT INTO `access_log` VALUES (22720, '62.80.15595234893455841', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '49.77.184.164', '2019-06-03 08:58:09', 12, 0, '', '2019-06-03 08:58:09');
INSERT INTO `access_log` VALUES (22721, '59.71.15595236438525983', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.233.185', '2019-06-03 09:00:44', 3, 0, '', '2019-06-03 09:00:44');
INSERT INTO `access_log` VALUES (22722, '59.75.15595236438515979', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.233.185', '2019-06-03 09:00:44', 13, 2001001000, '服务端发生异常', '2019-06-03 09:00:44');
INSERT INTO `access_log` VALUES (22723, '64.76.15595236618705527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.233.185', '2019-06-03 09:01:02', 5, 0, '', '2019-06-03 09:01:02');
INSERT INTO `access_log` VALUES (22724, '64.78.15595236619945543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.233.185', '2019-06-03 09:01:02', 2, 0, '', '2019-06-03 09:01:02');
INSERT INTO `access_log` VALUES (22725, '64.82.15595236629005547', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.233.185', '2019-06-03 09:01:03', 2, 0, '', '2019-06-03 09:01:03');
INSERT INTO `access_log` VALUES (22726, '64.77.15595236633845543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.233.185', '2019-06-03 09:01:03', 2, 0, '', '2019-06-03 09:01:03');
INSERT INTO `access_log` VALUES (22727, '59.77.15595238561845975', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:04:16', 3, 0, '', '2019-06-03 09:04:16');
INSERT INTO `access_log` VALUES (22728, '59.74.15595238561855979', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:04:16', 13, 2001001000, '服务端发生异常', '2019-06-03 09:04:16');
INSERT INTO `access_log` VALUES (22729, '64.79.15595238589245533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:04:19', 3, 0, '', '2019-06-03 09:04:19');
INSERT INTO `access_log` VALUES (22730, '64.83.15595238590545535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:04:19', 2, 0, '', '2019-06-03 09:04:19');
INSERT INTO `access_log` VALUES (22731, '64.84.15595238599525545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:04:20', 2, 0, '', '2019-06-03 09:04:20');
INSERT INTO `access_log` VALUES (22732, '64.78.15595238606095547', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:04:21', 2, 0, '', '2019-06-03 09:04:21');
INSERT INTO `access_log` VALUES (22733, '64.82.15595238610685551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:04:21', 368, 0, '', '2019-06-03 09:04:21');
INSERT INTO `access_log` VALUES (22734, '64.77.15595238613425547', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:04:21', 93, 0, '', '2019-06-03 09:04:21');
INSERT INTO `access_log` VALUES (22735, '64.81.15595238633815537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:04:23', 2, 0, '', '2019-06-03 09:04:23');
INSERT INTO `access_log` VALUES (22736, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:04:23', 9, 0, '', '2019-06-03 09:04:23');
INSERT INTO `access_log` VALUES (22737, '64.85.15595238646715553', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:04:25', 60, 0, '', '2019-06-03 09:04:25');
INSERT INTO `access_log` VALUES (22738, '59.77.15595239736305977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:14', 3, 0, '', '2019-06-03 09:06:14');
INSERT INTO `access_log` VALUES (22739, '59.74.15595239736315981', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:14', 12, 2001001000, '服务端发生异常', '2019-06-03 09:06:14');
INSERT INTO `access_log` VALUES (22740, '65.47.15595239816255757', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:06:22', 4, 1002001012, '访问令牌已过期', '2019-06-03 09:06:22');
INSERT INTO `access_log` VALUES (22741, '65.52.15595239816255745', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:06:22', 4, 1002001012, '访问令牌已过期', '2019-06-03 09:06:22');
INSERT INTO `access_log` VALUES (22742, '65.51.15595239816275749', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:06:22', 3, 1002001012, '访问令牌已过期', '2019-06-03 09:06:22');
INSERT INTO `access_log` VALUES (22743, '65.53.15595239838445731', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:06:24', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:06:24');
INSERT INTO `access_log` VALUES (22744, '64.81.15595239856825539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:26', 178, 0, '', '2019-06-03 09:06:26');
INSERT INTO `access_log` VALUES (22745, '64.85.15595239860305555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:26', 2, 0, '', '2019-06-03 09:06:26');
INSERT INTO `access_log` VALUES (22746, '64.80.15595239874795537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:27', 2, 0, '', '2019-06-03 09:06:27');
INSERT INTO `access_log` VALUES (22747, '65.45.15595239880265767', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:28', 1, 1002001015, '账号未登陆', '2019-06-03 09:06:28');
INSERT INTO `access_log` VALUES (22748, '65.48.15595239880305763', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:28', 0, 1002001015, '账号未登陆', '2019-06-03 09:06:28');
INSERT INTO `access_log` VALUES (22749, '65.46.15595239880385759', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:28', 1, 1002001015, '账号未登陆', '2019-06-03 09:06:28');
INSERT INTO `access_log` VALUES (22750, '59.71.15595239949795989', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.71.57.174', '2019-06-03 09:06:35', 3, 0, '', '2019-06-03 09:06:35');
INSERT INTO `access_log` VALUES (22751, '59.75.15595239949805985', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.71.57.174', '2019-06-03 09:06:35', 14, 2001001000, '服务端发生异常', '2019-06-03 09:06:35');
INSERT INTO `access_log` VALUES (22752, '65.50.15595239970235753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:37', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:06:37');
INSERT INTO `access_log` VALUES (22753, '65.52.15595240010525747', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:06:41', 61, 0, '', '2019-06-03 09:06:41');
INSERT INTO `access_log` VALUES (22754, '65.51.15595240015665751', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:06:42', 11, 0, '', '2019-06-03 09:06:42');
INSERT INTO `access_log` VALUES (22755, '65.49.15595240015675769', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:06:42', 9, 0, '', '2019-06-03 09:06:42');
INSERT INTO `access_log` VALUES (22756, '65.47.15595240015675759', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:06:42', 11, 0, '', '2019-06-03 09:06:42');
INSERT INTO `access_log` VALUES (22757, '64.83.15595240017815539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.71.57.174', '2019-06-03 09:06:42', 2, 0, '', '2019-06-03 09:06:42');
INSERT INTO `access_log` VALUES (22758, '64.84.15595240018995549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.71.57.174', '2019-06-03 09:06:42', 2, 0, '', '2019-06-03 09:06:42');
INSERT INTO `access_log` VALUES (22759, '65.53.15595240054415733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:45', 153, 0, '', '2019-06-03 09:06:46');
INSERT INTO `access_log` VALUES (22760, '64.76.15595240056045535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.71.57.174', '2019-06-03 09:06:46', 3, 0, '', '2019-06-03 09:06:46');
INSERT INTO `access_log` VALUES (22761, '64.78.15595240057075551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.71.57.174', '2019-06-03 09:06:46', 2, 0, '', '2019-06-03 09:06:46');
INSERT INTO `access_log` VALUES (22762, '65.46.15595240059025761', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:46', 9, 0, '', '2019-06-03 09:06:46');
INSERT INTO `access_log` VALUES (22763, '65.45.15595240059075769', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:46', 9, 0, '', '2019-06-03 09:06:46');
INSERT INTO `access_log` VALUES (22764, '65.48.15595240059105765', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:46', 9, 0, '', '2019-06-03 09:06:46');
INSERT INTO `access_log` VALUES (22765, '59.78.15595240106965989', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.71.57.174', '2019-06-03 09:06:51', 3, 0, '', '2019-06-03 09:06:51');
INSERT INTO `access_log` VALUES (22766, '59.80.15595240106965981', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.71.57.174', '2019-06-03 09:06:51', 13, 2001001000, '服务端发生异常', '2019-06-03 09:06:51');
INSERT INTO `access_log` VALUES (22767, '62.84.15595240131725831', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:06:53', 11, 0, '', '2019-06-03 09:06:53');
INSERT INTO `access_log` VALUES (22768, '64.82.15595240134175555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.71.57.174', '2019-06-03 09:06:53', 2, 0, '', '2019-06-03 09:06:53');
INSERT INTO `access_log` VALUES (22769, '64.81.15595240135215541', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.71.57.174', '2019-06-03 09:06:54', 2, 0, '', '2019-06-03 09:06:54');
INSERT INTO `access_log` VALUES (22770, '64.80.15595240153505539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.71.57.174', '2019-06-03 09:06:55', 165, 0, '', '2019-06-03 09:06:56');
INSERT INTO `access_log` VALUES (22771, '64.85.15595240147005557', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.71.57.174', '2019-06-03 09:06:55', 815, 0, '', '2019-06-03 09:06:56');
INSERT INTO `access_log` VALUES (22772, '64.83.15595240157905541', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:56', 7, 0, '', '2019-06-03 09:06:56');
INSERT INTO `access_log` VALUES (22773, '64.79.15595240157875539', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '220.172.53.92', '2019-06-03 09:06:56', 11, 0, '', '2019-06-03 09:06:56');
INSERT INTO `access_log` VALUES (22774, '64.82.15595240590175557', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:07:39', 8, 0, '', '2019-06-03 09:07:39');
INSERT INTO `access_log` VALUES (22775, '64.77.15595240590165553', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:07:39', 10, 0, '', '2019-06-03 09:07:39');
INSERT INTO `access_log` VALUES (22776, '62.82.15595241578555857', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:09:18', 86, 0, '', '2019-06-03 09:09:18');
INSERT INTO `access_log` VALUES (22777, '66.56.15595241650834729', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:09:25', 22, 0, '', '2019-06-03 09:09:25');
INSERT INTO `access_log` VALUES (22778, '64.82.15595241759495559', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:09:36', 11, 0, '', '2019-06-03 09:09:36');
INSERT INTO `access_log` VALUES (22779, '65.52.15595241795455751', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:09:40', 267, 0, '', '2019-06-03 09:09:40');
INSERT INTO `access_log` VALUES (22780, '65.47.15595241802305763', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:09:40', 10, 0, '', '2019-06-03 09:09:40');
INSERT INTO `access_log` VALUES (22781, '65.49.15595241811965773', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:09:41', 8, 0, '', '2019-06-03 09:09:41');
INSERT INTO `access_log` VALUES (22782, '65.51.15595241838045755', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.160.135.213', '2019-06-03 09:09:44', 13, 0, '', '2019-06-03 09:09:44');
INSERT INTO `access_log` VALUES (22783, '64.85.15595241927505561', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:09:53', 9, 0, '', '2019-06-03 09:09:53');
INSERT INTO `access_log` VALUES (22784, '64.81.15595241927475545', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:09:53', 13, 0, '', '2019-06-03 09:09:53');
INSERT INTO `access_log` VALUES (22785, '64.83.15595241947035545', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:09:55', 439, 0, '', '2019-06-03 09:09:55');
INSERT INTO `access_log` VALUES (22786, '64.79.15595241946705543', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:09:55', 473, 0, '', '2019-06-03 09:09:55');
INSERT INTO `access_log` VALUES (22787, '64.80.15595241946705543', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.178.118.37', '2019-06-03 09:09:55', 476, 0, '', '2019-06-03 09:09:55');
INSERT INTO `access_log` VALUES (22788, '65.54.15595242653695739', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.233.185', '2019-06-03 09:11:05', 1, 1002001015, '账号未登陆', '2019-06-03 09:11:05');
INSERT INTO `access_log` VALUES (22789, '65.52.15595242653695753', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.246.246.152', '2019-06-03 09:11:05', 1, 1002001015, '账号未登陆', '2019-06-03 09:11:05');
INSERT INTO `access_log` VALUES (22790, '65.47.15595242653735765', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.150.211', '2019-06-03 09:11:05', 0, 1002001015, '账号未登陆', '2019-06-03 09:11:05');
INSERT INTO `access_log` VALUES (22791, '65.47.15595243779825767', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.233.185', '2019-06-03 09:12:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:12:58');
INSERT INTO `access_log` VALUES (22792, '59.76.15595244259205985', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:13:46', 3, 0, '', '2019-06-03 09:13:46');
INSERT INTO `access_log` VALUES (22793, '59.78.15595244259225995', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:13:46', 13, 2001001000, '服务端发生异常', '2019-06-03 09:13:46');
INSERT INTO `access_log` VALUES (22794, '65.45.15595244350405777', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:13:55', 0, 1002001015, '账号未登陆', '2019-06-03 09:13:55');
INSERT INTO `access_log` VALUES (22795, '65.48.15595244350405773', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:13:55', 0, 1002001015, '账号未登陆', '2019-06-03 09:13:55');
INSERT INTO `access_log` VALUES (22796, '65.46.15595244350465769', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:13:55', 1, 1002001015, '账号未登陆', '2019-06-03 09:13:55');
INSERT INTO `access_log` VALUES (22797, '64.81.15595244356305549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:13:56', 5, 0, '', '2019-06-03 09:13:56');
INSERT INTO `access_log` VALUES (22798, '64.79.15595244357575547', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:13:56', 3, 0, '', '2019-06-03 09:13:56');
INSERT INTO `access_log` VALUES (22799, '64.80.15595244413315547', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:01', 2, 0, '', '2019-06-03 09:14:01');
INSERT INTO `access_log` VALUES (22800, '64.83.15595244416395549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:02', 2, 0, '', '2019-06-03 09:14:02');
INSERT INTO `access_log` VALUES (22801, '59.73.15595244429215995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:03', 2, 0, '', '2019-06-03 09:14:03');
INSERT INTO `access_log` VALUES (22802, '59.77.15595244429215985', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:03', 18, 2001001000, '服务端发生异常', '2019-06-03 09:14:03');
INSERT INTO `access_log` VALUES (22803, '65.50.15595244466625763', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:14:07');
INSERT INTO `access_log` VALUES (22804, '65.47.15595244511095769', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:11', 5, 1002002000, '账号不存在', '2019-06-03 09:14:11');
INSERT INTO `access_log` VALUES (22805, '65.49.15595244678505779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:28', 90, 0, '', '2019-06-03 09:14:28');
INSERT INTO `access_log` VALUES (22806, '65.51.15595244682325761', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:28', 8, 0, '', '2019-06-03 09:14:28');
INSERT INTO `access_log` VALUES (22807, '65.46.15595244682355771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:28', 8, 0, '', '2019-06-03 09:14:28');
INSERT INTO `access_log` VALUES (22808, '65.53.15595244682325743', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:28', 10, 0, '', '2019-06-03 09:14:28');
INSERT INTO `access_log` VALUES (22809, '62.86.15595244744345841', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:34', 13, 0, '', '2019-06-03 09:14:34');
INSERT INTO `access_log` VALUES (22810, '64.77.15595244769985561', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:37', 9, 0, '', '2019-06-03 09:14:37');
INSERT INTO `access_log` VALUES (22811, '64.82.15595244769965565', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:37', 12, 0, '', '2019-06-03 09:14:37');
INSERT INTO `access_log` VALUES (22812, '66.49.15595244798134735', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:40', 15, 0, '', '2019-06-03 09:14:40');
INSERT INTO `access_log` VALUES (22813, '59.75.15595244849075993', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:45', 11, 0, '', '2019-06-03 09:14:45');
INSERT INTO `access_log` VALUES (22814, '65.45.15595244870085779', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:47', 20, 0, '', '2019-06-03 09:14:47');
INSERT INTO `access_log` VALUES (22815, '65.50.15595244879535765', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:48', 9, 0, '', '2019-06-03 09:14:48');
INSERT INTO `access_log` VALUES (22816, '65.52.15595244888765759', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:49', 10, 0, '', '2019-06-03 09:14:49');
INSERT INTO `access_log` VALUES (22817, '65.47.15595244907995771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:14:51', 48, 0, '', '2019-06-03 09:14:51');
INSERT INTO `access_log` VALUES (22818, '62.81.15595245001195835', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:15:00', 13, 0, '', '2019-06-03 09:15:00');
INSERT INTO `access_log` VALUES (22819, '64.80.15595245131875549', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:15:13', 9, 0, '', '2019-06-03 09:15:13');
INSERT INTO `access_log` VALUES (22820, '64.79.15595245131875549', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:15:13', 11, 0, '', '2019-06-03 09:15:13');
INSERT INTO `access_log` VALUES (22821, '65.53.15595245352665745', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.229.251.88', '2019-06-03 09:15:35', 0, 1002001015, '账号未登陆', '2019-06-03 09:15:35');
INSERT INTO `access_log` VALUES (22822, '65.46.15595245352725773', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.229.251.88', '2019-06-03 09:15:35', 0, 1002001015, '账号未登陆', '2019-06-03 09:15:35');
INSERT INTO `access_log` VALUES (22823, '65.48.15595245352755777', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.229.251.88', '2019-06-03 09:15:35', 0, 1002001015, '账号未登陆', '2019-06-03 09:15:35');
INSERT INTO `access_log` VALUES (22824, '65.50.15595245397975767', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.229.251.88', '2019-06-03 09:15:40', 77, 0, '', '2019-06-03 09:15:40');
INSERT INTO `access_log` VALUES (22825, '65.52.15595245447635761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.229.251.88', '2019-06-03 09:15:45', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:15:45');
INSERT INTO `access_log` VALUES (22826, '65.54.15595245560385747', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.229.251.88', '2019-06-03 09:15:56', 223, 0, '', '2019-06-03 09:15:56');
INSERT INTO `access_log` VALUES (22827, '65.49.15595245621835783', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.229.251.88', '2019-06-03 09:16:02', 84, 0, '', '2019-06-03 09:16:02');
INSERT INTO `access_log` VALUES (22828, '65.46.15595245951045775', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '183.192.164.85', '2019-06-03 09:16:35', 1, 1002001015, '账号未登陆', '2019-06-03 09:16:35');
INSERT INTO `access_log` VALUES (22829, '65.45.15595246015855783', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '183.192.164.56', '2019-06-03 09:16:42', 1, 1002001015, '账号未登陆', '2019-06-03 09:16:42');
INSERT INTO `access_log` VALUES (22830, '65.52.15595246179885763', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '183.192.164.56', '2019-06-03 09:16:58', 0, 1002001015, '账号未登陆', '2019-06-03 09:16:58');
INSERT INTO `access_log` VALUES (22831, '65.51.15595246647175767', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:17:45', 0, 1002001015, '账号未登陆', '2019-06-03 09:17:45');
INSERT INTO `access_log` VALUES (22832, '65.53.15595246647195749', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:17:45', 0, 1002001015, '账号未登陆', '2019-06-03 09:17:45');
INSERT INTO `access_log` VALUES (22833, '65.46.15595246647255777', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:17:45', 1, 1002001015, '账号未登陆', '2019-06-03 09:17:45');
INSERT INTO `access_log` VALUES (22834, '65.48.15595246671055781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:17:47', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:17:47');
INSERT INTO `access_log` VALUES (22835, '65.45.15595246718225785', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:17:52', 92, 0, '', '2019-06-03 09:17:52');
INSERT INTO `access_log` VALUES (22836, '65.50.15595246721465771', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:17:52', 8, 0, '', '2019-06-03 09:17:52');
INSERT INTO `access_log` VALUES (22837, '65.52.15595246721485765', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:17:52', 8, 0, '', '2019-06-03 09:17:52');
INSERT INTO `access_log` VALUES (22838, '65.47.15595246721515777', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:17:52', 7, 0, '', '2019-06-03 09:17:52');
INSERT INTO `access_log` VALUES (22839, '62.89.15595246807705855', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:01', 13, 0, '', '2019-06-03 09:18:01');
INSERT INTO `access_log` VALUES (22840, '64.76.15595246831525549', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:03', 9, 0, '', '2019-06-03 09:18:03');
INSERT INTO `access_log` VALUES (22841, '64.84.15595246831515563', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:03', 12, 0, '', '2019-06-03 09:18:03');
INSERT INTO `access_log` VALUES (22842, '64.82.15595246863165569', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:06', 10, 0, '', '2019-06-03 09:18:06');
INSERT INTO `access_log` VALUES (22843, '64.77.15595246863165565', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:06', 12, 0, '', '2019-06-03 09:18:06');
INSERT INTO `access_log` VALUES (22844, '64.85.15595246889875571', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:09', 10, 0, '', '2019-06-03 09:18:09');
INSERT INTO `access_log` VALUES (22845, '66.50.15595246912384743', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:11', 13, 0, '', '2019-06-03 09:18:11');
INSERT INTO `access_log` VALUES (22846, '59.73.15595246949505999', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:15', 34, 0, '', '2019-06-03 09:18:15');
INSERT INTO `access_log` VALUES (22847, '59.77.15595246984485989', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:18', 20, 2001001000, '服务端发生异常', '2019-06-03 09:18:18');
INSERT INTO `access_log` VALUES (22848, '59.72.15595247005155993', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:21', 12, 0, '', '2019-06-03 09:18:21');
INSERT INTO `access_log` VALUES (22849, '59.79.15595247025535997', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:23', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 09:18:23');
INSERT INTO `access_log` VALUES (22850, '65.53.15595247047155751', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:25', 28, 0, '', '2019-06-03 09:18:25');
INSERT INTO `access_log` VALUES (22851, '65.46.15595247058125779', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:26', 9, 0, '', '2019-06-03 09:18:26');
INSERT INTO `access_log` VALUES (22852, '65.48.15595247069885783', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:27', 399, 0, '', '2019-06-03 09:18:27');
INSERT INTO `access_log` VALUES (22853, '65.45.15595247090095787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.190.251.242', '2019-06-03 09:18:29', 134, 0, '', '2019-06-03 09:18:29');
INSERT INTO `access_log` VALUES (22854, '65.52.15595247233105767', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:18:43', 17, 0, '', '2019-06-03 09:18:43');
INSERT INTO `access_log` VALUES (22855, '66.56.15595247304144737', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.154.194', '2019-06-03 09:18:50', 14, 0, '', '2019-06-03 09:18:50');
INSERT INTO `access_log` VALUES (22856, '65.47.15595248731635781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.246.246.152', '2019-06-03 09:21:13', 82, 0, '', '2019-06-03 09:21:13');
INSERT INTO `access_log` VALUES (22857, '65.54.15595248734495755', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.150.211', '2019-06-03 09:21:13', 10, 0, '', '2019-06-03 09:21:13');
INSERT INTO `access_log` VALUES (22858, '65.49.15595248734535791', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.246.246.152', '2019-06-03 09:21:13', 9, 0, '', '2019-06-03 09:21:13');
INSERT INTO `access_log` VALUES (22859, '65.51.15595248734625773', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.233.185', '2019-06-03 09:21:13', 9, 0, '', '2019-06-03 09:21:13');
INSERT INTO `access_log` VALUES (22860, '64.83.15595248808955557', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.150.211', '2019-06-03 09:21:21', 12, 0, '', '2019-06-03 09:21:21');
INSERT INTO `access_log` VALUES (22861, '64.84.15595248808995567', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.246.246.152', '2019-06-03 09:21:21', 9, 0, '', '2019-06-03 09:21:21');
INSERT INTO `access_log` VALUES (22862, '66.49.15595248833934741', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.150.211', '2019-06-03 09:21:23', 14, 0, '', '2019-06-03 09:21:23');
INSERT INTO `access_log` VALUES (22863, '62.85.15595248877415861', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.150.211', '2019-06-03 09:21:28', 14, 0, '', '2019-06-03 09:21:28');
INSERT INTO `access_log` VALUES (22864, '59.76.15595248908035993', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.150.211', '2019-06-03 09:21:31', 67, 0, '', '2019-06-03 09:21:31');
INSERT INTO `access_log` VALUES (22865, '65.46.15595248933985783', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.246.246.152', '2019-06-03 09:21:33', 20, 0, '', '2019-06-03 09:21:33');
INSERT INTO `access_log` VALUES (22866, '65.48.15595248952385787', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.246.246.152', '2019-06-03 09:21:35', 8, 0, '', '2019-06-03 09:21:35');
INSERT INTO `access_log` VALUES (22867, '65.45.15595248968935791', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.246.246.152', '2019-06-03 09:21:37', 9, 0, '', '2019-06-03 09:21:37');
INSERT INTO `access_log` VALUES (22868, '65.50.15595248978975777', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.150.211', '2019-06-03 09:21:38', 14, 0, '', '2019-06-03 09:21:38');
INSERT INTO `access_log` VALUES (22869, '65.50.15595250281185779', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:23:48', 0, 1002001015, '账号未登陆', '2019-06-03 09:23:48');
INSERT INTO `access_log` VALUES (22870, '65.47.15595250281395785', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:23:48', 0, 1002001015, '账号未登陆', '2019-06-03 09:23:48');
INSERT INTO `access_log` VALUES (22871, '65.52.15595250281395773', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:23:48', 0, 1002001015, '账号未登陆', '2019-06-03 09:23:48');
INSERT INTO `access_log` VALUES (22872, '65.54.15595250376385759', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminF&password=F&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:23:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:23:58');
INSERT INTO `access_log` VALUES (22873, '65.49.15595250404955795', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:24:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:24:01');
INSERT INTO `access_log` VALUES (22874, '65.53.15595250445285759', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:24:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:24:05');
INSERT INTO `access_log` VALUES (22875, '65.52.15595250891255775', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:24:49', 89, 0, '', '2019-06-03 09:24:49');
INSERT INTO `access_log` VALUES (22876, '65.47.15595250894835787', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:24:49', 9, 0, '', '2019-06-03 09:24:49');
INSERT INTO `access_log` VALUES (22877, '65.50.15595250894835781', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:24:49', 11, 0, '', '2019-06-03 09:24:49');
INSERT INTO `access_log` VALUES (22878, '65.51.15595250894865779', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:24:49', 9, 0, '', '2019-06-03 09:24:49');
INSERT INTO `access_log` VALUES (22879, '62.83.15595251006905861', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:25:01', 94, 0, '', '2019-06-03 09:25:01');
INSERT INTO `access_log` VALUES (22880, '59.74.15595251013625999', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.159.10.44', '2019-06-03 09:25:01', 13, 2001001000, '服务端发生异常', '2019-06-03 09:25:01');
INSERT INTO `access_log` VALUES (22881, '59.72.15595251013725999', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.159.10.44', '2019-06-03 09:25:01', 203, 0, '', '2019-06-03 09:25:02');
INSERT INTO `access_log` VALUES (22882, '62.81.15595251109255845', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:25:11', 15, 0, '', '2019-06-03 09:25:11');
INSERT INTO `access_log` VALUES (22883, '64.81.15595251170115561', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:25:17', 13, 0, '', '2019-06-03 09:25:17');
INSERT INTO `access_log` VALUES (22884, '64.79.15595251170165559', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:25:17', 9, 0, '', '2019-06-03 09:25:17');
INSERT INTO `access_log` VALUES (22885, '64.83.15595251210845561', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:25:21', 8, 0, '', '2019-06-03 09:25:21');
INSERT INTO `access_log` VALUES (22886, '64.84.15595251210835571', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:25:21', 11, 0, '', '2019-06-03 09:25:21');
INSERT INTO `access_log` VALUES (22887, '64.76.15595251289535557', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:25:29', 10, 0, '', '2019-06-03 09:25:29');
INSERT INTO `access_log` VALUES (22888, '66.56.15595251453254743', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:25:45', 14, 0, '', '2019-06-03 09:25:45');
INSERT INTO `access_log` VALUES (22889, '59.76.15595251483495997', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:25:48', 11, 0, '', '2019-06-03 09:25:48');
INSERT INTO `access_log` VALUES (22890, '65.48.15595251534565793', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:25:53', 19, 0, '', '2019-06-03 09:25:53');
INSERT INTO `access_log` VALUES (22891, '65.52.15595251555155777', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:25:56', 10, 0, '', '2019-06-03 09:25:56');
INSERT INTO `access_log` VALUES (22892, '65.50.15595251585265783', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '125.86.186.188', '2019-06-03 09:25:59', 9, 0, '', '2019-06-03 09:25:59');
INSERT INTO `access_log` VALUES (22893, '65.50.15595252072465785', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:26:47', 0, 1002001015, '账号未登陆', '2019-06-03 09:26:47');
INSERT INTO `access_log` VALUES (22894, '65.52.15595252073215779', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:26:47', 0, 1002001015, '账号未登陆', '2019-06-03 09:26:47');
INSERT INTO `access_log` VALUES (22895, '65.47.15595252073315791', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:26:47', 1, 1002001015, '账号未登陆', '2019-06-03 09:26:47');
INSERT INTO `access_log` VALUES (22896, '65.54.15595252167005763', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:26:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:26:57');
INSERT INTO `access_log` VALUES (22897, '65.46.15595252237355791', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:27:04', 78, 0, '', '2019-06-03 09:27:04');
INSERT INTO `access_log` VALUES (22898, '65.53.15595252241705765', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:27:04', 9, 0, '', '2019-06-03 09:27:04');
INSERT INTO `access_log` VALUES (22899, '65.49.15595252241725801', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:27:04', 8, 0, '', '2019-06-03 09:27:04');
INSERT INTO `access_log` VALUES (22900, '65.45.15595252241875801', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:27:04', 8, 0, '', '2019-06-03 09:27:04');
INSERT INTO `access_log` VALUES (22901, '62.84.15595252382695851', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:27:18', 10, 0, '', '2019-06-03 09:27:18');
INSERT INTO `access_log` VALUES (22902, '62.89.15595252420195865', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:27:22', 15, 0, '', '2019-06-03 09:27:22');
INSERT INTO `access_log` VALUES (22903, '64.84.15595252520715573', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:27:32', 18, 0, '', '2019-06-03 09:27:32');
INSERT INTO `access_log` VALUES (22904, '64.76.15595252520815559', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:27:32', 8, 0, '', '2019-06-03 09:27:32');
INSERT INTO `access_log` VALUES (22905, '65.51.15595252740205785', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:27:54', 1, 1002001015, '账号未登陆', '2019-06-03 09:27:54');
INSERT INTO `access_log` VALUES (22906, '65.54.15595252740205765', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:27:54', 0, 1002001015, '账号未登陆', '2019-06-03 09:27:54');
INSERT INTO `access_log` VALUES (22907, '65.46.15595252740255793', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:27:54', 1, 1002001015, '账号未登陆', '2019-06-03 09:27:54');
INSERT INTO `access_log` VALUES (22908, '65.49.15595252764605803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:27:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:27:56');
INSERT INTO `access_log` VALUES (22909, '65.45.15595252847865803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:28:05', 134, 0, '', '2019-06-03 09:28:05');
INSERT INTO `access_log` VALUES (22910, '65.53.15595252851705767', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:28:05', 10, 0, '', '2019-06-03 09:28:05');
INSERT INTO `access_log` VALUES (22911, '65.48.15595252851705799', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:28:05', 9, 0, '', '2019-06-03 09:28:05');
INSERT INTO `access_log` VALUES (22912, '65.50.15595252851755789', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:28:05', 9, 0, '', '2019-06-03 09:28:05');
INSERT INTO `access_log` VALUES (22913, '62.86.15595252968635855', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:28:17', 14, 0, '', '2019-06-03 09:28:17');
INSERT INTO `access_log` VALUES (22914, '62.84.15595253435905853', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:29:04', 13, 0, '', '2019-06-03 09:29:04');
INSERT INTO `access_log` VALUES (22915, '64.83.15595253587455565', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:29:19', 45, 0, '', '2019-06-03 09:29:19');
INSERT INTO `access_log` VALUES (22916, '64.84.15595253587455575', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:29:19', 49, 0, '', '2019-06-03 09:29:19');
INSERT INTO `access_log` VALUES (22917, '65.45.15595253691285805', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:29:29', 19, 0, '', '2019-06-03 09:29:29');
INSERT INTO `access_log` VALUES (22918, '65.48.15595253769835801', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=8', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:29:37', 9, 0, '', '2019-06-03 09:29:37');
INSERT INTO `access_log` VALUES (22919, '65.53.15595253813045769', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:29:41', 4, 0, '', '2019-06-03 09:29:41');
INSERT INTO `access_log` VALUES (22920, '65.52.15595253818225785', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:29:42', 9, 0, '', '2019-06-03 09:29:42');
INSERT INTO `access_log` VALUES (22921, '65.47.15595253882185797', 27, 2, 'admin-application', '/admin-api/admins/role/update', 'id=2&name=测试角色&createTime=2019-02-28T11:45:17.000+0000', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:29:48', 153, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-03 09:29:48');
INSERT INTO `access_log` VALUES (22922, '65.46.15595253885635797', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:29:49', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-06-03 09:29:49');
INSERT INTO `access_log` VALUES (22923, '65.51.15595253910385789', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:29:51', 316, 0, '', '2019-06-03 09:29:51');
INSERT INTO `access_log` VALUES (22924, '64.79.15595254161785565', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:30:16', 10, 0, '', '2019-06-03 09:30:16');
INSERT INTO `access_log` VALUES (22925, '64.85.15595254161785583', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:30:16', 12, 0, '', '2019-06-03 09:30:16');
INSERT INTO `access_log` VALUES (22926, '65.45.15595254171805807', 27, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=2&resourceIds=13,14,15,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,41,42,43,44,45,46,47,48,49,50,51,52,53', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:30:17', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-03 09:30:17');
INSERT INTO `access_log` VALUES (22927, '65.48.15595254193975803', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:30:19', 9, 0, '', '2019-06-03 09:30:19');
INSERT INTO `access_log` VALUES (22928, '64.83.15595254273035567', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:30:27', 9, 0, '', '2019-06-03 09:30:27');
INSERT INTO `access_log` VALUES (22929, '64.80.15595254273015565', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:30:27', 14, 0, '', '2019-06-03 09:30:27');
INSERT INTO `access_log` VALUES (22930, '64.84.15595254273025577', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:30:27', 10, 0, '', '2019-06-03 09:30:27');
INSERT INTO `access_log` VALUES (22931, '65.52.15595254471505787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:30:47', 281, 0, '', '2019-06-03 09:30:47');
INSERT INTO `access_log` VALUES (22932, '64.78.15595254483825579', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:30:48', 8, 0, '', '2019-06-03 09:30:48');
INSERT INTO `access_log` VALUES (22933, '66.51.15595254753314751', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:31:15', 15, 0, '', '2019-06-03 09:31:15');
INSERT INTO `access_log` VALUES (22934, '59.77.15595254832576001', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:31:23', 10, 0, '', '2019-06-03 09:31:23');
INSERT INTO `access_log` VALUES (22935, '59.74.15595254835526005', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:31:24', 15, 0, '', '2019-06-03 09:31:24');
INSERT INTO `access_log` VALUES (22936, '59.79.15595254977546009', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:31:38', 17, 2001001000, '服务端发生异常', '2019-06-03 09:31:38');
INSERT INTO `access_log` VALUES (22937, '59.75.15595255048426009', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:31:45', 28, 0, '', '2019-06-03 09:31:45');
INSERT INTO `access_log` VALUES (22938, '64.83.15595255126165569', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:31:53', 11, 0, '', '2019-06-03 09:31:53');
INSERT INTO `access_log` VALUES (22939, '64.84.15595255193295579', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:31:59', 21, 0, '', '2019-06-03 09:31:59');
INSERT INTO `access_log` VALUES (22940, '64.80.15595255226725567', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:32:03', 12, 0, '', '2019-06-03 09:32:03');
INSERT INTO `access_log` VALUES (22941, '64.78.15595255294155581', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:32:09', 19, 0, '', '2019-06-03 09:32:09');
INSERT INTO `access_log` VALUES (22942, '59.78.15595255334606013', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:32:13', 12, 0, '', '2019-06-03 09:32:13');
INSERT INTO `access_log` VALUES (22943, '59.73.15595255505036013', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:32:31', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 09:32:31');
INSERT INTO `access_log` VALUES (22944, '65.50.15595255565665795', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:32:37', 20, 0, '', '2019-06-03 09:32:37');
INSERT INTO `access_log` VALUES (22945, '65.52.15595255654635789', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:32:45', 12, 0, '', '2019-06-03 09:32:45');
INSERT INTO `access_log` VALUES (22946, '65.50.15595255694665797', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:32:49', 10, 0, '', '2019-06-03 09:32:49');
INSERT INTO `access_log` VALUES (22947, '65.50.15595255782895799', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:32:58', 10, 0, '', '2019-06-03 09:32:58');
INSERT INTO `access_log` VALUES (22948, '65.45.15595255858045811', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:33:06', 13, 0, '', '2019-06-03 09:33:06');
INSERT INTO `access_log` VALUES (22949, '59.73.15595256802716015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.59.205', '2019-06-03 09:34:40', 5, 0, '', '2019-06-03 09:34:40');
INSERT INTO `access_log` VALUES (22950, '59.77.15595256802716005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.59.205', '2019-06-03 09:34:40', 13, 2001001000, '服务端发生异常', '2019-06-03 09:34:40');
INSERT INTO `access_log` VALUES (22951, '65.47.15595256815215803', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:34:42', 0, 1002001015, '账号未登陆', '2019-06-03 09:34:42');
INSERT INTO `access_log` VALUES (22952, '65.45.15595256815225815', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:34:42', 1, 1002001015, '账号未登陆', '2019-06-03 09:34:42');
INSERT INTO `access_log` VALUES (22953, '65.54.15595256815305775', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:34:42', 0, 1002001015, '账号未登陆', '2019-06-03 09:34:42');
INSERT INTO `access_log` VALUES (22954, '59.72.15595256895166009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:34:50', 3, 0, '', '2019-06-03 09:34:50');
INSERT INTO `access_log` VALUES (22955, '59.79.15595256895166013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:34:50', 16, 2001001000, '服务端发生异常', '2019-06-03 09:34:50');
INSERT INTO `access_log` VALUES (22956, '65.53.15595256960135777', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:34:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:34:56');
INSERT INTO `access_log` VALUES (22957, '64.77.15595256962085583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:34:56', 3, 0, '', '2019-06-03 09:34:56');
INSERT INTO `access_log` VALUES (22958, '64.79.15595256963565571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:34:56', 2, 0, '', '2019-06-03 09:34:56');
INSERT INTO `access_log` VALUES (22959, '64.85.15595256976695589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:34:58', 2, 0, '', '2019-06-03 09:34:58');
INSERT INTO `access_log` VALUES (22960, '64.81.15595256985345573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:34:59', 2, 0, '', '2019-06-03 09:34:59');
INSERT INTO `access_log` VALUES (22961, '64.83.15595256989745573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '116.247.112.179', '2019-06-03 09:34:59', 69, 0, '', '2019-06-03 09:34:59');
INSERT INTO `access_log` VALUES (22962, '65.45.15595257141595817', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:35:14', 113, 0, '', '2019-06-03 09:35:14');
INSERT INTO `access_log` VALUES (22963, '65.51.15595257145385795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:35:15', 7, 0, '', '2019-06-03 09:35:15');
INSERT INTO `access_log` VALUES (22964, '65.53.15595257145395779', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:35:15', 8, 0, '', '2019-06-03 09:35:15');
INSERT INTO `access_log` VALUES (22965, '65.46.15595257145425805', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:35:15', 7, 0, '', '2019-06-03 09:35:15');
INSERT INTO `access_log` VALUES (22966, '65.52.15595257161365797', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.59.205', '2019-06-03 09:35:16', 0, 1002001015, '账号未登陆', '2019-06-03 09:35:16');
INSERT INTO `access_log` VALUES (22967, '65.48.15595257161375811', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.59.205', '2019-06-03 09:35:16', 0, 1002001015, '账号未登陆', '2019-06-03 09:35:16');
INSERT INTO `access_log` VALUES (22968, '65.49.15595257161395819', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.59.205', '2019-06-03 09:35:16', 0, 1002001015, '账号未登陆', '2019-06-03 09:35:16');
INSERT INTO `access_log` VALUES (22969, '62.88.15595257183175879', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:35:18', 13, 0, '', '2019-06-03 09:35:18');
INSERT INTO `access_log` VALUES (22970, '65.50.15595257193195805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.59.205', '2019-06-03 09:35:19', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:35:19');
INSERT INTO `access_log` VALUES (22971, '65.54.15595257216665777', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.59.205', '2019-06-03 09:35:22', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:35:22');
INSERT INTO `access_log` VALUES (22972, '64.76.15595257216925569', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:35:22', 11, 0, '', '2019-06-03 09:35:22');
INSERT INTO `access_log` VALUES (22973, '64.78.15595257216975585', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:35:22', 7, 0, '', '2019-06-03 09:35:22');
INSERT INTO `access_log` VALUES (22974, '64.82.15595257350895589', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:35:35', 11, 0, '', '2019-06-03 09:35:35');
INSERT INTO `access_log` VALUES (22975, '64.77.15595257350925585', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:35:35', 13, 0, '', '2019-06-03 09:35:35');
INSERT INTO `access_log` VALUES (22976, '64.81.15595257371825575', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:35:37', 9, 0, '', '2019-06-03 09:35:37');
INSERT INTO `access_log` VALUES (22977, '64.85.15595257371815591', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:35:37', 12, 0, '', '2019-06-03 09:35:37');
INSERT INTO `access_log` VALUES (22978, '64.83.15595257371825575', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:35:37', 336, 0, '', '2019-06-03 09:35:38');
INSERT INTO `access_log` VALUES (22979, '65.51.15595257386745797', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.59.205', '2019-06-03 09:35:39', 87, 0, '', '2019-06-03 09:35:39');
INSERT INTO `access_log` VALUES (22980, '65.46.15595257390235807', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.59.205', '2019-06-03 09:35:39', 9, 0, '', '2019-06-03 09:35:39');
INSERT INTO `access_log` VALUES (22981, '65.49.15595257390285821', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.59.205', '2019-06-03 09:35:39', 10, 0, '', '2019-06-03 09:35:39');
INSERT INTO `access_log` VALUES (22982, '65.52.15595257390285799', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.59.205', '2019-06-03 09:35:39', 9, 0, '', '2019-06-03 09:35:39');
INSERT INTO `access_log` VALUES (22983, '62.89.15595257438525873', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.59.205', '2019-06-03 09:35:44', 12, 0, '', '2019-06-03 09:35:44');
INSERT INTO `access_log` VALUES (22984, '62.82.15595257469765883', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.59.205', '2019-06-03 09:35:47', 12, 0, '', '2019-06-03 09:35:47');
INSERT INTO `access_log` VALUES (22985, '66.51.15595257527674755', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.59.205', '2019-06-03 09:35:53', 14, 0, '', '2019-06-03 09:35:53');
INSERT INTO `access_log` VALUES (22986, '65.53.15595257805555783', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:36:21', 9, 0, '', '2019-06-03 09:36:21');
INSERT INTO `access_log` VALUES (22987, '65.49.15595257816265823', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:36:22', 11, 0, '', '2019-06-03 09:36:22');
INSERT INTO `access_log` VALUES (22988, '65.52.15595257818315801', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:36:22', 18, 0, '', '2019-06-03 09:36:22');
INSERT INTO `access_log` VALUES (22989, '59.77.15595257825826007', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:36:23', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 09:36:23');
INSERT INTO `access_log` VALUES (22990, '59.74.15595257828006011', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:36:23', 12, 0, '', '2019-06-03 09:36:23');
INSERT INTO `access_log` VALUES (22991, '59.72.15595257838056011', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:36:24', 13, 0, '', '2019-06-03 09:36:24');
INSERT INTO `access_log` VALUES (22992, '59.79.15595257839976015', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:36:24', 32, 2001001000, '服务端发生异常', '2019-06-03 09:36:24');
INSERT INTO `access_log` VALUES (22993, '59.75.15595257859856015', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:36:26', 11, 0, '', '2019-06-03 09:36:26');
INSERT INTO `access_log` VALUES (22994, '66.54.15595257862454759', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '182.245.207.133', '2019-06-03 09:36:26', 14, 0, '', '2019-06-03 09:36:26');
INSERT INTO `access_log` VALUES (22995, '59.78.15595258200046019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.172.53.135', '2019-06-03 09:37:00', 3, 0, '', '2019-06-03 09:37:00');
INSERT INTO `access_log` VALUES (22996, '59.80.15595258200116011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.172.53.135', '2019-06-03 09:37:00', 12, 2001001000, '服务端发生异常', '2019-06-03 09:37:00');
INSERT INTO `access_log` VALUES (22997, '65.54.15595258291265779', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.172.53.135', '2019-06-03 09:37:09', 0, 1002001015, '账号未登陆', '2019-06-03 09:37:09');
INSERT INTO `access_log` VALUES (22998, '65.45.15595258291475823', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.172.53.135', '2019-06-03 09:37:09', 0, 1002001015, '账号未登陆', '2019-06-03 09:37:09');
INSERT INTO `access_log` VALUES (22999, '65.51.15595258291495801', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.172.53.135', '2019-06-03 09:37:09', 0, 1002001015, '账号未登陆', '2019-06-03 09:37:09');
INSERT INTO `access_log` VALUES (23000, '65.53.15595258313395785', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.172.53.135', '2019-06-03 09:37:11', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:37:11');
INSERT INTO `access_log` VALUES (23001, '65.52.15595258531835803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.172.53.135', '2019-06-03 09:37:33', 60, 0, '', '2019-06-03 09:37:33');
INSERT INTO `access_log` VALUES (23002, '65.48.15595258535515815', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.172.53.135', '2019-06-03 09:37:34', 281, 0, '', '2019-06-03 09:37:34');
INSERT INTO `access_log` VALUES (23003, '65.50.15595258535545809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.172.53.135', '2019-06-03 09:37:34', 279, 0, '', '2019-06-03 09:37:34');
INSERT INTO `access_log` VALUES (23004, '65.46.15595258535475811', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.172.53.135', '2019-06-03 09:37:34', 286, 0, '', '2019-06-03 09:37:34');
INSERT INTO `access_log` VALUES (23005, '62.85.15595258584565885', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.172.53.135', '2019-06-03 09:37:38', 228, 0, '', '2019-06-03 09:37:39');
INSERT INTO `access_log` VALUES (23006, '65.46.15595259864655813', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:39:46', 0, 1002001015, '账号未登陆', '2019-06-03 09:39:46');
INSERT INTO `access_log` VALUES (23007, '65.47.15595259864665811', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:39:46', 1, 1002001015, '账号未登陆', '2019-06-03 09:39:46');
INSERT INTO `access_log` VALUES (23008, '65.51.15595259864695805', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:39:46', 0, 1002001015, '账号未登陆', '2019-06-03 09:39:46');
INSERT INTO `access_log` VALUES (23009, '65.54.15595259900645783', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:39:50', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:39:50');
INSERT INTO `access_log` VALUES (23010, '65.53.15595259944515789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:39:54', 211, 0, '', '2019-06-03 09:39:55');
INSERT INTO `access_log` VALUES (23011, '65.49.15595259964455829', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:39:56', 689, 0, '', '2019-06-03 09:39:57');
INSERT INTO `access_log` VALUES (23012, '65.48.15595259964525819', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:39:56', 682, 0, '', '2019-06-03 09:39:57');
INSERT INTO `access_log` VALUES (23013, '65.52.15595259964475807', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:39:56', 686, 0, '', '2019-06-03 09:39:57');
INSERT INTO `access_log` VALUES (23014, '62.89.15595260143655885', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:40:14', 14, 0, '', '2019-06-03 09:40:14');
INSERT INTO `access_log` VALUES (23015, '64.84.15595260324455589', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:40:32', 9, 0, '', '2019-06-03 09:40:32');
INSERT INTO `access_log` VALUES (23016, '64.83.15595260324445579', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:40:32', 14, 0, '', '2019-06-03 09:40:32');
INSERT INTO `access_log` VALUES (23017, '62.86.15595260522585875', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:40:52', 12, 0, '', '2019-06-03 09:40:52');
INSERT INTO `access_log` VALUES (23018, '62.83.15595260563965885', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:40:56', 22, 0, '', '2019-06-03 09:40:56');
INSERT INTO `access_log` VALUES (23019, '62.81.15595260775355869', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:41:18', 14, 0, '', '2019-06-03 09:41:18');
INSERT INTO `access_log` VALUES (23020, '62.85.15595260821005889', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:41:22', 13, 0, '', '2019-06-03 09:41:22');
INSERT INTO `access_log` VALUES (23021, '66.57.15595261104984763', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:41:50', 15, 0, '', '2019-06-03 09:41:51');
INSERT INTO `access_log` VALUES (23022, '65.50.15595261529145815', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.41.129.229', '2019-06-03 09:42:33', 0, 1002001015, '账号未登陆', '2019-06-03 09:42:33');
INSERT INTO `access_log` VALUES (23023, '65.46.15595261529145817', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.41.129.229', '2019-06-03 09:42:33', 0, 1002001015, '账号未登陆', '2019-06-03 09:42:33');
INSERT INTO `access_log` VALUES (23024, '65.47.15595261529165815', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.41.129.229', '2019-06-03 09:42:33', 1, 1002001015, '账号未登陆', '2019-06-03 09:42:33');
INSERT INTO `access_log` VALUES (23025, '62.88.15595261529155895', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.41.129.229', '2019-06-03 09:42:33', 1, 1002001015, '账号未登陆', '2019-06-03 09:42:33');
INSERT INTO `access_log` VALUES (23026, '59.71.15595262062286025', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:43:26', 12, 0, '', '2019-06-03 09:43:26');
INSERT INTO `access_log` VALUES (23027, '59.76.15595262094296015', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:43:29', 21, 2001001000, '服务端发生异常', '2019-06-03 09:43:29');
INSERT INTO `access_log` VALUES (23028, '59.80.15595262136026017', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 09:43:34', 11, 0, '', '2019-06-03 09:43:34');
INSERT INTO `access_log` VALUES (23029, '59.74.15595262528086019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '221.220.26.161', '2019-06-03 09:44:13', 3, 0, '', '2019-06-03 09:44:13');
INSERT INTO `access_log` VALUES (23030, '59.72.15595262528136019', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '221.220.26.161', '2019-06-03 09:44:13', 19, 2001001000, '服务端发生异常', '2019-06-03 09:44:13');
INSERT INTO `access_log` VALUES (23031, '59.75.15595262700006023', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '221.220.26.161', '2019-06-03 09:44:30', 3, 0, '', '2019-06-03 09:44:30');
INSERT INTO `access_log` VALUES (23032, '59.71.15595262700026027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '221.220.26.161', '2019-06-03 09:44:30', 18, 2001001000, '服务端发生异常', '2019-06-03 09:44:30');
INSERT INTO `access_log` VALUES (23033, '65.47.15595262722315817', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:44:32', 1, 1002001015, '账号未登陆', '2019-06-03 09:44:32');
INSERT INTO `access_log` VALUES (23034, '65.50.15595262722315817', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:44:32', 1, 1002001015, '账号未登陆', '2019-06-03 09:44:32');
INSERT INTO `access_log` VALUES (23035, '65.51.15595262722315811', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:44:32', 0, 1002001015, '账号未登陆', '2019-06-03 09:44:32');
INSERT INTO `access_log` VALUES (23036, '65.54.15595262775655789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:44:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:44:38');
INSERT INTO `access_log` VALUES (23037, '59.78.15595262805336027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '221.220.26.161', '2019-06-03 09:44:41', 3, 0, '', '2019-06-03 09:44:41');
INSERT INTO `access_log` VALUES (23038, '59.80.15595262805336019', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '221.220.26.161', '2019-06-03 09:44:41', 12, 2001001000, '服务端发生异常', '2019-06-03 09:44:41');
INSERT INTO `access_log` VALUES (23039, '65.53.15595262834085795', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:44:43', 4, 1002002000, '账号不存在', '2019-06-03 09:44:43');
INSERT INTO `access_log` VALUES (23040, '64.81.15595262841675583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '221.220.26.161', '2019-06-03 09:44:44', 204, 0, '', '2019-06-03 09:44:44');
INSERT INTO `access_log` VALUES (23041, '64.84.15595262845065593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '221.220.26.161', '2019-06-03 09:44:45', 2, 0, '', '2019-06-03 09:44:45');
INSERT INTO `access_log` VALUES (23042, '65.48.15595262893095825', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:44:49', 112, 0, '', '2019-06-03 09:44:49');
INSERT INTO `access_log` VALUES (23043, '65.49.15595262896745835', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:44:50', 263, 0, '', '2019-06-03 09:44:50');
INSERT INTO `access_log` VALUES (23044, '65.52.15595262896745813', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:44:50', 264, 0, '', '2019-06-03 09:44:50');
INSERT INTO `access_log` VALUES (23045, '65.46.15595262896755821', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:44:50', 264, 0, '', '2019-06-03 09:44:50');
INSERT INTO `access_log` VALUES (23046, '65.47.15595262917375819', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '221.220.26.161', '2019-06-03 09:44:52', 1, 1002001015, '账号未登陆', '2019-06-03 09:44:52');
INSERT INTO `access_log` VALUES (23047, '65.50.15595262917405819', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '221.220.26.161', '2019-06-03 09:44:52', 0, 1002001015, '账号未登陆', '2019-06-03 09:44:52');
INSERT INTO `access_log` VALUES (23048, '65.51.15595262917435813', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '221.220.26.161', '2019-06-03 09:44:52', 0, 1002001015, '账号未登陆', '2019-06-03 09:44:52');
INSERT INTO `access_log` VALUES (23049, '62.81.15595262984815873', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:44:58', 13, 0, '', '2019-06-03 09:44:58');
INSERT INTO `access_log` VALUES (23050, '65.45.15595262987965835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '221.220.26.161', '2019-06-03 09:44:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:44:59');
INSERT INTO `access_log` VALUES (23051, '65.53.15595263039705797', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '221.220.26.161', '2019-06-03 09:45:04', 232, 0, '', '2019-06-03 09:45:04');
INSERT INTO `access_log` VALUES (23052, '62.84.15595263044445877', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:45:04', 15, 0, '', '2019-06-03 09:45:04');
INSERT INTO `access_log` VALUES (23053, '64.76.15595263065525579', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:45:07', 9, 0, '', '2019-06-03 09:45:07');
INSERT INTO `access_log` VALUES (23054, '64.78.15595263065505595', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:45:07', 11, 0, '', '2019-06-03 09:45:07');
INSERT INTO `access_log` VALUES (23055, '66.50.15595263216954767', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:45:22', 14, 0, '', '2019-06-03 09:45:22');
INSERT INTO `access_log` VALUES (23056, '59.74.15595263250006021', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:45:25', 13, 0, '', '2019-06-03 09:45:25');
INSERT INTO `access_log` VALUES (23057, '65.49.15595263296905837', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:45:30', 43, 0, '', '2019-06-03 09:45:30');
INSERT INTO `access_log` VALUES (23058, '65.52.15595263308425815', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:45:31', 11, 0, '', '2019-06-03 09:45:31');
INSERT INTO `access_log` VALUES (23059, '65.47.15595263326055821', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:45:33', 10, 0, '', '2019-06-03 09:45:33');
INSERT INTO `access_log` VALUES (23060, '65.51.15595263336475815', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3698.400 QQBrowser/10.4.3569.400', '182.50.124.211', '2019-06-03 09:45:34', 14, 0, '', '2019-06-03 09:45:34');
INSERT INTO `access_log` VALUES (23061, '59.71.15595264932896031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '222.82.222.83', '2019-06-03 09:48:13', 3, 0, '', '2019-06-03 09:48:13');
INSERT INTO `access_log` VALUES (23062, '59.75.15595264932896027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '222.82.222.83', '2019-06-03 09:48:13', 13, 2001001000, '服务端发生异常', '2019-06-03 09:48:13');
INSERT INTO `access_log` VALUES (23063, '64.85.15595265056045603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '222.82.222.83', '2019-06-03 09:48:26', 4, 0, '', '2019-06-03 09:48:26');
INSERT INTO `access_log` VALUES (23064, '64.81.15595265057965587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '222.82.222.83', '2019-06-03 09:48:26', 2, 0, '', '2019-06-03 09:48:26');
INSERT INTO `access_log` VALUES (23065, '64.84.15595265073635597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '222.82.222.83', '2019-06-03 09:48:27', 2, 0, '', '2019-06-03 09:48:27');
INSERT INTO `access_log` VALUES (23066, '64.83.15595265078515587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '222.82.222.83', '2019-06-03 09:48:28', 2, 0, '', '2019-06-03 09:48:28');
INSERT INTO `access_log` VALUES (23067, '65.49.15595265783905841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 09:49:38', 78, 0, '', '2019-06-03 09:49:38');
INSERT INTO `access_log` VALUES (23068, '65.52.15595265787425819', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 09:49:39', 9, 0, '', '2019-06-03 09:49:39');
INSERT INTO `access_log` VALUES (23069, '65.47.15595265787455825', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 09:49:39', 11, 0, '', '2019-06-03 09:49:39');
INSERT INTO `access_log` VALUES (23070, '65.51.15595265787485819', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 09:49:39', 9, 0, '', '2019-06-03 09:49:39');
INSERT INTO `access_log` VALUES (23071, '62.89.15595265871145895', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 09:49:47', 170, 0, '', '2019-06-03 09:49:47');
INSERT INTO `access_log` VALUES (23072, '64.81.15595265933365589', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 09:49:53', 27, 0, '', '2019-06-03 09:49:53');
INSERT INTO `access_log` VALUES (23073, '64.85.15595265933315605', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 09:49:53', 32, 0, '', '2019-06-03 09:49:53');
INSERT INTO `access_log` VALUES (23074, '59.75.15595266151066029', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.215.73.102', '2019-06-03 09:50:15', 11, 0, '', '2019-06-03 09:50:15');
INSERT INTO `access_log` VALUES (23075, '64.77.15595266727045601', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 09:51:13', 11, 0, '', '2019-06-03 09:51:13');
INSERT INTO `access_log` VALUES (23076, '65.50.15595268738965829', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:54:34', 0, 1002001015, '账号未登陆', '2019-06-03 09:54:34');
INSERT INTO `access_log` VALUES (23077, '65.54.15595268739045801', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:54:34', 0, 1002001015, '账号未登陆', '2019-06-03 09:54:34');
INSERT INTO `access_log` VALUES (23078, '65.45.15595268739455845', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:54:34', 1, 1002001015, '账号未登陆', '2019-06-03 09:54:34');
INSERT INTO `access_log` VALUES (23079, '65.48.15595268792005837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:54:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:54:39');
INSERT INTO `access_log` VALUES (23080, '65.46.15595268864005833', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:54:46', 105, 0, '', '2019-06-03 09:54:47');
INSERT INTO `access_log` VALUES (23081, '65.49.15595268869035847', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:54:47', 9, 0, '', '2019-06-03 09:54:47');
INSERT INTO `access_log` VALUES (23082, '65.51.15595268869185825', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:54:47', 9, 0, '', '2019-06-03 09:54:47');
INSERT INTO `access_log` VALUES (23083, '65.52.15595268869195825', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:54:47', 9, 0, '', '2019-06-03 09:54:47');
INSERT INTO `access_log` VALUES (23084, '62.82.15595269026645909', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:55:03', 14, 0, '', '2019-06-03 09:55:03');
INSERT INTO `access_log` VALUES (23085, '62.88.15595269111825907', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:55:11', 13, 0, '', '2019-06-03 09:55:11');
INSERT INTO `access_log` VALUES (23086, '64.80.15595269143345591', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:55:14', 12, 0, '', '2019-06-03 09:55:14');
INSERT INTO `access_log` VALUES (23087, '64.76.15595269143545589', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:55:14', 9, 0, '', '2019-06-03 09:55:14');
INSERT INTO `access_log` VALUES (23088, '64.78.15595269179285605', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:55:18', 9, 0, '', '2019-06-03 09:55:18');
INSERT INTO `access_log` VALUES (23089, '64.77.15595269179285605', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:55:18', 12, 0, '', '2019-06-03 09:55:18');
INSERT INTO `access_log` VALUES (23090, '59.80.15595271119446031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 09:58:32', 3, 0, '', '2019-06-03 09:58:32');
INSERT INTO `access_log` VALUES (23091, '59.73.15595271119446039', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 09:58:32', 13, 2001001000, '服务端发生异常', '2019-06-03 09:58:32');
INSERT INTO `access_log` VALUES (23092, '64.84.15595271158695607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 09:58:36', 3, 0, '', '2019-06-03 09:58:36');
INSERT INTO `access_log` VALUES (23093, '64.83.15595271160365597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 09:58:36', 2, 0, '', '2019-06-03 09:58:36');
INSERT INTO `access_log` VALUES (23094, '65.52.15595271372305829', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 09:58:57', 1, 1002001015, '账号未登陆', '2019-06-03 09:58:57');
INSERT INTO `access_log` VALUES (23095, '65.49.15595271372435851', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 09:58:57', 0, 1002001015, '账号未登陆', '2019-06-03 09:58:57');
INSERT INTO `access_log` VALUES (23096, '65.51.15595271372435829', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 09:58:57', 0, 1002001015, '账号未登陆', '2019-06-03 09:58:57');
INSERT INTO `access_log` VALUES (23097, '65.47.15595271393605835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 09:58:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:58:59');
INSERT INTO `access_log` VALUES (23098, '66.48.15595271395354779', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:59:00', 59, 0, '', '2019-06-03 09:59:00');
INSERT INTO `access_log` VALUES (23099, '59.79.15595271587496037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '124.133.239.116', '2019-06-03 09:59:19', 3, 0, '', '2019-06-03 09:59:19');
INSERT INTO `access_log` VALUES (23100, '59.75.15595271587506037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '124.133.239.116', '2019-06-03 09:59:19', 13, 2001001000, '服务端发生异常', '2019-06-03 09:59:19');
INSERT INTO `access_log` VALUES (23101, '62.88.15595271682575911', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:59:28', 16, 0, '', '2019-06-03 09:59:28');
INSERT INTO `access_log` VALUES (23102, '62.87.15595271712015911', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:59:31', 12, 0, '', '2019-06-03 09:59:31');
INSERT INTO `access_log` VALUES (23103, '65.53.15595271864355813', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 09:59:46', 0, 1002001015, '账号未登陆', '2019-06-03 09:59:46');
INSERT INTO `access_log` VALUES (23104, '65.48.15595271864395843', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 09:59:46', 0, 1002001015, '账号未登陆', '2019-06-03 09:59:46');
INSERT INTO `access_log` VALUES (23105, '65.46.15595271864495839', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 09:59:46', 1, 1002001015, '账号未登陆', '2019-06-03 09:59:46');
INSERT INTO `access_log` VALUES (23106, '59.78.15595271867346041', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:59:47', 11, 0, '', '2019-06-03 09:59:47');
INSERT INTO `access_log` VALUES (23107, '65.52.15595271895225831', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 09:59:50', 82, 0, '', '2019-06-03 09:59:50');
INSERT INTO `access_log` VALUES (23108, '65.49.15595271899785853', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 09:59:50', 10, 0, '', '2019-06-03 09:59:50');
INSERT INTO `access_log` VALUES (23109, '65.51.15595271899875831', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 09:59:50', 9, 0, '', '2019-06-03 09:59:50');
INSERT INTO `access_log` VALUES (23110, '65.47.15595271899925837', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 09:59:50', 8, 0, '', '2019-06-03 09:59:50');
INSERT INTO `access_log` VALUES (23111, '62.85.15595271938765907', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 09:59:54', 12, 0, '', '2019-06-03 09:59:54');
INSERT INTO `access_log` VALUES (23112, '65.54.15595271952645809', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 09:59:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 09:59:55');
INSERT INTO `access_log` VALUES (23113, '59.80.15595271986326033', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 09:59:59', 42, 2001001000, '服务端发生异常', '2019-06-03 09:59:59');
INSERT INTO `access_log` VALUES (23114, '65.50.15595272004435837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:00', 103, 0, '', '2019-06-03 10:00:01');
INSERT INTO `access_log` VALUES (23115, '65.53.15595272008215815', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:01', 8, 0, '', '2019-06-03 10:00:01');
INSERT INTO `access_log` VALUES (23116, '65.48.15595272008255845', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:01', 8, 0, '', '2019-06-03 10:00:01');
INSERT INTO `access_log` VALUES (23117, '65.46.15595272008325841', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:01', 8, 0, '', '2019-06-03 10:00:01');
INSERT INTO `access_log` VALUES (23118, '62.89.15595272077905905', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:08', 14, 0, '', '2019-06-03 10:00:08');
INSERT INTO `access_log` VALUES (23119, '59.72.15595272090836035', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:00:09', 19, 0, '', '2019-06-03 10:00:09');
INSERT INTO `access_log` VALUES (23120, '62.80.15595272141865909', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:14', 14, 0, '', '2019-06-03 10:00:14');
INSERT INTO `access_log` VALUES (23121, '59.74.15595272153246035', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:00:15', 229, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 10:00:16');
INSERT INTO `access_log` VALUES (23122, '64.85.15595272168955615', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:17', 35, 0, '', '2019-06-03 10:00:17');
INSERT INTO `access_log` VALUES (23123, '64.81.15595272168935599', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:17', 39, 0, '', '2019-06-03 10:00:17');
INSERT INTO `access_log` VALUES (23124, '64.83.15595272174505599', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 10:00:17', 8, 0, '', '2019-06-03 10:00:17');
INSERT INTO `access_log` VALUES (23125, '64.84.15595272174475609', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.20.27.214', '2019-06-03 10:00:17', 10, 0, '', '2019-06-03 10:00:17');
INSERT INTO `access_log` VALUES (23126, '65.51.15595272199365833', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:00:20', 706, 0, '', '2019-06-03 10:00:21');
INSERT INTO `access_log` VALUES (23127, '64.78.15595272241285611', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:24', 9, 0, '', '2019-06-03 10:00:24');
INSERT INTO `access_log` VALUES (23128, '64.76.15595272241265595', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:24', 12, 0, '', '2019-06-03 10:00:24');
INSERT INTO `access_log` VALUES (23129, '65.49.15595272268285855', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:00:27', 10, 0, '', '2019-06-03 10:00:27');
INSERT INTO `access_log` VALUES (23130, '64.77.15595272277885611', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:28', 10, 0, '', '2019-06-03 10:00:28');
INSERT INTO `access_log` VALUES (23131, '59.71.15595272348026043', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:35', 11, 0, '', '2019-06-03 10:00:35');
INSERT INTO `access_log` VALUES (23132, '65.45.15595272368795855', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:37', 17, 0, '', '2019-06-03 10:00:37');
INSERT INTO `access_log` VALUES (23133, '65.54.15595272385475811', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:39', 10, 0, '', '2019-06-03 10:00:39');
INSERT INTO `access_log` VALUES (23134, '65.46.15595272433375843', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:43', 9, 0, '', '2019-06-03 10:00:43');
INSERT INTO `access_log` VALUES (23135, '65.53.15595272443925817', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.3.135.171', '2019-06-03 10:00:44', 14, 0, '', '2019-06-03 10:00:44');
INSERT INTO `access_log` VALUES (23136, '65.48.15595272539275847', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:00:54', 133, 0, '', '2019-06-03 10:00:54');
INSERT INTO `access_log` VALUES (23137, '65.45.15595272841285857', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:01:24', 4, 1002001012, '访问令牌已过期', '2019-06-03 10:01:24');
INSERT INTO `access_log` VALUES (23138, '65.49.15595272841285857', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:01:24', 4, 1002001012, '访问令牌已过期', '2019-06-03 10:01:24');
INSERT INTO `access_log` VALUES (23139, '65.54.15595272841415813', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:01:24', 3, 1002001012, '访问令牌已过期', '2019-06-03 10:01:24');
INSERT INTO `access_log` VALUES (23140, '65.50.15595272873235841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:01:27', 99, 0, '', '2019-06-03 10:01:27');
INSERT INTO `access_log` VALUES (23141, '65.46.15595272877445845', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:01:28', 8, 0, '', '2019-06-03 10:01:28');
INSERT INTO `access_log` VALUES (23142, '65.52.15595272877535837', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:01:28', 9, 0, '', '2019-06-03 10:01:28');
INSERT INTO `access_log` VALUES (23143, '65.53.15595272877515819', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:01:28', 123, 0, '', '2019-06-03 10:01:28');
INSERT INTO `access_log` VALUES (23144, '65.47.15595273282175843', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:02:08', 20, 0, '', '2019-06-03 10:02:08');
INSERT INTO `access_log` VALUES (23145, '65.49.15595273290675859', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:02:09', 15, 0, '', '2019-06-03 10:02:09');
INSERT INTO `access_log` VALUES (23146, '59.76.15595275265686037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:27', 13, 2001001000, '服务端发生异常', '2019-06-03 10:05:27');
INSERT INTO `access_log` VALUES (23147, '59.71.15595275265676047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:27', 174, 0, '', '2019-06-03 10:05:27');
INSERT INTO `access_log` VALUES (23148, '64.82.15595275298195619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:30', 3, 0, '', '2019-06-03 10:05:30');
INSERT INTO `access_log` VALUES (23149, '64.79.15595275299305603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:30', 2, 0, '', '2019-06-03 10:05:30');
INSERT INTO `access_log` VALUES (23150, '64.85.15595275313755621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:31', 2, 0, '', '2019-06-03 10:05:31');
INSERT INTO `access_log` VALUES (23151, '64.81.15595275323095605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:32', 2, 0, '', '2019-06-03 10:05:32');
INSERT INTO `access_log` VALUES (23152, '59.73.15595275341896047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:34', 11, 0, '', '2019-06-03 10:05:34');
INSERT INTO `access_log` VALUES (23153, '59.80.15595275341896039', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:34', 16, 2001001000, '服务端发生异常', '2019-06-03 10:05:34');
INSERT INTO `access_log` VALUES (23154, '59.77.15595275406606037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:41', 2, 0, '', '2019-06-03 10:05:41');
INSERT INTO `access_log` VALUES (23155, '59.72.15595275406616041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:41', 15, 2001001000, '服务端发生异常', '2019-06-03 10:05:41');
INSERT INTO `access_log` VALUES (23156, '64.83.15595275447955605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:45', 2, 0, '', '2019-06-03 10:05:45');
INSERT INTO `access_log` VALUES (23157, '64.80.15595275449155603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:45', 2, 0, '', '2019-06-03 10:05:45');
INSERT INTO `access_log` VALUES (23158, '64.78.15595275482605617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:48', 1, 0, '', '2019-06-03 10:05:48');
INSERT INTO `access_log` VALUES (23159, '64.76.15595275483645601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:48', 1, 0, '', '2019-06-03 10:05:48');
INSERT INTO `access_log` VALUES (23160, '66.57.15595275537814783', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '14.145.90.66', '2019-06-03 10:05:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-03 10:05:54');
INSERT INTO `access_log` VALUES (23161, '59.74.15595276878096043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:08', 3, 0, '', '2019-06-03 10:08:08');
INSERT INTO `access_log` VALUES (23162, '59.75.15595276878096047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:08', 12, 2001001000, '服务端发生异常', '2019-06-03 10:08:08');
INSERT INTO `access_log` VALUES (23163, '64.77.15595276928565619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:13', 3, 0, '', '2019-06-03 10:08:13');
INSERT INTO `access_log` VALUES (23164, '64.82.15595276929685623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:13', 2, 0, '', '2019-06-03 10:08:13');
INSERT INTO `access_log` VALUES (23165, '64.79.15595276994375607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:19', 2, 0, '', '2019-06-03 10:08:19');
INSERT INTO `access_log` VALUES (23166, '64.85.15595276995975625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:20', 2, 0, '', '2019-06-03 10:08:20');
INSERT INTO `access_log` VALUES (23167, '59.76.15595277040096041', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:24', 3, 0, '', '2019-06-03 10:08:24');
INSERT INTO `access_log` VALUES (23168, '59.71.15595277040096051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:24', 16, 2001001000, '服务端发生异常', '2019-06-03 10:08:24');
INSERT INTO `access_log` VALUES (23169, '64.84.15595277070795619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:27', 2, 0, '', '2019-06-03 10:08:27');
INSERT INTO `access_log` VALUES (23170, '64.83.15595277072335609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:27', 2, 0, '', '2019-06-03 10:08:27');
INSERT INTO `access_log` VALUES (23171, '59.78.15595277078516051', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:28', 3, 0, '', '2019-06-03 10:08:28');
INSERT INTO `access_log` VALUES (23172, '59.73.15595277078516051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:28', 14, 2001001000, '服务端发生异常', '2019-06-03 10:08:28');
INSERT INTO `access_log` VALUES (23173, '65.47.15595277262255849', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:46', 0, 1002001015, '账号未登陆', '2019-06-03 10:08:46');
INSERT INTO `access_log` VALUES (23174, '65.51.15595277262255843', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:46', 1, 1002001015, '账号未登陆', '2019-06-03 10:08:46');
INSERT INTO `access_log` VALUES (23175, '65.45.15595277262275865', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:46', 1, 1002001015, '账号未登陆', '2019-06-03 10:08:46');
INSERT INTO `access_log` VALUES (23176, '65.49.15595277298005865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:08:50');
INSERT INTO `access_log` VALUES (23177, '65.54.15595277312585821', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '101.27.232.7', '2019-06-03 10:08:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:08:51');
INSERT INTO `access_log` VALUES (23178, '65.53.15595278997275829', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:11:40', 9, 0, '', '2019-06-03 10:11:40');
INSERT INTO `access_log` VALUES (23179, '65.46.15595278997275855', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:11:40', 10, 0, '', '2019-06-03 10:11:40');
INSERT INTO `access_log` VALUES (23180, '65.48.15595278997275859', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:11:40', 9, 0, '', '2019-06-03 10:11:40');
INSERT INTO `access_log` VALUES (23181, '65.45.15595278999235869', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:11:40', 14, 0, '', '2019-06-03 10:11:40');
INSERT INTO `access_log` VALUES (23182, '65.48.15595280337005861', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:13:54', 1, 1002001015, '账号未登陆', '2019-06-03 10:13:54');
INSERT INTO `access_log` VALUES (23183, '65.45.15595280337005871', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:13:54', 0, 1002001015, '账号未登陆', '2019-06-03 10:13:54');
INSERT INTO `access_log` VALUES (23184, '65.51.15595280337015849', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:13:54', 1, 1002001015, '账号未登陆', '2019-06-03 10:13:54');
INSERT INTO `access_log` VALUES (23185, '65.49.15595280354905871', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.43.230.229', '2019-06-03 10:13:55', 0, 1002001015, '账号未登陆', '2019-06-03 10:13:55');
INSERT INTO `access_log` VALUES (23186, '65.54.15595280354945827', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.43.230.229', '2019-06-03 10:13:55', 0, 1002001015, '账号未登陆', '2019-06-03 10:13:55');
INSERT INTO `access_log` VALUES (23187, '65.50.15595280354955855', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.43.230.229', '2019-06-03 10:13:55', 1, 1002001015, '账号未登陆', '2019-06-03 10:13:55');
INSERT INTO `access_log` VALUES (23188, '65.52.15595280378715851', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.43.230.229', '2019-06-03 10:13:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:13:58');
INSERT INTO `access_log` VALUES (23189, '65.46.15595280386815859', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:13:59', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:13:59');
INSERT INTO `access_log` VALUES (23190, '65.53.15595280456115833', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:14:06', 61, 0, '', '2019-06-03 10:14:06');
INSERT INTO `access_log` VALUES (23191, '59.74.15595280457776049', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.200.190.114', '2019-06-03 10:14:06', 3, 0, '', '2019-06-03 10:14:06');
INSERT INTO `access_log` VALUES (23192, '59.75.15595280457796053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.200.190.114', '2019-06-03 10:14:06', 11, 2001001000, '服务端发生异常', '2019-06-03 10:14:06');
INSERT INTO `access_log` VALUES (23193, '65.45.15595280462725873', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:14:06', 195, 0, '', '2019-06-03 10:14:06');
INSERT INTO `access_log` VALUES (23194, '65.51.15595280462765851', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:14:06', 194, 0, '', '2019-06-03 10:14:06');
INSERT INTO `access_log` VALUES (23195, '65.48.15595280462725863', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:14:06', 197, 0, '', '2019-06-03 10:14:06');
INSERT INTO `access_log` VALUES (23196, '65.54.15595280515885829', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.43.230.229', '2019-06-03 10:14:12', 57, 0, '', '2019-06-03 10:14:12');
INSERT INTO `access_log` VALUES (23197, '65.50.15595280519725857', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.43.230.229', '2019-06-03 10:14:12', 9, 0, '', '2019-06-03 10:14:12');
INSERT INTO `access_log` VALUES (23198, '65.49.15595280519735873', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.43.230.229', '2019-06-03 10:14:12', 9, 0, '', '2019-06-03 10:14:12');
INSERT INTO `access_log` VALUES (23199, '65.52.15595280519745853', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.43.230.229', '2019-06-03 10:14:12', 10, 0, '', '2019-06-03 10:14:12');
INSERT INTO `access_log` VALUES (23200, '62.86.15595280553695907', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:14:15', 12, 0, '', '2019-06-03 10:14:15');
INSERT INTO `access_log` VALUES (23201, '62.89.15595280578055917', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.43.230.229', '2019-06-03 10:14:18', 35, 0, '', '2019-06-03 10:14:18');
INSERT INTO `access_log` VALUES (23202, '65.53.15595280624565835', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.200.190.114', '2019-06-03 10:14:22', 0, 1002001015, '账号未登陆', '2019-06-03 10:14:22');
INSERT INTO `access_log` VALUES (23203, '65.46.15595280624565861', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.200.190.114', '2019-06-03 10:14:22', 0, 1002001015, '账号未登陆', '2019-06-03 10:14:22');
INSERT INTO `access_log` VALUES (23204, '65.45.15595280647575875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.200.190.114', '2019-06-03 10:14:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:14:25');
INSERT INTO `access_log` VALUES (23205, '62.82.15595280673695927', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:14:27', 15, 0, '', '2019-06-03 10:14:27');
INSERT INTO `access_log` VALUES (23206, '65.51.15595280726175853', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.200.190.114', '2019-06-03 10:14:33', 139, 0, '', '2019-06-03 10:14:33');
INSERT INTO `access_log` VALUES (23207, '65.47.15595280733375859', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.200.190.114', '2019-06-03 10:14:33', 7, 0, '', '2019-06-03 10:14:33');
INSERT INTO `access_log` VALUES (23208, '65.54.15595280733375831', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.200.190.114', '2019-06-03 10:14:33', 8, 0, '', '2019-06-03 10:14:33');
INSERT INTO `access_log` VALUES (23209, '65.50.15595280734355859', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.200.190.114', '2019-06-03 10:14:33', 6, 0, '', '2019-06-03 10:14:33');
INSERT INTO `access_log` VALUES (23210, '64.79.15595280738735613', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:14:34', 9, 0, '', '2019-06-03 10:14:34');
INSERT INTO `access_log` VALUES (23211, '64.82.15595280738735629', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:14:34', 10, 0, '', '2019-06-03 10:14:34');
INSERT INTO `access_log` VALUES (23212, '66.50.15595280791724791', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:14:39', 14, 0, '', '2019-06-03 10:14:39');
INSERT INTO `access_log` VALUES (23213, '59.71.15595280826876057', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:14:43', 11, 0, '', '2019-06-03 10:14:43');
INSERT INTO `access_log` VALUES (23214, '59.73.15595280905586057', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:14:51', 342, 2001001000, '服务端发生异常', '2019-06-03 10:14:51');
INSERT INTO `access_log` VALUES (23215, '59.80.15595280960316049', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:14:56', 90, 0, '', '2019-06-03 10:14:56');
INSERT INTO `access_log` VALUES (23216, '59.72.15595281002716051', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:15:00', 13, 0, '', '2019-06-03 10:15:00');
INSERT INTO `access_log` VALUES (23217, '59.74.15595281065266051', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:15:07', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 10:15:07');
INSERT INTO `access_log` VALUES (23218, '65.53.15595281125745837', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:15:13', 420, 0, '', '2019-06-03 10:15:13');
INSERT INTO `access_log` VALUES (23219, '65.48.15595281155045867', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:15:16', 8, 0, '', '2019-06-03 10:15:16');
INSERT INTO `access_log` VALUES (23220, '65.45.15595281182415877', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:15:18', 16, 0, '', '2019-06-03 10:15:18');
INSERT INTO `access_log` VALUES (23221, '65.51.15595281219225855', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '221.131.123.204', '2019-06-03 10:15:22', 14, 0, '', '2019-06-03 10:15:22');
INSERT INTO `access_log` VALUES (23222, '65.54.15595281246335833', 0, 2, 'admin-application', '/admin-api/admins/data_dict/delete', 'id=45', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:15:25', 10, 1002002007, '没有该操作权限', '2019-06-03 10:15:25');
INSERT INTO `access_log` VALUES (23223, '65.50.15595281248265861', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:15:25', 13, 0, '', '2019-06-03 10:15:25');
INSERT INTO `access_log` VALUES (23224, '59.75.15595282488056057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:17:29', 4, 0, '', '2019-06-03 10:17:29');
INSERT INTO `access_log` VALUES (23225, '59.74.15595282488056053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:17:29', 13, 2001001000, '服务端发生异常', '2019-06-03 10:17:29');
INSERT INTO `access_log` VALUES (23226, '65.49.15595282827765879', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:03', 0, 1002001015, '账号未登陆', '2019-06-03 10:18:03');
INSERT INTO `access_log` VALUES (23227, '65.52.15595282827765859', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:03', 0, 1002001015, '账号未登陆', '2019-06-03 10:18:03');
INSERT INTO `access_log` VALUES (23228, '65.46.15595282827805867', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:03', 0, 1002001015, '账号未登陆', '2019-06-03 10:18:03');
INSERT INTO `access_log` VALUES (23229, '65.53.15595282871115841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:07', 80, 0, '', '2019-06-03 10:18:07');
INSERT INTO `access_log` VALUES (23230, '65.48.15595282874635871', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:07', 9, 0, '', '2019-06-03 10:18:07');
INSERT INTO `access_log` VALUES (23231, '65.45.15595282874675881', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:07', 9, 0, '', '2019-06-03 10:18:07');
INSERT INTO `access_log` VALUES (23232, '65.51.15595282874695859', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:07', 9, 0, '', '2019-06-03 10:18:07');
INSERT INTO `access_log` VALUES (23233, '62.85.15595282954925923', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:15', 13, 0, '', '2019-06-03 10:18:16');
INSERT INTO `access_log` VALUES (23234, '62.89.15595283014225921', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:21', 15, 0, '', '2019-06-03 10:18:21');
INSERT INTO `access_log` VALUES (23235, '62.80.15595283033775925', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:23', 15, 0, '', '2019-06-03 10:18:23');
INSERT INTO `access_log` VALUES (23236, '65.50.15595283092815865', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:29', 20, 0, '', '2019-06-03 10:18:29');
INSERT INTO `access_log` VALUES (23237, '65.46.15595283132045869', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:33', 10, 0, '', '2019-06-03 10:18:33');
INSERT INTO `access_log` VALUES (23238, '65.52.15595283156775861', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:36', 12, 0, '', '2019-06-03 10:18:36');
INSERT INTO `access_log` VALUES (23239, '65.49.15595283181375881', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:38', 8, 0, '', '2019-06-03 10:18:38');
INSERT INTO `access_log` VALUES (23240, '65.53.15595283184105843', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:18:38', 8, 0, '', '2019-06-03 10:18:38');
INSERT INTO `access_log` VALUES (23241, '65.45.15595283206235883', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:18:41', 10, 0, '', '2019-06-03 10:18:41');
INSERT INTO `access_log` VALUES (23242, '65.48.15595283222995873', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:18:42', 9, 0, '', '2019-06-03 10:18:42');
INSERT INTO `access_log` VALUES (23243, '59.80.15595283228286053', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:43', 11, 0, '', '2019-06-03 10:18:43');
INSERT INTO `access_log` VALUES (23244, '65.47.15595283233265867', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:18:43', 13, 0, '', '2019-06-03 10:18:43');
INSERT INTO `access_log` VALUES (23245, '59.77.15595283340406051', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:54', 20, 2001001000, '服务端发生异常', '2019-06-03 10:18:54');
INSERT INTO `access_log` VALUES (23246, '59.75.15595283373976059', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:18:57', 12, 0, '', '2019-06-03 10:18:57');
INSERT INTO `access_log` VALUES (23247, '64.82.15595283410245633', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:19:01', 10, 0, '', '2019-06-03 10:19:01');
INSERT INTO `access_log` VALUES (23248, '64.79.15595283431745617', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:19:03', 9, 0, '', '2019-06-03 10:19:03');
INSERT INTO `access_log` VALUES (23249, '66.55.15595283449664801', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:19:05', 14, 0, '', '2019-06-03 10:19:05');
INSERT INTO `access_log` VALUES (23250, '66.56.15595283617594789', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:19:22', 12, 0, '', '2019-06-03 10:19:22');
INSERT INTO `access_log` VALUES (23251, '64.84.15595283664345629', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:19:26', 9, 0, '', '2019-06-03 10:19:26');
INSERT INTO `access_log` VALUES (23252, '64.83.15595283664345619', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:19:26', 36, 0, '', '2019-06-03 10:19:26');
INSERT INTO `access_log` VALUES (23253, '64.78.15595283688495631', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:19:29', 9, 0, '', '2019-06-03 10:19:29');
INSERT INTO `access_log` VALUES (23254, '64.80.15595283688495617', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:19:29', 11, 0, '', '2019-06-03 10:19:29');
INSERT INTO `access_log` VALUES (23255, '64.77.15595283713885631', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:19:31', 9, 0, '', '2019-06-03 10:19:31');
INSERT INTO `access_log` VALUES (23256, '64.82.15595283713915635', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:19:31', 9, 0, '', '2019-06-03 10:19:31');
INSERT INTO `access_log` VALUES (23257, '64.76.15595283713865615', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:19:31', 14, 0, '', '2019-06-03 10:19:31');
INSERT INTO `access_log` VALUES (23258, '64.79.15595283744115619', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:19:34', 6, 1002002009, NULL, '2019-06-03 10:19:34');
INSERT INTO `access_log` VALUES (23259, '59.73.15595283984946063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:19:58', 13, 2001001000, '服务端发生异常', '2019-06-03 10:19:59');
INSERT INTO `access_log` VALUES (23260, '59.78.15595283984826063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:19:58', 619, 0, '', '2019-06-03 10:19:59');
INSERT INTO `access_log` VALUES (23261, '64.84.15595284022605631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:20:02', 1, 0, '', '2019-06-03 10:20:02');
INSERT INTO `access_log` VALUES (23262, '65.53.15595284022595845', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:20:02', 11, 0, '', '2019-06-03 10:20:02');
INSERT INTO `access_log` VALUES (23263, '64.83.15595284023825621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:20:02', 1, 0, '', '2019-06-03 10:20:02');
INSERT INTO `access_log` VALUES (23264, '66.57.15595284050014795', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:20:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空', '2019-06-03 10:20:05');
INSERT INTO `access_log` VALUES (23265, '64.80.15595284088135619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:20:09', 2, 0, '', '2019-06-03 10:20:09');
INSERT INTO `access_log` VALUES (23266, '64.77.15595284091055633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:20:09', 1, 0, '', '2019-06-03 10:20:09');
INSERT INTO `access_log` VALUES (23267, '59.77.15595284201196053', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:20:20', 4, 0, '', '2019-06-03 10:20:20');
INSERT INTO `access_log` VALUES (23268, '59.75.15595284201196061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:20:20', 20, 2001001000, '服务端发生异常', '2019-06-03 10:20:20');
INSERT INTO `access_log` VALUES (23269, '64.82.15595284222085637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:20:22', 2, 0, '', '2019-06-03 10:20:22');
INSERT INTO `access_log` VALUES (23270, '64.79.15595284225115621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:20:23', 2, 0, '', '2019-06-03 10:20:23');
INSERT INTO `access_log` VALUES (23271, '59.74.15595284235766057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:20:24', 2, 0, '', '2019-06-03 10:20:24');
INSERT INTO `access_log` VALUES (23272, '59.79.15595284235766061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:20:24', 9, 2001001000, '服务端发生异常', '2019-06-03 10:20:24');
INSERT INTO `access_log` VALUES (23273, '62.82.15595284236905933', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:20:24', 12, 0, '', '2019-06-03 10:20:24');
INSERT INTO `access_log` VALUES (23274, '62.83.15595284345715923', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:20:35', 12, 0, '', '2019-06-03 10:20:35');
INSERT INTO `access_log` VALUES (23275, '65.54.15595284601795841', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:21:00', 15, 0, '', '2019-06-03 10:21:00');
INSERT INTO `access_log` VALUES (23276, '59.75.15595285124426063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:21:52', 3, 0, '', '2019-06-03 10:21:52');
INSERT INTO `access_log` VALUES (23277, '59.77.15595285134896055', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:21:53', 13, 2001001000, '服务端发生异常', '2019-06-03 10:21:54');
INSERT INTO `access_log` VALUES (23278, '64.77.15595285178385635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:21:58', 3, 0, '', '2019-06-03 10:21:58');
INSERT INTO `access_log` VALUES (23279, '64.76.15595285179585619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:21:58', 2, 0, '', '2019-06-03 10:21:58');
INSERT INTO `access_log` VALUES (23280, '64.82.15595285196605639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:22:00', 2, 0, '', '2019-06-03 10:22:00');
INSERT INTO `access_log` VALUES (23281, '64.79.15595285204555623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:22:00', 2, 0, '', '2019-06-03 10:22:00');
INSERT INTO `access_log` VALUES (23282, '64.81.15595285263395625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:22:06', 2, 0, '', '2019-06-03 10:22:06');
INSERT INTO `access_log` VALUES (23283, '64.84.15595285264645635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:22:06', 2, 0, '', '2019-06-03 10:22:06');
INSERT INTO `access_log` VALUES (23284, '59.76.15595285276466057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:22:08', 11, 2001001000, '服务端发生异常', '2019-06-03 10:22:08');
INSERT INTO `access_log` VALUES (23285, '59.79.15595285276426063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.220.141.225', '2019-06-03 10:22:08', 15, 0, '', '2019-06-03 10:22:08');
INSERT INTO `access_log` VALUES (23286, '64.83.15595285377895625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.220.141.225', '2019-06-03 10:22:18', 2, 0, '', '2019-06-03 10:22:18');
INSERT INTO `access_log` VALUES (23287, '64.78.15595285379325637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.220.141.225', '2019-06-03 10:22:18', 2, 0, '', '2019-06-03 10:22:18');
INSERT INTO `access_log` VALUES (23288, '64.77.15595285425555637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.220.141.225', '2019-06-03 10:22:23', 2, 0, '', '2019-06-03 10:22:23');
INSERT INTO `access_log` VALUES (23289, '64.76.15595285427245621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.220.141.225', '2019-06-03 10:22:23', 2, 0, '', '2019-06-03 10:22:23');
INSERT INTO `access_log` VALUES (23290, '59.73.15595285478266067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.220.141.225', '2019-06-03 10:22:28', 2, 0, '', '2019-06-03 10:22:28');
INSERT INTO `access_log` VALUES (23291, '59.78.15595285478266067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.220.141.225', '2019-06-03 10:22:28', 12, 2001001000, '服务端发生异常', '2019-06-03 10:22:28');
INSERT INTO `access_log` VALUES (23292, '64.82.15595285526315641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.220.141.225', '2019-06-03 10:22:33', 2, 0, '', '2019-06-03 10:22:33');
INSERT INTO `access_log` VALUES (23293, '64.79.15595285527355625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.220.141.225', '2019-06-03 10:22:33', 2, 0, '', '2019-06-03 10:22:33');
INSERT INTO `access_log` VALUES (23294, '64.85.15595285547695643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.220.141.225', '2019-06-03 10:22:35', 203, 0, '', '2019-06-03 10:22:35');
INSERT INTO `access_log` VALUES (23295, '64.84.15595285556465637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.220.141.225', '2019-06-03 10:22:36', 2, 0, '', '2019-06-03 10:22:36');
INSERT INTO `access_log` VALUES (23296, '64.83.15595285570555627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.220.141.225', '2019-06-03 10:22:37', 2, 0, '', '2019-06-03 10:22:37');
INSERT INTO `access_log` VALUES (23297, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.220.141.225', '2019-06-03 10:22:37', 13, 0, '', '2019-06-03 10:22:37');
INSERT INTO `access_log` VALUES (23298, '64.78.15595285600905639', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.220.141.225', '2019-06-03 10:22:40', 7, 0, '', '2019-06-03 10:22:40');
INSERT INTO `access_log` VALUES (23299, '64.77.15595285712155639', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.220.141.225', '2019-06-03 10:22:51', 7, 0, '', '2019-06-03 10:22:51');
INSERT INTO `access_log` VALUES (23300, '59.80.15595286873966061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:24:47', 12, 2001001000, '服务端发生异常', '2019-06-03 10:24:47');
INSERT INTO `access_log` VALUES (23301, '59.78.15595286873956069', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:24:47', 28, 0, '', '2019-06-03 10:24:47');
INSERT INTO `access_log` VALUES (23302, '65.45.15595286963555889', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:24:56', 0, 1002001015, '账号未登陆', '2019-06-03 10:24:56');
INSERT INTO `access_log` VALUES (23303, '65.48.15595286963555879', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:24:56', 0, 1002001015, '账号未登陆', '2019-06-03 10:24:56');
INSERT INTO `access_log` VALUES (23304, '65.47.15595286963565873', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:24:56', 0, 1002001015, '账号未登陆', '2019-06-03 10:24:56');
INSERT INTO `access_log` VALUES (23305, '65.54.15595286985215845', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:24:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:24:59');
INSERT INTO `access_log` VALUES (23306, '65.50.15595287000565873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:25:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:25:00');
INSERT INTO `access_log` VALUES (23307, '65.46.15595287006905877', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:25:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:25:01');
INSERT INTO `access_log` VALUES (23308, '65.49.15595287129695889', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:25:13', 61, 0, '', '2019-06-03 10:25:13');
INSERT INTO `access_log` VALUES (23309, '65.53.15595287132385851', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:25:13', 10, 0, '', '2019-06-03 10:25:13');
INSERT INTO `access_log` VALUES (23310, '65.51.15595287132445869', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:25:13', 13, 0, '', '2019-06-03 10:25:13');
INSERT INTO `access_log` VALUES (23311, '65.48.15595287132495881', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:25:13', 9, 0, '', '2019-06-03 10:25:13');
INSERT INTO `access_log` VALUES (23312, '65.54.15595287509785847', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.17.128.44', '2019-06-03 10:25:51', 0, 1002001015, '账号未登陆', '2019-06-03 10:25:51');
INSERT INTO `access_log` VALUES (23313, '65.50.15595287509825875', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.17.128.44', '2019-06-03 10:25:51', 0, 1002001015, '账号未登陆', '2019-06-03 10:25:51');
INSERT INTO `access_log` VALUES (23314, '65.46.15595287509845879', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.17.128.44', '2019-06-03 10:25:51', 0, 1002001015, '账号未登陆', '2019-06-03 10:25:51');
INSERT INTO `access_log` VALUES (23315, '65.49.15595287551815891', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.17.128.44', '2019-06-03 10:25:55', 95, 0, '', '2019-06-03 10:25:55');
INSERT INTO `access_log` VALUES (23316, '65.51.15595287555225871', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.17.128.44', '2019-06-03 10:25:56', 9, 0, '', '2019-06-03 10:25:56');
INSERT INTO `access_log` VALUES (23317, '65.53.15595287555245853', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.17.128.44', '2019-06-03 10:25:56', 9, 0, '', '2019-06-03 10:25:56');
INSERT INTO `access_log` VALUES (23318, '65.48.15595287555265883', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.17.128.44', '2019-06-03 10:25:56', 9, 0, '', '2019-06-03 10:25:56');
INSERT INTO `access_log` VALUES (23319, '62.81.15595287607275911', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.17.128.44', '2019-06-03 10:26:01', 14, 0, '', '2019-06-03 10:26:01');
INSERT INTO `access_log` VALUES (23320, '65.47.15595287683825877', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:26:08', 9, 0, '', '2019-06-03 10:26:08');
INSERT INTO `access_log` VALUES (23321, '65.45.15595287683875893', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:26:08', 9, 0, '', '2019-06-03 10:26:08');
INSERT INTO `access_log` VALUES (23322, '65.50.15595287683875877', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:26:08', 8, 0, '', '2019-06-03 10:26:08');
INSERT INTO `access_log` VALUES (23323, '65.46.15595287705355881', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:26:11', 8, 0, '', '2019-06-03 10:26:11');
INSERT INTO `access_log` VALUES (23324, '65.52.15595287705355873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:26:11', 9, 0, '', '2019-06-03 10:26:11');
INSERT INTO `access_log` VALUES (23325, '65.49.15595287705425893', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:26:11', 8, 0, '', '2019-06-03 10:26:11');
INSERT INTO `access_log` VALUES (23326, '65.48.15595287739415885', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:26:14', 9, 0, '', '2019-06-03 10:26:14');
INSERT INTO `access_log` VALUES (23327, '65.53.15595287739495855', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:26:14', 8, 0, '', '2019-06-03 10:26:14');
INSERT INTO `access_log` VALUES (23328, '65.51.15595287739515873', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:26:14', 8, 0, '', '2019-06-03 10:26:14');
INSERT INTO `access_log` VALUES (23329, '62.86.15595287894305919', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:26:29', 13, 0, '', '2019-06-03 10:26:29');
INSERT INTO `access_log` VALUES (23330, '62.80.15595287991405933', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:26:39', 109, 0, '', '2019-06-03 10:26:39');
INSERT INTO `access_log` VALUES (23331, '62.82.15595288078085939', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:26:48', 15, 0, '', '2019-06-03 10:26:48');
INSERT INTO `access_log` VALUES (23332, '64.83.15595288155985631', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:26:56', 10, 0, '', '2019-06-03 10:26:56');
INSERT INTO `access_log` VALUES (23333, '64.78.15595288156495643', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:26:56', 8, 0, '', '2019-06-03 10:26:56');
INSERT INTO `access_log` VALUES (23334, '64.77.15595288204605643', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:27:00', 8, 0, '', '2019-06-03 10:27:00');
INSERT INTO `access_log` VALUES (23335, '64.80.15595288204575629', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:27:00', 12, 0, '', '2019-06-03 10:27:00');
INSERT INTO `access_log` VALUES (23336, '64.85.15595288259915649', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:27:06', 9, 0, '', '2019-06-03 10:27:06');
INSERT INTO `access_log` VALUES (23337, '64.79.15595288259905631', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:27:06', 12, 0, '', '2019-06-03 10:27:06');
INSERT INTO `access_log` VALUES (23338, '64.82.15595288259905647', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:27:06', 16, 0, '', '2019-06-03 10:27:06');
INSERT INTO `access_log` VALUES (23339, '64.81.15595288353985633', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:27:15', 8, 1002002009, NULL, '2019-06-03 10:27:15');
INSERT INTO `access_log` VALUES (23340, '66.48.15595288453654803', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:27:25', 132, 0, '', '2019-06-03 10:27:25');
INSERT INTO `access_log` VALUES (23341, '59.75.15595288534856069', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:27:33', 19, 0, '', '2019-06-03 10:27:34');
INSERT INTO `access_log` VALUES (23342, '59.74.15595288638316065', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:27:44', 19, 2001001000, '服务端发生异常', '2019-06-03 10:27:44');
INSERT INTO `access_log` VALUES (23343, '59.79.15595288674576069', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:27:47', 11, 0, '', '2019-06-03 10:27:47');
INSERT INTO `access_log` VALUES (23344, '65.49.15595288727045897', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:27:53', 20, 0, '', '2019-06-03 10:27:53');
INSERT INTO `access_log` VALUES (23345, '65.46.15595288751835883', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:27:55', 11, 0, '', '2019-06-03 10:27:55');
INSERT INTO `access_log` VALUES (23346, '65.47.15595288804165881', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:28:00', 9, 0, '', '2019-06-03 10:28:00');
INSERT INTO `access_log` VALUES (23347, '65.51.15595288827305877', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:28:03', 12, 0, '', '2019-06-03 10:28:03');
INSERT INTO `access_log` VALUES (23348, '65.45.15595289049405897', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:28:25', 10, 0, '', '2019-06-03 10:28:25');
INSERT INTO `access_log` VALUES (23349, '65.52.15595289058735877', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.17.128.44', '2019-06-03 10:28:26', 2, 0, '', '2019-06-03 10:28:26');
INSERT INTO `access_log` VALUES (23350, '65.46.15595289240145885', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.17.128.44', '2019-06-03 10:28:44', 1, 1002001015, '账号未登陆', '2019-06-03 10:28:44');
INSERT INTO `access_log` VALUES (23351, '65.50.15595289453835885', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:29:05', 15, 0, '', '2019-06-03 10:29:05');
INSERT INTO `access_log` VALUES (23352, '65.48.15595290028635891', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:30:03', 15, 0, '', '2019-06-03 10:30:03');
INSERT INTO `access_log` VALUES (23353, '65.50.15595290032525887', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:30:03', 9, 0, '', '2019-06-03 10:30:03');
INSERT INTO `access_log` VALUES (23354, '65.45.15595290034135901', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:30:03', 10, 0, '', '2019-06-03 10:30:03');
INSERT INTO `access_log` VALUES (23355, '65.54.15595290035925855', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:30:04', 17, 0, '', '2019-06-03 10:30:04');
INSERT INTO `access_log` VALUES (23356, '59.79.15595290037916071', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:30:04', 13, 0, '', '2019-06-03 10:30:04');
INSERT INTO `access_log` VALUES (23357, '59.76.15595290039536065', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:30:04', 20, 2001001000, '服务端发生异常', '2019-06-03 10:30:04');
INSERT INTO `access_log` VALUES (23358, '59.73.15595290041156075', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:30:04', 200, 0, '', '2019-06-03 10:30:04');
INSERT INTO `access_log` VALUES (23359, '66.52.15595290045304801', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '222.65.2.101', '2019-06-03 10:30:05', 11, 0, '', '2019-06-03 10:30:05');
INSERT INTO `access_log` VALUES (23360, '64.80.15595290221885633', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:30:22', 15, 0, '', '2019-06-03 10:30:22');
INSERT INTO `access_log` VALUES (23361, '64.77.15595290221885647', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:30:22', 17, 0, '', '2019-06-03 10:30:22');
INSERT INTO `access_log` VALUES (23362, '65.47.15595290253105887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:30:25', 8, 0, '', '2019-06-03 10:30:25');
INSERT INTO `access_log` VALUES (23363, '65.51.15595290253115879', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:30:25', 8, 0, '', '2019-06-03 10:30:25');
INSERT INTO `access_log` VALUES (23364, '65.48.15595290253125893', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:30:25', 8, 0, '', '2019-06-03 10:30:25');
INSERT INTO `access_log` VALUES (23365, '64.76.15595290255245631', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:30:26', 9, 0, '', '2019-06-03 10:30:26');
INSERT INTO `access_log` VALUES (23366, '64.79.15595290255275635', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:30:26', 7, 0, '', '2019-06-03 10:30:26');
INSERT INTO `access_log` VALUES (23367, '65.51.15595291667275883', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:32:47', 1, 1002001015, '账号未登陆', '2019-06-03 10:32:47');
INSERT INTO `access_log` VALUES (23368, '65.48.15595291667275895', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:32:47', 0, 1002001015, '账号未登陆', '2019-06-03 10:32:47');
INSERT INTO `access_log` VALUES (23369, '65.50.15595291667295891', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:32:47', 0, 1002001015, '账号未登陆', '2019-06-03 10:32:47');
INSERT INTO `access_log` VALUES (23370, '65.45.15595291690715905', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:32:49', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:32:49');
INSERT INTO `access_log` VALUES (23371, '65.54.15595291723275857', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:32:52', 122, 0, '', '2019-06-03 10:32:52');
INSERT INTO `access_log` VALUES (23372, '65.52.15595291728485881', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:32:53', 10, 0, '', '2019-06-03 10:32:53');
INSERT INTO `access_log` VALUES (23373, '65.49.15595291728535907', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:32:53', 9, 0, '', '2019-06-03 10:32:53');
INSERT INTO `access_log` VALUES (23374, '65.53.15595291728585861', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:32:53', 8, 0, '', '2019-06-03 10:32:53');
INSERT INTO `access_log` VALUES (23375, '62.83.15595291798285945', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:33:00', 14, 0, '', '2019-06-03 10:33:00');
INSERT INTO `access_log` VALUES (23376, '62.88.15595291822235953', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:33:02', 12, 0, '', '2019-06-03 10:33:02');
INSERT INTO `access_log` VALUES (23377, '64.85.15595291863465655', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:33:06', 9, 0, '', '2019-06-03 10:33:06');
INSERT INTO `access_log` VALUES (23378, '64.81.15595291863565639', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:33:06', 9, 0, '', '2019-06-03 10:33:06');
INSERT INTO `access_log` VALUES (23379, '59.72.15595291950826071', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:33:15', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 10:33:15');
INSERT INTO `access_log` VALUES (23380, '65.50.15595291967705893', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:33:17', 20, 0, '', '2019-06-03 10:33:17');
INSERT INTO `access_log` VALUES (23381, '65.48.15595291973605897', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.28.97.130', '2019-06-03 10:33:17', 9, 0, '', '2019-06-03 10:33:17');
INSERT INTO `access_log` VALUES (23382, '64.85.15595292964385657', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:34:56', 64, 0, '', '2019-06-03 10:34:57');
INSERT INTO `access_log` VALUES (23383, '64.82.15595292964325655', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:34:56', 72, 0, '', '2019-06-03 10:34:57');
INSERT INTO `access_log` VALUES (23384, '64.81.15595292992775641', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:34:59', 17, 0, '', '2019-06-03 10:34:59');
INSERT INTO `access_log` VALUES (23385, '64.84.15595292992785651', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 10:34:59', 18, 0, '', '2019-06-03 10:34:59');
INSERT INTO `access_log` VALUES (23386, '59.71.15595294215556081', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:02', 3, 0, '', '2019-06-03 10:37:02');
INSERT INTO `access_log` VALUES (23387, '59.73.15595294215586081', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:02', 14, 2001001000, '服务端发生异常', '2019-06-03 10:37:02');
INSERT INTO `access_log` VALUES (23388, '65.46.15595294345405895', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:15', 0, 1002001015, '账号未登陆', '2019-06-03 10:37:15');
INSERT INTO `access_log` VALUES (23389, '65.47.15595294345435897', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:15', 0, 1002001015, '账号未登陆', '2019-06-03 10:37:15');
INSERT INTO `access_log` VALUES (23390, '65.50.15595294346025897', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:15', 1, 1002001015, '账号未登陆', '2019-06-03 10:37:15');
INSERT INTO `access_log` VALUES (23391, '65.48.15595294413925901', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:37:21');
INSERT INTO `access_log` VALUES (23392, '65.45.15595294484845911', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:28', 53, 0, '', '2019-06-03 10:37:29');
INSERT INTO `access_log` VALUES (23393, '65.54.15595294491155863', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:29', 10, 0, '', '2019-06-03 10:37:29');
INSERT INTO `access_log` VALUES (23394, '65.52.15595294491175887', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:29', 8, 0, '', '2019-06-03 10:37:29');
INSERT INTO `access_log` VALUES (23395, '65.53.15595294491205867', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:29', 9, 0, '', '2019-06-03 10:37:29');
INSERT INTO `access_log` VALUES (23396, '62.86.15595294566175939', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:37', 26, 0, '', '2019-06-03 10:37:37');
INSERT INTO `access_log` VALUES (23397, '62.89.15595294629565951', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:43', 15, 0, '', '2019-06-03 10:37:43');
INSERT INTO `access_log` VALUES (23398, '64.78.15595294657735655', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:46', 12, 0, '', '2019-06-03 10:37:46');
INSERT INTO `access_log` VALUES (23399, '64.80.15595294657765641', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:46', 9, 0, '', '2019-06-03 10:37:46');
INSERT INTO `access_log` VALUES (23400, '64.79.15595294695115643', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:50', 9, 0, '', '2019-06-03 10:37:50');
INSERT INTO `access_log` VALUES (23401, '64.77.15595294695095655', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:50', 12, 0, '', '2019-06-03 10:37:50');
INSERT INTO `access_log` VALUES (23402, '64.85.15595294729595661', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:53', 10, 0, '', '2019-06-03 10:37:53');
INSERT INTO `access_log` VALUES (23403, '64.81.15595294729635645', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:53', 8, 0, '', '2019-06-03 10:37:53');
INSERT INTO `access_log` VALUES (23404, '64.82.15595294729575659', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:37:53', 15, 0, '', '2019-06-03 10:37:53');
INSERT INTO `access_log` VALUES (23405, '64.78.15595295156105657', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:38:36', 7, 0, '', '2019-06-03 10:38:36');
INSERT INTO `access_log` VALUES (23406, '64.77.15595295304815657', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:38:50', 9, 0, '', '2019-06-03 10:38:50');
INSERT INTO `access_log` VALUES (23407, '64.79.15595295304805645', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:38:50', 11, 0, '', '2019-06-03 10:38:50');
INSERT INTO `access_log` VALUES (23408, '64.85.15595295340745663', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:38:54', 10, 0, '', '2019-06-03 10:38:54');
INSERT INTO `access_log` VALUES (23409, '64.81.15595295340735647', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:38:54', 13, 0, '', '2019-06-03 10:38:54');
INSERT INTO `access_log` VALUES (23410, '64.82.15595295341145661', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:38:54', 9, 0, '', '2019-06-03 10:38:54');
INSERT INTO `access_log` VALUES (23411, '59.80.15595295600006075', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:39:20', 12, 0, '', '2019-06-03 10:39:20');
INSERT INTO `access_log` VALUES (23412, '59.78.15595295635946083', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:39:24', 33, 2001001000, '服务端发生异常', '2019-06-03 10:39:24');
INSERT INTO `access_log` VALUES (23413, '59.72.15595295670376077', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:39:27', 10, 0, '', '2019-06-03 10:39:27');
INSERT INTO `access_log` VALUES (23414, '59.75.15595295698816081', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:39:30', 12, 0, '', '2019-06-03 10:39:30');
INSERT INTO `access_log` VALUES (23415, '65.52.15595295725295889', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:39:33', 19, 0, '', '2019-06-03 10:39:33');
INSERT INTO `access_log` VALUES (23416, '65.53.15595295743545869', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:39:34', 10, 0, '', '2019-06-03 10:39:34');
INSERT INTO `access_log` VALUES (23417, '65.49.15595295767065915', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:39:37', 9, 0, '', '2019-06-03 10:39:37');
INSERT INTO `access_log` VALUES (23418, '65.47.15595295785675901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:39:39', 88, 0, '', '2019-06-03 10:39:39');
INSERT INTO `access_log` VALUES (23419, '64.78.15595295861045659', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:39:46', 122, 0, '', '2019-06-03 10:39:46');
INSERT INTO `access_log` VALUES (23420, '65.50.15595295918265901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:39:52', 14, 0, '', '2019-06-03 10:39:52');
INSERT INTO `access_log` VALUES (23421, '64.79.15595296066645647', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:40:07', 7, 0, '', '2019-06-03 10:40:07');
INSERT INTO `access_log` VALUES (23422, '64.85.15595296134835665', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:40:13', 7, 0, '', '2019-06-03 10:40:13');
INSERT INTO `access_log` VALUES (23423, '64.81.15595296134825649', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:40:13', 10, 0, '', '2019-06-03 10:40:13');
INSERT INTO `access_log` VALUES (23424, '64.84.15595296208785659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:40:21', 2, 0, '', '2019-06-03 10:40:21');
INSERT INTO `access_log` VALUES (23425, '64.83.15595296209875649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:40:21', 2, 0, '', '2019-06-03 10:40:21');
INSERT INTO `access_log` VALUES (23426, '64.80.15595296228335647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:40:23', 2, 0, '', '2019-06-03 10:40:23');
INSERT INTO `access_log` VALUES (23427, '64.78.15595296235025661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:40:24', 2, 0, '', '2019-06-03 10:40:24');
INSERT INTO `access_log` VALUES (23428, '64.76.15595296279945645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:40:28', 2, 0, '', '2019-06-03 10:40:28');
INSERT INTO `access_log` VALUES (23429, '64.77.15595296281085661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:40:28', 2, 0, '', '2019-06-03 10:40:28');
INSERT INTO `access_log` VALUES (23430, '65.54.15595296295885867', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:40:30', 1, 1002001015, '账号未登陆', '2019-06-03 10:40:30');
INSERT INTO `access_log` VALUES (23431, '65.52.15595296295905891', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:40:30', 0, 1002001015, '账号未登陆', '2019-06-03 10:40:30');
INSERT INTO `access_log` VALUES (23432, '65.53.15595296295955871', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:40:30', 1, 1002001015, '账号未登陆', '2019-06-03 10:40:30');
INSERT INTO `access_log` VALUES (23433, '65.49.15595296313265917', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:40:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:40:31');
INSERT INTO `access_log` VALUES (23434, '59.71.15595296324436085', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:40:32', 3, 0, '', '2019-06-03 10:40:32');
INSERT INTO `access_log` VALUES (23435, '59.73.15595296324806085', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '111.20.176.230', '2019-06-03 10:40:32', 13, 2001001000, '服务端发生异常', '2019-06-03 10:40:32');
INSERT INTO `access_log` VALUES (23436, '65.48.15595296764555907', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.172.53.135', '2019-06-03 10:41:16', 3, 1002001012, '访问令牌已过期', '2019-06-03 10:41:16');
INSERT INTO `access_log` VALUES (23437, '65.51.15595296787085895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.172.53.135', '2019-06-03 10:41:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:41:19');
INSERT INTO `access_log` VALUES (23438, '65.53.15595297090545873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:41:49', 89, 0, '', '2019-06-03 10:41:49');
INSERT INTO `access_log` VALUES (23439, '65.54.15595297094055869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:41:49', 10, 0, '', '2019-06-03 10:41:49');
INSERT INTO `access_log` VALUES (23440, '65.49.15595297094075919', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:41:49', 9, 0, '', '2019-06-03 10:41:49');
INSERT INTO `access_log` VALUES (23441, '65.47.15595297094095905', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:41:49', 9, 0, '', '2019-06-03 10:41:49');
INSERT INTO `access_log` VALUES (23442, '59.76.15595297150366077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:41:55', 14, 2001001000, '服务端发生异常', '2019-06-03 10:41:55');
INSERT INTO `access_log` VALUES (23443, '59.79.15595297150366083', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:41:55', 50, 0, '', '2019-06-03 10:41:55');
INSERT INTO `access_log` VALUES (23444, '62.89.15595297169035955', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:41:57', 13, 0, '', '2019-06-03 10:41:57');
INSERT INTO `access_log` VALUES (23445, '64.80.15595297190315649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:41:59', 2, 0, '', '2019-06-03 10:41:59');
INSERT INTO `access_log` VALUES (23446, '64.78.15595297191495663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:41:59', 1, 0, '', '2019-06-03 10:41:59');
INSERT INTO `access_log` VALUES (23447, '65.50.15595297230585905', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:42:03', 19, 0, '', '2019-06-03 10:42:03');
INSERT INTO `access_log` VALUES (23448, '65.48.15595297238415909', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:42:04', 10, 0, '', '2019-06-03 10:42:04');
INSERT INTO `access_log` VALUES (23449, '65.51.15595297246385897', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:42:05', 9, 0, '', '2019-06-03 10:42:05');
INSERT INTO `access_log` VALUES (23450, '64.76.15595297253555647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:05', 1, 0, '', '2019-06-03 10:42:05');
INSERT INTO `access_log` VALUES (23451, '64.77.15595297254905663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:05', 1, 0, '', '2019-06-03 10:42:05');
INSERT INTO `access_log` VALUES (23452, '65.45.15595297256485919', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:42:06', 11, 0, '', '2019-06-03 10:42:06');
INSERT INTO `access_log` VALUES (23453, '59.73.15595297269276087', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:07', 2, 0, '', '2019-06-03 10:42:07');
INSERT INTO `access_log` VALUES (23454, '59.80.15595297269296079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:07', 12, 2001001000, '服务端发生异常', '2019-06-03 10:42:07');
INSERT INTO `access_log` VALUES (23455, '65.53.15595297310025875', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:42:11', 10, 0, '', '2019-06-03 10:42:11');
INSERT INTO `access_log` VALUES (23456, '65.54.15595297315815871', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:42:12', 10, 0, '', '2019-06-03 10:42:12');
INSERT INTO `access_log` VALUES (23457, '65.49.15595297319205921', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.72.102', '2019-06-03 10:42:12', 18, 0, '', '2019-06-03 10:42:12');
INSERT INTO `access_log` VALUES (23458, '65.47.15595297416365907', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:22', 0, 1002001015, '账号未登陆', '2019-06-03 10:42:22');
INSERT INTO `access_log` VALUES (23459, '65.46.15595297416375905', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:22', 0, 1002001015, '账号未登陆', '2019-06-03 10:42:22');
INSERT INTO `access_log` VALUES (23460, '65.50.15595297416405907', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:22', 1, 1002001015, '账号未登陆', '2019-06-03 10:42:22');
INSERT INTO `access_log` VALUES (23461, '65.51.15595297448475899', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:42:25');
INSERT INTO `access_log` VALUES (23462, '65.45.15595297492515921', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:29', 75, 0, '', '2019-06-03 10:42:29');
INSERT INTO `access_log` VALUES (23463, '65.52.15595297497255897', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:30', 10, 0, '', '2019-06-03 10:42:30');
INSERT INTO `access_log` VALUES (23464, '65.53.15595297497255877', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:30', 10, 0, '', '2019-06-03 10:42:30');
INSERT INTO `access_log` VALUES (23465, '65.54.15595297497255873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:30', 11, 0, '', '2019-06-03 10:42:30');
INSERT INTO `access_log` VALUES (23466, '62.80.15595297549835963', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:35', 13, 0, '', '2019-06-03 10:42:35');
INSERT INTO `access_log` VALUES (23467, '59.75.15595297633186085', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:43', 11, 0, '', '2019-06-03 10:42:43');
INSERT INTO `access_log` VALUES (23468, '65.45.15595297699545923', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:42:50', 357, 0, '', '2019-06-03 10:42:50');
INSERT INTO `access_log` VALUES (23469, '65.48.15595298879035913', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:44:48', 9, 0, '', '2019-06-03 10:44:48');
INSERT INTO `access_log` VALUES (23470, '65.45.15595298879035925', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:44:48', 10, 0, '', '2019-06-03 10:44:48');
INSERT INTO `access_log` VALUES (23471, '65.51.15595298879185903', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:44:48', 10, 0, '', '2019-06-03 10:44:48');
INSERT INTO `access_log` VALUES (23472, '65.52.15595298880385901', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:44:48', 18, 0, '', '2019-06-03 10:44:48');
INSERT INTO `access_log` VALUES (23473, '65.53.15595298914845881', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:44:51', 668, 0, '', '2019-06-03 10:44:52');
INSERT INTO `access_log` VALUES (23474, '65.46.15595298914965909', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:44:51', 656, 0, '', '2019-06-03 10:44:52');
INSERT INTO `access_log` VALUES (23475, '65.54.15595298914905877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:44:51', 664, 0, '', '2019-06-03 10:44:52');
INSERT INTO `access_log` VALUES (23476, '65.49.15595298916205927', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:44:52', 543, 0, '', '2019-06-03 10:44:52');
INSERT INTO `access_log` VALUES (23477, '65.48.15595298947885915', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:44:55', 343, 0, '', '2019-06-03 10:44:55');
INSERT INTO `access_log` VALUES (23478, '65.47.15595298947855913', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:44:55', 346, 0, '', '2019-06-03 10:44:55');
INSERT INTO `access_log` VALUES (23479, '65.45.15595298947945927', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:44:55', 337, 0, '', '2019-06-03 10:44:55');
INSERT INTO `access_log` VALUES (23480, '65.51.15595298948975905', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:44:55', 244, 0, '', '2019-06-03 10:44:55');
INSERT INTO `access_log` VALUES (23481, '62.81.15595299068075945', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:45:07', 14, 0, '', '2019-06-03 10:45:07');
INSERT INTO `access_log` VALUES (23482, '65.53.15595299112605883', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:45:11', 19, 0, '', '2019-06-03 10:45:11');
INSERT INTO `access_log` VALUES (23483, '59.77.15595299116136079', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:45:12', 435, 0, '', '2019-06-03 10:45:12');
INSERT INTO `access_log` VALUES (23484, '59.80.15595301400226085', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:00', 3, 0, '', '2019-06-03 10:49:00');
INSERT INTO `access_log` VALUES (23485, '59.78.15595301400236093', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:00', 19, 2001001000, '服务端发生异常', '2019-06-03 10:49:00');
INSERT INTO `access_log` VALUES (23486, '64.79.15595301460425657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:06', 2, 0, '', '2019-06-03 10:49:06');
INSERT INTO `access_log` VALUES (23487, '64.77.15595301461785669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:06', 2, 0, '', '2019-06-03 10:49:06');
INSERT INTO `access_log` VALUES (23488, '64.81.15595301474505659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:07', 2, 0, '', '2019-06-03 10:49:07');
INSERT INTO `access_log` VALUES (23489, '59.75.15595301488706091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:09', 3, 0, '', '2019-06-03 10:49:09');
INSERT INTO `access_log` VALUES (23490, '59.77.15595301488726083', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:09', 13, 2001001000, '服务端发生异常', '2019-06-03 10:49:09');
INSERT INTO `access_log` VALUES (23491, '64.85.15595301521895675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:12', 2, 0, '', '2019-06-03 10:49:12');
INSERT INTO `access_log` VALUES (23492, '64.82.15595301523005673', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:12', 2, 0, '', '2019-06-03 10:49:12');
INSERT INTO `access_log` VALUES (23493, '65.53.15595301549145887', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-03 10:49:15', 3, 1002001012, '访问令牌已过期', '2019-06-03 10:49:15');
INSERT INTO `access_log` VALUES (23494, '65.52.15595301549145907', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-03 10:49:15', 4, 1002001012, '访问令牌已过期', '2019-06-03 10:49:15');
INSERT INTO `access_log` VALUES (23495, '65.54.15595301549165883', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-03 10:49:15', 3, 1002001012, '访问令牌已过期', '2019-06-03 10:49:15');
INSERT INTO `access_log` VALUES (23496, '65.46.15595301565555915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-03 10:49:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:49:17');
INSERT INTO `access_log` VALUES (23497, '64.84.15595301567465669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:17', 2, 0, '', '2019-06-03 10:49:17');
INSERT INTO `access_log` VALUES (23498, '64.83.15595301568575659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:17', 2, 0, '', '2019-06-03 10:49:17');
INSERT INTO `access_log` VALUES (23499, '65.50.15595301743435919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-03 10:49:34', 211, 0, '', '2019-06-03 10:49:35');
INSERT INTO `access_log` VALUES (23500, '65.48.15595301747345919', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-03 10:49:35', 10, 0, '', '2019-06-03 10:49:35');
INSERT INTO `access_log` VALUES (23501, '65.45.15595301747365933', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-03 10:49:35', 9, 0, '', '2019-06-03 10:49:35');
INSERT INTO `access_log` VALUES (23502, '65.47.15595301747345919', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-03 10:49:35', 10, 0, '', '2019-06-03 10:49:35');
INSERT INTO `access_log` VALUES (23503, '64.76.15595301773075655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:37', 2, 0, '', '2019-06-03 10:49:37');
INSERT INTO `access_log` VALUES (23504, '64.79.15595301775385659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:38', 2, 0, '', '2019-06-03 10:49:38');
INSERT INTO `access_log` VALUES (23505, '64.81.15595301784465661', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-03 10:49:38', 168, 0, '', '2019-06-03 10:49:39');
INSERT INTO `access_log` VALUES (23506, '64.77.15595301784435671', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-03 10:49:38', 174, 0, '', '2019-06-03 10:49:39');
INSERT INTO `access_log` VALUES (23507, '64.85.15595301790415677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:39', 2, 0, '', '2019-06-03 10:49:39');
INSERT INTO `access_log` VALUES (23508, '64.82.15595301794625675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:39', 2, 0, '', '2019-06-03 10:49:39');
INSERT INTO `access_log` VALUES (23509, '64.84.15595301801725671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:40', 1, 0, '', '2019-06-03 10:49:40');
INSERT INTO `access_log` VALUES (23510, '59.79.15595301813776091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:41', 3, 0, '', '2019-06-03 10:49:41');
INSERT INTO `access_log` VALUES (23511, '59.71.15595301813796095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:66.0) Gecko/20100101 Firefox/66.0', '121.35.182.71', '2019-06-03 10:49:41', 19, 2001001000, '服务端发生异常', '2019-06-03 10:49:41');
INSERT INTO `access_log` VALUES (23512, '62.80.15595304034435973', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 10:53:23', 14, 0, '', '2019-06-03 10:53:23');
INSERT INTO `access_log` VALUES (23513, '65.52.15595304707155911', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.173.250', '2019-06-03 10:54:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:54:31');
INSERT INTO `access_log` VALUES (23514, '59.74.15595305689046093', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 10:56:09', 4, 0, '', '2019-06-03 10:56:09');
INSERT INTO `access_log` VALUES (23515, '59.76.15595305689076091', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 10:56:09', 13, 2001001000, '服务端发生异常', '2019-06-03 10:56:09');
INSERT INTO `access_log` VALUES (23516, '64.79.15595305726825667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 10:56:13', 2, 0, '', '2019-06-03 10:56:13');
INSERT INTO `access_log` VALUES (23517, '64.77.15595305727915679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 10:56:13', 2, 0, '', '2019-06-03 10:56:13');
INSERT INTO `access_log` VALUES (23518, '64.81.15595305741175667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 10:56:14', 25, 0, '', '2019-06-03 10:56:14');
INSERT INTO `access_log` VALUES (23519, '64.85.15595305747205685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 10:56:15', 2, 0, '', '2019-06-03 10:56:15');
INSERT INTO `access_log` VALUES (23520, '59.79.15595305761676097', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 10:56:16', 3, 0, '', '2019-06-03 10:56:16');
INSERT INTO `access_log` VALUES (23521, '59.71.15595305761686101', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 10:56:16', 13, 2001001000, '服务端发生异常', '2019-06-03 10:56:16');
INSERT INTO `access_log` VALUES (23522, '65.52.15595306088095913', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:56:49', 0, 1002001015, '账号未登陆', '2019-06-03 10:56:49');
INSERT INTO `access_log` VALUES (23523, '65.46.15595306088115921', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:56:49', 1, 1002001015, '账号未登陆', '2019-06-03 10:56:49');
INSERT INTO `access_log` VALUES (23524, '65.49.15595306088165941', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:56:49', 0, 1002001015, '账号未登陆', '2019-06-03 10:56:49');
INSERT INTO `access_log` VALUES (23525, '65.51.15595306650725919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:57:45', 85, 0, '', '2019-06-03 10:57:45');
INSERT INTO `access_log` VALUES (23526, '65.53.15595306654495897', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:57:45', 18, 0, '', '2019-06-03 10:57:45');
INSERT INTO `access_log` VALUES (23527, '65.54.15595306654535891', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:57:45', 17, 0, '', '2019-06-03 10:57:45');
INSERT INTO `access_log` VALUES (23528, '65.52.15595306654635915', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:57:45', 9, 0, '', '2019-06-03 10:57:45');
INSERT INTO `access_log` VALUES (23529, '65.46.15595306682155923', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '223.167.152.70', '2019-06-03 10:57:48', 1, 1002001015, '账号未登陆', '2019-06-03 10:57:48');
INSERT INTO `access_log` VALUES (23530, '65.49.15595306695285943', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '58.246.221.61', '2019-06-03 10:57:50', 1, 1002001015, '账号未登陆', '2019-06-03 10:57:50');
INSERT INTO `access_log` VALUES (23531, '65.50.15595306717385929', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.237.218', '2019-06-03 10:57:52', 1, 1002001015, '账号未登陆', '2019-06-03 10:57:52');
INSERT INTO `access_log` VALUES (23532, '65.48.15595306717555929', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.237.218', '2019-06-03 10:57:52', 0, 1002001015, '账号未登陆', '2019-06-03 10:57:52');
INSERT INTO `access_log` VALUES (23533, '65.45.15595306717665943', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.237.218', '2019-06-03 10:57:52', 0, 1002001015, '账号未登陆', '2019-06-03 10:57:52');
INSERT INTO `access_log` VALUES (23534, '62.83.15595306757375971', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:57:56', 175, 0, '', '2019-06-03 10:57:56');
INSERT INTO `access_log` VALUES (23535, '65.51.15595306830065921', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.237.218', '2019-06-03 10:58:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:58:03');
INSERT INTO `access_log` VALUES (23536, '62.88.15595306934715981', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:58:13', 19, 0, '', '2019-06-03 10:58:13');
INSERT INTO `access_log` VALUES (23537, '64.81.15595306998885669', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:58:20', 13, 0, '', '2019-06-03 10:58:20');
INSERT INTO `access_log` VALUES (23538, '64.85.15595306998935687', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:58:20', 9, 0, '', '2019-06-03 10:58:20');
INSERT INTO `access_log` VALUES (23539, '65.52.15595307096125917', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '116.128.128.79', '2019-06-03 10:58:30', 1, 1002001015, '账号未登陆', '2019-06-03 10:58:30');
INSERT INTO `access_log` VALUES (23540, '65.46.15595307135055925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.237.218', '2019-06-03 10:58:34', 85, 0, '', '2019-06-03 10:58:34');
INSERT INTO `access_log` VALUES (23541, '65.50.15595307140505931', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.237.218', '2019-06-03 10:58:34', 132, 0, '', '2019-06-03 10:58:34');
INSERT INTO `access_log` VALUES (23542, '65.49.15595307140435945', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.237.218', '2019-06-03 10:58:34', 216, 0, '', '2019-06-03 10:58:34');
INSERT INTO `access_log` VALUES (23543, '65.48.15595307140595931', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.237.218', '2019-06-03 10:58:34', 207, 0, '', '2019-06-03 10:58:34');
INSERT INTO `access_log` VALUES (23544, '62.84.15595307229635961', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.237.218', '2019-06-03 10:58:43', 13, 0, '', '2019-06-03 10:58:43');
INSERT INTO `access_log` VALUES (23545, '59.73.15595307289166103', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.237.218', '2019-06-03 10:58:49', 12, 0, '', '2019-06-03 10:58:49');
INSERT INTO `access_log` VALUES (23546, '65.47.15595307315195931', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.237.218', '2019-06-03 10:58:52', 18, 0, '', '2019-06-03 10:58:52');
INSERT INTO `access_log` VALUES (23547, '65.54.15595307349835895', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 10:58:55', 1, 1002001015, '账号未登陆', '2019-06-03 10:58:55');
INSERT INTO `access_log` VALUES (23548, '65.53.15595307349905901', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 10:58:55', 0, 1002001015, '账号未登陆', '2019-06-03 10:58:55');
INSERT INTO `access_log` VALUES (23549, '62.89.15595307350985975', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '223.166.151.197', '2019-06-03 10:58:55', 1, 1002001015, '账号未登陆', '2019-06-03 10:58:55');
INSERT INTO `access_log` VALUES (23550, '65.52.15595307370745919', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 10:58:57', 0, 1002001015, '账号未登陆', '2019-06-03 10:58:57');
INSERT INTO `access_log` VALUES (23551, '66.49.15595307450104823', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:59:05', 469, 0, '', '2019-06-03 10:59:05');
INSERT INTO `access_log` VALUES (23552, '65.46.15595307470725927', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 10:59:07', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:59:07');
INSERT INTO `access_log` VALUES (23553, '59.72.15595307530996097', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:59:13', 12, 0, '', '2019-06-03 10:59:13');
INSERT INTO `access_log` VALUES (23554, '62.88.15595307553395983', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '58.246.221.162', '2019-06-03 10:59:15', 1, 1002001015, '账号未登陆', '2019-06-03 10:59:15');
INSERT INTO `access_log` VALUES (23555, '65.49.15595307570945947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 10:59:17', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 10:59:17');
INSERT INTO `access_log` VALUES (23556, '59.77.15595307592476093', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:59:19', 20, 2001001000, '服务端发生异常', '2019-06-03 10:59:19');
INSERT INTO `access_log` VALUES (23557, '64.76.15595307601045667', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '58.247.204.63', '2019-06-03 10:59:20', 1, 1002001015, '账号未登陆', '2019-06-03 10:59:20');
INSERT INTO `access_log` VALUES (23558, '59.76.15595307629946095', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:59:23', 88, 0, '', '2019-06-03 10:59:23');
INSERT INTO `access_log` VALUES (23559, '65.45.15595307674875947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 10:59:27', 96, 0, '', '2019-06-03 10:59:28');
INSERT INTO `access_log` VALUES (23560, '64.79.15595307681695671', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:59:28', 9, 0, '', '2019-06-03 10:59:28');
INSERT INTO `access_log` VALUES (23561, '65.47.15595307690605933', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 10:59:29', 8, 0, '', '2019-06-03 10:59:29');
INSERT INTO `access_log` VALUES (23562, '65.51.15595307690615925', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 10:59:29', 7, 0, '', '2019-06-03 10:59:29');
INSERT INTO `access_log` VALUES (23563, '65.53.15595307692875903', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 10:59:29', 17, 0, '', '2019-06-03 10:59:29');
INSERT INTO `access_log` VALUES (23564, '64.81.15595307762235671', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:59:36', 9, 0, '', '2019-06-03 10:59:36');
INSERT INTO `access_log` VALUES (23565, '62.84.15595307772515963', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 10:59:37', 12, 0, '', '2019-06-03 10:59:37');
INSERT INTO `access_log` VALUES (23566, '59.79.15595307787146101', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:59:39', 11, 0, '', '2019-06-03 10:59:39');
INSERT INTO `access_log` VALUES (23567, '59.71.15595307816306105', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:59:42', 11, 0, '', '2019-06-03 10:59:42');
INSERT INTO `access_log` VALUES (23568, '59.73.15595307822026105', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:59:42', 9, 0, '', '2019-06-03 10:59:42');
INSERT INTO `access_log` VALUES (23569, '62.85.15595307841895979', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 10:59:44', 14, 0, '', '2019-06-03 10:59:44');
INSERT INTO `access_log` VALUES (23570, '65.52.15595307881215921', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:59:48', 19, 0, '', '2019-06-03 10:59:48');
INSERT INTO `access_log` VALUES (23571, '65.46.15595307892645929', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:59:49', 8, 0, '', '2019-06-03 10:59:49');
INSERT INTO `access_log` VALUES (23572, '65.50.15595307904425935', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:59:50', 18, 0, '', '2019-06-03 10:59:50');
INSERT INTO `access_log` VALUES (23573, '64.84.15595307912715681', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 10:59:51', 74, 0, '', '2019-06-03 10:59:51');
INSERT INTO `access_log` VALUES (23574, '64.82.15595307912665687', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 10:59:51', 81, 0, '', '2019-06-03 10:59:51');
INSERT INTO `access_log` VALUES (23575, '65.48.15595307992685935', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 10:59:59', 10, 0, '', '2019-06-03 10:59:59');
INSERT INTO `access_log` VALUES (23576, '64.80.15595308030265669', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 11:00:03', 8, 0, '', '2019-06-03 11:00:03');
INSERT INTO `access_log` VALUES (23577, '64.83.15595308030275671', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 11:00:03', 56, 0, '', '2019-06-03 11:00:03');
INSERT INTO `access_log` VALUES (23578, '66.55.15595308050584835', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '223.166.151.197', '2019-06-03 11:00:05', 1, 1002001015, '账号未登陆', '2019-06-03 11:00:05');
INSERT INTO `access_log` VALUES (23579, '65.45.15595308063975949', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:00:06', 13, 0, '', '2019-06-03 11:00:06');
INSERT INTO `access_log` VALUES (23580, '64.77.15595308072005685', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 11:00:07', 9, 0, '', '2019-06-03 11:00:07');
INSERT INTO `access_log` VALUES (23581, '64.78.15595308071995683', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 11:00:07', 89, 0, '', '2019-06-03 11:00:07');
INSERT INTO `access_log` VALUES (23582, '64.79.15595308071995673', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 11:00:07', 91, 0, '', '2019-06-03 11:00:07');
INSERT INTO `access_log` VALUES (23583, '66.50.15595308172954829', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 11:00:17', 1173, 0, '', '2019-06-03 11:00:18');
INSERT INTO `access_log` VALUES (23584, '65.47.15595308185215935', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:00:19', 9, 0, '', '2019-06-03 11:00:19');
INSERT INTO `access_log` VALUES (23585, '59.75.15595308196616103', 0, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '223.167.152.70', '2019-06-03 11:00:20', 1, 1002001015, '账号未登陆', '2019-06-03 11:00:20');
INSERT INTO `access_log` VALUES (23586, '59.77.15595308207176095', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 11:00:21', 10, 0, '', '2019-06-03 11:00:21');
INSERT INTO `access_log` VALUES (23587, '59.76.15595308230796097', 0, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '58.246.221.162', '2019-06-03 11:00:23', 0, 1002001015, '账号未登陆', '2019-06-03 11:00:23');
INSERT INTO `access_log` VALUES (23588, '59.74.15595308265006099', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '223.166.151.191', '2019-06-03 11:00:27', 1, 1002001015, '账号未登陆', '2019-06-03 11:00:27');
INSERT INTO `access_log` VALUES (23589, '59.79.15595308272236103', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 11:00:27', 12, 0, '', '2019-06-03 11:00:27');
INSERT INTO `access_log` VALUES (23590, '65.54.15595308292715899', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 11:00:29', 11, 0, '', '2019-06-03 11:00:29');
INSERT INTO `access_log` VALUES (23591, '65.52.15595308306285923', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.68.65.196', '2019-06-03 11:00:31', 12, 0, '', '2019-06-03 11:00:31');
INSERT INTO `access_log` VALUES (23592, '59.73.15595308382536107', 0, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '223.166.151.197', '2019-06-03 11:00:38', 0, 1002001015, '账号未登陆', '2019-06-03 11:00:38');
INSERT INTO `access_log` VALUES (23593, '65.48.15595308713325937', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:01:11', 10, 0, '', '2019-06-03 11:01:11');
INSERT INTO `access_log` VALUES (23594, '65.45.15595308723105951', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:01:12', 21, 0, '', '2019-06-03 11:01:12');
INSERT INTO `access_log` VALUES (23595, '65.51.15595308725415929', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:01:13', 9, 0, '', '2019-06-03 11:01:13');
INSERT INTO `access_log` VALUES (23596, '65.47.15595308727595937', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:01:13', 18, 0, '', '2019-06-03 11:01:13');
INSERT INTO `access_log` VALUES (23597, '59.72.15595308729826101', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:01:13', 11, 0, '', '2019-06-03 11:01:13');
INSERT INTO `access_log` VALUES (23598, '59.75.15595308731876105', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:01:13', 10, 0, '', '2019-06-03 11:01:13');
INSERT INTO `access_log` VALUES (23599, '59.77.15595308738396097', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:01:14', 32, 2001001000, '服务端发生异常', '2019-06-03 11:01:14');
INSERT INTO `access_log` VALUES (23600, '59.76.15595308743096099', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:01:14', 11, 0, '', '2019-06-03 11:01:14');
INSERT INTO `access_log` VALUES (23601, '66.48.15595308746974831', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:01:15', 13, 0, '', '2019-06-03 11:01:15');
INSERT INTO `access_log` VALUES (23602, '65.53.15595308782145907', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '58.247.204.63', '2019-06-03 11:01:18', 1, 1002001015, '账号未登陆', '2019-06-03 11:01:18');
INSERT INTO `access_log` VALUES (23603, '59.71.15595308952776109', 0, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '223.167.152.53', '2019-06-03 11:01:35', 1, 1002001015, '账号未登陆', '2019-06-03 11:01:35');
INSERT INTO `access_log` VALUES (23604, '64.76.15595309029925671', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '223.166.151.197', '2019-06-03 11:01:43', 1, 1002001015, '账号未登陆', '2019-06-03 11:01:43');
INSERT INTO `access_log` VALUES (23605, '59.74.15595310006566103', 0, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '223.167.152.53', '2019-06-03 11:03:21', 0, 1002001015, '账号未登陆', '2019-06-03 11:03:21');
INSERT INTO `access_log` VALUES (23606, '65.53.15595310111925909', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '58.246.221.163', '2019-06-03 11:03:31', 0, 1002001015, '账号未登陆', '2019-06-03 11:03:31');
INSERT INTO `access_log` VALUES (23607, '65.52.15595310275285927', 0, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '223.166.151.199', '2019-06-03 11:03:48', 1, 1002001015, '账号未登陆', '2019-06-03 11:03:48');
INSERT INTO `access_log` VALUES (23608, '64.79.15595315230125683', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 11:12:03', 8, 1002001012, '访问令牌已过期', '2019-06-03 11:12:03');
INSERT INTO `access_log` VALUES (23609, '64.78.15595315230125693', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 11:12:03', 8, 1002001012, '访问令牌已过期', '2019-06-03 11:12:03');
INSERT INTO `access_log` VALUES (23610, '65.47.15595315256635947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.172.7.33', '2019-06-03 11:12:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 11:12:06');
INSERT INTO `access_log` VALUES (23611, '59.80.15595317924226113', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:16:32', 3, 0, '', '2019-06-03 11:16:32');
INSERT INTO `access_log` VALUES (23612, '59.73.15595317924226121', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:16:32', 13, 2001001000, '服务端发生异常', '2019-06-03 11:16:32');
INSERT INTO `access_log` VALUES (23613, '64.79.15595317953965687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:16:35', 3, 0, '', '2019-06-03 11:16:35');
INSERT INTO `access_log` VALUES (23614, '64.81.15595317956655687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:16:36', 2, 0, '', '2019-06-03 11:16:36');
INSERT INTO `access_log` VALUES (23615, '65.46.15595318000305945', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 11:16:40', 1, 1002001015, '账号未登陆', '2019-06-03 11:16:40');
INSERT INTO `access_log` VALUES (23616, '65.53.15595318000305923', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 11:16:40', 1, 1002001015, '账号未登陆', '2019-06-03 11:16:40');
INSERT INTO `access_log` VALUES (23617, '65.54.15595318000335919', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 11:16:40', 0, 1002001015, '账号未登陆', '2019-06-03 11:16:40');
INSERT INTO `access_log` VALUES (23618, '65.50.15595318103275955', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 11:16:50', 146, 0, '', '2019-06-03 11:16:50');
INSERT INTO `access_log` VALUES (23619, '65.48.15595318107355953', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 11:16:51', 10, 0, '', '2019-06-03 11:16:51');
INSERT INTO `access_log` VALUES (23620, '65.51.15595318107375945', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 11:16:51', 10, 0, '', '2019-06-03 11:16:51');
INSERT INTO `access_log` VALUES (23621, '65.45.15595318107415969', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 11:16:51', 9, 0, '', '2019-06-03 11:16:51');
INSERT INTO `access_log` VALUES (23622, '64.84.15595318168475697', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 11:16:57', 12, 0, '', '2019-06-03 11:16:57');
INSERT INTO `access_log` VALUES (23623, '64.82.15595318168535703', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 11:16:57', 9, 0, '', '2019-06-03 11:16:57');
INSERT INTO `access_log` VALUES (23624, '64.80.15595318183065685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:16:58', 2, 0, '', '2019-06-03 11:16:58');
INSERT INTO `access_log` VALUES (23625, '64.83.15595318185855687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:16:59', 2, 0, '', '2019-06-03 11:16:59');
INSERT INTO `access_log` VALUES (23626, '64.76.15595318219935685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:02', 2, 0, '', '2019-06-03 11:17:02');
INSERT INTO `access_log` VALUES (23627, '64.77.15595318222275701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:02', 2, 0, '', '2019-06-03 11:17:02');
INSERT INTO `access_log` VALUES (23628, '64.78.15595318227615699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:03', 2, 0, '', '2019-06-03 11:17:03');
INSERT INTO `access_log` VALUES (23629, '64.79.15595318233325689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:03', 2, 0, '', '2019-06-03 11:17:03');
INSERT INTO `access_log` VALUES (23630, '64.81.15595318235375689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:04', 2, 0, '', '2019-06-03 11:17:04');
INSERT INTO `access_log` VALUES (23631, '59.76.15595318245726113', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:05', 13, 2001001000, '服务端发生异常', '2019-06-03 11:17:05');
INSERT INTO `access_log` VALUES (23632, '59.77.15595318245716111', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:05', 183, 0, '', '2019-06-03 11:17:05');
INSERT INTO `access_log` VALUES (23633, '64.84.15595318277985699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:08', 2, 0, '', '2019-06-03 11:17:08');
INSERT INTO `access_log` VALUES (23634, '64.82.15595318278945705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:08', 2, 0, '', '2019-06-03 11:17:08');
INSERT INTO `access_log` VALUES (23635, '65.53.15595318451655925', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:25', 0, 1002001015, '账号未登陆', '2019-06-03 11:17:25');
INSERT INTO `access_log` VALUES (23636, '65.46.15595318451695947', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:25', 0, 1002001015, '账号未登陆', '2019-06-03 11:17:25');
INSERT INTO `access_log` VALUES (23637, '65.54.15595318451725921', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:25', 0, 1002001015, '账号未登陆', '2019-06-03 11:17:25');
INSERT INTO `access_log` VALUES (23638, '65.50.15595318492045957', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 11:17:29');
INSERT INTO `access_log` VALUES (23639, '65.45.15595318532085971', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:33', 51, 0, '', '2019-06-03 11:17:33');
INSERT INTO `access_log` VALUES (23640, '65.51.15595318535225947', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:34', 8, 0, '', '2019-06-03 11:17:34');
INSERT INTO `access_log` VALUES (23641, '65.48.15595318535225955', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:34', 7, 0, '', '2019-06-03 11:17:34');
INSERT INTO `access_log` VALUES (23642, '65.49.15595318535305971', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:34', 8, 0, '', '2019-06-03 11:17:34');
INSERT INTO `access_log` VALUES (23643, '62.87.15595318577686005', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:38', 16, 0, '', '2019-06-03 11:17:38');
INSERT INTO `access_log` VALUES (23644, '59.71.15595318615246123', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.75', '2019-06-03 11:17:42', 138, 2001001000, '服务端发生异常', '2019-06-03 11:17:42');
INSERT INTO `access_log` VALUES (23645, '65.54.15595320364795925', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:20:36', 4, 1002001012, '访问令牌已过期', '2019-06-03 11:20:36');
INSERT INTO `access_log` VALUES (23646, '65.53.15595320364835929', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:20:36', 3, 1002001012, '访问令牌已过期', '2019-06-03 11:20:36');
INSERT INTO `access_log` VALUES (23647, '65.46.15595320364885951', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:20:36', 4, 1002001012, '访问令牌已过期', '2019-06-03 11:20:36');
INSERT INTO `access_log` VALUES (23648, '65.45.15595320398595975', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:20:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 11:20:40');
INSERT INTO `access_log` VALUES (23649, '65.49.15595320449165975', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:20:45', 81, 0, '', '2019-06-03 11:20:45');
INSERT INTO `access_log` VALUES (23650, '65.51.15595320452365951', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:20:45', 10, 0, '', '2019-06-03 11:20:45');
INSERT INTO `access_log` VALUES (23651, '65.48.15595320452425959', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:20:45', 10, 0, '', '2019-06-03 11:20:45');
INSERT INTO `access_log` VALUES (23652, '65.52.15595320452445947', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:20:45', 9, 0, '', '2019-06-03 11:20:45');
INSERT INTO `access_log` VALUES (23653, '62.89.15595320517386001', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:20:52', 14, 0, '', '2019-06-03 11:20:52');
INSERT INTO `access_log` VALUES (23654, '64.79.15595320608005693', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:21:01', 10, 0, '', '2019-06-03 11:21:01');
INSERT INTO `access_log` VALUES (23655, '64.81.15595320608025693', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:21:01', 10, 0, '', '2019-06-03 11:21:01');
INSERT INTO `access_log` VALUES (23656, '64.84.15595320677765703', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name= ', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 11:21:08', 7, 1002002009, NULL, '2019-06-03 11:21:08');
INSERT INTO `access_log` VALUES (23657, '65.54.15595320713135927', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:21:11', 19, 0, '', '2019-06-03 11:21:11');
INSERT INTO `access_log` VALUES (23658, '65.46.15595320753335953', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:21:15', 11, 0, '', '2019-06-03 11:21:15');
INSERT INTO `access_log` VALUES (23659, '65.50.15595320780755963', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:21:18', 8, 0, '', '2019-06-03 11:21:18');
INSERT INTO `access_log` VALUES (23660, '65.45.15595320797615977', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:21:20', 13, 0, '', '2019-06-03 11:21:20');
INSERT INTO `access_log` VALUES (23661, '65.48.15595320840245961', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:21:24', 7, 0, '', '2019-06-03 11:21:24');
INSERT INTO `access_log` VALUES (23662, '65.51.15595320874795953', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:21:27', 14, 0, '', '2019-06-03 11:21:27');
INSERT INTO `access_log` VALUES (23663, '59.76.15595320900666117', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:21:30', 12, 0, '', '2019-06-03 11:21:30');
INSERT INTO `access_log` VALUES (23664, '59.74.15595320993566119', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:21:39', 21, 2001001000, '服务端发生异常', '2019-06-03 11:21:39');
INSERT INTO `access_log` VALUES (23665, '59.79.15595321079806123', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:21:48', 12, 0, '', '2019-06-03 11:21:48');
INSERT INTO `access_log` VALUES (23666, '64.83.15595321101655693', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:21:50', 480, 0, '', '2019-06-03 11:21:51');
INSERT INTO `access_log` VALUES (23667, '65.50.15595321526055965', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:22:33', 16, 0, '', '2019-06-03 11:22:33');
INSERT INTO `access_log` VALUES (23668, '65.46.15595321526035955', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:22:33', 18, 0, '', '2019-06-03 11:22:33');
INSERT INTO `access_log` VALUES (23669, '65.45.15595321526175979', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:22:33', 8, 0, '', '2019-06-03 11:22:33');
INSERT INTO `access_log` VALUES (23670, '65.49.15595321526785979', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:22:33', 28, 0, '', '2019-06-03 11:22:33');
INSERT INTO `access_log` VALUES (23671, '59.72.15595321566216121', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:22:37', 12, 0, '', '2019-06-03 11:22:37');
INSERT INTO `access_log` VALUES (23672, '64.81.15595321649975695', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:22:45', 9, 0, '', '2019-06-03 11:22:45');
INSERT INTO `access_log` VALUES (23673, '64.84.15595321721715705', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:22:52', 9, 0, '', '2019-06-03 11:22:52');
INSERT INTO `access_log` VALUES (23674, '59.77.15595321884876117', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:23:08', 12, 0, '', '2019-06-03 11:23:09');
INSERT INTO `access_log` VALUES (23675, '59.74.15595321907666121', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:23:11', 20, 2001001000, '服务端发生异常', '2019-06-03 11:23:11');
INSERT INTO `access_log` VALUES (23676, '59.79.15595321952486125', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:23:15', 12, 0, '', '2019-06-03 11:23:15');
INSERT INTO `access_log` VALUES (23677, '64.76.15595322125705693', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:23:33', 10, 0, '', '2019-06-03 11:23:33');
INSERT INTO `access_log` VALUES (23678, '64.78.15595322451555707', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:24:05', 8, 0, '', '2019-06-03 11:24:05');
INSERT INTO `access_log` VALUES (23679, '65.46.15595322641205957', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:24:24', 10, 0, '', '2019-06-03 11:24:24');
INSERT INTO `access_log` VALUES (23680, '65.48.15595322641385965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:24:24', 9, 0, '', '2019-06-03 11:24:24');
INSERT INTO `access_log` VALUES (23681, '65.49.15595322641385981', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.67.104', '2019-06-03 11:24:24', 10, 0, '', '2019-06-03 11:24:24');
INSERT INTO `access_log` VALUES (23682, '59.74.15595330590686133', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.52.42.83', '2019-06-03 11:37:39', 3, 0, '', '2019-06-03 11:37:39');
INSERT INTO `access_log` VALUES (23683, '59.79.15595330590696137', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.52.42.83', '2019-06-03 11:37:39', 14, 2001001000, '服务端发生异常', '2019-06-03 11:37:39');
INSERT INTO `access_log` VALUES (23684, '64.80.15595330693905705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:37:49', 3, 0, '', '2019-06-03 11:37:49');
INSERT INTO `access_log` VALUES (23685, '64.76.15595330694925705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:37:49', 2, 0, '', '2019-06-03 11:37:49');
INSERT INTO `access_log` VALUES (23686, '64.77.15595330709225721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:37:51', 3, 0, '', '2019-06-03 11:37:51');
INSERT INTO `access_log` VALUES (23687, '64.78.15595330718095719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:37:52', 2, 0, '', '2019-06-03 11:37:52');
INSERT INTO `access_log` VALUES (23688, '64.79.15595330727955709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:37:53', 2, 0, '', '2019-06-03 11:37:53');
INSERT INTO `access_log` VALUES (23689, '64.81.15595330737615709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:37:54', 2, 0, '', '2019-06-03 11:37:54');
INSERT INTO `access_log` VALUES (23690, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:37:54', 15, 0, '', '2019-06-03 11:37:54');
INSERT INTO `access_log` VALUES (23691, '64.85.15595330755145727', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:37:56', 8, 0, '', '2019-06-03 11:37:56');
INSERT INTO `access_log` VALUES (23692, '64.82.15595330861405725', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:38:06', 6, 0, '', '2019-06-03 11:38:06');
INSERT INTO `access_log` VALUES (23693, '64.80.15595330894065707', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:38:09', 3, 0, '', '2019-06-03 11:38:09');
INSERT INTO `access_log` VALUES (23694, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:38:09', 7, 0, '', '2019-06-03 11:38:09');
INSERT INTO `access_log` VALUES (23695, '64.76.15595330906175707', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:38:11', 2, 0, '', '2019-06-03 11:38:11');
INSERT INTO `access_log` VALUES (23696, '64.83.15595330907505709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:38:11', 1, 0, '', '2019-06-03 11:38:11');
INSERT INTO `access_log` VALUES (23697, '59.80.15595330925736133', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:38:13', 2, 0, '', '2019-06-03 11:38:13');
INSERT INTO `access_log` VALUES (23698, '59.78.15595330925736141', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:38:13', 10, 2001001000, '服务端发生异常', '2019-06-03 11:38:13');
INSERT INTO `access_log` VALUES (23699, '64.78.15595331078685721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:38:28', 2, 0, '', '2019-06-03 11:38:28');
INSERT INTO `access_log` VALUES (23700, '64.79.15595331080125711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:38:28', 1, 0, '', '2019-06-03 11:38:28');
INSERT INTO `access_log` VALUES (23701, '59.76.15595331088656133', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:38:29', 3, 0, '', '2019-06-03 11:38:29');
INSERT INTO `access_log` VALUES (23702, '59.75.15595331088656139', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.52.42.83', '2019-06-03 11:38:29', 13, 2001001000, '服务端发生异常', '2019-06-03 11:38:29');
INSERT INTO `access_log` VALUES (23703, '65.52.15595333094505967', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:41:49', 9, 0, '', '2019-06-03 11:41:49');
INSERT INTO `access_log` VALUES (23704, '65.51.15595333094485971', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:41:49', 10, 0, '', '2019-06-03 11:41:49');
INSERT INTO `access_log` VALUES (23705, '65.49.15595333094485995', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:41:49', 11, 0, '', '2019-06-03 11:41:49');
INSERT INTO `access_log` VALUES (23706, '64.76.15595333146815711', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:41:55', 771, 0, '', '2019-06-03 11:41:55');
INSERT INTO `access_log` VALUES (23707, '64.80.15595333146755711', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:41:55', 945, 0, '', '2019-06-03 11:41:56');
INSERT INTO `access_log` VALUES (23708, '64.77.15595333238575727', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:42:04', 7, 0, '', '2019-06-03 11:42:04');
INSERT INTO `access_log` VALUES (23709, '64.83.15595333238545713', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:42:04', 12, 0, '', '2019-06-03 11:42:04');
INSERT INTO `access_log` VALUES (23710, '59.78.15595333276856145', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:08', 3, 0, '', '2019-06-03 11:42:08');
INSERT INTO `access_log` VALUES (23711, '59.80.15595333278006137', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:08', 13, 2001001000, '服务端发生异常', '2019-06-03 11:42:08');
INSERT INTO `access_log` VALUES (23712, '64.79.15595333286825715', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:42:09', 11, 0, '', '2019-06-03 11:42:09');
INSERT INTO `access_log` VALUES (23713, '64.81.15595333302675715', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:42:10', 13, 0, '', '2019-06-03 11:42:10');
INSERT INTO `access_log` VALUES (23714, '64.85.15595333302735733', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:42:10', 15, 0, '', '2019-06-03 11:42:10');
INSERT INTO `access_log` VALUES (23715, '64.84.15595333303055725', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:42:10', 8, 0, '', '2019-06-03 11:42:10');
INSERT INTO `access_log` VALUES (23716, '65.54.15595333368815947', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:17', 0, 1002001015, '账号未登陆', '2019-06-03 11:42:17');
INSERT INTO `access_log` VALUES (23717, '65.50.15595333369235983', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:17', 0, 1002001015, '账号未登陆', '2019-06-03 11:42:17');
INSERT INTO `access_log` VALUES (23718, '65.45.15595333369375997', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:17', 0, 1002001015, '账号未登陆', '2019-06-03 11:42:17');
INSERT INTO `access_log` VALUES (23719, '65.46.15595333412565973', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 11:42:21');
INSERT INTO `access_log` VALUES (23720, '65.49.15595333464575997', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:26', 111, 0, '', '2019-06-03 11:42:27');
INSERT INTO `access_log` VALUES (23721, '65.51.15595333468415973', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:27', 9, 0, '', '2019-06-03 11:42:27');
INSERT INTO `access_log` VALUES (23722, '65.52.15595333469095969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:27', 9, 0, '', '2019-06-03 11:42:27');
INSERT INTO `access_log` VALUES (23723, '65.47.15595333469505983', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:27', 10, 0, '', '2019-06-03 11:42:27');
INSERT INTO `access_log` VALUES (23724, '65.53.15595333527235953', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:42:33', 27, 0, '', '2019-06-03 11:42:33');
INSERT INTO `access_log` VALUES (23725, '62.84.15595333531066005', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:33', 13, 0, '', '2019-06-03 11:42:33');
INSERT INTO `access_log` VALUES (23726, '62.86.15595333588076007', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:39', 17, 0, '', '2019-06-03 11:42:39');
INSERT INTO `access_log` VALUES (23727, '62.89.15595333617156019', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:42', 12, 0, '', '2019-06-03 11:42:42');
INSERT INTO `access_log` VALUES (23728, '64.80.15595333664915713', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:46', 10, 0, '', '2019-06-03 11:42:47');
INSERT INTO `access_log` VALUES (23729, '64.83.15595333664945715', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:46', 8, 0, '', '2019-06-03 11:42:47');
INSERT INTO `access_log` VALUES (23730, '64.78.15595333691795727', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:49', 8, 0, '', '2019-06-03 11:42:49');
INSERT INTO `access_log` VALUES (23731, '64.77.15595333691785729', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:49', 10, 0, '', '2019-06-03 11:42:49');
INSERT INTO `access_log` VALUES (23732, '64.81.15595333750585717', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:42:55', 8, 0, '', '2019-06-03 11:42:55');
INSERT INTO `access_log` VALUES (23733, '66.49.15595333854444859', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:43:05', 21, 0, '', '2019-06-03 11:43:05');
INSERT INTO `access_log` VALUES (23734, '59.79.15595333880346143', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:43:08', 11, 0, '', '2019-06-03 11:43:08');
INSERT INTO `access_log` VALUES (23735, '59.74.15595333892796139', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '210.22.245.226', '2019-06-03 11:43:09', 14, 2001001000, '服务端发生异常', '2019-06-03 11:43:09');
INSERT INTO `access_log` VALUES (23736, '59.71.15595333914486147', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:43:11', 20, 2001001000, '服务端发生异常', '2019-06-03 11:43:11');
INSERT INTO `access_log` VALUES (23737, '59.73.15595333932536147', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:43:13', 10, 0, '', '2019-06-03 11:43:13');
INSERT INTO `access_log` VALUES (23738, '59.78.15595333973596147', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:43:17', 12, 0, '', '2019-06-03 11:43:17');
INSERT INTO `access_log` VALUES (23739, '64.84.15595333975515727', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:43:18', 13, 0, '', '2019-06-03 11:43:18');
INSERT INTO `access_log` VALUES (23740, '64.82.15595333975575733', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:43:18', 9, 0, '', '2019-06-03 11:43:18');
INSERT INTO `access_log` VALUES (23741, '64.76.15595333975965715', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:43:18', 9, 0, '', '2019-06-03 11:43:18');
INSERT INTO `access_log` VALUES (23742, '64.80.15595333985315715', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:43:19', 9, 0, '', '2019-06-03 11:43:19');
INSERT INTO `access_log` VALUES (23743, '64.83.15595333985245717', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 11:43:19', 11, 0, '', '2019-06-03 11:43:19');
INSERT INTO `access_log` VALUES (23744, '59.72.15595334008426141', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:43:21', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 11:43:21');
INSERT INTO `access_log` VALUES (23745, '65.46.15595334031045975', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:43:23', 15, 0, '', '2019-06-03 11:43:23');
INSERT INTO `access_log` VALUES (23746, '65.49.15595334040635999', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:43:24', 222, 0, '', '2019-06-03 11:43:24');
INSERT INTO `access_log` VALUES (23747, '65.51.15595334048925975', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:43:25', 9, 0, '', '2019-06-03 11:43:25');
INSERT INTO `access_log` VALUES (23748, '65.52.15595334059425971', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:43:26', 15, 0, '', '2019-06-03 11:43:26');
INSERT INTO `access_log` VALUES (23749, '65.47.15595334070155985', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:43:27', 8, 0, '', '2019-06-03 11:43:27');
INSERT INTO `access_log` VALUES (23750, '64.77.15595334125455731', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '210.22.245.226', '2019-06-03 11:43:33', 1, 1002001015, '账号未登陆', '2019-06-03 11:43:33');
INSERT INTO `access_log` VALUES (23751, '65.53.15595334164465955', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '116.128.128.79', '2019-06-03 11:43:36', 0, 1002001015, '账号未登陆', '2019-06-03 11:43:36');
INSERT INTO `access_log` VALUES (23752, '59.74.15595334624476141', 0, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '210.22.245.219', '2019-06-03 11:44:22', 0, 1002001015, '账号未登陆', '2019-06-03 11:44:22');
INSERT INTO `access_log` VALUES (23753, '64.82.15595334678595735', 0, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '223.166.151.191', '2019-06-03 11:44:28', 1, 1002001015, '账号未登陆', '2019-06-03 11:44:28');
INSERT INTO `access_log` VALUES (23754, '64.84.15595335878005731', 0, 2, 'product-application', '/product-api/admins/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '58.246.221.61', '2019-06-03 11:46:28', 1, 1002001015, '账号未登陆', '2019-06-03 11:46:28');
INSERT INTO `access_log` VALUES (23755, '65.53.15595338555705963', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.47.72.67', '2019-06-03 11:50:56', 1, 0, '', '2019-06-03 11:50:56');
INSERT INTO `access_log` VALUES (23756, '65.51.15595339155715983', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '58.247.204.63', '2019-06-03 11:51:56', 1, 0, '', '2019-06-03 11:51:56');
INSERT INTO `access_log` VALUES (23757, '64.77.15595341121875741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.104.1.108', '2019-06-03 11:55:12', 3, 0, '', '2019-06-03 11:55:12');
INSERT INTO `access_log` VALUES (23758, '64.79.15595341125525729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.104.1.108', '2019-06-03 11:55:13', 2, 0, '', '2019-06-03 11:55:13');
INSERT INTO `access_log` VALUES (23759, '59.72.15595341222986151', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.104.1.108', '2019-06-03 11:55:22', 15, 2001001000, '服务端发生异常', '2019-06-03 11:55:22');
INSERT INTO `access_log` VALUES (23760, '59.76.15595341223886149', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '223.104.1.108', '2019-06-03 11:55:22', 3, 0, '', '2019-06-03 11:55:22');
INSERT INTO `access_log` VALUES (23761, '59.77.15595341279916147', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:55:28', 46, 2001001000, '服务端发生异常', '2019-06-03 11:55:28');
INSERT INTO `access_log` VALUES (23762, '59.75.15595341279866155', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:55:28', 381, 0, '', '2019-06-03 11:55:28');
INSERT INTO `access_log` VALUES (23763, '59.74.15595341346246151', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:55:35', 3, 0, '', '2019-06-03 11:55:35');
INSERT INTO `access_log` VALUES (23764, '59.71.15595341346296159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:55:35', 12, 2001001000, '服务端发生异常', '2019-06-03 11:55:35');
INSERT INTO `access_log` VALUES (23765, '59.73.15595341378306159', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.1.1; Nexus 6 Build/LYZ28E) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '121.204.74.73', '2019-06-03 11:55:38', 3, 0, '', '2019-06-03 11:55:38');
INSERT INTO `access_log` VALUES (23766, '59.78.15595341378326159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.1.1; Nexus 6 Build/LYZ28E) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '121.204.74.73', '2019-06-03 11:55:38', 12, 2001001000, '服务端发生异常', '2019-06-03 11:55:38');
INSERT INTO `access_log` VALUES (23767, '64.84.15595341426125739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.1.1; Nexus 6 Build/LYZ28E) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '121.204.74.73', '2019-06-03 11:55:43', 2, 0, '', '2019-06-03 11:55:43');
INSERT INTO `access_log` VALUES (23768, '64.82.15595341427265745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.1.1; Nexus 6 Build/LYZ28E) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '121.204.74.73', '2019-06-03 11:55:43', 1, 0, '', '2019-06-03 11:55:43');
INSERT INTO `access_log` VALUES (23769, '64.76.15595341454185727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.1.1; Nexus 6 Build/LYZ28E) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '121.204.74.73', '2019-06-03 11:55:45', 3, 0, '', '2019-06-03 11:55:45');
INSERT INTO `access_log` VALUES (23770, '64.83.15595341455035729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.1.1; Nexus 6 Build/LYZ28E) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '121.204.74.73', '2019-06-03 11:55:46', 1, 0, '', '2019-06-03 11:55:46');
INSERT INTO `access_log` VALUES (23771, '59.72.15595341468196153', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.1.1; Nexus 6 Build/LYZ28E) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '121.204.74.73', '2019-06-03 11:55:47', 3, 0, '', '2019-06-03 11:55:47');
INSERT INTO `access_log` VALUES (23772, '59.80.15595341468166151', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.1.1; Nexus 6 Build/LYZ28E) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '121.204.74.73', '2019-06-03 11:55:47', 12, 2001001000, '服务端发生异常', '2019-06-03 11:55:47');
INSERT INTO `access_log` VALUES (23773, '59.77.15595341506886149', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.1.1; Nexus 6 Build/LYZ28E) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '121.204.74.73', '2019-06-03 11:55:51', 2, 0, '', '2019-06-03 11:55:51');
INSERT INTO `access_log` VALUES (23774, '59.75.15595341506976157', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.1.1; Nexus 6 Build/LYZ28E) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '121.204.74.73', '2019-06-03 11:55:51', 20, 2001001000, '服务端发生异常', '2019-06-03 11:55:51');
INSERT INTO `access_log` VALUES (23775, '65.51.15595342030275987', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '121.204.74.73', '2019-06-03 11:56:43', 0, 1002001015, '账号未登陆', '2019-06-03 11:56:43');
INSERT INTO `access_log` VALUES (23776, '65.49.15595342030346011', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '121.204.74.73', '2019-06-03 11:56:43', 1, 1002001015, '账号未登陆', '2019-06-03 11:56:43');
INSERT INTO `access_log` VALUES (23777, '65.52.15595342030405981', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '121.204.74.73', '2019-06-03 11:56:43', 0, 1002001015, '账号未登陆', '2019-06-03 11:56:43');
INSERT INTO `access_log` VALUES (23778, '65.47.15595342080745997', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '121.204.74.73', '2019-06-03 11:56:48', 74, 0, '', '2019-06-03 11:56:48');
INSERT INTO `access_log` VALUES (23779, '65.54.15595342113795963', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '121.204.74.73', '2019-06-03 11:56:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 11:56:51');
INSERT INTO `access_log` VALUES (23780, '65.50.15595342170806001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '121.204.74.73', '2019-06-03 11:56:57', 76, 0, '', '2019-06-03 11:56:57');
INSERT INTO `access_log` VALUES (23781, '65.45.15595342250746013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '121.204.74.73', '2019-06-03 11:57:05', 60, 0, '', '2019-06-03 11:57:05');
INSERT INTO `access_log` VALUES (23782, '65.48.15595342312665999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:57:11', 101, 0, '', '2019-06-03 11:57:11');
INSERT INTO `access_log` VALUES (23783, '65.52.15595342317085983', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:57:12', 321, 0, '', '2019-06-03 11:57:12');
INSERT INTO `access_log` VALUES (23784, '65.51.15595342317035989', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:57:12', 326, 0, '', '2019-06-03 11:57:12');
INSERT INTO `access_log` VALUES (23785, '65.49.15595342317036013', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:57:12', 326, 0, '', '2019-06-03 11:57:12');
INSERT INTO `access_log` VALUES (23786, '62.82.15595342375186041', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:57:18', 13, 0, '', '2019-06-03 11:57:18');
INSERT INTO `access_log` VALUES (23787, '64.82.15595342439445747', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:57:24', 11, 0, '', '2019-06-03 11:57:24');
INSERT INTO `access_log` VALUES (23788, '64.76.15595342439445729', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:57:24', 13, 0, '', '2019-06-03 11:57:24');
INSERT INTO `access_log` VALUES (23789, '64.83.15595342470715731', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:57:27', 8, 0, '', '2019-06-03 11:57:27');
INSERT INTO `access_log` VALUES (23790, '64.80.15595342470765729', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:57:27', 9, 0, '', '2019-06-03 11:57:27');
INSERT INTO `access_log` VALUES (23791, '64.77.15595342501035745', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:57:30', 8, 0, '', '2019-06-03 11:57:30');
INSERT INTO `access_log` VALUES (23792, '64.78.15595342501035743', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '121.204.74.73', '2019-06-03 11:57:30', 9, 0, '', '2019-06-03 11:57:30');
INSERT INTO `access_log` VALUES (23793, '65.45.15595345911256019', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 12:03:11', 4, 1002001012, '访问令牌已过期', '2019-06-03 12:03:11');
INSERT INTO `access_log` VALUES (23794, '65.46.15595345911265997', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 12:03:11', 4, 1002001012, '访问令牌已过期', '2019-06-03 12:03:11');
INSERT INTO `access_log` VALUES (23795, '65.48.15595345911326005', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 12:03:11', 3, 1002001012, '访问令牌已过期', '2019-06-03 12:03:11');
INSERT INTO `access_log` VALUES (23796, '65.52.15595345927245989', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.144.174.92', '2019-06-03 12:03:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 12:03:13');
INSERT INTO `access_log` VALUES (23797, '65.45.15595354452766031', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:17:25', 1, 1002001015, '账号未登陆', '2019-06-03 12:17:25');
INSERT INTO `access_log` VALUES (23798, '65.48.15595354452796017', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:17:25', 0, 1002001015, '账号未登陆', '2019-06-03 12:17:25');
INSERT INTO `access_log` VALUES (23799, '65.52.15595354452916001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:17:25', 0, 1002001015, '账号未登陆', '2019-06-03 12:17:25');
INSERT INTO `access_log` VALUES (23800, '65.49.15595354529736031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:17:33', 61, 0, '', '2019-06-03 12:17:33');
INSERT INTO `access_log` VALUES (23801, '65.51.15595354533496007', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:17:33', 9, 0, '', '2019-06-03 12:17:33');
INSERT INTO `access_log` VALUES (23802, '65.47.15595354533596017', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:17:33', 8, 0, '', '2019-06-03 12:17:33');
INSERT INTO `access_log` VALUES (23803, '65.54.15595354533665983', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:17:33', 9, 0, '', '2019-06-03 12:17:33');
INSERT INTO `access_log` VALUES (23804, '62.82.15595354620146059', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:17:42', 14, 0, '', '2019-06-03 12:17:42');
INSERT INTO `access_log` VALUES (23805, '62.80.15595354726476053', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:17:53', 11, 0, '', '2019-06-03 12:17:53');
INSERT INTO `access_log` VALUES (23806, '62.88.15595354734646057', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=4&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:17:53', 117, 0, '', '2019-06-03 12:17:54');
INSERT INTO `access_log` VALUES (23807, '62.87.15595354741426055', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=5&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:17:54', 11, 0, '', '2019-06-03 12:17:54');
INSERT INTO `access_log` VALUES (23808, '64.85.15595354768735767', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:17:57', 13, 0, '', '2019-06-03 12:17:57');
INSERT INTO `access_log` VALUES (23809, '64.84.15595354768775759', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:17:57', 9, 0, '', '2019-06-03 12:17:57');
INSERT INTO `access_log` VALUES (23810, '64.76.15595354838025747', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:18:04', 9, 0, '', '2019-06-03 12:18:04');
INSERT INTO `access_log` VALUES (23811, '64.82.15595354837945765', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:18:04', 18, 0, '', '2019-06-03 12:18:04');
INSERT INTO `access_log` VALUES (23812, '59.79.15595355082096175', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:18:28', 13, 0, '', '2019-06-03 12:18:28');
INSERT INTO `access_log` VALUES (23813, '65.45.15595355172816033', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:18:37', 20, 0, '', '2019-06-03 12:18:37');
INSERT INTO `access_log` VALUES (23814, '65.53.15595355861595991', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:19:46', 19, 0, '', '2019-06-03 12:19:46');
INSERT INTO `access_log` VALUES (23815, '59.80.15595355873086171', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.210.2.22', '2019-06-03 12:19:47', 12, 0, '', '2019-06-03 12:19:47');
INSERT INTO `access_log` VALUES (23816, '59.74.15595360917266179', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:12', 4, 0, '', '2019-06-03 12:28:12');
INSERT INTO `access_log` VALUES (23817, '59.71.15595360917266187', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:12', 13, 2001001000, '服务端发生异常', '2019-06-03 12:28:12');
INSERT INTO `access_log` VALUES (23818, '64.83.15595360980245757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:18', 77, 0, '', '2019-06-03 12:28:18');
INSERT INTO `access_log` VALUES (23819, '64.77.15595360982175771', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:18', 2, 0, '', '2019-06-03 12:28:18');
INSERT INTO `access_log` VALUES (23820, '64.78.15595360994375769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:19', 2, 0, '', '2019-06-03 12:28:19');
INSERT INTO `access_log` VALUES (23821, '64.79.15595361002865759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:20', 2, 0, '', '2019-06-03 12:28:20');
INSERT INTO `access_log` VALUES (23822, '64.84.15595361010375769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:21', 156, 0, '', '2019-06-03 12:28:21');
INSERT INTO `access_log` VALUES (23823, '64.85.15595361015575777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:22', 2, 0, '', '2019-06-03 12:28:22');
INSERT INTO `access_log` VALUES (23824, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:22', 13, 0, '', '2019-06-03 12:28:22');
INSERT INTO `access_log` VALUES (23825, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:23', 5, 0, '', '2019-06-03 12:28:23');
INSERT INTO `access_log` VALUES (23826, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:23', 25, 0, '', '2019-06-03 12:28:23');
INSERT INTO `access_log` VALUES (23827, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:23', 11, 0, '', '2019-06-03 12:28:23');
INSERT INTO `access_log` VALUES (23828, '64.76.15595361043725757', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:24', 108, 0, '', '2019-06-03 12:28:24');
INSERT INTO `access_log` VALUES (23829, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:28', 8, 0, '', '2019-06-03 12:28:28');
INSERT INTO `access_log` VALUES (23830, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:28', 5, 0, '', '2019-06-03 12:28:28');
INSERT INTO `access_log` VALUES (23831, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:28', 12, 0, '', '2019-06-03 12:28:28');
INSERT INTO `access_log` VALUES (23832, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:28', 11, 0, '', '2019-06-03 12:28:28');
INSERT INTO `access_log` VALUES (23833, '65.51.15595361341476017', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:54', 0, 1002001015, '账号未登陆', '2019-06-03 12:28:54');
INSERT INTO `access_log` VALUES (23834, '65.47.15595361341496027', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:54', 0, 1002001015, '账号未登陆', '2019-06-03 12:28:54');
INSERT INTO `access_log` VALUES (23835, '65.53.15595361341505999', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:54', 0, 1002001015, '账号未登陆', '2019-06-03 12:28:54');
INSERT INTO `access_log` VALUES (23836, '65.50.15595361360446031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:28:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 12:28:56');
INSERT INTO `access_log` VALUES (23837, '65.46.15595361435236021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:04', 72, 0, '', '2019-06-03 12:29:04');
INSERT INTO `access_log` VALUES (23838, '65.52.15595361438086013', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:04', 10, 0, '', '2019-06-03 12:29:04');
INSERT INTO `access_log` VALUES (23839, '65.48.15595361438136029', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:04', 9, 0, '', '2019-06-03 12:29:04');
INSERT INTO `access_log` VALUES (23840, '65.45.15595361438126043', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:04', 11, 0, '', '2019-06-03 12:29:04');
INSERT INTO `access_log` VALUES (23841, '62.88.15595361552356067', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:15', 14, 0, '', '2019-06-03 12:29:15');
INSERT INTO `access_log` VALUES (23842, '62.87.15595361577996065', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:18', 16, 0, '', '2019-06-03 12:29:18');
INSERT INTO `access_log` VALUES (23843, '59.75.15595361650806185', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:25', 13, 0, '', '2019-06-03 12:29:25');
INSERT INTO `access_log` VALUES (23844, '59.77.15595361680286177', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:28', 18, 2001001000, '服务端发生异常', '2019-06-03 12:29:28');
INSERT INTO `access_log` VALUES (23845, '59.79.15595361703996185', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:30', 245, 0, '', '2019-06-03 12:29:31');
INSERT INTO `access_log` VALUES (23846, '59.74.15595361742736181', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:34', 12, 0, '', '2019-06-03 12:29:34');
INSERT INTO `access_log` VALUES (23847, '59.73.15595361770076189', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:37', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 12:29:37');
INSERT INTO `access_log` VALUES (23848, '65.51.15595361798066019', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:40', 20, 0, '', '2019-06-03 12:29:40');
INSERT INTO `access_log` VALUES (23849, '65.47.15595361808126029', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:41', 10, 0, '', '2019-06-03 12:29:41');
INSERT INTO `access_log` VALUES (23850, '65.50.15595361835306033', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:44', 9, 0, '', '2019-06-03 12:29:44');
INSERT INTO `access_log` VALUES (23851, '65.46.15595361849556023', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:45', 10, 0, '', '2019-06-03 12:29:45');
INSERT INTO `access_log` VALUES (23852, '65.45.15595361866056045', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:47', 11, 0, '', '2019-06-03 12:29:47');
INSERT INTO `access_log` VALUES (23853, '65.48.15595361905956031', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:29:51', 311, 0, '', '2019-06-03 12:29:51');
INSERT INTO `access_log` VALUES (23854, '62.88.15595362409936069', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.87.163.60', '2019-06-03 12:30:41', 13, 0, '', '2019-06-03 12:30:41');
INSERT INTO `access_log` VALUES (23855, '65.45.15595363029896047', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:31:43', 4, 1002001012, '访问令牌已过期', '2019-06-03 12:31:43');
INSERT INTO `access_log` VALUES (23856, '65.48.15595363029946033', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:31:43', 4, 1002001012, '访问令牌已过期', '2019-06-03 12:31:43');
INSERT INTO `access_log` VALUES (23857, '65.52.15595363029986017', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:31:43', 3, 1002001012, '访问令牌已过期', '2019-06-03 12:31:43');
INSERT INTO `access_log` VALUES (23858, '65.49.15595363052386047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:31:45', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 12:31:45');
INSERT INTO `access_log` VALUES (23859, '65.54.15595363078685999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:31:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 12:31:48');
INSERT INTO `access_log` VALUES (23860, '59.79.15595367137376193', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.156.171', '2019-06-03 12:38:34', 12, 2001001000, '服务端发生异常', '2019-06-03 12:38:34');
INSERT INTO `access_log` VALUES (23861, '59.77.15595367137336185', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.156.171', '2019-06-03 12:38:34', 104, 0, '', '2019-06-03 12:38:34');
INSERT INTO `access_log` VALUES (23862, '64.80.15595367165125765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.156.171', '2019-06-03 12:38:37', 3, 0, '', '2019-06-03 12:38:37');
INSERT INTO `access_log` VALUES (23863, '64.83.15595367166415767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.156.171', '2019-06-03 12:38:37', 2, 0, '', '2019-06-03 12:38:37');
INSERT INTO `access_log` VALUES (23864, '64.77.15595367176035781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.156.171', '2019-06-03 12:38:38', 2, 0, '', '2019-06-03 12:38:38');
INSERT INTO `access_log` VALUES (23865, '65.49.15595367238156053', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:38:44', 0, 1002001015, '账号未登陆', '2019-06-03 12:38:44');
INSERT INTO `access_log` VALUES (23866, '65.54.15595367238156005', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:38:44', 0, 1002001015, '账号未登陆', '2019-06-03 12:38:44');
INSERT INTO `access_log` VALUES (23867, '65.53.15595367238216011', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:38:44', 0, 1002001015, '账号未登陆', '2019-06-03 12:38:44');
INSERT INTO `access_log` VALUES (23868, '65.51.15595367280726029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:38:48', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 12:38:48');
INSERT INTO `access_log` VALUES (23869, '65.50.15595367341096043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:38:54', 125, 0, '', '2019-06-03 12:38:54');
INSERT INTO `access_log` VALUES (23870, '65.46.15595367344676033', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:38:54', 9, 0, '', '2019-06-03 12:38:54');
INSERT INTO `access_log` VALUES (23871, '65.45.15595367344676055', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:38:54', 10, 0, '', '2019-06-03 12:38:54');
INSERT INTO `access_log` VALUES (23872, '65.52.15595367344736025', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:38:54', 9, 0, '', '2019-06-03 12:38:54');
INSERT INTO `access_log` VALUES (23873, '62.88.15595367382946077', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:38:58', 13, 0, '', '2019-06-03 12:38:58');
INSERT INTO `access_log` VALUES (23874, '64.84.15595367455215779', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:06', 9, 0, '', '2019-06-03 12:39:06');
INSERT INTO `access_log` VALUES (23875, '64.79.15595367455195769', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:06', 13, 0, '', '2019-06-03 12:39:06');
INSERT INTO `access_log` VALUES (23876, '64.85.15595367503395787', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:10', 9, 0, '', '2019-06-03 12:39:10');
INSERT INTO `access_log` VALUES (23877, '64.76.15595367503405767', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:10', 11, 0, '', '2019-06-03 12:39:10');
INSERT INTO `access_log` VALUES (23878, '64.80.15595367543575767', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:14', 9, 0, '', '2019-06-03 12:39:14');
INSERT INTO `access_log` VALUES (23879, '64.82.15595367543565785', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:14', 14, 0, '', '2019-06-03 12:39:14');
INSERT INTO `access_log` VALUES (23880, '66.50.15595367621534909', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:22', 21, 0, '', '2019-06-03 12:39:22');
INSERT INTO `access_log` VALUES (23881, '59.72.15595367654516191', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:25', 11, 0, '', '2019-06-03 12:39:25');
INSERT INTO `access_log` VALUES (23882, '59.80.15595367689026189', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:29', 12, 0, '', '2019-06-03 12:39:29');
INSERT INTO `access_log` VALUES (23883, '64.77.15595367700325783', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:30', 8, 0, '', '2019-06-03 12:39:30');
INSERT INTO `access_log` VALUES (23884, '64.78.15595367715435781', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:32', 9, 0, '', '2019-06-03 12:39:32');
INSERT INTO `access_log` VALUES (23885, '65.54.15595367732366007', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:33', 19, 0, '', '2019-06-03 12:39:33');
INSERT INTO `access_log` VALUES (23886, '65.53.15595367762146013', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:36', 13, 0, '', '2019-06-03 12:39:36');
INSERT INTO `access_log` VALUES (23887, '65.51.15595367786916031', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:39', 10, 0, '', '2019-06-03 12:39:39');
INSERT INTO `access_log` VALUES (23888, '65.50.15595367800856045', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:40', 10, 0, '', '2019-06-03 12:39:40');
INSERT INTO `access_log` VALUES (23889, '65.46.15595367807396035', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:41', 14, 0, '', '2019-06-03 12:39:41');
INSERT INTO `access_log` VALUES (23890, '65.52.15595367820996027', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:42', 8, 0, '', '2019-06-03 12:39:42');
INSERT INTO `access_log` VALUES (23891, '59.79.15595367924956195', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:52', 2, 0, '', '2019-06-03 12:39:52');
INSERT INTO `access_log` VALUES (23892, '59.77.15595367924956187', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:52', 14, 2001001000, '服务端发生异常', '2019-06-03 12:39:53');
INSERT INTO `access_log` VALUES (23893, '66.54.15595367929584911', 0, 2, 'user-application', '/user-api/admins/user/page', 'pageSize=10&nickname=小王&pageNo=1&status=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.156.171', '2019-06-03 12:39:53', 1, 1002001015, '账号未登陆', '2019-06-03 12:39:53');
INSERT INTO `access_log` VALUES (23894, '64.79.15595367958995771', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:56', 3, 0, '', '2019-06-03 12:39:56');
INSERT INTO `access_log` VALUES (23895, '64.85.15595367959995789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:56', 1, 0, '', '2019-06-03 12:39:56');
INSERT INTO `access_log` VALUES (23896, '66.49.15595367988034907', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:39:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空\n手机验证码不能为空\n手机号必须都是数字', '2019-06-03 12:39:59');
INSERT INTO `access_log` VALUES (23897, '64.76.15595368029315769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:40:03', 31, 0, '', '2019-06-03 12:40:03');
INSERT INTO `access_log` VALUES (23898, '64.80.15595368032355769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:40:03', 2, 0, '', '2019-06-03 12:40:03');
INSERT INTO `access_log` VALUES (23899, '66.57.15595368037394909', 0, 2, 'user-application', '/user-api/admins/user/update', 'avatar=http://www.iocoder.cn/xxx.jpg&id=1&nickname=小王', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.156.171', '2019-06-03 12:40:04', 0, 1002001015, '账号未登陆', '2019-06-03 12:40:04');
INSERT INTO `access_log` VALUES (23900, '59.73.15595368043656199', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:40:04', 18, 2001001000, '服务端发生异常', '2019-06-03 12:40:04');
INSERT INTO `access_log` VALUES (23901, '59.74.15595368043646191', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '113.246.193.72', '2019-06-03 12:40:04', 32, 0, '', '2019-06-03 12:40:04');
INSERT INTO `access_log` VALUES (23902, '65.50.15595368989016047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:41:39', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 12:41:39');
INSERT INTO `access_log` VALUES (23903, '65.52.15595369136796029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:41:54', 476, 0, '', '2019-06-03 12:41:54');
INSERT INTO `access_log` VALUES (23904, '65.48.15595369148726045', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:41:55', 477, 0, '', '2019-06-03 12:41:55');
INSERT INTO `access_log` VALUES (23905, '65.49.15595369148766059', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:41:55', 627, 0, '', '2019-06-03 12:41:56');
INSERT INTO `access_log` VALUES (23906, '65.54.15595369150096011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:41:55', 496, 0, '', '2019-06-03 12:41:56');
INSERT INTO `access_log` VALUES (23907, '62.89.15595369235786069', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:42:04', 13, 0, '', '2019-06-03 12:42:04');
INSERT INTO `access_log` VALUES (23908, '62.83.15595369257216071', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:42:06', 15, 0, '', '2019-06-03 12:42:06');
INSERT INTO `access_log` VALUES (23909, '66.57.15595369329844911', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:42:13', 14, 0, '', '2019-06-03 12:42:13');
INSERT INTO `access_log` VALUES (23910, '59.73.15595369347736201', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:42:15', 20, 2001001000, '服务端发生异常', '2019-06-03 12:42:15');
INSERT INTO `access_log` VALUES (23911, '65.51.15595369374916035', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:42:17', 18, 0, '', '2019-06-03 12:42:18');
INSERT INTO `access_log` VALUES (23912, '65.47.15595369392666045', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:42:19', 10, 0, '', '2019-06-03 12:42:19');
INSERT INTO `access_log` VALUES (23913, '65.46.15595369398446039', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:42:20', 9, 0, '', '2019-06-03 12:42:20');
INSERT INTO `access_log` VALUES (23914, '65.50.15595369409976049', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:42:21', 15, 0, '', '2019-06-03 12:42:21');
INSERT INTO `access_log` VALUES (23915, '65.45.15595369415416061', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:42:22', 9, 0, '', '2019-06-03 12:42:22');
INSERT INTO `access_log` VALUES (23916, '65.52.15595369420946031', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:42:22', 9, 0, '', '2019-06-03 12:42:22');
INSERT INTO `access_log` VALUES (23917, '65.48.15595369432016047', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:42:23', 9, 0, '', '2019-06-03 12:42:23');
INSERT INTO `access_log` VALUES (23918, '59.72.15595369544166195', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '1.180.4.109', '2019-06-03 12:42:34', 12, 0, '', '2019-06-03 12:42:34');
INSERT INTO `access_log` VALUES (23919, '59.78.15595387204536225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '61.143.152.8', '2019-06-03 13:12:00', 10, 2001001000, '服务端发生异常', '2019-06-03 13:12:00');
INSERT INTO `access_log` VALUES (23920, '59.74.15595387204496217', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; TRT-AL00A Build/HUAWEITRT-AL00A) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '61.143.152.7', '2019-06-03 13:12:00', 75, 0, '', '2019-06-03 13:12:01');
INSERT INTO `access_log` VALUES (23921, '59.71.15595389508876229', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:15:51', 3, 0, '', '2019-06-03 13:15:51');
INSERT INTO `access_log` VALUES (23922, '59.73.15595389510746229', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:15:51', 12, 2001001000, '服务端发生异常', '2019-06-03 13:15:51');
INSERT INTO `access_log` VALUES (23923, '64.81.15595389628745801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:03', 10, 0, '', '2019-06-03 13:16:03');
INSERT INTO `access_log` VALUES (23924, '64.84.15595389630945811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:03', 60, 0, '', '2019-06-03 13:16:03');
INSERT INTO `access_log` VALUES (23925, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:05', 9, 0, '', '2019-06-03 13:16:05');
INSERT INTO `access_log` VALUES (23926, '64.79.15595389648255801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:05', 98, 0, '', '2019-06-03 13:16:05');
INSERT INTO `access_log` VALUES (23927, '64.76.15595389673135799', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:07', 8, 0, '', '2019-06-03 13:16:07');
INSERT INTO `access_log` VALUES (23928, '64.80.15595389691735799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:09', 3, 0, '', '2019-06-03 13:16:09');
INSERT INTO `access_log` VALUES (23929, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:09', 7, 0, '', '2019-06-03 13:16:09');
INSERT INTO `access_log` VALUES (23930, '64.82.15595389705335817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:11', 3, 0, '', '2019-06-03 13:16:11');
INSERT INTO `access_log` VALUES (23931, '64.83.15595389707735801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:11', 2, 0, '', '2019-06-03 13:16:11');
INSERT INTO `access_log` VALUES (23932, '64.77.15595389728735815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:13', 3, 0, '', '2019-06-03 13:16:13');
INSERT INTO `access_log` VALUES (23933, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:13', 6, 0, '', '2019-06-03 13:16:13');
INSERT INTO `access_log` VALUES (23934, '64.78.15595389745355813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:15', 2, 0, '', '2019-06-03 13:16:15');
INSERT INTO `access_log` VALUES (23935, '64.81.15595389747555803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:15', 2, 0, '', '2019-06-03 13:16:15');
INSERT INTO `access_log` VALUES (23936, '64.84.15595389760755813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:16', 2, 0, '', '2019-06-03 13:16:16');
INSERT INTO `access_log` VALUES (23937, '64.79.15595389774645803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:17', 2, 0, '', '2019-06-03 13:16:17');
INSERT INTO `access_log` VALUES (23938, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:17', 7, 0, '', '2019-06-03 13:16:17');
INSERT INTO `access_log` VALUES (23939, '64.85.15595389788235821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:19', 2, 0, '', '2019-06-03 13:16:19');
INSERT INTO `access_log` VALUES (23940, '64.76.15595389792725801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:19', 2, 0, '', '2019-06-03 13:16:19');
INSERT INTO `access_log` VALUES (23941, '59.72.15595389796736223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:20', 2, 0, '', '2019-06-03 13:16:20');
INSERT INTO `access_log` VALUES (23942, '59.80.15595389796746221', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '117.136.79.121', '2019-06-03 13:16:20', 9, 2001001000, '服务端发生异常', '2019-06-03 13:16:20');
INSERT INTO `access_log` VALUES (23943, '59.71.15595390440256231', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.10', '2019-06-03 13:17:24', 3, 0, '', '2019-06-03 13:17:24');
INSERT INTO `access_log` VALUES (23944, '59.73.15595390440256231', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.131.110.10', '2019-06-03 13:17:24', 17, 2001001000, '服务端发生异常', '2019-06-03 13:17:24');
INSERT INTO `access_log` VALUES (23945, '59.75.15595392560346231', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:20:56', 13, 2001001000, '服务端发生异常', '2019-06-03 13:20:56');
INSERT INTO `access_log` VALUES (23946, '59.76.15595392560296225', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:20:56', 221, 0, '', '2019-06-03 13:20:56');
INSERT INTO `access_log` VALUES (23947, '64.76.15595392608765805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:21:01', 2, 0, '', '2019-06-03 13:21:01');
INSERT INTO `access_log` VALUES (23948, '64.80.15595392610035805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:21:01', 2, 0, '', '2019-06-03 13:21:01');
INSERT INTO `access_log` VALUES (23949, '64.82.15595392629595823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:21:03', 2, 0, '', '2019-06-03 13:21:03');
INSERT INTO `access_log` VALUES (23950, '64.83.15595392633865807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:21:03', 2, 0, '', '2019-06-03 13:21:03');
INSERT INTO `access_log` VALUES (23951, '65.45.15595392734346093', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:21:13', 3, 1002001012, '访问令牌已过期', '2019-06-03 13:21:13');
INSERT INTO `access_log` VALUES (23952, '65.50.15595392734346081', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:21:13', 4, 1002001012, '访问令牌已过期', '2019-06-03 13:21:13');
INSERT INTO `access_log` VALUES (23953, '65.52.15595392734536063', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:21:13', 10, 1002001012, '访问令牌已过期', '2019-06-03 13:21:13');
INSERT INTO `access_log` VALUES (23954, '65.48.15595392778496079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:21:18', 99, 0, '', '2019-06-03 13:21:18');
INSERT INTO `access_log` VALUES (23955, '65.54.15595392782476045', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:21:18', 56, 0, '', '2019-06-03 13:21:18');
INSERT INTO `access_log` VALUES (23956, '65.49.15595392782486093', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:21:18', 64, 0, '', '2019-06-03 13:21:18');
INSERT INTO `access_log` VALUES (23957, '65.53.15595392782496051', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:21:18', 56, 0, '', '2019-06-03 13:21:18');
INSERT INTO `access_log` VALUES (23958, '62.80.15595393073306109', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:21:47', 23, 0, '', '2019-06-03 13:21:47');
INSERT INTO `access_log` VALUES (23959, '62.81.15595393138446087', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:21:54', 227, 0, '', '2019-06-03 13:21:54');
INSERT INTO `access_log` VALUES (23960, '59.78.15595393300216235', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:22:10', 10, 0, '', '2019-06-03 13:22:10');
INSERT INTO `access_log` VALUES (23961, '59.80.15595393445906227', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:22:25', 10, 0, '', '2019-06-03 13:22:25');
INSERT INTO `access_log` VALUES (23962, '65.52.15595393484226065', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:22:28', 18, 0, '', '2019-06-03 13:22:28');
INSERT INTO `access_log` VALUES (23963, '65.48.15595393559166081', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:22:36', 12, 0, '', '2019-06-03 13:22:36');
INSERT INTO `access_log` VALUES (23964, '65.49.15595393602546095', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:22:40', 10, 0, '', '2019-06-03 13:22:40');
INSERT INTO `access_log` VALUES (23965, '65.54.15595393614916047', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.71.82', '2019-06-03 13:22:41', 10, 0, '', '2019-06-03 13:22:42');
INSERT INTO `access_log` VALUES (23966, '65.45.15595394161936097', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:23:36', 1, 1002001015, '账号未登陆', '2019-06-03 13:23:36');
INSERT INTO `access_log` VALUES (23967, '65.50.15595394161986085', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:23:36', 0, 1002001015, '账号未登陆', '2019-06-03 13:23:36');
INSERT INTO `access_log` VALUES (23968, '65.52.15595394162036067', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:23:36', 1, 1002001015, '账号未登陆', '2019-06-03 13:23:36');
INSERT INTO `access_log` VALUES (23969, '65.53.15595394217586055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:23:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 13:23:42');
INSERT INTO `access_log` VALUES (23970, '65.49.15595394269416097', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:23:47', 88, 0, '', '2019-06-03 13:23:47');
INSERT INTO `access_log` VALUES (23971, '65.54.15595394272846049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:23:47', 8, 0, '', '2019-06-03 13:23:47');
INSERT INTO `access_log` VALUES (23972, '65.51.15595394272876073', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:23:47', 8, 0, '', '2019-06-03 13:23:47');
INSERT INTO `access_log` VALUES (23973, '65.47.15595394272936083', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:23:47', 8, 0, '', '2019-06-03 13:23:47');
INSERT INTO `access_log` VALUES (23974, '62.80.15595394308996111', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:23:51', 13, 0, '', '2019-06-03 13:23:51');
INSERT INTO `access_log` VALUES (23975, '62.81.15595394336816089', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:23:54', 15, 0, '', '2019-06-03 13:23:54');
INSERT INTO `access_log` VALUES (23976, '62.84.15595394362866095', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:23:56', 58, 0, '', '2019-06-03 13:23:56');
INSERT INTO `access_log` VALUES (23977, '64.79.15595394464445811', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:24:06', 10, 0, '', '2019-06-03 13:24:06');
INSERT INTO `access_log` VALUES (23978, '64.84.15595394464425821', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:24:06', 13, 0, '', '2019-06-03 13:24:06');
INSERT INTO `access_log` VALUES (23979, '64.80.15595394763765809', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=6&name=453', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:24:36', 6, 1002002009, NULL, '2019-06-03 13:24:36');
INSERT INTO `access_log` VALUES (23980, '64.82.15595394783065827', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=345', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:24:38', 8, 1002002009, NULL, '2019-06-03 13:24:38');
INSERT INTO `access_log` VALUES (23981, '64.81.15595395081145813', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:25:08', 651, 0, '', '2019-06-03 13:25:09');
INSERT INTO `access_log` VALUES (23982, '64.78.15595395081145823', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:25:08', 654, 0, '', '2019-06-03 13:25:09');
INSERT INTO `access_log` VALUES (23983, '64.84.15595395143755823', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:25:14', 9, 0, '', '2019-06-03 13:25:14');
INSERT INTO `access_log` VALUES (23984, '66.53.15595395198534943', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:25:20', 22, 0, '', '2019-06-03 13:25:20');
INSERT INTO `access_log` VALUES (23985, '59.79.15595395214696235', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:25:21', 11, 0, '', '2019-06-03 13:25:21');
INSERT INTO `access_log` VALUES (23986, '65.49.15595395237906099', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:25:24', 10, 0, '', '2019-06-03 13:25:24');
INSERT INTO `access_log` VALUES (23987, '65.51.15595395250396075', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:25:25', 7, 0, '', '2019-06-03 13:25:25');
INSERT INTO `access_log` VALUES (23988, '65.54.15595395260076051', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:25:26', 15, 0, '', '2019-06-03 13:25:26');
INSERT INTO `access_log` VALUES (23989, '65.46.15595395272216079', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:25:27', 10, 0, '', '2019-06-03 13:25:27');
INSERT INTO `access_log` VALUES (23990, '65.45.15595395286906101', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.31.90', '2019-06-03 13:25:29', 14, 0, '', '2019-06-03 13:25:29');
INSERT INTO `access_log` VALUES (23991, '65.46.15595399313686085', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.107.198.197', '2019-06-03 13:32:11', 0, 1002001015, '账号未登陆', '2019-06-03 13:32:11');
INSERT INTO `access_log` VALUES (23992, '65.54.15595399313676057', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.107.198.197', '2019-06-03 13:32:11', 1, 1002001015, '账号未登陆', '2019-06-03 13:32:11');
INSERT INTO `access_log` VALUES (23993, '65.45.15595399313706107', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.107.198.197', '2019-06-03 13:32:11', 0, 1002001015, '账号未登陆', '2019-06-03 13:32:11');
INSERT INTO `access_log` VALUES (23994, '65.50.15595399334496095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.107.198.197', '2019-06-03 13:32:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 13:32:13');
INSERT INTO `access_log` VALUES (23995, '65.52.15595399378336077', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.107.198.197', '2019-06-03 13:32:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 13:32:18');
INSERT INTO `access_log` VALUES (23996, '65.48.15595399411706093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.107.198.197', '2019-06-03 13:32:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 13:32:21');
INSERT INTO `access_log` VALUES (23997, '59.71.15595399907676245', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.107.198.197', '2019-06-03 13:33:11', 3, 0, '', '2019-06-03 13:33:11');
INSERT INTO `access_log` VALUES (23998, '59.73.15595399910006245', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.107.198.197', '2019-06-03 13:33:11', 13, 2001001000, '服务端发生异常', '2019-06-03 13:33:11');
INSERT INTO `access_log` VALUES (23999, '65.51.15595406120006091', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:32', 1, 1002001015, '账号未登陆', '2019-06-03 13:43:32');
INSERT INTO `access_log` VALUES (24000, '65.46.15595406120006097', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:32', 1, 1002001015, '账号未登陆', '2019-06-03 13:43:32');
INSERT INTO `access_log` VALUES (24001, '65.45.15595406120056119', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:32', 0, 1002001015, '账号未登陆', '2019-06-03 13:43:32');
INSERT INTO `access_log` VALUES (24002, '65.54.15595406140966067', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:34', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 13:43:34');
INSERT INTO `access_log` VALUES (24003, '65.52.15595406248136089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:45', 85, 0, '', '2019-06-03 13:43:45');
INSERT INTO `access_log` VALUES (24004, '65.48.15595406251556103', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:45', 9, 0, '', '2019-06-03 13:43:45');
INSERT INTO `access_log` VALUES (24005, '65.49.15595406251566117', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:45', 10, 0, '', '2019-06-03 13:43:45');
INSERT INTO `access_log` VALUES (24006, '65.53.15595406251586075', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:45', 8, 0, '', '2019-06-03 13:43:45');
INSERT INTO `access_log` VALUES (24007, '64.76.15595406298195827', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:50', 10, 0, '', '2019-06-03 13:43:50');
INSERT INTO `access_log` VALUES (24008, '64.85.15595406298175849', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:50', 12, 0, '', '2019-06-03 13:43:50');
INSERT INTO `access_log` VALUES (24009, '64.82.15595406328365843', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:53', 9, 0, '', '2019-06-03 13:43:53');
INSERT INTO `access_log` VALUES (24010, '64.79.15595406328335829', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:53', 11, 0, '', '2019-06-03 13:43:53');
INSERT INTO `access_log` VALUES (24011, '64.81.15595406358525831', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:56', 9, 0, '', '2019-06-03 13:43:56');
INSERT INTO `access_log` VALUES (24012, '64.83.15595406358505831', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:56', 11, 0, '', '2019-06-03 13:43:56');
INSERT INTO `access_log` VALUES (24013, '64.77.15595406358515843', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:43:56', 14, 0, '', '2019-06-03 13:43:56');
INSERT INTO `access_log` VALUES (24014, '65.54.15595408214696071', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 13:47:01', 1, 1002001015, '账号未登陆', '2019-06-03 13:47:01');
INSERT INTO `access_log` VALUES (24015, '65.51.15595408214696095', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 13:47:01', 1, 1002001015, '账号未登陆', '2019-06-03 13:47:01');
INSERT INTO `access_log` VALUES (24016, '65.50.15595408214706111', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 13:47:01', 1, 1002001015, '账号未登陆', '2019-06-03 13:47:01');
INSERT INTO `access_log` VALUES (24017, '65.52.15595408266006093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 13:47:07', 65, 0, '', '2019-06-03 13:47:07');
INSERT INTO `access_log` VALUES (24018, '65.53.15595408268976079', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 13:47:07', 102, 0, '', '2019-06-03 13:47:07');
INSERT INTO `access_log` VALUES (24019, '65.48.15595408268906107', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 13:47:07', 119, 0, '', '2019-06-03 13:47:07');
INSERT INTO `access_log` VALUES (24020, '65.49.15595408268936121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 13:47:07', 116, 0, '', '2019-06-03 13:47:07');
INSERT INTO `access_log` VALUES (24021, '64.76.15595408273945831', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:47:07', 5, 1002001012, '访问令牌已过期', '2019-06-03 13:47:07');
INSERT INTO `access_log` VALUES (24022, '64.80.15595408274085831', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:47:07', 4, 1002001012, '访问令牌已过期', '2019-06-03 13:47:07');
INSERT INTO `access_log` VALUES (24023, '65.45.15595408289866125', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:47:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 13:47:09');
INSERT INTO `access_log` VALUES (24024, '62.88.15595408320986133', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.78.229', '2019-06-03 13:47:12', 12, 0, '', '2019-06-03 13:47:12');
INSERT INTO `access_log` VALUES (24025, '65.54.15595408534886073', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:47:33', 65, 0, '', '2019-06-03 13:47:34');
INSERT INTO `access_log` VALUES (24026, '65.51.15595408537956097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:47:34', 9, 0, '', '2019-06-03 13:47:34');
INSERT INTO `access_log` VALUES (24027, '65.50.15595408538006113', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:47:34', 10, 0, '', '2019-06-03 13:47:34');
INSERT INTO `access_log` VALUES (24028, '65.52.15595408538056095', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:47:34', 9, 0, '', '2019-06-03 13:47:34');
INSERT INTO `access_log` VALUES (24029, '64.83.15595408634775835', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:47:43', 196, 0, '', '2019-06-03 13:47:44');
INSERT INTO `access_log` VALUES (24030, '64.81.15595408634745835', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:47:43', 202, 0, '', '2019-06-03 13:47:44');
INSERT INTO `access_log` VALUES (24031, '64.77.15595409963075849', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:49:56', 10, 0, '', '2019-06-03 13:49:56');
INSERT INTO `access_log` VALUES (24032, '64.81.15595409963065837', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:49:56', 12, 0, '', '2019-06-03 13:49:56');
INSERT INTO `access_log` VALUES (24033, '64.76.15595410059595835', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:06', 9, 0, '', '2019-06-03 13:50:06');
INSERT INTO `access_log` VALUES (24034, '64.84.15595410059585847', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:06', 12, 0, '', '2019-06-03 13:50:06');
INSERT INTO `access_log` VALUES (24035, '64.85.15595410059595857', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:06', 15, 0, '', '2019-06-03 13:50:06');
INSERT INTO `access_log` VALUES (24036, '64.82.15595410206145851', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:21', 9, 0, '', '2019-06-03 13:50:21');
INSERT INTO `access_log` VALUES (24037, '64.79.15595410206135837', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:21', 11, 0, '', '2019-06-03 13:50:21');
INSERT INTO `access_log` VALUES (24038, '64.81.15595410227925839', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:23', 9, 0, '', '2019-06-03 13:50:23');
INSERT INTO `access_log` VALUES (24039, '64.83.15595410227925839', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:23', 10, 0, '', '2019-06-03 13:50:23');
INSERT INTO `access_log` VALUES (24040, '64.78.15595410244805847', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:24', 11, 0, '', '2019-06-03 13:50:24');
INSERT INTO `access_log` VALUES (24041, '64.85.15595410244845859', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:24', 7, 0, '', '2019-06-03 13:50:24');
INSERT INTO `access_log` VALUES (24042, '64.77.15595410244795851', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:24', 14, 0, '', '2019-06-03 13:50:24');
INSERT INTO `access_log` VALUES (24043, '64.76.15595410317535837', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:32', 11, 0, '', '2019-06-03 13:50:32');
INSERT INTO `access_log` VALUES (24044, '64.84.15595410317645849', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:32', 8, 0, '', '2019-06-03 13:50:32');
INSERT INTO `access_log` VALUES (24045, '65.49.15595410338796125', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:50:34', 1, 1002001015, '账号未登陆', '2019-06-03 13:50:34');
INSERT INTO `access_log` VALUES (24046, '65.53.15595410338846085', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:50:34', 0, 1002001015, '账号未登陆', '2019-06-03 13:50:34');
INSERT INTO `access_log` VALUES (24047, '65.48.15595410338986113', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:50:34', 0, 1002001015, '账号未登陆', '2019-06-03 13:50:34');
INSERT INTO `access_log` VALUES (24048, '64.79.15595410364315839', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:36', 8, 0, '', '2019-06-03 13:50:36');
INSERT INTO `access_log` VALUES (24049, '64.81.15595410382235841', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:38', 8, 0, '', '2019-06-03 13:50:38');
INSERT INTO `access_log` VALUES (24050, '64.82.15595410382235853', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:38', 11, 0, '', '2019-06-03 13:50:38');
INSERT INTO `access_log` VALUES (24051, '64.83.15595410483595841', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:50:48', 9, 0, '', '2019-06-03 13:50:48');
INSERT INTO `access_log` VALUES (24052, '64.85.15595410483595861', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.195.163.109', '2019-06-03 13:50:48', 11, 0, '', '2019-06-03 13:50:48');
INSERT INTO `access_log` VALUES (24053, '64.77.15595410515865853', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:52', 9, 0, '', '2019-06-03 13:50:52');
INSERT INTO `access_log` VALUES (24054, '64.76.15595410515895839', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 13:50:52', 6, 0, '', '2019-06-03 13:50:52');
INSERT INTO `access_log` VALUES (24055, '65.45.15595410529696129', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:50:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 13:50:53');
INSERT INTO `access_log` VALUES (24056, '59.78.15595410601226259', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.6.195.82', '2019-06-03 13:51:00', 13, 2001001000, '服务端发生异常', '2019-06-03 13:51:00');
INSERT INTO `access_log` VALUES (24057, '59.72.15595410601826253', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.6.195.82', '2019-06-03 13:51:00', 3, 0, '', '2019-06-03 13:51:00');
INSERT INTO `access_log` VALUES (24058, '64.84.15595410646485851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.6.195.82', '2019-06-03 13:51:05', 3, 0, '', '2019-06-03 13:51:05');
INSERT INTO `access_log` VALUES (24059, '64.80.15595410647895839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.6.195.82', '2019-06-03 13:51:05', 2, 0, '', '2019-06-03 13:51:05');
INSERT INTO `access_log` VALUES (24060, '64.82.15595410670205855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.6.195.82', '2019-06-03 13:51:07', 2, 0, '', '2019-06-03 13:51:07');
INSERT INTO `access_log` VALUES (24061, '64.81.15595410683155843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.6.195.82', '2019-06-03 13:51:08', 2, 0, '', '2019-06-03 13:51:08');
INSERT INTO `access_log` VALUES (24062, '64.83.15595410692565843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.6.195.82', '2019-06-03 13:51:09', 2, 0, '', '2019-06-03 13:51:09');
INSERT INTO `access_log` VALUES (24063, '64.85.15595410726335863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.6.195.82', '2019-06-03 13:51:13', 2, 0, '', '2019-06-03 13:51:13');
INSERT INTO `access_log` VALUES (24064, '64.78.15595410730105851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.6.195.82', '2019-06-03 13:51:13', 2, 0, '', '2019-06-03 13:51:13');
INSERT INTO `access_log` VALUES (24065, '59.75.15595410779886257', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.6.195.82', '2019-06-03 13:51:18', 4, 0, '', '2019-06-03 13:51:18');
INSERT INTO `access_log` VALUES (24066, '59.76.15595410779906251', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.6.195.82', '2019-06-03 13:51:18', 13, 2001001000, '服务端发生异常', '2019-06-03 13:51:18');
INSERT INTO `access_log` VALUES (24067, '66.49.15595410815934965', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.6.195.82', '2019-06-03 13:51:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-03 13:51:22');
INSERT INTO `access_log` VALUES (24068, '65.49.15595411159436127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=233666&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:51:56', 164, 0, '', '2019-06-03 13:51:56');
INSERT INTO `access_log` VALUES (24069, '65.47.15595411172916115', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:51:57', 10, 0, '', '2019-06-03 13:51:57');
INSERT INTO `access_log` VALUES (24070, '65.53.15595411172916087', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:51:57', 11, 0, '', '2019-06-03 13:51:57');
INSERT INTO `access_log` VALUES (24071, '65.48.15595411172916115', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:51:57', 13, 0, '', '2019-06-03 13:51:57');
INSERT INTO `access_log` VALUES (24072, '62.88.15595411227116137', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:52:03', 13, 0, '', '2019-06-03 13:52:03');
INSERT INTO `access_log` VALUES (24073, '64.79.15595411295595843', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:52:10', 10, 0, '', '2019-06-03 13:52:10');
INSERT INTO `access_log` VALUES (24074, '64.82.15595411295595857', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:52:10', 12, 0, '', '2019-06-03 13:52:10');
INSERT INTO `access_log` VALUES (24075, '64.83.15595411310055845', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:52:11', 8, 0, '', '2019-06-03 13:52:11');
INSERT INTO `access_log` VALUES (24076, '64.81.15595411310045845', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:52:11', 11, 0, '', '2019-06-03 13:52:11');
INSERT INTO `access_log` VALUES (24077, '59.78.15595411423596261', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:52:22', 16, 2001001000, '服务端发生异常', '2019-06-03 13:52:22');
INSERT INTO `access_log` VALUES (24078, '65.52.15595411669896101', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:52:47', 11, 0, '', '2019-06-03 13:52:47');
INSERT INTO `access_log` VALUES (24079, '65.51.15595411813096105', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:53:01', 14, 0, '', '2019-06-03 13:53:01');
INSERT INTO `access_log` VALUES (24080, '65.49.15595411865056129', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:53:07', 10, 0, '', '2019-06-03 13:53:07');
INSERT INTO `access_log` VALUES (24081, '65.47.15595412000246117', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=51&type=1&sort=-1&displayName=短信ss&pid=0&icon=user&createTime=2019-05-26T04:00:31.000+0000&children[0][id]=52&children[0][type]=1&children[0][sort]=1&children[0][displayName]=短信签名&children[0][pid]=51&children[0][handler]=/sms/sign-list&children[0][icon]=user&children[0][createTime]=2019-05-26T04:01:56.000+0000&children[0][children]=&children[1][id]=53&children[1][type]=1&children[1][sort]=2&children[1][displayName]=短信模板&children[1][pid]=51&children[1][handler]=/sms/template-list&children[1][icon]=user&children[1][createTime]=2019-05-26T04:02:19.000+0000&children[1][children]=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:53:20', 119, 0, '', '2019-06-03 13:53:20');
INSERT INTO `access_log` VALUES (24082, '65.53.15595412004686089', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:53:20', 9, 0, '', '2019-06-03 13:53:20');
INSERT INTO `access_log` VALUES (24083, '65.46.15595412079526111', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:53:28', 10, 0, '', '2019-06-03 13:53:28');
INSERT INTO `access_log` VALUES (24084, '65.54.15595412079526083', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:53:28', 9, 0, '', '2019-06-03 13:53:28');
INSERT INTO `access_log` VALUES (24085, '65.52.15595412079526103', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:53:28', 10, 0, '', '2019-06-03 13:53:28');
INSERT INTO `access_log` VALUES (24086, '65.50.15595412080486123', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:53:28', 16, 0, '', '2019-06-03 13:53:28');
INSERT INTO `access_log` VALUES (24087, '59.77.15595412220216251', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '218.93.39.18', '2019-06-03 13:53:42', 3, 0, '', '2019-06-03 13:53:42');
INSERT INTO `access_log` VALUES (24088, '59.71.15595412220216263', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '218.93.39.18', '2019-06-03 13:53:42', 11, 2001001000, '服务端发生异常', '2019-06-03 13:53:42');
INSERT INTO `access_log` VALUES (24089, '65.48.15595412394986119', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.254.115.146', '2019-06-03 13:53:59', 0, 1002001015, '账号未登陆', '2019-06-03 13:54:00');
INSERT INTO `access_log` VALUES (24090, '65.47.15595412395036119', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.254.115.146', '2019-06-03 13:54:00', 1, 1002001015, '账号未登陆', '2019-06-03 13:54:00');
INSERT INTO `access_log` VALUES (24091, '65.53.15595412395056091', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.254.115.146', '2019-06-03 13:54:00', 0, 1002001015, '账号未登陆', '2019-06-03 13:54:00');
INSERT INTO `access_log` VALUES (24092, '65.45.15595412418186135', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.254.115.146', '2019-06-03 13:54:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 13:54:02');
INSERT INTO `access_log` VALUES (24093, '65.50.15595412482306125', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.254.115.146', '2019-06-03 13:54:08', 637, 0, '', '2019-06-03 13:54:09');
INSERT INTO `access_log` VALUES (24094, '65.52.15595412491146105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.254.115.146', '2019-06-03 13:54:09', 160, 0, '', '2019-06-03 13:54:09');
INSERT INTO `access_log` VALUES (24095, '65.46.15595412491186113', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.254.115.146', '2019-06-03 13:54:09', 157, 0, '', '2019-06-03 13:54:09');
INSERT INTO `access_log` VALUES (24096, '65.51.15595412491216109', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.254.115.146', '2019-06-03 13:54:09', 156, 0, '', '2019-06-03 13:54:09');
INSERT INTO `access_log` VALUES (24097, '62.88.15595412561786139', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.254.115.146', '2019-06-03 13:54:16', 14, 0, '', '2019-06-03 13:54:16');
INSERT INTO `access_log` VALUES (24098, '65.49.15595412610786133', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:54:21', 0, 1002001015, '账号未登陆', '2019-06-03 13:54:21');
INSERT INTO `access_log` VALUES (24099, '65.48.15595412610796121', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:54:21', 0, 1002001015, '账号未登陆', '2019-06-03 13:54:21');
INSERT INTO `access_log` VALUES (24100, '65.47.15595412610796121', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:54:21', 0, 1002001015, '账号未登陆', '2019-06-03 13:54:21');
INSERT INTO `access_log` VALUES (24101, '65.53.15595412637596093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:54:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 13:54:24');
INSERT INTO `access_log` VALUES (24102, '65.50.15595412643236127', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.254.115.146', '2019-06-03 13:54:24', 20, 0, '', '2019-06-03 13:54:24');
INSERT INTO `access_log` VALUES (24103, '65.54.15595412656276087', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.254.115.146', '2019-06-03 13:54:26', 10, 0, '', '2019-06-03 13:54:26');
INSERT INTO `access_log` VALUES (24104, '65.51.15595412675196111', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:54:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 13:54:28');
INSERT INTO `access_log` VALUES (24105, '65.46.15595412681386115', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.254.115.146', '2019-06-03 13:54:28', 16, 0, '', '2019-06-03 13:54:28');
INSERT INTO `access_log` VALUES (24106, '65.47.15595412854386123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:54:45', 73, 0, '', '2019-06-03 13:54:46');
INSERT INTO `access_log` VALUES (24107, '65.49.15595412858296135', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:54:46', 9, 0, '', '2019-06-03 13:54:46');
INSERT INTO `access_log` VALUES (24108, '65.48.15595412858786123', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:54:46', 9, 0, '', '2019-06-03 13:54:46');
INSERT INTO `access_log` VALUES (24109, '65.53.15595412858806095', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:54:46', 9, 0, '', '2019-06-03 13:54:46');
INSERT INTO `access_log` VALUES (24110, '65.50.15595412942146129', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=51&type=1&sort=-1&displayName=短信服务&pid=0&icon=user&createTime=2019-05-26T04:00:31.000+0000&children[0][id]=52&children[0][type]=1&children[0][sort]=1&children[0][displayName]=短信签名&children[0][pid]=51&children[0][handler]=/sms/sign-list&children[0][icon]=user&children[0][createTime]=2019-05-26T04:01:56.000+0000&children[0][children]=&children[1][id]=53&children[1][type]=1&children[1][sort]=2&children[1][displayName]=短信模板&children[1][pid]=51&children[1][handler]=/sms/template-list&children[1][icon]=user&children[1][createTime]=2019-05-26T04:02:19.000+0000&children[1][children]=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:54:54', 108, 0, '', '2019-06-03 13:54:54');
INSERT INTO `access_log` VALUES (24111, '65.51.15595412945276113', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:54:55', 9, 0, '', '2019-06-03 13:54:55');
INSERT INTO `access_log` VALUES (24112, '65.54.15595412945166089', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=51&type=1&sort=-1&displayName=短信ss&pid=0&icon=user&createTime=2019-05-26T04:00:31.000+0000&children[0][id]=52&children[0][type]=1&children[0][sort]=1&children[0][displayName]=短信签名&children[0][pid]=51&children[0][handler]=/sms/sign-list&children[0][icon]=user&children[0][createTime]=2019-05-26T04:01:56.000+0000&children[0][children]=&children[1][id]=53&children[1][type]=1&children[1][sort]=2&children[1][displayName]=短信模板&children[1][pid]=51&children[1][handler]=/sms/template-list&children[1][icon]=user&children[1][createTime]=2019-05-26T04:02:19.000+0000&children[1][children]=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:54:55', 107, 0, '', '2019-06-03 13:54:55');
INSERT INTO `access_log` VALUES (24113, '65.46.15595412948466117', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.130', '2019-06-03 13:54:55', 10, 0, '', '2019-06-03 13:54:55');
INSERT INTO `access_log` VALUES (24114, '62.87.15595413009236141', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:55:01', 12, 0, '', '2019-06-03 13:55:01');
INSERT INTO `access_log` VALUES (24115, '64.76.15595413105185845', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:55:11', 10, 0, '', '2019-06-03 13:55:11');
INSERT INTO `access_log` VALUES (24116, '64.77.15595413105345859', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:55:11', 7, 0, '', '2019-06-03 13:55:11');
INSERT INTO `access_log` VALUES (24117, '59.77.15595413400296253', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:55:40', 21, 2001001000, '服务端发生异常', '2019-06-03 13:55:40');
INSERT INTO `access_log` VALUES (24118, '65.48.15595413449196125', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:55:45', 202, 0, '', '2019-06-03 13:55:45');
INSERT INTO `access_log` VALUES (24119, '65.53.15595413477606097', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:55:48', 28, 0, '', '2019-06-03 13:55:48');
INSERT INTO `access_log` VALUES (24120, '65.50.15595413552356131', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.160.111.234', '2019-06-03 13:55:55', 1, 1002001015, '账号未登陆', '2019-06-03 13:55:55');
INSERT INTO `access_log` VALUES (24121, '65.51.15595413552376115', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.160.111.234', '2019-06-03 13:55:55', 0, 1002001015, '账号未登陆', '2019-06-03 13:55:55');
INSERT INTO `access_log` VALUES (24122, '65.54.15595413552406091', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.160.111.234', '2019-06-03 13:55:55', 1, 1002001015, '账号未登陆', '2019-06-03 13:55:55');
INSERT INTO `access_log` VALUES (24123, '65.46.15595413573646119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.160.111.234', '2019-06-03 13:55:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 13:55:57');
INSERT INTO `access_log` VALUES (24124, '65.52.15595413575186111', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:55:58', 9, 0, '', '2019-06-03 13:55:58');
INSERT INTO `access_log` VALUES (24125, '65.47.15595413663156127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.160.111.234', '2019-06-03 13:56:06', 119, 0, '', '2019-06-03 13:56:06');
INSERT INTO `access_log` VALUES (24126, '65.48.15595413734776127', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:56:13', 12, 0, '', '2019-06-03 13:56:13');
INSERT INTO `access_log` VALUES (24127, '65.53.15595413837736099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.160.111.234', '2019-06-03 13:56:24', 58, 0, '', '2019-06-03 13:56:24');
INSERT INTO `access_log` VALUES (24128, '65.50.15595413840716133', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.160.111.234', '2019-06-03 13:56:24', 9, 0, '', '2019-06-03 13:56:24');
INSERT INTO `access_log` VALUES (24129, '65.51.15595413840756117', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.160.111.234', '2019-06-03 13:56:24', 8, 0, '', '2019-06-03 13:56:24');
INSERT INTO `access_log` VALUES (24130, '65.54.15595413840786093', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.160.111.234', '2019-06-03 13:56:24', 9, 0, '', '2019-06-03 13:56:24');
INSERT INTO `access_log` VALUES (24131, '64.85.15595413874785869', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:56:27', 8, 0, '', '2019-06-03 13:56:27');
INSERT INTO `access_log` VALUES (24132, '64.83.15595413874785849', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:56:27', 91, 0, '', '2019-06-03 13:56:28');
INSERT INTO `access_log` VALUES (24133, '62.80.15595413901826143', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.160.111.234', '2019-06-03 13:56:30', 13, 0, '', '2019-06-03 13:56:30');
INSERT INTO `access_log` VALUES (24134, '64.77.15595413909765861', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:56:31', 8, 0, '', '2019-06-03 13:56:31');
INSERT INTO `access_log` VALUES (24135, '64.76.15595413909765847', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:56:31', 12, 0, '', '2019-06-03 13:56:31');
INSERT INTO `access_log` VALUES (24136, '64.78.15595413909755857', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:56:31', 14, 0, '', '2019-06-03 13:56:31');
INSERT INTO `access_log` VALUES (24137, '66.48.15595413991194975', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.160.111.234', '2019-06-03 13:56:39', 21, 0, '', '2019-06-03 13:56:39');
INSERT INTO `access_log` VALUES (24138, '64.80.15595414005905847', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:56:41', 11, 0, '', '2019-06-03 13:56:41');
INSERT INTO `access_log` VALUES (24139, '64.79.15595414005985849', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:56:41', 8, 0, '', '2019-06-03 13:56:41');
INSERT INTO `access_log` VALUES (24140, '64.82.15595414065595863', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:56:47', 11, 0, '', '2019-06-03 13:56:47');
INSERT INTO `access_log` VALUES (24141, '64.81.15595414085095851', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.64.119.112', '2019-06-03 13:56:49', 10, 0, '', '2019-06-03 13:56:49');
INSERT INTO `access_log` VALUES (24142, '59.73.15595418019546271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.254.115.146', '2019-06-03 14:03:22', 4, 0, '', '2019-06-03 14:03:22');
INSERT INTO `access_log` VALUES (24143, '59.74.15595418019546263', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.254.115.146', '2019-06-03 14:03:22', 20, 2001001000, '服务端发生异常', '2019-06-03 14:03:22');
INSERT INTO `access_log` VALUES (24144, '64.79.15595418124825855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.254.115.146', '2019-06-03 14:03:32', 3, 0, '', '2019-06-03 14:03:32');
INSERT INTO `access_log` VALUES (24145, '64.82.15595418125705869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.254.115.146', '2019-06-03 14:03:33', 2, 0, '', '2019-06-03 14:03:33');
INSERT INTO `access_log` VALUES (24146, '64.81.15595418143865857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.254.115.146', '2019-06-03 14:03:34', 1, 0, '', '2019-06-03 14:03:34');
INSERT INTO `access_log` VALUES (24147, '64.85.15595418150425877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.254.115.146', '2019-06-03 14:03:35', 2, 0, '', '2019-06-03 14:03:35');
INSERT INTO `access_log` VALUES (24148, '64.76.15595418163265855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.254.115.146', '2019-06-03 14:03:36', 2, 0, '', '2019-06-03 14:03:36');
INSERT INTO `access_log` VALUES (24149, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.254.115.146', '2019-06-03 14:03:36', 29, 0, '', '2019-06-03 14:03:36');
INSERT INTO `access_log` VALUES (24150, '64.78.15595418173385865', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.254.115.146', '2019-06-03 14:03:37', 8, 0, '', '2019-06-03 14:03:37');
INSERT INTO `access_log` VALUES (24151, '64.79.15595420013305859', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 14:06:41', 43, 0, '', '2019-06-03 14:06:41');
INSERT INTO `access_log` VALUES (24152, '64.80.15595420013275857', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 14:06:41', 46, 0, '', '2019-06-03 14:06:41');
INSERT INTO `access_log` VALUES (24153, '64.82.15595420040945873', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 14:06:44', 9, 0, '', '2019-06-03 14:06:44');
INSERT INTO `access_log` VALUES (24154, '64.81.15595420040945861', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 14:06:44', 9, 0, '', '2019-06-03 14:06:44');
INSERT INTO `access_log` VALUES (24155, '64.85.15595420065455881', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 14:06:47', 11, 0, '', '2019-06-03 14:06:47');
INSERT INTO `access_log` VALUES (24156, '64.83.15595420065495861', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 14:06:47', 8, 0, '', '2019-06-03 14:06:47');
INSERT INTO `access_log` VALUES (24157, '64.76.15595420080625859', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 14:06:48', 9, 0, '', '2019-06-03 14:06:48');
INSERT INTO `access_log` VALUES (24158, '64.78.15595420080635869', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 14:06:48', 11, 0, '', '2019-06-03 14:06:48');
INSERT INTO `access_log` VALUES (24159, '64.84.15595420131385871', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 14:06:53', 9, 0, '', '2019-06-03 14:06:53');
INSERT INTO `access_log` VALUES (24160, '64.80.15595420131535859', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 14:06:53', 7, 0, '', '2019-06-03 14:06:53');
INSERT INTO `access_log` VALUES (24161, '65.47.15595420148566137', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:06:55', 0, 1002001015, '账号未登陆', '2019-06-03 14:06:55');
INSERT INTO `access_log` VALUES (24162, '65.49.15595420148596149', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:06:55', 0, 1002001015, '账号未登陆', '2019-06-03 14:06:55');
INSERT INTO `access_log` VALUES (24163, '65.48.15595420148596137', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:06:55', 0, 1002001015, '账号未登陆', '2019-06-03 14:06:55');
INSERT INTO `access_log` VALUES (24164, '65.53.15595420196156109', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:07:00', 286, 0, '', '2019-06-03 14:07:00');
INSERT INTO `access_log` VALUES (24165, '65.45.15595420204136153', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:07:00', 448, 0, '', '2019-06-03 14:07:01');
INSERT INTO `access_log` VALUES (24166, '65.51.15595420205056127', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:07:01', 358, 0, '', '2019-06-03 14:07:01');
INSERT INTO `access_log` VALUES (24167, '65.50.15595420205056143', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:07:01', 362, 0, '', '2019-06-03 14:07:01');
INSERT INTO `access_log` VALUES (24168, '65.46.15595420416106131', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:07:22', 10, 0, '', '2019-06-03 14:07:22');
INSERT INTO `access_log` VALUES (24169, '65.52.15595420416136123', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:07:22', 8, 0, '', '2019-06-03 14:07:22');
INSERT INTO `access_log` VALUES (24170, '65.48.15595420416146139', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:07:22', 10, 0, '', '2019-06-03 14:07:22');
INSERT INTO `access_log` VALUES (24171, '62.84.15595420467956137', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:07:27', 13, 0, '', '2019-06-03 14:07:27');
INSERT INTO `access_log` VALUES (24172, '62.85.15595420504596151', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:07:30', 15, 0, '', '2019-06-03 14:07:30');
INSERT INTO `access_log` VALUES (24173, '66.50.15595420614204983', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:07:41', 15, 0, '', '2019-06-03 14:07:41');
INSERT INTO `access_log` VALUES (24174, '65.53.15595420691916111', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:07:49', 18, 0, '', '2019-06-03 14:07:49');
INSERT INTO `access_log` VALUES (24175, '59.73.15595420756606275', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-03 14:07:56', 219, 0, '', '2019-06-03 14:07:56');
INSERT INTO `access_log` VALUES (24176, '59.75.15595424274156277', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.13.96.107', '2019-06-03 14:13:47', 3, 0, '', '2019-06-03 14:13:47');
INSERT INTO `access_log` VALUES (24177, '59.80.15595424274156271', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.13.96.107', '2019-06-03 14:13:47', 13, 2001001000, '服务端发生异常', '2019-06-03 14:13:47');
INSERT INTO `access_log` VALUES (24178, '64.80.15595424330325865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.13.96.107', '2019-06-03 14:13:53', 2, 0, '', '2019-06-03 14:13:53');
INSERT INTO `access_log` VALUES (24179, '64.84.15595424331635877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '175.13.96.107', '2019-06-03 14:13:53', 2, 0, '', '2019-06-03 14:13:53');
INSERT INTO `access_log` VALUES (24180, '59.76.15595430180276279', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:23:38', 3, 0, '', '2019-06-03 14:23:38');
INSERT INTO `access_log` VALUES (24181, '59.79.15595430180276285', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:23:38', 40, 2001001000, '服务端发生异常', '2019-06-03 14:23:38');
INSERT INTO `access_log` VALUES (24182, '64.84.15595430211955885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:23:41', 4, 0, '', '2019-06-03 14:23:41');
INSERT INTO `access_log` VALUES (24183, '64.79.15595430213345875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:23:41', 2, 0, '', '2019-06-03 14:23:41');
INSERT INTO `access_log` VALUES (24184, '64.81.15595430226085877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:23:43', 3, 0, '', '2019-06-03 14:23:43');
INSERT INTO `access_log` VALUES (24185, '64.82.15595430235695889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:23:44', 2, 0, '', '2019-06-03 14:23:44');
INSERT INTO `access_log` VALUES (24186, '59.71.15595430246186289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:23:45', 2, 0, '', '2019-06-03 14:23:45');
INSERT INTO `access_log` VALUES (24187, '59.77.15595430246186277', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:23:45', 12, 2001001000, '服务端发生异常', '2019-06-03 14:23:45');
INSERT INTO `access_log` VALUES (24188, '64.85.15595430261995897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:23:46', 2, 0, '', '2019-06-03 14:23:46');
INSERT INTO `access_log` VALUES (24189, '64.83.15595430263395877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:23:46', 2, 0, '', '2019-06-03 14:23:46');
INSERT INTO `access_log` VALUES (24190, '64.78.15595430279485885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:23:48', 2, 0, '', '2019-06-03 14:23:48');
INSERT INTO `access_log` VALUES (24191, '59.78.15595430291076289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:23:49', 2, 0, '', '2019-06-03 14:23:49');
INSERT INTO `access_log` VALUES (24192, '59.74.15595430291076281', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:23:49', 12, 2001001000, '服务端发生异常', '2019-06-03 14:23:49');
INSERT INTO `access_log` VALUES (24193, '65.48.15595430410316153', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:01', 0, 1002001015, '账号未登陆', '2019-06-03 14:24:01');
INSERT INTO `access_log` VALUES (24194, '65.52.15595430410316137', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:01', 0, 1002001015, '账号未登陆', '2019-06-03 14:24:01');
INSERT INTO `access_log` VALUES (24195, '65.47.15595430410326153', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:01', 0, 1002001015, '账号未登陆', '2019-06-03 14:24:01');
INSERT INTO `access_log` VALUES (24196, '65.49.15595430427376165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 14:24:03');
INSERT INTO `access_log` VALUES (24197, '65.53.15595430446886125', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 14:24:05');
INSERT INTO `access_log` VALUES (24198, '65.50.15595430721386159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:32', 209, 0, '', '2019-06-03 14:24:32');
INSERT INTO `access_log` VALUES (24199, '65.54.15595430726346119', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:33', 10, 0, '', '2019-06-03 14:24:33');
INSERT INTO `access_log` VALUES (24200, '65.46.15595430726366147', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:33', 9, 0, '', '2019-06-03 14:24:33');
INSERT INTO `access_log` VALUES (24201, '65.52.15595430726386139', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:33', 8, 0, '', '2019-06-03 14:24:33');
INSERT INTO `access_log` VALUES (24202, '62.86.15595430836276153', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:44', 14, 0, '', '2019-06-03 14:24:44');
INSERT INTO `access_log` VALUES (24203, '64.81.15595430869465879', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:47', 8, 0, '', '2019-06-03 14:24:47');
INSERT INTO `access_log` VALUES (24204, '64.79.15595430869445877', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:47', 158, 0, '', '2019-06-03 14:24:47');
INSERT INTO `access_log` VALUES (24205, '66.51.15595430899024991', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:50', 22, 0, '', '2019-06-03 14:24:50');
INSERT INTO `access_log` VALUES (24206, '65.49.15595430933286167', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.247.55.246', '2019-06-03 14:24:53', 1, 1002001015, '账号未登陆', '2019-06-03 14:24:53');
INSERT INTO `access_log` VALUES (24207, '65.47.15595430933286155', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.247.55.246', '2019-06-03 14:24:53', 1, 1002001015, '账号未登陆', '2019-06-03 14:24:53');
INSERT INTO `access_log` VALUES (24208, '65.53.15595430933306127', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.247.55.246', '2019-06-03 14:24:53', 0, 1002001015, '账号未登陆', '2019-06-03 14:24:53');
INSERT INTO `access_log` VALUES (24209, '65.46.15595430944266149', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:24:54', 0, 1002001015, '账号未登陆', '2019-06-03 14:24:54');
INSERT INTO `access_log` VALUES (24210, '65.50.15595430944256161', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:24:54', 0, 1002001015, '账号未登陆', '2019-06-03 14:24:54');
INSERT INTO `access_log` VALUES (24211, '65.51.15595430944256145', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:24:54', 0, 1002001015, '账号未登陆', '2019-06-03 14:24:54');
INSERT INTO `access_log` VALUES (24212, '59.79.15595430944506287', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:54', 401, 2001001000, '服务端发生异常', '2019-06-03 14:24:55');
INSERT INTO `access_log` VALUES (24213, '65.52.15595430975756141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:24:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 14:24:58');
INSERT INTO `access_log` VALUES (24214, '65.54.15595430979366121', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:58', 121, 0, '', '2019-06-03 14:24:58');
INSERT INTO `access_log` VALUES (24215, '59.71.15595430992456291', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.247.55.246', '2019-06-03 14:24:59', 4, 0, '', '2019-06-03 14:24:59');
INSERT INTO `access_log` VALUES (24216, '59.77.15595430992456279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.247.55.246', '2019-06-03 14:24:59', 13, 2001001000, '服务端发生异常', '2019-06-03 14:24:59');
INSERT INTO `access_log` VALUES (24217, '65.48.15595430994416157', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:24:59', 9, 0, '', '2019-06-03 14:24:59');
INSERT INTO `access_log` VALUES (24218, '65.49.15595431016836169', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:25:02', 9, 0, '', '2019-06-03 14:25:02');
INSERT INTO `access_log` VALUES (24219, '65.47.15595431036506157', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:25:04', 14, 0, '', '2019-06-03 14:25:04');
INSERT INTO `access_log` VALUES (24220, '65.53.15595431040006129', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:25:04', 63, 0, '', '2019-06-03 14:25:04');
INSERT INTO `access_log` VALUES (24221, '65.45.15595431043156173', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:25:04', 8, 0, '', '2019-06-03 14:25:04');
INSERT INTO `access_log` VALUES (24222, '65.50.15595431043286163', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:25:04', 10, 0, '', '2019-06-03 14:25:04');
INSERT INTO `access_log` VALUES (24223, '65.46.15595431043286151', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:25:04', 10, 0, '', '2019-06-03 14:25:04');
INSERT INTO `access_log` VALUES (24224, '64.83.15595431096095879', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:25:10', 15, 0, '', '2019-06-03 14:25:10');
INSERT INTO `access_log` VALUES (24225, '64.78.15595431096095887', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:25:10', 16, 0, '', '2019-06-03 14:25:10');
INSERT INTO `access_log` VALUES (24226, '65.52.15595431115956143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.247.55.246', '2019-06-03 14:25:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 14:25:12');
INSERT INTO `access_log` VALUES (24227, '65.54.15595431165056123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.247.55.246', '2019-06-03 14:25:17', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 14:25:17');
INSERT INTO `access_log` VALUES (24228, '65.48.15595431178156159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.247.55.246', '2019-06-03 14:25:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 14:25:18');
INSERT INTO `access_log` VALUES (24229, '65.49.15595431188086171', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.247.55.246', '2019-06-03 14:25:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 14:25:19');
INSERT INTO `access_log` VALUES (24230, '65.47.15595431193926159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.247.55.246', '2019-06-03 14:25:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 14:25:19');
INSERT INTO `access_log` VALUES (24231, '65.50.15595431257076165', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.1.83.16', '2019-06-03 14:25:26', 9, 0, '', '2019-06-03 14:25:26');
INSERT INTO `access_log` VALUES (24232, '64.77.15595431273615891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.247.55.246', '2019-06-03 14:25:27', 2, 0, '', '2019-06-03 14:25:27');
INSERT INTO `access_log` VALUES (24233, '64.80.15595431274645877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.247.55.246', '2019-06-03 14:25:27', 2, 0, '', '2019-06-03 14:25:27');
INSERT INTO `access_log` VALUES (24234, '65.46.15595431283006153', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.1.83.16', '2019-06-03 14:25:28', 10, 0, '', '2019-06-03 14:25:28');
INSERT INTO `access_log` VALUES (24235, '64.81.15595431294935881', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:25:29', 9, 0, '', '2019-06-03 14:25:30');
INSERT INTO `access_log` VALUES (24236, '64.84.15595431294935889', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:25:29', 11, 0, '', '2019-06-03 14:25:30');
INSERT INTO `access_log` VALUES (24237, '64.79.15595431295375879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.247.55.246', '2019-06-03 14:25:30', 2, 0, '', '2019-06-03 14:25:30');
INSERT INTO `access_log` VALUES (24238, '64.82.15595431305765893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.247.55.246', '2019-06-03 14:25:31', 1, 0, '', '2019-06-03 14:25:31');
INSERT INTO `access_log` VALUES (24239, '64.85.15595431326435901', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:25:33', 9, 0, '', '2019-06-03 14:25:33');
INSERT INTO `access_log` VALUES (24240, '64.78.15595431326465889', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:25:33', 10, 0, '', '2019-06-03 14:25:33');
INSERT INTO `access_log` VALUES (24241, '64.83.15595431326445881', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:25:33', 14, 0, '', '2019-06-03 14:25:33');
INSERT INTO `access_log` VALUES (24242, '64.77.15595431460025893', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:25:46', 10, 0, '', '2019-06-03 14:25:46');
INSERT INTO `access_log` VALUES (24243, '65.52.15595431572066145', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:25:57', 92, 0, '', '2019-06-03 14:25:57');
INSERT INTO `access_log` VALUES (24244, '59.80.15595431707596283', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '203.8.24.138', '2019-06-03 14:26:11', 3, 0, '', '2019-06-03 14:26:11');
INSERT INTO `access_log` VALUES (24245, '59.76.15595431707616283', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '203.8.24.138', '2019-06-03 14:26:11', 14, 2001001000, '服务端发生异常', '2019-06-03 14:26:11');
INSERT INTO `access_log` VALUES (24246, '65.48.15595431731796161', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:26:13', 26, 0, '', '2019-06-03 14:26:13');
INSERT INTO `access_log` VALUES (24247, '65.49.15595431744286173', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:26:14', 10, 0, '', '2019-06-03 14:26:14');
INSERT INTO `access_log` VALUES (24248, '65.47.15595431780126161', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:26:18', 13, 0, '', '2019-06-03 14:26:18');
INSERT INTO `access_log` VALUES (24249, '59.79.15595431787186289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '203.8.24.138', '2019-06-03 14:26:19', 2, 0, '', '2019-06-03 14:26:19');
INSERT INTO `access_log` VALUES (24250, '59.71.15595431787186293', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '203.8.24.138', '2019-06-03 14:26:19', 13, 2001001000, '服务端发生异常', '2019-06-03 14:26:19');
INSERT INTO `access_log` VALUES (24251, '64.79.15595431815275881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '203.8.24.138', '2019-06-03 14:26:22', 3, 0, '', '2019-06-03 14:26:22');
INSERT INTO `access_log` VALUES (24252, '64.82.15595431816975895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '203.8.24.138', '2019-06-03 14:26:22', 2, 0, '', '2019-06-03 14:26:22');
INSERT INTO `access_log` VALUES (24253, '64.78.15595431830355891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '203.8.24.138', '2019-06-03 14:26:23', 2, 0, '', '2019-06-03 14:26:23');
INSERT INTO `access_log` VALUES (24254, '64.83.15595431835545883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '203.8.24.138', '2019-06-03 14:26:24', 2, 0, '', '2019-06-03 14:26:24');
INSERT INTO `access_log` VALUES (24255, '65.50.15595431902106167', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:26:30', 149, 0, '', '2019-06-03 14:26:30');
INSERT INTO `access_log` VALUES (24256, '65.45.15595432017316177', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:26:42', 19, 0, '', '2019-06-03 14:26:42');
INSERT INTO `access_log` VALUES (24257, '65.51.15595432050606151', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:26:45', 12, 0, '', '2019-06-03 14:26:45');
INSERT INTO `access_log` VALUES (24258, '59.78.15595432160216293', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:26:56', 12, 0, '', '2019-06-03 14:26:56');
INSERT INTO `access_log` VALUES (24259, '59.72.15595432189926287', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:26:59', 20, 2001001000, '服务端发生异常', '2019-06-03 14:26:59');
INSERT INTO `access_log` VALUES (24260, '66.51.15595432251164993', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:27:05', 270, 0, '', '2019-06-03 14:27:05');
INSERT INTO `access_log` VALUES (24261, '62.89.15595432324806163', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.127.35.63', '2019-06-03 14:27:12', 13, 0, '', '2019-06-03 14:27:12');
INSERT INTO `access_log` VALUES (24262, '65.47.15595435846736167', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:33:05', 10, 1002001012, '访问令牌已过期', '2019-06-03 14:33:05');
INSERT INTO `access_log` VALUES (24263, '65.54.15595435846716131', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:33:05', 12, 1002001012, '访问令牌已过期', '2019-06-03 14:33:05');
INSERT INTO `access_log` VALUES (24264, '65.50.15595435846826173', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:33:05', 2, 1002001012, '访问令牌已过期', '2019-06-03 14:33:05');
INSERT INTO `access_log` VALUES (24265, '65.53.15595436104536141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:33:30', 76, 0, '', '2019-06-03 14:33:31');
INSERT INTO `access_log` VALUES (24266, '65.46.15595436107936161', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:33:31', 9, 0, '', '2019-06-03 14:33:31');
INSERT INTO `access_log` VALUES (24267, '65.51.15595436108006159', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:33:31', 9, 0, '', '2019-06-03 14:33:31');
INSERT INTO `access_log` VALUES (24268, '65.48.15595436108046171', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:33:31', 9, 0, '', '2019-06-03 14:33:31');
INSERT INTO `access_log` VALUES (24269, '62.82.15595436505936181', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:34:11', 16, 0, '', '2019-06-03 14:34:11');
INSERT INTO `access_log` VALUES (24270, '62.83.15595436652806171', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:34:25', 15, 0, '', '2019-06-03 14:34:25');
INSERT INTO `access_log` VALUES (24271, '64.80.15595436697335887', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:34:30', 11, 0, '', '2019-06-03 14:34:30');
INSERT INTO `access_log` VALUES (24272, '64.77.15595436697335901', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:34:30', 12, 0, '', '2019-06-03 14:34:30');
INSERT INTO `access_log` VALUES (24273, '64.79.15595436758135889', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:34:36', 9, 0, '', '2019-06-03 14:34:36');
INSERT INTO `access_log` VALUES (24274, '64.84.15595436758115899', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:34:36', 11, 0, '', '2019-06-03 14:34:36');
INSERT INTO `access_log` VALUES (24275, '64.82.15595436835675903', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:34:44', 8, 0, '', '2019-06-03 14:34:44');
INSERT INTO `access_log` VALUES (24276, '59.79.15595437099706297', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:35:10', 12, 0, '', '2019-06-03 14:35:10');
INSERT INTO `access_log` VALUES (24277, '59.71.15595437139846301', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:35:14', 20, 2001001000, '服务端发生异常', '2019-06-03 14:35:14');
INSERT INTO `access_log` VALUES (24278, '65.46.15595437236026163', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:35:24', 19, 0, '', '2019-06-03 14:35:24');
INSERT INTO `access_log` VALUES (24279, '65.49.15595437455606183', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:35:46', 17, 0, '', '2019-06-03 14:35:46');
INSERT INTO `access_log` VALUES (24280, '65.50.15595437466356177', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:35:47', 543, 0, '', '2019-06-03 14:35:47');
INSERT INTO `access_log` VALUES (24281, '65.54.15595437620146135', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.7', '2019-06-03 14:36:02', 11, 0, '', '2019-06-03 14:36:02');
INSERT INTO `access_log` VALUES (24282, '59.77.15595440178316293', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:40:18', 14, 2001001000, '服务端发生异常', '2019-06-03 14:40:18');
INSERT INTO `access_log` VALUES (24283, '59.73.15595440178326305', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:40:18', 553, 0, '', '2019-06-03 14:40:18');
INSERT INTO `access_log` VALUES (24284, '59.78.15595440294226305', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.176.33.221', '2019-06-03 14:40:29', 3, 0, '', '2019-06-03 14:40:29');
INSERT INTO `access_log` VALUES (24285, '59.72.15595440294276299', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.176.33.221', '2019-06-03 14:40:29', 13, 2001001000, '服务端发生异常', '2019-06-03 14:40:29');
INSERT INTO `access_log` VALUES (24286, '64.76.15595440341165893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.176.33.221', '2019-06-03 14:40:34', 2, 0, '', '2019-06-03 14:40:34');
INSERT INTO `access_log` VALUES (24287, '64.77.15595440342275907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.176.33.221', '2019-06-03 14:40:34', 2, 0, '', '2019-06-03 14:40:34');
INSERT INTO `access_log` VALUES (24288, '59.76.15595440428696297', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:40:43', 3, 0, '', '2019-06-03 14:40:43');
INSERT INTO `access_log` VALUES (24289, '59.80.15595440428696297', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:40:43', 13, 2001001000, '服务端发生异常', '2019-06-03 14:40:43');
INSERT INTO `access_log` VALUES (24290, '65.54.15595440436426139', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:40:44', 0, 1002001015, '账号未登陆', '2019-06-03 14:40:44');
INSERT INTO `access_log` VALUES (24291, '65.45.15595440436476193', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:40:44', 1, 1002001015, '账号未登陆', '2019-06-03 14:40:44');
INSERT INTO `access_log` VALUES (24292, '65.52.15595440436466161', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:40:44', 1, 1002001015, '账号未登陆', '2019-06-03 14:40:44');
INSERT INTO `access_log` VALUES (24293, '59.71.15595440543956307', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:40:54', 3, 0, '', '2019-06-03 14:40:54');
INSERT INTO `access_log` VALUES (24294, '59.73.15595440543966307', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:40:54', 10, 2001001000, '服务端发生异常', '2019-06-03 14:40:54');
INSERT INTO `access_log` VALUES (24295, '64.79.15595440572495895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:40:57', 394, 0, '', '2019-06-03 14:40:58');
INSERT INTO `access_log` VALUES (24296, '64.84.15595440578475905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:40:58', 412, 0, '', '2019-06-03 14:40:58');
INSERT INTO `access_log` VALUES (24297, '64.82.15595440588145909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:40:59', 2, 0, '', '2019-06-03 14:40:59');
INSERT INTO `access_log` VALUES (24298, '64.78.15595440600035905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:00', 3, 0, '', '2019-06-03 14:41:00');
INSERT INTO `access_log` VALUES (24299, '64.83.15595440608175897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:01', 2, 0, '', '2019-06-03 14:41:01');
INSERT INTO `access_log` VALUES (24300, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:01', 8, 0, '', '2019-06-03 14:41:01');
INSERT INTO `access_log` VALUES (24301, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:03', 8, 0, '', '2019-06-03 14:41:03');
INSERT INTO `access_log` VALUES (24302, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:05', 7, 0, '', '2019-06-03 14:41:05');
INSERT INTO `access_log` VALUES (24303, '64.76.15595440670225895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:07', 2, 0, '', '2019-06-03 14:41:07');
INSERT INTO `access_log` VALUES (24304, '64.77.15595440671245909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:07', 1, 0, '', '2019-06-03 14:41:07');
INSERT INTO `access_log` VALUES (24305, '64.80.15595440772325895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:17', 2, 0, '', '2019-06-03 14:41:17');
INSERT INTO `access_log` VALUES (24306, '64.81.15595440773455899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:17', 2, 0, '', '2019-06-03 14:41:17');
INSERT INTO `access_log` VALUES (24307, '65.51.15595440950786167', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:41:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 14:41:35');
INSERT INTO `access_log` VALUES (24308, '65.49.15595440970506189', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:41:37', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 14:41:37');
INSERT INTO `access_log` VALUES (24309, '64.82.15595441060895911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:46', 2, 0, '', '2019-06-03 14:41:46');
INSERT INTO `access_log` VALUES (24310, '64.78.15595441061945907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:46', 2, 0, '', '2019-06-03 14:41:46');
INSERT INTO `access_log` VALUES (24311, '59.72.15595441074026301', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:47', 3, 0, '', '2019-06-03 14:41:47');
INSERT INTO `access_log` VALUES (24312, '59.75.15595441074026305', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:47', 14, 2001001000, '服务端发生异常', '2019-06-03 14:41:47');
INSERT INTO `access_log` VALUES (24313, '64.83.15595441097485899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:50', 2, 0, '', '2019-06-03 14:41:50');
INSERT INTO `access_log` VALUES (24314, '64.85.15595441098685919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:50', 2, 0, '', '2019-06-03 14:41:50');
INSERT INTO `access_log` VALUES (24315, '64.77.15595441124185911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:52', 2, 0, '', '2019-06-03 14:41:52');
INSERT INTO `access_log` VALUES (24316, '64.80.15595441125655897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '221.176.33.221', '2019-06-03 14:41:53', 2, 0, '', '2019-06-03 14:41:53');
INSERT INTO `access_log` VALUES (24317, '65.52.15595441226666163', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:42:03', 104, 0, '', '2019-06-03 14:42:03');
INSERT INTO `access_log` VALUES (24318, '65.54.15595441231146141', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:42:03', 9, 0, '', '2019-06-03 14:42:03');
INSERT INTO `access_log` VALUES (24319, '65.45.15595441231186195', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:42:03', 9, 0, '', '2019-06-03 14:42:03');
INSERT INTO `access_log` VALUES (24320, '65.53.15595441231536151', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:42:03', 9, 0, '', '2019-06-03 14:42:03');
INSERT INTO `access_log` VALUES (24321, '62.81.15595441307706161', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:42:11', 13, 0, '', '2019-06-03 14:42:11');
INSERT INTO `access_log` VALUES (24322, '62.85.15595441423516181', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:42:22', 14, 0, '', '2019-06-03 14:42:22');
INSERT INTO `access_log` VALUES (24323, '64.84.15595441530305909', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:42:33', 11, 0, '', '2019-06-03 14:42:33');
INSERT INTO `access_log` VALUES (24324, '64.82.15595441530335913', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:42:33', 8, 0, '', '2019-06-03 14:42:33');
INSERT INTO `access_log` VALUES (24325, '64.85.15595441562155921', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:42:36', 12, 0, '', '2019-06-03 14:42:36');
INSERT INTO `access_log` VALUES (24326, '64.83.15595441562155901', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:42:36', 15, 0, '', '2019-06-03 14:42:36');
INSERT INTO `access_log` VALUES (24327, '64.80.15595441597935899', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:42:40', 15, 0, '', '2019-06-03 14:42:40');
INSERT INTO `access_log` VALUES (24328, '64.77.15595441597925913', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:42:40', 18, 0, '', '2019-06-03 14:42:40');
INSERT INTO `access_log` VALUES (24329, '64.76.15595441597915899', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:42:40', 22, 0, '', '2019-06-03 14:42:40');
INSERT INTO `access_log` VALUES (24330, '66.57.15595441780845009', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:42:58', 277, 0, '', '2019-06-03 14:42:58');
INSERT INTO `access_log` VALUES (24331, '59.77.15595441801616297', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:43:00', 94, 2001001000, '服务端发生异常', '2019-06-03 14:43:00');
INSERT INTO `access_log` VALUES (24332, '59.78.15595441843026309', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:43:04', 13, 0, '', '2019-06-03 14:43:04');
INSERT INTO `access_log` VALUES (24333, '59.72.15595441868586303', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:43:07', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 14:43:07');
INSERT INTO `access_log` VALUES (24334, '64.82.15595441939105915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:43:14', 2, 0, '', '2019-06-03 14:43:14');
INSERT INTO `access_log` VALUES (24335, '64.84.15595441940225911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:43:14', 1, 0, '', '2019-06-03 14:43:14');
INSERT INTO `access_log` VALUES (24336, '64.78.15595441953555911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:43:15', 46, 0, '', '2019-06-03 14:43:15');
INSERT INTO `access_log` VALUES (24337, '64.85.15595441960365923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.243.231', '2019-06-03 14:43:16', 2, 0, '', '2019-06-03 14:43:16');
INSERT INTO `access_log` VALUES (24338, '64.80.15595442117795901', 0, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=撒顶', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 14:43:32', 6, 1002001012, '访问令牌已过期', '2019-06-03 14:43:32');
INSERT INTO `access_log` VALUES (24339, '65.45.15595442298466197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 14:43:50', 110, 0, '', '2019-06-03 14:43:50');
INSERT INTO `access_log` VALUES (24340, '65.54.15595442311416143', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 14:43:51', 10, 0, '', '2019-06-03 14:43:51');
INSERT INTO `access_log` VALUES (24341, '65.53.15595442311436153', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 14:43:51', 9, 0, '', '2019-06-03 14:43:51');
INSERT INTO `access_log` VALUES (24342, '65.46.15595442311436173', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 14:43:51', 8, 0, '', '2019-06-03 14:43:51');
INSERT INTO `access_log` VALUES (24343, '64.81.15595442351695905', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 14:43:55', 9, 0, '', '2019-06-03 14:43:55');
INSERT INTO `access_log` VALUES (24344, '64.79.15595442351695903', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 14:43:55', 11, 0, '', '2019-06-03 14:43:55');
INSERT INTO `access_log` VALUES (24345, '64.82.15595442427665917', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=发', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 14:44:03', 8, 1002002009, NULL, '2019-06-03 14:44:03');
INSERT INTO `access_log` VALUES (24346, '64.78.15595442470185913', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=发色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 14:44:07', 8, 1002002009, NULL, '2019-06-03 14:44:07');
INSERT INTO `access_log` VALUES (24347, '64.85.15595442505945925', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 14:44:11', 6, 1002002009, NULL, '2019-06-03 14:44:11');
INSERT INTO `access_log` VALUES (24348, '64.83.15595442539915905', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=红色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 14:44:14', 71, 1002002009, NULL, '2019-06-03 14:44:14');
INSERT INTO `access_log` VALUES (24349, '64.80.15595442579165903', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=红色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 14:44:18', 8, 1002002009, NULL, '2019-06-03 14:44:18');
INSERT INTO `access_log` VALUES (24350, '64.76.15595442652105903', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=橘红色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 14:44:25', 8, 1002002009, NULL, '2019-06-03 14:44:25');
INSERT INTO `access_log` VALUES (24351, '64.79.15595442718285905', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=橘红橘红', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 14:44:32', 8, 1002002009, NULL, '2019-06-03 14:44:32');
INSERT INTO `access_log` VALUES (24352, '65.50.15595447154876193', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:51:55', 0, 1002001015, '账号未登陆', '2019-06-03 14:51:55');
INSERT INTO `access_log` VALUES (24353, '65.47.15595447154916187', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:51:55', 0, 1002001015, '账号未登陆', '2019-06-03 14:51:55');
INSERT INTO `access_log` VALUES (24354, '65.52.15595447154966173', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:51:55', 0, 1002001015, '账号未登陆', '2019-06-03 14:51:55');
INSERT INTO `access_log` VALUES (24355, '65.45.15595447218206205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:52:02', 66, 0, '', '2019-06-03 14:52:02');
INSERT INTO `access_log` VALUES (24356, '65.46.15595447221356181', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:52:02', 8, 0, '', '2019-06-03 14:52:02');
INSERT INTO `access_log` VALUES (24357, '65.53.15595447221386161', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:52:02', 7, 0, '', '2019-06-03 14:52:02');
INSERT INTO `access_log` VALUES (24358, '65.54.15595447221426151', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:52:02', 7, 0, '', '2019-06-03 14:52:02');
INSERT INTO `access_log` VALUES (24359, '62.84.15595447258616175', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:52:06', 20, 0, '', '2019-06-03 14:52:06');
INSERT INTO `access_log` VALUES (24360, '64.84.15595447282005921', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:52:08', 9, 0, '', '2019-06-03 14:52:08');
INSERT INTO `access_log` VALUES (24361, '64.82.15595447281975925', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:52:08', 12, 0, '', '2019-06-03 14:52:08');
INSERT INTO `access_log` VALUES (24362, '59.77.15595447317486305', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:52:12', 12, 0, '', '2019-06-03 14:52:12');
INSERT INTO `access_log` VALUES (24363, '64.78.15595447396225921', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:52:20', 10, 0, '', '2019-06-03 14:52:20');
INSERT INTO `access_log` VALUES (24364, '64.85.15595447396265933', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:52:20', 8, 0, '', '2019-06-03 14:52:20');
INSERT INTO `access_log` VALUES (24365, '59.75.15595447580166315', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:52:38', 13, 2001001000, '服务端发生异常', '2019-06-03 14:52:38');
INSERT INTO `access_log` VALUES (24366, '59.72.15595447580166311', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.69.36', '2019-06-03 14:52:38', 21, 0, '', '2019-06-03 14:52:38');
INSERT INTO `access_log` VALUES (24367, '59.74.15595448484166311', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:08', 3, 0, '', '2019-06-03 14:54:08');
INSERT INTO `access_log` VALUES (24368, '59.78.15595448484176319', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:08', 13, 2001001000, '服务端发生异常', '2019-06-03 14:54:08');
INSERT INTO `access_log` VALUES (24369, '64.78.15595448536525923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:14', 2, 0, '', '2019-06-03 14:54:14');
INSERT INTO `access_log` VALUES (24370, '64.85.15595448537495935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:14', 2, 0, '', '2019-06-03 14:54:14');
INSERT INTO `access_log` VALUES (24371, '59.72.15595448552536313', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:15', 3, 0, '', '2019-06-03 14:54:15');
INSERT INTO `access_log` VALUES (24372, '59.75.15595448553036317', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:15', 13, 2001001000, '服务端发生异常', '2019-06-03 14:54:15');
INSERT INTO `access_log` VALUES (24373, '64.83.15595448571295915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:17', 2, 0, '', '2019-06-03 14:54:17');
INSERT INTO `access_log` VALUES (24374, '64.80.15595448572365913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:17', 2, 0, '', '2019-06-03 14:54:17');
INSERT INTO `access_log` VALUES (24375, '64.77.15595448591365927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:19', 2, 0, '', '2019-06-03 14:54:19');
INSERT INTO `access_log` VALUES (24376, '64.76.15595448592805913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:19', 2, 0, '', '2019-06-03 14:54:19');
INSERT INTO `access_log` VALUES (24377, '66.56.15595448725765011', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13333333333', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:33', 80, 0, '', '2019-06-03 14:54:33');
INSERT INTO `access_log` VALUES (24378, '66.49.15595448770775017', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13333333333&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:37', 153, 0, '', '2019-06-03 14:54:37');
INSERT INTO `access_log` VALUES (24379, '66.48.15595448783955023', 66, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:38', 6, 0, '', '2019-06-03 14:54:38');
INSERT INTO `access_log` VALUES (24380, '66.53.15595448827655017', 66, 1, 'user-application', '/user-api/users/user/update_nickname', 'nickname=ds', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:43', 12, 0, '', '2019-06-03 14:54:43');
INSERT INTO `access_log` VALUES (24381, '66.55.15595448867905029', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:47', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机号不能为空\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空', '2019-06-03 14:54:47');
INSERT INTO `access_log` VALUES (24382, '66.50.15595448907425023', 66, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:51', 6, 0, '', '2019-06-03 14:54:51');
INSERT INTO `access_log` VALUES (24383, '66.56.15595448912475013', 66, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.116.147.146', '2019-06-03 14:54:51', 6, 0, '', '2019-06-03 14:54:51');
INSERT INTO `access_log` VALUES (24384, '65.51.15595450413596183', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 14:57:21', 0, 1002001015, '账号未登陆', '2019-06-03 14:57:21');
INSERT INTO `access_log` VALUES (24385, '65.49.15595450413606205', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 14:57:21', 0, 1002001015, '账号未登陆', '2019-06-03 14:57:21');
INSERT INTO `access_log` VALUES (24386, '65.52.15595450413696179', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 14:57:21', 0, 1002001015, '账号未登陆', '2019-06-03 14:57:21');
INSERT INTO `access_log` VALUES (24387, '65.50.15595450481236199', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 14:57:28', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 14:57:28');
INSERT INTO `access_log` VALUES (24388, '65.46.15595450611386187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 14:57:41', 88, 0, '', '2019-06-03 14:57:41');
INSERT INTO `access_log` VALUES (24389, '65.53.15595450614746167', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 14:57:41', 11, 0, '', '2019-06-03 14:57:41');
INSERT INTO `access_log` VALUES (24390, '65.54.15595450614776157', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 14:57:41', 10, 0, '', '2019-06-03 14:57:41');
INSERT INTO `access_log` VALUES (24391, '65.48.15595450614776197', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 14:57:41', 9, 0, '', '2019-06-03 14:57:41');
INSERT INTO `access_log` VALUES (24392, '62.80.15595450683406197', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 14:57:48', 13, 0, '', '2019-06-03 14:57:48');
INSERT INTO `access_log` VALUES (24393, '64.85.15595450717575939', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 14:57:52', 9, 0, '', '2019-06-03 14:57:52');
INSERT INTO `access_log` VALUES (24394, '64.83.15595450717575919', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 14:57:52', 11, 0, '', '2019-06-03 14:57:52');
INSERT INTO `access_log` VALUES (24395, '64.77.15595450760375931', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 14:57:56', 8, 0, '', '2019-06-03 14:57:56');
INSERT INTO `access_log` VALUES (24396, '64.80.15595450760365917', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 14:57:56', 10, 0, '', '2019-06-03 14:57:56');
INSERT INTO `access_log` VALUES (24397, '59.80.15595454713326319', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 15:04:31', 4, 0, '', '2019-06-03 15:04:31');
INSERT INTO `access_log` VALUES (24398, '59.79.15595454713376325', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 15:04:31', 12, 2001001000, '服务端发生异常', '2019-06-03 15:04:31');
INSERT INTO `access_log` VALUES (24399, '66.49.15595455097135027', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 15:05:10', 66, 0, '', '2019-06-03 15:05:10');
INSERT INTO `access_log` VALUES (24400, '59.74.15595455124446321', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 15:05:12', 10, 0, '', '2019-06-03 15:05:12');
INSERT INTO `access_log` VALUES (24401, '59.78.15595455171496329', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 15:05:17', 17, 2001001000, '服务端发生异常', '2019-06-03 15:05:17');
INSERT INTO `access_log` VALUES (24402, '59.75.15595455212346327', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 15:05:21', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 15:05:21');
INSERT INTO `access_log` VALUES (24403, '65.50.15595455232786207', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 15:05:23', 20, 0, '', '2019-06-03 15:05:23');
INSERT INTO `access_log` VALUES (24404, '65.48.15595455247116203', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 15:05:25', 8, 0, '', '2019-06-03 15:05:25');
INSERT INTO `access_log` VALUES (24405, '62.85.15595455267746201', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.202.28.53', '2019-06-03 15:05:27', 13, 0, '', '2019-06-03 15:05:27');
INSERT INTO `access_log` VALUES (24406, '65.51.15595455634616193', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.46.138', '2019-06-03 15:06:03', 0, 1002001015, '账号未登陆', '2019-06-03 15:06:03');
INSERT INTO `access_log` VALUES (24407, '65.53.15595455634696175', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.46.138', '2019-06-03 15:06:03', 0, 1002001015, '账号未登陆', '2019-06-03 15:06:03');
INSERT INTO `access_log` VALUES (24408, '65.54.15595455634706165', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.46.138', '2019-06-03 15:06:03', 1, 1002001015, '账号未登陆', '2019-06-03 15:06:03');
INSERT INTO `access_log` VALUES (24409, '65.49.15595455677136215', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.46.138', '2019-06-03 15:06:08', 91, 0, '', '2019-06-03 15:06:08');
INSERT INTO `access_log` VALUES (24410, '65.47.15595455680546203', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.46.138', '2019-06-03 15:06:08', 9, 0, '', '2019-06-03 15:06:08');
INSERT INTO `access_log` VALUES (24411, '65.50.15595455680606209', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.46.138', '2019-06-03 15:06:08', 9, 0, '', '2019-06-03 15:06:08');
INSERT INTO `access_log` VALUES (24412, '65.45.15595455680676219', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.46.138', '2019-06-03 15:06:08', 9, 0, '', '2019-06-03 15:06:08');
INSERT INTO `access_log` VALUES (24413, '62.83.15595455731466199', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.46.138', '2019-06-03 15:06:13', 11, 0, '', '2019-06-03 15:06:13');
INSERT INTO `access_log` VALUES (24414, '59.73.15595455839406331', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.46.138', '2019-06-03 15:06:24', 11, 0, '', '2019-06-03 15:06:24');
INSERT INTO `access_log` VALUES (24415, '65.52.15595455896616191', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '222.76.46.138', '2019-06-03 15:06:30', 19, 0, '', '2019-06-03 15:06:30');
INSERT INTO `access_log` VALUES (24416, '65.51.15595458621306199', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.60.78.135', '2019-06-03 15:11:02', 1, 1002001015, '账号未登陆', '2019-06-03 15:11:02');
INSERT INTO `access_log` VALUES (24417, '65.52.15595458621296195', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.60.78.135', '2019-06-03 15:11:02', 1, 1002001015, '账号未登陆', '2019-06-03 15:11:02');
INSERT INTO `access_log` VALUES (24418, '65.54.15595458621336171', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.60.78.135', '2019-06-03 15:11:02', 0, 1002001015, '账号未登陆', '2019-06-03 15:11:02');
INSERT INTO `access_log` VALUES (24419, '65.53.15595458659116179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.60.78.135', '2019-06-03 15:11:06', 107, 0, '', '2019-06-03 15:11:06');
INSERT INTO `access_log` VALUES (24420, '65.49.15595458662356221', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.60.78.135', '2019-06-03 15:11:06', 10, 0, '', '2019-06-03 15:11:06');
INSERT INTO `access_log` VALUES (24421, '65.47.15595458662406209', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.60.78.135', '2019-06-03 15:11:06', 9, 0, '', '2019-06-03 15:11:06');
INSERT INTO `access_log` VALUES (24422, '65.50.15595458662426215', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.60.78.135', '2019-06-03 15:11:06', 9, 0, '', '2019-06-03 15:11:06');
INSERT INTO `access_log` VALUES (24423, '62.87.15595458718836209', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.60.78.135', '2019-06-03 15:11:12', 13, 0, '', '2019-06-03 15:11:12');
INSERT INTO `access_log` VALUES (24424, '64.81.15595458766265933', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.60.78.135', '2019-06-03 15:11:17', 12, 0, '', '2019-06-03 15:11:17');
INSERT INTO `access_log` VALUES (24425, '64.79.15595458766305931', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.60.78.135', '2019-06-03 15:11:17', 9, 0, '', '2019-06-03 15:11:17');
INSERT INTO `access_log` VALUES (24426, '65.48.15595458796526211', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.60.78.135', '2019-06-03 15:11:20', 19, 0, '', '2019-06-03 15:11:20');
INSERT INTO `access_log` VALUES (24427, '65.46.15595458826736203', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.60.78.135', '2019-06-03 15:11:23', 10, 0, '', '2019-06-03 15:11:23');
INSERT INTO `access_log` VALUES (24428, '65.51.15595458844976201', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.60.78.135', '2019-06-03 15:11:24', 10, 0, '', '2019-06-03 15:11:25');
INSERT INTO `access_log` VALUES (24429, '65.54.15595458877176173', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.60.78.135', '2019-06-03 15:11:28', 14, 0, '', '2019-06-03 15:11:28');
INSERT INTO `access_log` VALUES (24430, '65.49.15595461844216227', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 15:16:24', 0, 1002001015, '账号未登陆', '2019-06-03 15:16:24');
INSERT INTO `access_log` VALUES (24431, '65.53.15595461844196185', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 15:16:24', 1, 1002001015, '账号未登陆', '2019-06-03 15:16:24');
INSERT INTO `access_log` VALUES (24432, '65.50.15595461844296221', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 15:16:24', 0, 1002001015, '账号未登陆', '2019-06-03 15:16:24');
INSERT INTO `access_log` VALUES (24433, '65.48.15595462148116217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 15:16:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 15:16:55');
INSERT INTO `access_log` VALUES (24434, '65.46.15595462169006209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 15:16:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 15:16:57');
INSERT INTO `access_log` VALUES (24435, '65.47.15595463099826217', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '153.101.119.162', '2019-06-03 15:18:30', 1, 1002001015, '账号未登陆', '2019-06-03 15:18:30');
INSERT INTO `access_log` VALUES (24436, '65.45.15595463099826233', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '153.101.119.162', '2019-06-03 15:18:30', 1, 1002001015, '账号未登陆', '2019-06-03 15:18:30');
INSERT INTO `access_log` VALUES (24437, '65.48.15595463099866219', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '153.101.119.162', '2019-06-03 15:18:30', 0, 1002001015, '账号未登陆', '2019-06-03 15:18:30');
INSERT INTO `access_log` VALUES (24438, '65.49.15595464020106231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 15:20:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 15:20:02');
INSERT INTO `access_log` VALUES (24439, '65.46.15595464451906213', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.237.67.146', '2019-06-03 15:20:45', 0, 1002001015, '账号未登陆', '2019-06-03 15:20:45');
INSERT INTO `access_log` VALUES (24440, '65.52.15595464451946207', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.237.67.146', '2019-06-03 15:20:45', 0, 1002001015, '账号未登陆', '2019-06-03 15:20:45');
INSERT INTO `access_log` VALUES (24441, '65.51.15595464451966211', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.237.67.146', '2019-06-03 15:20:45', 0, 1002001015, '账号未登陆', '2019-06-03 15:20:45');
INSERT INTO `access_log` VALUES (24442, '65.54.15595464499866183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.237.67.146', '2019-06-03 15:20:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 15:20:50');
INSERT INTO `access_log` VALUES (24443, '65.50.15595464559306227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.237.67.146', '2019-06-03 15:20:56', 453, 0, '', '2019-06-03 15:20:56');
INSERT INTO `access_log` VALUES (24444, '65.49.15595464566306233', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.237.67.146', '2019-06-03 15:20:57', 10, 0, '', '2019-06-03 15:20:57');
INSERT INTO `access_log` VALUES (24445, '65.45.15595464566356237', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.237.67.146', '2019-06-03 15:20:57', 10, 0, '', '2019-06-03 15:20:57');
INSERT INTO `access_log` VALUES (24446, '65.48.15595464566386223', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.237.67.146', '2019-06-03 15:20:57', 9, 0, '', '2019-06-03 15:20:57');
INSERT INTO `access_log` VALUES (24447, '62.87.15595464625376217', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.237.67.146', '2019-06-03 15:21:03', 12, 0, '', '2019-06-03 15:21:03');
INSERT INTO `access_log` VALUES (24448, '62.84.15595464688576201', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.237.67.146', '2019-06-03 15:21:09', 17, 0, '', '2019-06-03 15:21:09');
INSERT INTO `access_log` VALUES (24449, '64.84.15595464750845947', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.237.67.146', '2019-06-03 15:21:15', 9, 0, '', '2019-06-03 15:21:15');
INSERT INTO `access_log` VALUES (24450, '64.82.15595464750815953', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.237.67.146', '2019-06-03 15:21:15', 12, 0, '', '2019-06-03 15:21:15');
INSERT INTO `access_log` VALUES (24451, '66.51.15595464946315039', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.237.67.146', '2019-06-03 15:21:35', 13, 0, '', '2019-06-03 15:21:35');
INSERT INTO `access_log` VALUES (24452, '65.51.15595465106386213', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.237.67.146', '2019-06-03 15:21:51', 11, 0, '', '2019-06-03 15:21:51');
INSERT INTO `access_log` VALUES (24453, '65.49.15595467155456237', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:16', 10, 0, '', '2019-06-03 15:25:16');
INSERT INTO `access_log` VALUES (24454, '65.48.15595467155456227', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:16', 11, 0, '', '2019-06-03 15:25:16');
INSERT INTO `access_log` VALUES (24455, '65.47.15595467155516225', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:16', 8, 0, '', '2019-06-03 15:25:16');
INSERT INTO `access_log` VALUES (24456, '64.79.15595467158275943', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:16', 12, 0, '', '2019-06-03 15:25:16');
INSERT INTO `access_log` VALUES (24457, '64.81.15595467158295945', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:16', 8, 0, '', '2019-06-03 15:25:16');
INSERT INTO `access_log` VALUES (24458, '65.46.15595467189966219', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:19', 14, 0, '', '2019-06-03 15:25:19');
INSERT INTO `access_log` VALUES (24459, '65.52.15595467233386213', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:23', 9, 0, '', '2019-06-03 15:25:23');
INSERT INTO `access_log` VALUES (24460, '65.54.15595467241046189', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:24', 9, 0, '', '2019-06-03 15:25:24');
INSERT INTO `access_log` VALUES (24461, '65.53.15595467245266197', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:25', 18, 0, '', '2019-06-03 15:25:25');
INSERT INTO `access_log` VALUES (24462, '65.50.15595467249146233', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:25', 16, 0, '', '2019-06-03 15:25:25');
INSERT INTO `access_log` VALUES (24463, '65.45.15595467251866243', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:25', 10, 0, '', '2019-06-03 15:25:25');
INSERT INTO `access_log` VALUES (24464, '65.49.15595467292056239', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:29', 8, 0, '', '2019-06-03 15:25:29');
INSERT INTO `access_log` VALUES (24465, '65.47.15595467292076227', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:29', 7, 0, '', '2019-06-03 15:25:29');
INSERT INTO `access_log` VALUES (24466, '65.48.15595467292126229', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:29', 7, 0, '', '2019-06-03 15:25:29');
INSERT INTO `access_log` VALUES (24467, '65.46.15595467294086221', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:25:29', 10, 0, '', '2019-06-03 15:25:29');
INSERT INTO `access_log` VALUES (24468, '59.71.15595467520186347', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.220.1.29', '2019-06-03 15:25:52', 3, 0, '', '2019-06-03 15:25:52');
INSERT INTO `access_log` VALUES (24469, '59.73.15595467520296347', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.220.1.29', '2019-06-03 15:25:52', 10, 2001001000, '服务端发生异常', '2019-06-03 15:25:52');
INSERT INTO `access_log` VALUES (24470, '64.83.15595467573115943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.220.1.29', '2019-06-03 15:25:57', 2, 0, '', '2019-06-03 15:25:57');
INSERT INTO `access_log` VALUES (24471, '64.85.15595467574825965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.220.1.29', '2019-06-03 15:25:57', 2, 0, '', '2019-06-03 15:25:57');
INSERT INTO `access_log` VALUES (24472, '64.80.15595467638695943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.220.1.29', '2019-06-03 15:26:04', 2, 0, '', '2019-06-03 15:26:04');
INSERT INTO `access_log` VALUES (24473, '64.77.15595467640975955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.220.1.29', '2019-06-03 15:26:04', 2, 0, '', '2019-06-03 15:26:04');
INSERT INTO `access_log` VALUES (24474, '59.74.15595467700566339', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.176.217.33', '2019-06-03 15:26:10', 3, 0, '', '2019-06-03 15:26:10');
INSERT INTO `access_log` VALUES (24475, '59.78.15595467700576347', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.176.217.33', '2019-06-03 15:26:10', 12, 2001001000, '服务端发生异常', '2019-06-03 15:26:10');
INSERT INTO `access_log` VALUES (24476, '65.53.15595467742276199', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.220.1.29', '2019-06-03 15:26:14', 0, 1002001015, '账号未登陆', '2019-06-03 15:26:14');
INSERT INTO `access_log` VALUES (24477, '65.50.15595467742356235', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.220.1.29', '2019-06-03 15:26:14', 1, 1002001015, '账号未登陆', '2019-06-03 15:26:14');
INSERT INTO `access_log` VALUES (24478, '65.45.15595467742366245', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.220.1.29', '2019-06-03 15:26:14', 1, 1002001015, '账号未登陆', '2019-06-03 15:26:14');
INSERT INTO `access_log` VALUES (24479, '65.49.15595467774236241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.220.1.29', '2019-06-03 15:26:17', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 15:26:17');
INSERT INTO `access_log` VALUES (24480, '65.48.15595467821676231', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-03 15:26:22', 13, 0, '', '2019-06-03 15:26:22');
INSERT INTO `access_log` VALUES (24481, '65.46.15595467878996223', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.220.1.29', '2019-06-03 15:26:28', 78, 0, '', '2019-06-03 15:26:28');
INSERT INTO `access_log` VALUES (24482, '65.52.15595467933066217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.220.1.29', '2019-06-03 15:26:33', 119, 0, '', '2019-06-03 15:26:33');
INSERT INTO `access_log` VALUES (24483, '65.54.15595467994206193', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-03 15:26:39', 1, 1002001015, '账号未登陆', '2019-06-03 15:26:39');
INSERT INTO `access_log` VALUES (24484, '65.53.15595467994266201', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-03 15:26:39', 0, 1002001015, '账号未登陆', '2019-06-03 15:26:39');
INSERT INTO `access_log` VALUES (24485, '65.50.15595467994446237', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-03 15:26:39', 1, 1002001015, '账号未登陆', '2019-06-03 15:26:39');
INSERT INTO `access_log` VALUES (24486, '65.45.15595468020906247', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-03 15:26:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 15:26:42');
INSERT INTO `access_log` VALUES (24487, '65.49.15595468054376243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.220.1.29', '2019-06-03 15:26:45', 68, 0, '', '2019-06-03 15:26:46');
INSERT INTO `access_log` VALUES (24488, '65.48.15595468111626233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-03 15:26:51', 168, 0, '', '2019-06-03 15:26:51');
INSERT INTO `access_log` VALUES (24489, '65.46.15595468152746225', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-03 15:26:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 15:26:55');
INSERT INTO `access_log` VALUES (24490, '65.52.15595468200216219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-03 15:27:00', 79, 0, '', '2019-06-03 15:27:00');
INSERT INTO `access_log` VALUES (24491, '65.51.15595468274616223', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:07', 99, 0, '', '2019-06-03 15:27:08');
INSERT INTO `access_log` VALUES (24492, '65.54.15595468279036195', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:08', 9, 0, '', '2019-06-03 15:27:08');
INSERT INTO `access_log` VALUES (24493, '65.50.15595468279046239', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:08', 9, 0, '', '2019-06-03 15:27:08');
INSERT INTO `access_log` VALUES (24494, '65.53.15595468279056203', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:08', 9, 0, '', '2019-06-03 15:27:08');
INSERT INTO `access_log` VALUES (24495, '62.80.15595468335606223', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:14', 132, 0, '', '2019-06-03 15:27:14');
INSERT INTO `access_log` VALUES (24496, '65.48.15595468579346235', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:38', 9, 0, '', '2019-06-03 15:27:38');
INSERT INTO `access_log` VALUES (24497, '65.46.15595468579586227', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:38', 8, 0, '', '2019-06-03 15:27:38');
INSERT INTO `access_log` VALUES (24498, '65.47.15595468579586233', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:38', 9, 0, '', '2019-06-03 15:27:38');
INSERT INTO `access_log` VALUES (24499, '65.51.15595468612676225', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:41', 8, 0, '', '2019-06-03 15:27:41');
INSERT INTO `access_log` VALUES (24500, '65.50.15595468612746241', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:41', 8, 0, '', '2019-06-03 15:27:41');
INSERT INTO `access_log` VALUES (24501, '65.54.15595468612816197', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:41', 7, 0, '', '2019-06-03 15:27:41');
INSERT INTO `access_log` VALUES (24502, '65.53.15595468656216205', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:46', 9, 0, '', '2019-06-03 15:27:46');
INSERT INTO `access_log` VALUES (24503, '65.49.15595468656246247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:46', 19, 0, '', '2019-06-03 15:27:46');
INSERT INTO `access_log` VALUES (24504, '65.45.15595468656236251', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:46', 19, 0, '', '2019-06-03 15:27:46');
INSERT INTO `access_log` VALUES (24505, '64.80.15595468721015945', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:52', 10, 0, '', '2019-06-03 15:27:52');
INSERT INTO `access_log` VALUES (24506, '64.77.15595468721025957', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:52', 12, 0, '', '2019-06-03 15:27:52');
INSERT INTO `access_log` VALUES (24507, '64.76.15595468751535943', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:55', 9, 0, '', '2019-06-03 15:27:55');
INSERT INTO `access_log` VALUES (24508, '64.81.15595468751545949', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:27:55', 9, 0, '', '2019-06-03 15:27:55');
INSERT INTO `access_log` VALUES (24509, '64.84.15595469126945955', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=212', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:28:33', 886, 1002002009, NULL, '2019-06-03 15:28:34');
INSERT INTO `access_log` VALUES (24510, '64.83.15595469156785947', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=22', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:28:36', 8, 1002002009, NULL, '2019-06-03 15:28:36');
INSERT INTO `access_log` VALUES (24511, '59.79.15595469704356347', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:29:30', 12, 0, '', '2019-06-03 15:29:30');
INSERT INTO `access_log` VALUES (24512, '59.80.15595469736576341', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:29:34', 9, 0, '', '2019-06-03 15:29:34');
INSERT INTO `access_log` VALUES (24513, '59.71.15595469769316351', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.220.1.29', '2019-06-03 15:29:37', 11, 0, '', '2019-06-03 15:29:37');
INSERT INTO `access_log` VALUES (24514, '65.46.15595474961346237', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 15:38:16', 4, 1002001012, '访问令牌已过期', '2019-06-03 15:38:16');
INSERT INTO `access_log` VALUES (24515, '65.52.15595474961396231', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 15:38:16', 3, 1002001012, '访问令牌已过期', '2019-06-03 15:38:16');
INSERT INTO `access_log` VALUES (24516, '65.51.15595474961416235', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 15:38:16', 3, 1002001012, '访问令牌已过期', '2019-06-03 15:38:16');
INSERT INTO `access_log` VALUES (24517, '65.49.15595475386636257', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-03 15:38:59', 80, 0, '', '2019-06-03 15:38:59');
INSERT INTO `access_log` VALUES (24518, '65.53.15595475390846215', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-03 15:38:59', 10, 0, '', '2019-06-03 15:38:59');
INSERT INTO `access_log` VALUES (24519, '65.48.15595475390906247', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-03 15:38:59', 9, 0, '', '2019-06-03 15:38:59');
INSERT INTO `access_log` VALUES (24520, '65.47.15595475390936245', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-03 15:38:59', 8, 0, '', '2019-06-03 15:38:59');
INSERT INTO `access_log` VALUES (24521, '65.49.15595476313466259', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-03 15:40:31', 1, 1002001015, '账号未登陆', '2019-06-03 15:40:31');
INSERT INTO `access_log` VALUES (24522, '65.48.15595476456396249', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-03 15:40:46', 0, 1002001015, '账号未登陆', '2019-06-03 15:40:46');
INSERT INTO `access_log` VALUES (24523, '59.79.15595476700416357', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.192.178.155', '2019-06-03 15:41:10', 14, 2001001000, '服务端发生异常', '2019-06-03 15:41:10');
INSERT INTO `access_log` VALUES (24524, '59.80.15595476700516351', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.192.178.155', '2019-06-03 15:41:10', 11, 0, '', '2019-06-03 15:41:10');
INSERT INTO `access_log` VALUES (24525, '65.52.15595476788126235', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:41:19', 1, 1002001015, '账号未登陆', '2019-06-03 15:41:19');
INSERT INTO `access_log` VALUES (24526, '65.51.15595476788136239', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:41:19', 0, 1002001015, '账号未登陆', '2019-06-03 15:41:19');
INSERT INTO `access_log` VALUES (24527, '65.50.15595476788156255', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:41:19', 0, 1002001015, '账号未登陆', '2019-06-03 15:41:19');
INSERT INTO `access_log` VALUES (24528, '59.77.15595476802376349', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.10.7.178', '2019-06-03 15:41:20', 3, 0, '', '2019-06-03 15:41:20');
INSERT INTO `access_log` VALUES (24529, '59.71.15595476802366361', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.10.7.178', '2019-06-03 15:41:20', 10, 2001001000, '服务端发生异常', '2019-06-03 15:41:20');
INSERT INTO `access_log` VALUES (24530, '65.54.15595476803556211', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:41:20', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 15:41:20');
INSERT INTO `access_log` VALUES (24531, '64.77.15595476833815969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.10.7.178', '2019-06-03 15:41:23', 2, 0, '', '2019-06-03 15:41:23');
INSERT INTO `access_log` VALUES (24532, '64.80.15595476836715957', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.10.7.178', '2019-06-03 15:41:24', 2, 0, '', '2019-06-03 15:41:24');
INSERT INTO `access_log` VALUES (24533, '65.49.15595476866976261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:41:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 15:41:27');
INSERT INTO `access_log` VALUES (24534, '65.53.15595476963856219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:41:36', 82, 0, '', '2019-06-03 15:41:36');
INSERT INTO `access_log` VALUES (24535, '65.48.15595476966476251', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:41:37', 10, 0, '', '2019-06-03 15:41:37');
INSERT INTO `access_log` VALUES (24536, '65.47.15595476966486249', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:41:37', 9, 0, '', '2019-06-03 15:41:37');
INSERT INTO `access_log` VALUES (24537, '65.46.15595476966516243', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:41:37', 9, 0, '', '2019-06-03 15:41:37');
INSERT INTO `access_log` VALUES (24538, '62.87.15595477016176235', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:41:42', 11, 0, '', '2019-06-03 15:41:42');
INSERT INTO `access_log` VALUES (24539, '65.50.15595477018426257', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-03 15:41:42', 1, 1002001015, '账号未登陆', '2019-06-03 15:41:42');
INSERT INTO `access_log` VALUES (24540, '59.78.15595477055036361', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:41:46', 20, 2001001000, '服务端发生异常', '2019-06-03 15:41:46');
INSERT INTO `access_log` VALUES (24541, '65.51.15595477075656241', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:41:48', 4, 1002001012, '访问令牌已过期', '2019-06-03 15:41:48');
INSERT INTO `access_log` VALUES (24542, '65.54.15595477075686213', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:41:48', 3, 1002001012, '访问令牌已过期', '2019-06-03 15:41:48');
INSERT INTO `access_log` VALUES (24543, '65.45.15595477075726267', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:41:48', 2, 1002001012, '访问令牌已过期', '2019-06-03 15:41:48');
INSERT INTO `access_log` VALUES (24544, '59.75.15595477195826359', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:42:00', 3, 0, '', '2019-06-03 15:42:00');
INSERT INTO `access_log` VALUES (24545, '59.76.15595477195876353', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:42:00', 13, 2001001000, '服务端发生异常', '2019-06-03 15:42:00');
INSERT INTO `access_log` VALUES (24546, '65.53.15595477205996221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:42:01', 55, 0, '', '2019-06-03 15:42:01');
INSERT INTO `access_log` VALUES (24547, '65.48.15595477209176253', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:42:01', 9, 0, '', '2019-06-03 15:42:01');
INSERT INTO `access_log` VALUES (24548, '65.47.15595477239516251', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:42:04', 9, 0, '', '2019-06-03 15:42:04');
INSERT INTO `access_log` VALUES (24549, '64.79.15595477246905959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:42:05', 2, 0, '', '2019-06-03 15:42:05');
INSERT INTO `access_log` VALUES (24550, '64.82.15595477248165973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.6.69.201', '2019-06-03 15:42:05', 2, 0, '', '2019-06-03 15:42:05');
INSERT INTO `access_log` VALUES (24551, '64.83.15595477276085959', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:42:08', 8, 0, '', '2019-06-03 15:42:08');
INSERT INTO `access_log` VALUES (24552, '64.78.15595477276055967', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:42:08', 11, 0, '', '2019-06-03 15:42:08');
INSERT INTO `access_log` VALUES (24553, '65.52.15595477299526239', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:42:10', 446, 0, '', '2019-06-03 15:42:10');
INSERT INTO `access_log` VALUES (24554, '65.45.15595477539496269', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.42.111.50', '2019-06-03 15:42:34', 0, 1002001015, '账号未登陆', '2019-06-03 15:42:34');
INSERT INTO `access_log` VALUES (24555, '65.51.15595477539486243', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.42.111.50', '2019-06-03 15:42:34', 0, 1002001015, '账号未登陆', '2019-06-03 15:42:34');
INSERT INTO `access_log` VALUES (24556, '65.54.15595477539536215', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.42.111.50', '2019-06-03 15:42:34', 0, 1002001015, '账号未登陆', '2019-06-03 15:42:34');
INSERT INTO `access_log` VALUES (24557, '59.78.15595478033376363', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:43:23', 4, 0, '', '2019-06-03 15:43:23');
INSERT INTO `access_log` VALUES (24558, '59.72.15595478033386357', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:43:23', 13, 2001001000, '服务端发生异常', '2019-06-03 15:43:23');
INSERT INTO `access_log` VALUES (24559, '64.79.15595478063395961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:43:26', 2, 0, '', '2019-06-03 15:43:26');
INSERT INTO `access_log` VALUES (24560, '64.82.15595478064285975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:43:26', 1, 0, '', '2019-06-03 15:43:26');
INSERT INTO `access_log` VALUES (24561, '64.84.15595478077055969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:43:28', 2, 0, '', '2019-06-03 15:43:28');
INSERT INTO `access_log` VALUES (24562, '59.75.15595478089566361', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:43:29', 2, 0, '', '2019-06-03 15:43:29');
INSERT INTO `access_log` VALUES (24563, '59.76.15595478089566355', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:43:29', 12, 2001001000, '服务端发生异常', '2019-06-03 15:43:29');
INSERT INTO `access_log` VALUES (24564, '59.73.15595478430356365', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:44:03', 3, 0, '', '2019-06-03 15:44:03');
INSERT INTO `access_log` VALUES (24565, '59.71.15595478430356365', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.67.158.116', '2019-06-03 15:44:03', 13, 2001001000, '服务端发生异常', '2019-06-03 15:44:03');
INSERT INTO `access_log` VALUES (24566, '59.71.15595481225166369', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '180.159.254.51', '2019-06-03 15:48:43', 3, 0, '', '2019-06-03 15:48:43');
INSERT INTO `access_log` VALUES (24567, '59.77.15595481225186357', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '180.159.254.51', '2019-06-03 15:48:43', 12, 2001001000, '服务端发生异常', '2019-06-03 15:48:43');
INSERT INTO `access_log` VALUES (24568, '64.78.15595481258675973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '180.159.254.51', '2019-06-03 15:48:46', 3, 0, '', '2019-06-03 15:48:46');
INSERT INTO `access_log` VALUES (24569, '64.85.15595481259545987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '180.159.254.51', '2019-06-03 15:48:46', 2, 0, '', '2019-06-03 15:48:46');
INSERT INTO `access_log` VALUES (24570, '64.77.15595481271255977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '180.159.254.51', '2019-06-03 15:48:47', 2, 0, '', '2019-06-03 15:48:47');
INSERT INTO `access_log` VALUES (24571, '64.80.15595481277065965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '180.159.254.51', '2019-06-03 15:48:48', 2, 0, '', '2019-06-03 15:48:48');
INSERT INTO `access_log` VALUES (24572, '64.76.15595481282505963', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '180.159.254.51', '2019-06-03 15:48:48', 138, 0, '', '2019-06-03 15:48:48');
INSERT INTO `access_log` VALUES (24573, '59.78.15595481299446369', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '180.159.254.51', '2019-06-03 15:48:50', 3, 0, '', '2019-06-03 15:48:50');
INSERT INTO `access_log` VALUES (24574, '59.72.15595481299446363', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '180.159.254.51', '2019-06-03 15:48:50', 13, 2001001000, '服务端发生异常', '2019-06-03 15:48:50');
INSERT INTO `access_log` VALUES (24575, '59.76.15595481383156361', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '180.159.254.51', '2019-06-03 15:48:58', 3, 0, '', '2019-06-03 15:48:58');
INSERT INTO `access_log` VALUES (24576, '59.75.15595481383156367', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '180.159.254.51', '2019-06-03 15:48:58', 12, 2001001000, '服务端发生异常', '2019-06-03 15:48:58');
INSERT INTO `access_log` VALUES (24577, '64.79.15595481422225967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '180.159.254.51', '2019-06-03 15:49:02', 278, 0, '', '2019-06-03 15:49:03');
INSERT INTO `access_log` VALUES (24578, '64.82.15595481426445981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '180.159.254.51', '2019-06-03 15:49:03', 1, 0, '', '2019-06-03 15:49:03');
INSERT INTO `access_log` VALUES (24579, '59.77.15595481822546359', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.197', '2019-06-03 15:49:42', 3, 0, '', '2019-06-03 15:49:42');
INSERT INTO `access_log` VALUES (24580, '64.77.15595481871455979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.178.163', '2019-06-03 15:49:47', 34, 0, '', '2019-06-03 15:49:47');
INSERT INTO `access_log` VALUES (24581, '64.85.15595481870875989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.239.120', '2019-06-03 15:49:47', 91, 0, '', '2019-06-03 15:49:47');
INSERT INTO `access_log` VALUES (24582, '59.71.15595483175916373', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:51:58', 10, 2001001000, '服务端发生异常', '2019-06-03 15:51:58');
INSERT INTO `access_log` VALUES (24583, '59.77.15595483175906361', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:51:58', 50, 0, '', '2019-06-03 15:51:58');
INSERT INTO `access_log` VALUES (24584, '65.50.15595483279416269', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.21.32.154', '2019-06-03 15:52:08', 0, 1002001015, '账号未登陆', '2019-06-03 15:52:08');
INSERT INTO `access_log` VALUES (24585, '65.51.15595483279426253', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.21.32.154', '2019-06-03 15:52:08', 0, 1002001015, '账号未登陆', '2019-06-03 15:52:08');
INSERT INTO `access_log` VALUES (24586, '65.45.15595483279436277', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.21.32.154', '2019-06-03 15:52:08', 0, 1002001015, '账号未登陆', '2019-06-03 15:52:08');
INSERT INTO `access_log` VALUES (24587, '65.45.15595484318466279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.21.32.154', '2019-06-03 15:53:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 15:53:52');
INSERT INTO `access_log` VALUES (24588, '65.50.15595484484006271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.21.32.154', '2019-06-03 15:54:08', 65, 0, '', '2019-06-03 15:54:08');
INSERT INTO `access_log` VALUES (24589, '64.85.15595484547205993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:54:15', 3, 0, '', '2019-06-03 15:54:15');
INSERT INTO `access_log` VALUES (24590, '64.77.15595484548175983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:54:15', 2, 0, '', '2019-06-03 15:54:15');
INSERT INTO `access_log` VALUES (24591, '64.80.15595484558835971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:54:16', 2, 0, '', '2019-06-03 15:54:16');
INSERT INTO `access_log` VALUES (24592, '64.76.15595484564295969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:54:16', 2, 0, '', '2019-06-03 15:54:16');
INSERT INTO `access_log` VALUES (24593, '64.81.15595484569395975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:54:17', 204, 0, '', '2019-06-03 15:54:17');
INSERT INTO `access_log` VALUES (24594, '59.71.15595484581726375', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:54:18', 3, 0, '', '2019-06-03 15:54:18');
INSERT INTO `access_log` VALUES (24595, '59.74.15595484582106367', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:54:18', 13, 2001001000, '服务端发生异常', '2019-06-03 15:54:18');
INSERT INTO `access_log` VALUES (24596, '64.79.15595484601265973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:54:20', 1, 0, '', '2019-06-03 15:54:20');
INSERT INTO `access_log` VALUES (24597, '64.82.15595484602245987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:54:20', 2, 0, '', '2019-06-03 15:54:20');
INSERT INTO `access_log` VALUES (24598, '64.83.15595484641065973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:54:24', 2, 0, '', '2019-06-03 15:54:24');
INSERT INTO `access_log` VALUES (24599, '64.78.15595484642465981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:54:24', 2, 0, '', '2019-06-03 15:54:24');
INSERT INTO `access_log` VALUES (24600, '59.72.15595484664246369', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:54:26', 2, 0, '', '2019-06-03 15:54:26');
INSERT INTO `access_log` VALUES (24601, '59.76.15595484664246367', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.21.32.154', '2019-06-03 15:54:26', 12, 2001001000, '服务端发生异常', '2019-06-03 15:54:26');
INSERT INTO `access_log` VALUES (24602, '65.48.15595484850556265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.21.32.154', '2019-06-03 15:54:45', 95, 0, '', '2019-06-03 15:54:45');
INSERT INTO `access_log` VALUES (24603, '65.47.15595484884966263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.21.32.154', '2019-06-03 15:54:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 15:54:49');
INSERT INTO `access_log` VALUES (24604, '65.46.15595484930486259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.21.32.154', '2019-06-03 15:54:53', 88, 0, '', '2019-06-03 15:54:53');
INSERT INTO `access_log` VALUES (24605, '59.80.15595487764696371', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 baiduboxapp/10.5.0.10 (Baidu; P1 9)', '117.136.101.98', '2019-06-03 15:59:36', 3, 0, '', '2019-06-03 15:59:36');
INSERT INTO `access_log` VALUES (24606, '59.79.15595487764896377', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 baiduboxapp/10.5.0.10 (Baidu; P1 9)', '117.136.101.98', '2019-06-03 15:59:36', 13, 2001001000, '服务端发生异常', '2019-06-03 15:59:37');
INSERT INTO `access_log` VALUES (24607, '64.77.15595487824345989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 baiduboxapp/10.5.0.10 (Baidu; P1 9)', '117.136.101.98', '2019-06-03 15:59:42', 3, 0, '', '2019-06-03 15:59:42');
INSERT INTO `access_log` VALUES (24608, '64.80.15595487826585977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 baiduboxapp/10.5.0.10 (Baidu; P1 9)', '117.136.101.98', '2019-06-03 15:59:43', 2, 0, '', '2019-06-03 15:59:43');
INSERT INTO `access_log` VALUES (24609, '64.76.15595487848195975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 baiduboxapp/10.5.0.10 (Baidu; P1 9)', '117.136.101.98', '2019-06-03 15:59:45', 3, 0, '', '2019-06-03 15:59:45');
INSERT INTO `access_log` VALUES (24610, '64.81.15595487854545981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 baiduboxapp/10.5.0.10 (Baidu; P1 9)', '117.136.101.98', '2019-06-03 15:59:45', 2, 0, '', '2019-06-03 15:59:45');
INSERT INTO `access_log` VALUES (24611, '59.77.15595487864396369', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 baiduboxapp/10.5.0.10 (Baidu; P1 9)', '117.136.101.98', '2019-06-03 15:59:46', 3, 0, '', '2019-06-03 15:59:46');
INSERT INTO `access_log` VALUES (24612, '59.73.15595487864396381', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; TNY-AL00 Build/HUAWEITNY-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 baiduboxapp/10.5.0.10 (Baidu; P1 9)', '117.136.101.98', '2019-06-03 15:59:46', 10, 2001001000, '服务端发生异常', '2019-06-03 15:59:46');
INSERT INTO `access_log` VALUES (24613, '65.45.15595487883926285', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.109', '2019-06-03 15:59:48', 95, 1002001012, '访问令牌已过期', '2019-06-03 15:59:48');
INSERT INTO `access_log` VALUES (24614, '65.51.15595487883936261', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.109', '2019-06-03 15:59:48', 95, 1002001012, '访问令牌已过期', '2019-06-03 15:59:48');
INSERT INTO `access_log` VALUES (24615, '65.52.15595487883926257', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.109', '2019-06-03 15:59:48', 95, 1002001012, '访问令牌已过期', '2019-06-03 15:59:48');
INSERT INTO `access_log` VALUES (24616, '65.50.15595487933906277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.109', '2019-06-03 15:59:53', 310, 0, '', '2019-06-03 15:59:54');
INSERT INTO `access_log` VALUES (24617, '65.53.15595487939836241', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.109', '2019-06-03 15:59:54', 16, 0, '', '2019-06-03 15:59:54');
INSERT INTO `access_log` VALUES (24618, '65.54.15595487939826231', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.109', '2019-06-03 15:59:54', 16, 0, '', '2019-06-03 15:59:54');
INSERT INTO `access_log` VALUES (24619, '65.48.15595487939836271', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.109', '2019-06-03 15:59:54', 18, 0, '', '2019-06-03 15:59:54');
INSERT INTO `access_log` VALUES (24620, '62.82.15595487969306255', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.109', '2019-06-03 15:59:57', 13, 0, '', '2019-06-03 15:59:57');
INSERT INTO `access_log` VALUES (24621, '65.47.15595487993476269', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.254.105.235', '2019-06-03 15:59:59', 0, 1002001015, '账号未登陆', '2019-06-03 15:59:59');
INSERT INTO `access_log` VALUES (24622, '65.46.15595487993556265', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.254.105.235', '2019-06-03 15:59:59', 1, 1002001015, '账号未登陆', '2019-06-03 15:59:59');
INSERT INTO `access_log` VALUES (24623, '65.45.15595487993666287', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.254.105.235', '2019-06-03 15:59:59', 0, 1002001015, '账号未登陆', '2019-06-03 15:59:59');
INSERT INTO `access_log` VALUES (24624, '62.89.15595488040916243', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.109', '2019-06-03 16:00:04', 15, 0, '', '2019-06-03 16:00:04');
INSERT INTO `access_log` VALUES (24625, '65.52.15595488063816259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.254.105.235', '2019-06-03 16:00:06', 830, 0, '', '2019-06-03 16:00:07');
INSERT INTO `access_log` VALUES (24626, '65.51.15595488079366263', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.254.105.235', '2019-06-03 16:00:08', 10, 0, '', '2019-06-03 16:00:08');
INSERT INTO `access_log` VALUES (24627, '65.50.15595488079456279', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.254.105.235', '2019-06-03 16:00:08', 8, 0, '', '2019-06-03 16:00:08');
INSERT INTO `access_log` VALUES (24628, '65.49.15595488079536283', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.254.105.235', '2019-06-03 16:00:08', 9, 0, '', '2019-06-03 16:00:08');
INSERT INTO `access_log` VALUES (24629, '62.88.15595488139906253', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.254.105.235', '2019-06-03 16:00:14', 13, 0, '', '2019-06-03 16:00:14');
INSERT INTO `access_log` VALUES (24630, '62.80.15595488206516251', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.254.105.235', '2019-06-03 16:00:21', 14, 0, '', '2019-06-03 16:00:21');
INSERT INTO `access_log` VALUES (24631, '64.83.15595488230355979', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.254.105.235', '2019-06-03 16:00:23', 11, 0, '', '2019-06-03 16:00:23');
INSERT INTO `access_log` VALUES (24632, '64.78.15595488230385987', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.254.105.235', '2019-06-03 16:00:23', 8, 0, '', '2019-06-03 16:00:23');
INSERT INTO `access_log` VALUES (24633, '62.85.15595488324716249', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.109', '2019-06-03 16:00:32', 13, 0, '', '2019-06-03 16:00:32');
INSERT INTO `access_log` VALUES (24634, '59.72.15595488343656375', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.254.105.235', '2019-06-03 16:00:34', 11, 0, '', '2019-06-03 16:00:34');
INSERT INTO `access_log` VALUES (24635, '65.47.15595488401666271', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.254.105.235', '2019-06-03 16:00:40', 17, 0, '', '2019-06-03 16:00:40');
INSERT INTO `access_log` VALUES (24636, '65.52.15595488689606261', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:01:09', 0, 1002001015, '账号未登陆', '2019-06-03 16:01:09');
INSERT INTO `access_log` VALUES (24637, '65.49.15595488689666285', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:01:09', 0, 1002001015, '账号未登陆', '2019-06-03 16:01:09');
INSERT INTO `access_log` VALUES (24638, '65.50.15595488689726281', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:01:09', 0, 1002001015, '账号未登陆', '2019-06-03 16:01:09');
INSERT INTO `access_log` VALUES (24639, '65.51.15595488714276265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:01:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:01:11');
INSERT INTO `access_log` VALUES (24640, '65.54.15595488824756235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:01:22', 60, 0, '', '2019-06-03 16:01:23');
INSERT INTO `access_log` VALUES (24641, '65.48.15595488829116275', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:01:23', 9, 0, '', '2019-06-03 16:01:23');
INSERT INTO `access_log` VALUES (24642, '65.53.15595488829186245', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:01:23', 9, 0, '', '2019-06-03 16:01:23');
INSERT INTO `access_log` VALUES (24643, '65.47.15595488829206273', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:01:23', 8, 0, '', '2019-06-03 16:01:23');
INSERT INTO `access_log` VALUES (24644, '62.80.15595489001926253', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:01:40', 14, 0, '', '2019-06-03 16:01:40');
INSERT INTO `access_log` VALUES (24645, '65.52.15595489077636263', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:01:48', 1, 1002001015, '账号未登陆', '2019-06-03 16:01:48');
INSERT INTO `access_log` VALUES (24646, '65.49.15595489077656287', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:01:48', 1, 1002001015, '账号未登陆', '2019-06-03 16:01:48');
INSERT INTO `access_log` VALUES (24647, '65.50.15595489077706283', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:01:48', 0, 1002001015, '账号未登陆', '2019-06-03 16:01:48');
INSERT INTO `access_log` VALUES (24648, '65.54.15595489177946237', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:01:58', 87, 0, '', '2019-06-03 16:01:58');
INSERT INTO `access_log` VALUES (24649, '65.53.15595489180606247', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:01:58', 8, 0, '', '2019-06-03 16:01:58');
INSERT INTO `access_log` VALUES (24650, '65.47.15595489180736275', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:01:58', 9, 0, '', '2019-06-03 16:01:58');
INSERT INTO `access_log` VALUES (24651, '65.48.15595489180796277', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:01:58', 9, 0, '', '2019-06-03 16:01:58');
INSERT INTO `access_log` VALUES (24652, '62.81.15595489201186231', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:02:00', 14, 0, '', '2019-06-03 16:02:00');
INSERT INTO `access_log` VALUES (24653, '62.84.15595489244986237', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:04', 12, 0, '', '2019-06-03 16:02:05');
INSERT INTO `access_log` VALUES (24654, '64.84.15595489293765989', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:02:09', 12, 0, '', '2019-06-03 16:02:09');
INSERT INTO `access_log` VALUES (24655, '64.83.15595489293825981', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:02:09', 9, 0, '', '2019-06-03 16:02:09');
INSERT INTO `access_log` VALUES (24656, '62.86.15595489367406239', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:17', 13, 0, '', '2019-06-03 16:02:17');
INSERT INTO `access_log` VALUES (24657, '62.82.15595489374586259', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:17', 12, 0, '', '2019-06-03 16:02:17');
INSERT INTO `access_log` VALUES (24658, '64.78.15595489395335989', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:02:20', 11, 0, '', '2019-06-03 16:02:20');
INSERT INTO `access_log` VALUES (24659, '64.85.15595489395386003', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:02:20', 8, 0, '', '2019-06-03 16:02:20');
INSERT INTO `access_log` VALUES (24660, '64.76.15595489409445979', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:21', 71, 0, '', '2019-06-03 16:02:21');
INSERT INTO `access_log` VALUES (24661, '64.80.15595489409425981', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:21', 82, 0, '', '2019-06-03 16:02:21');
INSERT INTO `access_log` VALUES (24662, '64.79.15595489447695983', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:25', 9, 0, '', '2019-06-03 16:02:25');
INSERT INTO `access_log` VALUES (24663, '64.81.15595489447695985', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:25', 11, 0, '', '2019-06-03 16:02:25');
INSERT INTO `access_log` VALUES (24664, '64.82.15595489468445997', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:02:27', 10, 0, '', '2019-06-03 16:02:27');
INSERT INTO `access_log` VALUES (24665, '64.84.15595489486345991', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:02:29', 12, 0, '', '2019-06-03 16:02:29');
INSERT INTO `access_log` VALUES (24666, '64.83.15595489490185983', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:29', 11, 0, '', '2019-06-03 16:02:29');
INSERT INTO `access_log` VALUES (24667, '64.85.15595489514836005', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:31', 11, 0, '', '2019-06-03 16:02:31');
INSERT INTO `access_log` VALUES (24668, '64.78.15595489522425991', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:32', 11, 0, '', '2019-06-03 16:02:32');
INSERT INTO `access_log` VALUES (24669, '64.80.15595489552935983', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:35', 9, 0, '', '2019-06-03 16:02:35');
INSERT INTO `access_log` VALUES (24670, '64.77.15595489552925995', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:35', 10, 0, '', '2019-06-03 16:02:35');
INSERT INTO `access_log` VALUES (24671, '65.49.15595489588266289', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:02:39', 19, 0, '', '2019-06-03 16:02:39');
INSERT INTO `access_log` VALUES (24672, '65.52.15595489631396265', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:43', 26, 0, '', '2019-06-03 16:02:43');
INSERT INTO `access_log` VALUES (24673, '59.76.15595489661676375', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:02:46', 11, 0, '', '2019-06-03 16:02:46');
INSERT INTO `access_log` VALUES (24674, '65.51.15595489662666269', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:46', 9, 0, '', '2019-06-03 16:02:46');
INSERT INTO `access_log` VALUES (24675, '65.54.15595489676006239', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:48', 9, 0, '', '2019-06-03 16:02:48');
INSERT INTO `access_log` VALUES (24676, '65.48.15595489688976279', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:49', 69, 0, '', '2019-06-03 16:02:49');
INSERT INTO `access_log` VALUES (24677, '59.75.15595489701656381', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:02:50', 11, 0, '', '2019-06-03 16:02:50');
INSERT INTO `access_log` VALUES (24678, '66.52.15595489793045073', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:02:59', 21, 0, '', '2019-06-03 16:02:59');
INSERT INTO `access_log` VALUES (24679, '62.87.15595489931706255', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-03 16:03:13', 15, 0, '', '2019-06-03 16:03:13');
INSERT INTO `access_log` VALUES (24680, '59.72.15595491026966379', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.108.36.225', '2019-06-03 16:05:03', 3, 0, '', '2019-06-03 16:05:03');
INSERT INTO `access_log` VALUES (24681, '59.75.15595491026966383', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.108.36.225', '2019-06-03 16:05:03', 13, 2001001000, '服务端发生异常', '2019-06-03 16:05:03');
INSERT INTO `access_log` VALUES (24682, '59.73.15595491125596387', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:13', 13, 2001001000, '服务端发生异常', '2019-06-03 16:05:13');
INSERT INTO `access_log` VALUES (24683, '59.80.15595491125596377', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:13', 44, 0, '', '2019-06-03 16:05:13');
INSERT INTO `access_log` VALUES (24684, '64.79.15595491142705987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:14', 2, 0, '', '2019-06-03 16:05:14');
INSERT INTO `access_log` VALUES (24685, '64.81.15595491144175989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:14', 2, 0, '', '2019-06-03 16:05:14');
INSERT INTO `access_log` VALUES (24686, '64.82.15595491156136001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:16', 2, 0, '', '2019-06-03 16:05:16');
INSERT INTO `access_log` VALUES (24687, '64.84.15595491163715995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:16', 2, 0, '', '2019-06-03 16:05:16');
INSERT INTO `access_log` VALUES (24688, '64.83.15595491175055987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:18', 2, 0, '', '2019-06-03 16:05:18');
INSERT INTO `access_log` VALUES (24689, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:18', 13, 0, '', '2019-06-03 16:05:18');
INSERT INTO `access_log` VALUES (24690, '64.85.15595491190146009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:19', 2, 0, '', '2019-06-03 16:05:19');
INSERT INTO `access_log` VALUES (24691, '64.78.15595491191305995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:19', 2, 0, '', '2019-06-03 16:05:19');
INSERT INTO `access_log` VALUES (24692, '64.77.15595491198765999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:20', 2, 0, '', '2019-06-03 16:05:20');
INSERT INTO `access_log` VALUES (24693, '64.80.15595491203165987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:20', 2, 0, '', '2019-06-03 16:05:20');
INSERT INTO `access_log` VALUES (24694, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:20', 7, 0, '', '2019-06-03 16:05:20');
INSERT INTO `access_log` VALUES (24695, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:22', 6, 0, '', '2019-06-03 16:05:22');
INSERT INTO `access_log` VALUES (24696, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:23', 6, 0, '', '2019-06-03 16:05:23');
INSERT INTO `access_log` VALUES (24697, '64.79.15595491235335989', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:24', 9, 0, '', '2019-06-03 16:05:24');
INSERT INTO `access_log` VALUES (24698, '64.81.15595491295775991', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:30', 6, 0, '', '2019-06-03 16:05:30');
INSERT INTO `access_log` VALUES (24699, '64.82.15595491302126003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:30', 3, 0, '', '2019-06-03 16:05:30');
INSERT INTO `access_log` VALUES (24700, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:30', 7, 0, '', '2019-06-03 16:05:30');
INSERT INTO `access_log` VALUES (24701, '64.84.15595491309645997', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:31', 3, 0, '', '2019-06-03 16:05:31');
INSERT INTO `access_log` VALUES (24702, '64.83.15595491311115989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:31', 2, 0, '', '2019-06-03 16:05:31');
INSERT INTO `access_log` VALUES (24703, '64.85.15595491322636011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:32', 2, 0, '', '2019-06-03 16:05:32');
INSERT INTO `access_log` VALUES (24704, '64.78.15595491332785997', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:33', 2, 0, '', '2019-06-03 16:05:33');
INSERT INTO `access_log` VALUES (24705, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:33', 7, 0, '', '2019-06-03 16:05:33');
INSERT INTO `access_log` VALUES (24706, '64.80.15595491365875989', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:37', 5, 0, '', '2019-06-03 16:05:37');
INSERT INTO `access_log` VALUES (24707, '64.76.15595491397985987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:40', 2, 0, '', '2019-06-03 16:05:40');
INSERT INTO `access_log` VALUES (24708, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:40', 6, 0, '', '2019-06-03 16:05:40');
INSERT INTO `access_log` VALUES (24709, '64.79.15595491467255991', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:47', 7, 0, '', '2019-06-03 16:05:47');
INSERT INTO `access_log` VALUES (24710, '64.82.15595491527256005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:53', 2, 0, '', '2019-06-03 16:05:53');
INSERT INTO `access_log` VALUES (24711, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:53', 7, 0, '', '2019-06-03 16:05:53');
INSERT INTO `access_log` VALUES (24712, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:54', 6, 0, '', '2019-06-03 16:05:54');
INSERT INTO `access_log` VALUES (24713, '64.84.15595491558085999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:56', 447, 0, '', '2019-06-03 16:05:56');
INSERT INTO `access_log` VALUES (24714, '64.83.15595491565145991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:57', 2, 0, '', '2019-06-03 16:05:57');
INSERT INTO `access_log` VALUES (24715, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:58', 7, 0, '', '2019-06-03 16:05:58');
INSERT INTO `access_log` VALUES (24716, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:59', 7, 0, '', '2019-06-03 16:05:59');
INSERT INTO `access_log` VALUES (24717, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:59', 21, 0, '', '2019-06-03 16:05:59');
INSERT INTO `access_log` VALUES (24718, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:05:59', 95, 0, '', '2019-06-03 16:05:59');
INSERT INTO `access_log` VALUES (24719, '64.78.15595491683515999', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:06:08', 7, 0, '', '2019-06-03 16:06:08');
INSERT INTO `access_log` VALUES (24720, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:06:13', 7, 0, '', '2019-06-03 16:06:13');
INSERT INTO `access_log` VALUES (24721, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:06:14', 13, 0, '', '2019-06-03 16:06:14');
INSERT INTO `access_log` VALUES (24722, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:06:14', 5, 0, '', '2019-06-03 16:06:14');
INSERT INTO `access_log` VALUES (24723, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:06:14', 16, 0, '', '2019-06-03 16:06:14');
INSERT INTO `access_log` VALUES (24724, '64.77.15595491763546003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:06:16', 2, 0, '', '2019-06-03 16:06:16');
INSERT INTO `access_log` VALUES (24725, '64.80.15595491764825991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:06:16', 1, 0, '', '2019-06-03 16:06:16');
INSERT INTO `access_log` VALUES (24726, '59.72.15595491801326381', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:06:20', 3, 0, '', '2019-06-03 16:06:20');
INSERT INTO `access_log` VALUES (24727, '59.75.15595491801336385', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-03 16:06:20', 18, 2001001000, '服务端发生异常', '2019-06-03 16:06:20');
INSERT INTO `access_log` VALUES (24728, '65.54.15595492332796243', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:60.0) Gecko/20100101 Firefox/60.0', '219.155.30.91', '2019-06-03 16:07:13', 1, 1002001015, '账号未登陆', '2019-06-03 16:07:13');
INSERT INTO `access_log` VALUES (24729, '65.48.15595492332876283', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:60.0) Gecko/20100101 Firefox/60.0', '219.155.30.91', '2019-06-03 16:07:13', 0, 1002001015, '账号未登陆', '2019-06-03 16:07:13');
INSERT INTO `access_log` VALUES (24730, '65.53.15595492332986253', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:60.0) Gecko/20100101 Firefox/60.0', '219.155.30.91', '2019-06-03 16:07:13', 0, 1002001015, '账号未登陆', '2019-06-03 16:07:13');
INSERT INTO `access_log` VALUES (24731, '65.47.15595492359426281', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:60.0) Gecko/20100101 Firefox/60.0', '219.155.30.91', '2019-06-03 16:07:16', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:07:16');
INSERT INTO `access_log` VALUES (24732, '65.45.15595492432236299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:60.0) Gecko/20100101 Firefox/60.0', '219.155.30.91', '2019-06-03 16:07:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:07:23');
INSERT INTO `access_log` VALUES (24733, '65.52.15595492740056271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '219.155.30.91', '2019-06-03 16:07:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:07:54');
INSERT INTO `access_log` VALUES (24734, '65.51.15595492743826275', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '219.155.30.91', '2019-06-03 16:07:54', 1, 1002001015, '账号未登陆', '2019-06-03 16:07:54');
INSERT INTO `access_log` VALUES (24735, '65.48.15595492743936285', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '219.155.30.91', '2019-06-03 16:07:54', 0, 1002001015, '账号未登陆', '2019-06-03 16:07:54');
INSERT INTO `access_log` VALUES (24736, '65.53.15595492744016255', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '219.155.30.91', '2019-06-03 16:07:54', 0, 1002001015, '账号未登陆', '2019-06-03 16:07:54');
INSERT INTO `access_log` VALUES (24737, '65.54.15595492774046245', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '219.155.30.91', '2019-06-03 16:07:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:07:57');
INSERT INTO `access_log` VALUES (24738, '65.45.15595493014306301', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.108.36.225', '2019-06-03 16:08:21', 0, 1002001015, '账号未登陆', '2019-06-03 16:08:21');
INSERT INTO `access_log` VALUES (24739, '65.46.15595493014336279', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.108.36.225', '2019-06-03 16:08:21', 0, 1002001015, '账号未登陆', '2019-06-03 16:08:21');
INSERT INTO `access_log` VALUES (24740, '65.49.15595493014396297', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.108.36.225', '2019-06-03 16:08:21', 0, 1002001015, '账号未登陆', '2019-06-03 16:08:21');
INSERT INTO `access_log` VALUES (24741, '65.50.15595493034546293', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.108.36.225', '2019-06-03 16:08:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:08:23');
INSERT INTO `access_log` VALUES (24742, '65.48.15595493050726287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.108.36.225', '2019-06-03 16:08:25', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:08:25');
INSERT INTO `access_log` VALUES (24743, '65.51.15595493061426277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.108.36.225', '2019-06-03 16:08:26', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:08:26');
INSERT INTO `access_log` VALUES (24744, '65.53.15595493063666257', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.108.36.225', '2019-06-03 16:08:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:08:26');
INSERT INTO `access_log` VALUES (24745, '65.54.15595493067336247', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.108.36.225', '2019-06-03 16:08:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:08:27');
INSERT INTO `access_log` VALUES (24746, '65.47.15595493070816285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.108.36.225', '2019-06-03 16:08:27', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:08:27');
INSERT INTO `access_log` VALUES (24747, '65.50.15595493632126295', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:09:23', 17, 0, '', '2019-06-03 16:09:23');
INSERT INTO `access_log` VALUES (24748, '65.48.15595493674046289', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:09:27', 9, 0, '', '2019-06-03 16:09:27');
INSERT INTO `access_log` VALUES (24749, '65.53.15595493828626259', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:09:43', 10, 0, '', '2019-06-03 16:09:43');
INSERT INTO `access_log` VALUES (24750, '65.54.15595493828666249', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:09:43', 9, 0, '', '2019-06-03 16:09:43');
INSERT INTO `access_log` VALUES (24751, '65.47.15595493828676287', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:09:43', 9, 0, '', '2019-06-03 16:09:43');
INSERT INTO `access_log` VALUES (24752, '65.46.15595493829396283', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:09:43', 19, 0, '', '2019-06-03 16:09:43');
INSERT INTO `access_log` VALUES (24753, '65.45.15595493915726305', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:09:52', 8, 0, '', '2019-06-03 16:09:52');
INSERT INTO `access_log` VALUES (24754, '65.50.15595493915806297', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:09:52', 8, 0, '', '2019-06-03 16:09:52');
INSERT INTO `access_log` VALUES (24755, '65.49.15595493915696301', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:09:52', 178, 0, '', '2019-06-03 16:09:52');
INSERT INTO `access_log` VALUES (24756, '65.52.15595493916176277', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.199.99.203', '2019-06-03 16:09:52', 130, 0, '', '2019-06-03 16:09:52');
INSERT INTO `access_log` VALUES (24757, '65.47.15595494485976289', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:10:49', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:10:49');
INSERT INTO `access_log` VALUES (24758, '65.50.15595494591276299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:10:59', 79, 0, '', '2019-06-03 16:10:59');
INSERT INTO `access_log` VALUES (24759, '65.45.15595494595066307', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:11:00', 10, 0, '', '2019-06-03 16:11:00');
INSERT INTO `access_log` VALUES (24760, '65.52.15595494595096279', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:11:00', 115, 0, '', '2019-06-03 16:11:00');
INSERT INTO `access_log` VALUES (24761, '65.49.15595494595166303', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:11:00', 109, 0, '', '2019-06-03 16:11:00');
INSERT INTO `access_log` VALUES (24762, '59.72.15595494711706385', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:11:11', 12, 0, '', '2019-06-03 16:11:11');
INSERT INTO `access_log` VALUES (24763, '59.79.15595494789506389', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:11:19', 11, 0, '', '2019-06-03 16:11:19');
INSERT INTO `access_log` VALUES (24764, '59.80.15595494832346383', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10&title=百度', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:11:23', 12, 0, '', '2019-06-03 16:11:23');
INSERT INTO `access_log` VALUES (24765, '59.77.15595494842026381', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10&title=百度', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:11:24', 11, 0, '', '2019-06-03 16:11:24');
INSERT INTO `access_log` VALUES (24766, '59.71.15595494849216393', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10&title=百度', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:11:25', 11, 0, '', '2019-06-03 16:11:25');
INSERT INTO `access_log` VALUES (24767, '59.74.15595494897846385', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10&title=百度', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:11:30', 10, 0, '', '2019-06-03 16:11:30');
INSERT INTO `access_log` VALUES (24768, '65.53.15595494990116263', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:11:39', 11, 0, '', '2019-06-03 16:11:39');
INSERT INTO `access_log` VALUES (24769, '65.47.15595495008756291', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:11:41', 10, 0, '', '2019-06-03 16:11:41');
INSERT INTO `access_log` VALUES (24770, '64.81.15595495084055999', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:11:48', 12, 0, '', '2019-06-03 16:11:48');
INSERT INTO `access_log` VALUES (24771, '64.82.15595495084126011', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:11:48', 8, 0, '', '2019-06-03 16:11:48');
INSERT INTO `access_log` VALUES (24772, '64.83.15595495207875997', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:01', 356, 0, '', '2019-06-03 16:12:01');
INSERT INTO `access_log` VALUES (24773, '64.85.15595495239206019', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:04', 11, 0, '', '2019-06-03 16:12:04');
INSERT INTO `access_log` VALUES (24774, '64.77.15595495263646009', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&name=12&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:06', 11, 0, '', '2019-06-03 16:12:06');
INSERT INTO `access_log` VALUES (24775, '59.72.15595495285096387', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.20', '2019-06-03 16:12:09', 2, 0, '', '2019-06-03 16:12:09');
INSERT INTO `access_log` VALUES (24776, '59.73.15595495285806395', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.20', '2019-06-03 16:12:09', 16, 2001001000, '服务端发生异常', '2019-06-03 16:12:09');
INSERT INTO `access_log` VALUES (24777, '64.80.15595495298435997', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:10', 11, 0, '', '2019-06-03 16:12:10');
INSERT INTO `access_log` VALUES (24778, '64.76.15595495322165995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.20', '2019-06-03 16:12:12', 2, 0, '', '2019-06-03 16:12:12');
INSERT INTO `access_log` VALUES (24779, '64.79.15595495325355999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.20', '2019-06-03 16:12:13', 252, 0, '', '2019-06-03 16:12:13');
INSERT INTO `access_log` VALUES (24780, '64.82.15595495350656013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.20', '2019-06-03 16:12:15', 1, 0, '', '2019-06-03 16:12:15');
INSERT INTO `access_log` VALUES (24781, '64.81.15595495351666001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.20', '2019-06-03 16:12:15', 1, 0, '', '2019-06-03 16:12:15');
INSERT INTO `access_log` VALUES (24782, '64.84.15595495393186007', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&name=oracle&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:19', 11, 0, '', '2019-06-03 16:12:19');
INSERT INTO `access_log` VALUES (24783, '64.85.15595495426286021', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&name=oracle&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:23', 9, 0, '', '2019-06-03 16:12:23');
INSERT INTO `access_log` VALUES (24784, '64.78.15595495512606007', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&name=oracle&status=1&cid=784', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:31', 11, 0, '', '2019-06-03 16:12:31');
INSERT INTO `access_log` VALUES (24785, '64.77.15595495544286011', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1&cid=784', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:34', 11, 0, '', '2019-06-03 16:12:34');
INSERT INTO `access_log` VALUES (24786, '65.49.15595495598516305', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:40', 8, 0, '', '2019-06-03 16:12:40');
INSERT INTO `access_log` VALUES (24787, '65.48.15595495598596295', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:40', 8, 0, '', '2019-06-03 16:12:40');
INSERT INTO `access_log` VALUES (24788, '65.51.15595495598646285', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:40', 8, 0, '', '2019-06-03 16:12:40');
INSERT INTO `access_log` VALUES (24789, '64.76.15595495600625997', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:40', 11, 0, '', '2019-06-03 16:12:40');
INSERT INTO `access_log` VALUES (24790, '64.79.15595495600686001', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:40', 7, 0, '', '2019-06-03 16:12:40');
INSERT INTO `access_log` VALUES (24791, '65.54.15595495644806255', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:44', 10, 0, '', '2019-06-03 16:12:44');
INSERT INTO `access_log` VALUES (24792, '65.53.15595495644896265', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:44', 9, 0, '', '2019-06-03 16:12:44');
INSERT INTO `access_log` VALUES (24793, '65.47.15595495644946293', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:44', 9, 0, '', '2019-06-03 16:12:45');
INSERT INTO `access_log` VALUES (24794, '64.82.15595495646546015', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:45', 12, 0, '', '2019-06-03 16:12:45');
INSERT INTO `access_log` VALUES (24795, '64.81.15595495646586003', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:45', 9, 0, '', '2019-06-03 16:12:45');
INSERT INTO `access_log` VALUES (24796, '65.50.15595495716936303', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:52', 16, 0, '', '2019-06-03 16:12:52');
INSERT INTO `access_log` VALUES (24797, '65.46.15595495716886289', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:52', 116, 0, '', '2019-06-03 16:12:52');
INSERT INTO `access_log` VALUES (24798, '65.45.15595495717006311', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:52', 106, 0, '', '2019-06-03 16:12:52');
INSERT INTO `access_log` VALUES (24799, '64.83.15595495718496001', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:52', 10, 0, '', '2019-06-03 16:12:52');
INSERT INTO `access_log` VALUES (24800, '64.85.15595495718826023', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:12:52', 8, 0, '', '2019-06-03 16:12:52');
INSERT INTO `access_log` VALUES (24801, '65.49.15595495832446307', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:13:03', 11, 0, '', '2019-06-03 16:13:03');
INSERT INTO `access_log` VALUES (24802, '65.51.15595495908346287', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:13:11', 13, 0, '', '2019-06-03 16:13:11');
INSERT INTO `access_log` VALUES (24803, '64.77.15595495924236013', 0, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '58.246.221.162', '2019-06-03 16:13:12', 1, 1002001015, '账号未登陆', '2019-06-03 16:13:12');
INSERT INTO `access_log` VALUES (24804, '65.54.15595496007826257', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:13:21', 12, 0, '', '2019-06-03 16:13:21');
INSERT INTO `access_log` VALUES (24805, '64.76.15595496113085999', 0, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1&cid=784', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '223.166.151.199', '2019-06-03 16:13:31', 1, 1002001015, '账号未登陆', '2019-06-03 16:13:31');
INSERT INTO `access_log` VALUES (24806, '59.75.15595496230746393', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:13:43', 13, 0, '', '2019-06-03 16:13:43');
INSERT INTO `access_log` VALUES (24807, '64.82.15595496299516017', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:13:50', 9, 0, '', '2019-06-03 16:13:50');
INSERT INTO `access_log` VALUES (24808, '64.84.15595496329576011', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:13:53', 10, 0, '', '2019-06-03 16:13:53');
INSERT INTO `access_log` VALUES (24809, '65.45.15595496500706313', 0, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '58.247.204.63', '2019-06-03 16:14:10', 1, 1002001015, '账号未登陆', '2019-06-03 16:14:10');
INSERT INTO `access_log` VALUES (24810, '65.52.15595496620786285', 0, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '58.247.212.141', '2019-06-03 16:14:22', 0, 1002001015, '账号未登陆', '2019-06-03 16:14:22');
INSERT INTO `access_log` VALUES (24811, '65.45.15595497823516315', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:16:22', 11, 0, '', '2019-06-03 16:16:22');
INSERT INTO `access_log` VALUES (24812, '65.53.15595498569006271', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:17:37', 28, 0, '', '2019-06-03 16:17:37');
INSERT INTO `access_log` VALUES (24813, '65.47.15595498933636301', 27, 2, 'admin-application', '/admin-api/admins/admin/update', 'id=5&username=mimangxiaodai&nickname=迷茫小呆&password=111111', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:18:13', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-03 16:18:13');
INSERT INTO `access_log` VALUES (24814, '65.45.15595499167466317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=mimangxiaodai&password=mimangxiaodai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:18:37', 94, 0, '', '2019-06-03 16:18:37');
INSERT INTO `access_log` VALUES (24815, '65.52.15595499170946291', 5, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:18:37', 8, 0, '', '2019-06-03 16:18:37');
INSERT INTO `access_log` VALUES (24816, '65.49.15595499170966315', 5, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:18:37', 8, 0, '', '2019-06-03 16:18:37');
INSERT INTO `access_log` VALUES (24817, '65.51.15595499171286295', 5, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '61.50.210.130', '2019-06-03 16:18:37', 10, 0, '', '2019-06-03 16:18:37');
INSERT INTO `access_log` VALUES (24818, '59.72.15595500777636395', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.71.108.210', '2019-06-03 16:21:18', 4, 0, '', '2019-06-03 16:21:18');
INSERT INTO `access_log` VALUES (24819, '59.73.15595500777636403', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.71.108.210', '2019-06-03 16:21:18', 19, 2001001000, '服务端发生异常', '2019-06-03 16:21:18');
INSERT INTO `access_log` VALUES (24820, '64.83.15595500820486009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.71.108.210', '2019-06-03 16:21:22', 3, 0, '', '2019-06-03 16:21:22');
INSERT INTO `access_log` VALUES (24821, '64.85.15595500821866031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.71.108.210', '2019-06-03 16:21:22', 2, 0, '', '2019-06-03 16:21:22');
INSERT INTO `access_log` VALUES (24822, '64.78.15595500855876017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.71.108.210', '2019-06-03 16:21:26', 2, 0, '', '2019-06-03 16:21:26');
INSERT INTO `access_log` VALUES (24823, '64.77.15595500861706021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.71.108.210', '2019-06-03 16:21:26', 2, 0, '', '2019-06-03 16:21:26');
INSERT INTO `access_log` VALUES (24824, '64.79.15595501253526011', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:22:05', 7, 1002001012, '访问令牌已过期', '2019-06-03 16:22:05');
INSERT INTO `access_log` VALUES (24825, '64.82.15595501253546025', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:22:05', 6, 1002001012, '访问令牌已过期', '2019-06-03 16:22:05');
INSERT INTO `access_log` VALUES (24826, '65.46.15595501318556299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:22:12', 99, 0, '', '2019-06-03 16:22:12');
INSERT INTO `access_log` VALUES (24827, '65.45.15595501321906321', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:22:12', 9, 0, '', '2019-06-03 16:22:12');
INSERT INTO `access_log` VALUES (24828, '65.52.15595501321946295', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:22:12', 8, 0, '', '2019-06-03 16:22:12');
INSERT INTO `access_log` VALUES (24829, '65.49.15595501321956319', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:22:12', 8, 0, '', '2019-06-03 16:22:12');
INSERT INTO `access_log` VALUES (24830, '64.83.15595501368736011', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:22:17', 9, 0, '', '2019-06-03 16:22:17');
INSERT INTO `access_log` VALUES (24831, '64.84.15595501368736019', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:22:17', 14, 0, '', '2019-06-03 16:22:17');
INSERT INTO `access_log` VALUES (24832, '64.78.15595501400046019', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:22:20', 9, 0, '', '2019-06-03 16:22:20');
INSERT INTO `access_log` VALUES (24833, '64.85.15595501400026033', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:22:20', 11, 0, '', '2019-06-03 16:22:20');
INSERT INTO `access_log` VALUES (24834, '64.81.15595502021076015', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=13', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:23:22', 9, 1002002009, NULL, '2019-06-03 16:23:22');
INSERT INTO `access_log` VALUES (24835, '64.84.15595502030536021', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=123', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:23:23', 7, 1002002009, NULL, '2019-06-03 16:23:23');
INSERT INTO `access_log` VALUES (24836, '64.83.15595502062366013', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=3&name=123', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:23:26', 8, 1002002009, NULL, '2019-06-03 16:23:26');
INSERT INTO `access_log` VALUES (24837, '64.85.15595502077886035', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=3&name=123', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:23:28', 7, 1002002009, NULL, '2019-06-03 16:23:28');
INSERT INTO `access_log` VALUES (24838, '64.77.15595502196656025', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:23:40', 10, 0, '', '2019-06-03 16:23:40');
INSERT INTO `access_log` VALUES (24839, '64.76.15595502297756011', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:23:50', 97, 0, '', '2019-06-03 16:23:50');
INSERT INTO `access_log` VALUES (24840, '64.80.15595502297756013', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:23:50', 99, 0, '', '2019-06-03 16:23:50');
INSERT INTO `access_log` VALUES (24841, '59.77.15595502485326393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:09', 3, 0, '', '2019-06-03 16:24:09');
INSERT INTO `access_log` VALUES (24842, '59.71.15595502485356405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:09', 19, 2001001000, '服务端发生异常', '2019-06-03 16:24:09');
INSERT INTO `access_log` VALUES (24843, '64.84.15595502645396023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:25', 2, 0, '', '2019-06-03 16:24:25');
INSERT INTO `access_log` VALUES (24844, '64.83.15595502646676015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:25', 2, 0, '', '2019-06-03 16:24:25');
INSERT INTO `access_log` VALUES (24845, '64.85.15595502664866037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:26', 2, 0, '', '2019-06-03 16:24:26');
INSERT INTO `access_log` VALUES (24846, '64.78.15595502674176023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:27', 2, 0, '', '2019-06-03 16:24:27');
INSERT INTO `access_log` VALUES (24847, '64.77.15595502680936027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:28', 2, 0, '', '2019-06-03 16:24:28');
INSERT INTO `access_log` VALUES (24848, '64.76.15595502692516013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:29', 69, 0, '', '2019-06-03 16:24:29');
INSERT INTO `access_log` VALUES (24849, '64.80.15595502687036015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:29', 617, 0, '', '2019-06-03 16:24:29');
INSERT INTO `access_log` VALUES (24850, '64.79.15595502696206017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:30', 49, 0, '', '2019-06-03 16:24:30');
INSERT INTO `access_log` VALUES (24851, '59.78.15595502710666405', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:31', 2, 0, '', '2019-06-03 16:24:31');
INSERT INTO `access_log` VALUES (24852, '59.76.15595502710686397', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:31', 11, 2001001000, '服务端发生异常', '2019-06-03 16:24:31');
INSERT INTO `access_log` VALUES (24853, '64.82.15595502731556031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:33', 1, 0, '', '2019-06-03 16:24:33');
INSERT INTO `access_log` VALUES (24854, '64.81.15595502732946019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:33', 2, 0, '', '2019-06-03 16:24:33');
INSERT INTO `access_log` VALUES (24855, '64.84.15595502746656025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:35', 2, 0, '', '2019-06-03 16:24:35');
INSERT INTO `access_log` VALUES (24856, '64.83.15595502749586017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:35', 2, 0, '', '2019-06-03 16:24:35');
INSERT INTO `access_log` VALUES (24857, '59.72.15595502760136399', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:36', 3, 0, '', '2019-06-03 16:24:36');
INSERT INTO `access_log` VALUES (24858, '59.73.15595502760136407', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:36', 13, 2001001000, '服务端发生异常', '2019-06-03 16:24:36');
INSERT INTO `access_log` VALUES (24859, '65.48.15595502984386309', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:58', 0, 1002001015, '账号未登陆', '2019-06-03 16:24:58');
INSERT INTO `access_log` VALUES (24860, '65.54.15595502984426269', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:58', 0, 1002001015, '账号未登陆', '2019-06-03 16:24:58');
INSERT INTO `access_log` VALUES (24861, '65.53.15595502984476281', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:24:58', 0, 1002001015, '账号未登陆', '2019-06-03 16:24:58');
INSERT INTO `access_log` VALUES (24862, '2c904c5d-dfb1-4c89-a5ea-a582d7f53d2e', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:25:03', 62, 1002001015, '账号未登陆', '2019-06-03 16:25:03');
INSERT INTO `access_log` VALUES (24863, '97fdee89-f8ef-486f-bfc0-216d3664807f', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:25:03', 62, 1002001015, '账号未登陆', '2019-06-03 16:25:03');
INSERT INTO `access_log` VALUES (24864, '5988bfaf-fd27-4efd-9ec2-33c44e128af3', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:25:03', 62, 1002001015, '账号未登陆', '2019-06-03 16:25:03');
INSERT INTO `access_log` VALUES (24865, '71aabc3c-b045-4041-8eeb-3a6a50592633', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:25:05', 438, 0, '', '2019-06-03 16:25:06');
INSERT INTO `access_log` VALUES (24866, '4411fff8-e6e1-4c66-ba5e-6df2b4b48369', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:25:06', 292, 0, '', '2019-06-03 16:25:06');
INSERT INTO `access_log` VALUES (24867, '4f5056d4-158a-49c9-85b2-f032fccbe644', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:25:06', 303, 0, '', '2019-06-03 16:25:06');
INSERT INTO `access_log` VALUES (24868, '838dac5e-ca54-49d5-89dc-daab2c5b981e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:25:06', 312, 0, '', '2019-06-03 16:25:06');
INSERT INTO `access_log` VALUES (24869, '65.50.15595503080526317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:25:08', 103, 0, '', '2019-06-03 16:25:08');
INSERT INTO `access_log` VALUES (24870, '65.47.15595503084996309', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:25:08', 9, 0, '', '2019-06-03 16:25:09');
INSERT INTO `access_log` VALUES (24871, '65.46.15595503084996303', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:25:09', 8, 0, '', '2019-06-03 16:25:09');
INSERT INTO `access_log` VALUES (24872, '65.45.15595503085016325', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:25:09', 125, 0, '', '2019-06-03 16:25:09');
INSERT INTO `access_log` VALUES (24873, '62.87.15595503194026273', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.9.118', '2019-06-03 16:25:19', 11, 0, '', '2019-06-03 16:25:19');
INSERT INTO `access_log` VALUES (24874, '58c767cc-85e8-44ea-8ca2-4c46fa4cdc67', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:25:25', 526, 0, '', '2019-06-03 16:25:25');
INSERT INTO `access_log` VALUES (24875, '58c767cc-85e8-44ea-8ca2-4c46fa4cdc67', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:25:25', 526, 0, '', '2019-06-03 16:25:26');
INSERT INTO `access_log` VALUES (24876, '69b06646-cbea-4d04-87c9-ebba6e22c663', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:25:28', 235, 0, '', '2019-06-03 16:25:28');
INSERT INTO `access_log` VALUES (24877, 'c5aca333-aef0-4b59-84a1-5c0bfe5e798b', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:25:34', 799, 0, '', '2019-06-03 16:25:35');
INSERT INTO `access_log` VALUES (24878, '47c921e3-3b7d-4ea3-8e10-cb941e293a5f', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:25:43', 90, 0, '', '2019-06-03 16:25:43');
INSERT INTO `access_log` VALUES (24879, '6ed48158-1b15-4824-b59b-2be5c96895cb', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:25:56', 277, 0, '', '2019-06-03 16:25:57');
INSERT INTO `access_log` VALUES (24880, '40b844b6-d94f-4ed9-bd6e-a489100b8a2a', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:25:59', 361, 0, '', '2019-06-03 16:25:59');
INSERT INTO `access_log` VALUES (24881, '0eef5178-b2dd-41e8-b252-b5bd22437e52', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:26:01', 127, 0, '', '2019-06-03 16:26:02');
INSERT INTO `access_log` VALUES (24882, '65.48.15595503798346311', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:20', 0, 1002001015, '账号未登陆', '2019-06-03 16:26:20');
INSERT INTO `access_log` VALUES (24883, '65.50.15595503798376319', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:20', 1, 1002001015, '账号未登陆', '2019-06-03 16:26:20');
INSERT INTO `access_log` VALUES (24884, '65.46.15595503798416305', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:20', 0, 1002001015, '账号未登陆', '2019-06-03 16:26:20');
INSERT INTO `access_log` VALUES (24885, '65.45.15595503864976327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:26', 89, 0, '', '2019-06-03 16:26:27');
INSERT INTO `access_log` VALUES (24886, '65.49.15595503868546325', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:27', 9, 0, '', '2019-06-03 16:26:27');
INSERT INTO `access_log` VALUES (24887, '65.52.15595503868566301', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:27', 9, 0, '', '2019-06-03 16:26:27');
INSERT INTO `access_log` VALUES (24888, '65.51.15595503868586305', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:27', 8, 0, '', '2019-06-03 16:26:27');
INSERT INTO `access_log` VALUES (24889, '62.89.15595503899426267', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:30', 13, 0, '', '2019-06-03 16:26:30');
INSERT INTO `access_log` VALUES (24890, '64.85.15595503956496041', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:36', 9, 0, '', '2019-06-03 16:26:36');
INSERT INTO `access_log` VALUES (24891, '64.83.15595503956476019', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:36', 12, 0, '', '2019-06-03 16:26:36');
INSERT INTO `access_log` VALUES (24892, '64.77.15595503982736031', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:38', 9, 0, '', '2019-06-03 16:26:38');
INSERT INTO `access_log` VALUES (24893, '64.78.15595503982736027', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:38', 12, 0, '', '2019-06-03 16:26:38');
INSERT INTO `access_log` VALUES (24894, '64.79.15595504029066021', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:43', 125, 0, '', '2019-06-03 16:26:43');
INSERT INTO `access_log` VALUES (24895, '64.76.15595504029046017', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:43', 128, 0, '', '2019-06-03 16:26:43');
INSERT INTO `access_log` VALUES (24896, '64.80.15595504029026019', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:43', 134, 0, '', '2019-06-03 16:26:43');
INSERT INTO `access_log` VALUES (24897, '64.82.15595504060496035', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:46', 6, 1002002009, NULL, '2019-06-03 16:26:46');
INSERT INTO `access_log` VALUES (24898, '64.81.15595504067586023', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:26:47', 8, 1002002009, NULL, '2019-06-03 16:26:47');
INSERT INTO `access_log` VALUES (24899, 'd3af3b0e-3516-4d9e-aca2-7b032a542318', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:28:12', 3472, 2001001000, '服务端发生异常', '2019-06-03 16:28:16');
INSERT INTO `access_log` VALUES (24900, '65608c02-805f-49e5-8f70-6bada8265791', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:28:12', 3473, 0, '', '2019-06-03 16:28:16');
INSERT INTO `access_log` VALUES (24901, '8cc0e2f5-cb3c-40fd-a008-215c7bc6b03c', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:28:17', 985, 0, '', '2019-06-03 16:28:18');
INSERT INTO `access_log` VALUES (24902, 'db9f2321-34cf-4528-ac8c-3979e832ed5c', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:28:17', 1044, 2001001000, '服务端发生异常', '2019-06-03 16:28:18');
INSERT INTO `access_log` VALUES (24903, '73b5a957-c674-4a9a-90af-110764e85f45', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:28:52', 210, 0, '', '2019-06-03 16:28:52');
INSERT INTO `access_log` VALUES (24904, 'c3d5b166-3b26-4847-a985-b073dd31c1e8', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:28:54', 167, 0, '', '2019-06-03 16:28:54');
INSERT INTO `access_log` VALUES (24905, '669be7d6-7a9d-4cef-b624-c1d1ee6cb206', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:29:05', 215, 0, '', '2019-06-03 16:29:06');
INSERT INTO `access_log` VALUES (24906, '59.73.15595507170586413', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.193.69.252', '2019-06-03 16:31:57', 3, 0, '', '2019-06-03 16:31:57');
INSERT INTO `access_log` VALUES (24907, '59.79.15595507170596409', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.193.69.252', '2019-06-03 16:31:57', 18, 2001001000, '服务端发生异常', '2019-06-03 16:31:57');
INSERT INTO `access_log` VALUES (24908, '64.83.15595507254096025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:05', 4, 0, '', '2019-06-03 16:32:05');
INSERT INTO `access_log` VALUES (24909, '64.78.15595507255416033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:06', 3, 0, '', '2019-06-03 16:32:06');
INSERT INTO `access_log` VALUES (24910, '64.77.15595507274946037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:07', 2, 0, '', '2019-06-03 16:32:07');
INSERT INTO `access_log` VALUES (24911, '64.79.15595507279206027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:08', 2, 0, '', '2019-06-03 16:32:08');
INSERT INTO `access_log` VALUES (24912, '64.76.15595507290986023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:09', 2, 0, '', '2019-06-03 16:32:09');
INSERT INTO `access_log` VALUES (24913, '64.80.15595507303356025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:10', 84, 0, '', '2019-06-03 16:32:10');
INSERT INTO `access_log` VALUES (24914, '64.82.15595507310726041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:11', 2, 0, '', '2019-06-03 16:32:11');
INSERT INTO `access_log` VALUES (24915, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:11', 7, 0, '', '2019-06-03 16:32:11');
INSERT INTO `access_log` VALUES (24916, '64.81.15595507327306029', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:13', 8, 0, '', '2019-06-03 16:32:13');
INSERT INTO `access_log` VALUES (24917, '64.84.15595507362066035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:16', 2, 0, '', '2019-06-03 16:32:16');
INSERT INTO `access_log` VALUES (24918, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:16', 8, 0, '', '2019-06-03 16:32:16');
INSERT INTO `access_log` VALUES (24919, '64.83.15595507370306027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:17', 2, 0, '', '2019-06-03 16:32:17');
INSERT INTO `access_log` VALUES (24920, '64.85.15595507371526049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:17', 2, 0, '', '2019-06-03 16:32:17');
INSERT INTO `access_log` VALUES (24921, '64.77.15595507414696039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:21', 2, 0, '', '2019-06-03 16:32:21');
INSERT INTO `access_log` VALUES (24922, '64.79.15595507417916029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:22', 2, 0, '', '2019-06-03 16:32:22');
INSERT INTO `access_log` VALUES (24923, '59.74.15595507471566405', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:27', 3, 0, '', '2019-06-03 16:32:27');
INSERT INTO `access_log` VALUES (24924, '59.77.15595507471566401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:27', 10, 2001001000, '服务端发生异常', '2019-06-03 16:32:27');
INSERT INTO `access_log` VALUES (24925, '64.76.15595507495666025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:30', 2, 0, '', '2019-06-03 16:32:30');
INSERT INTO `access_log` VALUES (24926, '64.80.15595507497006027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:30', 2, 0, '', '2019-06-03 16:32:30');
INSERT INTO `access_log` VALUES (24927, '59.78.15595507520966413', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:32', 2, 0, '', '2019-06-03 16:32:32');
INSERT INTO `access_log` VALUES (24928, '59.76.15595507520966405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:32', 13, 2001001000, '服务端发生异常', '2019-06-03 16:32:32');
INSERT INTO `access_log` VALUES (24929, '64.81.15595507660186031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:46', 2, 0, '', '2019-06-03 16:32:46');
INSERT INTO `access_log` VALUES (24930, '64.84.15595507661526037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:46', 2, 0, '', '2019-06-03 16:32:46');
INSERT INTO `access_log` VALUES (24931, '59.72.15595507667546407', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:47', 3, 0, '', '2019-06-03 16:32:47');
INSERT INTO `access_log` VALUES (24932, '59.73.15595507667546415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:47', 13, 2001001000, '服务端发生异常', '2019-06-03 16:32:47');
INSERT INTO `access_log` VALUES (24933, '64.83.15595507671466029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:47', 2, 0, '', '2019-06-03 16:32:47');
INSERT INTO `access_log` VALUES (24934, '64.85.15595507672886051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:47', 1, 0, '', '2019-06-03 16:32:47');
INSERT INTO `access_log` VALUES (24935, '59.79.15595507673166411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:47', 2, 0, '', '2019-06-03 16:32:47');
INSERT INTO `access_log` VALUES (24936, '59.80.15595507673696403', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '1.193.69.252', '2019-06-03 16:32:47', 10, 2001001000, '服务端发生异常', '2019-06-03 16:32:47');
INSERT INTO `access_log` VALUES (24937, '59.79.15595508764666413', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:34:36', 3, 0, '', '2019-06-03 16:34:36');
INSERT INTO `access_log` VALUES (24938, '59.80.15595508764666405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.88.31.19', '2019-06-03 16:34:36', 13, 2001001000, '服务端发生异常', '2019-06-03 16:34:36');
INSERT INTO `access_log` VALUES (24939, '64.83.15595508865876031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 16:34:47', 3, 0, '', '2019-06-03 16:34:47');
INSERT INTO `access_log` VALUES (24940, '64.85.15595508868696053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 16:34:47', 2, 0, '', '2019-06-03 16:34:47');
INSERT INTO `access_log` VALUES (24941, '64.78.15595508886626039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 16:34:49', 2, 0, '', '2019-06-03 16:34:49');
INSERT INTO `access_log` VALUES (24942, '64.77.15595508892716043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 16:34:49', 2, 0, '', '2019-06-03 16:34:49');
INSERT INTO `access_log` VALUES (24943, '64.76.15595508920926029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 16:34:52', 2, 0, '', '2019-06-03 16:34:52');
INSERT INTO `access_log` VALUES (24944, '64.80.15595508921956031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 16:34:52', 2, 0, '', '2019-06-03 16:34:52');
INSERT INTO `access_log` VALUES (24945, '59.74.15595509004446409', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 16:35:00', 3, 0, '', '2019-06-03 16:35:00');
INSERT INTO `access_log` VALUES (24946, '59.77.15595509004456405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 16:35:00', 9, 2001001000, '服务端发生异常', '2019-06-03 16:35:00');
INSERT INTO `access_log` VALUES (24947, '64.81.15595509059436035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 16:35:06', 2, 0, '', '2019-06-03 16:35:06');
INSERT INTO `access_log` VALUES (24948, '64.84.15595509060346041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 16:35:06', 2, 0, '', '2019-06-03 16:35:06');
INSERT INTO `access_log` VALUES (24949, '59.76.15595509075066409', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 16:35:08', 2, 0, '', '2019-06-03 16:35:08');
INSERT INTO `access_log` VALUES (24950, '59.75.15595509075066415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 16:35:08', 10, 2001001000, '服务端发生异常', '2019-06-03 16:35:08');
INSERT INTO `access_log` VALUES (24951, '64.83.15595509096336033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 16:35:10', 2, 0, '', '2019-06-03 16:35:10');
INSERT INTO `access_log` VALUES (24952, '64.85.15595509099866055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 16:35:10', 2, 0, '', '2019-06-03 16:35:10');
INSERT INTO `access_log` VALUES (24953, '59.71.15595509740046419', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:36:14', 3, 0, '', '2019-06-03 16:36:14');
INSERT INTO `access_log` VALUES (24954, '59.74.15595509740066411', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:36:14', 14, 2001001000, '服务端发生异常', '2019-06-03 16:36:14');
INSERT INTO `access_log` VALUES (24955, '64.82.15595509826526049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.13.21.126', '2019-06-03 16:36:23', 4, 0, '', '2019-06-03 16:36:23');
INSERT INTO `access_log` VALUES (24956, '64.81.15595509827986037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.13.21.126', '2019-06-03 16:36:23', 2, 0, '', '2019-06-03 16:36:23');
INSERT INTO `access_log` VALUES (24957, '64.84.15595509861686043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.13.21.126', '2019-06-03 16:36:26', 2, 0, '', '2019-06-03 16:36:26');
INSERT INTO `access_log` VALUES (24958, '64.83.15595509863266035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.13.21.126', '2019-06-03 16:36:26', 2, 0, '', '2019-06-03 16:36:26');
INSERT INTO `access_log` VALUES (24959, '64.85.15595509876016057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.13.21.126', '2019-06-03 16:36:28', 3, 0, '', '2019-06-03 16:36:28');
INSERT INTO `access_log` VALUES (24960, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.13.21.126', '2019-06-03 16:36:28', 7, 0, '', '2019-06-03 16:36:28');
INSERT INTO `access_log` VALUES (24961, '64.78.15595509889976043', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.13.21.126', '2019-06-03 16:36:29', 9, 0, '', '2019-06-03 16:36:29');
INSERT INTO `access_log` VALUES (24962, '64.79.15595509969436037', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.13.21.126', '2019-06-03 16:36:37', 7, 0, '', '2019-06-03 16:36:37');
INSERT INTO `access_log` VALUES (24963, '64.76.15595509974406033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.13.21.126', '2019-06-03 16:36:37', 2, 0, '', '2019-06-03 16:36:37');
INSERT INTO `access_log` VALUES (24964, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.13.21.126', '2019-06-03 16:36:37', 7, 0, '', '2019-06-03 16:36:37');
INSERT INTO `access_log` VALUES (24965, '65.48.15595510000816321', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:36:40', 0, 1002001015, '账号未登陆', '2019-06-03 16:36:40');
INSERT INTO `access_log` VALUES (24966, '65.45.15595510000826335', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:36:40', 0, 1002001015, '账号未登陆', '2019-06-03 16:36:40');
INSERT INTO `access_log` VALUES (24967, '65.51.15595510000916315', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:36:40', 0, 1002001015, '账号未登陆', '2019-06-03 16:36:40');
INSERT INTO `access_log` VALUES (24968, '64.80.15595510011576035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.13.21.126', '2019-06-03 16:36:41', 2, 0, '', '2019-06-03 16:36:41');
INSERT INTO `access_log` VALUES (24969, '64.82.15595510012586051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.13.21.126', '2019-06-03 16:36:41', 2, 0, '', '2019-06-03 16:36:41');
INSERT INTO `access_log` VALUES (24970, '59.76.15595510017846411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.13.21.126', '2019-06-03 16:36:42', 3, 0, '', '2019-06-03 16:36:42');
INSERT INTO `access_log` VALUES (24971, '59.75.15595510017866417', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.13.21.126', '2019-06-03 16:36:42', 20, 2001001000, '服务端发生异常', '2019-06-03 16:36:42');
INSERT INTO `access_log` VALUES (24972, '65.52.15595510018636311', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:36:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:36:42');
INSERT INTO `access_log` VALUES (24973, '65.49.15595510113266335', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:36:51', 167, 0, '', '2019-06-03 16:36:51');
INSERT INTO `access_log` VALUES (24974, '65.53.15595510117696297', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:36:52', 10, 0, '', '2019-06-03 16:36:52');
INSERT INTO `access_log` VALUES (24975, '65.46.15595510117726315', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:36:52', 9, 0, '', '2019-06-03 16:36:52');
INSERT INTO `access_log` VALUES (24976, '65.54.15595510117716283', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:36:52', 9, 0, '', '2019-06-03 16:36:52');
INSERT INTO `access_log` VALUES (24977, '62.80.15595510150936283', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:36:55', 11, 0, '', '2019-06-03 16:36:55');
INSERT INTO `access_log` VALUES (24978, '64.84.15595510176036045', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:36:58', 12, 0, '', '2019-06-03 16:36:58');
INSERT INTO `access_log` VALUES (24979, '64.83.15595510176086037', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:36:58', 10, 0, '', '2019-06-03 16:36:58');
INSERT INTO `access_log` VALUES (24980, '59.73.15595510224926421', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:37:02', 24, 2001001000, '服务端发生异常', '2019-06-03 16:37:03');
INSERT INTO `access_log` VALUES (24981, '65.47.15595510242966323', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:37:04', 18, 0, '', '2019-06-03 16:37:04');
INSERT INTO `access_log` VALUES (24982, '65.48.15595510361726323', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:16', 1, 1002001015, '账号未登陆', '2019-06-03 16:37:16');
INSERT INTO `access_log` VALUES (24983, '65.51.15595510361756317', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:16', 1, 1002001015, '账号未登陆', '2019-06-03 16:37:16');
INSERT INTO `access_log` VALUES (24984, '65.52.15595510361776313', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:16', 0, 1002001015, '账号未登陆', '2019-06-03 16:37:16');
INSERT INTO `access_log` VALUES (24985, '65.49.15595510407206337', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:21', 114, 0, '', '2019-06-03 16:37:21');
INSERT INTO `access_log` VALUES (24986, '65.54.15595510411256285', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:21', 8, 0, '', '2019-06-03 16:37:21');
INSERT INTO `access_log` VALUES (24987, '65.53.15595510411276299', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:21', 7, 0, '', '2019-06-03 16:37:21');
INSERT INTO `access_log` VALUES (24988, '65.46.15595510411306317', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:21', 12, 0, '', '2019-06-03 16:37:21');
INSERT INTO `access_log` VALUES (24989, '62.84.15595510449226267', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:25', 12, 0, '', '2019-06-03 16:37:25');
INSERT INTO `access_log` VALUES (24990, '64.79.15595510522646039', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:32', 8, 0, '', '2019-06-03 16:37:32');
INSERT INTO `access_log` VALUES (24991, '64.77.15595510522626049', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:32', 11, 0, '', '2019-06-03 16:37:32');
INSERT INTO `access_log` VALUES (24992, '64.82.15595510584696053', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:38', 9, 0, '', '2019-06-03 16:37:38');
INSERT INTO `access_log` VALUES (24993, '64.80.15595510584686037', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:38', 12, 0, '', '2019-06-03 16:37:38');
INSERT INTO `access_log` VALUES (24994, '62.86.15595510618256269', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:37:42', 12, 0, '', '2019-06-03 16:37:42');
INSERT INTO `access_log` VALUES (24995, '64.84.15595510656556047', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:46', 9, 0, '', '2019-06-03 16:37:46');
INSERT INTO `access_log` VALUES (24996, '64.81.15595510656496041', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:46', 13, 0, '', '2019-06-03 16:37:46');
INSERT INTO `access_log` VALUES (24997, '64.83.15595510656566039', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:46', 13, 0, '', '2019-06-03 16:37:46');
INSERT INTO `access_log` VALUES (24998, '62.82.15595510665276289', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.67.9.138', '2019-06-03 16:37:47', 15, 0, '', '2019-06-03 16:37:47');
INSERT INTO `access_log` VALUES (24999, '66.53.15595510772505101', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:37:57', 21, 0, '', '2019-06-03 16:37:57');
INSERT INTO `access_log` VALUES (25000, '59.77.15595510803916409', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:38:00', 11, 0, '', '2019-06-03 16:38:00');
INSERT INTO `access_log` VALUES (25001, '59.78.15595510831376421', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:38:03', 16, 2001001000, '服务端发生异常', '2019-06-03 16:38:03');
INSERT INTO `access_log` VALUES (25002, '59.75.15595510859536419', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:38:06', 12, 0, '', '2019-06-03 16:38:06');
INSERT INTO `access_log` VALUES (25003, '65.48.15595510919486325', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:38:12', 20, 0, '', '2019-06-03 16:38:12');
INSERT INTO `access_log` VALUES (25004, '65.52.15595510937486315', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:38:14', 10, 0, '', '2019-06-03 16:38:14');
INSERT INTO `access_log` VALUES (25005, '65.49.15595510946696339', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:38:15', 9, 0, '', '2019-06-03 16:38:15');
INSERT INTO `access_log` VALUES (25006, '65.46.15595510961686319', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:38:16', 12, 0, '', '2019-06-03 16:38:16');
INSERT INTO `access_log` VALUES (25007, '62.87.15595511073906285', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:38:27', 12, 0, '', '2019-06-03 16:38:27');
INSERT INTO `access_log` VALUES (25008, '62.81.15595511098746263', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:38:30', 417, 0, '', '2019-06-03 16:38:30');
INSERT INTO `access_log` VALUES (25009, '64.80.15595511180046039', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:38:38', 16, 0, '', '2019-06-03 16:38:38');
INSERT INTO `access_log` VALUES (25010, '64.76.15595511180006037', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.13.21.126', '2019-06-03 16:38:38', 21, 0, '', '2019-06-03 16:38:38');
INSERT INTO `access_log` VALUES (25011, '65.46.15595513744736323', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:42:54', 0, 1002001015, '账号未登陆', '2019-06-03 16:42:54');
INSERT INTO `access_log` VALUES (25012, '65.54.15595513744756291', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:42:54', 1, 1002001015, '账号未登陆', '2019-06-03 16:42:54');
INSERT INTO `access_log` VALUES (25013, '65.53.15595513744796305', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:42:54', 1, 1002001015, '账号未登陆', '2019-06-03 16:42:54');
INSERT INTO `access_log` VALUES (25014, '65.50.15595513796976337', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:43:00', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:43:00');
INSERT INTO `access_log` VALUES (25015, '65.47.15595513849896331', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:43:05', 74, 0, '', '2019-06-03 16:43:05');
INSERT INTO `access_log` VALUES (25016, '65.45.15595513853376345', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:43:05', 10, 0, '', '2019-06-03 16:43:05');
INSERT INTO `access_log` VALUES (25017, '65.51.15595513853426325', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:43:05', 10, 0, '', '2019-06-03 16:43:05');
INSERT INTO `access_log` VALUES (25018, '65.48.15595513853466331', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:43:05', 9, 0, '', '2019-06-03 16:43:05');
INSERT INTO `access_log` VALUES (25019, '64.76.15595513920876041', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:43:12', 9, 0, '', '2019-06-03 16:43:12');
INSERT INTO `access_log` VALUES (25020, '64.80.15595513920856043', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:43:12', 13, 0, '', '2019-06-03 16:43:12');
INSERT INTO `access_log` VALUES (25021, '64.81.15595513983996047', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:43:18', 9, 0, '', '2019-06-03 16:43:18');
INSERT INTO `access_log` VALUES (25022, '64.82.15595513983986059', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:43:18', 11, 0, '', '2019-06-03 16:43:18');
INSERT INTO `access_log` VALUES (25023, '64.78.15595514271796053', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:43:47', 10, 0, '', '2019-06-03 16:43:47');
INSERT INTO `access_log` VALUES (25024, '64.85.15595514271796067', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:43:47', 12, 0, '', '2019-06-03 16:43:47');
INSERT INTO `access_log` VALUES (25025, '64.77.15595514304816057', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:43:50', 11, 0, '', '2019-06-03 16:43:50');
INSERT INTO `access_log` VALUES (25026, '64.76.15595514304856043', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:43:50', 8, 0, '', '2019-06-03 16:43:50');
INSERT INTO `access_log` VALUES (25027, '64.79.15595514304816047', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:43:50', 15, 0, '', '2019-06-03 16:43:50');
INSERT INTO `access_log` VALUES (25028, '64.80.15595515289956047', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:45:29', 102, 0, '', '2019-06-03 16:45:29');
INSERT INTO `access_log` VALUES (25029, '65.49.15595515404526347', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:45:40', 0, 1002001015, '账号未登陆', '2019-06-03 16:45:40');
INSERT INTO `access_log` VALUES (25030, '65.53.15595515404556309', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:45:40', 1, 1002001015, '账号未登陆', '2019-06-03 16:45:40');
INSERT INTO `access_log` VALUES (25031, '65.54.15595515404586295', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:45:40', 0, 1002001015, '账号未登陆', '2019-06-03 16:45:40');
INSERT INTO `access_log` VALUES (25032, '65.46.15595515435476327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:45:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:45:44');
INSERT INTO `access_log` VALUES (25033, '65.50.15595515495826341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:45:50', 93, 0, '', '2019-06-03 16:45:50');
INSERT INTO `access_log` VALUES (25034, '65.47.15595515499076335', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:45:50', 15, 0, '', '2019-06-03 16:45:50');
INSERT INTO `access_log` VALUES (25035, '65.45.15595515499096349', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:45:50', 16, 0, '', '2019-06-03 16:45:50');
INSERT INTO `access_log` VALUES (25036, '65.51.15595515499146329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:45:50', 17, 0, '', '2019-06-03 16:45:50');
INSERT INTO `access_log` VALUES (25037, '62.83.15595515525386287', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:45:53', 13, 0, '', '2019-06-03 16:45:53');
INSERT INTO `access_log` VALUES (25038, '64.81.15595515541736051', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:45:54', 8, 0, '', '2019-06-03 16:45:54');
INSERT INTO `access_log` VALUES (25039, '64.79.15595515541716049', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:45:54', 103, 0, '', '2019-06-03 16:45:54');
INSERT INTO `access_log` VALUES (25040, '66.50.15595515552945113', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:45:55', 15, 0, '', '2019-06-03 16:45:55');
INSERT INTO `access_log` VALUES (25041, '62.80.15595515565146293', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:45:57', 12, 0, '', '2019-06-03 16:45:57');
INSERT INTO `access_log` VALUES (25042, '65.52.15595515592396325', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:45:59', 14, 0, '', '2019-06-03 16:45:59');
INSERT INTO `access_log` VALUES (25043, '65.54.15595515628706297', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:46:03', 9, 0, '', '2019-06-03 16:46:03');
INSERT INTO `access_log` VALUES (25044, '65.49.15595515642156349', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:46:04', 10, 0, '', '2019-06-03 16:46:04');
INSERT INTO `access_log` VALUES (25045, '65.53.15595515650566311', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.65.171.98', '2019-06-03 16:46:05', 16, 0, '', '2019-06-03 16:46:05');
INSERT INTO `access_log` VALUES (25046, '64.84.15595515671196057', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:46:07', 10, 0, '', '2019-06-03 16:46:07');
INSERT INTO `access_log` VALUES (25047, '64.83.15595515671196049', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:46:07', 13, 0, '', '2019-06-03 16:46:07');
INSERT INTO `access_log` VALUES (25048, '64.77.15595515990996061', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:46:39', 44, 0, '', '2019-06-03 16:46:39');
INSERT INTO `access_log` VALUES (25049, '64.80.15595515990996049', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.170.218', '2019-06-03 16:46:39', 46, 0, '', '2019-06-03 16:46:39');
INSERT INTO `access_log` VALUES (25050, '64.81.15595516046636053', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:46:45', 8, 0, '', '2019-06-03 16:46:45');
INSERT INTO `access_log` VALUES (25051, '64.76.15595516046606047', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:46:45', 12, 0, '', '2019-06-03 16:46:45');
INSERT INTO `access_log` VALUES (25052, '64.79.15595516082226051', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:46:48', 9, 0, '', '2019-06-03 16:46:48');
INSERT INTO `access_log` VALUES (25053, '64.84.15595516224626059', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:47:02', 8, 0, '', '2019-06-03 16:47:02');
INSERT INTO `access_log` VALUES (25054, '64.83.15595516224616051', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:47:02', 11, 0, '', '2019-06-03 16:47:02');
INSERT INTO `access_log` VALUES (25055, '64.78.15595516358936059', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=3&name=jhjkh', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:47:16', 8, 1002002009, NULL, '2019-06-03 16:47:16');
INSERT INTO `access_log` VALUES (25056, '64.79.15595516941856053', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:48:14', 10, 0, '', '2019-06-03 16:48:14');
INSERT INTO `access_log` VALUES (25057, '64.83.15595517057396053', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:48:26', 7, 0, '', '2019-06-03 16:48:26');
INSERT INTO `access_log` VALUES (25058, '64.84.15595517057386061', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 16:48:26', 10, 0, '', '2019-06-03 16:48:26');
INSERT INTO `access_log` VALUES (25059, '59.78.15595517910946431', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:49:51', 3, 0, '', '2019-06-03 16:49:51');
INSERT INTO `access_log` VALUES (25060, '59.76.15595517910946423', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:49:51', 13, 2001001000, '服务端发生异常', '2019-06-03 16:49:51');
INSERT INTO `access_log` VALUES (25061, '59.75.15595518038196429', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:04', 2, 0, '', '2019-06-03 16:50:04');
INSERT INTO `access_log` VALUES (25062, '59.72.15595518038196425', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:04', 12, 2001001000, '服务端发生异常', '2019-06-03 16:50:04');
INSERT INTO `access_log` VALUES (25063, '64.82.15595518061636069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:06', 440, 0, '', '2019-06-03 16:50:07');
INSERT INTO `access_log` VALUES (25064, '64.84.15595518070966063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:07', 2, 0, '', '2019-06-03 16:50:07');
INSERT INTO `access_log` VALUES (25065, '64.83.15595518080266055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:08', 91, 0, '', '2019-06-03 16:50:08');
INSERT INTO `access_log` VALUES (25066, '64.85.15595518088166077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:09', 2, 0, '', '2019-06-03 16:50:09');
INSERT INTO `access_log` VALUES (25067, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:09', 7, 0, '', '2019-06-03 16:50:09');
INSERT INTO `access_log` VALUES (25068, '64.78.15595518111496063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:11', 2, 0, '', '2019-06-03 16:50:11');
INSERT INTO `access_log` VALUES (25069, '64.77.15595518112466067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:11', 2, 0, '', '2019-06-03 16:50:11');
INSERT INTO `access_log` VALUES (25070, '64.80.15595518120056055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:12', 365, 0, '', '2019-06-03 16:50:12');
INSERT INTO `access_log` VALUES (25071, '64.76.15595518125046053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:13', 2, 0, '', '2019-06-03 16:50:13');
INSERT INTO `access_log` VALUES (25072, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:13', 7, 0, '', '2019-06-03 16:50:13');
INSERT INTO `access_log` VALUES (25073, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:15', 6, 0, '', '2019-06-03 16:50:15');
INSERT INTO `access_log` VALUES (25074, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:15', 7, 0, '', '2019-06-03 16:50:15');
INSERT INTO `access_log` VALUES (25075, '64.81.15595518157846059', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 16:50:16', 7, 0, '', '2019-06-03 16:50:16');
INSERT INTO `access_log` VALUES (25076, '65.51.15595518378096335', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:50:38', 0, 1002001015, '账号未登陆', '2019-06-03 16:50:38');
INSERT INTO `access_log` VALUES (25077, '65.47.15595518378136341', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:50:38', 0, 1002001015, '账号未登陆', '2019-06-03 16:50:38');
INSERT INTO `access_log` VALUES (25078, '65.45.15595518378206355', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:50:38', 0, 1002001015, '账号未登陆', '2019-06-03 16:50:38');
INSERT INTO `access_log` VALUES (25079, '65.54.15595518542566303', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:50:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 16:50:54');
INSERT INTO `access_log` VALUES (25080, '65.49.15595518570566355', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:50:57', 233, 0, '', '2019-06-03 16:50:57');
INSERT INTO `access_log` VALUES (25081, '65.53.15595518576566315', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:50:58', 309, 0, '', '2019-06-03 16:50:58');
INSERT INTO `access_log` VALUES (25082, '65.50.15595518576646349', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:50:58', 301, 0, '', '2019-06-03 16:50:58');
INSERT INTO `access_log` VALUES (25083, '65.46.15595518576576335', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:50:58', 312, 0, '', '2019-06-03 16:50:58');
INSERT INTO `access_log` VALUES (25084, '62.86.15595518669736281', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:51:07', 13, 0, '', '2019-06-03 16:51:07');
INSERT INTO `access_log` VALUES (25085, '62.89.15595518797956289', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:51:20', 15, 0, '', '2019-06-03 16:51:20');
INSERT INTO `access_log` VALUES (25086, '64.77.15595518903556069', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:51:30', 8, 0, '', '2019-06-03 16:51:30');
INSERT INTO `access_log` VALUES (25087, '64.78.15595518903516065', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:51:30', 12, 0, '', '2019-06-03 16:51:30');
INSERT INTO `access_log` VALUES (25088, 'e611c068-55e5-4a0a-9bb9-c06091cb1d2c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:51:38', 300, 0, '', '2019-06-03 16:51:38');
INSERT INTO `access_log` VALUES (25089, 'f953bc71-4fc0-48ef-91f8-0bc63f4cbe23', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:51:38', 300, 0, '', '2019-06-03 16:51:38');
INSERT INTO `access_log` VALUES (25090, '92ce7337-ce24-4040-86b9-3c2923299959', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:51:38', 300, 0, '', '2019-06-03 16:51:38');
INSERT INTO `access_log` VALUES (25091, 'e991f46d-39c1-4ed0-9de3-42d36155be59', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:51:38', 250, 0, '', '2019-06-03 16:51:38');
INSERT INTO `access_log` VALUES (25092, 'a956e45c-9f61-4dbd-a6af-d3ec8c081aaa', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:51:48', 305, 0, '', '2019-06-03 16:51:48');
INSERT INTO `access_log` VALUES (25093, '66.48.15595519137255119', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:51:54', 14, 0, '', '2019-06-03 16:51:54');
INSERT INTO `access_log` VALUES (25094, '02351fc6-2053-4c7e-9a6b-d33d217853ca', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:51:56', 190, 0, '', '2019-06-03 16:51:56');
INSERT INTO `access_log` VALUES (25095, '59.75.15595519172656431', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:51:57', 12, 0, '', '2019-06-03 16:51:57');
INSERT INTO `access_log` VALUES (25096, '59.73.15595519218196435', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '180.175.177.191', '2019-06-03 16:52:02', 3, 0, '', '2019-06-03 16:52:02');
INSERT INTO `access_log` VALUES (25097, '59.72.15595519218186427', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '180.175.177.191', '2019-06-03 16:52:02', 13, 2001001000, '服务端发生异常', '2019-06-03 16:52:02');
INSERT INTO `access_log` VALUES (25098, '59.79.15595519235176431', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:52:04', 12, 0, '', '2019-06-03 16:52:04');
INSERT INTO `access_log` VALUES (25099, '59.71.15595519312856435', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:52:11', 12, 0, '', '2019-06-03 16:52:11');
INSERT INTO `access_log` VALUES (25100, '64.79.15595519322976059', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:52:12', 9, 0, '', '2019-06-03 16:52:12');
INSERT INTO `access_log` VALUES (25101, '64.82.15595519363666073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '180.175.177.191', '2019-06-03 16:52:16', 2, 0, '', '2019-06-03 16:52:16');
INSERT INTO `access_log` VALUES (25102, '64.84.15595519369066067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '180.175.177.191', '2019-06-03 16:52:17', 2, 0, '', '2019-06-03 16:52:17');
INSERT INTO `access_log` VALUES (25103, '64.83.15595519373946059', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:52:17', 9, 0, '', '2019-06-03 16:52:17');
INSERT INTO `access_log` VALUES (25104, '65.54.15595519436016305', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:52:24', 9, 0, '', '2019-06-03 16:52:24');
INSERT INTO `access_log` VALUES (25105, '65.46.15595519446166337', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 16:52:25', 16, 0, '', '2019-06-03 16:52:25');
INSERT INTO `access_log` VALUES (25106, 'f991b038-7721-47e9-98a7-1d37b9480ec1', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:53:51', 394, 0, '', '2019-06-03 16:53:51');
INSERT INTO `access_log` VALUES (25107, '1c971151-caf6-44b9-8fbb-1c95a3f4647b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:53:53', 624, 0, '', '2019-06-03 16:53:54');
INSERT INTO `access_log` VALUES (25108, '59.74.15595523864616433', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.173.2.76', '2019-06-03 16:59:46', 10, 0, '', '2019-06-03 16:59:46');
INSERT INTO `access_log` VALUES (25109, '59.77.15595523864616429', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.173.2.76', '2019-06-03 16:59:46', 14, 2001001000, '服务端发生异常', '2019-06-03 16:59:46');
INSERT INTO `access_log` VALUES (25110, '64.83.15595525188686067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.173.2.76', '2019-06-03 17:01:59', 3, 0, '', '2019-06-03 17:01:59');
INSERT INTO `access_log` VALUES (25111, '64.85.15595525189826089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.173.2.76', '2019-06-03 17:01:59', 2, 0, '', '2019-06-03 17:01:59');
INSERT INTO `access_log` VALUES (25112, '64.77.15595525202036079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.173.2.76', '2019-06-03 17:02:00', 2, 0, '', '2019-06-03 17:02:00');
INSERT INTO `access_log` VALUES (25113, '64.78.15595525209916075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.173.2.76', '2019-06-03 17:02:01', 2, 0, '', '2019-06-03 17:02:01');
INSERT INTO `access_log` VALUES (25114, '64.80.15595525248676067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.173.2.76', '2019-06-03 17:02:05', 179, 0, '', '2019-06-03 17:02:05');
INSERT INTO `access_log` VALUES (25115, '64.76.15595525251846065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.173.2.76', '2019-06-03 17:02:05', 1, 0, '', '2019-06-03 17:02:05');
INSERT INTO `access_log` VALUES (25116, '59.78.15595525261166443', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.173.2.76', '2019-06-03 17:02:06', 3, 0, '', '2019-06-03 17:02:06');
INSERT INTO `access_log` VALUES (25117, '59.76.15595525261386435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.173.2.76', '2019-06-03 17:02:06', 13, 2001001000, '服务端发生异常', '2019-06-03 17:02:06');
INSERT INTO `access_log` VALUES (25118, '64.77.15595526136066081', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:03:34', 9, 0, '', '2019-06-03 17:03:34');
INSERT INTO `access_log` VALUES (25119, '64.80.15595526288776069', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:03:49', 9, 0, '', '2019-06-03 17:03:49');
INSERT INTO `access_log` VALUES (25120, '64.82.15595526721836085', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:04:32', 11, 0, '', '2019-06-03 17:04:32');
INSERT INTO `access_log` VALUES (25121, '64.84.15595526721886079', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:04:32', 9, 0, '', '2019-06-03 17:04:32');
INSERT INTO `access_log` VALUES (25122, '64.85.15595526748836093', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:04:35', 9, 0, '', '2019-06-03 17:04:35');
INSERT INTO `access_log` VALUES (25123, '64.83.15595526748836071', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:04:35', 12, 0, '', '2019-06-03 17:04:35');
INSERT INTO `access_log` VALUES (25124, '64.76.15595526797086069', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:04:40', 8, 0, '', '2019-06-03 17:04:40');
INSERT INTO `access_log` VALUES (25125, '64.80.15595526797076071', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:04:40', 10, 0, '', '2019-06-03 17:04:40');
INSERT INTO `access_log` VALUES (25126, '64.78.15595526797056079', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:04:40', 13, 0, '', '2019-06-03 17:04:40');
INSERT INTO `access_log` VALUES (25127, '64.82.15595527142346087', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=Kafka 书籍汇总&sellPoint=分布式发布订阅消息系统&cid=783&visible=true&id=33&picUrls=http://static.iocoder.cn/kafka.png&skuStr=[{\"attrs\":[3,1],\"price\":100,\"quantity\":2},{\"attrs\":[3,1],\"price\":100,\"quantity\":2},{\"attrs\":[4,2],\"price\":100,\"quantity\":2},{\"attrs\":[4,2],\"price\":100,\"quantity\":2}]&description=<p>kafka是一种高吞吐量的分布式发布订阅消息系统，她有如下特性：  通过O(1)的磁盘数据结构提供消息的持久化，这种结构对于即使数以TB的消息存储也能够保持长时间的稳定性能。  高吞吐量：即使是非常普通的硬件kafka也可以支持每秒数十万的消息。  支持通过kafka服务器和消费机集群来分区消息。  支持Hadoop并行数据加载。  卡夫卡的目的是提供一个发布订阅解决方案，它可以处理消费者规模的网站中的所有动作流数据。 这种动作（网页浏览，搜索和其他用户的行动）是在现代网络上的许多社会功能的一个关键因素。 这些数据通常是由于吞吐量的要求而通过处理日志和日志聚合来解决。 对于像Hadoop的一样的日志数据和离线分析系统，但又要求实时处理的限制，这是一个可行的解决方案。kafka的目的是通过Hadoop的并行加载机制来统一线上和离线的消息处理，也是为了通过集群机来提供实时的消费。</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:05:14', 389, 1002002009, NULL, '2019-06-03 17:05:15');
INSERT INTO `access_log` VALUES (25128, '59.72.15595530005756443', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:10:01', 10, 2001001000, '服务端发生异常', '2019-06-03 17:10:01');
INSERT INTO `access_log` VALUES (25129, '59.73.15595530005746451', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:10:01', 784, 0, '', '2019-06-03 17:10:01');
INSERT INTO `access_log` VALUES (25130, '59.72.15595530005756443', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:10:01', 10, 2001001000, '服务端发生异常', '2019-06-03 17:10:02');
INSERT INTO `access_log` VALUES (25131, '65.53.15595530163556331', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:10:16', 1, 1002001015, '账号未登陆', '2019-06-03 17:10:16');
INSERT INTO `access_log` VALUES (25132, '65.47.15595530163566359', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:10:16', 1, 1002001015, '账号未登陆', '2019-06-03 17:10:16');
INSERT INTO `access_log` VALUES (25133, '65.45.15595530163616373', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:10:16', 1, 1002001015, '账号未登陆', '2019-06-03 17:10:16');
INSERT INTO `access_log` VALUES (25134, '59.72.15595531378296445', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.18.3.222', '2019-06-03 17:12:18', 3, 0, '', '2019-06-03 17:12:18');
INSERT INTO `access_log` VALUES (25135, '59.79.15595531378426449', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.18.3.222', '2019-06-03 17:12:18', 12, 2001001000, '服务端发生异常', '2019-06-03 17:12:18');
INSERT INTO `access_log` VALUES (25136, '64.82.15595531448266093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.18.3.222', '2019-06-03 17:12:25', 3, 0, '', '2019-06-03 17:12:25');
INSERT INTO `access_log` VALUES (25137, '64.84.15595531449996087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.18.3.222', '2019-06-03 17:12:25', 2, 0, '', '2019-06-03 17:12:25');
INSERT INTO `access_log` VALUES (25138, '64.85.15595531465476101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.18.3.222', '2019-06-03 17:12:27', 3, 0, '', '2019-06-03 17:12:27');
INSERT INTO `access_log` VALUES (25139, '64.83.15595531473496079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.18.3.222', '2019-06-03 17:12:27', 150, 0, '', '2019-06-03 17:12:28');
INSERT INTO `access_log` VALUES (25140, '66.51.15595531612785129', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13261631500', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.18.3.222', '2019-06-03 17:12:41', 278, 0, '', '2019-06-03 17:12:42');
INSERT INTO `access_log` VALUES (25141, '66.50.15595531672495135', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13261631500&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.18.3.222', '2019-06-03 17:12:47', 190, 0, '', '2019-06-03 17:12:47');
INSERT INTO `access_log` VALUES (25142, '64.84.15595532051956089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:13:25', 3, 0, '', '2019-06-03 17:13:25');
INSERT INTO `access_log` VALUES (25143, '64.85.15595532054696103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:13:25', 2, 0, '', '2019-06-03 17:13:25');
INSERT INTO `access_log` VALUES (25144, '64.83.15595532066826081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:13:27', 2, 0, '', '2019-06-03 17:13:27');
INSERT INTO `access_log` VALUES (25145, '64.77.15595532072276093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:13:27', 3, 0, '', '2019-06-03 17:13:27');
INSERT INTO `access_log` VALUES (25146, '64.76.15595532076586079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:13:28', 3, 0, '', '2019-06-03 17:13:28');
INSERT INTO `access_log` VALUES (25147, '64.80.15595532079396081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:13:28', 2, 0, '', '2019-06-03 17:13:28');
INSERT INTO `access_log` VALUES (25148, '64.78.15595532081956089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:13:28', 2, 0, '', '2019-06-03 17:13:28');
INSERT INTO `access_log` VALUES (25149, '65.54.15595532107046323', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:13:31', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 17:13:31');
INSERT INTO `access_log` VALUES (25150, 'd3d38cea-cda5-44d5-8d6f-33110124d0c8', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 17:13:32', 501, 1002001012, '访问令牌已过期', '2019-06-03 17:13:33');
INSERT INTO `access_log` VALUES (25151, '3b1f7229-396f-4032-807e-9c3f2b823bd2', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 17:13:32', 501, 1002001012, '访问令牌已过期', '2019-06-03 17:13:33');
INSERT INTO `access_log` VALUES (25152, 'be31df2b-b376-4fc5-83e4-83ddd6880772', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 17:13:32', 501, 1002001012, '访问令牌已过期', '2019-06-03 17:13:33');
INSERT INTO `access_log` VALUES (25153, '2afa7a14-637e-421f-bf20-2b7ee686e8e7', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 17:13:32', 501, 1002001012, '访问令牌已过期', '2019-06-03 17:13:33');
INSERT INTO `access_log` VALUES (25154, 'e1f3c385-39b9-4bef-9b83-b3b1eb020e4d', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 17:13:35', 1589, 0, '', '2019-06-03 17:13:37');
INSERT INTO `access_log` VALUES (25155, 'fce52e6b-d851-4264-a6c7-92a14157205b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 17:13:37', 139, 0, '', '2019-06-03 17:13:37');
INSERT INTO `access_log` VALUES (25156, '3df8558d-66ae-4671-a43e-9be7b61b0f19', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 17:13:37', 159, 0, '', '2019-06-03 17:13:37');
INSERT INTO `access_log` VALUES (25157, '663eda13-f5e3-4d2f-bb15-6867e3a70c80', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 17:13:37', 166, 0, '', '2019-06-03 17:13:37');
INSERT INTO `access_log` VALUES (25158, 'f38a3d57-ba1a-4e4a-8e56-9c053f0d6c5d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 17:13:46', 473, 0, '', '2019-06-03 17:13:47');
INSERT INTO `access_log` VALUES (25159, 'c64a4e5d-3ff1-419a-aef0-5609863d9ce2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 17:14:08', 145, 0, '', '2019-06-03 17:14:08');
INSERT INTO `access_log` VALUES (25160, '65.47.15595532725266363', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:14:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 17:14:33');
INSERT INTO `access_log` VALUES (25161, '65.48.15595533031696363', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 17:15:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 17:15:03');
INSERT INTO `access_log` VALUES (25162, '64.77.15595534547576097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:17:35', 3, 0, '', '2019-06-03 17:17:35');
INSERT INTO `access_log` VALUES (25163, '64.76.15595534549966083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:17:35', 2, 0, '', '2019-06-03 17:17:35');
INSERT INTO `access_log` VALUES (25164, '66.57.15595534851765137', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18780175943', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:18:05', 88, 0, '', '2019-06-03 17:18:05');
INSERT INTO `access_log` VALUES (25165, '64.79.15595534959366087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:18:16', 2, 0, '', '2019-06-03 17:18:16');
INSERT INTO `access_log` VALUES (25166, '64.82.15595534960376101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:18:16', 2, 0, '', '2019-06-03 17:18:16');
INSERT INTO `access_log` VALUES (25167, '64.84.15595534989766095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:18:19', 3, 0, '', '2019-06-03 17:18:19');
INSERT INTO `access_log` VALUES (25168, '64.85.15595534991416109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:18:19', 2, 0, '', '2019-06-03 17:18:19');
INSERT INTO `access_log` VALUES (25169, '59.73.15595535002906459', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:18:20', 3, 0, '', '2019-06-03 17:18:20');
INSERT INTO `access_log` VALUES (25170, '59.72.15595535003286451', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:18:20', 14, 2001001000, '服务端发生异常', '2019-06-03 17:18:20');
INSERT INTO `access_log` VALUES (25171, 'e097e6ac-c03f-41f6-a1a1-ba9cf8c1274c', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 17:18:23', 95, 0, '', '2019-06-03 17:18:23');
INSERT INTO `access_log` VALUES (25172, 'fc2af9ae-4e47-483f-ad59-84a8498b15a3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 17:18:26', 14641, 0, '', '2019-06-03 17:18:41');
INSERT INTO `access_log` VALUES (25173, '64.82.15595535870496103', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 17:19:47', 7, 1002001012, '访问令牌已过期', '2019-06-03 17:19:47');
INSERT INTO `access_log` VALUES (25174, '64.79.15595535870496089', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 17:19:47', 7, 1002001012, '访问令牌已过期', '2019-06-03 17:19:47');
INSERT INTO `access_log` VALUES (25175, '65.48.15595535920956367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 17:19:52', 112, 0, '', '2019-06-03 17:19:52');
INSERT INTO `access_log` VALUES (25176, '65.52.15595535924486355', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 17:19:52', 9, 0, '', '2019-06-03 17:19:52');
INSERT INTO `access_log` VALUES (25177, '65.54.15595535924546329', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 17:19:52', 9, 0, '', '2019-06-03 17:19:52');
INSERT INTO `access_log` VALUES (25178, '65.49.15595535924566381', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 17:19:52', 9, 0, '', '2019-06-03 17:19:52');
INSERT INTO `access_log` VALUES (25179, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:18', 7, 0, '', '2019-06-03 17:20:18');
INSERT INTO `access_log` VALUES (25180, '64.83.15595536179516089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:18', 122, 0, '', '2019-06-03 17:20:18');
INSERT INTO `access_log` VALUES (25181, '64.77.15595536192976101', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:19', 7, 0, '', '2019-06-03 17:20:19');
INSERT INTO `access_log` VALUES (25182, '64.80.15595536218656089', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 17:20:22', 11, 0, '', '2019-06-03 17:20:22');
INSERT INTO `access_log` VALUES (25183, '64.78.15595536218686097', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.27.120.84', '2019-06-03 17:20:22', 8, 0, '', '2019-06-03 17:20:22');
INSERT INTO `access_log` VALUES (25184, '64.81.15595536236106093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:24', 2, 0, '', '2019-06-03 17:20:24');
INSERT INTO `access_log` VALUES (25185, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:24', 6, 0, '', '2019-06-03 17:20:24');
INSERT INTO `access_log` VALUES (25186, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:25', 6, 0, '', '2019-06-03 17:20:26');
INSERT INTO `access_log` VALUES (25187, '64.79.15595536266366091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:27', 2, 0, '', '2019-06-03 17:20:27');
INSERT INTO `access_log` VALUES (25188, '64.82.15595536267596105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:27', 2, 0, '', '2019-06-03 17:20:27');
INSERT INTO `access_log` VALUES (25189, '64.84.15595536278436099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:28', 2, 0, '', '2019-06-03 17:20:28');
INSERT INTO `access_log` VALUES (25190, '64.85.15595536289446113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:29', 2, 0, '', '2019-06-03 17:20:29');
INSERT INTO `access_log` VALUES (25191, '64.83.15595536299766091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:30', 2, 0, '', '2019-06-03 17:20:30');
INSERT INTO `access_log` VALUES (25192, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:30', 6, 0, '', '2019-06-03 17:20:30');
INSERT INTO `access_log` VALUES (25193, '64.77.15595536328316103', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:33', 149, 0, '', '2019-06-03 17:20:33');
INSERT INTO `access_log` VALUES (25194, '64.78.15595536402526099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:40', 2, 0, '', '2019-06-03 17:20:40');
INSERT INTO `access_log` VALUES (25195, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:40', 7, 0, '', '2019-06-03 17:20:40');
INSERT INTO `access_log` VALUES (25196, '64.80.15595536416536091', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:42', 7, 0, '', '2019-06-03 17:20:42');
INSERT INTO `access_log` VALUES (25197, '64.81.15595536473526095', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:20:47', 116, 0, '', '2019-06-03 17:20:47');
INSERT INTO `access_log` VALUES (25198, '64.76.15595537300806091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:10', 3, 0, '', '2019-06-03 17:22:10');
INSERT INTO `access_log` VALUES (25199, '64.78.15595537302306101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:10', 2, 0, '', '2019-06-03 17:22:10');
INSERT INTO `access_log` VALUES (25200, '64.80.15595537315956093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:12', 2, 0, '', '2019-06-03 17:22:12');
INSERT INTO `access_log` VALUES (25201, '64.81.15595537320496097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:12', 2, 0, '', '2019-06-03 17:22:12');
INSERT INTO `access_log` VALUES (25202, '59.78.15595537331406461', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:13', 2, 0, '', '2019-06-03 17:22:13');
INSERT INTO `access_log` VALUES (25203, '59.76.15595537331766453', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:13', 19, 2001001000, '服务端发生异常', '2019-06-03 17:22:13');
INSERT INTO `access_log` VALUES (25204, '64.79.15595537352256095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:15', 2, 0, '', '2019-06-03 17:22:15');
INSERT INTO `access_log` VALUES (25205, '64.82.15595537353516109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:15', 2, 0, '', '2019-06-03 17:22:15');
INSERT INTO `access_log` VALUES (25206, '59.73.15595537366626463', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:17', 13, 2001001000, '服务端发生异常', '2019-06-03 17:22:17');
INSERT INTO `access_log` VALUES (25207, '59.75.15595537366626459', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:17', 169, 0, '', '2019-06-03 17:22:17');
INSERT INTO `access_log` VALUES (25208, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:22', 12, 0, '', '2019-06-03 17:22:22');
INSERT INTO `access_log` VALUES (25209, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:22', 4, 0, '', '2019-06-03 17:22:22');
INSERT INTO `access_log` VALUES (25210, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:22', 14, 0, '', '2019-06-03 17:22:22');
INSERT INTO `access_log` VALUES (25211, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:23', 9, 0, '', '2019-06-03 17:22:23');
INSERT INTO `access_log` VALUES (25212, '64.85.15595537443666117', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:24', 7, 0, '', '2019-06-03 17:22:24');
INSERT INTO `access_log` VALUES (25213, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:33', 8, 0, '', '2019-06-03 17:22:33');
INSERT INTO `access_log` VALUES (25214, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:33', 7, 0, '', '2019-06-03 17:22:33');
INSERT INTO `access_log` VALUES (25215, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:33', 14, 0, '', '2019-06-03 17:22:33');
INSERT INTO `access_log` VALUES (25216, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:33', 15, 0, '', '2019-06-03 17:22:33');
INSERT INTO `access_log` VALUES (25217, '59.80.15595537610866451', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:41', 2, 0, '', '2019-06-03 17:22:41');
INSERT INTO `access_log` VALUES (25218, '59.71.15595537610876463', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.88.31.19', '2019-06-03 17:22:41', 13, 2001001000, '服务端发生异常', '2019-06-03 17:22:41');
INSERT INTO `access_log` VALUES (25219, '64.84.15595538719806105', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:24:32', 8, 0, '', '2019-06-03 17:24:32');
INSERT INTO `access_log` VALUES (25220, '64.83.15595538766716097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:24:37', 10, 0, '', '2019-06-03 17:24:37');
INSERT INTO `access_log` VALUES (25221, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:24:37', 7, 0, '', '2019-06-03 17:24:37');
INSERT INTO `access_log` VALUES (25222, '64.77.15595538784866109', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:24:38', 7, 0, '', '2019-06-03 17:24:38');
INSERT INTO `access_log` VALUES (25223, '64.76.15595538810426095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:24:41', 2, 0, '', '2019-06-03 17:24:41');
INSERT INTO `access_log` VALUES (25224, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:24:41', 7, 0, '', '2019-06-03 17:24:41');
INSERT INTO `access_log` VALUES (25225, '64.78.15595538849576105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:24:45', 2, 0, '', '2019-06-03 17:24:45');
INSERT INTO `access_log` VALUES (25226, '64.80.15595538850756097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:24:45', 2, 0, '', '2019-06-03 17:24:45');
INSERT INTO `access_log` VALUES (25227, '64.81.15595538859046101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:24:46', 2, 0, '', '2019-06-03 17:24:46');
INSERT INTO `access_log` VALUES (25228, '64.79.15595538865666099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:24:47', 3, 0, '', '2019-06-03 17:24:47');
INSERT INTO `access_log` VALUES (25229, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:24:47', 6, 0, '', '2019-06-03 17:24:47');
INSERT INTO `access_log` VALUES (25230, '64.82.15595538878606113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:24:48', 2, 0, '', '2019-06-03 17:24:48');
INSERT INTO `access_log` VALUES (25231, '64.84.15595538879686107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:24:48', 2, 0, '', '2019-06-03 17:24:48');
INSERT INTO `access_log` VALUES (25232, '64.77.15595538926936111', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:24:53', 11, 0, '', '2019-06-03 17:24:53');
INSERT INTO `access_log` VALUES (25233, '64.83.15595538926936099', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:24:53', 13, 0, '', '2019-06-03 17:24:53');
INSERT INTO `access_log` VALUES (25234, '64.78.15595539004946107', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:00', 10, 0, '', '2019-06-03 17:25:01');
INSERT INTO `access_log` VALUES (25235, '64.80.15595539004946099', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:00', 11, 0, '', '2019-06-03 17:25:01');
INSERT INTO `access_log` VALUES (25236, '64.76.15595539004946097', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:00', 14, 0, '', '2019-06-03 17:25:01');
INSERT INTO `access_log` VALUES (25237, '64.81.15595539039526103', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=测试商品&sellPoint=又大又长&cid=638&visible=true&id=28&picUrls=https://user-gold-cdn.xitu.io/2019/4/1/169d694b02ef0df7?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1,http://static.shop.iocoder.cn/49ace70a-bebc-4d1c-b4e7-2115cedbf2a8&skuStr=[{\"attrs\":[1],\"price\":10000,\"quantity\":100},{\"attrs\":[2],\"price\":20000,\"quantity\":200}]&description=<p>厮大牛逼</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:04', 7, 1002002009, NULL, '2019-06-03 17:25:04');
INSERT INTO `access_log` VALUES (25238, '64.82.15595539082426115', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:08', 9, 0, '', '2019-06-03 17:25:08');
INSERT INTO `access_log` VALUES (25239, '64.84.15595539082436109', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:08', 10, 0, '', '2019-06-03 17:25:08');
INSERT INTO `access_log` VALUES (25240, '64.83.15595539112176101', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:11', 8, 0, '', '2019-06-03 17:25:11');
INSERT INTO `access_log` VALUES (25241, '64.85.15595539112166123', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:11', 39, 0, '', '2019-06-03 17:25:11');
INSERT INTO `access_log` VALUES (25242, '64.77.15595539130026113', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:13', 11, 0, '', '2019-06-03 17:25:13');
INSERT INTO `access_log` VALUES (25243, '64.78.15595539146116109', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:15', 11, 0, '', '2019-06-03 17:25:15');
INSERT INTO `access_log` VALUES (25244, '64.76.15595539146146099', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:15', 9, 0, '', '2019-06-03 17:25:15');
INSERT INTO `access_log` VALUES (25245, '64.80.15595539146106101', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:15', 14, 0, '', '2019-06-03 17:25:15');
INSERT INTO `access_log` VALUES (25246, '64.79.15595539200956103', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:20', 8, 0, '', '2019-06-03 17:25:20');
INSERT INTO `access_log` VALUES (25247, '64.81.15595539200956105', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:20', 9, 0, '', '2019-06-03 17:25:20');
INSERT INTO `access_log` VALUES (25248, '64.83.15595539232776103', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:23', 546, 0, '', '2019-06-03 17:25:24');
INSERT INTO `access_log` VALUES (25249, '64.82.15595539232746117', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:23', 550, 0, '', '2019-06-03 17:25:24');
INSERT INTO `access_log` VALUES (25250, '64.77.15595539283716115', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:28', 8, 0, '', '2019-06-03 17:25:28');
INSERT INTO `access_log` VALUES (25251, '64.78.15595539283726111', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:28', 10, 0, '', '2019-06-03 17:25:28');
INSERT INTO `access_log` VALUES (25252, '64.85.15595539283696125', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:25:28', 13, 0, '', '2019-06-03 17:25:28');
INSERT INTO `access_log` VALUES (25253, '64.82.15595540094446119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:26:49', 2, 0, '', '2019-06-03 17:26:49');
INSERT INTO `access_log` VALUES (25254, '64.78.15595540106636113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:26:51', 2, 0, '', '2019-06-03 17:26:51');
INSERT INTO `access_log` VALUES (25255, '64.77.15595540115046117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:26:52', 2, 0, '', '2019-06-03 17:26:52');
INSERT INTO `access_log` VALUES (25256, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:26:52', 6, 0, '', '2019-06-03 17:26:52');
INSERT INTO `access_log` VALUES (25257, '64.85.15595540137396127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:26:54', 2, 0, '', '2019-06-03 17:26:54');
INSERT INTO `access_log` VALUES (25258, '64.76.15595540138166103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:26:54', 1, 0, '', '2019-06-03 17:26:54');
INSERT INTO `access_log` VALUES (25259, '64.80.15595540148506105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:26:55', 2, 0, '', '2019-06-03 17:26:55');
INSERT INTO `access_log` VALUES (25260, '64.79.15595540155576107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:26:56', 2, 0, '', '2019-06-03 17:26:56');
INSERT INTO `access_log` VALUES (25261, '64.81.15595540169206109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:26:57', 2, 0, '', '2019-06-03 17:26:57');
INSERT INTO `access_log` VALUES (25262, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:26:57', 7, 0, '', '2019-06-03 17:26:57');
INSERT INTO `access_log` VALUES (25263, '64.84.15595540180866115', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:26:58', 5, 0, '', '2019-06-03 17:26:58');
INSERT INTO `access_log` VALUES (25264, '59.74.15595541900396461', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:29:50', 15, 2001001000, '服务端发生异常', '2019-06-03 17:29:50');
INSERT INTO `access_log` VALUES (25265, '59.80.15595541900286457', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:29:50', 32, 0, '', '2019-06-03 17:29:50');
INSERT INTO `access_log` VALUES (25266, '64.80.15595545505896113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:35:51', 3, 0, '', '2019-06-03 17:35:51');
INSERT INTO `access_log` VALUES (25267, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:35:51', 7, 0, '', '2019-06-03 17:35:51');
INSERT INTO `access_log` VALUES (25268, '64.79.15595545526996115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:35:53', 87, 0, '', '2019-06-03 17:35:53');
INSERT INTO `access_log` VALUES (25269, '64.81.15595545531116117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:35:53', 55, 0, '', '2019-06-03 17:35:53');
INSERT INTO `access_log` VALUES (25270, '59.72.15595545538676467', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:35:54', 20, 2001001000, '服务端发生异常', '2019-06-03 17:35:54');
INSERT INTO `access_log` VALUES (25271, '59.75.15595545538676471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.67.245.152', '2019-06-03 17:35:54', 196, 0, '', '2019-06-03 17:35:54');
INSERT INTO `access_log` VALUES (25272, '64.83.15595545719466115', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:36:12', 11, 0, '', '2019-06-03 17:36:12');
INSERT INTO `access_log` VALUES (25273, '64.82.15595545719456129', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:36:12', 13, 0, '', '2019-06-03 17:36:12');
INSERT INTO `access_log` VALUES (25274, '64.76.15595545838606113', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:36:24', 9, 0, '', '2019-06-03 17:36:24');
INSERT INTO `access_log` VALUES (25275, '64.85.15595545838606137', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:36:24', 12, 0, '', '2019-06-03 17:36:24');
INSERT INTO `access_log` VALUES (25276, '64.77.15595545838606127', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:36:24', 15, 0, '', '2019-06-03 17:36:24');
INSERT INTO `access_log` VALUES (25277, '59.77.15595546184336463', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.240.208.131', '2019-06-03 17:36:58', 4, 0, '', '2019-06-03 17:36:58');
INSERT INTO `access_log` VALUES (25278, '59.78.15595546184346475', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.240.208.131', '2019-06-03 17:36:58', 13, 2001001000, '服务端发生异常', '2019-06-03 17:36:58');
INSERT INTO `access_log` VALUES (25279, '65.45.15595546249036399', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.240.208.131', '2019-06-03 17:37:05', 0, 1002001015, '账号未登陆', '2019-06-03 17:37:05');
INSERT INTO `access_log` VALUES (25280, '65.50.15595546249036389', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.240.208.131', '2019-06-03 17:37:05', 0, 1002001015, '账号未登陆', '2019-06-03 17:37:05');
INSERT INTO `access_log` VALUES (25281, '65.51.15595546249066377', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.240.208.131', '2019-06-03 17:37:05', 1, 1002001015, '账号未登陆', '2019-06-03 17:37:05');
INSERT INTO `access_log` VALUES (25282, '59.73.15595546249736477', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.139.240', '2019-06-03 17:37:05', 3, 0, '', '2019-06-03 17:37:05');
INSERT INTO `access_log` VALUES (25283, '59.72.15595546249746469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.139.240', '2019-06-03 17:37:05', 13, 2001001000, '服务端发生异常', '2019-06-03 17:37:05');
INSERT INTO `access_log` VALUES (25284, '65.48.15595546273466383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.240.208.131', '2019-06-03 17:37:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 17:37:07');
INSERT INTO `access_log` VALUES (25285, '65.54.15595546308016347', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.240.208.131', '2019-06-03 17:37:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 17:37:11');
INSERT INTO `access_log` VALUES (25286, '64.84.15595546318976125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.139.240', '2019-06-03 17:37:12', 2, 0, '', '2019-06-03 17:37:12');
INSERT INTO `access_log` VALUES (25287, '64.83.15595546320636117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.139.240', '2019-06-03 17:37:12', 2, 0, '', '2019-06-03 17:37:12');
INSERT INTO `access_log` VALUES (25288, '64.82.15595546340326131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.139.240', '2019-06-03 17:37:14', 2, 0, '', '2019-06-03 17:37:14');
INSERT INTO `access_log` VALUES (25289, '64.78.15595546346696125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.139.240', '2019-06-03 17:37:15', 2, 0, '', '2019-06-03 17:37:15');
INSERT INTO `access_log` VALUES (25290, '59.75.15595546375056473', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.139.240', '2019-06-03 17:37:18', 3, 0, '', '2019-06-03 17:37:18');
INSERT INTO `access_log` VALUES (25291, '59.79.15595546375066473', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.139.240', '2019-06-03 17:37:18', 14, 2001001000, '服务端发生异常', '2019-06-03 17:37:18');
INSERT INTO `access_log` VALUES (25292, '65.52.15595546399306371', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:37:20', 9, 0, '', '2019-06-03 17:37:20');
INSERT INTO `access_log` VALUES (25293, '64.76.15595546454786115', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:37:25', 8, 0, '', '2019-06-03 17:37:25');
INSERT INTO `access_log` VALUES (25294, '62.87.15595547593006335', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:39:19', 7, 1002001012, '访问令牌已过期', '2019-06-03 17:39:19');
INSERT INTO `access_log` VALUES (25295, '65.52.15595547708186373', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:39:31', 433, 0, '', '2019-06-03 17:39:31');
INSERT INTO `access_log` VALUES (25296, '65.46.15595547716296381', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:39:32', 10, 0, '', '2019-06-03 17:39:32');
INSERT INTO `access_log` VALUES (25297, '65.53.15595547716316359', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:39:32', 8, 0, '', '2019-06-03 17:39:32');
INSERT INTO `access_log` VALUES (25298, '65.47.15595547716356385', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:39:32', 9, 0, '', '2019-06-03 17:39:32');
INSERT INTO `access_log` VALUES (25299, '62.84.15595547744456323', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:39:34', 21, 0, '', '2019-06-03 17:39:34');
INSERT INTO `access_log` VALUES (25300, '65.54.15595548537136351', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.159.40.139', '2019-06-03 17:40:54', 1, 1002001015, '账号未登陆', '2019-06-03 17:40:54');
INSERT INTO `access_log` VALUES (25301, '65.52.15595548537276375', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.159.40.139', '2019-06-03 17:40:54', 0, 1002001015, '账号未登陆', '2019-06-03 17:40:54');
INSERT INTO `access_log` VALUES (25302, '65.46.15595548537306383', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.159.40.139', '2019-06-03 17:40:54', 1, 1002001015, '账号未登陆', '2019-06-03 17:40:54');
INSERT INTO `access_log` VALUES (25303, '65.47.15595548651566387', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.159.40.139', '2019-06-03 17:41:05', 284, 0, '', '2019-06-03 17:41:05');
INSERT INTO `access_log` VALUES (25304, '65.51.15595548657156383', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.159.40.139', '2019-06-03 17:41:06', 9, 0, '', '2019-06-03 17:41:06');
INSERT INTO `access_log` VALUES (25305, '65.50.15595548657196395', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.159.40.139', '2019-06-03 17:41:06', 9, 0, '', '2019-06-03 17:41:06');
INSERT INTO `access_log` VALUES (25306, '65.45.15595548657216405', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.159.40.139', '2019-06-03 17:41:06', 9, 0, '', '2019-06-03 17:41:06');
INSERT INTO `access_log` VALUES (25307, '62.87.15595548732836337', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.159.40.139', '2019-06-03 17:41:13', 15, 0, '', '2019-06-03 17:41:13');
INSERT INTO `access_log` VALUES (25308, '64.77.15595550956366135', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 17:44:56', 8, 1002001012, '访问令牌已过期', '2019-06-03 17:44:56');
INSERT INTO `access_log` VALUES (25309, '64.80.15595550956376123', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 17:44:56', 7, 1002001012, '访问令牌已过期', '2019-06-03 17:44:56');
INSERT INTO `access_log` VALUES (25310, '59.72.15595551684446477', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.185.110.199', '2019-06-03 17:46:08', 3, 0, '', '2019-06-03 17:46:08');
INSERT INTO `access_log` VALUES (25311, '59.73.15595551684456485', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.185.110.199', '2019-06-03 17:46:08', 13, 2001001000, '服务端发生异常', '2019-06-03 17:46:08');
INSERT INTO `access_log` VALUES (25312, '64.78.15595551724546133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.185.110.199', '2019-06-03 17:46:12', 3, 0, '', '2019-06-03 17:46:12');
INSERT INTO `access_log` VALUES (25313, '64.85.15595551726376147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.185.110.199', '2019-06-03 17:46:13', 2, 0, '', '2019-06-03 17:46:13');
INSERT INTO `access_log` VALUES (25314, '64.76.15595551742036123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.185.110.199', '2019-06-03 17:46:14', 2, 0, '', '2019-06-03 17:46:14');
INSERT INTO `access_log` VALUES (25315, '59.79.15595551759136481', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.185.110.199', '2019-06-03 17:46:16', 2, 0, '', '2019-06-03 17:46:16');
INSERT INTO `access_log` VALUES (25316, '59.75.15595551759166481', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.185.110.199', '2019-06-03 17:46:16', 13, 2001001000, '服务端发生异常', '2019-06-03 17:46:16');
INSERT INTO `access_log` VALUES (25317, '59.72.15595557071406485', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:07', 14, 2001001000, '服务端发生异常', '2019-06-03 17:55:07');
INSERT INTO `access_log` VALUES (25318, '59.73.15595557071256493', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:07', 66, 0, '', '2019-06-03 17:55:07');
INSERT INTO `access_log` VALUES (25319, '64.82.15595557132806147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:13', 2, 0, '', '2019-06-03 17:55:13');
INSERT INTO `access_log` VALUES (25320, '64.78.15595557134456141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:13', 2, 0, '', '2019-06-03 17:55:13');
INSERT INTO `access_log` VALUES (25321, '64.76.15595557237906131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:24', 3, 0, '', '2019-06-03 17:55:24');
INSERT INTO `access_log` VALUES (25322, '64.77.15595557240556145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:24', 2, 0, '', '2019-06-03 17:55:24');
INSERT INTO `access_log` VALUES (25323, '59.71.15595557254006493', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:25', 9, 0, '', '2019-06-03 17:55:25');
INSERT INTO `access_log` VALUES (25324, '59.75.15595557253956489', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:25', 20, 2001001000, '服务端发生异常', '2019-06-03 17:55:25');
INSERT INTO `access_log` VALUES (25325, '64.80.15595557289506133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:29', 2, 0, '', '2019-06-03 17:55:29');
INSERT INTO `access_log` VALUES (25326, '64.79.15595557291306135', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:29', 2, 0, '', '2019-06-03 17:55:29');
INSERT INTO `access_log` VALUES (25327, '59.80.15595557309906481', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:31', 3, 0, '', '2019-06-03 17:55:31');
INSERT INTO `access_log` VALUES (25328, '59.74.15595557309846485', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:31', 14, 2001001000, '服务端发生异常', '2019-06-03 17:55:31');
INSERT INTO `access_log` VALUES (25329, '65.46.15595557481006395', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:48', 0, 1002001015, '账号未登陆', '2019-06-03 17:55:48');
INSERT INTO `access_log` VALUES (25330, '65.52.15595557481116389', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:48', 0, 1002001015, '账号未登陆', '2019-06-03 17:55:48');
INSERT INTO `access_log` VALUES (25331, '65.53.15595557481266375', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:48', 0, 1002001015, '账号未登陆', '2019-06-03 17:55:48');
INSERT INTO `access_log` VALUES (25332, '65.51.15595557564986397', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:55:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 17:55:57');
INSERT INTO `access_log` VALUES (25333, '65.49.15595557888556417', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyianma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:56:29', 91, 0, '', '2019-06-03 17:56:29');
INSERT INTO `access_log` VALUES (25334, '65.48.15595557896976403', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:56:30', 10, 0, '', '2019-06-03 17:56:30');
INSERT INTO `access_log` VALUES (25335, '65.54.15595557897076367', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:56:30', 9, 0, '', '2019-06-03 17:56:30');
INSERT INTO `access_log` VALUES (25336, '65.46.15595557897166397', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:56:30', 9, 0, '', '2019-06-03 17:56:30');
INSERT INTO `access_log` VALUES (25337, '65.47.15595558218056401', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:02', 10, 0, '', '2019-06-03 17:57:02');
INSERT INTO `access_log` VALUES (25338, '65.51.15595558218306399', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:02', 10, 0, '', '2019-06-03 17:57:02');
INSERT INTO `access_log` VALUES (25339, '65.45.15595558218376421', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:02', 8, 0, '', '2019-06-03 17:57:02');
INSERT INTO `access_log` VALUES (25340, '65.50.15595558227316411', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:03', 20, 0, '', '2019-06-03 17:57:03');
INSERT INTO `access_log` VALUES (25341, '65.54.15595558553506369', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:35', 10, 0, '', '2019-06-03 17:57:35');
INSERT INTO `access_log` VALUES (25342, '65.46.15595558553506399', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:35', 11, 0, '', '2019-06-03 17:57:35');
INSERT INTO `access_log` VALUES (25343, '65.53.15595558553526379', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:35', 9, 0, '', '2019-06-03 17:57:35');
INSERT INTO `access_log` VALUES (25344, '65.47.15595558646996403', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:45', 9, 0, '', '2019-06-03 17:57:45');
INSERT INTO `access_log` VALUES (25345, '65.51.15595558647076401', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:45', 9, 0, '', '2019-06-03 17:57:45');
INSERT INTO `access_log` VALUES (25346, '65.45.15595558647246423', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:45', 9, 0, '', '2019-06-03 17:57:45');
INSERT INTO `access_log` VALUES (25347, '64.81.15595558655756139', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:46', 279, 0, '', '2019-06-03 17:57:46');
INSERT INTO `access_log` VALUES (25348, '64.79.15595558655686137', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:46', 288, 0, '', '2019-06-03 17:57:46');
INSERT INTO `access_log` VALUES (25349, '64.82.15595558719006151', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:52', 10, 0, '', '2019-06-03 17:57:52');
INSERT INTO `access_log` VALUES (25350, '64.78.15595558719006145', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:52', 11, 0, '', '2019-06-03 17:57:52');
INSERT INTO `access_log` VALUES (25351, '64.83.15595558719006137', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO A77 Build/NMF26F) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.37.47', '2019-06-03 17:57:52', 14, 0, '', '2019-06-03 17:57:52');
INSERT INTO `access_log` VALUES (25352, '59.76.15595559052706487', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:58:25', 12, 0, '', '2019-06-03 17:58:25');
INSERT INTO `access_log` VALUES (25353, '64.77.15595559083056149', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:58:28', 10, 0, '', '2019-06-03 17:58:28');
INSERT INTO `access_log` VALUES (25354, '64.79.15595559443846139', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:59:04', 10, 0, '', '2019-06-03 17:59:04');
INSERT INTO `access_log` VALUES (25355, '59.75.15595559509586493', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:59:11', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 17:59:11');
INSERT INTO `access_log` VALUES (25356, '59.71.15595559557546497', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:59:16', 11, 0, '', '2019-06-03 17:59:16');
INSERT INTO `access_log` VALUES (25357, '59.77.15595559796556485', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.22', '2019-06-03 17:59:40', 3, 0, '', '2019-06-03 17:59:40');
INSERT INTO `access_log` VALUES (25358, '59.78.15595559796576497', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.22', '2019-06-03 17:59:40', 14, 2001001000, '服务端发生异常', '2019-06-03 17:59:40');
INSERT INTO `access_log` VALUES (25359, '64.78.15595559823956147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.22', '2019-06-03 17:59:42', 2, 0, '', '2019-06-03 17:59:42');
INSERT INTO `access_log` VALUES (25360, '64.85.15595559825256161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.22', '2019-06-03 17:59:43', 1, 0, '', '2019-06-03 17:59:43');
INSERT INTO `access_log` VALUES (25361, '64.76.15595559864106137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 17:59:46', 2, 0, '', '2019-06-03 17:59:46');
INSERT INTO `access_log` VALUES (25362, '59.76.15595559865076489', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:59:47', 12, 0, '', '2019-06-03 17:59:47');
INSERT INTO `access_log` VALUES (25363, '64.77.15595559865306151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 17:59:47', 2, 0, '', '2019-06-03 17:59:47');
INSERT INTO `access_log` VALUES (25364, '64.80.15595559891806139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 17:59:49', 2, 0, '', '2019-06-03 17:59:49');
INSERT INTO `access_log` VALUES (25365, '64.81.15595559893046143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 17:59:49', 2, 0, '', '2019-06-03 17:59:49');
INSERT INTO `access_log` VALUES (25366, '59.72.15595559898946491', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 17:59:50', 3, 0, '', '2019-06-03 17:59:50');
INSERT INTO `access_log` VALUES (25367, '59.79.15595559898956495', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 17:59:50', 14, 2001001000, '服务端发生异常', '2019-06-03 17:59:50');
INSERT INTO `access_log` VALUES (25368, '64.84.15595559923396149', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:59:52', 10, 0, '', '2019-06-03 17:59:52');
INSERT INTO `access_log` VALUES (25369, '64.83.15595559923476141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 17:59:52', 2, 0, '', '2019-06-03 17:59:52');
INSERT INTO `access_log` VALUES (25370, '64.82.15595559924906155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 17:59:52', 2, 0, '', '2019-06-03 17:59:52');
INSERT INTO `access_log` VALUES (25371, '64.78.15595559937056149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 17:59:54', 2, 0, '', '2019-06-03 17:59:54');
INSERT INTO `access_log` VALUES (25372, '64.85.15595559945616163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 17:59:55', 2, 0, '', '2019-06-03 17:59:55');
INSERT INTO `access_log` VALUES (25373, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 17:59:55', 7, 0, '', '2019-06-03 17:59:55');
INSERT INTO `access_log` VALUES (25374, '64.77.15595559960806153', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 17:59:56', 382, 0, '', '2019-06-03 17:59:56');
INSERT INTO `access_log` VALUES (25375, '64.76.15595559952056139', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-03 17:59:55', 1257, 0, '', '2019-06-03 17:59:56');
INSERT INTO `access_log` VALUES (25376, '64.81.15595560065466145', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 18:00:07', 8, 0, '', '2019-06-03 18:00:07');
INSERT INTO `access_log` VALUES (25377, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 18:00:12', 7, 0, '', '2019-06-03 18:00:12');
INSERT INTO `access_log` VALUES (25378, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 18:00:12', 7, 0, '', '2019-06-03 18:00:13');
INSERT INTO `access_log` VALUES (25379, '64.79.15595560117746143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 18:00:12', 1188, 0, '', '2019-06-03 18:00:13');
INSERT INTO `access_log` VALUES (25380, '64.84.15595560130236151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 18:00:13', 2, 0, '', '2019-06-03 18:00:13');
INSERT INTO `access_log` VALUES (25381, '64.83.15595560139806143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.52.22', '2019-06-03 18:00:14', 2, 0, '', '2019-06-03 18:00:14');
INSERT INTO `access_log` VALUES (25382, '65.50.15595567560406425', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:12:36', 0, 1002001015, '账号未登陆', '2019-06-03 18:12:36');
INSERT INTO `access_log` VALUES (25383, '65.47.15595567560396415', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:12:36', 0, 1002001015, '账号未登陆', '2019-06-03 18:12:36');
INSERT INTO `access_log` VALUES (25384, '65.49.15595567560436433', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:12:36', 0, 1002001015, '账号未登陆', '2019-06-03 18:12:36');
INSERT INTO `access_log` VALUES (25385, '65.48.15595567585206419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:12:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 18:12:39');
INSERT INTO `access_log` VALUES (25386, '65.53.15595567674166393', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=youdaoyuanma&password=youdaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:12:47', 4, 1002002000, '账号不存在', '2019-06-03 18:12:47');
INSERT INTO `access_log` VALUES (25387, '65.52.15595567774016407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:12:57', 5, 1002002000, '账号不存在', '2019-06-03 18:12:57');
INSERT INTO `access_log` VALUES (25388, '65.45.15595567865886437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:13:07', 97, 0, '', '2019-06-03 18:13:07');
INSERT INTO `access_log` VALUES (25389, '65.51.15595567870336415', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:13:07', 10, 0, '', '2019-06-03 18:13:07');
INSERT INTO `access_log` VALUES (25390, '65.47.15595567870356417', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:13:07', 8, 0, '', '2019-06-03 18:13:07');
INSERT INTO `access_log` VALUES (25391, '65.50.15595567870466427', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:13:07', 8, 0, '', '2019-06-03 18:13:07');
INSERT INTO `access_log` VALUES (25392, '62.88.15595567923326369', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:13:12', 22, 0, '', '2019-06-03 18:13:12');
INSERT INTO `access_log` VALUES (25393, '64.77.15595567969426165', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:13:17', 198, 0, '', '2019-06-03 18:13:17');
INSERT INTO `access_log` VALUES (25394, '64.85.15595567969426175', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:13:17', 200, 0, '', '2019-06-03 18:13:17');
INSERT INTO `access_log` VALUES (25395, '59.77.15595568133836497', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:13:33', 12, 0, '', '2019-06-03 18:13:33');
INSERT INTO `access_log` VALUES (25396, '65.53.15595568271906395', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:13:47', 15, 0, '', '2019-06-03 18:13:47');
INSERT INTO `access_log` VALUES (25397, '65.52.15595568387276409', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:13:59', 11, 0, '', '2019-06-03 18:13:59');
INSERT INTO `access_log` VALUES (25398, '64.79.15595568424346155', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:14:02', 16, 0, '', '2019-06-03 18:14:02');
INSERT INTO `access_log` VALUES (25399, '64.84.15595568424346163', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:14:02', 18, 0, '', '2019-06-03 18:14:02');
INSERT INTO `access_log` VALUES (25400, '59.79.15595568602096507', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:14:20', 2, 0, '', '2019-06-03 18:14:20');
INSERT INTO `access_log` VALUES (25401, '59.75.15595568602096507', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:14:20', 13, 2001001000, '服务端发生异常', '2019-06-03 18:14:20');
INSERT INTO `access_log` VALUES (25402, '64.78.15595568635726163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:14:24', 2, 0, '', '2019-06-03 18:14:24');
INSERT INTO `access_log` VALUES (25403, '64.77.15595568637766167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:14:24', 2, 0, '', '2019-06-03 18:14:24');
INSERT INTO `access_log` VALUES (25404, '64.85.15595568689196177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:14:29', 2, 0, '', '2019-06-03 18:14:29');
INSERT INTO `access_log` VALUES (25405, '64.76.15595568690356153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.109.26.122', '2019-06-03 18:14:29', 2, 0, '', '2019-06-03 18:14:29');
INSERT INTO `access_log` VALUES (25406, '59.71.15595576185876521', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.193.129', '2019-06-03 18:26:59', 4, 0, '', '2019-06-03 18:26:59');
INSERT INTO `access_log` VALUES (25407, '59.80.15595576185916509', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.193.129', '2019-06-03 18:26:59', 14, 2001001000, '服务端发生异常', '2019-06-03 18:26:59');
INSERT INTO `access_log` VALUES (25408, '64.81.15595576306826169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.193.129', '2019-06-03 18:27:11', 3, 0, '', '2019-06-03 18:27:11');
INSERT INTO `access_log` VALUES (25409, '64.84.15595576308666175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.193.129', '2019-06-03 18:27:11', 2, 0, '', '2019-06-03 18:27:11');
INSERT INTO `access_log` VALUES (25410, '64.79.15595576348886167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.193.129', '2019-06-03 18:27:15', 2, 0, '', '2019-06-03 18:27:15');
INSERT INTO `access_log` VALUES (25411, '64.82.15595576470716181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.193.129', '2019-06-03 18:27:27', 2, 0, '', '2019-06-03 18:27:27');
INSERT INTO `access_log` VALUES (25412, '64.78.15595576472106175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.193.129', '2019-06-03 18:27:27', 1, 0, '', '2019-06-03 18:27:27');
INSERT INTO `access_log` VALUES (25413, '65.50.15595579986336443', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:33:19', 0, 1002001015, '账号未登陆', '2019-06-03 18:33:19');
INSERT INTO `access_log` VALUES (25414, '65.47.15595579986326433', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:33:19', 0, 1002001015, '账号未登陆', '2019-06-03 18:33:19');
INSERT INTO `access_log` VALUES (25415, '65.49.15595579986496453', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:33:19', 0, 1002001015, '账号未登陆', '2019-06-03 18:33:19');
INSERT INTO `access_log` VALUES (25416, '65.53.15595580199566411', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:33:40', 131, 0, '', '2019-06-03 18:33:40');
INSERT INTO `access_log` VALUES (25417, '65.54.15595580204576403', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:33:40', 11, 0, '', '2019-06-03 18:33:40');
INSERT INTO `access_log` VALUES (25418, '65.52.15595580204616427', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:33:40', 9, 0, '', '2019-06-03 18:33:40');
INSERT INTO `access_log` VALUES (25419, '65.45.15595580204666457', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:33:40', 9, 0, '', '2019-06-03 18:33:40');
INSERT INTO `access_log` VALUES (25420, '62.84.15595580301906367', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:33:50', 188, 0, '', '2019-06-03 18:33:50');
INSERT INTO `access_log` VALUES (25421, '62.86.15595580453676367', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:34:05', 14, 0, '', '2019-06-03 18:34:05');
INSERT INTO `access_log` VALUES (25422, '64.82.15595580532096187', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:34:13', 9, 0, '', '2019-06-03 18:34:13');
INSERT INTO `access_log` VALUES (25423, '64.83.15595580532086173', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:34:13', 12, 0, '', '2019-06-03 18:34:13');
INSERT INTO `access_log` VALUES (25424, '64.77.15595580569156185', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:34:17', 8, 0, '', '2019-06-03 18:34:17');
INSERT INTO `access_log` VALUES (25425, '64.78.15595580569136181', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:34:17', 11, 0, '', '2019-06-03 18:34:17');
INSERT INTO `access_log` VALUES (25426, '64.76.15595580691906171', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:34:29', 9, 0, '', '2019-06-03 18:34:29');
INSERT INTO `access_log` VALUES (25427, '66.49.15595580907265197', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:34:51', 293, 0, '', '2019-06-03 18:34:51');
INSERT INTO `access_log` VALUES (25428, '59.78.15595580942726527', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:34:54', 12, 0, '', '2019-06-03 18:34:54');
INSERT INTO `access_log` VALUES (25429, '59.76.15595581007116519', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:35:01', 1243, 2001001000, '服务端发生异常', '2019-06-03 18:35:02');
INSERT INTO `access_log` VALUES (25430, '59.72.15595581082506521', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:35:08', 209, 0, '', '2019-06-03 18:35:08');
INSERT INTO `access_log` VALUES (25431, '59.80.15595581474186517', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/update_status', 'id=7&status=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:35:47', 9, 1002002009, NULL, '2019-06-03 18:35:47');
INSERT INTO `access_log` VALUES (25432, '65.52.15595581528316429', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:35:53', 20, 0, '', '2019-06-03 18:35:53');
INSERT INTO `access_log` VALUES (25433, '65.51.15595581553186437', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:35:55', 10, 0, '', '2019-06-03 18:35:55');
INSERT INTO `access_log` VALUES (25434, '65.50.15595581584056447', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:35:58', 9, 0, '', '2019-06-03 18:35:58');
INSERT INTO `access_log` VALUES (25435, '65.47.15595581667726437', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '43.243.12.129', '2019-06-03 18:36:07', 43, 0, '', '2019-06-03 18:36:07');
INSERT INTO `access_log` VALUES (25436, '59.75.15595583930556529', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.139.225.59', '2019-06-03 18:39:53', 10, 2001001000, '服务端发生异常', '2019-06-03 18:39:53');
INSERT INTO `access_log` VALUES (25437, '59.79.15595583930546529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.139.225.59', '2019-06-03 18:39:53', 188, 0, '', '2019-06-03 18:39:53');
INSERT INTO `access_log` VALUES (25438, '65.46.15595587935856445', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:46:34', 5, 1002001012, '访问令牌已过期', '2019-06-03 18:46:34');
INSERT INTO `access_log` VALUES (25439, '65.53.15595587935856423', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:46:34', 5, 1002001012, '访问令牌已过期', '2019-06-03 18:46:34');
INSERT INTO `access_log` VALUES (25440, '65.54.15595587935946415', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:46:34', 3, 1002001012, '访问令牌已过期', '2019-06-03 18:46:34');
INSERT INTO `access_log` VALUES (25441, '65.52.15595587952696439', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:46:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 18:46:35');
INSERT INTO `access_log` VALUES (25442, '65.45.15595587987836469', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:46:39', 84, 0, '', '2019-06-03 18:46:39');
INSERT INTO `access_log` VALUES (25443, '65.50.15595587991326457', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:46:39', 8, 0, '', '2019-06-03 18:46:39');
INSERT INTO `access_log` VALUES (25444, '65.47.15595587991356447', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:46:39', 8, 0, '', '2019-06-03 18:46:39');
INSERT INTO `access_log` VALUES (25445, '65.49.15595587991436467', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:46:39', 9, 0, '', '2019-06-03 18:46:39');
INSERT INTO `access_log` VALUES (25446, '64.80.15595588030046183', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:46:43', 18, 0, '', '2019-06-03 18:46:43');
INSERT INTO `access_log` VALUES (25447, '64.76.15595588029996181', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:46:43', 25, 0, '', '2019-06-03 18:46:43');
INSERT INTO `access_log` VALUES (25448, '64.84.15595588243786193', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:47:04', 10, 0, '', '2019-06-03 18:47:04');
INSERT INTO `access_log` VALUES (25449, '64.79.15595588243826185', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:47:04', 6, 0, '', '2019-06-03 18:47:04');
INSERT INTO `access_log` VALUES (25450, '64.83.15595588297826185', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:47:10', 10, 0, '', '2019-06-03 18:47:10');
INSERT INTO `access_log` VALUES (25451, '66.49.15595588376915207', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:47:18', 18, 0, '', '2019-06-03 18:47:18');
INSERT INTO `access_log` VALUES (25452, '62.84.15595588514816379', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.188', '2019-06-03 18:47:31', 136, 0, '', '2019-06-03 18:47:32');
INSERT INTO `access_log` VALUES (25453, '59.80.15595591529936531', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:64.0) Gecko/20100101 Firefox/64.0', '112.80.133.216', '2019-06-03 18:52:33', 3, 0, '', '2019-06-03 18:52:33');
INSERT INTO `access_log` VALUES (25454, '59.71.15595591529946543', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:64.0) Gecko/20100101 Firefox/64.0', '112.80.133.216', '2019-06-03 18:52:33', 27, 2001001000, '服务端发生异常', '2019-06-03 18:52:33');
INSERT INTO `access_log` VALUES (25455, '64.85.15595591566146211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:64.0) Gecko/20100101 Firefox/64.0', '112.80.133.216', '2019-06-03 18:52:37', 433, 0, '', '2019-06-03 18:52:37');
INSERT INTO `access_log` VALUES (25456, '64.80.15595591571576189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:64.0) Gecko/20100101 Firefox/64.0', '112.80.133.216', '2019-06-03 18:52:37', 2, 0, '', '2019-06-03 18:52:37');
INSERT INTO `access_log` VALUES (25457, '64.76.15595591590976187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:64.0) Gecko/20100101 Firefox/64.0', '112.80.133.216', '2019-06-03 18:52:39', 3, 0, '', '2019-06-03 18:52:39');
INSERT INTO `access_log` VALUES (25458, '64.81.15595591596836193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:64.0) Gecko/20100101 Firefox/64.0', '112.80.133.216', '2019-06-03 18:52:40', 130, 0, '', '2019-06-03 18:52:40');
INSERT INTO `access_log` VALUES (25459, '65.47.15595593733156455', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:13', 70, 0, '', '2019-06-03 18:56:13');
INSERT INTO `access_log` VALUES (25460, '65.49.15595593737076475', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:14', 10, 0, '', '2019-06-03 18:56:14');
INSERT INTO `access_log` VALUES (25461, '65.48.15595593737126461', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:14', 10, 0, '', '2019-06-03 18:56:14');
INSERT INTO `access_log` VALUES (25462, '65.46.15595593737156455', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:14', 9, 0, '', '2019-06-03 18:56:14');
INSERT INTO `access_log` VALUES (25463, '62.80.15595593852166399', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:25', 14, 0, '', '2019-06-03 18:56:25');
INSERT INTO `access_log` VALUES (25464, '64.77.15595593917446205', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:32', 10, 0, '', '2019-06-03 18:56:32');
INSERT INTO `access_log` VALUES (25465, '64.85.15595593917486215', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:32', 7, 0, '', '2019-06-03 18:56:32');
INSERT INTO `access_log` VALUES (25466, '66.54.15595593971455219', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:37', 14, 0, '', '2019-06-03 18:56:37');
INSERT INTO `access_log` VALUES (25467, '59.79.15595594003656543', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:40', 20, 0, '', '2019-06-03 18:56:40');
INSERT INTO `access_log` VALUES (25468, '59.71.15595594023306547', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:42', 20, 2001001000, '服务端发生异常', '2019-06-03 18:56:42');
INSERT INTO `access_log` VALUES (25469, '59.80.15595594042746535', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:44', 12, 0, '', '2019-06-03 18:56:44');
INSERT INTO `access_log` VALUES (25470, '59.74.15595594062046539', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:46', 11, 0, '', '2019-06-03 18:56:46');
INSERT INTO `access_log` VALUES (25471, '59.77.15595594076906535', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:48', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 18:56:48');
INSERT INTO `access_log` VALUES (25472, '65.52.15595594111876449', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:51', 20, 0, '', '2019-06-03 18:56:51');
INSERT INTO `access_log` VALUES (25473, '65.51.15595594144716457', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:54', 10, 0, '', '2019-06-03 18:56:54');
INSERT INTO `access_log` VALUES (25474, '65.50.15595594153166467', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:55', 9, 0, '', '2019-06-03 18:56:55');
INSERT INTO `access_log` VALUES (25475, '65.47.15595594157556457', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.211.52', '2019-06-03 18:56:56', 14, 0, '', '2019-06-03 18:56:56');
INSERT INTO `access_log` VALUES (25476, '65.52.15595598021056455', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.136.38.22', '2019-06-03 19:03:22', 0, 1002001015, '账号未登陆', '2019-06-03 19:03:22');
INSERT INTO `access_log` VALUES (25477, '65.45.15595598021096485', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.136.38.22', '2019-06-03 19:03:22', 0, 1002001015, '账号未登陆', '2019-06-03 19:03:22');
INSERT INTO `access_log` VALUES (25478, '65.51.15595598021236463', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.136.38.22', '2019-06-03 19:03:22', 1, 1002001015, '账号未登陆', '2019-06-03 19:03:22');
INSERT INTO `access_log` VALUES (25479, '65.47.15595598048436463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.136.38.22', '2019-06-03 19:03:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 19:03:25');
INSERT INTO `access_log` VALUES (25480, '65.46.15595598070166463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.136.38.22', '2019-06-03 19:03:27', 95, 0, '', '2019-06-03 19:03:27');
INSERT INTO `access_log` VALUES (25481, '65.48.15595598074356469', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.136.38.22', '2019-06-03 19:03:27', 10, 0, '', '2019-06-03 19:03:27');
INSERT INTO `access_log` VALUES (25482, '65.49.15595598074426483', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.136.38.22', '2019-06-03 19:03:27', 10, 0, '', '2019-06-03 19:03:27');
INSERT INTO `access_log` VALUES (25483, '65.54.15595598074456433', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.136.38.22', '2019-06-03 19:03:27', 8, 0, '', '2019-06-03 19:03:27');
INSERT INTO `access_log` VALUES (25484, '62.88.15595598113766411', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.136.38.22', '2019-06-03 19:03:31', 11, 0, '', '2019-06-03 19:03:31');
INSERT INTO `access_log` VALUES (25485, '64.77.15595598120176211', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.136.38.22', '2019-06-03 19:03:32', 11, 0, '', '2019-06-03 19:03:32');
INSERT INTO `access_log` VALUES (25486, '64.85.15595598120256221', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.136.38.22', '2019-06-03 19:03:32', 15, 0, '', '2019-06-03 19:03:32');
INSERT INTO `access_log` VALUES (25487, '65.47.15595613918736485', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '112.232.209.101', '2019-06-03 19:29:52', 0, 1002001015, '账号未登陆', '2019-06-03 19:29:52');
INSERT INTO `access_log` VALUES (25488, '65.46.15595613918746485', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '112.232.209.101', '2019-06-03 19:29:52', 1, 1002001015, '账号未登陆', '2019-06-03 19:29:52');
INSERT INTO `access_log` VALUES (25489, '65.48.15595613918746491', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '112.232.209.101', '2019-06-03 19:29:52', 1, 1002001015, '账号未登陆', '2019-06-03 19:29:52');
INSERT INTO `access_log` VALUES (25490, '65.49.15595613948646505', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '112.232.209.101', '2019-06-03 19:29:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 19:29:55');
INSERT INTO `access_log` VALUES (25491, '65.52.15595614107766479', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '112.232.209.101', '2019-06-03 19:30:11', 67, 0, '', '2019-06-03 19:30:11');
INSERT INTO `access_log` VALUES (25492, '65.51.15595614112896487', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '112.232.209.101', '2019-06-03 19:30:11', 10, 0, '', '2019-06-03 19:30:11');
INSERT INTO `access_log` VALUES (25493, '65.45.15595614112896509', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '112.232.209.101', '2019-06-03 19:30:11', 11, 0, '', '2019-06-03 19:30:11');
INSERT INTO `access_log` VALUES (25494, '65.50.15595614112956497', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '112.232.209.101', '2019-06-03 19:30:11', 9, 0, '', '2019-06-03 19:30:11');
INSERT INTO `access_log` VALUES (25495, '62.82.15595614175696435', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '112.232.209.101', '2019-06-03 19:30:18', 386, 0, '', '2019-06-03 19:30:18');
INSERT INTO `access_log` VALUES (25496, '65.46.15595614275786487', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '112.232.209.101', '2019-06-03 19:30:28', 20, 0, '', '2019-06-03 19:30:28');
INSERT INTO `access_log` VALUES (25497, '65.47.15595614286206487', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '112.232.209.101', '2019-06-03 19:30:29', 8, 0, '', '2019-06-03 19:30:29');
INSERT INTO `access_log` VALUES (25498, '59.76.15595628633096585', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:54:23', 11, 0, '', '2019-06-03 19:54:23');
INSERT INTO `access_log` VALUES (25499, '59.73.15595628633096595', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:54:23', 13, 2001001000, '服务端发生异常', '2019-06-03 19:54:23');
INSERT INTO `access_log` VALUES (25500, '64.84.15595628696986249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:54:30', 10, 0, '', '2019-06-03 19:54:30');
INSERT INTO `access_log` VALUES (25501, '64.82.15595628698326255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:54:30', 2, 0, '', '2019-06-03 19:54:30');
INSERT INTO `access_log` VALUES (25502, '64.83.15595628712236241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:54:31', 2, 0, '', '2019-06-03 19:54:31');
INSERT INTO `access_log` VALUES (25503, '64.78.15595628717416249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:54:32', 2, 0, '', '2019-06-03 19:54:32');
INSERT INTO `access_log` VALUES (25504, '64.77.15595628722196253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:54:32', 2, 0, '', '2019-06-03 19:54:32');
INSERT INTO `access_log` VALUES (25505, '59.72.15595628735386587', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:54:34', 4, 0, '', '2019-06-03 19:54:34');
INSERT INTO `access_log` VALUES (25506, '59.75.15595628735386591', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:54:34', 14, 2001001000, '服务端发生异常', '2019-06-03 19:54:34');
INSERT INTO `access_log` VALUES (25507, '64.80.15595628758366241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:54:36', 2, 0, '', '2019-06-03 19:54:36');
INSERT INTO `access_log` VALUES (25508, '64.76.15595628759626239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:54:36', 2, 0, '', '2019-06-03 19:54:36');
INSERT INTO `access_log` VALUES (25509, '65.49.15595629252246527', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:55:25', 0, 1002001015, '账号未登陆', '2019-06-03 19:55:25');
INSERT INTO `access_log` VALUES (25510, '65.54.15595629252246477', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:55:25', 0, 1002001015, '账号未登陆', '2019-06-03 19:55:25');
INSERT INTO `access_log` VALUES (25511, '65.53.15595629252286485', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:55:25', 1, 1002001015, '账号未登陆', '2019-06-03 19:55:25');
INSERT INTO `access_log` VALUES (25512, '59.78.15595629271786595', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:27', 3, 0, '', '2019-06-03 19:55:27');
INSERT INTO `access_log` VALUES (25513, '59.77.15595629271786583', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:27', 12, 2001001000, '服务端发生异常', '2019-06-03 19:55:27');
INSERT INTO `access_log` VALUES (25514, '65.52.15595629304786501', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:55:30', 70, 0, '', '2019-06-03 19:55:31');
INSERT INTO `access_log` VALUES (25515, '65.50.15595629308986519', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:55:31', 11, 0, '', '2019-06-03 19:55:31');
INSERT INTO `access_log` VALUES (25516, '65.51.15595629309036509', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:55:31', 10, 0, '', '2019-06-03 19:55:31');
INSERT INTO `access_log` VALUES (25517, '65.45.15595629309046531', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:55:31', 9, 0, '', '2019-06-03 19:55:31');
INSERT INTO `access_log` VALUES (25518, '64.82.15595629318076257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:32', 2, 0, '', '2019-06-03 19:55:32');
INSERT INTO `access_log` VALUES (25519, '64.83.15595629320216243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:32', 2, 0, '', '2019-06-03 19:55:32');
INSERT INTO `access_log` VALUES (25520, '64.78.15595629334986251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:33', 2, 0, '', '2019-06-03 19:55:34');
INSERT INTO `access_log` VALUES (25521, '64.77.15595629341226255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:34', 2, 0, '', '2019-06-03 19:55:34');
INSERT INTO `access_log` VALUES (25522, '59.72.15595629353186589', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:35', 3, 0, '', '2019-06-03 19:55:35');
INSERT INTO `access_log` VALUES (25523, '59.76.15595629353186587', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:35', 20, 2001001000, '服务端发生异常', '2019-06-03 19:55:35');
INSERT INTO `access_log` VALUES (25524, '62.87.15595629365936449', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:55:37', 14, 0, '', '2019-06-03 19:55:37');
INSERT INTO `access_log` VALUES (25525, '64.80.15595629396886243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:40', 2, 0, '', '2019-06-03 19:55:40');
INSERT INTO `access_log` VALUES (25526, '64.76.15595629397886241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:40', 2, 0, '', '2019-06-03 19:55:40');
INSERT INTO `access_log` VALUES (25527, '64.81.15595629409866247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:41', 2, 0, '', '2019-06-03 19:55:41');
INSERT INTO `access_log` VALUES (25528, '64.79.15595629414826245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:41', 1, 0, '', '2019-06-03 19:55:41');
INSERT INTO `access_log` VALUES (25529, '59.75.15595629428396593', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:43', 3, 0, '', '2019-06-03 19:55:43');
INSERT INTO `access_log` VALUES (25530, '59.79.15595629428406593', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:43', 13, 2001001000, '服务端发生异常', '2019-06-03 19:55:43');
INSERT INTO `access_log` VALUES (25531, '62.81.15595629443186431', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:55:44', 12, 0, '', '2019-06-03 19:55:44');
INSERT INTO `access_log` VALUES (25532, '62.84.15595629452906435', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:55:45', 12, 0, '', '2019-06-03 19:55:45');
INSERT INTO `access_log` VALUES (25533, '64.84.15595629462506253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:46', 3, 0, '', '2019-06-03 19:55:46');
INSERT INTO `access_log` VALUES (25534, '64.82.15595629463526259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:46', 2, 0, '', '2019-06-03 19:55:46');
INSERT INTO `access_log` VALUES (25535, '64.78.15595629510236253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:51', 2, 0, '', '2019-06-03 19:55:51');
INSERT INTO `access_log` VALUES (25536, '64.77.15595629511246257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:51', 2, 0, '', '2019-06-03 19:55:51');
INSERT INTO `access_log` VALUES (25537, '59.80.15595629512496585', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:51', 2, 0, '', '2019-06-03 19:55:51');
INSERT INTO `access_log` VALUES (25538, '59.74.15595629512506589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '222.72.44.130', '2019-06-03 19:55:51', 12, 2001001000, '服务端发生异常', '2019-06-03 19:55:51');
INSERT INTO `access_log` VALUES (25539, '64.80.15595629542966245', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:55:54', 6, 0, '', '2019-06-03 19:55:54');
INSERT INTO `access_log` VALUES (25540, '64.85.15595629542936267', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:55:54', 9, 0, '', '2019-06-03 19:55:54');
INSERT INTO `access_log` VALUES (25541, '64.76.15595629588786243', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:55:59', 12, 0, '', '2019-06-03 19:55:59');
INSERT INTO `access_log` VALUES (25542, '64.81.15595629590326249', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:55:59', 12, 0, '', '2019-06-03 19:55:59');
INSERT INTO `access_log` VALUES (25543, '64.82.15595629810296261', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:56:21', 9, 0, '', '2019-06-03 19:56:21');
INSERT INTO `access_log` VALUES (25544, '64.78.15595630010756255', 27, 2, 'product-application', '/product-api/admins/category/add', 'name=jbl&pid=0&sort=1&description=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:56:41', 8, 1002002009, NULL, '2019-06-03 19:56:41');
INSERT INTO `access_log` VALUES (25545, '65.52.15595630171206503', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:56:57', 9, 0, '', '2019-06-03 19:56:57');
INSERT INTO `access_log` VALUES (25546, '65.50.15595630171276521', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:56:57', 8, 0, '', '2019-06-03 19:56:57');
INSERT INTO `access_log` VALUES (25547, '65.51.15595630171286511', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:56:57', 8, 0, '', '2019-06-03 19:56:57');
INSERT INTO `access_log` VALUES (25548, '65.45.15595630196386533', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:57:00', 19, 0, '', '2019-06-03 19:57:00');
INSERT INTO `access_log` VALUES (25549, '65.48.15595630243846517', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:57:04', 9, 0, '', '2019-06-03 19:57:04');
INSERT INTO `access_log` VALUES (25550, '65.46.15595630258676511', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:57:06', 10, 0, '', '2019-06-03 19:57:06');
INSERT INTO `access_log` VALUES (25551, '65.49.15595630423386531', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:57:22', 14, 0, '', '2019-06-03 19:57:22');
INSERT INTO `access_log` VALUES (25552, '65.48.15595631212826519', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:58:41', 10, 0, '', '2019-06-03 19:58:41');
INSERT INTO `access_log` VALUES (25553, '65.46.15595631212916513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:58:41', 9, 0, '', '2019-06-03 19:58:41');
INSERT INTO `access_log` VALUES (25554, '65.47.15595631212926513', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:58:41', 9, 0, '', '2019-06-03 19:58:41');
INSERT INTO `access_log` VALUES (25555, '65.49.15595631271816533', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:58:47', 10, 0, '', '2019-06-03 19:58:47');
INSERT INTO `access_log` VALUES (25556, '65.54.15595631271976483', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:58:47', 8, 0, '', '2019-06-03 19:58:47');
INSERT INTO `access_log` VALUES (25557, '65.53.15595631272016491', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:58:47', 9, 0, '', '2019-06-03 19:58:47');
INSERT INTO `access_log` VALUES (25558, '65.52.15595631299396507', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:58:50', 10, 0, '', '2019-06-03 19:58:50');
INSERT INTO `access_log` VALUES (25559, '65.50.15595631299456525', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:58:50', 9, 0, '', '2019-06-03 19:58:50');
INSERT INTO `access_log` VALUES (25560, '65.51.15595631299556515', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-03 19:58:50', 8, 0, '', '2019-06-03 19:58:50');
INSERT INTO `access_log` VALUES (25561, '59.78.15595638399966609', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:10:40', 13, 2001001000, '服务端发生异常', '2019-06-03 20:10:40');
INSERT INTO `access_log` VALUES (25562, '59.74.15595638399966601', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:10:40', 201, 0, '', '2019-06-03 20:10:40');
INSERT INTO `access_log` VALUES (25563, '64.84.15595638431926267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:10:43', 2, 0, '', '2019-06-03 20:10:43');
INSERT INTO `access_log` VALUES (25564, '64.82.15595638435746273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:10:44', 24, 0, '', '2019-06-03 20:10:44');
INSERT INTO `access_log` VALUES (25565, '64.83.15595638452486259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:10:45', 2, 0, '', '2019-06-03 20:10:45');
INSERT INTO `access_log` VALUES (25566, '59.72.15595638595726603', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:11:00', 13, 2001001000, '服务端发生异常', '2019-06-03 20:11:00');
INSERT INTO `access_log` VALUES (25567, '59.73.15595638595726611', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:11:00', 383, 0, '', '2019-06-03 20:11:00');
INSERT INTO `access_log` VALUES (25568, '64.77.15595638625016271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:11:03', 2, 0, '', '2019-06-03 20:11:03');
INSERT INTO `access_log` VALUES (25569, '64.80.15595638627436259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:11:03', 2, 0, '', '2019-06-03 20:11:03');
INSERT INTO `access_log` VALUES (25570, '65.45.15595638671286547', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:11:07', 0, 1002001015, '账号未登陆', '2019-06-03 20:11:07');
INSERT INTO `access_log` VALUES (25571, '65.50.15595638671286535', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:11:07', 0, 1002001015, '账号未登陆', '2019-06-03 20:11:07');
INSERT INTO `access_log` VALUES (25572, '65.48.15595638671286531', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:11:07', 1, 1002001015, '账号未登陆', '2019-06-03 20:11:07');
INSERT INTO `access_log` VALUES (25573, '65.54.15595639088696495', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:11:49', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 20:11:49');
INSERT INTO `access_log` VALUES (25574, '65.52.15595639236506519', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:04', 100, 0, '', '2019-06-03 20:12:04');
INSERT INTO `access_log` VALUES (25575, '65.51.15595639240736527', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:04', 199, 0, '', '2019-06-03 20:12:04');
INSERT INTO `access_log` VALUES (25576, '65.50.15595639241076537', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:04', 168, 0, '', '2019-06-03 20:12:04');
INSERT INTO `access_log` VALUES (25577, '65.45.15595639240746549', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:04', 201, 0, '', '2019-06-03 20:12:04');
INSERT INTO `access_log` VALUES (25578, '62.81.15595639336946445', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:14', 15, 0, '', '2019-06-03 20:12:14');
INSERT INTO `access_log` VALUES (25579, '62.84.15595639399336449', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:20', 15, 0, '', '2019-06-03 20:12:20');
INSERT INTO `access_log` VALUES (25580, '64.78.15595639429866269', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:23', 33, 0, '', '2019-06-03 20:12:23');
INSERT INTO `access_log` VALUES (25581, '64.83.15595639429816261', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:23', 38, 0, '', '2019-06-03 20:12:23');
INSERT INTO `access_log` VALUES (25582, '64.80.15595639468046261', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:27', 9, 0, '', '2019-06-03 20:12:27');
INSERT INTO `access_log` VALUES (25583, '64.77.15595639468046273', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:27', 11, 0, '', '2019-06-03 20:12:27');
INSERT INTO `access_log` VALUES (25584, '66.52.15595639552895275', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:35', 19, 0, '', '2019-06-03 20:12:35');
INSERT INTO `access_log` VALUES (25585, '65.53.15595639652136505', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:45', 20, 0, '', '2019-06-03 20:12:45');
INSERT INTO `access_log` VALUES (25586, '65.54.15595639690846497', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:49', 8, 0, '', '2019-06-03 20:12:49');
INSERT INTO `access_log` VALUES (25587, '65.49.15595639710286547', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:51', 8, 0, '', '2019-06-03 20:12:51');
INSERT INTO `access_log` VALUES (25588, '65.51.15595639762166529', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:56', 12, 0, '', '2019-06-03 20:12:56');
INSERT INTO `access_log` VALUES (25589, '59.72.15595639793196605', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:12:59', 11, 0, '', '2019-06-03 20:12:59');
INSERT INTO `access_log` VALUES (25590, '59.76.15595639862496603', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:06', 25, 2001001000, '服务端发生异常', '2019-06-03 20:13:06');
INSERT INTO `access_log` VALUES (25591, '59.75.15595639898636609', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:10', 19, 0, '', '2019-06-03 20:13:10');
INSERT INTO `access_log` VALUES (25592, '65.50.15595639960046539', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:16', 9, 0, '', '2019-06-03 20:13:16');
INSERT INTO `access_log` VALUES (25593, '65.48.15595639960066535', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:16', 9, 0, '', '2019-06-03 20:13:16');
INSERT INTO `access_log` VALUES (25594, '65.47.15595639960566529', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:16', 9, 0, '', '2019-06-03 20:13:16');
INSERT INTO `access_log` VALUES (25595, '59.79.15595639961246609', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:16', 11, 0, '', '2019-06-03 20:13:16');
INSERT INTO `access_log` VALUES (25596, '65.46.15595639997466529', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:20', 613, 0, '', '2019-06-03 20:13:20');
INSERT INTO `access_log` VALUES (25597, '65.53.15595639997476507', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:20', 613, 0, '', '2019-06-03 20:13:20');
INSERT INTO `access_log` VALUES (25598, '59.80.15595639998346601', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:20', 527, 0, '', '2019-06-03 20:13:20');
INSERT INTO `access_log` VALUES (25599, '65.54.15595639997506499', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:20', 746, 0, '', '2019-06-03 20:13:20');
INSERT INTO `access_log` VALUES (25600, '65.52.15595640039286523', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:24', 8, 0, '', '2019-06-03 20:13:24');
INSERT INTO `access_log` VALUES (25601, '65.51.15595640039316531', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:24', 9, 0, '', '2019-06-03 20:13:24');
INSERT INTO `access_log` VALUES (25602, '65.49.15595640039276549', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:24', 9, 0, '', '2019-06-03 20:13:24');
INSERT INTO `access_log` VALUES (25603, '59.74.15595640040226605', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:24', 10, 0, '', '2019-06-03 20:13:24');
INSERT INTO `access_log` VALUES (25604, '62.87.15595640282016465', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:48', 12, 0, '', '2019-06-03 20:13:48');
INSERT INTO `access_log` VALUES (25605, '62.84.15595640356886451', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=9999', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:13:56', 12, 0, '', '2019-06-03 20:13:56');
INSERT INTO `access_log` VALUES (25606, '64.78.15595640404626271', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:14:00', 9, 0, '', '2019-06-03 20:14:00');
INSERT INTO `access_log` VALUES (25607, '64.83.15595640404596263', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.147.98.86', '2019-06-03 20:14:00', 12, 0, '', '2019-06-03 20:14:00');
INSERT INTO `access_log` VALUES (25608, '65.48.15595644689056543', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:09', 72, 0, '', '2019-06-03 20:21:09');
INSERT INTO `access_log` VALUES (25609, '65.47.15595644692636537', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:09', 9, 0, '', '2019-06-03 20:21:09');
INSERT INTO `access_log` VALUES (25610, '65.46.15595644692636537', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:09', 9, 0, '', '2019-06-03 20:21:09');
INSERT INTO `access_log` VALUES (25611, '65.53.15595644692676515', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:09', 9, 0, '', '2019-06-03 20:21:09');
INSERT INTO `access_log` VALUES (25612, '62.84.15595644711576457', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:11', 12, 0, '', '2019-06-03 20:21:11');
INSERT INTO `access_log` VALUES (25613, '59.77.15595644747516607', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:15', 12, 0, '', '2019-06-03 20:21:15');
INSERT INTO `access_log` VALUES (25614, '59.73.15595644800676621', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:20', 17, 2001001000, '服务端发生异常', '2019-06-03 20:21:20');
INSERT INTO `access_log` VALUES (25615, '59.76.15595644828356611', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:23', 1259, 0, '', '2019-06-03 20:21:24');
INSERT INTO `access_log` VALUES (25616, '59.75.15595644846346617', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:25', 12, 0, '', '2019-06-03 20:21:25');
INSERT INTO `access_log` VALUES (25617, '59.79.15595644882806617', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:28', 76, 0, '', '2019-06-03 20:21:28');
INSERT INTO `access_log` VALUES (25618, '59.71.15595644888226621', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:29', 11, 0, '', '2019-06-03 20:21:29');
INSERT INTO `access_log` VALUES (25619, '59.80.15595644894116609', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:29', 11, 0, '', '2019-06-03 20:21:29');
INSERT INTO `access_log` VALUES (25620, '59.74.15595644902466613', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=INVALID&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:30', 11, 0, '', '2019-06-03 20:21:30');
INSERT INTO `access_log` VALUES (25621, '59.78.15595644917126621', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:32', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 20:21:32');
INSERT INTO `access_log` VALUES (25622, '59.72.15595644951986615', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:35', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 20:21:35');
INSERT INTO `access_log` VALUES (25623, '65.45.15595644971966561', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:37', 20, 0, '', '2019-06-03 20:21:37');
INSERT INTO `access_log` VALUES (25624, '65.51.15595644981116539', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:38', 9, 0, '', '2019-06-03 20:21:38');
INSERT INTO `access_log` VALUES (25625, '65.49.15595645009816557', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:41', 11, 0, '', '2019-06-03 20:21:41');
INSERT INTO `access_log` VALUES (25626, '65.50.15595645035186549', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:44', 57, 0, '', '2019-06-03 20:21:44');
INSERT INTO `access_log` VALUES (25627, '65.48.15595645064556545', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:46', 9, 0, '', '2019-06-03 20:21:46');
INSERT INTO `access_log` VALUES (25628, '64.76.15595645150256267', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:55', 10, 0, '', '2019-06-03 20:21:55');
INSERT INTO `access_log` VALUES (25629, '64.85.15595645150226291', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:21:55', 14, 0, '', '2019-06-03 20:21:55');
INSERT INTO `access_log` VALUES (25630, '64.79.15595645203276271', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:22:00', 9, 0, '', '2019-06-03 20:22:00');
INSERT INTO `access_log` VALUES (25631, '64.81.15595645203266273', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:22:00', 11, 0, '', '2019-06-03 20:22:00');
INSERT INTO `access_log` VALUES (25632, '64.82.15595645231656285', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:22:03', 8, 0, '', '2019-06-03 20:22:03');
INSERT INTO `access_log` VALUES (25633, '64.84.15595645231646279', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:22:03', 10, 0, '', '2019-06-03 20:22:03');
INSERT INTO `access_log` VALUES (25634, '62.85.15595646130886473', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:23:33', 14, 0, '', '2019-06-03 20:23:33');
INSERT INTO `access_log` VALUES (25635, '62.89.15595646224976469', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:23:42', 12, 0, '', '2019-06-03 20:23:43');
INSERT INTO `access_log` VALUES (25636, '59.79.15595646946496621', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:24:55', 3, 0, '', '2019-06-03 20:24:55');
INSERT INTO `access_log` VALUES (25637, '59.71.15595646946496625', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:24:55', 12, 2001001000, '服务端发生异常', '2019-06-03 20:24:55');
INSERT INTO `access_log` VALUES (25638, '64.77.15595647034976285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:25:03', 3, 0, '', '2019-06-03 20:25:04');
INSERT INTO `access_log` VALUES (25639, '64.80.15595647036026273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:25:04', 2, 0, '', '2019-06-03 20:25:04');
INSERT INTO `access_log` VALUES (25640, '64.85.15595647045236295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:25:05', 2, 0, '', '2019-06-03 20:25:05');
INSERT INTO `access_log` VALUES (25641, '64.76.15595647049936271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:25:05', 2, 0, '', '2019-06-03 20:25:05');
INSERT INTO `access_log` VALUES (25642, '64.79.15595647077876275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:25:08', 2, 0, '', '2019-06-03 20:25:08');
INSERT INTO `access_log` VALUES (25643, '64.82.15595647081286289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:25:08', 2, 0, '', '2019-06-03 20:25:08');
INSERT INTO `access_log` VALUES (25644, '59.74.15595647105926617', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:25:11', 3, 0, '', '2019-06-03 20:25:11');
INSERT INTO `access_log` VALUES (25645, '59.78.15595647105926625', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 20:25:11', 13, 2001001000, '服务端发生异常', '2019-06-03 20:25:11');
INSERT INTO `access_log` VALUES (25646, '18f86404-9f3e-416c-91d1-9b43fbfa9607', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 20:31:50', 189, 1002001012, '访问令牌已过期', '2019-06-03 20:31:50');
INSERT INTO `access_log` VALUES (25647, 'eb6cca0e-0d00-4e87-9361-9a576f3a0243', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 20:31:50', 198, 1002001012, '访问令牌已过期', '2019-06-03 20:31:50');
INSERT INTO `access_log` VALUES (25648, 'cf98d2fe-a3d5-4962-aefc-da0353c74a4f', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 20:31:50', 210, 1002001012, '访问令牌已过期', '2019-06-03 20:31:50');
INSERT INTO `access_log` VALUES (25649, 'e162cb62-aef5-4f1e-9233-06b09f63abf2', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 20:31:50', 57, 1002001012, '访问令牌已过期', '2019-06-03 20:31:50');
INSERT INTO `access_log` VALUES (25650, '59.71.15595666056936651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '183.3.155.73', '2019-06-03 20:56:46', 11, 0, '', '2019-06-03 20:56:46');
INSERT INTO `access_log` VALUES (25651, '59.80.15595666056936639', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '183.3.155.73', '2019-06-03 20:56:46', 16, 2001001000, '服务端发生异常', '2019-06-03 20:56:46');
INSERT INTO `access_log` VALUES (25652, '64.76.15595666087966297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '183.3.155.73', '2019-06-03 20:56:49', 12, 0, '', '2019-06-03 20:56:49');
INSERT INTO `access_log` VALUES (25653, '64.81.15595666089366303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '183.3.155.73', '2019-06-03 20:56:49', 3, 0, '', '2019-06-03 20:56:49');
INSERT INTO `access_log` VALUES (25654, '64.79.15595666101746301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '183.3.155.73', '2019-06-03 20:56:50', 2, 0, '', '2019-06-03 20:56:50');
INSERT INTO `access_log` VALUES (25655, '64.84.15595666107146309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '183.3.155.73', '2019-06-03 20:56:51', 2, 0, '', '2019-06-03 20:56:51');
INSERT INTO `access_log` VALUES (25656, '59.78.15595666137416651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '183.3.155.73', '2019-06-03 20:56:54', 4, 0, '', '2019-06-03 20:56:54');
INSERT INTO `access_log` VALUES (25657, '59.77.15595666137416639', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '183.3.155.73', '2019-06-03 20:56:54', 14, 2001001000, '服务端发生异常', '2019-06-03 20:56:54');
INSERT INTO `access_log` VALUES (25658, '64.80.15595666681886301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.91.60.11', '2019-06-03 20:57:48', 3, 0, '', '2019-06-03 20:57:48');
INSERT INTO `access_log` VALUES (25659, '62.88.15595668995226509', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 21:01:40', 28, 0, '', '2019-06-03 21:01:40');
INSERT INTO `access_log` VALUES (25660, '66.57.15595669068325317', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 21:01:47', 23, 0, '', '2019-06-03 21:01:47');
INSERT INTO `access_log` VALUES (25661, '66.52.15595669134645315', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 21:01:53', 13, 0, '', '2019-06-03 21:01:53');
INSERT INTO `access_log` VALUES (25662, '59.72.15595669151006649', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 21:01:55', 12, 0, '', '2019-06-03 21:01:55');
INSERT INTO `access_log` VALUES (25663, '59.73.15595669170536657', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 21:01:57', 16, 2001001000, '服务端发生异常', '2019-06-03 21:01:57');
INSERT INTO `access_log` VALUES (25664, '59.76.15595669188116647', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 21:01:59', 9, 0, '', '2019-06-03 21:01:59');
INSERT INTO `access_log` VALUES (25665, '59.75.15595669209636653', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 21:02:01', 21, 2001001000, '服务端发生异常', '2019-06-03 21:02:01');
INSERT INTO `access_log` VALUES (25666, '59.71.15595669265346657', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 21:02:07', 11, 0, '', '2019-06-03 21:02:07');
INSERT INTO `access_log` VALUES (25667, '64.77.15595669292316317', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 21:02:09', 11, 0, '', '2019-06-03 21:02:09');
INSERT INTO `access_log` VALUES (25668, '64.85.15595669410546327', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-03 21:02:21', 9, 0, '', '2019-06-03 21:02:21');
INSERT INTO `access_log` VALUES (25669, '65.51.15595672875706577', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:08', 0, 1002001015, '账号未登陆', '2019-06-03 21:08:08');
INSERT INTO `access_log` VALUES (25670, '65.52.15595672875706569', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:08', 0, 1002001015, '账号未登陆', '2019-06-03 21:08:08');
INSERT INTO `access_log` VALUES (25671, '65.49.15595672875746595', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:08', 1, 1002001015, '账号未登陆', '2019-06-03 21:08:08');
INSERT INTO `access_log` VALUES (25672, '65.48.15595672917406583', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:12', 65, 0, '', '2019-06-03 21:08:12');
INSERT INTO `access_log` VALUES (25673, '65.46.15595672920216577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:12', 12, 0, '', '2019-06-03 21:08:12');
INSERT INTO `access_log` VALUES (25674, '65.47.15595672920206577', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:12', 12, 0, '', '2019-06-03 21:08:12');
INSERT INTO `access_log` VALUES (25675, '65.53.15595672920206555', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:12', 13, 0, '', '2019-06-03 21:08:12');
INSERT INTO `access_log` VALUES (25676, '65.54.15595673010666547', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:21', 39, 0, '', '2019-06-03 21:08:21');
INSERT INTO `access_log` VALUES (25677, '65.45.15595673010666601', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:21', 39, 0, '', '2019-06-03 21:08:21');
INSERT INTO `access_log` VALUES (25678, '65.49.15595673010676597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:21', 37, 0, '', '2019-06-03 21:08:21');
INSERT INTO `access_log` VALUES (25679, '62.80.15595673059176509', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:26', 15, 0, '', '2019-06-03 21:08:26');
INSERT INTO `access_log` VALUES (25680, '62.87.15595673135056511', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:34', 12, 0, '', '2019-06-03 21:08:34');
INSERT INTO `access_log` VALUES (25681, '59.76.15595673202206653', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:08:40', 4, 0, '', '2019-06-03 21:08:40');
INSERT INTO `access_log` VALUES (25682, '59.75.15595673202216659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:08:40', 13, 2001001000, '服务端发生异常', '2019-06-03 21:08:40');
INSERT INTO `access_log` VALUES (25683, '64.83.15595673211006311', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:41', 38, 0, '', '2019-06-03 21:08:41');
INSERT INTO `access_log` VALUES (25684, '64.78.15595673211006319', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:41', 39, 0, '', '2019-06-03 21:08:41');
INSERT INTO `access_log` VALUES (25685, '64.80.15595673242096311', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:44', 8, 0, '', '2019-06-03 21:08:44');
INSERT INTO `access_log` VALUES (25686, '64.77.15595673242096323', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:44', 12, 0, '', '2019-06-03 21:08:44');
INSERT INTO `access_log` VALUES (25687, '64.76.15595673317166309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:08:52', 2, 0, '', '2019-06-03 21:08:52');
INSERT INTO `access_log` VALUES (25688, '64.81.15595673318066315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:08:52', 2, 0, '', '2019-06-03 21:08:52');
INSERT INTO `access_log` VALUES (25689, '64.79.15595673330466313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:08:53', 2, 0, '', '2019-06-03 21:08:53');
INSERT INTO `access_log` VALUES (25690, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:08:53', 15, 0, '', '2019-06-03 21:08:53');
INSERT INTO `access_log` VALUES (25691, '64.78.15595673334176321', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:53', 8, 0, '', '2019-06-03 21:08:53');
INSERT INTO `access_log` VALUES (25692, '64.84.15595673334176321', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:53', 10, 0, '', '2019-06-03 21:08:53');
INSERT INTO `access_log` VALUES (25693, '64.82.15595673334146327', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:08:53', 15, 0, '', '2019-06-03 21:08:53');
INSERT INTO `access_log` VALUES (25694, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:08:55', 6, 0, '', '2019-06-03 21:08:55');
INSERT INTO `access_log` VALUES (25695, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:08:56', 8, 0, '', '2019-06-03 21:08:56');
INSERT INTO `access_log` VALUES (25696, '64.83.15595673375066313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:08:58', 4, 0, '', '2019-06-03 21:08:58');
INSERT INTO `access_log` VALUES (25697, '64.77.15595673376096325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:08:58', 3, 0, '', '2019-06-03 21:08:58');
INSERT INTO `access_log` VALUES (25698, '64.80.15595673389236313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:08:59', 2, 0, '', '2019-06-03 21:08:59');
INSERT INTO `access_log` VALUES (25699, '64.85.15595673395406335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:09:00', 2, 0, '', '2019-06-03 21:09:00');
INSERT INTO `access_log` VALUES (25700, '64.76.15595673406806311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:09:01', 2, 0, '', '2019-06-03 21:09:01');
INSERT INTO `access_log` VALUES (25701, '64.81.15595673416916317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:09:02', 2, 0, '', '2019-06-03 21:09:02');
INSERT INTO `access_log` VALUES (25702, '64.79.15595673424786315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:09:02', 39, 0, '', '2019-06-03 21:09:03');
INSERT INTO `access_log` VALUES (25703, '59.80.15595673478456651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:09:08', 2, 0, '', '2019-06-03 21:09:08');
INSERT INTO `access_log` VALUES (25704, '59.74.15595673478466655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:09:08', 19, 2001001000, '服务端发生异常', '2019-06-03 21:09:08');
INSERT INTO `access_log` VALUES (25705, '64.84.15595673485136323', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:09:09', 10, 0, '', '2019-06-03 21:09:09');
INSERT INTO `access_log` VALUES (25706, '64.78.15595673485146323', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:09:09', 11, 0, '', '2019-06-03 21:09:09');
INSERT INTO `access_log` VALUES (25707, '64.83.15595673524766315', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:09:12', 9, 0, '', '2019-06-03 21:09:12');
INSERT INTO `access_log` VALUES (25708, '64.77.15595673533576327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:09:13', 2, 0, '', '2019-06-03 21:09:13');
INSERT INTO `access_log` VALUES (25709, '64.80.15595673534636315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:09:13', 2, 0, '', '2019-06-03 21:09:13');
INSERT INTO `access_log` VALUES (25710, '59.78.15595673555526663', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:09:16', 2, 0, '', '2019-06-03 21:09:16');
INSERT INTO `access_log` VALUES (25711, '59.77.15595673555556651', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:09:16', 15, 2001001000, '服务端发生异常', '2019-06-03 21:09:16');
INSERT INTO `access_log` VALUES (25712, '64.85.15595673574036337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:09:17', 2, 0, '', '2019-06-03 21:09:17');
INSERT INTO `access_log` VALUES (25713, '64.76.15595673575046313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:09:18', 1, 0, '', '2019-06-03 21:09:18');
INSERT INTO `access_log` VALUES (25714, '59.73.15595673596606665', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:09:20', 3, 0, '', '2019-06-03 21:09:20');
INSERT INTO `access_log` VALUES (25715, '59.76.15595673596606655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.22.210', '2019-06-03 21:09:20', 13, 2001001000, '服务端发生异常', '2019-06-03 21:09:20');
INSERT INTO `access_log` VALUES (25716, '66.53.15595673721875321', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:09:32', 17, 0, '', '2019-06-03 21:09:32');
INSERT INTO `access_log` VALUES (25717, '59.79.15595673790506661', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:09:39', 9, 0, '', '2019-06-03 21:09:39');
INSERT INTO `access_log` VALUES (25718, '59.71.15595673843906665', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:09:44', 351, 2001001000, '服务端发生异常', '2019-06-03 21:09:45');
INSERT INTO `access_log` VALUES (25719, '59.80.15595673895926653', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:09:50', 11, 0, '', '2019-06-03 21:09:50');
INSERT INTO `access_log` VALUES (25720, '64.78.15595673917306325', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:09:52', 8, 0, '', '2019-06-03 21:09:52');
INSERT INTO `access_log` VALUES (25721, '64.84.15595673934656325', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:09:53', 9, 0, '', '2019-06-03 21:09:53');
INSERT INTO `access_log` VALUES (25722, '64.83.15595673967546317', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:09:57', 9, 0, '', '2019-06-03 21:09:57');
INSERT INTO `access_log` VALUES (25723, '64.77.15595674042526329', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:04', 9, 0, '', '2019-06-03 21:10:04');
INSERT INTO `access_log` VALUES (25724, '59.77.15595674071376653', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:07', 10, 0, '', '2019-06-03 21:10:07');
INSERT INTO `access_log` VALUES (25725, '65.45.15595674168656603', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:17', 18, 0, '', '2019-06-03 21:10:17');
INSERT INTO `access_log` VALUES (25726, '65.49.15595674176866599', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:18', 0, 1002001015, '账号未登陆', '2019-06-03 21:10:18');
INSERT INTO `access_log` VALUES (25727, '65.51.15595674176956581', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:18', 0, 1002001015, '账号未登陆', '2019-06-03 21:10:18');
INSERT INTO `access_log` VALUES (25728, '65.52.15595674177126573', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:18', 1, 1002001015, '账号未登陆', '2019-06-03 21:10:18');
INSERT INTO `access_log` VALUES (25729, '65.50.15595674208266591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 21:10:21');
INSERT INTO `access_log` VALUES (25730, '65.48.15595674233496587', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:23', 13, 0, '', '2019-06-03 21:10:23');
INSERT INTO `access_log` VALUES (25731, '65.46.15595674241466581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:24', 85, 0, '', '2019-06-03 21:10:24');
INSERT INTO `access_log` VALUES (25732, '65.53.15595674244536559', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:24', 9, 0, '', '2019-06-03 21:10:24');
INSERT INTO `access_log` VALUES (25733, '65.54.15595674244566551', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:24', 9, 0, '', '2019-06-03 21:10:24');
INSERT INTO `access_log` VALUES (25734, '65.45.15595674244626605', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:24', 8, 0, '', '2019-06-03 21:10:24');
INSERT INTO `access_log` VALUES (25735, '65.49.15595674251986601', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:25', 10, 0, '', '2019-06-03 21:10:25');
INSERT INTO `access_log` VALUES (25736, '65.51.15595674270986583', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:27', 11, 0, '', '2019-06-03 21:10:27');
INSERT INTO `access_log` VALUES (25737, '62.81.15595674297336495', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:30', 15, 0, '', '2019-06-03 21:10:30');
INSERT INTO `access_log` VALUES (25738, '65.52.15595674310036575', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:31', 493, 0, '', '2019-06-03 21:10:31');
INSERT INTO `access_log` VALUES (25739, '65.50.15595674356756593', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:36', 14, 0, '', '2019-06-03 21:10:36');
INSERT INTO `access_log` VALUES (25740, '64.81.15595674415296321', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:42', 16, 0, '', '2019-06-03 21:10:42');
INSERT INTO `access_log` VALUES (25741, '64.79.15595674415326319', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:42', 13, 0, '', '2019-06-03 21:10:42');
INSERT INTO `access_log` VALUES (25742, '65.47.15595674458296583', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:46', 8, 0, '', '2019-06-03 21:10:46');
INSERT INTO `access_log` VALUES (25743, '65.46.15595674462746583', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:46', 116, 0, '', '2019-06-03 21:10:46');
INSERT INTO `access_log` VALUES (25744, '65.45.15595674464846607', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:46', 18, 0, '', '2019-06-03 21:10:47');
INSERT INTO `access_log` VALUES (25745, '64.82.15595674466236333', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:47', 13, 0, '', '2019-06-03 21:10:47');
INSERT INTO `access_log` VALUES (25746, '64.78.15595674466276327', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:47', 9, 0, '', '2019-06-03 21:10:47');
INSERT INTO `access_log` VALUES (25747, '59.76.15595674466856657', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:47', 11, 0, '', '2019-06-03 21:10:47');
INSERT INTO `access_log` VALUES (25748, '59.75.15595674468926663', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:47', 11, 0, '', '2019-06-03 21:10:47');
INSERT INTO `access_log` VALUES (25749, '59.79.15595674473886663', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:47', 21, 2001001000, '服务端发生异常', '2019-06-03 21:10:47');
INSERT INTO `access_log` VALUES (25750, '59.71.15595674477786667', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:48', 10, 0, '', '2019-06-03 21:10:48');
INSERT INTO `access_log` VALUES (25751, '66.49.15595674480315323', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:10:48', 193, 0, '', '2019-06-03 21:10:48');
INSERT INTO `access_log` VALUES (25752, '64.77.15595674505216331', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:51', 11, 0, '', '2019-06-03 21:10:51');
INSERT INTO `access_log` VALUES (25753, '64.80.15595674505246319', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:51', 9, 0, '', '2019-06-03 21:10:51');
INSERT INTO `access_log` VALUES (25754, '64.83.15595674505196319', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:51', 14, 0, '', '2019-06-03 21:10:51');
INSERT INTO `access_log` VALUES (25755, '66.48.15595674584205329', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:10:58', 13, 0, '', '2019-06-03 21:10:58');
INSERT INTO `access_log` VALUES (25756, '59.80.15595674627906655', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:11:03', 33, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 21:11:03');
INSERT INTO `access_log` VALUES (25757, '59.77.15595674690776655', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.175.22.210', '2019-06-03 21:11:09', 8, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 21:11:09');
INSERT INTO `access_log` VALUES (25758, '65.49.15595674786736603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:11:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 21:11:19');
INSERT INTO `access_log` VALUES (25759, '59.80.15595677243776659', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:15:24', 3, 0, '', '2019-06-03 21:15:24');
INSERT INTO `access_log` VALUES (25760, '59.78.15595677243786671', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:15:24', 20, 2001001000, '服务端发生异常', '2019-06-03 21:15:24');
INSERT INTO `access_log` VALUES (25761, '64.80.15595677273996323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:15:27', 2, 0, '', '2019-06-03 21:15:27');
INSERT INTO `access_log` VALUES (25762, '64.77.15595677275446335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:15:28', 2, 0, '', '2019-06-03 21:15:28');
INSERT INTO `access_log` VALUES (25763, '64.85.15595677286546345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:15:29', 1, 0, '', '2019-06-03 21:15:29');
INSERT INTO `access_log` VALUES (25764, '64.76.15595677293036321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.70.179.148', '2019-06-03 21:15:29', 2, 0, '', '2019-06-03 21:15:29');
INSERT INTO `access_log` VALUES (25765, '59.80.15595690426036677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.169.186', '2019-06-03 21:37:23', 3, 0, '', '2019-06-03 21:37:23');
INSERT INTO `access_log` VALUES (25766, '59.78.15595690426036689', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.169.186', '2019-06-03 21:37:23', 13, 2001001000, '服务端发生异常', '2019-06-03 21:37:23');
INSERT INTO `access_log` VALUES (25767, '64.85.15595690477066363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.169.186', '2019-06-03 21:37:28', 3, 0, '', '2019-06-03 21:37:28');
INSERT INTO `access_log` VALUES (25768, '64.76.15595690478186339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.169.186', '2019-06-03 21:37:28', 2, 0, '', '2019-06-03 21:37:28');
INSERT INTO `access_log` VALUES (25769, '64.79.15595690490396343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.169.186', '2019-06-03 21:37:29', 47, 0, '', '2019-06-03 21:37:29');
INSERT INTO `access_log` VALUES (25770, '64.81.15595690496386345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.169.186', '2019-06-03 21:37:30', 2, 0, '', '2019-06-03 21:37:30');
INSERT INTO `access_log` VALUES (25771, '64.82.15595690506096357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.169.186', '2019-06-03 21:37:31', 2, 0, '', '2019-06-03 21:37:31');
INSERT INTO `access_log` VALUES (25772, '59.77.15595690519996677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.169.186', '2019-06-03 21:37:32', 3, 0, '', '2019-06-03 21:37:32');
INSERT INTO `access_log` VALUES (25773, '59.72.15595690519996683', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.169.186', '2019-06-03 21:37:32', 13, 2001001000, '服务端发生异常', '2019-06-03 21:37:32');
INSERT INTO `access_log` VALUES (25774, '64.78.15595690539566351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.169.186', '2019-06-03 21:37:34', 2, 0, '', '2019-06-03 21:37:34');
INSERT INTO `access_log` VALUES (25775, '64.84.15595690540726351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.119.169.186', '2019-06-03 21:37:34', 2, 0, '', '2019-06-03 21:37:34');
INSERT INTO `access_log` VALUES (25776, '65.54.15595690912926575', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:38:11', 1, 1002001015, '账号未登陆', '2019-06-03 21:38:11');
INSERT INTO `access_log` VALUES (25777, '65.49.15595690912926625', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:38:11', 1, 1002001015, '账号未登陆', '2019-06-03 21:38:11');
INSERT INTO `access_log` VALUES (25778, '65.51.15595690912936607', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:38:11', 0, 1002001015, '账号未登陆', '2019-06-03 21:38:11');
INSERT INTO `access_log` VALUES (25779, '65.52.15595690930896599', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:38:13', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 21:38:13');
INSERT INTO `access_log` VALUES (25780, '65.48.15595691174706613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:38:37', 303, 0, '', '2019-06-03 21:38:38');
INSERT INTO `access_log` VALUES (25781, '65.45.15595691180316631', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:38:38', 54, 0, '', '2019-06-03 21:38:38');
INSERT INTO `access_log` VALUES (25782, '65.47.15595691180266607', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:38:38', 57, 0, '', '2019-06-03 21:38:38');
INSERT INTO `access_log` VALUES (25783, '65.46.15595691180296607', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:38:38', 56, 0, '', '2019-06-03 21:38:38');
INSERT INTO `access_log` VALUES (25784, '62.85.15595691269136539', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:38:47', 13, 0, '', '2019-06-03 21:38:47');
INSERT INTO `access_log` VALUES (25785, '59.80.15595691329416679', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:38:53', 117, 0, '', '2019-06-03 21:38:53');
INSERT INTO `access_log` VALUES (25786, '65.49.15595691416636627', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:39:02', 19, 0, '', '2019-06-03 21:39:02');
INSERT INTO `access_log` VALUES (25787, '65.51.15595691428156609', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:39:03', 9, 0, '', '2019-06-03 21:39:03');
INSERT INTO `access_log` VALUES (25788, '65.50.15595691518366619', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:39:12', 13, 0, '', '2019-06-03 21:39:12');
INSERT INTO `access_log` VALUES (25789, '59.72.15595691534426685', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:39:13', 10, 0, '', '2019-06-03 21:39:13');
INSERT INTO `access_log` VALUES (25790, '59.77.15595691553536679', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:39:15', 11, 0, '', '2019-06-03 21:39:15');
INSERT INTO `access_log` VALUES (25791, '64.78.15595691575806353', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:39:18', 11, 0, '', '2019-06-03 21:39:18');
INSERT INTO `access_log` VALUES (25792, '64.82.15595691575776359', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.118.86.158', '2019-06-03 21:39:18', 14, 0, '', '2019-06-03 21:39:18');
INSERT INTO `access_log` VALUES (25793, '65.51.15595693900596613', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:10', 0, 1002001015, '账号未登陆', '2019-06-03 21:43:10');
INSERT INTO `access_log` VALUES (25794, '65.49.15595693900596631', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:10', 0, 1002001015, '账号未登陆', '2019-06-03 21:43:10');
INSERT INTO `access_log` VALUES (25795, '65.52.15595693900636605', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:10', 0, 1002001015, '账号未登陆', '2019-06-03 21:43:10');
INSERT INTO `access_log` VALUES (25796, '65.50.15595693923516623', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 21:43:12');
INSERT INTO `access_log` VALUES (25797, '65.48.15595693949346619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:15', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 21:43:15');
INSERT INTO `access_log` VALUES (25798, '65.47.15595694112806613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:31', 70, 0, '', '2019-06-03 21:43:31');
INSERT INTO `access_log` VALUES (25799, '65.45.15595694115526637', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:32', 10, 0, '', '2019-06-03 21:43:32');
INSERT INTO `access_log` VALUES (25800, '65.53.15595694115526591', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:32', 11, 0, '', '2019-06-03 21:43:32');
INSERT INTO `access_log` VALUES (25801, '65.54.15595694115556583', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:32', 10, 0, '', '2019-06-03 21:43:32');
INSERT INTO `access_log` VALUES (25802, '62.86.15595694151466535', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:35', 11, 0, '', '2019-06-03 21:43:35');
INSERT INTO `access_log` VALUES (25803, '66.53.15595694188665349', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:39', 20, 0, '', '2019-06-03 21:43:39');
INSERT INTO `access_log` VALUES (25804, '59.72.15595694220326689', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:42', 37, 2001001000, '服务端发生异常', '2019-06-03 21:43:42');
INSERT INTO `access_log` VALUES (25805, '64.78.15595694253066357', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:45', 10, 0, '', '2019-06-03 21:43:45');
INSERT INTO `access_log` VALUES (25806, '64.82.15595694253056363', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:45', 12, 0, '', '2019-06-03 21:43:45');
INSERT INTO `access_log` VALUES (25807, '64.83.15595694281086349', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:48', 9, 0, '', '2019-06-03 21:43:48');
INSERT INTO `access_log` VALUES (25808, '64.84.15595694281086357', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:48', 13, 0, '', '2019-06-03 21:43:48');
INSERT INTO `access_log` VALUES (25809, '65.52.15595694302986607', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:50', 168, 0, '', '2019-06-03 21:43:50');
INSERT INTO `access_log` VALUES (25810, '65.51.15595694323476615', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:52', 14, 0, '', '2019-06-03 21:43:52');
INSERT INTO `access_log` VALUES (25811, '65.48.15595694353726621', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:55', 9, 0, '', '2019-06-03 21:43:55');
INSERT INTO `access_log` VALUES (25812, '65.46.15595694364456615', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:56', 12, 0, '', '2019-06-03 21:43:56');
INSERT INTO `access_log` VALUES (25813, '64.85.15595694388686371', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:59', 9, 0, '', '2019-06-03 21:43:59');
INSERT INTO `access_log` VALUES (25814, '64.77.15595694388676361', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:43:59', 11, 0, '', '2019-06-03 21:43:59');
INSERT INTO `access_log` VALUES (25815, '62.87.15595694411036547', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:01', 14, 0, '', '2019-06-03 21:44:01');
INSERT INTO `access_log` VALUES (25816, '65.47.15595694459246615', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:06', 9, 0, '', '2019-06-03 21:44:06');
INSERT INTO `access_log` VALUES (25817, '65.53.15595694466956593', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:07', 93, 0, '', '2019-06-03 21:44:07');
INSERT INTO `access_log` VALUES (25818, '65.45.15595694525916639', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:13', 9, 0, '', '2019-06-03 21:44:13');
INSERT INTO `access_log` VALUES (25819, '62.81.15595694536906529', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:14', 12, 0, '', '2019-06-03 21:44:14');
INSERT INTO `access_log` VALUES (25820, '64.81.15595694541266353', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:14', 9, 0, '', '2019-06-03 21:44:14');
INSERT INTO `access_log` VALUES (25821, '64.79.15595694541256351', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:14', 11, 0, '', '2019-06-03 21:44:14');
INSERT INTO `access_log` VALUES (25822, '65.49.15595694543426635', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:14', 14, 0, '', '2019-06-03 21:44:14');
INSERT INTO `access_log` VALUES (25823, '65.52.15595694545756609', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:15', 9, 0, '', '2019-06-03 21:44:15');
INSERT INTO `access_log` VALUES (25824, '65.51.15595694549776617', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:15', 11, 0, '', '2019-06-03 21:44:15');
INSERT INTO `access_log` VALUES (25825, '65.50.15595694551956627', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:15', 18, 0, '', '2019-06-03 21:44:15');
INSERT INTO `access_log` VALUES (25826, '64.82.15595694554096365', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:15', 9, 0, '', '2019-06-03 21:44:15');
INSERT INTO `access_log` VALUES (25827, '64.78.15595694554096359', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:15', 11, 0, '', '2019-06-03 21:44:15');
INSERT INTO `access_log` VALUES (25828, '64.83.15595694556146351', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:16', 9, 0, '', '2019-06-03 21:44:16');
INSERT INTO `access_log` VALUES (25829, '64.84.15595694556136359', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:16', 10, 0, '', '2019-06-03 21:44:16');
INSERT INTO `access_log` VALUES (25830, '59.76.15595694558286687', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:16', 21, 2001001000, '服务端发生异常', '2019-06-03 21:44:16');
INSERT INTO `access_log` VALUES (25831, '66.50.15595694561035355', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.10.35.130', '2019-06-03 21:44:16', 13, 0, '', '2019-06-03 21:44:16');
INSERT INTO `access_log` VALUES (25832, '59.73.15595695720466699', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.205', '2019-06-03 21:46:12', 7, 0, '', '2019-06-03 21:46:12');
INSERT INTO `access_log` VALUES (25833, '59.76.15595695720466689', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.205', '2019-06-03 21:46:12', 10, 2001001000, '服务端发生异常', '2019-06-03 21:46:12');
INSERT INTO `access_log` VALUES (25834, '64.83.15595695743116353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.205', '2019-06-03 21:46:14', 2, 0, '', '2019-06-03 21:46:14');
INSERT INTO `access_log` VALUES (25835, '64.84.15595695744396361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.205', '2019-06-03 21:46:14', 2, 0, '', '2019-06-03 21:46:14');
INSERT INTO `access_log` VALUES (25836, '64.80.15595695756436353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.205', '2019-06-03 21:46:16', 394, 0, '', '2019-06-03 21:46:16');
INSERT INTO `access_log` VALUES (25837, '64.85.15595695761386375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.205', '2019-06-03 21:46:16', 3, 0, '', '2019-06-03 21:46:16');
INSERT INTO `access_log` VALUES (25838, '65.52.15595700099036617', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 21:53:30', 174, 0, '', '2019-06-03 21:53:30');
INSERT INTO `access_log` VALUES (25839, '65.51.15595700105616625', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 21:53:31', 8, 0, '', '2019-06-03 21:53:31');
INSERT INTO `access_log` VALUES (25840, '65.50.15595700105646635', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 21:53:31', 7, 0, '', '2019-06-03 21:53:31');
INSERT INTO `access_log` VALUES (25841, '65.48.15595700105826631', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 21:53:31', 8, 0, '', '2019-06-03 21:53:31');
INSERT INTO `access_log` VALUES (25842, '64.77.15595700138876371', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 21:53:34', 8, 0, '', '2019-06-03 21:53:34');
INSERT INTO `access_log` VALUES (25843, '64.85.15595700138856381', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 21:53:34', 12, 0, '', '2019-06-03 21:53:34');
INSERT INTO `access_log` VALUES (25844, '65.49.15595705357416651', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.179.109', '2019-06-03 22:02:16', 1, 1002001015, '账号未登陆', '2019-06-03 22:02:16');
INSERT INTO `access_log` VALUES (25845, '65.52.15595705357466625', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.179.109', '2019-06-03 22:02:16', 0, 1002001015, '账号未登陆', '2019-06-03 22:02:16');
INSERT INTO `access_log` VALUES (25846, '65.51.15595705357506633', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.179.109', '2019-06-03 22:02:16', 0, 1002001015, '账号未登陆', '2019-06-03 22:02:16');
INSERT INTO `access_log` VALUES (25847, '65.50.15595705435766643', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.179.109', '2019-06-03 22:02:24', 76, 0, '', '2019-06-03 22:02:24');
INSERT INTO `access_log` VALUES (25848, '65.46.15595705442446633', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.179.109', '2019-06-03 22:02:24', 10, 0, '', '2019-06-03 22:02:24');
INSERT INTO `access_log` VALUES (25849, '65.53.15595705442626611', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.179.109', '2019-06-03 22:02:24', 10, 0, '', '2019-06-03 22:02:24');
INSERT INTO `access_log` VALUES (25850, '65.47.15595705442626633', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.179.109', '2019-06-03 22:02:24', 10, 0, '', '2019-06-03 22:02:24');
INSERT INTO `access_log` VALUES (25851, '62.85.15595705471816563', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.179.109', '2019-06-03 22:02:27', 197, 0, '', '2019-06-03 22:02:27');
INSERT INTO `access_log` VALUES (25852, '62.88.15595705594866573', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&status=2&payChannel=101', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.179.109', '2019-06-03 22:02:39', 457, 0, '', '2019-06-03 22:02:40');
INSERT INTO `access_log` VALUES (25853, '66.48.15595705664095371', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.179.109', '2019-06-03 22:02:46', 14, 0, '', '2019-06-03 22:02:46');
INSERT INTO `access_log` VALUES (25854, '59.76.15595705894946703', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.179.109', '2019-06-03 22:03:09', 195, 0, '', '2019-06-03 22:03:10');
INSERT INTO `access_log` VALUES (25855, '65.49.15595708815946657', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:08:02', 11, 0, '', '2019-06-03 22:08:02');
INSERT INTO `access_log` VALUES (25856, '65.52.15595708816026631', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:08:02', 9, 0, '', '2019-06-03 22:08:02');
INSERT INTO `access_log` VALUES (25857, '65.51.15595708816126639', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:08:02', 10, 0, '', '2019-06-03 22:08:02');
INSERT INTO `access_log` VALUES (25858, '64.85.15595708818846393', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:08:02', 9, 0, '', '2019-06-03 22:08:02');
INSERT INTO `access_log` VALUES (25859, '64.77.15595708818836383', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:08:02', 11, 0, '', '2019-06-03 22:08:02');
INSERT INTO `access_log` VALUES (25860, '65.45.15595715648726671', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:19:25', 0, 1002001015, '账号未登陆', '2019-06-03 22:19:25');
INSERT INTO `access_log` VALUES (25861, '65.52.15595715648746641', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:19:25', 1, 1002001015, '账号未登陆', '2019-06-03 22:19:25');
INSERT INTO `access_log` VALUES (25862, '65.49.15595715648786667', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:19:25', 0, 1002001015, '账号未登陆', '2019-06-03 22:19:25');
INSERT INTO `access_log` VALUES (25863, '65.51.15595715732056649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:19:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 22:19:33');
INSERT INTO `access_log` VALUES (25864, '65.50.15595715778686659', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:19:38', 125, 0, '', '2019-06-03 22:19:38');
INSERT INTO `access_log` VALUES (25865, '65.48.15595715782746655', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:19:38', 9, 0, '', '2019-06-03 22:19:38');
INSERT INTO `access_log` VALUES (25866, '65.53.15595715782776627', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:19:38', 8, 0, '', '2019-06-03 22:19:38');
INSERT INTO `access_log` VALUES (25867, '65.46.15595715782816649', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:19:38', 8, 0, '', '2019-06-03 22:19:38');
INSERT INTO `access_log` VALUES (25868, '62.88.15595715871746587', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:19:47', 736, 0, '', '2019-06-03 22:19:48');
INSERT INTO `access_log` VALUES (25869, '62.89.15595715907916577', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:19:51', 22, 0, '', '2019-06-03 22:19:51');
INSERT INTO `access_log` VALUES (25870, '64.77.15595716005176393', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:20:01', 9, 0, '', '2019-06-03 22:20:01');
INSERT INTO `access_log` VALUES (25871, '64.85.15595716005136403', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:20:01', 12, 0, '', '2019-06-03 22:20:01');
INSERT INTO `access_log` VALUES (25872, '64.79.15595716045566383', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:20:05', 10, 0, '', '2019-06-03 22:20:05');
INSERT INTO `access_log` VALUES (25873, '64.76.15595716045556379', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:20:05', 11, 0, '', '2019-06-03 22:20:05');
INSERT INTO `access_log` VALUES (25874, '64.83.15595716100736383', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:20:10', 81, 0, '', '2019-06-03 22:20:10');
INSERT INTO `access_log` VALUES (25875, '64.78.15595716100706391', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:20:10', 84, 0, '', '2019-06-03 22:20:10');
INSERT INTO `access_log` VALUES (25876, '64.82.15595716100706397', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:20:10', 88, 0, '', '2019-06-03 22:20:10');
INSERT INTO `access_log` VALUES (25877, '64.84.15595716163576391', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:20:16', 11, 0, '', '2019-06-03 22:20:16');
INSERT INTO `access_log` VALUES (25878, '66.53.15595716248645379', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:20:25', 14, 0, '', '2019-06-03 22:20:25');
INSERT INTO `access_log` VALUES (25879, '59.76.15595716277726717', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:20:28', 11, 0, '', '2019-06-03 22:20:28');
INSERT INTO `access_log` VALUES (25880, '65.50.15595716640356661', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:21:04', 20, 0, '', '2019-06-03 22:21:04');
INSERT INTO `access_log` VALUES (25881, '65.49.15595717294286671', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:22:09', 12, 0, '', '2019-06-03 22:22:09');
INSERT INTO `access_log` VALUES (25882, '65.45.15595717342656675', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.166.104.249', '2019-06-03 22:22:14', 14, 0, '', '2019-06-03 22:22:14');
INSERT INTO `access_log` VALUES (25883, '66.50.15595718035405387', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.5.248.217', '2019-06-03 22:23:24', 7, 1002001012, '访问令牌已过期', '2019-06-03 22:23:24');
INSERT INTO `access_log` VALUES (25884, '65.53.15595718053206631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.5.248.217', '2019-06-03 22:23:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 22:23:25');
INSERT INTO `access_log` VALUES (25885, '65.47.15595718103576653', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.5.248.217', '2019-06-03 22:23:30', 85, 0, '', '2019-06-03 22:23:30');
INSERT INTO `access_log` VALUES (25886, '65.54.15595718107956623', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.5.248.217', '2019-06-03 22:23:31', 8, 0, '', '2019-06-03 22:23:31');
INSERT INTO `access_log` VALUES (25887, '65.49.15595718108036673', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.5.248.217', '2019-06-03 22:23:31', 16, 0, '', '2019-06-03 22:23:31');
INSERT INTO `access_log` VALUES (25888, '65.45.15595718108136677', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.5.248.217', '2019-06-03 22:23:31', 8, 0, '', '2019-06-03 22:23:31');
INSERT INTO `access_log` VALUES (25889, '59.71.15595718154546729', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.5.248.217', '2019-06-03 22:23:35', 12, 0, '', '2019-06-03 22:23:35');
INSERT INTO `access_log` VALUES (25890, '64.76.15595718199756383', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.5.248.217', '2019-06-03 22:23:40', 28, 0, '', '2019-06-03 22:23:40');
INSERT INTO `access_log` VALUES (25891, '64.81.15595718221286389', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.5.248.217', '2019-06-03 22:23:42', 10, 0, '', '2019-06-03 22:23:42');
INSERT INTO `access_log` VALUES (25892, '64.78.15595718305936395', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.5.248.217', '2019-06-03 22:23:51', 7, 0, '', '2019-06-03 22:23:51');
INSERT INTO `access_log` VALUES (25893, '64.83.15595718305936387', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.5.248.217', '2019-06-03 22:23:51', 9, 0, '', '2019-06-03 22:23:51');
INSERT INTO `access_log` VALUES (25894, '59.73.15595718912416731', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.91.107.222', '2019-06-03 22:24:51', 5, 0, '', '2019-06-03 22:24:51');
INSERT INTO `access_log` VALUES (25895, '59.76.15595718912416721', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.91.107.222', '2019-06-03 22:24:51', 12, 2001001000, '服务端发生异常', '2019-06-03 22:24:51');
INSERT INTO `access_log` VALUES (25896, '64.79.15595718962766389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.91.107.222', '2019-06-03 22:24:56', 3, 0, '', '2019-06-03 22:24:56');
INSERT INTO `access_log` VALUES (25897, '64.76.15595718963886385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.91.107.222', '2019-06-03 22:24:56', 1, 0, '', '2019-06-03 22:24:56');
INSERT INTO `access_log` VALUES (25898, '64.81.15595718976356391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.91.107.222', '2019-06-03 22:24:58', 2, 0, '', '2019-06-03 22:24:58');
INSERT INTO `access_log` VALUES (25899, '64.82.15595718983246403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.91.107.222', '2019-06-03 22:24:58', 2, 0, '', '2019-06-03 22:24:58');
INSERT INTO `access_log` VALUES (25900, '59.79.15595718999406727', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.91.107.222', '2019-06-03 22:25:00', 3, 0, '', '2019-06-03 22:25:00');
INSERT INTO `access_log` VALUES (25901, '59.75.15595718999406727', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.91.107.222', '2019-06-03 22:25:00', 17, 2001001000, '服务端发生异常', '2019-06-03 22:25:00');
INSERT INTO `access_log` VALUES (25902, '65.47.15595719085656655', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.91.107.222', '2019-06-03 22:25:09', 0, 1002001015, '账号未登陆', '2019-06-03 22:25:09');
INSERT INTO `access_log` VALUES (25903, '65.45.15595719085666679', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.91.107.222', '2019-06-03 22:25:09', 0, 1002001015, '账号未登陆', '2019-06-03 22:25:09');
INSERT INTO `access_log` VALUES (25904, '65.54.15595719085736625', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.91.107.222', '2019-06-03 22:25:09', 1, 1002001015, '账号未登陆', '2019-06-03 22:25:09');
INSERT INTO `access_log` VALUES (25905, '65.52.15595719108856649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.91.107.222', '2019-06-03 22:25:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 22:25:11');
INSERT INTO `access_log` VALUES (25906, '65.51.15595719133256657', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.91.107.222', '2019-06-03 22:25:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 22:25:13');
INSERT INTO `access_log` VALUES (25907, '65.46.15595719330216657', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:25:33', 10, 0, '', '2019-06-03 22:25:33');
INSERT INTO `access_log` VALUES (25908, '65.48.15595719330256663', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:25:33', 10, 0, '', '2019-06-03 22:25:33');
INSERT INTO `access_log` VALUES (25909, '65.53.15595719330316635', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:25:33', 9, 0, '', '2019-06-03 22:25:33');
INSERT INTO `access_log` VALUES (25910, '64.84.15595719333516397', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:25:33', 18, 0, '', '2019-06-03 22:25:33');
INSERT INTO `access_log` VALUES (25911, '64.80.15595719336196389', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:25:34', 9, 0, '', '2019-06-03 22:25:34');
INSERT INTO `access_log` VALUES (25912, '65.47.15595719410726657', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:25:41', 10, 0, '', '2019-06-03 22:25:41');
INSERT INTO `access_log` VALUES (25913, '65.45.15595719410766681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:25:41', 9, 0, '', '2019-06-03 22:25:41');
INSERT INTO `access_log` VALUES (25914, '65.54.15595719410806627', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:25:41', 10, 0, '', '2019-06-03 22:25:41');
INSERT INTO `access_log` VALUES (25915, '65.52.15595719476296651', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:25:48', 8, 0, '', '2019-06-03 22:25:48');
INSERT INTO `access_log` VALUES (25916, '65.51.15595719476396659', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:25:48', 9, 0, '', '2019-06-03 22:25:48');
INSERT INTO `access_log` VALUES (25917, '65.50.15595719476456669', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:25:48', 9, 0, '', '2019-06-03 22:25:48');
INSERT INTO `access_log` VALUES (25918, '66.50.15595719478895389', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:25:48', 12, 0, '', '2019-06-03 22:25:48');
INSERT INTO `access_log` VALUES (25919, '65.46.15595719734236659', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:26:13', 10, 0, '', '2019-06-03 22:26:13');
INSERT INTO `access_log` VALUES (25920, '65.49.15595719734276679', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:26:13', 9, 0, '', '2019-06-03 22:26:13');
INSERT INTO `access_log` VALUES (25921, '65.45.15595719734346683', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:26:13', 9, 0, '', '2019-06-03 22:26:13');
INSERT INTO `access_log` VALUES (25922, '64.76.15595719737396387', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:26:14', 11, 0, '', '2019-06-03 22:26:14');
INSERT INTO `access_log` VALUES (25923, '64.81.15595719737446393', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:26:14', 8, 0, '', '2019-06-03 22:26:14');
INSERT INTO `access_log` VALUES (25924, '64.78.15595719778746399', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:26:18', 84, 0, '', '2019-06-03 22:26:18');
INSERT INTO `access_log` VALUES (25925, '64.83.15595719778726391', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:26:18', 88, 0, '', '2019-06-03 22:26:18');
INSERT INTO `access_log` VALUES (25926, '64.82.15595719778706405', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:26:18', 94, 0, '', '2019-06-03 22:26:18');
INSERT INTO `access_log` VALUES (25927, '65.47.15595719961786659', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:26:36', 9, 0, '', '2019-06-03 22:26:36');
INSERT INTO `access_log` VALUES (25928, '65.52.15595719961856653', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:26:36', 9, 0, '', '2019-06-03 22:26:36');
INSERT INTO `access_log` VALUES (25929, '65.51.15595719961886661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.5.248.217', '2019-06-03 22:26:36', 8, 0, '', '2019-06-03 22:26:36');
INSERT INTO `access_log` VALUES (25930, '59.74.15595720591546725', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.171.61.138', '2019-06-03 22:27:39', 4, 0, '', '2019-06-03 22:27:39');
INSERT INTO `access_log` VALUES (25931, '59.80.15595720591556721', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.171.61.138', '2019-06-03 22:27:39', 14, 2001001000, '服务端发生异常', '2019-06-03 22:27:39');
INSERT INTO `access_log` VALUES (25932, '64.81.15595720658736395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:27:46', 3, 0, '', '2019-06-03 22:27:46');
INSERT INTO `access_log` VALUES (25933, '64.83.15595720661066393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:27:46', 1, 0, '', '2019-06-03 22:27:46');
INSERT INTO `access_log` VALUES (25934, '64.78.15595720683416401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:27:48', 2, 0, '', '2019-06-03 22:27:48');
INSERT INTO `access_log` VALUES (25935, '64.82.15595720684846407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:27:48', 2, 0, '', '2019-06-03 22:27:48');
INSERT INTO `access_log` VALUES (25936, '64.84.15595720699436401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:27:50', 2, 0, '', '2019-06-03 22:27:50');
INSERT INTO `access_log` VALUES (25937, '64.85.15595720708526415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:27:51', 3, 0, '', '2019-06-03 22:27:51');
INSERT INTO `access_log` VALUES (25938, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:27:51', 16, 0, '', '2019-06-03 22:27:51');
INSERT INTO `access_log` VALUES (25939, '64.77.15595720720206405', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:27:52', 6, 0, '', '2019-06-03 22:27:52');
INSERT INTO `access_log` VALUES (25940, '64.79.15595720779766395', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:27:58', 65, 0, '', '2019-06-03 22:27:58');
INSERT INTO `access_log` VALUES (25941, '64.81.15595721000656397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:28:20', 3, 0, '', '2019-06-03 22:28:20');
INSERT INTO `access_log` VALUES (25942, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:28:20', 7, 0, '', '2019-06-03 22:28:20');
INSERT INTO `access_log` VALUES (25943, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:28:22', 7, 0, '', '2019-06-03 22:28:22');
INSERT INTO `access_log` VALUES (25944, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:31:55', 30, 0, '', '2019-06-03 22:31:55');
INSERT INTO `access_log` VALUES (25945, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:31:57', 7, 0, '', '2019-06-03 22:31:57');
INSERT INTO `access_log` VALUES (25946, '64.85.15595723184976419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:31:58', 2, 0, '', '2019-06-03 22:31:59');
INSERT INTO `access_log` VALUES (25947, '64.77.15595723186186409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:31:59', 2, 0, '', '2019-06-03 22:31:59');
INSERT INTO `access_log` VALUES (25948, '64.79.15595723196976399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:32:00', 2, 0, '', '2019-06-03 22:32:00');
INSERT INTO `access_log` VALUES (25949, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:32:00', 5, 0, '', '2019-06-03 22:32:00');
INSERT INTO `access_log` VALUES (25950, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:32:01', 7, 0, '', '2019-06-03 22:32:01');
INSERT INTO `access_log` VALUES (25951, '64.76.15595723224346395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:32:02', 2, 0, '', '2019-06-03 22:32:02');
INSERT INTO `access_log` VALUES (25952, '64.81.15595723225516401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:32:03', 2, 0, '', '2019-06-03 22:32:03');
INSERT INTO `access_log` VALUES (25953, '64.83.15595723232626399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:32:03', 54, 0, '', '2019-06-03 22:32:03');
INSERT INTO `access_log` VALUES (25954, '64.78.15595723240546407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:32:04', 2, 0, '', '2019-06-03 22:32:04');
INSERT INTO `access_log` VALUES (25955, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:32:04', 7, 0, '', '2019-06-03 22:32:04');
INSERT INTO `access_log` VALUES (25956, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:32:05', 8, 0, '', '2019-06-03 22:32:05');
INSERT INTO `access_log` VALUES (25957, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:32:06', 8, 0, '', '2019-06-03 22:32:06');
INSERT INTO `access_log` VALUES (25958, '64.77.15595723833496411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:33:03', 2, 0, '', '2019-06-03 22:33:03');
INSERT INTO `access_log` VALUES (25959, '64.79.15595723834866401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:33:03', 2, 0, '', '2019-06-03 22:33:03');
INSERT INTO `access_log` VALUES (25960, '64.76.15595723843756397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:33:04', 2, 0, '', '2019-06-03 22:33:04');
INSERT INTO `access_log` VALUES (25961, '64.83.15595723871536401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:33:07', 2, 0, '', '2019-06-03 22:33:07');
INSERT INTO `access_log` VALUES (25962, '64.78.15595723872496409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:33:07', 1, 0, '', '2019-06-03 22:33:07');
INSERT INTO `access_log` VALUES (25963, '65.51.15595724048026667', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '116.22.163.60', '2019-06-03 22:33:25', 0, 1002001015, '账号未登陆', '2019-06-03 22:33:25');
INSERT INTO `access_log` VALUES (25964, '65.50.15595724048056677', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '116.22.163.60', '2019-06-03 22:33:25', 1, 1002001015, '账号未登陆', '2019-06-03 22:33:25');
INSERT INTO `access_log` VALUES (25965, '65.47.15595724048056665', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '116.22.163.60', '2019-06-03 22:33:25', 1, 1002001015, '账号未登陆', '2019-06-03 22:33:25');
INSERT INTO `access_log` VALUES (25966, '65.48.15595724069436673', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '116.22.163.60', '2019-06-03 22:33:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 22:33:27');
INSERT INTO `access_log` VALUES (25967, '65.53.15595724093876645', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '116.22.163.60', '2019-06-03 22:33:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 22:33:29');
INSERT INTO `access_log` VALUES (25968, '64.79.15595724656236403', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:34:26', 1, 1002001015, '账号未登陆', '2019-06-03 22:34:26');
INSERT INTO `access_log` VALUES (25969, '65.50.15595724824036679', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:34:42', 11, 0, '', '2019-06-03 22:34:42');
INSERT INTO `access_log` VALUES (25970, '65.51.15595724824076669', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:34:42', 9, 0, '', '2019-06-03 22:34:42');
INSERT INTO `access_log` VALUES (25971, '65.47.15595724824196667', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:34:42', 9, 0, '', '2019-06-03 22:34:42');
INSERT INTO `access_log` VALUES (25972, '64.83.15595724825936403', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:34:43', 9, 0, '', '2019-06-03 22:34:43');
INSERT INTO `access_log` VALUES (25973, '64.81.15595724825936405', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:34:43', 10, 0, '', '2019-06-03 22:34:43');
INSERT INTO `access_log` VALUES (25974, '64.82.15595724866556417', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:34:47', 57, 0, '', '2019-06-03 22:34:47');
INSERT INTO `access_log` VALUES (25975, '64.78.15595724866556411', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:34:47', 58, 0, '', '2019-06-03 22:34:47');
INSERT INTO `access_log` VALUES (25976, '64.84.15595724902016411', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:34:50', 1, 1002001015, '账号未登陆', '2019-06-03 22:34:50');
INSERT INTO `access_log` VALUES (25977, '64.85.15595724986296425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:34:59', 2, 0, '', '2019-06-03 22:34:59');
INSERT INTO `access_log` VALUES (25978, '64.77.15595724987576415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:34:59', 2, 0, '', '2019-06-03 22:34:59');
INSERT INTO `access_log` VALUES (25979, '64.79.15595724998936405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:35:00', 2, 0, '', '2019-06-03 22:35:00');
INSERT INTO `access_log` VALUES (25980, '64.76.15595725005296401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:35:01', 2, 0, '', '2019-06-03 22:35:01');
INSERT INTO `access_log` VALUES (25981, '59.80.15595725018806727', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:35:02', 5, 0, '', '2019-06-03 22:35:02');
INSERT INTO `access_log` VALUES (25982, '59.78.15595725019206739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Nexus 6P Build/OPP3.170518.006) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '115.171.61.138', '2019-06-03 22:35:02', 19, 2001001000, '服务端发生异常', '2019-06-03 22:35:02');
INSERT INTO `access_log` VALUES (25983, '64.81.15595725107946407', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:35:11', 12, 0, '', '2019-06-03 22:35:11');
INSERT INTO `access_log` VALUES (25984, '64.78.15595725108016413', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-03 22:35:11', 8, 0, '', '2019-06-03 22:35:11');
INSERT INTO `access_log` VALUES (25985, '65.50.15595734944136693', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.4.101', '2019-06-03 22:51:34', 4, 1002001012, '访问令牌已过期', '2019-06-03 22:51:34');
INSERT INTO `access_log` VALUES (25986, '65.51.15595734944136683', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.4.101', '2019-06-03 22:51:34', 4, 1002001012, '访问令牌已过期', '2019-06-03 22:51:34');
INSERT INTO `access_log` VALUES (25987, '65.47.15595734944136681', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.4.101', '2019-06-03 22:51:34', 4, 1002001012, '访问令牌已过期', '2019-06-03 22:51:34');
INSERT INTO `access_log` VALUES (25988, '65.53.15595735002406661', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.4.101', '2019-06-03 22:51:40', 108, 0, '', '2019-06-03 22:51:40');
INSERT INTO `access_log` VALUES (25989, '65.45.15595735012136707', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.4.101', '2019-06-03 22:51:41', 9, 0, '', '2019-06-03 22:51:41');
INSERT INTO `access_log` VALUES (25990, '65.46.15595735012336683', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.4.101', '2019-06-03 22:51:41', 9, 0, '', '2019-06-03 22:51:41');
INSERT INTO `access_log` VALUES (25991, '65.49.15595735012396703', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.4.101', '2019-06-03 22:51:41', 9, 0, '', '2019-06-03 22:51:41');
INSERT INTO `access_log` VALUES (25992, '64.83.15595735080196419', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.4.101', '2019-06-03 22:51:48', 52, 0, '', '2019-06-03 22:51:48');
INSERT INTO `access_log` VALUES (25993, '64.76.15595735080136415', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.4.101', '2019-06-03 22:51:48', 59, 0, '', '2019-06-03 22:51:48');
INSERT INTO `access_log` VALUES (25994, '65.54.15595735124546653', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.4.101', '2019-06-03 22:51:52', 19, 0, '', '2019-06-03 22:51:52');
INSERT INTO `access_log` VALUES (25995, '65.47.15595735181036683', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.4.101', '2019-06-03 22:51:58', 9, 0, '', '2019-06-03 22:51:58');
INSERT INTO `access_log` VALUES (25996, '65.51.15595735197676685', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.4.101', '2019-06-03 22:52:00', 12, 0, '', '2019-06-03 22:52:00');
INSERT INTO `access_log` VALUES (25997, '65.50.15595738272006699', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 22:57:07', 0, 1002001015, '账号未登陆', '2019-06-03 22:57:07');
INSERT INTO `access_log` VALUES (25998, '65.48.15595738272066695', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 22:57:07', 0, 1002001015, '账号未登陆', '2019-06-03 22:57:07');
INSERT INTO `access_log` VALUES (25999, '65.53.15595738272136667', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 22:57:07', 0, 1002001015, '账号未登陆', '2019-06-03 22:57:07');
INSERT INTO `access_log` VALUES (26000, '65.47.15595739034346689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 22:58:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-03 22:58:23');
INSERT INTO `access_log` VALUES (26001, '65.50.15595739228556701', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 22:58:43', 228, 0, '', '2019-06-03 22:58:43');
INSERT INTO `access_log` VALUES (26002, '65.53.15595739234626669', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 22:58:43', 8, 0, '', '2019-06-03 22:58:43');
INSERT INTO `access_log` VALUES (26003, '65.46.15595739234726691', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 22:58:43', 7, 0, '', '2019-06-03 22:58:43');
INSERT INTO `access_log` VALUES (26004, '65.45.15595739235026715', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 22:58:44', 8, 0, '', '2019-06-03 22:58:44');
INSERT INTO `access_log` VALUES (26005, '62.80.15595739338006611', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 22:58:54', 22, 0, '', '2019-06-03 22:58:54');
INSERT INTO `access_log` VALUES (26006, '65.54.15595739412256661', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 22:59:01', 21, 0, '', '2019-06-03 22:59:01');
INSERT INTO `access_log` VALUES (26007, '65.52.15595739431986685', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 22:59:03', 19, 0, '', '2019-06-03 22:59:03');
INSERT INTO `access_log` VALUES (26008, '65.51.15595739548096693', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 22:59:15', 10, 0, '', '2019-06-03 22:59:15');
INSERT INTO `access_log` VALUES (26009, '65.48.15595739575076699', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 22:59:18', 12, 0, '', '2019-06-03 22:59:18');
INSERT INTO `access_log` VALUES (26010, '65.53.15595739668536671', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 22:59:27', 9, 0, '', '2019-06-03 22:59:27');
INSERT INTO `access_log` VALUES (26011, '65.49.15595740035076713', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 23:00:04', 14, 0, '', '2019-06-03 23:00:04');
INSERT INTO `access_log` VALUES (26012, '59.76.15595740362186751', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.212.222', '2019-06-03 23:00:36', 3, 0, '', '2019-06-03 23:00:36');
INSERT INTO `access_log` VALUES (26013, '59.75.15595740362186757', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.212.222', '2019-06-03 23:00:36', 19, 2001001000, '服务端发生异常', '2019-06-03 23:00:36');
INSERT INTO `access_log` VALUES (26014, '59.71.15595740402186761', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.212.222', '2019-06-03 23:00:40', 13, 2001001000, '服务端发生异常', '2019-06-03 23:00:40');
INSERT INTO `access_log` VALUES (26015, '59.79.15595740402186757', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.212.222', '2019-06-03 23:00:40', 359, 0, '', '2019-06-03 23:00:41');
INSERT INTO `access_log` VALUES (26016, '65.50.15595740767166705', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 23:01:17', 10, 0, '', '2019-06-03 23:01:17');
INSERT INTO `access_log` VALUES (26017, '65.53.15595740775156673', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 23:01:18', 9, 0, '', '2019-06-03 23:01:18');
INSERT INTO `access_log` VALUES (26018, '59.72.15595740799166755', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 23:01:20', 10, 0, '', '2019-06-03 23:01:20');
INSERT INTO `access_log` VALUES (26019, '59.77.15595740909166749', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 23:01:31', 19, 2001001000, '服务端发生异常', '2019-06-03 23:01:31');
INSERT INTO `access_log` VALUES (26020, '59.73.15595740928306763', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 23:01:33', 12, 0, '', '2019-06-03 23:01:33');
INSERT INTO `access_log` VALUES (26021, '64.76.15595740948396423', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 23:01:35', 10, 0, '', '2019-06-03 23:01:35');
INSERT INTO `access_log` VALUES (26022, '64.78.15595741005926435', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 23:01:41', 9, 0, '', '2019-06-03 23:01:41');
INSERT INTO `access_log` VALUES (26023, '59.75.15595741029476759', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.251.172.34', '2019-06-03 23:01:43', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-03 23:01:43');
INSERT INTO `access_log` VALUES (26024, '64.84.15595741191186435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.212.222', '2019-06-03 23:01:59', 2, 0, '', '2019-06-03 23:01:59');
INSERT INTO `access_log` VALUES (26025, '64.80.15595741194386427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.212.222', '2019-06-03 23:01:59', 2, 0, '', '2019-06-03 23:01:59');
INSERT INTO `access_log` VALUES (26026, '64.85.15595741214786449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.212.222', '2019-06-03 23:02:01', 2, 0, '', '2019-06-03 23:02:01');
INSERT INTO `access_log` VALUES (26027, '59.79.15595741234986759', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.212.222', '2019-06-03 23:02:03', 2, 0, '', '2019-06-03 23:02:04');
INSERT INTO `access_log` VALUES (26028, '59.74.15595741235586755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.212.222', '2019-06-03 23:02:04', 12, 2001001000, '服务端发生异常', '2019-06-03 23:02:04');
INSERT INTO `access_log` VALUES (26029, '64.79.15595741259086429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.212.222', '2019-06-03 23:02:06', 1, 0, '', '2019-06-03 23:02:06');
INSERT INTO `access_log` VALUES (26030, '64.83.15595741260486429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.212.222', '2019-06-03 23:02:06', 2, 0, '', '2019-06-03 23:02:06');
INSERT INTO `access_log` VALUES (26031, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=啊了&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.212.222', '2019-06-03 23:02:17', 7, 0, '', '2019-06-03 23:02:17');
INSERT INTO `access_log` VALUES (26032, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=啊了', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.212.222', '2019-06-03 23:02:17', 10, 0, '', '2019-06-03 23:02:17');
INSERT INTO `access_log` VALUES (26033, '59.76.15595756941266775', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.197.187.198', '2019-06-03 23:28:14', 3, 0, '', '2019-06-03 23:28:14');
INSERT INTO `access_log` VALUES (26034, '59.75.15595756941336781', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.197.187.198', '2019-06-03 23:28:14', 10, 2001001000, '服务端发生异常', '2019-06-03 23:28:14');
INSERT INTO `access_log` VALUES (26035, '65.51.15595885334176893', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:13', 1, 1002001015, '账号未登陆', '2019-06-04 03:02:13');
INSERT INTO `access_log` VALUES (26036, '65.50.15595885334176899', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:13', 1, 1002001015, '账号未登陆', '2019-06-04 03:02:13');
INSERT INTO `access_log` VALUES (26037, '65.47.15595885334336887', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:13', 3, 1002001015, '账号未登陆', '2019-06-04 03:02:13');
INSERT INTO `access_log` VALUES (26038, '65.53.15595885379926869', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 03:02:18');
INSERT INTO `access_log` VALUES (26039, '65.45.15595885465966913', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:27', 64, 0, '', '2019-06-04 03:02:27');
INSERT INTO `access_log` VALUES (26040, '65.54.15595885469236861', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:27', 20, 0, '', '2019-06-04 03:02:27');
INSERT INTO `access_log` VALUES (26041, '65.49.15595885469256911', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:27', 19, 0, '', '2019-06-04 03:02:27');
INSERT INTO `access_log` VALUES (26042, '65.52.15595885469256885', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:27', 19, 0, '', '2019-06-04 03:02:27');
INSERT INTO `access_log` VALUES (26043, '62.83.15595885519266807', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:32', 23, 0, '', '2019-06-04 03:02:32');
INSERT INTO `access_log` VALUES (26044, '64.82.15595885583376635', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:38', 23, 0, '', '2019-06-04 03:02:38');
INSERT INTO `access_log` VALUES (26045, '64.78.15595885583306629', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:38', 37, 0, '', '2019-06-04 03:02:38');
INSERT INTO `access_log` VALUES (26046, '64.84.15595885643136629', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:44', 24, 0, '', '2019-06-04 03:02:44');
INSERT INTO `access_log` VALUES (26047, '64.80.15595885643156621', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:44', 10, 0, '', '2019-06-04 03:02:44');
INSERT INTO `access_log` VALUES (26048, '64.77.15595885733486633', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:53', 20, 0, '', '2019-06-04 03:02:53');
INSERT INTO `access_log` VALUES (26049, '64.79.15595885733486623', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:53', 15, 0, '', '2019-06-04 03:02:53');
INSERT INTO `access_log` VALUES (26050, '64.83.15595885733786623', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:02:53', 10, 0, '', '2019-06-04 03:02:53');
INSERT INTO `access_log` VALUES (26051, '64.81.15595885933286625', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:03:13', 11, 0, '', '2019-06-04 03:03:13');
INSERT INTO `access_log` VALUES (26052, '66.56.15595886019525603', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:03:22', 21, 0, '', '2019-06-04 03:03:22');
INSERT INTO `access_log` VALUES (26053, '59.74.15595886227576949', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:03:43', 31, 0, '', '2019-06-04 03:03:43');
INSERT INTO `access_log` VALUES (26054, '65.46.15595886260166891', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:03:46', 26, 0, '', '2019-06-04 03:03:46');
INSERT INTO `access_log` VALUES (26055, '65.54.15595886343086863', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:03:54', 10, 0, '', '2019-06-04 03:03:54');
INSERT INTO `access_log` VALUES (26056, '65.52.15595886375026887', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:03:58', 11, 0, '', '2019-06-04 03:03:58');
INSERT INTO `access_log` VALUES (26057, '65.49.15595886453916913', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:05', 10, 0, '', '2019-06-04 03:04:05');
INSERT INTO `access_log` VALUES (26058, '65.48.15595886487886899', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:09', 15, 0, '', '2019-06-04 03:04:09');
INSERT INTO `access_log` VALUES (26059, '65.47.15595886582036891', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:18', 140, 0, '', '2019-06-04 03:04:18');
INSERT INTO `access_log` VALUES (26060, '65.53.15595886718196873', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:32', 10, 0, '', '2019-06-04 03:04:32');
INSERT INTO `access_log` VALUES (26061, '65.46.15595886745806893', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:35', 12, 0, '', '2019-06-04 03:04:35');
INSERT INTO `access_log` VALUES (26062, '65.54.15595886845056865', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:45', 9, 0, '', '2019-06-04 03:04:45');
INSERT INTO `access_log` VALUES (26063, '65.52.15595886861396889', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:46', 12, 0, '', '2019-06-04 03:04:46');
INSERT INTO `access_log` VALUES (26064, '65.49.15595886868796915', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:47', 9, 0, '', '2019-06-04 03:04:47');
INSERT INTO `access_log` VALUES (26065, '65.48.15595886875166901', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:48', 10, 0, '', '2019-06-04 03:04:48');
INSERT INTO `access_log` VALUES (26066, '65.51.15595886883826899', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:48', 17, 0, '', '2019-06-04 03:04:48');
INSERT INTO `access_log` VALUES (26067, '59.76.15595886891306949', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:49', 13, 0, '', '2019-06-04 03:04:49');
INSERT INTO `access_log` VALUES (26068, '66.55.15595886900545617', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:50', 14, 0, '', '2019-06-04 03:04:50');
INSERT INTO `access_log` VALUES (26069, '64.77.15595886909306635', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:51', 11, 0, '', '2019-06-04 03:04:51');
INSERT INTO `access_log` VALUES (26070, '64.81.15595886919026627', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:52', 28, 0, '', '2019-06-04 03:04:52');
INSERT INTO `access_log` VALUES (26071, '64.82.15595886919086639', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:52', 21, 0, '', '2019-06-04 03:04:52');
INSERT INTO `access_log` VALUES (26072, '64.76.15595886919016621', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:52', 37, 0, '', '2019-06-04 03:04:52');
INSERT INTO `access_log` VALUES (26073, '64.84.15595886929286633', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:53', 11, 0, '', '2019-06-04 03:04:53');
INSERT INTO `access_log` VALUES (26074, '64.78.15595886929286633', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:53', 12, 0, '', '2019-06-04 03:04:53');
INSERT INTO `access_log` VALUES (26075, '62.82.15595886937266815', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.226.185.95', '2019-06-04 03:04:54', 12, 0, '', '2019-06-04 03:04:54');
INSERT INTO `access_log` VALUES (26076, '59.77.15595910322486977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.88.132.252', '2019-06-04 03:43:52', 11, 0, '', '2019-06-04 03:43:52');
INSERT INTO `access_log` VALUES (26077, '59.72.15595910322486983', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.88.132.252', '2019-06-04 03:43:52', 28, 2001001000, '服务端发生异常', '2019-06-04 03:43:52');
INSERT INTO `access_log` VALUES (26078, '59.78.15596050930147177', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.133.241.226', '2019-06-04 07:38:13', 17, 0, '', '2019-06-04 07:38:13');
INSERT INTO `access_log` VALUES (26079, '59.77.15596050930147165', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.133.241.226', '2019-06-04 07:38:13', 34, 2001001000, '服务端发生异常', '2019-06-04 07:38:13');
INSERT INTO `access_log` VALUES (26080, '64.79.15596050966296845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.133.241.226', '2019-06-04 07:38:17', 280, 0, '', '2019-06-04 07:38:17');
INSERT INTO `access_log` VALUES (26081, '64.77.15596050970426855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.133.241.226', '2019-06-04 07:38:17', 3, 0, '', '2019-06-04 07:38:17');
INSERT INTO `access_log` VALUES (26082, '64.82.15596050984916859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.133.241.226', '2019-06-04 07:38:18', 2, 0, '', '2019-06-04 07:38:18');
INSERT INTO `access_log` VALUES (26083, '64.81.15596050990556847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.133.241.226', '2019-06-04 07:38:19', 2, 0, '', '2019-06-04 07:38:19');
INSERT INTO `access_log` VALUES (26084, '59.75.15596063437577191', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:04', 4, 0, '', '2019-06-04 07:59:04');
INSERT INTO `access_log` VALUES (26085, '59.71.15596063437757195', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:04', 21, 2001001000, '服务端发生异常', '2019-06-04 07:59:04');
INSERT INTO `access_log` VALUES (26086, '59.78.15596063698507195', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:30', 3, 0, '', '2019-06-04 07:59:30');
INSERT INTO `access_log` VALUES (26087, '59.80.15596063698497183', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:30', 18, 2001001000, '服务端发生异常', '2019-06-04 07:59:30');
INSERT INTO `access_log` VALUES (26088, '64.83.15596063721806863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:32', 3, 0, '', '2019-06-04 07:59:32');
INSERT INTO `access_log` VALUES (26089, '64.79.15596063723736863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:32', 2, 0, '', '2019-06-04 07:59:32');
INSERT INTO `access_log` VALUES (26090, '64.77.15596063743886873', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:34', 2, 0, '', '2019-06-04 07:59:34');
INSERT INTO `access_log` VALUES (26091, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:34', 14, 0, '', '2019-06-04 07:59:34');
INSERT INTO `access_log` VALUES (26092, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:37', 6, 0, '', '2019-06-04 07:59:37');
INSERT INTO `access_log` VALUES (26093, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:38', 8, 0, '', '2019-06-04 07:59:38');
INSERT INTO `access_log` VALUES (26094, '64.81.15596063788176865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:39', 2, 0, '', '2019-06-04 07:59:39');
INSERT INTO `access_log` VALUES (26095, '64.76.15596063789936859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:39', 2, 0, '', '2019-06-04 07:59:39');
INSERT INTO `access_log` VALUES (26096, '64.78.15596063799056871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:40', 2, 0, '', '2019-06-04 07:59:40');
INSERT INTO `access_log` VALUES (26097, '64.84.15596063811466871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:41', 2, 0, '', '2019-06-04 07:59:41');
INSERT INTO `access_log` VALUES (26098, '64.80.15596063828386863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:43', 2, 0, '', '2019-06-04 07:59:43');
INSERT INTO `access_log` VALUES (26099, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:43', 7, 0, '', '2019-06-04 07:59:43');
INSERT INTO `access_log` VALUES (26100, '64.85.15596063859576885', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:46', 37, 0, '', '2019-06-04 07:59:46');
INSERT INTO `access_log` VALUES (26101, '64.79.15596063924196865', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 07:59:52', 7, 0, '', '2019-06-04 07:59:52');
INSERT INTO `access_log` VALUES (26102, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 08:00:00', 7, 0, '', '2019-06-04 08:00:00');
INSERT INTO `access_log` VALUES (26103, '64.77.15596064000516875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 08:00:00', 9, 0, '', '2019-06-04 08:00:00');
INSERT INTO `access_log` VALUES (26104, '64.81.15596064059956867', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 08:00:06', 2, 0, '', '2019-06-04 08:00:06');
INSERT INTO `access_log` VALUES (26105, '64.76.15596064061466861', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 08:00:06', 2, 0, '', '2019-06-04 08:00:06');
INSERT INTO `access_log` VALUES (26106, '59.76.15596064071437187', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 08:00:07', 4, 0, '', '2019-06-04 08:00:07');
INSERT INTO `access_log` VALUES (26107, '59.75.15596064071617193', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 08:00:07', 12, 2001001000, '服务端发生异常', '2019-06-04 08:00:07');
INSERT INTO `access_log` VALUES (26108, '59.79.15596064104627193', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 08:00:10', 3, 0, '', '2019-06-04 08:00:10');
INSERT INTO `access_log` VALUES (26109, '59.71.15596064104587197', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.0.0; zh-CN; PRO 6 Plus Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.1.111 Mobile Safari/537.36', '183.195.9.94', '2019-06-04 08:00:10', 18, 2001001000, '服务端发生异常', '2019-06-04 08:00:10');
INSERT INTO `access_log` VALUES (26110, '65.47.15596081877097153', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:29:48', 1, 1002001015, '账号未登陆', '2019-06-04 08:29:48');
INSERT INTO `access_log` VALUES (26111, '65.53.15596081877107135', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:29:48', 1, 1002001015, '账号未登陆', '2019-06-04 08:29:48');
INSERT INTO `access_log` VALUES (26112, '65.50.15596081877097165', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:29:48', 1, 1002001015, '账号未登陆', '2019-06-04 08:29:48');
INSERT INTO `access_log` VALUES (26113, '65.46.15596081900237155', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:29:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 08:29:50');
INSERT INTO `access_log` VALUES (26114, '65.54.15596081994297127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:29:59', 188, 0, '', '2019-06-04 08:30:00');
INSERT INTO `access_log` VALUES (26115, '65.52.15596081998907151', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:30:00', 13, 0, '', '2019-06-04 08:30:00');
INSERT INTO `access_log` VALUES (26116, '65.49.15596081998907177', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:30:00', 13, 0, '', '2019-06-04 08:30:00');
INSERT INTO `access_log` VALUES (26117, '65.48.15596081998917163', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:30:00', 12, 0, '', '2019-06-04 08:30:00');
INSERT INTO `access_log` VALUES (26118, '62.85.15596082084187067', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:30:08', 988, 0, '', '2019-06-04 08:30:09');
INSERT INTO `access_log` VALUES (26119, '64.84.15596082159146897', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:30:16', 20, 0, '', '2019-06-04 08:30:16');
INSERT INTO `access_log` VALUES (26120, '64.78.15596082159136897', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:30:16', 23, 0, '', '2019-06-04 08:30:16');
INSERT INTO `access_log` VALUES (26121, '65.50.15596082208377167', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:30:21', 4, 0, '', '2019-06-04 08:30:21');
INSERT INTO `access_log` VALUES (26122, '65.53.15596082282017137', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:30:28', 4, 0, '', '2019-06-04 08:30:28');
INSERT INTO `access_log` VALUES (26123, '64.78.15596083344266899', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:32:14', 14, 0, '', '2019-06-04 08:32:14');
INSERT INTO `access_log` VALUES (26124, '64.84.15596083344226899', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:32:14', 18, 0, '', '2019-06-04 08:32:14');
INSERT INTO `access_log` VALUES (26125, '64.85.15596083374636913', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:32:17', 14, 0, '', '2019-06-04 08:32:17');
INSERT INTO `access_log` VALUES (26126, '64.80.15596083374636891', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:32:17', 19, 0, '', '2019-06-04 08:32:17');
INSERT INTO `access_log` VALUES (26127, '64.83.15596083374746893', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:32:17', 10, 0, '', '2019-06-04 08:32:17');
INSERT INTO `access_log` VALUES (26128, '64.77.15596083461156903', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:32:26', 10, 0, '', '2019-06-04 08:32:26');
INSERT INTO `access_log` VALUES (26129, '66.54.15596083638635875', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:32:44', 21, 0, '', '2019-06-04 08:32:44');
INSERT INTO `access_log` VALUES (26130, '59.78.15596083729557223', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:32:53', 25, 0, '', '2019-06-04 08:32:53');
INSERT INTO `access_log` VALUES (26131, '59.77.15596083925257211', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:33:13', 20, 2001001000, '服务端发生异常', '2019-06-04 08:33:13');
INSERT INTO `access_log` VALUES (26132, '59.72.15596083989677217', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:33:19', 12, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-04 08:33:19');
INSERT INTO `access_log` VALUES (26133, '59.71.15596084394617225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:33:59', 34, 2001001000, '服务端发生异常', '2019-06-04 08:33:59');
INSERT INTO `access_log` VALUES (26134, '59.79.15596084394617221', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:33:59', 134, 0, '', '2019-06-04 08:34:00');
INSERT INTO `access_log` VALUES (26135, '64.83.15596084555066895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:34:16', 3, 0, '', '2019-06-04 08:34:16');
INSERT INTO `access_log` VALUES (26136, '64.79.15596084556136895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:34:16', 2, 0, '', '2019-06-04 08:34:16');
INSERT INTO `access_log` VALUES (26137, '64.77.15596084582686905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:34:18', 2, 0, '', '2019-06-04 08:34:18');
INSERT INTO `access_log` VALUES (26138, '64.82.15596084593006909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 08:34:19', 2, 0, '', '2019-06-04 08:34:19');
INSERT INTO `access_log` VALUES (26139, '65.53.15596086699877143', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.193.78.39', '2019-06-04 08:37:50', 0, 1002001015, '账号未登陆', '2019-06-04 08:37:50');
INSERT INTO `access_log` VALUES (26140, '65.46.15596086699947163', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.193.78.39', '2019-06-04 08:37:50', 0, 1002001015, '账号未登陆', '2019-06-04 08:37:50');
INSERT INTO `access_log` VALUES (26141, '65.45.15596086700057187', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.193.78.39', '2019-06-04 08:37:50', 0, 1002001015, '账号未登陆', '2019-06-04 08:37:50');
INSERT INTO `access_log` VALUES (26142, '65.49.15596086783117185', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.193.78.39', '2019-06-04 08:37:58', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 08:37:58');
INSERT INTO `access_log` VALUES (26143, '65.48.15596086830007171', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.193.78.39', '2019-06-04 08:38:03', 70, 0, '', '2019-06-04 08:38:03');
INSERT INTO `access_log` VALUES (26144, '65.52.15596086834487159', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.193.78.39', '2019-06-04 08:38:03', 11, 0, '', '2019-06-04 08:38:03');
INSERT INTO `access_log` VALUES (26145, '65.51.15596086834527169', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.193.78.39', '2019-06-04 08:38:03', 9, 0, '', '2019-06-04 08:38:03');
INSERT INTO `access_log` VALUES (26146, '65.50.15596086835277175', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.193.78.39', '2019-06-04 08:38:04', 315, 0, '', '2019-06-04 08:38:04');
INSERT INTO `access_log` VALUES (26147, '64.83.15596086952296899', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.193.78.39', '2019-06-04 08:38:15', 388, 0, '', '2019-06-04 08:38:16');
INSERT INTO `access_log` VALUES (26148, '59.79.15596086999827225', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.193.78.39', '2019-06-04 08:38:20', 224, 0, '', '2019-06-04 08:38:20');
INSERT INTO `access_log` VALUES (26149, '59.71.15596087130297229', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.193.78.39', '2019-06-04 08:38:33', 3, 0, '', '2019-06-04 08:38:33');
INSERT INTO `access_log` VALUES (26150, '59.74.15596087130337221', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.193.78.39', '2019-06-04 08:38:33', 16, 2001001000, '服务端发生异常', '2019-06-04 08:38:33');
INSERT INTO `access_log` VALUES (26151, '64.82.15596087179446913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.193.78.39', '2019-06-04 08:38:38', 2, 0, '', '2019-06-04 08:38:38');
INSERT INTO `access_log` VALUES (26152, '64.81.15596087180626901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.193.78.39', '2019-06-04 08:38:38', 2, 0, '', '2019-06-04 08:38:38');
INSERT INTO `access_log` VALUES (26153, '65.46.15596089793827169', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:42:59', 1, 1002001015, '账号未登陆', '2019-06-04 08:42:59');
INSERT INTO `access_log` VALUES (26154, '65.47.15596089793597167', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:42:59', 0, 1002001015, '账号未登陆', '2019-06-04 08:42:59');
INSERT INTO `access_log` VALUES (26155, '65.53.15596089793727149', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:42:59', 0, 1002001015, '账号未登陆', '2019-06-04 08:42:59');
INSERT INTO `access_log` VALUES (26156, '65.45.15596089888587193', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:43:09', 61, 0, '', '2019-06-04 08:43:09');
INSERT INTO `access_log` VALUES (26157, '65.49.15596089893617191', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:43:09', 10, 0, '', '2019-06-04 08:43:09');
INSERT INTO `access_log` VALUES (26158, '65.48.15596089893617177', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:43:09', 10, 0, '', '2019-06-04 08:43:09');
INSERT INTO `access_log` VALUES (26159, '65.52.15596089893657165', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:43:09', 9, 0, '', '2019-06-04 08:43:09');
INSERT INTO `access_log` VALUES (26160, '62.84.15596089979237069', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:43:18', 14, 0, '', '2019-06-04 08:43:18');
INSERT INTO `access_log` VALUES (26161, '64.81.15596090023896905', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:43:22', 12, 0, '', '2019-06-04 08:43:22');
INSERT INTO `access_log` VALUES (26162, '64.76.15596090023976899', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:43:22', 8, 0, '', '2019-06-04 08:43:22');
INSERT INTO `access_log` VALUES (26163, '64.84.15596090083226911', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:43:28', 183, 0, '', '2019-06-04 08:43:29');
INSERT INTO `access_log` VALUES (26164, '64.78.15596090083136911', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:43:28', 195, 0, '', '2019-06-04 08:43:29');
INSERT INTO `access_log` VALUES (26165, '59.80.15596090210497221', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:43:41', 16, 0, '', '2019-06-04 08:43:41');
INSERT INTO `access_log` VALUES (26166, '65.46.15596090422557171', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:44:02', 17, 0, '', '2019-06-04 08:44:02');
INSERT INTO `access_log` VALUES (26167, '65.47.15596090455037169', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:44:06', 10, 0, '', '2019-06-04 08:44:06');
INSERT INTO `access_log` VALUES (26168, '65.54.15596090478377143', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:44:08', 9, 0, '', '2019-06-04 08:44:08');
INSERT INTO `access_log` VALUES (26169, '65.49.15596090531227193', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:44:13', 14, 0, '', '2019-06-04 08:44:13');
INSERT INTO `access_log` VALUES (26170, '65.52.15596090587217167', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.123.64.40', '2019-06-04 08:44:19', 9, 0, '', '2019-06-04 08:44:19');
INSERT INTO `access_log` VALUES (26171, '65.45.15596091646387197', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-04 08:46:05', 4, 1002001012, '访问令牌已过期', '2019-06-04 08:46:05');
INSERT INTO `access_log` VALUES (26172, '65.52.15596091722187169', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-04 08:46:12', 102, 0, '', '2019-06-04 08:46:12');
INSERT INTO `access_log` VALUES (26173, '65.48.15596091726887181', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-04 08:46:13', 9, 0, '', '2019-06-04 08:46:13');
INSERT INTO `access_log` VALUES (26174, '65.51.15596091726967179', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-04 08:46:13', 9, 0, '', '2019-06-04 08:46:13');
INSERT INTO `access_log` VALUES (26175, '65.50.15596091727007185', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-04 08:46:13', 9, 0, '', '2019-06-04 08:46:13');
INSERT INTO `access_log` VALUES (26176, '65.53.15596091755637155', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-04 08:46:16', 16, 0, '', '2019-06-04 08:46:16');
INSERT INTO `access_log` VALUES (26177, '65.47.15596091869747173', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-04 08:46:27', 11, 0, '', '2019-06-04 08:46:27');
INSERT INTO `access_log` VALUES (26178, '65.54.15596091873817147', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-04 08:46:27', 28, 0, '', '2019-06-04 08:46:27');
INSERT INTO `access_log` VALUES (26179, '65.45.15596091879607199', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-04 08:46:28', 10, 0, '', '2019-06-04 08:46:28');
INSERT INTO `access_log` VALUES (26180, '65.49.15596091884897197', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-04 08:46:28', 19, 0, '', '2019-06-04 08:46:29');
INSERT INTO `access_log` VALUES (26181, '65.52.15596091909477171', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.40.187', '2019-06-04 08:46:31', 12, 0, '', '2019-06-04 08:46:31');
INSERT INTO `access_log` VALUES (26182, '65.52.15596097833237179', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.120.186', '2019-06-04 08:56:23', 1, 1002001015, '账号未登陆', '2019-06-04 08:56:23');
INSERT INTO `access_log` VALUES (26183, '65.51.15596097833257189', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.120.186', '2019-06-04 08:56:23', 0, 1002001015, '账号未登陆', '2019-06-04 08:56:23');
INSERT INTO `access_log` VALUES (26184, '65.48.15596097833297191', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.120.186', '2019-06-04 08:56:23', 0, 1002001015, '账号未登陆', '2019-06-04 08:56:23');
INSERT INTO `access_log` VALUES (26185, '65.53.15596097889377165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.120.186', '2019-06-04 08:56:29', 199, 0, '', '2019-06-04 08:56:29');
INSERT INTO `access_log` VALUES (26186, '65.46.15596097893477185', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.120.186', '2019-06-04 08:56:29', 9, 0, '', '2019-06-04 08:56:29');
INSERT INTO `access_log` VALUES (26187, '65.47.15596097893527183', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.120.186', '2019-06-04 08:56:29', 9, 0, '', '2019-06-04 08:56:29');
INSERT INTO `access_log` VALUES (26188, '65.54.15596097893577157', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.120.186', '2019-06-04 08:56:29', 9, 0, '', '2019-06-04 08:56:29');
INSERT INTO `access_log` VALUES (26189, '62.86.15596097948317081', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.120.186', '2019-06-04 08:56:35', 13, 0, '', '2019-06-04 08:56:35');
INSERT INTO `access_log` VALUES (26190, '64.77.15596098002506925', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.120.186', '2019-06-04 08:56:40', 10, 0, '', '2019-06-04 08:56:40');
INSERT INTO `access_log` VALUES (26191, '64.79.15596098002496915', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.120.186', '2019-06-04 08:56:40', 12, 0, '', '2019-06-04 08:56:40');
INSERT INTO `access_log` VALUES (26192, '64.76.15596098021386911', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.120.186', '2019-06-04 08:56:42', 24, 0, '', '2019-06-04 08:56:42');
INSERT INTO `access_log` VALUES (26193, '64.82.15596098021356929', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.120.186', '2019-06-04 08:56:42', 28, 0, '', '2019-06-04 08:56:42');
INSERT INTO `access_log` VALUES (26194, '65.49.15596098057437207', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.120.186', '2019-06-04 08:56:46', 16, 0, '', '2019-06-04 08:56:46');
INSERT INTO `access_log` VALUES (26195, '65.52.15596098127417181', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.120.186', '2019-06-04 08:56:53', 10, 0, '', '2019-06-04 08:56:53');
INSERT INTO `access_log` VALUES (26196, '65.54.15596098789857159', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:57:59', 1, 1002001015, '账号未登陆', '2019-06-04 08:57:59');
INSERT INTO `access_log` VALUES (26197, '65.46.15596098789877187', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:57:59', 1, 1002001015, '账号未登陆', '2019-06-04 08:57:59');
INSERT INTO `access_log` VALUES (26198, '65.45.15596098790047211', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:57:59', 1, 1002001015, '账号未登陆', '2019-06-04 08:57:59');
INSERT INTO `access_log` VALUES (26199, '65.49.15596098830377209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:58:03', 87, 0, '', '2019-06-04 08:58:03');
INSERT INTO `access_log` VALUES (26200, '65.52.15596098833187183', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:58:03', 9, 0, '', '2019-06-04 08:58:03');
INSERT INTO `access_log` VALUES (26201, '65.48.15596098833217195', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:58:03', 9, 0, '', '2019-06-04 08:58:03');
INSERT INTO `access_log` VALUES (26202, '65.51.15596098833277193', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:58:03', 8, 0, '', '2019-06-04 08:58:03');
INSERT INTO `access_log` VALUES (26203, '65.50.15596098883447199', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:58:08', 9, 0, '', '2019-06-04 08:58:08');
INSERT INTO `access_log` VALUES (26204, '65.53.15596098883467169', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:58:08', 8, 0, '', '2019-06-04 08:58:08');
INSERT INTO `access_log` VALUES (26205, '65.47.15596098883517187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:58:08', 8, 0, '', '2019-06-04 08:58:08');
INSERT INTO `access_log` VALUES (26206, '62.83.15596098913947093', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:58:11', 13, 0, '', '2019-06-04 08:58:11');
INSERT INTO `access_log` VALUES (26207, '62.82.15596098939437099', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:58:14', 17, 0, '', '2019-06-04 08:58:14');
INSERT INTO `access_log` VALUES (26208, '65.45.15596099005197213', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:58:21', 19, 0, '', '2019-06-04 08:58:21');
INSERT INTO `access_log` VALUES (26209, '65.54.15596099033167161', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:58:23', 10, 0, '', '2019-06-04 08:58:23');
INSERT INTO `access_log` VALUES (26210, '59.80.15596099083827233', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:58:28', 14, 0, '', '2019-06-04 08:58:28');
INSERT INTO `access_log` VALUES (26211, '66.48.15596099145045901', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.228.86.9', '2019-06-04 08:58:35', 19, 0, '', '2019-06-04 08:58:35');
INSERT INTO `access_log` VALUES (26212, '65.52.15596099163727185', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:58:36', 1, 1002001015, '账号未登陆', '2019-06-04 08:58:36');
INSERT INTO `access_log` VALUES (26213, '65.48.15596099163977197', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:58:36', 0, 1002001015, '账号未登陆', '2019-06-04 08:58:36');
INSERT INTO `access_log` VALUES (26214, '65.51.15596099164077195', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:58:36', 0, 1002001015, '账号未登陆', '2019-06-04 08:58:36');
INSERT INTO `access_log` VALUES (26215, '65.53.15596099193347171', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:58:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 08:58:39');
INSERT INTO `access_log` VALUES (26216, '65.50.15596099251267201', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:58:45', 73, 0, '', '2019-06-04 08:58:45');
INSERT INTO `access_log` VALUES (26217, '65.46.15596099255487191', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:58:46', 9, 0, '', '2019-06-04 08:58:46');
INSERT INTO `access_log` VALUES (26218, '65.45.15596099255637215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:58:46', 9, 0, '', '2019-06-04 08:58:46');
INSERT INTO `access_log` VALUES (26219, '65.54.15596099255827163', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:58:46', 9, 0, '', '2019-06-04 08:58:46');
INSERT INTO `access_log` VALUES (26220, '62.89.15596099310737093', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:58:51', 11, 0, '', '2019-06-04 08:58:51');
INSERT INTO `access_log` VALUES (26221, '62.87.15596099397477093', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:59:00', 16, 0, '', '2019-06-04 08:59:00');
INSERT INTO `access_log` VALUES (26222, '64.81.15596099492156919', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:59:09', 125, 0, '', '2019-06-04 08:59:09');
INSERT INTO `access_log` VALUES (26223, '64.84.15596099492186925', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:59:09', 124, 0, '', '2019-06-04 08:59:09');
INSERT INTO `access_log` VALUES (26224, '59.76.15596099582287237', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:59:18', 13, 0, '', '2019-06-04 08:59:18');
INSERT INTO `access_log` VALUES (26225, '59.79.15596099618457243', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:59:22', 24, 2001001000, '服务端发生异常', '2019-06-04 08:59:22');
INSERT INTO `access_log` VALUES (26226, '59.71.15596099722947247', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:59:32', 15, 0, '', '2019-06-04 08:59:32');
INSERT INTO `access_log` VALUES (26227, '65.48.15596099756497199', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:59:36', 11, 0, '', '2019-06-04 08:59:36');
INSERT INTO `access_log` VALUES (26228, '65.47.15596099771207191', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:59:37', 50, 0, '', '2019-06-04 08:59:37');
INSERT INTO `access_log` VALUES (26229, '65.53.15596099784147173', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.112.26.74', '2019-06-04 08:59:38', 14, 0, '', '2019-06-04 08:59:38');
INSERT INTO `access_log` VALUES (26230, '65.53.15596102349807177', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:03:55', 0, 1002001015, '账号未登陆', '2019-06-04 09:03:55');
INSERT INTO `access_log` VALUES (26231, '65.47.15596102349807195', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:03:55', 0, 1002001015, '账号未登陆', '2019-06-04 09:03:55');
INSERT INTO `access_log` VALUES (26232, '65.50.15596102349817207', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:03:55', 0, 1002001015, '账号未登陆', '2019-06-04 09:03:55');
INSERT INTO `access_log` VALUES (26233, '65.46.15596102422377197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:04:02', 72, 0, '', '2019-06-04 09:04:02');
INSERT INTO `access_log` VALUES (26234, '65.45.15596102428767221', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:04:03', 9, 0, '', '2019-06-04 09:04:03');
INSERT INTO `access_log` VALUES (26235, '65.54.15596102428787169', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:04:03', 9, 0, '', '2019-06-04 09:04:03');
INSERT INTO `access_log` VALUES (26236, '65.49.15596102428967219', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:04:03', 9, 0, '', '2019-06-04 09:04:03');
INSERT INTO `access_log` VALUES (26237, '62.82.15596102475377105', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:04:08', 13, 0, '', '2019-06-04 09:04:08');
INSERT INTO `access_log` VALUES (26238, '59.71.15596102527177251', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:04:13', 14, 0, '', '2019-06-04 09:04:13');
INSERT INTO `access_log` VALUES (26239, '59.77.15596102894377239', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:04:49', 11, 0, '', '2019-06-04 09:04:49');
INSERT INTO `access_log` VALUES (26240, '59.72.15596102901977245', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:04:50', 11, 0, '', '2019-06-04 09:04:50');
INSERT INTO `access_log` VALUES (26241, '62.81.15596102898777087', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:04:50', 1103, 0, '', '2019-06-04 09:04:51');
INSERT INTO `access_log` VALUES (26242, '59.73.15596102972347253', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:04:57', 3, 0, '', '2019-06-04 09:04:57');
INSERT INTO `access_log` VALUES (26243, '59.76.15596102972367243', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:04:57', 13, 2001001000, '服务端发生异常', '2019-06-04 09:04:57');
INSERT INTO `access_log` VALUES (26244, '64.83.15596103043946923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:05:04', 2, 0, '', '2019-06-04 09:05:04');
INSERT INTO `access_log` VALUES (26245, '64.77.15596103045766933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:05:05', 2, 0, '', '2019-06-04 09:05:05');
INSERT INTO `access_log` VALUES (26246, '62.86.15596103076027091', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '120.204.17.70', '2019-06-04 09:05:08', 0, 1002001015, '账号未登陆', '2019-06-04 09:05:08');
INSERT INTO `access_log` VALUES (26247, '64.82.15596103120746937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:05:12', 2, 0, '', '2019-06-04 09:05:12');
INSERT INTO `access_log` VALUES (26248, '64.76.15596103122346919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:05:12', 2, 0, '', '2019-06-04 09:05:12');
INSERT INTO `access_log` VALUES (26249, '59.79.15596103142147249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:05:14', 3, 0, '', '2019-06-04 09:05:14');
INSERT INTO `access_log` VALUES (26250, '59.71.15596103142167253', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '223.104.6.34', '2019-06-04 09:05:14', 12, 2001001000, '服务端发生异常', '2019-06-04 09:05:14');
INSERT INTO `access_log` VALUES (26251, '64.80.15596103669566923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '120.204.17.73', '2019-06-04 09:06:07', 2, 0, '', '2019-06-04 09:06:07');
INSERT INTO `access_log` VALUES (26252, '65.54.15596106698397175', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:11:10', 0, 1002001015, '账号未登陆', '2019-06-04 09:11:10');
INSERT INTO `access_log` VALUES (26253, '65.52.15596106698427199', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:11:10', 1, 1002001015, '账号未登陆', '2019-06-04 09:11:10');
INSERT INTO `access_log` VALUES (26254, '65.51.15596106699707209', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:11:10', 0, 1002001015, '账号未登陆', '2019-06-04 09:11:10');
INSERT INTO `access_log` VALUES (26255, '65.47.15596107101417203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:11:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 09:11:50');
INSERT INTO `access_log` VALUES (26256, '65.46.15596107180227205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:11:58', 87, 0, '', '2019-06-04 09:11:58');
INSERT INTO `access_log` VALUES (26257, '65.49.15596107183807227', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:11:58', 10, 0, '', '2019-06-04 09:11:58');
INSERT INTO `access_log` VALUES (26258, '65.45.15596107183867229', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:11:58', 9, 0, '', '2019-06-04 09:11:58');
INSERT INTO `access_log` VALUES (26259, '65.54.15596107184347177', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:11:58', 10, 0, '', '2019-06-04 09:11:58');
INSERT INTO `access_log` VALUES (26260, '62.82.15596107258497113', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:12:06', 13, 0, '', '2019-06-04 09:12:06');
INSERT INTO `access_log` VALUES (26261, '66.54.15596107302585907', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:12:10', 14, 0, '', '2019-06-04 09:12:10');
INSERT INTO `access_log` VALUES (26262, '59.79.15596107318787255', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:12:12', 12, 0, '', '2019-06-04 09:12:12');
INSERT INTO `access_log` VALUES (26263, '59.71.15596107347677259', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:12:15', 30, 2001001000, '服务端发生异常', '2019-06-04 09:12:15');
INSERT INTO `access_log` VALUES (26264, '65.51.15596107351977211', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '110.185.172.206', '2019-06-04 09:12:15', 0, 1002001015, '账号未登陆', '2019-06-04 09:12:15');
INSERT INTO `access_log` VALUES (26265, '65.48.15596107352147213', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.212.94.23', '2019-06-04 09:12:15', 0, 1002001015, '账号未登陆', '2019-06-04 09:12:15');
INSERT INTO `access_log` VALUES (26266, '65.53.15596107352277187', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.212.94.23', '2019-06-04 09:12:15', 1, 1002001015, '账号未登陆', '2019-06-04 09:12:15');
INSERT INTO `access_log` VALUES (26267, '65.47.15596107396477205', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:12:20', 131, 0, '', '2019-06-04 09:12:20');
INSERT INTO `access_log` VALUES (26268, '65.50.15596107406957217', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:12:21', 10, 0, '', '2019-06-04 09:12:21');
INSERT INTO `access_log` VALUES (26269, '65.46.15596107419677207', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:12:22', 9, 0, '', '2019-06-04 09:12:22');
INSERT INTO `access_log` VALUES (26270, '65.45.15596107435497231', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:12:24', 12, 0, '', '2019-06-04 09:12:24');
INSERT INTO `access_log` VALUES (26271, '65.54.15596107442017179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.212.94.23', '2019-06-04 09:12:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 09:12:24');
INSERT INTO `access_log` VALUES (26272, '65.52.15596107444867203', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:12:24', 10, 0, '', '2019-06-04 09:12:24');
INSERT INTO `access_log` VALUES (26273, '65.53.15596107470397189', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:12:27', 10, 0, '', '2019-06-04 09:12:27');
INSERT INTO `access_log` VALUES (26274, '65.48.15596107516727215', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:12:32', 13, 0, '', '2019-06-04 09:12:32');
INSERT INTO `access_log` VALUES (26275, '65.51.15596107551557213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.212.94.23', '2019-06-04 09:12:35', 200, 0, '', '2019-06-04 09:12:35');
INSERT INTO `access_log` VALUES (26276, '65.46.15596107558737209', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.212.94.23', '2019-06-04 09:12:36', 406, 0, '', '2019-06-04 09:12:36');
INSERT INTO `access_log` VALUES (26277, '65.47.15596107558667207', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '110.185.172.206', '2019-06-04 09:12:36', 413, 0, '', '2019-06-04 09:12:36');
INSERT INTO `access_log` VALUES (26278, '65.50.15596107558687219', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.212.94.23', '2019-06-04 09:12:36', 721, 0, '', '2019-06-04 09:12:37');
INSERT INTO `access_log` VALUES (26279, '62.80.15596107652357109', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '110.185.172.206', '2019-06-04 09:12:45', 13, 0, '', '2019-06-04 09:12:45');
INSERT INTO `access_log` VALUES (26280, '64.84.15596107700846937', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.212.94.23', '2019-06-04 09:12:50', 11, 0, '', '2019-06-04 09:12:50');
INSERT INTO `access_log` VALUES (26281, '64.78.15596107700886937', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '110.185.172.206', '2019-06-04 09:12:50', 9, 0, '', '2019-06-04 09:12:50');
INSERT INTO `access_log` VALUES (26282, '64.83.15596107729576931', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '110.185.172.206', '2019-06-04 09:12:53', 8, 0, '', '2019-06-04 09:12:53');
INSERT INTO `access_log` VALUES (26283, '64.80.15596107729546929', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.212.94.23', '2019-06-04 09:12:53', 12, 0, '', '2019-06-04 09:12:53');
INSERT INTO `access_log` VALUES (26284, '64.77.15596107791756941', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '110.185.172.206', '2019-06-04 09:12:59', 10, 0, '', '2019-06-04 09:12:59');
INSERT INTO `access_log` VALUES (26285, '64.78.15596108363206939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '115.60.62.110', '2019-06-04 09:13:56', 3, 0, '', '2019-06-04 09:13:56');
INSERT INTO `access_log` VALUES (26286, '64.84.15596108365026939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '115.60.62.110', '2019-06-04 09:13:57', 212, 0, '', '2019-06-04 09:13:57');
INSERT INTO `access_log` VALUES (26287, '59.75.15596108373787257', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '115.60.62.110', '2019-06-04 09:13:57', 4, 0, '', '2019-06-04 09:13:57');
INSERT INTO `access_log` VALUES (26288, '59.79.15596108380067257', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '115.60.62.110', '2019-06-04 09:13:58', 13, 2001001000, '服务端发生异常', '2019-06-04 09:13:58');
INSERT INTO `access_log` VALUES (26289, '59.74.15596108523697253', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-04 09:14:12', 9, 1002001012, '访问令牌已过期', '2019-06-04 09:14:12');
INSERT INTO `access_log` VALUES (26290, '66.51.15596108524855903', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.60.62.110', '2019-06-04 09:14:12', 66, 0, '', '2019-06-04 09:14:13');
INSERT INTO `access_log` VALUES (26291, '65.47.15596108540827209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.64.2.110', '2019-06-04 09:14:14', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 09:14:14');
INSERT INTO `access_log` VALUES (26292, '65.46.15596108633307211', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.35.133.115', '2019-06-04 09:14:23', 1, 1002001015, '账号未登陆', '2019-06-04 09:14:23');
INSERT INTO `access_log` VALUES (26293, '65.50.15596108633307221', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.35.133.115', '2019-06-04 09:14:23', 0, 1002001015, '账号未登陆', '2019-06-04 09:14:23');
INSERT INTO `access_log` VALUES (26294, '65.45.15596108633367235', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.35.133.115', '2019-06-04 09:14:23', 0, 1002001015, '账号未登陆', '2019-06-04 09:14:23');
INSERT INTO `access_log` VALUES (26295, '65.54.15596108659517183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.35.133.115', '2019-06-04 09:14:26', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 09:14:26');
INSERT INTO `access_log` VALUES (26296, '65.52.15596108686627207', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.35.133.115', '2019-06-04 09:14:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 09:14:29');
INSERT INTO `access_log` VALUES (26297, '65.51.15596109013867217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.35.133.115', '2019-06-04 09:15:01', 153, 0, '', '2019-06-04 09:15:02');
INSERT INTO `access_log` VALUES (26298, '65.50.15596109138677223', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:15:14', 0, 1002001015, '账号未登陆', '2019-06-04 09:15:14');
INSERT INTO `access_log` VALUES (26299, '65.46.15596109138707213', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:15:14', 1, 1002001015, '账号未登陆', '2019-06-04 09:15:14');
INSERT INTO `access_log` VALUES (26300, '65.45.15596109138737237', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:15:14', 0, 1002001015, '账号未登陆', '2019-06-04 09:15:14');
INSERT INTO `access_log` VALUES (26301, '65.49.15596109191867235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:15:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 09:15:19');
INSERT INTO `access_log` VALUES (26302, '65.52.15596109258207209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:15:26', 106, 0, '', '2019-06-04 09:15:26');
INSERT INTO `access_log` VALUES (26303, '65.48.15596109261977221', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:15:26', 181, 0, '', '2019-06-04 09:15:26');
INSERT INTO `access_log` VALUES (26304, '65.51.15596109262027219', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:15:26', 176, 0, '', '2019-06-04 09:15:26');
INSERT INTO `access_log` VALUES (26305, '65.53.15596109261957195', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:15:26', 187, 0, '', '2019-06-04 09:15:26');
INSERT INTO `access_log` VALUES (26306, '62.81.15596109323967097', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:15:32', 11, 0, '', '2019-06-04 09:15:32');
INSERT INTO `access_log` VALUES (26307, '64.81.15596109395046935', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:15:40', 11, 0, '', '2019-06-04 09:15:40');
INSERT INTO `access_log` VALUES (26308, '64.78.15596109395086941', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:15:40', 8, 0, '', '2019-06-04 09:15:40');
INSERT INTO `access_log` VALUES (26309, '59.71.15596109703847263', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 09:16:10', 3, 0, '', '2019-06-04 09:16:10');
INSERT INTO `access_log` VALUES (26310, '59.74.15596109703857255', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 09:16:10', 18, 2001001000, '服务端发生异常', '2019-06-04 09:16:10');
INSERT INTO `access_log` VALUES (26311, '65.50.15596109741517225', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:16:14', 218, 0, '', '2019-06-04 09:16:14');
INSERT INTO `access_log` VALUES (26312, '65.49.15596109746717237', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:16:15', 8, 0, '', '2019-06-04 09:16:15');
INSERT INTO `access_log` VALUES (26313, '65.54.15596109746747187', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:16:15', 8, 0, '', '2019-06-04 09:16:15');
INSERT INTO `access_log` VALUES (26314, '65.52.15596109746767211', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:16:15', 8, 0, '', '2019-06-04 09:16:15');
INSERT INTO `access_log` VALUES (26315, '64.80.15596109757696933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 09:16:16', 2, 0, '', '2019-06-04 09:16:16');
INSERT INTO `access_log` VALUES (26316, '64.83.15596109758726935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 09:16:16', 2, 0, '', '2019-06-04 09:16:16');
INSERT INTO `access_log` VALUES (26317, '64.79.15596109780666935', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:16:18', 9, 0, '', '2019-06-04 09:16:18');
INSERT INTO `access_log` VALUES (26318, '64.77.15596109780666945', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:16:18', 11, 0, '', '2019-06-04 09:16:18');
INSERT INTO `access_log` VALUES (26319, '64.82.15596109781776949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 09:16:18', 2, 0, '', '2019-06-04 09:16:18');
INSERT INTO `access_log` VALUES (26320, '64.81.15596109806876937', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:16:21', 9, 0, '', '2019-06-04 09:16:21');
INSERT INTO `access_log` VALUES (26321, '66.51.15596109815575905', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 09:16:22', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-04 09:16:22');
INSERT INTO `access_log` VALUES (26322, '59.80.15596109924307251', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.25.63', '2019-06-04 09:16:32', 12, 0, '', '2019-06-04 09:16:32');
INSERT INTO `access_log` VALUES (26323, '59.74.15596110843987257', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.212.94.23', '2019-06-04 09:18:04', 11, 0, '', '2019-06-04 09:18:04');
INSERT INTO `access_log` VALUES (26324, '65.52.15596110900897213', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.212.94.23', '2019-06-04 09:18:10', 21, 0, '', '2019-06-04 09:18:10');
INSERT INTO `access_log` VALUES (26325, '65.49.15596110990297239', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.212.94.23', '2019-06-04 09:18:19', 10, 0, '', '2019-06-04 09:18:19');
INSERT INTO `access_log` VALUES (26326, '65.51.15596111009197223', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.212.94.23', '2019-06-04 09:18:21', 10, 0, '', '2019-06-04 09:18:21');
INSERT INTO `access_log` VALUES (26327, '65.48.15596111023217225', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.212.94.23', '2019-06-04 09:18:22', 15, 0, '', '2019-06-04 09:18:22');
INSERT INTO `access_log` VALUES (26328, '59.76.15596117698177265', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 09:29:30', 4, 0, '', '2019-06-04 09:29:30');
INSERT INTO `access_log` VALUES (26329, '59.75.15596117698177271', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 09:29:30', 41, 2001001000, '服务端发生异常', '2019-06-04 09:29:30');
INSERT INTO `access_log` VALUES (26330, '59.72.15596119931687271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '59.53.175.21', '2019-06-04 09:33:13', 4, 0, '', '2019-06-04 09:33:13');
INSERT INTO `access_log` VALUES (26331, '59.77.15596119931687265', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '59.53.175.21', '2019-06-04 09:33:13', 21, 2001001000, '服务端发生异常', '2019-06-04 09:33:13');
INSERT INTO `access_log` VALUES (26332, '59.80.15596122394457269', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.183.81.6', '2019-06-04 09:37:19', 4, 0, '', '2019-06-04 09:37:19');
INSERT INTO `access_log` VALUES (26333, '59.77.15596122394497269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.183.81.6', '2019-06-04 09:37:19', 18, 2001001000, '服务端发生异常', '2019-06-04 09:37:19');
INSERT INTO `access_log` VALUES (26334, '64.83.15596122448436953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.183.81.6', '2019-06-04 09:37:25', 3, 0, '', '2019-06-04 09:37:25');
INSERT INTO `access_log` VALUES (26335, '64.77.15596122449606963', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.183.81.6', '2019-06-04 09:37:25', 2, 0, '', '2019-06-04 09:37:25');
INSERT INTO `access_log` VALUES (26336, '64.79.15596122462096953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.183.81.6', '2019-06-04 09:37:26', 2, 0, '', '2019-06-04 09:37:26');
INSERT INTO `access_log` VALUES (26337, '64.82.15596122468126967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.183.81.6', '2019-06-04 09:37:27', 2, 0, '', '2019-06-04 09:37:27');
INSERT INTO `access_log` VALUES (26338, '65.50.15596123523027245', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:39:12', 815, 1002001012, '访问令牌已过期', '2019-06-04 09:39:13');
INSERT INTO `access_log` VALUES (26339, '65.52.15596123523237231', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:39:12', 795, 1002001012, '访问令牌已过期', '2019-06-04 09:39:13');
INSERT INTO `access_log` VALUES (26340, '65.54.15596123523027207', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:39:12', 815, 1002001012, '访问令牌已过期', '2019-06-04 09:39:13');
INSERT INTO `access_log` VALUES (26341, '65.49.15596123551787257', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:39:15', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 09:39:15');
INSERT INTO `access_log` VALUES (26342, '65.48.15596123698947243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:39:30', 75, 0, '', '2019-06-04 09:39:30');
INSERT INTO `access_log` VALUES (26343, '65.47.15596123701897235', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:39:30', 9, 0, '', '2019-06-04 09:39:30');
INSERT INTO `access_log` VALUES (26344, '65.53.15596123701887217', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:39:30', 10, 0, '', '2019-06-04 09:39:30');
INSERT INTO `access_log` VALUES (26345, '65.45.15596123701897261', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:39:30', 10, 0, '', '2019-06-04 09:39:30');
INSERT INTO `access_log` VALUES (26346, '65.52.15596123907807233', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:39:51', 128, 0, '', '2019-06-04 09:39:51');
INSERT INTO `access_log` VALUES (26347, '65.50.15596123918807247', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:39:52', 11, 0, '', '2019-06-04 09:39:52');
INSERT INTO `access_log` VALUES (26348, '65.54.15596123926237209', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:39:53', 1156, 0, '', '2019-06-04 09:39:54');
INSERT INTO `access_log` VALUES (26349, '65.51.15596123942387243', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:39:54', 845, 0, '', '2019-06-04 09:39:55');
INSERT INTO `access_log` VALUES (26350, '59.72.15596123969387277', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:39:57', 11, 0, '', '2019-06-04 09:39:57');
INSERT INTO `access_log` VALUES (26351, '66.56.15596123999745923', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:40:00', 14, 0, '', '2019-06-04 09:40:00');
INSERT INTO `access_log` VALUES (26352, '64.76.15596124054606951', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:40:05', 11, 0, '', '2019-06-04 09:40:05');
INSERT INTO `access_log` VALUES (26353, '64.81.15596124054606957', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:40:05', 12, 0, '', '2019-06-04 09:40:05');
INSERT INTO `access_log` VALUES (26354, '62.82.15596124096407137', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:40:10', 406, 0, '', '2019-06-04 09:40:10');
INSERT INTO `access_log` VALUES (26355, '62.86.15596124121577121', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '112.243.127.236', '2019-06-04 09:40:12', 14, 0, '', '2019-06-04 09:40:12');
INSERT INTO `access_log` VALUES (26356, '59.72.15596125312307279', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.17.91', '2019-06-04 09:42:11', 4, 0, '', '2019-06-04 09:42:11');
INSERT INTO `access_log` VALUES (26357, '59.73.15596125312327287', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.17.91', '2019-06-04 09:42:11', 18, 2001001000, '服务端发生异常', '2019-06-04 09:42:11');
INSERT INTO `access_log` VALUES (26358, '59.76.15596125365907277', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.119.143.186', '2019-06-04 09:42:17', 3, 0, '', '2019-06-04 09:42:17');
INSERT INTO `access_log` VALUES (26359, '59.75.15596125365907283', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.119.143.186', '2019-06-04 09:42:17', 13, 2001001000, '服务端发生异常', '2019-06-04 09:42:17');
INSERT INTO `access_log` VALUES (26360, '64.81.15596125393436959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.119.143.186', '2019-06-04 09:42:19', 2, 0, '', '2019-06-04 09:42:19');
INSERT INTO `access_log` VALUES (26361, '64.76.15596125394656953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.119.143.186', '2019-06-04 09:42:19', 1, 0, '', '2019-06-04 09:42:19');
INSERT INTO `access_log` VALUES (26362, '64.85.15596125422246979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.119.143.186', '2019-06-04 09:42:22', 3, 0, '', '2019-06-04 09:42:22');
INSERT INTO `access_log` VALUES (26363, '64.80.15596125423516957', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.119.143.186', '2019-06-04 09:42:22', 1, 0, '', '2019-06-04 09:42:22');
INSERT INTO `access_log` VALUES (26364, '64.83.15596125429196959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.119.143.186', '2019-06-04 09:42:23', 2, 0, '', '2019-06-04 09:42:23');
INSERT INTO `access_log` VALUES (26365, '64.77.15596125433796969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.119.143.186', '2019-06-04 09:42:23', 2, 0, '', '2019-06-04 09:42:23');
INSERT INTO `access_log` VALUES (26366, '64.79.15596125454206959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.119.143.186', '2019-06-04 09:42:25', 1, 0, '', '2019-06-04 09:42:25');
INSERT INTO `access_log` VALUES (26367, '64.82.15596125455536973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.119.143.186', '2019-06-04 09:42:26', 2, 0, '', '2019-06-04 09:42:26');
INSERT INTO `access_log` VALUES (26368, '65.45.15596125462097265', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.17.91', '2019-06-04 09:42:26', 1, 1002001015, '账号未登陆', '2019-06-04 09:42:26');
INSERT INTO `access_log` VALUES (26369, '65.48.15596125462097247', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.17.91', '2019-06-04 09:42:26', 1, 1002001015, '账号未登陆', '2019-06-04 09:42:26');
INSERT INTO `access_log` VALUES (26370, '65.47.15596125462117239', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.17.91', '2019-06-04 09:42:26', 0, 1002001015, '账号未登陆', '2019-06-04 09:42:26');
INSERT INTO `access_log` VALUES (26371, '59.71.15596125478647287', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.119.143.186', '2019-06-04 09:42:28', 2, 0, '', '2019-06-04 09:42:28');
INSERT INTO `access_log` VALUES (26372, '59.74.15596125478657279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.119.143.186', '2019-06-04 09:42:28', 12, 2001001000, '服务端发生异常', '2019-06-04 09:42:28');
INSERT INTO `access_log` VALUES (26373, '65.53.15596125483457221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.17.91', '2019-06-04 09:42:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 09:42:28');
INSERT INTO `access_log` VALUES (26374, '59.72.15596125912417281', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:43:11', 2, 0, '', '2019-06-04 09:43:11');
INSERT INTO `access_log` VALUES (26375, '59.73.15596125923317289', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:43:12', 12, 2001001000, '服务端发生异常', '2019-06-04 09:43:12');
INSERT INTO `access_log` VALUES (26376, '65.49.15596126014467263', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '59.53.175.21', '2019-06-04 09:43:21', 0, 1002001015, '账号未登陆', '2019-06-04 09:43:21');
INSERT INTO `access_log` VALUES (26377, '65.54.15596126014507213', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '59.53.175.21', '2019-06-04 09:43:21', 0, 1002001015, '账号未登陆', '2019-06-04 09:43:21');
INSERT INTO `access_log` VALUES (26378, '65.51.15596126014607247', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '59.53.175.21', '2019-06-04 09:43:21', 0, 1002001015, '账号未登陆', '2019-06-04 09:43:21');
INSERT INTO `access_log` VALUES (26379, '65.45.15596126043867267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '59.53.175.21', '2019-06-04 09:43:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 09:43:24');
INSERT INTO `access_log` VALUES (26380, '59.75.15596126134267285', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:43:33', 3, 0, '', '2019-06-04 09:43:33');
INSERT INTO `access_log` VALUES (26381, '59.79.15596126134277285', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:43:33', 15, 2001001000, '服务端发生异常', '2019-06-04 09:43:33');
INSERT INTO `access_log` VALUES (26382, '64.80.15596126208096959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:43:41', 2, 0, '', '2019-06-04 09:43:41');
INSERT INTO `access_log` VALUES (26383, '64.83.15596126220176961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:43:42', 2, 0, '', '2019-06-04 09:43:42');
INSERT INTO `access_log` VALUES (26384, '64.77.15596126261116971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:43:46', 2, 0, '', '2019-06-04 09:43:46');
INSERT INTO `access_log` VALUES (26385, '65.54.15596126927237215', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:44:53', 1, 1002001015, '账号未登陆', '2019-06-04 09:44:53');
INSERT INTO `access_log` VALUES (26386, '65.49.15596126927237265', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:44:53', 1, 1002001015, '账号未登陆', '2019-06-04 09:44:53');
INSERT INTO `access_log` VALUES (26387, '65.51.15596126929717249', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:44:53', 1, 1002001015, '账号未登陆', '2019-06-04 09:44:53');
INSERT INTO `access_log` VALUES (26388, '65.53.15596127281177225', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:45:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 09:45:28');
INSERT INTO `access_log` VALUES (26389, '64.80.15596127311376961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:45:31', 2, 0, '', '2019-06-04 09:45:31');
INSERT INTO `access_log` VALUES (26390, '64.77.15596127398416973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:45:40', 2, 0, '', '2019-06-04 09:45:40');
INSERT INTO `access_log` VALUES (26391, '64.79.15596127413436963', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:45:41', 2, 0, '', '2019-06-04 09:45:41');
INSERT INTO `access_log` VALUES (26392, '65.49.15596127741017267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:46:14', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 09:46:14');
INSERT INTO `access_log` VALUES (26393, '65.48.15596128010517253', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:46:41', 728, 0, '', '2019-06-04 09:46:42');
INSERT INTO `access_log` VALUES (26394, '65.45.15596128021177271', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:46:42', 67, 0, '', '2019-06-04 09:46:42');
INSERT INTO `access_log` VALUES (26395, '65.53.15596128021207227', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:46:42', 66, 0, '', '2019-06-04 09:46:42');
INSERT INTO `access_log` VALUES (26396, '65.47.15596128021207245', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:46:42', 66, 0, '', '2019-06-04 09:46:42');
INSERT INTO `access_log` VALUES (26397, '65.49.15596128331707269', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:47:13', 10, 0, '', '2019-06-04 09:47:13');
INSERT INTO `access_log` VALUES (26398, '65.51.15596128331707253', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:47:13', 9, 0, '', '2019-06-04 09:47:13');
INSERT INTO `access_log` VALUES (26399, '65.50.15596128331707257', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:47:13', 10, 0, '', '2019-06-04 09:47:13');
INSERT INTO `access_log` VALUES (26400, '62.82.15596128411907143', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:47:21', 13, 0, '', '2019-06-04 09:47:21');
INSERT INTO `access_log` VALUES (26401, '62.85.15596128481887135', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:47:28', 16, 0, '', '2019-06-04 09:47:28');
INSERT INTO `access_log` VALUES (26402, '62.89.15596128614997137', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10&payChannel=200', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:47:42', 127, 2001001000, '服务端发生异常', '2019-06-04 09:47:42');
INSERT INTO `access_log` VALUES (26403, '64.79.15596128654716965', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:47:45', 10, 0, '', '2019-06-04 09:47:45');
INSERT INTO `access_log` VALUES (26404, '64.77.15596128654716975', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:47:45', 11, 0, '', '2019-06-04 09:47:45');
INSERT INTO `access_log` VALUES (26405, '64.76.15596128986456961', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:48:19', 9, 0, '', '2019-06-04 09:48:19');
INSERT INTO `access_log` VALUES (26406, '64.81.15596128986456967', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:48:19', 11, 0, '', '2019-06-04 09:48:19');
INSERT INTO `access_log` VALUES (26407, '64.85.15596129015176987', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:48:22', 11, 0, '', '2019-06-04 09:48:22');
INSERT INTO `access_log` VALUES (26408, '64.80.15596129016826965', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:48:22', 9, 0, '', '2019-06-04 09:48:22');
INSERT INTO `access_log` VALUES (26409, '65.46.15596129073747249', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:48:27', 20, 0, '', '2019-06-04 09:48:27');
INSERT INTO `access_log` VALUES (26410, '59.71.15596129113827293', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:48:31', 11, 0, '', '2019-06-04 09:48:31');
INSERT INTO `access_log` VALUES (26411, '65.47.15596139827687265', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 10:06:23', 0, 1002001015, '账号未登陆', '2019-06-04 10:06:23');
INSERT INTO `access_log` VALUES (26412, '65.53.15596139931387243', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 10:06:33', 1, 0, '', '2019-06-04 10:06:33');
INSERT INTO `access_log` VALUES (26413, '62.82.15596140168687159', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'createBeginTime=&createEndTime=&finishBeginTime=&finishEndTime=&pageNo=1&pageSize=10&payChannel=&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 10:06:57', 1, 1002001015, '账号未登陆', '2019-06-04 10:06:57');
INSERT INTO `access_log` VALUES (26414, '59.79.15596140741077305', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.178.155', '2019-06-04 10:07:54', 3, 0, '', '2019-06-04 10:07:54');
INSERT INTO `access_log` VALUES (26415, '59.71.15596140741237309', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.192.178.155', '2019-06-04 10:07:54', 12, 2001001000, '服务端发生异常', '2019-06-04 10:07:54');
INSERT INTO `access_log` VALUES (26416, '59.72.15596141241167303', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:08:44', 3, 0, '', '2019-06-04 10:08:44');
INSERT INTO `access_log` VALUES (26417, '59.80.15596141241167297', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:08:44', 13, 2001001000, '服务端发生异常', '2019-06-04 10:08:44');
INSERT INTO `access_log` VALUES (26418, '65.54.15596141365357239', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:08:57', 1, 1002001015, '账号未登陆', '2019-06-04 10:08:57');
INSERT INTO `access_log` VALUES (26419, '65.49.15596141365357289', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:08:57', 1, 1002001015, '账号未登陆', '2019-06-04 10:08:57');
INSERT INTO `access_log` VALUES (26420, '65.48.15596141365377273', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:08:57', 1, 1002001015, '账号未登陆', '2019-06-04 10:08:57');
INSERT INTO `access_log` VALUES (26421, '65.46.15596141385837267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:08:59', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 10:08:59');
INSERT INTO `access_log` VALUES (26422, '65.51.15596141572197273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:17', 146, 0, '', '2019-06-04 10:09:17');
INSERT INTO `access_log` VALUES (26423, '65.45.15596141576377291', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:18', 18, 0, '', '2019-06-04 10:09:18');
INSERT INTO `access_log` VALUES (26424, '65.47.15596141576407269', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:18', 10, 0, '', '2019-06-04 10:09:18');
INSERT INTO `access_log` VALUES (26425, '65.52.15596141576497265', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:18', 9, 0, '', '2019-06-04 10:09:18');
INSERT INTO `access_log` VALUES (26426, '62.85.15596141645257153', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:25', 14, 0, '', '2019-06-04 10:09:25');
INSERT INTO `access_log` VALUES (26427, '65.54.15596141723947241', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:32', 10, 0, '', '2019-06-04 10:09:32');
INSERT INTO `access_log` VALUES (26428, '65.48.15596141723997275', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:32', 9, 0, '', '2019-06-04 10:09:32');
INSERT INTO `access_log` VALUES (26429, '65.49.15596141724037291', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:32', 8, 0, '', '2019-06-04 10:09:32');
INSERT INTO `access_log` VALUES (26430, '62.88.15596141725117163', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:33', 12, 0, '', '2019-06-04 10:09:33');
INSERT INTO `access_log` VALUES (26431, '65.46.15596141770017269', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:37', 8, 0, '', '2019-06-04 10:09:37');
INSERT INTO `access_log` VALUES (26432, '65.50.15596141770057277', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:37', 8, 0, '', '2019-06-04 10:09:37');
INSERT INTO `access_log` VALUES (26433, '65.51.15596141770207275', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:37', 8, 0, '', '2019-06-04 10:09:37');
INSERT INTO `access_log` VALUES (26434, '62.80.15596141770747159', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:37', 20, 0, '', '2019-06-04 10:09:37');
INSERT INTO `access_log` VALUES (26435, '65.52.15596141805437267', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:41', 8, 0, '', '2019-06-04 10:09:41');
INSERT INTO `access_log` VALUES (26436, '65.47.15596141805467271', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:41', 14, 0, '', '2019-06-04 10:09:41');
INSERT INTO `access_log` VALUES (26437, '65.53.15596141805497249', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:41', 14, 0, '', '2019-06-04 10:09:41');
INSERT INTO `access_log` VALUES (26438, '65.54.15596141809397243', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:09:41', 132, 1002001012, '访问令牌已过期', '2019-06-04 10:09:41');
INSERT INTO `access_log` VALUES (26439, '62.84.15596141806097145', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:41', 461, 0, '', '2019-06-04 10:09:41');
INSERT INTO `access_log` VALUES (26440, '65.49.15596141809437293', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:09:41', 128, 1002001012, '访问令牌已过期', '2019-06-04 10:09:41');
INSERT INTO `access_log` VALUES (26441, '65.48.15596141809397277', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:09:41', 134, 1002001012, '访问令牌已过期', '2019-06-04 10:09:41');
INSERT INTO `access_log` VALUES (26442, '65.51.15596141886857277', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:49', 9, 0, '', '2019-06-04 10:09:49');
INSERT INTO `access_log` VALUES (26443, '65.46.15596141886897271', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:49', 9, 0, '', '2019-06-04 10:09:49');
INSERT INTO `access_log` VALUES (26444, '65.45.15596141886927295', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:49', 8, 0, '', '2019-06-04 10:09:49');
INSERT INTO `access_log` VALUES (26445, '65.50.15596141884487279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:09:48', 372, 0, '', '2019-06-04 10:09:49');
INSERT INTO `access_log` VALUES (26446, '62.87.15596141887537155', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:49', 338, 0, '', '2019-06-04 10:09:49');
INSERT INTO `access_log` VALUES (26447, '65.47.15596141894037273', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:09:49', 8, 0, '', '2019-06-04 10:09:49');
INSERT INTO `access_log` VALUES (26448, '65.52.15596141893527269', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:09:49', 136, 0, '', '2019-06-04 10:09:49');
INSERT INTO `access_log` VALUES (26449, '65.53.15596141893587251', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:09:49', 134, 0, '', '2019-06-04 10:09:49');
INSERT INTO `access_log` VALUES (26450, '62.81.15596141946087145', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:09:55', 11, 0, '', '2019-06-04 10:09:55');
INSERT INTO `access_log` VALUES (26451, '65.46.15596141969157273', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:57', 572, 0, '', '2019-06-04 10:09:57');
INSERT INTO `access_log` VALUES (26452, '65.49.15596141969087295', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:57', 578, 0, '', '2019-06-04 10:09:57');
INSERT INTO `access_log` VALUES (26453, '65.48.15596141969127279', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:57', 577, 0, '', '2019-06-04 10:09:57');
INSERT INTO `access_log` VALUES (26454, '62.86.15596141969847147', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:09:57', 504, 0, '', '2019-06-04 10:09:57');
INSERT INTO `access_log` VALUES (26455, '64.84.15596141976746991', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:09:58', 334, 0, '', '2019-06-04 10:09:58');
INSERT INTO `access_log` VALUES (26456, '64.76.15596141976686979', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:09:58', 340, 0, '', '2019-06-04 10:09:58');
INSERT INTO `access_log` VALUES (26457, '65.51.15596142004477279', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:10:00', 10, 0, '', '2019-06-04 10:10:00');
INSERT INTO `access_log` VALUES (26458, '65.45.15596142004497297', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:10:00', 9, 0, '', '2019-06-04 10:10:00');
INSERT INTO `access_log` VALUES (26459, '65.50.15596142004527281', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:10:00', 9, 0, '', '2019-06-04 10:10:00');
INSERT INTO `access_log` VALUES (26460, '62.82.15596142005237163', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:10:01', 13, 0, '', '2019-06-04 10:10:01');
INSERT INTO `access_log` VALUES (26461, '65.47.15596142027687275', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:10:03', 10, 0, '', '2019-06-04 10:10:03');
INSERT INTO `access_log` VALUES (26462, '65.53.15596142027707253', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:10:03', 9, 0, '', '2019-06-04 10:10:03');
INSERT INTO `access_log` VALUES (26463, '65.52.15596142027747271', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:10:03', 9, 0, '', '2019-06-04 10:10:03');
INSERT INTO `access_log` VALUES (26464, '62.85.15596142028567155', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.108.135.98', '2019-06-04 10:10:03', 40, 0, '', '2019-06-04 10:10:03');
INSERT INTO `access_log` VALUES (26465, '64.77.15596142227856995', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:10:23', 8, 0, '', '2019-06-04 10:10:23');
INSERT INTO `access_log` VALUES (26466, '64.83.15596142227846985', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:10:23', 11, 0, '', '2019-06-04 10:10:23');
INSERT INTO `access_log` VALUES (26467, '66.48.15596142263235959', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:10:26', 21, 0, '', '2019-06-04 10:10:26');
INSERT INTO `access_log` VALUES (26468, '59.77.15596142283607299', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:10:28', 11, 0, '', '2019-06-04 10:10:28');
INSERT INTO `access_log` VALUES (26469, '65.46.15596142306837275', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.3.41', '2019-06-04 10:10:31', 53, 0, '', '2019-06-04 10:10:31');
INSERT INTO `access_log` VALUES (26470, '59.80.15596142342367299', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:10:34', 3, 0, '', '2019-06-04 10:10:34');
INSERT INTO `access_log` VALUES (26471, '59.73.15596142342387313', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:10:34', 13, 2001001000, '服务端发生异常', '2019-06-04 10:10:34');
INSERT INTO `access_log` VALUES (26472, '64.82.15596142432806999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:10:43', 2, 0, '', '2019-06-04 10:10:43');
INSERT INTO `access_log` VALUES (26473, '64.78.15596142436536993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:10:44', 146, 0, '', '2019-06-04 10:10:44');
INSERT INTO `access_log` VALUES (26474, '64.81.15596142450106987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:10:45', 16, 0, '', '2019-06-04 10:10:45');
INSERT INTO `access_log` VALUES (26475, '64.84.15596142455616993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:10:46', 2, 0, '', '2019-06-04 10:10:46');
INSERT INTO `access_log` VALUES (26476, '59.75.15596142528847309', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:10:53', 2, 0, '', '2019-06-04 10:10:53');
INSERT INTO `access_log` VALUES (26477, '59.79.15596142528857309', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:10:53', 13, 2001001000, '服务端发生异常', '2019-06-04 10:10:53');
INSERT INTO `access_log` VALUES (26478, '65.51.15596142595537281', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:11:00', 1, 1002001015, '账号未登陆', '2019-06-04 10:11:00');
INSERT INTO `access_log` VALUES (26479, '65.50.15596142595557283', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:11:00', 0, 1002001015, '账号未登陆', '2019-06-04 10:11:00');
INSERT INTO `access_log` VALUES (26480, '65.47.15596142595607277', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:11:00', 0, 1002001015, '账号未登陆', '2019-06-04 10:11:00');
INSERT INTO `access_log` VALUES (26481, '65.53.15596142611677255', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:11:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 10:11:01');
INSERT INTO `access_log` VALUES (26482, '65.52.15596142659887273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:11:06', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 10:11:06');
INSERT INTO `access_log` VALUES (26483, '65.49.15596142755347299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:11:16', 71, 0, '', '2019-06-04 10:11:16');
INSERT INTO `access_log` VALUES (26484, '65.46.15596142758727277', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:11:16', 9, 0, '', '2019-06-04 10:11:16');
INSERT INTO `access_log` VALUES (26485, '65.48.15596142758777283', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:11:16', 9, 0, '', '2019-06-04 10:11:16');
INSERT INTO `access_log` VALUES (26486, '65.45.15596142758797301', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:11:16', 8, 0, '', '2019-06-04 10:11:16');
INSERT INTO `access_log` VALUES (26487, '65.51.15596142873047283', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:11:27', 1, 1002001015, '账号未登陆', '2019-06-04 10:11:27');
INSERT INTO `access_log` VALUES (26488, '65.53.15596142873047257', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:11:27', 0, 1002001015, '账号未登陆', '2019-06-04 10:11:27');
INSERT INTO `access_log` VALUES (26489, '65.47.15596142873047279', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:11:27', 1, 1002001015, '账号未登陆', '2019-06-04 10:11:27');
INSERT INTO `access_log` VALUES (26490, '65.52.15596142877897275', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:11:28', 10, 0, '', '2019-06-04 10:11:28');
INSERT INTO `access_log` VALUES (26491, '65.54.15596142900917251', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:11:30', 12, 0, '', '2019-06-04 10:11:30');
INSERT INTO `access_log` VALUES (26492, '65.49.15596142909467301', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:11:31', 68, 0, '', '2019-06-04 10:11:31');
INSERT INTO `access_log` VALUES (26493, '65.46.15596142914257279', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:11:31', 8, 0, '', '2019-06-04 10:11:31');
INSERT INTO `access_log` VALUES (26494, '65.48.15596142914297285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:11:31', 9, 0, '', '2019-06-04 10:11:31');
INSERT INTO `access_log` VALUES (26495, '65.45.15596142914357303', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:11:31', 9, 0, '', '2019-06-04 10:11:31');
INSERT INTO `access_log` VALUES (26496, '62.82.15596143018087165', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:11:42', 13, 0, '', '2019-06-04 10:11:42');
INSERT INTO `access_log` VALUES (26497, '65.51.15596143046507285', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:11:45', 9, 0, '', '2019-06-04 10:11:45');
INSERT INTO `access_log` VALUES (26498, '64.82.15596143209307001', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:12:01', 9, 0, '', '2019-06-04 10:12:01');
INSERT INTO `access_log` VALUES (26499, '64.79.15596143209286987', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:12:01', 12, 0, '', '2019-06-04 10:12:01');
INSERT INTO `access_log` VALUES (26500, '64.81.15596143335706989', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:12:14', 11, 0, '', '2019-06-04 10:12:14');
INSERT INTO `access_log` VALUES (26501, '64.84.15596143335746995', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:12:14', 8, 0, '', '2019-06-04 10:12:14');
INSERT INTO `access_log` VALUES (26502, '65.54.15596143514327253', 27, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=47&type=2&sort=1&displayName=新建员工&pid=33&permissions[0]=system.admin.add&permissions[1]=system.admin.update&createTime=2019-05-15T15:43:58.000+0000', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:12:31', 7, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-04 10:12:31');
INSERT INTO `access_log` VALUES (26503, '65.49.15596143515557303', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:12:32', 9, 0, '', '2019-06-04 10:12:32');
INSERT INTO `access_log` VALUES (26504, '64.80.15596143574806987', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:12:37', 12, 0, '', '2019-06-04 10:12:37');
INSERT INTO `access_log` VALUES (26505, '64.83.15596143574856989', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:12:37', 8, 0, '', '2019-06-04 10:12:37');
INSERT INTO `access_log` VALUES (26506, '62.83.15596143619737161', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:12:42', 12, 0, '', '2019-06-04 10:12:42');
INSERT INTO `access_log` VALUES (26507, '62.86.15596143757237151', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-07 10:12:41&createEndTime=2019-06-07 10:12:41', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:12:56', 13, 0, '', '2019-06-04 10:12:56');
INSERT INTO `access_log` VALUES (26508, '62.82.15596143819517167', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-07 10:12:41&createEndTime=2019-06-07 10:12:41&payChannel=101', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:13:02', 278, 0, '', '2019-06-04 10:13:02');
INSERT INTO `access_log` VALUES (26509, '62.88.15596143905577169', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-07 10:12:41&createEndTime=2019-06-07 10:12:41&status=1&payChannel=101', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:13:11', 10, 0, '', '2019-06-04 10:13:11');
INSERT INTO `access_log` VALUES (26510, '65.51.15596144120827287', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:13:32', 200, 0, '', '2019-06-04 10:13:32');
INSERT INTO `access_log` VALUES (26511, '65.53.15596144129427261', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.190.132.86', '2019-06-04 10:13:33', 10, 0, '', '2019-06-04 10:13:33');
INSERT INTO `access_log` VALUES (26512, '64.77.15596145166157001', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1&cid=784', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:15:17', 204, 0, '', '2019-06-04 10:15:17');
INSERT INTO `access_log` VALUES (26513, '62.89.15596145295967165', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:15:30', 14, 0, '', '2019-06-04 10:15:30');
INSERT INTO `access_log` VALUES (26514, '65.52.15596145781087281', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:16:18', 21, 0, '', '2019-06-04 10:16:18');
INSERT INTO `access_log` VALUES (26515, '65.54.15596145832297257', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:16:23', 11, 0, '', '2019-06-04 10:16:23');
INSERT INTO `access_log` VALUES (26516, '65.45.15596145886407309', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:16:29', 13, 0, '', '2019-06-04 10:16:29');
INSERT INTO `access_log` VALUES (26517, '65.48.15596145980007291', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:16:38', 16, 0, '', '2019-06-04 10:16:38');
INSERT INTO `access_log` VALUES (26518, '65.50.15596145995387293', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:16:40', 17, 0, '', '2019-06-04 10:16:40');
INSERT INTO `access_log` VALUES (26519, '65.51.15596146012697291', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:16:41', 17, 0, '', '2019-06-04 10:16:41');
INSERT INTO `access_log` VALUES (26520, '65.53.15596146033327265', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:16:43', 10, 0, '', '2019-06-04 10:16:43');
INSERT INTO `access_log` VALUES (26521, '65.47.15596146106797287', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:16:51', 13, 0, '', '2019-06-04 10:16:51');
INSERT INTO `access_log` VALUES (26522, '65.48.15596146634387293', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:17:43', 8, 0, '', '2019-06-04 10:17:43');
INSERT INTO `access_log` VALUES (26523, '65.52.15596147472587285', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:19:07', 16, 0, '', '2019-06-04 10:19:07');
INSERT INTO `access_log` VALUES (26524, '65.46.15596148005387289', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:20:01', 14, 0, '', '2019-06-04 10:20:01');
INSERT INTO `access_log` VALUES (26525, '59.79.15596148358197317', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:20:36', 13, 0, '', '2019-06-04 10:20:36');
INSERT INTO `access_log` VALUES (26526, '65.45.15596150622057317', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.124.21.173', '2019-06-04 10:24:22', 1, 1002001015, '账号未登陆', '2019-06-04 10:24:22');
INSERT INTO `access_log` VALUES (26527, '65.48.15596150622297299', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.124.21.173', '2019-06-04 10:24:22', 1, 1002001015, '账号未登陆', '2019-06-04 10:24:22');
INSERT INTO `access_log` VALUES (26528, '65.46.15596150622347293', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.124.21.173', '2019-06-04 10:24:22', 0, 1002001015, '账号未登陆', '2019-06-04 10:24:22');
INSERT INTO `access_log` VALUES (26529, '65.51.15596150675097299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.124.21.173', '2019-06-04 10:24:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 10:24:28');
INSERT INTO `access_log` VALUES (26530, '65.53.15596150755107273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.124.21.173', '2019-06-04 10:24:36', 233, 0, '', '2019-06-04 10:24:36');
INSERT INTO `access_log` VALUES (26531, '65.47.15596150783147295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.124.21.173', '2019-06-04 10:24:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 10:24:38');
INSERT INTO `access_log` VALUES (26532, '65.54.15596150842927267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.124.21.173', '2019-06-04 10:24:44', 91, 0, '', '2019-06-04 10:24:44');
INSERT INTO `access_log` VALUES (26533, '65.45.15596151004467319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.124.21.173', '2019-06-04 10:25:00', 523, 0, '', '2019-06-04 10:25:01');
INSERT INTO `access_log` VALUES (26534, '66.57.15596151540365965', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18814128912&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:25:54', 11, 1001003000, '验证码不存在', '2019-06-04 10:25:54');
INSERT INTO `access_log` VALUES (26535, '66.50.15596151563835963', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18814128912', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:25:56', 58, 0, '', '2019-06-04 10:25:56');
INSERT INTO `access_log` VALUES (26536, '66.51.15596151650285965', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18814128912&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:26:05', 208, 0, '', '2019-06-04 10:26:05');
INSERT INTO `access_log` VALUES (26537, '66.49.15596151668505971', 103, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:26:07', 7, 0, '', '2019-06-04 10:26:07');
INSERT INTO `access_log` VALUES (26538, '65.47.15596151861997297', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:26:26', 51, 1002001012, '访问令牌已过期', '2019-06-04 10:26:26');
INSERT INTO `access_log` VALUES (26539, '65.54.15596151950207269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:26:35', 84, 0, '', '2019-06-04 10:26:35');
INSERT INTO `access_log` VALUES (26540, '65.49.15596151955167319', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:26:36', 77, 0, '', '2019-06-04 10:26:36');
INSERT INTO `access_log` VALUES (26541, '65.48.15596151955227303', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:26:36', 73, 0, '', '2019-06-04 10:26:36');
INSERT INTO `access_log` VALUES (26542, '65.45.15596151955197321', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:26:36', 76, 0, '', '2019-06-04 10:26:36');
INSERT INTO `access_log` VALUES (26543, '65.46.15596151980067297', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:26:38', 13, 0, '', '2019-06-04 10:26:38');
INSERT INTO `access_log` VALUES (26544, '66.55.15596152120175973', 103, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:26:52', 5, 0, '', '2019-06-04 10:26:52');
INSERT INTO `access_log` VALUES (26545, '66.57.15596152131235967', 103, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:26:53', 6, 0, '', '2019-06-04 10:26:53');
INSERT INTO `access_log` VALUES (26546, '66.50.15596152164295965', 103, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:26:56', 6, 0, '', '2019-06-04 10:26:56');
INSERT INTO `access_log` VALUES (26547, '59.76.15596152174787317', 103, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:26:57', 6, 0, '', '2019-06-04 10:26:57');
INSERT INTO `access_log` VALUES (26548, '59.75.15596152175067323', 103, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:26:58', 20, 2001001000, '服务端发生异常', '2019-06-04 10:26:58');
INSERT INTO `access_log` VALUES (26549, '64.83.15596152193757001', 103, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:26:59', 6, 0, '', '2019-06-04 10:26:59');
INSERT INTO `access_log` VALUES (26550, '64.79.15596152197497001', 103, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:27:00', 4, 0, '', '2019-06-04 10:27:00');
INSERT INTO `access_log` VALUES (26551, '64.82.15596152215447015', 103, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:27:02', 5, 0, '', '2019-06-04 10:27:02');
INSERT INTO `access_log` VALUES (26552, 'N/A', 103, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:27:02', 19, 0, '', '2019-06-04 10:27:02');
INSERT INTO `access_log` VALUES (26553, '64.81.15596152228087003', 103, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:27:03', 11, 0, '', '2019-06-04 10:27:03');
INSERT INTO `access_log` VALUES (26554, '66.56.15596152293615963', 103, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:27:09', 8, 0, '', '2019-06-04 10:27:09');
INSERT INTO `access_log` VALUES (26555, '66.54.15596152355545971', 103, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.62.253.2', '2019-06-04 10:27:16', 6, 0, '', '2019-06-04 10:27:16');
INSERT INTO `access_log` VALUES (26556, '65.52.15596152361607295', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:27:16', 19, 0, '', '2019-06-04 10:27:16');
INSERT INTO `access_log` VALUES (26557, '65.53.15596153618747279', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:29:22', 14, 0, '', '2019-06-04 10:29:22');
INSERT INTO `access_log` VALUES (26558, '65.47.15596153747567301', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:29:35', 9, 0, '', '2019-06-04 10:29:35');
INSERT INTO `access_log` VALUES (26559, '65.49.15596154116637323', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:30:12', 3002, 0, '', '2019-06-04 10:30:15');
INSERT INTO `access_log` VALUES (26560, '65.51.15596154118437307', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:30:12', 2823, 0, '', '2019-06-04 10:30:15');
INSERT INTO `access_log` VALUES (26561, '65.46.15596154116637301', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:30:12', 3003, 0, '', '2019-06-04 10:30:15');
INSERT INTO `access_log` VALUES (26562, '65.50.15596154116677309', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:30:12', 3002, 0, '', '2019-06-04 10:30:15');
INSERT INTO `access_log` VALUES (26563, '65.53.15596154202317281', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:30:20', 19, 0, '', '2019-06-04 10:30:20');
INSERT INTO `access_log` VALUES (26564, '65.52.15596154220677299', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:30:22', 8, 0, '', '2019-06-04 10:30:22');
INSERT INTO `access_log` VALUES (26565, '65.47.15596154220737303', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:30:22', 8, 0, '', '2019-06-04 10:30:22');
INSERT INTO `access_log` VALUES (26566, '65.54.15596154220887275', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:30:22', 8, 0, '', '2019-06-04 10:30:22');
INSERT INTO `access_log` VALUES (26567, '65.48.15596154223237309', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:30:22', 18, 0, '', '2019-06-04 10:30:22');
INSERT INTO `access_log` VALUES (26568, '65.45.15596157181167331', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:35:18', 19, 0, '', '2019-06-04 10:35:18');
INSERT INTO `access_log` VALUES (26569, '65.49.15596157181177329', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:35:18', 18, 0, '', '2019-06-04 10:35:18');
INSERT INTO `access_log` VALUES (26570, '65.51.15596157181217313', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:35:18', 18, 0, '', '2019-06-04 10:35:18');
INSERT INTO `access_log` VALUES (26571, '59.78.15596157182627333', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.62.253.2', '2019-06-04 10:35:18', 12, 0, '', '2019-06-04 10:35:18');
INSERT INTO `access_log` VALUES (26572, '65.53.15596158993337289', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:38:19', 4, 1002001012, '访问令牌已过期', '2019-06-04 10:38:19');
INSERT INTO `access_log` VALUES (26573, '65.52.15596158993347307', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:38:19', 3, 1002001012, '访问令牌已过期', '2019-06-04 10:38:19');
INSERT INTO `access_log` VALUES (26574, '65.47.15596158993347311', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:38:19', 8, 1002001012, '访问令牌已过期', '2019-06-04 10:38:19');
INSERT INTO `access_log` VALUES (26575, '65.48.15596159047197317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:38:25', 65, 0, '', '2019-06-04 10:38:25');
INSERT INTO `access_log` VALUES (26576, '65.49.15596159050597333', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:38:25', 8, 0, '', '2019-06-04 10:38:25');
INSERT INTO `access_log` VALUES (26577, '65.45.15596159050617335', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:38:25', 8, 0, '', '2019-06-04 10:38:25');
INSERT INTO `access_log` VALUES (26578, '65.51.15596159050717317', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:38:25', 7, 0, '', '2019-06-04 10:38:25');
INSERT INTO `access_log` VALUES (26579, '64.82.15596159144127025', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:38:34', 9, 0, '', '2019-06-04 10:38:34');
INSERT INTO `access_log` VALUES (26580, '64.79.15596159144127011', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:38:34', 11, 0, '', '2019-06-04 10:38:34');
INSERT INTO `access_log` VALUES (26581, '65.52.15596159369887309', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:38:57', 4, 0, '', '2019-06-04 10:38:57');
INSERT INTO `access_log` VALUES (26582, '64.76.15596159567537007', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=11`', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:39:17', 8, 1002002009, NULL, '2019-06-04 10:39:17');
INSERT INTO `access_log` VALUES (26583, '64.80.15596159683677011', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=11111111111&sellPoint=111111111&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/dd087ce1-20c4-4afb-9259-2a8bb7a52459&skuStr=[{\"attrs\":[1],\"price\":100,\"quantity\":1},{\"attrs\":[2],\"price\":100,\"quantity\":1},{\"attrs\":[11],\"price\":100,\"quantity\":1}]&description=<p>111111111111</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:39:28', 8, 1002002009, NULL, '2019-06-04 10:39:28');
INSERT INTO `access_log` VALUES (26584, '66.49.15596159855565985', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:39:46', 22, 0, '', '2019-06-04 10:39:46');
INSERT INTO `access_log` VALUES (26585, '65.51.15596159947457319', 27, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:39:55', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-04 10:39:55');
INSERT INTO `access_log` VALUES (26586, '65.45.15596159978367337', 27, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:39:58', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-04 10:39:58');
INSERT INTO `access_log` VALUES (26587, '65.49.15596159990827335', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:39:59', 1978, 0, '', '2019-06-04 10:40:01');
INSERT INTO `access_log` VALUES (26588, '65.50.15596160076577321', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:40:08', 8, 0, '', '2019-06-04 10:40:08');
INSERT INTO `access_log` VALUES (26589, '65.52.15596160179267311', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:40:18', 14, 0, '', '2019-06-04 10:40:18');
INSERT INTO `access_log` VALUES (26590, '65.53.15596160220597293', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:40:22', 15, 0, '', '2019-06-04 10:40:22');
INSERT INTO `access_log` VALUES (26591, '64.84.15596160405037021', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:40:41', 9, 0, '', '2019-06-04 10:40:41');
INSERT INTO `access_log` VALUES (26592, '64.81.15596160404997015', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:40:41', 12, 0, '', '2019-06-04 10:40:41');
INSERT INTO `access_log` VALUES (26593, '62.86.15596160611587175', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:41:01', 14, 0, '', '2019-06-04 10:41:01');
INSERT INTO `access_log` VALUES (26594, '62.88.15596160861497193', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:41:26', 15, 0, '', '2019-06-04 10:41:26');
INSERT INTO `access_log` VALUES (26595, '62.84.15596161033557175', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:41:43', 12, 0, '', '2019-06-04 10:41:43');
INSERT INTO `access_log` VALUES (26596, '62.87.15596161069897185', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:41:47', 20, 0, '', '2019-06-04 10:41:47');
INSERT INTO `access_log` VALUES (26597, '62.81.15596161135897175', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:41:54', 14, 0, '', '2019-06-04 10:41:54');
INSERT INTO `access_log` VALUES (26598, '62.86.15596161148287177', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:41:55', 15, 0, '', '2019-06-04 10:41:55');
INSERT INTO `access_log` VALUES (26599, '62.82.15596161152207193', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:41:55', 14, 0, '', '2019-06-04 10:41:55');
INSERT INTO `access_log` VALUES (26600, '62.89.15596161536857189', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:42:34', 19, 0, '', '2019-06-04 10:42:34');
INSERT INTO `access_log` VALUES (26601, '65.47.15596161719377317', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:42:52', 10, 0, '', '2019-06-04 10:42:52');
INSERT INTO `access_log` VALUES (26602, '65.48.15596161719377323', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:42:52', 11, 0, '', '2019-06-04 10:42:52');
INSERT INTO `access_log` VALUES (26603, '65.54.15596161719377289', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:42:52', 11, 0, '', '2019-06-04 10:42:52');
INSERT INTO `access_log` VALUES (26604, '62.81.15596161762477179', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:42:56', 12, 0, '', '2019-06-04 10:42:56');
INSERT INTO `access_log` VALUES (26605, '65.49.15596161812237339', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:43:01', 9, 0, '', '2019-06-04 10:43:01');
INSERT INTO `access_log` VALUES (26606, '65.50.15596161812247325', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:43:01', 10, 0, '', '2019-06-04 10:43:01');
INSERT INTO `access_log` VALUES (26607, '65.45.15596161812207341', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:43:01', 13, 0, '', '2019-06-04 10:43:01');
INSERT INTO `access_log` VALUES (26608, '62.86.15596161813077181', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:43:01', 10, 0, '', '2019-06-04 10:43:01');
INSERT INTO `access_log` VALUES (26609, '59.73.15596161880587341', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:08', 3, 0, '', '2019-06-04 10:43:08');
INSERT INTO `access_log` VALUES (26610, '59.80.15596161880597327', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:08', 13, 2001001000, '服务端发生异常', '2019-06-04 10:43:08');
INSERT INTO `access_log` VALUES (26611, '65.52.15596161893487315', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:43:09', 8, 0, '', '2019-06-04 10:43:09');
INSERT INTO `access_log` VALUES (26612, '65.53.15596161893507297', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:43:09', 7, 0, '', '2019-06-04 10:43:09');
INSERT INTO `access_log` VALUES (26613, '65.54.15596161893527291', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:43:09', 7, 0, '', '2019-06-04 10:43:09');
INSERT INTO `access_log` VALUES (26614, '62.85.15596161894307189', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.196.193.19', '2019-06-04 10:43:09', 9, 0, '', '2019-06-04 10:43:09');
INSERT INTO `access_log` VALUES (26615, '64.76.15596161941007011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:14', 3, 0, '', '2019-06-04 10:43:14');
INSERT INTO `access_log` VALUES (26616, '64.85.15596161942157037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:14', 2, 0, '', '2019-06-04 10:43:14');
INSERT INTO `access_log` VALUES (26617, '64.80.15596161953687015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:15', 2, 0, '', '2019-06-04 10:43:15');
INSERT INTO `access_log` VALUES (26618, '64.83.15596161959787017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:16', 2, 0, '', '2019-06-04 10:43:16');
INSERT INTO `access_log` VALUES (26619, '64.77.15596161978137027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:18', 2, 0, '', '2019-06-04 10:43:18');
INSERT INTO `access_log` VALUES (26620, '64.79.15596161982897017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:18', 2, 0, '', '2019-06-04 10:43:18');
INSERT INTO `access_log` VALUES (26621, '64.82.15596161988387031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:19', 2, 0, '', '2019-06-04 10:43:19');
INSERT INTO `access_log` VALUES (26622, '59.75.15596161998877337', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:20', 2, 0, '', '2019-06-04 10:43:20');
INSERT INTO `access_log` VALUES (26623, '59.79.15596161998937337', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:20', 13, 2001001000, '服务端发生异常', '2019-06-04 10:43:20');
INSERT INTO `access_log` VALUES (26624, '64.84.15596162018557025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:22', 2, 0, '', '2019-06-04 10:43:22');
INSERT INTO `access_log` VALUES (26625, '64.81.15596162019767019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:22', 2, 0, '', '2019-06-04 10:43:22');
INSERT INTO `access_log` VALUES (26626, '64.76.15596162050367013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:25', 2, 0, '', '2019-06-04 10:43:25');
INSERT INTO `access_log` VALUES (26627, '64.85.15596162052027039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:43:25', 2, 0, '', '2019-06-04 10:43:25');
INSERT INTO `access_log` VALUES (26628, '64.80.15596162146127017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Mobile Safari/537.36', '113.116.23.39', '2019-06-04 10:43:35', 2, 0, '', '2019-06-04 10:43:35');
INSERT INTO `access_log` VALUES (26629, '64.83.15596162152957019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Mobile Safari/537.36', '113.116.23.39', '2019-06-04 10:43:35', 3, 0, '', '2019-06-04 10:43:35');
INSERT INTO `access_log` VALUES (26630, '59.74.15596162163287333', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Mobile Safari/537.36', '113.116.23.39', '2019-06-04 10:43:36', 2, 0, '', '2019-06-04 10:43:36');
INSERT INTO `access_log` VALUES (26631, '59.78.15596162163297341', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Mobile Safari/537.36', '113.116.23.39', '2019-06-04 10:43:36', 19, 2001001000, '服务端发生异常', '2019-06-04 10:43:36');
INSERT INTO `access_log` VALUES (26632, '59.77.15596162204247329', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Mobile Safari/537.36', '113.116.23.39', '2019-06-04 10:43:40', 2, 0, '', '2019-06-04 10:43:40');
INSERT INTO `access_log` VALUES (26633, '59.72.15596162204257335', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Mobile Safari/537.36', '113.116.23.39', '2019-06-04 10:43:40', 14, 2001001000, '服务端发生异常', '2019-06-04 10:43:40');
INSERT INTO `access_log` VALUES (26634, '65.50.15596162500827327', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:44:10', 1, 1002001015, '账号未登陆', '2019-06-04 10:44:10');
INSERT INTO `access_log` VALUES (26635, '65.49.15596162500817341', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:44:10', 0, 1002001015, '账号未登陆', '2019-06-04 10:44:10');
INSERT INTO `access_log` VALUES (26636, '65.46.15596162500857319', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:44:10', 0, 1002001015, '账号未登陆', '2019-06-04 10:44:10');
INSERT INTO `access_log` VALUES (26637, '65.52.15596162540507317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:44:14', 88, 0, '', '2019-06-04 10:44:14');
INSERT INTO `access_log` VALUES (26638, '65.53.15596162543527299', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:44:14', 10, 0, '', '2019-06-04 10:44:14');
INSERT INTO `access_log` VALUES (26639, '65.54.15596162543547293', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:44:14', 9, 0, '', '2019-06-04 10:44:14');
INSERT INTO `access_log` VALUES (26640, '65.47.15596162543567321', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:44:14', 9, 0, '', '2019-06-04 10:44:14');
INSERT INTO `access_log` VALUES (26641, '62.87.15596162588227191', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:44:19', 13, 0, '', '2019-06-04 10:44:19');
INSERT INTO `access_log` VALUES (26642, '59.75.15596162643137339', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:44:24', 11, 0, '', '2019-06-04 10:44:24');
INSERT INTO `access_log` VALUES (26643, '65.51.15596162690217327', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:44:29', 18, 0, '', '2019-06-04 10:44:29');
INSERT INTO `access_log` VALUES (26644, '65.45.15596162758587345', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:44:36', 119, 0, '', '2019-06-04 10:44:36');
INSERT INTO `access_log` VALUES (26645, '65.46.15596162765917321', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:44:37', 9, 0, '', '2019-06-04 10:44:37');
INSERT INTO `access_log` VALUES (26646, '65.49.15596162772097343', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 10:44:37', 9, 0, '', '2019-06-04 10:44:37');
INSERT INTO `access_log` VALUES (26647, '65.51.15596163619427329', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:46:02', 12, 0, '', '2019-06-04 10:46:02');
INSERT INTO `access_log` VALUES (26648, '65.50.15596164107427331', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:46:51', 13, 0, '', '2019-06-04 10:46:51');
INSERT INTO `access_log` VALUES (26649, '65.53.15596164175927303', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:46:58', 11, 0, '', '2019-06-04 10:46:58');
INSERT INTO `access_log` VALUES (26650, '65.52.15596165360747323', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:48:56', 13, 0, '', '2019-06-04 10:48:56');
INSERT INTO `access_log` VALUES (26651, '65.50.15596169677977339', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 10:56:08', 303, 1002001012, '访问令牌已过期', '2019-06-04 10:56:08');
INSERT INTO `access_log` VALUES (26652, '65.53.15596169678027311', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 10:56:08', 297, 1002001012, '访问令牌已过期', '2019-06-04 10:56:08');
INSERT INTO `access_log` VALUES (26653, '65.52.15596169677977329', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 10:56:08', 302, 1002001012, '访问令牌已过期', '2019-06-04 10:56:08');
INSERT INTO `access_log` VALUES (26654, '65.47.15596169699367333', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 10:56:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 10:56:10');
INSERT INTO `access_log` VALUES (26655, '65.48.15596169745117339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 10:56:15', 193, 0, '', '2019-06-04 10:56:15');
INSERT INTO `access_log` VALUES (26656, '65.51.15596169750407339', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 10:56:15', 10, 0, '', '2019-06-04 10:56:15');
INSERT INTO `access_log` VALUES (26657, '65.46.15596169750427333', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 10:56:15', 9, 0, '', '2019-06-04 10:56:15');
INSERT INTO `access_log` VALUES (26658, '65.45.15596169750417357', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 10:56:15', 11, 0, '', '2019-06-04 10:56:15');
INSERT INTO `access_log` VALUES (26659, '65.50.15596169913507341', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 10:56:31', 19, 0, '', '2019-06-04 10:56:31');
INSERT INTO `access_log` VALUES (26660, '65.52.15596169965227331', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 10:56:37', 11, 0, '', '2019-06-04 10:56:37');
INSERT INTO `access_log` VALUES (26661, '65.54.15596170002247307', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 10:56:40', 18, 0, '', '2019-06-04 10:56:40');
INSERT INTO `access_log` VALUES (26662, '65.46.15596173475057339', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:02:28', 9, 0, '', '2019-06-04 11:02:28');
INSERT INTO `access_log` VALUES (26663, '65.53.15596173475147317', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:02:28', 11, 0, '', '2019-06-04 11:02:28');
INSERT INTO `access_log` VALUES (26664, '65.52.15596173475157339', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:02:28', 10, 0, '', '2019-06-04 11:02:28');
INSERT INTO `access_log` VALUES (26665, '65.54.15596173476347311', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:02:28', 18, 0, '', '2019-06-04 11:02:28');
INSERT INTO `access_log` VALUES (26666, '65.45.15596173619787365', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:02:42', 11, 0, '', '2019-06-04 11:02:42');
INSERT INTO `access_log` VALUES (26667, '65.51.15596173678227349', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:02:48', 1, 1002001015, '账号未登陆', '2019-06-04 11:02:48');
INSERT INTO `access_log` VALUES (26668, '65.50.15596173678247349', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:02:48', 0, 1002001015, '账号未登陆', '2019-06-04 11:02:48');
INSERT INTO `access_log` VALUES (26669, '65.49.15596173678287363', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:02:48', 0, 1002001015, '账号未登陆', '2019-06-04 11:02:48');
INSERT INTO `access_log` VALUES (26670, '65.53.15596173718037319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:02:52', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 11:02:52');
INSERT INTO `access_log` VALUES (26671, '65.52.15596173762197341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:02:56', 53, 0, '', '2019-06-04 11:02:56');
INSERT INTO `access_log` VALUES (26672, '65.54.15596173765017313', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:02:57', 8, 0, '', '2019-06-04 11:02:57');
INSERT INTO `access_log` VALUES (26673, '65.47.15596173765017345', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:02:57', 9, 0, '', '2019-06-04 11:02:57');
INSERT INTO `access_log` VALUES (26674, '65.48.15596173765017351', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:02:57', 9, 0, '', '2019-06-04 11:02:57');
INSERT INTO `access_log` VALUES (26675, '62.85.15596173799127207', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:03:00', 13, 0, '', '2019-06-04 11:03:00');
INSERT INTO `access_log` VALUES (26676, '64.84.15596173814127043', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:03:01', 9, 0, '', '2019-06-04 11:03:01');
INSERT INTO `access_log` VALUES (26677, '64.85.15596173814107055', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:03:01', 13, 0, '', '2019-06-04 11:03:01');
INSERT INTO `access_log` VALUES (26678, '66.51.15596173828295997', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:03:03', 15, 0, '', '2019-06-04 11:03:03');
INSERT INTO `access_log` VALUES (26679, '59.79.15596173839077353', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:03:04', 11, 0, '', '2019-06-04 11:03:04');
INSERT INTO `access_log` VALUES (26680, '65.45.15596173853037367', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:03:05', 18, 0, '', '2019-06-04 11:03:05');
INSERT INTO `access_log` VALUES (26681, '65.49.15596173868817365', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:03:07', 18, 0, '', '2019-06-04 11:03:07');
INSERT INTO `access_log` VALUES (26682, '66.55.15596174656466007', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:04:26', 13, 0, '', '2019-06-04 11:04:26');
INSERT INTO `access_log` VALUES (26683, '64.80.15596174678637035', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:04:28', 11, 0, '', '2019-06-04 11:04:28');
INSERT INTO `access_log` VALUES (26684, '64.78.15596174678637045', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:04:28', 12, 0, '', '2019-06-04 11:04:28');
INSERT INTO `access_log` VALUES (26685, '62.83.15596174689137211', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:04:29', 13, 0, '', '2019-06-04 11:04:29');
INSERT INTO `access_log` VALUES (26686, '59.73.15596174701037359', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.48.109.3', '2019-06-04 11:04:30', 18, 0, '', '2019-06-04 11:04:30');
INSERT INTO `access_log` VALUES (26687, '59.71.15596176585057363', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:39', 4, 0, '', '2019-06-04 11:07:39');
INSERT INTO `access_log` VALUES (26688, '59.74.15596176585057355', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:39', 13, 2001001000, '服务端发生异常', '2019-06-04 11:07:39');
INSERT INTO `access_log` VALUES (26689, '59.72.15596176589237357', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:07:39', 2, 0, '', '2019-06-04 11:07:39');
INSERT INTO `access_log` VALUES (26690, '59.80.15596176589247349', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:07:39', 20, 2001001000, '服务端发生异常', '2019-06-04 11:07:39');
INSERT INTO `access_log` VALUES (26691, '64.81.15596176614707041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:41', 3, 0, '', '2019-06-04 11:07:41');
INSERT INTO `access_log` VALUES (26692, '64.76.15596176615827033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:42', 2, 0, '', '2019-06-04 11:07:42');
INSERT INTO `access_log` VALUES (26693, '64.83.15596176624877041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:42', 2, 0, '', '2019-06-04 11:07:42');
INSERT INTO `access_log` VALUES (26694, '64.77.15596176630827049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:43', 2, 0, '', '2019-06-04 11:07:43');
INSERT INTO `access_log` VALUES (26695, '64.82.15596176634577055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:43', 2, 0, '', '2019-06-04 11:07:43');
INSERT INTO `access_log` VALUES (26696, '59.77.15596176650387351', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:45', 3, 0, '', '2019-06-04 11:07:45');
INSERT INTO `access_log` VALUES (26697, '59.78.15596176650387363', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:45', 12, 2001001000, '服务端发生异常', '2019-06-04 11:07:45');
INSERT INTO `access_log` VALUES (26698, '64.80.15596176667747039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:47', 26, 0, '', '2019-06-04 11:07:47');
INSERT INTO `access_log` VALUES (26699, '64.78.15596176668887049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:47', 2, 0, '', '2019-06-04 11:07:47');
INSERT INTO `access_log` VALUES (26700, '64.85.15596176676967061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:48', 2, 0, '', '2019-06-04 11:07:48');
INSERT INTO `access_log` VALUES (26701, '64.84.15596176679317049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:48', 2, 0, '', '2019-06-04 11:07:48');
INSERT INTO `access_log` VALUES (26702, '59.75.15596176693567361', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:49', 2, 0, '', '2019-06-04 11:07:49');
INSERT INTO `access_log` VALUES (26703, '59.76.15596176693567353', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:07:49', 13, 2001001000, '服务端发生异常', '2019-06-04 11:07:49');
INSERT INTO `access_log` VALUES (26704, '64.81.15596176736087043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.169.135.186', '2019-06-04 11:07:54', 2, 0, '', '2019-06-04 11:07:54');
INSERT INTO `access_log` VALUES (26705, '64.76.15596176737957035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.169.135.186', '2019-06-04 11:07:54', 2, 0, '', '2019-06-04 11:07:54');
INSERT INTO `access_log` VALUES (26706, '64.83.15596176774587043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.169.135.186', '2019-06-04 11:07:57', 2, 0, '', '2019-06-04 11:07:57');
INSERT INTO `access_log` VALUES (26707, '64.77.15596176775427051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.169.135.186', '2019-06-04 11:07:58', 2, 0, '', '2019-06-04 11:07:58');
INSERT INTO `access_log` VALUES (26708, '64.82.15596176807417057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.169.135.186', '2019-06-04 11:08:01', 1, 0, '', '2019-06-04 11:08:01');
INSERT INTO `access_log` VALUES (26709, '64.80.15596176808277041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.169.135.186', '2019-06-04 11:08:01', 2, 0, '', '2019-06-04 11:08:01');
INSERT INTO `access_log` VALUES (26710, '59.74.15596176872137357', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:08:07', 3, 0, '', '2019-06-04 11:08:07');
INSERT INTO `access_log` VALUES (26711, '59.71.15596176872157365', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '49.77.129.207', '2019-06-04 11:08:07', 10, 2001001000, '服务端发生异常', '2019-06-04 11:08:07');
INSERT INTO `access_log` VALUES (26712, '65.51.15596176964087355', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:08:16', 1, 1002001015, '账号未登陆', '2019-06-04 11:08:16');
INSERT INTO `access_log` VALUES (26713, '65.53.15596176964097325', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:08:16', 0, 1002001015, '账号未登陆', '2019-06-04 11:08:16');
INSERT INTO `access_log` VALUES (26714, '65.46.15596176964177347', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:08:16', 1, 1002001015, '账号未登陆', '2019-06-04 11:08:16');
INSERT INTO `access_log` VALUES (26715, '65.47.15596178170667353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:10:17', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 11:10:17');
INSERT INTO `access_log` VALUES (26716, '65.48.15596178249117357', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:10:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 11:10:25');
INSERT INTO `access_log` VALUES (26717, '65.45.15596178344497373', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:10:34', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 11:10:34');
INSERT INTO `access_log` VALUES (26718, '65.50.15596178403277359', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:10:40', 93, 0, '', '2019-06-04 11:10:40');
INSERT INTO `access_log` VALUES (26719, '65.46.15596178407517351', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:10:41', 10, 0, '', '2019-06-04 11:10:41');
INSERT INTO `access_log` VALUES (26720, '65.51.15596178407507359', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:10:41', 9, 0, '', '2019-06-04 11:10:41');
INSERT INTO `access_log` VALUES (26721, '65.53.15596178407647329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:10:41', 9, 0, '', '2019-06-04 11:10:41');
INSERT INTO `access_log` VALUES (26722, '62.87.15596178506887211', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:10:51', 13, 0, '', '2019-06-04 11:10:51');
INSERT INTO `access_log` VALUES (26723, '64.79.15596178593787045', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:10:59', 10, 0, '', '2019-06-04 11:10:59');
INSERT INTO `access_log` VALUES (26724, '64.84.15596178593777053', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:10:59', 12, 0, '', '2019-06-04 11:10:59');
INSERT INTO `access_log` VALUES (26725, '65.47.15596178670277355', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:11:07', 10, 0, '', '2019-06-04 11:11:07');
INSERT INTO `access_log` VALUES (26726, '65.48.15596178718277359', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:11:12', 9, 0, '', '2019-06-04 11:11:12');
INSERT INTO `access_log` VALUES (26727, '65.45.15596178742807375', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:11:14', 14, 0, '', '2019-06-04 11:11:14');
INSERT INTO `access_log` VALUES (26728, '65.49.15596178816957375', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:11:22', 59, 0, '', '2019-06-04 11:11:22');
INSERT INTO `access_log` VALUES (26729, '65.50.15596178830877361', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:11:23', 14, 0, '', '2019-06-04 11:11:23');
INSERT INTO `access_log` VALUES (26730, '65.51.15596178840237361', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:11:24', 8, 0, '', '2019-06-04 11:11:24');
INSERT INTO `access_log` VALUES (26731, '65.53.15596178846477331', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:11:25', 15, 0, '', '2019-06-04 11:11:25');
INSERT INTO `access_log` VALUES (26732, '59.78.15596178877097367', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:11:28', 12, 0, '', '2019-06-04 11:11:28');
INSERT INTO `access_log` VALUES (26733, '59.73.15596178931707367', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.169.135.186', '2019-06-04 11:11:33', 3, 0, '', '2019-06-04 11:11:33');
INSERT INTO `access_log` VALUES (26734, '59.76.15596178931707357', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.169.135.186', '2019-06-04 11:11:33', 13, 2001001000, '服务端发生异常', '2019-06-04 11:11:33');
INSERT INTO `access_log` VALUES (26735, '59.79.15596179039807363', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:11:44', 8, 1002002009, NULL, '2019-06-04 11:11:44');
INSERT INTO `access_log` VALUES (26736, '59.71.15596179100827369', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.169.135.186', '2019-06-04 11:11:50', 3, 0, '', '2019-06-04 11:11:50');
INSERT INTO `access_log` VALUES (26737, '59.80.15596179100827355', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.169.135.186', '2019-06-04 11:11:50', 12, 2001001000, '服务端发生异常', '2019-06-04 11:11:50');
INSERT INTO `access_log` VALUES (26738, '65.45.15596179586467377', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:12:39', 9, 0, '', '2019-06-04 11:12:39');
INSERT INTO `access_log` VALUES (26739, '65.49.15596179586477377', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:12:39', 9, 0, '', '2019-06-04 11:12:39');
INSERT INTO `access_log` VALUES (26740, '65.50.15596179586487363', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:12:39', 9, 0, '', '2019-06-04 11:12:39');
INSERT INTO `access_log` VALUES (26741, '59.73.15596179587247369', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '180.169.135.186', '2019-06-04 11:12:39', 21, 0, '', '2019-06-04 11:12:39');
INSERT INTO `access_log` VALUES (26742, '65.54.15596180318767325', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:13:52', 0, 1002001015, '账号未登陆', '2019-06-04 11:13:52');
INSERT INTO `access_log` VALUES (26743, '65.48.15596180318797363', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:13:52', 1, 1002001015, '账号未登陆', '2019-06-04 11:13:52');
INSERT INTO `access_log` VALUES (26744, '65.50.15596180318827365', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:13:52', 0, 1002001015, '账号未登陆', '2019-06-04 11:13:52');
INSERT INTO `access_log` VALUES (26745, '65.49.15596180337747379', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:13:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 11:13:54');
INSERT INTO `access_log` VALUES (26746, '65.46.15596180371617357', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:13:57', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 11:13:57');
INSERT INTO `access_log` VALUES (26747, '65.53.15596180545597335', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:14:15', 185, 0, '', '2019-06-04 11:14:15');
INSERT INTO `access_log` VALUES (26748, '65.52.15596180551077357', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:14:15', 11, 0, '', '2019-06-04 11:14:15');
INSERT INTO `access_log` VALUES (26749, '65.47.15596180551107361', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:14:15', 10, 0, '', '2019-06-04 11:14:15');
INSERT INTO `access_log` VALUES (26750, '65.50.15596180551137367', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:14:15', 9, 0, '', '2019-06-04 11:14:15');
INSERT INTO `access_log` VALUES (26751, '64.79.15596181319107049', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:15:32', 73, 0, '', '2019-06-04 11:15:32');
INSERT INTO `access_log` VALUES (26752, '64.84.15596181319117057', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:15:32', 76, 0, '', '2019-06-04 11:15:32');
INSERT INTO `access_log` VALUES (26753, '62.84.15596182435717209', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:17:24', 14, 0, '', '2019-06-04 11:17:24');
INSERT INTO `access_log` VALUES (26754, '62.82.15596182490067229', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:17:29', 16, 0, '', '2019-06-04 11:17:29');
INSERT INTO `access_log` VALUES (26755, '62.89.15596182535037225', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:17:34', 12, 0, '', '2019-06-04 11:17:34');
INSERT INTO `access_log` VALUES (26756, '59.76.15596182571367363', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.170.254.175', '2019-06-04 11:17:37', 3, 0, '', '2019-06-04 11:17:37');
INSERT INTO `access_log` VALUES (26757, '59.75.15596182571407371', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.170.254.175', '2019-06-04 11:17:37', 10, 2001001000, '服务端发生异常', '2019-06-04 11:17:37');
INSERT INTO `access_log` VALUES (26758, '62.83.15596182577677223', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:17:38', 15, 0, '', '2019-06-04 11:17:38');
INSERT INTO `access_log` VALUES (26759, '59.79.15596182636267369', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.170.254.175', '2019-06-04 11:17:44', 2, 0, '', '2019-06-04 11:17:44');
INSERT INTO `access_log` VALUES (26760, '59.74.15596182636297367', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.170.254.175', '2019-06-04 11:17:44', 20, 2001001000, '服务端发生异常', '2019-06-04 11:17:44');
INSERT INTO `access_log` VALUES (26761, '62.88.15596182820127229', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:18:02', 54, 0, '', '2019-06-04 11:18:02');
INSERT INTO `access_log` VALUES (26762, '62.87.15596182828037217', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:18:03', 14, 0, '', '2019-06-04 11:18:03');
INSERT INTO `access_log` VALUES (26763, '62.80.15596182833147227', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:18:03', 15, 0, '', '2019-06-04 11:18:03');
INSERT INTO `access_log` VALUES (26764, '62.85.15596182839417223', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:18:04', 15, 0, '', '2019-06-04 11:18:04');
INSERT INTO `access_log` VALUES (26765, '62.81.15596182845707209', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:18:05', 14, 0, '', '2019-06-04 11:18:05');
INSERT INTO `access_log` VALUES (26766, '62.82.15596182855697231', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:18:06', 15, 0, '', '2019-06-04 11:18:06');
INSERT INTO `access_log` VALUES (26767, '62.86.15596182862877215', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:18:06', 16, 0, '', '2019-06-04 11:18:06');
INSERT INTO `access_log` VALUES (26768, '62.83.15596182931397225', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:18:13', 14, 0, '', '2019-06-04 11:18:13');
INSERT INTO `access_log` VALUES (26769, '62.84.15596182961677213', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:18:16', 9, 0, '', '2019-06-04 11:18:16');
INSERT INTO `access_log` VALUES (26770, '62.88.15596182976007231', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=8&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:18:18', 11, 0, '', '2019-06-04 11:18:18');
INSERT INTO `access_log` VALUES (26771, '62.87.15596182982787219', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=7&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:18:18', 12, 0, '', '2019-06-04 11:18:18');
INSERT INTO `access_log` VALUES (26772, '65.52.15596183154877361', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:18:35', 20, 0, '', '2019-06-04 11:18:36');
INSERT INTO `access_log` VALUES (26773, '64.77.15596183190237061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:18:39', 2, 0, '', '2019-06-04 11:18:39');
INSERT INTO `access_log` VALUES (26774, '64.82.15596183191227067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:18:39', 2, 0, '', '2019-06-04 11:18:39');
INSERT INTO `access_log` VALUES (26775, '64.80.15596183216587051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:18:42', 2, 0, '', '2019-06-04 11:18:42');
INSERT INTO `access_log` VALUES (26776, '64.78.15596183224317061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:18:42', 2, 0, '', '2019-06-04 11:18:42');
INSERT INTO `access_log` VALUES (26777, '59.78.15596183246547375', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:18:45', 2, 0, '', '2019-06-04 11:18:45');
INSERT INTO `access_log` VALUES (26778, '59.73.15596183246587375', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:18:45', 9, 2001001000, '服务端发生异常', '2019-06-04 11:18:45');
INSERT INTO `access_log` VALUES (26779, '64.85.15596183294707073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:18:49', 2, 0, '', '2019-06-04 11:18:49');
INSERT INTO `access_log` VALUES (26780, '64.79.15596183295707053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:18:50', 2, 0, '', '2019-06-04 11:18:50');
INSERT INTO `access_log` VALUES (26781, '64.81.15596183321607055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:18:52', 1, 0, '', '2019-06-04 11:18:52');
INSERT INTO `access_log` VALUES (26782, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:18:52', 13, 0, '', '2019-06-04 11:18:52');
INSERT INTO `access_log` VALUES (26783, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:18:56', 5, 0, '', '2019-06-04 11:18:56');
INSERT INTO `access_log` VALUES (26784, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:18:57', 8, 0, '', '2019-06-04 11:18:57');
INSERT INTO `access_log` VALUES (26785, '64.76.15596183381117047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:18:58', 11, 0, '', '2019-06-04 11:18:58');
INSERT INTO `access_log` VALUES (26786, '64.83.15596183383047055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:18:58', 28, 0, '', '2019-06-04 11:18:58');
INSERT INTO `access_log` VALUES (26787, '65.54.15596183425027331', 27, 2, 'admin-application', '/admin-api/admins/admin/update', 'id=1&username=admins&nickname=管理员&password=123456', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:19:03', 7, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-04 11:19:03');
INSERT INTO `access_log` VALUES (26788, '64.77.15596183435017063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:19:04', 2, 0, '', '2019-06-04 11:19:04');
INSERT INTO `access_log` VALUES (26789, '64.82.15596183436037069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.170.254.175', '2019-06-04 11:19:04', 2, 0, '', '2019-06-04 11:19:04');
INSERT INTO `access_log` VALUES (26790, '65.49.15596183603517385', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:19:20', 10, 0, '', '2019-06-04 11:19:20');
INSERT INTO `access_log` VALUES (26791, '65.45.15596183622257385', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:19:22', 9, 0, '', '2019-06-04 11:19:22');
INSERT INTO `access_log` VALUES (26792, '65.46.15596183636617363', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:19:24', 14, 0, '', '2019-06-04 11:19:24');
INSERT INTO `access_log` VALUES (26793, '65.53.15596183653377341', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:19:25', 17, 0, '', '2019-06-04 11:19:25');
INSERT INTO `access_log` VALUES (26794, '65.52.15596183670537363', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:19:27', 8, 0, '', '2019-06-04 11:19:27');
INSERT INTO `access_log` VALUES (26795, '65.47.15596183674617367', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:19:27', 56, 0, '', '2019-06-04 11:19:28');
INSERT INTO `access_log` VALUES (26796, '65.50.15596183678937373', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:19:28', 10, 0, '', '2019-06-04 11:19:28');
INSERT INTO `access_log` VALUES (26797, '65.54.15596183683117333', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:19:28', 14, 0, '', '2019-06-04 11:19:28');
INSERT INTO `access_log` VALUES (26798, '65.48.15596183691617371', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:19:29', 9, 0, '', '2019-06-04 11:19:29');
INSERT INTO `access_log` VALUES (26799, '65.49.15596183699147387', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:19:30', 9, 0, '', '2019-06-04 11:19:30');
INSERT INTO `access_log` VALUES (26800, '66.51.15596183728286011', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.8.98.32', '2019-06-04 11:19:33', 14, 0, '', '2019-06-04 11:19:33');
INSERT INTO `access_log` VALUES (26801, '65.54.15596184750767335', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:21:15', 1, 1002001015, '账号未登陆', '2019-06-04 11:21:15');
INSERT INTO `access_log` VALUES (26802, '65.48.15596184750807373', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:21:15', 1, 1002001015, '账号未登陆', '2019-06-04 11:21:15');
INSERT INTO `access_log` VALUES (26803, '65.49.15596184750807389', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:21:15', 0, 1002001015, '账号未登陆', '2019-06-04 11:21:15');
INSERT INTO `access_log` VALUES (26804, '65.45.15596184776947389', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:21:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 11:21:18');
INSERT INTO `access_log` VALUES (26805, '65.46.15596184817047367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:21:22', 101, 0, '', '2019-06-04 11:21:22');
INSERT INTO `access_log` VALUES (26806, '65.51.15596184820167375', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:21:22', 10, 0, '', '2019-06-04 11:21:22');
INSERT INTO `access_log` VALUES (26807, '65.52.15596184820217367', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:21:22', 9, 0, '', '2019-06-04 11:21:22');
INSERT INTO `access_log` VALUES (26808, '65.53.15596184820207345', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:21:22', 9, 0, '', '2019-06-04 11:21:22');
INSERT INTO `access_log` VALUES (26809, '59.73.15596187504377381', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:25:50', 14, 0, '', '2019-06-04 11:25:50');
INSERT INTO `access_log` VALUES (26810, '65.52.15596187914957373', 0, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=8', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:26:31', 4, 1002001012, '访问令牌已过期', '2019-06-04 11:26:31');
INSERT INTO `access_log` VALUES (26811, '65.47.15596187988157375', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:26:39', 69, 0, '', '2019-06-04 11:26:39');
INSERT INTO `access_log` VALUES (26812, '65.48.15596187992517381', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:26:39', 94, 0, '', '2019-06-04 11:26:39');
INSERT INTO `access_log` VALUES (26813, '65.50.15596187992517381', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:26:39', 98, 0, '', '2019-06-04 11:26:39');
INSERT INTO `access_log` VALUES (26814, '65.54.15596187992567343', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:26:39', 95, 0, '', '2019-06-04 11:26:39');
INSERT INTO `access_log` VALUES (26815, '65.49.15596188036287397', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:26:44', 19, 0, '', '2019-06-04 11:26:44');
INSERT INTO `access_log` VALUES (26816, '65.45.15596188049177395', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:26:45', 11, 0, '', '2019-06-04 11:26:45');
INSERT INTO `access_log` VALUES (26817, '65.51.15596188064777383', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:26:46', 12, 0, '', '2019-06-04 11:26:46');
INSERT INTO `access_log` VALUES (26818, '65.46.15596188079877375', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:26:48', 11, 0, '', '2019-06-04 11:26:48');
INSERT INTO `access_log` VALUES (26819, '65.52.15596188095017375', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=8', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:26:50', 10, 0, '', '2019-06-04 11:26:50');
INSERT INTO `access_log` VALUES (26820, '65.47.15596188116467377', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=9', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:26:52', 230, 0, '', '2019-06-04 11:26:52');
INSERT INTO `access_log` VALUES (26821, '65.53.15596188136467351', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:26:54', 10, 0, '', '2019-06-04 11:26:54');
INSERT INTO `access_log` VALUES (26822, '65.50.15596188165587383', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=11', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:26:57', 9, 0, '', '2019-06-04 11:26:57');
INSERT INTO `access_log` VALUES (26823, '62.84.15596188182347221', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:26:58', 13, 0, '', '2019-06-04 11:26:58');
INSERT INTO `access_log` VALUES (26824, '59.80.15596188227237369', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:27:03', 11, 0, '', '2019-06-04 11:27:03');
INSERT INTO `access_log` VALUES (26825, '65.54.15596188257787345', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:27:06', 119, 0, '', '2019-06-04 11:27:06');
INSERT INTO `access_log` VALUES (26826, '65.49.15596188272877399', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:27:07', 9, 0, '', '2019-06-04 11:27:07');
INSERT INTO `access_log` VALUES (26827, '65.45.15596188288167397', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:27:09', 9, 0, '', '2019-06-04 11:27:09');
INSERT INTO `access_log` VALUES (26828, '65.46.15596188298407377', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=12', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:27:10', 10, 0, '', '2019-06-04 11:27:10');
INSERT INTO `access_log` VALUES (26829, '65.52.15596188300587377', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 11:27:10', 13, 0, '', '2019-06-04 11:27:10');
INSERT INTO `access_log` VALUES (26830, '64.79.15596191218127065', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 11:32:02', 11, 0, '', '2019-06-04 11:32:02');
INSERT INTO `access_log` VALUES (26831, '64.85.15596191218117085', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.116.23.39', '2019-06-04 11:32:02', 13, 0, '', '2019-06-04 11:32:02');
INSERT INTO `access_log` VALUES (26832, '59.76.15596193474547379', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.75.181.64', '2019-06-04 11:35:47', 3, 0, '', '2019-06-04 11:35:47');
INSERT INTO `access_log` VALUES (26833, '59.75.15596193474697387', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.75.181.64', '2019-06-04 11:35:47', 14, 2001001000, '服务端发生异常', '2019-06-04 11:35:47');
INSERT INTO `access_log` VALUES (26834, '64.82.15596193499827083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.75.181.64', '2019-06-04 11:35:50', 3, 0, '', '2019-06-04 11:35:50');
INSERT INTO `access_log` VALUES (26835, '64.80.15596193501797067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.75.181.64', '2019-06-04 11:35:50', 1, 0, '', '2019-06-04 11:35:50');
INSERT INTO `access_log` VALUES (26836, '64.79.15596193512697069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.75.181.64', '2019-06-04 11:35:51', 2, 0, '', '2019-06-04 11:35:51');
INSERT INTO `access_log` VALUES (26837, '64.85.15596193515147089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.75.181.64', '2019-06-04 11:35:52', 2, 0, '', '2019-06-04 11:35:52');
INSERT INTO `access_log` VALUES (26838, '64.84.15596193520837077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.75.181.64', '2019-06-04 11:35:52', 2, 0, '', '2019-06-04 11:35:52');
INSERT INTO `access_log` VALUES (26839, '65.48.15596194732967393', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:37:53', 12, 0, '', '2019-06-04 11:37:53');
INSERT INTO `access_log` VALUES (26840, '65.54.15596194746047355', 27, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=10', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 11:37:55', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-04 11:37:55');
INSERT INTO `access_log` VALUES (26841, '59.80.15596195087217379', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '218.4.53.106', '2019-06-04 11:38:29', 3, 0, '', '2019-06-04 11:38:29');
INSERT INTO `access_log` VALUES (26842, '59.74.15596195087217385', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '218.4.53.106', '2019-06-04 11:38:29', 12, 2001001000, '服务端发生异常', '2019-06-04 11:38:29');
INSERT INTO `access_log` VALUES (26843, '64.81.15596195112307073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '218.4.53.106', '2019-06-04 11:38:31', 3, 0, '', '2019-06-04 11:38:31');
INSERT INTO `access_log` VALUES (26844, '64.76.15596195113727065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '218.4.53.106', '2019-06-04 11:38:31', 2, 0, '', '2019-06-04 11:38:31');
INSERT INTO `access_log` VALUES (26845, '64.83.15596195123897073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '218.4.53.106', '2019-06-04 11:38:32', 2, 0, '', '2019-06-04 11:38:32');
INSERT INTO `access_log` VALUES (26846, '64.77.15596195128577081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '218.4.53.106', '2019-06-04 11:38:33', 1, 0, '', '2019-06-04 11:38:33');
INSERT INTO `access_log` VALUES (26847, '64.82.15596195133647087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '218.4.53.106', '2019-06-04 11:38:33', 2, 0, '', '2019-06-04 11:38:33');
INSERT INTO `access_log` VALUES (26848, '64.82.15596199468467093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.169.135.186', '2019-06-04 11:45:47', 3, 0, '', '2019-06-04 11:45:47');
INSERT INTO `access_log` VALUES (26849, '64.80.15596199469307077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.169.135.186', '2019-06-04 11:45:47', 2, 0, '', '2019-06-04 11:45:47');
INSERT INTO `access_log` VALUES (26850, '64.78.15596199486227087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.169.135.186', '2019-06-04 11:45:49', 2, 0, '', '2019-06-04 11:45:49');
INSERT INTO `access_log` VALUES (26851, '64.79.15596199493367079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.169.135.186', '2019-06-04 11:45:49', 395, 0, '', '2019-06-04 11:45:50');
INSERT INTO `access_log` VALUES (26852, '65.54.15596200648607363', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:47:45', 0, 1002001015, '账号未登陆', '2019-06-04 11:47:45');
INSERT INTO `access_log` VALUES (26853, '65.49.15596200648627417', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:47:45', 0, 1002001015, '账号未登陆', '2019-06-04 11:47:45');
INSERT INTO `access_log` VALUES (26854, '65.45.15596200648777415', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:47:45', 0, 1002001015, '账号未登陆', '2019-06-04 11:47:45');
INSERT INTO `access_log` VALUES (26855, '65.51.15596200673977403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:47:47', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 11:47:47');
INSERT INTO `access_log` VALUES (26856, '65.46.15596200694557395', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:47:49', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 11:47:49');
INSERT INTO `access_log` VALUES (26857, '65.52.15596200699417395', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:47:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 11:47:50');
INSERT INTO `access_log` VALUES (26858, '65.47.15596200703637397', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:47:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 11:47:50');
INSERT INTO `access_log` VALUES (26859, '65.48.15596200847907403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:05', 110, 0, '', '2019-06-04 11:48:05');
INSERT INTO `access_log` VALUES (26860, '65.54.15596200851147365', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:05', 9, 0, '', '2019-06-04 11:48:05');
INSERT INTO `access_log` VALUES (26861, '65.50.15596200851147403', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:05', 11, 0, '', '2019-06-04 11:48:05');
INSERT INTO `access_log` VALUES (26862, '65.45.15596200851147417', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:05', 10, 0, '', '2019-06-04 11:48:05');
INSERT INTO `access_log` VALUES (26863, '62.89.15596200914117253', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:11', 13, 0, '', '2019-06-04 11:48:11');
INSERT INTO `access_log` VALUES (26864, '59.74.15596200958507393', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:16', 12, 0, '', '2019-06-04 11:48:16');
INSERT INTO `access_log` VALUES (26865, '59.71.15596200984927401', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:18', 26, 2001001000, '服务端发生异常', '2019-06-04 11:48:19');
INSERT INTO `access_log` VALUES (26866, '59.77.15596201000857389', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:20', 14, 0, '', '2019-06-04 11:48:20');
INSERT INTO `access_log` VALUES (26867, '65.46.15596201040707397', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:24', 9, 0, '', '2019-06-04 11:48:24');
INSERT INTO `access_log` VALUES (26868, '65.52.15596201047297397', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:25', 10, 0, '', '2019-06-04 11:48:25');
INSERT INTO `access_log` VALUES (26869, '65.47.15596201053057399', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:25', 120, 0, '', '2019-06-04 11:48:25');
INSERT INTO `access_log` VALUES (26870, '66.50.15596201068066033', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:27', 13, 0, '', '2019-06-04 11:48:27');
INSERT INTO `access_log` VALUES (26871, '62.83.15596201107497251', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:31', 19, 0, '', '2019-06-04 11:48:31');
INSERT INTO `access_log` VALUES (26872, '62.84.15596201129787239', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:33', 15, 0, '', '2019-06-04 11:48:33');
INSERT INTO `access_log` VALUES (26873, '65.48.15596201234087405', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:43', 7, 0, '', '2019-06-04 11:48:43');
INSERT INTO `access_log` VALUES (26874, '65.45.15596201234327419', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:43', 9, 0, '', '2019-06-04 11:48:43');
INSERT INTO `access_log` VALUES (26875, '65.54.15596201234377367', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:43', 7, 0, '', '2019-06-04 11:48:43');
INSERT INTO `access_log` VALUES (26876, '65.50.15596201271267405', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:47', 9, 0, '', '2019-06-04 11:48:47');
INSERT INTO `access_log` VALUES (26877, '65.49.15596201271267421', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:47', 9, 0, '', '2019-06-04 11:48:47');
INSERT INTO `access_log` VALUES (26878, '65.51.15596201271307407', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:47', 9, 0, '', '2019-06-04 11:48:47');
INSERT INTO `access_log` VALUES (26879, '65.46.15596201302887399', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:50', 7, 0, '', '2019-06-04 11:48:50');
INSERT INTO `access_log` VALUES (26880, '65.52.15596201302887399', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:50', 8, 0, '', '2019-06-04 11:48:50');
INSERT INTO `access_log` VALUES (26881, '65.47.15596201302947401', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:50', 8, 0, '', '2019-06-04 11:48:50');
INSERT INTO `access_log` VALUES (26882, '62.80.15596201330267255', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:53', 11, 0, '', '2019-06-04 11:48:53');
INSERT INTO `access_log` VALUES (26883, '66.49.15596201360216041', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.26.182.118', '2019-06-04 11:48:56', 77, 0, '', '2019-06-04 11:48:56');
INSERT INTO `access_log` VALUES (26884, '59.75.15596201582157399', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '58.246.221.61', '2019-06-04 11:49:18', 0, 1002001015, '账号未登陆', '2019-06-04 11:49:18');
INSERT INTO `access_log` VALUES (26885, '65.45.15596201641107421', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '210.22.245.219', '2019-06-04 11:49:24', 1, 1002001015, '账号未登陆', '2019-06-04 11:49:24');
INSERT INTO `access_log` VALUES (26886, '65.50.15596201642527407', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '223.166.151.199', '2019-06-04 11:49:24', 0, 1002001015, '账号未登陆', '2019-06-04 11:49:24');
INSERT INTO `access_log` VALUES (26887, '65.49.15596201676217423', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '58.246.221.162', '2019-06-04 11:49:28', 0, 1002001015, '账号未登陆', '2019-06-04 11:49:28');
INSERT INTO `access_log` VALUES (26888, '66.54.15596201682736039', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '223.166.151.197', '2019-06-04 11:49:28', 1, 1002001015, '账号未登陆', '2019-06-04 11:49:28');
INSERT INTO `access_log` VALUES (26889, '59.73.15596205618217407', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '221.2.74.214', '2019-06-04 11:56:02', 3, 0, '', '2019-06-04 11:56:02');
INSERT INTO `access_log` VALUES (26890, '59.76.15596205618237397', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '221.2.74.214', '2019-06-04 11:56:02', 13, 2001001000, '服务端发生异常', '2019-06-04 11:56:02');
INSERT INTO `access_log` VALUES (26891, '64.81.15596205733587089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '221.2.74.214', '2019-06-04 11:56:13', 3, 0, '', '2019-06-04 11:56:13');
INSERT INTO `access_log` VALUES (26892, '64.76.15596205734697081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '221.2.74.214', '2019-06-04 11:56:13', 2, 0, '', '2019-06-04 11:56:13');
INSERT INTO `access_log` VALUES (26893, '59.80.15596205824787395', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '221.2.74.214', '2019-06-04 11:56:22', 3, 0, '', '2019-06-04 11:56:22');
INSERT INTO `access_log` VALUES (26894, '59.74.15596205824787401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '221.2.74.214', '2019-06-04 11:56:22', 13, 2001001000, '服务端发生异常', '2019-06-04 11:56:22');
INSERT INTO `access_log` VALUES (26895, '65.53.15596231080177417', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:38:28', 1, 1002001015, '账号未登陆', '2019-06-04 12:38:28');
INSERT INTO `access_log` VALUES (26896, '65.48.15596231080167449', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:38:28', 1, 1002001015, '账号未登陆', '2019-06-04 12:38:28');
INSERT INTO `access_log` VALUES (26897, '65.54.15596231080187411', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:38:28', 0, 1002001015, '账号未登陆', '2019-06-04 12:38:28');
INSERT INTO `access_log` VALUES (26898, '65.45.15596231100017461', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:38:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 12:38:30');
INSERT INTO `access_log` VALUES (26899, '65.50.15596231125897449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:38:33', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 12:38:33');
INSERT INTO `access_log` VALUES (26900, '65.46.15596231357957443', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:38:56', 80, 0, '', '2019-06-04 12:38:56');
INSERT INTO `access_log` VALUES (26901, '65.52.15596231360967441', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:38:56', 11, 0, '', '2019-06-04 12:38:56');
INSERT INTO `access_log` VALUES (26902, '65.53.15596231360987419', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:38:56', 10, 0, '', '2019-06-04 12:38:56');
INSERT INTO `access_log` VALUES (26903, '65.47.15596231360977443', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:38:56', 12, 0, '', '2019-06-04 12:38:56');
INSERT INTO `access_log` VALUES (26904, '62.85.15596231430047291', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:39:03', 21, 0, '', '2019-06-04 12:39:03');
INSERT INTO `access_log` VALUES (26905, '66.54.15596231482576079', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:39:08', 23, 0, '', '2019-06-04 12:39:08');
INSERT INTO `access_log` VALUES (26906, '65.54.15596231566347413', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:39:17', 25, 0, '', '2019-06-04 12:39:17');
INSERT INTO `access_log` VALUES (26907, '65.45.15596231608287463', 27, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:39:21', 7, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-04 12:39:21');
INSERT INTO `access_log` VALUES (26908, '65.49.15596231728097465', 27, 2, 'admin-application', '/admin-api/admins/admin/update', 'id=1&username=yudaoyuanma&nickname=管理员&password=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:39:33', 377, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-04 12:39:33');
INSERT INTO `access_log` VALUES (26909, '65.46.15596231798687445', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:39:40', 10, 0, '', '2019-06-04 12:39:40');
INSERT INTO `access_log` VALUES (26910, '65.53.15596232016137421', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:40:02', 37, 0, '', '2019-06-04 12:40:02');
INSERT INTO `access_log` VALUES (26911, '65.48.15596232164377453', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:40:16', 14, 0, '', '2019-06-04 12:40:16');
INSERT INTO `access_log` VALUES (26912, '65.54.15596232178547415', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:40:18', 9, 0, '', '2019-06-04 12:40:18');
INSERT INTO `access_log` VALUES (26913, '65.45.15596232179297465', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:40:18', 161, 0, '', '2019-06-04 12:40:18');
INSERT INTO `access_log` VALUES (26914, '66.51.15596232181646077', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:40:18', 13, 0, '', '2019-06-04 12:40:18');
INSERT INTO `access_log` VALUES (26915, '62.84.15596232185077281', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:40:19', 13, 0, '', '2019-06-04 12:40:19');
INSERT INTO `access_log` VALUES (26916, '59.75.15596232288047441', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:40:29', 11, 0, '', '2019-06-04 12:40:29');
INSERT INTO `access_log` VALUES (26917, '59.79.15596232288047439', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:40:29', 15, 2001001000, '服务端发生异常', '2019-06-04 12:40:29');
INSERT INTO `access_log` VALUES (26918, '64.84.15596232346177131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:40:35', 11, 0, '', '2019-06-04 12:40:35');
INSERT INTO `access_log` VALUES (26919, '64.81.15596232347087125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:40:35', 2, 0, '', '2019-06-04 12:40:35');
INSERT INTO `access_log` VALUES (26920, '64.83.15596232365487125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:40:37', 2, 0, '', '2019-06-04 12:40:37');
INSERT INTO `access_log` VALUES (26921, '64.77.15596232384227133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:40:38', 1, 0, '', '2019-06-04 12:40:38');
INSERT INTO `access_log` VALUES (26922, '66.54.15596232658896081', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13458745582', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:41:06', 79, 0, '', '2019-06-04 12:41:06');
INSERT INTO `access_log` VALUES (26923, '66.53.15596232734106077', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13458745582&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:41:13', 579, 0, '', '2019-06-04 12:41:14');
INSERT INTO `access_log` VALUES (26924, '64.85.15596232811947145', 104, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:41:21', 5, 0, '', '2019-06-04 12:41:21');
INSERT INTO `access_log` VALUES (26925, '64.81.15596232814127127', 104, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:41:21', 5, 0, '', '2019-06-04 12:41:21');
INSERT INTO `access_log` VALUES (26926, '64.83.15596232823577127', 104, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:41:22', 5, 0, '', '2019-06-04 12:41:22');
INSERT INTO `access_log` VALUES (26927, '66.50.15596232845646077', 104, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:41:25', 6, 0, '', '2019-06-04 12:41:25');
INSERT INTO `access_log` VALUES (26928, '64.80.15596233036197125', 104, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:41:44', 4, 0, '', '2019-06-04 12:41:44');
INSERT INTO `access_log` VALUES (26929, '64.79.15596233037597127', 104, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:41:44', 5, 0, '', '2019-06-04 12:41:44');
INSERT INTO `access_log` VALUES (26930, '59.76.15596233048687435', 104, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:41:45', 7, 0, '', '2019-06-04 12:41:45');
INSERT INTO `access_log` VALUES (26931, '59.79.15596233048797441', 104, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.192.170.240', '2019-06-04 12:41:45', 15, 2001001000, '服务端发生异常', '2019-06-04 12:41:45');
INSERT INTO `access_log` VALUES (26932, '65.49.15596235572697471', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 12:45:57', 1, 1002001015, '账号未登陆', '2019-06-04 12:45:57');
INSERT INTO `access_log` VALUES (26933, '65.48.15596236012487459', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 12:46:41', 1, 1002001015, '账号未登陆', '2019-06-04 12:46:41');
INSERT INTO `access_log` VALUES (26934, '65.49.15596236446637473', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 12:47:25', 337, 1002002001, '密码不正确', '2019-06-04 12:47:25');
INSERT INTO `access_log` VALUES (26935, '65.51.15596236576107461', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=15601691300&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 12:47:38', 84, 0, '', '2019-06-04 12:47:38');
INSERT INTO `access_log` VALUES (26936, '65.53.15596236611957429', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.89.239.232', '2019-06-04 12:47:41', 0, 1002001015, '账号未登陆', '2019-06-04 12:47:41');
INSERT INTO `access_log` VALUES (26937, '65.47.15596236778317455', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 12:47:58', 0, 1002001015, '账号未登陆', '2019-06-04 12:47:58');
INSERT INTO `access_log` VALUES (26938, '65.49.15596237370907475', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.129.7.235', '2019-06-04 12:48:57', 1, 1002001015, '账号未登陆', '2019-06-04 12:48:57');
INSERT INTO `access_log` VALUES (26939, '59.72.15596251682547465', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '112.17.83.25', '2019-06-04 13:12:48', 20, 0, '', '2019-06-04 13:12:48');
INSERT INTO `access_log` VALUES (26940, '59.77.15596251684007459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '112.17.83.25', '2019-06-04 13:12:48', 13, 2001001000, '服务端发生异常', '2019-06-04 13:12:48');
INSERT INTO `access_log` VALUES (26941, '59.75.15596258142917477', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 13:23:34', 4, 0, '', '2019-06-04 13:23:34');
INSERT INTO `access_log` VALUES (26942, '59.74.15596258142917473', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 13:23:34', 11, 2001001000, '服务端发生异常', '2019-06-04 13:23:34');
INSERT INTO `access_log` VALUES (26943, '64.78.15596258167777169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 13:23:37', 19, 0, '', '2019-06-04 13:23:37');
INSERT INTO `access_log` VALUES (26944, '64.79.15596258169287161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 13:23:37', 2, 0, '', '2019-06-04 13:23:37');
INSERT INTO `access_log` VALUES (26945, '64.85.15596258189017181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 13:23:39', 2, 0, '', '2019-06-04 13:23:39');
INSERT INTO `access_log` VALUES (26946, '64.84.15596258196527169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 13:23:40', 2, 0, '', '2019-06-04 13:23:40');
INSERT INTO `access_log` VALUES (26947, '64.81.15596258265857163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 13:23:47', 2, 0, '', '2019-06-04 13:23:47');
INSERT INTO `access_log` VALUES (26948, '64.76.15596258266977155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 13:23:47', 2, 0, '', '2019-06-04 13:23:47');
INSERT INTO `access_log` VALUES (26949, '59.72.15596258357167475', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 13:23:56', 2, 0, '', '2019-06-04 13:23:56');
INSERT INTO `access_log` VALUES (26950, '59.71.15596258357107481', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.196.61', '2019-06-04 13:23:56', 10, 2001001000, '服务端发生异常', '2019-06-04 13:23:56');
INSERT INTO `access_log` VALUES (26951, '65.52.15596262889367487', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:31:29', 1, 1002001015, '账号未登陆', '2019-06-04 13:31:29');
INSERT INTO `access_log` VALUES (26952, '65.53.15596262889367465', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:31:29', 1, 1002001015, '账号未登陆', '2019-06-04 13:31:29');
INSERT INTO `access_log` VALUES (26953, '65.51.15596262889367497', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:31:29', 1, 1002001015, '账号未登陆', '2019-06-04 13:31:29');
INSERT INTO `access_log` VALUES (26954, '65.46.15596262906467489', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:31:31', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 13:31:31');
INSERT INTO `access_log` VALUES (26955, '65.47.15596262931547491', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:31:33', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 13:31:33');
INSERT INTO `access_log` VALUES (26956, '65.48.15596262954937497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:31:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 13:31:36');
INSERT INTO `access_log` VALUES (26957, '65.52.15596263582637489', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:32:38', 85, 0, '', '2019-06-04 13:32:38');
INSERT INTO `access_log` VALUES (26958, '65.51.15596263586017499', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:32:39', 406, 0, '', '2019-06-04 13:32:39');
INSERT INTO `access_log` VALUES (26959, '65.53.15596263586047467', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:32:39', 403, 0, '', '2019-06-04 13:32:39');
INSERT INTO `access_log` VALUES (26960, '65.46.15596263586107491', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:32:39', 398, 0, '', '2019-06-04 13:32:39');
INSERT INTO `access_log` VALUES (26961, '62.88.15596263620157341', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:32:42', 29, 0, '', '2019-06-04 13:32:42');
INSERT INTO `access_log` VALUES (26962, '59.75.15596263666477485', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:32:47', 12, 0, '', '2019-06-04 13:32:47');
INSERT INTO `access_log` VALUES (26963, '65.48.15596263731957499', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:32:53', 18, 0, '', '2019-06-04 13:32:53');
INSERT INTO `access_log` VALUES (26964, '65.50.15596263750497501', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:32:55', 8, 0, '', '2019-06-04 13:32:55');
INSERT INTO `access_log` VALUES (26965, '65.45.15596263767007511', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:32:57', 18, 0, '', '2019-06-04 13:32:57');
INSERT INTO `access_log` VALUES (26966, '65.49.15596263774887513', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:32:57', 12, 0, '', '2019-06-04 13:32:58');
INSERT INTO `access_log` VALUES (26967, '65.52.15596263798067491', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '125.71.76.3', '2019-06-04 13:33:00', 10, 0, '', '2019-06-04 13:33:00');
INSERT INTO `access_log` VALUES (26968, '65.48.15596264373187501', 0, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.165', '2019-06-04 13:33:57', 1, 1002001015, '账号未登陆', '2019-06-04 13:33:57');
INSERT INTO `access_log` VALUES (26969, '65.45.15596264725247513', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:34:33', 0, 1002001015, '账号未登陆', '2019-06-04 13:34:33');
INSERT INTO `access_log` VALUES (26970, '65.49.15596264725257515', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:34:33', 0, 1002001015, '账号未登陆', '2019-06-04 13:34:33');
INSERT INTO `access_log` VALUES (26971, '65.52.15596264725327493', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:34:33', 1, 1002001015, '账号未登陆', '2019-06-04 13:34:33');
INSERT INTO `access_log` VALUES (26972, '65.47.15596264754377497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:34:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 13:34:35');
INSERT INTO `access_log` VALUES (26973, '65.46.15596264886547495', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:34:49', 1104, 0, '', '2019-06-04 13:34:50');
INSERT INTO `access_log` VALUES (26974, '65.53.15596264900107471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:34:50', 8, 0, '', '2019-06-04 13:34:50');
INSERT INTO `access_log` VALUES (26975, '65.48.15596264900167503', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:34:50', 8, 0, '', '2019-06-04 13:34:50');
INSERT INTO `access_log` VALUES (26976, '65.54.15596264900187467', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:34:50', 8, 0, '', '2019-06-04 13:34:50');
INSERT INTO `access_log` VALUES (26977, '62.87.15596264926057331', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:34:53', 103, 0, '', '2019-06-04 13:34:53');
INSERT INTO `access_log` VALUES (26978, '62.80.15596264970367341', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=8&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:34:57', 12, 0, '', '2019-06-04 13:34:57');
INSERT INTO `access_log` VALUES (26979, '62.85.15596264976407337', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:34:58', 19, 0, '', '2019-06-04 13:34:58');
INSERT INTO `access_log` VALUES (26980, '62.81.15596265003717323', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:35:00', 10, 0, '', '2019-06-04 13:35:00');
INSERT INTO `access_log` VALUES (26981, '62.89.15596265093387341', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:35:09', 143, 0, '', '2019-06-04 13:35:09');
INSERT INTO `access_log` VALUES (26982, '64.84.15596265107277179', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:35:11', 11, 0, '', '2019-06-04 13:35:11');
INSERT INTO `access_log` VALUES (26983, '64.85.15596265107257191', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:35:11', 14, 0, '', '2019-06-04 13:35:11');
INSERT INTO `access_log` VALUES (26984, '64.76.15596265136417165', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:35:14', 11, 0, '', '2019-06-04 13:35:14');
INSERT INTO `access_log` VALUES (26985, '64.81.15596265136397173', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:35:14', 13, 0, '', '2019-06-04 13:35:14');
INSERT INTO `access_log` VALUES (26986, '64.82.15596265171187187', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:35:17', 8, 0, '', '2019-06-04 13:35:17');
INSERT INTO `access_log` VALUES (26987, '64.83.15596265171167173', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:35:17', 11, 0, '', '2019-06-04 13:35:17');
INSERT INTO `access_log` VALUES (26988, '64.77.15596265171167181', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:35:17', 14, 0, '', '2019-06-04 13:35:17');
INSERT INTO `access_log` VALUES (26989, '65.45.15596265302647515', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:35:30', 19, 0, '', '2019-06-04 13:35:30');
INSERT INTO `access_log` VALUES (26990, '65.47.15596265332687499', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:35:33', 11, 0, '', '2019-06-04 13:35:33');
INSERT INTO `access_log` VALUES (26991, '65.51.15596265380577505', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:35:38', 8, 0, '', '2019-06-04 13:35:38');
INSERT INTO `access_log` VALUES (26992, '65.53.15596265402507473', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:35:40', 13, 0, '', '2019-06-04 13:35:40');
INSERT INTO `access_log` VALUES (26993, '65.48.15596265488347505', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:35:49', 9, 0, '', '2019-06-04 13:35:49');
INSERT INTO `access_log` VALUES (26994, '65.54.15596266944257471', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '124.204.44.98', '2019-06-04 13:38:14', 20, 0, '', '2019-06-04 13:38:14');
INSERT INTO `access_log` VALUES (26995, '59.78.15596268818407495', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '101.68.86.194', '2019-06-04 13:41:22', 4, 0, '', '2019-06-04 13:41:22');
INSERT INTO `access_log` VALUES (26996, '59.73.15596268818427495', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '101.68.86.194', '2019-06-04 13:41:22', 13, 2001001000, '服务端发生异常', '2019-06-04 13:41:22');
INSERT INTO `access_log` VALUES (26997, '65.54.15596269590017475', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:42:39', 3, 1002001012, '访问令牌已过期', '2019-06-04 13:42:39');
INSERT INTO `access_log` VALUES (26998, '65.48.15596269590007511', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:42:39', 4, 1002001012, '访问令牌已过期', '2019-06-04 13:42:39');
INSERT INTO `access_log` VALUES (26999, '65.50.15596269590067513', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:42:39', 3, 1002001012, '访问令牌已过期', '2019-06-04 13:42:39');
INSERT INTO `access_log` VALUES (27000, '65.52.15596269631017503', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:42:43', 59, 0, '', '2019-06-04 13:42:43');
INSERT INTO `access_log` VALUES (27001, '65.49.15596269633507525', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:42:43', 11, 0, '', '2019-06-04 13:42:43');
INSERT INTO `access_log` VALUES (27002, '65.47.15596269633547507', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:42:43', 158, 0, '', '2019-06-04 13:42:44');
INSERT INTO `access_log` VALUES (27003, '65.45.15596269633537523', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:42:43', 157, 0, '', '2019-06-04 13:42:44');
INSERT INTO `access_log` VALUES (27004, '65.51.15596269661637513', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:42:46', 19, 0, '', '2019-06-04 13:42:46');
INSERT INTO `access_log` VALUES (27005, '64.78.15596269687877187', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:42:49', 13, 0, '', '2019-06-04 13:42:49');
INSERT INTO `access_log` VALUES (27006, '64.80.15596269687857177', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:42:49', 16, 0, '', '2019-06-04 13:42:49');
INSERT INTO `access_log` VALUES (27007, '64.84.15596269715487187', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:42:52', 10, 0, '', '2019-06-04 13:42:52');
INSERT INTO `access_log` VALUES (27008, '64.85.15596269715477199', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:42:52', 12, 0, '', '2019-06-04 13:42:52');
INSERT INTO `access_log` VALUES (27009, '64.81.15596269743387181', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:42:54', 9, 0, '', '2019-06-04 13:42:54');
INSERT INTO `access_log` VALUES (27010, '65.54.15596269913967477', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:11', 18, 0, '', '2019-06-04 13:43:11');
INSERT INTO `access_log` VALUES (27011, '65.50.15596269935347515', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:14', 10, 0, '', '2019-06-04 13:43:14');
INSERT INTO `access_log` VALUES (27012, '65.48.15596269954217513', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:15', 10, 0, '', '2019-06-04 13:43:15');
INSERT INTO `access_log` VALUES (27013, '65.52.15596269978567505', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:18', 13, 0, '', '2019-06-04 13:43:18');
INSERT INTO `access_log` VALUES (27014, '65.49.15596270008527527', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:21', 9, 0, '', '2019-06-04 13:43:21');
INSERT INTO `access_log` VALUES (27015, '65.45.15596270019727525', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:22', 9, 0, '', '2019-06-04 13:43:22');
INSERT INTO `access_log` VALUES (27016, '65.47.15596270036137509', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:24', 18, 0, '', '2019-06-04 13:43:24');
INSERT INTO `access_log` VALUES (27017, '59.73.15596270147077497', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:35', 12, 0, '', '2019-06-04 13:43:35');
INSERT INTO `access_log` VALUES (27018, '59.76.15596270191937487', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:39', 508, 2001001000, '服务端发生异常', '2019-06-04 13:43:40');
INSERT INTO `access_log` VALUES (27019, '59.79.15596270230947493', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:43', 204, 0, '', '2019-06-04 13:43:43');
INSERT INTO `access_log` VALUES (27020, '59.75.15596270283037495', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:48', 11, 0, '', '2019-06-04 13:43:48');
INSERT INTO `access_log` VALUES (27021, '59.80.15596270316487485', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:52', 11, 0, '', '2019-06-04 13:43:52');
INSERT INTO `access_log` VALUES (27022, '59.72.15596270326237493', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:53', 16, 0, '', '2019-06-04 13:43:53');
INSERT INTO `access_log` VALUES (27023, '59.71.15596270334157499', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:53', 11, 0, '', '2019-06-04 13:43:53');
INSERT INTO `access_log` VALUES (27024, '59.77.15596270343677487', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=INVALID&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:54', 11, 0, '', '2019-06-04 13:43:54');
INSERT INTO `access_log` VALUES (27025, '59.78.15596270358837499', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:43:56', 78, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-04 13:43:56');
INSERT INTO `access_log` VALUES (27026, '59.73.15596270402397499', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:44:00', 11, 0, '', '2019-06-04 13:44:00');
INSERT INTO `access_log` VALUES (27027, '66.56.15596270447636125', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:44:05', 21, 0, '', '2019-06-04 13:44:05');
INSERT INTO `access_log` VALUES (27028, '66.50.15596271391336129', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 13:45:39', 15, 0, '', '2019-06-04 13:45:39');
INSERT INTO `access_log` VALUES (27029, '59.72.15596274146167499', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:15', 3, 0, '', '2019-06-04 13:50:15');
INSERT INTO `access_log` VALUES (27030, '59.71.15596274146167505', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:15', 13, 2001001000, '服务端发生异常', '2019-06-04 13:50:15');
INSERT INTO `access_log` VALUES (27031, '64.76.15596274314977179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:31', 2, 0, '', '2019-06-04 13:50:32');
INSERT INTO `access_log` VALUES (27032, '64.83.15596274315707187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:32', 8, 0, '', '2019-06-04 13:50:32');
INSERT INTO `access_log` VALUES (27033, '64.82.15596274333237201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:33', 3, 0, '', '2019-06-04 13:50:33');
INSERT INTO `access_log` VALUES (27034, '64.77.15596274343267195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:34', 2, 0, '', '2019-06-04 13:50:34');
INSERT INTO `access_log` VALUES (27035, '64.78.15596274349557195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:35', 2, 0, '', '2019-06-04 13:50:35');
INSERT INTO `access_log` VALUES (27036, '64.80.15596274353617185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:35', 2, 0, '', '2019-06-04 13:50:35');
INSERT INTO `access_log` VALUES (27037, '65.51.15596274481907521', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:48', 1, 1002001015, '账号未登陆', '2019-06-04 13:50:48');
INSERT INTO `access_log` VALUES (27038, '65.46.15596274481927513', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:48', 1, 1002001015, '账号未登陆', '2019-06-04 13:50:48');
INSERT INTO `access_log` VALUES (27039, '65.53.15596274482007489', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:48', 0, 1002001015, '账号未登陆', '2019-06-04 13:50:48');
INSERT INTO `access_log` VALUES (27040, '65.54.15596274522837485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:52', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 13:50:52');
INSERT INTO `access_log` VALUES (27041, '65.48.15596274574287521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:57', 89, 0, '', '2019-06-04 13:50:58');
INSERT INTO `access_log` VALUES (27042, '65.52.15596274576977513', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:58', 9, 0, '', '2019-06-04 13:50:58');
INSERT INTO `access_log` VALUES (27043, '65.49.15596274576987535', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:58', 10, 0, '', '2019-06-04 13:50:58');
INSERT INTO `access_log` VALUES (27044, '65.45.15596274577047533', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:50:58', 9, 0, '', '2019-06-04 13:50:58');
INSERT INTO `access_log` VALUES (27045, '62.80.15596274656467355', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:51:06', 13, 0, '', '2019-06-04 13:51:06');
INSERT INTO `access_log` VALUES (27046, '66.49.15596274710426141', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:51:11', 14, 0, '', '2019-06-04 13:51:11');
INSERT INTO `access_log` VALUES (27047, '59.79.15596274742097501', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.163', '2019-06-04 13:51:14', 3, 0, '', '2019-06-04 13:51:14');
INSERT INTO `access_log` VALUES (27048, '59.75.15596274750307503', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.207.186', '2019-06-04 13:51:15', 13, 2001001000, '服务端发生异常', '2019-06-04 13:51:15');
INSERT INTO `access_log` VALUES (27049, '65.53.15596274763577491', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:51:16', 18, 0, '', '2019-06-04 13:51:16');
INSERT INTO `access_log` VALUES (27050, '65.46.15596274785327515', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:51:19', 10, 0, '', '2019-06-04 13:51:19');
INSERT INTO `access_log` VALUES (27051, '65.51.15596274810107523', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:51:21', 8, 0, '', '2019-06-04 13:51:21');
INSERT INTO `access_log` VALUES (27052, '65.50.15596274877407525', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:51:28', 12, 0, '', '2019-06-04 13:51:28');
INSERT INTO `access_log` VALUES (27053, '65.52.15596275015867515', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:51:42', 8, 0, '', '2019-06-04 13:51:42');
INSERT INTO `access_log` VALUES (27054, '65.49.15596275103347537', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:51:50', 65, 0, '', '2019-06-04 13:51:50');
INSERT INTO `access_log` VALUES (27055, '59.71.15596275121447507', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:51:52', 11, 0, '', '2019-06-04 13:51:52');
INSERT INTO `access_log` VALUES (27056, '59.77.15596275147587495', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '49.77.184.164', '2019-06-04 13:51:55', 20, 2001001000, '服务端发生异常', '2019-06-04 13:51:55');
INSERT INTO `access_log` VALUES (27057, '66.50.15596277124056137', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Mobile Safari/537.36', '113.116.23.39', '2019-06-04 13:55:12', 9, 1001003000, '验证码不存在', '2019-06-04 13:55:12');
INSERT INTO `access_log` VALUES (27058, '66.51.15596277151456139', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Mobile Safari/537.36', '113.116.23.39', '2019-06-04 13:55:15', 8, 1001003000, '验证码不存在', '2019-06-04 13:55:15');
INSERT INTO `access_log` VALUES (27059, '65.52.15596280618347523', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-04 14:01:02', 261, 1002001012, '访问令牌已过期', '2019-06-04 14:01:02');
INSERT INTO `access_log` VALUES (27060, '65.48.15596280618347531', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-04 14:01:02', 262, 1002001012, '访问令牌已过期', '2019-06-04 14:01:02');
INSERT INTO `access_log` VALUES (27061, '65.49.15596280618347545', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-04 14:01:02', 261, 1002001012, '访问令牌已过期', '2019-06-04 14:01:02');
INSERT INTO `access_log` VALUES (27062, '65.45.15596280624097543', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-04 14:01:02', 4, 1002001012, '访问令牌已过期', '2019-06-04 14:01:02');
INSERT INTO `access_log` VALUES (27063, '65.47.15596280624117527', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-04 14:01:02', 3, 1002001012, '访问令牌已过期', '2019-06-04 14:01:02');
INSERT INTO `access_log` VALUES (27064, '65.53.15596280624137501', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-04 14:01:02', 2, 1002001012, '访问令牌已过期', '2019-06-04 14:01:02');
INSERT INTO `access_log` VALUES (27065, '65.46.15596280662207525', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-04 14:01:06', 82, 0, '', '2019-06-04 14:01:06');
INSERT INTO `access_log` VALUES (27066, '65.51.15596280665237533', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-04 14:01:07', 9, 0, '', '2019-06-04 14:01:07');
INSERT INTO `access_log` VALUES (27067, '65.50.15596280665257535', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-04 14:01:07', 9, 0, '', '2019-06-04 14:01:07');
INSERT INTO `access_log` VALUES (27068, '65.54.15596280665247497', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-04 14:01:07', 11, 0, '', '2019-06-04 14:01:07');
INSERT INTO `access_log` VALUES (27069, '64.76.15596280693637189', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-04 14:01:09', 8, 0, '', '2019-06-04 14:01:09');
INSERT INTO `access_log` VALUES (27070, '64.81.15596280693617197', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.176.88.206', '2019-06-04 14:01:09', 12, 0, '', '2019-06-04 14:01:09');
INSERT INTO `access_log` VALUES (27071, '66.57.15596282148456149', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:03:35', 15, 0, '', '2019-06-04 14:03:35');
INSERT INTO `access_log` VALUES (27072, '66.53.15596282163586145', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:03:36', 13, 0, '', '2019-06-04 14:03:36');
INSERT INTO `access_log` VALUES (27073, '66.55.15596282175026155', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=4&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:03:38', 13, 0, '', '2019-06-04 14:03:38');
INSERT INTO `access_log` VALUES (27074, '66.52.15596282188066151', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=5&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:03:39', 14, 0, '', '2019-06-04 14:03:39');
INSERT INTO `access_log` VALUES (27075, '66.50.15596282198626145', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=6&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:03:40', 12, 0, '', '2019-06-04 14:03:40');
INSERT INTO `access_log` VALUES (27076, '66.51.15596282208546147', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=7&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:03:41', 12, 0, '', '2019-06-04 14:03:41');
INSERT INTO `access_log` VALUES (27077, '66.56.15596282217256143', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=8&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:03:42', 12, 0, '', '2019-06-04 14:03:42');
INSERT INTO `access_log` VALUES (27078, '66.49.15596282226146153', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:03:43', 9, 0, '', '2019-06-04 14:03:43');
INSERT INTO `access_log` VALUES (27079, '65.48.15596283949347537', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:06:35', 11, 0, '', '2019-06-04 14:06:35');
INSERT INTO `access_log` VALUES (27080, '65.53.15596283949357507', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:06:35', 11, 0, '', '2019-06-04 14:06:35');
INSERT INTO `access_log` VALUES (27081, '65.47.15596283949437533', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:06:35', 9, 0, '', '2019-06-04 14:06:35');
INSERT INTO `access_log` VALUES (27082, '65.45.15596283949987549', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:06:35', 27, 0, '', '2019-06-04 14:06:35');
INSERT INTO `access_log` VALUES (27083, '65.54.15596284003727503', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:06:40', 17, 0, '', '2019-06-04 14:06:40');
INSERT INTO `access_log` VALUES (27084, '65.50.15596284003777541', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:06:40', 15, 0, '', '2019-06-04 14:06:40');
INSERT INTO `access_log` VALUES (27085, '65.51.15596284003917539', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:06:40', 7, 0, '', '2019-06-04 14:06:40');
INSERT INTO `access_log` VALUES (27086, '65.52.15596284004297531', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:06:40', 18, 0, '', '2019-06-04 14:06:40');
INSERT INTO `access_log` VALUES (27087, '66.54.15596284088116153', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:06:49', 14, 0, '', '2019-06-04 14:06:49');
INSERT INTO `access_log` VALUES (27088, '65.45.15596287618217555', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:12:42', 4, 1002001012, '访问令牌已过期', '2019-06-04 14:12:42');
INSERT INTO `access_log` VALUES (27089, '65.46.15596287618237537', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:12:42', 4, 1002001012, '访问令牌已过期', '2019-06-04 14:12:42');
INSERT INTO `access_log` VALUES (27090, '65.51.15596287618387545', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:12:42', 3, 1002001012, '访问令牌已过期', '2019-06-04 14:12:42');
INSERT INTO `access_log` VALUES (27091, '65.50.15596287634687547', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:12:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 14:12:43');
INSERT INTO `access_log` VALUES (27092, '65.54.15596287698757509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:12:50', 260, 0, '', '2019-06-04 14:12:50');
INSERT INTO `access_log` VALUES (27093, '65.49.15596287705337559', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:12:51', 93, 0, '', '2019-06-04 14:12:51');
INSERT INTO `access_log` VALUES (27094, '65.52.15596287705307537', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:12:51', 95, 0, '', '2019-06-04 14:12:51');
INSERT INTO `access_log` VALUES (27095, '65.47.15596287705377541', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:12:51', 90, 0, '', '2019-06-04 14:12:51');
INSERT INTO `access_log` VALUES (27096, '62.80.15596287740337373', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:12:54', 13, 0, '', '2019-06-04 14:12:54');
INSERT INTO `access_log` VALUES (27097, '62.85.15596287766917369', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:12:57', 12, 0, '', '2019-06-04 14:12:57');
INSERT INTO `access_log` VALUES (27098, '62.82.15596287906807377', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:13:11', 15, 0, '', '2019-06-04 14:13:11');
INSERT INTO `access_log` VALUES (27099, '64.81.15596287967977207', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:13:17', 234, 0, '', '2019-06-04 14:13:17');
INSERT INTO `access_log` VALUES (27100, '64.76.15596287967957199', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:13:17', 239, 0, '', '2019-06-04 14:13:17');
INSERT INTO `access_log` VALUES (27101, '64.82.15596287999517221', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:13:20', 9, 0, '', '2019-06-04 14:13:20');
INSERT INTO `access_log` VALUES (27102, '64.83.15596287999517207', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:13:20', 11, 0, '', '2019-06-04 14:13:20');
INSERT INTO `access_log` VALUES (27103, '64.80.15596288017217205', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:13:22', 10, 0, '', '2019-06-04 14:13:22');
INSERT INTO `access_log` VALUES (27104, '64.79.15596288017247207', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:13:22', 8, 0, '', '2019-06-04 14:13:22');
INSERT INTO `access_log` VALUES (27105, '64.78.15596288017207215', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:13:22', 15, 0, '', '2019-06-04 14:13:22');
INSERT INTO `access_log` VALUES (27106, '64.84.15596288220437215', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:13:42', 10, 0, '', '2019-06-04 14:13:42');
INSERT INTO `access_log` VALUES (27107, '59.72.15596288270387519', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:13:47', 378, 0, '', '2019-06-04 14:13:47');
INSERT INTO `access_log` VALUES (27108, '59.77.15596288355667513', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:13:56', 12, 0, '', '2019-06-04 14:13:56');
INSERT INTO `access_log` VALUES (27109, '64.76.15596288401517201', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:14:00', 9, 0, '', '2019-06-04 14:14:00');
INSERT INTO `access_log` VALUES (27110, '64.82.15596288438567223', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:14:04', 9, 0, '', '2019-06-04 14:14:04');
INSERT INTO `access_log` VALUES (27111, '62.88.15596288502707377', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.91.60.104', '2019-06-04 14:14:10', 1, 1002001015, '账号未登陆', '2019-06-04 14:14:10');
INSERT INTO `access_log` VALUES (27112, '65.54.15596288512157511', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:14:11', 1, 1002001015, '账号未登陆', '2019-06-04 14:14:11');
INSERT INTO `access_log` VALUES (27113, '65.52.15596288512217539', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:14:11', 1, 1002001015, '账号未登陆', '2019-06-04 14:14:11');
INSERT INTO `access_log` VALUES (27114, '65.49.15596288512377561', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:14:11', 0, 1002001015, '账号未登陆', '2019-06-04 14:14:11');
INSERT INTO `access_log` VALUES (27115, '64.77.15596288563687217', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.60.104', '2019-06-04 14:14:16', 1, 1002001015, '账号未登陆', '2019-06-04 14:14:16');
INSERT INTO `access_log` VALUES (27116, '64.79.15596288628057209', 0, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.197', '2019-06-04 14:14:23', 0, 1002001015, '账号未登陆', '2019-06-04 14:14:23');
INSERT INTO `access_log` VALUES (27117, '64.78.15596288681557217', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.151.178.197', '2019-06-04 14:14:28', 0, 1002001015, '账号未登陆', '2019-06-04 14:14:28');
INSERT INTO `access_log` VALUES (27118, '59.75.15596288961017523', 0, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.129.6.151', '2019-06-04 14:14:56', 0, 1002001015, '账号未登陆', '2019-06-04 14:14:56');
INSERT INTO `access_log` VALUES (27119, '65.46.15596289035857541', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:15:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 14:15:04');
INSERT INTO `access_log` VALUES (27120, '64.76.15596289109907203', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:15:11', 10, 0, '', '2019-06-04 14:15:11');
INSERT INTO `access_log` VALUES (27121, '65.50.15596289385767551', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:15:39', 184, 0, '', '2019-06-04 14:15:39');
INSERT INTO `access_log` VALUES (27122, '65.49.15596289389757563', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:15:39', 9, 0, '', '2019-06-04 14:15:39');
INSERT INTO `access_log` VALUES (27123, '65.52.15596289389787541', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:15:39', 8, 0, '', '2019-06-04 14:15:39');
INSERT INTO `access_log` VALUES (27124, '65.47.15596289389927545', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:15:39', 8, 0, '', '2019-06-04 14:15:39');
INSERT INTO `access_log` VALUES (27125, '66.49.15596289398616163', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:15:40', 13, 0, '', '2019-06-04 14:15:40');
INSERT INTO `access_log` VALUES (27126, '59.77.15596289506017515', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:15:51', 10, 0, '', '2019-06-04 14:15:51');
INSERT INTO `access_log` VALUES (27127, '59.78.15596289544337527', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:15:54', 20, 2001001000, '服务端发生异常', '2019-06-04 14:15:54');
INSERT INTO `access_log` VALUES (27128, '62.88.15596289574977379', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:15:57', 12, 0, '', '2019-06-04 14:15:58');
INSERT INTO `access_log` VALUES (27129, '59.73.15596289586877527', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:15:59', 41, 0, '', '2019-06-04 14:15:59');
INSERT INTO `access_log` VALUES (27130, '59.76.15596289632537517', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:16:03', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-04 14:16:03');
INSERT INTO `access_log` VALUES (27131, '65.53.15596289671247519', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:16:07', 17, 0, '', '2019-06-04 14:16:07');
INSERT INTO `access_log` VALUES (27132, '59.75.15596289706677525', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:16:11', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-04 14:16:11');
INSERT INTO `access_log` VALUES (27133, '65.45.15596289780477561', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:16:18', 17, 0, '', '2019-06-04 14:16:18');
INSERT INTO `access_log` VALUES (27134, '65.51.15596289794957551', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:16:19', 10, 0, '', '2019-06-04 14:16:20');
INSERT INTO `access_log` VALUES (27135, '65.50.15596289814877553', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:16:21', 9, 0, '', '2019-06-04 14:16:21');
INSERT INTO `access_log` VALUES (27136, '62.85.15596289879197373', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-05 14:15:55&createEndTime=2019-06-06 14:15:55&paymentBeginTime=2019-06-05 14:15:55&paymentEndTime=2019-07-24 14:15:55', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:16:28', 13, 0, '', '2019-06-04 14:16:28');
INSERT INTO `access_log` VALUES (27137, '62.81.15596289891767359', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-05 14:15:55&createEndTime=2019-06-06 14:15:55&paymentBeginTime=2019-06-05 14:15:55&paymentEndTime=2019-07-24 14:15:55', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:16:29', 13, 0, '', '2019-06-04 14:16:29');
INSERT INTO `access_log` VALUES (27138, '62.82.15596289903307381', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-05 14:15:55&createEndTime=2019-06-06 14:15:55&paymentBeginTime=2019-06-05 14:15:55&paymentEndTime=2019-07-24 14:15:55', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:16:30', 12, 0, '', '2019-06-04 14:16:30');
INSERT INTO `access_log` VALUES (27139, '62.89.15596289920217377', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-05 14:15:55&createEndTime=2019-06-06 14:15:55&paymentBeginTime=2019-06-05 14:15:55&paymentEndTime=2019-07-24 14:15:55', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:16:32', 11, 0, '', '2019-06-04 14:16:32');
INSERT INTO `access_log` VALUES (27140, '62.83.15596289964887375', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:16:36', 15, 0, '', '2019-06-04 14:16:37');
INSERT INTO `access_log` VALUES (27141, '62.84.15596290025387363', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:16:43', 199, 2001001000, '服务端发生异常', '2019-06-04 14:16:43');
INSERT INTO `access_log` VALUES (27142, '64.84.15596290068997219', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:16:47', 9, 0, '', '2019-06-04 14:16:47');
INSERT INTO `access_log` VALUES (27143, '64.85.15596290068977231', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:16:47', 12, 0, '', '2019-06-04 14:16:47');
INSERT INTO `access_log` VALUES (27144, '64.82.15596290131697227', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:16:53', 8, 0, '', '2019-06-04 14:16:53');
INSERT INTO `access_log` VALUES (27145, '64.76.15596290131697205', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:16:53', 10, 0, '', '2019-06-04 14:16:53');
INSERT INTO `access_log` VALUES (27146, '64.77.15596290192417221', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:16:59', 11, 0, '', '2019-06-04 14:16:59');
INSERT INTO `access_log` VALUES (27147, '64.83.15596290192417213', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:16:59', 14, 0, '', '2019-06-04 14:16:59');
INSERT INTO `access_log` VALUES (27148, '64.80.15596290192507211', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:16:59', 9, 0, '', '2019-06-04 14:16:59');
INSERT INTO `access_log` VALUES (27149, '59.71.15596290231637529', 0, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.227.139.161', '2019-06-04 14:17:03', 1, 1002001015, '账号未登陆', '2019-06-04 14:17:03');
INSERT INTO `access_log` VALUES (27150, '65.49.15596290282897565', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-06-04 14:17:08', 13, 0, '', '2019-06-04 14:17:08');
INSERT INTO `access_log` VALUES (27151, '66.50.15596290316946157', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:17:12', 14, 0, '', '2019-06-04 14:17:12');
INSERT INTO `access_log` VALUES (27152, '59.78.15596290365987529', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:17:17', 13, 0, '', '2019-06-04 14:17:17');
INSERT INTO `access_log` VALUES (27153, '65.53.15596290431057521', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:17:23', 17, 0, '', '2019-06-04 14:17:23');
INSERT INTO `access_log` VALUES (27154, '65.45.15596290449187563', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:17:25', 10, 0, '', '2019-06-04 14:17:25');
INSERT INTO `access_log` VALUES (27155, '65.51.15596290461397553', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:17:26', 10, 0, '', '2019-06-04 14:17:26');
INSERT INTO `access_log` VALUES (27156, '65.50.15596290507577555', 27, 2, 'admin-application', '/admin-api/admins/resource/delete', 'id=51', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:17:31', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-04 14:17:31');
INSERT INTO `access_log` VALUES (27157, '65.54.15596290508797517', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:17:31', 9, 0, '', '2019-06-04 14:17:31');
INSERT INTO `access_log` VALUES (27158, '59.79.15596290575887525', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.93.90', '2019-06-04 14:17:38', 3, 0, '', '2019-06-04 14:17:38');
INSERT INTO `access_log` VALUES (27159, '59.75.15596290576847527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.93.90', '2019-06-04 14:17:38', 13, 2001001000, '服务端发生异常', '2019-06-04 14:17:38');
INSERT INTO `access_log` VALUES (27160, '65.49.15596290803227567', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.93.90', '2019-06-04 14:18:00', 0, 1002001015, '账号未登陆', '2019-06-04 14:18:00');
INSERT INTO `access_log` VALUES (27161, '65.48.15596290803237553', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.93.90', '2019-06-04 14:18:00', 1, 1002001015, '账号未登陆', '2019-06-04 14:18:00');
INSERT INTO `access_log` VALUES (27162, '65.53.15596290803267523', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.93.90', '2019-06-04 14:18:00', 1, 1002001015, '账号未登陆', '2019-06-04 14:18:00');
INSERT INTO `access_log` VALUES (27163, '65.46.15596290823207547', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.93.90', '2019-06-04 14:18:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 14:18:02');
INSERT INTO `access_log` VALUES (27164, '65.50.15596291052207557', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:18:25', 4, 1002001012, '访问令牌已过期', '2019-06-04 14:18:25');
INSERT INTO `access_log` VALUES (27165, '65.54.15596291052277519', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:18:25', 3, 1002001012, '访问令牌已过期', '2019-06-04 14:18:25');
INSERT INTO `access_log` VALUES (27166, '65.47.15596291052327551', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:18:25', 3, 1002001012, '访问令牌已过期', '2019-06-04 14:18:25');
INSERT INTO `access_log` VALUES (27167, '65.52.15596291138187547', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:18:34', 240, 0, '', '2019-06-04 14:18:34');
INSERT INTO `access_log` VALUES (27168, '65.48.15596291145397555', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:18:35', 9, 0, '', '2019-06-04 14:18:35');
INSERT INTO `access_log` VALUES (27169, '65.53.15596291145497525', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:18:35', 9, 0, '', '2019-06-04 14:18:35');
INSERT INTO `access_log` VALUES (27170, '65.49.15596291145547569', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:18:35', 9, 0, '', '2019-06-04 14:18:35');
INSERT INTO `access_log` VALUES (27171, '65.45.15596291194157567', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.138.78.136', '2019-06-04 14:18:39', 0, 1002001015, '账号未登陆', '2019-06-04 14:18:39');
INSERT INTO `access_log` VALUES (27172, '65.51.15596291194267557', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.138.78.136', '2019-06-04 14:18:39', 0, 1002001015, '账号未登陆', '2019-06-04 14:18:39');
INSERT INTO `access_log` VALUES (27173, '65.54.15596291194447521', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.138.78.136', '2019-06-04 14:18:39', 0, 1002001015, '账号未登陆', '2019-06-04 14:18:39');
INSERT INTO `access_log` VALUES (27174, '65.50.15596291220877559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.138.78.136', '2019-06-04 14:18:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 14:18:42');
INSERT INTO `access_log` VALUES (27175, '65.47.15596291237177553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.138.78.136', '2019-06-04 14:18:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 14:18:44');
INSERT INTO `access_log` VALUES (27176, '65.52.15596291244057549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.138.78.136', '2019-06-04 14:18:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 14:18:44');
INSERT INTO `access_log` VALUES (27177, '65.48.15596291250207557', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.138.78.136', '2019-06-04 14:18:45', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 14:18:45');
INSERT INTO `access_log` VALUES (27178, '65.49.15596291253947571', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.138.78.136', '2019-06-04 14:18:45', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 14:18:45');
INSERT INTO `access_log` VALUES (27179, '65.53.15596291259307527', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.138.78.136', '2019-06-04 14:18:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 14:18:46');
INSERT INTO `access_log` VALUES (27180, '62.88.15596291420067383', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:19:02', 207, 0, '', '2019-06-04 14:19:02');
INSERT INTO `access_log` VALUES (27181, '62.80.15596291493897381', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:19:09', 12, 0, '', '2019-06-04 14:19:09');
INSERT INTO `access_log` VALUES (27182, '64.79.15596291636257215', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:19:24', 19, 0, '', '2019-06-04 14:19:24');
INSERT INTO `access_log` VALUES (27183, '64.78.15596291636307223', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:19:24', 17, 0, '', '2019-06-04 14:19:24');
INSERT INTO `access_log` VALUES (27184, '65.53.15596292686647529', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:21:09', 4, 0, '', '2019-06-04 14:21:09');
INSERT INTO `access_log` VALUES (27185, '64.79.15596293095877217', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=测试商品&sellPoint=测试&cid=794&visible=true&picUrls=http://static.shop.iocoder.cn/59973ad7-189e-4a91-84b6-635e111de6ca&skuStr=[{\"attrs\":[28],\"price\":10000,\"quantity\":100}]&description=<p>这是一个神奇的商品</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:21:50', 8, 1002002009, NULL, '2019-06-04 14:21:50');
INSERT INTO `access_log` VALUES (27186, '64.81.15596293190367219', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:21:59', 10, 0, '', '2019-06-04 14:21:59');
INSERT INTO `access_log` VALUES (27187, '64.85.15596293190347237', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:21:59', 13, 0, '', '2019-06-04 14:21:59');
INSERT INTO `access_log` VALUES (27188, '64.76.15596293309767211', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:22:11', 9, 0, '', '2019-06-04 14:22:11');
INSERT INTO `access_log` VALUES (27189, '66.56.15596293495176159', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:22:30', 12, 0, '', '2019-06-04 14:22:30');
INSERT INTO `access_log` VALUES (27190, '59.74.15596293545427527', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:22:35', 11, 0, '', '2019-06-04 14:22:35');
INSERT INTO `access_log` VALUES (27191, '59.80.15596293602997521', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:22:40', 20, 2001001000, '服务端发生异常', '2019-06-04 14:22:40');
INSERT INTO `access_log` VALUES (27192, '59.72.15596293636467529', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:22:44', 10, 0, '', '2019-06-04 14:22:44');
INSERT INTO `access_log` VALUES (27193, '59.71.15596293671937535', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-04 14:22:47', 13, 0, '', '2019-06-04 14:22:47');
INSERT INTO `access_log` VALUES (27194, '65.46.15596294156077555', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.166.187.7', '2019-06-04 14:23:36', 0, 1002001015, '账号未登陆', '2019-06-04 14:23:36');
INSERT INTO `access_log` VALUES (27195, '65.51.15596294156177563', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.166.187.10', '2019-06-04 14:23:36', 0, 1002001015, '账号未登陆', '2019-06-04 14:23:36');
INSERT INTO `access_log` VALUES (27196, '65.45.15596294156187573', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.166.187.7', '2019-06-04 14:23:36', 0, 1002001015, '账号未登陆', '2019-06-04 14:23:36');
INSERT INTO `access_log` VALUES (27197, '65.54.15596294180037527', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.166.187.10', '2019-06-04 14:23:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 14:23:38');
INSERT INTO `access_log` VALUES (27198, '65.52.15596294374767555', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.166.187.5', '2019-06-04 14:23:57', 60, 0, '', '2019-06-04 14:23:58');
INSERT INTO `access_log` VALUES (27199, '65.48.15596294378487563', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.166.187.9', '2019-06-04 14:23:58', 9, 0, '', '2019-06-04 14:23:58');
INSERT INTO `access_log` VALUES (27200, '65.49.15596294378577577', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.166.187.5', '2019-06-04 14:23:58', 9, 0, '', '2019-06-04 14:23:58');
INSERT INTO `access_log` VALUES (27201, '65.53.15596294378617533', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.166.187.8', '2019-06-04 14:23:58', 8, 0, '', '2019-06-04 14:23:58');
INSERT INTO `access_log` VALUES (27202, '62.89.15596294618487385', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.166.187.9', '2019-06-04 14:24:22', 14, 0, '', '2019-06-04 14:24:22');
INSERT INTO `access_log` VALUES (27203, '62.86.15596294673777373', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.166.187.8', '2019-06-04 14:24:27', 15, 0, '', '2019-06-04 14:24:27');
INSERT INTO `access_log` VALUES (27204, '64.83.15596294833177221', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.166.187.9', '2019-06-04 14:24:43', 11, 0, '', '2019-06-04 14:24:43');
INSERT INTO `access_log` VALUES (27205, '64.80.15596294833237219', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.166.187.8', '2019-06-04 14:24:43', 8, 0, '', '2019-06-04 14:24:43');
INSERT INTO `access_log` VALUES (27206, '65.50.15596294966847567', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.166.187.8', '2019-06-04 14:24:57', 286, 0, '', '2019-06-04 14:24:57');
INSERT INTO `access_log` VALUES (27207, '65.49.15596302769607589', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:37:57', 4, 1002001012, '访问令牌已过期', '2019-06-04 14:37:57');
INSERT INTO `access_log` VALUES (27208, '65.48.15596302769607575', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:37:57', 4, 1002001012, '访问令牌已过期', '2019-06-04 14:37:57');
INSERT INTO `access_log` VALUES (27209, '65.53.15596302769787545', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:37:57', 3, 1002001012, '访问令牌已过期', '2019-06-04 14:37:57');
INSERT INTO `access_log` VALUES (27210, '66.57.15596302770146179', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:37:57', 18, 1002001012, '访问令牌已过期', '2019-06-04 14:37:57');
INSERT INTO `access_log` VALUES (27211, '65.46.15596302967257569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:38:17', 142, 0, '', '2019-06-04 14:38:17');
INSERT INTO `access_log` VALUES (27212, '65.54.15596302970827541', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:38:17', 9, 0, '', '2019-06-04 14:38:17');
INSERT INTO `access_log` VALUES (27213, '65.45.15596302970827587', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:38:17', 10, 0, '', '2019-06-04 14:38:17');
INSERT INTO `access_log` VALUES (27214, '65.50.15596302970867579', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:38:17', 7, 0, '', '2019-06-04 14:38:17');
INSERT INTO `access_log` VALUES (27215, '65.48.15596303317827577', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:38:52', 19, 0, '', '2019-06-04 14:38:52');
INSERT INTO `access_log` VALUES (27216, '65.49.15596303331507591', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:38:53', 11, 0, '', '2019-06-04 14:38:53');
INSERT INTO `access_log` VALUES (27217, '65.51.15596303345217579', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:38:55', 9, 0, '', '2019-06-04 14:38:55');
INSERT INTO `access_log` VALUES (27218, '65.46.15596303359917571', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 14:38:56', 14, 0, '', '2019-06-04 14:38:56');
INSERT INTO `access_log` VALUES (27219, '65.46.15596310708637581', 0, 2, 'admin-application', '/admin-api/admins/admin/update', 'id=1&username=admin1&nickname=管理员', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 14:51:11', 4, 1002001012, '访问令牌已过期', '2019-06-04 14:51:11');
INSERT INTO `access_log` VALUES (27220, '65.45.15596310803677599', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 14:51:20', 68, 0, '', '2019-06-04 14:51:20');
INSERT INTO `access_log` VALUES (27221, '65.50.15596310807727591', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 14:51:21', 10, 0, '', '2019-06-04 14:51:21');
INSERT INTO `access_log` VALUES (27222, '65.54.15596310807767553', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 14:51:21', 8, 0, '', '2019-06-04 14:51:21');
INSERT INTO `access_log` VALUES (27223, '65.47.15596310807787585', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 14:51:21', 9, 0, '', '2019-06-04 14:51:21');
INSERT INTO `access_log` VALUES (27224, '65.52.15596310838197581', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 14:51:24', 25, 0, '', '2019-06-04 14:51:24');
INSERT INTO `access_log` VALUES (27225, '65.53.15596311105407559', 27, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=da123123&nickname=呵呵&password=a123213', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 14:51:51', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-04 14:51:51');
INSERT INTO `access_log` VALUES (27226, '65.50.15596311732577593', 27, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=da123123&nickname=呵呵&password=a123213', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 14:52:53', 7, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-04 14:52:53');
INSERT INTO `access_log` VALUES (27227, '59.74.15596312571797553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.13.14.217', '2019-06-04 14:54:17', 18, 0, '', '2019-06-04 14:54:17');
INSERT INTO `access_log` VALUES (27228, '59.80.15596312571797547', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.13.14.217', '2019-06-04 14:54:17', 27, 2001001000, '服务端发生异常', '2019-06-04 14:54:17');
INSERT INTO `access_log` VALUES (27229, '64.83.15596312669767245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '218.13.14.217', '2019-06-04 14:54:27', 3, 0, '', '2019-06-04 14:54:27');
INSERT INTO `access_log` VALUES (27230, '64.77.15596312671077253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '218.13.14.217', '2019-06-04 14:54:27', 1, 0, '', '2019-06-04 14:54:27');
INSERT INTO `access_log` VALUES (27231, '64.78.15596312714657253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '218.13.14.217', '2019-06-04 14:54:31', 2, 0, '', '2019-06-04 14:54:31');
INSERT INTO `access_log` VALUES (27232, '64.79.15596312716057245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '218.13.14.217', '2019-06-04 14:54:32', 2, 0, '', '2019-06-04 14:54:32');
INSERT INTO `access_log` VALUES (27233, '59.77.15596312774787549', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.13.14.217', '2019-06-04 14:54:37', 3, 0, '', '2019-06-04 14:54:37');
INSERT INTO `access_log` VALUES (27234, '59.78.15596312774797561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.13.14.217', '2019-06-04 14:54:37', 14, 2001001000, '服务端发生异常', '2019-06-04 14:54:37');
INSERT INTO `access_log` VALUES (27235, '65.54.15596313231407557', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 14:55:23', 0, 1002001015, '账号未登陆', '2019-06-04 14:55:23');
INSERT INTO `access_log` VALUES (27236, '65.52.15596313231417585', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 14:55:23', 0, 1002001015, '账号未登陆', '2019-06-04 14:55:23');
INSERT INTO `access_log` VALUES (27237, '65.48.15596313231457593', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 14:55:23', 0, 1002001015, '账号未登陆', '2019-06-04 14:55:23');
INSERT INTO `access_log` VALUES (27238, '65.53.15596313251607563', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 14:55:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 14:55:25');
INSERT INTO `access_log` VALUES (27239, '65.46.15596313486157587', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 14:55:49', 134, 0, '', '2019-06-04 14:55:49');
INSERT INTO `access_log` VALUES (27240, '65.45.15596313489647605', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 14:55:49', 9, 0, '', '2019-06-04 14:55:49');
INSERT INTO `access_log` VALUES (27241, '65.47.15596313489687591', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 14:55:49', 9, 0, '', '2019-06-04 14:55:49');
INSERT INTO `access_log` VALUES (27242, '65.50.15596313489747597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 14:55:49', 9, 0, '', '2019-06-04 14:55:49');
INSERT INTO `access_log` VALUES (27243, '64.78.15596313727457255', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 14:56:13', 11, 0, '', '2019-06-04 14:56:13');
INSERT INTO `access_log` VALUES (27244, '64.77.15596313727447255', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 14:56:13', 13, 0, '', '2019-06-04 14:56:13');
INSERT INTO `access_log` VALUES (27245, '65.45.15596316212137609', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.124.254', '2019-06-04 15:00:21', 0, 1002001015, '账号未登陆', '2019-06-04 15:00:21');
INSERT INTO `access_log` VALUES (27246, '65.50.15596316212297601', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.124.254', '2019-06-04 15:00:21', 0, 1002001015, '账号未登陆', '2019-06-04 15:00:21');
INSERT INTO `access_log` VALUES (27247, '65.54.15596316212597563', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.124.254', '2019-06-04 15:00:21', 0, 1002001015, '账号未登陆', '2019-06-04 15:00:21');
INSERT INTO `access_log` VALUES (27248, '65.52.15596316294967591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.124.254', '2019-06-04 15:00:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 15:00:30');
INSERT INTO `access_log` VALUES (27249, '65.53.15596316462867569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.124.254', '2019-06-04 15:00:46', 80, 0, '', '2019-06-04 15:00:46');
INSERT INTO `access_log` VALUES (27250, '65.51.15596316468337601', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.124.254', '2019-06-04 15:00:47', 10, 0, '', '2019-06-04 15:00:47');
INSERT INTO `access_log` VALUES (27251, '65.46.15596316468377593', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.124.254', '2019-06-04 15:00:47', 9, 0, '', '2019-06-04 15:00:47');
INSERT INTO `access_log` VALUES (27252, '65.47.15596316468547597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.124.254', '2019-06-04 15:00:47', 9, 0, '', '2019-06-04 15:00:47');
INSERT INTO `access_log` VALUES (27253, '62.89.15596316567307415', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.124.254', '2019-06-04 15:00:57', 20, 0, '', '2019-06-04 15:00:57');
INSERT INTO `access_log` VALUES (27254, '62.86.15596316609157403', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.124.254', '2019-06-04 15:01:01', 175, 0, '', '2019-06-04 15:01:01');
INSERT INTO `access_log` VALUES (27255, '65.50.15596321473537609', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:07', 1, 1002001015, '账号未登陆', '2019-06-04 15:09:07');
INSERT INTO `access_log` VALUES (27256, '65.53.15596321473597577', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:07', 0, 1002001015, '账号未登陆', '2019-06-04 15:09:07');
INSERT INTO `access_log` VALUES (27257, '65.49.15596321473547623', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:07', 0, 1002001015, '账号未登陆', '2019-06-04 15:09:07');
INSERT INTO `access_log` VALUES (27258, '65.47.15596321517667605', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 15:09:12');
INSERT INTO `access_log` VALUES (27259, '65.46.15596321553247601', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:15', 110, 0, '', '2019-06-04 15:09:15');
INSERT INTO `access_log` VALUES (27260, '65.51.15596321555927607', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:16', 9, 0, '', '2019-06-04 15:09:16');
INSERT INTO `access_log` VALUES (27261, '65.54.15596321555947575', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:16', 19, 0, '', '2019-06-04 15:09:16');
INSERT INTO `access_log` VALUES (27262, '65.45.15596321555967621', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:16', 18, 0, '', '2019-06-04 15:09:16');
INSERT INTO `access_log` VALUES (27263, '62.80.15596321658957423', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:26', 14, 0, '', '2019-06-04 15:09:26');
INSERT INTO `access_log` VALUES (27264, '62.85.15596321712097419', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:31', 14, 0, '', '2019-06-04 15:09:31');
INSERT INTO `access_log` VALUES (27265, '64.82.15596321750567273', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:35', 320, 0, '', '2019-06-04 15:09:35');
INSERT INTO `access_log` VALUES (27266, '64.85.15596321750557277', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:35', 322, 0, '', '2019-06-04 15:09:35');
INSERT INTO `access_log` VALUES (27267, '64.83.15596321860827259', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:46', 9, 0, '', '2019-06-04 15:09:46');
INSERT INTO `access_log` VALUES (27268, '64.80.15596321860817257', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:46', 11, 0, '', '2019-06-04 15:09:46');
INSERT INTO `access_log` VALUES (27269, '64.79.15596321922657259', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:52', 9, 0, '', '2019-06-04 15:09:52');
INSERT INTO `access_log` VALUES (27270, '64.78.15596321922657267', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:52', 11, 0, '', '2019-06-04 15:09:52');
INSERT INTO `access_log` VALUES (27271, '64.81.15596321954257261', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:55', 9, 0, '', '2019-06-04 15:09:55');
INSERT INTO `access_log` VALUES (27272, '64.84.15596321954247267', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:55', 11, 0, '', '2019-06-04 15:09:55');
INSERT INTO `access_log` VALUES (27273, '64.76.15596321977417253', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:58', 9, 0, '', '2019-06-04 15:09:58');
INSERT INTO `access_log` VALUES (27274, '64.82.15596321977407275', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:58', 10, 0, '', '2019-06-04 15:09:58');
INSERT INTO `access_log` VALUES (27275, '64.85.15596321977407279', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:09:58', 15, 0, '', '2019-06-04 15:09:58');
INSERT INTO `access_log` VALUES (27276, '64.83.15596322023317261', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:10:02', 436, 0, '', '2019-06-04 15:10:03');
INSERT INTO `access_log` VALUES (27277, '66.57.15596322126596205', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:10:13', 19, 0, '', '2019-06-04 15:10:13');
INSERT INTO `access_log` VALUES (27278, '59.79.15596322167177569', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:10:17', 12, 0, '', '2019-06-04 15:10:17');
INSERT INTO `access_log` VALUES (27279, '59.74.15596322226697567', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:10:23', 20, 2001001000, '服务端发生异常', '2019-06-04 15:10:23');
INSERT INTO `access_log` VALUES (27280, '59.80.15596322296227561', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:10:30', 12, 0, '', '2019-06-04 15:10:30');
INSERT INTO `access_log` VALUES (27281, '59.72.15596322329317569', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:10:33', 12, 0, '', '2019-06-04 15:10:33');
INSERT INTO `access_log` VALUES (27282, '59.78.15596322349727575', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:10:35', 538, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-04 15:10:36');
INSERT INTO `access_log` VALUES (27283, '65.47.15596322366247607', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:10:37', 17, 0, '', '2019-06-04 15:10:37');
INSERT INTO `access_log` VALUES (27284, '65.46.15596322378667603', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:10:38', 10, 0, '', '2019-06-04 15:10:38');
INSERT INTO `access_log` VALUES (27285, '65.45.15596322388617623', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:10:39', 10, 0, '', '2019-06-04 15:10:39');
INSERT INTO `access_log` VALUES (27286, '65.54.15596322436697577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.5.237.243', '2019-06-04 15:10:44', 14, 0, '', '2019-06-04 15:10:44');
INSERT INTO `access_log` VALUES (27287, '59.76.15596325730377569', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '121.28.132.18', '2019-06-04 15:16:13', 3, 0, '', '2019-06-04 15:16:13');
INSERT INTO `access_log` VALUES (27288, '59.79.15596325730387575', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '121.28.132.18', '2019-06-04 15:16:13', 14, 2001001000, '服务端发生异常', '2019-06-04 15:16:13');
INSERT INTO `access_log` VALUES (27289, '64.84.15596325753527273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '121.28.132.18', '2019-06-04 15:16:15', 234, 0, '', '2019-06-04 15:16:16');
INSERT INTO `access_log` VALUES (27290, '64.82.15596325757337281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '121.28.132.18', '2019-06-04 15:16:16', 3, 0, '', '2019-06-04 15:16:16');
INSERT INTO `access_log` VALUES (27291, '59.74.15596327292867575', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-04 15:18:49', 4, 0, '', '2019-06-04 15:18:49');
INSERT INTO `access_log` VALUES (27292, '59.80.15596327292897569', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-04 15:18:49', 20, 2001001000, '服务端发生异常', '2019-06-04 15:18:49');
INSERT INTO `access_log` VALUES (27293, '65.49.15596327361197633', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-04 15:18:56', 0, 1002001015, '账号未登陆', '2019-06-04 15:18:56');
INSERT INTO `access_log` VALUES (27294, '65.48.15596327361247619', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-04 15:18:56', 0, 1002001015, '账号未登陆', '2019-06-04 15:18:56');
INSERT INTO `access_log` VALUES (27295, '65.47.15596327361297615', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-04 15:18:56', 0, 1002001015, '账号未登陆', '2019-06-04 15:18:56');
INSERT INTO `access_log` VALUES (27296, '65.46.15596327403677611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-04 15:19:00', 94, 0, '', '2019-06-04 15:19:00');
INSERT INTO `access_log` VALUES (27297, '65.45.15596327407297631', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-04 15:19:01', 11, 0, '', '2019-06-04 15:19:01');
INSERT INTO `access_log` VALUES (27298, '65.51.15596327407337617', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-04 15:19:01', 8, 0, '', '2019-06-04 15:19:01');
INSERT INTO `access_log` VALUES (27299, '65.54.15596327407517585', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-04 15:19:01', 174, 0, '', '2019-06-04 15:19:01');
INSERT INTO `access_log` VALUES (27300, '64.83.15596327452197269', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-04 15:19:05', 8, 0, '', '2019-06-04 15:19:05');
INSERT INTO `access_log` VALUES (27301, '64.85.15596327452167287', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-04 15:19:05', 11, 0, '', '2019-06-04 15:19:05');
INSERT INTO `access_log` VALUES (27302, '64.79.15596327473867269', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-04 15:19:07', 9, 0, '', '2019-06-04 15:19:07');
INSERT INTO `access_log` VALUES (27303, '64.77.15596327473867277', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-04 15:19:07', 11, 0, '', '2019-06-04 15:19:07');
INSERT INTO `access_log` VALUES (27304, '64.82.15596327928297285', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:19:53', 153, 0, '', '2019-06-04 15:19:53');
INSERT INTO `access_log` VALUES (27305, '64.85.15596328009777289', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:20:01', 9, 0, '', '2019-06-04 15:20:01');
INSERT INTO `access_log` VALUES (27306, '64.76.15596328009767263', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:20:01', 10, 0, '', '2019-06-04 15:20:01');
INSERT INTO `access_log` VALUES (27307, '64.77.15596328230187279', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:20:23', 10, 0, '', '2019-06-04 15:20:23');
INSERT INTO `access_log` VALUES (27308, '64.84.15596328729687279', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:21:13', 17, 0, '', '2019-06-04 15:21:13');
INSERT INTO `access_log` VALUES (27309, '64.82.15596328729697287', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:21:13', 17, 0, '', '2019-06-04 15:21:13');
INSERT INTO `access_log` VALUES (27310, '65.53.15596329097837591', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:21:50', 10, 0, '', '2019-06-04 15:21:50');
INSERT INTO `access_log` VALUES (27311, '65.50.15596329097847623', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:21:50', 10, 0, '', '2019-06-04 15:21:50');
INSERT INTO `access_log` VALUES (27312, '65.49.15596329097867637', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:21:50', 9, 0, '', '2019-06-04 15:21:50');
INSERT INTO `access_log` VALUES (27313, '64.80.15596329100277271', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:21:50', 10, 0, '', '2019-06-04 15:21:50');
INSERT INTO `access_log` VALUES (27314, '64.83.15596329100277273', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:21:50', 11, 0, '', '2019-06-04 15:21:50');
INSERT INTO `access_log` VALUES (27315, '65.54.15596329746787589', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:22:55', 10, 0, '', '2019-06-04 15:22:55');
INSERT INTO `access_log` VALUES (27316, '65.52.15596329746817615', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:22:55', 8, 0, '', '2019-06-04 15:22:55');
INSERT INTO `access_log` VALUES (27317, '65.53.15596329746917593', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:22:55', 9, 0, '', '2019-06-04 15:22:55');
INSERT INTO `access_log` VALUES (27318, '64.85.15596329748747293', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:22:55', 24, 0, '', '2019-06-04 15:22:55');
INSERT INTO `access_log` VALUES (27319, '64.82.15596329748697289', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-04 15:22:55', 29, 0, '', '2019-06-04 15:22:55');
INSERT INTO `access_log` VALUES (27320, '59.73.15596330952627587', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-04 15:24:55', 8, 1002001012, '访问令牌已过期', '2019-06-04 15:24:55');
INSERT INTO `access_log` VALUES (27321, '65.54.15596331055007591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-04 15:25:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 15:25:06');
INSERT INTO `access_log` VALUES (27322, '65.49.15596331192377641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-04 15:25:19', 81, 0, '', '2019-06-04 15:25:19');
INSERT INTO `access_log` VALUES (27323, '65.50.15596331195947627', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-04 15:25:20', 10, 0, '', '2019-06-04 15:25:20');
INSERT INTO `access_log` VALUES (27324, '65.47.15596331195977623', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-04 15:25:20', 9, 0, '', '2019-06-04 15:25:20');
INSERT INTO `access_log` VALUES (27325, '65.48.15596331196037627', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-04 15:25:20', 9, 0, '', '2019-06-04 15:25:20');
INSERT INTO `access_log` VALUES (27326, '59.78.15596331802577589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.6.168.34', '2019-06-04 15:26:20', 14, 2001001000, '服务端发生异常', '2019-06-04 15:26:20');
INSERT INTO `access_log` VALUES (27327, '59.71.15596331802577589', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.6.168.34', '2019-06-04 15:26:20', 308, 0, '', '2019-06-04 15:26:21');
INSERT INTO `access_log` VALUES (27328, '64.84.15596331846637287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.6.168.34', '2019-06-04 15:26:25', 3, 0, '', '2019-06-04 15:26:25');
INSERT INTO `access_log` VALUES (27329, '64.83.15596331848647275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.6.168.34', '2019-06-04 15:26:25', 2, 0, '', '2019-06-04 15:26:25');
INSERT INTO `access_log` VALUES (27330, '64.80.15596331860347277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.6.168.34', '2019-06-04 15:26:26', 2, 0, '', '2019-06-04 15:26:26');
INSERT INTO `access_log` VALUES (27331, '64.78.15596331865107287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.6.168.34', '2019-06-04 15:26:27', 2, 0, '', '2019-06-04 15:26:27');
INSERT INTO `access_log` VALUES (27332, '64.81.15596331868067279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.6.168.34', '2019-06-04 15:26:27', 2, 0, '', '2019-06-04 15:26:27');
INSERT INTO `access_log` VALUES (27333, '66.51.15596331896676215', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.6.168.34', '2019-06-04 15:26:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-04 15:26:30');
INSERT INTO `access_log` VALUES (27334, '66.56.15596331917046211', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.6.168.34', '2019-06-04 15:26:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-06-04 15:26:32');
INSERT INTO `access_log` VALUES (27335, '64.85.15596331964177299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.6.168.34', '2019-06-04 15:26:36', 2, 0, '', '2019-06-04 15:26:36');
INSERT INTO `access_log` VALUES (27336, '64.82.15596331965357293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.6.168.34', '2019-06-04 15:26:37', 2, 0, '', '2019-06-04 15:26:37');
INSERT INTO `access_log` VALUES (27337, '64.77.15596331986457289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.6.168.34', '2019-06-04 15:26:39', 2, 0, '', '2019-06-04 15:26:39');
INSERT INTO `access_log` VALUES (27338, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.6.168.34', '2019-06-04 15:26:39', 14, 0, '', '2019-06-04 15:26:39');
INSERT INTO `access_log` VALUES (27339, '64.79.15596332002877279', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.6.168.34', '2019-06-04 15:26:40', 8, 0, '', '2019-06-04 15:26:40');
INSERT INTO `access_log` VALUES (27340, '65.53.15596336385077603', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=14', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:33:59', 13, 0, '', '2019-06-04 15:33:59');
INSERT INTO `access_log` VALUES (27341, '65.54.15596336406147601', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=12', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:34:01', 8, 0, '', '2019-06-04 15:34:01');
INSERT INTO `access_log` VALUES (27342, '65.52.15596336428237627', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:34:03', 10, 0, '', '2019-06-04 15:34:03');
INSERT INTO `access_log` VALUES (27343, '65.49.15596336455437651', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=8', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:34:06', 10, 0, '', '2019-06-04 15:34:06');
INSERT INTO `access_log` VALUES (27344, '65.50.15596336478557637', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:34:08', 234, 0, '', '2019-06-04 15:34:08');
INSERT INTO `access_log` VALUES (27345, '65.52.15596337483067629', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:35:48', 12, 0, '', '2019-06-04 15:35:48');
INSERT INTO `access_log` VALUES (27346, '65.49.15596337498867653', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:35:50', 12, 0, '', '2019-06-04 15:35:50');
INSERT INTO `access_log` VALUES (27347, '59.79.15596337991697593', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.200.61', '2019-06-04 15:36:39', 18, 2001001000, '服务端发生异常', '2019-06-04 15:36:39');
INSERT INTO `access_log` VALUES (27348, '59.73.15596337991677597', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.200.61', '2019-06-04 15:36:39', 156, 0, '', '2019-06-04 15:36:39');
INSERT INTO `access_log` VALUES (27349, '64.84.15596338030837297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.200.61', '2019-06-04 15:36:43', 3, 0, '', '2019-06-04 15:36:43');
INSERT INTO `access_log` VALUES (27350, '64.83.15596338032077285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.200.61', '2019-06-04 15:36:43', 2, 0, '', '2019-06-04 15:36:43');
INSERT INTO `access_log` VALUES (27351, '64.80.15596338039767287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.200.61', '2019-06-04 15:36:44', 2, 0, '', '2019-06-04 15:36:44');
INSERT INTO `access_log` VALUES (27352, '64.78.15596338043117297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.200.61', '2019-06-04 15:36:44', 2, 0, '', '2019-06-04 15:36:44');
INSERT INTO `access_log` VALUES (27353, '64.81.15596338047897289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.242.200.61', '2019-06-04 15:36:45', 2, 0, '', '2019-06-04 15:36:45');
INSERT INTO `access_log` VALUES (27354, '65.48.15596339275587639', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:38:48', 17, 0, '', '2019-06-04 15:38:48');
INSERT INTO `access_log` VALUES (27355, '65.45.15596339385607653', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=20', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:38:59', 18, 0, '', '2019-06-04 15:38:59');
INSERT INTO `access_log` VALUES (27356, '65.51.15596339406377637', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:39:01', 18, 0, '', '2019-06-04 15:39:01');
INSERT INTO `access_log` VALUES (27357, '65.53.15596339437687609', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=30', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:39:04', 18, 0, '', '2019-06-04 15:39:04');
INSERT INTO `access_log` VALUES (27358, '65.54.15596339460337607', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=40', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:39:06', 18, 0, '', '2019-06-04 15:39:06');
INSERT INTO `access_log` VALUES (27359, '65.53.15596342119237613', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:43:32', 4, 1002001012, '访问令牌已过期', '2019-06-04 15:43:32');
INSERT INTO `access_log` VALUES (27360, '65.54.15596342119257611', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:43:32', 3, 1002001012, '访问令牌已过期', '2019-06-04 15:43:32');
INSERT INTO `access_log` VALUES (27361, '65.52.15596342119307637', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:43:32', 3, 1002001012, '访问令牌已过期', '2019-06-04 15:43:32');
INSERT INTO `access_log` VALUES (27362, '64.80.15596342121177293', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:43:32', 7, 1002001012, '访问令牌已过期', '2019-06-04 15:43:32');
INSERT INTO `access_log` VALUES (27363, '64.78.15596342121227303', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:43:32', 5, 1002001012, '访问令牌已过期', '2019-06-04 15:43:32');
INSERT INTO `access_log` VALUES (27364, '65.49.15596342136227661', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:43:34', 1, 1002001015, '账号未登陆', '2019-06-04 15:43:34');
INSERT INTO `access_log` VALUES (27365, '65.50.15596342136317647', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:43:34', 0, 1002001015, '账号未登陆', '2019-06-04 15:43:34');
INSERT INTO `access_log` VALUES (27366, '65.47.15596342136377641', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:43:34', 1, 1002001015, '账号未登陆', '2019-06-04 15:43:34');
INSERT INTO `access_log` VALUES (27367, '65.46.15596342200407637', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:43:40', 86, 0, '', '2019-06-04 15:43:40');
INSERT INTO `access_log` VALUES (27368, '65.51.15596342204587643', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:43:40', 10, 0, '', '2019-06-04 15:43:40');
INSERT INTO `access_log` VALUES (27369, '65.53.15596342204637615', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:43:40', 10, 0, '', '2019-06-04 15:43:40');
INSERT INTO `access_log` VALUES (27370, '65.52.15596342204677639', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:43:40', 11, 0, '', '2019-06-04 15:43:40');
INSERT INTO `access_log` VALUES (27371, '65.45.15596342204017659', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:43:40', 84, 0, '', '2019-06-04 15:43:40');
INSERT INTO `access_log` VALUES (27372, '65.54.15596342207227613', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:43:41', 9, 0, '', '2019-06-04 15:43:41');
INSERT INTO `access_log` VALUES (27373, '65.49.15596342207277663', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:43:41', 9, 0, '', '2019-06-04 15:43:41');
INSERT INTO `access_log` VALUES (27374, '65.47.15596342207327643', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:43:41', 9, 0, '', '2019-06-04 15:43:41');
INSERT INTO `access_log` VALUES (27375, '64.76.15596342246957287', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:43:45', 12, 0, '', '2019-06-04 15:43:45');
INSERT INTO `access_log` VALUES (27376, '64.85.15596342246987315', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:43:45', 9, 0, '', '2019-06-04 15:43:45');
INSERT INTO `access_log` VALUES (27377, '62.82.15596342262207455', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:43:46', 21, 0, '', '2019-06-04 15:43:46');
INSERT INTO `access_log` VALUES (27378, '62.86.15596342393617439', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:43:59', 17, 0, '', '2019-06-04 15:43:59');
INSERT INTO `access_log` VALUES (27379, '65.48.15596342446877647', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:44:05', 26, 0, '', '2019-06-04 15:44:05');
INSERT INTO `access_log` VALUES (27380, '65.53.15596342518577617', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:44:12', 10, 0, '', '2019-06-04 15:44:12');
INSERT INTO `access_log` VALUES (27381, '65.52.15596342548857641', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:44:15', 12, 0, '', '2019-06-04 15:44:15');
INSERT INTO `access_log` VALUES (27382, '65.51.15596342600297645', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:44:20', 9, 0, '', '2019-06-04 15:44:20');
INSERT INTO `access_log` VALUES (27383, '65.45.15596342613297661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:44:21', 14, 0, '', '2019-06-04 15:44:21');
INSERT INTO `access_log` VALUES (27384, '59.74.15596342851607597', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:44:45', 152, 0, '', '2019-06-04 15:44:45');
INSERT INTO `access_log` VALUES (27385, '64.78.15596342997297305', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:45:00', 13, 0, '', '2019-06-04 15:45:00');
INSERT INTO `access_log` VALUES (27386, '64.80.15596342997347295', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:45:00', 8, 0, '', '2019-06-04 15:45:00');
INSERT INTO `access_log` VALUES (27387, '64.76.15596343018297289', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:45:02', 611, 0, '', '2019-06-04 15:45:02');
INSERT INTO `access_log` VALUES (27388, '64.81.15596343018267297', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:45:02', 614, 0, '', '2019-06-04 15:45:02');
INSERT INTO `access_log` VALUES (27389, '64.85.15596343018267317', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:45:02', 617, 0, '', '2019-06-04 15:45:02');
INSERT INTO `access_log` VALUES (27390, '65.46.15596343249277641', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:45:25', 9, 0, '', '2019-06-04 15:45:25');
INSERT INTO `access_log` VALUES (27391, '65.53.15596343249387619', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:45:25', 8, 0, '', '2019-06-04 15:45:25');
INSERT INTO `access_log` VALUES (27392, '65.52.15596343249397643', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:45:25', 8, 0, '', '2019-06-04 15:45:25');
INSERT INTO `access_log` VALUES (27393, '65.51.15596343381027647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:45:38', 9, 0, '', '2019-06-04 15:45:38');
INSERT INTO `access_log` VALUES (27394, '65.45.15596343381197663', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:45:38', 9, 0, '', '2019-06-04 15:45:38');
INSERT INTO `access_log` VALUES (27395, '65.47.15596343381197647', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:45:38', 8, 0, '', '2019-06-04 15:45:38');
INSERT INTO `access_log` VALUES (27396, '65.49.15596343406657667', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:45:41', 8, 0, '', '2019-06-04 15:45:41');
INSERT INTO `access_log` VALUES (27397, '65.50.15596343406697653', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:45:41', 8, 0, '', '2019-06-04 15:45:41');
INSERT INTO `access_log` VALUES (27398, '65.48.15596343406737651', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.222.86', '2019-06-04 15:45:41', 8, 0, '', '2019-06-04 15:45:41');
INSERT INTO `access_log` VALUES (27399, '65.51.15596343829347649', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:46:23', 0, 1002001015, '账号未登陆', '2019-06-04 15:46:23');
INSERT INTO `access_log` VALUES (27400, '65.53.15596344856897621', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:48:06', 16, 0, '', '2019-06-04 15:48:06');
INSERT INTO `access_log` VALUES (27401, '65.51.15596344856897651', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:48:06', 18, 0, '', '2019-06-04 15:48:06');
INSERT INTO `access_log` VALUES (27402, '65.45.15596344857007667', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:48:06', 8, 0, '', '2019-06-04 15:48:06');
INSERT INTO `access_log` VALUES (27403, '64.78.15596344859047309', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:48:06', 10, 0, '', '2019-06-04 15:48:06');
INSERT INTO `access_log` VALUES (27404, '64.83.15596344859007297', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:48:06', 15, 0, '', '2019-06-04 15:48:06');
INSERT INTO `access_log` VALUES (27405, '64.84.15596344858997309', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:48:06', 18, 0, '', '2019-06-04 15:48:06');
INSERT INTO `access_log` VALUES (27406, '65.50.15596345373617657', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:48:57', 2, 0, '', '2019-06-04 15:48:57');
INSERT INTO `access_log` VALUES (27407, '65.49.15596346265767673', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:50:27', 10, 0, '', '2019-06-04 15:50:27');
INSERT INTO `access_log` VALUES (27408, '65.48.15596346265767655', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:50:27', 9, 0, '', '2019-06-04 15:50:27');
INSERT INTO `access_log` VALUES (27409, '65.54.15596346265747623', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:50:27', 11, 0, '', '2019-06-04 15:50:27');
INSERT INTO `access_log` VALUES (27410, '64.76.15596346267277295', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:50:27', 10, 0, '', '2019-06-04 15:50:27');
INSERT INTO `access_log` VALUES (27411, '64.80.15596346267257301', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:50:27', 11, 0, '', '2019-06-04 15:50:27');
INSERT INTO `access_log` VALUES (27412, '64.83.15596346267247299', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:50:27', 16, 0, '', '2019-06-04 15:50:27');
INSERT INTO `access_log` VALUES (27413, '65.45.15596346694867671', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:51:09', 8, 0, '', '2019-06-04 15:51:09');
INSERT INTO `access_log` VALUES (27414, '65.51.15596346694897655', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:51:09', 8, 0, '', '2019-06-04 15:51:09');
INSERT INTO `access_log` VALUES (27415, '65.53.15596346694937625', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:51:09', 8, 0, '', '2019-06-04 15:51:10');
INSERT INTO `access_log` VALUES (27416, '64.79.15596346696497303', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:51:10', 9, 0, '', '2019-06-04 15:51:10');
INSERT INTO `access_log` VALUES (27417, '64.77.15596346696477313', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:51:10', 13, 0, '', '2019-06-04 15:51:10');
INSERT INTO `access_log` VALUES (27418, '64.84.15596346696547313', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:51:10', 9, 0, '', '2019-06-04 15:51:10');
INSERT INTO `access_log` VALUES (27419, '66.51.15596346760726235', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15721986587', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:51:16', 246, 0, '', '2019-06-04 15:51:16');
INSERT INTO `access_log` VALUES (27420, '65.50.15596347405847661', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:52:21', 4, 1002001012, '访问令牌已过期', '2019-06-04 15:52:21');
INSERT INTO `access_log` VALUES (27421, '66.54.15596347443976239', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:52:24', 1, 1002001015, '账号未登陆', '2019-06-04 15:52:24');
INSERT INTO `access_log` VALUES (27422, '64.85.15596347449367325', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:52:25', 12, 0, '', '2019-06-04 15:52:25');
INSERT INTO `access_log` VALUES (27423, '64.82.15596347449397319', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 15:52:25', 10, 0, '', '2019-06-04 15:52:25');
INSERT INTO `access_log` VALUES (27424, '65.46.15596347483647651', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:52:28', 357, 0, '', '2019-06-04 15:52:29');
INSERT INTO `access_log` VALUES (27425, '65.45.15596347491237673', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:52:29', 213, 0, '', '2019-06-04 15:52:29');
INSERT INTO `access_log` VALUES (27426, '65.51.15596347491457657', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:52:29', 192, 0, '', '2019-06-04 15:52:29');
INSERT INTO `access_log` VALUES (27427, '65.53.15596347491217627', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:52:29', 215, 0, '', '2019-06-04 15:52:29');
INSERT INTO `access_log` VALUES (27428, '65.47.15596347515687657', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 15:52:32', 14, 0, '', '2019-06-04 15:52:32');
INSERT INTO `access_log` VALUES (27429, '59.78.15596347701237611', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:52:50', 3, 0, '', '2019-06-04 15:52:50');
INSERT INTO `access_log` VALUES (27430, '59.77.15596347701237599', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:52:50', 10, 2001001000, '服务端发生异常', '2019-06-04 15:52:50');
INSERT INTO `access_log` VALUES (27431, '65.48.15596347748927659', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:52:55', 1, 1002001015, '账号未登陆', '2019-06-04 15:52:55');
INSERT INTO `access_log` VALUES (27432, '65.50.15596347748987663', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:52:55', 0, 1002001015, '账号未登陆', '2019-06-04 15:52:55');
INSERT INTO `access_log` VALUES (27433, '65.52.15596347748997655', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:52:55', 0, 1002001015, '账号未登陆', '2019-06-04 15:52:55');
INSERT INTO `access_log` VALUES (27434, '64.84.15596347803207315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:53:00', 2, 0, '', '2019-06-04 15:53:00');
INSERT INTO `access_log` VALUES (27435, '64.78.15596347804427315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:53:00', 1, 0, '', '2019-06-04 15:53:00');
INSERT INTO `access_log` VALUES (27436, '64.80.15596347853177305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:53:05', 2, 0, '', '2019-06-04 15:53:05');
INSERT INTO `access_log` VALUES (27437, '64.83.15596347854497303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:53:05', 2, 0, '', '2019-06-04 15:53:05');
INSERT INTO `access_log` VALUES (27438, '59.73.15596347870487611', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:53:07', 13, 2001001000, '服务端发生异常', '2019-06-04 15:53:07');
INSERT INTO `access_log` VALUES (27439, '59.76.15596347870487601', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:53:07', 494, 0, '', '2019-06-04 15:53:08');
INSERT INTO `access_log` VALUES (27440, '65.51.15596347938697659', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:53:14', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 15:53:14');
INSERT INTO `access_log` VALUES (27441, '65.54.15596348345797629', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:53:55', 0, 1002001015, '账号未登陆', '2019-06-04 15:53:55');
INSERT INTO `access_log` VALUES (27442, '65.49.15596348345847679', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:53:55', 0, 1002001015, '账号未登陆', '2019-06-04 15:53:55');
INSERT INTO `access_log` VALUES (27443, '65.50.15596348345897665', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:53:55', 1, 1002001015, '账号未登陆', '2019-06-04 15:53:55');
INSERT INTO `access_log` VALUES (27444, '65.48.15596348373547661', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:53:57', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 15:53:57');
INSERT INTO `access_log` VALUES (27445, '65.52.15596348391757657', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:53:59', 100, 0, '', '2019-06-04 15:53:59');
INSERT INTO `access_log` VALUES (27446, '65.46.15596348396007655', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:54:00', 10, 0, '', '2019-06-04 15:54:00');
INSERT INTO `access_log` VALUES (27447, '65.51.15596348396017661', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:54:00', 10, 0, '', '2019-06-04 15:54:00');
INSERT INTO `access_log` VALUES (27448, '65.53.15596348396017631', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:54:00', 11, 0, '', '2019-06-04 15:54:00');
INSERT INTO `access_log` VALUES (27449, '62.84.15596348436717445', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:54:04', 14, 0, '', '2019-06-04 15:54:04');
INSERT INTO `access_log` VALUES (27450, '65.45.15596348437737677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:54:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 15:54:04');
INSERT INTO `access_log` VALUES (27451, '66.49.15596348463546245', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:54:06', 245, 0, '', '2019-06-04 15:54:07');
INSERT INTO `access_log` VALUES (27452, '66.53.15596348493256237', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=4&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:54:09', 620, 0, '', '2019-06-04 15:54:10');
INSERT INTO `access_log` VALUES (27453, '65.49.15596348506077681', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:54:11', 98, 0, '', '2019-06-04 15:54:11');
INSERT INTO `access_log` VALUES (27454, '65.50.15596348509757667', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:54:11', 9, 0, '', '2019-06-04 15:54:11');
INSERT INTO `access_log` VALUES (27455, '65.54.15596348509767631', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:54:11', 10, 0, '', '2019-06-04 15:54:11');
INSERT INTO `access_log` VALUES (27456, '65.48.15596348509837663', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:54:11', 9, 0, '', '2019-06-04 15:54:11');
INSERT INTO `access_log` VALUES (27457, '62.80.15596348590687461', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:54:19', 11, 0, '', '2019-06-04 15:54:19');
INSERT INTO `access_log` VALUES (27458, '59.78.15596348612967613', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:54:21', 184, 0, '', '2019-06-04 15:54:21');
INSERT INTO `access_log` VALUES (27459, '64.78.15596348650457317', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:54:25', 21, 0, '', '2019-06-04 15:54:25');
INSERT INTO `access_log` VALUES (27460, '64.84.15596348650447317', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:54:25', 25, 0, '', '2019-06-04 15:54:25');
INSERT INTO `access_log` VALUES (27461, '65.46.15596348726407657', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:54:33', 9, 0, '', '2019-06-04 15:54:33');
INSERT INTO `access_log` VALUES (27462, '65.53.15596348742547633', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '218.17.99.62', '2019-06-04 15:54:34', 523, 0, '', '2019-06-04 15:54:35');
INSERT INTO `access_log` VALUES (27463, '66.52.15596348810116245', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:54:41', 13, 0, '', '2019-06-04 15:54:41');
INSERT INTO `access_log` VALUES (27464, '59.73.15596348901247613', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:54:50', 11, 0, '', '2019-06-04 15:54:50');
INSERT INTO `access_log` VALUES (27465, '66.51.15596348987616239', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.164.42.58', '2019-06-04 15:54:59', 12, 0, '', '2019-06-04 15:54:59');
INSERT INTO `access_log` VALUES (27466, '65.47.15596349008067663', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:55:01', 1, 1002001015, '账号未登陆', '2019-06-04 15:55:01');
INSERT INTO `access_log` VALUES (27467, '65.49.15596349008127683', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:55:01', 0, 1002001015, '账号未登陆', '2019-06-04 15:55:01');
INSERT INTO `access_log` VALUES (27468, '65.50.15596349008167669', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:55:01', 0, 1002001015, '账号未登陆', '2019-06-04 15:55:01');
INSERT INTO `access_log` VALUES (27469, '65.48.15596349031727665', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:55:03', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 15:55:03');
INSERT INTO `access_log` VALUES (27470, '59.74.15596349082397607', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '103.208.15.203', '2019-06-04 15:55:08', 14, 2001001000, '服务端发生异常', '2019-06-04 15:55:08');
INSERT INTO `access_log` VALUES (27471, '59.75.15596349082387611', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '103.208.15.203', '2019-06-04 15:55:08', 208, 0, '', '2019-06-04 15:55:08');
INSERT INTO `access_log` VALUES (27472, '59.72.15596349286157609', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:55:29', 3, 0, '', '2019-06-04 15:55:29');
INSERT INTO `access_log` VALUES (27473, '59.71.15596349286157615', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:55:29', 10, 2001001000, '服务端发生异常', '2019-06-04 15:55:29');
INSERT INTO `access_log` VALUES (27474, '64.82.15596349333327323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:55:33', 3, 0, '', '2019-06-04 15:55:33');
INSERT INTO `access_log` VALUES (27475, '64.85.15596349334387329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:55:33', 2, 0, '', '2019-06-04 15:55:33');
INSERT INTO `access_log` VALUES (27476, '64.79.15596349348147309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:55:35', 2, 0, '', '2019-06-04 15:55:35');
INSERT INTO `access_log` VALUES (27477, '64.84.15596349355737319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:55:36', 2, 0, '', '2019-06-04 15:55:36');
INSERT INTO `access_log` VALUES (27478, '59.79.15596349402267611', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:55:40', 3, 0, '', '2019-06-04 15:55:40');
INSERT INTO `access_log` VALUES (27479, '59.77.15596349402267603', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:55:40', 13, 2001001000, '服务端发生异常', '2019-06-04 15:55:40');
INSERT INTO `access_log` VALUES (27480, '64.78.15596349482347319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:55:48', 2, 0, '', '2019-06-04 15:55:48');
INSERT INTO `access_log` VALUES (27481, '64.80.15596349483477309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:55:48', 2, 0, '', '2019-06-04 15:55:48');
INSERT INTO `access_log` VALUES (27482, '59.74.15596349622347609', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:02', 13, 2001001000, '服务端发生异常', '2019-06-04 15:56:02');
INSERT INTO `access_log` VALUES (27483, '59.76.15596349622337605', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:02', 212, 0, '', '2019-06-04 15:56:02');
INSERT INTO `access_log` VALUES (27484, '65.52.15596349941067663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:34', 86, 0, '', '2019-06-04 15:56:34');
INSERT INTO `access_log` VALUES (27485, '65.54.15596349944047635', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:34', 9, 0, '', '2019-06-04 15:56:34');
INSERT INTO `access_log` VALUES (27486, '65.45.15596349944097681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:34', 9, 0, '', '2019-06-04 15:56:34');
INSERT INTO `access_log` VALUES (27487, '65.51.15596349944117665', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:34', 9, 0, '', '2019-06-04 15:56:34');
INSERT INTO `access_log` VALUES (27488, '65.47.15596350051347667', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:45', 10, 0, '', '2019-06-04 15:56:45');
INSERT INTO `access_log` VALUES (27489, '65.50.15596350051427671', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:45', 40, 0, '', '2019-06-04 15:56:45');
INSERT INTO `access_log` VALUES (27490, '65.48.15596350051427669', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:45', 42, 0, '', '2019-06-04 15:56:45');
INSERT INTO `access_log` VALUES (27491, '65.46.15596350082407663', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:48', 9, 0, '', '2019-06-04 15:56:48');
INSERT INTO `access_log` VALUES (27492, '65.53.15596350082467639', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:48', 9, 0, '', '2019-06-04 15:56:48');
INSERT INTO `access_log` VALUES (27493, '65.52.15596350082477665', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:48', 8, 0, '', '2019-06-04 15:56:48');
INSERT INTO `access_log` VALUES (27494, '65.54.15596350105767637', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:51', 9, 0, '', '2019-06-04 15:56:51');
INSERT INTO `access_log` VALUES (27495, '65.45.15596350105797683', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:51', 9, 0, '', '2019-06-04 15:56:51');
INSERT INTO `access_log` VALUES (27496, '65.51.15596350105827667', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:51', 8, 0, '', '2019-06-04 15:56:51');
INSERT INTO `access_log` VALUES (27497, '65.49.15596350129437689', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:53', 9, 0, '', '2019-06-04 15:56:53');
INSERT INTO `access_log` VALUES (27498, '65.47.15596350129477669', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:53', 9, 0, '', '2019-06-04 15:56:53');
INSERT INTO `access_log` VALUES (27499, '65.48.15596350129507671', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:56:53', 8, 0, '', '2019-06-04 15:56:53');
INSERT INTO `access_log` VALUES (27500, '62.89.15596350264447469', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:57:06', 12, 0, '', '2019-06-04 15:57:06');
INSERT INTO `access_log` VALUES (27501, '64.84.15596350304967321', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:57:10', 8, 0, '', '2019-06-04 15:57:11');
INSERT INTO `access_log` VALUES (27502, '64.77.15596350304947321', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:57:10', 11, 0, '', '2019-06-04 15:57:11');
INSERT INTO `access_log` VALUES (27503, '66.51.15596350381676241', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:57:18', 13, 0, '', '2019-06-04 15:57:18');
INSERT INTO `access_log` VALUES (27504, '59.77.15596350408967605', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:57:21', 11, 0, '', '2019-06-04 15:57:21');
INSERT INTO `access_log` VALUES (27505, '65.53.15596350534947641', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:57:33', 19, 0, '', '2019-06-04 15:57:34');
INSERT INTO `access_log` VALUES (27506, '65.51.15596350596807669', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:57:40', 105, 0, '', '2019-06-04 15:57:40');
INSERT INTO `access_log` VALUES (27507, '65.45.15596350611267685', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:57:41', 7, 0, '', '2019-06-04 15:57:41');
INSERT INTO `access_log` VALUES (27508, '65.49.15596350690757691', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 15:57:49', 13, 0, '', '2019-06-04 15:57:49');
INSERT INTO `access_log` VALUES (27509, '65.53.15596354424827647', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:02', 0, 1002001015, '账号未登陆', '2019-06-04 16:04:02');
INSERT INTO `access_log` VALUES (27510, '65.54.15596354424857645', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:02', 1, 1002001015, '账号未登陆', '2019-06-04 16:04:02');
INSERT INTO `access_log` VALUES (27511, '65.51.15596354424957675', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:02', 1, 1002001015, '账号未登陆', '2019-06-04 16:04:02');
INSERT INTO `access_log` VALUES (27512, '65.49.15596354570927697', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:17', 69, 0, '', '2019-06-04 16:04:17');
INSERT INTO `access_log` VALUES (27513, '65.47.15596354574397677', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:17', 9, 0, '', '2019-06-04 16:04:17');
INSERT INTO `access_log` VALUES (27514, '65.48.15596354574487679', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:17', 8, 0, '', '2019-06-04 16:04:17');
INSERT INTO `access_log` VALUES (27515, '65.50.15596354574577681', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:17', 9, 0, '', '2019-06-04 16:04:17');
INSERT INTO `access_log` VALUES (27516, '64.77.15596354684607327', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:28', 12, 0, '', '2019-06-04 16:04:28');
INSERT INTO `access_log` VALUES (27517, '64.78.15596354684667327', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:28', 8, 0, '', '2019-06-04 16:04:28');
INSERT INTO `access_log` VALUES (27518, '66.51.15596354706626247', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:31', 13, 0, '', '2019-06-04 16:04:31');
INSERT INTO `access_log` VALUES (27519, '65.53.15596354828777649', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:43', 13, 0, '', '2019-06-04 16:04:43');
INSERT INTO `access_log` VALUES (27520, '65.51.15596354945387677', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:55', 1154, 0, '', '2019-06-04 16:04:56');
INSERT INTO `access_log` VALUES (27521, '65.45.15596354960477693', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:56', 1440, 0, '', '2019-06-04 16:04:57');
INSERT INTO `access_log` VALUES (27522, '65.49.15596354983347699', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:58', 810, 0, '', '2019-06-04 16:04:59');
INSERT INTO `access_log` VALUES (27523, '65.48.15596354994397681', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:04:59', 10, 0, '', '2019-06-04 16:04:59');
INSERT INTO `access_log` VALUES (27524, '65.47.15596355034357679', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:05:03', 9, 0, '', '2019-06-04 16:05:03');
INSERT INTO `access_log` VALUES (27525, '59.76.15596355101957613', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:05:10', 12, 0, '', '2019-06-04 16:05:10');
INSERT INTO `access_log` VALUES (27526, '66.49.15596355184416255', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:05:18', 12, 0, '', '2019-06-04 16:05:18');
INSERT INTO `access_log` VALUES (27527, '64.85.15596355228057339', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:05:23', 8, 0, '', '2019-06-04 16:05:23');
INSERT INTO `access_log` VALUES (27528, '64.82.15596355228007333', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:05:23', 16, 0, '', '2019-06-04 16:05:23');
INSERT INTO `access_log` VALUES (27529, '62.87.15596355268437467', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.3.193.119', '2019-06-04 16:05:27', 15, 0, '', '2019-06-04 16:05:27');
INSERT INTO `access_log` VALUES (27530, '65.50.15596359130897689', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:11:53', 1, 1002001015, '账号未登陆', '2019-06-04 16:11:53');
INSERT INTO `access_log` VALUES (27531, '65.46.15596359130947683', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:11:53', 1, 1002001015, '账号未登陆', '2019-06-04 16:11:53');
INSERT INTO `access_log` VALUES (27532, '65.52.15596359130987685', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:11:53', 1, 1002001015, '账号未登陆', '2019-06-04 16:11:53');
INSERT INTO `access_log` VALUES (27533, '65.54.15596359148517657', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:11:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 16:11:55');
INSERT INTO `access_log` VALUES (27534, '65.45.15596359300697701', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:12:10', 220, 0, '', '2019-06-04 16:12:10');
INSERT INTO `access_log` VALUES (27535, '65.48.15596359305457689', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:12:11', 266, 0, '', '2019-06-04 16:12:11');
INSERT INTO `access_log` VALUES (27536, '65.49.15596359305427707', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:12:11', 268, 0, '', '2019-06-04 16:12:11');
INSERT INTO `access_log` VALUES (27537, '65.47.15596359305487687', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:12:11', 264, 0, '', '2019-06-04 16:12:11');
INSERT INTO `access_log` VALUES (27538, '62.88.15596359374427485', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:12:17', 14, 0, '', '2019-06-04 16:12:17');
INSERT INTO `access_log` VALUES (27539, '64.82.15596359459797339', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:12:26', 8, 0, '', '2019-06-04 16:12:26');
INSERT INTO `access_log` VALUES (27540, '64.85.15596359459767345', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:12:26', 12, 0, '', '2019-06-04 16:12:26');
INSERT INTO `access_log` VALUES (27541, '59.74.15596359566877623', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:12:37', 12, 0, '', '2019-06-04 16:12:37');
INSERT INTO `access_log` VALUES (27542, '59.75.15596359621707627', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:12:42', 18, 2001001000, '服务端发生异常', '2019-06-04 16:12:42');
INSERT INTO `access_log` VALUES (27543, '59.80.15596359669547617', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:12:47', 11, 0, '', '2019-06-04 16:12:47');
INSERT INTO `access_log` VALUES (27544, '59.71.15596359717607631', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:12:52', 10, 0, '', '2019-06-04 16:12:52');
INSERT INTO `access_log` VALUES (27545, '65.53.15596359830537657', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:13:03', 25, 0, '', '2019-06-04 16:13:03');
INSERT INTO `access_log` VALUES (27546, '65.54.15596359842887659', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:13:04', 10, 0, '', '2019-06-04 16:13:04');
INSERT INTO `access_log` VALUES (27547, '65.51.15596359856177687', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:13:06', 196, 0, '', '2019-06-04 16:13:06');
INSERT INTO `access_log` VALUES (27548, '65.45.15596359863387703', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:13:06', 9, 0, '', '2019-06-04 16:13:06');
INSERT INTO `access_log` VALUES (27549, '59.79.15596359946927627', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:13:15', 3, 0, '', '2019-06-04 16:13:15');
INSERT INTO `access_log` VALUES (27550, '59.77.15596359946937619', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:13:15', 13, 2001001000, '服务端发生异常', '2019-06-04 16:13:15');
INSERT INTO `access_log` VALUES (27551, '64.77.15596359980667335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:13:18', 2, 0, '', '2019-06-04 16:13:18');
INSERT INTO `access_log` VALUES (27552, '64.80.15596359982257325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:13:18', 2, 0, '', '2019-06-04 16:13:18');
INSERT INTO `access_log` VALUES (27553, '64.83.15596359991737323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:13:19', 1, 0, '', '2019-06-04 16:13:19');
INSERT INTO `access_log` VALUES (27554, '64.76.15596359996527319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.12.50.224', '2019-06-04 16:13:20', 114, 0, '', '2019-06-04 16:13:20');
INSERT INTO `access_log` VALUES (27555, '65.46.15596366342487695', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:23:54', 0, 1002001015, '账号未登陆', '2019-06-04 16:23:54');
INSERT INTO `access_log` VALUES (27556, '65.52.15596366342487697', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:23:54', 0, 1002001015, '账号未登陆', '2019-06-04 16:23:54');
INSERT INTO `access_log` VALUES (27557, '65.53.15596366342527667', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:23:54', 1, 1002001015, '账号未登陆', '2019-06-04 16:23:54');
INSERT INTO `access_log` VALUES (27558, '65.54.15596366380477669', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:23:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 16:23:58');
INSERT INTO `access_log` VALUES (27559, '65.51.15596366408137697', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:24:01', 77, 0, '', '2019-06-04 16:24:01');
INSERT INTO `access_log` VALUES (27560, '65.45.15596366411477713', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:24:01', 10, 0, '', '2019-06-04 16:24:01');
INSERT INTO `access_log` VALUES (27561, '65.47.15596366411497699', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:24:01', 9, 0, '', '2019-06-04 16:24:01');
INSERT INTO `access_log` VALUES (27562, '65.48.15596366411517701', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:24:01', 8, 0, '', '2019-06-04 16:24:01');
INSERT INTO `access_log` VALUES (27563, '62.88.15596366450077495', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:24:05', 12, 0, '', '2019-06-04 16:24:05');
INSERT INTO `access_log` VALUES (27564, '64.78.15596366553627345', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:24:15', 10, 0, '', '2019-06-04 16:24:15');
INSERT INTO `access_log` VALUES (27565, '64.84.15596366553627345', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:24:15', 12, 0, '', '2019-06-04 16:24:15');
INSERT INTO `access_log` VALUES (27566, '64.80.15596366575557335', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:24:18', 8, 0, '', '2019-06-04 16:24:18');
INSERT INTO `access_log` VALUES (27567, '64.77.15596366575557345', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:24:18', 10, 0, '', '2019-06-04 16:24:18');
INSERT INTO `access_log` VALUES (27568, '64.76.15596366619027329', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:24:22', 9, 0, '', '2019-06-04 16:24:22');
INSERT INTO `access_log` VALUES (27569, '64.81.15596366619027337', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:24:22', 11, 0, '', '2019-06-04 16:24:22');
INSERT INTO `access_log` VALUES (27570, '64.85.15596366619037357', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:24:22', 14, 0, '', '2019-06-04 16:24:22');
INSERT INTO `access_log` VALUES (27571, '64.79.15596366761457337', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=3&name=111', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:24:36', 8, 1002002009, NULL, '2019-06-04 16:24:36');
INSERT INTO `access_log` VALUES (27572, '66.53.15596367203066263', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:25:20', 12, 0, '', '2019-06-04 16:25:20');
INSERT INTO `access_log` VALUES (27573, '59.77.15596367233227629', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:25:23', 519, 0, '', '2019-06-04 16:25:24');
INSERT INTO `access_log` VALUES (27574, '59.73.15596367293687641', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:25:29', 20, 2001001000, '服务端发生异常', '2019-06-04 16:25:29');
INSERT INTO `access_log` VALUES (27575, '59.75.15596367528097639', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:25:53', 11, 0, '', '2019-06-04 16:25:53');
INSERT INTO `access_log` VALUES (27576, '59.80.15596367550507629', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:25:55', 9, 0, '', '2019-06-04 16:25:55');
INSERT INTO `access_log` VALUES (27577, '59.72.15596367577287637', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 16:25:58', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-04 16:25:58');
INSERT INTO `access_log` VALUES (27578, '65.48.15596369163457705', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:28:36', 0, 1002001015, '账号未登陆', '2019-06-04 16:28:36');
INSERT INTO `access_log` VALUES (27579, '65.45.15596369163467717', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:28:36', 1, 1002001015, '账号未登陆', '2019-06-04 16:28:36');
INSERT INTO `access_log` VALUES (27580, '65.49.15596369163497723', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:28:36', 1, 1002001015, '账号未登陆', '2019-06-04 16:28:36');
INSERT INTO `access_log` VALUES (27581, '65.50.15596369177477707', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:28:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 16:28:38');
INSERT INTO `access_log` VALUES (27582, '65.46.15596369195277701', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:28:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 16:28:40');
INSERT INTO `access_log` VALUES (27583, '65.53.15596369205347673', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:28:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 16:28:41');
INSERT INTO `access_log` VALUES (27584, '65.54.15596369212577675', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:28:41', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 16:28:41');
INSERT INTO `access_log` VALUES (27585, '65.51.15596369281437703', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:28:48', 85, 0, '', '2019-06-04 16:28:48');
INSERT INTO `access_log` VALUES (27586, '65.47.15596369284107705', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:28:48', 10, 0, '', '2019-06-04 16:28:48');
INSERT INTO `access_log` VALUES (27587, '65.45.15596369284147719', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:28:48', 10, 0, '', '2019-06-04 16:28:48');
INSERT INTO `access_log` VALUES (27588, '65.49.15596369284167725', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:28:48', 9, 0, '', '2019-06-04 16:28:48');
INSERT INTO `access_log` VALUES (27589, '62.80.15596369308437497', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:28:51', 13, 0, '', '2019-06-04 16:28:51');
INSERT INTO `access_log` VALUES (27590, '62.81.15596369360787479', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:28:56', 12, 0, '', '2019-06-04 16:28:56');
INSERT INTO `access_log` VALUES (27591, '62.89.15596369486657497', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:29:09', 11, 0, '', '2019-06-04 16:29:09');
INSERT INTO `access_log` VALUES (27592, '62.86.15596369506077485', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:29:11', 16, 0, '', '2019-06-04 16:29:11');
INSERT INTO `access_log` VALUES (27593, '66.57.15596369521946273', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:29:12', 13, 0, '', '2019-06-04 16:29:12');
INSERT INTO `access_log` VALUES (27594, '59.73.15596369594747645', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:29:19', 11, 0, '', '2019-06-04 16:29:19');
INSERT INTO `access_log` VALUES (27595, '59.76.15596369668837635', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:29:27', 11, 0, '', '2019-06-04 16:29:27');
INSERT INTO `access_log` VALUES (27596, '65.54.15596370046377677', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-04 16:30:05', 3, 0, '', '2019-06-04 16:30:05');
INSERT INTO `access_log` VALUES (27597, '59.79.15596370506137643', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:30:51', 3, 0, '', '2019-06-04 16:30:51');
INSERT INTO `access_log` VALUES (27598, '59.77.15596370506237635', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:30:51', 13, 2001001000, '服务端发生异常', '2019-06-04 16:30:51');
INSERT INTO `access_log` VALUES (27599, '59.76.15596370658747637', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:31:06', 3, 0, '', '2019-06-04 16:31:06');
INSERT INTO `access_log` VALUES (27600, '59.74.15596370658887641', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:31:06', 13, 2001001000, '服务端发生异常', '2019-06-04 16:31:06');
INSERT INTO `access_log` VALUES (27601, '64.81.15596370700567343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:31:10', 2, 0, '', '2019-06-04 16:31:10');
INSERT INTO `access_log` VALUES (27602, '64.85.15596370702207363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:31:10', 2, 0, '', '2019-06-04 16:31:10');
INSERT INTO `access_log` VALUES (27603, '64.82.15596370712177357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:31:11', 2, 0, '', '2019-06-04 16:31:11');
INSERT INTO `access_log` VALUES (27604, '64.79.15596370717097343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:31:12', 1, 0, '', '2019-06-04 16:31:12');
INSERT INTO `access_log` VALUES (27605, '64.78.15596370721217353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:31:12', 2, 0, '', '2019-06-04 16:31:12');
INSERT INTO `access_log` VALUES (27606, '59.75.15596370730327645', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:31:13', 3, 0, '', '2019-06-04 16:31:13');
INSERT INTO `access_log` VALUES (27607, '59.80.15596370730357635', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:31:13', 17, 2001001000, '服务端发生异常', '2019-06-04 16:31:13');
INSERT INTO `access_log` VALUES (27608, '64.84.15596370804437353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:31:20', 2, 0, '', '2019-06-04 16:31:20');
INSERT INTO `access_log` VALUES (27609, '64.80.15596370805227343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:31:21', 1, 0, '', '2019-06-04 16:31:21');
INSERT INTO `access_log` VALUES (27610, '64.83.15596370822547341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:31:22', 120, 0, '', '2019-06-04 16:31:22');
INSERT INTO `access_log` VALUES (27611, '64.76.15596370829307337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:31:23', 2, 0, '', '2019-06-04 16:31:23');
INSERT INTO `access_log` VALUES (27612, '64.81.15596370834307345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:31:23', 2, 0, '', '2019-06-04 16:31:23');
INSERT INTO `access_log` VALUES (27613, '66.57.15596370835766275', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:31:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-06-04 16:31:24');
INSERT INTO `access_log` VALUES (27614, '66.48.15596370859056279', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:31:26', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空', '2019-06-04 16:31:26');
INSERT INTO `access_log` VALUES (27615, '66.49.15596370949446277', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17866624796', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:31:35', 274, 0, '', '2019-06-04 16:31:35');
INSERT INTO `access_log` VALUES (27616, '59.78.15596370966057649', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.91.40.55', '2019-06-04 16:31:37', 3, 0, '', '2019-06-04 16:31:37');
INSERT INTO `access_log` VALUES (27617, '59.79.15596370966097645', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.91.40.55', '2019-06-04 16:31:37', 12, 2001001000, '服务端发生异常', '2019-06-04 16:31:37');
INSERT INTO `access_log` VALUES (27618, '64.82.15596371027657359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.91.40.55', '2019-06-04 16:31:43', 2, 0, '', '2019-06-04 16:31:43');
INSERT INTO `access_log` VALUES (27619, '64.79.15596371028847345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.91.40.55', '2019-06-04 16:31:43', 2, 0, '', '2019-06-04 16:31:43');
INSERT INTO `access_log` VALUES (27620, '66.54.15596371064336273', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17866624796&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:31:46', 386, 0, '', '2019-06-04 16:31:47');
INSERT INTO `access_log` VALUES (27621, '66.52.15596371083496277', 105, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:31:48', 409, 0, '', '2019-06-04 16:31:49');
INSERT INTO `access_log` VALUES (27622, '64.84.15596371128067355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.91.40.55', '2019-06-04 16:31:53', 2, 0, '', '2019-06-04 16:31:53');
INSERT INTO `access_log` VALUES (27623, '64.77.15596371128727355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.91.40.55', '2019-06-04 16:31:53', 2, 0, '', '2019-06-04 16:31:53');
INSERT INTO `access_log` VALUES (27624, '64.80.15596371144307345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.91.40.55', '2019-06-04 16:31:54', 2, 0, '', '2019-06-04 16:31:54');
INSERT INTO `access_log` VALUES (27625, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.91.40.55', '2019-06-04 16:31:54', 16, 0, '', '2019-06-04 16:31:54');
INSERT INTO `access_log` VALUES (27626, '64.76.15596371159237339', 105, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.37.1.62', '2019-06-04 16:31:56', 6, 1003002003, 'Spu 只能添加在二级分类下', '2019-06-04 16:31:56');
INSERT INTO `access_log` VALUES (27627, '64.81.15596371166477347', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.91.40.55', '2019-06-04 16:31:57', 7, 0, '', '2019-06-04 16:31:57');
INSERT INTO `access_log` VALUES (27628, '66.51.15596371233766271', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.91.40.55', '2019-06-04 16:32:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空', '2019-06-04 16:32:03');
INSERT INTO `access_log` VALUES (27629, '65.54.15596371408997679', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:32:21', 1, 1002001015, '账号未登陆', '2019-06-04 16:32:21');
INSERT INTO `access_log` VALUES (27630, '65.51.15596371409057707', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:32:21', 0, 1002001015, '账号未登陆', '2019-06-04 16:32:21');
INSERT INTO `access_log` VALUES (27631, '65.47.15596371409077709', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:32:21', 1, 1002001015, '账号未登陆', '2019-06-04 16:32:21');
INSERT INTO `access_log` VALUES (27632, '66.48.15596374448986285', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:37:25', 15, 0, '', '2019-06-04 16:37:25');
INSERT INTO `access_log` VALUES (27633, '65.49.15596374462187733', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:37:26', 19, 0, '', '2019-06-04 16:37:26');
INSERT INTO `access_log` VALUES (27634, '65.48.15596374468597715', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:37:27', 10, 0, '', '2019-06-04 16:37:27');
INSERT INTO `access_log` VALUES (27635, '65.50.15596374499277717', 1, 2, 'admin-application', '/admin-api/admins/role/update', 'id=1&name=系统管理员&createTime=2019-02-24T01:03:51.000+0000', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:37:30', 22, 0, '', '2019-06-04 16:37:30');
INSERT INTO `access_log` VALUES (27636, '65.52.15596374500497713', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:37:30', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-06-04 16:37:30');
INSERT INTO `access_log` VALUES (27637, '59.74.15596374537257647', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.156.206.17', '2019-06-04 16:37:34', 11, 0, '', '2019-06-04 16:37:34');
INSERT INTO `access_log` VALUES (27638, '65.51.15596374763317713', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:37:56', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 16:37:56');
INSERT INTO `access_log` VALUES (27639, '65.47.15596374923727715', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:38:12', 91, 0, '', '2019-06-04 16:38:12');
INSERT INTO `access_log` VALUES (27640, '65.45.15596374930197729', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:38:13', 8, 0, '', '2019-06-04 16:38:13');
INSERT INTO `access_log` VALUES (27641, '65.49.15596374930197735', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:38:13', 9, 0, '', '2019-06-04 16:38:13');
INSERT INTO `access_log` VALUES (27642, '65.48.15596374930347717', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:38:13', 9, 0, '', '2019-06-04 16:38:13');
INSERT INTO `access_log` VALUES (27643, '66.52.15596375025476283', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:38:23', 13, 0, '', '2019-06-04 16:38:23');
INSERT INTO `access_log` VALUES (27644, '62.86.15596375174117493', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:38:37', 13, 0, '', '2019-06-04 16:38:37');
INSERT INTO `access_log` VALUES (27645, '62.83.15596375276617503', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:38:48', 12, 0, '', '2019-06-04 16:38:48');
INSERT INTO `access_log` VALUES (27646, '62.84.15596375284417491', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:38:48', 12, 0, '', '2019-06-04 16:38:48');
INSERT INTO `access_log` VALUES (27647, '62.88.15596375293767509', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:38:49', 12, 0, '', '2019-06-04 16:38:49');
INSERT INTO `access_log` VALUES (27648, '62.80.15596375332997507', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:38:53', 12, 0, '', '2019-06-04 16:38:53');
INSERT INTO `access_log` VALUES (27649, '62.85.15596375340687503', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:38:54', 20, 0, '', '2019-06-04 16:38:54');
INSERT INTO `access_log` VALUES (27650, '62.81.15596375353267489', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=4&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:38:55', 77, 0, '', '2019-06-04 16:38:55');
INSERT INTO `access_log` VALUES (27651, '59.73.15596375512647655', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:39:11', 11, 0, '', '2019-06-04 16:39:11');
INSERT INTO `access_log` VALUES (27652, '59.74.15596375638657649', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update_status', 'id=2&status=2', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-04 16:39:24', 8, 1002002009, NULL, '2019-06-04 16:39:24');
INSERT INTO `access_log` VALUES (27653, '65.53.15596376795637687', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.20.176.50', '2019-06-04 16:41:20', 0, 1002001015, '账号未登陆', '2019-06-04 16:41:20');
INSERT INTO `access_log` VALUES (27654, '65.46.15596376795627715', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.20.176.50', '2019-06-04 16:41:20', 0, 1002001015, '账号未登陆', '2019-06-04 16:41:20');
INSERT INTO `access_log` VALUES (27655, '65.51.15596376795767717', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.20.176.50', '2019-06-04 16:41:20', 1, 1002001015, '账号未登陆', '2019-06-04 16:41:20');
INSERT INTO `access_log` VALUES (27656, '65.54.15596376821647689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.20.176.50', '2019-06-04 16:41:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 16:41:22');
INSERT INTO `access_log` VALUES (27657, '65.45.15596376888347733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.20.176.50', '2019-06-04 16:41:29', 214, 0, '', '2019-06-04 16:41:29');
INSERT INTO `access_log` VALUES (27658, '65.48.15596376893957721', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.20.176.50', '2019-06-04 16:41:29', 9, 0, '', '2019-06-04 16:41:29');
INSERT INTO `access_log` VALUES (27659, '65.49.15596376894007739', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.20.176.50', '2019-06-04 16:41:29', 9, 0, '', '2019-06-04 16:41:29');
INSERT INTO `access_log` VALUES (27660, '65.50.15596376894107723', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.20.176.50', '2019-06-04 16:41:29', 10, 0, '', '2019-06-04 16:41:29');
INSERT INTO `access_log` VALUES (27661, '62.89.15596376953947509', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.20.176.50', '2019-06-04 16:41:35', 13, 0, '', '2019-06-04 16:41:35');
INSERT INTO `access_log` VALUES (27662, '66.57.15596376996916285', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.20.176.50', '2019-06-04 16:41:40', 13, 0, '', '2019-06-04 16:41:40');
INSERT INTO `access_log` VALUES (27663, '59.74.15596377009287651', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.20.176.50', '2019-06-04 16:41:41', 11, 0, '', '2019-06-04 16:41:41');
INSERT INTO `access_log` VALUES (27664, '65.51.15596377026047719', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.20.176.50', '2019-06-04 16:41:43', 19, 0, '', '2019-06-04 16:41:43');
INSERT INTO `access_log` VALUES (27665, '65.45.15596382205997741', 0, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:50:21', 5, 1002001012, '访问令牌已过期', '2019-06-04 16:50:21');
INSERT INTO `access_log` VALUES (27666, '65.48.15596382286897729', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:50:29', 101, 0, '', '2019-06-04 16:50:29');
INSERT INTO `access_log` VALUES (27667, '65.50.15596382291367731', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:50:29', 17, 0, '', '2019-06-04 16:50:29');
INSERT INTO `access_log` VALUES (27668, '65.52.15596382291397727', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:50:29', 17, 0, '', '2019-06-04 16:50:29');
INSERT INTO `access_log` VALUES (27669, '65.51.15596382291437727', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:50:29', 16, 0, '', '2019-06-04 16:50:29');
INSERT INTO `access_log` VALUES (27670, '65.46.15596382316997725', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:50:32', 19, 0, '', '2019-06-04 16:50:32');
INSERT INTO `access_log` VALUES (27671, '65.53.15596382321717697', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:50:32', 9, 0, '', '2019-06-04 16:50:32');
INSERT INTO `access_log` VALUES (27672, '65.54.15596382346357699', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:50:35', 12, 0, '', '2019-06-04 16:50:35');
INSERT INTO `access_log` VALUES (27673, '65.45.15596382409307743', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:50:41', 12, 0, '', '2019-06-04 16:50:41');
INSERT INTO `access_log` VALUES (27674, '65.49.15596382433197749', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:50:43', 12, 0, '', '2019-06-04 16:50:43');
INSERT INTO `access_log` VALUES (27675, '65.46.15596383004337727', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:51:40', 13, 0, '', '2019-06-04 16:51:40');
INSERT INTO `access_log` VALUES (27676, '59.79.15596383809377663', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:01', 3, 0, '', '2019-06-04 16:53:01');
INSERT INTO `access_log` VALUES (27677, '59.77.15596383809377655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:01', 19, 2001001000, '服务端发生异常', '2019-06-04 16:53:01');
INSERT INTO `access_log` VALUES (27678, '64.84.15596383829167373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:03', 3, 0, '', '2019-06-04 16:53:03');
INSERT INTO `access_log` VALUES (27679, '64.77.15596383830227373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:03', 1, 0, '', '2019-06-04 16:53:03');
INSERT INTO `access_log` VALUES (27680, '64.80.15596383840747363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:04', 2, 0, '', '2019-06-04 16:53:04');
INSERT INTO `access_log` VALUES (27681, '64.83.15596383845977361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:05', 2, 0, '', '2019-06-04 16:53:05');
INSERT INTO `access_log` VALUES (27682, '64.81.15596383868237365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:07', 2, 0, '', '2019-06-04 16:53:07');
INSERT INTO `access_log` VALUES (27683, '64.85.15596383868927385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:07', 1, 0, '', '2019-06-04 16:53:07');
INSERT INTO `access_log` VALUES (27684, '59.76.15596383878737657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:08', 2, 0, '', '2019-06-04 16:53:08');
INSERT INTO `access_log` VALUES (27685, '59.74.15596383878737661', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:08', 12, 2001001000, '服务端发生异常', '2019-06-04 16:53:08');
INSERT INTO `access_log` VALUES (27686, '65.51.15596383932237731', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:53:13', 0, 1002001015, '账号未登陆', '2019-06-04 16:53:13');
INSERT INTO `access_log` VALUES (27687, '65.52.15596383932267731', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:53:13', 1, 1002001015, '账号未登陆', '2019-06-04 16:53:13');
INSERT INTO `access_log` VALUES (27688, '65.50.15596383932307735', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:53:13', 1, 1002001015, '账号未登陆', '2019-06-04 16:53:13');
INSERT INTO `access_log` VALUES (27689, '65.46.15596383959007729', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:53:16', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 16:53:16');
INSERT INTO `access_log` VALUES (27690, '65.53.15596383998277701', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:20', 1, 1002001015, '账号未登陆', '2019-06-04 16:53:20');
INSERT INTO `access_log` VALUES (27691, '65.54.15596383998297703', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:20', 0, 1002001015, '账号未登陆', '2019-06-04 16:53:20');
INSERT INTO `access_log` VALUES (27692, '65.47.15596383998307733', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:20', 0, 1002001015, '账号未登陆', '2019-06-04 16:53:20');
INSERT INTO `access_log` VALUES (27693, '65.49.15596384149557753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:53:35', 104, 0, '', '2019-06-04 16:53:35');
INSERT INTO `access_log` VALUES (27694, '65.48.15596384153127735', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:53:35', 10, 0, '', '2019-06-04 16:53:35');
INSERT INTO `access_log` VALUES (27695, '65.52.15596384153167733', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:53:35', 9, 0, '', '2019-06-04 16:53:35');
INSERT INTO `access_log` VALUES (27696, '65.50.15596384153187737', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:53:35', 9, 0, '', '2019-06-04 16:53:35');
INSERT INTO `access_log` VALUES (27697, '65.51.15596384163237733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:36', 270, 0, '', '2019-06-04 16:53:37');
INSERT INTO `access_log` VALUES (27698, '65.46.15596384168977731', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:37', 8, 0, '', '2019-06-04 16:53:37');
INSERT INTO `access_log` VALUES (27699, '65.47.15596384168987735', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:37', 9, 0, '', '2019-06-04 16:53:37');
INSERT INTO `access_log` VALUES (27700, '65.53.15596384168997703', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:37', 10, 0, '', '2019-06-04 16:53:37');
INSERT INTO `access_log` VALUES (27701, '62.86.15596384194237507', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:53:39', 128, 0, '', '2019-06-04 16:53:40');
INSERT INTO `access_log` VALUES (27702, '62.83.15596384230817517', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:53:43', 14, 0, '', '2019-06-04 16:53:43');
INSERT INTO `access_log` VALUES (27703, '62.84.15596384247807505', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:45', 12, 0, '', '2019-06-04 16:53:45');
INSERT INTO `access_log` VALUES (27704, '62.88.15596384248667523', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:53:45', 11, 0, '', '2019-06-04 16:53:45');
INSERT INTO `access_log` VALUES (27705, '59.72.15596384283657663', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:48', 9, 0, '', '2019-06-04 16:53:48');
INSERT INTO `access_log` VALUES (27706, '65.45.15596384310707749', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:51', 16, 0, '', '2019-06-04 16:53:51');
INSERT INTO `access_log` VALUES (27707, '65.49.15596384321747755', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:52', 10, 0, '', '2019-06-04 16:53:52');
INSERT INTO `access_log` VALUES (27708, '65.48.15596384333377737', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:53', 327, 0, '', '2019-06-04 16:53:54');
INSERT INTO `access_log` VALUES (27709, '59.78.15596384348317669', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:55', 11, 0, '', '2019-06-04 16:53:55');
INSERT INTO `access_log` VALUES (27710, '59.77.15596384369297657', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '180.152.13.212', '2019-06-04 16:53:57', 12, 0, '', '2019-06-04 16:53:57');
INSERT INTO `access_log` VALUES (27711, '62.82.15596384446807525', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:54:05', 14, 0, '', '2019-06-04 16:54:05');
INSERT INTO `access_log` VALUES (27712, '64.80.15596384471917365', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:54:07', 11, 0, '', '2019-06-04 16:54:07');
INSERT INTO `access_log` VALUES (27713, '64.77.15596384471887375', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:54:07', 14, 0, '', '2019-06-04 16:54:07');
INSERT INTO `access_log` VALUES (27714, '64.85.15596384839177387', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:54:44', 11, 0, '', '2019-06-04 16:54:44');
INSERT INTO `access_log` VALUES (27715, '64.81.15596384839167367', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:54:44', 12, 0, '', '2019-06-04 16:54:44');
INSERT INTO `access_log` VALUES (27716, '64.79.15596384892057367', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:54:49', 9, 0, '', '2019-06-04 16:54:49');
INSERT INTO `access_log` VALUES (27717, '64.78.15596384892347377', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:54:49', 542, 0, '', '2019-06-04 16:54:50');
INSERT INTO `access_log` VALUES (27718, '64.82.15596384892047381', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:54:49', 576, 0, '', '2019-06-04 16:54:50');
INSERT INTO `access_log` VALUES (27719, '64.80.15596384949197367', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:54:55', 8, 0, '', '2019-06-04 16:54:55');
INSERT INTO `access_log` VALUES (27720, '64.77.15596384949187377', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:54:55', 10, 0, '', '2019-06-04 16:54:55');
INSERT INTO `access_log` VALUES (27721, '62.88.15596384984427525', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:54:58', 14, 0, '', '2019-06-04 16:54:58');
INSERT INTO `access_log` VALUES (27722, '62.87.15596385013027513', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:55:01', 17, 0, '', '2019-06-04 16:55:01');
INSERT INTO `access_log` VALUES (27723, '64.76.15596385029797361', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:55:03', 889, 0, '', '2019-06-04 16:55:04');
INSERT INTO `access_log` VALUES (27724, '64.83.15596385029777365', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:55:03', 892, 0, '', '2019-06-04 16:55:04');
INSERT INTO `access_log` VALUES (27725, '64.79.15596385061047369', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:55:06', 7, 0, '', '2019-06-04 16:55:06');
INSERT INTO `access_log` VALUES (27726, '64.81.15596385061037369', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:55:06', 9, 0, '', '2019-06-04 16:55:06');
INSERT INTO `access_log` VALUES (27727, '64.78.15596385088767379', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:55:09', 1727, 0, '', '2019-06-04 16:55:11');
INSERT INTO `access_log` VALUES (27728, '66.55.15596385161316299', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:55:16', 13, 0, '', '2019-06-04 16:55:16');
INSERT INTO `access_log` VALUES (27729, '59.80.15596385185177657', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:55:19', 11, 0, '', '2019-06-04 16:55:19');
INSERT INTO `access_log` VALUES (27730, '59.71.15596385227767671', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:55:23', 22, 2001001000, '服务端发生异常', '2019-06-04 16:55:23');
INSERT INTO `access_log` VALUES (27731, '59.78.15596385271577671', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:55:27', 8, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-04 16:55:27');
INSERT INTO `access_log` VALUES (27732, '65.45.15596385294957751', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:55:29', 19, 0, '', '2019-06-04 16:55:30');
INSERT INTO `access_log` VALUES (27733, '65.49.15596385306327757', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:55:31', 11, 0, '', '2019-06-04 16:55:31');
INSERT INTO `access_log` VALUES (27734, '65.48.15596385319537739', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:55:32', 10, 0, '', '2019-06-04 16:55:32');
INSERT INTO `access_log` VALUES (27735, '65.50.15596385330227741', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:55:33', 9, 0, '', '2019-06-04 16:55:33');
INSERT INTO `access_log` VALUES (27736, '65.52.15596385348187737', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-04 16:55:35', 14, 0, '', '2019-06-04 16:55:35');
INSERT INTO `access_log` VALUES (27737, '65.51.15596385365047737', 27, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=2&resourceIds=31,44', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:55:37', 69, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-04 16:55:37');
INSERT INTO `access_log` VALUES (27738, '65.53.15596385404847707', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:55:40', 9, 0, '', '2019-06-04 16:55:40');
INSERT INTO `access_log` VALUES (27739, '65.47.15596385464147739', 27, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=2&resourceIds=31,44', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:55:46', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-04 16:55:46');
INSERT INTO `access_log` VALUES (27740, '65.45.15596385649917753', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:56:05', 12, 0, '', '2019-06-04 16:56:05');
INSERT INTO `access_log` VALUES (27741, '65.52.15596385659697739', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 16:56:06', 24, 1002001012, '访问令牌已过期', '2019-06-04 16:56:06');
INSERT INTO `access_log` VALUES (27742, '65.48.15596385659207741', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 16:56:06', 73, 1002001012, '访问令牌已过期', '2019-06-04 16:56:06');
INSERT INTO `access_log` VALUES (27743, '65.49.15596385659207759', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 16:56:06', 74, 1002001012, '访问令牌已过期', '2019-06-04 16:56:06');
INSERT INTO `access_log` VALUES (27744, '65.50.15596385659357743', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 16:56:06', 59, 1002001012, '访问令牌已过期', '2019-06-04 16:56:06');
INSERT INTO `access_log` VALUES (27745, '65.51.15596385681987739', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 16:56:08', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 16:56:08');
INSERT INTO `access_log` VALUES (27746, '65.46.15596385686397737', 27, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=2&resourceIds=31,44', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:56:09', 5, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-04 16:56:09');
INSERT INTO `access_log` VALUES (27747, '65.47.15596385723897741', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 16:56:12', 12, 0, '', '2019-06-04 16:56:12');
INSERT INTO `access_log` VALUES (27748, '65.54.15596385752287711', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 16:56:15', 81, 0, '', '2019-06-04 16:56:15');
INSERT INTO `access_log` VALUES (27749, '65.45.15596385755037755', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 16:56:16', 8, 0, '', '2019-06-04 16:56:16');
INSERT INTO `access_log` VALUES (27750, '65.48.15596385755057743', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 16:56:16', 9, 0, '', '2019-06-04 16:56:16');
INSERT INTO `access_log` VALUES (27751, '65.49.15596385755117761', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 16:56:16', 7, 0, '', '2019-06-04 16:56:16');
INSERT INTO `access_log` VALUES (27752, '65.45.15596386888957757', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 16:58:09', 4, 1002001012, '访问令牌已过期', '2019-06-04 16:58:09');
INSERT INTO `access_log` VALUES (27753, '65.48.15596386888977745', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 16:58:09', 3, 1002001012, '访问令牌已过期', '2019-06-04 16:58:09');
INSERT INTO `access_log` VALUES (27754, '65.49.15596386889027763', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 16:58:09', 3, 1002001012, '访问令牌已过期', '2019-06-04 16:58:09');
INSERT INTO `access_log` VALUES (27755, '65.50.15596386889807747', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-04 16:58:09', 5, 1002001012, '访问令牌已过期', '2019-06-04 16:58:09');
INSERT INTO `access_log` VALUES (27756, '65.54.15596389023067717', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:01:42', 0, 1002001015, '账号未登陆', '2019-06-04 17:01:42');
INSERT INTO `access_log` VALUES (27757, '65.52.15596389023117747', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:01:42', 0, 1002001015, '账号未登陆', '2019-06-04 17:01:42');
INSERT INTO `access_log` VALUES (27758, '65.48.15596389023137749', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:01:42', 0, 1002001015, '账号未登陆', '2019-06-04 17:01:42');
INSERT INTO `access_log` VALUES (27759, '65.49.15596389040807767', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:01:44', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 17:01:44');
INSERT INTO `access_log` VALUES (27760, '65.51.15596389372087747', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:02:17', 77, 0, '', '2019-06-04 17:02:17');
INSERT INTO `access_log` VALUES (27761, '65.46.15596389375917745', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:02:18', 11, 0, '', '2019-06-04 17:02:18');
INSERT INTO `access_log` VALUES (27762, '65.53.15596389375947717', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:02:18', 9, 0, '', '2019-06-04 17:02:18');
INSERT INTO `access_log` VALUES (27763, '65.47.15596389375987749', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:02:18', 9, 0, '', '2019-06-04 17:02:18');
INSERT INTO `access_log` VALUES (27764, '62.81.15596389445437511', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:02:25', 12, 0, '', '2019-06-04 17:02:25');
INSERT INTO `access_log` VALUES (27765, '64.82.15596389491137389', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:02:29', 122, 0, '', '2019-06-04 17:02:29');
INSERT INTO `access_log` VALUES (27766, '64.78.15596389491117385', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:02:29', 126, 0, '', '2019-06-04 17:02:29');
INSERT INTO `access_log` VALUES (27767, '59.78.15596389634627677', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:02:43', 12, 0, '', '2019-06-04 17:02:43');
INSERT INTO `access_log` VALUES (27768, '59.77.15596389665087665', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:02:47', 19, 2001001000, '服务端发生异常', '2019-06-04 17:02:47');
INSERT INTO `access_log` VALUES (27769, '65.54.15596389733047719', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:02:53', 186, 0, '', '2019-06-04 17:02:53');
INSERT INTO `access_log` VALUES (27770, '65.45.15596389771707763', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:02:57', 15, 0, '', '2019-06-04 17:02:57');
INSERT INTO `access_log` VALUES (27771, '65.50.15596389779307753', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:02:58', 17, 0, '', '2019-06-04 17:02:58');
INSERT INTO `access_log` VALUES (27772, '65.47.15596389870667751', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:07', 9, 0, '', '2019-06-04 17:03:07');
INSERT INTO `access_log` VALUES (27773, '65.51.15596389870667749', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:07', 9, 0, '', '2019-06-04 17:03:07');
INSERT INTO `access_log` VALUES (27774, '65.53.15596389870677719', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:07', 9, 0, '', '2019-06-04 17:03:07');
INSERT INTO `access_log` VALUES (27775, '65.46.15596389871467747', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:07', 461, 0, '', '2019-06-04 17:03:08');
INSERT INTO `access_log` VALUES (27776, '65.49.15596389910727771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:11', 33, 0, '', '2019-06-04 17:03:11');
INSERT INTO `access_log` VALUES (27777, '65.52.15596389910617751', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:11', 44, 0, '', '2019-06-04 17:03:11');
INSERT INTO `access_log` VALUES (27778, '65.54.15596389910637721', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:11', 42, 0, '', '2019-06-04 17:03:11');
INSERT INTO `access_log` VALUES (27779, '65.45.15596389911167765', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:11', 14, 0, '', '2019-06-04 17:03:11');
INSERT INTO `access_log` VALUES (27780, '65.50.15596389932347755', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:13', 9, 0, '', '2019-06-04 17:03:13');
INSERT INTO `access_log` VALUES (27781, '65.47.15596389932387753', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:13', 9, 0, '', '2019-06-04 17:03:13');
INSERT INTO `access_log` VALUES (27782, '65.51.15596389932417751', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:13', 8, 0, '', '2019-06-04 17:03:13');
INSERT INTO `access_log` VALUES (27783, '65.53.15596389932937721', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:13', 17, 0, '', '2019-06-04 17:03:13');
INSERT INTO `access_log` VALUES (27784, '65.46.15596389976827749', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:18', 9, 0, '', '2019-06-04 17:03:18');
INSERT INTO `access_log` VALUES (27785, '65.48.15596389976827755', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:18', 9, 0, '', '2019-06-04 17:03:18');
INSERT INTO `access_log` VALUES (27786, '65.52.15596389976897753', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:18', 8, 0, '', '2019-06-04 17:03:18');
INSERT INTO `access_log` VALUES (27787, '65.45.15596389977337767', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:03:18', 25, 0, '', '2019-06-04 17:03:18');
INSERT INTO `access_log` VALUES (27788, '65.47.15596390474727755', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:07', 0, 1002001015, '账号未登陆', '2019-06-04 17:04:07');
INSERT INTO `access_log` VALUES (27789, '65.53.15596390474737723', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:07', 1, 1002001015, '账号未登陆', '2019-06-04 17:04:07');
INSERT INTO `access_log` VALUES (27790, '65.50.15596390474727757', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:07', 0, 1002001015, '账号未登陆', '2019-06-04 17:04:07');
INSERT INTO `access_log` VALUES (27791, '65.46.15596390495547751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:10', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 17:04:10');
INSERT INTO `access_log` VALUES (27792, '65.45.15596390665627769', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:04:27', 20, 0, '', '2019-06-04 17:04:27');
INSERT INTO `access_log` VALUES (27793, '59.71.15596390668717679', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:04:27', 12, 0, '', '2019-06-04 17:04:27');
INSERT INTO `access_log` VALUES (27794, '64.78.15596390675837387', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:04:28', 9, 0, '', '2019-06-04 17:04:28');
INSERT INTO `access_log` VALUES (27795, '64.82.15596390675827391', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:04:28', 12, 0, '', '2019-06-04 17:04:28');
INSERT INTO `access_log` VALUES (27796, '62.82.15596390677447535', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:04:28', 12, 0, '', '2019-06-04 17:04:28');
INSERT INTO `access_log` VALUES (27797, '65.54.15596390685717725', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:29', 74, 0, '', '2019-06-04 17:04:29');
INSERT INTO `access_log` VALUES (27798, '65.49.15596390689917775', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:29', 9, 0, '', '2019-06-04 17:04:29');
INSERT INTO `access_log` VALUES (27799, '65.51.15596390689927755', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:29', 9, 0, '', '2019-06-04 17:04:29');
INSERT INTO `access_log` VALUES (27800, '65.50.15596390689927759', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:29', 9, 0, '', '2019-06-04 17:04:29');
INSERT INTO `access_log` VALUES (27801, '65.46.15596390860067753', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:46', 11, 0, '', '2019-06-04 17:04:46');
INSERT INTO `access_log` VALUES (27802, '65.52.15596390860057757', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:46', 14, 0, '', '2019-06-04 17:04:46');
INSERT INTO `access_log` VALUES (27803, '65.47.15596390860047757', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:46', 10, 0, '', '2019-06-04 17:04:46');
INSERT INTO `access_log` VALUES (27804, '65.48.15596390925057759', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:53', 9, 0, '', '2019-06-04 17:04:53');
INSERT INTO `access_log` VALUES (27805, '65.45.15596390925057771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:53', 9, 0, '', '2019-06-04 17:04:53');
INSERT INTO `access_log` VALUES (27806, '65.54.15596390925067727', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:53', 586, 0, '', '2019-06-04 17:04:53');
INSERT INTO `access_log` VALUES (27807, '65.53.15596390957587727', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:56', 10, 0, '', '2019-06-04 17:04:56');
INSERT INTO `access_log` VALUES (27808, '65.51.15596390957577757', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:56', 9, 0, '', '2019-06-04 17:04:56');
INSERT INTO `access_log` VALUES (27809, '65.49.15596390957587777', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:04:56', 10, 0, '', '2019-06-04 17:04:56');
INSERT INTO `access_log` VALUES (27810, '62.83.15596391010087529', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:05:01', 2311, 0, '', '2019-06-04 17:05:03');
INSERT INTO `access_log` VALUES (27811, '65.50.15596391909687763', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '140.207.231.5', '2019-06-04 17:06:31', 0, 1002001015, '账号未登陆', '2019-06-04 17:06:31');
INSERT INTO `access_log` VALUES (27812, '65.53.15596391909687729', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '140.207.231.5', '2019-06-04 17:06:31', 0, 1002001015, '账号未登陆', '2019-06-04 17:06:31');
INSERT INTO `access_log` VALUES (27813, '65.48.15596391909767763', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '140.207.231.5', '2019-06-04 17:06:31', 0, 1002001015, '账号未登陆', '2019-06-04 17:06:31');
INSERT INTO `access_log` VALUES (27814, '65.54.15596391943887731', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '140.207.231.5', '2019-06-04 17:06:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 17:06:34');
INSERT INTO `access_log` VALUES (27815, '65.47.15596392006587761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '140.207.231.5', '2019-06-04 17:06:41', 78, 0, '', '2019-06-04 17:06:41');
INSERT INTO `access_log` VALUES (27816, '65.51.15596392009087759', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '140.207.231.5', '2019-06-04 17:06:41', 8, 0, '', '2019-06-04 17:06:41');
INSERT INTO `access_log` VALUES (27817, '65.46.15596392009097759', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '140.207.231.5', '2019-06-04 17:06:41', 9, 0, '', '2019-06-04 17:06:41');
INSERT INTO `access_log` VALUES (27818, '65.52.15596392009127761', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '140.207.231.5', '2019-06-04 17:06:41', 9, 0, '', '2019-06-04 17:06:41');
INSERT INTO `access_log` VALUES (27819, '62.89.15596392047107533', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '140.207.231.5', '2019-06-04 17:06:45', 12, 0, '', '2019-06-04 17:06:45');
INSERT INTO `access_log` VALUES (27820, '65.46.15596393387277761', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:08:59', 165, 0, '', '2019-06-04 17:08:59');
INSERT INTO `access_log` VALUES (27821, '65.45.15596393387287779', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:08:59', 165, 0, '', '2019-06-04 17:08:59');
INSERT INTO `access_log` VALUES (27822, '65.50.15596393387297767', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:08:59', 165, 0, '', '2019-06-04 17:08:59');
INSERT INTO `access_log` VALUES (27823, '65.48.15596393459897767', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '60.208.18.134', '2019-06-04 17:09:06', 1, 1002001015, '账号未登陆', '2019-06-04 17:09:06');
INSERT INTO `access_log` VALUES (27824, '65.53.15596393459937733', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '60.208.18.134', '2019-06-04 17:09:06', 0, 1002001015, '账号未登陆', '2019-06-04 17:09:06');
INSERT INTO `access_log` VALUES (27825, '65.54.15596393459997735', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '60.208.18.134', '2019-06-04 17:09:06', 0, 1002001015, '账号未登陆', '2019-06-04 17:09:06');
INSERT INTO `access_log` VALUES (27826, '62.86.15596393481127523', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:09:08', 10, 0, '', '2019-06-04 17:09:08');
INSERT INTO `access_log` VALUES (27827, '65.47.15596393515857765', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '60.208.18.134', '2019-06-04 17:09:12', 336, 0, '', '2019-06-04 17:09:12');
INSERT INTO `access_log` VALUES (27828, '65.45.15596393524527781', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '60.208.18.134', '2019-06-04 17:09:12', 7, 0, '', '2019-06-04 17:09:12');
INSERT INTO `access_log` VALUES (27829, '65.52.15596393524527765', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '60.208.18.134', '2019-06-04 17:09:12', 9, 0, '', '2019-06-04 17:09:12');
INSERT INTO `access_log` VALUES (27830, '65.51.15596393524527763', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '60.208.18.134', '2019-06-04 17:09:12', 8, 0, '', '2019-06-04 17:09:12');
INSERT INTO `access_log` VALUES (27831, '62.84.15596393624547521', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '60.208.18.134', '2019-06-04 17:09:22', 26, 0, '', '2019-06-04 17:09:22');
INSERT INTO `access_log` VALUES (27832, '62.88.15596393691957539', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&hasRefund=false', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '60.208.18.134', '2019-06-04 17:09:29', 12, 0, '', '2019-06-04 17:09:29');
INSERT INTO `access_log` VALUES (27833, '62.80.15596393871447537', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:09:47', 11, 0, '', '2019-06-04 17:09:47');
INSERT INTO `access_log` VALUES (27834, '62.85.15596393896787533', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:09:50', 15, 0, '', '2019-06-04 17:09:50');
INSERT INTO `access_log` VALUES (27835, '64.76.15596394118907375', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:10:12', 10, 0, '', '2019-06-04 17:10:12');
INSERT INTO `access_log` VALUES (27836, '64.83.15596394118897379', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:10:12', 12, 0, '', '2019-06-04 17:10:12');
INSERT INTO `access_log` VALUES (27837, '65.45.15596394569597783', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:10:57', 4, 0, '', '2019-06-04 17:10:57');
INSERT INTO `access_log` VALUES (27838, '65.51.15596394806387765', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:11:21', 4, 0, '', '2019-06-04 17:11:21');
INSERT INTO `access_log` VALUES (27839, '65.46.15596394853567765', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:11:25', 3, 0, '', '2019-06-04 17:11:25');
INSERT INTO `access_log` VALUES (27840, '66.53.15596395182406303', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:11:58', 13, 0, '', '2019-06-04 17:11:58');
INSERT INTO `access_log` VALUES (27841, '59.78.15596396630777687', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:14:23', 11, 0, '', '2019-06-04 17:14:23');
INSERT INTO `access_log` VALUES (27842, '65.48.15596396788457773', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:14:39', 4, 0, '', '2019-06-04 17:14:39');
INSERT INTO `access_log` VALUES (27843, '59.74.15596397265187681', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:15:27', 27, 2001001000, '服务端发生异常', '2019-06-04 17:15:27');
INSERT INTO `access_log` VALUES (27844, '59.80.15596397418347675', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:15:42', 13, 0, '', '2019-06-04 17:15:42');
INSERT INTO `access_log` VALUES (27845, '64.82.15596397513287401', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:15:51', 9, 0, '', '2019-06-04 17:15:51');
INSERT INTO `access_log` VALUES (27846, '64.78.15596397634857397', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:16:03', 9, 0, '', '2019-06-04 17:16:03');
INSERT INTO `access_log` VALUES (27847, '59.78.15596397667877689', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:16:07', 11, 0, '', '2019-06-04 17:16:07');
INSERT INTO `access_log` VALUES (27848, '59.77.15596397731547677', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:16:13', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-04 17:16:13');
INSERT INTO `access_log` VALUES (27849, '65.54.15596397773857743', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:16:17', 20, 0, '', '2019-06-04 17:16:17');
INSERT INTO `access_log` VALUES (27850, '65.53.15596397816657741', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:16:22', 10, 0, '', '2019-06-04 17:16:22');
INSERT INTO `access_log` VALUES (27851, '65.49.15596397889167793', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:16:29', 118, 0, '', '2019-06-04 17:16:29');
INSERT INTO `access_log` VALUES (27852, '65.45.15596398028527789', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:16:43', 13, 0, '', '2019-06-04 17:16:43');
INSERT INTO `access_log` VALUES (27853, '59.78.15596398788807691', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:17:59', 3, 0, '', '2019-06-04 17:17:59');
INSERT INTO `access_log` VALUES (27854, '59.71.15596398788807691', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:17:59', 12, 2001001000, '服务端发生异常', '2019-06-04 17:17:59');
INSERT INTO `access_log` VALUES (27855, '59.77.15596398811757679', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:18:01', 3, 0, '', '2019-06-04 17:18:01');
INSERT INTO `access_log` VALUES (27856, '59.79.15596398811787687', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:18:01', 13, 2001001000, '服务端发生异常', '2019-06-04 17:18:01');
INSERT INTO `access_log` VALUES (27857, '64.82.15596398837817403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:18:04', 3, 0, '', '2019-06-04 17:18:04');
INSERT INTO `access_log` VALUES (27858, '64.78.15596398839237399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:18:04', 2, 0, '', '2019-06-04 17:18:04');
INSERT INTO `access_log` VALUES (27859, '64.84.15596398853597399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:18:05', 2, 0, '', '2019-06-04 17:18:05');
INSERT INTO `access_log` VALUES (27860, '64.80.15596398857377389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:18:06', 1, 0, '', '2019-06-04 17:18:06');
INSERT INTO `access_log` VALUES (27861, '64.83.15596398862327387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.142.179', '2019-06-04 17:18:06', 2, 0, '', '2019-06-04 17:18:06');
INSERT INTO `access_log` VALUES (27862, '64.76.15596398893247383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:09', 2, 0, '', '2019-06-04 17:18:09');
INSERT INTO `access_log` VALUES (27863, '64.85.15596398894687411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:09', 2, 0, '', '2019-06-04 17:18:09');
INSERT INTO `access_log` VALUES (27864, '64.79.15596398909947391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:11', 2, 0, '', '2019-06-04 17:18:11');
INSERT INTO `access_log` VALUES (27865, '64.81.15596398919917391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:12', 2, 0, '', '2019-06-04 17:18:12');
INSERT INTO `access_log` VALUES (27866, '64.82.15596398931237405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:13', 2, 0, '', '2019-06-04 17:18:13');
INSERT INTO `access_log` VALUES (27867, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:13', 7, 0, '', '2019-06-04 17:18:13');
INSERT INTO `access_log` VALUES (27868, '64.78.15596398952917401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:18:15', 1, 0, '', '2019-06-04 17:18:15');
INSERT INTO `access_log` VALUES (27869, '64.84.15596398960177401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:18:16', 2, 0, '', '2019-06-04 17:18:16');
INSERT INTO `access_log` VALUES (27870, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:16', 7, 0, '', '2019-06-04 17:18:16');
INSERT INTO `access_log` VALUES (27871, '64.77.15596398964817401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:18:16', 2, 0, '', '2019-06-04 17:18:16');
INSERT INTO `access_log` VALUES (27872, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:17', 6, 0, '', '2019-06-04 17:18:17');
INSERT INTO `access_log` VALUES (27873, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:18:18', 7, 0, '', '2019-06-04 17:18:18');
INSERT INTO `access_log` VALUES (27874, '64.80.15596398978617391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:18', 1, 0, '', '2019-06-04 17:18:18');
INSERT INTO `access_log` VALUES (27875, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:18:18', 15, 0, '', '2019-06-04 17:18:18');
INSERT INTO `access_log` VALUES (27876, '64.83.15596398984637389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:18', 2, 0, '', '2019-06-04 17:18:18');
INSERT INTO `access_log` VALUES (27877, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:18:19', 5, 0, '', '2019-06-04 17:18:19');
INSERT INTO `access_log` VALUES (27878, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:18:19', 13, 0, '', '2019-06-04 17:18:19');
INSERT INTO `access_log` VALUES (27879, '64.85.15596399011637413', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:18:21', 7, 0, '', '2019-06-04 17:18:21');
INSERT INTO `access_log` VALUES (27880, '64.79.15596399052727393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:25', 2, 0, '', '2019-06-04 17:18:25');
INSERT INTO `access_log` VALUES (27881, '64.81.15596399054227393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:25', 2, 0, '', '2019-06-04 17:18:25');
INSERT INTO `access_log` VALUES (27882, '59.80.15596399202217679', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.44.165', '2019-06-04 17:18:40', 3, 0, '', '2019-06-04 17:18:40');
INSERT INTO `access_log` VALUES (27883, '59.75.15596399202207689', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.45.1', '2019-06-04 17:18:40', 13, 2001001000, '服务端发生异常', '2019-06-04 17:18:40');
INSERT INTO `access_log` VALUES (27884, '66.49.15596399329286317', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:18:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-06-04 17:18:53');
INSERT INTO `access_log` VALUES (27885, '66.53.15596399347446309', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.44.165', '2019-06-04 17:18:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-06-04 17:18:55');
INSERT INTO `access_log` VALUES (27886, '66.54.15596399353846313', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:18:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-06-04 17:18:55');
INSERT INTO `access_log` VALUES (27887, '59.71.15596399356057693', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:56', 3, 0, '', '2019-06-04 17:18:56');
INSERT INTO `access_log` VALUES (27888, '59.78.15596399356057693', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:56', 13, 2001001000, '服务端发生异常', '2019-06-04 17:18:56');
INSERT INTO `access_log` VALUES (27889, '64.84.15596399377897403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:58', 2, 0, '', '2019-06-04 17:18:58');
INSERT INTO `access_log` VALUES (27890, '64.77.15596399379847403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:58', 334, 0, '', '2019-06-04 17:18:58');
INSERT INTO `access_log` VALUES (27891, '64.80.15596399392547393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:18:59', 2, 0, '', '2019-06-04 17:18:59');
INSERT INTO `access_log` VALUES (27892, '64.83.15596399399427391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:19:00', 2, 0, '', '2019-06-04 17:19:00');
INSERT INTO `access_log` VALUES (27893, '66.55.15596399414446319', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.44.165', '2019-06-04 17:19:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-04 17:19:01');
INSERT INTO `access_log` VALUES (27894, '64.76.15596399428707387', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:19:03', 9, 0, '', '2019-06-04 17:19:03');
INSERT INTO `access_log` VALUES (27895, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:19:04', 7, 0, '', '2019-06-04 17:19:04');
INSERT INTO `access_log` VALUES (27896, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:19:04', 12, 0, '', '2019-06-04 17:19:04');
INSERT INTO `access_log` VALUES (27897, '64.85.15596399443947415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:19:04', 2, 0, '', '2019-06-04 17:19:04');
INSERT INTO `access_log` VALUES (27898, '64.79.15596399444757395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:19:04', 2, 0, '', '2019-06-04 17:19:04');
INSERT INTO `access_log` VALUES (27899, '59.79.15596399449597689', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:19:05', 3, 0, '', '2019-06-04 17:19:05');
INSERT INTO `access_log` VALUES (27900, '59.73.15596399449607693', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.101.142.179', '2019-06-04 17:19:05', 12, 2001001000, '服务端发生异常', '2019-06-04 17:19:05');
INSERT INTO `access_log` VALUES (27901, '66.50.15596399528596309', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.44.165', '2019-06-04 17:19:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空', '2019-06-04 17:19:13');
INSERT INTO `access_log` VALUES (27902, '64.82.15596399556117409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:19:16', 2, 0, '', '2019-06-04 17:19:16');
INSERT INTO `access_log` VALUES (27903, '64.78.15596399557107405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:19:16', 2, 0, '', '2019-06-04 17:19:16');
INSERT INTO `access_log` VALUES (27904, '59.74.15596399585087687', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.44.165', '2019-06-04 17:19:19', 3, 0, '', '2019-06-04 17:19:19');
INSERT INTO `access_log` VALUES (27905, '59.76.15596399585077683', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.45.1', '2019-06-04 17:19:19', 14, 2001001000, '服务端发生异常', '2019-06-04 17:19:19');
INSERT INTO `access_log` VALUES (27906, '64.77.15596399658887405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:19:26', 2, 0, '', '2019-06-04 17:19:26');
INSERT INTO `access_log` VALUES (27907, '64.80.15596399663027395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.149.210.161', '2019-06-04 17:19:26', 289, 0, '', '2019-06-04 17:19:27');
INSERT INTO `access_log` VALUES (27908, '65.51.15596399839907775', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.44.165', '2019-06-04 17:19:44', 1, 1002001015, '账号未登陆', '2019-06-04 17:19:44');
INSERT INTO `access_log` VALUES (27909, '65.46.15596399839907773', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.46.226', '2019-06-04 17:19:44', 1, 1002001015, '账号未登陆', '2019-06-04 17:19:44');
INSERT INTO `access_log` VALUES (27910, '65.45.15596399839957793', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.46.200', '2019-06-04 17:19:44', 0, 1002001015, '账号未登陆', '2019-06-04 17:19:44');
INSERT INTO `access_log` VALUES (27911, '65.50.15596399879367781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.46.226', '2019-06-04 17:19:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 17:19:48');
INSERT INTO `access_log` VALUES (27912, '65.52.15596399922067777', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.46.226', '2019-06-04 17:19:52', 64, 0, '', '2019-06-04 17:19:52');
INSERT INTO `access_log` VALUES (27913, '65.47.15596399924847779', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.44.165', '2019-06-04 17:19:52', 9, 0, '', '2019-06-04 17:19:52');
INSERT INTO `access_log` VALUES (27914, '65.49.15596399924897797', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.47.193', '2019-06-04 17:19:52', 9, 0, '', '2019-06-04 17:19:52');
INSERT INTO `access_log` VALUES (27915, '65.54.15596399924887747', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.46.226', '2019-06-04 17:19:52', 9, 0, '', '2019-06-04 17:19:52');
INSERT INTO `access_log` VALUES (27916, '64.85.15596399989727417', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.46.226', '2019-06-04 17:19:59', 10, 0, '', '2019-06-04 17:19:59');
INSERT INTO `access_log` VALUES (27917, '64.79.15596399989737397', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.44.165', '2019-06-04 17:19:59', 8, 0, '', '2019-06-04 17:19:59');
INSERT INTO `access_log` VALUES (27918, '65.53.15596400040577747', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.44.165', '2019-06-04 17:20:04', 3, 0, '', '2019-06-04 17:20:04');
INSERT INTO `access_log` VALUES (27919, '59.78.15596400134057695', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.44.165', '2019-06-04 17:20:13', 20, 2001001000, '服务端发生异常', '2019-06-04 17:20:13');
INSERT INTO `access_log` VALUES (27920, '59.77.15596400170257683', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.44.165', '2019-06-04 17:20:17', 10, 0, '', '2019-06-04 17:20:17');
INSERT INTO `access_log` VALUES (27921, '59.73.15596400227497695', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.44.165', '2019-06-04 17:20:23', 8, 1002002009, NULL, '2019-06-04 17:20:23');
INSERT INTO `access_log` VALUES (27922, '65.51.15596400264817777', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.46.226', '2019-06-04 17:20:26', 18, 0, '', '2019-06-04 17:20:27');
INSERT INTO `access_log` VALUES (27923, '65.50.15596400275297783', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '113.87.46.226', '2019-06-04 17:20:28', 10, 0, '', '2019-06-04 17:20:28');
INSERT INTO `access_log` VALUES (27924, '62.88.15596400366777549', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-04 17:20:37', 7, 1002001012, '访问令牌已过期', '2019-06-04 17:20:37');
INSERT INTO `access_log` VALUES (27925, '65.52.15596400383797779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.88.209.211', '2019-06-04 17:20:38', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 17:20:38');
INSERT INTO `access_log` VALUES (27926, '62.87.15596400410867537', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.149.210.161', '2019-06-04 17:20:41', 10, 0, '', '2019-06-04 17:20:41');
INSERT INTO `access_log` VALUES (27927, '59.72.15596402344817693', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '113.200.212.170', '2019-06-04 17:23:54', 3, 0, '', '2019-06-04 17:23:54');
INSERT INTO `access_log` VALUES (27928, '59.71.15596402344827699', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '113.200.212.170', '2019-06-04 17:23:54', 9, 2001001000, '服务端发生异常', '2019-06-04 17:23:54');
INSERT INTO `access_log` VALUES (27929, '64.83.15596402413457397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '113.200.212.170', '2019-06-04 17:24:01', 3, 0, '', '2019-06-04 17:24:01');
INSERT INTO `access_log` VALUES (27930, '64.76.15596402414747393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '113.200.212.170', '2019-06-04 17:24:01', 2, 0, '', '2019-06-04 17:24:01');
INSERT INTO `access_log` VALUES (27931, '59.78.15596402435677699', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '113.200.212.170', '2019-06-04 17:24:04', 3, 0, '', '2019-06-04 17:24:04');
INSERT INTO `access_log` VALUES (27932, '59.77.15596402435677687', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '113.200.212.170', '2019-06-04 17:24:04', 18, 2001001000, '服务端发生异常', '2019-06-04 17:24:04');
INSERT INTO `access_log` VALUES (27933, '64.85.15596402481707421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '113.200.212.170', '2019-06-04 17:24:08', 229, 0, '', '2019-06-04 17:24:08');
INSERT INTO `access_log` VALUES (27934, '64.81.15596402485277401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '113.200.212.170', '2019-06-04 17:24:09', 2, 0, '', '2019-06-04 17:24:09');
INSERT INTO `access_log` VALUES (27935, '65.53.15596403870567753', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '113.75.39.57', '2019-06-04 17:26:27', 11, 0, '', '2019-06-04 17:26:27');
INSERT INTO `access_log` VALUES (27936, '62.85.15596405139067549', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-04 17:28:34', 7, 1002001012, '访问令牌已过期', '2019-06-04 17:28:34');
INSERT INTO `access_log` VALUES (27937, '59.72.15596413798377709', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:00', 3, 0, '', '2019-06-04 17:43:00');
INSERT INTO `access_log` VALUES (27938, '59.71.15596413798387715', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:00', 14, 2001001000, '服务端发生异常', '2019-06-04 17:43:00');
INSERT INTO `access_log` VALUES (27939, '64.76.15596413886387409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:09', 2, 0, '', '2019-06-04 17:43:09');
INSERT INTO `access_log` VALUES (27940, '64.79.15596413887347417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:09', 2, 0, '', '2019-06-04 17:43:09');
INSERT INTO `access_log` VALUES (27941, '64.85.15596413898847437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:10', 2, 0, '', '2019-06-04 17:43:10');
INSERT INTO `access_log` VALUES (27942, '64.81.15596413904747417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:10', 2, 0, '', '2019-06-04 17:43:10');
INSERT INTO `access_log` VALUES (27943, '64.82.15596413909487431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:11', 2, 0, '', '2019-06-04 17:43:11');
INSERT INTO `access_log` VALUES (27944, '64.78.15596413914757427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:11', 1, 0, '', '2019-06-04 17:43:11');
INSERT INTO `access_log` VALUES (27945, '64.84.15596413917557427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:12', 2, 0, '', '2019-06-04 17:43:12');
INSERT INTO `access_log` VALUES (27946, '59.77.15596413926227703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:13', 3, 0, '', '2019-06-04 17:43:13');
INSERT INTO `access_log` VALUES (27947, '59.79.15596413926227711', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:13', 13, 2001001000, '服务端发生异常', '2019-06-04 17:43:13');
INSERT INTO `access_log` VALUES (27948, '64.77.15596413941207427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:14', 3, 0, '', '2019-06-04 17:43:14');
INSERT INTO `access_log` VALUES (27949, '64.80.15596413942197417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:14', 2, 0, '', '2019-06-04 17:43:14');
INSERT INTO `access_log` VALUES (27950, '64.83.15596413949797415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:15', 2, 0, '', '2019-06-04 17:43:15');
INSERT INTO `access_log` VALUES (27951, '64.76.15596413952027411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:15', 2, 0, '', '2019-06-04 17:43:15');
INSERT INTO `access_log` VALUES (27952, '59.73.15596413960347715', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:16', 2, 0, '', '2019-06-04 17:43:16');
INSERT INTO `access_log` VALUES (27953, '59.74.15596413960357709', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:16', 15, 2001001000, '服务端发生异常', '2019-06-04 17:43:16');
INSERT INTO `access_log` VALUES (27954, '59.80.15596414020837703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:22', 3, 0, '', '2019-06-04 17:43:22');
INSERT INTO `access_log` VALUES (27955, '59.75.15596414020837713', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:22', 13, 2001001000, '服务端发生异常', '2019-06-04 17:43:22');
INSERT INTO `access_log` VALUES (27956, '65.53.15596414282157767', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:48', 0, 1002001015, '账号未登陆', '2019-06-04 17:43:48');
INSERT INTO `access_log` VALUES (27957, '65.45.15596414282167815', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:48', 1, 1002001015, '账号未登陆', '2019-06-04 17:43:48');
INSERT INTO `access_log` VALUES (27958, '65.46.15596414282207795', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:48', 0, 1002001015, '账号未登陆', '2019-06-04 17:43:48');
INSERT INTO `access_log` VALUES (27959, '65.51.15596414305687797', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 17:43:51');
INSERT INTO `access_log` VALUES (27960, '65.52.15596414360427799', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:56', 103, 0, '', '2019-06-04 17:43:56');
INSERT INTO `access_log` VALUES (27961, '65.54.15596414363457769', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:56', 9, 0, '', '2019-06-04 17:43:56');
INSERT INTO `access_log` VALUES (27962, '65.49.15596414363477819', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:56', 9, 0, '', '2019-06-04 17:43:56');
INSERT INTO `access_log` VALUES (27963, '65.47.15596414363497801', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:43:56', 8, 0, '', '2019-06-04 17:43:56');
INSERT INTO `access_log` VALUES (27964, '62.89.15596414396307565', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:00', 163, 0, '', '2019-06-04 17:44:00');
INSERT INTO `access_log` VALUES (27965, '62.86.15596414443327553', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:04', 15, 0, '', '2019-06-04 17:44:04');
INSERT INTO `access_log` VALUES (27966, '64.84.15596414534257429', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:13', 8, 0, '', '2019-06-04 17:44:13');
INSERT INTO `access_log` VALUES (27967, '64.78.15596414534237429', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:13', 11, 0, '', '2019-06-04 17:44:13');
INSERT INTO `access_log` VALUES (27968, '64.80.15596414567207419', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:17', 9, 0, '', '2019-06-04 17:44:17');
INSERT INTO `access_log` VALUES (27969, '64.77.15596414567197429', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:17', 10, 0, '', '2019-06-04 17:44:17');
INSERT INTO `access_log` VALUES (27970, '64.79.15596414640977421', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:24', 11, 0, '', '2019-06-04 17:44:24');
INSERT INTO `access_log` VALUES (27971, '64.85.15596414641007441', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:24', 8, 0, '', '2019-06-04 17:44:24');
INSERT INTO `access_log` VALUES (27972, '64.76.15596414640967413', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:24', 14, 0, '', '2019-06-04 17:44:24');
INSERT INTO `access_log` VALUES (27973, '64.82.15596414666087435', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:27', 10, 0, '', '2019-06-04 17:44:27');
INSERT INTO `access_log` VALUES (27974, '64.81.15596414666087421', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:27', 10, 0, '', '2019-06-04 17:44:27');
INSERT INTO `access_log` VALUES (27975, '66.56.15596414708236327', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:31', 71, 0, '', '2019-06-04 17:44:31');
INSERT INTO `access_log` VALUES (27976, '59.74.15596414776727711', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:38', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-04 17:44:38');
INSERT INTO `access_log` VALUES (27977, '65.45.15596414793637817', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:39', 19, 0, '', '2019-06-04 17:44:39');
INSERT INTO `access_log` VALUES (27978, '65.51.15596414809407799', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:41', 10, 0, '', '2019-06-04 17:44:41');
INSERT INTO `access_log` VALUES (27979, '65.50.15596414817277805', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:42', 10, 0, '', '2019-06-04 17:44:42');
INSERT INTO `access_log` VALUES (27980, '65.52.15596414822227801', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:42', 50, 0, '', '2019-06-04 17:44:42');
INSERT INTO `access_log` VALUES (27981, '59.73.15596414833317717', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.18.22.100', '2019-06-04 17:44:43', 19, 2001001000, '服务端发生异常', '2019-06-04 17:44:43');
INSERT INTO `access_log` VALUES (27982, '65.54.15596416430337773', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:47:23', 1, 1002001015, '账号未登陆', '2019-06-04 17:47:23');
INSERT INTO `access_log` VALUES (27983, '65.49.15596416430367823', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:47:23', 0, 1002001015, '账号未登陆', '2019-06-04 17:47:23');
INSERT INTO `access_log` VALUES (27984, '65.47.15596416430607805', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:47:23', 0, 1002001015, '账号未登陆', '2019-06-04 17:47:23');
INSERT INTO `access_log` VALUES (27985, '65.53.15596416457187773', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:47:26', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 17:47:26');
INSERT INTO `access_log` VALUES (27986, '65.46.15596416507497801', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:47:31', 60, 0, '', '2019-06-04 17:47:31');
INSERT INTO `access_log` VALUES (27987, '65.45.15596416509867821', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:47:31', 9, 0, '', '2019-06-04 17:47:31');
INSERT INTO `access_log` VALUES (27988, '65.51.15596416509907803', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:47:31', 9, 0, '', '2019-06-04 17:47:31');
INSERT INTO `access_log` VALUES (27989, '65.50.15596416509927809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:47:31', 9, 0, '', '2019-06-04 17:47:31');
INSERT INTO `access_log` VALUES (27990, '62.83.15596416557057567', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:47:36', 11, 0, '', '2019-06-04 17:47:36');
INSERT INTO `access_log` VALUES (27991, '66.53.15596416598626333', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:47:40', 13, 0, '', '2019-06-04 17:47:40');
INSERT INTO `access_log` VALUES (27992, '59.80.15596416616227707', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:47:42', 11, 0, '', '2019-06-04 17:47:42');
INSERT INTO `access_log` VALUES (27993, '65.47.15596416807247807', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:48:01', 18, 0, '', '2019-06-04 17:48:01');
INSERT INTO `access_log` VALUES (27994, '65.54.15596416841627775', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:48:04', 18, 0, '', '2019-06-04 17:48:04');
INSERT INTO `access_log` VALUES (27995, '65.48.15596416862857807', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:48:06', 9, 0, '', '2019-06-04 17:48:06');
INSERT INTO `access_log` VALUES (27996, '65.53.15596416885927775', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:48:09', 12, 0, '', '2019-06-04 17:48:09');
INSERT INTO `access_log` VALUES (27997, '65.45.15596416905417823', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:48:11', 8, 0, '', '2019-06-04 17:48:11');
INSERT INTO `access_log` VALUES (27998, '65.51.15596416914967805', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.228.168.210', '2019-06-04 17:48:11', 14, 0, '', '2019-06-04 17:48:12');
INSERT INTO `access_log` VALUES (27999, '65.52.15596419799107811', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '211.103.142.26', '2019-06-04 17:53:00', 0, 1002001015, '账号未登陆', '2019-06-04 17:53:00');
INSERT INTO `access_log` VALUES (28000, '65.51.15596419798967809', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '211.103.142.26', '2019-06-04 17:53:00', 1, 1002001015, '账号未登陆', '2019-06-04 17:53:00');
INSERT INTO `access_log` VALUES (28001, '65.50.15596419798997815', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '211.103.142.26', '2019-06-04 17:53:00', 0, 1002001015, '账号未登陆', '2019-06-04 17:53:00');
INSERT INTO `access_log` VALUES (28002, '65.48.15596420291867813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '211.103.142.26', '2019-06-04 17:53:49', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 17:53:49');
INSERT INTO `access_log` VALUES (28003, '65.53.15596420323607781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '211.103.142.26', '2019-06-04 17:53:52', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 17:53:52');
INSERT INTO `access_log` VALUES (28004, '65.54.15596421296327783', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:55:30', 0, 1002001015, '账号未登陆', '2019-06-04 17:55:30');
INSERT INTO `access_log` VALUES (28005, '65.48.15596421296337815', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:55:30', 1, 1002001015, '账号未登陆', '2019-06-04 17:55:30');
INSERT INTO `access_log` VALUES (28006, '65.53.15596421296387783', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:55:30', 0, 1002001015, '账号未登陆', '2019-06-04 17:55:30');
INSERT INTO `access_log` VALUES (28007, '65.46.15596421315137811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:55:32', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 17:55:32');
INSERT INTO `access_log` VALUES (28008, '65.45.15596421363467831', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:55:36', 73, 0, '', '2019-06-04 17:55:36');
INSERT INTO `access_log` VALUES (28009, '65.50.15596421366937819', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:55:37', 199, 0, '', '2019-06-04 17:55:37');
INSERT INTO `access_log` VALUES (28010, '65.51.15596421366957813', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:55:37', 206, 0, '', '2019-06-04 17:55:37');
INSERT INTO `access_log` VALUES (28011, '65.52.15596421367057815', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:55:37', 199, 0, '', '2019-06-04 17:55:37');
INSERT INTO `access_log` VALUES (28012, '62.86.15596421423257563', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:55:42', 14, 0, '', '2019-06-04 17:55:42');
INSERT INTO `access_log` VALUES (28013, '64.79.15596421564077431', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:55:56', 10, 0, '', '2019-06-04 17:55:56');
INSERT INTO `access_log` VALUES (28014, '64.85.15596421564057451', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:55:56', 12, 0, '', '2019-06-04 17:55:56');
INSERT INTO `access_log` VALUES (28015, '64.81.15596421620637431', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:56:02', 9, 0, '', '2019-06-04 17:56:02');
INSERT INTO `access_log` VALUES (28016, '64.82.15596421620647445', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:56:02', 8, 0, '', '2019-06-04 17:56:02');
INSERT INTO `access_log` VALUES (28017, '64.84.15596421695507441', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:56:10', 9, 0, '', '2019-06-04 17:56:10');
INSERT INTO `access_log` VALUES (28018, '66.51.15596421747906341', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:56:15', 13, 0, '', '2019-06-04 17:56:15');
INSERT INTO `access_log` VALUES (28019, '59.74.15596421810037721', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:56:21', 20, 2001001000, '服务端发生异常', '2019-06-04 17:56:21');
INSERT INTO `access_log` VALUES (28020, '59.73.15596421852577727', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:56:25', 12, 0, '', '2019-06-04 17:56:25');
INSERT INTO `access_log` VALUES (28021, '64.80.15596421881597431', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:56:28', 9, 0, '', '2019-06-04 17:56:28');
INSERT INTO `access_log` VALUES (28022, '64.85.15596422261367453', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:57:06', 9, 0, '', '2019-06-04 17:57:06');
INSERT INTO `access_log` VALUES (28023, '59.72.15596422299537723', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.133.218', '2019-06-04 17:57:10', 12, 0, '', '2019-06-04 17:57:10');
INSERT INTO `access_log` VALUES (28024, '65.50.15596422570847821', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '211.103.142.26', '2019-06-04 17:57:37', 82, 0, '', '2019-06-04 17:57:37');
INSERT INTO `access_log` VALUES (28025, '65.52.15596422578467817', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '211.103.142.26', '2019-06-04 17:57:38', 9, 0, '', '2019-06-04 17:57:38');
INSERT INTO `access_log` VALUES (28026, '65.49.15596422578567837', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '211.103.142.26', '2019-06-04 17:57:38', 9, 0, '', '2019-06-04 17:57:38');
INSERT INTO `access_log` VALUES (28027, '65.47.15596422579167819', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '211.103.142.26', '2019-06-04 17:57:38', 9, 0, '', '2019-06-04 17:57:38');
INSERT INTO `access_log` VALUES (28028, '62.89.15596422666547579', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '211.103.142.26', '2019-06-04 17:57:47', 14, 0, '', '2019-06-04 17:57:47');
INSERT INTO `access_log` VALUES (28029, '62.83.15596422735737577', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '211.103.142.26', '2019-06-04 17:57:54', 15, 0, '', '2019-06-04 17:57:54');
INSERT INTO `access_log` VALUES (28030, '59.74.15596422930527723', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '211.103.142.26', '2019-06-04 17:58:13', 3, 0, '', '2019-06-04 17:58:13');
INSERT INTO `access_log` VALUES (28031, '59.73.15596422930537729', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '211.103.142.26', '2019-06-04 17:58:13', 10, 2001001000, '服务端发生异常', '2019-06-04 17:58:13');
INSERT INTO `access_log` VALUES (28032, '64.80.15596423111847433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '211.103.142.26', '2019-06-04 17:58:31', 3, 0, '', '2019-06-04 17:58:31');
INSERT INTO `access_log` VALUES (28033, '64.83.15596423113487431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '211.103.142.26', '2019-06-04 17:58:31', 2, 0, '', '2019-06-04 17:58:31');
INSERT INTO `access_log` VALUES (28034, '64.76.15596423130157427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '211.103.142.26', '2019-06-04 17:58:33', 2, 0, '', '2019-06-04 17:58:33');
INSERT INTO `access_log` VALUES (28035, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '211.103.142.26', '2019-06-04 17:58:33', 7, 0, '', '2019-06-04 17:58:33');
INSERT INTO `access_log` VALUES (28036, '64.79.15596423153547435', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '211.103.142.26', '2019-06-04 17:58:35', 8, 0, '', '2019-06-04 17:58:35');
INSERT INTO `access_log` VALUES (28037, '64.81.15596423272407435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '211.103.142.26', '2019-06-04 17:58:47', 2, 0, '', '2019-06-04 17:58:47');
INSERT INTO `access_log` VALUES (28038, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '211.103.142.26', '2019-06-04 17:58:47', 6, 0, '', '2019-06-04 17:58:47');
INSERT INTO `access_log` VALUES (28039, '64.82.15596423280967449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '211.103.142.26', '2019-06-04 17:58:48', 2, 0, '', '2019-06-04 17:58:48');
INSERT INTO `access_log` VALUES (28040, '64.78.15596423282227445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '211.103.142.26', '2019-06-04 17:58:48', 1, 0, '', '2019-06-04 17:58:48');
INSERT INTO `access_log` VALUES (28041, '64.77.15596423446617445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '211.103.142.26', '2019-06-04 17:59:05', 2, 0, '', '2019-06-04 17:59:05');
INSERT INTO `access_log` VALUES (28042, '64.80.15596423447807435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '211.103.142.26', '2019-06-04 17:59:05', 2, 0, '', '2019-06-04 17:59:05');
INSERT INTO `access_log` VALUES (28043, '59.71.15596423451627731', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '211.103.142.26', '2019-06-04 17:59:05', 3, 0, '', '2019-06-04 17:59:05');
INSERT INTO `access_log` VALUES (28044, '59.78.15596423451667731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '211.103.142.26', '2019-06-04 17:59:05', 19, 2001001000, '服务端发生异常', '2019-06-04 17:59:05');
INSERT INTO `access_log` VALUES (28045, '59.77.15596423503147719', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '203.86.67.202', '2019-06-04 17:59:10', 2, 0, '', '2019-06-04 17:59:10');
INSERT INTO `access_log` VALUES (28046, '59.79.15596423503147727', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '203.86.67.202', '2019-06-04 17:59:10', 15, 2001001000, '服务端发生异常', '2019-06-04 17:59:10');
INSERT INTO `access_log` VALUES (28047, '64.76.15596423564897429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '203.86.67.202', '2019-06-04 17:59:16', 2, 0, '', '2019-06-04 17:59:16');
INSERT INTO `access_log` VALUES (28048, '64.79.15596423566067437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '203.86.67.202', '2019-06-04 17:59:17', 2, 0, '', '2019-06-04 17:59:17');
INSERT INTO `access_log` VALUES (28049, '59.77.15596424914317721', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.204.33.9', '2019-06-04 18:01:31', 3, 0, '', '2019-06-04 18:01:31');
INSERT INTO `access_log` VALUES (28050, '59.74.15596424914347727', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.204.33.9', '2019-06-04 18:01:31', 14, 2001001000, '服务端发生异常', '2019-06-04 18:01:31');
INSERT INTO `access_log` VALUES (28051, '65.54.15596430288207797', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:10:29', 1, 1002001015, '账号未登陆', '2019-06-04 18:10:29');
INSERT INTO `access_log` VALUES (28052, '65.45.15596430288297845', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:10:29', 0, 1002001015, '账号未登陆', '2019-06-04 18:10:29');
INSERT INTO `access_log` VALUES (28053, '65.46.15596430288287825', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:10:29', 0, 1002001015, '账号未登陆', '2019-06-04 18:10:29');
INSERT INTO `access_log` VALUES (28054, '65.51.15596430354687827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:10:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 18:10:35');
INSERT INTO `access_log` VALUES (28055, '65.52.15596430483637829', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:10:48', 52, 0, '', '2019-06-04 18:10:48');
INSERT INTO `access_log` VALUES (28056, '65.49.15596430491917849', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:10:49', 10, 0, '', '2019-06-04 18:10:49');
INSERT INTO `access_log` VALUES (28057, '65.47.15596430492037831', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:10:49', 9, 0, '', '2019-06-04 18:10:49');
INSERT INTO `access_log` VALUES (28058, '65.48.15596430492037831', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:10:49', 10, 0, '', '2019-06-04 18:10:49');
INSERT INTO `access_log` VALUES (28059, '62.80.15596430560117591', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:10:56', 12, 0, '', '2019-06-04 18:10:56');
INSERT INTO `access_log` VALUES (28060, '62.85.15596430601017585', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:11:00', 17, 0, '', '2019-06-04 18:11:00');
INSERT INTO `access_log` VALUES (28061, '64.83.15596430640707443', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:11:04', 12, 0, '', '2019-06-04 18:11:04');
INSERT INTO `access_log` VALUES (28062, '64.76.15596430640787439', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:11:04', 10, 0, '', '2019-06-04 18:11:04');
INSERT INTO `access_log` VALUES (28063, '64.85.15596430702107467', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:11:10', 9, 0, '', '2019-06-04 18:11:10');
INSERT INTO `access_log` VALUES (28064, '64.81.15596430795407447', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:11:20', 9, 0, '', '2019-06-04 18:11:20');
INSERT INTO `access_log` VALUES (28065, '64.82.15596430795417461', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:11:20', 11, 0, '', '2019-06-04 18:11:20');
INSERT INTO `access_log` VALUES (28066, '64.84.15596430836537457', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:11:24', 8, 0, '', '2019-06-04 18:11:24');
INSERT INTO `access_log` VALUES (28067, '64.77.15596430836557457', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:11:24', 7, 0, '', '2019-06-04 18:11:24');
INSERT INTO `access_log` VALUES (28068, '62.86.15596430886527577', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:11:29', 12, 0, '', '2019-06-04 18:11:29');
INSERT INTO `access_log` VALUES (28069, '65.46.15596432213857829', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.43.206', '2019-06-04 18:13:41', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 18:13:41');
INSERT INTO `access_log` VALUES (28070, '59.78.15596443795367759', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.137.54.82', '2019-06-04 18:33:00', 23, 0, '', '2019-06-04 18:33:00');
INSERT INTO `access_log` VALUES (28071, '59.79.15596443795367755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.137.54.82', '2019-06-04 18:33:00', 26, 2001001000, '服务端发生异常', '2019-06-04 18:33:00');
INSERT INTO `access_log` VALUES (28072, '59.71.15596446148277763', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.29.4', '2019-06-04 18:36:55', 4, 0, '', '2019-06-04 18:36:55');
INSERT INTO `access_log` VALUES (28073, '59.72.15596446148217757', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.29.4', '2019-06-04 18:36:55', 14, 2001001000, '服务端发生异常', '2019-06-04 18:36:55');
INSERT INTO `access_log` VALUES (28074, '64.79.15596446275637469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '183.14.29.4', '2019-06-04 18:37:08', 3, 0, '', '2019-06-04 18:37:08');
INSERT INTO `access_log` VALUES (28075, '64.85.15596446276557489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '183.14.29.4', '2019-06-04 18:37:08', 2, 0, '', '2019-06-04 18:37:08');
INSERT INTO `access_log` VALUES (28076, '64.81.15596446296107469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '183.14.29.4', '2019-06-04 18:37:10', 26, 0, '', '2019-06-04 18:37:10');
INSERT INTO `access_log` VALUES (28077, '64.82.15596446300197483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '183.14.29.4', '2019-06-04 18:37:10', 2, 0, '', '2019-06-04 18:37:10');
INSERT INTO `access_log` VALUES (28078, '59.79.15596446314487759', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '183.14.29.4', '2019-06-04 18:37:11', 3, 0, '', '2019-06-04 18:37:11');
INSERT INTO `access_log` VALUES (28079, '59.77.15596446314487751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '183.14.29.4', '2019-06-04 18:37:11', 13, 2001001000, '服务端发生异常', '2019-06-04 18:37:11');
INSERT INTO `access_log` VALUES (28080, '64.78.15596446345317479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '183.14.29.4', '2019-06-04 18:37:15', 2, 0, '', '2019-06-04 18:37:15');
INSERT INTO `access_log` VALUES (28081, '64.84.15596446346647479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '183.14.29.4', '2019-06-04 18:37:15', 2, 0, '', '2019-06-04 18:37:15');
INSERT INTO `access_log` VALUES (28082, '64.77.15596446356587479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '183.14.29.4', '2019-06-04 18:37:16', 1, 0, '', '2019-06-04 18:37:16');
INSERT INTO `access_log` VALUES (28083, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '183.14.29.4', '2019-06-04 18:37:16', 7, 0, '', '2019-06-04 18:37:16');
INSERT INTO `access_log` VALUES (28084, '64.80.15596446368127469', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '183.14.29.4', '2019-06-04 18:37:17', 7, 0, '', '2019-06-04 18:37:17');
INSERT INTO `access_log` VALUES (28085, '65.47.15596455607427865', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 18:52:41', 4, 1002001012, '访问令牌已过期', '2019-06-04 18:52:41');
INSERT INTO `access_log` VALUES (28086, '65.53.15596455607427833', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 18:52:41', 4, 1002001012, '访问令牌已过期', '2019-06-04 18:52:41');
INSERT INTO `access_log` VALUES (28087, '65.45.15596455607437881', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-04 18:52:41', 5, 1002001012, '访问令牌已过期', '2019-06-04 18:52:41');
INSERT INTO `access_log` VALUES (28088, '59.75.15596460249627779', 0, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.235.181.247', '2019-06-04 19:00:25', 7, 1002001012, '访问令牌已过期', '2019-06-04 19:00:25');
INSERT INTO `access_log` VALUES (28089, '59.78.15596460659057783', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-04 19:01:06', 3, 0, '', '2019-06-04 19:01:06');
INSERT INTO `access_log` VALUES (28090, '59.79.15596460659387779', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-04 19:01:06', 13, 2001001000, '服务端发生异常', '2019-06-04 19:01:06');
INSERT INTO `access_log` VALUES (28091, '64.78.15596460698387499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-04 19:01:10', 3, 0, '', '2019-06-04 19:01:10');
INSERT INTO `access_log` VALUES (28092, '64.84.15596460700227499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-04 19:01:10', 2, 0, '', '2019-06-04 19:01:10');
INSERT INTO `access_log` VALUES (28093, '64.77.15596460719587499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-04 19:01:12', 2, 0, '', '2019-06-04 19:01:12');
INSERT INTO `access_log` VALUES (28094, '64.80.15596460724677489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-04 19:01:12', 2, 0, '', '2019-06-04 19:01:12');
INSERT INTO `access_log` VALUES (28095, '64.76.15596460794457483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-04 19:01:19', 1, 0, '', '2019-06-04 19:01:19');
INSERT INTO `access_log` VALUES (28096, '64.83.15596460796057487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-04 19:01:20', 1, 0, '', '2019-06-04 19:01:20');
INSERT INTO `access_log` VALUES (28097, '59.73.15596461047277783', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '182.105.109.173', '2019-06-04 19:01:45', 3, 0, '', '2019-06-04 19:01:45');
INSERT INTO `access_log` VALUES (28098, '59.76.15596461049937773', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '182.105.109.173', '2019-06-04 19:01:45', 13, 2001001000, '服务端发生异常', '2019-06-04 19:01:45');
INSERT INTO `access_log` VALUES (28099, '65.53.15596461177457841', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '182.105.109.173', '2019-06-04 19:01:58', 1, 1002001015, '账号未登陆', '2019-06-04 19:01:58');
INSERT INTO `access_log` VALUES (28100, '65.45.15596461177457889', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '182.105.109.173', '2019-06-04 19:01:58', 1, 1002001015, '账号未登陆', '2019-06-04 19:01:58');
INSERT INTO `access_log` VALUES (28101, '65.47.15596461177537873', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '182.105.109.173', '2019-06-04 19:01:58', 0, 1002001015, '账号未登陆', '2019-06-04 19:01:58');
INSERT INTO `access_log` VALUES (28102, '65.54.15596461289577841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '182.105.109.173', '2019-06-04 19:02:09', 106, 0, '', '2019-06-04 19:02:09');
INSERT INTO `access_log` VALUES (28103, '65.51.15596461294487871', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '182.105.109.173', '2019-06-04 19:02:09', 11, 0, '', '2019-06-04 19:02:09');
INSERT INTO `access_log` VALUES (28104, '65.50.15596461294487877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '182.105.109.173', '2019-06-04 19:02:09', 12, 0, '', '2019-06-04 19:02:09');
INSERT INTO `access_log` VALUES (28105, '65.52.15596461294487873', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '182.105.109.173', '2019-06-04 19:02:09', 12, 0, '', '2019-06-04 19:02:09');
INSERT INTO `access_log` VALUES (28106, '62.87.15596461365437621', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '182.105.109.173', '2019-06-04 19:02:17', 22, 0, '', '2019-06-04 19:02:17');
INSERT INTO `access_log` VALUES (28107, '64.84.15596461428077501', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '182.105.109.173', '2019-06-04 19:02:23', 12, 0, '', '2019-06-04 19:02:23');
INSERT INTO `access_log` VALUES (28108, '64.77.15596461428087501', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '182.105.109.173', '2019-06-04 19:02:23', 10, 0, '', '2019-06-04 19:02:23');
INSERT INTO `access_log` VALUES (28109, '66.54.15596461445576397', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '182.105.109.173', '2019-06-04 19:02:25', 22, 0, '', '2019-06-04 19:02:25');
INSERT INTO `access_log` VALUES (28110, '59.71.15596492957937827', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.215.37.47', '2019-06-04 19:54:56', 12, 0, '', '2019-06-04 19:54:56');
INSERT INTO `access_log` VALUES (28111, '59.78.15596492957937827', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.215.37.42', '2019-06-04 19:54:56', 23, 2001001000, '服务端发生异常', '2019-06-04 19:54:56');
INSERT INTO `access_log` VALUES (28112, '65.54.15596493024987885', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.215.37.55', '2019-06-04 19:55:02', 0, 1002001015, '账号未登陆', '2019-06-04 19:55:02');
INSERT INTO `access_log` VALUES (28113, '65.48.15596493024987917', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.215.37.47', '2019-06-04 19:55:02', 0, 1002001015, '账号未登陆', '2019-06-04 19:55:02');
INSERT INTO `access_log` VALUES (28114, '65.52.15596493025117923', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.215.37.47', '2019-06-04 19:55:03', 1, 1002001015, '账号未登陆', '2019-06-04 19:55:03');
INSERT INTO `access_log` VALUES (28115, '65.45.15596493086197935', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.215.37.47', '2019-06-04 19:55:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 19:55:09');
INSERT INTO `access_log` VALUES (28116, '65.47.15596493314217917', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.215.37.47', '2019-06-04 19:55:31', 69, 0, '', '2019-06-04 19:55:31');
INSERT INTO `access_log` VALUES (28117, '65.50.15596493325347921', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.215.37.55', '2019-06-04 19:55:33', 164, 0, '', '2019-06-04 19:55:33');
INSERT INTO `access_log` VALUES (28118, '65.51.15596493325387917', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.215.37.47', '2019-06-04 19:55:33', 162, 0, '', '2019-06-04 19:55:33');
INSERT INTO `access_log` VALUES (28119, '65.49.15596493325467939', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.215.37.55', '2019-06-04 19:55:33', 155, 0, '', '2019-06-04 19:55:33');
INSERT INTO `access_log` VALUES (28120, '62.88.15596493438917679', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.215.37.47', '2019-06-04 19:55:44', 21, 0, '', '2019-06-04 19:55:44');
INSERT INTO `access_log` VALUES (28121, '59.74.15596505058037837', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.41.252.225', '2019-06-04 20:15:06', 4, 0, '', '2019-06-04 20:15:06');
INSERT INTO `access_log` VALUES (28122, '59.77.15596505058037831', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.41.252.225', '2019-06-04 20:15:06', 13, 2001001000, '服务端发生异常', '2019-06-04 20:15:06');
INSERT INTO `access_log` VALUES (28123, '64.76.15596505201617543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.41.252.225', '2019-06-04 20:15:20', 11, 0, '', '2019-06-04 20:15:20');
INSERT INTO `access_log` VALUES (28124, '64.83.15596505203287547', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.41.252.225', '2019-06-04 20:15:20', 2, 0, '', '2019-06-04 20:15:20');
INSERT INTO `access_log` VALUES (28125, '64.85.15596505217217571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.41.252.225', '2019-06-04 20:15:22', 2, 0, '', '2019-06-04 20:15:22');
INSERT INTO `access_log` VALUES (28126, '64.81.15596505221307551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.41.252.225', '2019-06-04 20:15:22', 2, 0, '', '2019-06-04 20:15:22');
INSERT INTO `access_log` VALUES (28127, '59.78.15596510460767851', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.100.180', '2019-06-04 20:24:06', 4, 0, '', '2019-06-04 20:24:06');
INSERT INTO `access_log` VALUES (28128, '59.79.15596510460807847', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.100.180', '2019-06-04 20:24:06', 13, 2001001000, '服务端发生异常', '2019-06-04 20:24:06');
INSERT INTO `access_log` VALUES (28129, '64.76.15596510528477551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:24:13', 3, 0, '', '2019-06-04 20:24:13');
INSERT INTO `access_log` VALUES (28130, '64.83.15596510529797555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:24:13', 2, 0, '', '2019-06-04 20:24:13');
INSERT INTO `access_log` VALUES (28131, '64.79.15596510558667559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:24:16', 2, 0, '', '2019-06-04 20:24:16');
INSERT INTO `access_log` VALUES (28132, '64.85.15596510559657579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:24:16', 1, 0, '', '2019-06-04 20:24:16');
INSERT INTO `access_log` VALUES (28133, '59.74.15596510603737845', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:24:20', 2, 0, '', '2019-06-04 20:24:20');
INSERT INTO `access_log` VALUES (28134, '59.73.15596510603737851', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:24:20', 13, 2001001000, '服务端发生异常', '2019-06-04 20:24:20');
INSERT INTO `access_log` VALUES (28135, '64.82.15596510670567573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:24:27', 2, 0, '', '2019-06-04 20:24:27');
INSERT INTO `access_log` VALUES (28136, '64.78.15596510671517569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:24:27', 1, 0, '', '2019-06-04 20:24:27');
INSERT INTO `access_log` VALUES (28137, '64.84.15596510682387569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:24:28', 2, 0, '', '2019-06-04 20:24:28');
INSERT INTO `access_log` VALUES (28138, '64.77.15596510690267569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:24:29', 1, 0, '', '2019-06-04 20:24:29');
INSERT INTO `access_log` VALUES (28139, '64.80.15596510698017559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:24:30', 2, 0, '', '2019-06-04 20:24:30');
INSERT INTO `access_log` VALUES (28140, '59.76.15596510709417841', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:24:31', 3, 0, '', '2019-06-04 20:24:31');
INSERT INTO `access_log` VALUES (28141, '59.75.15596510709427849', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:24:31', 13, 2001001000, '服务端发生异常', '2019-06-04 20:24:31');
INSERT INTO `access_log` VALUES (28142, '64.79.15596511035157561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:25:04', 2, 0, '', '2019-06-04 20:25:04');
INSERT INTO `access_log` VALUES (28143, '64.85.15596511036237581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:25:04', 1, 0, '', '2019-06-04 20:25:04');
INSERT INTO `access_log` VALUES (28144, '59.79.15596511045287849', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:25:05', 3, 0, '', '2019-06-04 20:25:05');
INSERT INTO `access_log` VALUES (28145, '59.78.15596511045287853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:25:05', 14, 2001001000, '服务端发生异常', '2019-06-04 20:25:05');
INSERT INTO `access_log` VALUES (28146, '64.82.15596511077617575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:25:08', 534, 0, '', '2019-06-04 20:25:08');
INSERT INTO `access_log` VALUES (28147, '59.77.15596511086617841', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:25:09', 36, 0, '', '2019-06-04 20:25:09');
INSERT INTO `access_log` VALUES (28148, '64.78.15596511086107571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:25:09', 88, 0, '', '2019-06-04 20:25:09');
INSERT INTO `access_log` VALUES (28149, '59.73.15596511087227853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.100.180', '2019-06-04 20:25:09', 13, 2001001000, '服务端发生异常', '2019-06-04 20:25:09');
INSERT INTO `access_log` VALUES (28150, '59.75.15596511276647851', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.89.86.211', '2019-06-04 20:25:28', 2, 0, '', '2019-06-04 20:25:28');
INSERT INTO `access_log` VALUES (28151, '59.76.15596511276667843', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.89.86.211', '2019-06-04 20:25:28', 12, 2001001000, '服务端发生异常', '2019-06-04 20:25:28');
INSERT INTO `access_log` VALUES (28152, '64.80.15596511385787561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Mobile Safari/537.36', '124.89.86.211', '2019-06-04 20:25:39', 2, 0, '', '2019-06-04 20:25:39');
INSERT INTO `access_log` VALUES (28153, '64.76.15596511386997555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Mobile Safari/537.36', '124.89.86.211', '2019-06-04 20:25:39', 2, 0, '', '2019-06-04 20:25:39');
INSERT INTO `access_log` VALUES (28154, '64.83.15596511400747559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Mobile Safari/537.36', '124.89.86.211', '2019-06-04 20:25:40', 4, 0, '', '2019-06-04 20:25:40');
INSERT INTO `access_log` VALUES (28155, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Mobile Safari/537.36', '124.89.86.211', '2019-06-04 20:25:40', 17, 0, '', '2019-06-04 20:25:40');
INSERT INTO `access_log` VALUES (28156, '64.79.15596511417137563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Mobile Safari/537.36', '124.89.86.211', '2019-06-04 20:25:42', 2, 0, '', '2019-06-04 20:25:42');
INSERT INTO `access_log` VALUES (28157, '64.85.15596511418377583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Mobile Safari/537.36', '124.89.86.211', '2019-06-04 20:25:42', 2, 0, '', '2019-06-04 20:25:42');
INSERT INTO `access_log` VALUES (28158, '59.72.15596511445697849', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Mobile Safari/537.36', '124.89.86.211', '2019-06-04 20:25:45', 3, 0, '', '2019-06-04 20:25:45');
INSERT INTO `access_log` VALUES (28159, '59.71.15596511445837855', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Mobile Safari/537.36', '124.89.86.211', '2019-06-04 20:25:45', 13, 2001001000, '服务端发生异常', '2019-06-04 20:25:45');
INSERT INTO `access_log` VALUES (28160, '66.57.15596511622976467', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=111111111111&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Mobile Safari/537.36', '124.89.86.211', '2019-06-04 20:26:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-06-04 20:26:02');
INSERT INTO `access_log` VALUES (28161, '66.53.15596511786916461', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13223454312', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Mobile Safari/537.36', '124.89.86.211', '2019-06-04 20:26:19', 59, 0, '', '2019-06-04 20:26:19');
INSERT INTO `access_log` VALUES (28162, '66.55.15596511827906473', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13223454312&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Mobile Safari/537.36', '124.89.86.211', '2019-06-04 20:26:23', 170, 0, '', '2019-06-04 20:26:23');
INSERT INTO `access_log` VALUES (28163, '66.52.15596511844426471', 106, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Mobile Safari/537.36', '124.89.86.211', '2019-06-04 20:26:24', 7, 0, '', '2019-06-04 20:26:24');
INSERT INTO `access_log` VALUES (28164, '66.56.15596511944596459', 106, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Mobile Safari/537.36', '124.89.86.211', '2019-06-04 20:26:34', 6, 0, '', '2019-06-04 20:26:34');
INSERT INTO `access_log` VALUES (28165, '66.57.15596511972136469', 106, 1, 'user-application', '/user-api/users/user/update_nickname', '', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Mobile Safari/537.36', '124.89.86.211', '2019-06-04 20:26:37', 7, 2001001001, '参数缺失:Required String parameter \'nickname\' is not present', '2019-06-04 20:26:37');
INSERT INTO `access_log` VALUES (28166, '65.51.15596512353587943', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.89.86.211', '2019-06-04 20:27:15', 0, 1002001015, '账号未登陆', '2019-06-04 20:27:15');
INSERT INTO `access_log` VALUES (28167, '65.50.15596512353597947', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.89.86.211', '2019-06-04 20:27:15', 1, 1002001015, '账号未登陆', '2019-06-04 20:27:15');
INSERT INTO `access_log` VALUES (28168, '65.49.15596512353607965', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.89.86.211', '2019-06-04 20:27:15', 0, 1002001015, '账号未登陆', '2019-06-04 20:27:15');
INSERT INTO `access_log` VALUES (28169, '65.54.15596512386387913', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.89.86.211', '2019-06-04 20:27:19', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 20:27:19');
INSERT INTO `access_log` VALUES (28170, '65.52.15596512450367951', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.89.86.211', '2019-06-04 20:27:25', 84, 0, '', '2019-06-04 20:27:25');
INSERT INTO `access_log` VALUES (28171, '65.45.15596512455187963', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.89.86.211', '2019-06-04 20:27:26', 674, 0, '', '2019-06-04 20:27:26');
INSERT INTO `access_log` VALUES (28172, '65.53.15596512455437917', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.89.86.211', '2019-06-04 20:27:26', 653, 0, '', '2019-06-04 20:27:26');
INSERT INTO `access_log` VALUES (28173, '65.46.15596512455227941', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.89.86.211', '2019-06-04 20:27:26', 674, 0, '', '2019-06-04 20:27:26');
INSERT INTO `access_log` VALUES (28174, '62.86.15596512520917687', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.89.86.211', '2019-06-04 20:27:32', 27, 0, '', '2019-06-04 20:27:32');
INSERT INTO `access_log` VALUES (28175, '64.81.15596512709817565', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.89.86.211', '2019-06-04 20:27:51', 111, 0, '', '2019-06-04 20:27:51');
INSERT INTO `access_log` VALUES (28176, '64.85.15596512709697585', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.89.86.211', '2019-06-04 20:27:51', 125, 0, '', '2019-06-04 20:27:51');
INSERT INTO `access_log` VALUES (28177, '65.50.15596513028977949', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '124.89.86.211', '2019-06-04 20:28:23', 19, 0, '', '2019-06-04 20:28:23');
INSERT INTO `access_log` VALUES (28178, '59.73.15596519352317865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '101.86.63.56', '2019-06-04 20:38:55', 4, 0, '', '2019-06-04 20:38:55');
INSERT INTO `access_log` VALUES (28179, '59.74.15596519352347859', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '101.86.63.56', '2019-06-04 20:38:55', 13, 2001001000, '服务端发生异常', '2019-06-04 20:38:55');
INSERT INTO `access_log` VALUES (28180, '64.80.15596519420427573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '101.86.63.56', '2019-06-04 20:39:02', 6, 0, '', '2019-06-04 20:39:02');
INSERT INTO `access_log` VALUES (28181, '64.76.15596519421297567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '101.86.63.56', '2019-06-04 20:39:02', 3, 0, '', '2019-06-04 20:39:02');
INSERT INTO `access_log` VALUES (28182, '64.83.15596519436757571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '101.86.63.56', '2019-06-04 20:39:04', 2, 0, '', '2019-06-04 20:39:04');
INSERT INTO `access_log` VALUES (28183, '64.79.15596519440837575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '101.86.63.56', '2019-06-04 20:39:04', 2, 0, '', '2019-06-04 20:39:04');
INSERT INTO `access_log` VALUES (28184, '65.52.15596531142207977', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:58:34', 0, 1002001015, '账号未登陆', '2019-06-04 20:58:34');
INSERT INTO `access_log` VALUES (28185, '65.48.15596531142207971', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:58:34', 1, 1002001015, '账号未登陆', '2019-06-04 20:58:34');
INSERT INTO `access_log` VALUES (28186, '65.45.15596531142417989', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:58:34', 0, 1002001015, '账号未登陆', '2019-06-04 20:58:34');
INSERT INTO `access_log` VALUES (28187, '65.46.15596531250377967', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:58:45', 165, 0, '', '2019-06-04 20:58:45');
INSERT INTO `access_log` VALUES (28188, '65.47.15596531254627971', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:58:45', 17, 0, '', '2019-06-04 20:58:45');
INSERT INTO `access_log` VALUES (28189, '65.49.15596531254647993', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:58:45', 16, 0, '', '2019-06-04 20:58:45');
INSERT INTO `access_log` VALUES (28190, '65.51.15596531254687971', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:58:45', 17, 0, '', '2019-06-04 20:58:45');
INSERT INTO `access_log` VALUES (28191, '65.54.15596531376277941', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:58:58', 20, 0, '', '2019-06-04 20:58:58');
INSERT INTO `access_log` VALUES (28192, '65.45.15596531385067991', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:58:59', 10, 0, '', '2019-06-04 20:58:59');
INSERT INTO `access_log` VALUES (28193, '65.52.15596531392927979', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:58:59', 18, 0, '', '2019-06-04 20:58:59');
INSERT INTO `access_log` VALUES (28194, '65.48.15596531408057973', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:59:01', 14, 0, '', '2019-06-04 20:59:01');
INSERT INTO `access_log` VALUES (28195, '62.89.15596531467277727', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:59:07', 22, 0, '', '2019-06-04 20:59:07');
INSERT INTO `access_log` VALUES (28196, '62.86.15596531486007713', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:59:09', 28, 0, '', '2019-06-04 20:59:09');
INSERT INTO `access_log` VALUES (28197, '62.83.15596531537607725', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:59:14', 12, 0, '', '2019-06-04 20:59:14');
INSERT INTO `access_log` VALUES (28198, '62.88.15596531556527731', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 20:59:16', 17, 0, '', '2019-06-04 20:59:16');
INSERT INTO `access_log` VALUES (28199, '62.80.15596533194147729', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.160.17.218', '2019-06-04 21:01:59', 18, 0, '', '2019-06-04 21:01:59');
INSERT INTO `access_log` VALUES (28200, '59.77.15596539922507881', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-04 21:13:12', 12, 0, '', '2019-06-04 21:13:12');
INSERT INTO `access_log` VALUES (28201, '59.74.15596539922507887', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.17.218', '2019-06-04 21:13:12', 16, 2001001000, '服务端发生异常', '2019-06-04 21:13:12');
INSERT INTO `access_log` VALUES (28202, '64.83.15596540144557599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:13:34', 10, 0, '', '2019-06-04 21:13:34');
INSERT INTO `access_log` VALUES (28203, '64.79.15596540146107603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:13:35', 2, 0, '', '2019-06-04 21:13:35');
INSERT INTO `access_log` VALUES (28204, '59.76.15596540156147883', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:13:36', 4, 0, '', '2019-06-04 21:13:36');
INSERT INTO `access_log` VALUES (28205, '59.80.15596540156157881', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:13:36', 14, 2001001000, '服务端发生异常', '2019-06-04 21:13:36');
INSERT INTO `access_log` VALUES (28206, '64.85.15596540287897623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:13:49', 2, 0, '', '2019-06-04 21:13:49');
INSERT INTO `access_log` VALUES (28207, '64.82.15596540288767617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:13:49', 2, 0, '', '2019-06-04 21:13:49');
INSERT INTO `access_log` VALUES (28208, '64.84.15596540326987613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:13:53', 2, 0, '', '2019-06-04 21:13:53');
INSERT INTO `access_log` VALUES (28209, '64.77.15596540337107613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:13:54', 2, 0, '', '2019-06-04 21:13:54');
INSERT INTO `access_log` VALUES (28210, '66.57.15596540397636507', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15757179782', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:00', 61, 0, '', '2019-06-04 21:14:00');
INSERT INTO `access_log` VALUES (28211, '66.53.15596540530656501', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15757179782&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:13', 268, 0, '', '2019-06-04 21:14:13');
INSERT INTO `access_log` VALUES (28212, '64.83.15596540591007601', 107, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:19', 4, 0, '', '2019-06-04 21:14:19');
INSERT INTO `access_log` VALUES (28213, '64.81.15596540592387605', 107, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:19', 170, 0, '', '2019-06-04 21:14:19');
INSERT INTO `access_log` VALUES (28214, '66.55.15596540604036513', 107, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:20', 93, 0, '', '2019-06-04 21:14:20');
INSERT INTO `access_log` VALUES (28215, '66.52.15596540631946511', 107, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:23', 6, 0, '', '2019-06-04 21:14:23');
INSERT INTO `access_log` VALUES (28216, '66.56.15596540648196499', 107, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:25', 6, 0, '', '2019-06-04 21:14:25');
INSERT INTO `access_log` VALUES (28217, '66.51.15596540666556503', 107, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:27', 5, 0, '', '2019-06-04 21:14:27');
INSERT INTO `access_log` VALUES (28218, '66.48.15596540730856513', 107, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:33', 7, 0, '', '2019-06-04 21:14:33');
INSERT INTO `access_log` VALUES (28219, '59.74.15596540745257889', 107, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:35', 10, 0, '', '2019-06-04 21:14:35');
INSERT INTO `access_log` VALUES (28220, '59.75.15596540755907893', 107, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:36', 6, 0, '', '2019-06-04 21:14:36');
INSERT INTO `access_log` VALUES (28221, '59.76.15596540760417885', 107, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:36', 6, 0, '', '2019-06-04 21:14:36');
INSERT INTO `access_log` VALUES (28222, '66.49.15596540801616513', 107, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:40', 6, 0, '', '2019-06-04 21:14:40');
INSERT INTO `access_log` VALUES (28223, '66.53.15596540842976503', 107, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:44', 6, 0, '', '2019-06-04 21:14:44');
INSERT INTO `access_log` VALUES (28224, '66.55.15596540861756515', 107, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:46', 6, 0, '', '2019-06-04 21:14:46');
INSERT INTO `access_log` VALUES (28225, '66.50.15596540893806503', 107, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:49', 229, 0, '', '2019-06-04 21:14:50');
INSERT INTO `access_log` VALUES (28226, '66.52.15596540898626513', 107, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:50', 6, 0, '', '2019-06-04 21:14:50');
INSERT INTO `access_log` VALUES (28227, '59.78.15596540910317897', 107, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:51', 6, 0, '', '2019-06-04 21:14:51');
INSERT INTO `access_log` VALUES (28228, '59.77.15596540910417885', 107, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:51', 23, 2001001000, '服务端发生异常', '2019-06-04 21:14:51');
INSERT INTO `access_log` VALUES (28229, '64.84.15596540932467615', 107, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:53', 5, 0, '', '2019-06-04 21:14:53');
INSERT INTO `access_log` VALUES (28230, '64.77.15596540933547615', 107, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:53', 5, 0, '', '2019-06-04 21:14:53');
INSERT INTO `access_log` VALUES (28231, '64.76.15596540972437599', 107, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:57', 6, 0, '', '2019-06-04 21:14:57');
INSERT INTO `access_log` VALUES (28232, '64.79.15596540979787607', 107, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:58', 5, 0, '', '2019-06-04 21:14:58');
INSERT INTO `access_log` VALUES (28233, '64.81.15596540987907607', 107, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:59', 4, 0, '', '2019-06-04 21:14:59');
INSERT INTO `access_log` VALUES (28234, 'N/A', 107, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:14:59', 11, 0, '', '2019-06-04 21:14:59');
INSERT INTO `access_log` VALUES (28235, '64.85.15596540998427627', 107, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:15:00', 5, 0, '', '2019-06-04 21:15:00');
INSERT INTO `access_log` VALUES (28236, '64.85.15596540998427627', 107, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:15:00', 5, 0, '', '2019-06-04 21:15:01');
INSERT INTO `access_log` VALUES (28237, '59.74.15596541014727891', 107, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:15:01', 328, 0, '', '2019-06-04 21:15:02');
INSERT INTO `access_log` VALUES (28238, '64.82.15596541012127621', 107, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:15:01', 588, 0, '', '2019-06-04 21:15:02');
INSERT INTO `access_log` VALUES (28239, '59.73.15596541014827897', 107, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:15:01', 331, 2001001000, '服务端发生异常', '2019-06-04 21:15:02');
INSERT INTO `access_log` VALUES (28240, '64.78.15596541038977617', 107, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:15:04', 5, 0, '', '2019-06-04 21:15:04');
INSERT INTO `access_log` VALUES (28241, '64.84.15596541040357617', 107, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:15:04', 4, 0, '', '2019-06-04 21:15:04');
INSERT INTO `access_log` VALUES (28242, '64.77.15596541046917617', 107, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:15:05', 5, 0, '', '2019-06-04 21:15:05');
INSERT INTO `access_log` VALUES (28243, '64.80.15596541051987607', 107, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:15:05', 28, 0, '', '2019-06-04 21:15:05');
INSERT INTO `access_log` VALUES (28244, '59.80.15596541064407885', 107, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:15:06', 5, 0, '', '2019-06-04 21:15:06');
INSERT INTO `access_log` VALUES (28245, '59.76.15596541064407887', 107, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.160.17.218', '2019-06-04 21:15:06', 15, 2001001000, '服务端发生异常', '2019-06-04 21:15:06');
INSERT INTO `access_log` VALUES (28246, '65.45.15596547486948013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:25:49', 0, 1002001015, '账号未登陆', '2019-06-04 21:25:49');
INSERT INTO `access_log` VALUES (28247, '65.48.15596547486967995', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:25:49', 1, 1002001015, '账号未登陆', '2019-06-04 21:25:49');
INSERT INTO `access_log` VALUES (28248, '65.52.15596547486968001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:25:49', 1, 1002001015, '账号未登陆', '2019-06-04 21:25:49');
INSERT INTO `access_log` VALUES (28249, '65.53.15596547512047967', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:25:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 21:25:51');
INSERT INTO `access_log` VALUES (28250, '65.47.15596547578957995', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:25:58', 86, 0, '', '2019-06-04 21:25:58');
INSERT INTO `access_log` VALUES (28251, '65.49.15596547583398017', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:25:58', 10, 0, '', '2019-06-04 21:25:58');
INSERT INTO `access_log` VALUES (28252, '65.51.15596547583537995', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:25:58', 9, 0, '', '2019-06-04 21:25:58');
INSERT INTO `access_log` VALUES (28253, '65.50.15596547583547999', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:25:58', 9, 0, '', '2019-06-04 21:25:58');
INSERT INTO `access_log` VALUES (28254, '65.54.15596547671207965', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:26:07', 254, 0, '', '2019-06-04 21:26:07');
INSERT INTO `access_log` VALUES (28255, '65.48.15596547684757997', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:26:08', 10, 0, '', '2019-06-04 21:26:08');
INSERT INTO `access_log` VALUES (28256, '65.45.15596547696058015', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:26:10', 9, 0, '', '2019-06-04 21:26:10');
INSERT INTO `access_log` VALUES (28257, '65.53.15596547706127969', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:26:11', 14, 0, '', '2019-06-04 21:26:11');
INSERT INTO `access_log` VALUES (28258, '65.46.15596547753767993', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:26:15', 10, 0, '', '2019-06-04 21:26:15');
INSERT INTO `access_log` VALUES (28259, '65.47.15596547762777997', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:26:16', 10, 0, '', '2019-06-04 21:26:16');
INSERT INTO `access_log` VALUES (28260, '65.49.15596547770158019', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:26:17', 9, 0, '', '2019-06-04 21:26:17');
INSERT INTO `access_log` VALUES (28261, '59.76.15596548473897897', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '59.63.204.74', '2019-06-04 21:27:27', 13, 0, '', '2019-06-04 21:27:27');
INSERT INTO `access_log` VALUES (28262, '59.72.15596551394737907', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:19', 3, 0, '', '2019-06-04 21:32:19');
INSERT INTO `access_log` VALUES (28263, '59.71.15596551394877913', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:19', 12, 2001001000, '服务端发生异常', '2019-06-04 21:32:20');
INSERT INTO `access_log` VALUES (28264, '64.80.15596551453907621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:25', 3, 0, '', '2019-06-04 21:32:25');
INSERT INTO `access_log` VALUES (28265, '64.83.15596551455077619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:26', 2, 0, '', '2019-06-04 21:32:26');
INSERT INTO `access_log` VALUES (28266, '64.79.15596551469277623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:27', 2, 0, '', '2019-06-04 21:32:27');
INSERT INTO `access_log` VALUES (28267, '64.81.15596551477337623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:28', 2, 0, '', '2019-06-04 21:32:28');
INSERT INTO `access_log` VALUES (28268, '59.77.15596551499327901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:30', 2, 0, '', '2019-06-04 21:32:30');
INSERT INTO `access_log` VALUES (28269, '59.79.15596551499287909', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:30', 19, 2001001000, '服务端发生异常', '2019-06-04 21:32:30');
INSERT INTO `access_log` VALUES (28270, '65.53.15596551635837975', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:44', 0, 1002001015, '账号未登陆', '2019-06-04 21:32:44');
INSERT INTO `access_log` VALUES (28271, '65.46.15596551635957999', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:44', 1, 1002001015, '账号未登陆', '2019-06-04 21:32:44');
INSERT INTO `access_log` VALUES (28272, '65.47.15596551636098003', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:44', 1, 1002001015, '账号未登陆', '2019-06-04 21:32:44');
INSERT INTO `access_log` VALUES (28273, '65.49.15596551677998025', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 21:32:48');
INSERT INTO `access_log` VALUES (28274, '65.51.15596551763788003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:56', 64, 0, '', '2019-06-04 21:32:56');
INSERT INTO `access_log` VALUES (28275, '65.54.15596551766967973', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:57', 10, 0, '', '2019-06-04 21:32:57');
INSERT INTO `access_log` VALUES (28276, '65.48.15596551767248005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:57', 9, 0, '', '2019-06-04 21:32:57');
INSERT INTO `access_log` VALUES (28277, '65.52.15596551767278011', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:32:57', 9, 0, '', '2019-06-04 21:32:57');
INSERT INTO `access_log` VALUES (28278, '62.81.15596551936897745', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:33:14', 19, 0, '', '2019-06-04 21:33:14');
INSERT INTO `access_log` VALUES (28279, '65.47.15596552076378005', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.88.140.24', '2019-06-04 21:33:28', 17, 0, '', '2019-06-04 21:33:28');
INSERT INTO `access_log` VALUES (28280, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.7.9', '59.63.204.205', '2019-06-04 21:37:42', 16, 0, '', '2019-06-04 21:37:43');
INSERT INTO `access_log` VALUES (28281, '65.46.15596582373698041', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.197.34.152', '2019-06-04 22:23:57', 1, 1002001015, '账号未登陆', '2019-06-04 22:23:57');
INSERT INTO `access_log` VALUES (28282, '65.49.15596582373788067', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.197.34.152', '2019-06-04 22:23:57', 1, 1002001015, '账号未登陆', '2019-06-04 22:23:57');
INSERT INTO `access_log` VALUES (28283, '65.50.15596582373958051', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.197.34.152', '2019-06-04 22:23:57', 0, 1002001015, '账号未登陆', '2019-06-04 22:23:57');
INSERT INTO `access_log` VALUES (28284, '65.51.15596582416118047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.197.34.152', '2019-06-04 22:24:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 22:24:02');
INSERT INTO `access_log` VALUES (28285, '65.52.15596582476298053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.197.34.152', '2019-06-04 22:24:08', 115, 0, '', '2019-06-04 22:24:08');
INSERT INTO `access_log` VALUES (28286, '65.45.15596582526138065', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.197.34.152', '2019-06-04 22:24:13', 87, 0, '', '2019-06-04 22:24:13');
INSERT INTO `access_log` VALUES (28287, '65.53.15596582681288019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.197.34.152', '2019-06-04 22:24:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 22:24:28');
INSERT INTO `access_log` VALUES (28288, '65.52.15596599979238077', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.123.179.72', '2019-06-04 22:53:18', 1, 1002001015, '账号未登陆', '2019-06-04 22:53:18');
INSERT INTO `access_log` VALUES (28289, '65.48.15596599979258075', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.123.179.72', '2019-06-04 22:53:18', 0, 1002001015, '账号未登陆', '2019-06-04 22:53:18');
INSERT INTO `access_log` VALUES (28290, '65.45.15596599979288089', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.123.178.181', '2019-06-04 22:53:18', 1, 1002001015, '账号未登陆', '2019-06-04 22:53:18');
INSERT INTO `access_log` VALUES (28291, '65.53.15596603053578047', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:25', 0, 1002001015, '账号未登陆', '2019-06-04 22:58:25');
INSERT INTO `access_log` VALUES (28292, '65.47.15596603053588077', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:25', 1, 1002001015, '账号未登陆', '2019-06-04 22:58:25');
INSERT INTO `access_log` VALUES (28293, '65.49.15596603053598097', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:25', 1, 1002001015, '账号未登陆', '2019-06-04 22:58:25');
INSERT INTO `access_log` VALUES (28294, '65.46.15596603071818071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:27', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 22:58:27');
INSERT INTO `access_log` VALUES (28295, '65.50.15596603163308081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:36', 283, 0, '', '2019-06-04 22:58:37');
INSERT INTO `access_log` VALUES (28296, '65.51.15596603169488077', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:37', 11, 0, '', '2019-06-04 22:58:37');
INSERT INTO `access_log` VALUES (28297, '65.52.15596603169498083', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:37', 11, 0, '', '2019-06-04 22:58:37');
INSERT INTO `access_log` VALUES (28298, '65.48.15596603169538081', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:37', 9, 0, '', '2019-06-04 22:58:37');
INSERT INTO `access_log` VALUES (28299, '62.83.15596603215387833', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:42', 22, 0, '', '2019-06-04 22:58:42');
INSERT INTO `access_log` VALUES (28300, '64.76.15596603249997685', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:45', 145, 0, '', '2019-06-04 22:58:45');
INSERT INTO `access_log` VALUES (28301, '64.80.15596603249997691', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:45', 149, 0, '', '2019-06-04 22:58:45');
INSERT INTO `access_log` VALUES (28302, '64.79.15596603265117693', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:47', 11, 0, '', '2019-06-04 22:58:47');
INSERT INTO `access_log` VALUES (28303, '64.83.15596603265117689', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:47', 14, 0, '', '2019-06-04 22:58:47');
INSERT INTO `access_log` VALUES (28304, '66.54.15596603300926591', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:50', 21, 0, '', '2019-06-04 22:58:50');
INSERT INTO `access_log` VALUES (28305, '59.72.15596603315057977', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:52', 16, 0, '', '2019-06-04 22:58:52');
INSERT INTO `access_log` VALUES (28306, '59.71.15596603390467983', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.198.222.168', '2019-06-04 22:58:59', 101, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-04 22:58:59');
INSERT INTO `access_log` VALUES (28307, '65.54.15596632272018085', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.129.188.210', '2019-06-04 23:47:07', 1, 1002001015, '账号未登陆', '2019-06-04 23:47:07');
INSERT INTO `access_log` VALUES (28308, '65.49.15596632272018139', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.129.188.210', '2019-06-04 23:47:07', 1, 1002001015, '账号未登陆', '2019-06-04 23:47:07');
INSERT INTO `access_log` VALUES (28309, '65.47.15596632272088117', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.129.188.210', '2019-06-04 23:47:07', 0, 1002001015, '账号未登陆', '2019-06-04 23:47:07');
INSERT INTO `access_log` VALUES (28310, '65.50.15596632385838123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.129.188.210', '2019-06-04 23:47:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-04 23:47:19');
INSERT INTO `access_log` VALUES (28311, '65.51.15596632433348119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.129.188.210', '2019-06-04 23:47:23', 51, 0, '', '2019-06-04 23:47:23');
INSERT INTO `access_log` VALUES (28312, '65.48.15596632490248121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.129.188.210', '2019-06-04 23:47:29', 123, 0, '', '2019-06-04 23:47:29');
INSERT INTO `access_log` VALUES (28313, '59.79.15596649981618041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.149.190', '2019-06-05 00:16:38', 16, 2001001000, '服务端发生异常', '2019-06-05 00:16:38');
INSERT INTO `access_log` VALUES (28314, '59.78.15596649981648045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.149.190', '2019-06-05 00:16:38', 17, 0, '', '2019-06-05 00:16:38');
INSERT INTO `access_log` VALUES (28315, '59.73.15596653203968049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.22.251.36', '2019-06-05 00:22:00', 13, 2001001000, '服务端发生异常', '2019-06-05 00:22:00');
INSERT INTO `access_log` VALUES (28316, '59.75.15596653204158047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.22.251.36', '2019-06-05 00:22:00', 3, 0, '', '2019-06-05 00:22:00');
INSERT INTO `access_log` VALUES (28317, '64.84.15596653258237769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.22.251.36', '2019-06-05 00:22:06', 10, 0, '', '2019-06-05 00:22:06');
INSERT INTO `access_log` VALUES (28318, '64.77.15596653259697769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.22.251.36', '2019-06-05 00:22:06', 2, 0, '', '2019-06-05 00:22:06');
INSERT INTO `access_log` VALUES (28319, '59.77.15596653826708039', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.60.61.151', '2019-06-05 00:23:03', 3, 0, '', '2019-06-05 00:23:03');
INSERT INTO `access_log` VALUES (28320, '59.79.15596653826778047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.60.61.151', '2019-06-05 00:23:03', 12, 2001001000, '服务端发生异常', '2019-06-05 00:23:03');
INSERT INTO `access_log` VALUES (28321, '64.76.15596655046287755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.60.61.151', '2019-06-05 00:25:05', 2, 0, '', '2019-06-05 00:25:05');
INSERT INTO `access_log` VALUES (28322, '64.83.15596655047657759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.60.61.151', '2019-06-05 00:25:05', 2, 0, '', '2019-06-05 00:25:05');
INSERT INTO `access_log` VALUES (28323, '64.81.15596655056097763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.60.61.151', '2019-06-05 00:25:06', 2, 0, '', '2019-06-05 00:25:06');
INSERT INTO `access_log` VALUES (28324, '64.85.15596655067817783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.60.61.151', '2019-06-05 00:25:07', 2, 0, '', '2019-06-05 00:25:07');
INSERT INTO `access_log` VALUES (28325, '64.82.15596655079917777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.60.61.151', '2019-06-05 00:25:08', 2, 0, '', '2019-06-05 00:25:08');
INSERT INTO `access_log` VALUES (28326, '64.78.15596655081337773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.60.61.151', '2019-06-05 00:25:08', 2, 0, '', '2019-06-05 00:25:08');
INSERT INTO `access_log` VALUES (28327, '59.79.15596655090558049', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.60.61.151', '2019-06-05 00:25:09', 4, 0, '', '2019-06-05 00:25:09');
INSERT INTO `access_log` VALUES (28328, '59.78.15596655091018053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.60.61.151', '2019-06-05 00:25:09', 13, 2001001000, '服务端发生异常', '2019-06-05 00:25:09');
INSERT INTO `access_log` VALUES (28329, '65.47.15596655282018149', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '115.60.61.151', '2019-06-05 00:25:28', 0, 1002001015, '账号未登陆', '2019-06-05 00:25:28');
INSERT INTO `access_log` VALUES (28330, '65.49.15596655282018171', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '115.60.61.151', '2019-06-05 00:25:28', 0, 1002001015, '账号未登陆', '2019-06-05 00:25:28');
INSERT INTO `access_log` VALUES (28331, '65.54.15596655282078117', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '115.60.61.151', '2019-06-05 00:25:28', 0, 1002001015, '账号未登陆', '2019-06-05 00:25:28');
INSERT INTO `access_log` VALUES (28332, '64.83.15596655665177761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '223.166.151.197', '2019-06-05 00:26:07', 2, 0, '', '2019-06-05 00:26:07');
INSERT INTO `access_log` VALUES (28333, '65.48.15596655881558153', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '223.166.151.191', '2019-06-05 00:26:28', 1, 1002001015, '账号未登陆', '2019-06-05 00:26:28');
INSERT INTO `access_log` VALUES (28334, '65.45.15596655881568165', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '223.166.151.191', '2019-06-05 00:26:28', 0, 1002001015, '账号未登陆', '2019-06-05 00:26:28');
INSERT INTO `access_log` VALUES (28335, '65.53.15596655901538123', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '58.246.221.61', '2019-06-05 00:26:30', 0, 1002001015, '账号未登陆', '2019-06-05 00:26:30');
INSERT INTO `access_log` VALUES (28336, '65.54.15596678767228149', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:04:37', 0, 1002001015, '账号未登陆', '2019-06-05 01:04:37');
INSERT INTO `access_log` VALUES (28337, '65.46.15596678767228177', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:04:37', 0, 1002001015, '账号未登陆', '2019-06-05 01:04:37');
INSERT INTO `access_log` VALUES (28338, '65.50.15596678767248187', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:04:37', 1, 1002001015, '账号未登陆', '2019-06-05 01:04:37');
INSERT INTO `access_log` VALUES (28339, '65.52.15596678792708187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:04:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 01:04:39');
INSERT INTO `access_log` VALUES (28340, '65.45.15596678808328197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:04:41', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 01:04:41');
INSERT INTO `access_log` VALUES (28341, '65.52.15596680027018191', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:06:43', 53, 0, '', '2019-06-05 01:06:43');
INSERT INTO `access_log` VALUES (28342, '65.51.15596680036348185', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:06:44', 15, 0, '', '2019-06-05 01:06:44');
INSERT INTO `access_log` VALUES (28343, '65.50.15596680036358189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:06:44', 15, 0, '', '2019-06-05 01:06:44');
INSERT INTO `access_log` VALUES (28344, '65.45.15596680036378199', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:06:44', 11, 0, '', '2019-06-05 01:06:44');
INSERT INTO `access_log` VALUES (28345, '62.80.15596680081627939', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:06:48', 21, 0, '', '2019-06-05 01:06:48');
INSERT INTO `access_log` VALUES (28346, '64.78.15596680141047807', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:06:54', 24, 0, '', '2019-06-05 01:06:54');
INSERT INTO `access_log` VALUES (28347, '64.82.15596680141027811', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:06:54', 27, 0, '', '2019-06-05 01:06:54');
INSERT INTO `access_log` VALUES (28348, '64.77.15596680154837807', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:06:55', 121, 0, '', '2019-06-05 01:06:56');
INSERT INTO `access_log` VALUES (28349, '64.84.15596680154827807', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:06:55', 124, 0, '', '2019-06-05 01:06:56');
INSERT INTO `access_log` VALUES (28350, '66.56.15596680241996687', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:07:04', 18, 0, '', '2019-06-05 01:07:04');
INSERT INTO `access_log` VALUES (28351, '65.47.15596680297008187', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:07:10', 19, 0, '', '2019-06-05 01:07:10');
INSERT INTO `access_log` VALUES (28352, '65.49.15596680315358209', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:07:12', 9, 0, '', '2019-06-05 01:07:12');
INSERT INTO `access_log` VALUES (28353, '65.54.15596680349558153', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:07:15', 10, 0, '', '2019-06-05 01:07:15');
INSERT INTO `access_log` VALUES (28354, '65.46.15596680406568183', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:07:21', 1119, 0, '', '2019-06-05 01:07:22');
INSERT INTO `access_log` VALUES (28355, '65.50.15596680632408191', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:07:43', 15, 0, '', '2019-06-05 01:07:43');
INSERT INTO `access_log` VALUES (28356, '65.51.15596680721638187', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:07:52', 295, 0, '', '2019-06-05 01:07:52');
INSERT INTO `access_log` VALUES (28357, '65.48.15596680736768191', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:07:54', 14, 0, '', '2019-06-05 01:07:54');
INSERT INTO `access_log` VALUES (28358, '65.47.15596680758608189', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:07:56', 11, 0, '', '2019-06-05 01:07:56');
INSERT INTO `access_log` VALUES (28359, '65.54.15596680891398155', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:08:09', 9, 0, '', '2019-06-05 01:08:09');
INSERT INTO `access_log` VALUES (28360, '65.51.15596681507238189', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:09:11', 8, 0, '', '2019-06-05 01:09:11');
INSERT INTO `access_log` VALUES (28361, '65.48.15596681514928193', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:09:11', 17, 0, '', '2019-06-05 01:09:12');
INSERT INTO `access_log` VALUES (28362, '65.47.15596681706048191', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:09:31', 14, 0, '', '2019-06-05 01:09:31');
INSERT INTO `access_log` VALUES (28363, '65.49.15596681744228213', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:09:34', 10, 0, '', '2019-06-05 01:09:34');
INSERT INTO `access_log` VALUES (28364, '65.54.15596681763568157', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:09:36', 13, 0, '', '2019-06-05 01:09:36');
INSERT INTO `access_log` VALUES (28365, '65.52.15596681848108197', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/70.0.3538.77 Chrome/70.0.3538.77 Safari/537.36', '1.85.61.190', '2019-06-05 01:09:45', 19, 0, '', '2019-06-05 01:09:45');
INSERT INTO `access_log` VALUES (28366, '59.80.15596708125618111', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:53:33', 12, 0, '', '2019-06-05 01:53:33');
INSERT INTO `access_log` VALUES (28367, '59.76.15596708125618113', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:53:33', 16, 2001001000, '服务端发生异常', '2019-06-05 01:53:33');
INSERT INTO `access_log` VALUES (28368, '64.82.15596708159607849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:53:36', 11, 0, '', '2019-06-05 01:53:36');
INSERT INTO `access_log` VALUES (28369, '64.84.15596708161547845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:53:36', 138, 0, '', '2019-06-05 01:53:36');
INSERT INTO `access_log` VALUES (28370, '64.77.15596708186417845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:53:39', 1, 0, '', '2019-06-05 01:53:39');
INSERT INTO `access_log` VALUES (28371, '64.80.15596708195667835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:53:40', 2, 0, '', '2019-06-05 01:53:40');
INSERT INTO `access_log` VALUES (28372, '65.54.15596708445698193', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:05', 1, 1002001015, '账号未登陆', '2019-06-05 01:54:05');
INSERT INTO `access_log` VALUES (28373, '65.46.15596708445768223', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:05', 0, 1002001015, '账号未登陆', '2019-06-05 01:54:05');
INSERT INTO `access_log` VALUES (28374, '65.52.15596708445918233', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:05', 0, 1002001015, '账号未登陆', '2019-06-05 01:54:05');
INSERT INTO `access_log` VALUES (28375, '65.45.15596708481378241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:08', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 01:54:08');
INSERT INTO `access_log` VALUES (28376, '65.51.15596708500758227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 01:54:10');
INSERT INTO `access_log` VALUES (28377, '59.79.15596708531608121', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '117.136.2.164', '2019-06-05 01:54:13', 3, 0, '', '2019-06-05 01:54:13');
INSERT INTO `access_log` VALUES (28378, '59.78.15596708531658125', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '117.136.2.164', '2019-06-05 01:54:13', 17, 2001001000, '服务端发生异常', '2019-06-05 01:54:13');
INSERT INTO `access_log` VALUES (28379, '64.79.15596708597157837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '117.136.2.164', '2019-06-05 01:54:20', 1, 0, '', '2019-06-05 01:54:20');
INSERT INTO `access_log` VALUES (28380, '64.81.15596708598957837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '117.136.2.164', '2019-06-05 01:54:20', 2, 0, '', '2019-06-05 01:54:20');
INSERT INTO `access_log` VALUES (28381, '64.78.15596708646557847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '117.136.2.164', '2019-06-05 01:54:25', 2, 0, '', '2019-06-05 01:54:25');
INSERT INTO `access_log` VALUES (28382, '64.82.15596708649057851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '117.136.2.164', '2019-06-05 01:54:25', 2, 0, '', '2019-06-05 01:54:25');
INSERT INTO `access_log` VALUES (28383, '65.53.15596708663108199', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:26', 73, 0, '', '2019-06-05 01:54:26');
INSERT INTO `access_log` VALUES (28384, '65.47.15596708667948229', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:27', 11, 0, '', '2019-06-05 01:54:27');
INSERT INTO `access_log` VALUES (28385, '65.49.15596708668058251', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:27', 8, 0, '', '2019-06-05 01:54:27');
INSERT INTO `access_log` VALUES (28386, '65.52.15596708668078235', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:27', 8, 0, '', '2019-06-05 01:54:27');
INSERT INTO `access_log` VALUES (28387, '64.84.15596708674757847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '117.136.2.164', '2019-06-05 01:54:27', 2, 0, '', '2019-06-05 01:54:27');
INSERT INTO `access_log` VALUES (28388, '64.77.15596708677957847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '117.136.2.164', '2019-06-05 01:54:28', 2, 0, '', '2019-06-05 01:54:28');
INSERT INTO `access_log` VALUES (28389, '59.75.15596708682558123', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '117.136.2.164', '2019-06-05 01:54:28', 2, 0, '', '2019-06-05 01:54:28');
INSERT INTO `access_log` VALUES (28390, '59.73.15596708682658125', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9600) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '117.136.2.164', '2019-06-05 01:54:28', 13, 2001001000, '服务端发生异常', '2019-06-05 01:54:28');
INSERT INTO `access_log` VALUES (28391, '65.46.15596708742418225', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:34', 9, 0, '', '2019-06-05 01:54:34');
INSERT INTO `access_log` VALUES (28392, '65.54.15596708742488195', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:34', 8, 0, '', '2019-06-05 01:54:34');
INSERT INTO `access_log` VALUES (28393, '65.45.15596708742618243', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:34', 9, 0, '', '2019-06-05 01:54:34');
INSERT INTO `access_log` VALUES (28394, '65.48.15596708821688233', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:42', 9, 0, '', '2019-06-05 01:54:42');
INSERT INTO `access_log` VALUES (28395, '65.51.15596708821678229', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:42', 10, 0, '', '2019-06-05 01:54:42');
INSERT INTO `access_log` VALUES (28396, '65.53.15596708821688201', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:54:42', 10, 0, '', '2019-06-05 01:54:42');
INSERT INTO `access_log` VALUES (28397, '59.71.15596709028728127', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:55:03', 3, 0, '', '2019-06-05 01:55:03');
INSERT INTO `access_log` VALUES (28398, '59.72.15596709028708121', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:55:03', 13, 2001001000, '服务端发生异常', '2019-06-05 01:55:03');
INSERT INTO `access_log` VALUES (28399, '64.83.15596709054247835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:55:05', 2, 0, '', '2019-06-05 01:55:05');
INSERT INTO `access_log` VALUES (28400, '64.81.15596709056267839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:55:06', 1, 0, '', '2019-06-05 01:55:06');
INSERT INTO `access_log` VALUES (28401, '59.79.15596709130018123', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:55:13', 2, 0, '', '2019-06-05 01:55:13');
INSERT INTO `access_log` VALUES (28402, '59.78.15596709130048127', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:55:13', 13, 2001001000, '服务端发生异常', '2019-06-05 01:55:13');
INSERT INTO `access_log` VALUES (28403, '59.74.15596709177118121', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:55:18', 2, 0, '', '2019-06-05 01:55:18');
INSERT INTO `access_log` VALUES (28404, '59.75.15596709177138125', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:55:18', 12, 2001001000, '服务端发生异常', '2019-06-05 01:55:18');
INSERT INTO `access_log` VALUES (28405, '64.78.15596709211977849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:55:21', 2, 0, '', '2019-06-05 01:55:21');
INSERT INTO `access_log` VALUES (28406, '64.82.15596709213427853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:55:21', 2, 0, '', '2019-06-05 01:55:21');
INSERT INTO `access_log` VALUES (28407, '59.76.15596709222108117', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:55:22', 2, 0, '', '2019-06-05 01:55:22');
INSERT INTO `access_log` VALUES (28408, '59.80.15596709222148115', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.9 baiduboxapp/11.9.0.11 (Baidu; P1 9)', '117.173.217.227', '2019-06-05 01:55:22', 16, 2001001000, '服务端发生异常', '2019-06-05 01:55:22');
INSERT INTO `access_log` VALUES (28409, '59.79.15596709727338125', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0.1; SOV33 Build/35.0.D.0.326) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.91 Mobile Safari/537.36', '36.110.199.8', '2019-06-05 01:56:13', 5, 0, '', '2019-06-05 01:56:13');
INSERT INTO `access_log` VALUES (28410, '59.78.15596709727338129', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0.1; SOV33 Build/35.0.D.0.326) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.91 Mobile Safari/537.36', '36.110.199.66', '2019-06-05 01:56:13', 20, 2001001000, '服务端发生异常', '2019-06-05 01:56:13');
INSERT INTO `access_log` VALUES (28411, '59.80.15596716246958125', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '116.77.86.135', '2019-06-05 02:07:05', 4, 0, '', '2019-06-05 02:07:05');
INSERT INTO `access_log` VALUES (28412, '59.71.15596716246978139', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '116.77.86.135', '2019-06-05 02:07:05', 12, 2001001000, '服务端发生异常', '2019-06-05 02:07:05');
INSERT INTO `access_log` VALUES (28413, '64.85.15596716283057869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '116.77.86.135', '2019-06-05 02:07:08', 3, 0, '', '2019-06-05 02:07:08');
INSERT INTO `access_log` VALUES (28414, '64.78.15596716284317859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '116.77.86.135', '2019-06-05 02:07:08', 2, 0, '', '2019-06-05 02:07:08');
INSERT INTO `access_log` VALUES (28415, '64.82.15596716296077863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '116.77.86.135', '2019-06-05 02:07:10', 2, 0, '', '2019-06-05 02:07:10');
INSERT INTO `access_log` VALUES (28416, '64.84.15596716301177859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '116.77.86.135', '2019-06-05 02:07:10', 2, 0, '', '2019-06-05 02:07:10');
INSERT INTO `access_log` VALUES (28417, '59.73.15596937775148433', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:16:18', 10, 0, '', '2019-06-05 08:16:18');
INSERT INTO `access_log` VALUES (28418, '59.76.15596937775148423', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:16:18', 12, 2001001000, '服务端发生异常', '2019-06-05 08:16:18');
INSERT INTO `access_log` VALUES (28419, '65.46.15596937839788533', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:16:24', 0, 1002001015, '账号未登陆', '2019-06-05 08:16:24');
INSERT INTO `access_log` VALUES (28420, '65.47.15596937839788535', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:16:24', 0, 1002001015, '账号未登陆', '2019-06-05 08:16:24');
INSERT INTO `access_log` VALUES (28421, '65.49.15596937839948561', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:16:24', 0, 1002001015, '账号未登陆', '2019-06-05 08:16:24');
INSERT INTO `access_log` VALUES (28422, '64.78.15596937895638155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:16:30', 13, 0, '', '2019-06-05 08:16:30');
INSERT INTO `access_log` VALUES (28423, '64.82.15596937897278159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:16:30', 3, 0, '', '2019-06-05 08:16:30');
INSERT INTO `access_log` VALUES (28424, '64.84.15596937954448155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:16:35', 2, 0, '', '2019-06-05 08:16:35');
INSERT INTO `access_log` VALUES (28425, '64.80.15596937956328145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:16:36', 2, 0, '', '2019-06-05 08:16:36');
INSERT INTO `access_log` VALUES (28426, '65.50.15596938043968541', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:16:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 08:16:44');
INSERT INTO `access_log` VALUES (28427, '65.54.15596938291658503', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:17:09', 95, 0, '', '2019-06-05 08:17:09');
INSERT INTO `access_log` VALUES (28428, '65.49.15596938296818563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:17:10', 58, 0, '', '2019-06-05 08:17:10');
INSERT INTO `access_log` VALUES (28429, '65.53.15596938296728509', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:17:10', 66, 0, '', '2019-06-05 08:17:10');
INSERT INTO `access_log` VALUES (28430, '65.51.15596938296688535', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:17:10', 70, 0, '', '2019-06-05 08:17:10');
INSERT INTO `access_log` VALUES (28431, '62.84.15596938368368271', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:17:17', 22, 0, '', '2019-06-05 08:17:17');
INSERT INTO `access_log` VALUES (28432, '64.81.15596938389278147', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:17:19', 9, 0, '', '2019-06-05 08:17:19');
INSERT INTO `access_log` VALUES (28433, '64.83.15596938389248143', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:17:19', 13, 0, '', '2019-06-05 08:17:19');
INSERT INTO `access_log` VALUES (28434, '64.82.15596938485458161', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:17:29', 11, 0, '', '2019-06-05 08:17:29');
INSERT INTO `access_log` VALUES (28435, '64.78.15596938485408157', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:17:29', 18, 0, '', '2019-06-05 08:17:29');
INSERT INTO `access_log` VALUES (28436, '64.84.15596938485608157', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:17:29', 7, 0, '', '2019-06-05 08:17:29');
INSERT INTO `access_log` VALUES (28437, '59.74.15596938817538429', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:18:02', 4, 0, '', '2019-06-05 08:18:02');
INSERT INTO `access_log` VALUES (28438, '59.73.15596938817648435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:18:02', 14, 2001001000, '服务端发生异常', '2019-06-05 08:18:02');
INSERT INTO `access_log` VALUES (28439, '64.79.15596938860268149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:18:06', 2, 0, '', '2019-06-05 08:18:06');
INSERT INTO `access_log` VALUES (28440, '64.83.15596938862018145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:18:06', 2, 0, '', '2019-06-05 08:18:06');
INSERT INTO `access_log` VALUES (28441, '64.81.15596938872138149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:18:07', 195, 0, '', '2019-06-05 08:18:07');
INSERT INTO `access_log` VALUES (28442, '64.85.15596938883978169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:18:08', 2, 0, '', '2019-06-05 08:18:08');
INSERT INTO `access_log` VALUES (28443, '64.82.15596940774748165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:21:17', 3, 0, '', '2019-06-05 08:21:17');
INSERT INTO `access_log` VALUES (28444, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:21:17', 13, 0, '', '2019-06-05 08:21:17');
INSERT INTO `access_log` VALUES (28445, '64.77.15596940795608161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:21:20', 2, 0, '', '2019-06-05 08:21:20');
INSERT INTO `access_log` VALUES (28446, '64.80.15596940796958151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:21:20', 2, 0, '', '2019-06-05 08:21:20');
INSERT INTO `access_log` VALUES (28447, '59.77.15596940847678427', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:21:25', 3, 0, '', '2019-06-05 08:21:25');
INSERT INTO `access_log` VALUES (28448, '59.79.15596940847748435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:21:25', 14, 2001001000, '服务端发生异常', '2019-06-05 08:21:25');
INSERT INTO `access_log` VALUES (28449, '66.51.15596941158877039', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-06-05 08:21:56', 22, 0, '', '2019-06-05 08:21:56');
INSERT INTO `access_log` VALUES (28450, '65.50.15596970415428585', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:10:42', 0, 1002001015, '账号未登陆', '2019-06-05 09:10:42');
INSERT INTO `access_log` VALUES (28451, '65.45.15596970415438595', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:10:42', 0, 1002001015, '账号未登陆', '2019-06-05 09:10:42');
INSERT INTO `access_log` VALUES (28452, '65.52.15596970415558585', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:10:42', 0, 1002001015, '账号未登陆', '2019-06-05 09:10:42');
INSERT INTO `access_log` VALUES (28453, '65.54.15596970453868547', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:10:45', 70, 0, '', '2019-06-05 09:10:45');
INSERT INTO `access_log` VALUES (28454, '65.49.15596970456858609', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:10:46', 12, 0, '', '2019-06-05 09:10:46');
INSERT INTO `access_log` VALUES (28455, '65.51.15596970456858581', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:10:46', 12, 0, '', '2019-06-05 09:10:46');
INSERT INTO `access_log` VALUES (28456, '65.53.15596970456858553', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:10:46', 12, 0, '', '2019-06-05 09:10:46');
INSERT INTO `access_log` VALUES (28457, '64.80.15596970503458191', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:10:50', 26, 0, '', '2019-06-05 09:10:50');
INSERT INTO `access_log` VALUES (28458, '64.77.15596970503448201', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:10:50', 29, 0, '', '2019-06-05 09:10:50');
INSERT INTO `access_log` VALUES (28459, '64.79.15596970604368193', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:00', 10, 0, '', '2019-06-05 09:11:00');
INSERT INTO `access_log` VALUES (28460, '64.85.15596970697638213', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:10', 9, 0, '', '2019-06-05 09:11:10');
INSERT INTO `access_log` VALUES (28461, '64.81.15596970697638193', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:10', 12, 0, '', '2019-06-05 09:11:10');
INSERT INTO `access_log` VALUES (28462, '64.84.15596970722368203', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:12', 12, 0, '', '2019-06-05 09:11:12');
INSERT INTO `access_log` VALUES (28463, '64.82.15596970722428207', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:12', 8, 0, '', '2019-06-05 09:11:12');
INSERT INTO `access_log` VALUES (28464, '64.78.15596970722368203', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:12', 14, 0, '', '2019-06-05 09:11:12');
INSERT INTO `access_log` VALUES (28465, '64.77.15596970877108203', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:28', 18, 0, '', '2019-06-05 09:11:28');
INSERT INTO `access_log` VALUES (28466, '64.79.15596970933948195', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:33', 172, 0, '', '2019-06-05 09:11:34');
INSERT INTO `access_log` VALUES (28467, '64.76.15596970933948187', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:33', 174, 0, '', '2019-06-05 09:11:34');
INSERT INTO `access_log` VALUES (28468, '64.85.15596970986768215', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:39', 9, 0, '', '2019-06-05 09:11:39');
INSERT INTO `access_log` VALUES (28469, '64.81.15596970986758195', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:39', 10, 0, '', '2019-06-05 09:11:39');
INSERT INTO `access_log` VALUES (28470, '64.84.15596971075038205', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:48', 11, 0, '', '2019-06-05 09:11:48');
INSERT INTO `access_log` VALUES (28471, '64.82.15596971075078209', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:48', 8, 0, '', '2019-06-05 09:11:48');
INSERT INTO `access_log` VALUES (28472, '59.74.15596971109468473', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:51', 20, 0, '', '2019-06-05 09:11:51');
INSERT INTO `access_log` VALUES (28473, '64.80.15596971129288195', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:53', 9, 0, '', '2019-06-05 09:11:53');
INSERT INTO `access_log` VALUES (28474, '64.77.15596971148738205', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.49.186', '2019-06-05 09:11:55', 9, 0, '', '2019-06-05 09:11:55');
INSERT INTO `access_log` VALUES (28475, '65.49.15596972588428613', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.77.87.143', '2019-06-05 09:14:19', 1, 1002001015, '账号未登陆', '2019-06-05 09:14:19');
INSERT INTO `access_log` VALUES (28476, '65.51.15596972588478585', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.77.87.143', '2019-06-05 09:14:19', 0, 1002001015, '账号未登陆', '2019-06-05 09:14:19');
INSERT INTO `access_log` VALUES (28477, '65.47.15596972588528587', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.77.87.143', '2019-06-05 09:14:19', 0, 1002001015, '账号未登陆', '2019-06-05 09:14:19');
INSERT INTO `access_log` VALUES (28478, '65.46.15596972610878585', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.77.87.143', '2019-06-05 09:14:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 09:14:21');
INSERT INTO `access_log` VALUES (28479, '65.52.15596972670768589', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.77.87.143', '2019-06-05 09:14:27', 87, 0, '', '2019-06-05 09:14:27');
INSERT INTO `access_log` VALUES (28480, '65.45.15596972719728599', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.77.87.143', '2019-06-05 09:14:32', 63, 0, '', '2019-06-05 09:14:32');
INSERT INTO `access_log` VALUES (28481, '65.54.15596972737078553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.77.87.143', '2019-06-05 09:14:34', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 09:14:34');
INSERT INTO `access_log` VALUES (28482, '65.53.15596972776398559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.77.87.143', '2019-06-05 09:14:38', 77, 0, '', '2019-06-05 09:14:38');
INSERT INTO `access_log` VALUES (28483, '59.74.15596980026748485', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:26:43', 4, 0, '', '2019-06-05 09:26:43');
INSERT INTO `access_log` VALUES (28484, '59.73.15596980026748491', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:26:43', 13, 2001001000, '服务端发生异常', '2019-06-05 09:26:43');
INSERT INTO `access_log` VALUES (28485, '64.77.15596980053818217', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:26:45', 2, 0, '', '2019-06-05 09:26:45');
INSERT INTO `access_log` VALUES (28486, '64.79.15596980054818209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:26:45', 1, 0, '', '2019-06-05 09:26:45');
INSERT INTO `access_log` VALUES (28487, '64.76.15596980067918201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:26:47', 2, 0, '', '2019-06-05 09:26:47');
INSERT INTO `access_log` VALUES (28488, '64.83.15596980072858205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:26:47', 2, 0, '', '2019-06-05 09:26:47');
INSERT INTO `access_log` VALUES (28489, '64.81.15596980077288209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:26:48', 2, 0, '', '2019-06-05 09:26:48');
INSERT INTO `access_log` VALUES (28490, '65.49.15596980260918625', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:06', 0, 1002001015, '账号未登陆', '2019-06-05 09:27:06');
INSERT INTO `access_log` VALUES (28491, '65.50.15596980260918601', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:06', 0, 1002001015, '账号未登陆', '2019-06-05 09:27:06');
INSERT INTO `access_log` VALUES (28492, '65.51.15596980260968597', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:06', 0, 1002001015, '账号未登陆', '2019-06-05 09:27:06');
INSERT INTO `access_log` VALUES (28493, '65.46.15596980289848597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 09:27:09');
INSERT INTO `access_log` VALUES (28494, '65.3607.15596980393530371', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:19', 84, 0, '', '2019-06-05 09:27:19');
INSERT INTO `access_log` VALUES (28495, '65.52.15596980396968601', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:20', 9, 0, '', '2019-06-05 09:27:20');
INSERT INTO `access_log` VALUES (28496, '65.54.15596980396998565', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:20', 9, 0, '', '2019-06-05 09:27:20');
INSERT INTO `access_log` VALUES (28497, '65.45.15596980396968611', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:20', 10, 0, '', '2019-06-05 09:27:20');
INSERT INTO `access_log` VALUES (28498, '62.80.15596980441038341', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:24', 360, 0, '', '2019-06-05 09:27:24');
INSERT INTO `access_log` VALUES (28499, '62.81.15596980534148319', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:33', 14, 0, '', '2019-06-05 09:27:33');
INSERT INTO `access_log` VALUES (28500, '66.53.15596980582217091', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:38', 22, 0, '', '2019-06-05 09:27:38');
INSERT INTO `access_log` VALUES (28501, '59.77.15596980628378481', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:43', 12, 0, '', '2019-06-05 09:27:43');
INSERT INTO `access_log` VALUES (28502, '59.78.15596980691288493', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:49', 25, 2001001000, '服务端发生异常', '2019-06-05 09:27:49');
INSERT INTO `access_log` VALUES (28503, '59.75.15596980711508491', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:51', 10, 0, '', '2019-06-05 09:27:51');
INSERT INTO `access_log` VALUES (28504, '59.73.15596980734308493', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:53', 65, 0, '', '2019-06-05 09:27:53');
INSERT INTO `access_log` VALUES (28505, '59.74.15596980765978487', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:57', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-05 09:27:57');
INSERT INTO `access_log` VALUES (28506, '59.76.15596980791058483', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:27:59', 11, 0, '', '2019-06-05 09:27:59');
INSERT INTO `access_log` VALUES (28507, '65.51.15596980876538599', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:28:08', 14, 0, '', '2019-06-05 09:28:08');
INSERT INTO `access_log` VALUES (28508, '65.46.15596980977968599', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:28:18', 9, 0, '', '2019-06-05 09:28:18');
INSERT INTO `access_log` VALUES (28509, '65.45.15596981039578613', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:28:24', 10, 0, '', '2019-06-05 09:28:24');
INSERT INTO `access_log` VALUES (28510, '65.54.15596981046288567', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:28:25', 25, 0, '', '2019-06-05 09:28:25');
INSERT INTO `access_log` VALUES (28511, '65.52.15596981056828603', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.74.124.29', '2019-06-05 09:28:26', 10, 0, '', '2019-06-05 09:28:26');
INSERT INTO `access_log` VALUES (28512, '65.47.15596981924718605', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-05 09:29:52', 5, 1002001012, '访问令牌已过期', '2019-06-05 09:29:52');
INSERT INTO `access_log` VALUES (28513, '65.46.15596981924728603', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-05 09:29:52', 4, 1002001012, '访问令牌已过期', '2019-06-05 09:29:52');
INSERT INTO `access_log` VALUES (28514, '65.3607.15596981924750377', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-05 09:29:52', 3, 1002001012, '访问令牌已过期', '2019-06-05 09:29:52');
INSERT INTO `access_log` VALUES (28515, '65.54.15596981925358569', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.228.158', '2019-06-05 09:29:53', 7, 1002001012, '访问令牌已过期', '2019-06-05 09:29:53');
INSERT INTO `access_log` VALUES (28516, '59.80.15596982125578483', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:30:13', 4, 0, '', '2019-06-05 09:30:13');
INSERT INTO `access_log` VALUES (28517, '59.76.15596982125578485', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:30:13', 14, 2001001000, '服务端发生异常', '2019-06-05 09:30:13');
INSERT INTO `access_log` VALUES (28518, '64.77.15596982273998221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:30:27', 2, 0, '', '2019-06-05 09:30:27');
INSERT INTO `access_log` VALUES (28519, '64.79.15596982275078213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:30:28', 2, 0, '', '2019-06-05 09:30:28');
INSERT INTO `access_log` VALUES (28520, '59.72.15596982292988491', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:30:29', 2, 0, '', '2019-06-05 09:30:29');
INSERT INTO `access_log` VALUES (28521, '59.77.15596982292988485', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:30:29', 15, 2001001000, '服务端发生异常', '2019-06-05 09:30:29');
INSERT INTO `access_log` VALUES (28522, '64.76.15596982345388205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:30:35', 2, 0, '', '2019-06-05 09:30:35');
INSERT INTO `access_log` VALUES (28523, '64.83.15596982346798209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:30:35', 2, 0, '', '2019-06-05 09:30:35');
INSERT INTO `access_log` VALUES (28524, '64.85.15596982364158233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:30:36', 2, 0, '', '2019-06-05 09:30:36');
INSERT INTO `access_log` VALUES (28525, '64.84.15596982388658223', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:30:39', 1, 0, '', '2019-06-05 09:30:39');
INSERT INTO `access_log` VALUES (28526, '64.82.15596982501558227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:30:50', 2, 0, '', '2019-06-05 09:30:50');
INSERT INTO `access_log` VALUES (28527, '64.78.15596982502828223', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:30:50', 2, 0, '', '2019-06-05 09:30:50');
INSERT INTO `access_log` VALUES (28528, '66.51.15596982909457095', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678909&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:31:31', 10, 1001003000, '验证码不存在', '2019-06-05 09:31:31');
INSERT INTO `access_log` VALUES (28529, '66.48.15596982939367105', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678909&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:31:34', 8, 1001003000, '验证码不存在', '2019-06-05 09:31:34');
INSERT INTO `access_log` VALUES (28530, '66.49.15596982966587105', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=12345678909', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:31:37', 99, 0, '', '2019-06-05 09:31:37');
INSERT INTO `access_log` VALUES (28531, '66.53.15596982993377095', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678909&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:31:39', 300, 0, '', '2019-06-05 09:31:40');
INSERT INTO `access_log` VALUES (28532, '66.55.15596983012997107', 108, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:31:41', 6, 0, '', '2019-06-05 09:31:41');
INSERT INTO `access_log` VALUES (28533, '66.50.15596983079177095', 108, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:31:48', 6, 0, '', '2019-06-05 09:31:48');
INSERT INTO `access_log` VALUES (28534, '64.81.15596983096988215', 108, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:31:50', 5, 0, '', '2019-06-05 09:31:50');
INSERT INTO `access_log` VALUES (28535, '64.84.15596983098218225', 108, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:31:50', 4, 0, '', '2019-06-05 09:31:50');
INSERT INTO `access_log` VALUES (28536, '64.78.15596983122258225', 108, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:31:52', 151, 0, '', '2019-06-05 09:31:52');
INSERT INTO `access_log` VALUES (28537, 'N/A', 108, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:31:52', 126, 0, '', '2019-06-05 09:31:52');
INSERT INTO `access_log` VALUES (28538, 'N/A', 108, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:31:56', 11, 0, '', '2019-06-05 09:31:56');
INSERT INTO `access_log` VALUES (28539, 'N/A', 108, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:31:58', 13, 0, '', '2019-06-05 09:31:58');
INSERT INTO `access_log` VALUES (28540, '64.77.15596983192388225', 108, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:31:59', 10, 0, '', '2019-06-05 09:31:59');
INSERT INTO `access_log` VALUES (28541, '64.76.15596983344158209', 108, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:32:14', 4, 0, '', '2019-06-05 09:32:14');
INSERT INTO `access_log` VALUES (28542, 'N/A', 108, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:32:14', 11, 0, '', '2019-06-05 09:32:14');
INSERT INTO `access_log` VALUES (28543, '64.83.15596983355948213', 108, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:32:16', 5, 0, '', '2019-06-05 09:32:16');
INSERT INTO `access_log` VALUES (28544, '64.81.15596983357218217', 108, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:32:16', 5, 0, '', '2019-06-05 09:32:16');
INSERT INTO `access_log` VALUES (28545, '66.48.15596983549267107', 108, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.205.56.221', '2019-06-05 09:32:35', 7, 0, '', '2019-06-05 09:32:35');
INSERT INTO `access_log` VALUES (28546, '66.49.15596983606667107', 108, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:32:41', 6, 0, '', '2019-06-05 09:32:41');
INSERT INTO `access_log` VALUES (28547, '64.82.15596983609038231', 108, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:32:41', 5, 0, '', '2019-06-05 09:32:41');
INSERT INTO `access_log` VALUES (28548, '64.78.15596983610318227', 108, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:32:41', 4, 0, '', '2019-06-05 09:32:41');
INSERT INTO `access_log` VALUES (28549, '59.78.15596983611428499', 108, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:32:41', 5, 0, '', '2019-06-05 09:32:41');
INSERT INTO `access_log` VALUES (28550, '59.75.15596983611528497', 108, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:32:41', 14, 2001001000, '服务端发生异常', '2019-06-05 09:32:41');
INSERT INTO `access_log` VALUES (28551, '64.80.15596983614328217', 108, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:32:41', 5, 0, '', '2019-06-05 09:32:41');
INSERT INTO `access_log` VALUES (28552, '64.77.15596983615538227', 108, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:32:42', 5, 0, '', '2019-06-05 09:32:42');
INSERT INTO `access_log` VALUES (28553, '59.73.15596983621568499', 108, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:32:42', 4, 0, '', '2019-06-05 09:32:42');
INSERT INTO `access_log` VALUES (28554, '59.74.15596983621608493', 108, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:32:42', 12, 2001001000, '服务端发生异常', '2019-06-05 09:32:42');
INSERT INTO `access_log` VALUES (28555, '65.50.15596983713778609', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:32:51', 0, 1002001015, '账号未登陆', '2019-06-05 09:32:51');
INSERT INTO `access_log` VALUES (28556, '65.49.15596983713898631', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:32:51', 0, 1002001015, '账号未登陆', '2019-06-05 09:32:51');
INSERT INTO `access_log` VALUES (28557, '65.53.15596983714008577', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:32:51', 0, 1002001015, '账号未登陆', '2019-06-05 09:32:51');
INSERT INTO `access_log` VALUES (28558, '65.51.15596983736678605', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:32:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 09:32:54');
INSERT INTO `access_log` VALUES (28559, '65.3607.15596983902270381', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:33:10', 99, 0, '', '2019-06-05 09:33:10');
INSERT INTO `access_log` VALUES (28560, '65.54.15596983908138573', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:33:11', 10, 0, '', '2019-06-05 09:33:11');
INSERT INTO `access_log` VALUES (28561, '65.45.15596983908208621', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:33:11', 10, 0, '', '2019-06-05 09:33:11');
INSERT INTO `access_log` VALUES (28562, '65.52.15596983908278611', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:33:11', 10, 0, '', '2019-06-05 09:33:11');
INSERT INTO `access_log` VALUES (28563, '62.89.15596983986648345', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:33:19', 14, 0, '', '2019-06-05 09:33:19');
INSERT INTO `access_log` VALUES (28564, '62.88.15596984114778349', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:33:31', 13, 0, '', '2019-06-05 09:33:31');
INSERT INTO `access_log` VALUES (28565, '65.49.15596984217498633', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-05 09:33:42', 95, 0, '', '2019-06-05 09:33:42');
INSERT INTO `access_log` VALUES (28566, '65.51.15596984226338607', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-05 09:33:43', 9, 0, '', '2019-06-05 09:33:43');
INSERT INTO `access_log` VALUES (28567, '65.46.15596984226368609', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-05 09:33:43', 9, 0, '', '2019-06-05 09:33:43');
INSERT INTO `access_log` VALUES (28568, '65.47.15596984226798611', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-05 09:33:43', 9, 0, '', '2019-06-05 09:33:43');
INSERT INTO `access_log` VALUES (28569, '64.84.15596984277588229', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:33:48', 12, 0, '', '2019-06-05 09:33:48');
INSERT INTO `access_log` VALUES (28570, '64.85.15596984277578239', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:33:48', 14, 0, '', '2019-06-05 09:33:48');
INSERT INTO `access_log` VALUES (28571, '62.80.15596984323748347', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-05 09:33:52', 10, 0, '', '2019-06-05 09:33:52');
INSERT INTO `access_log` VALUES (28572, '64.80.15596984340708219', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:33:54', 8, 0, '', '2019-06-05 09:33:54');
INSERT INTO `access_log` VALUES (28573, '64.78.15596984340708229', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:33:54', 12, 0, '', '2019-06-05 09:33:54');
INSERT INTO `access_log` VALUES (28574, '62.81.15596984341048325', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-05 09:33:54', 11, 0, '', '2019-06-05 09:33:54');
INSERT INTO `access_log` VALUES (28575, '62.86.15596984357068333', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.39.60.222', '2019-06-05 09:33:56', 12, 0, '', '2019-06-05 09:33:56');
INSERT INTO `access_log` VALUES (28576, '64.77.15596984420878229', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:34:02', 42, 0, '', '2019-06-05 09:34:02');
INSERT INTO `access_log` VALUES (28577, '66.51.15596984534467099', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.205.56.221', '2019-06-05 09:34:13', 11, 0, '', '2019-06-05 09:34:13');
INSERT INTO `access_log` VALUES (28578, '5775a7da-0e81-4fd8-91dd-565d047ac3ac', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:40:01', 430, 1002001015, '账号未登陆', '2019-06-05 09:40:02');
INSERT INTO `access_log` VALUES (28579, 'be2fce40-9d79-47ed-95d3-f6bdfcde5909', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:40:01', 430, 1002001015, '账号未登陆', '2019-06-05 09:40:02');
INSERT INTO `access_log` VALUES (28580, '0ade0c62-c496-41ef-86ac-23dc4370d721', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:40:01', 430, 1002001015, '账号未登陆', '2019-06-05 09:40:02');
INSERT INTO `access_log` VALUES (28581, 'cc97df19-73b1-4b56-aac9-f2c2f5939386', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:40:04', 542, 0, '', '2019-06-05 09:40:05');
INSERT INTO `access_log` VALUES (28582, '28a43e67-e870-4b25-8736-04cf27400482', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:40:05', 264, 0, '', '2019-06-05 09:40:05');
INSERT INTO `access_log` VALUES (28583, '2606b8ff-efd1-434c-823b-de9d81f17433', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:40:05', 264, 0, '', '2019-06-05 09:40:05');
INSERT INTO `access_log` VALUES (28584, '81e19df9-5212-41d8-b6b8-0b0da30fe8a3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:40:05', 291, 0, '', '2019-06-05 09:40:05');
INSERT INTO `access_log` VALUES (28585, '975f8dae-b1a7-45db-b366-49bfbfdc155e', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai234&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:40:47', 445, 0, '', '2019-06-05 09:40:47');
INSERT INTO `access_log` VALUES (28586, '896a86ab-bee6-4d97-b8ba-b34502264f50', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:40:47', 160, 0, '', '2019-06-05 09:40:47');
INSERT INTO `access_log` VALUES (28587, '869b4ba5-cb62-48c0-9447-ece6d4710ad2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:40:48', 160, 0, '', '2019-06-05 09:40:48');
INSERT INTO `access_log` VALUES (28588, 'd76bc838-2d2d-417b-96d6-0d549f31926e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:40:48', 161, 0, '', '2019-06-05 09:40:48');
INSERT INTO `access_log` VALUES (28589, '59.77.15596990241538497', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '180.168.186.65', '2019-06-05 09:43:44', 4, 0, '', '2019-06-05 09:43:44');
INSERT INTO `access_log` VALUES (28590, '59.79.15596990241558505', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '180.168.186.65', '2019-06-05 09:43:44', 13, 2001001000, '服务端发生异常', '2019-06-05 09:43:44');
INSERT INTO `access_log` VALUES (28591, 'cc366f0e-fb27-4c14-bb70-fac54096371d', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:45:03', 67062, 0, '', '2019-06-05 09:46:10');
INSERT INTO `access_log` VALUES (28592, '13d8d403-abfa-477a-93b7-fae2fced11bf', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:46:11', 165, 0, '', '2019-06-05 09:46:11');
INSERT INTO `access_log` VALUES (28593, 'a6c4bf68-1423-45bb-a748-6b5d9b5c861b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:46:11', 204, 0, '', '2019-06-05 09:46:11');
INSERT INTO `access_log` VALUES (28594, '3234b957-e3b5-4ebd-829c-825c42ca53b9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:46:11', 223, 0, '', '2019-06-05 09:46:11');
INSERT INTO `access_log` VALUES (28595, 'c5d607c3-74ae-4186-b5b1-ce19a879554f', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin123ddffsdfdsf&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:46:17', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 5-16 位', '2019-06-05 09:46:17');
INSERT INTO `access_log` VALUES (28596, '3a352309-e80f-4de8-92bf-e276062f9d63', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=陈大时代&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:46:26', 3, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 5-16 位\n账号格式为数字以及字母', '2019-06-05 09:46:26');
INSERT INTO `access_log` VALUES (28597, '16601c4a-2d24-486d-9f8b-1bd72ae73268', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=chenjj&password=asdffasfad&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 09:46:36', 12841, 1002002000, '账号不存在', '2019-06-05 09:46:49');
INSERT INTO `access_log` VALUES (28598, '65.3607.15596997784540399', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:56:18', 0, 1002001015, '账号未登陆', '2019-06-05 09:56:18');
INSERT INTO `access_log` VALUES (28599, '65.47.15596997784538631', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:56:18', 0, 1002001015, '账号未登陆', '2019-06-05 09:56:18');
INSERT INTO `access_log` VALUES (28600, '65.52.15596997784608633', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:56:18', 0, 1002001015, '账号未登陆', '2019-06-05 09:56:18');
INSERT INTO `access_log` VALUES (28601, '65.54.15596997806938593', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:56:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 09:56:21');
INSERT INTO `access_log` VALUES (28602, '65.50.15596997839158633', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:56:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 09:56:24');
INSERT INTO `access_log` VALUES (28603, '65.53.15596997972668601', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:56:37', 73, 0, '', '2019-06-05 09:56:37');
INSERT INTO `access_log` VALUES (28604, '65.46.15596997976768629', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:56:38', 9, 0, '', '2019-06-05 09:56:38');
INSERT INTO `access_log` VALUES (28605, '65.49.15596997976828653', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:56:38', 8, 0, '', '2019-06-05 09:56:38');
INSERT INTO `access_log` VALUES (28606, '65.51.15596997976898627', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:56:38', 7, 0, '', '2019-06-05 09:56:38');
INSERT INTO `access_log` VALUES (28607, '62.80.15596998083798367', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:56:48', 14, 0, '', '2019-06-05 09:56:48');
INSERT INTO `access_log` VALUES (28608, '62.81.15596998142558345', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:56:54', 15, 0, '', '2019-06-05 09:56:54');
INSERT INTO `access_log` VALUES (28609, '65.52.15596998190558635', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:56:59', 9, 0, '', '2019-06-05 09:56:59');
INSERT INTO `access_log` VALUES (28610, '65.54.15596998190598595', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:56:59', 7, 0, '', '2019-06-05 09:56:59');
INSERT INTO `access_log` VALUES (28611, '65.45.15596998190658645', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:56:59', 7, 0, '', '2019-06-05 09:56:59');
INSERT INTO `access_log` VALUES (28612, '62.86.15596998228478351', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:57:03', 81, 0, '', '2019-06-05 09:57:03');
INSERT INTO `access_log` VALUES (28613, '64.83.15596998247788235', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:57:05', 11, 0, '', '2019-06-05 09:57:05');
INSERT INTO `access_log` VALUES (28614, '64.78.15596998247778249', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:57:05', 13, 0, '', '2019-06-05 09:57:05');
INSERT INTO `access_log` VALUES (28615, '66.49.15596998403047127', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:57:20', 12, 0, '', '2019-06-05 09:57:20');
INSERT INTO `access_log` VALUES (28616, '65.46.15596998415828631', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-05 09:57:22', 3, 1002001012, '访问令牌已过期', '2019-06-05 09:57:22');
INSERT INTO `access_log` VALUES (28617, '65.53.15596998415828603', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-05 09:57:22', 3, 1002001012, '访问令牌已过期', '2019-06-05 09:57:22');
INSERT INTO `access_log` VALUES (28618, '65.49.15596998415868655', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-05 09:57:22', 3, 1002001012, '访问令牌已过期', '2019-06-05 09:57:22');
INSERT INTO `access_log` VALUES (28619, '65.47.15596998592118635', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-05 09:57:39', 68, 0, '', '2019-06-05 09:57:39');
INSERT INTO `access_log` VALUES (28620, '65.54.15596998596018597', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-05 09:57:40', 9, 0, '', '2019-06-05 09:57:40');
INSERT INTO `access_log` VALUES (28621, '65.52.15596998596028637', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-05 09:57:40', 10, 0, '', '2019-06-05 09:57:40');
INSERT INTO `access_log` VALUES (28622, '65.45.15596998596108647', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-05 09:57:40', 9, 0, '', '2019-06-05 09:57:40');
INSERT INTO `access_log` VALUES (28623, '62.88.15596998677538371', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-05 09:57:48', 11, 0, '', '2019-06-05 09:57:48');
INSERT INTO `access_log` VALUES (28624, '66.54.15596999947507123', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:59:55', 19, 0, '', '2019-06-05 09:59:55');
INSERT INTO `access_log` VALUES (28625, '64.85.15596999970258263', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:59:57', 109, 0, '', '2019-06-05 09:59:57');
INSERT INTO `access_log` VALUES (28626, '64.84.15596999970238253', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:59:57', 111, 0, '', '2019-06-05 09:59:57');
INSERT INTO `access_log` VALUES (28627, '64.81.15596999974178243', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:59:57', 9, 0, '', '2019-06-05 09:59:57');
INSERT INTO `access_log` VALUES (28628, '64.80.15596999974168241', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:59:57', 11, 0, '', '2019-06-05 09:59:57');
INSERT INTO `access_log` VALUES (28629, '62.86.15596999976468355', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:59:58', 12, 0, '', '2019-06-05 09:59:58');
INSERT INTO `access_log` VALUES (28630, '62.82.15596999983278371', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:59:58', 15, 0, '', '2019-06-05 09:59:58');
INSERT INTO `access_log` VALUES (28631, '62.89.15596999988428371', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '106.120.122.130', '2019-06-05 09:59:59', 12, 0, '', '2019-06-05 09:59:59');
INSERT INTO `access_log` VALUES (28632, '65.53.15597000477888607', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:00:48', 1, 1002001015, '账号未登陆', '2019-06-05 10:00:48');
INSERT INTO `access_log` VALUES (28633, '65.51.15597000477888633', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:00:48', 0, 1002001015, '账号未登陆', '2019-06-05 10:00:48');
INSERT INTO `access_log` VALUES (28634, '65.46.15597000477888635', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:00:48', 1, 1002001015, '账号未登陆', '2019-06-05 10:00:48');
INSERT INTO `access_log` VALUES (28635, '65.3607.15597000496330407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:00:50', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 10:00:50');
INSERT INTO `access_log` VALUES (28636, '65.52.15597000659368641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:01:06', 84, 0, '', '2019-06-05 10:01:06');
INSERT INTO `access_log` VALUES (28637, '65.54.15597000662108601', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:01:06', 10, 0, '', '2019-06-05 10:01:06');
INSERT INTO `access_log` VALUES (28638, '65.45.15597000662128651', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:01:06', 10, 0, '', '2019-06-05 10:01:06');
INSERT INTO `access_log` VALUES (28639, '65.50.15597000662148641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:01:06', 9, 0, '', '2019-06-05 10:01:06');
INSERT INTO `access_log` VALUES (28640, '62.87.15597000794748359', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:01:19', 12, 0, '', '2019-06-05 10:01:19');
INSERT INTO `access_log` VALUES (28641, '62.86.15597000848048357', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:01:25', 14, 0, '', '2019-06-05 10:01:25');
INSERT INTO `access_log` VALUES (28642, '64.85.15597000880578265', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:01:28', 12, 0, '', '2019-06-05 10:01:28');
INSERT INTO `access_log` VALUES (28643, '64.84.15597000880618255', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:01:28', 9, 0, '', '2019-06-05 10:01:28');
INSERT INTO `access_log` VALUES (28644, '64.80.15597000951658243', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:01:35', 8, 0, '', '2019-06-05 10:01:35');
INSERT INTO `access_log` VALUES (28645, '64.81.15597000951648245', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:01:35', 33, 0, '', '2019-06-05 10:01:35');
INSERT INTO `access_log` VALUES (28646, '64.77.15597001024078255', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:01:42', 10, 0, '', '2019-06-05 10:01:42');
INSERT INTO `access_log` VALUES (28647, '66.55.15597001538517133', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:02:34', 13, 0, '', '2019-06-05 10:02:34');
INSERT INTO `access_log` VALUES (28648, '59.71.15597001627948525', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:02:43', 109, 0, '', '2019-06-05 10:02:43');
INSERT INTO `access_log` VALUES (28649, '59.72.15597001656438519', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:02:46', 265, 2001001000, '服务端发生异常', '2019-06-05 10:02:46');
INSERT INTO `access_log` VALUES (28650, '59.79.15597001689968521', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:02:49', 12, 0, '', '2019-06-05 10:02:49');
INSERT INTO `access_log` VALUES (28651, '59.78.15597001729368525', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:02:53', 12, 0, '', '2019-06-05 10:02:53');
INSERT INTO `access_log` VALUES (28652, '65.50.15597001799248643', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:03:00', 19, 0, '', '2019-06-05 10:03:00');
INSERT INTO `access_log` VALUES (28653, '65.45.15597001823048653', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:03:02', 9, 0, '', '2019-06-05 10:03:02');
INSERT INTO `access_log` VALUES (28654, '65.49.15597001843898663', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:03:04', 9, 0, '', '2019-06-05 10:03:04');
INSERT INTO `access_log` VALUES (28655, '65.47.15597002487328643', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.27.64.49', '2019-06-05 10:04:09', 22, 0, '', '2019-06-05 10:04:09');
INSERT INTO `access_log` VALUES (28656, '65.50.15597002678048645', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:04:28', 1, 1002001015, '账号未登陆', '2019-06-05 10:04:28');
INSERT INTO `access_log` VALUES (28657, '65.45.15597002678108655', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:04:28', 0, 1002001015, '账号未登陆', '2019-06-05 10:04:28');
INSERT INTO `access_log` VALUES (28658, '65.49.15597002678138665', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:04:28', 0, 1002001015, '账号未登陆', '2019-06-05 10:04:28');
INSERT INTO `access_log` VALUES (28659, '65.53.15597002766988613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:04:37', 392, 0, '', '2019-06-05 10:04:37');
INSERT INTO `access_log` VALUES (28660, '65.51.15597002775408639', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:04:38', 119, 0, '', '2019-06-05 10:04:38');
INSERT INTO `access_log` VALUES (28661, '65.46.15597002775348641', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:04:38', 127, 0, '', '2019-06-05 10:04:38');
INSERT INTO `access_log` VALUES (28662, '65.3607.15597002775400413', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:04:38', 125, 0, '', '2019-06-05 10:04:38');
INSERT INTO `access_log` VALUES (28663, '64.79.15597002809848247', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:04:41', 9, 0, '', '2019-06-05 10:04:41');
INSERT INTO `access_log` VALUES (28664, '64.76.15597002809808239', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:04:41', 12, 0, '', '2019-06-05 10:04:41');
INSERT INTO `access_log` VALUES (28665, '59.75.15597003192318525', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:19', 3, 0, '', '2019-06-05 10:05:19');
INSERT INTO `access_log` VALUES (28666, '59.74.15597003192318521', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:19', 13, 2001001000, '服务端发生异常', '2019-06-05 10:05:19');
INSERT INTO `access_log` VALUES (28667, '64.81.15597003313008249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:31', 2, 0, '', '2019-06-05 10:05:31');
INSERT INTO `access_log` VALUES (28668, '64.82.15597003314198263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:31', 1, 0, '', '2019-06-05 10:05:31');
INSERT INTO `access_log` VALUES (28669, '64.77.15597003331138259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:33', 2, 0, '', '2019-06-05 10:05:33');
INSERT INTO `access_log` VALUES (28670, '64.83.15597003338748245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:34', 1, 0, '', '2019-06-05 10:05:34');
INSERT INTO `access_log` VALUES (28671, '64.79.15597003374158249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:37', 53, 0, '', '2019-06-05 10:05:37');
INSERT INTO `access_log` VALUES (28672, '64.76.15597003376448241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:38', 2, 0, '', '2019-06-05 10:05:38');
INSERT INTO `access_log` VALUES (28673, '59.80.15597003428758515', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:43', 3, 0, '', '2019-06-05 10:05:43');
INSERT INTO `access_log` VALUES (28674, '59.76.15597003428758517', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:43', 13, 2001001000, '服务端发生异常', '2019-06-05 10:05:43');
INSERT INTO `access_log` VALUES (28675, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:49', 8, 0, '', '2019-06-05 10:05:49');
INSERT INTO `access_log` VALUES (28676, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:49', 5, 0, '', '2019-06-05 10:05:49');
INSERT INTO `access_log` VALUES (28677, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:49', 13, 0, '', '2019-06-05 10:05:49');
INSERT INTO `access_log` VALUES (28678, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:49', 12, 0, '', '2019-06-05 10:05:49');
INSERT INTO `access_log` VALUES (28679, '64.84.15597003514328261', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:51', 8, 0, '', '2019-06-05 10:05:51');
INSERT INTO `access_log` VALUES (28680, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:57', 7, 0, '', '2019-06-05 10:05:57');
INSERT INTO `access_log` VALUES (28681, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:58', 5, 0, '', '2019-06-05 10:05:58');
INSERT INTO `access_log` VALUES (28682, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:58', 9, 0, '', '2019-06-05 10:05:58');
INSERT INTO `access_log` VALUES (28683, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:58', 9, 0, '', '2019-06-05 10:05:58');
INSERT INTO `access_log` VALUES (28684, '64.80.15597003587838249', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:05:59', 6, 0, '', '2019-06-05 10:05:59');
INSERT INTO `access_log` VALUES (28685, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:08', 7, 0, '', '2019-06-05 10:06:08');
INSERT INTO `access_log` VALUES (28686, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:08', 5, 0, '', '2019-06-05 10:06:08');
INSERT INTO `access_log` VALUES (28687, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:08', 10, 0, '', '2019-06-05 10:06:08');
INSERT INTO `access_log` VALUES (28688, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:08', 13, 0, '', '2019-06-05 10:06:08');
INSERT INTO `access_log` VALUES (28689, '59.77.15597003686618517', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:09', 3, 0, '', '2019-06-05 10:06:09');
INSERT INTO `access_log` VALUES (28690, '59.79.15597003686618525', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:09', 12, 2001001000, '服务端发生异常', '2019-06-05 10:06:09');
INSERT INTO `access_log` VALUES (28691, '64.82.15597003699178265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:10', 2, 0, '', '2019-06-05 10:06:10');
INSERT INTO `access_log` VALUES (28692, '64.77.15597003700598261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:10', 1, 0, '', '2019-06-05 10:06:10');
INSERT INTO `access_log` VALUES (28693, '59.78.15597003705348529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:11', 3, 0, '', '2019-06-05 10:06:11');
INSERT INTO `access_log` VALUES (28694, '59.74.15597003705348523', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:11', 13, 2001001000, '服务端发生异常', '2019-06-05 10:06:11');
INSERT INTO `access_log` VALUES (28695, '65.51.15597003763448641', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:16', 1, 1002001015, '账号未登陆', '2019-06-05 10:06:16');
INSERT INTO `access_log` VALUES (28696, '65.3607.15597003763440415', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:16', 1, 1002001015, '账号未登陆', '2019-06-05 10:06:16');
INSERT INTO `access_log` VALUES (28697, '65.46.15597003763448643', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:16', 1, 1002001015, '账号未登陆', '2019-06-05 10:06:16');
INSERT INTO `access_log` VALUES (28698, '65.47.15597003792908647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 10:06:19');
INSERT INTO `access_log` VALUES (28699, '65.52.15597003817338649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 10:06:22');
INSERT INTO `access_log` VALUES (28700, '65.50.15597003981848649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:38', 88, 0, '', '2019-06-05 10:06:38');
INSERT INTO `access_log` VALUES (28701, '65.45.15597003985448659', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:39', 8, 0, '', '2019-06-05 10:06:39');
INSERT INTO `access_log` VALUES (28702, '65.49.15597003985458669', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:39', 9, 0, '', '2019-06-05 10:06:39');
INSERT INTO `access_log` VALUES (28703, '65.53.15597003985468617', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:39', 8, 0, '', '2019-06-05 10:06:39');
INSERT INTO `access_log` VALUES (28704, '62.83.15597004038478375', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:44', 13, 0, '', '2019-06-05 10:06:44');
INSERT INTO `access_log` VALUES (28705, '62.88.15597004132558381', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:06:53', 13, 0, '', '2019-06-05 10:06:53');
INSERT INTO `access_log` VALUES (28706, '64.76.15597004202728243', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:07:00', 9, 0, '', '2019-06-05 10:07:00');
INSERT INTO `access_log` VALUES (28707, '64.85.15597004202758273', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:07:00', 7, 0, '', '2019-06-05 10:07:00');
INSERT INTO `access_log` VALUES (28708, '64.80.15597004246828251', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:07:05', 9, 0, '', '2019-06-05 10:07:05');
INSERT INTO `access_log` VALUES (28709, '64.84.15597004246818263', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:07:05', 11, 0, '', '2019-06-05 10:07:05');
INSERT INTO `access_log` VALUES (28710, '64.82.15597004314228267', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:07:11', 9, 0, '', '2019-06-05 10:07:11');
INSERT INTO `access_log` VALUES (28711, '66.50.15597004497847125', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:07:30', 13, 0, '', '2019-06-05 10:07:30');
INSERT INTO `access_log` VALUES (28712, '65.54.15597004589778611', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:07:39', 18, 0, '', '2019-06-05 10:07:39');
INSERT INTO `access_log` VALUES (28713, '65.50.15597004628768651', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:07:43', 10, 0, '', '2019-06-05 10:07:43');
INSERT INTO `access_log` VALUES (28714, '65.49.15597004652868671', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:07:45', 348, 0, '', '2019-06-05 10:07:46');
INSERT INTO `access_log` VALUES (28715, '65.45.15597004682918661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:07:48', 14, 0, '', '2019-06-05 10:07:48');
INSERT INTO `access_log` VALUES (28716, '65.3607.15597004800470419', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:08:00', 10, 0, '', '2019-06-05 10:08:00');
INSERT INTO `access_log` VALUES (28717, '65.46.15597004800528647', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:08:00', 9, 0, '', '2019-06-05 10:08:00');
INSERT INTO `access_log` VALUES (28718, '65.51.15597004800538645', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:08:00', 9, 0, '', '2019-06-05 10:08:00');
INSERT INTO `access_log` VALUES (28719, '64.85.15597004802548275', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:08:00', 9, 0, '', '2019-06-05 10:08:00');
INSERT INTO `access_log` VALUES (28720, '64.79.15597004802538253', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:08:00', 10, 0, '', '2019-06-05 10:08:00');
INSERT INTO `access_log` VALUES (28721, '65.52.15597004894198653', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:08:09', 9, 0, '', '2019-06-05 10:08:09');
INSERT INTO `access_log` VALUES (28722, '65.54.15597004898518613', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:08:10', 23, 0, '', '2019-06-05 10:08:10');
INSERT INTO `access_log` VALUES (28723, '65.50.15597004904238653', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:08:10', 14, 0, '', '2019-06-05 10:08:10');
INSERT INTO `access_log` VALUES (28724, '59.78.15597004923368531', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:08:12', 11, 0, '', '2019-06-05 10:08:12');
INSERT INTO `access_log` VALUES (28725, '65.49.15597004990738673', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:08:19', 20, 0, '', '2019-06-05 10:08:19');
INSERT INTO `access_log` VALUES (28726, '65.45.15597004994828663', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:08:19', 10, 0, '', '2019-06-05 10:08:19');
INSERT INTO `access_log` VALUES (28727, '65.53.15597004997318621', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:08:20', 9, 0, '', '2019-06-05 10:08:20');
INSERT INTO `access_log` VALUES (28728, '65.51.15597005000898647', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:08:20', 12, 0, '', '2019-06-05 10:08:20');
INSERT INTO `access_log` VALUES (28729, '65.46.15597005001868649', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:08:20', 10, 0, '', '2019-06-05 10:08:20');
INSERT INTO `access_log` VALUES (28730, '65.3607.15597005002730421', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:08:20', 10, 0, '', '2019-06-05 10:08:20');
INSERT INTO `access_log` VALUES (28731, '65.47.15597005004598653', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:08:20', 19, 0, '', '2019-06-05 10:08:20');
INSERT INTO `access_log` VALUES (28732, '66.57.15597005006717133', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.17.228.172', '2019-06-05 10:08:21', 12, 0, '', '2019-06-05 10:08:21');
INSERT INTO `access_log` VALUES (28733, '64.84.15597006263948267', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:10:26', 10, 0, '', '2019-06-05 10:10:26');
INSERT INTO `access_log` VALUES (28734, '64.76.15597006263948247', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:10:26', 12, 0, '', '2019-06-05 10:10:26');
INSERT INTO `access_log` VALUES (28735, '64.77.15597006749328267', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:11:15', 10, 0, '', '2019-06-05 10:11:15');
INSERT INTO `access_log` VALUES (28736, '64.79.15597006973338257', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:11:37', 15, 0, '', '2019-06-05 10:11:37');
INSERT INTO `access_log` VALUES (28737, '64.85.15597006973318279', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 10:11:37', 19, 0, '', '2019-06-05 10:11:37');
INSERT INTO `access_log` VALUES (28738, '65.49.15597011248958683', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:18:45', 0, 1002001015, '账号未登陆', '2019-06-05 10:18:45');
INSERT INTO `access_log` VALUES (28739, '65.50.15597011248948663', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:18:45', 1, 1002001015, '账号未登陆', '2019-06-05 10:18:45');
INSERT INTO `access_log` VALUES (28740, '65.45.15597011248978673', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:18:45', 0, 1002001015, '账号未登陆', '2019-06-05 10:18:45');
INSERT INTO `access_log` VALUES (28741, '65.53.15597011308248631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:18:51', 201, 0, '', '2019-06-05 10:18:51');
INSERT INTO `access_log` VALUES (28742, '65.46.15597011312778659', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:18:51', 17, 0, '', '2019-06-05 10:18:51');
INSERT INTO `access_log` VALUES (28743, '65.3607.15597011312780431', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:18:51', 18, 0, '', '2019-06-05 10:18:51');
INSERT INTO `access_log` VALUES (28744, '65.51.15597011312778657', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:18:51', 18, 0, '', '2019-06-05 10:18:51');
INSERT INTO `access_log` VALUES (28745, '64.79.15597011366768263', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:18:57', 10, 0, '', '2019-06-05 10:18:57');
INSERT INTO `access_log` VALUES (28746, '64.84.15597011366778275', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:18:57', 12, 0, '', '2019-06-05 10:18:57');
INSERT INTO `access_log` VALUES (28747, '64.80.15597011390298263', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:18:59', 9, 0, '', '2019-06-05 10:18:59');
INSERT INTO `access_log` VALUES (28748, '64.76.15597011390298255', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:18:59', 11, 0, '', '2019-06-05 10:18:59');
INSERT INTO `access_log` VALUES (28749, '64.82.15597011464448279', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:19:06', 9, 0, '', '2019-06-05 10:19:06');
INSERT INTO `access_log` VALUES (28750, '65.3607.15597012429490433', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:20:43', 9, 0, '', '2019-06-05 10:20:43');
INSERT INTO `access_log` VALUES (28751, '65.46.15597012429508661', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:20:43', 9, 0, '', '2019-06-05 10:20:43');
INSERT INTO `access_log` VALUES (28752, '65.47.15597012429508665', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:20:43', 11, 0, '', '2019-06-05 10:20:43');
INSERT INTO `access_log` VALUES (28753, '64.80.15597012430768265', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:20:43', 540, 0, '', '2019-06-05 10:20:44');
INSERT INTO `access_log` VALUES (28754, '65.54.15597012548908627', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:20:55', 9, 0, '', '2019-06-05 10:20:55');
INSERT INTO `access_log` VALUES (28755, '65.50.15597012548928667', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:20:55', 8, 0, '', '2019-06-05 10:20:55');
INSERT INTO `access_log` VALUES (28756, '65.49.15597012548958687', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:20:55', 17, 0, '', '2019-06-05 10:20:55');
INSERT INTO `access_log` VALUES (28757, '64.81.15597012550478267', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:20:55', 9, 0, '', '2019-06-05 10:20:55');
INSERT INTO `access_log` VALUES (28758, '65.3607.15597014745460437', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.108.24.166', '2019-06-05 10:24:35', 0, 1002001015, '账号未登陆', '2019-06-05 10:24:35');
INSERT INTO `access_log` VALUES (28759, '65.46.15597014745468665', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.108.24.166', '2019-06-05 10:24:35', 0, 1002001015, '账号未登陆', '2019-06-05 10:24:35');
INSERT INTO `access_log` VALUES (28760, '65.52.15597014745548671', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.108.24.166', '2019-06-05 10:24:35', 0, 1002001015, '账号未登陆', '2019-06-05 10:24:35');
INSERT INTO `access_log` VALUES (28761, '65.54.15597014844498631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.108.24.166', '2019-06-05 10:24:44', 92, 0, '', '2019-06-05 10:24:45');
INSERT INTO `access_log` VALUES (28762, '65.49.15597014847298691', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.108.24.166', '2019-06-05 10:24:45', 8, 0, '', '2019-06-05 10:24:45');
INSERT INTO `access_log` VALUES (28763, '65.45.15597014847318681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.108.24.166', '2019-06-05 10:24:45', 7, 0, '', '2019-06-05 10:24:45');
INSERT INTO `access_log` VALUES (28764, '65.53.15597014847408639', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.108.24.166', '2019-06-05 10:24:45', 7, 0, '', '2019-06-05 10:24:45');
INSERT INTO `access_log` VALUES (28765, '62.82.15597015064078397', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.108.24.166', '2019-06-05 10:25:06', 15, 0, '', '2019-06-05 10:25:06');
INSERT INTO `access_log` VALUES (28766, '59.78.15597015223148545', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.108.24.166', '2019-06-05 10:25:22', 12, 0, '', '2019-06-05 10:25:22');
INSERT INTO `access_log` VALUES (28767, '65.3607.15597015241590439', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.108.24.166', '2019-06-05 10:25:24', 19, 0, '', '2019-06-05 10:25:24');
INSERT INTO `access_log` VALUES (28768, '59.71.15597024885918559', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:41:29', 12, 2001001000, '服务端发生异常', '2019-06-05 10:41:29');
INSERT INTO `access_log` VALUES (28769, '59.76.15597024885918547', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:41:29', 147, 0, '', '2019-06-05 10:41:29');
INSERT INTO `access_log` VALUES (28770, '64.78.15597025035358293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:41:44', 2, 0, '', '2019-06-05 10:41:44');
INSERT INTO `access_log` VALUES (28771, '64.85.15597025036688305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:41:44', 2, 0, '', '2019-06-05 10:41:44');
INSERT INTO `access_log` VALUES (28772, '66.54.15597025058417159', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:41:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空', '2019-06-05 10:41:46');
INSERT INTO `access_log` VALUES (28773, '64.84.15597025080498295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:41:48', 2, 0, '', '2019-06-05 10:41:48');
INSERT INTO `access_log` VALUES (28774, '64.79.15597025081948283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:41:48', 2, 0, '', '2019-06-05 10:41:48');
INSERT INTO `access_log` VALUES (28775, '64.80.15597025095018283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:41:50', 2, 0, '', '2019-06-05 10:41:50');
INSERT INTO `access_log` VALUES (28776, '64.76.15597025101518275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:41:50', 2, 0, '', '2019-06-05 10:41:50');
INSERT INTO `access_log` VALUES (28777, '65.47.15597025216468685', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:02', 1, 1002001015, '账号未登陆', '2019-06-05 10:42:02');
INSERT INTO `access_log` VALUES (28778, '65.51.15597025216468679', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:02', 1, 1002001015, '账号未登陆', '2019-06-05 10:42:02');
INSERT INTO `access_log` VALUES (28779, '65.46.15597025216468681', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:02', 0, 1002001015, '账号未登陆', '2019-06-05 10:42:02');
INSERT INTO `access_log` VALUES (28780, '64.83.15597025304448281', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:42:10', 10, 0, '', '2019-06-05 10:42:10');
INSERT INTO `access_log` VALUES (28781, '64.77.15597025304448295', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:42:10', 12, 0, '', '2019-06-05 10:42:10');
INSERT INTO `access_log` VALUES (28782, '65.52.15597025318148687', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 10:42:12');
INSERT INTO `access_log` VALUES (28783, '64.85.15597025334208307', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:42:13', 11, 0, '', '2019-06-05 10:42:13');
INSERT INTO `access_log` VALUES (28784, '64.78.15597025334198295', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:42:13', 13, 0, '', '2019-06-05 10:42:13');
INSERT INTO `access_log` VALUES (28785, '64.84.15597025334658297', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 10:42:13', 9, 0, '', '2019-06-05 10:42:13');
INSERT INTO `access_log` VALUES (28786, '65.50.15597025349208687', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:15', 205, 0, '', '2019-06-05 10:42:15');
INSERT INTO `access_log` VALUES (28787, '65.54.15597025354058647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:15', 9, 0, '', '2019-06-05 10:42:15');
INSERT INTO `access_log` VALUES (28788, '65.49.15597025354058707', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:15', 10, 0, '', '2019-06-05 10:42:15');
INSERT INTO `access_log` VALUES (28789, '65.45.15597025354298697', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:15', 9, 0, '', '2019-06-05 10:42:15');
INSERT INTO `access_log` VALUES (28790, '62.89.15597025430228411', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:23', 13, 0, '', '2019-06-05 10:42:23');
INSERT INTO `access_log` VALUES (28791, '64.80.15597025475858285', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:28', 10, 0, '', '2019-06-05 10:42:28');
INSERT INTO `access_log` VALUES (28792, '64.76.15597025475908277', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:28', 8, 0, '', '2019-06-05 10:42:28');
INSERT INTO `access_log` VALUES (28793, '64.81.15597025506428287', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:31', 11, 0, '', '2019-06-05 10:42:31');
INSERT INTO `access_log` VALUES (28794, '64.82.15597025506488301', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:31', 7, 0, '', '2019-06-05 10:42:31');
INSERT INTO `access_log` VALUES (28795, '64.77.15597025549798297', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:35', 8, 0, '', '2019-06-05 10:42:35');
INSERT INTO `access_log` VALUES (28796, '64.83.15597025549778283', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:35', 11, 0, '', '2019-06-05 10:42:35');
INSERT INTO `access_log` VALUES (28797, '66.48.15597025574647165', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:37', 20, 0, '', '2019-06-05 10:42:37');
INSERT INTO `access_log` VALUES (28798, '59.75.15597025635008557', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:44', 13, 0, '', '2019-06-05 10:42:44');
INSERT INTO `access_log` VALUES (28799, '59.73.15597025671538559', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:47', 12, 0, '', '2019-06-05 10:42:47');
INSERT INTO `access_log` VALUES (28800, '65.51.15597025715058681', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:52', 19, 0, '', '2019-06-05 10:42:52');
INSERT INTO `access_log` VALUES (28801, '65.46.15597025722748683', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:52', 10, 0, '', '2019-06-05 10:42:52');
INSERT INTO `access_log` VALUES (28802, '65.3607.15597025729640455', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:53', 16, 0, '', '2019-06-05 10:42:53');
INSERT INTO `access_log` VALUES (28803, '65.52.15597025738828689', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.186.96', '2019-06-05 10:42:54', 111, 0, '', '2019-06-05 10:42:54');
INSERT INTO `access_log` VALUES (28804, '59.80.15597026958688549', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.32.153.243', '2019-06-05 10:44:56', 3, 0, '', '2019-06-05 10:44:56');
INSERT INTO `access_log` VALUES (28805, '59.73.15597026958688561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.32.153.243', '2019-06-05 10:44:56', 13, 2001001000, '服务端发生异常', '2019-06-05 10:44:56');
INSERT INTO `access_log` VALUES (28806, '65.51.15597028133278685', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:46:53', 1, 1002001015, '账号未登陆', '2019-06-05 10:46:53');
INSERT INTO `access_log` VALUES (28807, '65.3607.15597028133380459', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:46:53', 0, 1002001015, '账号未登陆', '2019-06-05 10:46:53');
INSERT INTO `access_log` VALUES (28808, '65.46.15597028133308687', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:46:53', 8, 1002001015, '账号未登陆', '2019-06-05 10:46:53');
INSERT INTO `access_log` VALUES (28809, '65.52.15597028153938693', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:46:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 10:46:55');
INSERT INTO `access_log` VALUES (28810, '65.49.15597028269038713', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:07', 87, 0, '', '2019-06-05 10:47:07');
INSERT INTO `access_log` VALUES (28811, '65.54.15597028272088653', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:07', 9, 0, '', '2019-06-05 10:47:07');
INSERT INTO `access_log` VALUES (28812, '65.45.15597028272098703', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:07', 9, 0, '', '2019-06-05 10:47:07');
INSERT INTO `access_log` VALUES (28813, '65.53.15597028272138661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:07', 9, 0, '', '2019-06-05 10:47:07');
INSERT INTO `access_log` VALUES (28814, '62.89.15597028317438415', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:12', 12, 0, '', '2019-06-05 10:47:12');
INSERT INTO `access_log` VALUES (28815, '64.78.15597028343598301', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:14', 9, 0, '', '2019-06-05 10:47:14');
INSERT INTO `access_log` VALUES (28816, '64.77.15597028343578301', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:14', 12, 0, '', '2019-06-05 10:47:14');
INSERT INTO `access_log` VALUES (28817, '64.84.15597028408828303', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:21', 9, 0, '', '2019-06-05 10:47:21');
INSERT INTO `access_log` VALUES (28818, '59.71.15597028435538565', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:24', 19, 0, '', '2019-06-05 10:47:24');
INSERT INTO `access_log` VALUES (28819, '65.51.15597028465908687', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:27', 19, 0, '', '2019-06-05 10:47:27');
INSERT INTO `access_log` VALUES (28820, '65.46.15597028481938689', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:28', 10, 0, '', '2019-06-05 10:47:28');
INSERT INTO `access_log` VALUES (28821, '65.50.15597028491658695', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:29', 7, 0, '', '2019-06-05 10:47:29');
INSERT INTO `access_log` VALUES (28822, '65.52.15597028500948695', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:30', 12, 0, '', '2019-06-05 10:47:30');
INSERT INTO `access_log` VALUES (28823, '62.80.15597028622908417', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:42', 15, 0, '', '2019-06-05 10:47:42');
INSERT INTO `access_log` VALUES (28824, '62.87.15597028683468403', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:47:48', 14, 0, '', '2019-06-05 10:47:48');
INSERT INTO `access_log` VALUES (28825, '62.82.15597028999648417', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:48:20', 74, 0, '', '2019-06-05 10:48:20');
INSERT INTO `access_log` VALUES (28826, '66.53.15597029043377161', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:48:24', 14, 0, '', '2019-06-05 10:48:24');
INSERT INTO `access_log` VALUES (28827, '59.78.15597029085608565', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:48:29', 11, 0, '', '2019-06-05 10:48:29');
INSERT INTO `access_log` VALUES (28828, '65.47.15597029113878695', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:48:31', 0, 1002001015, '账号未登陆', '2019-06-05 10:48:31');
INSERT INTO `access_log` VALUES (28829, '65.3607.15597029113890463', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:48:31', 1, 1002001015, '账号未登陆', '2019-06-05 10:48:31');
INSERT INTO `access_log` VALUES (28830, '65.51.15597029113948689', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:48:31', 0, 1002001015, '账号未登陆', '2019-06-05 10:48:31');
INSERT INTO `access_log` VALUES (28831, '59.75.15597029150448563', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:48:35', 2, 0, '', '2019-06-05 10:48:35');
INSERT INTO `access_log` VALUES (28832, '59.80.15597029150448553', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:48:35', 10, 2001001000, '服务端发生异常', '2019-06-05 10:48:35');
INSERT INTO `access_log` VALUES (28833, '64.83.15597029194328289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:48:39', 2, 0, '', '2019-06-05 10:48:39');
INSERT INTO `access_log` VALUES (28834, '64.77.15597029195858303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:48:40', 1, 0, '', '2019-06-05 10:48:40');
INSERT INTO `access_log` VALUES (28835, '64.78.15597029219778303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:48:42', 2, 0, '', '2019-06-05 10:48:42');
INSERT INTO `access_log` VALUES (28836, '64.85.15597029229378315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.255.127.55', '2019-06-05 10:48:43', 2, 0, '', '2019-06-05 10:48:43');
INSERT INTO `access_log` VALUES (28837, '59.71.15597029288948567', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:48:49', 13, 2001001000, '服务端发生异常', '2019-06-05 10:48:49');
INSERT INTO `access_log` VALUES (28838, '59.73.15597029288938565', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:48:49', 77, 0, '', '2019-06-05 10:48:49');
INSERT INTO `access_log` VALUES (28839, '66.50.15597029346407159', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:48:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空', '2019-06-05 10:48:55');
INSERT INTO `access_log` VALUES (28840, '59.77.15597029444448555', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:04', 2, 0, '', '2019-06-05 10:49:04');
INSERT INTO `access_log` VALUES (28841, '59.79.15597029444458563', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:04', 20, 2001001000, '服务端发生异常', '2019-06-05 10:49:04');
INSERT INTO `access_log` VALUES (28842, '64.80.15597029478068293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:08', 2, 0, '', '2019-06-05 10:49:08');
INSERT INTO `access_log` VALUES (28843, '64.76.15597029479198285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:08', 2, 0, '', '2019-06-05 10:49:08');
INSERT INTO `access_log` VALUES (28844, '64.82.15597029493718309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:09', 2, 0, '', '2019-06-05 10:49:09');
INSERT INTO `access_log` VALUES (28845, '64.81.15597029502258295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:10', 2, 0, '', '2019-06-05 10:49:10');
INSERT INTO `access_log` VALUES (28846, '64.83.15597029513268291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:11', 2, 0, '', '2019-06-05 10:49:11');
INSERT INTO `access_log` VALUES (28847, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:11', 8, 0, '', '2019-06-05 10:49:11');
INSERT INTO `access_log` VALUES (28848, '64.77.15597029533578305', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:13', 141, 0, '', '2019-06-05 10:49:14');
INSERT INTO `access_log` VALUES (28849, '66.51.15597029599927161', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:20', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位', '2019-06-05 10:49:20');
INSERT INTO `access_log` VALUES (28850, '64.85.15597029683558317', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:28', 5, 0, '', '2019-06-05 10:49:28');
INSERT INTO `access_log` VALUES (28851, '64.84.15597029745438307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:35', 3, 0, '', '2019-06-05 10:49:35');
INSERT INTO `access_log` VALUES (28852, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:35', 7, 0, '', '2019-06-05 10:49:35');
INSERT INTO `access_log` VALUES (28853, '64.80.15597029812658295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:41', 84, 0, '', '2019-06-05 10:49:41');
INSERT INTO `access_log` VALUES (28854, '64.76.15597029814768287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:41', 2, 0, '', '2019-06-05 10:49:41');
INSERT INTO `access_log` VALUES (28855, '64.82.15597029826438311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:43', 2, 0, '', '2019-06-05 10:49:43');
INSERT INTO `access_log` VALUES (28856, '64.81.15597029832678297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:43', 2, 0, '', '2019-06-05 10:49:43');
INSERT INTO `access_log` VALUES (28857, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:48', 8, 0, '', '2019-06-05 10:49:48');
INSERT INTO `access_log` VALUES (28858, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=java', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:48', 12, 0, '', '2019-06-05 10:49:48');
INSERT INTO `access_log` VALUES (28859, '64.83.15597029900438293', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.255.127.55', '2019-06-05 10:49:50', 7, 0, '', '2019-06-05 10:49:50');
INSERT INTO `access_log` VALUES (28860, '65.46.15597029947688693', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:49:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 10:49:55');
INSERT INTO `access_log` VALUES (28861, '65.50.15597030066728699', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:50:07', 108, 0, '', '2019-06-05 10:50:07');
INSERT INTO `access_log` VALUES (28862, '65.52.15597030069788697', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:50:07', 9, 0, '', '2019-06-05 10:50:07');
INSERT INTO `access_log` VALUES (28863, '65.49.15597030069818717', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:50:07', 12, 0, '', '2019-06-05 10:50:07');
INSERT INTO `access_log` VALUES (28864, '65.45.15597030069958709', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:50:07', 8, 0, '', '2019-06-05 10:50:07');
INSERT INTO `access_log` VALUES (28865, '62.82.15597030126048419', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:50:13', 16, 0, '', '2019-06-05 10:50:13');
INSERT INTO `access_log` VALUES (28866, '65.53.15597030131028667', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:50:13', 0, 1002001015, '账号未登陆', '2019-06-05 10:50:13');
INSERT INTO `access_log` VALUES (28867, '65.47.15597030131068699', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:50:13', 0, 1002001015, '账号未登陆', '2019-06-05 10:50:13');
INSERT INTO `access_log` VALUES (28868, '65.3607.15597030131090467', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:50:13', 0, 1002001015, '账号未登陆', '2019-06-05 10:50:13');
INSERT INTO `access_log` VALUES (28869, '59.73.15597030157168567', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:50:16', 11, 0, '', '2019-06-05 10:50:16');
INSERT INTO `access_log` VALUES (28870, '65.51.15597030171568693', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:50:17', 164, 0, '', '2019-06-05 10:50:17');
INSERT INTO `access_log` VALUES (28871, '65.46.15597030175838695', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:50:18', 8, 0, '', '2019-06-05 10:50:18');
INSERT INTO `access_log` VALUES (28872, '65.50.15597030179648701', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:50:18', 9, 0, '', '2019-06-05 10:50:18');
INSERT INTO `access_log` VALUES (28873, '65.49.15597030183358719', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:50:18', 13, 0, '', '2019-06-05 10:50:18');
INSERT INTO `access_log` VALUES (28874, '59.76.15597030199508557', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:50:20', 10, 0, '', '2019-06-05 10:50:20');
INSERT INTO `access_log` VALUES (28875, '59.72.15597030212688563', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:50:21', 20, 2001001000, '服务端发生异常', '2019-06-05 10:50:21');
INSERT INTO `access_log` VALUES (28876, '65.52.15597030220428699', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:50:22', 80, 0, '', '2019-06-05 10:50:22');
INSERT INTO `access_log` VALUES (28877, '65.45.15597030223088711', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:50:22', 9, 0, '', '2019-06-05 10:50:22');
INSERT INTO `access_log` VALUES (28878, '65.54.15597030223118661', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:50:22', 9, 0, '', '2019-06-05 10:50:22');
INSERT INTO `access_log` VALUES (28879, '65.47.15597030223158701', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:50:22', 9, 0, '', '2019-06-05 10:50:22');
INSERT INTO `access_log` VALUES (28880, '59.79.15597030227268565', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:50:23', 11, 0, '', '2019-06-05 10:50:23');
INSERT INTO `access_log` VALUES (28881, '59.77.15597030243528557', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.200.231.2', '2019-06-05 10:50:24', 9, 0, '', '2019-06-05 10:50:24');
INSERT INTO `access_log` VALUES (28882, '64.79.15597030473478297', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:50:47', 11, 0, '', '2019-06-05 10:50:47');
INSERT INTO `access_log` VALUES (28883, '64.80.15597030473518297', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:50:47', 9, 0, '', '2019-06-05 10:50:47');
INSERT INTO `access_log` VALUES (28884, '66.50.15597030545467161', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:50:55', 13, 0, '', '2019-06-05 10:50:55');
INSERT INTO `access_log` VALUES (28885, '59.75.15597030566108567', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:50:57', 10, 0, '', '2019-06-05 10:50:57');
INSERT INTO `access_log` VALUES (28886, '64.81.15597030629328299', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:51:03', 9, 0, '', '2019-06-05 10:51:03');
INSERT INTO `access_log` VALUES (28887, '64.82.15597030629248313', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:51:03', 11, 0, '', '2019-06-05 10:51:03');
INSERT INTO `access_log` VALUES (28888, '64.77.15597030652978309', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:51:05', 10, 0, '', '2019-06-05 10:51:05');
INSERT INTO `access_log` VALUES (28889, '64.78.15597030652998309', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:51:05', 8, 0, '', '2019-06-05 10:51:05');
INSERT INTO `access_log` VALUES (28890, '64.83.15597030652978295', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:51:05', 15, 0, '', '2019-06-05 10:51:05');
INSERT INTO `access_log` VALUES (28891, '59.73.15597030772318569', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:51:17', 11, 0, '', '2019-06-05 10:51:17');
INSERT INTO `access_log` VALUES (28892, '65.49.15597030941728721', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.144.195', '2019-06-05 10:51:34', 8, 0, '', '2019-06-05 10:51:34');
INSERT INTO `access_log` VALUES (28893, '65.3607.15597033084110473', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-05 10:55:08', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 10:55:08');
INSERT INTO `access_log` VALUES (28894, '65.51.15597033118158699', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-05 10:55:12', 220, 0, '', '2019-06-05 10:55:12');
INSERT INTO `access_log` VALUES (28895, '65.46.15597033124318701', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-05 10:55:12', 9, 0, '', '2019-06-05 10:55:12');
INSERT INTO `access_log` VALUES (28896, '65.50.15597033124348707', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-05 10:55:12', 9, 0, '', '2019-06-05 10:55:12');
INSERT INTO `access_log` VALUES (28897, '65.49.15597033124708725', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-05 10:55:12', 9, 0, '', '2019-06-05 10:55:12');
INSERT INTO `access_log` VALUES (28898, '66.54.15597033160557171', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.163.60', '2019-06-05 10:55:16', 13, 0, '', '2019-06-05 10:55:16');
INSERT INTO `access_log` VALUES (28899, '64.82.15597037393638323', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:02:19', 12, 0, '', '2019-06-05 11:02:19');
INSERT INTO `access_log` VALUES (28900, '64.80.15597039672368311', 27, 2, 'product-application', '/product-api/admins/category/add', 'name=手机&pid=579&sort=1&description=qwerqew', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:06:07', 9, 1002002009, NULL, '2019-06-05 11:06:07');
INSERT INTO `access_log` VALUES (28901, '59.76.15597039856948571', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.10', '2019-06-05 11:06:26', 3, 0, '', '2019-06-05 11:06:26');
INSERT INTO `access_log` VALUES (28902, '59.72.15597039857028577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.11', '2019-06-05 11:06:26', 12, 2001001000, '服务端发生异常', '2019-06-05 11:06:26');
INSERT INTO `access_log` VALUES (28903, '64.76.15597039887758303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.11', '2019-06-05 11:06:29', 3, 0, '', '2019-06-05 11:06:29');
INSERT INTO `access_log` VALUES (28904, '64.82.15597039889118327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.11', '2019-06-05 11:06:29', 2, 0, '', '2019-06-05 11:06:29');
INSERT INTO `access_log` VALUES (28905, '64.81.15597039924298313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.11', '2019-06-05 11:06:32', 2, 0, '', '2019-06-05 11:06:32');
INSERT INTO `access_log` VALUES (28906, '64.78.15597039925278323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.11', '2019-06-05 11:06:33', 2, 0, '', '2019-06-05 11:06:33');
INSERT INTO `access_log` VALUES (28907, '59.77.15597039936678571', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.11', '2019-06-05 11:06:34', 3, 0, '', '2019-06-05 11:06:34');
INSERT INTO `access_log` VALUES (28908, '59.79.15597039936678579', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.10', '2019-06-05 11:06:34', 13, 2001001000, '服务端发生异常', '2019-06-05 11:06:34');
INSERT INTO `access_log` VALUES (28909, '65.51.15597040016308709', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.10', '2019-06-05 11:06:42', 0, 1002001015, '账号未登陆', '2019-06-05 11:06:42');
INSERT INTO `access_log` VALUES (28910, '65.50.15597040016338717', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.11', '2019-06-05 11:06:42', 1, 1002001015, '账号未登陆', '2019-06-05 11:06:42');
INSERT INTO `access_log` VALUES (28911, '65.46.15597040016398711', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.11', '2019-06-05 11:06:42', 0, 1002001015, '账号未登陆', '2019-06-05 11:06:42');
INSERT INTO `access_log` VALUES (28912, '65.49.15597040063568735', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.11', '2019-06-05 11:06:46', 89, 0, '', '2019-06-05 11:06:46');
INSERT INTO `access_log` VALUES (28913, '65.45.15597040066998727', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.11', '2019-06-05 11:06:47', 8, 0, '', '2019-06-05 11:06:47');
INSERT INTO `access_log` VALUES (28914, '65.52.15597040066988715', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.10', '2019-06-05 11:06:47', 10, 0, '', '2019-06-05 11:06:47');
INSERT INTO `access_log` VALUES (28915, '65.47.15597040067008717', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.10', '2019-06-05 11:06:47', 9, 0, '', '2019-06-05 11:06:47');
INSERT INTO `access_log` VALUES (28916, '62.86.15597040111898417', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.10', '2019-06-05 11:06:51', 11, 0, '', '2019-06-05 11:06:51');
INSERT INTO `access_log` VALUES (28917, '66.49.15597040159267187', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.11', '2019-06-05 11:06:56', 23, 0, '', '2019-06-05 11:06:56');
INSERT INTO `access_log` VALUES (28918, '62.83.15597040198728431', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.38.11', '2019-06-05 11:07:00', 11, 0, '', '2019-06-05 11:07:00');
INSERT INTO `access_log` VALUES (28919, '65.51.15597040472628711', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:07:27', 4, 1002001012, '访问令牌已过期', '2019-06-05 11:07:27');
INSERT INTO `access_log` VALUES (28920, '65.50.15597040472658719', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:07:27', 3, 1002001012, '访问令牌已过期', '2019-06-05 11:07:27');
INSERT INTO `access_log` VALUES (28921, '65.46.15597040473128713', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:07:27', 3, 1002001012, '访问令牌已过期', '2019-06-05 11:07:27');
INSERT INTO `access_log` VALUES (28922, '64.80.15597040474198313', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:07:27', 6, 1002001012, '访问令牌已过期', '2019-06-05 11:07:27');
INSERT INTO `access_log` VALUES (28923, '65.49.15597040517228737', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:07:32', 79, 0, '', '2019-06-05 11:07:32');
INSERT INTO `access_log` VALUES (28924, '65.52.15597040520838717', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:07:32', 9, 0, '', '2019-06-05 11:07:32');
INSERT INTO `access_log` VALUES (28925, '65.47.15597040520848719', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:07:32', 8, 0, '', '2019-06-05 11:07:32');
INSERT INTO `access_log` VALUES (28926, '65.45.15597040520878729', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:07:32', 8, 0, '', '2019-06-05 11:07:32');
INSERT INTO `access_log` VALUES (28927, '64.80.15597043187468317', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:11:59', 16, 0, '', '2019-06-05 11:11:59');
INSERT INTO `access_log` VALUES (28928, '64.84.15597043187468329', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:11:59', 18, 0, '', '2019-06-05 11:11:59');
INSERT INTO `access_log` VALUES (28929, '64.79.15597043230508317', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:12:03', 11, 0, '', '2019-06-05 11:12:03');
INSERT INTO `access_log` VALUES (28930, '64.81.15597043379258319', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:12:18', 93, 0, '', '2019-06-05 11:12:18');
INSERT INTO `access_log` VALUES (28931, '64.82.15597043379258333', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:12:18', 95, 0, '', '2019-06-05 11:12:18');
INSERT INTO `access_log` VALUES (28932, '64.83.15597043415268315', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:12:22', 16, 0, '', '2019-06-05 11:12:22');
INSERT INTO `access_log` VALUES (28933, '64.77.15597043415268329', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:12:22', 18, 0, '', '2019-06-05 11:12:22');
INSERT INTO `access_log` VALUES (28934, '64.85.15597043517328341', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1&cid=784', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:12:32', 9, 0, '', '2019-06-05 11:12:32');
INSERT INTO `access_log` VALUES (28935, '64.84.15597043574248331', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1&cid=783', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:12:37', 11, 0, '', '2019-06-05 11:12:37');
INSERT INTO `access_log` VALUES (28936, '59.73.15597044860008589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:14:46', 12, 2001001000, '服务端发生异常', '2019-06-05 11:14:46');
INSERT INTO `access_log` VALUES (28937, '59.80.15597044859998577', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:14:46', 193, 0, '', '2019-06-05 11:14:46');
INSERT INTO `access_log` VALUES (28938, '65.46.15597044964098721', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:14:56', 0, 1002001015, '账号未登陆', '2019-06-05 11:14:56');
INSERT INTO `access_log` VALUES (28939, '65.50.15597044964098727', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:14:56', 1, 1002001015, '账号未登陆', '2019-06-05 11:14:56');
INSERT INTO `access_log` VALUES (28940, '65.49.15597044964128745', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:14:56', 0, 1002001015, '账号未登陆', '2019-06-05 11:14:56');
INSERT INTO `access_log` VALUES (28941, '65.45.15597045012428737', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:15:01', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 11:15:01');
INSERT INTO `access_log` VALUES (28942, '65.54.15597045126638685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:15:13', 1776, 0, '', '2019-06-05 11:15:14');
INSERT INTO `access_log` VALUES (28943, '65.52.15597045148128725', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:15:15', 9, 0, '', '2019-06-05 11:15:15');
INSERT INTO `access_log` VALUES (28944, '65.3607.15597045148150495', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:15:15', 9, 0, '', '2019-06-05 11:15:15');
INSERT INTO `access_log` VALUES (28945, '65.53.15597045148148695', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:15:15', 9, 0, '', '2019-06-05 11:15:15');
INSERT INTO `access_log` VALUES (28946, '62.88.15597045186958445', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:15:19', 13, 0, '', '2019-06-05 11:15:19');
INSERT INTO `access_log` VALUES (28947, '59.77.15597045228738579', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:15:23', 11, 0, '', '2019-06-05 11:15:23');
INSERT INTO `access_log` VALUES (28948, '59.79.15597045246098587', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:15:25', 27, 2001001000, '服务端发生异常', '2019-06-05 11:15:25');
INSERT INTO `access_log` VALUES (28949, '65.49.15597045260438747', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:15:26', 18, 0, '', '2019-06-05 11:15:26');
INSERT INTO `access_log` VALUES (28950, '65.50.15597045268288729', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:15:27', 10, 0, '', '2019-06-05 11:15:27');
INSERT INTO `access_log` VALUES (28951, '65.46.15597045284598723', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:15:28', 9, 0, '', '2019-06-05 11:15:28');
INSERT INTO `access_log` VALUES (28952, '65.45.15597045346638739', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:15:35', 14, 0, '', '2019-06-05 11:15:35');
INSERT INTO `access_log` VALUES (28953, '59.75.15597045628238589', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:16:03', 11, 0, '', '2019-06-05 11:16:03');
INSERT INTO `access_log` VALUES (28954, '59.80.15597045660838579', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:16:06', 20, 2001001000, '服务端发生异常', '2019-06-05 11:16:06');
INSERT INTO `access_log` VALUES (28955, '59.71.15597045678858593', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:16:08', 12, 0, '', '2019-06-05 11:16:08');
INSERT INTO `access_log` VALUES (28956, '59.76.15597045703568581', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:16:10', 10, 0, '', '2019-06-05 11:16:10');
INSERT INTO `access_log` VALUES (28957, '64.85.15597045989948345', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:16:39', 55, 0, '', '2019-06-05 11:16:39');
INSERT INTO `access_log` VALUES (28958, '64.80.15597045989948323', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:16:39', 68, 0, '', '2019-06-05 11:16:39');
INSERT INTO `access_log` VALUES (28959, '64.83.15597045989948319', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 11:16:39', 72, 0, '', '2019-06-05 11:16:39');
INSERT INTO `access_log` VALUES (28960, '59.78.15597046205918593', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:17:01', 17, 2001001000, '服务端发生异常', '2019-06-05 11:17:01');
INSERT INTO `access_log` VALUES (28961, '59.74.15597046234378587', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:17:03', 13, 0, '', '2019-06-05 11:17:03');
INSERT INTO `access_log` VALUES (28962, '64.81.15597046439098325', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:17:24', 9, 0, '', '2019-06-05 11:17:24');
INSERT INTO `access_log` VALUES (28963, '65.52.15597046745888727', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:17:55', 10, 0, '', '2019-06-05 11:17:55');
INSERT INTO `access_log` VALUES (28964, '65.51.15597046745908725', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:17:55', 9, 0, '', '2019-06-05 11:17:55');
INSERT INTO `access_log` VALUES (28965, '65.49.15597046745948751', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:17:55', 10, 0, '', '2019-06-05 11:17:55');
INSERT INTO `access_log` VALUES (28966, '59.76.15597046746578583', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:17:55', 32, 2001001000, '服务端发生异常', '2019-06-05 11:17:55');
INSERT INTO `access_log` VALUES (28967, '59.72.15597046786428589', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:17:59', 11, 0, '', '2019-06-05 11:17:59');
INSERT INTO `access_log` VALUES (28968, '59.77.15597046806458583', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:18:01', 11, 0, '', '2019-06-05 11:18:01');
INSERT INTO `access_log` VALUES (28969, '59.78.15597046856868595', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:18:06', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-05 11:18:06');
INSERT INTO `access_log` VALUES (28970, '62.81.15597046896488421', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:18:10', 14, 0, '', '2019-06-05 11:18:10');
INSERT INTO `access_log` VALUES (28971, '62.82.15597046912498445', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:18:11', 14, 0, '', '2019-06-05 11:18:11');
INSERT INTO `access_log` VALUES (28972, '64.80.15597046935488325', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:18:14', 10, 0, '', '2019-06-05 11:18:14');
INSERT INTO `access_log` VALUES (28973, '64.85.15597046935488347', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:18:14', 12, 0, '', '2019-06-05 11:18:14');
INSERT INTO `access_log` VALUES (28974, '64.84.15597047152608337', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:18:35', 10, 0, '', '2019-06-05 11:18:35');
INSERT INTO `access_log` VALUES (28975, '62.81.15597047886368425', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:19:49', 11, 0, '', '2019-06-05 11:19:49');
INSERT INTO `access_log` VALUES (28976, '62.82.15597047907658449', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:19:51', 13, 0, '', '2019-06-05 11:19:51');
INSERT INTO `access_log` VALUES (28977, '62.89.15597047929078447', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.232.159.165', '2019-06-05 11:19:53', 13, 0, '', '2019-06-05 11:19:53');
INSERT INTO `access_log` VALUES (28978, '59.73.15597050220678599', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.62.236.114', '2019-06-05 11:23:42', 3, 0, '', '2019-06-05 11:23:42');
INSERT INTO `access_log` VALUES (28979, '59.80.15597050220678587', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '183.62.236.114', '2019-06-05 11:23:42', 9, 2001001000, '服务端发生异常', '2019-06-05 11:23:42');
INSERT INTO `access_log` VALUES (28980, '65.3607.15597052099690505', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.213.26', '2019-06-05 11:26:50', 4, 1002001012, '访问令牌已过期', '2019-06-05 11:26:50');
INSERT INTO `access_log` VALUES (28981, '65.53.15597052099728705', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.213.26', '2019-06-05 11:26:50', 3, 1002001012, '访问令牌已过期', '2019-06-05 11:26:50');
INSERT INTO `access_log` VALUES (28982, '65.51.15597052099898733', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.213.26', '2019-06-05 11:26:50', 3, 1002001012, '访问令牌已过期', '2019-06-05 11:26:50');
INSERT INTO `access_log` VALUES (28983, '65.52.15597052117608735', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.213.26', '2019-06-05 11:26:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 11:26:52');
INSERT INTO `access_log` VALUES (28984, '65.3607.15597053015490507', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:28:22', 4, 1002001012, '访问令牌已过期', '2019-06-05 11:28:22');
INSERT INTO `access_log` VALUES (28985, '65.53.15597053015518707', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:28:22', 3, 1002001012, '访问令牌已过期', '2019-06-05 11:28:22');
INSERT INTO `access_log` VALUES (28986, '65.51.15597053015588735', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:28:22', 3, 1002001012, '访问令牌已过期', '2019-06-05 11:28:22');
INSERT INTO `access_log` VALUES (28987, '64.79.15597053017968333', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:28:22', 13, 1002001012, '访问令牌已过期', '2019-06-05 11:28:22');
INSERT INTO `access_log` VALUES (28988, '64.76.15597053018008325', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:28:22', 12, 1002001012, '访问令牌已过期', '2019-06-05 11:28:22');
INSERT INTO `access_log` VALUES (28989, '65.49.15597053063738761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:28:26', 71, 0, '', '2019-06-05 11:28:26');
INSERT INTO `access_log` VALUES (28990, '65.50.15597053067888743', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:28:27', 95, 0, '', '2019-06-05 11:28:27');
INSERT INTO `access_log` VALUES (28991, '65.45.15597053068008753', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:28:27', 84, 0, '', '2019-06-05 11:28:27');
INSERT INTO `access_log` VALUES (28992, '65.46.15597053067968737', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:28:27', 88, 0, '', '2019-06-05 11:28:27');
INSERT INTO `access_log` VALUES (28993, '64.82.15597053146728349', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:28:35', 9, 0, '', '2019-06-05 11:28:35');
INSERT INTO `access_log` VALUES (28994, '64.81.15597053146698335', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:28:35', 12, 0, '', '2019-06-05 11:28:35');
INSERT INTO `access_log` VALUES (28995, '65.47.15597053179168741', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.55.41', '2019-06-05 11:28:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 11:28:38');
INSERT INTO `access_log` VALUES (28996, '64.85.15597054769168359', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:17', 9, 0, '', '2019-06-05 11:31:17');
INSERT INTO `access_log` VALUES (28997, '64.77.15597054769158347', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:17', 12, 0, '', '2019-06-05 11:31:17');
INSERT INTO `access_log` VALUES (28998, '64.84.15597054785048349', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:19', 17, 0, '', '2019-06-05 11:31:19');
INSERT INTO `access_log` VALUES (28999, '64.83.15597054785028333', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:19', 19, 0, '', '2019-06-05 11:31:19');
INSERT INTO `access_log` VALUES (29000, '64.80.15597054785018337', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:19', 24, 0, '', '2019-06-05 11:31:19');
INSERT INTO `access_log` VALUES (29001, '64.82.15597054840188353', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:24', 53, 0, '', '2019-06-05 11:31:24');
INSERT INTO `access_log` VALUES (29002, '64.79.15597054840188337', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:24', 54, 0, '', '2019-06-05 11:31:24');
INSERT INTO `access_log` VALUES (29003, '64.78.15597054880608349', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:28', 7, 0, '', '2019-06-05 11:31:28');
INSERT INTO `access_log` VALUES (29004, '64.81.15597054880598339', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:28', 11, 0, '', '2019-06-05 11:31:28');
INSERT INTO `access_log` VALUES (29005, '64.80.15597054902378339', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:30', 8, 0, '', '2019-06-05 11:31:30');
INSERT INTO `access_log` VALUES (29006, '64.85.15597054902368361', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:30', 10, 0, '', '2019-06-05 11:31:30');
INSERT INTO `access_log` VALUES (29007, '64.77.15597054902368349', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:30', 13, 0, '', '2019-06-05 11:31:30');
INSERT INTO `access_log` VALUES (29008, '64.76.15597055094498331', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:49', 7, 0, '', '2019-06-05 11:31:49');
INSERT INTO `access_log` VALUES (29009, '64.83.15597055094478335', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:49', 9, 0, '', '2019-06-05 11:31:49');
INSERT INTO `access_log` VALUES (29010, '64.81.15597055140888341', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:54', 8, 0, '', '2019-06-05 11:31:54');
INSERT INTO `access_log` VALUES (29011, '64.78.15597055140878351', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:54', 10, 0, '', '2019-06-05 11:31:54');
INSERT INTO `access_log` VALUES (29012, '64.82.15597055140878355', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:31:54', 13, 0, '', '2019-06-05 11:31:54');
INSERT INTO `access_log` VALUES (29013, '64.77.15597055196248351', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:32:00', 9, 0, '', '2019-06-05 11:32:00');
INSERT INTO `access_log` VALUES (29014, '64.85.15597055196248363', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:32:00', 14, 0, '', '2019-06-05 11:32:00');
INSERT INTO `access_log` VALUES (29015, '64.80.15597055196248341', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:32:00', 16, 0, '', '2019-06-05 11:32:00');
INSERT INTO `access_log` VALUES (29016, '64.83.15597055227398337', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:32:03', 8, 0, '', '2019-06-05 11:32:03');
INSERT INTO `access_log` VALUES (29017, '64.84.15597055227398353', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:32:03', 10, 0, '', '2019-06-05 11:32:03');
INSERT INTO `access_log` VALUES (29018, '64.78.15597055261448353', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:32:06', 9, 0, '', '2019-06-05 11:32:06');
INSERT INTO `access_log` VALUES (29019, '64.81.15597055261468343', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:32:06', 6, 0, '', '2019-06-05 11:32:06');
INSERT INTO `access_log` VALUES (29020, '64.79.15597055261438341', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 11:32:06', 11, 0, '', '2019-06-05 11:32:06');
INSERT INTO `access_log` VALUES (29021, '65.49.15597057834368767', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-05 11:36:23', 85, 0, '', '2019-06-05 11:36:24');
INSERT INTO `access_log` VALUES (29022, '65.50.15597057842718749', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-05 11:36:24', 88, 0, '', '2019-06-05 11:36:24');
INSERT INTO `access_log` VALUES (29023, '65.46.15597057842728745', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-05 11:36:24', 89, 0, '', '2019-06-05 11:36:24');
INSERT INTO `access_log` VALUES (29024, '65.54.15597057842778709', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-05 11:36:24', 83, 0, '', '2019-06-05 11:36:24');
INSERT INTO `access_log` VALUES (29025, '62.81.15597057913638439', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-05 11:36:31', 13, 0, '', '2019-06-05 11:36:31');
INSERT INTO `access_log` VALUES (29026, '65.47.15597057974748749', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-05 11:36:37', 449, 0, '', '2019-06-05 11:36:38');
INSERT INTO `access_log` VALUES (29027, '65.52.15597057983298747', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-05 11:36:38', 10, 0, '', '2019-06-05 11:36:38');
INSERT INTO `access_log` VALUES (29028, '65.3607.15597057991660517', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-05 11:36:39', 8, 0, '', '2019-06-05 11:36:39');
INSERT INTO `access_log` VALUES (29029, '65.51.15597057999378747', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.176.217.33', '2019-06-05 11:36:40', 14, 0, '', '2019-06-05 11:36:40');
INSERT INTO `access_log` VALUES (29030, '59.78.15597061273478615', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.250', '2019-06-05 11:42:07', 12, 2001001000, '服务端发生异常', '2019-06-05 11:42:07');
INSERT INTO `access_log` VALUES (29031, '59.79.15597061273468611', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.250', '2019-06-05 11:42:07', 99, 0, '', '2019-06-05 11:42:07');
INSERT INTO `access_log` VALUES (29032, '64.82.15597061307348365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.250', '2019-06-05 11:42:11', 3, 0, '', '2019-06-05 11:42:11');
INSERT INTO `access_log` VALUES (29033, '64.77.15597061308648361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.250', '2019-06-05 11:42:11', 2, 0, '', '2019-06-05 11:42:11');
INSERT INTO `access_log` VALUES (29034, '64.80.15597061321768351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.250', '2019-06-05 11:42:12', 2, 0, '', '2019-06-05 11:42:12');
INSERT INTO `access_log` VALUES (29035, '64.85.15597061328368373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.137.55.250', '2019-06-05 11:42:13', 2, 0, '', '2019-06-05 11:42:13');
INSERT INTO `access_log` VALUES (29036, '59.73.15597063065918617', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.62.18.98', '2019-06-05 11:45:07', 3, 0, '', '2019-06-05 11:45:07');
INSERT INTO `access_log` VALUES (29037, '59.80.15597063066028605', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.62.18.98', '2019-06-05 11:45:07', 13, 2001001000, '服务端发生异常', '2019-06-05 11:45:07');
INSERT INTO `access_log` VALUES (29038, '64.81.15597063227998355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.62.18.98', '2019-06-05 11:45:23', 3, 0, '', '2019-06-05 11:45:23');
INSERT INTO `access_log` VALUES (29039, '64.79.15597063229548353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.62.18.98', '2019-06-05 11:45:23', 1, 0, '', '2019-06-05 11:45:23');
INSERT INTO `access_log` VALUES (29040, '64.78.15597063245728365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.62.18.98', '2019-06-05 11:45:25', 3, 0, '', '2019-06-05 11:45:25');
INSERT INTO `access_log` VALUES (29041, '64.82.15597063254028369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.62.18.98', '2019-06-05 11:45:25', 2, 0, '', '2019-06-05 11:45:25');
INSERT INTO `access_log` VALUES (29042, '64.77.15597063295788365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.62.18.98', '2019-06-05 11:45:30', 2, 0, '', '2019-06-05 11:45:30');
INSERT INTO `access_log` VALUES (29043, '64.80.15597063296808355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.62.18.98', '2019-06-05 11:45:30', 2, 0, '', '2019-06-05 11:45:30');
INSERT INTO `access_log` VALUES (29044, '66.51.15597063488147207', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15627236666&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.62.18.98', '2019-06-05 11:45:49', 19, 1001003000, '验证码不存在', '2019-06-05 11:45:49');
INSERT INTO `access_log` VALUES (29045, '66.56.15597063535857205', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15627236666&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.62.18.98', '2019-06-05 11:45:54', 132, 1001003000, '验证码不存在', '2019-06-05 11:45:54');
INSERT INTO `access_log` VALUES (29046, '64.84.15597063583618367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.62.18.98', '2019-06-05 11:45:58', 2, 0, '', '2019-06-05 11:45:58');
INSERT INTO `access_log` VALUES (29047, '64.76.15597063584568347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.62.18.98', '2019-06-05 11:45:58', 2, 0, '', '2019-06-05 11:45:58');
INSERT INTO `access_log` VALUES (29048, '59.79.15597063662538615', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.91.60.110', '2019-06-05 11:46:06', 3, 0, '', '2019-06-05 11:46:06');
INSERT INTO `access_log` VALUES (29049, '65.3607.15597063690830525', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.62.18.98', '2019-06-05 11:46:09', 1, 1002001015, '账号未登陆', '2019-06-05 11:46:09');
INSERT INTO `access_log` VALUES (29050, '65.51.15597063690848755', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.62.18.98', '2019-06-05 11:46:09', 0, 1002001015, '账号未登陆', '2019-06-05 11:46:09');
INSERT INTO `access_log` VALUES (29051, '65.49.15597063690898777', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.62.18.98', '2019-06-05 11:46:09', 1, 1002001015, '账号未登陆', '2019-06-05 11:46:09');
INSERT INTO `access_log` VALUES (29052, '65.45.15597063713938769', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.62.18.98', '2019-06-05 11:46:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 11:46:11');
INSERT INTO `access_log` VALUES (29053, '64.78.15597063822548367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.251', '2019-06-05 11:46:22', 2, 0, '', '2019-06-05 11:46:22');
INSERT INTO `access_log` VALUES (29054, '65.54.15597063830788719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.62.18.98', '2019-06-05 11:46:23', 204, 0, '', '2019-06-05 11:46:23');
INSERT INTO `access_log` VALUES (29055, '65.50.15597063972468759', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.62.18.98', '2019-06-05 11:46:37', 243, 0, '', '2019-06-05 11:46:37');
INSERT INTO `access_log` VALUES (29056, '65.51.15597064296728757', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.129.6.147', '2019-06-05 11:47:10', 1, 1002001015, '账号未登陆', '2019-06-05 11:47:10');
INSERT INTO `access_log` VALUES (29057, '59.76.15597067505228613', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:52:31', 3, 0, '', '2019-06-05 11:52:31');
INSERT INTO `access_log` VALUES (29058, '59.71.15597067505218625', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:52:31', 13, 2001001000, '服务端发生异常', '2019-06-05 11:52:31');
INSERT INTO `access_log` VALUES (29059, '66.48.15597067829677223', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=1234567894&code=9999', 'POST', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-06-05 11:53:03');
INSERT INTO `access_log` VALUES (29060, '66.57.15597067917187219', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=123456789423&code=9999', 'POST', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-06-05 11:53:12');
INSERT INTO `access_log` VALUES (29061, '66.49.15597067995587225', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678942&code=9999', 'POST', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:20', 11, 1001003000, '验证码不存在', '2019-06-05 11:53:20');
INSERT INTO `access_log` VALUES (29062, '66.54.15597068019587219', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=12345678942', 'POST', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:22', 100, 0, '', '2019-06-05 11:53:22');
INSERT INTO `access_log` VALUES (29063, '59.74.15597068102788619', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:30', 3, 0, '', '2019-06-05 11:53:30');
INSERT INTO `access_log` VALUES (29064, '59.75.15597068102788623', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:30', 18, 2001001000, '服务端发生异常', '2019-06-05 11:53:30');
INSERT INTO `access_log` VALUES (29065, '64.79.15597068124378361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:32', 3, 0, '', '2019-06-05 11:53:32');
INSERT INTO `access_log` VALUES (29066, '64.78.15597068126578373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:33', 2, 0, '', '2019-06-05 11:53:33');
INSERT INTO `access_log` VALUES (29067, '64.82.15597068137988377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:34', 2, 0, '', '2019-06-05 11:53:34');
INSERT INTO `access_log` VALUES (29068, '64.77.15597068147578373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:35', 2, 0, '', '2019-06-05 11:53:35');
INSERT INTO `access_log` VALUES (29069, '64.85.15597068157178385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:36', 2, 0, '', '2019-06-05 11:53:36');
INSERT INTO `access_log` VALUES (29070, '64.83.15597068163578359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:36', 2, 0, '', '2019-06-05 11:53:36');
INSERT INTO `access_log` VALUES (29071, '64.84.15597068171588375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:37', 2, 0, '', '2019-06-05 11:53:37');
INSERT INTO `access_log` VALUES (29072, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:37', 13, 0, '', '2019-06-05 11:53:37');
INSERT INTO `access_log` VALUES (29073, '64.76.15597068186148355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:39', 1, 0, '', '2019-06-05 11:53:39');
INSERT INTO `access_log` VALUES (29074, '64.81.15597068188258365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:39', 2, 0, '', '2019-06-05 11:53:39');
INSERT INTO `access_log` VALUES (29075, '64.79.15597068193988363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:39', 1, 0, '', '2019-06-05 11:53:39');
INSERT INTO `access_log` VALUES (29076, '64.78.15597068202788375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:40', 2, 0, '', '2019-06-05 11:53:40');
INSERT INTO `access_log` VALUES (29077, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:40', 6, 0, '', '2019-06-05 11:53:40');
INSERT INTO `access_log` VALUES (29078, '64.82.15597068219138379', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:42', 6, 0, '', '2019-06-05 11:53:42');
INSERT INTO `access_log` VALUES (29079, '64.77.15597068277988375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:48', 2, 0, '', '2019-06-05 11:53:48');
INSERT INTO `access_log` VALUES (29080, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:48', 8, 0, '', '2019-06-05 11:53:48');
INSERT INTO `access_log` VALUES (29081, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:50', 7, 0, '', '2019-06-05 11:53:50');
INSERT INTO `access_log` VALUES (29082, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:51', 7, 0, '', '2019-06-05 11:53:51');
INSERT INTO `access_log` VALUES (29083, '64.85.15597068318148387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:52', 2, 0, '', '2019-06-05 11:53:52');
INSERT INTO `access_log` VALUES (29084, '64.83.15597068320128361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:52', 2, 0, '', '2019-06-05 11:53:52');
INSERT INTO `access_log` VALUES (29085, '64.84.15597068330028377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:53', 2, 0, '', '2019-06-05 11:53:53');
INSERT INTO `access_log` VALUES (29086, '64.76.15597068333188357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:53', 2, 0, '', '2019-06-05 11:53:53');
INSERT INTO `access_log` VALUES (29087, '64.81.15597068369178367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:57', 2, 0, '', '2019-06-05 11:53:57');
INSERT INTO `access_log` VALUES (29088, '64.79.15597068371378365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:57', 1, 0, '', '2019-06-05 11:53:57');
INSERT INTO `access_log` VALUES (29089, '59.71.15597068372938627', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:57', 3, 0, '', '2019-06-05 11:53:57');
INSERT INTO `access_log` VALUES (29090, '59.76.15597068372938615', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-cn; OPPO R9s Build/MMB29M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/53.0.2785.134 Mobile Safari/537.36 OppoBrowser/10.5.0.4', '223.104.190.51', '2019-06-05 11:53:57', 13, 2001001000, '服务端发生异常', '2019-06-05 11:53:57');
INSERT INTO `access_log` VALUES (29091, '65.52.15597074215528771', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:03:42', 0, 1002001015, '账号未登陆', '2019-06-05 12:03:42');
INSERT INTO `access_log` VALUES (29092, '65.47.15597074215528773', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:03:42', 1, 1002001015, '账号未登陆', '2019-06-05 12:03:42');
INSERT INTO `access_log` VALUES (29093, '65.53.15597074215528741', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:03:42', 0, 1002001015, '账号未登陆', '2019-06-05 12:03:42');
INSERT INTO `access_log` VALUES (29094, '65.51.15597074244768771', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:03:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 12:03:44');
INSERT INTO `access_log` VALUES (29095, '65.3607.15597074299500541', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:03:50', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 12:03:50');
INSERT INTO `access_log` VALUES (29096, '65.45.15597074375088785', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:03:58', 157, 0, '', '2019-06-05 12:03:58');
INSERT INTO `access_log` VALUES (29097, '65.50.15597074382298775', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:03:58', 338, 0, '', '2019-06-05 12:03:59');
INSERT INTO `access_log` VALUES (29098, '65.54.15597074382288735', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:03:58', 340, 0, '', '2019-06-05 12:03:59');
INSERT INTO `access_log` VALUES (29099, '65.46.15597074382298771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:03:58', 340, 0, '', '2019-06-05 12:03:59');
INSERT INTO `access_log` VALUES (29100, '62.89.15597074506578483', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:04:11', 13, 0, '', '2019-06-05 12:04:11');
INSERT INTO `access_log` VALUES (29101, '64.77.15597074593818385', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:04:19', 10, 0, '', '2019-06-05 12:04:19');
INSERT INTO `access_log` VALUES (29102, '64.82.15597074593808389', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:04:19', 13, 0, '', '2019-06-05 12:04:19');
INSERT INTO `access_log` VALUES (29103, '66.48.15597074719887233', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:04:32', 14, 0, '', '2019-06-05 12:04:32');
INSERT INTO `access_log` VALUES (29104, '64.84.15597074828908387', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:04:43', 11, 0, '', '2019-06-05 12:04:43');
INSERT INTO `access_log` VALUES (29105, '64.83.15597074828898371', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:04:43', 12, 0, '', '2019-06-05 12:04:43');
INSERT INTO `access_log` VALUES (29106, '62.88.15597074842208489', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 12:04:44', 11, 0, '', '2019-06-05 12:04:44');
INSERT INTO `access_log` VALUES (29107, 'e9d4d34c-c4b7-4ab6-9147-2463534f5bed', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 12:07:32', 5304, 0, '', '2019-06-05 12:07:37');
INSERT INTO `access_log` VALUES (29108, 'b8f3b384-0531-4b3f-9c89-06f4aa4f3ef3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 12:07:37', 208, 0, '', '2019-06-05 12:07:37');
INSERT INTO `access_log` VALUES (29109, '5b11e64b-93c7-406a-80cc-f85bce578b9e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 12:07:38', 334, 0, '', '2019-06-05 12:07:38');
INSERT INTO `access_log` VALUES (29110, 'be26b2da-f74b-4638-b2b4-11775b98b003', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-05 12:07:38', 379, 0, '', '2019-06-05 12:07:38');
INSERT INTO `access_log` VALUES (29111, '59.78.15597079363798641', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:12:16', 3, 0, '', '2019-06-05 12:12:16');
INSERT INTO `access_log` VALUES (29112, '59.75.15597079363808639', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:12:16', 13, 2001001000, '服务端发生异常', '2019-06-05 12:12:16');
INSERT INTO `access_log` VALUES (29113, '64.81.15597079426008383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:12:23', 2, 0, '', '2019-06-05 12:12:23');
INSERT INTO `access_log` VALUES (29114, '64.79.15597079427248381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:12:23', 2, 0, '', '2019-06-05 12:12:23');
INSERT INTO `access_log` VALUES (29115, '64.78.15597079439128393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:12:24', 2, 0, '', '2019-06-05 12:12:24');
INSERT INTO `access_log` VALUES (29116, '64.77.15597079445508393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:12:25', 2, 0, '', '2019-06-05 12:12:25');
INSERT INTO `access_log` VALUES (29117, '64.82.15597079451868397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:12:25', 154, 0, '', '2019-06-05 12:12:25');
INSERT INTO `access_log` VALUES (29118, '64.80.15597079480748383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:12:28', 2, 0, '', '2019-06-05 12:12:28');
INSERT INTO `access_log` VALUES (29119, '64.84.15597079683178395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '183.14.28.252', '2019-06-05 12:12:48', 1, 0, '', '2019-06-05 12:12:48');
INSERT INTO `access_log` VALUES (29120, '64.83.15597079691278379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '183.14.28.252', '2019-06-05 12:12:49', 472, 0, '', '2019-06-05 12:12:50');
INSERT INTO `access_log` VALUES (29121, '64.76.15597079697958375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '183.14.28.252', '2019-06-05 12:12:50', 2, 0, '', '2019-06-05 12:12:50');
INSERT INTO `access_log` VALUES (29122, '64.79.15597079803088383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.14.28.252', '2019-06-05 12:13:00', 2, 0, '', '2019-06-05 12:13:00');
INSERT INTO `access_log` VALUES (29123, '64.78.15597079816388395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.14.28.252', '2019-06-05 12:13:02', 1, 0, '', '2019-06-05 12:13:02');
INSERT INTO `access_log` VALUES (29124, '64.82.15597079867678399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.14.28.252', '2019-06-05 12:13:07', 2, 0, '', '2019-06-05 12:13:07');
INSERT INTO `access_log` VALUES (29125, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.14.28.252', '2019-06-05 12:13:07', 6, 0, '', '2019-06-05 12:13:07');
INSERT INTO `access_log` VALUES (29126, '65.50.15597080034708783', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:13:23', 0, 1002001015, '账号未登陆', '2019-06-05 12:13:23');
INSERT INTO `access_log` VALUES (29127, '65.46.15597080034718779', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:13:23', 1, 1002001015, '账号未登陆', '2019-06-05 12:13:23');
INSERT INTO `access_log` VALUES (29128, '65.54.15597080034768743', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:13:23', 0, 1002001015, '账号未登陆', '2019-06-05 12:13:23');
INSERT INTO `access_log` VALUES (29129, '65.52.15597080112478781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:13:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 12:13:31');
INSERT INTO `access_log` VALUES (29130, '65.51.15597080198458781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:13:40', 114, 0, '', '2019-06-05 12:13:40');
INSERT INTO `access_log` VALUES (29131, '65.49.15597080203138803', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:13:40', 44, 0, '', '2019-06-05 12:13:40');
INSERT INTO `access_log` VALUES (29132, '65.45.15597080203178795', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:13:40', 40, 0, '', '2019-06-05 12:13:40');
INSERT INTO `access_log` VALUES (29133, '65.3607.15597080203110551', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:13:40', 46, 0, '', '2019-06-05 12:13:40');
INSERT INTO `access_log` VALUES (29134, '62.84.15597080492868479', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:14:09', 14, 0, '', '2019-06-05 12:14:09');
INSERT INTO `access_log` VALUES (29135, '66.48.15597080559017241', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.14.28.252', '2019-06-05 12:14:16', 13, 0, '', '2019-06-05 12:14:16');
INSERT INTO `access_log` VALUES (29136, '59.78.15597083293688647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '106.2.233.137', '2019-06-05 12:18:49', 3, 0, '', '2019-06-05 12:18:49');
INSERT INTO `access_log` VALUES (29137, '59.79.15597083293638643', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '106.2.233.137', '2019-06-05 12:18:49', 13, 2001001000, '服务端发生异常', '2019-06-05 12:18:49');
INSERT INTO `access_log` VALUES (29138, '64.83.15597083326048385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '106.2.233.137', '2019-06-05 12:18:53', 34, 0, '', '2019-06-05 12:18:53');
INSERT INTO `access_log` VALUES (29139, '64.76.15597083327848381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '106.2.233.137', '2019-06-05 12:18:53', 2, 0, '', '2019-06-05 12:18:53');
INSERT INTO `access_log` VALUES (29140, '64.81.15597083339208391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '106.2.233.137', '2019-06-05 12:18:54', 2, 0, '', '2019-06-05 12:18:54');
INSERT INTO `access_log` VALUES (29141, '64.79.15597083345638389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '106.2.233.137', '2019-06-05 12:18:55', 2, 0, '', '2019-06-05 12:18:55');
INSERT INTO `access_log` VALUES (29142, '65.49.15597114534818849', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:10:53', 1, 1002001015, '账号未登陆', '2019-06-05 13:10:53');
INSERT INTO `access_log` VALUES (29143, '65.45.15597114534898841', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:10:53', 1, 1002001015, '账号未登陆', '2019-06-05 13:10:53');
INSERT INTO `access_log` VALUES (29144, '65.50.15597114534898831', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:10:53', 1, 1002001015, '账号未登陆', '2019-06-05 13:10:53');
INSERT INTO `access_log` VALUES (29145, '65.54.15597114582458791', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:10:58', 121, 0, '', '2019-06-05 13:10:58');
INSERT INTO `access_log` VALUES (29146, '65.47.15597114588348831', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:10:59', 10, 0, '', '2019-06-05 13:10:59');
INSERT INTO `access_log` VALUES (29147, '65.52.15597114588428829', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:10:59', 10, 0, '', '2019-06-05 13:10:59');
INSERT INTO `access_log` VALUES (29148, '65.53.15597114588468799', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:10:59', 17, 0, '', '2019-06-05 13:10:59');
INSERT INTO `access_log` VALUES (29149, '62.83.15597114721928535', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:11:12', 22, 0, '', '2019-06-05 13:11:12');
INSERT INTO `access_log` VALUES (29150, '62.88.15597114880678543', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:11:28', 13, 0, '', '2019-06-05 13:11:28');
INSERT INTO `access_log` VALUES (29151, '65.46.15597115337888829', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:12:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 13:12:14');
INSERT INTO `access_log` VALUES (29152, '65.54.15597115401248793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:12:20', 736, 0, '', '2019-06-05 13:12:21');
INSERT INTO `access_log` VALUES (29153, '65.52.15597115412408831', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:12:21', 9, 0, '', '2019-06-05 13:12:21');
INSERT INTO `access_log` VALUES (29154, '65.47.15597115412758833', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:12:21', 10, 0, '', '2019-06-05 13:12:21');
INSERT INTO `access_log` VALUES (29155, '65.53.15597115412798801', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:12:21', 9, 0, '', '2019-06-05 13:12:21');
INSERT INTO `access_log` VALUES (29156, '59.71.15597115458658691', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:12:26', 21, 0, '', '2019-06-05 13:12:26');
INSERT INTO `access_log` VALUES (29157, '59.76.15597115505638679', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:12:31', 17, 2001001000, '服务端发生异常', '2019-06-05 13:12:31');
INSERT INTO `access_log` VALUES (29158, '59.77.15597115552208679', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:12:35', 564, 0, '', '2019-06-05 13:12:36');
INSERT INTO `access_log` VALUES (29159, '65.45.15597115596268845', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:12:40', 18, 0, '', '2019-06-05 13:12:40');
INSERT INTO `access_log` VALUES (29160, '65.49.15597115650548853', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:12:45', 8, 0, '', '2019-06-05 13:12:45');
INSERT INTO `access_log` VALUES (29161, '65.50.15597115698068835', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:12:50', 10, 0, '', '2019-06-05 13:12:50');
INSERT INTO `access_log` VALUES (29162, '65.46.15597115731818831', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:12:53', 538, 0, '', '2019-06-05 13:12:54');
INSERT INTO `access_log` VALUES (29163, '59.75.15597115861848689', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:06', 2, 0, '', '2019-06-05 13:13:06');
INSERT INTO `access_log` VALUES (29164, '59.74.15597115861918685', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:06', 12, 2001001000, '服务端发生异常', '2019-06-05 13:13:06');
INSERT INTO `access_log` VALUES (29165, '64.76.15597115928208425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:13', 11, 0, '', '2019-06-05 13:13:13');
INSERT INTO `access_log` VALUES (29166, '64.81.15597115929708435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:13', 3, 0, '', '2019-06-05 13:13:13');
INSERT INTO `access_log` VALUES (29167, '64.79.15597115963758433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:16', 2, 0, '', '2019-06-05 13:13:16');
INSERT INTO `access_log` VALUES (29168, '64.78.15597115993098445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:19', 2, 0, '', '2019-06-05 13:13:19');
INSERT INTO `access_log` VALUES (29169, '64.77.15597116001888445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:20', 179, 0, '', '2019-06-05 13:13:20');
INSERT INTO `access_log` VALUES (29170, '64.80.15597116005378435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:21', 2, 0, '', '2019-06-05 13:13:21');
INSERT INTO `access_log` VALUES (29171, '59.80.15597116014368679', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:21', 3, 0, '', '2019-06-05 13:13:21');
INSERT INTO `access_log` VALUES (29172, '59.71.15597116014368693', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:21', 20, 2001001000, '服务端发生异常', '2019-06-05 13:13:21');
INSERT INTO `access_log` VALUES (29173, '64.85.15597116042738457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:24', 231, 0, '', '2019-06-05 13:13:25');
INSERT INTO `access_log` VALUES (29174, '64.84.15597116046648447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:25', 2, 0, '', '2019-06-05 13:13:25');
INSERT INTO `access_log` VALUES (29175, '59.76.15597116061828681', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:26', 2, 0, '', '2019-06-05 13:13:26');
INSERT INTO `access_log` VALUES (29176, '59.72.15597116062208687', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:26', 9, 2001001000, '服务端发生异常', '2019-06-05 13:13:26');
INSERT INTO `access_log` VALUES (29177, '64.83.15597116081488431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:28', 2, 0, '', '2019-06-05 13:13:28');
INSERT INTO `access_log` VALUES (29178, '64.76.15597116082998427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:28', 2, 0, '', '2019-06-05 13:13:28');
INSERT INTO `access_log` VALUES (29179, '59.77.15597116097228681', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:30', 2, 0, '', '2019-06-05 13:13:30');
INSERT INTO `access_log` VALUES (29180, '59.79.15597116097268689', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:13:30', 13, 2001001000, '服务端发生异常', '2019-06-05 13:13:30');
INSERT INTO `access_log` VALUES (29181, '59.80.15597121214758687', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.65.18.58', '2019-06-05 13:22:01', 10, 0, '', '2019-06-05 13:22:01');
INSERT INTO `access_log` VALUES (29182, '59.71.15597121214768701', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.65.18.58', '2019-06-05 13:22:01', 12, 2001001000, '服务端发生异常', '2019-06-05 13:22:01');
INSERT INTO `access_log` VALUES (29183, '64.82.15597121251238457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.65.18.58', '2019-06-05 13:22:05', 2, 0, '', '2019-06-05 13:22:05');
INSERT INTO `access_log` VALUES (29184, '64.80.15597121252508443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '112.65.18.58', '2019-06-05 13:22:05', 2, 0, '', '2019-06-05 13:22:05');
INSERT INTO `access_log` VALUES (29185, '59.75.15597121852018699', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '223.166.151.191', '2019-06-05 13:23:05', 14, 2001001000, '服务端发生异常', '2019-06-05 13:23:05');
INSERT INTO `access_log` VALUES (29186, '59.74.15597121871898695', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:23:07', 3, 0, '', '2019-06-05 13:23:07');
INSERT INTO `access_log` VALUES (29187, '59.73.15597121872068701', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:23:07', 9, 2001001000, '服务端发生异常', '2019-06-05 13:23:07');
INSERT INTO `access_log` VALUES (29188, '65.46.15597123915248841', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 13:26:32', 0, 1002001015, '账号未登陆', '2019-06-05 13:26:32');
INSERT INTO `access_log` VALUES (29189, '65.54.15597123915308807', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 13:26:32', 0, 1002001015, '账号未登陆', '2019-06-05 13:26:32');
INSERT INTO `access_log` VALUES (29190, '65.52.15597123915378845', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 13:26:32', 0, 1002001015, '账号未登陆', '2019-06-05 13:26:32');
INSERT INTO `access_log` VALUES (29191, '65.47.15597124017348847', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 13:26:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 13:26:42');
INSERT INTO `access_log` VALUES (29192, '65.51.15597124106008845', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 13:26:51', 4, 1002002000, '账号不存在', '2019-06-05 13:26:51');
INSERT INTO `access_log` VALUES (29193, '65.45.15597124163288859', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 13:26:56', 86, 0, '', '2019-06-05 13:26:56');
INSERT INTO `access_log` VALUES (29194, '65.49.15597124167778867', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 13:26:57', 375, 0, '', '2019-06-05 13:26:57');
INSERT INTO `access_log` VALUES (29195, '65.54.15597124168168809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 13:26:57', 339, 0, '', '2019-06-05 13:26:57');
INSERT INTO `access_log` VALUES (29196, '65.50.15597124167808847', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 13:26:57', 374, 0, '', '2019-06-05 13:26:57');
INSERT INTO `access_log` VALUES (29197, '62.82.15597124235888553', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 13:27:04', 14, 0, '', '2019-06-05 13:27:04');
INSERT INTO `access_log` VALUES (29198, '59.78.15597124306088705', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 13:27:11', 12, 0, '', '2019-06-05 13:27:11');
INSERT INTO `access_log` VALUES (29199, '64.80.15597132917808459', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:41:32', 10, 1002001012, '访问令牌已过期', '2019-06-05 13:41:32');
INSERT INTO `access_log` VALUES (29200, '64.82.15597132917808473', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:41:32', 10, 1002001012, '访问令牌已过期', '2019-06-05 13:41:32');
INSERT INTO `access_log` VALUES (29201, '65.52.15597132988698861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:41:39', 591, 0, '', '2019-06-05 13:41:39');
INSERT INTO `access_log` VALUES (29202, '65.3607.15597132998020631', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:41:40', 246, 0, '', '2019-06-05 13:41:40');
INSERT INTO `access_log` VALUES (29203, '65.50.15597132998018859', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:41:40', 250, 0, '', '2019-06-05 13:41:40');
INSERT INTO `access_log` VALUES (29204, '65.53.15597132997988829', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:41:40', 253, 0, '', '2019-06-05 13:41:40');
INSERT INTO `access_log` VALUES (29205, '64.84.15597133045758471', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:41:45', 10, 0, '', '2019-06-05 13:41:45');
INSERT INTO `access_log` VALUES (29206, '64.83.15597133045788455', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:41:45', 10, 0, '', '2019-06-05 13:41:45');
INSERT INTO `access_log` VALUES (29207, '65.54.15597133182398821', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:41:58', 1, 1002001015, '账号未登陆', '2019-06-05 13:41:58');
INSERT INTO `access_log` VALUES (29208, '65.45.15597133182688871', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:41:58', 0, 1002001015, '账号未登陆', '2019-06-05 13:41:58');
INSERT INTO `access_log` VALUES (29209, '65.49.15597133182698883', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:41:58', 0, 1002001015, '账号未登陆', '2019-06-05 13:41:58');
INSERT INTO `access_log` VALUES (29210, '65.46.15597133193878857', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.192.52.134', '2019-06-05 13:41:59', 1, 1002001015, '账号未登陆', '2019-06-05 13:41:59');
INSERT INTO `access_log` VALUES (29211, '65.47.15597133193948865', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.192.52.134', '2019-06-05 13:41:59', 1, 1002001015, '账号未登陆', '2019-06-05 13:41:59');
INSERT INTO `access_log` VALUES (29212, '65.52.15597133194028863', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.192.52.134', '2019-06-05 13:41:59', 0, 1002001015, '账号未登陆', '2019-06-05 13:41:59');
INSERT INTO `access_log` VALUES (29213, '65.3607.15597133214450633', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:42:01', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 13:42:01');
INSERT INTO `access_log` VALUES (29214, '64.81.15597133229158461', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:42:03', 59, 0, '', '2019-06-05 13:42:03');
INSERT INTO `access_log` VALUES (29215, '65.50.15597133274438861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:42:07', 126, 0, '', '2019-06-05 13:42:08');
INSERT INTO `access_log` VALUES (29216, '65.53.15597133279508831', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:42:08', 9, 0, '', '2019-06-05 13:42:08');
INSERT INTO `access_log` VALUES (29217, '65.51.15597133279608863', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:42:08', 9, 0, '', '2019-06-05 13:42:08');
INSERT INTO `access_log` VALUES (29218, '65.54.15597133279848823', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:42:08', 10, 0, '', '2019-06-05 13:42:08');
INSERT INTO `access_log` VALUES (29219, '62.83.15597133360388561', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:42:16', 11, 0, '', '2019-06-05 13:42:16');
INSERT INTO `access_log` VALUES (29220, '62.88.15597133412158569', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:42:21', 15, 0, '', '2019-06-05 13:42:21');
INSERT INTO `access_log` VALUES (29221, '66.53.15597133431827303', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:42:23', 20, 0, '', '2019-06-05 13:42:23');
INSERT INTO `access_log` VALUES (29222, '65.46.15597133462148859', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:42:26', 19, 0, '', '2019-06-05 13:42:26');
INSERT INTO `access_log` VALUES (29223, '65.52.15597133483918865', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:42:28', 50, 0, '', '2019-06-05 13:42:28');
INSERT INTO `access_log` VALUES (29224, '65.47.15597133507898867', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:42:31', 9, 0, '', '2019-06-05 13:42:31');
INSERT INTO `access_log` VALUES (29225, '65.3607.15597133527780635', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:42:33', 14, 0, '', '2019-06-05 13:42:33');
INSERT INTO `access_log` VALUES (29226, '64.77.15597133528668471', 27, 2, 'product-application', '/product-api/admins/category/add', 'name=电子产品&pid=0&sort=2&description=asdfasd', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:42:33', 7, 1002002009, NULL, '2019-06-05 13:42:33');
INSERT INTO `access_log` VALUES (29227, '59.73.15597133561788717', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.244.113.18', '2019-06-05 13:42:36', 10, 0, '', '2019-06-05 13:42:36');
INSERT INTO `access_log` VALUES (29228, '65.53.15597133645698833', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.192.52.134', '2019-06-05 13:42:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 13:42:45');
INSERT INTO `access_log` VALUES (29229, '64.80.15597133673668461', 27, 2, 'product-application', '/product-api/admins/category/add', 'name=电子产品&pid=0&sort=2&description=asdfasd', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:42:47', 96, 1002002009, NULL, '2019-06-05 13:42:47');
INSERT INTO `access_log` VALUES (29230, '65.54.15597133827318825', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.192.52.134', '2019-06-05 13:43:03', 77, 0, '', '2019-06-05 13:43:03');
INSERT INTO `access_log` VALUES (29231, '65.49.15597133833458887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.192.52.134', '2019-06-05 13:43:03', 17, 0, '', '2019-06-05 13:43:03');
INSERT INTO `access_log` VALUES (29232, '65.45.15597133833618875', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.192.52.134', '2019-06-05 13:43:03', 9, 0, '', '2019-06-05 13:43:03');
INSERT INTO `access_log` VALUES (29233, '65.46.15597133833718861', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.192.52.134', '2019-06-05 13:43:03', 8, 0, '', '2019-06-05 13:43:03');
INSERT INTO `access_log` VALUES (29234, '65.47.15597133902198869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.192.52.134', '2019-06-05 13:43:10', 36, 0, '', '2019-06-05 13:43:10');
INSERT INTO `access_log` VALUES (29235, '65.3607.15597133902260637', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.192.52.134', '2019-06-05 13:43:10', 29, 0, '', '2019-06-05 13:43:10');
INSERT INTO `access_log` VALUES (29236, '65.50.15597133902388865', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.192.52.134', '2019-06-05 13:43:10', 18, 0, '', '2019-06-05 13:43:10');
INSERT INTO `access_log` VALUES (29237, '65.53.15597133927458835', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.192.52.134', '2019-06-05 13:43:13', 9, 0, '', '2019-06-05 13:43:13');
INSERT INTO `access_log` VALUES (29238, '65.51.15597133927538867', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.192.52.134', '2019-06-05 13:43:13', 9, 0, '', '2019-06-05 13:43:13');
INSERT INTO `access_log` VALUES (29239, '65.54.15597133927598827', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.192.52.134', '2019-06-05 13:43:13', 8, 0, '', '2019-06-05 13:43:13');
INSERT INTO `access_log` VALUES (29240, '65.46.15597134244098863', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:43:44', 9, 0, '', '2019-06-05 13:43:44');
INSERT INTO `access_log` VALUES (29241, '65.52.15597134244128869', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:43:44', 10, 0, '', '2019-06-05 13:43:44');
INSERT INTO `access_log` VALUES (29242, '65.47.15597134244138871', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:43:44', 9, 0, '', '2019-06-05 13:43:44');
INSERT INTO `access_log` VALUES (29243, '64.81.15597134245478463', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:43:45', 10, 0, '', '2019-06-05 13:43:45');
INSERT INTO `access_log` VALUES (29244, '64.77.15597134473858473', 27, 2, 'product-application', '/product-api/admins/category/add', 'name=电子产品&pid=0&sort=12&description=asdfasdfa', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:44:07', 7, 1002002009, NULL, '2019-06-05 13:44:07');
INSERT INTO `access_log` VALUES (29245, '64.80.15597136113758465', 27, 2, 'product-application', '/product-api/admins/category/update', 'id=793&pid=0&name=图书&description=书是个好东西，可惜看的少。&sort=3&status=1&createTime=2019-05-05T08:12:39.000+0000&children[0][id]=794&children[0][pid]=793&children[0][name]=Java&children[0][description]=半年一更，妥妥的&children[0][picUrl]=http://static.shop.iocoder.cn/5fd5709e-988d-4efd-b5d8-54a599ca538f&children[0][sort]=1&children[0][status]=1&children[0][createTime]=2019-05-05T08:35:03.000+0000&children[0][children]=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-05 13:46:51', 9, 1002002009, NULL, '2019-06-05 13:46:51');
INSERT INTO `access_log` VALUES (29246, '65.54.15597137822388833', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:49:42', 10, 0, '', '2019-06-05 13:49:42');
INSERT INTO `access_log` VALUES (29247, '65.45.15597137822398883', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:49:42', 10, 0, '', '2019-06-05 13:49:42');
INSERT INTO `access_log` VALUES (29248, '65.49.15597137822578895', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:49:42', 9, 0, '', '2019-06-05 13:49:42');
INSERT INTO `access_log` VALUES (29249, '59.80.15597138162648711', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:50:16', 4, 0, '', '2019-06-05 13:50:16');
INSERT INTO `access_log` VALUES (29250, '59.71.15597138162718725', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:50:16', 14, 2001001000, '服务端发生异常', '2019-06-05 13:50:16');
INSERT INTO `access_log` VALUES (29251, '64.81.15597138207698469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:50:21', 2, 0, '', '2019-06-05 13:50:21');
INSERT INTO `access_log` VALUES (29252, '64.79.15597138208948467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:50:21', 3, 0, '', '2019-06-05 13:50:21');
INSERT INTO `access_log` VALUES (29253, '59.72.15597138231878719', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:50:23', 13, 2001001000, '服务端发生异常', '2019-06-05 13:50:23');
INSERT INTO `access_log` VALUES (29254, '59.77.15597138231908713', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:50:23', 34, 0, '', '2019-06-05 13:50:23');
INSERT INTO `access_log` VALUES (29255, '64.78.15597138258818479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:50:26', 2, 0, '', '2019-06-05 13:50:26');
INSERT INTO `access_log` VALUES (29256, '64.77.15597138260358479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:50:26', 2, 0, '', '2019-06-05 13:50:26');
INSERT INTO `access_log` VALUES (29257, '59.78.15597138278728725', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:50:28', 2, 0, '', '2019-06-05 13:50:28');
INSERT INTO `access_log` VALUES (29258, '59.79.15597138278708721', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:50:28', 19, 2001001000, '服务端发生异常', '2019-06-05 13:50:28');
INSERT INTO `access_log` VALUES (29259, '65.51.15597138621548875', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:51:02', 0, 1002001015, '账号未登陆', '2019-06-05 13:51:02');
INSERT INTO `access_log` VALUES (29260, '65.53.15597138621608843', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:51:02', 1, 1002001015, '账号未登陆', '2019-06-05 13:51:02');
INSERT INTO `access_log` VALUES (29261, '65.54.15597138621748835', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:51:02', 1, 1002001015, '账号未登陆', '2019-06-05 13:51:02');
INSERT INTO `access_log` VALUES (29262, '65.49.15597138829238897', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:51:23', 239, 0, '', '2019-06-05 13:51:23');
INSERT INTO `access_log` VALUES (29263, '65.46.15597138834958871', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:51:23', 105, 0, '', '2019-06-05 13:51:24');
INSERT INTO `access_log` VALUES (29264, '65.47.15597138835008879', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:51:24', 102, 0, '', '2019-06-05 13:51:24');
INSERT INTO `access_log` VALUES (29265, '65.52.15597138835048877', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:51:24', 100, 0, '', '2019-06-05 13:51:24');
INSERT INTO `access_log` VALUES (29266, '59.76.15597138990688715', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '175.167.138.65', '2019-06-05 13:51:39', 3, 0, '', '2019-06-05 13:51:39');
INSERT INTO `access_log` VALUES (29267, '59.77.15597138990688715', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '175.167.138.65', '2019-06-05 13:51:39', 14, 2001001000, '服务端发生异常', '2019-06-05 13:51:39');
INSERT INTO `access_log` VALUES (29268, '64.76.15597139045948461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '175.167.138.65', '2019-06-05 13:51:45', 2, 0, '', '2019-06-05 13:51:45');
INSERT INTO `access_log` VALUES (29269, '64.81.15597139047808471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '175.167.138.65', '2019-06-05 13:51:45', 1, 0, '', '2019-06-05 13:51:45');
INSERT INTO `access_log` VALUES (29270, '62.83.15597139061848569', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:51:46', 14, 0, '', '2019-06-05 13:51:46');
INSERT INTO `access_log` VALUES (29271, '64.79.15597139085458469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '175.167.138.65', '2019-06-05 13:51:49', 2, 0, '', '2019-06-05 13:51:49');
INSERT INTO `access_log` VALUES (29272, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '175.167.138.65', '2019-06-05 13:51:50', 11, 0, '', '2019-06-05 13:51:50');
INSERT INTO `access_log` VALUES (29273, '64.77.15597139131858481', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '175.167.138.65', '2019-06-05 13:51:53', 8, 0, '', '2019-06-05 13:51:53');
INSERT INTO `access_log` VALUES (29274, '64.80.15597139214778471', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:52:01', 141, 0, '', '2019-06-05 13:52:02');
INSERT INTO `access_log` VALUES (29275, '64.82.15597139214758485', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:52:01', 146, 0, '', '2019-06-05 13:52:02');
INSERT INTO `access_log` VALUES (29276, '59.78.15597139237658727', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '175.167.138.65', '2019-06-05 13:52:04', 2, 0, '', '2019-06-05 13:52:04');
INSERT INTO `access_log` VALUES (29277, '59.79.15597139237668723', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '175.167.138.65', '2019-06-05 13:52:04', 11, 2001001000, '服务端发生异常', '2019-06-05 13:52:04');
INSERT INTO `access_log` VALUES (29278, '64.83.15597139276268467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '175.167.138.65', '2019-06-05 13:52:08', 2, 0, '', '2019-06-05 13:52:08');
INSERT INTO `access_log` VALUES (29279, '64.84.15597139277928483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '175.167.138.65', '2019-06-05 13:52:08', 2, 0, '', '2019-06-05 13:52:08');
INSERT INTO `access_log` VALUES (29280, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '175.167.138.65', '2019-06-05 13:52:10', 4, 0, '', '2019-06-05 13:52:10');
INSERT INTO `access_log` VALUES (29281, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '175.167.138.65', '2019-06-05 13:52:12', 7, 0, '', '2019-06-05 13:52:12');
INSERT INTO `access_log` VALUES (29282, '64.76.15597139370638463', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '175.167.138.65', '2019-06-05 13:52:17', 6, 0, '', '2019-06-05 13:52:17');
INSERT INTO `access_log` VALUES (29283, '59.71.15597139487488729', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:52:29', 14, 2001001000, '服务端发生异常', '2019-06-05 13:52:29');
INSERT INTO `access_log` VALUES (29284, '59.73.15597139487468727', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:52:29', 64, 0, '', '2019-06-05 13:52:29');
INSERT INTO `access_log` VALUES (29285, '64.79.15597139518288471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:52:32', 1, 0, '', '2019-06-05 13:52:32');
INSERT INTO `access_log` VALUES (29286, '64.78.15597139519348483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:52:32', 2, 0, '', '2019-06-05 13:52:32');
INSERT INTO `access_log` VALUES (29287, '64.77.15597139531278483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:52:33', 2, 0, '', '2019-06-05 13:52:33');
INSERT INTO `access_log` VALUES (29288, '65.45.15597139551678887', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:52:35', 4, 0, '', '2019-06-05 13:52:35');
INSERT INTO `access_log` VALUES (29289, '65.46.15597139643258873', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:52:44', 1, 1002001015, '账号未登陆', '2019-06-05 13:52:44');
INSERT INTO `access_log` VALUES (29290, '65.52.15597139643258879', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:52:44', 0, 1002001015, '账号未登陆', '2019-06-05 13:52:44');
INSERT INTO `access_log` VALUES (29291, '65.47.15597139643288881', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:52:44', 0, 1002001015, '账号未登陆', '2019-06-05 13:52:44');
INSERT INTO `access_log` VALUES (29292, '59.77.15597139643388717', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:52:44', 41, 2001001000, '服务端发生异常', '2019-06-05 13:52:44');
INSERT INTO `access_log` VALUES (29293, '65.50.15597139664688877', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:52:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 13:52:46');
INSERT INTO `access_log` VALUES (29294, '65.53.15597139758708847', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:52:56', 88, 0, '', '2019-06-05 13:52:56');
INSERT INTO `access_log` VALUES (29295, '65.51.15597139763488879', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:52:56', 10, 0, '', '2019-06-05 13:52:56');
INSERT INTO `access_log` VALUES (29296, '65.54.15597139763518839', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:52:56', 9, 0, '', '2019-06-05 13:52:56');
INSERT INTO `access_log` VALUES (29297, '65.45.15597139763578889', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:52:56', 9, 0, '', '2019-06-05 13:52:56');
INSERT INTO `access_log` VALUES (29298, '62.81.15597139808678551', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:53:01', 13, 0, '', '2019-06-05 13:53:01');
INSERT INTO `access_log` VALUES (29299, '66.50.15597139853927309', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.115.102.138', '2019-06-05 13:53:05', 14, 0, '', '2019-06-05 13:53:05');
INSERT INTO `access_log` VALUES (29300, '65.50.15597140355938879', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:53:56', 3, 0, '', '2019-06-05 13:53:56');
INSERT INTO `access_log` VALUES (29301, '65.53.15597140507248849', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:54:11', 4, 0, '', '2019-06-05 13:54:11');
INSERT INTO `access_log` VALUES (29302, '65.45.15597140654258891', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:54:25', 15, 0, '', '2019-06-05 13:54:25');
INSERT INTO `access_log` VALUES (29303, '65.51.15597140776588881', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:54:38', 4, 0, '', '2019-06-05 13:54:38');
INSERT INTO `access_log` VALUES (29304, '64.77.15597140785298485', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:54:39', 12, 0, '', '2019-06-05 13:54:39');
INSERT INTO `access_log` VALUES (29305, '64.80.15597140785388475', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:54:39', 16, 0, '', '2019-06-05 13:54:39');
INSERT INTO `access_log` VALUES (29306, '64.82.15597140841678489', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name= 乌尼莫克吧.这种特种改良过的车.怎么得500吧. 雨神 911 9 大g的爸爸 新德里贪污部长 911 9 渣渣还在玩汽车?我已经开上飞机了 KittyFlier MP4-12...&sellPoint= 乌尼莫克吧.这种特种改良过的车.怎么得500吧. 雨神 911 9 大g的爸爸 新德里贪污部长 911 9 渣渣还在玩汽车?我已经开上飞机了 KittyFlier MP4-12...&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/da03a043-693b-4f9e-8b71-0ce11b8de17b,http://static.shop.iocoder.cn/a8c087dd-dda4-4c44-85c1-cb1eaa710305&skuStr=[{\"attrs\":[1,3],\"price\":9900,\"quantity\":245}]&description=<p><span style=\"color:#333333\"><span style=\"background-color:#ffffff\"><span style=\"font-size:13px\">乌尼莫克吧.这种特种改良过的车.怎么得500吧. 雨神 911 9</span></span></span><em>大g</em><span style=\"font-size:13px\"><span style=\"color:#333333\"><span style=\"background-color:#ffffff\">的爸爸 新德里贪污部长 911 9 渣渣还在玩</span></span></span><em>汽车</em><span style=\"background-color:#ffffff\"><span style=\"color:#333333\"><span style=\"font-size:13px\">?我已经开上飞机了 KittyFlier MP4-12...</span></span></span></p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/a3f8349c-3804-4f98-ac48-0425ffef0c9f\"/></div><p><span style=\"color:#333333\"><span style=\"background-color:#ffffff\"><span style=\"font-size:13px\">乌尼莫克吧.这种特种改良过的车.怎么得500吧. 雨神 911 9</span></span></span><em>大g</em><span style=\"font-size:13px\"><span style=\"color:#333333\"><span style=\"background-color:#ffffff\">的爸爸 新德里贪污部长 911 9 渣渣还在玩</span></span></span><em>汽车</em><span style=\"background-color:#ffffff\"><span style=\"color:#333333\"><span style=\"font-size:13px\">?我已经开上飞机了 KittyFlier MP4-12...</span></span></span></p><p></p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/1799f4ca-f4cb-40eb-b603-94f080138b5c\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:54:44', 7, 1002002009, NULL, '2019-06-05 13:54:44');
INSERT INTO `access_log` VALUES (29307, '64.85.15597140889638497', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name= 乌尼莫克吧.这种特种改良过的车.怎么得500吧. 雨神 911 9 大g的爸爸 新德里贪污部长 911 9 渣渣还在玩汽车?我已经开上飞机了 KittyFlier MP4-12...&sellPoint= 乌尼莫克吧.这种特种改良过的车.怎么得500吧. 雨神 911 9 大g的爸爸 新德里贪污部长 911 9 渣渣还在玩汽车?我已经开上飞机了 KittyFlier MP4-12...&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/da03a043-693b-4f9e-8b71-0ce11b8de17b,http://static.shop.iocoder.cn/a8c087dd-dda4-4c44-85c1-cb1eaa710305&skuStr=[{\"attrs\":[1,3],\"price\":9900,\"quantity\":245}]&description=<p><span style=\"color:#333333\"><span style=\"background-color:#ffffff\"><span style=\"font-size:13px\">乌尼莫克吧.这种特种改良过的车.怎么得500吧. 雨神 911 9</span></span></span><em>大g</em><span style=\"font-size:13px\"><span style=\"color:#333333\"><span style=\"background-color:#ffffff\">的爸爸 新德里贪污部长 911 9 渣渣还在玩</span></span></span><em>汽车</em><span style=\"background-color:#ffffff\"><span style=\"color:#333333\"><span style=\"font-size:13px\">?我已经开上飞机了 KittyFlier MP4-12...</span></span></span></p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/a3f8349c-3804-4f98-ac48-0425ffef0c9f\"/></div><p><span style=\"color:#333333\"><span style=\"background-color:#ffffff\"><span style=\"font-size:13px\">乌尼莫克吧.这种特种改良过的车.怎么得500吧. 雨神 911 9</span></span></span><em>大g</em><span style=\"font-size:13px\"><span style=\"color:#333333\"><span style=\"background-color:#ffffff\">的爸爸 新德里贪污部长 911 9 渣渣还在玩</span></span></span><em>汽车</em><span style=\"background-color:#ffffff\"><span style=\"color:#333333\"><span style=\"font-size:13px\">?我已经开上飞机了 KittyFlier MP4-12...</span></span></span></p><p></p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/1799f4ca-f4cb-40eb-b603-94f080138b5c\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:54:49', 61, 1002002009, NULL, '2019-06-05 13:54:49');
INSERT INTO `access_log` VALUES (29308, '64.84.15597140937188487', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:54:54', 10, 0, '', '2019-06-05 13:54:54');
INSERT INTO `access_log` VALUES (29309, '64.76.15597140937188467', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:54:54', 11, 0, '', '2019-06-05 13:54:54');
INSERT INTO `access_log` VALUES (29310, '64.79.15597140972328475', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:54:57', 11, 0, '', '2019-06-05 13:54:57');
INSERT INTO `access_log` VALUES (29311, '64.78.15597140972358487', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:54:57', 9, 0, '', '2019-06-05 13:54:57');
INSERT INTO `access_log` VALUES (29312, '64.81.15597140972318477', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:54:57', 14, 0, '', '2019-06-05 13:54:57');
INSERT INTO `access_log` VALUES (29313, '64.77.15597141078428487', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:55:08', 10, 0, '', '2019-06-05 13:55:08');
INSERT INTO `access_log` VALUES (29314, '59.78.15597141407638731', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:55:41', 11, 0, '', '2019-06-05 13:55:41');
INSERT INTO `access_log` VALUES (29315, '65.54.15597141729888843', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:56:13', 3, 0, '', '2019-06-05 13:56:13');
INSERT INTO `access_log` VALUES (29316, '65.51.15597141846328883', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 13:56:25', 4, 0, '', '2019-06-05 13:56:25');
INSERT INTO `access_log` VALUES (29317, '59.73.15597142042288731', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:56:44', 12, 0, '', '2019-06-05 13:56:44');
INSERT INTO `access_log` VALUES (29318, '59.77.15597142102088721', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:56:50', 11, 0, '', '2019-06-05 13:56:50');
INSERT INTO `access_log` VALUES (29319, '59.76.15597142217478721', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:57:02', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-05 13:57:02');
INSERT INTO `access_log` VALUES (29320, '65.52.15597142259688885', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:57:06', 19, 0, '', '2019-06-05 13:57:06');
INSERT INTO `access_log` VALUES (29321, '65.46.15597142285378879', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:57:09', 209, 0, '', '2019-06-05 13:57:09');
INSERT INTO `access_log` VALUES (29322, '65.3607.15597142324670655', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:57:12', 101, 0, '', '2019-06-05 13:57:13');
INSERT INTO `access_log` VALUES (29323, '65.53.15597142343418853', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '175.171.180.196', '2019-06-05 13:57:14', 14, 0, '', '2019-06-05 13:57:14');
INSERT INTO `access_log` VALUES (29324, '65.3607.15597143629060657', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 13:59:23', 1, 1002001015, '账号未登陆', '2019-06-05 13:59:23');
INSERT INTO `access_log` VALUES (29325, '65.53.15597143629088855', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 13:59:23', 0, 1002001015, '账号未登陆', '2019-06-05 13:59:23');
INSERT INTO `access_log` VALUES (29326, '65.54.15597143629168847', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 13:59:23', 0, 1002001015, '账号未登陆', '2019-06-05 13:59:23');
INSERT INTO `access_log` VALUES (29327, '65.51.15597143672808887', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 13:59:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 13:59:27');
INSERT INTO `access_log` VALUES (29328, '65.49.15597143724278909', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 13:59:32', 78, 0, '', '2019-06-05 13:59:33');
INSERT INTO `access_log` VALUES (29329, '65.47.15597143727598891', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 13:59:33', 9, 0, '', '2019-06-05 13:59:33');
INSERT INTO `access_log` VALUES (29330, '65.52.15597143727658889', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 13:59:33', 9, 0, '', '2019-06-05 13:59:33');
INSERT INTO `access_log` VALUES (29331, '65.46.15597143727698883', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 13:59:33', 8, 0, '', '2019-06-05 13:59:33');
INSERT INTO `access_log` VALUES (29332, '62.86.15597143949908563', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 13:59:55', 2012, 0, '', '2019-06-05 13:59:57');
INSERT INTO `access_log` VALUES (29333, '64.85.15597144060988503', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 14:00:06', 21, 0, '', '2019-06-05 14:00:06');
INSERT INTO `access_log` VALUES (29334, '64.82.15597144060968495', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 14:00:06', 23, 0, '', '2019-06-05 14:00:06');
INSERT INTO `access_log` VALUES (29335, '64.84.15597144115998493', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 14:00:12', 777, 0, '', '2019-06-05 14:00:12');
INSERT INTO `access_log` VALUES (29336, '64.83.15597144115988477', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 14:00:12', 781, 0, '', '2019-06-05 14:00:12');
INSERT INTO `access_log` VALUES (29337, '59.75.15597144130968733', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:00:13', 13, 2001001000, '服务端发生异常', '2019-06-05 14:00:13');
INSERT INTO `access_log` VALUES (29338, '59.74.15597144130978729', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:00:13', 20, 0, '', '2019-06-05 14:00:13');
INSERT INTO `access_log` VALUES (29339, '64.79.15597144182978481', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 14:00:18', 8, 0, '', '2019-06-05 14:00:18');
INSERT INTO `access_log` VALUES (29340, '64.81.15597144182968483', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 14:00:18', 11, 0, '', '2019-06-05 14:00:18');
INSERT INTO `access_log` VALUES (29341, '64.76.15597144182928473', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 14:00:18', 15, 0, '', '2019-06-05 14:00:18');
INSERT INTO `access_log` VALUES (29342, '64.80.15597144222548483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '125.69.76.110', '2019-06-05 14:00:22', 4, 0, '', '2019-06-05 14:00:22');
INSERT INTO `access_log` VALUES (29343, '64.77.15597144225078493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '125.69.76.110', '2019-06-05 14:00:23', 4, 0, '', '2019-06-05 14:00:23');
INSERT INTO `access_log` VALUES (29344, '59.80.15597144253848723', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '125.69.76.110', '2019-06-05 14:00:25', 4, 0, '', '2019-06-05 14:00:25');
INSERT INTO `access_log` VALUES (29345, '59.73.15597144253838735', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '125.69.76.110', '2019-06-05 14:00:25', 13, 2001001000, '服务端发生异常', '2019-06-05 14:00:25');
INSERT INTO `access_log` VALUES (29346, '64.85.15597144287608505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '125.69.76.110', '2019-06-05 14:00:29', 149, 0, '', '2019-06-05 14:00:29');
INSERT INTO `access_log` VALUES (29347, '64.82.15597144292138497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '125.69.76.110', '2019-06-05 14:00:29', 2, 0, '', '2019-06-05 14:00:29');
INSERT INTO `access_log` VALUES (29348, '64.83.15597144305818479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '125.69.76.110', '2019-06-05 14:00:31', 339, 0, '', '2019-06-05 14:00:31');
INSERT INTO `access_log` VALUES (29349, '64.84.15597144312658495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '125.69.76.110', '2019-06-05 14:00:31', 553, 0, '', '2019-06-05 14:00:32');
INSERT INTO `access_log` VALUES (29350, '64.81.15597144352308485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '125.69.76.110', '2019-06-05 14:00:35', 2, 0, '', '2019-06-05 14:00:35');
INSERT INTO `access_log` VALUES (29351, '64.76.15597144355308475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '125.69.76.110', '2019-06-05 14:00:36', 2, 0, '', '2019-06-05 14:00:36');
INSERT INTO `access_log` VALUES (29352, '64.78.15597144377338495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '125.69.76.110', '2019-06-05 14:00:38', 2, 0, '', '2019-06-05 14:00:38');
INSERT INTO `access_log` VALUES (29353, '64.80.15597144379788485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '125.69.76.110', '2019-06-05 14:00:38', 2, 0, '', '2019-06-05 14:00:38');
INSERT INTO `access_log` VALUES (29354, '64.83.15597144890748481', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.67.133', '2019-06-05 14:01:29', 10, 0, '', '2019-06-05 14:01:29');
INSERT INTO `access_log` VALUES (29355, '65.54.15597144965388853', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:01:37', 0, 1002001015, '账号未登陆', '2019-06-05 14:01:37');
INSERT INTO `access_log` VALUES (29356, '65.53.15597144965398861', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:01:37', 0, 1002001015, '账号未登陆', '2019-06-05 14:01:37');
INSERT INTO `access_log` VALUES (29357, '65.3607.15597144966230661', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:01:37', 0, 1002001015, '账号未登陆', '2019-06-05 14:01:37');
INSERT INTO `access_log` VALUES (29358, '65.45.15597145000358905', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:01:40', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 14:01:40');
INSERT INTO `access_log` VALUES (29359, '65.52.15597145045698895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:01:45', 222, 0, '', '2019-06-05 14:01:45');
INSERT INTO `access_log` VALUES (29360, '65.47.15597145053688895', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:01:45', 9, 0, '', '2019-06-05 14:01:45');
INSERT INTO `access_log` VALUES (29361, '65.49.15597145053688911', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:01:45', 10, 0, '', '2019-06-05 14:01:45');
INSERT INTO `access_log` VALUES (29362, '65.46.15597145054258889', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:01:45', 10, 0, '', '2019-06-05 14:01:45');
INSERT INTO `access_log` VALUES (29363, '62.86.15597145287558565', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:02:09', 13, 0, '', '2019-06-05 14:02:09');
INSERT INTO `access_log` VALUES (29364, '65.50.15597145354328887', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:02:15', 19, 0, '', '2019-06-05 14:02:15');
INSERT INTO `access_log` VALUES (29365, '65.53.15597145480608865', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:02:28', 14, 0, '', '2019-06-05 14:02:28');
INSERT INTO `access_log` VALUES (29366, '65.3607.15597145549860665', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:02:35', 9, 0, '', '2019-06-05 14:02:35');
INSERT INTO `access_log` VALUES (29367, '65.51.15597145575378897', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:02:38', 26, 0, '', '2019-06-05 14:02:38');
INSERT INTO `access_log` VALUES (29368, '65.47.15597145694518897', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.69.76.110', '2019-06-05 14:02:49', 11, 0, '', '2019-06-05 14:02:49');
INSERT INTO `access_log` VALUES (29369, '64.81.15597147895758491', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:06:30', 8, 1002001012, '访问令牌已过期', '2019-06-05 14:06:30');
INSERT INTO `access_log` VALUES (29370, '64.84.15597147895758501', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:06:30', 8, 1002001012, '访问令牌已过期', '2019-06-05 14:06:30');
INSERT INTO `access_log` VALUES (29371, '65.53.15597147922948869', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:06:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 14:06:32');
INSERT INTO `access_log` VALUES (29372, '65.3607.15597147956260669', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:06:36', 575, 0, '', '2019-06-05 14:06:36');
INSERT INTO `access_log` VALUES (29373, '65.45.15597147964978913', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:06:36', 609, 0, '', '2019-06-05 14:06:37');
INSERT INTO `access_log` VALUES (29374, '65.51.15597147964948901', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:06:36', 613, 0, '', '2019-06-05 14:06:37');
INSERT INTO `access_log` VALUES (29375, '65.47.15597147964988901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:06:36', 612, 0, '', '2019-06-05 14:06:37');
INSERT INTO `access_log` VALUES (29376, '64.76.15597148004128481', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:06:40', 12, 0, '', '2019-06-05 14:06:40');
INSERT INTO `access_log` VALUES (29377, '64.78.15597148004238501', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:06:40', 9, 0, '', '2019-06-05 14:06:40');
INSERT INTO `access_log` VALUES (29378, '64.77.15597148179218501', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:06:58', 11, 0, '', '2019-06-05 14:06:58');
INSERT INTO `access_log` VALUES (29379, '64.82.15597148265298505', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:07:07', 7, 0, '', '2019-06-05 14:07:07');
INSERT INTO `access_log` VALUES (29380, '64.81.15597148503518493', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:07:30', 9, 0, '', '2019-06-05 14:07:30');
INSERT INTO `access_log` VALUES (29381, '64.84.15597148537268503', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 14:07:34', 6, 1002001012, '访问令牌已过期', '2019-06-05 14:07:34');
INSERT INTO `access_log` VALUES (29382, '64.79.15597148537408491', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 14:07:34', 5, 1002001012, '访问令牌已过期', '2019-06-05 14:07:34');
INSERT INTO `access_log` VALUES (29383, '66.51.15597148591337323', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:07:39', 14, 0, '', '2019-06-05 14:07:39');
INSERT INTO `access_log` VALUES (29384, '65.46.15597148761648897', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:07:56', 9, 0, '', '2019-06-05 14:07:56');
INSERT INTO `access_log` VALUES (29385, '65.49.15597148849688921', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '123.246.202.83', '2019-06-05 14:08:05', 14, 0, '', '2019-06-05 14:08:05');
INSERT INTO `access_log` VALUES (29386, '65.54.15597149038928863', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 14:08:24', 101, 0, '', '2019-06-05 14:08:24');
INSERT INTO `access_log` VALUES (29387, '65.3607.15597149042140671', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 14:08:24', 10, 0, '', '2019-06-05 14:08:24');
INSERT INTO `access_log` VALUES (29388, '65.47.15597149042148905', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 14:08:24', 10, 0, '', '2019-06-05 14:08:24');
INSERT INTO `access_log` VALUES (29389, '65.51.15597149042218903', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 14:08:24', 9, 0, '', '2019-06-05 14:08:24');
INSERT INTO `access_log` VALUES (29390, '64.82.15597149094288507', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 14:08:29', 137, 0, '', '2019-06-05 14:08:30');
INSERT INTO `access_log` VALUES (29391, '64.85.15597149094268515', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 14:08:29', 139, 0, '', '2019-06-05 14:08:30');
INSERT INTO `access_log` VALUES (29392, '65.51.15597153530238911', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/2148 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '223.104.63.195', '2019-06-05 14:15:53', 1, 1002001015, '账号未登陆', '2019-06-05 14:15:53');
INSERT INTO `access_log` VALUES (29393, '59.77.15597154757278739', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:17:56', 5, 0, '', '2019-06-05 14:17:56');
INSERT INTO `access_log` VALUES (29394, '59.76.15597154757278739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:17:56', 15, 2001001000, '服务端发生异常', '2019-06-05 14:17:56');
INSERT INTO `access_log` VALUES (29395, '64.82.15597154855088515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:06', 2, 0, '', '2019-06-05 14:18:06');
INSERT INTO `access_log` VALUES (29396, '64.83.15597154856718497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:06', 1, 0, '', '2019-06-05 14:18:06');
INSERT INTO `access_log` VALUES (29397, '64.81.15597154868518503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:07', 2, 0, '', '2019-06-05 14:18:07');
INSERT INTO `access_log` VALUES (29398, '64.79.15597154875548501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:08', 2, 0, '', '2019-06-05 14:18:08');
INSERT INTO `access_log` VALUES (29399, '64.84.15597154879618513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:08', 2, 0, '', '2019-06-05 14:18:08');
INSERT INTO `access_log` VALUES (29400, '59.78.15597154895448751', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:10', 3, 0, '', '2019-06-05 14:18:10');
INSERT INTO `access_log` VALUES (29401, '59.79.15597154895448747', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:10', 12, 2001001000, '服务端发生异常', '2019-06-05 14:18:10');
INSERT INTO `access_log` VALUES (29402, '59.74.15597154944958745', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:14', 20, 0, '', '2019-06-05 14:18:15');
INSERT INTO `access_log` VALUES (29403, '59.75.15597154944958749', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:14', 23, 2001001000, '服务端发生异常', '2019-06-05 14:18:15');
INSERT INTO `access_log` VALUES (29404, '59.80.15597155064918739', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:18:26', 3, 0, '', '2019-06-05 14:18:26');
INSERT INTO `access_log` VALUES (29405, '64.76.15597155064928493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:18:26', 2, 0, '', '2019-06-05 14:18:26');
INSERT INTO `access_log` VALUES (29406, '59.73.15597155064918751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:18:26', 14, 2001001000, '服务端发生异常', '2019-06-05 14:18:27');
INSERT INTO `access_log` VALUES (29407, '64.80.15597155065928503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:18:27', 2, 0, '', '2019-06-05 14:18:27');
INSERT INTO `access_log` VALUES (29408, '65.50.15597155181718905', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:38', 1, 1002001015, '账号未登陆', '2019-06-05 14:18:38');
INSERT INTO `access_log` VALUES (29409, '65.53.15597155181728887', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:38', 0, 1002001015, '账号未登陆', '2019-06-05 14:18:38');
INSERT INTO `access_log` VALUES (29410, '65.49.15597155181748935', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:38', 0, 1002001015, '账号未登陆', '2019-06-05 14:18:38');
INSERT INTO `access_log` VALUES (29411, '65.47.15597155218688913', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:42', 555, 1002002000, '账号不存在', '2019-06-05 14:18:42');
INSERT INTO `access_log` VALUES (29412, '65.3607.15597155315370679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:52', 83, 0, '', '2019-06-05 14:18:52');
INSERT INTO `access_log` VALUES (29413, '65.45.15597155318648925', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:52', 10, 0, '', '2019-06-05 14:18:52');
INSERT INTO `access_log` VALUES (29414, '65.52.15597155318718915', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:52', 9, 0, '', '2019-06-05 14:18:52');
INSERT INTO `access_log` VALUES (29415, '65.51.15597155318728915', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:18:52', 9, 0, '', '2019-06-05 14:18:52');
INSERT INTO `access_log` VALUES (29416, '62.83.15597155635148593', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:19:24', 13, 0, '', '2019-06-05 14:19:24');
INSERT INTO `access_log` VALUES (29417, '62.84.15597155683538583', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:19:28', 14, 0, '', '2019-06-05 14:19:28');
INSERT INTO `access_log` VALUES (29418, '64.81.15597155751728505', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:19:35', 10, 0, '', '2019-06-05 14:19:35');
INSERT INTO `access_log` VALUES (29419, '64.79.15597155751728503', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:19:35', 11, 0, '', '2019-06-05 14:19:35');
INSERT INTO `access_log` VALUES (29420, '64.78.15597155847248515', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:19:45', 11, 0, '', '2019-06-05 14:19:45');
INSERT INTO `access_log` VALUES (29421, '64.80.15597155872708505', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:19:47', 8, 0, '', '2019-06-05 14:19:47');
INSERT INTO `access_log` VALUES (29422, '64.76.15597155872658495', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:19:47', 118, 0, '', '2019-06-05 14:19:47');
INSERT INTO `access_log` VALUES (29423, '59.71.15597156045248755', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:20:05', 12, 0, '', '2019-06-05 14:20:05');
INSERT INTO `access_log` VALUES (29424, '65.47.15597156064368915', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:06', 1, 1002001015, '账号未登陆', '2019-06-05 14:20:06');
INSERT INTO `access_log` VALUES (29425, '65.3607.15597156064390681', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:06', 0, 1002001015, '账号未登陆', '2019-06-05 14:20:06');
INSERT INTO `access_log` VALUES (29426, '65.45.15597156064468927', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:06', 0, 1002001015, '账号未登陆', '2019-06-05 14:20:06');
INSERT INTO `access_log` VALUES (29427, '65.52.15597156114948917', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:11', 129, 0, '', '2019-06-05 14:20:12');
INSERT INTO `access_log` VALUES (29428, '65.46.15597156119228913', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:12', 10, 0, '', '2019-06-05 14:20:12');
INSERT INTO `access_log` VALUES (29429, '65.49.15597156119278939', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:12', 9, 0, '', '2019-06-05 14:20:12');
INSERT INTO `access_log` VALUES (29430, '65.53.15597156119308891', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:12', 9, 0, '', '2019-06-05 14:20:12');
INSERT INTO `access_log` VALUES (29431, '59.80.15597156154708741', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:20:15', 20, 2001001000, '服务端发生异常', '2019-06-05 14:20:15');
INSERT INTO `access_log` VALUES (29432, '66.48.15597156185567343', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:20:19', 14, 0, '', '2019-06-05 14:20:19');
INSERT INTO `access_log` VALUES (29433, '62.86.15597156203298581', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:20', 12, 0, '', '2019-06-05 14:20:20');
INSERT INTO `access_log` VALUES (29434, '65.54.15597156243918879', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:20:24', 16, 0, '', '2019-06-05 14:20:24');
INSERT INTO `access_log` VALUES (29435, '65.47.15597156372368917', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:37', 234, 0, '', '2019-06-05 14:20:37');
INSERT INTO `access_log` VALUES (29436, '65.45.15597156372388929', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:37', 231, 0, '', '2019-06-05 14:20:37');
INSERT INTO `access_log` VALUES (29437, '65.3607.15597156372420683', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:37', 227, 0, '', '2019-06-05 14:20:37');
INSERT INTO `access_log` VALUES (29438, '65.52.15597156416768919', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:42', 9, 0, '', '2019-06-05 14:20:42');
INSERT INTO `access_log` VALUES (29439, '65.46.15597156416798915', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:42', 9, 0, '', '2019-06-05 14:20:42');
INSERT INTO `access_log` VALUES (29440, '65.53.15597156416828893', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:42', 9, 0, '', '2019-06-05 14:20:42');
INSERT INTO `access_log` VALUES (29441, '65.49.15597156483318941', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:20:48', 16, 0, '', '2019-06-05 14:20:48');
INSERT INTO `access_log` VALUES (29442, '66.53.15597156509697335', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:51', 12, 0, '', '2019-06-05 14:20:51');
INSERT INTO `access_log` VALUES (29443, '65.54.15597156540618881', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:20:54', 166, 0, '', '2019-06-05 14:20:54');
INSERT INTO `access_log` VALUES (29444, '65.47.15597156566388919', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:20:57', 12, 0, '', '2019-06-05 14:20:57');
INSERT INTO `access_log` VALUES (29445, '65.3607.15597156590330685', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:20:59', 16, 0, '', '2019-06-05 14:20:59');
INSERT INTO `access_log` VALUES (29446, '65.45.15597156606248931', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:21:01', 9, 0, '', '2019-06-05 14:21:01');
INSERT INTO `access_log` VALUES (29447, '65.51.15597156613798921', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.203.151.253', '2019-06-05 14:21:01', 9, 0, '', '2019-06-05 14:21:01');
INSERT INTO `access_log` VALUES (29448, '65.46.15597156624898917', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:21:02', 13, 0, '', '2019-06-05 14:21:03');
INSERT INTO `access_log` VALUES (29449, '65.53.15597156675418895', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:21:08', 137, 0, '', '2019-06-05 14:21:08');
INSERT INTO `access_log` VALUES (29450, '65.49.15597156711328943', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:21:11', 14, 0, '', '2019-06-05 14:21:11');
INSERT INTO `access_log` VALUES (29451, '65.54.15597156856648883', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.184.5.25', '2019-06-05 14:21:26', 9, 0, '', '2019-06-05 14:21:26');
INSERT INTO `access_log` VALUES (29452, '65.3607.15597158480000689', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 14:24:08', 4, 1002001012, '访问令牌已过期', '2019-06-05 14:24:08');
INSERT INTO `access_log` VALUES (29453, '65.47.15597158479998923', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 14:24:08', 4, 1002001012, '访问令牌已过期', '2019-06-05 14:24:08');
INSERT INTO `access_log` VALUES (29454, '65.45.15597158480018935', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0', '60.191.94.119', '2019-06-05 14:24:08', 6, 1002001012, '访问令牌已过期', '2019-06-05 14:24:08');
INSERT INTO `access_log` VALUES (29455, '64.84.15597159581788521', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 14:25:58', 9, 0, '', '2019-06-05 14:25:58');
INSERT INTO `access_log` VALUES (29456, '64.79.15597159581788509', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-05 14:25:58', 12, 0, '', '2019-06-05 14:25:58');
INSERT INTO `access_log` VALUES (29457, '59.71.15597163385518765', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.219.98.115', '2019-06-05 14:32:19', 3, 0, '', '2019-06-05 14:32:19');
INSERT INTO `access_log` VALUES (29458, '59.80.15597163385548751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.219.98.115', '2019-06-05 14:32:19', 10, 2001001000, '服务端发生异常', '2019-06-05 14:32:19');
INSERT INTO `access_log` VALUES (29459, '64.83.15597163420798511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.219.98.115', '2019-06-05 14:32:22', 3, 0, '', '2019-06-05 14:32:22');
INSERT INTO `access_log` VALUES (29460, '64.81.15597163422368517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.219.98.115', '2019-06-05 14:32:22', 1, 0, '', '2019-06-05 14:32:22');
INSERT INTO `access_log` VALUES (29461, '64.79.15597163434388515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.219.98.115', '2019-06-05 14:32:23', 83, 0, '', '2019-06-05 14:32:24');
INSERT INTO `access_log` VALUES (29462, '64.84.15597163440258527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.219.98.115', '2019-06-05 14:32:24', 88, 0, '', '2019-06-05 14:32:24');
INSERT INTO `access_log` VALUES (29463, '64.78.15597163476158527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.219.98.115', '2019-06-05 14:32:28', 2, 0, '', '2019-06-05 14:32:28');
INSERT INTO `access_log` VALUES (29464, '64.80.15597163479508517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.219.98.115', '2019-06-05 14:32:28', 2, 0, '', '2019-06-05 14:32:28');
INSERT INTO `access_log` VALUES (29465, '64.76.15597163534528507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.219.98.115', '2019-06-05 14:32:33', 2, 0, '', '2019-06-05 14:32:33');
INSERT INTO `access_log` VALUES (29466, '64.77.15597163535608527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.219.98.115', '2019-06-05 14:32:34', 2, 0, '', '2019-06-05 14:32:34');
INSERT INTO `access_log` VALUES (29467, '59.77.15597163541208753', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.219.98.115', '2019-06-05 14:32:34', 2, 0, '', '2019-06-05 14:32:34');
INSERT INTO `access_log` VALUES (29468, '59.72.15597163541208759', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.219.98.115', '2019-06-05 14:32:34', 12, 2001001000, '服务端发生异常', '2019-06-05 14:32:34');
INSERT INTO `access_log` VALUES (29469, '65.3607.15597171522290707', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:45:52', 0, 1002001015, '账号未登陆', '2019-06-05 14:45:52');
INSERT INTO `access_log` VALUES (29470, '65.47.15597171522298941', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:45:52', 0, 1002001015, '账号未登陆', '2019-06-05 14:45:52');
INSERT INTO `access_log` VALUES (29471, '65.45.15597171522888953', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:45:52', 1, 1002001015, '账号未登陆', '2019-06-05 14:45:52');
INSERT INTO `access_log` VALUES (29472, '65.53.15597171745278917', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:46:15', 64, 0, '', '2019-06-05 14:46:15');
INSERT INTO `access_log` VALUES (29473, '65.52.15597171751968943', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:46:15', 135, 0, '', '2019-06-05 14:46:15');
INSERT INTO `access_log` VALUES (29474, '65.50.15597171752658935', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:46:15', 66, 0, '', '2019-06-05 14:46:15');
INSERT INTO `access_log` VALUES (29475, '65.49.15597171751978965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:46:15', 136, 0, '', '2019-06-05 14:46:15');
INSERT INTO `access_log` VALUES (29476, '62.81.15597171820528597', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:46:22', 14, 0, '', '2019-06-05 14:46:22');
INSERT INTO `access_log` VALUES (29477, '62.82.15597171845898621', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:46:25', 14, 0, '', '2019-06-05 14:46:25');
INSERT INTO `access_log` VALUES (29478, '64.78.15597171868658539', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:46:27', 12, 0, '', '2019-06-05 14:46:27');
INSERT INTO `access_log` VALUES (29479, '64.80.15597171868888529', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:46:27', 9, 0, '', '2019-06-05 14:46:27');
INSERT INTO `access_log` VALUES (29480, '66.50.15597171952567353', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:46:35', 14, 0, '', '2019-06-05 14:46:35');
INSERT INTO `access_log` VALUES (29481, '65.3607.15597172053040709', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:46:45', 19, 0, '', '2019-06-05 14:46:45');
INSERT INTO `access_log` VALUES (29482, '65.45.15597172067298955', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:46:47', 9, 0, '', '2019-06-05 14:46:47');
INSERT INTO `access_log` VALUES (29483, '65.51.15597172094958945', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:46:49', 9, 0, '', '2019-06-05 14:46:50');
INSERT INTO `access_log` VALUES (29484, '65.53.15597172148458919', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:46:55', 13, 0, '', '2019-06-05 14:46:55');
INSERT INTO `access_log` VALUES (29485, '65.50.15597172235088937', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:47:04', 10, 0, '', '2019-06-05 14:47:04');
INSERT INTO `access_log` VALUES (29486, '59.77.15597172308428765', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:47:11', 11, 0, '', '2019-06-05 14:47:11');
INSERT INTO `access_log` VALUES (29487, '59.72.15597172327528771', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:47:13', 18, 2001001000, '服务端发生异常', '2019-06-05 14:47:13');
INSERT INTO `access_log` VALUES (29488, '66.56.15597172366467353', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:47:17', 11, 0, '', '2019-06-05 14:47:17');
INSERT INTO `access_log` VALUES (29489, '65.3607.15597172440170711', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:47:24', 105, 0, '', '2019-06-05 14:47:24');
INSERT INTO `access_log` VALUES (29490, '65.54.15597172439648907', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:47:24', 157, 0, '', '2019-06-05 14:47:24');
INSERT INTO `access_log` VALUES (29491, '65.47.15597172439668945', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:47:24', 156, 0, '', '2019-06-05 14:47:24');
INSERT INTO `access_log` VALUES (29492, '66.49.15597172441427367', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:47:24', 21, 0, '', '2019-06-05 14:47:24');
INSERT INTO `access_log` VALUES (29493, '65.45.15597172468318957', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:47:27', 10, 0, '', '2019-06-05 14:47:27');
INSERT INTO `access_log` VALUES (29494, '65.51.15597172468328947', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:47:27', 10, 0, '', '2019-06-05 14:47:27');
INSERT INTO `access_log` VALUES (29495, '65.46.15597172468628943', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:47:27', 66, 0, '', '2019-06-05 14:47:27');
INSERT INTO `access_log` VALUES (29496, '66.53.15597172472487357', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '43.242.140.116', '2019-06-05 14:47:27', 12, 0, '', '2019-06-05 14:47:27');
INSERT INTO `access_log` VALUES (29497, '65.45.15597187551948977', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-05 15:12:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 15:12:35');
INSERT INTO `access_log` VALUES (29498, '59.80.15597189367838787', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:15:37', 3, 0, '', '2019-06-05 15:15:37');
INSERT INTO `access_log` VALUES (29499, '59.71.15597189367928801', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:15:37', 13, 2001001000, '服务端发生异常', '2019-06-05 15:15:37');
INSERT INTO `access_log` VALUES (29500, '64.77.15597189418938563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:15:42', 2, 0, '', '2019-06-05 15:15:42');
INSERT INTO `access_log` VALUES (29501, '64.85.15597189420238575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:15:42', 2, 0, '', '2019-06-05 15:15:42');
INSERT INTO `access_log` VALUES (29502, '64.82.15597189434868565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:15:43', 2, 0, '', '2019-06-05 15:15:43');
INSERT INTO `access_log` VALUES (29503, '64.79.15597189557278553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:15:56', 2, 0, '', '2019-06-05 15:15:56');
INSERT INTO `access_log` VALUES (29504, '64.84.15597189558518565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:15:56', 2, 0, '', '2019-06-05 15:15:56');
INSERT INTO `access_log` VALUES (29505, '64.78.15597189574728565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:15:57', 2, 0, '', '2019-06-05 15:15:57');
INSERT INTO `access_log` VALUES (29506, '64.80.15597189582718555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:15:58', 2, 0, '', '2019-06-05 15:15:58');
INSERT INTO `access_log` VALUES (29507, '59.77.15597189599568789', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:16:00', 3, 0, '', '2019-06-05 15:16:00');
INSERT INTO `access_log` VALUES (29508, '59.76.15597189599528789', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:16:00', 12, 2001001000, '服务端发生异常', '2019-06-05 15:16:00');
INSERT INTO `access_log` VALUES (29509, '64.81.15597189626418555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:16:03', 2, 0, '', '2019-06-05 15:16:03');
INSERT INTO `access_log` VALUES (29510, '64.76.15597189627858545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:16:03', 2, 0, '', '2019-06-05 15:16:03');
INSERT INTO `access_log` VALUES (29511, '64.77.15597189641238565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:16:04', 2, 0, '', '2019-06-05 15:16:04');
INSERT INTO `access_log` VALUES (29512, '64.85.15597189645918577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:16:05', 2, 0, '', '2019-06-05 15:16:05');
INSERT INTO `access_log` VALUES (29513, '66.48.15597189738947389', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:16:14', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-06-05 15:16:14');
INSERT INTO `access_log` VALUES (29514, '66.57.15597189814247385', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=1111111111&code=111111111111', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:16:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码长度为 4-6 位\n账号长度为 11 位', '2019-06-05 15:16:21');
INSERT INTO `access_log` VALUES (29515, '66.53.15597190040617381', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=1234', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:16:44', 10, 1001003000, '验证码不存在', '2019-06-05 15:16:44');
INSERT INTO `access_log` VALUES (29516, '66.54.15597190069237385', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=1234', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:16:47', 9, 1001003000, '验证码不存在', '2019-06-05 15:16:47');
INSERT INTO `access_log` VALUES (29517, '66.55.15597190097247391', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=123400', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:16:50', 8, 1001003000, '验证码不存在', '2019-06-05 15:16:50');
INSERT INTO `access_log` VALUES (29518, '66.52.15597190194047389', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:16:59', 12, 1001003000, '验证码不存在', '2019-06-05 15:16:59');
INSERT INTO `access_log` VALUES (29519, '66.51.15597190244597381', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:17:04', 8, 1001003000, '验证码不存在', '2019-06-05 15:17:04');
INSERT INTO `access_log` VALUES (29520, '66.56.15597190285567379', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:17:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-05 15:17:09');
INSERT INTO `access_log` VALUES (29521, '66.57.15597190323807387', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:17:12', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-05 15:17:12');
INSERT INTO `access_log` VALUES (29522, '66.49.15597190365817393', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:17:17', 8, 1001003000, '验证码不存在', '2019-06-05 15:17:17');
INSERT INTO `access_log` VALUES (29523, '65.46.15597190551928969', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:17:35', 1, 1002001015, '账号未登陆', '2019-06-05 15:17:35');
INSERT INTO `access_log` VALUES (29524, '65.53.15597190551958945', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:17:35', 0, 1002001015, '账号未登陆', '2019-06-05 15:17:35');
INSERT INTO `access_log` VALUES (29525, '65.50.15597190552108965', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:17:35', 0, 1002001015, '账号未登陆', '2019-06-05 15:17:35');
INSERT INTO `access_log` VALUES (29526, '65.46.15597191523448971', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:19:12', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 15:19:12');
INSERT INTO `access_log` VALUES (29527, '65.50.15597191657838967', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:19:26', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 15:19:26');
INSERT INTO `access_log` VALUES (29528, '65.49.15597191854678995', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:19:45', 136, 0, '', '2019-06-05 15:19:46');
INSERT INTO `access_log` VALUES (29529, '65.54.15597191859538935', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:19:46', 228, 0, '', '2019-06-05 15:19:46');
INSERT INTO `access_log` VALUES (29530, '65.3607.15597191859540739', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:19:46', 226, 0, '', '2019-06-05 15:19:46');
INSERT INTO `access_log` VALUES (29531, '65.47.15597191859518973', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:19:46', 230, 0, '', '2019-06-05 15:19:46');
INSERT INTO `access_log` VALUES (29532, '62.86.15597191893768631', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:19:49', 20, 0, '', '2019-06-05 15:19:49');
INSERT INTO `access_log` VALUES (29533, '59.71.15597191931478805', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:19:53', 108, 0, '', '2019-06-05 15:19:53');
INSERT INTO `access_log` VALUES (29534, '66.54.15597191994757389', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:19:59', 14, 0, '', '2019-06-05 15:19:59');
INSERT INTO `access_log` VALUES (29535, '64.83.15597192092658553', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:20:09', 12, 0, '', '2019-06-05 15:20:09');
INSERT INTO `access_log` VALUES (29536, '64.79.15597192092738557', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:20:09', 8, 0, '', '2019-06-05 15:20:09');
INSERT INTO `access_log` VALUES (29537, '64.84.15597192167148569', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:20:17', 9, 0, '', '2019-06-05 15:20:17');
INSERT INTO `access_log` VALUES (29538, '64.78.15597192167188569', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.168.23.144', '2019-06-05 15:20:17', 10, 0, '', '2019-06-05 15:20:17');
INSERT INTO `access_log` VALUES (29539, '59.73.15597200881508815', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:34:48', 20, 2001001000, '服务端发生异常', '2019-06-05 15:34:48');
INSERT INTO `access_log` VALUES (29540, '59.71.15597200881498817', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:34:48', 120, 0, '', '2019-06-05 15:34:48');
INSERT INTO `access_log` VALUES (29541, '64.84.15597200947588581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:34:55', 44, 0, '', '2019-06-05 15:34:55');
INSERT INTO `access_log` VALUES (29542, '64.80.15597200949298573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:34:55', 2, 0, '', '2019-06-05 15:34:55');
INSERT INTO `access_log` VALUES (29543, '64.81.15597200990898573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:34:59', 2, 0, '', '2019-06-05 15:34:59');
INSERT INTO `access_log` VALUES (29544, '64.76.15597200991698563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:34:59', 2, 0, '', '2019-06-05 15:34:59');
INSERT INTO `access_log` VALUES (29545, '59.72.15597201008048811', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:35:01', 3, 0, '', '2019-06-05 15:35:01');
INSERT INTO `access_log` VALUES (29546, '59.76.15597201008048805', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:35:01', 13, 2001001000, '服务端发生异常', '2019-06-05 15:35:01');
INSERT INTO `access_log` VALUES (29547, '65.45.15597201066418997', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:35:07', 0, 1002001015, '账号未登陆', '2019-06-05 15:35:07');
INSERT INTO `access_log` VALUES (29548, '65.53.15597201066428961', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:35:07', 0, 1002001015, '账号未登陆', '2019-06-05 15:35:07');
INSERT INTO `access_log` VALUES (29549, '65.46.15597201066428985', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:35:07', 0, 1002001015, '账号未登陆', '2019-06-05 15:35:07');
INSERT INTO `access_log` VALUES (29550, '65.50.15597201083618981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:35:08', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 15:35:08');
INSERT INTO `access_log` VALUES (29551, '65.49.15597201107909009', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:35:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 15:35:11');
INSERT INTO `access_log` VALUES (29552, '65.54.15597201118558949', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:35:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 15:35:12');
INSERT INTO `access_log` VALUES (29553, '65.3607.15597201381530753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:35:38', 89, 0, '', '2019-06-05 15:35:38');
INSERT INTO `access_log` VALUES (29554, '65.51.15597201384678989', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:35:38', 10, 0, '', '2019-06-05 15:35:38');
INSERT INTO `access_log` VALUES (29555, '65.53.15597201384698963', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:35:38', 8, 0, '', '2019-06-05 15:35:38');
INSERT INTO `access_log` VALUES (29556, '65.45.15597201384708999', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:35:38', 18, 0, '', '2019-06-05 15:35:38');
INSERT INTO `access_log` VALUES (29557, '62.85.15597201579178655', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:35:58', 14, 0, '', '2019-06-05 15:35:58');
INSERT INTO `access_log` VALUES (29558, '59.80.15597201640408805', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:36:04', 43, 0, '', '2019-06-05 15:36:04');
INSERT INTO `access_log` VALUES (29559, '65.52.15597201673858989', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:36:07', 16, 0, '', '2019-06-05 15:36:07');
INSERT INTO `access_log` VALUES (29560, '59.73.15597201749588817', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.82.213', '2019-06-05 15:36:15', 10, 0, '', '2019-06-05 15:36:15');
INSERT INTO `access_log` VALUES (29561, '59.71.15597202641138821', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:37:44', 4, 0, '', '2019-06-05 15:37:44');
INSERT INTO `access_log` VALUES (29562, '59.74.15597202641138813', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:37:44', 14, 2001001000, '服务端发生异常', '2019-06-05 15:37:44');
INSERT INTO `access_log` VALUES (29563, '64.85.15597202676328597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:37:48', 3, 0, '', '2019-06-05 15:37:48');
INSERT INTO `access_log` VALUES (29564, '64.82.15597202677928587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:37:48', 2, 0, '', '2019-06-05 15:37:48');
INSERT INTO `access_log` VALUES (29565, '64.83.15597202693928569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:37:49', 2, 0, '', '2019-06-05 15:37:49');
INSERT INTO `access_log` VALUES (29566, '64.79.15597202700328573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:37:50', 2, 0, '', '2019-06-05 15:37:50');
INSERT INTO `access_log` VALUES (29567, '65.50.15597202802798985', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:00', 1, 1002001015, '账号未登陆', '2019-06-05 15:38:00');
INSERT INTO `access_log` VALUES (29568, '65.52.15597202802798991', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:00', 0, 1002001015, '账号未登陆', '2019-06-05 15:38:00');
INSERT INTO `access_log` VALUES (29569, '65.49.15597202802809013', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:00', 0, 1002001015, '账号未登陆', '2019-06-05 15:38:00');
INSERT INTO `access_log` VALUES (29570, '65.54.15597202834758953', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 15:38:03');
INSERT INTO `access_log` VALUES (29571, '65.47.15597202864358991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:06', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 15:38:06');
INSERT INTO `access_log` VALUES (29572, '65.3607.15597202874780757', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:38:07', 0, 1002001015, '账号未登陆', '2019-06-05 15:38:07');
INSERT INTO `access_log` VALUES (29573, '65.45.15597202874829003', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:38:07', 1, 1002001015, '账号未登陆', '2019-06-05 15:38:07');
INSERT INTO `access_log` VALUES (29574, '65.53.15597202874878967', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:38:07', 0, 1002001015, '账号未登陆', '2019-06-05 15:38:07');
INSERT INTO `access_log` VALUES (29575, '65.46.15597202900858991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:38:10', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 15:38:10');
INSERT INTO `access_log` VALUES (29576, '59.77.15597202921608809', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:38:12', 3, 0, '', '2019-06-05 15:38:12');
INSERT INTO `access_log` VALUES (29577, '59.72.15597202921618815', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:38:12', 13, 2001001000, '服务端发生异常', '2019-06-05 15:38:12');
INSERT INTO `access_log` VALUES (29578, '65.52.15597202960598993', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:38:16', 108, 0, '', '2019-06-05 15:38:16');
INSERT INTO `access_log` VALUES (29579, '65.50.15597202963998987', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:38:16', 9, 0, '', '2019-06-05 15:38:16');
INSERT INTO `access_log` VALUES (29580, '65.49.15597202964039015', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:38:16', 9, 0, '', '2019-06-05 15:38:16');
INSERT INTO `access_log` VALUES (29581, '65.54.15597202964078955', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:38:16', 8, 0, '', '2019-06-05 15:38:16');
INSERT INTO `access_log` VALUES (29582, '65.47.15597202991588993', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:19', 88, 0, '', '2019-06-05 15:38:19');
INSERT INTO `access_log` VALUES (29583, '65.3607.15597202997170759', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:20', 8, 0, '', '2019-06-05 15:38:20');
INSERT INTO `access_log` VALUES (29584, '65.53.15597202997158969', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:20', 10, 0, '', '2019-06-05 15:38:20');
INSERT INTO `access_log` VALUES (29585, '65.45.15597202997159005', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:20', 10, 0, '', '2019-06-05 15:38:20');
INSERT INTO `access_log` VALUES (29586, '62.81.15597203019748645', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:38:22', 13, 0, '', '2019-06-05 15:38:22');
INSERT INTO `access_log` VALUES (29587, '62.82.15597203048348669', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:25', 12, 0, '', '2019-06-05 15:38:25');
INSERT INTO `access_log` VALUES (29588, '64.81.15597203119558577', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:32', 10, 0, '', '2019-06-05 15:38:32');
INSERT INTO `access_log` VALUES (29589, '64.76.15597203119578567', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:32', 10, 0, '', '2019-06-05 15:38:32');
INSERT INTO `access_log` VALUES (29590, '62.89.15597203123988667', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:38:32', 16, 0, '', '2019-06-05 15:38:32');
INSERT INTO `access_log` VALUES (29591, '64.82.15597203166898589', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:38:37', 12, 0, '', '2019-06-05 15:38:37');
INSERT INTO `access_log` VALUES (29592, '64.85.15597203166898599', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:38:37', 14, 0, '', '2019-06-05 15:38:37');
INSERT INTO `access_log` VALUES (29593, '65.52.15597203225158995', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:43', 15, 0, '', '2019-06-05 15:38:43');
INSERT INTO `access_log` VALUES (29594, '64.79.15597203333958575', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:53', 14, 0, '', '2019-06-05 15:38:53');
INSERT INTO `access_log` VALUES (29595, '64.78.15597203334038587', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:53', 11, 0, '', '2019-06-05 15:38:53');
INSERT INTO `access_log` VALUES (29596, '62.87.15597203352348657', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:55', 10, 0, '', '2019-06-05 15:38:55');
INSERT INTO `access_log` VALUES (29597, '62.81.15597203357178647', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:38:56', 9, 0, '', '2019-06-05 15:38:56');
INSERT INTO `access_log` VALUES (29598, '64.80.15597203561778579', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:39:16', 10, 0, '', '2019-06-05 15:39:16');
INSERT INTO `access_log` VALUES (29599, '64.81.15597203561808579', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:39:16', 8, 0, '', '2019-06-05 15:39:16');
INSERT INTO `access_log` VALUES (29600, '65.45.15597203765489007', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:39:37', 1, 1002001015, '账号未登陆', '2019-06-05 15:39:37');
INSERT INTO `access_log` VALUES (29601, '65.47.15597203765478995', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:39:37', 1, 1002001015, '账号未登陆', '2019-06-05 15:39:37');
INSERT INTO `access_log` VALUES (29602, '65.53.15597203765518971', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:39:37', 1, 1002001015, '账号未登陆', '2019-06-05 15:39:37');
INSERT INTO `access_log` VALUES (29603, '64.82.15597203851688591', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:39:45', 9, 0, '', '2019-06-05 15:39:45');
INSERT INTO `access_log` VALUES (29604, '64.83.15597203851728573', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:39:45', 8, 0, '', '2019-06-05 15:39:45');
INSERT INTO `access_log` VALUES (29605, '64.85.15597203851688601', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:39:45', 14, 0, '', '2019-06-05 15:39:45');
INSERT INTO `access_log` VALUES (29606, '64.84.15597203913098589', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:39:51', 8, 0, '', '2019-06-05 15:39:51');
INSERT INTO `access_log` VALUES (29607, '64.78.15597203913098589', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:39:51', 9, 0, '', '2019-06-05 15:39:51');
INSERT INTO `access_log` VALUES (29608, '59.73.15597203934728821', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:39:53', 3, 0, '', '2019-06-05 15:39:53');
INSERT INTO `access_log` VALUES (29609, '59.77.15597203934728811', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:39:53', 13, 2001001000, '服务端发生异常', '2019-06-05 15:39:53');
INSERT INTO `access_log` VALUES (29610, '64.81.15597203951728581', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:39:55', 539, 0, '', '2019-06-05 15:39:56');
INSERT INTO `access_log` VALUES (29611, '64.80.15597203951718581', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:39:55', 541, 0, '', '2019-06-05 15:39:56');
INSERT INTO `access_log` VALUES (29612, '64.77.15597203957928591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:39:56', 378, 0, '', '2019-06-05 15:39:56');
INSERT INTO `access_log` VALUES (29613, '64.76.15597203951728571', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:39:55', 1001, 0, '', '2019-06-05 15:39:56');
INSERT INTO `access_log` VALUES (29614, '64.83.15597203963528575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:39:56', 2, 0, '', '2019-06-05 15:39:56');
INSERT INTO `access_log` VALUES (29615, '64.85.15597203976328603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:39:58', 2, 0, '', '2019-06-05 15:39:58');
INSERT INTO `access_log` VALUES (29616, '64.82.15597203984328593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:39:58', 1, 0, '', '2019-06-05 15:39:58');
INSERT INTO `access_log` VALUES (29617, '64.79.15597203998678579', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:40:00', 9, 0, '', '2019-06-05 15:40:00');
INSERT INTO `access_log` VALUES (29618, '66.55.15597204026727411', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:40:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字', '2019-06-05 15:40:03');
INSERT INTO `access_log` VALUES (29619, '65.52.15597204141218997', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:40:14', 71, 0, '', '2019-06-05 15:40:14');
INSERT INTO `access_log` VALUES (29620, '65.49.15597204144839019', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:40:14', 9, 0, '', '2019-06-05 15:40:14');
INSERT INTO `access_log` VALUES (29621, '65.50.15597204144878991', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:40:14', 9, 0, '', '2019-06-05 15:40:14');
INSERT INTO `access_log` VALUES (29622, '65.54.15597204144918959', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:40:14', 9, 0, '', '2019-06-05 15:40:15');
INSERT INTO `access_log` VALUES (29623, '66.52.15597204177097409', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:40:18', 13, 0, '', '2019-06-05 15:40:18');
INSERT INTO `access_log` VALUES (29624, '59.78.15597204223198823', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:40:22', 2127, 0, '', '2019-06-05 15:40:24');
INSERT INTO `access_log` VALUES (29625, '59.79.15597204250288819', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:40:25', 20, 2001001000, '服务端发生异常', '2019-06-05 15:40:25');
INSERT INTO `access_log` VALUES (29626, '65.45.15597204281709009', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:40:28', 19, 0, '', '2019-06-05 15:40:28');
INSERT INTO `access_log` VALUES (29627, '65.53.15597204300958973', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:40:30', 11, 0, '', '2019-06-05 15:40:30');
INSERT INTO `access_log` VALUES (29628, '65.3607.15597204307060763', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:40:31', 8, 0, '', '2019-06-05 15:40:31');
INSERT INTO `access_log` VALUES (29629, '65.51.15597204311598999', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.185.31', '2019-06-05 15:40:31', 14, 0, '', '2019-06-05 15:40:31');
INSERT INTO `access_log` VALUES (29630, '64.80.15597204359538583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:40:36', 1, 0, '', '2019-06-05 15:40:36');
INSERT INTO `access_log` VALUES (29631, '64.76.15597204361128573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.23.189', '2019-06-05 15:40:36', 2, 0, '', '2019-06-05 15:40:36');
INSERT INTO `access_log` VALUES (29632, '65.52.15597204479648999', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:40:48', 18, 0, '', '2019-06-05 15:40:48');
INSERT INTO `access_log` VALUES (29633, '65.49.15597204502319021', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:40:50', 9, 0, '', '2019-06-05 15:40:50');
INSERT INTO `access_log` VALUES (29634, '65.50.15597204534938993', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:40:53', 8, 0, '', '2019-06-05 15:40:54');
INSERT INTO `access_log` VALUES (29635, '65.47.15597204566358999', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:40:57', 15, 0, '', '2019-06-05 15:40:57');
INSERT INTO `access_log` VALUES (29636, '65.45.15597204661799011', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:41:06', 18, 0, '', '2019-06-05 15:41:06');
INSERT INTO `access_log` VALUES (29637, '65.53.15597204671218975', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:41:07', 17, 0, '', '2019-06-05 15:41:07');
INSERT INTO `access_log` VALUES (29638, '65.51.15597204701159001', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:41:10', 10, 0, '', '2019-06-05 15:41:10');
INSERT INTO `access_log` VALUES (29639, '65.46.15597204726668999', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-05 15:41:13', 1, 1002001015, '账号未登陆', '2019-06-05 15:41:13');
INSERT INTO `access_log` VALUES (29640, '65.52.15597204726669001', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-05 15:41:13', 1, 1002001015, '账号未登陆', '2019-06-05 15:41:13');
INSERT INTO `access_log` VALUES (29641, '65.49.15597204726669023', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-05 15:41:13', 1, 1002001015, '账号未登陆', '2019-06-05 15:41:13');
INSERT INTO `access_log` VALUES (29642, '65.50.15597204730618995', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.61.27.2', '2019-06-05 15:41:13', 13, 0, '', '2019-06-05 15:41:13');
INSERT INTO `access_log` VALUES (29643, '65.54.15597204828408963', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-05 15:41:23', 626, 0, '', '2019-06-05 15:41:23');
INSERT INTO `access_log` VALUES (29644, '65.53.15597204839258977', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-05 15:41:24', 96, 0, '', '2019-06-05 15:41:24');
INSERT INTO `access_log` VALUES (29645, '65.45.15597204839229013', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-05 15:41:24', 100, 0, '', '2019-06-05 15:41:24');
INSERT INTO `access_log` VALUES (29646, '65.47.15597204839209001', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-05 15:41:24', 101, 0, '', '2019-06-05 15:41:24');
INSERT INTO `access_log` VALUES (29647, '62.83.15597204988228671', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-05 15:41:39', 14, 0, '', '2019-06-05 15:41:39');
INSERT INTO `access_log` VALUES (29648, '65.49.15597205128519025', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-05 15:41:53', 20, 0, '', '2019-06-05 15:41:53');
INSERT INTO `access_log` VALUES (29649, '65.46.15597205190969001', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-05 15:41:59', 11, 0, '', '2019-06-05 15:41:59');
INSERT INTO `access_log` VALUES (29650, '65.50.15597205203988997', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-05 15:42:00', 9, 0, '', '2019-06-05 15:42:00');
INSERT INTO `access_log` VALUES (29651, '66.55.15597205240007413', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-05 15:42:04', 24, 0, '', '2019-06-05 15:42:04');
INSERT INTO `access_log` VALUES (29652, '64.78.15597205260788593', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-05 15:42:06', 11, 0, '', '2019-06-05 15:42:06');
INSERT INTO `access_log` VALUES (29653, '64.81.15597205260788585', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-05 15:42:06', 11, 0, '', '2019-06-05 15:42:06');
INSERT INTO `access_log` VALUES (29654, '66.50.15597206730457403', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:44:33', 14, 1001003000, '验证码不存在', '2019-06-05 15:44:33');
INSERT INTO `access_log` VALUES (29655, '66.51.15597206769747405', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=12345678911', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.168.23.144', '2019-06-05 15:44:37', 63, 0, '', '2019-06-05 15:44:37');
INSERT INTO `access_log` VALUES (29656, '59.71.15597216246278841', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:25', 13, 2001001000, '服务端发生异常', '2019-06-05 16:00:25');
INSERT INTO `access_log` VALUES (29657, '59.75.15597216246258837', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:25', 81, 0, '', '2019-06-05 16:00:25');
INSERT INTO `access_log` VALUES (29658, '64.83.15597216351798593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:35', 452, 0, '', '2019-06-05 16:00:36');
INSERT INTO `access_log` VALUES (29659, '64.82.15597216360178611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:36', 78, 0, '', '2019-06-05 16:00:36');
INSERT INTO `access_log` VALUES (29660, '64.79.15597216381848597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:38', 417, 0, '', '2019-06-05 16:00:39');
INSERT INTO `access_log` VALUES (29661, '64.84.15597216388458609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:39', 2, 0, '', '2019-06-05 16:00:39');
INSERT INTO `access_log` VALUES (29662, '64.78.15597216393258609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:39', 2, 0, '', '2019-06-05 16:00:39');
INSERT INTO `access_log` VALUES (29663, '59.80.15597216425818827', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:43', 3, 0, '', '2019-06-05 16:00:43');
INSERT INTO `access_log` VALUES (29664, '59.73.15597216425828839', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:43', 14, 2001001000, '服务端发生异常', '2019-06-05 16:00:43');
INSERT INTO `access_log` VALUES (29665, '64.81.15597216448368601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:45', 2, 0, '', '2019-06-05 16:00:45');
INSERT INTO `access_log` VALUES (29666, '64.80.15597216449488601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:45', 2, 0, '', '2019-06-05 16:00:45');
INSERT INTO `access_log` VALUES (29667, '59.77.15597216474688829', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:47', 2, 0, '', '2019-06-05 16:00:47');
INSERT INTO `access_log` VALUES (29668, '59.72.15597216474688835', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:47', 18, 2001001000, '服务端发生异常', '2019-06-05 16:00:47');
INSERT INTO `access_log` VALUES (29669, '59.78.15597216524738841', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:52', 2, 0, '', '2019-06-05 16:00:52');
INSERT INTO `access_log` VALUES (29670, '59.79.15597216524748837', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:00:52', 13, 2001001000, '服务端发生异常', '2019-06-05 16:00:52');
INSERT INTO `access_log` VALUES (29671, '59.73.15597216963698841', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.175.138.26', '2019-06-05 16:01:36', 13, 2001001000, '服务端发生异常', '2019-06-05 16:01:36');
INSERT INTO `access_log` VALUES (29672, '59.80.15597216963688829', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.175.138.26', '2019-06-05 16:01:36', 473, 0, '', '2019-06-05 16:01:37');
INSERT INTO `access_log` VALUES (29673, '59.74.15597219404198839', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.14.78.156', '2019-06-05 16:05:40', 13, 2001001000, '服务端发生异常', '2019-06-05 16:05:40');
INSERT INTO `access_log` VALUES (29674, '59.71.15597219404198847', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.14.78.156', '2019-06-05 16:05:40', 95, 0, '', '2019-06-05 16:05:41');
INSERT INTO `access_log` VALUES (29675, '65.54.15597223463548991', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 16:12:26', 4, 1002001012, '访问令牌已过期', '2019-06-05 16:12:26');
INSERT INTO `access_log` VALUES (29676, '65.49.15597223463549049', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 16:12:26', 4, 1002001012, '访问令牌已过期', '2019-06-05 16:12:26');
INSERT INTO `access_log` VALUES (29677, '65.51.15597223463549029', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 16:12:26', 5, 1002001012, '访问令牌已过期', '2019-06-05 16:12:26');
INSERT INTO `access_log` VALUES (29678, '64.78.15597223465138619', 0, 2, 'product-application', '/product-api/admins/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 16:12:27', 6, 1002001012, '访问令牌已过期', '2019-06-05 16:12:27');
INSERT INTO `access_log` VALUES (29679, '64.81.15597223465158611', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 16:12:27', 6, 1002001012, '访问令牌已过期', '2019-06-05 16:12:27');
INSERT INTO `access_log` VALUES (29680, '64.80.15597223465208611', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 16:12:27', 6, 1002001012, '访问令牌已过期', '2019-06-05 16:12:27');
INSERT INTO `access_log` VALUES (29681, '65.52.15597223497559031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 16:12:30', 77, 0, '', '2019-06-05 16:12:30');
INSERT INTO `access_log` VALUES (29682, '65.46.15597223500559029', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 16:12:30', 11, 0, '', '2019-06-05 16:12:30');
INSERT INTO `access_log` VALUES (29683, '65.45.15597223500569043', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 16:12:30', 12, 0, '', '2019-06-05 16:12:30');
INSERT INTO `access_log` VALUES (29684, '65.50.15597223500609023', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 16:12:30', 10, 0, '', '2019-06-05 16:12:30');
INSERT INTO `access_log` VALUES (29685, '64.77.15597223524898621', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 16:12:32', 8, 0, '', '2019-06-05 16:12:32');
INSERT INTO `access_log` VALUES (29686, '64.76.15597223524888601', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '60.176.88.206', '2019-06-05 16:12:32', 12, 0, '', '2019-06-05 16:12:33');
INSERT INTO `access_log` VALUES (29687, '59.78.15597226274518855', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.1.104', '2019-06-05 16:17:07', 4, 0, '', '2019-06-05 16:17:07');
INSERT INTO `access_log` VALUES (29688, '59.75.15597226274518853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.1.104', '2019-06-05 16:17:07', 13, 2001001000, '服务端发生异常', '2019-06-05 16:17:07');
INSERT INTO `access_log` VALUES (29689, '64.76.15597226308588605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.1.104', '2019-06-05 16:17:11', 98, 0, '', '2019-06-05 16:17:11');
INSERT INTO `access_log` VALUES (29690, '64.85.15597226310928637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.1.104', '2019-06-05 16:17:11', 3, 0, '', '2019-06-05 16:17:11');
INSERT INTO `access_log` VALUES (29691, '64.83.15597226328868609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.1.104', '2019-06-05 16:17:13', 2, 0, '', '2019-06-05 16:17:13');
INSERT INTO `access_log` VALUES (29692, '64.82.15597226335808627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.1.104', '2019-06-05 16:17:14', 2, 0, '', '2019-06-05 16:17:14');
INSERT INTO `access_log` VALUES (29693, '59.71.15597226356218857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.1.104', '2019-06-05 16:17:16', 2, 0, '', '2019-06-05 16:17:16');
INSERT INTO `access_log` VALUES (29694, '59.74.15597226356218849', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.1.104', '2019-06-05 16:17:16', 13, 2001001000, '服务端发生异常', '2019-06-05 16:17:16');
INSERT INTO `access_log` VALUES (29695, '59.80.15597226422338843', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.1.104', '2019-06-05 16:17:22', 2, 0, '', '2019-06-05 16:17:22');
INSERT INTO `access_log` VALUES (29696, '59.77.15597226422338845', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.1.104', '2019-06-05 16:17:22', 13, 2001001000, '服务端发生异常', '2019-06-05 16:17:22');
INSERT INTO `access_log` VALUES (29697, '65.51.15597226964789035', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:18:16', 0, 1002001015, '账号未登陆', '2019-06-05 16:18:16');
INSERT INTO `access_log` VALUES (29698, '65.49.15597226964839055', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:18:16', 0, 1002001015, '账号未登陆', '2019-06-05 16:18:16');
INSERT INTO `access_log` VALUES (29699, '65.54.15597226964968997', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:18:16', 0, 1002001015, '账号未登陆', '2019-06-05 16:18:16');
INSERT INTO `access_log` VALUES (29700, '65.52.15597226986809037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:18:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 16:18:19');
INSERT INTO `access_log` VALUES (29701, '65.46.15597227098099035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:18:30', 114, 0, '', '2019-06-05 16:18:30');
INSERT INTO `access_log` VALUES (29702, '65.45.15597227102719049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:18:30', 180, 0, '', '2019-06-05 16:18:30');
INSERT INTO `access_log` VALUES (29703, '65.53.15597227103089011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:18:30', 143, 0, '', '2019-06-05 16:18:30');
INSERT INTO `access_log` VALUES (29704, '65.47.15597227102749033', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:18:30', 177, 0, '', '2019-06-05 16:18:30');
INSERT INTO `access_log` VALUES (29705, '62.83.15597227208208701', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:18:41', 21, 0, '', '2019-06-05 16:18:41');
INSERT INTO `access_log` VALUES (29706, '62.84.15597227269768691', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:18:47', 15, 0, '', '2019-06-05 16:18:47');
INSERT INTO `access_log` VALUES (29707, '64.83.15597227317268611', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:18:52', 9, 0, '', '2019-06-05 16:18:52');
INSERT INTO `access_log` VALUES (29708, '64.85.15597227317238639', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:18:52', 12, 0, '', '2019-06-05 16:18:52');
INSERT INTO `access_log` VALUES (29709, '64.79.15597227355878615', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:18:56', 207, 0, '', '2019-06-05 16:18:56');
INSERT INTO `access_log` VALUES (29710, '64.82.15597227355828629', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:18:56', 215, 0, '', '2019-06-05 16:18:56');
INSERT INTO `access_log` VALUES (29711, '64.84.15597227430458627', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:19:03', 8, 0, '', '2019-06-05 16:19:03');
INSERT INTO `access_log` VALUES (29712, '64.80.15597227440328619', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:19:04', 9, 0, '', '2019-06-05 16:19:04');
INSERT INTO `access_log` VALUES (29713, '64.78.15597227452358627', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:19:05', 11, 0, '', '2019-06-05 16:19:05');
INSERT INTO `access_log` VALUES (29714, '64.76.15597227463418609', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:19:06', 9, 0, '', '2019-06-05 16:19:06');
INSERT INTO `access_log` VALUES (29715, '64.77.15597227463408629', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:19:06', 11, 0, '', '2019-06-05 16:19:06');
INSERT INTO `access_log` VALUES (29716, '64.85.15597227505588641', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:19:11', 370, 0, '', '2019-06-05 16:19:11');
INSERT INTO `access_log` VALUES (29717, '59.72.15597227775578853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:38', 12, 2001001000, '服务端发生异常', '2019-06-05 16:19:38');
INSERT INTO `access_log` VALUES (29718, '59.77.15597227775578847', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:38', 667, 0, '', '2019-06-05 16:19:38');
INSERT INTO `access_log` VALUES (29719, '64.82.15597227811568631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:41', 2, 0, '', '2019-06-05 16:19:41');
INSERT INTO `access_log` VALUES (29720, '64.84.15597227815228629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:42', 1, 0, '', '2019-06-05 16:19:42');
INSERT INTO `access_log` VALUES (29721, '66.48.15597227825127443', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:19:43', 24, 0, '', '2019-06-05 16:19:43');
INSERT INTO `access_log` VALUES (29722, '64.80.15597227826928621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:43', 2, 0, '', '2019-06-05 16:19:43');
INSERT INTO `access_log` VALUES (29723, '64.78.15597227831938629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:43', 2, 0, '', '2019-06-05 16:19:43');
INSERT INTO `access_log` VALUES (29724, '64.81.15597227835938621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:44', 2, 0, '', '2019-06-05 16:19:44');
INSERT INTO `access_log` VALUES (29725, '64.77.15597227837808631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:44', 2, 0, '', '2019-06-05 16:19:44');
INSERT INTO `access_log` VALUES (29726, '59.76.15597227845578847', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:45', 3, 0, '', '2019-06-05 16:19:45');
INSERT INTO `access_log` VALUES (29727, '59.79.15597227845588855', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:45', 18, 2001001000, '服务端发生异常', '2019-06-05 16:19:45');
INSERT INTO `access_log` VALUES (29728, '64.76.15597227863908611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:46', 1, 0, '', '2019-06-05 16:19:46');
INSERT INTO `access_log` VALUES (29729, '64.85.15597227864978643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:46', 2, 0, '', '2019-06-05 16:19:47');
INSERT INTO `access_log` VALUES (29730, '64.83.15597227873078615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:47', 2, 0, '', '2019-06-05 16:19:47');
INSERT INTO `access_log` VALUES (29731, '59.78.15597227889288859', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:49', 2, 0, '', '2019-06-05 16:19:49');
INSERT INTO `access_log` VALUES (29732, '59.75.15597227889318857', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:19:49', 13, 2001001000, '服务端发生异常', '2019-06-05 16:19:49');
INSERT INTO `access_log` VALUES (29733, '65.46.15597227963909037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:19:56', 160, 0, '', '2019-06-05 16:19:57');
INSERT INTO `access_log` VALUES (29734, '65.53.15597227995079013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:20:00', 1, 1002001015, '账号未登陆', '2019-06-05 16:20:00');
INSERT INTO `access_log` VALUES (29735, '65.47.15597227995279035', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:20:00', 0, 1002001015, '账号未登陆', '2019-06-05 16:20:00');
INSERT INTO `access_log` VALUES (29736, '65.45.15597227995639051', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:20:00', 0, 1002001015, '账号未登陆', '2019-06-05 16:20:00');
INSERT INTO `access_log` VALUES (29737, '65.3607.15597228018300805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '106.39.148.5', '2019-06-05 16:20:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 16:20:02');
INSERT INTO `access_log` VALUES (29738, '65.54.15597228355309001', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:20:36', 10, 0, '', '2019-06-05 16:20:36');
INSERT INTO `access_log` VALUES (29739, '65.50.15597228397619033', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:20:40', 10, 0, '', '2019-06-05 16:20:40');
INSERT INTO `access_log` VALUES (29740, '64.78.15597228412208631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.239.120', '2019-06-05 16:20:41', 1, 0, '', '2019-06-05 16:20:41');
INSERT INTO `access_log` VALUES (29741, '65.46.15597228417539039', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:20:42', 15, 0, '', '2019-06-05 16:20:42');
INSERT INTO `access_log` VALUES (29742, '64.81.15597228428478623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.89.239.232', '2019-06-05 16:20:43', 2, 0, '', '2019-06-05 16:20:43');
INSERT INTO `access_log` VALUES (29743, '64.77.15597228448568633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.129.6.151', '2019-06-05 16:20:45', 2, 0, '', '2019-06-05 16:20:45');
INSERT INTO `access_log` VALUES (29744, '59.72.15597228460728855', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:20:46', 12, 0, '', '2019-06-05 16:20:46');
INSERT INTO `access_log` VALUES (29745, '59.76.15597228504808849', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:20:50', 21, 2001001000, '服务端发生异常', '2019-06-05 16:20:51');
INSERT INTO `access_log` VALUES (29746, '59.79.15597228545888857', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:20:55', 11, 0, '', '2019-06-05 16:20:55');
INSERT INTO `access_log` VALUES (29747, '59.78.15597228574428861', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:20:57', 11, 0, '', '2019-06-05 16:20:57');
INSERT INTO `access_log` VALUES (29748, '59.75.15597228594028859', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:20:59', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-05 16:20:59');
INSERT INTO `access_log` VALUES (29749, '66.55.15597228619937445', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '61.148.202.254', '2019-06-05 16:21:02', 15, 0, '', '2019-06-05 16:21:02');
INSERT INTO `access_log` VALUES (29750, '65.54.15597241399189021', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:20', 4, 1002001012, '访问令牌已过期', '2019-06-05 16:42:20');
INSERT INTO `access_log` VALUES (29751, '65.49.15597241399179077', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:20', 4, 1002001012, '访问令牌已过期', '2019-06-05 16:42:20');
INSERT INTO `access_log` VALUES (29752, '65.50.15597241399479051', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:20', 3, 1002001012, '访问令牌已过期', '2019-06-05 16:42:20');
INSERT INTO `access_log` VALUES (29753, '65.52.15597241436729059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:24', 58, 0, '', '2019-06-05 16:42:24');
INSERT INTO `access_log` VALUES (29754, '65.53.15597241440799035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:24', 9, 0, '', '2019-06-05 16:42:24');
INSERT INTO `access_log` VALUES (29755, '65.47.15597241440829057', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:24', 8, 0, '', '2019-06-05 16:42:24');
INSERT INTO `access_log` VALUES (29756, '65.45.15597241440859071', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:24', 7, 0, '', '2019-06-05 16:42:24');
INSERT INTO `access_log` VALUES (29757, '62.89.15597241475968721', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:28', 20, 0, '', '2019-06-05 16:42:28');
INSERT INTO `access_log` VALUES (29758, '64.81.15597241517968641', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:32', 10, 0, '', '2019-06-05 16:42:32');
INSERT INTO `access_log` VALUES (29759, '64.78.15597241517968649', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:32', 11, 0, '', '2019-06-05 16:42:32');
INSERT INTO `access_log` VALUES (29760, '64.76.15597241555278631', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:36', 361, 0, '', '2019-06-05 16:42:36');
INSERT INTO `access_log` VALUES (29761, '64.85.15597241555278663', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:36', 363, 0, '', '2019-06-05 16:42:36');
INSERT INTO `access_log` VALUES (29762, '64.83.15597241599868635', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:40', 13, 0, '', '2019-06-05 16:42:40');
INSERT INTO `access_log` VALUES (29763, '64.82.15597241600048653', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:40', 8, 0, '', '2019-06-05 16:42:40');
INSERT INTO `access_log` VALUES (29764, '64.79.15597241600038639', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:42:40', 10, 0, '', '2019-06-05 16:42:40');
INSERT INTO `access_log` VALUES (29765, '64.77.15597242075178653', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:43:28', 9, 0, '', '2019-06-05 16:43:28');
INSERT INTO `access_log` VALUES (29766, '64.78.15597242075178651', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:43:28', 10, 0, '', '2019-06-05 16:43:28');
INSERT INTO `access_log` VALUES (29767, '64.76.15597242099168633', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:43:30', 9, 0, '', '2019-06-05 16:43:30');
INSERT INTO `access_log` VALUES (29768, '66.48.15597243960977465', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:46:36', 468, 0, '', '2019-06-05 16:46:37');
INSERT INTO `access_log` VALUES (29769, '59.80.15597244062708869', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:46:46', 12, 0, '', '2019-06-05 16:46:46');
INSERT INTO `access_log` VALUES (29770, '59.77.15597244128108871', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:46:53', 20, 2001001000, '服务端发生异常', '2019-06-05 16:46:53');
INSERT INTO `access_log` VALUES (29771, '59.76.15597244170658871', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-05 16:46:57', 11, 0, '', '2019-06-05 16:46:57');
INSERT INTO `access_log` VALUES (29772, '59.73.15597246392698885', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&title=满 10 元,&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 16:50:39', 163, 0, '', '2019-06-05 16:50:39');
INSERT INTO `access_log` VALUES (29773, '59.80.15597246428298873', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&title=满 10 元&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 16:50:43', 11, 0, '', '2019-06-05 16:50:43');
INSERT INTO `access_log` VALUES (29774, '59.72.15597246472968881', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&title=满&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 16:50:47', 147, 0, '', '2019-06-05 16:50:47');
INSERT INTO `access_log` VALUES (29775, '59.76.15597246498288875', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 16:50:50', 11, 0, '', '2019-06-05 16:50:50');
INSERT INTO `access_log` VALUES (29776, '59.73.15597247312398887', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&title=A&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 16:52:11', 10, 0, '', '2019-06-05 16:52:11');
INSERT INTO `access_log` VALUES (29777, '64.78.15597247588208659', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 16:52:39', 54, 0, '', '2019-06-05 16:52:39');
INSERT INTO `access_log` VALUES (29778, '64.77.15597247647088661', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 16:52:45', 10, 0, '', '2019-06-05 16:52:45');
INSERT INTO `access_log` VALUES (29779, '62.85.15597247730678727', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 16:52:53', 23, 0, '', '2019-06-05 16:52:53');
INSERT INTO `access_log` VALUES (29780, '64.77.15597256548108673', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:07:35', 14, 0, '', '2019-06-05 17:07:35');
INSERT INTO `access_log` VALUES (29781, '64.76.15597256548188653', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:07:35', 9, 0, '', '2019-06-05 17:07:35');
INSERT INTO `access_log` VALUES (29782, '66.54.15597256603897477', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:07:40', 14, 0, '', '2019-06-05 17:07:40');
INSERT INTO `access_log` VALUES (29783, '64.82.15597258110328677', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:10:11', 11, 0, '', '2019-06-05 17:10:11');
INSERT INTO `access_log` VALUES (29784, '64.83.15597258110328659', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:10:11', 13, 0, '', '2019-06-05 17:10:11');
INSERT INTO `access_log` VALUES (29785, '64.84.15597258161108675', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:10:16', 17, 0, '', '2019-06-05 17:10:16');
INSERT INTO `access_log` VALUES (29786, '64.79.15597258161098663', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:10:16', 1594, 0, '', '2019-06-05 17:10:18');
INSERT INTO `access_log` VALUES (29787, '64.81.15597258290898667', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:10:29', 10, 0, '', '2019-06-05 17:10:29');
INSERT INTO `access_log` VALUES (29788, '59.79.15597259972218901', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:13:17', 21, 2001001000, '服务端发生异常', '2019-06-05 17:13:17');
INSERT INTO `access_log` VALUES (29789, '59.75.15597260006008903', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:13:21', 18, 0, '', '2019-06-05 17:13:21');
INSERT INTO `access_log` VALUES (29790, '59.71.15597260107198907', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:13:31', 60, 0, '', '2019-06-05 17:13:31');
INSERT INTO `access_log` VALUES (29791, '59.80.15597260338298893', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:13:54', 2, 0, '', '2019-06-05 17:13:54');
INSERT INTO `access_log` VALUES (29792, '59.72.15597260338308901', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:13:54', 14, 2001001000, '服务端发生异常', '2019-06-05 17:13:54');
INSERT INTO `access_log` VALUES (29793, '64.82.15597260359078681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:13:56', 3, 0, '', '2019-06-05 17:13:56');
INSERT INTO `access_log` VALUES (29794, '64.83.15597260362608663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:13:56', 1, 0, '', '2019-06-05 17:13:56');
INSERT INTO `access_log` VALUES (29795, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=切&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:00', 13, 0, '', '2019-06-05 17:14:00');
INSERT INTO `access_log` VALUES (29796, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=切', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:00', 9, 0, '', '2019-06-05 17:14:00');
INSERT INTO `access_log` VALUES (29797, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=衣服&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:04', 7, 0, '', '2019-06-05 17:14:04');
INSERT INTO `access_log` VALUES (29798, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=衣服', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:04', 7, 0, '', '2019-06-05 17:14:04');
INSERT INTO `access_log` VALUES (29799, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=衣服&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:05', 6, 0, '', '2019-06-05 17:14:05');
INSERT INTO `access_log` VALUES (29800, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=衣服', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:05', 7, 0, '', '2019-06-05 17:14:05');
INSERT INTO `access_log` VALUES (29801, '64.79.15597260470688667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:07', 2, 0, '', '2019-06-05 17:14:07');
INSERT INTO `access_log` VALUES (29802, '64.80.15597260472468671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:07', 81, 0, '', '2019-06-05 17:14:07');
INSERT INTO `access_log` VALUES (29803, '64.81.15597260481408671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:08', 1, 0, '', '2019-06-05 17:14:08');
INSERT INTO `access_log` VALUES (29804, '64.78.15597260489208679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:09', 134, 0, '', '2019-06-05 17:14:09');
INSERT INTO `access_log` VALUES (29805, '59.79.15597260496148903', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:10', 12, 2001001000, '服务端发生异常', '2019-06-05 17:14:10');
INSERT INTO `access_log` VALUES (29806, '59.76.15597260496148895', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:10', 221, 0, '', '2019-06-05 17:14:10');
INSERT INTO `access_log` VALUES (29807, '64.76.15597260556318661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:16', 2, 0, '', '2019-06-05 17:14:16');
INSERT INTO `access_log` VALUES (29808, '64.77.15597260557808681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:16', 2, 0, '', '2019-06-05 17:14:16');
INSERT INTO `access_log` VALUES (29809, '59.78.15597260562628907', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:16', 3, 0, '', '2019-06-05 17:14:16');
INSERT INTO `access_log` VALUES (29810, '59.75.15597260562628905', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-05 17:14:16', 15, 2001001000, '服务端发生异常', '2019-06-05 17:14:16');
INSERT INTO `access_log` VALUES (29811, '59.72.15597261069258903', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:15:07', 960, 0, '', '2019-06-05 17:15:08');
INSERT INTO `access_log` VALUES (29812, '59.72.15597261069258903', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:15:07', 960, 0, '', '2019-06-05 17:15:09');
INSERT INTO `access_log` VALUES (29813, '62.80.15597265127148759', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:21:53', 99, 0, '', '2019-06-05 17:21:53');
INSERT INTO `access_log` VALUES (29814, '65.51.15597265545639091', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:22:35', 0, 1002001015, '账号未登陆', '2019-06-05 17:22:35');
INSERT INTO `access_log` VALUES (29815, '65.3607.15597265545660861', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:22:35', 1, 1002001015, '账号未登陆', '2019-06-05 17:22:35');
INSERT INTO `access_log` VALUES (29816, '65.49.15597265545719111', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:22:35', 0, 1002001015, '账号未登陆', '2019-06-05 17:22:35');
INSERT INTO `access_log` VALUES (29817, '62.86.15597265741848741', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:22:54', 13, 0, '', '2019-06-05 17:22:54');
INSERT INTO `access_log` VALUES (29818, '65.47.15597267452019095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:25:45', 88, 0, '', '2019-06-05 17:25:45');
INSERT INTO `access_log` VALUES (29819, '65.52.15597267456629095', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:25:46', 8, 0, '', '2019-06-05 17:25:46');
INSERT INTO `access_log` VALUES (29820, '65.53.15597267456669073', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:25:46', 8, 0, '', '2019-06-05 17:25:46');
INSERT INTO `access_log` VALUES (29821, '65.46.15597267457049099', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:25:46', 9, 0, '', '2019-06-05 17:25:46');
INSERT INTO `access_log` VALUES (29822, '62.84.15597267562028747', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:25:56', 14, 0, '', '2019-06-05 17:25:56');
INSERT INTO `access_log` VALUES (29823, '62.81.15597267875188737', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:26:28', 15, 0, '', '2019-06-05 17:26:28');
INSERT INTO `access_log` VALUES (29824, '64.82.15597267970808693', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:26:37', 9, 0, '', '2019-06-05 17:26:37');
INSERT INTO `access_log` VALUES (29825, '64.85.15597267970798703', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:26:37', 10, 0, '', '2019-06-05 17:26:37');
INSERT INTO `access_log` VALUES (29826, '64.84.15597268054518691', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:26:45', 8, 0, '', '2019-06-05 17:26:45');
INSERT INTO `access_log` VALUES (29827, '64.83.15597268054498675', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:26:45', 12, 0, '', '2019-06-05 17:26:45');
INSERT INTO `access_log` VALUES (29828, '64.79.15597268102798679', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.215', '2019-06-05 17:26:50', 8, 0, '', '2019-06-05 17:26:50');
INSERT INTO `access_log` VALUES (29829, '65.50.15597273854069099', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:36:25', 5, 1002001012, '访问令牌已过期', '2019-06-05 17:36:25');
INSERT INTO `access_log` VALUES (29830, '65.45.15597273876439119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:36:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 17:36:28');
INSERT INTO `access_log` VALUES (29831, '65.54.15597273910669067', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:36:31', 4, 1002002000, '账号不存在', '2019-06-05 17:36:31');
INSERT INTO `access_log` VALUES (29832, '65.47.15597273928229105', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:36:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 17:36:33');
INSERT INTO `access_log` VALUES (29833, '65.52.15597274030139105', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:36:43', 5, 1002002000, '账号不存在', '2019-06-05 17:36:43');
INSERT INTO `access_log` VALUES (29834, '65.46.15597274042609109', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:36:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 17:36:44');
INSERT INTO `access_log` VALUES (29835, '65.3607.15597274227770875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:37:03', 365, 0, '', '2019-06-05 17:37:03');
INSERT INTO `access_log` VALUES (29836, '65.49.15597274236599125', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:37:04', 10, 0, '', '2019-06-05 17:37:04');
INSERT INTO `access_log` VALUES (29837, '65.50.15597274236669101', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:37:04', 9, 0, '', '2019-06-05 17:37:04');
INSERT INTO `access_log` VALUES (29838, '65.45.15597274236669121', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:37:04', 9, 0, '', '2019-06-05 17:37:04');
INSERT INTO `access_log` VALUES (29839, '62.83.15597274274348767', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:37:07', 12, 0, '', '2019-06-05 17:37:07');
INSERT INTO `access_log` VALUES (29840, '66.54.15597274440137501', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:37:24', 14, 0, '', '2019-06-05 17:37:24');
INSERT INTO `access_log` VALUES (29841, '65.53.15597274530989085', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:37:33', 19, 0, '', '2019-06-05 17:37:33');
INSERT INTO `access_log` VALUES (29842, '65.52.15597274576049107', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:37:38', 11, 0, '', '2019-06-05 17:37:38');
INSERT INTO `access_log` VALUES (29843, '65.51.15597274599749107', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:37:40', 9, 0, '', '2019-06-05 17:37:40');
INSERT INTO `access_log` VALUES (29844, '65.3607.15597274654950877', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.25.11', '2019-06-05 17:37:45', 12, 0, '', '2019-06-05 17:37:46');
INSERT INTO `access_log` VALUES (29845, '59.73.15597275615798927', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:39:22', 3, 0, '', '2019-06-05 17:39:22');
INSERT INTO `access_log` VALUES (29846, '59.80.15597275615798915', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:39:22', 13, 2001001000, '服务端发生异常', '2019-06-05 17:39:22');
INSERT INTO `access_log` VALUES (29847, '64.81.15597275679468693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:39:28', 2, 0, '', '2019-06-05 17:39:28');
INSERT INTO `access_log` VALUES (29848, '64.78.15597275680528701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:39:28', 2, 0, '', '2019-06-05 17:39:28');
INSERT INTO `access_log` VALUES (29849, '64.76.15597275697938683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:39:30', 3, 0, '', '2019-06-05 17:39:30');
INSERT INTO `access_log` VALUES (29850, '64.77.15597275705468703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:39:31', 2, 0, '', '2019-06-05 17:39:31');
INSERT INTO `access_log` VALUES (29851, '64.82.15597275737788705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:39:34', 2, 0, '', '2019-06-05 17:39:34');
INSERT INTO `access_log` VALUES (29852, '64.85.15597275739048715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:39:34', 2, 0, '', '2019-06-05 17:39:34');
INSERT INTO `access_log` VALUES (29853, '59.77.15597275825778917', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:39:43', 2, 0, '', '2019-06-05 17:39:43');
INSERT INTO `access_log` VALUES (29854, '59.79.15597275825778925', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:39:43', 13, 2001001000, '服务端发生异常', '2019-06-05 17:39:43');
INSERT INTO `access_log` VALUES (29855, '59.79.15597277112158927', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:41:51', 3, 0, '', '2019-06-05 17:41:51');
INSERT INTO `access_log` VALUES (29856, '59.76.15597277112168919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:41:51', 13, 2001001000, '服务端发生异常', '2019-06-05 17:41:51');
INSERT INTO `access_log` VALUES (29857, '66.54.15597277370577505', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13516565388&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:42:17', 8, 1001003000, '验证码不存在', '2019-06-05 17:42:17');
INSERT INTO `access_log` VALUES (29858, '66.55.15597277388087511', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13516565388', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:42:19', 99, 0, '', '2019-06-05 17:42:19');
INSERT INTO `access_log` VALUES (29859, '66.52.15597277407107509', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13516565388&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:42:21', 186, 0, '', '2019-06-05 17:42:21');
INSERT INTO `access_log` VALUES (29860, '59.73.15597277479468931', 109, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:42:28', 5, 0, '', '2019-06-05 17:42:28');
INSERT INTO `access_log` VALUES (29861, '59.80.15597277479488919', 109, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 17:42:28', 15, 2001001000, '服务端发生异常', '2019-06-05 17:42:28');
INSERT INTO `access_log` VALUES (29862, '65.51.15597281816429117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-05 17:49:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 17:49:42');
INSERT INTO `access_log` VALUES (29863, '65.3607.15597281862300887', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-05 17:49:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 17:49:46');
INSERT INTO `access_log` VALUES (29864, '65.45.15597281995399133', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-05 17:50:00', 35, 0, '', '2019-06-05 17:50:00');
INSERT INTO `access_log` VALUES (29865, '65.50.15597281997759113', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-05 17:50:00', 10, 0, '', '2019-06-05 17:50:00');
INSERT INTO `access_log` VALUES (29866, '65.54.15597281997769081', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-05 17:50:00', 11, 0, '', '2019-06-05 17:50:00');
INSERT INTO `access_log` VALUES (29867, '65.47.15597281997799119', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.50.210.130', '2019-06-05 17:50:00', 9, 0, '', '2019-06-05 17:50:00');
INSERT INTO `access_log` VALUES (29868, '59.71.15597287250328947', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:45', 13, 2001001000, '服务端发生异常', '2019-06-05 17:58:45');
INSERT INTO `access_log` VALUES (29869, '59.75.15597287250298943', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:45', 27, 0, '', '2019-06-05 17:58:45');
INSERT INTO `access_log` VALUES (29870, '64.77.15597287285428719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:49', 315, 0, '', '2019-06-05 17:58:49');
INSERT INTO `access_log` VALUES (29871, '64.82.15597287289888721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:49', 2, 0, '', '2019-06-05 17:58:49');
INSERT INTO `access_log` VALUES (29872, '64.85.15597287298708731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:50', 2, 0, '', '2019-06-05 17:58:50');
INSERT INTO `access_log` VALUES (29873, '64.84.15597287305048719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:51', 2, 0, '', '2019-06-05 17:58:51');
INSERT INTO `access_log` VALUES (29874, '64.79.15597287311848707', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:51', 12, 0, '', '2019-06-05 17:58:51');
INSERT INTO `access_log` VALUES (29875, '64.80.15597287316258711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:52', 2, 0, '', '2019-06-05 17:58:52');
INSERT INTO `access_log` VALUES (29876, '64.81.15597287320538711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:52', 154, 0, '', '2019-06-05 17:58:52');
INSERT INTO `access_log` VALUES (29877, '64.78.15597287325288719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:53', 1, 0, '', '2019-06-05 17:58:53');
INSERT INTO `access_log` VALUES (29878, '64.76.15597287328798701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:53', 2, 0, '', '2019-06-05 17:58:53');
INSERT INTO `access_log` VALUES (29879, '64.77.15597287335968721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:54', 2, 0, '', '2019-06-05 17:58:54');
INSERT INTO `access_log` VALUES (29880, '64.82.15597287340618723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:54', 2, 0, '', '2019-06-05 17:58:54');
INSERT INTO `access_log` VALUES (29881, '64.85.15597287344418733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:54', 2, 0, '', '2019-06-05 17:58:54');
INSERT INTO `access_log` VALUES (29882, '64.83.15597287347638705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:55', 2, 0, '', '2019-06-05 17:58:55');
INSERT INTO `access_log` VALUES (29883, '64.84.15597287353828721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:55', 1, 0, '', '2019-06-05 17:58:55');
INSERT INTO `access_log` VALUES (29884, '64.79.15597287357868709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:56', 2, 0, '', '2019-06-05 17:58:56');
INSERT INTO `access_log` VALUES (29885, '64.80.15597287362298713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:56', 2, 0, '', '2019-06-05 17:58:56');
INSERT INTO `access_log` VALUES (29886, '64.81.15597287366468713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:57', 1, 0, '', '2019-06-05 17:58:57');
INSERT INTO `access_log` VALUES (29887, '64.78.15597287370098721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:57', 2, 0, '', '2019-06-05 17:58:57');
INSERT INTO `access_log` VALUES (29888, '64.76.15597287373088703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:57', 2, 0, '', '2019-06-05 17:58:57');
INSERT INTO `access_log` VALUES (29889, '64.77.15597287376988723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:58', 2, 0, '', '2019-06-05 17:58:58');
INSERT INTO `access_log` VALUES (29890, '64.82.15597287382018725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:58', 2, 0, '', '2019-06-05 17:58:58');
INSERT INTO `access_log` VALUES (29891, '64.85.15597287385258735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:59', 1, 0, '', '2019-06-05 17:58:59');
INSERT INTO `access_log` VALUES (29892, '64.83.15597287390758707', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:58:59', 2, 0, '', '2019-06-05 17:58:59');
INSERT INTO `access_log` VALUES (29893, '64.84.15597287426648723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:59:03', 2, 0, '', '2019-06-05 17:59:03');
INSERT INTO `access_log` VALUES (29894, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:59:03', 9, 0, '', '2019-06-05 17:59:03');
INSERT INTO `access_log` VALUES (29895, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:59:05', 6, 0, '', '2019-06-05 17:59:05');
INSERT INTO `access_log` VALUES (29896, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:59:06', 6, 0, '', '2019-06-05 17:59:06');
INSERT INTO `access_log` VALUES (29897, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:59:06', 6, 0, '', '2019-06-05 17:59:06');
INSERT INTO `access_log` VALUES (29898, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:59:07', 7, 0, '', '2019-06-05 17:59:07');
INSERT INTO `access_log` VALUES (29899, '64.80.15597287475678715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:59:08', 2, 0, '', '2019-06-05 17:59:08');
INSERT INTO `access_log` VALUES (29900, '64.81.15597287476768715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:59:08', 2, 0, '', '2019-06-05 17:59:08');
INSERT INTO `access_log` VALUES (29901, '59.80.15597287505788933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:59:11', 3, 0, '', '2019-06-05 17:59:11');
INSERT INTO `access_log` VALUES (29902, '59.72.15597287505798941', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.152.139.115', '2019-06-05 17:59:11', 13, 2001001000, '服务端发生异常', '2019-06-05 17:59:11');
INSERT INTO `access_log` VALUES (29903, '59.76.15597292269988941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:07:07', 3, 0, '', '2019-06-05 18:07:07');
INSERT INTO `access_log` VALUES (29904, '59.78.15597292269998953', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:07:07', 13, 2001001000, '服务端发生异常', '2019-06-05 18:07:07');
INSERT INTO `access_log` VALUES (29905, '64.77.15597292313728731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:07:11', 3, 0, '', '2019-06-05 18:07:11');
INSERT INTO `access_log` VALUES (29906, '64.82.15597292316888733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:07:12', 2, 0, '', '2019-06-05 18:07:12');
INSERT INTO `access_log` VALUES (29907, '64.85.15597292328468743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:07:13', 2, 0, '', '2019-06-05 18:07:13');
INSERT INTO `access_log` VALUES (29908, '64.83.15597292335298715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:07:14', 2, 0, '', '2019-06-05 18:07:14');
INSERT INTO `access_log` VALUES (29909, '64.84.15597292338748731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:07:14', 2, 0, '', '2019-06-05 18:07:14');
INSERT INTO `access_log` VALUES (29910, '66.52.15597292403217529', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Mobile Safari/537.36', '14.23.42.162', '2019-06-05 18:07:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-05 18:07:20');
INSERT INTO `access_log` VALUES (29911, '66.48.15597292427097531', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Mobile Safari/537.36', '14.23.42.162', '2019-06-05 18:07:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-05 18:07:23');
INSERT INTO `access_log` VALUES (29912, '64.80.15597292500368723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Mobile Safari/537.36', '14.23.42.162', '2019-06-05 18:07:30', 2, 0, '', '2019-06-05 18:07:30');
INSERT INTO `access_log` VALUES (29913, '64.81.15597292501478723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Mobile Safari/537.36', '14.23.42.162', '2019-06-05 18:07:30', 2, 0, '', '2019-06-05 18:07:30');
INSERT INTO `access_log` VALUES (29914, '64.78.15597292513548731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Mobile Safari/537.36', '14.23.42.162', '2019-06-05 18:07:31', 2, 0, '', '2019-06-05 18:07:31');
INSERT INTO `access_log` VALUES (29915, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Mobile Safari/537.36', '14.23.42.162', '2019-06-05 18:07:31', 15, 0, '', '2019-06-05 18:07:31');
INSERT INTO `access_log` VALUES (29916, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Mobile Safari/537.36', '14.23.42.162', '2019-06-05 18:07:33', 7, 0, '', '2019-06-05 18:07:33');
INSERT INTO `access_log` VALUES (29917, '64.76.15597292541698713', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Mobile Safari/537.36', '14.23.42.162', '2019-06-05 18:07:34', 7, 0, '', '2019-06-05 18:07:34');
INSERT INTO `access_log` VALUES (29918, '64.76.15597293865968715', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Mobile Safari/537.36', '14.23.42.162', '2019-06-05 18:09:47', 7, 0, '', '2019-06-05 18:09:47');
INSERT INTO `access_log` VALUES (29919, '65.49.15597294047429153', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:10:05', 0, 1002001015, '账号未登陆', '2019-06-05 18:10:05');
INSERT INTO `access_log` VALUES (29920, '65.45.15597294047439151', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:10:05', 0, 1002001015, '账号未登陆', '2019-06-05 18:10:05');
INSERT INTO `access_log` VALUES (29921, '65.47.15597294047529137', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:10:05', 0, 1002001015, '账号未登陆', '2019-06-05 18:10:05');
INSERT INTO `access_log` VALUES (29922, '65.52.15597294116899137', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:10:12', 65, 0, '', '2019-06-05 18:10:12');
INSERT INTO `access_log` VALUES (29923, '65.50.15597294121489131', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:10:12', 128, 0, '', '2019-06-05 18:10:12');
INSERT INTO `access_log` VALUES (29924, '65.54.15597294121539099', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:10:12', 124, 0, '', '2019-06-05 18:10:12');
INSERT INTO `access_log` VALUES (29925, '65.46.15597294121869141', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:10:12', 92, 0, '', '2019-06-05 18:10:12');
INSERT INTO `access_log` VALUES (29926, '62.87.15597294212328783', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:10:21', 18, 0, '', '2019-06-05 18:10:21');
INSERT INTO `access_log` VALUES (29927, '62.81.15597294243478773', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:10:24', 17, 0, '', '2019-06-05 18:10:24');
INSERT INTO `access_log` VALUES (29928, '62.82.15597294263058797', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:10:26', 13, 0, '', '2019-06-05 18:10:26');
INSERT INTO `access_log` VALUES (29929, '64.83.15597294288708719', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:10:29', 9, 0, '', '2019-06-05 18:10:29');
INSERT INTO `access_log` VALUES (29930, '64.84.15597294288708735', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:10:29', 11, 0, '', '2019-06-05 18:10:29');
INSERT INTO `access_log` VALUES (29931, '59.72.15597294550898951', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:10:55', 12, 0, '', '2019-06-05 18:10:55');
INSERT INTO `access_log` VALUES (29932, '65.47.15597294624979139', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:11:02', 299, 0, '', '2019-06-05 18:11:03');
INSERT INTO `access_log` VALUES (29933, '66.50.15597294836697523', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:11:24', 94, 0, '', '2019-06-05 18:11:24');
INSERT INTO `access_log` VALUES (29934, '59.78.15597294915128957', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:11:32', 12, 0, '', '2019-06-05 18:11:32');
INSERT INTO `access_log` VALUES (29935, '59.76.15597294939078945', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:11:34', 21, 2001001000, '服务端发生异常', '2019-06-05 18:11:34');
INSERT INTO `access_log` VALUES (29936, '59.75.15597294973068955', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:11:37', 131, 0, '', '2019-06-05 18:11:37');
INSERT INTO `access_log` VALUES (29937, '66.56.15597295342787523', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '14.23.42.162', '2019-06-05 18:12:14', 12, 0, '', '2019-06-05 18:12:14');
INSERT INTO `access_log` VALUES (29938, '59.71.15597301832648969', 109, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 18:23:03', 5, 0, '', '2019-06-05 18:23:03');
INSERT INTO `access_log` VALUES (29939, '59.76.15597301832618955', 109, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 18:23:03', 17, 2001001000, '服务端发生异常', '2019-06-05 18:23:03');
INSERT INTO `access_log` VALUES (29940, '64.81.15597301857458737', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 18:23:06', 8, 0, '', '2019-06-05 18:23:06');
INSERT INTO `access_log` VALUES (29941, '64.76.15597301859198727', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 18:23:06', 5, 0, '', '2019-06-05 18:23:06');
INSERT INTO `access_log` VALUES (29942, '64.82.15597301868588749', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 18:23:07', 5, 0, '', '2019-06-05 18:23:07');
INSERT INTO `access_log` VALUES (29943, '64.83.15597301873588731', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 18:23:07', 5, 0, '', '2019-06-05 18:23:07');
INSERT INTO `access_log` VALUES (29944, '64.84.15597301877588747', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 18:23:08', 5, 0, '', '2019-06-05 18:23:08');
INSERT INTO `access_log` VALUES (29945, '64.79.15597301903258735', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 18:23:10', 396, 0, '', '2019-06-05 18:23:11');
INSERT INTO `access_log` VALUES (29946, 'N/A', 109, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 18:23:10', 357, 0, '', '2019-06-05 18:23:11');
INSERT INTO `access_log` VALUES (29947, '64.80.15597301922668739', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 18:23:12', 5, 0, '', '2019-06-05 18:23:12');
INSERT INTO `access_log` VALUES (29948, '64.81.15597301924018739', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.128.232.103', '2019-06-05 18:23:12', 4, 0, '', '2019-06-05 18:23:12');
INSERT INTO `access_log` VALUES (29949, '64.78.15597301970218747', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:17', 5, 0, '', '2019-06-05 18:23:17');
INSERT INTO `access_log` VALUES (29950, '64.76.15597301971508729', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:17', 5, 0, '', '2019-06-05 18:23:17');
INSERT INTO `access_log` VALUES (29951, '64.77.15597301984288749', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:18', 4, 0, '', '2019-06-05 18:23:18');
INSERT INTO `access_log` VALUES (29952, '64.82.15597301990688751', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:19', 4, 0, '', '2019-06-05 18:23:19');
INSERT INTO `access_log` VALUES (29953, '64.85.15597301996048761', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:20', 5, 0, '', '2019-06-05 18:23:20');
INSERT INTO `access_log` VALUES (29954, '64.83.15597302004548733', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:20', 4, 0, '', '2019-06-05 18:23:20');
INSERT INTO `access_log` VALUES (29955, '64.79.15597302010838737', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:21', 4, 0, '', '2019-06-05 18:23:21');
INSERT INTO `access_log` VALUES (29956, 'N/A', 109, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:21', 11, 0, '', '2019-06-05 18:23:21');
INSERT INTO `access_log` VALUES (29957, '64.80.15597302026278741', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:23', 4, 0, '', '2019-06-05 18:23:23');
INSERT INTO `access_log` VALUES (29958, '64.81.15597302027698741', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:23', 5, 0, '', '2019-06-05 18:23:23');
INSERT INTO `access_log` VALUES (29959, '64.78.15597302033458749', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:23', 12, 0, '', '2019-06-05 18:23:23');
INSERT INTO `access_log` VALUES (29960, '64.76.15597302040608731', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:24', 4, 0, '', '2019-06-05 18:23:24');
INSERT INTO `access_log` VALUES (29961, 'N/A', 109, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:24', 10, 0, '', '2019-06-05 18:23:24');
INSERT INTO `access_log` VALUES (29962, '64.82.15597302119198753', 109, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:32', 10, 0, '', '2019-06-05 18:23:32');
INSERT INTO `access_log` VALUES (29963, '64.84.15597302280518751', 109, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:48', 9, 0, '', '2019-06-05 18:23:48');
INSERT INTO `access_log` VALUES (29964, '64.83.15597302287598735', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:49', 5, 0, '', '2019-06-05 18:23:49');
INSERT INTO `access_log` VALUES (29965, 'N/A', 109, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:49', 11, 0, '', '2019-06-05 18:23:49');
INSERT INTO `access_log` VALUES (29966, '64.79.15597302302298739', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:50', 5, 0, '', '2019-06-05 18:23:50');
INSERT INTO `access_log` VALUES (29967, '64.80.15597302303498743', 109, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:50', 4, 0, '', '2019-06-05 18:23:50');
INSERT INTO `access_log` VALUES (29968, '66.48.15597302326687545', 109, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:53', 91, 0, '', '2019-06-05 18:23:53');
INSERT INTO `access_log` VALUES (29969, '66.56.15597302359067533', 109, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '219.128.232.103', '2019-06-05 18:23:56', 7, 0, '', '2019-06-05 18:23:56');
INSERT INTO `access_log` VALUES (29970, '59.72.15597345756399021', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:36:16', 16, 2001001000, '服务端发生异常', '2019-06-05 19:36:16');
INSERT INTO `access_log` VALUES (29971, '59.80.15597345756379013', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:36:16', 397, 0, '', '2019-06-05 19:36:16');
INSERT INTO `access_log` VALUES (29972, '64.81.15597345795378801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:36:20', 11, 0, '', '2019-06-05 19:36:20');
INSERT INTO `access_log` VALUES (29973, '64.78.15597345797258809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:36:20', 3, 0, '', '2019-06-05 19:36:20');
INSERT INTO `access_log` VALUES (29974, '64.77.15597345810248811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:36:21', 1, 0, '', '2019-06-05 19:36:21');
INSERT INTO `access_log` VALUES (29975, '64.82.15597345816178813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:36:22', 2, 0, '', '2019-06-05 19:36:22');
INSERT INTO `access_log` VALUES (29976, '64.85.15597345822238823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:36:22', 2, 0, '', '2019-06-05 19:36:22');
INSERT INTO `access_log` VALUES (29977, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=111&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:36:25', 15, 0, '', '2019-06-05 19:36:25');
INSERT INTO `access_log` VALUES (29978, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=111', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:36:25', 8, 0, '', '2019-06-05 19:36:25');
INSERT INTO `access_log` VALUES (29979, '65.3607.15597346173030975', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:36:57', 0, 1002001015, '账号未登陆', '2019-06-05 19:36:57');
INSERT INTO `access_log` VALUES (29980, '65.50.15597346173039205', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:36:57', 0, 1002001015, '账号未登陆', '2019-06-05 19:36:57');
INSERT INTO `access_log` VALUES (29981, '65.45.15597346173059223', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:36:57', 0, 1002001015, '账号未登陆', '2019-06-05 19:36:57');
INSERT INTO `access_log` VALUES (29982, '65.54.15597346260159171', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:06', 90, 0, '', '2019-06-05 19:37:06');
INSERT INTO `access_log` VALUES (29983, '65.52.15597346264059209', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:06', 14, 0, '', '2019-06-05 19:37:06');
INSERT INTO `access_log` VALUES (29984, '65.51.15597346264079209', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:06', 13, 0, '', '2019-06-05 19:37:06');
INSERT INTO `access_log` VALUES (29985, '65.53.15597346264109187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:06', 12, 0, '', '2019-06-05 19:37:06');
INSERT INTO `access_log` VALUES (29986, '62.86.15597346347948851', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:15', 59, 0, '', '2019-06-05 19:37:15');
INSERT INTO `access_log` VALUES (29987, '64.81.15597346374598803', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:17', 10, 0, '', '2019-06-05 19:37:17');
INSERT INTO `access_log` VALUES (29988, '64.80.15597346374568803', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:17', 14, 0, '', '2019-06-05 19:37:17');
INSERT INTO `access_log` VALUES (29989, '65.46.15597346398589217', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:20', 144, 0, '', '2019-06-05 19:37:20');
INSERT INTO `access_log` VALUES (29990, '65.49.15597346407509227', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:21', 10, 0, '', '2019-06-05 19:37:21');
INSERT INTO `access_log` VALUES (29991, '65.3607.15597346421350977', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:22', 10, 0, '', '2019-06-05 19:37:22');
INSERT INTO `access_log` VALUES (29992, '65.45.15597346431859225', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:23', 12, 0, '', '2019-06-05 19:37:23');
INSERT INTO `access_log` VALUES (29993, '65.54.15597346509729173', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:31', 9, 0, '', '2019-06-05 19:37:31');
INSERT INTO `access_log` VALUES (29994, '59.74.15597346575289021', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:38', 10, 0, '', '2019-06-05 19:37:38');
INSERT INTO `access_log` VALUES (29995, '62.84.15597346666188855', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:47', 12, 0, '', '2019-06-05 19:37:47');
INSERT INTO `access_log` VALUES (29996, '62.88.15597346683118873', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:48', 14, 0, '', '2019-06-05 19:37:48');
INSERT INTO `access_log` VALUES (29997, '64.82.15597346697898815', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:50', 11, 0, '', '2019-06-05 19:37:50');
INSERT INTO `access_log` VALUES (29998, '64.77.15597346697888813', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:50', 13, 0, '', '2019-06-05 19:37:50');
INSERT INTO `access_log` VALUES (29999, '66.57.15597346721607599', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:52', 19, 0, '', '2019-06-05 19:37:52');
INSERT INTO `access_log` VALUES (30000, '59.72.15597346737539023', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:54', 11, 0, '', '2019-06-05 19:37:54');
INSERT INTO `access_log` VALUES (30001, '59.80.15597346754489015', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:55', 355, 0, '', '2019-06-05 19:37:56');
INSERT INTO `access_log` VALUES (30002, '59.77.15597346774329017', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-05 19:37:57', 305, 2001001000, '服务端发生异常', '2019-06-05 19:37:58');
INSERT INTO `access_log` VALUES (30003, '65.45.15597357943899241', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:63.0) Gecko/20100101 Firefox/63.0', '115.231.223.106', '2019-06-05 19:56:34', 0, 1002001015, '账号未登陆', '2019-06-05 19:56:34');
INSERT INTO `access_log` VALUES (30004, '65.53.15597357943909205', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:63.0) Gecko/20100101 Firefox/63.0', '115.231.223.106', '2019-06-05 19:56:34', 1, 1002001015, '账号未登陆', '2019-06-05 19:56:34');
INSERT INTO `access_log` VALUES (30005, '65.54.15597357943899189', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:63.0) Gecko/20100101 Firefox/63.0', '115.231.223.106', '2019-06-05 19:56:34', 0, 1002001015, '账号未登陆', '2019-06-05 19:56:34');
INSERT INTO `access_log` VALUES (30006, '65.47.15597357982849229', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:63.0) Gecko/20100101 Firefox/63.0', '115.231.223.106', '2019-06-05 19:56:38', 66, 0, '', '2019-06-05 19:56:38');
INSERT INTO `access_log` VALUES (30007, '65.3607.15597357991840993', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:63.0) Gecko/20100101 Firefox/63.0', '115.231.223.106', '2019-06-05 19:56:39', 234, 0, '', '2019-06-05 19:56:39');
INSERT INTO `access_log` VALUES (30008, '65.46.15597357991849235', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:63.0) Gecko/20100101 Firefox/63.0', '115.231.223.106', '2019-06-05 19:56:39', 233, 0, '', '2019-06-05 19:56:39');
INSERT INTO `access_log` VALUES (30009, '65.50.15597357991889225', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:63.0) Gecko/20100101 Firefox/63.0', '115.231.223.106', '2019-06-05 19:56:39', 230, 0, '', '2019-06-05 19:56:39');
INSERT INTO `access_log` VALUES (30010, '62.89.15597358058678881', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:63.0) Gecko/20100101 Firefox/63.0', '115.231.223.106', '2019-06-05 19:56:46', 16, 0, '', '2019-06-05 19:56:46');
INSERT INTO `access_log` VALUES (30011, '64.78.15597358092698827', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:63.0) Gecko/20100101 Firefox/63.0', '115.231.223.106', '2019-06-05 19:56:49', 11, 0, '', '2019-06-05 19:56:49');
INSERT INTO `access_log` VALUES (30012, '64.76.15597358092828809', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:63.0) Gecko/20100101 Firefox/63.0', '115.231.223.106', '2019-06-05 19:56:49', 8, 0, '', '2019-06-05 19:56:49');
INSERT INTO `access_log` VALUES (30013, '59.73.15597358140899043', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:63.0) Gecko/20100101 Firefox/63.0', '115.231.223.106', '2019-06-05 19:56:54', 11, 0, '', '2019-06-05 19:56:54');
INSERT INTO `access_log` VALUES (30014, '65.51.15597358224429229', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.12; rv:63.0) Gecko/20100101 Firefox/63.0', '115.231.223.106', '2019-06-05 19:57:02', 18, 0, '', '2019-06-05 19:57:02');
INSERT INTO `access_log` VALUES (30015, '59.78.15597366291649055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:10:29', 4, 0, '', '2019-06-05 20:10:29');
INSERT INTO `access_log` VALUES (30016, '59.76.15597366291679043', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:10:29', 14, 2001001000, '服务端发生异常', '2019-06-05 20:10:29');
INSERT INTO `access_log` VALUES (30017, '64.80.15597366365728831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:10:37', 390, 0, '', '2019-06-05 20:10:37');
INSERT INTO `access_log` VALUES (30018, '64.81.15597366374458831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:10:37', 1, 0, '', '2019-06-05 20:10:37');
INSERT INTO `access_log` VALUES (30019, '64.78.15597366394538839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:10:39', 43, 0, '', '2019-06-05 20:10:39');
INSERT INTO `access_log` VALUES (30020, '64.76.15597366406368821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:10:41', 2, 0, '', '2019-06-05 20:10:41');
INSERT INTO `access_log` VALUES (30021, '59.75.15597366427969053', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:10:43', 3, 0, '', '2019-06-05 20:10:43');
INSERT INTO `access_log` VALUES (30022, '59.74.15597366427969049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:10:43', 13, 2001001000, '服务端发生异常', '2019-06-05 20:10:43');
INSERT INTO `access_log` VALUES (30023, '64.82.15597366468508843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:10:47', 2, 0, '', '2019-06-05 20:10:47');
INSERT INTO `access_log` VALUES (30024, '64.77.15597366470308841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:10:47', 1, 0, '', '2019-06-05 20:10:47');
INSERT INTO `access_log` VALUES (30025, '64.84.15597366557668841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:10:56', 47, 0, '', '2019-06-05 20:10:56');
INSERT INTO `access_log` VALUES (30026, '64.83.15597366559928825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:10:56', 1, 0, '', '2019-06-05 20:10:56');
INSERT INTO `access_log` VALUES (30027, '59.72.15597366564809051', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:10:56', 2, 0, '', '2019-06-05 20:10:56');
INSERT INTO `access_log` VALUES (30028, '59.80.15597366564809043', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:10:56', 13, 2001001000, '服务端发生异常', '2019-06-05 20:10:56');
INSERT INTO `access_log` VALUES (30029, '65.3607.15597366754171005', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:11:15', 0, 1002001015, '账号未登陆', '2019-06-05 20:11:15');
INSERT INTO `access_log` VALUES (30030, '65.52.15597366754179241', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:11:15', 0, 1002001015, '账号未登陆', '2019-06-05 20:11:15');
INSERT INTO `access_log` VALUES (30031, '65.51.15597366754189241', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:11:15', 0, 1002001015, '账号未登陆', '2019-06-05 20:11:15');
INSERT INTO `access_log` VALUES (30032, '65.54.15597366784549203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:11:18', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 20:11:18');
INSERT INTO `access_log` VALUES (30033, '65.53.15597366911339219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:11:31', 66, 0, '', '2019-06-05 20:11:31');
INSERT INTO `access_log` VALUES (30034, '65.47.15597366915629243', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:11:32', 10, 0, '', '2019-06-05 20:11:32');
INSERT INTO `access_log` VALUES (30035, '65.49.15597366915659259', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:11:32', 9, 0, '', '2019-06-05 20:11:32');
INSERT INTO `access_log` VALUES (30036, '65.46.15597366915739249', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:11:32', 9, 0, '', '2019-06-05 20:11:32');
INSERT INTO `access_log` VALUES (30037, '62.83.15597367025958893', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:11:43', 13, 0, '', '2019-06-05 20:11:43');
INSERT INTO `access_log` VALUES (30038, '62.88.15597367124988901', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:11:52', 15, 0, '', '2019-06-05 20:11:53');
INSERT INTO `access_log` VALUES (30039, '66.55.15597367319067633', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:12:12', 21, 0, '', '2019-06-05 20:12:12');
INSERT INTO `access_log` VALUES (30040, '59.74.15597367399679051', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:12:20', 11, 0, '', '2019-06-05 20:12:20');
INSERT INTO `access_log` VALUES (30041, '59.73.15597367436809057', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:12:24', 18, 0, '', '2019-06-05 20:12:24');
INSERT INTO `access_log` VALUES (30042, '65.54.15597367478799205', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:12:28', 20, 0, '', '2019-06-05 20:12:28');
INSERT INTO `access_log` VALUES (30043, '65.45.15597367579699257', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:12:38', 12, 0, '', '2019-06-05 20:12:38');
INSERT INTO `access_log` VALUES (30044, '65.46.15597367635349251', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:12:44', 10, 0, '', '2019-06-05 20:12:44');
INSERT INTO `access_log` VALUES (30045, '65.49.15597367673359261', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:12:47', 12, 0, '', '2019-06-05 20:12:47');
INSERT INTO `access_log` VALUES (30046, '65.50.15597367792349241', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:12:59', 218, 0, '', '2019-06-05 20:12:59');
INSERT INTO `access_log` VALUES (30047, '65.54.15597368324739207', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:13:52', 10, 0, '', '2019-06-05 20:13:52');
INSERT INTO `access_log` VALUES (30048, '65.45.15597368326729259', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:13:53', 18, 0, '', '2019-06-05 20:13:53');
INSERT INTO `access_log` VALUES (30049, '59.71.15597368338489061', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:13:54', 12, 0, '', '2019-06-05 20:13:54');
INSERT INTO `access_log` VALUES (30050, '59.75.15597368348439057', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:13:55', 10, 0, '', '2019-06-05 20:13:55');
INSERT INTO `access_log` VALUES (30051, '66.49.15597368359397637', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.221.188.175', '2019-06-05 20:13:56', 82, 0, '', '2019-06-05 20:13:56');
INSERT INTO `access_log` VALUES (30052, '59.72.15597406148449105', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:16:55', 17, 0, '', '2019-06-05 21:16:55');
INSERT INTO `access_log` VALUES (30053, '59.80.15597406148459097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:16:55', 15, 2001001000, '服务端发生异常', '2019-06-05 21:16:55');
INSERT INTO `access_log` VALUES (30054, '65.47.15597406276969297', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:08', 0, 1002001015, '账号未登陆', '2019-06-05 21:17:08');
INSERT INTO `access_log` VALUES (30055, '65.50.15597406276969293', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:08', 0, 1002001015, '账号未登陆', '2019-06-05 21:17:08');
INSERT INTO `access_log` VALUES (30056, '65.52.15597406276999297', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:08', 1, 1002001015, '账号未登陆', '2019-06-05 21:17:08');
INSERT INTO `access_log` VALUES (30057, '65.3607.15597406307141061', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-05 21:17:11');
INSERT INTO `access_log` VALUES (30058, '65.45.15597406579839311', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:38', 68, 0, '', '2019-06-05 21:17:38');
INSERT INTO `access_log` VALUES (30059, '65.53.15597406583259275', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:38', 12, 0, '', '2019-06-05 21:17:38');
INSERT INTO `access_log` VALUES (30060, '65.46.15597406583319305', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:38', 10, 0, '', '2019-06-05 21:17:38');
INSERT INTO `access_log` VALUES (30061, '65.49.15597406583369315', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:38', 9, 0, '', '2019-06-05 21:17:38');
INSERT INTO `access_log` VALUES (30062, '65.50.15597406688109295', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:49', 9, 0, '', '2019-06-05 21:17:49');
INSERT INTO `access_log` VALUES (30063, '65.52.15597406688139299', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:49', 9, 0, '', '2019-06-05 21:17:49');
INSERT INTO `access_log` VALUES (30064, '65.51.15597406688189299', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:49', 9, 0, '', '2019-06-05 21:17:49');
INSERT INTO `access_log` VALUES (30065, '65.54.15597406743479261', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:54', 9, 0, '', '2019-06-05 21:17:54');
INSERT INTO `access_log` VALUES (30066, '65.45.15597406743539313', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:54', 9, 0, '', '2019-06-05 21:17:54');
INSERT INTO `access_log` VALUES (30067, '65.53.15597406743669277', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:54', 9, 0, '', '2019-06-05 21:17:54');
INSERT INTO `access_log` VALUES (30068, '62.88.15597406745148967', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '218.25.99.194', '2019-06-05 21:17:55', 21, 0, '', '2019-06-05 21:17:55');
INSERT INTO `access_log` VALUES (30069, '59.77.15597410728219105', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.244.112.109', '2019-06-05 21:24:33', 69, 0, '', '2019-06-05 21:24:33');
INSERT INTO `access_log` VALUES (30070, '59.79.15597410730069113', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.244.112.109', '2019-06-05 21:24:33', 13, 2001001000, '服务端发生异常', '2019-06-05 21:24:33');
INSERT INTO `access_log` VALUES (30071, '64.82.15597410783608903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.244.112.109', '2019-06-05 21:24:38', 11, 0, '', '2019-06-05 21:24:38');
INSERT INTO `access_log` VALUES (30072, '64.77.15597410784818901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.244.112.109', '2019-06-05 21:24:38', 3, 0, '', '2019-06-05 21:24:38');
INSERT INTO `access_log` VALUES (30073, '64.83.15597411146588885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.244.112.109', '2019-06-05 21:25:15', 2, 0, '', '2019-06-05 21:25:15');
INSERT INTO `access_log` VALUES (30074, '59.74.15597411167659111', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.244.112.109', '2019-06-05 21:25:17', 2, 0, '', '2019-06-05 21:25:17');
INSERT INTO `access_log` VALUES (30075, '59.75.15597411167659115', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.244.112.109', '2019-06-05 21:25:17', 13, 2001001000, '服务端发生异常', '2019-06-05 21:25:17');
INSERT INTO `access_log` VALUES (30076, '64.79.15597411180718889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.244.112.109', '2019-06-05 21:25:18', 324, 0, '', '2019-06-05 21:25:18');
INSERT INTO `access_log` VALUES (30077, '64.80.15597411187248893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.244.112.109', '2019-06-05 21:25:19', 2, 0, '', '2019-06-05 21:25:19');
INSERT INTO `access_log` VALUES (30078, '59.73.15597411189809117', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.244.112.109', '2019-06-05 21:25:19', 2, 0, '', '2019-06-05 21:25:19');
INSERT INTO `access_log` VALUES (30079, '59.80.15597411189929105', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.244.112.109', '2019-06-05 21:25:19', 12, 2001001000, '服务端发生异常', '2019-06-05 21:25:19');
INSERT INTO `access_log` VALUES (30080, '59.79.15597412699009117', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'xiaomiquan/4.1.0 Android/Phone/8.0.0 Xiaomi_MIX_2S', '61.148.243.229', '2019-06-05 21:27:50', 3, 0, '', '2019-06-05 21:27:50');
INSERT INTO `access_log` VALUES (30081, '59.77.15597412698969109', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'xiaomiquan/4.1.0 Android/Phone/8.0.0 Xiaomi_MIX_2S', '61.148.243.229', '2019-06-05 21:27:50', 13, 2001001000, '服务端发生异常', '2019-06-05 21:27:50');
INSERT INTO `access_log` VALUES (30082, '59.76.15597412757619109', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'xiaomiquan/4.1.0 Android/Phone/8.0.0 Xiaomi_MIX_2S', '61.148.243.229', '2019-06-05 21:27:56', 2, 0, '', '2019-06-05 21:27:56');
INSERT INTO `access_log` VALUES (30083, '59.78.15597412757639121', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'xiaomiquan/4.1.0 Android/Phone/8.0.0 Xiaomi_MIX_2S', '61.148.243.229', '2019-06-05 21:27:56', 14, 2001001000, '服务端发生异常', '2019-06-05 21:27:56');
INSERT INTO `access_log` VALUES (30084, '64.78.15597412776128903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'xiaomiquan/4.1.0 Android/Phone/8.0.0 Xiaomi_MIX_2S', '61.148.243.229', '2019-06-05 21:27:58', 3, 0, '', '2019-06-05 21:27:58');
INSERT INTO `access_log` VALUES (30085, '64.76.15597412778458885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'xiaomiquan/4.1.0 Android/Phone/8.0.0 Xiaomi_MIX_2S', '61.148.243.229', '2019-06-05 21:27:58', 1, 0, '', '2019-06-05 21:27:58');
INSERT INTO `access_log` VALUES (30086, '64.82.15597412809438907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'xiaomiquan/4.1.0 Android/Phone/8.0.0 Xiaomi_MIX_2S', '61.148.243.229', '2019-06-05 21:28:01', 9, 0, '', '2019-06-05 21:28:01');
INSERT INTO `access_log` VALUES (30087, '64.77.15597412811768905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'xiaomiquan/4.1.0 Android/Phone/8.0.0 Xiaomi_MIX_2S', '61.148.243.229', '2019-06-05 21:28:01', 2, 0, '', '2019-06-05 21:28:01');
INSERT INTO `access_log` VALUES (30088, '59.74.15597412848719115', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'xiaomiquan/4.1.0 Android/Phone/8.0.0 Xiaomi_MIX_2S', '61.148.243.229', '2019-06-05 21:28:05', 3, 0, '', '2019-06-05 21:28:05');
INSERT INTO `access_log` VALUES (30089, '59.75.15597412848809119', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'xiaomiquan/4.1.0 Android/Phone/8.0.0 Xiaomi_MIX_2S', '61.148.243.229', '2019-06-05 21:28:05', 18, 2001001000, '服务端发生异常', '2019-06-05 21:28:05');
INSERT INTO `access_log` VALUES (30090, '59.75.15597423315299133', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.217.20.232', '2019-06-05 21:45:32', 3, 0, '', '2019-06-05 21:45:32');
INSERT INTO `access_log` VALUES (30091, '59.72.15597423315479131', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.217.20.232', '2019-06-05 21:45:32', 13, 2001001000, '服务端发生异常', '2019-06-05 21:45:32');
INSERT INTO `access_log` VALUES (30092, '59.74.15597433369229143', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '120.85.77.127', '2019-06-05 22:02:17', 3, 0, '', '2019-06-05 22:02:17');
INSERT INTO `access_log` VALUES (30093, '59.75.15597433369229147', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '120.85.77.127', '2019-06-05 22:02:17', 13, 2001001000, '服务端发生异常', '2019-06-05 22:02:17');
INSERT INTO `access_log` VALUES (30094, '64.82.15597433407208935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '120.85.77.127', '2019-06-05 22:02:21', 86, 0, '', '2019-06-05 22:02:21');
INSERT INTO `access_log` VALUES (30095, '64.77.15597433409658933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '120.85.77.127', '2019-06-05 22:02:21', 2, 0, '', '2019-06-05 22:02:21');
INSERT INTO `access_log` VALUES (30096, '65.47.15597441598949347', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-05 22:16:00', 4, 1002001012, '访问令牌已过期', '2019-06-05 22:16:00');
INSERT INTO `access_log` VALUES (30097, '65.52.15597441598959347', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-05 22:16:00', 4, 1002001012, '访问令牌已过期', '2019-06-05 22:16:00');
INSERT INTO `access_log` VALUES (30098, '65.50.15597441598959343', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-05 22:16:00', 4, 1002001012, '访问令牌已过期', '2019-06-05 22:16:00');
INSERT INTO `access_log` VALUES (30099, '65.51.15597441648919347', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-05 22:16:05', 70, 0, '', '2019-06-05 22:16:05');
INSERT INTO `access_log` VALUES (30100, '65.3607.15597441656691111', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-05 22:16:06', 11, 0, '', '2019-06-05 22:16:06');
INSERT INTO `access_log` VALUES (30101, '65.54.15597441656739309', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-05 22:16:06', 9, 0, '', '2019-06-05 22:16:06');
INSERT INTO `access_log` VALUES (30102, '65.53.15597441656759325', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-05 22:16:06', 10, 0, '', '2019-06-05 22:16:06');
INSERT INTO `access_log` VALUES (30103, '62.81.15597441714628985', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-05 22:16:11', 21, 0, '', '2019-06-05 22:16:11');
INSERT INTO `access_log` VALUES (30104, '64.78.15597441787878943', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-05 22:16:19', 14, 0, '', '2019-06-05 22:16:19');
INSERT INTO `access_log` VALUES (30105, '64.81.15597441787838935', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-05 22:16:19', 21, 0, '', '2019-06-05 22:16:19');
INSERT INTO `access_log` VALUES (30106, '64.77.15597441814568945', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-05 22:16:21', 9, 0, '', '2019-06-05 22:16:21');
INSERT INTO `access_log` VALUES (30107, '64.82.15597441814528947', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-05 22:16:21', 14, 0, '', '2019-06-05 22:16:21');
INSERT INTO `access_log` VALUES (30108, '59.77.15597442802479151', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.104.217.93', '2019-06-05 22:18:00', 4, 0, '', '2019-06-05 22:18:00');
INSERT INTO `access_log` VALUES (30109, '59.79.15597442802489159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.104.217.93', '2019-06-05 22:18:00', 13, 2001001000, '服务端发生异常', '2019-06-05 22:18:00');
INSERT INTO `access_log` VALUES (30110, '64.81.15597442849798937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.104.217.93', '2019-06-05 22:18:05', 3, 0, '', '2019-06-05 22:18:05');
INSERT INTO `access_log` VALUES (30111, '64.76.15597442851218927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.104.217.93', '2019-06-05 22:18:05', 2, 0, '', '2019-06-05 22:18:05');
INSERT INTO `access_log` VALUES (30112, '59.78.15597457945659183', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.5.243.188', '2019-06-05 22:43:15', 4, 0, '', '2019-06-05 22:43:15');
INSERT INTO `access_log` VALUES (30113, '59.71.15597457947129185', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.5.243.188', '2019-06-05 22:43:15', 16, 2001001000, '服务端发生异常', '2019-06-05 22:43:15');
INSERT INTO `access_log` VALUES (30114, '64.82.15597457948078969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.5.243.188', '2019-06-05 22:43:15', 2, 0, '', '2019-06-05 22:43:15');
INSERT INTO `access_log` VALUES (30115, '64.85.15597457949168979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.5.243.188', '2019-06-05 22:43:15', 2, 0, '', '2019-06-05 22:43:15');
INSERT INTO `access_log` VALUES (30116, '64.84.15597457968938967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.5.243.188', '2019-06-05 22:43:17', 2, 0, '', '2019-06-05 22:43:17');
INSERT INTO `access_log` VALUES (30117, '64.83.15597457972248951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.5.243.188', '2019-06-05 22:43:17', 2, 0, '', '2019-06-05 22:43:17');
INSERT INTO `access_log` VALUES (30118, '64.79.15597457974958955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.5.243.188', '2019-06-05 22:43:17', 1, 0, '', '2019-06-05 22:43:17');
INSERT INTO `access_log` VALUES (30119, '64.80.15597457977768959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.5.243.188', '2019-06-05 22:43:18', 2, 0, '', '2019-06-05 22:43:18');
INSERT INTO `access_log` VALUES (30120, '59.74.15597519383809259', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.92.226.158', '2019-06-06 00:25:38', 15, 0, '', '2019-06-06 00:25:38');
INSERT INTO `access_log` VALUES (30121, '59.75.15597519383789263', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.92.226.158', '2019-06-06 00:25:38', 39, 2001001000, '服务端发生异常', '2019-06-06 00:25:38');
INSERT INTO `access_log` VALUES (30122, '64.78.15597519436209049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.92.226.158', '2019-06-06 00:25:44', 12, 0, '', '2019-06-06 00:25:44');
INSERT INTO `access_log` VALUES (30123, '64.81.15597519440009041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.92.226.158', '2019-06-06 00:25:44', 3, 0, '', '2019-06-06 00:25:44');
INSERT INTO `access_log` VALUES (30124, '64.76.15597519453409031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.92.226.158', '2019-06-06 00:25:45', 2, 0, '', '2019-06-06 00:25:45');
INSERT INTO `access_log` VALUES (30125, '64.77.15597519459869051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.92.226.158', '2019-06-06 00:25:46', 2, 0, '', '2019-06-06 00:25:46');
INSERT INTO `access_log` VALUES (30126, '59.72.15597519470779261', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.92.226.158', '2019-06-06 00:25:47', 9, 0, '', '2019-06-06 00:25:47');
INSERT INTO `access_log` VALUES (30127, '59.73.15597519470799265', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.92.226.158', '2019-06-06 00:25:47', 26, 2001001000, '服务端发生异常', '2019-06-06 00:25:47');
INSERT INTO `access_log` VALUES (30128, '65.3607.15597544397861251', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.75', '2019-06-06 01:07:20', 0, 1002001015, '账号未登陆', '2019-06-06 01:07:20');
INSERT INTO `access_log` VALUES (30129, '65.45.15597544397869499', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.75', '2019-06-06 01:07:20', 0, 1002001015, '账号未登陆', '2019-06-06 01:07:20');
INSERT INTO `access_log` VALUES (30130, '65.46.15597544397889495', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.75', '2019-06-06 01:07:20', 0, 1002001015, '账号未登陆', '2019-06-06 01:07:20');
INSERT INTO `access_log` VALUES (30131, '65.49.15597544420869505', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.75', '2019-06-06 01:07:22', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 01:07:22');
INSERT INTO `access_log` VALUES (30132, '65.51.15597544522849489', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.75', '2019-06-06 01:07:32', 77, 0, '', '2019-06-06 01:07:32');
INSERT INTO `access_log` VALUES (30133, '65.50.15597544526069481', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.75', '2019-06-06 01:07:33', 15, 0, '', '2019-06-06 01:07:33');
INSERT INTO `access_log` VALUES (30134, '65.52.15597544526069485', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.75', '2019-06-06 01:07:33', 15, 0, '', '2019-06-06 01:07:33');
INSERT INTO `access_log` VALUES (30135, '65.54.15597544526139447', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.75', '2019-06-06 01:07:33', 10, 0, '', '2019-06-06 01:07:33');
INSERT INTO `access_log` VALUES (30136, '62.82.15597544584189147', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.75', '2019-06-06 01:07:38', 21, 0, '', '2019-06-06 01:07:38');
INSERT INTO `access_log` VALUES (30137, '62.89.15597544666949145', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.75', '2019-06-06 01:07:47', 16, 0, '', '2019-06-06 01:07:47');
INSERT INTO `access_log` VALUES (30138, '64.82.15597544730029087', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.75', '2019-06-06 01:07:53', 21, 0, '', '2019-06-06 01:07:53');
INSERT INTO `access_log` VALUES (30139, '64.77.15597544730029085', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.75', '2019-06-06 01:07:53', 24, 0, '', '2019-06-06 01:07:53');
INSERT INTO `access_log` VALUES (30140, '66.54.15597545027467867', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.75', '2019-06-06 01:08:23', 19, 0, '', '2019-06-06 01:08:23');
INSERT INTO `access_log` VALUES (30141, '59.79.15597545213319297', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.75', '2019-06-06 01:08:41', 213, 0, '', '2019-06-06 01:08:42');
INSERT INTO `access_log` VALUES (30142, '65.3607.15597595816391321', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.98.33.155', '2019-06-06 02:33:02', 1, 1002001015, '账号未登陆', '2019-06-06 02:33:02');
INSERT INTO `access_log` VALUES (30143, '59.72.15597598475909367', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:37:28', 10, 0, '', '2019-06-06 02:37:28');
INSERT INTO `access_log` VALUES (30144, '59.73.15597598475919371', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:37:28', 23, 2001001000, '服务端发生异常', '2019-06-06 02:37:28');
INSERT INTO `access_log` VALUES (30145, '65.3607.15597598589751325', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:37:39', 1, 1002001015, '账号未登陆', '2019-06-06 02:37:39');
INSERT INTO `access_log` VALUES (30146, '65.46.15597598589779569', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:37:39', 1, 1002001015, '账号未登陆', '2019-06-06 02:37:39');
INSERT INTO `access_log` VALUES (30147, '65.45.15597598589779575', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:37:39', 1, 1002001015, '账号未登陆', '2019-06-06 02:37:39');
INSERT INTO `access_log` VALUES (30148, '65.49.15597598605689581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:37:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 02:37:41');
INSERT INTO `access_log` VALUES (30149, '65.51.15597598790259563', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:37:59', 144, 0, '', '2019-06-06 02:37:59');
INSERT INTO `access_log` VALUES (30150, '65.52.15597598793739559', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:37:59', 13, 0, '', '2019-06-06 02:37:59');
INSERT INTO `access_log` VALUES (30151, '65.54.15597598793769521', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:37:59', 12, 0, '', '2019-06-06 02:37:59');
INSERT INTO `access_log` VALUES (30152, '65.50.15597598793799555', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:37:59', 10, 0, '', '2019-06-06 02:37:59');
INSERT INTO `access_log` VALUES (30153, '62.88.15597598864179225', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:38:06', 183, 0, '', '2019-06-06 02:38:07');
INSERT INTO `access_log` VALUES (30154, '62.83.15597598883589217', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:38:08', 16, 0, '', '2019-06-06 02:38:08');
INSERT INTO `access_log` VALUES (30155, '64.83.15597598974859141', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:38:17', 24, 0, '', '2019-06-06 02:38:18');
INSERT INTO `access_log` VALUES (30156, '64.84.15597598974839157', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:38:17', 29, 0, '', '2019-06-06 02:38:18');
INSERT INTO `access_log` VALUES (30157, '64.80.15597598993869149', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:38:19', 11, 0, '', '2019-06-06 02:38:19');
INSERT INTO `access_log` VALUES (30158, '64.79.15597598993839145', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:38:19', 18, 0, '', '2019-06-06 02:38:19');
INSERT INTO `access_log` VALUES (30159, '64.81.15597599149789149', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:38:35', 11, 0, '', '2019-06-06 02:38:35');
INSERT INTO `access_log` VALUES (30160, '64.82.15597599164389161', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:38:36', 13, 0, '', '2019-06-06 02:38:36');
INSERT INTO `access_log` VALUES (30161, '64.77.15597599180599159', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:38:38', 10, 0, '', '2019-06-06 02:38:38');
INSERT INTO `access_log` VALUES (30162, '65.3607.15597599216531327', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:38:42', 15, 0, '', '2019-06-06 02:38:42');
INSERT INTO `access_log` VALUES (30163, '65.49.15597599233439583', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:38:43', 10, 0, '', '2019-06-06 02:38:43');
INSERT INTO `access_log` VALUES (30164, '65.47.15597599239619565', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:38:44', 10, 0, '', '2019-06-06 02:38:44');
INSERT INTO `access_log` VALUES (30165, '62.87.15597599286109207', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:38:49', 22, 0, '', '2019-06-06 02:38:49');
INSERT INTO `access_log` VALUES (30166, '62.81.15597599303589195', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '183.15.207.211', '2019-06-06 02:38:50', 13, 0, '', '2019-06-06 02:38:50');
INSERT INTO `access_log` VALUES (30167, '59.73.15597725613579541', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '45.56.152.136', '2019-06-06 06:09:21', 15, 2001001000, '服务端发生异常', '2019-06-06 06:09:21');
INSERT INTO `access_log` VALUES (30168, '59.72.15597725613579537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '45.56.152.136', '2019-06-06 06:09:21', 176, 0, '', '2019-06-06 06:09:22');
INSERT INTO `access_log` VALUES (30169, '64.79.15597725727629315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '45.56.152.136', '2019-06-06 06:09:33', 12, 0, '', '2019-06-06 06:09:33');
INSERT INTO `access_log` VALUES (30170, '64.80.15597725729549319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '45.56.152.136', '2019-06-06 06:09:33', 3, 0, '', '2019-06-06 06:09:33');
INSERT INTO `access_log` VALUES (30171, '59.75.15597735615279553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:02', 3, 0, '', '2019-06-06 06:26:02');
INSERT INTO `access_log` VALUES (30172, '59.74.15597735615349549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:02', 13, 2001001000, '服务端发生异常', '2019-06-06 06:26:02');
INSERT INTO `access_log` VALUES (30173, '59.80.15597735755899543', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:16', 2, 0, '', '2019-06-06 06:26:16');
INSERT INTO `access_log` VALUES (30174, '59.72.15597735755899551', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:16', 19, 2001001000, '服务端发生异常', '2019-06-06 06:26:16');
INSERT INTO `access_log` VALUES (30175, '64.79.15597735808249329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:21', 23, 0, '', '2019-06-06 06:26:21');
INSERT INTO `access_log` VALUES (30176, '64.80.15597735810749333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:21', 3, 0, '', '2019-06-06 06:26:21');
INSERT INTO `access_log` VALUES (30177, '64.78.15597735834429341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:23', 2, 0, '', '2019-06-06 06:26:23');
INSERT INTO `access_log` VALUES (30178, '64.81.15597735850889333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:25', 2, 0, '', '2019-06-06 06:26:25');
INSERT INTO `access_log` VALUES (30179, '64.76.15597735866369323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:27', 2, 0, '', '2019-06-06 06:26:27');
INSERT INTO `access_log` VALUES (30180, '64.82.15597735875089345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:28', 2, 0, '', '2019-06-06 06:26:28');
INSERT INTO `access_log` VALUES (30181, '64.77.15597735899519343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:30', 1, 0, '', '2019-06-06 06:26:30');
INSERT INTO `access_log` VALUES (30182, '64.85.15597735909799355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:31', 401, 0, '', '2019-06-06 06:26:31');
INSERT INTO `access_log` VALUES (30183, '64.84.15597735916439343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:32', 1, 0, '', '2019-06-06 06:26:32');
INSERT INTO `access_log` VALUES (30184, '59.79.15597735926619553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:33', 2, 0, '', '2019-06-06 06:26:33');
INSERT INTO `access_log` VALUES (30185, '59.76.15597735926659545', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OPPO R11s Build/NMF26X; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/55.0.2883.91 Mobile Safari/537.36', '59.63.204.74', '2019-06-06 06:26:33', 14, 2001001000, '服务端发生异常', '2019-06-06 06:26:33');
INSERT INTO `access_log` VALUES (30186, '59.71.15597804964329651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.4.101', '2019-06-06 08:21:36', 18, 0, '', '2019-06-06 08:21:36');
INSERT INTO `access_log` VALUES (30187, '59.75.15597804964329647', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.4.101', '2019-06-06 08:21:36', 21, 2001001000, '服务端发生异常', '2019-06-06 08:21:36');
INSERT INTO `access_log` VALUES (30188, '65.47.15597805799989841', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:23:00', 0, 1002001015, '账号未登陆', '2019-06-06 08:23:00');
INSERT INTO `access_log` VALUES (30189, '65.3607.15597805799931603', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:23:00', 1, 1002001015, '账号未登陆', '2019-06-06 08:23:00');
INSERT INTO `access_log` VALUES (30190, '65.49.15597805799939859', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:23:00', 1, 1002001015, '账号未登陆', '2019-06-06 08:23:00');
INSERT INTO `access_log` VALUES (30191, '65.54.15597805942649799', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:23:14', 109, 0, '', '2019-06-06 08:23:14');
INSERT INTO `access_log` VALUES (30192, '65.52.15597805946649837', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:23:15', 25, 0, '', '2019-06-06 08:23:15');
INSERT INTO `access_log` VALUES (30193, '65.53.15597805946729819', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:23:15', 15, 0, '', '2019-06-06 08:23:15');
INSERT INTO `access_log` VALUES (30194, '65.50.15597805946699833', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:23:15', 20, 0, '', '2019-06-06 08:23:15');
INSERT INTO `access_log` VALUES (30195, '62.81.15597806043089471', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:23:24', 37, 0, '', '2019-06-06 08:23:24');
INSERT INTO `access_log` VALUES (30196, '64.85.15597806122419449', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:23:32', 20, 0, '', '2019-06-06 08:23:32');
INSERT INTO `access_log` VALUES (30197, '64.84.15597806122459437', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:23:32', 16, 0, '', '2019-06-06 08:23:32');
INSERT INTO `access_log` VALUES (30198, '64.80.15597806181099429', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:23:38', 12, 0, '', '2019-06-06 08:23:38');
INSERT INTO `access_log` VALUES (30199, '64.79.15597806181099425', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:23:38', 15, 0, '', '2019-06-06 08:23:38');
INSERT INTO `access_log` VALUES (30200, '64.81.15597806212929429', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:23:41', 11, 0, '', '2019-06-06 08:23:41');
INSERT INTO `access_log` VALUES (30201, '64.78.15597806212919437', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:23:41', 14, 0, '', '2019-06-06 08:23:41');
INSERT INTO `access_log` VALUES (30202, '66.56.15597806621088205', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '123.160.132.150', '2019-06-06 08:24:22', 20, 0, '', '2019-06-06 08:24:22');
INSERT INTO `access_log` VALUES (30203, '59.72.15597812797459655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:34:40', 12, 2001001000, '服务端发生异常', '2019-06-06 08:34:40');
INSERT INTO `access_log` VALUES (30204, '59.80.15597812797459647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:34:40', 159, 0, '', '2019-06-06 08:34:40');
INSERT INTO `access_log` VALUES (30205, '59.79.15597812922689657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.119.90.34', '2019-06-06 08:34:52', 3, 0, '', '2019-06-06 08:34:52');
INSERT INTO `access_log` VALUES (30206, '59.76.15597812922699649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.119.90.34', '2019-06-06 08:34:52', 17, 2001001000, '服务端发生异常', '2019-06-06 08:34:52');
INSERT INTO `access_log` VALUES (30207, '64.83.15597812947529431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.119.90.34', '2019-06-06 08:34:55', 435, 0, '', '2019-06-06 08:34:55');
INSERT INTO `access_log` VALUES (30208, '64.80.15597812953579439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.119.90.34', '2019-06-06 08:34:55', 2, 0, '', '2019-06-06 08:34:55');
INSERT INTO `access_log` VALUES (30209, '65.45.15597826892949883', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:58:09', 0, 1002001015, '账号未登陆', '2019-06-06 08:58:09');
INSERT INTO `access_log` VALUES (30210, '65.46.15597826892939877', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:58:09', 0, 1002001015, '账号未登陆', '2019-06-06 08:58:09');
INSERT INTO `access_log` VALUES (30211, '65.49.15597826892949889', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:58:09', 0, 1002001015, '账号未登陆', '2019-06-06 08:58:09');
INSERT INTO `access_log` VALUES (30212, '65.47.15597827025469871', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '13.230.234.190', '2019-06-06 08:58:23', 0, 1002001015, '账号未登陆', '2019-06-06 08:58:23');
INSERT INTO `access_log` VALUES (30213, '65.3607.15597827025491633', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '13.230.234.190', '2019-06-06 08:58:23', 0, 1002001015, '账号未登陆', '2019-06-06 08:58:23');
INSERT INTO `access_log` VALUES (30214, '65.51.15597827025499871', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '13.230.234.190', '2019-06-06 08:58:23', 1, 1002001015, '账号未登陆', '2019-06-06 08:58:23');
INSERT INTO `access_log` VALUES (30215, '65.53.15597827127029849', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:58:33', 69, 0, '', '2019-06-06 08:58:33');
INSERT INTO `access_log` VALUES (30216, '65.52.15597827130689867', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:58:33', 159, 0, '', '2019-06-06 08:58:33');
INSERT INTO `access_log` VALUES (30217, '65.50.15597827130739863', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:58:33', 158, 0, '', '2019-06-06 08:58:33');
INSERT INTO `access_log` VALUES (30218, '65.49.15597827130749891', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:58:33', 156, 0, '', '2019-06-06 08:58:33');
INSERT INTO `access_log` VALUES (30219, '62.86.15597827181169507', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:58:38', 22, 0, '', '2019-06-06 08:58:38');
INSERT INTO `access_log` VALUES (30220, '64.84.15597827223849467', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:58:42', 14, 0, '', '2019-06-06 08:58:42');
INSERT INTO `access_log` VALUES (30221, '64.77.15597827223839467', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:58:42', 15, 0, '', '2019-06-06 08:58:42');
INSERT INTO `access_log` VALUES (30222, '64.83.15597827253699451', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:58:45', 11, 0, '', '2019-06-06 08:58:45');
INSERT INTO `access_log` VALUES (30223, '64.85.15597827253689479', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:58:45', 14, 0, '', '2019-06-06 08:58:45');
INSERT INTO `access_log` VALUES (30224, '66.48.15597827368038245', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:58:57', 20, 0, '', '2019-06-06 08:58:57');
INSERT INTO `access_log` VALUES (30225, '59.80.15597827407619667', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.119.90.34', '2019-06-06 08:59:01', 14, 0, '', '2019-06-06 08:59:01');
INSERT INTO `access_log` VALUES (30226, '65.49.15597829684579895', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '18.206.159.236', '2019-06-06 09:02:48', 0, 1002001015, '账号未登陆', '2019-06-06 09:02:48');
INSERT INTO `access_log` VALUES (30227, '65.50.15597831286329869', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '34.228.240.168', '2019-06-06 09:05:29', 0, 1002001015, '账号未登陆', '2019-06-06 09:05:29');
INSERT INTO `access_log` VALUES (30228, '65.45.15597831342809891', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '34.228.240.168', '2019-06-06 09:05:34', 0, 1002001015, '账号未登陆', '2019-06-06 09:05:34');
INSERT INTO `access_log` VALUES (30229, '65.50.15597851860059899', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-06 09:39:46', 13, 1002001012, '访问令牌已过期', '2019-06-06 09:39:46');
INSERT INTO `access_log` VALUES (30230, '65.54.15597851860069865', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-06 09:39:46', 13, 1002001012, '访问令牌已过期', '2019-06-06 09:39:46');
INSERT INTO `access_log` VALUES (30231, '65.52.15597851860049905', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-06 09:39:46', 13, 1002001012, '访问令牌已过期', '2019-06-06 09:39:46');
INSERT INTO `access_log` VALUES (30232, '65.49.15597851931849925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-06 09:39:53', 106, 0, '', '2019-06-06 09:39:53');
INSERT INTO `access_log` VALUES (30233, '65.45.15597851935299925', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-06 09:39:54', 11, 0, '', '2019-06-06 09:39:54');
INSERT INTO `access_log` VALUES (30234, '65.47.15597851935339909', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-06 09:39:54', 9, 0, '', '2019-06-06 09:39:54');
INSERT INTO `access_log` VALUES (30235, '65.51.15597851935349911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-06 09:39:54', 10, 0, '', '2019-06-06 09:39:54');
INSERT INTO `access_log` VALUES (30236, '64.82.15597852131149505', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-06 09:40:13', 20, 0, '', '2019-06-06 09:40:13');
INSERT INTO `access_log` VALUES (30237, '64.76.15597852131149481', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-06 09:40:13', 24, 0, '', '2019-06-06 09:40:13');
INSERT INTO `access_log` VALUES (30238, '64.83.15597854934139491', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-06 09:44:53', 16, 0, '', '2019-06-06 09:44:53');
INSERT INTO `access_log` VALUES (30239, '64.82.15597854934139509', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.88.206', '2019-06-06 09:44:53', 17, 0, '', '2019-06-06 09:44:53');
INSERT INTO `access_log` VALUES (30240, '65.53.15597856334819895', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:47:13', 0, 1002001015, '账号未登陆', '2019-06-06 09:47:13');
INSERT INTO `access_log` VALUES (30241, '65.3607.15597856334801677', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:47:13', 1, 1002001015, '账号未登陆', '2019-06-06 09:47:13');
INSERT INTO `access_log` VALUES (30242, '65.46.15597856334829919', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:47:13', 0, 1002001015, '账号未登陆', '2019-06-06 09:47:13');
INSERT INTO `access_log` VALUES (30243, '65.50.15597856359389907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:47:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 09:47:16');
INSERT INTO `access_log` VALUES (30244, '65.54.15597856403159873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:47:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 09:47:20');
INSERT INTO `access_log` VALUES (30245, '65.46.15597857332419921', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:48:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 09:48:53');
INSERT INTO `access_log` VALUES (30246, '65.53.15597858442289899', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:50:44', 169, 0, '', '2019-06-06 09:50:44');
INSERT INTO `access_log` VALUES (30247, '65.46.15597858446839923', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:50:45', 95, 0, '', '2019-06-06 09:50:45');
INSERT INTO `access_log` VALUES (30248, '65.3607.15597858446851681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:50:45', 93, 0, '', '2019-06-06 09:50:45');
INSERT INTO `access_log` VALUES (30249, '65.50.15597858446889911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:50:45', 91, 0, '', '2019-06-06 09:50:45');
INSERT INTO `access_log` VALUES (30250, '62.89.15597858494999565', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:50:50', 29, 0, '', '2019-06-06 09:50:50');
INSERT INTO `access_log` VALUES (30251, '64.79.15597858564089499', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:50:56', 12, 0, '', '2019-06-06 09:50:56');
INSERT INTO `access_log` VALUES (30252, '64.78.15597858564139511', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:50:56', 10, 0, '', '2019-06-06 09:50:56');
INSERT INTO `access_log` VALUES (30253, '66.50.15597858602248279', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:51:00', 22, 0, '', '2019-06-06 09:51:00');
INSERT INTO `access_log` VALUES (30254, '59.80.15597858642069709', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:51:04', 19, 0, '', '2019-06-06 09:51:04');
INSERT INTO `access_log` VALUES (30255, '65.52.15597858661829917', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:51:06', 28, 0, '', '2019-06-06 09:51:06');
INSERT INTO `access_log` VALUES (30256, '64.83.15597858856559497', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:51:26', 11, 0, '', '2019-06-06 09:51:26');
INSERT INTO `access_log` VALUES (30257, '64.82.15597858856559515', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:51:26', 9, 0, '', '2019-06-06 09:51:26');
INSERT INTO `access_log` VALUES (30258, '66.54.15597859514308287', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '202.98.47.197', '2019-06-06 09:52:31', 110, 0, '', '2019-06-06 09:52:32');
INSERT INTO `access_log` VALUES (30259, '59.71.15597868318669737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.81', '2019-06-06 10:07:12', 4, 0, '', '2019-06-06 10:07:12');
INSERT INTO `access_log` VALUES (30260, '59.75.15597868318679733', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.81', '2019-06-06 10:07:12', 24, 2001001000, '服务端发生异常', '2019-06-06 10:07:12');
INSERT INTO `access_log` VALUES (30261, '64.80.15597868373259515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.81', '2019-06-06 10:07:17', 87, 0, '', '2019-06-06 10:07:17');
INSERT INTO `access_log` VALUES (30262, '64.78.15597868378499525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.81', '2019-06-06 10:07:18', 2, 0, '', '2019-06-06 10:07:18');
INSERT INTO `access_log` VALUES (30263, '64.81.15597868463489515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.81', '2019-06-06 10:07:26', 2, 0, '', '2019-06-06 10:07:26');
INSERT INTO `access_log` VALUES (30264, '64.76.15597868464339505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.81', '2019-06-06 10:07:26', 2, 0, '', '2019-06-06 10:07:26');
INSERT INTO `access_log` VALUES (30265, '59.73.15597868473079735', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.81', '2019-06-06 10:07:27', 2, 0, '', '2019-06-06 10:07:27');
INSERT INTO `access_log` VALUES (30266, '59.72.15597868473079731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.81', '2019-06-06 10:07:27', 17, 2001001000, '服务端发生异常', '2019-06-06 10:07:27');
INSERT INTO `access_log` VALUES (30267, '65.50.15597868560429925', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.81', '2019-06-06 10:07:36', 4, 1002001012, '访问令牌已过期', '2019-06-06 10:07:36');
INSERT INTO `access_log` VALUES (30268, '65.46.15597868560429937', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.81', '2019-06-06 10:07:36', 6, 1002001012, '访问令牌已过期', '2019-06-06 10:07:36');
INSERT INTO `access_log` VALUES (30269, '65.54.15597868560499891', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.81', '2019-06-06 10:07:36', 2, 1002001012, '访问令牌已过期', '2019-06-06 10:07:36');
INSERT INTO `access_log` VALUES (30270, '65.49.15597868620969951', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.81', '2019-06-06 10:07:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 10:07:42');
INSERT INTO `access_log` VALUES (30271, '59.78.15597868956579737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:08:16', 2, 0, '', '2019-06-06 10:08:16');
INSERT INTO `access_log` VALUES (30272, '59.76.15597868956539725', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:08:16', 14, 2001001000, '服务端发生异常', '2019-06-06 10:08:16');
INSERT INTO `access_log` VALUES (30273, '64.85.15597869064269539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:08:26', 2, 0, '', '2019-06-06 10:08:26');
INSERT INTO `access_log` VALUES (30274, '64.80.15597869065869517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:08:27', 2, 0, '', '2019-06-06 10:08:27');
INSERT INTO `access_log` VALUES (30275, '64.78.15597869086429527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:08:29', 11, 0, '', '2019-06-06 10:08:29');
INSERT INTO `access_log` VALUES (30276, '64.79.15597869090799515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:08:29', 2, 0, '', '2019-06-06 10:08:29');
INSERT INTO `access_log` VALUES (30277, '64.81.15597869100659517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:08:30', 2, 0, '', '2019-06-06 10:08:30');
INSERT INTO `access_log` VALUES (30278, '59.80.15597871175019727', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:11:58', 3, 0, '', '2019-06-06 10:11:58');
INSERT INTO `access_log` VALUES (30279, '59.77.15597871175019729', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:11:58', 13, 2001001000, '服务端发生异常', '2019-06-06 10:11:58');
INSERT INTO `access_log` VALUES (30280, '59.75.15597871764439739', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:12:56', 4, 0, '', '2019-06-06 10:12:56');
INSERT INTO `access_log` VALUES (30281, '59.74.15597871764449735', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:12:56', 13, 2001001000, '服务端发生异常', '2019-06-06 10:12:56');
INSERT INTO `access_log` VALUES (30282, '64.79.15597871806589519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:13:01', 3, 0, '', '2019-06-06 10:13:01');
INSERT INTO `access_log` VALUES (30283, '64.81.15597871808609521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:13:01', 2, 0, '', '2019-06-06 10:13:01');
INSERT INTO `access_log` VALUES (30284, '64.82.15597871868689535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:13:07', 2, 0, '', '2019-06-06 10:13:07');
INSERT INTO `access_log` VALUES (30285, '64.83.15597871889139517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:13:09', 2, 0, '', '2019-06-06 10:13:09');
INSERT INTO `access_log` VALUES (30286, '64.84.15597871911529531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:13:11', 2, 0, '', '2019-06-06 10:13:11');
INSERT INTO `access_log` VALUES (30287, '64.77.15597871940819531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:13:14', 2, 0, '', '2019-06-06 10:13:14');
INSERT INTO `access_log` VALUES (30288, '64.85.15597871985799545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:13:19', 2, 0, '', '2019-06-06 10:13:19');
INSERT INTO `access_log` VALUES (30289, '64.80.15597871988399523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:13:19', 2, 0, '', '2019-06-06 10:13:19');
INSERT INTO `access_log` VALUES (30290, '64.79.15597872048489521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:13:25', 2, 0, '', '2019-06-06 10:13:25');
INSERT INTO `access_log` VALUES (30291, '64.81.15597872050849523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:13:25', 2, 0, '', '2019-06-06 10:13:25');
INSERT INTO `access_log` VALUES (30292, '64.83.15597872306369519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:13:51', 2, 0, '', '2019-06-06 10:13:51');
INSERT INTO `access_log` VALUES (30293, '64.84.15597872309109533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:13:51', 2, 0, '', '2019-06-06 10:13:51');
INSERT INTO `access_log` VALUES (30294, '64.77.15597872322819533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:13:52', 2, 0, '', '2019-06-06 10:13:52');
INSERT INTO `access_log` VALUES (30295, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:14:36', 14, 0, '', '2019-06-06 10:14:36');
INSERT INTO `access_log` VALUES (30296, '64.79.15597872759459523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:14:36', 2, 0, '', '2019-06-06 10:14:36');
INSERT INTO `access_log` VALUES (30297, '64.81.15597872902099525', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:14:50', 196, 0, '', '2019-06-06 10:14:50');
INSERT INTO `access_log` VALUES (30298, '64.83.15597873106229521', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:15:11', 7, 0, '', '2019-06-06 10:15:11');
INSERT INTO `access_log` VALUES (30299, '64.84.15597873156049535', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:15:16', 13, 0, '', '2019-06-06 10:15:16');
INSERT INTO `access_log` VALUES (30300, '64.77.15597873193459535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:15:19', 2, 0, '', '2019-06-06 10:15:19');
INSERT INTO `access_log` VALUES (30301, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:15:19', 7, 0, '', '2019-06-06 10:15:19');
INSERT INTO `access_log` VALUES (30302, '64.80.15597873226369527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:15:23', 3, 0, '', '2019-06-06 10:15:23');
INSERT INTO `access_log` VALUES (30303, '64.78.15597873229139537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:15:23', 2, 0, '', '2019-06-06 10:15:23');
INSERT INTO `access_log` VALUES (30304, '59.77.15597873628539733', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:16:03', 4, 0, '', '2019-06-06 10:16:03');
INSERT INTO `access_log` VALUES (30305, '59.80.15597873628599731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:16:03', 14, 2001001000, '服务端发生异常', '2019-06-06 10:16:03');
INSERT INTO `access_log` VALUES (30306, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:16:20', 8, 0, '', '2019-06-06 10:16:20');
INSERT INTO `access_log` VALUES (30307, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=java', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '58.243.250.131', '2019-06-06 10:16:20', 14, 0, '', '2019-06-06 10:16:20');
INSERT INTO `access_log` VALUES (30308, '59.77.15597874749819735', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:17:55', 3, 0, '', '2019-06-06 10:17:55');
INSERT INTO `access_log` VALUES (30309, '59.80.15597874749839733', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:17:55', 12, 2001001000, '服务端发生异常', '2019-06-06 10:17:55');
INSERT INTO `access_log` VALUES (30310, '65.47.15597874819329943', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:18:02', 1, 1002001015, '账号未登陆', '2019-06-06 10:18:02');
INSERT INTO `access_log` VALUES (30311, '65.45.15597874819329959', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:18:02', 1, 1002001015, '账号未登陆', '2019-06-06 10:18:02');
INSERT INTO `access_log` VALUES (30312, '65.53.15597874819559923', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:18:02', 0, 1002001015, '账号未登陆', '2019-06-06 10:18:02');
INSERT INTO `access_log` VALUES (30313, '64.81.15597874860009529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:18:06', 3, 0, '', '2019-06-06 10:18:06');
INSERT INTO `access_log` VALUES (30314, '64.76.15597874861639519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:18:06', 2, 0, '', '2019-06-06 10:18:06');
INSERT INTO `access_log` VALUES (30315, '64.82.15597874880249543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:18:08', 2, 0, '', '2019-06-06 10:18:08');
INSERT INTO `access_log` VALUES (30316, '64.83.15597874887819525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:18:09', 2, 0, '', '2019-06-06 10:18:09');
INSERT INTO `access_log` VALUES (30317, '66.48.15597874919998309', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:18:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空\n账号长度为 11 位', '2019-06-06 10:18:12');
INSERT INTO `access_log` VALUES (30318, '64.84.15597874958789539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:18:16', 2, 0, '', '2019-06-06 10:18:16');
INSERT INTO `access_log` VALUES (30319, '64.77.15597874959799539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:18:16', 1, 0, '', '2019-06-06 10:18:16');
INSERT INTO `access_log` VALUES (30320, '64.85.15597874974809553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:18:17', 2, 0, '', '2019-06-06 10:18:17');
INSERT INTO `access_log` VALUES (30321, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:18:17', 6, 0, '', '2019-06-06 10:18:17');
INSERT INTO `access_log` VALUES (30322, '64.80.15597874989189531', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:18:19', 7, 0, '', '2019-06-06 10:18:19');
INSERT INTO `access_log` VALUES (30323, '65.46.15597875044769947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:18:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 10:18:24');
INSERT INTO `access_log` VALUES (30324, '65.54.15597879738899909', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '180.97.204.248', '2019-06-06 10:26:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 10:26:14');
INSERT INTO `access_log` VALUES (30325, '65.47.15597880835449953', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:04', 0, 1002001015, '账号未登陆', '2019-06-06 10:28:04');
INSERT INTO `access_log` VALUES (30326, '65.54.15597880835529911', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:04', 1, 1002001015, '账号未登陆', '2019-06-06 10:28:04');
INSERT INTO `access_log` VALUES (30327, '65.46.15597880835529955', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:04', 0, 1002001015, '账号未登陆', '2019-06-06 10:28:04');
INSERT INTO `access_log` VALUES (30328, '65.51.15597880899709955', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 10:28:10');
INSERT INTO `access_log` VALUES (30329, '65.50.15597880940749947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:14', 64, 0, '', '2019-06-06 10:28:14');
INSERT INTO `access_log` VALUES (30330, '65.3607.15597880943121717', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:14', 9, 0, '', '2019-06-06 10:28:14');
INSERT INTO `access_log` VALUES (30331, '65.45.15597880943159969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:14', 16, 0, '', '2019-06-06 10:28:14');
INSERT INTO `access_log` VALUES (30332, '65.49.15597880943189969', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:14', 17, 0, '', '2019-06-06 10:28:14');
INSERT INTO `access_log` VALUES (30333, '62.84.15597881071579585', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:27', 25, 0, '', '2019-06-06 10:28:27');
INSERT INTO `access_log` VALUES (30334, '59.71.15597881167239757', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:37', 13, 0, '', '2019-06-06 10:28:37');
INSERT INTO `access_log` VALUES (30335, '59.75.15597881191819753', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:39', 20, 2001001000, '服务端发生异常', '2019-06-06 10:28:39');
INSERT INTO `access_log` VALUES (30336, '59.74.15597881214829749', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:41', 17, 0, '', '2019-06-06 10:28:42');
INSERT INTO `access_log` VALUES (30337, '59.72.15597881233019751', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:43', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-06 10:28:43');
INSERT INTO `access_log` VALUES (30338, '66.49.15597881258128323', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:46', 21, 0, '', '2019-06-06 10:28:46');
INSERT INTO `access_log` VALUES (30339, '65.46.15597881354409957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.43.235.112', '2019-06-06 10:28:55', 16, 0, '', '2019-06-06 10:28:55');
INSERT INTO `access_log` VALUES (30340, '59.78.15597884866719761', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.17.39.34', '2019-06-06 10:34:47', 4, 0, '', '2019-06-06 10:34:47');
INSERT INTO `access_log` VALUES (30341, '59.76.15597884867959749', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.17.39.34', '2019-06-06 10:34:47', 13, 2001001000, '服务端发生异常', '2019-06-06 10:34:47');
INSERT INTO `access_log` VALUES (30342, '64.77.15597884930579553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:34:53', 2, 0, '', '2019-06-06 10:34:53');
INSERT INTO `access_log` VALUES (30343, '64.85.15597884931819567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:34:53', 2, 0, '', '2019-06-06 10:34:53');
INSERT INTO `access_log` VALUES (30344, '64.80.15597884953959545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:34:55', 2, 0, '', '2019-06-06 10:34:55');
INSERT INTO `access_log` VALUES (30345, '64.78.15597884963149555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:34:56', 2, 0, '', '2019-06-06 10:34:56');
INSERT INTO `access_log` VALUES (30346, '64.79.15597884964749543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:34:56', 1, 0, '', '2019-06-06 10:34:56');
INSERT INTO `access_log` VALUES (30347, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:34:57', 8, 0, '', '2019-06-06 10:34:57');
INSERT INTO `access_log` VALUES (30348, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:34:58', 7, 0, '', '2019-06-06 10:34:58');
INSERT INTO `access_log` VALUES (30349, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:34:58', 11, 0, '', '2019-06-06 10:34:58');
INSERT INTO `access_log` VALUES (30350, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:34:58', 5, 0, '', '2019-06-06 10:34:58');
INSERT INTO `access_log` VALUES (30351, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:34:58', 5, 0, '', '2019-06-06 10:34:58');
INSERT INTO `access_log` VALUES (30352, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:34:58', 13, 0, '', '2019-06-06 10:34:58');
INSERT INTO `access_log` VALUES (30353, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:34:58', 12, 0, '', '2019-06-06 10:34:58');
INSERT INTO `access_log` VALUES (30354, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:34:58', 11, 0, '', '2019-06-06 10:34:58');
INSERT INTO `access_log` VALUES (30355, '64.81.15597885027559545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:35:03', 1, 0, '', '2019-06-06 10:35:03');
INSERT INTO `access_log` VALUES (30356, '64.76.15597885028509535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:35:03', 2, 0, '', '2019-06-06 10:35:03');
INSERT INTO `access_log` VALUES (30357, '59.72.15597885053369757', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:35:05', 13, 2001001000, '服务端发生异常', '2019-06-06 10:35:05');
INSERT INTO `access_log` VALUES (30358, '59.74.15597885053359755', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:35:05', 302, 0, '', '2019-06-06 10:35:06');
INSERT INTO `access_log` VALUES (30359, '66.56.15597885318328311', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13901167668&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '218.17.39.34', '2019-06-06 10:35:32', 179, 1001003000, '验证码不存在', '2019-06-06 10:35:32');
INSERT INTO `access_log` VALUES (30360, '65.51.15597893618649973', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:49:22', 1, 1002001015, '账号未登陆', '2019-06-06 10:49:22');
INSERT INTO `access_log` VALUES (30361, '65.50.15597893618659965', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:49:22', 0, 1002001015, '账号未登陆', '2019-06-06 10:49:22');
INSERT INTO `access_log` VALUES (30362, '65.49.15597893618659987', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:49:22', 0, 1002001015, '账号未登陆', '2019-06-06 10:49:22');
INSERT INTO `access_log` VALUES (30363, '65.45.15597893638509987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:49:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 10:49:24');
INSERT INTO `access_log` VALUES (30364, '65.53.15597893686409951', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:49:29', 86, 0, '', '2019-06-06 10:49:29');
INSERT INTO `access_log` VALUES (30365, '65.47.15597893689589973', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:49:29', 10, 0, '', '2019-06-06 10:49:29');
INSERT INTO `access_log` VALUES (30366, '65.54.15597893689589931', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:49:29', 11, 0, '', '2019-06-06 10:49:29');
INSERT INTO `access_log` VALUES (30367, '65.46.15597893689649975', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:49:29', 16, 0, '', '2019-06-06 10:49:29');
INSERT INTO `access_log` VALUES (30368, '62.89.15597893788679613', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:49:39', 17, 0, '', '2019-06-06 10:49:39');
INSERT INTO `access_log` VALUES (30369, '64.76.15597893858639547', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:49:46', 12, 0, '', '2019-06-06 10:49:46');
INSERT INTO `access_log` VALUES (30370, '64.82.15597893858709571', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:49:46', 9, 0, '', '2019-06-06 10:49:46');
INSERT INTO `access_log` VALUES (30371, '59.72.15597893927299769', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:49:53', 14, 0, '', '2019-06-06 10:49:53');
INSERT INTO `access_log` VALUES (30372, '62.83.15597894004449613', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:50:00', 14, 0, '', '2019-06-06 10:50:00');
INSERT INTO `access_log` VALUES (30373, '62.85.15597894087269611', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-07 10:50:00&createEndTime=2019-07-03 10:50:00&payChannel=200', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:50:09', 16, 0, '', '2019-06-06 10:50:09');
INSERT INTO `access_log` VALUES (30374, '62.87.15597894122359603', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-07 10:50:00&createEndTime=2019-07-03 10:50:00&payChannel=9999', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:50:12', 15, 0, '', '2019-06-06 10:50:12');
INSERT INTO `access_log` VALUES (30375, '62.81.15597894137829591', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-07 10:50:00&createEndTime=2019-07-03 10:50:00&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:50:14', 14, 0, '', '2019-06-06 10:50:14');
INSERT INTO `access_log` VALUES (30376, '62.82.15597894144199617', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-07 10:50:00&createEndTime=2019-07-03 10:50:00', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:50:14', 1306, 0, '', '2019-06-06 10:50:16');
INSERT INTO `access_log` VALUES (30377, '62.89.15597894159129615', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-07 10:50:00&createEndTime=2019-07-03 10:50:00', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.139.198.153', '2019-06-06 10:50:16', 300, 0, '', '2019-06-06 10:50:16');
INSERT INTO `access_log` VALUES (30378, '65.53.15597897569739955', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:55:57', 5, 1002001012, '访问令牌已过期', '2019-06-06 10:55:57');
INSERT INTO `access_log` VALUES (30379, '65.47.15597897569739979', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:55:57', 4, 1002001012, '访问令牌已过期', '2019-06-06 10:55:57');
INSERT INTO `access_log` VALUES (30380, '65.54.15597897569749939', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:55:57', 3, 1002001012, '访问令牌已过期', '2019-06-06 10:55:57');
INSERT INTO `access_log` VALUES (30381, '65.46.15597897808929983', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:56:21', 99, 0, '', '2019-06-06 10:56:21');
INSERT INTO `access_log` VALUES (30382, '65.51.15597897813039983', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:56:21', 9, 0, '', '2019-06-06 10:56:21');
INSERT INTO `access_log` VALUES (30383, '65.49.15597897813049997', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:56:21', 10, 0, '', '2019-06-06 10:56:21');
INSERT INTO `access_log` VALUES (30384, '65.50.15597897813199973', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.131', '2019-06-06 10:56:21', 9, 0, '', '2019-06-06 10:56:21');
INSERT INTO `access_log` VALUES (30385, '65.50.15597903681789981', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 11:06:08', 1, 1002001015, '账号未登陆', '2019-06-06 11:06:08');
INSERT INTO `access_log` VALUES (30386, '65.45.15597903681800003', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 11:06:08', 0, 1002001015, '账号未登陆', '2019-06-06 11:06:08');
INSERT INTO `access_log` VALUES (30387, '65.3607.15597903681911753', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 11:06:08', 1, 1002001015, '账号未登陆', '2019-06-06 11:06:08');
INSERT INTO `access_log` VALUES (30388, '65.47.15597903768279989', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 11:06:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 11:06:17');
INSERT INTO `access_log` VALUES (30389, '65.52.15597903873429987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 11:06:27', 62, 0, '', '2019-06-06 11:06:27');
INSERT INTO `access_log` VALUES (30390, '65.46.15597903876679993', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 11:06:28', 9, 0, '', '2019-06-06 11:06:28');
INSERT INTO `access_log` VALUES (30391, '65.51.15597903876689993', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 11:06:28', 10, 0, '', '2019-06-06 11:06:28');
INSERT INTO `access_log` VALUES (30392, '65.49.15597903876700007', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 11:06:28', 9, 0, '', '2019-06-06 11:06:28');
INSERT INTO `access_log` VALUES (30393, '62.81.15597904243429605', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 11:07:04', 16, 0, '', '2019-06-06 11:07:04');
INSERT INTO `access_log` VALUES (30394, '65.54.15597904356289951', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 11:07:16', 19, 0, '', '2019-06-06 11:07:16');
INSERT INTO `access_log` VALUES (30395, '65.53.15597904467959967', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 11:07:27', 13, 0, '', '2019-06-06 11:07:27');
INSERT INTO `access_log` VALUES (30396, '65.52.15597904493169989', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 11:07:29', 23, 0, '', '2019-06-06 11:07:29');
INSERT INTO `access_log` VALUES (30397, '65.51.15597904515169995', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 11:07:32', 13, 0, '', '2019-06-06 11:07:32');
INSERT INTO `access_log` VALUES (30398, '65.49.15597904608960009', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 11:07:41', 20, 0, '', '2019-06-06 11:07:41');
INSERT INTO `access_log` VALUES (30399, '59.72.15597922185499807', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:36:59', 17, 2001001000, '服务端发生异常', '2019-06-06 11:36:59');
INSERT INTO `access_log` VALUES (30400, '59.74.15597922185499805', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:36:59', 246, 0, '', '2019-06-06 11:36:59');
INSERT INTO `access_log` VALUES (30401, '64.83.15597922268619591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:07', 11, 0, '', '2019-06-06 11:37:07');
INSERT INTO `access_log` VALUES (30402, '64.84.15597922270189605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:07', 2, 0, '', '2019-06-06 11:37:07');
INSERT INTO `access_log` VALUES (30403, '64.85.15597922297379619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:10', 53, 0, '', '2019-06-06 11:37:10');
INSERT INTO `access_log` VALUES (30404, '64.77.15597922289069605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:09', 884, 0, '', '2019-06-06 11:37:10');
INSERT INTO `access_log` VALUES (30405, '64.80.15597922329989597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:13', 3, 0, '', '2019-06-06 11:37:13');
INSERT INTO `access_log` VALUES (30406, '64.78.15597922345039607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:15', 3, 0, '', '2019-06-06 11:37:15');
INSERT INTO `access_log` VALUES (30407, '64.79.15597922353769595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:15', 1, 0, '', '2019-06-06 11:37:15');
INSERT INTO `access_log` VALUES (30408, '65.49.15597922435410033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:24', 1, 1002001015, '账号未登陆', '2019-06-06 11:37:24');
INSERT INTO `access_log` VALUES (30409, '65.46.15597922435410019', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:24', 1, 1002001015, '账号未登陆', '2019-06-06 11:37:24');
INSERT INTO `access_log` VALUES (30410, '65.45.15597922435410031', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:24', 0, 1002001015, '账号未登陆', '2019-06-06 11:37:24');
INSERT INTO `access_log` VALUES (30411, '65.3607.15597922455701781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:26', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 11:37:26');
INSERT INTO `access_log` VALUES (30412, '65.54.15597922509599977', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 11:37:31');
INSERT INTO `access_log` VALUES (30413, '65.53.15597922670389993', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.116.53.16', '2019-06-06 11:37:47', 1, 1002001015, '账号未登陆', '2019-06-06 11:37:47');
INSERT INTO `access_log` VALUES (30414, '65.52.15597922670500015', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.116.53.16', '2019-06-06 11:37:47', 0, 1002001015, '账号未登陆', '2019-06-06 11:37:47');
INSERT INTO `access_log` VALUES (30415, '65.51.15597922670590021', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.116.53.16', '2019-06-06 11:37:47', 0, 1002001015, '账号未登陆', '2019-06-06 11:37:47');
INSERT INTO `access_log` VALUES (30416, '65.49.15597922705510035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:51', 61, 0, '', '2019-06-06 11:37:51');
INSERT INTO `access_log` VALUES (30417, '65.46.15597922708880021', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:51', 10, 0, '', '2019-06-06 11:37:51');
INSERT INTO `access_log` VALUES (30418, '65.45.15597922708930033', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:51', 10, 0, '', '2019-06-06 11:37:51');
INSERT INTO `access_log` VALUES (30419, '65.50.15597922708950011', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:37:51', 10, 0, '', '2019-06-06 11:37:51');
INSERT INTO `access_log` VALUES (30420, '65.3607.15597922711681783', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.116.53.16', '2019-06-06 11:37:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 11:37:51');
INSERT INTO `access_log` VALUES (30421, '65.47.15597922745580019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.116.53.16', '2019-06-06 11:37:55', 85, 0, '', '2019-06-06 11:37:55');
INSERT INTO `access_log` VALUES (30422, '65.53.15597922806939995', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.116.53.16', '2019-06-06 11:38:01', 74, 0, '', '2019-06-06 11:38:01');
INSERT INTO `access_log` VALUES (30423, '62.88.15597922849669661', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.184.200.230', '2019-06-06 11:38:05', 24, 0, '', '2019-06-06 11:38:05');
INSERT INTO `access_log` VALUES (30424, '65.49.15597923070450037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.116.53.16', '2019-06-06 11:38:27', 76, 0, '', '2019-06-06 11:38:27');
INSERT INTO `access_log` VALUES (30425, '65.45.15597923226640035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.116.53.16', '2019-06-06 11:38:43', 93, 0, '', '2019-06-06 11:38:43');
INSERT INTO `access_log` VALUES (30426, '65.3607.15597923231341785', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.116.53.16', '2019-06-06 11:38:43', 9, 0, '', '2019-06-06 11:38:43');
INSERT INTO `access_log` VALUES (30427, '65.50.15597923231340013', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.116.53.16', '2019-06-06 11:38:43', 11, 0, '', '2019-06-06 11:38:43');
INSERT INTO `access_log` VALUES (30428, '65.54.15597923231459981', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.116.53.16', '2019-06-06 11:38:43', 8, 0, '', '2019-06-06 11:38:43');
INSERT INTO `access_log` VALUES (30429, '59.73.15597923659909813', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.64.1', '2019-06-06 11:39:26', 7, 0, '', '2019-06-06 11:39:26');
INSERT INTO `access_log` VALUES (30430, '59.80.15597923659929801', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.64.1', '2019-06-06 11:39:26', 13, 2001001000, '服务端发生异常', '2019-06-06 11:39:26');
INSERT INTO `access_log` VALUES (30431, '65.52.15597923690220019', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:39:29', 1, 1002001015, '账号未登陆', '2019-06-06 11:39:29');
INSERT INTO `access_log` VALUES (30432, '65.49.15597923690230039', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:39:29', 0, 1002001015, '账号未登陆', '2019-06-06 11:39:29');
INSERT INTO `access_log` VALUES (30433, '65.46.15597923690270025', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:39:29', 0, 1002001015, '账号未登陆', '2019-06-06 11:39:29');
INSERT INTO `access_log` VALUES (30434, '65.50.15597923720030015', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:39:32', 0, 1002001015, '账号未登陆', '2019-06-06 11:39:32');
INSERT INTO `access_log` VALUES (30435, '65.45.15597923720030037', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:39:32', 1, 1002001015, '账号未登陆', '2019-06-06 11:39:32');
INSERT INTO `access_log` VALUES (30436, '65.3607.15597923720091787', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:39:32', 0, 1002001015, '账号未登陆', '2019-06-06 11:39:32');
INSERT INTO `access_log` VALUES (30437, '65.54.15597923729189983', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:39:33', 1, 1002001015, '账号未登陆', '2019-06-06 11:39:33');
INSERT INTO `access_log` VALUES (30438, '65.47.15597923729210023', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:39:33', 1, 1002001015, '账号未登陆', '2019-06-06 11:39:33');
INSERT INTO `access_log` VALUES (30439, '65.53.15597923729249999', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:39:33', 1, 1002001015, '账号未登陆', '2019-06-06 11:39:33');
INSERT INTO `access_log` VALUES (30440, '65.51.15597923750280027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:39:35', 78, 0, '', '2019-06-06 11:39:35');
INSERT INTO `access_log` VALUES (30441, '65.49.15597923752950041', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:39:35', 9, 0, '', '2019-06-06 11:39:35');
INSERT INTO `access_log` VALUES (30442, '65.52.15597923752950021', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:39:35', 9, 0, '', '2019-06-06 11:39:35');
INSERT INTO `access_log` VALUES (30443, '65.46.15597923753050027', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:39:35', 9, 0, '', '2019-06-06 11:39:35');
INSERT INTO `access_log` VALUES (30444, '65.50.15597923760950017', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:39:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 11:39:36');
INSERT INTO `access_log` VALUES (30445, '64.81.15597923770279599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.64.1', '2019-06-06 11:39:37', 3, 0, '', '2019-06-06 11:39:37');
INSERT INTO `access_log` VALUES (30446, '64.76.15597923771599589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.64.1', '2019-06-06 11:39:37', 2, 0, '', '2019-06-06 11:39:37');
INSERT INTO `access_log` VALUES (30447, '62.86.15597923792109639', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:39:39', 12, 0, '', '2019-06-06 11:39:39');
INSERT INTO `access_log` VALUES (30448, '65.3607.15597923794371789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:39:39', 100, 0, '', '2019-06-06 11:39:40');
INSERT INTO `access_log` VALUES (30449, '65.54.15597923797699985', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:39:40', 11, 0, '', '2019-06-06 11:39:40');
INSERT INTO `access_log` VALUES (30450, '65.53.15597923797740001', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:39:40', 8, 0, '', '2019-06-06 11:39:40');
INSERT INTO `access_log` VALUES (30451, '65.47.15597923797760025', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:39:40', 9, 0, '', '2019-06-06 11:39:40');
INSERT INTO `access_log` VALUES (30452, '64.82.15597923805069613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.64.1', '2019-06-06 11:39:41', 2, 0, '', '2019-06-06 11:39:41');
INSERT INTO `access_log` VALUES (30453, '64.83.15597923806319595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.64.1', '2019-06-06 11:39:41', 1, 0, '', '2019-06-06 11:39:41');
INSERT INTO `access_log` VALUES (30454, '59.79.15597923815519811', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.64.1', '2019-06-06 11:39:42', 2, 0, '', '2019-06-06 11:39:42');
INSERT INTO `access_log` VALUES (30455, '59.78.15597923815529815', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.64.1', '2019-06-06 11:39:42', 13, 2001001000, '服务端发生异常', '2019-06-06 11:39:42');
INSERT INTO `access_log` VALUES (30456, '62.84.15597923846649645', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:39:45', 12, 0, '', '2019-06-06 11:39:45');
INSERT INTO `access_log` VALUES (30457, '65.51.15597923861080029', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:39:46', 20, 0, '', '2019-06-06 11:39:46');
INSERT INTO `access_log` VALUES (30458, '65.52.15597923894420023', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:39:49', 291, 0, '', '2019-06-06 11:39:50');
INSERT INTO `access_log` VALUES (30459, '65.46.15597923918380029', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.64.1', '2019-06-06 11:39:52', 0, 1002001015, '账号未登陆', '2019-06-06 11:39:52');
INSERT INTO `access_log` VALUES (30460, '65.49.15597923918440043', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 11:39:52', 1, 1002001015, '账号未登陆', '2019-06-06 11:39:52');
INSERT INTO `access_log` VALUES (30461, '65.50.15597923918560019', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.64.1', '2019-06-06 11:39:52', 0, 1002001015, '账号未登陆', '2019-06-06 11:39:52');
INSERT INTO `access_log` VALUES (30462, '65.3607.15597923940781791', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:39:54', 45, 0, '', '2019-06-06 11:39:54');
INSERT INTO `access_log` VALUES (30463, '65.54.15597923959049987', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:39:56', 130, 0, '', '2019-06-06 11:39:56');
INSERT INTO `access_log` VALUES (30464, '65.53.15597923961240003', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:39:56', 31, 0, '', '2019-06-06 11:39:56');
INSERT INTO `access_log` VALUES (30465, '65.47.15597923978340027', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:39:58', 155, 0, '', '2019-06-06 11:39:58');
INSERT INTO `access_log` VALUES (30466, '65.51.15597924005540031', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:40:01', 8, 0, '', '2019-06-06 11:40:01');
INSERT INTO `access_log` VALUES (30467, '65.52.15597924039740025', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:40:04', 314, 0, '', '2019-06-06 11:40:04');
INSERT INTO `access_log` VALUES (30468, '62.85.15597924074989653', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.116.53.16', '2019-06-06 11:40:07', 9, 0, '', '2019-06-06 11:40:08');
INSERT INTO `access_log` VALUES (30469, '65.53.15597924087430005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=youdaoyuanma&password=youdaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 11:40:09', 5, 1002002000, '账号不存在', '2019-06-06 11:40:09');
INSERT INTO `access_log` VALUES (30470, '65.54.15597924099109989', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.108.191.154', '2019-06-06 11:40:10', 145, 0, '', '2019-06-06 11:40:10');
INSERT INTO `access_log` VALUES (30471, '62.87.15597924130269645', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.116.53.16', '2019-06-06 11:40:13', 19, 0, '', '2019-06-06 11:40:13');
INSERT INTO `access_log` VALUES (30472, '65.51.15597924144180033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 11:40:14', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 11:40:14');
INSERT INTO `access_log` VALUES (30473, '62.81.15597924204569633', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.116.53.16', '2019-06-06 11:40:20', 12, 0, '', '2019-06-06 11:40:20');
INSERT INTO `access_log` VALUES (30474, '65.52.15597924299390027', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.116.53.16', '2019-06-06 11:40:30', 30, 0, '', '2019-06-06 11:40:30');
INSERT INTO `access_log` VALUES (30475, '65.49.15597924360280045', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.116.53.16', '2019-06-06 11:40:36', 15, 0, '', '2019-06-06 11:40:36');
INSERT INTO `access_log` VALUES (30476, '65.46.15597924373780031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=youdaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 11:40:37', 81, 0, '', '2019-06-06 11:40:37');
INSERT INTO `access_log` VALUES (30477, '65.50.15597924377180023', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 11:40:38', 9, 0, '', '2019-06-06 11:40:38');
INSERT INTO `access_log` VALUES (30478, '65.45.15597924377210043', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 11:40:38', 8, 0, '', '2019-06-06 11:40:38');
INSERT INTO `access_log` VALUES (30479, '65.3607.15597924377241795', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.64.1', '2019-06-06 11:40:38', 9, 0, '', '2019-06-06 11:40:38');
INSERT INTO `access_log` VALUES (30480, '66.49.15597924458468381', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:40:46', 93, 0, '', '2019-06-06 11:40:46');
INSERT INTO `access_log` VALUES (30481, '65.49.15597924472060047', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.116.53.16', '2019-06-06 11:40:47', 10, 0, '', '2019-06-06 11:40:47');
INSERT INTO `access_log` VALUES (30482, '59.74.15597924485899809', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:40:49', 14, 0, '', '2019-06-06 11:40:49');
INSERT INTO `access_log` VALUES (30483, '59.80.15597924508469803', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:40:51', 12, 0, '', '2019-06-06 11:40:51');
INSERT INTO `access_log` VALUES (30484, '59.77.15597924526729805', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:40:53', 317, 0, '', '2019-06-06 11:40:53');
INSERT INTO `access_log` VALUES (30485, '65.46.15597924530460033', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.116.53.16', '2019-06-06 11:40:53', 8, 0, '', '2019-06-06 11:40:53');
INSERT INTO `access_log` VALUES (30486, '59.78.15597924559129817', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:40:56', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-06 11:40:56');
INSERT INTO `access_log` VALUES (30487, '59.79.15597924583489813', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:40:58', 13, 0, '', '2019-06-06 11:40:58');
INSERT INTO `access_log` VALUES (30488, '59.76.15597924606329805', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:41:01', 13, 0, '', '2019-06-06 11:41:01');
INSERT INTO `access_log` VALUES (30489, '59.71.15597924618149819', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:41:02', 10, 0, '', '2019-06-06 11:41:02');
INSERT INTO `access_log` VALUES (30490, '66.55.15597924625818379', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:41:03', 14, 0, '', '2019-06-06 11:41:03');
INSERT INTO `access_log` VALUES (30491, '59.72.15597924673749813', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.116.53.16', '2019-06-06 11:41:07', 11, 0, '', '2019-06-06 11:41:07');
INSERT INTO `access_log` VALUES (30492, '64.76.15597924684139591', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:41:08', 11, 0, '', '2019-06-06 11:41:08');
INSERT INTO `access_log` VALUES (30493, '64.81.15597924684119601', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.147.105.226', '2019-06-06 11:41:08', 13, 0, '', '2019-06-06 11:41:08');
INSERT INTO `access_log` VALUES (30494, '65.52.15597925484640029', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:42:28', 0, 1002001015, '账号未登陆', '2019-06-06 11:42:28');
INSERT INTO `access_log` VALUES (30495, '65.49.15597925484680049', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:42:28', 1, 1002001015, '账号未登陆', '2019-06-06 11:42:28');
INSERT INTO `access_log` VALUES (30496, '65.46.15597925484720035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:42:28', 0, 1002001015, '账号未登陆', '2019-06-06 11:42:28');
INSERT INTO `access_log` VALUES (30497, '65.3607.15597925559341799', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:42:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 11:42:36');
INSERT INTO `access_log` VALUES (30498, '59.76.15597925562149807', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '14.155.89.112', '2019-06-06 11:42:36', 5, 0, '', '2019-06-06 11:42:36');
INSERT INTO `access_log` VALUES (30499, '59.71.15597925562159821', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 11:42:36', 13, 2001001000, '服务端发生异常', '2019-06-06 11:42:36');
INSERT INTO `access_log` VALUES (30500, '65.50.15597925614670027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:42:41', 140, 0, '', '2019-06-06 11:42:42');
INSERT INTO `access_log` VALUES (30501, '65.47.15597925618750035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:42:42', 10, 0, '', '2019-06-06 11:42:42');
INSERT INTO `access_log` VALUES (30502, '65.54.15597925618769993', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:42:42', 9, 0, '', '2019-06-06 11:42:42');
INSERT INTO `access_log` VALUES (30503, '65.51.15597925618750037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:42:42', 10, 0, '', '2019-06-06 11:42:42');
INSERT INTO `access_log` VALUES (30504, '64.78.15597925632019613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 11:42:43', 11, 0, '', '2019-06-06 11:42:43');
INSERT INTO `access_log` VALUES (30505, '64.79.15597925633489601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 11:42:43', 1, 0, '', '2019-06-06 11:42:43');
INSERT INTO `access_log` VALUES (30506, '64.76.15597925651339593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 11:42:45', 2, 0, '', '2019-06-06 11:42:45');
INSERT INTO `access_log` VALUES (30507, '64.81.15597925656609603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 11:42:46', 166, 0, '', '2019-06-06 11:42:46');
INSERT INTO `access_log` VALUES (30508, '64.82.15597925668859617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 11:42:47', 2, 0, '', '2019-06-06 11:42:47');
INSERT INTO `access_log` VALUES (30509, '64.83.15597925702669599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 11:42:50', 2, 0, '', '2019-06-06 11:42:50');
INSERT INTO `access_log` VALUES (30510, '64.84.15597925703879613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 11:42:50', 1, 0, '', '2019-06-06 11:42:50');
INSERT INTO `access_log` VALUES (30511, '64.85.15597925770749627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 11:42:57', 2, 0, '', '2019-06-06 11:42:57');
INSERT INTO `access_log` VALUES (30512, '64.80.15597925771979605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 11:42:57', 2, 0, '', '2019-06-06 11:42:57');
INSERT INTO `access_log` VALUES (30513, '62.84.15597926325939651', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:43:53', 15, 0, '', '2019-06-06 11:43:53');
INSERT INTO `access_log` VALUES (30514, '65.45.15597926372180049', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '218.19.113.120', '2019-06-06 11:43:57', 0, 1002001015, '账号未登陆', '2019-06-06 11:43:57');
INSERT INTO `access_log` VALUES (30515, '65.50.15597926372200029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '218.19.113.120', '2019-06-06 11:43:57', 0, 1002001015, '账号未登陆', '2019-06-06 11:43:57');
INSERT INTO `access_log` VALUES (30516, '65.54.15597926372279995', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '218.19.113.120', '2019-06-06 11:43:57', 0, 1002001015, '账号未登陆', '2019-06-06 11:43:57');
INSERT INTO `access_log` VALUES (30517, '66.52.15597926399138379', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:44:00', 14, 0, '', '2019-06-06 11:44:00');
INSERT INTO `access_log` VALUES (30518, '65.51.15597926400250039', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '218.19.113.120', '2019-06-06 11:44:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 11:44:00');
INSERT INTO `access_log` VALUES (30519, '62.83.15597926453589661', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:44:05', 10, 0, '', '2019-06-06 11:44:05');
INSERT INTO `access_log` VALUES (30520, '65.49.15597926544140053', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:14', 1, 1002001015, '账号未登陆', '2019-06-06 11:44:14');
INSERT INTO `access_log` VALUES (30521, '65.53.15597926544140015', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:14', 1, 1002001015, '账号未登陆', '2019-06-06 11:44:14');
INSERT INTO `access_log` VALUES (30522, '65.52.15597926544140033', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:14', 1, 1002001015, '账号未登陆', '2019-06-06 11:44:14');
INSERT INTO `access_log` VALUES (30523, '65.46.15597926555950039', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.13.14.226', '2019-06-06 11:44:16', 0, 1002001015, '账号未登陆', '2019-06-06 11:44:16');
INSERT INTO `access_log` VALUES (30524, '65.3607.15597926555991803', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.13.14.226', '2019-06-06 11:44:16', 1, 1002001015, '账号未登陆', '2019-06-06 11:44:16');
INSERT INTO `access_log` VALUES (30525, '65.50.15597926556080031', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.13.14.226', '2019-06-06 11:44:16', 1, 1002001015, '账号未登陆', '2019-06-06 11:44:16');
INSERT INTO `access_log` VALUES (30526, '59.78.15597926557629821', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.66.66', '2019-06-06 11:44:16', 3, 0, '', '2019-06-06 11:44:16');
INSERT INTO `access_log` VALUES (30527, '59.79.15597926557689817', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.66.66', '2019-06-06 11:44:16', 13, 2001001000, '服务端发生异常', '2019-06-06 11:44:16');
INSERT INTO `access_log` VALUES (30528, '65.54.15597926564009997', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 11:44:16');
INSERT INTO `access_log` VALUES (30529, '66.48.15597926582038379', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:44:18', 15, 0, '', '2019-06-06 11:44:18');
INSERT INTO `access_log` VALUES (30530, '65.45.15597926602410051', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '218.19.113.120', '2019-06-06 11:44:20', 272, 0, '', '2019-06-06 11:44:21');
INSERT INTO `access_log` VALUES (30531, '65.51.15597926608130041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '218.19.113.120', '2019-06-06 11:44:21', 9, 0, '', '2019-06-06 11:44:21');
INSERT INTO `access_log` VALUES (30532, '65.47.15597926608180039', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '218.19.113.120', '2019-06-06 11:44:21', 8, 0, '', '2019-06-06 11:44:21');
INSERT INTO `access_log` VALUES (30533, '65.49.15597926608190055', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '218.19.113.120', '2019-06-06 11:44:21', 9, 0, '', '2019-06-06 11:44:21');
INSERT INTO `access_log` VALUES (30534, '62.87.15597926641629651', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '218.19.113.120', '2019-06-06 11:44:24', 75, 0, '', '2019-06-06 11:44:24');
INSERT INTO `access_log` VALUES (30535, '64.84.15597926665169615', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '218.19.113.120', '2019-06-06 11:44:27', 10, 0, '', '2019-06-06 11:44:27');
INSERT INTO `access_log` VALUES (30536, '64.77.15597926665209615', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '218.19.113.120', '2019-06-06 11:44:27', 7, 0, '', '2019-06-06 11:44:27');
INSERT INTO `access_log` VALUES (30537, '65.52.15597926664440035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:26', 85, 0, '', '2019-06-06 11:44:27');
INSERT INTO `access_log` VALUES (30538, '65.3607.15597926667381805', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:27', 7, 0, '', '2019-06-06 11:44:27');
INSERT INTO `access_log` VALUES (30539, '65.46.15597926667380041', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:27', 8, 0, '', '2019-06-06 11:44:27');
INSERT INTO `access_log` VALUES (30540, '65.50.15597926667410033', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:27', 8, 0, '', '2019-06-06 11:44:27');
INSERT INTO `access_log` VALUES (30541, '65.54.15597926684819999', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:44:28', 19, 0, '', '2019-06-06 11:44:29');
INSERT INTO `access_log` VALUES (30542, '65.45.15597926696310053', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '218.19.113.120', '2019-06-06 11:44:30', 18, 0, '', '2019-06-06 11:44:30');
INSERT INTO `access_log` VALUES (30543, '62.81.15597926759919639', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:36', 12, 0, '', '2019-06-06 11:44:36');
INSERT INTO `access_log` VALUES (30544, '65.51.15597926790570043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.13.14.226', '2019-06-06 11:44:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 11:44:39');
INSERT INTO `access_log` VALUES (30545, '65.47.15597926793940041', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:44:39', 11, 0, '', '2019-06-06 11:44:39');
INSERT INTO `access_log` VALUES (30546, '59.75.15597926878809819', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:48', 3, 0, '', '2019-06-06 11:44:48');
INSERT INTO `access_log` VALUES (30547, '59.72.15597926878819817', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:48', 14, 2001001000, '服务端发生异常', '2019-06-06 11:44:48');
INSERT INTO `access_log` VALUES (30548, '65.53.15597926926410019', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:44:53', 72, 0, '', '2019-06-06 11:44:53');
INSERT INTO `access_log` VALUES (30549, '64.78.15597926946209617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:55', 2, 0, '', '2019-06-06 11:44:55');
INSERT INTO `access_log` VALUES (30550, '64.79.15597926947409605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:55', 2, 0, '', '2019-06-06 11:44:55');
INSERT INTO `access_log` VALUES (30551, '64.76.15597926958039597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:56', 2, 0, '', '2019-06-06 11:44:56');
INSERT INTO `access_log` VALUES (30552, '64.81.15597926963419607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:44:56', 2, 0, '', '2019-06-06 11:44:56');
INSERT INTO `access_log` VALUES (30553, '65.46.15597927088530043', 27, 2, 'admin-application', '/admin-api/admins/role/add', 'name=管理员', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:45:09', 448, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-06 11:45:09');
INSERT INTO `access_log` VALUES (30554, '65.3607.15597927097941807', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:45:10', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-06-06 11:45:10');
INSERT INTO `access_log` VALUES (30555, '65.54.15597927166170001', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.47.149', '2019-06-06 11:45:17', 13, 0, '', '2019-06-06 11:45:17');
INSERT INTO `access_log` VALUES (30556, '59.80.15597927166359809', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:45:17', 10, 0, '', '2019-06-06 11:45:17');
INSERT INTO `access_log` VALUES (30557, '65.49.15597927259460059', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:45:26', 18, 0, '', '2019-06-06 11:45:26');
INSERT INTO `access_log` VALUES (30558, '65.53.15597927620730021', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:46:02', 10, 0, '', '2019-06-06 11:46:02');
INSERT INTO `access_log` VALUES (30559, '65.52.15597927649820039', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:46:05', 9, 0, '', '2019-06-06 11:46:05');
INSERT INTO `access_log` VALUES (30560, '65.50.15597927667530037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:46:07', 204, 0, '', '2019-06-06 11:46:07');
INSERT INTO `access_log` VALUES (30561, '59.72.15597927858999819', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:46:26', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-06 11:46:26');
INSERT INTO `access_log` VALUES (30562, '59.78.15597928828759825', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:48:03', 4, 0, '', '2019-06-06 11:48:03');
INSERT INTO `access_log` VALUES (30563, '59.76.15597928828789813', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:48:03', 14, 2001001000, '服务端发生异常', '2019-06-06 11:48:03');
INSERT INTO `access_log` VALUES (30564, '64.77.15597928860999619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:48:06', 2, 0, '', '2019-06-06 11:48:06');
INSERT INTO `access_log` VALUES (30565, '64.85.15597928862109633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:48:06', 2, 0, '', '2019-06-06 11:48:06');
INSERT INTO `access_log` VALUES (30566, '64.80.15597928871119611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:48:07', 2, 0, '', '2019-06-06 11:48:07');
INSERT INTO `access_log` VALUES (30567, '64.78.15597928874259621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:48:07', 2, 0, '', '2019-06-06 11:48:07');
INSERT INTO `access_log` VALUES (30568, '64.79.15597928877999609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:48:08', 2, 0, '', '2019-06-06 11:48:08');
INSERT INTO `access_log` VALUES (30569, '59.72.15597928910679821', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:48:11', 10, 2001001000, '服务端发生异常', '2019-06-06 11:48:11');
INSERT INTO `access_log` VALUES (30570, '59.75.15597928910699823', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.111.11.32', '2019-06-06 11:48:11', 29, 0, '', '2019-06-06 11:48:11');
INSERT INTO `access_log` VALUES (30571, '65.53.15597932993030029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '103.37.140.21', '2019-06-06 11:54:59', 1, 1002001015, '账号未登陆', '2019-06-06 11:54:59');
INSERT INTO `access_log` VALUES (30572, '65.47.15597932993030051', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '103.37.140.21', '2019-06-06 11:54:59', 1, 1002001015, '账号未登陆', '2019-06-06 11:54:59');
INSERT INTO `access_log` VALUES (30573, '65.52.15597932993060047', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '103.37.140.21', '2019-06-06 11:54:59', 0, 1002001015, '账号未登陆', '2019-06-06 11:54:59');
INSERT INTO `access_log` VALUES (30574, '65.50.15597933055500045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '103.37.140.21', '2019-06-06 11:55:06', 92, 0, '', '2019-06-06 11:55:06');
INSERT INTO `access_log` VALUES (30575, '65.46.15597933058590053', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '103.37.140.21', '2019-06-06 11:55:06', 9, 0, '', '2019-06-06 11:55:06');
INSERT INTO `access_log` VALUES (30576, '65.3607.15597933058611817', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '103.37.140.21', '2019-06-06 11:55:06', 9, 0, '', '2019-06-06 11:55:06');
INSERT INTO `access_log` VALUES (30577, '65.54.15597933058630011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '103.37.140.21', '2019-06-06 11:55:06', 8, 0, '', '2019-06-06 11:55:06');
INSERT INTO `access_log` VALUES (30578, '62.80.15597933230339677', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '103.37.140.21', '2019-06-06 11:55:23', 14, 0, '', '2019-06-06 11:55:23');
INSERT INTO `access_log` VALUES (30579, '65.51.15597933324460055', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:55:32', 0, 1002001015, '账号未登陆', '2019-06-06 11:55:32');
INSERT INTO `access_log` VALUES (30580, '65.53.15597933324510031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:55:32', 1, 1002001015, '账号未登陆', '2019-06-06 11:55:32');
INSERT INTO `access_log` VALUES (30581, '65.47.15597933324560053', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:55:32', 0, 1002001015, '账号未登陆', '2019-06-06 11:55:32');
INSERT INTO `access_log` VALUES (30582, '65.52.15597933353040049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:55:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 11:55:35');
INSERT INTO `access_log` VALUES (30583, '59.74.15597933439929825', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '103.37.140.21', '2019-06-06 11:55:44', 12, 0, '', '2019-06-06 11:55:44');
INSERT INTO `access_log` VALUES (30584, '65.46.15597933450870055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:55:45', 107, 0, '', '2019-06-06 11:55:45');
INSERT INTO `access_log` VALUES (30585, '65.3607.15597933455981819', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:55:46', 8, 0, '', '2019-06-06 11:55:46');
INSERT INTO `access_log` VALUES (30586, '65.54.15597933456010013', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:55:46', 8, 0, '', '2019-06-06 11:55:46');
INSERT INTO `access_log` VALUES (30587, '65.45.15597933456040067', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:55:46', 8, 0, '', '2019-06-06 11:55:46');
INSERT INTO `access_log` VALUES (30588, '65.49.15597933478740071', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '103.37.140.21', '2019-06-06 11:55:48', 19, 0, '', '2019-06-06 11:55:48');
INSERT INTO `access_log` VALUES (30589, '64.81.15597933519969617', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:55:52', 16, 0, '', '2019-06-06 11:55:52');
INSERT INTO `access_log` VALUES (30590, '64.82.15597933519969631', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:55:52', 13, 0, '', '2019-06-06 11:55:52');
INSERT INTO `access_log` VALUES (30591, '65.51.15597933793110057', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '103.37.140.21', '2019-06-06 11:56:19', 183, 0, '', '2019-06-06 11:56:19');
INSERT INTO `access_log` VALUES (30592, '64.85.15597933813489641', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:56:21', 9, 0, '', '2019-06-06 11:56:21');
INSERT INTO `access_log` VALUES (30593, '64.77.15597933813489627', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:56:21', 11, 0, '', '2019-06-06 11:56:21');
INSERT INTO `access_log` VALUES (30594, '65.50.15597933902560049', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '103.37.140.21', '2019-06-06 11:56:30', 19, 0, '', '2019-06-06 11:56:30');
INSERT INTO `access_log` VALUES (30595, '59.79.15597933910909829', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '103.37.140.21', '2019-06-06 11:56:31', 11, 0, '', '2019-06-06 11:56:31');
INSERT INTO `access_log` VALUES (30596, '65.54.15597934127010015', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:56:53', 11, 0, '', '2019-06-06 11:56:53');
INSERT INTO `access_log` VALUES (30597, '65.3607.15597934142691821', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:56:54', 10, 0, '', '2019-06-06 11:56:54');
INSERT INTO `access_log` VALUES (30598, '64.76.15597934344949609', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 11:57:14', 10, 0, '', '2019-06-06 11:57:15');
INSERT INTO `access_log` VALUES (30599, '59.72.15597934350979829', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.64.1', '2019-06-06 11:57:15', 2, 0, '', '2019-06-06 11:57:15');
INSERT INTO `access_log` VALUES (30600, '59.75.15597934350999831', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.64.1', '2019-06-06 11:57:15', 13, 2001001000, '服务端发生异常', '2019-06-06 11:57:15');
INSERT INTO `access_log` VALUES (30601, '59.72.15597935584389831', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 11:59:18', 4, 0, '', '2019-06-06 11:59:18');
INSERT INTO `access_log` VALUES (30602, '59.75.15597935584419833', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 11:59:18', 13, 2001001000, '服务端发生异常', '2019-06-06 11:59:18');
INSERT INTO `access_log` VALUES (30603, '64.76.15597935684649611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 11:59:28', 2, 0, '', '2019-06-06 11:59:28');
INSERT INTO `access_log` VALUES (30604, '64.81.15597935685639621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 11:59:29', 2, 0, '', '2019-06-06 11:59:29');
INSERT INTO `access_log` VALUES (30605, '64.83.15597935823309617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 11:59:42', 2, 0, '', '2019-06-06 11:59:42');
INSERT INTO `access_log` VALUES (30606, '64.84.15597935824419631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 11:59:42', 2, 0, '', '2019-06-06 11:59:42');
INSERT INTO `access_log` VALUES (30607, '59.79.15597935958839833', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 11:59:56', 13, 2001001000, '服务端发生异常', '2019-06-06 11:59:56');
INSERT INTO `access_log` VALUES (30608, '59.77.15597935958829825', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 11:59:56', 280, 0, '', '2019-06-06 11:59:56');
INSERT INTO `access_log` VALUES (30609, '64.77.15597936003909631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 12:00:00', 2, 0, '', '2019-06-06 12:00:00');
INSERT INTO `access_log` VALUES (30610, '64.80.15597936004869623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 12:00:00', 2, 0, '', '2019-06-06 12:00:00');
INSERT INTO `access_log` VALUES (30611, '64.79.15597936055989621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 12:00:06', 2, 0, '', '2019-06-06 12:00:06');
INSERT INTO `access_log` VALUES (30612, '64.76.15597936067879613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 12:00:07', 2, 0, '', '2019-06-06 12:00:07');
INSERT INTO `access_log` VALUES (30613, '64.81.15597936074899623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 12:00:07', 2, 0, '', '2019-06-06 12:00:07');
INSERT INTO `access_log` VALUES (30614, '64.82.15597936079369637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 12:00:08', 2, 0, '', '2019-06-06 12:00:08');
INSERT INTO `access_log` VALUES (30615, '64.83.15597936083559619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 12:00:08', 1, 0, '', '2019-06-06 12:00:08');
INSERT INTO `access_log` VALUES (30616, '64.84.15597936087519633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat QBCore/3.43.1021.400 QQBrowser/9.0.2524.400', '27.18.91.146', '2019-06-06 12:00:09', 2, 0, '', '2019-06-06 12:00:09');
INSERT INTO `access_log` VALUES (30617, '65.3607.15597937083791825', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 12:01:48', 75, 0, '', '2019-06-06 12:01:48');
INSERT INTO `access_log` VALUES (30618, '65.49.15597937087280077', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 12:01:49', 9, 0, '', '2019-06-06 12:01:49');
INSERT INTO `access_log` VALUES (30619, '65.47.15597937087310061', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 12:01:49', 9, 0, '', '2019-06-06 12:01:49');
INSERT INTO `access_log` VALUES (30620, '65.53.15597937087320039', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 12:01:49', 9, 0, '', '2019-06-06 12:01:49');
INSERT INTO `access_log` VALUES (30621, '62.88.15597937155209687', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 12:01:56', 12, 0, '', '2019-06-06 12:01:56');
INSERT INTO `access_log` VALUES (30622, '64.83.15597937233419621', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 12:02:03', 8, 0, '', '2019-06-06 12:02:03');
INSERT INTO `access_log` VALUES (30623, '64.82.15597937233389639', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 12:02:03', 11, 0, '', '2019-06-06 12:02:03');
INSERT INTO `access_log` VALUES (30624, '64.77.15597937477789635', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=8&name=ssss', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 12:02:28', 8, 1002002009, NULL, '2019-06-06 12:02:28');
INSERT INTO `access_log` VALUES (30625, '65.45.15597937725540075', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.64.1', '2019-06-06 12:02:53', 7, 0, '', '2019-06-06 12:02:53');
INSERT INTO `access_log` VALUES (30626, '65.54.15597937725530021', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.66.66', '2019-06-06 12:02:53', 10, 0, '', '2019-06-06 12:02:53');
INSERT INTO `access_log` VALUES (30627, '65.3607.15597937725611827', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 12:02:53', 7, 0, '', '2019-06-06 12:02:53');
INSERT INTO `access_log` VALUES (30628, '62.81.15597937834729657', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.64.1', '2019-06-06 12:03:03', 14, 0, '', '2019-06-06 12:03:03');
INSERT INTO `access_log` VALUES (30629, '62.86.15597937971689665', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 12:03:17', 17, 0, '', '2019-06-06 12:03:17');
INSERT INTO `access_log` VALUES (30630, '66.51.15597938150128391', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 12:03:35', 13, 0, '', '2019-06-06 12:03:35');
INSERT INTO `access_log` VALUES (30631, '62.89.15597938996659683', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 12:05:00', 15, 0, '', '2019-06-06 12:05:00');
INSERT INTO `access_log` VALUES (30632, '64.78.15597939017039639', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 12:05:02', 107, 0, '', '2019-06-06 12:05:02');
INSERT INTO `access_log` VALUES (30633, '64.80.15597939016699629', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 12:05:02', 141, 0, '', '2019-06-06 12:05:02');
INSERT INTO `access_log` VALUES (30634, '62.86.15597939036909667', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.206.53', '2019-06-06 12:05:04', 45, 0, '', '2019-06-06 12:05:04');
INSERT INTO `access_log` VALUES (30635, '59.75.15597943984429845', 0, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:13:18', 7, 1002001012, '访问令牌已过期', '2019-06-06 12:13:18');
INSERT INTO `access_log` VALUES (30636, '65.49.15597944001690087', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:13:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 12:13:20');
INSERT INTO `access_log` VALUES (30637, '65.52.15597944102520067', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:13:30', 88, 0, '', '2019-06-06 12:13:30');
INSERT INTO `access_log` VALUES (30638, '65.50.15597944105830065', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:13:31', 10, 0, '', '2019-06-06 12:13:31');
INSERT INTO `access_log` VALUES (30639, '65.46.15597944105850073', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:13:31', 9, 0, '', '2019-06-06 12:13:31');
INSERT INTO `access_log` VALUES (30640, '65.54.15597944105890031', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:13:31', 10, 0, '', '2019-06-06 12:13:31');
INSERT INTO `access_log` VALUES (30641, '59.74.15597944135669841', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:13:34', 20, 2001001000, '服务端发生异常', '2019-06-06 12:13:34');
INSERT INTO `access_log` VALUES (30642, '59.80.15597944170299835', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:13:37', 12, 0, '', '2019-06-06 12:13:37');
INSERT INTO `access_log` VALUES (30643, '64.84.15597944201239645', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:13:40', 10, 0, '', '2019-06-06 12:13:40');
INSERT INTO `access_log` VALUES (30644, '64.85.15597944250449659', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:13:45', 9, 0, '', '2019-06-06 12:13:45');
INSERT INTO `access_log` VALUES (30645, '64.78.15597944326669647', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:13:53', 9, 0, '', '2019-06-06 12:13:53');
INSERT INTO `access_log` VALUES (30646, '64.76.15597944634589627', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:23', 9, 0, '', '2019-06-06 12:14:23');
INSERT INTO `access_log` VALUES (30647, '65.49.15597944772520089', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:37', 9, 0, '', '2019-06-06 12:14:37');
INSERT INTO `access_log` VALUES (30648, '65.51.15597944772570075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:37', 8, 0, '', '2019-06-06 12:14:37');
INSERT INTO `access_log` VALUES (30649, '65.52.15597944772670069', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:37', 9, 0, '', '2019-06-06 12:14:37');
INSERT INTO `access_log` VALUES (30650, '59.71.15597944773549851', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:37', 11, 0, '', '2019-06-06 12:14:37');
INSERT INTO `access_log` VALUES (30651, '65.50.15597944829190067', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:43', 9, 0, '', '2019-06-06 12:14:43');
INSERT INTO `access_log` VALUES (30652, '65.54.15597944829210033', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:43', 9, 0, '', '2019-06-06 12:14:43');
INSERT INTO `access_log` VALUES (30653, '65.45.15597944829250087', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:43', 8, 0, '', '2019-06-06 12:14:43');
INSERT INTO `access_log` VALUES (30654, '59.75.15597944829739847', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:43', 20, 0, '', '2019-06-06 12:14:43');
INSERT INTO `access_log` VALUES (30655, '65.47.15597944939640075', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:54', 10, 0, '', '2019-06-06 12:14:54');
INSERT INTO `access_log` VALUES (30656, '65.53.15597944939640053', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:54', 12, 0, '', '2019-06-06 12:14:54');
INSERT INTO `access_log` VALUES (30657, '65.52.15597944939680071', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:54', 9, 0, '', '2019-06-06 12:14:54');
INSERT INTO `access_log` VALUES (30658, '59.74.15597944940629843', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:54', 11, 0, '', '2019-06-06 12:14:54');
INSERT INTO `access_log` VALUES (30659, '65.51.15597944960170077', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:56', 9, 0, '', '2019-06-06 12:14:56');
INSERT INTO `access_log` VALUES (30660, '65.49.15597944960190091', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:56', 9, 0, '', '2019-06-06 12:14:56');
INSERT INTO `access_log` VALUES (30661, '65.46.15597944960200077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:56', 9, 0, '', '2019-06-06 12:14:56');
INSERT INTO `access_log` VALUES (30662, '59.73.15597944960809849', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:56', 9, 0, '', '2019-06-06 12:14:56');
INSERT INTO `access_log` VALUES (30663, '59.80.15597944989479837', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:14:59', 11, 0, '', '2019-06-06 12:14:59');
INSERT INTO `access_log` VALUES (30664, '64.83.15597945032899633', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:03', 481, 0, '', '2019-06-06 12:15:04');
INSERT INTO `access_log` VALUES (30665, '64.85.15597945083909661', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:08', 9, 0, '', '2019-06-06 12:15:08');
INSERT INTO `access_log` VALUES (30666, '64.77.15597945103499647', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:10', 9, 0, '', '2019-06-06 12:15:10');
INSERT INTO `access_log` VALUES (30667, '64.78.15597945134619649', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:13', 9, 0, '', '2019-06-06 12:15:13');
INSERT INTO `access_log` VALUES (30668, '64.80.15597945140879639', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:14', 7, 0, '', '2019-06-06 12:15:14');
INSERT INTO `access_log` VALUES (30669, '64.79.15597945167549637', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:17', 9, 0, '', '2019-06-06 12:15:17');
INSERT INTO `access_log` VALUES (30670, '64.76.15597945179039629', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:18', 9, 0, '', '2019-06-06 12:15:18');
INSERT INTO `access_log` VALUES (30671, '64.81.15597945192579639', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:19', 10, 0, '', '2019-06-06 12:15:19');
INSERT INTO `access_log` VALUES (30672, '64.83.15597945213659635', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:21', 7, 0, '', '2019-06-06 12:15:21');
INSERT INTO `access_log` VALUES (30673, '64.84.15597945328869649', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:33', 10, 0, '', '2019-06-06 12:15:33');
INSERT INTO `access_log` VALUES (30674, '59.76.15597945363169839', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:36', 11, 0, '', '2019-06-06 12:15:36');
INSERT INTO `access_log` VALUES (30675, '59.71.15597945445089853', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:45', 10, 0, '', '2019-06-06 12:15:45');
INSERT INTO `access_log` VALUES (30676, '59.75.15597945457979849', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10&status=WAIT&activityType=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:46', 10, 0, '', '2019-06-06 12:15:46');
INSERT INTO `access_log` VALUES (30677, '59.72.15597945465749847', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:47', 11, 0, '', '2019-06-06 12:15:47');
INSERT INTO `access_log` VALUES (30678, '59.73.15597945515609851', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:52', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-06 12:15:52');
INSERT INTO `access_log` VALUES (30679, '59.80.15597945530209839', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:53', 20, 2001001000, '服务端发生异常', '2019-06-06 12:15:53');
INSERT INTO `access_log` VALUES (30680, '65.52.15597945585380073', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:15:59', 15, 0, '', '2019-06-06 12:15:59');
INSERT INTO `access_log` VALUES (30681, '64.76.15597947413359633', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:19:01', 11, 0, '', '2019-06-06 12:19:01');
INSERT INTO `access_log` VALUES (30682, '64.79.15597947413349641', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:19:01', 13, 0, '', '2019-06-06 12:19:01');
INSERT INTO `access_log` VALUES (30683, '64.83.15597947555069639', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:19:16', 8, 0, '', '2019-06-06 12:19:16');
INSERT INTO `access_log` VALUES (30684, '64.82.15597947555049657', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:19:16', 12, 0, '', '2019-06-06 12:19:16');
INSERT INTO `access_log` VALUES (30685, '64.84.15597947595039653', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:19:20', 7, 0, '', '2019-06-06 12:19:20');
INSERT INTO `access_log` VALUES (30686, '64.78.15597947638839655', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:19:24', 9, 0, '', '2019-06-06 12:19:24');
INSERT INTO `access_log` VALUES (30687, '64.77.15597947638839653', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:19:24', 11, 0, '', '2019-06-06 12:19:24');
INSERT INTO `access_log` VALUES (30688, '64.81.15597948017259645', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:02', 9, 0, '', '2019-06-06 12:20:02');
INSERT INTO `access_log` VALUES (30689, '64.76.15597948017259635', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:02', 10, 0, '', '2019-06-06 12:20:02');
INSERT INTO `access_log` VALUES (30690, '64.83.15597948137509641', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:14', 10, 0, '', '2019-06-06 12:20:14');
INSERT INTO `access_log` VALUES (30691, '64.84.15597948149159655', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:15', 10, 0, '', '2019-06-06 12:20:15');
INSERT INTO `access_log` VALUES (30692, '64.85.15597948177829669', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:18', 11, 0, '', '2019-06-06 12:20:18');
INSERT INTO `access_log` VALUES (30693, '64.77.15597948189999655', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:19', 9, 0, '', '2019-06-06 12:20:19');
INSERT INTO `access_log` VALUES (30694, '64.78.15597948189959657', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:19', 13, 0, '', '2019-06-06 12:20:19');
INSERT INTO `access_log` VALUES (30695, '64.80.15597948190259647', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:19', 9, 0, '', '2019-06-06 12:20:19');
INSERT INTO `access_log` VALUES (30696, '62.81.15597948296669673', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:30', 11, 0, '', '2019-06-06 12:20:30');
INSERT INTO `access_log` VALUES (30697, '64.81.15597948342629647', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:34', 10, 0, '', '2019-06-06 12:20:34');
INSERT INTO `access_log` VALUES (30698, '64.76.15597948342629637', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:34', 11, 0, '', '2019-06-06 12:20:34');
INSERT INTO `access_log` VALUES (30699, '64.83.15597948370859643', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:37', 33, 0, '', '2019-06-06 12:20:37');
INSERT INTO `access_log` VALUES (30700, '64.84.15597948370869657', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:37', 32, 0, '', '2019-06-06 12:20:37');
INSERT INTO `access_log` VALUES (30701, '64.78.15597948489719659', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:49', 10, 0, '', '2019-06-06 12:20:49');
INSERT INTO `access_log` VALUES (30702, '64.77.15597948489719657', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:49', 12, 0, '', '2019-06-06 12:20:49');
INSERT INTO `access_log` VALUES (30703, '64.85.15597948489719671', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:49', 14, 0, '', '2019-06-06 12:20:49');
INSERT INTO `access_log` VALUES (30704, '64.81.15597948554299649', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:55', 11, 0, '', '2019-06-06 12:20:55');
INSERT INTO `access_log` VALUES (30705, '64.79.15597948554299647', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:20:55', 14, 0, '', '2019-06-06 12:20:55');
INSERT INTO `access_log` VALUES (30706, '64.82.15597948640919663', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:04', 9, 0, '', '2019-06-06 12:21:04');
INSERT INTO `access_log` VALUES (30707, '64.76.15597948640919639', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:04', 11, 0, '', '2019-06-06 12:21:04');
INSERT INTO `access_log` VALUES (30708, '64.77.15597948683389659', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:08', 16, 0, '', '2019-06-06 12:21:08');
INSERT INTO `access_log` VALUES (30709, '64.83.15597948683389645', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:08', 17, 0, '', '2019-06-06 12:21:08');
INSERT INTO `access_log` VALUES (30710, '64.80.15597948723429651', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:12', 9, 0, '', '2019-06-06 12:21:12');
INSERT INTO `access_log` VALUES (30711, '64.85.15597948723419673', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:12', 11, 0, '', '2019-06-06 12:21:12');
INSERT INTO `access_log` VALUES (30712, '64.78.15597948723419661', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:12', 14, 0, '', '2019-06-06 12:21:12');
INSERT INTO `access_log` VALUES (30713, '64.79.15597948771129649', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:17', 9, 0, '', '2019-06-06 12:21:17');
INSERT INTO `access_log` VALUES (30714, '64.81.15597948771119651', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:17', 11, 0, '', '2019-06-06 12:21:17');
INSERT INTO `access_log` VALUES (30715, '64.82.15597948784789665', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:18', 7, 0, '', '2019-06-06 12:21:18');
INSERT INTO `access_log` VALUES (30716, '64.76.15597948784789641', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:18', 9, 0, '', '2019-06-06 12:21:18');
INSERT INTO `access_log` VALUES (30717, '64.84.15597948803599661', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:20', 42, 0, '', '2019-06-06 12:21:20');
INSERT INTO `access_log` VALUES (30718, '62.80.15597948955669703', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:36', 12, 0, '', '2019-06-06 12:21:36');
INSERT INTO `access_log` VALUES (30719, '62.87.15597949014019687', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:41', 16, 0, '', '2019-06-06 12:21:41');
INSERT INTO `access_log` VALUES (30720, '66.57.15597949160218407', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:21:56', 12, 0, '', '2019-06-06 12:21:56');
INSERT INTO `access_log` VALUES (30721, '65.50.15597949251160079', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.38', '2019-06-06 12:22:05', 14, 0, '', '2019-06-06 12:22:05');
INSERT INTO `access_log` VALUES (30722, '59.73.15597958694229869', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60 MicroMessenger/7.0.3(0x17000321) NetType/3G Language/zh_CN', '112.96.173.44', '2019-06-06 12:37:49', 13, 2001001000, '服务端发生异常', '2019-06-06 12:37:49');
INSERT INTO `access_log` VALUES (30723, '59.80.15597958694429857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60 MicroMessenger/7.0.3(0x17000321) NetType/3G Language/zh_CN', '112.96.173.44', '2019-06-06 12:37:49', 3, 0, '', '2019-06-06 12:37:49');
INSERT INTO `access_log` VALUES (30724, '65.52.15597958820980097', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60 MicroMessenger/7.0.3(0x17000321) NetType/3G Language/zh_CN', '112.96.173.44', '2019-06-06 12:38:02', 1, 1002001015, '账号未登陆', '2019-06-06 12:38:02');
INSERT INTO `access_log` VALUES (30725, '65.47.15597958820970097', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60 MicroMessenger/7.0.3(0x17000321) NetType/3G Language/zh_CN', '112.96.173.44', '2019-06-06 12:38:02', 0, 1002001015, '账号未登陆', '2019-06-06 12:38:02');
INSERT INTO `access_log` VALUES (30726, '65.53.15597958821000075', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60 MicroMessenger/7.0.3(0x17000321) NetType/3G Language/zh_CN', '112.96.173.44', '2019-06-06 12:38:02', 0, 1002001015, '账号未登陆', '2019-06-06 12:38:02');
INSERT INTO `access_log` VALUES (30727, '65.49.15597958851330117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60 MicroMessenger/7.0.3(0x17000321) NetType/3G Language/zh_CN', '112.96.173.44', '2019-06-06 12:38:05', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 12:38:05');
INSERT INTO `access_log` VALUES (30728, '59.72.15597959549809867', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5964 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.63.76', '2019-06-06 12:39:15', 6, 0, '', '2019-06-06 12:39:15');
INSERT INTO `access_log` VALUES (30729, '59.75.15597959549809869', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5964 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.63.76', '2019-06-06 12:39:15', 19, 2001001000, '服务端发生异常', '2019-06-06 12:39:15');
INSERT INTO `access_log` VALUES (30730, '65.47.15597983703850131', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:19:30', 0, 1002001015, '账号未登陆', '2019-06-06 13:19:30');
INSERT INTO `access_log` VALUES (30731, '65.53.15597983703850109', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:19:30', 1, 1002001015, '账号未登陆', '2019-06-06 13:19:30');
INSERT INTO `access_log` VALUES (30732, '65.52.15597983704020131', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:19:30', 3, 1002001015, '账号未登陆', '2019-06-06 13:19:30');
INSERT INTO `access_log` VALUES (30733, '65.50.15597983712580125', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:19:31', 0, 1002001015, '账号未登陆', '2019-06-06 13:19:31');
INSERT INTO `access_log` VALUES (30734, '65.46.15597983712570135', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:19:31', 0, 1002001015, '账号未登陆', '2019-06-06 13:19:31');
INSERT INTO `access_log` VALUES (30735, '65.49.15597983712570151', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:19:31', 0, 1002001015, '账号未登陆', '2019-06-06 13:19:31');
INSERT INTO `access_log` VALUES (30736, '65.45.15597983719610155', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:19:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 13:19:32');
INSERT INTO `access_log` VALUES (30737, '65.54.15597983738670095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:19:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 13:19:34');
INSERT INTO `access_log` VALUES (30738, '65.3607.15597983758921901', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:19:36', 75, 0, '', '2019-06-06 13:19:36');
INSERT INTO `access_log` VALUES (30739, '65.51.15597983761650137', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:19:36', 15, 0, '', '2019-06-06 13:19:36');
INSERT INTO `access_log` VALUES (30740, '65.52.15597983761660133', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:19:36', 15, 0, '', '2019-06-06 13:19:36');
INSERT INTO `access_log` VALUES (30741, '65.53.15597983761670111', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:19:36', 11, 0, '', '2019-06-06 13:19:36');
INSERT INTO `access_log` VALUES (30742, '65.47.15597983777450133', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:19:38', 92, 0, '', '2019-06-06 13:19:38');
INSERT INTO `access_log` VALUES (30743, '65.50.15597983780710127', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:19:38', 7, 0, '', '2019-06-06 13:19:38');
INSERT INTO `access_log` VALUES (30744, '65.49.15597983780760153', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:19:38', 7, 0, '', '2019-06-06 13:19:38');
INSERT INTO `access_log` VALUES (30745, '65.46.15597983780950137', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:19:38', 8, 0, '', '2019-06-06 13:19:38');
INSERT INTO `access_log` VALUES (30746, '62.89.15597983809839745', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:19:41', 22, 0, '', '2019-06-06 13:19:41');
INSERT INTO `access_log` VALUES (30747, '62.86.15597983812179729', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:19:41', 12, 0, '', '2019-06-06 13:19:41');
INSERT INTO `access_log` VALUES (30748, '64.81.15597983835079699', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:19:44', 28, 0, '', '2019-06-06 13:19:44');
INSERT INTO `access_log` VALUES (30749, '64.78.15597983835069709', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:19:44', 33, 0, '', '2019-06-06 13:19:44');
INSERT INTO `access_log` VALUES (30750, '64.82.15597983883269713', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:19:48', 431, 0, '', '2019-06-06 13:19:49');
INSERT INTO `access_log` VALUES (30751, '64.79.15597983883229697', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:19:48', 436, 0, '', '2019-06-06 13:19:49');
INSERT INTO `access_log` VALUES (30752, '64.83.15597983933359695', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:19:53', 10, 0, '', '2019-06-06 13:19:53');
INSERT INTO `access_log` VALUES (30753, '64.84.15597983933349709', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:19:53', 11, 0, '', '2019-06-06 13:19:53');
INSERT INTO `access_log` VALUES (30754, '66.56.15597984021068445', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:20:02', 18, 0, '', '2019-06-06 13:20:02');
INSERT INTO `access_log` VALUES (30755, '65.3607.15597984041661903', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:20:04', 19, 0, '', '2019-06-06 13:20:04');
INSERT INTO `access_log` VALUES (30756, '59.77.15597984158779893', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:20:16', 20, 0, '', '2019-06-06 13:20:16');
INSERT INTO `access_log` VALUES (30757, '65.53.15597984163890113', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:20:16', 16, 0, '', '2019-06-06 13:20:16');
INSERT INTO `access_log` VALUES (30758, '65.47.15597984163920135', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:20:16', 8, 0, '', '2019-06-06 13:20:16');
INSERT INTO `access_log` VALUES (30759, '65.52.15597984163860135', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:20:16', 24, 0, '', '2019-06-06 13:20:16');
INSERT INTO `access_log` VALUES (30760, '65.49.15597984194940155', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:20:19', 10, 0, '', '2019-06-06 13:20:20');
INSERT INTO `access_log` VALUES (30761, '65.50.15597984194970129', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:20:19', 9, 0, '', '2019-06-06 13:20:20');
INSERT INTO `access_log` VALUES (30762, '65.46.15597984195050139', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '183.134.103.169', '2019-06-06 13:20:20', 9, 0, '', '2019-06-06 13:20:20');
INSERT INTO `access_log` VALUES (30763, '59.76.15597984204479893', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:20:20', 17, 2001001000, '服务端发生异常', '2019-06-06 13:20:20');
INSERT INTO `access_log` VALUES (30764, '59.71.15597984241569907', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:20:24', 11, 0, '', '2019-06-06 13:20:24');
INSERT INTO `access_log` VALUES (30765, '59.72.15597984255549901', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:20:26', 11, 0, '', '2019-06-06 13:20:26');
INSERT INTO `access_log` VALUES (30766, '59.75.15597984274199903', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:20:27', 8, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-06 13:20:27');
INSERT INTO `access_log` VALUES (30767, '59.74.15597984300369899', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:20:30', 10, 0, '', '2019-06-06 13:20:30');
INSERT INTO `access_log` VALUES (30768, '64.81.15597984354109701', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:20:35', 9, 0, '', '2019-06-06 13:20:35');
INSERT INTO `access_log` VALUES (30769, '64.80.15597984354099701', 27, 2, 'product-application', '/product-api/admins/spu/list', 'ids=29,32,36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:20:35', 10, 0, '', '2019-06-06 13:20:35');
INSERT INTO `access_log` VALUES (30770, '64.82.15597984596699715', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:21:00', 10, 0, '', '2019-06-06 13:21:00');
INSERT INTO `access_log` VALUES (30771, '65.51.15597984612530141', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:21:01', 19, 0, '', '2019-06-06 13:21:01');
INSERT INTO `access_log` VALUES (30772, '65.53.15597984650880115', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:21:05', 8, 0, '', '2019-06-06 13:21:05');
INSERT INTO `access_log` VALUES (30773, '65.52.15597984664250137', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:21:06', 9, 0, '', '2019-06-06 13:21:06');
INSERT INTO `access_log` VALUES (30774, '65.47.15597984688810137', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:21:09', 235, 0, '', '2019-06-06 13:21:09');
INSERT INTO `access_log` VALUES (30775, '65.46.15597984708750141', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:21:11', 9, 0, '', '2019-06-06 13:21:11');
INSERT INTO `access_log` VALUES (30776, '65.50.15597984713630131', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:21:11', 10, 0, '', '2019-06-06 13:21:11');
INSERT INTO `access_log` VALUES (30777, '65.45.15597984715500161', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:21:12', 18, 0, '', '2019-06-06 13:21:12');
INSERT INTO `access_log` VALUES (30778, '59.77.15597984717029895', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:21:12', 12, 0, '', '2019-06-06 13:21:12');
INSERT INTO `access_log` VALUES (30779, '59.78.15597984718499907', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:21:12', 16, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-06 13:21:12');
INSERT INTO `access_log` VALUES (30780, '59.76.15597984719999895', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:21:12', 11, 0, '', '2019-06-06 13:21:12');
INSERT INTO `access_log` VALUES (30781, '59.71.15597984721709909', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:21:12', 10, 0, '', '2019-06-06 13:21:12');
INSERT INTO `access_log` VALUES (30782, '59.72.15597984723319903', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:21:12', 25, 2001001000, '服务端发生异常', '2019-06-06 13:21:12');
INSERT INTO `access_log` VALUES (30783, '59.75.15597984724989905', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.112.199', '2019-06-06 13:21:12', 11, 0, '', '2019-06-06 13:21:13');
INSERT INTO `access_log` VALUES (30784, '65.49.15597992998950169', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.168.134.65', '2019-06-06 13:35:00', 1, 1002001015, '账号未登陆', '2019-06-06 13:35:00');
INSERT INTO `access_log` VALUES (30785, '65.47.15597992998960149', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.168.134.65', '2019-06-06 13:35:00', 1, 1002001015, '账号未登陆', '2019-06-06 13:35:00');
INSERT INTO `access_log` VALUES (30786, '65.46.15597992998970153', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.168.134.65', '2019-06-06 13:35:00', 1, 1002001015, '账号未登陆', '2019-06-06 13:35:00');
INSERT INTO `access_log` VALUES (30787, '65.50.15597993018980143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.168.134.65', '2019-06-06 13:35:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 13:35:02');
INSERT INTO `access_log` VALUES (30788, '65.45.15597993051500173', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.168.134.65', '2019-06-06 13:35:05', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 13:35:05');
INSERT INTO `access_log` VALUES (30789, '65.54.15597993088130113', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.168.134.65', '2019-06-06 13:35:09', 55, 0, '', '2019-06-06 13:35:09');
INSERT INTO `access_log` VALUES (30790, '65.51.15597993090680155', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.168.134.65', '2019-06-06 13:35:09', 16, 0, '', '2019-06-06 13:35:09');
INSERT INTO `access_log` VALUES (30791, '65.52.15597993090710151', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.168.134.65', '2019-06-06 13:35:09', 16, 0, '', '2019-06-06 13:35:09');
INSERT INTO `access_log` VALUES (30792, '65.53.15597993090690129', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.168.134.65', '2019-06-06 13:35:09', 17, 0, '', '2019-06-06 13:35:09');
INSERT INTO `access_log` VALUES (30793, '64.79.15597993140709711', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.168.134.65', '2019-06-06 13:35:14', 10, 0, '', '2019-06-06 13:35:14');
INSERT INTO `access_log` VALUES (30794, '64.78.15597993140709723', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.168.134.65', '2019-06-06 13:35:14', 12, 0, '', '2019-06-06 13:35:14');
INSERT INTO `access_log` VALUES (30795, '66.51.15597993163338465', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.168.134.65', '2019-06-06 13:35:16', 129, 0, '', '2019-06-06 13:35:16');
INSERT INTO `access_log` VALUES (30796, '59.78.15597994448479921', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.168.134.65', '2019-06-06 13:37:25', 3, 0, '', '2019-06-06 13:37:25');
INSERT INTO `access_log` VALUES (30797, '59.76.15597994448499909', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.168.134.65', '2019-06-06 13:37:25', 13, 2001001000, '服务端发生异常', '2019-06-06 13:37:25');
INSERT INTO `access_log` VALUES (30798, '59.72.15597994541099917', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.168.134.65', '2019-06-06 13:37:34', 4, 0, '', '2019-06-06 13:37:34');
INSERT INTO `access_log` VALUES (30799, '59.75.15597994541099919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.168.134.65', '2019-06-06 13:37:34', 11, 2001001000, '服务端发生异常', '2019-06-06 13:37:34');
INSERT INTO `access_log` VALUES (30800, '59.74.15597994628809915', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.168.134.65', '2019-06-06 13:37:43', 3, 0, '', '2019-06-06 13:37:43');
INSERT INTO `access_log` VALUES (30801, '59.80.15597994628819909', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.168.134.65', '2019-06-06 13:37:43', 13, 2001001000, '服务端发生异常', '2019-06-06 13:37:43');
INSERT INTO `access_log` VALUES (30802, '64.82.15597994655939729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.168.134.65', '2019-06-06 13:37:46', 3, 0, '', '2019-06-06 13:37:46');
INSERT INTO `access_log` VALUES (30803, '64.76.15597994656919705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.168.134.65', '2019-06-06 13:37:46', 2, 0, '', '2019-06-06 13:37:46');
INSERT INTO `access_log` VALUES (30804, '64.83.15597994675699711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.168.134.65', '2019-06-06 13:37:48', 2, 0, '', '2019-06-06 13:37:48');
INSERT INTO `access_log` VALUES (30805, '64.84.15597994683539725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.168.134.65', '2019-06-06 13:37:48', 2, 0, '', '2019-06-06 13:37:48');
INSERT INTO `access_log` VALUES (30806, '64.85.15597994739219739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.168.134.65', '2019-06-06 13:37:54', 2, 0, '', '2019-06-06 13:37:54');
INSERT INTO `access_log` VALUES (30807, '64.80.15597994740449717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.168.134.65', '2019-06-06 13:37:54', 2, 0, '', '2019-06-06 13:37:54');
INSERT INTO `access_log` VALUES (30808, '66.49.15597994846238477', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=无所谓&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.168.134.65', '2019-06-06 13:38:05', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空', '2019-06-06 13:38:05');
INSERT INTO `access_log` VALUES (30809, '65.46.15597999444430163', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '119.137.55.198', '2019-06-06 13:45:44', 0, 1002001015, '账号未登陆', '2019-06-06 13:45:44');
INSERT INTO `access_log` VALUES (30810, '65.45.15597999444450183', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '119.137.55.198', '2019-06-06 13:45:44', 1, 1002001015, '账号未登陆', '2019-06-06 13:45:44');
INSERT INTO `access_log` VALUES (30811, '65.50.15597999444450153', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '119.137.55.198', '2019-06-06 13:45:44', 1, 1002001015, '账号未登陆', '2019-06-06 13:45:44');
INSERT INTO `access_log` VALUES (30812, '65.54.15597999480710123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '119.137.55.198', '2019-06-06 13:45:48', 60, 0, '', '2019-06-06 13:45:48');
INSERT INTO `access_log` VALUES (30813, '65.3607.15597999483481929', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '119.137.55.198', '2019-06-06 13:45:48', 10, 0, '', '2019-06-06 13:45:48');
INSERT INTO `access_log` VALUES (30814, '65.53.15597999483520139', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '119.137.55.198', '2019-06-06 13:45:48', 9, 0, '', '2019-06-06 13:45:48');
INSERT INTO `access_log` VALUES (30815, '65.51.15597999483540165', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '119.137.55.198', '2019-06-06 13:45:48', 9, 0, '', '2019-06-06 13:45:48');
INSERT INTO `access_log` VALUES (30816, '62.87.15597999584949757', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '119.137.55.198', '2019-06-06 13:45:58', 13, 0, '', '2019-06-06 13:45:59');
INSERT INTO `access_log` VALUES (30817, '62.81.15597999612389745', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '119.137.55.198', '2019-06-06 13:46:01', 16, 0, '', '2019-06-06 13:46:01');
INSERT INTO `access_log` VALUES (30818, '64.76.15597999699709713', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '119.137.55.198', '2019-06-06 13:46:10', 224, 0, '', '2019-06-06 13:46:10');
INSERT INTO `access_log` VALUES (30819, '64.82.15597999699689737', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '119.137.55.198', '2019-06-06 13:46:10', 227, 0, '', '2019-06-06 13:46:10');
INSERT INTO `access_log` VALUES (30820, '59.71.15597999832369931', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '119.137.55.198', '2019-06-06 13:46:23', 11, 0, '', '2019-06-06 13:46:23');
INSERT INTO `access_log` VALUES (30821, '65.50.15597999981560155', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '119.137.55.198', '2019-06-06 13:46:38', 169, 0, '', '2019-06-06 13:46:38');
INSERT INTO `access_log` VALUES (30822, '59.80.15598000096709917', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '119.137.55.198', '2019-06-06 13:46:50', 9, 0, '', '2019-06-06 13:46:50');
INSERT INTO `access_log` VALUES (30823, '65.54.15598008709290139', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '59.42.239.47', '2019-06-06 14:01:11', 1, 1002001015, '账号未登陆', '2019-06-06 14:01:11');
INSERT INTO `access_log` VALUES (30824, '65.51.15598008709320179', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '59.42.239.47', '2019-06-06 14:01:11', 1, 1002001015, '账号未登陆', '2019-06-06 14:01:11');
INSERT INTO `access_log` VALUES (30825, '65.49.15598008709400195', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '59.42.239.47', '2019-06-06 14:01:11', 1, 1002001015, '账号未登陆', '2019-06-06 14:01:11');
INSERT INTO `access_log` VALUES (30826, '65.47.15598008761360177', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '59.42.239.47', '2019-06-06 14:01:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 14:01:16');
INSERT INTO `access_log` VALUES (30827, '59.74.15598010723479937', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '14.145.232.239', '2019-06-06 14:04:32', 4, 0, '', '2019-06-06 14:04:32');
INSERT INTO `access_log` VALUES (30828, '59.73.15598010723479943', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '14.145.232.239', '2019-06-06 14:04:32', 12, 2001001000, '服务端发生异常', '2019-06-06 14:04:32');
INSERT INTO `access_log` VALUES (30829, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=te&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '14.145.232.239', '2019-06-06 14:04:40', 14, 0, '', '2019-06-06 14:04:40');
INSERT INTO `access_log` VALUES (30830, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=te', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '14.145.232.239', '2019-06-06 14:04:40', 6, 0, '', '2019-06-06 14:04:40');
INSERT INTO `access_log` VALUES (30831, '59.78.15598010879109945', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '14.145.232.239', '2019-06-06 14:04:48', 3, 0, '', '2019-06-06 14:04:48');
INSERT INTO `access_log` VALUES (30832, '59.77.15598010879109933', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '14.145.232.239', '2019-06-06 14:04:48', 13, 2001001000, '服务端发生异常', '2019-06-06 14:04:48');
INSERT INTO `access_log` VALUES (30833, '64.81.15598010921289739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '14.145.232.239', '2019-06-06 14:04:52', 3, 0, '', '2019-06-06 14:04:52');
INSERT INTO `access_log` VALUES (30834, '64.79.15598010922589737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '14.145.232.239', '2019-06-06 14:04:52', 2, 0, '', '2019-06-06 14:04:52');
INSERT INTO `access_log` VALUES (30835, '64.78.15598010934309749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '14.145.232.239', '2019-06-06 14:04:53', 2, 0, '', '2019-06-06 14:04:53');
INSERT INTO `access_log` VALUES (30836, '64.76.15598010941159729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '14.145.232.239', '2019-06-06 14:04:54', 712, 0, '', '2019-06-06 14:04:55');
INSERT INTO `access_log` VALUES (30837, '59.79.15598011889559943', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:06:29', 2, 0, '', '2019-06-06 14:06:29');
INSERT INTO `access_log` VALUES (30838, '59.78.15598011889629947', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:06:29', 12, 2001001000, '服务端发生异常', '2019-06-06 14:06:29');
INSERT INTO `access_log` VALUES (30839, '64.81.15598011924329741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:06:32', 179, 0, '', '2019-06-06 14:06:33');
INSERT INTO `access_log` VALUES (30840, '64.79.15598011927849739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:06:33', 2, 0, '', '2019-06-06 14:06:33');
INSERT INTO `access_log` VALUES (30841, '64.78.15598011941929751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:06:34', 2, 0, '', '2019-06-06 14:06:34');
INSERT INTO `access_log` VALUES (30842, '64.82.15598011959529755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:06:36', 2, 0, '', '2019-06-06 14:06:36');
INSERT INTO `access_log` VALUES (30843, '59.71.15598012138649949', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:06:54', 2, 0, '', '2019-06-06 14:06:54');
INSERT INTO `access_log` VALUES (30844, '59.75.15598012138779945', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:06:54', 13, 2001001000, '服务端发生异常', '2019-06-06 14:06:54');
INSERT INTO `access_log` VALUES (30845, '64.84.15598012208289751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:01', 2, 0, '', '2019-06-06 14:07:01');
INSERT INTO `access_log` VALUES (30846, '64.77.15598012209729751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:01', 2, 0, '', '2019-06-06 14:07:01');
INSERT INTO `access_log` VALUES (30847, '64.85.15598012231929765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:03', 162, 0, '', '2019-06-06 14:07:03');
INSERT INTO `access_log` VALUES (30848, '64.80.15598012243729743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:04', 2, 0, '', '2019-06-06 14:07:04');
INSERT INTO `access_log` VALUES (30849, '64.79.15598012264329741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:06', 2, 0, '', '2019-06-06 14:07:06');
INSERT INTO `access_log` VALUES (30850, '64.78.15598012297649753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:10', 2, 0, '', '2019-06-06 14:07:10');
INSERT INTO `access_log` VALUES (30851, '64.82.15598012458449757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:26', 3, 0, '', '2019-06-06 14:07:26');
INSERT INTO `access_log` VALUES (30852, '64.83.15598012459939739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:26', 2, 0, '', '2019-06-06 14:07:26');
INSERT INTO `access_log` VALUES (30853, '59.74.15598012522129941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:32', 3, 0, '', '2019-06-06 14:07:32');
INSERT INTO `access_log` VALUES (30854, '59.73.15598012522259947', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:32', 12, 2001001000, '服务端发生异常', '2019-06-06 14:07:32');
INSERT INTO `access_log` VALUES (30855, '64.77.15598012565579753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:37', 2, 0, '', '2019-06-06 14:07:37');
INSERT INTO `access_log` VALUES (30856, '64.85.15598012567499767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:37', 2, 0, '', '2019-06-06 14:07:37');
INSERT INTO `access_log` VALUES (30857, '59.79.15598012595869945', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; COL-AL10 Build/HUAWEICOL-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/7462 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '14.25.169.126', '2019-06-06 14:07:40', 3, 0, '', '2019-06-06 14:07:40');
INSERT INTO `access_log` VALUES (30858, '59.77.15598012595899937', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; COL-AL10 Build/HUAWEICOL-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/7462 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '14.25.169.126', '2019-06-06 14:07:40', 13, 2001001000, '服务端发生异常', '2019-06-06 14:07:40');
INSERT INTO `access_log` VALUES (30859, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=手机&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:43', 7, 0, '', '2019-06-06 14:07:43');
INSERT INTO `access_log` VALUES (30860, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=手机', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:44', 13, 0, '', '2019-06-06 14:07:44');
INSERT INTO `access_log` VALUES (30861, '64.80.15598012693579745', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:07:49', 7, 0, '', '2019-06-06 14:07:49');
INSERT INTO `access_log` VALUES (30862, '65.45.15598012699080199', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; COL-AL10 Build/HUAWEICOL-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/7462 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '14.25.169.126', '2019-06-06 14:07:50', 0, 1002001015, '账号未登陆', '2019-06-06 14:07:50');
INSERT INTO `access_log` VALUES (30863, '65.54.15598012699180147', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; COL-AL10 Build/HUAWEICOL-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/7462 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '14.25.169.126', '2019-06-06 14:07:50', 0, 1002001015, '账号未登陆', '2019-06-06 14:07:50');
INSERT INTO `access_log` VALUES (30864, '65.50.15598012699380177', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; COL-AL10 Build/HUAWEICOL-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/7462 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '14.25.169.126', '2019-06-06 14:07:50', 0, 1002001015, '账号未登陆', '2019-06-06 14:07:50');
INSERT INTO `access_log` VALUES (30865, '65.52.15598012726790179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; COL-AL10 Build/HUAWEICOL-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/7462 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '14.25.169.126', '2019-06-06 14:07:53', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 14:07:53');
INSERT INTO `access_log` VALUES (30866, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:08:11', 7, 0, '', '2019-06-06 14:08:11');
INSERT INTO `access_log` VALUES (30867, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:08:11', 10, 0, '', '2019-06-06 14:08:11');
INSERT INTO `access_log` VALUES (30868, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:08:18', 5, 0, '', '2019-06-06 14:08:18');
INSERT INTO `access_log` VALUES (30869, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:08:19', 11, 0, '', '2019-06-06 14:08:19');
INSERT INTO `access_log` VALUES (30870, '64.76.15598013073389735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:08:27', 20, 0, '', '2019-06-06 14:08:27');
INSERT INTO `access_log` VALUES (30871, '64.82.15598013075589759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:08:28', 2, 0, '', '2019-06-06 14:08:28');
INSERT INTO `access_log` VALUES (30872, '59.80.15598013085589937', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:08:29', 2, 0, '', '2019-06-06 14:08:29');
INSERT INTO `access_log` VALUES (30873, '59.72.15598013085539945', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:08:29', 13, 2001001000, '服务端发生异常', '2019-06-06 14:08:29');
INSERT INTO `access_log` VALUES (30874, '64.83.15598013106529741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:08:31', 260, 0, '', '2019-06-06 14:08:31');
INSERT INTO `access_log` VALUES (30875, '64.84.15598013110849755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:08:31', 2, 0, '', '2019-06-06 14:08:31');
INSERT INTO `access_log` VALUES (30876, '59.74.15598013113329943', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:08:31', 2, 0, '', '2019-06-06 14:08:31');
INSERT INTO `access_log` VALUES (30877, '59.73.15598013113389949', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043B) Process/tools NetType/4G Language/zh_CN', '58.243.250.34', '2019-06-06 14:08:31', 10, 2001001000, '服务端发生异常', '2019-06-06 14:08:31');
INSERT INTO `access_log` VALUES (30878, '65.45.15598013929990201', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 14:09:53', 1, 1002001015, '账号未登陆', '2019-06-06 14:09:53');
INSERT INTO `access_log` VALUES (30879, '65.52.15598013930010181', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.90.7', '2019-06-06 14:09:53', 0, 1002001015, '账号未登陆', '2019-06-06 14:09:53');
INSERT INTO `access_log` VALUES (30880, '65.51.15598013930050189', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.64.1', '2019-06-06 14:09:53', 0, 1002001015, '账号未登陆', '2019-06-06 14:09:53');
INSERT INTO `access_log` VALUES (30881, '65.3607.15598014060221949', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 14:10:06', 52, 0, '', '2019-06-06 14:10:06');
INSERT INTO `access_log` VALUES (30882, '65.49.15598014063170209', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 14:10:06', 196, 0, '', '2019-06-06 14:10:07');
INSERT INTO `access_log` VALUES (30883, '65.46.15598014063250187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.90.7', '2019-06-06 14:10:06', 191, 0, '', '2019-06-06 14:10:07');
INSERT INTO `access_log` VALUES (30884, '65.47.15598014063220189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 14:10:06', 195, 0, '', '2019-06-06 14:10:07');
INSERT INTO `access_log` VALUES (30885, '62.81.15598014152799769', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 14:10:15', 14, 0, '', '2019-06-06 14:10:15');
INSERT INTO `access_log` VALUES (30886, '62.82.15598014207989793', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 14:10:21', 13, 0, '', '2019-06-06 14:10:21');
INSERT INTO `access_log` VALUES (30887, '64.83.15598014229169743', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.90.7', '2019-06-06 14:10:23', 10, 0, '', '2019-06-06 14:10:23');
INSERT INTO `access_log` VALUES (30888, '64.84.15598014229179757', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 14:10:23', 12, 0, '', '2019-06-06 14:10:23');
INSERT INTO `access_log` VALUES (30889, '59.74.15598014319559945', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 14:10:32', 11, 0, '', '2019-06-06 14:10:32');
INSERT INTO `access_log` VALUES (30890, '65.52.15598014348650183', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 14:10:35', 11, 0, '', '2019-06-06 14:10:35');
INSERT INTO `access_log` VALUES (30891, '65.51.15598014356880191', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 14:10:36', 9, 0, '', '2019-06-06 14:10:36');
INSERT INTO `access_log` VALUES (30892, '65.45.15598014363950203', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 14:10:36', 27, 0, '', '2019-06-06 14:10:36');
INSERT INTO `access_log` VALUES (30893, '62.84.15598014397189781', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.155.89.112', '2019-06-06 14:10:40', 14, 0, '', '2019-06-06 14:10:40');
INSERT INTO `access_log` VALUES (30894, '59.77.15598014661919941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.66.66', '2019-06-06 14:11:06', 2, 0, '', '2019-06-06 14:11:06');
INSERT INTO `access_log` VALUES (30895, '59.76.15598014661919941', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.66.66', '2019-06-06 14:11:06', 12, 2001001000, '服务端发生异常', '2019-06-06 14:11:06');
INSERT INTO `access_log` VALUES (30896, '64.81.15598014693479749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.66.66', '2019-06-06 14:11:09', 2, 0, '', '2019-06-06 14:11:09');
INSERT INTO `access_log` VALUES (30897, '64.79.15598014694819747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.66.66', '2019-06-06 14:11:09', 1, 0, '', '2019-06-06 14:11:09');
INSERT INTO `access_log` VALUES (30898, '64.78.15598014760589759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.66.66', '2019-06-06 14:11:16', 2, 0, '', '2019-06-06 14:11:16');
INSERT INTO `access_log` VALUES (30899, '64.76.15598014763269739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.66.66', '2019-06-06 14:11:16', 2, 0, '', '2019-06-06 14:11:16');
INSERT INTO `access_log` VALUES (30900, '64.82.15598014768079763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.7.66.66', '2019-06-06 14:11:17', 2, 0, '', '2019-06-06 14:11:17');
INSERT INTO `access_log` VALUES (30901, '59.75.15598014804979951', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:11:20', 3, 0, '', '2019-06-06 14:11:21');
INSERT INTO `access_log` VALUES (30902, '59.80.15598014804979941', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:11:20', 12, 2001001000, '服务端发生异常', '2019-06-06 14:11:21');
INSERT INTO `access_log` VALUES (30903, '64.83.15598014828189745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:11:23', 2, 0, '', '2019-06-06 14:11:23');
INSERT INTO `access_log` VALUES (30904, '64.77.15598014829269759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:11:23', 2, 0, '', '2019-06-06 14:11:23');
INSERT INTO `access_log` VALUES (30905, '64.85.15598014840589773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:11:24', 2, 0, '', '2019-06-06 14:11:24');
INSERT INTO `access_log` VALUES (30906, '64.80.15598014843819751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:11:24', 2, 0, '', '2019-06-06 14:11:24');
INSERT INTO `access_log` VALUES (30907, '64.81.15598014846729751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:11:25', 120, 0, '', '2019-06-06 14:11:25');
INSERT INTO `access_log` VALUES (30908, '66.56.15598015059438487', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18123920907&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:11:46', 24, 1001003000, '验证码不存在', '2019-06-06 14:11:46');
INSERT INTO `access_log` VALUES (30909, '66.48.15598015098828497', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18123920907', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:11:50', 367, 0, '', '2019-06-06 14:11:50');
INSERT INTO `access_log` VALUES (30910, '66.55.15598015128308503', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18123920907&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:11:53', 186, 0, '', '2019-06-06 14:11:53');
INSERT INTO `access_log` VALUES (30911, '64.82.15598015222829765', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:02', 6, 0, '', '2019-06-06 14:12:02');
INSERT INTO `access_log` VALUES (30912, '64.83.15598015224389747', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:02', 4, 0, '', '2019-06-06 14:12:02');
INSERT INTO `access_log` VALUES (30913, '64.85.15598015258269775', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:06', 5, 0, '', '2019-06-06 14:12:06');
INSERT INTO `access_log` VALUES (30914, '64.80.15598015259489753', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:06', 5, 0, '', '2019-06-06 14:12:06');
INSERT INTO `access_log` VALUES (30915, '64.81.15598015288859753', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:09', 6, 0, '', '2019-06-06 14:12:09');
INSERT INTO `access_log` VALUES (30916, '64.79.15598015290479751', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:09', 4, 0, '', '2019-06-06 14:12:09');
INSERT INTO `access_log` VALUES (30917, '59.77.15598015309499943', 110, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:11', 6, 0, '', '2019-06-06 14:12:11');
INSERT INTO `access_log` VALUES (30918, '59.76.15598015309509943', 110, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:11', 17, 2001001000, '服务端发生异常', '2019-06-06 14:12:11');
INSERT INTO `access_log` VALUES (30919, '64.78.15598015338989763', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:14', 5, 0, '', '2019-06-06 14:12:14');
INSERT INTO `access_log` VALUES (30920, '64.76.15598015340149743', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:14', 4, 0, '', '2019-06-06 14:12:14');
INSERT INTO `access_log` VALUES (30921, '64.82.15598015350449767', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:15', 4, 0, '', '2019-06-06 14:12:15');
INSERT INTO `access_log` VALUES (30922, 'N/A', 110, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:15', 16, 0, '', '2019-06-06 14:12:15');
INSERT INTO `access_log` VALUES (30923, 'N/A', 110, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:17', 13, 0, '', '2019-06-06 14:12:17');
INSERT INTO `access_log` VALUES (30924, '64.83.15598015379339749', 110, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:18', 10, 0, '', '2019-06-06 14:12:18');
INSERT INTO `access_log` VALUES (30925, '66.57.15598015547338497', 110, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:35', 6, 0, '', '2019-06-06 14:12:35');
INSERT INTO `access_log` VALUES (30926, '64.80.15598015620229755', 110, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:42', 10, 0, '', '2019-06-06 14:12:42');
INSERT INTO `access_log` VALUES (30927, '64.81.15598015624699755', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:42', 5, 0, '', '2019-06-06 14:12:42');
INSERT INTO `access_log` VALUES (30928, 'N/A', 110, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:42', 10, 0, '', '2019-06-06 14:12:42');
INSERT INTO `access_log` VALUES (30929, '64.79.15598015634379753', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:43', 4, 0, '', '2019-06-06 14:12:43');
INSERT INTO `access_log` VALUES (30930, '64.78.15598015635689765', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:44', 4, 0, '', '2019-06-06 14:12:44');
INSERT INTO `access_log` VALUES (30931, '64.82.15598015647809769', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:45', 4, 0, '', '2019-06-06 14:12:45');
INSERT INTO `access_log` VALUES (30932, '64.83.15598015650369751', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:45', 4, 0, '', '2019-06-06 14:12:45');
INSERT INTO `access_log` VALUES (30933, '64.77.15598015671709765', 110, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:47', 5, 0, '', '2019-06-06 14:12:47');
INSERT INTO `access_log` VALUES (30934, 'N/A', 110, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.66', '2019-06-06 14:12:47', 10, 0, '', '2019-06-06 14:12:47');
INSERT INTO `access_log` VALUES (30935, '59.74.15598017444789951', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.207.195', '2019-06-06 14:15:44', 4, 0, '', '2019-06-06 14:15:44');
INSERT INTO `access_log` VALUES (30936, '59.73.15598017444799957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.207.195', '2019-06-06 14:15:44', 13, 2001001000, '服务端发生异常', '2019-06-06 14:15:44');
INSERT INTO `access_log` VALUES (30937, '65.53.15598017496960169', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.207.195', '2019-06-06 14:15:50', 1, 1002001015, '账号未登陆', '2019-06-06 14:15:50');
INSERT INTO `access_log` VALUES (30938, '65.45.15598017496960209', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.207.195', '2019-06-06 14:15:50', 0, 1002001015, '账号未登陆', '2019-06-06 14:15:50');
INSERT INTO `access_log` VALUES (30939, '65.49.15598017497030217', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.207.195', '2019-06-06 14:15:50', 0, 1002001015, '账号未登陆', '2019-06-06 14:15:50');
INSERT INTO `access_log` VALUES (30940, '59.77.15598017719439947', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:12', 2, 0, '', '2019-06-06 14:16:12');
INSERT INTO `access_log` VALUES (30941, '59.76.15598017719449947', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:12', 19, 2001001000, '服务端发生异常', '2019-06-06 14:16:12');
INSERT INTO `access_log` VALUES (30942, '64.78.15598017771079769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:17', 3, 0, '', '2019-06-06 14:16:17');
INSERT INTO `access_log` VALUES (30943, '64.76.15598017772289749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:17', 2, 0, '', '2019-06-06 14:16:17');
INSERT INTO `access_log` VALUES (30944, '64.82.15598017795089773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:20', 2, 0, '', '2019-06-06 14:16:20');
INSERT INTO `access_log` VALUES (30945, '64.83.15598017815129755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:22', 2, 0, '', '2019-06-06 14:16:22');
INSERT INTO `access_log` VALUES (30946, '64.77.15598017819999769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:22', 2, 0, '', '2019-06-06 14:16:22');
INSERT INTO `access_log` VALUES (30947, '64.85.15598017881119783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:28', 1, 0, '', '2019-06-06 14:16:28');
INSERT INTO `access_log` VALUES (30948, '64.80.15598017882059761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:28', 2, 0, '', '2019-06-06 14:16:28');
INSERT INTO `access_log` VALUES (30949, '59.72.15598017963289955', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:36', 3, 0, '', '2019-06-06 14:16:36');
INSERT INTO `access_log` VALUES (30950, '59.80.15598017963289947', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:36', 13, 2001001000, '服务端发生异常', '2019-06-06 14:16:36');
INSERT INTO `access_log` VALUES (30951, '64.79.15598018002119759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:40', 2, 0, '', '2019-06-06 14:16:40');
INSERT INTO `access_log` VALUES (30952, '64.78.15598018003009771', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:40', 2, 0, '', '2019-06-06 14:16:40');
INSERT INTO `access_log` VALUES (30953, '64.76.15598018014379751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:41', 2, 0, '', '2019-06-06 14:16:41');
INSERT INTO `access_log` VALUES (30954, '64.82.15598018019269775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:42', 1, 0, '', '2019-06-06 14:16:42');
INSERT INTO `access_log` VALUES (30955, '59.74.15598018028639953', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:43', 3, 0, '', '2019-06-06 14:16:43');
INSERT INTO `access_log` VALUES (30956, '59.73.15598018028639959', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:43', 13, 2001001000, '服务端发生异常', '2019-06-06 14:16:43');
INSERT INTO `access_log` VALUES (30957, '64.84.15598018043179771', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:44', 2, 0, '', '2019-06-06 14:16:44');
INSERT INTO `access_log` VALUES (30958, '64.83.15598018043969757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:44', 2, 0, '', '2019-06-06 14:16:44');
INSERT INTO `access_log` VALUES (30959, '59.79.15598018057449957', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:46', 3, 0, '', '2019-06-06 14:16:46');
INSERT INTO `access_log` VALUES (30960, '59.78.15598018057449961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.207.195', '2019-06-06 14:16:46', 19, 2001001000, '服务端发生异常', '2019-06-06 14:16:46');
INSERT INTO `access_log` VALUES (30961, '65.51.15598018307320197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.207.195', '2019-06-06 14:17:11', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 14:17:11');
INSERT INTO `access_log` VALUES (30962, '65.45.15598018478860211', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.207.195', '2019-06-06 14:17:28', 82, 0, '', '2019-06-06 14:17:28');
INSERT INTO `access_log` VALUES (30963, '65.49.15598018481840219', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.207.195', '2019-06-06 14:17:28', 11, 0, '', '2019-06-06 14:17:28');
INSERT INTO `access_log` VALUES (30964, '65.3607.15598018481841959', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.207.195', '2019-06-06 14:17:28', 10, 0, '', '2019-06-06 14:17:28');
INSERT INTO `access_log` VALUES (30965, '65.47.15598018482060199', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.207.195', '2019-06-06 14:17:28', 9, 0, '', '2019-06-06 14:17:28');
INSERT INTO `access_log` VALUES (30966, '66.56.15598020319948495', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.207.195', '2019-06-06 14:20:32', 21, 0, '', '2019-06-06 14:20:32');
INSERT INTO `access_log` VALUES (30967, '65.46.15598020797670199', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.144.97.222', '2019-06-06 14:21:20', 0, 1002001015, '账号未登陆', '2019-06-06 14:21:20');
INSERT INTO `access_log` VALUES (30968, '65.54.15598020797760163', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.144.97.222', '2019-06-06 14:21:20', 0, 1002001015, '账号未登陆', '2019-06-06 14:21:20');
INSERT INTO `access_log` VALUES (30969, '65.50.15598020797870193', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.144.97.222', '2019-06-06 14:21:20', 0, 1002001015, '账号未登陆', '2019-06-06 14:21:20');
INSERT INTO `access_log` VALUES (30970, '65.49.15598020892840223', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.144.97.222', '2019-06-06 14:21:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 14:21:29');
INSERT INTO `access_log` VALUES (30971, '65.52.15598020930780197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.144.97.222', '2019-06-06 14:21:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 14:21:33');
INSERT INTO `access_log` VALUES (30972, '65.51.15598020951290203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.144.97.222', '2019-06-06 14:21:35', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 14:21:35');
INSERT INTO `access_log` VALUES (30973, '65.47.15598022634540205', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:24:23', 0, 1002001015, '账号未登陆', '2019-06-06 14:24:23');
INSERT INTO `access_log` VALUES (30974, '65.49.15598022634550227', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:24:23', 0, 1002001015, '账号未登陆', '2019-06-06 14:24:23');
INSERT INTO `access_log` VALUES (30975, '65.52.15598022634550203', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:24:23', 0, 1002001015, '账号未登陆', '2019-06-06 14:24:23');
INSERT INTO `access_log` VALUES (30976, '65.51.15598022693870209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:24:29', 895, 0, '', '2019-06-06 14:24:30');
INSERT INTO `access_log` VALUES (30977, '65.45.15598022707920221', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:24:31', 43, 0, '', '2019-06-06 14:24:31');
INSERT INTO `access_log` VALUES (30978, '65.54.15598022707960169', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:24:31', 39, 0, '', '2019-06-06 14:24:31');
INSERT INTO `access_log` VALUES (30979, '65.3607.15598022707951969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:24:31', 41, 0, '', '2019-06-06 14:24:31');
INSERT INTO `access_log` VALUES (30980, '62.82.15598022754909805', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:24:35', 13, 0, '', '2019-06-06 14:24:36');
INSERT INTO `access_log` VALUES (30981, '62.86.15598022780749789', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:24:38', 13, 0, '', '2019-06-06 14:24:38');
INSERT INTO `access_log` VALUES (30982, '64.81.15598022802549769', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:24:40', 10, 0, '', '2019-06-06 14:24:40');
INSERT INTO `access_log` VALUES (30983, '64.80.15598022802539769', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:24:40', 12, 0, '', '2019-06-06 14:24:40');
INSERT INTO `access_log` VALUES (30984, '64.78.15598022833279779', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:24:43', 125, 0, '', '2019-06-06 14:24:43');
INSERT INTO `access_log` VALUES (30985, '64.79.15598022833269767', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:24:43', 127, 0, '', '2019-06-06 14:24:43');
INSERT INTO `access_log` VALUES (30986, '64.83.15598023338119765', 27, 2, 'product-application', '/product-api/admins/spu/update_sort', 'id=32&sort=1', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:25:34', 8, 1002002009, NULL, '2019-06-06 14:25:34');
INSERT INTO `access_log` VALUES (30987, '65.49.15598023365330229', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.144.97.222', '2019-06-06 14:25:37', 81, 0, '', '2019-06-06 14:25:37');
INSERT INTO `access_log` VALUES (30988, '65.53.15598023370470183', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.144.97.222', '2019-06-06 14:25:37', 18, 0, '', '2019-06-06 14:25:37');
INSERT INTO `access_log` VALUES (30989, '65.51.15598023370610211', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.144.97.222', '2019-06-06 14:25:37', 9, 0, '', '2019-06-06 14:25:37');
INSERT INTO `access_log` VALUES (30990, '65.54.15598023370620171', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.144.97.222', '2019-06-06 14:25:37', 9, 0, '', '2019-06-06 14:25:37');
INSERT INTO `access_log` VALUES (30991, '65.3607.15598023431291971', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:25:43', 15, 0, '', '2019-06-06 14:25:43');
INSERT INTO `access_log` VALUES (30992, '65.50.15598023442630201', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:25:44', 95, 0, '', '2019-06-06 14:25:44');
INSERT INTO `access_log` VALUES (30993, '62.87.15598023555629795', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.144.97.222', '2019-06-06 14:25:56', 289, 0, '', '2019-06-06 14:25:56');
INSERT INTO `access_log` VALUES (30994, '62.81.15598023590119783', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.144.97.222', '2019-06-06 14:25:59', 16, 0, '', '2019-06-06 14:25:59');
INSERT INTO `access_log` VALUES (30995, '66.55.15598023613148515', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.144.97.222', '2019-06-06 14:26:01', 11, 0, '', '2019-06-06 14:26:01');
INSERT INTO `access_log` VALUES (30996, '65.54.15598024196950173', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:27:00', 9, 0, '', '2019-06-06 14:27:00');
INSERT INTO `access_log` VALUES (30997, '65.46.15598024822860209', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:28:02', 16, 0, '', '2019-06-06 14:28:02');
INSERT INTO `access_log` VALUES (30998, '65.52.15598024828820209', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:28:03', 19, 0, '', '2019-06-06 14:28:03');
INSERT INTO `access_log` VALUES (30999, '64.85.15598024832599795', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:28:03', 11, 0, '', '2019-06-06 14:28:03');
INSERT INTO `access_log` VALUES (31000, '64.77.15598024832589781', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:28:03', 12, 0, '', '2019-06-06 14:28:03');
INSERT INTO `access_log` VALUES (31001, '64.80.15598024834629773', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:28:03', 8, 0, '', '2019-06-06 14:28:03');
INSERT INTO `access_log` VALUES (31002, '64.81.15598024834619773', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:28:03', 10, 0, '', '2019-06-06 14:28:03');
INSERT INTO `access_log` VALUES (31003, '62.87.15598024835879797', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:28:04', 14, 0, '', '2019-06-06 14:28:04');
INSERT INTO `access_log` VALUES (31004, '62.81.15598024840199785', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.40.26.62', '2019-06-06 14:28:04', 12, 0, '', '2019-06-06 14:28:04');
INSERT INTO `access_log` VALUES (31005, '65.46.15598029054550215', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:35:05', 1, 1002001015, '账号未登陆', '2019-06-06 14:35:05');
INSERT INTO `access_log` VALUES (31006, '65.52.15598029054560215', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:35:05', 0, 1002001015, '账号未登陆', '2019-06-06 14:35:05');
INSERT INTO `access_log` VALUES (31007, '65.47.15598029054610217', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:35:05', 0, 1002001015, '账号未登陆', '2019-06-06 14:35:05');
INSERT INTO `access_log` VALUES (31008, '65.51.15598029147430221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:35:15', 207, 0, '', '2019-06-06 14:35:15');
INSERT INTO `access_log` VALUES (31009, '65.54.15598029161420181', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:35:16', 9, 0, '', '2019-06-06 14:35:16');
INSERT INTO `access_log` VALUES (31010, '65.53.15598029161450193', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:35:16', 9, 0, '', '2019-06-06 14:35:16');
INSERT INTO `access_log` VALUES (31011, '65.45.15598029161520233', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:35:16', 9, 0, '', '2019-06-06 14:35:16');
INSERT INTO `access_log` VALUES (31012, '64.79.15598029238369777', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:35:24', 13, 0, '', '2019-06-06 14:35:24');
INSERT INTO `access_log` VALUES (31013, '64.78.15598029238419789', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:35:24', 8, 0, '', '2019-06-06 14:35:24');
INSERT INTO `access_log` VALUES (31014, '64.82.15598029288489793', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:35:29', 9, 0, '', '2019-06-06 14:35:29');
INSERT INTO `access_log` VALUES (31015, '64.76.15598029288489769', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:35:29', 11, 0, '', '2019-06-06 14:35:29');
INSERT INTO `access_log` VALUES (31016, '64.84.15598029350109789', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:35:35', 8, 0, '', '2019-06-06 14:35:35');
INSERT INTO `access_log` VALUES (31017, '64.85.15598029407439803', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:35:41', 9, 0, '', '2019-06-06 14:35:41');
INSERT INTO `access_log` VALUES (31018, '64.77.15598029407439789', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:35:41', 10, 0, '', '2019-06-06 14:35:41');
INSERT INTO `access_log` VALUES (31019, '65.3607.15598033629671989', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:42:43', 4, 0, '', '2019-06-06 14:42:43');
INSERT INTO `access_log` VALUES (31020, '59.74.15598033925269975', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) snap Chromium/74.0.3729.169 Chrome/74.0.3729.169 Safari/537.36', '121.18.115.251', '2019-06-06 14:43:13', 3, 0, '', '2019-06-06 14:43:13');
INSERT INTO `access_log` VALUES (31021, '59.73.15598033926359981', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) snap Chromium/74.0.3729.169 Chrome/74.0.3729.169 Safari/537.36', '121.18.115.251', '2019-06-06 14:43:13', 13, 2001001000, '服务端发生异常', '2019-06-06 14:43:13');
INSERT INTO `access_log` VALUES (31022, '65.45.15598033939430239', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:43:14', 5, 0, '', '2019-06-06 14:43:14');
INSERT INTO `access_log` VALUES (31023, '65.52.15598033984600225', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:43:18', 3, 0, '', '2019-06-06 14:43:18');
INSERT INTO `access_log` VALUES (31024, '65.51.15598034009570231', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:43:21', 3, 0, '', '2019-06-06 14:43:21');
INSERT INTO `access_log` VALUES (31025, '64.79.15598034308929785', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=曜岩灰', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:43:51', 314, 1002002009, NULL, '2019-06-06 14:43:51');
INSERT INTO `access_log` VALUES (31026, '64.82.15598034360749801', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=曜岩灰', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:43:56', 7, 1002002009, NULL, '2019-06-06 14:43:56');
INSERT INTO `access_log` VALUES (31027, '64.76.15598034384229777', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=曜岩灰', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:43:58', 8, 1002002009, NULL, '2019-06-06 14:43:58');
INSERT INTO `access_log` VALUES (31028, '64.79.15598035358069787', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:45:36', 8, 1002002009, NULL, '2019-06-06 14:45:36');
INSERT INTO `access_log` VALUES (31029, '64.82.15598035412529803', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:45:41', 8, 1002002009, NULL, '2019-06-06 14:45:41');
INSERT INTO `access_log` VALUES (31030, '64.84.15598035545169799', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=784&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:45:55', 8, 1002002009, NULL, '2019-06-06 14:45:55');
INSERT INTO `access_log` VALUES (31031, '64.77.15598035657409799', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=783&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:06', 7, 1002002009, NULL, '2019-06-06 14:46:06');
INSERT INTO `access_log` VALUES (31032, '59.77.15598035716419973', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:46:12', 3, 0, '', '2019-06-06 14:46:12');
INSERT INTO `access_log` VALUES (31033, '59.76.15598035716549973', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:46:12', 13, 2001001000, '服务端发生异常', '2019-06-06 14:46:12');
INSERT INTO `access_log` VALUES (31034, '64.85.15598035791819813', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=783&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:19', 7, 1002002009, NULL, '2019-06-06 14:46:19');
INSERT INTO `access_log` VALUES (31035, '64.80.15598035811189791', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=783&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:21', 8, 1002002009, NULL, '2019-06-06 14:46:21');
INSERT INTO `access_log` VALUES (31036, '64.78.15598035813499801', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=783&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:21', 7, 1002002009, NULL, '2019-06-06 14:46:21');
INSERT INTO `access_log` VALUES (31037, '64.79.15598035815389789', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=783&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:22', 8, 1002002009, NULL, '2019-06-06 14:46:22');
INSERT INTO `access_log` VALUES (31038, '64.82.15598035817649805', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=783&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:22', 7, 1002002009, NULL, '2019-06-06 14:46:22');
INSERT INTO `access_log` VALUES (31039, '64.76.15598035819109781', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=783&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:22', 7, 1002002009, NULL, '2019-06-06 14:46:22');
INSERT INTO `access_log` VALUES (31040, '64.84.15598035820999801', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=783&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:22', 6, 1002002009, NULL, '2019-06-06 14:46:22');
INSERT INTO `access_log` VALUES (31041, '64.83.15598035822799787', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=783&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:22', 8, 1002002009, NULL, '2019-06-06 14:46:22');
INSERT INTO `access_log` VALUES (31042, '64.77.15598035824629801', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=783&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:22', 8, 1002002009, NULL, '2019-06-06 14:46:22');
INSERT INTO `access_log` VALUES (31043, '65.54.15598035825760191', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:46:23', 0, 1002001015, '账号未登陆', '2019-06-06 14:46:23');
INSERT INTO `access_log` VALUES (31044, '65.53.15598035825770203', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:46:23', 0, 1002001015, '账号未登陆', '2019-06-06 14:46:23');
INSERT INTO `access_log` VALUES (31045, '65.3607.15598035825791993', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:46:23', 0, 1002001015, '账号未登陆', '2019-06-06 14:46:23');
INSERT INTO `access_log` VALUES (31046, '64.85.15598035826319815', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=783&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:23', 17, 1002002009, NULL, '2019-06-06 14:46:23');
INSERT INTO `access_log` VALUES (31047, '64.81.15598035828069793', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=783&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:23', 8, 1002002009, NULL, '2019-06-06 14:46:23');
INSERT INTO `access_log` VALUES (31048, '64.80.15598035829939793', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=783&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:23', 7, 1002002009, NULL, '2019-06-06 14:46:23');
INSERT INTO `access_log` VALUES (31049, '64.78.15598035831359803', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=一加 OnePlus 7 Pro 手机&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=783&visible=false&picUrls=http://static.shop.iocoder.cn/fc12c20f-f2e8-46aa-a0c9-53c84bbe43c5,http://static.shop.iocoder.cn/b6eba0c1-2cbc-4024-a208-0d8779ae98f1,http://static.shop.iocoder.cn/41b9c178-d2c2-46c3-8382-fe2f5d71389e,http://static.shop.iocoder.cn/1c755308-7439-404e-91fa-1acced024b29&skuStr=[{\"attrs\":[15],\"price\":449900,\"quantity\":99}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:23', 8, 1002002009, NULL, '2019-06-06 14:46:23');
INSERT INTO `access_log` VALUES (31050, '64.79.15598035917439791', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:32', 13, 0, '', '2019-06-06 14:46:32');
INSERT INTO `access_log` VALUES (31051, '64.82.15598035917439807', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:32', 12, 0, '', '2019-06-06 14:46:32');
INSERT INTO `access_log` VALUES (31052, '64.84.15598035958649803', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:36', 11, 0, '', '2019-06-06 14:46:36');
INSERT INTO `access_log` VALUES (31053, '64.83.15598035958789789', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:36', 8, 0, '', '2019-06-06 14:46:36');
INSERT INTO `access_log` VALUES (31054, '59.80.15598035981589973', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:46:38', 3, 0, '', '2019-06-06 14:46:38');
INSERT INTO `access_log` VALUES (31055, '59.72.15598035981519981', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:46:38', 19, 2001001000, '服务端发生异常', '2019-06-06 14:46:38');
INSERT INTO `access_log` VALUES (31056, '64.77.15598036086529803', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:49', 11, 0, '', '2019-06-06 14:46:49');
INSERT INTO `access_log` VALUES (31057, '64.85.15598036086599817', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:46:49', 8, 0, '', '2019-06-06 14:46:49');
INSERT INTO `access_log` VALUES (31058, '65.45.15598036120350243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:46:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 14:46:52');
INSERT INTO `access_log` VALUES (31059, '65.51.15598036164480235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:46:56', 286, 0, '', '2019-06-06 14:46:57');
INSERT INTO `access_log` VALUES (31060, '65.46.15598036170050227', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:46:57', 9, 0, '', '2019-06-06 14:46:57');
INSERT INTO `access_log` VALUES (31061, '65.49.15598036170090251', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:46:57', 8, 0, '', '2019-06-06 14:46:57');
INSERT INTO `access_log` VALUES (31062, '65.54.15598036170100193', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:46:57', 8, 0, '', '2019-06-06 14:46:57');
INSERT INTO `access_log` VALUES (31063, '64.78.15598036254849805', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:05', 11, 0, '', '2019-06-06 14:47:05');
INSERT INTO `access_log` VALUES (31064, '64.80.15598036254849795', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=39', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:05', 15, 0, '', '2019-06-06 14:47:05');
INSERT INTO `access_log` VALUES (31065, '64.79.15598036255139793', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:06', 9, 0, '', '2019-06-06 14:47:06');
INSERT INTO `access_log` VALUES (31066, '65.3607.15598036303051995', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:10', 3, 0, '', '2019-06-06 14:47:10');
INSERT INTO `access_log` VALUES (31067, '65.50.15598036329940225', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:13', 4, 0, '', '2019-06-06 14:47:13');
INSERT INTO `access_log` VALUES (31068, '65.47.15598036355650231', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:16', 3, 0, '', '2019-06-06 14:47:16');
INSERT INTO `access_log` VALUES (31069, '65.45.15598036374830245', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:17', 3, 0, '', '2019-06-06 14:47:17');
INSERT INTO `access_log` VALUES (31070, '62.87.15598036385879813', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:47:19', 14, 0, '', '2019-06-06 14:47:19');
INSERT INTO `access_log` VALUES (31071, '62.82.15598036453869823', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:47:25', 18, 0, '', '2019-06-06 14:47:25');
INSERT INTO `access_log` VALUES (31072, '64.83.15598036520079791', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:47:32', 9, 0, '', '2019-06-06 14:47:32');
INSERT INTO `access_log` VALUES (31073, '64.84.15598036520059805', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:47:32', 11, 0, '', '2019-06-06 14:47:32');
INSERT INTO `access_log` VALUES (31074, '64.77.15598036539499805', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:47:34', 9, 0, '', '2019-06-06 14:47:34');
INSERT INTO `access_log` VALUES (31075, '64.85.15598036539479819', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:47:34', 11, 0, '', '2019-06-06 14:47:34');
INSERT INTO `access_log` VALUES (31076, '64.82.15598036569119811', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:47:37', 119, 0, '', '2019-06-06 14:47:37');
INSERT INTO `access_log` VALUES (31077, '64.80.15598036598199797', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=一加 7 pro&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=637&visible=true&id=39&picUrls=http://static.shop.iocoder.cn/ef1a145e-0b6b-4137-be7f-a49ca77e8811,http://static.shop.iocoder.cn/f05dedbc-3d14-4b63-8865-a60ad4aa9ae2,http://static.shop.iocoder.cn/516d718d-e4ce-4897-8b38-78a35eac2715,http://static.shop.iocoder.cn/20dabbb6-37f5-4fc1-9ab8-8b5dbfa9e5a2&skuStr=[{\"attrs\":[1,3],\"price\":100000,\"quantity\":20}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:40', 7, 1002002009, NULL, '2019-06-06 14:47:40');
INSERT INTO `access_log` VALUES (31078, '64.78.15598036611839807', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=一加 7 pro&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=637&visible=true&id=39&picUrls=http://static.shop.iocoder.cn/ef1a145e-0b6b-4137-be7f-a49ca77e8811,http://static.shop.iocoder.cn/f05dedbc-3d14-4b63-8865-a60ad4aa9ae2,http://static.shop.iocoder.cn/516d718d-e4ce-4897-8b38-78a35eac2715,http://static.shop.iocoder.cn/20dabbb6-37f5-4fc1-9ab8-8b5dbfa9e5a2&skuStr=[{\"attrs\":[1,3],\"price\":100000,\"quantity\":20}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:41', 7, 1002002009, NULL, '2019-06-06 14:47:41');
INSERT INTO `access_log` VALUES (31079, '64.79.15598036618989795', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=一加 7 pro&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=637&visible=true&id=39&picUrls=http://static.shop.iocoder.cn/ef1a145e-0b6b-4137-be7f-a49ca77e8811,http://static.shop.iocoder.cn/f05dedbc-3d14-4b63-8865-a60ad4aa9ae2,http://static.shop.iocoder.cn/516d718d-e4ce-4897-8b38-78a35eac2715,http://static.shop.iocoder.cn/20dabbb6-37f5-4fc1-9ab8-8b5dbfa9e5a2&skuStr=[{\"attrs\":[1,3],\"price\":100000,\"quantity\":20}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:42', 8, 1002002009, NULL, '2019-06-06 14:47:42');
INSERT INTO `access_log` VALUES (31080, '64.76.15598036621129787', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=一加 7 pro&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=637&visible=true&id=39&picUrls=http://static.shop.iocoder.cn/ef1a145e-0b6b-4137-be7f-a49ca77e8811,http://static.shop.iocoder.cn/f05dedbc-3d14-4b63-8865-a60ad4aa9ae2,http://static.shop.iocoder.cn/516d718d-e4ce-4897-8b38-78a35eac2715,http://static.shop.iocoder.cn/20dabbb6-37f5-4fc1-9ab8-8b5dbfa9e5a2&skuStr=[{\"attrs\":[1,3],\"price\":100000,\"quantity\":20}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:42', 8, 1002002009, NULL, '2019-06-06 14:47:42');
INSERT INTO `access_log` VALUES (31081, '64.83.15598036623059793', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=一加 7 pro&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=637&visible=true&id=39&picUrls=http://static.shop.iocoder.cn/ef1a145e-0b6b-4137-be7f-a49ca77e8811,http://static.shop.iocoder.cn/f05dedbc-3d14-4b63-8865-a60ad4aa9ae2,http://static.shop.iocoder.cn/516d718d-e4ce-4897-8b38-78a35eac2715,http://static.shop.iocoder.cn/20dabbb6-37f5-4fc1-9ab8-8b5dbfa9e5a2&skuStr=[{\"attrs\":[1,3],\"price\":100000,\"quantity\":20}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:42', 8, 1002002009, NULL, '2019-06-06 14:47:42');
INSERT INTO `access_log` VALUES (31082, '64.84.15598036624889807', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=一加 7 pro&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=637&visible=true&id=39&picUrls=http://static.shop.iocoder.cn/ef1a145e-0b6b-4137-be7f-a49ca77e8811,http://static.shop.iocoder.cn/f05dedbc-3d14-4b63-8865-a60ad4aa9ae2,http://static.shop.iocoder.cn/516d718d-e4ce-4897-8b38-78a35eac2715,http://static.shop.iocoder.cn/20dabbb6-37f5-4fc1-9ab8-8b5dbfa9e5a2&skuStr=[{\"attrs\":[1,3],\"price\":100000,\"quantity\":20}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:42', 7, 1002002009, NULL, '2019-06-06 14:47:42');
INSERT INTO `access_log` VALUES (31083, '64.77.15598036626719807', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=一加 7 pro&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=637&visible=true&id=39&picUrls=http://static.shop.iocoder.cn/ef1a145e-0b6b-4137-be7f-a49ca77e8811,http://static.shop.iocoder.cn/f05dedbc-3d14-4b63-8865-a60ad4aa9ae2,http://static.shop.iocoder.cn/516d718d-e4ce-4897-8b38-78a35eac2715,http://static.shop.iocoder.cn/20dabbb6-37f5-4fc1-9ab8-8b5dbfa9e5a2&skuStr=[{\"attrs\":[1,3],\"price\":100000,\"quantity\":20}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:43', 7, 1002002009, NULL, '2019-06-06 14:47:43');
INSERT INTO `access_log` VALUES (31084, '64.85.15598036628609821', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=一加 7 pro&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=637&visible=true&id=39&picUrls=http://static.shop.iocoder.cn/ef1a145e-0b6b-4137-be7f-a49ca77e8811,http://static.shop.iocoder.cn/f05dedbc-3d14-4b63-8865-a60ad4aa9ae2,http://static.shop.iocoder.cn/516d718d-e4ce-4897-8b38-78a35eac2715,http://static.shop.iocoder.cn/20dabbb6-37f5-4fc1-9ab8-8b5dbfa9e5a2&skuStr=[{\"attrs\":[1,3],\"price\":100000,\"quantity\":20}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:43', 7, 1002002009, NULL, '2019-06-06 14:47:43');
INSERT INTO `access_log` VALUES (31085, '64.81.15598036696379799', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=一加 7 pro&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=637&visible=true&id=39&picUrls=http://static.shop.iocoder.cn/ef1a145e-0b6b-4137-be7f-a49ca77e8811,http://static.shop.iocoder.cn/f05dedbc-3d14-4b63-8865-a60ad4aa9ae2,http://static.shop.iocoder.cn/516d718d-e4ce-4897-8b38-78a35eac2715,http://static.shop.iocoder.cn/20dabbb6-37f5-4fc1-9ab8-8b5dbfa9e5a2&skuStr=[{\"attrs\":[1,3],\"price\":100000,\"quantity\":20}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:50', 8, 1002002009, NULL, '2019-06-06 14:47:50');
INSERT INTO `access_log` VALUES (31086, '66.51.15598036730038525', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:47:53', 12, 0, '', '2019-06-06 14:47:53');
INSERT INTO `access_log` VALUES (31087, '64.80.15598036766049799', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=一加 7 pro&sellPoint=2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机&cid=637&visible=true&id=39&picUrls=http://static.shop.iocoder.cn/ef1a145e-0b6b-4137-be7f-a49ca77e8811,http://static.shop.iocoder.cn/f05dedbc-3d14-4b63-8865-a60ad4aa9ae2,http://static.shop.iocoder.cn/516d718d-e4ce-4897-8b38-78a35eac2715,http://static.shop.iocoder.cn/20dabbb6-37f5-4fc1-9ab8-8b5dbfa9e5a2&skuStr=[{\"attrs\":[1,3],\"price\":100000,\"quantity\":20}]&description=<p>2K+90Hz 流体屏 骁龙855旗舰 4800万超广角三摄 8GB+256GB 曜岩灰 全面屏拍照游戏手机</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:47:57', 8, 1002002009, NULL, '2019-06-06 14:47:57');
INSERT INTO `access_log` VALUES (31088, '59.76.15598036796999975', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:48:00', 12, 0, '', '2019-06-06 14:48:00');
INSERT INTO `access_log` VALUES (31089, '59.71.15598036824309989', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:48:02', 19, 2001001000, '服务端发生异常', '2019-06-06 14:48:02');
INSERT INTO `access_log` VALUES (31090, '64.79.15598036867489797', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:48:07', 10, 0, '', '2019-06-06 14:48:07');
INSERT INTO `access_log` VALUES (31091, '64.76.15598036867529789', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.223.188.98', '2019-06-06 14:48:07', 8, 0, '', '2019-06-06 14:48:07');
INSERT INTO `access_log` VALUES (31092, '59.72.15598036869009983', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:48:07', 3, 0, '', '2019-06-06 14:48:07');
INSERT INTO `access_log` VALUES (31093, '59.80.15598036869069975', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-06 14:48:07', 12, 2001001000, '服务端发生异常', '2019-06-06 14:48:07');
INSERT INTO `access_log` VALUES (31094, '59.78.15598037285979989', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '223.104.23.186', '2019-06-06 14:48:49', 3, 0, '', '2019-06-06 14:48:49');
INSERT INTO `access_log` VALUES (31095, '59.79.15598037286009985', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '223.104.23.186', '2019-06-06 14:48:49', 14, 2001001000, '服务端发生异常', '2019-06-06 14:48:49');
INSERT INTO `access_log` VALUES (31096, '64.85.15598037341529823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '223.104.23.186', '2019-06-06 14:48:54', 2, 0, '', '2019-06-06 14:48:54');
INSERT INTO `access_log` VALUES (31097, '64.81.15598037343929801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '223.104.23.186', '2019-06-06 14:48:54', 2, 0, '', '2019-06-06 14:48:54');
INSERT INTO `access_log` VALUES (31098, '64.82.15598037376349815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '223.104.23.186', '2019-06-06 14:48:58', 2, 0, '', '2019-06-06 14:48:58');
INSERT INTO `access_log` VALUES (31099, '64.80.15598037395849801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '223.104.23.186', '2019-06-06 14:49:00', 2, 0, '', '2019-06-06 14:49:00');
INSERT INTO `access_log` VALUES (31100, '64.78.15598037415989811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '223.104.23.186', '2019-06-06 14:49:02', 2, 0, '', '2019-06-06 14:49:02');
INSERT INTO `access_log` VALUES (31101, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '223.104.23.186', '2019-06-06 14:49:03', 14, 0, '', '2019-06-06 14:49:03');
INSERT INTO `access_log` VALUES (31102, '64.76.15598037429139791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '223.104.23.186', '2019-06-06 14:49:03', 728, 0, '', '2019-06-06 14:49:04');
INSERT INTO `access_log` VALUES (31103, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '223.104.23.186', '2019-06-06 14:49:07', 7, 0, '', '2019-06-06 14:49:07');
INSERT INTO `access_log` VALUES (31104, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '223.104.23.186', '2019-06-06 14:49:08', 8, 0, '', '2019-06-06 14:49:08');
INSERT INTO `access_log` VALUES (31105, '65.51.15598040958140243', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.171.74', '2019-06-06 14:54:56', 1, 1002001015, '账号未登陆', '2019-06-06 14:54:56');
INSERT INTO `access_log` VALUES (31106, '65.46.15598040958190235', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.171.74', '2019-06-06 14:54:56', 0, 1002001015, '账号未登陆', '2019-06-06 14:54:56');
INSERT INTO `access_log` VALUES (31107, '65.49.15598040958160259', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.171.74', '2019-06-06 14:54:56', 1, 1002001015, '账号未登陆', '2019-06-06 14:54:56');
INSERT INTO `access_log` VALUES (31108, '59.80.15598040999219981', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.171.74', '2019-06-06 14:55:00', 3, 0, '', '2019-06-06 14:55:00');
INSERT INTO `access_log` VALUES (31109, '59.74.15598040999229987', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.171.74', '2019-06-06 14:55:00', 20, 2001001000, '服务端发生异常', '2019-06-06 14:55:00');
INSERT INTO `access_log` VALUES (31110, '59.78.15598041062309995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.212.171.74', '2019-06-06 14:55:06', 2, 0, '', '2019-06-06 14:55:06');
INSERT INTO `access_log` VALUES (31111, '59.79.15598041062309991', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.212.171.74', '2019-06-06 14:55:06', 11, 2001001000, '服务端发生异常', '2019-06-06 14:55:06');
INSERT INTO `access_log` VALUES (31112, '64.81.15598041087869807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.212.171.74', '2019-06-06 14:55:09', 3, 0, '', '2019-06-06 14:55:09');
INSERT INTO `access_log` VALUES (31113, '64.82.15598041088929821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.212.171.74', '2019-06-06 14:55:09', 2, 0, '', '2019-06-06 14:55:09');
INSERT INTO `access_log` VALUES (31114, '64.80.15598041126909807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.212.171.74', '2019-06-06 14:55:13', 2, 0, '', '2019-06-06 14:55:13');
INSERT INTO `access_log` VALUES (31115, '64.78.15598041129339817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.212.171.74', '2019-06-06 14:55:13', 2, 0, '', '2019-06-06 14:55:13');
INSERT INTO `access_log` VALUES (31116, '64.76.15598041141389797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.212.171.74', '2019-06-06 14:55:14', 2, 0, '', '2019-06-06 14:55:14');
INSERT INTO `access_log` VALUES (31117, '64.79.15598041146129805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.212.171.74', '2019-06-06 14:55:15', 2, 0, '', '2019-06-06 14:55:15');
INSERT INTO `access_log` VALUES (31118, '64.76.15598041141389797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.212.171.74', '2019-06-06 14:55:14', 2, 0, '', '2019-06-06 14:55:15');
INSERT INTO `access_log` VALUES (31119, '64.83.15598041169079803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.212.171.74', '2019-06-06 14:55:17', 2, 0, '', '2019-06-06 14:55:17');
INSERT INTO `access_log` VALUES (31120, '64.84.15598041185409817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '222.212.171.74', '2019-06-06 14:55:19', 125, 0, '', '2019-06-06 14:55:19');
INSERT INTO `access_log` VALUES (31121, '65.53.15598041213140213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.212.171.74', '2019-06-06 14:55:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 14:55:21');
INSERT INTO `access_log` VALUES (31122, '65.50.15598047326700241', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:33', 0, 1002001015, '账号未登陆', '2019-06-06 15:05:33');
INSERT INTO `access_log` VALUES (31123, '65.47.15598047326700247', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:33', 0, 1002001015, '账号未登陆', '2019-06-06 15:05:33');
INSERT INTO `access_log` VALUES (31124, '65.45.15598047326750261', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:33', 0, 1002001015, '账号未登陆', '2019-06-06 15:05:33');
INSERT INTO `access_log` VALUES (31125, '65.46.15598047410410245', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:41', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:41');
INSERT INTO `access_log` VALUES (31126, '65.51.15598047428440253', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:43');
INSERT INTO `access_log` VALUES (31127, '65.49.15598047437140269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:44');
INSERT INTO `access_log` VALUES (31128, '65.54.15598047440730211', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:44', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:44');
INSERT INTO `access_log` VALUES (31129, '65.53.15598047444300223', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:44');
INSERT INTO `access_log` VALUES (31130, '65.3607.15598047447852013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:45');
INSERT INTO `access_log` VALUES (31131, '65.50.15598047451220243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:45');
INSERT INTO `access_log` VALUES (31132, '65.47.15598047454390249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:45');
INSERT INTO `access_log` VALUES (31133, '65.45.15598047459610263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:46');
INSERT INTO `access_log` VALUES (31134, '65.52.15598047462820249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:46');
INSERT INTO `access_log` VALUES (31135, '65.46.15598047466080247', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:47');
INSERT INTO `access_log` VALUES (31136, '65.51.15598047469390255', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:47');
INSERT INTO `access_log` VALUES (31137, '65.49.15598047472700271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:47');
INSERT INTO `access_log` VALUES (31138, '65.54.15598047475990213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:48');
INSERT INTO `access_log` VALUES (31139, '65.53.15598047479580225', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:48', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:48');
INSERT INTO `access_log` VALUES (31140, '65.3607.15598047483262015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:48', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:48');
INSERT INTO `access_log` VALUES (31141, '65.50.15598047486580245', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:49', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:49');
INSERT INTO `access_log` VALUES (31142, '65.47.15598047490230251', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:49', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:49');
INSERT INTO `access_log` VALUES (31143, '65.45.15598047493430265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:49');
INSERT INTO `access_log` VALUES (31144, '65.52.15598047497090251', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:50');
INSERT INTO `access_log` VALUES (31145, '65.46.15598047500570249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:50');
INSERT INTO `access_log` VALUES (31146, '65.51.15598047504140257', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:50');
INSERT INTO `access_log` VALUES (31147, '65.49.15598047507690273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:51');
INSERT INTO `access_log` VALUES (31148, '65.54.15598047511240215', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:51', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:51');
INSERT INTO `access_log` VALUES (31149, '65.53.15598047515000227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:52', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:52');
INSERT INTO `access_log` VALUES (31150, '65.3607.15598047520252017', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:05:52', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:05:52');
INSERT INTO `access_log` VALUES (31151, '65.47.15598047597060253', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:00', 74, 0, '', '2019-06-06 15:06:00');
INSERT INTO `access_log` VALUES (31152, '65.45.15598047600800267', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:00', 9, 0, '', '2019-06-06 15:06:00');
INSERT INTO `access_log` VALUES (31153, '65.52.15598047600800253', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:00', 10, 0, '', '2019-06-06 15:06:00');
INSERT INTO `access_log` VALUES (31154, '65.46.15598047600830251', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:00', 9, 0, '', '2019-06-06 15:06:00');
INSERT INTO `access_log` VALUES (31155, '62.89.15598047711819841', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:11', 14, 0, '', '2019-06-06 15:06:11');
INSERT INTO `access_log` VALUES (31156, '62.84.15598047930519829', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:33', 12, 0, '', '2019-06-06 15:06:33');
INSERT INTO `access_log` VALUES (31157, '64.85.15598047966619839', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:37', 190, 0, '', '2019-06-06 15:06:37');
INSERT INTO `access_log` VALUES (31158, '64.81.15598047966599819', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:37', 193, 0, '', '2019-06-06 15:06:37');
INSERT INTO `access_log` VALUES (31159, '64.82.15598048007259833', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:41', 9, 0, '', '2019-06-06 15:06:41');
INSERT INTO `access_log` VALUES (31160, '64.84.15598048007259827', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:41', 12, 0, '', '2019-06-06 15:06:41');
INSERT INTO `access_log` VALUES (31161, '64.80.15598048100439819', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:50', 10, 0, '', '2019-06-06 15:06:50');
INSERT INTO `access_log` VALUES (31162, '64.78.15598048108469829', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:51', 10, 0, '', '2019-06-06 15:06:51');
INSERT INTO `access_log` VALUES (31163, '64.76.15598048121049809', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:52', 9, 0, '', '2019-06-06 15:06:52');
INSERT INTO `access_log` VALUES (31164, '64.83.15598048127299813', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:53', 12, 0, '', '2019-06-06 15:06:53');
INSERT INTO `access_log` VALUES (31165, '66.52.15598048171448543', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:57', 18, 0, '', '2019-06-06 15:06:57');
INSERT INTO `access_log` VALUES (31166, '59.77.15598048187579991', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:06:59', 11, 0, '', '2019-06-06 15:06:59');
INSERT INTO `access_log` VALUES (31167, '59.76.15598048222999993', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:07:02', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-06 15:07:02');
INSERT INTO `access_log` VALUES (31168, '65.3607.15598048248102019', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:07:05', 10, 0, '', '2019-06-06 15:07:05');
INSERT INTO `access_log` VALUES (31169, '65.50.15598048266810249', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:07:07', 18, 0, '', '2019-06-06 15:07:07');
INSERT INTO `access_log` VALUES (31170, '65.52.15598048332920255', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.133.170.76', '2019-06-06 15:07:13', 11, 0, '', '2019-06-06 15:07:13');
INSERT INTO `access_log` VALUES (31171, '59.71.15598063177920025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '223.104.23.186', '2019-06-06 15:31:58', 4, 0, '', '2019-06-06 15:31:58');
INSERT INTO `access_log` VALUES (31172, '59.75.15598063178030023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '223.104.23.186', '2019-06-06 15:31:58', 13, 2001001000, '服务端发生异常', '2019-06-06 15:31:58');
INSERT INTO `access_log` VALUES (31173, '59.74.15598073908910033', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '103.208.15.203', '2019-06-06 15:49:51', 3, 0, '', '2019-06-06 15:49:51');
INSERT INTO `access_log` VALUES (31174, '59.73.15598073908910039', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '103.208.15.203', '2019-06-06 15:49:51', 13, 2001001000, '服务端发生异常', '2019-06-06 15:49:51');
INSERT INTO `access_log` VALUES (31175, '59.79.15598074001900037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '103.208.15.203', '2019-06-06 15:50:00', 13, 2001001000, '服务端发生异常', '2019-06-06 15:50:00');
INSERT INTO `access_log` VALUES (31176, '59.78.15598074001850041', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '103.208.15.203', '2019-06-06 15:50:00', 195, 0, '', '2019-06-06 15:50:00');
INSERT INTO `access_log` VALUES (31177, '59.71.15598074114680041', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:50:11', 2, 0, '', '2019-06-06 15:50:11');
INSERT INTO `access_log` VALUES (31178, '59.76.15598074114680029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:50:11', 20, 2001001000, '服务端发生异常', '2019-06-06 15:50:11');
INSERT INTO `access_log` VALUES (31179, '64.84.15598074166179863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:50:17', 10, 0, '', '2019-06-06 15:50:17');
INSERT INTO `access_log` VALUES (31180, '64.82.15598074169449869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:50:17', 2, 0, '', '2019-06-06 15:50:17');
INSERT INTO `access_log` VALUES (31181, '65.50.15598074602710283', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.212.82.131', '2019-06-06 15:51:00', 0, 1002001015, '账号未登陆', '2019-06-06 15:51:00');
INSERT INTO `access_log` VALUES (31182, '65.47.15598074602700293', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.212.82.131', '2019-06-06 15:51:00', 0, 1002001015, '账号未登陆', '2019-06-06 15:51:00');
INSERT INTO `access_log` VALUES (31183, '65.52.15598074602920291', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.212.82.131', '2019-06-06 15:51:00', 0, 1002001015, '账号未登陆', '2019-06-06 15:51:00');
INSERT INTO `access_log` VALUES (31184, '65.46.15598074697690291', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.212.82.131', '2019-06-06 15:51:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:51:10');
INSERT INTO `access_log` VALUES (31185, '65.53.15598074849810267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.212.82.131', '2019-06-06 15:51:25', 102, 0, '', '2019-06-06 15:51:25');
INSERT INTO `access_log` VALUES (31186, '65.3607.15598075124602057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.212.82.131', '2019-06-06 15:51:52', 87, 0, '', '2019-06-06 15:51:53');
INSERT INTO `access_log` VALUES (31187, '65.47.15598075187700295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.212.82.131', '2019-06-06 15:51:59', 177, 0, '', '2019-06-06 15:51:59');
INSERT INTO `access_log` VALUES (31188, '59.71.15598075366970043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.212.82.131', '2019-06-06 15:52:17', 4, 0, '', '2019-06-06 15:52:17');
INSERT INTO `access_log` VALUES (31189, '59.76.15598075366970031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.212.82.131', '2019-06-06 15:52:17', 13, 2001001000, '服务端发生异常', '2019-06-06 15:52:17');
INSERT INTO `access_log` VALUES (31190, '64.82.15598075419809871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.212.82.131', '2019-06-06 15:52:22', 3, 0, '', '2019-06-06 15:52:22');
INSERT INTO `access_log` VALUES (31191, '64.80.15598075421269857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.212.82.131', '2019-06-06 15:52:22', 1, 0, '', '2019-06-06 15:52:22');
INSERT INTO `access_log` VALUES (31192, '64.79.15598075469989855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.212.82.131', '2019-06-06 15:52:27', 2, 0, '', '2019-06-06 15:52:27');
INSERT INTO `access_log` VALUES (31193, '64.78.15598075471139867', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.212.82.131', '2019-06-06 15:52:27', 2, 0, '', '2019-06-06 15:52:27');
INSERT INTO `access_log` VALUES (31194, '59.72.15598075502100039', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.212.82.131', '2019-06-06 15:52:30', 3, 0, '', '2019-06-06 15:52:30');
INSERT INTO `access_log` VALUES (31195, '59.80.15598075502130031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.212.82.131', '2019-06-06 15:52:30', 14, 2001001000, '服务端发生异常', '2019-06-06 15:52:30');
INSERT INTO `access_log` VALUES (31196, '65.3607.15598076334932059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=http://h5.shop.iocoder.cn:18099&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.212.82.131', '2019-06-06 15:53:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:53:54');
INSERT INTO `access_log` VALUES (31197, '65.47.15598077864920299', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '103.208.15.203', '2019-06-06 15:56:26', 0, 1002001015, '账号未登陆', '2019-06-06 15:56:26');
INSERT INTO `access_log` VALUES (31198, '65.50.15598077864930289', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '103.208.15.203', '2019-06-06 15:56:26', 0, 1002001015, '账号未登陆', '2019-06-06 15:56:26');
INSERT INTO `access_log` VALUES (31199, '65.52.15598077864980297', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '103.208.15.203', '2019-06-06 15:56:26', 0, 1002001015, '账号未登陆', '2019-06-06 15:56:26');
INSERT INTO `access_log` VALUES (31200, '65.49.15598078016120319', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:56:42', 0, 1002001015, '账号未登陆', '2019-06-06 15:56:42');
INSERT INTO `access_log` VALUES (31201, '65.46.15598078016120297', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:56:42', 1, 1002001015, '账号未登陆', '2019-06-06 15:56:42');
INSERT INTO `access_log` VALUES (31202, '65.53.15598078016150273', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:56:42', 0, 1002001015, '账号未登陆', '2019-06-06 15:56:42');
INSERT INTO `access_log` VALUES (31203, '65.51.15598078041470305', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:56:44', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:56:44');
INSERT INTO `access_log` VALUES (31204, '65.3607.15598078071772063', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:56:47', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 15:56:47');
INSERT INTO `access_log` VALUES (31205, '65.52.15598078243860299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:57:04', 72, 0, '', '2019-06-06 15:57:04');
INSERT INTO `access_log` VALUES (31206, '65.50.15598078250580291', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:57:05', 10, 0, '', '2019-06-06 15:57:05');
INSERT INTO `access_log` VALUES (31207, '65.45.15598078250580315', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:57:05', 11, 0, '', '2019-06-06 15:57:05');
INSERT INTO `access_log` VALUES (31208, '65.47.15598078250580301', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:57:05', 11, 0, '', '2019-06-06 15:57:05');
INSERT INTO `access_log` VALUES (31209, '62.82.15598078514219881', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:57:31', 22, 0, '', '2019-06-06 15:57:31');
INSERT INTO `access_log` VALUES (31210, '62.89.15598078609019883', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:57:41', 12, 0, '', '2019-06-06 15:57:41');
INSERT INTO `access_log` VALUES (31211, '62.86.15598078636309867', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:57:44', 56, 0, '', '2019-06-06 15:57:44');
INSERT INTO `access_log` VALUES (31212, '66.57.15598079210538583', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:58:41', 20, 0, '', '2019-06-06 15:58:41');
INSERT INTO `access_log` VALUES (31213, '59.76.15598079351960037', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:58:55', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-06 15:58:55');
INSERT INTO `access_log` VALUES (31214, '59.75.15598079410610047', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 15:59:01', 10, 0, '', '2019-06-06 15:59:01');
INSERT INTO `access_log` VALUES (31215, '59.71.15598083419750055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.31.100.251', '2019-06-06 16:05:42', 11, 0, '', '2019-06-06 16:05:42');
INSERT INTO `access_log` VALUES (31216, '59.76.15598083419760043', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.31.100.251', '2019-06-06 16:05:42', 12, 2001001000, '服务端发生异常', '2019-06-06 16:05:42');
INSERT INTO `access_log` VALUES (31217, '64.81.15598083445069869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.31.100.251', '2019-06-06 16:05:45', 2, 0, '', '2019-06-06 16:05:45');
INSERT INTO `access_log` VALUES (31218, '64.85.15598083446709889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.31.100.251', '2019-06-06 16:05:45', 2, 0, '', '2019-06-06 16:05:45');
INSERT INTO `access_log` VALUES (31219, '64.84.15598083456589877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.31.100.251', '2019-06-06 16:05:46', 2, 0, '', '2019-06-06 16:05:46');
INSERT INTO `access_log` VALUES (31220, '64.82.15598083463009883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.31.100.251', '2019-06-06 16:05:46', 1, 0, '', '2019-06-06 16:05:46');
INSERT INTO `access_log` VALUES (31221, '64.80.15598083466989869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.31.100.251', '2019-06-06 16:05:47', 2, 0, '', '2019-06-06 16:05:47');
INSERT INTO `access_log` VALUES (31222, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.31.100.251', '2019-06-06 16:05:48', 15, 0, '', '2019-06-06 16:05:48');
INSERT INTO `access_log` VALUES (31223, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.31.100.251', '2019-06-06 16:05:48', 13, 0, '', '2019-06-06 16:05:48');
INSERT INTO `access_log` VALUES (31224, '64.79.15598083491529867', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.31.100.251', '2019-06-06 16:05:49', 7, 0, '', '2019-06-06 16:05:49');
INSERT INTO `access_log` VALUES (31225, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.31.100.251', '2019-06-06 16:05:51', 8, 0, '', '2019-06-06 16:05:51');
INSERT INTO `access_log` VALUES (31226, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.31.100.251', '2019-06-06 16:05:52', 11, 0, '', '2019-06-06 16:05:52');
INSERT INTO `access_log` VALUES (31227, '64.76.15598083525189859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.31.100.251', '2019-06-06 16:05:53', 2, 0, '', '2019-06-06 16:05:53');
INSERT INTO `access_log` VALUES (31228, '64.83.15598083526689863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.31.100.251', '2019-06-06 16:05:53', 2, 0, '', '2019-06-06 16:05:53');
INSERT INTO `access_log` VALUES (31229, '59.76.15598084723800045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:07:52', 3, 0, '', '2019-06-06 16:07:52');
INSERT INTO `access_log` VALUES (31230, '59.75.15598084723830055', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:07:52', 9, 2001001000, '服务端发生异常', '2019-06-06 16:07:52');
INSERT INTO `access_log` VALUES (31231, '59.80.15598084861940045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:08:06', 2, 0, '', '2019-06-06 16:08:06');
INSERT INTO `access_log` VALUES (31232, '59.73.15598084861940057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:08:06', 9, 2001001000, '服务端发生异常', '2019-06-06 16:08:06');
INSERT INTO `access_log` VALUES (31233, '65.54.15598084967020271', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:08:17', 0, 1002001015, '账号未登陆', '2019-06-06 16:08:17');
INSERT INTO `access_log` VALUES (31234, '65.52.15598084967050309', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:08:17', 1, 1002001015, '账号未登陆', '2019-06-06 16:08:17');
INSERT INTO `access_log` VALUES (31235, '65.50.15598084967180301', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:08:17', 1, 1002001015, '账号未登陆', '2019-06-06 16:08:17');
INSERT INTO `access_log` VALUES (31236, '65.45.15598084995110325', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:08:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 16:08:20');
INSERT INTO `access_log` VALUES (31237, '65.49.15598085045160331', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:08:25', 80, 0, '', '2019-06-06 16:08:25');
INSERT INTO `access_log` VALUES (31238, '65.53.15598085048710285', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:08:25', 10, 0, '', '2019-06-06 16:08:25');
INSERT INTO `access_log` VALUES (31239, '65.46.15598085048780309', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:08:25', 8, 0, '', '2019-06-06 16:08:25');
INSERT INTO `access_log` VALUES (31240, '65.51.15598085048850317', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:08:25', 9, 0, '', '2019-06-06 16:08:25');
INSERT INTO `access_log` VALUES (31241, '62.80.15598085110439897', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:08:31', 14, 0, '', '2019-06-06 16:08:31');
INSERT INTO `access_log` VALUES (31242, '62.87.15598085164529881', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:08:36', 15, 0, '', '2019-06-06 16:08:36');
INSERT INTO `access_log` VALUES (31243, '64.81.15598085213589873', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:08:41', 11, 0, '', '2019-06-06 16:08:41');
INSERT INTO `access_log` VALUES (31244, '64.85.15598085213629893', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:08:41', 8, 0, '', '2019-06-06 16:08:41');
INSERT INTO `access_log` VALUES (31245, '65.45.15598085647440327', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:09:25', 3, 0, '', '2019-06-06 16:09:25');
INSERT INTO `access_log` VALUES (31246, '64.76.15598085768569863', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:09:37', 12, 0, '', '2019-06-06 16:09:37');
INSERT INTO `access_log` VALUES (31247, '64.78.15598085768569883', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:09:37', 15, 0, '', '2019-06-06 16:09:37');
INSERT INTO `access_log` VALUES (31248, '64.77.15598085988729883', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1&cid=637', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:09:59', 11, 0, '', '2019-06-06 16:09:59');
INSERT INTO `access_log` VALUES (31249, '64.84.15598086252739883', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1&cid=638', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:10:25', 11, 0, '', '2019-06-06 16:10:25');
INSERT INTO `access_log` VALUES (31250, '64.82.15598086291279889', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1&cid=639', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:10:29', 9, 0, '', '2019-06-06 16:10:29');
INSERT INTO `access_log` VALUES (31251, '64.79.15598086372729873', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:10:37', 9, 0, '', '2019-06-06 16:10:37');
INSERT INTO `access_log` VALUES (31252, '66.48.15598087114658595', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:11:51', 15, 0, '', '2019-06-06 16:11:51');
INSERT INTO `access_log` VALUES (31253, '59.75.15598087342640059', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:12:14', 13, 0, '', '2019-06-06 16:12:14');
INSERT INTO `access_log` VALUES (31254, '59.80.15598087516750049', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:12:32', 20, 2001001000, '服务端发生异常', '2019-06-06 16:12:32');
INSERT INTO `access_log` VALUES (31255, '59.74.15598087566790055', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:12:37', 12, 0, '', '2019-06-06 16:12:37');
INSERT INTO `access_log` VALUES (31256, '59.78.15598087601530063', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:12:40', 21, 0, '', '2019-06-06 16:12:40');
INSERT INTO `access_log` VALUES (31257, '59.79.15598087628890059', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:12:43', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-06 16:12:43');
INSERT INTO `access_log` VALUES (31258, '65.51.15598087690200321', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:12:49', 18, 0, '', '2019-06-06 16:12:49');
INSERT INTO `access_log` VALUES (31259, '65.3607.15598087746832079', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:12:55', 10, 0, '', '2019-06-06 16:12:55');
INSERT INTO `access_log` VALUES (31260, '65.52.15598087785160315', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:12:59', 9, 0, '', '2019-06-06 16:12:59');
INSERT INTO `access_log` VALUES (31261, '65.50.15598087839680307', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 16:13:04', 162, 0, '', '2019-06-06 16:13:04');
INSERT INTO `access_log` VALUES (31262, '65.46.15598091894620321', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:19:49', 1, 1002001015, '账号未登陆', '2019-06-06 16:19:49');
INSERT INTO `access_log` VALUES (31263, '65.3607.15598091894632085', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:19:49', 1, 1002001015, '账号未登陆', '2019-06-06 16:19:49');
INSERT INTO `access_log` VALUES (31264, '65.52.15598091894630321', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:19:49', 1, 1002001015, '账号未登陆', '2019-06-06 16:19:49');
INSERT INTO `access_log` VALUES (31265, '65.50.15598091914700313', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:19:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 16:19:51');
INSERT INTO `access_log` VALUES (31266, '65.45.15598091962750339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:19:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 16:19:56');
INSERT INTO `access_log` VALUES (31267, '65.47.15598091974210325', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:19:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 16:19:57');
INSERT INTO `access_log` VALUES (31268, '65.49.15598092052450343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:20:05', 94, 0, '', '2019-06-06 16:20:05');
INSERT INTO `access_log` VALUES (31269, '65.53.15598092055510297', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:20:06', 10, 0, '', '2019-06-06 16:20:06');
INSERT INTO `access_log` VALUES (31270, '65.51.15598092055520331', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:20:06', 9, 0, '', '2019-06-06 16:20:06');
INSERT INTO `access_log` VALUES (31271, '65.52.15598092055560323', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:20:06', 9, 0, '', '2019-06-06 16:20:06');
INSERT INTO `access_log` VALUES (31272, '65.3607.15598092090262087', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:20:09', 18, 0, '', '2019-06-06 16:20:09');
INSERT INTO `access_log` VALUES (31273, '59.77.15598092154140055', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:20:15', 12, 0, '', '2019-06-06 16:20:15');
INSERT INTO `access_log` VALUES (31274, '64.79.15598092186149881', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:20:19', 11, 0, '', '2019-06-06 16:20:19');
INSERT INTO `access_log` VALUES (31275, '64.80.15598092186149883', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:20:19', 13, 0, '', '2019-06-06 16:20:19');
INSERT INTO `access_log` VALUES (31276, '64.83.15598092215719877', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:20:22', 8, 0, '', '2019-06-06 16:20:22');
INSERT INTO `access_log` VALUES (31277, '64.78.15598092215719893', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '14.223.161.122', '2019-06-06 16:20:22', 10, 0, '', '2019-06-06 16:20:22');
INSERT INTO `access_log` VALUES (31278, '59.76.15598092227660057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:23', 3, 0, '', '2019-06-06 16:20:23');
INSERT INTO `access_log` VALUES (31279, '59.75.15598092227670067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:23', 14, 2001001000, '服务端发生异常', '2019-06-06 16:20:23');
INSERT INTO `access_log` VALUES (31280, '64.77.15598092268599893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:27', 2, 0, '', '2019-06-06 16:20:27');
INSERT INTO `access_log` VALUES (31281, '64.85.15598092272489905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:27', 2, 0, '', '2019-06-06 16:20:27');
INSERT INTO `access_log` VALUES (31282, '64.81.15598092285639885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:29', 2, 0, '', '2019-06-06 16:20:29');
INSERT INTO `access_log` VALUES (31283, '64.84.15598092292139893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:29', 91, 0, '', '2019-06-06 16:20:29');
INSERT INTO `access_log` VALUES (31284, '59.80.15598092302350057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:30', 15, 2001001000, '服务端发生异常', '2019-06-06 16:20:30');
INSERT INTO `access_log` VALUES (31285, '59.72.15598092302350065', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:30', 153, 0, '', '2019-06-06 16:20:30');
INSERT INTO `access_log` VALUES (31286, '64.82.15598092325739899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:33', 2, 0, '', '2019-06-06 16:20:33');
INSERT INTO `access_log` VALUES (31287, '64.80.15598092326919885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:33', 2, 0, '', '2019-06-06 16:20:33');
INSERT INTO `access_log` VALUES (31288, '64.79.15598092340279883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:34', 2, 0, '', '2019-06-06 16:20:34');
INSERT INTO `access_log` VALUES (31289, '64.76.15598092344319875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:34', 2, 0, '', '2019-06-06 16:20:34');
INSERT INTO `access_log` VALUES (31290, '64.78.15598092390869895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:39', 1, 0, '', '2019-06-06 16:20:39');
INSERT INTO `access_log` VALUES (31291, '64.77.15598092392069895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:39', 2, 0, '', '2019-06-06 16:20:39');
INSERT INTO `access_log` VALUES (31292, '59.74.15598092407310063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:41', 3, 0, '', '2019-06-06 16:20:41');
INSERT INTO `access_log` VALUES (31293, '59.78.15598092407330071', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:20:41', 14, 2001001000, '服务端发生异常', '2019-06-06 16:20:41');
INSERT INTO `access_log` VALUES (31294, '65.47.15598092550720327', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:20:55', 0, 1002001015, '账号未登陆', '2019-06-06 16:20:55');
INSERT INTO `access_log` VALUES (31295, '65.49.15598092550740345', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:20:55', 0, 1002001015, '账号未登陆', '2019-06-06 16:20:55');
INSERT INTO `access_log` VALUES (31296, '65.53.15598092551780299', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:20:55', 0, 1002001015, '账号未登陆', '2019-06-06 16:20:55');
INSERT INTO `access_log` VALUES (31297, '65.46.15598092871160325', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:21:27', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 16:21:27');
INSERT INTO `access_log` VALUES (31298, '65.54.15598093231040287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:22:03', 56, 0, '', '2019-06-06 16:22:03');
INSERT INTO `access_log` VALUES (31299, '65.45.15598093238800343', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:22:04', 9, 0, '', '2019-06-06 16:22:04');
INSERT INTO `access_log` VALUES (31300, '65.49.15598093238800347', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:22:04', 10, 0, '', '2019-06-06 16:22:04');
INSERT INTO `access_log` VALUES (31301, '65.47.15598093239300329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:22:04', 10, 0, '', '2019-06-06 16:22:04');
INSERT INTO `access_log` VALUES (31302, '62.80.15598093303169909', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:22:10', 14, 0, '', '2019-06-06 16:22:10');
INSERT INTO `access_log` VALUES (31303, '62.85.15598093371079899', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:22:17', 15, 0, '', '2019-06-06 16:22:17');
INSERT INTO `access_log` VALUES (31304, '64.83.15598093410599881', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:22:21', 9, 0, '', '2019-06-06 16:22:21');
INSERT INTO `access_log` VALUES (31305, '64.78.15598093410909897', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:22:21', 7, 0, '', '2019-06-06 16:22:21');
INSERT INTO `access_log` VALUES (31306, '64.77.15598093461209897', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:22:26', 9, 0, '', '2019-06-06 16:22:26');
INSERT INTO `access_log` VALUES (31307, '64.85.15598093461209909', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:22:26', 11, 0, '', '2019-06-06 16:22:26');
INSERT INTO `access_log` VALUES (31308, '64.81.15598093515499889', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:22:32', 9, 0, '', '2019-06-06 16:22:32');
INSERT INTO `access_log` VALUES (31309, '59.74.15598093643930065', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:22:44', 13, 0, '', '2019-06-06 16:22:44');
INSERT INTO `access_log` VALUES (31310, '65.51.15598093724700337', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '110.87.118.26', '2019-06-06 16:22:52', 10, 0, '', '2019-06-06 16:22:52');
INSERT INTO `access_log` VALUES (31311, '65.50.15598093889500321', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '117.136.101.13', '2019-06-06 16:23:09', 1, 0, '', '2019-06-06 16:23:09');
INSERT INTO `access_log` VALUES (31312, '65.53.15598095615970311', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:02', 0, 1002001015, '账号未登陆', '2019-06-06 16:26:02');
INSERT INTO `access_log` VALUES (31313, '65.45.15598095616060347', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:02', 0, 1002001015, '账号未登陆', '2019-06-06 16:26:02');
INSERT INTO `access_log` VALUES (31314, '65.51.15598095616070343', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:02', 0, 1002001015, '账号未登陆', '2019-06-06 16:26:02');
INSERT INTO `access_log` VALUES (31315, '65.46.15598095658060333', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:06', 112, 0, '', '2019-06-06 16:26:06');
INSERT INTO `access_log` VALUES (31316, '65.3607.15598095661192097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:06', 10, 0, '', '2019-06-06 16:26:06');
INSERT INTO `access_log` VALUES (31317, '65.52.15598095661200333', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:06', 11, 0, '', '2019-06-06 16:26:06');
INSERT INTO `access_log` VALUES (31318, '65.50.15598095661220325', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:06', 9, 0, '', '2019-06-06 16:26:06');
INSERT INTO `access_log` VALUES (31319, '62.88.15598095720409915', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:12', 11, 0, '', '2019-06-06 16:26:12');
INSERT INTO `access_log` VALUES (31320, '62.80.15598095745769913', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:15', 15, 0, '', '2019-06-06 16:26:15');
INSERT INTO `access_log` VALUES (31321, '64.85.15598095808459913', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:21', 10, 0, '', '2019-06-06 16:26:21');
INSERT INTO `access_log` VALUES (31322, '64.78.15598095808449901', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:21', 12, 0, '', '2019-06-06 16:26:21');
INSERT INTO `access_log` VALUES (31323, '59.75.15598095861680073', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:26', 11, 0, '', '2019-06-06 16:26:26');
INSERT INTO `access_log` VALUES (31324, '59.72.15598095885350071', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:29', 20, 2001001000, '服务端发生异常', '2019-06-06 16:26:29');
INSERT INTO `access_log` VALUES (31325, '59.80.15598095907190063', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:31', 11, 0, '', '2019-06-06 16:26:31');
INSERT INTO `access_log` VALUES (31326, '65.51.15598095989880345', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:39', 18, 0, '', '2019-06-06 16:26:39');
INSERT INTO `access_log` VALUES (31327, '65.53.15598096001710313', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:40', 8, 0, '', '2019-06-06 16:26:40');
INSERT INTO `access_log` VALUES (31328, '65.45.15598096046500349', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:45', 13, 0, '', '2019-06-06 16:26:45');
INSERT INTO `access_log` VALUES (31329, '65.46.15598096072390335', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:47', 9, 0, '', '2019-06-06 16:26:47');
INSERT INTO `access_log` VALUES (31330, '65.50.15598096077600327', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:48', 19, 0, '', '2019-06-06 16:26:48');
INSERT INTO `access_log` VALUES (31331, '59.74.15598096081150069', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:48', 10, 0, '', '2019-06-06 16:26:48');
INSERT INTO `access_log` VALUES (31332, '59.78.15598096083300077', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:48', 19, 2001001000, '服务端发生异常', '2019-06-06 16:26:48');
INSERT INTO `access_log` VALUES (31333, '59.79.15598096086170073', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:49', 12, 0, '', '2019-06-06 16:26:49');
INSERT INTO `access_log` VALUES (31334, '64.84.15598096089899901', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:49', 9, 0, '', '2019-06-06 16:26:49');
INSERT INTO `access_log` VALUES (31335, '64.81.15598096089889893', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:49', 10, 0, '', '2019-06-06 16:26:49');
INSERT INTO `access_log` VALUES (31336, '62.82.15598096093059907', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:49', 14, 0, '', '2019-06-06 16:26:49');
INSERT INTO `access_log` VALUES (31337, '62.81.15598096096149883', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.31.111', '2019-06-06 16:26:50', 13, 0, '', '2019-06-06 16:26:50');
INSERT INTO `access_log` VALUES (31338, '59.76.15598097874090067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:29:47', 4, 0, '', '2019-06-06 16:29:47');
INSERT INTO `access_log` VALUES (31339, '59.75.15598097874090077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:29:47', 13, 2001001000, '服务端发生异常', '2019-06-06 16:29:47');
INSERT INTO `access_log` VALUES (31340, '65.47.15598097948750341', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:29:55', 1, 1002001015, '账号未登陆', '2019-06-06 16:29:55');
INSERT INTO `access_log` VALUES (31341, '65.54.15598097948830297', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:29:55', 0, 1002001015, '账号未登陆', '2019-06-06 16:29:55');
INSERT INTO `access_log` VALUES (31342, '65.51.15598097948910349', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:29:55', 0, 1002001015, '账号未登陆', '2019-06-06 16:29:55');
INSERT INTO `access_log` VALUES (31343, '64.77.15598098521969905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:30:52', 3, 0, '', '2019-06-06 16:30:52');
INSERT INTO `access_log` VALUES (31344, '64.84.15598098523379905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:30:52', 2, 0, '', '2019-06-06 16:30:52');
INSERT INTO `access_log` VALUES (31345, '64.81.15598098533219897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:30:53', 2, 0, '', '2019-06-06 16:30:53');
INSERT INTO `access_log` VALUES (31346, '64.82.15598098538779911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:30:54', 2, 0, '', '2019-06-06 16:30:54');
INSERT INTO `access_log` VALUES (31347, '65.3607.15598098600762103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:00', 101, 0, '', '2019-06-06 16:31:00');
INSERT INTO `access_log` VALUES (31348, '65.52.15598098604830339', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:00', 10, 0, '', '2019-06-06 16:31:00');
INSERT INTO `access_log` VALUES (31349, '65.47.15598098605060343', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:01', 9, 0, '', '2019-06-06 16:31:01');
INSERT INTO `access_log` VALUES (31350, '65.49.15598098605060363', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:01', 10, 0, '', '2019-06-06 16:31:01');
INSERT INTO `access_log` VALUES (31351, '62.87.15598098640919901', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:04', 13, 0, '', '2019-06-06 16:31:04');
INSERT INTO `access_log` VALUES (31352, '62.81.15598098711299887', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:11', 15, 0, '', '2019-06-06 16:31:11');
INSERT INTO `access_log` VALUES (31353, '64.76.15598098741799887', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:14', 8, 0, '', '2019-06-06 16:31:14');
INSERT INTO `access_log` VALUES (31354, '64.79.15598098741779895', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:14', 10, 0, '', '2019-06-06 16:31:14');
INSERT INTO `access_log` VALUES (31355, '64.85.15598098772669919', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:17', 8, 0, '', '2019-06-06 16:31:17');
INSERT INTO `access_log` VALUES (31356, '64.83.15598098772639891', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:17', 11, 0, '', '2019-06-06 16:31:17');
INSERT INTO `access_log` VALUES (31357, '64.77.15598098829969907', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:23', 9, 0, '', '2019-06-06 16:31:23');
INSERT INTO `access_log` VALUES (31358, '66.56.15598098883858601', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:28', 14, 0, '', '2019-06-06 16:31:28');
INSERT INTO `access_log` VALUES (31359, '65.53.15598098918170319', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:32', 19, 0, '', '2019-06-06 16:31:32');
INSERT INTO `access_log` VALUES (31360, '65.45.15598098935160355', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:34', 8, 0, '', '2019-06-06 16:31:34');
INSERT INTO `access_log` VALUES (31361, '65.46.15598098950150341', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.131.244', '2019-06-06 16:31:35', 9, 0, '', '2019-06-06 16:31:35');
INSERT INTO `access_log` VALUES (31362, '64.83.15598120797949921', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 17:08:00', 25, 1002001012, '访问令牌已过期', '2019-06-06 17:08:00');
INSERT INTO `access_log` VALUES (31363, '64.85.15598120797949949', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 17:08:00', 28, 1002001012, '访问令牌已过期', '2019-06-06 17:08:00');
INSERT INTO `access_log` VALUES (31364, '65.45.15598121041820385', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 17:08:24', 83, 0, '', '2019-06-06 17:08:24');
INSERT INTO `access_log` VALUES (31365, '65.46.15598121046010371', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 17:08:25', 11, 0, '', '2019-06-06 17:08:25');
INSERT INTO `access_log` VALUES (31366, '65.50.15598121046060363', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 17:08:25', 12, 0, '', '2019-06-06 17:08:25');
INSERT INTO `access_log` VALUES (31367, '65.3607.15598121046122135', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 17:08:25', 15, 0, '', '2019-06-06 17:08:25');
INSERT INTO `access_log` VALUES (31368, '64.81.15598121065789929', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 17:08:27', 17, 0, '', '2019-06-06 17:08:27');
INSERT INTO `access_log` VALUES (31369, '64.84.15598121065749937', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-06 17:08:27', 23, 0, '', '2019-06-06 17:08:27');
INSERT INTO `access_log` VALUES (31370, '65.52.15598122543670373', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 17:10:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 17:10:54');
INSERT INTO `access_log` VALUES (31371, '65.49.15598122708610397', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-06 17:11:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 17:11:11');
INSERT INTO `access_log` VALUES (31372, '65.50.15598126316340371', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.175', '2019-06-06 17:17:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 17:17:12');
INSERT INTO `access_log` VALUES (31373, '65.46.15598126403670379', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.175', '2019-06-06 17:17:20', 110, 0, '', '2019-06-06 17:17:20');
INSERT INTO `access_log` VALUES (31374, '65.3607.15598126407342143', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.175', '2019-06-06 17:17:21', 10, 0, '', '2019-06-06 17:17:21');
INSERT INTO `access_log` VALUES (31375, '65.52.15598126407430379', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.175', '2019-06-06 17:17:21', 17, 0, '', '2019-06-06 17:17:21');
INSERT INTO `access_log` VALUES (31376, '65.47.15598126407430383', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.95.83.175', '2019-06-06 17:17:21', 17, 0, '', '2019-06-06 17:17:21');
INSERT INTO `access_log` VALUES (31377, '59.74.15598126592460111', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.95.83.175', '2019-06-06 17:17:39', 10, 0, '', '2019-06-06 17:17:39');
INSERT INTO `access_log` VALUES (31378, '59.73.15598126592460117', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.95.83.175', '2019-06-06 17:17:39', 14, 2001001000, '服务端发生异常', '2019-06-06 17:17:39');
INSERT INTO `access_log` VALUES (31379, '65.53.15598126650610359', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.95.83.175', '2019-06-06 17:17:45', 9, 0, '', '2019-06-06 17:17:45');
INSERT INTO `access_log` VALUES (31380, '65.54.15598126650600339', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.95.83.175', '2019-06-06 17:17:45', 11, 0, '', '2019-06-06 17:17:45');
INSERT INTO `access_log` VALUES (31381, '65.45.15598126650630395', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.95.83.175', '2019-06-06 17:17:45', 7, 0, '', '2019-06-06 17:17:45');
INSERT INTO `access_log` VALUES (31382, '62.89.15598127135429951', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.46.69', '2019-06-06 17:18:34', 305, 1002001012, '访问令牌已过期', '2019-06-06 17:18:34');
INSERT INTO `access_log` VALUES (31383, '65.51.15598127529520393', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:19:13', 0, 1002001015, '账号未登陆', '2019-06-06 17:19:13');
INSERT INTO `access_log` VALUES (31384, '65.54.15598127529620341', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:19:13', 0, 1002001015, '账号未登陆', '2019-06-06 17:19:13');
INSERT INTO `access_log` VALUES (31385, '65.53.15598127529670361', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:19:13', 1, 1002001015, '账号未登陆', '2019-06-06 17:19:13');
INSERT INTO `access_log` VALUES (31386, '65.45.15598127566180397', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:19:17', 1, 1002001015, '账号未登陆', '2019-06-06 17:19:17');
INSERT INTO `access_log` VALUES (31387, '65.50.15598127566300375', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:19:17', 1, 1002001015, '账号未登陆', '2019-06-06 17:19:17');
INSERT INTO `access_log` VALUES (31388, '65.46.15598127566360383', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:19:17', 0, 1002001015, '账号未登陆', '2019-06-06 17:19:17');
INSERT INTO `access_log` VALUES (31389, '65.52.15598127642250383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:19:24', 93, 0, '', '2019-06-06 17:19:24');
INSERT INTO `access_log` VALUES (31390, '65.49.15598127648540407', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:19:25', 18, 0, '', '2019-06-06 17:19:25');
INSERT INTO `access_log` VALUES (31391, '65.51.15598127648540395', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:19:25', 17, 0, '', '2019-06-06 17:19:25');
INSERT INTO `access_log` VALUES (31392, '65.47.15598127648530387', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:19:25', 17, 0, '', '2019-06-06 17:19:25');
INSERT INTO `access_log` VALUES (31393, '65.54.15598127734370343', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:19:33', 62, 0, '', '2019-06-06 17:19:34');
INSERT INTO `access_log` VALUES (31394, '65.53.15598127742210363', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:19:34', 9, 0, '', '2019-06-06 17:19:34');
INSERT INTO `access_log` VALUES (31395, '62.87.15598127795649941', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:19:40', 21, 0, '', '2019-06-06 17:19:40');
INSERT INTO `access_log` VALUES (31396, '64.78.15598127997409947', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:20:00', 15, 0, '', '2019-06-06 17:20:00');
INSERT INTO `access_log` VALUES (31397, '64.77.15598127997489947', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '36.108.123.83', '2019-06-06 17:20:00', 11, 0, '', '2019-06-06 17:20:00');
INSERT INTO `access_log` VALUES (31398, '65.52.15598132703170391', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:27:50', 1, 1002001015, '账号未登陆', '2019-06-06 17:27:50');
INSERT INTO `access_log` VALUES (31399, '65.3607.15598132703162155', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:27:50', 1, 1002001015, '账号未登陆', '2019-06-06 17:27:50');
INSERT INTO `access_log` VALUES (31400, '65.47.15598132703200395', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:27:50', 0, 1002001015, '账号未登陆', '2019-06-06 17:27:50');
INSERT INTO `access_log` VALUES (31401, '65.49.15598132752480415', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:27:55', 152, 0, '', '2019-06-06 17:27:55');
INSERT INTO `access_log` VALUES (31402, '65.50.15598132756790385', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:27:56', 659, 0, '', '2019-06-06 17:27:56');
INSERT INTO `access_log` VALUES (31403, '65.54.15598132756720351', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:27:56', 667, 0, '', '2019-06-06 17:27:56');
INSERT INTO `access_log` VALUES (31404, '65.53.15598132756790371', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:27:56', 660, 0, '', '2019-06-06 17:27:56');
INSERT INTO `access_log` VALUES (31405, '62.86.15598132824239943', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:28:02', 15, 0, '', '2019-06-06 17:28:02');
INSERT INTO `access_log` VALUES (31406, '62.84.15598132850579947', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:28:05', 15, 0, '', '2019-06-06 17:28:05');
INSERT INTO `access_log` VALUES (31407, '66.54.15598132922878657', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:28:12', 22, 0, '', '2019-06-06 17:28:12');
INSERT INTO `access_log` VALUES (31408, '59.77.15598132959970113', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:28:16', 13, 0, '', '2019-06-06 17:28:16');
INSERT INTO `access_log` VALUES (31409, '59.71.15598132985400127', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:28:19', 20, 2001001000, '服务端发生异常', '2019-06-06 17:28:19');
INSERT INTO `access_log` VALUES (31410, '65.52.15598133047520393', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:28:25', 19, 0, '', '2019-06-06 17:28:25');
INSERT INTO `access_log` VALUES (31411, '65.47.15598133058100397', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:28:26', 18, 0, '', '2019-06-06 17:28:26');
INSERT INTO `access_log` VALUES (31412, '65.3607.15598133071282157', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:28:27', 9, 0, '', '2019-06-06 17:28:27');
INSERT INTO `access_log` VALUES (31413, '65.51.15598133089350405', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:28:29', 118, 0, '', '2019-06-06 17:28:29');
INSERT INTO `access_log` VALUES (31414, '65.49.15598133189260417', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:28:39', 18, 0, '', '2019-06-06 17:28:39');
INSERT INTO `access_log` VALUES (31415, '59.72.15598133224960123', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:28:42', 11, 0, '', '2019-06-06 17:28:43');
INSERT INTO `access_log` VALUES (31416, '59.80.15598133245090115', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:28:45', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-06 17:28:45');
INSERT INTO `access_log` VALUES (31417, '62.82.15598133324619959', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '211.103.144.116', '2019-06-06 17:28:52', 13, 0, '', '2019-06-06 17:28:52');
INSERT INTO `access_log` VALUES (31418, '65.52.15598135404270397', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-06 17:32:20', 3, 1002001012, '访问令牌已过期', '2019-06-06 17:32:20');
INSERT INTO `access_log` VALUES (31419, '65.47.15598135404270401', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-06 17:32:20', 5, 1002001012, '访问令牌已过期', '2019-06-06 17:32:20');
INSERT INTO `access_log` VALUES (31420, '65.3607.15598135404292161', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-06 17:32:20', 4, 1002001012, '访问令牌已过期', '2019-06-06 17:32:20');
INSERT INTO `access_log` VALUES (31421, '65.51.15598135422120409', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-06 17:32:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 17:32:22');
INSERT INTO `access_log` VALUES (31422, '65.49.15598135531100421', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-06 17:32:33', 402, 0, '', '2019-06-06 17:32:34');
INSERT INTO `access_log` VALUES (31423, '65.50.15598135538290391', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-06 17:32:34', 9, 0, '', '2019-06-06 17:32:34');
INSERT INTO `access_log` VALUES (31424, '65.53.15598135538290377', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-06 17:32:34', 9, 0, '', '2019-06-06 17:32:34');
INSERT INTO `access_log` VALUES (31425, '65.46.15598135538340399', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-06 17:32:34', 9, 0, '', '2019-06-06 17:32:34');
INSERT INTO `access_log` VALUES (31426, '65.47.15598135589840403', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-06 17:32:39', 19, 0, '', '2019-06-06 17:32:39');
INSERT INTO `access_log` VALUES (31427, '59.75.15598135626620129', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-06 17:32:43', 11, 0, '', '2019-06-06 17:32:43');
INSERT INTO `access_log` VALUES (31428, '66.53.15598135653218657', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-06 17:32:45', 14, 0, '', '2019-06-06 17:32:45');
INSERT INTO `access_log` VALUES (31429, '62.87.15598135719969953', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-06 17:32:52', 14, 0, '', '2019-06-06 17:32:52');
INSERT INTO `access_log` VALUES (31430, '2e8fb92b-cf73-4547-b4fc-4d97eec820e6', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-06 17:34:51', 61, 1002001015, '账号未登陆', '2019-06-06 17:34:52');
INSERT INTO `access_log` VALUES (31431, '20e7573d-cfd6-461c-8d76-73ec1fbc30e5', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-06 17:34:51', 61, 1002001015, '账号未登陆', '2019-06-06 17:34:52');
INSERT INTO `access_log` VALUES (31432, '64ff3b94-9ab0-4e9c-93f3-cccbad98ad6e', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-06 17:34:51', 61, 1002001015, '账号未登陆', '2019-06-06 17:34:52');
INSERT INTO `access_log` VALUES (31433, '10bd4138-3365-4b79-84b3-285f9e0342c6', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-06 17:34:56', 744, 0, '', '2019-06-06 17:34:57');
INSERT INTO `access_log` VALUES (31434, 'a27df494-03ac-4b7e-8736-5a74888b6041', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-06 17:34:57', 354, 0, '', '2019-06-06 17:34:58');
INSERT INTO `access_log` VALUES (31435, '4198d073-d46b-4f2d-b862-2131d57e9004', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-06 17:34:57', 507, 0, '', '2019-06-06 17:34:58');
INSERT INTO `access_log` VALUES (31436, 'da313e5a-c268-4531-8601-710039d65d12', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-06 17:34:57', 528, 0, '', '2019-06-06 17:34:58');
INSERT INTO `access_log` VALUES (31437, 'c69374ff-8c36-4d66-bb5d-b397fe510832', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-06 17:35:19', 766, 0, '', '2019-06-06 17:35:20');
INSERT INTO `access_log` VALUES (31438, '9ae16423-6edd-497e-9dff-d254518b801e', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-06 17:35:19', 850, 0, '', '2019-06-06 17:35:20');
INSERT INTO `access_log` VALUES (31439, 'adfacda5-8e6a-4378-b2c3-b3758b16081e', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-06 17:35:26', 833, 0, '', '2019-06-06 17:35:26');
INSERT INTO `access_log` VALUES (31440, '695aae73-9ecd-4ad1-9063-ad3a6d41882d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-06 17:36:00', 141, 0, '', '2019-06-06 17:36:00');
INSERT INTO `access_log` VALUES (31441, '1c52f733-fdc0-4d09-a568-53cf22ab52cc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-06 17:36:00', 142, 0, '', '2019-06-06 17:36:00');
INSERT INTO `access_log` VALUES (31442, 'ed2f6ea4-d45d-4090-860c-965c908885e0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-06 17:36:00', 180, 0, '', '2019-06-06 17:36:00');
INSERT INTO `access_log` VALUES (31443, '65.47.15598140062050409', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:40:06', 1, 1002001015, '账号未登陆', '2019-06-06 17:40:06');
INSERT INTO `access_log` VALUES (31444, '65.3607.15598140062192169', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:40:06', 0, 1002001015, '账号未登陆', '2019-06-06 17:40:06');
INSERT INTO `access_log` VALUES (31445, '65.52.15598140062250405', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:40:06', 1, 1002001015, '账号未登陆', '2019-06-06 17:40:06');
INSERT INTO `access_log` VALUES (31446, '65.54.15598140120300365', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:40:12', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 17:40:12');
INSERT INTO `access_log` VALUES (31447, '65.53.15598140322380385', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:40:32', 51, 0, '', '2019-06-06 17:40:32');
INSERT INTO `access_log` VALUES (31448, '65.50.15598140335690399', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:40:34', 9, 0, '', '2019-06-06 17:40:34');
INSERT INTO `access_log` VALUES (31449, '65.46.15598140335790407', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:40:34', 8, 0, '', '2019-06-06 17:40:34');
INSERT INTO `access_log` VALUES (31450, '65.45.15598140335930421', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:40:34', 8, 0, '', '2019-06-06 17:40:34');
INSERT INTO `access_log` VALUES (31451, '62.81.15598140454029945', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:40:45', 14, 0, '', '2019-06-06 17:40:45');
INSERT INTO `access_log` VALUES (31452, '62.86.15598140536969955', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:40:54', 14, 0, '', '2019-06-06 17:40:54');
INSERT INTO `access_log` VALUES (31453, '64.79.15598140649649953', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:41:05', 12, 0, '', '2019-06-06 17:41:05');
INSERT INTO `access_log` VALUES (31454, '64.76.15598140649939945', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:41:05', 9, 0, '', '2019-06-06 17:41:05');
INSERT INTO `access_log` VALUES (31455, '64.85.15598140746459977', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:41:15', 9, 0, '', '2019-06-06 17:41:15');
INSERT INTO `access_log` VALUES (31456, '64.77.15598140746669965', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:41:15', 9, 0, '', '2019-06-06 17:41:15');
INSERT INTO `access_log` VALUES (31457, '64.78.15598140779389965', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:41:18', 12, 0, '', '2019-06-06 17:41:18');
INSERT INTO `access_log` VALUES (31458, '64.84.15598140779639965', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:41:18', 8, 0, '', '2019-06-06 17:41:18');
INSERT INTO `access_log` VALUES (31459, '64.82.15598140837059971', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:41:24', 11, 0, '', '2019-06-06 17:41:24');
INSERT INTO `access_log` VALUES (31460, '64.80.15598140837309957', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:41:24', 14, 0, '', '2019-06-06 17:41:24');
INSERT INTO `access_log` VALUES (31461, '64.76.15598140837389947', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:41:24', 8, 0, '', '2019-06-06 17:41:24');
INSERT INTO `access_log` VALUES (31462, '66.56.15598140931438659', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:41:33', 12, 0, '', '2019-06-06 17:41:33');
INSERT INTO `access_log` VALUES (31463, '59.79.15598140971160135', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:41:37', 11, 0, '', '2019-06-06 17:41:37');
INSERT INTO `access_log` VALUES (31464, '59.77.15598141027570125', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:41:43', 25, 2001001000, '服务端发生异常', '2019-06-06 17:41:43');
INSERT INTO `access_log` VALUES (31465, '59.71.15598141068120139', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:41:47', 12, 0, '', '2019-06-06 17:41:47');
INSERT INTO `access_log` VALUES (31466, '59.76.15598141155810127', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:41:56', 11, 0, '', '2019-06-06 17:41:56');
INSERT INTO `access_log` VALUES (31467, '59.72.15598141197760135', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:42:00', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-06 17:42:00');
INSERT INTO `access_log` VALUES (31468, '65.46.15598141541820409', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:42:34', 20, 0, '', '2019-06-06 17:42:34');
INSERT INTO `access_log` VALUES (31469, '65.45.15598141574990423', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:42:38', 10, 0, '', '2019-06-06 17:42:38');
INSERT INTO `access_log` VALUES (31470, '65.3607.15598141597272173', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:42:40', 10, 0, '', '2019-06-06 17:42:40');
INSERT INTO `access_log` VALUES (31471, '65.47.15598141622680413', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:42:42', 15, 0, '', '2019-06-06 17:42:42');
INSERT INTO `access_log` VALUES (31472, '65.51.15598141666570421', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:42:47', 19, 0, '', '2019-06-06 17:42:47');
INSERT INTO `access_log` VALUES (31473, '65.54.15598141690550369', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:42:49', 10, 0, '', '2019-06-06 17:42:49');
INSERT INTO `access_log` VALUES (31474, '65.49.15598141717260433', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '172.94.19.89', '2019-06-06 17:42:52', 17, 0, '', '2019-06-06 17:42:52');
INSERT INTO `access_log` VALUES (31475, '65.45.15598155650620443', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:05', 0, 1002001015, '账号未登陆', '2019-06-06 18:06:05');
INSERT INTO `access_log` VALUES (31476, '65.52.15598155650630429', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:05', 1, 1002001015, '账号未登陆', '2019-06-06 18:06:05');
INSERT INTO `access_log` VALUES (31477, '65.3607.15598155650882193', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:05', 0, 1002001015, '账号未登陆', '2019-06-06 18:06:05');
INSERT INTO `access_log` VALUES (31478, '65.47.15598155669660433', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 18:06:07');
INSERT INTO `access_log` VALUES (31479, '65.54.15598155704030389', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:10', 66, 0, '', '2019-06-06 18:06:10');
INSERT INTO `access_log` VALUES (31480, '65.49.15598155713580453', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:11', 10, 0, '', '2019-06-06 18:06:11');
INSERT INTO `access_log` VALUES (31481, '65.50.15598155713580423', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:11', 9, 0, '', '2019-06-06 18:06:11');
INSERT INTO `access_log` VALUES (31482, '65.53.15598155713580409', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:11', 12, 0, '', '2019-06-06 18:06:11');
INSERT INTO `access_log` VALUES (31483, '62.80.15598155761029997', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:16', 13, 0, '', '2019-06-06 18:06:16');
INSERT INTO `access_log` VALUES (31484, '64.79.15598155814069975', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:21', 10, 0, '', '2019-06-06 18:06:21');
INSERT INTO `access_log` VALUES (31485, '64.83.15598155820989971', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:22', 11, 0, '', '2019-06-06 18:06:22');
INSERT INTO `access_log` VALUES (31486, '64.77.15598155838149987', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:24', 9, 0, '', '2019-06-06 18:06:24');
INSERT INTO `access_log` VALUES (31487, '64.85.15598155838139999', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:24', 12, 0, '', '2019-06-06 18:06:24');
INSERT INTO `access_log` VALUES (31488, '66.49.15598155909658697', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:31', 14, 0, '', '2019-06-06 18:06:31');
INSERT INTO `access_log` VALUES (31489, '59.76.15598155932460147', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:33', 11, 0, '', '2019-06-06 18:06:33');
INSERT INTO `access_log` VALUES (31490, '59.80.15598155979210147', 1, 2, 'promotion-application', '/promotion-api/admins/banner/update_status', 'id=1&status=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:38', 231, 0, '', '2019-06-06 18:06:38');
INSERT INTO `access_log` VALUES (31491, '59.73.15598155982720159', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:38', 9, 0, '', '2019-06-06 18:06:38');
INSERT INTO `access_log` VALUES (31492, '65.45.15598156052250445', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.204.70.88', '2019-06-06 18:06:45', 16, 0, '', '2019-06-06 18:06:45');
INSERT INTO `access_log` VALUES (31493, '65.50.15598182115910459', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:50:12', 14, 1002001012, '访问令牌已过期', '2019-06-06 18:50:12');
INSERT INTO `access_log` VALUES (31494, '65.53.15598182115930445', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:50:12', 14, 1002001012, '访问令牌已过期', '2019-06-06 18:50:12');
INSERT INTO `access_log` VALUES (31495, '65.49.15598182116120489', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:50:12', 17, 1002001012, '访问令牌已过期', '2019-06-06 18:50:12');
INSERT INTO `access_log` VALUES (31496, '65.46.15598182210020467', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:50:21', 89, 0, '', '2019-06-06 18:50:21');
INSERT INTO `access_log` VALUES (31497, '65.52.15598182215070467', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:50:22', 9, 0, '', '2019-06-06 18:50:22');
INSERT INTO `access_log` VALUES (31498, '65.45.15598182215130481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:50:22', 10, 0, '', '2019-06-06 18:50:22');
INSERT INTO `access_log` VALUES (31499, '65.3607.15598182215162231', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:50:22', 10, 0, '', '2019-06-06 18:50:22');
INSERT INTO `access_log` VALUES (31500, '62.88.15598182244830035', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:50:24', 20, 0, '', '2019-06-06 18:50:25');
INSERT INTO `access_log` VALUES (31501, '59.72.15598182585090191', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.127.11', '2019-06-06 18:50:59', 14, 0, '', '2019-06-06 18:50:59');
INSERT INTO `access_log` VALUES (31502, '59.80.15598182585110183', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.127.11', '2019-06-06 18:50:59', 24, 2001001000, '服务端发生异常', '2019-06-06 18:50:59');
INSERT INTO `access_log` VALUES (31503, '64.77.15598182634640023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.127.11', '2019-06-06 18:51:03', 12, 0, '', '2019-06-06 18:51:03');
INSERT INTO `access_log` VALUES (31504, '64.85.15598182635900035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.127.11', '2019-06-06 18:51:04', 3, 0, '', '2019-06-06 18:51:04');
INSERT INTO `access_log` VALUES (31505, '65.53.15598182709810447', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.127.11', '2019-06-06 18:51:11', 1, 1002001015, '账号未登陆', '2019-06-06 18:51:11');
INSERT INTO `access_log` VALUES (31506, '65.49.15598182709820491', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.127.11', '2019-06-06 18:51:11', 1, 1002001015, '账号未登陆', '2019-06-06 18:51:11');
INSERT INTO `access_log` VALUES (31507, '65.46.15598182709860469', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.127.11', '2019-06-06 18:51:11', 0, 1002001015, '账号未登陆', '2019-06-06 18:51:11');
INSERT INTO `access_log` VALUES (31508, '65.3607.15598182728812233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.127.11', '2019-06-06 18:51:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 18:51:13');
INSERT INTO `access_log` VALUES (31509, '65.45.15598182760070483', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.127.11', '2019-06-06 18:51:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 18:51:16');
INSERT INTO `access_log` VALUES (31510, '65.52.15598182769670469', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.127.11', '2019-06-06 18:51:17', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 18:51:17');
INSERT INTO `access_log` VALUES (31511, '65.47.15598182779020473', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.127.11', '2019-06-06 18:51:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 18:51:18');
INSERT INTO `access_log` VALUES (31512, '59.71.15598183266880197', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:52:07', 12, 0, '', '2019-06-06 18:52:07');
INSERT INTO `access_log` VALUES (31513, '59.75.15598183285850195', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:52:09', 10, 0, '', '2019-06-06 18:52:09');
INSERT INTO `access_log` VALUES (31514, '64.80.15598183322360015', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:52:12', 10, 0, '', '2019-06-06 18:52:12');
INSERT INTO `access_log` VALUES (31515, '64.79.15598183340780013', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:52:14', 9, 0, '', '2019-06-06 18:52:14');
INSERT INTO `access_log` VALUES (31516, '59.80.15598183559450185', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:52:36', 12, 0, '', '2019-06-06 18:52:36');
INSERT INTO `access_log` VALUES (31517, '59.73.15598183607470197', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=INVALID&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:52:41', 10, 0, '', '2019-06-06 18:52:41');
INSERT INTO `access_log` VALUES (31518, '59.74.15598183611950191', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:52:41', 11, 0, '', '2019-06-06 18:52:41');
INSERT INTO `access_log` VALUES (31519, '59.78.15598183615480199', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:52:42', 11, 0, '', '2019-06-06 18:52:42');
INSERT INTO `access_log` VALUES (31520, '59.79.15598183623020195', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:52:42', 16, 0, '', '2019-06-06 18:52:42');
INSERT INTO `access_log` VALUES (31521, '59.77.15598183643840185', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:52:44', 60, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-06 18:52:44');
INSERT INTO `access_log` VALUES (31522, '65.3607.15598183674412235', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:52:47', 19, 0, '', '2019-06-06 18:52:47');
INSERT INTO `access_log` VALUES (31523, '65.45.15598183687450485', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:52:49', 10, 0, '', '2019-06-06 18:52:49');
INSERT INTO `access_log` VALUES (31524, '65.52.15598183706450471', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:52:51', 16, 0, '', '2019-06-06 18:52:51');
INSERT INTO `access_log` VALUES (31525, '65.47.15598183712340475', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '36.102.10.145', '2019-06-06 18:52:51', 9, 0, '', '2019-06-06 18:52:51');
INSERT INTO `access_log` VALUES (31526, '65.54.15598259140220531', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.78.207.196', '2019-06-06 20:58:34', 0, 1002001015, '账号未登陆', '2019-06-06 20:58:34');
INSERT INTO `access_log` VALUES (31527, '65.50.15598259140220567', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.78.207.196', '2019-06-06 20:58:34', 0, 1002001015, '账号未登陆', '2019-06-06 20:58:34');
INSERT INTO `access_log` VALUES (31528, '65.49.15598259140230597', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.78.207.196', '2019-06-06 20:58:34', 1, 1002001015, '账号未登陆', '2019-06-06 20:58:34');
INSERT INTO `access_log` VALUES (31529, '59.79.15598297267980347', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:02:07', 11, 0, '', '2019-06-06 22:02:07');
INSERT INTO `access_log` VALUES (31530, '59.77.15598297268000337', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:02:07', 16, 2001001000, '服务端发生异常', '2019-06-06 22:02:07');
INSERT INTO `access_log` VALUES (31531, '64.83.15598297324920161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:02:12', 13, 0, '', '2019-06-06 22:02:13');
INSERT INTO `access_log` VALUES (31532, '64.77.15598297326180177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:02:13', 3, 0, '', '2019-06-06 22:02:13');
INSERT INTO `access_log` VALUES (31533, '64.85.15598297337850189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:02:14', 2, 0, '', '2019-06-06 22:02:14');
INSERT INTO `access_log` VALUES (31534, '64.78.15598297341830177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:02:14', 584, 0, '', '2019-06-06 22:02:15');
INSERT INTO `access_log` VALUES (31535, '64.81.15598297471380169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:02:27', 2, 0, '', '2019-06-06 22:02:27');
INSERT INTO `access_log` VALUES (31536, '64.76.15598297472330159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:02:27', 2, 0, '', '2019-06-06 22:02:27');
INSERT INTO `access_log` VALUES (31537, '65.47.15598298654660629', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:04:25', 1, 1002001015, '账号未登陆', '2019-06-06 22:04:25');
INSERT INTO `access_log` VALUES (31538, '65.52.15598298654650627', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:04:25', 1, 1002001015, '账号未登陆', '2019-06-06 22:04:25');
INSERT INTO `access_log` VALUES (31539, '65.51.15598298654660639', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:04:25', 1, 1002001015, '账号未登陆', '2019-06-06 22:04:25');
INSERT INTO `access_log` VALUES (31540, '65.49.15598298712340651', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:04:31', 83, 0, '', '2019-06-06 22:04:31');
INSERT INTO `access_log` VALUES (31541, '65.50.15598298716770621', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:04:32', 9, 0, '', '2019-06-06 22:04:32');
INSERT INTO `access_log` VALUES (31542, '65.54.15598298716820585', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:04:32', 9, 0, '', '2019-06-06 22:04:32');
INSERT INTO `access_log` VALUES (31543, '65.46.15598298716850627', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:04:32', 9, 0, '', '2019-06-06 22:04:32');
INSERT INTO `access_log` VALUES (31544, '65.3607.15598298880932391', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:04:48', 17, 0, '', '2019-06-06 22:04:48');
INSERT INTO `access_log` VALUES (31545, '62.83.15598299017050183', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:05:02', 22, 0, '', '2019-06-06 22:05:02');
INSERT INTO `access_log` VALUES (31546, '62.80.15598299190930189', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:05:19', 16, 0, '', '2019-06-06 22:05:19');
INSERT INTO `access_log` VALUES (31547, '64.83.15598299284720165', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:05:28', 9, 0, '', '2019-06-06 22:05:28');
INSERT INTO `access_log` VALUES (31548, '64.79.15598299284690169', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:05:28', 13, 0, '', '2019-06-06 22:05:28');
INSERT INTO `access_log` VALUES (31549, '64.78.15598299359600181', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:05:36', 11, 0, '', '2019-06-06 22:05:36');
INSERT INTO `access_log` VALUES (31550, '64.85.15598299359580193', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:05:36', 15, 0, '', '2019-06-06 22:05:36');
INSERT INTO `access_log` VALUES (31551, '64.84.15598299384140181', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:05:38', 12, 0, '', '2019-06-06 22:05:38');
INSERT INTO `access_log` VALUES (31552, '64.81.15598299393470173', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:05:39', 10, 0, '', '2019-06-06 22:05:39');
INSERT INTO `access_log` VALUES (31553, '64.76.15598299413680163', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:05:41', 9, 0, '', '2019-06-06 22:05:41');
INSERT INTO `access_log` VALUES (31554, '64.82.15598299424000187', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:05:42', 11, 0, '', '2019-06-06 22:05:42');
INSERT INTO `access_log` VALUES (31555, '64.80.15598299424020173', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:05:42', 8, 0, '', '2019-06-06 22:05:42');
INSERT INTO `access_log` VALUES (31556, '59.73.15598299559350353', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:05:56', 20, 2001001000, '服务端发生异常', '2019-06-06 22:05:56');
INSERT INTO `access_log` VALUES (31557, '59.73.15598299559350353', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:05:56', 20, 2001001000, '服务端发生异常', '2019-06-06 22:05:57');
INSERT INTO `access_log` VALUES (31558, '59.74.15598299562210347', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:05:56', 1309, 0, '', '2019-06-06 22:05:58');
INSERT INTO `access_log` VALUES (31559, '65.46.15598299698950629', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:06:10', 10, 0, '', '2019-06-06 22:06:10');
INSERT INTO `access_log` VALUES (31560, '65.54.15598299745540587', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.18.5', '2019-06-06 22:06:15', 14, 0, '', '2019-06-06 22:06:15');
INSERT INTO `access_log` VALUES (31561, '65.45.15598310790260659', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.198', '2019-06-06 22:24:39', 3, 1002001012, '访问令牌已过期', '2019-06-06 22:24:39');
INSERT INTO `access_log` VALUES (31562, '65.47.15598310790250647', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.198', '2019-06-06 22:24:39', 4, 1002001012, '访问令牌已过期', '2019-06-06 22:24:39');
INSERT INTO `access_log` VALUES (31563, '65.52.15598310790570647', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.198', '2019-06-06 22:24:39', 4, 1002001012, '访问令牌已过期', '2019-06-06 22:24:39');
INSERT INTO `access_log` VALUES (31564, '65.46.15598310959870645', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.198', '2019-06-06 22:24:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 22:24:56');
INSERT INTO `access_log` VALUES (31565, '65.50.15598311052120641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.198', '2019-06-06 22:25:05', 1675, 0, '', '2019-06-06 22:25:07');
INSERT INTO `access_log` VALUES (31566, '65.49.15598311073400669', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.198', '2019-06-06 22:25:07', 9, 0, '', '2019-06-06 22:25:07');
INSERT INTO `access_log` VALUES (31567, '65.54.15598311073400603', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.198', '2019-06-06 22:25:07', 10, 0, '', '2019-06-06 22:25:07');
INSERT INTO `access_log` VALUES (31568, '65.53.15598311073710625', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.198', '2019-06-06 22:25:07', 10, 0, '', '2019-06-06 22:25:07');
INSERT INTO `access_log` VALUES (31569, '65.52.15598311184880649', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.198', '2019-06-06 22:25:18', 19, 0, '', '2019-06-06 22:25:19');
INSERT INTO `access_log` VALUES (31570, '65.45.15598311197530661', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.198', '2019-06-06 22:25:20', 10, 0, '', '2019-06-06 22:25:20');
INSERT INTO `access_log` VALUES (31571, '65.47.15598311206200649', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.198', '2019-06-06 22:25:21', 1172, 0, '', '2019-06-06 22:25:22');
INSERT INTO `access_log` VALUES (31572, '65.51.15598311228890661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.198', '2019-06-06 22:25:23', 673, 0, '', '2019-06-06 22:25:24');
INSERT INTO `access_log` VALUES (31573, '65.47.15598312351730651', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:15', 1, 1002001015, '账号未登陆', '2019-06-06 22:27:15');
INSERT INTO `access_log` VALUES (31574, '65.51.15598312351840663', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:15', 1, 1002001015, '账号未登陆', '2019-06-06 22:27:15');
INSERT INTO `access_log` VALUES (31575, '65.46.15598312351900649', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:15', 0, 1002001015, '账号未登陆', '2019-06-06 22:27:15');
INSERT INTO `access_log` VALUES (31576, '65.50.15598312387040645', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:19', 390, 0, '', '2019-06-06 22:27:19');
INSERT INTO `access_log` VALUES (31577, '65.49.15598312393610673', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:19', 9, 0, '', '2019-06-06 22:27:19');
INSERT INTO `access_log` VALUES (31578, '65.53.15598312393660629', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:19', 9, 0, '', '2019-06-06 22:27:19');
INSERT INTO `access_log` VALUES (31579, '65.54.15598312393790607', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:19', 9, 0, '', '2019-06-06 22:27:19');
INSERT INTO `access_log` VALUES (31580, '62.87.15598312494140191', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:29', 217, 0, '', '2019-06-06 22:27:30');
INSERT INTO `access_log` VALUES (31581, '64.82.15598312667600205', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:47', 12, 0, '', '2019-06-06 22:27:47');
INSERT INTO `access_log` VALUES (31582, '64.80.15598312667590191', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:47', 13, 0, '', '2019-06-06 22:27:47');
INSERT INTO `access_log` VALUES (31583, '64.83.15598312690730185', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:49', 8, 0, '', '2019-06-06 22:27:49');
INSERT INTO `access_log` VALUES (31584, '64.79.15598312690730189', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:49', 10, 0, '', '2019-06-06 22:27:49');
INSERT INTO `access_log` VALUES (31585, '64.85.15598312725940213', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:53', 10, 0, '', '2019-06-06 22:27:53');
INSERT INTO `access_log` VALUES (31586, '64.78.15598312726230201', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:53', 8, 0, '', '2019-06-06 22:27:53');
INSERT INTO `access_log` VALUES (31587, '65.51.15598312793310665', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:27:59', 19, 0, '', '2019-06-06 22:27:59');
INSERT INTO `access_log` VALUES (31588, '65.47.15598312828600653', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:28:03', 12, 0, '', '2019-06-06 22:28:03');
INSERT INTO `access_log` VALUES (31589, '65.50.15598312917780647', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:28:12', 10, 0, '', '2019-06-06 22:28:12');
INSERT INTO `access_log` VALUES (31590, '65.49.15598313213460675', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:28:41', 15, 0, '', '2019-06-06 22:28:41');
INSERT INTO `access_log` VALUES (31591, '65.52.15598313476620655', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:29:08', 10, 0, '', '2019-06-06 22:29:08');
INSERT INTO `access_log` VALUES (31592, '65.45.15598313476660667', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:29:08', 8, 0, '', '2019-06-06 22:29:08');
INSERT INTO `access_log` VALUES (31593, '65.51.15598313476740667', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:29:08', 9, 0, '', '2019-06-06 22:29:08');
INSERT INTO `access_log` VALUES (31594, '65.46.15598313538860653', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:29:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 22:29:14');
INSERT INTO `access_log` VALUES (31595, '65.50.15598313599500649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:29:20', 80, 0, '', '2019-06-06 22:29:20');
INSERT INTO `access_log` VALUES (31596, '65.54.15598313603010611', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:29:20', 8, 0, '', '2019-06-06 22:29:20');
INSERT INTO `access_log` VALUES (31597, '65.53.15598313603000633', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:29:20', 12, 0, '', '2019-06-06 22:29:20');
INSERT INTO `access_log` VALUES (31598, '65.49.15598313603050677', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:29:20', 9, 0, '', '2019-06-06 22:29:20');
INSERT INTO `access_log` VALUES (31599, '59.75.15598313687600371', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:29:29', 13, 0, '', '2019-06-06 22:29:29');
INSERT INTO `access_log` VALUES (31600, '62.89.15598313763040205', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:29:36', 23, 0, '', '2019-06-06 22:29:36');
INSERT INTO `access_log` VALUES (31601, '65.51.15598313793240669', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:29:39', 10, 0, '', '2019-06-06 22:29:39');
INSERT INTO `access_log` VALUES (31602, '65.45.15598313855930669', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:29:46', 13, 0, '', '2019-06-06 22:29:46');
INSERT INTO `access_log` VALUES (31603, '65.46.15598313939710655', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:29:54', 9, 0, '', '2019-06-06 22:29:54');
INSERT INTO `access_log` VALUES (31604, '65.50.15598313959340651', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.122.144.30', '2019-06-06 22:29:56', 348, 0, '', '2019-06-06 22:29:56');
INSERT INTO `access_log` VALUES (31605, '65.53.15598323288820647', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:45:29', 0, 1002001015, '账号未登陆', '2019-06-06 22:45:29');
INSERT INTO `access_log` VALUES (31606, '65.52.15598323288830671', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:45:29', 1, 1002001015, '账号未登陆', '2019-06-06 22:45:29');
INSERT INTO `access_log` VALUES (31607, '65.3607.15598323288822433', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:45:29', 0, 1002001015, '账号未登陆', '2019-06-06 22:45:29');
INSERT INTO `access_log` VALUES (31608, '65.51.15598323341450683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:45:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 22:45:34');
INSERT INTO `access_log` VALUES (31609, '65.45.15598323372850683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:45:37', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-06 22:45:37');
INSERT INTO `access_log` VALUES (31610, '65.45.15598329188260691', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:55:19', 82, 0, '', '2019-06-06 22:55:19');
INSERT INTO `access_log` VALUES (31611, '65.47.15598329206420679', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:55:21', 9, 0, '', '2019-06-06 22:55:21');
INSERT INTO `access_log` VALUES (31612, '65.46.15598329206490677', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:55:21', 8, 0, '', '2019-06-06 22:55:21');
INSERT INTO `access_log` VALUES (31613, '65.50.15598329206520673', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:55:21', 8, 0, '', '2019-06-06 22:55:21');
INSERT INTO `access_log` VALUES (31614, '62.88.15598329253340233', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:55:25', 14, 0, '', '2019-06-06 22:55:25');
INSERT INTO `access_log` VALUES (31615, '65.49.15598329375170701', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '122.235.172.189', '2019-06-06 22:55:38', 314, 0, '', '2019-06-06 22:55:38');
INSERT INTO `access_log` VALUES (31616, '65.52.15598329375230681', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '122.235.172.189', '2019-06-06 22:55:38', 310, 0, '', '2019-06-06 22:55:38');
INSERT INTO `access_log` VALUES (31617, '65.53.15598329375190657', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '122.235.172.189', '2019-06-06 22:55:38', 313, 0, '', '2019-06-06 22:55:38');
INSERT INTO `access_log` VALUES (31618, '65.51.15598329428920693', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '122.235.172.189', '2019-06-06 22:55:43', 9, 0, '', '2019-06-06 22:55:43');
INSERT INTO `access_log` VALUES (31619, '65.50.15598329428930675', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '122.235.172.189', '2019-06-06 22:55:43', 10, 0, '', '2019-06-06 22:55:43');
INSERT INTO `access_log` VALUES (31620, '65.45.15598329428920693', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '122.235.172.189', '2019-06-06 22:55:43', 10, 0, '', '2019-06-06 22:55:43');
INSERT INTO `access_log` VALUES (31621, '64.76.15598329431760205', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '122.235.172.189', '2019-06-06 22:55:43', 10, 0, '', '2019-06-06 22:55:43');
INSERT INTO `access_log` VALUES (31622, '64.81.15598329431760215', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '122.235.172.189', '2019-06-06 22:55:43', 12, 0, '', '2019-06-06 22:55:43');
INSERT INTO `access_log` VALUES (31623, '65.46.15598329533890679', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '122.235.172.189', '2019-06-06 22:55:53', 10, 0, '', '2019-06-06 22:55:53');
INSERT INTO `access_log` VALUES (31624, '65.47.15598329533940681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '122.235.172.189', '2019-06-06 22:55:53', 15, 0, '', '2019-06-06 22:55:53');
INSERT INTO `access_log` VALUES (31625, '65.54.15598329533970637', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '122.235.172.189', '2019-06-06 22:55:53', 16, 0, '', '2019-06-06 22:55:53');
INSERT INTO `access_log` VALUES (31626, '66.56.15598329535508911', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '122.235.172.189', '2019-06-06 22:55:54', 19, 0, '', '2019-06-06 22:55:54');
INSERT INTO `access_log` VALUES (31627, '65.53.15598329647410659', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:56:05', 18, 0, '', '2019-06-06 22:56:05');
INSERT INTO `access_log` VALUES (31628, '65.52.15598329664140683', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:56:06', 10, 0, '', '2019-06-06 22:56:06');
INSERT INTO `access_log` VALUES (31629, '65.51.15598329747500695', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:56:15', 15, 0, '', '2019-06-06 22:56:15');
INSERT INTO `access_log` VALUES (31630, '65.50.15598329886790677', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:56:29', 14, 0, '', '2019-06-06 22:56:29');
INSERT INTO `access_log` VALUES (31631, '65.54.15598329888550639', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:56:29', 9, 0, '', '2019-06-06 22:56:29');
INSERT INTO `access_log` VALUES (31632, '65.46.15598329889840681', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:56:29', 19, 0, '', '2019-06-06 22:56:29');
INSERT INTO `access_log` VALUES (31633, '66.51.15598329891578917', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:56:29', 12, 0, '', '2019-06-06 22:56:29');
INSERT INTO `access_log` VALUES (31634, '64.79.15598329902420213', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:56:30', 11, 0, '', '2019-06-06 22:56:30');
INSERT INTO `access_log` VALUES (31635, '64.77.15598329902470225', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.235.172.189', '2019-06-06 22:56:30', 9, 0, '', '2019-06-06 22:56:30');
INSERT INTO `access_log` VALUES (31636, '59.78.15598338472460407', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:10:47', 10, 0, '', '2019-06-06 23:10:47');
INSERT INTO `access_log` VALUES (31637, '59.79.15598338472460403', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:10:47', 13, 2001001000, '服务端发生异常', '2019-06-06 23:10:47');
INSERT INTO `access_log` VALUES (31638, '64.83.15598338496730221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:10:50', 52, 0, '', '2019-06-06 23:10:50');
INSERT INTO `access_log` VALUES (31639, '64.79.15598338499530225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:10:50', 2, 0, '', '2019-06-06 23:10:50');
INSERT INTO `access_log` VALUES (31640, '64.85.15598338545660249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:10:55', 1, 0, '', '2019-06-06 23:10:55');
INSERT INTO `access_log` VALUES (31641, '64.78.15598338547690237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:10:55', 2, 0, '', '2019-06-06 23:10:55');
INSERT INTO `access_log` VALUES (31642, '59.71.15598338583610407', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:10:58', 4, 0, '', '2019-06-06 23:10:58');
INSERT INTO `access_log` VALUES (31643, '59.75.15598338583610405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:10:58', 14, 2001001000, '服务端发生异常', '2019-06-06 23:10:58');
INSERT INTO `access_log` VALUES (31644, '64.84.15598338605330237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:01', 405, 0, '', '2019-06-06 23:11:01');
INSERT INTO `access_log` VALUES (31645, '64.81.15598338611570229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:01', 2, 0, '', '2019-06-06 23:11:01');
INSERT INTO `access_log` VALUES (31646, '64.76.15598338622400219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:02', 2, 0, '', '2019-06-06 23:11:02');
INSERT INTO `access_log` VALUES (31647, '64.82.15598338630730243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:03', 2, 0, '', '2019-06-06 23:11:03');
INSERT INTO `access_log` VALUES (31648, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:03', 15, 0, '', '2019-06-06 23:11:03');
INSERT INTO `access_log` VALUES (31649, '64.80.15598338642800229', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:04', 7, 0, '', '2019-06-06 23:11:04');
INSERT INTO `access_log` VALUES (31650, '64.79.15598338699650227', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:10', 7, 0, '', '2019-06-06 23:11:10');
INSERT INTO `access_log` VALUES (31651, '64.77.15598338710420239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:11', 2, 0, '', '2019-06-06 23:11:11');
INSERT INTO `access_log` VALUES (31652, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:11', 6, 0, '', '2019-06-06 23:11:11');
INSERT INTO `access_log` VALUES (31653, '64.85.15598338714700251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:11', 2, 0, '', '2019-06-06 23:11:11');
INSERT INTO `access_log` VALUES (31654, '64.78.15598338717150239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:12', 2, 0, '', '2019-06-06 23:11:12');
INSERT INTO `access_log` VALUES (31655, '59.72.15598338719150403', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:12', 3, 0, '', '2019-06-06 23:11:12');
INSERT INTO `access_log` VALUES (31656, '59.80.15598338719250395', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:12', 13, 2001001000, '服务端发生异常', '2019-06-06 23:11:12');
INSERT INTO `access_log` VALUES (31657, '64.84.15598338735590239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:14', 2, 0, '', '2019-06-06 23:11:14');
INSERT INTO `access_log` VALUES (31658, '64.81.15598338738030231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:14', 2, 0, '', '2019-06-06 23:11:14');
INSERT INTO `access_log` VALUES (31659, '59.74.15598338750090401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:15', 19, 2001001000, '服务端发生异常', '2019-06-06 23:11:15');
INSERT INTO `access_log` VALUES (31660, '59.73.15598338749950407', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.171.137', '2019-06-06 23:11:15', 241, 0, '', '2019-06-06 23:11:15');
INSERT INTO `access_log` VALUES (31661, '59.77.15598353897820415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.14.135.101', '2019-06-06 23:36:30', 20, 2001001000, '服务端发生异常', '2019-06-06 23:36:30');
INSERT INTO `access_log` VALUES (31662, '59.78.15598353897810429', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.14.135.101', '2019-06-06 23:36:30', 143, 0, '', '2019-06-06 23:36:30');
INSERT INTO `access_log` VALUES (31663, '59.75.15598354006870427', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '183.14.135.101', '2019-06-06 23:36:41', 2, 0, '', '2019-06-06 23:36:41');
INSERT INTO `access_log` VALUES (31664, '59.76.15598354006870417', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '183.14.135.101', '2019-06-06 23:36:41', 12, 2001001000, '服务端发生异常', '2019-06-06 23:36:41');
INSERT INTO `access_log` VALUES (31665, '64.80.15598354090760251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '183.14.135.101', '2019-06-06 23:36:49', 2, 0, '', '2019-06-06 23:36:49');
INSERT INTO `access_log` VALUES (31666, '64.83.15598354091730245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '183.14.135.101', '2019-06-06 23:36:49', 2, 0, '', '2019-06-06 23:36:49');
INSERT INTO `access_log` VALUES (31667, '64.77.15598354105960261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '183.14.135.101', '2019-06-06 23:36:51', 2, 0, '', '2019-06-06 23:36:51');
INSERT INTO `access_log` VALUES (31668, '64.85.15598354111000273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '183.14.135.101', '2019-06-06 23:36:51', 1, 0, '', '2019-06-06 23:36:51');
INSERT INTO `access_log` VALUES (31669, '64.78.15598354118280261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '183.14.135.101', '2019-06-06 23:36:52', 2, 0, '', '2019-06-06 23:36:52');
INSERT INTO `access_log` VALUES (31670, '64.84.15598354123560261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '183.14.135.101', '2019-06-06 23:36:52', 2, 0, '', '2019-06-06 23:36:52');
INSERT INTO `access_log` VALUES (31671, '59.80.15598354132740417', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '183.14.135.101', '2019-06-06 23:36:53', 3, 0, '', '2019-06-06 23:36:53');
INSERT INTO `access_log` VALUES (31672, '59.73.15598354132750429', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '183.14.135.101', '2019-06-06 23:36:53', 13, 2001001000, '服务端发生异常', '2019-06-06 23:36:53');
INSERT INTO `access_log` VALUES (31673, '59.77.15598354492300417', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.129.6.159', '2019-06-06 23:37:29', 2, 0, '', '2019-06-06 23:37:29');
INSERT INTO `access_log` VALUES (31674, '64.80.15598354691300253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.129.8.179', '2019-06-06 23:37:49', 2, 0, '', '2019-06-06 23:37:49');
INSERT INTO `access_log` VALUES (31675, '64.83.15598354701130247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.129.6.147', '2019-06-06 23:37:50', 2, 0, '', '2019-06-06 23:37:50');
INSERT INTO `access_log` VALUES (31676, '64.77.15598354710920263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.89.239.120', '2019-06-06 23:37:51', 1, 0, '', '2019-06-06 23:37:51');
INSERT INTO `access_log` VALUES (31677, '65.46.15598719700401201', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:46:10', 1, 1002001015, '账号未登陆', '2019-06-07 09:46:10');
INSERT INTO `access_log` VALUES (31678, '65.47.15598719700411203', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:46:10', 0, 1002001015, '账号未登陆', '2019-06-07 09:46:10');
INSERT INTO `access_log` VALUES (31679, '65.49.15598719700431225', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:46:10', 0, 1002001015, '账号未登陆', '2019-06-07 09:46:10');
INSERT INTO `access_log` VALUES (31680, '65.52.15598719849821205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:46:25', 1337, 0, '', '2019-06-07 09:46:26');
INSERT INTO `access_log` VALUES (31681, '65.3607.15598719867222967', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:46:27', 14, 0, '', '2019-06-07 09:46:27');
INSERT INTO `access_log` VALUES (31682, '65.51.15598719867221217', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:46:27', 13, 0, '', '2019-06-07 09:46:27');
INSERT INTO `access_log` VALUES (31683, '65.45.15598719867231217', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:46:27', 13, 0, '', '2019-06-07 09:46:27');
INSERT INTO `access_log` VALUES (31684, '62.86.15598719940410735', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:46:34', 21, 0, '', '2019-06-07 09:46:34');
INSERT INTO `access_log` VALUES (31685, '64.80.15598720045330741', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:46:45', 16, 0, '', '2019-06-07 09:46:45');
INSERT INTO `access_log` VALUES (31686, '64.82.15598720045330755', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:46:45', 18, 0, '', '2019-06-07 09:46:45');
INSERT INTO `access_log` VALUES (31687, '65.46.15598720217011203', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:47:02', 3, 0, '', '2019-06-07 09:47:02');
INSERT INTO `access_log` VALUES (31688, '64.77.15598720341220751', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:47:14', 18, 0, '', '2019-06-07 09:47:14');
INSERT INTO `access_log` VALUES (31689, '64.85.15598720341220763', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:47:14', 18, 0, '', '2019-06-07 09:47:14');
INSERT INTO `access_log` VALUES (31690, '64.84.15598720447310751', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:47:25', 34, 0, '', '2019-06-07 09:47:25');
INSERT INTO `access_log` VALUES (31691, '64.81.15598720447310743', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:47:25', 37, 0, '', '2019-06-07 09:47:25');
INSERT INTO `access_log` VALUES (31692, '64.76.15598720447310733', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:47:25', 40, 0, '', '2019-06-07 09:47:25');
INSERT INTO `access_log` VALUES (31693, '64.80.15598720511020743', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:47:31', 10, 0, '', '2019-06-07 09:47:31');
INSERT INTO `access_log` VALUES (31694, '64.82.15598720511020757', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:47:31', 11, 0, '', '2019-06-07 09:47:31');
INSERT INTO `access_log` VALUES (31695, '66.50.15598720542429435', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:47:34', 21, 0, '', '2019-06-07 09:47:34');
INSERT INTO `access_log` VALUES (31696, '59.71.15598720654010919', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:47:45', 19, 0, '', '2019-06-07 09:47:45');
INSERT INTO `access_log` VALUES (31697, '59.76.15598720714610907', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:47:51', 25, 2001001000, '服务端发生异常', '2019-06-07 09:47:51');
INSERT INTO `access_log` VALUES (31698, '59.72.15598720755330915', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:47:56', 101, 0, '', '2019-06-07 09:47:56');
INSERT INTO `access_log` VALUES (31699, '59.73.15598720798010919', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:48:00', 12, 0, '', '2019-06-07 09:48:00');
INSERT INTO `access_log` VALUES (31700, '59.74.15598720915600913', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:48:12', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-07 09:48:12');
INSERT INTO `access_log` VALUES (31701, '59.77.15598721047930907', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:48:25', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-07 09:48:25');
INSERT INTO `access_log` VALUES (31702, '59.78.15598721049530921', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:48:25', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-07 09:48:25');
INSERT INTO `access_log` VALUES (31703, '59.71.15598721051530921', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:48:25', 129, 0, '', '2019-06-07 09:48:25');
INSERT INTO `access_log` VALUES (31704, '59.75.15598721053330919', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:48:25', 11, 0, '', '2019-06-07 09:48:25');
INSERT INTO `access_log` VALUES (31705, '59.76.15598721055220909', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:48:26', 22, 2001001000, '服务端发生异常', '2019-06-07 09:48:26');
INSERT INTO `access_log` VALUES (31706, '59.72.15598721057340917', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:48:26', 13, 0, '', '2019-06-07 09:48:26');
INSERT INTO `access_log` VALUES (31707, '66.51.15598721061739439', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:48:26', 13, 0, '', '2019-06-07 09:48:26');
INSERT INTO `access_log` VALUES (31708, '64.84.15598721068220753', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:48:27', 9, 0, '', '2019-06-07 09:48:27');
INSERT INTO `access_log` VALUES (31709, '64.78.15598721068220753', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:48:27', 10, 0, '', '2019-06-07 09:48:27');
INSERT INTO `access_log` VALUES (31710, '62.85.15598721071710749', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.224.69.13', '2019-06-07 09:48:27', 12, 0, '', '2019-06-07 09:48:27');
INSERT INTO `access_log` VALUES (31711, '65.46.15598721570381205', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '117.11.233.221', '2019-06-07 09:49:17', 0, 1002001015, '账号未登陆', '2019-06-07 09:49:17');
INSERT INTO `access_log` VALUES (31712, '65.47.15598721570401207', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '117.11.233.221', '2019-06-07 09:49:17', 1, 1002001015, '账号未登陆', '2019-06-07 09:49:17');
INSERT INTO `access_log` VALUES (31713, '65.49.15598721570441229', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '117.11.233.221', '2019-06-07 09:49:17', 1, 1002001015, '账号未登陆', '2019-06-07 09:49:17');
INSERT INTO `access_log` VALUES (31714, '65.52.15598721665561209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '117.11.233.221', '2019-06-07 09:49:27', 80, 0, '', '2019-06-07 09:49:27');
INSERT INTO `access_log` VALUES (31715, '65.45.15598721669211221', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '117.11.233.221', '2019-06-07 09:49:27', 166, 0, '', '2019-06-07 09:49:27');
INSERT INTO `access_log` VALUES (31716, '65.3607.15598721669232971', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '117.11.233.221', '2019-06-07 09:49:27', 165, 0, '', '2019-06-07 09:49:27');
INSERT INTO `access_log` VALUES (31717, '65.51.15598721669281221', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '117.11.233.221', '2019-06-07 09:49:27', 166, 0, '', '2019-06-07 09:49:27');
INSERT INTO `access_log` VALUES (31718, '62.86.15598721711340739', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '117.11.233.221', '2019-06-07 09:49:31', 14, 0, '', '2019-06-07 09:49:31');
INSERT INTO `access_log` VALUES (31719, '64.85.15598721780310767', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '117.11.233.221', '2019-06-07 09:49:38', 10, 0, '', '2019-06-07 09:49:38');
INSERT INTO `access_log` VALUES (31720, '64.79.15598721780310743', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '117.11.233.221', '2019-06-07 09:49:38', 11, 0, '', '2019-06-07 09:49:38');
INSERT INTO `access_log` VALUES (31721, '64.78.15598722193230755', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '117.11.233.221', '2019-06-07 09:50:19', 9, 0, '', '2019-06-07 09:50:19');
INSERT INTO `access_log` VALUES (31722, '59.76.15598722249340911', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '117.11.233.221', '2019-06-07 09:50:25', 11, 0, '', '2019-06-07 09:50:25');
INSERT INTO `access_log` VALUES (31723, '59.72.15598722264100919', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.112.214.144', '2019-06-07 09:50:26', 3, 0, '', '2019-06-07 09:50:26');
INSERT INTO `access_log` VALUES (31724, '59.73.15598722264100923', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.112.214.144', '2019-06-07 09:50:26', 19, 2001001000, '服务端发生异常', '2019-06-07 09:50:26');
INSERT INTO `access_log` VALUES (31725, '64.81.15598722299920747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.112.214.144', '2019-06-07 09:50:30', 2, 0, '', '2019-06-07 09:50:30');
INSERT INTO `access_log` VALUES (31726, '64.82.15598722301190761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.112.214.144', '2019-06-07 09:50:30', 1, 0, '', '2019-06-07 09:50:30');
INSERT INTO `access_log` VALUES (31727, '65.49.15598722311211231', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '117.11.233.221', '2019-06-07 09:50:31', 16, 0, '', '2019-06-07 09:50:31');
INSERT INTO `access_log` VALUES (31728, '64.80.15598722327650747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.112.214.144', '2019-06-07 09:50:33', 2, 0, '', '2019-06-07 09:50:33');
INSERT INTO `access_log` VALUES (31729, '64.83.15598722329310741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.112.214.144', '2019-06-07 09:50:33', 2, 0, '', '2019-06-07 09:50:33');
INSERT INTO `access_log` VALUES (31730, '65.3607.15598722586462973', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '117.11.233.221', '2019-06-07 09:50:59', 10, 0, '', '2019-06-07 09:50:59');
INSERT INTO `access_log` VALUES (31731, '65.54.15598748578221201', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.110.179.35', '2019-06-07 10:34:18', 13, 1002001012, '访问令牌已过期', '2019-06-07 10:34:18');
INSERT INTO `access_log` VALUES (31732, '65.46.15598748578221243', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.110.179.35', '2019-06-07 10:34:18', 15, 1002001012, '访问令牌已过期', '2019-06-07 10:34:18');
INSERT INTO `access_log` VALUES (31733, '65.47.15598748578531245', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.110.179.35', '2019-06-07 10:34:18', 13, 1002001012, '访问令牌已过期', '2019-06-07 10:34:18');
INSERT INTO `access_log` VALUES (31734, '65.53.15598748724811223', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.110.179.35', '2019-06-07 10:34:32', 384, 0, '', '2019-06-07 10:34:33');
INSERT INTO `access_log` VALUES (31735, '65.52.15598748734831247', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.110.179.35', '2019-06-07 10:34:33', 10, 0, '', '2019-06-07 10:34:33');
INSERT INTO `access_log` VALUES (31736, '65.3607.15598748734963009', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.110.179.35', '2019-06-07 10:34:33', 9, 0, '', '2019-06-07 10:34:34');
INSERT INTO `access_log` VALUES (31737, '65.51.15598748735071259', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.110.179.35', '2019-06-07 10:34:34', 9, 0, '', '2019-06-07 10:34:34');
INSERT INTO `access_log` VALUES (31738, '65.50.15598748939221241', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.110.179.35', '2019-06-07 10:34:54', 245, 0, '', '2019-06-07 10:34:54');
INSERT INTO `access_log` VALUES (31739, '65.46.15598751488991249', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.118.201.21', '2019-06-07 10:39:09', 0, 1002001015, '账号未登陆', '2019-06-07 10:39:09');
INSERT INTO `access_log` VALUES (31740, '59.80.15598785269590995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.109.22.191', '2019-06-07 11:35:27', 11, 0, '', '2019-06-07 11:35:27');
INSERT INTO `access_log` VALUES (31741, '59.74.15598785269601001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.109.22.191', '2019-06-07 11:35:27', 17, 2001001000, '服务端发生异常', '2019-06-07 11:35:27');
INSERT INTO `access_log` VALUES (31742, '64.85.15598785305400853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.109.22.191', '2019-06-07 11:35:31', 10, 0, '', '2019-06-07 11:35:31');
INSERT INTO `access_log` VALUES (31743, '64.79.15598785307180829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.109.22.191', '2019-06-07 11:35:31', 2, 0, '', '2019-06-07 11:35:31');
INSERT INTO `access_log` VALUES (31744, '64.77.15598785320280841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.109.22.191', '2019-06-07 11:35:32', 2, 0, '', '2019-06-07 11:35:32');
INSERT INTO `access_log` VALUES (31745, '64.84.15598785326700841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.109.22.191', '2019-06-07 11:35:33', 2, 0, '', '2019-06-07 11:35:33');
INSERT INTO `access_log` VALUES (31746, '64.78.15598785334570841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.109.22.191', '2019-06-07 11:35:33', 2, 0, '', '2019-06-07 11:35:33');
INSERT INTO `access_log` VALUES (31747, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=手表&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.109.22.191', '2019-06-07 11:35:38', 18, 0, '', '2019-06-07 11:35:38');
INSERT INTO `access_log` VALUES (31748, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=手表', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.109.22.191', '2019-06-07 11:35:38', 7, 0, '', '2019-06-07 11:35:38');
INSERT INTO `access_log` VALUES (31749, '64.81.15598785426600833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.109.22.191', '2019-06-07 11:35:43', 2, 0, '', '2019-06-07 11:35:43');
INSERT INTO `access_log` VALUES (31750, '64.82.15598785427530847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.109.22.191', '2019-06-07 11:35:43', 1, 0, '', '2019-06-07 11:35:43');
INSERT INTO `access_log` VALUES (31751, '59.77.15598785449300995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.109.22.191', '2019-06-07 11:35:45', 3, 0, '', '2019-06-07 11:35:45');
INSERT INTO `access_log` VALUES (31752, '59.78.15598785449311009', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.109.22.191', '2019-06-07 11:35:45', 13, 2001001000, '服务端发生异常', '2019-06-07 11:35:45');
INSERT INTO `access_log` VALUES (31753, '64.83.15598785590360827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.109.22.191', '2019-06-07 11:35:59', 2, 0, '', '2019-06-07 11:35:59');
INSERT INTO `access_log` VALUES (31754, '64.85.15598785591310855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.109.22.191', '2019-06-07 11:35:59', 2, 0, '', '2019-06-07 11:35:59');
INSERT INTO `access_log` VALUES (31755, '64.79.15598785603680831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.109.22.191', '2019-06-07 11:36:00', 2, 0, '', '2019-06-07 11:36:00');
INSERT INTO `access_log` VALUES (31756, '64.77.15598785608570843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.109.22.191', '2019-06-07 11:36:01', 2, 0, '', '2019-06-07 11:36:01');
INSERT INTO `access_log` VALUES (31757, '64.84.15598785617060843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.109.22.191', '2019-06-07 11:36:02', 1, 0, '', '2019-06-07 11:36:02');
INSERT INTO `access_log` VALUES (31758, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=小米&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.109.22.191', '2019-06-07 11:36:05', 7, 0, '', '2019-06-07 11:36:05');
INSERT INTO `access_log` VALUES (31759, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=小米', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.109.22.191', '2019-06-07 11:36:05', 18, 0, '', '2019-06-07 11:36:05');
INSERT INTO `access_log` VALUES (31760, '64.76.15598785667650825', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.109.22.191', '2019-06-07 11:36:07', 8, 0, '', '2019-06-07 11:36:07');
INSERT INTO `access_log` VALUES (31761, '66.48.15598785892779531', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18551822931', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.109.22.191', '2019-06-07 11:36:29', 71, 0, '', '2019-06-07 11:36:29');
INSERT INTO `access_log` VALUES (31762, '59.79.15598793880201017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; Redmi Note 5 Build/PKQ1.180904.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 V1_AND_SQ_7.1.0_0_TIM_D TIM/2.3.1.1834 QQ/6.5.5  NetType/4G WebP/0.3.0 Pixel/1080', '114.87.92.21', '2019-06-07 11:49:48', 3, 0, '', '2019-06-07 11:49:48');
INSERT INTO `access_log` VALUES (31763, '59.74.15598793880201013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; Redmi Note 5 Build/PKQ1.180904.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 V1_AND_SQ_7.1.0_0_TIM_D TIM/2.3.1.1834 QQ/6.5.5  NetType/4G WebP/0.3.0 Pixel/1080', '114.87.92.21', '2019-06-07 11:49:48', 14, 2001001000, '服务端发生异常', '2019-06-07 11:49:48');
INSERT INTO `access_log` VALUES (31764, '64.79.15598793918370843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; Redmi Note 5 Build/PKQ1.180904.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 V1_AND_SQ_7.1.0_0_TIM_D TIM/2.3.1.1834 QQ/6.5.5  NetType/4G WebP/0.3.0 Pixel/1080', '114.87.92.21', '2019-06-07 11:49:52', 82, 0, '', '2019-06-07 11:49:52');
INSERT INTO `access_log` VALUES (31765, '64.77.15598793921410855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; Redmi Note 5 Build/PKQ1.180904.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 V1_AND_SQ_7.1.0_0_TIM_D TIM/2.3.1.1834 QQ/6.5.5  NetType/4G WebP/0.3.0 Pixel/1080', '114.87.92.21', '2019-06-07 11:49:52', 2, 0, '', '2019-06-07 11:49:52');
INSERT INTO `access_log` VALUES (31766, '64.84.15598793943170855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; Redmi Note 5 Build/PKQ1.180904.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 V1_AND_SQ_7.1.0_0_TIM_D TIM/2.3.1.1834 QQ/6.5.5  NetType/4G WebP/0.3.0 Pixel/1080', '114.87.92.21', '2019-06-07 11:49:54', 2, 0, '', '2019-06-07 11:49:54');
INSERT INTO `access_log` VALUES (31767, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; Redmi Note 5 Build/PKQ1.180904.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 V1_AND_SQ_7.1.0_0_TIM_D TIM/2.3.1.1834 QQ/6.5.5  NetType/4G WebP/0.3.0 Pixel/1080', '114.87.92.21', '2019-06-07 11:49:54', 8, 0, '', '2019-06-07 11:49:54');
INSERT INTO `access_log` VALUES (31768, '64.78.15598793959800855', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; Redmi Note 5 Build/PKQ1.180904.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 V1_AND_SQ_7.1.0_0_TIM_D TIM/2.3.1.1834 QQ/6.5.5  NetType/4G WebP/0.3.0 Pixel/1080', '114.87.92.21', '2019-06-07 11:49:56', 7, 0, '', '2019-06-07 11:49:56');
INSERT INTO `access_log` VALUES (31769, '65.51.15598793971141319', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:49:57', 1, 1002001015, '账号未登陆', '2019-06-07 11:49:57');
INSERT INTO `access_log` VALUES (31770, '65.45.15598793971141321', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:49:57', 1, 1002001015, '账号未登陆', '2019-06-07 11:49:57');
INSERT INTO `access_log` VALUES (31771, '65.54.15598793971141265', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:49:57', 0, 1002001015, '账号未登陆', '2019-06-07 11:49:57');
INSERT INTO `access_log` VALUES (31772, '65.46.15598794056391307', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:50:06', 102, 0, '', '2019-06-07 11:50:06');
INSERT INTO `access_log` VALUES (31773, '65.50.15598794066001303', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:50:07', 11, 0, '', '2019-06-07 11:50:07');
INSERT INTO `access_log` VALUES (31774, '65.49.15598794066051333', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:50:07', 9, 0, '', '2019-06-07 11:50:07');
INSERT INTO `access_log` VALUES (31775, '65.53.15598794066141287', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:50:07', 9, 0, '', '2019-06-07 11:50:07');
INSERT INTO `access_log` VALUES (31776, '64.81.15598794088280847', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; Redmi Note 5 Build/PKQ1.180904.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 V1_AND_SQ_7.1.0_0_TIM_D TIM/2.3.1.1834 QQ/6.5.5  NetType/4G WebP/0.3.0 Pixel/1080', '114.87.92.21', '2019-06-07 11:50:09', 1195, 0, '', '2019-06-07 11:50:10');
INSERT INTO `access_log` VALUES (31777, '62.85.15598794143000845', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:50:14', 22, 0, '', '2019-06-07 11:50:14');
INSERT INTO `access_log` VALUES (31778, '62.87.15598794190860841', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:50:19', 17, 0, '', '2019-06-07 11:50:19');
INSERT INTO `access_log` VALUES (31779, '59.75.15598794266021019', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:50:27', 10, 0, '', '2019-06-07 11:50:27');
INSERT INTO `access_log` VALUES (31780, '59.76.15598794285601009', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:50:29', 12, 0, '', '2019-06-07 11:50:29');
INSERT INTO `access_log` VALUES (31781, '59.73.15598794461701021', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:50:46', 12, 0, '', '2019-06-07 11:50:46');
INSERT INTO `access_log` VALUES (31782, '59.79.15598794562711019', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:50:56', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-07 11:50:56');
INSERT INTO `access_log` VALUES (31783, '59.78.15598794815801023', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:51:22', 296, 0, '', '2019-06-07 11:51:22');
INSERT INTO `access_log` VALUES (31784, '59.71.15598794831991023', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:51:23', 15, 0, '', '2019-06-07 11:51:23');
INSERT INTO `access_log` VALUES (31785, '59.75.15598794832101021', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:51:23', 10, 0, '', '2019-06-07 11:51:23');
INSERT INTO `access_log` VALUES (31786, '62.83.15598794834660853', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:51:23', 99, 0, '', '2019-06-07 11:51:24');
INSERT INTO `access_log` VALUES (31787, '62.88.15598794845680861', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '14.24.165.246', '2019-06-07 11:51:25', 35, 0, '', '2019-06-07 11:51:25');
INSERT INTO `access_log` VALUES (31788, '59.74.15598854129801095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:13', 12, 0, '', '2019-06-07 13:30:13');
INSERT INTO `access_log` VALUES (31789, '59.77.15598854129841089', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:13', 16, 2001001000, '服务端发生异常', '2019-06-07 13:30:13');
INSERT INTO `access_log` VALUES (31790, '64.82.15598854165890941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:17', 9, 0, '', '2019-06-07 13:30:17');
INSERT INTO `access_log` VALUES (31791, '64.80.15598854168050927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:17', 3, 0, '', '2019-06-07 13:30:17');
INSERT INTO `access_log` VALUES (31792, '59.78.15598854173821103', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:17', 4, 0, '', '2019-06-07 13:30:17');
INSERT INTO `access_log` VALUES (31793, '59.75.15598854173821101', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:17', 13, 2001001000, '服务端发生异常', '2019-06-07 13:30:17');
INSERT INTO `access_log` VALUES (31794, '65.3607.15598854277973153', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:28', 1, 1002001015, '账号未登陆', '2019-06-07 13:30:28');
INSERT INTO `access_log` VALUES (31795, '65.51.15598854277971401', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:28', 1, 1002001015, '账号未登陆', '2019-06-07 13:30:28');
INSERT INTO `access_log` VALUES (31796, '65.45.15598854278081403', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:28', 0, 1002001015, '账号未登陆', '2019-06-07 13:30:28');
INSERT INTO `access_log` VALUES (31797, '65.54.15598854298001347', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 13:30:30');
INSERT INTO `access_log` VALUES (31798, '65.46.15598854370531389', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:37', 81, 0, '', '2019-06-07 13:30:37');
INSERT INTO `access_log` VALUES (31799, '65.50.15598854374461385', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:37', 13, 0, '', '2019-06-07 13:30:37');
INSERT INTO `access_log` VALUES (31800, '65.49.15598854374461415', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:37', 14, 0, '', '2019-06-07 13:30:37');
INSERT INTO `access_log` VALUES (31801, '65.53.15598854374501369', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:37', 11, 0, '', '2019-06-07 13:30:37');
INSERT INTO `access_log` VALUES (31802, '62.84.15598854421640921', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:42', 20, 0, '', '2019-06-07 13:30:42');
INSERT INTO `access_log` VALUES (31803, '65.47.15598854515291393', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:52', 155, 0, '', '2019-06-07 13:30:52');
INSERT INTO `access_log` VALUES (31804, '65.51.15598854529171403', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:53', 10, 0, '', '2019-06-07 13:30:53');
INSERT INTO `access_log` VALUES (31805, '65.45.15598854540211405', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:54', 9, 0, '', '2019-06-07 13:30:54');
INSERT INTO `access_log` VALUES (31806, '65.54.15598854545521349', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:55', 13, 0, '', '2019-06-07 13:30:55');
INSERT INTO `access_log` VALUES (31807, '65.46.15598854562341391', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:56', 9, 0, '', '2019-06-07 13:30:56');
INSERT INTO `access_log` VALUES (31808, '65.53.15598854571711371', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:30:57', 14, 0, '', '2019-06-07 13:30:57');
INSERT INTO `access_log` VALUES (31809, '66.51.15598865649339633', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13902223331&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:25', 16, 1001003000, '验证码不存在', '2019-06-07 13:49:25');
INSERT INTO `access_log` VALUES (31810, '66.53.15598865679959631', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13902223331', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:28', 49, 0, '', '2019-06-07 13:49:28');
INSERT INTO `access_log` VALUES (31811, '66.54.15598865700789637', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13902223331&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:30', 230, 0, '', '2019-06-07 13:49:30');
INSERT INTO `access_log` VALUES (31812, '59.71.15598865764141119', 111, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:36', 7, 0, '', '2019-06-07 13:49:36');
INSERT INTO `access_log` VALUES (31813, '59.76.15598865764621107', 111, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:36', 16, 2001001000, '服务端发生异常', '2019-06-07 13:49:36');
INSERT INTO `access_log` VALUES (31814, '64.80.15598865787110943', 111, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:39', 198, 0, '', '2019-06-07 13:49:39');
INSERT INTO `access_log` VALUES (31815, '64.85.15598865791050965', 111, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:39', 4, 0, '', '2019-06-07 13:49:39');
INSERT INTO `access_log` VALUES (31816, '64.77.15598865803080953', 111, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:40', 133, 0, '', '2019-06-07 13:49:40');
INSERT INTO `access_log` VALUES (31817, '64.78.15598865808510953', 111, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:41', 5, 0, '', '2019-06-07 13:49:41');
INSERT INTO `access_log` VALUES (31818, '64.76.15598865832020935', 111, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:43', 5, 0, '', '2019-06-07 13:49:43');
INSERT INTO `access_log` VALUES (31819, '64.81.15598865833080945', 111, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:43', 4, 0, '', '2019-06-07 13:49:43');
INSERT INTO `access_log` VALUES (31820, '66.52.15598865844389637', 111, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:44', 7, 0, '', '2019-06-07 13:49:44');
INSERT INTO `access_log` VALUES (31821, '59.72.15598865877491115', 111, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:48', 5, 0, '', '2019-06-07 13:49:48');
INSERT INTO `access_log` VALUES (31822, '59.73.15598865877501119', 111, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:48', 14, 2001001000, '服务端发生异常', '2019-06-07 13:49:48');
INSERT INTO `access_log` VALUES (31823, '62.89.15598865978700949', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:49:58', 21, 0, '', '2019-06-07 13:49:58');
INSERT INTO `access_log` VALUES (31824, '62.86.15598866004300933', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 13:50:00', 15, 0, '', '2019-06-07 13:50:00');
INSERT INTO `access_log` VALUES (31825, '65.52.15598874425571423', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '103.90.92.64', '2019-06-07 14:04:03', 4, 1002001012, '访问令牌已过期', '2019-06-07 14:04:03');
INSERT INTO `access_log` VALUES (31826, '65.51.15598874425581431', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '103.90.92.64', '2019-06-07 14:04:03', 5, 1002001012, '访问令牌已过期', '2019-06-07 14:04:03');
INSERT INTO `access_log` VALUES (31827, '65.47.15598874425581421', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '103.90.92.64', '2019-06-07 14:04:03', 5, 1002001012, '访问令牌已过期', '2019-06-07 14:04:03');
INSERT INTO `access_log` VALUES (31828, '65.3607.15598874469263183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.239.251.83', '2019-06-07 14:04:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 14:04:07');
INSERT INTO `access_log` VALUES (31829, '65.54.15598874631281377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '103.90.92.64', '2019-06-07 14:04:23', 176, 0, '', '2019-06-07 14:04:23');
INSERT INTO `access_log` VALUES (31830, '65.46.15598874636821419', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '103.90.92.64', '2019-06-07 14:04:24', 11, 0, '', '2019-06-07 14:04:24');
INSERT INTO `access_log` VALUES (31831, '65.53.15598874636861399', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '103.90.92.64', '2019-06-07 14:04:24', 8, 0, '', '2019-06-07 14:04:24');
INSERT INTO `access_log` VALUES (31832, '65.50.15598874637041415', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.239.251.83', '2019-06-07 14:04:24', 7, 0, '', '2019-06-07 14:04:24');
INSERT INTO `access_log` VALUES (31833, '65.51.15598874778411433', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.239.251.83', '2019-06-07 14:04:38', 1013, 0, '', '2019-06-07 14:04:39');
INSERT INTO `access_log` VALUES (31834, '65.47.15598874813041423', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.239.251.83', '2019-06-07 14:04:41', 12, 0, '', '2019-06-07 14:04:41');
INSERT INTO `access_log` VALUES (31835, '62.86.15598875303870949', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.239.251.83', '2019-06-07 14:05:30', 11, 0, '', '2019-06-07 14:05:30');
INSERT INTO `access_log` VALUES (31836, '59.79.15598889796841149', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:29:40', 10, 0, '', '2019-06-07 14:29:40');
INSERT INTO `access_log` VALUES (31837, '59.80.15598889796831139', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:29:40', 12, 2001001000, '服务端发生异常', '2019-06-07 14:29:40');
INSERT INTO `access_log` VALUES (31838, '64.82.15598889886830991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:29:49', 525, 0, '', '2019-06-07 14:29:49');
INSERT INTO `access_log` VALUES (31839, '64.80.15598889894030977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:29:49', 3, 0, '', '2019-06-07 14:29:49');
INSERT INTO `access_log` VALUES (31840, '64.85.15598889920380999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:29:52', 2, 0, '', '2019-06-07 14:29:52');
INSERT INTO `access_log` VALUES (31841, '64.79.15598889933660975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:29:53', 2, 0, '', '2019-06-07 14:29:53');
INSERT INTO `access_log` VALUES (31842, '64.77.15598889951020987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:29:55', 2, 0, '', '2019-06-07 14:29:55');
INSERT INTO `access_log` VALUES (31843, '64.84.15598889963410987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:29:56', 2, 0, '', '2019-06-07 14:29:56');
INSERT INTO `access_log` VALUES (31844, '66.49.15598890113419679', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=1787928374&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:30:11', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-06-07 14:30:11');
INSERT INTO `access_log` VALUES (31845, '66.51.15598890224229667', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17879283741&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:30:22', 17, 1001003000, '验证码不存在', '2019-06-07 14:30:22');
INSERT INTO `access_log` VALUES (31846, '66.53.15598890275279665', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17879283741', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:30:28', 68, 0, '', '2019-06-07 14:30:28');
INSERT INTO `access_log` VALUES (31847, '66.54.15598890311819671', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17879283741&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:30:31', 189, 0, '', '2019-06-07 14:30:31');
INSERT INTO `access_log` VALUES (31848, '64.80.15598890390760979', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:30:39', 6, 0, '', '2019-06-07 14:30:39');
INSERT INTO `access_log` VALUES (31849, '64.85.15598890393781001', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:30:39', 344, 0, '', '2019-06-07 14:30:40');
INSERT INTO `access_log` VALUES (31850, '66.52.15598890413769671', 112, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:30:41', 7, 0, '', '2019-06-07 14:30:41');
INSERT INTO `access_log` VALUES (31851, '66.56.15598890491849663', 112, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:30:49', 5, 0, '', '2019-06-07 14:30:49');
INSERT INTO `access_log` VALUES (31852, '66.49.15598890521519681', 112, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:30:52', 12, 0, '', '2019-06-07 14:30:52');
INSERT INTO `access_log` VALUES (31853, '66.55.15598890624999677', 112, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:03', 6, 0, '', '2019-06-07 14:31:03');
INSERT INTO `access_log` VALUES (31854, '66.54.15598890848719673', 112, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:25', 6, 0, '', '2019-06-07 14:31:25');
INSERT INTO `access_log` VALUES (31855, '64.78.15598890874210989', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:27', 5, 0, '', '2019-06-07 14:31:27');
INSERT INTO `access_log` VALUES (31856, '64.76.15598890875320971', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:28', 5, 0, '', '2019-06-07 14:31:28');
INSERT INTO `access_log` VALUES (31857, '59.80.15598890887241141', 112, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:29', 6, 0, '', '2019-06-07 14:31:29');
INSERT INTO `access_log` VALUES (31858, '59.74.15598890887371147', 112, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:29', 100, 2001001000, '服务端发生异常', '2019-06-07 14:31:29');
INSERT INTO `access_log` VALUES (31859, '64.81.15598890939430981', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:34', 5, 0, '', '2019-06-07 14:31:34');
INSERT INTO `access_log` VALUES (31860, '64.82.15598890940490995', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:34', 4, 0, '', '2019-06-07 14:31:34');
INSERT INTO `access_log` VALUES (31861, '59.75.15598890959511153', 112, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:36', 6, 0, '', '2019-06-07 14:31:36');
INSERT INTO `access_log` VALUES (31862, '59.78.15598890959521155', 112, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:36', 15, 2001001000, '服务端发生异常', '2019-06-07 14:31:36');
INSERT INTO `access_log` VALUES (31863, '64.83.15598890990130975', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:39', 5, 0, '', '2019-06-07 14:31:39');
INSERT INTO `access_log` VALUES (31864, '64.85.15598890993241003', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:39', 5, 0, '', '2019-06-07 14:31:39');
INSERT INTO `access_log` VALUES (31865, '59.71.15598891015551155', 112, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:42', 6, 0, '', '2019-06-07 14:31:42');
INSERT INTO `access_log` VALUES (31866, '59.76.15598891015551143', 112, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:42', 15, 2001001000, '服务端发生异常', '2019-06-07 14:31:42');
INSERT INTO `access_log` VALUES (31867, '64.79.15598891048490979', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:45', 5, 0, '', '2019-06-07 14:31:45');
INSERT INTO `access_log` VALUES (31868, '64.77.15598891050980991', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:45', 4, 0, '', '2019-06-07 14:31:45');
INSERT INTO `access_log` VALUES (31869, '59.72.15598891071301151', 112, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:47', 89, 0, '', '2019-06-07 14:31:47');
INSERT INTO `access_log` VALUES (31870, '59.73.15598891071301155', 112, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '58.213.93.21', '2019-06-07 14:31:47', 98, 2001001000, '服务端发生异常', '2019-06-07 14:31:47');
INSERT INTO `access_log` VALUES (31871, '64.81.15598891361690983', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:16', 5, 0, '', '2019-06-07 14:32:16');
INSERT INTO `access_log` VALUES (31872, '64.80.15598891362770983', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:16', 4, 0, '', '2019-06-07 14:32:16');
INSERT INTO `access_log` VALUES (31873, '59.78.15598891373011157', 112, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:17', 5, 0, '', '2019-06-07 14:32:17');
INSERT INTO `access_log` VALUES (31874, '59.75.15598891373001155', 112, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:17', 16, 2001001000, '服务端发生异常', '2019-06-07 14:32:17');
INSERT INTO `access_log` VALUES (31875, '64.83.15598891386450977', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:19', 5, 0, '', '2019-06-07 14:32:19');
INSERT INTO `access_log` VALUES (31876, '64.85.15598891387591005', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:19', 4, 0, '', '2019-06-07 14:32:19');
INSERT INTO `access_log` VALUES (31877, '59.71.15598891449191157', 112, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:25', 6, 0, '', '2019-06-07 14:32:25');
INSERT INTO `access_log` VALUES (31878, '59.73.15598891449201157', 112, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:25', 16, 2001001000, '服务端发生异常', '2019-06-07 14:32:25');
INSERT INTO `access_log` VALUES (31879, '64.77.15598891450180993', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:25', 4, 0, '', '2019-06-07 14:32:25');
INSERT INTO `access_log` VALUES (31880, '64.84.15598891451440993', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:25', 5, 0, '', '2019-06-07 14:32:25');
INSERT INTO `access_log` VALUES (31881, '59.79.15598891454381155', 112, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:25', 5, 0, '', '2019-06-07 14:32:25');
INSERT INTO `access_log` VALUES (31882, '59.72.15598891454371153', 112, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:25', 16, 2001001000, '服务端发生异常', '2019-06-07 14:32:25');
INSERT INTO `access_log` VALUES (31883, '64.78.15598891455870993', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:26', 5, 0, '', '2019-06-07 14:32:26');
INSERT INTO `access_log` VALUES (31884, '64.76.15598891458190975', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:26', 4, 0, '', '2019-06-07 14:32:26');
INSERT INTO `access_log` VALUES (31885, '66.49.15598891460959683', 112, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:26', 8, 0, '', '2019-06-07 14:32:26');
INSERT INTO `access_log` VALUES (31886, '64.81.15598891461280985', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:26', 4, 0, '', '2019-06-07 14:32:26');
INSERT INTO `access_log` VALUES (31887, '64.82.15598891463170999', 112, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:26', 5, 0, '', '2019-06-07 14:32:26');
INSERT INTO `access_log` VALUES (31888, '59.80.15598891465891145', 112, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:27', 5, 0, '', '2019-06-07 14:32:27');
INSERT INTO `access_log` VALUES (31889, '59.74.15598891465901151', 112, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.213.93.21', '2019-06-07 14:32:27', 15, 2001001000, '服务端发生异常', '2019-06-07 14:32:27');
INSERT INTO `access_log` VALUES (31890, '59.72.15598907564041175', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:16', 3, 0, '', '2019-06-07 14:59:16');
INSERT INTO `access_log` VALUES (31891, '59.80.15598907564061167', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:16', 13, 2001001000, '服务端发生异常', '2019-06-07 14:59:16');
INSERT INTO `access_log` VALUES (31892, '64.76.15598907596020997', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:20', 45, 0, '', '2019-06-07 14:59:20');
INSERT INTO `access_log` VALUES (31893, '64.81.15598907597811007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:20', 2, 0, '', '2019-06-07 14:59:20');
INSERT INTO `access_log` VALUES (31894, '64.80.15598907614381007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:21', 2, 0, '', '2019-06-07 14:59:21');
INSERT INTO `access_log` VALUES (31895, '64.83.15598907622061001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:22', 1, 0, '', '2019-06-07 14:59:22');
INSERT INTO `access_log` VALUES (31896, '64.85.15598907629591029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:23', 2, 0, '', '2019-06-07 14:59:23');
INSERT INTO `access_log` VALUES (31897, '64.79.15598907634221005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:23', 2, 0, '', '2019-06-07 14:59:23');
INSERT INTO `access_log` VALUES (31898, '59.77.15598907656601167', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:26', 3, 0, '', '2019-06-07 14:59:26');
INSERT INTO `access_log` VALUES (31899, '59.75.15598907656601179', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:26', 13, 2001001000, '服务端发生异常', '2019-06-07 14:59:26');
INSERT INTO `access_log` VALUES (31900, '64.77.15598907698591017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:30', 2, 0, '', '2019-06-07 14:59:30');
INSERT INTO `access_log` VALUES (31901, '64.84.15598907699821017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:30', 2, 0, '', '2019-06-07 14:59:30');
INSERT INTO `access_log` VALUES (31902, '64.78.15598907708861017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:31', 2, 0, '', '2019-06-07 14:59:31');
INSERT INTO `access_log` VALUES (31903, '64.76.15598907713430999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:31', 2, 0, '', '2019-06-07 14:59:31');
INSERT INTO `access_log` VALUES (31904, '64.81.15598907718861009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:32', 2, 0, '', '2019-06-07 14:59:32');
INSERT INTO `access_log` VALUES (31905, '59.76.15598907745021169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:35', 2, 0, '', '2019-06-07 14:59:35');
INSERT INTO `access_log` VALUES (31906, '59.71.15598907745031181', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 14:59:35', 13, 2001001000, '服务端发生异常', '2019-06-07 14:59:35');
INSERT INTO `access_log` VALUES (31907, '59.72.15598908118091177', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:12', 20, 2001001000, '服务端发生异常', '2019-06-07 15:00:12');
INSERT INTO `access_log` VALUES (31908, '59.80.15598908118091169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:12', 674, 0, '', '2019-06-07 15:00:12');
INSERT INTO `access_log` VALUES (31909, '64.85.15598908149471031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:15', 3, 0, '', '2019-06-07 15:00:15');
INSERT INTO `access_log` VALUES (31910, '64.79.15598908151251007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:15', 2, 0, '', '2019-06-07 15:00:15');
INSERT INTO `access_log` VALUES (31911, '59.77.15598908218421169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:22', 3, 0, '', '2019-06-07 15:00:22');
INSERT INTO `access_log` VALUES (31912, '59.75.15598908218641181', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:22', 12, 2001001000, '服务端发生异常', '2019-06-07 15:00:22');
INSERT INTO `access_log` VALUES (31913, '59.76.15598908387291171', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:39', 18, 0, '', '2019-06-07 15:00:39');
INSERT INTO `access_log` VALUES (31914, '59.71.15598908387541183', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:39', 14, 2001001000, '服务端发生异常', '2019-06-07 15:00:39');
INSERT INTO `access_log` VALUES (31915, '64.78.15598908408321019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:41', 2, 0, '', '2019-06-07 15:00:41');
INSERT INTO `access_log` VALUES (31916, '64.76.15598908413161001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:41', 2, 0, '', '2019-06-07 15:00:41');
INSERT INTO `access_log` VALUES (31917, '64.81.15598908429851011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:43', 2, 0, '', '2019-06-07 15:00:43');
INSERT INTO `access_log` VALUES (31918, '64.82.15598908449681025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:45', 2, 0, '', '2019-06-07 15:00:45');
INSERT INTO `access_log` VALUES (31919, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:45', 14, 0, '', '2019-06-07 15:00:45');
INSERT INTO `access_log` VALUES (31920, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:50', 6, 0, '', '2019-06-07 15:00:50');
INSERT INTO `access_log` VALUES (31921, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:51', 8, 0, '', '2019-06-07 15:00:51');
INSERT INTO `access_log` VALUES (31922, '64.83.15598908537061005', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:54', 7, 0, '', '2019-06-07 15:00:54');
INSERT INTO `access_log` VALUES (31923, '64.85.15598908589231033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:59', 2, 0, '', '2019-06-07 15:00:59');
INSERT INTO `access_log` VALUES (31924, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:00:59', 7, 0, '', '2019-06-07 15:00:59');
INSERT INTO `access_log` VALUES (31925, '64.79.15598908596341009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:01:00', 2, 0, '', '2019-06-07 15:01:00');
INSERT INTO `access_log` VALUES (31926, '64.77.15598908600151021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:01:00', 1, 0, '', '2019-06-07 15:01:00');
INSERT INTO `access_log` VALUES (31927, '59.79.15598908603851181', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:01:00', 3, 0, '', '2019-06-07 15:01:00');
INSERT INTO `access_log` VALUES (31928, '59.80.15598908604631171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:01:00', 13, 2001001000, '服务端发生异常', '2019-06-07 15:01:00');
INSERT INTO `access_log` VALUES (31929, '59.72.15598908618391179', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:01:02', 2, 0, '', '2019-06-07 15:01:02');
INSERT INTO `access_log` VALUES (31930, '59.74.15598908618451177', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; FRD-AL10 Build/HUAWEIFRD-AL10; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/6043 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '219.134.114.161', '2019-06-07 15:01:02', 14, 2001001000, '服务端发生异常', '2019-06-07 15:01:02');
INSERT INTO `access_log` VALUES (31931, '65.50.15598908772411463', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:01:17', 1, 1002001015, '账号未登陆', '2019-06-07 15:01:17');
INSERT INTO `access_log` VALUES (31932, '65.53.15598908772411445', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:01:17', 1, 1002001015, '账号未登陆', '2019-06-07 15:01:17');
INSERT INTO `access_log` VALUES (31933, '65.52.15598908772411469', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:01:17', 1, 1002001015, '账号未登陆', '2019-06-07 15:01:17');
INSERT INTO `access_log` VALUES (31934, '65.3607.15598908861303233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:01:26', 71, 0, '', '2019-06-07 15:01:26');
INSERT INTO `access_log` VALUES (31935, '65.51.15598908864401481', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:01:26', 11, 0, '', '2019-06-07 15:01:26');
INSERT INTO `access_log` VALUES (31936, '65.54.15598908864421427', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:01:26', 10, 0, '', '2019-06-07 15:01:26');
INSERT INTO `access_log` VALUES (31937, '65.45.15598908864461483', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:01:26', 9, 0, '', '2019-06-07 15:01:26');
INSERT INTO `access_log` VALUES (31938, '62.82.15598909027531005', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:01:43', 195, 0, '', '2019-06-07 15:01:43');
INSERT INTO `access_log` VALUES (31939, '62.89.15598909229131007', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:02:03', 17, 0, '', '2019-06-07 15:02:03');
INSERT INTO `access_log` VALUES (31940, '62.80.15598909449241013', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-08 15:02:01&createEndTime=2019-06-08 15:02:01&status=2&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:02:25', 161, 2001001000, '服务端发生异常', '2019-06-07 15:02:25');
INSERT INTO `access_log` VALUES (31941, '64.83.15598909524341007', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:02:32', 13, 0, '', '2019-06-07 15:02:32');
INSERT INTO `access_log` VALUES (31942, '64.85.15598909524341035', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:02:32', 10, 0, '', '2019-06-07 15:02:32');
INSERT INTO `access_log` VALUES (31943, '64.77.15598909566791023', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:02:37', 14, 0, '', '2019-06-07 15:02:37');
INSERT INTO `access_log` VALUES (31944, '64.84.15598909566851023', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:02:37', 12, 0, '', '2019-06-07 15:02:37');
INSERT INTO `access_log` VALUES (31945, '64.76.15598909602801005', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:02:40', 8, 0, '', '2019-06-07 15:02:40');
INSERT INTO `access_log` VALUES (31946, '64.81.15598909602801015', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:02:40', 8, 0, '', '2019-06-07 15:02:40');
INSERT INTO `access_log` VALUES (31947, '64.78.15598909602791023', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:02:40', 13, 0, '', '2019-06-07 15:02:40');
INSERT INTO `access_log` VALUES (31948, '64.82.15598909650031029', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:02:45', 11, 0, '', '2019-06-07 15:02:45');
INSERT INTO `access_log` VALUES (31949, '59.74.15598909851661179', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:03:05', 12, 0, '', '2019-06-07 15:03:05');
INSERT INTO `access_log` VALUES (31950, '66.56.15598909910039691', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:03:11', 25, 0, '', '2019-06-07 15:03:11');
INSERT INTO `access_log` VALUES (31951, '59.75.15598909998461185', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:03:20', 11, 0, '', '2019-06-07 15:03:20');
INSERT INTO `access_log` VALUES (31952, '59.78.15598910023461187', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:03:22', 10, 0, '', '2019-06-07 15:03:22');
INSERT INTO `access_log` VALUES (31953, '59.76.15598910046571175', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:03:25', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-07 15:03:25');
INSERT INTO `access_log` VALUES (31954, '65.54.15598910075121429', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:03:28', 18, 0, '', '2019-06-07 15:03:28');
INSERT INTO `access_log` VALUES (31955, '65.45.15598910131611485', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:03:33', 9, 0, '', '2019-06-07 15:03:33');
INSERT INTO `access_log` VALUES (31956, '65.49.15598910171421495', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:03:37', 9, 0, '', '2019-06-07 15:03:37');
INSERT INTO `access_log` VALUES (31957, '65.52.15598910189811473', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:03:39', 8, 0, '', '2019-06-07 15:03:39');
INSERT INTO `access_log` VALUES (31958, '65.53.15598910197521449', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:03:40', 496, 0, '', '2019-06-07 15:03:40');
INSERT INTO `access_log` VALUES (31959, '59.79.15598910435801185', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:04:04', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-07 15:04:04');
INSERT INTO `access_log` VALUES (31960, '65.3607.15598910517733237', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:04:12', 15, 0, '', '2019-06-07 15:04:12');
INSERT INTO `access_log` VALUES (31961, '65.51.15598910527621485', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:04:13', 9, 0, '', '2019-06-07 15:04:13');
INSERT INTO `access_log` VALUES (31962, '65.54.15598910534371431', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:04:13', 10, 0, '', '2019-06-07 15:04:13');
INSERT INTO `access_log` VALUES (31963, '65.45.15598910539601487', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:04:14', 18, 0, '', '2019-06-07 15:04:14');
INSERT INTO `access_log` VALUES (31964, '59.72.15598910543271183', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:04:14', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-07 15:04:14');
INSERT INTO `access_log` VALUES (31965, '59.74.15598910545821181', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:04:15', 18, 0, '', '2019-06-07 15:04:15');
INSERT INTO `access_log` VALUES (31966, '59.77.15598910551441175', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:04:15', 11, 0, '', '2019-06-07 15:04:15');
INSERT INTO `access_log` VALUES (31967, '66.53.15598910556509695', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:04:16', 14, 0, '', '2019-06-07 15:04:16');
INSERT INTO `access_log` VALUES (31968, '59.75.15598910558971187', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:04:16', 10, 0, '', '2019-06-07 15:04:16');
INSERT INTO `access_log` VALUES (31969, '59.79.15598936667101221', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 15:47:47', 11, 0, '', '2019-06-07 15:47:47');
INSERT INTO `access_log` VALUES (31970, '59.80.15598936667231211', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 15:47:47', 19, 2001001000, '服务端发生异常', '2019-06-07 15:47:47');
INSERT INTO `access_log` VALUES (31971, '59.77.15598936768401211', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 15:47:57', 4, 0, '', '2019-06-07 15:47:57');
INSERT INTO `access_log` VALUES (31972, '59.74.15598936768381217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 15:47:57', 13, 2001001000, '服务端发生异常', '2019-06-07 15:47:57');
INSERT INTO `access_log` VALUES (31973, '64.83.15598936794381045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 15:47:59', 11, 0, '', '2019-06-07 15:47:59');
INSERT INTO `access_log` VALUES (31974, '64.85.15598936796191073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 15:48:00', 3, 0, '', '2019-06-07 15:48:00');
INSERT INTO `access_log` VALUES (31975, '64.79.15598936807381049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 15:48:01', 2, 0, '', '2019-06-07 15:48:01');
INSERT INTO `access_log` VALUES (31976, '64.77.15598936824191061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 15:48:02', 2, 0, '', '2019-06-07 15:48:02');
INSERT INTO `access_log` VALUES (31977, '64.84.15598936831881061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 15:48:03', 2, 0, '', '2019-06-07 15:48:03');
INSERT INTO `access_log` VALUES (31978, '59.78.15598936844581225', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 15:48:04', 2, 0, '', '2019-06-07 15:48:04');
INSERT INTO `access_log` VALUES (31979, '59.76.15598936844601213', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 15:48:04', 14, 2001001000, '服务端发生异常', '2019-06-07 15:48:04');
INSERT INTO `access_log` VALUES (31980, '65.47.15598939797561513', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '210.12.59.117', '2019-06-07 15:53:00', 0, 1002001015, '账号未登陆', '2019-06-07 15:53:00');
INSERT INTO `access_log` VALUES (31981, '65.3607.15598939797713277', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '210.12.59.117', '2019-06-07 15:53:00', 0, 1002001015, '账号未登陆', '2019-06-07 15:53:00');
INSERT INTO `access_log` VALUES (31982, '65.51.15598939797741525', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '210.12.59.117', '2019-06-07 15:53:00', 0, 1002001015, '账号未登陆', '2019-06-07 15:53:00');
INSERT INTO `access_log` VALUES (31983, '65.54.15598939830411471', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '210.12.59.117', '2019-06-07 15:53:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 15:53:03');
INSERT INTO `access_log` VALUES (31984, '65.45.15598939880631527', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '210.12.59.117', '2019-06-07 15:53:08', 105, 0, '', '2019-06-07 15:53:08');
INSERT INTO `access_log` VALUES (31985, '65.49.15598939884441537', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '210.12.59.117', '2019-06-07 15:53:08', 10, 0, '', '2019-06-07 15:53:08');
INSERT INTO `access_log` VALUES (31986, '65.46.15598939884551511', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '210.12.59.117', '2019-06-07 15:53:08', 9, 0, '', '2019-06-07 15:53:08');
INSERT INTO `access_log` VALUES (31987, '65.52.15598939884591515', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '210.12.59.117', '2019-06-07 15:53:08', 9, 0, '', '2019-06-07 15:53:08');
INSERT INTO `access_log` VALUES (31988, '62.80.15598939960881059', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '210.12.59.117', '2019-06-07 15:53:16', 91, 0, '', '2019-06-07 15:53:16');
INSERT INTO `access_log` VALUES (31989, '64.82.15598940009941071', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '210.12.59.117', '2019-06-07 15:53:21', 11, 0, '', '2019-06-07 15:53:21');
INSERT INTO `access_log` VALUES (31990, '64.78.15598940009941065', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '210.12.59.117', '2019-06-07 15:53:21', 14, 0, '', '2019-06-07 15:53:21');
INSERT INTO `access_log` VALUES (31991, '65.51.15598940200941527', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '210.12.59.117', '2019-06-07 15:53:40', 475, 0, '', '2019-06-07 15:53:41');
INSERT INTO `access_log` VALUES (31992, '59.79.15598940360661227', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '210.12.59.117', '2019-06-07 15:53:56', 45, 0, '', '2019-06-07 15:53:56');
INSERT INTO `access_log` VALUES (31993, '65.54.15598940438871473', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '210.12.59.117', '2019-06-07 15:54:04', 20, 0, '', '2019-06-07 15:54:04');
INSERT INTO `access_log` VALUES (31994, '65.51.15598954871671547', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 16:18:07', 0, 1002001015, '账号未登陆', '2019-06-07 16:18:07');
INSERT INTO `access_log` VALUES (31995, '65.53.15598954871671511', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 16:18:07', 1, 1002001015, '账号未登陆', '2019-06-07 16:18:07');
INSERT INTO `access_log` VALUES (31996, '65.47.15598954871671537', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 16:18:07', 1, 1002001015, '账号未登陆', '2019-06-07 16:18:07');
INSERT INTO `access_log` VALUES (31997, '65.54.15598954893811495', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 16:18:09', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 16:18:09');
INSERT INTO `access_log` VALUES (31998, '65.45.15598954942971547', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 16:18:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 16:18:14');
INSERT INTO `access_log` VALUES (31999, '65.50.15598955077721533', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 16:18:28', 81, 0, '', '2019-06-07 16:18:28');
INSERT INTO `access_log` VALUES (32000, '65.49.15598955082081561', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 16:18:28', 10, 0, '', '2019-06-07 16:18:28');
INSERT INTO `access_log` VALUES (32001, '65.46.15598955082071535', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 16:18:28', 12, 0, '', '2019-06-07 16:18:28');
INSERT INTO `access_log` VALUES (32002, '65.53.15598955082131513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 16:18:28', 9, 0, '', '2019-06-07 16:18:28');
INSERT INTO `access_log` VALUES (32003, '62.88.15598955142081081', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.63.37', '2019-06-07 16:18:34', 13, 0, '', '2019-06-07 16:18:34');
INSERT INTO `access_log` VALUES (32004, '59.72.15598955347181245', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:18:55', 3, 0, '', '2019-06-07 16:18:55');
INSERT INTO `access_log` VALUES (32005, '59.77.15598955347191237', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:18:55', 13, 2001001000, '服务端发生异常', '2019-06-07 16:18:55');
INSERT INTO `access_log` VALUES (32006, '59.75.15598955504861249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:19:10', 3, 0, '', '2019-06-07 16:19:10');
INSERT INTO `access_log` VALUES (32007, '59.76.15598955504891239', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:19:10', 12, 2001001000, '服务端发生异常', '2019-06-07 16:19:11');
INSERT INTO `access_log` VALUES (32008, '64.79.15598955537151075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:19:14', 6, 0, '', '2019-06-07 16:19:14');
INSERT INTO `access_log` VALUES (32009, '64.77.15598955541011087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:19:14', 2, 0, '', '2019-06-07 16:19:14');
INSERT INTO `access_log` VALUES (32010, '64.76.15598955616661069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:19:22', 2, 0, '', '2019-06-07 16:19:22');
INSERT INTO `access_log` VALUES (32011, '64.81.15598955617951079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:19:22', 2, 0, '', '2019-06-07 16:19:22');
INSERT INTO `access_log` VALUES (32012, '59.71.15598955666001251', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:19:27', 3, 0, '', '2019-06-07 16:19:27');
INSERT INTO `access_log` VALUES (32013, '59.73.15598955666131251', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:19:27', 10, 2001001000, '服务端发生异常', '2019-06-07 16:19:27');
INSERT INTO `access_log` VALUES (32014, '65.52.15598955857311539', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:19:46', 0, 1002001015, '账号未登陆', '2019-06-07 16:19:46');
INSERT INTO `access_log` VALUES (32015, '65.50.15598955857391535', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:19:46', 1, 1002001015, '账号未登陆', '2019-06-07 16:19:46');
INSERT INTO `access_log` VALUES (32016, '65.53.15598955857451515', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:19:46', 0, 1002001015, '账号未登陆', '2019-06-07 16:19:46');
INSERT INTO `access_log` VALUES (32017, '65.49.15598955888361563', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:19:49', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 16:19:49');
INSERT INTO `access_log` VALUES (32018, '65.51.15598956040961551', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:20:04', 107, 0, '', '2019-06-07 16:20:04');
INSERT INTO `access_log` VALUES (32019, '65.47.15598956046651541', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:20:05', 10, 0, '', '2019-06-07 16:20:05');
INSERT INTO `access_log` VALUES (32020, '65.3607.15598956046653303', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:20:05', 10, 0, '', '2019-06-07 16:20:05');
INSERT INTO `access_log` VALUES (32021, '65.54.15598956046771499', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:20:05', 8, 0, '', '2019-06-07 16:20:05');
INSERT INTO `access_log` VALUES (32022, '62.83.15598956171411077', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:20:17', 12, 0, '', '2019-06-07 16:20:17');
INSERT INTO `access_log` VALUES (32023, '64.85.15598956211271101', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:20:21', 12, 0, '', '2019-06-07 16:20:21');
INSERT INTO `access_log` VALUES (32024, '64.79.15598956211301077', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:20:21', 9, 0, '', '2019-06-07 16:20:21');
INSERT INTO `access_log` VALUES (32025, '64.77.15598956249521089', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:20:25', 12, 0, '', '2019-06-07 16:20:25');
INSERT INTO `access_log` VALUES (32026, '64.84.15598956249581089', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:20:25', 8, 0, '', '2019-06-07 16:20:25');
INSERT INTO `access_log` VALUES (32027, '59.75.15598956353531251', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:20:35', 13, 0, '', '2019-06-07 16:20:35');
INSERT INTO `access_log` VALUES (32028, '65.49.15598956603221565', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:21:00', 9, 0, '', '2019-06-07 16:21:00');
INSERT INTO `access_log` VALUES (32029, '65.46.15598956627571539', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:21:03', 11, 0, '', '2019-06-07 16:21:03');
INSERT INTO `access_log` VALUES (32030, '65.51.15598956647231553', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:21:05', 16, 0, '', '2019-06-07 16:21:05');
INSERT INTO `access_log` VALUES (32031, '65.47.15598956682851543', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.176.31.25', '2019-06-07 16:21:08', 10, 0, '', '2019-06-07 16:21:08');
INSERT INTO `access_log` VALUES (32032, '65.52.15598973928401565', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '14.215.37.140', '2019-06-07 16:49:53', 0, 1002001015, '账号未登陆', '2019-06-07 16:49:53');
INSERT INTO `access_log` VALUES (32033, '65.49.15598973928411589', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '14.215.37.140', '2019-06-07 16:49:53', 1, 1002001015, '账号未登陆', '2019-06-07 16:49:53');
INSERT INTO `access_log` VALUES (32034, '65.46.15598973928421563', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '14.215.37.140', '2019-06-07 16:49:53', 0, 1002001015, '账号未登陆', '2019-06-07 16:49:53');
INSERT INTO `access_log` VALUES (32035, '65.47.15598973976771567', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '14.215.37.140', '2019-06-07 16:49:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 16:49:58');
INSERT INTO `access_log` VALUES (32036, '65.54.15598973994941525', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '14.215.37.140', '2019-06-07 16:49:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 16:50:00');
INSERT INTO `access_log` VALUES (32037, '65.45.15598974153071577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '14.215.37.140', '2019-06-07 16:50:15', 110, 0, '', '2019-06-07 16:50:15');
INSERT INTO `access_log` VALUES (32038, '65.50.15598974157091563', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '14.215.37.140', '2019-06-07 16:50:16', 9, 0, '', '2019-06-07 16:50:16');
INSERT INTO `access_log` VALUES (32039, '65.53.15598974157091543', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '14.215.37.140', '2019-06-07 16:50:16', 9, 0, '', '2019-06-07 16:50:16');
INSERT INTO `access_log` VALUES (32040, '65.49.15598974157141591', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '14.215.37.140', '2019-06-07 16:50:16', 9, 0, '', '2019-06-07 16:50:16');
INSERT INTO `access_log` VALUES (32041, '62.88.15598974203111107', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '14.215.37.140', '2019-06-07 16:50:20', 317, 0, '', '2019-06-07 16:50:21');
INSERT INTO `access_log` VALUES (32042, '66.49.15598974222569793', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '14.215.37.140', '2019-06-07 16:50:22', 20, 0, '', '2019-06-07 16:50:22');
INSERT INTO `access_log` VALUES (32043, '59.73.15598974893961277', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:29', 18, 0, '', '2019-06-07 16:51:29');
INSERT INTO `access_log` VALUES (32044, '59.80.15598974893971265', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:29', 23, 2001001000, '服务端发生异常', '2019-06-07 16:51:29');
INSERT INTO `access_log` VALUES (32045, '64.80.15598974954091105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:35', 10, 0, '', '2019-06-07 16:51:35');
INSERT INTO `access_log` VALUES (32046, '64.79.15598974955171103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:36', 3, 0, '', '2019-06-07 16:51:36');
INSERT INTO `access_log` VALUES (32047, '64.85.15598975006561127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:41', 2, 0, '', '2019-06-07 16:51:41');
INSERT INTO `access_log` VALUES (32048, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:41', 14, 0, '', '2019-06-07 16:51:41');
INSERT INTO `access_log` VALUES (32049, '64.84.15598975031041115', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:43', 8, 0, '', '2019-06-07 16:51:43');
INSERT INTO `access_log` VALUES (32050, '64.77.15598975055131115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:46', 2, 0, '', '2019-06-07 16:51:46');
INSERT INTO `access_log` VALUES (32051, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:46', 6, 0, '', '2019-06-07 16:51:46');
INSERT INTO `access_log` VALUES (32052, '64.76.15598975061751097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:46', 2, 0, '', '2019-06-07 16:51:46');
INSERT INTO `access_log` VALUES (32053, '64.81.15598975063131107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:46', 1, 0, '', '2019-06-07 16:51:46');
INSERT INTO `access_log` VALUES (32054, '59.72.15598975071031273', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:47', 12, 2001001000, '服务端发生异常', '2019-06-07 16:51:47');
INSERT INTO `access_log` VALUES (32055, '59.77.15598975071011265', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:47', 585, 0, '', '2019-06-07 16:51:48');
INSERT INTO `access_log` VALUES (32056, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=k&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:52', 5, 0, '', '2019-06-07 16:51:52');
INSERT INTO `access_log` VALUES (32057, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=k', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:53', 9, 0, '', '2019-06-07 16:51:53');
INSERT INTO `access_log` VALUES (32058, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:59', 6, 0, '', '2019-06-07 16:51:59');
INSERT INTO `access_log` VALUES (32059, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=java', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:51:59', 9, 0, '', '2019-06-07 16:51:59');
INSERT INTO `access_log` VALUES (32060, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:01', 7, 0, '', '2019-06-07 16:52:01');
INSERT INTO `access_log` VALUES (32061, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=java', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:01', 18, 0, '', '2019-06-07 16:52:01');
INSERT INTO `access_log` VALUES (32062, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:02', 7, 0, '', '2019-06-07 16:52:02');
INSERT INTO `access_log` VALUES (32063, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:04', 7, 0, '', '2019-06-07 16:52:04');
INSERT INTO `access_log` VALUES (32064, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=java', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:04', 12, 0, '', '2019-06-07 16:52:04');
INSERT INTO `access_log` VALUES (32065, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=java', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:04', 11, 0, '', '2019-06-07 16:52:04');
INSERT INTO `access_log` VALUES (32066, '59.76.15598975273741267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:07', 3, 0, '', '2019-06-07 16:52:07');
INSERT INTO `access_log` VALUES (32067, '59.78.15598975273761279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:07', 19, 2001001000, '服务端发生异常', '2019-06-07 16:52:07');
INSERT INTO `access_log` VALUES (32068, '64.80.15598975300181107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:10', 2, 0, '', '2019-06-07 16:52:10');
INSERT INTO `access_log` VALUES (32069, '64.83.15598975301661101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:10', 2, 0, '', '2019-06-07 16:52:10');
INSERT INTO `access_log` VALUES (32070, '64.79.15598975311361105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:11', 2, 0, '', '2019-06-07 16:52:11');
INSERT INTO `access_log` VALUES (32071, '64.85.15598975316881129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:12', 2, 0, '', '2019-06-07 16:52:12');
INSERT INTO `access_log` VALUES (32072, '59.71.15598975334261279', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:13', 2, 0, '', '2019-06-07 16:52:13');
INSERT INTO `access_log` VALUES (32073, '59.80.15598975334261267', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:13', 10, 2001001000, '服务端发生异常', '2019-06-07 16:52:13');
INSERT INTO `access_log` VALUES (32074, '65.50.15598975487261565', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:29', 0, 1002001015, '账号未登陆', '2019-06-07 16:52:29');
INSERT INTO `access_log` VALUES (32075, '65.46.15598975490311567', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:29', 1, 1002001015, '账号未登陆', '2019-06-07 16:52:29');
INSERT INTO `access_log` VALUES (32076, '65.52.15598975490331569', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:29', 1, 1002001015, '账号未登陆', '2019-06-07 16:52:29');
INSERT INTO `access_log` VALUES (32077, '65.51.15598975528021581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 16:52:33');
INSERT INTO `access_log` VALUES (32078, '65.47.15598975564431571', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:36', 76, 0, '', '2019-06-07 16:52:37');
INSERT INTO `access_log` VALUES (32079, '65.54.15598975568641529', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:37', 10, 0, '', '2019-06-07 16:52:37');
INSERT INTO `access_log` VALUES (32080, '65.3607.15598975568683333', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:37', 9, 0, '', '2019-06-07 16:52:37');
INSERT INTO `access_log` VALUES (32081, '65.45.15598975568751581', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:37', 9, 0, '', '2019-06-07 16:52:37');
INSERT INTO `access_log` VALUES (32082, '62.81.15598975734061079', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '120.229.160.0', '2019-06-07 16:52:53', 14, 0, '', '2019-06-07 16:52:53');
INSERT INTO `access_log` VALUES (32083, '65.54.15599000571311563', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:34:17', 1, 1002001015, '账号未登陆', '2019-06-07 17:34:17');
INSERT INTO `access_log` VALUES (32084, '65.45.15599000571311615', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:34:17', 1, 1002001015, '账号未登陆', '2019-06-07 17:34:17');
INSERT INTO `access_log` VALUES (32085, '65.3607.15599000571313367', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:34:17', 0, 1002001015, '账号未登陆', '2019-06-07 17:34:17');
INSERT INTO `access_log` VALUES (32086, '65.49.15599000607411629', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:34:21', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 17:34:21');
INSERT INTO `access_log` VALUES (32087, '65.50.15599000676681601', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:34:28', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 17:34:28');
INSERT INTO `access_log` VALUES (32088, '65.46.15599000884031603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:34:48', 136, 0, '', '2019-06-07 17:34:49');
INSERT INTO `access_log` VALUES (32089, '65.51.15599000890791617', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:34:49', 329, 0, '', '2019-06-07 17:34:49');
INSERT INTO `access_log` VALUES (32090, '65.47.15599000890801607', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:34:49', 330, 0, '', '2019-06-07 17:34:49');
INSERT INTO `access_log` VALUES (32091, '65.54.15599000893701565', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:34:49', 39, 0, '', '2019-06-07 17:34:49');
INSERT INTO `access_log` VALUES (32092, '62.81.15599001000391113', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:35:00', 22, 0, '', '2019-06-07 17:35:00');
INSERT INTO `access_log` VALUES (32093, '64.81.15599001153561143', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:35:15', 19, 0, '', '2019-06-07 17:35:15');
INSERT INTO `access_log` VALUES (32094, '64.76.15599001153541133', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:35:15', 23, 0, '', '2019-06-07 17:35:15');
INSERT INTO `access_log` VALUES (32095, '65.53.15599001354981583', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:35:35', 4, 0, '', '2019-06-07 17:35:36');
INSERT INTO `access_log` VALUES (32096, '66.51.15599001548549819', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:35:55', 20, 0, '', '2019-06-07 17:35:55');
INSERT INTO `access_log` VALUES (32097, '59.76.15599001664431303', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:36:06', 293, 0, '', '2019-06-07 17:36:07');
INSERT INTO `access_log` VALUES (32098, '65.47.15599001739691609', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.60.116.163', '2019-06-07 17:36:14', 19, 0, '', '2019-06-07 17:36:14');
INSERT INTO `access_log` VALUES (32099, '59.76.15599013368111319', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0;zh-cn; FRD-AL10 Build/HUAWEIFRD-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '114.87.163.43', '2019-06-07 17:55:37', 3, 0, '', '2019-06-07 17:55:37');
INSERT INTO `access_log` VALUES (32100, '59.75.15599013368101329', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0;zh-cn; FRD-AL10 Build/HUAWEIFRD-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '114.87.163.43', '2019-06-07 17:55:37', 14, 2001001000, '服务端发生异常', '2019-06-07 17:55:37');
INSERT INTO `access_log` VALUES (32101, '64.80.15599013410691159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0;zh-cn; FRD-AL10 Build/HUAWEIFRD-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '114.87.163.43', '2019-06-07 17:55:41', 4, 0, '', '2019-06-07 17:55:41');
INSERT INTO `access_log` VALUES (32102, '64.83.15599013413181153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0;zh-cn; FRD-AL10 Build/HUAWEIFRD-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '114.87.163.43', '2019-06-07 17:55:41', 3, 0, '', '2019-06-07 17:55:41');
INSERT INTO `access_log` VALUES (32103, '64.79.15599013429941157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0;zh-cn; FRD-AL10 Build/HUAWEIFRD-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '114.87.163.43', '2019-06-07 17:55:43', 3, 0, '', '2019-06-07 17:55:43');
INSERT INTO `access_log` VALUES (32104, '64.85.15599013438721181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0;zh-cn; FRD-AL10 Build/HUAWEIFRD-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '114.87.163.43', '2019-06-07 17:55:44', 2, 0, '', '2019-06-07 17:55:44');
INSERT INTO `access_log` VALUES (32105, '59.78.15599013452041331', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0;zh-cn; FRD-AL10 Build/HUAWEIFRD-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '114.87.163.43', '2019-06-07 17:55:45', 3, 0, '', '2019-06-07 17:55:45');
INSERT INTO `access_log` VALUES (32106, '59.71.15599013452281331', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0;zh-cn; FRD-AL10 Build/HUAWEIFRD-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '114.87.163.43', '2019-06-07 17:55:45', 12, 2001001000, '服务端发生异常', '2019-06-07 17:55:45');
INSERT INTO `access_log` VALUES (32107, '64.84.15599013470221169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0;zh-cn; FRD-AL10 Build/HUAWEIFRD-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '114.87.163.43', '2019-06-07 17:55:47', 2, 0, '', '2019-06-07 17:55:47');
INSERT INTO `access_log` VALUES (32108, '64.77.15599013471581169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0;zh-cn; FRD-AL10 Build/HUAWEIFRD-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '114.87.163.43', '2019-06-07 17:55:47', 2, 0, '', '2019-06-07 17:55:47');
INSERT INTO `access_log` VALUES (32109, '59.80.15599013484681319', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0;zh-cn; FRD-AL10 Build/HUAWEIFRD-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '114.87.163.43', '2019-06-07 17:55:48', 2, 0, '', '2019-06-07 17:55:48');
INSERT INTO `access_log` VALUES (32110, '59.73.15599013484681331', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0;zh-cn; FRD-AL10 Build/HUAWEIFRD-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '114.87.163.43', '2019-06-07 17:55:48', 9, 2001001000, '服务端发生异常', '2019-06-07 17:55:48');
INSERT INTO `access_log` VALUES (32111, '59.72.15599015063071329', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0;zh-cn; FRD-AL10 Build/HUAWEIFRD-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '114.87.163.43', '2019-06-07 17:58:26', 3, 0, '', '2019-06-07 17:58:26');
INSERT INTO `access_log` VALUES (32112, '59.77.15599015063081321', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0;zh-cn; FRD-AL10 Build/HUAWEIFRD-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '114.87.163.43', '2019-06-07 17:58:26', 13, 2001001000, '服务端发生异常', '2019-06-07 17:58:26');
INSERT INTO `access_log` VALUES (32113, '59.71.15599021460571343', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:06', 3, 0, '', '2019-06-07 18:09:06');
INSERT INTO `access_log` VALUES (32114, '59.78.15599021460541343', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:06', 14, 2001001000, '服务端发生异常', '2019-06-07 18:09:06');
INSERT INTO `access_log` VALUES (32115, '64.80.15599021507651171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:11', 2, 0, '', '2019-06-07 18:09:11');
INSERT INTO `access_log` VALUES (32116, '64.83.15599021509591165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:11', 2, 0, '', '2019-06-07 18:09:11');
INSERT INTO `access_log` VALUES (32117, '64.79.15599021522191169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:12', 3, 0, '', '2019-06-07 18:09:12');
INSERT INTO `access_log` VALUES (32118, '64.85.15599021526981193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:13', 2, 0, '', '2019-06-07 18:09:13');
INSERT INTO `access_log` VALUES (32119, '64.84.15599021532841181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:13', 2, 0, '', '2019-06-07 18:09:13');
INSERT INTO `access_log` VALUES (32120, '65.45.15599021602031645', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:20', 0, 1002001015, '账号未登陆', '2019-06-07 18:09:20');
INSERT INTO `access_log` VALUES (32121, '65.3607.15599021602043397', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:20', 0, 1002001015, '账号未登陆', '2019-06-07 18:09:20');
INSERT INTO `access_log` VALUES (32122, '65.49.15599021602051659', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:20', 1, 1002001015, '账号未登陆', '2019-06-07 18:09:20');
INSERT INTO `access_log` VALUES (32123, '65.50.15599021652601631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:25', 79, 0, '', '2019-06-07 18:09:25');
INSERT INTO `access_log` VALUES (32124, '65.52.15599021655871635', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:26', 10, 0, '', '2019-06-07 18:09:26');
INSERT INTO `access_log` VALUES (32125, '65.46.15599021655911633', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:26', 8, 0, '', '2019-06-07 18:09:26');
INSERT INTO `access_log` VALUES (32126, '65.47.15599021655951637', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:26', 8, 0, '', '2019-06-07 18:09:26');
INSERT INTO `access_log` VALUES (32127, '62.84.15599021700581153', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:30', 19, 0, '', '2019-06-07 18:09:30');
INSERT INTO `access_log` VALUES (32128, '64.76.15599021730981163', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:33', 8, 0, '', '2019-06-07 18:09:33');
INSERT INTO `access_log` VALUES (32129, '64.81.15599021730961173', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:33', 12, 0, '', '2019-06-07 18:09:33');
INSERT INTO `access_log` VALUES (32130, '64.82.15599021838011187', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=qqq', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:44', 8, 1002002009, NULL, '2019-06-07 18:09:44');
INSERT INTO `access_log` VALUES (32131, '64.80.15599021861351173', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=3&name=eee', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:46', 7, 1002002009, NULL, '2019-06-07 18:09:46');
INSERT INTO `access_log` VALUES (32132, '64.79.15599021910731171', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=6&name=333', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:51', 6, 1002002009, NULL, '2019-06-07 18:09:51');
INSERT INTO `access_log` VALUES (32133, '64.85.15599021935861195', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=7&name=444', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:54', 8, 1002002009, NULL, '2019-06-07 18:09:54');
INSERT INTO `access_log` VALUES (32134, '64.84.15599021959061183', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=4&name=555', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:09:56', 7, 1002002009, NULL, '2019-06-07 18:09:56');
INSERT INTO `access_log` VALUES (32135, '59.76.15599022397901333', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:10:40', 12, 0, '', '2019-06-07 18:10:40');
INSERT INTO `access_log` VALUES (32136, '59.75.15599022424611343', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:10:42', 26, 2001001000, '服务端发生异常', '2019-06-07 18:10:42');
INSERT INTO `access_log` VALUES (32137, '65.53.15599022444831613', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:10:44', 16, 0, '', '2019-06-07 18:10:44');
INSERT INTO `access_log` VALUES (32138, '65.50.15599022452671633', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:10:45', 10, 0, '', '2019-06-07 18:10:45');
INSERT INTO `access_log` VALUES (32139, '62.89.15599022506881167', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:10:51', 13, 0, '', '2019-06-07 18:10:51');
INSERT INTO `access_log` VALUES (32140, '62.86.15599022524521155', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.56.60.67', '2019-06-07 18:10:52', 15, 0, '', '2019-06-07 18:10:52');
INSERT INTO `access_log` VALUES (32141, '64.77.15599030851521195', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:24:45', 6, 1002001012, '访问令牌已过期', '2019-06-07 18:24:45');
INSERT INTO `access_log` VALUES (32142, '64.84.15599030851521195', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:24:45', 7, 1002001012, '访问令牌已过期', '2019-06-07 18:24:45');
INSERT INTO `access_log` VALUES (32143, '65.45.15599030915311659', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:24:52', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 18:24:52');
INSERT INTO `access_log` VALUES (32144, '65.53.15599030982371625', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:24:58', 55, 0, '', '2019-06-07 18:24:58');
INSERT INTO `access_log` VALUES (32145, '65.50.15599030985851645', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:24:59', 46, 0, '', '2019-06-07 18:24:59');
INSERT INTO `access_log` VALUES (32146, '65.47.15599030985851651', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:24:59', 47, 0, '', '2019-06-07 18:24:59');
INSERT INTO `access_log` VALUES (32147, '65.52.15599030992121649', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:24:59', 10, 0, '', '2019-06-07 18:24:59');
INSERT INTO `access_log` VALUES (32148, '62.89.15599031150931179', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:25:15', 11, 0, '', '2019-06-07 18:25:15');
INSERT INTO `access_log` VALUES (32149, '62.86.15599031284471167', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=6&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:25:28', 12, 0, '', '2019-06-07 18:25:28');
INSERT INTO `access_log` VALUES (32150, '62.80.15599031301731185', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:25:30', 13, 0, '', '2019-06-07 18:25:30');
INSERT INTO `access_log` VALUES (32151, '64.83.15599031374061181', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:25:37', 130, 0, '', '2019-06-07 18:25:38');
INSERT INTO `access_log` VALUES (32152, '64.80.15599031373811187', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:25:37', 158, 0, '', '2019-06-07 18:25:38');
INSERT INTO `access_log` VALUES (32153, '66.51.15599031412119859', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:25:41', 20, 0, '', '2019-06-07 18:25:41');
INSERT INTO `access_log` VALUES (32154, '65.3607.15599031462343413', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:25:46', 20, 0, '', '2019-06-07 18:25:46');
INSERT INTO `access_log` VALUES (32155, '65.45.15599031509141661', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:25:51', 12, 0, '', '2019-06-07 18:25:51');
INSERT INTO `access_log` VALUES (32156, '65.53.15599031584571627', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:25:58', 16, 0, '', '2019-06-07 18:25:58');
INSERT INTO `access_log` VALUES (32157, '65.50.15599031592801647', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:25:59', 18, 0, '', '2019-06-07 18:25:59');
INSERT INTO `access_log` VALUES (32158, '65.47.15599031610521653', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=27', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 18:26:01', 9, 0, '', '2019-06-07 18:26:01');
INSERT INTO `access_log` VALUES (32159, '65.47.15599056754261687', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.242', '2019-06-07 19:07:55', 231, 1002001012, '访问令牌已过期', '2019-06-07 19:07:56');
INSERT INTO `access_log` VALUES (32160, '65.50.15599056754261681', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.242', '2019-06-07 19:07:55', 238, 1002001012, '访问令牌已过期', '2019-06-07 19:07:56');
INSERT INTO `access_log` VALUES (32161, '65.52.15599056754261685', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.242', '2019-06-07 19:07:55', 238, 1002001012, '访问令牌已过期', '2019-06-07 19:07:56');
INSERT INTO `access_log` VALUES (32162, '59.75.15599056754791389', 0, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.242', '2019-06-07 19:07:55', 191, 1002001012, '访问令牌已过期', '2019-06-07 19:07:56');
INSERT INTO `access_log` VALUES (32163, '65.46.15599056888111683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.242', '2019-06-07 19:08:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 19:08:09');
INSERT INTO `access_log` VALUES (32164, '65.51.15599056926281697', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.209.242', '2019-06-07 19:08:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 19:08:13');
INSERT INTO `access_log` VALUES (32165, '64.77.15599063425131239', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 19:19:03', 8, 1002001012, '访问令牌已过期', '2019-06-07 19:19:03');
INSERT INTO `access_log` VALUES (32166, '64.76.15599063432851221', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.154.228.203', '2019-06-07 19:19:03', 6, 1002001012, '访问令牌已过期', '2019-06-07 19:19:03');
INSERT INTO `access_log` VALUES (32167, '59.75.15599086681601429', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.153.95.84', '2019-06-07 19:57:48', 10, 0, '', '2019-06-07 19:57:48');
INSERT INTO `access_log` VALUES (32168, '59.78.15599086682691431', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.153.95.84', '2019-06-07 19:57:48', 12, 2001001000, '服务端发生异常', '2019-06-07 19:57:48');
INSERT INTO `access_log` VALUES (32169, '64.84.15599086921551271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.153.95.84', '2019-06-07 19:58:12', 10, 0, '', '2019-06-07 19:58:12');
INSERT INTO `access_log` VALUES (32170, '64.77.15599086922711271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.153.95.84', '2019-06-07 19:58:12', 3, 0, '', '2019-06-07 19:58:12');
INSERT INTO `access_log` VALUES (32171, '65.46.15599150832891809', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:44:43', 55, 1002001012, '访问令牌已过期', '2019-06-07 21:44:43');
INSERT INTO `access_log` VALUES (32172, '65.47.15599150832831813', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:44:43', 61, 1002001012, '访问令牌已过期', '2019-06-07 21:44:43');
INSERT INTO `access_log` VALUES (32173, '65.54.15599150833621771', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:44:43', 11, 1002001012, '访问令牌已过期', '2019-06-07 21:44:43');
INSERT INTO `access_log` VALUES (32174, '65.51.15599150889831823', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:44:49', 82, 0, '', '2019-06-07 21:44:49');
INSERT INTO `access_log` VALUES (32175, '65.3607.15599150893383575', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:44:49', 10, 0, '', '2019-06-07 21:44:49');
INSERT INTO `access_log` VALUES (32176, '65.45.15599150893411823', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:44:49', 8, 0, '', '2019-06-07 21:44:49');
INSERT INTO `access_log` VALUES (32177, '65.49.15599150893441837', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:44:49', 8, 0, '', '2019-06-07 21:44:49');
INSERT INTO `access_log` VALUES (32178, '62.80.15599150949001345', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:44:55', 1716, 0, '', '2019-06-07 21:44:57');
INSERT INTO `access_log` VALUES (32179, '59.78.15599151009331517', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:45:01', 43, 0, '', '2019-06-07 21:45:01');
INSERT INTO `access_log` VALUES (32180, '65.52.15599151048451813', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:45:05', 19, 0, '', '2019-06-07 21:45:05');
INSERT INTO `access_log` VALUES (32181, '65.47.15599151114471815', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:45:11', 1034, 0, '', '2019-06-07 21:45:12');
INSERT INTO `access_log` VALUES (32182, '65.54.15599151183671773', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:45:18', 20, 0, '', '2019-06-07 21:45:18');
INSERT INTO `access_log` VALUES (32183, '64.76.15599151273991339', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:45:27', 19, 0, '', '2019-06-07 21:45:27');
INSERT INTO `access_log` VALUES (32184, '64.77.15599151273951357', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:45:27', 23, 0, '', '2019-06-07 21:45:27');
INSERT INTO `access_log` VALUES (32185, '62.80.15599155040091351', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.239.129.8', '2019-06-07 21:51:44', 398, 0, '', '2019-06-07 21:51:44');
INSERT INTO `access_log` VALUES (32186, '59.77.15599163646291521', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.8.57.0', '2019-06-07 22:06:05', 5, 0, '', '2019-06-07 22:06:05');
INSERT INTO `access_log` VALUES (32187, '59.74.15599163646291527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.8.57.0', '2019-06-07 22:06:05', 14, 2001001000, '服务端发生异常', '2019-06-07 22:06:05');
INSERT INTO `access_log` VALUES (32188, '65.52.15599178935111851', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.93.189.15', '2019-06-07 22:31:34', 0, 1002001015, '账号未登陆', '2019-06-07 22:31:34');
INSERT INTO `access_log` VALUES (32189, '65.53.15599178935111827', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.93.189.15', '2019-06-07 22:31:34', 0, 1002001015, '账号未登陆', '2019-06-07 22:31:34');
INSERT INTO `access_log` VALUES (32190, '65.50.15599178935281847', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.93.189.15', '2019-06-07 22:31:34', 0, 1002001015, '账号未登陆', '2019-06-07 22:31:34');
INSERT INTO `access_log` VALUES (32191, '59.78.15599179019811555', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.93.189.15', '2019-06-07 22:31:42', 3, 0, '', '2019-06-07 22:31:42');
INSERT INTO `access_log` VALUES (32192, '59.71.15599179020081555', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.93.189.15', '2019-06-07 22:31:42', 13, 2001001000, '服务端发生异常', '2019-06-07 22:31:42');
INSERT INTO `access_log` VALUES (32193, '65.54.15599179124951811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.93.189.15', '2019-06-07 22:31:52', 101, 0, '', '2019-06-07 22:31:53');
INSERT INTO `access_log` VALUES (32194, '65.51.15599179189991863', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.93.189.15', '2019-06-07 22:31:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-07 22:31:59');
INSERT INTO `access_log` VALUES (32195, '64.84.15599179309771395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.93.189.15', '2019-06-07 22:32:11', 11, 0, '', '2019-06-07 22:32:11');
INSERT INTO `access_log` VALUES (32196, '64.76.15599179313241377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.93.189.15', '2019-06-07 22:32:11', 2, 0, '', '2019-06-07 22:32:11');
INSERT INTO `access_log` VALUES (32197, '65.3607.15599179438823615', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.93.189.15', '2019-06-07 22:32:24', 108, 0, '', '2019-06-07 22:32:24');
INSERT INTO `access_log` VALUES (32198, '59.74.15599179623891549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.93.189.15', '2019-06-07 22:32:42', 20, 2001001000, '服务端发生异常', '2019-06-07 22:32:42');
INSERT INTO `access_log` VALUES (32199, '59.77.15599179624061543', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.93.189.15', '2019-06-07 22:32:42', 531, 0, '', '2019-06-07 22:32:43');
INSERT INTO `access_log` VALUES (32200, '64.78.15599179673341395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.93.189.15', '2019-06-07 22:32:47', 2, 0, '', '2019-06-07 22:32:47');
INSERT INTO `access_log` VALUES (32201, '64.82.15599179674961401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.93.189.15', '2019-06-07 22:32:47', 2, 0, '', '2019-06-07 22:32:47');
INSERT INTO `access_log` VALUES (32202, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.158', '2019-06-07 23:12:42', 9, 0, '', '2019-06-07 23:12:42');
INSERT INTO `access_log` VALUES (32203, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=a', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.158', '2019-06-07 23:13:09', 6, 0, '', '2019-06-07 23:13:09');
INSERT INTO `access_log` VALUES (32204, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.73.158', '2019-06-07 23:13:15', 5, 0, '', '2019-06-07 23:13:15');
INSERT INTO `access_log` VALUES (32205, '65.3607.15599259178103723', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:45:18', 1, 1002001015, '账号未登陆', '2019-06-08 00:45:18');
INSERT INTO `access_log` VALUES (32206, '65.54.15599259178101919', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:45:18', 1, 1002001015, '账号未登陆', '2019-06-08 00:45:18');
INSERT INTO `access_log` VALUES (32207, '65.51.15599259178091971', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:45:18', 1, 1002001015, '账号未登陆', '2019-06-08 00:45:18');
INSERT INTO `access_log` VALUES (32208, '65.49.15599259243111985', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:45:24', 128, 0, '', '2019-06-08 00:45:24');
INSERT INTO `access_log` VALUES (32209, '65.53.15599259247901935', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:45:25', 209, 0, '', '2019-06-08 00:45:25');
INSERT INTO `access_log` VALUES (32210, '65.52.15599259247901961', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:45:25', 216, 0, '', '2019-06-08 00:45:25');
INSERT INTO `access_log` VALUES (32211, '65.50.15599259248751957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:45:25', 138, 0, '', '2019-06-08 00:45:25');
INSERT INTO `access_log` VALUES (32212, '64.84.15599259600531503', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:46:00', 25, 0, '', '2019-06-08 00:46:00');
INSERT INTO `access_log` VALUES (32213, '64.85.15599259600451515', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:46:00', 35, 0, '', '2019-06-08 00:46:00');
INSERT INTO `access_log` VALUES (32214, '64.81.15599259952091495', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:46:35', 11, 0, '', '2019-06-08 00:46:35');
INSERT INTO `access_log` VALUES (32215, '64.78.15599259952131503', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:46:35', 9, 0, '', '2019-06-08 00:46:35');
INSERT INTO `access_log` VALUES (32216, '64.80.15599259972861495', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:46:37', 10, 0, '', '2019-06-08 00:46:37');
INSERT INTO `access_log` VALUES (32217, '64.83.15599259972841489', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:46:37', 14, 0, '', '2019-06-08 00:46:37');
INSERT INTO `access_log` VALUES (32218, '64.79.15599259973481493', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:46:37', 9, 0, '', '2019-06-08 00:46:37');
INSERT INTO `access_log` VALUES (32219, '64.84.15599260081021505', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:46:48', 10, 0, '', '2019-06-08 00:46:48');
INSERT INTO `access_log` VALUES (32220, '65.49.15599260269661987', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:47:07', 16, 0, '', '2019-06-08 00:47:07');
INSERT INTO `access_log` VALUES (32221, '59.74.15599260525631657', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:47:33', 13, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-08 00:47:33');
INSERT INTO `access_log` VALUES (32222, '64.78.15599260629341505', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:47:43', 11, 0, '', '2019-06-08 00:47:43');
INSERT INTO `access_log` VALUES (32223, '64.82.15599260629421511', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.45.201.211', '2019-06-08 00:47:43', 8, 0, '', '2019-06-08 00:47:43');
INSERT INTO `access_log` VALUES (32224, '59.75.15599280090501689', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:09', 12, 0, '', '2019-06-08 01:20:09');
INSERT INTO `access_log` VALUES (32225, '59.78.15599280090611691', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:09', 20, 2001001000, '服务端发生异常', '2019-06-08 01:20:09');
INSERT INTO `access_log` VALUES (32226, '64.80.15599280162071523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:16', 12, 0, '', '2019-06-08 01:20:16');
INSERT INTO `access_log` VALUES (32227, '64.83.15599280163611517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:16', 3, 0, '', '2019-06-08 01:20:16');
INSERT INTO `access_log` VALUES (32228, '64.79.15599280187441521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:19', 2, 0, '', '2019-06-08 01:20:19');
INSERT INTO `access_log` VALUES (32229, '64.84.15599280197951533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:20', 2, 0, '', '2019-06-08 01:20:20');
INSERT INTO `access_log` VALUES (32230, '64.76.15599280206401515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:21', 2, 0, '', '2019-06-08 01:20:21');
INSERT INTO `access_log` VALUES (32231, '59.80.15599280248721679', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:25', 3, 0, '', '2019-06-08 01:20:25');
INSERT INTO `access_log` VALUES (32232, '59.73.15599280248731691', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:25', 19, 2001001000, '服务端发生异常', '2019-06-08 01:20:25');
INSERT INTO `access_log` VALUES (32233, '64.77.15599280276611533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:28', 2, 0, '', '2019-06-08 01:20:28');
INSERT INTO `access_log` VALUES (32234, '64.81.15599280278061525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:28', 2, 0, '', '2019-06-08 01:20:28');
INSERT INTO `access_log` VALUES (32235, '65.3607.15599280467083753', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:47', 0, 1002001015, '账号未登陆', '2019-06-08 01:20:47');
INSERT INTO `access_log` VALUES (32236, '65.54.15599280467081949', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:47', 0, 1002001015, '账号未登陆', '2019-06-08 01:20:47');
INSERT INTO `access_log` VALUES (32237, '65.51.15599280467092001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:47', 0, 1002001015, '账号未登陆', '2019-06-08 01:20:47');
INSERT INTO `access_log` VALUES (32238, '65.45.15599280491962001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 01:20:49');
INSERT INTO `access_log` VALUES (32239, '65.50.15599280554361987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:20:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 01:20:55');
INSERT INTO `access_log` VALUES (32240, '65.53.15599280747981965', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:21:15', 99, 0, '', '2019-06-08 01:21:15');
INSERT INTO `access_log` VALUES (32241, '65.47.15599280752381991', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:21:15', 12, 0, '', '2019-06-08 01:21:15');
INSERT INTO `access_log` VALUES (32242, '65.46.15599280752381989', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:21:15', 13, 0, '', '2019-06-08 01:21:15');
INSERT INTO `access_log` VALUES (32243, '65.51.15599280752432003', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:21:15', 11, 0, '', '2019-06-08 01:21:15');
INSERT INTO `access_log` VALUES (32244, '66.55.15599280830590197', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:21:23', 21, 0, '', '2019-06-08 01:21:23');
INSERT INTO `access_log` VALUES (32245, '65.54.15599280902711951', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:21:30', 18, 0, '', '2019-06-08 01:21:30');
INSERT INTO `access_log` VALUES (32246, '65.45.15599280953272003', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:21:35', 11, 0, '', '2019-06-08 01:21:35');
INSERT INTO `access_log` VALUES (32247, '65.50.15599281038151989', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:21:44', 247, 0, '', '2019-06-08 01:21:44');
INSERT INTO `access_log` VALUES (32248, '62.82.15599281093161511', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:64.0) Gecko/20100101 Firefox/64.0', '111.34.236.249', '2019-06-08 01:21:49', 30, 0, '', '2019-06-08 01:21:49');
INSERT INTO `access_log` VALUES (32249, '65.49.15599573253042407', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:28:45', 0, 1002001015, '账号未登陆', '2019-06-08 09:28:45');
INSERT INTO `access_log` VALUES (32250, '65.50.15599573253042379', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:28:45', 0, 1002001015, '账号未登陆', '2019-06-08 09:28:45');
INSERT INTO `access_log` VALUES (32251, '65.52.15599573253182383', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:28:45', 1, 1002001015, '账号未登陆', '2019-06-08 09:28:45');
INSERT INTO `access_log` VALUES (32252, '65.53.15599573276352357', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:28:48', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 09:28:48');
INSERT INTO `access_log` VALUES (32253, '65.47.15599573343212383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:28:54', 94, 0, '', '2019-06-08 09:28:54');
INSERT INTO `access_log` VALUES (32254, '65.51.15599573346702395', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:28:55', 13, 0, '', '2019-06-08 09:28:55');
INSERT INTO `access_log` VALUES (32255, '65.3607.15599573346754147', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:28:55', 8, 0, '', '2019-06-08 09:28:55');
INSERT INTO `access_log` VALUES (32256, '65.54.15599573346782343', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:28:55', 10, 0, '', '2019-06-08 09:28:55');
INSERT INTO `access_log` VALUES (32257, '62.82.15599573397661901', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:29:00', 22, 0, '', '2019-06-08 09:29:00');
INSERT INTO `access_log` VALUES (32258, '62.81.15599573430271881', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:29:03', 16, 0, '', '2019-06-08 09:29:03');
INSERT INTO `access_log` VALUES (32259, '64.85.15599573465351937', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:29:07', 27, 0, '', '2019-06-08 09:29:07');
INSERT INTO `access_log` VALUES (32260, '64.84.15599573465331925', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:29:07', 32, 0, '', '2019-06-08 09:29:07');
INSERT INTO `access_log` VALUES (32261, '64.81.15599573635831917', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:29:24', 24, 0, '', '2019-06-08 09:29:24');
INSERT INTO `access_log` VALUES (32262, '64.77.15599573635811925', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:29:24', 32, 0, '', '2019-06-08 09:29:24');
INSERT INTO `access_log` VALUES (32263, '59.78.15599573692922083', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.182.136.113', '2019-06-08 09:29:29', 21, 0, '', '2019-06-08 09:29:29');
INSERT INTO `access_log` VALUES (32264, '65.54.15599591285432367', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-08 09:58:49', 11, 1002001012, '访问令牌已过期', '2019-06-08 09:58:49');
INSERT INTO `access_log` VALUES (32265, '65.50.15599591285432405', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-08 09:58:49', 11, 1002001012, '访问令牌已过期', '2019-06-08 09:58:49');
INSERT INTO `access_log` VALUES (32266, '65.45.15599591285432419', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-08 09:58:49', 11, 1002001012, '访问令牌已过期', '2019-06-08 09:58:49');
INSERT INTO `access_log` VALUES (32267, '65.53.15599591586082383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-08 09:59:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 09:59:19');
INSERT INTO `access_log` VALUES (32268, '65.46.15599591624372407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-08 09:59:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 09:59:22');
INSERT INTO `access_log` VALUES (32269, '65.51.15599591717212421', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-08 09:59:32', 104, 0, '', '2019-06-08 09:59:32');
INSERT INTO `access_log` VALUES (32270, '65.3607.15599591725244173', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-08 09:59:33', 10, 0, '', '2019-06-08 09:59:33');
INSERT INTO `access_log` VALUES (32271, '65.50.15599591725282407', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-08 09:59:33', 10, 0, '', '2019-06-08 09:59:33');
INSERT INTO `access_log` VALUES (32272, '65.54.15599591725312369', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-08 09:59:33', 9, 0, '', '2019-06-08 09:59:33');
INSERT INTO `access_log` VALUES (32273, '62.80.15599591772901935', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-08 09:59:37', 578, 0, '', '2019-06-08 09:59:38');
INSERT INTO `access_log` VALUES (32274, '66.50.15599591804090603', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-08 09:59:40', 20, 0, '', '2019-06-08 09:59:40');
INSERT INTO `access_log` VALUES (32275, '59.80.15599591837182095', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '60.25.8.104', '2019-06-08 09:59:44', 15, 0, '', '2019-06-08 09:59:44');
INSERT INTO `access_log` VALUES (32276, '59.71.15599607814222129', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:26:21', 4, 0, '', '2019-06-08 10:26:21');
INSERT INTO `access_log` VALUES (32277, '59.78.15599607814222129', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:26:21', 17, 2001001000, '服务端发生异常', '2019-06-08 10:26:21');
INSERT INTO `access_log` VALUES (32278, '65.3607.15599607880294195', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:26:28', 0, 1002001015, '账号未登陆', '2019-06-08 10:26:28');
INSERT INTO `access_log` VALUES (32279, '65.54.15599607880302391', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:26:28', 0, 1002001015, '账号未登陆', '2019-06-08 10:26:28');
INSERT INTO `access_log` VALUES (32280, '65.45.15599607880302443', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:26:28', 1, 1002001015, '账号未登陆', '2019-06-08 10:26:28');
INSERT INTO `access_log` VALUES (32281, '64.78.15599607981331971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:26:38', 11, 0, '', '2019-06-08 10:26:38');
INSERT INTO `access_log` VALUES (32282, '64.82.15599607983151977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:26:38', 2, 0, '', '2019-06-08 10:26:38');
INSERT INTO `access_log` VALUES (32283, '64.80.15599608010091961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:26:41', 2, 0, '', '2019-06-08 10:26:41');
INSERT INTO `access_log` VALUES (32284, '64.83.15599608011921957', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:26:41', 2, 0, '', '2019-06-08 10:26:41');
INSERT INTO `access_log` VALUES (32285, '64.79.15599608019121961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:26:42', 2, 0, '', '2019-06-08 10:26:42');
INSERT INTO `access_log` VALUES (32286, '65.53.15599608268292407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yundaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:27:07', 4, 1002002000, '账号不存在', '2019-06-08 10:27:07');
INSERT INTO `access_log` VALUES (32287, '65.47.15599608309202433', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:27:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 10:27:11');
INSERT INTO `access_log` VALUES (32288, '65.50.15599608443332431', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yundaoyuanma&password=yundaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:27:24', 4, 1002002000, '账号不存在', '2019-06-08 10:27:24');
INSERT INTO `access_log` VALUES (32289, '65.52.15599608891572435', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:28:09', 173, 0, '', '2019-06-08 10:28:09');
INSERT INTO `access_log` VALUES (32290, '65.49.15599608906152459', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:28:11', 562, 0, '', '2019-06-08 10:28:11');
INSERT INTO `access_log` VALUES (32291, '65.46.15599608906872433', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:28:11', 493, 0, '', '2019-06-08 10:28:11');
INSERT INTO `access_log` VALUES (32292, '65.53.15599608906222409', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:28:11', 557, 0, '', '2019-06-08 10:28:11');
INSERT INTO `access_log` VALUES (32293, '62.81.15599609137971929', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.180.238.65', '2019-06-08 10:28:34', 14, 0, '', '2019-06-08 10:28:34');
INSERT INTO `access_log` VALUES (32294, '59.77.15599648902722171', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.196.82.6', '2019-06-08 11:34:50', 11, 0, '', '2019-06-08 11:34:50');
INSERT INTO `access_log` VALUES (32295, '59.74.15599648902732177', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.196.82.6', '2019-06-08 11:34:50', 16, 2001001000, '服务端发生异常', '2019-06-08 11:34:50');
INSERT INTO `access_log` VALUES (32296, '64.81.15599649090312019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '111.196.82.6', '2019-06-08 11:35:09', 10, 0, '', '2019-06-08 11:35:09');
INSERT INTO `access_log` VALUES (32297, '64.78.15599649091562027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '111.196.82.6', '2019-06-08 11:35:09', 3, 0, '', '2019-06-08 11:35:09');
INSERT INTO `access_log` VALUES (32298, '64.82.15599649112212033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '111.196.82.6', '2019-06-08 11:35:11', 2, 0, '', '2019-06-08 11:35:11');
INSERT INTO `access_log` VALUES (32299, '64.80.15599649124372017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '111.196.82.6', '2019-06-08 11:35:12', 125, 0, '', '2019-06-08 11:35:13');
INSERT INTO `access_log` VALUES (32300, '64.83.15599649138992013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '111.196.82.6', '2019-06-08 11:35:14', 5, 0, '', '2019-06-08 11:35:14');
INSERT INTO `access_log` VALUES (32301, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '111.196.82.6', '2019-06-08 11:35:14', 13, 0, '', '2019-06-08 11:35:14');
INSERT INTO `access_log` VALUES (32302, '64.79.15599649173792017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '111.196.82.6', '2019-06-08 11:35:17', 176, 0, '', '2019-06-08 11:35:18');
INSERT INTO `access_log` VALUES (32303, '64.85.15599649177172041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '111.196.82.6', '2019-06-08 11:35:18', 3, 0, '', '2019-06-08 11:35:18');
INSERT INTO `access_log` VALUES (32304, '64.84.15599649194432029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '111.196.82.6', '2019-06-08 11:35:19', 2, 0, '', '2019-06-08 11:35:19');
INSERT INTO `access_log` VALUES (32305, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '111.196.82.6', '2019-06-08 11:35:19', 7, 0, '', '2019-06-08 11:35:19');
INSERT INTO `access_log` VALUES (32306, '64.77.15599649222242029', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '111.196.82.6', '2019-06-08 11:35:22', 8, 0, '', '2019-06-08 11:35:22');
INSERT INTO `access_log` VALUES (32307, '65.53.15599685146212511', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.69.197', '2019-06-08 12:35:15', 1, 1002001015, '账号未登陆', '2019-06-08 12:35:15');
INSERT INTO `access_log` VALUES (32308, '65.49.15599685146212561', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:35:15', 0, 1002001015, '账号未登陆', '2019-06-08 12:35:15');
INSERT INTO `access_log` VALUES (32309, '65.47.15599685146212537', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.69.197', '2019-06-08 12:35:15', 0, 1002001015, '账号未登陆', '2019-06-08 12:35:15');
INSERT INTO `access_log` VALUES (32310, '65.50.15599685317932535', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:35:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 12:35:32');
INSERT INTO `access_log` VALUES (32311, '65.3607.15599685377324301', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:35:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 12:35:38');
INSERT INTO `access_log` VALUES (32312, '65.52.15599685632902539', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:36:03', 142, 0, '', '2019-06-08 12:36:03');
INSERT INTO `access_log` VALUES (32313, '65.46.15599685637842537', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.69.197', '2019-06-08 12:36:04', 11, 0, '', '2019-06-08 12:36:04');
INSERT INTO `access_log` VALUES (32314, '65.49.15599685637882563', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:36:04', 9, 0, '', '2019-06-08 12:36:04');
INSERT INTO `access_log` VALUES (32315, '65.53.15599685637902513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:36:04', 11, 0, '', '2019-06-08 12:36:04');
INSERT INTO `access_log` VALUES (32316, '64.80.15599685797142067', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:36:20', 23, 0, '', '2019-06-08 12:36:20');
INSERT INTO `access_log` VALUES (32317, '64.83.15599685797222063', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:36:20', 17, 0, '', '2019-06-08 12:36:20');
INSERT INTO `access_log` VALUES (32318, '64.84.15599685893092079', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:36:29', 12, 0, '', '2019-06-08 12:36:29');
INSERT INTO `access_log` VALUES (32319, '64.85.15599685893072091', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:36:29', 16, 0, '', '2019-06-08 12:36:29');
INSERT INTO `access_log` VALUES (32320, '64.76.15599685949072061', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:36:35', 18, 0, '', '2019-06-08 12:36:35');
INSERT INTO `access_log` VALUES (32321, '64.77.15599685949382079', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:36:35', 10, 0, '', '2019-06-08 12:36:35');
INSERT INTO `access_log` VALUES (32322, '64.81.15599685949402071', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:36:35', 9, 0, '', '2019-06-08 12:36:35');
INSERT INTO `access_log` VALUES (32323, '59.79.15599686105512233', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:36:51', 25, 0, '', '2019-06-08 12:36:51');
INSERT INTO `access_log` VALUES (32324, '59.80.15599686190232221', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:36:59', 25, 2001001000, '服务端发生异常', '2019-06-08 12:36:59');
INSERT INTO `access_log` VALUES (32325, '59.73.15599686212252233', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:37:01', 17, 0, '', '2019-06-08 12:37:01');
INSERT INTO `access_log` VALUES (32326, '64.80.15599686232622069', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:37:03', 11, 0, '', '2019-06-08 12:37:03');
INSERT INTO `access_log` VALUES (32327, '64.79.15599686331132069', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:37:13', 7, 0, '', '2019-06-08 12:37:13');
INSERT INTO `access_log` VALUES (32328, '59.74.15599686356122229', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.69.197', '2019-06-08 12:37:16', 24, 0, '', '2019-06-08 12:37:16');
INSERT INTO `access_log` VALUES (32329, '59.76.15599686464792225', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.69.197', '2019-06-08 12:37:26', 11, 0, '', '2019-06-08 12:37:26');
INSERT INTO `access_log` VALUES (32330, '59.75.15599686472192235', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.69.197', '2019-06-08 12:37:27', 14, 0, '', '2019-06-08 12:37:27');
INSERT INTO `access_log` VALUES (32331, '59.71.15599686479652235', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.69.197', '2019-06-08 12:37:28', 11, 0, '', '2019-06-08 12:37:28');
INSERT INTO `access_log` VALUES (32332, '59.78.15599686486572235', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=INVALID&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:37:29', 214, 0, '', '2019-06-08 12:37:29');
INSERT INTO `access_log` VALUES (32333, '59.79.15599686495732235', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:37:30', 43, 0, '', '2019-06-08 12:37:30');
INSERT INTO `access_log` VALUES (32334, '65.46.15599686621652539', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:37:42', 17, 0, '', '2019-06-08 12:37:42');
INSERT INTO `access_log` VALUES (32335, '65.49.15599686651402565', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:37:45', 10, 0, '', '2019-06-08 12:37:45');
INSERT INTO `access_log` VALUES (32336, '65.53.15599686669472515', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:37:47', 9, 0, '', '2019-06-08 12:37:47');
INSERT INTO `access_log` VALUES (32337, '65.47.15599686708802541', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.69.197', '2019-06-08 12:37:51', 14, 0, '', '2019-06-08 12:37:51');
INSERT INTO `access_log` VALUES (32338, '65.50.15599686821322539', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:38:02', 7, 0, '', '2019-06-08 12:38:02');
INSERT INTO `access_log` VALUES (32339, '66.56.15599686836360729', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.69.197', '2019-06-08 12:38:04', 21, 0, '', '2019-06-08 12:38:04');
INSERT INTO `access_log` VALUES (32340, '64.77.15599686872562081', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.11.39.159', '2019-06-08 12:38:07', 9, 0, '', '2019-06-08 12:38:07');
INSERT INTO `access_log` VALUES (32341, '65.47.15599716403062581', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-08 13:27:20', 0, 1002001015, '账号未登陆', '2019-06-08 13:27:20');
INSERT INTO `access_log` VALUES (32342, '65.50.15599716403072579', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-08 13:27:20', 0, 1002001015, '账号未登陆', '2019-06-08 13:27:20');
INSERT INTO `access_log` VALUES (32343, '65.51.15599716403072593', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-08 13:27:20', 0, 1002001015, '账号未登陆', '2019-06-08 13:27:20');
INSERT INTO `access_log` VALUES (32344, '65.54.15599716503742541', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-08 13:27:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 13:27:30');
INSERT INTO `access_log` VALUES (32345, '65.52.15599716608602583', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-08 13:27:41', 92, 0, '', '2019-06-08 13:27:41');
INSERT INTO `access_log` VALUES (32346, '65.46.15599716611832581', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-08 13:27:41', 13, 0, '', '2019-06-08 13:27:41');
INSERT INTO `access_log` VALUES (32347, '65.53.15599716611892557', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-08 13:27:41', 11, 0, '', '2019-06-08 13:27:41');
INSERT INTO `access_log` VALUES (32348, '65.49.15599716611872607', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-08 13:27:41', 12, 0, '', '2019-06-08 13:27:41');
INSERT INTO `access_log` VALUES (32349, '62.81.15599716676192073', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-08 13:27:48', 37, 0, '', '2019-06-08 13:27:48');
INSERT INTO `access_log` VALUES (32350, '64.77.15599716722422121', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-08 13:27:52', 21, 0, '', '2019-06-08 13:27:52');
INSERT INTO `access_log` VALUES (32351, '64.78.15599716722792121', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-08 13:27:52', 10, 0, '', '2019-06-08 13:27:52');
INSERT INTO `access_log` VALUES (32352, '59.76.15599732042772287', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:53:24', 16, 2001001000, '服务端发生异常', '2019-06-08 13:53:24');
INSERT INTO `access_log` VALUES (32353, '59.77.15599732042772285', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:53:24', 17, 0, '', '2019-06-08 13:53:24');
INSERT INTO `access_log` VALUES (32354, '59.75.15599732093742297', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:53:29', 3, 0, '', '2019-06-08 13:53:29');
INSERT INTO `access_log` VALUES (32355, '59.71.15599732093742297', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:53:29', 13, 2001001000, '服务端发生异常', '2019-06-08 13:53:29');
INSERT INTO `access_log` VALUES (32356, '64.83.15599732137912127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:53:34', 3, 0, '', '2019-06-08 13:53:34');
INSERT INTO `access_log` VALUES (32357, '64.79.15599732139012131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:53:34', 3, 0, '', '2019-06-08 13:53:34');
INSERT INTO `access_log` VALUES (32358, '64.84.15599732148962143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:53:35', 36, 0, '', '2019-06-08 13:53:35');
INSERT INTO `access_log` VALUES (32359, '64.85.15599732155152155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:53:36', 1, 0, '', '2019-06-08 13:53:36');
INSERT INTO `access_log` VALUES (32360, '64.81.15599732158622135', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:53:36', 2, 0, '', '2019-06-08 13:53:36');
INSERT INTO `access_log` VALUES (32361, '64.77.15599732162972143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:53:36', 13, 0, '', '2019-06-08 13:53:36');
INSERT INTO `access_log` VALUES (32362, '64.78.15599732224282143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:42', 2, 0, '', '2019-06-08 13:53:42');
INSERT INTO `access_log` VALUES (32363, '64.82.15599732225102149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:43', 2, 0, '', '2019-06-08 13:53:43');
INSERT INTO `access_log` VALUES (32364, '64.80.15599732237282133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:44', 2, 0, '', '2019-06-08 13:53:44');
INSERT INTO `access_log` VALUES (32365, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:44', 39, 0, '', '2019-06-08 13:53:44');
INSERT INTO `access_log` VALUES (32366, '64.83.15599732255912129', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:46', 8, 0, '', '2019-06-08 13:53:46');
INSERT INTO `access_log` VALUES (32367, '64.79.15599732269132133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:47', 2, 0, '', '2019-06-08 13:53:47');
INSERT INTO `access_log` VALUES (32368, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:47', 6, 0, '', '2019-06-08 13:53:47');
INSERT INTO `access_log` VALUES (32369, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:48', 6, 0, '', '2019-06-08 13:53:48');
INSERT INTO `access_log` VALUES (32370, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:49', 6, 0, '', '2019-06-08 13:53:49');
INSERT INTO `access_log` VALUES (32371, '64.84.15599732297802145', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:50', 6, 0, '', '2019-06-08 13:53:50');
INSERT INTO `access_log` VALUES (32372, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:51', 6, 0, '', '2019-06-08 13:53:51');
INSERT INTO `access_log` VALUES (32373, '64.85.15599732312472157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:51', 35, 0, '', '2019-06-08 13:53:51');
INSERT INTO `access_log` VALUES (32374, '64.81.15599732317012137', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:52', 5, 0, '', '2019-06-08 13:53:52');
INSERT INTO `access_log` VALUES (32375, '64.77.15599732326002145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:53', 2, 0, '', '2019-06-08 13:53:53');
INSERT INTO `access_log` VALUES (32376, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:53', 6, 0, '', '2019-06-08 13:53:53');
INSERT INTO `access_log` VALUES (32377, '64.78.15599732331762145', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:53', 6, 0, '', '2019-06-08 13:53:53');
INSERT INTO `access_log` VALUES (32378, '64.82.15599732343892151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:54', 1, 0, '', '2019-06-08 13:53:54');
INSERT INTO `access_log` VALUES (32379, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.62.69', '2019-06-08 13:53:54', 6, 0, '', '2019-06-08 13:53:54');
INSERT INTO `access_log` VALUES (32380, '65.47.15599732947522605', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:54:55', 1, 1002001015, '账号未登陆', '2019-06-08 13:54:55');
INSERT INTO `access_log` VALUES (32381, '65.46.15599732947522603', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:54:55', 1, 1002001015, '账号未登陆', '2019-06-08 13:54:55');
INSERT INTO `access_log` VALUES (32382, '65.50.15599732947742603', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:54:55', 0, 1002001015, '账号未登陆', '2019-06-08 13:54:55');
INSERT INTO `access_log` VALUES (32383, '65.51.15599732971352617', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:54:57', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 13:54:57');
INSERT INTO `access_log` VALUES (32384, '65.3607.15599733013484369', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:01', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 13:55:01');
INSERT INTO `access_log` VALUES (32385, '65.54.15599733029662565', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 13:55:03');
INSERT INTO `access_log` VALUES (32386, '65.45.15599733042462617', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 13:55:04');
INSERT INTO `access_log` VALUES (32387, '65.52.15599733055812607', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 13:55:06');
INSERT INTO `access_log` VALUES (32388, '65.49.15599733183872631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:18', 63, 0, '', '2019-06-08 13:55:18');
INSERT INTO `access_log` VALUES (32389, '65.50.15599733186402605', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:19', 92, 0, '', '2019-06-08 13:55:19');
INSERT INTO `access_log` VALUES (32390, '65.46.15599733186382605', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:19', 93, 0, '', '2019-06-08 13:55:19');
INSERT INTO `access_log` VALUES (32391, '65.47.15599733186382607', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:19', 96, 0, '', '2019-06-08 13:55:19');
INSERT INTO `access_log` VALUES (32392, '62.84.15599733224132107', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:22', 11, 0, '', '2019-06-08 13:55:22');
INSERT INTO `access_log` VALUES (32393, '64.77.15599733283802147', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:28', 9, 0, '', '2019-06-08 13:55:28');
INSERT INTO `access_log` VALUES (32394, '64.81.15599733283772139', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:28', 12, 0, '', '2019-06-08 13:55:28');
INSERT INTO `access_log` VALUES (32395, '64.82.15599733316612153', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:32', 622, 0, '', '2019-06-08 13:55:32');
INSERT INTO `access_log` VALUES (32396, '64.78.15599733316612147', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:32', 625, 0, '', '2019-06-08 13:55:32');
INSERT INTO `access_log` VALUES (32397, '64.83.15599733359522133', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:36', 9, 0, '', '2019-06-08 13:55:36');
INSERT INTO `access_log` VALUES (32398, '64.79.15599733397332137', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:40', 11, 0, '', '2019-06-08 13:55:40');
INSERT INTO `access_log` VALUES (32399, '64.84.15599733397332149', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:40', 11, 0, '', '2019-06-08 13:55:40');
INSERT INTO `access_log` VALUES (32400, '64.85.15599733449292161', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:45', 11, 0, '', '2019-06-08 13:55:45');
INSERT INTO `access_log` VALUES (32401, '64.81.15599733449322141', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:45', 10, 0, '', '2019-06-08 13:55:45');
INSERT INTO `access_log` VALUES (32402, '64.76.15599733449292131', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:55:45', 14, 0, '', '2019-06-08 13:55:45');
INSERT INTO `access_log` VALUES (32403, '64.78.15599733626152149', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 13:56:03', 14, 0, '', '2019-06-08 13:56:03');
INSERT INTO `access_log` VALUES (32404, '65.45.15599739684332627', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.35.188.118', '2019-06-08 14:06:08', 0, 1002001015, '账号未登陆', '2019-06-08 14:06:08');
INSERT INTO `access_log` VALUES (32405, '65.52.15599739684412617', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.35.188.118', '2019-06-08 14:06:08', 9, 1002001015, '账号未登陆', '2019-06-08 14:06:08');
INSERT INTO `access_log` VALUES (32406, '65.53.15599739684552591', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.35.188.118', '2019-06-08 14:06:08', 1, 1002001015, '账号未登陆', '2019-06-08 14:06:08');
INSERT INTO `access_log` VALUES (32407, '65.47.15599739764842617', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.35.188.118', '2019-06-08 14:06:16', 79, 0, '', '2019-06-08 14:06:17');
INSERT INTO `access_log` VALUES (32408, '65.46.15599739769772615', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.35.188.118', '2019-06-08 14:06:17', 9, 0, '', '2019-06-08 14:06:17');
INSERT INTO `access_log` VALUES (32409, '65.50.15599739769872615', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.35.188.118', '2019-06-08 14:06:17', 9, 0, '', '2019-06-08 14:06:17');
INSERT INTO `access_log` VALUES (32410, '65.51.15599739769902629', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.35.188.118', '2019-06-08 14:06:17', 9, 0, '', '2019-06-08 14:06:17');
INSERT INTO `access_log` VALUES (32411, '65.54.15599739848782577', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.35.188.118', '2019-06-08 14:06:25', 9, 0, '', '2019-06-08 14:06:25');
INSERT INTO `access_log` VALUES (32412, '65.45.15599739848782629', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.35.188.118', '2019-06-08 14:06:25', 10, 0, '', '2019-06-08 14:06:25');
INSERT INTO `access_log` VALUES (32413, '65.52.15599739848782619', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.35.188.118', '2019-06-08 14:06:25', 10, 0, '', '2019-06-08 14:06:25');
INSERT INTO `access_log` VALUES (32414, '62.88.15599739916762135', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.35.188.118', '2019-06-08 14:06:32', 14, 0, '', '2019-06-08 14:06:32');
INSERT INTO `access_log` VALUES (32415, '59.72.15599770116072345', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 14:56:52', 9, 0, '', '2019-06-08 14:56:52');
INSERT INTO `access_log` VALUES (32416, '59.74.15599770116112343', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 14:56:52', 11, 2001001000, '服务端发生异常', '2019-06-08 14:56:52');
INSERT INTO `access_log` VALUES (32417, '65.54.15599815207932677', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:12:01', 0, 1002001015, '账号未登陆', '2019-06-08 16:12:01');
INSERT INTO `access_log` VALUES (32418, '65.52.15599815207932721', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:12:01', 0, 1002001015, '账号未登陆', '2019-06-08 16:12:01');
INSERT INTO `access_log` VALUES (32419, '65.46.15599815208022717', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:12:01', 1, 1002001015, '账号未登陆', '2019-06-08 16:12:01');
INSERT INTO `access_log` VALUES (32420, '65.45.15599815248702729', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:12:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 16:12:05');
INSERT INTO `access_log` VALUES (32421, '65.50.15599815295582719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:12:10', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 16:12:10');
INSERT INTO `access_log` VALUES (32422, '65.47.15599815551942721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:12:35', 436, 0, '', '2019-06-08 16:12:36');
INSERT INTO `access_log` VALUES (32423, '65.51.15599815562892733', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:12:36', 10, 0, '', '2019-06-08 16:12:36');
INSERT INTO `access_log` VALUES (32424, '65.3607.15599815562994485', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:12:36', 9, 0, '', '2019-06-08 16:12:36');
INSERT INTO `access_log` VALUES (32425, '65.54.15599815563082679', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:12:36', 9, 0, '', '2019-06-08 16:12:36');
INSERT INTO `access_log` VALUES (32426, '62.80.15599815641322235', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:12:44', 20, 0, '', '2019-06-08 16:12:44');
INSERT INTO `access_log` VALUES (32427, '66.49.15599815776080917', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:12:58', 21, 0, '', '2019-06-08 16:12:58');
INSERT INTO `access_log` VALUES (32428, '59.79.15599815843382409', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:13:04', 19, 0, '', '2019-06-08 16:13:04');
INSERT INTO `access_log` VALUES (32429, '65.45.15599815879872731', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:13:08', 17, 0, '', '2019-06-08 16:13:08');
INSERT INTO `access_log` VALUES (32430, '65.50.15599815893992721', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:13:09', 22, 0, '', '2019-06-08 16:13:09');
INSERT INTO `access_log` VALUES (32431, '65.49.15599815920752747', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:13:12', 11, 0, '', '2019-06-08 16:13:12');
INSERT INTO `access_log` VALUES (32432, '65.47.15599815988572723', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:13:19', 9, 0, '', '2019-06-08 16:13:19');
INSERT INTO `access_log` VALUES (32433, '65.54.15599816057812681', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:13:26', 1, 1002001015, '账号未登陆', '2019-06-08 16:13:26');
INSERT INTO `access_log` VALUES (32434, '65.51.15599816057882735', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:13:26', 1, 1002001015, '账号未登陆', '2019-06-08 16:13:26');
INSERT INTO `access_log` VALUES (32435, '65.46.15599816057962721', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:13:26', 0, 1002001015, '账号未登陆', '2019-06-08 16:13:26');
INSERT INTO `access_log` VALUES (32436, '65.52.15599816084512725', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:13:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 16:13:28');
INSERT INTO `access_log` VALUES (32437, '65.45.15599816136072733', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '119.130.230.48', '2019-06-08 16:13:34', 14, 0, '', '2019-06-08 16:13:34');
INSERT INTO `access_log` VALUES (32438, '65.53.15599816144752699', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:13:34', 95, 0, '', '2019-06-08 16:13:35');
INSERT INTO `access_log` VALUES (32439, '65.50.15599816149222723', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:13:35', 509, 0, '', '2019-06-08 16:13:35');
INSERT INTO `access_log` VALUES (32440, '65.49.15599816149252749', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:13:35', 505, 0, '', '2019-06-08 16:13:35');
INSERT INTO `access_log` VALUES (32441, '65.47.15599816149302725', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:13:35', 502, 0, '', '2019-06-08 16:13:35');
INSERT INTO `access_log` VALUES (32442, '62.89.15599816272552231', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:13:47', 14, 0, '', '2019-06-08 16:13:47');
INSERT INTO `access_log` VALUES (32443, '64.79.15599816497392249', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:14:10', 16, 0, '', '2019-06-08 16:14:10');
INSERT INTO `access_log` VALUES (32444, '64.84.15599816497352261', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:14:10', 23, 0, '', '2019-06-08 16:14:10');
INSERT INTO `access_log` VALUES (32445, '64.85.15599816567102273', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:14:17', 804, 0, '', '2019-06-08 16:14:18');
INSERT INTO `access_log` VALUES (32446, '64.76.15599816567072243', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:14:17', 807, 0, '', '2019-06-08 16:14:18');
INSERT INTO `access_log` VALUES (32447, '64.77.15599816691432261', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:14:29', 8, 0, '', '2019-06-08 16:14:29');
INSERT INTO `access_log` VALUES (32448, '59.71.15599816972152411', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:14:57', 13, 0, '', '2019-06-08 16:14:57');
INSERT INTO `access_log` VALUES (32449, '59.79.15599817111592411', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:15:11', 21, 2001001000, '服务端发生异常', '2019-06-08 16:15:11');
INSERT INTO `access_log` VALUES (32450, '65.47.15599817177702727', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:15:18', 19, 0, '', '2019-06-08 16:15:18');
INSERT INTO `access_log` VALUES (32451, '65.50.15599817278202725', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:15:28', 10, 0, '', '2019-06-08 16:15:28');
INSERT INTO `access_log` VALUES (32452, '65.3607.15599817301664491', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:15:30', 10, 0, '', '2019-06-08 16:15:30');
INSERT INTO `access_log` VALUES (32453, '65.51.15599817432502739', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.13.9.250', '2019-06-08 16:15:43', 11, 0, '', '2019-06-08 16:15:43');
INSERT INTO `access_log` VALUES (32454, '59.72.15599819091092411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.97.201.57', '2019-06-08 16:18:29', 4, 0, '', '2019-06-08 16:18:29');
INSERT INTO `access_log` VALUES (32455, '59.77.15599819091092403', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.97.201.57', '2019-06-08 16:18:29', 15, 2001001000, '服务端发生异常', '2019-06-08 16:18:29');
INSERT INTO `access_log` VALUES (32456, '64.76.15599819125062247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.97.201.57', '2019-06-08 16:18:33', 3, 0, '', '2019-06-08 16:18:33');
INSERT INTO `access_log` VALUES (32457, '64.85.15599819126142277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.97.201.57', '2019-06-08 16:18:33', 2, 0, '', '2019-06-08 16:18:33');
INSERT INTO `access_log` VALUES (32458, '65.47.15599821026442733', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:21:43', 0, 1002001015, '账号未登陆', '2019-06-08 16:21:43');
INSERT INTO `access_log` VALUES (32459, '65.49.15599821026492757', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:21:43', 1, 1002001015, '账号未登陆', '2019-06-08 16:21:43');
INSERT INTO `access_log` VALUES (32460, '65.50.15599821026552731', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:21:43', 1, 1002001015, '账号未登陆', '2019-06-08 16:21:43');
INSERT INTO `access_log` VALUES (32461, '65.3607.15599821126754497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:21:53', 109, 0, '', '2019-06-08 16:21:53');
INSERT INTO `access_log` VALUES (32462, '65.54.15599821132852691', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:21:53', 16, 0, '', '2019-06-08 16:21:53');
INSERT INTO `access_log` VALUES (32463, '65.51.15599821132852745', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:21:53', 17, 0, '', '2019-06-08 16:21:53');
INSERT INTO `access_log` VALUES (32464, '65.46.15599821133262731', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:21:53', 9, 0, '', '2019-06-08 16:21:53');
INSERT INTO `access_log` VALUES (32465, '62.80.15599821255362245', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:22:06', 13, 0, '', '2019-06-08 16:22:06');
INSERT INTO `access_log` VALUES (32466, '65.53.15599821292582709', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:22:09', 20, 0, '', '2019-06-08 16:22:09');
INSERT INTO `access_log` VALUES (32467, '59.80.15599821332482405', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:22:13', 12, 0, '', '2019-06-08 16:22:13');
INSERT INTO `access_log` VALUES (32468, '65.49.15599821535582759', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:22:34', 10, 0, '', '2019-06-08 16:22:34');
INSERT INTO `access_log` VALUES (32469, '65.50.15599821536052733', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:22:34', 9, 0, '', '2019-06-08 16:22:34');
INSERT INTO `access_log` VALUES (32470, '65.3607.15599821536334499', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:22:34', 9, 0, '', '2019-06-08 16:22:34');
INSERT INTO `access_log` VALUES (32471, '65.51.15599821580132747', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:22:38', 9, 0, '', '2019-06-08 16:22:38');
INSERT INTO `access_log` VALUES (32472, '65.54.15599821580152693', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:22:38', 8, 0, '', '2019-06-08 16:22:38');
INSERT INTO `access_log` VALUES (32473, '65.46.15599821580162733', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:22:38', 9, 0, '', '2019-06-08 16:22:38');
INSERT INTO `access_log` VALUES (32474, '59.72.15599821832442415', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:23:03', 2, 0, '', '2019-06-08 16:23:03');
INSERT INTO `access_log` VALUES (32475, '59.76.15599821832892409', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:23:03', 13, 2001001000, '服务端发生异常', '2019-06-08 16:23:03');
INSERT INTO `access_log` VALUES (32476, '64.85.15599821872442281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:23:07', 3, 0, '', '2019-06-08 16:23:07');
INSERT INTO `access_log` VALUES (32477, '64.81.15599821874442261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:23:07', 2, 0, '', '2019-06-08 16:23:07');
INSERT INTO `access_log` VALUES (32478, '64.78.15599822016532269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:23:22', 2, 0, '', '2019-06-08 16:23:22');
INSERT INTO `access_log` VALUES (32479, '64.82.15599822018762275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.22.113.170', '2019-06-08 16:23:22', 2, 0, '', '2019-06-08 16:23:22');
INSERT INTO `access_log` VALUES (32480, '64.83.15599822212042255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '58.22.113.170', '2019-06-08 16:23:41', 2, 0, '', '2019-06-08 16:23:41');
INSERT INTO `access_log` VALUES (32481, '64.84.15599822214832271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '58.22.113.170', '2019-06-08 16:23:41', 2, 0, '', '2019-06-08 16:23:41');
INSERT INTO `access_log` VALUES (32482, '64.79.15599822233302259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '58.22.113.170', '2019-06-08 16:23:43', 2, 0, '', '2019-06-08 16:23:43');
INSERT INTO `access_log` VALUES (32483, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '58.22.113.170', '2019-06-08 16:23:43', 13, 0, '', '2019-06-08 16:23:43');
INSERT INTO `access_log` VALUES (32484, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '58.22.113.170', '2019-06-08 16:23:49', 5, 0, '', '2019-06-08 16:23:49');
INSERT INTO `access_log` VALUES (32485, '64.76.15599822299232253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '58.22.113.170', '2019-06-08 16:23:50', 2, 0, '', '2019-06-08 16:23:50');
INSERT INTO `access_log` VALUES (32486, '64.85.15599822301232283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '58.22.113.170', '2019-06-08 16:23:50', 2, 0, '', '2019-06-08 16:23:50');
INSERT INTO `access_log` VALUES (32487, '66.50.15599822416370911', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '58.22.113.170', '2019-06-08 16:24:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字', '2019-06-08 16:24:02');
INSERT INTO `access_log` VALUES (32488, '59.73.15599822474142419', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '58.22.113.170', '2019-06-08 16:24:07', 3, 0, '', '2019-06-08 16:24:07');
INSERT INTO `access_log` VALUES (32489, '59.74.15599822474342415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '58.22.113.170', '2019-06-08 16:24:07', 10, 2001001000, '服务端发生异常', '2019-06-08 16:24:07');
INSERT INTO `access_log` VALUES (32490, '62.89.15599824770722245', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.65.62.69', '2019-06-08 16:27:57', 8, 1002001012, '访问令牌已过期', '2019-06-08 16:27:57');
INSERT INTO `access_log` VALUES (32491, '59.77.15599831575662421', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '106.36.217.184', '2019-06-08 16:39:18', 3, 0, '', '2019-06-08 16:39:18');
INSERT INTO `access_log` VALUES (32492, '59.72.15599831575662429', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '106.36.217.184', '2019-06-08 16:39:18', 18, 2001001000, '服务端发生异常', '2019-06-08 16:39:18');
INSERT INTO `access_log` VALUES (32493, '64.78.15599831604942283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '106.36.217.184', '2019-06-08 16:39:20', 3, 0, '', '2019-06-08 16:39:20');
INSERT INTO `access_log` VALUES (32494, '64.80.15599831606442273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '106.36.217.184', '2019-06-08 16:39:21', 2, 0, '', '2019-06-08 16:39:21');
INSERT INTO `access_log` VALUES (32495, '64.83.15599831617162269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '106.36.217.184', '2019-06-08 16:39:22', 2, 0, '', '2019-06-08 16:39:22');
INSERT INTO `access_log` VALUES (32496, '64.84.15599831621062285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '106.36.217.184', '2019-06-08 16:39:22', 2, 0, '', '2019-06-08 16:39:22');
INSERT INTO `access_log` VALUES (32497, '66.57.15599831643270933', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '106.36.217.184', '2019-06-08 16:39:24', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位', '2019-06-08 16:39:24');
INSERT INTO `access_log` VALUES (32498, '65.52.15599863453862793', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.241.216', '2019-06-08 17:32:25', 403, 1002001012, '访问令牌已过期', '2019-06-08 17:32:26');
INSERT INTO `access_log` VALUES (32499, '65.53.15599863453892767', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.241.216', '2019-06-08 17:32:25', 401, 1002001012, '访问令牌已过期', '2019-06-08 17:32:26');
INSERT INTO `access_log` VALUES (32500, '65.45.15599863453892801', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.241.216', '2019-06-08 17:32:25', 401, 1002001012, '访问令牌已过期', '2019-06-08 17:32:26');
INSERT INTO `access_log` VALUES (32501, '66.55.15599863454120975', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.241.216', '2019-06-08 17:32:25', 383, 1002001012, '访问令牌已过期', '2019-06-08 17:32:26');
INSERT INTO `access_log` VALUES (32502, '65.47.15599863499532793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.241.216', '2019-06-08 17:32:30', 578, 0, '', '2019-06-08 17:32:31');
INSERT INTO `access_log` VALUES (32503, '65.49.15599863507362817', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.241.216', '2019-06-08 17:32:31', 11, 0, '', '2019-06-08 17:32:31');
INSERT INTO `access_log` VALUES (32504, '65.50.15599863507362791', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.241.216', '2019-06-08 17:32:31', 12, 0, '', '2019-06-08 17:32:31');
INSERT INTO `access_log` VALUES (32505, '65.3607.15599863507384557', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.241.216', '2019-06-08 17:32:31', 10, 0, '', '2019-06-08 17:32:31');
INSERT INTO `access_log` VALUES (32506, '66.51.15599863534930969', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.241.216', '2019-06-08 17:32:33', 21, 0, '', '2019-06-08 17:32:34');
INSERT INTO `access_log` VALUES (32507, '66.50.15599868254380973', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.241.216', '2019-06-08 17:40:25', 370, 0, '', '2019-06-08 17:40:26');
INSERT INTO `access_log` VALUES (32508, '66.54.15599868268260981', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.241.216', '2019-06-08 17:40:27', 12, 0, '', '2019-06-08 17:40:27');
INSERT INTO `access_log` VALUES (32509, '66.52.15599868278240981', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.241.216', '2019-06-08 17:40:28', 12, 0, '', '2019-06-08 17:40:28');
INSERT INTO `access_log` VALUES (32510, '66.56.15599868481470973', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.241.216', '2019-06-08 17:40:48', 13, 0, '', '2019-06-08 17:40:48');
INSERT INTO `access_log` VALUES (32511, '65.46.15599875674542807', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '219.147.98.86', '2019-06-08 17:52:47', 1, 1002001015, '账号未登陆', '2019-06-08 17:52:47');
INSERT INTO `access_log` VALUES (32512, '65.51.15599875674542821', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '219.147.98.86', '2019-06-08 17:52:47', 0, 1002001015, '账号未登陆', '2019-06-08 17:52:47');
INSERT INTO `access_log` VALUES (32513, '65.52.15599875674632811', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '219.147.98.86', '2019-06-08 17:52:47', 0, 1002001015, '账号未登陆', '2019-06-08 17:52:47');
INSERT INTO `access_log` VALUES (32514, '65.45.15599875700932819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '219.147.98.86', '2019-06-08 17:52:50', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 17:52:50');
INSERT INTO `access_log` VALUES (32515, '65.47.15599875767642811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '219.147.98.86', '2019-06-08 17:52:57', 101, 0, '', '2019-06-08 17:52:57');
INSERT INTO `access_log` VALUES (32516, '65.50.15599875773842809', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '219.147.98.86', '2019-06-08 17:52:57', 556, 0, '', '2019-06-08 17:52:58');
INSERT INTO `access_log` VALUES (32517, '65.3607.15599875773994575', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '219.147.98.86', '2019-06-08 17:52:57', 541, 0, '', '2019-06-08 17:52:58');
INSERT INTO `access_log` VALUES (32518, '65.49.15599875773892835', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '219.147.98.86', '2019-06-08 17:52:57', 552, 0, '', '2019-06-08 17:52:58');
INSERT INTO `access_log` VALUES (32519, '62.86.15599875907762301', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '219.147.98.86', '2019-06-08 17:53:11', 21, 0, '', '2019-06-08 17:53:11');
INSERT INTO `access_log` VALUES (32520, '66.49.15599875958730999', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '219.147.98.86', '2019-06-08 17:53:16', 14, 0, '', '2019-06-08 17:53:16');
INSERT INTO `access_log` VALUES (32521, '59.73.15599875986702491', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '219.147.98.86', '2019-06-08 17:53:19', 22, 0, '', '2019-06-08 17:53:19');
INSERT INTO `access_log` VALUES (32522, '65.52.15599876009242813', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '219.147.98.86', '2019-06-08 17:53:21', 22, 0, '', '2019-06-08 17:53:21');
INSERT INTO `access_log` VALUES (32523, '65.46.15599876020342809', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36 OPR/60.0.3255.109', '219.147.98.86', '2019-06-08 17:53:22', 9, 0, '', '2019-06-08 17:53:22');
INSERT INTO `access_log` VALUES (32524, '65.47.15599907826372855', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.135.220', '2019-06-08 18:46:23', 1, 1002001015, '账号未登陆', '2019-06-08 18:46:23');
INSERT INTO `access_log` VALUES (32525, '65.53.15599907826372829', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.135.220', '2019-06-08 18:46:23', 1, 1002001015, '账号未登陆', '2019-06-08 18:46:23');
INSERT INTO `access_log` VALUES (32526, '65.50.15599907826622853', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.135.220', '2019-06-08 18:46:23', 0, 1002001015, '账号未登陆', '2019-06-08 18:46:23');
INSERT INTO `access_log` VALUES (32527, '65.49.15599907850542879', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.135.220', '2019-06-08 18:46:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 18:46:25');
INSERT INTO `access_log` VALUES (32528, '65.54.15599907886692813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.135.220', '2019-06-08 18:46:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 18:46:29');
INSERT INTO `access_log` VALUES (32529, '59.77.15599948253612577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:53:45', 22, 2001001000, '服务端发生异常', '2019-06-08 19:53:45');
INSERT INTO `access_log` VALUES (32530, '59.76.15599948253612579', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:53:45', 27, 0, '', '2019-06-08 19:53:45');
INSERT INTO `access_log` VALUES (32531, '64.83.15599948435692425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.172.106.82', '2019-06-08 19:54:04', 11, 0, '', '2019-06-08 19:54:04');
INSERT INTO `access_log` VALUES (32532, '64.84.15599948436712441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.172.106.82', '2019-06-08 19:54:04', 2, 0, '', '2019-06-08 19:54:04');
INSERT INTO `access_log` VALUES (32533, '64.79.15599948451082429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.172.106.82', '2019-06-08 19:54:05', 2, 0, '', '2019-06-08 19:54:05');
INSERT INTO `access_log` VALUES (32534, '64.85.15599948457612453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.172.106.82', '2019-06-08 19:54:06', 2, 0, '', '2019-06-08 19:54:06');
INSERT INTO `access_log` VALUES (32535, '59.78.15599948491882589', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.172.106.82', '2019-06-08 19:54:09', 3, 0, '', '2019-06-08 19:54:09');
INSERT INTO `access_log` VALUES (32536, '59.79.15599948491882589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.172.106.82', '2019-06-08 19:54:09', 14, 2001001000, '服务端发生异常', '2019-06-08 19:54:09');
INSERT INTO `access_log` VALUES (32537, '59.73.15599948530912589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.172.106.82', '2019-06-08 19:54:13', 13, 2001001000, '服务端发生异常', '2019-06-08 19:54:13');
INSERT INTO `access_log` VALUES (32538, '59.80.15599948530912577', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.172.106.82', '2019-06-08 19:54:13', 104, 0, '', '2019-06-08 19:54:13');
INSERT INTO `access_log` VALUES (32539, '59.77.15599948601552579', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.172.106.82', '2019-06-08 19:54:20', 19, 2001001000, '服务端发生异常', '2019-06-08 19:54:20');
INSERT INTO `access_log` VALUES (32540, '59.72.15599948601552587', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.172.106.82', '2019-06-08 19:54:20', 34, 0, '', '2019-06-08 19:54:20');
INSERT INTO `access_log` VALUES (32541, '64.77.15599948608452441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.172.106.82', '2019-06-08 19:54:21', 3, 0, '', '2019-06-08 19:54:21');
INSERT INTO `access_log` VALUES (32542, '64.82.15599948612182447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.172.106.82', '2019-06-08 19:54:21', 2, 0, '', '2019-06-08 19:54:21');
INSERT INTO `access_log` VALUES (32543, '59.76.15599948612492581', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.172.106.82', '2019-06-08 19:54:21', 2, 0, '', '2019-06-08 19:54:21');
INSERT INTO `access_log` VALUES (32544, '59.75.15599948612702591', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.172.106.82', '2019-06-08 19:54:21', 10, 2001001000, '服务端发生异常', '2019-06-08 19:54:21');
INSERT INTO `access_log` VALUES (32545, '65.46.15599948733122909', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:54:33', 1, 1002001015, '账号未登陆', '2019-06-08 19:54:33');
INSERT INTO `access_log` VALUES (32546, '65.45.15599948733142915', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:54:33', 0, 1002001015, '账号未登陆', '2019-06-08 19:54:33');
INSERT INTO `access_log` VALUES (32547, '65.51.15599948733142921', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:54:33', 0, 1002001015, '账号未登陆', '2019-06-08 19:54:33');
INSERT INTO `access_log` VALUES (32548, '65.47.15599948761782911', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:54:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 19:54:36');
INSERT INTO `access_log` VALUES (32549, '65.3607.15599948968444677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:54:57', 271, 0, '', '2019-06-08 19:54:57');
INSERT INTO `access_log` VALUES (32550, '65.49.15599948974572937', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:54:57', 11, 0, '', '2019-06-08 19:54:57');
INSERT INTO `access_log` VALUES (32551, '65.54.15599948974642873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:54:57', 9, 0, '', '2019-06-08 19:54:57');
INSERT INTO `access_log` VALUES (32552, '65.52.15599948974672915', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:54:57', 11, 0, '', '2019-06-08 19:54:57');
INSERT INTO `access_log` VALUES (32553, '62.86.15599949131702399', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:55:13', 22, 0, '', '2019-06-08 19:55:13');
INSERT INTO `access_log` VALUES (32554, '62.83.15599949236552413', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:55:24', 16, 0, '', '2019-06-08 19:55:24');
INSERT INTO `access_log` VALUES (32555, '64.79.15599949267792431', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:55:27', 14, 0, '', '2019-06-08 19:55:27');
INSERT INTO `access_log` VALUES (32556, '64.76.15599949267902425', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:55:27', 9, 0, '', '2019-06-08 19:55:27');
INSERT INTO `access_log` VALUES (32557, '65.51.15599949383392923', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:55:38', 16, 0, '', '2019-06-08 19:55:38');
INSERT INTO `access_log` VALUES (32558, '65.50.15599949471472911', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:55:47', 12, 0, '', '2019-06-08 19:55:47');
INSERT INTO `access_log` VALUES (32559, '65.53.15599949500522887', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:55:50', 10, 0, '', '2019-06-08 19:55:50');
INSERT INTO `access_log` VALUES (32560, '65.3607.15599949533514679', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:55:53', 13, 0, '', '2019-06-08 19:55:53');
INSERT INTO `access_log` VALUES (32561, '65.49.15599949623062939', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:56:02', 10, 0, '', '2019-06-08 19:56:02');
INSERT INTO `access_log` VALUES (32562, '65.54.15599949669802875', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:56:07', 14, 0, '', '2019-06-08 19:56:07');
INSERT INTO `access_log` VALUES (32563, '65.51.15599949940012925', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:56:34', 21, 0, '', '2019-06-08 19:56:34');
INSERT INTO `access_log` VALUES (32564, '65.46.15599951156742915', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:58:36', 15, 0, '', '2019-06-08 19:58:36');
INSERT INTO `access_log` VALUES (32565, '65.47.15599951221782917', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:58:42', 9, 0, '', '2019-06-08 19:58:42');
INSERT INTO `access_log` VALUES (32566, '65.50.15599951312492915', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:58:51', 11, 0, '', '2019-06-08 19:58:51');
INSERT INTO `access_log` VALUES (32567, '65.53.15599951320392891', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:58:52', 278, 0, '', '2019-06-08 19:58:52');
INSERT INTO `access_log` VALUES (32568, '64.80.15599951604572435', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:59:20', 21, 0, '', '2019-06-08 19:59:20');
INSERT INTO `access_log` VALUES (32569, '64.83.15599951604602431', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:59:20', 19, 0, '', '2019-06-08 19:59:20');
INSERT INTO `access_log` VALUES (32570, '62.84.15599951606722411', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:59:21', 16, 0, '', '2019-06-08 19:59:21');
INSERT INTO `access_log` VALUES (32571, '62.80.15599951620432429', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 19:59:22', 10, 0, '', '2019-06-08 19:59:22');
INSERT INTO `access_log` VALUES (32572, '59.78.15599959331352605', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.246.41.35', '2019-06-08 20:12:13', 3, 0, '', '2019-06-08 20:12:13');
INSERT INTO `access_log` VALUES (32573, '59.79.15599959331372605', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '122.246.41.35', '2019-06-08 20:12:13', 10, 2001001000, '服务端发生异常', '2019-06-08 20:12:13');
INSERT INTO `access_log` VALUES (32574, '65.47.15599959492372929', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.246.41.35', '2019-06-08 20:12:29', 1, 1002001015, '账号未登陆', '2019-06-08 20:12:29');
INSERT INTO `access_log` VALUES (32575, '65.46.15599959492362927', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.246.41.35', '2019-06-08 20:12:29', 1, 1002001015, '账号未登陆', '2019-06-08 20:12:29');
INSERT INTO `access_log` VALUES (32576, '65.51.15599959492362939', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.246.41.35', '2019-06-08 20:12:29', 1, 1002001015, '账号未登陆', '2019-06-08 20:12:29');
INSERT INTO `access_log` VALUES (32577, '65.50.15599959533832927', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.246.41.35', '2019-06-08 20:12:33', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 20:12:33');
INSERT INTO `access_log` VALUES (32578, '65.53.15599959574622903', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.246.41.35', '2019-06-08 20:12:37', 91, 0, '', '2019-06-08 20:12:38');
INSERT INTO `access_log` VALUES (32579, '65.52.15599959646512933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '122.246.41.35', '2019-06-08 20:12:45', 136, 0, '', '2019-06-08 20:12:45');
INSERT INTO `access_log` VALUES (32580, '65.51.15599960201992941', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.41.35', '2019-06-08 20:13:40', 68, 0, '', '2019-06-08 20:13:40');
INSERT INTO `access_log` VALUES (32581, '65.47.15599960208782931', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.41.35', '2019-06-08 20:13:41', 11, 0, '', '2019-06-08 20:13:41');
INSERT INTO `access_log` VALUES (32582, '65.53.15599960208852905', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.41.35', '2019-06-08 20:13:41', 10, 0, '', '2019-06-08 20:13:41');
INSERT INTO `access_log` VALUES (32583, '65.50.15599960208852929', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.41.35', '2019-06-08 20:13:41', 9, 0, '', '2019-06-08 20:13:41');
INSERT INTO `access_log` VALUES (32584, '62.84.15599960292032423', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.41.35', '2019-06-08 20:13:49', 13, 0, '', '2019-06-08 20:13:49');
INSERT INTO `access_log` VALUES (32585, '62.83.15599960525382437', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.41.35', '2019-06-08 20:14:13', 13, 0, '', '2019-06-08 20:14:13');
INSERT INTO `access_log` VALUES (32586, '64.78.15599965953562465', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.41.35', '2019-06-08 20:23:15', 10, 0, '', '2019-06-08 20:23:15');
INSERT INTO `access_log` VALUES (32587, '64.82.15599965953532471', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.246.41.35', '2019-06-08 20:23:15', 15, 0, '', '2019-06-08 20:23:15');
INSERT INTO `access_log` VALUES (32588, '65.52.15600030834493029', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 22:11:23', 16, 1002001012, '访问令牌已过期', '2019-06-08 22:11:23');
INSERT INTO `access_log` VALUES (32589, '65.3607.15600030834484791', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 22:11:23', 16, 1002001012, '访问令牌已过期', '2019-06-08 22:11:23');
INSERT INTO `access_log` VALUES (32590, '65.49.15600030834503051', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 22:11:23', 16, 1002001012, '访问令牌已过期', '2019-06-08 22:11:23');
INSERT INTO `access_log` VALUES (32591, '65.45.15600030853393031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 22:11:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 22:11:25');
INSERT INTO `access_log` VALUES (32592, '65.46.15600030905573025', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 22:11:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 22:11:31');
INSERT INTO `access_log` VALUES (32593, '65.53.15600031149933001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 22:11:55', 72, 0, '', '2019-06-08 22:11:55');
INSERT INTO `access_log` VALUES (32594, '65.50.15600031153793025', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 22:11:55', 12, 0, '', '2019-06-08 22:11:55');
INSERT INTO `access_log` VALUES (32595, '65.52.15600031153833031', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 22:11:55', 10, 0, '', '2019-06-08 22:11:55');
INSERT INTO `access_log` VALUES (32596, '65.49.15600031153883053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 22:11:55', 9, 0, '', '2019-06-08 22:11:55');
INSERT INTO `access_log` VALUES (32597, '62.87.15600031207632521', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.172.106.82', '2019-06-08 22:12:01', 19, 0, '', '2019-06-08 22:12:01');
INSERT INTO `access_log` VALUES (32598, '59.78.15600035649352707', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.223.16', '2019-06-08 22:19:25', 10, 0, '', '2019-06-08 22:19:25');
INSERT INTO `access_log` VALUES (32599, '59.80.15600035649402695', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.223.13', '2019-06-08 22:19:25', 16, 2001001000, '服务端发生异常', '2019-06-08 22:19:25');
INSERT INTO `access_log` VALUES (32600, '66.51.15600035802561201', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15011566666', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.223.16', '2019-06-08 22:19:40', 99, 0, '', '2019-06-08 22:19:40');
INSERT INTO `access_log` VALUES (32601, '66.53.15600035884751201', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15011566666&code=2222', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.223.16', '2019-06-08 22:19:48', 7, 1001003003, '验证码不正确', '2019-06-08 22:19:48');
INSERT INTO `access_log` VALUES (32602, '66.52.15600035929081207', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15011566666', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.223.16', '2019-06-08 22:19:53', 6, 1001003005, '短信发送过于频率', '2019-06-08 22:19:53');
INSERT INTO `access_log` VALUES (32603, '66.56.15600036003531199', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15011566666&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.223.16', '2019-06-08 22:20:00', 241, 0, '', '2019-06-08 22:20:01');
INSERT INTO `access_log` VALUES (32604, '66.48.15600036345131207', 113, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.223.16', '2019-06-08 22:20:35', 6, 0, '', '2019-06-08 22:20:35');
INSERT INTO `access_log` VALUES (32605, '66.57.15600036637071209', 113, 1, 'user-application', '/user-api/users/user/update_nickname', 'nickname=222', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.223.16', '2019-06-08 22:21:04', 86, 0, '', '2019-06-08 22:21:04');
INSERT INTO `access_log` VALUES (32606, '66.56.15600036701911201', 113, 1, 'user-application', '/user-api/users/user/update_nickname', 'nickname=222', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.223.16', '2019-06-08 22:21:10', 8, 0, '', '2019-06-08 22:21:10');
INSERT INTO `access_log` VALUES (32607, '66.49.15600036734461215', 113, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.223.16', '2019-06-08 22:21:13', 430, 0, '', '2019-06-08 22:21:14');
INSERT INTO `access_log` VALUES (32608, '66.55.15600036750091209', 113, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.223.16', '2019-06-08 22:21:15', 6, 0, '', '2019-06-08 22:21:15');
INSERT INTO `access_log` VALUES (32609, '66.54.15600036776791211', 113, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.223.16', '2019-06-08 22:21:18', 6, 0, '', '2019-06-08 22:21:18');
INSERT INTO `access_log` VALUES (32610, '59.73.15600038687742711', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '221.6.211.30', '2019-06-08 22:24:29', 3, 0, '', '2019-06-08 22:24:29');
INSERT INTO `access_log` VALUES (32611, '59.74.15600038687802707', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '221.6.211.30', '2019-06-08 22:24:29', 18, 2001001000, '服务端发生异常', '2019-06-08 22:24:29');
INSERT INTO `access_log` VALUES (32612, '59.72.15600038740782709', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '221.6.211.30', '2019-06-08 22:24:34', 3, 0, '', '2019-06-08 22:24:34');
INSERT INTO `access_log` VALUES (32613, '59.77.15600038740782701', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '221.6.211.30', '2019-06-08 22:24:34', 16, 2001001000, '服务端发生异常', '2019-06-08 22:24:34');
INSERT INTO `access_log` VALUES (32614, '66.52.15600038952761213', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15555555555&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '221.6.211.30', '2019-06-08 22:24:55', 13, 1001003000, '验证码不存在', '2019-06-08 22:24:55');
INSERT INTO `access_log` VALUES (32615, '66.56.15600038984001205', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15555555555', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '221.6.211.30', '2019-06-08 22:24:58', 409, 0, '', '2019-06-08 22:24:59');
INSERT INTO `access_log` VALUES (32616, '66.49.15600039014141219', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15555555555&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '221.6.211.30', '2019-06-08 22:25:01', 182, 0, '', '2019-06-08 22:25:02');
INSERT INTO `access_log` VALUES (32617, '66.54.15600039030791215', 114, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '221.6.211.30', '2019-06-08 22:25:03', 909, 0, '', '2019-06-08 22:25:04');
INSERT INTO `access_log` VALUES (32618, '66.50.15600039072651205', 114, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '221.6.211.30', '2019-06-08 22:25:07', 6, 0, '', '2019-06-08 22:25:07');
INSERT INTO `access_log` VALUES (32619, '66.51.15600039155151209', 114, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '221.6.211.30', '2019-06-08 22:25:16', 193, 0, '', '2019-06-08 22:25:16');
INSERT INTO `access_log` VALUES (32620, '66.53.15600039168861209', 114, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '221.6.211.30', '2019-06-08 22:25:17', 6, 0, '', '2019-06-08 22:25:17');
INSERT INTO `access_log` VALUES (32621, '59.74.15600039210602709', 114, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '221.6.211.30', '2019-06-08 22:25:21', 6, 0, '', '2019-06-08 22:25:21');
INSERT INTO `access_log` VALUES (32622, '59.73.15600039210642713', 114, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '221.6.211.30', '2019-06-08 22:25:21', 17, 2001001000, '服务端发生异常', '2019-06-08 22:25:21');
INSERT INTO `access_log` VALUES (32623, '66.52.15600039237401215', 114, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '221.6.211.30', '2019-06-08 22:25:24', 6, 0, '', '2019-06-08 22:25:24');
INSERT INTO `access_log` VALUES (32624, '59.80.15600047615682713', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:39:22', 4, 0, '', '2019-06-08 22:39:22');
INSERT INTO `access_log` VALUES (32625, '59.78.15600047615702725', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:39:22', 13, 2001001000, '服务端发生异常', '2019-06-08 22:39:22');
INSERT INTO `access_log` VALUES (32626, '64.85.15600047724932587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:39:32', 11, 0, '', '2019-06-08 22:39:33');
INSERT INTO `access_log` VALUES (32627, '64.81.15600047731272567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:39:33', 2, 0, '', '2019-06-08 22:39:33');
INSERT INTO `access_log` VALUES (32628, '64.77.15600047749702575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:39:35', 2, 0, '', '2019-06-08 22:39:35');
INSERT INTO `access_log` VALUES (32629, '64.78.15600047760722575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:39:36', 2, 0, '', '2019-06-08 22:39:36');
INSERT INTO `access_log` VALUES (32630, '64.84.15600047774302577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:39:37', 2, 0, '', '2019-06-08 22:39:37');
INSERT INTO `access_log` VALUES (32631, '64.83.15600047781452561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:39:38', 2, 0, '', '2019-06-08 22:39:38');
INSERT INTO `access_log` VALUES (32632, '64.80.15600047813762565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:39:41', 2, 0, '', '2019-06-08 22:39:41');
INSERT INTO `access_log` VALUES (32633, '64.76.15600047815702559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:39:42', 2, 0, '', '2019-06-08 22:39:42');
INSERT INTO `access_log` VALUES (32634, '65.53.15600048575973025', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '223.104.5.164', '2019-06-08 22:40:58', 0, 1002001015, '账号未登陆', '2019-06-08 22:40:58');
INSERT INTO `access_log` VALUES (32635, '65.50.15600048580213049', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '223.104.5.164', '2019-06-08 22:40:58', 0, 1002001015, '账号未登陆', '2019-06-08 22:40:58');
INSERT INTO `access_log` VALUES (32636, '65.49.15600048581103077', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '223.104.5.164', '2019-06-08 22:40:58', 0, 1002001015, '账号未登陆', '2019-06-08 22:40:58');
INSERT INTO `access_log` VALUES (32637, '59.73.15600050790902729', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:44:39', 3, 0, '', '2019-06-08 22:44:39');
INSERT INTO `access_log` VALUES (32638, '59.76.15600050790912721', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:44:39', 19, 2001001000, '服务端发生异常', '2019-06-08 22:44:39');
INSERT INTO `access_log` VALUES (32639, '64.85.15600050983212593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:44:58', 129, 0, '', '2019-06-08 22:44:58');
INSERT INTO `access_log` VALUES (32640, '64.81.15600050987382573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:44:59', 2, 0, '', '2019-06-08 22:44:59');
INSERT INTO `access_log` VALUES (32641, '59.77.15600051014472719', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:01', 14, 0, '', '2019-06-08 22:45:01');
INSERT INTO `access_log` VALUES (32642, '59.75.15600051014522731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:01', 13, 2001001000, '服务端发生异常', '2019-06-08 22:45:01');
INSERT INTO `access_log` VALUES (32643, '64.82.15600051107622587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:11', 2, 0, '', '2019-06-08 22:45:11');
INSERT INTO `access_log` VALUES (32644, '64.78.15600051110102581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:11', 2, 0, '', '2019-06-08 22:45:11');
INSERT INTO `access_log` VALUES (32645, '64.84.15600051129642583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:13', 1, 0, '', '2019-06-08 22:45:13');
INSERT INTO `access_log` VALUES (32646, '64.83.15600051134312567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:13', 2, 0, '', '2019-06-08 22:45:13');
INSERT INTO `access_log` VALUES (32647, '64.80.15600051142522571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:14', 2, 0, '', '2019-06-08 22:45:14');
INSERT INTO `access_log` VALUES (32648, '64.76.15600051158322565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:16', 70, 0, '', '2019-06-08 22:45:16');
INSERT INTO `access_log` VALUES (32649, '64.79.15600051165192571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:17', 1, 0, '', '2019-06-08 22:45:17');
INSERT INTO `access_log` VALUES (32650, '64.81.15600051288782575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:29', 270, 0, '', '2019-06-08 22:45:29');
INSERT INTO `access_log` VALUES (32651, '64.77.15600051293372583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:29', 1, 0, '', '2019-06-08 22:45:29');
INSERT INTO `access_log` VALUES (32652, '64.82.15600051311242589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:31', 2, 0, '', '2019-06-08 22:45:31');
INSERT INTO `access_log` VALUES (32653, '64.78.15600051321662583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:32', 171, 0, '', '2019-06-08 22:45:32');
INSERT INTO `access_log` VALUES (32654, '64.84.15600051345172585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:35', 2, 0, '', '2019-06-08 22:45:35');
INSERT INTO `access_log` VALUES (32655, '64.83.15600051353292569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:35', 2, 0, '', '2019-06-08 22:45:35');
INSERT INTO `access_log` VALUES (32656, '64.76.15600051361422567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:36', 2, 0, '', '2019-06-08 22:45:36');
INSERT INTO `access_log` VALUES (32657, '64.79.15600051383532573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:38', 1, 0, '', '2019-06-08 22:45:38');
INSERT INTO `access_log` VALUES (32658, '64.85.15600051385462597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:39', 2, 0, '', '2019-06-08 22:45:39');
INSERT INTO `access_log` VALUES (32659, '59.78.15600051456562731', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:46', 3, 0, '', '2019-06-08 22:45:46');
INSERT INTO `access_log` VALUES (32660, '59.74.15600051456662727', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:46', 13, 2001001000, '服务端发生异常', '2019-06-08 22:45:46');
INSERT INTO `access_log` VALUES (32661, '64.77.15600051541432585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:54', 2, 0, '', '2019-06-08 22:45:54');
INSERT INTO `access_log` VALUES (32662, '64.82.15600051542932591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:54', 2, 0, '', '2019-06-08 22:45:54');
INSERT INTO `access_log` VALUES (32663, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:55', 13, 0, '', '2019-06-08 22:45:55');
INSERT INTO `access_log` VALUES (32664, '64.78.15600051553322585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:55', 1, 0, '', '2019-06-08 22:45:55');
INSERT INTO `access_log` VALUES (32665, '64.84.15600051570182587', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.108 Safari/537.36 UCBrowser/12.1.6.996', '117.88.125.152', '2019-06-08 22:45:57', 579, 0, '', '2019-06-08 22:45:58');
INSERT INTO `access_log` VALUES (32666, '59.78.15600068866572755', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:14:47', 10, 0, '', '2019-06-08 23:14:47');
INSERT INTO `access_log` VALUES (32667, '59.74.15600068866582751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:14:47', 17, 2001001000, '服务端发生异常', '2019-06-08 23:14:47');
INSERT INTO `access_log` VALUES (32668, '64.77.15600068902582609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:14:50', 8, 0, '', '2019-06-08 23:14:50');
INSERT INTO `access_log` VALUES (32669, '64.78.15600068904652609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:14:50', 7, 0, '', '2019-06-08 23:14:50');
INSERT INTO `access_log` VALUES (32670, '64.83.15600068927272595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:14:53', 702, 0, '', '2019-06-08 23:14:53');
INSERT INTO `access_log` VALUES (32671, '66.52.15600068937521255', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:14:54', 678, 1002001011, '访问令牌不存在', '2019-06-08 23:14:54');
INSERT INTO `access_log` VALUES (32672, '64.80.15600068936862599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:14:54', 745, 0, '', '2019-06-08 23:14:54');
INSERT INTO `access_log` VALUES (32673, '66.56.15600068978011247', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:14:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位', '2019-06-08 23:14:58');
INSERT INTO `access_log` VALUES (32674, '66.49.15600068979921261', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:14:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空', '2019-06-08 23:14:58');
INSERT INTO `access_log` VALUES (32675, '66.55.15600068982381255', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:14:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-08 23:14:58');
INSERT INTO `access_log` VALUES (32676, '66.54.15600068983901257', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:14:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-06-08 23:14:58');
INSERT INTO `access_log` VALUES (32677, '66.48.15600069039031255', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字', '2019-06-08 23:15:04');
INSERT INTO `access_log` VALUES (32678, '64.79.15600069057102599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:06', 9, 0, '', '2019-06-08 23:15:06');
INSERT INTO `access_log` VALUES (32679, '64.85.15600069059022623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:06', 7, 0, '', '2019-06-08 23:15:06');
INSERT INTO `access_log` VALUES (32680, '59.77.15600069074512745', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:07', 7, 0, '', '2019-06-08 23:15:07');
INSERT INTO `access_log` VALUES (32681, '59.72.15600069074512753', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:07', 19, 2001001000, '服务端发生异常', '2019-06-08 23:15:07');
INSERT INTO `access_log` VALUES (32682, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:12', 18, 0, '', '2019-06-08 23:15:12');
INSERT INTO `access_log` VALUES (32683, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:12', 12, 0, '', '2019-06-08 23:15:12');
INSERT INTO `access_log` VALUES (32684, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:13', 23, 0, '', '2019-06-08 23:15:13');
INSERT INTO `access_log` VALUES (32685, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:13', 16, 0, '', '2019-06-08 23:15:13');
INSERT INTO `access_log` VALUES (32686, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:13', 16, 0, '', '2019-06-08 23:15:13');
INSERT INTO `access_log` VALUES (32687, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:13', 24, 0, '', '2019-06-08 23:15:13');
INSERT INTO `access_log` VALUES (32688, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:13', 115, 0, '', '2019-06-08 23:15:13');
INSERT INTO `access_log` VALUES (32689, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:13', 18, 0, '', '2019-06-08 23:15:13');
INSERT INTO `access_log` VALUES (32690, '59.71.15600069144332757', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:14', 164, 0, '', '2019-06-08 23:15:15');
INSERT INTO `access_log` VALUES (32691, '59.75.15600069144332757', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:14', 174, 2001001000, '服务端发生异常', '2019-06-08 23:15:15');
INSERT INTO `access_log` VALUES (32692, '64.81.15600069166222603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:17', 9, 0, '', '2019-06-08 23:15:17');
INSERT INTO `access_log` VALUES (32693, '64.77.15600069167752611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-08 23:15:17', 7, 0, '', '2019-06-08 23:15:17');
INSERT INTO `access_log` VALUES (32694, '65.46.15600074541713085', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:24:14', 0, 1002001015, '账号未登陆', '2019-06-08 23:24:14');
INSERT INTO `access_log` VALUES (32695, '65.45.15600074541703091', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:24:14', 0, 1002001015, '账号未登陆', '2019-06-08 23:24:14');
INSERT INTO `access_log` VALUES (32696, '65.51.15600074541833097', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:24:14', 0, 1002001015, '账号未登陆', '2019-06-08 23:24:14');
INSERT INTO `access_log` VALUES (32697, '65.47.15600074559433087', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:24:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-08 23:24:16');
INSERT INTO `access_log` VALUES (32698, '65.50.15600074761923085', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:24:36', 339, 0, '', '2019-06-08 23:24:37');
INSERT INTO `access_log` VALUES (32699, '65.49.15600074767763113', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:24:37', 14, 0, '', '2019-06-08 23:24:37');
INSERT INTO `access_log` VALUES (32700, '65.3607.15600074767804853', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:24:37', 12, 0, '', '2019-06-08 23:24:37');
INSERT INTO `access_log` VALUES (32701, '65.52.15600074767803091', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:24:37', 13, 0, '', '2019-06-08 23:24:37');
INSERT INTO `access_log` VALUES (32702, '62.89.15600074891262589', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:24:49', 24, 0, '', '2019-06-08 23:24:49');
INSERT INTO `access_log` VALUES (32703, '62.86.15600074987602577', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:24:59', 17, 0, '', '2019-06-08 23:24:59');
INSERT INTO `access_log` VALUES (32704, '64.82.15600075025522625', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:03', 8, 0, '', '2019-06-08 23:25:03');
INSERT INTO `access_log` VALUES (32705, '64.77.15600075025492619', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:03', 13, 0, '', '2019-06-08 23:25:03');
INSERT INTO `access_log` VALUES (32706, '64.78.15600075061162619', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:06', 461, 0, '', '2019-06-08 23:25:07');
INSERT INTO `access_log` VALUES (32707, '64.83.15600075061162605', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:06', 460, 0, '', '2019-06-08 23:25:07');
INSERT INTO `access_log` VALUES (32708, '64.76.15600075118472603', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:12', 433, 0, '', '2019-06-08 23:25:12');
INSERT INTO `access_log` VALUES (32709, '64.80.15600075118472609', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:12', 436, 0, '', '2019-06-08 23:25:12');
INSERT INTO `access_log` VALUES (32710, '64.79.15600075154422609', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:15', 16, 0, '', '2019-06-08 23:25:15');
INSERT INTO `access_log` VALUES (32711, '64.85.15600075154422633', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:15', 18, 0, '', '2019-06-08 23:25:15');
INSERT INTO `access_log` VALUES (32712, '64.81.15600075176302613', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:18', 8, 0, '', '2019-06-08 23:25:18');
INSERT INTO `access_log` VALUES (32713, '64.82.15600075238892627', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:24', 11, 0, '', '2019-06-08 23:25:24');
INSERT INTO `access_log` VALUES (32714, '64.84.15600075239012623', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:24', 8, 0, '', '2019-06-08 23:25:24');
INSERT INTO `access_log` VALUES (32715, '65.47.15600075365333089', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:37', 19, 0, '', '2019-06-08 23:25:37');
INSERT INTO `access_log` VALUES (32716, '65.53.15600075375333063', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:38', 203, 0, '', '2019-06-08 23:25:38');
INSERT INTO `access_log` VALUES (32717, '65.50.15600075387793087', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:39', 9, 0, '', '2019-06-08 23:25:39');
INSERT INTO `access_log` VALUES (32718, '65.3607.15600075404934855', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:40', 15, 0, '', '2019-06-08 23:25:41');
INSERT INTO `access_log` VALUES (32719, '65.54.15600075580323051', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:25:58', 9, 0, '', '2019-06-08 23:25:58');
INSERT INTO `access_log` VALUES (32720, '65.46.15600075720193089', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:26:12', 14, 0, '', '2019-06-08 23:26:12');
INSERT INTO `access_log` VALUES (32721, '65.51.15600075726723101', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:26:13', 9, 0, '', '2019-06-08 23:26:13');
INSERT INTO `access_log` VALUES (32722, '65.47.15600075730993091', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:26:13', 9, 0, '', '2019-06-08 23:26:13');
INSERT INTO `access_log` VALUES (32723, '65.53.15600075734223065', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.77.233.222', '2019-06-08 23:26:13', 15, 0, '', '2019-06-08 23:26:13');
INSERT INTO `access_log` VALUES (32724, '59.80.15600097685262783', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.194.158.48', '2019-06-09 00:02:49', 20, 2001001000, '服务端发生异常', '2019-06-09 00:02:49');
INSERT INTO `access_log` VALUES (32725, '59.79.15600097685262795', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.194.158.48', '2019-06-09 00:02:49', 403, 0, '', '2019-06-09 00:02:49');
INSERT INTO `access_log` VALUES (32726, '59.78.15600419773263225', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '27.26.121.105', '2019-06-09 08:59:37', 14, 0, '', '2019-06-09 08:59:37');
INSERT INTO `access_log` VALUES (32727, '59.79.15600419773263225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '27.26.121.105', '2019-06-09 08:59:37', 16, 2001001000, '服务端发生异常', '2019-06-09 08:59:37');
INSERT INTO `access_log` VALUES (32728, '64.77.15600419845663081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '27.26.121.105', '2019-06-09 08:59:45', 11, 0, '', '2019-06-09 08:59:45');
INSERT INTO `access_log` VALUES (32729, '64.84.15600419847053083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '27.26.121.105', '2019-06-09 08:59:45', 3, 0, '', '2019-06-09 08:59:45');
INSERT INTO `access_log` VALUES (32730, '64.82.15600419859853087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '27.26.121.105', '2019-06-09 08:59:46', 2, 0, '', '2019-06-09 08:59:46');
INSERT INTO `access_log` VALUES (32731, '64.83.15600419864773067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '27.26.121.105', '2019-06-09 08:59:46', 2, 0, '', '2019-06-09 08:59:46');
INSERT INTO `access_log` VALUES (32732, '64.80.15600419942723071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '27.26.121.105', '2019-06-09 08:59:54', 2, 0, '', '2019-06-09 08:59:54');
INSERT INTO `access_log` VALUES (32733, '64.76.15600419943773065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '27.26.121.105', '2019-06-09 08:59:54', 2, 0, '', '2019-06-09 08:59:54');
INSERT INTO `access_log` VALUES (32734, '59.74.15600420372033221', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.91.60.105', '2019-06-09 09:00:37', 3, 0, '', '2019-06-09 09:00:37');
INSERT INTO `access_log` VALUES (32735, '59.71.15600420372033225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.197', '2019-06-09 09:00:37', 13, 2001001000, '服务端发生异常', '2019-06-09 09:00:37');
INSERT INTO `access_log` VALUES (32736, '64.77.15600420441123083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.151.178.166', '2019-06-09 09:00:44', 2, 0, '', '2019-06-09 09:00:44');
INSERT INTO `access_log` VALUES (32737, '64.84.15600420442213085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.227.139.161', '2019-06-09 09:00:44', 2, 0, '', '2019-06-09 09:00:44');
INSERT INTO `access_log` VALUES (32738, '64.82.15600420470293089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '180.97.118.219', '2019-06-09 09:00:47', 2, 0, '', '2019-06-09 09:00:47');
INSERT INTO `access_log` VALUES (32739, '65.49.15600426174713585', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.218.104.71', '2019-06-09 09:10:17', 0, 1002001015, '账号未登陆', '2019-06-09 09:10:17');
INSERT INTO `access_log` VALUES (32740, '65.3607.15600426174715325', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.218.104.71', '2019-06-09 09:10:17', 0, 1002001015, '账号未登陆', '2019-06-09 09:10:17');
INSERT INTO `access_log` VALUES (32741, '65.52.15600426174783563', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.218.104.71', '2019-06-09 09:10:17', 0, 1002001015, '账号未登陆', '2019-06-09 09:10:17');
INSERT INTO `access_log` VALUES (32742, '65.54.15600426219033517', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.218.104.71', '2019-06-09 09:10:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 09:10:22');
INSERT INTO `access_log` VALUES (32743, '65.46.15600426246273557', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.218.104.71', '2019-06-09 09:10:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 09:10:25');
INSERT INTO `access_log` VALUES (32744, '59.80.15600451697663257', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3817.0 Safari/537.36', '112.10.69.102', '2019-06-09 09:52:50', 11, 0, '', '2019-06-09 09:52:50');
INSERT INTO `access_log` VALUES (32745, '59.74.15600451697663263', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3817.0 Safari/537.36', '112.10.69.102', '2019-06-09 09:52:50', 15, 2001001000, '服务端发生异常', '2019-06-09 09:52:50');
INSERT INTO `access_log` VALUES (32746, '59.75.15600451802413269', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3817.0 Safari/537.36', '112.10.69.102', '2019-06-09 09:53:00', 4, 0, '', '2019-06-09 09:53:00');
INSERT INTO `access_log` VALUES (32747, '59.79.15600451802413269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3817.0 Safari/537.36', '112.10.69.102', '2019-06-09 09:53:00', 14, 2001001000, '服务端发生异常', '2019-06-09 09:53:00');
INSERT INTO `access_log` VALUES (32748, '59.73.15600456423163275', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:00:42', 12, 2001001000, '服务端发生异常', '2019-06-09 10:00:42');
INSERT INTO `access_log` VALUES (32749, '59.76.15600456423173267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:00:42', 225, 0, '', '2019-06-09 10:00:43');
INSERT INTO `access_log` VALUES (32750, '59.73.15600457535373277', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:02:34', 3, 0, '', '2019-06-09 10:02:34');
INSERT INTO `access_log` VALUES (32751, '59.78.15600457535363277', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:02:34', 13, 2001001000, '服务端发生异常', '2019-06-09 10:02:34');
INSERT INTO `access_log` VALUES (32752, '59.80.15600483719943301', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:12', 11, 0, '', '2019-06-09 10:46:12');
INSERT INTO `access_log` VALUES (32753, '59.75.15600483719943313', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:12', 23, 2001001000, '服务端发生异常', '2019-06-09 10:46:12');
INSERT INTO `access_log` VALUES (32754, '64.80.15600483760613157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:16', 9, 0, '', '2019-06-09 10:46:16');
INSERT INTO `access_log` VALUES (32755, '64.76.15600483762243151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:16', 4, 0, '', '2019-06-09 10:46:16');
INSERT INTO `access_log` VALUES (32756, '64.79.15600483773593157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:17', 2, 0, '', '2019-06-09 10:46:17');
INSERT INTO `access_log` VALUES (32757, '64.85.15600483779773181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:18', 1, 0, '', '2019-06-09 10:46:18');
INSERT INTO `access_log` VALUES (32758, '64.81.15600483785443161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:19', 2, 0, '', '2019-06-09 10:46:19');
INSERT INTO `access_log` VALUES (32759, '66.54.15600483941341811', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13333333333&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:34', 17, 1001003001, '验证码已过期', '2019-06-09 10:46:34');
INSERT INTO `access_log` VALUES (32760, '64.82.15600484013283175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:41', 2, 0, '', '2019-06-09 10:46:41');
INSERT INTO `access_log` VALUES (32761, '64.83.15600484014713155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:41', 2, 0, '', '2019-06-09 10:46:41');
INSERT INTO `access_log` VALUES (32762, '64.78.15600484023613169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:42', 2, 0, '', '2019-06-09 10:46:42');
INSERT INTO `access_log` VALUES (32763, '64.80.15600484027923159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:43', 2, 0, '', '2019-06-09 10:46:43');
INSERT INTO `access_log` VALUES (32764, '59.76.15600484037703305', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:44', 13, 2001001000, '服务端发生异常', '2019-06-09 10:46:44');
INSERT INTO `access_log` VALUES (32765, '59.73.15600484037703313', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:44', 200, 0, '', '2019-06-09 10:46:44');
INSERT INTO `access_log` VALUES (32766, '64.76.15600484047733153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:45', 2, 0, '', '2019-06-09 10:46:45');
INSERT INTO `access_log` VALUES (32767, '64.79.15600484049083159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:45', 2, 0, '', '2019-06-09 10:46:45');
INSERT INTO `access_log` VALUES (32768, '64.85.15600484064383183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:46', 2, 0, '', '2019-06-09 10:46:46');
INSERT INTO `access_log` VALUES (32769, '59.72.15600484079783311', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:48', 3, 0, '', '2019-06-09 10:46:48');
INSERT INTO `access_log` VALUES (32770, '59.77.15600484079793303', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:48', 14, 2001001000, '服务端发生异常', '2019-06-09 10:46:48');
INSERT INTO `access_log` VALUES (32771, '64.81.15600484083983163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:48', 2, 0, '', '2019-06-09 10:46:48');
INSERT INTO `access_log` VALUES (32772, '64.77.15600484086453171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:49', 2, 0, '', '2019-06-09 10:46:49');
INSERT INTO `access_log` VALUES (32773, '59.74.15600484091493309', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:49', 3, 0, '', '2019-06-09 10:46:49');
INSERT INTO `access_log` VALUES (32774, '59.80.15600484091493303', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:46:49', 13, 2001001000, '服务端发生异常', '2019-06-09 10:46:49');
INSERT INTO `access_log` VALUES (32775, '65.51.15600484212393649', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:01', 1, 1002001015, '账号未登陆', '2019-06-09 10:47:01');
INSERT INTO `access_log` VALUES (32776, '65.46.15600484212383635', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:01', 0, 1002001015, '账号未登陆', '2019-06-09 10:47:01');
INSERT INTO `access_log` VALUES (32777, '65.50.15600484212503637', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:01', 0, 1002001015, '账号未登陆', '2019-06-09 10:47:01');
INSERT INTO `access_log` VALUES (32778, '65.49.15600484233393663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 10:47:03');
INSERT INTO `access_log` VALUES (32779, '65.53.15600484281703615', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:08', 177, 0, '', '2019-06-09 10:47:08');
INSERT INTO `access_log` VALUES (32780, '65.3607.15600484286715405', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:09', 21, 0, '', '2019-06-09 10:47:09');
INSERT INTO `access_log` VALUES (32781, '65.54.15600484286823597', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:09', 11, 0, '', '2019-06-09 10:47:09');
INSERT INTO `access_log` VALUES (32782, '65.52.15600484286903643', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:09', 10, 0, '', '2019-06-09 10:47:09');
INSERT INTO `access_log` VALUES (32783, '59.79.15600484312253315', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.89.29.97', '2019-06-09 10:47:11', 12, 2001001000, '服务端发生异常', '2019-06-09 10:47:11');
INSERT INTO `access_log` VALUES (32784, '62.89.15600484391623145', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:19', 58, 0, '', '2019-06-09 10:47:19');
INSERT INTO `access_log` VALUES (32785, '66.51.15600484499221807', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:30', 147, 0, '', '2019-06-09 10:47:30');
INSERT INTO `access_log` VALUES (32786, '65.50.15600484545193639', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:35', 18, 0, '', '2019-06-09 10:47:35');
INSERT INTO `access_log` VALUES (32787, '65.51.15600484561163651', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:36', 8, 0, '', '2019-06-09 10:47:36');
INSERT INTO `access_log` VALUES (32788, '65.46.15600484589083637', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:39', 18, 0, '', '2019-06-09 10:47:39');
INSERT INTO `access_log` VALUES (32789, '65.53.15600484598673617', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:40', 369, 0, '', '2019-06-09 10:47:40');
INSERT INTO `access_log` VALUES (32790, '65.3607.15600484606225407', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:41', 11, 0, '', '2019-06-09 10:47:41');
INSERT INTO `access_log` VALUES (32791, '62.85.15600484777753137', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.130.200', '2019-06-09 10:47:58', 17, 0, '', '2019-06-09 10:47:58');
INSERT INTO `access_log` VALUES (32792, '65.52.15600484810883645', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.29.86', '2019-06-09 10:48:01', 1, 1002001015, '账号未登陆', '2019-06-09 10:48:01');
INSERT INTO `access_log` VALUES (32793, '65.47.15600484812303641', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.151.178.197', '2019-06-09 10:48:01', 1, 1002001015, '账号未登陆', '2019-06-09 10:48:01');
INSERT INTO `access_log` VALUES (32794, '65.45.15600484817563645', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.89.19.149', '2019-06-09 10:48:02', 0, 1002001015, '账号未登陆', '2019-06-09 10:48:02');
INSERT INTO `access_log` VALUES (32795, '62.85.15600484991533139', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.89.29.94', '2019-06-09 10:48:19', 1, 1002001015, '账号未登陆', '2019-06-09 10:48:19');
INSERT INTO `access_log` VALUES (32796, '66.54.15600485091821813', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.19.149', '2019-06-09 10:48:29', 0, 1002001015, '账号未登陆', '2019-06-09 10:48:29');
INSERT INTO `access_log` VALUES (32797, '65.49.15600485162763667', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.129.7.235', '2019-06-09 10:48:36', 0, 1002001015, '账号未登陆', '2019-06-09 10:48:36');
INSERT INTO `access_log` VALUES (32798, '65.53.15600485190953619', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.91.60.104', '2019-06-09 10:48:39', 0, 1002001015, '账号未登陆', '2019-06-09 10:48:39');
INSERT INTO `access_log` VALUES (32799, '65.3607.15600485211565409', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.251', '2019-06-09 10:48:41', 0, 1002001015, '账号未登陆', '2019-06-09 10:48:41');
INSERT INTO `access_log` VALUES (32800, '59.78.15600490289413323', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:09', 4, 0, '', '2019-06-09 10:57:09');
INSERT INTO `access_log` VALUES (32801, '59.76.15600490289553315', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:09', 12, 2001001000, '服务端发生异常', '2019-06-09 10:57:09');
INSERT INTO `access_log` VALUES (32802, '64.83.15600490385503165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:19', 4, 0, '', '2019-06-09 10:57:19');
INSERT INTO `access_log` VALUES (32803, '64.78.15600490387033179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:19', 2, 0, '', '2019-06-09 10:57:19');
INSERT INTO `access_log` VALUES (32804, '64.80.15600490401493169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:20', 8, 0, '', '2019-06-09 10:57:20');
INSERT INTO `access_log` VALUES (32805, '64.79.15600490409763169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:21', 2, 0, '', '2019-06-09 10:57:21');
INSERT INTO `access_log` VALUES (32806, '64.85.15600490416693193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:22', 1, 0, '', '2019-06-09 10:57:22');
INSERT INTO `access_log` VALUES (32807, '64.81.15600490421233173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:22', 2, 0, '', '2019-06-09 10:57:22');
INSERT INTO `access_log` VALUES (32808, '59.72.15600490425973321', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:23', 2, 0, '', '2019-06-09 10:57:23');
INSERT INTO `access_log` VALUES (32809, '59.77.15600490425983313', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:23', 13, 2001001000, '服务端发生异常', '2019-06-09 10:57:23');
INSERT INTO `access_log` VALUES (32810, '59.74.15600490504083319', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:30', 13, 2001001000, '服务端发生异常', '2019-06-09 10:57:30');
INSERT INTO `access_log` VALUES (32811, '59.71.15600490504073323', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:30', 332, 0, '', '2019-06-09 10:57:31');
INSERT INTO `access_log` VALUES (32812, '64.77.15600490527913181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:33', 2, 0, '', '2019-06-09 10:57:33');
INSERT INTO `access_log` VALUES (32813, '64.84.15600490529523183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:33', 1, 0, '', '2019-06-09 10:57:33');
INSERT INTO `access_log` VALUES (32814, '64.82.15600490539873187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:34', 2, 0, '', '2019-06-09 10:57:34');
INSERT INTO `access_log` VALUES (32815, '64.83.15600490544723167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.226.185.92', '2019-06-09 10:57:34', 2, 0, '', '2019-06-09 10:57:34');
INSERT INTO `access_log` VALUES (32816, '65.54.15600497292383617', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.96', '2019-06-09 11:08:49', 5, 1002001012, '访问令牌已过期', '2019-06-09 11:08:49');
INSERT INTO `access_log` VALUES (32817, '65.52.15600497293073663', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.96', '2019-06-09 11:08:49', 4, 1002001012, '访问令牌已过期', '2019-06-09 11:08:49');
INSERT INTO `access_log` VALUES (32818, '65.47.15600497293093659', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.96', '2019-06-09 11:08:49', 4, 1002001012, '访问令牌已过期', '2019-06-09 11:08:49');
INSERT INTO `access_log` VALUES (32819, '65.45.15600497328863663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.96', '2019-06-09 11:08:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 11:08:53');
INSERT INTO `access_log` VALUES (32820, '65.51.15600497405223671', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.96', '2019-06-09 11:09:01', 71, 0, '', '2019-06-09 11:09:01');
INSERT INTO `access_log` VALUES (32821, '65.53.15600497415033637', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.96', '2019-06-09 11:09:02', 9, 0, '', '2019-06-09 11:09:02');
INSERT INTO `access_log` VALUES (32822, '65.46.15600497415023657', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.96', '2019-06-09 11:09:02', 10, 0, '', '2019-06-09 11:09:02');
INSERT INTO `access_log` VALUES (32823, '65.49.15600497415013685', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.96', '2019-06-09 11:09:02', 10, 0, '', '2019-06-09 11:09:02');
INSERT INTO `access_log` VALUES (32824, '62.89.15600497459803165', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.96', '2019-06-09 11:09:06', 60, 0, '', '2019-06-09 11:09:06');
INSERT INTO `access_log` VALUES (32825, '64.82.15600497482523197', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.96', '2019-06-09 11:09:08', 7, 0, '', '2019-06-09 11:09:08');
INSERT INTO `access_log` VALUES (32826, '64.84.15600497482503193', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '120.85.149.96', '2019-06-09 11:09:08', 11, 0, '', '2019-06-09 11:09:08');
INSERT INTO `access_log` VALUES (32827, '65.50.15600519221573689', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.91.124', '2019-06-09 11:45:22', 0, 1002001015, '账号未登陆', '2019-06-09 11:45:22');
INSERT INTO `access_log` VALUES (32828, '65.51.15600519221573701', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.91.124', '2019-06-09 11:45:22', 0, 1002001015, '账号未登陆', '2019-06-09 11:45:22');
INSERT INTO `access_log` VALUES (32829, '65.53.15600519221773667', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.91.124', '2019-06-09 11:45:22', 0, 1002001015, '账号未登陆', '2019-06-09 11:45:22');
INSERT INTO `access_log` VALUES (32830, '65.46.15600519248623687', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.91.124', '2019-06-09 11:45:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 11:45:25');
INSERT INTO `access_log` VALUES (32831, '65.54.15600519413423649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.91.124', '2019-06-09 11:45:41', 92, 0, '', '2019-06-09 11:45:41');
INSERT INTO `access_log` VALUES (32832, '65.47.15600519418843691', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.91.124', '2019-06-09 11:45:42', 13, 0, '', '2019-06-09 11:45:42');
INSERT INTO `access_log` VALUES (32833, '65.52.15600519418843695', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.91.124', '2019-06-09 11:45:42', 13, 0, '', '2019-06-09 11:45:42');
INSERT INTO `access_log` VALUES (32834, '65.45.15600519419013695', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.91.124', '2019-06-09 11:45:42', 8, 0, '', '2019-06-09 11:45:42');
INSERT INTO `access_log` VALUES (32835, '62.89.15600519478223195', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '223.104.91.124', '2019-06-09 11:45:48', 23, 0, '', '2019-06-09 11:45:48');
INSERT INTO `access_log` VALUES (32836, '65.45.15600534023833715', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '61.143.62.3', '2019-06-09 12:10:02', 0, 1002001015, '账号未登陆', '2019-06-09 12:10:02');
INSERT INTO `access_log` VALUES (32837, '65.52.15600534023853715', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '61.143.62.2', '2019-06-09 12:10:02', 0, 1002001015, '账号未登陆', '2019-06-09 12:10:02');
INSERT INTO `access_log` VALUES (32838, '65.47.15600534024063711', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '61.143.62.7', '2019-06-09 12:10:02', 0, 1002001015, '账号未登陆', '2019-06-09 12:10:02');
INSERT INTO `access_log` VALUES (32839, '65.51.15600534044633723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '61.143.62.3', '2019-06-09 12:10:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 12:10:04');
INSERT INTO `access_log` VALUES (32840, '65.53.15600534115303689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai8&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '61.143.62.3', '2019-06-09 12:10:12', 90, 0, '', '2019-06-09 12:10:12');
INSERT INTO `access_log` VALUES (32841, '65.49.15600534122253737', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '61.143.62.3', '2019-06-09 12:10:12', 10, 0, '', '2019-06-09 12:10:12');
INSERT INTO `access_log` VALUES (32842, '65.46.15600534122253709', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '61.143.62.4', '2019-06-09 12:10:12', 10, 0, '', '2019-06-09 12:10:12');
INSERT INTO `access_log` VALUES (32843, '65.3607.15600534122265479', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '61.143.62.6', '2019-06-09 12:10:12', 19, 0, '', '2019-06-09 12:10:12');
INSERT INTO `access_log` VALUES (32844, '66.57.15600534189951877', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '61.143.62.3', '2019-06-09 12:10:19', 20, 0, '', '2019-06-09 12:10:19');
INSERT INTO `access_log` VALUES (32845, '65.45.15600534257983717', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '61.143.62.3', '2019-06-09 12:10:26', 11, 0, '', '2019-06-09 12:10:26');
INSERT INTO `access_log` VALUES (32846, '66.54.15600534287241879', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '61.143.62.3', '2019-06-09 12:10:29', 12, 0, '', '2019-06-09 12:10:29');
INSERT INTO `access_log` VALUES (32847, '59.73.15600548187243401', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:33:39', 10, 0, '', '2019-06-09 12:33:39');
INSERT INTO `access_log` VALUES (32848, '59.72.15600548187243399', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:33:39', 16, 2001001000, '服务端发生异常', '2019-06-09 12:33:39');
INSERT INTO `access_log` VALUES (32849, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=xx&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:33:48', 13, 0, '', '2019-06-09 12:33:48');
INSERT INTO `access_log` VALUES (32850, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=xx', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:33:48', 8, 0, '', '2019-06-09 12:33:48');
INSERT INTO `access_log` VALUES (32851, '59.74.15600548373413397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:33:57', 5, 0, '', '2019-06-09 12:33:57');
INSERT INTO `access_log` VALUES (32852, '59.71.15600548373443401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:33:57', 20, 2001001000, '服务端发生异常', '2019-06-09 12:33:57');
INSERT INTO `access_log` VALUES (32853, '65.3607.15600548472175499', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:07', 0, 1002001015, '账号未登陆', '2019-06-09 12:34:07');
INSERT INTO `access_log` VALUES (32854, '65.53.15600548472173709', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:07', 0, 1002001015, '账号未登陆', '2019-06-09 12:34:07');
INSERT INTO `access_log` VALUES (32855, '65.49.15600548472713757', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:07', 0, 1002001015, '账号未登陆', '2019-06-09 12:34:07');
INSERT INTO `access_log` VALUES (32856, '65.54.15600548630993691', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:23', 80, 0, '', '2019-06-09 12:34:23');
INSERT INTO `access_log` VALUES (32857, '65.45.15600548637223737', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:24', 9, 0, '', '2019-06-09 12:34:24');
INSERT INTO `access_log` VALUES (32858, '65.52.15600548637223737', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:24', 10, 0, '', '2019-06-09 12:34:24');
INSERT INTO `access_log` VALUES (32859, '65.47.15600548637533733', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:24', 9, 0, '', '2019-06-09 12:34:24');
INSERT INTO `access_log` VALUES (32860, '62.82.15600548709163231', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:31', 23, 0, '', '2019-06-09 12:34:31');
INSERT INTO `access_log` VALUES (32861, '64.76.15600548836223243', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:44', 19, 0, '', '2019-06-09 12:34:44');
INSERT INTO `access_log` VALUES (32862, '64.80.15600548836183249', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:44', 25, 0, '', '2019-06-09 12:34:44');
INSERT INTO `access_log` VALUES (32863, '64.81.15600548907523253', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:51', 85, 0, '', '2019-06-09 12:34:51');
INSERT INTO `access_log` VALUES (32864, '64.85.15600548907523273', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:51', 86, 0, '', '2019-06-09 12:34:51');
INSERT INTO `access_log` VALUES (32865, '64.77.15600548956263261', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:56', 79, 0, '', '2019-06-09 12:34:56');
INSERT INTO `access_log` VALUES (32866, '64.82.15600548966683267', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:57', 10, 0, '', '2019-06-09 12:34:57');
INSERT INTO `access_log` VALUES (32867, '64.84.15600548978983263', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:34:58', 1342, 0, '', '2019-06-09 12:34:59');
INSERT INTO `access_log` VALUES (32868, '59.76.15600549025723395', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:35:03', 13, 0, '', '2019-06-09 12:35:03');
INSERT INTO `access_log` VALUES (32869, '59.72.15600549068733401', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:35:07', 13, 0, '', '2019-06-09 12:35:07');
INSERT INTO `access_log` VALUES (32870, '65.49.15600549128273759', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:35:13', 18, 0, '', '2019-06-09 12:35:13');
INSERT INTO `access_log` VALUES (32871, '65.46.15600549158003731', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:35:16', 10, 0, '', '2019-06-09 12:35:16');
INSERT INTO `access_log` VALUES (32872, '65.54.15600549180113693', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:35:18', 10, 0, '', '2019-06-09 12:35:18');
INSERT INTO `access_log` VALUES (32873, '65.45.15600549204823739', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.64.47', '2019-06-09 12:35:20', 14, 0, '', '2019-06-09 12:35:20');
INSERT INTO `access_log` VALUES (32874, '59.76.15600595223413457', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.196.82.6', '2019-06-09 13:52:02', 11, 0, '', '2019-06-09 13:52:02');
INSERT INTO `access_log` VALUES (32875, '59.73.15600595223433465', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.196.82.6', '2019-06-09 13:52:02', 15, 2001001000, '服务端发生异常', '2019-06-09 13:52:02');
INSERT INTO `access_log` VALUES (32876, '64.84.15600595270223325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.196.82.6', '2019-06-09 13:52:07', 9, 0, '', '2019-06-09 13:52:07');
INSERT INTO `access_log` VALUES (32877, '64.83.15600595271713309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.196.82.6', '2019-06-09 13:52:07', 2, 0, '', '2019-06-09 13:52:07');
INSERT INTO `access_log` VALUES (32878, '64.78.15600595289213323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.196.82.6', '2019-06-09 13:52:09', 134, 0, '', '2019-06-09 13:52:09');
INSERT INTO `access_log` VALUES (32879, '64.76.15600595295193307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.196.82.6', '2019-06-09 13:52:10', 2, 0, '', '2019-06-09 13:52:10');
INSERT INTO `access_log` VALUES (32880, '65.52.15600620375573835', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.7.98', '2019-06-09 14:33:58', 1, 1002001015, '账号未登陆', '2019-06-09 14:33:58');
INSERT INTO `access_log` VALUES (32881, '65.45.15600620375563835', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.7.98', '2019-06-09 14:33:58', 1, 1002001015, '账号未登陆', '2019-06-09 14:33:58');
INSERT INTO `access_log` VALUES (32882, '65.47.15600620375593831', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.7.98', '2019-06-09 14:33:58', 0, 1002001015, '账号未登陆', '2019-06-09 14:33:58');
INSERT INTO `access_log` VALUES (32883, '65.51.15600620393803843', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.7.98', '2019-06-09 14:33:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 14:33:59');
INSERT INTO `access_log` VALUES (32884, '65.50.15600620453963831', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.7.98', '2019-06-09 14:34:05', 84, 0, '', '2019-06-09 14:34:05');
INSERT INTO `access_log` VALUES (32885, '65.3607.15600620456565599', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.7.98', '2019-06-09 14:34:06', 13, 0, '', '2019-06-09 14:34:06');
INSERT INTO `access_log` VALUES (32886, '65.53.15600620456563809', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.7.98', '2019-06-09 14:34:06', 15, 0, '', '2019-06-09 14:34:06');
INSERT INTO `access_log` VALUES (32887, '65.49.15600620456623855', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.7.98', '2019-06-09 14:34:06', 14, 0, '', '2019-06-09 14:34:06');
INSERT INTO `access_log` VALUES (32888, '62.86.15600620923463319', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.7.98', '2019-06-09 14:34:52', 1151, 0, '', '2019-06-09 14:34:54');
INSERT INTO `access_log` VALUES (32889, '65.47.15600621021403833', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.7.98', '2019-06-09 14:35:02', 28, 0, '', '2019-06-09 14:35:02');
INSERT INTO `access_log` VALUES (32890, '65.51.15600621070783845', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.7.98', '2019-06-09 14:35:07', 12, 0, '', '2019-06-09 14:35:07');
INSERT INTO `access_log` VALUES (32891, '59.74.15600673400413565', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '171.43.204.142', '2019-06-09 16:02:20', 11, 0, '', '2019-06-09 16:02:20');
INSERT INTO `access_log` VALUES (32892, '59.71.15600673400423569', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '171.43.204.142', '2019-06-09 16:02:20', 14, 2001001000, '服务端发生异常', '2019-06-09 16:02:20');
INSERT INTO `access_log` VALUES (32893, '65.47.15600700204813939', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.143.205.57', '2019-06-09 16:47:00', 0, 1002001015, '账号未登陆', '2019-06-09 16:47:00');
INSERT INTO `access_log` VALUES (32894, '65.51.15600700204833951', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.143.205.57', '2019-06-09 16:47:00', 0, 1002001015, '账号未登陆', '2019-06-09 16:47:00');
INSERT INTO `access_log` VALUES (32895, '65.50.15600700204843939', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.143.205.57', '2019-06-09 16:47:00', 0, 1002001015, '账号未登陆', '2019-06-09 16:47:00');
INSERT INTO `access_log` VALUES (32896, '65.53.15600700230043917', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.143.205.57', '2019-06-09 16:47:03', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 16:47:03');
INSERT INTO `access_log` VALUES (32897, '65.49.15600700261483963', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.143.205.57', '2019-06-09 16:47:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 16:47:06');
INSERT INTO `access_log` VALUES (32898, '65.46.15600700350953935', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.143.205.57', '2019-06-09 16:47:15', 122, 0, '', '2019-06-09 16:47:15');
INSERT INTO `access_log` VALUES (32899, '65.54.15600700355673899', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.143.205.57', '2019-06-09 16:47:16', 148, 0, '', '2019-06-09 16:47:16');
INSERT INTO `access_log` VALUES (32900, '65.52.15600700355813945', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.143.205.57', '2019-06-09 16:47:16', 136, 0, '', '2019-06-09 16:47:16');
INSERT INTO `access_log` VALUES (32901, '65.45.15600700355743945', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.143.205.57', '2019-06-09 16:47:16', 144, 0, '', '2019-06-09 16:47:16');
INSERT INTO `access_log` VALUES (32902, '62.80.15600700428983443', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.143.205.57', '2019-06-09 16:47:23', 22, 0, '', '2019-06-09 16:47:23');
INSERT INTO `access_log` VALUES (32903, '65.47.15600700471093941', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.143.205.57', '2019-06-09 16:47:27', 18, 0, '', '2019-06-09 16:47:27');
INSERT INTO `access_log` VALUES (32904, '65.46.15600713037693953', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:08:24', 1, 1002001015, '账号未登陆', '2019-06-09 17:08:24');
INSERT INTO `access_log` VALUES (32905, '65.45.15600713037703963', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:08:24', 1, 1002001015, '账号未登陆', '2019-06-09 17:08:24');
INSERT INTO `access_log` VALUES (32906, '65.52.15600713037713961', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:08:24', 0, 1002001015, '账号未登陆', '2019-06-09 17:08:24');
INSERT INTO `access_log` VALUES (32907, '65.51.15600713139173973', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:08:34', 65, 0, '', '2019-06-09 17:08:34');
INSERT INTO `access_log` VALUES (32908, '65.50.15600713141603963', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:08:34', 9, 0, '', '2019-06-09 17:08:34');
INSERT INTO `access_log` VALUES (32909, '65.47.15600713141633959', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:08:34', 8, 0, '', '2019-06-09 17:08:34');
INSERT INTO `access_log` VALUES (32910, '65.53.15600713141673937', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:08:34', 9, 0, '', '2019-06-09 17:08:34');
INSERT INTO `access_log` VALUES (32911, '62.89.15600713217983455', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:08:42', 15, 0, '', '2019-06-09 17:08:42');
INSERT INTO `access_log` VALUES (32912, '64.83.15600713278103467', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:08:48', 24, 0, '', '2019-06-09 17:08:48');
INSERT INTO `access_log` VALUES (32913, '64.84.15600713278103483', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:08:48', 27, 0, '', '2019-06-09 17:08:48');
INSERT INTO `access_log` VALUES (32914, '66.51.15600713335862113', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:08:54', 21, 0, '', '2019-06-09 17:08:54');
INSERT INTO `access_log` VALUES (32915, '59.72.15600713414193621', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:09:01', 20, 2001001000, '服务端发生异常', '2019-06-09 17:09:01');
INSERT INTO `access_log` VALUES (32916, '59.77.15600713437353613', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:09:04', 17, 0, '', '2019-06-09 17:09:04');
INSERT INTO `access_log` VALUES (32917, '65.46.15600713490983955', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:09:09', 19, 0, '', '2019-06-09 17:09:09');
INSERT INTO `access_log` VALUES (32918, '65.45.15600713501183965', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:09:10', 8, 0, '', '2019-06-09 17:09:10');
INSERT INTO `access_log` VALUES (32919, '65.54.15600713508993921', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:09:11', 8, 0, '', '2019-06-09 17:09:11');
INSERT INTO `access_log` VALUES (32920, '65.51.15600713517383975', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.175.148.227', '2019-06-09 17:09:12', 15, 0, '', '2019-06-09 17:09:12');
INSERT INTO `access_log` VALUES (32921, '65.51.15600722423923987', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '118.113.64.112', '2019-06-09 17:24:02', 1, 1002001015, '账号未登陆', '2019-06-09 17:24:02');
INSERT INTO `access_log` VALUES (32922, '65.50.15600722424023977', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '118.113.64.112', '2019-06-09 17:24:02', 0, 1002001015, '账号未登陆', '2019-06-09 17:24:02');
INSERT INTO `access_log` VALUES (32923, '65.47.15600722424023973', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '118.113.64.112', '2019-06-09 17:24:02', 0, 1002001015, '账号未登陆', '2019-06-09 17:24:02');
INSERT INTO `access_log` VALUES (32924, '65.49.15600722654363999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '118.113.64.112', '2019-06-09 17:24:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 17:24:25');
INSERT INTO `access_log` VALUES (32925, '65.46.15600722793783969', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '118.113.64.112', '2019-06-09 17:24:39', 96, 0, '', '2019-06-09 17:24:39');
INSERT INTO `access_log` VALUES (32926, '65.45.15600722799453979', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '118.113.64.112', '2019-06-09 17:24:40', 10, 0, '', '2019-06-09 17:24:40');
INSERT INTO `access_log` VALUES (32927, '65.54.15600722799493935', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '118.113.64.112', '2019-06-09 17:24:40', 9, 0, '', '2019-06-09 17:24:40');
INSERT INTO `access_log` VALUES (32928, '59.78.15600730589343647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:39', 4, 0, '', '2019-06-09 17:37:39');
INSERT INTO `access_log` VALUES (32929, '59.76.15600730589443639', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:39', 13, 2001001000, '服务端发生异常', '2019-06-09 17:37:39');
INSERT INTO `access_log` VALUES (32930, '64.77.15600730611633505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:41', 6, 0, '', '2019-06-09 17:37:41');
INSERT INTO `access_log` VALUES (32931, '64.82.15600730615053511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:42', 3, 0, '', '2019-06-09 17:37:42');
INSERT INTO `access_log` VALUES (32932, '64.84.15600730639213507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:44', 2, 0, '', '2019-06-09 17:37:44');
INSERT INTO `access_log` VALUES (32933, '64.83.15600730640843491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:44', 2, 0, '', '2019-06-09 17:37:44');
INSERT INTO `access_log` VALUES (32934, '59.73.15600730658133647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:46', 3, 0, '', '2019-06-09 17:37:46');
INSERT INTO `access_log` VALUES (32935, '59.72.15600730658193645', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:46', 21, 2001001000, '服务端发生异常', '2019-06-09 17:37:46');
INSERT INTO `access_log` VALUES (32936, '64.78.15600730682453505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:48', 3, 0, '', '2019-06-09 17:37:48');
INSERT INTO `access_log` VALUES (32937, '64.76.15600730684743489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:48', 2, 0, '', '2019-06-09 17:37:48');
INSERT INTO `access_log` VALUES (32938, '64.80.15600730692693495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:49', 2, 0, '', '2019-06-09 17:37:49');
INSERT INTO `access_log` VALUES (32939, '64.79.15600730696963495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:50', 2, 0, '', '2019-06-09 17:37:50');
INSERT INTO `access_log` VALUES (32940, '59.74.15600730705503643', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:51', 2, 0, '', '2019-06-09 17:37:51');
INSERT INTO `access_log` VALUES (32941, '59.71.15600730705513647', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:51', 13, 2001001000, '服务端发生异常', '2019-06-09 17:37:51');
INSERT INTO `access_log` VALUES (32942, '64.85.15600730721283519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:52', 2, 0, '', '2019-06-09 17:37:52');
INSERT INTO `access_log` VALUES (32943, '64.77.15600730723303507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:37:52', 2, 0, '', '2019-06-09 17:37:52');
INSERT INTO `access_log` VALUES (32944, '59.74.15600733656173647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:42:46', 4, 0, '', '2019-06-09 17:42:46');
INSERT INTO `access_log` VALUES (32945, '59.80.15600733656173641', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:42:46', 14, 2001001000, '服务端发生异常', '2019-06-09 17:42:46');
INSERT INTO `access_log` VALUES (32946, '64.77.15600733660483511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:42:46', 78, 0, '', '2019-06-09 17:42:46');
INSERT INTO `access_log` VALUES (32947, '64.82.15600733663563517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:42:46', 2, 0, '', '2019-06-09 17:42:46');
INSERT INTO `access_log` VALUES (32948, '59.79.15600733672773653', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:42:47', 15, 2001001000, '服务端发生异常', '2019-06-09 17:42:47');
INSERT INTO `access_log` VALUES (32949, '59.75.15600733672753653', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:42:47', 54, 0, '', '2019-06-09 17:42:47');
INSERT INTO `access_log` VALUES (32950, '64.84.15600733679683513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:42:48', 2, 0, '', '2019-06-09 17:42:48');
INSERT INTO `access_log` VALUES (32951, '64.83.15600733681503497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:42:48', 2, 0, '', '2019-06-09 17:42:48');
INSERT INTO `access_log` VALUES (32952, '59.78.15600733686083653', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:42:49', 3, 0, '', '2019-06-09 17:42:49');
INSERT INTO `access_log` VALUES (32953, '59.76.15600733686123645', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:42:49', 13, 2001001000, '服务端发生异常', '2019-06-09 17:42:49');
INSERT INTO `access_log` VALUES (32954, '64.78.15600733696583511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:42:50', 2, 0, '', '2019-06-09 17:42:50');
INSERT INTO `access_log` VALUES (32955, '64.76.15600733698753495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:42:50', 2, 0, '', '2019-06-09 17:42:50');
INSERT INTO `access_log` VALUES (32956, '59.72.15600733700273651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:42:50', 3, 0, '', '2019-06-09 17:42:50');
INSERT INTO `access_log` VALUES (32957, '59.77.15600733700763643', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:42:50', 13, 2001001000, '服务端发生异常', '2019-06-09 17:42:50');
INSERT INTO `access_log` VALUES (32958, '65.53.15600733810113967', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:43:01', 0, 1002001015, '账号未登陆', '2019-06-09 17:43:01');
INSERT INTO `access_log` VALUES (32959, '65.3607.15600733810145757', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:43:01', 0, 1002001015, '账号未登陆', '2019-06-09 17:43:01');
INSERT INTO `access_log` VALUES (32960, '65.49.15600733810354015', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:43:01', 0, 1002001015, '账号未登陆', '2019-06-09 17:43:01');
INSERT INTO `access_log` VALUES (32961, '65.52.15600733833793993', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:43:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 17:43:03');
INSERT INTO `access_log` VALUES (32962, '65.46.15600733856373985', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:43:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 17:43:06');
INSERT INTO `access_log` VALUES (32963, '65.54.15600734014583951', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=youdaoyuanma&password=youdaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:43:21', 4, 1002002000, '账号不存在', '2019-06-09 17:43:21');
INSERT INTO `access_log` VALUES (32964, '65.51.15600734040294005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:43:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 17:43:24');
INSERT INTO `access_log` VALUES (32965, '65.50.15600734054293995', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:43:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 17:43:25');
INSERT INTO `access_log` VALUES (32966, '65.53.15600734274793969', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=youdaoyuanma&password=youdaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 7.1.1; OS105) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.112 Mobile Safari/537.36', '101.206.166.143', '2019-06-09 17:43:47', 4, 1002002000, '账号不存在', '2019-06-09 17:43:47');
INSERT INTO `access_log` VALUES (32967, '65.52.15600785306454063', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:08:51', 12, 1002001012, '访问令牌已过期', '2019-06-09 19:08:51');
INSERT INTO `access_log` VALUES (32968, '65.49.15600785306454085', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:08:51', 14, 1002001012, '访问令牌已过期', '2019-06-09 19:08:51');
INSERT INTO `access_log` VALUES (32969, '65.46.15600785306464055', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:08:51', 14, 1002001012, '访问令牌已过期', '2019-06-09 19:08:51');
INSERT INTO `access_log` VALUES (32970, '65.45.15600785333204065', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:08:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 19:08:53');
INSERT INTO `access_log` VALUES (32971, '65.47.15600785479184061', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:09:08', 167, 0, '', '2019-06-09 19:09:08');
INSERT INTO `access_log` VALUES (32972, '65.51.15600785486604075', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:09:09', 12, 0, '', '2019-06-09 19:09:09');
INSERT INTO `access_log` VALUES (32973, '65.50.15600785486694065', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:09:09', 9, 0, '', '2019-06-09 19:09:09');
INSERT INTO `access_log` VALUES (32974, '65.3607.15600785486735829', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:09:09', 9, 0, '', '2019-06-09 19:09:09');
INSERT INTO `access_log` VALUES (32975, '65.49.15600785554704087', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:09:15', 19, 0, '', '2019-06-09 19:09:15');
INSERT INTO `access_log` VALUES (32976, '65.46.15600785568664057', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:09:17', 9, 0, '', '2019-06-09 19:09:17');
INSERT INTO `access_log` VALUES (32977, '65.52.15600785624004065', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:09:22', 13, 0, '', '2019-06-09 19:09:22');
INSERT INTO `access_log` VALUES (32978, '65.54.15600785700084023', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:09:30', 9, 0, '', '2019-06-09 19:09:30');
INSERT INTO `access_log` VALUES (32979, '65.3607.15600785858825831', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:09:46', 14, 0, '', '2019-06-09 19:09:46');
INSERT INTO `access_log` VALUES (32980, '62.88.15600785943773561', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:09:54', 76, 0, '', '2019-06-09 19:09:54');
INSERT INTO `access_log` VALUES (32981, '64.76.15600785975083565', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:09:58', 22, 0, '', '2019-06-09 19:09:58');
INSERT INTO `access_log` VALUES (32982, '64.80.15600785975243571', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:09:58', 12, 0, '', '2019-06-09 19:09:58');
INSERT INTO `access_log` VALUES (32983, '64.79.15600786028603571', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:10:03', 159, 0, '', '2019-06-09 19:10:03');
INSERT INTO `access_log` VALUES (32984, '64.81.15600786028673575', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.230.101.192', '2019-06-09 19:10:03', 157, 0, '', '2019-06-09 19:10:03');
INSERT INTO `access_log` VALUES (32985, '65.54.15600807870894053', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:46:27', 0, 1002001015, '账号未登陆', '2019-06-09 19:46:27');
INSERT INTO `access_log` VALUES (32986, '65.47.15600807870894093', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:46:27', 0, 1002001015, '账号未登陆', '2019-06-09 19:46:27');
INSERT INTO `access_log` VALUES (32987, '65.3607.15600807870915861', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:46:27', 0, 1002001015, '账号未登陆', '2019-06-09 19:46:27');
INSERT INTO `access_log` VALUES (32988, '65.51.15600807901414107', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:46:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 19:46:30');
INSERT INTO `access_log` VALUES (32989, '65.50.15600807950594097', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:46:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 19:46:35');
INSERT INTO `access_log` VALUES (32990, '65.49.15600808018754119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:46:42', 110, 0, '', '2019-06-09 19:46:42');
INSERT INTO `access_log` VALUES (32991, '65.46.15600808022144089', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:46:42', 10, 0, '', '2019-06-09 19:46:42');
INSERT INTO `access_log` VALUES (32992, '65.52.15600808022414097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:46:42', 9, 0, '', '2019-06-09 19:46:42');
INSERT INTO `access_log` VALUES (32993, '65.45.15600808022444099', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:46:42', 9, 0, '', '2019-06-09 19:46:42');
INSERT INTO `access_log` VALUES (32994, '62.83.15600808060233585', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:46:46', 22, 0, '', '2019-06-09 19:46:46');
INSERT INTO `access_log` VALUES (32995, '62.85.15600808096573575', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:46:50', 23, 0, '', '2019-06-09 19:46:50');
INSERT INTO `access_log` VALUES (32996, '65.3607.15600808194925863', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:46:59', 19, 0, '', '2019-06-09 19:47:00');
INSERT INTO `access_log` VALUES (32997, '65.47.15600808228564095', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:47:03', 10, 0, '', '2019-06-09 19:47:03');
INSERT INTO `access_log` VALUES (32998, '65.51.15600808239304109', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:47:04', 9, 0, '', '2019-06-09 19:47:04');
INSERT INTO `access_log` VALUES (32999, '65.50.15600808249144099', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:47:05', 21, 0, '', '2019-06-09 19:47:05');
INSERT INTO `access_log` VALUES (33000, '59.73.15600808284623753', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:47:08', 17, 2001001000, '服务端发生异常', '2019-06-09 19:47:08');
INSERT INTO `access_log` VALUES (33001, '59.75.15600809189073755', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:48:39', 13, 0, '', '2019-06-09 19:48:39');
INSERT INTO `access_log` VALUES (33002, '59.78.15600809189203755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.65.30.82', '2019-06-09 19:48:39', 18, 2001001000, '服务端发生异常', '2019-06-09 19:48:39');
INSERT INTO `access_log` VALUES (33003, '59.74.15600824802553771', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.181', '2019-06-09 20:14:40', 11, 2001001000, '服务端发生异常', '2019-06-09 20:14:40');
INSERT INTO `access_log` VALUES (33004, '59.71.15600824802543775', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.181', '2019-06-09 20:14:40', 67, 0, '', '2019-06-09 20:14:40');
INSERT INTO `access_log` VALUES (33005, '64.79.15600824867433623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.181', '2019-06-09 20:14:47', 11, 0, '', '2019-06-09 20:14:47');
INSERT INTO `access_log` VALUES (33006, '64.85.15600824869173647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.181', '2019-06-09 20:14:47', 2, 0, '', '2019-06-09 20:14:47');
INSERT INTO `access_log` VALUES (33007, '66.54.15600825049292267', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15510086451&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.181', '2019-06-09 20:15:05', 17, 1001003000, '验证码不存在', '2019-06-09 20:15:05');
INSERT INTO `access_log` VALUES (33008, '66.49.15600825073462271', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15510086451', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.181', '2019-06-09 20:15:07', 72, 0, '', '2019-06-09 20:15:07');
INSERT INTO `access_log` VALUES (33009, '66.55.15600825177792267', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15510086451&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.181', '2019-06-09 20:15:18', 196, 0, '', '2019-06-09 20:15:18');
INSERT INTO `access_log` VALUES (33010, '59.71.15600865025143829', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '130.105.186.81', '2019-06-09 21:21:43', 17, 0, '', '2019-06-09 21:21:43');
INSERT INTO `access_log` VALUES (33011, '59.74.15600865025143825', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '130.105.186.81', '2019-06-09 21:21:43', 22, 2001001000, '服务端发生异常', '2019-06-09 21:21:43');
INSERT INTO `access_log` VALUES (33012, '65.3607.15600870617965947', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:31:02', 0, 1002001015, '账号未登陆', '2019-06-09 21:31:02');
INSERT INTO `access_log` VALUES (33013, '65.54.15600870617964141', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:31:02', 1, 1002001015, '账号未登陆', '2019-06-09 21:31:02');
INSERT INTO `access_log` VALUES (33014, '65.47.15600870617974179', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:31:02', 1, 1002001015, '账号未登陆', '2019-06-09 21:31:02');
INSERT INTO `access_log` VALUES (33015, '65.51.15600870639054193', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:31:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 21:31:04');
INSERT INTO `access_log` VALUES (33016, '65.49.15600870862944205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:31:26', 54, 0, '', '2019-06-09 21:31:26');
INSERT INTO `access_log` VALUES (33017, '65.46.15600870866434177', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:31:27', 9, 0, '', '2019-06-09 21:31:27');
INSERT INTO `access_log` VALUES (33018, '65.52.15600870866524183', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:31:27', 8, 0, '', '2019-06-09 21:31:27');
INSERT INTO `access_log` VALUES (33019, '65.45.15600870866574187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:31:27', 8, 0, '', '2019-06-09 21:31:27');
INSERT INTO `access_log` VALUES (33020, '62.82.15600871041423663', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:31:44', 22, 0, '', '2019-06-09 21:31:44');
INSERT INTO `access_log` VALUES (33021, '59.79.15600871227353839', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:32:03', 24, 0, '', '2019-06-09 21:32:03');
INSERT INTO `access_log` VALUES (33022, '65.54.15600871281254143', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:32:08', 16, 0, '', '2019-06-09 21:32:08');
INSERT INTO `access_log` VALUES (33023, '65.50.15600871327264187', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:32:13', 10, 0, '', '2019-06-09 21:32:13');
INSERT INTO `access_log` VALUES (33024, '65.53.15600871347164159', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:32:15', 9, 0, '', '2019-06-09 21:32:15');
INSERT INTO `access_log` VALUES (33025, '65.49.15600871399014207', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:32:20', 13, 0, '', '2019-06-09 21:32:20');
INSERT INTO `access_log` VALUES (33026, '62.80.15600871496273673', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:32:30', 14, 0, '', '2019-06-09 21:32:30');
INSERT INTO `access_log` VALUES (33027, '64.85.15600871546163711', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.242.191', '2019-06-09 21:32:35', 22, 0, '', '2019-06-09 21:32:35');
INSERT INTO `access_log` VALUES (33028, '65.45.15600889662354213', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:02:46', 1, 1002001015, '账号未登陆', '2019-06-09 22:02:46');
INSERT INTO `access_log` VALUES (33029, '65.47.15600889662364207', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:02:46', 0, 1002001015, '账号未登陆', '2019-06-09 22:02:46');
INSERT INTO `access_log` VALUES (33030, '65.3607.15600889662365975', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:02:46', 0, 1002001015, '账号未登陆', '2019-06-09 22:02:46');
INSERT INTO `access_log` VALUES (33031, '65.54.15600889694324169', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:02:49', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-09 22:02:49');
INSERT INTO `access_log` VALUES (33032, '65.50.15600889777874213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:02:58', 178, 0, '', '2019-06-09 22:02:58');
INSERT INTO `access_log` VALUES (33033, '65.53.15600889781964185', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:02:58', 13, 0, '', '2019-06-09 22:02:58');
INSERT INTO `access_log` VALUES (33034, '65.46.15600889781974205', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:02:58', 14, 0, '', '2019-06-09 22:02:58');
INSERT INTO `access_log` VALUES (33035, '65.49.15600889781974233', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:02:58', 14, 0, '', '2019-06-09 22:02:58');
INSERT INTO `access_log` VALUES (33036, '64.84.15600889908093725', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:03:11', 81, 0, '', '2019-06-09 22:03:11');
INSERT INTO `access_log` VALUES (33037, '64.83.15600889908103709', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:03:11', 83, 0, '', '2019-06-09 22:03:11');
INSERT INTO `access_log` VALUES (33038, '66.57.15600890276862353', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:03:48', 26, 0, '', '2019-06-09 22:03:48');
INSERT INTO `access_log` VALUES (33039, '59.80.15600890342293853', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:03:54', 21, 2001001000, '服务端发生异常', '2019-06-09 22:03:54');
INSERT INTO `access_log` VALUES (33040, '59.79.15600890414273865', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:04:01', 20, 0, '', '2019-06-09 22:04:01');
INSERT INTO `access_log` VALUES (33041, '64.85.15600890591863737', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:04:19', 11, 0, '', '2019-06-09 22:04:19');
INSERT INTO `access_log` VALUES (33042, '64.82.15600890674463729', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '111.201.227.91', '2019-06-09 22:04:27', 15, 0, '', '2019-06-09 22:04:27');
INSERT INTO `access_log` VALUES (33043, '66.52.15600921671022395', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18311112222', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:56:07', 172, 0, '', '2019-06-09 22:56:07');
INSERT INTO `access_log` VALUES (33044, '66.54.15600921718522397', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18311112222&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:56:12', 169, 0, '', '2019-06-09 22:56:12');
INSERT INTO `access_log` VALUES (33045, '66.49.15600921745362401', 116, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:56:15', 7, 0, '', '2019-06-09 22:56:15');
INSERT INTO `access_log` VALUES (33046, '66.51.15600921933332393', 116, 1, 'user-application', '/user-api/users/user/update_nickname', 'nickname=各回各家', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:56:33', 101, 0, '', '2019-06-09 22:56:33');
INSERT INTO `access_log` VALUES (33047, '66.53.15600922006672393', 116, 1, 'user-application', '/user-api/users/user/update_nickname', 'nickname=各回各家', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:56:41', 9, 0, '', '2019-06-09 22:56:41');
INSERT INTO `access_log` VALUES (33048, '66.54.15600922367092399', 116, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:57:17', 6, 0, '', '2019-06-09 22:57:17');
INSERT INTO `access_log` VALUES (33049, '66.56.15600922389512391', 116, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:57:19', 6, 0, '', '2019-06-09 22:57:19');
INSERT INTO `access_log` VALUES (33050, '59.71.15600922441553907', 116, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:57:24', 18, 0, '', '2019-06-09 22:57:24');
INSERT INTO `access_log` VALUES (33051, '59.74.15600922442553903', 116, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:57:24', 36, 2001001000, '服务端发生异常', '2019-06-09 22:57:24');
INSERT INTO `access_log` VALUES (33052, '64.81.15600922664403759', 116, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:57:46', 11, 0, '', '2019-06-09 22:57:46');
INSERT INTO `access_log` VALUES (33053, '64.79.15600922667693755', 116, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:57:47', 5, 0, '', '2019-06-09 22:57:47');
INSERT INTO `access_log` VALUES (33054, '64.82.15600922724713773', 116, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:57:52', 98, 0, '', '2019-06-09 22:57:53');
INSERT INTO `access_log` VALUES (33055, '64.78.15600922750923769', 116, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:57:55', 5, 0, '', '2019-06-09 22:57:55');
INSERT INTO `access_log` VALUES (33056, 'N/A', 116, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:57:55', 19, 0, '', '2019-06-09 22:57:55');
INSERT INTO `access_log` VALUES (33057, '64.83.15600922845123755', 116, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:58:05', 64, 0, '', '2019-06-09 22:58:05');
INSERT INTO `access_log` VALUES (33058, '66.53.15600922909502395', 116, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:58:11', 6, 0, '', '2019-06-09 22:58:11');
INSERT INTO `access_log` VALUES (33059, '66.54.15600923027352401', 116, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:58:23', 6, 0, '', '2019-06-09 22:58:23');
INSERT INTO `access_log` VALUES (33060, '66.56.15600923108192393', 116, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:58:31', 6, 0, '', '2019-06-09 22:58:31');
INSERT INTO `access_log` VALUES (33061, '64.79.15600923173363757', 116, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:58:37', 10, 0, '', '2019-06-09 22:58:37');
INSERT INTO `access_log` VALUES (33062, '64.77.15600923424353769', 116, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:59:02', 62, 0, '', '2019-06-09 22:59:02');
INSERT INTO `access_log` VALUES (33063, 'N/A', 116, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:59:03', 22, 0, '', '2019-06-09 22:59:03');
INSERT INTO `access_log` VALUES (33064, 'N/A', 116, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:59:06', 11, 0, '', '2019-06-09 22:59:06');
INSERT INTO `access_log` VALUES (33065, 'N/A', 116, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '130.105.186.81', '2019-06-09 22:59:09', 10, 0, '', '2019-06-09 22:59:09');
INSERT INTO `access_log` VALUES (33066, '59.79.15600966062623967', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:10:06', 13, 0, '', '2019-06-10 00:10:06');
INSERT INTO `access_log` VALUES (33067, '59.75.15600966062623967', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:10:06', 28, 2001001000, '服务端发生异常', '2019-06-10 00:10:06');
INSERT INTO `access_log` VALUES (33068, '64.81.15600966108483819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:10:11', 11, 0, '', '2019-06-10 00:10:11');
INSERT INTO `access_log` VALUES (33069, '64.76.15600966110553811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:10:11', 3, 0, '', '2019-06-10 00:10:11');
INSERT INTO `access_log` VALUES (33070, '64.79.15600966132233815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:10:13', 85, 0, '', '2019-06-10 00:10:13');
INSERT INTO `access_log` VALUES (33071, '64.85.15600966146593841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:10:15', 2, 0, '', '2019-06-10 00:10:15');
INSERT INTO `access_log` VALUES (33072, '64.77.15600966160413827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:10:16', 2, 0, '', '2019-06-10 00:10:16');
INSERT INTO `access_log` VALUES (33073, '64.82.15600966171073833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:10:17', 2, 0, '', '2019-06-10 00:10:17');
INSERT INTO `access_log` VALUES (33074, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:10:17', 14, 0, '', '2019-06-10 00:10:17');
INSERT INTO `access_log` VALUES (33075, '64.78.15600966190263829', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:10:19', 8, 0, '', '2019-06-10 00:10:19');
INSERT INTO `access_log` VALUES (33076, '64.81.15600966539353821', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:10:54', 7, 0, '', '2019-06-10 00:10:54');
INSERT INTO `access_log` VALUES (33077, '64.76.15600966555843813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:10:56', 2, 0, '', '2019-06-10 00:10:56');
INSERT INTO `access_log` VALUES (33078, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:10:56', 5, 0, '', '2019-06-10 00:10:56');
INSERT INTO `access_log` VALUES (33079, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:00', 6, 0, '', '2019-06-10 00:11:00');
INSERT INTO `access_log` VALUES (33080, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:01', 5, 0, '', '2019-06-10 00:11:01');
INSERT INTO `access_log` VALUES (33081, '64.79.15600966616733817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:02', 18, 0, '', '2019-06-10 00:11:02');
INSERT INTO `access_log` VALUES (33082, '64.85.15600966618803843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:02', 2, 0, '', '2019-06-10 00:11:02');
INSERT INTO `access_log` VALUES (33083, '64.77.15600966630073829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:03', 2, 0, '', '2019-06-10 00:11:03');
INSERT INTO `access_log` VALUES (33084, '64.82.15600966650513835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:05', 1, 0, '', '2019-06-10 00:11:05');
INSERT INTO `access_log` VALUES (33085, '59.77.15600966675143957', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:08', 3, 0, '', '2019-06-10 00:11:08');
INSERT INTO `access_log` VALUES (33086, '59.71.15600966675373967', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:08', 31, 2001001000, '服务端发生异常', '2019-06-10 00:11:08');
INSERT INTO `access_log` VALUES (33087, '64.84.15600966721593833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:12', 2, 0, '', '2019-06-10 00:11:12');
INSERT INTO `access_log` VALUES (33088, '64.83.15600966723373817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:12', 1, 0, '', '2019-06-10 00:11:12');
INSERT INTO `access_log` VALUES (33089, '59.74.15600966747863963', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:15', 2, 0, '', '2019-06-10 00:11:15');
INSERT INTO `access_log` VALUES (33090, '59.80.15600966747873957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:15', 18, 2001001000, '服务端发生异常', '2019-06-10 00:11:15');
INSERT INTO `access_log` VALUES (33091, '64.80.15600966804103819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:20', 2, 0, '', '2019-06-10 00:11:20');
INSERT INTO `access_log` VALUES (33092, '64.76.15600966805383815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:21', 2, 0, '', '2019-06-10 00:11:21');
INSERT INTO `access_log` VALUES (33093, '64.79.15600966914683819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:31', 2, 0, '', '2019-06-10 00:11:31');
INSERT INTO `access_log` VALUES (33094, '64.85.15600966916053845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:32', 2, 0, '', '2019-06-10 00:11:32');
INSERT INTO `access_log` VALUES (33095, '64.77.15600966944663831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:34', 2, 0, '', '2019-06-10 00:11:34');
INSERT INTO `access_log` VALUES (33096, '64.82.15600966946133837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:35', 2, 0, '', '2019-06-10 00:11:35');
INSERT INTO `access_log` VALUES (33097, '59.78.15600966952323969', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:35', 3, 0, '', '2019-06-10 00:11:35');
INSERT INTO `access_log` VALUES (33098, '59.76.15600966952323961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:35', 12, 2001001000, '服务端发生异常', '2019-06-10 00:11:35');
INSERT INTO `access_log` VALUES (33099, '64.84.15600966956513835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:36', 2, 0, '', '2019-06-10 00:11:36');
INSERT INTO `access_log` VALUES (33100, '64.83.15600966958533819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:36', 2, 0, '', '2019-06-10 00:11:36');
INSERT INTO `access_log` VALUES (33101, '59.73.15600966971913969', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:37', 2, 0, '', '2019-06-10 00:11:37');
INSERT INTO `access_log` VALUES (33102, '59.72.15600966972113967', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:37', 22, 2001001000, '服务端发生异常', '2019-06-10 00:11:37');
INSERT INTO `access_log` VALUES (33103, '64.80.15600966977203821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:38', 37, 0, '', '2019-06-10 00:11:38');
INSERT INTO `access_log` VALUES (33104, '64.81.15600966979153825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:38', 2, 0, '', '2019-06-10 00:11:38');
INSERT INTO `access_log` VALUES (33105, '59.71.15600966989163969', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:39', 3, 0, '', '2019-06-10 00:11:39');
INSERT INTO `access_log` VALUES (33106, '59.77.15600966989153959', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-cn; ONEPLUS A3010 Build/OPR1.170623.032) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/37.0.0.0 Mobile Safari/537.36', '::ffff:112.49.107.212', '2019-06-10 00:11:39', 17, 2001001000, '服务端发生异常', '2019-06-10 00:11:39');
INSERT INTO `access_log` VALUES (33107, '65.47.15601288670164741', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.232', '2019-06-10 09:07:47', 16, 1002001012, '访问令牌已过期', '2019-06-10 09:07:47');
INSERT INTO `access_log` VALUES (33108, '65.46.15601288670164739', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.232', '2019-06-10 09:07:47', 14, 1002001012, '访问令牌已过期', '2019-06-10 09:07:47');
INSERT INTO `access_log` VALUES (33109, '65.3607.15601288670166509', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.232', '2019-06-10 09:07:47', 22, 1002001012, '访问令牌已过期', '2019-06-10 09:07:47');
INSERT INTO `access_log` VALUES (33110, '64.82.15601288671704267', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.232', '2019-06-10 09:07:47', 10, 1002001012, '访问令牌已过期', '2019-06-10 09:07:47');
INSERT INTO `access_log` VALUES (33111, '59.74.15601289327584395', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '113.108.197.197', '2019-06-10 09:08:53', 32, 2001001000, '服务端发生异常', '2019-06-10 09:08:53');
INSERT INTO `access_log` VALUES (33112, '59.77.15601289327584389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '113.108.197.197', '2019-06-10 09:08:53', 257, 0, '', '2019-06-10 09:08:53');
INSERT INTO `access_log` VALUES (33113, '64.77.15601289822984263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '113.108.197.197', '2019-06-10 09:09:42', 11, 0, '', '2019-06-10 09:09:42');
INSERT INTO `access_log` VALUES (33114, '64.82.15601289824394269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '113.108.197.197', '2019-06-10 09:09:42', 2, 0, '', '2019-06-10 09:09:42');
INSERT INTO `access_log` VALUES (33115, '59.78.15601289846444401', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '113.108.197.197', '2019-06-10 09:09:45', 4, 0, '', '2019-06-10 09:09:45');
INSERT INTO `access_log` VALUES (33116, '59.76.15601289846714393', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '113.108.197.197', '2019-06-10 09:09:45', 19, 2001001000, '服务端发生异常', '2019-06-10 09:09:45');
INSERT INTO `access_log` VALUES (33117, '64.78.15601289870744265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '113.108.197.197', '2019-06-10 09:09:47', 1, 0, '', '2019-06-10 09:09:47');
INSERT INTO `access_log` VALUES (33118, '64.84.15601289871884267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '113.108.197.197', '2019-06-10 09:09:47', 2, 0, '', '2019-06-10 09:09:47');
INSERT INTO `access_log` VALUES (33119, '59.72.15601289883484399', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '113.108.197.197', '2019-06-10 09:09:48', 13, 2001001000, '服务端发生异常', '2019-06-10 09:09:48');
INSERT INTO `access_log` VALUES (33120, '59.73.15601289883484401', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '113.108.197.197', '2019-06-10 09:09:48', 200, 0, '', '2019-06-10 09:09:49');
INSERT INTO `access_log` VALUES (33121, '935aa34f-9654-4dde-8700-5b5ab04ea4d2', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '127.0.0.1', '2019-06-10 09:12:42', 594, 1002001012, '访问令牌已过期', '2019-06-10 09:12:43');
INSERT INTO `access_log` VALUES (33122, '05bd8d6c-6c7e-4226-bbd9-c59be16c1695', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '127.0.0.1', '2019-06-10 09:12:42', 594, 1002001012, '访问令牌已过期', '2019-06-10 09:12:43');
INSERT INTO `access_log` VALUES (33123, '40280896-58e0-44c1-a232-99d3085daa84', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '127.0.0.1', '2019-06-10 09:12:42', 594, 1002001012, '访问令牌已过期', '2019-06-10 09:12:43');
INSERT INTO `access_log` VALUES (33124, 'e6138d53-c8eb-4a9e-beaf-7348a4c935e4', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '127.0.0.1', '2019-06-10 09:15:29', 2, 1002001015, '账号未登陆', '2019-06-10 09:15:29');
INSERT INTO `access_log` VALUES (33125, '21b3997b-59c3-421d-96dc-5b29c07c0871', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '127.0.0.1', '2019-06-10 09:15:29', 1, 1002001015, '账号未登陆', '2019-06-10 09:15:29');
INSERT INTO `access_log` VALUES (33126, 'edb29f59-c3cf-4d33-a24a-088d8db83e04', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '127.0.0.1', '2019-06-10 09:15:29', 1, 1002001015, '账号未登陆', '2019-06-10 09:15:29');
INSERT INTO `access_log` VALUES (33127, 'ba5598e4-7d27-4049-b2e0-a1a68cb70e78', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '127.0.0.1', '2019-06-10 09:15:34', 18276, 0, '', '2019-06-10 09:15:52');
INSERT INTO `access_log` VALUES (33128, '1a846bde-cc97-42ab-b45a-206d02c6f32b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '127.0.0.1', '2019-06-10 09:15:52', 221, 0, '', '2019-06-10 09:15:52');
INSERT INTO `access_log` VALUES (33129, 'ee1022b3-48f1-47f4-a340-176dac06e85e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '127.0.0.1', '2019-06-10 09:15:52', 222, 0, '', '2019-06-10 09:15:52');
INSERT INTO `access_log` VALUES (33130, 'af9b44f1-5ad5-4449-8f85-a51095c07a0f', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '127.0.0.1', '2019-06-10 09:15:52', 253, 0, '', '2019-06-10 09:15:52');
INSERT INTO `access_log` VALUES (33131, '59.73.15601295730204409', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-10 09:19:33', 4, 0, '', '2019-06-10 09:19:33');
INSERT INTO `access_log` VALUES (33132, '59.71.15601295730224409', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-10 09:19:33', 13, 2001001000, '服务端发生异常', '2019-06-10 09:19:33');
INSERT INTO `access_log` VALUES (33133, '64.84.15601295754664275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-10 09:19:35', 80, 0, '', '2019-06-10 09:19:36');
INSERT INTO `access_log` VALUES (33134, '64.80.15601295756564261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-10 09:19:36', 2, 0, '', '2019-06-10 09:19:36');
INSERT INTO `access_log` VALUES (33135, '64.81.15601295767544265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-10 09:19:37', 3, 0, '', '2019-06-10 09:19:37');
INSERT INTO `access_log` VALUES (33136, '64.76.15601295770244257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-10 09:19:37', 2, 0, '', '2019-06-10 09:19:37');
INSERT INTO `access_log` VALUES (33137, '64.79.15601295773194261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-10 09:19:37', 1, 0, '', '2019-06-10 09:19:37');
INSERT INTO `access_log` VALUES (33138, '65.47.15601298362464755', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-cn; Redmi 3 Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '218.92.226.196', '2019-06-10 09:23:56', 0, 1002001015, '账号未登陆', '2019-06-10 09:23:56');
INSERT INTO `access_log` VALUES (33139, '65.50.15601298362104759', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-cn; Redmi 3 Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '218.92.226.196', '2019-06-10 09:23:56', 1, 1002001015, '账号未登陆', '2019-06-10 09:23:56');
INSERT INTO `access_log` VALUES (33140, '65.49.15601298362284779', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-cn; Redmi 3 Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '218.92.226.196', '2019-06-10 09:23:56', 0, 1002001015, '账号未登陆', '2019-06-10 09:23:56');
INSERT INTO `access_log` VALUES (33141, '65.46.15601298432294753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-cn; Redmi 3 Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '218.92.226.196', '2019-06-10 09:24:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 09:24:03');
INSERT INTO `access_log` VALUES (33142, '65.3607.15601298462306523', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-cn; Redmi 3 Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '218.92.226.196', '2019-06-10 09:24:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 09:24:06');
INSERT INTO `access_log` VALUES (33143, '65.54.15601298817944719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-cn; Redmi 3 Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '218.92.226.196', '2019-06-10 09:24:42', 260, 0, '', '2019-06-10 09:24:42');
INSERT INTO `access_log` VALUES (33144, '65.51.15601298833074767', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-cn; Redmi 3 Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '218.92.226.196', '2019-06-10 09:24:43', 10, 0, '', '2019-06-10 09:24:43');
INSERT INTO `access_log` VALUES (33145, '65.49.15601298833244781', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-cn; Redmi 3 Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '218.92.226.196', '2019-06-10 09:24:43', 9, 0, '', '2019-06-10 09:24:43');
INSERT INTO `access_log` VALUES (33146, '65.50.15601298833394761', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-cn; Redmi 3 Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '218.92.226.196', '2019-06-10 09:24:43', 9, 0, '', '2019-06-10 09:24:43');
INSERT INTO `access_log` VALUES (33147, '65.46.15601298960694755', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-cn; Redmi 3 Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '218.92.226.196', '2019-06-10 09:24:56', 9, 0, '', '2019-06-10 09:24:56');
INSERT INTO `access_log` VALUES (33148, '65.3607.15601298960896525', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-cn; Redmi 3 Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '218.92.226.196', '2019-06-10 09:24:56', 9, 0, '', '2019-06-10 09:24:56');
INSERT INTO `access_log` VALUES (33149, '65.52.15601298961184761', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 5.1.1; zh-cn; Redmi 3 Build/LMY47V) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.1', '218.92.226.196', '2019-06-10 09:24:56', 10, 0, '', '2019-06-10 09:24:56');
INSERT INTO `access_log` VALUES (33150, '65.53.15601299181344735', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.88.15.101', '2019-06-10 09:25:18', 3, 1002001012, '访问令牌已过期', '2019-06-10 09:25:18');
INSERT INTO `access_log` VALUES (33151, '65.51.15601299181534769', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.88.15.101', '2019-06-10 09:25:18', 2, 1002001012, '访问令牌已过期', '2019-06-10 09:25:18');
INSERT INTO `access_log` VALUES (33152, '65.54.15601299181534721', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.88.15.101', '2019-06-10 09:25:18', 2, 1002001012, '访问令牌已过期', '2019-06-10 09:25:18');
INSERT INTO `access_log` VALUES (33153, '66.52.15601299182012901', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.88.15.101', '2019-06-10 09:25:18', 16, 1002001012, '访问令牌已过期', '2019-06-10 09:25:18');
INSERT INTO `access_log` VALUES (33154, '65.50.15601311040624779', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:45:04', 5, 1002001012, '访问令牌已过期', '2019-06-10 09:45:04');
INSERT INTO `access_log` VALUES (33155, '65.53.15601311040614751', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:45:04', 14, 1002001012, '访问令牌已过期', '2019-06-10 09:45:04');
INSERT INTO `access_log` VALUES (33156, '65.49.15601311040674799', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:45:04', 11, 1002001012, '访问令牌已过期', '2019-06-10 09:45:04');
INSERT INTO `access_log` VALUES (33157, '65.47.15601311060814775', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:45:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 09:45:06');
INSERT INTO `access_log` VALUES (33158, '2e7fea22-95af-44f0-9ec8-0ee7f966c28f', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=俊哥哥&password=timo.123&username=hoiyook', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '0:0:0:0:0:0:0:1', '2019-06-10 09:45:06', 1, 1002001015, '账号未登陆', '2019-06-10 09:45:06');
INSERT INTO `access_log` VALUES (33159, '65.46.15601311177534773', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:45:18', 78, 0, '', '2019-06-10 09:45:18');
INSERT INTO `access_log` VALUES (33160, '65.45.15601311180934783', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:45:18', 10, 0, '', '2019-06-10 09:45:18');
INSERT INTO `access_log` VALUES (33161, '65.51.15601311180934787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:45:18', 9, 0, '', '2019-06-10 09:45:18');
INSERT INTO `access_log` VALUES (33162, '65.52.15601311180914779', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:45:18', 10, 0, '', '2019-06-10 09:45:18');
INSERT INTO `access_log` VALUES (33163, '65.54.15601311230574739', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:45:23', 290, 0, '', '2019-06-10 09:45:23');
INSERT INTO `access_log` VALUES (33164, '65.49.15601311283964801', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:45:28', 10, 0, '', '2019-06-10 09:45:28');
INSERT INTO `access_log` VALUES (33165, '65.50.15601311314124781', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:45:31', 22, 0, '', '2019-06-10 09:45:31');
INSERT INTO `access_log` VALUES (33166, '65.47.15601311362364777', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:45:36', 9, 0, '', '2019-06-10 09:45:36');
INSERT INTO `access_log` VALUES (33167, '65.46.15601311398834775', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:45:40', 13, 0, '', '2019-06-10 09:45:40');
INSERT INTO `access_log` VALUES (33168, '62.86.15601311723914243', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:46:12', 18, 0, '', '2019-06-10 09:46:12');
INSERT INTO `access_log` VALUES (33169, '66.51.15601311922862915', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:46:32', 21, 0, '', '2019-06-10 09:46:32');
INSERT INTO `access_log` VALUES (33170, '59.71.15601311978484431', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:46:38', 111, 0, '', '2019-06-10 09:46:38');
INSERT INTO `access_log` VALUES (33171, '59.74.15601312011884427', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:46:41', 17, 0, '', '2019-06-10 09:46:41');
INSERT INTO `access_log` VALUES (33172, '65.53.15601313519234757', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:49:12', 26, 0, '', '2019-06-10 09:49:12');
INSERT INTO `access_log` VALUES (33173, '65.50.15601313771034785', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:49:37', 18, 0, '', '2019-06-10 09:49:37');
INSERT INTO `access_log` VALUES (33174, '65.3607.15601313824376549', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:49:42', 9, 0, '', '2019-06-10 09:49:42');
INSERT INTO `access_log` VALUES (33175, '65.46.15601313923684779', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:49:52', 1481, 0, '', '2019-06-10 09:49:54');
INSERT INTO `access_log` VALUES (33176, '65.51.15601313983434793', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:49:58', 9, 0, '', '2019-06-10 09:49:58');
INSERT INTO `access_log` VALUES (33177, '51be08db-9912-4441-af78-2496b1aad40b', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:49:57', 474, 1002001015, '账号未登陆', '2019-06-10 09:49:58');
INSERT INTO `access_log` VALUES (33178, '68a33dc3-e2bc-45af-a5f5-2a7592d05e7a', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:49:57', 474, 1002001015, '账号未登陆', '2019-06-10 09:49:58');
INSERT INTO `access_log` VALUES (33179, '1dba4af5-cf58-4837-8d2d-a4a860216834', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:49:57', 474, 1002001015, '账号未登陆', '2019-06-10 09:49:58');
INSERT INTO `access_log` VALUES (33180, 'd30b8c0c-b7df-4ecb-861f-9053c5823492', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:50:02', 1049, 0, '', '2019-06-10 09:50:03');
INSERT INTO `access_log` VALUES (33181, '33379907-9ed5-4b1e-8a0e-077df77ca171', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:50:04', 586, 0, '', '2019-06-10 09:50:04');
INSERT INTO `access_log` VALUES (33182, 'aace931b-4338-4e19-ae16-02b9eafa9563', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:50:04', 634, 0, '', '2019-06-10 09:50:04');
INSERT INTO `access_log` VALUES (33183, '30a58f16-c045-4b2e-88e5-eccd8845c61c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:50:04', 636, 0, '', '2019-06-10 09:50:04');
INSERT INTO `access_log` VALUES (33184, '65.49.15601314394874807', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:50:39', 9, 0, '', '2019-06-10 09:50:39');
INSERT INTO `access_log` VALUES (33185, '65.50.15601314403064787', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:50:40', 355, 0, '', '2019-06-10 09:50:41');
INSERT INTO `access_log` VALUES (33186, '65.47.15601314483574783', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:50:48', 11, 0, '', '2019-06-10 09:50:48');
INSERT INTO `access_log` VALUES (33187, '65.45.15601314642054791', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-10 09:51:04', 10, 0, '', '2019-06-10 09:51:04');
INSERT INTO `access_log` VALUES (33188, '55c547ce-63cc-41d3-937f-262ce32e98db', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:51:58', 1350, 0, '', '2019-06-10 09:51:59');
INSERT INTO `access_log` VALUES (33189, '1d510362-5a62-4815-90db-e00297ed4338', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:52:27', 243, 0, '', '2019-06-10 09:52:28');
INSERT INTO `access_log` VALUES (33190, '4351b49a-f2da-4d82-951c-d608cd4c26a6', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:54:49', 706, 0, '', '2019-06-10 09:54:49');
INSERT INTO `access_log` VALUES (33191, '3bef5cce-fb11-4a20-b19d-9c884538b337', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=12', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:56:02', 352, 0, '', '2019-06-10 09:56:03');
INSERT INTO `access_log` VALUES (33192, '59.74.15601317701734435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:56:10', 14, 2001001000, '服务端发生异常', '2019-06-10 09:56:10');
INSERT INTO `access_log` VALUES (33193, '59.71.15601317701724439', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:56:10', 91, 0, '', '2019-06-10 09:56:10');
INSERT INTO `access_log` VALUES (33194, '7fa45c29-ff3e-432c-ac80-4296a625e3a7', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:56:12', 284, 0, '', '2019-06-10 09:56:12');
INSERT INTO `access_log` VALUES (33195, '46f883ac-922c-425d-9c98-2223353c9711', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:56:17', 253, 0, '', '2019-06-10 09:56:18');
INSERT INTO `access_log` VALUES (33196, '65.54.15601317844454751', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:56:24', 1, 1002001015, '账号未登陆', '2019-06-10 09:56:24');
INSERT INTO `access_log` VALUES (33197, '65.52.15601317844454791', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:56:24', 1, 1002001015, '账号未登陆', '2019-06-10 09:56:24');
INSERT INTO `access_log` VALUES (33198, '65.53.15601317844474765', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:56:24', 0, 1002001015, '账号未登陆', '2019-06-10 09:56:24');
INSERT INTO `access_log` VALUES (33199, '71957944-9818-43a5-89e5-c405575db3b4', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:56:39', 918, 0, '', '2019-06-10 09:56:40');
INSERT INTO `access_log` VALUES (33200, '65.50.15601318013894793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:56:41', 77, 0, '', '2019-06-10 09:56:41');
INSERT INTO `access_log` VALUES (33201, '65.47.15601318019324789', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:56:42', 164, 0, '', '2019-06-10 09:56:42');
INSERT INTO `access_log` VALUES (33202, '65.45.15601318019814797', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:56:42', 118, 0, '', '2019-06-10 09:56:42');
INSERT INTO `access_log` VALUES (33203, '65.3607.15601318019406557', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:56:42', 162, 0, '', '2019-06-10 09:56:42');
INSERT INTO `access_log` VALUES (33204, 'a30417f5-9145-4ca1-9e65-557d3e24200e', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:56:44', 225, 0, '', '2019-06-10 09:56:44');
INSERT INTO `access_log` VALUES (33205, 'eb48b3ba-998e-4a3a-88fe-6fe11ad83332', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:56:46', 407, 0, '', '2019-06-10 09:56:46');
INSERT INTO `access_log` VALUES (33206, '74a7a4be-03f9-4181-be93-c7a7e674f2a9', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:56:52', 205, 0, '', '2019-06-10 09:56:52');
INSERT INTO `access_log` VALUES (33207, '62.84.15601318130184253', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:56:53', 16, 0, '', '2019-06-10 09:56:53');
INSERT INTO `access_log` VALUES (33208, '3f91bfc7-b00f-4527-b384-69f0ec509e73', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:56:54', 296, 0, '', '2019-06-10 09:56:55');
INSERT INTO `access_log` VALUES (33209, 'ea5ce2a0-800b-4dc1-a7cf-8173c513687e', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:56:56', 185, 0, '', '2019-06-10 09:56:57');
INSERT INTO `access_log` VALUES (33210, '4f779699-ce86-4ec1-8aea-b21f08d07788', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:56:59', 229, 0, '', '2019-06-10 09:57:00');
INSERT INTO `access_log` VALUES (33211, '53f5d92e-fa30-4d57-8088-e86814446ccd', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:57:01', 514, 0, '', '2019-06-10 09:57:02');
INSERT INTO `access_log` VALUES (33212, '62.81.15601318273344241', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:57:07', 14, 0, '', '2019-06-10 09:57:07');
INSERT INTO `access_log` VALUES (33213, '766a56e1-c522-4e1f-beb8-ebf3db3dc7ec', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:57:10', 422, 0, '', '2019-06-10 09:57:11');
INSERT INTO `access_log` VALUES (33214, '62.83.15601318314064267', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:57:11', 17, 0, '', '2019-06-10 09:57:11');
INSERT INTO `access_log` VALUES (33215, '4bb44ffe-fea8-45f4-b096-14467ec9f7b6', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:57:11', 247, 0, '', '2019-06-10 09:57:12');
INSERT INTO `access_log` VALUES (33216, '98604698-3244-40db-8ba4-d5401dbd9fae', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:57:12', 180, 0, '', '2019-06-10 09:57:12');
INSERT INTO `access_log` VALUES (33217, '3e1e7b4c-9c6f-4082-925e-f28ff859de8c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:57:13', 279, 0, '', '2019-06-10 09:57:13');
INSERT INTO `access_log` VALUES (33218, '64.85.15601318335454317', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:57:14', 22, 0, '', '2019-06-10 09:57:14');
INSERT INTO `access_log` VALUES (33219, '64.77.15601318335464303', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:57:14', 24, 0, '', '2019-06-10 09:57:14');
INSERT INTO `access_log` VALUES (33220, '21c62c80-f146-4845-a743-00d091f0f871', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:57:15', 367, 0, '', '2019-06-10 09:57:15');
INSERT INTO `access_log` VALUES (33221, '65.53.15601318432214767', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:57:23', 4, 0, '', '2019-06-10 09:57:23');
INSERT INTO `access_log` VALUES (33222, '64.78.15601318496354305', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=阿斯达', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:57:30', 9, 1002002009, NULL, '2019-06-10 09:57:30');
INSERT INTO `access_log` VALUES (33223, '018d36a2-12b6-4a4c-b65c-f6119e781017', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:57:31', 326, 0, '', '2019-06-10 09:57:31');
INSERT INTO `access_log` VALUES (33224, '0ee6cf8b-6e35-45dd-8b79-fdd36ca3d7a8', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:57:33', 259, 0, '', '2019-06-10 09:57:34');
INSERT INTO `access_log` VALUES (33225, 'ac88ec8b-5647-464b-87bc-970ad028d001', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:57:33', 320, 0, '', '2019-06-10 09:57:34');
INSERT INTO `access_log` VALUES (33226, '64.84.15601318611074307', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=hello-world&sellPoint=123&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/7f8ed31e-e7f6-44f6-bfd4-2702d0c808a8&skuStr=[{\"attrs\":[1],\"price\":100,\"quantity\":123}]&description=<p>1231</p>', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:57:41', 7, 1002002009, NULL, '2019-06-10 09:57:41');
INSERT INTO `access_log` VALUES (33227, '64.81.15601318646064297', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:57:45', 12, 0, '', '2019-06-10 09:57:45');
INSERT INTO `access_log` VALUES (33228, '64.80.15601318646024293', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:57:45', 18, 0, '', '2019-06-10 09:57:45');
INSERT INTO `access_log` VALUES (33229, '64.77.15601318687934305', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:57:49', 177, 0, '', '2019-06-10 09:57:49');
INSERT INTO `access_log` VALUES (33230, '64.79.15601318687524293', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:57:49', 221, 0, '', '2019-06-10 09:57:49');
INSERT INTO `access_log` VALUES (33231, '64.76.15601318687504289', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:57:49', 226, 0, '', '2019-06-10 09:57:49');
INSERT INTO `access_log` VALUES (33232, '64.82.15601318772094311', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:57:57', 10, 0, '', '2019-06-10 09:57:57');
INSERT INTO `access_log` VALUES (33233, 'fcf5b95f-80c3-4efe-88f2-32cf55167b7c', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:58:02', 1046, 0, '', '2019-06-10 09:58:03');
INSERT INTO `access_log` VALUES (33234, '4874a767-ecb4-4d8f-ad17-38a50c6c180d', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=40', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-06-10 09:58:06', 1464, 0, '', '2019-06-10 09:58:08');
INSERT INTO `access_log` VALUES (33235, '64.83.15601318899534293', 27, 2, 'product-application', '/product-api/admins/category/add', 'name=hello-world&pid=0&sort=1&description=1231', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:58:10', 7, 1002002009, NULL, '2019-06-10 09:58:10');
INSERT INTO `access_log` VALUES (33236, '64.84.15601318967964309', 27, 2, 'product-application', '/product-api/admins/category/update_status', 'id=784&status=2', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:58:17', 7, 1002002009, NULL, '2019-06-10 09:58:17');
INSERT INTO `access_log` VALUES (33237, '66.48.15601319088792929', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:58:29', 14, 0, '', '2019-06-10 09:58:29');
INSERT INTO `access_log` VALUES (33238, '59.77.15601319159794431', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:58:36', 12, 0, '', '2019-06-10 09:58:36');
INSERT INTO `access_log` VALUES (33239, '59.75.15601319308574443', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:58:51', 22, 2001001000, '服务端发生异常', '2019-06-10 09:58:51');
INSERT INTO `access_log` VALUES (33240, '59.79.15601319414434443', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:59:01', 115, 0, '', '2019-06-10 09:59:02');
INSERT INTO `access_log` VALUES (33241, '64.77.15601319438134307', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:59:04', 9, 0, '', '2019-06-10 09:59:04');
INSERT INTO `access_log` VALUES (33242, '65.54.15601319934894755', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:59:53', 10, 0, '', '2019-06-10 09:59:54');
INSERT INTO `access_log` VALUES (33243, '65.52.15601319934984795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:59:53', 10, 0, '', '2019-06-10 09:59:54');
INSERT INTO `access_log` VALUES (33244, '66.56.15601319936352923', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:59:54', 13, 0, '', '2019-06-10 09:59:54');
INSERT INTO `access_log` VALUES (33245, '65.49.15601319938014817', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:59:54', 9, 0, '', '2019-06-10 09:59:54');
INSERT INTO `access_log` VALUES (33246, '59.71.15601319978054443', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 09:59:58', 51, 0, '', '2019-06-10 09:59:58');
INSERT INTO `access_log` VALUES (33247, '59.77.15601320068364433', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:00:07', 14, 0, '', '2019-06-10 10:00:07');
INSERT INTO `access_log` VALUES (33248, '64.84.15601320081984311', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:00:08', 10, 0, '', '2019-06-10 10:00:08');
INSERT INTO `access_log` VALUES (33249, '64.80.15601320105154297', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:00:11', 11, 0, '', '2019-06-10 10:00:11');
INSERT INTO `access_log` VALUES (33250, '59.80.15601320135724433', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:00:14', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-10 10:00:14');
INSERT INTO `access_log` VALUES (33251, '65.3607.15601320189346561', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:00:19', 20, 0, '', '2019-06-10 10:00:19');
INSERT INTO `access_log` VALUES (33252, '65.46.15601320269454791', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:00:27', 9, 0, '', '2019-06-10 10:00:27');
INSERT INTO `access_log` VALUES (33253, '65.53.15601320432694771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:00:43', 60, 0, '', '2019-06-10 10:00:43');
INSERT INTO `access_log` VALUES (33254, '59.72.15601320650174443', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:01:05', 2, 0, '', '2019-06-10 10:01:05');
INSERT INTO `access_log` VALUES (33255, '59.73.15601320650224445', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:01:05', 13, 2001001000, '服务端发生异常', '2019-06-10 10:01:05');
INSERT INTO `access_log` VALUES (33256, '59.71.15601320734954445', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.197.100.98', '2019-06-10 10:01:13', 12, 0, '', '2019-06-10 10:01:14');
INSERT INTO `access_log` VALUES (33257, '59.74.15601320734964441', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.197.100.98', '2019-06-10 10:01:13', 13, 2001001000, '服务端发生异常', '2019-06-10 10:01:14');
INSERT INTO `access_log` VALUES (33258, '64.85.15601320789554323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.197.100.98', '2019-06-10 10:01:19', 2, 0, '', '2019-06-10 10:01:19');
INSERT INTO `access_log` VALUES (33259, '64.82.15601320790994315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.197.100.98', '2019-06-10 10:01:19', 2, 0, '', '2019-06-10 10:01:19');
INSERT INTO `access_log` VALUES (33260, '64.83.15601320807024297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.197.100.98', '2019-06-10 10:01:21', 3, 0, '', '2019-06-10 10:01:21');
INSERT INTO `access_log` VALUES (33261, '64.84.15601320813144313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.197.100.98', '2019-06-10 10:01:21', 2, 0, '', '2019-06-10 10:01:21');
INSERT INTO `access_log` VALUES (33262, '64.80.15601320821154299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.197.100.98', '2019-06-10 10:01:22', 2, 0, '', '2019-06-10 10:01:22');
INSERT INTO `access_log` VALUES (33263, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.197.100.98', '2019-06-10 10:01:22', 11, 0, '', '2019-06-10 10:01:22');
INSERT INTO `access_log` VALUES (33264, '64.81.15601320835524303', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.197.100.98', '2019-06-10 10:01:24', 8, 0, '', '2019-06-10 10:01:24');
INSERT INTO `access_log` VALUES (33265, '64.77.15601320998254311', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.197.100.98', '2019-06-10 10:01:40', 147, 0, '', '2019-06-10 10:01:40');
INSERT INTO `access_log` VALUES (33266, '65.51.15601323139984809', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:05:14', 0, 1002001015, '账号未登陆', '2019-06-10 10:05:14');
INSERT INTO `access_log` VALUES (33267, '65.53.15601323140014775', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:05:14', 0, 1002001015, '账号未登陆', '2019-06-10 10:05:14');
INSERT INTO `access_log` VALUES (33268, '65.52.15601323140104801', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:05:14', 1, 1002001015, '账号未登陆', '2019-06-10 10:05:14');
INSERT INTO `access_log` VALUES (33269, '65.54.15601323178354761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:05:18', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 10:05:18');
INSERT INTO `access_log` VALUES (33270, '65.50.15601323247064803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:05:25', 73, 0, '', '2019-06-10 10:05:25');
INSERT INTO `access_log` VALUES (33271, '65.47.15601323250114799', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:05:25', 10, 0, '', '2019-06-10 10:05:25');
INSERT INTO `access_log` VALUES (33272, '65.3607.15601323250136567', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:05:25', 9, 0, '', '2019-06-10 10:05:25');
INSERT INTO `access_log` VALUES (33273, '65.45.15601323250164807', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:05:25', 9, 0, '', '2019-06-10 10:05:25');
INSERT INTO `access_log` VALUES (33274, '62.82.15601323284574269', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:05:28', 13, 0, '', '2019-06-10 10:05:28');
INSERT INTO `access_log` VALUES (33275, '62.84.15601323335394261', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:05:34', 48, 0, '', '2019-06-10 10:05:34');
INSERT INTO `access_log` VALUES (33276, '64.81.15601323395064307', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:05:40', 9, 0, '', '2019-06-10 10:05:40');
INSERT INTO `access_log` VALUES (33277, '64.80.15601323395034303', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:05:40', 12, 0, '', '2019-06-10 10:05:40');
INSERT INTO `access_log` VALUES (33278, '64.85.15601323726764329', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:06:13', 9, 0, '', '2019-06-10 10:06:13');
INSERT INTO `access_log` VALUES (33279, '64.79.15601323726754303', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:06:13', 14, 0, '', '2019-06-10 10:06:13');
INSERT INTO `access_log` VALUES (33280, '64.83.15601323762974303', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:06:16', 45, 0, '', '2019-06-10 10:06:16');
INSERT INTO `access_log` VALUES (33281, '64.82.15601323762954321', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:06:16', 50, 0, '', '2019-06-10 10:06:16');
INSERT INTO `access_log` VALUES (33282, '64.78.15601323762974317', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '119.137.55.75', '2019-06-10 10:06:16', 54, 0, '', '2019-06-10 10:06:16');
INSERT INTO `access_log` VALUES (33283, '59.75.15601324003684451', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:06:40', 4, 0, '', '2019-06-10 10:06:40');
INSERT INTO `access_log` VALUES (33284, '59.79.15601324003694451', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:06:40', 47, 2001001000, '服务端发生异常', '2019-06-10 10:06:40');
INSERT INTO `access_log` VALUES (33285, '64.76.15601324106284301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:06:51', 2, 0, '', '2019-06-10 10:06:51');
INSERT INTO `access_log` VALUES (33286, '64.77.15601324107594317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:06:51', 2, 0, '', '2019-06-10 10:06:51');
INSERT INTO `access_log` VALUES (33287, '64.85.15601324126974331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:06:53', 2, 0, '', '2019-06-10 10:06:53');
INSERT INTO `access_log` VALUES (33288, '64.79.15601324132474305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:06:53', 2, 0, '', '2019-06-10 10:06:53');
INSERT INTO `access_log` VALUES (33289, '64.78.15601324256854319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:07:06', 2, 0, '', '2019-06-10 10:07:06');
INSERT INTO `access_log` VALUES (33290, '64.82.15601324258924323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:07:06', 1, 0, '', '2019-06-10 10:07:06');
INSERT INTO `access_log` VALUES (33291, '64.84.15601324310594321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:07:11', 2, 0, '', '2019-06-10 10:07:11');
INSERT INTO `access_log` VALUES (33292, '64.81.15601324311614311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:07:11', 1, 0, '', '2019-06-10 10:07:11');
INSERT INTO `access_log` VALUES (33293, '59.73.15601324339014451', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:07:14', 2, 0, '', '2019-06-10 10:07:14');
INSERT INTO `access_log` VALUES (33294, '59.72.15601324339024449', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:07:14', 14, 2001001000, '服务端发生异常', '2019-06-10 10:07:14');
INSERT INTO `access_log` VALUES (33295, '65.3607.15601324462186569', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:07:26', 1, 1002001015, '账号未登陆', '2019-06-10 10:07:26');
INSERT INTO `access_log` VALUES (33296, '65.45.15601324462204809', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:07:26', 0, 1002001015, '账号未登陆', '2019-06-10 10:07:26');
INSERT INTO `access_log` VALUES (33297, '65.46.15601324462244799', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:07:26', 1, 1002001015, '账号未登陆', '2019-06-10 10:07:26');
INSERT INTO `access_log` VALUES (33298, '65.52.15601324545664805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:07:35', 255, 0, '', '2019-06-10 10:07:35');
INSERT INTO `access_log` VALUES (33299, '65.53.15601324550264779', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:07:35', 10, 0, '', '2019-06-10 10:07:35');
INSERT INTO `access_log` VALUES (33300, '65.51.15601324550294813', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:07:35', 9, 0, '', '2019-06-10 10:07:35');
INSERT INTO `access_log` VALUES (33301, '65.54.15601324550314765', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:07:35', 10, 0, '', '2019-06-10 10:07:35');
INSERT INTO `access_log` VALUES (33302, '62.84.15601324636964263', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:07:44', 12, 0, '', '2019-06-10 10:07:44');
INSERT INTO `access_log` VALUES (33303, '62.83.15601324994024277', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:08:19', 14, 0, '', '2019-06-10 10:08:19');
INSERT INTO `access_log` VALUES (33304, '64.78.15601325055204321', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:08:26', 9, 0, '', '2019-06-10 10:08:26');
INSERT INTO `access_log` VALUES (33305, '64.83.15601325055204307', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:08:26', 12, 0, '', '2019-06-10 10:08:26');
INSERT INTO `access_log` VALUES (33306, '64.78.15601326308384323', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:10:31', 10, 0, '', '2019-06-10 10:10:31');
INSERT INTO `access_log` VALUES (33307, '64.83.15601326308384309', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:10:31', 12, 0, '', '2019-06-10 10:10:31');
INSERT INTO `access_log` VALUES (33308, '64.84.15601326410154325', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:10:41', 11, 0, '', '2019-06-10 10:10:41');
INSERT INTO `access_log` VALUES (33309, '64.76.15601326663014307', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:11:06', 12, 0, '', '2019-06-10 10:11:06');
INSERT INTO `access_log` VALUES (33310, '66.57.15601326841432939', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:11:24', 12, 0, '', '2019-06-10 10:11:24');
INSERT INTO `access_log` VALUES (33311, '59.72.15601327013404453', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:11:41', 15, 0, '', '2019-06-10 10:11:41');
INSERT INTO `access_log` VALUES (33312, '59.74.15601327250884451', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:12:05', 26, 2001001000, '服务端发生异常', '2019-06-10 10:12:05');
INSERT INTO `access_log` VALUES (33313, '59.80.15601327444904445', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:12:24', 153, 0, '', '2019-06-10 10:12:25');
INSERT INTO `access_log` VALUES (33314, '64.82.15601327512324329', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-10 10:12:31', 12, 0, '', '2019-06-10 10:12:31');
INSERT INTO `access_log` VALUES (33315, '65.45.15601329826384819', 0, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:16:23', 0, 1002001015, '账号未登陆', '2019-06-10 10:16:23');
INSERT INTO `access_log` VALUES (33316, '65.52.15601329839434815', 0, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:16:24', 0, 1002001015, '账号未登陆', '2019-06-10 10:16:24');
INSERT INTO `access_log` VALUES (33317, '65.53.15601329842864787', 0, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:16:24', 1, 1002001015, '账号未登陆', '2019-06-10 10:16:24');
INSERT INTO `access_log` VALUES (33318, '65.51.15601329846944823', 0, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:16:25', 0, 1002001015, '账号未登陆', '2019-06-10 10:16:25');
INSERT INTO `access_log` VALUES (33319, '65.47.15601330148134811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:16:55', 5, 1002002001, '密码不正确', '2019-06-10 10:16:55');
INSERT INTO `access_log` VALUES (33320, '65.3607.15601330216696577', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:17:02', 0, 1002001015, '账号未登陆', '2019-06-10 10:17:02');
INSERT INTO `access_log` VALUES (33321, '65.46.15601330227154809', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:17:03', 1, 1002001015, '账号未登陆', '2019-06-10 10:17:03');
INSERT INTO `access_log` VALUES (33322, '65.54.15601330230764775', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:17:03', 0, 1002001015, '账号未登陆', '2019-06-10 10:17:03');
INSERT INTO `access_log` VALUES (33323, '65.52.15601330234374817', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:17:03', 0, 1002001015, '账号未登陆', '2019-06-10 10:17:03');
INSERT INTO `access_log` VALUES (33324, '65.53.15601330275024789', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=小王&offset=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:17:08', 0, 1002001015, '账号未登陆', '2019-06-10 10:17:08');
INSERT INTO `access_log` VALUES (33325, '65.51.15601330279824825', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=小王&offset=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:17:08', 0, 1002001015, '账号未登陆', '2019-06-10 10:17:08');
INSERT INTO `access_log` VALUES (33326, '65.49.15601330281834839', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=小王&offset=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '120.197.100.98', '2019-06-10 10:17:08', 1, 1002001015, '账号未登陆', '2019-06-10 10:17:08');
INSERT INTO `access_log` VALUES (33327, '59.73.15601331215504461', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '210.75.217.241', '2019-06-10 10:18:42', 3, 0, '', '2019-06-10 10:18:42');
INSERT INTO `access_log` VALUES (33328, '59.71.15601331215524461', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '210.75.217.241', '2019-06-10 10:18:42', 13, 2001001000, '服务端发生异常', '2019-06-10 10:18:42');
INSERT INTO `access_log` VALUES (33329, '64.85.15601331243094343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '210.75.217.241', '2019-06-10 10:18:44', 3, 0, '', '2019-06-10 10:18:44');
INSERT INTO `access_log` VALUES (33330, '64.79.15601331244064317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '210.75.217.241', '2019-06-10 10:18:44', 2, 0, '', '2019-06-10 10:18:44');
INSERT INTO `access_log` VALUES (33331, '64.78.15601331256804331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '210.75.217.241', '2019-06-10 10:18:46', 1, 0, '', '2019-06-10 10:18:46');
INSERT INTO `access_log` VALUES (33332, '64.83.15601331264224317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '210.75.217.241', '2019-06-10 10:18:46', 2, 0, '', '2019-06-10 10:18:46');
INSERT INTO `access_log` VALUES (33333, '59.74.15601331289584457', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '210.75.217.241', '2019-06-10 10:18:49', 2, 0, '', '2019-06-10 10:18:49');
INSERT INTO `access_log` VALUES (33334, '59.77.15601331289604451', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '210.75.217.241', '2019-06-10 10:18:49', 14, 2001001000, '服务端发生异常', '2019-06-10 10:18:49');
INSERT INTO `access_log` VALUES (33335, '65.52.15601331549314821', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:19:15', 4, 1002001012, '访问令牌已过期', '2019-06-10 10:19:15');
INSERT INTO `access_log` VALUES (33336, '65.53.15601331569074791', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:19:17', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 10:19:17');
INSERT INTO `access_log` VALUES (33337, '65.50.15601331742244821', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:19:34', 104, 0, '', '2019-06-10 10:19:34');
INSERT INTO `access_log` VALUES (33338, '65.47.15601331745734815', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:19:35', 8, 0, '', '2019-06-10 10:19:35');
INSERT INTO `access_log` VALUES (33339, '65.3607.15601331745786579', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:19:35', 8, 0, '', '2019-06-10 10:19:35');
INSERT INTO `access_log` VALUES (33340, '65.46.15601331745804813', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:19:35', 8, 0, '', '2019-06-10 10:19:35');
INSERT INTO `access_log` VALUES (33341, '62.83.15601332052194287', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:20:05', 1501, 0, '', '2019-06-10 10:20:07');
INSERT INTO `access_log` VALUES (33342, '62.85.15601332103204275', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:20:10', 15, 0, '', '2019-06-10 10:20:10');
INSERT INTO `access_log` VALUES (33343, '64.78.15601332302294333', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:20:30', 8, 0, '', '2019-06-10 10:20:30');
INSERT INTO `access_log` VALUES (33344, '64.79.15601332302284319', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:20:30', 10, 0, '', '2019-06-10 10:20:30');
INSERT INTO `access_log` VALUES (33345, '64.82.15601332337424337', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:20:34', 8, 0, '', '2019-06-10 10:20:34');
INSERT INTO `access_log` VALUES (33346, '64.83.15601332337414319', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:20:34', 11, 0, '', '2019-06-10 10:20:34');
INSERT INTO `access_log` VALUES (33347, '64.80.15601332463604321', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:20:46', 173, 0, '', '2019-06-10 10:20:47');
INSERT INTO `access_log` VALUES (33348, '64.81.15601332463584325', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:20:46', 177, 0, '', '2019-06-10 10:20:47');
INSERT INTO `access_log` VALUES (33349, '65.54.15601332543194781', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:20:54', 20, 0, '', '2019-06-10 10:20:54');
INSERT INTO `access_log` VALUES (33350, '65.52.15601332557594825', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.215.152.58', '2019-06-10 10:20:56', 9, 0, '', '2019-06-10 10:20:56');
INSERT INTO `access_log` VALUES (33351, '65.53.15601339492664801', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:32:29', 0, 1002001015, '账号未登陆', '2019-06-10 10:32:29');
INSERT INTO `access_log` VALUES (33352, '65.49.15601339492674849', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:32:29', 0, 1002001015, '账号未登陆', '2019-06-10 10:32:29');
INSERT INTO `access_log` VALUES (33353, '65.51.15601339492674843', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:32:29', 1, 1002001015, '账号未登陆', '2019-06-10 10:32:29');
INSERT INTO `access_log` VALUES (33354, '65.50.15601339535604835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:32:34', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 10:32:34');
INSERT INTO `access_log` VALUES (33355, '65.47.15601339656384827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:32:46', 61, 0, '', '2019-06-10 10:32:46');
INSERT INTO `access_log` VALUES (33356, '65.3607.15601339659406591', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:32:46', 10, 0, '', '2019-06-10 10:32:46');
INSERT INTO `access_log` VALUES (33357, '65.45.15601339659464837', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:32:46', 9, 0, '', '2019-06-10 10:32:46');
INSERT INTO `access_log` VALUES (33358, '65.54.15601339659504793', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:32:46', 9, 0, '', '2019-06-10 10:32:46');
INSERT INTO `access_log` VALUES (33359, '59.73.15601339668804473', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:32:47', 4, 0, '', '2019-06-10 10:32:47');
INSERT INTO `access_log` VALUES (33360, '59.71.15601339668814473', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:32:47', 13, 2001001000, '服务端发生异常', '2019-06-10 10:32:47');
INSERT INTO `access_log` VALUES (33361, '62.89.15601339733274297', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:32:53', 19, 0, '', '2019-06-10 10:32:53');
INSERT INTO `access_log` VALUES (33362, '64.80.15601339742594331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:32:54', 3, 0, '', '2019-06-10 10:32:54');
INSERT INTO `access_log` VALUES (33363, '64.76.15601339743244327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:32:54', 2, 0, '', '2019-06-10 10:32:54');
INSERT INTO `access_log` VALUES (33364, '64.77.15601339754754343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:32:55', 2, 0, '', '2019-06-10 10:32:55');
INSERT INTO `access_log` VALUES (33365, '64.85.15601339759724357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:32:56', 2, 0, '', '2019-06-10 10:32:56');
INSERT INTO `access_log` VALUES (33366, '65.49.15601339864434851', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:33:06', 8, 0, '', '2019-06-10 10:33:06');
INSERT INTO `access_log` VALUES (33367, '65.51.15601339887284845', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:33:09', 19, 0, '', '2019-06-10 10:33:09');
INSERT INTO `access_log` VALUES (33368, '65.50.15601339914624837', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:33:11', 14, 0, '', '2019-06-10 10:33:11');
INSERT INTO `access_log` VALUES (33369, '65.45.15601340320204839', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:33:52', 9, 0, '', '2019-06-10 10:33:52');
INSERT INTO `access_log` VALUES (33370, '65.54.15601340376394795', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:33:58', 1, 1002001015, '账号未登陆', '2019-06-10 10:33:58');
INSERT INTO `access_log` VALUES (33371, '65.52.15601340376404839', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:33:58', 0, 1002001015, '账号未登陆', '2019-06-10 10:33:58');
INSERT INTO `access_log` VALUES (33372, '65.49.15601340376454853', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:33:58', 0, 1002001015, '账号未登陆', '2019-06-10 10:33:58');
INSERT INTO `access_log` VALUES (33373, '65.51.15601340419614847', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:34:02', 5, 1002002000, '账号不存在', '2019-06-10 10:34:02');
INSERT INTO `access_log` VALUES (33374, '65.53.15601340459034805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:34:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 10:34:06');
INSERT INTO `access_log` VALUES (33375, '59.76.15601340475394467', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:34:08', 14, 0, '', '2019-06-10 10:34:08');
INSERT INTO `access_log` VALUES (33376, '65.46.15601340515274827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:34:12', 108, 0, '', '2019-06-10 10:34:12');
INSERT INTO `access_log` VALUES (33377, '65.47.15601340518094831', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:34:12', 10, 0, '', '2019-06-10 10:34:12');
INSERT INTO `access_log` VALUES (33378, '65.45.15601340518104841', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:34:12', 10, 0, '', '2019-06-10 10:34:12');
INSERT INTO `access_log` VALUES (33379, '65.3607.15601340518116595', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:34:12', 10, 0, '', '2019-06-10 10:34:12');
INSERT INTO `access_log` VALUES (33380, '62.86.15601340541064285', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:34:14', 12, 0, '', '2019-06-10 10:34:14');
INSERT INTO `access_log` VALUES (33381, '65.52.15601340650554841', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:34:25', 3, 0, '', '2019-06-10 10:34:25');
INSERT INTO `access_log` VALUES (33382, '66.54.15601340699342957', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:34:30', 365, 0, '', '2019-06-10 10:34:30');
INSERT INTO `access_log` VALUES (33383, '65.49.15601340710774855', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:34:31', 16, 0, '', '2019-06-10 10:34:31');
INSERT INTO `access_log` VALUES (33384, '65.51.15601340716414849', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:34:32', 10, 0, '', '2019-06-10 10:34:32');
INSERT INTO `access_log` VALUES (33385, '65.53.15601340725504807', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:34:33', 9, 0, '', '2019-06-10 10:34:33');
INSERT INTO `access_log` VALUES (33386, '65.50.15601340741394841', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:34:34', 14, 0, '', '2019-06-10 10:34:34');
INSERT INTO `access_log` VALUES (33387, '64.76.15601340792614329', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:34:39', 12, 0, '', '2019-06-10 10:34:39');
INSERT INTO `access_log` VALUES (33388, '65.3607.15601340859736597', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:34:46', 16, 0, '', '2019-06-10 10:34:46');
INSERT INTO `access_log` VALUES (33389, '59.73.15601340879474475', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:34:48', 31, 0, '', '2019-06-10 10:34:48');
INSERT INTO `access_log` VALUES (33390, '59.77.15601340909024465', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.129.148.2', '2019-06-10 10:34:51', 26, 2001001000, '服务端发生异常', '2019-06-10 10:34:51');
INSERT INTO `access_log` VALUES (33391, '64.85.15601340988954359', 27, 2, 'product-application', '/product-api/admins/category/add', 'name=chanfit-web&pid=0&sort=5&description=美美美', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:34:59', 974, 1002002009, NULL, '2019-06-10 10:35:00');
INSERT INTO `access_log` VALUES (33392, '62.82.15601341112744295', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:35:11', 14, 0, '', '2019-06-10 10:35:11');
INSERT INTO `access_log` VALUES (33393, '64.78.15601341131784347', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:35:13', 12, 0, '', '2019-06-10 10:35:13');
INSERT INTO `access_log` VALUES (33394, '64.82.15601341131814351', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.81.162.127', '2019-06-10 10:35:13', 8, 0, '', '2019-06-10 10:35:13');
INSERT INTO `access_log` VALUES (33395, '59.74.15601343650854475', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.71.120', '2019-06-10 10:39:25', 3, 0, '', '2019-06-10 10:39:25');
INSERT INTO `access_log` VALUES (33396, '59.77.15601343650854469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.71.120', '2019-06-10 10:39:25', 10, 2001001000, '服务端发生异常', '2019-06-10 10:39:25');
INSERT INTO `access_log` VALUES (33397, '59.75.15601343825144481', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:39:43', 3, 0, '', '2019-06-10 10:39:43');
INSERT INTO `access_log` VALUES (33398, '59.79.15601343825154481', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:39:43', 11, 2001001000, '服务端发生异常', '2019-06-10 10:39:43');
INSERT INTO `access_log` VALUES (33399, '65.49.15601343858164861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.228', '2019-06-10 10:39:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 10:39:46');
INSERT INTO `access_log` VALUES (33400, '64.78.15601343859264351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:39:46', 2, 0, '', '2019-06-10 10:39:46');
INSERT INTO `access_log` VALUES (33401, '64.82.15601343860174355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:39:46', 2, 0, '', '2019-06-10 10:39:46');
INSERT INTO `access_log` VALUES (33402, '64.83.15601343878954337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:39:48', 2, 0, '', '2019-06-10 10:39:48');
INSERT INTO `access_log` VALUES (33403, '64.84.15601343885354353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:39:49', 2, 0, '', '2019-06-10 10:39:49');
INSERT INTO `access_log` VALUES (33404, '65.51.15601343909744853', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.228', '2019-06-10 10:39:51', 89, 0, '', '2019-06-10 10:39:51');
INSERT INTO `access_log` VALUES (33405, '65.53.15601343915094811', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.228', '2019-06-10 10:39:52', 10, 0, '', '2019-06-10 10:39:52');
INSERT INTO `access_log` VALUES (33406, '65.50.15601343915094847', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.228', '2019-06-10 10:39:52', 11, 0, '', '2019-06-10 10:39:52');
INSERT INTO `access_log` VALUES (33407, '65.46.15601343915184835', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.228', '2019-06-10 10:39:52', 9, 0, '', '2019-06-10 10:39:52');
INSERT INTO `access_log` VALUES (33408, '64.80.15601343920984339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:39:52', 1, 0, '', '2019-06-10 10:39:52');
INSERT INTO `access_log` VALUES (33409, '64.76.15601343921754335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:39:52', 2, 0, '', '2019-06-10 10:39:52');
INSERT INTO `access_log` VALUES (33410, '59.72.15601343955594479', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:39:56', 13, 2001001000, '服务端发生异常', '2019-06-10 10:39:56');
INSERT INTO `access_log` VALUES (33411, '59.76.15601343955414473', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:39:56', 42, 0, '', '2019-06-10 10:39:56');
INSERT INTO `access_log` VALUES (33412, '64.77.15601343974294351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:39:57', 2, 0, '', '2019-06-10 10:39:57');
INSERT INTO `access_log` VALUES (33413, '64.85.15601343976984365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:39:58', 2, 0, '', '2019-06-10 10:39:58');
INSERT INTO `access_log` VALUES (33414, '64.79.15601343987724339', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.228', '2019-06-10 10:39:59', 11, 0, '', '2019-06-10 10:39:59');
INSERT INTO `access_log` VALUES (33415, '64.78.15601343987824353', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.228', '2019-06-10 10:39:59', 7, 0, '', '2019-06-10 10:39:59');
INSERT INTO `access_log` VALUES (33416, '64.82.15601343988064357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:39:59', 2, 0, '', '2019-06-10 10:39:59');
INSERT INTO `access_log` VALUES (33417, '64.83.15601343993754339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:39:59', 2, 0, '', '2019-06-10 10:39:59');
INSERT INTO `access_log` VALUES (33418, '59.71.15601344003544481', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:40:00', 2, 0, '', '2019-06-10 10:40:00');
INSERT INTO `access_log` VALUES (33419, '59.73.15601344003664481', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:40:00', 12, 2001001000, '服务端发生异常', '2019-06-10 10:40:00');
INSERT INTO `access_log` VALUES (33420, '64.84.15601344026354355', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.228', '2019-06-10 10:40:03', 9, 0, '', '2019-06-10 10:40:03');
INSERT INTO `access_log` VALUES (33421, '64.81.15601344046014345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:40:05', 2, 0, '', '2019-06-10 10:40:05');
INSERT INTO `access_log` VALUES (33422, '64.80.15601344047034341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:40:05', 2, 0, '', '2019-06-10 10:40:05');
INSERT INTO `access_log` VALUES (33423, '64.77.15601344057244353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:40:06', 2, 0, '', '2019-06-10 10:40:06');
INSERT INTO `access_log` VALUES (33424, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:40:06', 6, 0, '', '2019-06-10 10:40:06');
INSERT INTO `access_log` VALUES (33425, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:40:08', 9, 0, '', '2019-06-10 10:40:08');
INSERT INTO `access_log` VALUES (33426, '64.85.15601344085424367', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:40:09', 8, 0, '', '2019-06-10 10:40:09');
INSERT INTO `access_log` VALUES (33427, '66.50.15601344162442951', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.7.71.120', '2019-06-10 10:40:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空\n账号长度为 11 位\n手机号不能为空', '2019-06-10 10:40:16');
INSERT INTO `access_log` VALUES (33428, '65.52.15601344417664849', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.71.120', '2019-06-10 10:40:42', 0, 1002001015, '账号未登陆', '2019-06-10 10:40:42');
INSERT INTO `access_log` VALUES (33429, '65.49.15601344417684863', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.71.120', '2019-06-10 10:40:42', 0, 1002001015, '账号未登陆', '2019-06-10 10:40:42');
INSERT INTO `access_log` VALUES (33430, '65.51.15601344417744855', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.71.120', '2019-06-10 10:40:42', 0, 1002001015, '账号未登陆', '2019-06-10 10:40:42');
INSERT INTO `access_log` VALUES (33431, '65.50.15601344439244849', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.71.120', '2019-06-10 10:40:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 10:40:44');
INSERT INTO `access_log` VALUES (33432, '65.53.15601344501714813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=000000&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.71.120', '2019-06-10 10:40:50', 92, 0, '', '2019-06-10 10:40:50');
INSERT INTO `access_log` VALUES (33433, '65.46.15601344504244837', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.71.120', '2019-06-10 10:40:50', 9, 0, '', '2019-06-10 10:40:50');
INSERT INTO `access_log` VALUES (33434, '65.3607.15601344504266605', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.71.120', '2019-06-10 10:40:50', 9, 0, '', '2019-06-10 10:40:50');
INSERT INTO `access_log` VALUES (33435, '65.47.15601344504304841', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.71.120', '2019-06-10 10:40:50', 8, 0, '', '2019-06-10 10:40:50');
INSERT INTO `access_log` VALUES (33436, '64.83.15601344525524341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.151.178.236', '2019-06-10 10:40:53', 2, 0, '', '2019-06-10 10:40:53');
INSERT INTO `access_log` VALUES (33437, '62.86.15601344545344291', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.71.120', '2019-06-10 10:40:55', 12, 0, '', '2019-06-10 10:40:55');
INSERT INTO `access_log` VALUES (33438, '64.84.15601344572654357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.227.139.178', '2019-06-10 10:40:57', 2, 0, '', '2019-06-10 10:40:57');
INSERT INTO `access_log` VALUES (33439, '64.80.15601344637204343', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.71.120', '2019-06-10 10:41:04', 9, 0, '', '2019-06-10 10:41:04');
INSERT INTO `access_log` VALUES (33440, '64.81.15601344637204347', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.71.120', '2019-06-10 10:41:04', 11, 0, '', '2019-06-10 10:41:04');
INSERT INTO `access_log` VALUES (33441, '66.52.15601344782312963', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.71.120', '2019-06-10 10:41:18', 14, 0, '', '2019-06-10 10:41:18');
INSERT INTO `access_log` VALUES (33442, '65.49.15601345038064865', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.129.6.159', '2019-06-10 10:41:44', 0, 1002001015, '账号未登陆', '2019-06-10 10:41:44');
INSERT INTO `access_log` VALUES (33443, '65.50.15601345074264851', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.227', '2019-06-10 10:41:47', 0, 1002001015, '账号未登陆', '2019-06-10 10:41:47');
INSERT INTO `access_log` VALUES (33444, '62.84.15601345143184293', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.207.205', '2019-06-10 10:41:54', 0, 1002001015, '账号未登陆', '2019-06-10 10:41:54');
INSERT INTO `access_log` VALUES (33445, '64.78.15601345243724357', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.151.178.236', '2019-06-10 10:42:04', 1, 1002001015, '账号未登陆', '2019-06-10 10:42:04');
INSERT INTO `access_log` VALUES (33446, '65.3607.15601346717966609', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:44:32', 0, 1002001015, '账号未登陆', '2019-06-10 10:44:32');
INSERT INTO `access_log` VALUES (33447, '65.47.15601346717994845', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:44:32', 0, 1002001015, '账号未登陆', '2019-06-10 10:44:32');
INSERT INTO `access_log` VALUES (33448, '65.46.15601346718064841', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:44:32', 1, 1002001015, '账号未登陆', '2019-06-10 10:44:32');
INSERT INTO `access_log` VALUES (33449, '65.45.15601346770374855', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:44:37', 343, 0, '', '2019-06-10 10:44:37');
INSERT INTO `access_log` VALUES (33450, '65.54.15601346776884811', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:44:38', 9, 0, '', '2019-06-10 10:44:38');
INSERT INTO `access_log` VALUES (33451, '65.52.15601346776914855', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:44:38', 8, 0, '', '2019-06-10 10:44:38');
INSERT INTO `access_log` VALUES (33452, '65.51.15601346776954861', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:44:38', 8, 0, '', '2019-06-10 10:44:38');
INSERT INTO `access_log` VALUES (33453, '65.50.15601346813014855', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:44:41', 19, 0, '', '2019-06-10 10:44:41');
INSERT INTO `access_log` VALUES (33454, '65.53.15601346870294819', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:44:47', 11, 0, '', '2019-06-10 10:44:47');
INSERT INTO `access_log` VALUES (33455, '65.46.15601346909004843', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:44:51', 1301, 0, '', '2019-06-10 10:44:52');
INSERT INTO `access_log` VALUES (33456, '65.3607.15601346936406611', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:44:54', 227, 0, '', '2019-06-10 10:44:54');
INSERT INTO `access_log` VALUES (33457, '64.80.15601347217424347', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:45:22', 16, 0, '', '2019-06-10 10:45:22');
INSERT INTO `access_log` VALUES (33458, '64.76.15601347217474343', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:45:22', 12, 0, '', '2019-06-10 10:45:22');
INSERT INTO `access_log` VALUES (33459, '64.85.15601347380584373', 27, 2, 'product-application', '/product-api/admins/attr_value/add', 'name=的', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:45:38', 589, 1002002009, NULL, '2019-06-10 10:45:39');
INSERT INTO `access_log` VALUES (33460, '59.75.15601347463114487', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:45:46', 12, 0, '', '2019-06-10 10:45:46');
INSERT INTO `access_log` VALUES (33461, '59.78.15601347521784487', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:45:52', 19, 2001001000, '服务端发生异常', '2019-06-10 10:45:52');
INSERT INTO `access_log` VALUES (33462, '59.72.15601347588124485', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:45:59', 13, 0, '', '2019-06-10 10:45:59');
INSERT INTO `access_log` VALUES (33463, '64.78.15601347592624361', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '180.97.118.219', '2019-06-10 10:45:59', 7, 0, '', '2019-06-10 10:45:59');
INSERT INTO `access_log` VALUES (33464, '64.82.15601347647794365', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:05', 9, 0, '', '2019-06-10 10:46:05');
INSERT INTO `access_log` VALUES (33465, '64.84.15601347715484363', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:12', 10, 0, '', '2019-06-10 10:46:12');
INSERT INTO `access_log` VALUES (33466, '59.71.15601347743554487', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:14', 12, 0, '', '2019-06-10 10:46:14');
INSERT INTO `access_log` VALUES (33467, '59.77.15601347870984477', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:27', 9, 0, '', '2019-06-10 10:46:27');
INSERT INTO `access_log` VALUES (33468, '59.74.15601347879224483', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:28', 11, 0, '', '2019-06-10 10:46:28');
INSERT INTO `access_log` VALUES (33469, '59.80.15601347886744477', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:29', 10, 0, '', '2019-06-10 10:46:29');
INSERT INTO `access_log` VALUES (33470, '62.84.15601347907474297', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:31', 14, 0, '', '2019-06-10 10:46:31');
INSERT INTO `access_log` VALUES (33471, '62.81.15601348029054285', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:43', 12, 0, '', '2019-06-10 10:46:43');
INSERT INTO `access_log` VALUES (33472, '59.79.15601348034624489', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:43', 10, 0, '', '2019-06-10 10:46:43');
INSERT INTO `access_log` VALUES (33473, '59.78.15601348043564489', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:44', 12, 0, '', '2019-06-10 10:46:44');
INSERT INTO `access_log` VALUES (33474, '59.72.15601348049584487', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:45', 22, 2001001000, '服务端发生异常', '2019-06-10 10:46:45');
INSERT INTO `access_log` VALUES (33475, '59.76.15601348055184481', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:46', 146, 0, '', '2019-06-10 10:46:46');
INSERT INTO `access_log` VALUES (33476, '64.80.15601348062744349', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:46', 11, 0, '', '2019-06-10 10:46:46');
INSERT INTO `access_log` VALUES (33477, '64.77.15601348063374361', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:46', 9, 0, '', '2019-06-10 10:46:46');
INSERT INTO `access_log` VALUES (33478, '65.46.15601348067524845', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:47', 9, 0, '', '2019-06-10 10:46:47');
INSERT INTO `access_log` VALUES (33479, '65.3607.15601348074436613', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:47', 10, 0, '', '2019-06-10 10:46:47');
INSERT INTO `access_log` VALUES (33480, '65.47.15601348081624849', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.166', '2019-06-10 10:46:48', 16, 0, '', '2019-06-10 10:46:48');
INSERT INTO `access_log` VALUES (33481, '64.84.15601348846434365', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.60.104', '2019-06-10 10:48:05', 0, 1002001015, '账号未登陆', '2019-06-10 10:48:05');
INSERT INTO `access_log` VALUES (33482, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.60.105', '2019-06-10 10:49:46', 6, 0, '', '2019-06-10 10:49:46');
INSERT INTO `access_log` VALUES (33483, '66.52.15601350615062971', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.91.60.104', '2019-06-10 10:51:02', 0, 1002001015, '账号未登陆', '2019-06-10 10:51:02');
INSERT INTO `access_log` VALUES (33484, '65.50.15601361533054877', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '139.207.19.97', '2019-06-10 11:09:13', 0, 1002001015, '账号未登陆', '2019-06-10 11:09:13');
INSERT INTO `access_log` VALUES (33485, '65.49.15601361533044889', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '139.207.19.97', '2019-06-10 11:09:13', 0, 1002001015, '账号未登陆', '2019-06-10 11:09:13');
INSERT INTO `access_log` VALUES (33486, '65.45.15601361533054879', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '139.207.19.97', '2019-06-10 11:09:13', 1, 1002001015, '账号未登陆', '2019-06-10 11:09:13');
INSERT INTO `access_log` VALUES (33487, '65.46.15601361595504863', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '139.207.19.97', '2019-06-10 11:09:20', 0, 1002001015, '账号未登陆', '2019-06-10 11:09:20');
INSERT INTO `access_log` VALUES (33488, '65.53.15601361595504841', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '139.207.19.97', '2019-06-10 11:09:20', 1, 1002001015, '账号未登陆', '2019-06-10 11:09:20');
INSERT INTO `access_log` VALUES (33489, '65.3607.15601361595536633', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '139.207.19.97', '2019-06-10 11:09:20', 0, 1002001015, '账号未登陆', '2019-06-10 11:09:20');
INSERT INTO `access_log` VALUES (33490, '65.54.15601361654474835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '139.207.19.97', '2019-06-10 11:09:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 11:09:25');
INSERT INTO `access_log` VALUES (33491, '65.51.15601361710204885', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:09:31', 0, 1002001015, '账号未登陆', '2019-06-10 11:09:31');
INSERT INTO `access_log` VALUES (33492, '65.52.15601361710234879', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:09:31', 1, 1002001015, '账号未登陆', '2019-06-10 11:09:31');
INSERT INTO `access_log` VALUES (33493, '65.49.15601361710264891', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:09:31', 1, 1002001015, '账号未登陆', '2019-06-10 11:09:31');
INSERT INTO `access_log` VALUES (33494, '65.45.15601361723884881', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '139.207.19.97', '2019-06-10 11:09:32', 91, 0, '', '2019-06-10 11:09:32');
INSERT INTO `access_log` VALUES (33495, '65.3607.15601361728266635', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '139.207.19.97', '2019-06-10 11:09:33', 9, 0, '', '2019-06-10 11:09:33');
INSERT INTO `access_log` VALUES (33496, '65.50.15601361728264879', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '139.207.19.97', '2019-06-10 11:09:33', 11, 0, '', '2019-06-10 11:09:33');
INSERT INTO `access_log` VALUES (33497, '65.53.15601361729074843', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '139.207.19.97', '2019-06-10 11:09:33', 10, 0, '', '2019-06-10 11:09:33');
INSERT INTO `access_log` VALUES (33498, '65.46.15601361742604865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:09:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 11:09:34');
INSERT INTO `access_log` VALUES (33499, '64.82.15601361798294385', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '139.207.19.97', '2019-06-10 11:09:40', 10, 0, '', '2019-06-10 11:09:40');
INSERT INTO `access_log` VALUES (33500, '64.83.15601361798294367', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '139.207.19.97', '2019-06-10 11:09:40', 12, 0, '', '2019-06-10 11:09:40');
INSERT INTO `access_log` VALUES (33501, '65.54.15601361816844837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:09:42', 313, 0, '', '2019-06-10 11:09:42');
INSERT INTO `access_log` VALUES (33502, '65.52.15601361822884881', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:09:42', 9, 0, '', '2019-06-10 11:09:42');
INSERT INTO `access_log` VALUES (33503, '65.51.15601361822914887', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:09:42', 15, 0, '', '2019-06-10 11:09:42');
INSERT INTO `access_log` VALUES (33504, '65.49.15601361822924893', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:09:42', 17, 0, '', '2019-06-10 11:09:42');
INSERT INTO `access_log` VALUES (33505, '62.85.15601361871244317', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:09:47', 16, 0, '', '2019-06-10 11:09:47');
INSERT INTO `access_log` VALUES (33506, '59.74.15601361979644503', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:09:58', 49, 0, '', '2019-06-10 11:09:58');
INSERT INTO `access_log` VALUES (33507, '59.75.15601362133494509', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:10:13', 429, 2001001000, '服务端发生异常', '2019-06-10 11:10:14');
INSERT INTO `access_log` VALUES (33508, '59.79.15601362158694509', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:10:16', 11, 0, '', '2019-06-10 11:10:16');
INSERT INTO `access_log` VALUES (33509, '59.78.15601362178174509', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:10:18', 11, 0, '', '2019-06-10 11:10:18');
INSERT INTO `access_log` VALUES (33510, '59.76.15601362200044501', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:10:20', 12, 0, '', '2019-06-10 11:10:20');
INSERT INTO `access_log` VALUES (33511, '59.71.15601362229054509', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:10:23', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-10 11:10:23');
INSERT INTO `access_log` VALUES (33512, '65.53.15601362250114845', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:10:25', 20, 0, '', '2019-06-10 11:10:25');
INSERT INTO `access_log` VALUES (33513, '65.46.15601362257794867', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:10:26', 9, 0, '', '2019-06-10 11:10:26');
INSERT INTO `access_log` VALUES (33514, '65.47.15601362269414873', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:10:27', 9, 0, '', '2019-06-10 11:10:27');
INSERT INTO `access_log` VALUES (33515, '65.54.15601362285514839', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:10:29', 12, 0, '', '2019-06-10 11:10:29');
INSERT INTO `access_log` VALUES (33516, '65.51.15601362498784889', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:10:50', 14, 0, '', '2019-06-10 11:10:50');
INSERT INTO `access_log` VALUES (33517, '65.49.15601362506844895', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:10:51', 9, 0, '', '2019-06-10 11:10:51');
INSERT INTO `access_log` VALUES (33518, '65.45.15601362513624885', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.62.29', '2019-06-10 11:10:51', 18, 0, '', '2019-06-10 11:10:51');
INSERT INTO `access_log` VALUES (33519, 'ddd0d4e5-341c-42da-92ab-aada8ae8a8a3', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-10 11:12:48', 25, 1002001015, '账号未登陆', '2019-06-10 11:12:49');
INSERT INTO `access_log` VALUES (33520, '3b2192e3-9e33-4939-b622-a59729164d21', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-10 11:12:48', 25, 1002001015, '账号未登陆', '2019-06-10 11:12:49');
INSERT INTO `access_log` VALUES (33521, '48124438-7347-4ebf-8788-7ae80a52dad8', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-10 11:12:48', 25, 1002001015, '账号未登陆', '2019-06-10 11:12:49');
INSERT INTO `access_log` VALUES (33522, 'df5b4593-8a33-48e9-8d24-fb20d127a3d9', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-10 11:13:22', 535, 0, '', '2019-06-10 11:13:23');
INSERT INTO `access_log` VALUES (33523, '067c11af-ad1e-45d4-8699-95a27b49c31c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-10 11:13:23', 180, 0, '', '2019-06-10 11:13:23');
INSERT INTO `access_log` VALUES (33524, 'c57bd82b-09bb-4abf-868b-403b4e310943', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-10 11:13:23', 201, 0, '', '2019-06-10 11:13:23');
INSERT INTO `access_log` VALUES (33525, '93a28e2e-92cf-4f10-84bb-668a96ce3c7a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-10 11:13:23', 220, 0, '', '2019-06-10 11:13:23');
INSERT INTO `access_log` VALUES (33526, '64.81.15601364975974377', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:14:58', 11, 0, '', '2019-06-10 11:14:58');
INSERT INTO `access_log` VALUES (33527, '64.76.15601364975974369', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:14:58', 12, 0, '', '2019-06-10 11:14:58');
INSERT INTO `access_log` VALUES (33528, '64.77.15601365042004385', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:15:04', 11, 0, '', '2019-06-10 11:15:04');
INSERT INTO `access_log` VALUES (33529, '64.80.15601365041974373', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:15:04', 16, 0, '', '2019-06-10 11:15:04');
INSERT INTO `access_log` VALUES (33530, '64.79.15601365111194373', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:15:11', 9, 0, '', '2019-06-10 11:15:11');
INSERT INTO `access_log` VALUES (33531, '64.82.15601365231304391', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:15:23', 8, 0, '', '2019-06-10 11:15:23');
INSERT INTO `access_log` VALUES (33532, '64.83.15601365231294373', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:15:23', 10, 0, '', '2019-06-10 11:15:23');
INSERT INTO `access_log` VALUES (33533, '64.76.15601365250614371', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:15:25', 10, 0, '', '2019-06-10 11:15:25');
INSERT INTO `access_log` VALUES (33534, '64.84.15601365250584389', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:15:25', 14, 0, '', '2019-06-10 11:15:25');
INSERT INTO `access_log` VALUES (33535, '64.81.15601365251134379', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:15:25', 9, 0, '', '2019-06-10 11:15:25');
INSERT INTO `access_log` VALUES (33536, '64.85.15601365614054401', 27, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[2,4],\"price\":1200,\"quantity\":12}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:16:01', 8, 1002002009, NULL, '2019-06-10 11:16:01');
INSERT INTO `access_log` VALUES (33537, '64.77.15601369470744393', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:22:27', 18, 0, '', '2019-06-10 11:22:27');
INSERT INTO `access_log` VALUES (33538, '64.79.15601369708874381', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:22:51', 13, 0, '', '2019-06-10 11:22:51');
INSERT INTO `access_log` VALUES (33539, '64.78.15601369709364395', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:22:51', 10, 0, '', '2019-06-10 11:22:51');
INSERT INTO `access_log` VALUES (33540, '64.82.15601369731954399', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:22:53', 10, 0, '', '2019-06-10 11:22:53');
INSERT INTO `access_log` VALUES (33541, '64.83.15601369731944381', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:22:53', 12, 0, '', '2019-06-10 11:22:53');
INSERT INTO `access_log` VALUES (33542, '64.81.15601370017854387', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:23:22', 10, 0, '', '2019-06-10 11:23:22');
INSERT INTO `access_log` VALUES (33543, '64.80.15601370210784383', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:23:41', 9, 0, '', '2019-06-10 11:23:41');
INSERT INTO `access_log` VALUES (33544, '64.79.15601370379144383', 27, 2, 'product-application', '/product-api/admins/category/update', 'id=784&pid=579&name=红米系列&description=qweqw&picUrl=https://shop.io.mi-img.com/app/shop/img?id=shop_72605808146ee82c9961f9e3be6d8696.jpeg&sort=2&status=1&createTime=2019-02-21T10:34:29.000+0000', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:23:58', 9, 1002002009, NULL, '2019-06-10 11:23:58');
INSERT INTO `access_log` VALUES (33545, '64.83.15601370544694383', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:24:14', 9, 0, '', '2019-06-10 11:24:14');
INSERT INTO `access_log` VALUES (33546, '64.82.15601370544694401', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:24:14', 12, 0, '', '2019-06-10 11:24:14');
INSERT INTO `access_log` VALUES (33547, '64.76.15601370610884381', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1&cid=784', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:24:21', 10, 0, '', '2019-06-10 11:24:21');
INSERT INTO `access_log` VALUES (33548, '65.54.15601370716424851', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:24:32', 10, 0, '', '2019-06-10 11:24:32');
INSERT INTO `access_log` VALUES (33549, '65.52.15601370716444895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:24:32', 9, 0, '', '2019-06-10 11:24:32');
INSERT INTO `access_log` VALUES (33550, '65.51.15601370716664901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:24:32', 10, 0, '', '2019-06-10 11:24:32');
INSERT INTO `access_log` VALUES (33551, '64.77.15601370718084397', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:24:32', 9, 0, '', '2019-06-10 11:24:32');
INSERT INTO `access_log` VALUES (33552, '64.81.15601370718074389', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:24:32', 11, 0, '', '2019-06-10 11:24:32');
INSERT INTO `access_log` VALUES (33553, '64.78.15601370775004399', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:24:38', 53, 0, '', '2019-06-10 11:24:38');
INSERT INTO `access_log` VALUES (33554, '64.79.15601370774994385', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:24:38', 58, 0, '', '2019-06-10 11:24:38');
INSERT INTO `access_log` VALUES (33555, '64.85.15601370774984411', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-10 11:24:37', 60, 0, '', '2019-06-10 11:24:38');
INSERT INTO `access_log` VALUES (33556, '65.54.15601375225314857', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:32:03', 0, 1002001015, '账号未登陆', '2019-06-10 11:32:03');
INSERT INTO `access_log` VALUES (33557, '65.51.15601375225374907', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:32:03', 0, 1002001015, '账号未登陆', '2019-06-10 11:32:03');
INSERT INTO `access_log` VALUES (33558, '65.45.15601375225414905', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:32:03', 1, 1002001015, '账号未登陆', '2019-06-10 11:32:03');
INSERT INTO `access_log` VALUES (33559, '65.50.15601375267574903', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:32:07', 53, 0, '', '2019-06-10 11:32:07');
INSERT INTO `access_log` VALUES (33560, '65.3607.15601375271036657', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:32:07', 8, 0, '', '2019-06-10 11:32:07');
INSERT INTO `access_log` VALUES (33561, '65.49.15601375271004915', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:32:07', 10, 0, '', '2019-06-10 11:32:07');
INSERT INTO `access_log` VALUES (33562, '65.53.15601375271084865', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:32:07', 9, 0, '', '2019-06-10 11:32:07');
INSERT INTO `access_log` VALUES (33563, '62.87.15601375403134341', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:32:20', 12, 0, '', '2019-06-10 11:32:20');
INSERT INTO `access_log` VALUES (33564, '59.71.15601375602114527', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:32:40', 11, 0, '', '2019-06-10 11:32:40');
INSERT INTO `access_log` VALUES (33565, '64.84.15601375652264407', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:32:45', 13, 0, '', '2019-06-10 11:32:45');
INSERT INTO `access_log` VALUES (33566, '64.76.15601375652264389', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:32:45', 14, 0, '', '2019-06-10 11:32:45');
INSERT INTO `access_log` VALUES (33567, '64.77.15601375688704405', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:32:49', 9, 0, '', '2019-06-10 11:32:49');
INSERT INTO `access_log` VALUES (33568, '64.81.15601375688704397', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:32:49', 12, 0, '', '2019-06-10 11:32:49');
INSERT INTO `access_log` VALUES (33569, '64.78.15601375966464407', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:33:17', 192, 0, '', '2019-06-10 11:33:17');
INSERT INTO `access_log` VALUES (33570, '64.82.15601376022084411', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:33:22', 9, 0, '', '2019-06-10 11:33:22');
INSERT INTO `access_log` VALUES (33571, '64.83.15601376022074393', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:33:22', 11, 0, '', '2019-06-10 11:33:22');
INSERT INTO `access_log` VALUES (33572, '64.77.15601376545714407', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:34:15', 9, 0, '', '2019-06-10 11:34:15');
INSERT INTO `access_log` VALUES (33573, '64.80.15601376545724395', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:34:15', 8, 0, '', '2019-06-10 11:34:15');
INSERT INTO `access_log` VALUES (33574, '64.78.15601376579874409', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:34:18', 10, 0, '', '2019-06-10 11:34:18');
INSERT INTO `access_log` VALUES (33575, '64.85.15601376579864421', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:34:18', 12, 0, '', '2019-06-10 11:34:18');
INSERT INTO `access_log` VALUES (33576, '64.83.15601376649604395', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&name=农夫&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 11:34:25', 279, 0, '', '2019-06-10 11:34:25');
INSERT INTO `access_log` VALUES (33577, '59.72.15601412679924575', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.37.171.188', '2019-06-10 12:34:28', 11, 0, '', '2019-06-10 12:34:28');
INSERT INTO `access_log` VALUES (33578, '59.76.15601412680024569', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.37.171.188', '2019-06-10 12:34:28', 12, 2001001000, '服务端发生异常', '2019-06-10 12:34:28');
INSERT INTO `access_log` VALUES (33579, '65.46.15601412766394941', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.37.171.188', '2019-06-10 12:34:37', 0, 1002001015, '账号未登陆', '2019-06-10 12:34:37');
INSERT INTO `access_log` VALUES (33580, '65.45.15601412766394957', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.37.171.188', '2019-06-10 12:34:37', 1, 1002001015, '账号未登陆', '2019-06-10 12:34:37');
INSERT INTO `access_log` VALUES (33581, '65.47.15601412766554943', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.37.171.188', '2019-06-10 12:34:37', 0, 1002001015, '账号未登陆', '2019-06-10 12:34:37');
INSERT INTO `access_log` VALUES (33582, '65.53.15601413282714919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.37.171.188', '2019-06-10 12:35:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 12:35:28');
INSERT INTO `access_log` VALUES (33583, '65.45.15601413757434959', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.37.171.188', '2019-06-10 12:36:16', 288, 0, '', '2019-06-10 12:36:16');
INSERT INTO `access_log` VALUES (33584, '65.52.15601413763844959', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.37.171.188', '2019-06-10 12:36:16', 11, 0, '', '2019-06-10 12:36:16');
INSERT INTO `access_log` VALUES (33585, '65.47.15601413763834945', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.37.171.188', '2019-06-10 12:36:16', 11, 0, '', '2019-06-10 12:36:16');
INSERT INTO `access_log` VALUES (33586, '65.54.15601413763994913', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.37.171.188', '2019-06-10 12:36:16', 9, 0, '', '2019-06-10 12:36:16');
INSERT INTO `access_log` VALUES (33587, '62.84.15601413896024387', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.37.171.188', '2019-06-10 12:36:30', 104, 0, '', '2019-06-10 12:36:30');
INSERT INTO `access_log` VALUES (33588, '65.54.15601441989164951', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 13:23:19', 13, 1002001012, '访问令牌已过期', '2019-06-10 13:23:19');
INSERT INTO `access_log` VALUES (33589, '65.52.15601441989164997', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 13:23:19', 16, 1002001012, '访问令牌已过期', '2019-06-10 13:23:19');
INSERT INTO `access_log` VALUES (33590, '65.51.15601441989324999', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 13:23:19', 13, 1002001012, '访问令牌已过期', '2019-06-10 13:23:19');
INSERT INTO `access_log` VALUES (33591, '64.77.15601441990324495', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 13:23:19', 11, 1002001012, '访问令牌已过期', '2019-06-10 13:23:19');
INSERT INTO `access_log` VALUES (33592, '64.78.15601441990394497', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.204.16.106', '2019-06-10 13:23:19', 5, 1002001012, '访问令牌已过期', '2019-06-10 13:23:19');
INSERT INTO `access_log` VALUES (33593, '59.77.15601453536784621', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:42:34', 18, 0, '', '2019-06-10 13:42:34');
INSERT INTO `access_log` VALUES (33594, '59.74.15601453536784627', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:42:34', 21, 2001001000, '服务端发生异常', '2019-06-10 13:42:34');
INSERT INTO `access_log` VALUES (33595, '59.75.15601453615774633', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:42:42', 3, 0, '', '2019-06-10 13:42:42');
INSERT INTO `access_log` VALUES (33596, '59.79.15601453615784633', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:42:42', 10, 2001001000, '服务端发生异常', '2019-06-10 13:42:42');
INSERT INTO `access_log` VALUES (33597, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=手机&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:42:48', 11, 0, '', '2019-06-10 13:42:48');
INSERT INTO `access_log` VALUES (33598, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=手机', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:42:48', 19, 0, '', '2019-06-10 13:42:48');
INSERT INTO `access_log` VALUES (33599, '64.77.15601453709194511', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:42:51', 9, 0, '', '2019-06-10 13:42:51');
INSERT INTO `access_log` VALUES (33600, '66.57.15601453982973111', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=aaaaa&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:43:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n账号长度为 11 位', '2019-06-10 13:43:18');
INSERT INTO `access_log` VALUES (33601, '66.52.15601454107933107', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12312341233&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:43:31', 16, 1001003000, '验证码不存在', '2019-06-10 13:43:31');
INSERT INTO `access_log` VALUES (33602, '66.49.15601454133373119', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=12312341233', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:43:33', 66, 0, '', '2019-06-10 13:43:33');
INSERT INTO `access_log` VALUES (33603, '64.82.15601454229484517', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:43:43', 7, 0, '', '2019-06-10 13:43:43');
INSERT INTO `access_log` VALUES (33604, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:43:44', 6, 0, '', '2019-06-10 13:43:44');
INSERT INTO `access_log` VALUES (33605, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:43:44', 4, 0, '', '2019-06-10 13:43:44');
INSERT INTO `access_log` VALUES (33606, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:43:44', 9, 0, '', '2019-06-10 13:43:44');
INSERT INTO `access_log` VALUES (33607, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:43:44', 11, 0, '', '2019-06-10 13:43:45');
INSERT INTO `access_log` VALUES (33608, '59.77.15601454354474623', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:43:55', 3, 0, '', '2019-06-10 13:43:55');
INSERT INTO `access_log` VALUES (33609, '59.74.15601454354474629', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.108.36.225', '2019-06-10 13:43:55', 13, 2001001000, '服务端发生异常', '2019-06-10 13:43:55');
INSERT INTO `access_log` VALUES (33610, '65.52.15601455313775015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:45:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 13:45:31');
INSERT INTO `access_log` VALUES (33611, '65.3607.15601455364416767', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:45:36', 318, 0, '', '2019-06-10 13:45:37');
INSERT INTO `access_log` VALUES (33612, '65.53.15601455376414977', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:45:38', 19, 0, '', '2019-06-10 13:45:38');
INSERT INTO `access_log` VALUES (33613, '65.50.15601455376545013', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:45:38', 9, 0, '', '2019-06-10 13:45:38');
INSERT INTO `access_log` VALUES (33614, '65.49.15601455376605027', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:45:38', 8, 0, '', '2019-06-10 13:45:38');
INSERT INTO `access_log` VALUES (33615, '62.80.15601455724814459', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:46:12', 54, 0, '', '2019-06-10 13:46:13');
INSERT INTO `access_log` VALUES (33616, '62.86.15601455849264443', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:46:25', 12, 0, '', '2019-06-10 13:46:25');
INSERT INTO `access_log` VALUES (33617, '64.81.15601455868054507', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:46:27', 9, 0, '', '2019-06-10 13:46:27');
INSERT INTO `access_log` VALUES (33618, '64.84.15601455868034517', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:46:27', 13, 0, '', '2019-06-10 13:46:27');
INSERT INTO `access_log` VALUES (33619, '59.80.15601455926224625', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:46:33', 10, 0, '', '2019-06-10 13:46:33');
INSERT INTO `access_log` VALUES (33620, '59.78.15601456165364637', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:46:57', 25, 2001001000, '服务端发生异常', '2019-06-10 13:46:57');
INSERT INTO `access_log` VALUES (33621, '59.72.15601456202454635', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:47:00', 515, 0, '', '2019-06-10 13:47:01');
INSERT INTO `access_log` VALUES (33622, '64.77.15601456232854515', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:47:03', 12, 0, '', '2019-06-10 13:47:03');
INSERT INTO `access_log` VALUES (33623, '64.79.15601456317834503', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:47:12', 10, 0, '', '2019-06-10 13:47:12');
INSERT INTO `access_log` VALUES (33624, '65.49.15601456455795029', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.108.36.225', '2019-06-10 13:47:26', 20, 0, '', '2019-06-10 13:47:26');
INSERT INTO `access_log` VALUES (33625, '59.72.15601460185034641', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '122.233.210.142', '2019-06-10 13:53:39', 10, 0, '', '2019-06-10 13:53:39');
INSERT INTO `access_log` VALUES (33626, '59.76.15601460185044635', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '122.233.210.142', '2019-06-10 13:53:39', 19, 2001001000, '服务端发生异常', '2019-06-10 13:53:39');
INSERT INTO `access_log` VALUES (33627, '64.77.15601460246684521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '122.233.210.142', '2019-06-10 13:53:45', 18, 0, '', '2019-06-10 13:53:45');
INSERT INTO `access_log` VALUES (33628, '64.79.15601460248584509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '122.233.210.142', '2019-06-10 13:53:45', 8, 0, '', '2019-06-10 13:53:45');
INSERT INTO `access_log` VALUES (33629, '64.83.15601460279424509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '122.233.210.142', '2019-06-10 13:53:48', 8, 0, '', '2019-06-10 13:53:48');
INSERT INTO `access_log` VALUES (33630, '64.82.15601460280954527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '122.233.210.142', '2019-06-10 13:53:48', 8, 0, '', '2019-06-10 13:53:48');
INSERT INTO `access_log` VALUES (33631, '66.48.15601460287763125', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '122.233.210.142', '2019-06-10 13:53:49', 7, 1002001012, '访问令牌已过期', '2019-06-10 13:53:49');
INSERT INTO `access_log` VALUES (33632, '66.55.15601460288973119', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=9839a2038f4d46b1b97af5b034857c9f', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '122.233.210.142', '2019-06-10 13:53:49', 14, 1002001018, '访问令牌已过期', '2019-06-10 13:53:49');
INSERT INTO `access_log` VALUES (33633, '66.51.15601460401243121', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15136212594&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '122.233.210.142', '2019-06-10 13:54:00', 376, 1001003001, '验证码已过期', '2019-06-10 13:54:01');
INSERT INTO `access_log` VALUES (33634, '66.57.15601460430903121', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15136212594', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '122.233.210.142', '2019-06-10 13:54:03', 69, 0, '', '2019-06-10 13:54:03');
INSERT INTO `access_log` VALUES (33635, '66.53.15601460451693119', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15136212594&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '122.233.210.142', '2019-06-10 13:54:05', 320, 0, '', '2019-06-10 13:54:05');
INSERT INTO `access_log` VALUES (33636, '66.49.15601460467803129', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '122.233.210.142', '2019-06-10 13:54:07', 6, 0, '', '2019-06-10 13:54:07');
INSERT INTO `access_log` VALUES (33637, '64.80.15601460525134511', 74, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '122.233.210.142', '2019-06-10 13:54:13', 6, 1003002003, 'Spu 只能添加在二级分类下', '2019-06-10 13:54:13');
INSERT INTO `access_log` VALUES (33638, '66.56.15601460550593117', 74, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '122.233.210.142', '2019-06-10 13:54:15', 5, 0, '', '2019-06-10 13:54:15');
INSERT INTO `access_log` VALUES (33639, '65.45.15601479461055051', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:25:46', 0, 1002001015, '账号未登陆', '2019-06-10 14:25:46');
INSERT INTO `access_log` VALUES (33640, '65.54.15601479461055005', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:25:46', 0, 1002001015, '账号未登陆', '2019-06-10 14:25:46');
INSERT INTO `access_log` VALUES (33641, '65.52.15601479461095049', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:25:46', 1, 1002001015, '账号未登陆', '2019-06-10 14:25:46');
INSERT INTO `access_log` VALUES (33642, '65.47.15601479490735037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:25:49', 77, 0, '', '2019-06-10 14:25:49');
INSERT INTO `access_log` VALUES (33643, '65.50.15601479493725047', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:25:49', 143, 0, '', '2019-06-10 14:25:50');
INSERT INTO `access_log` VALUES (33644, '65.3607.15601479493776799', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:25:49', 138, 0, '', '2019-06-10 14:25:50');
INSERT INTO `access_log` VALUES (33645, '65.51.15601479493715051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:25:49', 144, 0, '', '2019-06-10 14:25:50');
INSERT INTO `access_log` VALUES (33646, '64.84.15601479602874551', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:26:00', 18, 0, '', '2019-06-10 14:26:00');
INSERT INTO `access_log` VALUES (33647, '64.81.15601479602864541', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:26:00', 23, 0, '', '2019-06-10 14:26:00');
INSERT INTO `access_log` VALUES (33648, '64.79.15601479969264537', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:26:37', 11, 0, '', '2019-06-10 14:26:37');
INSERT INTO `access_log` VALUES (33649, '64.85.15601479969244563', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:26:37', 14, 0, '', '2019-06-10 14:26:37');
INSERT INTO `access_log` VALUES (33650, '64.82.15601480122774555', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:26:52', 10, 0, '', '2019-06-10 14:26:52');
INSERT INTO `access_log` VALUES (33651, '62.89.15601480194054491', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:26:59', 21, 0, '', '2019-06-10 14:26:59');
INSERT INTO `access_log` VALUES (33652, '64.81.15601480267994543', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:27:07', 10, 0, '', '2019-06-10 14:27:07');
INSERT INTO `access_log` VALUES (33653, '59.78.15601480748014671', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.108.32.107', '2019-06-10 14:27:55', 11, 0, '', '2019-06-10 14:27:55');
INSERT INTO `access_log` VALUES (33654, '59.76.15601480748034663', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.108.32.107', '2019-06-10 14:27:55', 15, 2001001000, '服务端发生异常', '2019-06-10 14:27:55');
INSERT INTO `access_log` VALUES (33655, '64.85.15601480933544565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.108.32.107', '2019-06-10 14:28:13', 3, 0, '', '2019-06-10 14:28:13');
INSERT INTO `access_log` VALUES (33656, '64.79.15601480935224539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '119.108.32.107', '2019-06-10 14:28:14', 2, 0, '', '2019-06-10 14:28:14');
INSERT INTO `access_log` VALUES (33657, '65.54.15601495084225025', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:51:48', 12, 0, '', '2019-06-10 14:51:48');
INSERT INTO `access_log` VALUES (33658, '65.52.15601495084235069', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:51:48', 11, 0, '', '2019-06-10 14:51:48');
INSERT INTO `access_log` VALUES (33659, '65.45.15601495084225073', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:51:48', 13, 0, '', '2019-06-10 14:51:48');
INSERT INTO `access_log` VALUES (33660, '64.80.15601495140194559', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 14:51:54', 10, 0, '', '2019-06-10 14:51:54');
INSERT INTO `access_log` VALUES (33661, '65.51.15601496706885077', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:54:31', 0, 1002001015, '账号未登陆', '2019-06-10 14:54:31');
INSERT INTO `access_log` VALUES (33662, '65.50.15601496706925073', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:54:31', 0, 1002001015, '账号未登陆', '2019-06-10 14:54:31');
INSERT INTO `access_log` VALUES (33663, '65.3607.15601496707006825', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:54:31', 1, 1002001015, '账号未登陆', '2019-06-10 14:54:31');
INSERT INTO `access_log` VALUES (33664, '65.49.15601496938025089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:54:54', 1089, 0, '', '2019-06-10 14:54:55');
INSERT INTO `access_log` VALUES (33665, '65.54.15601496953045029', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:54:55', 10, 0, '', '2019-06-10 14:54:55');
INSERT INTO `access_log` VALUES (33666, '65.45.15601496953105077', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:54:55', 8, 0, '', '2019-06-10 14:54:55');
INSERT INTO `access_log` VALUES (33667, '65.52.15601496953165073', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:54:55', 9, 0, '', '2019-06-10 14:54:55');
INSERT INTO `access_log` VALUES (33668, '62.85.15601497017954499', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:55:02', 14, 0, '', '2019-06-10 14:55:02');
INSERT INTO `access_log` VALUES (33669, '59.77.15601498508164685', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:57:31', 4, 0, '', '2019-06-10 14:57:31');
INSERT INTO `access_log` VALUES (33670, '59.80.15601498508164683', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:57:31', 14, 2001001000, '服务端发生异常', '2019-06-10 14:57:31');
INSERT INTO `access_log` VALUES (33671, '64.83.15601498840994563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:58:04', 2, 0, '', '2019-06-10 14:58:04');
INSERT INTO `access_log` VALUES (33672, '64.82.15601498842974581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:58:04', 2, 0, '', '2019-06-10 14:58:04');
INSERT INTO `access_log` VALUES (33673, '59.76.15601498863204687', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:58:06', 3, 0, '', '2019-06-10 14:58:06');
INSERT INTO `access_log` VALUES (33674, '59.71.15601498863234695', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:58:06', 19, 2001001000, '服务端发生异常', '2019-06-10 14:58:06');
INSERT INTO `access_log` VALUES (33675, '59.72.15601498903264693', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:58:10', 2, 0, '', '2019-06-10 14:58:10');
INSERT INTO `access_log` VALUES (33676, '59.73.15601498903304697', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:58:10', 10, 2001001000, '服务端发生异常', '2019-06-10 14:58:10');
INSERT INTO `access_log` VALUES (33677, '64.81.15601498925894569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:58:13', 2, 0, '', '2019-06-10 14:58:13');
INSERT INTO `access_log` VALUES (33678, '64.84.15601498927314579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:58:13', 2, 0, '', '2019-06-10 14:58:13');
INSERT INTO `access_log` VALUES (33679, '59.80.15601498939124685', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:58:14', 14, 2001001000, '服务端发生异常', '2019-06-10 14:58:14');
INSERT INTO `access_log` VALUES (33680, '59.74.15601498939094693', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:58:14', 58, 0, '', '2019-06-10 14:58:14');
INSERT INTO `access_log` VALUES (33681, '66.53.15601498982723171', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:58:18', 25, 0, '', '2019-06-10 14:58:18');
INSERT INTO `access_log` VALUES (33682, '64.78.15601499014304579', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:58:21', 11, 0, '', '2019-06-10 14:58:21');
INSERT INTO `access_log` VALUES (33683, '64.77.15601499014384577', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 14:58:21', 8, 0, '', '2019-06-10 14:58:21');
INSERT INTO `access_log` VALUES (33684, '65.50.15601503384605083', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:05:38', 3, 1002001012, '访问令牌已过期', '2019-06-10 15:05:38');
INSERT INTO `access_log` VALUES (33685, '65.3607.15601503384616835', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:05:38', 3, 1002001012, '访问令牌已过期', '2019-06-10 15:05:38');
INSERT INTO `access_log` VALUES (33686, '65.53.15601503384655049', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:05:38', 3, 1002001012, '访问令牌已过期', '2019-06-10 15:05:38');
INSERT INTO `access_log` VALUES (33687, '65.52.15601503900545083', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:06:30', 98, 0, '', '2019-06-10 15:06:30');
INSERT INTO `access_log` VALUES (33688, '65.47.15601503907875073', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:06:31', 9, 0, '', '2019-06-10 15:06:31');
INSERT INTO `access_log` VALUES (33689, '65.3607.15601503907896837', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:06:31', 9, 0, '', '2019-06-10 15:06:31');
INSERT INTO `access_log` VALUES (33690, '65.51.15601503907875089', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:06:31', 10, 0, '', '2019-06-10 15:06:31');
INSERT INTO `access_log` VALUES (33691, '62.81.15601503950864495', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:06:35', 12, 0, '', '2019-06-10 15:06:35');
INSERT INTO `access_log` VALUES (33692, '62.83.15601503998344523', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:06:40', 15, 0, '', '2019-06-10 15:06:40');
INSERT INTO `access_log` VALUES (33693, '65.53.15601504000065051', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3150 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '117.136.39.84', '2019-06-10 15:06:40', 0, 1002001015, '账号未登陆', '2019-06-10 15:06:40');
INSERT INTO `access_log` VALUES (33694, '65.46.15601504000355073', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3150 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '117.136.39.84', '2019-06-10 15:06:40', 0, 1002001015, '账号未登陆', '2019-06-10 15:06:40');
INSERT INTO `access_log` VALUES (33695, '65.49.15601504000835101', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6000 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/3150 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '117.136.39.84', '2019-06-10 15:06:40', 0, 1002001015, '账号未登陆', '2019-06-10 15:06:40');
INSERT INTO `access_log` VALUES (33696, '64.82.15601504056474589', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:06:46', 11, 0, '', '2019-06-10 15:06:46');
INSERT INTO `access_log` VALUES (33697, '64.76.15601504056474569', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:06:46', 12, 0, '', '2019-06-10 15:06:46');
INSERT INTO `access_log` VALUES (33698, '64.84.15601504113664587', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:06:51', 15, 0, '', '2019-06-10 15:06:51');
INSERT INTO `access_log` VALUES (33699, '64.80.15601504113674573', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:06:51', 15, 0, '', '2019-06-10 15:06:51');
INSERT INTO `access_log` VALUES (33700, '64.78.15601504217834587', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:07:02', 10, 0, '', '2019-06-10 15:07:02');
INSERT INTO `access_log` VALUES (33701, '66.50.15601504382663169', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:07:18', 15, 0, '', '2019-06-10 15:07:18');
INSERT INTO `access_log` VALUES (33702, '59.73.15601504421464705', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:07:22', 12, 0, '', '2019-06-10 15:07:22');
INSERT INTO `access_log` VALUES (33703, '59.74.15601504488264701', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:07:29', 19, 2001001000, '服务端发生异常', '2019-06-10 15:07:29');
INSERT INTO `access_log` VALUES (33704, '59.80.15601504530464693', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:07:33', 10, 0, '', '2019-06-10 15:07:33');
INSERT INTO `access_log` VALUES (33705, '59.75.15601504571304707', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:07:37', 10, 0, '', '2019-06-10 15:07:37');
INSERT INTO `access_log` VALUES (33706, '59.79.15601504629504707', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:07:43', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-10 15:07:43');
INSERT INTO `access_log` VALUES (33707, '65.47.15601504742025075', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:07:54', 1, 1002001015, '账号未登陆', '2019-06-10 15:07:54');
INSERT INTO `access_log` VALUES (33708, '65.50.15601504742125087', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:07:54', 0, 1002001015, '账号未登陆', '2019-06-10 15:07:54');
INSERT INTO `access_log` VALUES (33709, '65.53.15601504742745053', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:07:54', 0, 1002001015, '账号未登陆', '2019-06-10 15:07:54');
INSERT INTO `access_log` VALUES (33710, '65.46.15601504749465075', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:07:55', 19, 0, '', '2019-06-10 15:07:55');
INSERT INTO `access_log` VALUES (33711, '65.49.15601504794265103', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:07:59', 10, 0, '', '2019-06-10 15:07:59');
INSERT INTO `access_log` VALUES (33712, '65.45.15601504846685091', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:08:05', 84, 0, '', '2019-06-10 15:08:05');
INSERT INTO `access_log` VALUES (33713, '65.54.15601504855395043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:08:06', 411, 0, '', '2019-06-10 15:08:06');
INSERT INTO `access_log` VALUES (33714, '65.51.15601504865055093', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:08:07', 10, 0, '', '2019-06-10 15:08:07');
INSERT INTO `access_log` VALUES (33715, '65.52.15601504865045087', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:08:07', 10, 0, '', '2019-06-10 15:08:07');
INSERT INTO `access_log` VALUES (33716, '65.3607.15601504865146841', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:08:07', 9, 0, '', '2019-06-10 15:08:07');
INSERT INTO `access_log` VALUES (33717, '65.50.15601504941065089', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.73.213.174', '2019-06-10 15:08:14', 14, 0, '', '2019-06-10 15:08:14');
INSERT INTO `access_log` VALUES (33718, '65.46.15601505045085077', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:08:25', 10, 0, '', '2019-06-10 15:08:25');
INSERT INTO `access_log` VALUES (33719, '65.45.15601505045195093', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:08:25', 9, 0, '', '2019-06-10 15:08:25');
INSERT INTO `access_log` VALUES (33720, '65.49.15601505045195105', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:08:25', 9, 0, '', '2019-06-10 15:08:25');
INSERT INTO `access_log` VALUES (33721, '65.3607.15601505293396843', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:08:49', 10, 0, '', '2019-06-10 15:08:49');
INSERT INTO `access_log` VALUES (33722, '65.52.15601505293405089', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:08:49', 12, 0, '', '2019-06-10 15:08:49');
INSERT INTO `access_log` VALUES (33723, '65.51.15601505293485095', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:08:49', 9, 0, '', '2019-06-10 15:08:49');
INSERT INTO `access_log` VALUES (33724, '65.50.15601505400695091', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:09:00', 8, 0, '', '2019-06-10 15:09:00');
INSERT INTO `access_log` VALUES (33725, '65.46.15601505400845079', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:09:00', 8, 0, '', '2019-06-10 15:09:00');
INSERT INTO `access_log` VALUES (33726, '65.53.15601505400835057', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:09:00', 8, 0, '', '2019-06-10 15:09:00');
INSERT INTO `access_log` VALUES (33727, '62.87.15601505403334517', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:09:00', 13, 0, '', '2019-06-10 15:09:00');
INSERT INTO `access_log` VALUES (33728, '65.49.15601505480585107', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:09:08', 8, 0, '', '2019-06-10 15:09:08');
INSERT INTO `access_log` VALUES (33729, '65.45.15601505480585095', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:09:08', 9, 0, '', '2019-06-10 15:09:08');
INSERT INTO `access_log` VALUES (33730, '65.54.15601505480595047', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:09:08', 9, 0, '', '2019-06-10 15:09:08');
INSERT INTO `access_log` VALUES (33731, '59.80.15601505483264695', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:09:08', 10, 0, '', '2019-06-10 15:09:08');
INSERT INTO `access_log` VALUES (33732, '65.3607.15601505580676845', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:09:18', 8, 0, '', '2019-06-10 15:09:18');
INSERT INTO `access_log` VALUES (33733, '65.47.15601505580935081', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:09:18', 7, 0, '', '2019-06-10 15:09:18');
INSERT INTO `access_log` VALUES (33734, '65.52.15601505580935091', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.4.9.1029 Mobile Safari/537.36', '117.136.39.84', '2019-06-10 15:09:18', 8, 0, '', '2019-06-10 15:09:18');
INSERT INTO `access_log` VALUES (33735, '59.76.15601513541024709', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 15:22:34', 2, 0, '', '2019-06-10 15:22:34');
INSERT INTO `access_log` VALUES (33736, '59.71.15601513541004717', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 15:22:34', 11, 2001001000, '服务端发生异常', '2019-06-10 15:22:34');
INSERT INTO `access_log` VALUES (33737, '65.3607.15601514132146857', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 15:23:33', 11, 0, '', '2019-06-10 15:23:33');
INSERT INTO `access_log` VALUES (33738, '65.47.15601514132145093', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 15:23:33', 12, 0, '', '2019-06-10 15:23:33');
INSERT INTO `access_log` VALUES (33739, '65.52.15601514132165103', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 15:23:33', 10, 0, '', '2019-06-10 15:23:33');
INSERT INTO `access_log` VALUES (33740, '64.81.15601514135974591', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 15:23:34', 12, 0, '', '2019-06-10 15:23:34');
INSERT INTO `access_log` VALUES (33741, '64.84.15601514136024601', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '10.4.19.67', '2019-06-10 15:23:34', 9, 0, '', '2019-06-10 15:23:34');
INSERT INTO `access_log` VALUES (33742, '59.80.15601539408644741', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:05:41', 12, 2001001000, '服务端发生异常', '2019-06-10 16:05:41');
INSERT INTO `access_log` VALUES (33743, '59.74.15601539408604749', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:05:41', 27, 0, '', '2019-06-10 16:05:41');
INSERT INTO `access_log` VALUES (33744, '64.81.15601539452504625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:05:45', 11, 0, '', '2019-06-10 16:05:45');
INSERT INTO `access_log` VALUES (33745, '64.80.15601539453664621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:05:45', 4, 0, '', '2019-06-10 16:05:45');
INSERT INTO `access_log` VALUES (33746, '64.78.15601539467064635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:05:47', 3, 0, '', '2019-06-10 16:05:47');
INSERT INTO `access_log` VALUES (33747, '64.77.15601539473624633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:05:47', 2, 0, '', '2019-06-10 16:05:47');
INSERT INTO `access_log` VALUES (33748, '59.75.15601539486964755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:05:49', 12, 2001001000, '服务端发生异常', '2019-06-10 16:05:49');
INSERT INTO `access_log` VALUES (33749, '59.77.15601539486964743', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:05:49', 362, 0, '', '2019-06-10 16:05:49');
INSERT INTO `access_log` VALUES (33750, '65.52.15601539540505139', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:05:54', 0, 1002001015, '账号未登陆', '2019-06-10 16:05:54');
INSERT INTO `access_log` VALUES (33751, '65.3607.15601539540496893', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:05:54', 0, 1002001015, '账号未登陆', '2019-06-10 16:05:54');
INSERT INTO `access_log` VALUES (33752, '65.47.15601539540535129', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:05:54', 1, 1002001015, '账号未登陆', '2019-06-10 16:05:54');
INSERT INTO `access_log` VALUES (33753, '65.53.15601539571095105', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:05:57', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 16:05:57');
INSERT INTO `access_log` VALUES (33754, '65.50.15601539644085139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:06:04', 198, 0, '', '2019-06-10 16:06:05');
INSERT INTO `access_log` VALUES (33755, '65.46.15601539648725129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:06:05', 108, 0, '', '2019-06-10 16:06:05');
INSERT INTO `access_log` VALUES (33756, '65.54.15601539648745095', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:06:05', 109, 0, '', '2019-06-10 16:06:05');
INSERT INTO `access_log` VALUES (33757, '65.49.15601539648775157', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:06:05', 107, 0, '', '2019-06-10 16:06:05');
INSERT INTO `access_log` VALUES (33758, '62.84.15601539695514557', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:06:10', 21, 0, '', '2019-06-10 16:06:10');
INSERT INTO `access_log` VALUES (33759, '64.83.15601539770124621', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:06:17', 19, 0, '', '2019-06-10 16:06:17');
INSERT INTO `access_log` VALUES (33760, '64.82.15601539770164639', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:06:17', 17, 0, '', '2019-06-10 16:06:17');
INSERT INTO `access_log` VALUES (33761, '59.76.15601539825374745', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:06:23', 11, 0, '', '2019-06-10 16:06:23');
INSERT INTO `access_log` VALUES (33762, '59.73.15601539942664755', 27, 2, 'promotion-application', '/promotion-api/admins/banner/update_status', 'id=4&status=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:06:34', 8, 1002002009, NULL, '2019-06-10 16:06:34');
INSERT INTO `access_log` VALUES (33763, '65.3607.15601539973876895', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:06:37', 19, 0, '', '2019-06-10 16:06:37');
INSERT INTO `access_log` VALUES (33764, '65.52.15601540002485141', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:06:40', 10, 0, '', '2019-06-10 16:06:40');
INSERT INTO `access_log` VALUES (33765, '65.53.15601540022235107', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:06:42', 9, 0, '', '2019-06-10 16:06:42');
INSERT INTO `access_log` VALUES (33766, '65.50.15601540079495141', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:06:48', 13, 0, '', '2019-06-10 16:06:48');
INSERT INTO `access_log` VALUES (33767, '59.76.15601563340894777', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:45:34', 15, 2001001000, '服务端发生异常', '2019-06-10 16:45:34');
INSERT INTO `access_log` VALUES (33768, '59.71.15601563340894785', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:45:34', 16, 0, '', '2019-06-10 16:45:34');
INSERT INTO `access_log` VALUES (33769, '64.82.15601563375564671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:45:38', 10, 0, '', '2019-06-10 16:45:38');
INSERT INTO `access_log` VALUES (33770, '64.83.15601563376604653', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:45:38', 3, 0, '', '2019-06-10 16:45:38');
INSERT INTO `access_log` VALUES (33771, '64.76.15601563438964651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:45:44', 1, 0, '', '2019-06-10 16:45:44');
INSERT INTO `access_log` VALUES (33772, '64.84.15601563440024669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:45:44', 2, 0, '', '2019-06-10 16:45:44');
INSERT INTO `access_log` VALUES (33773, '64.81.15601563449774659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:45:45', 2, 0, '', '2019-06-10 16:45:45');
INSERT INTO `access_log` VALUES (33774, '64.80.15601563455294655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:45:46', 2, 0, '', '2019-06-10 16:45:46');
INSERT INTO `access_log` VALUES (33775, '64.78.15601563487564669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:45:49', 2, 0, '', '2019-06-10 16:45:49');
INSERT INTO `access_log` VALUES (33776, '64.77.15601563488374667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '211.95.56.242', '2019-06-10 16:45:49', 2, 0, '', '2019-06-10 16:45:49');
INSERT INTO `access_log` VALUES (33777, '64.79.15601566576564659', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 16:50:58', 8, 1002001012, '访问令牌已过期', '2019-06-10 16:50:58');
INSERT INTO `access_log` VALUES (33778, '64.82.15601566576704677', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 16:50:58', 6, 1002001012, '访问令牌已过期', '2019-06-10 16:50:58');
INSERT INTO `access_log` VALUES (33779, '65.54.15601566591025133', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 16:50:59', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 16:50:59');
INSERT INTO `access_log` VALUES (33780, '65.46.15601566612995167', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 16:51:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 16:51:01');
INSERT INTO `access_log` VALUES (33781, '65.45.15601566745575179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 16:51:15', 79, 0, '', '2019-06-10 16:51:15');
INSERT INTO `access_log` VALUES (33782, '65.51.15601566749415183', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 16:51:15', 14, 0, '', '2019-06-10 16:51:15');
INSERT INTO `access_log` VALUES (33783, '65.3607.15601566749416933', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 16:51:15', 15, 0, '', '2019-06-10 16:51:15');
INSERT INTO `access_log` VALUES (33784, '65.53.15601566749425145', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 16:51:15', 16, 0, '', '2019-06-10 16:51:15');
INSERT INTO `access_log` VALUES (33785, '64.84.15601566786694675', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 16:51:19', 323, 0, '', '2019-06-10 16:51:19');
INSERT INTO `access_log` VALUES (33786, '64.76.15601566786664657', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 16:51:19', 328, 0, '', '2019-06-10 16:51:19');
INSERT INTO `access_log` VALUES (33787, '64.82.15601572022644685', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 17:00:02', 14, 0, '', '2019-06-10 17:00:02');
INSERT INTO `access_log` VALUES (33788, '64.84.15601572082434683', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 17:00:08', 9, 0, '', '2019-06-10 17:00:08');
INSERT INTO `access_log` VALUES (33789, '64.83.15601572082424667', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 17:00:08', 13, 0, '', '2019-06-10 17:00:08');
INSERT INTO `access_log` VALUES (33790, '64.81.15601572092664673', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 17:00:09', 127, 0, '', '2019-06-10 17:00:09');
INSERT INTO `access_log` VALUES (33791, '64.76.15601572092654665', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 17:00:09', 128, 0, '', '2019-06-10 17:00:09');
INSERT INTO `access_log` VALUES (33792, '64.80.15601572126284669', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 17:00:13', 178, 0, '', '2019-06-10 17:00:13');
INSERT INTO `access_log` VALUES (33793, '65.53.15601572198945153', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 17:00:20', 10, 0, '', '2019-06-10 17:00:20');
INSERT INTO `access_log` VALUES (33794, '65.52.15601572220985187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 17:00:22', 12, 0, '', '2019-06-10 17:00:22');
INSERT INTO `access_log` VALUES (33795, '62.87.15601572284204607', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 17:00:28', 22, 0, '', '2019-06-10 17:00:28');
INSERT INTO `access_log` VALUES (33796, '64.85.15601572297564695', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 17:00:30', 9, 0, '', '2019-06-10 17:00:30');
INSERT INTO `access_log` VALUES (33797, '64.77.15601572297564681', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 17:00:30', 11, 0, '', '2019-06-10 17:00:30');
INSERT INTO `access_log` VALUES (33798, '59.72.15601572388954795', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-10 17:00:39', 93, 2001001000, '服务端发生异常', '2019-06-10 17:00:39');
INSERT INTO `access_log` VALUES (33799, '65.3607.15601574525886945', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-10 17:04:13', 5, 1002001012, '访问令牌已过期', '2019-06-10 17:04:13');
INSERT INTO `access_log` VALUES (33800, '65.46.15601574525945179', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-10 17:04:13', 3, 1002001012, '访问令牌已过期', '2019-06-10 17:04:13');
INSERT INTO `access_log` VALUES (33801, '65.53.15601574525975157', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-06-10 17:04:13', 3, 1002001012, '访问令牌已过期', '2019-06-10 17:04:13');
INSERT INTO `access_log` VALUES (33802, '59.72.15601591572454821', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:32:37', 20, 2001001000, '服务端发生异常', '2019-06-10 17:32:37');
INSERT INTO `access_log` VALUES (33803, '59.76.15601591572424815', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:32:37', 125, 0, '', '2019-06-10 17:32:37');
INSERT INTO `access_log` VALUES (33804, '64.78.15601591664924709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:32:46', 10, 0, '', '2019-06-10 17:32:47');
INSERT INTO `access_log` VALUES (33805, '64.85.15601591666704721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:32:47', 2, 0, '', '2019-06-10 17:32:47');
INSERT INTO `access_log` VALUES (33806, '64.77.15601591680474709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:32:48', 2, 0, '', '2019-06-10 17:32:48');
INSERT INTO `access_log` VALUES (33807, '64.82.15601591689444713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:32:49', 2, 0, '', '2019-06-10 17:32:49');
INSERT INTO `access_log` VALUES (33808, '64.79.15601591701734697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:32:50', 2, 0, '', '2019-06-10 17:32:50');
INSERT INTO `access_log` VALUES (33809, '64.83.15601591707854695', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:32:51', 2, 0, '', '2019-06-10 17:32:51');
INSERT INTO `access_log` VALUES (33810, '64.81.15601591720754703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:32:52', 54, 0, '', '2019-06-10 17:32:52');
INSERT INTO `access_log` VALUES (33811, '64.76.15601591726154695', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:32:53', 2, 0, '', '2019-06-10 17:32:53');
INSERT INTO `access_log` VALUES (33812, '64.80.15601591730614699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:32:53', 1, 0, '', '2019-06-10 17:32:53');
INSERT INTO `access_log` VALUES (33813, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:32:54', 13, 0, '', '2019-06-10 17:32:54');
INSERT INTO `access_log` VALUES (33814, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:32:54', 231, 0, '', '2019-06-10 17:32:54');
INSERT INTO `access_log` VALUES (33815, '64.78.15601591800604711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:33:00', 2, 0, '', '2019-06-10 17:33:00');
INSERT INTO `access_log` VALUES (33816, '64.85.15601591802014723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:33:00', 1, 0, '', '2019-06-10 17:33:00');
INSERT INTO `access_log` VALUES (33817, '64.77.15601591811454711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:33:01', 2, 0, '', '2019-06-10 17:33:01');
INSERT INTO `access_log` VALUES (33818, '64.82.15601591818184715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:33:02', 2, 0, '', '2019-06-10 17:33:02');
INSERT INTO `access_log` VALUES (33819, '64.79.15601591821724699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:33:02', 1, 0, '', '2019-06-10 17:33:02');
INSERT INTO `access_log` VALUES (33820, '64.84.15601591825404713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:33:03', 2, 0, '', '2019-06-10 17:33:03');
INSERT INTO `access_log` VALUES (33821, '64.81.15601591862384705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:33:06', 2, 0, '', '2019-06-10 17:33:06');
INSERT INTO `access_log` VALUES (33822, '64.76.15601591863754697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:33:06', 1, 0, '', '2019-06-10 17:33:06');
INSERT INTO `access_log` VALUES (33823, '59.80.15601591874974813', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:33:07', 12, 2001001000, '服务端发生异常', '2019-06-10 17:33:08');
INSERT INTO `access_log` VALUES (33824, '59.79.15601591874974827', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '1.119.186.241', '2019-06-10 17:33:07', 587, 0, '', '2019-06-10 17:33:08');
INSERT INTO `access_log` VALUES (33825, '64.82.15601602944104731', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-10 17:51:34', 9, 1002001012, '访问令牌已过期', '2019-06-10 17:51:34');
INSERT INTO `access_log` VALUES (33826, '64.77.15601602944104727', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-10 17:51:34', 9, 1002001012, '访问令牌已过期', '2019-06-10 17:51:34');
INSERT INTO `access_log` VALUES (33827, '65.53.15601602976795195', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-10 17:51:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 17:51:38');
INSERT INTO `access_log` VALUES (33828, '65.47.15601603133555219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-10 17:51:53', 234, 0, '', '2019-06-10 17:51:54');
INSERT INTO `access_log` VALUES (33829, '65.45.15601603140285231', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-10 17:51:54', 9, 0, '', '2019-06-10 17:51:54');
INSERT INTO `access_log` VALUES (33830, '65.49.15601603140365249', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-10 17:51:54', 8, 0, '', '2019-06-10 17:51:54');
INSERT INTO `access_log` VALUES (33831, '65.54.15601603141435185', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-10 17:51:54', 8, 0, '', '2019-06-10 17:51:54');
INSERT INTO `access_log` VALUES (33832, '64.83.15601603187714713', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-10 17:51:59', 12, 0, '', '2019-06-10 17:51:59');
INSERT INTO `access_log` VALUES (33833, '64.81.15601603187774721', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.65.148.26', '2019-06-10 17:51:59', 8, 0, '', '2019-06-10 17:51:59');
INSERT INTO `access_log` VALUES (33834, '65.51.15601606178405239', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.79.30', '2019-06-10 17:56:58', 1, 1002001015, '账号未登陆', '2019-06-10 17:56:58');
INSERT INTO `access_log` VALUES (33835, '65.3607.15601606178436989', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.79.30', '2019-06-10 17:56:58', 1, 1002001015, '账号未登陆', '2019-06-10 17:56:58');
INSERT INTO `access_log` VALUES (33836, '65.46.15601606178475223', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.79.30', '2019-06-10 17:56:58', 0, 1002001015, '账号未登陆', '2019-06-10 17:56:58');
INSERT INTO `access_log` VALUES (33837, '65.53.15601606197555201', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.79.30', '2019-06-10 17:57:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 17:57:00');
INSERT INTO `access_log` VALUES (33838, '65.47.15601606334605225', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.79.30', '2019-06-10 17:57:13', 54, 0, '', '2019-06-10 17:57:14');
INSERT INTO `access_log` VALUES (33839, '65.50.15601606338085233', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.79.30', '2019-06-10 17:57:14', 11, 0, '', '2019-06-10 17:57:14');
INSERT INTO `access_log` VALUES (33840, '65.45.15601606338125237', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.79.30', '2019-06-10 17:57:14', 10, 0, '', '2019-06-10 17:57:14');
INSERT INTO `access_log` VALUES (33841, '65.49.15601606338165255', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.79.30', '2019-06-10 17:57:14', 10, 0, '', '2019-06-10 17:57:14');
INSERT INTO `access_log` VALUES (33842, '62.89.15601606400564663', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.79.30', '2019-06-10 17:57:20', 22, 0, '', '2019-06-10 17:57:20');
INSERT INTO `access_log` VALUES (33843, '64.85.15601606470964745', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.79.30', '2019-06-10 17:57:27', 9, 0, '', '2019-06-10 17:57:27');
INSERT INTO `access_log` VALUES (33844, '64.78.15601606470934733', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.79.30', '2019-06-10 17:57:27', 12, 0, '', '2019-06-10 17:57:27');
INSERT INTO `access_log` VALUES (33845, '62.83.15601607240794663', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.152.79.30', '2019-06-10 17:58:44', 15, 0, '', '2019-06-10 17:58:44');
INSERT INTO `access_log` VALUES (33846, '59.72.15601607454694843', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.14.135.56', '2019-06-10 17:59:05', 3, 0, '', '2019-06-10 17:59:05');
INSERT INTO `access_log` VALUES (33847, '59.76.15601607454704837', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.14.135.56', '2019-06-10 17:59:05', 13, 2001001000, '服务端发生异常', '2019-06-10 17:59:05');
INSERT INTO `access_log` VALUES (33848, '64.80.15601607511584723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.14.135.56', '2019-06-10 17:59:11', 6, 0, '', '2019-06-10 17:59:11');
INSERT INTO `access_log` VALUES (33849, '64.78.15601607512884735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.14.135.56', '2019-06-10 17:59:11', 3, 0, '', '2019-06-10 17:59:11');
INSERT INTO `access_log` VALUES (33850, '64.85.15601607527124747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.14.135.56', '2019-06-10 17:59:13', 2, 0, '', '2019-06-10 17:59:13');
INSERT INTO `access_log` VALUES (33851, '64.82.15601607535204739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.14.135.56', '2019-06-10 17:59:14', 2, 0, '', '2019-06-10 17:59:14');
INSERT INTO `access_log` VALUES (33852, '59.73.15601607550264847', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.14.135.56', '2019-06-10 17:59:15', 2, 0, '', '2019-06-10 17:59:15');
INSERT INTO `access_log` VALUES (33853, '59.74.15601607550304843', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.14.135.56', '2019-06-10 17:59:15', 11, 2001001000, '服务端发生异常', '2019-06-10 17:59:15');
INSERT INTO `access_log` VALUES (33854, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.88.125.180', '2019-06-10 18:38:40', 9, 0, '', '2019-06-10 18:38:40');
INSERT INTO `access_log` VALUES (33855, '58.87.15601631258074263', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=&keyword=&pageNo=&pageSize=&sortField=&sortOrder=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.88.125.180', '2019-06-10 18:38:46', 426, 2001001000, '服务端发生异常', '2019-06-10 18:38:46');
INSERT INTO `access_log` VALUES (33856, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.88.125.180', '2019-06-10 18:38:50', 8, 0, '', '2019-06-10 18:38:50');
INSERT INTO `access_log` VALUES (33857, '65.3607.15601673946957081', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-10 19:49:55', 20, 1002001012, '访问令牌已过期', '2019-06-10 19:49:55');
INSERT INTO `access_log` VALUES (33858, '65.51.15601673946955331', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-10 19:49:55', 17, 1002001012, '访问令牌已过期', '2019-06-10 19:49:55');
INSERT INTO `access_log` VALUES (33859, '65.46.15601673946955315', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-10 19:49:55', 22, 1002001012, '访问令牌已过期', '2019-06-10 19:49:55');
INSERT INTO `access_log` VALUES (33860, '65.53.15601673963455293', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-10 19:49:56', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 19:49:56');
INSERT INTO `access_log` VALUES (33861, '65.52.15601673989635327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-10 19:49:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 19:49:59');
INSERT INTO `access_log` VALUES (33862, '65.49.15601674259735347', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-10 19:50:26', 93, 0, '', '2019-06-10 19:50:26');
INSERT INTO `access_log` VALUES (33863, '65.45.15601674263675329', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-10 19:50:26', 13, 0, '', '2019-06-10 19:50:26');
INSERT INTO `access_log` VALUES (33864, '65.46.15601674263735317', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-10 19:50:26', 10, 0, '', '2019-06-10 19:50:26');
INSERT INTO `access_log` VALUES (33865, '65.54.15601674263735283', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-10 19:50:26', 11, 0, '', '2019-06-10 19:50:26');
INSERT INTO `access_log` VALUES (33866, '65.3607.15601674325667083', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-10 19:50:33', 89, 0, '', '2019-06-10 19:50:33');
INSERT INTO `access_log` VALUES (33867, '65.51.15601674354945333', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-10 19:50:35', 16, 0, '', '2019-06-10 19:50:36');
INSERT INTO `access_log` VALUES (33868, '65.53.15601674372665295', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-10 19:50:37', 9, 0, '', '2019-06-10 19:50:37');
INSERT INTO `access_log` VALUES (33869, '65.47.15601674390505319', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-10 19:50:39', 12, 0, '', '2019-06-10 19:50:39');
INSERT INTO `access_log` VALUES (33870, '59.73.15601700225834971', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.95.248.108', '2019-06-10 20:33:43', 10, 0, '', '2019-06-10 20:33:43');
INSERT INTO `access_log` VALUES (33871, '59.74.15601700226144967', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.95.248.108', '2019-06-10 20:33:43', 9, 2001001000, '服务端发生异常', '2019-06-10 20:33:43');
INSERT INTO `access_log` VALUES (33872, '64.82.15601700315524863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.95.248.108', '2019-06-10 20:33:52', 11, 0, '', '2019-06-10 20:33:52');
INSERT INTO `access_log` VALUES (33873, '64.77.15601700317264859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.95.248.108', '2019-06-10 20:33:52', 3, 0, '', '2019-06-10 20:33:52');
INSERT INTO `access_log` VALUES (33874, '59.79.15601700334104973', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.95.248.108', '2019-06-10 20:33:53', 4, 0, '', '2019-06-10 20:33:53');
INSERT INTO `access_log` VALUES (33875, '59.77.15601700334154961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.95.248.108', '2019-06-10 20:33:53', 13, 2001001000, '服务端发生异常', '2019-06-10 20:33:53');
INSERT INTO `access_log` VALUES (33876, '59.80.15601720848194987', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:05', 11, 0, '', '2019-06-10 21:08:05');
INSERT INTO `access_log` VALUES (33877, '59.77.15601720848224989', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:05', 22, 2001001000, '服务端发生异常', '2019-06-10 21:08:05');
INSERT INTO `access_log` VALUES (33878, '65.47.15601721031445381', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:23', 0, 1002001015, '账号未登陆', '2019-06-10 21:08:23');
INSERT INTO `access_log` VALUES (33879, '65.52.15601721031465391', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:23', 0, 1002001015, '账号未登陆', '2019-06-10 21:08:23');
INSERT INTO `access_log` VALUES (33880, '65.49.15601721031465413', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:23', 0, 1002001015, '账号未登陆', '2019-06-10 21:08:23');
INSERT INTO `access_log` VALUES (33881, '65.45.15601721063095395', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-10 21:08:26');
INSERT INTO `access_log` VALUES (33882, '65.54.15601721128105349', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:33', 93, 0, '', '2019-06-10 21:08:33');
INSERT INTO `access_log` VALUES (33883, '65.3607.15601721131817147', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:33', 327, 0, '', '2019-06-10 21:08:34');
INSERT INTO `access_log` VALUES (33884, '65.51.15601721131825397', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:33', 326, 0, '', '2019-06-10 21:08:34');
INSERT INTO `access_log` VALUES (33885, '65.46.15601721131875385', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:33', 321, 0, '', '2019-06-10 21:08:34');
INSERT INTO `access_log` VALUES (33886, '65.53.15601721178055359', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:38', 9, 0, '', '2019-06-10 21:08:38');
INSERT INTO `access_log` VALUES (33887, '65.47.15601721178095383', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:38', 108, 0, '', '2019-06-10 21:08:38');
INSERT INTO `access_log` VALUES (33888, '65.52.15601721178165393', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:38', 102, 0, '', '2019-06-10 21:08:38');
INSERT INTO `access_log` VALUES (33889, '62.88.15601721333344819', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:53', 20, 0, '', '2019-06-10 21:08:53');
INSERT INTO `access_log` VALUES (33890, '62.89.15601721364724817', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:56', 14, 0, '', '2019-06-10 21:08:56');
INSERT INTO `access_log` VALUES (33891, '64.79.15601721392144875', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:59', 20, 0, '', '2019-06-10 21:08:59');
INSERT INTO `access_log` VALUES (33892, '64.84.15601721392214889', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:08:59', 15, 0, '', '2019-06-10 21:08:59');
INSERT INTO `access_log` VALUES (33893, '64.81.15601721452104881', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:09:05', 12, 0, '', '2019-06-10 21:09:05');
INSERT INTO `access_log` VALUES (33894, '64.83.15601721452094873', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:09:05', 14, 0, '', '2019-06-10 21:09:05');
INSERT INTO `access_log` VALUES (33895, '64.85.15601721480274901', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:09:08', 10, 0, '', '2019-06-10 21:09:08');
INSERT INTO `access_log` VALUES (33896, '64.78.15601721480264889', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:09:08', 12, 0, '', '2019-06-10 21:09:08');
INSERT INTO `access_log` VALUES (33897, '64.80.15601721480244877', 27, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:09:08', 15, 0, '', '2019-06-10 21:09:08');
INSERT INTO `access_log` VALUES (33898, '59.72.15601721527944997', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:09:13', 12, 0, '', '2019-06-10 21:09:13');
INSERT INTO `access_log` VALUES (33899, '59.76.15601721550424991', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.21.95.0', '2019-06-10 21:09:15', 359, 2001001000, '服务端发生异常', '2019-06-10 21:09:15');
INSERT INTO `access_log` VALUES (33900, '59.79.15601774627125073', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.30.97.173', '2019-06-10 22:37:43', 11, 0, '', '2019-06-10 22:37:43');
INSERT INTO `access_log` VALUES (33901, '59.75.15601774627505073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.30.97.173', '2019-06-10 22:37:43', 13, 2001001000, '服务端发生异常', '2019-06-10 22:37:43');
INSERT INTO `access_log` VALUES (33902, '64.83.15601774669454945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.30.97.173', '2019-06-10 22:37:47', 13, 0, '', '2019-06-10 22:37:47');
INSERT INTO `access_log` VALUES (33903, '64.81.15601774670804953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.30.97.173', '2019-06-10 22:37:47', 3, 0, '', '2019-06-10 22:37:47');
INSERT INTO `access_log` VALUES (33904, '64.76.15601774702114945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.30.97.173', '2019-06-10 22:37:50', 1, 0, '', '2019-06-10 22:37:50');
INSERT INTO `access_log` VALUES (33905, '64.85.15601774703644973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.30.97.173', '2019-06-10 22:37:50', 2, 0, '', '2019-06-10 22:37:50');
INSERT INTO `access_log` VALUES (33906, '59.71.15601774736795071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.30.97.173', '2019-06-10 22:37:54', 4, 0, '', '2019-06-10 22:37:54');
INSERT INTO `access_log` VALUES (33907, '59.72.15601774736795069', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.30.97.173', '2019-06-10 22:37:54', 13, 2001001000, '服务端发生异常', '2019-06-10 22:37:54');
INSERT INTO `access_log` VALUES (33908, '65.54.15601832488875499', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.88.156.209', '2019-06-11 00:14:09', 1, 1002001015, '账号未登陆', '2019-06-11 00:14:09');
INSERT INTO `access_log` VALUES (33909, '65.45.15601832488875545', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.88.156.209', '2019-06-11 00:14:09', 1, 1002001015, '账号未登陆', '2019-06-11 00:14:09');
INSERT INTO `access_log` VALUES (33910, '65.51.15601832489155547', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.88.156.209', '2019-06-11 00:14:09', 0, 1002001015, '账号未登陆', '2019-06-11 00:14:09');
INSERT INTO `access_log` VALUES (33911, '65.53.15601832770275509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.88.156.209', '2019-06-11 00:14:37', 71, 0, '', '2019-06-11 00:14:37');
INSERT INTO `access_log` VALUES (33912, '65.52.15601832775415543', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.88.156.209', '2019-06-11 00:14:38', 14, 0, '', '2019-06-11 00:14:38');
INSERT INTO `access_log` VALUES (33913, '65.47.15601832775425533', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.88.156.209', '2019-06-11 00:14:38', 15, 0, '', '2019-06-11 00:14:38');
INSERT INTO `access_log` VALUES (33914, '65.49.15601832775445565', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.88.156.209', '2019-06-11 00:14:38', 13, 0, '', '2019-06-11 00:14:38');
INSERT INTO `access_log` VALUES (33915, '65.45.15601832946925547', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.88.156.209', '2019-06-11 00:14:55', 7, 0, '', '2019-06-11 00:14:55');
INSERT INTO `access_log` VALUES (33916, '65.51.15601832946925549', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.88.156.209', '2019-06-11 00:14:55', 9, 0, '', '2019-06-11 00:14:55');
INSERT INTO `access_log` VALUES (33917, '65.54.15601832947035501', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.88.156.209', '2019-06-11 00:14:55', 8, 0, '', '2019-06-11 00:14:55');
INSERT INTO `access_log` VALUES (33918, '62.86.15601833059174951', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.88.156.209', '2019-06-11 00:15:06', 30, 0, '', '2019-06-11 00:15:06');
INSERT INTO `access_log` VALUES (33919, '62.85.15601833129414951', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.88.156.209', '2019-06-11 00:15:13', 13, 0, '', '2019-06-11 00:15:13');
INSERT INTO `access_log` VALUES (33920, '62.88.15601833164714969', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.88.156.209', '2019-06-11 00:15:16', 15, 0, '', '2019-06-11 00:15:16');
INSERT INTO `access_log` VALUES (33921, '66.52.15601833290223615', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.88.156.209', '2019-06-11 00:15:29', 27, 0, '', '2019-06-11 00:15:29');
INSERT INTO `access_log` VALUES (33922, '59.80.15602157662155571', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.206.117.178', '2019-06-11 09:16:06', 12, 0, '', '2019-06-11 09:16:06');
INSERT INTO `access_log` VALUES (33923, '59.77.15602157662155573', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.206.117.178', '2019-06-11 09:16:06', 15, 2001001000, '服务端发生异常', '2019-06-11 09:16:06');
INSERT INTO `access_log` VALUES (33924, '64.79.15602157707475459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.206.117.178', '2019-06-11 09:16:11', 10, 0, '', '2019-06-11 09:16:11');
INSERT INTO `access_log` VALUES (33925, '64.84.15602157708465473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.206.117.178', '2019-06-11 09:16:11', 3, 0, '', '2019-06-11 09:16:11');
INSERT INTO `access_log` VALUES (33926, '64.83.15602157750675457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.206.117.178', '2019-06-11 09:16:15', 2, 0, '', '2019-06-11 09:16:15');
INSERT INTO `access_log` VALUES (33927, '64.81.15602157751655465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.206.117.178', '2019-06-11 09:16:15', 2, 0, '', '2019-06-11 09:16:15');
INSERT INTO `access_log` VALUES (33928, '64.76.15602157775755457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.206.117.178', '2019-06-11 09:16:18', 2, 0, '', '2019-06-11 09:16:18');
INSERT INTO `access_log` VALUES (33929, '64.85.15602157781505485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.206.117.178', '2019-06-11 09:16:18', 1, 0, '', '2019-06-11 09:16:18');
INSERT INTO `access_log` VALUES (33930, '59.78.15602157795175583', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.206.117.178', '2019-06-11 09:16:20', 13, 2001001000, '服务端发生异常', '2019-06-11 09:16:20');
INSERT INTO `access_log` VALUES (33931, '59.75.15602157795165585', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.206.117.178', '2019-06-11 09:16:20', 238, 0, '', '2019-06-11 09:16:20');
INSERT INTO `access_log` VALUES (33932, '64.78.15602157824615473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.206.117.178', '2019-06-11 09:16:22', 2, 0, '', '2019-06-11 09:16:22');
INSERT INTO `access_log` VALUES (33933, '64.82.15602157826815477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.206.117.178', '2019-06-11 09:16:23', 2, 0, '', '2019-06-11 09:16:23');
INSERT INTO `access_log` VALUES (33934, '59.72.15602157844565581', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.206.117.178', '2019-06-11 09:16:24', 3, 0, '', '2019-06-11 09:16:24');
INSERT INTO `access_log` VALUES (33935, '59.71.15602157844565583', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.206.117.178', '2019-06-11 09:16:24', 13, 2001001000, '服务端发生异常', '2019-06-11 09:16:24');
INSERT INTO `access_log` VALUES (33936, '65.53.15602176860225969', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.24.14', '2019-06-11 09:48:06', 13, 1002001012, '访问令牌已过期', '2019-06-11 09:48:06');
INSERT INTO `access_log` VALUES (33937, '65.3607.15602176860237757', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.24.14', '2019-06-11 09:48:06', 14, 1002001012, '访问令牌已过期', '2019-06-11 09:48:06');
INSERT INTO `access_log` VALUES (33938, '65.52.15602176860246005', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.24.14', '2019-06-11 09:48:06', 20, 1002001012, '访问令牌已过期', '2019-06-11 09:48:06');
INSERT INTO `access_log` VALUES (33939, '65.49.15602176881446023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.24.14', '2019-06-11 09:48:08', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 09:48:08');
INSERT INTO `access_log` VALUES (33940, '65.50.15602176919376007', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.24.14', '2019-06-11 09:48:12', 5, 1002002000, '账号不存在', '2019-06-11 09:48:12');
INSERT INTO `access_log` VALUES (33941, '59.80.15602180628215603', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.23.69.116', '2019-06-11 09:54:23', 14, 0, '', '2019-06-11 09:54:23');
INSERT INTO `access_log` VALUES (33942, '59.74.15602180628215611', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.23.69.116', '2019-06-11 09:54:23', 18, 2001001000, '服务端发生异常', '2019-06-11 09:54:23');
INSERT INTO `access_log` VALUES (33943, '64.84.15602180682765505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.23.69.116', '2019-06-11 09:54:28', 11, 0, '', '2019-06-11 09:54:28');
INSERT INTO `access_log` VALUES (33944, '64.83.15602180685095489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.23.69.116', '2019-06-11 09:54:29', 3, 0, '', '2019-06-11 09:54:29');
INSERT INTO `access_log` VALUES (33945, '64.81.15602180696555497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.23.69.116', '2019-06-11 09:54:30', 2, 0, '', '2019-06-11 09:54:30');
INSERT INTO `access_log` VALUES (33946, '64.76.15602180702905489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.23.69.116', '2019-06-11 09:54:30', 325, 0, '', '2019-06-11 09:54:31');
INSERT INTO `access_log` VALUES (33947, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.23.69.116', '2019-06-11 09:54:31', 14, 0, '', '2019-06-11 09:54:31');
INSERT INTO `access_log` VALUES (33948, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.23.69.116', '2019-06-11 09:54:32', 12, 0, '', '2019-06-11 09:54:32');
INSERT INTO `access_log` VALUES (33949, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.23.69.116', '2019-06-11 09:54:34', 6, 0, '', '2019-06-11 09:54:34');
INSERT INTO `access_log` VALUES (33950, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.23.69.116', '2019-06-11 09:54:34', 13, 0, '', '2019-06-11 09:54:34');
INSERT INTO `access_log` VALUES (33951, '65.53.15602184891165981', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:01:29', 4, 1002001012, '访问令牌已过期', '2019-06-11 10:01:29');
INSERT INTO `access_log` VALUES (33952, '65.3607.15602184891167769', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:01:29', 5, 1002001012, '访问令牌已过期', '2019-06-11 10:01:29');
INSERT INTO `access_log` VALUES (33953, '65.54.15602184891155971', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:01:29', 5, 1002001012, '访问令牌已过期', '2019-06-11 10:01:29');
INSERT INTO `access_log` VALUES (33954, '65.52.15602184968786017', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:01:37', 88, 0, '', '2019-06-11 10:01:37');
INSERT INTO `access_log` VALUES (33955, '65.49.15602184972406035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:01:37', 9, 0, '', '2019-06-11 10:01:37');
INSERT INTO `access_log` VALUES (33956, '65.50.15602184972426019', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:01:37', 9, 0, '', '2019-06-11 10:01:37');
INSERT INTO `access_log` VALUES (33957, '65.47.15602184972416005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:01:37', 9, 0, '', '2019-06-11 10:01:37');
INSERT INTO `access_log` VALUES (33958, '62.85.15602185060435421', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:01:46', 166, 0, '', '2019-06-11 10:01:46');
INSERT INTO `access_log` VALUES (33959, '64.80.15602185181905499', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:01:58', 10, 0, '', '2019-06-11 10:01:58');
INSERT INTO `access_log` VALUES (33960, '64.85.15602185181875523', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:01:58', 12, 0, '', '2019-06-11 10:01:58');
INSERT INTO `access_log` VALUES (33961, '64.78.15602185234715511', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:02:03', 12, 0, '', '2019-06-11 10:02:03');
INSERT INTO `access_log` VALUES (33962, '64.82.15602185252845515', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:02:05', 9, 0, '', '2019-06-11 10:02:05');
INSERT INTO `access_log` VALUES (33963, '64.79.15602185278375499', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:02:08', 11, 0, '', '2019-06-11 10:02:08');
INSERT INTO `access_log` VALUES (33964, '64.83.15602185341685497', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:02:14', 9, 0, '', '2019-06-11 10:02:14');
INSERT INTO `access_log` VALUES (33965, '64.84.15602185341685513', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:02:14', 11, 0, '', '2019-06-11 10:02:14');
INSERT INTO `access_log` VALUES (33966, '64.80.15602185565235501', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:02:37', 9, 0, '', '2019-06-11 10:02:37');
INSERT INTO `access_log` VALUES (33967, '66.49.15602185738114097', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:02:54', 21, 0, '', '2019-06-11 10:02:54');
INSERT INTO `access_log` VALUES (33968, '66.56.15602185785274085', 27, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=10&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:02:59', 808, 0, '', '2019-06-11 10:02:59');
INSERT INTO `access_log` VALUES (33969, '59.71.15602185845785621', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:03:05', 11, 0, '', '2019-06-11 10:03:05');
INSERT INTO `access_log` VALUES (33970, '65.49.15602185973196037', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:03:17', 27, 0, '', '2019-06-11 10:03:17');
INSERT INTO `access_log` VALUES (33971, '65.47.15602186021156007', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:03:22', 10, 0, '', '2019-06-11 10:03:22');
INSERT INTO `access_log` VALUES (33972, '65.46.15602186054796013', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:03:25', 9, 0, '', '2019-06-11 10:03:25');
INSERT INTO `access_log` VALUES (33973, '65.45.15602186106256025', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:03:31', 13, 0, '', '2019-06-11 10:03:31');
INSERT INTO `access_log` VALUES (33974, '65.53.15602186266115985', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:03:47', 12, 0, '', '2019-06-11 10:03:47');
INSERT INTO `access_log` VALUES (33975, '65.54.15602186320595975', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:03:52', 17, 0, '', '2019-06-11 10:03:52');
INSERT INTO `access_log` VALUES (33976, '65.3607.15602186327937773', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.207.218.246', '2019-06-11 10:03:53', 14, 0, '', '2019-06-11 10:03:53');
INSERT INTO `access_log` VALUES (33977, '65.53.15602200796816003', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:28:00', 0, 1002001015, '账号未登陆', '2019-06-11 10:28:00');
INSERT INTO `access_log` VALUES (33978, '65.54.15602200796825995', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:28:00', 0, 1002001015, '账号未登陆', '2019-06-11 10:28:00');
INSERT INTO `access_log` VALUES (33979, '65.3607.15602200796837793', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:28:00', 0, 1002001015, '账号未登陆', '2019-06-11 10:28:00');
INSERT INTO `access_log` VALUES (33980, '65.52.15602200817416043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:28:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 10:28:02');
INSERT INTO `access_log` VALUES (33981, '65.46.15602201194436035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:28:39', 97, 0, '', '2019-06-11 10:28:40');
INSERT INTO `access_log` VALUES (33982, '65.45.15602201200906047', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:28:40', 11, 0, '', '2019-06-11 10:28:40');
INSERT INTO `access_log` VALUES (33983, '65.53.15602201200906005', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:28:40', 10, 0, '', '2019-06-11 10:28:40');
INSERT INTO `access_log` VALUES (33984, '65.51.15602201200906047', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:28:40', 11, 0, '', '2019-06-11 10:28:40');
INSERT INTO `access_log` VALUES (33985, '62.88.15602201266435461', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:28:47', 14, 0, '', '2019-06-11 10:28:47');
INSERT INTO `access_log` VALUES (33986, '64.79.15602201346695523', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:28:55', 9, 0, '', '2019-06-11 10:28:55');
INSERT INTO `access_log` VALUES (33987, '64.77.15602201346695535', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:28:55', 12, 0, '', '2019-06-11 10:28:55');
INSERT INTO `access_log` VALUES (33988, '64.81.15602201379395527', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:28:58', 9, 0, '', '2019-06-11 10:28:58');
INSERT INTO `access_log` VALUES (33989, '64.84.15602201379385535', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:28:58', 11, 0, '', '2019-06-11 10:28:58');
INSERT INTO `access_log` VALUES (33990, '59.77.15602201547015633', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:29:15', 12, 0, '', '2019-06-11 10:29:15');
INSERT INTO `access_log` VALUES (33991, '59.75.15602201655695645', 27, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:29:26', 268, 0, '', '2019-06-11 10:29:26');
INSERT INTO `access_log` VALUES (33992, '59.76.15602202042495635', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:30:04', 11, 0, '', '2019-06-11 10:30:04');
INSERT INTO `access_log` VALUES (33993, '65.54.15602202814215999', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:31:21', 22, 0, '', '2019-06-11 10:31:21');
INSERT INTO `access_log` VALUES (33994, '65.52.15602202848966047', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:31:25', 9, 0, '', '2019-06-11 10:31:25');
INSERT INTO `access_log` VALUES (33995, '65.49.15602202868106063', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:31:27', 9, 0, '', '2019-06-11 10:31:27');
INSERT INTO `access_log` VALUES (33996, '65.50.15602202881536047', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:31:28', 15, 0, '', '2019-06-11 10:31:28');
INSERT INTO `access_log` VALUES (33997, '65.47.15602202934926033', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.7.64.235', '2019-06-11 10:31:33', 9, 0, '', '2019-06-11 10:31:34');
INSERT INTO `access_log` VALUES (33998, '65.49.15602205522966067', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:35:52', 4, 1002001012, '访问令牌已过期', '2019-06-11 10:35:52');
INSERT INTO `access_log` VALUES (33999, '65.50.15602205522976051', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:35:52', 3, 1002001012, '访问令牌已过期', '2019-06-11 10:35:52');
INSERT INTO `access_log` VALUES (34000, '65.47.15602205522986037', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:35:52', 3, 1002001012, '访问令牌已过期', '2019-06-11 10:35:52');
INSERT INTO `access_log` VALUES (34001, '65.51.15602205590526055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:35:59', 177, 0, '', '2019-06-11 10:35:59');
INSERT INTO `access_log` VALUES (34002, '65.45.15602205594456055', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:35:59', 11, 0, '', '2019-06-11 10:35:59');
INSERT INTO `access_log` VALUES (34003, '65.53.15602205594486013', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:35:59', 9, 0, '', '2019-06-11 10:35:59');
INSERT INTO `access_log` VALUES (34004, '65.54.15602205594486005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:35:59', 9, 0, '', '2019-06-11 10:35:59');
INSERT INTO `access_log` VALUES (34005, '64.84.15602205636485541', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:36:04', 9, 0, '', '2019-06-11 10:36:04');
INSERT INTO `access_log` VALUES (34006, '64.81.15602205636465533', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:36:04', 12, 0, '', '2019-06-11 10:36:04');
INSERT INTO `access_log` VALUES (34007, '64.80.15602205656475531', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:36:06', 157, 0, '', '2019-06-11 10:36:06');
INSERT INTO `access_log` VALUES (34008, '64.83.15602205656475527', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:36:06', 159, 0, '', '2019-06-11 10:36:06');
INSERT INTO `access_log` VALUES (34009, '64.85.15602205696115553', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:36:10', 7, 0, '', '2019-06-11 10:36:10');
INSERT INTO `access_log` VALUES (34010, '64.77.15602205864465543', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:36:26', 8, 0, '', '2019-06-11 10:36:26');
INSERT INTO `access_log` VALUES (34011, '64.82.15602205864455545', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:36:26', 10, 0, '', '2019-06-11 10:36:26');
INSERT INTO `access_log` VALUES (34012, '64.79.15602205878465531', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:36:28', 10, 0, '', '2019-06-11 10:36:28');
INSERT INTO `access_log` VALUES (34013, '64.84.15602205885905543', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:36:29', 10, 0, '', '2019-06-11 10:36:29');
INSERT INTO `access_log` VALUES (34014, '64.81.15602205900385535', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:36:30', 9, 0, '', '2019-06-11 10:36:30');
INSERT INTO `access_log` VALUES (34015, '64.76.15602205942995529', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1&cid=784', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:36:34', 10, 0, '', '2019-06-11 10:36:34');
INSERT INTO `access_log` VALUES (34016, '64.83.15602206015865529', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:36:42', 11, 0, '', '2019-06-11 10:36:42');
INSERT INTO `access_log` VALUES (34017, '64.78.15602206069625543', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:36:47', 9, 0, '', '2019-06-11 10:36:47');
INSERT INTO `access_log` VALUES (34018, '64.85.15602206069615555', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 10:36:47', 10, 0, '', '2019-06-11 10:36:47');
INSERT INTO `access_log` VALUES (34019, '59.73.15602217054585665', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:55:05', 3, 0, '', '2019-06-11 10:55:05');
INSERT INTO `access_log` VALUES (34020, '59.80.15602217054595653', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:55:05', 20, 2001001000, '服务端发生异常', '2019-06-11 10:55:05');
INSERT INTO `access_log` VALUES (34021, '64.81.15602217137335551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:55:14', 3, 0, '', '2019-06-11 10:55:14');
INSERT INTO `access_log` VALUES (34022, '64.76.15602217140615545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:55:14', 2, 0, '', '2019-06-11 10:55:14');
INSERT INTO `access_log` VALUES (34023, '65.46.15602218481966061', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:57:28', 0, 1002001015, '账号未登陆', '2019-06-11 10:57:28');
INSERT INTO `access_log` VALUES (34024, '65.51.15602218481966073', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:57:28', 0, 1002001015, '账号未登陆', '2019-06-11 10:57:28');
INSERT INTO `access_log` VALUES (34025, '65.54.15602218482256023', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:57:28', 0, 1002001015, '账号未登陆', '2019-06-11 10:57:28');
INSERT INTO `access_log` VALUES (34026, '65.50.15602218638436073', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:57:44', 80, 0, '', '2019-06-11 10:57:44');
INSERT INTO `access_log` VALUES (34027, '65.47.15602218642806057', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:57:44', 8, 0, '', '2019-06-11 10:57:44');
INSERT INTO `access_log` VALUES (34028, '65.49.15602218642856087', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:57:44', 9, 0, '', '2019-06-11 10:57:44');
INSERT INTO `access_log` VALUES (34029, '65.54.15602218642886025', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:57:44', 7, 0, '', '2019-06-11 10:57:44');
INSERT INTO `access_log` VALUES (34030, '62.88.15602218738195485', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:57:54', 13, 0, '', '2019-06-11 10:57:54');
INSERT INTO `access_log` VALUES (34031, '64.85.15602218848905573', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:58:05', 357, 0, '', '2019-06-11 10:58:05');
INSERT INTO `access_log` VALUES (34032, '64.83.15602218848875547', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:58:05', 360, 0, '', '2019-06-11 10:58:05');
INSERT INTO `access_log` VALUES (34033, '65.50.15602219259226075', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:58:46', 19, 0, '', '2019-06-11 10:58:46');
INSERT INTO `access_log` VALUES (34034, '65.49.15602219314476089', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:58:51', 12, 0, '', '2019-06-11 10:58:51');
INSERT INTO `access_log` VALUES (34035, '65.54.15602219402676027', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:59:00', 17, 0, '', '2019-06-11 10:59:00');
INSERT INTO `access_log` VALUES (34036, '65.46.15602219480506063', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=15', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:59:08', 9, 0, '', '2019-06-11 10:59:08');
INSERT INTO `access_log` VALUES (34037, '65.53.15602219526676035', 27, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=15&roleIds=1,2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:59:13', 6, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-11 10:59:13');
INSERT INTO `access_log` VALUES (34038, '65.3607.15602219677627823', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:59:28', 10, 0, '', '2019-06-11 10:59:28');
INSERT INTO `access_log` VALUES (34039, '65.52.15602219700646073', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:59:30', 8, 0, '', '2019-06-11 10:59:30');
INSERT INTO `access_log` VALUES (34040, '65.50.15602219717786077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:59:32', 760, 0, '', '2019-06-11 10:59:33');
INSERT INTO `access_log` VALUES (34041, '59.73.15602219752095669', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:59:35', 12, 0, '', '2019-06-11 10:59:35');
INSERT INTO `access_log` VALUES (34042, '66.48.15602219830114141', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 10:59:43', 33, 0, '', '2019-06-11 10:59:43');
INSERT INTO `access_log` VALUES (34043, '65.3607.15602227949027837', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:13:15', 0, 1002001015, '账号未登陆', '2019-06-11 11:13:15');
INSERT INTO `access_log` VALUES (34044, '65.52.15602227949046083', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:13:15', 1, 1002001015, '账号未登陆', '2019-06-11 11:13:15');
INSERT INTO `access_log` VALUES (34045, '65.50.15602227949046089', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:13:15', 1, 1002001015, '账号未登陆', '2019-06-11 11:13:15');
INSERT INTO `access_log` VALUES (34046, '65.46.15602228378086077', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:13:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 11:13:58');
INSERT INTO `access_log` VALUES (34047, '65.51.15602228489066089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:14:09', 57, 0, '', '2019-06-11 11:14:09');
INSERT INTO `access_log` VALUES (34048, '65.50.15602228495986091', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:14:10', 9, 0, '', '2019-06-11 11:14:10');
INSERT INTO `access_log` VALUES (34049, '65.3607.15602228495977839', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:14:10', 11, 0, '', '2019-06-11 11:14:10');
INSERT INTO `access_log` VALUES (34050, '65.45.15602228495976087', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:14:10', 12, 0, '', '2019-06-11 11:14:10');
INSERT INTO `access_log` VALUES (34051, '62.83.15602228606225495', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:14:21', 13, 0, '', '2019-06-11 11:14:21');
INSERT INTO `access_log` VALUES (34052, '62.88.15602228663505499', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:14:26', 16, 0, '', '2019-06-11 11:14:26');
INSERT INTO `access_log` VALUES (34053, '59.80.15602228790145669', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:14:39', 17, 0, '', '2019-06-11 11:14:39');
INSERT INTO `access_log` VALUES (34054, '59.74.15602228867455677', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:14:47', 23, 2001001000, '服务端发生异常', '2019-06-11 11:14:47');
INSERT INTO `access_log` VALUES (34055, '59.79.15602228908205683', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:14:51', 26, 0, '', '2019-06-11 11:14:51');
INSERT INTO `access_log` VALUES (34056, '64.85.15602228935665587', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:14:54', 1179, 0, '', '2019-06-11 11:14:55');
INSERT INTO `access_log` VALUES (34057, '64.77.15602229211825577', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:15:21', 8, 0, '', '2019-06-11 11:15:21');
INSERT INTO `access_log` VALUES (34058, '65.46.15602229233306079', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:15:23', 20, 0, '', '2019-06-11 11:15:23');
INSERT INTO `access_log` VALUES (34059, '59.72.15602229281755679', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:15:28', 9, 0, '', '2019-06-11 11:15:28');
INSERT INTO `access_log` VALUES (34060, '59.71.15602229304615681', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.95.183.116', '2019-06-11 11:15:30', 20, 2001001000, '服务端发生异常', '2019-06-11 11:15:30');
INSERT INTO `access_log` VALUES (34061, '65.45.15602230890886091', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-11 11:18:09', 0, 1002001015, '账号未登陆', '2019-06-11 11:18:09');
INSERT INTO `access_log` VALUES (34062, '65.3607.15602230891017843', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-11 11:18:09', 0, 1002001015, '账号未登陆', '2019-06-11 11:18:09');
INSERT INTO `access_log` VALUES (34063, '65.50.15602230891066095', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-11 11:18:09', 0, 1002001015, '账号未登陆', '2019-06-11 11:18:09');
INSERT INTO `access_log` VALUES (34064, '65.46.15602231517296083', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-11 11:19:12', 91, 0, '', '2019-06-11 11:19:12');
INSERT INTO `access_log` VALUES (34065, '65.53.15602231520826059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-11 11:19:12', 364, 0, '', '2019-06-11 11:19:12');
INSERT INTO `access_log` VALUES (34066, '65.51.15602231531546095', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-11 11:19:13', 9, 0, '', '2019-06-11 11:19:13');
INSERT INTO `access_log` VALUES (34067, '65.45.15602231531586093', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-11 11:19:13', 8, 0, '', '2019-06-11 11:19:13');
INSERT INTO `access_log` VALUES (34068, '65.3607.15602231533127845', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-11 11:19:13', 10, 0, '', '2019-06-11 11:19:13');
INSERT INTO `access_log` VALUES (34069, '62.82.15602231695645497', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-11 11:19:30', 13, 0, '', '2019-06-11 11:19:30');
INSERT INTO `access_log` VALUES (34070, '66.55.15602231824324149', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-11 11:19:42', 16, 0, '', '2019-06-11 11:19:42');
INSERT INTO `access_log` VALUES (34071, '65.45.15602233892416097', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:23:09', 5, 1002001012, '访问令牌已过期', '2019-06-11 11:23:09');
INSERT INTO `access_log` VALUES (34072, '65.53.15602233892416063', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:23:09', 5, 1002001012, '访问令牌已过期', '2019-06-11 11:23:09');
INSERT INTO `access_log` VALUES (34073, '65.51.15602233892456099', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:23:09', 3, 1002001012, '访问令牌已过期', '2019-06-11 11:23:09');
INSERT INTO `access_log` VALUES (34074, '65.3607.15602233984327849', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=udaoyuanma&password=udaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:23:18', 4, 1002002000, '账号不存在', '2019-06-11 11:23:18');
INSERT INTO `access_log` VALUES (34075, '65.49.15602234192326117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:23:39', 78, 0, '', '2019-06-11 11:23:39');
INSERT INTO `access_log` VALUES (34076, '65.47.15602234196336083', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:23:40', 11, 0, '', '2019-06-11 11:23:40');
INSERT INTO `access_log` VALUES (34077, '65.54.15602234196366057', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:23:40', 9, 0, '', '2019-06-11 11:23:40');
INSERT INTO `access_log` VALUES (34078, '65.46.15602234196376089', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:23:40', 9, 0, '', '2019-06-11 11:23:40');
INSERT INTO `access_log` VALUES (34079, '64.76.15602234262065569', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:23:46', 9, 0, '', '2019-06-11 11:23:46');
INSERT INTO `access_log` VALUES (34080, '64.81.15602234262035575', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:23:46', 11, 0, '', '2019-06-11 11:23:46');
INSERT INTO `access_log` VALUES (34081, '64.83.15602234307735569', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:23:51', 8, 0, '', '2019-06-11 11:23:51');
INSERT INTO `access_log` VALUES (34082, '64.85.15602234307715595', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:23:51', 11, 0, '', '2019-06-11 11:23:51');
INSERT INTO `access_log` VALUES (34083, '64.78.15602234402975583', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:24:00', 10, 0, '', '2019-06-11 11:24:00');
INSERT INTO `access_log` VALUES (34084, '59.79.15602234584495691', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:24:18', 4, 0, '', '2019-06-11 11:24:18');
INSERT INTO `access_log` VALUES (34085, '59.75.15602234585905691', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:24:19', 13, 2001001000, '服务端发生异常', '2019-06-11 11:24:19');
INSERT INTO `access_log` VALUES (34086, '64.79.15602234626255573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:24:23', 2, 0, '', '2019-06-11 11:24:23');
INSERT INTO `access_log` VALUES (34087, '64.84.15602234631575585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:24:23', 2, 0, '', '2019-06-11 11:24:23');
INSERT INTO `access_log` VALUES (34088, '64.76.15602234641595571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:24:24', 1, 0, '', '2019-06-11 11:24:24');
INSERT INTO `access_log` VALUES (34089, '64.81.15602234647015577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:24:25', 2, 0, '', '2019-06-11 11:24:25');
INSERT INTO `access_log` VALUES (34090, '65.3607.15602234688467851', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:24:29', 10, 0, '', '2019-06-11 11:24:29');
INSERT INTO `access_log` VALUES (34091, '65.50.15602234688526103', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:24:29', 106, 0, '', '2019-06-11 11:24:29');
INSERT INTO `access_log` VALUES (34092, '65.52.15602234688616097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:24:29', 98, 0, '', '2019-06-11 11:24:29');
INSERT INTO `access_log` VALUES (34093, '62.84.15602234724995489', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:24:32', 15, 0, '', '2019-06-11 11:24:33');
INSERT INTO `access_log` VALUES (34094, '64.83.15602234764145571', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:24:36', 12, 0, '', '2019-06-11 11:24:36');
INSERT INTO `access_log` VALUES (34095, '64.85.15602234764095597', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:24:36', 19, 0, '', '2019-06-11 11:24:36');
INSERT INTO `access_log` VALUES (34096, '64.84.15602235320295587', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:25:32', 14, 0, '', '2019-06-11 11:25:32');
INSERT INTO `access_log` VALUES (34097, '64.79.15602235320285575', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:25:32', 16, 0, '', '2019-06-11 11:25:32');
INSERT INTO `access_log` VALUES (34098, '62.88.15602235438505509', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:25:44', 17, 0, '', '2019-06-11 11:25:44');
INSERT INTO `access_log` VALUES (34099, '66.49.15602235520364165', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:25:52', 11, 0, '', '2019-06-11 11:25:52');
INSERT INTO `access_log` VALUES (34100, '64.85.15602235530285599', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:25:53', 9, 0, '', '2019-06-11 11:25:53');
INSERT INTO `access_log` VALUES (34101, '64.80.15602235530285577', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:25:53', 12, 0, '', '2019-06-11 11:25:53');
INSERT INTO `access_log` VALUES (34102, '64.78.15602235600325587', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:26:00', 98, 0, '', '2019-06-11 11:26:00');
INSERT INTO `access_log` VALUES (34103, '64.83.15602235600315573', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 11:26:00', 99, 0, '', '2019-06-11 11:26:00');
INSERT INTO `access_log` VALUES (34104, '64.82.15602235608085591', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:26:01', 8, 0, '', '2019-06-11 11:26:01');
INSERT INTO `access_log` VALUES (34105, '64.77.15602235608055589', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:26:01', 11, 0, '', '2019-06-11 11:26:01');
INSERT INTO `access_log` VALUES (34106, '64.76.15602235675795575', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:26:08', 8, 0, '', '2019-06-11 11:26:08');
INSERT INTO `access_log` VALUES (34107, '64.84.15602235675775589', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:26:08', 11, 0, '', '2019-06-11 11:26:08');
INSERT INTO `access_log` VALUES (34108, '64.80.15602235789205579', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:26:19', 7, 0, '', '2019-06-11 11:26:19');
INSERT INTO `access_log` VALUES (34109, '64.81.15602235789185581', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:26:19', 11, 0, '', '2019-06-11 11:26:19');
INSERT INTO `access_log` VALUES (34110, '64.78.15602235843675589', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:26:24', 8, 0, '', '2019-06-11 11:26:24');
INSERT INTO `access_log` VALUES (34111, '64.83.15602235843665575', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:26:24', 11, 0, '', '2019-06-11 11:26:24');
INSERT INTO `access_log` VALUES (34112, '65.47.15602237925876089', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:29:53', 1, 1002001015, '账号未登陆', '2019-06-11 11:29:53');
INSERT INTO `access_log` VALUES (34113, '65.54.15602237925876063', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:29:53', 0, 1002001015, '账号未登陆', '2019-06-11 11:29:53');
INSERT INTO `access_log` VALUES (34114, '65.46.15602237925866095', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:29:53', 1, 1002001015, '账号未登陆', '2019-06-11 11:29:53');
INSERT INTO `access_log` VALUES (34115, '65.51.15602237994156107', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:29:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 11:29:59');
INSERT INTO `access_log` VALUES (34116, '65.53.15602239498896073', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:32:30', 1, 1002001015, '账号未登陆', '2019-06-11 11:32:30');
INSERT INTO `access_log` VALUES (34117, '65.3607.15602239498967859', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:32:30', 0, 1002001015, '账号未登陆', '2019-06-11 11:32:30');
INSERT INTO `access_log` VALUES (34118, '65.52.15602239499046105', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:32:30', 0, 1002001015, '账号未登陆', '2019-06-11 11:32:30');
INSERT INTO `access_log` VALUES (34119, '65.50.15602239540356111', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:32:34', 406, 0, '', '2019-06-11 11:32:34');
INSERT INTO `access_log` VALUES (34120, '65.49.15602239547256127', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:32:35', 131, 0, '', '2019-06-11 11:32:35');
INSERT INTO `access_log` VALUES (34121, '65.47.15602239547356093', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:32:35', 122, 0, '', '2019-06-11 11:32:35');
INSERT INTO `access_log` VALUES (34122, '65.46.15602239547326099', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:32:35', 125, 0, '', '2019-06-11 11:32:35');
INSERT INTO `access_log` VALUES (34123, '62.85.15602239589305497', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:32:39', 13, 0, '', '2019-06-11 11:32:39');
INSERT INTO `access_log` VALUES (34124, '64.85.15602239707665607', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:32:51', 10, 0, '', '2019-06-11 11:32:51');
INSERT INTO `access_log` VALUES (34125, '64.81.15602239707655587', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:32:51', 11, 0, '', '2019-06-11 11:32:51');
INSERT INTO `access_log` VALUES (34126, '64.78.15602239744935595', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:32:54', 10, 0, '', '2019-06-11 11:32:55');
INSERT INTO `access_log` VALUES (34127, '64.77.15602239833685597', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:33:03', 17, 0, '', '2019-06-11 11:33:03');
INSERT INTO `access_log` VALUES (34128, '64.83.15602239833675581', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:33:03', 19, 0, '', '2019-06-11 11:33:03');
INSERT INTO `access_log` VALUES (34129, '64.85.15602240363465609', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:33:56', 8, 0, '', '2019-06-11 11:33:56');
INSERT INTO `access_log` VALUES (34130, '64.80.15602240363445587', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.42.254', '2019-06-11 11:33:56', 11, 0, '', '2019-06-11 11:33:56');
INSERT INTO `access_log` VALUES (34131, '59.79.15602241783915701', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-11 11:36:18', 13, 0, '', '2019-06-11 11:36:18');
INSERT INTO `access_log` VALUES (34132, '65.3607.15602243187677865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:38:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 11:38:39');
INSERT INTO `access_log` VALUES (34133, '65.50.15602243210616117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:38:41', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 11:38:41');
INSERT INTO `access_log` VALUES (34134, '65.54.15602243506006073', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:39:11', 1, 1002001015, '账号未登陆', '2019-06-11 11:39:11');
INSERT INTO `access_log` VALUES (34135, '65.47.15602243505996099', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:39:11', 1, 1002001015, '账号未登陆', '2019-06-11 11:39:11');
INSERT INTO `access_log` VALUES (34136, '65.45.15602243506096115', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:39:11', 0, 1002001015, '账号未登陆', '2019-06-11 11:39:11');
INSERT INTO `access_log` VALUES (34137, '65.51.15602243527606117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:39:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 11:39:13');
INSERT INTO `access_log` VALUES (34138, '65.53.15602243595306081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:39:20', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 11:39:20');
INSERT INTO `access_log` VALUES (34139, '65.52.15602243675196113', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:39:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 11:39:28');
INSERT INTO `access_log` VALUES (34140, '65.50.15602243739496119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:39:34', 72, 0, '', '2019-06-11 11:39:34');
INSERT INTO `access_log` VALUES (34141, '65.49.15602243742716135', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:39:34', 268, 0, '', '2019-06-11 11:39:35');
INSERT INTO `access_log` VALUES (34142, '65.46.15602243742696107', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:39:34', 272, 0, '', '2019-06-11 11:39:35');
INSERT INTO `access_log` VALUES (34143, '65.54.15602243742736075', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:39:34', 269, 0, '', '2019-06-11 11:39:35');
INSERT INTO `access_log` VALUES (34144, '65.45.15602243817786117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=RPsa2GHjTNs8pxEU&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:39:42', 143, 0, '', '2019-06-11 11:39:42');
INSERT INTO `access_log` VALUES (34145, '65.51.15602243821126119', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:39:42', 8, 0, '', '2019-06-11 11:39:42');
INSERT INTO `access_log` VALUES (34146, '65.53.15602243821366083', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:39:42', 10, 0, '', '2019-06-11 11:39:42');
INSERT INTO `access_log` VALUES (34147, '65.3607.15602243822227869', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:39:42', 10, 0, '', '2019-06-11 11:39:42');
INSERT INTO `access_log` VALUES (34148, '62.85.15602243840645503', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:39:44', 17, 0, '', '2019-06-11 11:39:44');
INSERT INTO `access_log` VALUES (34149, '62.88.15602243876675521', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:39:48', 15, 0, '', '2019-06-11 11:39:48');
INSERT INTO `access_log` VALUES (34150, '62.89.15602243889705519', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:39:49', 12, 0, '', '2019-06-11 11:39:49');
INSERT INTO `access_log` VALUES (34151, '65.50.15602243954186121', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:39:55', 20, 0, '', '2019-06-11 11:39:55');
INSERT INTO `access_log` VALUES (34152, '62.82.15602243988775515', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:39:59', 790, 0, '', '2019-06-11 11:40:00');
INSERT INTO `access_log` VALUES (34153, '59.80.15602244085085691', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:40:09', 11, 0, '', '2019-06-11 11:40:09');
INSERT INTO `access_log` VALUES (34154, '59.74.15602244183235699', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:40:18', 25, 2001001000, '服务端发生异常', '2019-06-11 11:40:18');
INSERT INTO `access_log` VALUES (34155, '59.79.15602244210555705', 27, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:40:21', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-11 11:40:21');
INSERT INTO `access_log` VALUES (34156, '65.49.15602244234236137', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:40:23', 19, 0, '', '2019-06-11 11:40:23');
INSERT INTO `access_log` VALUES (34157, '65.47.15602244303936103', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:40:30', 10, 0, '', '2019-06-11 11:40:30');
INSERT INTO `access_log` VALUES (34158, '65.45.15602244324666119', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:40:32', 9, 0, '', '2019-06-11 11:40:32');
INSERT INTO `access_log` VALUES (34159, '65.51.15602244434786121', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:40:43', 14, 0, '', '2019-06-11 11:40:43');
INSERT INTO `access_log` VALUES (34160, '65.3607.15602244491057871', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:40:49', 98, 0, '', '2019-06-11 11:40:49');
INSERT INTO `access_log` VALUES (34161, '65.52.15602244502176117', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:40:50', 10, 0, '', '2019-06-11 11:40:50');
INSERT INTO `access_log` VALUES (34162, '65.50.15602244520466123', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:40:52', 14, 0, '', '2019-06-11 11:40:52');
INSERT INTO `access_log` VALUES (34163, '64.77.15602245088575605', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:41:49', 11, 0, '', '2019-06-11 11:41:49');
INSERT INTO `access_log` VALUES (34164, '64.78.15602245088565603', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:41:49', 12, 0, '', '2019-06-11 11:41:49');
INSERT INTO `access_log` VALUES (34165, '64.79.15602245137115593', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:41:54', 8, 0, '', '2019-06-11 11:41:54');
INSERT INTO `access_log` VALUES (34166, '64.82.15602245137085607', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.204.202.55', '2019-06-11 11:41:54', 11, 0, '', '2019-06-11 11:41:54');
INSERT INTO `access_log` VALUES (34167, '64.82.15602247804095611', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:46:20', 12, 0, '', '2019-06-11 11:46:20');
INSERT INTO `access_log` VALUES (34168, '64.83.15602247804095593', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.49.131.138', '2019-06-11 11:46:20', 16, 0, '', '2019-06-11 11:46:20');
INSERT INTO `access_log` VALUES (34169, '65.51.15602317284686219', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:42:08', 0, 1002001015, '账号未登陆', '2019-06-11 13:42:08');
INSERT INTO `access_log` VALUES (34170, '65.53.15602317284676183', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:42:08', 0, 1002001015, '账号未登陆', '2019-06-11 13:42:08');
INSERT INTO `access_log` VALUES (34171, '65.3607.15602317284687969', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:42:08', 1, 1002001015, '账号未登陆', '2019-06-11 13:42:08');
INSERT INTO `access_log` VALUES (34172, '65.50.15602317310976221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:42:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 13:42:11');
INSERT INTO `access_log` VALUES (34173, '65.49.15602317450406237', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:42:25', 89, 0, '', '2019-06-11 13:42:25');
INSERT INTO `access_log` VALUES (34174, '65.54.15602317455466177', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:42:26', 13, 0, '', '2019-06-11 13:42:26');
INSERT INTO `access_log` VALUES (34175, '65.47.15602317455476203', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:42:26', 12, 0, '', '2019-06-11 13:42:26');
INSERT INTO `access_log` VALUES (34176, '65.45.15602317455516219', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:42:26', 9, 0, '', '2019-06-11 13:42:26');
INSERT INTO `access_log` VALUES (34177, '62.85.15602317522905613', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:42:32', 21, 0, '', '2019-06-11 13:42:32');
INSERT INTO `access_log` VALUES (34178, '64.78.15602317595625701', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:42:40', 17, 0, '', '2019-06-11 13:42:40');
INSERT INTO `access_log` VALUES (34179, '64.77.15602317595625703', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:42:40', 21, 0, '', '2019-06-11 13:42:40');
INSERT INTO `access_log` VALUES (34180, '64.83.15602317619235687', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:42:42', 12, 0, '', '2019-06-11 13:42:42');
INSERT INTO `access_log` VALUES (34181, '64.79.15602317619235691', 27, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:42:42', 14, 0, '', '2019-06-11 13:42:42');
INSERT INTO `access_log` VALUES (34182, '59.75.15602317816115803', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:43:02', 21, 0, '', '2019-06-11 13:43:02');
INSERT INTO `access_log` VALUES (34183, '65.51.15602317854486221', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:43:05', 18, 0, '', '2019-06-11 13:43:05');
INSERT INTO `access_log` VALUES (34184, '65.50.15602317898596223', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:43:10', 19, 0, '', '2019-06-11 13:43:10');
INSERT INTO `access_log` VALUES (34185, '65.46.15602317927896211', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:43:13', 9, 0, '', '2019-06-11 13:43:13');
INSERT INTO `access_log` VALUES (34186, '65.49.15602317954916239', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:43:15', 13, 0, '', '2019-06-11 13:43:16');
INSERT INTO `access_log` VALUES (34187, '64.80.15602318254555693', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3469.400', '61.140.124.166', '2019-06-11 13:43:45', 9, 0, '', '2019-06-11 13:43:45');
INSERT INTO `access_log` VALUES (34188, '65.53.15602323111286193', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:51:51', 3, 1002001012, '访问令牌已过期', '2019-06-11 13:51:51');
INSERT INTO `access_log` VALUES (34189, '65.51.15602323131636229', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:51:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 13:51:53');
INSERT INTO `access_log` VALUES (34190, '65.50.15602323198686231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:52:00', 89, 0, '', '2019-06-11 13:52:00');
INSERT INTO `access_log` VALUES (34191, '65.46.15602323202126219', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:52:00', 17, 0, '', '2019-06-11 13:52:00');
INSERT INTO `access_log` VALUES (34192, '65.49.15602323202156247', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:52:00', 17, 0, '', '2019-06-11 13:52:00');
INSERT INTO `access_log` VALUES (34193, '65.45.15602323202176229', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:52:00', 9, 0, '', '2019-06-11 13:52:00');
INSERT INTO `access_log` VALUES (34194, '65.47.15602323231096213', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:52:03', 9, 0, '', '2019-06-11 13:52:03');
INSERT INTO `access_log` VALUES (34195, '65.3607.15602323335657981', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:52:14', 9, 0, '', '2019-06-11 13:52:14');
INSERT INTO `access_log` VALUES (34196, '65.53.15602323357546195', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:52:16', 9, 0, '', '2019-06-11 13:52:16');
INSERT INTO `access_log` VALUES (34197, '65.46.15602323873646221', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:53:07', 20, 0, '', '2019-06-11 13:53:07');
INSERT INTO `access_log` VALUES (34198, '65.54.15602324332926189', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:53:53', 10, 0, '', '2019-06-11 13:53:53');
INSERT INTO `access_log` VALUES (34199, '65.3607.15602324332977983', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:53:53', 9, 0, '', '2019-06-11 13:53:53');
INSERT INTO `access_log` VALUES (34200, '65.53.15602324333006197', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:53:53', 10, 0, '', '2019-06-11 13:53:53');
INSERT INTO `access_log` VALUES (34201, '65.52.15602324452606229', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:54:05', 10, 0, '', '2019-06-11 13:54:05');
INSERT INTO `access_log` VALUES (34202, '65.50.15602324452656235', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:54:05', 9, 0, '', '2019-06-11 13:54:05');
INSERT INTO `access_log` VALUES (34203, '65.46.15602324452656223', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:54:05', 9, 0, '', '2019-06-11 13:54:05');
INSERT INTO `access_log` VALUES (34204, '65.49.15602324575466251', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:54:18', 116, 0, '', '2019-06-11 13:54:18');
INSERT INTO `access_log` VALUES (34205, '65.47.15602324627646217', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:54:23', 12, 0, '', '2019-06-11 13:54:23');
INSERT INTO `access_log` VALUES (34206, '65.54.15602324726456191', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=11', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:54:33', 108, 0, '', '2019-06-11 13:54:33');
INSERT INTO `access_log` VALUES (34207, '65.53.15602324764356199', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=14', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:54:36', 9, 0, '', '2019-06-11 13:54:36');
INSERT INTO `access_log` VALUES (34208, '65.46.15602324870296225', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:54:47', 10, 0, '', '2019-06-11 13:54:47');
INSERT INTO `access_log` VALUES (34209, '65.50.15602324987236237', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:54:59', 817, 0, '', '2019-06-11 13:55:00');
INSERT INTO `access_log` VALUES (34210, '65.47.15602325321106219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:55:32', 88, 0, '', '2019-06-11 13:55:32');
INSERT INTO `access_log` VALUES (34211, '65.3607.15602325325127987', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:55:33', 7, 0, '', '2019-06-11 13:55:33');
INSERT INTO `access_log` VALUES (34212, '65.54.15602325325186193', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:55:33', 8, 0, '', '2019-06-11 13:55:33');
INSERT INTO `access_log` VALUES (34213, '65.53.15602325325196201', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:55:33', 8, 0, '', '2019-06-11 13:55:33');
INSERT INTO `access_log` VALUES (34214, '65.50.15602325802006239', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:56:20', 20, 0, '', '2019-06-11 13:56:20');
INSERT INTO `access_log` VALUES (34215, '65.49.15602325938626255', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:56:34', 12, 0, '', '2019-06-11 13:56:34');
INSERT INTO `access_log` VALUES (34216, '65.3607.15602326187837989', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:56:59', 12, 0, '', '2019-06-11 13:56:59');
INSERT INTO `access_log` VALUES (34217, '65.54.15602326228826195', 27, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=5&roleIds=1,2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:57:03', 7, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-11 13:57:03');
INSERT INTO `access_log` VALUES (34218, '65.49.15602326972586257', 27, 2, 'admin-application', '/admin-api/admins/admin/update', 'id=5&username=mimangxiaodai&nickname=迷茫小呆&password=123456', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:58:17', 7, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-11 13:58:17');
INSERT INTO `access_log` VALUES (34219, '65.53.15602327059116205', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 13:58:26', 4, 0, '', '2019-06-11 13:58:26');
INSERT INTO `access_log` VALUES (34220, '65.3607.15602327117167991', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.82.145', '2019-06-11 13:58:32', 4, 0, '', '2019-06-11 13:58:32');
INSERT INTO `access_log` VALUES (34221, '65.46.15602327390236231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:58:59', 505, 0, '', '2019-06-11 13:59:00');
INSERT INTO `access_log` VALUES (34222, '65.52.15602327397656237', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:59:00', 9, 0, '', '2019-06-11 13:59:00');
INSERT INTO `access_log` VALUES (34223, '65.50.15602327397716243', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:59:00', 9, 0, '', '2019-06-11 13:59:00');
INSERT INTO `access_log` VALUES (34224, '65.45.15602327397716241', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:59:00', 9, 0, '', '2019-06-11 13:59:00');
INSERT INTO `access_log` VALUES (34225, '65.49.15602327481726259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:59:08', 84, 0, '', '2019-06-11 13:59:08');
INSERT INTO `access_log` VALUES (34226, '65.47.15602327484586225', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:59:08', 9, 0, '', '2019-06-11 13:59:08');
INSERT INTO `access_log` VALUES (34227, '65.53.15602327484726207', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:59:08', 9, 0, '', '2019-06-11 13:59:08');
INSERT INTO `access_log` VALUES (34228, '65.3607.15602327484727993', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 13:59:08', 8, 0, '', '2019-06-11 13:59:08');
INSERT INTO `access_log` VALUES (34229, '65.52.15602330869996243', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.204.59.157', '2019-06-11 14:04:47', 1, 1002001015, '账号未登陆', '2019-06-11 14:04:47');
INSERT INTO `access_log` VALUES (34230, '65.50.15602330870006249', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.204.59.157', '2019-06-11 14:04:47', 0, 1002001015, '账号未登陆', '2019-06-11 14:04:47');
INSERT INTO `access_log` VALUES (34231, '65.45.15602330870056247', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.204.59.157', '2019-06-11 14:04:47', 0, 1002001015, '账号未登陆', '2019-06-11 14:04:47');
INSERT INTO `access_log` VALUES (34232, '65.49.15602330899916265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.204.59.157', '2019-06-11 14:04:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 14:04:50');
INSERT INTO `access_log` VALUES (34233, '65.3607.15602331045067999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuma&password=yudaoyuma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.204.59.157', '2019-06-11 14:05:05', 4, 1002002000, '账号不存在', '2019-06-11 14:05:05');
INSERT INTO `access_log` VALUES (34234, '65.53.15602332278776215', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-11 14:07:08', 4, 1002001012, '访问令牌已过期', '2019-06-11 14:07:08');
INSERT INTO `access_log` VALUES (34235, '65.3607.15602332278808001', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-11 14:07:08', 2, 1002001012, '访问令牌已过期', '2019-06-11 14:07:08');
INSERT INTO `access_log` VALUES (34236, '65.47.15602332278876233', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-11 14:07:08', 3, 1002001012, '访问令牌已过期', '2019-06-11 14:07:08');
INSERT INTO `access_log` VALUES (34237, '65.51.15602332341516251', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-11 14:07:14', 94, 0, '', '2019-06-11 14:07:14');
INSERT INTO `access_log` VALUES (34238, '65.46.15602332344486241', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-11 14:07:14', 20, 0, '', '2019-06-11 14:07:14');
INSERT INTO `access_log` VALUES (34239, '65.45.15602332344546251', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-11 14:07:14', 20, 0, '', '2019-06-11 14:07:14');
INSERT INTO `access_log` VALUES (34240, '65.52.15602332344676247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-11 14:07:14', 8, 0, '', '2019-06-11 14:07:14');
INSERT INTO `access_log` VALUES (34241, '64.82.15602332398035725', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-11 14:07:20', 10, 0, '', '2019-06-11 14:07:20');
INSERT INTO `access_log` VALUES (34242, '64.83.15602332398035707', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-11 14:07:20', 12, 0, '', '2019-06-11 14:07:20');
INSERT INTO `access_log` VALUES (34243, '65.54.15602333117936209', 27, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-11 14:08:32', 3, 0, '', '2019-06-11 14:08:32');
INSERT INTO `access_log` VALUES (34244, '64.77.15602333135655725', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=aa&sellPoint=1&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/e6be4977-6e77-4fe8-b73d-851e48b4fe6e&skuStr=[{\"attrs\":[1,3],\"price\":100,\"quantity\":2},{\"attrs\":[1,3],\"price\":300,\"quantity\":4},{\"attrs\":[2,4],\"price\":500,\"quantity\":6},{\"attrs\":[2,4],\"price\":700,\"quantity\":8}]&description=<p>1</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-11 14:08:34', 8, 1002002009, NULL, '2019-06-11 14:08:34');
INSERT INTO `access_log` VALUES (34245, '65.45.15602333326016253', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:08:53', 18, 0, '', '2019-06-11 14:08:53');
INSERT INTO `access_log` VALUES (34246, '65.52.15602333480426249', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=腾讯QQ	', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:09:08', 16, 0, '', '2019-06-11 14:09:08');
INSERT INTO `access_log` VALUES (34247, '65.49.15602333574636271', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:09:17', 25, 0, '', '2019-06-11 14:09:17');
INSERT INTO `access_log` VALUES (34248, '65.47.15602333642236237', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=管理员', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:09:24', 19, 0, '', '2019-06-11 14:09:24');
INSERT INTO `access_log` VALUES (34249, '64.76.15602333669155711', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=aa&sellPoint=1&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/e6be4977-6e77-4fe8-b73d-851e48b4fe6e&skuStr=[{\"attrs\":[1,3],\"price\":1000,\"quantity\":20},{\"attrs\":[1,3],\"price\":3000,\"quantity\":40},{\"attrs\":[2,4],\"price\":5000,\"quantity\":60},{\"attrs\":[2,4],\"price\":7000,\"quantity\":80}]&description=<p>1</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-11 14:09:27', 7, 1002002009, NULL, '2019-06-11 14:09:27');
INSERT INTO `access_log` VALUES (34250, '65.46.15602334369066245', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:10:37', 20, 0, '', '2019-06-11 14:10:37');
INSERT INTO `access_log` VALUES (34251, '64.79.15602334533415715', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=aa&sellPoint=1&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/e6be4977-6e77-4fe8-b73d-851e48b4fe6e&skuStr=[{\"attrs\":[1,3],\"price\":100,\"quantity\":1},{\"attrs\":[1,3],\"price\":100,\"quantity\":1},{\"attrs\":[2,3],\"price\":100,\"quantity\":1},{\"attrs\":[2,4],\"price\":100,\"quantity\":1},{\"attrs\":[5,4],\"price\":100,\"quantity\":1},{\"attrs\":[5,4],\"price\":100,\"quantity\":1}]&description=<p>1</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-11 14:10:53', 8, 1002002009, NULL, '2019-06-11 14:10:53');
INSERT INTO `access_log` VALUES (34252, '65.49.15602334674326273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:11:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 14:11:07');
INSERT INTO `access_log` VALUES (34253, '65.47.15602334783416239', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:11:18', 215, 0, '', '2019-06-11 14:11:19');
INSERT INTO `access_log` VALUES (34254, '65.53.15602334787856221', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:11:19', 9, 0, '', '2019-06-11 14:11:19');
INSERT INTO `access_log` VALUES (34255, '65.54.15602334787866213', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:11:19', 9, 0, '', '2019-06-11 14:11:19');
INSERT INTO `access_log` VALUES (34256, '65.51.15602334787916257', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:11:19', 9, 0, '', '2019-06-11 14:11:19');
INSERT INTO `access_log` VALUES (34257, '65.52.15602335077976253', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:11:48', 18, 0, '', '2019-06-11 14:11:48');
INSERT INTO `access_log` VALUES (34258, '64.81.15602335439105719', 27, 2, 'product-application', '/product-api/admins/spu/add', 'name=aa&sellPoint=1&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/e6be4977-6e77-4fe8-b73d-851e48b4fe6e&skuStr=[{\"attrs\":[1,4],\"price\":100,\"quantity\":1},{\"attrs\":[2,4],\"price\":100,\"quantity\":1},{\"attrs\":[5,4],\"price\":100,\"quantity\":1},{\"attrs\":[11,4],\"price\":100,\"quantity\":1},{\"attrs\":[12,4],\"price\":100,\"quantity\":1},{\"attrs\":[13,4],\"price\":100,\"quantity\":1},{\"attrs\":[14,4],\"price\":100,\"quantity\":1},{\"attrs\":[15,4],\"price\":100,\"quantity\":1}]&description=<p>1</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-11 14:12:24', 8, 1002002009, NULL, '2019-06-11 14:12:24');
INSERT INTO `access_log` VALUES (34259, '59.73.15602346762225841', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:31:16', 15, 0, '', '2019-06-11 14:31:16');
INSERT INTO `access_log` VALUES (34260, '59.76.15602346762225831', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:31:16', 18, 2001001000, '服务端发生异常', '2019-06-11 14:31:16');
INSERT INTO `access_log` VALUES (34261, '64.76.15602346786795729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:31:19', 3, 0, '', '2019-06-11 14:31:19');
INSERT INTO `access_log` VALUES (34262, '64.84.15602346787875743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:31:19', 2, 0, '', '2019-06-11 14:31:19');
INSERT INTO `access_log` VALUES (34263, '64.80.15602346820575733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:31:22', 1, 0, '', '2019-06-11 14:31:22');
INSERT INTO `access_log` VALUES (34264, '64.81.15602346821645735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:31:22', 2, 0, '', '2019-06-11 14:31:22');
INSERT INTO `access_log` VALUES (34265, '59.77.15602346838575831', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:31:24', 13, 2001001000, '服务端发生异常', '2019-06-11 14:31:24');
INSERT INTO `access_log` VALUES (34266, '59.74.15602346838575837', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:31:24', 51, 0, '', '2019-06-11 14:31:24');
INSERT INTO `access_log` VALUES (34267, '64.77.15602346874145745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:31:27', 2, 0, '', '2019-06-11 14:31:27');
INSERT INTO `access_log` VALUES (34268, '64.78.15602346875285743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:31:28', 2, 0, '', '2019-06-11 14:31:28');
INSERT INTO `access_log` VALUES (34269, '59.79.15602346897065843', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:31:30', 3, 0, '', '2019-06-11 14:31:30');
INSERT INTO `access_log` VALUES (34270, '59.75.15602346897065843', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:31:30', 19, 2001001000, '服务端发生异常', '2019-06-11 14:31:30');
INSERT INTO `access_log` VALUES (34271, '65.50.15602350001146279', 27, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:36:40', 15, 0, '', '2019-06-11 14:36:40');
INSERT INTO `access_log` VALUES (34272, '65.49.15602350013656295', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:36:41', 135, 0, '', '2019-06-11 14:36:42');
INSERT INTO `access_log` VALUES (34273, '65.52.15602351163566275', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '106.38.115.20', '2019-06-11 14:38:36', 0, 1002001015, '账号未登陆', '2019-06-11 14:38:36');
INSERT INTO `access_log` VALUES (34274, '65.50.15602351163616281', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '106.38.115.20', '2019-06-11 14:38:36', 0, 1002001015, '账号未登陆', '2019-06-11 14:38:36');
INSERT INTO `access_log` VALUES (34275, '65.49.15602351163706297', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '106.38.115.20', '2019-06-11 14:38:36', 0, 1002001015, '账号未登陆', '2019-06-11 14:38:36');
INSERT INTO `access_log` VALUES (34276, '59.79.15602351166325849', 0, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Dash/4.6.2 Xcode/8.3.3', '106.38.115.20', '2019-06-11 14:38:37', 0, 1002001015, '账号未登陆', '2019-06-11 14:38:37');
INSERT INTO `access_log` VALUES (34277, '65.3607.15602352632008033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:41:03', 63, 0, '', '2019-06-11 14:41:03');
INSERT INTO `access_log` VALUES (34278, '65.47.15602352634766265', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:41:03', 9, 0, '', '2019-06-11 14:41:03');
INSERT INTO `access_log` VALUES (34279, '65.51.15602352634806283', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:41:03', 9, 0, '', '2019-06-11 14:41:03');
INSERT INTO `access_log` VALUES (34280, '65.53.15602352634856247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:41:03', 8, 0, '', '2019-06-11 14:41:03');
INSERT INTO `access_log` VALUES (34281, '65.45.15602352833436283', 27, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:41:23', 8, 0, '', '2019-06-11 14:41:23');
INSERT INTO `access_log` VALUES (34282, '65.50.15602352861486285', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:41:26', 9, 0, '', '2019-06-11 14:41:26');
INSERT INTO `access_log` VALUES (34283, '65.52.15602352963676279', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:41:36', 18, 0, '', '2019-06-11 14:41:36');
INSERT INTO `access_log` VALUES (34284, '65.3607.15602353070638035', 27, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:41:47', 8, 0, '', '2019-06-11 14:41:47');
INSERT INTO `access_log` VALUES (34285, '65.53.15602353092836249', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:41:49', 1, 1002001015, '账号未登陆', '2019-06-11 14:41:49');
INSERT INTO `access_log` VALUES (34286, '65.51.15602353092826285', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:41:49', 0, 1002001015, '账号未登陆', '2019-06-11 14:41:49');
INSERT INTO `access_log` VALUES (34287, '65.47.15602353092866267', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:41:49', 0, 1002001015, '账号未登陆', '2019-06-11 14:41:49');
INSERT INTO `access_log` VALUES (34288, '65.54.15602353135786241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:41:54', 104, 0, '', '2019-06-11 14:41:54');
INSERT INTO `access_log` VALUES (34289, '65.46.15602353139526275', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:41:54', 9, 0, '', '2019-06-11 14:41:54');
INSERT INTO `access_log` VALUES (34290, '65.50.15602353139546287', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:41:54', 11, 0, '', '2019-06-11 14:41:54');
INSERT INTO `access_log` VALUES (34291, '65.52.15602353139546281', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:41:54', 11, 0, '', '2019-06-11 14:41:54');
INSERT INTO `access_log` VALUES (34292, '62.88.15602353194685679', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:41:59', 20, 0, '', '2019-06-11 14:41:59');
INSERT INTO `access_log` VALUES (34293, '59.76.15602353317575841', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:42:12', 13, 0, '', '2019-06-11 14:42:12');
INSERT INTO `access_log` VALUES (34294, '59.80.15602353339905839', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:42:14', 20, 2001001000, '服务端发生异常', '2019-06-11 14:42:14');
INSERT INTO `access_log` VALUES (34295, '65.3607.15602353356298037', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:42:16', 18, 0, '', '2019-06-11 14:42:16');
INSERT INTO `access_log` VALUES (34296, '64.84.15602353378765753', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:42:18', 11, 0, '', '2019-06-11 14:42:18');
INSERT INTO `access_log` VALUES (34297, '64.76.15602353378755739', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:42:18', 14, 0, '', '2019-06-11 14:42:18');
INSERT INTO `access_log` VALUES (34298, '62.82.15602353402695673', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:42:20', 12, 0, '', '2019-06-11 14:42:20');
INSERT INTO `access_log` VALUES (34299, '64.81.15602353430825745', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:42:23', 11, 0, '', '2019-06-11 14:42:23');
INSERT INTO `access_log` VALUES (34300, '64.80.15602353430805743', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:42:23', 13, 0, '', '2019-06-11 14:42:23');
INSERT INTO `access_log` VALUES (34301, '65.53.15602353438386251', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:42:24', 17, 0, '', '2019-06-11 14:42:24');
INSERT INTO `access_log` VALUES (34302, '59.74.15602353443845847', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:42:24', 19, 2001001000, '服务端发生异常', '2019-06-11 14:42:24');
INSERT INTO `access_log` VALUES (34303, '59.75.15602353448375853', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.10.249', '2019-06-11 14:42:25', 11, 0, '', '2019-06-11 14:42:25');
INSERT INTO `access_log` VALUES (34304, '65.53.15602359225646259', 27, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:52:03', 15, 0, '', '2019-06-11 14:52:03');
INSERT INTO `access_log` VALUES (34305, '65.47.15602359280596277', 27, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:52:08', 182, 0, '', '2019-06-11 14:52:08');
INSERT INTO `access_log` VALUES (34306, '65.54.15602359307566251', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:52:11', 13, 0, '', '2019-06-11 14:52:11');
INSERT INTO `access_log` VALUES (34307, '65.45.15602359353486295', 27, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=1,2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:52:15', 7, 1002002009, '演示账号，暂不允许写操作。欢迎加入我们的交流群：http://t.cn/EKEr5WE', '2019-06-11 14:52:15');
INSERT INTO `access_log` VALUES (34308, '65.52.15602359547246291', 27, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.247.104.78', '2019-06-11 14:52:35', 12, 0, '', '2019-06-11 14:52:35');
INSERT INTO `access_log` VALUES (34309, '59.78.15602359552675859', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:52:35', 3, 0, '', '2019-06-11 14:52:35');
INSERT INTO `access_log` VALUES (34310, '59.72.15602359552685857', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:52:35', 9, 2001001000, '服务端发生异常', '2019-06-11 14:52:35');
INSERT INTO `access_log` VALUES (34311, '64.78.15602359601285761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:52:40', 2, 0, '', '2019-06-11 14:52:40');
INSERT INTO `access_log` VALUES (34312, '64.79.15602359602635751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:52:40', 2, 0, '', '2019-06-11 14:52:40');
INSERT INTO `access_log` VALUES (34313, '65.47.15602360155066279', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:53:36', 0, 1002001015, '账号未登陆', '2019-06-11 14:53:36');
INSERT INTO `access_log` VALUES (34314, '65.51.15602360155136297', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:53:36', 0, 1002001015, '账号未登陆', '2019-06-11 14:53:36');
INSERT INTO `access_log` VALUES (34315, '65.54.15602360155186253', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:53:36', 1, 1002001015, '账号未登陆', '2019-06-11 14:53:36');
INSERT INTO `access_log` VALUES (34316, '65.50.15602360206396299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:53:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 14:53:41');
INSERT INTO `access_log` VALUES (34317, '65.52.15602360252746293', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:53:45', 105, 0, '', '2019-06-11 14:53:45');
INSERT INTO `access_log` VALUES (34318, '65.46.15602360256766287', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:53:46', 7, 0, '', '2019-06-11 14:53:46');
INSERT INTO `access_log` VALUES (34319, '65.49.15602360256806315', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:53:46', 7, 0, '', '2019-06-11 14:53:46');
INSERT INTO `access_log` VALUES (34320, '65.3607.15602360256828049', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:53:46', 7, 0, '', '2019-06-11 14:53:46');
INSERT INTO `access_log` VALUES (34321, '62.87.15602360447115681', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:54:05', 13, 0, '', '2019-06-11 14:54:05');
INSERT INTO `access_log` VALUES (34322, '62.80.15602360718435693', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:54:32', 15, 0, '', '2019-06-11 14:54:32');
INSERT INTO `access_log` VALUES (34323, '64.78.15602360828055763', 27, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:54:43', 18, 0, '', '2019-06-11 14:54:43');
INSERT INTO `access_log` VALUES (34324, '64.79.15602360828095753', 27, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:54:43', 14, 0, '', '2019-06-11 14:54:43');
INSERT INTO `access_log` VALUES (34325, '66.53.15602361185394323', 27, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:55:19', 22, 0, '', '2019-06-11 14:55:19');
INSERT INTO `access_log` VALUES (34326, '59.73.15602361333025863', 27, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:55:33', 12, 0, '', '2019-06-11 14:55:33');
INSERT INTO `access_log` VALUES (34327, '66.53.15602362424144325', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=admin&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:57:22', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号必须都是数字\n账号长度为 11 位', '2019-06-11 14:57:22');
INSERT INTO `access_log` VALUES (34328, '66.52.15602362522884323', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=admin&code=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:57:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码必须都是数字\n手机号必须都是数字', '2019-06-11 14:57:32');
INSERT INTO `access_log` VALUES (34329, '66.56.15602362638074323', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11569586325&code=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:57:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字', '2019-06-11 14:57:44');
INSERT INTO `access_log` VALUES (34330, '66.54.15602362702954323', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11569586325&code=152364', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:57:50', 15, 1001003000, '验证码不存在', '2019-06-11 14:57:50');
INSERT INTO `access_log` VALUES (34331, '66.55.15602362728314325', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=11569586325', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:57:53', 68, 0, '', '2019-06-11 14:57:53');
INSERT INTO `access_log` VALUES (34332, '66.50.15602362841344317', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11569586325&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:58:04', 178, 0, '', '2019-06-11 14:58:04');
INSERT INTO `access_log` VALUES (34333, '64.81.15602362906945759', 117, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:58:11', 6, 0, '', '2019-06-11 14:58:11');
INSERT INTO `access_log` VALUES (34334, '64.77.15602362909715769', 117, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:58:11', 4, 0, '', '2019-06-11 14:58:11');
INSERT INTO `access_log` VALUES (34335, '64.78.15602362936835767', 117, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:58:14', 5, 0, '', '2019-06-11 14:58:14');
INSERT INTO `access_log` VALUES (34336, '64.79.15602362938265757', 117, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:58:14', 4, 0, '', '2019-06-11 14:58:14');
INSERT INTO `access_log` VALUES (34337, '66.53.15602362964114327', 117, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:58:16', 6, 0, '', '2019-06-11 14:58:16');
INSERT INTO `access_log` VALUES (34338, '66.49.15602363143444337', 117, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:58:34', 6, 0, '', '2019-06-11 14:58:34');
INSERT INTO `access_log` VALUES (34339, '64.84.15602363155355769', 117, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:58:36', 5, 0, '', '2019-06-11 14:58:36');
INSERT INTO `access_log` VALUES (34340, '64.76.15602363156535755', 117, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:58:36', 4, 0, '', '2019-06-11 14:58:36');
INSERT INTO `access_log` VALUES (34341, '64.81.15602363165755761', 117, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:58:37', 5, 0, '', '2019-06-11 14:58:37');
INSERT INTO `access_log` VALUES (34342, '64.77.15602363196455771', 117, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:58:40', 5, 0, '', '2019-06-11 14:58:40');
INSERT INTO `access_log` VALUES (34343, '59.79.15602363209125867', 117, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:58:41', 17, 2001001000, '服务端发生异常', '2019-06-11 14:58:41');
INSERT INTO `access_log` VALUES (34344, '59.78.15602363211335865', 117, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '101.204.236.149', '2019-06-11 14:58:41', 6, 0, '', '2019-06-11 14:58:41');
INSERT INTO `access_log` VALUES (34345, '65.54.15602365143596261', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:01:54', 4, 1002001012, '访问令牌已过期', '2019-06-11 15:01:54');
INSERT INTO `access_log` VALUES (34346, '65.45.15602365143636305', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:01:54', 2, 1002001012, '访问令牌已过期', '2019-06-11 15:01:54');
INSERT INTO `access_log` VALUES (34347, '65.50.15602365143716307', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:01:54', 4, 1002001012, '访问令牌已过期', '2019-06-11 15:01:54');
INSERT INTO `access_log` VALUES (34348, '65.52.15602365179486301', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:01:58', 124, 0, '', '2019-06-11 15:01:58');
INSERT INTO `access_log` VALUES (34349, '65.3607.15602365183758057', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:01:58', 311, 0, '', '2019-06-11 15:01:59');
INSERT INTO `access_log` VALUES (34350, '65.49.15602365183756323', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:01:58', 502, 0, '', '2019-06-11 15:01:59');
INSERT INTO `access_log` VALUES (34351, '65.46.15602365183796295', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:01:58', 1007, 0, '', '2019-06-11 15:01:59');
INSERT INTO `access_log` VALUES (34352, '65.53.15602365265086271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:02:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 15:02:07');
INSERT INTO `access_log` VALUES (34353, '65.51.15602365303476307', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:02:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 15:02:10');
INSERT INTO `access_log` VALUES (34354, '65.54.15602365352356263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:02:15', 115, 0, '', '2019-06-11 15:02:15');
INSERT INTO `access_log` VALUES (34355, '65.45.15602365355656307', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:02:16', 9, 0, '', '2019-06-11 15:02:16');
INSERT INTO `access_log` VALUES (34356, '65.50.15602365355706309', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:02:16', 10, 0, '', '2019-06-11 15:02:16');
INSERT INTO `access_log` VALUES (34357, '65.52.15602365355736303', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:02:16', 8, 0, '', '2019-06-11 15:02:16');
INSERT INTO `access_log` VALUES (34358, '65.3607.15602365406408059', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:02:21', 10, 0, '', '2019-06-11 15:02:21');
INSERT INTO `access_log` VALUES (34359, '65.46.15602365451156297', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:02:25', 96, 0, '', '2019-06-11 15:02:25');
INSERT INTO `access_log` VALUES (34360, '65.53.15602365569636273', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:02:37', 13, 0, '', '2019-06-11 15:02:37');
INSERT INTO `access_log` VALUES (34361, '65.51.15602365609726309', 1, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=1&resourceIds=14,15,16,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,41,42,43,44,45,46,47,51,52,53', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:02:41', 792, 0, '', '2019-06-11 15:02:42');
INSERT INTO `access_log` VALUES (34362, '65.54.15602365626966265', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:02:43', 12, 0, '', '2019-06-11 15:02:43');
INSERT INTO `access_log` VALUES (34363, '65.45.15602365802086309', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:03:00', 14, 0, '', '2019-06-11 15:03:00');
INSERT INTO `access_log` VALUES (34364, '65.50.15602365851616311', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:03:05', 11, 0, '', '2019-06-11 15:03:05');
INSERT INTO `access_log` VALUES (34365, '65.49.15602365991226327', 1, 2, 'admin-application', '/admin-api/admins/role/add', 'name=测试', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:03:19', 115, 0, '', '2019-06-11 15:03:19');
INSERT INTO `access_log` VALUES (34366, '65.46.15602365994326299', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:03:19', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-06-11 15:03:19');
INSERT INTO `access_log` VALUES (34367, '65.53.15602366022726275', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:03:22', 11, 0, '', '2019-06-11 15:03:22');
INSERT INTO `access_log` VALUES (34368, '65.51.15602366074606311', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:03:27', 10, 0, '', '2019-06-11 15:03:27');
INSERT INTO `access_log` VALUES (34369, '65.54.15602366074626267', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:03:27', 11, 0, '', '2019-06-11 15:03:27');
INSERT INTO `access_log` VALUES (34370, '65.52.15602366075126307', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:03:28', 11, 0, '', '2019-06-11 15:03:28');
INSERT INTO `access_log` VALUES (34371, '65.45.15602366075656311', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:03:28', 9, 0, '', '2019-06-11 15:03:28');
INSERT INTO `access_log` VALUES (34372, '65.50.15602366100246313', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=8', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:03:30', 13, 0, '', '2019-06-11 15:03:30');
INSERT INTO `access_log` VALUES (34373, '65.49.15602366267906329', 1, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=8&resourceIds=20,21,22,29,30,33,44,45,46', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:03:47', 113, 0, '', '2019-06-11 15:03:47');
INSERT INTO `access_log` VALUES (34374, '65.46.15602366293456301', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=8', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:03:49', 12, 0, '', '2019-06-11 15:03:49');
INSERT INTO `access_log` VALUES (34375, '65.47.15602366354316295', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:03:55', 19, 0, '', '2019-06-11 15:03:55');
INSERT INTO `access_log` VALUES (34376, '65.54.15602366371676269', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:03:57', 11, 0, '', '2019-06-11 15:03:57');
INSERT INTO `access_log` VALUES (34377, '65.52.15602366502646309', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:04:10', 11, 0, '', '2019-06-11 15:04:10');
INSERT INTO `access_log` VALUES (34378, '65.3607.15602366927448065', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:04:53', 13, 0, '', '2019-06-11 15:04:53');
INSERT INTO `access_log` VALUES (34379, '65.53.15602367125656279', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:05:13', 27, 0, '', '2019-06-11 15:05:13');
INSERT INTO `access_log` VALUES (34380, '65.47.15602367157136297', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:05:16', 11, 0, '', '2019-06-11 15:05:16');
INSERT INTO `access_log` VALUES (34381, '65.51.15602367263706315', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:05:26', 10, 0, '', '2019-06-11 15:05:26');
INSERT INTO `access_log` VALUES (34382, '65.45.15602367424646315', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:05:42', 13, 0, '', '2019-06-11 15:05:42');
INSERT INTO `access_log` VALUES (34383, '65.50.15602367521606317', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:05:52', 20, 0, '', '2019-06-11 15:05:52');
INSERT INTO `access_log` VALUES (34384, '65.49.15602367572156333', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:05:57', 11, 0, '', '2019-06-11 15:05:57');
INSERT INTO `access_log` VALUES (34385, '65.46.15602367618056305', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:06:02', 19, 0, '', '2019-06-11 15:06:02');
INSERT INTO `access_log` VALUES (34386, '65.53.15602367655846281', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:06:06', 12, 0, '', '2019-06-11 15:06:06');
INSERT INTO `access_log` VALUES (34387, '65.47.15602367683456299', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:06:08', 12, 0, '', '2019-06-11 15:06:08');
INSERT INTO `access_log` VALUES (34388, '65.51.15602367708406317', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:06:11', 12, 0, '', '2019-06-11 15:06:11');
INSERT INTO `access_log` VALUES (34389, '65.52.15602367778336313', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:06:18', 19, 0, '', '2019-06-11 15:06:18');
INSERT INTO `access_log` VALUES (34390, '65.50.15602367851206319', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:06:25', 12, 0, '', '2019-06-11 15:06:25');
INSERT INTO `access_log` VALUES (34391, '65.3607.15602367949378069', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=5&roleIds=1,2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:06:35', 91, 0, '', '2019-06-11 15:06:35');
INSERT INTO `access_log` VALUES (34392, '65.53.15602368154176283', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:06:55', 12, 0, '', '2019-06-11 15:06:55');
INSERT INTO `access_log` VALUES (34393, '65.47.15602368201416301', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=1&roleIds=2,6', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:07:00', 101, 0, '', '2019-06-11 15:07:00');
INSERT INTO `access_log` VALUES (34394, '65.54.15602368228406275', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:07:03', 12, 0, '', '2019-06-11 15:07:03');
INSERT INTO `access_log` VALUES (34395, '65.52.15602368312366315', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=5', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:07:11', 196, 0, '', '2019-06-11 15:07:11');
INSERT INTO `access_log` VALUES (34396, '65.45.15602368338566319', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:07:14', 396, 0, '', '2019-06-11 15:07:14');
INSERT INTO `access_log` VALUES (34397, '65.50.15602368355586321', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:07:16', 29, 0, '', '2019-06-11 15:07:16');
INSERT INTO `access_log` VALUES (34398, '65.49.15602368461596337', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:07:26', 10, 0, '', '2019-06-11 15:07:26');
INSERT INTO `access_log` VALUES (34399, '65.46.15602368479446309', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:07:28', 12, 0, '', '2019-06-11 15:07:28');
INSERT INTO `access_log` VALUES (34400, '65.53.15602368510546285', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:07:31', 7, 0, '', '2019-06-11 15:07:31');
INSERT INTO `access_log` VALUES (34401, '62.82.15602368869735697', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:08:07', 20, 0, '', '2019-06-11 15:08:07');
INSERT INTO `access_log` VALUES (34402, '65.52.15602368933196317', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:08:13', 15, 0, '', '2019-06-11 15:08:13');
INSERT INTO `access_log` VALUES (34403, '65.45.15602368960586321', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:08:16', 8, 0, '', '2019-06-11 15:08:16');
INSERT INTO `access_log` VALUES (34404, '65.49.15602369296516339', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:08:50', 14, 0, '', '2019-06-11 15:08:50');
INSERT INTO `access_log` VALUES (34405, '65.47.15602369588706305', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:09:19', 10, 0, '', '2019-06-11 15:09:19');
INSERT INTO `access_log` VALUES (34406, '65.49.15602370467436341', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:10:47', 10, 0, '', '2019-06-11 15:10:47');
INSERT INTO `access_log` VALUES (34407, '65.46.15602370504336313', 1, 2, 'admin-application', '/admin-api/admins/role/delete', 'id=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:10:50', 252, 0, '', '2019-06-11 15:10:51');
INSERT INTO `access_log` VALUES (34408, '65.53.15602370508636289', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:10:51', 21, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-06-11 15:10:51');
INSERT INTO `access_log` VALUES (34409, '65.54.15602370565806281', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:10:57', 9, 0, '', '2019-06-11 15:10:57');
INSERT INTO `access_log` VALUES (34410, '65.51.15602370565816325', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:10:57', 9, 0, '', '2019-06-11 15:10:57');
INSERT INTO `access_log` VALUES (34411, '65.52.15602370566346321', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:10:57', 10, 0, '', '2019-06-11 15:10:57');
INSERT INTO `access_log` VALUES (34412, '65.45.15602370566966325', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:10:57', 10, 0, '', '2019-06-11 15:10:57');
INSERT INTO `access_log` VALUES (34413, '65.50.15602370615946327', 1, 2, 'admin-application', '/admin-api/admins/role/delete', 'id=8', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:11:02', 77, 0, '', '2019-06-11 15:11:02');
INSERT INTO `access_log` VALUES (34414, '65.3607.15602370618358077', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:11:02', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-06-11 15:11:02');
INSERT INTO `access_log` VALUES (34415, '65.49.15602370637496343', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:11:04', 9, 0, '', '2019-06-11 15:11:04');
INSERT INTO `access_log` VALUES (34416, '65.46.15602370637526315', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:11:04', 9, 0, '', '2019-06-11 15:11:04');
INSERT INTO `access_log` VALUES (34417, '65.53.15602370637556291', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:11:04', 8, 0, '', '2019-06-11 15:11:04');
INSERT INTO `access_log` VALUES (34418, '65.47.15602370638306309', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:11:04', 19, 0, '', '2019-06-11 15:11:04');
INSERT INTO `access_log` VALUES (34419, '62.83.15602370871335703', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.222.170', '2019-06-11 15:11:27', 16, 0, '', '2019-06-11 15:11:27');
INSERT INTO `access_log` VALUES (34420, '59.71.15602379871535887', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:26:27', 4, 0, '', '2019-06-11 15:26:27');
INSERT INTO `access_log` VALUES (34421, '59.73.15602379871535889', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:26:27', 13, 2001001000, '服务端发生异常', '2019-06-11 15:26:27');
INSERT INTO `access_log` VALUES (34422, '64.79.15602379924315781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:26:32', 2, 0, '', '2019-06-11 15:26:32');
INSERT INTO `access_log` VALUES (34423, '64.83.15602379927225777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:26:33', 2, 0, '', '2019-06-11 15:26:33');
INSERT INTO `access_log` VALUES (34424, '64.84.15602380076265793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:26:48', 2, 0, '', '2019-06-11 15:26:48');
INSERT INTO `access_log` VALUES (34425, '64.76.15602380077395779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:26:48', 2, 0, '', '2019-06-11 15:26:48');
INSERT INTO `access_log` VALUES (34426, '64.81.15602380122285785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:26:52', 2, 0, '', '2019-06-11 15:26:52');
INSERT INTO `access_log` VALUES (34427, '64.80.15602380136545783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:26:54', 189, 0, '', '2019-06-11 15:26:54');
INSERT INTO `access_log` VALUES (34428, '59.77.15602380206205879', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:27:01', 2, 0, '', '2019-06-11 15:27:01');
INSERT INTO `access_log` VALUES (34429, '59.74.15602380206205885', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:27:01', 10, 2001001000, '服务端发生异常', '2019-06-11 15:27:01');
INSERT INTO `access_log` VALUES (34430, '59.79.15602380274825891', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:27:07', 2, 0, '', '2019-06-11 15:27:07');
INSERT INTO `access_log` VALUES (34431, '59.78.15602380274845889', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:27:07', 10, 2001001000, '服务端发生异常', '2019-06-11 15:27:07');
INSERT INTO `access_log` VALUES (34432, '59.72.15602380345625887', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:27:15', 2, 0, '', '2019-06-11 15:27:15');
INSERT INTO `access_log` VALUES (34433, '59.73.15602380345635891', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:27:15', 10, 2001001000, '服务端发生异常', '2019-06-11 15:27:15');
INSERT INTO `access_log` VALUES (34434, '65.51.15602381211336341', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:28:41', 0, 1002001015, '账号未登陆', '2019-06-11 15:28:41');
INSERT INTO `access_log` VALUES (34435, '65.52.15602381211386337', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.181.197', '2019-06-11 15:28:41', 0, 1002001015, '账号未登陆', '2019-06-11 15:28:41');
INSERT INTO `access_log` VALUES (34436, '65.45.15602381211406341', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:28:41', 0, 1002001015, '账号未登陆', '2019-06-11 15:28:41');
INSERT INTO `access_log` VALUES (34437, '65.50.15602381232606343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:28:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 15:28:43');
INSERT INTO `access_log` VALUES (34438, '65.3607.15602381270128093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:28:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 15:28:47');
INSERT INTO `access_log` VALUES (34439, '65.46.15602381340386331', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:28:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 15:28:54');
INSERT INTO `access_log` VALUES (34440, '65.49.15602381408196359', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai0&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:29:01', 88, 0, '', '2019-06-11 15:29:01');
INSERT INTO `access_log` VALUES (34441, '65.47.15602381412516325', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:29:01', 10, 0, '', '2019-06-11 15:29:01');
INSERT INTO `access_log` VALUES (34442, '65.54.15602381413586299', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:29:01', 18, 0, '', '2019-06-11 15:29:01');
INSERT INTO `access_log` VALUES (34443, '65.45.15602381413646343', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:29:01', 18, 0, '', '2019-06-11 15:29:01');
INSERT INTO `access_log` VALUES (34444, '62.89.15602381512185721', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:29:11', 13, 0, '', '2019-06-11 15:29:11');
INSERT INTO `access_log` VALUES (34445, '64.80.15602381570655785', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:29:17', 10, 0, '', '2019-06-11 15:29:17');
INSERT INTO `access_log` VALUES (34446, '64.77.15602381570655797', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:29:17', 12, 0, '', '2019-06-11 15:29:17');
INSERT INTO `access_log` VALUES (34447, '64.79.15602381641435785', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:29:24', 17, 0, '', '2019-06-11 15:29:24');
INSERT INTO `access_log` VALUES (34448, '64.83.15602381642375781', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:29:24', 11, 0, '', '2019-06-11 15:29:24');
INSERT INTO `access_log` VALUES (34449, '66.56.15602381749494351', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:29:35', 21, 0, '', '2019-06-11 15:29:35');
INSERT INTO `access_log` VALUES (34450, '59.71.15602381801995891', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:29:40', 20, 2001001000, '服务端发生异常', '2019-06-11 15:29:40');
INSERT INTO `access_log` VALUES (34451, '65.3607.15602381839918095', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:29:44', 394, 0, '', '2019-06-11 15:29:44');
INSERT INTO `access_log` VALUES (34452, '65.53.15602381853296309', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:29:45', 9, 0, '', '2019-06-11 15:29:45');
INSERT INTO `access_log` VALUES (34453, '65.47.15602382115816327', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:30:12', 10, 0, '', '2019-06-11 15:30:12');
INSERT INTO `access_log` VALUES (34454, '65.54.15602382125856301', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:30:13', 27, 0, '', '2019-06-11 15:30:13');
INSERT INTO `access_log` VALUES (34455, '59.74.15602382135745889', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:30:14', 20, 2001001000, '服务端发生异常', '2019-06-11 15:30:14');
INSERT INTO `access_log` VALUES (34456, '66.50.15602382145814343', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:30:15', 12, 0, '', '2019-06-11 15:30:15');
INSERT INTO `access_log` VALUES (34457, '64.85.15602382171915809', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:30:17', 11, 0, '', '2019-06-11 15:30:17');
INSERT INTO `access_log` VALUES (34458, '64.81.15602382172475789', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:30:17', 9, 0, '', '2019-06-11 15:30:17');
INSERT INTO `access_log` VALUES (34459, '64.77.15602382179465799', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:30:18', 11, 0, '', '2019-06-11 15:30:18');
INSERT INTO `access_log` VALUES (34460, '64.80.15602382180585787', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:30:18', 9, 0, '', '2019-06-11 15:30:18');
INSERT INTO `access_log` VALUES (34461, '62.89.15602382193235723', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.95.183.71', '2019-06-11 15:30:19', 216, 0, '', '2019-06-11 15:30:20');
INSERT INTO `access_log` VALUES (34462, '59.76.15602394999305901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 15:51:40', 4, 0, '', '2019-06-11 15:51:40');
INSERT INTO `access_log` VALUES (34463, '59.71.15602394999305909', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 15:51:40', 22, 2001001000, '服务端发生异常', '2019-06-11 15:51:40');
INSERT INTO `access_log` VALUES (34464, '59.74.15602395101815907', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:51:50', 3, 0, '', '2019-06-11 15:51:50');
INSERT INTO `access_log` VALUES (34465, '59.77.15602395101835901', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:51:50', 14, 2001001000, '服务端发生异常', '2019-06-11 15:51:50');
INSERT INTO `access_log` VALUES (34466, '64.85.15602395124525827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:51:52', 4, 0, '', '2019-06-11 15:51:52');
INSERT INTO `access_log` VALUES (34467, '64.77.15602395125975817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:51:53', 2, 0, '', '2019-06-11 15:51:53');
INSERT INTO `access_log` VALUES (34468, '64.80.15602395140395805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:51:54', 2, 0, '', '2019-06-11 15:51:54');
INSERT INTO `access_log` VALUES (34469, '64.78.15602395147215815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:51:55', 2, 0, '', '2019-06-11 15:51:55');
INSERT INTO `access_log` VALUES (34470, '64.79.15602395161135805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:51:56', 7, 0, '', '2019-06-11 15:51:56');
INSERT INTO `access_log` VALUES (34471, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:51:56', 21, 0, '', '2019-06-11 15:51:56');
INSERT INTO `access_log` VALUES (34472, '64.83.15602395179505801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:51:58', 2, 0, '', '2019-06-11 15:51:58');
INSERT INTO `access_log` VALUES (34473, '64.82.15602395180785819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:51:58', 1, 0, '', '2019-06-11 15:51:58');
INSERT INTO `access_log` VALUES (34474, '64.84.15602395198335817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:52:00', 2, 0, '', '2019-06-11 15:52:00');
INSERT INTO `access_log` VALUES (34475, '64.76.15602395208535803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:52:01', 2, 0, '', '2019-06-11 15:52:01');
INSERT INTO `access_log` VALUES (34476, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:52:01', 7, 0, '', '2019-06-11 15:52:01');
INSERT INTO `access_log` VALUES (34477, '64.81.15602395224085809', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:52:02', 8, 0, '', '2019-06-11 15:52:02');
INSERT INTO `access_log` VALUES (34478, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:52:10', 8, 0, '', '2019-06-11 15:52:10');
INSERT INTO `access_log` VALUES (34479, '64.77.15602395297285819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:52:10', 553, 0, '', '2019-06-11 15:52:10');
INSERT INTO `access_log` VALUES (34480, '64.80.15602395304985807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:52:10', 1, 0, '', '2019-06-11 15:52:11');
INSERT INTO `access_log` VALUES (34481, '64.78.15602395307105817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:52:11', 58, 0, '', '2019-06-11 15:52:11');
INSERT INTO `access_log` VALUES (34482, '59.79.15602395324945913', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:52:12', 2, 0, '', '2019-06-11 15:52:12');
INSERT INTO `access_log` VALUES (34483, '59.78.15602395324945911', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:52:12', 10, 2001001000, '服务端发生异常', '2019-06-11 15:52:13');
INSERT INTO `access_log` VALUES (34484, '66.57.15602395694434373', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15556906631&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:52:49', 10, 1001003000, '验证码不存在', '2019-06-11 15:52:49');
INSERT INTO `access_log` VALUES (34485, '65.45.15602395723786363', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.173.28.175', '2019-06-11 15:52:52', 1, 1002001015, '账号未登陆', '2019-06-11 15:52:52');
INSERT INTO `access_log` VALUES (34486, '65.51.15602395723786363', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.173.28.175', '2019-06-11 15:52:52', 0, 1002001015, '账号未登陆', '2019-06-11 15:52:52');
INSERT INTO `access_log` VALUES (34487, '65.52.15602395723916359', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.173.28.175', '2019-06-11 15:52:52', 0, 1002001015, '账号未登陆', '2019-06-11 15:52:52');
INSERT INTO `access_log` VALUES (34488, '66.53.15602395721684371', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15556906631', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:52:52', 291, 0, '', '2019-06-11 15:52:52');
INSERT INTO `access_log` VALUES (34489, '66.52.15602395746134371', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15556906631&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:52:55', 189, 0, '', '2019-06-11 15:52:55');
INSERT INTO `access_log` VALUES (34490, '65.3607.15602395748828115', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.173.28.175', '2019-06-11 15:52:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 15:52:55');
INSERT INTO `access_log` VALUES (34491, '66.56.15602395762984371', 118, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:52:56', 84, 0, '', '2019-06-11 15:52:56');
INSERT INTO `access_log` VALUES (34492, '65.53.15602395788866329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.173.28.175', '2019-06-11 15:52:59', 62, 0, '', '2019-06-11 15:52:59');
INSERT INTO `access_log` VALUES (34493, '65.46.15602395791496353', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.173.28.175', '2019-06-11 15:52:59', 11, 0, '', '2019-06-11 15:52:59');
INSERT INTO `access_log` VALUES (34494, '65.47.15602395791516347', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.173.28.175', '2019-06-11 15:52:59', 10, 0, '', '2019-06-11 15:52:59');
INSERT INTO `access_log` VALUES (34495, '65.49.15602395791506381', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.173.28.175', '2019-06-11 15:52:59', 140, 2001001000, '服务端发生异常', '2019-06-11 15:52:59');
INSERT INTO `access_log` VALUES (34496, '66.48.15602395819514381', 118, 1, 'user-application', '/user-api/users/user/update_nickname', 'nickname=123', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:02', 69, 0, '', '2019-06-11 15:53:02');
INSERT INTO `access_log` VALUES (34497, '65.45.15602395890986365', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.173.28.175', '2019-06-11 15:53:09', 9, 0, '', '2019-06-11 15:53:09');
INSERT INTO `access_log` VALUES (34498, '65.51.15602395891056365', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.173.28.175', '2019-06-11 15:53:09', 7, 0, '', '2019-06-11 15:53:09');
INSERT INTO `access_log` VALUES (34499, '65.52.15602395891046361', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.173.28.175', '2019-06-11 15:53:09', 89, 2001001000, '服务端发生异常', '2019-06-11 15:53:09');
INSERT INTO `access_log` VALUES (34500, '66.57.15602395897824375', 118, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:10', 6, 0, '', '2019-06-11 15:53:10');
INSERT INTO `access_log` VALUES (34501, '66.53.15602395906374373', 118, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:11', 5, 0, '', '2019-06-11 15:53:11');
INSERT INTO `access_log` VALUES (34502, '59.77.15602395924175903', 118, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:12', 6, 0, '', '2019-06-11 15:53:12');
INSERT INTO `access_log` VALUES (34503, '59.75.15602395924315915', 118, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:12', 15, 2001001000, '服务端发生异常', '2019-06-11 15:53:12');
INSERT INTO `access_log` VALUES (34504, '64.81.15602395966605811', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:17', 6, 0, '', '2019-06-11 15:53:17');
INSERT INTO `access_log` VALUES (34505, '64.77.15602395968075821', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:17', 5, 0, '', '2019-06-11 15:53:17');
INSERT INTO `access_log` VALUES (34506, '64.78.15602395979065819', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:18', 5, 0, '', '2019-06-11 15:53:18');
INSERT INTO `access_log` VALUES (34507, '64.83.15602395985135805', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:19', 6, 0, '', '2019-06-11 15:53:19');
INSERT INTO `access_log` VALUES (34508, '59.73.15602395994295915', 118, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:19', 5, 0, '', '2019-06-11 15:53:19');
INSERT INTO `access_log` VALUES (34509, '59.76.15602395994295905', 118, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:19', 16, 2001001000, '服务端发生异常', '2019-06-11 15:53:19');
INSERT INTO `access_log` VALUES (34510, '64.76.15602396014015807', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:21', 5, 0, '', '2019-06-11 15:53:21');
INSERT INTO `access_log` VALUES (34511, '64.85.15602396016455833', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:22', 5, 0, '', '2019-06-11 15:53:22');
INSERT INTO `access_log` VALUES (34512, '64.80.15602396026965811', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:23', 172, 0, '', '2019-06-11 15:53:23');
INSERT INTO `access_log` VALUES (34513, '64.79.15602396031535811', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:23', 4, 0, '', '2019-06-11 15:53:23');
INSERT INTO `access_log` VALUES (34514, '59.77.15602396042305905', 118, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:24', 4, 0, '', '2019-06-11 15:53:24');
INSERT INTO `access_log` VALUES (34515, '59.74.15602396042245911', 118, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:24', 16, 2001001000, '服务端发生异常', '2019-06-11 15:53:24');
INSERT INTO `access_log` VALUES (34516, '64.82.15602396067905825', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:27', 5, 0, '', '2019-06-11 15:53:27');
INSERT INTO `access_log` VALUES (34517, '64.76.15602396069645809', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:27', 5, 0, '', '2019-06-11 15:53:27');
INSERT INTO `access_log` VALUES (34518, '64.85.15602396082785835', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:28', 5, 0, '', '2019-06-11 15:53:28');
INSERT INTO `access_log` VALUES (34519, '64.80.15602396088125813', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:29', 5, 0, '', '2019-06-11 15:53:29');
INSERT INTO `access_log` VALUES (34520, '64.79.15602396105305813', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:31', 5, 0, '', '2019-06-11 15:53:31');
INSERT INTO `access_log` VALUES (34521, '64.82.15602396112915827', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:31', 5, 0, '', '2019-06-11 15:53:31');
INSERT INTO `access_log` VALUES (34522, 'N/A', 118, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:31', 11, 0, '', '2019-06-11 15:53:31');
INSERT INTO `access_log` VALUES (34523, '64.76.15602396125995811', 118, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:33', 9, 0, '', '2019-06-11 15:53:33');
INSERT INTO `access_log` VALUES (34524, '66.56.15602396152644373', 118, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:35', 6, 0, '', '2019-06-11 15:53:35');
INSERT INTO `access_log` VALUES (34525, '66.55.15602396175664373', 118, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:38', 6, 0, '', '2019-06-11 15:53:38');
INSERT INTO `access_log` VALUES (34526, '66.51.15602396324844379', 118, 1, 'user-application', '/user-api/users/address/add', 'name=3213&tel=15556906631&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=111&isDefault=true&address=111&areaNo=110101&mobile=15556906631&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:52', 101, 2001001000, '服务端发生异常', '2019-06-11 15:53:53');
INSERT INTO `access_log` VALUES (34527, '66.52.15602396341194375', 118, 1, 'user-application', '/user-api/users/address/add', 'name=3213&tel=15556906631&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=111&isDefault=true&address=111&areaNo=110101&mobile=15556906631&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:54', 102, 2001001000, '服务端发生异常', '2019-06-11 15:53:54');
INSERT INTO `access_log` VALUES (34528, '66.56.15602396359404375', 118, 1, 'user-application', '/user-api/users/address/add', 'name=3213&tel=15556906631&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=111&isDefault=true&address=111&areaNo=110101&mobile=15556906631&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:56', 250, 2001001000, '服务端发生异常', '2019-06-11 15:53:56');
INSERT INTO `access_log` VALUES (34529, '66.48.15602396377604385', 118, 1, 'user-application', '/user-api/users/address/add', 'name=3213&tel=15556906631&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=111&isDefault=true&address=111&areaNo=110101&mobile=15556906631&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:58', 80, 2001001000, '服务端发生异常', '2019-06-11 15:53:58');
INSERT INTO `access_log` VALUES (34530, '66.51.15602396697394381', 118, 1, 'user-application', '/user-api/users/address/add', 'name=3213&tel=15556906631&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=111&isDefault=true&address=111&areaNo=110101&mobile=15556906631&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:54:30', 73, 2001001000, '服务端发生异常', '2019-06-11 15:54:30');
INSERT INTO `access_log` VALUES (34531, '66.49.15602396792594389', 118, 1, 'user-application', '/user-api/users/address/add', 'name=3213&tel=15556906631&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=111&isDefault=true&address=111&areaNo=110101&mobile=15556906631&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:54:39', 55, 2001001000, '服务端发生异常', '2019-06-11 15:54:39');
INSERT INTO `access_log` VALUES (34532, '65.50.15602397427786369', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.90.244', '2019-06-11 15:55:43', 0, 1002001015, '账号未登陆', '2019-06-11 15:55:43');
INSERT INTO `access_log` VALUES (34533, '65.3607.15602397427798119', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.90.244', '2019-06-11 15:55:43', 0, 1002001015, '账号未登陆', '2019-06-11 15:55:43');
INSERT INTO `access_log` VALUES (34534, '65.53.15602397427886333', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.90.244', '2019-06-11 15:55:43', 0, 1002001015, '账号未登陆', '2019-06-11 15:55:43');
INSERT INTO `access_log` VALUES (34535, '65.47.15602397453456351', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.90.244', '2019-06-11 15:55:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 15:55:45');
INSERT INTO `access_log` VALUES (34536, '65.46.15602397471946357', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.90.244', '2019-06-11 15:55:47', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 15:55:47');
INSERT INTO `access_log` VALUES (34537, '65.54.15602397547616325', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.90.244', '2019-06-11 15:55:55', 88, 0, '', '2019-06-11 15:55:55');
INSERT INTO `access_log` VALUES (34538, '65.45.15602397550836369', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.90.244', '2019-06-11 15:55:55', 9, 0, '', '2019-06-11 15:55:55');
INSERT INTO `access_log` VALUES (34539, '65.52.15602397550886365', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.90.244', '2019-06-11 15:55:55', 9, 0, '', '2019-06-11 15:55:55');
INSERT INTO `access_log` VALUES (34540, '65.51.15602397550846369', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.90.244', '2019-06-11 15:55:55', 90, 2001001000, '服务端发生异常', '2019-06-11 15:55:55');
INSERT INTO `access_log` VALUES (34541, '59.76.15602397983835909', 118, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 15:56:38', 5, 0, '', '2019-06-11 15:56:38');
INSERT INTO `access_log` VALUES (34542, '59.71.15602397983835917', 118, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 15:56:38', 12, 2001001000, '服务端发生异常', '2019-06-11 15:56:38');
INSERT INTO `access_log` VALUES (34543, '64.78.15602398037795827', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 15:56:44', 6, 0, '', '2019-06-11 15:56:44');
INSERT INTO `access_log` VALUES (34544, '64.83.15602398038935813', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 15:56:44', 4, 0, '', '2019-06-11 15:56:44');
INSERT INTO `access_log` VALUES (34545, '64.82.15602398068755831', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 15:56:47', 6, 0, '', '2019-06-11 15:56:47');
INSERT INTO `access_log` VALUES (34546, '64.84.15602398074955829', 118, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 15:56:47', 57, 0, '', '2019-06-11 15:56:48');
INSERT INTO `access_log` VALUES (34547, '66.49.15602398083594391', 118, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 15:56:48', 9, 0, '', '2019-06-11 15:56:48');
INSERT INTO `access_log` VALUES (34548, '59.74.15602398169515915', 118, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 15:56:57', 6, 0, '', '2019-06-11 15:56:57');
INSERT INTO `access_log` VALUES (34549, '59.77.15602398169515909', 118, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 15:56:57', 15, 2001001000, '服务端发生异常', '2019-06-11 15:56:57');
INSERT INTO `access_log` VALUES (34550, '65.50.15602400429126375', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:43', 0, 1002001015, '账号未登陆', '2019-06-11 16:00:43');
INSERT INTO `access_log` VALUES (34551, '65.47.15602400429186355', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:43', 0, 1002001015, '账号未登陆', '2019-06-11 16:00:43');
INSERT INTO `access_log` VALUES (34552, '65.46.15602400429266363', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:43', 0, 1002001015, '账号未登陆', '2019-06-11 16:00:43');
INSERT INTO `access_log` VALUES (34553, '65.54.15602400467806329', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:47', 0, 1002001015, '账号未登陆', '2019-06-11 16:00:47');
INSERT INTO `access_log` VALUES (34554, '65.45.15602400467926375', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:47', 1, 1002001015, '账号未登陆', '2019-06-11 16:00:47');
INSERT INTO `access_log` VALUES (34555, '65.3607.15602400467998127', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:47', 1, 1002001015, '账号未登陆', '2019-06-11 16:00:47');
INSERT INTO `access_log` VALUES (34556, '65.51.15602400513706375', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:51', 66, 0, '', '2019-06-11 16:00:51');
INSERT INTO `access_log` VALUES (34557, '65.49.15602400519696389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:52', 18, 0, '', '2019-06-11 16:00:52');
INSERT INTO `access_log` VALUES (34558, '65.53.15602400519796341', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:52', 9, 0, '', '2019-06-11 16:00:52');
INSERT INTO `access_log` VALUES (34559, '65.52.15602400519706371', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:52', 93, 2001001000, '服务端发生异常', '2019-06-11 16:00:52');
INSERT INTO `access_log` VALUES (34560, '65.47.15602400558596357', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:56', 9, 0, '', '2019-06-11 16:00:56');
INSERT INTO `access_log` VALUES (34561, '65.3607.15602400558728129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:56', 9, 0, '', '2019-06-11 16:00:56');
INSERT INTO `access_log` VALUES (34562, '65.46.15602400558666365', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:56', 67, 2001001000, '服务端发生异常', '2019-06-11 16:00:56');
INSERT INTO `access_log` VALUES (34563, '59.74.15602403795285921', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.233.184.194', '2019-06-11 16:06:20', 3, 0, '', '2019-06-11 16:06:20');
INSERT INTO `access_log` VALUES (34564, '59.75.15602403795295929', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.233.184.194', '2019-06-11 16:06:20', 11, 2001001000, '服务端发生异常', '2019-06-11 16:06:20');
INSERT INTO `access_log` VALUES (34565, '64.84.15602403875145837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.233.184.194', '2019-06-11 16:06:28', 24, 0, '', '2019-06-11 16:06:28');
INSERT INTO `access_log` VALUES (34566, '64.76.15602403877385823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.233.184.194', '2019-06-11 16:06:28', 2, 0, '', '2019-06-11 16:06:28');
INSERT INTO `access_log` VALUES (34567, '64.85.15602404071105849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:06:47', 2, 0, '', '2019-06-11 16:06:47');
INSERT INTO `access_log` VALUES (34568, '64.77.15602404073075839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:06:47', 1, 0, '', '2019-06-11 16:06:47');
INSERT INTO `access_log` VALUES (34569, '59.72.15602404194395927', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:06:59', 3, 0, '', '2019-06-11 16:06:59');
INSERT INTO `access_log` VALUES (34570, '59.76.15602404194395919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:06:59', 19, 2001001000, '服务端发生异常', '2019-06-11 16:06:59');
INSERT INTO `access_log` VALUES (34571, '64.78.15602404226265837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:03', 2, 0, '', '2019-06-11 16:07:03');
INSERT INTO `access_log` VALUES (34572, '64.79.15602404228105827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:03', 2, 0, '', '2019-06-11 16:07:03');
INSERT INTO `access_log` VALUES (34573, '59.80.15602404244505915', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:04', 2, 0, '', '2019-06-11 16:07:04');
INSERT INTO `access_log` VALUES (34574, '59.77.15602404244505917', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:04', 13, 2001001000, '服务端发生异常', '2019-06-11 16:07:04');
INSERT INTO `access_log` VALUES (34575, '64.82.15602404277455841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:08', 2, 0, '', '2019-06-11 16:07:08');
INSERT INTO `access_log` VALUES (34576, '64.84.15602404278865839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:08', 2, 0, '', '2019-06-11 16:07:08');
INSERT INTO `access_log` VALUES (34577, '64.76.15602404301335825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:10', 80, 0, '', '2019-06-11 16:07:10');
INSERT INTO `access_log` VALUES (34578, '64.81.15602404311425831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:11', 1, 0, '', '2019-06-11 16:07:11');
INSERT INTO `access_log` VALUES (34579, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:12', 6, 0, '', '2019-06-11 16:07:12');
INSERT INTO `access_log` VALUES (34580, '64.85.15602404322635851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:12', 52, 0, '', '2019-06-11 16:07:12');
INSERT INTO `access_log` VALUES (34581, '64.77.15602404353435841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:15', 1, 0, '', '2019-06-11 16:07:15');
INSERT INTO `access_log` VALUES (34582, '64.80.15602404354605829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:15', 2, 0, '', '2019-06-11 16:07:15');
INSERT INTO `access_log` VALUES (34583, '59.78.15602404374215927', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:17', 2, 0, '', '2019-06-11 16:07:17');
INSERT INTO `access_log` VALUES (34584, '59.74.15602404374235923', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:17', 13, 2001001000, '服务端发生异常', '2019-06-11 16:07:17');
INSERT INTO `access_log` VALUES (34585, '64.79.15602404434745829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:23', 45, 0, '', '2019-06-11 16:07:24');
INSERT INTO `access_log` VALUES (34586, '64.83.15602404436635825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:24', 2, 0, '', '2019-06-11 16:07:24');
INSERT INTO `access_log` VALUES (34587, '59.79.15602404443105933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:24', 3, 0, '', '2019-06-11 16:07:24');
INSERT INTO `access_log` VALUES (34588, '59.73.15602404443165931', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:24', 12, 2001001000, '服务端发生异常', '2019-06-11 16:07:24');
INSERT INTO `access_log` VALUES (34589, '64.82.15602404446675843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:25', 2, 0, '', '2019-06-11 16:07:25');
INSERT INTO `access_log` VALUES (34590, '64.84.15602404448055841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:25', 2, 0, '', '2019-06-11 16:07:25');
INSERT INTO `access_log` VALUES (34591, '59.76.15602404448905921', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:25', 2, 0, '', '2019-06-11 16:07:25');
INSERT INTO `access_log` VALUES (34592, '59.72.15602404448905929', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:25', 19, 2001001000, '服务端发生异常', '2019-06-11 16:07:25');
INSERT INTO `access_log` VALUES (34593, '64.76.15602404453015827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:25', 68, 0, '', '2019-06-11 16:07:25');
INSERT INTO `access_log` VALUES (34594, '59.71.15602404455035929', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:26', 3, 0, '', '2019-06-11 16:07:26');
INSERT INTO `access_log` VALUES (34595, '59.80.15602404455065917', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:26', 13, 2001001000, '服务端发生异常', '2019-06-11 16:07:26');
INSERT INTO `access_log` VALUES (34596, '64.81.15602404456415833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.233.184.194', '2019-06-11 16:07:26', 2, 0, '', '2019-06-11 16:07:26');
INSERT INTO `access_log` VALUES (34597, '65.54.15602408305556341', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '117.136.45.143', '2019-06-11 16:13:51', 1, 1002001015, '账号未登陆', '2019-06-11 16:13:51');
INSERT INTO `access_log` VALUES (34598, '65.51.15602408305556387', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '117.136.45.143', '2019-06-11 16:13:51', 0, 1002001015, '账号未登陆', '2019-06-11 16:13:51');
INSERT INTO `access_log` VALUES (34599, '65.49.15602408305566401', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '117.136.45.143', '2019-06-11 16:13:51', 1, 1002001015, '账号未登陆', '2019-06-11 16:13:51');
INSERT INTO `access_log` VALUES (34600, '65.52.15602408374366383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '117.136.45.143', '2019-06-11 16:13:57', 110, 0, '', '2019-06-11 16:13:58');
INSERT INTO `access_log` VALUES (34601, '65.47.15602408382626369', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '117.136.45.143', '2019-06-11 16:13:58', 10, 0, '', '2019-06-11 16:13:58');
INSERT INTO `access_log` VALUES (34602, '65.3607.15602408382628141', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '117.136.45.143', '2019-06-11 16:13:58', 10, 0, '', '2019-06-11 16:13:58');
INSERT INTO `access_log` VALUES (34603, '65.50.15602408382626389', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '117.136.45.143', '2019-06-11 16:13:58', 91, 2001001000, '服务端发生异常', '2019-06-11 16:13:58');
INSERT INTO `access_log` VALUES (34604, '65.45.15602408531766389', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '117.136.45.143', '2019-06-11 16:14:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 16:14:13');
INSERT INTO `access_log` VALUES (34605, '65.49.15602408622706403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '117.136.45.143', '2019-06-11 16:14:22', 85, 0, '', '2019-06-11 16:14:22');
INSERT INTO `access_log` VALUES (34606, '65.51.15602408629866389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '117.136.45.143', '2019-06-11 16:14:23', 9, 0, '', '2019-06-11 16:14:23');
INSERT INTO `access_log` VALUES (34607, '65.53.15602408629906355', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '117.136.45.143', '2019-06-11 16:14:23', 8, 0, '', '2019-06-11 16:14:23');
INSERT INTO `access_log` VALUES (34608, '65.54.15602408629866343', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '117.136.45.143', '2019-06-11 16:14:23', 236, 2001001000, '服务端发生异常', '2019-06-11 16:14:23');
INSERT INTO `access_log` VALUES (34609, '65.54.15602433102996377', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3766.2 Safari/537.36', '115.236.71.65', '2019-06-11 16:55:10', 0, 1002001015, '账号未登陆', '2019-06-11 16:55:10');
INSERT INTO `access_log` VALUES (34610, '65.3607.15602433103018175', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3766.2 Safari/537.36', '115.236.71.65', '2019-06-11 16:55:10', 1, 1002001015, '账号未登陆', '2019-06-11 16:55:10');
INSERT INTO `access_log` VALUES (34611, '65.47.15602433103016405', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3766.2 Safari/537.36', '115.236.71.65', '2019-06-11 16:55:10', 1, 1002001015, '账号未登陆', '2019-06-11 16:55:10');
INSERT INTO `access_log` VALUES (34612, '59.72.15602435472675971', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 16:59:07', 13, 0, '', '2019-06-11 16:59:07');
INSERT INTO `access_log` VALUES (34613, '59.71.15602435472705971', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 16:59:07', 17, 2001001000, '服务端发生异常', '2019-06-11 16:59:07');
INSERT INTO `access_log` VALUES (34614, '65.54.15602435785716381', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3766.2 Safari/537.36', '115.236.71.65', '2019-06-11 16:59:39', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 16:59:39');
INSERT INTO `access_log` VALUES (34615, '59.75.15602435938825975', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 16:59:54', 3, 0, '', '2019-06-11 16:59:54');
INSERT INTO `access_log` VALUES (34616, '59.74.15602435938815967', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 16:59:54', 13, 2001001000, '服务端发生异常', '2019-06-11 16:59:54');
INSERT INTO `access_log` VALUES (34617, '65.45.15602436447866427', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:00:45', 0, 1002001015, '账号未登陆', '2019-06-11 17:00:45');
INSERT INTO `access_log` VALUES (34618, '65.53.15602436447936393', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:00:45', 1, 1002001015, '账号未登陆', '2019-06-11 17:00:45');
INSERT INTO `access_log` VALUES (34619, '65.51.15602436447946429', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:00:45', 1, 1002001015, '账号未登陆', '2019-06-11 17:00:45');
INSERT INTO `access_log` VALUES (34620, '65.54.15602436552016383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:00:55', 78, 0, '', '2019-06-11 17:00:55');
INSERT INTO `access_log` VALUES (34621, '65.47.15602436555256411', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:00:56', 10, 0, '', '2019-06-11 17:00:56');
INSERT INTO `access_log` VALUES (34622, '65.46.15602436555366419', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:00:56', 8, 0, '', '2019-06-11 17:00:56');
INSERT INTO `access_log` VALUES (34623, '65.3607.15602436555318181', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:00:56', 108, 2001001000, '服务端发生异常', '2019-06-11 17:00:56');
INSERT INTO `access_log` VALUES (34624, '65.50.15602436654366429', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:01:05', 11, 0, '', '2019-06-11 17:01:05');
INSERT INTO `access_log` VALUES (34625, '65.45.15602436654376429', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:01:05', 12, 0, '', '2019-06-11 17:01:05');
INSERT INTO `access_log` VALUES (34626, '65.49.15602436654366443', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:01:05', 79, 2001001000, '服务端发生异常', '2019-06-11 17:01:06');
INSERT INTO `access_log` VALUES (34627, '65.52.15602436951006429', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:01:35', 9, 0, '', '2019-06-11 17:01:35');
INSERT INTO `access_log` VALUES (34628, '65.47.15602436951066413', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:01:35', 8, 0, '', '2019-06-11 17:01:35');
INSERT INTO `access_log` VALUES (34629, '65.54.15602436951036385', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:01:35', 114, 2001001000, '服务端发生异常', '2019-06-11 17:01:35');
INSERT INTO `access_log` VALUES (34630, '59.76.15602452551695987', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:27:35', 4, 0, '', '2019-06-11 17:27:35');
INSERT INTO `access_log` VALUES (34631, '59.73.15602452551695997', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:27:35', 13, 2001001000, '服务端发生异常', '2019-06-11 17:27:35');
INSERT INTO `access_log` VALUES (34632, '64.81.15602452598625897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:27:40', 10, 0, '', '2019-06-11 17:27:40');
INSERT INTO `access_log` VALUES (34633, '64.77.15602452600105909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:27:40', 3, 0, '', '2019-06-11 17:27:40');
INSERT INTO `access_log` VALUES (34634, '64.85.15602452610005917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:27:41', 526, 0, '', '2019-06-11 17:27:42');
INSERT INTO `access_log` VALUES (34635, '64.80.15602452616405897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:27:42', 2, 0, '', '2019-06-11 17:27:42');
INSERT INTO `access_log` VALUES (34636, '64.79.15602452621845897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:27:42', 2, 0, '', '2019-06-11 17:27:42');
INSERT INTO `access_log` VALUES (34637, '64.82.15602452659085909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:27:46', 2, 0, '', '2019-06-11 17:27:46');
INSERT INTO `access_log` VALUES (34638, '64.78.15602452660325905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:27:46', 1, 0, '', '2019-06-11 17:27:46');
INSERT INTO `access_log` VALUES (34639, '66.51.15602452791014457', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15965412563&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:27:59', 187, 1001003000, '验证码不存在', '2019-06-11 17:27:59');
INSERT INTO `access_log` VALUES (34640, '66.53.15602452885604451', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15965412563', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:09', 81, 0, '', '2019-06-11 17:28:09');
INSERT INTO `access_log` VALUES (34641, '66.52.15602452905914453', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15965412563&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:11', 211, 0, '', '2019-06-11 17:28:11');
INSERT INTO `access_log` VALUES (34642, '66.56.15602452922834453', 119, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:12', 12, 0, '', '2019-06-11 17:28:12');
INSERT INTO `access_log` VALUES (34643, '66.54.15602452955564455', 119, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:16', 6, 0, '', '2019-06-11 17:28:16');
INSERT INTO `access_log` VALUES (34644, '66.48.15602452963054463', 119, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:16', 6, 0, '', '2019-06-11 17:28:16');
INSERT INTO `access_log` VALUES (34645, '66.55.15602453017434453', 119, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:22', 6, 0, '', '2019-06-11 17:28:22');
INSERT INTO `access_log` VALUES (34646, '64.77.15602453027915911', 119, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:23', 5, 0, '', '2019-06-11 17:28:23');
INSERT INTO `access_log` VALUES (34647, '64.80.15602453030485899', 119, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:23', 273, 0, '', '2019-06-11 17:28:23');
INSERT INTO `access_log` VALUES (34648, '64.82.15602453040745911', 119, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:24', 5, 0, '', '2019-06-11 17:28:24');
INSERT INTO `access_log` VALUES (34649, '64.76.15602453045675897', 119, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:25', 5, 0, '', '2019-06-11 17:28:25');
INSERT INTO `access_log` VALUES (34650, '64.84.15602453049625911', 119, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:25', 208, 0, '', '2019-06-11 17:28:25');
INSERT INTO `access_log` VALUES (34651, '59.75.15602453059885999', 119, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:26', 96, 2001001000, '服务端发生异常', '2019-06-11 17:28:26');
INSERT INTO `access_log` VALUES (34652, '59.74.15602453059895991', 119, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:26', 239, 0, '', '2019-06-11 17:28:26');
INSERT INTO `access_log` VALUES (34653, '64.83.15602453099335893', 119, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:30', 5, 0, '', '2019-06-11 17:28:30');
INSERT INTO `access_log` VALUES (34654, '64.81.15602453101005901', 119, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:30', 4, 0, '', '2019-06-11 17:28:30');
INSERT INTO `access_log` VALUES (34655, '64.77.15602453110155913', 119, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:31', 5, 0, '', '2019-06-11 17:28:31');
INSERT INTO `access_log` VALUES (34656, '64.85.15602453113695921', 119, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:31', 4, 0, '', '2019-06-11 17:28:31');
INSERT INTO `access_log` VALUES (34657, '59.79.15602453122666001', 119, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:32', 6, 0, '', '2019-06-11 17:28:32');
INSERT INTO `access_log` VALUES (34658, '59.76.15602453122665989', 119, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:32', 17, 2001001000, '服务端发生异常', '2019-06-11 17:28:32');
INSERT INTO `access_log` VALUES (34659, 'N/A', 119, 1, 'search-application', '/search-api/users/product/page', 'keyword=55&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:36', 19, 0, '', '2019-06-11 17:28:36');
INSERT INTO `access_log` VALUES (34660, 'N/A', 119, 1, 'search-application', '/search-api/users/product/condition', 'keyword=55', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:36', 14, 0, '', '2019-06-11 17:28:36');
INSERT INTO `access_log` VALUES (34661, '59.71.15602453179725997', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '52.43.210.125', '2019-06-11 17:28:38', 3, 0, '', '2019-06-11 17:28:38');
INSERT INTO `access_log` VALUES (34662, '59.72.15602453264815997', 119, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:46', 5, 0, '', '2019-06-11 17:28:46');
INSERT INTO `access_log` VALUES (34663, '59.80.15602453264815985', 119, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:46', 15, 2001001000, '服务端发生异常', '2019-06-11 17:28:46');
INSERT INTO `access_log` VALUES (34664, '64.82.15602453320755913', 119, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:52', 5, 0, '', '2019-06-11 17:28:52');
INSERT INTO `access_log` VALUES (34665, '64.78.15602453322045909', 119, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.62.134.113', '2019-06-11 17:28:52', 4, 0, '', '2019-06-11 17:28:52');
INSERT INTO `access_log` VALUES (34666, '59.78.15602453430345997', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '18.237.9.247', '2019-06-11 17:29:03', 17, 2001001000, '服务端发生异常', '2019-06-11 17:29:03');
INSERT INTO `access_log` VALUES (34667, '59.79.15602453596016003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '174.129.63.19', '2019-06-11 17:29:20', 3, 0, '', '2019-06-11 17:29:20');
INSERT INTO `access_log` VALUES (34668, '59.77.15602454356345989', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '35.174.154.178', '2019-06-11 17:30:36', 14, 2001001000, '服务端发生异常', '2019-06-11 17:30:36');
INSERT INTO `access_log` VALUES (34669, '59.73.15602456708486005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.86.80.131', '2019-06-11 17:34:31', 3, 0, '', '2019-06-11 17:34:31');
INSERT INTO `access_log` VALUES (34670, '59.71.15602456708496003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.86.80.131', '2019-06-11 17:34:31', 20, 2001001000, '服务端发生异常', '2019-06-11 17:34:31');
INSERT INTO `access_log` VALUES (34671, '64.79.15602456759065907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.86.80.131', '2019-06-11 17:34:36', 276, 0, '', '2019-06-11 17:34:36');
INSERT INTO `access_log` VALUES (34672, '64.82.15602456763245919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.86.80.131', '2019-06-11 17:34:36', 1, 0, '', '2019-06-11 17:34:36');
INSERT INTO `access_log` VALUES (34673, '64.85.15602457719695927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.86.80.131', '2019-06-11 17:36:12', 3, 0, '', '2019-06-11 17:36:12');
INSERT INTO `access_log` VALUES (34674, '64.80.15602457725515907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.86.80.131', '2019-06-11 17:36:13', 2, 0, '', '2019-06-11 17:36:13');
INSERT INTO `access_log` VALUES (34675, '65.45.15602457726416457', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.19.1.62', '2019-06-11 17:36:13', 0, 1002001015, '账号未登陆', '2019-06-11 17:36:13');
INSERT INTO `access_log` VALUES (34676, '65.49.15602457726416471', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.19.1.62', '2019-06-11 17:36:13', 0, 1002001015, '账号未登陆', '2019-06-11 17:36:13');
INSERT INTO `access_log` VALUES (34677, '65.52.15602457726476459', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.19.1.62', '2019-06-11 17:36:13', 0, 1002001015, '账号未登陆', '2019-06-11 17:36:13');
INSERT INTO `access_log` VALUES (34678, '65.47.15602457795086443', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.19.1.62', '2019-06-11 17:36:20', 361, 0, '', '2019-06-11 17:36:20');
INSERT INTO `access_log` VALUES (34679, '65.54.15602457801486415', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.19.1.62', '2019-06-11 17:36:20', 13, 0, '', '2019-06-11 17:36:20');
INSERT INTO `access_log` VALUES (34680, '65.53.15602457802416425', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.19.1.62', '2019-06-11 17:36:20', 10, 0, '', '2019-06-11 17:36:20');
INSERT INTO `access_log` VALUES (34681, '65.50.15602457801496461', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.19.1.62', '2019-06-11 17:36:20', 303, 2001001000, '服务端发生异常', '2019-06-11 17:36:20');
INSERT INTO `access_log` VALUES (34682, '59.73.15602457901946007', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.86.80.131', '2019-06-11 17:36:30', 2, 0, '', '2019-06-11 17:36:30');
INSERT INTO `access_log` VALUES (34683, '59.71.15602457902236005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.86.80.131', '2019-06-11 17:36:30', 10, 2001001000, '服务端发生异常', '2019-06-11 17:36:30');
INSERT INTO `access_log` VALUES (34684, '64.78.15602492334295963', 0, 2, 'product-application', '/product-api/admins/attr/add', 'name=颜色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.186.255', '2019-06-11 18:33:53', 0, 1002001015, '账号未登陆', '2019-06-11 18:33:53');
INSERT INTO `access_log` VALUES (34685, '64.78.15602493516225965', 0, 1, 'product-application', '/product-api/users/spu/page', 'pageSize=10&cid=1&pageNo=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.186.255', '2019-06-11 18:35:52', 15, 0, '', '2019-06-11 18:35:52');
INSERT INTO `access_log` VALUES (34686, 'b4e66632-df92-45f3-b067-ec14cd3c1991', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-11 18:50:44', 2178, 0, '', '2019-06-11 18:50:46');
INSERT INTO `access_log` VALUES (34687, '38d84f3a-29b7-49fa-9e3f-4b796644867f', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-11 18:50:44', 3150, 2001001000, '服务端发生异常', '2019-06-11 18:50:47');
INSERT INTO `access_log` VALUES (34688, '851962e2-b0a3-4dd2-95f8-93fa9ba707b0', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:51:10', 82, 0, '', '2019-06-11 18:51:11');
INSERT INTO `access_log` VALUES (34689, '16f83650-fdab-4c7a-baed-2926c520e526', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:51:10', 266, 2001001000, '服务端发生异常', '2019-06-11 18:51:11');
INSERT INTO `access_log` VALUES (34690, '24912168-35c3-486d-97b4-f1a8c605a62a', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:51:30', 400, 0, '', '2019-06-11 18:51:31');
INSERT INTO `access_log` VALUES (34691, 'fc0e2051-18f7-4fb0-b1fc-6e83f33e891c', 0, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:51:32', 845, 0, '', '2019-06-11 18:51:33');
INSERT INTO `access_log` VALUES (34692, '53842be1-7159-459e-a59e-885caa9838e3', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:51:37', 71, 0, '', '2019-06-11 18:51:37');
INSERT INTO `access_log` VALUES (34693, '91e9b169-ed5d-438f-8d90-54b5677af25d', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:51:37', 405, 2001001000, '服务端发生异常', '2019-06-11 18:51:38');
INSERT INTO `access_log` VALUES (34694, '3eb23430-7c29-4ebe-958a-5fa1fa52ca0c', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:52:14', 93, 0, '', '2019-06-11 18:52:14');
INSERT INTO `access_log` VALUES (34695, '6f23c8bf-c06f-4414-a95c-13e1f1388927', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:52:14', 223, 2001001000, '服务端发生异常', '2019-06-11 18:52:14');
INSERT INTO `access_log` VALUES (34696, 'd5cd3a1b-712f-4347-8b92-7e75fa06a530', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:52:48', 134, 0, '', '2019-06-11 18:52:48');
INSERT INTO `access_log` VALUES (34697, 'f4109c74-ab89-4d0e-9049-66b5ecae62f3', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:52:48', 165, 2001001000, '服务端发生异常', '2019-06-11 18:52:48');
INSERT INTO `access_log` VALUES (34698, '7c517d1a-8b9b-4d1f-91fe-bfd9634532be', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:53:19', 9174, 0, '', '2019-06-11 18:53:28');
INSERT INTO `access_log` VALUES (34699, '7c517d1a-8b9b-4d1f-91fe-bfd9634532be', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:53:19', 9174, 0, '', '2019-06-11 18:53:33');
INSERT INTO `access_log` VALUES (34700, '6b95a7ad-ecca-4103-bbe5-13812ca35674', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:53:19', 14159, 2001001000, '服务端发生异常', '2019-06-11 18:53:33');
INSERT INTO `access_log` VALUES (34701, '84814a67-ee73-4b80-9caa-e8f8aebf03b8', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:54:38', 388, 0, '', '2019-06-11 18:54:38');
INSERT INTO `access_log` VALUES (34702, '5086364d-d3be-4857-b98b-df4870caf3ee', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:54:35', 3405, 2001001000, '服务端发生异常', '2019-06-11 18:54:39');
INSERT INTO `access_log` VALUES (34703, '3ed0aa5a-e7a9-43ee-b215-4968a3775600', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:54:57', 50, 0, '', '2019-06-11 18:54:57');
INSERT INTO `access_log` VALUES (34704, '1c905b09-6458-4e62-b549-da6a4be413c6', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:54:57', 156, 2001001000, '服务端发生异常', '2019-06-11 18:54:57');
INSERT INTO `access_log` VALUES (34705, '370633c9-02bb-4c30-b7b1-c7b7ab83a93b', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:55:05', 33859, 0, '', '2019-06-11 18:55:39');
INSERT INTO `access_log` VALUES (34706, 'f0b3318b-23c9-4b16-89fd-89c27fdffc28', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:55:05', 34029, 2001001000, '服务端发生异常', '2019-06-11 18:55:39');
INSERT INTO `access_log` VALUES (34707, '370633c9-02bb-4c30-b7b1-c7b7ab83a93b', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:55:05', 33859, 0, '', '2019-06-11 18:55:40');
INSERT INTO `access_log` VALUES (34708, '1f6fd3a1-5b3a-47ad-bfb7-c9ae1ecdd7e5', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:00:35', 80, 0, '', '2019-06-11 19:00:35');
INSERT INTO `access_log` VALUES (34709, 'c0778b51-020e-46d9-8424-3cb0a3c656df', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:00:35', 20, 0, '', '2019-06-11 19:00:35');
INSERT INTO `access_log` VALUES (34710, 'e4bfd6ca-1e13-49e2-ba3c-beb416be5c73', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:00:42', 19, 0, '', '2019-06-11 19:00:42');
INSERT INTO `access_log` VALUES (34711, '45a3afe3-63a0-4ee2-9627-3223fee1b650', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:00:42', 22, 0, '', '2019-06-11 19:00:42');
INSERT INTO `access_log` VALUES (34712, '62d0b58f-a953-45a0-a96b-e2211692d85e', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:00:57', 149, 2001001000, '服务端发生异常', '2019-06-11 19:00:58');
INSERT INTO `access_log` VALUES (34713, 'd845487d-f68c-43ef-b264-f55c63df346f', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:00:57', 146, 0, '', '2019-06-11 19:00:58');
INSERT INTO `access_log` VALUES (34714, '8c76220f-ab9e-4d1e-947b-916048cf3c5d', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:01:03', 21, 0, '', '2019-06-11 19:01:03');
INSERT INTO `access_log` VALUES (34715, '0bcc2bc5-8d0a-4da3-ac82-253ef3607c0c', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:01:03', 22, 0, '', '2019-06-11 19:01:03');
INSERT INTO `access_log` VALUES (34716, '8f1e2ccf-d1ca-47d9-b5b8-1d20260dfc56', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:01:05', 45, 0, '', '2019-06-11 19:01:05');
INSERT INTO `access_log` VALUES (34717, '9efeb73c-63ed-445d-9b8a-2e06cb744c60', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:01:05', 162, 2001001000, '服务端发生异常', '2019-06-11 19:01:05');
INSERT INTO `access_log` VALUES (34718, '3ef2148c-3d35-4114-bffe-e6c526908cf7', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:03:26', 264, 0, '', '2019-06-11 19:03:27');
INSERT INTO `access_log` VALUES (34719, '9d147fd2-6740-4173-831b-a23fb6806431', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:03:26', 277, 2001001000, '服务端发生异常', '2019-06-11 19:03:27');
INSERT INTO `access_log` VALUES (34720, '3d2b960b-a201-47bf-89e4-0eb074ad2a60', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:29:06', 6764, 0, '', '2019-06-11 19:29:16');
INSERT INTO `access_log` VALUES (34721, '3d2b960b-a201-47bf-89e4-0eb074ad2a60', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:29:06', 6764, 0, '', '2019-06-11 19:29:16');
INSERT INTO `access_log` VALUES (34722, '78b3ff91-18a4-4d37-9f5e-53da6677bd1b', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:29:06', 10800, 2001001000, '服务端发生异常', '2019-06-11 19:29:17');
INSERT INTO `access_log` VALUES (34723, '3d2b960b-a201-47bf-89e4-0eb074ad2a60', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:29:06', 6764, 0, '', '2019-06-11 19:29:16');
INSERT INTO `access_log` VALUES (34724, '90bf32d3-ee30-4a05-99e0-f7b3e778de03', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:29:18', 27, 0, '', '2019-06-11 19:29:19');
INSERT INTO `access_log` VALUES (34725, '91db475d-e8e6-4d2f-9eeb-fe164431a382', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:29:18', 302, 0, '', '2019-06-11 19:29:19');
INSERT INTO `access_log` VALUES (34726, '97da216e-47f5-4774-9af9-e974b3820d1b', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:29:25', 115, 0, '', '2019-06-11 19:29:25');
INSERT INTO `access_log` VALUES (34727, '99fe203b-7bc7-4ddc-883e-6bea02d9845b', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:29:26', 24, 0, '', '2019-06-11 19:29:26');
INSERT INTO `access_log` VALUES (34728, '02fbb15b-edbb-45e0-8734-166a13f0884c', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=小米&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:29:30', 262, 0, '', '2019-06-11 19:29:31');
INSERT INTO `access_log` VALUES (34729, '6b75e4f7-e104-4999-95bb-9b07c22edf2d', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=小米', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:29:31', 238, 0, '', '2019-06-11 19:29:31');
INSERT INTO `access_log` VALUES (34730, '238b82d9-1c1b-4e31-ad2d-453df4e05f0c', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=小米&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:03', 30, 0, '', '2019-06-11 19:30:03');
INSERT INTO `access_log` VALUES (34731, 'e8aa4c91-75ad-44a5-bc81-824328a8ac4f', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=小米', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:03', 65, 0, '', '2019-06-11 19:30:03');
INSERT INTO `access_log` VALUES (34732, 'e3cb7de3-7b8a-489b-ad31-9f914e13f739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:05', 23, 0, '', '2019-06-11 19:30:05');
INSERT INTO `access_log` VALUES (34733, '1d57d15a-6c9d-403b-ab2c-58f58fb27a44', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:06', 22, 0, '', '2019-06-11 19:30:06');
INSERT INTO `access_log` VALUES (34734, 'c5eaf0ce-ea2c-4c79-9ba6-4ce8b68c8a06', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:08', 27, 0, '', '2019-06-11 19:30:08');
INSERT INTO `access_log` VALUES (34735, '7d232e7b-54dc-4876-8cda-9af318e53167', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:08', 34, 0, '', '2019-06-11 19:30:08');
INSERT INTO `access_log` VALUES (34736, 'a805e8f4-89bd-4001-8375-7fc5bfc7a5cf', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:13', 22, 0, '', '2019-06-11 19:30:13');
INSERT INTO `access_log` VALUES (34737, 'c5d47922-699e-4af0-9cde-bd4588a0c7d4', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:14', 26, 0, '', '2019-06-11 19:30:14');
INSERT INTO `access_log` VALUES (34738, '5cb69eba-0563-4957-b52f-6ca32ffda8ce', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:14', 25, 0, '', '2019-06-11 19:30:14');
INSERT INTO `access_log` VALUES (34739, '2296e38c-1c0e-47a3-a390-7e9d48b5ba51', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:16', 36, 0, '', '2019-06-11 19:30:16');
INSERT INTO `access_log` VALUES (34740, '508815d6-dd97-4efd-8027-862f3a96d54f', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:18', 27, 0, '', '2019-06-11 19:30:18');
INSERT INTO `access_log` VALUES (34741, 'c26a5d88-3850-4ea7-a4fe-402821af97a4', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:18', 24, 0, '', '2019-06-11 19:30:18');
INSERT INTO `access_log` VALUES (34742, '32499a1d-86f4-45b9-90ee-fd6fc7efd520', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:21', 22, 0, '', '2019-06-11 19:30:21');
INSERT INTO `access_log` VALUES (34743, '2f754612-f275-4e52-af3e-de19cfff7160', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:21', 21, 0, '', '2019-06-11 19:30:21');
INSERT INTO `access_log` VALUES (34744, 'dfbf7cbd-a29b-4f8b-bb66-65b2cd7fb20b', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=僵尸&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:24', 24, 0, '', '2019-06-11 19:30:24');
INSERT INTO `access_log` VALUES (34745, '7285c9b6-6448-4243-8305-904986b0ed0b', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=僵尸', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:24', 83, 0, '', '2019-06-11 19:30:24');
INSERT INTO `access_log` VALUES (34746, 'ea4997b3-2e72-455b-813a-e37fe482c63d', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:26', 466, 0, '', '2019-06-11 19:30:26');
INSERT INTO `access_log` VALUES (34747, '431e9201-520e-44c7-afdc-d32f893ff6c2', 0, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=55', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:27', 535, 0, '', '2019-06-11 19:30:27');
INSERT INTO `access_log` VALUES (34748, '22702262-da2e-42aa-87ff-ee93bf48ed44', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17700000000', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:43', 460, 0, '', '2019-06-11 19:30:44');
INSERT INTO `access_log` VALUES (34749, 'fd28138f-18f2-4f11-b2ce-d0735a8b30c4', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17700000000&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:47', 800, 0, '', '2019-06-11 19:30:48');
INSERT INTO `access_log` VALUES (34750, 'f3d0610b-c378-4d8c-bbc8-a1b2c0fa8fb3', 120, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:50', 222, 0, '', '2019-06-11 19:30:50');
INSERT INTO `access_log` VALUES (34751, '868147b6-e1c3-4f2f-8fbf-76f62f0a4ec4', 120, 1, 'order-impl', '/order-api/users/order/confirm_create_order', 'skuId=55&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:50', 436, 0, '', '2019-06-11 19:30:50');
INSERT INTO `access_log` VALUES (34752, 'bcf0641c-71a1-402e-9785-e2bd91afcd10', 120, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:53', 70, 0, '', '2019-06-11 19:30:53');
INSERT INTO `access_log` VALUES (34753, '82d51642-1d66-4db5-9701-a6eed91ac4a4', 120, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:56', 56, 0, '', '2019-06-11 19:30:56');
INSERT INTO `access_log` VALUES (34754, 'e7f0762f-0742-467d-ad28-d8f4f5700709', 120, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:56', 55, 0, '', '2019-06-11 19:30:56');
INSERT INTO `access_log` VALUES (34755, 'c08b5b67-4996-4b86-b2b2-bb7830049b60', 120, 1, 'order-impl', '/order-api/users/order/confirm_create_order', 'skuId=55&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:56', 394, 0, '', '2019-06-11 19:30:57');
INSERT INTO `access_log` VALUES (34756, '8774b562-ff4d-4557-b44f-9cca7d156154', 120, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:59', 187, 0, '', '2019-06-11 19:31:00');
INSERT INTO `access_log` VALUES (34757, 'f5281494-a786-4d0e-8378-236fddd1648f', 120, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:30:59', 188, 0, '', '2019-06-11 19:31:00');
INSERT INTO `access_log` VALUES (34758, '6fc1a2c8-21c5-441e-ab1d-14b63e44d7b9', 120, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=55', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:31:00', 148, 0, '', '2019-06-11 19:31:00');
INSERT INTO `access_log` VALUES (34759, '906b91c3-9f58-472c-9a62-046f65018f16', 120, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:31:00', 125, 0, '', '2019-06-11 19:31:00');
INSERT INTO `access_log` VALUES (34760, 'db0ff9d1-2bc3-4d94-a584-7cd84e024f71', 120, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:31:01', 80, 0, '', '2019-06-11 19:31:01');
INSERT INTO `access_log` VALUES (34761, 'd8724128-d5ed-4f11-8cbe-81d7db426865', 120, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:31:01', 93, 0, '', '2019-06-11 19:31:01');
INSERT INTO `access_log` VALUES (34762, 'ecc81cfb-9c7a-48e2-9cf9-596556f9b6cf', 120, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:31:01', 91, 0, '', '2019-06-11 19:31:01');
INSERT INTO `access_log` VALUES (34763, 'fed75f83-50b7-4d56-af51-a6d4ac14846f', 120, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:31:02', 73, 0, '', '2019-06-11 19:31:02');
INSERT INTO `access_log` VALUES (34764, 'b9e3e273-7921-4c0a-a5e8-be31cc7839b9', 120, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:31:02', 49, 0, '', '2019-06-11 19:31:02');
INSERT INTO `access_log` VALUES (34765, '746ebd97-485d-4bc0-853d-3a6c56dfb379', 120, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:31:03', 80, 0, '', '2019-06-11 19:31:03');
INSERT INTO `access_log` VALUES (34766, '947173d3-83f9-4665-93fd-9216005e7904', 120, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:31:04', 50, 0, '', '2019-06-11 19:31:05');
INSERT INTO `access_log` VALUES (34767, '711bcf20-9a0b-484d-8bd8-c8074a49b80f', 120, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:31:06', 58, 0, '', '2019-06-11 19:31:06');
INSERT INTO `access_log` VALUES (34768, '2125c4ba-cfca-49ae-86af-59c238fe87e4', 120, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:31:08', 235, 0, '', '2019-06-11 19:31:08');
INSERT INTO `access_log` VALUES (34769, '194560f8-5623-4f47-a897-b38768362f7c', 120, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:31:09', 63, 0, '', '2019-06-11 19:31:09');
INSERT INTO `access_log` VALUES (34770, 'd9e77c28-cab2-4042-a6d4-373d42a231b5', 120, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:31:13', 58, 0, '', '2019-06-11 19:31:13');
INSERT INTO `access_log` VALUES (34771, '52801c76-e4bf-40d7-afc2-68c753480f64', 120, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:31:17', 80, 0, '', '2019-06-11 19:31:17');
INSERT INTO `access_log` VALUES (34772, '59.79.15602545755356127', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '49.94.70.44', '2019-06-11 20:02:56', 10, 0, '', '2019-06-11 20:02:56');
INSERT INTO `access_log` VALUES (34773, '59.76.15602545756016115', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '49.94.70.44', '2019-06-11 20:02:56', 20, 2001001000, '服务端发生异常', '2019-06-11 20:02:56');
INSERT INTO `access_log` VALUES (34774, '59.78.15602546377086123', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:03:58', 3, 0, '', '2019-06-11 20:03:58');
INSERT INTO `access_log` VALUES (34775, '59.77.15602546377076113', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:03:58', 23, 2001001000, '服务端发生异常', '2019-06-11 20:03:58');
INSERT INTO `access_log` VALUES (34776, '64.79.15602546413326027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:01', 11, 0, '', '2019-06-11 20:04:01');
INSERT INTO `access_log` VALUES (34777, '64.83.15602546415696023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:02', 3, 0, '', '2019-06-11 20:04:02');
INSERT INTO `access_log` VALUES (34778, '64.84.15602546428616037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:03', 195, 0, '', '2019-06-11 20:04:03');
INSERT INTO `access_log` VALUES (34779, '64.81.15602546437086031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:04', 2, 0, '', '2019-06-11 20:04:04');
INSERT INTO `access_log` VALUES (34780, '64.77.15602546446746041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:05', 2, 0, '', '2019-06-11 20:04:05');
INSERT INTO `access_log` VALUES (34781, '64.85.15602546452226049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:05', 1, 0, '', '2019-06-11 20:04:05');
INSERT INTO `access_log` VALUES (34782, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:05', 11, 0, '', '2019-06-11 20:04:05');
INSERT INTO `access_log` VALUES (34783, '64.78.15602546464426037', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:06', 7, 0, '', '2019-06-11 20:04:06');
INSERT INTO `access_log` VALUES (34784, '64.82.15602546510826043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:11', 2, 0, '', '2019-06-11 20:04:11');
INSERT INTO `access_log` VALUES (34785, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:11', 5, 0, '', '2019-06-11 20:04:11');
INSERT INTO `access_log` VALUES (34786, '64.76.15602546520766027', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:12', 5, 0, '', '2019-06-11 20:04:12');
INSERT INTO `access_log` VALUES (34787, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:13', 8, 0, '', '2019-06-11 20:04:13');
INSERT INTO `access_log` VALUES (34788, '64.79.15602546533156029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:13', 89, 0, '', '2019-06-11 20:04:13');
INSERT INTO `access_log` VALUES (34789, '64.83.15602546542386025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:14', 2, 0, '', '2019-06-11 20:04:14');
INSERT INTO `access_log` VALUES (34790, '64.84.15602546544256039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:14', 2, 0, '', '2019-06-11 20:04:14');
INSERT INTO `access_log` VALUES (34791, '64.81.15602546553136033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:15', 1, 0, '', '2019-06-11 20:04:15');
INSERT INTO `access_log` VALUES (34792, '59.74.15602546568046119', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:17', 22, 2001001000, '服务端发生异常', '2019-06-11 20:04:17');
INSERT INTO `access_log` VALUES (34793, '59.79.15602546568056129', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:17', 23, 0, '', '2019-06-11 20:04:17');
INSERT INTO `access_log` VALUES (34794, '59.71.15602546606476125', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:21', 3, 0, '', '2019-06-11 20:04:21');
INSERT INTO `access_log` VALUES (34795, '59.73.15602546606466127', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044704 Mobile Safari/537.36 MMWEBID/9351 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '113.69.37.205', '2019-06-11 20:04:21', 25, 2001001000, '服务端发生异常', '2019-06-11 20:04:21');
INSERT INTO `access_log` VALUES (34796, '65.51.15602548911156583', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.164.56.129', '2019-06-11 20:08:11', 0, 1002001015, '账号未登陆', '2019-06-11 20:08:11');
INSERT INTO `access_log` VALUES (34797, '65.3607.15602548911158335', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.164.56.129', '2019-06-11 20:08:11', 0, 1002001015, '账号未登陆', '2019-06-11 20:08:11');
INSERT INTO `access_log` VALUES (34798, '65.49.15602548911166595', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.164.56.129', '2019-06-11 20:08:11', 0, 1002001015, '账号未登陆', '2019-06-11 20:08:11');
INSERT INTO `access_log` VALUES (34799, '65.45.15602549053346581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.164.56.129', '2019-06-11 20:08:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 20:08:25');
INSERT INTO `access_log` VALUES (34800, '59.77.15602551443406121', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:24', 3, 0, '', '2019-06-11 20:12:24');
INSERT INTO `access_log` VALUES (34801, '59.78.15602551444646131', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:24', 23, 2001001000, '服务端发生异常', '2019-06-11 20:12:24');
INSERT INTO `access_log` VALUES (34802, '64.78.15602551510896045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:31', 3, 0, '', '2019-06-11 20:12:31');
INSERT INTO `access_log` VALUES (34803, '64.82.15602551512076051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:31', 2, 0, '', '2019-06-11 20:12:31');
INSERT INTO `access_log` VALUES (34804, '64.76.15602551530946035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:33', 2, 0, '', '2019-06-11 20:12:33');
INSERT INTO `access_log` VALUES (34805, '64.79.15602551537036037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:34', 2, 0, '', '2019-06-11 20:12:34');
INSERT INTO `access_log` VALUES (34806, '64.83.15602551539626033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:34', 2, 0, '', '2019-06-11 20:12:34');
INSERT INTO `access_log` VALUES (34807, '64.84.15602551544836047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:34', 2, 0, '', '2019-06-11 20:12:34');
INSERT INTO `access_log` VALUES (34808, '64.77.15602551558996051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:36', 2, 0, '', '2019-06-11 20:12:36');
INSERT INTO `access_log` VALUES (34809, '64.85.15602551560346059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:36', 2, 0, '', '2019-06-11 20:12:36');
INSERT INTO `access_log` VALUES (34810, '64.80.15602551569816037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:37', 2, 0, '', '2019-06-11 20:12:37');
INSERT INTO `access_log` VALUES (34811, '59.74.15602551582076127', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:38', 3, 0, '', '2019-06-11 20:12:38');
INSERT INTO `access_log` VALUES (34812, '59.79.15602551583016137', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:38', 17, 2001001000, '服务端发生异常', '2019-06-11 20:12:38');
INSERT INTO `access_log` VALUES (34813, '65.52.15602551791286587', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:59', 1, 1002001015, '账号未登陆', '2019-06-11 20:12:59');
INSERT INTO `access_log` VALUES (34814, '65.45.15602551791296585', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:59', 0, 1002001015, '账号未登陆', '2019-06-11 20:12:59');
INSERT INTO `access_log` VALUES (34815, '65.47.15602551791326571', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:12:59', 1, 1002001015, '账号未登陆', '2019-06-11 20:12:59');
INSERT INTO `access_log` VALUES (34816, '59.73.15602551835126135', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:04', 3, 0, '', '2019-06-11 20:13:04');
INSERT INTO `access_log` VALUES (34817, '59.71.15602551835126133', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:04', 20, 2001001000, '服务端发生异常', '2019-06-11 20:13:04');
INSERT INTO `access_log` VALUES (34818, '65.53.15602551855496553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:13:06', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 20:13:06');
INSERT INTO `access_log` VALUES (34819, '64.76.15602551858636037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:06', 2, 0, '', '2019-06-11 20:13:06');
INSERT INTO `access_log` VALUES (34820, '64.79.15602551859586039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:06', 2, 0, '', '2019-06-11 20:13:06');
INSERT INTO `access_log` VALUES (34821, '64.83.15602551868166035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:07', 2, 0, '', '2019-06-11 20:13:07');
INSERT INTO `access_log` VALUES (34822, '64.84.15602551874166049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:07', 375, 0, '', '2019-06-11 20:13:08');
INSERT INTO `access_log` VALUES (34823, '64.81.15602551877666043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:08', 25, 0, '', '2019-06-11 20:13:08');
INSERT INTO `access_log` VALUES (34824, '64.77.15602551879906053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:08', 3, 0, '', '2019-06-11 20:13:08');
INSERT INTO `access_log` VALUES (34825, '59.72.15602551899466133', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:10', 2, 0, '', '2019-06-11 20:13:10');
INSERT INTO `access_log` VALUES (34826, '59.77.15602551899466123', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:10', 33, 2001001000, '服务端发生异常', '2019-06-11 20:13:10');
INSERT INTO `access_log` VALUES (34827, '64.85.15602551964396061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:16', 2, 0, '', '2019-06-11 20:13:16');
INSERT INTO `access_log` VALUES (34828, '64.80.15602551965446039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:17', 1, 0, '', '2019-06-11 20:13:17');
INSERT INTO `access_log` VALUES (34829, '64.78.15602551982326049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:18', 2, 0, '', '2019-06-11 20:13:18');
INSERT INTO `access_log` VALUES (34830, '64.82.15602551985116055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:19', 1, 0, '', '2019-06-11 20:13:19');
INSERT INTO `access_log` VALUES (34831, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:20', 9, 0, '', '2019-06-11 20:13:20');
INSERT INTO `access_log` VALUES (34832, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:20', 6, 0, '', '2019-06-11 20:13:20');
INSERT INTO `access_log` VALUES (34833, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:20', 13, 0, '', '2019-06-11 20:13:20');
INSERT INTO `access_log` VALUES (34834, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:20', 16, 0, '', '2019-06-11 20:13:20');
INSERT INTO `access_log` VALUES (34835, '65.50.15602552004706587', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:13:20', 98, 0, '', '2019-06-11 20:13:21');
INSERT INTO `access_log` VALUES (34836, '65.3607.15602552009508341', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:13:21', 10, 0, '', '2019-06-11 20:13:21');
INSERT INTO `access_log` VALUES (34837, '65.49.15602552009506601', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:13:21', 11, 0, '', '2019-06-11 20:13:21');
INSERT INTO `access_log` VALUES (34838, '65.46.15602552009156579', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:13:21', 86, 2001001000, '服务端发生异常', '2019-06-11 20:13:21');
INSERT INTO `access_log` VALUES (34839, '64.79.15602552017176041', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:22', 329, 0, '', '2019-06-11 20:13:22');
INSERT INTO `access_log` VALUES (34840, '65.52.15602552061976589', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:13:26', 9, 0, '', '2019-06-11 20:13:26');
INSERT INTO `access_log` VALUES (34841, '65.45.15602552062006587', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:13:26', 16, 0, '', '2019-06-11 20:13:26');
INSERT INTO `access_log` VALUES (34842, '65.47.15602552061976573', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:13:26', 77, 2001001000, '服务端发生异常', '2019-06-11 20:13:26');
INSERT INTO `access_log` VALUES (34843, '66.53.15602552299754585', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13516451223', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:50', 102, 0, '', '2019-06-11 20:13:50');
INSERT INTO `access_log` VALUES (34844, '66.50.15602552382954581', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13516451223&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:13:58', 210, 0, '', '2019-06-11 20:13:59');
INSERT INTO `access_log` VALUES (34845, '66.52.15602552398884589', 121, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:14:00', 7, 0, '', '2019-06-11 20:14:00');
INSERT INTO `access_log` VALUES (34846, '65.45.15602552593846589', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.164.56.129', '2019-06-11 20:14:19', 118, 0, '', '2019-06-11 20:14:20');
INSERT INTO `access_log` VALUES (34847, '65.52.15602552603566591', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.164.56.129', '2019-06-11 20:14:20', 9, 0, '', '2019-06-11 20:14:20');
INSERT INTO `access_log` VALUES (34848, '65.53.15602552603746557', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.164.56.129', '2019-06-11 20:14:20', 9, 0, '', '2019-06-11 20:14:20');
INSERT INTO `access_log` VALUES (34849, '65.47.15602552603676575', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.164.56.129', '2019-06-11 20:14:20', 87, 2001001000, '服务端发生异常', '2019-06-11 20:14:20');
INSERT INTO `access_log` VALUES (34850, '66.57.15602552630134593', 121, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:14:23', 6, 0, '', '2019-06-11 20:14:23');
INSERT INTO `access_log` VALUES (34851, '66.51.15602552827054593', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=12312332333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=false&address=23&areaNo=110101&mobile=12312332333&hasDefault=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:14:43', 89, 2001001000, '服务端发生异常', '2019-06-11 20:14:43');
INSERT INTO `access_log` VALUES (34852, '66.50.15602552848724583', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=12312332333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=false&address=23&areaNo=110101&mobile=12312332333&hasDefault=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:14:45', 1318, 2001001000, '服务端发生异常', '2019-06-11 20:14:46');
INSERT INTO `access_log` VALUES (34853, '66.49.15602552860314605', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=12312332333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=false&address=23&areaNo=110101&mobile=12312332333&hasDefault=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:14:46', 158, 2001001000, '服务端发生异常', '2019-06-11 20:14:46');
INSERT INTO `access_log` VALUES (34854, '66.54.15602552956054593', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=false&address=23&areaNo=110101&mobile=13514532333&hasDefault=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:14:56', 86, 2001001000, '服务端发生异常', '2019-06-11 20:14:56');
INSERT INTO `access_log` VALUES (34855, '66.57.15602553002924595', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:00', 176, 2001001000, '服务端发生异常', '2019-06-11 20:15:00');
INSERT INTO `access_log` VALUES (34856, '66.57.15602553002924595', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:00', 176, 2001001000, '服务端发生异常', '2019-06-11 20:15:01');
INSERT INTO `access_log` VALUES (34857, '66.53.15602553015874589', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:02', 694, 2001001000, '服务端发生异常', '2019-06-11 20:15:02');
INSERT INTO `access_log` VALUES (34858, '66.53.15602553015874589', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:02', 694, 2001001000, '服务端发生异常', '2019-06-11 20:15:03');
INSERT INTO `access_log` VALUES (34859, '66.51.15602553017994595', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:02', 2148, 2001001000, '服务端发生异常', '2019-06-11 20:15:04');
INSERT INTO `access_log` VALUES (34860, '66.55.15602553012564589', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:01', 3039, 2001001000, '服务端发生异常', '2019-06-11 20:15:04');
INSERT INTO `access_log` VALUES (34861, '66.52.15602553023164593', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:02', 1982, 2001001000, '服务端发生异常', '2019-06-11 20:15:04');
INSERT INTO `access_log` VALUES (34862, '66.50.15602553021354585', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:02', 2262, 2001001000, '服务端发生异常', '2019-06-11 20:15:04');
INSERT INTO `access_log` VALUES (34863, '66.49.15602553019704607', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:02', 2428, 2001001000, '服务端发生异常', '2019-06-11 20:15:04');
INSERT INTO `access_log` VALUES (34864, '65.50.15602570671126615', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:44:27', 1, 1002001015, '账号未登陆', '2019-06-11 20:44:27');
INSERT INTO `access_log` VALUES (34865, '65.49.15602570673206629', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:44:27', 1, 1002001015, '账号未登陆', '2019-06-11 20:44:27');
INSERT INTO `access_log` VALUES (34866, '65.3607.15602570673608367', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:44:27', 0, 1002001015, '账号未登陆', '2019-06-11 20:44:27');
INSERT INTO `access_log` VALUES (34867, '65.46.15602570708786607', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:44:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 20:44:31');
INSERT INTO `access_log` VALUES (34868, '65.51.15602570765086615', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:44:37', 68, 0, '', '2019-06-11 20:44:37');
INSERT INTO `access_log` VALUES (34869, '65.45.15602570771826615', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:44:37', 10, 0, '', '2019-06-11 20:44:37');
INSERT INTO `access_log` VALUES (34870, '65.53.15602570772436583', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:44:37', 9, 0, '', '2019-06-11 20:44:37');
INSERT INTO `access_log` VALUES (34871, '65.52.15602570772216617', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:44:37', 61, 2001001000, '服务端发生异常', '2019-06-11 20:44:37');
INSERT INTO `access_log` VALUES (34872, '65.54.15602570888226573', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:44:49', 10, 0, '', '2019-06-11 20:44:49');
INSERT INTO `access_log` VALUES (34873, '65.49.15602570889476631', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:44:49', 10, 0, '', '2019-06-11 20:44:49');
INSERT INTO `access_log` VALUES (34874, '65.50.15602570888566617', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:44:49', 186, 2001001000, '服务端发生异常', '2019-06-11 20:44:49');
INSERT INTO `access_log` VALUES (34875, '59.79.15602571801346165', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:46:20', 9, 0, '', '2019-06-11 20:46:20');
INSERT INTO `access_log` VALUES (34876, '59.76.15602571801706153', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:46:20', 12, 2001001000, '服务端发生异常', '2019-06-11 20:46:20');
INSERT INTO `access_log` VALUES (34877, '64.84.15602571848696077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:46:25', 11, 0, '', '2019-06-11 20:46:25');
INSERT INTO `access_log` VALUES (34878, '64.77.15602571853746081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:46:25', 576, 0, '', '2019-06-11 20:46:26');
INSERT INTO `access_log` VALUES (34879, '64.85.15602571882446089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:46:28', 1, 0, '', '2019-06-11 20:46:28');
INSERT INTO `access_log` VALUES (34880, '64.78.15602571962046077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:46:36', 2, 0, '', '2019-06-11 20:46:36');
INSERT INTO `access_log` VALUES (34881, '64.82.15602571966496083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:46:37', 2, 0, '', '2019-06-11 20:46:37');
INSERT INTO `access_log` VALUES (34882, '59.71.15602571978396161', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:46:38', 3, 0, '', '2019-06-11 20:46:38');
INSERT INTO `access_log` VALUES (34883, '59.80.15602571978606149', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:46:38', 22, 2001001000, '服务端发生异常', '2019-06-11 20:46:38');
INSERT INTO `access_log` VALUES (34884, '59.80.15602600312046187', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.122', '2019-06-11 21:33:51', 11, 0, '', '2019-06-11 21:33:51');
INSERT INTO `access_log` VALUES (34885, '59.72.15602600312346199', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.122', '2019-06-11 21:33:51', 12, 2001001000, '服务端发生异常', '2019-06-11 21:33:51');
INSERT INTO `access_log` VALUES (34886, '64.78.15602600335606115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.122', '2019-06-11 21:33:54', 13, 0, '', '2019-06-11 21:33:54');
INSERT INTO `access_log` VALUES (34887, '64.82.15602600337626121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.122', '2019-06-11 21:33:54', 5, 0, '', '2019-06-11 21:33:54');
INSERT INTO `access_log` VALUES (34888, '64.76.15602600352936105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.122', '2019-06-11 21:33:55', 3, 0, '', '2019-06-11 21:33:55');
INSERT INTO `access_log` VALUES (34889, '64.83.15602600363606103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.122', '2019-06-11 21:33:56', 1, 0, '', '2019-06-11 21:33:56');
INSERT INTO `access_log` VALUES (34890, '64.81.15602600369286109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.193.60.122', '2019-06-11 21:33:57', 202, 0, '', '2019-06-11 21:33:57');
INSERT INTO `access_log` VALUES (34891, '0d6b0c69-93c4-4988-ac95-9b7e970465f5', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 21:51:57', 1189, 1002001011, '访问令牌不存在', '2019-06-11 21:51:58');
INSERT INTO `access_log` VALUES (34892, 'b9904ab1-2801-48fc-b10f-f45cb87f6f2c', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 21:51:57', 1190, 1002001011, '访问令牌不存在', '2019-06-11 21:51:58');
INSERT INTO `access_log` VALUES (34893, 'ab0b0c18-3a90-4562-866f-faba3c3a3415', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 21:51:57', 1190, 1002001011, '访问令牌不存在', '2019-06-11 21:51:58');
INSERT INTO `access_log` VALUES (34894, '6fedf441-7abe-444c-a8dc-b433cdc2ac78', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 21:52:06', 390, 1002002001, '密码不正确', '2019-06-11 21:52:06');
INSERT INTO `access_log` VALUES (34895, '21ed0961-61ba-44c4-9e7b-ade1690ef745', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=18817715513&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 21:58:42', 2582, 0, '', '2019-06-11 21:58:44');
INSERT INTO `access_log` VALUES (34896, 'dec0a1af-dce9-4719-8ffa-17b1aa4ab0ee', 14, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 21:58:45', 331, 0, '', '2019-06-11 21:58:45');
INSERT INTO `access_log` VALUES (34897, '7dc9a528-bd21-40d0-b999-d9154d98cb10', 14, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 21:58:45', 372, 0, '', '2019-06-11 21:58:46');
INSERT INTO `access_log` VALUES (34898, 'aa5c4631-0162-4944-9508-80283fbf74cd', 14, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 21:58:45', 312, 0, '', '2019-06-11 21:58:45');
INSERT INTO `access_log` VALUES (34899, '22d7f0e1-707d-414a-b98f-44e0cba50853', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 21:58:58', 58, 1002002001, '密码不正确', '2019-06-11 21:58:58');
INSERT INTO `access_log` VALUES (34900, '993af053-73a9-4bc5-b7ee-e90fc9aee445', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 22:00:26', 109, 1002002001, '密码不正确', '2019-06-11 22:00:26');
INSERT INTO `access_log` VALUES (34901, '5b08f966-b113-4c86-9843-420e5eaf7f9f', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 22:00:37', 344, 1002002001, '密码不正确', '2019-06-11 22:00:37');
INSERT INTO `access_log` VALUES (34902, '279379d8-fa69-4374-8b94-425ae3044996', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 22:01:14', 425, 0, '', '2019-06-11 22:01:14');
INSERT INTO `access_log` VALUES (34903, '5e13a597-96d9-41d3-9d1f-b16fb35e0708', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 22:01:15', 393, 0, '', '2019-06-11 22:01:15');
INSERT INTO `access_log` VALUES (34904, '478b127c-45d0-433a-b909-8414d13f33f5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 22:01:15', 426, 0, '', '2019-06-11 22:01:15');
INSERT INTO `access_log` VALUES (34905, '11b10d98-ae9f-45f3-9ff2-30b6743a009d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 22:01:15', 436, 0, '', '2019-06-11 22:01:15');
INSERT INTO `access_log` VALUES (34906, '677ea5de-9ed3-44a9-a6ec-a56e93d9d061', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 22:01:19', 1717, 0, '', '2019-06-11 22:01:21');
INSERT INTO `access_log` VALUES (34907, 'f1ed7fde-65ab-4894-b793-bd92e2fbdbb6', 1, 2, 'order-impl', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 22:01:24', 2365, 0, '', '2019-06-11 22:01:26');
INSERT INTO `access_log` VALUES (34908, '0ddfc734-7beb-42ee-b406-1c437379b5dd', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 22:01:33', 349, 0, '', '2019-06-11 22:01:33');
INSERT INTO `access_log` VALUES (34909, '94182037-de7f-45c6-83cf-62e822eee8a2', 1, 2, 'order-impl', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 22:01:37', 529, 0, '', '2019-06-11 22:01:37');
INSERT INTO `access_log` VALUES (34910, '59.78.15602616980496221', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.44.107.41', '2019-06-11 22:01:38', 112, 0, '', '2019-06-11 22:01:38');
INSERT INTO `access_log` VALUES (34911, '59.75.15602616984686225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.44.107.41', '2019-06-11 22:01:38', 13, 2001001000, '服务端发生异常', '2019-06-11 22:01:38');
INSERT INTO `access_log` VALUES (34912, '1ecbecb4-cfb3-4b30-b1ae-59e38950c1a7', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 22:01:42', 651, 0, '', '2019-06-11 22:01:43');
INSERT INTO `access_log` VALUES (34913, '8bc838b3-96ba-4b5e-a56e-6960d137407d', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-11 22:03:15', 315, 0, '', '2019-06-11 22:03:16');
INSERT INTO `access_log` VALUES (34914, '59.72.15602619218066225', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:05:22', 3, 0, '', '2019-06-11 22:05:22');
INSERT INTO `access_log` VALUES (34915, '59.80.15602619217996213', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:05:22', 13, 2001001000, '服务端发生异常', '2019-06-11 22:05:22');
INSERT INTO `access_log` VALUES (34916, '59.77.15602619260006215', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:05:26', 2, 0, '', '2019-06-11 22:05:26');
INSERT INTO `access_log` VALUES (34917, '59.78.15602619260046225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:05:26', 17, 2001001000, '服务端发生异常', '2019-06-11 22:05:26');
INSERT INTO `access_log` VALUES (34918, '64.82.15602619299146147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:05:30', 12, 0, '', '2019-06-11 22:05:30');
INSERT INTO `access_log` VALUES (34919, '64.76.15602619301246131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:05:30', 2, 0, '', '2019-06-11 22:05:30');
INSERT INTO `access_log` VALUES (34920, '64.83.15602619314396129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:05:31', 2, 0, '', '2019-06-11 22:05:31');
INSERT INTO `access_log` VALUES (34921, '64.81.15602619320566135', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:05:32', 1, 0, '', '2019-06-11 22:05:32');
INSERT INTO `access_log` VALUES (34922, '64.84.15602619326126143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:05:33', 2, 0, '', '2019-06-11 22:05:33');
INSERT INTO `access_log` VALUES (34923, '59.75.15602619339936229', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:05:34', 2, 0, '', '2019-06-11 22:05:34');
INSERT INTO `access_log` VALUES (34924, '59.74.15602619339976221', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:05:34', 17, 2001001000, '服务端发生异常', '2019-06-11 22:05:34');
INSERT INTO `access_log` VALUES (34925, '65.47.15602622815956671', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.87.180.119', '2019-06-11 22:11:22', 1, 1002001015, '账号未登陆', '2019-06-11 22:11:22');
INSERT INTO `access_log` VALUES (34926, '65.54.15602622815996643', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.87.180.119', '2019-06-11 22:11:22', 0, 1002001015, '账号未登陆', '2019-06-11 22:11:22');
INSERT INTO `access_log` VALUES (34927, '65.49.15602622816026701', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.87.180.119', '2019-06-11 22:11:22', 0, 1002001015, '账号未登陆', '2019-06-11 22:11:22');
INSERT INTO `access_log` VALUES (34928, '65.3607.15602622878198439', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.87.180.119', '2019-06-11 22:11:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 22:11:28');
INSERT INTO `access_log` VALUES (34929, '65.46.15602622933256679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.87.180.119', '2019-06-11 22:11:33', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 22:11:33');
INSERT INTO `access_log` VALUES (34930, '59.75.15602623504666235', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.119.187.18', '2019-06-11 22:12:30', 4, 0, '', '2019-06-11 22:12:30');
INSERT INTO `access_log` VALUES (34931, '59.79.15602623504676237', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '113.119.187.18', '2019-06-11 22:12:30', 47, 2001001000, '服务端发生异常', '2019-06-11 22:12:31');
INSERT INTO `access_log` VALUES (34932, '65.45.15602627444846693', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '59.47.37.199', '2019-06-11 22:19:04', 0, 1002001015, '账号未登陆', '2019-06-11 22:19:04');
INSERT INTO `access_log` VALUES (34933, '65.51.15602627444846693', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '59.47.37.199', '2019-06-11 22:19:04', 1, 1002001015, '账号未登陆', '2019-06-11 22:19:04');
INSERT INTO `access_log` VALUES (34934, '65.53.15602627444906661', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '59.47.37.199', '2019-06-11 22:19:04', 0, 1002001015, '账号未登陆', '2019-06-11 22:19:04');
INSERT INTO `access_log` VALUES (34935, '65.54.15602627706276651', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '59.47.37.199', '2019-06-11 22:19:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 22:19:31');
INSERT INTO `access_log` VALUES (34936, '65.50.15602627792946695', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '59.47.37.199', '2019-06-11 22:19:39', 93, 0, '', '2019-06-11 22:19:39');
INSERT INTO `access_log` VALUES (34937, '65.3607.15602627800228447', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '59.47.37.199', '2019-06-11 22:19:40', 11, 0, '', '2019-06-11 22:19:40');
INSERT INTO `access_log` VALUES (34938, '65.45.15602627800526695', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '59.47.37.199', '2019-06-11 22:19:40', 8, 0, '', '2019-06-11 22:19:40');
INSERT INTO `access_log` VALUES (34939, '65.46.15602627800296687', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '59.47.37.199', '2019-06-11 22:19:40', 99, 2001001000, '服务端发生异常', '2019-06-11 22:19:40');
INSERT INTO `access_log` VALUES (34940, '65.51.15602628048016695', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.159', '2019-06-11 22:20:05', 1, 1002001015, '账号未登陆', '2019-06-11 22:20:05');
INSERT INTO `access_log` VALUES (34941, '59.79.15602633867546251', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 22:29:47', 4, 0, '', '2019-06-11 22:29:47');
INSERT INTO `access_log` VALUES (34942, '59.74.15602633867896241', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 22:29:47', 20, 2001001000, '服务端发生异常', '2019-06-11 22:29:47');
INSERT INTO `access_log` VALUES (34943, '59.80.15602635960176237', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:33:16', 15, 2001001000, '服务端发生异常', '2019-06-11 22:33:16');
INSERT INTO `access_log` VALUES (34944, '59.78.15602635960276249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:33:16', 17, 0, '', '2019-06-11 22:33:16');
INSERT INTO `access_log` VALUES (34945, '65.47.15602640535226699', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:40:54', 0, 1002001015, '账号未登陆', '2019-06-11 22:40:54');
INSERT INTO `access_log` VALUES (34946, '65.54.15602640535236669', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:40:54', 1, 1002001015, '账号未登陆', '2019-06-11 22:40:54');
INSERT INTO `access_log` VALUES (34947, '65.49.15602640535406727', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:40:54', 0, 1002001015, '账号未登陆', '2019-06-11 22:40:54');
INSERT INTO `access_log` VALUES (34948, '65.46.15602642351836707', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:43:55', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 22:43:55');
INSERT INTO `access_log` VALUES (34949, '65.53.15602642450466683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:44:05', 55, 0, '', '2019-06-11 22:44:05');
INSERT INTO `access_log` VALUES (34950, '65.51.15602642458556715', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:44:06', 10, 0, '', '2019-06-11 22:44:06');
INSERT INTO `access_log` VALUES (34951, '65.52.15602642458636719', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:44:06', 81, 2001001000, '服务端发生异常', '2019-06-11 22:44:06');
INSERT INTO `access_log` VALUES (34952, '65.49.15602642459456731', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:44:06', 11, 0, '', '2019-06-11 22:44:06');
INSERT INTO `access_log` VALUES (34953, '65.47.15602642549436703', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:44:15', 10, 0, '', '2019-06-11 22:44:15');
INSERT INTO `access_log` VALUES (34954, '65.50.15602642549436721', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:44:15', 10, 0, '', '2019-06-11 22:44:15');
INSERT INTO `access_log` VALUES (34955, '65.45.15602642549436719', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:44:15', 69, 2001001000, '服务端发生异常', '2019-06-11 22:44:15');
INSERT INTO `access_log` VALUES (34956, '59.79.15602649769376273', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:17', 3, 0, '', '2019-06-11 22:56:17');
INSERT INTO `access_log` VALUES (34957, '59.74.15602649769406263', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:17', 12, 2001001000, '服务端发生异常', '2019-06-11 22:56:17');
INSERT INTO `access_log` VALUES (34958, '64.80.15602649828756179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:23', 11, 0, '', '2019-06-11 22:56:23');
INSERT INTO `access_log` VALUES (34959, '64.79.15602649830006175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:23', 3, 0, '', '2019-06-11 22:56:23');
INSERT INTO `access_log` VALUES (34960, '64.78.15602649843686185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:24', 2, 0, '', '2019-06-11 22:56:24');
INSERT INTO `access_log` VALUES (34961, '64.82.15602649851926189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:25', 2, 0, '', '2019-06-11 22:56:25');
INSERT INTO `access_log` VALUES (34962, '64.76.15602649859896173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:26', 2, 0, '', '2019-06-11 22:56:26');
INSERT INTO `access_log` VALUES (34963, '64.81.15602649863416177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:26', 2, 0, '', '2019-06-11 22:56:26');
INSERT INTO `access_log` VALUES (34964, '59.73.15602649883326271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:28', 3, 0, '', '2019-06-11 22:56:28');
INSERT INTO `access_log` VALUES (34965, '59.71.15602649883326269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:28', 12, 2001001000, '服务端发生异常', '2019-06-11 22:56:28');
INSERT INTO `access_log` VALUES (34966, '64.83.15602649922586171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:32', 2, 0, '', '2019-06-11 22:56:32');
INSERT INTO `access_log` VALUES (34967, '64.84.15602649923266187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:32', 2, 0, '', '2019-06-11 22:56:32');
INSERT INTO `access_log` VALUES (34968, '64.85.15602649933266199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:33', 2, 0, '', '2019-06-11 22:56:33');
INSERT INTO `access_log` VALUES (34969, '64.77.15602649938326189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:34', 2, 0, '', '2019-06-11 22:56:34');
INSERT INTO `access_log` VALUES (34970, '64.80.15602649948386181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:35', 2, 0, '', '2019-06-11 22:56:35');
INSERT INTO `access_log` VALUES (34971, '59.80.15602649972716257', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:37', 2, 0, '', '2019-06-11 22:56:37');
INSERT INTO `access_log` VALUES (34972, '59.78.15602649972726269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:37', 13, 2001001000, '服务端发生异常', '2019-06-11 22:56:37');
INSERT INTO `access_log` VALUES (34973, '65.3607.15602650062598479', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:46', 1, 1002001015, '账号未登陆', '2019-06-11 22:56:46');
INSERT INTO `access_log` VALUES (34974, '65.46.15602650062606719', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:46', 1, 1002001015, '账号未登陆', '2019-06-11 22:56:46');
INSERT INTO `access_log` VALUES (34975, '65.53.15602650062636695', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:46', 0, 1002001015, '账号未登陆', '2019-06-11 22:56:46');
INSERT INTO `access_log` VALUES (34976, '65.51.15602650092116727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-11 22:56:49');
INSERT INTO `access_log` VALUES (34977, '65.52.15602650192296731', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:56:59', 94, 0, '', '2019-06-11 22:56:59');
INSERT INTO `access_log` VALUES (34978, '65.54.15602650195216685', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:57:00', 44, 0, '', '2019-06-11 22:57:00');
INSERT INTO `access_log` VALUES (34979, '65.47.15602650195246715', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:57:00', 41, 0, '', '2019-06-11 22:57:00');
INSERT INTO `access_log` VALUES (34980, '65.50.15602650195216733', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:57:00', 135, 2001001000, '服务端发生异常', '2019-06-11 22:57:00');
INSERT INTO `access_log` VALUES (34981, '59.78.15602738430746387', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:03', 11, 0, '', '2019-06-12 01:24:03');
INSERT INTO `access_log` VALUES (34982, '59.77.15602738430746377', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:03', 17, 2001001000, '服务端发生异常', '2019-06-12 01:24:03');
INSERT INTO `access_log` VALUES (34983, '64.78.15602738507716305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:11', 11, 0, '', '2019-06-12 01:24:11');
INSERT INTO `access_log` VALUES (34984, '64.82.15602738509506309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:11', 2, 0, '', '2019-06-12 01:24:11');
INSERT INTO `access_log` VALUES (34985, '64.76.15602738547106293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:15', 2, 0, '', '2019-06-12 01:24:15');
INSERT INTO `access_log` VALUES (34986, '64.81.15602738559106297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:16', 2, 0, '', '2019-06-12 01:24:16');
INSERT INTO `access_log` VALUES (34987, '59.79.15602738586746393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:19', 3, 0, '', '2019-06-12 01:24:19');
INSERT INTO `access_log` VALUES (34988, '59.74.15602738586746383', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:19', 13, 2001001000, '服务端发生异常', '2019-06-12 01:24:19');
INSERT INTO `access_log` VALUES (34989, '66.50.15602738715914833', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-12 01:24:32');
INSERT INTO `access_log` VALUES (34990, '59.73.15602738759956391', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:36', 2, 0, '', '2019-06-12 01:24:36');
INSERT INTO `access_log` VALUES (34991, '59.72.15602738759956389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:36', 13, 2001001000, '服务端发生异常', '2019-06-12 01:24:36');
INSERT INTO `access_log` VALUES (34992, '64.85.15602738786426319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:39', 2, 0, '', '2019-06-12 01:24:39');
INSERT INTO `access_log` VALUES (34993, '64.77.15602738789906309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:39', 2, 0, '', '2019-06-12 01:24:39');
INSERT INTO `access_log` VALUES (34994, '59.80.15602738801746377', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:40', 2, 0, '', '2019-06-12 01:24:40');
INSERT INTO `access_log` VALUES (34995, '59.77.15602738801746379', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.90.128.23', '2019-06-12 01:24:40', 13, 2001001000, '服务端发生异常', '2019-06-12 01:24:40');
INSERT INTO `access_log` VALUES (34996, '59.76.15602970386266691', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:39', 11, 0, '', '2019-06-12 07:50:39');
INSERT INTO `access_log` VALUES (34997, '59.71.15602970386396699', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:39', 14, 2001001000, '服务端发生异常', '2019-06-12 07:50:39');
INSERT INTO `access_log` VALUES (34998, '64.76.15602970425816603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:43', 11, 0, '', '2019-06-12 07:50:43');
INSERT INTO `access_log` VALUES (34999, '64.81.15602970427596607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:43', 3, 0, '', '2019-06-12 07:50:43');
INSERT INTO `access_log` VALUES (35000, '64.83.15602970438826601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:44', 36, 0, '', '2019-06-12 07:50:44');
INSERT INTO `access_log` VALUES (35001, '64.84.15602970444486617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:44', 2, 0, '', '2019-06-12 07:50:44');
INSERT INTO `access_log` VALUES (35002, '59.73.15602970455606701', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:46', 3, 0, '', '2019-06-12 07:50:46');
INSERT INTO `access_log` VALUES (35003, '59.72.15602970455686699', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:46', 12, 2001001000, '服务端发生异常', '2019-06-12 07:50:46');
INSERT INTO `access_log` VALUES (35004, '64.85.15602970478186629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:48', 2, 0, '', '2019-06-12 07:50:48');
INSERT INTO `access_log` VALUES (35005, '64.77.15602970480056619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:48', 2, 0, '', '2019-06-12 07:50:48');
INSERT INTO `access_log` VALUES (35006, '59.78.15602970491706699', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:49', 2, 0, '', '2019-06-12 07:50:49');
INSERT INTO `access_log` VALUES (35007, '59.77.15602970491636689', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:49', 13, 2001001000, '服务端发生异常', '2019-06-12 07:50:49');
INSERT INTO `access_log` VALUES (35008, '64.79.15602970518706607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:52', 3, 0, '', '2019-06-12 07:50:52');
INSERT INTO `access_log` VALUES (35009, '64.78.15602970520276617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:52', 2, 0, '', '2019-06-12 07:50:52');
INSERT INTO `access_log` VALUES (35010, '64.82.15602970531986621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:53', 1, 0, '', '2019-06-12 07:50:53');
INSERT INTO `access_log` VALUES (35011, '64.76.15602970537246605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:54', 2, 0, '', '2019-06-12 07:50:54');
INSERT INTO `access_log` VALUES (35012, '59.79.15602970548666705', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:55', 2, 0, '', '2019-06-12 07:50:55');
INSERT INTO `access_log` VALUES (35013, '59.75.15602970548596703', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:50:55', 12, 2001001000, '服务端发生异常', '2019-06-12 07:50:55');
INSERT INTO `access_log` VALUES (35014, '64.83.15602970678326603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:51:08', 1, 0, '', '2019-06-12 07:51:08');
INSERT INTO `access_log` VALUES (35015, '64.84.15602970679946619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:51:08', 1, 0, '', '2019-06-12 07:51:08');
INSERT INTO `access_log` VALUES (35016, '64.77.15602970835006621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:51:24', 2, 0, '', '2019-06-12 07:51:24');
INSERT INTO `access_log` VALUES (35017, '64.80.15602970836486613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:51:24', 2, 0, '', '2019-06-12 07:51:24');
INSERT INTO `access_log` VALUES (35018, '64.79.15602970847006609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:51:25', 220, 0, '', '2019-06-12 07:51:25');
INSERT INTO `access_log` VALUES (35019, '64.78.15602970853876619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:51:25', 2, 0, '', '2019-06-12 07:51:25');
INSERT INTO `access_log` VALUES (35020, '64.82.15602970882776623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:51:28', 2, 0, '', '2019-06-12 07:51:28');
INSERT INTO `access_log` VALUES (35021, '64.76.15602970888416607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.4.12.74', '2019-06-12 07:51:29', 1, 0, '', '2019-06-12 07:51:29');
INSERT INTO `access_log` VALUES (35022, '65.3607.15602999217308949', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:38:42', 11, 1002001012, '访问令牌已过期', '2019-06-12 08:38:42');
INSERT INTO `access_log` VALUES (35023, '65.54.15602999217317151', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:38:42', 13, 1002001012, '访问令牌已过期', '2019-06-12 08:38:42');
INSERT INTO `access_log` VALUES (35024, '65.51.15602999217517197', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:38:42', 9, 1002001012, '访问令牌已过期', '2019-06-12 08:38:42');
INSERT INTO `access_log` VALUES (35025, '65.45.15602999285467199', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:38:49', 65, 0, '', '2019-06-12 08:38:49');
INSERT INTO `access_log` VALUES (35026, '65.49.15602999288057211', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:38:49', 9, 0, '', '2019-06-12 08:38:49');
INSERT INTO `access_log` VALUES (35027, '65.46.15602999288107189', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:38:49', 10, 0, '', '2019-06-12 08:38:49');
INSERT INTO `access_log` VALUES (35028, '65.52.15602999288077199', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:38:49', 61, 2001001000, '服务端发生异常', '2019-06-12 08:38:49');
INSERT INTO `access_log` VALUES (35029, '65.47.15602999397477183', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:39:00', 9, 0, '', '2019-06-12 08:39:00');
INSERT INTO `access_log` VALUES (35030, '65.3607.15602999397488951', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:39:00', 10, 0, '', '2019-06-12 08:39:00');
INSERT INTO `access_log` VALUES (35031, '65.53.15602999397477163', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:39:00', 91, 2001001000, '服务端发生异常', '2019-06-12 08:39:00');
INSERT INTO `access_log` VALUES (35032, '59.75.15603000205696743', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.159.4', '2019-06-12 08:40:21', 10, 0, '', '2019-06-12 08:40:21');
INSERT INTO `access_log` VALUES (35033, '59.79.15603000205696745', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.159.4', '2019-06-12 08:40:21', 15, 2001001000, '服务端发生异常', '2019-06-12 08:40:21');
INSERT INTO `access_log` VALUES (35034, '59.71.15603000228246741', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:40:23', 13, 2001001000, '服务端发生异常', '2019-06-12 08:40:23');
INSERT INTO `access_log` VALUES (35035, '59.74.15603000227936735', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:40:23', 635, 0, '', '2019-06-12 08:40:23');
INSERT INTO `access_log` VALUES (35036, '64.79.15603000268036649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:40:27', 10, 0, '', '2019-06-12 08:40:27');
INSERT INTO `access_log` VALUES (35037, '64.78.15603000269826659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:40:27', 2, 0, '', '2019-06-12 08:40:27');
INSERT INTO `access_log` VALUES (35038, '64.82.15603000287626663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:40:29', 2, 0, '', '2019-06-12 08:40:29');
INSERT INTO `access_log` VALUES (35039, '65.50.15603000328337203', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.159.4', '2019-06-12 08:40:33', 1, 1002001015, '账号未登陆', '2019-06-12 08:40:33');
INSERT INTO `access_log` VALUES (35040, '65.47.15603000328387185', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.159.4', '2019-06-12 08:40:33', 0, 1002001015, '账号未登陆', '2019-06-12 08:40:33');
INSERT INTO `access_log` VALUES (35041, '65.3607.15603000328458953', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.159.4', '2019-06-12 08:40:33', 0, 1002001015, '账号未登陆', '2019-06-12 08:40:33');
INSERT INTO `access_log` VALUES (35042, '65.53.15603000348857165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.159.4', '2019-06-12 08:40:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 08:40:35');
INSERT INTO `access_log` VALUES (35043, '65.51.15603000497707201', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.159.4', '2019-06-12 08:40:50', 54, 0, '', '2019-06-12 08:40:50');
INSERT INTO `access_log` VALUES (35044, '65.45.15603000501637203', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.159.4', '2019-06-12 08:40:50', 8, 0, '', '2019-06-12 08:40:50');
INSERT INTO `access_log` VALUES (35045, '65.46.15603000501747193', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.159.4', '2019-06-12 08:40:50', 9, 0, '', '2019-06-12 08:40:50');
INSERT INTO `access_log` VALUES (35046, '65.49.15603000501667215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.159.4', '2019-06-12 08:40:50', 67, 2001001000, '服务端发生异常', '2019-06-12 08:40:50');
INSERT INTO `access_log` VALUES (35047, '62.82.15603005933666549', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '58.49.131.138', '2019-06-12 08:49:53', 10, 1002001012, '访问令牌已过期', '2019-06-12 08:49:53');
INSERT INTO `access_log` VALUES (35048, '59.76.15603006069686741', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 08:50:07', 12, 2001001000, '服务端发生异常', '2019-06-12 08:50:07');
INSERT INTO `access_log` VALUES (35049, '59.71.15603006069666749', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 08:50:07', 910, 0, '', '2019-06-12 08:50:08');
INSERT INTO `access_log` VALUES (35050, '59.76.15603006069686741', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 08:50:07', 12, 2001001000, '服务端发生异常', '2019-06-12 08:50:08');
INSERT INTO `access_log` VALUES (35051, '64.84.15603008165546671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 08:53:37', 3, 0, '', '2019-06-12 08:53:37');
INSERT INTO `access_log` VALUES (35052, '64.85.15603008167036683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 08:53:37', 2, 0, '', '2019-06-12 08:53:37');
INSERT INTO `access_log` VALUES (35053, '64.77.15603008188686673', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 08:53:39', 2, 0, '', '2019-06-12 08:53:39');
INSERT INTO `access_log` VALUES (35054, '64.80.15603008202996665', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 08:53:40', 2, 0, '', '2019-06-12 08:53:40');
INSERT INTO `access_log` VALUES (35055, '64.79.15603008216246661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 08:53:42', 66, 0, '', '2019-06-12 08:53:42');
INSERT INTO `access_log` VALUES (35056, '64.78.15603008263046671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 08:53:46', 2, 0, '', '2019-06-12 08:53:46');
INSERT INTO `access_log` VALUES (35057, '64.82.15603008264336675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 08:53:46', 2, 0, '', '2019-06-12 08:53:46');
INSERT INTO `access_log` VALUES (35058, '59.79.15603008309286757', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 08:53:51', 3, 0, '', '2019-06-12 08:53:51');
INSERT INTO `access_log` VALUES (35059, '59.75.15603008309656755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 08:53:51', 13, 2001001000, '服务端发生异常', '2019-06-12 08:53:51');
INSERT INTO `access_log` VALUES (35060, '65.52.15603012714257221', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 09:01:11', 1, 1002001015, '账号未登陆', '2019-06-12 09:01:11');
INSERT INTO `access_log` VALUES (35061, '65.50.15603012714257223', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 09:01:11', 0, 1002001015, '账号未登陆', '2019-06-12 09:01:11');
INSERT INTO `access_log` VALUES (35062, '65.47.15603012714297203', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 09:01:11', 0, 1002001015, '账号未登陆', '2019-06-12 09:01:11');
INSERT INTO `access_log` VALUES (35063, '59.74.15603012828486753', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 09:01:23', 3, 0, '', '2019-06-12 09:01:23');
INSERT INTO `access_log` VALUES (35064, '59.71.15603012828516759', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 09:01:23', 13, 2001001000, '服务端发生异常', '2019-06-12 09:01:23');
INSERT INTO `access_log` VALUES (35065, '65.53.15603012869317185', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.207', '2019-06-12 09:01:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 09:01:27');
INSERT INTO `access_log` VALUES (35066, '59.72.15603035643086789', 0, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:39:24', 17, 1002001012, '访问令牌已过期', '2019-06-12 09:39:24');
INSERT INTO `access_log` VALUES (35067, '65.51.15603035681827249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:39:28', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 09:39:28');
INSERT INTO `access_log` VALUES (35068, '65.46.15603035753417243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:39:35', 5, 1002002001, '密码不正确', '2019-06-12 09:39:35');
INSERT INTO `access_log` VALUES (35069, '65.47.15603036248587235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:40:25', 104, 0, '', '2019-06-12 09:40:25');
INSERT INTO `access_log` VALUES (35070, '65.3607.15603036253929005', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:40:25', 17, 0, '', '2019-06-12 09:40:25');
INSERT INTO `access_log` VALUES (35071, '65.53.15603036254087217', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:40:25', 11, 0, '', '2019-06-12 09:40:25');
INSERT INTO `access_log` VALUES (35072, '65.54.15603036253977205', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:40:25', 194, 2001001000, '服务端发生异常', '2019-06-12 09:40:26');
INSERT INTO `access_log` VALUES (35073, '65.51.15603036319377251', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:40:32', 9, 0, '', '2019-06-12 09:40:32');
INSERT INTO `access_log` VALUES (35074, '65.45.15603036319517257', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:40:32', 10, 0, '', '2019-06-12 09:40:32');
INSERT INTO `access_log` VALUES (35075, '65.46.15603036319437245', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:40:32', 131, 2001001000, '服务端发生异常', '2019-06-12 09:40:32');
INSERT INTO `access_log` VALUES (35076, '65.50.15603036623717257', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:41:02', 10, 0, '', '2019-06-12 09:41:02');
INSERT INTO `access_log` VALUES (35077, '65.53.15603036623927219', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:41:02', 8, 0, '', '2019-06-12 09:41:02');
INSERT INTO `access_log` VALUES (35078, '65.47.15603036623797237', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:41:02', 689, 2001001000, '服务端发生异常', '2019-06-12 09:41:03');
INSERT INTO `access_log` VALUES (35079, '65.50.15603042233037265', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.22.197.198', '2019-06-12 09:50:23', 0, 1002001015, '账号未登陆', '2019-06-12 09:50:23');
INSERT INTO `access_log` VALUES (35080, '65.53.15603042233067227', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.22.197.198', '2019-06-12 09:50:23', 0, 1002001015, '账号未登陆', '2019-06-12 09:50:23');
INSERT INTO `access_log` VALUES (35081, '65.47.15603042233107245', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.22.197.198', '2019-06-12 09:50:23', 0, 1002001015, '账号未登陆', '2019-06-12 09:50:23');
INSERT INTO `access_log` VALUES (35082, '65.54.15603042327267215', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.22.197.198', '2019-06-12 09:50:33', 88, 0, '', '2019-06-12 09:50:33');
INSERT INTO `access_log` VALUES (35083, '65.45.15603042330407267', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.22.197.198', '2019-06-12 09:50:33', 17, 0, '', '2019-06-12 09:50:33');
INSERT INTO `access_log` VALUES (35084, '65.46.15603042330457255', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.22.197.198', '2019-06-12 09:50:33', 20, 0, '', '2019-06-12 09:50:33');
INSERT INTO `access_log` VALUES (35085, '65.51.15603042330417261', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.22.197.198', '2019-06-12 09:50:33', 133, 2001001000, '服务端发生异常', '2019-06-12 09:50:33');
INSERT INTO `access_log` VALUES (35086, '65.50.15603059218287289', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:18:42', 0, 1002001015, '账号未登陆', '2019-06-12 10:18:42');
INSERT INTO `access_log` VALUES (35087, '65.47.15603059218287269', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:18:42', 0, 1002001015, '账号未登陆', '2019-06-12 10:18:42');
INSERT INTO `access_log` VALUES (35088, '65.53.15603059218297251', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:18:42', 0, 1002001015, '账号未登陆', '2019-06-12 10:18:42');
INSERT INTO `access_log` VALUES (35089, '65.45.15603059350817291', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:18:55', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 10:18:55');
INSERT INTO `access_log` VALUES (35090, '65.46.15603059417317279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:19:02', 334, 0, '', '2019-06-12 10:19:02');
INSERT INTO `access_log` VALUES (35091, '65.51.15603059423117285', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:19:02', 10, 0, '', '2019-06-12 10:19:02');
INSERT INTO `access_log` VALUES (35092, '65.52.15603059423217289', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:19:02', 9, 0, '', '2019-06-12 10:19:02');
INSERT INTO `access_log` VALUES (35093, '65.49.15603059423147301', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:19:02', 118, 2001001000, '服务端发生异常', '2019-06-12 10:19:02');
INSERT INTO `access_log` VALUES (35094, '65.3607.15603059477969041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:19:08', 17, 0, '', '2019-06-12 10:19:08');
INSERT INTO `access_log` VALUES (35095, '65.50.15603059478057291', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:19:08', 9, 0, '', '2019-06-12 10:19:08');
INSERT INTO `access_log` VALUES (35096, '65.47.15603059477977271', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:19:08', 76, 2001001000, '服务端发生异常', '2019-06-12 10:19:08');
INSERT INTO `access_log` VALUES (35097, '65.53.15603059488727253', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:19:09', 9, 0, '', '2019-06-12 10:19:09');
INSERT INTO `access_log` VALUES (35098, '65.45.15603059488807293', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:19:09', 9, 0, '', '2019-06-12 10:19:09');
INSERT INTO `access_log` VALUES (35099, '65.54.15603059488757241', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:19:09', 98, 2001001000, '服务端发生异常', '2019-06-12 10:19:09');
INSERT INTO `access_log` VALUES (35100, '59.79.15603065911556835', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:29:51', 19, 2001001000, '服务端发生异常', '2019-06-12 10:29:51');
INSERT INTO `access_log` VALUES (35101, '59.77.15603065911556819', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:29:51', 222, 0, '', '2019-06-12 10:29:51');
INSERT INTO `access_log` VALUES (35102, '64.77.15603065937696751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:29:54', 29, 0, '', '2019-06-12 10:29:54');
INSERT INTO `access_log` VALUES (35103, '64.80.15603065939576743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:29:54', 3, 0, '', '2019-06-12 10:29:54');
INSERT INTO `access_log` VALUES (35104, '64.79.15603065951136739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:29:55', 2, 0, '', '2019-06-12 10:29:55');
INSERT INTO `access_log` VALUES (35105, '64.78.15603065957366749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:29:56', 2, 0, '', '2019-06-12 10:29:56');
INSERT INTO `access_log` VALUES (35106, '59.75.15603065963976833', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:29:56', 3, 0, '', '2019-06-12 10:29:56');
INSERT INTO `access_log` VALUES (35107, '59.74.15603065963976825', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:29:56', 13, 2001001000, '服务端发生异常', '2019-06-12 10:29:56');
INSERT INTO `access_log` VALUES (35108, '64.82.15603065999886753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:30:00', 2, 0, '', '2019-06-12 10:30:00');
INSERT INTO `access_log` VALUES (35109, '64.76.15603066003016737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:30:00', 2, 0, '', '2019-06-12 10:30:00');
INSERT INTO `access_log` VALUES (35110, '64.81.15603066012736741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:30:01', 2, 0, '', '2019-06-12 10:30:01');
INSERT INTO `access_log` VALUES (35111, '64.76.15603066003016737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:30:00', 2, 0, '', '2019-06-12 10:30:01');
INSERT INTO `access_log` VALUES (35112, '64.83.15603066016006735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:30:02', 323, 0, '', '2019-06-12 10:30:02');
INSERT INTO `access_log` VALUES (35113, '59.71.15603066022536831', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:30:02', 2, 0, '', '2019-06-12 10:30:02');
INSERT INTO `access_log` VALUES (35114, '59.76.15603066022786823', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.193.165.188', '2019-06-12 10:30:02', 12, 2001001000, '服务端发生异常', '2019-06-12 10:30:02');
INSERT INTO `access_log` VALUES (35115, '65.53.15603067889587265', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.71', '2019-06-12 10:33:09', 0, 1002001015, '账号未登陆', '2019-06-12 10:33:09');
INSERT INTO `access_log` VALUES (35116, '65.46.15603067889607293', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.71', '2019-06-12 10:33:09', 1, 1002001015, '账号未登陆', '2019-06-12 10:33:09');
INSERT INTO `access_log` VALUES (35117, '65.45.15603067889717305', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.71', '2019-06-12 10:33:09', 1, 1002001015, '账号未登陆', '2019-06-12 10:33:09');
INSERT INTO `access_log` VALUES (35118, '65.54.15603067946657253', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.71', '2019-06-12 10:33:15', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 10:33:15');
INSERT INTO `access_log` VALUES (35119, '65.51.15603068025487299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.71', '2019-06-12 10:33:23', 98, 0, '', '2019-06-12 10:33:23');
INSERT INTO `access_log` VALUES (35120, '65.52.15603068031237303', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.71', '2019-06-12 10:33:23', 8, 0, '', '2019-06-12 10:33:23');
INSERT INTO `access_log` VALUES (35121, '65.49.15603068031247315', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.71', '2019-06-12 10:33:23', 9, 0, '', '2019-06-12 10:33:23');
INSERT INTO `access_log` VALUES (35122, '65.50.15603068031257305', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.71', '2019-06-12 10:33:23', 79, 2001001000, '服务端发生异常', '2019-06-12 10:33:23');
INSERT INTO `access_log` VALUES (35123, '65.53.15603100757067311', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-06-12 11:27:56', 14, 1002001012, '访问令牌已过期', '2019-06-12 11:27:56');
INSERT INTO `access_log` VALUES (35124, '65.54.15603100757067299', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-06-12 11:27:56', 17, 1002001012, '访问令牌已过期', '2019-06-12 11:27:56');
INSERT INTO `access_log` VALUES (35125, '65.51.15603100757087345', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-06-12 11:27:56', 19, 1002001012, '访问令牌已过期', '2019-06-12 11:27:56');
INSERT INTO `access_log` VALUES (35126, '65.49.15603100784747361', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-06-12 11:27:58', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 11:27:58');
INSERT INTO `access_log` VALUES (35127, '65.52.15603100873607347', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-06-12 11:28:07', 66, 0, '', '2019-06-12 11:28:07');
INSERT INTO `access_log` VALUES (35128, '65.50.15603100876247351', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-06-12 11:28:08', 10, 0, '', '2019-06-12 11:28:08');
INSERT INTO `access_log` VALUES (35129, '65.47.15603100876487331', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-06-12 11:28:08', 10, 0, '', '2019-06-12 11:28:08');
INSERT INTO `access_log` VALUES (35130, '65.3607.15603100876479101', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-06-12 11:28:08', 95, 2001001000, '服务端发生异常', '2019-06-12 11:28:08');
INSERT INTO `access_log` VALUES (35131, '59.79.15603101041316883', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.255.127.49', '2019-06-12 11:28:24', 12, 0, '', '2019-06-12 11:28:24');
INSERT INTO `access_log` VALUES (35132, '59.77.15603101041316867', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.255.127.49', '2019-06-12 11:28:24', 17, 2001001000, '服务端发生异常', '2019-06-12 11:28:24');
INSERT INTO `access_log` VALUES (35133, '64.79.15603101097956787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.255.127.49', '2019-06-12 11:28:30', 10, 0, '', '2019-06-12 11:28:30');
INSERT INTO `access_log` VALUES (35134, '64.78.15603101099146797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.255.127.49', '2019-06-12 11:28:30', 3, 0, '', '2019-06-12 11:28:30');
INSERT INTO `access_log` VALUES (35135, '64.81.15603101113046791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.255.127.49', '2019-06-12 11:28:31', 2, 0, '', '2019-06-12 11:28:31');
INSERT INTO `access_log` VALUES (35136, '64.82.15603101124466803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.255.127.49', '2019-06-12 11:28:32', 171, 0, '', '2019-06-12 11:28:33');
INSERT INTO `access_log` VALUES (35137, '64.83.15603101132076785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.255.127.49', '2019-06-12 11:28:33', 1, 0, '', '2019-06-12 11:28:33');
INSERT INTO `access_log` VALUES (35138, '65.3607.15603101229319103', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-06-12 11:28:43', 0, 1002001015, '账号未登陆', '2019-06-12 11:28:43');
INSERT INTO `access_log` VALUES (35139, '65.46.15603101486857341', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-06-12 11:29:09', 1, 1002001015, '账号未登陆', '2019-06-12 11:29:09');
INSERT INTO `access_log` VALUES (35140, '65.54.15603101547017303', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-06-12 11:29:15', 1, 1002001015, '账号未登陆', '2019-06-12 11:29:15');
INSERT INTO `access_log` VALUES (35141, '65.50.15603104811757357', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.162.87', '2019-06-12 11:34:41', 0, 1002001015, '账号未登陆', '2019-06-12 11:34:41');
INSERT INTO `access_log` VALUES (35142, '65.52.15603104811757355', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.162.87', '2019-06-12 11:34:41', 0, 1002001015, '账号未登陆', '2019-06-12 11:34:41');
INSERT INTO `access_log` VALUES (35143, '65.47.15603104811817337', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.162.87', '2019-06-12 11:34:41', 1, 1002001015, '账号未登陆', '2019-06-12 11:34:41');
INSERT INTO `access_log` VALUES (35144, '65.3607.15603104843709109', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.162.87', '2019-06-12 11:34:44', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 11:34:44');
INSERT INTO `access_log` VALUES (35145, '65.45.15603104887537359', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.162.87', '2019-06-12 11:34:49', 342, 0, '', '2019-06-12 11:34:49');
INSERT INTO `access_log` VALUES (35146, '65.54.15603104894097309', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.162.87', '2019-06-12 11:34:49', 41, 0, '', '2019-06-12 11:34:49');
INSERT INTO `access_log` VALUES (35147, '65.46.15603104894077347', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.162.87', '2019-06-12 11:34:49', 42, 0, '', '2019-06-12 11:34:49');
INSERT INTO `access_log` VALUES (35148, '65.53.15603104894077321', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.162.87', '2019-06-12 11:34:49', 137, 2001001000, '服务端发生异常', '2019-06-12 11:34:50');
INSERT INTO `access_log` VALUES (35149, '59.72.15603106315116885', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.17.197.172', '2019-06-12 11:37:12', 3, 0, '', '2019-06-12 11:37:12');
INSERT INTO `access_log` VALUES (35150, '59.80.15603106315126873', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.17.197.172', '2019-06-12 11:37:12', 11, 2001001000, '服务端发生异常', '2019-06-12 11:37:12');
INSERT INTO `access_log` VALUES (35151, '66.52.15603106398305333', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.17.197.172', '2019-06-12 11:37:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-06-12 11:37:20');
INSERT INTO `access_log` VALUES (35152, '59.71.15603115845586899', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:53:05', 4, 0, '', '2019-06-12 11:53:05');
INSERT INTO `access_log` VALUES (35153, '59.76.15603115845606891', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:53:05', 13, 2001001000, '服务端发生异常', '2019-06-12 11:53:05');
INSERT INTO `access_log` VALUES (35154, '64.76.15603115918466807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:53:12', 3, 0, '', '2019-06-12 11:53:12');
INSERT INTO `access_log` VALUES (35155, '64.84.15603115919676821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:53:12', 2, 0, '', '2019-06-12 11:53:12');
INSERT INTO `access_log` VALUES (35156, '64.85.15603115962796831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:53:16', 2, 0, '', '2019-06-12 11:53:16');
INSERT INTO `access_log` VALUES (35157, '64.80.15603115966336813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:53:17', 2, 0, '', '2019-06-12 11:53:17');
INSERT INTO `access_log` VALUES (35158, '64.79.15603116056046809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:53:26', 3, 0, '', '2019-06-12 11:53:26');
INSERT INTO `access_log` VALUES (35159, '64.78.15603116057086819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:53:26', 2, 0, '', '2019-06-12 11:53:26');
INSERT INTO `access_log` VALUES (35160, '59.80.15603116072096887', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:53:27', 2, 0, '', '2019-06-12 11:53:27');
INSERT INTO `access_log` VALUES (35161, '59.72.15603116072106899', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:53:27', 12, 2001001000, '服务端发生异常', '2019-06-12 11:53:27');
INSERT INTO `access_log` VALUES (35162, '64.81.15603116111676813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:53:31', 2, 0, '', '2019-06-12 11:53:31');
INSERT INTO `access_log` VALUES (35163, '64.82.15603116112966825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:53:31', 2, 0, '', '2019-06-12 11:53:31');
INSERT INTO `access_log` VALUES (35164, '59.78.15603116119926899', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:53:32', 26, 2001001000, '服务端发生异常', '2019-06-12 11:53:32');
INSERT INTO `access_log` VALUES (35165, '59.77.15603116119926889', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:53:32', 61, 0, '', '2019-06-12 11:53:32');
INSERT INTO `access_log` VALUES (35166, '65.47.15603117772927357', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:17', 0, 1002001015, '账号未登陆', '2019-06-12 11:56:17');
INSERT INTO `access_log` VALUES (35167, '65.54.15603117772927329', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:17', 0, 1002001015, '账号未登陆', '2019-06-12 11:56:17');
INSERT INTO `access_log` VALUES (35168, '65.45.15603117773047377', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:17', 1, 1002001015, '账号未登陆', '2019-06-12 11:56:17');
INSERT INTO `access_log` VALUES (35169, '65.46.15603117823327367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:22', 104, 0, '', '2019-06-12 11:56:22');
INSERT INTO `access_log` VALUES (35170, '65.51.15603117829827373', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:23', 9, 0, '', '2019-06-12 11:56:23');
INSERT INTO `access_log` VALUES (35171, '65.53.15603117829857341', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:23', 9, 0, '', '2019-06-12 11:56:23');
INSERT INTO `access_log` VALUES (35172, '65.3607.15603117829829127', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:23', 87, 2001001000, '服务端发生异常', '2019-06-12 11:56:23');
INSERT INTO `access_log` VALUES (35173, '65.50.15603117902907379', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:30', 10, 0, '', '2019-06-12 11:56:30');
INSERT INTO `access_log` VALUES (35174, '65.47.15603117902977359', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:30', 9, 0, '', '2019-06-12 11:56:30');
INSERT INTO `access_log` VALUES (35175, '65.52.15603117902947375', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:30', 201, 2001001000, '服务端发生异常', '2019-06-12 11:56:30');
INSERT INTO `access_log` VALUES (35176, '65.45.15603118092727379', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 11:56:49');
INSERT INTO `access_log` VALUES (35177, '65.51.15603118187927375', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:59', 68, 0, '', '2019-06-12 11:56:59');
INSERT INTO `access_log` VALUES (35178, '65.53.15603118190607343', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:59', 9, 0, '', '2019-06-12 11:56:59');
INSERT INTO `access_log` VALUES (35179, '65.3607.15603118190609129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:59', 10, 0, '', '2019-06-12 11:56:59');
INSERT INTO `access_log` VALUES (35180, '65.49.15603118190607389', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:59', 66, 2001001000, '服务端发生异常', '2019-06-12 11:56:59');
INSERT INTO `access_log` VALUES (35181, '65.50.15603134925887403', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:24:53', 0, 1002001015, '账号未登陆', '2019-06-12 12:24:53');
INSERT INTO `access_log` VALUES (35182, '65.52.15603134925897399', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:24:53', 1, 1002001015, '账号未登陆', '2019-06-12 12:24:53');
INSERT INTO `access_log` VALUES (35183, '65.54.15603134926067355', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:24:53', 0, 1002001015, '账号未登陆', '2019-06-12 12:24:53');
INSERT INTO `access_log` VALUES (35184, '65.46.15603134972637393', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:24:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 12:24:57');
INSERT INTO `access_log` VALUES (35185, '65.51.15603135030707399', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:25:03', 118, 0, '', '2019-06-12 12:25:03');
INSERT INTO `access_log` VALUES (35186, '65.53.15603135037967367', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:25:04', 10, 0, '', '2019-06-12 12:25:04');
INSERT INTO `access_log` VALUES (35187, '65.3607.15603135038119153', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:25:04', 10, 0, '', '2019-06-12 12:25:04');
INSERT INTO `access_log` VALUES (35188, '65.49.15603135038177413', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:25:04', 113, 2001001000, '服务端发生异常', '2019-06-12 12:25:04');
INSERT INTO `access_log` VALUES (35189, '65.45.15603135232687405', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:25:23', 305, 0, '', '2019-06-12 12:25:24');
INSERT INTO `access_log` VALUES (35190, '65.54.15603135232747357', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:25:23', 300, 0, '', '2019-06-12 12:25:24');
INSERT INTO `access_log` VALUES (35191, '65.52.15603135232747401', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:25:23', 388, 2001001000, '服务端发生异常', '2019-06-12 12:25:24');
INSERT INTO `access_log` VALUES (35192, '65.46.15603135271607395', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:25:27', 9, 0, '', '2019-06-12 12:25:27');
INSERT INTO `access_log` VALUES (35193, '65.51.15603135271707401', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:25:27', 7, 0, '', '2019-06-12 12:25:27');
INSERT INTO `access_log` VALUES (35194, '65.3607.15603135271769155', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:25:27', 74, 2001001000, '服务端发生异常', '2019-06-12 12:25:27');
INSERT INTO `access_log` VALUES (35195, '59.72.15603144124826937', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:40:12', 11, 0, '', '2019-06-12 12:40:12');
INSERT INTO `access_log` VALUES (35196, '59.78.15603144124936937', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:40:12', 19, 2001001000, '服务端发生异常', '2019-06-12 12:40:13');
INSERT INTO `access_log` VALUES (35197, '64.78.15603144173816857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:40:17', 10, 0, '', '2019-06-12 12:40:17');
INSERT INTO `access_log` VALUES (35198, '64.81.15603144176916851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:40:18', 3, 0, '', '2019-06-12 12:40:18');
INSERT INTO `access_log` VALUES (35199, '66.49.15603144208385395', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:40:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空', '2019-06-12 12:40:21');
INSERT INTO `access_log` VALUES (35200, '64.83.15603144247266843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:40:25', 2, 0, '', '2019-06-12 12:40:25');
INSERT INTO `access_log` VALUES (35201, '64.76.15603144250296847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:40:25', 1, 0, '', '2019-06-12 12:40:25');
INSERT INTO `access_log` VALUES (35202, '59.79.15603144273176943', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:40:27', 3, 0, '', '2019-06-12 12:40:27');
INSERT INTO `access_log` VALUES (35203, '59.75.15603144273296939', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:40:27', 12, 2001001000, '服务端发生异常', '2019-06-12 12:40:27');
INSERT INTO `access_log` VALUES (35204, '59.79.15603192069117007', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36', '106.37.209.14', '2019-06-12 14:00:07', 11, 0, '', '2019-06-12 14:00:07');
INSERT INTO `access_log` VALUES (35205, '59.74.15603192069126997', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36', '106.37.209.14', '2019-06-12 14:00:07', 15, 2001001000, '服务端发生异常', '2019-06-12 14:00:07');
INSERT INTO `access_log` VALUES (35206, '65.50.15603192364367483', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.166.99.16', '2019-06-12 14:00:36', 0, 1002001015, '账号未登陆', '2019-06-12 14:00:36');
INSERT INTO `access_log` VALUES (35207, '65.54.15603192364357437', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.166.99.16', '2019-06-12 14:00:36', 0, 1002001015, '账号未登陆', '2019-06-12 14:00:36');
INSERT INTO `access_log` VALUES (35208, '65.47.15603192364407463', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.166.99.16', '2019-06-12 14:00:36', 1, 1002001015, '账号未登陆', '2019-06-12 14:00:36');
INSERT INTO `access_log` VALUES (35209, '65.3607.15603192482429233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.166.99.16', '2019-06-12 14:00:48', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 14:00:48');
INSERT INTO `access_log` VALUES (35210, '65.49.15603192547917491', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.166.99.16', '2019-06-12 14:00:55', 83, 0, '', '2019-06-12 14:00:55');
INSERT INTO `access_log` VALUES (35211, '65.53.15603192619797447', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.166.99.16', '2019-06-12 14:01:02', 68, 0, '', '2019-06-12 14:01:02');
INSERT INTO `access_log` VALUES (35212, '65.54.15603194443857441', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:04', 4, 1002001012, '访问令牌已过期', '2019-06-12 14:04:04');
INSERT INTO `access_log` VALUES (35213, '65.47.15603194443887467', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:04', 2, 1002001012, '访问令牌已过期', '2019-06-12 14:04:04');
INSERT INTO `access_log` VALUES (35214, '65.50.15603194443917487', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:04', 4, 1002001012, '访问令牌已过期', '2019-06-12 14:04:04');
INSERT INTO `access_log` VALUES (35215, '65.3607.15603194539329237', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:14', 130, 0, '', '2019-06-12 14:04:14');
INSERT INTO `access_log` VALUES (35216, '65.51.15603194543227485', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:14', 10, 0, '', '2019-06-12 14:04:14');
INSERT INTO `access_log` VALUES (35217, '65.53.15603194543307451', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:14', 9, 0, '', '2019-06-12 14:04:14');
INSERT INTO `access_log` VALUES (35218, '65.49.15603194543257495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:14', 70, 2001001000, '服务端发生异常', '2019-06-12 14:04:14');
INSERT INTO `access_log` VALUES (35219, '65.45.15603194595707489', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:20', 14, 0, '', '2019-06-12 14:04:20');
INSERT INTO `access_log` VALUES (35220, '65.54.15603194595737443', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:20', 11, 0, '', '2019-06-12 14:04:20');
INSERT INTO `access_log` VALUES (35221, '65.52.15603194595717485', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:20', 83, 2001001000, '服务端发生异常', '2019-06-12 14:04:20');
INSERT INTO `access_log` VALUES (35222, '65.46.15603194825187479', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:43', 8, 0, '', '2019-06-12 14:04:43');
INSERT INTO `access_log` VALUES (35223, '65.51.15603194825257487', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:43', 8, 0, '', '2019-06-12 14:04:43');
INSERT INTO `access_log` VALUES (35224, '65.3607.15603194825249239', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:43', 99, 2001001000, '服务端发生异常', '2019-06-12 14:04:43');
INSERT INTO `access_log` VALUES (35225, '65.49.15603194954387497', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:55', 17, 0, '', '2019-06-12 14:04:55');
INSERT INTO `access_log` VALUES (35226, '65.54.15603194954417445', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:55', 8, 0, '', '2019-06-12 14:04:55');
INSERT INTO `access_log` VALUES (35227, '65.45.15603194954407491', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:55', 232, 2001001000, '服务端发生异常', '2019-06-12 14:04:56');
INSERT INTO `access_log` VALUES (35228, '65.52.15603195068557487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:05:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 14:05:07');
INSERT INTO `access_log` VALUES (35229, '65.47.15603195174917471', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:05:17', 91, 0, '', '2019-06-12 14:05:18');
INSERT INTO `access_log` VALUES (35230, '65.51.15603195177567489', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:05:18', 9, 0, '', '2019-06-12 14:05:18');
INSERT INTO `access_log` VALUES (35231, '65.3607.15603195177609241', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:05:18', 8, 0, '', '2019-06-12 14:05:18');
INSERT INTO `access_log` VALUES (35232, '65.46.15603195177587481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:05:18', 91, 2001001000, '服务端发生异常', '2019-06-12 14:05:18');
INSERT INTO `access_log` VALUES (35233, '65.50.15603195879077493', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:06:28', 9, 0, '', '2019-06-12 14:06:28');
INSERT INTO `access_log` VALUES (35234, '65.51.15603195879117491', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:06:28', 8, 0, '', '2019-06-12 14:06:28');
INSERT INTO `access_log` VALUES (35235, '65.47.15603195879097473', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:06:28', 235, 2001001000, '服务端发生异常', '2019-06-12 14:06:28');
INSERT INTO `access_log` VALUES (35236, '65.46.15603196001267483', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:06:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 14:06:40');
INSERT INTO `access_log` VALUES (35237, '65.49.15603199349267505', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:12:15', 59, 0, '', '2019-06-12 14:12:15');
INSERT INTO `access_log` VALUES (35238, '65.45.15603199352767499', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:12:15', 9, 0, '', '2019-06-12 14:12:15');
INSERT INTO `access_log` VALUES (35239, '65.50.15603199352817499', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:12:15', 9, 0, '', '2019-06-12 14:12:15');
INSERT INTO `access_log` VALUES (35240, '65.52.15603199352807495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:12:15', 72, 2001001000, '服务端发生异常', '2019-06-12 14:12:15');
INSERT INTO `access_log` VALUES (35241, '65.47.15603199471007479', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:12:27', 9, 0, '', '2019-06-12 14:12:27');
INSERT INTO `access_log` VALUES (35242, '65.46.15603199471077489', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:12:27', 8, 0, '', '2019-06-12 14:12:27');
INSERT INTO `access_log` VALUES (35243, '65.3607.15603199471049249', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:12:27', 88, 2001001000, '服务端发生异常', '2019-06-12 14:12:27');
INSERT INTO `access_log` VALUES (35244, '59.75.15603200653237015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '125.82.188.202', '2019-06-12 14:14:25', 4, 0, '', '2019-06-12 14:14:25');
INSERT INTO `access_log` VALUES (35245, '59.79.15603200653247019', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '125.82.188.202', '2019-06-12 14:14:25', 17, 2001001000, '服务端发生异常', '2019-06-12 14:14:25');
INSERT INTO `access_log` VALUES (35246, '59.74.15603209866857023', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:29:47', 2, 0, '', '2019-06-12 14:29:47');
INSERT INTO `access_log` VALUES (35247, '59.73.15603209866857027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:29:47', 13, 2001001000, '服务端发生异常', '2019-06-12 14:29:47');
INSERT INTO `access_log` VALUES (35248, '65.3607.15603209950849263', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:29:55', 0, 1002001015, '账号未登陆', '2019-06-12 14:29:55');
INSERT INTO `access_log` VALUES (35249, '65.47.15603209950837495', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:29:55', 0, 1002001015, '账号未登陆', '2019-06-12 14:29:55');
INSERT INTO `access_log` VALUES (35250, '65.53.15603209950897479', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:29:55', 1, 1002001015, '账号未登陆', '2019-06-12 14:29:55');
INSERT INTO `access_log` VALUES (35251, '65.54.15603209969727469', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:29:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 14:29:57');
INSERT INTO `access_log` VALUES (35252, '65.45.15603210011727515', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:30:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 14:30:01');
INSERT INTO `access_log` VALUES (35253, '65.50.15603210023347517', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:30:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 14:30:02');
INSERT INTO `access_log` VALUES (35254, '65.51.15603210314257513', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:30:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 14:30:31');
INSERT INTO `access_log` VALUES (35255, '65.46.15603210324447505', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:30:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 14:30:32');
INSERT INTO `access_log` VALUES (35256, '65.53.15603210335777481', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:30:34', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 14:30:34');
INSERT INTO `access_log` VALUES (35257, '65.3607.15603210367739265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:30:37', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 14:30:37');
INSERT INTO `access_log` VALUES (35258, '65.47.15603210383597497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:30:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 14:30:38');
INSERT INTO `access_log` VALUES (35259, '65.3607.15603211534849267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:32:33', 80, 0, '', '2019-06-12 14:32:34');
INSERT INTO `access_log` VALUES (35260, '65.47.15603211538147499', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:32:34', 9, 0, '', '2019-06-12 14:32:34');
INSERT INTO `access_log` VALUES (35261, '65.45.15603211538187519', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:32:34', 9, 0, '', '2019-06-12 14:32:34');
INSERT INTO `access_log` VALUES (35262, '65.54.15603211538157473', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:32:34', 83, 2001001000, '服务端发生异常', '2019-06-12 14:32:34');
INSERT INTO `access_log` VALUES (35263, '65.49.15603211639937527', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:32:44', 9, 0, '', '2019-06-12 14:32:44');
INSERT INTO `access_log` VALUES (35264, '65.51.15603211639987517', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:32:44', 9, 0, '', '2019-06-12 14:32:44');
INSERT INTO `access_log` VALUES (35265, '65.52.15603211639957517', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:32:44', 75, 2001001000, '服务端发生异常', '2019-06-12 14:32:44');
INSERT INTO `access_log` VALUES (35266, '59.80.15603213593687019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36', '219.147.98.81', '2019-06-12 14:35:59', 3, 0, '', '2019-06-12 14:35:59');
INSERT INTO `access_log` VALUES (35267, '59.79.15603213593777037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36', '219.147.98.81', '2019-06-12 14:35:59', 13, 2001001000, '服务端发生异常', '2019-06-12 14:35:59');
INSERT INTO `access_log` VALUES (35268, '64.80.15603213651626945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36', '219.147.98.81', '2019-06-12 14:36:05', 9, 0, '', '2019-06-12 14:36:05');
INSERT INTO `access_log` VALUES (35269, '64.77.15603213653426953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36', '219.147.98.81', '2019-06-12 14:36:05', 11, 0, '', '2019-06-12 14:36:05');
INSERT INTO `access_log` VALUES (35270, '64.78.15603213666076951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.113 Safari/537.36', '219.147.98.81', '2019-06-12 14:36:07', 2, 0, '', '2019-06-12 14:36:07');
INSERT INTO `access_log` VALUES (35271, '65.53.15603217755707493', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.163.210.202', '2019-06-12 14:42:56', 0, 1002001015, '账号未登陆', '2019-06-12 14:42:56');
INSERT INTO `access_log` VALUES (35272, '65.3607.15603217755889277', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.163.210.202', '2019-06-12 14:42:56', 0, 1002001015, '账号未登陆', '2019-06-12 14:42:56');
INSERT INTO `access_log` VALUES (35273, '65.45.15603217756107529', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.163.210.202', '2019-06-12 14:42:56', 0, 1002001015, '账号未登陆', '2019-06-12 14:42:56');
INSERT INTO `access_log` VALUES (35274, '65.47.15603217824747509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.163.210.202', '2019-06-12 14:43:02', 88, 0, '', '2019-06-12 14:43:03');
INSERT INTO `access_log` VALUES (35275, '65.51.15603217830757527', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.163.210.202', '2019-06-12 14:43:03', 7, 0, '', '2019-06-12 14:43:03');
INSERT INTO `access_log` VALUES (35276, '65.50.15603217830577531', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.163.210.202', '2019-06-12 14:43:03', 63, 2001001000, '服务端发生异常', '2019-06-12 14:43:03');
INSERT INTO `access_log` VALUES (35277, '65.54.15603217830477483', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.163.210.202', '2019-06-12 14:43:03', 162, 0, '', '2019-06-12 14:43:03');
INSERT INTO `access_log` VALUES (35278, '65.53.15603231729957513', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '123.233.246.107', '2019-06-12 15:06:13', 0, 1002001015, '账号未登陆', '2019-06-12 15:06:13');
INSERT INTO `access_log` VALUES (35279, '65.45.15603231730077549', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '123.233.246.107', '2019-06-12 15:06:13', 1, 1002001015, '账号未登陆', '2019-06-12 15:06:13');
INSERT INTO `access_log` VALUES (35280, '65.3607.15603231730109297', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '123.233.246.107', '2019-06-12 15:06:13', 0, 1002001015, '账号未登陆', '2019-06-12 15:06:13');
INSERT INTO `access_log` VALUES (35281, '65.49.15603232331947557', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '223.167.152.53', '2019-06-12 15:07:13', 1, 1002001015, '账号未登陆', '2019-06-12 15:07:13');
INSERT INTO `access_log` VALUES (35282, '65.52.15603232376167547', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '223.167.152.53', '2019-06-12 15:07:18', 1, 1002001015, '账号未登陆', '2019-06-12 15:07:18');
INSERT INTO `access_log` VALUES (35283, '65.50.15603233287007553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '123.233.246.107', '2019-06-12 15:08:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 15:08:49');
INSERT INTO `access_log` VALUES (35284, '65.54.15603233307847505', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '123.233.246.107', '2019-06-12 15:08:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 15:08:51');
INSERT INTO `access_log` VALUES (35285, '65.46.15603233574067541', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '123.233.246.107', '2019-06-12 15:09:17', 88, 0, '', '2019-06-12 15:09:17');
INSERT INTO `access_log` VALUES (35286, '65.45.15603233578107553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '123.233.246.107', '2019-06-12 15:09:18', 10, 0, '', '2019-06-12 15:09:18');
INSERT INTO `access_log` VALUES (35287, '65.3607.15603233578249301', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '123.233.246.107', '2019-06-12 15:09:18', 8, 0, '', '2019-06-12 15:09:18');
INSERT INTO `access_log` VALUES (35288, '65.53.15603233578197517', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '123.233.246.107', '2019-06-12 15:09:18', 66, 2001001000, '服务端发生异常', '2019-06-12 15:09:18');
INSERT INTO `access_log` VALUES (35289, '65.50.15603238357857561', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:17:16', 0, 1002001015, '账号未登陆', '2019-06-12 15:17:16');
INSERT INTO `access_log` VALUES (35290, '65.54.15603238357897513', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:17:16', 0, 1002001015, '账号未登陆', '2019-06-12 15:17:16');
INSERT INTO `access_log` VALUES (35291, '65.49.15603238358057567', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:17:16', 0, 1002001015, '账号未登陆', '2019-06-12 15:17:16');
INSERT INTO `access_log` VALUES (35292, '65.46.15603238474797549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:17:27', 271, 0, '', '2019-06-12 15:17:28');
INSERT INTO `access_log` VALUES (35293, '65.45.15603238480507561', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:17:28', 7, 0, '', '2019-06-12 15:17:28');
INSERT INTO `access_log` VALUES (35294, '65.53.15603238480597525', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:17:28', 7, 0, '', '2019-06-12 15:17:28');
INSERT INTO `access_log` VALUES (35295, '65.3607.15603238480549309', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:17:28', 70, 2001001000, '服务端发生异常', '2019-06-12 15:17:28');
INSERT INTO `access_log` VALUES (35296, '65.51.15603238731307559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:17:53', 85, 0, '', '2019-06-12 15:17:53');
INSERT INTO `access_log` VALUES (35297, '65.54.15603238735807515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:17:54', 9, 0, '', '2019-06-12 15:17:54');
INSERT INTO `access_log` VALUES (35298, '65.49.15603238735957569', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:17:54', 9, 0, '', '2019-06-12 15:17:54');
INSERT INTO `access_log` VALUES (35299, '65.50.15603238735837563', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:17:54', 98, 2001001000, '服务端发生异常', '2019-06-12 15:17:54');
INSERT INTO `access_log` VALUES (35300, '59.73.15603239247157067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:18:45', 9, 0, '', '2019-06-12 15:18:45');
INSERT INTO `access_log` VALUES (35301, '59.74.15603239247167063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:18:45', 12, 2001001000, '服务端发生异常', '2019-06-12 15:18:45');
INSERT INTO `access_log` VALUES (35302, '65.53.15603239883737529', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.105.193.146', '2019-06-12 15:19:48', 0, 1002001015, '账号未登陆', '2019-06-12 15:19:48');
INSERT INTO `access_log` VALUES (35303, '65.3607.15603239883769313', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.105.193.146', '2019-06-12 15:19:48', 0, 1002001015, '账号未登陆', '2019-06-12 15:19:48');
INSERT INTO `access_log` VALUES (35304, '65.47.15603239883807545', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.105.193.146', '2019-06-12 15:19:48', 0, 1002001015, '账号未登陆', '2019-06-12 15:19:48');
INSERT INTO `access_log` VALUES (35305, '65.51.15603239902367561', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.105.193.146', '2019-06-12 15:19:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 15:19:50');
INSERT INTO `access_log` VALUES (35306, '65.3607.15603240505399315', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:20:51', 3, 1002001012, '访问令牌已过期', '2019-06-12 15:20:51');
INSERT INTO `access_log` VALUES (35307, '65.51.15603240505437563', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:20:51', 2, 1002001012, '访问令牌已过期', '2019-06-12 15:20:51');
INSERT INTO `access_log` VALUES (35308, '65.49.15603240505517575', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:20:51', 2, 1002001012, '访问令牌已过期', '2019-06-12 15:20:51');
INSERT INTO `access_log` VALUES (35309, '65.52.15603240590457563', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:20:59', 81, 0, '', '2019-06-12 15:20:59');
INSERT INTO `access_log` VALUES (35310, '65.46.15603240595567557', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:21:00', 9, 0, '', '2019-06-12 15:21:00');
INSERT INTO `access_log` VALUES (35311, '65.50.15603240595577567', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:21:00', 9, 0, '', '2019-06-12 15:21:00');
INSERT INTO `access_log` VALUES (35312, '65.45.15603240595567565', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:21:00', 79, 2001001000, '服务端发生异常', '2019-06-12 15:21:00');
INSERT INTO `access_log` VALUES (35313, '65.47.15603240669357547', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:21:07', 8, 0, '', '2019-06-12 15:21:07');
INSERT INTO `access_log` VALUES (35314, '65.3607.15603240669879317', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:21:07', 9, 0, '', '2019-06-12 15:21:07');
INSERT INTO `access_log` VALUES (35315, '65.53.15603240669357533', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:21:07', 91, 2001001000, '服务端发生异常', '2019-06-12 15:21:07');
INSERT INTO `access_log` VALUES (35316, '65.45.15603249116517577', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:35:12', 10, 0, '', '2019-06-12 15:35:12');
INSERT INTO `access_log` VALUES (35317, '65.3607.15603249116859331', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:35:12', 9, 0, '', '2019-06-12 15:35:12');
INSERT INTO `access_log` VALUES (35318, '65.46.15603249116517569', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:35:12', 100, 2001001000, '服务端发生异常', '2019-06-12 15:35:12');
INSERT INTO `access_log` VALUES (35319, '65.3607.15603253199199337', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:00', 0, 1002001015, '账号未登陆', '2019-06-12 15:42:00');
INSERT INTO `access_log` VALUES (35320, '65.45.15603253199197583', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:00', 0, 1002001015, '账号未登陆', '2019-06-12 15:42:00');
INSERT INTO `access_log` VALUES (35321, '65.46.15603253199247575', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:00', 0, 1002001015, '账号未登陆', '2019-06-12 15:42:00');
INSERT INTO `access_log` VALUES (35322, '65.54.15603253230077543', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 15:42:03');
INSERT INTO `access_log` VALUES (35323, '65.49.15603253319547597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:12', 91, 0, '', '2019-06-12 15:42:12');
INSERT INTO `access_log` VALUES (35324, '65.53.15603253322817551', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:12', 9, 0, '', '2019-06-12 15:42:12');
INSERT INTO `access_log` VALUES (35325, '65.52.15603253322867583', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:12', 8, 0, '', '2019-06-12 15:42:12');
INSERT INTO `access_log` VALUES (35326, '65.47.15603253322867565', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:12', 75, 2001001000, '服务端发生异常', '2019-06-12 15:42:12');
INSERT INTO `access_log` VALUES (35327, '65.46.15603253503527577', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:30', 9, 0, '', '2019-06-12 15:42:30');
INSERT INTO `access_log` VALUES (35328, '65.45.15603253503567585', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:30', 9, 0, '', '2019-06-12 15:42:30');
INSERT INTO `access_log` VALUES (35329, '65.3607.15603253503539339', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:30', 89, 2001001000, '服务端发生异常', '2019-06-12 15:42:30');
INSERT INTO `access_log` VALUES (35330, '65.54.15603253512437545', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:31', 8, 0, '', '2019-06-12 15:42:31');
INSERT INTO `access_log` VALUES (35331, '65.51.15603253512447587', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:31', 19, 2001001000, '服务端发生异常', '2019-06-12 15:42:31');
INSERT INTO `access_log` VALUES (35332, '65.49.15603253512477599', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:31', 19, 0, '', '2019-06-12 15:42:31');
INSERT INTO `access_log` VALUES (35333, '59.79.15603259607807099', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:52:41', 16, 2001001000, '服务端发生异常', '2019-06-12 15:52:41');
INSERT INTO `access_log` VALUES (35334, '59.78.15603259607847093', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:52:41', 11, 0, '', '2019-06-12 15:52:41');
INSERT INTO `access_log` VALUES (35335, '64.80.15603259681127007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:52:48', 9, 0, '', '2019-06-12 15:52:48');
INSERT INTO `access_log` VALUES (35336, '64.77.15603259682617015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:52:48', 3, 0, '', '2019-06-12 15:52:48');
INSERT INTO `access_log` VALUES (35337, '64.79.15603259694887003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:52:49', 2, 0, '', '2019-06-12 15:52:49');
INSERT INTO `access_log` VALUES (35338, '64.81.15603259706397007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:52:51', 1, 0, '', '2019-06-12 15:52:51');
INSERT INTO `access_log` VALUES (35339, '64.82.15603259715197019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:52:52', 2, 0, '', '2019-06-12 15:52:52');
INSERT INTO `access_log` VALUES (35340, '59.74.15603259723497091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:52:52', 4, 0, '', '2019-06-12 15:52:52');
INSERT INTO `access_log` VALUES (35341, '59.72.15603259723547095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:52:52', 13, 2001001000, '服务端发生异常', '2019-06-12 15:52:52');
INSERT INTO `access_log` VALUES (35342, '64.83.15603259760156999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:52:56', 2, 0, '', '2019-06-12 15:52:56');
INSERT INTO `access_log` VALUES (35343, '64.76.15603259761227003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:52:56', 1, 0, '', '2019-06-12 15:52:56');
INSERT INTO `access_log` VALUES (35344, '64.85.15603259866877027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:53:07', 2, 0, '', '2019-06-12 15:53:07');
INSERT INTO `access_log` VALUES (35345, '64.80.15603259868127009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:53:07', 2, 0, '', '2019-06-12 15:53:07');
INSERT INTO `access_log` VALUES (35346, '64.77.15603259881047017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:53:08', 2, 0, '', '2019-06-12 15:53:08');
INSERT INTO `access_log` VALUES (35347, '64.79.15603259885377005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:53:09', 2, 0, '', '2019-06-12 15:53:09');
INSERT INTO `access_log` VALUES (35348, '59.77.15603259892767085', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:53:09', 10, 2001001000, '服务端发生异常', '2019-06-12 15:53:09');
INSERT INTO `access_log` VALUES (35349, '59.71.15603259892707097', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:53:09', 516, 0, '', '2019-06-12 15:53:10');
INSERT INTO `access_log` VALUES (35350, '64.82.15603260186367021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:53:39', 286, 0, '', '2019-06-12 15:53:39');
INSERT INTO `access_log` VALUES (35351, '64.83.15603260191017001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:53:39', 100, 0, '', '2019-06-12 15:53:39');
INSERT INTO `access_log` VALUES (35352, '59.78.15603260201457095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:53:40', 15, 0, '', '2019-06-12 15:53:40');
INSERT INTO `access_log` VALUES (35353, '59.79.15603260201507101', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.111', '2019-06-12 15:53:40', 10, 2001001000, '服务端发生异常', '2019-06-12 15:53:40');
INSERT INTO `access_log` VALUES (35354, '59.74.15603263461147097', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 15:59:06', 3, 0, '', '2019-06-12 15:59:06');
INSERT INTO `access_log` VALUES (35355, '59.75.15603263461157103', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 15:59:06', 15, 2001001000, '服务端发生异常', '2019-06-12 15:59:06');
INSERT INTO `access_log` VALUES (35356, '59.77.15603263627177091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 15:59:23', 2, 0, '', '2019-06-12 15:59:23');
INSERT INTO `access_log` VALUES (35357, '59.76.15603263627177095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 15:59:23', 20, 2001001000, '服务端发生异常', '2019-06-12 15:59:23');
INSERT INTO `access_log` VALUES (35358, '64.80.15603263663377015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 15:59:26', 50, 0, '', '2019-06-12 15:59:26');
INSERT INTO `access_log` VALUES (35359, '64.77.15603263665007023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 15:59:27', 2, 0, '', '2019-06-12 15:59:27');
INSERT INTO `access_log` VALUES (35360, '64.79.15603263690297011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 15:59:29', 2, 0, '', '2019-06-12 15:59:29');
INSERT INTO `access_log` VALUES (35361, '64.78.15603263700207021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 15:59:30', 197, 0, '', '2019-06-12 15:59:30');
INSERT INTO `access_log` VALUES (35362, '64.81.15603263706357015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 15:59:31', 2, 0, '', '2019-06-12 15:59:31');
INSERT INTO `access_log` VALUES (35363, '64.82.15603263715247027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 15:59:32', 2, 0, '', '2019-06-12 15:59:32');
INSERT INTO `access_log` VALUES (35364, '64.83.15603263722557007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 15:59:32', 2, 0, '', '2019-06-12 15:59:32');
INSERT INTO `access_log` VALUES (35365, '64.76.15603263733867011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 15:59:33', 2, 0, '', '2019-06-12 15:59:33');
INSERT INTO `access_log` VALUES (35366, '64.85.15603263790407035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 15:59:39', 2, 0, '', '2019-06-12 15:59:39');
INSERT INTO `access_log` VALUES (35367, '64.80.15603263791647017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 15:59:39', 2, 0, '', '2019-06-12 15:59:39');
INSERT INTO `access_log` VALUES (35368, '66.52.15603264050695545', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18827007445', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:00:05', 93, 0, '', '2019-06-12 16:00:05');
INSERT INTO `access_log` VALUES (35369, '66.49.15603264270195555', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18827007445&code=9999', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:00:27', 169, 0, '', '2019-06-12 16:00:27');
INSERT INTO `access_log` VALUES (35370, '66.55.15603264289355539', 122, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:00:29', 92, 0, '', '2019-06-12 16:00:29');
INSERT INTO `access_log` VALUES (35371, '66.50.15603264355605537', 122, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:00:36', 6, 0, '', '2019-06-12 16:00:36');
INSERT INTO `access_log` VALUES (35372, '66.51.15603264429705547', 122, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:00:43', 6, 0, '', '2019-06-12 16:00:43');
INSERT INTO `access_log` VALUES (35373, '59.71.15603264449147105', 122, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:00:45', 9, 0, '', '2019-06-12 16:00:45');
INSERT INTO `access_log` VALUES (35374, '59.77.15603264449377093', 122, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:00:45', 15, 2001001000, '服务端发生异常', '2019-06-12 16:00:45');
INSERT INTO `access_log` VALUES (35375, '64.76.15603264544247013', 122, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:00:54', 8, 0, '', '2019-06-12 16:00:54');
INSERT INTO `access_log` VALUES (35376, '64.85.15603264547167037', 122, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:00:55', 9, 0, '', '2019-06-12 16:00:55');
INSERT INTO `access_log` VALUES (35377, '64.77.15603264557117027', 122, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:00:56', 7, 0, '', '2019-06-12 16:00:56');
INSERT INTO `access_log` VALUES (35378, '64.78.15603264562587025', 122, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:00:56', 4, 0, '', '2019-06-12 16:00:56');
INSERT INTO `access_log` VALUES (35379, '64.81.15603264568897019', 122, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:00:57', 5, 0, '', '2019-06-12 16:00:57');
INSERT INTO `access_log` VALUES (35380, '66.52.15603264587835547', 122, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:00:59', 80, 0, '', '2019-06-12 16:00:59');
INSERT INTO `access_log` VALUES (35381, '66.53.15603264600415545', 122, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:01:00', 6, 0, '', '2019-06-12 16:01:00');
INSERT INTO `access_log` VALUES (35382, '66.54.15603264688655549', 122, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:01:09', 6, 0, '', '2019-06-12 16:01:09');
INSERT INTO `access_log` VALUES (35383, '66.55.15603264695875541', 122, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:01:10', 6, 0, '', '2019-06-12 16:01:10');
INSERT INTO `access_log` VALUES (35384, '59.78.15603264746357103', 122, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:01:15', 12, 0, '', '2019-06-12 16:01:15');
INSERT INTO `access_log` VALUES (35385, '59.72.15603264757287105', 122, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:01:16', 8, 0, '', '2019-06-12 16:01:16');
INSERT INTO `access_log` VALUES (35386, '59.75.15603264766007107', 122, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:01:17', 8, 0, '', '2019-06-12 16:01:17');
INSERT INTO `access_log` VALUES (35387, '66.50.15603264834775539', 122, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:01:23', 643, 0, '', '2019-06-12 16:01:24');
INSERT INTO `access_log` VALUES (35388, '66.57.15603265099525549', 122, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:01:50', 6, 0, '', '2019-06-12 16:01:50');
INSERT INTO `access_log` VALUES (35389, '65.51.15603265134567603', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:01:53', 3, 1002001012, '访问令牌已过期', '2019-06-12 16:01:53');
INSERT INTO `access_log` VALUES (35390, '65.54.15603265134567561', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:01:53', 4, 1002001012, '访问令牌已过期', '2019-06-12 16:01:53');
INSERT INTO `access_log` VALUES (35391, '65.53.15603265134577569', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:01:53', 3, 1002001012, '访问令牌已过期', '2019-06-12 16:01:53');
INSERT INTO `access_log` VALUES (35392, '66.48.15603265145725555', 122, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:01:55', 112, 0, '', '2019-06-12 16:01:55');
INSERT INTO `access_log` VALUES (35393, '65.47.15603265169987583', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:01:57', 69, 0, '', '2019-06-12 16:01:57');
INSERT INTO `access_log` VALUES (35394, '65.50.15603265172807607', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:01:57', 65, 0, '', '2019-06-12 16:01:57');
INSERT INTO `access_log` VALUES (35395, '65.45.15603265172827603', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:01:57', 64, 0, '', '2019-06-12 16:01:57');
INSERT INTO `access_log` VALUES (35396, '65.46.15603265172817595', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:01:57', 74, 2001001000, '服务端发生异常', '2019-06-12 16:01:57');
INSERT INTO `access_log` VALUES (35397, '65.3607.15603265273929357', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:02:07', 184, 0, '', '2019-06-12 16:02:08');
INSERT INTO `access_log` VALUES (35398, '65.54.15603265273957563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:02:07', 182, 0, '', '2019-06-12 16:02:08');
INSERT INTO `access_log` VALUES (35399, '65.49.15603265273927617', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:02:07', 184, 2001001000, '服务端发生异常', '2019-06-12 16:02:08');
INSERT INTO `access_log` VALUES (35400, '66.49.15603265290075559', 122, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:02:09', 6, 0, '', '2019-06-12 16:02:09');
INSERT INTO `access_log` VALUES (35401, '64.80.15603265315147021', 122, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:02:12', 8, 0, '', '2019-06-12 16:02:12');
INSERT INTO `access_log` VALUES (35402, '64.77.15603265316457029', 122, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:02:12', 5, 0, '', '2019-06-12 16:02:12');
INSERT INTO `access_log` VALUES (35403, '59.79.15603265333617111', 122, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:02:13', 8, 0, '', '2019-06-12 16:02:13');
INSERT INTO `access_log` VALUES (35404, '59.78.15603265333927105', 122, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:02:13', 17, 2001001000, '服务端发生异常', '2019-06-12 16:02:13');
INSERT INTO `access_log` VALUES (35405, '65.53.15603265335717571', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:02:14', 16, 0, '', '2019-06-12 16:02:14');
INSERT INTO `access_log` VALUES (35406, '65.52.15603265335747603', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:02:14', 19, 2001001000, '服务端发生异常', '2019-06-12 16:02:14');
INSERT INTO `access_log` VALUES (35407, '65.47.15603265335787585', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:02:14', 22, 0, '', '2019-06-12 16:02:14');
INSERT INTO `access_log` VALUES (35408, '65.50.15603265410487609', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:02:21', 75, 0, '', '2019-06-12 16:02:21');
INSERT INTO `access_log` VALUES (35409, '65.45.15603265413017605', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:02:21', 10, 0, '', '2019-06-12 16:02:21');
INSERT INTO `access_log` VALUES (35410, '65.46.15603265413027597', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:02:21', 11, 2001001000, '服务端发生异常', '2019-06-12 16:02:21');
INSERT INTO `access_log` VALUES (35411, '65.49.15603265413037619', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-12 16:02:21', 10, 0, '', '2019-06-12 16:02:21');
INSERT INTO `access_log` VALUES (35412, '59.71.15603265582847109', 122, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:02:38', 7, 0, '', '2019-06-12 16:02:38');
INSERT INTO `access_log` VALUES (35413, '59.77.15603265582847097', 122, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.156.251.15', '2019-06-12 16:02:38', 18, 2001001000, '服务端发生异常', '2019-06-12 16:02:38');
INSERT INTO `access_log` VALUES (35414, '59.74.15603269684137109', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.199.40', '2019-06-12 16:09:28', 3, 0, '', '2019-06-12 16:09:28');
INSERT INTO `access_log` VALUES (35415, '59.71.15603269684147115', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.199.40', '2019-06-12 16:09:28', 12, 2001001000, '服务端发生异常', '2019-06-12 16:09:28');
INSERT INTO `access_log` VALUES (35416, '65.45.15603269767937611', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.199.40', '2019-06-12 16:09:37', 1, 1002001015, '账号未登陆', '2019-06-12 16:09:37');
INSERT INTO `access_log` VALUES (35417, '65.3607.15603269767979365', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.199.40', '2019-06-12 16:09:37', 0, 1002001015, '账号未登陆', '2019-06-12 16:09:37');
INSERT INTO `access_log` VALUES (35418, '65.54.15603269768077571', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.199.40', '2019-06-12 16:09:37', 0, 1002001015, '账号未登陆', '2019-06-12 16:09:37');
INSERT INTO `access_log` VALUES (35419, '65.51.15603269787727613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.91.199.40', '2019-06-12 16:09:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 16:09:39');
INSERT INTO `access_log` VALUES (35420, '65.49.15603282464207643', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:30:46', 0, 1002001015, '账号未登陆', '2019-06-12 16:30:46');
INSERT INTO `access_log` VALUES (35421, '65.3607.15603282464219383', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:30:46', 0, 1002001015, '账号未登陆', '2019-06-12 16:30:46');
INSERT INTO `access_log` VALUES (35422, '65.45.15603282464227629', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:30:46', 0, 1002001015, '账号未登陆', '2019-06-12 16:30:46');
INSERT INTO `access_log` VALUES (35423, '65.52.15603282639597629', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:31:04', 62, 0, '', '2019-06-12 16:31:04');
INSERT INTO `access_log` VALUES (35424, '65.51.15603282643787631', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:31:04', 9, 0, '', '2019-06-12 16:31:04');
INSERT INTO `access_log` VALUES (35425, '65.47.15603282643807611', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:31:04', 8, 2001001000, '服务端发生异常', '2019-06-12 16:31:04');
INSERT INTO `access_log` VALUES (35426, '65.53.15603282643847597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:31:04', 8, 0, '', '2019-06-12 16:31:04');
INSERT INTO `access_log` VALUES (35427, '65.45.15603282966407631', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:31:37', 10, 0, '', '2019-06-12 16:31:37');
INSERT INTO `access_log` VALUES (35428, '65.49.15603282966447645', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:31:37', 10, 2001001000, '服务端发生异常', '2019-06-12 16:31:37');
INSERT INTO `access_log` VALUES (35429, '65.3607.15603282966849385', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:31:37', 10, 0, '', '2019-06-12 16:31:37');
INSERT INTO `access_log` VALUES (35430, '65.52.15603283040917631', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:31:44', 18, 0, '', '2019-06-12 16:31:44');
INSERT INTO `access_log` VALUES (35431, '65.53.15603283041037599', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:31:44', 9, 0, '', '2019-06-12 16:31:44');
INSERT INTO `access_log` VALUES (35432, '65.51.15603283041037633', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:31:44', 10, 2001001000, '服务端发生异常', '2019-06-12 16:31:44');
INSERT INTO `access_log` VALUES (35433, '65.47.15603283112507613', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:31:51', 11, 0, '', '2019-06-12 16:31:51');
INSERT INTO `access_log` VALUES (35434, '65.50.15603283112517637', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:31:51', 11, 2001001000, '服务端发生异常', '2019-06-12 16:31:51');
INSERT INTO `access_log` VALUES (35435, '65.46.15603283112567625', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:31:51', 10, 0, '', '2019-06-12 16:31:51');
INSERT INTO `access_log` VALUES (35436, '59.76.15603283200707125', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:32:00', 12, 2001001000, '服务端发生异常', '2019-06-12 16:32:00');
INSERT INTO `access_log` VALUES (35437, '59.77.15603283200687121', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:32:00', 521, 0, '', '2019-06-12 16:32:01');
INSERT INTO `access_log` VALUES (35438, '64.79.15603283271907041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:32:07', 3, 0, '', '2019-06-12 16:32:07');
INSERT INTO `access_log` VALUES (35439, '64.78.15603283273237051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:32:07', 2, 0, '', '2019-06-12 16:32:07');
INSERT INTO `access_log` VALUES (35440, '64.81.15603283286477045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:32:09', 2, 0, '', '2019-06-12 16:32:09');
INSERT INTO `access_log` VALUES (35441, '64.82.15603283293087057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:32:09', 2, 0, '', '2019-06-12 16:32:09');
INSERT INTO `access_log` VALUES (35442, '64.83.15603283323007037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:32:12', 1, 0, '', '2019-06-12 16:32:12');
INSERT INTO `access_log` VALUES (35443, '64.76.15603283324797041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:32:12', 2, 0, '', '2019-06-12 16:32:12');
INSERT INTO `access_log` VALUES (35444, '66.55.15603283463705567', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13667909756', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:32:26', 56, 0, '', '2019-06-12 16:32:26');
INSERT INTO `access_log` VALUES (35445, '66.50.15603283619865565', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13667909756&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:32:42', 182, 0, '', '2019-06-12 16:32:42');
INSERT INTO `access_log` VALUES (35446, '59.72.15603283636977133', 123, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:32:44', 9, 0, '', '2019-06-12 16:32:44');
INSERT INTO `access_log` VALUES (35447, '59.71.15603283661947135', 123, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:32:46', 8, 0, '', '2019-06-12 16:32:46');
INSERT INTO `access_log` VALUES (35448, '59.76.15603283667317127', 123, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '223.83.232.226', '2019-06-12 16:32:47', 7, 0, '', '2019-06-12 16:32:47');
INSERT INTO `access_log` VALUES (35449, '59.80.15603300304157143', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.182.151', '2019-06-12 17:00:30', 3, 0, '', '2019-06-12 17:00:30');
INSERT INTO `access_log` VALUES (35450, '59.79.15603300304207161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.182.151', '2019-06-12 17:00:30', 13, 2001001000, '服务端发生异常', '2019-06-12 17:00:30');
INSERT INTO `access_log` VALUES (35451, '64.77.15603300333577077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.182.151', '2019-06-12 17:00:33', 3, 0, '', '2019-06-12 17:00:33');
INSERT INTO `access_log` VALUES (35452, '64.79.15603300334887065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.15.182.151', '2019-06-12 17:00:33', 1, 0, '', '2019-06-12 17:00:33');
INSERT INTO `access_log` VALUES (35453, '59.78.15603303234957159', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.139.19.144', '2019-06-12 17:05:23', 3, 0, '', '2019-06-12 17:05:24');
INSERT INTO `access_log` VALUES (35454, '59.73.15603303235907161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.139.19.144', '2019-06-12 17:05:24', 19, 2001001000, '服务端发生异常', '2019-06-12 17:05:24');
INSERT INTO `access_log` VALUES (35455, '64.78.15603303349617079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.139.19.144', '2019-06-12 17:05:35', 3, 0, '', '2019-06-12 17:05:35');
INSERT INTO `access_log` VALUES (35456, '64.81.15603303350687073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.139.19.144', '2019-06-12 17:05:35', 2, 0, '', '2019-06-12 17:05:35');
INSERT INTO `access_log` VALUES (35457, '64.83.15603303364017065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.139.19.144', '2019-06-12 17:05:36', 2, 0, '', '2019-06-12 17:05:36');
INSERT INTO `access_log` VALUES (35458, '64.76.15603303370267069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.139.19.144', '2019-06-12 17:05:37', 2, 0, '', '2019-06-12 17:05:37');
INSERT INTO `access_log` VALUES (35459, '64.84.15603303391537083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.139.19.144', '2019-06-12 17:05:39', 2, 0, '', '2019-06-12 17:05:39');
INSERT INTO `access_log` VALUES (35460, '64.85.15603303401177093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.139.19.144', '2019-06-12 17:05:40', 2, 0, '', '2019-06-12 17:05:40');
INSERT INTO `access_log` VALUES (35461, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.139.19.144', '2019-06-12 17:05:40', 15, 0, '', '2019-06-12 17:05:40');
INSERT INTO `access_log` VALUES (35462, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.139.19.144', '2019-06-12 17:05:43', 6, 0, '', '2019-06-12 17:05:43');
INSERT INTO `access_log` VALUES (35463, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.139.19.144', '2019-06-12 17:05:44', 8, 0, '', '2019-06-12 17:05:44');
INSERT INTO `access_log` VALUES (35464, '64.80.15603303444597075', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.139.19.144', '2019-06-12 17:05:44', 273, 0, '', '2019-06-12 17:05:45');
INSERT INTO `access_log` VALUES (35465, '59.71.15603309381457171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.94.69', '2019-06-12 17:15:38', 10, 2001001000, '服务端发生异常', '2019-06-12 17:15:38');
INSERT INTO `access_log` VALUES (35466, '59.75.15603309381457171', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.94.69', '2019-06-12 17:15:38', 133, 0, '', '2019-06-12 17:15:38');
INSERT INTO `access_log` VALUES (35467, '64.77.15603309426937091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.94.69', '2019-06-12 17:15:43', 3, 0, '', '2019-06-12 17:15:43');
INSERT INTO `access_log` VALUES (35468, '64.79.15603309427877079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.94.69', '2019-06-12 17:15:43', 2, 0, '', '2019-06-12 17:15:43');
INSERT INTO `access_log` VALUES (35469, '64.78.15603309439627089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.94.69', '2019-06-12 17:15:44', 2, 0, '', '2019-06-12 17:15:44');
INSERT INTO `access_log` VALUES (35470, '64.81.15603309446387083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.94.69', '2019-06-12 17:15:45', 1, 0, '', '2019-06-12 17:15:45');
INSERT INTO `access_log` VALUES (35471, '66.53.15603309670715607', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.94.69', '2019-06-12 17:16:07', 147, 0, '', '2019-06-12 17:16:07');
INSERT INTO `access_log` VALUES (35472, '64.76.15603309694817079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.94.69', '2019-06-12 17:16:09', 2, 0, '', '2019-06-12 17:16:09');
INSERT INTO `access_log` VALUES (35473, '64.84.15603309695657093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.94.69', '2019-06-12 17:16:10', 2, 0, '', '2019-06-12 17:16:10');
INSERT INTO `access_log` VALUES (35474, '59.77.15603309737337159', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.94.69', '2019-06-12 17:16:14', 2, 0, '', '2019-06-12 17:16:14');
INSERT INTO `access_log` VALUES (35475, '59.80.15603309737347157', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.169.94.69', '2019-06-12 17:16:14', 9, 2001001000, '服务端发生异常', '2019-06-12 17:16:14');
INSERT INTO `access_log` VALUES (35476, '59.73.15603309949367171', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-06-12 17:16:35', 3, 0, '', '2019-06-12 17:16:35');
INSERT INTO `access_log` VALUES (35477, '59.72.15603309949377171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-06-12 17:16:35', 21, 2001001000, '服务端发生异常', '2019-06-12 17:16:35');
INSERT INTO `access_log` VALUES (35478, '64.77.15603309978047093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-06-12 17:16:38', 3, 0, '', '2019-06-12 17:16:38');
INSERT INTO `access_log` VALUES (35479, '64.79.15603309979027081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-06-12 17:16:38', 2, 0, '', '2019-06-12 17:16:38');
INSERT INTO `access_log` VALUES (35480, '64.78.15603309990157091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-06-12 17:16:39', 2, 0, '', '2019-06-12 17:16:39');
INSERT INTO `access_log` VALUES (35481, '64.81.15603309993637085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-06-12 17:16:39', 2, 0, '', '2019-06-12 17:16:39');
INSERT INTO `access_log` VALUES (35482, '64.82.15603309996477097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-06-12 17:16:40', 1, 0, '', '2019-06-12 17:16:40');
INSERT INTO `access_log` VALUES (35483, '65.46.15603311064477663', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.208.24.2', '2019-06-12 17:18:26', 1, 1002001015, '账号未登陆', '2019-06-12 17:18:26');
INSERT INTO `access_log` VALUES (35484, '65.47.15603311064477651', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.208.24.2', '2019-06-12 17:18:26', 0, 1002001015, '账号未登陆', '2019-06-12 17:18:26');
INSERT INTO `access_log` VALUES (35485, '65.50.15603311064487675', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.208.24.2', '2019-06-12 17:18:26', 0, 1002001015, '账号未登陆', '2019-06-12 17:18:26');
INSERT INTO `access_log` VALUES (35486, '65.45.15603311086617671', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.208.24.2', '2019-06-12 17:18:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 17:18:29');
INSERT INTO `access_log` VALUES (35487, '65.49.15603311124937685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.208.24.2', '2019-06-12 17:18:32', 105, 0, '', '2019-06-12 17:18:33');
INSERT INTO `access_log` VALUES (35488, '65.3607.15603311128479425', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.208.24.2', '2019-06-12 17:18:33', 12, 0, '', '2019-06-12 17:18:33');
INSERT INTO `access_log` VALUES (35489, '65.54.15603311128477631', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.208.24.2', '2019-06-12 17:18:33', 13, 2001001000, '服务端发生异常', '2019-06-12 17:18:33');
INSERT INTO `access_log` VALUES (35490, '65.52.15603311128487671', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.208.24.2', '2019-06-12 17:18:33', 19, 0, '', '2019-06-12 17:18:33');
INSERT INTO `access_log` VALUES (35491, '59.75.15603312963367177', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:21:36', 3, 0, '', '2019-06-12 17:21:36');
INSERT INTO `access_log` VALUES (35492, '59.71.15603312963627177', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:21:36', 14, 2001001000, '服务端发生异常', '2019-06-12 17:21:36');
INSERT INTO `access_log` VALUES (35493, '64.83.15603313037627081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:21:44', 2, 0, '', '2019-06-12 17:21:44');
INSERT INTO `access_log` VALUES (35494, '64.76.15603313039577085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:21:44', 2, 0, '', '2019-06-12 17:21:44');
INSERT INTO `access_log` VALUES (35495, '64.84.15603313055927099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:21:46', 2, 0, '', '2019-06-12 17:21:46');
INSERT INTO `access_log` VALUES (35496, '64.85.15603313065527109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:21:47', 2, 0, '', '2019-06-12 17:21:47');
INSERT INTO `access_log` VALUES (35497, '64.77.15603313129227099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:21:53', 2, 0, '', '2019-06-12 17:21:53');
INSERT INTO `access_log` VALUES (35498, '64.79.15603313130727087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:21:53', 2, 0, '', '2019-06-12 17:21:53');
INSERT INTO `access_log` VALUES (35499, '64.78.15603313143027097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:21:54', 2, 0, '', '2019-06-12 17:21:54');
INSERT INTO `access_log` VALUES (35500, '59.77.15603313165877165', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:21:57', 3, 0, '', '2019-06-12 17:21:57');
INSERT INTO `access_log` VALUES (35501, '59.76.15603313165877169', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:21:57', 10, 2001001000, '服务端发生异常', '2019-06-12 17:21:57');
INSERT INTO `access_log` VALUES (35502, '65.49.15603313419127689', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:22:22', 1, 1002001015, '账号未登陆', '2019-06-12 17:22:22');
INSERT INTO `access_log` VALUES (35503, '65.45.15603313419117675', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:22:22', 0, 1002001015, '账号未登陆', '2019-06-12 17:22:22');
INSERT INTO `access_log` VALUES (35504, '65.54.15603313419147635', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:22:22', 1, 1002001015, '账号未登陆', '2019-06-12 17:22:22');
INSERT INTO `access_log` VALUES (35505, '65.52.15603313446377675', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:22:25', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 17:22:25');
INSERT INTO `access_log` VALUES (35506, '65.51.15603313502277677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:22:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 17:22:30');
INSERT INTO `access_log` VALUES (35507, '65.53.15603313576027643', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:22:38', 64, 0, '', '2019-06-12 17:22:38');
INSERT INTO `access_log` VALUES (35508, '65.47.15603313580657657', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:22:38', 9, 0, '', '2019-06-12 17:22:38');
INSERT INTO `access_log` VALUES (35509, '65.50.15603313580767681', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:22:38', 8, 0, '', '2019-06-12 17:22:38');
INSERT INTO `access_log` VALUES (35510, '65.46.15603313580777669', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:22:38', 9, 2001001000, '服务端发生异常', '2019-06-12 17:22:38');
INSERT INTO `access_log` VALUES (35511, '65.49.15603313877257691', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:23:08', 9, 0, '', '2019-06-12 17:23:08');
INSERT INTO `access_log` VALUES (35512, '65.3607.15603313877749431', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:23:08', 10, 2001001000, '服务端发生异常', '2019-06-12 17:23:08');
INSERT INTO `access_log` VALUES (35513, '65.52.15603313877807677', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:23:08', 9, 0, '', '2019-06-12 17:23:08');
INSERT INTO `access_log` VALUES (35514, '65.53.15603313941947645', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:23:14', 9, 0, '', '2019-06-12 17:23:14');
INSERT INTO `access_log` VALUES (35515, '65.47.15603313942007659', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:23:14', 8, 2001001000, '服务端发生异常', '2019-06-12 17:23:14');
INSERT INTO `access_log` VALUES (35516, '65.50.15603313942077683', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:23:14', 8, 0, '', '2019-06-12 17:23:14');
INSERT INTO `access_log` VALUES (35517, '65.54.15603314295577639', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:23:50', 10, 0, '', '2019-06-12 17:23:50');
INSERT INTO `access_log` VALUES (35518, '65.49.15603314295697693', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:23:50', 9, 2001001000, '服务端发生异常', '2019-06-12 17:23:50');
INSERT INTO `access_log` VALUES (35519, '65.52.15603314295717679', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.104.64.142', '2019-06-12 17:23:50', 8, 0, '', '2019-06-12 17:23:50');
INSERT INTO `access_log` VALUES (35520, '65.49.15603315503417695', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '183.61.6.253', '2019-06-12 17:25:50', 1, 1002001015, '账号未登陆', '2019-06-12 17:25:50');
INSERT INTO `access_log` VALUES (35521, '65.54.15603315503497641', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '183.61.6.252', '2019-06-12 17:25:50', 0, 1002001015, '账号未登陆', '2019-06-12 17:25:50');
INSERT INTO `access_log` VALUES (35522, '65.3607.15603315503529435', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '218.98.33.145', '2019-06-12 17:25:50', 0, 1002001015, '账号未登陆', '2019-06-12 17:25:50');
INSERT INTO `access_log` VALUES (35523, '65.3607.15603316754279437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '218.98.33.145', '2019-06-12 17:27:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 17:27:55');
INSERT INTO `access_log` VALUES (35524, '65.51.15603316879817685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '218.98.33.145', '2019-06-12 17:28:08', 55, 0, '', '2019-06-12 17:28:08');
INSERT INTO `access_log` VALUES (35525, '65.53.15603316884497651', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '183.61.6.253', '2019-06-12 17:28:08', 100, 2001001000, '服务端发生异常', '2019-06-12 17:28:09');
INSERT INTO `access_log` VALUES (35526, '65.50.15603316884777689', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '218.98.33.145', '2019-06-12 17:28:08', 74, 0, '', '2019-06-12 17:28:09');
INSERT INTO `access_log` VALUES (35527, '65.45.15603378541577767', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.57.68.162', '2019-06-12 19:10:54', 0, 1002001015, '账号未登陆', '2019-06-12 19:10:54');
INSERT INTO `access_log` VALUES (35528, '65.52.15603378541587767', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.57.68.162', '2019-06-12 19:10:54', 0, 1002001015, '账号未登陆', '2019-06-12 19:10:54');
INSERT INTO `access_log` VALUES (35529, '65.54.15603378541587727', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.57.68.162', '2019-06-12 19:10:54', 1, 1002001015, '账号未登陆', '2019-06-12 19:10:54');
INSERT INTO `access_log` VALUES (35530, '65.49.15603378635967781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.57.68.162', '2019-06-12 19:11:04', 73, 0, '', '2019-06-12 19:11:04');
INSERT INTO `access_log` VALUES (35531, '65.3607.15603378641119521', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.57.68.162', '2019-06-12 19:11:04', 9, 0, '', '2019-06-12 19:11:04');
INSERT INTO `access_log` VALUES (35532, '65.51.15603378641197769', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.57.68.162', '2019-06-12 19:11:04', 8, 2001001000, '服务端发生异常', '2019-06-12 19:11:04');
INSERT INTO `access_log` VALUES (35533, '65.50.15603378641507773', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.57.68.162', '2019-06-12 19:11:04', 9, 0, '', '2019-06-12 19:11:04');
INSERT INTO `access_log` VALUES (35534, '59.80.15603382228577255', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:17:03', 12, 0, '', '2019-06-12 19:17:03');
INSERT INTO `access_log` VALUES (35535, '59.79.15603382228607273', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:17:03', 22, 2001001000, '服务端发生异常', '2019-06-12 19:17:03');
INSERT INTO `access_log` VALUES (35536, '64.82.15603382272137195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:17:07', 12, 0, '', '2019-06-12 19:17:07');
INSERT INTO `access_log` VALUES (35537, '64.83.15603382273377175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:17:07', 2, 0, '', '2019-06-12 19:17:07');
INSERT INTO `access_log` VALUES (35538, '59.73.15603382310057269', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:17:11', 3, 0, '', '2019-06-12 19:17:11');
INSERT INTO `access_log` VALUES (35539, '59.72.15603382310047269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:17:11', 15, 2001001000, '服务端发生异常', '2019-06-12 19:17:11');
INSERT INTO `access_log` VALUES (35540, '65.49.15603382422827787', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:17:22', 5, 1002001012, '访问令牌已过期', '2019-06-12 19:17:22');
INSERT INTO `access_log` VALUES (35541, '65.52.15603382422827773', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:17:22', 5, 1002001012, '访问令牌已过期', '2019-06-12 19:17:22');
INSERT INTO `access_log` VALUES (35542, '65.50.15603382422827779', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:17:22', 5, 1002001012, '访问令牌已过期', '2019-06-12 19:17:22');
INSERT INTO `access_log` VALUES (35543, '65.49.15603386461437793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:24:06', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 19:24:06');
INSERT INTO `access_log` VALUES (35544, '65.51.15603386674127781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:24:27', 83, 0, '', '2019-06-12 19:24:27');
INSERT INTO `access_log` VALUES (35545, '65.3607.15603386679199533', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:24:28', 10, 0, '', '2019-06-12 19:24:28');
INSERT INTO `access_log` VALUES (35546, '65.53.15603386679247747', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:24:28', 11, 2001001000, '服务端发生异常', '2019-06-12 19:24:28');
INSERT INTO `access_log` VALUES (35547, '65.47.15603386679767761', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:24:28', 10, 0, '', '2019-06-12 19:24:28');
INSERT INTO `access_log` VALUES (35548, '65.45.15603386934107781', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:24:53', 9, 0, '', '2019-06-12 19:24:53');
INSERT INTO `access_log` VALUES (35549, '65.54.15603386934107741', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:24:53', 9, 0, '', '2019-06-12 19:24:53');
INSERT INTO `access_log` VALUES (35550, '65.49.15603386934117795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:24:53', 10, 2001001000, '服务端发生异常', '2019-06-12 19:24:53');
INSERT INTO `access_log` VALUES (35551, '65.53.15603387013107749', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:25:01', 8, 0, '', '2019-06-12 19:25:01');
INSERT INTO `access_log` VALUES (35552, '65.52.15603387013067781', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:25:01', 13, 0, '', '2019-06-12 19:25:01');
INSERT INTO `access_log` VALUES (35553, '65.51.15603387013067783', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:25:01', 13, 2001001000, '服务端发生异常', '2019-06-12 19:25:01');
INSERT INTO `access_log` VALUES (35554, '64.85.15603387149487209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:25:15', 3, 0, '', '2019-06-12 19:25:15');
INSERT INTO `access_log` VALUES (35555, '64.80.15603387150947191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:25:15', 2, 0, '', '2019-06-12 19:25:15');
INSERT INTO `access_log` VALUES (35556, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:25:20', 8, 0, '', '2019-06-12 19:25:20');
INSERT INTO `access_log` VALUES (35557, '64.77.15603387196027199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:25:20', 2, 0, '', '2019-06-12 19:25:20');
INSERT INTO `access_log` VALUES (35558, '64.78.15603387214887197', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:25:21', 7, 0, '', '2019-06-12 19:25:21');
INSERT INTO `access_log` VALUES (35559, '65.49.15603387360637797', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-12 19:25:36', 0, 1002001015, '账号未登陆', '2019-06-12 19:25:36');
INSERT INTO `access_log` VALUES (35560, '65.46.15603387360637775', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-12 19:25:36', 1, 1002001015, '账号未登陆', '2019-06-12 19:25:36');
INSERT INTO `access_log` VALUES (35561, '65.45.15603387360657783', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-12 19:25:36', 0, 1002001015, '账号未登陆', '2019-06-12 19:25:36');
INSERT INTO `access_log` VALUES (35562, '65.50.15603387461987789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-12 19:25:46', 66, 0, '', '2019-06-12 19:25:46');
INSERT INTO `access_log` VALUES (35563, '65.53.15603387465727751', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-12 19:25:47', 8, 0, '', '2019-06-12 19:25:47');
INSERT INTO `access_log` VALUES (35564, '65.52.15603387465997783', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-12 19:25:47', 9, 0, '', '2019-06-12 19:25:47');
INSERT INTO `access_log` VALUES (35565, '65.51.15603387465997785', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-12 19:25:47', 12, 2001001000, '服务端发生异常', '2019-06-12 19:25:47');
INSERT INTO `access_log` VALUES (35566, '59.79.15603387616487281', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-12 19:26:02', 3, 0, '', '2019-06-12 19:26:02');
INSERT INTO `access_log` VALUES (35567, '59.80.15603387616487263', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-12 19:26:02', 13, 2001001000, '服务端发生异常', '2019-06-12 19:26:02');
INSERT INTO `access_log` VALUES (35568, '65.49.15603388913967801', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:28:11', 10, 0, '', '2019-06-12 19:28:11');
INSERT INTO `access_log` VALUES (35569, '65.3607.15603388913959539', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:28:11', 10, 0, '', '2019-06-12 19:28:11');
INSERT INTO `access_log` VALUES (35570, '65.47.15603388913957767', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.253.30.118', '2019-06-12 19:28:11', 11, 2001001000, '服务端发生异常', '2019-06-12 19:28:11');
INSERT INTO `access_log` VALUES (35571, '59.73.15603393499257285', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:35:50', 4, 0, '', '2019-06-12 19:35:50');
INSERT INTO `access_log` VALUES (35572, '59.78.15603393499227283', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:35:50', 14, 2001001000, '服务端发生异常', '2019-06-12 19:35:50');
INSERT INTO `access_log` VALUES (35573, '65.54.15603393571557753', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:35:57', 0, 1002001015, '账号未登陆', '2019-06-12 19:35:57');
INSERT INTO `access_log` VALUES (35574, '65.45.15603393571557793', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:35:57', 1, 1002001015, '账号未登陆', '2019-06-12 19:35:57');
INSERT INTO `access_log` VALUES (35575, '65.50.15603393571557799', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:35:57', 0, 1002001015, '账号未登陆', '2019-06-12 19:35:57');
INSERT INTO `access_log` VALUES (35576, '65.53.15603393823947761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:36:22', 86, 0, '', '2019-06-12 19:36:22');
INSERT INTO `access_log` VALUES (35577, '65.52.15603393828527793', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:36:23', 10, 0, '', '2019-06-12 19:36:23');
INSERT INTO `access_log` VALUES (35578, '65.3607.15603393828529547', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:36:23', 10, 0, '', '2019-06-12 19:36:23');
INSERT INTO `access_log` VALUES (35579, '65.49.15603393828537809', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:36:23', 11, 2001001000, '服务端发生异常', '2019-06-12 19:36:23');
INSERT INTO `access_log` VALUES (35580, '64.85.15603394098327219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:36:50', 2, 0, '', '2019-06-12 19:36:50');
INSERT INTO `access_log` VALUES (35581, '64.80.15603394100537201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:36:50', 1, 0, '', '2019-06-12 19:36:50');
INSERT INTO `access_log` VALUES (35582, '64.79.15603394108897197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:36:51', 2, 0, '', '2019-06-12 19:36:51');
INSERT INTO `access_log` VALUES (35583, '64.78.15603394113207207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:36:51', 2, 0, '', '2019-06-12 19:36:51');
INSERT INTO `access_log` VALUES (35584, '64.81.15603394115827201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:36:52', 1, 0, '', '2019-06-12 19:36:52');
INSERT INTO `access_log` VALUES (35585, '59.77.15603394195547275', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:37:00', 3, 0, '', '2019-06-12 19:37:00');
INSERT INTO `access_log` VALUES (35586, '59.76.15603394195577279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '36.152.48.80', '2019-06-12 19:37:00', 13, 2001001000, '服务端发生异常', '2019-06-12 19:37:00');
INSERT INTO `access_log` VALUES (35587, '59.71.15603412884337313', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.19.90.119', '2019-06-12 20:08:08', 15, 2001001000, '服务端发生异常', '2019-06-12 20:08:08');
INSERT INTO `access_log` VALUES (35588, '59.75.15603412884327313', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.19.90.119', '2019-06-12 20:08:08', 145, 0, '', '2019-06-12 20:08:09');
INSERT INTO `access_log` VALUES (35589, '64.80.15603412939117227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.19.90.119', '2019-06-12 20:08:14', 10, 0, '', '2019-06-12 20:08:14');
INSERT INTO `access_log` VALUES (35590, '64.77.15603412940317235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.19.90.119', '2019-06-12 20:08:14', 3, 0, '', '2019-06-12 20:08:14');
INSERT INTO `access_log` VALUES (35591, '64.79.15603412981177223', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.19.90.119', '2019-06-12 20:08:18', 2, 0, '', '2019-06-12 20:08:18');
INSERT INTO `access_log` VALUES (35592, '64.78.15603412982447233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.19.90.119', '2019-06-12 20:08:18', 1, 0, '', '2019-06-12 20:08:18');
INSERT INTO `access_log` VALUES (35593, '59.76.15603413073737305', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.19.90.119', '2019-06-12 20:08:27', 3, 0, '', '2019-06-12 20:08:27');
INSERT INTO `access_log` VALUES (35594, '59.77.15603413073767301', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.19.90.119', '2019-06-12 20:08:27', 13, 2001001000, '服务端发生异常', '2019-06-12 20:08:27');
INSERT INTO `access_log` VALUES (35595, '64.82.15603413130167239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.19.90.119', '2019-06-12 20:08:33', 2, 0, '', '2019-06-12 20:08:33');
INSERT INTO `access_log` VALUES (35596, '64.83.15603413131057219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.19.90.119', '2019-06-12 20:08:33', 2, 0, '', '2019-06-12 20:08:33');
INSERT INTO `access_log` VALUES (35597, '59.80.15603413163147299', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.19.90.119', '2019-06-12 20:08:36', 3, 0, '', '2019-06-12 20:08:36');
INSERT INTO `access_log` VALUES (35598, '59.73.15603413163157313', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.19.90.119', '2019-06-12 20:08:36', 20, 2001001000, '服务端发生异常', '2019-06-12 20:08:36');
INSERT INTO `access_log` VALUES (35599, '59.71.15603413482007315', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.129.6.251', '2019-06-12 20:09:08', 12, 2001001000, '服务端发生异常', '2019-06-12 20:09:08');
INSERT INTO `access_log` VALUES (35600, '64.80.15603413531857229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.227.139.178', '2019-06-12 20:09:13', 2, 0, '', '2019-06-12 20:09:13');
INSERT INTO `access_log` VALUES (35601, '64.77.15603413544777237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.174', '2019-06-12 20:09:14', 2, 0, '', '2019-06-12 20:09:14');
INSERT INTO `access_log` VALUES (35602, '59.71.15603416297847319', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:13:50', 3, 0, '', '2019-06-12 20:13:50');
INSERT INTO `access_log` VALUES (35603, '59.75.15603416297847319', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:13:50', 13, 2001001000, '服务端发生异常', '2019-06-12 20:13:50');
INSERT INTO `access_log` VALUES (35604, '64.77.15603416331497241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:13:53', 3, 0, '', '2019-06-12 20:13:53');
INSERT INTO `access_log` VALUES (35605, '64.79.15603416335097229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:13:54', 2, 0, '', '2019-06-12 20:13:54');
INSERT INTO `access_log` VALUES (35606, '64.78.15603416355257239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:13:56', 1, 0, '', '2019-06-12 20:13:56');
INSERT INTO `access_log` VALUES (35607, '64.81.15603416363517233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:13:56', 1, 0, '', '2019-06-12 20:13:56');
INSERT INTO `access_log` VALUES (35608, '64.82.15603416370377245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:13:57', 1, 0, '', '2019-06-12 20:13:57');
INSERT INTO `access_log` VALUES (35609, '64.83.15603416376007225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:13:58', 2, 0, '', '2019-06-12 20:13:58');
INSERT INTO `access_log` VALUES (35610, '59.74.15603416393997313', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:13:59', 3, 0, '', '2019-06-12 20:13:59');
INSERT INTO `access_log` VALUES (35611, '59.76.15603416393997311', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:13:59', 21, 2001001000, '服务端发生异常', '2019-06-12 20:13:59');
INSERT INTO `access_log` VALUES (35612, '59.79.15603416470627323', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:14:07', 2, 0, '', '2019-06-12 20:14:07');
INSERT INTO `access_log` VALUES (35613, '59.80.15603416470627305', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:14:07', 13, 2001001000, '服务端发生异常', '2019-06-12 20:14:07');
INSERT INTO `access_log` VALUES (35614, '65.45.15603416619327825', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:14:22', 1, 1002001015, '账号未登陆', '2019-06-12 20:14:22');
INSERT INTO `access_log` VALUES (35615, '65.54.15603416619327785', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:14:22', 1, 1002001015, '账号未登陆', '2019-06-12 20:14:22');
INSERT INTO `access_log` VALUES (35616, '65.50.15603416619357831', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:14:22', 0, 1002001015, '账号未登陆', '2019-06-12 20:14:22');
INSERT INTO `access_log` VALUES (35617, '65.53.15603416687737793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:14:29', 88, 0, '', '2019-06-12 20:14:29');
INSERT INTO `access_log` VALUES (35618, '65.52.15603416691077825', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:14:29', 9, 0, '', '2019-06-12 20:14:29');
INSERT INTO `access_log` VALUES (35619, '65.49.15603416691117841', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:14:29', 17, 2001001000, '服务端发生异常', '2019-06-12 20:14:29');
INSERT INTO `access_log` VALUES (35620, '65.3607.15603416691129579', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.251.100.37', '2019-06-12 20:14:29', 17, 0, '', '2019-06-12 20:14:29');
INSERT INTO `access_log` VALUES (35621, '59.78.15603469094097387', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.147.98.97', '2019-06-12 21:41:49', 12, 0, '', '2019-06-12 21:41:49');
INSERT INTO `access_log` VALUES (35622, '59.72.15603469094097389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.147.98.97', '2019-06-12 21:41:49', 16, 2001001000, '服务端发生异常', '2019-06-12 21:41:49');
INSERT INTO `access_log` VALUES (35623, '59.74.15603478440577397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '14.215.36.94', '2019-06-12 21:57:24', 8, 0, '', '2019-06-12 21:57:24');
INSERT INTO `access_log` VALUES (35624, '59.76.15603478440597395', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '14.215.36.93', '2019-06-12 21:57:24', 12, 2001001000, '服务端发生异常', '2019-06-12 21:57:24');
INSERT INTO `access_log` VALUES (35625, '64.77.15603478500967325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '14.215.36.93', '2019-06-12 21:57:30', 9, 0, '', '2019-06-12 21:57:30');
INSERT INTO `access_log` VALUES (35626, '64.79.15603478502327313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '14.215.36.93', '2019-06-12 21:57:30', 2, 0, '', '2019-06-12 21:57:30');
INSERT INTO `access_log` VALUES (35627, '64.78.15603478519237323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '14.215.36.93', '2019-06-12 21:57:32', 2, 0, '', '2019-06-12 21:57:32');
INSERT INTO `access_log` VALUES (35628, '59.77.15603478529097391', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '14.215.36.93', '2019-06-12 21:57:33', 2, 0, '', '2019-06-12 21:57:33');
INSERT INTO `access_log` VALUES (35629, '59.79.15603478529117407', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '14.215.36.94', '2019-06-12 21:57:33', 13, 2001001000, '服务端发生异常', '2019-06-12 21:57:33');
INSERT INTO `access_log` VALUES (35630, '59.73.15603528110417469', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:11', 12, 0, '', '2019-06-12 23:20:11');
INSERT INTO `access_log` VALUES (35631, '59.78.15603528110427467', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:11', 16, 2001001000, '服务端发生异常', '2019-06-12 23:20:11');
INSERT INTO `access_log` VALUES (35632, '64.82.15603528154657395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:15', 13, 0, '', '2019-06-12 23:20:15');
INSERT INTO `access_log` VALUES (35633, '64.83.15603528156297375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:16', 4, 0, '', '2019-06-12 23:20:16');
INSERT INTO `access_log` VALUES (35634, '64.76.15603528178557379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:18', 2, 0, '', '2019-06-12 23:20:18');
INSERT INTO `access_log` VALUES (35635, '59.71.15603528195457471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:20', 3, 0, '', '2019-06-12 23:20:20');
INSERT INTO `access_log` VALUES (35636, '59.75.15603528195467471', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:20', 19, 2001001000, '服务端发生异常', '2019-06-12 23:20:20');
INSERT INTO `access_log` VALUES (35637, '64.85.15603528230967403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:23', 1, 0, '', '2019-06-12 23:20:23');
INSERT INTO `access_log` VALUES (35638, '64.80.15603528232797385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:23', 2, 0, '', '2019-06-12 23:20:23');
INSERT INTO `access_log` VALUES (35639, '64.77.15603528248557393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:25', 1, 0, '', '2019-06-12 23:20:25');
INSERT INTO `access_log` VALUES (35640, '64.79.15603528297817381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:30', 2, 0, '', '2019-06-12 23:20:30');
INSERT INTO `access_log` VALUES (35641, '64.78.15603528299587391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:30', 2, 0, '', '2019-06-12 23:20:30');
INSERT INTO `access_log` VALUES (35642, '59.74.15603528312147465', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:31', 3, 0, '', '2019-06-12 23:20:31');
INSERT INTO `access_log` VALUES (35643, '59.76.15603528312147463', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:31', 12, 2001001000, '服务端发生异常', '2019-06-12 23:20:31');
INSERT INTO `access_log` VALUES (35644, '64.81.15603528346207385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:35', 2, 0, '', '2019-06-12 23:20:35');
INSERT INTO `access_log` VALUES (35645, '64.82.15603528347917397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:35', 2, 0, '', '2019-06-12 23:20:35');
INSERT INTO `access_log` VALUES (35646, '59.77.15603528356557459', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:36', 2, 0, '', '2019-06-12 23:20:36');
INSERT INTO `access_log` VALUES (35647, '59.80.15603528356557457', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:36', 13, 2001001000, '服务端发生异常', '2019-06-12 23:20:36');
INSERT INTO `access_log` VALUES (35648, '64.76.15603528366847381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:37', 2, 0, '', '2019-06-12 23:20:37');
INSERT INTO `access_log` VALUES (35649, '64.84.15603528368517395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:37', 2, 0, '', '2019-06-12 23:20:37');
INSERT INTO `access_log` VALUES (35650, '64.85.15603528387817405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:39', 2, 0, '', '2019-06-12 23:20:39');
INSERT INTO `access_log` VALUES (35651, '64.80.15603528389687387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:39', 3, 0, '', '2019-06-12 23:20:39');
INSERT INTO `access_log` VALUES (35652, '59.73.15603528393667471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:39', 3, 0, '', '2019-06-12 23:20:39');
INSERT INTO `access_log` VALUES (35653, '59.78.15603528393667469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:39', 13, 2001001000, '服务端发生异常', '2019-06-12 23:20:39');
INSERT INTO `access_log` VALUES (35654, '64.77.15603528399057395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:40', 2, 0, '', '2019-06-12 23:20:40');
INSERT INTO `access_log` VALUES (35655, '64.79.15603528400527383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:40', 1, 0, '', '2019-06-12 23:20:40');
INSERT INTO `access_log` VALUES (35656, '59.72.15603528406377471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:41', 2, 0, '', '2019-06-12 23:20:41');
INSERT INTO `access_log` VALUES (35657, '59.75.15603528406387473', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:41', 19, 2001001000, '服务端发生异常', '2019-06-12 23:20:41');
INSERT INTO `access_log` VALUES (35658, '65.45.15603528512727981', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:51', 0, 1002001015, '账号未登陆', '2019-06-12 23:20:51');
INSERT INTO `access_log` VALUES (35659, '65.50.15603528512717981', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:51', 1, 1002001015, '账号未登陆', '2019-06-12 23:20:51');
INSERT INTO `access_log` VALUES (35660, '65.51.15603528512757979', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:51', 0, 1002001015, '账号未登陆', '2019-06-12 23:20:51');
INSERT INTO `access_log` VALUES (35661, '65.54.15603528534067939', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:20:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 23:20:53');
INSERT INTO `access_log` VALUES (35662, '59.76.15603528714637465', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.207.186', '2019-06-12 23:21:11', 2, 0, '', '2019-06-12 23:21:11');
INSERT INTO `access_log` VALUES (35663, '64.82.15603528750977399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.89.239.230', '2019-06-12 23:21:15', 2, 0, '', '2019-06-12 23:21:15');
INSERT INTO `access_log` VALUES (35664, '64.83.15603528751667379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.89.239.230', '2019-06-12 23:21:15', 2, 0, '', '2019-06-12 23:21:15');
INSERT INTO `access_log` VALUES (35665, '64.76.15603528778167383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.91.60.107', '2019-06-12 23:21:18', 2, 0, '', '2019-06-12 23:21:18');
INSERT INTO `access_log` VALUES (35666, '65.45.15603529530697983', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:22:33', 86, 0, '', '2019-06-12 23:22:33');
INSERT INTO `access_log` VALUES (35667, '65.50.15603529534357983', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:22:33', 10, 0, '', '2019-06-12 23:22:33');
INSERT INTO `access_log` VALUES (35668, '65.54.15603529534367941', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:22:33', 12, 2001001000, '服务端发生异常', '2019-06-12 23:22:33');
INSERT INTO `access_log` VALUES (35669, '65.46.15603529534407971', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:22:33', 9, 0, '', '2019-06-12 23:22:33');
INSERT INTO `access_log` VALUES (35670, '65.47.15603530187167957', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:23:39', 10, 0, '', '2019-06-12 23:23:39');
INSERT INTO `access_log` VALUES (35671, '65.51.15603530187177983', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:23:39', 11, 2001001000, '服务端发生异常', '2019-06-12 23:23:39');
INSERT INTO `access_log` VALUES (35672, '65.45.15603530187207985', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:23:39', 11, 0, '', '2019-06-12 23:23:39');
INSERT INTO `access_log` VALUES (35673, '65.54.15603530325097943', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:23:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-12 23:23:53');
INSERT INTO `access_log` VALUES (35674, '65.53.15603530408867955', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:24:01', 89, 0, '', '2019-06-12 23:24:01');
INSERT INTO `access_log` VALUES (35675, '65.52.15603530411537985', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:24:01', 9, 0, '', '2019-06-12 23:24:01');
INSERT INTO `access_log` VALUES (35676, '65.3607.15603530411569735', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:24:01', 9, 0, '', '2019-06-12 23:24:01');
INSERT INTO `access_log` VALUES (35677, '65.49.15603530411587997', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:24:01', 9, 0, '', '2019-06-12 23:24:01');
INSERT INTO `access_log` VALUES (35678, '64.77.15603530506507399', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:24:11', 12, 0, '', '2019-06-12 23:24:11');
INSERT INTO `access_log` VALUES (35679, '64.80.15603530506487391', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:24:11', 16, 0, '', '2019-06-12 23:24:11');
INSERT INTO `access_log` VALUES (35680, '64.78.15603530539087397', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:24:14', 14, 0, '', '2019-06-12 23:24:14');
INSERT INTO `access_log` VALUES (35681, '64.79.15603530539077387', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:24:14', 21, 0, '', '2019-06-12 23:24:14');
INSERT INTO `access_log` VALUES (35682, '64.82.15603530592907403', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:24:19', 10, 0, '', '2019-06-12 23:24:19');
INSERT INTO `access_log` VALUES (35683, '64.81.15603530592907391', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.113.1.147', '2019-06-12 23:24:19', 11, 0, '', '2019-06-12 23:24:19');
INSERT INTO `access_log` VALUES (35684, '64.77.15603531101667401', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.91.60.104', '2019-06-12 23:25:10', 1, 1002001015, '账号未登陆', '2019-06-12 23:25:10');
INSERT INTO `access_log` VALUES (35685, '64.80.15603531101787393', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.227.139.178', '2019-06-12 23:25:10', 0, 1002001015, '账号未登陆', '2019-06-12 23:25:10');
INSERT INTO `access_log` VALUES (35686, '64.78.15603531149867399', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.207.186', '2019-06-12 23:25:15', 0, 1002001015, '账号未登陆', '2019-06-12 23:25:15');
INSERT INTO `access_log` VALUES (35687, '59.74.15603564398437515', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:40', 12, 0, '', '2019-06-13 00:20:40');
INSERT INTO `access_log` VALUES (35688, '59.76.15603564398447513', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:40', 16, 2001001000, '服务端发生异常', '2019-06-13 00:20:40');
INSERT INTO `access_log` VALUES (35689, '64.84.15603564451537445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:45', 10, 0, '', '2019-06-13 00:20:45');
INSERT INTO `access_log` VALUES (35690, '64.77.15603564453217447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:45', 3, 0, '', '2019-06-13 00:20:45');
INSERT INTO `access_log` VALUES (35691, '64.80.15603564465157439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:47', 2, 0, '', '2019-06-13 00:20:47');
INSERT INTO `access_log` VALUES (35692, '64.85.15603564472587457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:47', 2, 0, '', '2019-06-13 00:20:47');
INSERT INTO `access_log` VALUES (35693, '64.79.15603564478807435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:48', 2, 0, '', '2019-06-13 00:20:48');
INSERT INTO `access_log` VALUES (35694, '59.77.15603564492687509', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:49', 4, 0, '', '2019-06-13 00:20:49');
INSERT INTO `access_log` VALUES (35695, '59.80.15603564492687507', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:49', 21, 2001001000, '服务端发生异常', '2019-06-13 00:20:49');
INSERT INTO `access_log` VALUES (35696, '64.81.15603564521217441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:52', 2, 0, '', '2019-06-13 00:20:52');
INSERT INTO `access_log` VALUES (35697, '64.78.15603564522387447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:52', 2, 0, '', '2019-06-13 00:20:52');
INSERT INTO `access_log` VALUES (35698, '64.83.15603564533257431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:53', 2, 0, '', '2019-06-13 00:20:53');
INSERT INTO `access_log` VALUES (35699, '64.76.15603564538597433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:54', 2, 0, '', '2019-06-13 00:20:54');
INSERT INTO `access_log` VALUES (35700, '59.73.15603564583027521', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:58', 3, 0, '', '2019-06-13 00:20:58');
INSERT INTO `access_log` VALUES (35701, '59.78.15603564583037519', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.159.64.144', '2019-06-13 00:20:58', 13, 2001001000, '服务端发生异常', '2019-06-13 00:20:58');
INSERT INTO `access_log` VALUES (35702, '59.80.15603580266797529', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.114.203.22', '2019-06-13 00:47:07', 14, 2001001000, '服务端发生异常', '2019-06-13 00:47:07');
INSERT INTO `access_log` VALUES (35703, '59.79.15603580266777547', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.114.203.22', '2019-06-13 00:47:07', 145, 0, '', '2019-06-13 00:47:07');
INSERT INTO `access_log` VALUES (35704, '65.53.15603580336138023', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.114.203.22', '2019-06-13 00:47:14', 0, 1002001015, '账号未登陆', '2019-06-13 00:47:14');
INSERT INTO `access_log` VALUES (35705, '65.3607.15603580336149803', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.114.203.22', '2019-06-13 00:47:14', 0, 1002001015, '账号未登陆', '2019-06-13 00:47:14');
INSERT INTO `access_log` VALUES (35706, '65.54.15603580336138011', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.114.203.22', '2019-06-13 00:47:14', 0, 1002001015, '账号未登陆', '2019-06-13 00:47:14');
INSERT INTO `access_log` VALUES (35707, '64.81.15603580422057463', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.114.203.22', '2019-06-13 00:47:22', 128, 0, '', '2019-06-13 00:47:22');
INSERT INTO `access_log` VALUES (35708, '64.78.15603580425217469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.114.203.22', '2019-06-13 00:47:23', 1, 0, '', '2019-06-13 00:47:23');
INSERT INTO `access_log` VALUES (35709, '65.45.15603580514138053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.114.203.22', '2019-06-13 00:47:31', 99, 0, '', '2019-06-13 00:47:32');
INSERT INTO `access_log` VALUES (35710, '65.50.15603580519458053', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.114.203.22', '2019-06-13 00:47:32', 11, 0, '', '2019-06-13 00:47:32');
INSERT INTO `access_log` VALUES (35711, '65.47.15603580519528029', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.114.203.22', '2019-06-13 00:47:32', 10, 2001001000, '服务端发生异常', '2019-06-13 00:47:32');
INSERT INTO `access_log` VALUES (35712, '65.49.15603580519598067', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.114.203.22', '2019-06-13 00:47:32', 9, 0, '', '2019-06-13 00:47:32');
INSERT INTO `access_log` VALUES (35713, '59.72.15603658703297647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; HMA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '36.108.41.84', '2019-06-13 02:57:50', 11, 0, '', '2019-06-13 02:57:50');
INSERT INTO `access_log` VALUES (35714, '59.75.15603658703357649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; HMA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Mobile Safari/537.36', '36.108.41.84', '2019-06-13 02:57:50', 16, 2001001000, '服务端发生异常', '2019-06-13 02:57:50');
INSERT INTO `access_log` VALUES (35715, '59.73.15603727354447739', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.24.7', '2019-06-13 04:52:15', 10, 0, '', '2019-06-13 04:52:15');
INSERT INTO `access_log` VALUES (35716, '59.72.15603727354547739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.24.7', '2019-06-13 04:52:15', 10, 2001001000, '服务端发生异常', '2019-06-13 04:52:15');
INSERT INTO `access_log` VALUES (35717, '64.78.15603727391387665', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.24.7', '2019-06-13 04:52:19', 178, 0, '', '2019-06-13 04:52:19');
INSERT INTO `access_log` VALUES (35718, '64.83.15603727394687649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.24.7', '2019-06-13 04:52:19', 2, 0, '', '2019-06-13 04:52:19');
INSERT INTO `access_log` VALUES (35719, '66.57.15603727496416169', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=32432423432&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.38.24.7', '2019-06-13 04:52:30', 15, 1001003000, '验证码不存在', '2019-06-13 04:52:30');
INSERT INTO `access_log` VALUES (35720, '65.46.15603791633458325', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.60', '2019-06-13 06:39:23', 0, 1002001015, '账号未登陆', '2019-06-13 06:39:23');
INSERT INTO `access_log` VALUES (35721, '65.50.15603791633458337', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.60', '2019-06-13 06:39:23', 0, 1002001015, '账号未登陆', '2019-06-13 06:39:23');
INSERT INTO `access_log` VALUES (35722, '65.53.15603791633488309', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.60', '2019-06-13 06:39:23', 0, 1002001015, '账号未登陆', '2019-06-13 06:39:23');
INSERT INTO `access_log` VALUES (35723, '65.3607.15603791681400087', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.60', '2019-06-13 06:39:28', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 06:39:28');
INSERT INTO `access_log` VALUES (35724, '65.52.15603791745158335', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.60', '2019-06-13 06:39:35', 84, 0, '', '2019-06-13 06:39:35');
INSERT INTO `access_log` VALUES (35725, '65.49.15603791748808349', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.60', '2019-06-13 06:39:35', 12, 0, '', '2019-06-13 06:39:35');
INSERT INTO `access_log` VALUES (35726, '65.45.15603791748878339', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.60', '2019-06-13 06:39:35', 10, 2001001000, '服务端发生异常', '2019-06-13 06:39:35');
INSERT INTO `access_log` VALUES (35727, '65.51.15603791748948337', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.60', '2019-06-13 06:39:35', 9, 0, '', '2019-06-13 06:39:35');
INSERT INTO `access_log` VALUES (35728, '65.53.15603791948838311', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.60', '2019-06-13 06:39:55', 10, 0, '', '2019-06-13 06:39:55');
INSERT INTO `access_log` VALUES (35729, '65.50.15603791948958339', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.60', '2019-06-13 06:39:55', 10, 0, '', '2019-06-13 06:39:55');
INSERT INTO `access_log` VALUES (35730, '65.54.15603791948958299', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.60', '2019-06-13 06:39:55', 10, 2001001000, '服务端发生异常', '2019-06-13 06:39:55');
INSERT INTO `access_log` VALUES (35731, '65.52.15603791998488337', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.60', '2019-06-13 06:40:00', 10, 2001001000, '服务端发生异常', '2019-06-13 06:40:00');
INSERT INTO `access_log` VALUES (35732, '65.49.15603791998558351', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.60', '2019-06-13 06:40:00', 9, 0, '', '2019-06-13 06:40:00');
INSERT INTO `access_log` VALUES (35733, '65.3607.15603791998460089', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.60', '2019-06-13 06:40:00', 9, 0, '', '2019-06-13 06:40:00');
INSERT INTO `access_log` VALUES (35734, '59.80.15603808948817835', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/42.0.2311.154 Safari/537.36 LBBROWSER', '113.87.129.146', '2019-06-13 07:08:15', 11, 0, '', '2019-06-13 07:08:15');
INSERT INTO `access_log` VALUES (35735, '59.79.15603808948827853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/42.0.2311.154 Safari/537.36 LBBROWSER', '113.87.129.146', '2019-06-13 07:08:15', 16, 2001001000, '服务端发生异常', '2019-06-13 07:08:15');
INSERT INTO `access_log` VALUES (35736, '59.80.15603852172617893', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.247.49.90', '2019-06-13 08:20:17', 11, 0, '', '2019-06-13 08:20:17');
INSERT INTO `access_log` VALUES (35737, '59.79.15603852172627911', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.247.49.90', '2019-06-13 08:20:17', 15, 2001001000, '服务端发生异常', '2019-06-13 08:20:17');
INSERT INTO `access_log` VALUES (35738, '64.80.15603852276047825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.247.49.90', '2019-06-13 08:20:28', 11, 0, '', '2019-06-13 08:20:28');
INSERT INTO `access_log` VALUES (35739, '64.85.15603852277317843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.247.49.90', '2019-06-13 08:20:28', 3, 0, '', '2019-06-13 08:20:28');
INSERT INTO `access_log` VALUES (35740, '59.78.15603852288237905', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.247.49.90', '2019-06-13 08:20:29', 4, 0, '', '2019-06-13 08:20:29');
INSERT INTO `access_log` VALUES (35741, '59.73.15603852288237907', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.247.49.90', '2019-06-13 08:20:29', 14, 2001001000, '服务端发生异常', '2019-06-13 08:20:29');
INSERT INTO `access_log` VALUES (35742, '65.50.15603906086138491', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.168.50', '2019-06-13 09:50:09', 0, 1002001015, '账号未登陆', '2019-06-13 09:50:09');
INSERT INTO `access_log` VALUES (35743, '65.3607.15603906086130243', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.168.50', '2019-06-13 09:50:09', 1, 1002001015, '账号未登陆', '2019-06-13 09:50:09');
INSERT INTO `access_log` VALUES (35744, '65.54.15603906086478453', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.168.50', '2019-06-13 09:50:09', 1, 1002001015, '账号未登陆', '2019-06-13 09:50:09');
INSERT INTO `access_log` VALUES (35745, '65.49.15603906118788505', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.168.50', '2019-06-13 09:50:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 09:50:12');
INSERT INTO `access_log` VALUES (35746, '65.51.15603906263268493', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.168.50', '2019-06-13 09:50:26', 88, 0, '', '2019-06-13 09:50:26');
INSERT INTO `access_log` VALUES (35747, '65.47.15603906268558467', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.168.50', '2019-06-13 09:50:27', 12, 0, '', '2019-06-13 09:50:27');
INSERT INTO `access_log` VALUES (35748, '65.45.15603906268578495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.168.50', '2019-06-13 09:50:27', 11, 2001001000, '服务端发生异常', '2019-06-13 09:50:27');
INSERT INTO `access_log` VALUES (35749, '65.46.15603906268618483', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.168.50', '2019-06-13 09:50:27', 10, 0, '', '2019-06-13 09:50:27');
INSERT INTO `access_log` VALUES (35750, '65.50.15603906337518493', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.168.50', '2019-06-13 09:50:34', 10, 0, '', '2019-06-13 09:50:34');
INSERT INTO `access_log` VALUES (35751, '65.3607.15603906337570245', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.168.50', '2019-06-13 09:50:34', 11, 2001001000, '服务端发生异常', '2019-06-13 09:50:34');
INSERT INTO `access_log` VALUES (35752, '65.54.15603906337638455', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.168.50', '2019-06-13 09:50:34', 9, 0, '', '2019-06-13 09:50:34');
INSERT INTO `access_log` VALUES (35753, '65.51.15603911146648501', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '122.235.82.145', '2019-06-13 09:58:35', 0, 1002001015, '账号未登陆', '2019-06-13 09:58:35');
INSERT INTO `access_log` VALUES (35754, '65.52.15603911146648499', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '122.235.82.145', '2019-06-13 09:58:35', 0, 1002001015, '账号未登陆', '2019-06-13 09:58:35');
INSERT INTO `access_log` VALUES (35755, '65.47.15603911146658475', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '122.235.82.145', '2019-06-13 09:58:35', 0, 1002001015, '账号未登陆', '2019-06-13 09:58:35');
INSERT INTO `access_log` VALUES (35756, '65.46.15603911192378491', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '122.235.82.145', '2019-06-13 09:58:39', 106, 0, '', '2019-06-13 09:58:39');
INSERT INTO `access_log` VALUES (35757, '65.54.15603911195628463', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '122.235.82.145', '2019-06-13 09:58:40', 10, 0, '', '2019-06-13 09:58:40');
INSERT INTO `access_log` VALUES (35758, '65.3607.15603911195660253', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '122.235.82.145', '2019-06-13 09:58:40', 10, 0, '', '2019-06-13 09:58:40');
INSERT INTO `access_log` VALUES (35759, '65.50.15603911195658501', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '122.235.82.145', '2019-06-13 09:58:40', 10, 2001001000, '服务端发生异常', '2019-06-13 09:58:40');
INSERT INTO `access_log` VALUES (35760, '65.53.15603911245298475', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '122.235.82.145', '2019-06-13 09:58:45', 7, 0, '', '2019-06-13 09:58:45');
INSERT INTO `access_log` VALUES (35761, '65.49.15603911245338515', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '122.235.82.145', '2019-06-13 09:58:45', 9, 2001001000, '服务端发生异常', '2019-06-13 09:58:45');
INSERT INTO `access_log` VALUES (35762, '65.52.15603911245368501', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '122.235.82.145', '2019-06-13 09:58:45', 8, 0, '', '2019-06-13 09:58:45');
INSERT INTO `access_log` VALUES (35763, '65.46.15603913190318495', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '117.39.60.222', '2019-06-13 10:01:59', 4, 1002001012, '访问令牌已过期', '2019-06-13 10:01:59');
INSERT INTO `access_log` VALUES (35764, '65.54.15603913190328467', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '117.39.60.222', '2019-06-13 10:01:59', 4, 1002001012, '访问令牌已过期', '2019-06-13 10:01:59');
INSERT INTO `access_log` VALUES (35765, '65.3607.15603913190330257', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '117.39.60.222', '2019-06-13 10:01:59', 3, 1002001012, '访问令牌已过期', '2019-06-13 10:01:59');
INSERT INTO `access_log` VALUES (35766, '62.82.15603913191427761', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '117.39.60.222', '2019-06-13 10:01:59', 24, 1002001012, '访问令牌已过期', '2019-06-13 10:01:59');
INSERT INTO `access_log` VALUES (35767, '65.54.15603917264778473', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:08:46', 1, 1002001015, '账号未登陆', '2019-06-13 10:08:46');
INSERT INTO `access_log` VALUES (35768, '65.46.15603917264778501', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:08:46', 0, 1002001015, '账号未登陆', '2019-06-13 10:08:46');
INSERT INTO `access_log` VALUES (35769, '65.3607.15603917264830263', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:08:46', 0, 1002001015, '账号未登陆', '2019-06-13 10:08:46');
INSERT INTO `access_log` VALUES (35770, '65.50.15603917290578511', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:08:49', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 10:08:49');
INSERT INTO `access_log` VALUES (35771, '65.53.15603917535228485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:09:14', 61, 0, '', '2019-06-13 10:09:14');
INSERT INTO `access_log` VALUES (35772, '65.47.15603917538528487', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:09:14', 9, 0, '', '2019-06-13 10:09:14');
INSERT INTO `access_log` VALUES (35773, '65.51.15603917538548513', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:09:14', 9, 2001001000, '服务端发生异常', '2019-06-13 10:09:14');
INSERT INTO `access_log` VALUES (35774, '65.45.15603917538608515', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:09:14', 8, 0, '', '2019-06-13 10:09:14');
INSERT INTO `access_log` VALUES (35775, '65.53.15603918277618487', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:10:28', 10, 2001001000, '服务端发生异常', '2019-06-13 10:10:28');
INSERT INTO `access_log` VALUES (35776, '65.51.15603918277618515', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:10:28', 9, 0, '', '2019-06-13 10:10:28');
INSERT INTO `access_log` VALUES (35777, '65.49.15603918277588527', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:10:28', 328, 0, '', '2019-06-13 10:10:28');
INSERT INTO `access_log` VALUES (35778, '65.45.15603918363518517', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:10:36', 10, 0, '', '2019-06-13 10:10:36');
INSERT INTO `access_log` VALUES (35779, '65.47.15603918363548489', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:10:36', 10, 2001001000, '服务端发生异常', '2019-06-13 10:10:36');
INSERT INTO `access_log` VALUES (35780, '65.46.15603918363588505', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:10:36', 9, 0, '', '2019-06-13 10:10:36');
INSERT INTO `access_log` VALUES (35781, '65.54.15603918439458477', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:10:44', 10, 0, '', '2019-06-13 10:10:44');
INSERT INTO `access_log` VALUES (35782, '65.50.15603918439498515', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:10:44', 10, 2001001000, '服务端发生异常', '2019-06-13 10:10:44');
INSERT INTO `access_log` VALUES (35783, '65.52.15603918439538515', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:10:44', 9, 0, '', '2019-06-13 10:10:44');
INSERT INTO `access_log` VALUES (35784, '65.51.15603918520338517', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:10:52', 9, 2001001000, '服务端发生异常', '2019-06-13 10:10:52');
INSERT INTO `access_log` VALUES (35785, '65.53.15603918520318489', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:10:52', 11, 0, '', '2019-06-13 10:10:52');
INSERT INTO `access_log` VALUES (35786, '65.49.15603918520358529', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-13 10:10:52', 7, 0, '', '2019-06-13 10:10:52');
INSERT INTO `access_log` VALUES (35787, '65.49.15603946505898567', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.42.82', '2019-06-13 10:57:31', 0, 1002001015, '账号未登陆', '2019-06-13 10:57:31');
INSERT INTO `access_log` VALUES (35788, '65.51.15603946505908555', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.42.82', '2019-06-13 10:57:31', 0, 1002001015, '账号未登陆', '2019-06-13 10:57:31');
INSERT INTO `access_log` VALUES (35789, '65.53.15603946505918527', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.42.82', '2019-06-13 10:57:31', 0, 1002001015, '账号未登陆', '2019-06-13 10:57:31');
INSERT INTO `access_log` VALUES (35790, '65.46.15603946526588545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.42.82', '2019-06-13 10:57:33', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 10:57:33');
INSERT INTO `access_log` VALUES (35791, '65.45.15603946596068557', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.42.82', '2019-06-13 10:57:40', 92, 0, '', '2019-06-13 10:57:40');
INSERT INTO `access_log` VALUES (35792, '65.3607.15603946599860307', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.42.82', '2019-06-13 10:57:40', 14, 0, '', '2019-06-13 10:57:40');
INSERT INTO `access_log` VALUES (35793, '65.50.15603946599908555', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.42.82', '2019-06-13 10:57:40', 12, 0, '', '2019-06-13 10:57:40');
INSERT INTO `access_log` VALUES (35794, '65.54.15603946599878517', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.42.82', '2019-06-13 10:57:40', 25, 2001001000, '服务端发生异常', '2019-06-13 10:57:40');
INSERT INTO `access_log` VALUES (35795, '59.77.15603947812518023', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.165', '2019-06-13 10:59:41', 13, 0, '', '2019-06-13 10:59:41');
INSERT INTO `access_log` VALUES (35796, '59.78.15603947812528033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.165', '2019-06-13 10:59:41', 16, 2001001000, '服务端发生异常', '2019-06-13 10:59:41');
INSERT INTO `access_log` VALUES (35797, '64.77.15603947855297961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.165', '2019-06-13 10:59:46', 9, 0, '', '2019-06-13 10:59:46');
INSERT INTO `access_log` VALUES (35798, '64.80.15603947857017953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.165', '2019-06-13 10:59:46', 2, 0, '', '2019-06-13 10:59:46');
INSERT INTO `access_log` VALUES (35799, '65.53.15603951130958535', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.141.211.66', '2019-06-13 11:05:13', 1, 1002001015, '账号未登陆', '2019-06-13 11:05:13');
INSERT INTO `access_log` VALUES (35800, '65.47.15603951130958537', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.141.211.66', '2019-06-13 11:05:13', 0, 1002001015, '账号未登陆', '2019-06-13 11:05:13');
INSERT INTO `access_log` VALUES (35801, '65.50.15603951130958561', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.141.211.66', '2019-06-13 11:05:13', 0, 1002001015, '账号未登陆', '2019-06-13 11:05:13');
INSERT INTO `access_log` VALUES (35802, '65.3607.15603951272280315', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.141.211.66', '2019-06-13 11:05:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 11:05:27');
INSERT INTO `access_log` VALUES (35803, '65.52.15603951491588563', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.141.211.66', '2019-06-13 11:05:49', 80, 0, '', '2019-06-13 11:05:49');
INSERT INTO `access_log` VALUES (35804, '65.51.15603951495528565', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.141.211.66', '2019-06-13 11:05:50', 8, 0, '', '2019-06-13 11:05:50');
INSERT INTO `access_log` VALUES (35805, '65.49.15603951495628575', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.141.211.66', '2019-06-13 11:05:50', 9, 0, '', '2019-06-13 11:05:50');
INSERT INTO `access_log` VALUES (35806, '65.46.15603951495638555', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.141.211.66', '2019-06-13 11:05:50', 10, 2001001000, '服务端发生异常', '2019-06-13 11:05:50');
INSERT INTO `access_log` VALUES (35807, '65.3607.15603951700210317', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.141.211.66', '2019-06-13 11:06:10', 22, 0, '', '2019-06-13 11:06:10');
INSERT INTO `access_log` VALUES (35808, '65.47.15603951700198539', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.141.211.66', '2019-06-13 11:06:10', 27, 0, '', '2019-06-13 11:06:10');
INSERT INTO `access_log` VALUES (35809, '65.45.15603951700198567', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.141.211.66', '2019-06-13 11:06:10', 29, 2001001000, '服务端发生异常', '2019-06-13 11:06:10');
INSERT INTO `access_log` VALUES (35810, '65.53.15603952468348539', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '61.141.139.105', '2019-06-13 11:07:27', 0, 1002001015, '账号未登陆', '2019-06-13 11:07:27');
INSERT INTO `access_log` VALUES (35811, '65.50.15603952468418565', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '61.141.139.105', '2019-06-13 11:07:27', 0, 1002001015, '账号未登陆', '2019-06-13 11:07:27');
INSERT INTO `access_log` VALUES (35812, '65.3607.15603952468460319', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '61.141.139.105', '2019-06-13 11:07:27', 0, 1002001015, '账号未登陆', '2019-06-13 11:07:27');
INSERT INTO `access_log` VALUES (35813, '65.45.15603952498768569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '61.141.139.105', '2019-06-13 11:07:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 11:07:30');
INSERT INTO `access_log` VALUES (35814, '65.47.15603952567618541', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '61.141.139.105', '2019-06-13 11:07:37', 68, 0, '', '2019-06-13 11:07:37');
INSERT INTO `access_log` VALUES (35815, '65.54.15603952571428529', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '61.141.139.105', '2019-06-13 11:07:37', 7, 0, '', '2019-06-13 11:07:37');
INSERT INTO `access_log` VALUES (35816, '65.52.15603952571468567', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '61.141.139.105', '2019-06-13 11:07:37', 8, 2001001000, '服务端发生异常', '2019-06-13 11:07:37');
INSERT INTO `access_log` VALUES (35817, '65.46.15603952571498559', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '61.141.139.105', '2019-06-13 11:07:37', 9, 0, '', '2019-06-13 11:07:37');
INSERT INTO `access_log` VALUES (35818, '59.75.15603954133658045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '39.155.185.27', '2019-06-13 11:10:13', 4, 0, '', '2019-06-13 11:10:13');
INSERT INTO `access_log` VALUES (35819, '59.71.15603954133688045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '39.155.185.27', '2019-06-13 11:10:13', 21, 2001001000, '服务端发生异常', '2019-06-13 11:10:13');
INSERT INTO `access_log` VALUES (35820, '59.80.15603956102198033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 11:13:30', 14, 2001001000, '服务端发生异常', '2019-06-13 11:13:30');
INSERT INTO `access_log` VALUES (35821, '59.78.15603956102378045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 11:13:30', 3, 0, '', '2019-06-13 11:13:30');
INSERT INTO `access_log` VALUES (35822, '64.79.15603957013887961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 11:15:01', 3, 0, '', '2019-06-13 11:15:01');
INSERT INTO `access_log` VALUES (35823, '64.82.15603957029417977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 11:15:03', 2, 0, '', '2019-06-13 11:15:03');
INSERT INTO `access_log` VALUES (35824, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 11:15:05', 6, 0, '', '2019-06-13 11:15:05');
INSERT INTO `access_log` VALUES (35825, '64.81.15603957051377967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 11:15:05', 2, 0, '', '2019-06-13 11:15:05');
INSERT INTO `access_log` VALUES (35826, '64.83.15603957075407957', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 11:15:08', 7, 0, '', '2019-06-13 11:15:08');
INSERT INTO `access_log` VALUES (35827, '59.72.15603962430308055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:03', 3, 0, '', '2019-06-13 11:24:03');
INSERT INTO `access_log` VALUES (35828, '59.75.15603962430308057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:03', 13, 2001001000, '服务端发生异常', '2019-06-13 11:24:03');
INSERT INTO `access_log` VALUES (35829, '64.82.15603962492377985', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:09', 2, 0, '', '2019-06-13 11:24:09');
INSERT INTO `access_log` VALUES (35830, '64.81.15603962493277975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:09', 1, 0, '', '2019-06-13 11:24:09');
INSERT INTO `access_log` VALUES (35831, '64.78.15603962534267981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:13', 2, 0, '', '2019-06-13 11:24:13');
INSERT INTO `access_log` VALUES (35832, '64.83.15603962539837965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:14', 2, 0, '', '2019-06-13 11:24:14');
INSERT INTO `access_log` VALUES (35833, '64.76.15603962546007967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:15', 2, 0, '', '2019-06-13 11:24:15');
INSERT INTO `access_log` VALUES (35834, '64.84.15603962550487981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:15', 2, 0, '', '2019-06-13 11:24:15');
INSERT INTO `access_log` VALUES (35835, '64.77.15603962553707983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:15', 2, 0, '', '2019-06-13 11:24:15');
INSERT INTO `access_log` VALUES (35836, '64.80.15603962556397975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:16', 2, 0, '', '2019-06-13 11:24:16');
INSERT INTO `access_log` VALUES (35837, '64.85.15603962559607993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:16', 2, 0, '', '2019-06-13 11:24:16');
INSERT INTO `access_log` VALUES (35838, '64.79.15603962569777971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:17', 2, 0, '', '2019-06-13 11:24:17');
INSERT INTO `access_log` VALUES (35839, '64.82.15603962579937987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:18', 2, 0, '', '2019-06-13 11:24:18');
INSERT INTO `access_log` VALUES (35840, '64.81.15603962591407977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:19', 2, 0, '', '2019-06-13 11:24:19');
INSERT INTO `access_log` VALUES (35841, '64.78.15603962592677983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:19', 2, 0, '', '2019-06-13 11:24:19');
INSERT INTO `access_log` VALUES (35842, '64.76.15603962641387969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:24', 2, 0, '', '2019-06-13 11:24:24');
INSERT INTO `access_log` VALUES (35843, '64.84.15603962642517983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:24', 2, 0, '', '2019-06-13 11:24:24');
INSERT INTO `access_log` VALUES (35844, '59.74.15603962651568051', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:25', 3, 0, '', '2019-06-13 11:24:25');
INSERT INTO `access_log` VALUES (35845, '59.79.15603962651578061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:25', 11, 2001001000, '服务端发生异常', '2019-06-13 11:24:25');
INSERT INTO `access_log` VALUES (35846, '64.77.15603962683207985', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:28', 2, 0, '', '2019-06-13 11:24:28');
INSERT INTO `access_log` VALUES (35847, '64.80.15603962685377977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:29', 2, 0, '', '2019-06-13 11:24:29');
INSERT INTO `access_log` VALUES (35848, '59.78.15603962690488055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:29', 3, 0, '', '2019-06-13 11:24:29');
INSERT INTO `access_log` VALUES (35849, '59.80.15603962690488043', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.124.170', '2019-06-13 11:24:29', 11, 2001001000, '服务端发生异常', '2019-06-13 11:24:29');
INSERT INTO `access_log` VALUES (35850, '65.3607.15603967966590343', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-13 11:33:17', 4, 1002001012, '访问令牌已过期', '2019-06-13 11:33:17');
INSERT INTO `access_log` VALUES (35851, '65.50.15603967966598587', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-13 11:33:17', 4, 1002001012, '访问令牌已过期', '2019-06-13 11:33:17');
INSERT INTO `access_log` VALUES (35852, '65.47.15603967966608563', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-13 11:33:17', 3, 1002001012, '访问令牌已过期', '2019-06-13 11:33:17');
INSERT INTO `access_log` VALUES (35853, '65.45.15603968004198589', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-13 11:33:20', 63, 0, '', '2019-06-13 11:33:20');
INSERT INTO `access_log` VALUES (35854, '65.46.15603968006898583', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-13 11:33:21', 10, 0, '', '2019-06-13 11:33:21');
INSERT INTO `access_log` VALUES (35855, '65.51.15603968006918593', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-13 11:33:21', 8, 0, '', '2019-06-13 11:33:21');
INSERT INTO `access_log` VALUES (35856, '65.52.15603968006908589', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.40.89', '2019-06-13 11:33:21', 11, 2001001000, '服务端发生异常', '2019-06-13 11:33:21');
INSERT INTO `access_log` VALUES (35857, '65.3607.15603970154310347', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.84.120.146', '2019-06-13 11:36:55', 0, 1002001015, '账号未登陆', '2019-06-13 11:36:55');
INSERT INTO `access_log` VALUES (35858, '65.45.15603970154328593', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.84.120.146', '2019-06-13 11:36:55', 0, 1002001015, '账号未登陆', '2019-06-13 11:36:55');
INSERT INTO `access_log` VALUES (35859, '65.46.15603970154338587', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.84.120.146', '2019-06-13 11:36:55', 0, 1002001015, '账号未登陆', '2019-06-13 11:36:55');
INSERT INTO `access_log` VALUES (35860, '65.51.15603970305418597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.84.120.146', '2019-06-13 11:37:11', 4, 1002002000, '账号不存在', '2019-06-13 11:37:11');
INSERT INTO `access_log` VALUES (35861, '65.54.15603970354258557', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.84.120.146', '2019-06-13 11:37:15', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 11:37:15');
INSERT INTO `access_log` VALUES (35862, '59.76.15603970412058061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '180.167.213.26', '2019-06-13 11:37:21', 15, 0, '', '2019-06-13 11:37:21');
INSERT INTO `access_log` VALUES (35863, '59.71.15603970412048069', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '180.167.213.26', '2019-06-13 11:37:21', 20, 2001001000, '服务端发生异常', '2019-06-13 11:37:21');
INSERT INTO `access_log` VALUES (35864, '59.74.15603970452978063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '180.167.213.26', '2019-06-13 11:37:25', 10, 0, '', '2019-06-13 11:37:25');
INSERT INTO `access_log` VALUES (35865, '59.79.15603970452998073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '180.167.213.26', '2019-06-13 11:37:25', 25, 2001001000, '服务端发生异常', '2019-06-13 11:37:25');
INSERT INTO `access_log` VALUES (35866, '65.47.15603970628618569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.84.120.146', '2019-06-13 11:37:43', 92, 0, '', '2019-06-13 11:37:43');
INSERT INTO `access_log` VALUES (35867, '65.50.15603970635008593', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.84.120.146', '2019-06-13 11:37:44', 9, 0, '', '2019-06-13 11:37:44');
INSERT INTO `access_log` VALUES (35868, '65.46.15603970635038589', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.84.120.146', '2019-06-13 11:37:44', 9, 2001001000, '服务端发生异常', '2019-06-13 11:37:44');
INSERT INTO `access_log` VALUES (35869, '65.3607.15603970635060349', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.84.120.146', '2019-06-13 11:37:44', 9, 0, '', '2019-06-13 11:37:44');
INSERT INTO `access_log` VALUES (35870, '65.45.15603970692348595', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.84.120.146', '2019-06-13 11:37:49', 10, 0, '', '2019-06-13 11:37:49');
INSERT INTO `access_log` VALUES (35871, '65.52.15603970692418595', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.84.120.146', '2019-06-13 11:37:49', 10, 2001001000, '服务端发生异常', '2019-06-13 11:37:49');
INSERT INTO `access_log` VALUES (35872, '65.51.15603970692418599', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.84.120.146', '2019-06-13 11:37:49', 9, 0, '', '2019-06-13 11:37:49');
INSERT INTO `access_log` VALUES (35873, '59.74.15603977708938073', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '218.92.211.30', '2019-06-13 11:49:31', 3, 0, '', '2019-06-13 11:49:31');
INSERT INTO `access_log` VALUES (35874, '59.79.15603977708938083', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '218.92.211.30', '2019-06-13 11:49:31', 12, 2001001000, '服务端发生异常', '2019-06-13 11:49:31');
INSERT INTO `access_log` VALUES (35875, '64.79.15603977782657993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '218.92.211.30', '2019-06-13 11:49:38', 2, 0, '', '2019-06-13 11:49:38');
INSERT INTO `access_log` VALUES (35876, '64.82.15603977783358009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '218.92.211.30', '2019-06-13 11:49:38', 2, 0, '', '2019-06-13 11:49:38');
INSERT INTO `access_log` VALUES (35877, '64.81.15603977795637999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '218.92.211.30', '2019-06-13 11:49:40', 2, 0, '', '2019-06-13 11:49:40');
INSERT INTO `access_log` VALUES (35878, '64.78.15603977800338005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '218.92.211.30', '2019-06-13 11:49:40', 1, 0, '', '2019-06-13 11:49:40');
INSERT INTO `access_log` VALUES (35879, '66.48.15603977827016511', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '218.92.211.30', '2019-06-13 11:49:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空', '2019-06-13 11:49:43');
INSERT INTO `access_log` VALUES (35880, '65.47.15603979989828583', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:53:19', 0, 1002001015, '账号未登陆', '2019-06-13 11:53:19');
INSERT INTO `access_log` VALUES (35881, '65.49.15603979989818619', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:53:19', 1, 1002001015, '账号未登陆', '2019-06-13 11:53:19');
INSERT INTO `access_log` VALUES (35882, '65.46.15603979989848603', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:53:19', 1, 1002001015, '账号未登陆', '2019-06-13 11:53:19');
INSERT INTO `access_log` VALUES (35883, '65.51.15603980409088613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:54:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 11:54:01');
INSERT INTO `access_log` VALUES (35884, '65.45.15603980455078609', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:54:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 11:54:06');
INSERT INTO `access_log` VALUES (35885, '65.53.15603980551458583', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:54:15', 95, 0, '', '2019-06-13 11:54:15');
INSERT INTO `access_log` VALUES (35886, '65.46.15603980555208605', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:54:16', 9, 0, '', '2019-06-13 11:54:16');
INSERT INTO `access_log` VALUES (35887, '65.47.15603980555218585', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:54:16', 10, 0, '', '2019-06-13 11:54:16');
INSERT INTO `access_log` VALUES (35888, '65.49.15603980555208621', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:54:16', 11, 2001001000, '服务端发生异常', '2019-06-13 11:54:16');
INSERT INTO `access_log` VALUES (35889, '65.50.15603980614598609', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:54:21', 8, 0, '', '2019-06-13 11:54:21');
INSERT INTO `access_log` VALUES (35890, '65.3607.15603980614670365', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:54:21', 8, 2001001000, '服务端发生异常', '2019-06-13 11:54:21');
INSERT INTO `access_log` VALUES (35891, '65.52.15603980614758611', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:54:21', 7, 0, '', '2019-06-13 11:54:21');
INSERT INTO `access_log` VALUES (35892, '65.53.15603981051968585', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:55:05', 10, 0, '', '2019-06-13 11:55:05');
INSERT INTO `access_log` VALUES (35893, '65.49.15603981052018623', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:55:05', 9, 2001001000, '服务端发生异常', '2019-06-13 11:55:05');
INSERT INTO `access_log` VALUES (35894, '65.46.15603981052048607', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:55:05', 9, 0, '', '2019-06-13 11:55:05');
INSERT INTO `access_log` VALUES (35895, '65.47.15603981087318587', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:55:09', 9, 0, '', '2019-06-13 11:55:09');
INSERT INTO `access_log` VALUES (35896, '65.50.15603981087348611', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:55:09', 10, 2001001000, '服务端发生异常', '2019-06-13 11:55:09');
INSERT INTO `access_log` VALUES (35897, '65.3607.15603981087370367', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:55:09', 9, 0, '', '2019-06-13 11:55:09');
INSERT INTO `access_log` VALUES (35898, '65.51.15603981131068617', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:55:13', 7, 0, '', '2019-06-13 11:55:13');
INSERT INTO `access_log` VALUES (35899, '65.45.15603981131088613', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:55:13', 8, 2001001000, '服务端发生异常', '2019-06-13 11:55:13');
INSERT INTO `access_log` VALUES (35900, '65.54.15603981131228577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.171.84', '2019-06-13 11:55:13', 7, 0, '', '2019-06-13 11:55:13');
INSERT INTO `access_log` VALUES (35901, '65.3607.15603986259450375', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 12:03:46', 0, 1002001015, '账号未登陆', '2019-06-13 12:03:46');
INSERT INTO `access_log` VALUES (35902, '65.47.15603986259458595', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 12:03:46', 0, 1002001015, '账号未登陆', '2019-06-13 12:03:46');
INSERT INTO `access_log` VALUES (35903, '65.52.15603986259478621', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 12:03:46', 0, 1002001015, '账号未登陆', '2019-06-13 12:03:46');
INSERT INTO `access_log` VALUES (35904, '59.74.15603986331458085', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 12:03:53', 3, 0, '', '2019-06-13 12:03:53');
INSERT INTO `access_log` VALUES (35905, '65.54.15603986331428585', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 12:03:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 12:03:53');
INSERT INTO `access_log` VALUES (35906, '59.79.15603986331458095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 12:03:53', 12, 2001001000, '服务端发生异常', '2019-06-13 12:03:53');
INSERT INTO `access_log` VALUES (35907, '65.51.15603986371398625', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 12:03:57', 61, 0, '', '2019-06-13 12:03:57');
INSERT INTO `access_log` VALUES (35908, '65.46.15603986374658617', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 12:03:57', 9, 0, '', '2019-06-13 12:03:57');
INSERT INTO `access_log` VALUES (35909, '65.49.15603986374698633', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 12:03:57', 10, 2001001000, '服务端发生异常', '2019-06-13 12:03:57');
INSERT INTO `access_log` VALUES (35910, '65.53.15603986374818595', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 12:03:57', 9, 0, '', '2019-06-13 12:03:57');
INSERT INTO `access_log` VALUES (35911, '64.82.15603986448338021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 12:04:05', 620, 0, '', '2019-06-13 12:04:05');
INSERT INTO `access_log` VALUES (35912, '64.78.15603986455268017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 12:04:06', 2, 0, '', '2019-06-13 12:04:06');
INSERT INTO `access_log` VALUES (35913, '64.83.15603986481978001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 12:04:08', 2, 0, '', '2019-06-13 12:04:08');
INSERT INTO `access_log` VALUES (35914, '64.76.15603986483378003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.166.68.117', '2019-06-13 12:04:08', 1, 0, '', '2019-06-13 12:04:08');
INSERT INTO `access_log` VALUES (35915, '65.54.15604002160928607', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:16', 0, 1002001015, '账号未登陆', '2019-06-13 12:30:16');
INSERT INTO `access_log` VALUES (35916, '65.45.15604002160918643', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:16', 1, 1002001015, '账号未登陆', '2019-06-13 12:30:16');
INSERT INTO `access_log` VALUES (35917, '65.46.15604002160948637', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:16', 1, 1002001015, '账号未登陆', '2019-06-13 12:30:16');
INSERT INTO `access_log` VALUES (35918, '65.51.15604002182878649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 12:30:18');
INSERT INTO `access_log` VALUES (35919, '59.76.15604002418868105', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:42', 3, 0, '', '2019-06-13 12:30:42');
INSERT INTO `access_log` VALUES (35920, '59.74.15604002418928107', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:42', 12, 2001001000, '服务端发生异常', '2019-06-13 12:30:42');
INSERT INTO `access_log` VALUES (35921, '64.81.15604002451928033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:45', 3, 0, '', '2019-06-13 12:30:45');
INSERT INTO `access_log` VALUES (35922, '64.78.15604002453348039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:45', 2, 0, '', '2019-06-13 12:30:45');
INSERT INTO `access_log` VALUES (35923, '64.83.15604002470278023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:47', 2, 0, '', '2019-06-13 12:30:47');
INSERT INTO `access_log` VALUES (35924, '64.76.15604002474708025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:47', 2, 0, '', '2019-06-13 12:30:47');
INSERT INTO `access_log` VALUES (35925, '64.84.15604002483908039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:48', 2, 0, '', '2019-06-13 12:30:48');
INSERT INTO `access_log` VALUES (35926, '64.77.15604002489968041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:49', 2, 0, '', '2019-06-13 12:30:49');
INSERT INTO `access_log` VALUES (35927, '59.80.15604002512208099', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:51', 2, 0, '', '2019-06-13 12:30:51');
INSERT INTO `access_log` VALUES (35928, '59.78.15604002512218111', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:51', 13, 2001001000, '服务端发生异常', '2019-06-13 12:30:51');
INSERT INTO `access_log` VALUES (35929, '64.85.15604002529848051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:53', 2, 0, '', '2019-06-13 12:30:53');
INSERT INTO `access_log` VALUES (35930, '64.79.15604002531358029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:53', 2, 0, '', '2019-06-13 12:30:53');
INSERT INTO `access_log` VALUES (35931, '64.82.15604002547728045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:55', 2, 0, '', '2019-06-13 12:30:55');
INSERT INTO `access_log` VALUES (35932, '64.81.15604002551158035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:55', 2, 0, '', '2019-06-13 12:30:55');
INSERT INTO `access_log` VALUES (35933, '59.77.15604002558788101', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:56', 3, 0, '', '2019-06-13 12:30:56');
INSERT INTO `access_log` VALUES (35934, '59.73.15604002558798113', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:56', 13, 2001001000, '服务端发生异常', '2019-06-13 12:30:56');
INSERT INTO `access_log` VALUES (35935, '64.78.15604002581348041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:58', 1, 0, '', '2019-06-13 12:30:58');
INSERT INTO `access_log` VALUES (35936, '64.83.15604002582588025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:30:58', 2, 0, '', '2019-06-13 12:30:58');
INSERT INTO `access_log` VALUES (35937, '59.75.15604002622978115', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:31:02', 2, 0, '', '2019-06-13 12:31:02');
INSERT INTO `access_log` VALUES (35938, '59.72.15604002622988113', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:31:02', 13, 2001001000, '服务端发生异常', '2019-06-13 12:31:02');
INSERT INTO `access_log` VALUES (35939, '64.76.15604002627678027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:31:03', 2, 0, '', '2019-06-13 12:31:03');
INSERT INTO `access_log` VALUES (35940, '64.84.15604002629008041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:31:03', 1, 0, '', '2019-06-13 12:31:03');
INSERT INTO `access_log` VALUES (35941, '59.71.15604002632608115', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:31:03', 2, 0, '', '2019-06-13 12:31:03');
INSERT INTO `access_log` VALUES (35942, '59.74.15604002632618109', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:31:03', 20, 2001001000, '服务端发生异常', '2019-06-13 12:31:03');
INSERT INTO `access_log` VALUES (35943, '64.77.15604002637098043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:31:04', 1, 0, '', '2019-06-13 12:31:04');
INSERT INTO `access_log` VALUES (35944, '64.80.15604002638508035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:31:04', 3, 0, '', '2019-06-13 12:31:04');
INSERT INTO `access_log` VALUES (35945, '59.79.15604002642128119', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:31:04', 2, 0, '', '2019-06-13 12:31:04');
INSERT INTO `access_log` VALUES (35946, '59.80.15604002642158101', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '124.193.214.210', '2019-06-13 12:31:04', 12, 2001001000, '服务端发生异常', '2019-06-13 12:31:04');
INSERT INTO `access_log` VALUES (35947, '65.53.15604002761238619', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '58.247.212.141', '2019-06-13 12:31:16', 0, 1002001015, '账号未登陆', '2019-06-13 12:31:16');
INSERT INTO `access_log` VALUES (35948, '65.47.15604002768888621', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '223.167.152.53', '2019-06-13 12:31:17', 1, 1002001015, '账号未登陆', '2019-06-13 12:31:17');
INSERT INTO `access_log` VALUES (35949, '65.54.15604002790128609', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '58.246.221.162', '2019-06-13 12:31:19', 1, 1002001015, '账号未登陆', '2019-06-13 12:31:19');
INSERT INTO `access_log` VALUES (35950, '64.78.15604003112148043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '58.247.204.63', '2019-06-13 12:31:51', 1, 0, '', '2019-06-13 12:31:51');
INSERT INTO `access_log` VALUES (35951, '59.80.15604017404768121', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.194.187.2', '2019-06-13 12:55:40', 5, 0, '', '2019-06-13 12:55:40');
INSERT INTO `access_log` VALUES (35952, '59.79.15604017404778139', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.194.187.2', '2019-06-13 12:55:40', 14, 2001001000, '服务端发生异常', '2019-06-13 12:55:40');
INSERT INTO `access_log` VALUES (35953, '64.85.15604017440778073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.194.187.2', '2019-06-13 12:55:44', 2, 0, '', '2019-06-13 12:55:44');
INSERT INTO `access_log` VALUES (35954, '64.79.15604017442038051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.194.187.2', '2019-06-13 12:55:44', 2, 0, '', '2019-06-13 12:55:44');
INSERT INTO `access_log` VALUES (35955, '64.82.15604017461688067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.194.187.2', '2019-06-13 12:55:46', 2, 0, '', '2019-06-13 12:55:46');
INSERT INTO `access_log` VALUES (35956, '64.81.15604017466808057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.194.187.2', '2019-06-13 12:55:47', 2, 0, '', '2019-06-13 12:55:47');
INSERT INTO `access_log` VALUES (35957, '59.78.15604017476378133', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.194.187.2', '2019-06-13 12:55:48', 2, 0, '', '2019-06-13 12:55:48');
INSERT INTO `access_log` VALUES (35958, '59.77.15604017476378123', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.194.187.2', '2019-06-13 12:55:48', 12, 2001001000, '服务端发生异常', '2019-06-13 12:55:48');
INSERT INTO `access_log` VALUES (35959, '65.45.15604019316698667', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.236.2', '2019-06-13 12:58:52', 1, 1002001015, '账号未登陆', '2019-06-13 12:58:52');
INSERT INTO `access_log` VALUES (35960, '65.46.15604019316698661', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.236.2', '2019-06-13 12:58:52', 0, 1002001015, '账号未登陆', '2019-06-13 12:58:52');
INSERT INTO `access_log` VALUES (35961, '65.51.15604019316908673', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.236.2', '2019-06-13 12:58:52', 0, 1002001015, '账号未登陆', '2019-06-13 12:58:52');
INSERT INTO `access_log` VALUES (35962, '65.50.15604019399898669', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.141.236.2', '2019-06-13 12:59:00', 1, 1002001015, '账号未登陆', '2019-06-13 12:59:00');
INSERT INTO `access_log` VALUES (35963, '65.52.15604019400008671', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.141.236.2', '2019-06-13 12:59:00', 0, 1002001015, '账号未登陆', '2019-06-13 12:59:00');
INSERT INTO `access_log` VALUES (35964, '65.3607.15604019400070425', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.141.236.2', '2019-06-13 12:59:00', 1, 1002001015, '账号未登陆', '2019-06-13 12:59:00');
INSERT INTO `access_log` VALUES (35965, '65.47.15604019532868645', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.141.236.2', '2019-06-13 12:59:13', 58, 0, '', '2019-06-13 12:59:13');
INSERT INTO `access_log` VALUES (35966, '65.54.15604019537428633', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.141.236.2', '2019-06-13 12:59:14', 8, 0, '', '2019-06-13 12:59:14');
INSERT INTO `access_log` VALUES (35967, '65.45.15604019537438669', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.141.236.2', '2019-06-13 12:59:14', 11, 2001001000, '服务端发生异常', '2019-06-13 12:59:14');
INSERT INTO `access_log` VALUES (35968, '65.51.15604019537468675', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.141.236.2', '2019-06-13 12:59:14', 8, 0, '', '2019-06-13 12:59:14');
INSERT INTO `access_log` VALUES (35969, '65.46.15604019619148663', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.141.236.2', '2019-06-13 12:59:22', 10, 0, '', '2019-06-13 12:59:22');
INSERT INTO `access_log` VALUES (35970, '65.49.15604019619148679', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.141.236.2', '2019-06-13 12:59:22', 11, 2001001000, '服务端发生异常', '2019-06-13 12:59:22');
INSERT INTO `access_log` VALUES (35971, '65.50.15604019619188671', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.141.236.2', '2019-06-13 12:59:22', 9, 0, '', '2019-06-13 12:59:22');
INSERT INTO `access_log` VALUES (35972, '65.52.15604019777868673', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.236.2', '2019-06-13 12:59:38', 107, 0, '', '2019-06-13 12:59:38');
INSERT INTO `access_log` VALUES (35973, '65.53.15604019783728645', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.236.2', '2019-06-13 12:59:38', 8, 0, '', '2019-06-13 12:59:38');
INSERT INTO `access_log` VALUES (35974, '65.47.15604019783728647', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.236.2', '2019-06-13 12:59:38', 10, 2001001000, '服务端发生异常', '2019-06-13 12:59:38');
INSERT INTO `access_log` VALUES (35975, '65.51.15604019783938677', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.236.2', '2019-06-13 12:59:38', 8, 0, '', '2019-06-13 12:59:38');
INSERT INTO `access_log` VALUES (35976, '65.45.15604019891428671', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.236.2', '2019-06-13 12:59:49', 7, 0, '', '2019-06-13 12:59:49');
INSERT INTO `access_log` VALUES (35977, '65.46.15604019891478665', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.236.2', '2019-06-13 12:59:49', 8, 2001001000, '服务端发生异常', '2019-06-13 12:59:49');
INSERT INTO `access_log` VALUES (35978, '65.49.15604019891798681', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.141.236.2', '2019-06-13 12:59:49', 9, 0, '', '2019-06-13 12:59:49');
INSERT INTO `access_log` VALUES (35979, '59.79.15604031948438159', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:19:55', 3, 0, '', '2019-06-13 13:19:55');
INSERT INTO `access_log` VALUES (35980, '59.78.15604031948468153', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:19:55', 13, 2001001000, '服务端发生异常', '2019-06-13 13:19:55');
INSERT INTO `access_log` VALUES (35981, '64.79.15604031980768071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:19:58', 2, 0, '', '2019-06-13 13:19:58');
INSERT INTO `access_log` VALUES (35982, '64.82.15604031982048087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:19:58', 2, 0, '', '2019-06-13 13:19:58');
INSERT INTO `access_log` VALUES (35983, '64.81.15604031994948077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:19:59', 2, 0, '', '2019-06-13 13:19:59');
INSERT INTO `access_log` VALUES (35984, '64.78.15604032001598083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:20:00', 1, 0, '', '2019-06-13 13:20:00');
INSERT INTO `access_log` VALUES (35985, '64.83.15604032038148067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:20:04', 2, 0, '', '2019-06-13 13:20:04');
INSERT INTO `access_log` VALUES (35986, '64.76.15604032039658069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:20:04', 1, 0, '', '2019-06-13 13:20:04');
INSERT INTO `access_log` VALUES (35987, '59.73.15604032108528155', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:20:11', 3, 0, '', '2019-06-13 13:20:11');
INSERT INTO `access_log` VALUES (35988, '59.75.15604032108548157', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:20:11', 12, 2001001000, '服务端发生异常', '2019-06-13 13:20:11');
INSERT INTO `access_log` VALUES (35989, '64.77.15604032136738085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:20:14', 2, 0, '', '2019-06-13 13:20:14');
INSERT INTO `access_log` VALUES (35990, '64.80.15604032138108077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:20:14', 2, 0, '', '2019-06-13 13:20:14');
INSERT INTO `access_log` VALUES (35991, '64.85.15604032147908095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:20:15', 2, 0, '', '2019-06-13 13:20:15');
INSERT INTO `access_log` VALUES (35992, '64.79.15604032151958073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:20:15', 1, 0, '', '2019-06-13 13:20:15');
INSERT INTO `access_log` VALUES (35993, '64.82.15604032155108089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:20:16', 2, 0, '', '2019-06-13 13:20:16');
INSERT INTO `access_log` VALUES (35994, '64.81.15604032159968079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:20:16', 2, 0, '', '2019-06-13 13:20:16');
INSERT INTO `access_log` VALUES (35995, '59.72.15604032172728155', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:20:17', 3, 0, '', '2019-06-13 13:20:17');
INSERT INTO `access_log` VALUES (35996, '59.74.15604032172728151', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.93.121.138', '2019-06-13 13:20:17', 13, 2001001000, '服务端发生异常', '2019-06-13 13:20:17');
INSERT INTO `access_log` VALUES (35997, '59.71.15604039565358167', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.175.169.59', '2019-06-13 13:32:37', 4, 0, '', '2019-06-13 13:32:37');
INSERT INTO `access_log` VALUES (35998, '59.76.15604039565378159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.175.169.59', '2019-06-13 13:32:37', 14, 2001001000, '服务端发生异常', '2019-06-13 13:32:37');
INSERT INTO `access_log` VALUES (35999, '64.78.15604039597758095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.175.169.59', '2019-06-13 13:32:40', 3, 0, '', '2019-06-13 13:32:40');
INSERT INTO `access_log` VALUES (36000, '64.83.15604039598938079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.175.169.59', '2019-06-13 13:32:40', 1, 0, '', '2019-06-13 13:32:40');
INSERT INTO `access_log` VALUES (36001, '64.76.15604039610738081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.175.169.59', '2019-06-13 13:32:41', 2, 0, '', '2019-06-13 13:32:41');
INSERT INTO `access_log` VALUES (36002, '64.84.15604039616718095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.175.169.59', '2019-06-13 13:32:42', 2, 0, '', '2019-06-13 13:32:42');
INSERT INTO `access_log` VALUES (36003, '64.77.15604039623278097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.175.169.59', '2019-06-13 13:32:42', 1, 0, '', '2019-06-13 13:32:42');
INSERT INTO `access_log` VALUES (36004, '64.80.15604039627038089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.175.169.59', '2019-06-13 13:32:43', 2, 0, '', '2019-06-13 13:32:43');
INSERT INTO `access_log` VALUES (36005, '59.78.15604039646678165', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.175.169.59', '2019-06-13 13:32:45', 3, 0, '', '2019-06-13 13:32:45');
INSERT INTO `access_log` VALUES (36006, '59.80.15604039646668153', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.175.169.59', '2019-06-13 13:32:45', 13, 2001001000, '服务端发生异常', '2019-06-13 13:32:45');
INSERT INTO `access_log` VALUES (36007, '65.3607.15604043447930461', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-13 13:39:05', 0, 1002001015, '账号未登陆', '2019-06-13 13:39:05');
INSERT INTO `access_log` VALUES (36008, '65.52.15604043447948707', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-13 13:39:05', 0, 1002001015, '账号未登陆', '2019-06-13 13:39:05');
INSERT INTO `access_log` VALUES (36009, '65.53.15604043448188679', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-13 13:39:05', 0, 1002001015, '账号未登陆', '2019-06-13 13:39:05');
INSERT INTO `access_log` VALUES (36010, '65.51.15604043548548713', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-13 13:39:15', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 13:39:15');
INSERT INTO `access_log` VALUES (36011, '65.46.15604043674148697', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-13 13:39:27', 124, 0, '', '2019-06-13 13:39:28');
INSERT INTO `access_log` VALUES (36012, '65.50.15604043677498709', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-13 13:39:28', 102, 0, '', '2019-06-13 13:39:28');
INSERT INTO `access_log` VALUES (36013, '65.49.15604043677458713', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-13 13:39:28', 106, 2001001000, '服务端发生异常', '2019-06-13 13:39:28');
INSERT INTO `access_log` VALUES (36014, '65.45.15604043677428705', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-13 13:39:28', 110, 0, '', '2019-06-13 13:39:28');
INSERT INTO `access_log` VALUES (36015, '65.46.15604046161768701', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.79', '2019-06-13 13:43:36', 4, 1002001012, '访问令牌已过期', '2019-06-13 13:43:36');
INSERT INTO `access_log` VALUES (36016, '65.54.15604046161758669', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.79', '2019-06-13 13:43:36', 4, 1002001012, '访问令牌已过期', '2019-06-13 13:43:36');
INSERT INTO `access_log` VALUES (36017, '65.50.15604046161768713', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.79', '2019-06-13 13:43:36', 3, 1002001012, '访问令牌已过期', '2019-06-13 13:43:36');
INSERT INTO `access_log` VALUES (36018, '65.52.15604046222388713', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.79', '2019-06-13 13:43:42', 88, 0, '', '2019-06-13 13:43:42');
INSERT INTO `access_log` VALUES (36019, '65.45.15604046225818709', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.79', '2019-06-13 13:43:43', 10, 0, '', '2019-06-13 13:43:43');
INSERT INTO `access_log` VALUES (36020, '65.53.15604046225898685', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.79', '2019-06-13 13:43:43', 17, 0, '', '2019-06-13 13:43:43');
INSERT INTO `access_log` VALUES (36021, '65.47.15604046225898689', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.79', '2019-06-13 13:43:43', 17, 2001001000, '服务端发生异常', '2019-06-13 13:43:43');
INSERT INTO `access_log` VALUES (36022, '65.53.15604051806988693', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.60.210', '2019-06-13 13:53:01', 0, 1002001015, '账号未登陆', '2019-06-13 13:53:01');
INSERT INTO `access_log` VALUES (36023, '65.47.15604051806998697', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.60.210', '2019-06-13 13:53:01', 1, 1002001015, '账号未登陆', '2019-06-13 13:53:01');
INSERT INTO `access_log` VALUES (36024, '65.45.15604051806978717', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.60.210', '2019-06-13 13:53:01', 0, 1002001015, '账号未登陆', '2019-06-13 13:53:01');
INSERT INTO `access_log` VALUES (36025, '65.51.15604051928398727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=youdaoyuanma &password=youdaoyuanma &type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.60.210', '2019-06-13 13:53:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号格式为数字以及字母', '2019-06-13 13:53:13');
INSERT INTO `access_log` VALUES (36026, '65.54.15604052165658679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.60.210', '2019-06-13 13:53:37', 188, 0, '', '2019-06-13 13:53:37');
INSERT INTO `access_log` VALUES (36027, '65.50.15604052169768723', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.60.210', '2019-06-13 13:53:37', 10, 0, '', '2019-06-13 13:53:37');
INSERT INTO `access_log` VALUES (36028, '65.52.15604052169798723', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.60.210', '2019-06-13 13:53:37', 10, 0, '', '2019-06-13 13:53:37');
INSERT INTO `access_log` VALUES (36029, '65.49.15604052169788727', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.60.210', '2019-06-13 13:53:37', 11, 2001001000, '服务端发生异常', '2019-06-13 13:53:37');
INSERT INTO `access_log` VALUES (36030, '65.51.15604052399828729', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.60.210', '2019-06-13 13:54:00', 9, 0, '', '2019-06-13 13:54:00');
INSERT INTO `access_log` VALUES (36031, '65.53.15604052399818695', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.60.210', '2019-06-13 13:54:00', 10, 0, '', '2019-06-13 13:54:00');
INSERT INTO `access_log` VALUES (36032, '65.3607.15604052399810479', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.60.210', '2019-06-13 13:54:00', 11, 2001001000, '服务端发生异常', '2019-06-13 13:54:00');
INSERT INTO `access_log` VALUES (36033, '65.46.15604052435708713', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.60.210', '2019-06-13 13:54:04', 7, 0, '', '2019-06-13 13:54:04');
INSERT INTO `access_log` VALUES (36034, '65.49.15604052436018729', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.60.210', '2019-06-13 13:54:04', 8, 0, '', '2019-06-13 13:54:04');
INSERT INTO `access_log` VALUES (36035, '65.54.15604052436018681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.205.60.210', '2019-06-13 13:54:04', 9, 2001001000, '服务端发生异常', '2019-06-13 13:54:04');
INSERT INTO `access_log` VALUES (36036, '59.80.15604053011498171', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.39.151.96', '2019-06-13 13:55:01', 4, 0, '', '2019-06-13 13:55:01');
INSERT INTO `access_log` VALUES (36037, '59.79.15604053011498189', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.39.151.96', '2019-06-13 13:55:01', 12, 2001001000, '服务端发生异常', '2019-06-13 13:55:01');
INSERT INTO `access_log` VALUES (36038, '64.82.15604053484938119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.39.151.96', '2019-06-13 13:55:48', 3, 0, '', '2019-06-13 13:55:48');
INSERT INTO `access_log` VALUES (36039, '64.81.15604053485878109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.39.151.96', '2019-06-13 13:55:49', 1, 0, '', '2019-06-13 13:55:49');
INSERT INTO `access_log` VALUES (36040, '64.78.15604053496758115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.39.151.96', '2019-06-13 13:55:50', 2, 0, '', '2019-06-13 13:55:50');
INSERT INTO `access_log` VALUES (36041, '64.83.15604053503158099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.39.151.96', '2019-06-13 13:55:50', 2, 0, '', '2019-06-13 13:55:50');
INSERT INTO `access_log` VALUES (36042, '64.84.15604053511078115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.39.151.96', '2019-06-13 13:55:51', 2, 0, '', '2019-06-13 13:55:51');
INSERT INTO `access_log` VALUES (36043, '64.77.15604053516068117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.39.151.96', '2019-06-13 13:55:52', 2, 0, '', '2019-06-13 13:55:52');
INSERT INTO `access_log` VALUES (36044, '59.71.15604053560288187', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.39.151.96', '2019-06-13 13:55:56', 2, 0, '', '2019-06-13 13:55:56');
INSERT INTO `access_log` VALUES (36045, '59.74.15604053560288181', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.39.151.96', '2019-06-13 13:55:56', 11, 2001001000, '服务端发生异常', '2019-06-13 13:55:56');
INSERT INTO `access_log` VALUES (36046, '59.76.15604053638018179', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.39.151.96', '2019-06-13 13:56:04', 3, 0, '', '2019-06-13 13:56:04');
INSERT INTO `access_log` VALUES (36047, '59.78.15604053638038185', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.39.151.96', '2019-06-13 13:56:04', 20, 2001001000, '服务端发生异常', '2019-06-13 13:56:04');
INSERT INTO `access_log` VALUES (36048, '65.54.15604059563328691', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:05:56', 0, 1002001015, '账号未登陆', '2019-06-13 14:05:56');
INSERT INTO `access_log` VALUES (36049, '65.49.15604059563378739', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:05:56', 1, 1002001015, '账号未登陆', '2019-06-13 14:05:56');
INSERT INTO `access_log` VALUES (36050, '65.50.15604059563418735', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:05:56', 1, 1002001015, '账号未登陆', '2019-06-13 14:05:56');
INSERT INTO `access_log` VALUES (36051, '65.52.15604059586898735', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:05:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 14:05:59');
INSERT INTO `access_log` VALUES (36052, '65.52.15604060912748737', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:08:11', 81, 0, '', '2019-06-13 14:08:11');
INSERT INTO `access_log` VALUES (36053, '65.47.15604060915978713', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:08:12', 10, 0, '', '2019-06-13 14:08:12');
INSERT INTO `access_log` VALUES (36054, '65.45.15604060916018733', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:08:12', 10, 2001001000, '服务端发生异常', '2019-06-13 14:08:12');
INSERT INTO `access_log` VALUES (36055, '65.53.15604060916218709', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:08:12', 10, 0, '', '2019-06-13 14:08:12');
INSERT INTO `access_log` VALUES (36056, '65.51.15604061003808743', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:08:20', 9, 0, '', '2019-06-13 14:08:20');
INSERT INTO `access_log` VALUES (36057, '65.3607.15604061003850493', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:08:20', 10, 2001001000, '服务端发生异常', '2019-06-13 14:08:20');
INSERT INTO `access_log` VALUES (36058, '65.46.15604061003918727', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:08:20', 9, 0, '', '2019-06-13 14:08:20');
INSERT INTO `access_log` VALUES (36059, '65.50.15604061300928739', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:08:50', 10, 0, '', '2019-06-13 14:08:50');
INSERT INTO `access_log` VALUES (36060, '65.52.15604061300958739', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:08:50', 10, 2001001000, '服务端发生异常', '2019-06-13 14:08:50');
INSERT INTO `access_log` VALUES (36061, '65.45.15604061300978735', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:08:50', 9, 0, '', '2019-06-13 14:08:50');
INSERT INTO `access_log` VALUES (36062, '65.46.15604061681848729', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:09:28', 9, 0, '', '2019-06-13 14:09:28');
INSERT INTO `access_log` VALUES (36063, '65.3607.15604061681840495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:09:28', 9, 2001001000, '服务端发生异常', '2019-06-13 14:09:28');
INSERT INTO `access_log` VALUES (36064, '65.54.15604061681898697', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.65.122', '2019-06-13 14:09:28', 9, 0, '', '2019-06-13 14:09:28');
INSERT INTO `access_log` VALUES (36065, '59.78.15604068351018205', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/606.4.5 (KHTML, like Gecko) Version/12.0.3 Safari/606.4.5 Maxthon/5.1.60', '116.22.55.136', '2019-06-13 14:20:35', 3, 0, '', '2019-06-13 14:20:35');
INSERT INTO `access_log` VALUES (36066, '59.80.15604068351018193', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/606.4.5 (KHTML, like Gecko) Version/12.0.3 Safari/606.4.5 Maxthon/5.1.60', '116.22.55.136', '2019-06-13 14:20:35', 16, 2001001000, '服务端发生异常', '2019-06-13 14:20:35');
INSERT INTO `access_log` VALUES (36067, '64.77.15604068420658137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/606.4.5 (KHTML, like Gecko) Version/12.0.3 Safari/606.4.5 Maxthon/5.1.60', '116.22.55.136', '2019-06-13 14:20:42', 2, 0, '', '2019-06-13 14:20:42');
INSERT INTO `access_log` VALUES (36068, '64.80.15604068422088129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/606.4.5 (KHTML, like Gecko) Version/12.0.3 Safari/606.4.5 Maxthon/5.1.60', '116.22.55.136', '2019-06-13 14:20:42', 2, 0, '', '2019-06-13 14:20:42');
INSERT INTO `access_log` VALUES (36069, '64.85.15604068431488147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/606.4.5 (KHTML, like Gecko) Version/12.0.3 Safari/606.4.5 Maxthon/5.1.60', '116.22.55.136', '2019-06-13 14:20:43', 2, 0, '', '2019-06-13 14:20:43');
INSERT INTO `access_log` VALUES (36070, '64.79.15604068436128125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/606.4.5 (KHTML, like Gecko) Version/12.0.3 Safari/606.4.5 Maxthon/5.1.60', '116.22.55.136', '2019-06-13 14:20:44', 2, 0, '', '2019-06-13 14:20:44');
INSERT INTO `access_log` VALUES (36071, '64.82.15604068471848141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/606.4.5 (KHTML, like Gecko) Version/12.0.3 Safari/606.4.5 Maxthon/5.1.60', '116.22.55.136', '2019-06-13 14:20:47', 2, 0, '', '2019-06-13 14:20:47');
INSERT INTO `access_log` VALUES (36072, '64.81.15604068473218131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/606.4.5 (KHTML, like Gecko) Version/12.0.3 Safari/606.4.5 Maxthon/5.1.60', '116.22.55.136', '2019-06-13 14:20:47', 1, 0, '', '2019-06-13 14:20:47');
INSERT INTO `access_log` VALUES (36073, '59.73.15604068642008207', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/606.4.5 (KHTML, like Gecko) Version/12.0.3 Safari/606.4.5 Maxthon/5.1.60', '116.22.55.136', '2019-06-13 14:21:04', 3, 0, '', '2019-06-13 14:21:04');
INSERT INTO `access_log` VALUES (36074, '59.75.15604068642018209', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/606.4.5 (KHTML, like Gecko) Version/12.0.3 Safari/606.4.5 Maxthon/5.1.60', '116.22.55.136', '2019-06-13 14:21:04', 14, 2001001000, '服务端发生异常', '2019-06-13 14:21:04');
INSERT INTO `access_log` VALUES (36075, '64.76.15604068663318123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/606.4.5 (KHTML, like Gecko) Version/12.0.3 Safari/606.4.5 Maxthon/5.1.60', '116.22.55.136', '2019-06-13 14:21:06', 2, 0, '', '2019-06-13 14:21:06');
INSERT INTO `access_log` VALUES (36076, '64.84.15604068664548137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/606.4.5 (KHTML, like Gecko) Version/12.0.3 Safari/606.4.5 Maxthon/5.1.60', '116.22.55.136', '2019-06-13 14:21:06', 2, 0, '', '2019-06-13 14:21:06');
INSERT INTO `access_log` VALUES (36077, '65.45.15604069324938747', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '112.10.228.183', '2019-06-13 14:22:12', 0, 1002001015, '账号未登陆', '2019-06-13 14:22:12');
INSERT INTO `access_log` VALUES (36078, '65.50.15604069324938751', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '112.10.228.183', '2019-06-13 14:22:12', 0, 1002001015, '账号未登陆', '2019-06-13 14:22:12');
INSERT INTO `access_log` VALUES (36079, '65.52.15604069324958751', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '112.10.228.183', '2019-06-13 14:22:12', 0, 1002001015, '账号未登陆', '2019-06-13 14:22:12');
INSERT INTO `access_log` VALUES (36080, '65.47.15604069351598727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '112.10.228.183', '2019-06-13 14:22:15', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 14:22:15');
INSERT INTO `access_log` VALUES (36081, '65.53.15604069396208723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '112.10.228.183', '2019-06-13 14:22:20', 68, 0, '', '2019-06-13 14:22:20');
INSERT INTO `access_log` VALUES (36082, '65.51.15604069399688757', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '112.10.228.183', '2019-06-13 14:22:20', 10, 0, '', '2019-06-13 14:22:20');
INSERT INTO `access_log` VALUES (36083, '65.46.15604069399698741', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '112.10.228.183', '2019-06-13 14:22:20', 11, 2001001000, '服务端发生异常', '2019-06-13 14:22:20');
INSERT INTO `access_log` VALUES (36084, '65.3607.15604069400750507', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '112.10.228.183', '2019-06-13 14:22:20', 8, 0, '', '2019-06-13 14:22:20');
INSERT INTO `access_log` VALUES (36085, '59.79.15604069488828213', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.24', '2019-06-13 14:22:29', 3, 0, '', '2019-06-13 14:22:29');
INSERT INTO `access_log` VALUES (36086, '59.78.15604069488828207', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.24', '2019-06-13 14:22:29', 26, 2001001000, '服务端发生异常', '2019-06-13 14:22:29');
INSERT INTO `access_log` VALUES (36087, '65.54.15604072328718713', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.179.143', '2019-06-13 14:27:13', 1, 1002001015, '账号未登陆', '2019-06-13 14:27:13');
INSERT INTO `access_log` VALUES (36088, '65.49.15604072328778761', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.179.143', '2019-06-13 14:27:13', 0, 1002001015, '账号未登陆', '2019-06-13 14:27:13');
INSERT INTO `access_log` VALUES (36089, '65.45.15604072328798753', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.179.143', '2019-06-13 14:27:13', 8, 1002001015, '账号未登陆', '2019-06-13 14:27:13');
INSERT INTO `access_log` VALUES (36090, '59.79.15604072343888217', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.179.143', '2019-06-13 14:27:14', 4, 0, '', '2019-06-13 14:27:14');
INSERT INTO `access_log` VALUES (36091, '59.77.15604072343948201', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.179.143', '2019-06-13 14:27:14', 23, 2001001000, '服务端发生异常', '2019-06-13 14:27:14');
INSERT INTO `access_log` VALUES (36092, '65.52.15604072367338757', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.179.143', '2019-06-13 14:27:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 14:27:17');
INSERT INTO `access_log` VALUES (36093, '65.47.15604072507568733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.179.143', '2019-06-13 14:27:31', 95, 0, '', '2019-06-13 14:27:31');
INSERT INTO `access_log` VALUES (36094, '65.53.15604072511018729', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.179.143', '2019-06-13 14:27:31', 9, 0, '', '2019-06-13 14:27:31');
INSERT INTO `access_log` VALUES (36095, '65.46.15604072511038747', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.179.143', '2019-06-13 14:27:31', 10, 2001001000, '服务端发生异常', '2019-06-13 14:27:31');
INSERT INTO `access_log` VALUES (36096, '65.51.15604072511088763', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.179.143', '2019-06-13 14:27:31', 9, 0, '', '2019-06-13 14:27:31');
INSERT INTO `access_log` VALUES (36097, '64.83.15604072722608127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.179.143', '2019-06-13 14:27:52', 2, 0, '', '2019-06-13 14:27:52');
INSERT INTO `access_log` VALUES (36098, '64.76.15604072723708129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.179.143', '2019-06-13 14:27:52', 1, 0, '', '2019-06-13 14:27:52');
INSERT INTO `access_log` VALUES (36099, '64.84.15604072737678143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '125.86.179.143', '2019-06-13 14:27:54', 2, 0, '', '2019-06-13 14:27:54');
INSERT INTO `access_log` VALUES (36100, '59.72.15604089109628235', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:11', 3, 0, '', '2019-06-13 14:55:11');
INSERT INTO `access_log` VALUES (36101, '59.71.15604089109628237', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:11', 22, 2001001000, '服务端发生异常', '2019-06-13 14:55:11');
INSERT INTO `access_log` VALUES (36102, '64.84.15604089175458165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:18', 3, 0, '', '2019-06-13 14:55:18');
INSERT INTO `access_log` VALUES (36103, '64.77.15604089176418167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:18', 1, 0, '', '2019-06-13 14:55:18');
INSERT INTO `access_log` VALUES (36104, '64.80.15604089201268159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:20', 2, 0, '', '2019-06-13 14:55:20');
INSERT INTO `access_log` VALUES (36105, '64.79.15604089209318155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:21', 1, 0, '', '2019-06-13 14:55:21');
INSERT INTO `access_log` VALUES (36106, '64.82.15604089216268171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:22', 2, 0, '', '2019-06-13 14:55:22');
INSERT INTO `access_log` VALUES (36107, '64.81.15604089342768161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:34', 2, 0, '', '2019-06-13 14:55:34');
INSERT INTO `access_log` VALUES (36108, '64.78.15604089348578167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:35', 2, 0, '', '2019-06-13 14:55:35');
INSERT INTO `access_log` VALUES (36109, '59.80.15604089367118223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:37', 2, 0, '', '2019-06-13 14:55:37');
INSERT INTO `access_log` VALUES (36110, '59.78.15604089367128235', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:37', 19, 2001001000, '服务端发生异常', '2019-06-13 14:55:37');
INSERT INTO `access_log` VALUES (36111, '59.79.15604089489408241', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:49', 3, 0, '', '2019-06-13 14:55:49');
INSERT INTO `access_log` VALUES (36112, '59.77.15604089489408225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:49', 14, 2001001000, '服务端发生异常', '2019-06-13 14:55:49');
INSERT INTO `access_log` VALUES (36113, '64.84.15604089514468167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:51', 2, 0, '', '2019-06-13 14:55:51');
INSERT INTO `access_log` VALUES (36114, '64.77.15604089515248169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:52', 1, 0, '', '2019-06-13 14:55:52');
INSERT INTO `access_log` VALUES (36115, '59.75.15604089521628239', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:52', 2, 0, '', '2019-06-13 14:55:52');
INSERT INTO `access_log` VALUES (36116, '59.72.15604089521628237', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '218.94.83.140', '2019-06-13 14:55:52', 13, 2001001000, '服务端发生异常', '2019-06-13 14:55:52');
INSERT INTO `access_log` VALUES (36117, '59.78.15604091457078239', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 14:59:06', 3, 0, '', '2019-06-13 14:59:06');
INSERT INTO `access_log` VALUES (36118, '59.80.15604091457088227', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 14:59:06', 13, 2001001000, '服务端发生异常', '2019-06-13 14:59:06');
INSERT INTO `access_log` VALUES (36119, '64.82.15604091521968175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 14:59:12', 2, 0, '', '2019-06-13 14:59:12');
INSERT INTO `access_log` VALUES (36120, '64.81.15604091533478165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 14:59:13', 2, 0, '', '2019-06-13 14:59:13');
INSERT INTO `access_log` VALUES (36121, '64.78.15604091548258171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 14:59:15', 2, 0, '', '2019-06-13 14:59:15');
INSERT INTO `access_log` VALUES (36122, '64.83.15604091556158155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 14:59:16', 2, 0, '', '2019-06-13 14:59:16');
INSERT INTO `access_log` VALUES (36123, '66.55.15604091627686645', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 14:59:23', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-13 14:59:23');
INSERT INTO `access_log` VALUES (36124, '64.77.15604091883958173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 14:59:48', 25, 0, '', '2019-06-13 14:59:48');
INSERT INTO `access_log` VALUES (36125, '64.80.15604091895518165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 14:59:50', 2, 0, '', '2019-06-13 14:59:50');
INSERT INTO `access_log` VALUES (36126, '64.79.15604091919468161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 14:59:52', 2, 0, '', '2019-06-13 14:59:52');
INSERT INTO `access_log` VALUES (36127, '64.82.15604091921088177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 14:59:52', 1, 0, '', '2019-06-13 14:59:52');
INSERT INTO `access_log` VALUES (36128, '59.72.15604091963628241', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 14:59:56', 2, 0, '', '2019-06-13 14:59:56');
INSERT INTO `access_log` VALUES (36129, '59.75.15604091963568243', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 14:59:56', 13, 2001001000, '服务端发生异常', '2019-06-13 14:59:56');
INSERT INTO `access_log` VALUES (36130, '64.81.15604091989608167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 14:59:59', 2, 0, '', '2019-06-13 14:59:59');
INSERT INTO `access_log` VALUES (36131, '64.78.15604092003378173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:00', 2, 0, '', '2019-06-13 15:00:00');
INSERT INTO `access_log` VALUES (36132, '59.71.15604092017078243', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:02', 3, 0, '', '2019-06-13 15:00:02');
INSERT INTO `access_log` VALUES (36133, '59.74.15604092017088237', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:02', 13, 2001001000, '服务端发生异常', '2019-06-13 15:00:02');
INSERT INTO `access_log` VALUES (36134, '64.83.15604092041768157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:04', 2, 0, '', '2019-06-13 15:00:04');
INSERT INTO `access_log` VALUES (36135, '64.76.15604092043768159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:04', 2, 0, '', '2019-06-13 15:00:04');
INSERT INTO `access_log` VALUES (36136, '59.80.15604092058488229', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:06', 2, 0, '', '2019-06-13 15:00:06');
INSERT INTO `access_log` VALUES (36137, '59.78.15604092058488241', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:06', 12, 2001001000, '服务端发生异常', '2019-06-13 15:00:06');
INSERT INTO `access_log` VALUES (36138, '64.77.15604092098418175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:10', 2, 0, '', '2019-06-13 15:00:10');
INSERT INTO `access_log` VALUES (36139, '64.80.15604092099388167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:10', 1, 0, '', '2019-06-13 15:00:10');
INSERT INTO `access_log` VALUES (36140, '59.79.15604092206258247', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:00:21', 3, 0, '', '2019-06-13 15:00:21');
INSERT INTO `access_log` VALUES (36141, '59.73.15604092206298243', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:00:21', 18, 2001001000, '服务端发生异常', '2019-06-13 15:00:21');
INSERT INTO `access_log` VALUES (36142, '65.47.15604092349908761', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:35', 4, 1002001012, '访问令牌已过期', '2019-06-13 15:00:35');
INSERT INTO `access_log` VALUES (36143, '65.53.15604092349908757', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:35', 4, 1002001012, '访问令牌已过期', '2019-06-13 15:00:35');
INSERT INTO `access_log` VALUES (36144, '65.51.15604092349918791', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:35', 5, 1002001012, '访问令牌已过期', '2019-06-13 15:00:35');
INSERT INTO `access_log` VALUES (36145, '65.46.15604092388208775', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:39', 94, 0, '', '2019-06-13 15:00:39');
INSERT INTO `access_log` VALUES (36146, '65.45.15604092392378781', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:39', 192, 0, '', '2019-06-13 15:00:39');
INSERT INTO `access_log` VALUES (36147, '65.54.15604092392468743', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:39', 184, 0, '', '2019-06-13 15:00:39');
INSERT INTO `access_log` VALUES (36148, '65.49.15604092392438791', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:39', 187, 2001001000, '服务端发生异常', '2019-06-13 15:00:39');
INSERT INTO `access_log` VALUES (36149, '64.82.15604092423138179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.204.236.149', '2019-06-13 15:00:42', 2, 0, '', '2019-06-13 15:00:42');
INSERT INTO `access_log` VALUES (36150, '65.52.15604092469558785', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:47', 9, 0, '', '2019-06-13 15:00:47');
INSERT INTO `access_log` VALUES (36151, '65.50.15604092469608787', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:47', 10, 2001001000, '服务端发生异常', '2019-06-13 15:00:47');
INSERT INTO `access_log` VALUES (36152, '65.47.15604092469668763', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.43.113', '2019-06-13 15:00:47', 8, 0, '', '2019-06-13 15:00:47');
INSERT INTO `access_log` VALUES (36153, '66.50.15604092594146651', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=123&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.204.236.149', '2019-06-13 15:00:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-06-13 15:00:59');
INSERT INTO `access_log` VALUES (36154, '66.51.15604092664526659', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678912&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.204.236.149', '2019-06-13 15:01:06', 17, 1001003000, '验证码不存在', '2019-06-13 15:01:06');
INSERT INTO `access_log` VALUES (36155, '64.83.15604092804198159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.204.236.149', '2019-06-13 15:01:20', 2, 0, '', '2019-06-13 15:01:20');
INSERT INTO `access_log` VALUES (36156, '64.84.15604092805368175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.204.236.149', '2019-06-13 15:01:21', 2, 0, '', '2019-06-13 15:01:21');
INSERT INTO `access_log` VALUES (36157, '64.77.15604092826088177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.204.236.149', '2019-06-13 15:01:23', 1, 0, '', '2019-06-13 15:01:23');
INSERT INTO `access_log` VALUES (36158, '64.80.15604092835938169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.204.236.149', '2019-06-13 15:01:24', 1, 0, '', '2019-06-13 15:01:24');
INSERT INTO `access_log` VALUES (36159, '64.85.15604092845988187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.204.236.149', '2019-06-13 15:01:25', 2, 0, '', '2019-06-13 15:01:25');
INSERT INTO `access_log` VALUES (36160, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.204.236.149', '2019-06-13 15:01:26', 7, 0, '', '2019-06-13 15:01:26');
INSERT INTO `access_log` VALUES (36161, '64.79.15604092864358165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.204.236.149', '2019-06-13 15:01:26', 2, 0, '', '2019-06-13 15:01:26');
INSERT INTO `access_log` VALUES (36162, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.204.236.149', '2019-06-13 15:01:28', 6, 0, '', '2019-06-13 15:01:28');
INSERT INTO `access_log` VALUES (36163, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.204.236.149', '2019-06-13 15:01:29', 6, 0, '', '2019-06-13 15:01:29');
INSERT INTO `access_log` VALUES (36164, '64.82.15604092903198181', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.204.236.149', '2019-06-13 15:01:30', 8, 0, '', '2019-06-13 15:01:30');
INSERT INTO `access_log` VALUES (36165, '64.78.15604093025768177', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.204.236.149', '2019-06-13 15:01:43', 6, 0, '', '2019-06-13 15:01:43');
INSERT INTO `access_log` VALUES (36166, '65.53.15604093289418761', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:02:09', 0, 1002001015, '账号未登陆', '2019-06-13 15:02:09');
INSERT INTO `access_log` VALUES (36167, '65.51.15604093289428793', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:02:09', 1, 1002001015, '账号未登陆', '2019-06-13 15:02:09');
INSERT INTO `access_log` VALUES (36168, '65.3607.15604093289420543', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:02:09', 1, 1002001015, '账号未登陆', '2019-06-13 15:02:09');
INSERT INTO `access_log` VALUES (36169, '65.45.15604093319168785', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:02:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 15:02:12');
INSERT INTO `access_log` VALUES (36170, '65.54.15604093368128745', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:02:17', 166, 0, '', '2019-06-13 15:02:17');
INSERT INTO `access_log` VALUES (36171, '65.49.15604093372458795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:02:17', 10, 0, '', '2019-06-13 15:02:17');
INSERT INTO `access_log` VALUES (36172, '65.50.15604093372538791', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:02:17', 9, 2001001000, '服务端发生异常', '2019-06-13 15:02:17');
INSERT INTO `access_log` VALUES (36173, '65.47.15604093372578767', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:02:17', 9, 0, '', '2019-06-13 15:02:17');
INSERT INTO `access_log` VALUES (36174, '65.51.15604093637858795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:02:44', 9, 0, '', '2019-06-13 15:02:44');
INSERT INTO `access_log` VALUES (36175, '65.53.15604093637868763', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:02:44', 11, 2001001000, '服务端发生异常', '2019-06-13 15:02:44');
INSERT INTO `access_log` VALUES (36176, '65.3607.15604093637900545', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:02:44', 9, 0, '', '2019-06-13 15:02:44');
INSERT INTO `access_log` VALUES (36177, '59.71.15604101760328257', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:16:16', 3, 0, '', '2019-06-13 15:16:16');
INSERT INTO `access_log` VALUES (36178, '59.76.15604101760348249', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:16:16', 23, 2001001000, '服务端发生异常', '2019-06-13 15:16:16');
INSERT INTO `access_log` VALUES (36179, '64.81.15604101801348183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:16:20', 3, 0, '', '2019-06-13 15:16:20');
INSERT INTO `access_log` VALUES (36180, '64.78.15604101802528189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:16:20', 2, 0, '', '2019-06-13 15:16:20');
INSERT INTO `access_log` VALUES (36181, '64.76.15604101815208175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:16:22', 2, 0, '', '2019-06-13 15:16:22');
INSERT INTO `access_log` VALUES (36182, '64.84.15604101821308189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:16:22', 2, 0, '', '2019-06-13 15:16:22');
INSERT INTO `access_log` VALUES (36183, '65.53.15604102380728775', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:17:18', 0, 1002001015, '账号未登陆', '2019-06-13 15:17:18');
INSERT INTO `access_log` VALUES (36184, '65.3607.15604102380770557', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:17:18', 0, 1002001015, '账号未登陆', '2019-06-13 15:17:18');
INSERT INTO `access_log` VALUES (36185, '65.45.15604102380918799', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:17:18', 0, 1002001015, '账号未登陆', '2019-06-13 15:17:18');
INSERT INTO `access_log` VALUES (36186, '65.47.15604102452578781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:17:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 15:17:25');
INSERT INTO `access_log` VALUES (36187, '65.49.15604102510278809', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:17:31', 69, 0, '', '2019-06-13 15:17:31');
INSERT INTO `access_log` VALUES (36188, '65.50.15604102513058805', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:17:31', 11, 0, '', '2019-06-13 15:17:31');
INSERT INTO `access_log` VALUES (36189, '65.52.15604102513088803', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:17:31', 10, 2001001000, '服务端发生异常', '2019-06-13 15:17:31');
INSERT INTO `access_log` VALUES (36190, '65.46.15604102513158793', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:17:31', 9, 0, '', '2019-06-13 15:17:31');
INSERT INTO `access_log` VALUES (36191, '65.53.15604102597508777', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:17:40', 10, 0, '', '2019-06-13 15:17:40');
INSERT INTO `access_log` VALUES (36192, '65.3607.15604102597550559', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:17:40', 9, 2001001000, '服务端发生异常', '2019-06-13 15:17:40');
INSERT INTO `access_log` VALUES (36193, '65.45.15604102597628801', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '125.120.81.221', '2019-06-13 15:17:40', 8, 0, '', '2019-06-13 15:17:40');
INSERT INTO `access_log` VALUES (36194, '65.54.15604102652698761', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:17:45', 9, 0, '', '2019-06-13 15:17:45');
INSERT INTO `access_log` VALUES (36195, '65.47.15604102652748783', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:17:45', 9, 2001001000, '服务端发生异常', '2019-06-13 15:17:45');
INSERT INTO `access_log` VALUES (36196, '65.49.15604102652838811', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-13 15:17:45', 9, 0, '', '2019-06-13 15:17:45');
INSERT INTO `access_log` VALUES (36197, '59.77.15604106410388251', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.168.49.246', '2019-06-13 15:24:01', 3, 0, '', '2019-06-13 15:24:01');
INSERT INTO `access_log` VALUES (36198, '59.78.15604106410388261', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.168.49.246', '2019-06-13 15:24:01', 10, 2001001000, '服务端发生异常', '2019-06-13 15:24:01');
INSERT INTO `access_log` VALUES (36199, '64.80.15604106483758189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.168.49.246', '2019-06-13 15:24:08', 2, 0, '', '2019-06-13 15:24:08');
INSERT INTO `access_log` VALUES (36200, '64.85.15604106484888207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.168.49.246', '2019-06-13 15:24:08', 2, 0, '', '2019-06-13 15:24:08');
INSERT INTO `access_log` VALUES (36201, '64.79.15604106601378185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.168.49.246', '2019-06-13 15:24:20', 2, 0, '', '2019-06-13 15:24:20');
INSERT INTO `access_log` VALUES (36202, '64.81.15604106607768191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.168.49.246', '2019-06-13 15:24:21', 1, 0, '', '2019-06-13 15:24:21');
INSERT INTO `access_log` VALUES (36203, '59.72.15604106617238263', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.168.49.246', '2019-06-13 15:24:22', 3, 0, '', '2019-06-13 15:24:22');
INSERT INTO `access_log` VALUES (36204, '59.75.15604106617238265', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.168.49.246', '2019-06-13 15:24:22', 10, 2001001000, '服务端发生异常', '2019-06-13 15:24:22');
INSERT INTO `access_log` VALUES (36205, '59.76.15604108491588259', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.159.198.136', '2019-06-13 15:27:29', 3, 0, '', '2019-06-13 15:27:29');
INSERT INTO `access_log` VALUES (36206, '59.80.15604108491588253', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.159.198.136', '2019-06-13 15:27:29', 14, 2001001000, '服务端发生异常', '2019-06-13 15:27:29');
INSERT INTO `access_log` VALUES (36207, '64.76.15604108554718185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.159.198.136', '2019-06-13 15:27:35', 3, 0, '', '2019-06-13 15:27:35');
INSERT INTO `access_log` VALUES (36208, '64.77.15604108555808201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.159.198.136', '2019-06-13 15:27:36', 2, 0, '', '2019-06-13 15:27:36');
INSERT INTO `access_log` VALUES (36209, '59.79.15604108696748271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.159.198.136', '2019-06-13 15:27:50', 3, 0, '', '2019-06-13 15:27:50');
INSERT INTO `access_log` VALUES (36210, '59.73.15604108696748267', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.159.198.136', '2019-06-13 15:27:50', 13, 2001001000, '服务端发生异常', '2019-06-13 15:27:50');
INSERT INTO `access_log` VALUES (36211, '64.85.15604111790308215', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-13 15:32:59', 12, 1002001012, '访问令牌已过期', '2019-06-13 15:32:59');
INSERT INTO `access_log` VALUES (36212, '64.79.15604111790748193', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36 OPR/58.0.3135.65 (Edition 360-1)', '202.100.231.235', '2019-06-13 15:32:59', 5, 1002001012, '访问令牌已过期', '2019-06-13 15:32:59');
INSERT INTO `access_log` VALUES (36213, '65.54.15604114535818777', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-13 15:37:34', 1, 1002001015, '账号未登陆', '2019-06-13 15:37:34');
INSERT INTO `access_log` VALUES (36214, '65.46.15604114535828811', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-13 15:37:34', 0, 1002001015, '账号未登陆', '2019-06-13 15:37:34');
INSERT INTO `access_log` VALUES (36215, '65.50.15604114535918823', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-13 15:37:34', 0, 1002001015, '账号未登陆', '2019-06-13 15:37:34');
INSERT INTO `access_log` VALUES (36216, '65.52.15604114553318821', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-13 15:37:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 15:37:35');
INSERT INTO `access_log` VALUES (36217, '65.45.15604114700448819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-13 15:37:50', 370, 0, '', '2019-06-13 15:37:50');
INSERT INTO `access_log` VALUES (36218, '65.53.15604114707208795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-13 15:37:51', 10, 0, '', '2019-06-13 15:37:51');
INSERT INTO `access_log` VALUES (36219, '65.3607.15604114707270577', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-13 15:37:51', 10, 2001001000, '服务端发生异常', '2019-06-13 15:37:51');
INSERT INTO `access_log` VALUES (36220, '65.49.15604114707318829', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-13 15:37:51', 9, 0, '', '2019-06-13 15:37:51');
INSERT INTO `access_log` VALUES (36221, '59.79.15604129458678299', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '112.64.145.194', '2019-06-13 16:02:26', 20, 2001001000, '服务端发生异常', '2019-06-13 16:02:26');
INSERT INTO `access_log` VALUES (36222, '59.73.15604129458618295', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '112.64.145.194', '2019-06-13 16:02:26', 530, 0, '', '2019-06-13 16:02:26');
INSERT INTO `access_log` VALUES (36223, '64.79.15604129513908217', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '112.64.145.194', '2019-06-13 16:02:31', 13, 0, '', '2019-06-13 16:02:31');
INSERT INTO `access_log` VALUES (36224, '64.85.15604129515958239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '112.64.145.194', '2019-06-13 16:02:32', 5, 0, '', '2019-06-13 16:02:32');
INSERT INTO `access_log` VALUES (36225, '64.82.15604129534628233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '112.64.145.194', '2019-06-13 16:02:33', 3, 0, '', '2019-06-13 16:02:33');
INSERT INTO `access_log` VALUES (36226, '64.81.15604129542568223', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '112.64.145.194', '2019-06-13 16:02:34', 2, 0, '', '2019-06-13 16:02:34');
INSERT INTO `access_log` VALUES (36227, '64.83.15604129609938213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '112.64.145.194', '2019-06-13 16:02:41', 1, 0, '', '2019-06-13 16:02:41');
INSERT INTO `access_log` VALUES (36228, '64.76.15604129611198215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '112.64.145.194', '2019-06-13 16:02:41', 1, 0, '', '2019-06-13 16:02:41');
INSERT INTO `access_log` VALUES (36229, '59.75.15604129615238297', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '112.64.145.194', '2019-06-13 16:02:42', 3, 0, '', '2019-06-13 16:02:42');
INSERT INTO `access_log` VALUES (36230, '59.74.15604129615238291', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '112.64.145.194', '2019-06-13 16:02:42', 13, 2001001000, '服务端发生异常', '2019-06-13 16:02:42');
INSERT INTO `access_log` VALUES (36231, '65.3607.15604130389750601', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.7.67.84', '2019-06-13 16:03:59', 1, 1002001015, '账号未登陆', '2019-06-13 16:03:59');
INSERT INTO `access_log` VALUES (36232, '65.52.15604130389748845', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.7.67.84', '2019-06-13 16:03:59', 1, 1002001015, '账号未登陆', '2019-06-13 16:03:59');
INSERT INTO `access_log` VALUES (36233, '65.51.15604130389968849', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.7.67.84', '2019-06-13 16:03:59', 1, 1002001015, '账号未登陆', '2019-06-13 16:03:59');
INSERT INTO `access_log` VALUES (36234, '65.45.15604130416598843', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.7.67.84', '2019-06-13 16:04:02', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 16:04:02');
INSERT INTO `access_log` VALUES (36235, '65.53.15604130493068817', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.7.67.84', '2019-06-13 16:04:09', 83, 0, '', '2019-06-13 16:04:09');
INSERT INTO `access_log` VALUES (36236, '65.47.15604130499738823', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.7.67.84', '2019-06-13 16:04:10', 10, 0, '', '2019-06-13 16:04:10');
INSERT INTO `access_log` VALUES (36237, '65.50.15604130499748849', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.7.67.84', '2019-06-13 16:04:10', 20, 2001001000, '服务端发生异常', '2019-06-13 16:04:10');
INSERT INTO `access_log` VALUES (36238, '65.46.15604130499788835', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.7.67.84', '2019-06-13 16:04:10', 16, 0, '', '2019-06-13 16:04:10');
INSERT INTO `access_log` VALUES (36239, '59.79.15604147085738323', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.18.22.127', '2019-06-13 16:31:49', 3, 0, '', '2019-06-13 16:31:49');
INSERT INTO `access_log` VALUES (36240, '59.72.15604147086008319', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.18.22.127', '2019-06-13 16:31:49', 21, 2001001000, '服务端发生异常', '2019-06-13 16:31:49');
INSERT INTO `access_log` VALUES (36241, '65.3607.15604147239100625', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.18.22.127', '2019-06-13 16:32:04', 1, 1002001015, '账号未登陆', '2019-06-13 16:32:04');
INSERT INTO `access_log` VALUES (36242, '65.51.15604147239108873', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.18.22.127', '2019-06-13 16:32:04', 1, 1002001015, '账号未登陆', '2019-06-13 16:32:04');
INSERT INTO `access_log` VALUES (36243, '65.52.15604147239118869', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.18.22.127', '2019-06-13 16:32:04', 0, 1002001015, '账号未登陆', '2019-06-13 16:32:04');
INSERT INTO `access_log` VALUES (36244, '65.45.15604147263628867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.18.22.127', '2019-06-13 16:32:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 16:32:06');
INSERT INTO `access_log` VALUES (36245, '65.53.15604147341298841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.18.22.127', '2019-06-13 16:32:14', 92, 0, '', '2019-06-13 16:32:14');
INSERT INTO `access_log` VALUES (36246, '65.47.15604147345638847', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.18.22.127', '2019-06-13 16:32:15', 10, 0, '', '2019-06-13 16:32:15');
INSERT INTO `access_log` VALUES (36247, '65.50.15604147362928873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.18.22.127', '2019-06-13 16:32:16', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 16:32:16');
INSERT INTO `access_log` VALUES (36248, '65.49.15604149773708879', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.200.200.98', '2019-06-13 16:36:17', 0, 1002001015, '账号未登陆', '2019-06-13 16:36:17');
INSERT INTO `access_log` VALUES (36249, '65.53.15604149773748845', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.200.200.98', '2019-06-13 16:36:17', 0, 1002001015, '账号未登陆', '2019-06-13 16:36:17');
INSERT INTO `access_log` VALUES (36250, '65.47.15604149773768851', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.200.200.98', '2019-06-13 16:36:17', 0, 1002001015, '账号未登陆', '2019-06-13 16:36:17');
INSERT INTO `access_log` VALUES (36251, '65.45.15604155035548879', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:45:04', 5, 1002001012, '访问令牌已过期', '2019-06-13 16:45:04');
INSERT INTO `access_log` VALUES (36252, '65.52.15604155035548881', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:45:04', 5, 1002001012, '访问令牌已过期', '2019-06-13 16:45:04');
INSERT INTO `access_log` VALUES (36253, '65.49.15604155035588887', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:45:04', 3, 1002001012, '访问令牌已过期', '2019-06-13 16:45:04');
INSERT INTO `access_log` VALUES (36254, '65.53.15604155051168853', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:45:05', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 16:45:05');
INSERT INTO `access_log` VALUES (36255, '65.46.15604155373208871', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:45:37', 195, 0, '', '2019-06-13 16:45:38');
INSERT INTO `access_log` VALUES (36256, '65.54.15604155377598837', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:45:38', 10, 0, '', '2019-06-13 16:45:38');
INSERT INTO `access_log` VALUES (36257, '65.3607.15604155377620639', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:45:38', 9, 0, '', '2019-06-13 16:45:38');
INSERT INTO `access_log` VALUES (36258, '65.51.15604155377608887', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:45:38', 12, 2001001000, '服务端发生异常', '2019-06-13 16:45:38');
INSERT INTO `access_log` VALUES (36259, '65.45.15604155432188881', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:45:43', 9, 0, '', '2019-06-13 16:45:43');
INSERT INTO `access_log` VALUES (36260, '65.53.15604155432208855', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:45:43', 8, 0, '', '2019-06-13 16:45:43');
INSERT INTO `access_log` VALUES (36261, '65.52.15604155432188883', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:45:43', 11, 2001001000, '服务端发生异常', '2019-06-13 16:45:43');
INSERT INTO `access_log` VALUES (36262, '65.54.15604155960348839', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:46:36', 9, 0, '', '2019-06-13 16:46:36');
INSERT INTO `access_log` VALUES (36263, '65.51.15604155960348889', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:46:36', 8, 0, '', '2019-06-13 16:46:36');
INSERT INTO `access_log` VALUES (36264, '65.3607.15604155960340641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:46:36', 11, 2001001000, '服务端发生异常', '2019-06-13 16:46:36');
INSERT INTO `access_log` VALUES (36265, '65.45.15604156012078883', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:46:41', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 16:46:41');
INSERT INTO `access_log` VALUES (36266, '65.53.15604156104308857', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:46:50', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 16:46:50');
INSERT INTO `access_log` VALUES (36267, '65.47.15604156146158863', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:46:55', 5, 1002002001, '密码不正确', '2019-06-13 16:46:55');
INSERT INTO `access_log` VALUES (36268, '65.50.15604156286358889', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:47:09', 166, 0, '', '2019-06-13 16:47:09');
INSERT INTO `access_log` VALUES (36269, '65.54.15604156289828841', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:47:09', 18, 0, '', '2019-06-13 16:47:09');
INSERT INTO `access_log` VALUES (36270, '65.51.15604156289828891', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:47:09', 17, 0, '', '2019-06-13 16:47:09');
INSERT INTO `access_log` VALUES (36271, '65.3607.15604156289830643', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:47:09', 18, 0, '', '2019-06-13 16:47:09');
INSERT INTO `access_log` VALUES (36272, '64.76.15604156371918251', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:47:17', 14, 0, '', '2019-06-13 16:47:17');
INSERT INTO `access_log` VALUES (36273, '64.83.15604156371828249', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:47:17', 25, 0, '', '2019-06-13 16:47:17');
INSERT INTO `access_log` VALUES (36274, '65.54.15604157355378843', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:48:56', 4, 0, '', '2019-06-13 16:48:56');
INSERT INTO `access_log` VALUES (36275, '65.49.15604159268928897', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-13 16:52:07', 4, 0, '', '2019-06-13 16:52:07');
INSERT INTO `access_log` VALUES (36276, '59.73.15604170373828351', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:10:37', 11, 0, '', '2019-06-13 17:10:37');
INSERT INTO `access_log` VALUES (36277, '59.77.15604170373798339', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:10:37', 15, 2001001000, '服务端发生异常', '2019-06-13 17:10:37');
INSERT INTO `access_log` VALUES (36278, '64.85.15604170399478295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:10:40', 6, 0, '', '2019-06-13 17:10:40');
INSERT INTO `access_log` VALUES (36279, '64.82.15604170400508289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:10:40', 2, 0, '', '2019-06-13 17:10:40');
INSERT INTO `access_log` VALUES (36280, '64.81.15604170415748279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:10:42', 2, 0, '', '2019-06-13 17:10:42');
INSERT INTO `access_log` VALUES (36281, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:10:42', 7, 0, '', '2019-06-13 17:10:42');
INSERT INTO `access_log` VALUES (36282, '64.78.15604170433328285', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:10:43', 8, 0, '', '2019-06-13 17:10:43');
INSERT INTO `access_log` VALUES (36283, '66.51.15604170516286763', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:10:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空', '2019-06-13 17:10:52');
INSERT INTO `access_log` VALUES (36284, '66.55.15604170558476751', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:10:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机号不能为空\n手机验证码长度为 4-6 位\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字', '2019-06-13 17:10:56');
INSERT INTO `access_log` VALUES (36285, '64.76.15604170620548271', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:11:02', 6, 0, '', '2019-06-13 17:11:02');
INSERT INTO `access_log` VALUES (36286, '64.84.15604170636618285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:11:04', 2, 0, '', '2019-06-13 17:11:04');
INSERT INTO `access_log` VALUES (36287, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:11:04', 6, 0, '', '2019-06-13 17:11:04');
INSERT INTO `access_log` VALUES (36288, '64.77.15604170651668287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:11:05', 2, 0, '', '2019-06-13 17:11:05');
INSERT INTO `access_log` VALUES (36289, '64.80.15604170653308279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:11:05', 2, 0, '', '2019-06-13 17:11:05');
INSERT INTO `access_log` VALUES (36290, '64.85.15604170661258297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:11:06', 1, 0, '', '2019-06-13 17:11:06');
INSERT INTO `access_log` VALUES (36291, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:11:06', 4, 0, '', '2019-06-13 17:11:06');
INSERT INTO `access_log` VALUES (36292, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 xiaomiquan/4.2.0', '124.90.46.82', '2019-06-13 17:11:08', 6, 0, '', '2019-06-13 17:11:08');
INSERT INTO `access_log` VALUES (36293, '65.51.15604174393178919', 0, 2, 'admin-application', '/admin-api/admins/admin/delete', 'id=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.236.53.211', '2019-06-13 17:17:19', 0, 1002001015, '账号未登陆', '2019-06-13 17:17:19');
INSERT INTO `access_log` VALUES (36294, '65.52.15604174603918911', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-13 17:17:40', 3, 1002001012, '访问令牌已过期', '2019-06-13 17:17:40');
INSERT INTO `access_log` VALUES (36295, '65.53.15604174603918885', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-13 17:17:40', 4, 1002001012, '访问令牌已过期', '2019-06-13 17:17:40');
INSERT INTO `access_log` VALUES (36296, '65.50.15604174603958917', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-13 17:17:40', 18, 1002001012, '访问令牌已过期', '2019-06-13 17:17:40');
INSERT INTO `access_log` VALUES (36297, '65.49.15604195027518947', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '211.138.20.170', '2019-06-13 17:51:43', 0, 1002001015, '账号未登陆', '2019-06-13 17:51:43');
INSERT INTO `access_log` VALUES (36298, '65.53.15604195027518913', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '211.138.20.170', '2019-06-13 17:51:43', 0, 1002001015, '账号未登陆', '2019-06-13 17:51:43');
INSERT INTO `access_log` VALUES (36299, '65.50.15604195027538945', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '211.138.20.170', '2019-06-13 17:51:43', 0, 1002001015, '账号未登陆', '2019-06-13 17:51:43');
INSERT INTO `access_log` VALUES (36300, '65.52.15604195066118939', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '211.138.20.170', '2019-06-13 17:51:47', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 17:51:47');
INSERT INTO `access_log` VALUES (36301, '65.46.15604195111908933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '211.138.20.170', '2019-06-13 17:51:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 17:51:51');
INSERT INTO `access_log` VALUES (36302, '65.3607.15604195144940699', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '211.138.20.170', '2019-06-13 17:51:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 17:51:55');
INSERT INTO `access_log` VALUES (36303, '65.45.15604200062218947', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.213.168', '2019-06-13 18:00:06', 0, 1002001015, '账号未登陆', '2019-06-13 18:00:06');
INSERT INTO `access_log` VALUES (36304, '65.49.15604200062228955', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.213.168', '2019-06-13 18:00:06', 0, 1002001015, '账号未登陆', '2019-06-13 18:00:06');
INSERT INTO `access_log` VALUES (36305, '65.52.15604200062288947', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.213.168', '2019-06-13 18:00:06', 0, 1002001015, '账号未登陆', '2019-06-13 18:00:06');
INSERT INTO `access_log` VALUES (36306, '65.51.15604200076998957', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.213.168', '2019-06-13 18:00:08', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 18:00:08');
INSERT INTO `access_log` VALUES (36307, '65.3607.15604200095870707', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.213.168', '2019-06-13 18:00:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 18:00:10');
INSERT INTO `access_log` VALUES (36308, '65.49.15604200220008957', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.213.168', '2019-06-13 18:00:22', 55, 0, '', '2019-06-13 18:00:22');
INSERT INTO `access_log` VALUES (36309, '65.45.15604200222868949', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.213.168', '2019-06-13 18:00:22', 19, 0, '', '2019-06-13 18:00:22');
INSERT INTO `access_log` VALUES (36310, '65.50.15604200222988953', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.213.168', '2019-06-13 18:00:22', 10, 0, '', '2019-06-13 18:00:22');
INSERT INTO `access_log` VALUES (36311, '65.52.15604200222898949', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.157.213.168', '2019-06-13 18:00:22', 11, 2001001000, '服务端发生异常', '2019-06-13 18:00:22');
INSERT INTO `access_log` VALUES (36312, '59.73.15604202923508395', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.112.17.127', '2019-06-13 18:04:52', 16, 2001001000, '服务端发生异常', '2019-06-13 18:04:52');
INSERT INTO `access_log` VALUES (36313, '59.78.15604202923498393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.112.17.127', '2019-06-13 18:04:52', 235, 0, '', '2019-06-13 18:04:53');
INSERT INTO `access_log` VALUES (36314, '65.3607.15604219876300737', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:33:08', 1, 1002001015, '账号未登陆', '2019-06-13 18:33:08');
INSERT INTO `access_log` VALUES (36315, '65.54.15604219876308929', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:33:08', 0, 1002001015, '账号未登陆', '2019-06-13 18:33:08');
INSERT INTO `access_log` VALUES (36316, '65.45.15604219876508975', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:33:08', 0, 1002001015, '账号未登陆', '2019-06-13 18:33:08');
INSERT INTO `access_log` VALUES (36317, '65.49.15604219927138987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:33:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 18:33:13');
INSERT INTO `access_log` VALUES (36318, '65.50.15604220028008981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=nicaiyudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:33:23', 78, 0, '', '2019-06-13 18:33:23');
INSERT INTO `access_log` VALUES (36319, '65.46.15604220031228971', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:33:23', 11, 0, '', '2019-06-13 18:33:23');
INSERT INTO `access_log` VALUES (36320, '65.47.15604220031278957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:33:23', 8, 0, '', '2019-06-13 18:33:23');
INSERT INTO `access_log` VALUES (36321, '65.53.15604220031258949', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:33:23', 10, 2001001000, '服务端发生异常', '2019-06-13 18:33:23');
INSERT INTO `access_log` VALUES (36322, '59.71.15604220271878421', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '221.192.3.232', '2019-06-13 18:33:47', 4, 0, '', '2019-06-13 18:33:47');
INSERT INTO `access_log` VALUES (36323, '59.76.15604220271878413', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '221.192.3.232', '2019-06-13 18:33:47', 13, 2001001000, '服务端发生异常', '2019-06-13 18:33:47');
INSERT INTO `access_log` VALUES (36324, '65.54.15604220413878931', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:34:01', 80, 0, '', '2019-06-13 18:34:01');
INSERT INTO `access_log` VALUES (36325, '65.51.15604220417818989', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:34:02', 9, 0, '', '2019-06-13 18:34:02');
INSERT INTO `access_log` VALUES (36326, '65.50.15604220417868983', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:34:02', 9, 0, '', '2019-06-13 18:34:02');
INSERT INTO `access_log` VALUES (36327, '65.49.15604220417868989', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:34:02', 9, 2001001000, '服务端发生异常', '2019-06-13 18:34:02');
INSERT INTO `access_log` VALUES (36328, '65.47.15604220504898959', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:34:10', 8, 0, '', '2019-06-13 18:34:10');
INSERT INTO `access_log` VALUES (36329, '65.46.15604220504908973', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:34:10', 9, 2001001000, '服务端发生异常', '2019-06-13 18:34:10');
INSERT INTO `access_log` VALUES (36330, '65.52.15604220504948979', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.35.107.195', '2019-06-13 18:34:10', 7, 0, '', '2019-06-13 18:34:11');
INSERT INTO `access_log` VALUES (36331, '65.54.15604220866468933', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0', '182.35.107.195', '2019-06-13 18:34:47', 0, 1002001015, '账号未登陆', '2019-06-13 18:34:47');
INSERT INTO `access_log` VALUES (36332, '65.51.15604220866498991', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0', '182.35.107.195', '2019-06-13 18:34:47', 0, 1002001015, '账号未登陆', '2019-06-13 18:34:47');
INSERT INTO `access_log` VALUES (36333, '65.50.15604220866538985', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0', '182.35.107.195', '2019-06-13 18:34:47', 0, 1002001015, '账号未登陆', '2019-06-13 18:34:47');
INSERT INTO `access_log` VALUES (36334, '65.53.15604221010138953', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0', '182.35.107.195', '2019-06-13 18:35:01', 72, 0, '', '2019-06-13 18:35:01');
INSERT INTO `access_log` VALUES (36335, '65.52.15604221014768981', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0', '182.35.107.195', '2019-06-13 18:35:01', 9, 0, '', '2019-06-13 18:35:01');
INSERT INTO `access_log` VALUES (36336, '65.47.15604221014788961', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0', '182.35.107.195', '2019-06-13 18:35:01', 9, 2001001000, '服务端发生异常', '2019-06-13 18:35:01');
INSERT INTO `access_log` VALUES (36337, '65.46.15604221014818975', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0', '182.35.107.195', '2019-06-13 18:35:01', 9, 0, '', '2019-06-13 18:35:01');
INSERT INTO `access_log` VALUES (36338, '64.76.15604221159958341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '221.192.3.232', '2019-06-13 18:35:16', 11, 0, '', '2019-06-13 18:35:16');
INSERT INTO `access_log` VALUES (36339, '64.84.15604221162838353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '221.192.3.232', '2019-06-13 18:35:16', 3, 0, '', '2019-06-13 18:35:16');
INSERT INTO `access_log` VALUES (36340, '59.74.15604221200368415', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '221.192.3.232', '2019-06-13 18:35:20', 3, 0, '', '2019-06-13 18:35:20');
INSERT INTO `access_log` VALUES (36341, '59.76.15604221200828415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '221.192.3.232', '2019-06-13 18:35:20', 11, 2001001000, '服务端发生异常', '2019-06-13 18:35:20');
INSERT INTO `access_log` VALUES (36342, '65.50.15604221400688987', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0', '182.35.107.195', '2019-06-13 18:35:40', 9, 0, '', '2019-06-13 18:35:40');
INSERT INTO `access_log` VALUES (36343, '65.51.15604221400728993', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0', '182.35.107.195', '2019-06-13 18:35:40', 10, 2001001000, '服务端发生异常', '2019-06-13 18:35:40');
INSERT INTO `access_log` VALUES (36344, '65.49.15604221400738993', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:65.0) Gecko/20100101 Firefox/65.0', '182.35.107.195', '2019-06-13 18:35:40', 9, 0, '', '2019-06-13 18:35:40');
INSERT INTO `access_log` VALUES (36345, '65.45.15604232875068997', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.27.3.221', '2019-06-13 18:54:48', 0, 1002001015, '账号未登陆', '2019-06-13 18:54:48');
INSERT INTO `access_log` VALUES (36346, '65.45.15604258535079033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-13 19:37:34', 1, 1002001015, '账号未登陆', '2019-06-13 19:37:34');
INSERT INTO `access_log` VALUES (36347, '65.47.15604258535079015', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-13 19:37:34', 0, 1002001015, '账号未登陆', '2019-06-13 19:37:34');
INSERT INTO `access_log` VALUES (36348, '65.51.15604258535089049', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-13 19:37:34', 0, 1002001015, '账号未登陆', '2019-06-13 19:37:34');
INSERT INTO `access_log` VALUES (36349, '65.3607.15604258588740793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-13 19:37:39', 102, 0, '', '2019-06-13 19:37:39');
INSERT INTO `access_log` VALUES (36350, '65.54.15604258593888987', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-13 19:37:39', 13, 0, '', '2019-06-13 19:37:39');
INSERT INTO `access_log` VALUES (36351, '65.52.15604258593889041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-13 19:37:39', 11, 0, '', '2019-06-13 19:37:39');
INSERT INTO `access_log` VALUES (36352, '65.53.15604258593879013', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.236.48.202', '2019-06-13 19:37:39', 14, 2001001000, '服务端发生异常', '2019-06-13 19:37:39');
INSERT INTO `access_log` VALUES (36353, '65.51.15604313079319123', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.85.97.124', '2019-06-13 21:08:28', 1, 1002001015, '账号未登陆', '2019-06-13 21:08:28');
INSERT INTO `access_log` VALUES (36354, '65.47.15604313079329089', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.85.97.124', '2019-06-13 21:08:28', 1, 1002001015, '账号未登陆', '2019-06-13 21:08:28');
INSERT INTO `access_log` VALUES (36355, '65.50.15604313079329115', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.85.97.124', '2019-06-13 21:08:28', 1, 1002001015, '账号未登陆', '2019-06-13 21:08:28');
INSERT INTO `access_log` VALUES (36356, '65.3607.15604313100700867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.85.97.124', '2019-06-13 21:08:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 21:08:30');
INSERT INTO `access_log` VALUES (36357, '65.54.15604313208879061', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.85.97.124', '2019-06-13 21:08:41', 87, 0, '', '2019-06-13 21:08:41');
INSERT INTO `access_log` VALUES (36358, '65.52.15604313211879115', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.85.97.124', '2019-06-13 21:08:41', 11, 0, '', '2019-06-13 21:08:41');
INSERT INTO `access_log` VALUES (36359, '65.49.15604313211969117', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.85.97.124', '2019-06-13 21:08:41', 10, 2001001000, '服务端发生异常', '2019-06-13 21:08:41');
INSERT INTO `access_log` VALUES (36360, '65.46.15604313212019101', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.85.97.124', '2019-06-13 21:08:41', 9, 0, '', '2019-06-13 21:08:41');
INSERT INTO `access_log` VALUES (36361, '65.47.15604313383929091', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.85.97.124', '2019-06-13 21:08:58', 11, 0, '', '2019-06-13 21:08:58');
INSERT INTO `access_log` VALUES (36362, '65.50.15604313383959117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.85.97.124', '2019-06-13 21:08:58', 9, 0, '', '2019-06-13 21:08:58');
INSERT INTO `access_log` VALUES (36363, '65.51.15604313383939125', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.85.97.124', '2019-06-13 21:08:58', 13, 2001001000, '服务端发生异常', '2019-06-13 21:08:58');
INSERT INTO `access_log` VALUES (36364, '65.3607.15604313418000869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.85.97.124', '2019-06-13 21:09:02', 8, 0, '', '2019-06-13 21:09:02');
INSERT INTO `access_log` VALUES (36365, '65.53.15604313418019089', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.85.97.124', '2019-06-13 21:09:02', 9, 2001001000, '服务端发生异常', '2019-06-13 21:09:02');
INSERT INTO `access_log` VALUES (36366, '65.54.15604313418029063', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.85.97.124', '2019-06-13 21:09:02', 8, 0, '', '2019-06-13 21:09:02');
INSERT INTO `access_log` VALUES (36367, '65.53.15604356431329147', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '123.123.143.88', '2019-06-13 22:20:43', 1, 1002001015, '账号未登陆', '2019-06-13 22:20:43');
INSERT INTO `access_log` VALUES (36368, '65.54.15604356431329121', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '123.123.143.88', '2019-06-13 22:20:43', 0, 1002001015, '账号未登陆', '2019-06-13 22:20:43');
INSERT INTO `access_log` VALUES (36369, '65.3607.15604356431320927', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '123.123.139.66', '2019-06-13 22:20:43', 0, 1002001015, '账号未登陆', '2019-06-13 22:20:43');
INSERT INTO `access_log` VALUES (36370, '65.46.15604356462979161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '123.123.143.88', '2019-06-13 22:20:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 22:20:46');
INSERT INTO `access_log` VALUES (36371, '65.51.15604360804669191', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 22:28:00', 0, 1002001015, '账号未登陆', '2019-06-13 22:28:00');
INSERT INTO `access_log` VALUES (36372, '65.47.15604360804739157', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 22:28:00', 1, 1002001015, '账号未登陆', '2019-06-13 22:28:00');
INSERT INTO `access_log` VALUES (36373, '65.50.15604360804799183', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 22:28:00', 0, 1002001015, '账号未登陆', '2019-06-13 22:28:00');
INSERT INTO `access_log` VALUES (36374, '65.3607.15604360859400933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 22:28:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 22:28:06');
INSERT INTO `access_log` VALUES (36375, '65.52.15604361427799183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 22:29:03', 76, 0, '', '2019-06-13 22:29:03');
INSERT INTO `access_log` VALUES (36376, '65.45.15604361431529177', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 22:29:03', 177, 0, '', '2019-06-13 22:29:03');
INSERT INTO `access_log` VALUES (36377, '65.47.15604361431569159', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 22:29:03', 175, 0, '', '2019-06-13 22:29:03');
INSERT INTO `access_log` VALUES (36378, '65.51.15604361431539193', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 22:29:03', 180, 2001001000, '服务端发生异常', '2019-06-13 22:29:03');
INSERT INTO `access_log` VALUES (36379, '59.72.15604378138338629', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:56:54', 11, 0, '', '2019-06-13 22:56:54');
INSERT INTO `access_log` VALUES (36380, '59.75.15604378138338633', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:56:54', 16, 2001001000, '服务端发生异常', '2019-06-13 22:56:54');
INSERT INTO `access_log` VALUES (36381, '64.78.15604378172788563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:56:57', 10, 0, '', '2019-06-13 22:56:57');
INSERT INTO `access_log` VALUES (36382, '64.84.15604378175038563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:56:58', 3, 0, '', '2019-06-13 22:56:58');
INSERT INTO `access_log` VALUES (36383, '64.76.15604378184928551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:56:58', 2, 0, '', '2019-06-13 22:56:58');
INSERT INTO `access_log` VALUES (36384, '64.82.15604378189078569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:56:59', 2, 0, '', '2019-06-13 22:56:59');
INSERT INTO `access_log` VALUES (36385, '59.74.15604378235588625', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:57:04', 3, 0, '', '2019-06-13 22:57:04');
INSERT INTO `access_log` VALUES (36386, '59.76.15604378235598625', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:57:04', 14, 2001001000, '服务端发生异常', '2019-06-13 22:57:04');
INSERT INTO `access_log` VALUES (36387, '65.53.15604378346389179', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:57:15', 1, 1002001015, '账号未登陆', '2019-06-13 22:57:15');
INSERT INTO `access_log` VALUES (36388, '65.46.15604378347099193', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:57:15', 1, 1002001015, '账号未登陆', '2019-06-13 22:57:15');
INSERT INTO `access_log` VALUES (36389, '65.49.15604378347109209', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:57:15', 1, 1002001015, '账号未登陆', '2019-06-13 22:57:15');
INSERT INTO `access_log` VALUES (36390, '65.52.15604378367709207', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:57:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 22:57:17');
INSERT INTO `access_log` VALUES (36391, '65.51.15604378444379217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:57:24', 60, 0, '', '2019-06-13 22:57:24');
INSERT INTO `access_log` VALUES (36392, '65.45.15604378447759201', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:57:25', 9, 0, '', '2019-06-13 22:57:25');
INSERT INTO `access_log` VALUES (36393, '65.3607.15604378447770959', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:57:25', 9, 0, '', '2019-06-13 22:57:25');
INSERT INTO `access_log` VALUES (36394, '65.50.15604378447779209', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.243.14.45', '2019-06-13 22:57:25', 10, 2001001000, '服务端发生异常', '2019-06-13 22:57:25');
INSERT INTO `access_log` VALUES (36395, '59.80.15604381263408623', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:02:06', 3, 0, '', '2019-06-13 23:02:06');
INSERT INTO `access_log` VALUES (36396, '59.73.15604381263418637', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:02:06', 19, 2001001000, '服务端发生异常', '2019-06-13 23:02:06');
INSERT INTO `access_log` VALUES (36397, '64.85.15604381374268579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:02:17', 3, 0, '', '2019-06-13 23:02:17');
INSERT INTO `access_log` VALUES (36398, '64.81.15604381375298565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:02:18', 2, 0, '', '2019-06-13 23:02:18');
INSERT INTO `access_log` VALUES (36399, '66.50.15604381628987039', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15910697326&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:02:43', 17, 1001003000, '验证码不存在', '2019-06-13 23:02:43');
INSERT INTO `access_log` VALUES (36400, '66.49.15604381668557049', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15910697326', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:02:47', 71, 0, '', '2019-06-13 23:02:47');
INSERT INTO `access_log` VALUES (36401, '64.78.15604381739778569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:02:54', 2, 0, '', '2019-06-13 23:02:54');
INSERT INTO `access_log` VALUES (36402, '64.84.15604381740698569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:02:54', 1, 0, '', '2019-06-13 23:02:54');
INSERT INTO `access_log` VALUES (36403, '64.76.15604381761638557', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:02:56', 2, 0, '', '2019-06-13 23:02:56');
INSERT INTO `access_log` VALUES (36404, '64.82.15604381776888575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:02:58', 1, 0, '', '2019-06-13 23:02:58');
INSERT INTO `access_log` VALUES (36405, '64.83.15604381846438557', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:03:05', 1, 0, '', '2019-06-13 23:03:05');
INSERT INTO `access_log` VALUES (36406, '64.85.15604381847768581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:03:05', 2, 0, '', '2019-06-13 23:03:05');
INSERT INTO `access_log` VALUES (36407, '64.80.15604381859628567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:03:06', 2, 0, '', '2019-06-13 23:03:06');
INSERT INTO `access_log` VALUES (36408, '59.75.15604381922928639', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:03:12', 3, 0, '', '2019-06-13 23:03:12');
INSERT INTO `access_log` VALUES (36409, '59.74.15604381923208631', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.142.153.82', '2019-06-13 23:03:12', 10, 2001001000, '服务端发生异常', '2019-06-13 23:03:12');
INSERT INTO `access_log` VALUES (36410, '65.46.15604383459769201', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '111.199.189.236', '2019-06-13 23:05:46', 1, 1002001015, '账号未登陆', '2019-06-13 23:05:46');
INSERT INTO `access_log` VALUES (36411, '65.52.15604383459879215', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '111.199.189.236', '2019-06-13 23:05:46', 0, 1002001015, '账号未登陆', '2019-06-13 23:05:46');
INSERT INTO `access_log` VALUES (36412, '65.47.15604383460029191', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '111.199.189.236', '2019-06-13 23:05:46', 0, 1002001015, '账号未登陆', '2019-06-13 23:05:46');
INSERT INTO `access_log` VALUES (36413, '65.51.15604390625049235', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '58.101.143.98', '2019-06-13 23:17:43', 0, 1002001015, '账号未登陆', '2019-06-13 23:17:43');
INSERT INTO `access_log` VALUES (36414, '65.52.15604390625039225', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '58.101.143.98', '2019-06-13 23:17:43', 0, 1002001015, '账号未登陆', '2019-06-13 23:17:43');
INSERT INTO `access_log` VALUES (36415, '65.47.15604390625039201', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '58.101.143.98', '2019-06-13 23:17:43', 1, 1002001015, '账号未登陆', '2019-06-13 23:17:43');
INSERT INTO `access_log` VALUES (36416, '59.74.15604408641548667', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:47:44', 11, 0, '', '2019-06-13 23:47:44');
INSERT INTO `access_log` VALUES (36417, '59.75.15604408641548675', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:47:44', 15, 2001001000, '服务端发生异常', '2019-06-13 23:47:44');
INSERT INTO `access_log` VALUES (36418, '64.81.15604408697318603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:47:50', 10, 0, '', '2019-06-13 23:47:50');
INSERT INTO `access_log` VALUES (36419, '64.80.15604408698568603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:47:50', 2, 0, '', '2019-06-13 23:47:50');
INSERT INTO `access_log` VALUES (36420, '64.77.15604408735948609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:47:54', 2, 0, '', '2019-06-13 23:47:54');
INSERT INTO `access_log` VALUES (36421, '64.78.15604408737268607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:47:54', 2, 0, '', '2019-06-13 23:47:54');
INSERT INTO `access_log` VALUES (36422, '59.71.15604408773378675', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:47:57', 3, 0, '', '2019-06-13 23:47:57');
INSERT INTO `access_log` VALUES (36423, '59.73.15604408773588675', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:47:57', 12, 2001001000, '服务端发生异常', '2019-06-13 23:47:57');
INSERT INTO `access_log` VALUES (36424, '65.3607.15604408830191001', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:48:03', 1, 1002001015, '账号未登陆', '2019-06-13 23:48:03');
INSERT INTO `access_log` VALUES (36425, '65.50.15604408830199251', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:48:03', 0, 1002001015, '账号未登陆', '2019-06-13 23:48:03');
INSERT INTO `access_log` VALUES (36426, '65.54.15604408830219195', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:48:03', 0, 1002001015, '账号未登陆', '2019-06-13 23:48:03');
INSERT INTO `access_log` VALUES (36427, '65.49.15604408909249253', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:48:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-13 23:48:11');
INSERT INTO `access_log` VALUES (36428, '65.46.15604408995459237', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:48:20', 61, 0, '', '2019-06-13 23:48:20');
INSERT INTO `access_log` VALUES (36429, '65.47.15604408999419227', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:48:20', 10, 0, '', '2019-06-13 23:48:20');
INSERT INTO `access_log` VALUES (36430, '65.51.15604408999439261', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:48:20', 10, 2001001000, '服务端发生异常', '2019-06-13 23:48:20');
INSERT INTO `access_log` VALUES (36431, '65.52.15604408999699251', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:48:20', 9, 0, '', '2019-06-13 23:48:20');
INSERT INTO `access_log` VALUES (36432, '65.3607.15604409411451003', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:49:01', 12, 0, '', '2019-06-13 23:49:01');
INSERT INTO `access_log` VALUES (36433, '65.53.15604409411519225', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:49:01', 9, 2001001000, '服务端发生异常', '2019-06-13 23:49:01');
INSERT INTO `access_log` VALUES (36434, '65.49.15604409411569255', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.229.47', '2019-06-13 23:49:01', 9, 0, '', '2019-06-13 23:49:01');
INSERT INTO `access_log` VALUES (36435, '59.77.15604433017598693', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:28:22', 10, 0, '', '2019-06-14 00:28:22');
INSERT INTO `access_log` VALUES (36436, '59.79.15604433017608711', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:28:22', 16, 2001001000, '服务端发生异常', '2019-06-14 00:28:22');
INSERT INTO `access_log` VALUES (36437, '64.82.15604433054328645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:28:25', 11, 0, '', '2019-06-14 00:28:25');
INSERT INTO `access_log` VALUES (36438, '64.83.15604433056828627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:28:26', 2, 0, '', '2019-06-14 00:28:26');
INSERT INTO `access_log` VALUES (36439, '65.3607.15604433238731035', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:28:44', 1, 1002001015, '账号未登陆', '2019-06-14 00:28:44');
INSERT INTO `access_log` VALUES (36440, '65.46.15604433238749271', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:28:44', 1, 1002001015, '账号未登陆', '2019-06-14 00:28:44');
INSERT INTO `access_log` VALUES (36441, '65.47.15604433238749261', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:28:44', 1, 1002001015, '账号未登陆', '2019-06-14 00:28:44');
INSERT INTO `access_log` VALUES (36442, '65.52.15604433369499285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:28:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 00:28:57');
INSERT INTO `access_log` VALUES (36443, '65.45.15604433446459279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:29:05', 77, 0, '', '2019-06-14 00:29:05');
INSERT INTO `access_log` VALUES (36444, '65.54.15604433452059231', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:29:05', 15, 0, '', '2019-06-14 00:29:05');
INSERT INTO `access_log` VALUES (36445, '65.50.15604433452099287', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:29:05', 12, 0, '', '2019-06-14 00:29:05');
INSERT INTO `access_log` VALUES (36446, '65.49.15604433452099289', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:29:05', 14, 2001001000, '服务端发生异常', '2019-06-14 00:29:05');
INSERT INTO `access_log` VALUES (36447, '65.3607.15604433647351037', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:29:25', 12, 0, '', '2019-06-14 00:29:25');
INSERT INTO `access_log` VALUES (36448, '65.47.15604433647399263', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:29:25', 10, 2001001000, '服务端发生异常', '2019-06-14 00:29:25');
INSERT INTO `access_log` VALUES (36449, '65.51.15604433647459297', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '223.74.43.193', '2019-06-14 00:29:25', 9, 0, '', '2019-06-14 00:29:25');
INSERT INTO `access_log` VALUES (36450, '64.81.15604475273228695', 0, 2, 'product-application', '/product-api/admins/attr/add', 'name=颜色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.70.128.98', '2019-06-14 01:38:47', 1, 1002001015, '账号未登陆', '2019-06-14 01:38:47');
INSERT INTO `access_log` VALUES (36451, '65.3607.15604734273031441', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.6.133', '2019-06-14 08:50:27', 0, 1002001015, '账号未登陆', '2019-06-14 08:50:27');
INSERT INTO `access_log` VALUES (36452, '65.53.15604734273039663', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.6.130', '2019-06-14 08:50:27', 0, 1002001015, '账号未登陆', '2019-06-14 08:50:27');
INSERT INTO `access_log` VALUES (36453, '65.46.15604734273049679', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.6.133', '2019-06-14 08:50:27', 1, 1002001015, '账号未登陆', '2019-06-14 08:50:27');
INSERT INTO `access_log` VALUES (36454, '65.47.15604734346479669', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.6.130', '2019-06-14 08:50:35', 84, 0, '', '2019-06-14 08:50:35');
INSERT INTO `access_log` VALUES (36455, '65.52.15604734349469689', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.6.133', '2019-06-14 08:50:35', 12, 0, '', '2019-06-14 08:50:35');
INSERT INTO `access_log` VALUES (36456, '65.49.15604734349529691', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.6.130', '2019-06-14 08:50:35', 12, 0, '', '2019-06-14 08:50:35');
INSERT INTO `access_log` VALUES (36457, '65.45.15604734349519685', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.6.130', '2019-06-14 08:50:35', 12, 2001001000, '服务端发生异常', '2019-06-14 08:50:35');
INSERT INTO `access_log` VALUES (36458, '65.51.15604734613359701', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.6.130', '2019-06-14 08:51:01', 10, 0, '', '2019-06-14 08:51:01');
INSERT INTO `access_log` VALUES (36459, '65.3607.15604734613401443', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.6.133', '2019-06-14 08:51:01', 9, 0, '', '2019-06-14 08:51:01');
INSERT INTO `access_log` VALUES (36460, '65.46.15604734613379681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.6.130', '2019-06-14 08:51:01', 13, 2001001000, '服务端发生异常', '2019-06-14 08:51:01');
INSERT INTO `access_log` VALUES (36461, '65.52.15604734768329691', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.6.133', '2019-06-14 08:51:17', 10, 2001001000, '服务端发生异常', '2019-06-14 08:51:17');
INSERT INTO `access_log` VALUES (36462, '65.47.15604734768309671', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.6.130', '2019-06-14 08:51:17', 9, 0, '', '2019-06-14 08:51:17');
INSERT INTO `access_log` VALUES (36463, '65.49.15604734768419693', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.62.6.133', '2019-06-14 08:51:17', 20, 0, '', '2019-06-14 08:51:17');
INSERT INTO `access_log` VALUES (36464, '65.47.15604736037689673', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.222.147.72', '2019-06-14 08:53:24', 1, 1002001015, '账号未登陆', '2019-06-14 08:53:24');
INSERT INTO `access_log` VALUES (36465, '65.49.15604736037749695', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.222.147.72', '2019-06-14 08:53:24', 0, 1002001015, '账号未登陆', '2019-06-14 08:53:24');
INSERT INTO `access_log` VALUES (36466, '65.45.15604736037809689', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.222.147.72', '2019-06-14 08:53:24', 0, 1002001015, '账号未登陆', '2019-06-14 08:53:24');
INSERT INTO `access_log` VALUES (36467, '65.50.15604736060459693', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.222.147.72', '2019-06-14 08:53:26', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 08:53:26');
INSERT INTO `access_log` VALUES (36468, '65.51.15604736307459705', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.222.147.72', '2019-06-14 08:53:51', 167, 0, '', '2019-06-14 08:53:51');
INSERT INTO `access_log` VALUES (36469, '65.53.15604736312899669', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.222.147.72', '2019-06-14 08:53:51', 8, 0, '', '2019-06-14 08:53:51');
INSERT INTO `access_log` VALUES (36470, '65.3607.15604736312891447', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.222.147.72', '2019-06-14 08:53:51', 12, 2001001000, '服务端发生异常', '2019-06-14 08:53:51');
INSERT INTO `access_log` VALUES (36471, '65.52.15604736312979695', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.222.147.72', '2019-06-14 08:53:51', 9, 0, '', '2019-06-14 08:53:51');
INSERT INTO `access_log` VALUES (36472, '65.54.15604736690669641', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '120.204.17.73', '2019-06-14 08:54:29', 1, 1002001015, '账号未登陆', '2019-06-14 08:54:29');
INSERT INTO `access_log` VALUES (36473, '65.51.15604736820059707', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.222.147.72', '2019-06-14 08:54:42', 8, 0, '', '2019-06-14 08:54:42');
INSERT INTO `access_log` VALUES (36474, '65.46.15604736820039687', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.222.147.72', '2019-06-14 08:54:42', 9, 2001001000, '服务端发生异常', '2019-06-14 08:54:42');
INSERT INTO `access_log` VALUES (36475, '65.3607.15604736820341449', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.222.147.72', '2019-06-14 08:54:42', 8, 0, '', '2019-06-14 08:54:42');
INSERT INTO `access_log` VALUES (36476, '65.52.15604736927339697', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.222.147.72', '2019-06-14 08:54:53', 9, 0, '', '2019-06-14 08:54:53');
INSERT INTO `access_log` VALUES (36477, '65.53.15604736927369671', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.222.147.72', '2019-06-14 08:54:53', 9, 2001001000, '服务端发生异常', '2019-06-14 08:54:53');
INSERT INTO `access_log` VALUES (36478, '65.45.15604736927419693', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.222.147.72', '2019-06-14 08:54:53', 9, 0, '', '2019-06-14 08:54:53');
INSERT INTO `access_log` VALUES (36479, '65.47.15604743012079685', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:05:01', 0, 1002001015, '账号未登陆', '2019-06-14 09:05:01');
INSERT INTO `access_log` VALUES (36480, '65.50.15604743012119705', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:05:01', 1, 1002001015, '账号未登陆', '2019-06-14 09:05:01');
INSERT INTO `access_log` VALUES (36481, '65.54.15604743012119651', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:05:01', 0, 1002001015, '账号未登陆', '2019-06-14 09:05:01');
INSERT INTO `access_log` VALUES (36482, '65.3607.15604743115301459', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:05:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 09:05:12');
INSERT INTO `access_log` VALUES (36483, '65.52.15604743286329707', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:05:29', 59, 0, '', '2019-06-14 09:05:29');
INSERT INTO `access_log` VALUES (36484, '65.45.15604743289319703', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:05:29', 11, 0, '', '2019-06-14 09:05:29');
INSERT INTO `access_log` VALUES (36485, '65.53.15604743289339681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:05:29', 10, 2001001000, '服务端发生异常', '2019-06-14 09:05:29');
INSERT INTO `access_log` VALUES (36486, '65.49.15604743289389709', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:05:29', 9, 0, '', '2019-06-14 09:05:29');
INSERT INTO `access_log` VALUES (36487, '65.47.15604743426269687', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:05:43', 11, 0, '', '2019-06-14 09:05:43');
INSERT INTO `access_log` VALUES (36488, '65.50.15604743426279707', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:05:43', 10, 2001001000, '服务端发生异常', '2019-06-14 09:05:43');
INSERT INTO `access_log` VALUES (36489, '65.46.15604743426309699', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:05:43', 9, 0, '', '2019-06-14 09:05:43');
INSERT INTO `access_log` VALUES (36490, '65.52.15604743834259709', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:06:23', 10, 0, '', '2019-06-14 09:06:23');
INSERT INTO `access_log` VALUES (36491, '65.53.15604743834299683', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:06:23', 9, 0, '', '2019-06-14 09:06:23');
INSERT INTO `access_log` VALUES (36492, '65.45.15604743834269705', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:06:23', 12, 2001001000, '服务端发生异常', '2019-06-14 09:06:23');
INSERT INTO `access_log` VALUES (36493, '65.49.15604749603259719', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.255.127.89', '2019-06-14 09:16:00', 0, 1002001015, '账号未登陆', '2019-06-14 09:16:00');
INSERT INTO `access_log` VALUES (36494, '65.52.15604749603259717', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.255.127.89', '2019-06-14 09:16:00', 0, 1002001015, '账号未登陆', '2019-06-14 09:16:00');
INSERT INTO `access_log` VALUES (36495, '65.54.15604749603279663', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.255.127.89', '2019-06-14 09:16:00', 1, 1002001015, '账号未登陆', '2019-06-14 09:16:00');
INSERT INTO `access_log` VALUES (36496, '65.50.15604749854829717', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:16:25', 10, 0, '', '2019-06-14 09:16:25');
INSERT INTO `access_log` VALUES (36497, '65.3607.15604749854841471', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:16:25', 11, 2001001000, '服务端发生异常', '2019-06-14 09:16:25');
INSERT INTO `access_log` VALUES (36498, '65.51.15604749854889729', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:16:25', 9, 0, '', '2019-06-14 09:16:25');
INSERT INTO `access_log` VALUES (36499, '65.45.15604749892989715', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.255.127.89', '2019-06-14 09:16:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 09:16:29');
INSERT INTO `access_log` VALUES (36500, '65.53.15604749969959693', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:16:37', 63, 0, '', '2019-06-14 09:16:37');
INSERT INTO `access_log` VALUES (36501, '65.49.15604749972389721', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:16:37', 9, 0, '', '2019-06-14 09:16:37');
INSERT INTO `access_log` VALUES (36502, '65.54.15604749972419665', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:16:37', 9, 2001001000, '服务端发生异常', '2019-06-14 09:16:37');
INSERT INTO `access_log` VALUES (36503, '65.52.15604749972499719', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:16:37', 8, 0, '', '2019-06-14 09:16:37');
INSERT INTO `access_log` VALUES (36504, '65.47.15604750030899699', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:16:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 09:16:43');
INSERT INTO `access_log` VALUES (36505, '65.50.15604750091119719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.255.127.89', '2019-06-14 09:16:49', 121, 0, '', '2019-06-14 09:16:49');
INSERT INTO `access_log` VALUES (36506, '65.3607.15604750096001473', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.255.127.89', '2019-06-14 09:16:50', 10, 0, '', '2019-06-14 09:16:50');
INSERT INTO `access_log` VALUES (36507, '65.45.15604750096009717', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.255.127.89', '2019-06-14 09:16:50', 8, 0, '', '2019-06-14 09:16:50');
INSERT INTO `access_log` VALUES (36508, '65.51.15604750096009731', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.255.127.89', '2019-06-14 09:16:50', 10, 2001001000, '服务端发生异常', '2019-06-14 09:16:50');
INSERT INTO `access_log` VALUES (36509, '65.52.15604750245869721', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.255.127.89', '2019-06-14 09:17:05', 9, 0, '', '2019-06-14 09:17:05');
INSERT INTO `access_log` VALUES (36510, '65.49.15604750245929723', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.255.127.89', '2019-06-14 09:17:05', 9, 0, '', '2019-06-14 09:17:05');
INSERT INTO `access_log` VALUES (36511, '65.54.15604750245929667', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.255.127.89', '2019-06-14 09:17:05', 10, 2001001000, '服务端发生异常', '2019-06-14 09:17:05');
INSERT INTO `access_log` VALUES (36512, '65.51.15604750769499733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:17:57', 176, 0, '', '2019-06-14 09:17:57');
INSERT INTO `access_log` VALUES (36513, '65.3607.15604750772801475', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:17:57', 9, 0, '', '2019-06-14 09:17:57');
INSERT INTO `access_log` VALUES (36514, '65.49.15604750773089725', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:17:57', 8, 0, '', '2019-06-14 09:17:57');
INSERT INTO `access_log` VALUES (36515, '65.53.15604750773089697', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:17:57', 9, 2001001000, '服务端发生异常', '2019-06-14 09:17:57');
INSERT INTO `access_log` VALUES (36516, '65.54.15604751006189669', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:18:21', 10, 0, '', '2019-06-14 09:18:21');
INSERT INTO `access_log` VALUES (36517, '65.47.15604751006249703', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:18:21', 8, 0, '', '2019-06-14 09:18:21');
INSERT INTO `access_log` VALUES (36518, '65.46.15604751006239715', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '219.233.175.82', '2019-06-14 09:18:21', 10, 2001001000, '服务端发生异常', '2019-06-14 09:18:21');
INSERT INTO `access_log` VALUES (36519, '59.76.15604758452309135', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.166', '2019-06-14 09:30:45', 9, 0, '', '2019-06-14 09:30:45');
INSERT INTO `access_log` VALUES (36520, '59.75.15604758452299145', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.166', '2019-06-14 09:30:45', 13, 2001001000, '服务端发生异常', '2019-06-14 09:30:45');
INSERT INTO `access_log` VALUES (36521, '64.81.15604758556039073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.166', '2019-06-14 09:30:56', 12, 0, '', '2019-06-14 09:30:56');
INSERT INTO `access_log` VALUES (36522, '64.79.15604758557279067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.166', '2019-06-14 09:30:56', 3, 0, '', '2019-06-14 09:30:56');
INSERT INTO `access_log` VALUES (36523, '64.80.15604758591859073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.166', '2019-06-14 09:30:59', 2, 0, '', '2019-06-14 09:30:59');
INSERT INTO `access_log` VALUES (36524, '64.77.15604758593169079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.166', '2019-06-14 09:30:59', 2, 0, '', '2019-06-14 09:30:59');
INSERT INTO `access_log` VALUES (36525, '59.73.15604758624239143', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.166', '2019-06-14 09:31:02', 3, 0, '', '2019-06-14 09:31:02');
INSERT INTO `access_log` VALUES (36526, '59.80.15604758624239129', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.166', '2019-06-14 09:31:02', 14, 2001001000, '服务端发生异常', '2019-06-14 09:31:02');
INSERT INTO `access_log` VALUES (36527, '59.78.15604759948489141', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.242', '2019-06-14 09:33:15', 2, 0, '', '2019-06-14 09:33:15');
INSERT INTO `access_log` VALUES (36528, '59.73.15604759948479145', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.242', '2019-06-14 09:33:15', 13, 2001001000, '服务端发生异常', '2019-06-14 09:33:15');
INSERT INTO `access_log` VALUES (36529, '64.78.15604760012729077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.242', '2019-06-14 09:33:21', 2, 0, '', '2019-06-14 09:33:21');
INSERT INTO `access_log` VALUES (36530, '64.76.15604760016679067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.242', '2019-06-14 09:33:22', 2, 0, '', '2019-06-14 09:33:22');
INSERT INTO `access_log` VALUES (36531, '64.84.15604760051459075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.242', '2019-06-14 09:33:25', 2, 0, '', '2019-06-14 09:33:25');
INSERT INTO `access_log` VALUES (36532, '64.82.15604760052859083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.242', '2019-06-14 09:33:25', 2, 0, '', '2019-06-14 09:33:25');
INSERT INTO `access_log` VALUES (36533, '59.74.15604760207819139', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.242', '2019-06-14 09:33:41', 2, 0, '', '2019-06-14 09:33:41');
INSERT INTO `access_log` VALUES (36534, '59.79.15604760207819147', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.242', '2019-06-14 09:33:41', 12, 2001001000, '服务端发生异常', '2019-06-14 09:33:41');
INSERT INTO `access_log` VALUES (36535, '64.85.15604760304459089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.242', '2019-06-14 09:33:50', 2, 0, '', '2019-06-14 09:33:50');
INSERT INTO `access_log` VALUES (36536, '64.79.15604760305689071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.210.138.242', '2019-06-14 09:33:51', 2, 0, '', '2019-06-14 09:33:51');
INSERT INTO `access_log` VALUES (36537, '59.75.15604793365769193', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.229.149', '2019-06-14 10:28:57', 11, 0, '', '2019-06-14 10:28:57');
INSERT INTO `access_log` VALUES (36538, '59.71.15604793365779191', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.229.149', '2019-06-14 10:28:57', 15, 2001001000, '服务端发生异常', '2019-06-14 10:28:57');
INSERT INTO `access_log` VALUES (36539, '65.47.15604793451659761', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.229.149', '2019-06-14 10:29:05', 0, 1002001015, '账号未登陆', '2019-06-14 10:29:05');
INSERT INTO `access_log` VALUES (36540, '65.54.15604793451659727', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.229.149', '2019-06-14 10:29:05', 0, 1002001015, '账号未登陆', '2019-06-14 10:29:05');
INSERT INTO `access_log` VALUES (36541, '65.46.15604793451709773', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.229.149', '2019-06-14 10:29:05', 1, 1002001015, '账号未登陆', '2019-06-14 10:29:05');
INSERT INTO `access_log` VALUES (36542, '65.52.15604794377919783', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 10:30:38', 4, 1002001012, '访问令牌已过期', '2019-06-14 10:30:38');
INSERT INTO `access_log` VALUES (36543, '65.47.15604794377929763', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 10:30:38', 4, 1002001012, '访问令牌已过期', '2019-06-14 10:30:38');
INSERT INTO `access_log` VALUES (36544, '65.54.15604794377959729', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 10:30:38', 3, 1002001012, '访问令牌已过期', '2019-06-14 10:30:38');
INSERT INTO `access_log` VALUES (36545, '65.49.15604794470539787', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 10:30:47', 64, 0, '', '2019-06-14 10:30:47');
INSERT INTO `access_log` VALUES (36546, '65.50.15604794473939781', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 10:30:47', 11, 0, '', '2019-06-14 10:30:47');
INSERT INTO `access_log` VALUES (36547, '65.3607.15604794474001537', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 10:30:47', 11, 0, '', '2019-06-14 10:30:47');
INSERT INTO `access_log` VALUES (36548, '65.45.15604794474009779', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 10:30:47', 12, 2001001000, '服务端发生异常', '2019-06-14 10:30:47');
INSERT INTO `access_log` VALUES (36549, '65.3607.15604797118971541', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.222.26', '2019-06-14 10:35:12', 0, 1002001015, '账号未登陆', '2019-06-14 10:35:12');
INSERT INTO `access_log` VALUES (36550, '65.50.15604797118989785', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.222.26', '2019-06-14 10:35:12', 1, 1002001015, '账号未登陆', '2019-06-14 10:35:12');
INSERT INTO `access_log` VALUES (36551, '65.51.15604797118999799', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.222.26', '2019-06-14 10:35:12', 0, 1002001015, '账号未登陆', '2019-06-14 10:35:12');
INSERT INTO `access_log` VALUES (36552, '65.53.15604797194199763', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.222.26', '2019-06-14 10:35:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 10:35:19');
INSERT INTO `access_log` VALUES (36553, '65.54.15604797306159735', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.222.26', '2019-06-14 10:35:31', 79, 0, '', '2019-06-14 10:35:31');
INSERT INTO `access_log` VALUES (36554, '65.52.15604797314029789', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.222.26', '2019-06-14 10:35:31', 14, 0, '', '2019-06-14 10:35:31');
INSERT INTO `access_log` VALUES (36555, '65.49.15604797314079793', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.222.26', '2019-06-14 10:35:31', 111, 0, '', '2019-06-14 10:35:32');
INSERT INTO `access_log` VALUES (36556, '65.46.15604797314039781', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.222.26', '2019-06-14 10:35:31', 117, 2001001000, '服务端发生异常', '2019-06-14 10:35:32');
INSERT INTO `access_log` VALUES (36557, '65.51.15604797488279801', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.222.26', '2019-06-14 10:35:49', 7, 0, '', '2019-06-14 10:35:49');
INSERT INTO `access_log` VALUES (36558, '65.50.15604797488259787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.222.26', '2019-06-14 10:35:49', 9, 0, '', '2019-06-14 10:35:49');
INSERT INTO `access_log` VALUES (36559, '65.3607.15604797488271543', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.222.26', '2019-06-14 10:35:49', 9, 2001001000, '服务端发生异常', '2019-06-14 10:35:49');
INSERT INTO `access_log` VALUES (36560, '65.49.15604797847169795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.222.26', '2019-06-14 10:36:25', 9, 0, '', '2019-06-14 10:36:25');
INSERT INTO `access_log` VALUES (36561, '65.46.15604797847169783', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.222.26', '2019-06-14 10:36:25', 172, 0, '', '2019-06-14 10:36:25');
INSERT INTO `access_log` VALUES (36562, '65.52.15604797847159791', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.222.26', '2019-06-14 10:36:25', 176, 2001001000, '服务端发生异常', '2019-06-14 10:36:25');
INSERT INTO `access_log` VALUES (36563, '65.46.15604823148279817', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-14 11:18:35', 0, 1002001015, '账号未登陆', '2019-06-14 11:18:35');
INSERT INTO `access_log` VALUES (36564, '65.52.15604823148289825', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-14 11:18:35', 0, 1002001015, '账号未登陆', '2019-06-14 11:18:35');
INSERT INTO `access_log` VALUES (36565, '65.45.15604823148289821', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-14 11:18:35', 1, 1002001015, '账号未登陆', '2019-06-14 11:18:35');
INSERT INTO `access_log` VALUES (36566, '65.50.15604823183229823', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-14 11:18:38', 61, 0, '', '2019-06-14 11:18:38');
INSERT INTO `access_log` VALUES (36567, '65.3607.15604823186961579', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-14 11:18:39', 14, 0, '', '2019-06-14 11:18:39');
INSERT INTO `access_log` VALUES (36568, '65.53.15604823187009801', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-14 11:18:39', 14, 0, '', '2019-06-14 11:18:39');
INSERT INTO `access_log` VALUES (36569, '65.51.15604823187019837', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-14 11:18:39', 12, 2001001000, '服务端发生异常', '2019-06-14 11:18:39');
INSERT INTO `access_log` VALUES (36570, '65.3607.15604824422471581', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-14 11:20:42', 9, 0, '', '2019-06-14 11:20:42');
INSERT INTO `access_log` VALUES (36571, '65.47.15604824422499809', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-14 11:20:42', 10, 2001001000, '服务端发生异常', '2019-06-14 11:20:42');
INSERT INTO `access_log` VALUES (36572, '65.54.15604824422539775', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-14 11:20:42', 8, 0, '', '2019-06-14 11:20:42');
INSERT INTO `access_log` VALUES (36573, '65.49.15604845519269861', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 11:55:52', 1, 1002001015, '账号未登陆', '2019-06-14 11:55:52');
INSERT INTO `access_log` VALUES (36574, '65.46.15604845519269849', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 11:55:52', 0, 1002001015, '账号未登陆', '2019-06-14 11:55:52');
INSERT INTO `access_log` VALUES (36575, '65.52.15604845519489857', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 11:55:52', 0, 1002001015, '账号未登陆', '2019-06-14 11:55:52');
INSERT INTO `access_log` VALUES (36576, '65.50.15604845545169855', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 11:55:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 11:55:55');
INSERT INTO `access_log` VALUES (36577, '65.53.15604845585709833', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 11:55:59', 55, 0, '', '2019-06-14 11:55:59');
INSERT INTO `access_log` VALUES (36578, '65.51.15604845589159869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 11:55:59', 12, 0, '', '2019-06-14 11:55:59');
INSERT INTO `access_log` VALUES (36579, '65.47.15604845589179839', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 11:55:59', 11, 2001001000, '服务端发生异常', '2019-06-14 11:55:59');
INSERT INTO `access_log` VALUES (36580, '65.54.15604845589219805', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 11:55:59', 10, 0, '', '2019-06-14 11:55:59');
INSERT INTO `access_log` VALUES (36581, '65.46.15604845724469851', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 11:56:12', 10, 0, '', '2019-06-14 11:56:12');
INSERT INTO `access_log` VALUES (36582, '65.49.15604845724569863', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 11:56:12', 11, 0, '', '2019-06-14 11:56:12');
INSERT INTO `access_log` VALUES (36583, '65.52.15604845724569859', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 11:56:12', 10, 2001001000, '服务端发生异常', '2019-06-14 11:56:12');
INSERT INTO `access_log` VALUES (36584, '59.80.15604845892339247', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 11:56:29', 13, 0, '', '2019-06-14 11:56:29');
INSERT INTO `access_log` VALUES (36585, '59.78.15604845892419257', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 11:56:29', 16, 2001001000, '服务端发生异常', '2019-06-14 11:56:29');
INSERT INTO `access_log` VALUES (36586, '65.53.15604846043809835', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.93.176.21', '2019-06-14 11:56:44', 1, 1002001015, '账号未登陆', '2019-06-14 11:56:44');
INSERT INTO `access_log` VALUES (36587, '65.47.15604846043819841', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.93.176.21', '2019-06-14 11:56:44', 1, 1002001015, '账号未登陆', '2019-06-14 11:56:44');
INSERT INTO `access_log` VALUES (36588, '65.51.15604846043829871', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.93.176.21', '2019-06-14 11:56:44', 0, 1002001015, '账号未登陆', '2019-06-14 11:56:44');
INSERT INTO `access_log` VALUES (36589, '65.54.15604846072309807', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.93.176.21', '2019-06-14 11:56:47', 85, 0, '', '2019-06-14 11:56:47');
INSERT INTO `access_log` VALUES (36590, '65.3607.15604846074961613', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.93.176.21', '2019-06-14 11:56:47', 10, 0, '', '2019-06-14 11:56:48');
INSERT INTO `access_log` VALUES (36591, '65.46.15604846074989853', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.93.176.21', '2019-06-14 11:56:47', 7, 0, '', '2019-06-14 11:56:48');
INSERT INTO `access_log` VALUES (36592, '65.52.15604846074969861', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.93.176.21', '2019-06-14 11:56:47', 11, 2001001000, '服务端发生异常', '2019-06-14 11:56:48');
INSERT INTO `access_log` VALUES (36593, '65.49.15604850502429871', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 12:04:10', 19, 0, '', '2019-06-14 12:04:10');
INSERT INTO `access_log` VALUES (36594, '65.50.15604850502469865', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 12:04:10', 16, 0, '', '2019-06-14 12:04:10');
INSERT INTO `access_log` VALUES (36595, '65.45.15604850502439863', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.93.176.21', '2019-06-14 12:04:10', 21, 2001001000, '服务端发生异常', '2019-06-14 12:04:10');
INSERT INTO `access_log` VALUES (36596, '59.75.15604867802219293', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '117.155.182.14', '2019-06-14 12:33:00', 18, 0, '', '2019-06-14 12:33:00');
INSERT INTO `access_log` VALUES (36597, '59.71.15604867802239291', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '117.155.182.14', '2019-06-14 12:33:00', 20, 2001001000, '服务端发生异常', '2019-06-14 12:33:00');
INSERT INTO `access_log` VALUES (36598, '65.50.15604868031849889', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '117.155.182.14', '2019-06-14 12:33:23', 0, 1002001015, '账号未登陆', '2019-06-14 12:33:23');
INSERT INTO `access_log` VALUES (36599, '65.3607.15604868031841643', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '117.155.182.14', '2019-06-14 12:33:23', 1, 1002001015, '账号未登陆', '2019-06-14 12:33:23');
INSERT INTO `access_log` VALUES (36600, '65.49.15604868031899895', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '117.155.182.14', '2019-06-14 12:33:23', 1, 1002001015, '账号未登陆', '2019-06-14 12:33:23');
INSERT INTO `access_log` VALUES (36601, '65.53.15604868475979867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '117.155.182.14', '2019-06-14 12:34:08', 102, 0, '', '2019-06-14 12:34:08');
INSERT INTO `access_log` VALUES (36602, '65.54.15604868481049839', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '117.155.182.14', '2019-06-14 12:34:08', 9, 0, '', '2019-06-14 12:34:08');
INSERT INTO `access_log` VALUES (36603, '65.46.15604868481069885', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '117.155.182.14', '2019-06-14 12:34:08', 10, 2001001000, '服务端发生异常', '2019-06-14 12:34:08');
INSERT INTO `access_log` VALUES (36604, '65.52.15604868481139893', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '117.155.182.14', '2019-06-14 12:34:08', 9, 0, '', '2019-06-14 12:34:08');
INSERT INTO `access_log` VALUES (36605, '65.50.15604868649619891', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.64.17.117', '2019-06-14 12:34:25', 1, 1002001015, '账号未登陆', '2019-06-14 12:34:25');
INSERT INTO `access_log` VALUES (36606, '65.45.15604868649709889', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.64.17.117', '2019-06-14 12:34:25', 0, 1002001015, '账号未登陆', '2019-06-14 12:34:25');
INSERT INTO `access_log` VALUES (36607, '65.47.15604868649709875', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.64.17.117', '2019-06-14 12:34:25', 0, 1002001015, '账号未登陆', '2019-06-14 12:34:25');
INSERT INTO `access_log` VALUES (36608, '65.51.15604868731119905', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.64.17.117', '2019-06-14 12:34:33', 84, 0, '', '2019-06-14 12:34:33');
INSERT INTO `access_log` VALUES (36609, '65.54.15604868829929841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.64.17.117', '2019-06-14 12:34:43', 109, 0, '', '2019-06-14 12:34:43');
INSERT INTO `access_log` VALUES (36610, '59.75.15604870521219297', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 12:37:32', 3, 0, '', '2019-06-14 12:37:32');
INSERT INTO `access_log` VALUES (36611, '59.71.15604870521279295', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 12:37:32', 11, 2001001000, '服务端发生异常', '2019-06-14 12:37:32');
INSERT INTO `access_log` VALUES (36612, '65.49.15604870724589901', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.64.17.117', '2019-06-14 12:37:52', 106, 0, '', '2019-06-14 12:37:53');
INSERT INTO `access_log` VALUES (36613, '65.3607.15604870731531649', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.64.17.117', '2019-06-14 12:37:53', 8, 0, '', '2019-06-14 12:37:53');
INSERT INTO `access_log` VALUES (36614, '65.45.15604870731699893', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.64.17.117', '2019-06-14 12:37:53', 9, 2001001000, '服务端发生异常', '2019-06-14 12:37:53');
INSERT INTO `access_log` VALUES (36615, '65.50.15604870731769895', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.64.17.117', '2019-06-14 12:37:53', 8, 0, '', '2019-06-14 12:37:53');
INSERT INTO `access_log` VALUES (36616, '65.52.15604871305179899', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 12:38:51', 0, 1002001015, '账号未登陆', '2019-06-14 12:38:51');
INSERT INTO `access_log` VALUES (36617, '65.46.15604871305179891', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 12:38:51', 0, 1002001015, '账号未登陆', '2019-06-14 12:38:51');
INSERT INTO `access_log` VALUES (36618, '65.49.15604871305209903', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 12:38:51', 0, 1002001015, '账号未登陆', '2019-06-14 12:38:51');
INSERT INTO `access_log` VALUES (36619, '65.50.15604871367529897', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 12:38:57', 62, 0, '', '2019-06-14 12:38:57');
INSERT INTO `access_log` VALUES (36620, '65.45.15604871371619895', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 12:38:57', 8, 0, '', '2019-06-14 12:38:57');
INSERT INTO `access_log` VALUES (36621, '65.47.15604871371719881', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 12:38:57', 8, 2001001000, '服务端发生异常', '2019-06-14 12:38:57');
INSERT INTO `access_log` VALUES (36622, '65.51.15604871371799911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 12:38:57', 8, 0, '', '2019-06-14 12:38:57');
INSERT INTO `access_log` VALUES (36623, '65.51.15604885904669931', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.18.239.162', '2019-06-14 13:03:10', 0, 1002001015, '账号未登陆', '2019-06-14 13:03:10');
INSERT INTO `access_log` VALUES (36624, '65.45.15604885904659915', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.18.239.162', '2019-06-14 13:03:10', 0, 1002001015, '账号未登陆', '2019-06-14 13:03:10');
INSERT INTO `access_log` VALUES (36625, '65.47.15604885904669901', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.18.239.162', '2019-06-14 13:03:10', 1, 1002001015, '账号未登陆', '2019-06-14 13:03:10');
INSERT INTO `access_log` VALUES (36626, '65.53.15604885938829895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.18.239.162', '2019-06-14 13:03:14', 63, 0, '', '2019-06-14 13:03:14');
INSERT INTO `access_log` VALUES (36627, '65.54.15604885942569867', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.18.239.162', '2019-06-14 13:03:14', 151, 0, '', '2019-06-14 13:03:14');
INSERT INTO `access_log` VALUES (36628, '65.46.15604885942579913', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.18.239.162', '2019-06-14 13:03:14', 154, 0, '', '2019-06-14 13:03:14');
INSERT INTO `access_log` VALUES (36629, '65.52.15604885942579921', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.18.239.162', '2019-06-14 13:03:14', 153, 2001001000, '服务端发生异常', '2019-06-14 13:03:14');
INSERT INTO `access_log` VALUES (36630, '65.54.15604894597939879', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-14 13:17:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 13:17:40');
INSERT INTO `access_log` VALUES (36631, '59.79.15604908885259347', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:29', 11, 0, '', '2019-06-14 13:41:29');
INSERT INTO `access_log` VALUES (36632, '59.76.15604908885279339', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:29', 13, 2001001000, '服务端发生异常', '2019-06-14 13:41:29');
INSERT INTO `access_log` VALUES (36633, '64.82.15604908927789281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:33', 11, 0, '', '2019-06-14 13:41:33');
INSERT INTO `access_log` VALUES (36634, '64.76.15604908928689267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:33', 3, 0, '', '2019-06-14 13:41:33');
INSERT INTO `access_log` VALUES (36635, '64.85.15604908943919287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:34', 1, 0, '', '2019-06-14 13:41:34');
INSERT INTO `access_log` VALUES (36636, '64.79.15604908950799271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:35', 1, 0, '', '2019-06-14 13:41:35');
INSERT INTO `access_log` VALUES (36637, '64.80.15604908956319277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:36', 2, 0, '', '2019-06-14 13:41:36');
INSERT INTO `access_log` VALUES (36638, '64.83.15604908959529265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:36', 3, 0, '', '2019-06-14 13:41:36');
INSERT INTO `access_log` VALUES (36639, '59.71.15604908970289347', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:37', 3, 0, '', '2019-06-14 13:41:37');
INSERT INTO `access_log` VALUES (36640, '59.78.15604908970299343', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:37', 14, 2001001000, '服务端发生异常', '2019-06-14 13:41:37');
INSERT INTO `access_log` VALUES (36641, '64.78.15604908992839279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:39', 2, 0, '', '2019-06-14 13:41:39');
INSERT INTO `access_log` VALUES (36642, '64.84.15604908993689277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:39', 2, 0, '', '2019-06-14 13:41:39');
INSERT INTO `access_log` VALUES (36643, '64.77.15604909003059283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:40', 1, 0, '', '2019-06-14 13:41:40');
INSERT INTO `access_log` VALUES (36644, '64.82.15604909006639283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:41', 1, 0, '', '2019-06-14 13:41:41');
INSERT INTO `access_log` VALUES (36645, '59.80.15604909016579333', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:42', 2, 0, '', '2019-06-14 13:41:42');
INSERT INTO `access_log` VALUES (36646, '59.73.15604909016579347', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:42', 12, 2001001000, '服务端发生异常', '2019-06-14 13:41:42');
INSERT INTO `access_log` VALUES (36647, '65.45.15604909138879947', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:54', 1, 1002001015, '账号未登陆', '2019-06-14 13:41:54');
INSERT INTO `access_log` VALUES (36648, '65.53.15604909138889927', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:54', 1, 1002001015, '账号未登陆', '2019-06-14 13:41:54');
INSERT INTO `access_log` VALUES (36649, '65.52.15604909138889953', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:54', 1, 1002001015, '账号未登陆', '2019-06-14 13:41:54');
INSERT INTO `access_log` VALUES (36650, '65.46.15604909177249945', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:58', 92, 0, '', '2019-06-14 13:41:58');
INSERT INTO `access_log` VALUES (36651, '65.49.15604909179929957', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:58', 11, 0, '', '2019-06-14 13:41:58');
INSERT INTO `access_log` VALUES (36652, '65.50.15604909179989951', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:58', 10, 0, '', '2019-06-14 13:41:58');
INSERT INTO `access_log` VALUES (36653, '65.3607.15604909179971705', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.84.100', '2019-06-14 13:41:58', 11, 2001001000, '服务端发生异常', '2019-06-14 13:41:58');
INSERT INTO `access_log` VALUES (36654, '65.47.15604912160299939', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-14 13:46:56', 4, 1002001012, '访问令牌已过期', '2019-06-14 13:46:56');
INSERT INTO `access_log` VALUES (36655, '65.51.15604912175129969', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-14 13:46:58', 67, 0, '', '2019-06-14 13:46:58');
INSERT INTO `access_log` VALUES (36656, '65.54.15604912177889905', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-14 13:46:58', 171, 0, '', '2019-06-14 13:46:58');
INSERT INTO `access_log` VALUES (36657, '65.53.15604912177909933', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-14 13:46:58', 171, 0, '', '2019-06-14 13:46:58');
INSERT INTO `access_log` VALUES (36658, '65.45.15604912177949953', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-14 13:46:58', 168, 0, '', '2019-06-14 13:46:58');
INSERT INTO `access_log` VALUES (36659, '65.52.15604912205659959', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.137.52.91', '2019-06-14 13:47:01', 62, 0, '', '2019-06-14 13:47:01');
INSERT INTO `access_log` VALUES (36660, '59.75.15604918739199363', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.64.17.183', '2019-06-14 13:57:54', 3, 0, '', '2019-06-14 13:57:54');
INSERT INTO `access_log` VALUES (36661, '59.78.15604918739379357', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.64.17.183', '2019-06-14 13:57:54', 13, 2001001000, '服务端发生异常', '2019-06-14 13:57:54');
INSERT INTO `access_log` VALUES (36662, '64.77.15604922152639301', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-14 14:03:35', 11, 1002001012, '访问令牌已过期', '2019-06-14 14:03:35');
INSERT INTO `access_log` VALUES (36663, '64.84.15604922152639295', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.235.82.145', '2019-06-14 14:03:35', 11, 1002001012, '访问令牌已过期', '2019-06-14 14:03:35');
INSERT INTO `access_log` VALUES (36664, '59.74.15604927084699365', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.248.56.50', '2019-06-14 14:11:48', 3, 0, '', '2019-06-14 14:11:48');
INSERT INTO `access_log` VALUES (36665, '59.79.15604927084709373', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.248.56.50', '2019-06-14 14:11:48', 11, 2001001000, '服务端发生异常', '2019-06-14 14:11:48');
INSERT INTO `access_log` VALUES (36666, '64.80.15604927341169303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.248.56.50', '2019-06-14 14:12:14', 11, 0, '', '2019-06-14 14:12:14');
INSERT INTO `access_log` VALUES (36667, '64.83.15604927342329291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.248.56.50', '2019-06-14 14:12:14', 3, 0, '', '2019-06-14 14:12:14');
INSERT INTO `access_log` VALUES (36668, '64.78.15604927354219305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.248.56.50', '2019-06-14 14:12:15', 2, 0, '', '2019-06-14 14:12:15');
INSERT INTO `access_log` VALUES (36669, '64.77.15604927359199309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.248.56.50', '2019-06-14 14:12:16', 2, 0, '', '2019-06-14 14:12:16');
INSERT INTO `access_log` VALUES (36670, '64.84.15604927363009303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.248.56.50', '2019-06-14 14:12:16', 2, 0, '', '2019-06-14 14:12:16');
INSERT INTO `access_log` VALUES (36671, '64.82.15604927367389309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.248.56.50', '2019-06-14 14:12:17', 2, 0, '', '2019-06-14 14:12:17');
INSERT INTO `access_log` VALUES (36672, '59.75.15604927378619375', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.248.56.50', '2019-06-14 14:12:18', 2, 0, '', '2019-06-14 14:12:18');
INSERT INTO `access_log` VALUES (36673, '59.71.15604927378629373', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.248.56.50', '2019-06-14 14:12:18', 13, 2001001000, '服务端发生异常', '2019-06-14 14:12:18');
INSERT INTO `access_log` VALUES (36674, '64.76.15604927401469295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.248.56.50', '2019-06-14 14:12:20', 2, 0, '', '2019-06-14 14:12:20');
INSERT INTO `access_log` VALUES (36675, '64.85.15604927403139315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.248.56.50', '2019-06-14 14:12:20', 2, 0, '', '2019-06-14 14:12:20');
INSERT INTO `access_log` VALUES (36676, '59.73.15604927413589373', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.248.56.50', '2019-06-14 14:12:21', 3, 0, '', '2019-06-14 14:12:21');
INSERT INTO `access_log` VALUES (36677, '59.77.15604927413589357', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.248.56.50', '2019-06-14 14:12:21', 13, 2001001000, '服务端发生异常', '2019-06-14 14:12:21');
INSERT INTO `access_log` VALUES (36678, '65.49.15604929023669985', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.128.100.88', '2019-06-14 14:15:02', 1, 1002001015, '账号未登陆', '2019-06-14 14:15:02');
INSERT INTO `access_log` VALUES (36679, '65.3607.15604929023671733', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.128.100.88', '2019-06-14 14:15:02', 0, 1002001015, '账号未登陆', '2019-06-14 14:15:02');
INSERT INTO `access_log` VALUES (36680, '65.47.15604929023719963', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.128.100.88', '2019-06-14 14:15:02', 1, 1002001015, '账号未登陆', '2019-06-14 14:15:02');
INSERT INTO `access_log` VALUES (36681, '65.51.15604929057269993', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.128.100.88', '2019-06-14 14:15:06', 63, 0, '', '2019-06-14 14:15:06');
INSERT INTO `access_log` VALUES (36682, '65.45.15604929060209977', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.128.100.88', '2019-06-14 14:15:06', 9, 0, '', '2019-06-14 14:15:06');
INSERT INTO `access_log` VALUES (36683, '65.54.15604929060229929', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.128.100.88', '2019-06-14 14:15:06', 11, 2001001000, '服务端发生异常', '2019-06-14 14:15:06');
INSERT INTO `access_log` VALUES (36684, '65.53.15604929060269957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.128.100.88', '2019-06-14 14:15:06', 9, 0, '', '2019-06-14 14:15:06');
INSERT INTO `access_log` VALUES (36685, '65.47.15604929816739965', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-14 14:16:22', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 14:16:22');
INSERT INTO `access_log` VALUES (36686, '59.77.15604930159359361', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.90.206.203', '2019-06-14 14:16:56', 3, 0, '', '2019-06-14 14:16:56');
INSERT INTO `access_log` VALUES (36687, '59.73.15604930159499377', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.90.206.203', '2019-06-14 14:16:56', 13, 2001001000, '服务端发生异常', '2019-06-14 14:16:56');
INSERT INTO `access_log` VALUES (36688, '59.78.15604930752589375', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.163', '2019-06-14 14:17:55', 13, 2001001000, '服务端发生异常', '2019-06-14 14:17:55');
INSERT INTO `access_log` VALUES (36689, '59.75.15604930769819381', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.129.6.147', '2019-06-14 14:17:57', 3, 0, '', '2019-06-14 14:17:57');
INSERT INTO `access_log` VALUES (36690, '65.51.15604934283010001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '103.208.15.203', '2019-06-14 14:23:48', 121, 0, '', '2019-06-14 14:23:48');
INSERT INTO `access_log` VALUES (36691, '65.45.15604934293579985', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '103.208.15.203', '2019-06-14 14:23:49', 8, 0, '', '2019-06-14 14:23:49');
INSERT INTO `access_log` VALUES (36692, '65.53.15604934293809965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '103.208.15.203', '2019-06-14 14:23:49', 8, 0, '', '2019-06-14 14:23:49');
INSERT INTO `access_log` VALUES (36693, '65.54.15604934293799937', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '103.208.15.203', '2019-06-14 14:23:49', 9, 2001001000, '服务端发生异常', '2019-06-14 14:23:49');
INSERT INTO `access_log` VALUES (36694, '59.79.15604934590949385', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '103.208.15.203', '2019-06-14 14:24:19', 3, 0, '', '2019-06-14 14:24:19');
INSERT INTO `access_log` VALUES (36695, '59.76.15604934590959377', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '103.208.15.203', '2019-06-14 14:24:19', 13, 2001001000, '服务端发生异常', '2019-06-14 14:24:19');
INSERT INTO `access_log` VALUES (36696, '65.3607.15604934755471743', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '103.208.15.203', '2019-06-14 14:24:36', 9, 0, '', '2019-06-14 14:24:36');
INSERT INTO `access_log` VALUES (36697, '65.49.15604934755609995', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '103.208.15.203', '2019-06-14 14:24:36', 8, 0, '', '2019-06-14 14:24:36');
INSERT INTO `access_log` VALUES (36698, '65.47.15604934755619973', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '103.208.15.203', '2019-06-14 14:24:36', 10, 2001001000, '服务端发生异常', '2019-06-14 14:24:36');
INSERT INTO `access_log` VALUES (36699, '65.53.15604934904509967', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '103.208.15.203', '2019-06-14 14:24:50', 75, 0, '', '2019-06-14 14:24:51');
INSERT INTO `access_log` VALUES (36700, '65.3607.15604935541861745', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-14 14:25:54', 74, 0, '', '2019-06-14 14:25:54');
INSERT INTO `access_log` VALUES (36701, '65.49.15604935549789997', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-14 14:25:55', 9, 0, '', '2019-06-14 14:25:55');
INSERT INTO `access_log` VALUES (36702, '65.47.15604935549809975', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-14 14:25:55', 11, 2001001000, '服务端发生异常', '2019-06-14 14:25:55');
INSERT INTO `access_log` VALUES (36703, '65.51.15604935549820005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-14 14:25:55', 10, 0, '', '2019-06-14 14:25:55');
INSERT INTO `access_log` VALUES (36704, '59.80.15604939661289377', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:32:46', 3, 0, '', '2019-06-14 14:32:46');
INSERT INTO `access_log` VALUES (36705, '59.77.15604939661289375', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:32:46', 19, 2001001000, '服务端发生异常', '2019-06-14 14:32:46');
INSERT INTO `access_log` VALUES (36706, '64.80.15604939701239321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:32:50', 4, 0, '', '2019-06-14 14:32:50');
INSERT INTO `access_log` VALUES (36707, '64.83.15604939702359309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:32:50', 2, 0, '', '2019-06-14 14:32:50');
INSERT INTO `access_log` VALUES (36708, '64.77.15604939714239327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:32:51', 2, 0, '', '2019-06-14 14:32:51');
INSERT INTO `access_log` VALUES (36709, '64.84.15604939719309321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:32:52', 2, 0, '', '2019-06-14 14:32:52');
INSERT INTO `access_log` VALUES (36710, '59.72.15604939727979387', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:32:53', 2, 0, '', '2019-06-14 14:32:53');
INSERT INTO `access_log` VALUES (36711, '59.74.15604939727979385', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:32:53', 12, 2001001000, '服务端发生异常', '2019-06-14 14:32:53');
INSERT INTO `access_log` VALUES (36712, '64.82.15604939748369327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:32:55', 2, 0, '', '2019-06-14 14:32:55');
INSERT INTO `access_log` VALUES (36713, '64.76.15604939749499313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:32:55', 2, 0, '', '2019-06-14 14:32:55');
INSERT INTO `access_log` VALUES (36714, '66.53.15604939938997785', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13629583007&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:14', 17, 1001003000, '验证码不存在', '2019-06-14 14:33:14');
INSERT INTO `access_log` VALUES (36715, '66.55.15604939960697781', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13629583007', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:16', 94, 0, '', '2019-06-14 14:33:16');
INSERT INTO `access_log` VALUES (36716, '66.51.15604939982077789', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13629583007&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:18', 152, 0, '', '2019-06-14 14:33:18');
INSERT INTO `access_log` VALUES (36717, '64.80.15604940032319323', 124, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:23', 4, 0, '', '2019-06-14 14:33:23');
INSERT INTO `access_log` VALUES (36718, '64.78.15604940034109325', 124, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:23', 7, 0, '', '2019-06-14 14:33:23');
INSERT INTO `access_log` VALUES (36719, '66.49.15604940047487795', 124, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:25', 6, 0, '', '2019-06-14 14:33:25');
INSERT INTO `access_log` VALUES (36720, '66.52.15604940064637793', 124, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:26', 6, 0, '', '2019-06-14 14:33:26');
INSERT INTO `access_log` VALUES (36721, '66.57.15604940087497789', 124, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:29', 6, 0, '', '2019-06-14 14:33:29');
INSERT INTO `access_log` VALUES (36722, '64.77.15604940126079329', 124, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:33', 7, 0, '', '2019-06-14 14:33:33');
INSERT INTO `access_log` VALUES (36723, '64.84.15604940128479323', 124, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:33', 7, 0, '', '2019-06-14 14:33:33');
INSERT INTO `access_log` VALUES (36724, '59.80.15604940137379379', 124, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:34', 9, 0, '', '2019-06-14 14:33:34');
INSERT INTO `access_log` VALUES (36725, '59.71.15604940137379393', 124, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:34', 21, 2001001000, '服务端发生异常', '2019-06-14 14:33:34');
INSERT INTO `access_log` VALUES (36726, '65.54.15604940236329947', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:44', 1, 1002001015, '账号未登陆', '2019-06-14 14:33:44');
INSERT INTO `access_log` VALUES (36727, '65.45.15604940236349995', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:44', 0, 1002001015, '账号未登陆', '2019-06-14 14:33:44');
INSERT INTO `access_log` VALUES (36728, '65.52.15604940236380001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:44', 1, 1002001015, '账号未登陆', '2019-06-14 14:33:44');
INSERT INTO `access_log` VALUES (36729, '65.46.15604940317699993', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 14:33:52');
INSERT INTO `access_log` VALUES (36730, '65.3607.15604940391211753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:33:59', 90, 0, '', '2019-06-14 14:33:59');
INSERT INTO `access_log` VALUES (36731, '65.49.15604940395310005', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:34:00', 10, 0, '', '2019-06-14 14:34:00');
INSERT INTO `access_log` VALUES (36732, '65.47.15604940395339983', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:34:00', 10, 2001001000, '服务端发生异常', '2019-06-14 14:34:00');
INSERT INTO `access_log` VALUES (36733, '65.51.15604940395380013', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:34:00', 9, 0, '', '2019-06-14 14:34:00');
INSERT INTO `access_log` VALUES (36734, '65.45.15604940556389997', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:34:16', 24, 0, '', '2019-06-14 14:34:16');
INSERT INTO `access_log` VALUES (36735, '65.52.15604940556430003', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:34:16', 19, 0, '', '2019-06-14 14:34:16');
INSERT INTO `access_log` VALUES (36736, '65.54.15604940556429949', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:34:16', 21, 2001001000, '服务端发生异常', '2019-06-14 14:34:16');
INSERT INTO `access_log` VALUES (36737, '65.46.15604940582449995', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:34:18', 9, 0, '', '2019-06-14 14:34:18');
INSERT INTO `access_log` VALUES (36738, '65.3607.15604940582451755', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:34:18', 9, 0, '', '2019-06-14 14:34:18');
INSERT INTO `access_log` VALUES (36739, '65.50.15604940582450001', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.24.67.123', '2019-06-14 14:34:18', 10, 2001001000, '服务端发生异常', '2019-06-14 14:34:18');
INSERT INTO `access_log` VALUES (36740, '59.80.15604945815719387', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 14:43:02', 3, 0, '', '2019-06-14 14:43:02');
INSERT INTO `access_log` VALUES (36741, '59.71.15604945815719401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 14:43:02', 12, 2001001000, '服务端发生异常', '2019-06-14 14:43:02');
INSERT INTO `access_log` VALUES (36742, '65.50.15604946254520009', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-14 14:43:45', 10, 0, '', '2019-06-14 14:43:45');
INSERT INTO `access_log` VALUES (36743, '65.3607.15604946254521763', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-14 14:43:45', 12, 2001001000, '服务端发生异常', '2019-06-14 14:43:45');
INSERT INTO `access_log` VALUES (36744, '65.47.15604946254559993', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-14 14:43:45', 9, 0, '', '2019-06-14 14:43:45');
INSERT INTO `access_log` VALUES (36745, '65.52.15604951554090019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-14 14:52:35', 75, 0, '', '2019-06-14 14:52:35');
INSERT INTO `access_log` VALUES (36746, '65.46.15604951557210011', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-14 14:52:36', 8, 0, '', '2019-06-14 14:52:36');
INSERT INTO `access_log` VALUES (36747, '65.47.15604951557250001', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-14 14:52:36', 11, 2001001000, '服务端发生异常', '2019-06-14 14:52:36');
INSERT INTO `access_log` VALUES (36748, '65.3607.15604951557351771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-14 14:52:36', 9, 0, '', '2019-06-14 14:52:36');
INSERT INTO `access_log` VALUES (36749, '64.80.15604952765879341', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:54:37', 9, 1002001012, '访问令牌已过期', '2019-06-14 14:54:37');
INSERT INTO `access_log` VALUES (36750, '65.3607.15604952795591773', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:54:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 14:54:40');
INSERT INTO `access_log` VALUES (36751, '65.50.15604952840750019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:54:44', 61, 0, '', '2019-06-14 14:54:44');
INSERT INTO `access_log` VALUES (36752, '65.53.15604952844459997', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:54:44', 7, 0, '', '2019-06-14 14:54:44');
INSERT INTO `access_log` VALUES (36753, '65.51.15604952844420033', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:54:44', 8, 0, '', '2019-06-14 14:54:44');
INSERT INTO `access_log` VALUES (36754, '65.49.15604952844430025', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:54:44', 9, 2001001000, '服务端发生异常', '2019-06-14 14:54:44');
INSERT INTO `access_log` VALUES (36755, '65.45.15604952926010017', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:54:53', 8, 0, '', '2019-06-14 14:54:53');
INSERT INTO `access_log` VALUES (36756, '65.54.15604952926049969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:54:53', 11, 2001001000, '服务端发生异常', '2019-06-14 14:54:53');
INSERT INTO `access_log` VALUES (36757, '65.52.15604952926090023', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:54:53', 9, 0, '', '2019-06-14 14:54:53');
INSERT INTO `access_log` VALUES (36758, '65.47.15604953012770005', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:55:01', 8, 0, '', '2019-06-14 14:55:01');
INSERT INTO `access_log` VALUES (36759, '65.3607.15604953012781775', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:55:01', 10, 2001001000, '服务端发生异常', '2019-06-14 14:55:01');
INSERT INTO `access_log` VALUES (36760, '65.50.15604953012810021', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:55:01', 8, 0, '', '2019-06-14 14:55:01');
INSERT INTO `access_log` VALUES (36761, '65.49.15604953072650027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:55:07', 15, 2001001000, '服务端发生异常', '2019-06-14 14:55:07');
INSERT INTO `access_log` VALUES (36762, '65.53.15604953072659999', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:55:07', 16, 0, '', '2019-06-14 14:55:07');
INSERT INTO `access_log` VALUES (36763, '65.51.15604953072620035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:55:07', 9, 0, '', '2019-06-14 14:55:07');
INSERT INTO `access_log` VALUES (36764, '65.52.15604953242570025', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:55:24', 9, 0, '', '2019-06-14 14:55:24');
INSERT INTO `access_log` VALUES (36765, '65.50.15604953242580023', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:55:24', 8, 0, '', '2019-06-14 14:55:24');
INSERT INTO `access_log` VALUES (36766, '65.46.15604953242580017', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:55:24', 9, 2001001000, '服务端发生异常', '2019-06-14 14:55:24');
INSERT INTO `access_log` VALUES (36767, '65.47.15604953430950007', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:55:43', 8, 0, '', '2019-06-14 14:55:43');
INSERT INTO `access_log` VALUES (36768, '65.51.15604953430980037', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:55:43', 9, 2001001000, '服务端发生异常', '2019-06-14 14:55:43');
INSERT INTO `access_log` VALUES (36769, '65.49.15604953431010029', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '210.83.240.178', '2019-06-14 14:55:43', 8, 0, '', '2019-06-14 14:55:43');
INSERT INTO `access_log` VALUES (36770, '65.50.15604958368980031', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:03:57', 0, 1002001015, '账号未登陆', '2019-06-14 15:03:57');
INSERT INTO `access_log` VALUES (36771, '65.52.15604958369020033', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:03:57', 1, 1002001015, '账号未登陆', '2019-06-14 15:03:57');
INSERT INTO `access_log` VALUES (36772, '65.46.15604958369070025', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:03:57', 0, 1002001015, '账号未登陆', '2019-06-14 15:03:57');
INSERT INTO `access_log` VALUES (36773, '65.3607.15604958415301785', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:04:02', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 15:04:02');
INSERT INTO `access_log` VALUES (36774, '65.47.15604958450770015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:04:05', 92, 0, '', '2019-06-14 15:04:05');
INSERT INTO `access_log` VALUES (36775, '65.51.15604958457430045', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:04:06', 10, 0, '', '2019-06-14 15:04:06');
INSERT INTO `access_log` VALUES (36776, '65.53.15604958457440009', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:04:06', 10, 0, '', '2019-06-14 15:04:06');
INSERT INTO `access_log` VALUES (36777, '65.49.15604958457440037', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:04:06', 12, 2001001000, '服务端发生异常', '2019-06-14 15:04:06');
INSERT INTO `access_log` VALUES (36778, '65.46.15604958742820027', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:04:34', 15, 0, '', '2019-06-14 15:04:34');
INSERT INTO `access_log` VALUES (36779, '65.50.15604958742830033', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:04:34', 17, 2001001000, '服务端发生异常', '2019-06-14 15:04:34');
INSERT INTO `access_log` VALUES (36780, '65.52.15604958742910035', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:04:34', 8, 0, '', '2019-06-14 15:04:34');
INSERT INTO `access_log` VALUES (36781, '65.47.15604958844450017', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:04:44', 10, 0, '', '2019-06-14 15:04:44');
INSERT INTO `access_log` VALUES (36782, '65.49.15604958844520039', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:04:44', 9, 0, '', '2019-06-14 15:04:44');
INSERT INTO `access_log` VALUES (36783, '65.51.15604958844520047', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:04:44', 10, 2001001000, '服务端发生异常', '2019-06-14 15:04:44');
INSERT INTO `access_log` VALUES (36784, '65.53.15604958846590011', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:04:45', 9, 0, '', '2019-06-14 15:04:45');
INSERT INTO `access_log` VALUES (36785, '65.45.15604958846600031', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:04:45', 10, 2001001000, '服务端发生异常', '2019-06-14 15:04:45');
INSERT INTO `access_log` VALUES (36786, '65.54.15604958846639983', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.77.192.254', '2019-06-14 15:04:45', 9, 0, '', '2019-06-14 15:04:45');
INSERT INTO `access_log` VALUES (36787, '65.53.15604959887410013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-14 15:06:29', 1103, 0, '', '2019-06-14 15:06:30');
INSERT INTO `access_log` VALUES (36788, '65.45.15604959901150033', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-14 15:06:30', 9, 0, '', '2019-06-14 15:06:30');
INSERT INTO `access_log` VALUES (36789, '65.54.15604959901219985', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-14 15:06:30', 9, 2001001000, '服务端发生异常', '2019-06-14 15:06:30');
INSERT INTO `access_log` VALUES (36790, '65.50.15604959901300037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-14 15:06:30', 9, 0, '', '2019-06-14 15:06:30');
INSERT INTO `access_log` VALUES (36791, '59.76.15604959995519413', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '180.169.25.162', '2019-06-14 15:06:40', 2, 0, '', '2019-06-14 15:06:40');
INSERT INTO `access_log` VALUES (36792, '59.78.15604959995679417', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '180.169.25.162', '2019-06-14 15:06:40', 12, 2001001000, '服务端发生异常', '2019-06-14 15:06:40');
INSERT INTO `access_log` VALUES (36793, '64.81.15604960058439351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '180.169.25.162', '2019-06-14 15:06:46', 10, 0, '', '2019-06-14 15:06:46');
INSERT INTO `access_log` VALUES (36794, '64.80.15604960059619351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '180.169.25.162', '2019-06-14 15:06:46', 2, 0, '', '2019-06-14 15:06:46');
INSERT INTO `access_log` VALUES (36795, '64.83.15604960080339339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '180.169.25.162', '2019-06-14 15:06:48', 2, 0, '', '2019-06-14 15:06:48');
INSERT INTO `access_log` VALUES (36796, '59.71.15604960098089421', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '180.169.25.162', '2019-06-14 15:06:50', 2, 0, '', '2019-06-14 15:06:50');
INSERT INTO `access_log` VALUES (36797, '59.80.15604960098109407', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '180.169.25.162', '2019-06-14 15:06:50', 12, 2001001000, '服务端发生异常', '2019-06-14 15:06:50');
INSERT INTO `access_log` VALUES (36798, '59.74.15604960598479415', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.129.6.151', '2019-06-14 15:07:40', 2, 0, '', '2019-06-14 15:07:40');
INSERT INTO `access_log` VALUES (36799, '64.76.15604960667939343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.178.236', '2019-06-14 15:07:47', 5, 0, '', '2019-06-14 15:07:47');
INSERT INTO `access_log` VALUES (36800, '59.79.15604960670309423', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.89.239.238', '2019-06-14 15:07:47', 13, 2001001000, '服务端发生异常', '2019-06-14 15:07:47');
INSERT INTO `access_log` VALUES (36801, '64.85.15604960674179363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.129.6.251', '2019-06-14 15:07:47', 2, 0, '', '2019-06-14 15:07:47');
INSERT INTO `access_log` VALUES (36802, '65.47.15604960685410021', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.62.130', '2019-06-14 15:07:49', 0, 1002001015, '账号未登陆', '2019-06-14 15:07:49');
INSERT INTO `access_log` VALUES (36803, '65.53.15604960685430015', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.62.130', '2019-06-14 15:07:49', 0, 1002001015, '账号未登陆', '2019-06-14 15:07:49');
INSERT INTO `access_log` VALUES (36804, '65.45.15604960685480035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.62.130', '2019-06-14 15:07:49', 0, 1002001015, '账号未登陆', '2019-06-14 15:07:49');
INSERT INTO `access_log` VALUES (36805, '59.75.15604960728969425', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.62.130', '2019-06-14 15:07:53', 3, 0, '', '2019-06-14 15:07:53');
INSERT INTO `access_log` VALUES (36806, '59.76.15604960728969415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.62.130', '2019-06-14 15:07:53', 21, 2001001000, '服务端发生异常', '2019-06-14 15:07:53');
INSERT INTO `access_log` VALUES (36807, '64.78.15604961157109355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '124.204.62.130', '2019-06-14 15:08:36', 2, 0, '', '2019-06-14 15:08:36');
INSERT INTO `access_log` VALUES (36808, '64.77.15604961158239359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '124.204.62.130', '2019-06-14 15:08:36', 2, 0, '', '2019-06-14 15:08:36');
INSERT INTO `access_log` VALUES (36809, '64.84.15604961174539353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '124.204.62.130', '2019-06-14 15:08:37', 1, 0, '', '2019-06-14 15:08:37');
INSERT INTO `access_log` VALUES (36810, '64.82.15604961183359359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '124.204.62.130', '2019-06-14 15:08:38', 1, 0, '', '2019-06-14 15:08:38');
INSERT INTO `access_log` VALUES (36811, '59.73.15604961198299423', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '124.204.62.130', '2019-06-14 15:08:40', 3, 0, '', '2019-06-14 15:08:40');
INSERT INTO `access_log` VALUES (36812, '59.72.15604961198299419', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '124.204.62.130', '2019-06-14 15:08:40', 19, 2001001000, '服务端发生异常', '2019-06-14 15:08:40');
INSERT INTO `access_log` VALUES (36813, '65.3607.15604961229421793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.62.130', '2019-06-14 15:08:43', 69, 0, '', '2019-06-14 15:08:43');
INSERT INTO `access_log` VALUES (36814, '65.51.15604961232790053', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.62.130', '2019-06-14 15:08:43', 10, 0, '', '2019-06-14 15:08:43');
INSERT INTO `access_log` VALUES (36815, '65.49.15604961232790045', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.62.130', '2019-06-14 15:08:43', 11, 2001001000, '服务端发生异常', '2019-06-14 15:08:43');
INSERT INTO `access_log` VALUES (36816, '65.45.15604961232810037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.62.130', '2019-06-14 15:08:43', 10, 0, '', '2019-06-14 15:08:43');
INSERT INTO `access_log` VALUES (36817, '65.53.15604961250410017', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:08:45', 3, 1002001012, '访问令牌已过期', '2019-06-14 15:08:45');
INSERT INTO `access_log` VALUES (36818, '65.47.15604961250510023', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:08:45', 2, 1002001012, '访问令牌已过期', '2019-06-14 15:08:45');
INSERT INTO `access_log` VALUES (36819, '65.54.15604961250719989', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:08:45', 3, 1002001012, '访问令牌已过期', '2019-06-14 15:08:45');
INSERT INTO `access_log` VALUES (36820, '65.50.15604961295510041', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:08:50', 104, 0, '', '2019-06-14 15:08:50');
INSERT INTO `access_log` VALUES (36821, '65.46.15604961298730035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:08:50', 9, 0, '', '2019-06-14 15:08:50');
INSERT INTO `access_log` VALUES (36822, '65.52.15604961298770043', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:08:50', 10, 2001001000, '服务端发生异常', '2019-06-14 15:08:50');
INSERT INTO `access_log` VALUES (36823, '65.3607.15604961298801795', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:08:50', 9, 0, '', '2019-06-14 15:08:50');
INSERT INTO `access_log` VALUES (36824, '64.85.15604961377529365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '124.204.62.130', '2019-06-14 15:08:58', 2, 0, '', '2019-06-14 15:08:58');
INSERT INTO `access_log` VALUES (36825, '64.79.15604961378639349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '124.204.62.130', '2019-06-14 15:08:58', 2, 0, '', '2019-06-14 15:08:58');
INSERT INTO `access_log` VALUES (36826, '59.79.15604961394199425', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '124.204.62.130', '2019-06-14 15:08:59', 2, 0, '', '2019-06-14 15:08:59');
INSERT INTO `access_log` VALUES (36827, '59.78.15604961394219421', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '124.204.62.130', '2019-06-14 15:08:59', 13, 2001001000, '服务端发生异常', '2019-06-14 15:08:59');
INSERT INTO `access_log` VALUES (36828, '65.45.15604961556780039', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-14 15:09:16', 9, 0, '', '2019-06-14 15:09:16');
INSERT INTO `access_log` VALUES (36829, '65.54.15604961556829991', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-14 15:09:16', 9, 2001001000, '服务端发生异常', '2019-06-14 15:09:16');
INSERT INTO `access_log` VALUES (36830, '65.53.15604961556860019', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.88.197.124', '2019-06-14 15:09:16', 9, 0, '', '2019-06-14 15:09:16');
INSERT INTO `access_log` VALUES (36831, '65.46.15604961848310037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:09:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 15:09:45');
INSERT INTO `access_log` VALUES (36832, '65.3607.15604961913311797', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:09:51', 61, 0, '', '2019-06-14 15:09:51');
INSERT INTO `access_log` VALUES (36833, '65.52.15604961916510045', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:09:52', 9, 0, '', '2019-06-14 15:09:52');
INSERT INTO `access_log` VALUES (36834, '65.51.15604961916650057', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:09:52', 9, 2001001000, '服务端发生异常', '2019-06-14 15:09:52');
INSERT INTO `access_log` VALUES (36835, '65.49.15604961916680049', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:09:52', 9, 0, '', '2019-06-14 15:09:52');
INSERT INTO `access_log` VALUES (36836, '59.72.15604962069629421', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:10:07', 3, 0, '', '2019-06-14 15:10:07');
INSERT INTO `access_log` VALUES (36837, '59.73.15604962069629425', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:10:07', 20, 2001001000, '服务端发生异常', '2019-06-14 15:10:07');
INSERT INTO `access_log` VALUES (36838, '65.45.15604962148350041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:10:15', 9, 0, '', '2019-06-14 15:10:15');
INSERT INTO `access_log` VALUES (36839, '65.50.15604962148410045', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:10:15', 8, 0, '', '2019-06-14 15:10:15');
INSERT INTO `access_log` VALUES (36840, '65.47.15604962148410027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:10:15', 10, 2001001000, '服务端发生异常', '2019-06-14 15:10:15');
INSERT INTO `access_log` VALUES (36841, '65.46.15604962234360039', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:10:23', 9, 0, '', '2019-06-14 15:10:23');
INSERT INTO `access_log` VALUES (36842, '65.3607.15604962234401799', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:10:23', 9, 2001001000, '服务端发生异常', '2019-06-14 15:10:23');
INSERT INTO `access_log` VALUES (36843, '65.49.15604962234470051', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:10:23', 9, 0, '', '2019-06-14 15:10:23');
INSERT INTO `access_log` VALUES (36844, '64.76.15604962382289347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:10:38', 2, 0, '', '2019-06-14 15:10:38');
INSERT INTO `access_log` VALUES (36845, '64.85.15604962383119367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:10:38', 2, 0, '', '2019-06-14 15:10:38');
INSERT INTO `access_log` VALUES (36846, '64.79.15604962392909351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:10:39', 2, 0, '', '2019-06-14 15:10:39');
INSERT INTO `access_log` VALUES (36847, '64.81.15604962397399357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:10:40', 1, 0, '', '2019-06-14 15:10:40');
INSERT INTO `access_log` VALUES (36848, '64.80.15604962402399357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.67.245.152', '2019-06-14 15:10:40', 2, 0, '', '2019-06-14 15:10:40');
INSERT INTO `access_log` VALUES (36849, '65.50.15604964366480049', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.232.139.254', '2019-06-14 15:13:57', 0, 1002001015, '账号未登陆', '2019-06-14 15:13:57');
INSERT INTO `access_log` VALUES (36850, '65.47.15604964366500031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.232.139.254', '2019-06-14 15:13:57', 0, 1002001015, '账号未登陆', '2019-06-14 15:13:57');
INSERT INTO `access_log` VALUES (36851, '65.46.15604964366530043', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.232.139.254', '2019-06-14 15:13:57', 0, 1002001015, '账号未登陆', '2019-06-14 15:13:57');
INSERT INTO `access_log` VALUES (36852, '65.49.15604964387630055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.232.139.254', '2019-06-14 15:13:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 15:13:59');
INSERT INTO `access_log` VALUES (36853, '65.51.15604964517430063', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=youdaoyuanma&password=youdaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.232.139.254', '2019-06-14 15:14:12', 4, 1002002000, '账号不存在', '2019-06-14 15:14:12');
INSERT INTO `access_log` VALUES (36854, '65.54.15604964707689999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.232.139.254', '2019-06-14 15:14:31', 59, 0, '', '2019-06-14 15:14:31');
INSERT INTO `access_log` VALUES (36855, '65.53.15604964710430027', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.232.139.254', '2019-06-14 15:14:31', 9, 0, '', '2019-06-14 15:14:31');
INSERT INTO `access_log` VALUES (36856, '65.45.15604964710450047', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.232.139.254', '2019-06-14 15:14:31', 10, 0, '', '2019-06-14 15:14:31');
INSERT INTO `access_log` VALUES (36857, '65.50.15604964710450051', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.232.139.254', '2019-06-14 15:14:31', 10, 2001001000, '服务端发生异常', '2019-06-14 15:14:31');
INSERT INTO `access_log` VALUES (36858, '65.52.15604989480180085', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 15:55:48', 1, 1002001015, '账号未登陆', '2019-06-14 15:55:48');
INSERT INTO `access_log` VALUES (36859, '65.54.15604989482650033', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 15:55:48', 1, 1002001015, '账号未登陆', '2019-06-14 15:55:48');
INSERT INTO `access_log` VALUES (36860, '65.50.15604989482720085', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 15:55:48', 0, 1002001015, '账号未登陆', '2019-06-14 15:55:48');
INSERT INTO `access_log` VALUES (36861, '65.45.15604989582930081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 15:55:58', 189, 0, '', '2019-06-14 15:55:58');
INSERT INTO `access_log` VALUES (36862, '65.47.15604989590620067', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 15:55:59', 9, 0, '', '2019-06-14 15:55:59');
INSERT INTO `access_log` VALUES (36863, '65.46.15604989590710079', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 15:55:59', 9, 2001001000, '服务端发生异常', '2019-06-14 15:55:59');
INSERT INTO `access_log` VALUES (36864, '65.49.15604989590780091', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.64.17.117', '2019-06-14 15:55:59', 15, 0, '', '2019-06-14 15:55:59');
INSERT INTO `access_log` VALUES (36865, '65.46.15605002878220097', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 16:18:08', 4, 1002001012, '访问令牌已过期', '2019-06-14 16:18:08');
INSERT INTO `access_log` VALUES (36866, '65.3607.15605002878231857', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 16:18:08', 4, 1002001012, '访问令牌已过期', '2019-06-14 16:18:08');
INSERT INTO `access_log` VALUES (36867, '65.49.15605002878220109', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 16:18:08', 4, 1002001012, '访问令牌已过期', '2019-06-14 16:18:08');
INSERT INTO `access_log` VALUES (36868, '65.52.15605002988000105', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 16:18:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 16:18:19');
INSERT INTO `access_log` VALUES (36869, '65.54.15605003032150053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 16:18:23', 124, 0, '', '2019-06-14 16:18:23');
INSERT INTO `access_log` VALUES (36870, '65.50.15605003035420105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 16:18:24', 8, 0, '', '2019-06-14 16:18:24');
INSERT INTO `access_log` VALUES (36871, '65.53.15605003035460081', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 16:18:24', 8, 2001001000, '服务端发生异常', '2019-06-14 16:18:24');
INSERT INTO `access_log` VALUES (36872, '65.45.15605003035470101', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 16:18:24', 7, 0, '', '2019-06-14 16:18:24');
INSERT INTO `access_log` VALUES (36873, '65.49.15605003149800111', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 16:18:35', 8, 0, '', '2019-06-14 16:18:35');
INSERT INTO `access_log` VALUES (36874, '65.46.15605003149840099', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 16:18:35', 10, 2001001000, '服务端发生异常', '2019-06-14 16:18:35');
INSERT INTO `access_log` VALUES (36875, '65.3607.15605003149891859', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 16:18:35', 9, 0, '', '2019-06-14 16:18:35');
INSERT INTO `access_log` VALUES (36876, '65.50.15605013003710123', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '1.192.121.236', '2019-06-14 16:35:00', 0, 1002001015, '账号未登陆', '2019-06-14 16:35:00');
INSERT INTO `access_log` VALUES (36877, '65.45.15605013003710115', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '1.192.121.236', '2019-06-14 16:35:00', 0, 1002001015, '账号未登陆', '2019-06-14 16:35:00');
INSERT INTO `access_log` VALUES (36878, '65.47.15605013003900101', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '1.192.121.236', '2019-06-14 16:35:00', 0, 1002001015, '账号未登陆', '2019-06-14 16:35:00');
INSERT INTO `access_log` VALUES (36879, '65.46.15605013032440113', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '1.192.121.236', '2019-06-14 16:35:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 16:35:03');
INSERT INTO `access_log` VALUES (36880, '65.49.15605013086500127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '1.192.121.236', '2019-06-14 16:35:09', 160, 0, '', '2019-06-14 16:35:09');
INSERT INTO `access_log` VALUES (36881, '65.52.15605013091410121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '1.192.121.236', '2019-06-14 16:35:09', 12, 2001001000, '服务端发生异常', '2019-06-14 16:35:09');
INSERT INTO `access_log` VALUES (36882, '65.51.15605013091400135', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '1.192.121.236', '2019-06-14 16:35:09', 10, 0, '', '2019-06-14 16:35:09');
INSERT INTO `access_log` VALUES (36883, '65.54.15605013091480073', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '1.192.121.236', '2019-06-14 16:35:09', 10, 0, '', '2019-06-14 16:35:09');
INSERT INTO `access_log` VALUES (36884, '65.53.15605013162260099', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '1.192.121.236', '2019-06-14 16:35:16', 11, 0, '', '2019-06-14 16:35:16');
INSERT INTO `access_log` VALUES (36885, '65.45.15605013162280117', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '1.192.121.236', '2019-06-14 16:35:16', 10, 2001001000, '服务端发生异常', '2019-06-14 16:35:16');
INSERT INTO `access_log` VALUES (36886, '65.50.15605013162330125', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '1.192.121.236', '2019-06-14 16:35:16', 8, 0, '', '2019-06-14 16:35:16');
INSERT INTO `access_log` VALUES (36887, '65.53.15605025694070115', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 16:56:09', 11, 0, '', '2019-06-14 16:56:09');
INSERT INTO `access_log` VALUES (36888, '65.50.15605025694070143', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 16:56:09', 11, 0, '', '2019-06-14 16:56:09');
INSERT INTO `access_log` VALUES (36889, '65.46.15605025694090133', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.47.53', '2019-06-14 16:56:09', 10, 2001001000, '服务端发生异常', '2019-06-14 16:56:09');
INSERT INTO `access_log` VALUES (36890, '59.76.15605028782099507', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.131.117.100', '2019-06-14 17:01:18', 11, 0, '', '2019-06-14 17:01:18');
INSERT INTO `access_log` VALUES (36891, '59.71.15605028782109515', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.131.117.100', '2019-06-14 17:01:18', 15, 2001001000, '服务端发生异常', '2019-06-14 17:01:18');
INSERT INTO `access_log` VALUES (36892, '64.84.15605028815599445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.131.117.100', '2019-06-14 17:01:22', 10, 0, '', '2019-06-14 17:01:22');
INSERT INTO `access_log` VALUES (36893, '64.82.15605028816659451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.131.117.100', '2019-06-14 17:01:22', 3, 0, '', '2019-06-14 17:01:22');
INSERT INTO `access_log` VALUES (36894, '64.76.15605028825299437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.131.117.100', '2019-06-14 17:01:23', 2, 0, '', '2019-06-14 17:01:23');
INSERT INTO `access_log` VALUES (36895, '59.72.15605074147859571', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.116.140.212', '2019-06-14 18:16:55', 11, 0, '', '2019-06-14 18:16:55');
INSERT INTO `access_log` VALUES (36896, '59.74.15605074147899569', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.116.140.212', '2019-06-14 18:16:55', 14, 2001001000, '服务端发生异常', '2019-06-14 18:16:55');
INSERT INTO `access_log` VALUES (36897, '64.81.15605074187919507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.116.140.212', '2019-06-14 18:16:59', 10, 0, '', '2019-06-14 18:16:59');
INSERT INTO `access_log` VALUES (36898, '64.80.15605074189299507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.116.140.212', '2019-06-14 18:16:59', 3, 0, '', '2019-06-14 18:16:59');
INSERT INTO `access_log` VALUES (36899, '64.83.15605074210759495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.116.140.212', '2019-06-14 18:17:01', 2, 0, '', '2019-06-14 18:17:01');
INSERT INTO `access_log` VALUES (36900, '64.78.15605074217239509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.116.140.212', '2019-06-14 18:17:02', 2, 0, '', '2019-06-14 18:17:02');
INSERT INTO `access_log` VALUES (36901, '59.79.15605074237979577', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.116.140.212', '2019-06-14 18:17:04', 3, 0, '', '2019-06-14 18:17:04');
INSERT INTO `access_log` VALUES (36902, '59.78.15605074237979573', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.116.140.212', '2019-06-14 18:17:04', 13, 2001001000, '服务端发生异常', '2019-06-14 18:17:04');
INSERT INTO `access_log` VALUES (36903, '65.52.15605075742900207', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 18:19:34', 5, 1002001012, '访问令牌已过期', '2019-06-14 18:19:34');
INSERT INTO `access_log` VALUES (36904, '65.3607.15605075742901959', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 18:19:34', 3, 1002001012, '访问令牌已过期', '2019-06-14 18:19:34');
INSERT INTO `access_log` VALUES (36905, '65.46.15605075743050203', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 18:19:34', 11, 1002001012, '访问令牌已过期', '2019-06-14 18:19:34');
INSERT INTO `access_log` VALUES (36906, '65.45.15605075848390203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 18:19:45', 5, 1002002000, '账号不存在', '2019-06-14 18:19:45');
INSERT INTO `access_log` VALUES (36907, '65.53.15605075947600183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 18:19:55', 67, 0, '', '2019-06-14 18:19:55');
INSERT INTO `access_log` VALUES (36908, '65.50.15605075950710211', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 18:19:55', 22, 0, '', '2019-06-14 18:19:55');
INSERT INTO `access_log` VALUES (36909, '65.47.15605075950730189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 18:19:55', 23, 2001001000, '服务端发生异常', '2019-06-14 18:19:55');
INSERT INTO `access_log` VALUES (36910, '65.49.15605075950750215', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 18:19:55', 22, 0, '', '2019-06-14 18:19:55');
INSERT INTO `access_log` VALUES (36911, '65.3607.15605075992011961', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 18:19:59', 10, 0, '', '2019-06-14 18:19:59');
INSERT INTO `access_log` VALUES (36912, '65.46.15605075992040205', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 18:19:59', 9, 0, '', '2019-06-14 18:19:59');
INSERT INTO `access_log` VALUES (36913, '65.52.15605075992020209', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 18:19:59', 12, 2001001000, '服务端发生异常', '2019-06-14 18:19:59');
INSERT INTO `access_log` VALUES (36914, '65.51.15605076051720225', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 18:20:05', 9, 0, '', '2019-06-14 18:20:05');
INSERT INTO `access_log` VALUES (36915, '65.54.15605076051780161', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 18:20:05', 9, 0, '', '2019-06-14 18:20:05');
INSERT INTO `access_log` VALUES (36916, '65.45.15605076051770205', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.32.247.118', '2019-06-14 18:20:05', 10, 2001001000, '服务端发生异常', '2019-06-14 18:20:05');
INSERT INTO `access_log` VALUES (36917, '59.72.15605088581189591', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.131.96.155', '2019-06-14 18:40:58', 3, 0, '', '2019-06-14 18:40:58');
INSERT INTO `access_log` VALUES (36918, '59.74.15605088581219589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.131.96.155', '2019-06-14 18:40:58', 10, 2001001000, '服务端发生异常', '2019-06-14 18:40:58');
INSERT INTO `access_log` VALUES (36919, '64.81.15605088652859527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:05', 3, 0, '', '2019-06-14 18:41:05');
INSERT INTO `access_log` VALUES (36920, '64.80.15605088653989527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:05', 2, 0, '', '2019-06-14 18:41:05');
INSERT INTO `access_log` VALUES (36921, '64.78.15605088668119529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:07', 2, 0, '', '2019-06-14 18:41:07');
INSERT INTO `access_log` VALUES (36922, '64.77.15605088673229533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:07', 1, 0, '', '2019-06-14 18:41:07');
INSERT INTO `access_log` VALUES (36923, '64.84.15605088692509527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:09', 2, 0, '', '2019-06-14 18:41:09');
INSERT INTO `access_log` VALUES (36924, '64.82.15605088695469533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:10', 2, 0, '', '2019-06-14 18:41:10');
INSERT INTO `access_log` VALUES (36925, '59.78.15605088705679593', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:11', 2, 0, '', '2019-06-14 18:41:11');
INSERT INTO `access_log` VALUES (36926, '59.75.15605088705709599', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:11', 14, 2001001000, '服务端发生异常', '2019-06-14 18:41:11');
INSERT INTO `access_log` VALUES (36927, '64.76.15605088736389519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:14', 2, 0, '', '2019-06-14 18:41:14');
INSERT INTO `access_log` VALUES (36928, '64.85.15605088737419539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:14', 2, 0, '', '2019-06-14 18:41:14');
INSERT INTO `access_log` VALUES (36929, '64.79.15605088745929523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:15', 2, 0, '', '2019-06-14 18:41:15');
INSERT INTO `access_log` VALUES (36930, '64.80.15605088832939529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:23', 1, 0, '', '2019-06-14 18:41:23');
INSERT INTO `access_log` VALUES (36931, '64.83.15605088834289517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:23', 2, 0, '', '2019-06-14 18:41:23');
INSERT INTO `access_log` VALUES (36932, '64.78.15605088885719531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:29', 2, 0, '', '2019-06-14 18:41:29');
INSERT INTO `access_log` VALUES (36933, '64.77.15605088886759535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:29', 2, 0, '', '2019-06-14 18:41:29');
INSERT INTO `access_log` VALUES (36934, '64.84.15605088919019529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:32', 2, 0, '', '2019-06-14 18:41:32');
INSERT INTO `access_log` VALUES (36935, '64.82.15605088920219535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:32', 1, 0, '', '2019-06-14 18:41:32');
INSERT INTO `access_log` VALUES (36936, '59.80.15605088943979583', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:34', 3, 0, '', '2019-06-14 18:41:34');
INSERT INTO `access_log` VALUES (36937, '59.77.15605088943999581', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:34', 13, 2001001000, '服务端发生异常', '2019-06-14 18:41:34');
INSERT INTO `access_log` VALUES (36938, '64.85.15605088970299541', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:37', 1, 0, '', '2019-06-14 18:41:37');
INSERT INTO `access_log` VALUES (36939, '64.79.15605088971359525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:37', 2, 0, '', '2019-06-14 18:41:37');
INSERT INTO `access_log` VALUES (36940, '64.81.15605089034069531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:43', 2, 0, '', '2019-06-14 18:41:43');
INSERT INTO `access_log` VALUES (36941, '64.80.15605089035199531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:44', 2, 0, '', '2019-06-14 18:41:44');
INSERT INTO `access_log` VALUES (36942, '59.73.15605089040929597', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:44', 2, 0, '', '2019-06-14 18:41:44');
INSERT INTO `access_log` VALUES (36943, '59.74.15605089040959591', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:41:44', 19, 2001001000, '服务端发生异常', '2019-06-14 18:41:44');
INSERT INTO `access_log` VALUES (36944, '64.83.15605089065249519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.131.96.155', '2019-06-14 18:41:47', 2, 0, '', '2019-06-14 18:41:47');
INSERT INTO `access_log` VALUES (36945, '64.78.15605089066649533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.131.96.155', '2019-06-14 18:41:47', 2, 0, '', '2019-06-14 18:41:47');
INSERT INTO `access_log` VALUES (36946, '59.72.15605089071369593', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.131.96.155', '2019-06-14 18:41:47', 3, 0, '', '2019-06-14 18:41:47');
INSERT INTO `access_log` VALUES (36947, '59.79.15605089071419599', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.131.96.155', '2019-06-14 18:41:47', 10, 2001001000, '服务端发生异常', '2019-06-14 18:41:47');
INSERT INTO `access_log` VALUES (36948, '65.46.15605099305150237', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 18:58:51', 0, 1002001015, '账号未登陆', '2019-06-14 18:58:51');
INSERT INTO `access_log` VALUES (36949, '65.52.15605099305150241', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 18:58:51', 0, 1002001015, '账号未登陆', '2019-06-14 18:58:51');
INSERT INTO `access_log` VALUES (36950, '65.45.15605099305170237', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 18:58:51', 0, 1002001015, '账号未登陆', '2019-06-14 18:58:51');
INSERT INTO `access_log` VALUES (36951, '59.78.15605099312819609', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 18:58:51', 3, 0, '', '2019-06-14 18:58:51');
INSERT INTO `access_log` VALUES (36952, '59.79.15605099312809613', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 18:58:51', 12, 2001001000, '服务端发生异常', '2019-06-14 18:58:51');
INSERT INTO `access_log` VALUES (36953, '59.71.15605099485449613', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.131.96.155', '2019-06-14 18:59:09', 3, 0, '', '2019-06-14 18:59:09');
INSERT INTO `access_log` VALUES (36954, '59.76.15605099485499605', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.131.96.155', '2019-06-14 18:59:09', 12, 2001001000, '服务端发生异常', '2019-06-14 18:59:09');
INSERT INTO `access_log` VALUES (36955, '64.77.15605099546479551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:59:15', 3, 0, '', '2019-06-14 18:59:15');
INSERT INTO `access_log` VALUES (36956, '64.84.15605099548039545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:59:15', 2, 0, '', '2019-06-14 18:59:15');
INSERT INTO `access_log` VALUES (36957, '64.82.15605099558349551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:59:16', 3, 0, '', '2019-06-14 18:59:16');
INSERT INTO `access_log` VALUES (36958, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:59:16', 7, 0, '', '2019-06-14 18:59:16');
INSERT INTO `access_log` VALUES (36959, '64.76.15605099570049537', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:59:17', 7, 0, '', '2019-06-14 18:59:17');
INSERT INTO `access_log` VALUES (36960, '64.81.15605099843929547', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:59:44', 2, 0, '', '2019-06-14 18:59:44');
INSERT INTO `access_log` VALUES (36961, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:59:44', 5, 0, '', '2019-06-14 18:59:44');
INSERT INTO `access_log` VALUES (36962, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:59:47', 5, 0, '', '2019-06-14 18:59:47');
INSERT INTO `access_log` VALUES (36963, '64.80.15605099898489547', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:59:50', 2, 0, '', '2019-06-14 18:59:50');
INSERT INTO `access_log` VALUES (36964, '64.83.15605099899519535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 18:59:50', 1, 0, '', '2019-06-14 18:59:50');
INSERT INTO `access_log` VALUES (36965, '64.77.15605099934719553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 18:59:53', 2, 0, '', '2019-06-14 18:59:53');
INSERT INTO `access_log` VALUES (36966, '64.84.15605099936599547', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 18:59:54', 1, 0, '', '2019-06-14 18:59:54');
INSERT INTO `access_log` VALUES (36967, '64.82.15605099947219553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 18:59:55', 2, 0, '', '2019-06-14 18:59:55');
INSERT INTO `access_log` VALUES (36968, '64.76.15605099952379539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 18:59:55', 3, 0, '', '2019-06-14 18:59:55');
INSERT INTO `access_log` VALUES (36969, '64.85.15605099955699559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 18:59:56', 2, 0, '', '2019-06-14 18:59:56');
INSERT INTO `access_log` VALUES (36970, '64.79.15605099958259543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 18:59:56', 2, 0, '', '2019-06-14 18:59:56');
INSERT INTO `access_log` VALUES (36971, '64.80.15605100061879549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '222.82.178.103', '2019-06-14 19:00:06', 2, 0, '', '2019-06-14 19:00:06');
INSERT INTO `access_log` VALUES (36972, '64.83.15605100066819537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '222.82.178.103', '2019-06-14 19:00:07', 2, 0, '', '2019-06-14 19:00:07');
INSERT INTO `access_log` VALUES (36973, '64.78.15605100069539551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '222.82.178.103', '2019-06-14 19:00:07', 2, 0, '', '2019-06-14 19:00:07');
INSERT INTO `access_log` VALUES (36974, '66.49.15605100078858009', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17758710030', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:08', 117, 0, '', '2019-06-14 19:00:08');
INSERT INTO `access_log` VALUES (36975, '64.77.15605100093509555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '222.82.178.103', '2019-06-14 19:00:09', 2, 0, '', '2019-06-14 19:00:09');
INSERT INTO `access_log` VALUES (36976, '66.52.15605100093558007', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17758710030&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:09', 193, 0, '', '2019-06-14 19:00:10');
INSERT INTO `access_log` VALUES (36977, '64.84.15605100095479549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '222.82.178.103', '2019-06-14 19:00:10', 3, 0, '', '2019-06-14 19:00:10');
INSERT INTO `access_log` VALUES (36978, '66.56.15605100105098005', 125, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:11', 7, 0, '', '2019-06-14 19:00:11');
INSERT INTO `access_log` VALUES (36979, '59.72.15605100114819609', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '222.82.178.103', '2019-06-14 19:00:11', 3, 0, '', '2019-06-14 19:00:11');
INSERT INTO `access_log` VALUES (36980, '59.78.15605100114839611', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '222.82.178.103', '2019-06-14 19:00:11', 13, 2001001000, '服务端发生异常', '2019-06-14 19:00:11');
INSERT INTO `access_log` VALUES (36981, '66.54.15605100133218003', 125, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:13', 6, 0, '', '2019-06-14 19:00:13');
INSERT INTO `access_log` VALUES (36982, '64.82.15605100140979555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '222.82.178.103', '2019-06-14 19:00:14', 2, 0, '', '2019-06-14 19:00:14');
INSERT INTO `access_log` VALUES (36983, '64.76.15605100143019541', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '222.82.178.103', '2019-06-14 19:00:14', 2, 0, '', '2019-06-14 19:00:14');
INSERT INTO `access_log` VALUES (36984, '66.53.15605100144288001', 125, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:14', 6, 0, '', '2019-06-14 19:00:14');
INSERT INTO `access_log` VALUES (36985, '64.85.15605100155709561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '222.82.178.103', '2019-06-14 19:00:16', 2, 0, '', '2019-06-14 19:00:16');
INSERT INTO `access_log` VALUES (36986, '64.79.15605100162839545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '222.82.178.103', '2019-06-14 19:00:16', 2, 0, '', '2019-06-14 19:00:16');
INSERT INTO `access_log` VALUES (36987, '64.81.15605100171719551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '222.82.178.103', '2019-06-14 19:00:17', 2, 0, '', '2019-06-14 19:00:17');
INSERT INTO `access_log` VALUES (36988, '64.80.15605100174919551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '222.82.178.103', '2019-06-14 19:00:17', 2, 0, '', '2019-06-14 19:00:17');
INSERT INTO `access_log` VALUES (36989, '66.55.15605100187647997', 125, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:19', 6, 0, '', '2019-06-14 19:00:19');
INSERT INTO `access_log` VALUES (36990, '66.51.15605100200178005', 125, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:20', 6, 0, '', '2019-06-14 19:00:20');
INSERT INTO `access_log` VALUES (36991, '65.3607.15605100202261995', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 19:00:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 19:00:20');
INSERT INTO `access_log` VALUES (36992, '66.50.15605100213788001', 125, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:21', 6, 0, '', '2019-06-14 19:00:21');
INSERT INTO `access_log` VALUES (36993, '64.77.15605100296169557', 125, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:30', 7, 1003002003, 'Spu 只能添加在二级分类下', '2019-06-14 19:00:30');
INSERT INTO `access_log` VALUES (36994, '66.52.15605100365498009', 125, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:37', 6, 0, '', '2019-06-14 19:00:37');
INSERT INTO `access_log` VALUES (36995, '65.46.15605100386170239', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 19:00:39', 107, 0, '', '2019-06-14 19:00:39');
INSERT INTO `access_log` VALUES (36996, '65.51.15605100391630259', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 19:00:39', 10, 0, '', '2019-06-14 19:00:39');
INSERT INTO `access_log` VALUES (36997, '65.54.15605100391630195', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 19:00:39', 11, 2001001000, '服务端发生异常', '2019-06-14 19:00:39');
INSERT INTO `access_log` VALUES (36998, '65.53.15605100392510219', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 19:00:39', 10, 0, '', '2019-06-14 19:00:39');
INSERT INTO `access_log` VALUES (36999, '59.76.15605100411559607', 125, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:41', 41, 0, '', '2019-06-14 19:00:41');
INSERT INTO `access_log` VALUES (37000, '59.80.15605100420989601', 125, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:42', 8, 0, '', '2019-06-14 19:00:42');
INSERT INTO `access_log` VALUES (37001, '59.73.15605100424989615', 125, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:42', 233, 0, '', '2019-06-14 19:00:43');
INSERT INTO `access_log` VALUES (37002, '66.57.15605100432258005', 125, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:43', 6, 0, '', '2019-06-14 19:00:43');
INSERT INTO `access_log` VALUES (37003, '64.76.15605100444409543', 125, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:44', 15, 0, '', '2019-06-14 19:00:44');
INSERT INTO `access_log` VALUES (37004, '64.79.15605100445969547', 125, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:45', 4, 0, '', '2019-06-14 19:00:45');
INSERT INTO `access_log` VALUES (37005, '64.81.15605100455529553', 125, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:46', 5, 0, '', '2019-06-14 19:00:46');
INSERT INTO `access_log` VALUES (37006, 'N/A', 125, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:46', 12, 0, '', '2019-06-14 19:00:46');
INSERT INTO `access_log` VALUES (37007, '64.83.15605100464509541', 125, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:46', 9, 0, '', '2019-06-14 19:00:46');
INSERT INTO `access_log` VALUES (37008, '65.49.15605100492020251', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 19:00:49', 9, 0, '', '2019-06-14 19:00:49');
INSERT INTO `access_log` VALUES (37009, '65.47.15605100492000225', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 19:00:49', 10, 2001001000, '服务端发生异常', '2019-06-14 19:00:49');
INSERT INTO `access_log` VALUES (37010, '65.50.15605100492000247', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-14 19:00:49', 9, 0, '', '2019-06-14 19:00:49');
INSERT INTO `access_log` VALUES (37011, '66.54.15605100492878005', 125, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:49', 17, 0, '', '2019-06-14 19:00:49');
INSERT INTO `access_log` VALUES (37012, '66.51.15605100551808007', 125, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:00:55', 6, 0, '', '2019-06-14 19:00:55');
INSERT INTO `access_log` VALUES (37013, '66.49.15605100777048013', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:18', 96, 2001001000, '服务端发生异常', '2019-06-14 19:01:18');
INSERT INTO `access_log` VALUES (37014, '66.52.15605100792598011', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:19', 76, 2001001000, '服务端发生异常', '2019-06-14 19:01:19');
INSERT INTO `access_log` VALUES (37015, '66.54.15605100837298007', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11222&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:24', 154, 2001001000, '服务端发生异常', '2019-06-14 19:01:24');
INSERT INTO `access_log` VALUES (37016, '66.53.15605100859648005', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11222&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:26', 105, 2001001000, '服务端发生异常', '2019-06-14 19:01:26');
INSERT INTO `access_log` VALUES (37017, '66.55.15605100871238001', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11222&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:27', 114, 2001001000, '服务端发生异常', '2019-06-14 19:01:27');
INSERT INTO `access_log` VALUES (37018, '66.51.15605100881878009', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11222&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:28', 93, 2001001000, '服务端发生异常', '2019-06-14 19:01:28');
INSERT INTO `access_log` VALUES (37019, '66.48.15605100891898017', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11222&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:29', 91, 2001001000, '服务端发生异常', '2019-06-14 19:01:29');
INSERT INTO `access_log` VALUES (37020, '66.49.15605101032678015', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11222&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:43', 648, 2001001000, '服务端发生异常', '2019-06-14 19:01:44');
INSERT INTO `access_log` VALUES (37021, '66.56.15605101308928011', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11222&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:02:11', 91, 2001001000, '服务端发生异常', '2019-06-14 19:02:11');
INSERT INTO `access_log` VALUES (37022, '66.54.15605101324668009', 125, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:02:12', 7, 0, '', '2019-06-14 19:02:12');
INSERT INTO `access_log` VALUES (37023, '66.53.15605101380828007', 125, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:02:18', 4, 0, '', '2019-06-14 19:02:18');
INSERT INTO `access_log` VALUES (37024, '64.79.15605101386039549', 125, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:02:19', 10, 0, '', '2019-06-14 19:02:19');
INSERT INTO `access_log` VALUES (37025, '64.81.15605101389629555', 125, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:02:19', 5, 0, '', '2019-06-14 19:02:19');
INSERT INTO `access_log` VALUES (37026, 'N/A', 125, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:02:19', 10, 0, '', '2019-06-14 19:02:19');
INSERT INTO `access_log` VALUES (37027, '64.80.15605101391109555', 125, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:02:19', 4, 0, '', '2019-06-14 19:02:19');
INSERT INTO `access_log` VALUES (37028, '64.83.15605101392299543', 125, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:02:19', 7, 0, '', '2019-06-14 19:02:19');
INSERT INTO `access_log` VALUES (37029, '66.55.15605101392588003', 125, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:02:19', 6, 0, '', '2019-06-14 19:02:19');
INSERT INTO `access_log` VALUES (37030, '64.78.15605101394109557', 125, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:02:19', 6, 0, '', '2019-06-14 19:02:19');
INSERT INTO `access_log` VALUES (37031, '64.77.15605101395369561', 125, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:02:20', 6, 0, '', '2019-06-14 19:02:20');
INSERT INTO `access_log` VALUES (37032, '59.73.15605101395969617', 125, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:02:20', 15, 0, '', '2019-06-14 19:02:20');
INSERT INTO `access_log` VALUES (37033, '59.72.15605101396139613', 125, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:02:20', 15, 2001001000, '服务端发生异常', '2019-06-14 19:02:20');
INSERT INTO `access_log` VALUES (37034, '59.72.15605104225129617', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:03', 2, 0, '', '2019-06-14 19:07:03');
INSERT INTO `access_log` VALUES (37035, '59.73.15605104225129621', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:03', 13, 2001001000, '服务端发生异常', '2019-06-14 19:07:03');
INSERT INTO `access_log` VALUES (37036, '64.84.15605104286279559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:09', 2, 0, '', '2019-06-14 19:07:09');
INSERT INTO `access_log` VALUES (37037, '64.82.15605104287779565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:09', 2, 0, '', '2019-06-14 19:07:09');
INSERT INTO `access_log` VALUES (37038, '64.76.15605104399869551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:20', 2, 0, '', '2019-06-14 19:07:20');
INSERT INTO `access_log` VALUES (37039, '59.75.15605104481139625', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:28', 2, 0, '', '2019-06-14 19:07:28');
INSERT INTO `access_log` VALUES (37040, '59.71.15605104481139623', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:28', 19, 2001001000, '服务端发生异常', '2019-06-14 19:07:28');
INSERT INTO `access_log` VALUES (37041, '64.79.15605104506179555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:31', 2, 0, '', '2019-06-14 19:07:31');
INSERT INTO `access_log` VALUES (37042, '64.81.15605104507449561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:31', 2, 0, '', '2019-06-14 19:07:31');
INSERT INTO `access_log` VALUES (37043, '59.76.15605104536759615', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:34', 2, 0, '', '2019-06-14 19:07:34');
INSERT INTO `access_log` VALUES (37044, '59.77.15605104536759607', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:34', 9, 2001001000, '服务端发生异常', '2019-06-14 19:07:34');
INSERT INTO `access_log` VALUES (37045, '64.83.15605104657539549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:46', 2, 0, '', '2019-06-14 19:07:46');
INSERT INTO `access_log` VALUES (37046, '64.78.15605104659939563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:46', 1, 0, '', '2019-06-14 19:07:46');
INSERT INTO `access_log` VALUES (37047, '65.50.15605104782930253', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:58', 0, 1002001015, '账号未登陆', '2019-06-14 19:07:58');
INSERT INTO `access_log` VALUES (37048, '65.3607.15605104782952003', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:58', 0, 1002001015, '账号未登陆', '2019-06-14 19:07:58');
INSERT INTO `access_log` VALUES (37049, '65.45.15605104783270247', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:07:58', 0, 1002001015, '账号未登陆', '2019-06-14 19:07:58');
INSERT INTO `access_log` VALUES (37050, '65.46.15605104855120247', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:08:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 19:08:06');
INSERT INTO `access_log` VALUES (37051, '65.54.15605104950670203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.22.53.116', '2019-06-14 19:08:15', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 19:08:15');
INSERT INTO `access_log` VALUES (37052, '65.46.15605107297900251', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-14 19:12:10', 3, 1002001012, '访问令牌已过期', '2019-06-14 19:12:10');
INSERT INTO `access_log` VALUES (37053, '65.3607.15605107297892007', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-14 19:12:10', 5, 1002001012, '访问令牌已过期', '2019-06-14 19:12:10');
INSERT INTO `access_log` VALUES (37054, '65.52.15605107297910255', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-14 19:12:10', 3, 1002001012, '访问令牌已过期', '2019-06-14 19:12:10');
INSERT INTO `access_log` VALUES (37055, '65.54.15605107354370207', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-14 19:12:15', 115, 0, '', '2019-06-14 19:12:16');
INSERT INTO `access_log` VALUES (37056, '65.51.15605107357520271', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-14 19:12:16', 9, 0, '', '2019-06-14 19:12:16');
INSERT INTO `access_log` VALUES (37057, '65.47.15605107357550237', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-14 19:12:16', 9, 0, '', '2019-06-14 19:12:16');
INSERT INTO `access_log` VALUES (37058, '65.53.15605107357550231', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-14 19:12:16', 9, 2001001000, '服务端发生异常', '2019-06-14 19:12:16');
INSERT INTO `access_log` VALUES (37059, '65.50.15605107490580259', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-14 19:12:29', 17, 0, '', '2019-06-14 19:12:29');
INSERT INTO `access_log` VALUES (37060, '65.3607.15605107490592009', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-14 19:12:29', 16, 0, '', '2019-06-14 19:12:29');
INSERT INTO `access_log` VALUES (37061, '65.45.15605107490590253', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-14 19:12:29', 17, 2001001000, '服务端发生异常', '2019-06-14 19:12:29');
INSERT INTO `access_log` VALUES (37062, '59.80.15605116297669625', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.3.252', '2019-06-14 19:27:10', 13, 2001001000, '服务端发生异常', '2019-06-14 19:27:10');
INSERT INTO `access_log` VALUES (37063, '59.76.15605116297659631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.3.252', '2019-06-14 19:27:10', 83, 0, '', '2019-06-14 19:27:10');
INSERT INTO `access_log` VALUES (37064, '64.83.15605116328519565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.3.252', '2019-06-14 19:27:13', 3, 0, '', '2019-06-14 19:27:13');
INSERT INTO `access_log` VALUES (37065, '64.78.15605116329629579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.3.252', '2019-06-14 19:27:13', 2, 0, '', '2019-06-14 19:27:13');
INSERT INTO `access_log` VALUES (37066, '64.77.15605116338029583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.3.252', '2019-06-14 19:27:14', 2, 0, '', '2019-06-14 19:27:14');
INSERT INTO `access_log` VALUES (37067, '64.84.15605116341359577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.3.252', '2019-06-14 19:27:14', 2, 0, '', '2019-06-14 19:27:14');
INSERT INTO `access_log` VALUES (37068, '64.82.15605116346809583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.3.252', '2019-06-14 19:27:15', 2, 0, '', '2019-06-14 19:27:15');
INSERT INTO `access_log` VALUES (37069, '64.76.15605116351279569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.3.252', '2019-06-14 19:27:15', 2, 0, '', '2019-06-14 19:27:15');
INSERT INTO `access_log` VALUES (37070, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=sprin&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.3.252', '2019-06-14 19:27:19', 7, 0, '', '2019-06-14 19:27:19');
INSERT INTO `access_log` VALUES (37071, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=sprin', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.3.252', '2019-06-14 19:27:19', 9, 0, '', '2019-06-14 19:27:19');
INSERT INTO `access_log` VALUES (37072, '65.50.15605191414560373', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:32:21', 1, 1002001015, '账号未登陆', '2019-06-14 21:32:21');
INSERT INTO `access_log` VALUES (37073, '65.45.15605191414610365', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:32:21', 0, 1002001015, '账号未登陆', '2019-06-14 21:32:21');
INSERT INTO `access_log` VALUES (37074, '65.3607.15605191414832121', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:32:21', 0, 1002001015, '账号未登陆', '2019-06-14 21:32:21');
INSERT INTO `access_log` VALUES (37075, '65.46.15605191436300367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:32:24', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 21:32:24');
INSERT INTO `access_log` VALUES (37076, '65.54.15605191462640321', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:32:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 21:32:26');
INSERT INTO `access_log` VALUES (37077, '65.47.15605191471230351', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:32:27', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 21:32:27');
INSERT INTO `access_log` VALUES (37078, '65.53.15605191773740347', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:32:57', 79, 0, '', '2019-06-14 21:32:57');
INSERT INTO `access_log` VALUES (37079, '65.45.15605191776730367', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:32:58', 12, 0, '', '2019-06-14 21:32:58');
INSERT INTO `access_log` VALUES (37080, '65.50.15605191776740375', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:32:58', 13, 2001001000, '服务端发生异常', '2019-06-14 21:32:58');
INSERT INTO `access_log` VALUES (37081, '65.3607.15605191776772123', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:32:58', 11, 0, '', '2019-06-14 21:32:58');
INSERT INTO `access_log` VALUES (37082, '65.52.15605191911540373', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:33:11', 9, 0, '', '2019-06-14 21:33:11');
INSERT INTO `access_log` VALUES (37083, '65.54.15605191911570323', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:33:11', 11, 2001001000, '服务端发生异常', '2019-06-14 21:33:11');
INSERT INTO `access_log` VALUES (37084, '65.47.15605191911620353', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:33:11', 10, 0, '', '2019-06-14 21:33:11');
INSERT INTO `access_log` VALUES (37085, '65.51.15605191951690389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:33:15', 9, 0, '', '2019-06-14 21:33:15');
INSERT INTO `access_log` VALUES (37086, '65.49.15605191951720379', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:33:15', 10, 2001001000, '服务端发生异常', '2019-06-14 21:33:15');
INSERT INTO `access_log` VALUES (37087, '65.53.15605191951780349', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.119.233.75', '2019-06-14 21:33:15', 8, 0, '', '2019-06-14 21:33:15');
INSERT INTO `access_log` VALUES (37088, '59.73.15605194437559743', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:37:24', 23, 2001001000, '服务端发生异常', '2019-06-14 21:37:24');
INSERT INTO `access_log` VALUES (37089, '59.72.15605194437549739', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:37:24', 27, 0, '', '2019-06-14 21:37:24');
INSERT INTO `access_log` VALUES (37090, '65.45.15605194945290373', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:38:15', 1, 1002001015, '账号未登陆', '2019-06-14 21:38:15');
INSERT INTO `access_log` VALUES (37091, '65.3607.15605194945322129', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:38:15', 1, 1002001015, '账号未登陆', '2019-06-14 21:38:15');
INSERT INTO `access_log` VALUES (37092, '65.50.15605194945360381', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:38:15', 0, 1002001015, '账号未登陆', '2019-06-14 21:38:15');
INSERT INTO `access_log` VALUES (37093, '65.47.15605198307310363', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:43:51', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 21:43:51');
INSERT INTO `access_log` VALUES (37094, '65.49.15605198387790389', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicaial&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:43:59', 72, 0, '', '2019-06-14 21:43:59');
INSERT INTO `access_log` VALUES (37095, '65.53.15605198391120359', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:43:59', 9, 0, '', '2019-06-14 21:43:59');
INSERT INTO `access_log` VALUES (37096, '65.51.15605198391120399', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:43:59', 9, 0, '', '2019-06-14 21:43:59');
INSERT INTO `access_log` VALUES (37097, '65.45.15605198391150379', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:43:59', 9, 0, '', '2019-06-14 21:43:59');
INSERT INTO `access_log` VALUES (37098, '62.80.15605198619369481', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:44:22', 31, 0, '', '2019-06-14 21:44:22');
INSERT INTO `access_log` VALUES (37099, '59.72.15605198712359745', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:44:31', 16, 0, '', '2019-06-14 21:44:31');
INSERT INTO `access_log` VALUES (37100, '65.54.15605198860500335', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:44:46', 31, 0, '', '2019-06-14 21:44:46');
INSERT INTO `access_log` VALUES (37101, '65.52.15605198942990385', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:44:54', 16, 0, '', '2019-06-14 21:44:54');
INSERT INTO `access_log` VALUES (37102, '65.49.15605198950990391', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:44:55', 17, 0, '', '2019-06-14 21:44:55');
INSERT INTO `access_log` VALUES (37103, '65.45.15605198973020381', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:44:57', 18, 0, '', '2019-06-14 21:44:57');
INSERT INTO `access_log` VALUES (37104, '65.53.15605199011000361', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:01', 25, 0, '', '2019-06-14 21:45:01');
INSERT INTO `access_log` VALUES (37105, '65.51.15605199024150401', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:02', 9, 0, '', '2019-06-14 21:45:02');
INSERT INTO `access_log` VALUES (37106, '66.52.15605199329038145', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:33', 22, 0, '', '2019-06-14 21:45:33');
INSERT INTO `access_log` VALUES (37107, '65.54.15605199437350337', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:44', 9, 0, '', '2019-06-14 21:45:44');
INSERT INTO `access_log` VALUES (37108, '65.52.15605199437510387', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:44', 8, 0, '', '2019-06-14 21:45:44');
INSERT INTO `access_log` VALUES (37109, '65.47.15605199437500367', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:44', 9, 0, '', '2019-06-14 21:45:44');
INSERT INTO `access_log` VALUES (37110, '66.53.15605199438268139', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:44', 13, 0, '', '2019-06-14 21:45:44');
INSERT INTO `access_log` VALUES (37111, '65.49.15605199526990393', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:53', 9, 0, '', '2019-06-14 21:45:53');
INSERT INTO `access_log` VALUES (37112, '65.45.15605199527020383', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:53', 8, 0, '', '2019-06-14 21:45:53');
INSERT INTO `access_log` VALUES (37113, '65.53.15605199527060363', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:53', 7, 0, '', '2019-06-14 21:45:53');
INSERT INTO `access_log` VALUES (37114, '66.51.15605199527728143', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:53', 26, 0, '', '2019-06-14 21:45:53');
INSERT INTO `access_log` VALUES (37115, '65.3607.15605199563162139', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:56', 11, 0, '', '2019-06-14 21:45:56');
INSERT INTO `access_log` VALUES (37116, '65.50.15605199563170391', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:56', 10, 0, '', '2019-06-14 21:45:56');
INSERT INTO `access_log` VALUES (37117, '65.46.15605199563220385', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:56', 9, 0, '', '2019-06-14 21:45:56');
INSERT INTO `access_log` VALUES (37118, '66.48.15605199563708149', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:45:56', 11, 0, '', '2019-06-14 21:45:56');
INSERT INTO `access_log` VALUES (37119, '65.54.15605199643840339', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.113.207.138', '2019-06-14 21:46:04', 12, 0, '', '2019-06-14 21:46:04');
INSERT INTO `access_log` VALUES (37120, '65.45.15605236084010433', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.90.104.68', '2019-06-14 22:46:48', 0, 1002001015, '账号未登陆', '2019-06-14 22:46:48');
INSERT INTO `access_log` VALUES (37121, '65.49.15605236084010443', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.90.104.68', '2019-06-14 22:46:48', 0, 1002001015, '账号未登陆', '2019-06-14 22:46:48');
INSERT INTO `access_log` VALUES (37122, '65.51.15605236084010453', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.90.104.68', '2019-06-14 22:46:48', 0, 1002001015, '账号未登陆', '2019-06-14 22:46:48');
INSERT INTO `access_log` VALUES (37123, '65.50.15605236147220441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.90.104.68', '2019-06-14 22:46:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 22:46:55');
INSERT INTO `access_log` VALUES (37124, '65.46.15605236190800435', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.90.104.68', '2019-06-14 22:46:59', 52, 0, '', '2019-06-14 22:46:59');
INSERT INTO `access_log` VALUES (37125, '65.54.15605236194450389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.90.104.68', '2019-06-14 22:46:59', 11, 0, '', '2019-06-14 22:46:59');
INSERT INTO `access_log` VALUES (37126, '65.52.15605236194490439', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.90.104.68', '2019-06-14 22:46:59', 12, 2001001000, '服务端发生异常', '2019-06-14 22:46:59');
INSERT INTO `access_log` VALUES (37127, '65.47.15605236194530419', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.90.104.68', '2019-06-14 22:46:59', 11, 0, '', '2019-06-14 22:46:59');
INSERT INTO `access_log` VALUES (37128, '65.53.15605236265400415', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.90.104.68', '2019-06-14 22:47:07', 9, 0, '', '2019-06-14 22:47:07');
INSERT INTO `access_log` VALUES (37129, '65.51.15605236265400455', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.90.104.68', '2019-06-14 22:47:07', 11, 2001001000, '服务端发生异常', '2019-06-14 22:47:07');
INSERT INTO `access_log` VALUES (37130, '65.49.15605236265450445', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.90.104.68', '2019-06-14 22:47:07', 16, 0, '', '2019-06-14 22:47:07');
INSERT INTO `access_log` VALUES (37131, '59.72.15605245020419807', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:01:42', 27, 0, '', '2019-06-14 23:01:42');
INSERT INTO `access_log` VALUES (37132, '59.73.15605245020419811', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:01:42', 29, 2001001000, '服务端发生异常', '2019-06-14 23:01:42');
INSERT INTO `access_log` VALUES (37133, '65.49.15605245054870459', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:01:45', 0, 1002001015, '账号未登陆', '2019-06-14 23:01:45');
INSERT INTO `access_log` VALUES (37134, '65.45.15605245054880447', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:01:45', 1, 1002001015, '账号未登陆', '2019-06-14 23:01:45');
INSERT INTO `access_log` VALUES (37135, '65.50.15605245054980457', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:01:45', 0, 1002001015, '账号未登陆', '2019-06-14 23:01:45');
INSERT INTO `access_log` VALUES (37136, '64.76.15605245114039741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:01:51', 10, 0, '', '2019-06-14 23:01:51');
INSERT INTO `access_log` VALUES (37137, '64.85.15605245115079761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:01:52', 2, 0, '', '2019-06-14 23:01:52');
INSERT INTO `access_log` VALUES (37138, '64.79.15605245127499745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:01:53', 2, 0, '', '2019-06-14 23:01:53');
INSERT INTO `access_log` VALUES (37139, '64.81.15605245133349751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:01:53', 2, 0, '', '2019-06-14 23:01:53');
INSERT INTO `access_log` VALUES (37140, '65.54.15605245154350403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:01:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-14 23:01:55');
INSERT INTO `access_log` VALUES (37141, '65.52.15605245385940455', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:02:19', 155, 0, '', '2019-06-14 23:02:19');
INSERT INTO `access_log` VALUES (37142, '65.51.15605245389950471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:02:19', 9, 0, '', '2019-06-14 23:02:19');
INSERT INTO `access_log` VALUES (37143, '65.47.15605245389970433', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:02:19', 10, 2001001000, '服务端发生异常', '2019-06-14 23:02:19');
INSERT INTO `access_log` VALUES (37144, '65.53.15605245390010429', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:02:19', 9, 0, '', '2019-06-14 23:02:19');
INSERT INTO `access_log` VALUES (37145, '65.46.15605245811450451', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:03:01', 18, 0, '', '2019-06-14 23:03:01');
INSERT INTO `access_log` VALUES (37146, '65.54.15605245811470405', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.174.216.117', '2019-06-14 23:03:01', 16, 2001001000, '服务端发生异常', '2019-06-14 23:03:01');
INSERT INTO `access_log` VALUES (37147, '65.3607.15605245811502207', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.152.109.2', '2019-06-14 23:03:01', 16, 0, '', '2019-06-14 23:03:01');
INSERT INTO `access_log` VALUES (37148, '65.49.15605305023980541', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '58.39.143.214', '2019-06-15 00:41:42', 1, 1002001015, '账号未登陆', '2019-06-15 00:41:42');
INSERT INTO `access_log` VALUES (37149, '65.45.15605305023980529', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '58.39.143.214', '2019-06-15 00:41:42', 1, 1002001015, '账号未登陆', '2019-06-15 00:41:42');
INSERT INTO `access_log` VALUES (37150, '65.54.15605305024000485', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '58.39.143.214', '2019-06-15 00:41:42', 0, 1002001015, '账号未登陆', '2019-06-15 00:41:42');
INSERT INTO `access_log` VALUES (37151, '65.46.15605305047160531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '58.39.143.214', '2019-06-15 00:41:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 00:41:45');
INSERT INTO `access_log` VALUES (37152, '65.47.15605305401970515', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '58.39.143.214', '2019-06-15 00:42:20', 94, 0, '', '2019-06-15 00:42:20');
INSERT INTO `access_log` VALUES (37153, '65.51.15605305406540553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '58.39.143.214', '2019-06-15 00:42:21', 11, 0, '', '2019-06-15 00:42:21');
INSERT INTO `access_log` VALUES (37154, '65.53.15605305406600511', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '58.39.143.214', '2019-06-15 00:42:21', 10, 2001001000, '服务端发生异常', '2019-06-15 00:42:21');
INSERT INTO `access_log` VALUES (37155, '65.50.15605305406710541', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '58.39.143.214', '2019-06-15 00:42:21', 9, 0, '', '2019-06-15 00:42:21');
INSERT INTO `access_log` VALUES (37156, '65.54.15605305725280487', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '58.39.143.214', '2019-06-15 00:42:53', 12, 0, '', '2019-06-15 00:42:53');
INSERT INTO `access_log` VALUES (37157, '65.46.15605305725370533', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '58.39.143.214', '2019-06-15 00:42:53', 10, 2001001000, '服务端发生异常', '2019-06-15 00:42:53');
INSERT INTO `access_log` VALUES (37158, '65.3607.15605305725462289', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '58.39.143.214', '2019-06-15 00:42:53', 8, 0, '', '2019-06-15 00:42:53');
INSERT INTO `access_log` VALUES (37159, '65.47.15605305818940517', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '58.39.143.214', '2019-06-15 00:43:02', 8, 0, '', '2019-06-15 00:43:02');
INSERT INTO `access_log` VALUES (37160, '65.53.15605305819040513', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '58.39.143.214', '2019-06-15 00:43:02', 9, 2001001000, '服务端发生异常', '2019-06-15 00:43:02');
INSERT INTO `access_log` VALUES (37161, '65.51.15605305819140555', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '58.39.143.214', '2019-06-15 00:43:02', 8, 0, '', '2019-06-15 00:43:02');
INSERT INTO `access_log` VALUES (37162, '59.73.15605608778260297', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.10.81.141', '2019-06-15 09:07:58', 18, 0, '', '2019-06-15 09:07:58');
INSERT INTO `access_log` VALUES (37163, '59.72.15605608778290293', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.10.81.141', '2019-06-15 09:07:58', 32, 2001001000, '服务端发生异常', '2019-06-15 09:07:58');
INSERT INTO `access_log` VALUES (37164, '64.77.15605610157860243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.10.81.141', '2019-06-15 09:10:16', 12, 0, '', '2019-06-15 09:10:16');
INSERT INTO `access_log` VALUES (37165, '64.84.15605610159330237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.10.81.141', '2019-06-15 09:10:16', 3, 0, '', '2019-06-15 09:10:16');
INSERT INTO `access_log` VALUES (37166, '59.76.15605630192640319', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '106.122.174.70', '2019-06-15 09:43:39', 23, 2001001000, '服务端发生异常', '2019-06-15 09:43:39');
INSERT INTO `access_log` VALUES (37167, '59.71.15605630192620325', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '106.122.174.70', '2019-06-15 09:43:39', 458, 0, '', '2019-06-15 09:43:40');
INSERT INTO `access_log` VALUES (37168, '65.49.15605641321170993', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.42.241.116', '2019-06-15 10:02:12', 1, 1002001015, '账号未登陆', '2019-06-15 10:02:12');
INSERT INTO `access_log` VALUES (37169, '65.54.15605641321180937', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.42.241.116', '2019-06-15 10:02:12', 1, 1002001015, '账号未登陆', '2019-06-15 10:02:12');
INSERT INTO `access_log` VALUES (37170, '65.50.15605641321170991', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.42.241.116', '2019-06-15 10:02:12', 1, 1002001015, '账号未登陆', '2019-06-15 10:02:12');
INSERT INTO `access_log` VALUES (37171, '65.3607.15605641346742739', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.42.241.116', '2019-06-15 10:02:15', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 10:02:15');
INSERT INTO `access_log` VALUES (37172, '65.46.15605641420120983', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.42.241.116', '2019-06-15 10:02:22', 95, 0, '', '2019-06-15 10:02:22');
INSERT INTO `access_log` VALUES (37173, '65.52.15605641424130987', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.42.241.116', '2019-06-15 10:02:22', 17, 0, '', '2019-06-15 10:02:22');
INSERT INTO `access_log` VALUES (37174, '65.47.15605641424160967', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.42.241.116', '2019-06-15 10:02:22', 18, 2001001000, '服务端发生异常', '2019-06-15 10:02:22');
INSERT INTO `access_log` VALUES (37175, '65.53.15605641424220963', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.42.241.116', '2019-06-15 10:02:22', 17, 0, '', '2019-06-15 10:02:22');
INSERT INTO `access_log` VALUES (37176, '59.80.15605643835760331', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.42.241.116', '2019-06-15 10:06:24', 5, 0, '', '2019-06-15 10:06:24');
INSERT INTO `access_log` VALUES (37177, '59.74.15605643835770339', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.42.241.116', '2019-06-15 10:06:24', 26, 2001001000, '服务端发生异常', '2019-06-15 10:06:24');
INSERT INTO `access_log` VALUES (37178, '65.53.15605643946820967', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.42.241.116', '2019-06-15 10:06:35', 286, 0, '', '2019-06-15 10:06:35');
INSERT INTO `access_log` VALUES (37179, '65.47.15605643946910971', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.42.241.116', '2019-06-15 10:06:35', 277, 0, '', '2019-06-15 10:06:35');
INSERT INTO `access_log` VALUES (37180, '65.52.15605643946860991', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.42.241.116', '2019-06-15 10:06:35', 283, 2001001000, '服务端发生异常', '2019-06-15 10:06:35');
INSERT INTO `access_log` VALUES (37181, '65.45.15605644037360987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.42.241.116', '2019-06-15 10:06:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 10:06:44');
INSERT INTO `access_log` VALUES (37182, '65.49.15605669489421033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:49:09', 1, 1002001015, '账号未登陆', '2019-06-15 10:49:09');
INSERT INTO `access_log` VALUES (37183, '65.45.15605669489421021', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:49:09', 1, 1002001015, '账号未登陆', '2019-06-15 10:49:09');
INSERT INTO `access_log` VALUES (37184, '65.54.15605669489420977', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:49:09', 0, 1002001015, '账号未登陆', '2019-06-15 10:49:09');
INSERT INTO `access_log` VALUES (37185, '65.3607.15605669593692779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:49:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 10:49:19');
INSERT INTO `access_log` VALUES (37186, '65.53.15605669654631003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:49:25', 55, 0, '', '2019-06-15 10:49:26');
INSERT INTO `access_log` VALUES (37187, '65.52.15605669657911027', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:49:26', 11, 0, '', '2019-06-15 10:49:26');
INSERT INTO `access_log` VALUES (37188, '65.51.15605669657961043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:49:26', 10, 0, '', '2019-06-15 10:49:26');
INSERT INTO `access_log` VALUES (37189, '65.47.15605669657931007', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:49:26', 12, 2001001000, '服务端发生异常', '2019-06-15 10:49:26');
INSERT INTO `access_log` VALUES (37190, '65.50.15605669729411033', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:49:33', 10, 0, '', '2019-06-15 10:49:33');
INSERT INTO `access_log` VALUES (37191, '65.45.15605669729451023', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:49:33', 9, 2001001000, '服务端发生异常', '2019-06-15 10:49:33');
INSERT INTO `access_log` VALUES (37192, '65.54.15605669729470979', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:49:33', 8, 0, '', '2019-06-15 10:49:33');
INSERT INTO `access_log` VALUES (37193, '65.49.15605669772491035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:49:37', 9, 0, '', '2019-06-15 10:49:37');
INSERT INTO `access_log` VALUES (37194, '65.3607.15605669772532781', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:49:37', 9, 2001001000, '服务端发生异常', '2019-06-15 10:49:37');
INSERT INTO `access_log` VALUES (37195, '65.46.15605669772561025', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:49:37', 35, 0, '', '2019-06-15 10:49:37');
INSERT INTO `access_log` VALUES (37196, '65.54.15605671922140983', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:53:12', 11, 0, '', '2019-06-15 10:53:12');
INSERT INTO `access_log` VALUES (37197, '65.50.15605671922181037', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:53:12', 11, 2001001000, '服务端发生异常', '2019-06-15 10:53:12');
INSERT INTO `access_log` VALUES (37198, '65.49.15605671922221039', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:53:12', 9, 0, '', '2019-06-15 10:53:12');
INSERT INTO `access_log` VALUES (37199, '65.53.15605672333241009', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:53:53', 9, 0, '', '2019-06-15 10:53:53');
INSERT INTO `access_log` VALUES (37200, '65.51.15605672333301049', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:53:53', 9, 2001001000, '服务端发生异常', '2019-06-15 10:53:53');
INSERT INTO `access_log` VALUES (37201, '65.52.15605672333391033', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.237.74', '2019-06-15 10:53:53', 8, 0, '', '2019-06-15 10:53:53');
INSERT INTO `access_log` VALUES (37202, '65.47.15605692985761041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '122.233.104.46', '2019-06-15 11:28:19', 0, 1002001015, '账号未登陆', '2019-06-15 11:28:19');
INSERT INTO `access_log` VALUES (37203, '65.52.15605692985761061', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '122.233.104.46', '2019-06-15 11:28:19', 0, 1002001015, '账号未登陆', '2019-06-15 11:28:19');
INSERT INTO `access_log` VALUES (37204, '65.51.15605692985751077', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '122.233.104.46', '2019-06-15 11:28:19', 0, 1002001015, '账号未登陆', '2019-06-15 11:28:19');
INSERT INTO `access_log` VALUES (37205, '65.45.15605693009801057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '122.233.104.46', '2019-06-15 11:28:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 11:28:21');
INSERT INTO `access_log` VALUES (37206, '65.54.15605693056221013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '122.233.104.46', '2019-06-15 11:28:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 11:28:26');
INSERT INTO `access_log` VALUES (37207, '65.50.15605693100171067', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '122.233.104.46', '2019-06-15 11:28:30', 5, 1002002001, '密码不正确', '2019-06-15 11:28:30');
INSERT INTO `access_log` VALUES (37208, '65.46.15605693203931059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '122.233.104.46', '2019-06-15 11:28:40', 98, 0, '', '2019-06-15 11:28:40');
INSERT INTO `access_log` VALUES (37209, '65.53.15605693207031039', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '122.233.104.46', '2019-06-15 11:28:41', 10, 0, '', '2019-06-15 11:28:41');
INSERT INTO `access_log` VALUES (37210, '65.47.15605693207051043', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '122.233.104.46', '2019-06-15 11:28:41', 11, 2001001000, '服务端发生异常', '2019-06-15 11:28:41');
INSERT INTO `access_log` VALUES (37211, '65.51.15605693207091079', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '122.233.104.46', '2019-06-15 11:28:41', 9, 0, '', '2019-06-15 11:28:41');
INSERT INTO `access_log` VALUES (37212, '65.52.15605693258141063', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '122.233.104.46', '2019-06-15 11:28:46', 14, 0, '', '2019-06-15 11:28:46');
INSERT INTO `access_log` VALUES (37213, '65.49.15605693258201071', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '122.233.104.46', '2019-06-15 11:28:46', 13, 0, '', '2019-06-15 11:28:46');
INSERT INTO `access_log` VALUES (37214, '65.45.15605693258201059', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '122.233.104.46', '2019-06-15 11:28:46', 14, 2001001000, '服务端发生异常', '2019-06-15 11:28:46');
INSERT INTO `access_log` VALUES (37215, '65.46.15605764066311155', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:26:47', 1, 1002001015, '账号未登陆', '2019-06-15 13:26:47');
INSERT INTO `access_log` VALUES (37216, '65.3607.15605764066312911', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:26:47', 1, 1002001015, '账号未登陆', '2019-06-15 13:26:47');
INSERT INTO `access_log` VALUES (37217, '65.51.15605764066311175', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:26:47', 0, 1002001015, '账号未登陆', '2019-06-15 13:26:47');
INSERT INTO `access_log` VALUES (37218, '65.47.15605764133381139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:26:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 13:26:53');
INSERT INTO `access_log` VALUES (37219, '65.49.15605764282511167', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:27:08', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 13:27:08');
INSERT INTO `access_log` VALUES (37220, '65.45.15605764420011155', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:27:22', 206, 0, '', '2019-06-15 13:27:22');
INSERT INTO `access_log` VALUES (37221, '65.51.15605764431271177', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:27:23', 12, 0, '', '2019-06-15 13:27:23');
INSERT INTO `access_log` VALUES (37222, '65.54.15605764431251111', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:27:23', 12, 0, '', '2019-06-15 13:27:23');
INSERT INTO `access_log` VALUES (37223, '65.50.15605764431271165', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:27:23', 12, 2001001000, '服务端发生异常', '2019-06-15 13:27:23');
INSERT INTO `access_log` VALUES (37224, '65.47.15605764474211141', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:27:27', 10, 2001001000, '服务端发生异常', '2019-06-15 13:27:27');
INSERT INTO `access_log` VALUES (37225, '65.46.15605764474181157', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:27:27', 191, 0, '', '2019-06-15 13:27:28');
INSERT INTO `access_log` VALUES (37226, '65.53.15605764474211137', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:27:27', 188, 0, '', '2019-06-15 13:27:28');
INSERT INTO `access_log` VALUES (37227, '65.49.15605764483011169', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:27:28', 8, 0, '', '2019-06-15 13:27:28');
INSERT INTO `access_log` VALUES (37228, '65.52.15605764483111161', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:27:28', 9, 0, '', '2019-06-15 13:27:28');
INSERT INTO `access_log` VALUES (37229, '65.45.15605764483111157', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '59.42.26.145', '2019-06-15 13:27:28', 9, 2001001000, '服务端发生异常', '2019-06-15 13:27:28');
INSERT INTO `access_log` VALUES (37230, '65.50.15605771686241175', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 13:39:29', 0, 1002001015, '账号未登陆', '2019-06-15 13:39:29');
INSERT INTO `access_log` VALUES (37231, '65.54.15605771686321125', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 13:39:29', 0, 1002001015, '账号未登陆', '2019-06-15 13:39:29');
INSERT INTO `access_log` VALUES (37232, '65.47.15605771686331153', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 13:39:29', 0, 1002001015, '账号未登陆', '2019-06-15 13:39:29');
INSERT INTO `access_log` VALUES (37233, '65.3607.15605771868902925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 13:39:47', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 13:39:47');
INSERT INTO `access_log` VALUES (37234, '65.45.15605771993411169', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 13:39:59', 87, 0, '', '2019-06-15 13:39:59');
INSERT INTO `access_log` VALUES (37235, '65.52.15605771998161173', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 13:40:00', 9, 0, '', '2019-06-15 13:40:00');
INSERT INTO `access_log` VALUES (37236, '65.49.15605771998161181', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 13:40:00', 12, 2001001000, '服务端发生异常', '2019-06-15 13:40:00');
INSERT INTO `access_log` VALUES (37237, '65.51.15605771998221189', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 13:40:00', 9, 0, '', '2019-06-15 13:40:00');
INSERT INTO `access_log` VALUES (37238, '65.53.15605772493321151', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 13:40:49', 9, 0, '', '2019-06-15 13:40:49');
INSERT INTO `access_log` VALUES (37239, '65.3607.15605772493402927', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 13:40:49', 10, 2001001000, '服务端发生异常', '2019-06-15 13:40:49');
INSERT INTO `access_log` VALUES (37240, '65.46.15605772493441171', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 13:40:49', 8, 0, '', '2019-06-15 13:40:49');
INSERT INTO `access_log` VALUES (37241, '65.49.15605772613551183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 13:41:01', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 13:41:01');
INSERT INTO `access_log` VALUES (37242, '59.78.15605785347410531', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 14:02:15', 10, 0, '', '2019-06-15 14:02:15');
INSERT INTO `access_log` VALUES (37243, '59.75.15605785347490535', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 14:02:15', 20, 2001001000, '服务端发生异常', '2019-06-15 14:02:15');
INSERT INTO `access_log` VALUES (37244, '64.84.15605785405890471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 14:02:21', 12, 0, '', '2019-06-15 14:02:21');
INSERT INTO `access_log` VALUES (37245, '64.82.15605785407330477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 14:02:21', 3, 0, '', '2019-06-15 14:02:21');
INSERT INTO `access_log` VALUES (37246, '64.76.15605785420470463', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 14:02:22', 2, 0, '', '2019-06-15 14:02:22');
INSERT INTO `access_log` VALUES (37247, '64.85.15605785432180483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 14:02:23', 1, 0, '', '2019-06-15 14:02:23');
INSERT INTO `access_log` VALUES (37248, '59.71.15605785447460533', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 14:02:25', 3, 0, '', '2019-06-15 14:02:25');
INSERT INTO `access_log` VALUES (37249, '59.77.15605785447600519', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '116.117.135.205', '2019-06-15 14:02:25', 15, 2001001000, '服务端发生异常', '2019-06-15 14:02:25');
INSERT INTO `access_log` VALUES (37250, '59.76.15605787948960531', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '27.195.156.186', '2019-06-15 14:06:35', 3, 0, '', '2019-06-15 14:06:35');
INSERT INTO `access_log` VALUES (37251, '59.71.15605787948970537', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '27.195.156.186', '2019-06-15 14:06:35', 56, 2001001000, '服务端发生异常', '2019-06-15 14:06:35');
INSERT INTO `access_log` VALUES (37252, '64.82.15605787990500481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '27.195.156.186', '2019-06-15 14:06:39', 3, 0, '', '2019-06-15 14:06:39');
INSERT INTO `access_log` VALUES (37253, '64.76.15605787992150467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '27.195.156.186', '2019-06-15 14:06:39', 2, 0, '', '2019-06-15 14:06:39');
INSERT INTO `access_log` VALUES (37254, '64.85.15605788006880487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '27.195.156.186', '2019-06-15 14:06:41', 2, 0, '', '2019-06-15 14:06:41');
INSERT INTO `access_log` VALUES (37255, '64.79.15605788012160471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '27.195.156.186', '2019-06-15 14:06:41', 2, 0, '', '2019-06-15 14:06:41');
INSERT INTO `access_log` VALUES (37256, '65.52.15605788158011195', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '27.195.156.186', '2019-06-15 14:06:56', 0, 1002001015, '账号未登陆', '2019-06-15 14:06:56');
INSERT INTO `access_log` VALUES (37257, '65.51.15605788158031213', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '27.195.156.186', '2019-06-15 14:06:56', 0, 1002001015, '账号未登陆', '2019-06-15 14:06:56');
INSERT INTO `access_log` VALUES (37258, '65.49.15605788158031205', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '27.195.156.186', '2019-06-15 14:06:56', 0, 1002001015, '账号未登陆', '2019-06-15 14:06:56');
INSERT INTO `access_log` VALUES (37259, '65.54.15605788521621151', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '27.195.156.186', '2019-06-15 14:07:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 14:07:32');
INSERT INTO `access_log` VALUES (37260, '65.46.15605788794761195', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '27.195.156.186', '2019-06-15 14:07:59', 100, 0, '', '2019-06-15 14:08:00');
INSERT INTO `access_log` VALUES (37261, '65.49.15605788962451207', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '27.195.156.186', '2019-06-15 14:08:16', 145, 0, '', '2019-06-15 14:08:16');
INSERT INTO `access_log` VALUES (37262, '65.52.15605788967021197', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '27.195.156.186', '2019-06-15 14:08:17', 10, 0, '', '2019-06-15 14:08:17');
INSERT INTO `access_log` VALUES (37263, '65.51.15605788967071215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '27.195.156.186', '2019-06-15 14:08:17', 10, 2001001000, '服务端发生异常', '2019-06-15 14:08:17');
INSERT INTO `access_log` VALUES (37264, '65.45.15605788967111195', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '27.195.156.186', '2019-06-15 14:08:17', 9, 0, '', '2019-06-15 14:08:17');
INSERT INTO `access_log` VALUES (37265, '59.72.15605790094810537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.117.135.205', '2019-06-15 14:10:09', 3, 0, '', '2019-06-15 14:10:09');
INSERT INTO `access_log` VALUES (37266, '59.79.15605790094850543', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.117.135.205', '2019-06-15 14:10:09', 13, 2001001000, '服务端发生异常', '2019-06-15 14:10:10');
INSERT INTO `access_log` VALUES (37267, '64.84.15605790215820479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.117.135.205', '2019-06-15 14:10:22', 2, 0, '', '2019-06-15 14:10:22');
INSERT INTO `access_log` VALUES (37268, '64.82.15605790217570485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.117.135.205', '2019-06-15 14:10:22', 1, 0, '', '2019-06-15 14:10:22');
INSERT INTO `access_log` VALUES (37269, '64.76.15605790267540471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.117.135.205', '2019-06-15 14:10:27', 2, 0, '', '2019-06-15 14:10:27');
INSERT INTO `access_log` VALUES (37270, '64.85.15605790269010491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.117.135.205', '2019-06-15 14:10:27', 1, 0, '', '2019-06-15 14:10:27');
INSERT INTO `access_log` VALUES (37271, '64.79.15605790328570475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.117.135.205', '2019-06-15 14:10:33', 2, 0, '', '2019-06-15 14:10:33');
INSERT INTO `access_log` VALUES (37272, '64.81.15605790330060481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.117.135.205', '2019-06-15 14:10:33', 2, 0, '', '2019-06-15 14:10:33');
INSERT INTO `access_log` VALUES (37273, '59.76.15605790339690535', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.117.135.205', '2019-06-15 14:10:34', 2, 0, '', '2019-06-15 14:10:34');
INSERT INTO `access_log` VALUES (37274, '59.75.15605790339690543', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.117.135.205', '2019-06-15 14:10:34', 32, 2001001000, '服务端发生异常', '2019-06-15 14:10:34');
INSERT INTO `access_log` VALUES (37275, '65.49.15605806567501231', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '14.120.118.73', '2019-06-15 14:37:37', 0, 1002001015, '账号未登陆', '2019-06-15 14:37:37');
INSERT INTO `access_log` VALUES (37276, '65.52.15605806567521223', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '14.120.118.73', '2019-06-15 14:37:37', 0, 1002001015, '账号未登陆', '2019-06-15 14:37:37');
INSERT INTO `access_log` VALUES (37277, '65.51.15605806567561241', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '14.120.118.73', '2019-06-15 14:37:37', 0, 1002001015, '账号未登陆', '2019-06-15 14:37:37');
INSERT INTO `access_log` VALUES (37278, '65.50.15605806601601227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '14.120.118.73', '2019-06-15 14:37:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 14:37:40');
INSERT INTO `access_log` VALUES (37279, '65.47.15605806823501207', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '14.120.118.73', '2019-06-15 14:38:02', 59, 0, '', '2019-06-15 14:38:02');
INSERT INTO `access_log` VALUES (37280, '65.3607.15605806829682979', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '14.120.118.73', '2019-06-15 14:38:03', 9, 0, '', '2019-06-15 14:38:03');
INSERT INTO `access_log` VALUES (37281, '65.46.15605806829701221', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '14.120.118.73', '2019-06-15 14:38:03', 10, 2001001000, '服务端发生异常', '2019-06-15 14:38:03');
INSERT INTO `access_log` VALUES (37282, '65.53.15605806829741201', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '14.120.118.73', '2019-06-15 14:38:03', 16, 0, '', '2019-06-15 14:38:03');
INSERT INTO `access_log` VALUES (37283, '65.53.15605811186151207', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.104.3.193', '2019-06-15 14:45:19', 0, 1002001015, '账号未登陆', '2019-06-15 14:45:19');
INSERT INTO `access_log` VALUES (37284, '65.51.15605811186171249', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.104.3.193', '2019-06-15 14:45:19', 1, 1002001015, '账号未登陆', '2019-06-15 14:45:19');
INSERT INTO `access_log` VALUES (37285, '65.49.15605811186211239', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.104.3.193', '2019-06-15 14:45:19', 0, 1002001015, '账号未登陆', '2019-06-15 14:45:19');
INSERT INTO `access_log` VALUES (37286, '65.52.15605811219571231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.104.3.193', '2019-06-15 14:45:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 14:45:22');
INSERT INTO `access_log` VALUES (37287, '65.50.15605811366181235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.104.3.193', '2019-06-15 14:45:37', 96, 0, '', '2019-06-15 14:45:37');
INSERT INTO `access_log` VALUES (37288, '65.54.15605811373711183', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.104.3.193', '2019-06-15 14:45:37', 9, 0, '', '2019-06-15 14:45:37');
INSERT INTO `access_log` VALUES (37289, '65.3607.15605811373762987', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.104.3.193', '2019-06-15 14:45:37', 15, 0, '', '2019-06-15 14:45:37');
INSERT INTO `access_log` VALUES (37290, '65.47.15605811373741215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.104.3.193', '2019-06-15 14:45:37', 18, 2001001000, '服务端发生异常', '2019-06-15 14:45:37');
INSERT INTO `access_log` VALUES (37291, '65.45.15605856195831289', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.218.25.158', '2019-06-15 16:00:20', 1, 1002001015, '账号未登陆', '2019-06-15 16:00:20');
INSERT INTO `access_log` VALUES (37292, '65.47.15605856195831277', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.218.25.158', '2019-06-15 16:00:20', 1, 1002001015, '账号未登陆', '2019-06-15 16:00:20');
INSERT INTO `access_log` VALUES (37293, '65.46.15605856195841291', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.218.25.158', '2019-06-15 16:00:20', 0, 1002001015, '账号未登陆', '2019-06-15 16:00:20');
INSERT INTO `access_log` VALUES (37294, '59.77.15605869601830633', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.131.96.155', '2019-06-15 16:22:40', 30, 2001001000, '服务端发生异常', '2019-06-15 16:22:40');
INSERT INTO `access_log` VALUES (37295, '59.80.15605869604170635', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.131.96.155', '2019-06-15 16:22:40', 18, 0, '', '2019-06-15 16:22:40');
INSERT INTO `access_log` VALUES (37296, '64.79.15605869637210583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-15 16:22:44', 13, 0, '', '2019-06-15 16:22:44');
INSERT INTO `access_log` VALUES (37297, '64.80.15605869638820589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-15 16:22:44', 8, 0, '', '2019-06-15 16:22:44');
INSERT INTO `access_log` VALUES (37298, '64.78.15605869646920589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-15 16:22:45', 8, 0, '', '2019-06-15 16:22:45');
INSERT INTO `access_log` VALUES (37299, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-15 16:22:45', 17, 0, '', '2019-06-15 16:22:45');
INSERT INTO `access_log` VALUES (37300, '64.84.15605869656240587', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-15 16:22:46', 14, 0, '', '2019-06-15 16:22:46');
INSERT INTO `access_log` VALUES (37301, '64.81.15605869709610589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-15 16:22:51', 12, 0, '', '2019-06-15 16:22:51');
INSERT INTO `access_log` VALUES (37302, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-15 16:22:51', 15, 0, '', '2019-06-15 16:22:51');
INSERT INTO `access_log` VALUES (37303, '64.85.15605869718230601', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-15 16:22:52', 13, 0, '', '2019-06-15 16:22:52');
INSERT INTO `access_log` VALUES (37304, '64.83.15605869768240579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-15 16:22:57', 7, 0, '', '2019-06-15 16:22:57');
INSERT INTO `access_log` VALUES (37305, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-15 16:22:57', 12, 0, '', '2019-06-15 16:22:57');
INSERT INTO `access_log` VALUES (37306, '65.53.15605934214761373', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.200.187.49', '2019-06-15 18:10:21', 1, 1002001015, '账号未登陆', '2019-06-15 18:10:21');
INSERT INTO `access_log` VALUES (37307, '65.49.15605934214771405', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.200.187.49', '2019-06-15 18:10:21', 1, 1002001015, '账号未登陆', '2019-06-15 18:10:21');
INSERT INTO `access_log` VALUES (37308, '65.54.15605934215011351', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.200.187.49', '2019-06-15 18:10:22', 0, 1002001015, '账号未登陆', '2019-06-15 18:10:22');
INSERT INTO `access_log` VALUES (37309, '65.3607.15605934473203153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.200.187.49', '2019-06-15 18:10:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 18:10:47');
INSERT INTO `access_log` VALUES (37310, '65.49.15605935438551407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.200.187.49', '2019-06-15 18:12:24', 70, 0, '', '2019-06-15 18:12:24');
INSERT INTO `access_log` VALUES (37311, '65.47.15605935441961389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.200.187.49', '2019-06-15 18:12:24', 151, 0, '', '2019-06-15 18:12:24');
INSERT INTO `access_log` VALUES (37312, '65.45.15605935442011399', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.200.187.49', '2019-06-15 18:12:24', 150, 0, '', '2019-06-15 18:12:24');
INSERT INTO `access_log` VALUES (37313, '65.3607.15605935442013155', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.200.187.49', '2019-06-15 18:12:24', 150, 2001001000, '服务端发生异常', '2019-06-15 18:12:24');
INSERT INTO `access_log` VALUES (37314, '65.3607.15605963821973193', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.23.155.0', '2019-06-15 18:59:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 18:59:42');
INSERT INTO `access_log` VALUES (37315, '65.51.15605963930981459', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.23.155.0', '2019-06-15 18:59:53', 68, 0, '', '2019-06-15 18:59:53');
INSERT INTO `access_log` VALUES (37316, '65.46.15605963934661439', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.65.230.58', '2019-06-15 18:59:53', 158, 0, '', '2019-06-15 18:59:54');
INSERT INTO `access_log` VALUES (37317, '65.52.15605963934721441', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.23.155.0', '2019-06-15 18:59:53', 155, 0, '', '2019-06-15 18:59:54');
INSERT INTO `access_log` VALUES (37318, '65.53.15605963934721415', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '116.23.155.0', '2019-06-15 18:59:53', 154, 2001001000, '服务端发生异常', '2019-06-15 18:59:54');
INSERT INTO `access_log` VALUES (37319, '59.74.15605964057020769', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.65.230.58', '2019-06-15 19:00:06', 10, 0, '', '2019-06-15 19:00:06');
INSERT INTO `access_log` VALUES (37320, '59.73.15605964057040775', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.65.230.58', '2019-06-15 19:00:06', 14, 2001001000, '服务端发生异常', '2019-06-15 19:00:06');
INSERT INTO `access_log` VALUES (37321, '64.83.15605964084390705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.65.230.58', '2019-06-15 19:00:08', 10, 0, '', '2019-06-15 19:00:08');
INSERT INTO `access_log` VALUES (37322, '64.78.15605964086400717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.65.230.58', '2019-06-15 19:00:09', 2, 0, '', '2019-06-15 19:00:09');
INSERT INTO `access_log` VALUES (37323, '59.79.15605964094400777', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.65.230.58', '2019-06-15 19:00:09', 4, 0, '', '2019-06-15 19:00:09');
INSERT INTO `access_log` VALUES (37324, '59.72.15605964094400771', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.65.230.58', '2019-06-15 19:00:09', 25, 2001001000, '服务端发生异常', '2019-06-15 19:00:09');
INSERT INTO `access_log` VALUES (37325, '64.77.15605964116610721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.65.230.58', '2019-06-15 19:00:12', 2, 0, '', '2019-06-15 19:00:12');
INSERT INTO `access_log` VALUES (37326, '64.84.15605964117600715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.65.230.58', '2019-06-15 19:00:12', 2, 0, '', '2019-06-15 19:00:12');
INSERT INTO `access_log` VALUES (37327, '64.82.15605964124770723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.65.230.58', '2019-06-15 19:00:12', 2, 0, '', '2019-06-15 19:00:12');
INSERT INTO `access_log` VALUES (37328, '64.76.15605964127680707', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.65.230.58', '2019-06-15 19:00:13', 2, 0, '', '2019-06-15 19:00:13');
INSERT INTO `access_log` VALUES (37329, '64.81.15605964132620717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.65.230.58', '2019-06-15 19:00:13', 2, 0, '', '2019-06-15 19:00:13');
INSERT INTO `access_log` VALUES (37330, '65.46.15606110554441635', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:04:15', 14, 1002001012, '访问令牌已过期', '2019-06-15 23:04:15');
INSERT INTO `access_log` VALUES (37331, '65.53.15606110554441611', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:04:15', 23, 1002001012, '访问令牌已过期', '2019-06-15 23:04:15');
INSERT INTO `access_log` VALUES (37332, '65.54.15606110554441589', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:04:15', 26, 1002001012, '访问令牌已过期', '2019-06-15 23:04:15');
INSERT INTO `access_log` VALUES (37333, '65.49.15606110764761643', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:04:36', 63, 0, '', '2019-06-15 23:04:37');
INSERT INTO `access_log` VALUES (37334, '65.3607.15606110768963391', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:04:37', 11, 0, '', '2019-06-15 23:04:37');
INSERT INTO `access_log` VALUES (37335, '65.45.15606110768961635', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:04:37', 12, 0, '', '2019-06-15 23:04:37');
INSERT INTO `access_log` VALUES (37336, '65.47.15606110768961625', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:04:37', 13, 2001001000, '服务端发生异常', '2019-06-15 23:04:37');
INSERT INTO `access_log` VALUES (37337, '65.52.15606110899881639', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:04:50', 8, 0, '', '2019-06-15 23:04:50');
INSERT INTO `access_log` VALUES (37338, '65.53.15606110899881613', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:04:50', 10, 2001001000, '服务端发生异常', '2019-06-15 23:04:50');
INSERT INTO `access_log` VALUES (37339, '65.54.15606110899971591', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:04:50', 535, 0, '', '2019-06-15 23:04:51');
INSERT INTO `access_log` VALUES (37340, '59.71.15606111176320971', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:05:18', 66, 0, '', '2019-06-15 23:05:18');
INSERT INTO `access_log` VALUES (37341, '59.75.15606111176320973', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:05:18', 85, 2001001000, '服务端发生异常', '2019-06-15 23:05:18');
INSERT INTO `access_log` VALUES (37342, '64.80.15606111286240915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:05:29', 19, 0, '', '2019-06-15 23:05:29');
INSERT INTO `access_log` VALUES (37343, '64.78.15606111296730915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:05:30', 9, 0, '', '2019-06-15 23:05:30');
INSERT INTO `access_log` VALUES (37344, '64.77.15606111332730919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:05:33', 7, 0, '', '2019-06-15 23:05:33');
INSERT INTO `access_log` VALUES (37345, '64.84.15606111341430913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:05:34', 6, 0, '', '2019-06-15 23:05:34');
INSERT INTO `access_log` VALUES (37346, '64.76.15606111382350905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:05:38', 7, 0, '', '2019-06-15 23:05:38');
INSERT INTO `access_log` VALUES (37347, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:05:38', 14, 0, '', '2019-06-15 23:05:38');
INSERT INTO `access_log` VALUES (37348, '64.79.15606111419720911', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:05:42', 71, 0, '', '2019-06-15 23:05:42');
INSERT INTO `access_log` VALUES (37349, '66.50.15606111610019359', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:06:01', 17, 0, '', '2019-06-15 23:06:01');
INSERT INTO `access_log` VALUES (37350, '64.83.15606111674130905', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:06:07', 11, 0, '', '2019-06-15 23:06:07');
INSERT INTO `access_log` VALUES (37351, '64.78.15606111680920917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:06:08', 8, 0, '', '2019-06-15 23:06:08');
INSERT INTO `access_log` VALUES (37352, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:06:08', 15, 0, '', '2019-06-15 23:06:08');
INSERT INTO `access_log` VALUES (37353, '64.77.15606111691250921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:06:09', 6, 0, '', '2019-06-15 23:06:09');
INSERT INTO `access_log` VALUES (37354, '64.84.15606111692820915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:06:09', 6, 0, '', '2019-06-15 23:06:09');
INSERT INTO `access_log` VALUES (37355, '59.72.15606111717030969', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:06:12', 10, 0, '', '2019-06-15 23:06:12');
INSERT INTO `access_log` VALUES (37356, '59.79.15606111717030975', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '49.95.192.82', '2019-06-15 23:06:12', 23, 2001001000, '服务端发生异常', '2019-06-15 23:06:12');
INSERT INTO `access_log` VALUES (37357, '64.76.15606111811760907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:06:21', 7, 0, '', '2019-06-15 23:06:21');
INSERT INTO `access_log` VALUES (37358, '64.81.15606111813420917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:06:21', 7, 0, '', '2019-06-15 23:06:21');
INSERT INTO `access_log` VALUES (37359, '59.75.15606111816120975', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:06:22', 9, 0, '', '2019-06-15 23:06:22');
INSERT INTO `access_log` VALUES (37360, '59.78.15606111816120971', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:06:22', 19, 2001001000, '服务端发生异常', '2019-06-15 23:06:22');
INSERT INTO `access_log` VALUES (37361, '65.52.15606111967301641', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:06:37', 9, 0, '', '2019-06-15 23:06:37');
INSERT INTO `access_log` VALUES (37362, '65.53.15606111967311615', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:06:37', 11, 2001001000, '服务端发生异常', '2019-06-15 23:06:37');
INSERT INTO `access_log` VALUES (37363, '65.54.15606111967421593', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '49.95.192.82', '2019-06-15 23:06:37', 9, 0, '', '2019-06-15 23:06:37');
INSERT INTO `access_log` VALUES (37364, '65.46.15606113419781641', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '110.124.179.46', '2019-06-15 23:09:02', 1, 1002001015, '账号未登陆', '2019-06-15 23:09:02');
INSERT INTO `access_log` VALUES (37365, '65.50.15606113419991647', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '110.124.179.46', '2019-06-15 23:09:02', 1, 1002001015, '账号未登陆', '2019-06-15 23:09:02');
INSERT INTO `access_log` VALUES (37366, '65.49.15606113420091649', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '110.124.179.46', '2019-06-15 23:09:02', 1, 1002001015, '账号未登陆', '2019-06-15 23:09:02');
INSERT INTO `access_log` VALUES (37367, '59.80.15606113487400963', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '110.124.179.46', '2019-06-15 23:09:09', 4, 0, '', '2019-06-15 23:09:09');
INSERT INTO `access_log` VALUES (37368, '59.77.15606113487350961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '110.124.179.46', '2019-06-15 23:09:09', 14, 2001001000, '服务端发生异常', '2019-06-15 23:09:09');
INSERT INTO `access_log` VALUES (37369, '64.85.15606113526900931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '110.124.179.46', '2019-06-15 23:09:13', 3, 0, '', '2019-06-15 23:09:13');
INSERT INTO `access_log` VALUES (37370, '64.80.15606113529270921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '110.124.179.46', '2019-06-15 23:09:13', 2, 0, '', '2019-06-15 23:09:13');
INSERT INTO `access_log` VALUES (37371, '64.83.15606113573040909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '110.124.179.46', '2019-06-15 23:09:17', 2, 0, '', '2019-06-15 23:09:17');
INSERT INTO `access_log` VALUES (37372, '64.78.15606113575690921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '110.124.179.46', '2019-06-15 23:09:18', 1, 0, '', '2019-06-15 23:09:18');
INSERT INTO `access_log` VALUES (37373, '59.73.15606113590610977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '110.124.179.46', '2019-06-15 23:09:19', 3, 0, '', '2019-06-15 23:09:19');
INSERT INTO `access_log` VALUES (37374, '59.74.15606113590340971', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '110.124.179.46', '2019-06-15 23:09:19', 36, 2001001000, '服务端发生异常', '2019-06-15 23:09:19');
INSERT INTO `access_log` VALUES (37375, '59.74.15606128382520991', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:33:58', 3, 0, '', '2019-06-15 23:33:58');
INSERT INTO `access_log` VALUES (37376, '59.73.15606128382520997', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:33:58', 21, 2001001000, '服务端发生异常', '2019-06-15 23:33:58');
INSERT INTO `access_log` VALUES (37377, '64.78.15606128423900941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:02', 2, 0, '', '2019-06-15 23:34:02');
INSERT INTO `access_log` VALUES (37378, '64.77.15606128425280945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:03', 2, 0, '', '2019-06-15 23:34:03');
INSERT INTO `access_log` VALUES (37379, '64.84.15606128449150939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:05', 2, 0, '', '2019-06-15 23:34:05');
INSERT INTO `access_log` VALUES (37380, '64.82.15606128455020947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:06', 2, 0, '', '2019-06-15 23:34:06');
INSERT INTO `access_log` VALUES (37381, '64.81.15606128490040941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:09', 2, 0, '', '2019-06-15 23:34:09');
INSERT INTO `access_log` VALUES (37382, '64.79.15606128491340937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:09', 2, 0, '', '2019-06-15 23:34:09');
INSERT INTO `access_log` VALUES (37383, '59.76.15606128496700991', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:10', 2, 0, '', '2019-06-15 23:34:10');
INSERT INTO `access_log` VALUES (37384, '59.75.15606128496700999', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:10', 9, 2001001000, '服务端发生异常', '2019-06-15 23:34:10');
INSERT INTO `access_log` VALUES (37385, '65.3607.15606128579923417', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:18', 0, 1002001015, '账号未登陆', '2019-06-15 23:34:18');
INSERT INTO `access_log` VALUES (37386, '65.47.15606128579921651', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:18', 0, 1002001015, '账号未登陆', '2019-06-15 23:34:18');
INSERT INTO `access_log` VALUES (37387, '65.51.15606128579971683', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:18', 1, 1002001015, '账号未登陆', '2019-06-15 23:34:18');
INSERT INTO `access_log` VALUES (37388, '65.52.15606128599021665', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 23:34:20');
INSERT INTO `access_log` VALUES (37389, '65.54.15606128633951617', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:23', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 23:34:23');
INSERT INTO `access_log` VALUES (37390, '65.50.15606128697421669', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-15 23:34:30');
INSERT INTO `access_log` VALUES (37391, '65.46.15606128855881663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:46', 65, 0, '', '2019-06-15 23:34:46');
INSERT INTO `access_log` VALUES (37392, '65.45.15606128859441663', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:46', 9, 0, '', '2019-06-15 23:34:46');
INSERT INTO `access_log` VALUES (37393, '65.47.15606128859461653', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:46', 10, 2001001000, '服务端发生异常', '2019-06-15 23:34:46');
INSERT INTO `access_log` VALUES (37394, '65.51.15606128859481685', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:34:46', 9, 0, '', '2019-06-15 23:34:46');
INSERT INTO `access_log` VALUES (37395, '65.50.15606130936051673', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:38:14', 10, 0, '', '2019-06-15 23:38:14');
INSERT INTO `access_log` VALUES (37396, '65.49.15606130936131675', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:38:14', 10, 2001001000, '服务端发生异常', '2019-06-15 23:38:14');
INSERT INTO `access_log` VALUES (37397, '65.46.15606130936161667', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.114.190.182', '2019-06-15 23:38:14', 9, 0, '', '2019-06-15 23:38:14');
INSERT INTO `access_log` VALUES (37398, '59.73.15606436729001409', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:07:53', 10, 0, '', '2019-06-16 08:07:53');
INSERT INTO `access_log` VALUES (37399, '59.74.15606436728981403', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:07:53', 14, 2001001000, '服务端发生异常', '2019-06-16 08:07:53');
INSERT INTO `access_log` VALUES (37400, '64.84.15606436787311351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:07:59', 11, 0, '', '2019-06-16 08:07:59');
INSERT INTO `access_log` VALUES (37401, '64.76.15606436789391343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:07:59', 3, 0, '', '2019-06-16 08:07:59');
INSERT INTO `access_log` VALUES (37402, '64.82.15606436803141359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:08:00', 2, 0, '', '2019-06-16 08:08:00');
INSERT INTO `access_log` VALUES (37403, '64.81.15606436815091353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:08:02', 2, 0, '', '2019-06-16 08:08:02');
INSERT INTO `access_log` VALUES (37404, '59.80.15606437559601397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:09:16', 4, 0, '', '2019-06-16 08:09:16');
INSERT INTO `access_log` VALUES (37405, '59.77.15606437559941395', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:09:16', 12, 2001001000, '服务端发生异常', '2019-06-16 08:09:16');
INSERT INTO `access_log` VALUES (37406, '64.84.15606437635811353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:09:24', 3, 0, '', '2019-06-16 08:09:24');
INSERT INTO `access_log` VALUES (37407, '64.76.15606437637811345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:09:24', 2, 0, '', '2019-06-16 08:09:24');
INSERT INTO `access_log` VALUES (37408, '59.73.15606437667391411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:09:27', 2, 0, '', '2019-06-16 08:09:27');
INSERT INTO `access_log` VALUES (37409, '59.74.15606437667421405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:09:27', 12, 2001001000, '服务端发生异常', '2019-06-16 08:09:27');
INSERT INTO `access_log` VALUES (37410, '64.82.15606437683131361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:09:28', 2, 0, '', '2019-06-16 08:09:28');
INSERT INTO `access_log` VALUES (37411, '64.81.15606437685161355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:09:29', 2, 0, '', '2019-06-16 08:09:29');
INSERT INTO `access_log` VALUES (37412, '59.79.15606437696851413', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:09:30', 3, 0, '', '2019-06-16 08:09:30');
INSERT INTO `access_log` VALUES (37413, '59.76.15606437696851405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:09:30', 19, 2001001000, '服务端发生异常', '2019-06-16 08:09:30');
INSERT INTO `access_log` VALUES (37414, '64.79.15606437713521351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:09:31', 2, 0, '', '2019-06-16 08:09:31');
INSERT INTO `access_log` VALUES (37415, '64.85.15606437715511367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:09:32', 2, 0, '', '2019-06-16 08:09:32');
INSERT INTO `access_log` VALUES (37416, '59.75.15606437725531413', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:09:33', 3, 0, '', '2019-06-16 08:09:33');
INSERT INTO `access_log` VALUES (37417, '59.78.15606437725571409', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:09:33', 12, 2001001000, '服务端发生异常', '2019-06-16 08:09:33');
INSERT INTO `access_log` VALUES (37418, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:10:02', 7, 0, '', '2019-06-16 08:10:02');
INSERT INTO `access_log` VALUES (37419, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=java', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:10:02', 11, 0, '', '2019-06-16 08:10:02');
INSERT INTO `access_log` VALUES (37420, '64.78.15606438040811357', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.1.6.996 Mobile Safari/537.36', '36.57.128.19', '2019-06-16 08:10:04', 9, 0, '', '2019-06-16 08:10:04');
INSERT INTO `access_log` VALUES (37421, '65.46.15606451170122095', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:31:57', 1, 1002001015, '账号未登陆', '2019-06-16 08:31:57');
INSERT INTO `access_log` VALUES (37422, '65.53.15606451170122071', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:31:57', 1, 1002001015, '账号未登陆', '2019-06-16 08:31:57');
INSERT INTO `access_log` VALUES (37423, '65.54.15606451170112049', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:31:57', 1, 1002001015, '账号未登陆', '2019-06-16 08:31:57');
INSERT INTO `access_log` VALUES (37424, '65.50.15606451189522101', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:31:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 08:31:59');
INSERT INTO `access_log` VALUES (37425, '65.49.15606451265162103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:32:07', 4, 1002002001, '密码不正确', '2019-06-16 08:32:07');
INSERT INTO `access_log` VALUES (37426, '65.47.15606451430752085', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:32:23', 200, 0, '', '2019-06-16 08:32:23');
INSERT INTO `access_log` VALUES (37427, '65.3607.15606451435053851', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:32:24', 12, 0, '', '2019-06-16 08:32:24');
INSERT INTO `access_log` VALUES (37428, '65.52.15606451435072099', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:32:24', 12, 0, '', '2019-06-16 08:32:24');
INSERT INTO `access_log` VALUES (37429, '65.51.15606451435052117', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:32:24', 13, 2001001000, '服务端发生异常', '2019-06-16 08:32:24');
INSERT INTO `access_log` VALUES (37430, '65.54.15606451463352051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:32:26', 10, 0, '', '2019-06-16 08:32:26');
INSERT INTO `access_log` VALUES (37431, '65.46.15606451463372097', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:32:26', 10, 2001001000, '服务端发生异常', '2019-06-16 08:32:26');
INSERT INTO `access_log` VALUES (37432, '65.50.15606451463572103', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:32:26', 9, 0, '', '2019-06-16 08:32:26');
INSERT INTO `access_log` VALUES (37433, '65.49.15606451471002105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:32:27', 8, 0, '', '2019-06-16 08:32:27');
INSERT INTO `access_log` VALUES (37434, '65.47.15606451471002087', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:32:27', 8, 0, '', '2019-06-16 08:32:27');
INSERT INTO `access_log` VALUES (37435, '65.45.15606451471002097', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '139.226.106.153', '2019-06-16 08:32:27', 11, 2001001000, '服务端发生异常', '2019-06-16 08:32:27');
INSERT INTO `access_log` VALUES (37436, '65.50.15606492679602159', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.57.128.19', '2019-06-16 09:41:08', 13, 1002001012, '访问令牌已过期', '2019-06-16 09:41:08');
INSERT INTO `access_log` VALUES (37437, '65.54.15606492680102107', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.57.128.19', '2019-06-16 09:41:08', 12, 1002001012, '访问令牌已过期', '2019-06-16 09:41:08');
INSERT INTO `access_log` VALUES (37438, '65.46.15606492680102153', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.57.128.19', '2019-06-16 09:41:08', 14, 1002001012, '访问令牌已过期', '2019-06-16 09:41:08');
INSERT INTO `access_log` VALUES (37439, '65.49.15606492754152161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.57.128.19', '2019-06-16 09:41:15', 93, 0, '', '2019-06-16 09:41:16');
INSERT INTO `access_log` VALUES (37440, '65.45.15606492759712153', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.57.128.19', '2019-06-16 09:41:16', 12, 0, '', '2019-06-16 09:41:16');
INSERT INTO `access_log` VALUES (37441, '65.51.15606492759762175', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.57.128.19', '2019-06-16 09:41:16', 10, 0, '', '2019-06-16 09:41:16');
INSERT INTO `access_log` VALUES (37442, '65.52.15606492759722157', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.57.128.19', '2019-06-16 09:41:16', 15, 2001001000, '服务端发生异常', '2019-06-16 09:41:16');
INSERT INTO `access_log` VALUES (37443, '65.54.15606520037082145', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.170.82', '2019-06-16 10:26:44', 1, 1002001015, '账号未登陆', '2019-06-16 10:26:44');
INSERT INTO `access_log` VALUES (37444, '65.50.15606520037082197', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.170.82', '2019-06-16 10:26:44', 1, 1002001015, '账号未登陆', '2019-06-16 10:26:44');
INSERT INTO `access_log` VALUES (37445, '65.46.15606520037092191', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.170.82', '2019-06-16 10:26:44', 1, 1002001015, '账号未登陆', '2019-06-16 10:26:44');
INSERT INTO `access_log` VALUES (37446, '65.52.15606520345582195', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.170.82', '2019-06-16 10:27:15', 79, 0, '', '2019-06-16 10:27:15');
INSERT INTO `access_log` VALUES (37447, '65.45.15606520350432191', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.170.82', '2019-06-16 10:27:15', 221, 0, '', '2019-06-16 10:27:15');
INSERT INTO `access_log` VALUES (37448, '65.3607.15606520350573947', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.170.82', '2019-06-16 10:27:15', 216, 0, '', '2019-06-16 10:27:15');
INSERT INTO `access_log` VALUES (37449, '65.51.15606520350492213', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.209.170.82', '2019-06-16 10:27:15', 225, 2001001000, '服务端发生异常', '2019-06-16 10:27:15');
INSERT INTO `access_log` VALUES (37450, '65.3607.15606574509484021', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.160.64.64', '2019-06-16 11:57:31', 1, 1002001015, '账号未登陆', '2019-06-16 11:57:31');
INSERT INTO `access_log` VALUES (37451, '65.49.15606574509482273', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.160.64.64', '2019-06-16 11:57:31', 0, 1002001015, '账号未登陆', '2019-06-16 11:57:31');
INSERT INTO `access_log` VALUES (37452, '65.53.15606574509482241', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.160.64.64', '2019-06-16 11:57:31', 1, 1002001015, '账号未登陆', '2019-06-16 11:57:31');
INSERT INTO `access_log` VALUES (37453, '65.54.15606574526642221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.160.64.64', '2019-06-16 11:57:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 11:57:33');
INSERT INTO `access_log` VALUES (37454, '65.50.15606574681072273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.160.64.64', '2019-06-16 11:57:48', 61, 0, '', '2019-06-16 11:57:48');
INSERT INTO `access_log` VALUES (37455, '65.45.15606574683832267', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.160.64.64', '2019-06-16 11:57:48', 12, 0, '', '2019-06-16 11:57:48');
INSERT INTO `access_log` VALUES (37456, '65.52.15606574683852269', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.160.64.64', '2019-06-16 11:57:48', 11, 2001001000, '服务端发生异常', '2019-06-16 11:57:48');
INSERT INTO `access_log` VALUES (37457, '65.47.15606574683892255', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.160.64.64', '2019-06-16 11:57:48', 10, 0, '', '2019-06-16 11:57:48');
INSERT INTO `access_log` VALUES (37458, '59.73.15606588290801613', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.83.176', '2019-06-16 12:20:29', 11, 0, '', '2019-06-16 12:20:29');
INSERT INTO `access_log` VALUES (37459, '59.74.15606588290821607', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.83.176', '2019-06-16 12:20:29', 15, 2001001000, '服务端发生异常', '2019-06-16 12:20:29');
INSERT INTO `access_log` VALUES (37460, '65.53.15606588313832261', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.83.176', '2019-06-16 12:20:31', 1, 1002001015, '账号未登陆', '2019-06-16 12:20:31');
INSERT INTO `access_log` VALUES (37461, '65.3607.15606588313844041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.83.176', '2019-06-16 12:20:31', 0, 1002001015, '账号未登陆', '2019-06-16 12:20:31');
INSERT INTO `access_log` VALUES (37462, '65.49.15606588313842293', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.83.176', '2019-06-16 12:20:31', 0, 1002001015, '账号未登陆', '2019-06-16 12:20:31');
INSERT INTO `access_log` VALUES (37463, '65.54.15606588330912241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.83.176', '2019-06-16 12:20:33', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 12:20:33');
INSERT INTO `access_log` VALUES (37464, '65.46.15606588351772287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.83.176', '2019-06-16 12:20:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 12:20:35');
INSERT INTO `access_log` VALUES (37465, '65.45.15606588438012287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.83.176', '2019-06-16 12:20:44', 279, 0, '', '2019-06-16 12:20:44');
INSERT INTO `access_log` VALUES (37466, '65.52.15606588443142289', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.83.176', '2019-06-16 12:20:44', 9, 0, '', '2019-06-16 12:20:44');
INSERT INTO `access_log` VALUES (37467, '65.47.15606588443142275', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.83.176', '2019-06-16 12:20:44', 9, 2001001000, '服务端发生异常', '2019-06-16 12:20:44');
INSERT INTO `access_log` VALUES (37468, '65.51.15606588443442307', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '1.80.83.176', '2019-06-16 12:20:44', 175, 0, '', '2019-06-16 12:20:45');
INSERT INTO `access_log` VALUES (37469, '65.46.15606588904612289', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2S Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '223.104.3.4', '2019-06-16 12:21:30', 0, 1002001015, '账号未登陆', '2019-06-16 12:21:30');
INSERT INTO `access_log` VALUES (37470, '65.50.15606588904612295', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2S Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '223.104.3.4', '2019-06-16 12:21:30', 0, 1002001015, '账号未登陆', '2019-06-16 12:21:30');
INSERT INTO `access_log` VALUES (37471, '65.54.15606588904612243', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2S Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '223.104.3.4', '2019-06-16 12:21:30', 0, 1002001015, '账号未登陆', '2019-06-16 12:21:30');
INSERT INTO `access_log` VALUES (37472, '65.45.15606588937352289', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2S Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '223.104.3.4', '2019-06-16 12:21:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 12:21:34');
INSERT INTO `access_log` VALUES (37473, '65.52.15606588965232291', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2S Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '223.104.3.4', '2019-06-16 12:21:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 12:21:37');
INSERT INTO `access_log` VALUES (37474, '65.53.15606589287272265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2S Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '223.104.3.4', '2019-06-16 12:22:09', 88, 0, '', '2019-06-16 12:22:09');
INSERT INTO `access_log` VALUES (37475, '65.3607.15606589294084045', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2S Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '223.104.3.4', '2019-06-16 12:22:09', 9, 0, '', '2019-06-16 12:22:09');
INSERT INTO `access_log` VALUES (37476, '65.46.15606589294182291', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2S Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '223.104.3.4', '2019-06-16 12:22:09', 10, 2001001000, '服务端发生异常', '2019-06-16 12:22:09');
INSERT INTO `access_log` VALUES (37477, '65.54.15606589294442245', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2S Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.0.1030 Mobile Safari/537.36', '223.104.3.4', '2019-06-16 12:22:09', 9, 0, '', '2019-06-16 12:22:09');
INSERT INTO `access_log` VALUES (37478, '65.54.15606592028802249', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.52.123.105', '2019-06-16 12:26:43', 1, 1002001015, '账号未登陆', '2019-06-16 12:26:43');
INSERT INTO `access_log` VALUES (37479, '65.3607.15606592028854049', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.52.123.105', '2019-06-16 12:26:43', 0, 1002001015, '账号未登陆', '2019-06-16 12:26:43');
INSERT INTO `access_log` VALUES (37480, '65.50.15606592029012301', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.52.123.105', '2019-06-16 12:26:43', 0, 1002001015, '账号未登陆', '2019-06-16 12:26:43');
INSERT INTO `access_log` VALUES (37481, '65.45.15606592055482295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.52.123.105', '2019-06-16 12:26:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 12:26:46');
INSERT INTO `access_log` VALUES (37482, '65.52.15606592106052297', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.52.123.105', '2019-06-16 12:26:51', 61, 0, '', '2019-06-16 12:26:51');
INSERT INTO `access_log` VALUES (37483, '65.47.15606592110672283', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.52.123.105', '2019-06-16 12:26:51', 10, 2001001000, '服务端发生异常', '2019-06-16 12:26:51');
INSERT INTO `access_log` VALUES (37484, '65.51.15606592110732315', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.52.123.105', '2019-06-16 12:26:51', 8, 0, '', '2019-06-16 12:26:51');
INSERT INTO `access_log` VALUES (37485, '65.53.15606592118482271', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.52.123.105', '2019-06-16 12:26:52', 10, 0, '', '2019-06-16 12:26:52');
INSERT INTO `access_log` VALUES (37486, '65.54.15606592288012251', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.52.123.105', '2019-06-16 12:27:09', 9, 2001001000, '服务端发生异常', '2019-06-16 12:27:09');
INSERT INTO `access_log` VALUES (37487, '65.46.15606592287982297', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.52.123.105', '2019-06-16 12:27:09', 85, 0, '', '2019-06-16 12:27:09');
INSERT INTO `access_log` VALUES (37488, '65.50.15606592288122303', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.52.123.105', '2019-06-16 12:27:09', 77, 0, '', '2019-06-16 12:27:09');
INSERT INTO `access_log` VALUES (37489, '59.76.15606742950451813', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.67.18.0', '2019-06-16 16:38:15', 10, 0, '', '2019-06-16 16:38:15');
INSERT INTO `access_log` VALUES (37490, '59.78.15606742950461817', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.67.18.0', '2019-06-16 16:38:15', 15, 2001001000, '服务端发生异常', '2019-06-16 16:38:15');
INSERT INTO `access_log` VALUES (37491, '64.82.15606742988061769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.67.18.0', '2019-06-16 16:38:19', 13, 0, '', '2019-06-16 16:38:19');
INSERT INTO `access_log` VALUES (37492, '64.81.15606742989961763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.67.18.0', '2019-06-16 16:38:19', 5, 0, '', '2019-06-16 16:38:19');
INSERT INTO `access_log` VALUES (37493, '64.85.15606743006221775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.67.18.0', '2019-06-16 16:38:21', 3, 0, '', '2019-06-16 16:38:21');
INSERT INTO `access_log` VALUES (37494, '64.80.15606743011181765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.67.18.0', '2019-06-16 16:38:21', 2, 0, '', '2019-06-16 16:38:21');
INSERT INTO `access_log` VALUES (37495, '59.77.15606743028511805', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.67.18.0', '2019-06-16 16:38:23', 3, 0, '', '2019-06-16 16:38:23');
INSERT INTO `access_log` VALUES (37496, '59.71.15606743028501819', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.67.18.0', '2019-06-16 16:38:23', 13, 2001001000, '服务端发生异常', '2019-06-16 16:38:23');
INSERT INTO `access_log` VALUES (37497, '64.83.15606743129271753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.67.18.0', '2019-06-16 16:38:33', 2, 0, '', '2019-06-16 16:38:33');
INSERT INTO `access_log` VALUES (37498, '64.78.15606743133011765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.67.18.0', '2019-06-16 16:38:33', 2, 0, '', '2019-06-16 16:38:33');
INSERT INTO `access_log` VALUES (37499, '64.84.15606743180681763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.67.18.0', '2019-06-16 16:38:38', 3, 0, '', '2019-06-16 16:38:38');
INSERT INTO `access_log` VALUES (37500, '64.76.15606743181931755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.67.18.0', '2019-06-16 16:38:38', 1, 0, '', '2019-06-16 16:38:38');
INSERT INTO `access_log` VALUES (37501, '59.75.15606762125741847', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.19.190.37', '2019-06-16 17:10:13', 10, 0, '', '2019-06-16 17:10:13');
INSERT INTO `access_log` VALUES (37502, '59.77.15606762125881831', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.19.190.37', '2019-06-16 17:10:13', 12, 2001001000, '服务端发生异常', '2019-06-16 17:10:13');
INSERT INTO `access_log` VALUES (37503, '64.77.15606762278961795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.19.190.37', '2019-06-16 17:10:28', 11, 0, '', '2019-06-16 17:10:28');
INSERT INTO `access_log` VALUES (37504, '64.84.15606762280321789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.19.190.37', '2019-06-16 17:10:28', 2, 0, '', '2019-06-16 17:10:28');
INSERT INTO `access_log` VALUES (37505, '65.50.15606772595052543', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-06-16 17:27:40', 1, 1002001015, '账号未登陆', '2019-06-16 17:27:40');
INSERT INTO `access_log` VALUES (37506, '65.46.15606772595052539', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-06-16 17:27:40', 1, 1002001015, '账号未登陆', '2019-06-16 17:27:40');
INSERT INTO `access_log` VALUES (37507, '65.52.15606772595052541', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-06-16 17:27:40', 0, 1002001015, '账号未登陆', '2019-06-16 17:27:40');
INSERT INTO `access_log` VALUES (37508, '65.3607.15606786121954313', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:50:12', 0, 1002001015, '账号未登陆', '2019-06-16 17:50:12');
INSERT INTO `access_log` VALUES (37509, '65.51.15606786121952577', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:50:12', 0, 1002001015, '账号未登陆', '2019-06-16 17:50:12');
INSERT INTO `access_log` VALUES (37510, '65.53.15606786121962533', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:50:12', 1, 1002001015, '账号未登陆', '2019-06-16 17:50:12');
INSERT INTO `access_log` VALUES (37511, '65.46.15606786145052559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:50:15', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 17:50:15');
INSERT INTO `access_log` VALUES (37512, '65.52.15606786173362561', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:50:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 17:50:17');
INSERT INTO `access_log` VALUES (37513, '65.50.15606786240682563', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:50:24', 79, 0, '', '2019-06-16 17:50:24');
INSERT INTO `access_log` VALUES (37514, '65.47.15606786244712543', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:50:24', 12, 0, '', '2019-06-16 17:50:24');
INSERT INTO `access_log` VALUES (37515, '65.49.15606786244712567', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:50:24', 12, 2001001000, '服务端发生异常', '2019-06-16 17:50:24');
INSERT INTO `access_log` VALUES (37516, '65.54.15606786244772511', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:50:24', 10, 0, '', '2019-06-16 17:50:24');
INSERT INTO `access_log` VALUES (37517, '65.3607.15606786562904315', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:50:56', 19, 0, '', '2019-06-16 17:50:56');
INSERT INTO `access_log` VALUES (37518, '65.46.15606786562932561', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:50:56', 18, 2001001000, '服务端发生异常', '2019-06-16 17:50:56');
INSERT INTO `access_log` VALUES (37519, '65.52.15606786563012563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:50:56', 9, 0, '', '2019-06-16 17:50:56');
INSERT INTO `access_log` VALUES (37520, '65.50.15606786829002565', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:51:23', 9, 0, '', '2019-06-16 17:51:23');
INSERT INTO `access_log` VALUES (37521, '65.49.15606786829002569', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:51:23', 10, 2001001000, '服务端发生异常', '2019-06-16 17:51:23');
INSERT INTO `access_log` VALUES (37522, '65.54.15606786829082513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '111.0.237.186', '2019-06-16 17:51:23', 9, 0, '', '2019-06-16 17:51:23');
INSERT INTO `access_log` VALUES (37523, '59.75.15606793316041889', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.110.255.194', '2019-06-16 18:02:12', 11, 0, '', '2019-06-16 18:02:12');
INSERT INTO `access_log` VALUES (37524, '59.77.15606793316041873', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.110.255.194', '2019-06-16 18:02:12', 15, 2001001000, '服务端发生异常', '2019-06-16 18:02:12');
INSERT INTO `access_log` VALUES (37525, '65.46.15606793373902571', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.110.255.194', '2019-06-16 18:02:17', 1, 1002001015, '账号未登陆', '2019-06-16 18:02:17');
INSERT INTO `access_log` VALUES (37526, '65.52.15606793373892573', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.110.255.194', '2019-06-16 18:02:17', 1, 1002001015, '账号未登陆', '2019-06-16 18:02:17');
INSERT INTO `access_log` VALUES (37527, '65.45.15606793373902571', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.110.255.194', '2019-06-16 18:02:17', 0, 1002001015, '账号未登陆', '2019-06-16 18:02:17');
INSERT INTO `access_log` VALUES (37528, '65.49.15606793391272579', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.110.255.194', '2019-06-16 18:02:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 18:02:19');
INSERT INTO `access_log` VALUES (37529, '65.50.15606793427352575', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.110.255.194', '2019-06-16 18:02:23', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 18:02:23');
INSERT INTO `access_log` VALUES (37530, '65.47.15606793477492555', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.110.255.194', '2019-06-16 18:02:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 18:02:28');
INSERT INTO `access_log` VALUES (37531, '64.77.15606793535071837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.110.255.194', '2019-06-16 18:02:34', 10, 0, '', '2019-06-16 18:02:34');
INSERT INTO `access_log` VALUES (37532, '64.84.15606793536341831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.110.255.194', '2019-06-16 18:02:34', 2, 0, '', '2019-06-16 18:02:34');
INSERT INTO `access_log` VALUES (37533, '65.51.15606793726802591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.110.255.194', '2019-06-16 18:02:53', 88, 0, '', '2019-06-16 18:02:53');
INSERT INTO `access_log` VALUES (37534, '65.3607.15606793730844327', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.110.255.194', '2019-06-16 18:02:53', 9, 0, '', '2019-06-16 18:02:53');
INSERT INTO `access_log` VALUES (37535, '65.46.15606793730902573', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.110.255.194', '2019-06-16 18:02:53', 8, 0, '', '2019-06-16 18:02:53');
INSERT INTO `access_log` VALUES (37536, '65.52.15606793730902575', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.110.255.194', '2019-06-16 18:02:53', 8, 2001001000, '服务端发生异常', '2019-06-16 18:02:53');
INSERT INTO `access_log` VALUES (37537, '65.45.15606816199032603', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '220.175.54.96', '2019-06-16 18:40:20', 13, 1002001012, '访问令牌已过期', '2019-06-16 18:40:20');
INSERT INTO `access_log` VALUES (37538, '65.49.15606816199032611', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '220.175.54.96', '2019-06-16 18:40:20', 15, 1002001012, '访问令牌已过期', '2019-06-16 18:40:20');
INSERT INTO `access_log` VALUES (37539, '65.50.15606816199162607', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '220.175.54.96', '2019-06-16 18:40:20', 7, 1002001012, '访问令牌已过期', '2019-06-16 18:40:20');
INSERT INTO `access_log` VALUES (37540, '65.54.15606816235732555', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1.0; XT1929-15) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '220.175.54.96', '2019-06-16 18:40:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 18:40:24');
INSERT INTO `access_log` VALUES (37541, '59.72.15606844594161953', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.20.91.81', '2019-06-16 19:27:39', 10, 0, '', '2019-06-16 19:27:39');
INSERT INTO `access_log` VALUES (37542, '59.73.15606844594171957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.20.91.81', '2019-06-16 19:27:39', 16, 2001001000, '服务端发生异常', '2019-06-16 19:27:39');
INSERT INTO `access_log` VALUES (37543, '59.79.15606844725201959', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '14.20.91.81', '2019-06-16 19:27:53', 3, 0, '', '2019-06-16 19:27:53');
INSERT INTO `access_log` VALUES (37544, '59.76.15606844725241951', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '14.20.91.81', '2019-06-16 19:27:53', 19, 2001001000, '服务端发生异常', '2019-06-16 19:27:53');
INSERT INTO `access_log` VALUES (37545, '66.49.15606845124780343', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '14.20.91.81', '2019-06-16 19:28:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-06-16 19:28:32');
INSERT INTO `access_log` VALUES (37546, '59.71.15606845191891957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.89.239.216', '2019-06-16 19:28:39', 19, 2001001000, '服务端发生异常', '2019-06-16 19:28:39');
INSERT INTO `access_log` VALUES (37547, '59.80.15606845196881945', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.29.92', '2019-06-16 19:28:40', 2, 0, '', '2019-06-16 19:28:40');
INSERT INTO `access_log` VALUES (37548, '65.54.15606845413902595', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '14.20.91.81', '2019-06-16 19:29:01', 1, 1002001015, '账号未登陆', '2019-06-16 19:29:01');
INSERT INTO `access_log` VALUES (37549, '65.51.15606845413902663', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '14.20.91.81', '2019-06-16 19:29:01', 1, 1002001015, '账号未登陆', '2019-06-16 19:29:01');
INSERT INTO `access_log` VALUES (37550, '65.53.15606845413902619', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '14.20.91.81', '2019-06-16 19:29:01', 0, 1002001015, '账号未登陆', '2019-06-16 19:29:01');
INSERT INTO `access_log` VALUES (37551, '65.52.15606845464002647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '14.20.91.81', '2019-06-16 19:29:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 19:29:06');
INSERT INTO `access_log` VALUES (37552, '65.3607.15606845606644399', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '14.20.91.81', '2019-06-16 19:29:21', 77, 0, '', '2019-06-16 19:29:21');
INSERT INTO `access_log` VALUES (37553, '65.45.15606845693702643', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '14.20.91.81', '2019-06-16 19:29:29', 81, 0, '', '2019-06-16 19:29:29');
INSERT INTO `access_log` VALUES (37554, '65.46.15606845796842647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.20.91.81', '2019-06-16 19:29:40', 61, 0, '', '2019-06-16 19:29:40');
INSERT INTO `access_log` VALUES (37555, '65.53.15606845800562621', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.20.91.81', '2019-06-16 19:29:40', 9, 0, '', '2019-06-16 19:29:40');
INSERT INTO `access_log` VALUES (37556, '65.51.15606845800682665', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.20.91.81', '2019-06-16 19:29:40', 17, 2001001000, '服务端发生异常', '2019-06-16 19:29:40');
INSERT INTO `access_log` VALUES (37557, '65.54.15606845800762597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.20.91.81', '2019-06-16 19:29:40', 9, 0, '', '2019-06-16 19:29:40');
INSERT INTO `access_log` VALUES (37558, '65.50.15606846010622649', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '180.97.118.223', '2019-06-16 19:30:01', 0, 1002001015, '账号未登陆', '2019-06-16 19:30:01');
INSERT INTO `access_log` VALUES (37559, '65.3607.15606846011524401', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.129.6.151', '2019-06-16 19:30:01', 0, 1002001015, '账号未登陆', '2019-06-16 19:30:01');
INSERT INTO `access_log` VALUES (37560, '65.49.15606846011752653', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.91.62.99', '2019-06-16 19:30:01', 1, 1002001015, '账号未登陆', '2019-06-16 19:30:01');
INSERT INTO `access_log` VALUES (37561, '65.46.15606875060162687', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:18:26', 0, 1002001015, '账号未登陆', '2019-06-16 20:18:26');
INSERT INTO `access_log` VALUES (37562, '65.53.15606875060172663', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:18:26', 1, 1002001015, '账号未登陆', '2019-06-16 20:18:26');
INSERT INTO `access_log` VALUES (37563, '65.51.15606875060192705', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:18:26', 0, 1002001015, '账号未登陆', '2019-06-16 20:18:26');
INSERT INTO `access_log` VALUES (37564, '65.54.15606875084962637', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:18:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 20:18:29');
INSERT INTO `access_log` VALUES (37565, '59.71.15606877980832001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:18', 25, 0, '', '2019-06-16 20:23:18');
INSERT INTO `access_log` VALUES (37566, '59.80.15606877980851989', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:18', 24, 2001001000, '服务端发生异常', '2019-06-16 20:23:18');
INSERT INTO `access_log` VALUES (37567, '64.78.15606878048671945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:25', 11, 0, '', '2019-06-16 20:23:25');
INSERT INTO `access_log` VALUES (37568, '64.83.15606878051741933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:25', 2, 0, '', '2019-06-16 20:23:25');
INSERT INTO `access_log` VALUES (37569, '64.77.15606878067601951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:27', 2, 0, '', '2019-06-16 20:23:27');
INSERT INTO `access_log` VALUES (37570, '64.82.15606878074171953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:27', 2, 0, '', '2019-06-16 20:23:27');
INSERT INTO `access_log` VALUES (37571, '64.81.15606878080281947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:28', 2, 0, '', '2019-06-16 20:23:28');
INSERT INTO `access_log` VALUES (37572, '64.84.15606878084101945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:28', 2, 0, '', '2019-06-16 20:23:28');
INSERT INTO `access_log` VALUES (37573, '59.73.15606878094502003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:29', 3, 0, '', '2019-06-16 20:23:29');
INSERT INTO `access_log` VALUES (37574, '59.74.15606878094621997', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:29', 12, 2001001000, '服务端发生异常', '2019-06-16 20:23:29');
INSERT INTO `access_log` VALUES (37575, '64.76.15606878121751937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:32', 2, 0, '', '2019-06-16 20:23:32');
INSERT INTO `access_log` VALUES (37576, '64.79.15606878123021943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:32', 2, 0, '', '2019-06-16 20:23:32');
INSERT INTO `access_log` VALUES (37577, '64.80.15606878133521949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:33', 2, 0, '', '2019-06-16 20:23:33');
INSERT INTO `access_log` VALUES (37578, '64.85.15606878139061959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:34', 1, 0, '', '2019-06-16 20:23:34');
INSERT INTO `access_log` VALUES (37579, '59.76.15606878148881997', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:35', 2, 0, '', '2019-06-16 20:23:35');
INSERT INTO `access_log` VALUES (37580, '59.78.15606878148902001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:23:35', 13, 2001001000, '服务端发生异常', '2019-06-16 20:23:35');
INSERT INTO `access_log` VALUES (37581, '65.45.15606878586952689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:24:19', 84, 0, '', '2019-06-16 20:24:19');
INSERT INTO `access_log` VALUES (37582, '65.50.15606878591092693', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:24:19', 20, 0, '', '2019-06-16 20:24:19');
INSERT INTO `access_log` VALUES (37583, '65.47.15606878591092675', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:24:19', 23, 2001001000, '服务端发生异常', '2019-06-16 20:24:19');
INSERT INTO `access_log` VALUES (37584, '65.46.15606878591152693', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:24:19', 17, 0, '', '2019-06-16 20:24:19');
INSERT INTO `access_log` VALUES (37585, '59.73.15606883577972011', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:32:38', 3, 0, '', '2019-06-16 20:32:38');
INSERT INTO `access_log` VALUES (37586, '59.79.15606883577992013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:32:38', 13, 2001001000, '服务端发生异常', '2019-06-16 20:32:38');
INSERT INTO `access_log` VALUES (37587, '64.79.15606883649331951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:32:45', 3, 0, '', '2019-06-16 20:32:45');
INSERT INTO `access_log` VALUES (37588, '64.80.15606883650401957', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:32:45', 1, 0, '', '2019-06-16 20:32:45');
INSERT INTO `access_log` VALUES (37589, '64.85.15606883660511967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:32:46', 1, 0, '', '2019-06-16 20:32:46');
INSERT INTO `access_log` VALUES (37590, '64.78.15606883670701955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:32:47', 2, 0, '', '2019-06-16 20:32:47');
INSERT INTO `access_log` VALUES (37591, '59.76.15606883680522005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:32:48', 2, 0, '', '2019-06-16 20:32:48');
INSERT INTO `access_log` VALUES (37592, '59.78.15606883680592009', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:32:48', 14, 2001001000, '服务端发生异常', '2019-06-16 20:32:48');
INSERT INTO `access_log` VALUES (37593, '65.3607.15606883739214455', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:32:54', 23, 0, '', '2019-06-16 20:32:54');
INSERT INTO `access_log` VALUES (37594, '65.52.15606883739202703', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:32:54', 23, 0, '', '2019-06-16 20:32:54');
INSERT INTO `access_log` VALUES (37595, '65.45.15606883739212697', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.140.11.124', '2019-06-16 20:32:54', 23, 2001001000, '服务端发生异常', '2019-06-16 20:32:54');
INSERT INTO `access_log` VALUES (37596, '59.78.15606887995352015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.194.155.229', '2019-06-16 20:40:00', 2, 0, '', '2019-06-16 20:40:00');
INSERT INTO `access_log` VALUES (37597, '59.75.15606887995362019', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.194.155.229', '2019-06-16 20:40:00', 10, 2001001000, '服务端发生异常', '2019-06-16 20:40:00');
INSERT INTO `access_log` VALUES (37598, '65.46.15606888224352707', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.194.155.229', '2019-06-16 20:40:22', 1, 1002001015, '账号未登陆', '2019-06-16 20:40:22');
INSERT INTO `access_log` VALUES (37599, '65.3607.15606888224354461', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.194.155.229', '2019-06-16 20:40:22', 1, 1002001015, '账号未登陆', '2019-06-16 20:40:22');
INSERT INTO `access_log` VALUES (37600, '65.50.15606888224402707', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.194.155.229', '2019-06-16 20:40:22', 1, 1002001015, '账号未登陆', '2019-06-16 20:40:22');
INSERT INTO `access_log` VALUES (37601, '65.51.15606888247412725', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.194.155.229', '2019-06-16 20:40:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 20:40:25');
INSERT INTO `access_log` VALUES (37602, '65.49.15606888427162715', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.194.155.229', '2019-06-16 20:40:43', 63, 0, '', '2019-06-16 20:40:43');
INSERT INTO `access_log` VALUES (37603, '65.52.15606888430102711', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.194.155.229', '2019-06-16 20:40:43', 9, 0, '', '2019-06-16 20:40:43');
INSERT INTO `access_log` VALUES (37604, '65.45.15606888430102705', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.194.155.229', '2019-06-16 20:40:43', 9, 0, '', '2019-06-16 20:40:43');
INSERT INTO `access_log` VALUES (37605, '65.47.15606888430092691', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.194.155.229', '2019-06-16 20:40:43', 11, 2001001000, '服务端发生异常', '2019-06-16 20:40:43');
INSERT INTO `access_log` VALUES (37606, '65.51.15606963565902827', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.95.203', '2019-06-16 22:45:57', 15, 1002001012, '访问令牌已过期', '2019-06-16 22:45:57');
INSERT INTO `access_log` VALUES (37607, '65.53.15606963565902785', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.95.203', '2019-06-16 22:45:57', 13, 1002001012, '访问令牌已过期', '2019-06-16 22:45:57');
INSERT INTO `access_log` VALUES (37608, '65.54.15606963565922757', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.95.203', '2019-06-16 22:45:57', 15, 1002001012, '访问令牌已过期', '2019-06-16 22:45:57');
INSERT INTO `access_log` VALUES (37609, '65.49.15606963611582815', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.95.203', '2019-06-16 22:46:01', 72, 0, '', '2019-06-16 22:46:01');
INSERT INTO `access_log` VALUES (37610, '65.52.15606963614902813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.95.203', '2019-06-16 22:46:01', 12, 0, '', '2019-06-16 22:46:02');
INSERT INTO `access_log` VALUES (37611, '65.45.15606963614922807', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.95.203', '2019-06-16 22:46:01', 15, 2001001000, '服务端发生异常', '2019-06-16 22:46:02');
INSERT INTO `access_log` VALUES (37612, '65.47.15606963614972793', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.95.203', '2019-06-16 22:46:01', 12, 0, '', '2019-06-16 22:46:02');
INSERT INTO `access_log` VALUES (37613, '65.51.15606991296232865', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.45.84', '2019-06-16 23:32:10', 0, 1002001015, '账号未登陆', '2019-06-16 23:32:10');
INSERT INTO `access_log` VALUES (37614, '65.49.15606991296232853', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.45.84', '2019-06-16 23:32:10', 0, 1002001015, '账号未登陆', '2019-06-16 23:32:10');
INSERT INTO `access_log` VALUES (37615, '65.52.15606991296242851', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.45.84', '2019-06-16 23:32:10', 0, 1002001015, '账号未登陆', '2019-06-16 23:32:10');
INSERT INTO `access_log` VALUES (37616, '65.45.15606991312052845', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.45.84', '2019-06-16 23:32:11', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 23:32:11');
INSERT INTO `access_log` VALUES (37617, '65.46.15606991730502849', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.45.84', '2019-06-16 23:32:53', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-16 23:32:53');
INSERT INTO `access_log` VALUES (37618, '65.54.15606991802942797', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.45.84', '2019-06-16 23:33:00', 82, 0, '', '2019-06-16 23:33:00');
INSERT INTO `access_log` VALUES (37619, '65.52.15606991805232853', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.45.84', '2019-06-16 23:33:01', 10, 0, '', '2019-06-16 23:33:01');
INSERT INTO `access_log` VALUES (37620, '65.53.15606991805202825', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.45.84', '2019-06-16 23:33:01', 12, 0, '', '2019-06-16 23:33:01');
INSERT INTO `access_log` VALUES (37621, '65.51.15606991805212867', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.45.84', '2019-06-16 23:33:01', 14, 2001001000, '服务端发生异常', '2019-06-16 23:33:01');
INSERT INTO `access_log` VALUES (37622, '59.78.15606995767182159', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.45.84', '2019-06-16 23:39:37', 11, 0, '', '2019-06-16 23:39:37');
INSERT INTO `access_log` VALUES (37623, '59.77.15606995767202147', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.45.84', '2019-06-16 23:39:37', 15, 2001001000, '服务端发生异常', '2019-06-16 23:39:37');
INSERT INTO `access_log` VALUES (37624, '64.85.15606995790102117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.45.84', '2019-06-16 23:39:39', 9, 0, '', '2019-06-16 23:39:39');
INSERT INTO `access_log` VALUES (37625, '64.78.15606995791282105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.45.84', '2019-06-16 23:39:39', 2, 0, '', '2019-06-16 23:39:39');
INSERT INTO `access_log` VALUES (37626, '65.50.15607344508833323', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '210.13.80.220', '2019-06-17 09:20:51', 0, 1002001015, '账号未登陆', '2019-06-17 09:20:51');
INSERT INTO `access_log` VALUES (37627, '65.52.15607344508843325', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '210.13.80.220', '2019-06-17 09:20:51', 1, 1002001015, '账号未登陆', '2019-06-17 09:20:51');
INSERT INTO `access_log` VALUES (37628, '65.45.15607344509053319', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '210.13.80.220', '2019-06-17 09:20:51', 0, 1002001015, '账号未登陆', '2019-06-17 09:20:51');
INSERT INTO `access_log` VALUES (37629, '65.49.15607344564203329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '210.13.80.220', '2019-06-17 09:20:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 09:20:56');
INSERT INTO `access_log` VALUES (37630, '65.46.15607344619113323', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '210.13.80.220', '2019-06-17 09:21:02', 5, 1002002000, '账号不存在', '2019-06-17 09:21:02');
INSERT INTO `access_log` VALUES (37631, '65.45.15607345524423321', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '58.246.221.163', '2019-06-17 09:22:32', 0, 1002001015, '账号未登陆', '2019-06-17 09:22:32');
INSERT INTO `access_log` VALUES (37632, '59.79.15607353348722641', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '202.101.61.35', '2019-06-17 09:35:35', 13, 0, '', '2019-06-17 09:35:35');
INSERT INTO `access_log` VALUES (37633, '59.73.15607353348732639', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '202.101.61.35', '2019-06-17 09:35:35', 28, 2001001000, '服务端发生异常', '2019-06-17 09:35:35');
INSERT INTO `access_log` VALUES (37634, '65.46.15607353361223335', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '202.101.61.35', '2019-06-17 09:35:36', 0, 1002001015, '账号未登陆', '2019-06-17 09:35:36');
INSERT INTO `access_log` VALUES (37635, '65.47.15607353361253317', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '202.101.61.35', '2019-06-17 09:35:36', 0, 1002001015, '账号未登陆', '2019-06-17 09:35:36');
INSERT INTO `access_log` VALUES (37636, '65.54.15607353361313285', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '202.101.61.35', '2019-06-17 09:35:36', 1, 1002001015, '账号未登陆', '2019-06-17 09:35:36');
INSERT INTO `access_log` VALUES (37637, '64.84.15607353439962581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '202.101.61.35', '2019-06-17 09:35:44', 11, 0, '', '2019-06-17 09:35:44');
INSERT INTO `access_log` VALUES (37638, '64.76.15607353441412573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '202.101.61.35', '2019-06-17 09:35:44', 3, 0, '', '2019-06-17 09:35:44');
INSERT INTO `access_log` VALUES (37639, '64.79.15607353488892579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '202.101.61.35', '2019-06-17 09:35:49', 2, 0, '', '2019-06-17 09:35:49');
INSERT INTO `access_log` VALUES (37640, '64.80.15607353490132585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '202.101.61.35', '2019-06-17 09:35:49', 1, 0, '', '2019-06-17 09:35:49');
INSERT INTO `access_log` VALUES (37641, '65.52.15607353574523339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '202.101.61.35', '2019-06-17 09:35:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 09:35:57');
INSERT INTO `access_log` VALUES (37642, '65.50.15607353688083337', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '202.101.61.35', '2019-06-17 09:36:09', 73, 0, '', '2019-06-17 09:36:09');
INSERT INTO `access_log` VALUES (37643, '65.3607.15607353711945089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko', '202.101.61.35', '2019-06-17 09:36:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 09:36:11');
INSERT INTO `access_log` VALUES (37644, '65.51.15607382989873391', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-17 10:24:59', 1, 1002001015, '账号未登陆', '2019-06-17 10:24:59');
INSERT INTO `access_log` VALUES (37645, '65.52.15607382989873379', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-17 10:24:59', 0, 1002001015, '账号未登陆', '2019-06-17 10:24:59');
INSERT INTO `access_log` VALUES (37646, '65.45.15607382989933373', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-17 10:24:59', 1, 1002001015, '账号未登陆', '2019-06-17 10:24:59');
INSERT INTO `access_log` VALUES (37647, '65.50.15607383029543377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-17 10:25:03', 68, 0, '', '2019-06-17 10:25:03');
INSERT INTO `access_log` VALUES (37648, '65.3607.15607383033105129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-17 10:25:03', 66, 0, '', '2019-06-17 10:25:03');
INSERT INTO `access_log` VALUES (37649, '65.46.15607383033213377', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-17 10:25:03', 59, 0, '', '2019-06-17 10:25:03');
INSERT INTO `access_log` VALUES (37650, '65.49.15607383033163383', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-17 10:25:03', 64, 2001001000, '服务端发生异常', '2019-06-17 10:25:03');
INSERT INTO `access_log` VALUES (37651, '65.53.15607383083073355', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-17 10:25:08', 29, 0, '', '2019-06-17 10:25:08');
INSERT INTO `access_log` VALUES (37652, '65.47.15607383082973359', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-17 10:25:08', 38, 0, '', '2019-06-17 10:25:08');
INSERT INTO `access_log` VALUES (37653, '65.54.15607383083043327', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-17 10:25:08', 33, 2001001000, '服务端发生异常', '2019-06-17 10:25:08');
INSERT INTO `access_log` VALUES (37654, '65.53.15607391803573369', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:39:40', 0, 1002001015, '账号未登陆', '2019-06-17 10:39:40');
INSERT INTO `access_log` VALUES (37655, '65.50.15607391803583389', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:39:40', 1, 1002001015, '账号未登陆', '2019-06-17 10:39:40');
INSERT INTO `access_log` VALUES (37656, '65.52.15607391803623393', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:39:40', 0, 1002001015, '账号未登陆', '2019-06-17 10:39:40');
INSERT INTO `access_log` VALUES (37657, '65.51.15607391878593405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:39:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 10:39:48');
INSERT INTO `access_log` VALUES (37658, '65.54.15607391933733339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:39:53', 67, 0, '', '2019-06-17 10:39:53');
INSERT INTO `access_log` VALUES (37659, '65.45.15607391936453389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:39:54', 9, 0, '', '2019-06-17 10:39:54');
INSERT INTO `access_log` VALUES (37660, '65.49.15607391936483399', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:39:54', 9, 2001001000, '服务端发生异常', '2019-06-17 10:39:54');
INSERT INTO `access_log` VALUES (37661, '65.3607.15607391936545145', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:39:54', 9, 0, '', '2019-06-17 10:39:54');
INSERT INTO `access_log` VALUES (37662, '65.46.15607392039303393', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:40:04', 10, 0, '', '2019-06-17 10:40:04');
INSERT INTO `access_log` VALUES (37663, '65.52.15607392039333395', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:40:04', 10, 2001001000, '服务端发生异常', '2019-06-17 10:40:04');
INSERT INTO `access_log` VALUES (37664, '65.50.15607392039393391', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:40:04', 9, 0, '', '2019-06-17 10:40:04');
INSERT INTO `access_log` VALUES (37665, '65.51.15607392125613407', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:40:13', 8, 0, '', '2019-06-17 10:40:13');
INSERT INTO `access_log` VALUES (37666, '65.54.15607392125623341', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:40:13', 10, 2001001000, '服务端发生异常', '2019-06-17 10:40:13');
INSERT INTO `access_log` VALUES (37667, '65.49.15607392125643401', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:40:13', 8, 0, '', '2019-06-17 10:40:13');
INSERT INTO `access_log` VALUES (37668, '65.45.15607392236983391', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:40:24', 16, 0, '', '2019-06-17 10:40:24');
INSERT INTO `access_log` VALUES (37669, '65.3607.15607392237015147', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:40:24', 17, 2001001000, '服务端发生异常', '2019-06-17 10:40:24');
INSERT INTO `access_log` VALUES (37670, '65.47.15607392237013375', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:40:24', 16, 0, '', '2019-06-17 10:40:24');
INSERT INTO `access_log` VALUES (37671, '65.51.15607392942973409', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:41:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 10:41:34');
INSERT INTO `access_log` VALUES (37672, '65.49.15607392984013403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:41:38', 74, 0, '', '2019-06-17 10:41:38');
INSERT INTO `access_log` VALUES (37673, '65.45.15607392986213393', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:41:39', 8, 0, '', '2019-06-17 10:41:39');
INSERT INTO `access_log` VALUES (37674, '65.3607.15607392986215149', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:41:39', 8, 0, '', '2019-06-17 10:41:39');
INSERT INTO `access_log` VALUES (37675, '65.47.15607392986243377', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:41:39', 10, 0, '', '2019-06-17 10:41:39');
INSERT INTO `access_log` VALUES (37676, '62.89.15607393069032417', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:41:47', 29, 0, '', '2019-06-17 10:41:47');
INSERT INTO `access_log` VALUES (37677, '64.76.15607393269922627', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:42:07', 22, 0, '', '2019-06-17 10:42:07');
INSERT INTO `access_log` VALUES (37678, '64.84.15607393269922635', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:42:07', 27, 0, '', '2019-06-17 10:42:07');
INSERT INTO `access_log` VALUES (37679, '64.80.15607393299252639', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:42:10', 10, 0, '', '2019-06-17 10:42:10');
INSERT INTO `access_log` VALUES (37680, '64.79.15607393299212633', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:42:10', 146, 0, '', '2019-06-17 10:42:10');
INSERT INTO `access_log` VALUES (37681, '66.56.15607393439771071', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:42:24', 23, 0, '', '2019-06-17 10:42:24');
INSERT INTO `access_log` VALUES (37682, '59.74.15607393492792687', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:42:29', 24, 0, '', '2019-06-17 10:42:29');
INSERT INTO `access_log` VALUES (37683, '59.73.15607393547272693', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:42:35', 25, 0, '', '2019-06-17 10:42:35');
INSERT INTO `access_log` VALUES (37684, '65.54.15607393575093345', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:42:38', 51, 0, '', '2019-06-17 10:42:38');
INSERT INTO `access_log` VALUES (37685, '65.51.15607393586553411', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:42:39', 25, 0, '', '2019-06-17 10:42:39');
INSERT INTO `access_log` VALUES (37686, '65.47.15607393598513379', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:42:40', 9, 0, '', '2019-06-17 10:42:40');
INSERT INTO `access_log` VALUES (37687, '65.45.15607393613173395', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:42:41', 14, 0, '', '2019-06-17 10:42:41');
INSERT INTO `access_log` VALUES (37688, '62.82.15607393782182411', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:42:58', 17, 0, '', '2019-06-17 10:42:58');
INSERT INTO `access_log` VALUES (37689, '62.89.15607393829812419', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.226.135.170', '2019-06-17 10:43:03', 19, 0, '', '2019-06-17 10:43:03');
INSERT INTO `access_log` VALUES (37690, '59.75.15607446336202765', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/4.0 (compatible;)', '219.233.201.34', '2019-06-17 12:10:34', 11, 0, '', '2019-06-17 12:10:34');
INSERT INTO `access_log` VALUES (37691, '65.47.15607457793163465', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.196.225.160', '2019-06-17 12:29:39', 0, 1002001015, '账号未登陆', '2019-06-17 12:29:39');
INSERT INTO `access_log` VALUES (37692, '65.3607.15607457793175237', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.196.225.160', '2019-06-17 12:29:39', 0, 1002001015, '账号未登陆', '2019-06-17 12:29:39');
INSERT INTO `access_log` VALUES (37693, '65.45.15607457793173481', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.196.225.160', '2019-06-17 12:29:39', 0, 1002001015, '账号未登陆', '2019-06-17 12:29:39');
INSERT INTO `access_log` VALUES (37694, '65.46.15607457851783485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.196.225.160', '2019-06-17 12:29:45', 90, 0, '', '2019-06-17 12:29:45');
INSERT INTO `access_log` VALUES (37695, '65.53.15607457854603463', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.196.225.160', '2019-06-17 12:29:45', 15, 0, '', '2019-06-17 12:29:45');
INSERT INTO `access_log` VALUES (37696, '65.50.15607457854593483', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.196.225.160', '2019-06-17 12:29:45', 25, 0, '', '2019-06-17 12:29:45');
INSERT INTO `access_log` VALUES (37697, '65.52.15607457854603487', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.196.225.160', '2019-06-17 12:29:45', 25, 2001001000, '服务端发生异常', '2019-06-17 12:29:45');
INSERT INTO `access_log` VALUES (37698, '65.3607.15607502081055297', 0, 2, 'admin-application', '/admin-api/admins/role/add', 'name=系统管理员', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.76', '2019-06-17 13:43:28', 0, 1002001015, '账号未登陆', '2019-06-17 13:43:28');
INSERT INTO `access_log` VALUES (37699, '59.78.15607507886942843', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '218.76.145.198', '2019-06-17 13:53:09', 11, 0, '', '2019-06-17 13:53:09');
INSERT INTO `access_log` VALUES (37700, '59.71.15607507886992845', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '218.76.145.198', '2019-06-17 13:53:09', 20, 2001001000, '服务端发生异常', '2019-06-17 13:53:09');
INSERT INTO `access_log` VALUES (37701, '65.54.15607518457763517', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '121.35.101.183', '2019-06-17 14:10:46', 0, 1002001015, '账号未登陆', '2019-06-17 14:10:46');
INSERT INTO `access_log` VALUES (37702, '65.51.15607518457813583', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '121.35.101.183', '2019-06-17 14:10:46', 0, 1002001015, '账号未登陆', '2019-06-17 14:10:46');
INSERT INTO `access_log` VALUES (37703, '65.49.15607518457953575', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '121.35.101.183', '2019-06-17 14:10:46', 0, 1002001015, '账号未登陆', '2019-06-17 14:10:46');
INSERT INTO `access_log` VALUES (37704, '65.3607.15607518583925319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '121.35.101.183', '2019-06-17 14:10:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 14:10:58');
INSERT INTO `access_log` VALUES (37705, '65.50.15607518588103567', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '121.35.101.183', '2019-06-17 14:10:59', 1, 1002001015, '账号未登陆', '2019-06-17 14:10:59');
INSERT INTO `access_log` VALUES (37706, '65.46.15607518588133571', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '121.35.101.183', '2019-06-17 14:10:59', 0, 1002001015, '账号未登陆', '2019-06-17 14:10:59');
INSERT INTO `access_log` VALUES (37707, '65.53.15607518588233553', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '121.35.101.183', '2019-06-17 14:10:59', 1, 1002001015, '账号未登陆', '2019-06-17 14:10:59');
INSERT INTO `access_log` VALUES (37708, '65.45.15607518712563565', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '121.35.101.183', '2019-06-17 14:11:11', 62, 0, '', '2019-06-17 14:11:11');
INSERT INTO `access_log` VALUES (37709, '65.54.15607518717523519', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '121.35.101.183', '2019-06-17 14:11:12', 10, 0, '', '2019-06-17 14:11:12');
INSERT INTO `access_log` VALUES (37710, '65.51.15607518717673585', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '121.35.101.183', '2019-06-17 14:11:12', 10, 2001001000, '服务端发生异常', '2019-06-17 14:11:12');
INSERT INTO `access_log` VALUES (37711, '65.49.15607518717783577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '121.35.101.183', '2019-06-17 14:11:12', 8, 0, '', '2019-06-17 14:11:12');
INSERT INTO `access_log` VALUES (37712, '65.47.15607518808083549', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '121.35.101.183', '2019-06-17 14:11:21', 10, 0, '', '2019-06-17 14:11:21');
INSERT INTO `access_log` VALUES (37713, '65.3607.15607518808225321', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '121.35.101.183', '2019-06-17 14:11:21', 12, 2001001000, '服务端发生异常', '2019-06-17 14:11:21');
INSERT INTO `access_log` VALUES (37714, '65.46.15607518808343573', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '121.35.101.183', '2019-06-17 14:11:21', 10, 0, '', '2019-06-17 14:11:21');
INSERT INTO `access_log` VALUES (37715, '65.51.15607519365373587', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '121.35.101.183', '2019-06-17 14:12:17', 17, 0, '', '2019-06-17 14:12:17');
INSERT INTO `access_log` VALUES (37716, '65.54.15607519365483521', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '121.35.101.183', '2019-06-17 14:12:17', 9, 2001001000, '服务端发生异常', '2019-06-17 14:12:17');
INSERT INTO `access_log` VALUES (37717, '65.46.15607519365533575', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '121.35.101.183', '2019-06-17 14:12:17', 7, 0, '', '2019-06-17 14:12:17');
INSERT INTO `access_log` VALUES (37718, '59.79.15607520429622865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:14:03', 6, 0, '', '2019-06-17 14:14:03');
INSERT INTO `access_log` VALUES (37719, '59.73.15607520429682863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:14:03', 13, 2001001000, '服务端发生异常', '2019-06-17 14:14:03');
INSERT INTO `access_log` VALUES (37720, '64.80.15607520526392809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:13', 11, 0, '', '2019-06-17 14:14:13');
INSERT INTO `access_log` VALUES (37721, '64.79.15607520527942803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:13', 3, 0, '', '2019-06-17 14:14:13');
INSERT INTO `access_log` VALUES (37722, '64.85.15607520547122819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:15', 2, 0, '', '2019-06-17 14:14:15');
INSERT INTO `access_log` VALUES (37723, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:15', 6, 0, '', '2019-06-17 14:14:15');
INSERT INTO `access_log` VALUES (37724, '64.78.15607520569892807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:17', 2, 0, '', '2019-06-17 14:14:17');
INSERT INTO `access_log` VALUES (37725, '64.83.15607520571402795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:17', 2, 0, '', '2019-06-17 14:14:17');
INSERT INTO `access_log` VALUES (37726, '59.77.15607520598922849', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:20', 3, 0, '', '2019-06-17 14:14:20');
INSERT INTO `access_log` VALUES (37727, '59.78.15607520598962861', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:20', 13, 2001001000, '服务端发生异常', '2019-06-17 14:14:20');
INSERT INTO `access_log` VALUES (37728, '64.82.15607520638702815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:24', 2, 0, '', '2019-06-17 14:14:24');
INSERT INTO `access_log` VALUES (37729, '64.81.15607520640612809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:24', 2, 0, '', '2019-06-17 14:14:24');
INSERT INTO `access_log` VALUES (37730, '64.76.15607520685512799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:29', 2, 0, '', '2019-06-17 14:14:29');
INSERT INTO `access_log` VALUES (37731, '64.84.15607520686712807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:29', 2, 0, '', '2019-06-17 14:14:29');
INSERT INTO `access_log` VALUES (37732, '59.71.15607520722232863', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:32', 2, 0, '', '2019-06-17 14:14:32');
INSERT INTO `access_log` VALUES (37733, '59.80.15607520722242851', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:32', 24, 2001001000, '服务端发生异常', '2019-06-17 14:14:32');
INSERT INTO `access_log` VALUES (37734, '64.80.15607520748172811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:35', 2, 0, '', '2019-06-17 14:14:35');
INSERT INTO `access_log` VALUES (37735, '64.79.15607520752852805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:35', 2, 0, '', '2019-06-17 14:14:35');
INSERT INTO `access_log` VALUES (37736, '64.78.15607520764462809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:36', 2, 0, '', '2019-06-17 14:14:36');
INSERT INTO `access_log` VALUES (37737, '64.83.15607520772362797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:37', 2, 0, '', '2019-06-17 14:14:37');
INSERT INTO `access_log` VALUES (37738, '64.77.15607520779422815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:38', 1, 0, '', '2019-06-17 14:14:38');
INSERT INTO `access_log` VALUES (37739, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:38', 5, 0, '', '2019-06-17 14:14:38');
INSERT INTO `access_log` VALUES (37740, '64.82.15607520794932817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:39', 2, 0, '', '2019-06-17 14:14:39');
INSERT INTO `access_log` VALUES (37741, '64.81.15607520796362811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:40', 2, 0, '', '2019-06-17 14:14:40');
INSERT INTO `access_log` VALUES (37742, '64.76.15607520802132801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:40', 2, 0, '', '2019-06-17 14:14:40');
INSERT INTO `access_log` VALUES (37743, '64.84.15607520807312809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:41', 2, 0, '', '2019-06-17 14:14:41');
INSERT INTO `access_log` VALUES (37744, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:41', 6, 0, '', '2019-06-17 14:14:41');
INSERT INTO `access_log` VALUES (37745, '64.80.15607520828682813', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.148.56.49', '2019-06-17 14:14:43', 8, 0, '', '2019-06-17 14:14:43');
INSERT INTO `access_log` VALUES (37746, '65.49.15607521107963583', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:11', 1, 1002001015, '账号未登陆', '2019-06-17 14:15:11');
INSERT INTO `access_log` VALUES (37747, '65.46.15607521107983579', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:11', 0, 1002001015, '账号未登陆', '2019-06-17 14:15:11');
INSERT INTO `access_log` VALUES (37748, '65.54.15607521108053525', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:11', 1, 1002001015, '账号未登陆', '2019-06-17 14:15:11');
INSERT INTO `access_log` VALUES (37749, '65.3607.15607521143075327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:14', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 14:15:14');
INSERT INTO `access_log` VALUES (37750, '65.47.15607521208453553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:21', 164, 0, '', '2019-06-17 14:15:21');
INSERT INTO `access_log` VALUES (37751, '65.53.15607521213053561', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:21', 9, 0, '', '2019-06-17 14:15:21');
INSERT INTO `access_log` VALUES (37752, '65.50.15607521213063571', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:21', 10, 2001001000, '服务端发生异常', '2019-06-17 14:15:21');
INSERT INTO `access_log` VALUES (37753, '65.52.15607521213103579', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:21', 7, 0, '', '2019-06-17 14:15:21');
INSERT INTO `access_log` VALUES (37754, '65.54.15607521305913527', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:31', 10, 0, '', '2019-06-17 14:15:31');
INSERT INTO `access_log` VALUES (37755, '65.49.15607521305933585', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:31', 10, 2001001000, '服务端发生异常', '2019-06-17 14:15:31');
INSERT INTO `access_log` VALUES (37756, '65.46.15607521305983581', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:31', 10, 0, '', '2019-06-17 14:15:31');
INSERT INTO `access_log` VALUES (37757, '65.3607.15607521374185329', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:37', 9, 0, '', '2019-06-17 14:15:37');
INSERT INTO `access_log` VALUES (37758, '65.47.15607521374223555', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:37', 9, 2001001000, '服务端发生异常', '2019-06-17 14:15:37');
INSERT INTO `access_log` VALUES (37759, '65.53.15607521374273563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:37', 8, 0, '', '2019-06-17 14:15:37');
INSERT INTO `access_log` VALUES (37760, '65.50.15607521437613573', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:44', 10, 0, '', '2019-06-17 14:15:44');
INSERT INTO `access_log` VALUES (37761, '65.45.15607521437643571', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:44', 9, 2001001000, '服务端发生异常', '2019-06-17 14:15:44');
INSERT INTO `access_log` VALUES (37762, '65.49.15607521437733587', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:15:44', 9, 0, '', '2019-06-17 14:15:44');
INSERT INTO `access_log` VALUES (37763, '59.76.15607525780222865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '210.83.240.178', '2019-06-17 14:22:58', 3, 0, '', '2019-06-17 14:22:58');
INSERT INTO `access_log` VALUES (37764, '59.75.15607525780222873', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '210.83.240.178', '2019-06-17 14:22:58', 18, 2001001000, '服务端发生异常', '2019-06-17 14:22:58');
INSERT INTO `access_log` VALUES (37765, '64.83.15607525818232805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '210.83.240.178', '2019-06-17 14:23:02', 3, 0, '', '2019-06-17 14:23:02');
INSERT INTO `access_log` VALUES (37766, '64.77.15607525820262823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '210.83.240.178', '2019-06-17 14:23:02', 2, 0, '', '2019-06-17 14:23:02');
INSERT INTO `access_log` VALUES (37767, '59.77.15607525836562857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '210.83.240.178', '2019-06-17 14:23:04', 2, 0, '', '2019-06-17 14:23:04');
INSERT INTO `access_log` VALUES (37768, '59.78.15607525836582869', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '210.83.240.178', '2019-06-17 14:23:04', 10, 2001001000, '服务端发生异常', '2019-06-17 14:23:04');
INSERT INTO `access_log` VALUES (37769, '64.81.15607525855502819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '210.83.240.178', '2019-06-17 14:23:06', 2, 0, '', '2019-06-17 14:23:06');
INSERT INTO `access_log` VALUES (37770, '64.76.15607525856962809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '210.83.240.178', '2019-06-17 14:23:06', 2, 0, '', '2019-06-17 14:23:06');
INSERT INTO `access_log` VALUES (37771, '64.84.15607525864942817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '210.83.240.178', '2019-06-17 14:23:06', 2, 0, '', '2019-06-17 14:23:06');
INSERT INTO `access_log` VALUES (37772, '65.46.15607527279973589', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.112.4.2', '2019-06-17 14:25:28', 0, 1002001015, '账号未登陆', '2019-06-17 14:25:28');
INSERT INTO `access_log` VALUES (37773, '65.51.15607527280053599', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.112.4.2', '2019-06-17 14:25:28', 0, 1002001015, '账号未登陆', '2019-06-17 14:25:28');
INSERT INTO `access_log` VALUES (37774, '65.53.15607527280063575', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.112.4.2', '2019-06-17 14:25:28', 1, 1002001015, '账号未登陆', '2019-06-17 14:25:28');
INSERT INTO `access_log` VALUES (37775, '65.3607.15607527306785335', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.112.4.2', '2019-06-17 14:25:31', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 14:25:31');
INSERT INTO `access_log` VALUES (37776, '65.52.15607527428943591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.112.4.2', '2019-06-17 14:25:43', 400, 0, '', '2019-06-17 14:25:43');
INSERT INTO `access_log` VALUES (37777, '65.49.15607527435813599', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.112.4.2', '2019-06-17 14:25:44', 10, 0, '', '2019-06-17 14:25:44');
INSERT INTO `access_log` VALUES (37778, '65.50.15607527435923581', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.112.4.2', '2019-06-17 14:25:44', 10, 2001001000, '服务端发生异常', '2019-06-17 14:25:44');
INSERT INTO `access_log` VALUES (37779, '65.45.15607527435933579', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.112.4.2', '2019-06-17 14:25:44', 9, 0, '', '2019-06-17 14:25:44');
INSERT INTO `access_log` VALUES (37780, '65.51.15607530748173605', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:31:15', 10, 2001001000, '服务端发生异常', '2019-06-17 14:31:15');
INSERT INTO `access_log` VALUES (37781, '65.3607.15607530748235341', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:31:15', 131, 0, '', '2019-06-17 14:31:15');
INSERT INTO `access_log` VALUES (37782, '65.53.15607530748153581', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.148.56.49', '2019-06-17 14:31:15', 143, 0, '', '2019-06-17 14:31:15');
INSERT INTO `access_log` VALUES (37783, '65.54.15607555526653579', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.97.61.90', '2019-06-17 15:12:33', 1, 1002001015, '账号未登陆', '2019-06-17 15:12:33');
INSERT INTO `access_log` VALUES (37784, '65.46.15607555526653629', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.97.61.90', '2019-06-17 15:12:33', 0, 1002001015, '账号未登陆', '2019-06-17 15:12:33');
INSERT INTO `access_log` VALUES (37785, '65.51.15607555526673639', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.97.61.90', '2019-06-17 15:12:33', 1, 1002001015, '账号未登陆', '2019-06-17 15:12:33');
INSERT INTO `access_log` VALUES (37786, '65.3607.15607555602815375', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.97.61.90', '2019-06-17 15:12:40', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 15:12:40');
INSERT INTO `access_log` VALUES (37787, '65.47.15607555676023605', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.97.61.90', '2019-06-17 15:12:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 15:12:48');
INSERT INTO `access_log` VALUES (37788, '65.45.15607555778903619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.97.61.90', '2019-06-17 15:12:58', 88, 0, '', '2019-06-17 15:12:58');
INSERT INTO `access_log` VALUES (37789, '65.50.15607555782613621', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.97.61.90', '2019-06-17 15:12:58', 57, 0, '', '2019-06-17 15:12:58');
INSERT INTO `access_log` VALUES (37790, '65.49.15607555782683639', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.97.61.90', '2019-06-17 15:12:58', 52, 0, '', '2019-06-17 15:12:58');
INSERT INTO `access_log` VALUES (37791, '65.46.15607555782693631', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.97.61.90', '2019-06-17 15:12:58', 54, 2001001000, '服务端发生异常', '2019-06-17 15:12:58');
INSERT INTO `access_log` VALUES (37792, '65.51.15607555829633641', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.97.61.90', '2019-06-17 15:13:03', 18, 0, '', '2019-06-17 15:13:03');
INSERT INTO `access_log` VALUES (37793, '65.54.15607555829633581', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.97.61.90', '2019-06-17 15:13:03', 10, 0, '', '2019-06-17 15:13:03');
INSERT INTO `access_log` VALUES (37794, '65.53.15607555829643617', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.97.61.90', '2019-06-17 15:13:03', 19, 2001001000, '服务端发生异常', '2019-06-17 15:13:03');
INSERT INTO `access_log` VALUES (37795, '59.73.15607557964542915', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:16:36', 18, 0, '', '2019-06-17 15:16:36');
INSERT INTO `access_log` VALUES (37796, '59.75.15607557964552917', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:16:36', 41, 2001001000, '服务端发生异常', '2019-06-17 15:16:36');
INSERT INTO `access_log` VALUES (37797, '64.83.15607558030402849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:16:43', 9, 0, '', '2019-06-17 15:16:43');
INSERT INTO `access_log` VALUES (37798, '64.77.15607558031632867', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:16:43', 3, 0, '', '2019-06-17 15:16:43');
INSERT INTO `access_log` VALUES (37799, '64.82.15607558051432869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:16:45', 2, 0, '', '2019-06-17 15:16:45');
INSERT INTO `access_log` VALUES (37800, '64.81.15607558068382863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:16:47', 1, 0, '', '2019-06-17 15:16:47');
INSERT INTO `access_log` VALUES (37801, '64.76.15607558078622853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:16:48', 2, 0, '', '2019-06-17 15:16:48');
INSERT INTO `access_log` VALUES (37802, '59.78.15607558175542913', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:16:58', 7, 0, '', '2019-06-17 15:16:58');
INSERT INTO `access_log` VALUES (37803, '59.77.15607558175532901', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:16:58', 20, 2001001000, '服务端发生异常', '2019-06-17 15:16:58');
INSERT INTO `access_log` VALUES (37804, '64.80.15607558214962865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:17:01', 2, 0, '', '2019-06-17 15:17:01');
INSERT INTO `access_log` VALUES (37805, '64.79.15607558216362859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:17:02', 2, 0, '', '2019-06-17 15:17:02');
INSERT INTO `access_log` VALUES (37806, '64.85.15607558234822875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:17:03', 2, 0, '', '2019-06-17 15:17:03');
INSERT INTO `access_log` VALUES (37807, '64.78.15607558239742863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:17:04', 2, 0, '', '2019-06-17 15:17:04');
INSERT INTO `access_log` VALUES (37808, '64.83.15607558244122851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:17:04', 1, 0, '', '2019-06-17 15:17:04');
INSERT INTO `access_log` VALUES (37809, '64.77.15607558248212869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:17:05', 2, 0, '', '2019-06-17 15:17:05');
INSERT INTO `access_log` VALUES (37810, '65.49.15607558697893643', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:17:50', 1, 1002001015, '账号未登陆', '2019-06-17 15:17:50');
INSERT INTO `access_log` VALUES (37811, '65.53.15607558698053623', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:17:50', 0, 1002001015, '账号未登陆', '2019-06-17 15:17:50');
INSERT INTO `access_log` VALUES (37812, '65.51.15607558698113645', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:17:50', 0, 1002001015, '账号未登陆', '2019-06-17 15:17:50');
INSERT INTO `access_log` VALUES (37813, '65.47.15607558802663613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:18:00', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 15:18:00');
INSERT INTO `access_log` VALUES (37814, '65.52.15607558850643637', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:18:05', 75, 0, '', '2019-06-17 15:18:05');
INSERT INTO `access_log` VALUES (37815, '65.45.15607558854683625', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:18:05', 18, 0, '', '2019-06-17 15:18:05');
INSERT INTO `access_log` VALUES (37816, '65.46.15607558854683639', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:18:05', 18, 2001001000, '服务端发生异常', '2019-06-17 15:18:05');
INSERT INTO `access_log` VALUES (37817, '65.50.15607558855263629', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.33.231.52', '2019-06-17 15:18:06', 9, 0, '', '2019-06-17 15:18:06');
INSERT INTO `access_log` VALUES (37818, '65.51.15607566679343657', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.80.147.244', '2019-06-17 15:31:08', 0, 1002001015, '账号未登陆', '2019-06-17 15:31:08');
INSERT INTO `access_log` VALUES (37819, '65.49.15607566679353655', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.80.147.244', '2019-06-17 15:31:08', 1, 1002001015, '账号未登陆', '2019-06-17 15:31:08');
INSERT INTO `access_log` VALUES (37820, '65.3607.15607566679375395', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.80.147.244', '2019-06-17 15:31:08', 0, 1002001015, '账号未登陆', '2019-06-17 15:31:08');
INSERT INTO `access_log` VALUES (37821, '65.52.15607566704533649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.80.147.244', '2019-06-17 15:31:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 15:31:10');
INSERT INTO `access_log` VALUES (37822, '65.46.15607566830293651', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.80.147.244', '2019-06-17 15:31:23', 91, 0, '', '2019-06-17 15:31:23');
INSERT INTO `access_log` VALUES (37823, '65.45.15607566833593637', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.80.147.244', '2019-06-17 15:31:23', 10, 0, '', '2019-06-17 15:31:23');
INSERT INTO `access_log` VALUES (37824, '65.54.15607566833853599', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.80.147.244', '2019-06-17 15:31:23', 8, 0, '', '2019-06-17 15:31:23');
INSERT INTO `access_log` VALUES (37825, '65.50.15607566833763641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.80.147.244', '2019-06-17 15:31:23', 18, 2001001000, '服务端发生异常', '2019-06-17 15:31:23');
INSERT INTO `access_log` VALUES (37826, '59.75.15607567899422931', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-17 15:33:10', 4, 0, '', '2019-06-17 15:33:10');
INSERT INTO `access_log` VALUES (37827, '59.73.15607567899462929', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-17 15:33:10', 17, 2001001000, '服务端发生异常', '2019-06-17 15:33:10');
INSERT INTO `access_log` VALUES (37828, '59.78.15607568008712927', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-17 15:33:21', 3, 0, '', '2019-06-17 15:33:21');
INSERT INTO `access_log` VALUES (37829, '59.77.15607568008712915', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-17 15:33:21', 19, 2001001000, '服务端发生异常', '2019-06-17 15:33:21');
INSERT INTO `access_log` VALUES (37830, '64.85.15607568130712889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:33:33', 2, 0, '', '2019-06-17 15:33:33');
INSERT INTO `access_log` VALUES (37831, '64.78.15607568132902877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:33:33', 2, 0, '', '2019-06-17 15:33:33');
INSERT INTO `access_log` VALUES (37832, '64.77.15607568212062883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:33:41', 2, 0, '', '2019-06-17 15:33:41');
INSERT INTO `access_log` VALUES (37833, '65.53.15607568222233639', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:33:42', 0, 1002001015, '账号未登陆', '2019-06-17 15:33:42');
INSERT INTO `access_log` VALUES (37834, '65.3607.15607568222365399', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:33:42', 0, 1002001015, '账号未登陆', '2019-06-17 15:33:42');
INSERT INTO `access_log` VALUES (37835, '65.51.15607568222413661', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:33:42', 0, 1002001015, '账号未登陆', '2019-06-17 15:33:42');
INSERT INTO `access_log` VALUES (37836, '64.82.15607568226062885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:33:43', 2, 0, '', '2019-06-17 15:33:43');
INSERT INTO `access_log` VALUES (37837, '64.81.15607568241052879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:33:44', 1, 0, '', '2019-06-17 15:33:44');
INSERT INTO `access_log` VALUES (37838, '64.76.15607568245632869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:33:45', 2, 0, '', '2019-06-17 15:33:45');
INSERT INTO `access_log` VALUES (37839, '64.84.15607568253952877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:33:45', 1, 0, '', '2019-06-17 15:33:45');
INSERT INTO `access_log` VALUES (37840, '64.79.15607568334142875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:33:53', 2, 0, '', '2019-06-17 15:33:53');
INSERT INTO `access_log` VALUES (37841, '64.85.15607568335582891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:33:54', 2, 0, '', '2019-06-17 15:33:54');
INSERT INTO `access_log` VALUES (37842, '65.47.15607568419403629', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaiyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:34:02', 77, 0, '', '2019-06-17 15:34:02');
INSERT INTO `access_log` VALUES (37843, '65.52.15607568422823653', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:34:02', 9, 0, '', '2019-06-17 15:34:02');
INSERT INTO `access_log` VALUES (37844, '65.46.15607568422883655', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:34:02', 10, 2001001000, '服务端发生异常', '2019-06-17 15:34:02');
INSERT INTO `access_log` VALUES (37845, '65.45.15607568423023641', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:34:02', 9, 0, '', '2019-06-17 15:34:02');
INSERT INTO `access_log` VALUES (37846, '59.72.15607568434592927', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:34:03', 3, 0, '', '2019-06-17 15:34:03');
INSERT INTO `access_log` VALUES (37847, '59.74.15607568434622925', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:34:03', 13, 2001001000, '服务端发生异常', '2019-06-17 15:34:03');
INSERT INTO `access_log` VALUES (37848, '64.83.15607568567652867', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:34:17', 2, 0, '', '2019-06-17 15:34:17');
INSERT INTO `access_log` VALUES (37849, '64.77.15607568569992885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:34:17', 1, 0, '', '2019-06-17 15:34:17');
INSERT INTO `access_log` VALUES (37850, '64.82.15607568587282887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:34:19', 2, 0, '', '2019-06-17 15:34:19');
INSERT INTO `access_log` VALUES (37851, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:34:19', 6, 0, '', '2019-06-17 15:34:19');
INSERT INTO `access_log` VALUES (37852, '65.50.15607568622943645', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:34:22', 9, 0, '', '2019-06-17 15:34:22');
INSERT INTO `access_log` VALUES (37853, '65.53.15607568623063641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:34:22', 17, 2001001000, '服务端发生异常', '2019-06-17 15:34:22');
INSERT INTO `access_log` VALUES (37854, '65.3607.15607568623135401', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:34:22', 16, 0, '', '2019-06-17 15:34:22');
INSERT INTO `access_log` VALUES (37855, '64.76.15607568675872871', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:34:28', 7, 0, '', '2019-06-17 15:34:28');
INSERT INTO `access_log` VALUES (37856, '65.49.15607568750323661', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:34:35', 8, 0, '', '2019-06-17 15:34:35');
INSERT INTO `access_log` VALUES (37857, '65.47.15607568750403631', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:34:35', 9, 2001001000, '服务端发生异常', '2019-06-17 15:34:35');
INSERT INTO `access_log` VALUES (37858, '65.52.15607568750513655', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:34:35', 8, 0, '', '2019-06-17 15:34:35');
INSERT INTO `access_log` VALUES (37859, '64.80.15607568838482883', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Mobile Safari/537.36', '125.46.74.93', '2019-06-17 15:34:44', 30, 0, '', '2019-06-17 15:34:44');
INSERT INTO `access_log` VALUES (37860, '65.54.15607569034573605', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:35:03', 9, 0, '', '2019-06-17 15:35:03');
INSERT INTO `access_log` VALUES (37861, '65.53.15607569034653643', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:35:03', 10, 2001001000, '服务端发生异常', '2019-06-17 15:35:03');
INSERT INTO `access_log` VALUES (37862, '65.3607.15607569034705403', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:35:03', 8, 0, '', '2019-06-17 15:35:03');
INSERT INTO `access_log` VALUES (37863, '65.50.15607569089083647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:35:09', 9, 0, '', '2019-06-17 15:35:09');
INSERT INTO `access_log` VALUES (37864, '65.51.15607569089153665', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:35:09', 10, 2001001000, '服务端发生异常', '2019-06-17 15:35:09');
INSERT INTO `access_log` VALUES (37865, '65.49.15607569089223663', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:35:09', 9, 0, '', '2019-06-17 15:35:09');
INSERT INTO `access_log` VALUES (37866, '65.52.15607569129283657', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:35:13', 10, 0, '', '2019-06-17 15:35:13');
INSERT INTO `access_log` VALUES (37867, '65.46.15607569129363659', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:35:13', 10, 2001001000, '服务端发生异常', '2019-06-17 15:35:13');
INSERT INTO `access_log` VALUES (37868, '65.45.15607569129423645', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.1.21.54', '2019-06-17 15:35:13', 9, 0, '', '2019-06-17 15:35:13');
INSERT INTO `access_log` VALUES (37869, '65.3607.15607569412325405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-17 15:35:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 15:35:41');
INSERT INTO `access_log` VALUES (37870, '65.47.15607569511143635', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-17 15:35:51', 76, 0, '', '2019-06-17 15:35:51');
INSERT INTO `access_log` VALUES (37871, '65.49.15607569515993665', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-17 15:35:52', 7, 0, '', '2019-06-17 15:35:52');
INSERT INTO `access_log` VALUES (37872, '65.51.15607569516013667', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-17 15:35:52', 8, 2001001000, '服务端发生异常', '2019-06-17 15:35:52');
INSERT INTO `access_log` VALUES (37873, '65.50.15607569516453649', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-17 15:35:52', 8, 0, '', '2019-06-17 15:35:52');
INSERT INTO `access_log` VALUES (37874, '65.45.15607569756273647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-17 15:36:16', 10, 0, '', '2019-06-17 15:36:16');
INSERT INTO `access_log` VALUES (37875, '65.54.15607569756273609', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-17 15:36:16', 11, 2001001000, '服务端发生异常', '2019-06-17 15:36:16');
INSERT INTO `access_log` VALUES (37876, '65.53.15607569756333647', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '125.46.74.93', '2019-06-17 15:36:16', 9, 0, '', '2019-06-17 15:36:16');
INSERT INTO `access_log` VALUES (37877, '65.50.15607573165983655', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.4.120.231', '2019-06-17 15:41:57', 0, 1002001015, '账号未登陆', '2019-06-17 15:41:57');
INSERT INTO `access_log` VALUES (37878, '65.51.15607573165983673', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.4.120.231', '2019-06-17 15:41:57', 1, 1002001015, '账号未登陆', '2019-06-17 15:41:57');
INSERT INTO `access_log` VALUES (37879, '65.46.15607573166253667', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.4.120.231', '2019-06-17 15:41:57', 1, 1002001015, '账号未登陆', '2019-06-17 15:41:57');
INSERT INTO `access_log` VALUES (37880, '65.52.15607573195523665', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '116.128.128.79', '2019-06-17 15:42:00', 0, 1002001015, '账号未登陆', '2019-06-17 15:42:00');
INSERT INTO `access_log` VALUES (37881, '65.45.15607573213553653', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.4.120.231', '2019-06-17 15:42:01', 89, 0, '', '2019-06-17 15:42:01');
INSERT INTO `access_log` VALUES (37882, '65.53.15607573217393653', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.4.120.231', '2019-06-17 15:42:02', 9, 0, '', '2019-06-17 15:42:02');
INSERT INTO `access_log` VALUES (37883, '65.54.15607573217453615', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.4.120.231', '2019-06-17 15:42:02', 10, 2001001000, '服务端发生异常', '2019-06-17 15:42:02');
INSERT INTO `access_log` VALUES (37884, '65.3607.15607573217485413', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '111.4.120.231', '2019-06-17 15:42:02', 8, 0, '', '2019-06-17 15:42:02');
INSERT INTO `access_log` VALUES (37885, '65.51.15607573877933675', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:43:08', 0, 1002001015, '账号未登陆', '2019-06-17 15:43:08');
INSERT INTO `access_log` VALUES (37886, '65.52.15607573877933667', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:43:08', 0, 1002001015, '账号未登陆', '2019-06-17 15:43:08');
INSERT INTO `access_log` VALUES (37887, '65.45.15607573877963655', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:43:08', 0, 1002001015, '账号未登陆', '2019-06-17 15:43:08');
INSERT INTO `access_log` VALUES (37888, '65.53.15607573952413655', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:43:15', 82, 0, '', '2019-06-17 15:43:15');
INSERT INTO `access_log` VALUES (37889, '65.47.15607573957813645', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:43:16', 9, 0, '', '2019-06-17 15:43:16');
INSERT INTO `access_log` VALUES (37890, '65.3607.15607573957815415', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:43:16', 11, 2001001000, '服务端发生异常', '2019-06-17 15:43:16');
INSERT INTO `access_log` VALUES (37891, '65.49.15607573957853675', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:43:16', 8, 0, '', '2019-06-17 15:43:16');
INSERT INTO `access_log` VALUES (37892, '65.46.15607574028823671', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:43:23', 19, 0, '', '2019-06-17 15:43:23');
INSERT INTO `access_log` VALUES (37893, '65.50.15607574028823659', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:43:23', 20, 2001001000, '服务端发生异常', '2019-06-17 15:43:23');
INSERT INTO `access_log` VALUES (37894, '65.52.15607574028863669', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:43:23', 18, 0, '', '2019-06-17 15:43:23');
INSERT INTO `access_log` VALUES (37895, '65.54.15607574241223619', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:43:44', 8, 0, '', '2019-06-17 15:43:44');
INSERT INTO `access_log` VALUES (37896, '65.53.15607574242213657', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:43:44', 10, 0, '', '2019-06-17 15:43:44');
INSERT INTO `access_log` VALUES (37897, '65.3607.15607574242215417', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:43:44', 10, 2001001000, '服务端发生异常', '2019-06-17 15:43:44');
INSERT INTO `access_log` VALUES (37898, '65.46.15607574408343673', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:44:01', 9, 0, '', '2019-06-17 15:44:01');
INSERT INTO `access_log` VALUES (37899, '65.50.15607574408363661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:44:01', 8, 0, '', '2019-06-17 15:44:01');
INSERT INTO `access_log` VALUES (37900, '65.49.15607574408343677', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.58.47', '2019-06-17 15:44:01', 11, 2001001000, '服务端发生异常', '2019-06-17 15:44:01');
INSERT INTO `access_log` VALUES (37901, '59.80.15607585680672941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '180.167.213.26', '2019-06-17 16:02:48', 11, 0, '', '2019-06-17 16:02:48');
INSERT INTO `access_log` VALUES (37902, '59.72.15607585680692951', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '180.167.213.26', '2019-06-17 16:02:48', 45, 2001001000, '服务端发生异常', '2019-06-17 16:02:48');
INSERT INTO `access_log` VALUES (37903, '64.83.15607585702532891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '180.167.213.26', '2019-06-17 16:02:50', 10, 0, '', '2019-06-17 16:02:50');
INSERT INTO `access_log` VALUES (37904, '64.82.15607585703692911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '180.167.213.26', '2019-06-17 16:02:50', 9, 0, '', '2019-06-17 16:02:50');
INSERT INTO `access_log` VALUES (37905, '59.79.15607585711532957', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '180.167.213.26', '2019-06-17 16:02:51', 7, 0, '', '2019-06-17 16:02:51');
INSERT INTO `access_log` VALUES (37906, '59.75.15607585711542957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '180.167.213.26', '2019-06-17 16:02:51', 20, 2001001000, '服务端发生异常', '2019-06-17 16:02:51');
INSERT INTO `access_log` VALUES (37907, '66.50.15607585733131325', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '180.167.213.26', '2019-06-17 16:02:53', 7, 1002001012, '访问令牌已过期', '2019-06-17 16:02:53');
INSERT INTO `access_log` VALUES (37908, '66.57.15607585734051327', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=c0039cec6aba456d8422c64052ae681e', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '180.167.213.26', '2019-06-17 16:02:53', 14, 1002001018, '访问令牌已过期', '2019-06-17 16:02:53');
INSERT INTO `access_log` VALUES (37909, '65.52.15607594233183697', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-17 16:17:03', 5, 1002001012, '访问令牌已过期', '2019-06-17 16:17:03');
INSERT INTO `access_log` VALUES (37910, '65.51.15607594233253705', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-17 16:17:03', 3, 1002001012, '访问令牌已过期', '2019-06-17 16:17:03');
INSERT INTO `access_log` VALUES (37911, '65.45.15607594233313685', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-17 16:17:03', 11, 1002001012, '访问令牌已过期', '2019-06-17 16:17:03');
INSERT INTO `access_log` VALUES (37912, '65.54.15607594264283649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-17 16:17:06', 305, 0, '', '2019-06-17 16:17:07');
INSERT INTO `access_log` VALUES (37913, '65.53.15607594269563685', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-17 16:17:07', 10, 0, '', '2019-06-17 16:17:07');
INSERT INTO `access_log` VALUES (37914, '65.46.15607594269593703', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-17 16:17:07', 9, 0, '', '2019-06-17 16:17:07');
INSERT INTO `access_log` VALUES (37915, '65.47.15607594269593675', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-17 16:17:07', 9, 2001001000, '服务端发生异常', '2019-06-17 16:17:07');
INSERT INTO `access_log` VALUES (37916, '65.52.15607600592013707', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.28.133.53', '2019-06-17 16:27:39', 0, 1002001015, '账号未登陆', '2019-06-17 16:27:39');
INSERT INTO `access_log` VALUES (37917, '65.51.15607600592083715', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.28.133.53', '2019-06-17 16:27:39', 0, 1002001015, '账号未登陆', '2019-06-17 16:27:39');
INSERT INTO `access_log` VALUES (37918, '65.45.15607600592093695', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.28.133.53', '2019-06-17 16:27:39', 0, 1002001015, '账号未登陆', '2019-06-17 16:27:39');
INSERT INTO `access_log` VALUES (37919, '65.54.15607600618903659', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.28.133.53', '2019-06-17 16:27:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 16:27:42');
INSERT INTO `access_log` VALUES (37920, '65.47.15607600679023685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.28.133.53', '2019-06-17 16:27:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 16:27:48');
INSERT INTO `access_log` VALUES (37921, '59.71.15607607354722981', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.62.134.100', '2019-06-17 16:38:55', 18, 0, '', '2019-06-17 16:38:55');
INSERT INTO `access_log` VALUES (37922, '59.80.15607607354742971', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.62.134.100', '2019-06-17 16:38:55', 20, 2001001000, '服务端发生异常', '2019-06-17 16:38:55');
INSERT INTO `access_log` VALUES (37923, '65.51.15607607702313725', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.62.134.100', '2019-06-17 16:39:30', 0, 1002001015, '账号未登陆', '2019-06-17 16:39:30');
INSERT INTO `access_log` VALUES (37924, '65.54.15607607702333669', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.62.134.100', '2019-06-17 16:39:30', 1, 1002001015, '账号未登陆', '2019-06-17 16:39:30');
INSERT INTO `access_log` VALUES (37925, '65.47.15607607702353695', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.62.134.100', '2019-06-17 16:39:30', 1, 1002001015, '账号未登陆', '2019-06-17 16:39:30');
INSERT INTO `access_log` VALUES (37926, '65.53.15607607737083705', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.62.134.100', '2019-06-17 16:39:34', 97, 0, '', '2019-06-17 16:39:34');
INSERT INTO `access_log` VALUES (37927, '65.46.15607607740543723', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.62.134.100', '2019-06-17 16:39:34', 9, 0, '', '2019-06-17 16:39:34');
INSERT INTO `access_log` VALUES (37928, '65.50.15607607740553711', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.62.134.100', '2019-06-17 16:39:34', 9, 0, '', '2019-06-17 16:39:34');
INSERT INTO `access_log` VALUES (37929, '65.3607.15607607740545467', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.62.134.100', '2019-06-17 16:39:34', 10, 2001001000, '服务端发生异常', '2019-06-17 16:39:34');
INSERT INTO `access_log` VALUES (37930, '65.50.15607614393793723', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-17 16:50:39', 4, 1002001012, '访问令牌已过期', '2019-06-17 16:50:39');
INSERT INTO `access_log` VALUES (37931, '65.53.15607614393803713', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-17 16:50:39', 3, 1002001012, '访问令牌已过期', '2019-06-17 16:50:39');
INSERT INTO `access_log` VALUES (37932, '65.46.15607614394053733', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-17 16:50:39', 3, 1002001012, '访问令牌已过期', '2019-06-17 16:50:39');
INSERT INTO `access_log` VALUES (37933, '65.3607.15607614414465479', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-17 16:50:41', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 16:50:41');
INSERT INTO `access_log` VALUES (37934, '65.49.15607614443183737', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-17 16:50:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 16:50:44');
INSERT INTO `access_log` VALUES (37935, '65.51.15607614544223737', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-17 16:50:54', 109, 0, '', '2019-06-17 16:50:55');
INSERT INTO `access_log` VALUES (37936, '65.45.15607614551733721', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-17 16:50:55', 10, 0, '', '2019-06-17 16:50:55');
INSERT INTO `access_log` VALUES (37937, '65.47.15607614551813707', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-17 16:50:55', 9, 0, '', '2019-06-17 16:50:55');
INSERT INTO `access_log` VALUES (37938, '65.54.15607614551803679', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-17 16:50:55', 9, 2001001000, '服务端发生异常', '2019-06-17 16:50:55');
INSERT INTO `access_log` VALUES (37939, '65.46.15607614599593735', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-17 16:51:00', 9, 0, '', '2019-06-17 16:51:00');
INSERT INTO `access_log` VALUES (37940, '65.53.15607614599593715', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-17 16:51:00', 10, 2001001000, '服务端发生异常', '2019-06-17 16:51:00');
INSERT INTO `access_log` VALUES (37941, '65.50.15607614599613725', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '222.82.178.103', '2019-06-17 16:51:00', 11, 0, '', '2019-06-17 16:51:00');
INSERT INTO `access_log` VALUES (37942, '59.79.15607616592852999', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:19', 5, 0, '', '2019-06-17 16:54:19');
INSERT INTO `access_log` VALUES (37943, '59.75.15607616592852999', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:19', 45, 2001001000, '服务端发生异常', '2019-06-17 16:54:19');
INSERT INTO `access_log` VALUES (37944, '64.83.15607616631762933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:23', 10, 0, '', '2019-06-17 16:54:23');
INSERT INTO `access_log` VALUES (37945, '64.77.15607616633132951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:23', 3, 0, '', '2019-06-17 16:54:23');
INSERT INTO `access_log` VALUES (37946, '66.52.15607616733211371', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18274730213', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:33', 111, 0, '', '2019-06-17 16:54:33');
INSERT INTO `access_log` VALUES (37947, '64.82.15607616846792953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:45', 2, 0, '', '2019-06-17 16:54:45');
INSERT INTO `access_log` VALUES (37948, '64.76.15607616847882937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:45', 2, 0, '', '2019-06-17 16:54:45');
INSERT INTO `access_log` VALUES (37949, '59.78.15607616853852995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:45', 3, 0, '', '2019-06-17 16:54:45');
INSERT INTO `access_log` VALUES (37950, '59.76.15607616853852991', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:45', 15, 2001001000, '服务端发生异常', '2019-06-17 16:54:45');
INSERT INTO `access_log` VALUES (37951, '65.54.15607616905443683', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:51', 1, 1002001015, '账号未登陆', '2019-06-17 16:54:51');
INSERT INTO `access_log` VALUES (37952, '65.47.15607616905433711', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:51', 0, 1002001015, '账号未登陆', '2019-06-17 16:54:51');
INSERT INTO `access_log` VALUES (37953, '65.46.15607616905453739', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:51', 0, 1002001015, '账号未登陆', '2019-06-17 16:54:51');
INSERT INTO `access_log` VALUES (37954, '65.50.15607616947713729', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:55', 4, 1002002000, '账号不存在', '2019-06-17 16:54:55');
INSERT INTO `access_log` VALUES (37955, '65.3607.15607616974655485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:57', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 16:54:57');
INSERT INTO `access_log` VALUES (37956, '65.49.15607616986103743', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 16:54:59');
INSERT INTO `access_log` VALUES (37957, '65.52.15607616990033735', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 16:54:59');
INSERT INTO `access_log` VALUES (37958, '65.51.15607616993803743', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:54:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 16:54:59');
INSERT INTO `access_log` VALUES (37959, '65.45.15607616997623727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:55:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 16:55:00');
INSERT INTO `access_log` VALUES (37960, '65.47.15607617001553713', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:55:00', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 16:55:00');
INSERT INTO `access_log` VALUES (37961, '65.46.15607617005233741', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:55:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 16:55:01');
INSERT INTO `access_log` VALUES (37962, '65.54.15607617009563685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:55:01', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 16:55:01');
INSERT INTO `access_log` VALUES (37963, '59.71.15607617011792995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.181.20', '2019-06-17 16:55:01', 3, 0, '', '2019-06-17 16:55:01');
INSERT INTO `access_log` VALUES (37964, '59.80.15607617011802985', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.87.181.20', '2019-06-17 16:55:01', 13, 2001001000, '服务端发生异常', '2019-06-17 16:55:01');
INSERT INTO `access_log` VALUES (37965, '65.53.15607617014583721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:55:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 16:55:01');
INSERT INTO `access_log` VALUES (37966, '65.50.15607617018513731', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:55:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 16:55:02');
INSERT INTO `access_log` VALUES (37967, '65.3607.15607617065565487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:55:07', 65, 0, '', '2019-06-17 16:55:07');
INSERT INTO `access_log` VALUES (37968, '65.49.15607617068933745', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:55:07', 10, 0, '', '2019-06-17 16:55:07');
INSERT INTO `access_log` VALUES (37969, '65.52.15607617068933737', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:55:07', 9, 0, '', '2019-06-17 16:55:07');
INSERT INTO `access_log` VALUES (37970, '65.51.15607617068953745', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.63.89.203', '2019-06-17 16:55:07', 10, 2001001000, '服务端发生异常', '2019-06-17 16:55:07');
INSERT INTO `access_log` VALUES (37971, '66.49.15607628022501391', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '180.167.101.22', '2019-06-17 17:13:22', 1, 1002001015, '账号未登陆', '2019-06-17 17:13:22');
INSERT INTO `access_log` VALUES (37972, '59.78.15607638822093025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.4.48', '2019-06-17 17:31:22', 11, 0, '', '2019-06-17 17:31:22');
INSERT INTO `access_log` VALUES (37973, '59.77.15607638822103015', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.4.48', '2019-06-17 17:31:22', 15, 2001001000, '服务端发生异常', '2019-06-17 17:31:22');
INSERT INTO `access_log` VALUES (37974, '64.81.15607638854652977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.4.48', '2019-06-17 17:31:25', 11, 0, '', '2019-06-17 17:31:25');
INSERT INTO `access_log` VALUES (37975, '64.82.15607638856052983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.4.48', '2019-06-17 17:31:26', 3, 0, '', '2019-06-17 17:31:26');
INSERT INTO `access_log` VALUES (37976, '64.76.15607638871252967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.4.48', '2019-06-17 17:31:27', 2, 0, '', '2019-06-17 17:31:27');
INSERT INTO `access_log` VALUES (37977, '64.84.15607638882852975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.4.48', '2019-06-17 17:31:28', 2, 0, '', '2019-06-17 17:31:28');
INSERT INTO `access_log` VALUES (37978, '64.80.15607638891042979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.4.48', '2019-06-17 17:31:29', 1, 0, '', '2019-06-17 17:31:29');
INSERT INTO `access_log` VALUES (37979, '59.80.15607638903043015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.4.48', '2019-06-17 17:31:30', 4, 0, '', '2019-06-17 17:31:30');
INSERT INTO `access_log` VALUES (37980, '59.71.15607638903043025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.4.48', '2019-06-17 17:31:30', 14, 2001001000, '服务端发生异常', '2019-06-17 17:31:30');
INSERT INTO `access_log` VALUES (37981, '65.50.15607645083043771', 0, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'resourceIds=&id=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '58.247.119.44', '2019-06-17 17:41:48', 0, 1002001015, '账号未登陆', '2019-06-17 17:41:48');
INSERT INTO `access_log` VALUES (37982, '65.3607.15607648077485533', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.64.84', '2019-06-17 17:46:48', 0, 1002001015, '账号未登陆', '2019-06-17 17:46:48');
INSERT INTO `access_log` VALUES (37983, '65.52.15607648077483781', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.64.84', '2019-06-17 17:46:48', 0, 1002001015, '账号未登陆', '2019-06-17 17:46:48');
INSERT INTO `access_log` VALUES (37984, '65.51.15607648077573789', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.64.84', '2019-06-17 17:46:48', 1, 1002001015, '账号未登陆', '2019-06-17 17:46:48');
INSERT INTO `access_log` VALUES (37985, '65.47.15607648494713759', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.64.84', '2019-06-17 17:47:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 17:47:29');
INSERT INTO `access_log` VALUES (37986, '65.50.15607648768273777', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.64.84', '2019-06-17 17:47:57', 213, 0, '', '2019-06-17 17:47:57');
INSERT INTO `access_log` VALUES (37987, '65.52.15607648773173783', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.64.84', '2019-06-17 17:47:57', 11, 0, '', '2019-06-17 17:47:57');
INSERT INTO `access_log` VALUES (37988, '65.51.15607648773673791', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.64.84', '2019-06-17 17:47:57', 11, 2001001000, '服务端发生异常', '2019-06-17 17:47:57');
INSERT INTO `access_log` VALUES (37989, '65.3607.15607648773875535', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.64.84', '2019-06-17 17:47:57', 10, 0, '', '2019-06-17 17:47:57');
INSERT INTO `access_log` VALUES (37990, '65.49.15607648808593789', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.64.84', '2019-06-17 17:48:01', 12, 0, '', '2019-06-17 17:48:01');
INSERT INTO `access_log` VALUES (37991, '65.45.15607648808653775', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.64.84', '2019-06-17 17:48:01', 10, 2001001000, '服务端发生异常', '2019-06-17 17:48:01');
INSERT INTO `access_log` VALUES (37992, '65.46.15607648808693791', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.60.64.84', '2019-06-17 17:48:01', 17, 0, '', '2019-06-17 17:48:01');
INSERT INTO `access_log` VALUES (37993, '59.74.15607654042283043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.144.212.32', '2019-06-17 17:56:44', 3, 0, '', '2019-06-17 17:56:44');
INSERT INTO `access_log` VALUES (37994, '59.79.15607654042283051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.144.212.32', '2019-06-17 17:56:44', 17, 2001001000, '服务端发生异常', '2019-06-17 17:56:44');
INSERT INTO `access_log` VALUES (37995, '65.51.15607654260333799', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.144.212.32', '2019-06-17 17:57:06', 1, 1002001015, '账号未登陆', '2019-06-17 17:57:06');
INSERT INTO `access_log` VALUES (37996, '65.46.15607654260363799', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.144.212.32', '2019-06-17 17:57:06', 0, 1002001015, '账号未登陆', '2019-06-17 17:57:06');
INSERT INTO `access_log` VALUES (37997, '65.45.15607654260423783', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.144.212.32', '2019-06-17 17:57:06', 1, 1002001015, '账号未登陆', '2019-06-17 17:57:06');
INSERT INTO `access_log` VALUES (37998, '65.49.15607654287033797', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.144.212.32', '2019-06-17 17:57:09', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-17 17:57:09');
INSERT INTO `access_log` VALUES (37999, '59.72.15607727127233143', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 19:58:33', 11, 0, '', '2019-06-17 19:58:33');
INSERT INTO `access_log` VALUES (38000, '59.74.15607727127283141', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 19:58:33', 15, 2001001000, '服务端发生异常', '2019-06-17 19:58:33');
INSERT INTO `access_log` VALUES (38001, '64.80.15607727156053097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 19:58:36', 8, 0, '', '2019-06-17 19:58:36');
INSERT INTO `access_log` VALUES (38002, '64.79.15607727159033091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 19:58:36', 3, 0, '', '2019-06-17 19:58:36');
INSERT INTO `access_log` VALUES (38003, '64.85.15607727167653107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 19:58:37', 2, 0, '', '2019-06-17 19:58:37');
INSERT INTO `access_log` VALUES (38004, '64.78.15607727170433095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 19:58:37', 2, 0, '', '2019-06-17 19:58:37');
INSERT INTO `access_log` VALUES (38005, '64.83.15607727175423083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 19:58:38', 2, 0, '', '2019-06-17 19:58:38');
INSERT INTO `access_log` VALUES (38006, '64.77.15607727187213101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 19:58:39', 2, 0, '', '2019-06-17 19:58:39');
INSERT INTO `access_log` VALUES (38007, '64.81.15607727188563097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 19:58:39', 2, 0, '', '2019-06-17 19:58:39');
INSERT INTO `access_log` VALUES (38008, '59.78.15607727738233145', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.178.163', '2019-06-17 19:59:34', 13, 2001001000, '服务端发生异常', '2019-06-17 19:59:34');
INSERT INTO `access_log` VALUES (38009, '64.80.15607727751373099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.175', '2019-06-17 19:59:35', 2, 0, '', '2019-06-17 19:59:35');
INSERT INTO `access_log` VALUES (38010, '64.79.15607727751583093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.89.239.230', '2019-06-17 19:59:35', 2, 0, '', '2019-06-17 19:59:35');
INSERT INTO `access_log` VALUES (38011, '65.54.15607730796193841', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 20:04:40', 0, 1002001015, '账号未登陆', '2019-06-17 20:04:40');
INSERT INTO `access_log` VALUES (38012, '65.53.15607730796203877', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 20:04:40', 0, 1002001015, '账号未登陆', '2019-06-17 20:04:40');
INSERT INTO `access_log` VALUES (38013, '65.50.15607730796273889', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 20:04:40', 1, 1002001015, '账号未登陆', '2019-06-17 20:04:40');
INSERT INTO `access_log` VALUES (38014, '65.3607.15607730975495647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 20:04:58', 314, 0, '', '2019-06-17 20:04:58');
INSERT INTO `access_log` VALUES (38015, '65.46.15607730980813903', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 20:04:58', 11, 0, '', '2019-06-17 20:04:58');
INSERT INTO `access_log` VALUES (38016, '65.51.15607730980873903', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 20:04:58', 11, 0, '', '2019-06-17 20:04:58');
INSERT INTO `access_log` VALUES (38017, '65.45.15607730980863887', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 20:04:58', 11, 2001001000, '服务端发生异常', '2019-06-17 20:04:58');
INSERT INTO `access_log` VALUES (38018, '65.49.15607731031063901', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 20:05:03', 8, 0, '', '2019-06-17 20:05:03');
INSERT INTO `access_log` VALUES (38019, '65.53.15607731031233879', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 20:05:03', 8, 0, '', '2019-06-17 20:05:03');
INSERT INTO `access_log` VALUES (38020, '65.47.15607731031223873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-17 20:05:03', 8, 2001001000, '服务端发生异常', '2019-06-17 20:05:03');
INSERT INTO `access_log` VALUES (38021, '65.3607.15607731391885649', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.151.178.175', '2019-06-17 20:05:39', 1, 1002001015, '账号未登陆', '2019-06-17 20:05:39');
INSERT INTO `access_log` VALUES (38022, '59.80.15607735300783145', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:10', 4, 0, '', '2019-06-17 20:12:10');
INSERT INTO `access_log` VALUES (38023, '59.71.15607735300793155', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:10', 11, 2001001000, '服务端发生异常', '2019-06-17 20:12:10');
INSERT INTO `access_log` VALUES (38024, '64.78.15607735334623107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:13', 108, 0, '', '2019-06-17 20:12:14');
INSERT INTO `access_log` VALUES (38025, '64.83.15607735336693095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:14', 2, 0, '', '2019-06-17 20:12:14');
INSERT INTO `access_log` VALUES (38026, '64.77.15607735358413113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:16', 2, 0, '', '2019-06-17 20:12:16');
INSERT INTO `access_log` VALUES (38027, '64.81.15607735363623109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:16', 2, 0, '', '2019-06-17 20:12:16');
INSERT INTO `access_log` VALUES (38028, '59.74.15607735371713153', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:17', 2, 0, '', '2019-06-17 20:12:17');
INSERT INTO `access_log` VALUES (38029, '59.72.15607735371713155', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:17', 12, 2001001000, '服务端发生异常', '2019-06-17 20:12:17');
INSERT INTO `access_log` VALUES (38030, '64.76.15607735425913099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:23', 2, 0, '', '2019-06-17 20:12:23');
INSERT INTO `access_log` VALUES (38031, '64.84.15607735426953107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:23', 2, 0, '', '2019-06-17 20:12:23');
INSERT INTO `access_log` VALUES (38032, '64.80.15607735439443111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:24', 2, 0, '', '2019-06-17 20:12:24');
INSERT INTO `access_log` VALUES (38033, '59.75.15607735448543161', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:25', 2, 0, '', '2019-06-17 20:12:25');
INSERT INTO `access_log` VALUES (38034, '59.73.15607735448543159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:25', 13, 2001001000, '服务端发生异常', '2019-06-17 20:12:25');
INSERT INTO `access_log` VALUES (38035, '64.79.15607735470403105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:27', 2, 0, '', '2019-06-17 20:12:27');
INSERT INTO `access_log` VALUES (38036, '64.85.15607735471493121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.34.39.95', '2019-06-17 20:12:27', 2, 0, '', '2019-06-17 20:12:27');
INSERT INTO `access_log` VALUES (38037, '65.54.15607918153204093', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '114.250.35.49', '2019-06-18 01:16:55', 1, 1002001015, '账号未登陆', '2019-06-18 01:16:55');
INSERT INTO `access_log` VALUES (38038, '65.53.15607918153204129', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '114.250.35.49', '2019-06-18 01:16:55', 1, 1002001015, '账号未登陆', '2019-06-18 01:16:55');
INSERT INTO `access_log` VALUES (38039, '65.50.15607918153204141', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '114.250.35.49', '2019-06-18 01:16:55', 0, 1002001015, '账号未登陆', '2019-06-18 01:16:55');
INSERT INTO `access_log` VALUES (38040, '65.52.15607918199224147', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '114.250.35.49', '2019-06-18 01:17:00', 70, 0, '', '2019-06-18 01:17:00');
INSERT INTO `access_log` VALUES (38041, '65.3607.15607918203595899', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '114.250.35.49', '2019-06-18 01:17:00', 257, 0, '', '2019-06-18 01:17:01');
INSERT INTO `access_log` VALUES (38042, '65.46.15607918203594155', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '114.250.35.49', '2019-06-18 01:17:00', 262, 2001001000, '服务端发生异常', '2019-06-18 01:17:01');
INSERT INTO `access_log` VALUES (38043, '65.45.15607918203664139', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '114.250.35.49', '2019-06-18 01:17:00', 257, 0, '', '2019-06-18 01:17:01');
INSERT INTO `access_log` VALUES (38044, '65.49.15607918438234153', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '114.250.35.49', '2019-06-18 01:17:24', 10, 0, '', '2019-06-18 01:17:24');
INSERT INTO `access_log` VALUES (38045, '65.47.15607918438264125', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '114.250.35.49', '2019-06-18 01:17:24', 10, 2001001000, '服务端发生异常', '2019-06-18 01:17:24');
INSERT INTO `access_log` VALUES (38046, '65.50.15607918438304143', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '114.250.35.49', '2019-06-18 01:17:24', 8, 0, '', '2019-06-18 01:17:24');
INSERT INTO `access_log` VALUES (38047, '59.80.15607959256333445', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.150.166', '2019-06-18 02:25:26', 17, 0, '', '2019-06-18 02:25:26');
INSERT INTO `access_log` VALUES (38048, '59.77.15607959256333445', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.150.166', '2019-06-18 02:25:26', 21, 2001001000, '服务端发生异常', '2019-06-18 02:25:26');
INSERT INTO `access_log` VALUES (38049, '65.3607.15608210163896289', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-18 09:23:36', 17, 1002001012, '访问令牌已过期', '2019-06-18 09:23:36');
INSERT INTO `access_log` VALUES (38050, '65.51.15608210163904545', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-18 09:23:36', 34, 1002001012, '访问令牌已过期', '2019-06-18 09:23:36');
INSERT INTO `access_log` VALUES (38051, '65.49.15608210163924543', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.176.106.168', '2019-06-18 09:23:36', 32, 1002001012, '访问令牌已过期', '2019-06-18 09:23:36');
INSERT INTO `access_log` VALUES (38052, '65.46.15608213684284551', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 09:29:28', 5, 1002001012, '访问令牌已过期', '2019-06-18 09:29:28');
INSERT INTO `access_log` VALUES (38053, '65.52.15608213684264543', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 09:29:28', 6, 1002001012, '访问令牌已过期', '2019-06-18 09:29:28');
INSERT INTO `access_log` VALUES (38054, '65.45.15608213684314535', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 09:29:28', 2, 1002001012, '访问令牌已过期', '2019-06-18 09:29:28');
INSERT INTO `access_log` VALUES (38055, '65.3607.15608213711236295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 09:29:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 09:29:31');
INSERT INTO `access_log` VALUES (38056, '65.49.15608213817794549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 09:29:42', 83, 0, '', '2019-06-18 09:29:42');
INSERT INTO `access_log` VALUES (38057, '65.53.15608213823434527', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 09:29:42', 9, 0, '', '2019-06-18 09:29:42');
INSERT INTO `access_log` VALUES (38058, '65.47.15608213823434521', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 09:29:42', 10, 0, '', '2019-06-18 09:29:42');
INSERT INTO `access_log` VALUES (38059, '65.50.15608213823414539', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 09:29:42', 12, 2001001000, '服务端发生异常', '2019-06-18 09:29:42');
INSERT INTO `access_log` VALUES (38060, '65.52.15608214118254545', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 09:30:12', 9, 0, '', '2019-06-18 09:30:12');
INSERT INTO `access_log` VALUES (38061, '65.45.15608214118304537', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 09:30:12', 9, 2001001000, '服务端发生异常', '2019-06-18 09:30:12');
INSERT INTO `access_log` VALUES (38062, '65.3607.15608214118356297', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 09:30:12', 127, 0, '', '2019-06-18 09:30:12');
INSERT INTO `access_log` VALUES (38063, '65.46.15608216504304557', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 09:34:10', 11, 0, '', '2019-06-18 09:34:10');
INSERT INTO `access_log` VALUES (38064, '65.45.15608216504364541', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 09:34:10', 10, 0, '', '2019-06-18 09:34:10');
INSERT INTO `access_log` VALUES (38065, '65.52.15608216504364549', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 09:34:10', 11, 2001001000, '服务端发生异常', '2019-06-18 09:34:10');
INSERT INTO `access_log` VALUES (38066, '65.53.15608218440934535', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '116.22.148.253', '2019-06-18 09:37:24', 1, 1002001015, '账号未登陆', '2019-06-18 09:37:24');
INSERT INTO `access_log` VALUES (38067, '65.47.15608218440974529', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '116.22.148.253', '2019-06-18 09:37:24', 0, 1002001015, '账号未登陆', '2019-06-18 09:37:24');
INSERT INTO `access_log` VALUES (38068, '65.50.15608218441084547', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '116.22.148.253', '2019-06-18 09:37:24', 0, 1002001015, '账号未登陆', '2019-06-18 09:37:24');
INSERT INTO `access_log` VALUES (38069, '65.54.15608218474744499', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '116.22.148.253', '2019-06-18 09:37:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 09:37:27');
INSERT INTO `access_log` VALUES (38070, '65.46.15608218640804561', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '116.22.148.253', '2019-06-18 09:37:44', 74, 0, '', '2019-06-18 09:37:44');
INSERT INTO `access_log` VALUES (38071, '65.45.15608218644024545', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '116.22.148.253', '2019-06-18 09:37:44', 10, 0, '', '2019-06-18 09:37:44');
INSERT INTO `access_log` VALUES (38072, '65.3607.15608218644066305', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '116.22.148.253', '2019-06-18 09:37:44', 9, 2001001000, '服务端发生异常', '2019-06-18 09:37:44');
INSERT INTO `access_log` VALUES (38073, '65.51.15608218644154561', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '116.22.148.253', '2019-06-18 09:37:44', 9, 0, '', '2019-06-18 09:37:44');
INSERT INTO `access_log` VALUES (38074, '65.54.15608250106344543', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.43.168', '2019-06-18 10:30:11', 14, 1002001012, '访问令牌已过期', '2019-06-18 10:30:11');
INSERT INTO `access_log` VALUES (38075, '65.52.15608250106344597', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.43.168', '2019-06-18 10:30:11', 17, 1002001012, '访问令牌已过期', '2019-06-18 10:30:11');
INSERT INTO `access_log` VALUES (38076, '65.46.15608250106344605', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.43.168', '2019-06-18 10:30:11', 20, 1002001012, '访问令牌已过期', '2019-06-18 10:30:11');
INSERT INTO `access_log` VALUES (38077, '65.47.15608250148644575', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.43.168', '2019-06-18 10:30:15', 166, 0, '', '2019-06-18 10:30:15');
INSERT INTO `access_log` VALUES (38078, '65.3607.15608250152796347', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.43.168', '2019-06-18 10:30:15', 14, 0, '', '2019-06-18 10:30:15');
INSERT INTO `access_log` VALUES (38079, '65.51.15608250152824605', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.43.168', '2019-06-18 10:30:15', 12, 0, '', '2019-06-18 10:30:15');
INSERT INTO `access_log` VALUES (38080, '65.49.15608250152824601', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.43.168', '2019-06-18 10:30:15', 16, 2001001000, '服务端发生异常', '2019-06-18 10:30:15');
INSERT INTO `access_log` VALUES (38081, '59.76.15608255482763847', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.239.53', '2019-06-18 10:39:08', 22, 2001001000, '服务端发生异常', '2019-06-18 10:39:08');
INSERT INTO `access_log` VALUES (38082, '59.73.15608255482753853', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.89.239.53', '2019-06-18 10:39:08', 22, 0, '', '2019-06-18 10:39:08');
INSERT INTO `access_log` VALUES (38083, '65.47.15608255564784583', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.74.78.190', '2019-06-18 10:39:16', 0, 1002001015, '账号未登陆', '2019-06-18 10:39:16');
INSERT INTO `access_log` VALUES (38084, '65.49.15608255564984609', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.74.78.190', '2019-06-18 10:39:16', 0, 1002001015, '账号未登陆', '2019-06-18 10:39:16');
INSERT INTO `access_log` VALUES (38085, '65.3607.15608255565186355', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.74.78.190', '2019-06-18 10:39:17', 1, 1002001015, '账号未登陆', '2019-06-18 10:39:17');
INSERT INTO `access_log` VALUES (38086, '65.51.15608255586024613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.74.78.190', '2019-06-18 10:39:19', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 10:39:19');
INSERT INTO `access_log` VALUES (38087, '65.45.15608255621694597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.74.78.190', '2019-06-18 10:39:22', 65, 0, '', '2019-06-18 10:39:22');
INSERT INTO `access_log` VALUES (38088, '65.53.15608255624344589', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.74.78.190', '2019-06-18 10:39:22', 10, 0, '', '2019-06-18 10:39:22');
INSERT INTO `access_log` VALUES (38089, '65.50.15608255624364601', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.74.78.190', '2019-06-18 10:39:22', 10, 2001001000, '服务端发生异常', '2019-06-18 10:39:22');
INSERT INTO `access_log` VALUES (38090, '65.54.15608255624404553', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.74.78.190', '2019-06-18 10:39:22', 9, 0, '', '2019-06-18 10:39:22');
INSERT INTO `access_log` VALUES (38091, '65.47.15608255932604585', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.74.78.190', '2019-06-18 10:39:53', 8, 0, '', '2019-06-18 10:39:53');
INSERT INTO `access_log` VALUES (38092, '65.3607.15608255932626357', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.74.78.190', '2019-06-18 10:39:53', 9, 2001001000, '服务端发生异常', '2019-06-18 10:39:53');
INSERT INTO `access_log` VALUES (38093, '65.49.15608255932824611', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.74.78.190', '2019-06-18 10:39:53', 8, 0, '', '2019-06-18 10:39:53');
INSERT INTO `access_log` VALUES (38094, '65.45.15608256048224599', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.74.78.190', '2019-06-18 10:40:05', 10, 0, '', '2019-06-18 10:40:05');
INSERT INTO `access_log` VALUES (38095, '65.50.15608256048254603', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.74.78.190', '2019-06-18 10:40:05', 10, 2001001000, '服务端发生异常', '2019-06-18 10:40:05');
INSERT INTO `access_log` VALUES (38096, '65.53.15608256048284591', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '124.74.78.190', '2019-06-18 10:40:05', 9, 0, '', '2019-06-18 10:40:05');
INSERT INTO `access_log` VALUES (38097, '59.73.15608258065013857', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:43:27', 14, 2001001000, '服务端发生异常', '2019-06-18 10:43:27');
INSERT INTO `access_log` VALUES (38098, '59.75.15608258064993859', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:43:27', 162, 0, '', '2019-06-18 10:43:27');
INSERT INTO `access_log` VALUES (38099, '65.54.15608258813144559', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-18 10:44:41', 3, 1002001012, '访问令牌已过期', '2019-06-18 10:44:41');
INSERT INTO `access_log` VALUES (38100, '65.45.15608258813134603', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-18 10:44:41', 4, 1002001012, '访问令牌已过期', '2019-06-18 10:44:41');
INSERT INTO `access_log` VALUES (38101, '65.52.15608258813144613', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-18 10:44:41', 3, 1002001012, '访问令牌已过期', '2019-06-18 10:44:41');
INSERT INTO `access_log` VALUES (38102, '65.46.15608258852774621', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-18 10:44:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 10:44:45');
INSERT INTO `access_log` VALUES (38103, '64.78.15608258934383807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.110.89.187', '2019-06-18 10:44:53', 12, 0, '', '2019-06-18 10:44:53');
INSERT INTO `access_log` VALUES (38104, '64.83.15608258935683795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.110.89.187', '2019-06-18 10:44:54', 3, 0, '', '2019-06-18 10:44:54');
INSERT INTO `access_log` VALUES (38105, '64.77.15608258950863813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.110.89.187', '2019-06-18 10:44:55', 1, 0, '', '2019-06-18 10:44:55');
INSERT INTO `access_log` VALUES (38106, '65.47.15608258952234591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-18 10:44:55', 89, 0, '', '2019-06-18 10:44:55');
INSERT INTO `access_log` VALUES (38107, '65.49.15608258956204617', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-18 10:44:56', 9, 0, '', '2019-06-18 10:44:56');
INSERT INTO `access_log` VALUES (38108, '65.51.15608258956224621', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-18 10:44:56', 11, 2001001000, '服务端发生异常', '2019-06-18 10:44:56');
INSERT INTO `access_log` VALUES (38109, '65.53.15608258956284597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '118.26.16.215', '2019-06-18 10:44:56', 9, 0, '', '2019-06-18 10:44:56');
INSERT INTO `access_log` VALUES (38110, '64.81.15608258957393809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.110.89.187', '2019-06-18 10:44:56', 2, 0, '', '2019-06-18 10:44:56');
INSERT INTO `access_log` VALUES (38111, '64.82.15608258968473815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.110.89.187', '2019-06-18 10:44:57', 2, 0, '', '2019-06-18 10:44:57');
INSERT INTO `access_log` VALUES (38112, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '36.110.89.187', '2019-06-18 10:44:57', 13, 0, '', '2019-06-18 10:44:57');
INSERT INTO `access_log` VALUES (38113, '65.52.15608259489054615', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:45:49', 4, 1002001012, '访问令牌已过期', '2019-06-18 10:45:49');
INSERT INTO `access_log` VALUES (38114, '65.46.15608259489054623', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:45:49', 4, 1002001012, '访问令牌已过期', '2019-06-18 10:45:49');
INSERT INTO `access_log` VALUES (38115, '65.3607.15608259489076365', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:45:49', 3, 1002001012, '访问令牌已过期', '2019-06-18 10:45:49');
INSERT INTO `access_log` VALUES (38116, '65.47.15608259533334593', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:45:53', 76, 0, '', '2019-06-18 10:45:53');
INSERT INTO `access_log` VALUES (38117, '65.49.15608259536174619', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:45:54', 18, 0, '', '2019-06-18 10:45:54');
INSERT INTO `access_log` VALUES (38118, '65.51.15608259536194623', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:45:54', 18, 2001001000, '服务端发生异常', '2019-06-18 10:45:54');
INSERT INTO `access_log` VALUES (38119, '65.53.15608259536214599', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:45:54', 17, 0, '', '2019-06-18 10:45:54');
INSERT INTO `access_log` VALUES (38120, '65.46.15608259667964625', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:46:07', 9, 0, '', '2019-06-18 10:46:07');
INSERT INTO `access_log` VALUES (38121, '65.45.15608259667954607', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:46:07', 9, 0, '', '2019-06-18 10:46:07');
INSERT INTO `access_log` VALUES (38122, '65.54.15608259667964563', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:46:07', 10, 2001001000, '服务端发生异常', '2019-06-18 10:46:07');
INSERT INTO `access_log` VALUES (38123, '65.3607.15608259804136367', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:46:20', 9, 0, '', '2019-06-18 10:46:20');
INSERT INTO `access_log` VALUES (38124, '65.47.15608259804154595', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:46:20', 10, 2001001000, '服务端发生异常', '2019-06-18 10:46:20');
INSERT INTO `access_log` VALUES (38125, '65.53.15608259804174601', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.89.187', '2019-06-18 10:46:20', 9, 0, '', '2019-06-18 10:46:20');
INSERT INTO `access_log` VALUES (38126, '59.78.15608261070903859', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-18 10:48:27', 3, 0, '', '2019-06-18 10:48:27');
INSERT INTO `access_log` VALUES (38127, '59.76.15608261070903855', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-18 10:48:27', 10, 2001001000, '服务端发生异常', '2019-06-18 10:48:27');
INSERT INTO `access_log` VALUES (38128, '65.47.15608261116724597', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-18 10:48:32', 3, 1002001012, '访问令牌已过期', '2019-06-18 10:48:32');
INSERT INTO `access_log` VALUES (38129, '65.51.15608261116824627', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-18 10:48:32', 2, 1002001012, '访问令牌已过期', '2019-06-18 10:48:32');
INSERT INTO `access_log` VALUES (38130, '65.49.15608261116834623', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-18 10:48:32', 2, 1002001012, '访问令牌已过期', '2019-06-18 10:48:32');
INSERT INTO `access_log` VALUES (38131, '65.45.15608261229084611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-18 10:48:43', 89, 0, '', '2019-06-18 10:48:43');
INSERT INTO `access_log` VALUES (38132, '65.54.15608261237684567', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-18 10:48:44', 9, 0, '', '2019-06-18 10:48:44');
INSERT INTO `access_log` VALUES (38133, '65.46.15608261237854629', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-18 10:48:44', 9, 2001001000, '服务端发生异常', '2019-06-18 10:48:44');
INSERT INTO `access_log` VALUES (38134, '65.52.15608261237934621', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.88.46.165', '2019-06-18 10:48:44', 9, 0, '', '2019-06-18 10:48:44');
INSERT INTO `access_log` VALUES (38135, '65.45.15608272453934627', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 11:07:25', 3, 1002001012, '访问令牌已过期', '2019-06-18 11:07:25');
INSERT INTO `access_log` VALUES (38136, '65.50.15608272453934631', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 11:07:25', 3, 1002001012, '访问令牌已过期', '2019-06-18 11:07:25');
INSERT INTO `access_log` VALUES (38137, '65.46.15608272454154645', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '60.208.18.134', '2019-06-18 11:07:25', 3, 1002001012, '访问令牌已过期', '2019-06-18 11:07:25');
INSERT INTO `access_log` VALUES (38138, '59.78.15608283052313889', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.28.133.34', '2019-06-18 11:25:05', 11, 0, '', '2019-06-18 11:25:05');
INSERT INTO `access_log` VALUES (38139, '59.75.15608283052313893', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.28.133.34', '2019-06-18 11:25:05', 21, 2001001000, '服务端发生异常', '2019-06-18 11:25:05');
INSERT INTO `access_log` VALUES (38140, '59.80.15608283206263879', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.28.133.34', '2019-06-18 11:25:21', 13, 2001001000, '服务端发生异常', '2019-06-18 11:25:21');
INSERT INTO `access_log` VALUES (38141, '59.77.15608283206233879', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.28.133.34', '2019-06-18 11:25:21', 30, 0, '', '2019-06-18 11:25:21');
INSERT INTO `access_log` VALUES (38142, '64.80.15608283279123843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.28.133.34', '2019-06-18 11:25:28', 10, 0, '', '2019-06-18 11:25:28');
INSERT INTO `access_log` VALUES (38143, '59.71.15608283279993889', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0.1; OPPO R9s Build/MMB29M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4388 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '117.28.133.34', '2019-06-18 11:25:28', 2, 0, '', '2019-06-18 11:25:28');
INSERT INTO `access_log` VALUES (38144, '59.74.15608283280033887', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0.1; OPPO R9s Build/MMB29M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4388 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '117.28.133.34', '2019-06-18 11:25:28', 13, 2001001000, '服务端发生异常', '2019-06-18 11:25:28');
INSERT INTO `access_log` VALUES (38145, '64.79.15608283280373837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.28.133.34', '2019-06-18 11:25:28', 3, 0, '', '2019-06-18 11:25:28');
INSERT INTO `access_log` VALUES (38146, '59.72.15608283302643889', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.28.133.34', '2019-06-18 11:25:30', 2, 0, '', '2019-06-18 11:25:30');
INSERT INTO `access_log` VALUES (38147, '59.79.15608283302653895', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.28.133.34', '2019-06-18 11:25:30', 9, 2001001000, '服务端发生异常', '2019-06-18 11:25:30');
INSERT INTO `access_log` VALUES (38148, '64.85.15608283337383853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0.1; OPPO R9s Build/MMB29M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4388 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '117.28.133.34', '2019-06-18 11:25:34', 2, 0, '', '2019-06-18 11:25:34');
INSERT INTO `access_log` VALUES (38149, '64.78.15608283338803841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0.1; OPPO R9s Build/MMB29M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4388 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '117.28.133.34', '2019-06-18 11:25:34', 2, 0, '', '2019-06-18 11:25:34');
INSERT INTO `access_log` VALUES (38150, '64.83.15608283353593829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0.1; OPPO R9s Build/MMB29M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4388 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '117.28.133.34', '2019-06-18 11:25:35', 2, 0, '', '2019-06-18 11:25:35');
INSERT INTO `access_log` VALUES (38151, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0.1; OPPO R9s Build/MMB29M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4388 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '117.28.133.34', '2019-06-18 11:25:35', 7, 0, '', '2019-06-18 11:25:35');
INSERT INTO `access_log` VALUES (38152, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0.1; OPPO R9s Build/MMB29M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4388 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '117.28.133.34', '2019-06-18 11:25:37', 8, 0, '', '2019-06-18 11:25:37');
INSERT INTO `access_log` VALUES (38153, '64.81.15608283379973843', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0.1; OPPO R9s Build/MMB29M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4388 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '117.28.133.34', '2019-06-18 11:25:38', 9, 0, '', '2019-06-18 11:25:38');
INSERT INTO `access_log` VALUES (38154, '65.3607.15608287978906407', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:33:18', 0, 1002001015, '账号未登陆', '2019-06-18 11:33:18');
INSERT INTO `access_log` VALUES (38155, '65.52.15608287978904657', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:33:18', 0, 1002001015, '账号未登陆', '2019-06-18 11:33:18');
INSERT INTO `access_log` VALUES (38156, '65.47.15608287979224635', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:33:18', 0, 1002001015, '账号未登陆', '2019-06-18 11:33:18');
INSERT INTO `access_log` VALUES (38157, '65.53.15608287995014643', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:33:20', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 11:33:20');
INSERT INTO `access_log` VALUES (38158, '65.49.15608288124384663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:33:32', 92, 0, '', '2019-06-18 11:33:33');
INSERT INTO `access_log` VALUES (38159, '65.50.15608288128734653', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:33:33', 9, 0, '', '2019-06-18 11:33:33');
INSERT INTO `access_log` VALUES (38160, '65.46.15608288128734669', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:33:33', 10, 2001001000, '服务端发生异常', '2019-06-18 11:33:33');
INSERT INTO `access_log` VALUES (38161, '65.51.15608288128614669', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:33:33', 21, 0, '', '2019-06-18 11:33:33');
INSERT INTO `access_log` VALUES (38162, '65.54.15608288183994607', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:33:38', 10, 0, '', '2019-06-18 11:33:38');
INSERT INTO `access_log` VALUES (38163, '65.3607.15608288184026409', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:33:38', 10, 2001001000, '服务端发生异常', '2019-06-18 11:33:38');
INSERT INTO `access_log` VALUES (38164, '65.52.15608288184054659', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:33:38', 9, 0, '', '2019-06-18 11:33:38');
INSERT INTO `access_log` VALUES (38165, '65.49.15608288491654665', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:34:09', 8, 0, '', '2019-06-18 11:34:09');
INSERT INTO `access_log` VALUES (38166, '65.46.15608288491714671', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:34:09', 9, 2001001000, '服务端发生异常', '2019-06-18 11:34:09');
INSERT INTO `access_log` VALUES (38167, '65.50.15608288491834655', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:34:09', 9, 0, '', '2019-06-18 11:34:09');
INSERT INTO `access_log` VALUES (38168, '65.51.15608288590254671', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:34:19', 9, 0, '', '2019-06-18 11:34:19');
INSERT INTO `access_log` VALUES (38169, '65.3607.15608288590266411', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:34:19', 9, 0, '', '2019-06-18 11:34:19');
INSERT INTO `access_log` VALUES (38170, '65.52.15608288590254661', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.72.248.38', '2019-06-18 11:34:19', 10, 2001001000, '服务端发生异常', '2019-06-18 11:34:19');
INSERT INTO `access_log` VALUES (38171, '65.51.15608299790384687', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.39', '2019-06-18 11:52:59', 3, 1002001012, '访问令牌已过期', '2019-06-18 11:52:59');
INSERT INTO `access_log` VALUES (38172, '65.50.15608299790374671', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.39', '2019-06-18 11:52:59', 4, 1002001012, '访问令牌已过期', '2019-06-18 11:52:59');
INSERT INTO `access_log` VALUES (38173, '65.46.15608299790374687', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.39', '2019-06-18 11:52:59', 9, 1002001012, '访问令牌已过期', '2019-06-18 11:52:59');
INSERT INTO `access_log` VALUES (38174, '65.52.15608299812104677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.39', '2019-06-18 11:53:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 11:53:01');
INSERT INTO `access_log` VALUES (38175, '65.53.15608300238214663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.39', '2019-06-18 11:53:44', 99, 0, '', '2019-06-18 11:53:44');
INSERT INTO `access_log` VALUES (38176, '65.49.15608300241934683', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.39', '2019-06-18 11:53:44', 7, 0, '', '2019-06-18 11:53:44');
INSERT INTO `access_log` VALUES (38177, '65.45.15608300241934667', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.39', '2019-06-18 11:53:44', 11, 2001001000, '服务端发生异常', '2019-06-18 11:53:44');
INSERT INTO `access_log` VALUES (38178, '65.46.15608300241984689', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.37.140.39', '2019-06-18 11:53:44', 8, 0, '', '2019-06-18 11:53:44');
INSERT INTO `access_log` VALUES (38179, '65.46.15608348034184753', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:13:23', 0, 1002001015, '账号未登陆', '2019-06-18 13:13:23');
INSERT INTO `access_log` VALUES (38180, '65.45.15608348034214731', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:13:23', 1, 1002001015, '账号未登陆', '2019-06-18 13:13:23');
INSERT INTO `access_log` VALUES (38181, '65.51.15608348034384753', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:13:23', 0, 1002001015, '账号未登陆', '2019-06-18 13:13:23');
INSERT INTO `access_log` VALUES (38182, '65.52.15608348049234743', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:13:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 13:13:25');
INSERT INTO `access_log` VALUES (38183, '65.3607.15608348091826493', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:13:29', 279, 0, '', '2019-06-18 13:13:29');
INSERT INTO `access_log` VALUES (38184, '65.54.15608348096464691', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:13:30', 32, 0, '', '2019-06-18 13:13:30');
INSERT INTO `access_log` VALUES (38185, '65.47.15608348096494721', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:13:30', 33, 2001001000, '服务端发生异常', '2019-06-18 13:13:30');
INSERT INTO `access_log` VALUES (38186, '65.53.15608348096494729', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:13:30', 32, 0, '', '2019-06-18 13:13:30');
INSERT INTO `access_log` VALUES (38187, '65.49.15608348154784749', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:13:35', 11, 0, '', '2019-06-18 13:13:35');
INSERT INTO `access_log` VALUES (38188, '65.45.15608348154824733', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:13:35', 8, 0, '', '2019-06-18 13:13:35');
INSERT INTO `access_log` VALUES (38189, '65.46.15608348154824755', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:13:35', 10, 2001001000, '服务端发生异常', '2019-06-18 13:13:35');
INSERT INTO `access_log` VALUES (38190, '65.50.15608348247644739', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:13:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 13:13:45');
INSERT INTO `access_log` VALUES (38191, '65.52.15608348323594745', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:13:52', 4, 1002002001, '密码不正确', '2019-06-18 13:13:52');
INSERT INTO `access_log` VALUES (38192, '65.54.15608348751564693', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:14:35', 73, 0, '', '2019-06-18 13:14:35');
INSERT INTO `access_log` VALUES (38193, '65.46.15608348754674757', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:14:35', 7, 0, '', '2019-06-18 13:14:35');
INSERT INTO `access_log` VALUES (38194, '65.49.15608348754684751', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:14:35', 9, 2001001000, '服务端发生异常', '2019-06-18 13:14:35');
INSERT INTO `access_log` VALUES (38195, '65.45.15608348754704735', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:14:35', 7, 0, '', '2019-06-18 13:14:35');
INSERT INTO `access_log` VALUES (38196, '65.50.15608348917424741', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:14:52', 116, 0, '', '2019-06-18 13:14:52');
INSERT INTO `access_log` VALUES (38197, '65.3607.15608348917486497', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:14:52', 112, 0, '', '2019-06-18 13:14:52');
INSERT INTO `access_log` VALUES (38198, '65.52.15608348917444747', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:14:52', 115, 2001001000, '服务端发生异常', '2019-06-18 13:14:52');
INSERT INTO `access_log` VALUES (38199, '65.49.15608349427714753', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:15:43', 8, 0, '', '2019-06-18 13:15:43');
INSERT INTO `access_log` VALUES (38200, '65.45.15608349427724737', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:15:43', 9, 2001001000, '服务端发生异常', '2019-06-18 13:15:43');
INSERT INTO `access_log` VALUES (38201, '65.51.15608349427754759', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:15:43', 8, 0, '', '2019-06-18 13:15:43');
INSERT INTO `access_log` VALUES (38202, '65.52.15608349633644749', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:16:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 13:16:03');
INSERT INTO `access_log` VALUES (38203, '65.3607.15608349675846499', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:16:08', 5, 1002002001, '密码不正确', '2019-06-18 13:16:08');
INSERT INTO `access_log` VALUES (38204, '65.47.15608349710964727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:16:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 13:16:11');
INSERT INTO `access_log` VALUES (38205, '65.54.15608349784274697', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:16:18', 79, 0, '', '2019-06-18 13:16:19');
INSERT INTO `access_log` VALUES (38206, '65.46.15608349786534761', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:16:19', 9, 0, '', '2019-06-18 13:16:19');
INSERT INTO `access_log` VALUES (38207, '65.49.15608349786554755', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:16:19', 9, 0, '', '2019-06-18 13:16:19');
INSERT INTO `access_log` VALUES (38208, '65.51.15608349786584761', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:16:19', 8, 0, '', '2019-06-18 13:16:19');
INSERT INTO `access_log` VALUES (38209, '64.78.15608349861723931', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:16:26', 30, 0, '', '2019-06-18 13:16:26');
INSERT INTO `access_log` VALUES (38210, '64.81.15608349861703931', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:16:26', 40, 0, '', '2019-06-18 13:16:26');
INSERT INTO `access_log` VALUES (38211, '64.80.15608350502433935', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:17:30', 9, 0, '', '2019-06-18 13:17:30');
INSERT INTO `access_log` VALUES (38212, '64.83.15608350502413919', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:17:30', 17, 0, '', '2019-06-18 13:17:30');
INSERT INTO `access_log` VALUES (38213, '64.77.15608350560193939', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:17:36', 10, 0, '', '2019-06-18 13:17:36');
INSERT INTO `access_log` VALUES (38214, '64.78.15608350571373933', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:17:37', 10, 0, '', '2019-06-18 13:17:37');
INSERT INTO `access_log` VALUES (38215, '64.81.15608350582963933', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:17:38', 10, 0, '', '2019-06-18 13:17:38');
INSERT INTO `access_log` VALUES (38216, '64.76.15608350590833923', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:17:39', 12, 0, '', '2019-06-18 13:17:39');
INSERT INTO `access_log` VALUES (38217, '64.79.15608350616973931', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:17:42', 13, 0, '', '2019-06-18 13:17:42');
INSERT INTO `access_log` VALUES (38218, '64.84.15608350616963933', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:17:42', 17, 0, '', '2019-06-18 13:17:42');
INSERT INTO `access_log` VALUES (38219, '64.85.15608350617093947', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:17:42', 9, 0, '', '2019-06-18 13:17:42');
INSERT INTO `access_log` VALUES (38220, '64.82.15608350922623943', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:18:12', 9, 0, '', '2019-06-18 13:18:12');
INSERT INTO `access_log` VALUES (38221, '65.45.15608351205904741', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:18:41', 24, 0, '', '2019-06-18 13:18:41');
INSERT INTO `access_log` VALUES (38222, '65.50.15608351269404747', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:18:47', 25, 0, '', '2019-06-18 13:18:47');
INSERT INTO `access_log` VALUES (38223, '65.52.15608351288504753', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:18:49', 9, 0, '', '2019-06-18 13:18:49');
INSERT INTO `access_log` VALUES (38224, '65.53.15608351363954739', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:18:56', 12, 0, '', '2019-06-18 13:18:56');
INSERT INTO `access_log` VALUES (38225, '59.80.15608351425683971', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:19:03', 18, 0, '', '2019-06-18 13:19:03');
INSERT INTO `access_log` VALUES (38226, '59.71.15608351666793981', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:19:27', 21, 2001001000, '服务端发生异常', '2019-06-18 13:19:27');
INSERT INTO `access_log` VALUES (38227, '59.79.15608351717373987', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:19:32', 23, 0, '', '2019-06-18 13:19:32');
INSERT INTO `access_log` VALUES (38228, '59.72.15608351739893981', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:19:34', 14, 0, '', '2019-06-18 13:19:34');
INSERT INTO `access_log` VALUES (38229, '59.75.15608351760813987', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:19:36', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-18 13:19:36');
INSERT INTO `access_log` VALUES (38230, '64.85.15608351853023949', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:19:45', 10, 0, '', '2019-06-18 13:19:45');
INSERT INTO `access_log` VALUES (38231, '62.84.15608351897103663', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:19:50', 30, 0, '', '2019-06-18 13:19:50');
INSERT INTO `access_log` VALUES (38232, '64.82.15608351956273945', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:19:56', 9, 0, '', '2019-06-18 13:19:56');
INSERT INTO `access_log` VALUES (38233, '64.83.15608351956253923', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:19:56', 13, 0, '', '2019-06-18 13:19:56');
INSERT INTO `access_log` VALUES (38234, '65.50.15608352373904749', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:20:37', 4, 0, '', '2019-06-18 13:20:37');
INSERT INTO `access_log` VALUES (38235, '65.53.15608352563504741', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:20:56', 3, 0, '', '2019-06-18 13:20:56');
INSERT INTO `access_log` VALUES (38236, '59.78.15608356177293989', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:26:58', 3, 0, '', '2019-06-18 13:26:58');
INSERT INTO `access_log` VALUES (38237, '59.75.15608356177293993', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:26:58', 10, 2001001000, '服务端发生异常', '2019-06-18 13:26:58');
INSERT INTO `access_log` VALUES (38238, '64.83.15608356206443929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:01', 2, 0, '', '2019-06-18 13:27:01');
INSERT INTO `access_log` VALUES (38239, '64.82.15608356207283951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:01', 2, 0, '', '2019-06-18 13:27:01');
INSERT INTO `access_log` VALUES (38240, '59.76.15608356238083985', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:04', 3, 0, '', '2019-06-18 13:27:04');
INSERT INTO `access_log` VALUES (38241, '59.80.15608356238093979', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:04', 14, 2001001000, '服务端发生异常', '2019-06-18 13:27:04');
INSERT INTO `access_log` VALUES (38242, '64.78.15608356257393943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:06', 2, 0, '', '2019-06-18 13:27:06');
INSERT INTO `access_log` VALUES (38243, '64.81.15608356258173943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:06', 2, 0, '', '2019-06-18 13:27:06');
INSERT INTO `access_log` VALUES (38244, '59.74.15608356272273987', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:07', 3, 0, '', '2019-06-18 13:27:07');
INSERT INTO `access_log` VALUES (38245, '59.71.15608356272273989', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:07', 13, 2001001000, '服务端发生异常', '2019-06-18 13:27:07');
INSERT INTO `access_log` VALUES (38246, '65.45.15608356310134749', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:11', 12, 0, '', '2019-06-18 13:27:11');
INSERT INTO `access_log` VALUES (38247, '65.50.15608356310164755', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:11', 10, 0, '', '2019-06-18 13:27:11');
INSERT INTO `access_log` VALUES (38248, '65.52.15608356310214761', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:11', 8, 0, '', '2019-06-18 13:27:11');
INSERT INTO `access_log` VALUES (38249, '64.79.15608356349063941', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:15', 8, 0, '', '2019-06-18 13:27:15');
INSERT INTO `access_log` VALUES (38250, '64.76.15608356349043933', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:15', 11, 0, '', '2019-06-18 13:27:15');
INSERT INTO `access_log` VALUES (38251, '64.85.15608356371023957', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:17', 10, 0, '', '2019-06-18 13:27:17');
INSERT INTO `access_log` VALUES (38252, '64.84.15608356371013943', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:17', 12, 0, '', '2019-06-18 13:27:17');
INSERT INTO `access_log` VALUES (38253, '64.82.15608356446153953', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:25', 9, 0, '', '2019-06-18 13:27:25');
INSERT INTO `access_log` VALUES (38254, '64.83.15608356446133931', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:25', 13, 0, '', '2019-06-18 13:27:25');
INSERT INTO `access_log` VALUES (38255, '64.81.15608356483433945', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:28', 9, 0, '', '2019-06-18 13:27:28');
INSERT INTO `access_log` VALUES (38256, '64.78.15608356483423945', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:28', 13, 0, '', '2019-06-18 13:27:28');
INSERT INTO `access_log` VALUES (38257, '64.77.15608356483423951', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:28', 14, 0, '', '2019-06-18 13:27:28');
INSERT INTO `access_log` VALUES (38258, '64.76.15608356595373935', 1, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:40', 229, 2001001000, '服务端发生异常', '2019-06-18 13:27:40');
INSERT INTO `access_log` VALUES (38259, '59.77.15608370928103999', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.114.250.241', '2019-06-18 13:51:33', 3, 0, '', '2019-06-18 13:51:33');
INSERT INTO `access_log` VALUES (38260, '59.74.15608370928164007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.114.250.241', '2019-06-18 13:51:33', 12, 2001001000, '服务端发生异常', '2019-06-18 13:51:33');
INSERT INTO `access_log` VALUES (38261, '65.53.15608372947984769', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '122.225.128.131', '2019-06-18 13:54:55', 1, 1002001015, '账号未登陆', '2019-06-18 13:54:55');
INSERT INTO `access_log` VALUES (38262, '65.47.15608372947984761', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '122.225.128.131', '2019-06-18 13:54:55', 0, 1002001015, '账号未登陆', '2019-06-18 13:54:55');
INSERT INTO `access_log` VALUES (38263, '65.54.15608372948234731', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '122.225.128.131', '2019-06-18 13:54:55', 0, 1002001015, '账号未登陆', '2019-06-18 13:54:55');
INSERT INTO `access_log` VALUES (38264, '65.46.15608372969634795', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '122.225.128.131', '2019-06-18 13:54:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 13:54:57');
INSERT INTO `access_log` VALUES (38265, '65.49.15608373015824789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '122.225.128.131', '2019-06-18 13:55:02', 84, 0, '', '2019-06-18 13:55:02');
INSERT INTO `access_log` VALUES (38266, '65.51.15608373018944795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '122.225.128.131', '2019-06-18 13:55:02', 9, 0, '', '2019-06-18 13:55:02');
INSERT INTO `access_log` VALUES (38267, '65.50.15608373018974779', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '122.225.128.131', '2019-06-18 13:55:02', 9, 2001001000, '服务端发生异常', '2019-06-18 13:55:02');
INSERT INTO `access_log` VALUES (38268, '65.45.15608373019004773', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '122.225.128.131', '2019-06-18 13:55:02', 9, 0, '', '2019-06-18 13:55:02');
INSERT INTO `access_log` VALUES (38269, '59.76.15608379219144017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.106.164.17', '2019-06-18 14:05:22', 4, 0, '', '2019-06-18 14:05:22');
INSERT INTO `access_log` VALUES (38270, '59.80.15608379219144011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.106.164.17', '2019-06-18 14:05:22', 13, 2001001000, '服务端发生异常', '2019-06-18 14:05:22');
INSERT INTO `access_log` VALUES (38271, '65.54.15608379312804741', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.106.164.17', '2019-06-18 14:05:31', 0, 1002001015, '账号未登陆', '2019-06-18 14:05:31');
INSERT INTO `access_log` VALUES (38272, '65.53.15608379312914779', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.106.164.17', '2019-06-18 14:05:31', 0, 1002001015, '账号未登陆', '2019-06-18 14:05:31');
INSERT INTO `access_log` VALUES (38273, '65.47.15608379313014771', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.106.164.17', '2019-06-18 14:05:31', 1, 1002001015, '账号未登陆', '2019-06-18 14:05:31');
INSERT INTO `access_log` VALUES (38274, '65.46.15608379333334805', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:05:33', 1, 1002001015, '账号未登陆', '2019-06-18 14:05:33');
INSERT INTO `access_log` VALUES (38275, '65.49.15608379333334799', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:05:33', 0, 1002001015, '账号未登陆', '2019-06-18 14:05:33');
INSERT INTO `access_log` VALUES (38276, '65.50.15608379333404789', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:05:33', 0, 1002001015, '账号未登陆', '2019-06-18 14:05:33');
INSERT INTO `access_log` VALUES (38277, '65.45.15608379405914783', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.106.164.17', '2019-06-18 14:05:41', 83, 0, '', '2019-06-18 14:05:41');
INSERT INTO `access_log` VALUES (38278, '65.52.15608379409454795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.106.164.17', '2019-06-18 14:05:41', 9, 0, '', '2019-06-18 14:05:41');
INSERT INTO `access_log` VALUES (38279, '65.3607.15608379409496545', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.106.164.17', '2019-06-18 14:05:41', 9, 2001001000, '服务端发生异常', '2019-06-18 14:05:41');
INSERT INTO `access_log` VALUES (38280, '65.54.15608379409554743', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.106.164.17', '2019-06-18 14:05:41', 9, 0, '', '2019-06-18 14:05:41');
INSERT INTO `access_log` VALUES (38281, '65.53.15608379432244781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:05:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 14:05:43');
INSERT INTO `access_log` VALUES (38282, '65.47.15608379492444773', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:05:49', 82, 0, '', '2019-06-18 14:05:49');
INSERT INTO `access_log` VALUES (38283, '65.49.15608379495584801', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:05:50', 10, 0, '', '2019-06-18 14:05:50');
INSERT INTO `access_log` VALUES (38284, '65.46.15608379495644807', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:05:50', 10, 2001001000, '服务端发生异常', '2019-06-18 14:05:50');
INSERT INTO `access_log` VALUES (38285, '65.50.15608379495664791', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:05:50', 9, 0, '', '2019-06-18 14:05:50');
INSERT INTO `access_log` VALUES (38286, '65.52.15608379932664797', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.151.178.175', '2019-06-18 14:06:33', 1, 1002001015, '账号未登陆', '2019-06-18 14:06:33');
INSERT INTO `access_log` VALUES (38287, '65.53.15608379999254783', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.89.29.94', '2019-06-18 14:06:40', 0, 1002001015, '账号未登陆', '2019-06-18 14:06:40');
INSERT INTO `access_log` VALUES (38288, '65.46.15608380029914809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:06:43', 9, 0, '', '2019-06-18 14:06:43');
INSERT INTO `access_log` VALUES (38289, '65.49.15608380029894803', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:06:43', 138, 2001001000, '服务端发生异常', '2019-06-18 14:06:43');
INSERT INTO `access_log` VALUES (38290, '65.47.15608380029864775', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:06:43', 141, 0, '', '2019-06-18 14:06:43');
INSERT INTO `access_log` VALUES (38291, '65.51.15608380207354809', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:07:01', 9, 0, '', '2019-06-18 14:07:01');
INSERT INTO `access_log` VALUES (38292, '65.45.15608380207384787', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:07:01', 10, 2001001000, '服务端发生异常', '2019-06-18 14:07:01');
INSERT INTO `access_log` VALUES (38293, '65.54.15608380207414747', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:07:01', 8, 0, '', '2019-06-18 14:07:01');
INSERT INTO `access_log` VALUES (38294, '65.52.15608380224224799', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:07:02', 9, 0, '', '2019-06-18 14:07:02');
INSERT INTO `access_log` VALUES (38295, '65.3607.15608380224246549', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:07:02', 10, 2001001000, '服务端发生异常', '2019-06-18 14:07:02');
INSERT INTO `access_log` VALUES (38296, '65.53.15608380224264785', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:07:02', 9, 0, '', '2019-06-18 14:07:02');
INSERT INTO `access_log` VALUES (38297, '65.47.15608380290294777', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:07:09', 4, 1002002000, '账号不存在', '2019-06-18 14:07:09');
INSERT INTO `access_log` VALUES (38298, '65.49.15608380332064805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:07:13', 63, 0, '', '2019-06-18 14:07:13');
INSERT INTO `access_log` VALUES (38299, '65.50.15608380334394795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:07:13', 16, 0, '', '2019-06-18 14:07:13');
INSERT INTO `access_log` VALUES (38300, '65.54.15608380334404749', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:07:13', 17, 2001001000, '服务端发生异常', '2019-06-18 14:07:13');
INSERT INTO `access_log` VALUES (38301, '65.51.15608380334434811', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '115.171.198.150', '2019-06-18 14:07:13', 16, 0, '', '2019-06-18 14:07:13');
INSERT INTO `access_log` VALUES (38302, '59.72.15608385907844029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '103.208.15.203', '2019-06-18 14:16:31', 4, 0, '', '2019-06-18 14:16:31');
INSERT INTO `access_log` VALUES (38303, '59.73.15608385907844033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '103.208.15.203', '2019-06-18 14:16:31', 14, 2001001000, '服务端发生异常', '2019-06-18 14:16:31');
INSERT INTO `access_log` VALUES (38304, '59.78.15608386033254031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:16:43', 2, 0, '', '2019-06-18 14:16:43');
INSERT INTO `access_log` VALUES (38305, '59.76.15608386033254027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:16:43', 13, 2001001000, '服务端发生异常', '2019-06-18 14:16:43');
INSERT INTO `access_log` VALUES (38306, '64.85.15608386649323999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:17:45', 12, 0, '', '2019-06-18 14:17:45');
INSERT INTO `access_log` VALUES (38307, '64.84.15608386663833985', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:17:46', 4, 0, '', '2019-06-18 14:17:46');
INSERT INTO `access_log` VALUES (38308, '64.82.15608386716673995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:17:52', 2, 0, '', '2019-06-18 14:17:52');
INSERT INTO `access_log` VALUES (38309, '64.83.15608386739523973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:17:54', 2, 0, '', '2019-06-18 14:17:54');
INSERT INTO `access_log` VALUES (38310, '59.73.15608386862604035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:18:06', 3, 0, '', '2019-06-18 14:18:06');
INSERT INTO `access_log` VALUES (38311, '59.75.15608386866764037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:18:07', 13, 2001001000, '服务端发生异常', '2019-06-18 14:18:07');
INSERT INTO `access_log` VALUES (38312, '64.78.15608386948873987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:18:15', 2, 0, '', '2019-06-18 14:18:15');
INSERT INTO `access_log` VALUES (38313, '64.77.15608386950423993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:18:15', 2, 0, '', '2019-06-18 14:18:15');
INSERT INTO `access_log` VALUES (38314, '59.80.15608387279754023', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:18:48', 2, 0, '', '2019-06-18 14:18:48');
INSERT INTO `access_log` VALUES (38315, '59.77.15608387280184023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:18:48', 10, 2001001000, '服务端发生异常', '2019-06-18 14:18:48');
INSERT INTO `access_log` VALUES (38316, '64.84.15608387314963987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:18:51', 2, 0, '', '2019-06-18 14:18:52');
INSERT INTO `access_log` VALUES (38317, '64.80.15608387316293991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:18:52', 2, 0, '', '2019-06-18 14:18:52');
INSERT INTO `access_log` VALUES (38318, '64.82.15608387406913997', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:19:01', 2, 0, '', '2019-06-18 14:19:01');
INSERT INTO `access_log` VALUES (38319, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:19:01', 6, 0, '', '2019-06-18 14:19:01');
INSERT INTO `access_log` VALUES (38320, '64.85.15608388320144003', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:20:32', 8, 0, '', '2019-06-18 14:20:32');
INSERT INTO `access_log` VALUES (38321, '64.84.15608388350403989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:20:35', 2, 0, '', '2019-06-18 14:20:35');
INSERT INTO `access_log` VALUES (38322, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:20:35', 6, 0, '', '2019-06-18 14:20:35');
INSERT INTO `access_log` VALUES (38323, '64.82.15608388366483999', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:20:37', 6, 0, '', '2019-06-18 14:20:37');
INSERT INTO `access_log` VALUES (38324, '64.83.15608388412743977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:20:41', 2, 0, '', '2019-06-18 14:20:41');
INSERT INTO `access_log` VALUES (38325, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:20:41', 7, 0, '', '2019-06-18 14:20:41');
INSERT INTO `access_log` VALUES (38326, '64.81.15608388487873991', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:20:49', 6, 0, '', '2019-06-18 14:20:49');
INSERT INTO `access_log` VALUES (38327, '64.79.15608388657253989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:21:06', 2, 0, '', '2019-06-18 14:21:06');
INSERT INTO `access_log` VALUES (38328, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:49.0) Gecko/20100101 Firefox/49.0', '103.208.15.203', '2019-06-18 14:21:06', 6, 0, '', '2019-06-18 14:21:06');
INSERT INTO `access_log` VALUES (38329, '59.75.15608389483504041', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '118.114.253.212', '2019-06-18 14:22:28', 3, 0, '', '2019-06-18 14:22:28');
INSERT INTO `access_log` VALUES (38330, '59.78.15608389483504037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '118.114.253.212', '2019-06-18 14:22:28', 13, 2001001000, '服务端发生异常', '2019-06-18 14:22:28');
INSERT INTO `access_log` VALUES (38331, '64.83.15608389527353979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '118.114.253.212', '2019-06-18 14:22:33', 3, 0, '', '2019-06-18 14:22:33');
INSERT INTO `access_log` VALUES (38332, '64.81.15608389533643993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '118.114.253.212', '2019-06-18 14:22:33', 2, 0, '', '2019-06-18 14:22:33');
INSERT INTO `access_log` VALUES (38333, '64.78.15608389543073993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '118.114.253.212', '2019-06-18 14:22:34', 2, 0, '', '2019-06-18 14:22:34');
INSERT INTO `access_log` VALUES (38334, '64.77.15608389547163999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '118.114.253.212', '2019-06-18 14:22:35', 2, 0, '', '2019-06-18 14:22:35');
INSERT INTO `access_log` VALUES (38335, '64.76.15608389580083983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '118.114.253.212', '2019-06-18 14:22:38', 2, 0, '', '2019-06-18 14:22:38');
INSERT INTO `access_log` VALUES (38336, '64.85.15608389581304007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '118.114.253.212', '2019-06-18 14:22:38', 2, 0, '', '2019-06-18 14:22:38');
INSERT INTO `access_log` VALUES (38337, '65.51.15608393566244829', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.71.168.226', '2019-06-18 14:29:17', 1, 1002001015, '账号未登陆', '2019-06-18 14:29:17');
INSERT INTO `access_log` VALUES (38338, '65.50.15608393566234813', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.71.168.226', '2019-06-18 14:29:17', 0, 1002001015, '账号未登陆', '2019-06-18 14:29:17');
INSERT INTO `access_log` VALUES (38339, '65.45.15608393566264807', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.71.168.226', '2019-06-18 14:29:17', 0, 1002001015, '账号未登陆', '2019-06-18 14:29:17');
INSERT INTO `access_log` VALUES (38340, '65.3607.15608393624846569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.71.168.226', '2019-06-18 14:29:22', 66, 0, '', '2019-06-18 14:29:23');
INSERT INTO `access_log` VALUES (38341, '65.53.15608393664404805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.71.168.226', '2019-06-18 14:29:26', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 14:29:26');
INSERT INTO `access_log` VALUES (38342, '65.46.15608393729994831', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.71.168.226', '2019-06-18 14:29:33', 88, 0, '', '2019-06-18 14:29:33');
INSERT INTO `access_log` VALUES (38343, '65.52.15608394761284821', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '121.237.61.3', '2019-06-18 14:31:16', 1, 1002001015, '账号未登陆', '2019-06-18 14:31:16');
INSERT INTO `access_log` VALUES (38344, '65.53.15608394761294807', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '121.237.61.3', '2019-06-18 14:31:16', 0, 1002001015, '账号未登陆', '2019-06-18 14:31:16');
INSERT INTO `access_log` VALUES (38345, '65.46.15608394761344833', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '121.237.61.3', '2019-06-18 14:31:16', 0, 1002001015, '账号未登陆', '2019-06-18 14:31:16');
INSERT INTO `access_log` VALUES (38346, '65.49.15608394884124827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '121.237.61.3', '2019-06-18 14:31:28', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 14:31:28');
INSERT INTO `access_log` VALUES (38347, '65.50.15608395005224817', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '121.237.61.3', '2019-06-18 14:31:41', 95, 0, '', '2019-06-18 14:31:41');
INSERT INTO `access_log` VALUES (38348, '65.45.15608395011684811', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '121.237.61.3', '2019-06-18 14:31:41', 9, 0, '', '2019-06-18 14:31:41');
INSERT INTO `access_log` VALUES (38349, '65.3607.15608395011696573', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '121.237.61.3', '2019-06-18 14:31:41', 10, 0, '', '2019-06-18 14:31:41');
INSERT INTO `access_log` VALUES (38350, '65.51.15608395011684833', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '121.237.61.3', '2019-06-18 14:31:41', 11, 2001001000, '服务端发生异常', '2019-06-18 14:31:41');
INSERT INTO `access_log` VALUES (38351, '59.78.15608411861144067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.234.61.189', '2019-06-18 14:59:46', 16, 0, '', '2019-06-18 14:59:46');
INSERT INTO `access_log` VALUES (38352, '59.76.15608411861144063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.234.61.189', '2019-06-18 14:59:46', 15, 2001001000, '服务端发生异常', '2019-06-18 14:59:46');
INSERT INTO `access_log` VALUES (38353, '65.49.15608412046794851', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.116.112.228', '2019-06-18 15:00:05', 1, 1002001015, '账号未登陆', '2019-06-18 15:00:05');
INSERT INTO `access_log` VALUES (38354, '65.47.15608412046794823', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.116.112.228', '2019-06-18 15:00:05', 1, 1002001015, '账号未登陆', '2019-06-18 15:00:05');
INSERT INTO `access_log` VALUES (38355, '65.54.15608412046844795', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.116.112.228', '2019-06-18 15:00:05', 0, 1002001015, '账号未登陆', '2019-06-18 15:00:05');
INSERT INTO `access_log` VALUES (38356, '59.74.15608412173584065', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.181.13.177', '2019-06-18 15:00:17', 3, 0, '', '2019-06-18 15:00:17');
INSERT INTO `access_log` VALUES (38357, '59.71.15608412173614067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '60.181.13.177', '2019-06-18 15:00:17', 10, 2001001000, '服务端发生异常', '2019-06-18 15:00:17');
INSERT INTO `access_log` VALUES (38358, '59.76.15608418894894073', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:11:29', 3, 0, '', '2019-06-18 15:11:29');
INSERT INTO `access_log` VALUES (38359, '59.80.15608418894944067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:11:29', 10, 2001001000, '服务端发生异常', '2019-06-18 15:11:30');
INSERT INTO `access_log` VALUES (38360, '64.78.15608418921404033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:11:32', 9, 0, '', '2019-06-18 15:11:32');
INSERT INTO `access_log` VALUES (38361, '64.77.15608418922564039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:11:32', 2, 0, '', '2019-06-18 15:11:32');
INSERT INTO `access_log` VALUES (38362, '64.79.15608418935584031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:11:34', 2, 0, '', '2019-06-18 15:11:34');
INSERT INTO `access_log` VALUES (38363, '64.76.15608418940784023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:11:34', 2, 0, '', '2019-06-18 15:11:34');
INSERT INTO `access_log` VALUES (38364, '64.85.15608418945384047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:11:35', 2, 0, '', '2019-06-18 15:11:35');
INSERT INTO `access_log` VALUES (38365, '59.74.15608419002244075', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:11:40', 2, 0, '', '2019-06-18 15:11:40');
INSERT INTO `access_log` VALUES (38366, '59.71.15608419002244077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:11:40', 14, 2001001000, '服务端发生异常', '2019-06-18 15:11:40');
INSERT INTO `access_log` VALUES (38367, '65.46.15608419089834867', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:11:49', 0, 1002001015, '账号未登陆', '2019-06-18 15:11:49');
INSERT INTO `access_log` VALUES (38368, '65.54.15608419089854807', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:11:49', 1, 1002001015, '账号未登陆', '2019-06-18 15:11:49');
INSERT INTO `access_log` VALUES (38369, '65.47.15608419089904833', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:11:49', 0, 1002001015, '账号未登陆', '2019-06-18 15:11:49');
INSERT INTO `access_log` VALUES (38370, '65.49.15608419109074861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:11:51', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 15:11:51');
INSERT INTO `access_log` VALUES (38371, '65.3607.15608419143066607', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:11:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 15:11:54');
INSERT INTO `access_log` VALUES (38372, '65.51.15608419323574869', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:12:12', 62, 0, '', '2019-06-18 15:12:12');
INSERT INTO `access_log` VALUES (38373, '65.53.15608419326414845', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:12:13', 9, 0, '', '2019-06-18 15:12:13');
INSERT INTO `access_log` VALUES (38374, '65.52.15608419326464859', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:12:13', 9, 2001001000, '服务端发生异常', '2019-06-18 15:12:13');
INSERT INTO `access_log` VALUES (38375, '65.54.15608419326554809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:12:13', 8, 0, '', '2019-06-18 15:12:13');
INSERT INTO `access_log` VALUES (38376, '65.46.15608419565354869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:12:37', 9, 0, '', '2019-06-18 15:12:37');
INSERT INTO `access_log` VALUES (38377, '65.49.15608419565404863', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:12:37', 10, 2001001000, '服务端发生异常', '2019-06-18 15:12:37');
INSERT INTO `access_log` VALUES (38378, '65.50.15608419565564851', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '122.227.169.98', '2019-06-18 15:12:37', 9, 0, '', '2019-06-18 15:12:37');
INSERT INTO `access_log` VALUES (38379, '59.74.15608424737364083', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:14', 3, 0, '', '2019-06-18 15:21:14');
INSERT INTO `access_log` VALUES (38380, '59.71.15608424737384085', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:14', 12, 2001001000, '服务端发生异常', '2019-06-18 15:21:14');
INSERT INTO `access_log` VALUES (38381, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=iphone&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:24', 7, 0, '', '2019-06-18 15:21:24');
INSERT INTO `access_log` VALUES (38382, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=iphone', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:24', 7, 0, '', '2019-06-18 15:21:24');
INSERT INTO `access_log` VALUES (38383, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=手机&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:34', 7, 0, '', '2019-06-18 15:21:34');
INSERT INTO `access_log` VALUES (38384, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=手机', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:35', 13, 0, '', '2019-06-18 15:21:35');
INSERT INTO `access_log` VALUES (38385, '64.80.15608424971724045', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:37', 7, 0, '', '2019-06-18 15:21:37');
INSERT INTO `access_log` VALUES (38386, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:45', 7, 0, '', '2019-06-18 15:21:45');
INSERT INTO `access_log` VALUES (38387, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:45', 4, 0, '', '2019-06-18 15:21:45');
INSERT INTO `access_log` VALUES (38388, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:45', 9, 0, '', '2019-06-18 15:21:45');
INSERT INTO `access_log` VALUES (38389, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:46', 8, 0, '', '2019-06-18 15:21:46');
INSERT INTO `access_log` VALUES (38390, '59.75.15608425058134091', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:46', 13, 2001001000, '服务端发生异常', '2019-06-18 15:21:46');
INSERT INTO `access_log` VALUES (38391, '59.73.15608425057644089', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:46', 86, 0, '', '2019-06-18 15:21:46');
INSERT INTO `access_log` VALUES (38392, '64.82.15608425104204051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:50', 2, 0, '', '2019-06-18 15:21:50');
INSERT INTO `access_log` VALUES (38393, '64.81.15608425105754043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:51', 2, 0, '', '2019-06-18 15:21:51');
INSERT INTO `access_log` VALUES (38394, '64.78.15608425122224043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:52', 2, 0, '', '2019-06-18 15:21:52');
INSERT INTO `access_log` VALUES (38395, '64.77.15608425130204049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:21:53', 2, 0, '', '2019-06-18 15:21:53');
INSERT INTO `access_log` VALUES (38396, '64.79.15608425210434041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:22:01', 2, 0, '', '2019-06-18 15:22:01');
INSERT INTO `access_log` VALUES (38397, '64.76.15608425211834033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:22:01', 2, 0, '', '2019-06-18 15:22:01');
INSERT INTO `access_log` VALUES (38398, '59.76.15608425215544083', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:22:02', 3, 0, '', '2019-06-18 15:22:02');
INSERT INTO `access_log` VALUES (38399, '59.80.15608425215544077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.50.125.102', '2019-06-18 15:22:02', 13, 2001001000, '服务端发生异常', '2019-06-18 15:22:02');
INSERT INTO `access_log` VALUES (38400, '59.73.15608427604844093', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.35.38', '2019-06-18 15:26:00', 2, 0, '', '2019-06-18 15:26:00');
INSERT INTO `access_log` VALUES (38401, '59.78.15608427604844091', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.35.38', '2019-06-18 15:26:00', 13, 2001001000, '服务端发生异常', '2019-06-18 15:26:00');
INSERT INTO `access_log` VALUES (38402, '64.78.15608427648384047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.35.38', '2019-06-18 15:26:05', 3, 0, '', '2019-06-18 15:26:05');
INSERT INTO `access_log` VALUES (38403, '64.77.15608427649224053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.35.38', '2019-06-18 15:26:05', 1, 0, '', '2019-06-18 15:26:05');
INSERT INTO `access_log` VALUES (38404, '64.76.15608427663084037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.35.38', '2019-06-18 15:26:06', 2, 0, '', '2019-06-18 15:26:06');
INSERT INTO `access_log` VALUES (38405, '64.85.15608427670834061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.35.38', '2019-06-18 15:26:07', 2, 0, '', '2019-06-18 15:26:07');
INSERT INTO `access_log` VALUES (38406, '65.47.15608427849774847', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.35.38', '2019-06-18 15:26:25', 1, 1002001015, '账号未登陆', '2019-06-18 15:26:25');
INSERT INTO `access_log` VALUES (38407, '65.50.15608427849794863', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.35.38', '2019-06-18 15:26:25', 0, 1002001015, '账号未登陆', '2019-06-18 15:26:25');
INSERT INTO `access_log` VALUES (38408, '65.46.15608427849844881', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.35.38', '2019-06-18 15:26:25', 0, 1002001015, '账号未登陆', '2019-06-18 15:26:25');
INSERT INTO `access_log` VALUES (38409, '65.49.15608427888994875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.35.38', '2019-06-18 15:26:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 15:26:29');
INSERT INTO `access_log` VALUES (38410, '65.45.15608428003154861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.35.38', '2019-06-18 15:26:40', 79, 0, '', '2019-06-18 15:26:40');
INSERT INTO `access_log` VALUES (38411, '65.51.15608428006234883', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.35.38', '2019-06-18 15:26:41', 10, 0, '', '2019-06-18 15:26:41');
INSERT INTO `access_log` VALUES (38412, '65.52.15608428006284873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.35.38', '2019-06-18 15:26:41', 11, 2001001000, '服务端发生异常', '2019-06-18 15:26:41');
INSERT INTO `access_log` VALUES (38413, '65.53.15608428006374859', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.156.35.38', '2019-06-18 15:26:41', 8, 0, '', '2019-06-18 15:26:41');
INSERT INTO `access_log` VALUES (38414, '59.71.15608431213014095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:01', 3, 0, '', '2019-06-18 15:32:01');
INSERT INTO `access_log` VALUES (38415, '59.79.15608431213064101', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:01', 10, 2001001000, '服务端发生异常', '2019-06-18 15:32:01');
INSERT INTO `access_log` VALUES (38416, '66.52.15608431365502463', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18588858554&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:17', 17, 1001003000, '验证码不存在', '2019-06-18 15:32:17');
INSERT INTO `access_log` VALUES (38417, '66.51.15608431388152461', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18588858554', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:19', 231, 0, '', '2019-06-18 15:32:19');
INSERT INTO `access_log` VALUES (38418, '66.57.15608431408132459', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18588858554&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:21', 213, 0, '', '2019-06-18 15:32:21');
INSERT INTO `access_log` VALUES (38419, '66.56.15608431423732459', 126, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:22', 5, 0, '', '2019-06-18 15:32:22');
INSERT INTO `access_log` VALUES (38420, '66.54.15608431461252459', 126, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:26', 7, 0, '', '2019-06-18 15:32:26');
INSERT INTO `access_log` VALUES (38421, '66.49.15608431467562465', 126, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:27', 6, 0, '', '2019-06-18 15:32:27');
INSERT INTO `access_log` VALUES (38422, '59.80.15608431489054087', 126, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:29', 7, 0, '', '2019-06-18 15:32:29');
INSERT INTO `access_log` VALUES (38423, '59.76.15608431488984093', 126, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:29', 15, 2001001000, '服务端发生异常', '2019-06-18 15:32:29');
INSERT INTO `access_log` VALUES (38424, '64.77.15608431519454059', 126, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:32', 6, 0, '', '2019-06-18 15:32:32');
INSERT INTO `access_log` VALUES (38425, '64.76.15608431521414043', 126, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:32', 4, 0, '', '2019-06-18 15:32:32');
INSERT INTO `access_log` VALUES (38426, '64.84.15608431532234053', 126, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:33', 4, 0, '', '2019-06-18 15:32:33');
INSERT INTO `access_log` VALUES (38427, '64.83.15608431539104041', 126, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:34', 7, 0, '', '2019-06-18 15:32:34');
INSERT INTO `access_log` VALUES (38428, '64.81.15608431591394055', 126, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:39', 4, 0, '', '2019-06-18 15:32:39');
INSERT INTO `access_log` VALUES (38429, '64.78.15608431592574055', 126, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:39', 4, 0, '', '2019-06-18 15:32:39');
INSERT INTO `access_log` VALUES (38430, '64.77.15608431601124061', 126, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:40', 5, 0, '', '2019-06-18 15:32:40');
INSERT INTO `access_log` VALUES (38431, '64.79.15608431604614053', 126, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.204.236.149', '2019-06-18 15:32:40', 6, 0, '', '2019-06-18 15:32:40');
INSERT INTO `access_log` VALUES (38432, '66.52.15608464939452509', 0, 2, 'user-application', '/user-api/admins/user/update', 'avatar=http://www.iocoder.cn/xxx.jpg&id=1&nickname=小王', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.198.235.94', '2019-06-18 16:28:14', 0, 1002001015, '账号未登陆', '2019-06-18 16:28:14');
INSERT INTO `access_log` VALUES (38433, '66.54.15608465130382507', 0, 2, 'user-application', '/user-api/admins/user/update', 'avatar=http://www.iocoder.cn/xxx.jpg&id=1&nickname=小王', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.198.235.94', '2019-06-18 16:28:33', 1, 1002001015, '账号未登陆', '2019-06-18 16:28:33');
INSERT INTO `access_log` VALUES (38434, '65.3607.15608481427096693', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.130.103.58', '2019-06-18 16:55:43', 0, 1002001015, '账号未登陆', '2019-06-18 16:55:43');
INSERT INTO `access_log` VALUES (38435, '65.49.15608481427104947', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.130.103.58', '2019-06-18 16:55:43', 1, 1002001015, '账号未登陆', '2019-06-18 16:55:43');
INSERT INTO `access_log` VALUES (38436, '65.45.15608481427274935', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.130.103.58', '2019-06-18 16:55:43', 1, 1002001015, '账号未登陆', '2019-06-18 16:55:43');
INSERT INTO `access_log` VALUES (38437, '65.53.15608481447334929', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.130.103.58', '2019-06-18 16:55:45', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 16:55:45');
INSERT INTO `access_log` VALUES (38438, '65.52.15608481479164947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.130.103.58', '2019-06-18 16:55:48', 73, 0, '', '2019-06-18 16:55:48');
INSERT INTO `access_log` VALUES (38439, '65.51.15608481481634957', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.130.103.58', '2019-06-18 16:55:48', 11, 0, '', '2019-06-18 16:55:48');
INSERT INTO `access_log` VALUES (38440, '65.50.15608481481674939', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.130.103.58', '2019-06-18 16:55:48', 8, 0, '', '2019-06-18 16:55:48');
INSERT INTO `access_log` VALUES (38441, '65.54.15608481481634895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.130.103.58', '2019-06-18 16:55:48', 12, 2001001000, '服务端发生异常', '2019-06-18 16:55:48');
INSERT INTO `access_log` VALUES (38442, '59.73.15608481770154167', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.130.103.58', '2019-06-18 16:56:17', 16, 2001001000, '服务端发生异常', '2019-06-18 16:56:17');
INSERT INTO `access_log` VALUES (38443, '59.75.15608481770104169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.130.103.58', '2019-06-18 16:56:17', 200, 0, '', '2019-06-18 16:56:17');
INSERT INTO `access_log` VALUES (38444, '59.80.15608481905424155', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:31', 2, 0, '', '2019-06-18 16:56:31');
INSERT INTO `access_log` VALUES (38445, '59.76.15608481905434161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:31', 15, 2001001000, '服务端发生异常', '2019-06-18 16:56:31');
INSERT INTO `access_log` VALUES (38446, '64.82.15608481943654131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:34', 12, 0, '', '2019-06-18 16:56:34');
INSERT INTO `access_log` VALUES (38447, '64.81.15608481944694123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:34', 3, 0, '', '2019-06-18 16:56:34');
INSERT INTO `access_log` VALUES (38448, '64.77.15608481972394129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:37', 2, 0, '', '2019-06-18 16:56:37');
INSERT INTO `access_log` VALUES (38449, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:37', 8, 0, '', '2019-06-18 16:56:37');
INSERT INTO `access_log` VALUES (38450, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:38', 5, 0, '', '2019-06-18 16:56:38');
INSERT INTO `access_log` VALUES (38451, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:39', 6, 0, '', '2019-06-18 16:56:39');
INSERT INTO `access_log` VALUES (38452, '64.79.15608481995534121', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:40', 7, 0, '', '2019-06-18 16:56:40');
INSERT INTO `access_log` VALUES (38453, '64.85.15608482130884137', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:53', 6, 0, '', '2019-06-18 16:56:53');
INSERT INTO `access_log` VALUES (38454, '64.84.15608482138234123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:54', 2, 0, '', '2019-06-18 16:56:54');
INSERT INTO `access_log` VALUES (38455, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:54', 6, 0, '', '2019-06-18 16:56:54');
INSERT INTO `access_log` VALUES (38456, '64.80.15608482145994127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:55', 2, 0, '', '2019-06-18 16:56:55');
INSERT INTO `access_log` VALUES (38457, '64.83.15608482147034111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:55', 2, 0, '', '2019-06-18 16:56:55');
INSERT INTO `access_log` VALUES (38458, '64.82.15608482159384133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:56', 2, 0, '', '2019-06-18 16:56:56');
INSERT INTO `access_log` VALUES (38459, '64.81.15608482163864125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:56', 2, 0, '', '2019-06-18 16:56:56');
INSERT INTO `access_log` VALUES (38460, '59.79.15608482182414171', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:58', 2, 0, '', '2019-06-18 16:56:58');
INSERT INTO `access_log` VALUES (38461, '59.71.15608482182414165', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:56:58', 14, 2001001000, '服务端发生异常', '2019-06-18 16:56:58');
INSERT INTO `access_log` VALUES (38462, '64.78.15608482223654125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:57:02', 2, 0, '', '2019-06-18 16:57:02');
INSERT INTO `access_log` VALUES (38463, '64.77.15608482224404131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:57:02', 2, 0, '', '2019-06-18 16:57:02');
INSERT INTO `access_log` VALUES (38464, '64.79.15608482247244123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:57:05', 1, 0, '', '2019-06-18 16:57:05');
INSERT INTO `access_log` VALUES (38465, '64.76.15608482248514115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:57:05', 2, 0, '', '2019-06-18 16:57:05');
INSERT INTO `access_log` VALUES (38466, '66.53.15608482333282525', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=123&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.103.58', '2019-06-18 16:57:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-06-18 16:57:13');
INSERT INTO `access_log` VALUES (38467, '59.71.15608500864774189', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.240.38.151', '2019-06-18 17:28:06', 16, 0, '', '2019-06-18 17:28:06');
INSERT INTO `access_log` VALUES (38468, '59.72.15608500864824189', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.240.38.151', '2019-06-18 17:28:06', 15, 2001001000, '服务端发生异常', '2019-06-18 17:28:06');
INSERT INTO `access_log` VALUES (38469, '59.78.15608528226304229', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.186.13.146', '2019-06-18 18:13:43', 10, 0, '', '2019-06-18 18:13:43');
INSERT INTO `access_log` VALUES (38470, '59.80.15608528226324219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.186.13.146', '2019-06-18 18:13:43', 26, 2001001000, '服务端发生异常', '2019-06-18 18:13:43');
INSERT INTO `access_log` VALUES (38471, '64.82.15608528292134195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.186.13.146', '2019-06-18 18:13:49', 10, 0, '', '2019-06-18 18:13:49');
INSERT INTO `access_log` VALUES (38472, '64.78.15608528293854189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.186.13.146', '2019-06-18 18:13:49', 2, 0, '', '2019-06-18 18:13:49');
INSERT INTO `access_log` VALUES (38473, '64.79.15608528310754187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.186.13.146', '2019-06-18 18:13:51', 2, 0, '', '2019-06-18 18:13:51');
INSERT INTO `access_log` VALUES (38474, '64.85.15608528321174203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.186.13.146', '2019-06-18 18:13:52', 2, 0, '', '2019-06-18 18:13:52');
INSERT INTO `access_log` VALUES (38475, '59.74.15608528335974227', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.186.13.146', '2019-06-18 18:13:54', 3, 0, '', '2019-06-18 18:13:54');
INSERT INTO `access_log` VALUES (38476, '59.77.15608528335974219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.186.13.146', '2019-06-18 18:13:54', 14, 2001001000, '服务端发生异常', '2019-06-18 18:13:54');
INSERT INTO `access_log` VALUES (38477, '64.76.15608528368694177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.186.13.146', '2019-06-18 18:13:57', 2, 0, '', '2019-06-18 18:13:57');
INSERT INTO `access_log` VALUES (38478, '64.84.15608528370154187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.186.13.146', '2019-06-18 18:13:57', 2, 0, '', '2019-06-18 18:13:57');
INSERT INTO `access_log` VALUES (38479, '66.50.15608528401712585', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.186.13.146', '2019-06-18 18:14:00', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空', '2019-06-18 18:14:00');
INSERT INTO `access_log` VALUES (38480, '59.73.15608587385834311', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:52:19', 10, 0, '', '2019-06-18 19:52:19');
INSERT INTO `access_log` VALUES (38481, '59.75.15608587385834313', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:52:19', 12, 2001001000, '服务端发生异常', '2019-06-18 19:52:19');
INSERT INTO `access_log` VALUES (38482, '65.50.15608587390165081', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:52:19', 1, 1002001015, '账号未登陆', '2019-06-18 19:52:19');
INSERT INTO `access_log` VALUES (38483, '65.54.15608587390165037', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:52:19', 1, 1002001015, '账号未登陆', '2019-06-18 19:52:19');
INSERT INTO `access_log` VALUES (38484, '65.52.15608587390165089', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:52:19', 1, 1002001015, '账号未登陆', '2019-06-18 19:52:19');
INSERT INTO `access_log` VALUES (38485, '65.51.15608587424005099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:52:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 19:52:22');
INSERT INTO `access_log` VALUES (38486, '64.78.15608587525014269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:52:33', 10, 0, '', '2019-06-18 19:52:33');
INSERT INTO `access_log` VALUES (38487, '64.77.15608587528424273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:52:33', 5, 0, '', '2019-06-18 19:52:33');
INSERT INTO `access_log` VALUES (38488, '64.79.15608587542604267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:52:34', 3, 0, '', '2019-06-18 19:52:34');
INSERT INTO `access_log` VALUES (38489, '64.85.15608587550824283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:52:35', 2, 0, '', '2019-06-18 19:52:35');
INSERT INTO `access_log` VALUES (38490, '64.84.15608587555264267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:52:36', 2, 0, '', '2019-06-18 19:52:36');
INSERT INTO `access_log` VALUES (38491, '59.76.15608587567494305', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:52:37', 3, 0, '', '2019-06-18 19:52:37');
INSERT INTO `access_log` VALUES (38492, '59.74.15608587567494307', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:52:37', 19, 2001001000, '服务端发生异常', '2019-06-18 19:52:37');
INSERT INTO `access_log` VALUES (38493, '65.49.15608587799435091', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:53:00', 69, 0, '', '2019-06-18 19:53:00');
INSERT INTO `access_log` VALUES (38494, '65.50.15608587807175083', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:53:01', 10, 0, '', '2019-06-18 19:53:01');
INSERT INTO `access_log` VALUES (38495, '65.53.15608587807165073', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:53:01', 11, 0, '', '2019-06-18 19:53:01');
INSERT INTO `access_log` VALUES (38496, '65.45.15608587807165079', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '204.14.236.152', '2019-06-18 19:53:01', 13, 2001001000, '服务端发生异常', '2019-06-18 19:53:01');
INSERT INTO `access_log` VALUES (38497, '65.49.15608599091965107', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.165.99.147', '2019-06-18 20:11:49', 4, 1002001012, '访问令牌已过期', '2019-06-18 20:11:49');
INSERT INTO `access_log` VALUES (38498, '65.3607.15608599091966853', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.165.99.147', '2019-06-18 20:11:49', 4, 1002001012, '访问令牌已过期', '2019-06-18 20:11:49');
INSERT INTO `access_log` VALUES (38499, '65.53.15608599091995089', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.165.99.147', '2019-06-18 20:11:49', 2, 1002001012, '访问令牌已过期', '2019-06-18 20:11:49');
INSERT INTO `access_log` VALUES (38500, '59.80.15608629218484355', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:02:02', 11, 0, '', '2019-06-18 21:02:02');
INSERT INTO `access_log` VALUES (38501, '59.76.15608629218504361', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:02:02', 28, 2001001000, '服务端发生异常', '2019-06-18 21:02:02');
INSERT INTO `access_log` VALUES (38502, '65.52.15608629442435149', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:02:24', 0, 1002001015, '账号未登陆', '2019-06-18 21:02:24');
INSERT INTO `access_log` VALUES (38503, '65.53.15608629442425131', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:02:24', 0, 1002001015, '账号未登陆', '2019-06-18 21:02:24');
INSERT INTO `access_log` VALUES (38504, '65.47.15608629442705125', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:02:24', 0, 1002001015, '账号未登陆', '2019-06-18 21:02:24');
INSERT INTO `access_log` VALUES (38505, '65.54.15608629741115097', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:02:54', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 21:02:54');
INSERT INTO `access_log` VALUES (38506, '59.72.15608629797824363', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:03:00', 3, 0, '', '2019-06-18 21:03:00');
INSERT INTO `access_log` VALUES (38507, '59.75.15608629797824371', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:03:00', 16, 2001001000, '服务端发生异常', '2019-06-18 21:03:00');
INSERT INTO `access_log` VALUES (38508, '64.83.15608629816024313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:03:02', 10, 0, '', '2019-06-18 21:03:02');
INSERT INTO `access_log` VALUES (38509, '64.81.15608629817024325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:03:02', 2, 0, '', '2019-06-18 21:03:02');
INSERT INTO `access_log` VALUES (38510, '64.82.15608629828144333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:03:03', 2, 0, '', '2019-06-18 21:03:03');
INSERT INTO `access_log` VALUES (38511, '64.78.15608629833394327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:03:03', 2, 0, '', '2019-06-18 21:03:03');
INSERT INTO `access_log` VALUES (38512, '59.78.15608629844204367', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:03:04', 3, 0, '', '2019-06-18 21:03:04');
INSERT INTO `access_log` VALUES (38513, '59.80.15608629844204357', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:03:04', 12, 2001001000, '服务端发生异常', '2019-06-18 21:03:04');
INSERT INTO `access_log` VALUES (38514, '65.51.15608631662785161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.145.183', '2019-06-18 21:06:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-18 21:06:06');
INSERT INTO `access_log` VALUES (38515, '65.54.15609052626525663', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.46', '2019-06-19 08:47:43', 16, 1002001012, '访问令牌已过期', '2019-06-19 08:47:43');
INSERT INTO `access_log` VALUES (38516, '65.46.15609052626525723', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.46', '2019-06-19 08:47:43', 18, 1002001012, '访问令牌已过期', '2019-06-19 08:47:43');
INSERT INTO `access_log` VALUES (38517, '65.51.15609052626825723', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.46', '2019-06-19 08:47:43', 11, 1002001012, '访问令牌已过期', '2019-06-19 08:47:43');
INSERT INTO `access_log` VALUES (38518, '65.3607.15609052738437461', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.46', '2019-06-19 08:47:54', 121, 0, '', '2019-06-19 08:47:54');
INSERT INTO `access_log` VALUES (38519, '65.49.15609052742495715', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.46', '2019-06-19 08:47:54', 10, 0, '', '2019-06-19 08:47:54');
INSERT INTO `access_log` VALUES (38520, '65.52.15609052742615715', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.46', '2019-06-19 08:47:54', 8, 2001001000, '服务端发生异常', '2019-06-19 08:47:54');
INSERT INTO `access_log` VALUES (38521, '65.47.15609052742785691', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.46', '2019-06-19 08:47:54', 16, 0, '', '2019-06-19 08:47:54');
INSERT INTO `access_log` VALUES (38522, '59.77.15609069538074943', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:15:54', 13, 0, '', '2019-06-19 09:15:54');
INSERT INTO `access_log` VALUES (38523, '59.74.15609069538024951', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:15:54', 18, 2001001000, '服务端发生异常', '2019-06-19 09:15:54');
INSERT INTO `access_log` VALUES (38524, '64.85.15609069568774927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:15:57', 10, 0, '', '2019-06-19 09:15:57');
INSERT INTO `access_log` VALUES (38525, '64.76.15609069570544901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:15:57', 3, 0, '', '2019-06-19 09:15:57');
INSERT INTO `access_log` VALUES (38526, '64.80.15609069659294917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:06', 2, 0, '', '2019-06-19 09:16:06');
INSERT INTO `access_log` VALUES (38527, '64.83.15609069660894901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:06', 2, 0, '', '2019-06-19 09:16:06');
INSERT INTO `access_log` VALUES (38528, '64.81.15609069675584913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:08', 2, 0, '', '2019-06-19 09:16:08');
INSERT INTO `access_log` VALUES (38529, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:08', 7, 0, '', '2019-06-19 09:16:08');
INSERT INTO `access_log` VALUES (38530, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:10', 6, 0, '', '2019-06-19 09:16:10');
INSERT INTO `access_log` VALUES (38531, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:10', 6, 0, '', '2019-06-19 09:16:10');
INSERT INTO `access_log` VALUES (38532, '64.82.15609069713154921', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:11', 7, 0, '', '2019-06-19 09:16:11');
INSERT INTO `access_log` VALUES (38533, '64.78.15609069789734915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:19', 2, 0, '', '2019-06-19 09:16:19');
INSERT INTO `access_log` VALUES (38534, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:19', 6, 0, '', '2019-06-19 09:16:19');
INSERT INTO `access_log` VALUES (38535, '64.77.15609069801094919', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:20', 6, 0, '', '2019-06-19 09:16:20');
INSERT INTO `access_log` VALUES (38536, '64.85.15609069835594929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:24', 2, 0, '', '2019-06-19 09:16:24');
INSERT INTO `access_log` VALUES (38537, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:24', 15, 0, '', '2019-06-19 09:16:24');
INSERT INTO `access_log` VALUES (38538, '64.76.15609069843964903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:24', 2, 0, '', '2019-06-19 09:16:24');
INSERT INTO `access_log` VALUES (38539, '64.84.15609069843964913', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:24', 7, 0, '', '2019-06-19 09:16:24');
INSERT INTO `access_log` VALUES (38540, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:24', 6, 0, '', '2019-06-19 09:16:24');
INSERT INTO `access_log` VALUES (38541, '64.80.15609069855624919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:26', 5, 0, '', '2019-06-19 09:16:26');
INSERT INTO `access_log` VALUES (38542, '64.83.15609069856954903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:26', 2, 0, '', '2019-06-19 09:16:26');
INSERT INTO `access_log` VALUES (38543, '64.81.15609069868364915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:27', 1, 0, '', '2019-06-19 09:16:27');
INSERT INTO `access_log` VALUES (38544, '64.82.15609069876394923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:28', 2, 0, '', '2019-06-19 09:16:28');
INSERT INTO `access_log` VALUES (38545, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:28', 6, 0, '', '2019-06-19 09:16:28');
INSERT INTO `access_log` VALUES (38546, '64.78.15609069889314917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:29', 2, 0, '', '2019-06-19 09:16:29');
INSERT INTO `access_log` VALUES (38547, '64.77.15609069891084921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:29', 1, 0, '', '2019-06-19 09:16:29');
INSERT INTO `access_log` VALUES (38548, '64.79.15609069900024915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:30', 2, 0, '', '2019-06-19 09:16:30');
INSERT INTO `access_log` VALUES (38549, '64.85.15609069925704931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:33', 2, 0, '', '2019-06-19 09:16:33');
INSERT INTO `access_log` VALUES (38550, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:33', 7, 0, '', '2019-06-19 09:16:33');
INSERT INTO `access_log` VALUES (38551, '64.84.15609069942724915', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:34', 6, 0, '', '2019-06-19 09:16:34');
INSERT INTO `access_log` VALUES (38552, '64.80.15609069973014921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:37', 2, 0, '', '2019-06-19 09:16:37');
INSERT INTO `access_log` VALUES (38553, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:37', 7, 0, '', '2019-06-19 09:16:37');
INSERT INTO `access_log` VALUES (38554, '64.83.15609069997304905', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:40', 6, 0, '', '2019-06-19 09:16:40');
INSERT INTO `access_log` VALUES (38555, '64.81.15609070033314917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:43', 2, 0, '', '2019-06-19 09:16:43');
INSERT INTO `access_log` VALUES (38556, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:43', 7, 0, '', '2019-06-19 09:16:43');
INSERT INTO `access_log` VALUES (38557, '64.82.15609070041434925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:44', 2, 0, '', '2019-06-19 09:16:44');
INSERT INTO `access_log` VALUES (38558, '64.78.15609070043024919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:44', 2, 0, '', '2019-06-19 09:16:44');
INSERT INTO `access_log` VALUES (38559, '64.77.15609070076794923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:48', 2, 0, '', '2019-06-19 09:16:48');
INSERT INTO `access_log` VALUES (38560, '64.79.15609070078564917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:48', 2, 0, '', '2019-06-19 09:16:48');
INSERT INTO `access_log` VALUES (38561, '59.80.15609070124544945', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:52', 3, 0, '', '2019-06-19 09:16:52');
INSERT INTO `access_log` VALUES (38562, '59.73.15609070124544957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/74.0.3729.157 Mobile Safari/537.36', '14.23.183.53', '2019-06-19 09:16:52', 14, 2001001000, '服务端发生异常', '2019-06-19 09:16:52');
INSERT INTO `access_log` VALUES (38563, '59.79.15609079787354973', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.203.94', '2019-06-19 09:32:59', 14, 2001001000, '服务端发生异常', '2019-06-19 09:32:59');
INSERT INTO `access_log` VALUES (38564, '59.71.15609079787394965', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.203.94', '2019-06-19 09:32:59', 55, 0, '', '2019-06-19 09:32:59');
INSERT INTO `access_log` VALUES (38565, '64.85.15609080497654947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.203.94', '2019-06-19 09:34:10', 2, 0, '', '2019-06-19 09:34:10');
INSERT INTO `access_log` VALUES (38566, '64.84.15609080498834931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.203.94', '2019-06-19 09:34:10', 2, 0, '', '2019-06-19 09:34:10');
INSERT INTO `access_log` VALUES (38567, '64.76.15609080514654921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.203.94', '2019-06-19 09:34:11', 2, 0, '', '2019-06-19 09:34:11');
INSERT INTO `access_log` VALUES (38568, '65.50.15609093709365765', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:56:11', 4, 1002001012, '访问令牌已过期', '2019-06-19 09:56:11');
INSERT INTO `access_log` VALUES (38569, '65.46.15609093709375781', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:56:11', 5, 1002001012, '访问令牌已过期', '2019-06-19 09:56:11');
INSERT INTO `access_log` VALUES (38570, '65.47.15609093709395749', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:56:11', 4, 1002001012, '访问令牌已过期', '2019-06-19 09:56:11');
INSERT INTO `access_log` VALUES (38571, '65.51.15609093725225779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:56:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 09:56:13');
INSERT INTO `access_log` VALUES (38572, '65.45.15609093793405763', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:56:19', 5, 1002002001, '密码不正确', '2019-06-19 09:56:19');
INSERT INTO `access_log` VALUES (38573, '65.54.15609093834375719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:56:23', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 09:56:23');
INSERT INTO `access_log` VALUES (38574, '65.52.15609094121865773', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:56:52', 67, 0, '', '2019-06-19 09:56:52');
INSERT INTO `access_log` VALUES (38575, '65.49.15609094124495771', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:56:52', 10, 0, '', '2019-06-19 09:56:52');
INSERT INTO `access_log` VALUES (38576, '65.50.15609094124495767', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:56:52', 11, 2001001000, '服务端发生异常', '2019-06-19 09:56:52');
INSERT INTO `access_log` VALUES (38577, '65.46.15609094124585783', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:56:52', 9, 0, '', '2019-06-19 09:56:52');
INSERT INTO `access_log` VALUES (38578, '65.45.15609094301415765', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:57:10', 9, 0, '', '2019-06-19 09:57:10');
INSERT INTO `access_log` VALUES (38579, '65.54.15609094301495721', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:57:10', 10, 2001001000, '服务端发生异常', '2019-06-19 09:57:10');
INSERT INTO `access_log` VALUES (38580, '65.53.15609094301555753', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:57:10', 9, 0, '', '2019-06-19 09:57:10');
INSERT INTO `access_log` VALUES (38581, '65.3607.15609094359207519', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:57:16', 10, 0, '', '2019-06-19 09:57:16');
INSERT INTO `access_log` VALUES (38582, '65.50.15609094359295769', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:57:16', 18, 0, '', '2019-06-19 09:57:16');
INSERT INTO `access_log` VALUES (38583, '65.52.15609094359285775', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:57:16', 19, 2001001000, '服务端发生异常', '2019-06-19 09:57:16');
INSERT INTO `access_log` VALUES (38584, '65.46.15609094547095785', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:57:35', 10, 0, '', '2019-06-19 09:57:35');
INSERT INTO `access_log` VALUES (38585, '65.47.15609094547135753', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:57:35', 10, 2001001000, '服务端发生异常', '2019-06-19 09:57:35');
INSERT INTO `access_log` VALUES (38586, '65.51.15609094547175783', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 09:57:35', 9, 0, '', '2019-06-19 09:57:35');
INSERT INTO `access_log` VALUES (38587, '65.45.15609102066815777', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.173.11.26', '2019-06-19 10:10:07', 0, 1002001015, '账号未登陆', '2019-06-19 10:10:07');
INSERT INTO `access_log` VALUES (38588, '65.54.15609102066815733', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.173.11.26', '2019-06-19 10:10:07', 1, 1002001015, '账号未登陆', '2019-06-19 10:10:07');
INSERT INTO `access_log` VALUES (38589, '65.53.15609102066855765', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.173.11.26', '2019-06-19 10:10:07', 1, 1002001015, '账号未登陆', '2019-06-19 10:10:07');
INSERT INTO `access_log` VALUES (38590, '65.3607.15609102100917531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.173.11.26', '2019-06-19 10:10:10', 101, 0, '', '2019-06-19 10:10:10');
INSERT INTO `access_log` VALUES (38591, '65.52.15609102134535787', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.173.11.26', '2019-06-19 10:10:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 10:10:13');
INSERT INTO `access_log` VALUES (38592, '65.49.15609102215695785', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.173.11.26', '2019-06-19 10:10:22', 63, 0, '', '2019-06-19 10:10:22');
INSERT INTO `access_log` VALUES (38593, '65.46.15609102244915797', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.173.11.26', '2019-06-19 10:10:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 10:10:25');
INSERT INTO `access_log` VALUES (38594, '65.51.15609102258815795', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.173.11.26', '2019-06-19 10:10:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 10:10:26');
INSERT INTO `access_log` VALUES (38595, '65.54.15609102268255735', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.173.11.26', '2019-06-19 10:10:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 10:10:27');
INSERT INTO `access_log` VALUES (38596, '65.53.15609102358935767', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-06-19 10:10:36', 80, 0, '', '2019-06-19 10:10:36');
INSERT INTO `access_log` VALUES (38597, '65.45.15609102362605779', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-06-19 10:10:36', 10, 0, '', '2019-06-19 10:10:36');
INSERT INTO `access_log` VALUES (38598, '65.50.15609102362655783', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-06-19 10:10:36', 10, 2001001000, '服务端发生异常', '2019-06-19 10:10:36');
INSERT INTO `access_log` VALUES (38599, '65.3607.15609102362687533', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-06-19 10:10:36', 9, 0, '', '2019-06-19 10:10:36');
INSERT INTO `access_log` VALUES (38600, '65.45.15609126051565811', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:05', 0, 1002001015, '账号未登陆', '2019-06-19 10:50:05');
INSERT INTO `access_log` VALUES (38601, '65.50.15609126051565815', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:05', 0, 1002001015, '账号未登陆', '2019-06-19 10:50:05');
INSERT INTO `access_log` VALUES (38602, '65.52.15609126051575821', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:05', 0, 1002001015, '账号未登陆', '2019-06-19 10:50:05');
INSERT INTO `access_log` VALUES (38603, '65.49.15609126068305819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 10:50:07');
INSERT INTO `access_log` VALUES (38604, '65.47.15609126083575799', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 10:50:08');
INSERT INTO `access_log` VALUES (38605, '59.73.15609126361095033', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:36', 10, 0, '', '2019-06-19 10:50:36');
INSERT INTO `access_log` VALUES (38606, '59.72.15609126361095027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:36', 15, 2001001000, '服务端发生异常', '2019-06-19 10:50:36');
INSERT INTO `access_log` VALUES (38607, '64.79.15609126381724993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:38', 9, 0, '', '2019-06-19 10:50:38');
INSERT INTO `access_log` VALUES (38608, '64.85.15609126382755009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:38', 2, 0, '', '2019-06-19 10:50:38');
INSERT INTO `access_log` VALUES (38609, '64.84.15609126394274993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:39', 2, 0, '', '2019-06-19 10:50:39');
INSERT INTO `access_log` VALUES (38610, '64.76.15609126400174983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:40', 2, 0, '', '2019-06-19 10:50:40');
INSERT INTO `access_log` VALUES (38611, '64.80.15609126404674999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:40', 2, 0, '', '2019-06-19 10:50:40');
INSERT INTO `access_log` VALUES (38612, '64.83.15609126408314983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:41', 2, 0, '', '2019-06-19 10:50:41');
INSERT INTO `access_log` VALUES (38613, '59.80.15609126419915021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:42', 3, 0, '', '2019-06-19 10:50:42');
INSERT INTO `access_log` VALUES (38614, '59.78.15609126419925031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.131.93', '2019-06-19 10:50:42', 20, 2001001000, '服务端发生异常', '2019-06-19 10:50:42');
INSERT INTO `access_log` VALUES (38615, '65.47.15609139349005817', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 11:12:15', 4, 1002001012, '访问令牌已过期', '2019-06-19 11:12:15');
INSERT INTO `access_log` VALUES (38616, '65.46.15609139349015849', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 11:12:15', 3, 1002001012, '访问令牌已过期', '2019-06-19 11:12:15');
INSERT INTO `access_log` VALUES (38617, '65.51.15609139349265847', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 11:12:15', 3, 1002001012, '访问令牌已过期', '2019-06-19 11:12:15');
INSERT INTO `access_log` VALUES (38618, '65.53.15609139446515819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 11:12:25', 65, 0, '', '2019-06-19 11:12:25');
INSERT INTO `access_log` VALUES (38619, '65.3607.15609139449267585', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 11:12:25', 10, 0, '', '2019-06-19 11:12:25');
INSERT INTO `access_log` VALUES (38620, '65.45.15609139449305831', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 11:12:25', 12, 2001001000, '服务端发生异常', '2019-06-19 11:12:25');
INSERT INTO `access_log` VALUES (38621, '65.50.15609139449365835', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.168.134.212', '2019-06-19 11:12:25', 10, 0, '', '2019-06-19 11:12:25');
INSERT INTO `access_log` VALUES (38622, '59.73.15609140688055053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.118.72', '2019-06-19 11:14:29', 13, 2001001000, '服务端发生异常', '2019-06-19 11:14:29');
INSERT INTO `access_log` VALUES (38623, '59.75.15609140688045055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.118.72', '2019-06-19 11:14:29', 17, 0, '', '2019-06-19 11:14:29');
INSERT INTO `access_log` VALUES (38624, '64.85.15609140732625029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.118.72', '2019-06-19 11:14:33', 2, 0, '', '2019-06-19 11:14:33');
INSERT INTO `access_log` VALUES (38625, '64.84.15609140737105013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.118.72', '2019-06-19 11:14:34', 1, 0, '', '2019-06-19 11:14:34');
INSERT INTO `access_log` VALUES (38626, '65.50.15609166147525871', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:56:55', 1, 1002001015, '账号未登陆', '2019-06-19 11:56:55');
INSERT INTO `access_log` VALUES (38627, '65.45.15609166147525867', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:56:55', 0, 1002001015, '账号未登陆', '2019-06-19 11:56:55');
INSERT INTO `access_log` VALUES (38628, '65.52.15609166147525877', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:56:55', 0, 1002001015, '账号未登陆', '2019-06-19 11:56:55');
INSERT INTO `access_log` VALUES (38629, '65.49.15609166164375875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:56:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 11:56:56');
INSERT INTO `access_log` VALUES (38630, '65.46.15609166278465887', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:57:08', 108, 0, '', '2019-06-19 11:57:08');
INSERT INTO `access_log` VALUES (38631, '65.51.15609166281905885', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:57:08', 11, 0, '', '2019-06-19 11:57:08');
INSERT INTO `access_log` VALUES (38632, '65.47.15609166281905855', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:57:08', 12, 2001001000, '服务端发生异常', '2019-06-19 11:57:08');
INSERT INTO `access_log` VALUES (38633, '65.54.15609166281915825', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:57:08', 9, 0, '', '2019-06-19 11:57:08');
INSERT INTO `access_log` VALUES (38634, '65.3607.15609166439097623', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:57:24', 10, 0, '', '2019-06-19 11:57:24');
INSERT INTO `access_log` VALUES (38635, '65.50.15609166439095873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:57:24', 12, 2001001000, '服务端发生异常', '2019-06-19 11:57:24');
INSERT INTO `access_log` VALUES (38636, '65.45.15609166439405869', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:57:24', 9, 0, '', '2019-06-19 11:57:24');
INSERT INTO `access_log` VALUES (38637, '65.49.15609166518285877', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:57:32', 91, 0, '', '2019-06-19 11:57:32');
INSERT INTO `access_log` VALUES (38638, '65.46.15609166520835889', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:57:32', 8, 0, '', '2019-06-19 11:57:32');
INSERT INTO `access_log` VALUES (38639, '65.47.15609166520845857', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:57:32', 8, 2001001000, '服务端发生异常', '2019-06-19 11:57:32');
INSERT INTO `access_log` VALUES (38640, '65.51.15609166520865887', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.134.187.212', '2019-06-19 11:57:32', 7, 0, '', '2019-06-19 11:57:32');
INSERT INTO `access_log` VALUES (38641, '65.47.15609187626315887', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:32:43', 1, 1002001015, '账号未登陆', '2019-06-19 12:32:43');
INSERT INTO `access_log` VALUES (38642, '65.53.15609187626315887', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:32:43', 0, 1002001015, '账号未登陆', '2019-06-19 12:32:43');
INSERT INTO `access_log` VALUES (38643, '65.54.15609187626565855', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:32:43', 1, 1002001015, '账号未登陆', '2019-06-19 12:32:43');
INSERT INTO `access_log` VALUES (38644, '65.52.15609187775255909', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:32:58', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 12:32:58');
INSERT INTO `access_log` VALUES (38645, '65.3607.15609187837237655', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:33:04', 100, 0, '', '2019-06-19 12:33:04');
INSERT INTO `access_log` VALUES (38646, '65.49.15609187840995907', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:33:04', 19, 2001001000, '服务端发生异常', '2019-06-19 12:33:04');
INSERT INTO `access_log` VALUES (38647, '65.45.15609187840945899', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:33:04', 11, 0, '', '2019-06-19 12:33:04');
INSERT INTO `access_log` VALUES (38648, '65.51.15609187841005919', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:33:04', 20, 0, '', '2019-06-19 12:33:04');
INSERT INTO `access_log` VALUES (38649, '65.47.15609187917255889', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:33:12', 13, 0, '', '2019-06-19 12:33:12');
INSERT INTO `access_log` VALUES (38650, '65.54.15609187917285857', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:33:12', 12, 2001001000, '服务端发生异常', '2019-06-19 12:33:12');
INSERT INTO `access_log` VALUES (38651, '65.53.15609187917335889', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:33:12', 9, 0, '', '2019-06-19 12:33:12');
INSERT INTO `access_log` VALUES (38652, '65.47.15609189038155891', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:35:04', 9, 0, '', '2019-06-19 12:35:04');
INSERT INTO `access_log` VALUES (38653, '65.54.15609189038165859', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:35:04', 10, 2001001000, '服务端发生异常', '2019-06-19 12:35:04');
INSERT INTO `access_log` VALUES (38654, '65.53.15609189038205891', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:35:04', 9, 0, '', '2019-06-19 12:35:04');
INSERT INTO `access_log` VALUES (38655, '65.50.15609189071945909', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:35:07', 8, 0, '', '2019-06-19 12:35:07');
INSERT INTO `access_log` VALUES (38656, '65.52.15609189071945913', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:35:07', 10, 2001001000, '服务端发生异常', '2019-06-19 12:35:07');
INSERT INTO `access_log` VALUES (38657, '65.3607.15609189071977659', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:35:07', 9, 0, '', '2019-06-19 12:35:07');
INSERT INTO `access_log` VALUES (38658, '65.51.15609189099895923', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:35:10', 9, 0, '', '2019-06-19 12:35:10');
INSERT INTO `access_log` VALUES (38659, '65.46.15609189099975925', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:35:10', 14, 0, '', '2019-06-19 12:35:10');
INSERT INTO `access_log` VALUES (38660, '65.49.15609189099955911', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.237.87.30', '2019-06-19 12:35:10', 11, 2001001000, '服务端发生异常', '2019-06-19 12:35:10');
INSERT INTO `access_log` VALUES (38661, '59.76.15609236895155175', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:54:50', 11, 0, '', '2019-06-19 13:54:50');
INSERT INTO `access_log` VALUES (38662, '59.78.15609236895155179', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:54:50', 15, 2001001000, '服务端发生异常', '2019-06-19 13:54:50');
INSERT INTO `access_log` VALUES (38663, '64.81.15609236946225143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:54:55', 12, 0, '', '2019-06-19 13:54:55');
INSERT INTO `access_log` VALUES (38664, '64.76.15609236947605131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:54:55', 2, 0, '', '2019-06-19 13:54:55');
INSERT INTO `access_log` VALUES (38665, '64.84.15609236976815143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:54:58', 2, 0, '', '2019-06-19 13:54:58');
INSERT INTO `access_log` VALUES (38666, '64.83.15609236978315131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:54:58', 2, 0, '', '2019-06-19 13:54:58');
INSERT INTO `access_log` VALUES (38667, '59.77.15609236983225169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:54:58', 3, 0, '', '2019-06-19 13:54:58');
INSERT INTO `access_log` VALUES (38668, '59.74.15609236983245177', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:54:58', 10, 2001001000, '服务端发生异常', '2019-06-19 13:54:58');
INSERT INTO `access_log` VALUES (38669, '65.54.15609237054565925', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:55:05', 1, 1002001015, '账号未登陆', '2019-06-19 13:55:05');
INSERT INTO `access_log` VALUES (38670, '65.46.15609237054565989', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:55:05', 0, 1002001015, '账号未登陆', '2019-06-19 13:55:05');
INSERT INTO `access_log` VALUES (38671, '65.47.15609237054575957', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:55:05', 0, 1002001015, '账号未登陆', '2019-06-19 13:55:05');
INSERT INTO `access_log` VALUES (38672, '65.52.15609237093425979', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:55:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 13:55:09');
INSERT INTO `access_log` VALUES (38673, '65.50.15609237135895975', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:55:14', 65, 0, '', '2019-06-19 13:55:14');
INSERT INTO `access_log` VALUES (38674, '65.3607.15609237138707725', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:55:14', 11, 0, '', '2019-06-19 13:55:14');
INSERT INTO `access_log` VALUES (38675, '65.45.15609237138725969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:55:14', 10, 2001001000, '服务端发生异常', '2019-06-19 13:55:14');
INSERT INTO `access_log` VALUES (38676, '65.51.15609237138805989', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:55:14', 10, 0, '', '2019-06-19 13:55:14');
INSERT INTO `access_log` VALUES (38677, '65.46.15609237292545991', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:55:29', 11, 0, '', '2019-06-19 13:55:29');
INSERT INTO `access_log` VALUES (38678, '65.54.15609237292585927', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:55:29', 10, 0, '', '2019-06-19 13:55:29');
INSERT INTO `access_log` VALUES (38679, '65.47.15609237292585959', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.21.2.54', '2019-06-19 13:55:29', 10, 2001001000, '服务端发生异常', '2019-06-19 13:55:29');
INSERT INTO `access_log` VALUES (38680, '59.71.15609242848905185', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:04:45', 4, 0, '', '2019-06-19 14:04:45');
INSERT INTO `access_log` VALUES (38681, '59.77.15609242848895177', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:04:45', 13, 2001001000, '服务端发生异常', '2019-06-19 14:04:45');
INSERT INTO `access_log` VALUES (38682, '64.83.15609242886385139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:04:49', 2, 0, '', '2019-06-19 14:04:49');
INSERT INTO `access_log` VALUES (38683, '64.82.15609242887665161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:04:49', 1, 0, '', '2019-06-19 14:04:49');
INSERT INTO `access_log` VALUES (38684, '64.77.15609242995315157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:00', 3, 0, '', '2019-06-19 14:05:00');
INSERT INTO `access_log` VALUES (38685, '64.85.15609242996745169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:00', 2, 0, '', '2019-06-19 14:05:00');
INSERT INTO `access_log` VALUES (38686, '64.79.15609243019215153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:02', 2, 0, '', '2019-06-19 14:05:02');
INSERT INTO `access_log` VALUES (38687, '64.80.15609243029835157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:03', 2, 0, '', '2019-06-19 14:05:03');
INSERT INTO `access_log` VALUES (38688, '64.81.15609243038065153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:04', 2, 0, '', '2019-06-19 14:05:04');
INSERT INTO `access_log` VALUES (38689, '59.75.15609243080225193', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:08', 2, 0, '', '2019-06-19 14:05:08');
INSERT INTO `access_log` VALUES (38690, '59.72.15609243080235185', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:08', 12, 2001001000, '服务端发生异常', '2019-06-19 14:05:08');
INSERT INTO `access_log` VALUES (38691, '64.84.15609243165995153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:17', 2, 0, '', '2019-06-19 14:05:17');
INSERT INTO `access_log` VALUES (38692, '64.83.15609243167385141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:17', 1, 0, '', '2019-06-19 14:05:17');
INSERT INTO `access_log` VALUES (38693, '64.82.15609243177675163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:18', 2, 0, '', '2019-06-19 14:05:18');
INSERT INTO `access_log` VALUES (38694, '64.78.15609243182085157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:18', 1, 0, '', '2019-06-19 14:05:18');
INSERT INTO `access_log` VALUES (38695, '64.77.15609243186145159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:19', 2, 0, '', '2019-06-19 14:05:19');
INSERT INTO `access_log` VALUES (38696, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:19', 8, 0, '', '2019-06-19 14:05:19');
INSERT INTO `access_log` VALUES (38697, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:20', 4, 0, '', '2019-06-19 14:05:20');
INSERT INTO `access_log` VALUES (38698, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:20', 11, 0, '', '2019-06-19 14:05:20');
INSERT INTO `access_log` VALUES (38699, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:20', 18, 0, '', '2019-06-19 14:05:20');
INSERT INTO `access_log` VALUES (38700, '64.79.15609243218435155', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:05:22', 9, 0, '', '2019-06-19 14:05:22');
INSERT INTO `access_log` VALUES (38701, '59.79.15609253080235207', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:21:48', 3, 0, '', '2019-06-19 14:21:48');
INSERT INTO `access_log` VALUES (38702, '59.73.15609253080235205', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:21:48', 14, 2001001000, '服务端发生异常', '2019-06-19 14:21:48');
INSERT INTO `access_log` VALUES (38703, '64.78.15609253137465171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:21:54', 2, 0, '', '2019-06-19 14:21:54');
INSERT INTO `access_log` VALUES (38704, '64.77.15609253138785173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:21:54', 1, 0, '', '2019-06-19 14:21:54');
INSERT INTO `access_log` VALUES (38705, '64.85.15609253192185185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:21:59', 2, 0, '', '2019-06-19 14:21:59');
INSERT INTO `access_log` VALUES (38706, '64.79.15609253193695169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:21:59', 2, 0, '', '2019-06-19 14:21:59');
INSERT INTO `access_log` VALUES (38707, '59.72.15609253202895199', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:22:00', 3, 0, '', '2019-06-19 14:22:00');
INSERT INTO `access_log` VALUES (38708, '59.80.15609253202905193', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:22:00', 19, 2001001000, '服务端发生异常', '2019-06-19 14:22:00');
INSERT INTO `access_log` VALUES (38709, '65.46.15609253308646013', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:22:11', 1, 1002001015, '账号未登陆', '2019-06-19 14:22:11');
INSERT INTO `access_log` VALUES (38710, '65.47.15609253308645981', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:22:11', 0, 1002001015, '账号未登陆', '2019-06-19 14:22:11');
INSERT INTO `access_log` VALUES (38711, '65.54.15609253308665949', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:22:11', 0, 1002001015, '账号未登陆', '2019-06-19 14:22:11');
INSERT INTO `access_log` VALUES (38712, '65.52.15609253476016003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:22:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 14:22:28');
INSERT INTO `access_log` VALUES (38713, '65.50.15609253549455999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:22:35', 241, 0, '', '2019-06-19 14:22:35');
INSERT INTO `access_log` VALUES (38714, '65.51.15609253554796013', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:22:35', 9, 0, '', '2019-06-19 14:22:35');
INSERT INTO `access_log` VALUES (38715, '65.3607.15609253554807749', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:22:35', 10, 2001001000, '服务端发生异常', '2019-06-19 14:22:35');
INSERT INTO `access_log` VALUES (38716, '65.45.15609253554915993', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:22:35', 9, 0, '', '2019-06-19 14:22:36');
INSERT INTO `access_log` VALUES (38717, '65.46.15609253644406015', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:22:44', 8, 2001001000, '服务端发生异常', '2019-06-19 14:22:44');
INSERT INTO `access_log` VALUES (38718, '65.47.15609253644425983', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:22:44', 112, 0, '', '2019-06-19 14:22:45');
INSERT INTO `access_log` VALUES (38719, '65.54.15609253644395951', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.209.34.48', '2019-06-19 14:22:44', 118, 0, '', '2019-06-19 14:22:45');
INSERT INTO `access_log` VALUES (38720, '59.76.15609254309465201', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:23:51', 11, 0, '', '2019-06-19 14:23:51');
INSERT INTO `access_log` VALUES (38721, '59.78.15609254309475205', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:23:51', 20, 2001001000, '服务端发生异常', '2019-06-19 14:23:51');
INSERT INTO `access_log` VALUES (38722, '64.79.15609254401075171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:00', 12, 0, '', '2019-06-19 14:24:00');
INSERT INTO `access_log` VALUES (38723, '64.81.15609254403075171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:00', 11, 0, '', '2019-06-19 14:24:00');
INSERT INTO `access_log` VALUES (38724, '64.76.15609254446355159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:05', 11, 0, '', '2019-06-19 14:24:05');
INSERT INTO `access_log` VALUES (38725, '64.84.15609254447675171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:05', 9, 0, '', '2019-06-19 14:24:05');
INSERT INTO `access_log` VALUES (38726, '64.78.15609254464065175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:06', 8, 0, '', '2019-06-19 14:24:06');
INSERT INTO `access_log` VALUES (38727, '64.85.15609254472265189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:07', 11, 0, '', '2019-06-19 14:24:07');
INSERT INTO `access_log` VALUES (38728, '59.71.15609254485945203', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:09', 8, 0, '', '2019-06-19 14:24:09');
INSERT INTO `access_log` VALUES (38729, '59.77.15609254485955195', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:09', 14, 2001001000, '服务端发生异常', '2019-06-19 14:24:09');
INSERT INTO `access_log` VALUES (38730, '64.79.15609254558755173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:16', 10, 0, '', '2019-06-19 14:24:16');
INSERT INTO `access_log` VALUES (38731, '64.80.15609254560265177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:16', 30, 0, '', '2019-06-19 14:24:16');
INSERT INTO `access_log` VALUES (38732, '59.79.15609254568825211', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:17', 8, 0, '', '2019-06-19 14:24:17');
INSERT INTO `access_log` VALUES (38733, '59.73.15609254568825209', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:17', 17, 2001001000, '服务端发生异常', '2019-06-19 14:24:17');
INSERT INTO `access_log` VALUES (38734, '65.46.15609254755196017', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:36', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 14:24:36');
INSERT INTO `access_log` VALUES (38735, '65.47.15609254817585985', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:42', 81, 0, '', '2019-06-19 14:24:42');
INSERT INTO `access_log` VALUES (38736, '65.53.15609254822105985', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:42', 9, 0, '', '2019-06-19 14:24:42');
INSERT INTO `access_log` VALUES (38737, '65.52.15609254822296007', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:42', 16, 2001001000, '服务端发生异常', '2019-06-19 14:24:42');
INSERT INTO `access_log` VALUES (38738, '65.50.15609254822376003', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:24:42', 9, 0, '', '2019-06-19 14:24:42');
INSERT INTO `access_log` VALUES (38739, '65.45.15609255233095997', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:25:23', 10, 0, '', '2019-06-19 14:25:23');
INSERT INTO `access_log` VALUES (38740, '65.49.15609255233296005', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:25:23', 18, 2001001000, '服务端发生异常', '2019-06-19 14:25:23');
INSERT INTO `access_log` VALUES (38741, '65.46.15609255233406019', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:25:23', 9, 0, '', '2019-06-19 14:25:23');
INSERT INTO `access_log` VALUES (38742, '59.80.15609256331545199', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.207.40.66', '2019-06-19 14:27:13', 3, 0, '', '2019-06-19 14:27:13');
INSERT INTO `access_log` VALUES (38743, '59.76.15609256331555205', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '140.207.40.66', '2019-06-19 14:27:13', 11, 2001001000, '服务端发生异常', '2019-06-19 14:27:13');
INSERT INTO `access_log` VALUES (38744, '66.50.15609256552673555', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13122612541&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:27:35', 18, 1001003000, '验证码不存在', '2019-06-19 14:27:35');
INSERT INTO `access_log` VALUES (38745, '66.54.15609256605693565', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13122612541&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:27:41', 9, 1001003000, '验证码不存在', '2019-06-19 14:27:41');
INSERT INTO `access_log` VALUES (38746, '66.56.15609256975773569', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13122616189', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:28:18', 218, 0, '', '2019-06-19 14:28:18');
INSERT INTO `access_log` VALUES (38747, '66.51.15609258445293575', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13122616189&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:30:45', 266, 0, '', '2019-06-19 14:30:45');
INSERT INTO `access_log` VALUES (38748, '66.49.15609258463833573', 127, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:30:46', 7, 0, '', '2019-06-19 14:30:46');
INSERT INTO `access_log` VALUES (38749, '66.48.15609258535103575', 127, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:30:54', 6, 0, '', '2019-06-19 14:30:54');
INSERT INTO `access_log` VALUES (38750, '66.53.15609258584043567', 127, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:30:58', 6, 0, '', '2019-06-19 14:30:58');
INSERT INTO `access_log` VALUES (38751, '66.56.15609258601783573', 127, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:00', 5, 0, '', '2019-06-19 14:31:00');
INSERT INTO `access_log` VALUES (38752, '66.52.15609258612753571', 127, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:01', 6, 0, '', '2019-06-19 14:31:01');
INSERT INTO `access_log` VALUES (38753, '59.77.15609258633525203', 127, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:03', 6, 0, '', '2019-06-19 14:31:03');
INSERT INTO `access_log` VALUES (38754, '59.73.15609258633525217', 127, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:03', 17, 2001001000, '服务端发生异常', '2019-06-19 14:31:03');
INSERT INTO `access_log` VALUES (38755, '59.80.15609258772365203', 127, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:17', 6, 0, '', '2019-06-19 14:31:17');
INSERT INTO `access_log` VALUES (38756, '59.76.15609258772365209', 127, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:17', 16, 2001001000, '服务端发生异常', '2019-06-19 14:31:17');
INSERT INTO `access_log` VALUES (38757, '64.80.15609258801485183', 127, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:20', 8, 0, '', '2019-06-19 14:31:20');
INSERT INTO `access_log` VALUES (38758, '64.76.15609258802495167', 127, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:20', 4, 0, '', '2019-06-19 14:31:20');
INSERT INTO `access_log` VALUES (38759, '64.82.15609258815785189', 127, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:22', 5, 0, '', '2019-06-19 14:31:22');
INSERT INTO `access_log` VALUES (38760, '64.77.15609258825265185', 127, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:23', 5, 0, '', '2019-06-19 14:31:23');
INSERT INTO `access_log` VALUES (38761, '64.79.15609258836525181', 127, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:24', 5, 0, '', '2019-06-19 14:31:24');
INSERT INTO `access_log` VALUES (38762, '64.81.15609258846065181', 127, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:25', 4, 0, '', '2019-06-19 14:31:25');
INSERT INTO `access_log` VALUES (38763, '64.84.15609258851065181', 127, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:25', 4, 0, '', '2019-06-19 14:31:25');
INSERT INTO `access_log` VALUES (38764, '64.82.15609258860075191', 127, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:26', 5, 0, '', '2019-06-19 14:31:26');
INSERT INTO `access_log` VALUES (38765, 'N/A', 127, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:26', 21, 0, '', '2019-06-19 14:31:26');
INSERT INTO `access_log` VALUES (38766, '64.77.15609258925515187', 127, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:33', 10, 0, '', '2019-06-19 14:31:33');
INSERT INTO `access_log` VALUES (38767, '66.54.15609259025083571', 127, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '140.207.40.66', '2019-06-19 14:31:43', 6, 0, '', '2019-06-19 14:31:43');
INSERT INTO `access_log` VALUES (38768, '65.52.15609259811016015', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:33:01', 3, 1002001012, '访问令牌已过期', '2019-06-19 14:33:01');
INSERT INTO `access_log` VALUES (38769, '65.50.15609259811016011', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:33:01', 4, 1002001012, '访问令牌已过期', '2019-06-19 14:33:01');
INSERT INTO `access_log` VALUES (38770, '65.47.15609259811005993', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:33:01', 3, 1002001012, '访问令牌已过期', '2019-06-19 14:33:01');
INSERT INTO `access_log` VALUES (38771, '65.53.15609259833055993', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:33:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 14:33:03');
INSERT INTO `access_log` VALUES (38772, '65.46.15609260327486027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:33:53', 59, 0, '', '2019-06-19 14:33:53');
INSERT INTO `access_log` VALUES (38773, '65.49.15609260330786013', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:33:53', 9, 0, '', '2019-06-19 14:33:53');
INSERT INTO `access_log` VALUES (38774, '65.54.15609260330895963', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:33:53', 9, 0, '', '2019-06-19 14:33:53');
INSERT INTO `access_log` VALUES (38775, '65.50.15609260330896013', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:33:53', 10, 2001001000, '服务端发生异常', '2019-06-19 14:33:53');
INSERT INTO `access_log` VALUES (38776, '65.53.15609260504525995', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:34:10', 8, 0, '', '2019-06-19 14:34:10');
INSERT INTO `access_log` VALUES (38777, '65.51.15609260504536027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:34:10', 9, 2001001000, '服务端发生异常', '2019-06-19 14:34:10');
INSERT INTO `access_log` VALUES (38778, '65.3607.15609260504637763', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:34:10', 7, 0, '', '2019-06-19 14:34:10');
INSERT INTO `access_log` VALUES (38779, '59.73.15609260698855221', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:30', 3, 0, '', '2019-06-19 14:34:30');
INSERT INTO `access_log` VALUES (38780, '59.77.15609260698855207', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:30', 13, 2001001000, '服务端发生异常', '2019-06-19 14:34:30');
INSERT INTO `access_log` VALUES (38781, '65.47.15609260731785997', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:34:33', 9, 0, '', '2019-06-19 14:34:33');
INSERT INTO `access_log` VALUES (38782, '65.52.15609260732006019', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:34:33', 9, 2001001000, '服务端发生异常', '2019-06-19 14:34:33');
INSERT INTO `access_log` VALUES (38783, '65.53.15609260732055997', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:34:33', 8, 0, '', '2019-06-19 14:34:33');
INSERT INTO `access_log` VALUES (38784, '64.81.15609260777995185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:38', 3, 0, '', '2019-06-19 14:34:38');
INSERT INTO `access_log` VALUES (38785, '64.76.15609260778715173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:38', 1, 0, '', '2019-06-19 14:34:38');
INSERT INTO `access_log` VALUES (38786, '64.84.15609260792295185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:39', 2, 0, '', '2019-06-19 14:34:39');
INSERT INTO `access_log` VALUES (38787, '64.83.15609260801885173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:40', 1, 0, '', '2019-06-19 14:34:40');
INSERT INTO `access_log` VALUES (38788, '64.82.15609260808205195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:41', 2, 0, '', '2019-06-19 14:34:41');
INSERT INTO `access_log` VALUES (38789, '64.78.15609260816255189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:42', 2, 0, '', '2019-06-19 14:34:42');
INSERT INTO `access_log` VALUES (38790, '64.77.15609260818575191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:42', 1, 0, '', '2019-06-19 14:34:42');
INSERT INTO `access_log` VALUES (38791, '59.75.15609260834715221', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:43', 2, 0, '', '2019-06-19 14:34:43');
INSERT INTO `access_log` VALUES (38792, '59.72.15609260834725215', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:43', 12, 2001001000, '服务端发生异常', '2019-06-19 14:34:43');
INSERT INTO `access_log` VALUES (38793, '64.85.15609260884995203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:48', 2, 0, '', '2019-06-19 14:34:49');
INSERT INTO `access_log` VALUES (38794, '64.79.15609260886515187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:49', 1, 0, '', '2019-06-19 14:34:49');
INSERT INTO `access_log` VALUES (38795, '64.80.15609260897725191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:50', 2, 0, '', '2019-06-19 14:34:50');
INSERT INTO `access_log` VALUES (38796, '64.81.15609260903445187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:50', 2, 0, '', '2019-06-19 14:34:50');
INSERT INTO `access_log` VALUES (38797, '59.76.15609260921265213', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:52', 2, 0, '', '2019-06-19 14:34:52');
INSERT INTO `access_log` VALUES (38798, '59.74.15609260921275215', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:52', 12, 2001001000, '服务端发生异常', '2019-06-19 14:34:52');
INSERT INTO `access_log` VALUES (38799, '64.84.15609260945265187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:55', 2, 0, '', '2019-06-19 14:34:55');
INSERT INTO `access_log` VALUES (38800, '64.83.15609260946515175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:34:55', 2, 0, '', '2019-06-19 14:34:55');
INSERT INTO `access_log` VALUES (38801, '65.52.15609261004726021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 14:35:00', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 14:35:00');
INSERT INTO `access_log` VALUES (38802, '66.52.15609261102023575', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=1111111&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:35:10', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-06-19 14:35:10');
INSERT INTO `access_log` VALUES (38803, '65.51.15609261137926031', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.65.61.221', '2019-06-19 14:35:14', 0, 1002001015, '账号未登陆', '2019-06-19 14:35:14');
INSERT INTO `access_log` VALUES (38804, '66.49.15609261186573579', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:35:19', 9, 1001003000, '验证码不存在', '2019-06-19 14:35:19');
INSERT INTO `access_log` VALUES (38805, '66.50.15609261243773565', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=11111111111', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:35:24', 173, 0, '', '2019-06-19 14:35:25');
INSERT INTO `access_log` VALUES (38806, '66.48.15609261262413581', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:35:26', 163, 0, '', '2019-06-19 14:35:26');
INSERT INTO `access_log` VALUES (38807, '64.79.15609261366435189', 128, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:35:37', 6, 0, '', '2019-06-19 14:35:37');
INSERT INTO `access_log` VALUES (38808, '64.76.15609261367495177', 128, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:35:37', 5, 0, '', '2019-06-19 14:35:37');
INSERT INTO `access_log` VALUES (38809, '66.55.15609261397883569', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:35:40', 6, 0, '', '2019-06-19 14:35:40');
INSERT INTO `access_log` VALUES (38810, '66.56.15609261423913579', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:35:42', 6, 0, '', '2019-06-19 14:35:42');
INSERT INTO `access_log` VALUES (38811, '66.52.15609261564273577', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:35:56', 6, 0, '', '2019-06-19 14:35:56');
INSERT INTO `access_log` VALUES (38812, '59.72.15609261593275217', 128, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:35:59', 12, 0, '', '2019-06-19 14:35:59');
INSERT INTO `access_log` VALUES (38813, '59.80.15609261608215209', 128, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:36:01', 6, 0, '', '2019-06-19 14:36:01');
INSERT INTO `access_log` VALUES (38814, '59.74.15609261616585217', 128, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.190.126.151', '2019-06-19 14:36:02', 7, 0, '', '2019-06-19 14:36:02');
INSERT INTO `access_log` VALUES (38815, '65.51.15609263940616035', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-19 14:39:54', 0, 1002001015, '账号未登陆', '2019-06-19 14:39:54');
INSERT INTO `access_log` VALUES (38816, '65.3607.15609263940637769', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-19 14:39:54', 0, 1002001015, '账号未登陆', '2019-06-19 14:39:54');
INSERT INTO `access_log` VALUES (38817, '65.45.15609263940676011', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-19 14:39:54', 0, 1002001015, '账号未登陆', '2019-06-19 14:39:54');
INSERT INTO `access_log` VALUES (38818, '59.76.15609264197795219', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '123.125.34.11', '2019-06-19 14:40:20', 3, 0, '', '2019-06-19 14:40:20');
INSERT INTO `access_log` VALUES (38819, '59.74.15609264197985221', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '123.125.34.11', '2019-06-19 14:40:20', 13, 2001001000, '服务端发生异常', '2019-06-19 14:40:20');
INSERT INTO `access_log` VALUES (38820, '64.81.15609264418445193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '123.125.34.11', '2019-06-19 14:40:42', 3, 0, '', '2019-06-19 14:40:42');
INSERT INTO `access_log` VALUES (38821, '64.84.15609264419835193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '123.125.34.11', '2019-06-19 14:40:42', 1, 0, '', '2019-06-19 14:40:42');
INSERT INTO `access_log` VALUES (38822, '59.71.15609264435165223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '123.125.34.11', '2019-06-19 14:40:44', 3, 0, '', '2019-06-19 14:40:44');
INSERT INTO `access_log` VALUES (38823, '59.73.15609264435165229', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '123.125.34.11', '2019-06-19 14:40:44', 13, 2001001000, '服务端发生异常', '2019-06-19 14:40:44');
INSERT INTO `access_log` VALUES (38824, '59.79.15609264496535231', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '123.125.34.11', '2019-06-19 14:40:50', 2, 0, '', '2019-06-19 14:40:50');
INSERT INTO `access_log` VALUES (38825, '59.72.15609264496535223', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '123.125.34.11', '2019-06-19 14:40:50', 9, 2001001000, '服务端发生异常', '2019-06-19 14:40:50');
INSERT INTO `access_log` VALUES (38826, '65.3607.15609272937037781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-19 14:54:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 14:54:54');
INSERT INTO `access_log` VALUES (38827, '65.49.15609273285466035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-19 14:55:29', 104, 0, '', '2019-06-19 14:55:29');
INSERT INTO `access_log` VALUES (38828, '65.52.15609273290256039', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-19 14:55:29', 129, 0, '', '2019-06-19 14:55:29');
INSERT INTO `access_log` VALUES (38829, '65.53.15609273290346015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-19 14:55:29', 123, 0, '', '2019-06-19 14:55:29');
INSERT INTO `access_log` VALUES (38830, '65.47.15609273290316017', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-19 14:55:29', 127, 2001001000, '服务端发生异常', '2019-06-19 14:55:29');
INSERT INTO `access_log` VALUES (38831, '65.54.15609275434025987', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-19 14:59:03', 8, 0, '', '2019-06-19 14:59:03');
INSERT INTO `access_log` VALUES (38832, '65.50.15609275434016039', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-19 14:59:03', 11, 2001001000, '服务端发生异常', '2019-06-19 14:59:03');
INSERT INTO `access_log` VALUES (38833, '65.49.15609275434456039', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-19 14:59:03', 86, 0, '', '2019-06-19 14:59:04');
INSERT INTO `access_log` VALUES (38834, '65.53.15609275491386019', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-19 14:59:09', 8, 0, '', '2019-06-19 14:59:09');
INSERT INTO `access_log` VALUES (38835, '65.47.15609275491406021', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-19 14:59:09', 8, 2001001000, '服务端发生异常', '2019-06-19 14:59:09');
INSERT INTO `access_log` VALUES (38836, '65.51.15609275491466053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-19 14:59:09', 8, 0, '', '2019-06-19 14:59:09');
INSERT INTO `access_log` VALUES (38837, '59.79.15609277094645249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:01:49', 3, 0, '', '2019-06-19 15:01:49');
INSERT INTO `access_log` VALUES (38838, '59.75.15609277094645245', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:01:49', 10, 2001001000, '服务端发生异常', '2019-06-19 15:01:49');
INSERT INTO `access_log` VALUES (38839, '65.46.15609278884496055', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.191.76.226', '2019-06-19 15:04:48', 0, 1002001015, '账号未登陆', '2019-06-19 15:04:48');
INSERT INTO `access_log` VALUES (38840, '65.54.15609278884505993', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.191.76.226', '2019-06-19 15:04:48', 0, 1002001015, '账号未登陆', '2019-06-19 15:04:48');
INSERT INTO `access_log` VALUES (38841, '65.50.15609278884526045', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.191.76.226', '2019-06-19 15:04:48', 0, 1002001015, '账号未登陆', '2019-06-19 15:04:48');
INSERT INTO `access_log` VALUES (38842, '65.52.15609278967546049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.191.76.226', '2019-06-19 15:04:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 15:04:57');
INSERT INTO `access_log` VALUES (38843, '65.51.15609279032046059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.191.76.226', '2019-06-19 15:05:03', 351, 0, '', '2019-06-19 15:05:04');
INSERT INTO `access_log` VALUES (38844, '65.53.15609279039596025', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.191.76.226', '2019-06-19 15:05:04', 19, 2001001000, '服务端发生异常', '2019-06-19 15:05:04');
INSERT INTO `access_log` VALUES (38845, '65.45.15609279091566035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.191.76.226', '2019-06-19 15:05:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 15:05:09');
INSERT INTO `access_log` VALUES (38846, '65.3607.15609279125777793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.191.76.226', '2019-06-19 15:05:13', 68, 0, '', '2019-06-19 15:05:13');
INSERT INTO `access_log` VALUES (38847, '65.51.15609279841846061', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:06:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 15:06:24');
INSERT INTO `access_log` VALUES (38848, '65.53.15609279848786027', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:06:25', 0, 1002001015, '账号未登陆', '2019-06-19 15:06:25');
INSERT INTO `access_log` VALUES (38849, '65.47.15609279849026029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:06:25', 1, 1002001015, '账号未登陆', '2019-06-19 15:06:25');
INSERT INTO `access_log` VALUES (38850, '65.45.15609279849186037', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:06:25', 0, 1002001015, '账号未登陆', '2019-06-19 15:06:25');
INSERT INTO `access_log` VALUES (38851, '65.46.15609279996666059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:06:40', 71, 0, '', '2019-06-19 15:06:40');
INSERT INTO `access_log` VALUES (38852, '65.54.15609280000715997', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:06:40', 9, 0, '', '2019-06-19 15:06:40');
INSERT INTO `access_log` VALUES (38853, '65.50.15609280000766049', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:06:40', 10, 2001001000, '服务端发生异常', '2019-06-19 15:06:40');
INSERT INTO `access_log` VALUES (38854, '65.49.15609280000996049', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:06:40', 10, 0, '', '2019-06-19 15:06:40');
INSERT INTO `access_log` VALUES (38855, '65.51.15609280104996063', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:06:51', 18, 0, '', '2019-06-19 15:06:51');
INSERT INTO `access_log` VALUES (38856, '65.53.15609280105006029', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:06:51', 19, 0, '', '2019-06-19 15:06:51');
INSERT INTO `access_log` VALUES (38857, '65.52.15609280104996053', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:06:51', 20, 2001001000, '服务端发生异常', '2019-06-19 15:06:51');
INSERT INTO `access_log` VALUES (38858, '65.45.15609280143206039', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:06:54', 9, 0, '', '2019-06-19 15:06:54');
INSERT INTO `access_log` VALUES (38859, '65.3607.15609280143277797', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:06:54', 9, 2001001000, '服务端发生异常', '2019-06-19 15:06:54');
INSERT INTO `access_log` VALUES (38860, '65.46.15609280143406061', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:06:54', 8, 0, '', '2019-06-19 15:06:54');
INSERT INTO `access_log` VALUES (38861, '65.49.15609280421316051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:07:22', 9, 0, '', '2019-06-19 15:07:22');
INSERT INTO `access_log` VALUES (38862, '65.50.15609280421366051', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:07:22', 17, 2001001000, '服务端发生异常', '2019-06-19 15:07:22');
INSERT INTO `access_log` VALUES (38863, '65.53.15609280421396031', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:07:22', 16, 0, '', '2019-06-19 15:07:22');
INSERT INTO `access_log` VALUES (38864, '65.49.15609288233676065', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:20:23', 11, 0, '', '2019-06-19 15:20:23');
INSERT INTO `access_log` VALUES (38865, '65.52.15609288233706065', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:20:23', 10, 2001001000, '服务端发生异常', '2019-06-19 15:20:23');
INSERT INTO `access_log` VALUES (38866, '65.47.15609288233726045', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:20:23', 9, 0, '', '2019-06-19 15:20:23');
INSERT INTO `access_log` VALUES (38867, '65.3607.15609289664287813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:22:46', 68, 0, '', '2019-06-19 15:22:46');
INSERT INTO `access_log` VALUES (38868, '65.45.15609289667906053', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:22:47', 8, 0, '', '2019-06-19 15:22:47');
INSERT INTO `access_log` VALUES (38869, '65.46.15609289668126077', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:22:47', 10, 2001001000, '服务端发生异常', '2019-06-19 15:22:47');
INSERT INTO `access_log` VALUES (38870, '65.50.15609289668166065', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:22:47', 9, 0, '', '2019-06-19 15:22:47');
INSERT INTO `access_log` VALUES (38871, '65.53.15609289756616047', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:22:56', 9, 0, '', '2019-06-19 15:22:56');
INSERT INTO `access_log` VALUES (38872, '65.51.15609289756646077', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:22:56', 9, 2001001000, '服务端发生异常', '2019-06-19 15:22:56');
INSERT INTO `access_log` VALUES (38873, '65.52.15609289756726069', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:22:56', 8, 0, '', '2019-06-19 15:22:56');
INSERT INTO `access_log` VALUES (38874, '64.83.15609292907435223', 0, 2, 'product-application', '/product-api/admins/attr/page', 'name=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.191.76.226', '2019-06-19 15:28:11', 0, 1002001015, '账号未登陆', '2019-06-19 15:28:11');
INSERT INTO `access_log` VALUES (38875, '65.3607.15609299170107827', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:38:37', 1, 1002001015, '账号未登陆', '2019-06-19 15:38:37');
INSERT INTO `access_log` VALUES (38876, '65.50.15609299170186079', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:38:37', 0, 1002001015, '账号未登陆', '2019-06-19 15:38:37');
INSERT INTO `access_log` VALUES (38877, '65.46.15609299170246091', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:38:37', 1, 1002001015, '账号未登陆', '2019-06-19 15:38:37');
INSERT INTO `access_log` VALUES (38878, '65.54.15609299201486027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:38:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 15:38:40');
INSERT INTO `access_log` VALUES (38879, '65.51.15609299261326091', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:38:46', 70, 0, '', '2019-06-19 15:38:46');
INSERT INTO `access_log` VALUES (38880, '65.52.15609299264656083', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:38:46', 10, 0, '', '2019-06-19 15:38:46');
INSERT INTO `access_log` VALUES (38881, '65.53.15609299264686061', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:38:46', 10, 2001001000, '服务端发生异常', '2019-06-19 15:38:46');
INSERT INTO `access_log` VALUES (38882, '65.47.15609299264746063', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:38:46', 9, 0, '', '2019-06-19 15:38:46');
INSERT INTO `access_log` VALUES (38883, '65.50.15609299493316081', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:39:09', 8, 0, '', '2019-06-19 15:39:09');
INSERT INTO `access_log` VALUES (38884, '65.46.15609299493316093', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:39:09', 9, 2001001000, '服务端发生异常', '2019-06-19 15:39:09');
INSERT INTO `access_log` VALUES (38885, '65.45.15609299493376069', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:39:09', 7, 0, '', '2019-06-19 15:39:09');
INSERT INTO `access_log` VALUES (38886, '65.51.15609299745456093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:39:35', 73, 0, '', '2019-06-19 15:39:35');
INSERT INTO `access_log` VALUES (38887, '65.52.15609299748236085', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:39:35', 9, 0, '', '2019-06-19 15:39:35');
INSERT INTO `access_log` VALUES (38888, '65.47.15609299748296065', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:39:35', 9, 2001001000, '服务端发生异常', '2019-06-19 15:39:35');
INSERT INTO `access_log` VALUES (38889, '65.53.15609299748306063', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.111.63.180', '2019-06-19 15:39:35', 9, 0, '', '2019-06-19 15:39:35');
INSERT INTO `access_log` VALUES (38890, '59.79.15609303839995285', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '221.218.103.38', '2019-06-19 15:46:24', 14, 0, '', '2019-06-19 15:46:24');
INSERT INTO `access_log` VALUES (38891, '59.75.15609303840005281', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '221.218.103.38', '2019-06-19 15:46:24', 15, 2001001000, '服务端发生异常', '2019-06-19 15:46:24');
INSERT INTO `access_log` VALUES (38892, '65.49.15609304010506091', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '221.218.103.38', '2019-06-19 15:46:41', 3, 1002001012, '访问令牌已过期', '2019-06-19 15:46:41');
INSERT INTO `access_log` VALUES (38893, '65.53.15609304010496069', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '221.218.103.38', '2019-06-19 15:46:41', 4, 1002001012, '访问令牌已过期', '2019-06-19 15:46:41');
INSERT INTO `access_log` VALUES (38894, '65.3607.15609304010537837', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '221.218.103.38', '2019-06-19 15:46:41', 3, 1002001012, '访问令牌已过期', '2019-06-19 15:46:41');
INSERT INTO `access_log` VALUES (38895, '65.51.15609307569426105', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.244.155.168', '2019-06-19 15:52:37', 0, 1002001015, '账号未登陆', '2019-06-19 15:52:37');
INSERT INTO `access_log` VALUES (38896, '65.54.15609307569426041', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.244.155.168', '2019-06-19 15:52:37', 0, 1002001015, '账号未登陆', '2019-06-19 15:52:37');
INSERT INTO `access_log` VALUES (38897, '65.52.15609307569446097', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.244.155.168', '2019-06-19 15:52:37', 0, 1002001015, '账号未登陆', '2019-06-19 15:52:37');
INSERT INTO `access_log` VALUES (38898, '65.46.15609308297366107', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.244.155.168', '2019-06-19 15:53:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 15:53:50');
INSERT INTO `access_log` VALUES (38899, '65.3607.15609308346637845', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.244.155.168', '2019-06-19 15:53:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 15:53:55');
INSERT INTO `access_log` VALUES (38900, '65.3607.15609309579757847', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.244.155.168', '2019-06-19 15:55:58', 89, 0, '', '2019-06-19 15:55:58');
INSERT INTO `access_log` VALUES (38901, '59.79.15609309694355293', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.244.155.168', '2019-06-19 15:56:09', 4, 0, '', '2019-06-19 15:56:09');
INSERT INTO `access_log` VALUES (38902, '59.72.15609309695725283', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.244.155.168', '2019-06-19 15:56:10', 14, 2001001000, '服务端发生异常', '2019-06-19 15:56:10');
INSERT INTO `access_log` VALUES (38903, '65.53.15609309773396079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.244.155.168', '2019-06-19 15:56:17', 68, 0, '', '2019-06-19 15:56:17');
INSERT INTO `access_log` VALUES (38904, '65.47.15609310601956083', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.211.113', '2019-06-19 15:57:40', 4, 1002001012, '访问令牌已过期', '2019-06-19 15:57:40');
INSERT INTO `access_log` VALUES (38905, '65.3607.15609310601957849', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.211.113', '2019-06-19 15:57:40', 291, 1002001012, '访问令牌已过期', '2019-06-19 15:57:40');
INSERT INTO `access_log` VALUES (38906, '65.49.15609310601966103', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.211.113', '2019-06-19 15:57:40', 291, 1002001012, '访问令牌已过期', '2019-06-19 15:57:40');
INSERT INTO `access_log` VALUES (38907, '62.88.15609310650164969', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 15:57:45', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-19 15:57:45');
INSERT INTO `access_log` VALUES (38908, '65.53.15609310660616081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.211.113', '2019-06-19 15:57:46', 75, 0, '', '2019-06-19 15:57:46');
INSERT INTO `access_log` VALUES (38909, '65.50.15609310663156101', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.211.113', '2019-06-19 15:57:46', 9, 0, '', '2019-06-19 15:57:46');
INSERT INTO `access_log` VALUES (38910, '65.45.15609310663176087', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.211.113', '2019-06-19 15:57:46', 9, 2001001000, '服务端发生异常', '2019-06-19 15:57:46');
INSERT INTO `access_log` VALUES (38911, '65.52.15609310663186103', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.211.113', '2019-06-19 15:57:46', 9, 0, '', '2019-06-19 15:57:46');
INSERT INTO `access_log` VALUES (38912, '62.85.15609310726934957', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'createBeginTime=&createEndTime=&hasRefund=&orderSubject=&pageNo=1&pageSize=10&payChannel=&paymentBeginTime=&paymentEndTime=&status=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 15:57:53', 1, 1002001015, '账号未登陆', '2019-06-19 15:57:53');
INSERT INTO `access_log` VALUES (38913, '65.51.15609311548706113', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 15:59:15', 4, 1002001012, '访问令牌已过期', '2019-06-19 15:59:15');
INSERT INTO `access_log` VALUES (38914, '65.3607.15609311548707851', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 15:59:15', 4, 1002001012, '访问令牌已过期', '2019-06-19 15:59:15');
INSERT INTO `access_log` VALUES (38915, '65.52.15609311548706105', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 15:59:15', 4, 1002001012, '访问令牌已过期', '2019-06-19 15:59:15');
INSERT INTO `access_log` VALUES (38916, '65.50.15609311630466105', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 15:59:23', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 15:59:23');
INSERT INTO `access_log` VALUES (38917, '65.47.15609311722886087', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 15:59:32', 129, 0, '', '2019-06-19 15:59:32');
INSERT INTO `access_log` VALUES (38918, '65.46.15609311729826117', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 15:59:33', 9, 0, '', '2019-06-19 15:59:33');
INSERT INTO `access_log` VALUES (38919, '65.53.15609311729826085', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 15:59:33', 9, 0, '', '2019-06-19 15:59:33');
INSERT INTO `access_log` VALUES (38920, '65.49.15609311729826107', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 15:59:33', 10, 2001001000, '服务端发生异常', '2019-06-19 15:59:33');
INSERT INTO `access_log` VALUES (38921, '65.52.15609312011506107', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 16:00:01', 9, 0, '', '2019-06-19 16:00:01');
INSERT INTO `access_log` VALUES (38922, '65.3607.15609312011527853', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 16:00:01', 10, 2001001000, '服务端发生异常', '2019-06-19 16:00:01');
INSERT INTO `access_log` VALUES (38923, '65.50.15609312011656107', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 16:00:01', 9, 0, '', '2019-06-19 16:00:01');
INSERT INTO `access_log` VALUES (38924, '65.49.15609312364016109', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 16:00:36', 9, 0, '', '2019-06-19 16:00:36');
INSERT INTO `access_log` VALUES (38925, '65.53.15609312364036087', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 16:00:36', 9, 2001001000, '服务端发生异常', '2019-06-19 16:00:36');
INSERT INTO `access_log` VALUES (38926, '65.46.15609312364046119', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.206.244.238', '2019-06-19 16:00:36', 9, 0, '', '2019-06-19 16:00:36');
INSERT INTO `access_log` VALUES (38927, '65.3607.15609318629987863', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 16:11:03', 139, 0, '', '2019-06-19 16:11:03');
INSERT INTO `access_log` VALUES (38928, '65.50.15609318637686117', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 16:11:04', 9, 0, '', '2019-06-19 16:11:04');
INSERT INTO `access_log` VALUES (38929, '65.52.15609318637696117', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 16:11:04', 11, 2001001000, '服务端发生异常', '2019-06-19 16:11:04');
INSERT INTO `access_log` VALUES (38930, '65.54.15609318638156061', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 16:11:04', 10, 0, '', '2019-06-19 16:11:04');
INSERT INTO `access_log` VALUES (38931, '65.46.15609318713086129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 16:11:11', 9, 0, '', '2019-06-19 16:11:11');
INSERT INTO `access_log` VALUES (38932, '65.53.15609318713106097', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 16:11:11', 9, 2001001000, '服务端发生异常', '2019-06-19 16:11:11');
INSERT INTO `access_log` VALUES (38933, '65.49.15609318713146119', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.66.90.161', '2019-06-19 16:11:11', 8, 0, '', '2019-06-19 16:11:11');
INSERT INTO `access_log` VALUES (38934, '65.45.15609335226286125', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.80.181.148', '2019-06-19 16:38:43', 0, 1002001015, '账号未登陆', '2019-06-19 16:38:43');
INSERT INTO `access_log` VALUES (38935, '65.51.15609335226286149', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.80.181.148', '2019-06-19 16:38:43', 0, 1002001015, '账号未登陆', '2019-06-19 16:38:43');
INSERT INTO `access_log` VALUES (38936, '65.3607.15609335226307887', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.80.181.148', '2019-06-19 16:38:43', 0, 1002001015, '账号未登陆', '2019-06-19 16:38:43');
INSERT INTO `access_log` VALUES (38937, '65.50.15609335327746141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=youdaoyuanma&password=youdaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.80.181.148', '2019-06-19 16:38:53', 11, 1002002000, '账号不存在', '2019-06-19 16:38:53');
INSERT INTO `access_log` VALUES (38938, '65.54.15609335406976085', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.80.181.148', '2019-06-19 16:39:01', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 16:39:01');
INSERT INTO `access_log` VALUES (38939, '65.46.15609335510616153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.80.181.148', '2019-06-19 16:39:11', 90, 0, '', '2019-06-19 16:39:11');
INSERT INTO `access_log` VALUES (38940, '65.49.15609335514136143', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.80.181.148', '2019-06-19 16:39:11', 9, 0, '', '2019-06-19 16:39:11');
INSERT INTO `access_log` VALUES (38941, '65.53.15609335514176121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.80.181.148', '2019-06-19 16:39:11', 9, 2001001000, '服务端发生异常', '2019-06-19 16:39:11');
INSERT INTO `access_log` VALUES (38942, '65.51.15609335514226151', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.80.181.148', '2019-06-19 16:39:11', 8, 0, '', '2019-06-19 16:39:11');
INSERT INTO `access_log` VALUES (38943, '65.45.15609335685606127', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.80.181.148', '2019-06-19 16:39:29', 9, 0, '', '2019-06-19 16:39:29');
INSERT INTO `access_log` VALUES (38944, '65.50.15609335685656143', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.80.181.148', '2019-06-19 16:39:29', 7, 2001001000, '服务端发生异常', '2019-06-19 16:39:29');
INSERT INTO `access_log` VALUES (38945, '65.52.15609335685696143', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.80.181.148', '2019-06-19 16:39:29', 7, 0, '', '2019-06-19 16:39:29');
INSERT INTO `access_log` VALUES (38946, '65.47.15609335823536125', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '58.247.204.63', '2019-06-19 16:39:42', 0, 1002001015, '账号未登陆', '2019-06-19 16:39:42');
INSERT INTO `access_log` VALUES (38947, '59.71.15609338470975325', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:07', 11, 0, '', '2019-06-19 16:44:07');
INSERT INTO `access_log` VALUES (38948, '59.76.15609338470985321', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:07', 15, 2001001000, '服务端发生异常', '2019-06-19 16:44:07');
INSERT INTO `access_log` VALUES (38949, '64.83.15609338512345285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:11', 10, 0, '', '2019-06-19 16:44:11');
INSERT INTO `access_log` VALUES (38950, '64.81.15609338513765295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:11', 3, 0, '', '2019-06-19 16:44:11');
INSERT INTO `access_log` VALUES (38951, '64.78.15609338541515299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:14', 2, 0, '', '2019-06-19 16:44:14');
INSERT INTO `access_log` VALUES (38952, '64.82.15609338547465305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:15', 2, 0, '', '2019-06-19 16:44:15');
INSERT INTO `access_log` VALUES (38953, '59.78.15609338561215327', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:16', 2, 0, '', '2019-06-19 16:44:16');
INSERT INTO `access_log` VALUES (38954, '59.73.15609338561255331', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:16', 9, 2001001000, '服务端发生异常', '2019-06-19 16:44:16');
INSERT INTO `access_log` VALUES (38955, '59.75.15609338610555329', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:21', 2, 0, '', '2019-06-19 16:44:21');
INSERT INTO `access_log` VALUES (38956, '59.79.15609338610565333', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:21', 19, 2001001000, '服务端发生异常', '2019-06-19 16:44:21');
INSERT INTO `access_log` VALUES (38957, '65.47.15609338691966129', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:29', 0, 1002001015, '账号未登陆', '2019-06-19 16:44:29');
INSERT INTO `access_log` VALUES (38958, '65.46.15609338691996159', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:29', 1, 1002001015, '账号未登陆', '2019-06-19 16:44:29');
INSERT INTO `access_log` VALUES (38959, '65.51.15609338692066157', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:29', 0, 1002001015, '账号未登陆', '2019-06-19 16:44:29');
INSERT INTO `access_log` VALUES (38960, '65.53.15609338744626127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 16:44:34');
INSERT INTO `access_log` VALUES (38961, '65.3607.15609338824907895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 16:44:42');
INSERT INTO `access_log` VALUES (38962, '65.52.15609338929946149', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:53', 74, 0, '', '2019-06-19 16:44:53');
INSERT INTO `access_log` VALUES (38963, '65.50.15609338933786149', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:53', 182, 0, '', '2019-06-19 16:44:54');
INSERT INTO `access_log` VALUES (38964, '65.54.15609338933946093', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:53', 174, 0, '', '2019-06-19 16:44:54');
INSERT INTO `access_log` VALUES (38965, '65.45.15609338933826133', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:44:53', 186, 2001001000, '服务端发生异常', '2019-06-19 16:44:54');
INSERT INTO `access_log` VALUES (38966, '65.53.15609339287986129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:45:29', 9, 0, '', '2019-06-19 16:45:29');
INSERT INTO `access_log` VALUES (38967, '65.49.15609339288026151', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:45:29', 10, 2001001000, '服务端发生异常', '2019-06-19 16:45:29');
INSERT INTO `access_log` VALUES (38968, '65.3607.15609339288077897', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.142.140.58', '2019-06-19 16:45:29', 9, 0, '', '2019-06-19 16:45:29');
INSERT INTO `access_log` VALUES (38969, '65.52.15609341884586155', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '223.166.151.191', '2019-06-19 16:49:48', 1, 1002001015, '账号未登陆', '2019-06-19 16:49:48');
INSERT INTO `access_log` VALUES (38970, '65.54.15609342040906097', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '223.166.151.191', '2019-06-19 16:50:04', 0, 1002001015, '账号未登陆', '2019-06-19 16:50:04');
INSERT INTO `access_log` VALUES (38971, '59.76.15609343716595329', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '124.192.213.2', '2019-06-19 16:52:52', 3, 0, '', '2019-06-19 16:52:52');
INSERT INTO `access_log` VALUES (38972, '59.78.15609343716595335', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '124.192.213.2', '2019-06-19 16:52:52', 13, 2001001000, '服务端发生异常', '2019-06-19 16:52:52');
INSERT INTO `access_log` VALUES (38973, '64.77.15609343761845305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '124.192.213.2', '2019-06-19 16:52:56', 3, 0, '', '2019-06-19 16:52:56');
INSERT INTO `access_log` VALUES (38974, '64.83.15609343763345293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '124.192.213.2', '2019-06-19 16:52:56', 2, 0, '', '2019-06-19 16:52:56');
INSERT INTO `access_log` VALUES (38975, '59.73.15609343790285339', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '124.192.213.2', '2019-06-19 16:52:59', 2, 0, '', '2019-06-19 16:52:59');
INSERT INTO `access_log` VALUES (38976, '59.77.15609343790285325', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '124.192.213.2', '2019-06-19 16:52:59', 13, 2001001000, '服务端发生异常', '2019-06-19 16:52:59');
INSERT INTO `access_log` VALUES (38977, '65.3607.15609343977667905', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '124.192.213.2', '2019-06-19 16:53:18', 1, 1002001015, '账号未登陆', '2019-06-19 16:53:18');
INSERT INTO `access_log` VALUES (38978, '65.46.15609343977686169', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '124.192.213.2', '2019-06-19 16:53:18', 0, 1002001015, '账号未登陆', '2019-06-19 16:53:18');
INSERT INTO `access_log` VALUES (38979, '65.49.15609343977756159', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '124.192.213.2', '2019-06-19 16:53:18', 0, 1002001015, '账号未登陆', '2019-06-19 16:53:18');
INSERT INTO `access_log` VALUES (38980, '65.50.15609343998076159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '124.192.213.2', '2019-06-19 16:53:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 16:53:20');
INSERT INTO `access_log` VALUES (38981, '65.54.15609344234766101', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '124.192.213.2', '2019-06-19 16:53:43', 596, 0, '', '2019-06-19 16:53:44');
INSERT INTO `access_log` VALUES (38982, '65.47.15609344244676141', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '124.192.213.2', '2019-06-19 16:53:44', 10, 0, '', '2019-06-19 16:53:44');
INSERT INTO `access_log` VALUES (38983, '65.51.15609344244736169', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '124.192.213.2', '2019-06-19 16:53:44', 9, 2001001000, '服务端发生异常', '2019-06-19 16:53:44');
INSERT INTO `access_log` VALUES (38984, '65.53.15609344244786139', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '124.192.213.2', '2019-06-19 16:53:44', 9, 0, '', '2019-06-19 16:53:44');
INSERT INTO `access_log` VALUES (38985, '59.75.15609348233795343', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.188.229', '2019-06-19 17:00:23', 3, 0, '', '2019-06-19 17:00:23');
INSERT INTO `access_log` VALUES (38986, '59.79.15609348243455347', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.191.93', '2019-06-19 17:00:24', 12, 2001001000, '服务端发生异常', '2019-06-19 17:00:24');
INSERT INTO `access_log` VALUES (38987, '59.80.15609351256935335', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '36.7.136.208', '2019-06-19 17:05:26', 3, 0, '', '2019-06-19 17:05:26');
INSERT INTO `access_log` VALUES (38988, '59.72.15609351256925341', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '36.7.136.208', '2019-06-19 17:05:26', 13, 2001001000, '服务端发生异常', '2019-06-19 17:05:26');
INSERT INTO `access_log` VALUES (38989, '59.76.15609354414925345', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.239.42.66', '2019-06-19 17:10:41', 3, 0, '', '2019-06-19 17:10:41');
INSERT INTO `access_log` VALUES (38990, '59.71.15609354414895349', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.239.42.66', '2019-06-19 17:10:41', 13, 2001001000, '服务端发生异常', '2019-06-19 17:10:42');
INSERT INTO `access_log` VALUES (38991, '64.78.15609354466895321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.239.42.66', '2019-06-19 17:10:47', 3, 0, '', '2019-06-19 17:10:47');
INSERT INTO `access_log` VALUES (38992, '64.82.15609354470645327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.239.42.66', '2019-06-19 17:10:47', 1, 0, '', '2019-06-19 17:10:47');
INSERT INTO `access_log` VALUES (38993, '66.53.15609354547523697', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.239.42.66', '2019-06-19 17:10:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机号不能为空\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空', '2019-06-19 17:10:55');
INSERT INTO `access_log` VALUES (38994, '64.85.15609354597035333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.239.42.66', '2019-06-19 17:11:00', 2, 0, '', '2019-06-19 17:11:00');
INSERT INTO `access_log` VALUES (38995, '64.76.15609354598525305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.239.42.66', '2019-06-19 17:11:00', 1, 0, '', '2019-06-19 17:11:00');
INSERT INTO `access_log` VALUES (38996, '64.80.15609354614185321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.239.42.66', '2019-06-19 17:11:01', 2, 0, '', '2019-06-19 17:11:01');
INSERT INTO `access_log` VALUES (38997, '64.84.15609354622245313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.239.42.66', '2019-06-19 17:11:02', 2, 0, '', '2019-06-19 17:11:02');
INSERT INTO `access_log` VALUES (38998, '65.51.15609356487536189', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.93.161.98', '2019-06-19 17:14:09', 1, 1002001015, '账号未登陆', '2019-06-19 17:14:09');
INSERT INTO `access_log` VALUES (38999, '65.47.15609356487546157', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.93.161.98', '2019-06-19 17:14:09', 0, 1002001015, '账号未登陆', '2019-06-19 17:14:09');
INSERT INTO `access_log` VALUES (39000, '65.53.15609356487596159', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.93.161.98', '2019-06-19 17:14:09', 0, 1002001015, '账号未登陆', '2019-06-19 17:14:09');
INSERT INTO `access_log` VALUES (39001, '65.49.15609356519646179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.93.161.98', '2019-06-19 17:14:12', 119, 0, '', '2019-06-19 17:14:12');
INSERT INTO `access_log` VALUES (39002, '65.50.15609356523086179', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.93.161.98', '2019-06-19 17:14:12', 10, 0, '', '2019-06-19 17:14:12');
INSERT INTO `access_log` VALUES (39003, '65.3607.15609356523107925', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.93.161.98', '2019-06-19 17:14:12', 10, 0, '', '2019-06-19 17:14:12');
INSERT INTO `access_log` VALUES (39004, '65.52.15609356523096177', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.93.161.98', '2019-06-19 17:14:12', 10, 2001001000, '服务端发生异常', '2019-06-19 17:14:12');
INSERT INTO `access_log` VALUES (39005, '65.52.15609395241136229', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:18:44', 1, 1002001015, '账号未登陆', '2019-06-19 18:18:44');
INSERT INTO `access_log` VALUES (39006, '65.54.15609395241136173', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:18:44', 1, 1002001015, '账号未登陆', '2019-06-19 18:18:44');
INSERT INTO `access_log` VALUES (39007, '65.45.15609395241156209', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:18:44', 1, 1002001015, '账号未登陆', '2019-06-19 18:18:44');
INSERT INTO `access_log` VALUES (39008, '65.53.15609395434066213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:03', 177, 0, '', '2019-06-19 18:19:04');
INSERT INTO `access_log` VALUES (39009, '65.47.15609395438166211', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:04', 12, 2001001000, '服务端发生异常', '2019-06-19 18:19:04');
INSERT INTO `access_log` VALUES (39010, '65.46.15609395438286245', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:04', 8, 0, '', '2019-06-19 18:19:04');
INSERT INTO `access_log` VALUES (39011, '65.49.15609395438696233', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:04', 10, 0, '', '2019-06-19 18:19:04');
INSERT INTO `access_log` VALUES (39012, '65.3607.15609395510737979', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:11', 10, 0, '', '2019-06-19 18:19:11');
INSERT INTO `access_log` VALUES (39013, '65.54.15609395510756175', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:11', 9, 2001001000, '服务端发生异常', '2019-06-19 18:19:11');
INSERT INTO `access_log` VALUES (39014, '65.52.15609395510776231', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:11', 9, 0, '', '2019-06-19 18:19:11');
INSERT INTO `access_log` VALUES (39015, '59.72.15609395691425401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:29', 12, 2001001000, '服务端发生异常', '2019-06-19 18:19:29');
INSERT INTO `access_log` VALUES (39016, '59.80.15609395690765395', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:29', 91, 0, '', '2019-06-19 18:19:29');
INSERT INTO `access_log` VALUES (39017, '59.76.15609395751655401', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:35', 3, 0, '', '2019-06-19 18:19:35');
INSERT INTO `access_log` VALUES (39018, '59.71.15609395751665405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:35', 13, 2001001000, '服务端发生异常', '2019-06-19 18:19:35');
INSERT INTO `access_log` VALUES (39019, '64.85.15609395965835389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:57', 10, 0, '', '2019-06-19 18:19:57');
INSERT INTO `access_log` VALUES (39020, '64.79.15609395966935373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:57', 2, 0, '', '2019-06-19 18:19:57');
INSERT INTO `access_log` VALUES (39021, '64.76.15609395988025363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:59', 2, 0, '', '2019-06-19 18:19:59');
INSERT INTO `access_log` VALUES (39022, '64.84.15609395994975371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:19:59', 2, 0, '', '2019-06-19 18:20:00');
INSERT INTO `access_log` VALUES (39023, '59.73.15609396022835411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:20:02', 3, 0, '', '2019-06-19 18:20:02');
INSERT INTO `access_log` VALUES (39024, '59.77.15609396022855397', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '140.205.147.39', '2019-06-19 18:20:02', 11, 2001001000, '服务端发生异常', '2019-06-19 18:20:02');
INSERT INTO `access_log` VALUES (39025, '59.80.15609446568375463', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:44:17', 25, 0, '', '2019-06-19 19:44:17');
INSERT INTO `access_log` VALUES (39026, '59.78.15609446568385475', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:44:17', 30, 2001001000, '服务端发生异常', '2019-06-19 19:44:17');
INSERT INTO `access_log` VALUES (39027, '65.54.15609446674566243', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:44:27', 3, 1002001012, '访问令牌已过期', '2019-06-19 19:44:27');
INSERT INTO `access_log` VALUES (39028, '65.45.15609446674576281', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:44:27', 3, 1002001012, '访问令牌已过期', '2019-06-19 19:44:27');
INSERT INTO `access_log` VALUES (39029, '65.51.15609446674606313', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:44:27', 12, 1002001012, '访问令牌已过期', '2019-06-19 19:44:27');
INSERT INTO `access_log` VALUES (39030, '65.53.15609446696206285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:44:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 19:44:30');
INSERT INTO `access_log` VALUES (39031, '65.47.15609446787806283', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:44:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 19:44:39');
INSERT INTO `access_log` VALUES (39032, '65.49.15609446877406305', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanmadd&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:44:48', 91, 0, '', '2019-06-19 19:44:48');
INSERT INTO `access_log` VALUES (39033, '65.50.15609446882316303', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:44:48', 154, 0, '', '2019-06-19 19:44:48');
INSERT INTO `access_log` VALUES (39034, '65.52.15609446882416303', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:44:48', 146, 0, '', '2019-06-19 19:44:48');
INSERT INTO `access_log` VALUES (39035, '65.3607.15609446882398049', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:44:48', 148, 2001001000, '服务端发生异常', '2019-06-19 19:44:48');
INSERT INTO `access_log` VALUES (39036, '65.54.15609447208206245', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:45:21', 77, 0, '', '2019-06-19 19:45:21');
INSERT INTO `access_log` VALUES (39037, '65.53.15609447214136287', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:45:21', 9, 0, '', '2019-06-19 19:45:21');
INSERT INTO `access_log` VALUES (39038, '65.46.15609447214136317', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:45:21', 10, 0, '', '2019-06-19 19:45:21');
INSERT INTO `access_log` VALUES (39039, '65.47.15609447214136285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.68.45', '2019-06-19 19:45:21', 9, 2001001000, '服务端发生异常', '2019-06-19 19:45:21');
INSERT INTO `access_log` VALUES (39040, '65.46.15609490399406377', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.89.129.36', '2019-06-19 20:57:20', 1, 1002001015, '账号未登陆', '2019-06-19 20:57:20');
INSERT INTO `access_log` VALUES (39041, '65.3607.15609501833778125', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:16:23', 0, 1002001015, '账号未登陆', '2019-06-19 21:16:23');
INSERT INTO `access_log` VALUES (39042, '65.54.15609501833776319', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:16:23', 0, 1002001015, '账号未登陆', '2019-06-19 21:16:23');
INSERT INTO `access_log` VALUES (39043, '65.45.15609501837806357', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:16:24', 1, 1002001015, '账号未登陆', '2019-06-19 21:16:24');
INSERT INTO `access_log` VALUES (39044, '65.45.15609503175626359', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:18:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 21:18:38');
INSERT INTO `access_log` VALUES (39045, '65.49.15609503368296383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:18:57', 85, 0, '', '2019-06-19 21:18:57');
INSERT INTO `access_log` VALUES (39046, '65.47.15609503378896361', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:18:58', 13, 0, '', '2019-06-19 21:18:58');
INSERT INTO `access_log` VALUES (39047, '65.52.15609503378946383', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:18:58', 12, 2001001000, '服务端发生异常', '2019-06-19 21:18:58');
INSERT INTO `access_log` VALUES (39048, '65.50.15609503380736381', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:18:58', 10, 0, '', '2019-06-19 21:18:58');
INSERT INTO `access_log` VALUES (39049, '65.46.15609503825736397', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:19:43', 7, 0, '', '2019-06-19 21:19:43');
INSERT INTO `access_log` VALUES (39050, '65.45.15609503825726361', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:19:43', 9, 2001001000, '服务端发生异常', '2019-06-19 21:19:43');
INSERT INTO `access_log` VALUES (39051, '65.53.15609503825846367', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:19:43', 15, 0, '', '2019-06-19 21:19:43');
INSERT INTO `access_log` VALUES (39052, '59.77.15609504405855543', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:20:41', 11, 0, '', '2019-06-19 21:20:41');
INSERT INTO `access_log` VALUES (39053, '59.72.15609504405865549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:20:41', 14, 2001001000, '服务端发生异常', '2019-06-19 21:20:41');
INSERT INTO `access_log` VALUES (39054, '64.81.15609504432025519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:20:43', 11, 0, '', '2019-06-19 21:20:43');
INSERT INTO `access_log` VALUES (39055, '64.78.15609504433415525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:20:43', 2, 0, '', '2019-06-19 21:20:43');
INSERT INTO `access_log` VALUES (39056, '64.82.15609504445055531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:20:45', 1, 0, '', '2019-06-19 21:20:45');
INSERT INTO `access_log` VALUES (39057, '64.85.15609504450025535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:20:45', 2, 0, '', '2019-06-19 21:20:45');
INSERT INTO `access_log` VALUES (39058, '59.80.15609504460825541', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:20:46', 15, 0, '', '2019-06-19 21:20:46');
INSERT INTO `access_log` VALUES (39059, '59.78.15609504460825553', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:20:46', 18, 2001001000, '服务端发生异常', '2019-06-19 21:20:46');
INSERT INTO `access_log` VALUES (39060, '59.71.15609504507625553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:20:51', 3, 0, '', '2019-06-19 21:20:51');
INSERT INTO `access_log` VALUES (39061, '59.74.15609504507625551', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:20:51', 13, 2001001000, '服务端发生异常', '2019-06-19 21:20:51');
INSERT INTO `access_log` VALUES (39062, '64.76.15609504530705509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:20:53', 2, 0, '', '2019-06-19 21:20:53');
INSERT INTO `access_log` VALUES (39063, '64.84.15609504531655517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:20:53', 2, 0, '', '2019-06-19 21:20:53');
INSERT INTO `access_log` VALUES (39064, '59.73.15609504537885559', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:20:54', 2, 0, '', '2019-06-19 21:20:54');
INSERT INTO `access_log` VALUES (39065, '59.76.15609504537885549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:20:54', 13, 2001001000, '服务端发生异常', '2019-06-19 21:20:54');
INSERT INTO `access_log` VALUES (39066, '65.3607.15609504626988131', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:21:03', 10, 0, '', '2019-06-19 21:21:03');
INSERT INTO `access_log` VALUES (39067, '65.54.15609504628086325', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:21:03', 11, 2001001000, '服务端发生异常', '2019-06-19 21:21:03');
INSERT INTO `access_log` VALUES (39068, '65.45.15609504628146363', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:21:03', 10, 0, '', '2019-06-19 21:21:03');
INSERT INTO `access_log` VALUES (39069, '65.53.15609504649436369', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:21:05', 0, 1002001015, '账号未登陆', '2019-06-19 21:21:05');
INSERT INTO `access_log` VALUES (39070, '65.46.15609504649436399', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:21:05', 0, 1002001015, '账号未登陆', '2019-06-19 21:21:05');
INSERT INTO `access_log` VALUES (39071, '65.49.15609504649516387', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:21:05', 0, 1002001015, '账号未登陆', '2019-06-19 21:21:05');
INSERT INTO `access_log` VALUES (39072, '65.47.15609504682906365', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:21:08', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 21:21:08');
INSERT INTO `access_log` VALUES (39073, '65.50.15609504692236385', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:21:09', 9, 0, '', '2019-06-19 21:21:09');
INSERT INTO `access_log` VALUES (39074, '65.51.15609504692296397', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:21:09', 9, 2001001000, '服务端发生异常', '2019-06-19 21:21:09');
INSERT INTO `access_log` VALUES (39075, '65.3607.15609504692488133', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:21:09', 9, 0, '', '2019-06-19 21:21:09');
INSERT INTO `access_log` VALUES (39076, '65.45.15609504799686365', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:21:20', 9, 0, '', '2019-06-19 21:21:20');
INSERT INTO `access_log` VALUES (39077, '65.54.15609504799756327', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:21:20', 10, 2001001000, '服务端发生异常', '2019-06-19 21:21:20');
INSERT INTO `access_log` VALUES (39078, '65.46.15609504799796401', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.87.205.20', '2019-06-19 21:21:20', 8, 0, '', '2019-06-19 21:21:20');
INSERT INTO `access_log` VALUES (39079, '65.46.15609505744856403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:22:54', 83, 0, '', '2019-06-19 21:22:55');
INSERT INTO `access_log` VALUES (39080, '65.49.15609505749096391', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:22:55', 9, 0, '', '2019-06-19 21:22:55');
INSERT INTO `access_log` VALUES (39081, '65.54.15609505749076329', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:22:55', 10, 0, '', '2019-06-19 21:22:55');
INSERT INTO `access_log` VALUES (39082, '65.45.15609505749096367', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '27.18.70.179', '2019-06-19 21:22:55', 9, 2001001000, '服务端发生异常', '2019-06-19 21:22:55');
INSERT INTO `access_log` VALUES (39083, '65.50.15609513769716399', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '153.34.128.126', '2019-06-19 21:36:17', 0, 1002001015, '账号未登陆', '2019-06-19 21:36:17');
INSERT INTO `access_log` VALUES (39084, '65.51.15609513769866411', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '153.34.128.126', '2019-06-19 21:36:17', 0, 1002001015, '账号未登陆', '2019-06-19 21:36:17');
INSERT INTO `access_log` VALUES (39085, '65.3607.15609513769938147', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '153.34.128.126', '2019-06-19 21:36:17', 0, 1002001015, '账号未登陆', '2019-06-19 21:36:17');
INSERT INTO `access_log` VALUES (39086, '65.46.15609513815836415', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '153.34.128.126', '2019-06-19 21:36:22', 61, 0, '', '2019-06-19 21:36:22');
INSERT INTO `access_log` VALUES (39087, '65.54.15609513819946341', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '153.34.128.126', '2019-06-19 21:36:22', 10, 0, '', '2019-06-19 21:36:22');
INSERT INTO `access_log` VALUES (39088, '65.45.15609513819976379', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '153.34.128.126', '2019-06-19 21:36:22', 8, 0, '', '2019-06-19 21:36:22');
INSERT INTO `access_log` VALUES (39089, '65.49.15609513819966403', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '153.34.128.126', '2019-06-19 21:36:22', 10, 2001001000, '服务端发生异常', '2019-06-19 21:36:22');
INSERT INTO `access_log` VALUES (39090, '65.52.15609514024086403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '153.34.128.126', '2019-06-19 21:36:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 21:36:42');
INSERT INTO `access_log` VALUES (39091, '65.53.15609520216366395', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:02', 0, 1002001015, '账号未登陆', '2019-06-19 21:47:02');
INSERT INTO `access_log` VALUES (39092, '65.47.15609520216386391', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:02', 0, 1002001015, '账号未登陆', '2019-06-19 21:47:02');
INSERT INTO `access_log` VALUES (39093, '65.52.15609520216426413', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:02', 0, 1002001015, '账号未登陆', '2019-06-19 21:47:02');
INSERT INTO `access_log` VALUES (39094, '65.50.15609520284386411', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:08', 63, 0, '', '2019-06-19 21:47:09');
INSERT INTO `access_log` VALUES (39095, '65.46.15609520287586425', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:09', 115, 0, '', '2019-06-19 21:47:09');
INSERT INTO `access_log` VALUES (39096, '65.51.15609520287446421', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:09', 129, 0, '', '2019-06-19 21:47:09');
INSERT INTO `access_log` VALUES (39097, '65.3607.15609520287508159', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:09', 127, 2001001000, '服务端发生异常', '2019-06-19 21:47:09');
INSERT INTO `access_log` VALUES (39098, '65.49.15609520384856413', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:18', 9, 2001001000, '服务端发生异常', '2019-06-19 21:47:18');
INSERT INTO `access_log` VALUES (39099, '65.54.15609520384816353', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:18', 82, 0, '', '2019-06-19 21:47:19');
INSERT INTO `access_log` VALUES (39100, '65.53.15609520384876397', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:18', 77, 0, '', '2019-06-19 21:47:19');
INSERT INTO `access_log` VALUES (39101, '65.52.15609520509266415', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:31', 8, 0, '', '2019-06-19 21:47:31');
INSERT INTO `access_log` VALUES (39102, '65.50.15609520509286413', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:31', 10, 2001001000, '服务端发生异常', '2019-06-19 21:47:31');
INSERT INTO `access_log` VALUES (39103, '65.45.15609520509346393', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:31', 9, 0, '', '2019-06-19 21:47:31');
INSERT INTO `access_log` VALUES (39104, '65.51.15609520560196423', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 21:47:36');
INSERT INTO `access_log` VALUES (39105, '65.3607.15609520576908161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 21:47:38');
INSERT INTO `access_log` VALUES (39106, '65.46.15609520586086427', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '163.179.63.240', '2019-06-19 21:47:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 21:47:39');
INSERT INTO `access_log` VALUES (39107, '59.80.15609522847155567', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.19.104.213', '2019-06-19 21:51:25', 20, 2001001000, '服务端发生异常', '2019-06-19 21:51:25');
INSERT INTO `access_log` VALUES (39108, '59.77.15609522847155569', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.19.104.213', '2019-06-19 21:51:25', 78, 0, '', '2019-06-19 21:51:25');
INSERT INTO `access_log` VALUES (39109, '64.83.15609522889105537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.19.104.213', '2019-06-19 21:51:29', 10, 0, '', '2019-06-19 21:51:29');
INSERT INTO `access_log` VALUES (39110, '64.81.15609522891405545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.19.104.213', '2019-06-19 21:51:29', 2, 0, '', '2019-06-19 21:51:29');
INSERT INTO `access_log` VALUES (39111, '64.78.15609522905705551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.19.104.213', '2019-06-19 21:51:31', 2, 0, '', '2019-06-19 21:51:31');
INSERT INTO `access_log` VALUES (39112, '64.82.15609522915155557', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.19.104.213', '2019-06-19 21:51:32', 2, 0, '', '2019-06-19 21:51:32');
INSERT INTO `access_log` VALUES (39113, '65.47.15609523965086399', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.19.104.213', '2019-06-19 21:53:17', 0, 1002001015, '账号未登陆', '2019-06-19 21:53:17');
INSERT INTO `access_log` VALUES (39114, '65.45.15609523965166399', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.19.104.213', '2019-06-19 21:53:17', 1, 1002001015, '账号未登陆', '2019-06-19 21:53:17');
INSERT INTO `access_log` VALUES (39115, '65.52.15609523965246421', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.19.104.213', '2019-06-19 21:53:17', 0, 1002001015, '账号未登陆', '2019-06-19 21:53:17');
INSERT INTO `access_log` VALUES (39116, '65.50.15609524017586419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.19.104.213', '2019-06-19 21:53:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 21:53:22');
INSERT INTO `access_log` VALUES (39117, '65.49.15609524382236421', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.19.104.213', '2019-06-19 21:53:58', 61, 0, '', '2019-06-19 21:53:58');
INSERT INTO `access_log` VALUES (39118, '65.53.15609524388436405', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.19.104.213', '2019-06-19 21:53:59', 11, 0, '', '2019-06-19 21:53:59');
INSERT INTO `access_log` VALUES (39119, '65.54.15609524388436361', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.19.104.213', '2019-06-19 21:53:59', 11, 2001001000, '服务端发生异常', '2019-06-19 21:53:59');
INSERT INTO `access_log` VALUES (39120, '65.47.15609524389826401', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.19.104.213', '2019-06-19 21:53:59', 9, 0, '', '2019-06-19 21:53:59');
INSERT INTO `access_log` VALUES (39121, '59.72.15609556718945621', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:47:52', 11, 0, '', '2019-06-19 22:47:52');
INSERT INTO `access_log` VALUES (39122, '59.75.15609556718935627', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:47:52', 16, 2001001000, '服务端发生异常', '2019-06-19 22:47:52');
INSERT INTO `access_log` VALUES (39123, '59.77.15609556915465615', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:12', 3, 0, '', '2019-06-19 22:48:12');
INSERT INTO `access_log` VALUES (39124, '59.78.15609556915475625', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:12', 13, 2001001000, '服务端发生异常', '2019-06-19 22:48:12');
INSERT INTO `access_log` VALUES (39125, '64.81.15609556941395591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:14', 11, 0, '', '2019-06-19 22:48:14');
INSERT INTO `access_log` VALUES (39126, '64.78.15609556944085597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:14', 3, 0, '', '2019-06-19 22:48:14');
INSERT INTO `access_log` VALUES (39127, '64.82.15609556959705603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:16', 2, 0, '', '2019-06-19 22:48:16');
INSERT INTO `access_log` VALUES (39128, '64.85.15609556968485607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:17', 2, 0, '', '2019-06-19 22:48:17');
INSERT INTO `access_log` VALUES (39129, '59.71.15609557100245625', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:30', 2, 0, '', '2019-06-19 22:48:30');
INSERT INTO `access_log` VALUES (39130, '59.74.15609557100275623', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:30', 11, 2001001000, '服务端发生异常', '2019-06-19 22:48:30');
INSERT INTO `access_log` VALUES (39131, '64.76.15609557129385581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:33', 2, 0, '', '2019-06-19 22:48:33');
INSERT INTO `access_log` VALUES (39132, '64.84.15609557131135589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:33', 2, 0, '', '2019-06-19 22:48:33');
INSERT INTO `access_log` VALUES (39133, '59.73.15609557144815631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:34', 2, 0, '', '2019-06-19 22:48:34');
INSERT INTO `access_log` VALUES (39134, '59.75.15609557144855629', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:34', 12, 2001001000, '服务端发生异常', '2019-06-19 22:48:34');
INSERT INTO `access_log` VALUES (39135, '64.80.15609557165465595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:37', 2, 0, '', '2019-06-19 22:48:37');
INSERT INTO `access_log` VALUES (39136, '64.83.15609557166795585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:37', 2, 0, '', '2019-06-19 22:48:37');
INSERT INTO `access_log` VALUES (39137, '59.72.15609557176185623', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:38', 3, 0, '', '2019-06-19 22:48:38');
INSERT INTO `access_log` VALUES (39138, '59.80.15609557176205615', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:38', 12, 2001001000, '服务端发生异常', '2019-06-19 22:48:38');
INSERT INTO `access_log` VALUES (39139, '64.81.15609557216135593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:42', 3, 0, '', '2019-06-19 22:48:42');
INSERT INTO `access_log` VALUES (39140, '64.78.15609557217785599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:42', 1, 0, '', '2019-06-19 22:48:42');
INSERT INTO `access_log` VALUES (39141, '59.78.15609557226995627', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:43', 2, 0, '', '2019-06-19 22:48:43');
INSERT INTO `access_log` VALUES (39142, '59.77.15609557227025617', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; COR-AL10 Build/HUAWEICOR-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Mobile Safari/537.36', '120.228.92.170', '2019-06-19 22:48:43', 18, 2001001000, '服务端发生异常', '2019-06-19 22:48:43');
INSERT INTO `access_log` VALUES (39143, '59.80.15609570192825633', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.169.163', '2019-06-19 23:10:19', 3, 0, '', '2019-06-19 23:10:19');
INSERT INTO `access_log` VALUES (39144, '59.78.15609570192855645', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.169.163', '2019-06-19 23:10:19', 13, 2001001000, '服务端发生异常', '2019-06-19 23:10:19');
INSERT INTO `access_log` VALUES (39145, '65.49.15609570306136483', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.169.163', '2019-06-19 23:10:31', 1, 1002001015, '账号未登陆', '2019-06-19 23:10:31');
INSERT INTO `access_log` VALUES (39146, '65.53.15609570306136467', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.169.163', '2019-06-19 23:10:31', 0, 1002001015, '账号未登陆', '2019-06-19 23:10:31');
INSERT INTO `access_log` VALUES (39147, '65.54.15609570306376423', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.169.163', '2019-06-19 23:10:31', 0, 1002001015, '账号未登陆', '2019-06-19 23:10:31');
INSERT INTO `access_log` VALUES (39148, '65.47.15609570325226463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.169.163', '2019-06-19 23:10:33', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-19 23:10:33');
INSERT INTO `access_log` VALUES (39149, '65.52.15609570514036485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.169.163', '2019-06-19 23:10:51', 68, 0, '', '2019-06-19 23:10:51');
INSERT INTO `access_log` VALUES (39150, '65.3607.15609570518828231', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.169.163', '2019-06-19 23:10:52', 10, 0, '', '2019-06-19 23:10:52');
INSERT INTO `access_log` VALUES (39151, '65.50.15609570518806483', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.169.163', '2019-06-19 23:10:52', 13, 0, '', '2019-06-19 23:10:52');
INSERT INTO `access_log` VALUES (39152, '65.51.15609570518826493', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.169.163', '2019-06-19 23:10:52', 13, 2001001000, '服务端发生异常', '2019-06-19 23:10:52');
INSERT INTO `access_log` VALUES (39153, '59.78.15609580600495659', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:40', 3, 0, '', '2019-06-19 23:27:40');
INSERT INTO `access_log` VALUES (39154, '59.77.15609580600515649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:40', 13, 2001001000, '服务端发生异常', '2019-06-19 23:27:40');
INSERT INTO `access_log` VALUES (39155, '64.80.15609580632195627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:43', 10, 0, '', '2019-06-19 23:27:43');
INSERT INTO `access_log` VALUES (39156, '64.83.15609580633935617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:43', 3, 0, '', '2019-06-19 23:27:43');
INSERT INTO `access_log` VALUES (39157, '64.81.15609580648975625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:45', 2, 0, '', '2019-06-19 23:27:45');
INSERT INTO `access_log` VALUES (39158, '64.78.15609580656325631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:46', 2, 0, '', '2019-06-19 23:27:46');
INSERT INTO `access_log` VALUES (39159, '64.82.15609580668645637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:47', 2, 0, '', '2019-06-19 23:27:47');
INSERT INTO `access_log` VALUES (39160, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:47', 7, 0, '', '2019-06-19 23:27:47');
INSERT INTO `access_log` VALUES (39161, '64.85.15609580684235641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:48', 1, 0, '', '2019-06-19 23:27:48');
INSERT INTO `access_log` VALUES (39162, '64.79.15609580687455625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:49', 2, 0, '', '2019-06-19 23:27:49');
INSERT INTO `access_log` VALUES (39163, '59.74.15609580695455657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:50', 2, 0, '', '2019-06-19 23:27:50');
INSERT INTO `access_log` VALUES (39164, '59.71.15609580695455659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:50', 12, 2001001000, '服务端发生异常', '2019-06-19 23:27:50');
INSERT INTO `access_log` VALUES (39165, '59.76.15609580728905655', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:53', 2, 0, '', '2019-06-19 23:27:53');
INSERT INTO `access_log` VALUES (39166, '59.73.15609580728915665', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:53', 13, 2001001000, '服务端发生异常', '2019-06-19 23:27:53');
INSERT INTO `access_log` VALUES (39167, '59.75.15609580771005663', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:57', 2, 0, '', '2019-06-19 23:27:57');
INSERT INTO `access_log` VALUES (39168, '59.72.15609580771005657', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:57', 12, 2001001000, '服务端发生异常', '2019-06-19 23:27:57');
INSERT INTO `access_log` VALUES (39169, '64.84.15609580779375623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:58', 2, 0, '', '2019-06-19 23:27:58');
INSERT INTO `access_log` VALUES (39170, '64.77.15609580780515629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:58', 2, 0, '', '2019-06-19 23:27:58');
INSERT INTO `access_log` VALUES (39171, '59.78.15609580790525661', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:59', 3, 0, '', '2019-06-19 23:27:59');
INSERT INTO `access_log` VALUES (39172, '59.80.15609580790525649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; MZ-M1852 Build/MRA58K) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 MZBrowser/7.12.0 UWS/2.15.0.4 Mobile Safari/537.36', '119.36.54.13', '2019-06-19 23:27:59', 13, 2001001000, '服务端发生异常', '2019-06-19 23:27:59');
INSERT INTO `access_log` VALUES (39173, '59.76.15609624955135715', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:41:36', 17, 0, '', '2019-06-20 00:41:36');
INSERT INTO `access_log` VALUES (39174, '59.72.15609624955145717', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:41:36', 22, 2001001000, '服务端发生异常', '2019-06-20 00:41:36');
INSERT INTO `access_log` VALUES (39175, '64.76.15609625396125675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:20', 11, 0, '', '2019-06-20 00:42:20');
INSERT INTO `access_log` VALUES (39176, '64.84.15609625397215683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:20', 2, 0, '', '2019-06-20 00:42:20');
INSERT INTO `access_log` VALUES (39177, '64.80.15609625410995689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:21', 1, 0, '', '2019-06-20 00:42:21');
INSERT INTO `access_log` VALUES (39178, '64.83.15609625416855679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:22', 1, 0, '', '2019-06-20 00:42:22');
INSERT INTO `access_log` VALUES (39179, '59.77.15609625422915711', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:22', 4, 0, '', '2019-06-20 00:42:22');
INSERT INTO `access_log` VALUES (39180, '59.79.15609625422915727', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:22', 20, 2001001000, '服务端发生异常', '2019-06-20 00:42:22');
INSERT INTO `access_log` VALUES (39181, '64.81.15609625439195687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:24', 2, 0, '', '2019-06-20 00:42:24');
INSERT INTO `access_log` VALUES (39182, '64.78.15609625441195693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:24', 2, 0, '', '2019-06-20 00:42:24');
INSERT INTO `access_log` VALUES (39183, '64.82.15609625449835699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:25', 2, 0, '', '2019-06-20 00:42:25');
INSERT INTO `access_log` VALUES (39184, '64.85.15609625452715703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:25', 2, 0, '', '2019-06-20 00:42:25');
INSERT INTO `access_log` VALUES (39185, '59.71.15609625453035721', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:25', 2, 0, '', '2019-06-20 00:42:25');
INSERT INTO `access_log` VALUES (39186, '59.74.15609625453365719', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:25', 14, 2001001000, '服务端发生异常', '2019-06-20 00:42:25');
INSERT INTO `access_log` VALUES (39187, '64.79.15609625481055687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:28', 2, 0, '', '2019-06-20 00:42:28');
INSERT INTO `access_log` VALUES (39188, '64.76.15609625482975677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:28', 1, 0, '', '2019-06-20 00:42:28');
INSERT INTO `access_log` VALUES (39189, '64.77.15609625600565691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:40', 2, 0, '', '2019-06-20 00:42:40');
INSERT INTO `access_log` VALUES (39190, '64.80.15609625602365691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.63.119.50', '2019-06-20 00:42:40', 2, 0, '', '2019-06-20 00:42:40');
INSERT INTO `access_log` VALUES (39191, '59.72.15609678275695789', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.129.112.46', '2019-06-20 02:10:28', 18, 0, '', '2019-06-20 02:10:28');
INSERT INTO `access_log` VALUES (39192, '59.75.15609678275695795', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.129.112.46', '2019-06-20 02:10:28', 21, 2001001000, '服务端发生异常', '2019-06-20 02:10:28');
INSERT INTO `access_log` VALUES (39193, '64.81.15609678311405759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.129.112.46', '2019-06-20 02:10:31', 123, 0, '', '2019-06-20 02:10:31');
INSERT INTO `access_log` VALUES (39194, '64.78.15609678314145765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.129.112.46', '2019-06-20 02:10:31', 4, 0, '', '2019-06-20 02:10:31');
INSERT INTO `access_log` VALUES (39195, '64.82.15609678328135771', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.129.112.46', '2019-06-20 02:10:33', 3, 0, '', '2019-06-20 02:10:33');
INSERT INTO `access_log` VALUES (39196, '64.85.15609678332625775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.129.112.46', '2019-06-20 02:10:33', 2, 0, '', '2019-06-20 02:10:33');
INSERT INTO `access_log` VALUES (39197, '64.76.15609678355685749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.129.112.46', '2019-06-20 02:10:36', 2, 0, '', '2019-06-20 02:10:36');
INSERT INTO `access_log` VALUES (39198, '64.84.15609678357295757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.129.112.46', '2019-06-20 02:10:36', 2, 0, '', '2019-06-20 02:10:36');
INSERT INTO `access_log` VALUES (39199, '59.78.15609678383915793', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.129.112.46', '2019-06-20 02:10:38', 4, 0, '', '2019-06-20 02:10:38');
INSERT INTO `access_log` VALUES (39200, '59.79.15609678383925799', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.129.112.46', '2019-06-20 02:10:38', 14, 2001001000, '服务端发生异常', '2019-06-20 02:10:38');
INSERT INTO `access_log` VALUES (39201, '59.76.15609678912055789', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '120.204.17.70', '2019-06-20 02:11:31', 3, 0, '', '2019-06-20 02:11:31');
INSERT INTO `access_log` VALUES (39202, '59.73.15609678911985799', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '183.192.164.85', '2019-06-20 02:11:31', 14, 2001001000, '服务端发生异常', '2019-06-20 02:11:31');
INSERT INTO `access_log` VALUES (39203, '64.81.15609678921825761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '120.204.17.71', '2019-06-20 02:11:32', 2, 0, '', '2019-06-20 02:11:32');
INSERT INTO `access_log` VALUES (39204, '64.78.15609678930455767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '120.204.17.73', '2019-06-20 02:11:33', 1, 0, '', '2019-06-20 02:11:33');
INSERT INTO `access_log` VALUES (39205, '64.82.15609678931115773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '183.192.164.56', '2019-06-20 02:11:33', 2, 0, '', '2019-06-20 02:11:33');
INSERT INTO `access_log` VALUES (39206, '64.85.15609678931125777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '183.192.164.56', '2019-06-20 02:11:33', 3, 0, '', '2019-06-20 02:11:33');
INSERT INTO `access_log` VALUES (39207, '59.73.15609879506506067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'xiaomiquan/4.1.1 iOS/phone/11.3.1', '223.104.147.52', '2019-06-20 07:45:51', 26, 2001001000, '服务端发生异常', '2019-06-20 07:45:51');
INSERT INTO `access_log` VALUES (39208, '59.76.15609879506696057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'xiaomiquan/4.1.1 iOS/phone/11.3.1', '223.104.147.52', '2019-06-20 07:45:51', 14, 0, '', '2019-06-20 07:45:51');
INSERT INTO `access_log` VALUES (39209, '64.82.15609879559506041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'xiaomiquan/4.1.1 iOS/phone/11.3.1', '223.104.147.52', '2019-06-20 07:45:56', 12, 0, '', '2019-06-20 07:45:56');
INSERT INTO `access_log` VALUES (39210, '64.85.15609879561056045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'xiaomiquan/4.1.1 iOS/phone/11.3.1', '223.104.147.52', '2019-06-20 07:45:56', 3, 0, '', '2019-06-20 07:45:56');
INSERT INTO `access_log` VALUES (39211, '66.51.15609879686804411', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18761424986', 'POST', 'xiaomiquan/4.1.1 iOS/phone/11.3.1', '223.104.147.52', '2019-06-20 07:46:09', 83, 0, '', '2019-06-20 07:46:09');
INSERT INTO `access_log` VALUES (39212, '66.56.15609879747244405', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18761424986&code=9999', 'POST', 'xiaomiquan/4.1.1 iOS/phone/11.3.1', '223.104.147.52', '2019-06-20 07:46:15', 187, 0, '', '2019-06-20 07:46:15');
INSERT INTO `access_log` VALUES (39213, '59.76.15609905106846093', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:28:31', 11, 0, '', '2019-06-20 08:28:31');
INSERT INTO `access_log` VALUES (39214, '59.73.15609905107156103', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:28:31', 16, 2001001000, '服务端发生异常', '2019-06-20 08:28:31');
INSERT INTO `access_log` VALUES (39215, '64.81.15609905292446065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:28:49', 12, 0, '', '2019-06-20 08:28:49');
INSERT INTO `access_log` VALUES (39216, '64.78.15609905294046071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:28:49', 3, 0, '', '2019-06-20 08:28:49');
INSERT INTO `access_log` VALUES (39217, '64.85.15609905336046081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:28:54', 2, 0, '', '2019-06-20 08:28:54');
INSERT INTO `access_log` VALUES (39218, '64.79.15609905363326065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:28:56', 1, 0, '', '2019-06-20 08:28:56');
INSERT INTO `access_log` VALUES (39219, '64.76.15609905383776055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:28:58', 2, 0, '', '2019-06-20 08:28:58');
INSERT INTO `access_log` VALUES (39220, '64.84.15609905396946063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:00', 2, 0, '', '2019-06-20 08:29:00');
INSERT INTO `access_log` VALUES (39221, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:00', 5, 0, '', '2019-06-20 08:29:00');
INSERT INTO `access_log` VALUES (39222, '64.77.15609905420536069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:02', 2, 0, '', '2019-06-20 08:29:02');
INSERT INTO `access_log` VALUES (39223, '64.80.15609905422456069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:02', 2, 0, '', '2019-06-20 08:29:02');
INSERT INTO `access_log` VALUES (39224, '64.83.15609905433656059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:03', 2, 0, '', '2019-06-20 08:29:03');
INSERT INTO `access_log` VALUES (39225, '64.81.15609905444456067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:04', 2, 0, '', '2019-06-20 08:29:04');
INSERT INTO `access_log` VALUES (39226, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:04', 7, 0, '', '2019-06-20 08:29:04');
INSERT INTO `access_log` VALUES (39227, '64.85.15609905608936083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:21', 2, 0, '', '2019-06-20 08:29:21');
INSERT INTO `access_log` VALUES (39228, '64.79.15609905610736067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:21', 2, 0, '', '2019-06-20 08:29:21');
INSERT INTO `access_log` VALUES (39229, '59.79.15609905629006105', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:23', 3, 0, '', '2019-06-20 08:29:23');
INSERT INTO `access_log` VALUES (39230, '59.77.15609905629526089', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:23', 21, 2001001000, '服务端发生异常', '2019-06-20 08:29:23');
INSERT INTO `access_log` VALUES (39231, '65.52.15609905742066931', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:34', 0, 1002001015, '账号未登陆', '2019-06-20 08:29:34');
INSERT INTO `access_log` VALUES (39232, '65.50.15609905742076931', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:34', 0, 1002001015, '账号未登陆', '2019-06-20 08:29:34');
INSERT INTO `access_log` VALUES (39233, '65.3607.15609905742288679', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:34', 1, 1002001015, '账号未登陆', '2019-06-20 08:29:34');
INSERT INTO `access_log` VALUES (39234, '65.51.15609905772576941', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '122.96.40.63', '2019-06-20 08:29:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 08:29:37');
INSERT INTO `access_log` VALUES (39235, '65.3607.15609908108448683', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2S) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '120.229.45.91', '2019-06-20 08:33:31', 1, 1002001015, '账号未登陆', '2019-06-20 08:33:31');
INSERT INTO `access_log` VALUES (39236, '65.52.15609908108446935', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2S) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '120.229.45.91', '2019-06-20 08:33:31', 1, 1002001015, '账号未登陆', '2019-06-20 08:33:31');
INSERT INTO `access_log` VALUES (39237, '65.50.15609908108446935', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2S) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '120.229.45.91', '2019-06-20 08:33:31', 0, 1002001015, '账号未登陆', '2019-06-20 08:33:31');
INSERT INTO `access_log` VALUES (39238, '65.51.15609908137446945', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; MIX 2S) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '120.229.45.91', '2019-06-20 08:33:34', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 08:33:34');
INSERT INTO `access_log` VALUES (39239, '65.53.15609908319316921', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; MIX 2S) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '120.229.45.91', '2019-06-20 08:33:52', 84, 0, '', '2019-06-20 08:33:52');
INSERT INTO `access_log` VALUES (39240, '65.49.15609908323316937', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2S) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '120.229.45.91', '2019-06-20 08:33:52', 11, 0, '', '2019-06-20 08:33:52');
INSERT INTO `access_log` VALUES (39241, '65.54.15609908323336877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2S) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '120.229.45.91', '2019-06-20 08:33:52', 12, 2001001000, '服务端发生异常', '2019-06-20 08:33:52');
INSERT INTO `access_log` VALUES (39242, '65.47.15609908323376917', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2S) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.136 Mobile Safari/537.36', '120.229.45.91', '2019-06-20 08:33:52', 10, 0, '', '2019-06-20 08:33:52');
INSERT INTO `access_log` VALUES (39243, '65.49.15609915543846949', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:45:54', 0, 1002001015, '账号未登陆', '2019-06-20 08:45:54');
INSERT INTO `access_log` VALUES (39244, '65.47.15609915543896927', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:45:54', 0, 1002001015, '账号未登陆', '2019-06-20 08:45:54');
INSERT INTO `access_log` VALUES (39245, '65.54.15609915543926889', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:45:54', 1, 1002001015, '账号未登陆', '2019-06-20 08:45:54');
INSERT INTO `access_log` VALUES (39246, '65.45.15609915567946929', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:45:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 08:45:57');
INSERT INTO `access_log` VALUES (39247, '65.52.15609915606436947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:46:01', 55, 0, '', '2019-06-20 08:46:01');
INSERT INTO `access_log` VALUES (39248, '65.50.15609915610186947', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:46:01', 9, 0, '', '2019-06-20 08:46:01');
INSERT INTO `access_log` VALUES (39249, '65.3607.15609915610208697', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:46:01', 9, 2001001000, '服务端发生异常', '2019-06-20 08:46:01');
INSERT INTO `access_log` VALUES (39250, '65.53.15609915610236931', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:46:01', 9, 0, '', '2019-06-20 08:46:01');
INSERT INTO `access_log` VALUES (39251, '65.51.15609915680046959', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:46:08', 9, 0, '', '2019-06-20 08:46:08');
INSERT INTO `access_log` VALUES (39252, '65.46.15609915680096963', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:46:08', 10, 2001001000, '服务端发生异常', '2019-06-20 08:46:08');
INSERT INTO `access_log` VALUES (39253, '65.47.15609915680106929', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:46:08', 9, 0, '', '2019-06-20 08:46:08');
INSERT INTO `access_log` VALUES (39254, '65.49.15609915697806951', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '120.229.45.91', '2019-06-20 08:46:10', 1, 1002001015, '账号未登陆', '2019-06-20 08:46:10');
INSERT INTO `access_log` VALUES (39255, '65.45.15609915697826931', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '120.229.45.91', '2019-06-20 08:46:10', 0, 1002001015, '账号未登陆', '2019-06-20 08:46:10');
INSERT INTO `access_log` VALUES (39256, '65.52.15609915697866949', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '120.229.45.91', '2019-06-20 08:46:10', 1, 1002001015, '账号未登陆', '2019-06-20 08:46:10');
INSERT INTO `access_log` VALUES (39257, '65.53.15609915735856933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '120.229.45.91', '2019-06-20 08:46:14', 96, 0, '', '2019-06-20 08:46:14');
INSERT INTO `access_log` VALUES (39258, '65.50.15609915739386949', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '120.229.45.91', '2019-06-20 08:46:14', 9, 0, '', '2019-06-20 08:46:14');
INSERT INTO `access_log` VALUES (39259, '65.3607.15609915739388699', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '120.229.45.91', '2019-06-20 08:46:14', 11, 2001001000, '服务端发生异常', '2019-06-20 08:46:14');
INSERT INTO `access_log` VALUES (39260, '65.46.15609915739416965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '120.229.45.91', '2019-06-20 08:46:14', 10, 0, '', '2019-06-20 08:46:14');
INSERT INTO `access_log` VALUES (39261, '65.51.15609915816946961', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:46:22', 80, 0, '', '2019-06-20 08:46:22');
INSERT INTO `access_log` VALUES (39262, '65.47.15609915821086931', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:46:22', 9, 0, '', '2019-06-20 08:46:22');
INSERT INTO `access_log` VALUES (39263, '65.54.15609915821096893', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:46:22', 9, 2001001000, '服务端发生异常', '2019-06-20 08:46:22');
INSERT INTO `access_log` VALUES (39264, '65.52.15609915821116951', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:46:22', 8, 0, '', '2019-06-20 08:46:22');
INSERT INTO `access_log` VALUES (39265, '65.50.15609916474146951', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '110.184.10.207', '2019-06-20 08:47:27', 1, 1002001015, '账号未登陆', '2019-06-20 08:47:27');
INSERT INTO `access_log` VALUES (39266, '65.51.15609916474146963', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '110.184.10.207', '2019-06-20 08:47:27', 1, 1002001015, '账号未登陆', '2019-06-20 08:47:27');
INSERT INTO `access_log` VALUES (39267, '65.54.15609916474216895', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '110.184.10.207', '2019-06-20 08:47:27', 1, 1002001015, '账号未登陆', '2019-06-20 08:47:27');
INSERT INTO `access_log` VALUES (39268, '65.52.15609916511596953', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '110.184.10.207', '2019-06-20 08:47:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 08:47:31');
INSERT INTO `access_log` VALUES (39269, '65.45.15609916659736935', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '110.184.10.207', '2019-06-20 08:47:46', 81, 0, '', '2019-06-20 08:47:46');
INSERT INTO `access_log` VALUES (39270, '65.53.15609916663546937', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '110.184.10.207', '2019-06-20 08:47:46', 9, 2001001000, '服务端发生异常', '2019-06-20 08:47:46');
INSERT INTO `access_log` VALUES (39271, '65.46.15609916663576969', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '110.184.10.207', '2019-06-20 08:47:46', 8, 0, '', '2019-06-20 08:47:46');
INSERT INTO `access_log` VALUES (39272, '65.49.15609916663506955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '110.184.10.207', '2019-06-20 08:47:46', 455, 0, '', '2019-06-20 08:47:47');
INSERT INTO `access_log` VALUES (39273, '65.53.15609917819436939', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '110.184.10.207', '2019-06-20 08:49:42', 10, 0, '', '2019-06-20 08:49:42');
INSERT INTO `access_log` VALUES (39274, '65.49.15609917819456957', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '110.184.10.207', '2019-06-20 08:49:42', 10, 2001001000, '服务端发生异常', '2019-06-20 08:49:42');
INSERT INTO `access_log` VALUES (39275, '65.3607.15609917819568705', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '110.184.10.207', '2019-06-20 08:49:42', 9, 0, '', '2019-06-20 08:49:42');
INSERT INTO `access_log` VALUES (39276, '65.45.15609918656766939', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:51:06', 9, 0, '', '2019-06-20 08:51:06');
INSERT INTO `access_log` VALUES (39277, '65.46.15609918656776973', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:51:06', 11, 2001001000, '服务端发生异常', '2019-06-20 08:51:06');
INSERT INTO `access_log` VALUES (39278, '65.53.15609918656796941', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.63', '2019-06-20 08:51:06', 9, 0, '', '2019-06-20 08:51:06');
INSERT INTO `access_log` VALUES (39279, '65.45.15609922920296945', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.197.174.169', '2019-06-20 08:58:12', 1, 1002001015, '账号未登陆', '2019-06-20 08:58:12');
INSERT INTO `access_log` VALUES (39280, '65.3607.15609922920498713', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.197.174.169', '2019-06-20 08:58:12', 1, 1002001015, '账号未登陆', '2019-06-20 08:58:12');
INSERT INTO `access_log` VALUES (39281, '65.49.15609922920686965', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.197.174.169', '2019-06-20 08:58:12', 1, 1002001015, '账号未登陆', '2019-06-20 08:58:12');
INSERT INTO `access_log` VALUES (39282, '65.54.15609923266806907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.197.174.169', '2019-06-20 08:58:47', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 08:58:47');
INSERT INTO `access_log` VALUES (39283, '65.52.15609923324556965', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.197.174.169', '2019-06-20 08:58:52', 101, 0, '', '2019-06-20 08:58:53');
INSERT INTO `access_log` VALUES (39284, '65.47.15609923332186945', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.197.174.169', '2019-06-20 08:58:53', 8, 0, '', '2019-06-20 08:58:53');
INSERT INTO `access_log` VALUES (39285, '65.46.15609923332436981', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.197.174.169', '2019-06-20 08:58:53', 9, 2001001000, '服务端发生异常', '2019-06-20 08:58:53');
INSERT INTO `access_log` VALUES (39286, '65.53.15609923332726949', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.197.174.169', '2019-06-20 08:58:53', 8, 0, '', '2019-06-20 08:58:53');
INSERT INTO `access_log` VALUES (39287, '65.45.15609923443726947', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.197.174.169', '2019-06-20 08:59:04', 9, 0, '', '2019-06-20 08:59:04');
INSERT INTO `access_log` VALUES (39288, '65.49.15609923443796967', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.197.174.169', '2019-06-20 08:59:04', 9, 2001001000, '服务端发生异常', '2019-06-20 08:59:04');
INSERT INTO `access_log` VALUES (39289, '65.50.15609923444016965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.197.174.169', '2019-06-20 08:59:04', 9, 0, '', '2019-06-20 08:59:04');
INSERT INTO `access_log` VALUES (39290, '65.52.15609926534166971', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:04:13', 0, 1002001015, '账号未登陆', '2019-06-20 09:04:13');
INSERT INTO `access_log` VALUES (39291, '65.54.15609926534166913', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:04:13', 1, 1002001015, '账号未登陆', '2019-06-20 09:04:13');
INSERT INTO `access_log` VALUES (39292, '65.46.15609926534216987', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:04:13', 0, 1002001015, '账号未登陆', '2019-06-20 09:04:13');
INSERT INTO `access_log` VALUES (39293, '65.47.15609926551396951', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:04:15', 20, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 09:04:15');
INSERT INTO `access_log` VALUES (39294, '65.53.15609926624576955', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:04:22', 81, 0, '', '2019-06-20 09:04:23');
INSERT INTO `access_log` VALUES (39295, '65.3607.15609926627558721', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:04:23', 55, 0, '', '2019-06-20 09:04:23');
INSERT INTO `access_log` VALUES (39296, '65.45.15609926627606953', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:04:23', 50, 0, '', '2019-06-20 09:04:23');
INSERT INTO `access_log` VALUES (39297, '65.49.15609926627576973', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:04:23', 66, 2001001000, '服务端发生异常', '2019-06-20 09:04:23');
INSERT INTO `access_log` VALUES (39298, '65.46.15609926806016989', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:04:41', 9, 0, '', '2019-06-20 09:04:41');
INSERT INTO `access_log` VALUES (39299, '65.54.15609926806036915', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:04:41', 8, 0, '', '2019-06-20 09:04:41');
INSERT INTO `access_log` VALUES (39300, '65.52.15609926806036973', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:04:41', 10, 2001001000, '服务端发生异常', '2019-06-20 09:04:41');
INSERT INTO `access_log` VALUES (39301, '65.47.15609926875396953', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:04:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 09:04:48');
INSERT INTO `access_log` VALUES (39302, '65.53.15609926892516957', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:04:49', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 09:04:49');
INSERT INTO `access_log` VALUES (39303, '65.49.15609926903066975', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:04:50', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 09:04:50');
INSERT INTO `access_log` VALUES (39304, '59.72.15609927065176125', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:05:07', 51, 2001001000, '服务端发生异常', '2019-06-20 09:05:07');
INSERT INTO `access_log` VALUES (39305, '59.72.15609927065176125', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:05:07', 51, 2001001000, '服务端发生异常', '2019-06-20 09:05:08');
INSERT INTO `access_log` VALUES (39306, '59.73.15609927065136133', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:05:07', 1301, 0, '', '2019-06-20 09:05:08');
INSERT INTO `access_log` VALUES (39307, '59.80.15609927180876117', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:05:18', 2, 0, '', '2019-06-20 09:05:18');
INSERT INTO `access_log` VALUES (39308, '59.75.15609927180866131', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.254.68.219', '2019-06-20 09:05:18', 20, 2001001000, '服务端发生异常', '2019-06-20 09:05:18');
INSERT INTO `access_log` VALUES (39309, '59.79.15609928794236137', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:07:59', 6, 0, '', '2019-06-20 09:07:59');
INSERT INTO `access_log` VALUES (39310, '59.77.15609928794246121', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:07:59', 17, 2001001000, '服务端发生异常', '2019-06-20 09:07:59');
INSERT INTO `access_log` VALUES (39311, '65.51.15609928822556987', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:02', 1, 1002001015, '账号未登陆', '2019-06-20 09:08:02');
INSERT INTO `access_log` VALUES (39312, '65.52.15609928822556977', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:02', 0, 1002001015, '账号未登陆', '2019-06-20 09:08:02');
INSERT INTO `access_log` VALUES (39313, '65.54.15609928822556919', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:02', 0, 1002001015, '账号未登陆', '2019-06-20 09:08:02');
INSERT INTO `access_log` VALUES (39314, '65.46.15609928849726993', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 09:08:05');
INSERT INTO `access_log` VALUES (39315, '65.47.15609928854476957', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:05', 1, 1002001015, '账号未登陆', '2019-06-20 09:08:05');
INSERT INTO `access_log` VALUES (39316, '65.53.15609928854496961', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:05', 1, 1002001015, '账号未登陆', '2019-06-20 09:08:05');
INSERT INTO `access_log` VALUES (39317, '65.49.15609928854516979', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:05', 0, 1002001015, '账号未登陆', '2019-06-20 09:08:05');
INSERT INTO `access_log` VALUES (39318, '65.45.15609928885626959', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 09:08:09');
INSERT INTO `access_log` VALUES (39319, '65.50.15609928927426977', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:13', 58, 0, '', '2019-06-20 09:08:13');
INSERT INTO `access_log` VALUES (39320, '65.52.15609928929716979', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:13', 9, 0, '', '2019-06-20 09:08:13');
INSERT INTO `access_log` VALUES (39321, '65.51.15609928929736989', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:13', 9, 0, '', '2019-06-20 09:08:13');
INSERT INTO `access_log` VALUES (39322, '65.54.15609928929766921', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:13', 10, 0, '', '2019-06-20 09:08:13');
INSERT INTO `access_log` VALUES (39323, '64.80.15609928976226103', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:18', 19, 0, '', '2019-06-20 09:08:18');
INSERT INTO `access_log` VALUES (39324, '64.83.15609928976226093', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:18', 30, 0, '', '2019-06-20 09:08:18');
INSERT INTO `access_log` VALUES (39325, '65.46.15609929006516995', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:21', 3, 1002002000, '账号不存在', '2019-06-20 09:08:21');
INSERT INTO `access_log` VALUES (39326, '64.82.15609929013936113', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:21', 19, 0, '', '2019-06-20 09:08:21');
INSERT INTO `access_log` VALUES (39327, '64.78.15609929013916105', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:21', 22, 0, '', '2019-06-20 09:08:21');
INSERT INTO `access_log` VALUES (39328, '59.72.15609929170896129', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:37', 2, 0, '', '2019-06-20 09:08:37');
INSERT INTO `access_log` VALUES (39329, '59.73.15609929170986137', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:37', 10, 2001001000, '服务端发生异常', '2019-06-20 09:08:37');
INSERT INTO `access_log` VALUES (39330, '64.85.15609929179306117', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:38', 9, 0, '', '2019-06-20 09:08:38');
INSERT INTO `access_log` VALUES (39331, '59.75.15609929216256135', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:42', 3, 0, '', '2019-06-20 09:08:42');
INSERT INTO `access_log` VALUES (39332, '59.80.15609929216256121', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:42', 56, 2001001000, '服务端发生异常', '2019-06-20 09:08:42');
INSERT INTO `access_log` VALUES (39333, '64.84.15609929241096097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:44', 2, 0, '', '2019-06-20 09:08:44');
INSERT INTO `access_log` VALUES (39334, '64.76.15609929242816089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:44', 1, 0, '', '2019-06-20 09:08:44');
INSERT INTO `access_log` VALUES (39335, '64.80.15609929245396105', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:45', 9, 0, '', '2019-06-20 09:08:45');
INSERT INTO `access_log` VALUES (39336, '64.77.15609929245396103', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:45', 12, 0, '', '2019-06-20 09:08:45');
INSERT INTO `access_log` VALUES (39337, '64.83.15609929261896095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:46', 2, 0, '', '2019-06-20 09:08:46');
INSERT INTO `access_log` VALUES (39338, '64.78.15609929263376107', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:46', 8, 0, '', '2019-06-20 09:08:46');
INSERT INTO `access_log` VALUES (39339, '64.82.15609929263356115', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:46', 11, 0, '', '2019-06-20 09:08:46');
INSERT INTO `access_log` VALUES (39340, '64.81.15609929263346101', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:08:46', 13, 0, '', '2019-06-20 09:08:46');
INSERT INTO `access_log` VALUES (39341, '64.79.15609929272196103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:47', 4, 0, '', '2019-06-20 09:08:47');
INSERT INTO `access_log` VALUES (39342, '64.85.15609929296496119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:50', 3, 0, '', '2019-06-20 09:08:50');
INSERT INTO `access_log` VALUES (39343, '64.84.15609929304816099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:50', 2, 0, '', '2019-06-20 09:08:50');
INSERT INTO `access_log` VALUES (39344, '64.80.15609929312896107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:51', 2, 0, '', '2019-06-20 09:08:51');
INSERT INTO `access_log` VALUES (39345, '64.77.15609929321906105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:52', 2, 0, '', '2019-06-20 09:08:52');
INSERT INTO `access_log` VALUES (39346, '64.83.15609929326696097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:53', 2, 0, '', '2019-06-20 09:08:53');
INSERT INTO `access_log` VALUES (39347, '64.82.15609929381396117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:58', 1, 0, '', '2019-06-20 09:08:58');
INSERT INTO `access_log` VALUES (39348, '64.81.15609929383476103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:08:58', 1, 0, '', '2019-06-20 09:08:58');
INSERT INTO `access_log` VALUES (39349, '59.77.15609929509936123', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:09:11', 2, 0, '', '2019-06-20 09:09:11');
INSERT INTO `access_log` VALUES (39350, '59.71.15609929509946133', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:09:11', 13, 2001001000, '服务端发生异常', '2019-06-20 09:09:11');
INSERT INTO `access_log` VALUES (39351, '64.85.15609929606806121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:09:21', 2, 0, '', '2019-06-20 09:09:21');
INSERT INTO `access_log` VALUES (39352, '64.76.15609929608046093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:09:21', 1, 0, '', '2019-06-20 09:09:21');
INSERT INTO `access_log` VALUES (39353, '64.84.15609929621926101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:09:22', 2, 0, '', '2019-06-20 09:09:22');
INSERT INTO `access_log` VALUES (39354, '64.80.15609929638396109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:09:24', 2, 0, '', '2019-06-20 09:09:24');
INSERT INTO `access_log` VALUES (39355, '64.77.15609929639636107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:09:24', 2, 0, '', '2019-06-20 09:09:24');
INSERT INTO `access_log` VALUES (39356, '64.83.15609929641526099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:09:24', 2, 0, '', '2019-06-20 09:09:24');
INSERT INTO `access_log` VALUES (39357, '59.76.15609929669846129', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:09:27', 2, 0, '', '2019-06-20 09:09:27');
INSERT INTO `access_log` VALUES (39358, '59.72.15609929669926131', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; SAMSUNG SM-G9500 Build/R16NW) AppleWebKit/537.36 (KHTML, like Gecko) SamsungBrowser/9.3 Chrome/67.0.3396.87 Mobile Safari/537.36', '106.121.140.25', '2019-06-20 09:09:27', 13, 2001001000, '服务端发生异常', '2019-06-20 09:09:27');
INSERT INTO `access_log` VALUES (39359, '65.45.15609930947266963', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.94', '2019-06-20 09:11:35', 4, 1002001012, '访问令牌已过期', '2019-06-20 09:11:35');
INSERT INTO `access_log` VALUES (39360, '65.3607.15609930947358731', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.94', '2019-06-20 09:11:35', 4, 1002001012, '访问令牌已过期', '2019-06-20 09:11:35');
INSERT INTO `access_log` VALUES (39361, '65.50.15609930947426981', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.94', '2019-06-20 09:11:35', 3, 1002001012, '访问令牌已过期', '2019-06-20 09:11:35');
INSERT INTO `access_log` VALUES (39362, '65.51.15609930973756993', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.94', '2019-06-20 09:11:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 09:11:37');
INSERT INTO `access_log` VALUES (39363, '65.52.15609931050166983', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.94', '2019-06-20 09:11:45', 86, 0, '', '2019-06-20 09:11:45');
INSERT INTO `access_log` VALUES (39364, '65.46.15609931053766999', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.94', '2019-06-20 09:11:45', 19, 0, '', '2019-06-20 09:11:45');
INSERT INTO `access_log` VALUES (39365, '65.49.15609931053786985', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.94', '2019-06-20 09:11:45', 18, 0, '', '2019-06-20 09:11:45');
INSERT INTO `access_log` VALUES (39366, '65.53.15609931053786967', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.94', '2019-06-20 09:11:45', 19, 2001001000, '服务端发生异常', '2019-06-20 09:11:45');
INSERT INTO `access_log` VALUES (39367, '64.81.15609932683616109', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:14:28', 10, 0, '', '2019-06-20 09:14:28');
INSERT INTO `access_log` VALUES (39368, '64.82.15609932683616123', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:14:28', 12, 0, '', '2019-06-20 09:14:28');
INSERT INTO `access_log` VALUES (39369, '64.78.15609932727946115', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:14:33', 10, 0, '', '2019-06-20 09:14:33');
INSERT INTO `access_log` VALUES (39370, '59.78.15609932891576139', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:14:49', 13, 2001001000, '服务端发生异常', '2019-06-20 09:14:49');
INSERT INTO `access_log` VALUES (39371, '59.80.15609932891556127', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:14:49', 192, 0, '', '2019-06-20 09:14:49');
INSERT INTO `access_log` VALUES (39372, '65.50.15609932894076985', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:14:49', 0, 1002001015, '账号未登陆', '2019-06-20 09:14:49');
INSERT INTO `access_log` VALUES (39373, '65.45.15609932894116967', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:14:49', 1, 1002001015, '账号未登陆', '2019-06-20 09:14:49');
INSERT INTO `access_log` VALUES (39374, '65.51.15609932894146997', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:14:49', 0, 1002001015, '账号未登陆', '2019-06-20 09:14:49');
INSERT INTO `access_log` VALUES (39375, '65.54.15609932933016929', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:14:53', 76, 0, '', '2019-06-20 09:14:53');
INSERT INTO `access_log` VALUES (39376, '65.52.15609932935986987', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:14:54', 10, 0, '', '2019-06-20 09:14:54');
INSERT INTO `access_log` VALUES (39377, '65.49.15609932936026989', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:14:54', 9, 0, '', '2019-06-20 09:14:54');
INSERT INTO `access_log` VALUES (39378, '65.53.15609932936006971', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:14:54', 11, 2001001000, '服务端发生异常', '2019-06-20 09:14:54');
INSERT INTO `access_log` VALUES (39379, '64.84.15609933111346107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:15:11', 2, 0, '', '2019-06-20 09:15:11');
INSERT INTO `access_log` VALUES (39380, '64.80.15609933112216115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:15:11', 2, 0, '', '2019-06-20 09:15:11');
INSERT INTO `access_log` VALUES (39381, '64.77.15609933123946113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:15:12', 2, 0, '', '2019-06-20 09:15:12');
INSERT INTO `access_log` VALUES (39382, '64.83.15609933127866105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:15:13', 2, 0, '', '2019-06-20 09:15:13');
INSERT INTO `access_log` VALUES (39383, '59.77.15609933141566129', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:15:14', 2, 0, '', '2019-06-20 09:15:14');
INSERT INTO `access_log` VALUES (39384, '59.71.15609933141576139', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:15:14', 10, 2001001000, '服务端发生异常', '2019-06-20 09:15:14');
INSERT INTO `access_log` VALUES (39385, '64.81.15609933170906111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:15:17', 2, 0, '', '2019-06-20 09:15:17');
INSERT INTO `access_log` VALUES (39386, '64.82.15609933172126125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.192.5', '2019-06-20 09:15:17', 2, 0, '', '2019-06-20 09:15:17');
INSERT INTO `access_log` VALUES (39387, '64.76.15609933376116101', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:15:38', 8, 0, '', '2019-06-20 09:15:38');
INSERT INTO `access_log` VALUES (39388, '64.85.15609933376116129', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:15:38', 12, 0, '', '2019-06-20 09:15:38');
INSERT INTO `access_log` VALUES (39389, '64.77.15609933411736115', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:15:41', 7, 0, '', '2019-06-20 09:15:41');
INSERT INTO `access_log` VALUES (39390, '64.80.15609933411726117', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:15:41', 11, 0, '', '2019-06-20 09:15:41');
INSERT INTO `access_log` VALUES (39391, '64.84.15609933411716109', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.64.186.2', '2019-06-20 09:15:41', 13, 0, '', '2019-06-20 09:15:41');
INSERT INTO `access_log` VALUES (39392, '59.76.15609940888136145', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:09', 3, 0, '', '2019-06-20 09:28:09');
INSERT INTO `access_log` VALUES (39393, '59.73.15609940888146155', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:09', 14, 2001001000, '服务端发生异常', '2019-06-20 09:28:09');
INSERT INTO `access_log` VALUES (39394, '64.83.15609940937166117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:14', 4, 0, '', '2019-06-20 09:28:14');
INSERT INTO `access_log` VALUES (39395, '64.81.15609940938376123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:14', 2, 0, '', '2019-06-20 09:28:14');
INSERT INTO `access_log` VALUES (39396, '64.82.15609940965566137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:17', 2, 0, '', '2019-06-20 09:28:17');
INSERT INTO `access_log` VALUES (39397, '64.78.15609940966606129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:17', 2, 0, '', '2019-06-20 09:28:17');
INSERT INTO `access_log` VALUES (39398, '59.75.15609940970586153', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:17', 2, 0, '', '2019-06-20 09:28:17');
INSERT INTO `access_log` VALUES (39399, '59.78.15609940970596151', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:17', 12, 2001001000, '服务端发生异常', '2019-06-20 09:28:17');
INSERT INTO `access_log` VALUES (39400, '65.50.15609941043966997', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:24', 0, 1002001015, '账号未登陆', '2019-06-20 09:28:24');
INSERT INTO `access_log` VALUES (39401, '65.54.15609941043996941', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:24', 0, 1002001015, '账号未登陆', '2019-06-20 09:28:24');
INSERT INTO `access_log` VALUES (39402, '65.53.15609941044006983', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:24', 0, 1002001015, '账号未登陆', '2019-06-20 09:28:24');
INSERT INTO `access_log` VALUES (39403, '65.49.15609941060727001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 09:28:26');
INSERT INTO `access_log` VALUES (39404, '65.52.15609941098696999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 09:28:30');
INSERT INTO `access_log` VALUES (39405, '65.47.15609941214996979', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:41', 103, 0, '', '2019-06-20 09:28:42');
INSERT INTO `access_log` VALUES (39406, '65.45.15609941219516981', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:42', 56, 0, '', '2019-06-20 09:28:42');
INSERT INTO `access_log` VALUES (39407, '65.3607.15609941219518749', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:42', 57, 0, '', '2019-06-20 09:28:42');
INSERT INTO `access_log` VALUES (39408, '65.51.15609941219517011', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.139.111.18', '2019-06-20 09:28:42', 58, 2001001000, '服务端发生异常', '2019-06-20 09:28:42');
INSERT INTO `access_log` VALUES (39409, '59.78.15609946587836159', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.231.137.40', '2019-06-20 09:37:39', 3, 0, '', '2019-06-20 09:37:39');
INSERT INTO `access_log` VALUES (39410, '59.75.15609946587836161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.231.137.40', '2019-06-20 09:37:39', 27, 2001001000, '服务端发生异常', '2019-06-20 09:37:39');
INSERT INTO `access_log` VALUES (39411, '65.46.15609946702227025', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.231.137.40', '2019-06-20 09:37:50', 0, 1002001015, '账号未登陆', '2019-06-20 09:37:50');
INSERT INTO `access_log` VALUES (39412, '65.49.15609946702227009', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.231.137.40', '2019-06-20 09:37:50', 0, 1002001015, '账号未登陆', '2019-06-20 09:37:50');
INSERT INTO `access_log` VALUES (39413, '65.47.15609946702256987', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.231.137.40', '2019-06-20 09:37:50', 0, 1002001015, '账号未登陆', '2019-06-20 09:37:50');
INSERT INTO `access_log` VALUES (39414, '65.3607.15609946718398757', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.231.137.40', '2019-06-20 09:37:52', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 09:37:52');
INSERT INTO `access_log` VALUES (39415, '65.51.15609946817747021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.231.137.40', '2019-06-20 09:38:02', 78, 0, '', '2019-06-20 09:38:02');
INSERT INTO `access_log` VALUES (39416, '65.53.15609946820426995', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.231.137.40', '2019-06-20 09:38:02', 10, 0, '', '2019-06-20 09:38:02');
INSERT INTO `access_log` VALUES (39417, '65.50.15609946820467009', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.231.137.40', '2019-06-20 09:38:02', 9, 2001001000, '服务端发生异常', '2019-06-20 09:38:02');
INSERT INTO `access_log` VALUES (39418, '65.52.15609946820527009', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.231.137.40', '2019-06-20 09:38:02', 9, 0, '', '2019-06-20 09:38:02');
INSERT INTO `access_log` VALUES (39419, '59.77.15609946953706149', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.137.141.211', '2019-06-20 09:38:15', 3, 0, '', '2019-06-20 09:38:15');
INSERT INTO `access_log` VALUES (39420, '59.71.15609946953706159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '219.137.141.211', '2019-06-20 09:38:15', 64, 2001001000, '服务端发生异常', '2019-06-20 09:38:15');
INSERT INTO `access_log` VALUES (39421, '59.76.15609947168086155', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.141.211', '2019-06-20 09:38:37', 2, 0, '', '2019-06-20 09:38:37');
INSERT INTO `access_log` VALUES (39422, '59.73.15609947168096165', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.141.211', '2019-06-20 09:38:37', 14, 2001001000, '服务端发生异常', '2019-06-20 09:38:37');
INSERT INTO `access_log` VALUES (39423, '64.76.15609947299646121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.137.141.211', '2019-06-20 09:38:50', 2, 0, '', '2019-06-20 09:38:50');
INSERT INTO `access_log` VALUES (39424, '64.84.15609947301166129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.137.141.211', '2019-06-20 09:38:50', 2, 0, '', '2019-06-20 09:38:50');
INSERT INTO `access_log` VALUES (39425, '64.80.15609947321286137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.137.141.211', '2019-06-20 09:38:52', 2, 0, '', '2019-06-20 09:38:52');
INSERT INTO `access_log` VALUES (39426, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.137.141.211', '2019-06-20 09:38:52', 7, 0, '', '2019-06-20 09:38:52');
INSERT INTO `access_log` VALUES (39427, '64.83.15609947358696127', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.137.141.211', '2019-06-20 09:38:56', 8, 0, '', '2019-06-20 09:38:56');
INSERT INTO `access_log` VALUES (39428, '64.81.15609947441556133', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.137.141.211', '2019-06-20 09:39:04', 6, 0, '', '2019-06-20 09:39:04');
INSERT INTO `access_log` VALUES (39429, '65.49.15609948544137013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.161.96.198', '2019-06-20 09:40:54', 0, 1002001015, '账号未登陆', '2019-06-20 09:40:54');
INSERT INTO `access_log` VALUES (39430, '65.47.15609948544176993', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.161.96.198', '2019-06-20 09:40:54', 1, 1002001015, '账号未登陆', '2019-06-20 09:40:54');
INSERT INTO `access_log` VALUES (39431, '65.46.15609948544227029', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.161.96.198', '2019-06-20 09:40:54', 1, 1002001015, '账号未登陆', '2019-06-20 09:40:54');
INSERT INTO `access_log` VALUES (39432, '65.3607.15609948639098763', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.161.96.198', '2019-06-20 09:41:04', 107, 0, '', '2019-06-20 09:41:04');
INSERT INTO `access_log` VALUES (39433, '65.45.15609948648096997', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.161.96.198', '2019-06-20 09:41:05', 9, 0, '', '2019-06-20 09:41:05');
INSERT INTO `access_log` VALUES (39434, '65.50.15609948648137013', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.161.96.198', '2019-06-20 09:41:05', 9, 2001001000, '服务端发生异常', '2019-06-20 09:41:05');
INSERT INTO `access_log` VALUES (39435, '65.51.15609948648227025', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '202.161.96.198', '2019-06-20 09:41:05', 9, 0, '', '2019-06-20 09:41:05');
INSERT INTO `access_log` VALUES (39436, '59.71.15609949392476163', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:19', 3, 0, '', '2019-06-20 09:42:19');
INSERT INTO `access_log` VALUES (39437, '59.74.15609949392516161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:19', 12, 2001001000, '服务端发生异常', '2019-06-20 09:42:19');
INSERT INTO `access_log` VALUES (39438, '64.76.15609949440796125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:24', 2, 0, '', '2019-06-20 09:42:24');
INSERT INTO `access_log` VALUES (39439, '64.84.15609949442426133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:24', 2, 0, '', '2019-06-20 09:42:24');
INSERT INTO `access_log` VALUES (39440, '64.77.15609949455846139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:26', 2, 0, '', '2019-06-20 09:42:26');
INSERT INTO `access_log` VALUES (39441, '64.80.15609949462406141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:26', 2, 0, '', '2019-06-20 09:42:26');
INSERT INTO `access_log` VALUES (39442, '64.83.15609949469646131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:27', 2, 0, '', '2019-06-20 09:42:27');
INSERT INTO `access_log` VALUES (39443, '64.81.15609949518526137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:32', 2, 0, '', '2019-06-20 09:42:32');
INSERT INTO `access_log` VALUES (39444, '64.82.15609949520226151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:32', 1, 0, '', '2019-06-20 09:42:32');
INSERT INTO `access_log` VALUES (39445, '59.73.15609949602816169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:40', 5, 0, '', '2019-06-20 09:42:40');
INSERT INTO `access_log` VALUES (39446, '59.76.15609949602816159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:40', 13, 2001001000, '服务端发生异常', '2019-06-20 09:42:40');
INSERT INTO `access_log` VALUES (39447, '64.79.15609949674076139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:47', 2, 0, '', '2019-06-20 09:42:47');
INSERT INTO `access_log` VALUES (39448, '64.85.15609949675726155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:48', 2, 0, '', '2019-06-20 09:42:48');
INSERT INTO `access_log` VALUES (39449, '59.75.15609949687626167', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:49', 3, 0, '', '2019-06-20 09:42:49');
INSERT INTO `access_log` VALUES (39450, '59.78.15609949687636165', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '218.201.251.73', '2019-06-20 09:42:49', 13, 2001001000, '服务端发生异常', '2019-06-20 09:42:49');
INSERT INTO `access_log` VALUES (39451, '59.76.15609950546666161', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 09:44:15', 3, 0, '', '2019-06-20 09:44:15');
INSERT INTO `access_log` VALUES (39452, '59.73.15609950546666171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 09:44:15', 17, 2001001000, '服务端发生异常', '2019-06-20 09:44:15');
INSERT INTO `access_log` VALUES (39453, '64.82.15609950591556153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 09:44:19', 141, 0, '', '2019-06-20 09:44:19');
INSERT INTO `access_log` VALUES (39454, '64.78.15609950594576145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 09:44:19', 2, 0, '', '2019-06-20 09:44:19');
INSERT INTO `access_log` VALUES (39455, '64.85.15609950609156157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 09:44:21', 2, 0, '', '2019-06-20 09:44:21');
INSERT INTO `access_log` VALUES (39456, '64.76.15609950615186129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 09:44:22', 2, 0, '', '2019-06-20 09:44:22');
INSERT INTO `access_log` VALUES (39457, '59.75.15609950653456169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 09:44:25', 2, 0, '', '2019-06-20 09:44:25');
INSERT INTO `access_log` VALUES (39458, '59.80.15609950653466155', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 09:44:25', 12, 2001001000, '服务端发生异常', '2019-06-20 09:44:25');
INSERT INTO `access_log` VALUES (39459, '65.46.15609952359597035', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.132.214.66', '2019-06-20 09:47:16', 1, 1002001015, '账号未登陆', '2019-06-20 09:47:16');
INSERT INTO `access_log` VALUES (39460, '65.3607.15609952359628769', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.132.214.66', '2019-06-20 09:47:16', 0, 1002001015, '账号未登陆', '2019-06-20 09:47:16');
INSERT INTO `access_log` VALUES (39461, '65.51.15609952359727031', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.132.214.66', '2019-06-20 09:47:16', 0, 1002001015, '账号未登陆', '2019-06-20 09:47:16');
INSERT INTO `access_log` VALUES (39462, '65.45.15609952380027003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.132.214.66', '2019-06-20 09:47:18', 22, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 09:47:18');
INSERT INTO `access_log` VALUES (39463, '65.53.15609952617747005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.132.214.66', '2019-06-20 09:47:42', 67, 0, '', '2019-06-20 09:47:42');
INSERT INTO `access_log` VALUES (39464, '65.54.15609952622586963', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.132.214.66', '2019-06-20 09:47:42', 10, 0, '', '2019-06-20 09:47:42');
INSERT INTO `access_log` VALUES (39465, '65.49.15609952622637021', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.132.214.66', '2019-06-20 09:47:42', 10, 2001001000, '服务端发生异常', '2019-06-20 09:47:42');
INSERT INTO `access_log` VALUES (39466, '65.47.15609952622677001', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.132.214.66', '2019-06-20 09:47:42', 8, 0, '', '2019-06-20 09:47:42');
INSERT INTO `access_log` VALUES (39467, '65.53.15609957581387013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '101.231.252.125', '2019-06-20 09:55:58', 1, 1002001015, '账号未登陆', '2019-06-20 09:55:58');
INSERT INTO `access_log` VALUES (39468, '65.47.15609957581427009', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '101.231.252.125', '2019-06-20 09:55:58', 0, 1002001015, '账号未登陆', '2019-06-20 09:55:58');
INSERT INTO `access_log` VALUES (39469, '65.49.15609957581467027', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '101.231.252.125', '2019-06-20 09:55:58', 0, 1002001015, '账号未登陆', '2019-06-20 09:55:58');
INSERT INTO `access_log` VALUES (39470, '65.54.15609957599386971', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '101.231.252.125', '2019-06-20 09:56:00', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 09:56:00');
INSERT INTO `access_log` VALUES (39471, '65.46.15609957647177045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '101.231.252.125', '2019-06-20 09:56:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 09:56:05');
INSERT INTO `access_log` VALUES (39472, '65.51.15609957785257041', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '101.231.252.125', '2019-06-20 09:56:19', 69, 0, '', '2019-06-20 09:56:19');
INSERT INTO `access_log` VALUES (39473, '65.45.15609957788957013', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '101.231.252.125', '2019-06-20 09:56:19', 10, 0, '', '2019-06-20 09:56:19');
INSERT INTO `access_log` VALUES (39474, '65.50.15609957789027029', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '101.231.252.125', '2019-06-20 09:56:19', 10, 2001001000, '服务端发生异常', '2019-06-20 09:56:19');
INSERT INTO `access_log` VALUES (39475, '65.52.15609957789057029', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '101.231.252.125', '2019-06-20 09:56:19', 9, 0, '', '2019-06-20 09:56:19');
INSERT INTO `access_log` VALUES (39476, '65.49.15609958094987029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '101.231.252.125', '2019-06-20 09:56:49', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 09:56:50');
INSERT INTO `access_log` VALUES (39477, '65.45.15609961653217019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.244.155.168', '2019-06-20 10:02:45', 57, 0, '', '2019-06-20 10:02:45');
INSERT INTO `access_log` VALUES (39478, '65.52.15609961656617035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.244.155.168', '2019-06-20 10:02:46', 9, 0, '', '2019-06-20 10:02:46');
INSERT INTO `access_log` VALUES (39479, '65.50.15609961656637035', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.244.155.168', '2019-06-20 10:02:46', 9, 2001001000, '服务端发生异常', '2019-06-20 10:02:46');
INSERT INTO `access_log` VALUES (39480, '65.53.15609961656677021', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.244.155.168', '2019-06-20 10:02:46', 9, 0, '', '2019-06-20 10:02:46');
INSERT INTO `access_log` VALUES (39481, '59.73.15609962115806187', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.244.155.168', '2019-06-20 10:03:32', 3, 0, '', '2019-06-20 10:03:32');
INSERT INTO `access_log` VALUES (39482, '59.78.15609962115896183', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.244.155.168', '2019-06-20 10:03:32', 10, 2001001000, '服务端发生异常', '2019-06-20 10:03:32');
INSERT INTO `access_log` VALUES (39483, '64.79.15609962156206157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.244.155.168', '2019-06-20 10:03:36', 3, 0, '', '2019-06-20 10:03:36');
INSERT INTO `access_log` VALUES (39484, '64.85.15609962158136173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.244.155.168', '2019-06-20 10:03:36', 1, 0, '', '2019-06-20 10:03:36');
INSERT INTO `access_log` VALUES (39485, '65.53.15609970523147033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.137.120.209', '2019-06-20 10:17:32', 0, 1002001015, '账号未登陆', '2019-06-20 10:17:32');
INSERT INTO `access_log` VALUES (39486, '65.47.15609970523157029', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.137.120.209', '2019-06-20 10:17:32', 1, 1002001015, '账号未登陆', '2019-06-20 10:17:32');
INSERT INTO `access_log` VALUES (39487, '65.49.15609970523167047', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.137.120.209', '2019-06-20 10:17:32', 0, 1002001015, '账号未登陆', '2019-06-20 10:17:32');
INSERT INTO `access_log` VALUES (39488, '65.53.15609971638667035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.137.120.209', '2019-06-20 10:19:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 10:19:24');
INSERT INTO `access_log` VALUES (39489, '65.47.15609971779847031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.137.120.209', '2019-06-20 10:19:38', 106, 0, '', '2019-06-20 10:19:38');
INSERT INTO `access_log` VALUES (39490, '65.54.15609971783536993', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.137.120.209', '2019-06-20 10:19:38', 10, 0, '', '2019-06-20 10:19:38');
INSERT INTO `access_log` VALUES (39491, '65.46.15609971783537067', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.137.120.209', '2019-06-20 10:19:38', 10, 2001001000, '服务端发生异常', '2019-06-20 10:19:38');
INSERT INTO `access_log` VALUES (39492, '65.3607.15609971783588801', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.137.120.209', '2019-06-20 10:19:38', 9, 0, '', '2019-06-20 10:19:38');
INSERT INTO `access_log` VALUES (39493, '65.46.15609977256647075', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:28:46', 0, 1002001015, '账号未登陆', '2019-06-20 10:28:46');
INSERT INTO `access_log` VALUES (39494, '65.3607.15609977256658809', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:28:46', 0, 1002001015, '账号未登陆', '2019-06-20 10:28:46');
INSERT INTO `access_log` VALUES (39495, '65.54.15609977256677001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:28:46', 1, 1002001015, '账号未登陆', '2019-06-20 10:28:46');
INSERT INTO `access_log` VALUES (39496, '65.45.15609977374657043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:28:57', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 10:28:57');
INSERT INTO `access_log` VALUES (39497, '65.50.15609977423737059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:02', 52, 0, '', '2019-06-20 10:29:02');
INSERT INTO `access_log` VALUES (39498, '65.49.15609977427107059', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:03', 10, 0, '', '2019-06-20 10:29:03');
INSERT INTO `access_log` VALUES (39499, '65.52.15609977427107059', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:03', 10, 0, '', '2019-06-20 10:29:03');
INSERT INTO `access_log` VALUES (39500, '65.53.15609977427117045', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:03', 10, 2001001000, '服务端发生异常', '2019-06-20 10:29:03');
INSERT INTO `access_log` VALUES (39501, '65.3607.15609977501218811', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:10', 9, 0, '', '2019-06-20 10:29:10');
INSERT INTO `access_log` VALUES (39502, '65.46.15609977501217077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:10', 9, 0, '', '2019-06-20 10:29:10');
INSERT INTO `access_log` VALUES (39503, '65.54.15609977501217003', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:10', 12, 2001001000, '服务端发生异常', '2019-06-20 10:29:10');
INSERT INTO `access_log` VALUES (39504, '65.51.15609977632267073', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:23', 8, 0, '', '2019-06-20 10:29:23');
INSERT INTO `access_log` VALUES (39505, '65.45.15609977632297045', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:23', 9, 2001001000, '服务端发生异常', '2019-06-20 10:29:23');
INSERT INTO `access_log` VALUES (39506, '65.50.15609977632327061', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:23', 9, 0, '', '2019-06-20 10:29:23');
INSERT INTO `access_log` VALUES (39507, '65.49.15609977681157061', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:28', 8, 0, '', '2019-06-20 10:29:28');
INSERT INTO `access_log` VALUES (39508, '65.52.15609977681177061', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:28', 9, 2001001000, '服务端发生异常', '2019-06-20 10:29:28');
INSERT INTO `access_log` VALUES (39509, '65.47.15609977681207043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:28', 8, 0, '', '2019-06-20 10:29:28');
INSERT INTO `access_log` VALUES (39510, '65.3607.15609977708898813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:31', 8, 0, '', '2019-06-20 10:29:31');
INSERT INTO `access_log` VALUES (39511, '65.54.15609977708927005', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:31', 10, 2001001000, '服务端发生异常', '2019-06-20 10:29:31');
INSERT INTO `access_log` VALUES (39512, '65.46.15609977708957079', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:31', 9, 0, '', '2019-06-20 10:29:31');
INSERT INTO `access_log` VALUES (39513, '65.50.15609977735937063', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:34', 8, 0, '', '2019-06-20 10:29:34');
INSERT INTO `access_log` VALUES (39514, '65.45.15609977735947047', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:34', 10, 2001001000, '服务端发生异常', '2019-06-20 10:29:34');
INSERT INTO `access_log` VALUES (39515, '65.51.15609977736007075', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.145.235.71', '2019-06-20 10:29:34', 9, 0, '', '2019-06-20 10:29:34');
INSERT INTO `access_log` VALUES (39516, '65.51.15609978923627077', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '119.137.55.145', '2019-06-20 10:31:32', 1, 1002001015, '账号未登陆', '2019-06-20 10:31:32');
INSERT INTO `access_log` VALUES (39517, '65.45.15609978923627049', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '119.137.55.145', '2019-06-20 10:31:32', 1, 1002001015, '账号未登陆', '2019-06-20 10:31:32');
INSERT INTO `access_log` VALUES (39518, '65.53.15609978923647051', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '119.137.55.145', '2019-06-20 10:31:32', 0, 1002001015, '账号未登陆', '2019-06-20 10:31:32');
INSERT INTO `access_log` VALUES (39519, '65.49.15609978990167065', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '119.137.55.145', '2019-06-20 10:31:39', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 10:31:39');
INSERT INTO `access_log` VALUES (39520, '65.54.15609979329867009', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '119.137.55.145', '2019-06-20 10:32:13', 93, 0, '', '2019-06-20 10:32:13');
INSERT INTO `access_log` VALUES (39521, '65.3607.15609979334008817', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '119.137.55.145', '2019-06-20 10:32:13', 10, 0, '', '2019-06-20 10:32:13');
INSERT INTO `access_log` VALUES (39522, '65.50.15609979334017067', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '119.137.55.145', '2019-06-20 10:32:13', 8, 2001001000, '服务端发生异常', '2019-06-20 10:32:13');
INSERT INTO `access_log` VALUES (39523, '65.53.15609979334067053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '119.137.55.145', '2019-06-20 10:32:13', 7, 0, '', '2019-06-20 10:32:13');
INSERT INTO `access_log` VALUES (39524, '59.71.15609982096426209', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:36:50', 16, 0, '', '2019-06-20 10:36:50');
INSERT INTO `access_log` VALUES (39525, '59.74.15609982096436207', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:36:50', 20, 2001001000, '服务端发生异常', '2019-06-20 10:36:50');
INSERT INTO `access_log` VALUES (39526, '59.72.15609982167076207', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:36:57', 3, 0, '', '2019-06-20 10:36:57');
INSERT INTO `access_log` VALUES (39527, '59.76.15609982167086205', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:36:57', 14, 2001001000, '服务端发生异常', '2019-06-20 10:36:57');
INSERT INTO `access_log` VALUES (39528, '64.80.15609982229806187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:37:03', 11, 0, '', '2019-06-20 10:37:03');
INSERT INTO `access_log` VALUES (39529, '64.84.15609982231166179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:37:03', 2, 0, '', '2019-06-20 10:37:03');
INSERT INTO `access_log` VALUES (39530, '64.83.15609982268596177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:37:07', 2, 0, '', '2019-06-20 10:37:07');
INSERT INTO `access_log` VALUES (39531, '64.81.15609982269926183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:37:07', 2, 0, '', '2019-06-20 10:37:07');
INSERT INTO `access_log` VALUES (39532, '59.73.15609983678626217', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:39:28', 3, 0, '', '2019-06-20 10:39:28');
INSERT INTO `access_log` VALUES (39533, '59.78.15609983678646213', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:39:28', 13, 2001001000, '服务端发生异常', '2019-06-20 10:39:28');
INSERT INTO `access_log` VALUES (39534, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:39:42', 7, 0, '', '2019-06-20 10:39:42');
INSERT INTO `access_log` VALUES (39535, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:39:42', 15, 0, '', '2019-06-20 10:39:42');
INSERT INTO `access_log` VALUES (39536, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:39:46', 6, 0, '', '2019-06-20 10:39:46');
INSERT INTO `access_log` VALUES (39537, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:39:46', 10, 0, '', '2019-06-20 10:39:46');
INSERT INTO `access_log` VALUES (39538, '64.82.15609983882286201', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:39:48', 7, 0, '', '2019-06-20 10:39:48');
INSERT INTO `access_log` VALUES (39539, '64.76.15609984133296175', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:40:13', 7, 0, '', '2019-06-20 10:40:13');
INSERT INTO `access_log` VALUES (39540, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:40:33', 8, 0, '', '2019-06-20 10:40:33');
INSERT INTO `access_log` VALUES (39541, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:40:34', 11, 0, '', '2019-06-20 10:40:34');
INSERT INTO `access_log` VALUES (39542, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:40:37', 5, 0, '', '2019-06-20 10:40:37');
INSERT INTO `access_log` VALUES (39543, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:40:37', 14, 0, '', '2019-06-20 10:40:37');
INSERT INTO `access_log` VALUES (39544, '59.74.15609984409546211', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:40:41', 3, 0, '', '2019-06-20 10:40:41');
INSERT INTO `access_log` VALUES (39545, '59.72.15609984409876211', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:40:41', 13, 2001001000, '服务端发生异常', '2019-06-20 10:40:41');
INSERT INTO `access_log` VALUES (39546, '64.84.15609984492406183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:40:49', 2, 0, '', '2019-06-20 10:40:49');
INSERT INTO `access_log` VALUES (39547, '64.77.15609984493896193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:40:49', 2, 0, '', '2019-06-20 10:40:49');
INSERT INTO `access_log` VALUES (39548, '64.81.15609984537276187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:40:54', 2, 0, '', '2019-06-20 10:40:54');
INSERT INTO `access_log` VALUES (39549, '64.82.15609984538666203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:40:54', 2, 0, '', '2019-06-20 10:40:54');
INSERT INTO `access_log` VALUES (39550, '59.73.15609984563436219', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:40:56', 3, 0, '', '2019-06-20 10:40:56');
INSERT INTO `access_log` VALUES (39551, '59.78.15609984563436215', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:40:56', 13, 2001001000, '服务端发生异常', '2019-06-20 10:40:56');
INSERT INTO `access_log` VALUES (39552, '64.76.15609984806096177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:41:21', 1, 0, '', '2019-06-20 10:41:21');
INSERT INTO `access_log` VALUES (39553, '64.85.15609984807196205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:41:21', 2, 0, '', '2019-06-20 10:41:21');
INSERT INTO `access_log` VALUES (39554, '64.80.15609984829066193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:41:23', 1, 0, '', '2019-06-20 10:41:23');
INSERT INTO `access_log` VALUES (39555, '64.84.15609984837276185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:41:24', 2, 0, '', '2019-06-20 10:41:24');
INSERT INTO `access_log` VALUES (39556, '64.77.15609984845616195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:41:25', 2, 0, '', '2019-06-20 10:41:25');
INSERT INTO `access_log` VALUES (39557, '64.83.15609984852706183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:41:25', 2, 0, '', '2019-06-20 10:41:25');
INSERT INTO `access_log` VALUES (39558, '64.81.15609984861386189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:41:26', 2, 0, '', '2019-06-20 10:41:26');
INSERT INTO `access_log` VALUES (39559, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:41:26', 6, 0, '', '2019-06-20 10:41:26');
INSERT INTO `access_log` VALUES (39560, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:41:28', 5, 0, '', '2019-06-20 10:41:28');
INSERT INTO `access_log` VALUES (39561, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:41:29', 7, 0, '', '2019-06-20 10:41:29');
INSERT INTO `access_log` VALUES (39562, '64.82.15609984911716205', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:41:31', 7, 0, '', '2019-06-20 10:41:31');
INSERT INTO `access_log` VALUES (39563, '64.76.15609985200776179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:00', 2, 0, '', '2019-06-20 10:42:00');
INSERT INTO `access_log` VALUES (39564, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:00', 7, 0, '', '2019-06-20 10:42:00');
INSERT INTO `access_log` VALUES (39565, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:02', 5, 0, '', '2019-06-20 10:42:02');
INSERT INTO `access_log` VALUES (39566, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:03', 6, 0, '', '2019-06-20 10:42:03');
INSERT INTO `access_log` VALUES (39567, '64.85.15609985235436207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:04', 2, 0, '', '2019-06-20 10:42:04');
INSERT INTO `access_log` VALUES (39568, '64.80.15609985237366195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:04', 2, 0, '', '2019-06-20 10:42:04');
INSERT INTO `access_log` VALUES (39569, '64.84.15609985252776187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:05', 2, 0, '', '2019-06-20 10:42:05');
INSERT INTO `access_log` VALUES (39570, '64.83.15609985258176185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:06', 2, 0, '', '2019-06-20 10:42:06');
INSERT INTO `access_log` VALUES (39571, '64.81.15609985275436191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:08', 2, 0, '', '2019-06-20 10:42:08');
INSERT INTO `access_log` VALUES (39572, '64.82.15609985280596207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:08', 1, 0, '', '2019-06-20 10:42:08');
INSERT INTO `access_log` VALUES (39573, '64.79.15609985285166195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:09', 2, 0, '', '2019-06-20 10:42:09');
INSERT INTO `access_log` VALUES (39574, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:12', 8, 0, '', '2019-06-20 10:42:12');
INSERT INTO `access_log` VALUES (39575, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:12', 11, 0, '', '2019-06-20 10:42:12');
INSERT INTO `access_log` VALUES (39576, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:19', 8, 0, '', '2019-06-20 10:42:19');
INSERT INTO `access_log` VALUES (39577, '64.76.15609985420606181', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.34.52.200', '2019-06-20 10:42:22', 6, 0, '', '2019-06-20 10:42:22');
INSERT INTO `access_log` VALUES (39578, '65.47.15609985631987057', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:42:43', 1, 1002001015, '账号未登陆', '2019-06-20 10:42:43');
INSERT INTO `access_log` VALUES (39579, '65.49.15609985632017075', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:42:43', 1, 1002001015, '账号未登陆', '2019-06-20 10:42:43');
INSERT INTO `access_log` VALUES (39580, '65.52.15609985632127075', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:42:43', 0, 1002001015, '账号未登陆', '2019-06-20 10:42:43');
INSERT INTO `access_log` VALUES (39581, '65.46.15609985655427093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:42:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 10:42:46');
INSERT INTO `access_log` VALUES (39582, '65.3607.15609985866908827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:43:07', 65, 0, '', '2019-06-20 10:43:07');
INSERT INTO `access_log` VALUES (39583, '65.50.15609985872357077', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:43:07', 10, 0, '', '2019-06-20 10:43:07');
INSERT INTO `access_log` VALUES (39584, '65.53.15609985872397063', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:43:07', 10, 2001001000, '服务端发生异常', '2019-06-20 10:43:07');
INSERT INTO `access_log` VALUES (39585, '65.45.15609985872567061', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:43:07', 10, 0, '', '2019-06-20 10:43:07');
INSERT INTO `access_log` VALUES (39586, '65.49.15609985988707077', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:43:19', 9, 0, '', '2019-06-20 10:43:19');
INSERT INTO `access_log` VALUES (39587, '65.52.15609985988887077', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:43:19', 10, 2001001000, '服务端发生异常', '2019-06-20 10:43:19');
INSERT INTO `access_log` VALUES (39588, '65.47.15609985988907059', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 10:43:19', 8, 0, '', '2019-06-20 10:43:19');
INSERT INTO `access_log` VALUES (39589, '65.45.15609988209887065', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:01', 1, 1002001015, '账号未登陆', '2019-06-20 10:47:01');
INSERT INTO `access_log` VALUES (39590, '65.47.15609988209897063', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:01', 0, 1002001015, '账号未登陆', '2019-06-20 10:47:01');
INSERT INTO `access_log` VALUES (39591, '65.51.15609988209887093', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:01', 0, 1002001015, '账号未登陆', '2019-06-20 10:47:01');
INSERT INTO `access_log` VALUES (39592, '65.49.15609988226447081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:03', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 10:47:03');
INSERT INTO `access_log` VALUES (39593, '65.52.15609988272637081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:07', 73, 0, '', '2019-06-20 10:47:07');
INSERT INTO `access_log` VALUES (39594, '65.46.15609988275607099', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:08', 9, 0, '', '2019-06-20 10:47:08');
INSERT INTO `access_log` VALUES (39595, '65.54.15609988275627025', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:08', 9, 0, '', '2019-06-20 10:47:08');
INSERT INTO `access_log` VALUES (39596, '65.3607.15609988275668833', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:08', 9, 0, '', '2019-06-20 10:47:08');
INSERT INTO `access_log` VALUES (39597, '59.72.15609988301726217', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:47:10', 3, 0, '', '2019-06-20 10:47:10');
INSERT INTO `access_log` VALUES (39598, '59.74.15609988301716217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:47:10', 11, 2001001000, '服务端发生异常', '2019-06-20 10:47:10');
INSERT INTO `access_log` VALUES (39599, '62.89.15609988509835887', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:31', 33, 0, '', '2019-06-20 10:47:31');
INSERT INTO `access_log` VALUES (39600, '65.51.15609988613527095', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:41', 18, 0, '', '2019-06-20 10:47:41');
INSERT INTO `access_log` VALUES (39601, '65.45.15609988619967067', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:42', 10, 0, '', '2019-06-20 10:47:42');
INSERT INTO `access_log` VALUES (39602, '65.49.15609988632127083', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:43', 9, 0, '', '2019-06-20 10:47:43');
INSERT INTO `access_log` VALUES (39603, '64.80.15609988667716201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:47:47', 2, 0, '', '2019-06-20 10:47:47');
INSERT INTO `access_log` VALUES (39604, '64.84.15609988669576193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:47:47', 2, 0, '', '2019-06-20 10:47:47');
INSERT INTO `access_log` VALUES (39605, '64.77.15609988686516203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:47:49', 2, 0, '', '2019-06-20 10:47:49');
INSERT INTO `access_log` VALUES (39606, '64.83.15609988689806191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:47:49', 2, 0, '', '2019-06-20 10:47:49');
INSERT INTO `access_log` VALUES (39607, '64.81.15609988695206197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:47:50', 2, 0, '', '2019-06-20 10:47:50');
INSERT INTO `access_log` VALUES (39608, '64.79.15609988711636201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:47:51', 1, 0, '', '2019-06-20 10:47:51');
INSERT INTO `access_log` VALUES (39609, '64.78.15609988714986205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:47:51', 2, 0, '', '2019-06-20 10:47:52');
INSERT INTO `access_log` VALUES (39610, '64.76.15609988722436187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:47:52', 2, 0, '', '2019-06-20 10:47:52');
INSERT INTO `access_log` VALUES (39611, '64.85.15609988731356215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:47:53', 2, 0, '', '2019-06-20 10:47:53');
INSERT INTO `access_log` VALUES (39612, '64.80.15609988735946203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:47:54', 2, 0, '', '2019-06-20 10:47:54');
INSERT INTO `access_log` VALUES (39613, '65.52.15609988752287083', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:55', 0, 1002001015, '账号未登陆', '2019-06-20 10:47:55');
INSERT INTO `access_log` VALUES (39614, '65.3607.15609988752318835', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:55', 0, 1002001015, '账号未登陆', '2019-06-20 10:47:55');
INSERT INTO `access_log` VALUES (39615, '65.46.15609988752347101', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:47:55', 0, 1002001015, '账号未登陆', '2019-06-20 10:47:55');
INSERT INTO `access_log` VALUES (39616, '64.84.15609988804006195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:48:00', 2, 0, '', '2019-06-20 10:48:00');
INSERT INTO `access_log` VALUES (39617, '64.77.15609988806316205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:48:01', 2, 0, '', '2019-06-20 10:48:01');
INSERT INTO `access_log` VALUES (39618, '65.45.15609988818367071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:02', 104, 0, '', '2019-06-20 10:48:02');
INSERT INTO `access_log` VALUES (39619, '59.75.15609988821576223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:48:02', 3, 0, '', '2019-06-20 10:48:02');
INSERT INTO `access_log` VALUES (39620, '59.80.15609988821886209', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:48:02', 13, 2001001000, '服务端发生异常', '2019-06-20 10:48:02');
INSERT INTO `access_log` VALUES (39621, '65.49.15609988822257085', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:02', 14, 0, '', '2019-06-20 10:48:02');
INSERT INTO `access_log` VALUES (39622, '65.46.15609988822297103', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:02', 83, 0, '', '2019-06-20 10:48:02');
INSERT INTO `access_log` VALUES (39623, '65.3607.15609988822278837', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:02', 89, 2001001000, '服务端发生异常', '2019-06-20 10:48:02');
INSERT INTO `access_log` VALUES (39624, '65.54.15609988863527027', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:06', 0, 1002001015, '账号未登陆', '2019-06-20 10:48:06');
INSERT INTO `access_log` VALUES (39625, '65.50.15609988863557085', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:06', 0, 1002001015, '账号未登陆', '2019-06-20 10:48:06');
INSERT INTO `access_log` VALUES (39626, '65.53.15609988863597071', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:06', 0, 1002001015, '账号未登陆', '2019-06-20 10:48:06');
INSERT INTO `access_log` VALUES (39627, '64.81.15609988871366199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:48:07', 2, 0, '', '2019-06-20 10:48:07');
INSERT INTO `access_log` VALUES (39628, '64.82.15609988873246215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:48:07', 1, 0, '', '2019-06-20 10:48:07');
INSERT INTO `access_log` VALUES (39629, '64.79.15609988886016203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:48:09', 2, 0, '', '2019-06-20 10:48:09');
INSERT INTO `access_log` VALUES (39630, '64.78.15609988890936207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.235', '2019-06-20 10:48:09', 2, 0, '', '2019-06-20 10:48:09');
INSERT INTO `access_log` VALUES (39631, '65.51.15609988905397099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:11', 71, 0, '', '2019-06-20 10:48:11');
INSERT INTO `access_log` VALUES (39632, '65.45.15609988907627073', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:11', 9, 0, '', '2019-06-20 10:48:11');
INSERT INTO `access_log` VALUES (39633, '65.49.15609988907637087', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:11', 9, 0, '', '2019-06-20 10:48:11');
INSERT INTO `access_log` VALUES (39634, '65.3607.15609988907688839', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:11', 9, 0, '', '2019-06-20 10:48:11');
INSERT INTO `access_log` VALUES (39635, '64.85.15609988989096217', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:19', 10, 0, '', '2019-06-20 10:48:19');
INSERT INTO `access_log` VALUES (39636, '64.76.15609988989096189', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:19', 13, 0, '', '2019-06-20 10:48:19');
INSERT INTO `access_log` VALUES (39637, '64.77.15609989007956207', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:21', 14, 0, '', '2019-06-20 10:48:21');
INSERT INTO `access_log` VALUES (39638, '64.84.15609989007936197', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:21', 22, 0, '', '2019-06-20 10:48:21');
INSERT INTO `access_log` VALUES (39639, '64.83.15609989029506195', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:23', 10, 0, '', '2019-06-20 10:48:23');
INSERT INTO `access_log` VALUES (39640, '65.3607.15609989042558841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:24', 97, 0, '', '2019-06-20 10:48:24');
INSERT INTO `access_log` VALUES (39641, '65.46.15609989046017105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:25', 11, 0, '', '2019-06-20 10:48:25');
INSERT INTO `access_log` VALUES (39642, '65.52.15609989046077085', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:25', 10, 2001001000, '服务端发生异常', '2019-06-20 10:48:25');
INSERT INTO `access_log` VALUES (39643, '65.47.15609989046107071', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:25', 8, 0, '', '2019-06-20 10:48:25');
INSERT INTO `access_log` VALUES (39644, '62.80.15609989060045883', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:26', 77, 0, '', '2019-06-20 10:48:26');
INSERT INTO `access_log` VALUES (39645, '66.53.15609989189384545', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:39', 24, 0, '', '2019-06-20 10:48:39');
INSERT INTO `access_log` VALUES (39646, '59.72.15609989207536219', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:41', 13, 0, '', '2019-06-20 10:48:41');
INSERT INTO `access_log` VALUES (39647, '59.74.15609989226256219', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:43', 30, 2001001000, '服务端发生异常', '2019-06-20 10:48:43');
INSERT INTO `access_log` VALUES (39648, '59.76.15609989251616217', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:45', 17, 0, '', '2019-06-20 10:48:45');
INSERT INTO `access_log` VALUES (39649, '65.46.15609989267997107', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:47', 63, 0, '', '2019-06-20 10:48:47');
INSERT INTO `access_log` VALUES (39650, '65.47.15609989270507073', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:47', 7, 0, '', '2019-06-20 10:48:47');
INSERT INTO `access_log` VALUES (39651, '65.54.15609989270537029', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:47', 8, 0, '', '2019-06-20 10:48:47');
INSERT INTO `access_log` VALUES (39652, '65.53.15609989270547073', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:47', 7, 0, '', '2019-06-20 10:48:47');
INSERT INTO `access_log` VALUES (39653, '65.50.15609989271517087', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:47', 15, 0, '', '2019-06-20 10:48:47');
INSERT INTO `access_log` VALUES (39654, '65.51.15609989280387101', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:48', 8, 0, '', '2019-06-20 10:48:48');
INSERT INTO `access_log` VALUES (39655, '65.45.15609989290777075', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:49', 10, 0, '', '2019-06-20 10:48:49');
INSERT INTO `access_log` VALUES (39656, '65.49.15609989304347091', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:50', 43, 0, '', '2019-06-20 10:48:50');
INSERT INTO `access_log` VALUES (39657, '62.84.15609989332075859', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:53', 13, 0, '', '2019-06-20 10:48:53');
INSERT INTO `access_log` VALUES (39658, '59.78.15609989356026223', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:56', 12, 0, '', '2019-06-20 10:48:56');
INSERT INTO `access_log` VALUES (39659, '66.52.15609989365894553', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:57', 13, 0, '', '2019-06-20 10:48:57');
INSERT INTO `access_log` VALUES (39660, '59.75.15609989382776225', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:48:58', 11, 0, '', '2019-06-20 10:48:58');
INSERT INTO `access_log` VALUES (39661, '65.52.15609989405567089', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:49:01', 17, 0, '', '2019-06-20 10:49:01');
INSERT INTO `access_log` VALUES (39662, '65.46.15609989435477109', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:49:04', 9, 0, '', '2019-06-20 10:49:04');
INSERT INTO `access_log` VALUES (39663, '65.53.15609989456887075', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:49:06', 9, 0, '', '2019-06-20 10:49:06');
INSERT INTO `access_log` VALUES (39664, '65.54.15609989478507031', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:49:08', 15, 0, '', '2019-06-20 10:49:08');
INSERT INTO `access_log` VALUES (39665, '62.88.15609989544745879', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.240.37.213', '2019-06-20 10:49:14', 14, 0, '', '2019-06-20 10:49:14');
INSERT INTO `access_log` VALUES (39666, '65.50.15609989613627089', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:49:21', 9, 0, '', '2019-06-20 10:49:21');
INSERT INTO `access_log` VALUES (39667, '62.82.15609990966665881', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-06-20 10:51:37', 19, 0, '', '2019-06-20 10:51:37');
INSERT INTO `access_log` VALUES (39668, '65.49.15609995832267101', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 10:59:43', 1, 1002001015, '账号未登陆', '2019-06-20 10:59:43');
INSERT INTO `access_log` VALUES (39669, '65.3607.15609995832438853', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 10:59:43', 0, 1002001015, '账号未登陆', '2019-06-20 10:59:43');
INSERT INTO `access_log` VALUES (39670, '65.52.15609995832437099', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 10:59:43', 0, 1002001015, '账号未登陆', '2019-06-20 10:59:43');
INSERT INTO `access_log` VALUES (39671, '65.46.15609995854447119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 10:59:45', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 10:59:45');
INSERT INTO `access_log` VALUES (39672, '65.54.15609995975277041', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 10:59:58', 53, 0, '', '2019-06-20 10:59:58');
INSERT INTO `access_log` VALUES (39673, '65.47.15609995978987085', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 10:59:58', 10, 0, '', '2019-06-20 10:59:58');
INSERT INTO `access_log` VALUES (39674, '65.50.15609995979037099', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 10:59:58', 9, 0, '', '2019-06-20 10:59:58');
INSERT INTO `access_log` VALUES (39675, '65.51.15609995979047113', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 10:59:58', 9, 0, '', '2019-06-20 10:59:58');
INSERT INTO `access_log` VALUES (39676, '62.84.15609996039215869', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 11:00:04', 16, 0, '', '2019-06-20 11:00:04');
INSERT INTO `access_log` VALUES (39677, '62.85.15609996058615877', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 11:00:06', 12, 0, '', '2019-06-20 11:00:06');
INSERT INTO `access_log` VALUES (39678, '62.87.15609996066035885', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 11:00:07', 11, 0, '', '2019-06-20 11:00:07');
INSERT INTO `access_log` VALUES (39679, '62.88.15609996075265889', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 11:00:08', 13, 0, '', '2019-06-20 11:00:08');
INSERT INTO `access_log` VALUES (39680, '66.50.15609996270404551', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 11:00:27', 19, 0, '', '2019-06-20 11:00:27');
INSERT INTO `access_log` VALUES (39681, '62.82.15609996321675889', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 11:00:32', 14, 0, '', '2019-06-20 11:00:32');
INSERT INTO `access_log` VALUES (39682, '62.89.15609996347605901', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 11:00:35', 13, 0, '', '2019-06-20 11:00:35');
INSERT INTO `access_log` VALUES (39683, '65.50.15609997010807101', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 11:01:41', 10, 0, '', '2019-06-20 11:01:41');
INSERT INTO `access_log` VALUES (39684, '65.51.15609997010877115', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 11:01:41', 10, 2001001000, '服务端发生异常', '2019-06-20 11:01:41');
INSERT INTO `access_log` VALUES (39685, '65.47.15609997010937087', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '121.34.52.200', '2019-06-20 11:01:41', 9, 0, '', '2019-06-20 11:01:41');
INSERT INTO `access_log` VALUES (39686, '65.3607.15609997349798857', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 11:02:15', 19, 0, '', '2019-06-20 11:02:15');
INSERT INTO `access_log` VALUES (39687, '59.73.15609997898456239', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 11:03:10', 47, 0, '', '2019-06-20 11:03:10');
INSERT INTO `access_log` VALUES (39688, '62.85.15609998070745881', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 11:03:27', 14, 0, '', '2019-06-20 11:03:27');
INSERT INTO `access_log` VALUES (39689, '59.79.15609999811836243', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 11:06:21', 139, 0, '', '2019-06-20 11:06:21');
INSERT INTO `access_log` VALUES (39690, '59.76.15610000434186233', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 11:07:23', 12, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-20 11:07:23');
INSERT INTO `access_log` VALUES (39691, '59.73.15610000472106243', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 11:07:27', 10, 0, '', '2019-06-20 11:07:27');
INSERT INTO `access_log` VALUES (39692, '65.47.15610005703777099', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.94.103.200', '2019-06-20 11:16:10', 0, 1002001015, '账号未登陆', '2019-06-20 11:16:10');
INSERT INTO `access_log` VALUES (39693, '65.45.15610005703787101', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.94.103.200', '2019-06-20 11:16:10', 1, 1002001015, '账号未登陆', '2019-06-20 11:16:10');
INSERT INTO `access_log` VALUES (39694, '65.52.15610005703857115', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.94.102.192', '2019-06-20 11:16:10', 0, 1002001015, '账号未登陆', '2019-06-20 11:16:10');
INSERT INTO `access_log` VALUES (39695, '65.3607.15610005737548869', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.94.103.200', '2019-06-20 11:16:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 11:16:14');
INSERT INTO `access_log` VALUES (39696, '59.72.15610005754586243', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '171.120.91.12', '2019-06-20 11:16:15', 12, 2001001000, '服务端发生异常', '2019-06-20 11:16:15');
INSERT INTO `access_log` VALUES (39697, '59.71.15610005754526245', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '171.120.91.12', '2019-06-20 11:16:15', 21, 0, '', '2019-06-20 11:16:15');
INSERT INTO `access_log` VALUES (39698, '64.80.15610005787216229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '171.120.91.12', '2019-06-20 11:16:19', 2, 0, '', '2019-06-20 11:16:19');
INSERT INTO `access_log` VALUES (39699, '64.84.15610005788466219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '171.120.91.12', '2019-06-20 11:16:19', 1, 0, '', '2019-06-20 11:16:19');
INSERT INTO `access_log` VALUES (39700, '64.83.15610005802876221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '171.120.91.12', '2019-06-20 11:16:20', 1, 0, '', '2019-06-20 11:16:20');
INSERT INTO `access_log` VALUES (39701, '64.78.15610005807296231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '171.120.91.12', '2019-06-20 11:16:21', 1, 0, '', '2019-06-20 11:16:21');
INSERT INTO `access_log` VALUES (39702, '65.50.15610007893387117', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.255.127.48', '2019-06-20 11:19:49', 0, 1002001015, '账号未登陆', '2019-06-20 11:19:49');
INSERT INTO `access_log` VALUES (39703, '65.51.15610007893397131', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.255.127.48', '2019-06-20 11:19:49', 0, 1002001015, '账号未登陆', '2019-06-20 11:19:49');
INSERT INTO `access_log` VALUES (39704, '65.52.15610007893477119', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.255.127.48', '2019-06-20 11:19:49', 0, 1002001015, '账号未登陆', '2019-06-20 11:19:49');
INSERT INTO `access_log` VALUES (39705, '65.47.15610007921997103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.255.127.48', '2019-06-20 11:19:52', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 11:19:52');
INSERT INTO `access_log` VALUES (39706, '65.3607.15610007981408873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.255.127.48', '2019-06-20 11:19:58', 103, 0, '', '2019-06-20 11:19:58');
INSERT INTO `access_log` VALUES (39707, '65.49.15610007986237121', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.255.127.48', '2019-06-20 11:19:59', 175, 0, '', '2019-06-20 11:19:59');
INSERT INTO `access_log` VALUES (39708, '65.53.15610007986317105', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.255.127.48', '2019-06-20 11:19:59', 170, 0, '', '2019-06-20 11:19:59');
INSERT INTO `access_log` VALUES (39709, '65.46.15610007986277139', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.255.127.48', '2019-06-20 11:19:59', 174, 2001001000, '服务端发生异常', '2019-06-20 11:19:59');
INSERT INTO `access_log` VALUES (39710, '65.54.15610009533287063', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.43.99', '2019-06-20 11:22:33', 4, 1002001012, '访问令牌已过期', '2019-06-20 11:22:33');
INSERT INTO `access_log` VALUES (39711, '65.51.15610009533417135', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.43.99', '2019-06-20 11:22:33', 10, 1002001012, '访问令牌已过期', '2019-06-20 11:22:33');
INSERT INTO `access_log` VALUES (39712, '65.50.15610009533427121', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.43.99', '2019-06-20 11:22:33', 11, 1002001012, '访问令牌已过期', '2019-06-20 11:22:33');
INSERT INTO `access_log` VALUES (39713, '65.52.15610009573977123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.43.99', '2019-06-20 11:22:37', 86, 0, '', '2019-06-20 11:22:37');
INSERT INTO `access_log` VALUES (39714, '65.47.15610009577067107', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.43.99', '2019-06-20 11:22:38', 8, 0, '', '2019-06-20 11:22:38');
INSERT INTO `access_log` VALUES (39715, '65.45.15610009577087109', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.43.99', '2019-06-20 11:22:38', 9, 2001001000, '服务端发生异常', '2019-06-20 11:22:38');
INSERT INTO `access_log` VALUES (39716, '65.3607.15610009577118877', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.25.43.99', '2019-06-20 11:22:38', 7, 0, '', '2019-06-20 11:22:38');
INSERT INTO `access_log` VALUES (39717, '65.50.15610011607857125', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 11:26:01', 1, 1002001015, '账号未登陆', '2019-06-20 11:26:01');
INSERT INTO `access_log` VALUES (39718, '65.51.15610011607857139', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 11:26:01', 1, 1002001015, '账号未登陆', '2019-06-20 11:26:01');
INSERT INTO `access_log` VALUES (39719, '65.52.15610011607887127', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 11:26:01', 0, 1002001015, '账号未登陆', '2019-06-20 11:26:01');
INSERT INTO `access_log` VALUES (39720, '65.3607.15610011634938881', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 11:26:03', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 11:26:04');
INSERT INTO `access_log` VALUES (39721, '65.47.15610011752977111', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 11:26:15', 73, 0, '', '2019-06-20 11:26:15');
INSERT INTO `access_log` VALUES (39722, '65.53.15610011758877113', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 11:26:16', 10, 0, '', '2019-06-20 11:26:16');
INSERT INTO `access_log` VALUES (39723, '65.49.15610011758887129', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 11:26:16', 10, 2001001000, '服务端发生异常', '2019-06-20 11:26:16');
INSERT INTO `access_log` VALUES (39724, '65.46.15610011758937147', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 11:26:16', 9, 0, '', '2019-06-20 11:26:16');
INSERT INTO `access_log` VALUES (39725, '65.54.15610011820717069', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 11:26:22', 8, 0, '', '2019-06-20 11:26:22');
INSERT INTO `access_log` VALUES (39726, '65.52.15610011820777129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 11:26:22', 7, 0, '', '2019-06-20 11:26:22');
INSERT INTO `access_log` VALUES (39727, '65.51.15610011820777141', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-20 11:26:22', 9, 2001001000, '服务端发生异常', '2019-06-20 11:26:22');
INSERT INTO `access_log` VALUES (39728, '65.52.15610013116447131', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:28:32', 0, 1002001015, '账号未登陆', '2019-06-20 11:28:32');
INSERT INTO `access_log` VALUES (39729, '65.50.15610013116457129', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:28:32', 0, 1002001015, '账号未登陆', '2019-06-20 11:28:32');
INSERT INTO `access_log` VALUES (39730, '65.3607.15610013116488885', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:28:32', 0, 1002001015, '账号未登陆', '2019-06-20 11:28:32');
INSERT INTO `access_log` VALUES (39731, '65.45.15610013174157117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:28:37', 104, 0, '', '2019-06-20 11:28:38');
INSERT INTO `access_log` VALUES (39732, '65.47.15610013177687115', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:28:38', 9, 0, '', '2019-06-20 11:28:38');
INSERT INTO `access_log` VALUES (39733, '65.53.15610013177707117', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:28:38', 9, 2001001000, '服务端发生异常', '2019-06-20 11:28:38');
INSERT INTO `access_log` VALUES (39734, '65.49.15610013178017133', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:28:38', 110, 0, '', '2019-06-20 11:28:38');
INSERT INTO `access_log` VALUES (39735, '65.51.15610013461937145', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:29:06', 9, 0, '', '2019-06-20 11:29:06');
INSERT INTO `access_log` VALUES (39736, '65.3607.15610013461968887', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:29:06', 9, 2001001000, '服务端发生异常', '2019-06-20 11:29:06');
INSERT INTO `access_log` VALUES (39737, '65.52.15610013462187133', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:29:06', 9, 0, '', '2019-06-20 11:29:06');
INSERT INTO `access_log` VALUES (39738, '65.50.15610013487337131', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:29:09', 9, 0, '', '2019-06-20 11:29:09');
INSERT INTO `access_log` VALUES (39739, '65.45.15610013487337119', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:29:09', 11, 2001001000, '服务端发生异常', '2019-06-20 11:29:09');
INSERT INTO `access_log` VALUES (39740, '65.53.15610013487567119', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:29:09', 9, 0, '', '2019-06-20 11:29:09');
INSERT INTO `access_log` VALUES (39741, '65.49.15610013530407135', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:29:13', 9, 0, '', '2019-06-20 11:29:13');
INSERT INTO `access_log` VALUES (39742, '65.46.15610013530427153', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:29:13', 9, 2001001000, '服务端发生异常', '2019-06-20 11:29:13');
INSERT INTO `access_log` VALUES (39743, '65.54.15610013530447075', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:29:13', 8, 0, '', '2019-06-20 11:29:13');
INSERT INTO `access_log` VALUES (39744, '59.76.15610014817146253', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:31:22', 3, 0, '', '2019-06-20 11:31:22');
INSERT INTO `access_log` VALUES (39745, '59.73.15610014817146263', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:31:22', 19, 2001001000, '服务端发生异常', '2019-06-20 11:31:22');
INSERT INTO `access_log` VALUES (39746, '64.79.15610014882246241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:31:28', 3, 0, '', '2019-06-20 11:31:28');
INSERT INTO `access_log` VALUES (39747, '64.82.15610014883216253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:31:28', 2, 0, '', '2019-06-20 11:31:28');
INSERT INTO `access_log` VALUES (39748, '64.81.15610014917876237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:31:32', 2, 0, '', '2019-06-20 11:31:32');
INSERT INTO `access_log` VALUES (39749, '64.77.15610014919206243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:31:32', 2, 0, '', '2019-06-20 11:31:32');
INSERT INTO `access_log` VALUES (39750, '64.80.15610014986366243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:31:39', 2, 0, '', '2019-06-20 11:31:39');
INSERT INTO `access_log` VALUES (39751, '64.84.15610014987996233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:31:39', 2, 0, '', '2019-06-20 11:31:39');
INSERT INTO `access_log` VALUES (39752, '59.75.15610014991796261', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:31:39', 2, 0, '', '2019-06-20 11:31:39');
INSERT INTO `access_log` VALUES (39753, '59.80.15610014991796247', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '124.65.96.158', '2019-06-20 11:31:39', 11, 2001001000, '服务端发生异常', '2019-06-20 11:31:39');
INSERT INTO `access_log` VALUES (39754, '59.79.15610018069356269', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '59.63.204.215', '2019-06-20 11:36:47', 3, 0, '', '2019-06-20 11:36:47');
INSERT INTO `access_log` VALUES (39755, '59.77.15610018069476253', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '59.63.204.215', '2019-06-20 11:36:47', 13, 2001001000, '服务端发生异常', '2019-06-20 11:36:47');
INSERT INTO `access_log` VALUES (39756, '64.78.15610018326696249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.63.204.215', '2019-06-20 11:37:13', 2, 0, '', '2019-06-20 11:37:13');
INSERT INTO `access_log` VALUES (39757, '64.79.15610018328616247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.63.204.215', '2019-06-20 11:37:13', 1, 0, '', '2019-06-20 11:37:13');
INSERT INTO `access_log` VALUES (39758, '64.82.15610018345876259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.63.204.215', '2019-06-20 11:37:15', 2, 0, '', '2019-06-20 11:37:15');
INSERT INTO `access_log` VALUES (39759, '64.81.15610018353296243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.63.204.215', '2019-06-20 11:37:15', 2, 0, '', '2019-06-20 11:37:15');
INSERT INTO `access_log` VALUES (39760, '59.74.15610018367546261', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.63.204.215', '2019-06-20 11:37:17', 3, 0, '', '2019-06-20 11:37:17');
INSERT INTO `access_log` VALUES (39761, '59.76.15610018367556259', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.63.204.215', '2019-06-20 11:37:17', 18, 2001001000, '服务端发生异常', '2019-06-20 11:37:17');
INSERT INTO `access_log` VALUES (39762, '65.49.15610019619727145', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '59.63.204.215', '2019-06-20 11:39:22', 1, 1002001015, '账号未登陆', '2019-06-20 11:39:22');
INSERT INTO `access_log` VALUES (39763, '65.3607.15610019620058899', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '59.63.204.215', '2019-06-20 11:39:22', 0, 1002001015, '账号未登陆', '2019-06-20 11:39:22');
INSERT INTO `access_log` VALUES (39764, '65.51.15610019620067157', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '59.63.204.215', '2019-06-20 11:39:22', 1, 1002001015, '账号未登陆', '2019-06-20 11:39:22');
INSERT INTO `access_log` VALUES (39765, '65.53.15610019661897127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '59.63.204.215', '2019-06-20 11:39:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 11:39:26');
INSERT INTO `access_log` VALUES (39766, '65.45.15610019724127129', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '59.63.204.215', '2019-06-20 11:39:32', 103, 0, '', '2019-06-20 11:39:33');
INSERT INTO `access_log` VALUES (39767, '65.54.15610019729837087', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '59.63.204.215', '2019-06-20 11:39:33', 10, 0, '', '2019-06-20 11:39:33');
INSERT INTO `access_log` VALUES (39768, '65.47.15610019729837129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '59.63.204.215', '2019-06-20 11:39:33', 10, 0, '', '2019-06-20 11:39:33');
INSERT INTO `access_log` VALUES (39769, '65.50.15610019729857141', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '59.63.204.215', '2019-06-20 11:39:33', 11, 2001001000, '服务端发生异常', '2019-06-20 11:39:33');
INSERT INTO `access_log` VALUES (39770, '65.49.15610019853537147', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '59.63.204.215', '2019-06-20 11:39:45', 9, 0, '', '2019-06-20 11:39:45');
INSERT INTO `access_log` VALUES (39771, '65.3607.15610019853598901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '59.63.204.215', '2019-06-20 11:39:45', 16, 0, '', '2019-06-20 11:39:45');
INSERT INTO `access_log` VALUES (39772, '65.51.15610019853587159', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '59.63.204.215', '2019-06-20 11:39:45', 16, 2001001000, '服务端发生异常', '2019-06-20 11:39:45');
INSERT INTO `access_log` VALUES (39773, '65.54.15610041636517119', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.236.221.122', '2019-06-20 12:16:04', 0, 1002001015, '账号未登陆', '2019-06-20 12:16:04');
INSERT INTO `access_log` VALUES (39774, '65.50.15610041636537173', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.95.5.118', '2019-06-20 12:16:04', 1, 1002001015, '账号未登陆', '2019-06-20 12:16:04');
INSERT INTO `access_log` VALUES (39775, '65.47.15610041636537159', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.95.5.118', '2019-06-20 12:16:04', 0, 1002001015, '账号未登陆', '2019-06-20 12:16:04');
INSERT INTO `access_log` VALUES (39776, '65.3607.15610041655538931', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.236.221.122', '2019-06-20 12:16:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 12:16:06');
INSERT INTO `access_log` VALUES (39777, '65.45.15610041756777163', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.236.221.122', '2019-06-20 12:16:16', 85, 0, '', '2019-06-20 12:16:16');
INSERT INTO `access_log` VALUES (39778, '65.49.15610041759697179', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.95.5.118', '2019-06-20 12:16:16', 10, 0, '', '2019-06-20 12:16:16');
INSERT INTO `access_log` VALUES (39779, '65.51.15610041759787189', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.95.5.118', '2019-06-20 12:16:16', 10, 0, '', '2019-06-20 12:16:16');
INSERT INTO `access_log` VALUES (39780, '65.52.15610041759867175', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.236.221.122', '2019-06-20 12:16:16', 12, 2001001000, '服务端发生异常', '2019-06-20 12:16:16');
INSERT INTO `access_log` VALUES (39781, '65.53.15610041838277159', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.236.221.122', '2019-06-20 12:16:24', 17, 0, '', '2019-06-20 12:16:24');
INSERT INTO `access_log` VALUES (39782, '65.50.15610041838407175', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.95.5.118', '2019-06-20 12:16:24', 10, 0, '', '2019-06-20 12:16:24');
INSERT INTO `access_log` VALUES (39783, '65.54.15610041838327121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.95.5.118', '2019-06-20 12:16:24', 10, 2001001000, '服务端发生异常', '2019-06-20 12:16:24');
INSERT INTO `access_log` VALUES (39784, '65.50.15610042869097177', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.95.5.118', '2019-06-20 12:18:07', 10, 0, '', '2019-06-20 12:18:07');
INSERT INTO `access_log` VALUES (39785, '65.53.15610042869107161', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.95.5.118', '2019-06-20 12:18:07', 10, 2001001000, '服务端发生异常', '2019-06-20 12:18:07');
INSERT INTO `access_log` VALUES (39786, '65.54.15610042869207123', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '203.95.5.118', '2019-06-20 12:18:07', 10, 0, '', '2019-06-20 12:18:07');
INSERT INTO `access_log` VALUES (39787, '65.49.15610051169047195', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:31:57', 1, 1002001015, '账号未登陆', '2019-06-20 12:31:57');
INSERT INTO `access_log` VALUES (39788, '65.52.15610051169117189', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:31:57', 0, 1002001015, '账号未登陆', '2019-06-20 12:31:57');
INSERT INTO `access_log` VALUES (39789, '65.51.15610051169197205', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:31:57', 0, 1002001015, '账号未登陆', '2019-06-20 12:31:57');
INSERT INTO `access_log` VALUES (39790, '65.54.15610051255437137', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:32:06', 104, 0, '', '2019-06-20 12:32:06');
INSERT INTO `access_log` VALUES (39791, '65.53.15610051259667173', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:32:06', 88, 2001001000, '服务端发生异常', '2019-06-20 12:32:06');
INSERT INTO `access_log` VALUES (39792, '65.50.15610051259667189', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:32:06', 87, 0, '', '2019-06-20 12:32:06');
INSERT INTO `access_log` VALUES (39793, '65.47.15610051259677175', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:32:06', 87, 0, '', '2019-06-20 12:32:06');
INSERT INTO `access_log` VALUES (39794, '65.46.15610051328407213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:32:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 12:32:13');
INSERT INTO `access_log` VALUES (39795, '65.45.15610051365577181', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:32:17', 63, 0, '', '2019-06-20 12:32:17');
INSERT INTO `access_log` VALUES (39796, '65.52.15610051368567191', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:32:17', 9, 2001001000, '服务端发生异常', '2019-06-20 12:32:17');
INSERT INTO `access_log` VALUES (39797, '65.51.15610051368507207', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:32:17', 153, 0, '', '2019-06-20 12:32:17');
INSERT INTO `access_log` VALUES (39798, '65.49.15610051368617197', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:32:17', 144, 0, '', '2019-06-20 12:32:17');
INSERT INTO `access_log` VALUES (39799, '65.47.15610051573137177', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:32:37', 7, 0, '', '2019-06-20 12:32:37');
INSERT INTO `access_log` VALUES (39800, '65.50.15610051573227191', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:32:37', 8, 2001001000, '服务端发生异常', '2019-06-20 12:32:37');
INSERT INTO `access_log` VALUES (39801, '65.53.15610051573277175', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '116.247.112.153', '2019-06-20 12:32:37', 8, 0, '', '2019-06-20 12:32:37');
INSERT INTO `access_log` VALUES (39802, '65.45.15610051797097183', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.247.112.153', '2019-06-20 12:33:00', 1, 1002001015, '账号未登陆', '2019-06-20 12:33:00');
INSERT INTO `access_log` VALUES (39803, '65.52.15610051797167193', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.247.112.153', '2019-06-20 12:33:00', 1, 1002001015, '账号未登陆', '2019-06-20 12:33:00');
INSERT INTO `access_log` VALUES (39804, '65.51.15610051797277209', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.247.112.153', '2019-06-20 12:33:00', 0, 1002001015, '账号未登陆', '2019-06-20 12:33:00');
INSERT INTO `access_log` VALUES (39805, '65.49.15610051843607199', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.247.112.153', '2019-06-20 12:33:04', 91, 0, '', '2019-06-20 12:33:04');
INSERT INTO `access_log` VALUES (39806, '65.54.15610051846827141', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.247.112.153', '2019-06-20 12:33:05', 9, 0, '', '2019-06-20 12:33:05');
INSERT INTO `access_log` VALUES (39807, '65.47.15610051846877179', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.247.112.153', '2019-06-20 12:33:05', 18, 2001001000, '服务端发生异常', '2019-06-20 12:33:05');
INSERT INTO `access_log` VALUES (39808, '65.53.15610051846917177', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.247.112.153', '2019-06-20 12:33:05', 19, 0, '', '2019-06-20 12:33:05');
INSERT INTO `access_log` VALUES (39809, '65.46.15610064136327233', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-06-20 12:53:34', 0, 1002001015, '账号未登陆', '2019-06-20 12:53:34');
INSERT INTO `access_log` VALUES (39810, '65.45.15610064136417201', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-06-20 12:53:34', 1, 1002001015, '账号未登陆', '2019-06-20 12:53:34');
INSERT INTO `access_log` VALUES (39811, '65.51.15610064139327227', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-06-20 12:53:34', 1, 1002001015, '账号未登陆', '2019-06-20 12:53:34');
INSERT INTO `access_log` VALUES (39812, '65.49.15610064218417217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-06-20 12:53:42', 97, 0, '', '2019-06-20 12:53:42');
INSERT INTO `access_log` VALUES (39813, '65.54.15610064228127159', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-06-20 12:53:43', 9, 0, '', '2019-06-20 12:53:43');
INSERT INTO `access_log` VALUES (39814, '65.53.15610064228177195', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-06-20 12:53:43', 10, 2001001000, '服务端发生异常', '2019-06-20 12:53:43');
INSERT INTO `access_log` VALUES (39815, '65.47.15610064229297197', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-06-20 12:53:43', 10, 0, '', '2019-06-20 12:53:43');
INSERT INTO `access_log` VALUES (39816, '65.50.15610064288607211', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-06-20 12:53:49', 9, 0, '', '2019-06-20 12:53:49');
INSERT INTO `access_log` VALUES (39817, '65.46.15610064288637235', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-06-20 12:53:49', 9, 0, '', '2019-06-20 12:53:49');
INSERT INTO `access_log` VALUES (39818, '65.3607.15610064288628969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-06-20 12:53:49', 9, 2001001000, '服务端发生异常', '2019-06-20 12:53:49');
INSERT INTO `access_log` VALUES (39819, '59.71.15610076196196343', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.81.237.133', '2019-06-20 13:13:40', 11, 0, '', '2019-06-20 13:13:40');
INSERT INTO `access_log` VALUES (39820, '59.77.15610076196196331', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.81.237.133', '2019-06-20 13:13:40', 17, 2001001000, '服务端发生异常', '2019-06-20 13:13:40');
INSERT INTO `access_log` VALUES (39821, '64.78.15610076271606327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.81.237.133', '2019-06-20 13:13:47', 10, 0, '', '2019-06-20 13:13:47');
INSERT INTO `access_log` VALUES (39822, '64.79.15610076272546325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.81.237.133', '2019-06-20 13:13:47', 3, 0, '', '2019-06-20 13:13:47');
INSERT INTO `access_log` VALUES (39823, '65.46.15610077552467255', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.81.237.133', '2019-06-20 13:15:55', 1, 1002001015, '账号未登陆', '2019-06-20 13:15:55');
INSERT INTO `access_log` VALUES (39824, '65.3607.15610077552478987', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.81.237.133', '2019-06-20 13:15:55', 1, 1002001015, '账号未登陆', '2019-06-20 13:15:55');
INSERT INTO `access_log` VALUES (39825, '65.45.15610077552527221', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.81.237.133', '2019-06-20 13:15:55', 0, 1002001015, '账号未登陆', '2019-06-20 13:15:55');
INSERT INTO `access_log` VALUES (39826, '65.51.15610077569987247', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.81.237.133', '2019-06-20 13:15:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 13:15:57');
INSERT INTO `access_log` VALUES (39827, '59.78.15610082818826351', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '58.132.171.108', '2019-06-20 13:24:42', 4, 0, '', '2019-06-20 13:24:42');
INSERT INTO `access_log` VALUES (39828, '59.75.15610082818836353', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '58.132.171.108', '2019-06-20 13:24:42', 14, 2001001000, '服务端发生异常', '2019-06-20 13:24:42');
INSERT INTO `access_log` VALUES (39829, '64.80.15610082868656335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '58.132.171.108', '2019-06-20 13:24:47', 4, 0, '', '2019-06-20 13:24:47');
INSERT INTO `access_log` VALUES (39830, '64.84.15610082870096325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '58.132.171.108', '2019-06-20 13:24:47', 2, 0, '', '2019-06-20 13:24:47');
INSERT INTO `access_log` VALUES (39831, '59.79.15610082901696357', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '58.132.171.108', '2019-06-20 13:24:50', 3, 0, '', '2019-06-20 13:24:50');
INSERT INTO `access_log` VALUES (39832, '59.71.15610082901696353', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '58.132.171.108', '2019-06-20 13:24:50', 12, 2001001000, '服务端发生异常', '2019-06-20 13:24:50');
INSERT INTO `access_log` VALUES (39833, '59.76.15610083241606347', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:25:24', 2, 0, '', '2019-06-20 13:25:24');
INSERT INTO `access_log` VALUES (39834, '59.74.15610083241606351', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:25:24', 11, 2001001000, '服务端发生异常', '2019-06-20 13:25:24');
INSERT INTO `access_log` VALUES (39835, '64.79.15610083301276335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:25:30', 2, 0, '', '2019-06-20 13:25:30');
INSERT INTO `access_log` VALUES (39836, '64.82.15610083303496347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:25:30', 2, 0, '', '2019-06-20 13:25:30');
INSERT INTO `access_log` VALUES (39837, '64.81.15610083318736331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:25:32', 2, 0, '', '2019-06-20 13:25:32');
INSERT INTO `access_log` VALUES (39838, '64.77.15610083322156337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:25:32', 2, 0, '', '2019-06-20 13:25:32');
INSERT INTO `access_log` VALUES (39839, '59.78.15610083346376353', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:25:35', 3, 0, '', '2019-06-20 13:25:35');
INSERT INTO `access_log` VALUES (39840, '59.75.15610083346456355', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:25:35', 18, 2001001000, '服务端发生异常', '2019-06-20 13:25:35');
INSERT INTO `access_log` VALUES (39841, '64.80.15610083371946337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:25:37', 2, 0, '', '2019-06-20 13:25:37');
INSERT INTO `access_log` VALUES (39842, '64.84.15610083374126327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:25:37', 1, 0, '', '2019-06-20 13:25:37');
INSERT INTO `access_log` VALUES (39843, '64.83.15610083398596329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:25:40', 1, 0, '', '2019-06-20 13:25:40');
INSERT INTO `access_log` VALUES (39844, '64.85.15610083400796351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:25:40', 2, 0, '', '2019-06-20 13:25:40');
INSERT INTO `access_log` VALUES (39845, '64.78.15610083416436339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:25:42', 1, 0, '', '2019-06-20 13:25:42');
INSERT INTO `access_log` VALUES (39846, '64.79.15610083418566337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:25:42', 9, 0, '', '2019-06-20 13:25:42');
INSERT INTO `access_log` VALUES (39847, '59.79.15610094017876373', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '42.120.74.125', '2019-06-20 13:43:22', 3, 0, '', '2019-06-20 13:43:22');
INSERT INTO `access_log` VALUES (39848, '59.71.15610094017916369', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '42.120.74.125', '2019-06-20 13:43:22', 12, 2001001000, '服务端发生异常', '2019-06-20 13:43:22');
INSERT INTO `access_log` VALUES (39849, '59.72.15610094157046365', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.125', '2019-06-20 13:43:36', 2, 0, '', '2019-06-20 13:43:36');
INSERT INTO `access_log` VALUES (39850, '59.76.15610094157056363', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.125', '2019-06-20 13:43:36', 13, 2001001000, '服务端发生异常', '2019-06-20 13:43:36');
INSERT INTO `access_log` VALUES (39851, '59.73.15610094213796375', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '42.120.74.125', '2019-06-20 13:43:41', 5, 0, '', '2019-06-20 13:43:41');
INSERT INTO `access_log` VALUES (39852, '59.74.15610094213796367', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '42.120.74.125', '2019-06-20 13:43:41', 13, 2001001000, '服务端发生异常', '2019-06-20 13:43:41');
INSERT INTO `access_log` VALUES (39853, '64.77.15610094234266353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '42.120.74.125', '2019-06-20 13:43:43', 3, 0, '', '2019-06-20 13:43:43');
INSERT INTO `access_log` VALUES (39854, '64.76.15610094235536337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '42.120.74.125', '2019-06-20 13:43:44', 2, 0, '', '2019-06-20 13:43:44');
INSERT INTO `access_log` VALUES (39855, '64.84.15610094321806343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '42.120.74.125', '2019-06-20 13:43:52', 2, 0, '', '2019-06-20 13:43:52');
INSERT INTO `access_log` VALUES (39856, '64.83.15610094322676345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '42.120.74.125', '2019-06-20 13:43:52', 2, 0, '', '2019-06-20 13:43:52');
INSERT INTO `access_log` VALUES (39857, '59.80.15610094386946359', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '42.120.74.125', '2019-06-20 13:43:59', 3, 0, '', '2019-06-20 13:43:59');
INSERT INTO `access_log` VALUES (39858, '59.78.15610094386946369', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '42.120.74.125', '2019-06-20 13:43:59', 13, 2001001000, '服务端发生异常', '2019-06-20 13:43:59');
INSERT INTO `access_log` VALUES (39859, '65.49.15610094493077259', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '42.120.74.125', '2019-06-20 13:44:09', 0, 1002001015, '账号未登陆', '2019-06-20 13:44:09');
INSERT INTO `access_log` VALUES (39860, '65.53.15610094493087237', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '42.120.74.125', '2019-06-20 13:44:09', 0, 1002001015, '账号未登陆', '2019-06-20 13:44:09');
INSERT INTO `access_log` VALUES (39861, '65.50.15610094493257255', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '42.120.74.125', '2019-06-20 13:44:09', 0, 1002001015, '账号未登陆', '2019-06-20 13:44:09');
INSERT INTO `access_log` VALUES (39862, '65.47.15610094537077241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '42.120.74.125', '2019-06-20 13:44:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 13:44:14');
INSERT INTO `access_log` VALUES (39863, '65.46.15610094583297279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '42.120.74.125', '2019-06-20 13:44:18', 71, 0, '', '2019-06-20 13:44:18');
INSERT INTO `access_log` VALUES (39864, '65.3607.15610094589319011', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '42.120.74.125', '2019-06-20 13:44:19', 40, 0, '', '2019-06-20 13:44:19');
INSERT INTO `access_log` VALUES (39865, '65.51.15610094589347273', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '42.120.74.125', '2019-06-20 13:44:19', 38, 0, '', '2019-06-20 13:44:19');
INSERT INTO `access_log` VALUES (39866, '65.52.15610094589327255', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '42.120.74.125', '2019-06-20 13:44:19', 41, 2001001000, '服务端发生异常', '2019-06-20 13:44:19');
INSERT INTO `access_log` VALUES (39867, '62.89.15610099293456039', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 13:52:09', 13, 1002001012, '访问令牌已过期', '2019-06-20 13:52:09');
INSERT INTO `access_log` VALUES (39868, '65.53.15610099316047245', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 13:52:12', 136, 0, '', '2019-06-20 13:52:12');
INSERT INTO `access_log` VALUES (39869, '65.50.15610099321097263', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 13:52:12', 9, 0, '', '2019-06-20 13:52:12');
INSERT INTO `access_log` VALUES (39870, '65.49.15610099321127267', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 13:52:12', 8, 0, '', '2019-06-20 13:52:12');
INSERT INTO `access_log` VALUES (39871, '65.47.15610099321177249', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 13:52:12', 8, 0, '', '2019-06-20 13:52:12');
INSERT INTO `access_log` VALUES (39872, '62.81.15610099347926003', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 13:52:15', 54, 0, '', '2019-06-20 13:52:15');
INSERT INTO `access_log` VALUES (39873, '59.72.15610099400656373', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 13:52:20', 12, 0, '', '2019-06-20 13:52:20');
INSERT INTO `access_log` VALUES (39874, '59.74.15610099436606375', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 13:52:24', 147, 0, '', '2019-06-20 13:52:24');
INSERT INTO `access_log` VALUES (39875, '62.85.15610099469606019', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '222.240.37.213', '2019-06-20 13:52:27', 13, 0, '', '2019-06-20 13:52:27');
INSERT INTO `access_log` VALUES (39876, '65.3607.15610101140039021', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.43.87', '2019-06-20 13:55:14', 1, 1002001015, '账号未登陆', '2019-06-20 13:55:14');
INSERT INTO `access_log` VALUES (39877, '65.51.15610101140397283', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.43.87', '2019-06-20 13:55:14', 1, 1002001015, '账号未登陆', '2019-06-20 13:55:14');
INSERT INTO `access_log` VALUES (39878, '65.45.15610101140397255', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.43.87', '2019-06-20 13:55:14', 0, 1002001015, '账号未登陆', '2019-06-20 13:55:14');
INSERT INTO `access_log` VALUES (39879, '65.54.15610101160627215', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.43.87', '2019-06-20 13:55:16', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 13:55:16');
INSERT INTO `access_log` VALUES (39880, '65.50.15610101307427267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.43.87', '2019-06-20 13:55:31', 79, 0, '', '2019-06-20 13:55:31');
INSERT INTO `access_log` VALUES (39881, '65.49.15610101311387271', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.43.87', '2019-06-20 13:55:31', 9, 0, '', '2019-06-20 13:55:31');
INSERT INTO `access_log` VALUES (39882, '65.47.15610101311437253', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.43.87', '2019-06-20 13:55:31', 9, 2001001000, '服务端发生异常', '2019-06-20 13:55:31');
INSERT INTO `access_log` VALUES (39883, '65.46.15610101311777291', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.43.87', '2019-06-20 13:55:31', 9, 0, '', '2019-06-20 13:55:31');
INSERT INTO `access_log` VALUES (39884, '65.51.15610101515677285', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.43.87', '2019-06-20 13:55:52', 9, 0, '', '2019-06-20 13:55:52');
INSERT INTO `access_log` VALUES (39885, '65.3607.15610101515699023', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.43.87', '2019-06-20 13:55:52', 9, 2001001000, '服务端发生异常', '2019-06-20 13:55:52');
INSERT INTO `access_log` VALUES (39886, '65.45.15610101515737257', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.43.87', '2019-06-20 13:55:52', 9, 0, '', '2019-06-20 13:55:52');
INSERT INTO `access_log` VALUES (39887, '65.49.15610102038337273', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.178.80.202', '2019-06-20 13:56:44', 0, 1002001015, '账号未登陆', '2019-06-20 13:56:44');
INSERT INTO `access_log` VALUES (39888, '65.46.15610102038347293', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.178.80.202', '2019-06-20 13:56:44', 1, 1002001015, '账号未登陆', '2019-06-20 13:56:44');
INSERT INTO `access_log` VALUES (39889, '65.52.15610102038367269', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.178.80.202', '2019-06-20 13:56:44', 0, 1002001015, '账号未登陆', '2019-06-20 13:56:44');
INSERT INTO `access_log` VALUES (39890, '65.51.15610102076937287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.178.80.202', '2019-06-20 13:56:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 13:56:48');
INSERT INTO `access_log` VALUES (39891, '65.45.15610102106657259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.178.80.202', '2019-06-20 13:56:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 13:56:51');
INSERT INTO `access_log` VALUES (39892, '64.77.15610102587246365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:57:39', 3, 0, '', '2019-06-20 13:57:39');
INSERT INTO `access_log` VALUES (39893, '64.76.15610102592116349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:57:39', 2, 0, '', '2019-06-20 13:57:39');
INSERT INTO `access_log` VALUES (39894, '59.75.15610102607336383', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:57:41', 3, 0, '', '2019-06-20 13:57:41');
INSERT INTO `access_log` VALUES (39895, '59.80.15610102607366371', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:57:41', 10, 2001001000, '服务端发生异常', '2019-06-20 13:57:41');
INSERT INTO `access_log` VALUES (39896, '64.80.15610102634436365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:57:43', 2, 0, '', '2019-06-20 13:57:43');
INSERT INTO `access_log` VALUES (39897, '64.84.15610102636736355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:57:44', 2, 0, '', '2019-06-20 13:57:44');
INSERT INTO `access_log` VALUES (39898, '59.78.15610102643836381', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:57:44', 3, 0, '', '2019-06-20 13:57:44');
INSERT INTO `access_log` VALUES (39899, '59.79.15610102643836387', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9500 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/8040 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '114.242.249.40', '2019-06-20 13:57:44', 13, 2001001000, '服务端发生异常', '2019-06-20 13:57:44');
INSERT INTO `access_log` VALUES (39900, '65.49.15610103061007275', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.178.80.202', '2019-06-20 13:58:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 13:58:26');
INSERT INTO `access_log` VALUES (39901, '65.51.15610103087727289', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.178.80.202', '2019-06-20 13:58:29', 187, 0, '', '2019-06-20 13:58:29');
INSERT INTO `access_log` VALUES (39902, '65.45.15610103091877261', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.178.80.202', '2019-06-20 13:58:29', 8, 0, '', '2019-06-20 13:58:29');
INSERT INTO `access_log` VALUES (39903, '65.3607.15610103091909027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.178.80.202', '2019-06-20 13:58:29', 8, 2001001000, '服务端发生异常', '2019-06-20 13:58:29');
INSERT INTO `access_log` VALUES (39904, '65.54.15610103091947221', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '220.178.80.202', '2019-06-20 13:58:29', 8, 0, '', '2019-06-20 13:58:29');
INSERT INTO `access_log` VALUES (39905, '59.80.15610103596866373', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.43.87', '2019-06-20 13:59:20', 2, 0, '', '2019-06-20 13:59:20');
INSERT INTO `access_log` VALUES (39906, '59.78.15610103596896383', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.54.43.87', '2019-06-20 13:59:20', 13, 2001001000, '服务端发生异常', '2019-06-20 13:59:20');
INSERT INTO `access_log` VALUES (39907, '59.77.15610105503096375', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:30', 3, 0, '', '2019-06-20 14:02:30');
INSERT INTO `access_log` VALUES (39908, '59.76.15610105503106381', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:30', 12, 2001001000, '服务端发生异常', '2019-06-20 14:02:30');
INSERT INTO `access_log` VALUES (39909, '65.54.15610105606407225', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:41', 0, 1002001015, '账号未登陆', '2019-06-20 14:02:41');
INSERT INTO `access_log` VALUES (39910, '65.3607.15610105606429031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:41', 0, 1002001015, '账号未登陆', '2019-06-20 14:02:41');
INSERT INTO `access_log` VALUES (39911, '65.45.15610105606457265', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:41', 0, 1002001015, '账号未登陆', '2019-06-20 14:02:41');
INSERT INTO `access_log` VALUES (39912, '65.53.15610105628217259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:43');
INSERT INTO `access_log` VALUES (39913, '65.50.15610105647057277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:45');
INSERT INTO `access_log` VALUES (39914, '65.47.15610105654427263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:45');
INSERT INTO `access_log` VALUES (39915, '65.52.15610105661307277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:46');
INSERT INTO `access_log` VALUES (39916, '65.46.15610105666427301', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:47', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:47');
INSERT INTO `access_log` VALUES (39917, '65.49.15610105669047281', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:47');
INSERT INTO `access_log` VALUES (39918, '65.51.15610105671397295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:47');
INSERT INTO `access_log` VALUES (39919, '65.54.15610105673547227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:47');
INSERT INTO `access_log` VALUES (39920, '65.45.15610105677957267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:48');
INSERT INTO `access_log` VALUES (39921, '65.3607.15610105680079033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:48');
INSERT INTO `access_log` VALUES (39922, '65.53.15610105684187261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:48', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:48');
INSERT INTO `access_log` VALUES (39923, '65.50.15610105686427279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:49', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:49');
INSERT INTO `access_log` VALUES (39924, '65.47.15610105690567265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:49', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:49');
INSERT INTO `access_log` VALUES (39925, '65.52.15610105694417279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:49');
INSERT INTO `access_log` VALUES (39926, '65.46.15610105698257303', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:02:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:02:50');
INSERT INTO `access_log` VALUES (39927, '65.51.15610105853177297', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:03:05', 293, 0, '', '2019-06-20 14:03:06');
INSERT INTO `access_log` VALUES (39928, '65.45.15610105859707269', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:03:06', 8, 0, '', '2019-06-20 14:03:06');
INSERT INTO `access_log` VALUES (39929, '65.54.15610105859707229', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:03:06', 9, 0, '', '2019-06-20 14:03:06');
INSERT INTO `access_log` VALUES (39930, '65.3607.15610105859719035', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.69.254.214', '2019-06-20 14:03:06', 10, 2001001000, '服务端发生异常', '2019-06-20 14:03:06');
INSERT INTO `access_log` VALUES (39931, '59.74.15610108416696389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '1.119.195.153', '2019-06-20 14:07:22', 2, 0, '', '2019-06-20 14:07:22');
INSERT INTO `access_log` VALUES (39932, '59.72.15610108416636387', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '1.119.195.153', '2019-06-20 14:07:22', 10, 2001001000, '服务端发生异常', '2019-06-20 14:07:22');
INSERT INTO `access_log` VALUES (39933, '65.45.15610108504157273', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '1.119.195.153', '2019-06-20 14:07:30', 1, 1002001015, '账号未登陆', '2019-06-20 14:07:30');
INSERT INTO `access_log` VALUES (39934, '65.54.15610108504157233', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '1.119.195.153', '2019-06-20 14:07:30', 1, 1002001015, '账号未登陆', '2019-06-20 14:07:30');
INSERT INTO `access_log` VALUES (39935, '65.53.15610108504237267', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '1.119.195.153', '2019-06-20 14:07:30', 0, 1002001015, '账号未登陆', '2019-06-20 14:07:30');
INSERT INTO `access_log` VALUES (39936, '65.50.15610108526847285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '1.119.195.153', '2019-06-20 14:07:33', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 14:07:33');
INSERT INTO `access_log` VALUES (39937, '65.52.15610108614257285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '1.119.195.153', '2019-06-20 14:07:41', 73, 0, '', '2019-06-20 14:07:41');
INSERT INTO `access_log` VALUES (39938, '65.46.15610108618417309', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '1.119.195.153', '2019-06-20 14:07:42', 9, 0, '', '2019-06-20 14:07:42');
INSERT INTO `access_log` VALUES (39939, '65.49.15610108618517289', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '1.119.195.153', '2019-06-20 14:07:42', 9, 2001001000, '服务端发生异常', '2019-06-20 14:07:42');
INSERT INTO `access_log` VALUES (39940, '65.51.15610108618597303', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '1.119.195.153', '2019-06-20 14:07:42', 8, 0, '', '2019-06-20 14:07:42');
INSERT INTO `access_log` VALUES (39941, '59.71.15610109175666393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.209.88.46', '2019-06-20 14:08:38', 3, 0, '', '2019-06-20 14:08:38');
INSERT INTO `access_log` VALUES (39942, '59.76.15610109175666387', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.209.88.46', '2019-06-20 14:08:38', 19, 2001001000, '服务端发生异常', '2019-06-20 14:08:38');
INSERT INTO `access_log` VALUES (39943, '65.50.15610109278737287', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.209.88.46', '2019-06-20 14:08:48', 1, 1002001015, '账号未登陆', '2019-06-20 14:08:48');
INSERT INTO `access_log` VALUES (39944, '65.47.15610109278777273', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.209.88.46', '2019-06-20 14:08:48', 0, 1002001015, '账号未登陆', '2019-06-20 14:08:48');
INSERT INTO `access_log` VALUES (39945, '65.52.15610109278847287', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.209.88.46', '2019-06-20 14:08:48', 0, 1002001015, '账号未登陆', '2019-06-20 14:08:48');
INSERT INTO `access_log` VALUES (39946, '65.46.15610109331627311', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.209.88.46', '2019-06-20 14:08:53', 55, 0, '', '2019-06-20 14:08:53');
INSERT INTO `access_log` VALUES (39947, '65.49.15610109334517291', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.209.88.46', '2019-06-20 14:08:53', 9, 0, '', '2019-06-20 14:08:53');
INSERT INTO `access_log` VALUES (39948, '65.51.15610109334547305', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.209.88.46', '2019-06-20 14:08:53', 9, 2001001000, '服务端发生异常', '2019-06-20 14:08:53');
INSERT INTO `access_log` VALUES (39949, '65.3607.15610109334579043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.209.88.46', '2019-06-20 14:08:53', 9, 0, '', '2019-06-20 14:08:53');
INSERT INTO `access_log` VALUES (39950, '65.45.15610148117667329', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:13:32', 0, 1002001015, '账号未登陆', '2019-06-20 15:13:32');
INSERT INTO `access_log` VALUES (39951, '65.52.15610148117667341', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:13:32', 0, 1002001015, '账号未登陆', '2019-06-20 15:13:32');
INSERT INTO `access_log` VALUES (39952, '65.50.15610148117677343', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:13:32', 0, 1002001015, '账号未登陆', '2019-06-20 15:13:32');
INSERT INTO `access_log` VALUES (39953, '65.53.15610148251957325', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:13:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 15:13:45');
INSERT INTO `access_log` VALUES (39954, '59.77.15610148271166433', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:13:47', 12, 0, '', '2019-06-20 15:13:47');
INSERT INTO `access_log` VALUES (39955, '59.74.15610148271176443', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:13:47', 15, 2001001000, '服务端发生异常', '2019-06-20 15:13:47');
INSERT INTO `access_log` VALUES (39956, '64.85.15610148310076441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:13:51', 16, 0, '', '2019-06-20 15:13:51');
INSERT INTO `access_log` VALUES (39957, '64.84.15610148311346417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:13:51', 2, 0, '', '2019-06-20 15:13:51');
INSERT INTO `access_log` VALUES (39958, '64.83.15610148323726419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:13:52', 2, 0, '', '2019-06-20 15:13:52');
INSERT INTO `access_log` VALUES (39959, '64.78.15610148329776429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:13:53', 2, 0, '', '2019-06-20 15:13:53');
INSERT INTO `access_log` VALUES (39960, '64.79.15610148335666427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:13:54', 2, 0, '', '2019-06-20 15:13:54');
INSERT INTO `access_log` VALUES (39961, '65.46.15610148352417369', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:13:55', 112, 0, '', '2019-06-20 15:13:55');
INSERT INTO `access_log` VALUES (39962, '59.73.15610148367236451', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:13:57', 3, 0, '', '2019-06-20 15:13:57');
INSERT INTO `access_log` VALUES (39963, '59.75.15610148367266447', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:13:57', 22, 2001001000, '服务端发生异常', '2019-06-20 15:13:57');
INSERT INTO `access_log` VALUES (39964, '65.54.15610148413157291', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:14:01', 13, 0, '', '2019-06-20 15:14:01');
INSERT INTO `access_log` VALUES (39965, '65.3607.15610148413159097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:14:01', 13, 0, '', '2019-06-20 15:14:01');
INSERT INTO `access_log` VALUES (39966, '65.47.15610148413157329', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:14:01', 13, 2001001000, '服务端发生异常', '2019-06-20 15:14:01');
INSERT INTO `access_log` VALUES (39967, '65.52.15610148470977343', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:14:07', 8, 0, '', '2019-06-20 15:14:07');
INSERT INTO `access_log` VALUES (39968, '65.45.15610148470997331', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:14:07', 9, 0, '', '2019-06-20 15:14:07');
INSERT INTO `access_log` VALUES (39969, '65.50.15610148471017345', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:14:07', 9, 2001001000, '服务端发生异常', '2019-06-20 15:14:07');
INSERT INTO `access_log` VALUES (39970, '59.78.15610148476046445', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:14:08', 3, 0, '', '2019-06-20 15:14:08');
INSERT INTO `access_log` VALUES (39971, '59.79.15610148476066451', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:14:08', 13, 2001001000, '服务端发生异常', '2019-06-20 15:14:08');
INSERT INTO `access_log` VALUES (39972, '65.53.15610148571427327', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:14:17', 16, 0, '', '2019-06-20 15:14:17');
INSERT INTO `access_log` VALUES (39973, '65.51.15610148571427361', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:14:17', 16, 0, '', '2019-06-20 15:14:17');
INSERT INTO `access_log` VALUES (39974, '65.46.15610148571517371', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:14:17', 10, 2001001000, '服务端发生异常', '2019-06-20 15:14:17');
INSERT INTO `access_log` VALUES (39975, '59.74.15610148831436445', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:14:43', 2, 0, '', '2019-06-20 15:14:43');
INSERT INTO `access_log` VALUES (39976, '59.77.15610148831466435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:14:43', 10, 2001001000, '服务端发生异常', '2019-06-20 15:14:43');
INSERT INTO `access_log` VALUES (39977, '64.76.15610148864966411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:14:46', 2, 0, '', '2019-06-20 15:14:47');
INSERT INTO `access_log` VALUES (39978, '64.80.15610148866066427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:14:47', 2, 0, '', '2019-06-20 15:14:47');
INSERT INTO `access_log` VALUES (39979, '59.73.15610148889326453', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:14:49', 12, 2001001000, '服务端发生异常', '2019-06-20 15:14:49');
INSERT INTO `access_log` VALUES (39980, '59.72.15610148889296443', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.119.38.88', '2019-06-20 15:14:49', 184, 0, '', '2019-06-20 15:14:49');
INSERT INTO `access_log` VALUES (39981, '65.54.15610148925327293', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:14:53', 32, 0, '', '2019-06-20 15:14:53');
INSERT INTO `access_log` VALUES (39982, '65.52.15610148926907345', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:14:53', 11, 2001001000, '服务端发生异常', '2019-06-20 15:14:53');
INSERT INTO `access_log` VALUES (39983, '65.50.15610148926937347', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '124.65.190.54', '2019-06-20 15:14:53', 9, 0, '', '2019-06-20 15:14:53');
INSERT INTO `access_log` VALUES (39984, '65.3607.15610159921799115', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:33:12', 1, 1002001015, '账号未登陆', '2019-06-20 15:33:12');
INSERT INTO `access_log` VALUES (39985, '65.51.15610159921797377', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:33:12', 1, 1002001015, '账号未登陆', '2019-06-20 15:33:12');
INSERT INTO `access_log` VALUES (39986, '65.47.15610159921797347', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:33:12', 1, 1002001015, '账号未登陆', '2019-06-20 15:33:12');
INSERT INTO `access_log` VALUES (39987, '65.54.15610160017787309', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:33:22', 93, 0, '', '2019-06-20 15:33:22');
INSERT INTO `access_log` VALUES (39988, '65.52.15610160022067361', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:33:22', 44, 0, '', '2019-06-20 15:33:22');
INSERT INTO `access_log` VALUES (39989, '65.50.15610160022067363', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:33:22', 45, 0, '', '2019-06-20 15:33:22');
INSERT INTO `access_log` VALUES (39990, '65.45.15610160022097349', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:33:22', 44, 2001001000, '服务端发生异常', '2019-06-20 15:33:22');
INSERT INTO `access_log` VALUES (39991, '59.77.15610160253656451', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:33:45', 4, 0, '', '2019-06-20 15:33:45');
INSERT INTO `access_log` VALUES (39992, '59.74.15610160253776461', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:33:45', 14, 2001001000, '服务端发生异常', '2019-06-20 15:33:45');
INSERT INTO `access_log` VALUES (39993, '64.81.15610160284506439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:33:48', 3, 0, '', '2019-06-20 15:33:48');
INSERT INTO `access_log` VALUES (39994, '64.77.15610160285806445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:33:49', 1, 0, '', '2019-06-20 15:33:49');
INSERT INTO `access_log` VALUES (39995, '64.76.15610160298086427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:33:50', 2, 0, '', '2019-06-20 15:33:50');
INSERT INTO `access_log` VALUES (39996, '64.80.15610160303336443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:33:50', 1, 0, '', '2019-06-20 15:33:50');
INSERT INTO `access_log` VALUES (39997, '64.84.15610160309436435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:33:51', 2, 0, '', '2019-06-20 15:33:51');
INSERT INTO `access_log` VALUES (39998, '64.77.15610161157426447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:35:16', 2, 0, '', '2019-06-20 15:35:16');
INSERT INTO `access_log` VALUES (39999, '59.80.15610163620406457', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:39:22', 3, 0, '', '2019-06-20 15:39:22');
INSERT INTO `access_log` VALUES (40000, '59.78.15610163620446467', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:39:22', 13, 2001001000, '服务端发生异常', '2019-06-20 15:39:22');
INSERT INTO `access_log` VALUES (40001, '59.79.15610163699546473', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:39:30', 9, 0, '', '2019-06-20 15:39:30');
INSERT INTO `access_log` VALUES (40002, '59.71.15610163699546469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:39:30', 13, 2001001000, '服务端发生异常', '2019-06-20 15:39:30');
INSERT INTO `access_log` VALUES (40003, '64.81.15610163786636445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:39:39', 2, 0, '', '2019-06-20 15:39:39');
INSERT INTO `access_log` VALUES (40004, '64.77.15610163788056451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:39:39', 2, 0, '', '2019-06-20 15:39:39');
INSERT INTO `access_log` VALUES (40005, '64.76.15610163881846433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:39:48', 2, 0, '', '2019-06-20 15:39:48');
INSERT INTO `access_log` VALUES (40006, '64.80.15610163886116449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:39:49', 2, 0, '', '2019-06-20 15:39:49');
INSERT INTO `access_log` VALUES (40007, '64.85.15610163895656465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:39:50', 2, 0, '', '2019-06-20 15:39:50');
INSERT INTO `access_log` VALUES (40008, '64.84.15610163901176441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:39:50', 2, 0, '', '2019-06-20 15:39:50');
INSERT INTO `access_log` VALUES (40009, '59.77.15610163915546457', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:39:52', 2, 0, '', '2019-06-20 15:39:52');
INSERT INTO `access_log` VALUES (40010, '59.73.15610163915556475', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '221.13.55.179', '2019-06-20 15:39:52', 13, 2001001000, '服务端发生异常', '2019-06-20 15:39:52');
INSERT INTO `access_log` VALUES (40011, '59.78.15610174806816483', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.228.88.122', '2019-06-20 15:58:01', 3, 0, '', '2019-06-20 15:58:01');
INSERT INTO `access_log` VALUES (40012, '59.80.15610174806816473', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.228.88.122', '2019-06-20 15:58:01', 13, 2001001000, '服务端发生异常', '2019-06-20 15:58:01');
INSERT INTO `access_log` VALUES (40013, '59.71.15610174925066485', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:13', 2, 0, '', '2019-06-20 15:58:13');
INSERT INTO `access_log` VALUES (40014, '59.76.15610174925066479', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:13', 12, 2001001000, '服务端发生异常', '2019-06-20 15:58:13');
INSERT INTO `access_log` VALUES (40015, '64.79.15610174945786467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:15', 2, 0, '', '2019-06-20 15:58:15');
INSERT INTO `access_log` VALUES (40016, '64.82.15610174946666477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:15', 2, 0, '', '2019-06-20 15:58:15');
INSERT INTO `access_log` VALUES (40017, '64.81.15610174962216461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:16', 2, 0, '', '2019-06-20 15:58:16');
INSERT INTO `access_log` VALUES (40018, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:16', 7, 0, '', '2019-06-20 15:58:16');
INSERT INTO `access_log` VALUES (40019, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:17', 6, 0, '', '2019-06-20 15:58:17');
INSERT INTO `access_log` VALUES (40020, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:18', 5, 0, '', '2019-06-20 15:58:18');
INSERT INTO `access_log` VALUES (40021, '64.80.15610174989196467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:19', 2, 0, '', '2019-06-20 15:58:19');
INSERT INTO `access_log` VALUES (40022, '64.77.15610174989896467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:19', 1, 0, '', '2019-06-20 15:58:19');
INSERT INTO `access_log` VALUES (40023, '64.76.15610175023986451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:22', 2, 0, '', '2019-06-20 15:58:22');
INSERT INTO `access_log` VALUES (40024, '64.84.15610175024706459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:22', 2, 0, '', '2019-06-20 15:58:22');
INSERT INTO `access_log` VALUES (40025, '59.73.15610175037756491', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:24', 2, 0, '', '2019-06-20 15:58:24');
INSERT INTO `access_log` VALUES (40026, '59.77.15610175037756473', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:24', 12, 2001001000, '服务端发生异常', '2019-06-20 15:58:24');
INSERT INTO `access_log` VALUES (40027, '64.83.15610175060756461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:26', 1, 0, '', '2019-06-20 15:58:26');
INSERT INTO `access_log` VALUES (40028, '64.78.15610175061576469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:26', 2, 0, '', '2019-06-20 15:58:26');
INSERT INTO `access_log` VALUES (40029, '64.79.15610175074106469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:27', 2, 0, '', '2019-06-20 15:58:27');
INSERT INTO `access_log` VALUES (40030, '64.82.15610175082206479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:28', 2, 0, '', '2019-06-20 15:58:28');
INSERT INTO `access_log` VALUES (40031, '64.81.15610175092756463', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:29', 2, 0, '', '2019-06-20 15:58:29');
INSERT INTO `access_log` VALUES (40032, '64.80.15610175134526469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:33', 2, 0, '', '2019-06-20 15:58:33');
INSERT INTO `access_log` VALUES (40033, '64.77.15610175135506469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:34', 2, 0, '', '2019-06-20 15:58:34');
INSERT INTO `access_log` VALUES (40034, '64.84.15610175369896461', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.228.88.122', '2019-06-20 15:58:57', 4, 1003002003, 'Spu 只能添加在二级分类下', '2019-06-20 15:58:57');
INSERT INTO `access_log` VALUES (40035, '59.71.15610184859606499', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.39', '2019-06-20 16:14:46', 4, 0, '', '2019-06-20 16:14:46');
INSERT INTO `access_log` VALUES (40036, '59.76.15610184859616493', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.39', '2019-06-20 16:14:46', 13, 2001001000, '服务端发生异常', '2019-06-20 16:14:46');
INSERT INTO `access_log` VALUES (40037, '59.77.15610185059716487', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:15:06', 3, 0, '', '2019-06-20 16:15:06');
INSERT INTO `access_log` VALUES (40038, '59.75.15610185059766501', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:15:06', 13, 2001001000, '服务端发生异常', '2019-06-20 16:15:06');
INSERT INTO `access_log` VALUES (40039, '64.80.15610185085736483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:15:09', 2, 0, '', '2019-06-20 16:15:09');
INSERT INTO `access_log` VALUES (40040, '64.77.15610185089776483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:15:09', 2, 0, '', '2019-06-20 16:15:09');
INSERT INTO `access_log` VALUES (40041, '64.85.15610185108366497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:15:11', 2, 0, '', '2019-06-20 16:15:11');
INSERT INTO `access_log` VALUES (40042, '64.76.15610185119356467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:15:12', 2, 0, '', '2019-06-20 16:15:12');
INSERT INTO `access_log` VALUES (40043, '64.84.15610185145556475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:15:15', 2, 0, '', '2019-06-20 16:15:15');
INSERT INTO `access_log` VALUES (40044, '64.83.15610185147556477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:15:15', 2, 0, '', '2019-06-20 16:15:15');
INSERT INTO `access_log` VALUES (40045, '59.76.15610185696556495', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:10', 3, 0, '', '2019-06-20 16:16:10');
INSERT INTO `access_log` VALUES (40046, '59.71.15610185696496501', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:10', 10, 2001001000, '服务端发生异常', '2019-06-20 16:16:10');
INSERT INTO `access_log` VALUES (40047, '64.80.15610185757666485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:16', 2, 0, '', '2019-06-20 16:16:16');
INSERT INTO `access_log` VALUES (40048, '64.77.15610185759056485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:16', 2, 0, '', '2019-06-20 16:16:16');
INSERT INTO `access_log` VALUES (40049, '64.85.15610185768866499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:17', 2, 0, '', '2019-06-20 16:16:17');
INSERT INTO `access_log` VALUES (40050, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:17', 6, 0, '', '2019-06-20 16:16:17');
INSERT INTO `access_log` VALUES (40051, '64.76.15610185782606469', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:18', 8, 0, '', '2019-06-20 16:16:18');
INSERT INTO `access_log` VALUES (40052, '64.83.15610185851806479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:25', 2, 0, '', '2019-06-20 16:16:25');
INSERT INTO `access_log` VALUES (40053, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:25', 6, 0, '', '2019-06-20 16:16:25');
INSERT INTO `access_log` VALUES (40054, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:31', 6, 0, '', '2019-06-20 16:16:31');
INSERT INTO `access_log` VALUES (40055, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:32', 6, 0, '', '2019-06-20 16:16:32');
INSERT INTO `access_log` VALUES (40056, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:33', 5, 0, '', '2019-06-20 16:16:33');
INSERT INTO `access_log` VALUES (40057, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:34', 6, 0, '', '2019-06-20 16:16:34');
INSERT INTO `access_log` VALUES (40058, '64.79.15610185965536487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:37', 2, 0, '', '2019-06-20 16:16:37');
INSERT INTO `access_log` VALUES (40059, '64.82.15610185968176497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:37', 1, 0, '', '2019-06-20 16:16:37');
INSERT INTO `access_log` VALUES (40060, '64.81.15610185979136481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:38', 2, 0, '', '2019-06-20 16:16:38');
INSERT INTO `access_log` VALUES (40061, '64.80.15610185989056487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:39', 2, 0, '', '2019-06-20 16:16:39');
INSERT INTO `access_log` VALUES (40062, '64.77.15610186006866487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:41', 2, 0, '', '2019-06-20 16:16:41');
INSERT INTO `access_log` VALUES (40063, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:41', 6, 0, '', '2019-06-20 16:16:41');
INSERT INTO `access_log` VALUES (40064, '64.85.15610186030806501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:43', 2, 0, '', '2019-06-20 16:16:43');
INSERT INTO `access_log` VALUES (40065, '64.76.15610186032396471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:43', 2, 0, '', '2019-06-20 16:16:43');
INSERT INTO `access_log` VALUES (40066, '64.84.15610186042996479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:44', 1, 0, '', '2019-06-20 16:16:44');
INSERT INTO `access_log` VALUES (40067, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:44', 5, 0, '', '2019-06-20 16:16:44');
INSERT INTO `access_log` VALUES (40068, '64.83.15610186053856481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:45', 1, 0, '', '2019-06-20 16:16:45');
INSERT INTO `access_log` VALUES (40069, '64.78.15610186055456489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:46', 1, 0, '', '2019-06-20 16:16:46');
INSERT INTO `access_log` VALUES (40070, '64.79.15610186061256489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:46', 2, 0, '', '2019-06-20 16:16:46');
INSERT INTO `access_log` VALUES (40071, '64.82.15610186068656499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:47', 2, 0, '', '2019-06-20 16:16:47');
INSERT INTO `access_log` VALUES (40072, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:16:47', 7, 0, '', '2019-06-20 16:16:47');
INSERT INTO `access_log` VALUES (40073, '59.80.15610186515856491', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:17:32', 3, 0, '', '2019-06-20 16:17:32');
INSERT INTO `access_log` VALUES (40074, '59.78.15610186515826501', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:17:32', 13, 2001001000, '服务端发生异常', '2019-06-20 16:17:32');
INSERT INTO `access_log` VALUES (40075, '64.85.15610186540016503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:17:34', 2, 0, '', '2019-06-20 16:17:34');
INSERT INTO `access_log` VALUES (40076, '64.76.15610186541886473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:17:34', 2, 0, '', '2019-06-20 16:17:34');
INSERT INTO `access_log` VALUES (40077, '64.84.15610186551276481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:17:35', 2, 0, '', '2019-06-20 16:17:35');
INSERT INTO `access_log` VALUES (40078, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:17:35', 6, 0, '', '2019-06-20 16:17:35');
INSERT INTO `access_log` VALUES (40079, '64.78.15610186562206491', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:17:36', 6, 0, '', '2019-06-20 16:17:36');
INSERT INTO `access_log` VALUES (40080, '64.79.15610186620806491', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:17:42', 7, 0, '', '2019-06-20 16:17:42');
INSERT INTO `access_log` VALUES (40081, '64.81.15610186711096485', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:17:51', 6, 0, '', '2019-06-20 16:17:51');
INSERT INTO `access_log` VALUES (40082, '64.80.15610186762486491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:17:56', 2, 0, '', '2019-06-20 16:17:56');
INSERT INTO `access_log` VALUES (40083, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:17:56', 6, 0, '', '2019-06-20 16:17:56');
INSERT INTO `access_log` VALUES (40084, '64.77.15610186797436491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:18:00', 2, 0, '', '2019-06-20 16:18:00');
INSERT INTO `access_log` VALUES (40085, '64.85.15610186799216505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:18:00', 1, 0, '', '2019-06-20 16:18:00');
INSERT INTO `access_log` VALUES (40086, '64.76.15610186821016475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:18:02', 2, 0, '', '2019-06-20 16:18:02');
INSERT INTO `access_log` VALUES (40087, '59.74.15610186824616501', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:02', 2, 0, '', '2019-06-20 16:18:02');
INSERT INTO `access_log` VALUES (40088, '59.71.15610186824616503', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:02', 15, 2001001000, '服务端发生异常', '2019-06-20 16:18:02');
INSERT INTO `access_log` VALUES (40089, '64.84.15610186829806483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:18:03', 2, 0, '', '2019-06-20 16:18:03');
INSERT INTO `access_log` VALUES (40090, '64.83.15610186838216485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:18:04', 2, 0, '', '2019-06-20 16:18:04');
INSERT INTO `access_log` VALUES (40091, '64.78.15610186845616493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:18:05', 2, 0, '', '2019-06-20 16:18:05');
INSERT INTO `access_log` VALUES (40092, '64.79.15610186852216493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:18:05', 2, 0, '', '2019-06-20 16:18:05');
INSERT INTO `access_log` VALUES (40093, '64.81.15610186857406487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:18:06', 2, 0, '', '2019-06-20 16:18:06');
INSERT INTO `access_log` VALUES (40094, '64.80.15610186882006493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:18:08', 2, 0, '', '2019-06-20 16:18:08');
INSERT INTO `access_log` VALUES (40095, '64.77.15610186889426493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:18:09', 2, 0, '', '2019-06-20 16:18:09');
INSERT INTO `access_log` VALUES (40096, '64.85.15610186896636507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:18:10', 2, 0, '', '2019-06-20 16:18:10');
INSERT INTO `access_log` VALUES (40097, '64.76.15610186916606477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:18:12', 2, 0, '', '2019-06-20 16:18:12');
INSERT INTO `access_log` VALUES (40098, '64.84.15610186918146485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '58.243.250.39', '2019-06-20 16:18:12', 2, 0, '', '2019-06-20 16:18:12');
INSERT INTO `access_log` VALUES (40099, '59.80.15610187226796493', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:43', 3, 0, '', '2019-06-20 16:18:43');
INSERT INTO `access_log` VALUES (40100, '59.72.15610187226796499', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:43', 13, 2001001000, '服务端发生异常', '2019-06-20 16:18:43');
INSERT INTO `access_log` VALUES (40101, '64.79.15610187252436495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:45', 2, 0, '', '2019-06-20 16:18:45');
INSERT INTO `access_log` VALUES (40102, '64.82.15610187253916505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:45', 2, 0, '', '2019-06-20 16:18:45');
INSERT INTO `access_log` VALUES (40103, '64.81.15610187274116489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:47', 2, 0, '', '2019-06-20 16:18:47');
INSERT INTO `access_log` VALUES (40104, '64.80.15610187282906495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:48', 2, 0, '', '2019-06-20 16:18:48');
INSERT INTO `access_log` VALUES (40105, '64.77.15610187295966495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:50', 1, 0, '', '2019-06-20 16:18:50');
INSERT INTO `access_log` VALUES (40106, '64.76.15610187307556479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:51', 2, 0, '', '2019-06-20 16:18:51');
INSERT INTO `access_log` VALUES (40107, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:51', 6, 0, '', '2019-06-20 16:18:51');
INSERT INTO `access_log` VALUES (40108, '64.84.15610187342706487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:54', 2, 0, '', '2019-06-20 16:18:54');
INSERT INTO `access_log` VALUES (40109, '64.83.15610187344506489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:54', 2, 0, '', '2019-06-20 16:18:54');
INSERT INTO `access_log` VALUES (40110, '64.78.15610187352016497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:55', 2, 0, '', '2019-06-20 16:18:55');
INSERT INTO `access_log` VALUES (40111, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:55', 5, 0, '', '2019-06-20 16:18:55');
INSERT INTO `access_log` VALUES (40112, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:57', 7, 0, '', '2019-06-20 16:18:57');
INSERT INTO `access_log` VALUES (40113, '64.79.15610187376876497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:58', 2, 0, '', '2019-06-20 16:18:58');
INSERT INTO `access_log` VALUES (40114, '64.82.15610187377656507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:58', 2, 0, '', '2019-06-20 16:18:58');
INSERT INTO `access_log` VALUES (40115, '64.81.15610187393616491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:59', 2, 0, '', '2019-06-20 16:18:59');
INSERT INTO `access_log` VALUES (40116, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:18:59', 5, 0, '', '2019-06-20 16:18:59');
INSERT INTO `access_log` VALUES (40117, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:19:01', 6, 0, '', '2019-06-20 16:19:01');
INSERT INTO `access_log` VALUES (40118, '64.80.15610187416866497', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:19:02', 6, 0, '', '2019-06-20 16:19:02');
INSERT INTO `access_log` VALUES (40119, '59.76.15610187490836499', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:19:09', 2, 0, '', '2019-06-20 16:19:09');
INSERT INTO `access_log` VALUES (40120, '59.74.15610187490836503', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.3(0x17000321) NetType/WIFI Language/zh_CN', '183.160.112.175', '2019-06-20 16:19:09', 13, 2001001000, '服务端发生异常', '2019-06-20 16:19:09');
INSERT INTO `access_log` VALUES (40121, '62.82.15610187611516145', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:19:21', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-20 16:19:21');
INSERT INTO `access_log` VALUES (40122, '62.81.15610187939196123', 0, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=1024&payChannel=1', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:19:54', 81, 2001001002, '参数校验不正确\n\n详细错误如下：\n支付渠道必须是 [100, 101, 200, 9999]', '2019-06-20 16:19:54');
INSERT INTO `access_log` VALUES (40123, '62.80.15610188174056155', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'createBeginTime=&createEndTime=&finishBeginTime=&finishEndTime=&pageNo=1&pageSize=10&payChannel=&status=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:20:17', 1, 1002001015, '账号未登陆', '2019-06-20 16:20:17');
INSERT INTO `access_log` VALUES (40124, '62.85.15610188688436139', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'createBeginTime=&createEndTime=&hasRefund=&orderSubject=&pageNo=1&pageSize=10&payChannel=&paymentBeginTime=&paymentEndTime=&status=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:21:09', 1, 1002001015, '账号未登陆', '2019-06-20 16:21:09');
INSERT INTO `access_log` VALUES (40125, '62.84.15610188745026135', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:21:15', 31, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-20 16:21:15');
INSERT INTO `access_log` VALUES (40126, '62.88.15610188824666149', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:21:22', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-20 16:21:22');
INSERT INTO `access_log` VALUES (40127, '62.80.15610188827066159', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:21:23', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-20 16:21:23');
INSERT INTO `access_log` VALUES (40128, '62.87.15610188831506149', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:21:23', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-20 16:21:23');
INSERT INTO `access_log` VALUES (40129, '62.86.15610188833706139', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:21:23', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-20 16:21:23');
INSERT INTO `access_log` VALUES (40130, '62.82.15610188837306151', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:21:24', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-20 16:21:24');
INSERT INTO `access_log` VALUES (40131, '62.85.15610188843876141', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:21:24', 5, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-20 16:21:24');
INSERT INTO `access_log` VALUES (40132, '62.89.15610188851636163', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:21:25', 5, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-20 16:21:25');
INSERT INTO `access_log` VALUES (40133, '62.84.15610188860276137', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:21:26', 5, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-20 16:21:26');
INSERT INTO `access_log` VALUES (40134, '62.81.15610188865636127', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:21:27', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-20 16:21:27');
INSERT INTO `access_log` VALUES (40135, '62.83.15610188869776157', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:21:27', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-20 16:21:27');
INSERT INTO `access_log` VALUES (40136, '62.88.15610188874226151', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-20 16:21:27', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-06-20 16:21:27');
INSERT INTO `access_log` VALUES (40137, '59.75.15610201470696525', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.59.211', '2019-06-20 16:42:27', 2, 0, '', '2019-06-20 16:42:27');
INSERT INTO `access_log` VALUES (40138, '59.72.15610201470706519', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.59.211', '2019-06-20 16:42:27', 10, 2001001000, '服务端发生异常', '2019-06-20 16:42:27');
INSERT INTO `access_log` VALUES (40139, '64.83.15610201522786509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.59.211', '2019-06-20 16:42:32', 3, 0, '', '2019-06-20 16:42:32');
INSERT INTO `access_log` VALUES (40140, '64.78.15610201523566517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.59.211', '2019-06-20 16:42:32', 2, 0, '', '2019-06-20 16:42:32');
INSERT INTO `access_log` VALUES (40141, '64.79.15610201534736517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.59.211', '2019-06-20 16:42:33', 2, 0, '', '2019-06-20 16:42:33');
INSERT INTO `access_log` VALUES (40142, '64.82.15610201543496527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.59.211', '2019-06-20 16:42:34', 2, 0, '', '2019-06-20 16:42:34');
INSERT INTO `access_log` VALUES (40143, '64.81.15610201550306511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.59.211', '2019-06-20 16:42:35', 2, 0, '', '2019-06-20 16:42:35');
INSERT INTO `access_log` VALUES (40144, '59.78.15610201561056523', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.59.211', '2019-06-20 16:42:36', 2, 0, '', '2019-06-20 16:42:36');
INSERT INTO `access_log` VALUES (40145, '59.79.15610201561056529', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.59.211', '2019-06-20 16:42:36', 12, 2001001000, '服务端发生异常', '2019-06-20 16:42:36');
INSERT INTO `access_log` VALUES (40146, '64.77.15610201597156517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.59.211', '2019-06-20 16:42:40', 1, 0, '', '2019-06-20 16:42:40');
INSERT INTO `access_log` VALUES (40147, '64.85.15610201597746531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.59.211', '2019-06-20 16:42:40', 2, 0, '', '2019-06-20 16:42:40');
INSERT INTO `access_log` VALUES (40148, '59.76.15610201606576519', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.59.211', '2019-06-20 16:42:41', 2, 0, '', '2019-06-20 16:42:41');
INSERT INTO `access_log` VALUES (40149, '59.74.15610201606636523', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.59.211', '2019-06-20 16:42:41', 13, 2001001000, '服务端发生异常', '2019-06-20 16:42:41');
INSERT INTO `access_log` VALUES (40150, '65.53.15610204957007405', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.155.22.214', '2019-06-20 16:48:16', 46, 1002001012, '访问令牌已过期', '2019-06-20 16:48:16');
INSERT INTO `access_log` VALUES (40151, '65.3607.15610204956799179', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.155.22.214', '2019-06-20 16:48:16', 66, 1002001012, '访问令牌已过期', '2019-06-20 16:48:16');
INSERT INTO `access_log` VALUES (40152, '65.45.15610204956827413', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.155.22.214', '2019-06-20 16:48:16', 63, 1002001012, '访问令牌已过期', '2019-06-20 16:48:16');
INSERT INTO `access_log` VALUES (40153, '65.51.15610204975527439', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.155.22.214', '2019-06-20 16:48:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 16:48:18');
INSERT INTO `access_log` VALUES (40154, '65.52.15610204998497423', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.155.22.214', '2019-06-20 16:48:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 16:48:20');
INSERT INTO `access_log` VALUES (40155, '65.50.15610205004647427', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.155.22.214', '2019-06-20 16:48:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 16:48:20');
INSERT INTO `access_log` VALUES (40156, '65.54.15610205007847377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.155.22.214', '2019-06-20 16:48:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 16:48:21');
INSERT INTO `access_log` VALUES (40157, '65.46.15610205083567451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.155.22.214', '2019-06-20 16:48:28', 69, 0, '', '2019-06-20 16:48:28');
INSERT INTO `access_log` VALUES (40158, '65.53.15610205087807407', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.155.22.214', '2019-06-20 16:48:29', 10, 0, '', '2019-06-20 16:48:29');
INSERT INTO `access_log` VALUES (40159, '65.3607.15610205087809181', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.155.22.214', '2019-06-20 16:48:29', 10, 0, '', '2019-06-20 16:48:29');
INSERT INTO `access_log` VALUES (40160, '65.49.15610205087807425', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.155.22.214', '2019-06-20 16:48:29', 11, 2001001000, '服务端发生异常', '2019-06-20 16:48:29');
INSERT INTO `access_log` VALUES (40161, '65.45.15610210949167423', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 16:58:15', 1, 1002001015, '账号未登陆', '2019-06-20 16:58:15');
INSERT INTO `access_log` VALUES (40162, '65.3607.15610210949159189', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 16:58:15', 0, 1002001015, '账号未登陆', '2019-06-20 16:58:15');
INSERT INTO `access_log` VALUES (40163, '65.51.15610210949167449', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 16:58:15', 0, 1002001015, '账号未登陆', '2019-06-20 16:58:15');
INSERT INTO `access_log` VALUES (40164, '65.52.15610211016287433', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 16:58:22', 73, 0, '', '2019-06-20 16:58:22');
INSERT INTO `access_log` VALUES (40165, '65.50.15610211019487437', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 16:58:22', 65, 0, '', '2019-06-20 16:58:22');
INSERT INTO `access_log` VALUES (40166, '65.54.15610211019507387', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 16:58:22', 66, 2001001000, '服务端发生异常', '2019-06-20 16:58:22');
INSERT INTO `access_log` VALUES (40167, '65.47.15610211019527419', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 16:58:22', 63, 0, '', '2019-06-20 16:58:22');
INSERT INTO `access_log` VALUES (40168, '65.3607.15610211116829191', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 16:58:32', 79, 0, '', '2019-06-20 16:58:32');
INSERT INTO `access_log` VALUES (40169, '65.53.15610211116767417', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 16:58:32', 84, 0, '', '2019-06-20 16:58:32');
INSERT INTO `access_log` VALUES (40170, '65.49.15610211116787435', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 16:58:32', 83, 2001001000, '服务端发生异常', '2019-06-20 16:58:32');
INSERT INTO `access_log` VALUES (40171, '65.3607.15610212173599193', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:00:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 17:00:17');
INSERT INTO `access_log` VALUES (40172, '65.49.15610212217307437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin &type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:00:22', 92, 0, '', '2019-06-20 17:00:22');
INSERT INTO `access_log` VALUES (40173, '65.53.15610212220007419', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:00:22', 9, 0, '', '2019-06-20 17:00:22');
INSERT INTO `access_log` VALUES (40174, '65.45.15610212220137427', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:00:22', 10, 0, '', '2019-06-20 17:00:22');
INSERT INTO `access_log` VALUES (40175, '65.51.15610212220197453', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:00:22', 9, 0, '', '2019-06-20 17:00:22');
INSERT INTO `access_log` VALUES (40176, '62.87.15610212262656185', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:00:26', 22, 0, '', '2019-06-20 17:00:26');
INSERT INTO `access_log` VALUES (40177, '62.84.15610212333606167', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:00:33', 14, 0, '', '2019-06-20 17:00:33');
INSERT INTO `access_log` VALUES (40178, '62.81.15610212365416159', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=101', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:00:37', 9, 0, '', '2019-06-20 17:00:37');
INSERT INTO `access_log` VALUES (40179, '62.83.15610212388596193', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&payChannel=200', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:00:39', 12, 0, '', '2019-06-20 17:00:39');
INSERT INTO `access_log` VALUES (40180, '64.78.15610212413786533', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:00:41', 10, 0, '', '2019-06-20 17:00:41');
INSERT INTO `access_log` VALUES (40181, '64.83.15610212413776525', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:00:41', 15, 0, '', '2019-06-20 17:00:41');
INSERT INTO `access_log` VALUES (40182, '66.49.15610212535064855', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:00:54', 19, 0, '', '2019-06-20 17:00:54');
INSERT INTO `access_log` VALUES (40183, '59.75.15610212553056541', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:00:55', 28, 2001001000, '服务端发生异常', '2019-06-20 17:00:55');
INSERT INTO `access_log` VALUES (40184, '59.72.15610212612606535', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:01:01', 11, 0, '', '2019-06-20 17:01:01');
INSERT INTO `access_log` VALUES (40185, '59.79.15610212668756545', 1, 2, 'promotion-application', '/promotion-api/admins/banner/update_status', 'id=1&status=1', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:01:07', 70, 0, '', '2019-06-20 17:01:07');
INSERT INTO `access_log` VALUES (40186, '59.78.15610212671056539', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:01:07', 9, 0, '', '2019-06-20 17:01:07');
INSERT INTO `access_log` VALUES (40187, '59.76.15610212730326535', 1, 2, 'promotion-application', '/promotion-api/admins/banner/update', 'id=1&title=百度是最棒的&url=https://user-gold-cdn.xitu.io/2019/3/30/169cdcbb93d48ff1?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1&sort=0&memo=哈哈哈哈&picUrl=https://user-gold-cdn.xitu.io/2019/3/30/169cdcbb93d48ff1?imageView2/0/w/1280/h/960/format/jpeg/ignore-error/1', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:01:13', 254, 0, '', '2019-06-20 17:01:13');
INSERT INTO `access_log` VALUES (40188, '59.74.15610212734316539', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:01:13', 9, 0, '', '2019-06-20 17:01:13');
INSERT INTO `access_log` VALUES (40189, '65.46.15610212761467465', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:01:16', 30, 0, '', '2019-06-20 17:01:16');
INSERT INTO `access_log` VALUES (40190, '65.3607.15610212797619195', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:01:20', 12, 0, '', '2019-06-20 17:01:20');
INSERT INTO `access_log` VALUES (40191, '65.45.15610212844417429', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:01:24', 9, 0, '', '2019-06-20 17:01:24');
INSERT INTO `access_log` VALUES (40192, '65.53.15610212879947421', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=14', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:01:28', 10, 0, '', '2019-06-20 17:01:28');
INSERT INTO `access_log` VALUES (40193, '65.51.15610212908267455', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:01:31', 10, 0, '', '2019-06-20 17:01:31');
INSERT INTO `access_log` VALUES (40194, '65.50.15610213138207443', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:01:54', 15, 0, '', '2019-06-20 17:01:54');
INSERT INTO `access_log` VALUES (40195, '65.46.15610213411387467', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:02:21', 8, 0, '', '2019-06-20 17:02:21');
INSERT INTO `access_log` VALUES (40196, '65.49.15610213563487441', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:02:36', 18, 0, '', '2019-06-20 17:02:36');
INSERT INTO `access_log` VALUES (40197, '65.53.15610213616717423', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:02:42', 25, 0, '', '2019-06-20 17:02:42');
INSERT INTO `access_log` VALUES (40198, '65.51.15610213647867457', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:02:45', 9, 0, '', '2019-06-20 17:02:45');
INSERT INTO `access_log` VALUES (40199, '65.52.15610213704457441', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:02:50', 14, 0, '', '2019-06-20 17:02:50');
INSERT INTO `access_log` VALUES (40200, '59.78.15610213829726541', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:03:03', 11, 0, '', '2019-06-20 17:03:03');
INSERT INTO `access_log` VALUES (40201, '59.74.15610213851296541', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:03:05', 11, 0, '', '2019-06-20 17:03:05');
INSERT INTO `access_log` VALUES (40202, '64.79.15610213925856535', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:03:13', 12, 0, '', '2019-06-20 17:03:13');
INSERT INTO `access_log` VALUES (40203, '64.82.15610213997296545', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:03:20', 10, 0, '', '2019-06-20 17:03:20');
INSERT INTO `access_log` VALUES (40204, '64.77.15610214024766535', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:03:22', 9, 0, '', '2019-06-20 17:03:22');
INSERT INTO `access_log` VALUES (40205, '64.80.15610214024766535', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:03:22', 11, 0, '', '2019-06-20 17:03:22');
INSERT INTO `access_log` VALUES (40206, '64.85.15610214067916549', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:03:27', 10, 0, '', '2019-06-20 17:03:27');
INSERT INTO `access_log` VALUES (40207, '64.84.15610214097996527', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:03:30', 8, 0, '', '2019-06-20 17:03:30');
INSERT INTO `access_log` VALUES (40208, '64.76.15610214097966519', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:03:30', 11, 0, '', '2019-06-20 17:03:30');
INSERT INTO `access_log` VALUES (40209, '64.78.15610214110306537', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:03:31', 9, 0, '', '2019-06-20 17:03:31');
INSERT INTO `access_log` VALUES (40210, '64.83.15610214110336529', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:03:31', 8, 0, '', '2019-06-20 17:03:31');
INSERT INTO `access_log` VALUES (40211, '62.88.15610214124586187', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'payChannel=200&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:03:32', 12, 0, '', '2019-06-20 17:03:32');
INSERT INTO `access_log` VALUES (40212, '62.85.15610214145736179', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.176.204', '2019-06-20 17:03:35', 17, 0, '', '2019-06-20 17:03:35');
INSERT INTO `access_log` VALUES (40213, '65.54.15610219918267403', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.32.248.150', '2019-06-20 17:13:12', 0, 1002001015, '账号未登陆', '2019-06-20 17:13:12');
INSERT INTO `access_log` VALUES (40214, '65.46.15610219918277477', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.32.248.150', '2019-06-20 17:13:12', 0, 1002001015, '账号未登陆', '2019-06-20 17:13:12');
INSERT INTO `access_log` VALUES (40215, '65.3607.15610219918319207', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.32.248.150', '2019-06-20 17:13:12', 1, 1002001015, '账号未登陆', '2019-06-20 17:13:12');
INSERT INTO `access_log` VALUES (40216, '65.45.15610220097297441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.32.248.150', '2019-06-20 17:13:30', 142, 0, '', '2019-06-20 17:13:30');
INSERT INTO `access_log` VALUES (40217, '65.53.15610220101437433', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.32.248.150', '2019-06-20 17:13:30', 9, 0, '', '2019-06-20 17:13:30');
INSERT INTO `access_log` VALUES (40218, '65.51.15610220101447467', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.32.248.150', '2019-06-20 17:13:30', 9, 2001001000, '服务端发生异常', '2019-06-20 17:13:30');
INSERT INTO `access_log` VALUES (40219, '65.52.15610220101467451', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.32.248.150', '2019-06-20 17:13:30', 8, 0, '', '2019-06-20 17:13:30');
INSERT INTO `access_log` VALUES (40220, '65.50.15610220161677455', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.32.248.150', '2019-06-20 17:13:36', 8, 0, '', '2019-06-20 17:13:36');
INSERT INTO `access_log` VALUES (40221, '65.3607.15610220161739209', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.32.248.150', '2019-06-20 17:13:36', 8, 0, '', '2019-06-20 17:13:36');
INSERT INTO `access_log` VALUES (40222, '65.47.15610220161737437', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.32.248.150', '2019-06-20 17:13:36', 9, 2001001000, '服务端发生异常', '2019-06-20 17:13:36');
INSERT INTO `access_log` VALUES (40223, '65.54.15610220283457405', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.32.248.150', '2019-06-20 17:13:48', 10, 0, '', '2019-06-20 17:13:48');
INSERT INTO `access_log` VALUES (40224, '65.49.15610220283497453', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.32.248.150', '2019-06-20 17:13:48', 10, 2001001000, '服务端发生异常', '2019-06-20 17:13:48');
INSERT INTO `access_log` VALUES (40225, '65.45.15610220283517443', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.32.248.150', '2019-06-20 17:13:48', 9, 0, '', '2019-06-20 17:13:48');
INSERT INTO `access_log` VALUES (40226, '59.71.15610228723616563', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.41.94.20', '2019-06-20 17:27:52', 3, 0, '', '2019-06-20 17:27:52');
INSERT INTO `access_log` VALUES (40227, '59.74.15610228723616561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.41.94.20', '2019-06-20 17:27:52', 14, 2001001000, '服务端发生异常', '2019-06-20 17:27:52');
INSERT INTO `access_log` VALUES (40228, '65.45.15610228791087455', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.41.94.20', '2019-06-20 17:27:59', 1, 1002001015, '账号未登陆', '2019-06-20 17:27:59');
INSERT INTO `access_log` VALUES (40229, '65.49.15610228791097465', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.41.94.20', '2019-06-20 17:27:59', 0, 1002001015, '账号未登陆', '2019-06-20 17:27:59');
INSERT INTO `access_log` VALUES (40230, '65.54.15610228791147417', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.41.94.20', '2019-06-20 17:27:59', 0, 1002001015, '账号未登陆', '2019-06-20 17:27:59');
INSERT INTO `access_log` VALUES (40231, '65.53.15610228811657447', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.41.94.20', '2019-06-20 17:28:01', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 17:28:01');
INSERT INTO `access_log` VALUES (40232, '65.52.15610228825387465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.41.94.20', '2019-06-20 17:28:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 17:28:03');
INSERT INTO `access_log` VALUES (40233, '65.47.15610245549617475', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:55:55', 0, 1002001015, '账号未登陆', '2019-06-20 17:55:55');
INSERT INTO `access_log` VALUES (40234, '65.51.15610245549607505', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:55:55', 0, 1002001015, '账号未登陆', '2019-06-20 17:55:55');
INSERT INTO `access_log` VALUES (40235, '65.50.15610245549897491', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:55:55', 0, 1002001015, '账号未登陆', '2019-06-20 17:55:55');
INSERT INTO `access_log` VALUES (40236, '65.46.15610245658007517', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:56:06', 88, 0, '', '2019-06-20 17:56:06');
INSERT INTO `access_log` VALUES (40237, '65.45.15610245662227479', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:56:06', 171, 0, '', '2019-06-20 17:56:06');
INSERT INTO `access_log` VALUES (40238, '65.3607.15610245662269247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:56:06', 171, 0, '', '2019-06-20 17:56:06');
INSERT INTO `access_log` VALUES (40239, '65.49.15610245662257489', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:56:06', 171, 2001001000, '服务端发生异常', '2019-06-20 17:56:06');
INSERT INTO `access_log` VALUES (40240, '65.52.15610245918497489', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:56:32', 9, 0, '', '2019-06-20 17:56:32');
INSERT INTO `access_log` VALUES (40241, '65.51.15610245918527507', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:56:32', 10, 2001001000, '服务端发生异常', '2019-06-20 17:56:32');
INSERT INTO `access_log` VALUES (40242, '65.47.15610245918567477', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:56:32', 9, 0, '', '2019-06-20 17:56:32');
INSERT INTO `access_log` VALUES (40243, '65.46.15610246114227519', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:56:51', 9, 0, '', '2019-06-20 17:56:51');
INSERT INTO `access_log` VALUES (40244, '65.3607.15610246114229249', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:56:51', 10, 2001001000, '服务端发生异常', '2019-06-20 17:56:51');
INSERT INTO `access_log` VALUES (40245, '65.45.15610246114367481', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:56:51', 9, 0, '', '2019-06-20 17:56:51');
INSERT INTO `access_log` VALUES (40246, '59.78.15610246200796585', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:57:00', 3, 0, '', '2019-06-20 17:57:00');
INSERT INTO `access_log` VALUES (40247, '59.76.15610246200806581', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.167.204.14', '2019-06-20 17:57:00', 9, 2001001000, '服务端发生异常', '2019-06-20 17:57:00');
INSERT INTO `access_log` VALUES (40248, '65.54.15610271783747477', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.244.114', '2019-06-20 18:39:38', 1, 1002001015, '账号未登陆', '2019-06-20 18:39:38');
INSERT INTO `access_log` VALUES (40249, '65.3607.15610271783759283', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.244.114', '2019-06-20 18:39:38', 1, 1002001015, '账号未登陆', '2019-06-20 18:39:38');
INSERT INTO `access_log` VALUES (40250, '65.45.15610271783787517', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.244.114', '2019-06-20 18:39:38', 0, 1002001015, '账号未登陆', '2019-06-20 18:39:38');
INSERT INTO `access_log` VALUES (40251, '65.49.15610271826477523', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.244.114', '2019-06-20 18:39:43', 83, 0, '', '2019-06-20 18:39:43');
INSERT INTO `access_log` VALUES (40252, '65.47.15610271830017515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.244.114', '2019-06-20 18:39:43', 11, 0, '', '2019-06-20 18:39:43');
INSERT INTO `access_log` VALUES (40253, '65.51.15610271830017545', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.244.114', '2019-06-20 18:39:43', 13, 2001001000, '服务端发生异常', '2019-06-20 18:39:43');
INSERT INTO `access_log` VALUES (40254, '65.53.15610271830367513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.244.114', '2019-06-20 18:39:43', 12, 0, '', '2019-06-20 18:39:43');
INSERT INTO `access_log` VALUES (40255, '59.73.15610271975476627', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.244.114', '2019-06-20 18:39:58', 10, 0, '', '2019-06-20 18:39:58');
INSERT INTO `access_log` VALUES (40256, '59.77.15610271975476609', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.244.114', '2019-06-20 18:39:58', 16, 2001001000, '服务端发生异常', '2019-06-20 18:39:58');
INSERT INTO `access_log` VALUES (40257, '59.72.15610272129056617', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.244.114', '2019-06-20 18:40:13', 3, 0, '', '2019-06-20 18:40:13');
INSERT INTO `access_log` VALUES (40258, '59.80.15610272129066611', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.244.114', '2019-06-20 18:40:13', 19, 2001001000, '服务端发生异常', '2019-06-20 18:40:13');
INSERT INTO `access_log` VALUES (40259, '64.76.15610272175086597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.244.114', '2019-06-20 18:40:18', 31, 0, '', '2019-06-20 18:40:18');
INSERT INTO `access_log` VALUES (40260, '64.78.15610272176456615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.244.114', '2019-06-20 18:40:18', 2, 0, '', '2019-06-20 18:40:18');
INSERT INTO `access_log` VALUES (40261, '66.48.15610272212134931', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.244.114', '2019-06-20 18:40:21', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-20 18:40:21');
INSERT INTO `access_log` VALUES (40262, '64.79.15610272251136615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.244.114', '2019-06-20 18:40:25', 1, 0, '', '2019-06-20 18:40:25');
INSERT INTO `access_log` VALUES (40263, '64.82.15610272252416625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.244.114', '2019-06-20 18:40:25', 2, 0, '', '2019-06-20 18:40:25');
INSERT INTO `access_log` VALUES (40264, '59.78.15610272265566621', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.244.114', '2019-06-20 18:40:27', 2, 0, '', '2019-06-20 18:40:27');
INSERT INTO `access_log` VALUES (40265, '59.76.15610272265956617', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.35.244.114', '2019-06-20 18:40:27', 12, 2001001000, '服务端发生异常', '2019-06-20 18:40:27');
INSERT INTO `access_log` VALUES (40266, '65.49.15610278672827533', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.92', '2019-06-20 18:51:07', 1, 1002001015, '账号未登陆', '2019-06-20 18:51:07');
INSERT INTO `access_log` VALUES (40267, '65.46.15610278672817567', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.92', '2019-06-20 18:51:07', 0, 1002001015, '账号未登陆', '2019-06-20 18:51:07');
INSERT INTO `access_log` VALUES (40268, '65.51.15610278672867555', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.92', '2019-06-20 18:51:07', 0, 1002001015, '账号未登陆', '2019-06-20 18:51:07');
INSERT INTO `access_log` VALUES (40269, '65.53.15610278710647523', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.92', '2019-06-20 18:51:11', 67, 0, '', '2019-06-20 18:51:11');
INSERT INTO `access_log` VALUES (40270, '65.52.15610278713707535', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.92', '2019-06-20 18:51:11', 216, 0, '', '2019-06-20 18:51:12');
INSERT INTO `access_log` VALUES (40271, '65.3607.15610278713729295', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.92', '2019-06-20 18:51:11', 215, 0, '', '2019-06-20 18:51:12');
INSERT INTO `access_log` VALUES (40272, '65.50.15610278713717539', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.92', '2019-06-20 18:51:11', 218, 2001001000, '服务端发生异常', '2019-06-20 18:51:12');
INSERT INTO `access_log` VALUES (40273, '65.45.15610278828237529', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.92', '2019-06-20 18:51:23', 9, 0, '', '2019-06-20 18:51:23');
INSERT INTO `access_log` VALUES (40274, '65.54.15610278828347489', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.92', '2019-06-20 18:51:23', 9, 2001001000, '服务端发生异常', '2019-06-20 18:51:23');
INSERT INTO `access_log` VALUES (40275, '65.49.15610278828497535', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.92', '2019-06-20 18:51:23', 8, 0, '', '2019-06-20 18:51:23');
INSERT INTO `access_log` VALUES (40276, '65.51.15610278879337557', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.92', '2019-06-20 18:51:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 18:51:28');
INSERT INTO `access_log` VALUES (40277, '59.72.15610279083766627', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.92', '2019-06-20 18:51:48', 3, 0, '', '2019-06-20 18:51:48');
INSERT INTO `access_log` VALUES (40278, '59.80.15610279083916621', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.74.92', '2019-06-20 18:51:48', 19, 2001001000, '服务端发生异常', '2019-06-20 18:51:48');
INSERT INTO `access_log` VALUES (40279, '65.54.15610281237867493', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.65.211.93', '2019-06-20 18:55:24', 0, 1002001015, '账号未登陆', '2019-06-20 18:55:24');
INSERT INTO `access_log` VALUES (40280, '65.45.15610281237877533', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.65.211.93', '2019-06-20 18:55:24', 0, 1002001015, '账号未登陆', '2019-06-20 18:55:24');
INSERT INTO `access_log` VALUES (40281, '65.49.15610281237867539', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.65.211.93', '2019-06-20 18:55:24', 0, 1002001015, '账号未登陆', '2019-06-20 18:55:24');
INSERT INTO `access_log` VALUES (40282, '65.51.15610281305707561', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.65.211.93', '2019-06-20 18:55:31', 86, 0, '', '2019-06-20 18:55:31');
INSERT INTO `access_log` VALUES (40283, '65.47.15610281309727531', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.65.211.93', '2019-06-20 18:55:31', 64, 0, '', '2019-06-20 18:55:31');
INSERT INTO `access_log` VALUES (40284, '65.53.15610281309737529', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.65.211.93', '2019-06-20 18:55:31', 65, 0, '', '2019-06-20 18:55:31');
INSERT INTO `access_log` VALUES (40285, '65.3607.15610281309739301', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.65.211.93', '2019-06-20 18:55:31', 65, 2001001000, '服务端发生异常', '2019-06-20 18:55:31');
INSERT INTO `access_log` VALUES (40286, '65.50.15610281390607545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.65.211.93', '2019-06-20 18:55:39', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 18:55:39');
INSERT INTO `access_log` VALUES (40287, '65.54.15610281438557495', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.65.211.93', '2019-06-20 18:55:44', 75, 0, '', '2019-06-20 18:55:44');
INSERT INTO `access_log` VALUES (40288, '65.45.15610281442087535', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.65.211.93', '2019-06-20 18:55:44', 9, 0, '', '2019-06-20 18:55:44');
INSERT INTO `access_log` VALUES (40289, '65.49.15610281442087541', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.65.211.93', '2019-06-20 18:55:44', 10, 2001001000, '服务端发生异常', '2019-06-20 18:55:44');
INSERT INTO `access_log` VALUES (40290, '65.46.15610281442087575', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.65.211.93', '2019-06-20 18:55:44', 9, 0, '', '2019-06-20 18:55:44');
INSERT INTO `access_log` VALUES (40291, '65.46.15610295649137595', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.214.210.242', '2019-06-20 19:19:25', 0, 1002001015, '账号未登陆', '2019-06-20 19:19:25');
INSERT INTO `access_log` VALUES (40292, '65.54.15610295649137515', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.214.210.242', '2019-06-20 19:19:25', 1, 1002001015, '账号未登陆', '2019-06-20 19:19:25');
INSERT INTO `access_log` VALUES (40293, '65.50.15610295649137565', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.214.210.242', '2019-06-20 19:19:25', 1, 1002001015, '账号未登陆', '2019-06-20 19:19:25');
INSERT INTO `access_log` VALUES (40294, '59.78.15610295660746653', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.214.210.242', '2019-06-20 19:19:26', 3, 0, '', '2019-06-20 19:19:26');
INSERT INTO `access_log` VALUES (40295, '59.76.15610295660756649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.214.210.242', '2019-06-20 19:19:26', 11, 2001001000, '服务端发生异常', '2019-06-20 19:19:26');
INSERT INTO `access_log` VALUES (40296, '65.45.15610295712237555', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.214.210.242', '2019-06-20 19:19:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 19:19:31');
INSERT INTO `access_log` VALUES (40297, '65.53.15610295970617551', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.214.210.242', '2019-06-20 19:19:57', 98, 0, '', '2019-06-20 19:19:57');
INSERT INTO `access_log` VALUES (40298, '65.3607.15610295974779323', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.214.210.242', '2019-06-20 19:19:57', 10, 0, '', '2019-06-20 19:19:57');
INSERT INTO `access_log` VALUES (40299, '65.52.15610295974827563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.214.210.242', '2019-06-20 19:19:57', 9, 0, '', '2019-06-20 19:19:57');
INSERT INTO `access_log` VALUES (40300, '65.47.15610295974827553', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.214.210.242', '2019-06-20 19:19:57', 10, 2001001000, '服务端发生异常', '2019-06-20 19:19:57');
INSERT INTO `access_log` VALUES (40301, '59.74.15610322885506689', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.40.22.89', '2019-06-20 20:04:49', 11, 0, '', '2019-06-20 20:04:49');
INSERT INTO `access_log` VALUES (40302, '59.73.15610322885546697', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.40.22.89', '2019-06-20 20:04:49', 15, 2001001000, '服务端发生异常', '2019-06-20 20:04:49');
INSERT INTO `access_log` VALUES (40303, '59.74.15610324048996691', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:06:45', 4, 0, '', '2019-06-20 20:06:45');
INSERT INTO `access_log` VALUES (40304, '59.73.15610324049406699', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:06:45', 13, 2001001000, '服务端发生异常', '2019-06-20 20:06:45');
INSERT INTO `access_log` VALUES (40305, '64.81.15610324220866679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:07:02', 13, 0, '', '2019-06-20 20:07:02');
INSERT INTO `access_log` VALUES (40306, '64.77.15610324226716683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:07:03', 2, 0, '', '2019-06-20 20:07:03');
INSERT INTO `access_log` VALUES (40307, '64.80.15610324252026683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:07:05', 2, 0, '', '2019-06-20 20:07:05');
INSERT INTO `access_log` VALUES (40308, '64.85.15610324264916699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:07:06', 1, 0, '', '2019-06-20 20:07:06');
INSERT INTO `access_log` VALUES (40309, '64.76.15610324280186669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:07:08', 2, 0, '', '2019-06-20 20:07:08');
INSERT INTO `access_log` VALUES (40310, '64.83.15610324351606679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:07:15', 2, 0, '', '2019-06-20 20:07:15');
INSERT INTO `access_log` VALUES (40311, '64.79.15610324356296687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:07:16', 1, 0, '', '2019-06-20 20:07:16');
INSERT INTO `access_log` VALUES (40312, '64.77.15610324795576685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:08:00', 2, 0, '', '2019-06-20 20:08:00');
INSERT INTO `access_log` VALUES (40313, '64.80.15610324807276685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:08:01', 1, 0, '', '2019-06-20 20:08:01');
INSERT INTO `access_log` VALUES (40314, '64.78.15610324822736689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:08:02', 2, 0, '', '2019-06-20 20:08:02');
INSERT INTO `access_log` VALUES (40315, '59.74.15610325173346693', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:08:37', 3, 0, '', '2019-06-20 20:08:37');
INSERT INTO `access_log` VALUES (40316, '59.73.15610325177206701', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:08:38', 13, 2001001000, '服务端发生异常', '2019-06-20 20:08:38');
INSERT INTO `access_log` VALUES (40317, '64.84.15610325335336679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:08:54', 1, 0, '', '2019-06-20 20:08:54');
INSERT INTO `access_log` VALUES (40318, '64.82.15610325340086699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:08:54', 2, 0, '', '2019-06-20 20:08:54');
INSERT INTO `access_log` VALUES (40319, '64.81.15610325383276683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:08:58', 3, 0, '', '2019-06-20 20:08:58');
INSERT INTO `access_log` VALUES (40320, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:08:58', 7, 0, '', '2019-06-20 20:08:58');
INSERT INTO `access_log` VALUES (40321, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:02', 5, 0, '', '2019-06-20 20:09:02');
INSERT INTO `access_log` VALUES (40322, '64.80.15610325505356687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:11', 2, 0, '', '2019-06-20 20:09:11');
INSERT INTO `access_log` VALUES (40323, '64.78.15610325510056691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:11', 2, 0, '', '2019-06-20 20:09:11');
INSERT INTO `access_log` VALUES (40324, '64.85.15610325527596703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:13', 2, 0, '', '2019-06-20 20:09:13');
INSERT INTO `access_log` VALUES (40325, '64.76.15610325546216673', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:15', 2, 0, '', '2019-06-20 20:09:15');
INSERT INTO `access_log` VALUES (40326, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:15', 7, 0, '', '2019-06-20 20:09:15');
INSERT INTO `access_log` VALUES (40327, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:20', 6, 0, '', '2019-06-20 20:09:20');
INSERT INTO `access_log` VALUES (40328, '64.79.15610325619246691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:22', 2, 0, '', '2019-06-20 20:09:22');
INSERT INTO `access_log` VALUES (40329, '64.84.15610325624736681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:22', 1, 0, '', '2019-06-20 20:09:22');
INSERT INTO `access_log` VALUES (40330, '64.82.15610325638596701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:24', 2, 0, '', '2019-06-20 20:09:24');
INSERT INTO `access_log` VALUES (40331, '64.81.15610325658346685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:26', 2, 0, '', '2019-06-20 20:09:26');
INSERT INTO `access_log` VALUES (40332, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:26', 6, 0, '', '2019-06-20 20:09:26');
INSERT INTO `access_log` VALUES (40333, '64.77.15610325681386689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:28', 2, 0, '', '2019-06-20 20:09:28');
INSERT INTO `access_log` VALUES (40334, '64.80.15610325686096689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:29', 2, 0, '', '2019-06-20 20:09:29');
INSERT INTO `access_log` VALUES (40335, '59.80.15610325726006685', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:33', 3, 0, '', '2019-06-20 20:09:33');
INSERT INTO `access_log` VALUES (40336, '59.79.15610325726016701', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:09:33', 14, 2001001000, '服务端发生异常', '2019-06-20 20:09:33');
INSERT INTO `access_log` VALUES (40337, '65.52.15610334615207615', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:24:22', 6, 1002001012, '访问令牌已过期', '2019-06-20 20:24:22');
INSERT INTO `access_log` VALUES (40338, '65.47.15610334615207605', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:24:22', 6, 1002001012, '访问令牌已过期', '2019-06-20 20:24:22');
INSERT INTO `access_log` VALUES (40339, '65.3607.15610334615219375', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:24:22', 7, 1002001012, '访问令牌已过期', '2019-06-20 20:24:22');
INSERT INTO `access_log` VALUES (40340, '65.50.15610334647567619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:24:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 20:24:25');
INSERT INTO `access_log` VALUES (40341, '65.54.15610334722187569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:24:32', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 20:24:32');
INSERT INTO `access_log` VALUES (40342, '65.45.15610334771737609', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:24:37', 5, 1002002001, '密码不正确', '2019-06-20 20:24:37');
INSERT INTO `access_log` VALUES (40343, '65.51.15610334836727637', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:24:44', 155, 0, '', '2019-06-20 20:24:44');
INSERT INTO `access_log` VALUES (40344, '65.52.15610334841207617', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:24:44', 11, 0, '', '2019-06-20 20:24:44');
INSERT INTO `access_log` VALUES (40345, '65.53.15610334841207605', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:24:44', 11, 0, '', '2019-06-20 20:24:44');
INSERT INTO `access_log` VALUES (40346, '65.47.15610334841227607', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:24:44', 10, 0, '', '2019-06-20 20:24:44');
INSERT INTO `access_log` VALUES (40347, '65.3607.15610334887089377', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:24:49', 1, 1002001015, '账号未登陆', '2019-06-20 20:24:49');
INSERT INTO `access_log` VALUES (40348, '65.46.15610334887277651', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:24:49', 0, 1002001015, '账号未登陆', '2019-06-20 20:24:49');
INSERT INTO `access_log` VALUES (40349, '65.50.15610334887297621', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:24:49', 0, 1002001015, '账号未登陆', '2019-06-20 20:24:49');
INSERT INTO `access_log` VALUES (40350, '66.53.15610334990895005', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:24:59', 21, 0, '', '2019-06-20 20:24:59');
INSERT INTO `access_log` VALUES (40351, '59.71.15610335039936709', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:25:04', 12, 0, '', '2019-06-20 20:25:04');
INSERT INTO `access_log` VALUES (40352, '65.49.15610335144447617', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:25:14', 15, 0, '', '2019-06-20 20:25:14');
INSERT INTO `access_log` VALUES (40353, '65.51.15610335234117639', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:25:23', 9, 0, '', '2019-06-20 20:25:23');
INSERT INTO `access_log` VALUES (40354, '65.52.15610335278677619', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:25:28', 15, 0, '', '2019-06-20 20:25:28');
INSERT INTO `access_log` VALUES (40355, '65.47.15610335321177609', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:25:32', 10, 0, '', '2019-06-20 20:25:32');
INSERT INTO `access_log` VALUES (40356, '65.50.15610335368177623', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.97.145.140', '2019-06-20 20:25:37', 12, 0, '', '2019-06-20 20:25:37');
INSERT INTO `access_log` VALUES (40357, '65.46.15610335377347653', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:25:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 20:25:38');
INSERT INTO `access_log` VALUES (40358, '65.54.15610335526867573', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:25:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 20:25:53');
INSERT INTO `access_log` VALUES (40359, '65.51.15610335721297641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:26:12', 92, 0, '', '2019-06-20 20:26:12');
INSERT INTO `access_log` VALUES (40360, '65.53.15610335736417609', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:26:14', 10, 0, '', '2019-06-20 20:26:14');
INSERT INTO `access_log` VALUES (40361, '65.52.15610335736457621', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:26:14', 9, 0, '', '2019-06-20 20:26:14');
INSERT INTO `access_log` VALUES (40362, '65.47.15610335736467611', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:26:14', 17, 2001001000, '服务端发生异常', '2019-06-20 20:26:14');
INSERT INTO `access_log` VALUES (40363, '65.46.15610335877037655', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:26:28', 10, 0, '', '2019-06-20 20:26:28');
INSERT INTO `access_log` VALUES (40364, '65.54.15610335877067575', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:26:28', 9, 0, '', '2019-06-20 20:26:28');
INSERT INTO `access_log` VALUES (40365, '65.3607.15610335877049381', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:26:28', 10, 2001001000, '服务端发生异常', '2019-06-20 20:26:28');
INSERT INTO `access_log` VALUES (40366, '65.49.15610335996557621', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:26:40', 8, 0, '', '2019-06-20 20:26:40');
INSERT INTO `access_log` VALUES (40367, '65.51.15610335996577643', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:26:40', 9, 2001001000, '服务端发生异常', '2019-06-20 20:26:40');
INSERT INTO `access_log` VALUES (40368, '65.53.15610335996587611', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-20 20:26:40', 9, 0, '', '2019-06-20 20:26:40');
INSERT INTO `access_log` VALUES (40369, '65.47.15610336145817613', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:26:55', 9, 0, '', '2019-06-20 20:26:55');
INSERT INTO `access_log` VALUES (40370, '65.50.15610336145837627', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:26:55', 10, 2001001000, '服务端发生异常', '2019-06-20 20:26:55');
INSERT INTO `access_log` VALUES (40371, '65.3607.15610336145859383', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:26:55', 8, 0, '', '2019-06-20 20:26:55');
INSERT INTO `access_log` VALUES (40372, '64.78.15610340715986713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:34:32', 3, 0, '', '2019-06-20 20:34:32');
INSERT INTO `access_log` VALUES (40373, '64.85.15610340720556725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:34:32', 2, 0, '', '2019-06-20 20:34:32');
INSERT INTO `access_log` VALUES (40374, '59.71.15610340741086717', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:34:34', 2, 0, '', '2019-06-20 20:34:34');
INSERT INTO `access_log` VALUES (40375, '59.74.15610340744736715', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '47.254.155.65', '2019-06-20 20:34:34', 15, 2001001000, '服务端发生异常', '2019-06-20 20:34:34');
INSERT INTO `access_log` VALUES (40376, '65.54.15610354370667601', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.116.6.224', '2019-06-20 20:57:17', 0, 1002001015, '账号未登陆', '2019-06-20 20:57:17');
INSERT INTO `access_log` VALUES (40377, '65.46.15610354370677683', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.116.6.224', '2019-06-20 20:57:17', 0, 1002001015, '账号未登陆', '2019-06-20 20:57:17');
INSERT INTO `access_log` VALUES (40378, '65.47.15610354370677637', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.116.6.224', '2019-06-20 20:57:17', 0, 1002001015, '账号未登陆', '2019-06-20 20:57:17');
INSERT INTO `access_log` VALUES (40379, '65.45.15610354391727641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.116.6.224', '2019-06-20 20:57:19', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 20:57:19');
INSERT INTO `access_log` VALUES (40380, '65.51.15610354428757671', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.116.6.224', '2019-06-20 20:57:23', 60, 0, '', '2019-06-20 20:57:23');
INSERT INTO `access_log` VALUES (40381, '65.53.15610354431637637', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.116.6.224', '2019-06-20 20:57:23', 19, 0, '', '2019-06-20 20:57:23');
INSERT INTO `access_log` VALUES (40382, '65.49.15610354431717647', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.116.6.224', '2019-06-20 20:57:23', 18, 0, '', '2019-06-20 20:57:23');
INSERT INTO `access_log` VALUES (40383, '65.52.15610354431727651', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.116.6.224', '2019-06-20 20:57:23', 17, 2001001000, '服务端发生异常', '2019-06-20 20:57:23');
INSERT INTO `access_log` VALUES (40384, '65.54.15610354741517603', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.116.6.224', '2019-06-20 20:57:54', 9, 2001001000, '服务端发生异常', '2019-06-20 20:57:54');
INSERT INTO `access_log` VALUES (40385, '65.45.15610354741557643', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.116.6.224', '2019-06-20 20:57:54', 211, 0, '', '2019-06-20 20:57:54');
INSERT INTO `access_log` VALUES (40386, '65.46.15610354741497685', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.116.6.224', '2019-06-20 20:57:54', 218, 0, '', '2019-06-20 20:57:54');
INSERT INTO `access_log` VALUES (40387, '65.51.15610354819007673', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.116.6.224', '2019-06-20 20:58:02', 9, 0, '', '2019-06-20 20:58:02');
INSERT INTO `access_log` VALUES (40388, '65.53.15610354819027639', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.116.6.224', '2019-06-20 20:58:02', 9, 2001001000, '服务端发生异常', '2019-06-20 20:58:02');
INSERT INTO `access_log` VALUES (40389, '65.49.15610354819077649', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.116.6.224', '2019-06-20 20:58:02', 8, 0, '', '2019-06-20 20:58:02');
INSERT INTO `access_log` VALUES (40390, '59.72.15610374220206757', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.163', '2019-06-20 21:30:22', 11, 0, '', '2019-06-20 21:30:22');
INSERT INTO `access_log` VALUES (40391, '59.80.15610374341446751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.163', '2019-06-20 21:30:34', 10, 2001001000, '服务端发生异常', '2019-06-20 21:30:34');
INSERT INTO `access_log` VALUES (40392, '65.52.15610395891367707', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.70.32.61', '2019-06-20 22:06:29', 0, 1002001015, '账号未登陆', '2019-06-20 22:06:29');
INSERT INTO `access_log` VALUES (40393, '65.50.15610395891387713', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.70.32.61', '2019-06-20 22:06:29', 0, 1002001015, '账号未登陆', '2019-06-20 22:06:29');
INSERT INTO `access_log` VALUES (40394, '65.3607.15610395891389467', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.70.32.61', '2019-06-20 22:06:29', 0, 1002001015, '账号未登陆', '2019-06-20 22:06:29');
INSERT INTO `access_log` VALUES (40395, '65.47.15610395984777697', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.70.32.61', '2019-06-20 22:06:38', 300, 0, '', '2019-06-20 22:06:39');
INSERT INTO `access_log` VALUES (40396, '65.53.15610395989667697', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.70.32.61', '2019-06-20 22:06:39', 12, 0, '', '2019-06-20 22:06:39');
INSERT INTO `access_log` VALUES (40397, '65.45.15610395989657699', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.70.32.61', '2019-06-20 22:06:39', 12, 0, '', '2019-06-20 22:06:39');
INSERT INTO `access_log` VALUES (40398, '65.46.15610395989667743', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.70.32.61', '2019-06-20 22:06:39', 14, 2001001000, '服务端发生异常', '2019-06-20 22:06:39');
INSERT INTO `access_log` VALUES (40399, '65.51.15610396208037731', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.70.32.61', '2019-06-20 22:07:01', 9, 0, '', '2019-06-20 22:07:01');
INSERT INTO `access_log` VALUES (40400, '65.52.15610396208077709', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.70.32.61', '2019-06-20 22:07:01', 8, 0, '', '2019-06-20 22:07:01');
INSERT INTO `access_log` VALUES (40401, '65.50.15610396208077715', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.70.32.61', '2019-06-20 22:07:01', 9, 2001001000, '服务端发生异常', '2019-06-20 22:07:01');
INSERT INTO `access_log` VALUES (40402, '59.78.15610407402766805', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.168.88.154', '2019-06-20 22:25:40', 11, 0, '', '2019-06-20 22:25:40');
INSERT INTO `access_log` VALUES (40403, '59.76.15610407402776801', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.168.88.154', '2019-06-20 22:25:40', 15, 2001001000, '服务端发生异常', '2019-06-20 22:25:40');
INSERT INTO `access_log` VALUES (40404, '65.46.15610407497737761', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.168.88.154', '2019-06-20 22:25:50', 1, 1002001015, '账号未登陆', '2019-06-20 22:25:50');
INSERT INTO `access_log` VALUES (40405, '65.53.15610407497807713', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.168.88.154', '2019-06-20 22:25:50', 0, 1002001015, '账号未登陆', '2019-06-20 22:25:50');
INSERT INTO `access_log` VALUES (40406, '65.45.15610407497857717', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.168.88.154', '2019-06-20 22:25:50', 0, 1002001015, '账号未登陆', '2019-06-20 22:25:50');
INSERT INTO `access_log` VALUES (40407, '59.80.15610420507506813', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:47:31', 9, 0, '', '2019-06-20 22:47:31');
INSERT INTO `access_log` VALUES (40408, '59.78.15610420507516823', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:47:31', 15, 2001001000, '服务端发生异常', '2019-06-20 22:47:31');
INSERT INTO `access_log` VALUES (40409, '64.84.15610420563586809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:47:36', 10, 0, '', '2019-06-20 22:47:36');
INSERT INTO `access_log` VALUES (40410, '64.82.15610420564656829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:47:36', 2, 0, '', '2019-06-20 22:47:36');
INSERT INTO `access_log` VALUES (40411, '64.81.15610420579826813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:47:38', 2, 0, '', '2019-06-20 22:47:38');
INSERT INTO `access_log` VALUES (40412, '64.77.15610420586166817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:47:39', 2, 0, '', '2019-06-20 22:47:39');
INSERT INTO `access_log` VALUES (40413, '64.80.15610420591606817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:47:39', 2, 0, '', '2019-06-20 22:47:39');
INSERT INTO `access_log` VALUES (40414, '64.78.15610420608006821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:47:41', 2, 0, '', '2019-06-20 22:47:41');
INSERT INTO `access_log` VALUES (40415, '64.85.15610420643606833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:47:44', 1, 0, '', '2019-06-20 22:47:44');
INSERT INTO `access_log` VALUES (40416, '65.46.15610420788477781', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:47:59', 1, 1002001015, '账号未登陆', '2019-06-20 22:47:59');
INSERT INTO `access_log` VALUES (40417, '65.45.15610420788477735', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:47:59', 1, 1002001015, '账号未登陆', '2019-06-20 22:47:59');
INSERT INTO `access_log` VALUES (40418, '65.53.15610420788477731', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:47:59', 1, 1002001015, '账号未登陆', '2019-06-20 22:47:59');
INSERT INTO `access_log` VALUES (40419, '65.51.15610420808597767', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:48:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 22:48:01');
INSERT INTO `access_log` VALUES (40420, '65.49.15610420853557743', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:48:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 22:48:05');
INSERT INTO `access_log` VALUES (40421, '59.75.15610421271546827', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:48:47', 3, 0, '', '2019-06-20 22:48:47');
INSERT INTO `access_log` VALUES (40422, '59.72.15610421271626821', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.82.106.204', '2019-06-20 22:48:47', 18, 2001001000, '服务端发生异常', '2019-06-20 22:48:47');
INSERT INTO `access_log` VALUES (40423, '59.71.15610435303636845', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:10', 3, 0, '', '2019-06-20 23:12:10');
INSERT INTO `access_log` VALUES (40424, '59.74.15610435303656843', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:10', 14, 2001001000, '服务端发生异常', '2019-06-20 23:12:10');
INSERT INTO `access_log` VALUES (40425, '64.78.15610435329876841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:13', 3, 0, '', '2019-06-20 23:12:13');
INSERT INTO `access_log` VALUES (40426, '64.85.15610435331076853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:13', 1, 0, '', '2019-06-20 23:12:13');
INSERT INTO `access_log` VALUES (40427, '64.76.15610435340436823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:14', 2, 0, '', '2019-06-20 23:12:14');
INSERT INTO `access_log` VALUES (40428, '59.73.15610435351126851', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:15', 3, 0, '', '2019-06-20 23:12:15');
INSERT INTO `access_log` VALUES (40429, '59.77.15610435351136833', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:15', 23, 2001001000, '服务端发生异常', '2019-06-20 23:12:15');
INSERT INTO `access_log` VALUES (40430, '65.51.15610435520187787', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:32', 1, 1002001015, '账号未登陆', '2019-06-20 23:12:32');
INSERT INTO `access_log` VALUES (40431, '65.49.15610435520187763', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:32', 1, 1002001015, '账号未登陆', '2019-06-20 23:12:32');
INSERT INTO `access_log` VALUES (40432, '65.50.15610435520287773', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:32', 0, 1002001015, '账号未登陆', '2019-06-20 23:12:32');
INSERT INTO `access_log` VALUES (40433, '65.3607.15610435624029525', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 23:12:42');
INSERT INTO `access_log` VALUES (40434, '65.47.15610435788797753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:59', 64, 0, '', '2019-06-20 23:12:59');
INSERT INTO `access_log` VALUES (40435, '65.46.15610435792517803', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:59', 10, 0, '', '2019-06-20 23:12:59');
INSERT INTO `access_log` VALUES (40436, '65.53.15610435792547753', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:59', 10, 2001001000, '服务端发生异常', '2019-06-20 23:12:59');
INSERT INTO `access_log` VALUES (40437, '65.45.15610435792607757', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.50.151', '2019-06-20 23:12:59', 9, 0, '', '2019-06-20 23:12:59');
INSERT INTO `access_log` VALUES (40438, '65.3607.15610457392179555', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:48:59', 1, 1002001015, '账号未登陆', '2019-06-20 23:48:59');
INSERT INTO `access_log` VALUES (40439, '65.54.15610457392187751', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:48:59', 1, 1002001015, '账号未登陆', '2019-06-20 23:48:59');
INSERT INTO `access_log` VALUES (40440, '65.47.15610457392207783', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:48:59', 1, 1002001015, '账号未登陆', '2019-06-20 23:48:59');
INSERT INTO `access_log` VALUES (40441, '65.46.15610457417927833', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:49:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 23:49:02');
INSERT INTO `access_log` VALUES (40442, '65.53.15610457458057783', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:49:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 23:49:06');
INSERT INTO `access_log` VALUES (40443, '65.51.15610457510357819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:49:11', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 23:49:11');
INSERT INTO `access_log` VALUES (40444, '65.50.15610457520787805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:49:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-20 23:49:12');
INSERT INTO `access_log` VALUES (40445, '65.3607.15610457807289557', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:49:41', 67, 0, '', '2019-06-20 23:49:41');
INSERT INTO `access_log` VALUES (40446, '65.54.15610457810567753', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:49:41', 17, 0, '', '2019-06-20 23:49:41');
INSERT INTO `access_log` VALUES (40447, '65.47.15610457810667785', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:49:41', 10, 2001001000, '服务端发生异常', '2019-06-20 23:49:41');
INSERT INTO `access_log` VALUES (40448, '65.46.15610457810667835', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:49:41', 11, 0, '', '2019-06-20 23:49:41');
INSERT INTO `access_log` VALUES (40449, '65.53.15610457903237785', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:49:50', 8, 0, '', '2019-06-20 23:49:50');
INSERT INTO `access_log` VALUES (40450, '65.45.15610457903247789', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:49:50', 10, 2001001000, '服务端发生异常', '2019-06-20 23:49:50');
INSERT INTO `access_log` VALUES (40451, '65.51.15610457908907821', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:49:51', 144, 0, '', '2019-06-20 23:49:51');
INSERT INTO `access_log` VALUES (40452, '65.49.15610457925587797', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:49:53', 7, 0, '', '2019-06-20 23:49:53');
INSERT INTO `access_log` VALUES (40453, '65.50.15610457925587807', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:49:53', 8, 0, '', '2019-06-20 23:49:53');
INSERT INTO `access_log` VALUES (40454, '65.52.15610457925587797', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '180.111.93.221', '2019-06-20 23:49:53', 9, 2001001000, '服务端发生异常', '2019-06-20 23:49:53');
INSERT INTO `access_log` VALUES (40455, '59.79.15610473109206901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:11', 11, 0, '', '2019-06-21 00:15:11');
INSERT INTO `access_log` VALUES (40456, '59.80.15610473109266885', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:11', 15, 2001001000, '服务端发生异常', '2019-06-21 00:15:11');
INSERT INTO `access_log` VALUES (40457, '64.84.15610473150686881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:15', 11, 0, '', '2019-06-21 00:15:15');
INSERT INTO `access_log` VALUES (40458, '64.82.15610473151846901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:15', 3, 0, '', '2019-06-21 00:15:15');
INSERT INTO `access_log` VALUES (40459, '64.81.15610473188656885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:19', 2, 0, '', '2019-06-21 00:15:19');
INSERT INTO `access_log` VALUES (40460, '64.77.15610473189656889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:19', 2, 0, '', '2019-06-21 00:15:19');
INSERT INTO `access_log` VALUES (40461, '59.74.15610473282866895', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:28', 3, 0, '', '2019-06-21 00:15:28');
INSERT INTO `access_log` VALUES (40462, '59.76.15610473282856891', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:28', 14, 2001001000, '服务端发生异常', '2019-06-21 00:15:28');
INSERT INTO `access_log` VALUES (40463, '64.78.15610473350106893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:35', 2, 0, '', '2019-06-21 00:15:35');
INSERT INTO `access_log` VALUES (40464, '64.85.15610473351486905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:35', 2, 0, '', '2019-06-21 00:15:35');
INSERT INTO `access_log` VALUES (40465, '64.83.15610473373166885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:37', 1, 0, '', '2019-06-21 00:15:37');
INSERT INTO `access_log` VALUES (40466, '64.79.15610473374606893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:37', 2, 0, '', '2019-06-21 00:15:37');
INSERT INTO `access_log` VALUES (40467, '64.84.15610473429126883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:43', 2, 0, '', '2019-06-21 00:15:43');
INSERT INTO `access_log` VALUES (40468, '64.82.15610473430296903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:43', 2, 0, '', '2019-06-21 00:15:43');
INSERT INTO `access_log` VALUES (40469, '59.77.15610473438166885', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:44', 3, 0, '', '2019-06-21 00:15:44');
INSERT INTO `access_log` VALUES (40470, '59.73.15610473438156903', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:44', 12, 2001001000, '服务端发生异常', '2019-06-21 00:15:44');
INSERT INTO `access_log` VALUES (40471, '64.81.15610473462746887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:46', 2, 0, '', '2019-06-21 00:15:46');
INSERT INTO `access_log` VALUES (40472, '64.77.15610473463986891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:46', 1, 0, '', '2019-06-21 00:15:46');
INSERT INTO `access_log` VALUES (40473, '59.75.15610473469526899', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:47', 3, 0, '', '2019-06-21 00:15:47');
INSERT INTO `access_log` VALUES (40474, '59.72.15610473469576893', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/534.24 (KHTML, like Gecko) Chrome/71.0.3578.141 Safari/534.24 XiaoMi/MiuiBrowser/10.7.14', '112.123.13.7', '2019-06-21 00:15:47', 13, 2001001000, '服务端发生异常', '2019-06-21 00:15:47');
INSERT INTO `access_log` VALUES (40475, '59.78.15610497761016929', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:16', 17, 0, '', '2019-06-21 00:56:16');
INSERT INTO `access_log` VALUES (40476, '59.76.15610497761026925', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:16', 18, 2001001000, '服务端发生异常', '2019-06-21 00:56:16');
INSERT INTO `access_log` VALUES (40477, '64.76.15610497809376909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:21', 11, 0, '', '2019-06-21 00:56:21');
INSERT INTO `access_log` VALUES (40478, '64.83.15610497810526919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:21', 3, 0, '', '2019-06-21 00:56:21');
INSERT INTO `access_log` VALUES (40479, '59.71.15610497820216931', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:22', 3, 0, '', '2019-06-21 00:56:22');
INSERT INTO `access_log` VALUES (40480, '59.77.15610497820216919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:22', 16, 2001001000, '服务端发生异常', '2019-06-21 00:56:22');
INSERT INTO `access_log` VALUES (40481, '59.73.15610497874646937', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:27', 2, 0, '', '2019-06-21 00:56:27');
INSERT INTO `access_log` VALUES (40482, '59.75.15610497874646933', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:27', 12, 2001001000, '服务端发生异常', '2019-06-21 00:56:27');
INSERT INTO `access_log` VALUES (40483, '64.79.15610497923546927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:32', 2, 0, '', '2019-06-21 00:56:32');
INSERT INTO `access_log` VALUES (40484, '64.84.15610497927546917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:33', 2, 0, '', '2019-06-21 00:56:33');
INSERT INTO `access_log` VALUES (40485, '64.81.15610497957986921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:36', 2, 0, '', '2019-06-21 00:56:36');
INSERT INTO `access_log` VALUES (40486, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:36', 7, 0, '', '2019-06-21 00:56:36');
INSERT INTO `access_log` VALUES (40487, '64.77.15610497991046925', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:39', 6, 0, '', '2019-06-21 00:56:39');
INSERT INTO `access_log` VALUES (40488, '64.80.15610498067346925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:47', 2, 0, '', '2019-06-21 00:56:47');
INSERT INTO `access_log` VALUES (40489, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:47', 7, 0, '', '2019-06-21 00:56:47');
INSERT INTO `access_log` VALUES (40490, '64.78.15610498089606929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:49', 2, 0, '', '2019-06-21 00:56:49');
INSERT INTO `access_log` VALUES (40491, '64.85.15610498091326941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:49', 2, 0, '', '2019-06-21 00:56:49');
INSERT INTO `access_log` VALUES (40492, '59.80.15610498120756921', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:52', 2, 0, '', '2019-06-21 00:56:52');
INSERT INTO `access_log` VALUES (40493, '59.78.15610498120756931', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:52', 13, 2001001000, '服务端发生异常', '2019-06-21 00:56:52');
INSERT INTO `access_log` VALUES (40494, '64.83.15610498138336921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:54', 1, 0, '', '2019-06-21 00:56:54');
INSERT INTO `access_log` VALUES (40495, '64.79.15610498140396929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:56:54', 2, 0, '', '2019-06-21 00:56:54');
INSERT INTO `access_log` VALUES (40496, '65.3607.15610498379079613', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:57:18', 1, 1002001015, '账号未登陆', '2019-06-21 00:57:18');
INSERT INTO `access_log` VALUES (40497, '65.46.15610498379077891', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:57:18', 0, 1002001015, '账号未登陆', '2019-06-21 00:57:18');
INSERT INTO `access_log` VALUES (40498, '65.54.15610498379277809', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:57:18', 0, 1002001015, '账号未登陆', '2019-06-21 00:57:18');
INSERT INTO `access_log` VALUES (40499, '65.53.15610498453497841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:57:25', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 00:57:25');
INSERT INTO `access_log` VALUES (40500, '65.51.15610498685437877', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:57:49', 89, 0, '', '2019-06-21 00:57:49');
INSERT INTO `access_log` VALUES (40501, '65.52.15610498689587853', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:57:49', 162, 0, '', '2019-06-21 00:57:49');
INSERT INTO `access_log` VALUES (40502, '65.50.15610498689677863', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:57:49', 156, 0, '', '2019-06-21 00:57:49');
INSERT INTO `access_log` VALUES (40503, '65.49.15610498689637853', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '218.92.226.149', '2019-06-21 00:57:49', 162, 2001001000, '服务端发生异常', '2019-06-21 00:57:49');
INSERT INTO `access_log` VALUES (40504, '65.45.15610535356477895', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '121.237.185.170', '2019-06-21 01:58:56', 0, 1002001015, '账号未登陆', '2019-06-21 01:58:56');
INSERT INTO `access_log` VALUES (40505, '65.51.15610535356487927', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '121.237.185.170', '2019-06-21 01:58:56', 1, 1002001015, '账号未登陆', '2019-06-21 01:58:56');
INSERT INTO `access_log` VALUES (40506, '65.50.15610535356517913', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '121.237.185.170', '2019-06-21 01:58:56', 1, 1002001015, '账号未登陆', '2019-06-21 01:58:56');
INSERT INTO `access_log` VALUES (40507, '65.52.15610535391167903', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '121.237.185.170', '2019-06-21 01:58:59', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 01:58:59');
INSERT INTO `access_log` VALUES (40508, '65.49.15610535437067903', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '121.237.185.170', '2019-06-21 01:59:04', 135, 0, '', '2019-06-21 01:59:04');
INSERT INTO `access_log` VALUES (40509, '65.46.15610535440487943', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '121.237.185.170', '2019-06-21 01:59:04', 11, 0, '', '2019-06-21 01:59:04');
INSERT INTO `access_log` VALUES (40510, '65.3607.15610535440499665', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '121.237.185.170', '2019-06-21 01:59:04', 11, 0, '', '2019-06-21 01:59:04');
INSERT INTO `access_log` VALUES (40511, '65.54.15610535440497861', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '121.237.185.170', '2019-06-21 01:59:04', 12, 2001001000, '服务端发生异常', '2019-06-21 01:59:04');
INSERT INTO `access_log` VALUES (40512, '59.74.15610589842747053', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.32.67.202', '2019-06-21 03:29:44', 11, 0, '', '2019-06-21 03:29:44');
INSERT INTO `access_log` VALUES (40513, '59.71.15610589842757055', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.32.67.202', '2019-06-21 03:29:44', 16, 2001001000, '服务端发生异常', '2019-06-21 03:29:44');
INSERT INTO `access_log` VALUES (40514, '64.82.15610589885847061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.32.67.202', '2019-06-21 03:29:49', 165, 0, '', '2019-06-21 03:29:49');
INSERT INTO `access_log` VALUES (40515, '64.81.15610589888947045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.32.67.202', '2019-06-21 03:29:49', 3, 0, '', '2019-06-21 03:29:49');
INSERT INTO `access_log` VALUES (40516, '64.80.15610589905977049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.32.67.202', '2019-06-21 03:29:51', 2, 0, '', '2019-06-21 03:29:51');
INSERT INTO `access_log` VALUES (40517, '64.78.15610589914717053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.32.67.202', '2019-06-21 03:29:51', 2, 0, '', '2019-06-21 03:29:51');
INSERT INTO `access_log` VALUES (40518, '65.3607.15610718178719909', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/47.0.2526.106 BIDUBrowser/8.7 Safari/537.36', '183.2.198.51', '2019-06-21 07:03:38', 1, 1002001015, '账号未登陆', '2019-06-21 07:03:38');
INSERT INTO `access_log` VALUES (40519, '65.47.15610718178848137', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/47.0.2526.106 BIDUBrowser/8.7 Safari/537.36', '183.2.198.103', '2019-06-21 07:03:38', 0, 1002001015, '账号未登陆', '2019-06-21 07:03:38');
INSERT INTO `access_log` VALUES (40520, '65.53.15610718179098137', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/47.0.2526.106 BIDUBrowser/8.7 Safari/537.36', '183.2.198.103', '2019-06-21 07:03:38', 0, 1002001015, '账号未登陆', '2019-06-21 07:03:38');
INSERT INTO `access_log` VALUES (40521, '65.50.15610718247328159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/47.0.2526.106 BIDUBrowser/8.7 Safari/537.36', '183.2.198.51', '2019-06-21 07:03:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 07:03:45');
INSERT INTO `access_log` VALUES (40522, '65.52.15610718391358149', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/47.0.2526.106 BIDUBrowser/8.7 Safari/537.36', '183.2.198.51', '2019-06-21 07:03:59', 182, 0, '', '2019-06-21 07:03:59');
INSERT INTO `access_log` VALUES (40523, '65.49.15610718406588149', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/47.0.2526.106 BIDUBrowser/8.7 Safari/537.36', '183.2.198.103', '2019-06-21 07:04:01', 11, 0, '', '2019-06-21 07:04:01');
INSERT INTO `access_log` VALUES (40524, '65.46.15610718406638189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/47.0.2526.106 BIDUBrowser/8.7 Safari/537.36', '183.2.198.51', '2019-06-21 07:04:01', 11, 2001001000, '服务端发生异常', '2019-06-21 07:04:01');
INSERT INTO `access_log` VALUES (40525, '65.54.15610718406698107', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/47.0.2526.106 BIDUBrowser/8.7 Safari/537.36', '183.2.198.103', '2019-06-21 07:04:01', 9, 0, '', '2019-06-21 07:04:01');
INSERT INTO `access_log` VALUES (40526, '65.53.15610778546748219', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '1.202.237.218', '2019-06-21 08:44:15', 0, 1002001015, '账号未登陆', '2019-06-21 08:44:15');
INSERT INTO `access_log` VALUES (40527, '65.47.15610778546748219', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '1.202.237.218', '2019-06-21 08:44:15', 0, 1002001015, '账号未登陆', '2019-06-21 08:44:15');
INSERT INTO `access_log` VALUES (40528, '65.51.15610778546878255', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '1.202.237.218', '2019-06-21 08:44:15', 1, 1002001015, '账号未登陆', '2019-06-21 08:44:15');
INSERT INTO `access_log` VALUES (40529, '65.45.15610778687648221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '1.202.237.218', '2019-06-21 08:44:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 08:44:29');
INSERT INTO `access_log` VALUES (40530, '65.46.15610778901468271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '1.202.237.218', '2019-06-21 08:44:50', 123, 0, '', '2019-06-21 08:44:50');
INSERT INTO `access_log` VALUES (40531, '65.49.15610778905968231', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '1.202.237.218', '2019-06-21 08:44:51', 10, 0, '', '2019-06-21 08:44:51');
INSERT INTO `access_log` VALUES (40532, '65.54.15610778906008189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '1.202.237.218', '2019-06-21 08:44:51', 10, 2001001000, '服务端发生异常', '2019-06-21 08:44:51');
INSERT INTO `access_log` VALUES (40533, '65.3607.15610778906069993', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '1.202.237.218', '2019-06-21 08:44:51', 9, 0, '', '2019-06-21 08:44:51');
INSERT INTO `access_log` VALUES (40534, '65.50.15610786889058253', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.234.61.189', '2019-06-21 08:58:09', 0, 1002001015, '账号未登陆', '2019-06-21 08:58:09');
INSERT INTO `access_log` VALUES (40535, '65.45.15610786889058233', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.234.61.189', '2019-06-21 08:58:09', 0, 1002001015, '账号未登陆', '2019-06-21 08:58:09');
INSERT INTO `access_log` VALUES (40536, '65.52.15610786889108243', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.234.61.189', '2019-06-21 08:58:09', 0, 1002001015, '账号未登陆', '2019-06-21 08:58:09');
INSERT INTO `access_log` VALUES (40537, '65.3607.15610786906190005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.234.61.189', '2019-06-21 08:58:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 08:58:11');
INSERT INTO `access_log` VALUES (40538, '65.49.15610786931598243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.234.61.189', '2019-06-21 08:58:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 08:58:13');
INSERT INTO `access_log` VALUES (40539, '65.51.15610787192128269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.234.61.189', '2019-06-21 08:58:39', 85, 0, '', '2019-06-21 08:58:39');
INSERT INTO `access_log` VALUES (40540, '65.47.15610787195528233', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.234.61.189', '2019-06-21 08:58:40', 10, 0, '', '2019-06-21 08:58:40');
INSERT INTO `access_log` VALUES (40541, '65.46.15610787195528285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.234.61.189', '2019-06-21 08:58:40', 11, 2001001000, '服务端发生异常', '2019-06-21 08:58:40');
INSERT INTO `access_log` VALUES (40542, '65.52.15610787195568245', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.234.61.189', '2019-06-21 08:58:40', 9, 0, '', '2019-06-21 08:58:40');
INSERT INTO `access_log` VALUES (40543, '59.78.15610793147987325', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.254.115.146', '2019-06-21 09:08:35', 12, 0, '', '2019-06-21 09:08:35');
INSERT INTO `access_log` VALUES (40544, '59.76.15610793148007321', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.254.115.146', '2019-06-21 09:08:35', 16, 2001001000, '服务端发生异常', '2019-06-21 09:08:35');
INSERT INTO `access_log` VALUES (40545, '64.82.15610793179267333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.254.115.146', '2019-06-21 09:08:38', 11, 0, '', '2019-06-21 09:08:38');
INSERT INTO `access_log` VALUES (40546, '64.81.15610793180577317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.254.115.146', '2019-06-21 09:08:38', 2, 0, '', '2019-06-21 09:08:38');
INSERT INTO `access_log` VALUES (40547, '64.77.15610793190787321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.254.115.146', '2019-06-21 09:08:39', 3, 0, '', '2019-06-21 09:08:39');
INSERT INTO `access_log` VALUES (40548, '64.80.15610793196117321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.254.115.146', '2019-06-21 09:08:40', 2, 0, '', '2019-06-21 09:08:40');
INSERT INTO `access_log` VALUES (40549, '59.71.15610793201437327', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.254.115.146', '2019-06-21 09:08:40', 4, 0, '', '2019-06-21 09:08:40');
INSERT INTO `access_log` VALUES (40550, '59.74.15610793201437325', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.254.115.146', '2019-06-21 09:08:40', 15, 2001001000, '服务端发生异常', '2019-06-21 09:08:40');
INSERT INTO `access_log` VALUES (40551, '65.54.15610793336838209', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.254.115.146', '2019-06-21 09:08:54', 4, 1002001012, '访问令牌已过期', '2019-06-21 09:08:54');
INSERT INTO `access_log` VALUES (40552, '65.53.15610793336848241', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.254.115.146', '2019-06-21 09:08:54', 3, 1002001012, '访问令牌已过期', '2019-06-21 09:08:54');
INSERT INTO `access_log` VALUES (40553, '65.51.15610793336868279', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.254.115.146', '2019-06-21 09:08:54', 3, 1002001012, '访问令牌已过期', '2019-06-21 09:08:54');
INSERT INTO `access_log` VALUES (40554, '59.78.15610795476187329', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OD103 Build/NMF26F; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3133 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.3.236', '2019-06-21 09:12:28', 3, 0, '', '2019-06-21 09:12:28');
INSERT INTO `access_log` VALUES (40555, '59.80.15610795476187319', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.1; OD103 Build/NMF26F; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3133 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.3.236', '2019-06-21 09:12:28', 19, 2001001000, '服务端发生异常', '2019-06-21 09:12:28');
INSERT INTO `access_log` VALUES (40556, '59.79.15610800977157343', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:21:38', 4, 0, '', '2019-06-21 09:21:38');
INSERT INTO `access_log` VALUES (40557, '59.80.15610800977167327', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:21:38', 13, 2001001000, '服务端发生异常', '2019-06-21 09:21:38');
INSERT INTO `access_log` VALUES (40558, '64.76.15610801062947317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:21:46', 2, 0, '', '2019-06-21 09:21:46');
INSERT INTO `access_log` VALUES (40559, '64.83.15610801063967327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:21:46', 2, 0, '', '2019-06-21 09:21:46');
INSERT INTO `access_log` VALUES (40560, '64.79.15610801085327335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:21:49', 2, 0, '', '2019-06-21 09:21:49');
INSERT INTO `access_log` VALUES (40561, '64.84.15610801094517325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:21:49', 1, 0, '', '2019-06-21 09:21:49');
INSERT INTO `access_log` VALUES (40562, '65.51.15610801373478291', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:22:17', 1, 1002001015, '账号未登陆', '2019-06-21 09:22:17');
INSERT INTO `access_log` VALUES (40563, '65.54.15610801373498221', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:22:17', 0, 1002001015, '账号未登陆', '2019-06-21 09:22:17');
INSERT INTO `access_log` VALUES (40564, '65.52.15610801373608265', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:22:17', 0, 1002001015, '账号未登陆', '2019-06-21 09:22:17');
INSERT INTO `access_log` VALUES (40565, '65.47.15610801398008255', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:22:20', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 09:22:20');
INSERT INTO `access_log` VALUES (40566, '65.46.15610801419538307', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:22:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 09:22:22');
INSERT INTO `access_log` VALUES (40567, '65.3607.15610801605600029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:22:41', 95, 0, '', '2019-06-21 09:22:41');
INSERT INTO `access_log` VALUES (40568, '65.49.15610801609188267', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:22:41', 10, 0, '', '2019-06-21 09:22:41');
INSERT INTO `access_log` VALUES (40569, '65.53.15610801609258253', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:22:41', 10, 2001001000, '服务端发生异常', '2019-06-21 09:22:41');
INSERT INTO `access_log` VALUES (40570, '65.51.15610801609328293', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '59.52.224.163', '2019-06-21 09:22:41', 9, 0, '', '2019-06-21 09:22:41');
INSERT INTO `access_log` VALUES (40571, '65.49.15610803026748269', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:25:03', 1, 1002001015, '账号未登陆', '2019-06-21 09:25:03');
INSERT INTO `access_log` VALUES (40572, '65.52.15610803026768269', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:25:03', 0, 1002001015, '账号未登陆', '2019-06-21 09:25:03');
INSERT INTO `access_log` VALUES (40573, '65.54.15610803026838225', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:25:03', 0, 1002001015, '账号未登陆', '2019-06-21 09:25:03');
INSERT INTO `access_log` VALUES (40574, '65.47.15610803043488259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:25:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 09:25:04');
INSERT INTO `access_log` VALUES (40575, '65.45.15610803187758261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:25:19', 69, 0, '', '2019-06-21 09:25:19');
INSERT INTO `access_log` VALUES (40576, '65.50.15610803191448281', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:25:19', 9, 0, '', '2019-06-21 09:25:19');
INSERT INTO `access_log` VALUES (40577, '65.3607.15610803191480033', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:25:19', 8, 2001001000, '服务端发生异常', '2019-06-21 09:25:19');
INSERT INTO `access_log` VALUES (40578, '65.51.15610803191528297', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:25:19', 8, 0, '', '2019-06-21 09:25:19');
INSERT INTO `access_log` VALUES (40579, '65.52.15610803256458271', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:25:26', 17, 0, '', '2019-06-21 09:25:26');
INSERT INTO `access_log` VALUES (40580, '65.49.15610803256498271', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:25:26', 17, 2001001000, '服务端发生异常', '2019-06-21 09:25:26');
INSERT INTO `access_log` VALUES (40581, '65.54.15610803256528227', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:25:26', 17, 0, '', '2019-06-21 09:25:26');
INSERT INTO `access_log` VALUES (40582, '59.80.15610803772507331', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:26:17', 3, 0, '', '2019-06-21 09:26:17');
INSERT INTO `access_log` VALUES (40583, '59.79.15610803772557347', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:26:17', 13, 2001001000, '服务端发生异常', '2019-06-21 09:26:17');
INSERT INTO `access_log` VALUES (40584, '64.84.15610803921447329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:26:32', 2, 0, '', '2019-06-21 09:26:32');
INSERT INTO `access_log` VALUES (40585, '64.82.15610803922547349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:26:32', 2, 0, '', '2019-06-21 09:26:32');
INSERT INTO `access_log` VALUES (40586, '64.81.15610803935587333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:26:34', 2, 0, '', '2019-06-21 09:26:34');
INSERT INTO `access_log` VALUES (40587, '64.77.15610803941447337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:26:34', 2, 0, '', '2019-06-21 09:26:34');
INSERT INTO `access_log` VALUES (40588, '64.80.15610803947927337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:26:35', 2, 0, '', '2019-06-21 09:26:35');
INSERT INTO `access_log` VALUES (40589, '64.85.15610803972887353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:26:37', 2, 0, '', '2019-06-21 09:26:37');
INSERT INTO `access_log` VALUES (40590, '64.76.15610803978247323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:26:38', 2, 0, '', '2019-06-21 09:26:38');
INSERT INTO `access_log` VALUES (40591, '64.83.15610803981947333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.22.7.114', '2019-06-21 09:26:38', 1, 0, '', '2019-06-21 09:26:38');
INSERT INTO `access_log` VALUES (40592, '64.79.15610804029217341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:43', 2, 0, '', '2019-06-21 09:26:43');
INSERT INTO `access_log` VALUES (40593, '64.84.15610804035707331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:44', 2, 0, '', '2019-06-21 09:26:44');
INSERT INTO `access_log` VALUES (40594, '64.82.15610804040107351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:44', 2, 0, '', '2019-06-21 09:26:44');
INSERT INTO `access_log` VALUES (40595, '64.81.15610804047137335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:45', 2, 0, '', '2019-06-21 09:26:45');
INSERT INTO `access_log` VALUES (40596, '64.77.15610804052017339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:45', 2, 0, '', '2019-06-21 09:26:45');
INSERT INTO `access_log` VALUES (40597, '64.80.15610804057547339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:46', 2, 0, '', '2019-06-21 09:26:46');
INSERT INTO `access_log` VALUES (40598, '64.78.15610804061977343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:46', 2, 0, '', '2019-06-21 09:26:46');
INSERT INTO `access_log` VALUES (40599, '64.85.15610804066257355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:47', 2, 0, '', '2019-06-21 09:26:47');
INSERT INTO `access_log` VALUES (40600, '64.76.15610804070917325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:47', 2, 0, '', '2019-06-21 09:26:47');
INSERT INTO `access_log` VALUES (40601, '64.83.15610804088897335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:49', 2, 0, '', '2019-06-21 09:26:49');
INSERT INTO `access_log` VALUES (40602, '64.79.15610804094037343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:49', 1, 0, '', '2019-06-21 09:26:49');
INSERT INTO `access_log` VALUES (40603, '64.82.15610804125307353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:53', 2, 0, '', '2019-06-21 09:26:53');
INSERT INTO `access_log` VALUES (40604, '64.81.15610804136747337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:54', 2, 0, '', '2019-06-21 09:26:54');
INSERT INTO `access_log` VALUES (40605, '64.77.15610804142737341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:54', 2, 0, '', '2019-06-21 09:26:54');
INSERT INTO `access_log` VALUES (40606, '64.80.15610804156427341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:56', 2, 0, '', '2019-06-21 09:26:56');
INSERT INTO `access_log` VALUES (40607, '64.78.15610804160387345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:56', 1, 0, '', '2019-06-21 09:26:56');
INSERT INTO `access_log` VALUES (40608, '64.85.15610804167457357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:57', 2, 0, '', '2019-06-21 09:26:57');
INSERT INTO `access_log` VALUES (40609, '64.76.15610804171297327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:57', 2, 0, '', '2019-06-21 09:26:57');
INSERT INTO `access_log` VALUES (40610, '64.83.15610804175697337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:58', 2, 0, '', '2019-06-21 09:26:58');
INSERT INTO `access_log` VALUES (40611, '64.79.15610804179627345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:26:58', 2, 0, '', '2019-06-21 09:26:58');
INSERT INTO `access_log` VALUES (40612, '59.77.15610804265007331', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:07', 2, 0, '', '2019-06-21 09:27:07');
INSERT INTO `access_log` VALUES (40613, '59.73.15610804265057349', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:07', 12, 2001001000, '服务端发生异常', '2019-06-21 09:27:07');
INSERT INTO `access_log` VALUES (40614, '64.82.15610804292347355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:09', 2, 0, '', '2019-06-21 09:27:09');
INSERT INTO `access_log` VALUES (40615, '64.81.15610804293497339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:09', 1, 0, '', '2019-06-21 09:27:09');
INSERT INTO `access_log` VALUES (40616, '64.77.15610804338647343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:14', 2, 0, '', '2019-06-21 09:27:14');
INSERT INTO `access_log` VALUES (40617, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:14', 7, 0, '', '2019-06-21 09:27:14');
INSERT INTO `access_log` VALUES (40618, '64.80.15610804366087343', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:17', 8, 0, '', '2019-06-21 09:27:17');
INSERT INTO `access_log` VALUES (40619, '64.85.15610804460577359', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:26', 6, 0, '', '2019-06-21 09:27:26');
INSERT INTO `access_log` VALUES (40620, '64.76.15610804522197329', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:32', 6, 0, '', '2019-06-21 09:27:32');
INSERT INTO `access_log` VALUES (40621, '64.83.15610804526557339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:33', 2, 0, '', '2019-06-21 09:27:33');
INSERT INTO `access_log` VALUES (40622, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:33', 7, 0, '', '2019-06-21 09:27:33');
INSERT INTO `access_log` VALUES (40623, '64.79.15610804538517347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:34', 2, 0, '', '2019-06-21 09:27:34');
INSERT INTO `access_log` VALUES (40624, '64.84.15610804539487337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:34', 2, 0, '', '2019-06-21 09:27:34');
INSERT INTO `access_log` VALUES (40625, '59.80.15610804554087333', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:35', 2, 0, '', '2019-06-21 09:27:35');
INSERT INTO `access_log` VALUES (40626, '59.79.15610804554097349', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 2.3.6; zh-cn; GT-S5660 Build/GINGERBREAD) AppleWebKit/533.1 (KHTML, like Gecko) Version/4.0 Mobile Safari/533.1 MicroMessenger/4.5.255', '116.22.7.114', '2019-06-21 09:27:35', 13, 2001001000, '服务端发生异常', '2019-06-21 09:27:35');
INSERT INTO `access_log` VALUES (40627, '59.75.15610805584957347', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.247.60', '2019-06-21 09:29:18', 3, 0, '', '2019-06-21 09:29:18');
INSERT INTO `access_log` VALUES (40628, '59.72.15610805584957341', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.247.60', '2019-06-21 09:29:18', 13, 2001001000, '服务端发生异常', '2019-06-21 09:29:19');
INSERT INTO `access_log` VALUES (40629, '64.79.15610805684757349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.247.60', '2019-06-21 09:29:28', 2, 0, '', '2019-06-21 09:29:28');
INSERT INTO `access_log` VALUES (40630, '64.84.15610805686257339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.247.60', '2019-06-21 09:29:29', 2, 0, '', '2019-06-21 09:29:29');
INSERT INTO `access_log` VALUES (40631, '64.82.15610805699957359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.247.60', '2019-06-21 09:29:30', 2, 0, '', '2019-06-21 09:29:30');
INSERT INTO `access_log` VALUES (40632, '59.73.15610812584907361', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.77.137.231', '2019-06-21 09:40:58', 3, 0, '', '2019-06-21 09:40:58');
INSERT INTO `access_log` VALUES (40633, '59.75.15610812584927357', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.77.137.231', '2019-06-21 09:40:58', 13, 2001001000, '服务端发生异常', '2019-06-21 09:40:59');
INSERT INTO `access_log` VALUES (40634, '59.76.15610831119077375', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '113.109.38.10', '2019-06-21 10:11:52', 10, 0, '', '2019-06-21 10:11:52');
INSERT INTO `access_log` VALUES (40635, '59.71.15610831119137381', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '113.109.38.10', '2019-06-21 10:11:52', 14, 2001001000, '服务端发生异常', '2019-06-21 10:11:52');
INSERT INTO `access_log` VALUES (40636, '65.52.15610831179748311', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '113.109.38.10', '2019-06-21 10:11:58', 1, 1002001015, '账号未登陆', '2019-06-21 10:11:58');
INSERT INTO `access_log` VALUES (40637, '65.49.15610831179748309', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '113.109.38.10', '2019-06-21 10:11:58', 0, 1002001015, '账号未登陆', '2019-06-21 10:11:58');
INSERT INTO `access_log` VALUES (40638, '65.45.15610831179768301', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '113.109.38.10', '2019-06-21 10:11:58', 1, 1002001015, '账号未登陆', '2019-06-21 10:11:58');
INSERT INTO `access_log` VALUES (40639, '65.47.15610831233118299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '113.109.38.10', '2019-06-21 10:12:03', 66, 0, '', '2019-06-21 10:12:03');
INSERT INTO `access_log` VALUES (40640, '65.51.15610831237138339', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '113.109.38.10', '2019-06-21 10:12:04', 87, 0, '', '2019-06-21 10:12:04');
INSERT INTO `access_log` VALUES (40641, '65.50.15610831237218319', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '113.109.38.10', '2019-06-21 10:12:04', 83, 0, '', '2019-06-21 10:12:04');
INSERT INTO `access_log` VALUES (40642, '65.46.15610831237198353', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '113.109.38.10', '2019-06-21 10:12:04', 86, 2001001000, '服务端发生异常', '2019-06-21 10:12:04');
INSERT INTO `access_log` VALUES (40643, '65.50.15610840019068331', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:26:42', 1, 1002001015, '账号未登陆', '2019-06-21 10:26:42');
INSERT INTO `access_log` VALUES (40644, '65.53.15610840019108309', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:26:42', 1, 1002001015, '账号未登陆', '2019-06-21 10:26:42');
INSERT INTO `access_log` VALUES (40645, '65.3607.15610840019130085', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:26:42', 0, 1002001015, '账号未登陆', '2019-06-21 10:26:42');
INSERT INTO `access_log` VALUES (40646, '65.54.15610840036988281', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:26:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 10:26:44');
INSERT INTO `access_log` VALUES (40647, '65.52.15610840079228325', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:26:48', 140, 0, '', '2019-06-21 10:26:48');
INSERT INTO `access_log` VALUES (40648, '65.49.15610840083588323', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:26:48', 10, 0, '', '2019-06-21 10:26:48');
INSERT INTO `access_log` VALUES (40649, '65.45.15610840083688315', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:26:48', 8, 0, '', '2019-06-21 10:26:48');
INSERT INTO `access_log` VALUES (40650, '65.47.15610840083728313', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:26:48', 8, 0, '', '2019-06-21 10:26:48');
INSERT INTO `access_log` VALUES (40651, '62.82.15610840135267025', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:26:54', 21, 0, '', '2019-06-21 10:26:54');
INSERT INTO `access_log` VALUES (40652, '64.77.15610840177597393', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:26:58', 22, 0, '', '2019-06-21 10:26:58');
INSERT INTO `access_log` VALUES (40653, '64.81.15610840177587389', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:26:58', 27, 0, '', '2019-06-21 10:26:58');
INSERT INTO `access_log` VALUES (40654, '59.77.15610840182687381', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:26:58', 13, 2001001000, '服务端发生异常', '2019-06-21 10:26:58');
INSERT INTO `access_log` VALUES (40655, '59.74.15610840182567391', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:26:58', 112, 0, '', '2019-06-21 10:26:58');
INSERT INTO `access_log` VALUES (40656, '64.80.15610840231387393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:03', 10, 0, '', '2019-06-21 10:27:03');
INSERT INTO `access_log` VALUES (40657, '64.78.15610840233097397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:03', 3, 0, '', '2019-06-21 10:27:03');
INSERT INTO `access_log` VALUES (40658, '64.76.15610840276747379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:08', 2, 0, '', '2019-06-21 10:27:08');
INSERT INTO `access_log` VALUES (40659, '64.83.15610840278497389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:08', 2, 0, '', '2019-06-21 10:27:08');
INSERT INTO `access_log` VALUES (40660, '59.75.15610840294677395', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:09', 2, 0, '', '2019-06-21 10:27:09');
INSERT INTO `access_log` VALUES (40661, '59.72.15610840294717389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:09', 12, 2001001000, '服务端发生异常', '2019-06-21 10:27:09');
INSERT INTO `access_log` VALUES (40662, '59.79.15610840342337399', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:14', 2, 0, '', '2019-06-21 10:27:14');
INSERT INTO `access_log` VALUES (40663, '59.80.15610840342337383', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:14', 13, 2001001000, '服务端发生异常', '2019-06-21 10:27:14');
INSERT INTO `access_log` VALUES (40664, '59.76.15610840376327389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:18', 2, 0, '', '2019-06-21 10:27:18');
INSERT INTO `access_log` VALUES (40665, '59.78.15610840376327393', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:18', 23, 2001001000, '服务端发生异常', '2019-06-21 10:27:18');
INSERT INTO `access_log` VALUES (40666, '66.56.15610840402105691', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:27:20', 19, 0, '', '2019-06-21 10:27:20');
INSERT INTO `access_log` VALUES (40667, '64.84.15610840467007387', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:27:27', 11, 0, '', '2019-06-21 10:27:27');
INSERT INTO `access_log` VALUES (40668, '64.82.15610840467067407', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:27:27', 8, 0, '', '2019-06-21 10:27:27');
INSERT INTO `access_log` VALUES (40669, '62.83.15610840471997031', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:27:27', 10, 0, '', '2019-06-21 10:27:27');
INSERT INTO `access_log` VALUES (40670, '59.77.15610840502197383', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:30', 12, 2001001000, '服务端发生异常', '2019-06-21 10:27:30');
INSERT INTO `access_log` VALUES (40671, '59.74.15610840502197393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:30', 97, 0, '', '2019-06-21 10:27:30');
INSERT INTO `access_log` VALUES (40672, '64.77.15610840511557395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:31', 2, 0, '', '2019-06-21 10:27:31');
INSERT INTO `access_log` VALUES (40673, '64.81.15610840513027391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:31', 2, 0, '', '2019-06-21 10:27:31');
INSERT INTO `access_log` VALUES (40674, '59.75.15610840519977397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:32', 2, 0, '', '2019-06-21 10:27:32');
INSERT INTO `access_log` VALUES (40675, '59.73.15610840519977401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:32', 13, 2001001000, '服务端发生异常', '2019-06-21 10:27:32');
INSERT INTO `access_log` VALUES (40676, '59.80.15610840614347385', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:41', 2, 0, '', '2019-06-21 10:27:41');
INSERT INTO `access_log` VALUES (40677, '59.79.15610840614337401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.10.33', '2019-06-21 10:27:41', 15, 2001001000, '服务端发生异常', '2019-06-21 10:27:41');
INSERT INTO `access_log` VALUES (40678, '64.85.15610840821357411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '36.102.10.33', '2019-06-21 10:28:02', 2, 0, '', '2019-06-21 10:28:02');
INSERT INTO `access_log` VALUES (40679, '64.76.15610840823077381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '36.102.10.33', '2019-06-21 10:28:02', 2, 0, '', '2019-06-21 10:28:02');
INSERT INTO `access_log` VALUES (40680, '64.79.15610840866827399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '36.102.10.33', '2019-06-21 10:28:07', 2, 0, '', '2019-06-21 10:28:07');
INSERT INTO `access_log` VALUES (40681, '64.84.15610840868487389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '36.102.10.33', '2019-06-21 10:28:07', 2, 0, '', '2019-06-21 10:28:07');
INSERT INTO `access_log` VALUES (40682, '64.82.15610840881097409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '36.102.10.33', '2019-06-21 10:28:08', 2, 0, '', '2019-06-21 10:28:08');
INSERT INTO `access_log` VALUES (40683, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '36.102.10.33', '2019-06-21 10:28:08', 6, 0, '', '2019-06-21 10:28:08');
INSERT INTO `access_log` VALUES (40684, '64.77.15610840894747397', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '36.102.10.33', '2019-06-21 10:28:09', 6, 0, '', '2019-06-21 10:28:09');
INSERT INTO `access_log` VALUES (40685, '64.81.15610840987137393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '36.102.10.33', '2019-06-21 10:28:19', 1, 0, '', '2019-06-21 10:28:19');
INSERT INTO `access_log` VALUES (40686, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '36.102.10.33', '2019-06-21 10:28:19', 6, 0, '', '2019-06-21 10:28:19');
INSERT INTO `access_log` VALUES (40687, '64.80.15610840995667397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '36.102.10.33', '2019-06-21 10:28:20', 2, 0, '', '2019-06-21 10:28:20');
INSERT INTO `access_log` VALUES (40688, '64.78.15610840996907401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '36.102.10.33', '2019-06-21 10:28:20', 2, 0, '', '2019-06-21 10:28:20');
INSERT INTO `access_log` VALUES (40689, '59.77.15610841011947385', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '36.102.10.33', '2019-06-21 10:28:21', 2, 0, '', '2019-06-21 10:28:21');
INSERT INTO `access_log` VALUES (40690, '59.74.15610841011957395', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '36.102.10.33', '2019-06-21 10:28:21', 14, 2001001000, '服务端发生异常', '2019-06-21 10:28:21');
INSERT INTO `access_log` VALUES (40691, '59.74.15610842195157397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.240.236.76', '2019-06-21 10:30:20', 3, 0, '', '2019-06-21 10:30:20');
INSERT INTO `access_log` VALUES (40692, '59.77.15610842195197387', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.240.236.76', '2019-06-21 10:30:20', 13, 2001001000, '服务端发生异常', '2019-06-21 10:30:20');
INSERT INTO `access_log` VALUES (40693, '64.78.15610842242227403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.240.236.76', '2019-06-21 10:30:24', 3, 0, '', '2019-06-21 10:30:24');
INSERT INTO `access_log` VALUES (40694, '64.85.15610842243537415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.240.236.76', '2019-06-21 10:30:24', 2, 0, '', '2019-06-21 10:30:24');
INSERT INTO `access_log` VALUES (40695, '59.75.15610842255087401', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.240.236.76', '2019-06-21 10:30:26', 3, 0, '', '2019-06-21 10:30:26');
INSERT INTO `access_log` VALUES (40696, '59.73.15610842255077405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.240.236.76', '2019-06-21 10:30:26', 12, 2001001000, '服务端发生异常', '2019-06-21 10:30:26');
INSERT INTO `access_log` VALUES (40697, '64.76.15610842282737385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.240.236.76', '2019-06-21 10:30:28', 2, 0, '', '2019-06-21 10:30:28');
INSERT INTO `access_log` VALUES (40698, '64.83.15610842283907395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.240.236.76', '2019-06-21 10:30:28', 2, 0, '', '2019-06-21 10:30:28');
INSERT INTO `access_log` VALUES (40699, '59.72.15610842300497395', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.240.236.76', '2019-06-21 10:30:30', 2, 0, '', '2019-06-21 10:30:30');
INSERT INTO `access_log` VALUES (40700, '59.80.15610842300527389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.240.236.76', '2019-06-21 10:30:30', 9, 2001001000, '服务端发生异常', '2019-06-21 10:30:30');
INSERT INTO `access_log` VALUES (40701, '65.47.15610842592408317', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.240.236.76', '2019-06-21 10:30:59', 1, 1002001015, '账号未登陆', '2019-06-21 10:30:59');
INSERT INTO `access_log` VALUES (40702, '65.45.15610842592408319', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.240.236.76', '2019-06-21 10:30:59', 1, 1002001015, '账号未登陆', '2019-06-21 10:30:59');
INSERT INTO `access_log` VALUES (40703, '65.49.15610842592458327', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.240.236.76', '2019-06-21 10:30:59', 0, 1002001015, '账号未登陆', '2019-06-21 10:30:59');
INSERT INTO `access_log` VALUES (40704, '65.46.15610842609338371', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.240.236.76', '2019-06-21 10:31:01', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 10:31:01');
INSERT INTO `access_log` VALUES (40705, '59.78.15610844042417401', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:33:24', 3, 0, '', '2019-06-21 10:33:24');
INSERT INTO `access_log` VALUES (40706, '59.71.15610844042417403', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:33:24', 10, 2001001000, '服务端发生异常', '2019-06-21 10:33:24');
INSERT INTO `access_log` VALUES (40707, '64.82.15610844083427415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:33:28', 2, 0, '', '2019-06-21 10:33:28');
INSERT INTO `access_log` VALUES (40708, '64.77.15610844084947403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:33:28', 2, 0, '', '2019-06-21 10:33:28');
INSERT INTO `access_log` VALUES (40709, '64.81.15610844125267399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:33:33', 3, 0, '', '2019-06-21 10:33:33');
INSERT INTO `access_log` VALUES (40710, '64.80.15610844126657403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:33:33', 2, 0, '', '2019-06-21 10:33:33');
INSERT INTO `access_log` VALUES (40711, '59.74.15610844134447401', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:33:33', 3, 0, '', '2019-06-21 10:33:33');
INSERT INTO `access_log` VALUES (40712, '59.77.15610844134467391', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:33:33', 12, 2001001000, '服务端发生异常', '2019-06-21 10:33:33');
INSERT INTO `access_log` VALUES (40713, '66.51.15610844294855705', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15565061502&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:33:49', 10, 1001003000, '验证码不存在', '2019-06-21 10:33:49');
INSERT INTO `access_log` VALUES (40714, '59.80.15610844330177393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:33:53', 2, 0, '', '2019-06-21 10:33:53');
INSERT INTO `access_log` VALUES (40715, '59.72.15610844330177399', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.88.63.137', '2019-06-21 10:33:53', 19, 2001001000, '服务端发生异常', '2019-06-21 10:33:53');
INSERT INTO `access_log` VALUES (40716, '65.52.15610853660448345', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:26', 0, 1002001015, '账号未登陆', '2019-06-21 10:49:26');
INSERT INTO `access_log` VALUES (40717, '65.54.15610853660448301', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:26', 0, 1002001015, '账号未登陆', '2019-06-21 10:49:26');
INSERT INTO `access_log` VALUES (40718, '65.47.15610853660718333', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:26', 0, 1002001015, '账号未登陆', '2019-06-21 10:49:26');
INSERT INTO `access_log` VALUES (40719, '65.45.15610853680738335', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 10:49:28');
INSERT INTO `access_log` VALUES (40720, '65.49.15610853700788343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:30', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 10:49:30');
INSERT INTO `access_log` VALUES (40721, '65.46.15610853714638387', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 10:49:31');
INSERT INTO `access_log` VALUES (40722, '65.51.15610853773338373', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:37', 117, 0, '', '2019-06-21 10:49:37');
INSERT INTO `access_log` VALUES (40723, '65.53.15610853778998331', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:38', 9, 0, '', '2019-06-21 10:49:38');
INSERT INTO `access_log` VALUES (40724, '65.3607.15610853779100107', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:38', 9, 0, '', '2019-06-21 10:49:38');
INSERT INTO `access_log` VALUES (40725, '65.50.15610853779138353', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:38', 9, 0, '', '2019-06-21 10:49:38');
INSERT INTO `access_log` VALUES (40726, '65.52.15610853860488347', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:46', 9, 0, '', '2019-06-21 10:49:46');
INSERT INTO `access_log` VALUES (40727, '65.47.15610853860528335', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:46', 9, 0, '', '2019-06-21 10:49:46');
INSERT INTO `access_log` VALUES (40728, '65.45.15610853860608337', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:46', 9, 0, '', '2019-06-21 10:49:46');
INSERT INTO `access_log` VALUES (40729, '62.83.15610853887447049', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:49', 155, 0, '', '2019-06-21 10:49:49');
INSERT INTO `access_log` VALUES (40730, '64.77.15610853936337417', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:54', 11, 0, '', '2019-06-21 10:49:54');
INSERT INTO `access_log` VALUES (40731, '64.82.15610853936297429', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:54', 14, 0, '', '2019-06-21 10:49:54');
INSERT INTO `access_log` VALUES (40732, '62.86.15610853977777029', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:49:58', 12, 0, '', '2019-06-21 10:49:58');
INSERT INTO `access_log` VALUES (40733, '62.87.15610854024807045', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:50:02', 15, 0, '', '2019-06-21 10:50:02');
INSERT INTO `access_log` VALUES (40734, '64.80.15610854159097417', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:50:16', 12, 0, '', '2019-06-21 10:50:16');
INSERT INTO `access_log` VALUES (40735, '64.78.15610854159137421', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:50:16', 8, 0, '', '2019-06-21 10:50:16');
INSERT INTO `access_log` VALUES (40736, '59.77.15610854179817405', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:50:18', 14, 0, '', '2019-06-21 10:50:18');
INSERT INTO `access_log` VALUES (40737, '59.73.15610854261937423', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:50:26', 16, 2001001000, '服务端发生异常', '2019-06-21 10:50:26');
INSERT INTO `access_log` VALUES (40738, '65.3607.15610854284460109', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:50:28', 20, 0, '', '2019-06-21 10:50:28');
INSERT INTO `access_log` VALUES (40739, '65.54.15610856123428307', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:53:32', 208, 0, '', '2019-06-21 10:53:33');
INSERT INTO `access_log` VALUES (40740, '65.45.15610856134308341', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:53:33', 9, 0, '', '2019-06-21 10:53:33');
INSERT INTO `access_log` VALUES (40741, '65.47.15610856140158339', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:53:34', 14, 0, '', '2019-06-21 10:53:34');
INSERT INTO `access_log` VALUES (40742, '65.52.15610856151728351', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.144.203.194', '2019-06-21 10:53:35', 7, 0, '', '2019-06-21 10:53:35');
INSERT INTO `access_log` VALUES (40743, '59.78.15610859312967423', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.40.210', '2019-06-21 10:58:51', 3, 0, '', '2019-06-21 10:58:51');
INSERT INTO `access_log` VALUES (40744, '59.71.15610859312967425', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.40.210', '2019-06-21 10:58:51', 12, 2001001000, '服务端发生异常', '2019-06-21 10:58:51');
INSERT INTO `access_log` VALUES (40745, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=鞋子&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.40.210', '2019-06-21 10:58:59', 7, 0, '', '2019-06-21 10:58:59');
INSERT INTO `access_log` VALUES (40746, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=鞋子', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.40.210', '2019-06-21 10:58:59', 6, 0, '', '2019-06-21 10:58:59');
INSERT INTO `access_log` VALUES (40747, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.40.210', '2019-06-21 10:59:08', 7, 0, '', '2019-06-21 10:59:08');
INSERT INTO `access_log` VALUES (40748, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.40.210', '2019-06-21 10:59:08', 12, 0, '', '2019-06-21 10:59:08');
INSERT INTO `access_log` VALUES (40749, '64.82.15610859502877437', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.238.40.210', '2019-06-21 10:59:10', 7, 0, '', '2019-06-21 10:59:10');
INSERT INTO `access_log` VALUES (40750, '59.76.15610881413077449', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 11:35:41', 11, 0, '', '2019-06-21 11:35:41');
INSERT INTO `access_log` VALUES (40751, '59.71.15610881413087455', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 11:35:41', 15, 2001001000, '服务端发生异常', '2019-06-21 11:35:41');
INSERT INTO `access_log` VALUES (40752, '64.79.15610881473167457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 11:35:47', 11, 0, '', '2019-06-21 11:35:47');
INSERT INTO `access_log` VALUES (40753, '64.84.15610881474817447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 11:35:47', 3, 0, '', '2019-06-21 11:35:47');
INSERT INTO `access_log` VALUES (40754, '64.82.15610881520337467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 11:35:52', 1, 0, '', '2019-06-21 11:35:52');
INSERT INTO `access_log` VALUES (40755, '64.81.15610881533397451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 11:35:53', 2, 0, '', '2019-06-21 11:35:53');
INSERT INTO `access_log` VALUES (40756, '59.77.15610890616077455', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:51:02', 4, 0, '', '2019-06-21 11:51:02');
INSERT INTO `access_log` VALUES (40757, '59.74.15610890616077465', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:51:02', 13, 2001001000, '服务端发生异常', '2019-06-21 11:51:02');
INSERT INTO `access_log` VALUES (40758, '66.55.15610890806805747', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15921563201&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:51:21', 13, 1001003000, '验证码不存在', '2019-06-21 11:51:21');
INSERT INTO `access_log` VALUES (40759, '66.56.15610890827035759', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15921563201', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:51:23', 73, 0, '', '2019-06-21 11:51:23');
INSERT INTO `access_log` VALUES (40760, '66.50.15610890845505747', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15921563201&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:51:25', 171, 0, '', '2019-06-21 11:51:25');
INSERT INTO `access_log` VALUES (40761, '66.48.15610890860575759', 130, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:51:26', 6, 0, '', '2019-06-21 11:51:26');
INSERT INTO `access_log` VALUES (40762, '66.52.15610890897185757', 130, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:51:30', 6, 0, '', '2019-06-21 11:51:30');
INSERT INTO `access_log` VALUES (40763, '66.49.15610890907015761', 130, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:51:31', 6, 0, '', '2019-06-21 11:51:31');
INSERT INTO `access_log` VALUES (40764, '66.55.15610891293835749', 130, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:52:09', 5, 0, '', '2019-06-21 11:52:09');
INSERT INTO `access_log` VALUES (40765, '59.78.15610891319197467', 130, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:52:12', 7, 0, '', '2019-06-21 11:52:12');
INSERT INTO `access_log` VALUES (40766, '59.74.15610891319277467', 130, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:52:12', 16, 2001001000, '服务端发生异常', '2019-06-21 11:52:12');
INSERT INTO `access_log` VALUES (40767, '64.84.15610891340087461', 130, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:52:14', 7, 0, '', '2019-06-21 11:52:14');
INSERT INTO `access_log` VALUES (40768, '64.82.15610891341777481', 130, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:52:14', 5, 0, '', '2019-06-21 11:52:14');
INSERT INTO `access_log` VALUES (40769, '64.80.15610891355127469', 130, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:52:16', 5, 0, '', '2019-06-21 11:52:16');
INSERT INTO `access_log` VALUES (40770, '64.85.15610891360527485', 130, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 11:52:16', 5, 0, '', '2019-06-21 11:52:16');
INSERT INTO `access_log` VALUES (40771, '65.50.15610896041138411', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.137.52.5', '2019-06-21 12:00:04', 1, 1002001015, '账号未登陆', '2019-06-21 12:00:04');
INSERT INTO `access_log` VALUES (40772, '65.53.15610896041138389', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.137.52.5', '2019-06-21 12:00:04', 0, 1002001015, '账号未登陆', '2019-06-21 12:00:04');
INSERT INTO `access_log` VALUES (40773, '65.54.15610896041138361', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.137.52.5', '2019-06-21 12:00:04', 0, 1002001015, '账号未登陆', '2019-06-21 12:00:04');
INSERT INTO `access_log` VALUES (40774, '65.52.15610896377208405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.137.52.5', '2019-06-21 12:00:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 12:00:38');
INSERT INTO `access_log` VALUES (40775, '59.76.15610898063357473', 130, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 12:03:26', 7, 0, '', '2019-06-21 12:03:26');
INSERT INTO `access_log` VALUES (40776, '59.78.15610898063407477', 130, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 12:03:26', 15, 2001001000, '服务端发生异常', '2019-06-21 12:03:26');
INSERT INTO `access_log` VALUES (40777, '64.83.15610898955497475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 12:04:56', 2, 0, '', '2019-06-21 12:04:56');
INSERT INTO `access_log` VALUES (40778, '64.79.15610898960937483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 12:04:56', 2, 0, '', '2019-06-21 12:04:56');
INSERT INTO `access_log` VALUES (40779, '59.71.15610898972937481', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 12:04:57', 12, 2001001000, '服务端发生异常', '2019-06-21 12:04:57');
INSERT INTO `access_log` VALUES (40780, '59.79.15610898972437485', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 12:04:57', 102, 0, '', '2019-06-21 12:04:57');
INSERT INTO `access_log` VALUES (40781, '64.84.15610898996977473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 12:05:00', 2, 0, '', '2019-06-21 12:05:00');
INSERT INTO `access_log` VALUES (40782, '64.77.15610899006807481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 12:05:01', 1, 0, '', '2019-06-21 12:05:01');
INSERT INTO `access_log` VALUES (40783, '59.78.15610899066757479', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 12:05:07', 2, 0, '', '2019-06-21 12:05:07');
INSERT INTO `access_log` VALUES (40784, '59.74.15610899066767479', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 12:05:07', 10, 2001001000, '服务端发生异常', '2019-06-21 12:05:07');
INSERT INTO `access_log` VALUES (40785, '64.81.15610899078077477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 12:05:08', 2, 0, '', '2019-06-21 12:05:08');
INSERT INTO `access_log` VALUES (40786, '64.80.15610899079307481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 12:05:08', 2, 0, '', '2019-06-21 12:05:08');
INSERT INTO `access_log` VALUES (40787, '59.77.15610899096577469', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 12:05:10', 2, 0, '', '2019-06-21 12:05:10');
INSERT INTO `access_log` VALUES (40788, '59.75.15610899096587483', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.185.212.78', '2019-06-21 12:05:10', 13, 2001001000, '服务端发生异常', '2019-06-21 12:05:10');
INSERT INTO `access_log` VALUES (40789, '59.72.15610926411217513', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.247.21.202', '2019-06-21 12:50:41', 15, 0, '', '2019-06-21 12:50:41');
INSERT INTO `access_log` VALUES (40790, '59.71.15610926411227519', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.247.21.202', '2019-06-21 12:50:41', 17, 2001001000, '服务端发生异常', '2019-06-21 12:50:41');
INSERT INTO `access_log` VALUES (40791, '64.76.15610926484107503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.247.21.202', '2019-06-21 12:50:48', 12, 0, '', '2019-06-21 12:50:48');
INSERT INTO `access_log` VALUES (40792, '64.83.15610926485567513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.247.21.202', '2019-06-21 12:50:49', 3, 0, '', '2019-06-21 12:50:49');
INSERT INTO `access_log` VALUES (40793, '64.84.15610926517697511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.247.21.202', '2019-06-21 12:50:52', 2, 0, '', '2019-06-21 12:50:52');
INSERT INTO `access_log` VALUES (40794, '64.77.15610926519187519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.247.21.202', '2019-06-21 12:50:52', 1, 0, '', '2019-06-21 12:50:52');
INSERT INTO `access_log` VALUES (40795, '65.50.15610926719148453', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.247.21.202', '2019-06-21 12:51:12', 1, 1002001015, '账号未登陆', '2019-06-21 12:51:12');
INSERT INTO `access_log` VALUES (40796, '65.53.15610926719158431', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.247.21.202', '2019-06-21 12:51:12', 0, 1002001015, '账号未登陆', '2019-06-21 12:51:12');
INSERT INTO `access_log` VALUES (40797, '65.45.15610926719378439', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.247.21.202', '2019-06-21 12:51:12', 0, 1002001015, '账号未登陆', '2019-06-21 12:51:12');
INSERT INTO `access_log` VALUES (40798, '65.52.15610926768908445', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.247.21.202', '2019-06-21 12:51:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 12:51:17');
INSERT INTO `access_log` VALUES (40799, '65.49.15610926804788445', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.247.21.202', '2019-06-21 12:51:20', 98, 0, '', '2019-06-21 12:51:21');
INSERT INTO `access_log` VALUES (40800, '65.46.15610926808848491', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.247.21.202', '2019-06-21 12:51:21', 12, 0, '', '2019-06-21 12:51:21');
INSERT INTO `access_log` VALUES (40801, '65.51.15610926808888477', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.247.21.202', '2019-06-21 12:51:21', 10, 2001001000, '服务端发生异常', '2019-06-21 12:51:21');
INSERT INTO `access_log` VALUES (40802, '65.3607.15610926808930211', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '60.247.21.202', '2019-06-21 12:51:21', 10, 0, '', '2019-06-21 12:51:21');
INSERT INTO `access_log` VALUES (40803, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=白菜&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 12:54:32', 18, 0, '', '2019-06-21 12:54:32');
INSERT INTO `access_log` VALUES (40804, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=白菜', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 12:54:32', 12, 0, '', '2019-06-21 12:54:32');
INSERT INTO `access_log` VALUES (40805, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=白菜&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=desc', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 12:54:39', 15, 0, '', '2019-06-21 12:54:39');
INSERT INTO `access_log` VALUES (40806, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=白菜&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=asc', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 12:54:40', 13, 0, '', '2019-06-21 12:54:41');
INSERT INTO `access_log` VALUES (40807, '65.51.15610943041458501', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:18:24', 1, 1002001015, '账号未登陆', '2019-06-21 13:18:24');
INSERT INTO `access_log` VALUES (40808, '65.46.15610943041468513', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:18:24', 1, 1002001015, '账号未登陆', '2019-06-21 13:18:24');
INSERT INTO `access_log` VALUES (40809, '65.3607.15610943041620233', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:18:24', 0, 1002001015, '账号未登陆', '2019-06-21 13:18:24');
INSERT INTO `access_log` VALUES (40810, '65.54.15610943057868429', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:18:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 13:18:26');
INSERT INTO `access_log` VALUES (40811, '65.50.15610943271858477', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:18:47', 83, 0, '', '2019-06-21 13:18:47');
INSERT INTO `access_log` VALUES (40812, '65.45.15610943275218463', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:18:48', 10, 0, '', '2019-06-21 13:18:48');
INSERT INTO `access_log` VALUES (40813, '65.52.15610943275248469', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:18:48', 8, 0, '', '2019-06-21 13:18:48');
INSERT INTO `access_log` VALUES (40814, '65.53.15610943275238455', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:18:48', 12, 2001001000, '服务端发生异常', '2019-06-21 13:18:48');
INSERT INTO `access_log` VALUES (40815, '65.46.15610943307238515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:18:51', 21, 0, '', '2019-06-21 13:18:51');
INSERT INTO `access_log` VALUES (40816, '65.49.15610943307238469', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:18:51', 22, 0, '', '2019-06-21 13:18:51');
INSERT INTO `access_log` VALUES (40817, '65.51.15610943307248503', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:18:51', 22, 2001001000, '服务端发生异常', '2019-06-21 13:18:51');
INSERT INTO `access_log` VALUES (40818, '59.75.15610957078207561', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.207.216.34', '2019-06-21 13:41:48', 14, 0, '', '2019-06-21 13:41:48');
INSERT INTO `access_log` VALUES (40819, '59.77.15610957078207547', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.207.216.34', '2019-06-21 13:41:48', 20, 2001001000, '服务端发生异常', '2019-06-21 13:41:48');
INSERT INTO `access_log` VALUES (40820, '64.85.15610957109977575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.207.216.34', '2019-06-21 13:41:51', 13, 0, '', '2019-06-21 13:41:51');
INSERT INTO `access_log` VALUES (40821, '64.76.15610957111417545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.207.216.34', '2019-06-21 13:41:51', 3, 0, '', '2019-06-21 13:41:51');
INSERT INTO `access_log` VALUES (40822, '64.83.15610957122257555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.207.216.34', '2019-06-21 13:41:52', 2, 0, '', '2019-06-21 13:41:52');
INSERT INTO `access_log` VALUES (40823, '64.79.15610957126527563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.207.216.34', '2019-06-21 13:41:53', 2, 0, '', '2019-06-21 13:41:53');
INSERT INTO `access_log` VALUES (40824, '64.84.15610957188547553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.207.216.34', '2019-06-21 13:41:59', 1, 0, '', '2019-06-21 13:41:59');
INSERT INTO `access_log` VALUES (40825, '64.77.15610957189787561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.207.216.34', '2019-06-21 13:41:59', 2, 0, '', '2019-06-21 13:41:59');
INSERT INTO `access_log` VALUES (40826, '59.80.15610957203267549', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.207.216.34', '2019-06-21 13:42:00', 3, 0, '', '2019-06-21 13:42:00');
INSERT INTO `access_log` VALUES (40827, '59.72.15610957203267555', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.207.216.34', '2019-06-21 13:42:00', 13, 2001001000, '服务端发生异常', '2019-06-21 13:42:00');
INSERT INTO `access_log` VALUES (40828, '64.81.15610957378697557', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.207.216.34', '2019-06-21 13:42:18', 2, 0, '', '2019-06-21 13:42:18');
INSERT INTO `access_log` VALUES (40829, '64.80.15610957379967561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '111.207.216.34', '2019-06-21 13:42:18', 2, 0, '', '2019-06-21 13:42:18');
INSERT INTO `access_log` VALUES (40830, '65.49.15610957767848489', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '183.30.178.138', '2019-06-21 13:42:57', 0, 1002001015, '账号未登陆', '2019-06-21 13:42:57');
INSERT INTO `access_log` VALUES (40831, '65.46.15610957767848535', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '183.30.178.138', '2019-06-21 13:42:57', 0, 1002001015, '账号未登陆', '2019-06-21 13:42:57');
INSERT INTO `access_log` VALUES (40832, '65.51.15610957767848523', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '183.30.178.138', '2019-06-21 13:42:57', 0, 1002001015, '账号未登陆', '2019-06-21 13:42:57');
INSERT INTO `access_log` VALUES (40833, '65.3607.15610957795230255', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '183.30.178.138', '2019-06-21 13:43:00', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 13:43:00');
INSERT INTO `access_log` VALUES (40834, '65.47.15610958022248483', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '183.30.178.138', '2019-06-21 13:43:22', 84, 0, '', '2019-06-21 13:43:22');
INSERT INTO `access_log` VALUES (40835, '65.50.15610958030008499', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '183.30.178.138', '2019-06-21 13:43:23', 10, 0, '', '2019-06-21 13:43:23');
INSERT INTO `access_log` VALUES (40836, '65.45.15610958030128485', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '183.30.178.138', '2019-06-21 13:43:23', 9, 2001001000, '服务端发生异常', '2019-06-21 13:43:23');
INSERT INTO `access_log` VALUES (40837, '65.52.15610958030258491', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '183.30.178.138', '2019-06-21 13:43:23', 8, 0, '', '2019-06-21 13:43:23');
INSERT INTO `access_log` VALUES (40838, '65.51.15610958125348525', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '183.30.178.138', '2019-06-21 13:43:33', 9, 0, '', '2019-06-21 13:43:33');
INSERT INTO `access_log` VALUES (40839, '65.49.15610958125408491', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '183.30.178.138', '2019-06-21 13:43:33', 10, 2001001000, '服务端发生异常', '2019-06-21 13:43:33');
INSERT INTO `access_log` VALUES (40840, '65.46.15610958125458537', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '183.30.178.138', '2019-06-21 13:43:33', 8, 0, '', '2019-06-21 13:43:33');
INSERT INTO `access_log` VALUES (40841, '59.73.15610962732897573', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.242.237.192', '2019-06-21 13:51:13', 3, 0, '', '2019-06-21 13:51:13');
INSERT INTO `access_log` VALUES (40842, '59.80.15610962732907557', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.242.237.192', '2019-06-21 13:51:13', 12, 2001001000, '服务端发生异常', '2019-06-21 13:51:13');
INSERT INTO `access_log` VALUES (40843, '65.47.15610962845768491', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.242.237.192', '2019-06-21 13:51:25', 0, 1002001015, '账号未登陆', '2019-06-21 13:51:25');
INSERT INTO `access_log` VALUES (40844, '65.45.15610962845768493', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.242.237.192', '2019-06-21 13:51:25', 0, 1002001015, '账号未登陆', '2019-06-21 13:51:25');
INSERT INTO `access_log` VALUES (40845, '65.50.15610962845818507', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.242.237.192', '2019-06-21 13:51:25', 1, 1002001015, '账号未登陆', '2019-06-21 13:51:25');
INSERT INTO `access_log` VALUES (40846, '65.52.15610962863688499', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.242.237.192', '2019-06-21 13:51:26', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 13:51:26');
INSERT INTO `access_log` VALUES (40847, '65.53.15610962898728485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.242.237.192', '2019-06-21 13:51:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 13:51:30');
INSERT INTO `access_log` VALUES (40848, '65.51.15610962905368533', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.242.237.192', '2019-06-21 13:51:31', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 13:51:31');
INSERT INTO `access_log` VALUES (40849, '65.46.15610962911698545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.242.237.192', '2019-06-21 13:51:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 13:51:31');
INSERT INTO `access_log` VALUES (40850, '65.49.15610962919458499', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.242.237.192', '2019-06-21 13:51:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 13:51:32');
INSERT INTO `access_log` VALUES (40851, '65.54.15610963022248461', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.242.237.192', '2019-06-21 13:51:42', 80, 0, '', '2019-06-21 13:51:42');
INSERT INTO `access_log` VALUES (40852, '65.50.15610963025388509', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.242.237.192', '2019-06-21 13:51:43', 10, 0, '', '2019-06-21 13:51:43');
INSERT INTO `access_log` VALUES (40853, '65.47.15610963025388493', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.242.237.192', '2019-06-21 13:51:43', 12, 2001001000, '服务端发生异常', '2019-06-21 13:51:43');
INSERT INTO `access_log` VALUES (40854, '65.45.15610963025428495', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.242.237.192', '2019-06-21 13:51:43', 10, 0, '', '2019-06-21 13:51:43');
INSERT INTO `access_log` VALUES (40855, '59.77.15610963329557557', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:52:13', 13, 0, '', '2019-06-21 13:52:13');
INSERT INTO `access_log` VALUES (40856, '59.75.15610963329547571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:52:13', 21, 2001001000, '服务端发生异常', '2019-06-21 13:52:13');
INSERT INTO `access_log` VALUES (40857, '59.79.15610963418447575', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.91.40.55', '2019-06-21 13:52:22', 8, 0, '', '2019-06-21 13:52:22');
INSERT INTO `access_log` VALUES (40858, '59.71.15610963418397571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '114.91.40.55', '2019-06-21 13:52:22', 19, 2001001000, '服务端发生异常', '2019-06-21 13:52:22');
INSERT INTO `access_log` VALUES (40859, '65.50.15610964178538511', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:53:38', 11, 0, '', '2019-06-21 13:53:38');
INSERT INTO `access_log` VALUES (40860, '65.45.15610964178618497', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:53:38', 9, 0, '', '2019-06-21 13:53:38');
INSERT INTO `access_log` VALUES (40861, '65.47.15610964178608495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:53:38', 11, 2001001000, '服务端发生异常', '2019-06-21 13:53:38');
INSERT INTO `access_log` VALUES (40862, '65.53.15610964224858489', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:53:42', 18, 0, '', '2019-06-21 13:53:43');
INSERT INTO `access_log` VALUES (40863, '65.51.15610964224898537', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:53:42', 17, 0, '', '2019-06-21 13:53:43');
INSERT INTO `access_log` VALUES (40864, '65.46.15610964224988549', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:53:42', 9, 2001001000, '服务端发生异常', '2019-06-21 13:53:43');
INSERT INTO `access_log` VALUES (40865, '59.80.15610964309197561', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:53:51', 3, 0, '', '2019-06-21 13:53:51');
INSERT INTO `access_log` VALUES (40866, '59.72.15610964309217567', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.254.33.45', '2019-06-21 13:53:51', 13, 2001001000, '服务端发生异常', '2019-06-21 13:53:51');
INSERT INTO `access_log` VALUES (40867, '59.71.15610964437507573', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.254.33.45', '2019-06-21 13:54:04', 3, 0, '', '2019-06-21 13:54:04');
INSERT INTO `access_log` VALUES (40868, '59.79.15610964437487577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.254.33.45', '2019-06-21 13:54:04', 14, 2001001000, '服务端发生异常', '2019-06-21 13:54:04');
INSERT INTO `access_log` VALUES (40869, '64.81.15610964473267567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.254.33.45', '2019-06-21 13:54:07', 4, 0, '', '2019-06-21 13:54:07');
INSERT INTO `access_log` VALUES (40870, '64.80.15610964474237571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.254.33.45', '2019-06-21 13:54:07', 1, 0, '', '2019-06-21 13:54:07');
INSERT INTO `access_log` VALUES (40871, '64.78.15610964492227575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.254.33.45', '2019-06-21 13:54:09', 2, 0, '', '2019-06-21 13:54:09');
INSERT INTO `access_log` VALUES (40872, '64.85.15610964497447587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.254.33.45', '2019-06-21 13:54:10', 2, 0, '', '2019-06-21 13:54:10');
INSERT INTO `access_log` VALUES (40873, '64.76.15610964503157557', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.254.33.45', '2019-06-21 13:54:10', 2, 0, '', '2019-06-21 13:54:10');
INSERT INTO `access_log` VALUES (40874, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.254.33.45', '2019-06-21 13:54:10', 6, 0, '', '2019-06-21 13:54:10');
INSERT INTO `access_log` VALUES (40875, '64.83.15610964515147567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.254.33.45', '2019-06-21 13:54:12', 2, 0, '', '2019-06-21 13:54:12');
INSERT INTO `access_log` VALUES (40876, '64.79.15610964516247575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.254.33.45', '2019-06-21 13:54:12', 1, 0, '', '2019-06-21 13:54:12');
INSERT INTO `access_log` VALUES (40877, '66.54.15610964575405857', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '118.254.33.45', '2019-06-21 13:54:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空', '2019-06-21 13:54:18');
INSERT INTO `access_log` VALUES (40878, '64.85.15610966849407591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:05', 10, 0, '', '2019-06-21 13:58:05');
INSERT INTO `access_log` VALUES (40879, '64.83.15610966850677571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:05', 6, 0, '', '2019-06-21 13:58:05');
INSERT INTO `access_log` VALUES (40880, '64.77.15610966883307577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:08', 10, 0, '', '2019-06-21 13:58:08');
INSERT INTO `access_log` VALUES (40881, '64.81.15610966898347573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:10', 9, 0, '', '2019-06-21 13:58:10');
INSERT INTO `access_log` VALUES (40882, '64.80.15610966948747577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:15', 7, 0, '', '2019-06-21 13:58:15');
INSERT INTO `access_log` VALUES (40883, '64.78.15610966954747581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:15', 8, 0, '', '2019-06-21 13:58:15');
INSERT INTO `access_log` VALUES (40884, '66.54.15610966969905863', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:17', 7, 1002001012, '访问令牌已过期', '2019-06-21 13:58:17');
INSERT INTO `access_log` VALUES (40885, '66.48.15610966970995861', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=f109dfb5263041fb9ec6a70128a2bdad', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:17', 200, 0, '', '2019-06-21 13:58:17');
INSERT INTO `access_log` VALUES (40886, '66.57.15610966974105861', 130, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:17', 14, 0, '', '2019-06-21 13:58:17');
INSERT INTO `access_log` VALUES (40887, '66.51.15610967000275871', 130, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:20', 7, 0, '', '2019-06-21 13:58:20');
INSERT INTO `access_log` VALUES (40888, '66.53.15610967022145851', 130, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:22', 6, 0, '', '2019-06-21 13:58:22');
INSERT INTO `access_log` VALUES (40889, '66.49.15610967035865865', 130, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:24', 5, 0, '', '2019-06-21 13:58:24');
INSERT INTO `access_log` VALUES (40890, '66.52.15610967242015861', 130, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:44', 5, 0, '', '2019-06-21 13:58:44');
INSERT INTO `access_log` VALUES (40891, '66.54.15610967260425865', 130, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:46', 6, 0, '', '2019-06-21 13:58:46');
INSERT INTO `access_log` VALUES (40892, '64.84.15610967327687571', 130, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 13:58:53', 6, 1003002003, 'Spu 只能添加在二级分类下', '2019-06-21 13:58:53');
INSERT INTO `access_log` VALUES (40893, '65.45.15610968022968505', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 14:00:02', 1, 1002001015, '账号未登陆', '2019-06-21 14:00:02');
INSERT INTO `access_log` VALUES (40894, '65.46.15610968022968557', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 14:00:02', 1, 1002001015, '账号未登陆', '2019-06-21 14:00:02');
INSERT INTO `access_log` VALUES (40895, '65.53.15610968023138497', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 14:00:02', 0, 1002001015, '账号未登陆', '2019-06-21 14:00:02');
INSERT INTO `access_log` VALUES (40896, '65.49.15610968064978509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 14:00:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 14:00:07');
INSERT INTO `access_log` VALUES (40897, '65.54.15610968122478473', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 14:00:12', 113, 0, '', '2019-06-21 14:00:12');
INSERT INTO `access_log` VALUES (40898, '65.50.15610968126158517', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 14:00:13', 10, 0, '', '2019-06-21 14:00:13');
INSERT INTO `access_log` VALUES (40899, '65.47.15610968126178503', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 14:00:13', 9, 2001001000, '服务端发生异常', '2019-06-21 14:00:13');
INSERT INTO `access_log` VALUES (40900, '65.51.15610968126208547', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 14:00:13', 16, 0, '', '2019-06-21 14:00:13');
INSERT INTO `access_log` VALUES (40901, '65.52.15610968190068513', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 14:00:19', 9, 0, '', '2019-06-21 14:00:19');
INSERT INTO `access_log` VALUES (40902, '65.53.15610968190088499', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 14:00:19', 10, 2001001000, '服务端发生异常', '2019-06-21 14:00:19');
INSERT INTO `access_log` VALUES (40903, '65.46.15610968190128559', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 14:00:19', 9, 0, '', '2019-06-21 14:00:19');
INSERT INTO `access_log` VALUES (40904, '65.45.15610968201838507', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 14:00:20', 9, 0, '', '2019-06-21 14:00:20');
INSERT INTO `access_log` VALUES (40905, '65.49.15610968201888511', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 14:00:20', 9, 2001001000, '服务端发生异常', '2019-06-21 14:00:20');
INSERT INTO `access_log` VALUES (40906, '65.3607.15610968201900277', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.91.40.55', '2019-06-21 14:00:20', 8, 0, '', '2019-06-21 14:00:20');
INSERT INTO `access_log` VALUES (40907, '59.79.15610973283817589', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:08:48', 3, 0, '', '2019-06-21 14:08:48');
INSERT INTO `access_log` VALUES (40908, '59.76.15610973285147579', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:08:49', 19, 2001001000, '服务端发生异常', '2019-06-21 14:08:49');
INSERT INTO `access_log` VALUES (40909, '64.77.15610973384957587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:08:58', 3, 0, '', '2019-06-21 14:08:58');
INSERT INTO `access_log` VALUES (40910, '64.82.15610973386117599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:08:59', 2, 0, '', '2019-06-21 14:08:59');
INSERT INTO `access_log` VALUES (40911, '64.81.15610973403537583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:00', 2, 0, '', '2019-06-21 14:09:00');
INSERT INTO `access_log` VALUES (40912, '64.80.15610973408257587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:01', 2, 0, '', '2019-06-21 14:09:01');
INSERT INTO `access_log` VALUES (40913, '64.78.15610973413107591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:01', 2, 0, '', '2019-06-21 14:09:01');
INSERT INTO `access_log` VALUES (40914, '64.85.15610973415767603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:02', 2, 0, '', '2019-06-21 14:09:02');
INSERT INTO `access_log` VALUES (40915, '64.76.15610973418147573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:02', 2, 0, '', '2019-06-21 14:09:02');
INSERT INTO `access_log` VALUES (40916, '59.74.15610973426307583', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:03', 3, 0, '', '2019-06-21 14:09:03');
INSERT INTO `access_log` VALUES (40917, '59.75.15610973427637587', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:03', 13, 2001001000, '服务端发生异常', '2019-06-21 14:09:03');
INSERT INTO `access_log` VALUES (40918, '64.79.15610973500707591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:10', 1, 0, '', '2019-06-21 14:09:10');
INSERT INTO `access_log` VALUES (40919, '64.84.15610973501787581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:10', 2, 0, '', '2019-06-21 14:09:10');
INSERT INTO `access_log` VALUES (40920, '59.73.15610973523437591', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:12', 2, 0, '', '2019-06-21 14:09:12');
INSERT INTO `access_log` VALUES (40921, '59.80.15610973523437575', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:12', 12, 2001001000, '服务端发生异常', '2019-06-21 14:09:12');
INSERT INTO `access_log` VALUES (40922, '59.71.15610973620517587', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:22', 10, 2001001000, '服务端发生异常', '2019-06-21 14:09:22');
INSERT INTO `access_log` VALUES (40923, '59.79.15610973620597591', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:22', 2, 0, '', '2019-06-21 14:09:22');
INSERT INTO `access_log` VALUES (40924, '65.3607.15610973732620285', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:33', 1, 1002001015, '账号未登陆', '2019-06-21 14:09:33');
INSERT INTO `access_log` VALUES (40925, '65.49.15610973732668519', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:33', 0, 1002001015, '账号未登陆', '2019-06-21 14:09:33');
INSERT INTO `access_log` VALUES (40926, '65.45.15610973732718515', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:33', 0, 1002001015, '账号未登陆', '2019-06-21 14:09:33');
INSERT INTO `access_log` VALUES (40927, '64.81.15610973835457585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:44', 2, 0, '', '2019-06-21 14:09:44');
INSERT INTO `access_log` VALUES (40928, '64.80.15610973836567589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:44', 2, 0, '', '2019-06-21 14:09:44');
INSERT INTO `access_log` VALUES (40929, '64.78.15610973850467593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:45', 2, 0, '', '2019-06-21 14:09:45');
INSERT INTO `access_log` VALUES (40930, '64.85.15610973855107605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:46', 2, 0, '', '2019-06-21 14:09:46');
INSERT INTO `access_log` VALUES (40931, '64.76.15610973860857575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:46', 2, 0, '', '2019-06-21 14:09:46');
INSERT INTO `access_log` VALUES (40932, '59.78.15610973870057585', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:47', 2, 0, '', '2019-06-21 14:09:47');
INSERT INTO `access_log` VALUES (40933, '59.74.15610973870067585', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:47', 13, 2001001000, '服务端发生异常', '2019-06-21 14:09:47');
INSERT INTO `access_log` VALUES (40934, '64.79.15610973928477593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:53', 2, 0, '', '2019-06-21 14:09:53');
INSERT INTO `access_log` VALUES (40935, '64.84.15610973929607583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:09:53', 1, 0, '', '2019-06-21 14:09:53');
INSERT INTO `access_log` VALUES (40936, '65.46.15610974340568569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:10:34', 51, 0, '', '2019-06-21 14:10:34');
INSERT INTO `access_log` VALUES (40937, '65.52.15610974343678523', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:10:34', 18, 0, '', '2019-06-21 14:10:34');
INSERT INTO `access_log` VALUES (40938, '65.53.15610974343728509', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:10:34', 18, 2001001000, '服务端发生异常', '2019-06-21 14:10:34');
INSERT INTO `access_log` VALUES (40939, '65.3607.15610974343740287', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:10:34', 18, 0, '', '2019-06-21 14:10:34');
INSERT INTO `access_log` VALUES (40940, '66.54.15610974525155875', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18526043842', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:10:53', 291, 0, '', '2019-06-21 14:10:53');
INSERT INTO `access_log` VALUES (40941, '66.48.15610974564595873', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18526043842&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:10:56', 187, 0, '', '2019-06-21 14:10:57');
INSERT INTO `access_log` VALUES (40942, '64.85.15610974616757607', 131, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:02', 5, 0, '', '2019-06-21 14:11:02');
INSERT INTO `access_log` VALUES (40943, '64.83.15610974618457587', 131, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:02', 4, 0, '', '2019-06-21 14:11:02');
INSERT INTO `access_log` VALUES (40944, '64.79.15610974634677595', 131, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:03', 5, 0, '', '2019-06-21 14:11:03');
INSERT INTO `access_log` VALUES (40945, '64.84.15610974638307585', 131, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:04', 5, 0, '', '2019-06-21 14:11:04');
INSERT INTO `access_log` VALUES (40946, '66.55.15610974654515863', 131, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:05', 6, 0, '', '2019-06-21 14:11:05');
INSERT INTO `access_log` VALUES (40947, '66.56.15610974668085877', 131, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:07', 6, 0, '', '2019-06-21 14:11:07');
INSERT INTO `access_log` VALUES (40948, '66.49.15610974706535877', 131, 1, 'user-application', '/user-api/users/user/update_nickname', 'nickname=aaa', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:11', 85, 0, '', '2019-06-21 14:11:11');
INSERT INTO `access_log` VALUES (40949, '66.50.15610974752655865', 131, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:15', 6, 0, '', '2019-06-21 14:11:15');
INSERT INTO `access_log` VALUES (40950, '66.52.15610974777445873', 131, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:18', 6, 0, '', '2019-06-21 14:11:18');
INSERT INTO `access_log` VALUES (40951, '59.74.15610974805547587', 131, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:21', 5, 0, '', '2019-06-21 14:11:21');
INSERT INTO `access_log` VALUES (40952, '59.75.15610974805827591', 131, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:21', 12, 2001001000, '服务端发生异常', '2019-06-21 14:11:21');
INSERT INTO `access_log` VALUES (40953, '64.81.15610974821897589', 131, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:22', 4, 0, '', '2019-06-21 14:11:22');
INSERT INTO `access_log` VALUES (40954, '64.80.15610974825417593', 131, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:23', 7, 0, '', '2019-06-21 14:11:23');
INSERT INTO `access_log` VALUES (40955, '64.85.15610974832797609', 131, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:23', 5, 0, '', '2019-06-21 14:11:23');
INSERT INTO `access_log` VALUES (40956, '64.83.15610974838627589', 131, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:24', 5, 0, '', '2019-06-21 14:11:24');
INSERT INTO `access_log` VALUES (40957, '59.77.15610974845537577', 131, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:25', 5, 0, '', '2019-06-21 14:11:25');
INSERT INTO `access_log` VALUES (40958, '59.73.15610974845537595', 131, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:25', 15, 2001001000, '服务端发生异常', '2019-06-21 14:11:25');
INSERT INTO `access_log` VALUES (40959, '65.47.15610974896518515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:30', 9, 0, '', '2019-06-21 14:11:30');
INSERT INTO `access_log` VALUES (40960, '65.50.15610974896538529', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:30', 10, 2001001000, '服务端发生异常', '2019-06-21 14:11:30');
INSERT INTO `access_log` VALUES (40961, '65.46.15610974896578571', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:11:30', 9, 0, '', '2019-06-21 14:11:30');
INSERT INTO `access_log` VALUES (40962, '65.50.15610976220618531', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:13:42', 11, 0, '', '2019-06-21 14:13:42');
INSERT INTO `access_log` VALUES (40963, '65.53.15610976220638513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:13:42', 10, 0, '', '2019-06-21 14:13:42');
INSERT INTO `access_log` VALUES (40964, '65.3607.15610976220620291', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:13:42', 12, 2001001000, '服务端发生异常', '2019-06-21 14:13:42');
INSERT INTO `access_log` VALUES (40965, '65.45.15610976342958521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:13:54', 659, 0, '', '2019-06-21 14:13:55');
INSERT INTO `access_log` VALUES (40966, '65.49.15610976352168525', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:13:55', 9, 0, '', '2019-06-21 14:13:55');
INSERT INTO `access_log` VALUES (40967, '65.51.15610976352198563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:13:55', 9, 0, '', '2019-06-21 14:13:55');
INSERT INTO `access_log` VALUES (40968, '65.54.15610976352188489', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:13:55', 10, 2001001000, '服务端发生异常', '2019-06-21 14:13:55');
INSERT INTO `access_log` VALUES (40969, '64.79.15610991238527619', 131, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:38:44', 6, 0, '', '2019-06-21 14:38:44');
INSERT INTO `access_log` VALUES (40970, '64.77.15610991242497617', 131, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:38:44', 6, 0, '', '2019-06-21 14:38:44');
INSERT INTO `access_log` VALUES (40971, '64.80.15610991252287617', 131, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:38:45', 4, 0, '', '2019-06-21 14:38:45');
INSERT INTO `access_log` VALUES (40972, '64.78.15610991255387621', 131, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.30.240.226', '2019-06-21 14:38:46', 4, 0, '', '2019-06-21 14:38:46');
INSERT INTO `access_log` VALUES (40973, '65.53.15610991909288535', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '101.84.62.129', '2019-06-21 14:39:51', 1, 1002001015, '账号未登陆', '2019-06-21 14:39:51');
INSERT INTO `access_log` VALUES (40974, '65.50.15610991909288553', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '101.84.62.129', '2019-06-21 14:39:51', 0, 1002001015, '账号未登陆', '2019-06-21 14:39:51');
INSERT INTO `access_log` VALUES (40975, '65.52.15610991909318549', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '101.84.62.129', '2019-06-21 14:39:51', 1, 1002001015, '账号未登陆', '2019-06-21 14:39:51');
INSERT INTO `access_log` VALUES (40976, '65.54.15610992116988511', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '101.84.62.129', '2019-06-21 14:40:12', 87, 0, '', '2019-06-21 14:40:12');
INSERT INTO `access_log` VALUES (40977, '65.49.15610992124248547', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '101.84.62.129', '2019-06-21 14:40:12', 10, 0, '', '2019-06-21 14:40:12');
INSERT INTO `access_log` VALUES (40978, '65.46.15610992124318597', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '101.84.62.129', '2019-06-21 14:40:12', 10, 2001001000, '服务端发生异常', '2019-06-21 14:40:12');
INSERT INTO `access_log` VALUES (40979, '65.47.15610992124328541', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '101.84.62.129', '2019-06-21 14:40:12', 9, 0, '', '2019-06-21 14:40:12');
INSERT INTO `access_log` VALUES (40980, '59.73.15610992507467619', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '101.84.62.129', '2019-06-21 14:40:51', 3, 0, '', '2019-06-21 14:40:51');
INSERT INTO `access_log` VALUES (40981, '59.77.15610992507457601', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '101.84.62.129', '2019-06-21 14:40:51', 12, 2001001000, '服务端发生异常', '2019-06-21 14:40:51');
INSERT INTO `access_log` VALUES (40982, '65.45.15610992801358545', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:41:20', 0, 1002001015, '账号未登陆', '2019-06-21 14:41:20');
INSERT INTO `access_log` VALUES (40983, '65.51.15610992801418587', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:41:20', 1, 1002001015, '账号未登陆', '2019-06-21 14:41:20');
INSERT INTO `access_log` VALUES (40984, '65.54.15610992801488513', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:41:20', 0, 1002001015, '账号未登陆', '2019-06-21 14:41:20');
INSERT INTO `access_log` VALUES (40985, '65.46.15610992937038599', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:41:34', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 14:41:34');
INSERT INTO `access_log` VALUES (40986, '65.3607.15610992992530317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:41:39', 72, 0, '', '2019-06-21 14:41:39');
INSERT INTO `access_log` VALUES (40987, '65.50.15610992996288557', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:41:40', 9, 0, '', '2019-06-21 14:41:40');
INSERT INTO `access_log` VALUES (40988, '65.53.15610992996468539', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:41:40', 9, 0, '', '2019-06-21 14:41:40');
INSERT INTO `access_log` VALUES (40989, '65.52.15610992996468553', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:41:40', 10, 2001001000, '服务端发生异常', '2019-06-21 14:41:40');
INSERT INTO `access_log` VALUES (40990, '65.49.15610993481388551', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:28', 10, 0, '', '2019-06-21 14:42:28');
INSERT INTO `access_log` VALUES (40991, '65.46.15610993481408601', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:28', 10, 2001001000, '服务端发生异常', '2019-06-21 14:42:28');
INSERT INTO `access_log` VALUES (40992, '65.47.15610993481428545', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:28', 9, 0, '', '2019-06-21 14:42:28');
INSERT INTO `access_log` VALUES (40993, '59.75.15610993590857617', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:39', 3, 0, '', '2019-06-21 14:42:39');
INSERT INTO `access_log` VALUES (40994, '59.73.15610993590877621', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:39', 10, 2001001000, '服务端发生异常', '2019-06-21 14:42:39');
INSERT INTO `access_log` VALUES (40995, '64.82.15610993646017633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:45', 2, 0, '', '2019-06-21 14:42:45');
INSERT INTO `access_log` VALUES (40996, '64.81.15610993647017617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:45', 2, 0, '', '2019-06-21 14:42:45');
INSERT INTO `access_log` VALUES (40997, '64.80.15610993659487621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:46', 2, 0, '', '2019-06-21 14:42:46');
INSERT INTO `access_log` VALUES (40998, '64.78.15610993664367625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:46', 2, 0, '', '2019-06-21 14:42:46');
INSERT INTO `access_log` VALUES (40999, '64.85.15610993670437637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:47', 9, 0, '', '2019-06-21 14:42:47');
INSERT INTO `access_log` VALUES (41000, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:48', 7, 0, '', '2019-06-21 14:42:48');
INSERT INTO `access_log` VALUES (41001, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:48', 11, 0, '', '2019-06-21 14:42:48');
INSERT INTO `access_log` VALUES (41002, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:48', 23, 0, '', '2019-06-21 14:42:48');
INSERT INTO `access_log` VALUES (41003, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:48', 252, 0, '', '2019-06-21 14:42:48');
INSERT INTO `access_log` VALUES (41004, '64.83.15610993709427617', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:42:51', 7, 0, '', '2019-06-21 14:42:51');
INSERT INTO `access_log` VALUES (41005, '66.50.15610993909465891', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18105822099&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:43:11', 16, 1001003000, '验证码不存在', '2019-06-21 14:43:11');
INSERT INTO `access_log` VALUES (41006, '66.52.15610993978495899', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18105822099', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:43:18', 76, 0, '', '2019-06-21 14:43:18');
INSERT INTO `access_log` VALUES (41007, '66.54.15610994004925903', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18105822099&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:43:20', 213, 0, '', '2019-06-21 14:43:21');
INSERT INTO `access_log` VALUES (41008, '66.55.15610994020675891', 132, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:43:22', 6, 0, '', '2019-06-21 14:43:22');
INSERT INTO `access_log` VALUES (41009, '66.56.15610994052685905', 132, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:43:25', 5, 0, '', '2019-06-21 14:43:25');
INSERT INTO `access_log` VALUES (41010, '66.50.15610994185205893', 132, 1, 'user-application', '/user-api/users/address/add', 'name=12&tel=18105822099&country=&province=北京市&city=北京市&county=西城区&areaCode=110102&postalCode=&addressDetail=12121&isDefault=true&address=12121&areaNo=110102&mobile=18105822099&hasDefault=2', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:43:39', 92, 2001001000, '服务端发生异常', '2019-06-21 14:43:39');
INSERT INTO `access_log` VALUES (41011, '66.52.15610994205845901', 132, 1, 'user-application', '/user-api/users/address/add', 'name=12&tel=18105822099&country=&province=北京市&city=北京市&county=西城区&areaCode=110102&postalCode=&addressDetail=12121&isDefault=true&address=12121&areaNo=110102&mobile=18105822099&hasDefault=2', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:43:41', 197, 2001001000, '服务端发生异常', '2019-06-21 14:43:41');
INSERT INTO `access_log` VALUES (41012, '66.48.15610994226725903', 132, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:43:43', 6, 0, '', '2019-06-21 14:43:43');
INSERT INTO `access_log` VALUES (41013, '65.52.15610999709808563', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 14:52:51', 0, 1002001015, '账号未登陆', '2019-06-21 14:52:51');
INSERT INTO `access_log` VALUES (41014, '65.50.15610999709808567', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 14:52:51', 0, 1002001015, '账号未登陆', '2019-06-21 14:52:51');
INSERT INTO `access_log` VALUES (41015, '65.53.15610999709908549', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 14:52:51', 0, 1002001015, '账号未登陆', '2019-06-21 14:52:51');
INSERT INTO `access_log` VALUES (41016, '65.51.15610999730858599', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 14:52:53', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 14:52:53');
INSERT INTO `access_log` VALUES (41017, '65.46.15610999952338611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=youdaoyuanma&password=youdaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 14:53:15', 4, 1002002000, '账号不存在', '2019-06-21 14:53:15');
INSERT INTO `access_log` VALUES (41018, '65.3607.15611000198960329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 14:53:40', 94, 0, '', '2019-06-21 14:53:40');
INSERT INTO `access_log` VALUES (41019, '65.52.15611000202648565', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 14:53:40', 10, 0, '', '2019-06-21 14:53:40');
INSERT INTO `access_log` VALUES (41020, '65.53.15611000202708551', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 14:53:40', 10, 2001001000, '服务端发生异常', '2019-06-21 14:53:40');
INSERT INTO `access_log` VALUES (41021, '65.50.15611000202788569', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 14:53:40', 9, 0, '', '2019-06-21 14:53:40');
INSERT INTO `access_log` VALUES (41022, '65.54.15611000496398527', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 14:54:10', 8, 0, '', '2019-06-21 14:54:10');
INSERT INTO `access_log` VALUES (41023, '65.46.15611000496448613', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 14:54:10', 13, 2001001000, '服务端发生异常', '2019-06-21 14:54:10');
INSERT INTO `access_log` VALUES (41024, '65.49.15611000496478563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 14:54:10', 14, 0, '', '2019-06-21 14:54:10');
INSERT INTO `access_log` VALUES (41025, '65.52.15611004206538571', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '223.72.88.164', '2019-06-21 15:00:21', 1, 1002001015, '账号未登陆', '2019-06-21 15:00:21');
INSERT INTO `access_log` VALUES (41026, '65.51.15611004206548607', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '223.72.88.164', '2019-06-21 15:00:21', 0, 1002001015, '账号未登陆', '2019-06-21 15:00:21');
INSERT INTO `access_log` VALUES (41027, '65.45.15611004206598565', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '223.72.88.164', '2019-06-21 15:00:21', 0, 1002001015, '账号未登陆', '2019-06-21 15:00:21');
INSERT INTO `access_log` VALUES (41028, '65.52.15611006710358575', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:04:31', 0, 1002001015, '账号未登陆', '2019-06-21 15:04:31');
INSERT INTO `access_log` VALUES (41029, '65.45.15611006710368569', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:04:31', 0, 1002001015, '账号未登陆', '2019-06-21 15:04:31');
INSERT INTO `access_log` VALUES (41030, '65.51.15611006710378611', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:04:31', 1, 1002001015, '账号未登陆', '2019-06-21 15:04:31');
INSERT INTO `access_log` VALUES (41031, '65.46.15611006735988623', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:04:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 15:04:34');
INSERT INTO `access_log` VALUES (41032, '65.54.15611006758108537', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:04:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 15:04:36');
INSERT INTO `access_log` VALUES (41033, '65.47.15611006846618567', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:04:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 15:04:45');
INSERT INTO `access_log` VALUES (41034, '65.53.15611007003508563', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:05:00', 113, 0, '', '2019-06-21 15:05:00');
INSERT INTO `access_log` VALUES (41035, '65.50.15611007008288581', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:05:01', 11, 0, '', '2019-06-21 15:05:01');
INSERT INTO `access_log` VALUES (41036, '65.51.15611007008288613', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:05:01', 12, 2001001000, '服务端发生异常', '2019-06-21 15:05:01');
INSERT INTO `access_log` VALUES (41037, '65.45.15611007008328571', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:05:01', 8, 0, '', '2019-06-21 15:05:01');
INSERT INTO `access_log` VALUES (41038, '65.46.15611007106128625', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:05:11', 10, 0, '', '2019-06-21 15:05:11');
INSERT INTO `access_log` VALUES (41039, '65.54.15611007106148539', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:05:11', 10, 2001001000, '服务端发生异常', '2019-06-21 15:05:11');
INSERT INTO `access_log` VALUES (41040, '65.49.15611007106178575', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:05:11', 17, 0, '', '2019-06-21 15:05:11');
INSERT INTO `access_log` VALUES (41041, '59.74.15611009708217635', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:09:31', 4, 0, '', '2019-06-21 15:09:31');
INSERT INTO `access_log` VALUES (41042, '59.75.15611009708227639', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '157.61.161.50', '2019-06-21 15:09:31', 20, 2001001000, '服务端发生异常', '2019-06-21 15:09:31');
INSERT INTO `access_log` VALUES (41043, '64.85.15611009790227659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:09:39', 2, 0, '', '2019-06-21 15:09:39');
INSERT INTO `access_log` VALUES (41044, '64.76.15611009791787629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:09:39', 2, 0, '', '2019-06-21 15:09:39');
INSERT INTO `access_log` VALUES (41045, '64.83.15611009831437639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:09:43', 2, 0, '', '2019-06-21 15:09:43');
INSERT INTO `access_log` VALUES (41046, '64.79.15611009833147647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:09:43', 2, 0, '', '2019-06-21 15:09:43');
INSERT INTO `access_log` VALUES (41047, '59.77.15611009858277625', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:09:46', 2, 0, '', '2019-06-21 15:09:46');
INSERT INTO `access_log` VALUES (41048, '59.80.15611009858277627', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:09:46', 19, 2001001000, '服务端发生异常', '2019-06-21 15:09:46');
INSERT INTO `access_log` VALUES (41049, '64.84.15611009892417637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:09:49', 2, 0, '', '2019-06-21 15:09:49');
INSERT INTO `access_log` VALUES (41050, '64.77.15611009894887645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:09:49', 2, 0, '', '2019-06-21 15:09:49');
INSERT INTO `access_log` VALUES (41051, '64.81.15611009905297641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:09:51', 2, 0, '', '2019-06-21 15:09:51');
INSERT INTO `access_log` VALUES (41052, '64.80.15611009916677645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:09:52', 2, 0, '', '2019-06-21 15:09:52');
INSERT INTO `access_log` VALUES (41053, '64.78.15611009929167649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:09:53', 2, 0, '', '2019-06-21 15:09:53');
INSERT INTO `access_log` VALUES (41054, '64.85.15611009935407661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:09:54', 2, 0, '', '2019-06-21 15:09:54');
INSERT INTO `access_log` VALUES (41055, '59.76.15611010185267633', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:10:19', 2, 0, '', '2019-06-21 15:10:19');
INSERT INTO `access_log` VALUES (41056, '59.71.15611010185267639', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:10:19', 23, 2001001000, '服务端发生异常', '2019-06-21 15:10:19');
INSERT INTO `access_log` VALUES (41057, '64.83.15611010194267641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:10:19', 2, 0, '', '2019-06-21 15:10:19');
INSERT INTO `access_log` VALUES (41058, '64.79.15611010195927649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:10:20', 2, 0, '', '2019-06-21 15:10:20');
INSERT INTO `access_log` VALUES (41059, '59.74.15611010204267637', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:10:20', 2, 0, '', '2019-06-21 15:10:20');
INSERT INTO `access_log` VALUES (41060, '59.75.15611010204277641', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '157.61.161.50', '2019-06-21 15:10:20', 19, 2001001000, '服务端发生异常', '2019-06-21 15:10:20');
INSERT INTO `access_log` VALUES (41061, '65.54.15611013641948547', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '223.72.88.164', '2019-06-21 15:16:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 15:16:04');
INSERT INTO `access_log` VALUES (41062, '65.3607.15611013911440355', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanman&password=yudaoyuanman&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '223.72.88.164', '2019-06-21 15:16:31', 5, 1002002000, '账号不存在', '2019-06-21 15:16:31');
INSERT INTO `access_log` VALUES (41063, '65.51.15611014016328623', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanman&password=yudaoyuanman&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '223.72.88.164', '2019-06-21 15:16:42', 4, 1002002000, '账号不存在', '2019-06-21 15:16:42');
INSERT INTO `access_log` VALUES (41064, '65.50.15611014194138593', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '223.72.88.164', '2019-06-21 15:16:59', 87, 0, '', '2019-06-21 15:17:00');
INSERT INTO `access_log` VALUES (41065, '65.52.15611014198448587', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '223.72.88.164', '2019-06-21 15:17:00', 18, 0, '', '2019-06-21 15:17:00');
INSERT INTO `access_log` VALUES (41066, '65.49.15611014198478585', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '223.72.88.164', '2019-06-21 15:17:00', 20, 2001001000, '服务端发生异常', '2019-06-21 15:17:00');
INSERT INTO `access_log` VALUES (41067, '65.54.15611014198948549', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '223.72.88.164', '2019-06-21 15:17:00', 11, 0, '', '2019-06-21 15:17:00');
INSERT INTO `access_log` VALUES (41068, '65.47.15611014297238581', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '223.72.88.164', '2019-06-21 15:17:10', 8, 0, '', '2019-06-21 15:17:10');
INSERT INTO `access_log` VALUES (41069, '65.3607.15611014297250357', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '223.72.88.164', '2019-06-21 15:17:10', 11, 2001001000, '服务端发生异常', '2019-06-21 15:17:10');
INSERT INTO `access_log` VALUES (41070, '65.53.15611014297298577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '223.72.88.164', '2019-06-21 15:17:10', 8, 0, '', '2019-06-21 15:17:10');
INSERT INTO `access_log` VALUES (41071, '65.54.15611018102568555', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 15:23:30', 11, 0, '', '2019-06-21 15:23:30');
INSERT INTO `access_log` VALUES (41072, '65.46.15611018102578641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 15:23:30', 11, 2001001000, '服务端发生异常', '2019-06-21 15:23:30');
INSERT INTO `access_log` VALUES (41073, '65.3607.15611018102620363', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 15:23:30', 9, 0, '', '2019-06-21 15:23:30');
INSERT INTO `access_log` VALUES (41074, '65.50.15611018724658601', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 15:24:32', 9, 0, '', '2019-06-21 15:24:32');
INSERT INTO `access_log` VALUES (41075, '65.52.15611018724778595', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 15:24:32', 10, 2001001000, '服务端发生异常', '2019-06-21 15:24:32');
INSERT INTO `access_log` VALUES (41076, '65.49.15611018724848593', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.24.26', '2019-06-21 15:24:32', 8, 0, '', '2019-06-21 15:24:32');
INSERT INTO `access_log` VALUES (41077, '65.3607.15611020491570367', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.236.48.202', '2019-06-21 15:27:29', 1, 1002001015, '账号未登陆', '2019-06-21 15:27:29');
INSERT INTO `access_log` VALUES (41078, '65.53.15611020491598587', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.236.48.202', '2019-06-21 15:27:29', 0, 1002001015, '账号未登陆', '2019-06-21 15:27:29');
INSERT INTO `access_log` VALUES (41079, '65.47.15611020491698591', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.236.48.202', '2019-06-21 15:27:29', 0, 1002001015, '账号未登陆', '2019-06-21 15:27:29');
INSERT INTO `access_log` VALUES (41080, '65.51.15611020517248635', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.236.48.202', '2019-06-21 15:27:32', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 15:27:32');
INSERT INTO `access_log` VALUES (41081, '65.45.15611020575348593', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.236.48.202', '2019-06-21 15:27:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 15:27:38');
INSERT INTO `access_log` VALUES (41082, '65.49.15611020829498597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.236.48.202', '2019-06-21 15:28:03', 90, 0, '', '2019-06-21 15:28:03');
INSERT INTO `access_log` VALUES (41083, '65.46.15611020834858647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.236.48.202', '2019-06-21 15:28:03', 9, 0, '', '2019-06-21 15:28:03');
INSERT INTO `access_log` VALUES (41084, '65.54.15611020834918561', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.236.48.202', '2019-06-21 15:28:03', 10, 2001001000, '服务端发生异常', '2019-06-21 15:28:04');
INSERT INTO `access_log` VALUES (41085, '65.3607.15611020835070369', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.236.48.202', '2019-06-21 15:28:04', 9, 0, '', '2019-06-21 15:28:04');
INSERT INTO `access_log` VALUES (41086, '65.53.15611020949648589', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.236.48.202', '2019-06-21 15:28:15', 9, 0, '', '2019-06-21 15:28:15');
INSERT INTO `access_log` VALUES (41087, '65.51.15611020949698637', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.236.48.202', '2019-06-21 15:28:15', 10, 2001001000, '服务端发生异常', '2019-06-21 15:28:15');
INSERT INTO `access_log` VALUES (41088, '65.45.15611020949728595', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.236.48.202', '2019-06-21 15:28:15', 9, 0, '', '2019-06-21 15:28:15');
INSERT INTO `access_log` VALUES (41089, '59.72.15611022767087651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.156.119.127', '2019-06-21 15:31:17', 3, 0, '', '2019-06-21 15:31:17');
INSERT INTO `access_log` VALUES (41090, '59.79.15611022767857661', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '61.156.119.127', '2019-06-21 15:31:17', 23, 2001001000, '服务端发生异常', '2019-06-21 15:31:17');
INSERT INTO `access_log` VALUES (41091, '59.71.15611022822707657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '61.156.119.127', '2019-06-21 15:31:22', 3, 0, '', '2019-06-21 15:31:22');
INSERT INTO `access_log` VALUES (41092, '59.78.15611022822717655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '61.156.119.127', '2019-06-21 15:31:22', 18, 2001001000, '服务端发生异常', '2019-06-21 15:31:22');
INSERT INTO `access_log` VALUES (41093, '59.75.15611022904427659', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '61.156.119.127', '2019-06-21 15:31:30', 2, 0, '', '2019-06-21 15:31:30');
INSERT INTO `access_log` VALUES (41094, '59.74.15611022904447655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '61.156.119.127', '2019-06-21 15:31:30', 15, 2001001000, '服务端发生异常', '2019-06-21 15:31:30');
INSERT INTO `access_log` VALUES (41095, '65.47.15611026403628603', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.64.146.36', '2019-06-21 15:37:20', 0, 1002001015, '账号未登陆', '2019-06-21 15:37:20');
INSERT INTO `access_log` VALUES (41096, '65.52.15611026403628611', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.64.146.36', '2019-06-21 15:37:20', 1, 1002001015, '账号未登陆', '2019-06-21 15:37:20');
INSERT INTO `access_log` VALUES (41097, '65.51.15611026403658647', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.64.146.36', '2019-06-21 15:37:20', 1, 1002001015, '账号未登陆', '2019-06-21 15:37:20');
INSERT INTO `access_log` VALUES (41098, '65.53.15611026422568597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.64.146.36', '2019-06-21 15:37:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 15:37:22');
INSERT INTO `access_log` VALUES (41099, '65.50.15611026436568615', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.64.146.36', '2019-06-21 15:37:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 15:37:24');
INSERT INTO `access_log` VALUES (41100, '65.3607.15611026488730377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.64.146.36', '2019-06-21 15:37:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 15:37:29');
INSERT INTO `access_log` VALUES (41101, '65.49.15611026615928607', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.64.146.36', '2019-06-21 15:37:42', 70, 0, '', '2019-06-21 15:37:42');
INSERT INTO `access_log` VALUES (41102, '65.54.15611026618618571', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.64.146.36', '2019-06-21 15:37:42', 10, 0, '', '2019-06-21 15:37:42');
INSERT INTO `access_log` VALUES (41103, '65.52.15611026618618613', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.64.146.36', '2019-06-21 15:37:42', 10, 2001001000, '服务端发生异常', '2019-06-21 15:37:42');
INSERT INTO `access_log` VALUES (41104, '65.51.15611026618658649', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.64.146.36', '2019-06-21 15:37:42', 9, 0, '', '2019-06-21 15:37:42');
INSERT INTO `access_log` VALUES (41105, '64.78.15611027317677673', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '61.156.119.127', '2019-06-21 15:38:52', 3, 0, '', '2019-06-21 15:38:52');
INSERT INTO `access_log` VALUES (41106, '64.85.15611027319937685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '61.156.119.127', '2019-06-21 15:38:52', 2, 0, '', '2019-06-21 15:38:52');
INSERT INTO `access_log` VALUES (41107, '66.57.15611027432565947', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18669418671', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '61.156.119.127', '2019-06-21 15:39:03', 106, 0, '', '2019-06-21 15:39:03');
INSERT INTO `access_log` VALUES (41108, '66.55.15611027449425937', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18669418671&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '61.156.119.127', '2019-06-21 15:39:05', 164, 0, '', '2019-06-21 15:39:05');
INSERT INTO `access_log` VALUES (41109, '59.77.15611027640477651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:39:24', 3, 0, '', '2019-06-21 15:39:24');
INSERT INTO `access_log` VALUES (41110, '59.72.15611027640477659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:39:24', 15, 2001001000, '服务端发生异常', '2019-06-21 15:39:24');
INSERT INTO `access_log` VALUES (41111, '64.79.15611027699407673', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:39:30', 2, 0, '', '2019-06-21 15:39:30');
INSERT INTO `access_log` VALUES (41112, '64.84.15611027700237663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:39:30', 2, 0, '', '2019-06-21 15:39:30');
INSERT INTO `access_log` VALUES (41113, '64.77.15611027714557671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:39:31', 2, 0, '', '2019-06-21 15:39:31');
INSERT INTO `access_log` VALUES (41114, '64.82.15611027719657683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:39:32', 2, 0, '', '2019-06-21 15:39:32');
INSERT INTO `access_log` VALUES (41115, '66.53.15611027721425937', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18669418671&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '61.156.119.127', '2019-06-21 15:39:32', 7, 1001003002, '验证码已使用', '2019-06-21 15:39:32');
INSERT INTO `access_log` VALUES (41116, '64.81.15611027727297667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:39:33', 2, 0, '', '2019-06-21 15:39:33');
INSERT INTO `access_log` VALUES (41117, '66.49.15611027741505951', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18669418671&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '61.156.119.127', '2019-06-21 15:39:34', 8, 1001003002, '验证码已使用', '2019-06-21 15:39:34');
INSERT INTO `access_log` VALUES (41118, '65.51.15611029022548653', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:41:42', 0, 1002001015, '账号未登陆', '2019-06-21 15:41:42');
INSERT INTO `access_log` VALUES (41119, '65.49.15611029022538611', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:41:42', 0, 1002001015, '账号未登陆', '2019-06-21 15:41:42');
INSERT INTO `access_log` VALUES (41120, '65.52.15611029022548617', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:41:42', 0, 1002001015, '账号未登陆', '2019-06-21 15:41:42');
INSERT INTO `access_log` VALUES (41121, '65.54.15611029039308575', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:41:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 15:41:44');
INSERT INTO `access_log` VALUES (41122, '65.47.15611029092578609', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai3333&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:41:49', 105, 0, '', '2019-06-21 15:41:49');
INSERT INTO `access_log` VALUES (41123, '65.53.15611029102658603', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:41:50', 10, 0, '', '2019-06-21 15:41:50');
INSERT INTO `access_log` VALUES (41124, '65.50.15611029102708621', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:41:50', 9, 0, '', '2019-06-21 15:41:50');
INSERT INTO `access_log` VALUES (41125, '65.46.15611029102728663', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:41:50', 9, 0, '', '2019-06-21 15:41:50');
INSERT INTO `access_log` VALUES (41126, '62.85.15611029136507269', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:41:54', 54, 0, '', '2019-06-21 15:41:54');
INSERT INTO `access_log` VALUES (41127, '65.45.15611029161088611', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:41:56', 18, 0, '', '2019-06-21 15:41:56');
INSERT INTO `access_log` VALUES (41128, '59.79.15611029208447671', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:42:01', 17, 0, '', '2019-06-21 15:42:01');
INSERT INTO `access_log` VALUES (41129, '59.71.15611029251287667', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:42:05', 22, 2001001000, '服务端发生异常', '2019-06-21 15:42:05');
INSERT INTO `access_log` VALUES (41130, '62.84.15611029346287261', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:42:15', 16, 0, '', '2019-06-21 15:42:15');
INSERT INTO `access_log` VALUES (41131, '62.89.15611029492027291', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:42:29', 193, 0, '', '2019-06-21 15:42:29');
INSERT INTO `access_log` VALUES (41132, '62.88.15611029557837275', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=20', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:42:36', 14, 0, '', '2019-06-21 15:42:36');
INSERT INTO `access_log` VALUES (41133, '64.83.15611029777287669', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.95.175.62', '2019-06-21 15:42:58', 10, 0, '', '2019-06-21 15:42:58');
INSERT INTO `access_log` VALUES (41134, '59.72.15611031493647665', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:45:49', 3, 0, '', '2019-06-21 15:45:49');
INSERT INTO `access_log` VALUES (41135, '59.77.15611031493637657', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:45:49', 16, 2001001000, '服务端发生异常', '2019-06-21 15:45:49');
INSERT INTO `access_log` VALUES (41136, '64.77.15611031518357677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:45:52', 2, 0, '', '2019-06-21 15:45:52');
INSERT INTO `access_log` VALUES (41137, '64.82.15611031520467689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:45:52', 2, 0, '', '2019-06-21 15:45:52');
INSERT INTO `access_log` VALUES (41138, '64.81.15611031530587673', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:45:53', 2, 0, '', '2019-06-21 15:45:53');
INSERT INTO `access_log` VALUES (41139, '64.80.15611031537267677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:45:54', 1, 0, '', '2019-06-21 15:45:54');
INSERT INTO `access_log` VALUES (41140, '59.79.15611031548327675', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:45:55', 2, 0, '', '2019-06-21 15:45:55');
INSERT INTO `access_log` VALUES (41141, '59.76.15611031548327665', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:45:55', 13, 2001001000, '服务端发生异常', '2019-06-21 15:45:55');
INSERT INTO `access_log` VALUES (41142, '64.78.15611031570277681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:45:57', 2, 0, '', '2019-06-21 15:45:57');
INSERT INTO `access_log` VALUES (41143, '64.85.15611031571937693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:45:57', 2, 0, '', '2019-06-21 15:45:57');
INSERT INTO `access_log` VALUES (41144, '64.76.15611031581047663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:45:58', 2, 0, '', '2019-06-21 15:45:58');
INSERT INTO `access_log` VALUES (41145, '64.83.15611031584267673', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:45:58', 2, 0, '', '2019-06-21 15:45:58');
INSERT INTO `access_log` VALUES (41146, '59.71.15611031587947671', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:45:59', 3, 0, '', '2019-06-21 15:45:59');
INSERT INTO `access_log` VALUES (41147, '59.78.15611031588697669', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:45:59', 13, 2001001000, '服务端发生异常', '2019-06-21 15:45:59');
INSERT INTO `access_log` VALUES (41148, '64.79.15611031603887681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:46:00', 2, 0, '', '2019-06-21 15:46:00');
INSERT INTO `access_log` VALUES (41149, '64.84.15611031606317671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:46:01', 1, 0, '', '2019-06-21 15:46:01');
INSERT INTO `access_log` VALUES (41150, '59.74.15611031610417669', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:46:01', 3, 0, '', '2019-06-21 15:46:01');
INSERT INTO `access_log` VALUES (41151, '59.75.15611031610497673', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.104.64.205', '2019-06-21 15:46:01', 14, 2001001000, '服务端发生异常', '2019-06-21 15:46:01');
INSERT INTO `access_log` VALUES (41152, '59.72.15611040690727679', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '223.73.35.100', '2019-06-21 16:01:09', 3, 0, '', '2019-06-21 16:01:09');
INSERT INTO `access_log` VALUES (41153, '59.80.15611040690717673', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '223.73.35.100', '2019-06-21 16:01:09', 13, 2001001000, '服务端发生异常', '2019-06-21 16:01:09');
INSERT INTO `access_log` VALUES (41154, '59.76.15611040781217679', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '223.73.35.100', '2019-06-21 16:01:18', 2, 0, '', '2019-06-21 16:01:18');
INSERT INTO `access_log` VALUES (41155, '59.77.15611040781217671', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '223.73.35.100', '2019-06-21 16:01:18', 18, 2001001000, '服务端发生异常', '2019-06-21 16:01:18');
INSERT INTO `access_log` VALUES (41156, '59.77.15611045091407677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.10.33', '2019-06-21 16:08:29', 2, 0, '', '2019-06-21 16:08:29');
INSERT INTO `access_log` VALUES (41157, '59.79.15611045091417695', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.10.33', '2019-06-21 16:08:29', 9, 2001001000, '服务端发生异常', '2019-06-21 16:08:29');
INSERT INTO `access_log` VALUES (41158, '64.77.15611045136937697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.10.33', '2019-06-21 16:08:34', 3, 0, '', '2019-06-21 16:08:34');
INSERT INTO `access_log` VALUES (41159, '64.82.15611045138577709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.10.33', '2019-06-21 16:08:34', 1, 0, '', '2019-06-21 16:08:34');
INSERT INTO `access_log` VALUES (41160, '64.85.15611066474947741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.10.33', '2019-06-21 16:44:07', 12, 0, '', '2019-06-21 16:44:08');
INSERT INTO `access_log` VALUES (41161, '64.76.15611066476797711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.10.33', '2019-06-21 16:44:08', 3, 0, '', '2019-06-21 16:44:08');
INSERT INTO `access_log` VALUES (41162, '59.74.15611066491577717', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.10.33', '2019-06-21 16:44:09', 11, 0, '', '2019-06-21 16:44:09');
INSERT INTO `access_log` VALUES (41163, '59.73.15611066492177725', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '36.102.10.33', '2019-06-21 16:44:09', 13, 2001001000, '服务端发生异常', '2019-06-21 16:44:09');
INSERT INTO `access_log` VALUES (41164, '59.79.15611077449747739', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.76.8.29', '2019-06-21 17:02:25', 4, 0, '', '2019-06-21 17:02:25');
INSERT INTO `access_log` VALUES (41165, '59.77.15611077449747721', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.76.8.29', '2019-06-21 17:02:25', 13, 2001001000, '服务端发生异常', '2019-06-21 17:02:25');
INSERT INTO `access_log` VALUES (41166, '64.77.15611077511547741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.76.8.29', '2019-06-21 17:02:31', 2, 0, '', '2019-06-21 17:02:31');
INSERT INTO `access_log` VALUES (41167, '64.82.15611077512777753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.76.8.29', '2019-06-21 17:02:31', 2, 0, '', '2019-06-21 17:02:31');
INSERT INTO `access_log` VALUES (41168, '64.81.15611077525257737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.76.8.29', '2019-06-21 17:02:33', 2, 0, '', '2019-06-21 17:02:33');
INSERT INTO `access_log` VALUES (41169, '64.80.15611077531827741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.76.8.29', '2019-06-21 17:02:33', 1, 0, '', '2019-06-21 17:02:33');
INSERT INTO `access_log` VALUES (41170, '64.78.15611077537677745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.76.8.29', '2019-06-21 17:02:34', 2, 0, '', '2019-06-21 17:02:34');
INSERT INTO `access_log` VALUES (41171, '64.85.15611077542677757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.76.8.29', '2019-06-21 17:02:34', 2, 0, '', '2019-06-21 17:02:34');
INSERT INTO `access_log` VALUES (41172, '65.50.15611077621968687', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.76.8.29', '2019-06-21 17:02:42', 0, 1002001015, '账号未登陆', '2019-06-21 17:02:42');
INSERT INTO `access_log` VALUES (41173, '65.3607.15611077621960449', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.76.8.29', '2019-06-21 17:02:42', 0, 1002001015, '账号未登陆', '2019-06-21 17:02:42');
INSERT INTO `access_log` VALUES (41174, '65.45.15611077622198677', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.76.8.29', '2019-06-21 17:02:42', 1, 1002001015, '账号未登陆', '2019-06-21 17:02:42');
INSERT INTO `access_log` VALUES (41175, '65.52.15611077646728685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.76.8.29', '2019-06-21 17:02:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 17:02:45');
INSERT INTO `access_log` VALUES (41176, '65.49.15611077748438677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.76.8.29', '2019-06-21 17:02:55', 52, 0, '', '2019-06-21 17:02:55');
INSERT INTO `access_log` VALUES (41177, '65.54.15611077821368641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.76.8.29', '2019-06-21 17:03:02', 59, 0, '', '2019-06-21 17:03:02');
INSERT INTO `access_log` VALUES (41178, '59.80.15611084409867733', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.43.82', '2019-06-21 17:14:01', 3, 0, '', '2019-06-21 17:14:01');
INSERT INTO `access_log` VALUES (41179, '59.76.15611084409867739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.43.82', '2019-06-21 17:14:01', 18, 2001001000, '服务端发生异常', '2019-06-21 17:14:01');
INSERT INTO `access_log` VALUES (41180, '64.80.15611084472037751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.43.82', '2019-06-21 17:14:07', 3, 0, '', '2019-06-21 17:14:07');
INSERT INTO `access_log` VALUES (41181, '64.78.15611084473087755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.43.82', '2019-06-21 17:14:07', 1, 0, '', '2019-06-21 17:14:07');
INSERT INTO `access_log` VALUES (41182, '64.85.15611084568077767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.43.82', '2019-06-21 17:14:17', 1, 0, '', '2019-06-21 17:14:17');
INSERT INTO `access_log` VALUES (41183, '64.76.15611084569107737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.43.82', '2019-06-21 17:14:17', 2, 0, '', '2019-06-21 17:14:17');
INSERT INTO `access_log` VALUES (41184, '64.83.15611084603127747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.43.82', '2019-06-21 17:14:20', 2, 0, '', '2019-06-21 17:14:20');
INSERT INTO `access_log` VALUES (41185, '64.79.15611084604307755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.43.82', '2019-06-21 17:14:20', 2, 0, '', '2019-06-21 17:14:20');
INSERT INTO `access_log` VALUES (41186, '59.71.15611087600497749', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:20', 3, 0, '', '2019-06-21 17:19:20');
INSERT INTO `access_log` VALUES (41187, '59.78.15611087600507747', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:20', 10, 2001001000, '服务端发生异常', '2019-06-21 17:19:20');
INSERT INTO `access_log` VALUES (41188, '64.79.15611087681657761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:28', 3, 0, '', '2019-06-21 17:19:28');
INSERT INTO `access_log` VALUES (41189, '64.77.15611087682667757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:28', 2, 0, '', '2019-06-21 17:19:28');
INSERT INTO `access_log` VALUES (41190, '64.83.15611087722007751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:32', 2, 0, '', '2019-06-21 17:19:32');
INSERT INTO `access_log` VALUES (41191, '64.82.15611087733507771', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:33', 2, 0, '', '2019-06-21 17:19:33');
INSERT INTO `access_log` VALUES (41192, '64.80.15611087790457759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:39', 2, 0, '', '2019-06-21 17:19:39');
INSERT INTO `access_log` VALUES (41193, '64.76.15611087791687743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:39', 2, 0, '', '2019-06-21 17:19:39');
INSERT INTO `access_log` VALUES (41194, '59.74.15611087828567747', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:43', 3, 0, '', '2019-06-21 17:19:43');
INSERT INTO `access_log` VALUES (41195, '59.73.15611087828567755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:43', 13, 2001001000, '服务端发生异常', '2019-06-21 17:19:43');
INSERT INTO `access_log` VALUES (41196, '64.84.15611087865257753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:47', 2, 0, '', '2019-06-21 17:19:47');
INSERT INTO `access_log` VALUES (41197, '64.85.15611087868617775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:47', 2, 0, '', '2019-06-21 17:19:47');
INSERT INTO `access_log` VALUES (41198, '64.79.15611087882177763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:48', 1, 0, '', '2019-06-21 17:19:48');
INSERT INTO `access_log` VALUES (41199, '64.77.15611087893767759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:49', 1, 0, '', '2019-06-21 17:19:49');
INSERT INTO `access_log` VALUES (41200, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=戴尔&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:56', 6, 0, '', '2019-06-21 17:19:56');
INSERT INTO `access_log` VALUES (41201, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=戴尔', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:19:56', 7, 0, '', '2019-06-21 17:19:56');
INSERT INTO `access_log` VALUES (41202, '64.82.15611088035677773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:20:04', 2, 0, '', '2019-06-21 17:20:04');
INSERT INTO `access_log` VALUES (41203, '64.81.15611088036897753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:20:04', 2, 0, '', '2019-06-21 17:20:04');
INSERT INTO `access_log` VALUES (41204, '59.79.15611088058867755', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:20:06', 2, 0, '', '2019-06-21 17:20:06');
INSERT INTO `access_log` VALUES (41205, '59.80.15611088058847739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:20:06', 13, 2001001000, '服务端发生异常', '2019-06-21 17:20:06');
INSERT INTO `access_log` VALUES (41206, '64.80.15611088082147761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:20:08', 2, 0, '', '2019-06-21 17:20:08');
INSERT INTO `access_log` VALUES (41207, '64.76.15611088083267745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:20:08', 2, 0, '', '2019-06-21 17:20:08');
INSERT INTO `access_log` VALUES (41208, '59.77.15611088113467737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:20:11', 3, 0, '', '2019-06-21 17:20:11');
INSERT INTO `access_log` VALUES (41209, '59.71.15611088113477751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.186.191.55', '2019-06-21 17:20:11', 13, 2001001000, '服务端发生异常', '2019-06-21 17:20:11');
INSERT INTO `access_log` VALUES (41210, '59.77.15611090975737741', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.244.114', '2019-06-21 17:24:58', 3, 0, '', '2019-06-21 17:24:58');
INSERT INTO `access_log` VALUES (41211, '59.78.15611090975747753', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.244.114', '2019-06-21 17:24:58', 13, 2001001000, '服务端发生异常', '2019-06-21 17:24:58');
INSERT INTO `access_log` VALUES (41212, '65.49.15611094062478699', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.244.114', '2019-06-21 17:30:06', 0, 1002001015, '账号未登陆', '2019-06-21 17:30:06');
INSERT INTO `access_log` VALUES (41213, '65.54.15611094062488663', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.244.114', '2019-06-21 17:30:06', 1, 1002001015, '账号未登陆', '2019-06-21 17:30:06');
INSERT INTO `access_log` VALUES (41214, '65.47.15611094062818699', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.244.114', '2019-06-21 17:30:06', 1, 1002001015, '账号未登陆', '2019-06-21 17:30:06');
INSERT INTO `access_log` VALUES (41215, '59.76.15611108066727773', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.178', '2019-06-21 17:53:27', 3, 0, '', '2019-06-21 17:53:27');
INSERT INTO `access_log` VALUES (41216, '59.79.15611108066737783', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.178', '2019-06-21 17:53:27', 14, 2001001000, '服务端发生异常', '2019-06-21 17:53:27');
INSERT INTO `access_log` VALUES (41217, '65.52.15611108180578727', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.178', '2019-06-21 17:53:38', 0, 1002001015, '账号未登陆', '2019-06-21 17:53:38');
INSERT INTO `access_log` VALUES (41218, '65.45.15611108180578719', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.178', '2019-06-21 17:53:38', 1, 1002001015, '账号未登陆', '2019-06-21 17:53:38');
INSERT INTO `access_log` VALUES (41219, '65.51.15611108180628761', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.178', '2019-06-21 17:53:38', 1, 1002001015, '账号未登陆', '2019-06-21 17:53:38');
INSERT INTO `access_log` VALUES (41220, '65.49.15611108208638719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.178', '2019-06-21 17:53:41', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 17:53:41');
INSERT INTO `access_log` VALUES (41221, '65.47.15611108290618719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.178', '2019-06-21 17:53:49', 106, 0, '', '2019-06-21 17:53:49');
INSERT INTO `access_log` VALUES (41222, '65.53.15611108294288711', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.178', '2019-06-21 17:53:49', 9, 0, '', '2019-06-21 17:53:49');
INSERT INTO `access_log` VALUES (41223, '65.46.15611108294328773', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.178', '2019-06-21 17:53:49', 8, 2001001000, '服务端发生异常', '2019-06-21 17:53:49');
INSERT INTO `access_log` VALUES (41224, '65.50.15611108294378731', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.178', '2019-06-21 17:53:49', 9, 0, '', '2019-06-21 17:53:49');
INSERT INTO `access_log` VALUES (41225, '59.78.15611108581887777', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '223.88.165.148', '2019-06-21 17:54:18', 3, 0, '', '2019-06-21 17:54:18');
INSERT INTO `access_log` VALUES (41226, '59.75.15611108581897781', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '223.88.165.148', '2019-06-21 17:54:18', 13, 2001001000, '服务端发生异常', '2019-06-21 17:54:18');
INSERT INTO `access_log` VALUES (41227, '59.72.15611108644637775', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '223.88.165.148', '2019-06-21 17:54:24', 3, 0, '', '2019-06-21 17:54:24');
INSERT INTO `access_log` VALUES (41228, '59.73.15611108644637785', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '223.88.165.148', '2019-06-21 17:54:24', 10, 2001001000, '服务端发生异常', '2019-06-21 17:54:24');
INSERT INTO `access_log` VALUES (41229, '59.77.15611109222227767', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '120.204.17.70', '2019-06-21 17:55:22', 3, 0, '', '2019-06-21 17:55:22');
INSERT INTO `access_log` VALUES (41230, '59.75.15611109222227783', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '120.204.17.70', '2019-06-21 17:55:22', 12, 2001001000, '服务端发生异常', '2019-06-21 17:55:22');
INSERT INTO `access_log` VALUES (41231, '59.76.15611109919187777', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.22', '2019-06-21 17:56:32', 3, 0, '', '2019-06-21 17:56:32');
INSERT INTO `access_log` VALUES (41232, '59.79.15611109919187787', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.22', '2019-06-21 17:56:32', 15, 2001001000, '服务端发生异常', '2019-06-21 17:56:32');
INSERT INTO `access_log` VALUES (41233, '64.82.15611109943667803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.22', '2019-06-21 17:56:34', 10, 0, '', '2019-06-21 17:56:34');
INSERT INTO `access_log` VALUES (41234, '64.81.15611109944957783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.22', '2019-06-21 17:56:34', 3, 0, '', '2019-06-21 17:56:34');
INSERT INTO `access_log` VALUES (41235, '64.78.15611109954417793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.22', '2019-06-21 17:56:35', 2, 0, '', '2019-06-21 17:56:35');
INSERT INTO `access_log` VALUES (41236, '64.76.15611109958497775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.22', '2019-06-21 17:56:36', 2, 0, '', '2019-06-21 17:56:36');
INSERT INTO `access_log` VALUES (41237, '64.84.15611109961727785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.22', '2019-06-21 17:56:36', 2, 0, '', '2019-06-21 17:56:36');
INSERT INTO `access_log` VALUES (41238, '64.85.15611109967707807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.22', '2019-06-21 17:56:37', 2, 0, '', '2019-06-21 17:56:37');
INSERT INTO `access_log` VALUES (41239, '64.79.15611109975297795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.22', '2019-06-21 17:56:38', 2, 0, '', '2019-06-21 17:56:38');
INSERT INTO `access_log` VALUES (41240, '64.77.15611109980027791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.22', '2019-06-21 17:56:38', 2, 0, '', '2019-06-21 17:56:38');
INSERT INTO `access_log` VALUES (41241, '64.83.15611109984737785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.22', '2019-06-21 17:56:38', 2, 0, '', '2019-06-21 17:56:38');
INSERT INTO `access_log` VALUES (41242, '64.82.15611109988747805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.22', '2019-06-21 17:56:39', 2, 0, '', '2019-06-21 17:56:39');
INSERT INTO `access_log` VALUES (41243, '59.71.15611109999967783', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.22', '2019-06-21 17:56:40', 2, 0, '', '2019-06-21 17:56:40');
INSERT INTO `access_log` VALUES (41244, '59.77.15611109999987769', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.22', '2019-06-21 17:56:40', 13, 2001001000, '服务端发生异常', '2019-06-21 17:56:40');
INSERT INTO `access_log` VALUES (41245, '65.3607.15611138180370533', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '121.11.241.54', '2019-06-21 18:43:38', 0, 1002001015, '账号未登陆', '2019-06-21 18:43:38');
INSERT INTO `access_log` VALUES (41246, '65.46.15611138180368813', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '121.11.241.54', '2019-06-21 18:43:38', 0, 1002001015, '账号未登陆', '2019-06-21 18:43:38');
INSERT INTO `access_log` VALUES (41247, '65.45.15611138180378761', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '121.11.241.54', '2019-06-21 18:43:38', 0, 1002001015, '账号未登陆', '2019-06-21 18:43:38');
INSERT INTO `access_log` VALUES (41248, '65.52.15611138200308769', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '121.11.241.54', '2019-06-21 18:43:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 18:43:40');
INSERT INTO `access_log` VALUES (41249, '65.53.15611138782178753', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.178.166', '2019-06-21 18:44:38', 1, 1002001015, '账号未登陆', '2019-06-21 18:44:38');
INSERT INTO `access_log` VALUES (41250, '65.50.15611138782168773', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.89.29.92', '2019-06-21 18:44:38', 0, 1002001015, '账号未登陆', '2019-06-21 18:44:38');
INSERT INTO `access_log` VALUES (41251, '65.3607.15611138782270535', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.91.60.11', '2019-06-21 18:44:38', 1, 1002001015, '账号未登陆', '2019-06-21 18:44:38');
INSERT INTO `access_log` VALUES (41252, '59.72.15611163096147849', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '36.7.80.38', '2019-06-21 19:25:10', 10, 0, '', '2019-06-21 19:25:10');
INSERT INTO `access_log` VALUES (41253, '59.79.15611163096347859', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '36.7.80.38', '2019-06-21 19:25:10', 12, 2001001000, '服务端发生异常', '2019-06-21 19:25:10');
INSERT INTO `access_log` VALUES (41254, '65.51.15611168909858845', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-21 19:34:51', 691, 1002001012, '访问令牌已过期', '2019-06-21 19:34:52');
INSERT INTO `access_log` VALUES (41255, '65.45.15611168909818803', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-21 19:34:51', 696, 1002001012, '访问令牌已过期', '2019-06-21 19:34:52');
INSERT INTO `access_log` VALUES (41256, '65.52.15611168909988811', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-21 19:34:51', 678, 1002001012, '访问令牌已过期', '2019-06-21 19:34:52');
INSERT INTO `access_log` VALUES (41257, '59.79.15611168923417867', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.48.126.73', '2019-06-21 19:34:52', 4, 0, '', '2019-06-21 19:34:52');
INSERT INTO `access_log` VALUES (41258, '59.76.15611168923437857', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.48.126.73', '2019-06-21 19:34:52', 15, 2001001000, '服务端发生异常', '2019-06-21 19:34:52');
INSERT INTO `access_log` VALUES (41259, '64.76.15611168966017855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.48.126.73', '2019-06-21 19:34:57', 11, 0, '', '2019-06-21 19:34:57');
INSERT INTO `access_log` VALUES (41260, '64.84.15611168967497865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.48.126.73', '2019-06-21 19:34:57', 3, 0, '', '2019-06-21 19:34:57');
INSERT INTO `access_log` VALUES (41261, '64.85.15611169029417887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.48.126.73', '2019-06-21 19:35:03', 2, 0, '', '2019-06-21 19:35:03');
INSERT INTO `access_log` VALUES (41262, '64.79.15611169033437875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.48.126.73', '2019-06-21 19:35:03', 2, 0, '', '2019-06-21 19:35:03');
INSERT INTO `access_log` VALUES (41263, '59.80.15611169036527851', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.48.126.73', '2019-06-21 19:35:04', 2, 0, '', '2019-06-21 19:35:04');
INSERT INTO `access_log` VALUES (41264, '59.71.15611169036537863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.48.126.73', '2019-06-21 19:35:04', 12, 2001001000, '服务端发生异常', '2019-06-21 19:35:04');
INSERT INTO `access_log` VALUES (41265, '65.49.15611169087308803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-21 19:35:09', 88, 0, '', '2019-06-21 19:35:09');
INSERT INTO `access_log` VALUES (41266, '65.53.15611169099138795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-21 19:35:10', 12, 2001001000, '服务端发生异常', '2019-06-21 19:35:10');
INSERT INTO `access_log` VALUES (41267, '65.50.15611169099148815', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-21 19:35:10', 12, 0, '', '2019-06-21 19:35:10');
INSERT INTO `access_log` VALUES (41268, '65.3607.15611169099150577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '47.254.155.65', '2019-06-21 19:35:10', 11, 0, '', '2019-06-21 19:35:10');
INSERT INTO `access_log` VALUES (41269, '59.80.15611183654937871', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.157.160.44', '2019-06-21 19:59:25', 3, 0, '', '2019-06-21 19:59:25');
INSERT INTO `access_log` VALUES (41270, '59.71.15611183654967883', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.157.160.44', '2019-06-21 19:59:25', 13, 2001001000, '服务端发生异常', '2019-06-21 19:59:26');
INSERT INTO `access_log` VALUES (41271, '59.75.15611219741817933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 20:59:34', 10, 0, '', '2019-06-21 20:59:34');
INSERT INTO `access_log` VALUES (41272, '59.78.15611219741817929', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 20:59:34', 15, 2001001000, '服务端发生异常', '2019-06-21 20:59:34');
INSERT INTO `access_log` VALUES (41273, '64.79.15611219823297943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 20:59:42', 11, 0, '', '2019-06-21 20:59:42');
INSERT INTO `access_log` VALUES (41274, '64.77.15611219824287939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 20:59:42', 3, 0, '', '2019-06-21 20:59:42');
INSERT INTO `access_log` VALUES (41275, '64.83.15611219844407933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 20:59:44', 2, 0, '', '2019-06-21 20:59:44');
INSERT INTO `access_log` VALUES (41276, '64.82.15611219850687953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 20:59:45', 2, 0, '', '2019-06-21 20:59:45');
INSERT INTO `access_log` VALUES (41277, '64.81.15611219902807933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 20:59:50', 2, 0, '', '2019-06-21 20:59:50');
INSERT INTO `access_log` VALUES (41278, '64.80.15611219905977941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 20:59:51', 2, 0, '', '2019-06-21 20:59:51');
INSERT INTO `access_log` VALUES (41279, '59.72.15611219920157927', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 20:59:52', 3, 0, '', '2019-06-21 20:59:52');
INSERT INTO `access_log` VALUES (41280, '59.73.15611219920157937', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 20:59:52', 14, 2001001000, '服务端发生异常', '2019-06-21 20:59:52');
INSERT INTO `access_log` VALUES (41281, '65.46.15611220061808925', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 21:00:06', 3, 1002001012, '访问令牌已过期', '2019-06-21 21:00:06');
INSERT INTO `access_log` VALUES (41282, '65.3607.15611220061800645', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 21:00:06', 3, 1002001012, '访问令牌已过期', '2019-06-21 21:00:06');
INSERT INTO `access_log` VALUES (41283, '65.52.15611220061828881', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 21:00:06', 5, 1002001012, '访问令牌已过期', '2019-06-21 21:00:06');
INSERT INTO `access_log` VALUES (41284, '65.51.15611220079528915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 21:00:08', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 21:00:08');
INSERT INTO `access_log` VALUES (41285, '65.54.15611220129568837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 21:00:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 21:00:13');
INSERT INTO `access_log` VALUES (41286, '65.49.15611220258448873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 21:00:26', 72, 0, '', '2019-06-21 21:00:26');
INSERT INTO `access_log` VALUES (41287, '65.50.15611220261208885', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 21:00:26', 14, 0, '', '2019-06-21 21:00:26');
INSERT INTO `access_log` VALUES (41288, '65.53.15611220261218865', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 21:00:26', 15, 2001001000, '服务端发生异常', '2019-06-21 21:00:26');
INSERT INTO `access_log` VALUES (41289, '65.3607.15611220261280647', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.230.223.85', '2019-06-21 21:00:26', 11, 0, '', '2019-06-21 21:00:26');
INSERT INTO `access_log` VALUES (41290, '65.52.15611235513468903', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:25:51', 0, 1002001015, '账号未登陆', '2019-06-21 21:25:51');
INSERT INTO `access_log` VALUES (41291, '65.45.15611235513478895', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:25:51', 0, 1002001015, '账号未登陆', '2019-06-21 21:25:51');
INSERT INTO `access_log` VALUES (41292, '65.51.15611235513478937', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:25:51', 0, 1002001015, '账号未登陆', '2019-06-21 21:25:51');
INSERT INTO `access_log` VALUES (41293, '65.47.15611235554318895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:25:55', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 21:25:55');
INSERT INTO `access_log` VALUES (41294, '65.49.15611235658968895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:26:06', 367, 0, '', '2019-06-21 21:26:06');
INSERT INTO `access_log` VALUES (41295, '65.3607.15611235664530669', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:26:06', 17, 0, '', '2019-06-21 21:26:06');
INSERT INTO `access_log` VALUES (41296, '65.50.15611235664538907', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:26:06', 17, 0, '', '2019-06-21 21:26:06');
INSERT INTO `access_log` VALUES (41297, '65.53.15611235666288887', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:26:07', 10, 2001001000, '服务端发生异常', '2019-06-21 21:26:07');
INSERT INTO `access_log` VALUES (41298, '65.51.15611235870198939', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:26:27', 9, 0, '', '2019-06-21 21:26:27');
INSERT INTO `access_log` VALUES (41299, '65.45.15611235870198897', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:26:27', 10, 2001001000, '服务端发生异常', '2019-06-21 21:26:27');
INSERT INTO `access_log` VALUES (41300, '65.54.15611235870218861', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:26:27', 7, 0, '', '2019-06-21 21:26:27');
INSERT INTO `access_log` VALUES (41301, '59.79.15611236408997959', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:27:21', 15, 2001001000, '服务端发生异常', '2019-06-21 21:27:21');
INSERT INTO `access_log` VALUES (41302, '59.76.15611236408617949', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:27:21', 274, 0, '', '2019-06-21 21:27:21');
INSERT INTO `access_log` VALUES (41303, '64.76.15611236470057947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:27:27', 3, 0, '', '2019-06-21 21:27:27');
INSERT INTO `access_log` VALUES (41304, '64.84.15611236471117957', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:27:27', 1, 0, '', '2019-06-21 21:27:27');
INSERT INTO `access_log` VALUES (41305, '64.85.15611236488507979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:27:29', 2, 0, '', '2019-06-21 21:27:29');
INSERT INTO `access_log` VALUES (41306, '64.79.15611236495567967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.192.16.220', '2019-06-21 21:27:30', 2, 0, '', '2019-06-21 21:27:30');
INSERT INTO `access_log` VALUES (41307, '65.52.15611251733508927', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '101.80.12.63', '2019-06-21 21:52:53', 0, 1002001015, '账号未登陆', '2019-06-21 21:52:53');
INSERT INTO `access_log` VALUES (41308, '65.46.15611251733508971', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '101.80.12.63', '2019-06-21 21:52:53', 0, 1002001015, '账号未登陆', '2019-06-21 21:52:53');
INSERT INTO `access_log` VALUES (41309, '65.54.15611251733528883', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '101.80.12.63', '2019-06-21 21:52:53', 0, 1002001015, '账号未登陆', '2019-06-21 21:52:53');
INSERT INTO `access_log` VALUES (41310, '65.51.15611251746188961', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '101.80.12.63', '2019-06-21 21:52:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 21:52:55');
INSERT INTO `access_log` VALUES (41311, '65.47.15611251777148919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '101.80.12.63', '2019-06-21 21:52:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-21 21:52:58');
INSERT INTO `access_log` VALUES (41312, '65.49.15611251877758919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '101.80.12.63', '2019-06-21 21:53:08', 60, 0, '', '2019-06-21 21:53:08');
INSERT INTO `access_log` VALUES (41313, '65.3607.15611251880100693', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '101.80.12.63', '2019-06-21 21:53:08', 9, 0, '', '2019-06-21 21:53:08');
INSERT INTO `access_log` VALUES (41314, '65.50.15611251880118931', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '101.80.12.63', '2019-06-21 21:53:08', 11, 2001001000, '服务端发生异常', '2019-06-21 21:53:08');
INSERT INTO `access_log` VALUES (41315, '65.53.15611251880158911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '101.80.12.63', '2019-06-21 21:53:08', 9, 0, '', '2019-06-21 21:53:08');
INSERT INTO `access_log` VALUES (41316, '59.72.15611264377187987', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-21 22:13:58', 10, 0, '', '2019-06-21 22:13:58');
INSERT INTO `access_log` VALUES (41317, '59.73.15611264383367997', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-21 22:13:58', 12, 2001001000, '服务端发生异常', '2019-06-21 22:13:58');
INSERT INTO `access_log` VALUES (41318, '64.84.15611264532757995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-21 22:14:13', 10, 0, '', '2019-06-21 22:14:13');
INSERT INTO `access_log` VALUES (41319, '64.85.15611264534578017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-21 22:14:13', 4, 0, '', '2019-06-21 22:14:13');
INSERT INTO `access_log` VALUES (41320, '64.79.15611264545868005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-21 22:14:15', 3, 0, '', '2019-06-21 22:14:15');
INSERT INTO `access_log` VALUES (41321, '64.77.15611264552858001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-21 22:14:15', 2, 0, '', '2019-06-21 22:14:15');
INSERT INTO `access_log` VALUES (41322, '64.83.15611264556257995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-21 22:14:16', 2, 0, '', '2019-06-21 22:14:16');
INSERT INTO `access_log` VALUES (41323, '64.82.15611264576598015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-21 22:14:18', 2, 0, '', '2019-06-21 22:14:18');
INSERT INTO `access_log` VALUES (41324, '64.78.15611264578038005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-21 22:14:18', 2, 0, '', '2019-06-21 22:14:18');
INSERT INTO `access_log` VALUES (41325, '64.81.15611264600147995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-21 22:14:20', 1, 0, '', '2019-06-21 22:14:20');
INSERT INTO `access_log` VALUES (41326, '59.80.15611264608167981', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-21 22:14:21', 4, 0, '', '2019-06-21 22:14:21');
INSERT INTO `access_log` VALUES (41327, '59.71.15611264608647993', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-21 22:14:21', 12, 2001001000, '服务端发生异常', '2019-06-21 22:14:21');
INSERT INTO `access_log` VALUES (41328, '66.52.15611264733446263', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13112114436', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-21 22:14:33', 104, 0, '', '2019-06-21 22:14:33');
INSERT INTO `access_log` VALUES (41329, '59.77.15611291724578015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/602.1 (KHTML, like Gecko) JavaFX/8.0 Safari/602.1', '183.136.216.194', '2019-06-21 22:59:32', 11, 0, '', '2019-06-21 22:59:32');
INSERT INTO `access_log` VALUES (41330, '59.75.15611291724608031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/602.1 (KHTML, like Gecko) JavaFX/8.0 Safari/602.1', '183.136.216.194', '2019-06-21 22:59:32', 15, 2001001000, '服务端发生异常', '2019-06-21 22:59:32');
INSERT INTO `access_log` VALUES (41331, '59.76.15611328445058073', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.136.216.194', '2019-06-22 00:00:45', 9, 0, '', '2019-06-22 00:00:45');
INSERT INTO `access_log` VALUES (41332, '59.80.15611328445068067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.136.216.194', '2019-06-22 00:00:45', 12, 2001001000, '服务端发生异常', '2019-06-22 00:00:45');
INSERT INTO `access_log` VALUES (41333, '64.82.15611328527028101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.136.216.194', '2019-06-22 00:00:53', 11, 0, '', '2019-06-22 00:00:53');
INSERT INTO `access_log` VALUES (41334, '64.78.15611328528738091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.136.216.194', '2019-06-22 00:00:53', 3, 0, '', '2019-06-22 00:00:53');
INSERT INTO `access_log` VALUES (41335, '64.81.15611328547828081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.136.216.194', '2019-06-22 00:00:55', 2, 0, '', '2019-06-22 00:00:55');
INSERT INTO `access_log` VALUES (41336, '64.80.15611328555228089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.136.216.194', '2019-06-22 00:00:56', 1, 0, '', '2019-06-22 00:00:56');
INSERT INTO `access_log` VALUES (41337, '64.76.15611328585668073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.136.216.194', '2019-06-22 00:00:59', 1, 0, '', '2019-06-22 00:00:59');
INSERT INTO `access_log` VALUES (41338, '64.84.15611328586978083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.136.216.194', '2019-06-22 00:00:59', 1, 0, '', '2019-06-22 00:00:59');
INSERT INTO `access_log` VALUES (41339, '59.72.15611395182258163', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.5.242.235', '2019-06-22 01:51:58', 11, 0, '', '2019-06-22 01:51:58');
INSERT INTO `access_log` VALUES (41340, '59.73.15611395182408173', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.5.242.235', '2019-06-22 01:51:58', 13, 2001001000, '服务端发生异常', '2019-06-22 01:51:58');
INSERT INTO `access_log` VALUES (41341, '65.49.15611395202199111', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.5.242.235', '2019-06-22 01:52:00', 1, 1002001015, '账号未登陆', '2019-06-22 01:52:00');
INSERT INTO `access_log` VALUES (41342, '65.51.15611395202189153', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.5.242.235', '2019-06-22 01:52:00', 1, 1002001015, '账号未登陆', '2019-06-22 01:52:00');
INSERT INTO `access_log` VALUES (41343, '65.50.15611395202259125', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.5.242.235', '2019-06-22 01:52:00', 1, 1002001015, '账号未登陆', '2019-06-22 01:52:00');
INSERT INTO `access_log` VALUES (41344, '64.78.15611395272448181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.5.242.235', '2019-06-22 01:52:07', 10, 0, '', '2019-06-22 01:52:07');
INSERT INTO `access_log` VALUES (41345, '64.81.15611395273768171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.5.242.235', '2019-06-22 01:52:07', 2, 0, '', '2019-06-22 01:52:07');
INSERT INTO `access_log` VALUES (41346, '65.52.15611395299459123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.5.242.235', '2019-06-22 01:52:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 01:52:10');
INSERT INTO `access_log` VALUES (41347, '65.47.15611395370349111', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.5.242.235', '2019-06-22 01:52:17', 4, 1002002001, '密码不正确', '2019-06-22 01:52:17');
INSERT INTO `access_log` VALUES (41348, '65.46.15611395475389165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.5.242.235', '2019-06-22 01:52:28', 70, 0, '', '2019-06-22 01:52:28');
INSERT INTO `access_log` VALUES (41349, '65.51.15611395478469155', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.5.242.235', '2019-06-22 01:52:28', 10, 0, '', '2019-06-22 01:52:28');
INSERT INTO `access_log` VALUES (41350, '65.45.15611395478449115', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.5.242.235', '2019-06-22 01:52:28', 12, 0, '', '2019-06-22 01:52:28');
INSERT INTO `access_log` VALUES (41351, '65.54.15611395478439079', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.5.242.235', '2019-06-22 01:52:28', 13, 2001001000, '服务端发生异常', '2019-06-22 01:52:28');
INSERT INTO `access_log` VALUES (41352, '65.46.15611627239569475', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:18:44', 0, 1002001015, '账号未登陆', '2019-06-22 08:18:44');
INSERT INTO `access_log` VALUES (41353, '65.53.15611627239569413', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:18:44', 0, 1002001015, '账号未登陆', '2019-06-22 08:18:44');
INSERT INTO `access_log` VALUES (41354, '65.45.15611627239739425', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:18:44', 0, 1002001015, '账号未登陆', '2019-06-22 08:18:44');
INSERT INTO `access_log` VALUES (41355, '65.54.15611627259029389', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:18:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 08:18:46');
INSERT INTO `access_log` VALUES (41356, '65.51.15611627300219465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:18:50', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 08:18:50');
INSERT INTO `access_log` VALUES (41357, '65.52.15611639754019451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:39:35', 80, 0, '', '2019-06-22 08:39:35');
INSERT INTO `access_log` VALUES (41358, '65.47.15611639758739439', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:39:36', 12, 0, '', '2019-06-22 08:39:36');
INSERT INTO `access_log` VALUES (41359, '65.46.15611639758749493', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:39:36', 13, 2001001000, '服务端发生异常', '2019-06-22 08:39:36');
INSERT INTO `access_log` VALUES (41360, '65.53.15611639758849431', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:39:36', 8, 0, '', '2019-06-22 08:39:36');
INSERT INTO `access_log` VALUES (41361, '65.3607.15611640527781217', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:40:53', 12, 0, '', '2019-06-22 08:40:53');
INSERT INTO `access_log` VALUES (41362, '65.52.15611640527789453', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:40:53', 13, 2001001000, '服务端发生异常', '2019-06-22 08:40:53');
INSERT INTO `access_log` VALUES (41363, '65.53.15611640527829433', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:40:53', 9, 0, '', '2019-06-22 08:40:53');
INSERT INTO `access_log` VALUES (41364, '65.46.15611640656989495', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:41:06', 9, 0, '', '2019-06-22 08:41:06');
INSERT INTO `access_log` VALUES (41365, '65.45.15611640657019445', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:41:06', 9, 2001001000, '服务端发生异常', '2019-06-22 08:41:06');
INSERT INTO `access_log` VALUES (41366, '65.54.15611640657069409', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '110.82.117.218', '2019-06-22 08:41:06', 8, 0, '', '2019-06-22 08:41:06');
INSERT INTO `access_log` VALUES (41367, '65.3607.15611765538741385', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '111.196.201.42', '2019-06-22 12:09:14', 0, 1002001015, '账号未登陆', '2019-06-22 12:09:14');
INSERT INTO `access_log` VALUES (41368, '65.53.15611765538769601', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '111.196.201.42', '2019-06-22 12:09:14', 1, 1002001015, '账号未登陆', '2019-06-22 12:09:14');
INSERT INTO `access_log` VALUES (41369, '65.52.15611765539009621', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '111.196.201.42', '2019-06-22 12:09:14', 1, 1002001015, '账号未登陆', '2019-06-22 12:09:14');
INSERT INTO `access_log` VALUES (41370, '65.47.15611765627329609', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '111.196.201.42', '2019-06-22 12:09:23', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 12:09:23');
INSERT INTO `access_log` VALUES (41371, '65.46.15611765662159663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '111.196.201.42', '2019-06-22 12:09:26', 402, 0, '', '2019-06-22 12:09:27');
INSERT INTO `access_log` VALUES (41372, '65.45.15611765670709613', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '111.196.201.42', '2019-06-22 12:09:27', 9, 0, '', '2019-06-22 12:09:27');
INSERT INTO `access_log` VALUES (41373, '65.51.15611765670759653', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '111.196.201.42', '2019-06-22 12:09:27', 15, 2001001000, '服务端发生异常', '2019-06-22 12:09:27');
INSERT INTO `access_log` VALUES (41374, '65.49.15611765670809611', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '111.196.201.42', '2019-06-22 12:09:27', 16, 0, '', '2019-06-22 12:09:27');
INSERT INTO `access_log` VALUES (41375, '59.79.15611767031538669', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.101', '2019-06-22 12:11:43', 20, 2001001000, '服务端发生异常', '2019-06-22 12:11:43');
INSERT INTO `access_log` VALUES (41376, '59.73.15611767031528669', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.101', '2019-06-22 12:11:43', 83, 0, '', '2019-06-22 12:11:43');
INSERT INTO `access_log` VALUES (41377, '64.78.15611767081068677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.101', '2019-06-22 12:11:48', 10, 0, '', '2019-06-22 12:11:48');
INSERT INTO `access_log` VALUES (41378, '64.81.15611767082148667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.101', '2019-06-22 12:11:48', 2, 0, '', '2019-06-22 12:11:48');
INSERT INTO `access_log` VALUES (41379, '64.80.15611767099348675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.101', '2019-06-22 12:11:50', 2, 0, '', '2019-06-22 12:11:50');
INSERT INTO `access_log` VALUES (41380, '64.84.15611767105938669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.101', '2019-06-22 12:11:51', 2, 0, '', '2019-06-22 12:11:51');
INSERT INTO `access_log` VALUES (41381, '59.80.15611767129478653', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.101', '2019-06-22 12:11:53', 4, 0, '', '2019-06-22 12:11:53');
INSERT INTO `access_log` VALUES (41382, '59.71.15611767129498665', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.101', '2019-06-22 12:11:53', 14, 2001001000, '服务端发生异常', '2019-06-22 12:11:53');
INSERT INTO `access_log` VALUES (41383, '64.85.15611767151678691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.101', '2019-06-22 12:11:55', 2, 0, '', '2019-06-22 12:11:55');
INSERT INTO `access_log` VALUES (41384, '64.79.15611767152648679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.101', '2019-06-22 12:11:55', 1, 0, '', '2019-06-22 12:11:55');
INSERT INTO `access_log` VALUES (41385, '64.77.15611767233768675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.101', '2019-06-22 12:12:03', 2, 0, '', '2019-06-22 12:12:03');
INSERT INTO `access_log` VALUES (41386, '64.83.15611767234788669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.101', '2019-06-22 12:12:03', 2, 0, '', '2019-06-22 12:12:03');
INSERT INTO `access_log` VALUES (41387, '65.52.15611788482249655', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.75.60', '2019-06-22 12:47:28', 0, 1002001015, '账号未登陆', '2019-06-22 12:47:28');
INSERT INTO `access_log` VALUES (41388, '65.53.15611788482249635', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.75.60', '2019-06-22 12:47:28', 0, 1002001015, '账号未登陆', '2019-06-22 12:47:28');
INSERT INTO `access_log` VALUES (41389, '65.3607.15611788482471417', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.75.60', '2019-06-22 12:47:28', 1, 1002001015, '账号未登陆', '2019-06-22 12:47:28');
INSERT INTO `access_log` VALUES (41390, '65.47.15611788520979641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.75.60', '2019-06-22 12:47:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 12:47:32');
INSERT INTO `access_log` VALUES (41391, '65.54.15611788569269611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.75.60', '2019-06-22 12:47:37', 166, 0, '', '2019-06-22 12:47:37');
INSERT INTO `access_log` VALUES (41392, '65.49.15611788575949643', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.75.60', '2019-06-22 12:47:38', 841, 0, '', '2019-06-22 12:47:38');
INSERT INTO `access_log` VALUES (41393, '65.45.15611788576049645', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.75.60', '2019-06-22 12:47:38', 832, 0, '', '2019-06-22 12:47:38');
INSERT INTO `access_log` VALUES (41394, '65.46.15611788575969695', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.75.60', '2019-06-22 12:47:38', 840, 2001001000, '服务端发生异常', '2019-06-22 12:47:38');
INSERT INTO `access_log` VALUES (41395, '65.50.15611788688159659', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.75.60', '2019-06-22 12:47:49', 9, 0, '', '2019-06-22 12:47:49');
INSERT INTO `access_log` VALUES (41396, '65.53.15611788688269637', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.75.60', '2019-06-22 12:47:49', 10, 2001001000, '服务端发生异常', '2019-06-22 12:47:49');
INSERT INTO `access_log` VALUES (41397, '65.52.15611788688409657', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '42.120.75.60', '2019-06-22 12:47:49', 15, 0, '', '2019-06-22 12:47:49');
INSERT INTO `access_log` VALUES (41398, '65.3607.15611812479611451', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-06-22 13:27:28', 17, 1002001012, '访问令牌已过期', '2019-06-22 13:27:28');
INSERT INTO `access_log` VALUES (41399, '65.52.15611812479619689', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-06-22 13:27:28', 14, 1002001012, '访问令牌已过期', '2019-06-22 13:27:28');
INSERT INTO `access_log` VALUES (41400, '65.47.15611812479619675', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '115.236.91.15', '2019-06-22 13:27:28', 18, 1002001012, '访问令牌已过期', '2019-06-22 13:27:28');
INSERT INTO `access_log` VALUES (41401, '65.52.15611825565519707', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.131.110.7', '2019-06-22 13:49:17', 0, 1002001015, '账号未登陆', '2019-06-22 13:49:17');
INSERT INTO `access_log` VALUES (41402, '65.3607.15611825566341469', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.131.110.23', '2019-06-22 13:49:17', 0, 1002001015, '账号未登陆', '2019-06-22 13:49:17');
INSERT INTO `access_log` VALUES (41403, '65.47.15611825566349693', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.131.110.8', '2019-06-22 13:49:17', 0, 1002001015, '账号未登陆', '2019-06-22 13:49:17');
INSERT INTO `access_log` VALUES (41404, '65.54.15611825586449663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.131.110.7', '2019-06-22 13:49:19', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 13:49:19');
INSERT INTO `access_log` VALUES (41405, '65.46.15611825620459747', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.131.110.7', '2019-06-22 13:49:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 13:49:22');
INSERT INTO `access_log` VALUES (41406, '65.53.15611826170409689', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.207.205', '2019-06-22 13:50:17', 1, 1002001015, '账号未登陆', '2019-06-22 13:50:17');
INSERT INTO `access_log` VALUES (41407, '65.52.15611826185309709', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.91.60.110', '2019-06-22 13:50:19', 1, 1002001015, '账号未登陆', '2019-06-22 13:50:19');
INSERT INTO `access_log` VALUES (41408, '59.76.15611832714748747', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.39.33.238', '2019-06-22 14:01:11', 11, 0, '', '2019-06-22 14:01:11');
INSERT INTO `access_log` VALUES (41409, '59.71.15611832714758753', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.39.33.238', '2019-06-22 14:01:11', 15, 2001001000, '服务端发生异常', '2019-06-22 14:01:11');
INSERT INTO `access_log` VALUES (41410, '64.85.15611849191798803', 0, 2, 'product-application', '/product-api/admins/attr/add', 'name=颜色', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.93.23.78', '2019-06-22 14:28:39', 0, 1002001015, '账号未登陆', '2019-06-22 14:28:39');
INSERT INTO `access_log` VALUES (41411, '64.85.15611853442778809', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.93.23.78', '2019-06-22 14:35:44', 11, 1003002003, 'Spu 只能添加在二级分类下', '2019-06-22 14:35:44');
INSERT INTO `access_log` VALUES (41412, '64.82.15611857046428809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.93.23.78', '2019-06-22 14:41:45', 3, 0, '', '2019-06-22 14:41:45');
INSERT INTO `access_log` VALUES (41413, '64.81.15611857091268791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.93.23.78', '2019-06-22 14:41:49', 2, 0, '', '2019-06-22 14:41:49');
INSERT INTO `access_log` VALUES (41414, '64.76.15611857129478783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.93.23.78', '2019-06-22 14:41:53', 2, 0, '', '2019-06-22 14:41:53');
INSERT INTO `access_log` VALUES (41415, '64.85.15611857260178815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.93.23.78', '2019-06-22 14:42:06', 3, 0, '', '2019-06-22 14:42:06');
INSERT INTO `access_log` VALUES (41416, '59.74.15611866384518795', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.61.100.218', '2019-06-22 14:57:18', 11, 0, '', '2019-06-22 14:57:18');
INSERT INTO `access_log` VALUES (41417, '59.72.15611866384538793', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.61.100.218', '2019-06-22 14:57:18', 15, 2001001000, '服务端发生异常', '2019-06-22 14:57:18');
INSERT INTO `access_log` VALUES (41418, '64.81.15611866711868805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.61.100.218', '2019-06-22 14:57:51', 3, 0, '', '2019-06-22 14:57:51');
INSERT INTO `access_log` VALUES (41419, '64.80.15611866713078811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.61.100.218', '2019-06-22 14:57:51', 2, 0, '', '2019-06-22 14:57:51');
INSERT INTO `access_log` VALUES (41420, '64.76.15611866727658797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.61.100.218', '2019-06-22 14:57:53', 2, 0, '', '2019-06-22 14:57:53');
INSERT INTO `access_log` VALUES (41421, '64.84.15611866733748803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.61.100.218', '2019-06-22 14:57:53', 2, 0, '', '2019-06-22 14:57:53');
INSERT INTO `access_log` VALUES (41422, '59.73.15611884493718827', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '114.249.27.249', '2019-06-22 15:27:29', 12, 2001001000, '服务端发生异常', '2019-06-22 15:27:29');
INSERT INTO `access_log` VALUES (41423, '59.76.15611884493738817', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '114.249.27.249', '2019-06-22 15:27:29', 45, 0, '', '2019-06-22 15:27:29');
INSERT INTO `access_log` VALUES (41424, '64.76.15611884521958821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '114.249.27.249', '2019-06-22 15:27:32', 2, 0, '', '2019-06-22 15:27:32');
INSERT INTO `access_log` VALUES (41425, '64.84.15611884523138827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '114.249.27.249', '2019-06-22 15:27:32', 1, 0, '', '2019-06-22 15:27:32');
INSERT INTO `access_log` VALUES (41426, '64.85.15611884531908853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '114.249.27.249', '2019-06-22 15:27:33', 2, 0, '', '2019-06-22 15:27:33');
INSERT INTO `access_log` VALUES (41427, '64.79.15611884539418839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '114.249.27.249', '2019-06-22 15:27:34', 1, 0, '', '2019-06-22 15:27:34');
INSERT INTO `access_log` VALUES (41428, '64.77.15611884542718835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '114.249.27.249', '2019-06-22 15:27:34', 2, 0, '', '2019-06-22 15:27:34');
INSERT INTO `access_log` VALUES (41429, '65.50.15611889444429797', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.186', '2019-06-22 15:35:44', 4, 1002001012, '访问令牌已过期', '2019-06-22 15:35:44');
INSERT INTO `access_log` VALUES (41430, '65.51.15611889444429823', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.186', '2019-06-22 15:35:44', 4, 1002001012, '访问令牌已过期', '2019-06-22 15:35:44');
INSERT INTO `access_log` VALUES (41431, '65.53.15611889444619775', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.186', '2019-06-22 15:35:44', 11, 1002001012, '访问令牌已过期', '2019-06-22 15:35:44');
INSERT INTO `access_log` VALUES (41432, '65.52.15611889491389795', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.186', '2019-06-22 15:35:49', 87, 0, '', '2019-06-22 15:35:49');
INSERT INTO `access_log` VALUES (41433, '65.3607.15611889499851557', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.186', '2019-06-22 15:35:50', 20, 0, '', '2019-06-22 15:35:50');
INSERT INTO `access_log` VALUES (41434, '65.47.15611889499859781', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.186', '2019-06-22 15:35:50', 20, 0, '', '2019-06-22 15:35:50');
INSERT INTO `access_log` VALUES (41435, '65.54.15611889499949749', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.186', '2019-06-22 15:35:50', 20, 2001001000, '服务端发生异常', '2019-06-22 15:35:50');
INSERT INTO `access_log` VALUES (41436, '59.71.15611903900938849', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.241.251.231', '2019-06-22 15:59:50', 11, 0, '', '2019-06-22 15:59:50');
INSERT INTO `access_log` VALUES (41437, '59.80.15611903900938837', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.241.251.231', '2019-06-22 15:59:50', 15, 2001001000, '服务端发生异常', '2019-06-22 15:59:50');
INSERT INTO `access_log` VALUES (41438, '65.47.15611904012459801', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.241.251.231', '2019-06-22 16:00:01', 0, 1002001015, '账号未登陆', '2019-06-22 16:00:01');
INSERT INTO `access_log` VALUES (41439, '65.3607.15611904012451577', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.241.251.231', '2019-06-22 16:00:01', 0, 1002001015, '账号未登陆', '2019-06-22 16:00:01');
INSERT INTO `access_log` VALUES (41440, '65.54.15611904012469769', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.241.251.231', '2019-06-22 16:00:01', 0, 1002001015, '账号未登陆', '2019-06-22 16:00:01');
INSERT INTO `access_log` VALUES (41441, '64.78.15611904110208865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.241.251.231', '2019-06-22 16:00:11', 11, 0, '', '2019-06-22 16:00:11');
INSERT INTO `access_log` VALUES (41442, '64.82.15611904111528875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.241.251.231', '2019-06-22 16:00:11', 3, 0, '', '2019-06-22 16:00:11');
INSERT INTO `access_log` VALUES (41443, '65.49.15611904172369803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.241.251.231', '2019-06-22 16:00:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 16:00:17');
INSERT INTO `access_log` VALUES (41444, '65.51.15611904561989845', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.241.251.231', '2019-06-22 16:00:56', 4, 1002002000, '账号不存在', '2019-06-22 16:00:56');
INSERT INTO `access_log` VALUES (41445, '65.3607.15611904824511579', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.241.251.231', '2019-06-22 16:01:22', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 16:01:22');
INSERT INTO `access_log` VALUES (41446, '65.54.15611904865209771', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.241.251.231', '2019-06-22 16:01:27', 4, 1002002001, '密码不正确', '2019-06-22 16:01:27');
INSERT INTO `access_log` VALUES (41447, '64.85.15611906232678883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.241.251.231', '2019-06-22 16:03:43', 3, 0, '', '2019-06-22 16:03:43');
INSERT INTO `access_log` VALUES (41448, '64.79.15611906237538869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.241.251.231', '2019-06-22 16:03:44', 2, 0, '', '2019-06-22 16:03:44');
INSERT INTO `access_log` VALUES (41449, '64.77.15611906269188865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.241.251.231', '2019-06-22 16:03:47', 2, 0, '', '2019-06-22 16:03:47');
INSERT INTO `access_log` VALUES (41450, '64.83.15611906270358861', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.241.251.231', '2019-06-22 16:03:47', 1, 0, '', '2019-06-22 16:03:47');
INSERT INTO `access_log` VALUES (41451, '59.79.15611906279608857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.241.251.231', '2019-06-22 16:03:48', 4, 0, '', '2019-06-22 16:03:48');
INSERT INTO `access_log` VALUES (41452, '59.76.15611906279968847', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.241.251.231', '2019-06-22 16:03:48', 13, 2001001000, '服务端发生异常', '2019-06-22 16:03:48');
INSERT INTO `access_log` VALUES (41453, '65.53.15611917325929815', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.231', '2019-06-22 16:22:13', 4, 1002001012, '访问令牌已过期', '2019-06-22 16:22:13');
INSERT INTO `access_log` VALUES (41454, '65.50.15611917325939837', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.231', '2019-06-22 16:22:13', 4, 1002001012, '访问令牌已过期', '2019-06-22 16:22:13');
INSERT INTO `access_log` VALUES (41455, '65.51.15611917325969863', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.231', '2019-06-22 16:22:13', 3, 1002001012, '访问令牌已过期', '2019-06-22 16:22:13');
INSERT INTO `access_log` VALUES (41456, '65.3607.15611917463021597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.231', '2019-06-22 16:22:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 16:22:26');
INSERT INTO `access_log` VALUES (41457, '65.46.15611917797149875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.231', '2019-06-22 16:23:00', 72, 0, '', '2019-06-22 16:23:00');
INSERT INTO `access_log` VALUES (41458, '65.49.15611917801319823', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.231', '2019-06-22 16:23:00', 8, 0, '', '2019-06-22 16:23:00');
INSERT INTO `access_log` VALUES (41459, '65.45.15611917801439823', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.231', '2019-06-22 16:23:00', 8, 2001001000, '服务端发生异常', '2019-06-22 16:23:00');
INSERT INTO `access_log` VALUES (41460, '65.51.15611917801489865', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.231', '2019-06-22 16:23:00', 8, 0, '', '2019-06-22 16:23:00');
INSERT INTO `access_log` VALUES (41461, '65.50.15611917842509839', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.231', '2019-06-22 16:23:04', 8, 0, '', '2019-06-22 16:23:04');
INSERT INTO `access_log` VALUES (41462, '65.53.15611917842579817', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.231', '2019-06-22 16:23:04', 9, 2001001000, '服务端发生异常', '2019-06-22 16:23:04');
INSERT INTO `access_log` VALUES (41463, '65.52.15611917842609837', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.231', '2019-06-22 16:23:04', 7, 0, '', '2019-06-22 16:23:04');
INSERT INTO `access_log` VALUES (41464, '59.72.15611919092478865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.244.116.14', '2019-06-22 16:25:09', 3, 0, '', '2019-06-22 16:25:09');
INSERT INTO `access_log` VALUES (41465, '59.74.15611919092498867', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.244.116.14', '2019-06-22 16:25:09', 14, 2001001000, '服务端发生异常', '2019-06-22 16:25:09');
INSERT INTO `access_log` VALUES (41466, '64.85.15611919123358901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.244.116.14', '2019-06-22 16:25:12', 3, 0, '', '2019-06-22 16:25:12');
INSERT INTO `access_log` VALUES (41467, '64.79.15611919124678887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.244.116.14', '2019-06-22 16:25:12', 2, 0, '', '2019-06-22 16:25:12');
INSERT INTO `access_log` VALUES (41468, '64.77.15611919136728883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.244.116.14', '2019-06-22 16:25:14', 2, 0, '', '2019-06-22 16:25:14');
INSERT INTO `access_log` VALUES (41469, '64.83.15611919141998879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.244.116.14', '2019-06-22 16:25:14', 2, 0, '', '2019-06-22 16:25:14');
INSERT INTO `access_log` VALUES (41470, '59.79.15611919162268875', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.244.116.14', '2019-06-22 16:25:16', 3, 0, '', '2019-06-22 16:25:16');
INSERT INTO `access_log` VALUES (41471, '59.76.15611919162268865', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.244.116.14', '2019-06-22 16:25:16', 24, 2001001000, '服务端发生异常', '2019-06-22 16:25:16');
INSERT INTO `access_log` VALUES (41472, '65.53.15611937296249843', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:55:30', 0, 1002001015, '账号未登陆', '2019-06-22 16:55:30');
INSERT INTO `access_log` VALUES (41473, '65.45.15611937296239851', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:55:30', 0, 1002001015, '账号未登陆', '2019-06-22 16:55:30');
INSERT INTO `access_log` VALUES (41474, '65.49.15611937296249851', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:55:30', 1, 1002001015, '账号未登陆', '2019-06-22 16:55:30');
INSERT INTO `access_log` VALUES (41475, '65.51.15611937317559895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:55:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 16:55:32');
INSERT INTO `access_log` VALUES (41476, '65.52.15611937382009865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:55:38', 72, 0, '', '2019-06-22 16:55:38');
INSERT INTO `access_log` VALUES (41477, '65.50.15611937384639865', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:55:38', 11, 0, '', '2019-06-22 16:55:38');
INSERT INTO `access_log` VALUES (41478, '65.54.15611937384709819', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:55:38', 13, 2001001000, '服务端发生异常', '2019-06-22 16:55:38');
INSERT INTO `access_log` VALUES (41479, '65.3607.15611937384741625', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:55:38', 11, 0, '', '2019-06-22 16:55:38');
INSERT INTO `access_log` VALUES (41480, '59.73.15611938602768901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:57:40', 11, 0, '', '2019-06-22 16:57:40');
INSERT INTO `access_log` VALUES (41481, '59.80.15611938602768885', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:57:40', 15, 2001001000, '服务端发生异常', '2019-06-22 16:57:40');
INSERT INTO `access_log` VALUES (41482, '64.78.15611938634908913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:57:43', 9, 0, '', '2019-06-22 16:57:44');
INSERT INTO `access_log` VALUES (41483, '64.82.15611938638388923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:57:44', 3, 0, '', '2019-06-22 16:57:44');
INSERT INTO `access_log` VALUES (41484, '64.81.15611938655208905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:57:46', 1, 0, '', '2019-06-22 16:57:46');
INSERT INTO `access_log` VALUES (41485, '64.80.15611938661718911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:57:46', 2, 0, '', '2019-06-22 16:57:46');
INSERT INTO `access_log` VALUES (41486, '59.71.15611938672558897', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:57:47', 3, 0, '', '2019-06-22 16:57:47');
INSERT INTO `access_log` VALUES (41487, '59.75.15611938672568899', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:57:47', 14, 2001001000, '服务端发生异常', '2019-06-22 16:57:47');
INSERT INTO `access_log` VALUES (41488, '65.46.15611938730599907', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:57:53', 18, 0, '', '2019-06-22 16:57:53');
INSERT INTO `access_log` VALUES (41489, '65.47.15611938730619853', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:57:53', 18, 2001001000, '服务端发生异常', '2019-06-22 16:57:53');
INSERT INTO `access_log` VALUES (41490, '65.53.15611938730739847', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.72.252', '2019-06-22 16:57:53', 8, 0, '', '2019-06-22 16:57:53');
INSERT INTO `access_log` VALUES (41491, '65.50.15611939564289867', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-22 16:59:16', 1, 1002001015, '账号未登陆', '2019-06-22 16:59:16');
INSERT INTO `access_log` VALUES (41492, '65.53.15611939564749849', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-22 16:59:16', 1, 1002001015, '账号未登陆', '2019-06-22 16:59:16');
INSERT INTO `access_log` VALUES (41493, '65.46.15611939564879909', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-22 16:59:16', 0, 1002001015, '账号未登陆', '2019-06-22 16:59:16');
INSERT INTO `access_log` VALUES (41494, '65.51.15611943002489905', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-22 17:05:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 17:05:00');
INSERT INTO `access_log` VALUES (41495, '65.3607.15611943127661635', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-22 17:05:13', 59, 0, '', '2019-06-22 17:05:13');
INSERT INTO `access_log` VALUES (41496, '65.54.15611943131809829', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-22 17:05:13', 9, 0, '', '2019-06-22 17:05:13');
INSERT INTO `access_log` VALUES (41497, '65.50.15611943131859873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-22 17:05:13', 9, 2001001000, '服务端发生异常', '2019-06-22 17:05:13');
INSERT INTO `access_log` VALUES (41498, '65.53.15611943132289855', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-22 17:05:13', 9, 0, '', '2019-06-22 17:05:13');
INSERT INTO `access_log` VALUES (41499, '65.54.15611947336239835', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-22 17:12:14', 11, 0, '', '2019-06-22 17:12:14');
INSERT INTO `access_log` VALUES (41500, '65.53.15611947336239861', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-22 17:12:14', 12, 2001001000, '服务端发生异常', '2019-06-22 17:12:14');
INSERT INTO `access_log` VALUES (41501, '65.46.15611947336279921', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-22 17:12:14', 10, 0, '', '2019-06-22 17:12:14');
INSERT INTO `access_log` VALUES (41502, '59.76.15611948325098905', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-22 17:13:53', 3, 0, '', '2019-06-22 17:13:53');
INSERT INTO `access_log` VALUES (41503, '59.73.15611948325108915', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-22 17:13:53', 19, 2001001000, '服务端发生异常', '2019-06-22 17:13:53');
INSERT INTO `access_log` VALUES (41504, '65.47.15611965179549891', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0; BIDUBrowser 8.7) like Gecko', '183.2.198.55', '2019-06-22 17:41:58', 1, 1002001015, '账号未登陆', '2019-06-22 17:41:58');
INSERT INTO `access_log` VALUES (41505, '65.54.15611965179539859', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0; BIDUBrowser 8.7) like Gecko', '183.2.198.103', '2019-06-22 17:41:58', 0, 1002001015, '账号未登陆', '2019-06-22 17:41:58');
INSERT INTO `access_log` VALUES (41506, '65.45.15611965179719893', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0; BIDUBrowser 8.7) like Gecko', '183.2.198.52', '2019-06-22 17:41:58', 0, 1002001015, '账号未登陆', '2019-06-22 17:41:58');
INSERT INTO `access_log` VALUES (41507, '65.49.15611965245919893', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0; BIDUBrowser 8.7) like Gecko', '183.2.198.103', '2019-06-22 17:42:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 17:42:05');
INSERT INTO `access_log` VALUES (41508, '65.52.15611965337579907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0; BIDUBrowser 8.7) like Gecko', '183.2.198.103', '2019-06-22 17:42:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 17:42:14');
INSERT INTO `access_log` VALUES (41509, '65.53.15612084247960045', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.153.238.142', '2019-06-22 21:00:25', 0, 1002001015, '账号未登陆', '2019-06-22 21:00:25');
INSERT INTO `access_log` VALUES (41510, '65.47.15612084247960051', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.153.238.142', '2019-06-22 21:00:25', 0, 1002001015, '账号未登陆', '2019-06-22 21:00:25');
INSERT INTO `access_log` VALUES (41511, '65.54.15612084248160019', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.153.238.142', '2019-06-22 21:00:25', 0, 1002001015, '账号未登陆', '2019-06-22 21:00:25');
INSERT INTO `access_log` VALUES (41512, '65.45.15612084275990053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.153.238.142', '2019-06-22 21:00:28', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 21:00:28');
INSERT INTO `access_log` VALUES (41513, '65.3607.15612089301021833', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:08:50', 1, 1002001015, '账号未登陆', '2019-06-22 21:08:50');
INSERT INTO `access_log` VALUES (41514, '65.50.15612089301040071', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:08:50', 0, 1002001015, '账号未登陆', '2019-06-22 21:08:50');
INSERT INTO `access_log` VALUES (41515, '65.46.15612089301140113', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:08:50', 0, 1002001015, '账号未登陆', '2019-06-22 21:08:50');
INSERT INTO `access_log` VALUES (41516, '65.47.15612089415880059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:09:02', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 21:09:02');
INSERT INTO `access_log` VALUES (41517, '65.54.15612089480640027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:09:08', 57, 0, '', '2019-06-22 21:09:08');
INSERT INTO `access_log` VALUES (41518, '65.45.15612089484570061', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:09:08', 10, 0, '', '2019-06-22 21:09:08');
INSERT INTO `access_log` VALUES (41519, '65.49.15612089484620061', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:09:08', 8, 2001001000, '服务端发生异常', '2019-06-22 21:09:08');
INSERT INTO `access_log` VALUES (41520, '65.51.15612089484630105', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:09:08', 8, 0, '', '2019-06-22 21:09:08');
INSERT INTO `access_log` VALUES (41521, '59.74.15612090066329097', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:07', 11, 0, '', '2019-06-22 21:10:07');
INSERT INTO `access_log` VALUES (41522, '59.72.15612090066349095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:07', 15, 2001001000, '服务端发生异常', '2019-06-22 21:10:07');
INSERT INTO `access_log` VALUES (41523, '64.81.15612090175259109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:18', 173, 0, '', '2019-06-22 21:10:18');
INSERT INTO `access_log` VALUES (41524, '64.82.15612090179289127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:18', 2, 0, '', '2019-06-22 21:10:18');
INSERT INTO `access_log` VALUES (41525, '64.76.15612090196319101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:20', 2, 0, '', '2019-06-22 21:10:20');
INSERT INTO `access_log` VALUES (41526, '64.77.15612090205269113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:21', 2, 0, '', '2019-06-22 21:10:21');
INSERT INTO `access_log` VALUES (41527, '64.85.15612090213739131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:21', 2, 0, '', '2019-06-22 21:10:21');
INSERT INTO `access_log` VALUES (41528, '64.79.15612090221749119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:22', 2, 0, '', '2019-06-22 21:10:22');
INSERT INTO `access_log` VALUES (41529, '64.83.15612090226159109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:23', 2, 0, '', '2019-06-22 21:10:23');
INSERT INTO `access_log` VALUES (41530, '59.76.15612090242099095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:24', 4, 0, '', '2019-06-22 21:10:24');
INSERT INTO `access_log` VALUES (41531, '59.73.15612090242109105', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:24', 19, 2001001000, '服务端发生异常', '2019-06-22 21:10:24');
INSERT INTO `access_log` VALUES (41532, '64.78.15612090276949117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:28', 2, 0, '', '2019-06-22 21:10:28');
INSERT INTO `access_log` VALUES (41533, '64.80.15612090278629115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:28', 2, 0, '', '2019-06-22 21:10:28');
INSERT INTO `access_log` VALUES (41534, '64.81.15612090291439111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:29', 2, 0, '', '2019-06-22 21:10:29');
INSERT INTO `access_log` VALUES (41535, '64.82.15612090301109129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:30', 2, 0, '', '2019-06-22 21:10:30');
INSERT INTO `access_log` VALUES (41536, '59.71.15612090343789101', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:34', 3, 0, '', '2019-06-22 21:10:34');
INSERT INTO `access_log` VALUES (41537, '59.75.15612090343789103', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:34', 13, 2001001000, '服务端发生异常', '2019-06-22 21:10:34');
INSERT INTO `access_log` VALUES (41538, '64.76.15612090352129103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:35', 2, 0, '', '2019-06-22 21:10:35');
INSERT INTO `access_log` VALUES (41539, '64.77.15612090355509115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:36', 2, 0, '', '2019-06-22 21:10:36');
INSERT INTO `access_log` VALUES (41540, '59.77.15612090390289087', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:39', 3, 0, '', '2019-06-22 21:10:39');
INSERT INTO `access_log` VALUES (41541, '59.78.15612090390289099', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.87.239', '2019-06-22 21:10:39', 14, 2001001000, '服务端发生异常', '2019-06-22 21:10:39');
INSERT INTO `access_log` VALUES (41542, '59.77.15612098901899099', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-06-22 21:24:50', 13, 2001001000, '服务端发生异常', '2019-06-22 21:24:50');
INSERT INTO `access_log` VALUES (41543, '59.75.15612098901859115', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-06-22 21:24:50', 82, 0, '', '2019-06-22 21:24:50');
INSERT INTO `access_log` VALUES (41544, '65.47.15612098983480073', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-06-22 21:24:58', 8, 1002001012, '访问令牌已过期', '2019-06-22 21:24:58');
INSERT INTO `access_log` VALUES (41545, '65.53.15612098983480067', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-06-22 21:24:58', 4, 1002001012, '访问令牌已过期', '2019-06-22 21:24:58');
INSERT INTO `access_log` VALUES (41546, '65.54.15612098983500041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-06-22 21:24:58', 7, 1002001012, '访问令牌已过期', '2019-06-22 21:24:58');
INSERT INTO `access_log` VALUES (41547, '65.49.15612099243020075', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-06-22 21:25:24', 93, 0, '', '2019-06-22 21:25:24');
INSERT INTO `access_log` VALUES (41548, '65.52.15612099249120089', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-06-22 21:25:25', 10, 0, '', '2019-06-22 21:25:25');
INSERT INTO `access_log` VALUES (41549, '65.46.15612099249350129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-06-22 21:25:25', 10, 0, '', '2019-06-22 21:25:25');
INSERT INTO `access_log` VALUES (41550, '65.50.15612099251270087', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-06-22 21:25:25', 10, 2001001000, '服务端发生异常', '2019-06-22 21:25:25');
INSERT INTO `access_log` VALUES (41551, '65.54.15612102683330047', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.65.49.40', '2019-06-22 21:31:08', 4, 1002001012, '访问令牌已过期', '2019-06-22 21:31:08');
INSERT INTO `access_log` VALUES (41552, '65.53.15612102683370073', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.65.49.40', '2019-06-22 21:31:08', 3, 1002001012, '访问令牌已过期', '2019-06-22 21:31:08');
INSERT INTO `access_log` VALUES (41553, '65.45.15612102683420081', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.65.49.40', '2019-06-22 21:31:08', 2, 1002001012, '访问令牌已过期', '2019-06-22 21:31:08');
INSERT INTO `access_log` VALUES (41554, '65.49.15612102742370081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.65.49.40', '2019-06-22 21:31:14', 93, 0, '', '2019-06-22 21:31:14');
INSERT INTO `access_log` VALUES (41555, '65.52.15612102744890095', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.65.49.40', '2019-06-22 21:31:14', 11, 0, '', '2019-06-22 21:31:15');
INSERT INTO `access_log` VALUES (41556, '65.50.15612102744920093', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.65.49.40', '2019-06-22 21:31:14', 11, 0, '', '2019-06-22 21:31:15');
INSERT INTO `access_log` VALUES (41557, '65.46.15612102744910135', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.65.49.40', '2019-06-22 21:31:14', 11, 2001001000, '服务端发生异常', '2019-06-22 21:31:15');
INSERT INTO `access_log` VALUES (41558, '65.45.15612119394450105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-06-22 21:58:59', 11, 0, '', '2019-06-22 21:58:59');
INSERT INTO `access_log` VALUES (41559, '65.49.15612119394450105', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-06-22 21:58:59', 12, 2001001000, '服务端发生异常', '2019-06-22 21:58:59');
INSERT INTO `access_log` VALUES (41560, '65.52.15612119394520119', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-06-22 21:58:59', 10, 0, '', '2019-06-22 21:58:59');
INSERT INTO `access_log` VALUES (41561, '65.3607.15612143976551911', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-22 22:39:58', 1, 1002001015, '账号未登陆', '2019-06-22 22:39:58');
INSERT INTO `access_log` VALUES (41562, '65.51.15612143976550183', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-22 22:39:58', 0, 1002001015, '账号未登陆', '2019-06-22 22:39:58');
INSERT INTO `access_log` VALUES (41563, '65.54.15612143976560105', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-22 22:39:58', 1, 1002001015, '账号未登陆', '2019-06-22 22:39:58');
INSERT INTO `access_log` VALUES (41564, '65.45.15612144015400139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-22 22:40:02', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-22 22:40:02');
INSERT INTO `access_log` VALUES (41565, '65.52.15612144104380153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-22 22:40:10', 85, 0, '', '2019-06-22 22:40:11');
INSERT INTO `access_log` VALUES (41566, '65.46.15612144107680193', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-22 22:40:11', 11, 0, '', '2019-06-22 22:40:11');
INSERT INTO `access_log` VALUES (41567, '65.50.15612144107700151', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-22 22:40:11', 12, 2001001000, '服务端发生异常', '2019-06-22 22:40:11');
INSERT INTO `access_log` VALUES (41568, '65.47.15612144107740137', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-22 22:40:11', 11, 0, '', '2019-06-22 22:40:11');
INSERT INTO `access_log` VALUES (41569, '65.53.15612144178870131', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-22 22:40:18', 11, 0, '', '2019-06-22 22:40:18');
INSERT INTO `access_log` VALUES (41570, '65.3607.15612144178901913', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-22 22:40:18', 11, 2001001000, '服务端发生异常', '2019-06-22 22:40:18');
INSERT INTO `access_log` VALUES (41571, '65.51.15612144178940185', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-22 22:40:18', 11, 0, '', '2019-06-22 22:40:18');
INSERT INTO `access_log` VALUES (41572, '59.79.15612145957609181', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-22 22:43:16', 11, 0, '', '2019-06-22 22:43:16');
INSERT INTO `access_log` VALUES (41573, '59.76.15612145957619171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-22 22:43:16', 15, 2001001000, '服务端发生异常', '2019-06-22 22:43:16');
INSERT INTO `access_log` VALUES (41574, '59.78.15612152665879183', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.190.22', '2019-06-22 22:54:27', 58, 0, '', '2019-06-22 22:54:27');
INSERT INTO `access_log` VALUES (41575, '59.72.15612152666529181', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.190.22', '2019-06-22 22:54:27', 12, 2001001000, '服务端发生异常', '2019-06-22 22:54:27');
INSERT INTO `access_log` VALUES (41576, '59.78.15612159738149193', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.78.218.5', '2019-06-22 23:06:14', 3, 0, '', '2019-06-22 23:06:14');
INSERT INTO `access_log` VALUES (41577, '59.75.15612159738139197', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.78.218.5', '2019-06-22 23:06:14', 12, 2001001000, '服务端发生异常', '2019-06-22 23:06:14');
INSERT INTO `access_log` VALUES (41578, '65.45.15612159811030161', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.78.218.5', '2019-06-22 23:06:21', 0, 1002001015, '账号未登陆', '2019-06-22 23:06:21');
INSERT INTO `access_log` VALUES (41579, '65.52.15612159811030177', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.78.218.5', '2019-06-22 23:06:21', 0, 1002001015, '账号未登陆', '2019-06-22 23:06:21');
INSERT INTO `access_log` VALUES (41580, '65.49.15612159811040163', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.78.218.5', '2019-06-22 23:06:21', 0, 1002001015, '账号未登陆', '2019-06-22 23:06:21');
INSERT INTO `access_log` VALUES (41581, '65.46.15612159881220215', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.78.218.5', '2019-06-22 23:06:28', 4, 1002002000, '账号不存在', '2019-06-22 23:06:28');
INSERT INTO `access_log` VALUES (41582, '65.51.15612159945130209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.78.218.5', '2019-06-22 23:06:35', 67, 0, '', '2019-06-22 23:06:35');
INSERT INTO `access_log` VALUES (41583, '65.47.15612159948260163', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.78.218.5', '2019-06-22 23:06:35', 150, 0, '', '2019-06-22 23:06:35');
INSERT INTO `access_log` VALUES (41584, '65.3607.15612159948411935', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.78.218.5', '2019-06-22 23:06:35', 145, 0, '', '2019-06-22 23:06:35');
INSERT INTO `access_log` VALUES (41585, '65.54.15612159948410131', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.78.218.5', '2019-06-22 23:06:35', 146, 2001001000, '服务端发生异常', '2019-06-22 23:06:35');
INSERT INTO `access_log` VALUES (41586, '59.76.15612206725589253', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.244.140.210', '2019-06-23 00:24:33', 12, 0, '', '2019-06-23 00:24:33');
INSERT INTO `access_log` VALUES (41587, '59.73.15612206725609263', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.244.140.210', '2019-06-23 00:24:33', 15, 2001001000, '服务端发生异常', '2019-06-23 00:24:33');
INSERT INTO `access_log` VALUES (41588, '59.80.15612244147359297', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.4882.400 QQBrowser/9.7.13059.400', '116.21.134.53', '2019-06-23 01:26:55', 13, 0, '', '2019-06-23 01:26:55');
INSERT INTO `access_log` VALUES (41589, '59.71.15612244147359309', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.4882.400 QQBrowser/9.7.13059.400', '116.21.134.53', '2019-06-23 01:26:55', 17, 2001001000, '服务端发生异常', '2019-06-23 01:26:55');
INSERT INTO `access_log` VALUES (41590, '59.72.15612244593139305', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.4882.400 QQBrowser/9.7.13059.400', '116.21.134.53', '2019-06-23 01:27:39', 4, 0, '', '2019-06-23 01:27:39');
INSERT INTO `access_log` VALUES (41591, '59.74.15612244593149307', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.4882.400 QQBrowser/9.7.13059.400', '116.21.134.53', '2019-06-23 01:27:39', 14, 2001001000, '服务端发生异常', '2019-06-23 01:27:39');
INSERT INTO `access_log` VALUES (41592, '64.84.15612244611529315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.4882.400 QQBrowser/9.7.13059.400', '116.21.134.53', '2019-06-23 01:27:41', 9, 0, '', '2019-06-23 01:27:41');
INSERT INTO `access_log` VALUES (41593, '64.77.15612244612619321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.4882.400 QQBrowser/9.7.13059.400', '116.21.134.53', '2019-06-23 01:27:41', 2, 0, '', '2019-06-23 01:27:41');
INSERT INTO `access_log` VALUES (41594, '64.85.15612244625149339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.4882.400 QQBrowser/9.7.13059.400', '116.21.134.53', '2019-06-23 01:27:43', 2, 0, '', '2019-06-23 01:27:43');
INSERT INTO `access_log` VALUES (41595, '64.79.15612244631559327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.4882.400 QQBrowser/9.7.13059.400', '116.21.134.53', '2019-06-23 01:27:43', 2, 0, '', '2019-06-23 01:27:43');
INSERT INTO `access_log` VALUES (41596, '64.78.15612244745309325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.76 Mobile Safari/537.36', '116.21.134.53', '2019-06-23 01:27:55', 2, 0, '', '2019-06-23 01:27:55');
INSERT INTO `access_log` VALUES (41597, '64.80.15612244746699323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.76 Mobile Safari/537.36', '116.21.134.53', '2019-06-23 01:27:55', 2, 0, '', '2019-06-23 01:27:55');
INSERT INTO `access_log` VALUES (41598, '64.81.15612244762809319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.76 Mobile Safari/537.36', '116.21.134.53', '2019-06-23 01:27:56', 2, 0, '', '2019-06-23 01:27:56');
INSERT INTO `access_log` VALUES (41599, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.76 Mobile Safari/537.36', '116.21.134.53', '2019-06-23 01:27:56', 7, 0, '', '2019-06-23 01:27:56');
INSERT INTO `access_log` VALUES (41600, '64.82.15612244780849337', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.76 Mobile Safari/537.36', '116.21.134.53', '2019-06-23 01:27:58', 8, 0, '', '2019-06-23 01:27:58');
INSERT INTO `access_log` VALUES (41601, '64.84.15612244925849317', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.76 Mobile Safari/537.36', '116.21.134.53', '2019-06-23 01:28:13', 6, 0, '', '2019-06-23 01:28:13');
INSERT INTO `access_log` VALUES (41602, '64.77.15612244960259323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.76 Mobile Safari/537.36', '116.21.134.53', '2019-06-23 01:28:16', 2, 0, '', '2019-06-23 01:28:16');
INSERT INTO `access_log` VALUES (41603, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.76 Mobile Safari/537.36', '116.21.134.53', '2019-06-23 01:28:16', 7, 0, '', '2019-06-23 01:28:16');
INSERT INTO `access_log` VALUES (41604, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2490.76 Mobile Safari/537.36', '116.21.134.53', '2019-06-23 01:28:18', 5, 0, '', '2019-06-23 01:28:18');
INSERT INTO `access_log` VALUES (41605, '65.47.15612300207200349', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:00:21', 0, 1002001015, '账号未登陆', '2019-06-23 03:00:21');
INSERT INTO `access_log` VALUES (41606, '65.52.15612300207200371', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:00:21', 0, 1002001015, '账号未登陆', '2019-06-23 03:00:21');
INSERT INTO `access_log` VALUES (41607, '65.49.15612300207220355', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:00:21', 0, 1002001015, '账号未登陆', '2019-06-23 03:00:21');
INSERT INTO `access_log` VALUES (41608, '65.46.15612300244160405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:00:24', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 03:00:24');
INSERT INTO `access_log` VALUES (41609, '65.53.15612300325960345', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:00:33', 80, 0, '', '2019-06-23 03:00:33');
INSERT INTO `access_log` VALUES (41610, '65.50.15612300329960367', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:00:33', 14, 0, '', '2019-06-23 03:00:33');
INSERT INTO `access_log` VALUES (41611, '65.3607.15612300330002127', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:00:33', 13, 2001001000, '服务端发生异常', '2019-06-23 03:00:33');
INSERT INTO `access_log` VALUES (41612, '65.51.15612300330630397', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:00:33', 9, 0, '', '2019-06-23 03:00:33');
INSERT INTO `access_log` VALUES (41613, '59.76.15612301584249381', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:02:38', 11, 0, '', '2019-06-23 03:02:38');
INSERT INTO `access_log` VALUES (41614, '59.79.15612301584249391', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:02:38', 29, 2001001000, '服务端发生异常', '2019-06-23 03:02:38');
INSERT INTO `access_log` VALUES (41615, '64.84.15612301655899393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:02:46', 9, 0, '', '2019-06-23 03:02:46');
INSERT INTO `access_log` VALUES (41616, '64.77.15612301658319399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:02:46', 2, 0, '', '2019-06-23 03:02:46');
INSERT INTO `access_log` VALUES (41617, '65.47.15612302156430353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:03:36', 513, 0, '', '2019-06-23 03:03:36');
INSERT INTO `access_log` VALUES (41618, '65.49.15612302165560359', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:03:37', 11, 0, '', '2019-06-23 03:03:37');
INSERT INTO `access_log` VALUES (41619, '65.45.15612302165580359', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:03:37', 11, 2001001000, '服务端发生异常', '2019-06-23 03:03:37');
INSERT INTO `access_log` VALUES (41620, '65.46.15612302165620409', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.120.228.117', '2019-06-23 03:03:37', 9, 0, '', '2019-06-23 03:03:37');
INSERT INTO `access_log` VALUES (41621, '59.73.15612561116279737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.228.131.154', '2019-06-23 10:15:12', 11, 0, '', '2019-06-23 10:15:12');
INSERT INTO `access_log` VALUES (41622, '59.71.15612561116289733', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.228.131.154', '2019-06-23 10:15:12', 32, 2001001000, '服务端发生异常', '2019-06-23 10:15:12');
INSERT INTO `access_log` VALUES (41623, '65.52.15612565790420731', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:22:59', 3, 1002001012, '访问令牌已过期', '2019-06-23 10:22:59');
INSERT INTO `access_log` VALUES (41624, '65.49.15612565790420713', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:22:59', 4, 1002001012, '访问令牌已过期', '2019-06-23 10:22:59');
INSERT INTO `access_log` VALUES (41625, '65.45.15612565790440713', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:22:59', 4, 1002001012, '访问令牌已过期', '2019-06-23 10:22:59');
INSERT INTO `access_log` VALUES (41626, '65.53.15612565831410703', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:23:03', 85, 0, '', '2019-06-23 10:23:03');
INSERT INTO `access_log` VALUES (41627, '65.54.15612565836730677', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:23:04', 10, 0, '', '2019-06-23 10:23:04');
INSERT INTO `access_log` VALUES (41628, '65.3607.15612565836732485', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:23:04', 11, 2001001000, '服务端发生异常', '2019-06-23 10:23:04');
INSERT INTO `access_log` VALUES (41629, '65.50.15612565837030725', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:23:04', 9, 0, '', '2019-06-23 10:23:04');
INSERT INTO `access_log` VALUES (41630, '65.51.15612565882220753', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:23:08', 9, 0, '', '2019-06-23 10:23:08');
INSERT INTO `access_log` VALUES (41631, '65.47.15612565882240709', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:23:08', 9, 2001001000, '服务端发生异常', '2019-06-23 10:23:08');
INSERT INTO `access_log` VALUES (41632, '65.46.15612565882290765', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:23:08', 9, 0, '', '2019-06-23 10:23:08');
INSERT INTO `access_log` VALUES (41633, '65.49.15612565929080715', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:23:13', 9, 0, '', '2019-06-23 10:23:13');
INSERT INTO `access_log` VALUES (41634, '65.52.15612565929130733', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:23:13', 10, 2001001000, '服务端发生异常', '2019-06-23 10:23:13');
INSERT INTO `access_log` VALUES (41635, '65.53.15612565929150705', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:23:13', 8, 0, '', '2019-06-23 10:23:13');
INSERT INTO `access_log` VALUES (41636, '59.78.15612566067569737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:23:27', 4, 0, '', '2019-06-23 10:23:27');
INSERT INTO `access_log` VALUES (41637, '59.74.15612566067569737', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.120.228.117', '2019-06-23 10:23:27', 23, 2001001000, '服务端发生异常', '2019-06-23 10:23:27');
INSERT INTO `access_log` VALUES (41638, '65.50.15612572323310735', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.71.69.4', '2019-06-23 10:33:52', 0, 1002001015, '账号未登陆', '2019-06-23 10:33:52');
INSERT INTO `access_log` VALUES (41639, '65.47.15612572323320719', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.71.69.4', '2019-06-23 10:33:52', 1, 1002001015, '账号未登陆', '2019-06-23 10:33:52');
INSERT INTO `access_log` VALUES (41640, '65.51.15612572323360763', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.71.69.4', '2019-06-23 10:33:52', 0, 1002001015, '账号未登陆', '2019-06-23 10:33:52');
INSERT INTO `access_log` VALUES (41641, '65.53.15612572761580715', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.71.69.4', '2019-06-23 10:34:36', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 10:34:36');
INSERT INTO `access_log` VALUES (41642, '65.3607.15612572805012497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.71.69.4', '2019-06-23 10:34:41', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 10:34:41');
INSERT INTO `access_log` VALUES (41643, '65.54.15612572862090689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.71.69.4', '2019-06-23 10:34:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 10:34:46');
INSERT INTO `access_log` VALUES (41644, '65.50.15612572865090737', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.71.69.4', '2019-06-23 10:34:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 10:34:47');
INSERT INTO `access_log` VALUES (41645, '65.51.15612572873550765', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.71.69.4', '2019-06-23 10:34:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 10:34:47');
INSERT INTO `access_log` VALUES (41646, '65.47.15612572876780721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.71.69.4', '2019-06-23 10:34:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 10:34:48');
INSERT INTO `access_log` VALUES (41647, '59.78.15612573109539747', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.146', '2019-06-23 10:35:11', 21, 2001001000, '服务端发生异常', '2019-06-23 10:35:11');
INSERT INTO `access_log` VALUES (41648, '59.75.15612573109509751', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.146', '2019-06-23 10:35:11', 75, 0, '', '2019-06-23 10:35:11');
INSERT INTO `access_log` VALUES (41649, '64.79.15612573227119767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.146', '2019-06-23 10:35:23', 9, 0, '', '2019-06-23 10:35:23');
INSERT INTO `access_log` VALUES (41650, '64.83.15612573229529757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.146', '2019-06-23 10:35:23', 3, 0, '', '2019-06-23 10:35:23');
INSERT INTO `access_log` VALUES (41651, '64.78.15612573284659765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.146', '2019-06-23 10:35:28', 2, 0, '', '2019-06-23 10:35:28');
INSERT INTO `access_log` VALUES (41652, '64.80.15612573297699763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.146', '2019-06-23 10:35:30', 1, 0, '', '2019-06-23 10:35:30');
INSERT INTO `access_log` VALUES (41653, '64.82.15612573377699777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:35:38', 1, 0, '', '2019-06-23 10:35:38');
INSERT INTO `access_log` VALUES (41654, '59.79.15612573394349755', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:35:39', 2, 0, '', '2019-06-23 10:35:39');
INSERT INTO `access_log` VALUES (41655, '59.76.15612573394349745', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:35:39', 13, 2001001000, '服务端发生异常', '2019-06-23 10:35:39');
INSERT INTO `access_log` VALUES (41656, '59.77.15612573753549737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:36:15', 2, 0, '', '2019-06-23 10:36:15');
INSERT INTO `access_log` VALUES (41657, '59.80.15612573753549739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:36:15', 19, 2001001000, '服务端发生异常', '2019-06-23 10:36:15');
INSERT INTO `access_log` VALUES (41658, '64.77.15612573796759763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:36:20', 2, 0, '', '2019-06-23 10:36:20');
INSERT INTO `access_log` VALUES (41659, '64.85.15612573799099781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:36:20', 2, 0, '', '2019-06-23 10:36:20');
INSERT INTO `access_log` VALUES (41660, '64.83.15612573821649759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:36:22', 2, 0, '', '2019-06-23 10:36:22');
INSERT INTO `access_log` VALUES (41661, '64.78.15612573839059767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:36:24', 2, 0, '', '2019-06-23 10:36:24');
INSERT INTO `access_log` VALUES (41662, '64.80.15612573859509765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:36:26', 2, 0, '', '2019-06-23 10:36:26');
INSERT INTO `access_log` VALUES (41663, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:36:26', 7, 0, '', '2019-06-23 10:36:26');
INSERT INTO `access_log` VALUES (41664, '64.81.15612573883749761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:36:28', 2, 0, '', '2019-06-23 10:36:28');
INSERT INTO `access_log` VALUES (41665, '64.82.15612573885869779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:36:29', 2, 0, '', '2019-06-23 10:36:29');
INSERT INTO `access_log` VALUES (41666, '64.76.15612573901279753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:36:30', 2, 0, '', '2019-06-23 10:36:30');
INSERT INTO `access_log` VALUES (41667, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:36:30', 7, 0, '', '2019-06-23 10:36:30');
INSERT INTO `access_log` VALUES (41668, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:36:32', 6, 0, '', '2019-06-23 10:36:32');
INSERT INTO `access_log` VALUES (41669, '64.84.15612573943539759', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:36:34', 7, 0, '', '2019-06-23 10:36:34');
INSERT INTO `access_log` VALUES (41670, '64.80.15612574593959767', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:37:39', 7, 0, '', '2019-06-23 10:37:39');
INSERT INTO `access_log` VALUES (41671, '64.81.15612574608499763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '36.102.10.146', '2019-06-23 10:37:41', 2, 0, '', '2019-06-23 10:37:41');
INSERT INTO `access_log` VALUES (41672, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.92.226.192', '2019-06-23 10:37:41', 5, 0, '', '2019-06-23 10:37:41');
INSERT INTO `access_log` VALUES (41673, '64.82.15612574633099781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.92.226.192', '2019-06-23 10:37:43', 2, 0, '', '2019-06-23 10:37:43');
INSERT INTO `access_log` VALUES (41674, '64.76.15612574634369755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.92.226.192', '2019-06-23 10:37:43', 2, 0, '', '2019-06-23 10:37:43');
INSERT INTO `access_log` VALUES (41675, '65.47.15612575645790725', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.71.69.4', '2019-06-23 10:39:25', 102, 0, '', '2019-06-23 10:39:25');
INSERT INTO `access_log` VALUES (41676, '65.46.15612575649360781', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.71.69.4', '2019-06-23 10:39:25', 10, 0, '', '2019-06-23 10:39:25');
INSERT INTO `access_log` VALUES (41677, '65.49.15612575649390731', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.71.69.4', '2019-06-23 10:39:25', 9, 0, '', '2019-06-23 10:39:25');
INSERT INTO `access_log` VALUES (41678, '65.45.15612575649370731', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.71.69.4', '2019-06-23 10:39:25', 12, 2001001000, '服务端发生异常', '2019-06-23 10:39:25');
INSERT INTO `access_log` VALUES (41679, '59.80.15612604934619781', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36', '203.208.60.121', '2019-06-23 11:28:13', 11, 0, '', '2019-06-23 11:28:13');
INSERT INTO `access_log` VALUES (41680, '59.77.15612604942109779', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36', '203.208.60.120', '2019-06-23 11:28:14', 17, 2001001000, '服务端发生异常', '2019-06-23 11:28:14');
INSERT INTO `access_log` VALUES (41681, '65.45.15612626399830799', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.165.116.140', '2019-06-23 12:04:00', 78, 0, '', '2019-06-23 12:04:00');
INSERT INTO `access_log` VALUES (41682, '65.47.15612626404720795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.165.116.140', '2019-06-23 12:04:00', 179, 0, '', '2019-06-23 12:04:01');
INSERT INTO `access_log` VALUES (41683, '65.46.15612626404780849', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.165.116.140', '2019-06-23 12:04:00', 175, 0, '', '2019-06-23 12:04:01');
INSERT INTO `access_log` VALUES (41684, '65.49.15612626404770801', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.165.116.140', '2019-06-23 12:04:00', 176, 2001001000, '服务端发生异常', '2019-06-23 12:04:01');
INSERT INTO `access_log` VALUES (41685, '65.51.15612628624110845', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:07:42', 0, 1002001015, '账号未登陆', '2019-06-23 12:07:42');
INSERT INTO `access_log` VALUES (41686, '65.45.15612628624140803', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:07:42', 0, 1002001015, '账号未登陆', '2019-06-23 12:07:42');
INSERT INTO `access_log` VALUES (41687, '65.49.15612628624170805', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:07:42', 1, 1002001015, '账号未登陆', '2019-06-23 12:07:42');
INSERT INTO `access_log` VALUES (41688, '65.47.15612628641230799', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:07:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 12:07:44');
INSERT INTO `access_log` VALUES (41689, '65.52.15612628747380819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:07:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 12:07:55');
INSERT INTO `access_log` VALUES (41690, '65.50.15612628955470815', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:08:16', 99, 0, '', '2019-06-23 12:08:16');
INSERT INTO `access_log` VALUES (41691, '65.3607.15612628958972577', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:08:16', 11, 0, '', '2019-06-23 12:08:16');
INSERT INTO `access_log` VALUES (41692, '65.54.15612628959000769', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:08:16', 11, 2001001000, '服务端发生异常', '2019-06-23 12:08:16');
INSERT INTO `access_log` VALUES (41693, '65.49.15612628959030807', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:08:16', 9, 0, '', '2019-06-23 12:08:16');
INSERT INTO `access_log` VALUES (41694, '59.79.15612629555669831', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:09:16', 12, 0, '', '2019-06-23 12:09:16');
INSERT INTO `access_log` VALUES (41695, '59.76.15612629555679821', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:09:16', 35, 2001001000, '服务端发生异常', '2019-06-23 12:09:16');
INSERT INTO `access_log` VALUES (41696, '64.81.15612629629069837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:09:23', 10, 0, '', '2019-06-23 12:09:23');
INSERT INTO `access_log` VALUES (41697, '64.82.15612629630649855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:09:23', 2, 0, '', '2019-06-23 12:09:23');
INSERT INTO `access_log` VALUES (41698, '64.76.15612629652019829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:09:25', 2, 0, '', '2019-06-23 12:09:25');
INSERT INTO `access_log` VALUES (41699, '64.84.15612629658819835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:09:26', 2, 0, '', '2019-06-23 12:09:26');
INSERT INTO `access_log` VALUES (41700, '64.77.15612629694949841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:09:29', 2, 0, '', '2019-06-23 12:09:29');
INSERT INTO `access_log` VALUES (41701, '64.85.15612629696269859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:09:30', 2, 0, '', '2019-06-23 12:09:30');
INSERT INTO `access_log` VALUES (41702, '59.80.15612629739369815', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:09:34', 3, 0, '', '2019-06-23 12:09:34');
INSERT INTO `access_log` VALUES (41703, '59.71.15612629739369827', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.69.211.174', '2019-06-23 12:09:34', 14, 2001001000, '服务端发生异常', '2019-06-23 12:09:34');
INSERT INTO `access_log` VALUES (41704, '65.50.15612662559260863', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.166', '2019-06-23 13:04:16', 0, 1002001015, '账号未登陆', '2019-06-23 13:04:16');
INSERT INTO `access_log` VALUES (41705, '65.46.15612662559270899', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.166', '2019-06-23 13:04:16', 1, 1002001015, '账号未登陆', '2019-06-23 13:04:16');
INSERT INTO `access_log` VALUES (41706, '65.52.15612662559490867', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.166', '2019-06-23 13:04:16', 1, 1002001015, '账号未登陆', '2019-06-23 13:04:16');
INSERT INTO `access_log` VALUES (41707, '65.53.15612662594450843', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.166', '2019-06-23 13:04:19', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 13:04:19');
INSERT INTO `access_log` VALUES (41708, '65.3607.15612668628192633', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:14:23', 1, 1002001015, '账号未登陆', '2019-06-23 13:14:23');
INSERT INTO `access_log` VALUES (41709, '65.54.15612668628280823', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:14:23', 0, 1002001015, '账号未登陆', '2019-06-23 13:14:23');
INSERT INTO `access_log` VALUES (41710, '65.47.15612668628170855', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:14:23', 0, 1002001015, '账号未登陆', '2019-06-23 13:14:23');
INSERT INTO `access_log` VALUES (41711, '65.50.15612669061760873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:15:06', 141, 0, '', '2019-06-23 13:15:06');
INSERT INTO `access_log` VALUES (41712, '65.46.15612669065980909', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:15:07', 142, 0, '', '2019-06-23 13:15:07');
INSERT INTO `access_log` VALUES (41713, '65.52.15612669066050877', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:15:07', 309, 2001001000, '服务端发生异常', '2019-06-23 13:15:07');
INSERT INTO `access_log` VALUES (41714, '65.3607.15612669089962635', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:15:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 13:15:09');
INSERT INTO `access_log` VALUES (41715, '65.51.15612669587140901', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:15:59', 79, 0, '', '2019-06-23 13:15:59');
INSERT INTO `access_log` VALUES (41716, '65.49.15612669591440867', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:15:59', 9, 0, '', '2019-06-23 13:15:59');
INSERT INTO `access_log` VALUES (41717, '65.50.15612669591510875', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:15:59', 9, 0, '', '2019-06-23 13:15:59');
INSERT INTO `access_log` VALUES (41718, '65.53.15612669906450855', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:16:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 13:16:31');
INSERT INTO `access_log` VALUES (41719, '65.54.15612670102010827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:16:50', 91, 0, '', '2019-06-23 13:16:50');
INSERT INTO `access_log` VALUES (41720, '65.47.15612670106010859', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:16:51', 10, 0, '', '2019-06-23 13:16:51');
INSERT INTO `access_log` VALUES (41721, '65.45.15612670106050861', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:16:51', 11, 2001001000, '服务端发生异常', '2019-06-23 13:16:51');
INSERT INTO `access_log` VALUES (41722, '65.51.15612670106090903', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:16:51', 10, 0, '', '2019-06-23 13:16:51');
INSERT INTO `access_log` VALUES (41723, '59.73.15612671199999887', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.145.82.204', '2019-06-23 13:18:40', 13, 0, '', '2019-06-23 13:18:40');
INSERT INTO `access_log` VALUES (41724, '59.80.15612671199999871', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.145.82.204', '2019-06-23 13:18:40', 17, 2001001000, '服务端发生异常', '2019-06-23 13:18:40');
INSERT INTO `access_log` VALUES (41725, '65.51.15612672566270907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.166', '2019-06-23 13:20:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 13:20:57');
INSERT INTO `access_log` VALUES (41726, '65.47.15612672725610863', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.166', '2019-06-23 13:21:13', 63, 0, '', '2019-06-23 13:21:13');
INSERT INTO `access_log` VALUES (41727, '65.50.15612672729690881', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.166', '2019-06-23 13:21:13', 10, 0, '', '2019-06-23 13:21:13');
INSERT INTO `access_log` VALUES (41728, '65.49.15612672729700873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.166', '2019-06-23 13:21:13', 11, 2001001000, '服务端发生异常', '2019-06-23 13:21:13');
INSERT INTO `access_log` VALUES (41729, '65.46.15612672730090917', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.53.166', '2019-06-23 13:21:13', 10, 0, '', '2019-06-23 13:21:13');
INSERT INTO `access_log` VALUES (41730, '65.47.15612712668900917', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCJB; rv:11.0) like Gecko', '111.196.207.89', '2019-06-23 14:27:47', 1, 1002001015, '账号未登陆', '2019-06-23 14:27:47');
INSERT INTO `access_log` VALUES (41731, '65.49.15612712668910927', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCJB; rv:11.0) like Gecko', '111.196.207.89', '2019-06-23 14:27:47', 1, 1002001015, '账号未登陆', '2019-06-23 14:27:47');
INSERT INTO `access_log` VALUES (41732, '65.50.15612712668900935', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCJB; rv:11.0) like Gecko', '111.196.207.89', '2019-06-23 14:27:47', 1, 1002001015, '账号未登陆', '2019-06-23 14:27:47');
INSERT INTO `access_log` VALUES (41733, '65.52.15612712836140939', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCJB; rv:11.0) like Gecko', '111.196.207.89', '2019-06-23 14:28:04', 101, 0, '', '2019-06-23 14:28:04');
INSERT INTO `access_log` VALUES (41734, '65.3607.15612712968702697', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCJB; rv:11.0) like Gecko', '111.196.207.89', '2019-06-23 14:28:17', 96, 0, '', '2019-06-23 14:28:17');
INSERT INTO `access_log` VALUES (41735, '65.54.15612714440180889', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCJB; rv:11.0) like Gecko', '111.196.207.89', '2019-06-23 14:30:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 14:30:44');
INSERT INTO `access_log` VALUES (41736, '65.51.15612714522120965', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCJB; rv:11.0) like Gecko', '111.196.207.89', '2019-06-23 14:30:52', 79, 0, '', '2019-06-23 14:30:52');
INSERT INTO `access_log` VALUES (41737, '65.45.15612714526110923', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCJB; rv:11.0) like Gecko', '111.196.207.89', '2019-06-23 14:30:53', 101, 0, '', '2019-06-23 14:30:53');
INSERT INTO `access_log` VALUES (41738, '65.50.15612714526190939', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCJB; rv:11.0) like Gecko', '111.196.207.89', '2019-06-23 14:30:53', 96, 0, '', '2019-06-23 14:30:53');
INSERT INTO `access_log` VALUES (41739, '65.49.15612714526300931', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCJB; rv:11.0) like Gecko', '111.196.207.89', '2019-06-23 14:30:53', 86, 0, '', '2019-06-23 14:30:53');
INSERT INTO `access_log` VALUES (41740, '62.83.15612714596269533', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCJB; rv:11.0) like Gecko', '111.196.207.89', '2019-06-23 14:31:00', 33, 0, '', '2019-06-23 14:31:00');
INSERT INTO `access_log` VALUES (41741, '62.85.15612714627129517', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCJB; rv:11.0) like Gecko', '111.196.207.89', '2019-06-23 14:31:03', 23, 0, '', '2019-06-23 14:31:03');
INSERT INTO `access_log` VALUES (41742, '64.77.15612714657029955', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCJB; rv:11.0) like Gecko', '111.196.207.89', '2019-06-23 14:31:06', 20, 0, '', '2019-06-23 14:31:06');
INSERT INTO `access_log` VALUES (41743, '64.84.15612714656989949', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCJB; rv:11.0) like Gecko', '111.196.207.89', '2019-06-23 14:31:06', 25, 0, '', '2019-06-23 14:31:06');
INSERT INTO `access_log` VALUES (41744, '65.49.15612739936130969', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.36.73.166', '2019-06-23 15:13:14', 1, 1002001015, '账号未登陆', '2019-06-23 15:13:14');
INSERT INTO `access_log` VALUES (41745, '65.51.15612739936131001', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.36.73.166', '2019-06-23 15:13:14', 0, 1002001015, '账号未登陆', '2019-06-23 15:13:14');
INSERT INTO `access_log` VALUES (41746, '65.50.15612739936130975', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.36.73.166', '2019-06-23 15:13:14', 0, 1002001015, '账号未登陆', '2019-06-23 15:13:14');
INSERT INTO `access_log` VALUES (41747, '65.49.15612775981001019', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:13:18', 0, 1002001015, '账号未登陆', '2019-06-23 16:13:18');
INSERT INTO `access_log` VALUES (41748, '65.50.15612775981001023', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:13:18', 0, 1002001015, '账号未登陆', '2019-06-23 16:13:18');
INSERT INTO `access_log` VALUES (41749, '65.47.15612775981021005', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:13:18', 0, 1002001015, '账号未登陆', '2019-06-23 16:13:18');
INSERT INTO `access_log` VALUES (41750, '65.53.15612776268441007', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:13:47', 90, 0, '', '2019-06-23 16:13:47');
INSERT INTO `access_log` VALUES (41751, '65.54.15612776271370977', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:13:47', 14, 0, '', '2019-06-23 16:13:47');
INSERT INTO `access_log` VALUES (41752, '65.46.15612776271361057', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:13:47', 17, 0, '', '2019-06-23 16:13:47');
INSERT INTO `access_log` VALUES (41753, '65.52.15612776271361027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:13:47', 18, 2001001000, '服务端发生异常', '2019-06-23 16:13:47');
INSERT INTO `access_log` VALUES (41754, '65.50.15612776347991025', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:13:55', 9, 0, '', '2019-06-23 16:13:55');
INSERT INTO `access_log` VALUES (41755, '65.49.15612776348051021', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:13:55', 10, 0, '', '2019-06-23 16:13:55');
INSERT INTO `access_log` VALUES (41756, '65.47.15612776348061007', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:13:55', 11, 2001001000, '服务端发生异常', '2019-06-23 16:13:55');
INSERT INTO `access_log` VALUES (41757, '65.3607.15612776460822785', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:06', 9, 0, '', '2019-06-23 16:14:06');
INSERT INTO `access_log` VALUES (41758, '65.45.15612776460861011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:06', 8, 0, '', '2019-06-23 16:14:06');
INSERT INTO `access_log` VALUES (41759, '65.53.15612776460871009', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:06', 10, 2001001000, '服务端发生异常', '2019-06-23 16:14:06');
INSERT INTO `access_log` VALUES (41760, '65.46.15612776468281059', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:07', 17, 0, '', '2019-06-23 16:14:07');
INSERT INTO `access_log` VALUES (41761, '65.52.15612776468451029', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:07', 9, 0, '', '2019-06-23 16:14:07');
INSERT INTO `access_log` VALUES (41762, '65.54.15612776468450979', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:07', 9, 2001001000, '服务端发生异常', '2019-06-23 16:14:07');
INSERT INTO `access_log` VALUES (41763, '65.51.15612776471321053', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:07', 8, 0, '', '2019-06-23 16:14:07');
INSERT INTO `access_log` VALUES (41764, '65.50.15612776471321027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:07', 8, 2001001000, '服务端发生异常', '2019-06-23 16:14:07');
INSERT INTO `access_log` VALUES (41765, '65.47.15612776471371009', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:07', 7, 0, '', '2019-06-23 16:14:07');
INSERT INTO `access_log` VALUES (41766, '65.49.15612776475641023', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:08', 9, 0, '', '2019-06-23 16:14:08');
INSERT INTO `access_log` VALUES (41767, '65.45.15612776475661013', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:08', 9, 0, '', '2019-06-23 16:14:08');
INSERT INTO `access_log` VALUES (41768, '65.3607.15612776475652787', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:08', 9, 2001001000, '服务端发生异常', '2019-06-23 16:14:08');
INSERT INTO `access_log` VALUES (41769, '59.78.15612776559380021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:16', 11, 0, '', '2019-06-23 16:14:16');
INSERT INTO `access_log` VALUES (41770, '59.75.15612776559390025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:16', 14, 2001001000, '服务端发生异常', '2019-06-23 16:14:16');
INSERT INTO `access_log` VALUES (41771, '64.78.15612776637900041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:24', 11, 0, '', '2019-06-23 16:14:24');
INSERT INTO `access_log` VALUES (41772, '64.80.15612776638880039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:24', 2, 0, '', '2019-06-23 16:14:24');
INSERT INTO `access_log` VALUES (41773, '64.81.15612776681120035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:28', 2, 0, '', '2019-06-23 16:14:28');
INSERT INTO `access_log` VALUES (41774, '64.82.15612776682140053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:14:28', 2, 0, '', '2019-06-23 16:14:28');
INSERT INTO `access_log` VALUES (41775, '65.50.15612781445741035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:22:25', 11, 0, '', '2019-06-23 16:22:25');
INSERT INTO `access_log` VALUES (41776, '65.47.15612781445751017', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:22:25', 11, 0, '', '2019-06-23 16:22:25');
INSERT INTO `access_log` VALUES (41777, '65.51.15612781445741061', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-23 16:22:25', 12, 2001001000, '服务端发生异常', '2019-06-23 16:22:25');
INSERT INTO `access_log` VALUES (41778, '59.75.15612781862980035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.72.41.251', '2019-06-23 16:23:06', 5, 0, '', '2019-06-23 16:23:06');
INSERT INTO `access_log` VALUES (41779, '59.71.15612781864150033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.72.41.251', '2019-06-23 16:23:06', 12, 2001001000, '服务端发生异常', '2019-06-23 16:23:06');
INSERT INTO `access_log` VALUES (41780, '65.51.15612788653501071', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:34:25', 1, 1002001015, '账号未登陆', '2019-06-23 16:34:25');
INSERT INTO `access_log` VALUES (41781, '65.47.15612788653501027', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:34:25', 1, 1002001015, '账号未登陆', '2019-06-23 16:34:25');
INSERT INTO `access_log` VALUES (41782, '65.49.15612788653501041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:34:25', 0, 1002001015, '账号未登陆', '2019-06-23 16:34:25');
INSERT INTO `access_log` VALUES (41783, '65.3607.15612788700282805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:34:30', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 16:34:30');
INSERT INTO `access_log` VALUES (41784, '65.53.15612788842091029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:34:44', 135, 0, '', '2019-06-23 16:34:44');
INSERT INTO `access_log` VALUES (41785, '65.46.15612788852421079', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:34:45', 8, 0, '', '2019-06-23 16:34:45');
INSERT INTO `access_log` VALUES (41786, '65.52.15612788852801049', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:34:45', 9, 2001001000, '服务端发生异常', '2019-06-23 16:34:45');
INSERT INTO `access_log` VALUES (41787, '65.54.15612788853040999', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:34:45', 8, 0, '', '2019-06-23 16:34:45');
INSERT INTO `access_log` VALUES (41788, '65.49.15612788946071043', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:34:55', 9, 0, '', '2019-06-23 16:34:55');
INSERT INTO `access_log` VALUES (41789, '65.47.15612788946201029', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:34:55', 9, 2001001000, '服务端发生异常', '2019-06-23 16:34:55');
INSERT INTO `access_log` VALUES (41790, '65.51.15612788946231073', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:34:55', 9, 0, '', '2019-06-23 16:34:55');
INSERT INTO `access_log` VALUES (41791, '65.46.15612789463151081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:35:46', 112, 0, '', '2019-06-23 16:35:46');
INSERT INTO `access_log` VALUES (41792, '65.54.15612789467631001', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:35:47', 10, 2001001000, '服务端发生异常', '2019-06-23 16:35:47');
INSERT INTO `access_log` VALUES (41793, '65.52.15612789467611051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:35:47', 12, 0, '', '2019-06-23 16:35:47');
INSERT INTO `access_log` VALUES (41794, '65.50.15612789467711049', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:35:47', 9, 0, '', '2019-06-23 16:35:47');
INSERT INTO `access_log` VALUES (41795, '65.47.15612789550091031', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:35:55', 9, 0, '', '2019-06-23 16:35:55');
INSERT INTO `access_log` VALUES (41796, '65.51.15612789550151075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:35:55', 9, 2001001000, '服务端发生异常', '2019-06-23 16:35:55');
INSERT INTO `access_log` VALUES (41797, '65.3607.15612789550182809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.88.200', '2019-06-23 16:35:55', 8, 0, '', '2019-06-23 16:35:55');
INSERT INTO `access_log` VALUES (41798, '65.50.15612813380151081', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.246.3.172', '2019-06-23 17:15:38', 1, 1002001015, '账号未登陆', '2019-06-23 17:15:38');
INSERT INTO `access_log` VALUES (41799, '65.52.15612813380091085', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.246.3.172', '2019-06-23 17:15:38', 0, 1002001015, '账号未登陆', '2019-06-23 17:15:38');
INSERT INTO `access_log` VALUES (41800, '65.46.15612813380081115', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.246.3.172', '2019-06-23 17:15:38', 0, 1002001015, '账号未登陆', '2019-06-23 17:15:38');
INSERT INTO `access_log` VALUES (41801, '65.3607.15612813404852843', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.246.3.172', '2019-06-23 17:15:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 17:15:40');
INSERT INTO `access_log` VALUES (41802, '65.47.15612813568501065', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.246.3.172', '2019-06-23 17:15:57', 80, 0, '', '2019-06-23 17:15:57');
INSERT INTO `access_log` VALUES (41803, '65.54.15612813571771035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.246.3.172', '2019-06-23 17:15:57', 60, 0, '', '2019-06-23 17:15:57');
INSERT INTO `access_log` VALUES (41804, '65.45.15612813571851069', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.246.3.172', '2019-06-23 17:15:57', 52, 0, '', '2019-06-23 17:15:57');
INSERT INTO `access_log` VALUES (41805, '65.53.15612813571811065', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.246.3.172', '2019-06-23 17:15:57', 59, 2001001000, '服务端发生异常', '2019-06-23 17:15:57');
INSERT INTO `access_log` VALUES (41806, '65.47.15612873029241145', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.114.112.196', '2019-06-23 18:55:03', 0, 1002001015, '账号未登陆', '2019-06-23 18:55:03');
INSERT INTO `access_log` VALUES (41807, '65.54.15612873029241115', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.114.112.196', '2019-06-23 18:55:03', 0, 1002001015, '账号未登陆', '2019-06-23 18:55:03');
INSERT INTO `access_log` VALUES (41808, '65.53.15612873029241145', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.114.112.196', '2019-06-23 18:55:03', 0, 1002001015, '账号未登陆', '2019-06-23 18:55:03');
INSERT INTO `access_log` VALUES (41809, '65.45.15612873051121149', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.114.112.196', '2019-06-23 18:55:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 18:55:05');
INSERT INTO `access_log` VALUES (41810, '65.52.15612873105711167', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.114.112.196', '2019-06-23 18:55:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 18:55:11');
INSERT INTO `access_log` VALUES (41811, '65.46.15612873171001197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.114.112.196', '2019-06-23 18:55:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 18:55:17');
INSERT INTO `access_log` VALUES (41812, '65.49.15612873238181161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.114.112.196', '2019-06-23 18:55:24', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 18:55:24');
INSERT INTO `access_log` VALUES (41813, '59.76.15612876487220153', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.114.112.196', '2019-06-23 19:00:49', 21, 0, '', '2019-06-23 19:00:49');
INSERT INTO `access_log` VALUES (41814, '59.77.15612876487240143', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.114.112.196', '2019-06-23 19:00:49', 15, 2001001000, '服务端发生异常', '2019-06-23 19:00:49');
INSERT INTO `access_log` VALUES (41815, '64.78.15612876526920175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.114.112.196', '2019-06-23 19:00:53', 14, 0, '', '2019-06-23 19:00:53');
INSERT INTO `access_log` VALUES (41816, '64.80.15612876529480173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.114.112.196', '2019-06-23 19:00:53', 3, 0, '', '2019-06-23 19:00:53');
INSERT INTO `access_log` VALUES (41817, '64.81.15612876540430169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.114.112.196', '2019-06-23 19:00:54', 2, 0, '', '2019-06-23 19:00:54');
INSERT INTO `access_log` VALUES (41818, '64.82.15612876544990187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.114.112.196', '2019-06-23 19:00:55', 2, 0, '', '2019-06-23 19:00:55');
INSERT INTO `access_log` VALUES (41819, '66.51.15612876577548425', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.114.112.196', '2019-06-23 19:00:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字', '2019-06-23 19:00:58');
INSERT INTO `access_log` VALUES (41820, '64.77.15612876724150173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:01:12', 2, 0, '', '2019-06-23 19:01:12');
INSERT INTO `access_log` VALUES (41821, '64.84.15612876725640167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:01:13', 2, 0, '', '2019-06-23 19:01:13');
INSERT INTO `access_log` VALUES (41822, '59.74.15612876745510157', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:01:15', 4, 0, '', '2019-06-23 19:01:15');
INSERT INTO `access_log` VALUES (41823, '59.72.15612876745520155', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:01:15', 13, 2001001000, '服务端发生异常', '2019-06-23 19:01:15');
INSERT INTO `access_log` VALUES (41824, '64.85.15612876760560191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:01:16', 1, 0, '', '2019-06-23 19:01:16');
INSERT INTO `access_log` VALUES (41825, '64.79.15612876761760179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:01:16', 1, 0, '', '2019-06-23 19:01:16');
INSERT INTO `access_log` VALUES (41826, '64.83.15612876770250169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:01:17', 2, 0, '', '2019-06-23 19:01:17');
INSERT INTO `access_log` VALUES (41827, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:01:17', 7, 0, '', '2019-06-23 19:01:17');
INSERT INTO `access_log` VALUES (41828, '64.78.15612876803290177', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:01:20', 8, 0, '', '2019-06-23 19:01:20');
INSERT INTO `access_log` VALUES (41829, '66.50.15612877002008403', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18181108112', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:01:40', 90, 0, '', '2019-06-23 19:01:40');
INSERT INTO `access_log` VALUES (41830, '66.48.15612877175528417', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18181108112&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:01:58', 151, 0, '', '2019-06-23 19:01:58');
INSERT INTO `access_log` VALUES (41831, '66.57.15612877187348417', 134, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:01:59', 6, 0, '', '2019-06-23 19:01:59');
INSERT INTO `access_log` VALUES (41832, '66.51.15612877243508427', 134, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:02:04', 6, 0, '', '2019-06-23 19:02:04');
INSERT INTO `access_log` VALUES (41833, '66.50.15612877472028405', 134, 1, 'user-application', '/user-api/users/address/add', 'name=sdf&tel=19181109112&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=dsfds&isDefault=true&address=dsfds&areaNo=110101&mobile=19181109112&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:02:27', 129, 2001001000, '服务端发生异常', '2019-06-23 19:02:27');
INSERT INTO `access_log` VALUES (41834, '66.57.15612877909908419', 134, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:03:11', 7, 0, '', '2019-06-23 19:03:11');
INSERT INTO `access_log` VALUES (41835, '66.55.15612877913278409', 134, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:03:11', 6, 0, '', '2019-06-23 19:03:11');
INSERT INTO `access_log` VALUES (41836, '64.78.15612877920180179', 134, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:03:12', 10, 0, '', '2019-06-23 19:03:12');
INSERT INTO `access_log` VALUES (41837, '64.81.15612877922270173', 134, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:03:12', 5, 0, '', '2019-06-23 19:03:12');
INSERT INTO `access_log` VALUES (41838, 'N/A', 134, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:03:12', 10, 0, '', '2019-06-23 19:03:12');
INSERT INTO `access_log` VALUES (41839, '64.76.15612877924260165', 134, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:03:12', 6, 0, '', '2019-06-23 19:03:12');
INSERT INTO `access_log` VALUES (41840, '64.77.15612877925530177', 134, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:03:13', 27, 0, '', '2019-06-23 19:03:13');
INSERT INTO `access_log` VALUES (41841, '59.78.15612877926280157', 134, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:03:13', 8, 0, '', '2019-06-23 19:03:13');
INSERT INTO `access_log` VALUES (41842, '59.73.15612877926680165', 134, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:03:13', 22, 2001001000, '服务端发生异常', '2019-06-23 19:03:13');
INSERT INTO `access_log` VALUES (41843, '64.84.15612877928040171', 134, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:03:13', 14, 0, '', '2019-06-23 19:03:13');
INSERT INTO `access_log` VALUES (41844, '64.85.15612877929250195', 134, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:03:13', 6, 0, '', '2019-06-23 19:03:13');
INSERT INTO `access_log` VALUES (41845, '59.71.15612877929920163', 134, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:03:13', 6, 0, '', '2019-06-23 19:03:13');
INSERT INTO `access_log` VALUES (41846, '59.75.15612877929920165', 134, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:03:13', 39, 2001001000, '服务端发生异常', '2019-06-23 19:03:13');
INSERT INTO `access_log` VALUES (41847, '65.53.15612897401231177', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.132.249.0', '2019-06-23 19:35:40', 0, 1002001015, '账号未登陆', '2019-06-23 19:35:40');
INSERT INTO `access_log` VALUES (41848, '65.51.15612897401231225', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.132.249.0', '2019-06-23 19:35:40', 0, 1002001015, '账号未登陆', '2019-06-23 19:35:40');
INSERT INTO `access_log` VALUES (41849, '65.47.15612897401361179', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.132.249.0', '2019-06-23 19:35:40', 0, 1002001015, '账号未登陆', '2019-06-23 19:35:40');
INSERT INTO `access_log` VALUES (41850, '65.54.15612897482111151', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.84.110.81', '2019-06-23 19:35:48', 119, 0, '', '2019-06-23 19:35:48');
INSERT INTO `access_log` VALUES (41851, '65.45.15612897489631185', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.132.249.0', '2019-06-23 19:35:49', 11, 0, '', '2019-06-23 19:35:49');
INSERT INTO `access_log` VALUES (41852, '65.50.15612897489871199', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.84.110.80', '2019-06-23 19:35:49', 11, 0, '', '2019-06-23 19:35:49');
INSERT INTO `access_log` VALUES (41853, '65.52.15612897489881201', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.84.110.81', '2019-06-23 19:35:49', 12, 2001001000, '服务端发生异常', '2019-06-23 19:35:49');
INSERT INTO `access_log` VALUES (41854, '65.3607.15612897633722961', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.84.110.80', '2019-06-23 19:36:03', 17, 0, '', '2019-06-23 19:36:03');
INSERT INTO `access_log` VALUES (41855, '65.51.15612897633781227', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.84.110.81', '2019-06-23 19:36:03', 11, 2001001000, '服务端发生异常', '2019-06-23 19:36:03');
INSERT INTO `access_log` VALUES (41856, '65.49.15612897633771195', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '182.84.110.81', '2019-06-23 19:36:03', 12, 0, '', '2019-06-23 19:36:03');
INSERT INTO `access_log` VALUES (41857, '65.45.15612984295131305', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'xiaomiquan/4.2.1 Android/Phone/9 HUAWEI_MHA-AL00', '111.221.174.161', '2019-06-23 22:00:30', 0, 1002001015, '账号未登陆', '2019-06-23 22:00:30');
INSERT INTO `access_log` VALUES (41858, '65.46.15612984295131349', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'xiaomiquan/4.2.1 Android/Phone/9 HUAWEI_MHA-AL00', '111.221.174.161', '2019-06-23 22:00:30', 1, 1002001015, '账号未登陆', '2019-06-23 22:00:30');
INSERT INTO `access_log` VALUES (41859, '65.3607.15612984295293079', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'xiaomiquan/4.2.1 Android/Phone/9 HUAWEI_MHA-AL00', '111.221.174.161', '2019-06-23 22:00:30', 0, 1002001015, '账号未登陆', '2019-06-23 22:00:30');
INSERT INTO `access_log` VALUES (41860, '65.50.15612984453411317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'xiaomiquan/4.2.1 Android/Phone/9 HUAWEI_MHA-AL00', '111.221.174.161', '2019-06-23 22:00:45', 101, 0, '', '2019-06-23 22:00:45');
INSERT INTO `access_log` VALUES (41861, '65.53.15612984459361299', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'xiaomiquan/4.2.1 Android/Phone/9 HUAWEI_MHA-AL00', '111.221.174.161', '2019-06-23 22:00:46', 11, 0, '', '2019-06-23 22:00:46');
INSERT INTO `access_log` VALUES (41862, '65.52.15612984459501319', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'xiaomiquan/4.2.1 Android/Phone/9 HUAWEI_MHA-AL00', '111.221.174.161', '2019-06-23 22:00:46', 10, 2001001000, '服务端发生异常', '2019-06-23 22:00:46');
INSERT INTO `access_log` VALUES (41863, '65.54.15612984459641271', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'xiaomiquan/4.2.1 Android/Phone/9 HUAWEI_MHA-AL00', '111.221.174.161', '2019-06-23 22:00:46', 9, 0, '', '2019-06-23 22:00:46');
INSERT INTO `access_log` VALUES (41864, '59.74.15612996885110319', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '113.100.63.183', '2019-06-23 22:21:29', 11, 0, '', '2019-06-23 22:21:29');
INSERT INTO `access_log` VALUES (41865, '59.79.15612996885100325', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '113.100.63.183', '2019-06-23 22:21:29', 16, 2001001000, '服务端发生异常', '2019-06-23 22:21:29');
INSERT INTO `access_log` VALUES (41866, '59.80.15612997806880309', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:23:01', 3, 0, '', '2019-06-23 22:23:01');
INSERT INTO `access_log` VALUES (41867, '59.76.15612997806880317', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:23:01', 11, 2001001000, '服务端发生异常', '2019-06-23 22:23:01');
INSERT INTO `access_log` VALUES (41868, '59.73.15612998167000327', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:23:37', 3, 0, '', '2019-06-23 22:23:37');
INSERT INTO `access_log` VALUES (41869, '59.78.15612998167000319', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:23:37', 12, 2001001000, '服务端发生异常', '2019-06-23 22:23:37');
INSERT INTO `access_log` VALUES (41870, '64.78.15612998207080341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:23:41', 153, 0, '', '2019-06-23 22:23:41');
INSERT INTO `access_log` VALUES (41871, '64.80.15612998210700339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:23:41', 2, 0, '', '2019-06-23 22:23:41');
INSERT INTO `access_log` VALUES (41872, '64.81.15612998227820335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '113.100.63.183', '2019-06-23 22:23:43', 1, 0, '', '2019-06-23 22:23:43');
INSERT INTO `access_log` VALUES (41873, '64.82.15612998229280353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '113.100.63.183', '2019-06-23 22:23:43', 9, 0, '', '2019-06-23 22:23:43');
INSERT INTO `access_log` VALUES (41874, '66.49.15612998323048581', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15575752952&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:23:52', 17, 1001003000, '验证码不存在', '2019-06-23 22:23:52');
INSERT INTO `access_log` VALUES (41875, '66.50.15612998348118567', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15575752952', 'POST', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:23:55', 81, 0, '', '2019-06-23 22:23:55');
INSERT INTO `access_log` VALUES (41876, '66.54.15612998659528583', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15575752952&code=', 'POST', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-23 22:24:26');
INSERT INTO `access_log` VALUES (41877, '66.57.15612998698348581', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15575752952&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:30', 160, 0, '', '2019-06-23 22:24:30');
INSERT INTO `access_log` VALUES (41878, '64.79.15612998738820345', 135, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:34', 9, 0, '', '2019-06-23 22:24:34');
INSERT INTO `access_log` VALUES (41879, '64.78.15612998743480343', 135, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:34', 5, 0, '', '2019-06-23 22:24:34');
INSERT INTO `access_log` VALUES (41880, '64.81.15612998763380337', 135, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:36', 6, 0, '', '2019-06-23 22:24:36');
INSERT INTO `access_log` VALUES (41881, '64.82.15612998764920355', 135, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:36', 6, 0, '', '2019-06-23 22:24:36');
INSERT INTO `access_log` VALUES (41882, '66.56.15612998777418585', 135, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:38', 7, 0, '', '2019-06-23 22:24:38');
INSERT INTO `access_log` VALUES (41883, '59.79.15612998811960329', 135, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:41', 7, 0, '', '2019-06-23 22:24:41');
INSERT INTO `access_log` VALUES (41884, '59.72.15612998812010321', 135, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:41', 16, 2001001000, '服务端发生异常', '2019-06-23 22:24:41');
INSERT INTO `access_log` VALUES (41885, 'N/A', 135, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:44', 13, 0, '', '2019-06-23 22:24:44');
INSERT INTO `access_log` VALUES (41886, 'N/A', 135, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:44', 13, 0, '', '2019-06-23 22:24:44');
INSERT INTO `access_log` VALUES (41887, '59.73.15612998867580329', 135, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:47', 6, 0, '', '2019-06-23 22:24:47');
INSERT INTO `access_log` VALUES (41888, '59.78.15612998867600321', 135, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:47', 15, 2001001000, '服务端发生异常', '2019-06-23 22:24:47');
INSERT INTO `access_log` VALUES (41889, '64.76.15612998881470329', 135, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:48', 6, 0, '', '2019-06-23 22:24:48');
INSERT INTO `access_log` VALUES (41890, '64.77.15612998882860341', 135, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:48', 5, 0, '', '2019-06-23 22:24:48');
INSERT INTO `access_log` VALUES (41891, '59.75.15612998891560329', 135, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:49', 7, 0, '', '2019-06-23 22:24:49');
INSERT INTO `access_log` VALUES (41892, '59.77.15612998891570311', 135, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:49', 23, 2001001000, '服务端发生异常', '2019-06-23 22:24:49');
INSERT INTO `access_log` VALUES (41893, '64.85.15612998909610359', 135, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:51', 5, 0, '', '2019-06-23 22:24:51');
INSERT INTO `access_log` VALUES (41894, '64.79.15612998911070347', 135, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:51', 4, 0, '', '2019-06-23 22:24:51');
INSERT INTO `access_log` VALUES (41895, '59.80.15612998915380313', 135, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:52', 7, 0, '', '2019-06-23 22:24:52');
INSERT INTO `access_log` VALUES (41896, '59.76.15612998915420321', 135, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:52', 14, 2001001000, '服务端发生异常', '2019-06-23 22:24:52');
INSERT INTO `access_log` VALUES (41897, '66.49.15612998921828583', 135, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2S Build/OPR1.170623.032; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4368 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/WIFI Language/zh_CN', '116.22.148.173', '2019-06-23 22:24:52', 5, 0, '', '2019-06-23 22:24:52');
INSERT INTO `access_log` VALUES (41898, '65.52.15612999028701339', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:25:03', 1, 1002001015, '账号未登陆', '2019-06-23 22:25:03');
INSERT INTO `access_log` VALUES (41899, '65.54.15612999028701291', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:25:03', 0, 1002001015, '账号未登陆', '2019-06-23 22:25:03');
INSERT INTO `access_log` VALUES (41900, '65.53.15612999028771319', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:25:03', 0, 1002001015, '账号未登陆', '2019-06-23 22:25:03');
INSERT INTO `access_log` VALUES (41901, '65.49.15612999207451333', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:25:21', 191, 0, '', '2019-06-23 22:25:21');
INSERT INTO `access_log` VALUES (41902, '65.3607.15612999215023101', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:25:22', 10, 0, '', '2019-06-23 22:25:22');
INSERT INTO `access_log` VALUES (41903, '65.46.15612999215081371', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:25:22', 18, 2001001000, '服务端发生异常', '2019-06-23 22:25:22');
INSERT INTO `access_log` VALUES (41904, '65.45.15612999215111327', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:25:22', 17, 0, '', '2019-06-23 22:25:22');
INSERT INTO `access_log` VALUES (41905, '65.52.15612999394931341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:25:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 22:25:40');
INSERT INTO `access_log` VALUES (41906, '65.53.15612999475581321', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:25:48', 4, 1002002001, '密码不正确', '2019-06-23 22:25:48');
INSERT INTO `access_log` VALUES (41907, '65.51.15612999547331365', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin134&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:25:55', 239, 0, '', '2019-06-23 22:25:55');
INSERT INTO `access_log` VALUES (41908, '65.49.15612999552991335', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:25:55', 8, 0, '', '2019-06-23 22:25:55');
INSERT INTO `access_log` VALUES (41909, '65.3607.15612999553083103', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:25:55', 8, 0, '', '2019-06-23 22:25:55');
INSERT INTO `access_log` VALUES (41910, '65.46.15612999553111373', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:25:55', 8, 0, '', '2019-06-23 22:25:55');
INSERT INTO `access_log` VALUES (41911, '65.45.15612999633991329', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '113.100.63.183', '2019-06-23 22:26:03', 1, 1002001015, '账号未登陆', '2019-06-23 22:26:03');
INSERT INTO `access_log` VALUES (41912, '65.47.15612999634031321', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '113.100.63.183', '2019-06-23 22:26:03', 0, 1002001015, '账号未登陆', '2019-06-23 22:26:03');
INSERT INTO `access_log` VALUES (41913, '65.50.15612999634111341', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '113.100.63.183', '2019-06-23 22:26:03', 0, 1002001015, '账号未登陆', '2019-06-23 22:26:03');
INSERT INTO `access_log` VALUES (41914, '59.71.15612999751810329', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:26:15', 18, 0, '', '2019-06-23 22:26:15');
INSERT INTO `access_log` VALUES (41915, '65.53.15612999816371323', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '113.100.63.183', '2019-06-23 22:26:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 22:26:22');
INSERT INTO `access_log` VALUES (41916, '65.51.15612999955691367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '113.100.63.183', '2019-06-23 22:26:36', 111, 0, '', '2019-06-23 22:26:36');
INSERT INTO `access_log` VALUES (41917, '65.49.15612999960691337', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '113.100.63.183', '2019-06-23 22:26:36', 9, 0, '', '2019-06-23 22:26:36');
INSERT INTO `access_log` VALUES (41918, '65.46.15612999960691375', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '113.100.63.183', '2019-06-23 22:26:36', 10, 2001001000, '服务端发生异常', '2019-06-23 22:26:36');
INSERT INTO `access_log` VALUES (41919, '65.3607.15612999960883105', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '113.100.63.183', '2019-06-23 22:26:36', 9, 0, '', '2019-06-23 22:26:36');
INSERT INTO `access_log` VALUES (41920, '66.55.15613001260058575', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:28:46', 13, 0, '', '2019-06-23 22:28:46');
INSERT INTO `access_log` VALUES (41921, '65.47.15613001422721325', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:29:02', 35, 0, '', '2019-06-23 22:29:02');
INSERT INTO `access_log` VALUES (41922, '65.45.15613001434141333', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:29:03', 13, 0, '', '2019-06-23 22:29:03');
INSERT INTO `access_log` VALUES (41923, '62.86.15613002243699893', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-23 22:30:24', 92, 0, '', '2019-06-23 22:30:24');
INSERT INTO `access_log` VALUES (41924, '65.52.15613002992011349', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.194.213', '2019-06-23 22:31:39', 1, 1002001015, '账号未登陆', '2019-06-23 22:31:39');
INSERT INTO `access_log` VALUES (41925, '65.53.15613002992061329', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.194.212', '2019-06-23 22:31:39', 0, 1002001015, '账号未登陆', '2019-06-23 22:31:39');
INSERT INTO `access_log` VALUES (41926, '65.54.15613002992321301', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.98.33.146', '2019-06-23 22:31:39', 0, 1002001015, '账号未登陆', '2019-06-23 22:31:39');
INSERT INTO `access_log` VALUES (41927, '65.51.15613003135561373', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.98.33.146', '2019-06-23 22:31:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 22:31:54');
INSERT INTO `access_log` VALUES (41928, '65.49.15613003173561343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.98.33.146', '2019-06-23 22:31:57', 106, 0, '', '2019-06-23 22:31:57');
INSERT INTO `access_log` VALUES (41929, '65.47.15613003178641329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.194.213', '2019-06-23 22:31:58', 9, 0, '', '2019-06-23 22:31:58');
INSERT INTO `access_log` VALUES (41930, '65.3607.15613003178643111', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.194.213', '2019-06-23 22:31:58', 10, 2001001000, '服务端发生异常', '2019-06-23 22:31:58');
INSERT INTO `access_log` VALUES (41931, '65.45.15613003178771337', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.98.33.146', '2019-06-23 22:31:58', 8, 0, '', '2019-06-23 22:31:58');
INSERT INTO `access_log` VALUES (41932, '59.72.15613021427680353', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:02:23', 15, 0, '', '2019-06-23 23:02:23');
INSERT INTO `access_log` VALUES (41933, '59.79.15613021427690361', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:02:23', 17, 2001001000, '服务端发生异常', '2019-06-23 23:02:23');
INSERT INTO `access_log` VALUES (41934, '64.83.15613021488100367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:02:29', 10, 0, '', '2019-06-23 23:02:29');
INSERT INTO `access_log` VALUES (41935, '64.78.15613021489370375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:02:29', 2, 0, '', '2019-06-23 23:02:29');
INSERT INTO `access_log` VALUES (41936, '64.80.15613021521330373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:02:32', 2, 0, '', '2019-06-23 23:02:32');
INSERT INTO `access_log` VALUES (41937, '64.81.15613021522320369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:02:32', 2, 0, '', '2019-06-23 23:02:32');
INSERT INTO `access_log` VALUES (41938, '59.78.15613021656290353', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:02:46', 3, 0, '', '2019-06-23 23:02:46');
INSERT INTO `access_log` VALUES (41939, '59.71.15613021656310359', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:02:46', 19, 2001001000, '服务端发生异常', '2019-06-23 23:02:46');
INSERT INTO `access_log` VALUES (41940, '65.51.15613021809911399', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:03:01', 0, 1002001015, '账号未登陆', '2019-06-23 23:03:01');
INSERT INTO `access_log` VALUES (41941, '65.46.15613021809911407', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:03:01', 0, 1002001015, '账号未登陆', '2019-06-23 23:03:01');
INSERT INTO `access_log` VALUES (41942, '65.49.15613021809921369', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:03:01', 0, 1002001015, '账号未登陆', '2019-06-23 23:03:01');
INSERT INTO `access_log` VALUES (41943, '65.3607.15613021837563137', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:03:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 23:03:04');
INSERT INTO `access_log` VALUES (41944, '65.47.15613021895271355', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:03:10', 57, 0, '', '2019-06-23 23:03:10');
INSERT INTO `access_log` VALUES (41945, '65.50.15613021898651375', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:03:10', 11, 0, '', '2019-06-23 23:03:10');
INSERT INTO `access_log` VALUES (41946, '65.53.15613021898871357', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:03:10', 9, 0, '', '2019-06-23 23:03:10');
INSERT INTO `access_log` VALUES (41947, '65.52.15613021898781377', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:03:10', 18, 2001001000, '服务端发生异常', '2019-06-23 23:03:10');
INSERT INTO `access_log` VALUES (41948, '65.54.15613022036961329', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:03:24', 9, 0, '', '2019-06-23 23:03:24');
INSERT INTO `access_log` VALUES (41949, '65.46.15613022036991409', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:03:24', 9, 2001001000, '服务端发生异常', '2019-06-23 23:03:24');
INSERT INTO `access_log` VALUES (41950, '65.49.15613022037041371', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:03:24', 8, 0, '', '2019-06-23 23:03:24');
INSERT INTO `access_log` VALUES (41951, '65.47.15613022396181357', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:04:00', 9, 0, '', '2019-06-23 23:04:00');
INSERT INTO `access_log` VALUES (41952, '65.53.15613022396201359', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:04:00', 10, 2001001000, '服务端发生异常', '2019-06-23 23:04:00');
INSERT INTO `access_log` VALUES (41953, '65.52.15613022396271379', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:04:00', 9, 0, '', '2019-06-23 23:04:00');
INSERT INTO `access_log` VALUES (41954, '65.50.15613022478491377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:04:08', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-23 23:04:08');
INSERT INTO `access_log` VALUES (41955, '65.49.15613022530701373', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:04:13', 84, 0, '', '2019-06-23 23:04:13');
INSERT INTO `access_log` VALUES (41956, '65.54.15613022533771331', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:04:13', 18, 0, '', '2019-06-23 23:04:13');
INSERT INTO `access_log` VALUES (41957, '65.51.15613022533781403', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:04:13', 18, 0, '', '2019-06-23 23:04:13');
INSERT INTO `access_log` VALUES (41958, '65.3607.15613022533843141', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:04:13', 9, 0, '', '2019-06-23 23:04:13');
INSERT INTO `access_log` VALUES (41959, '62.82.15613022658599939', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:04:26', 22, 0, '', '2019-06-23 23:04:26');
INSERT INTO `access_log` VALUES (41960, '64.81.15613022712840371', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:04:31', 9, 0, '', '2019-06-23 23:04:31');
INSERT INTO `access_log` VALUES (41961, '64.80.15613022712820375', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:04:31', 16, 0, '', '2019-06-23 23:04:31');
INSERT INTO `access_log` VALUES (41962, '64.77.15613022834060375', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:04:43', 12, 0, '', '2019-06-23 23:04:43');
INSERT INTO `access_log` VALUES (41963, '64.84.15613022834110369', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:04:43', 12, 0, '', '2019-06-23 23:04:43');
INSERT INTO `access_log` VALUES (41964, '64.76.15613022834030363', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:04:43', 21, 0, '', '2019-06-23 23:04:43');
INSERT INTO `access_log` VALUES (41965, '64.79.15613023013500381', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:05:01', 11, 0, '', '2019-06-23 23:05:01');
INSERT INTO `access_log` VALUES (41966, '66.48.15613023094638615', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:05:09', 19, 0, '', '2019-06-23 23:05:09');
INSERT INTO `access_log` VALUES (41967, '59.77.15613023233350345', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:05:23', 15, 0, '', '2019-06-23 23:05:23');
INSERT INTO `access_log` VALUES (41968, '59.80.15613023279340347', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:05:28', 22, 2001001000, '服务端发生异常', '2019-06-23 23:05:28');
INSERT INTO `access_log` VALUES (41969, '65.46.15613023343441413', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:05:34', 18, 0, '', '2019-06-23 23:05:34');
INSERT INTO `access_log` VALUES (41970, '65.51.15613023578751405', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:05:58', 25, 0, '', '2019-06-23 23:05:58');
INSERT INTO `access_log` VALUES (41971, '65.3607.15613023605443143', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:06:01', 9, 0, '', '2019-06-23 23:06:01');
INSERT INTO `access_log` VALUES (41972, '65.45.15613023631121369', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.189.160', '2019-06-23 23:06:03', 12, 0, '', '2019-06-23 23:06:03');
INSERT INTO `access_log` VALUES (41973, '65.3607.15613360495823593', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 08:27:30', 17, 1002001012, '访问令牌已过期', '2019-06-24 08:27:30');
INSERT INTO `access_log` VALUES (41974, '65.45.15613360495821819', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 08:27:30', 19, 1002001012, '访问令牌已过期', '2019-06-24 08:27:30');
INSERT INTO `access_log` VALUES (41975, '65.52.15613360495821833', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 08:27:30', 20, 1002001012, '访问令牌已过期', '2019-06-24 08:27:30');
INSERT INTO `access_log` VALUES (41976, '62.83.15613360497320395', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 08:27:30', 8, 1002001012, '访问令牌已过期', '2019-06-24 08:27:30');
INSERT INTO `access_log` VALUES (41977, '65.53.15613360519831813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 08:27:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 08:27:32');
INSERT INTO `access_log` VALUES (41978, '65.47.15613360567411809', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 08:27:37', 92, 0, '', '2019-06-24 08:27:37');
INSERT INTO `access_log` VALUES (41979, '65.50.15613360570831831', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 08:27:37', 9, 0, '', '2019-06-24 08:27:37');
INSERT INTO `access_log` VALUES (41980, '65.46.15613360570881865', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 08:27:37', 8, 0, '', '2019-06-24 08:27:37');
INSERT INTO `access_log` VALUES (41981, '65.49.15613360570921827', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 08:27:37', 7, 0, '', '2019-06-24 08:27:37');
INSERT INTO `access_log` VALUES (41982, '65.51.15613410182291925', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.86.193.173', '2019-06-24 09:50:18', 0, 1002001015, '账号未登陆', '2019-06-24 09:50:18');
INSERT INTO `access_log` VALUES (41983, '65.54.15613410182291851', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.86.193.173', '2019-06-24 09:50:18', 1, 1002001015, '账号未登陆', '2019-06-24 09:50:18');
INSERT INTO `access_log` VALUES (41984, '65.45.15613410182301887', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.86.193.173', '2019-06-24 09:50:18', 0, 1002001015, '账号未登陆', '2019-06-24 09:50:18');
INSERT INTO `access_log` VALUES (41985, '65.3607.15613410200673661', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.86.193.173', '2019-06-24 09:50:20', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 09:50:20');
INSERT INTO `access_log` VALUES (41986, '59.74.15613410357430875', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.110.229.135', '2019-06-24 09:50:36', 10, 0, '', '2019-06-24 09:50:36');
INSERT INTO `access_log` VALUES (41987, '59.72.15613410357440873', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.110.229.135', '2019-06-24 09:50:36', 15, 2001001000, '服务端发生异常', '2019-06-24 09:50:36');
INSERT INTO `access_log` VALUES (41988, '65.53.15613410532391881', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.86.193.173', '2019-06-24 09:50:53', 94, 0, '', '2019-06-24 09:50:53');
INSERT INTO `access_log` VALUES (41989, '65.46.15613410536091933', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.86.193.173', '2019-06-24 09:50:54', 12, 0, '', '2019-06-24 09:50:54');
INSERT INTO `access_log` VALUES (41990, '65.49.15613410536101897', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.86.193.173', '2019-06-24 09:50:54', 12, 0, '', '2019-06-24 09:50:54');
INSERT INTO `access_log` VALUES (41991, '65.50.15613410536101901', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.86.193.173', '2019-06-24 09:50:54', 13, 2001001000, '服务端发生异常', '2019-06-24 09:50:54');
INSERT INTO `access_log` VALUES (41992, '65.45.15613410626351889', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.86.193.173', '2019-06-24 09:51:03', 20, 0, '', '2019-06-24 09:51:03');
INSERT INTO `access_log` VALUES (41993, '65.54.15613410626351853', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.86.193.173', '2019-06-24 09:51:03', 20, 2001001000, '服务端发生异常', '2019-06-24 09:51:03');
INSERT INTO `access_log` VALUES (41994, '65.3607.15613410626373663', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.86.193.173', '2019-06-24 09:51:03', 18, 0, '', '2019-06-24 09:51:03');
INSERT INTO `access_log` VALUES (41995, '65.46.15613416935971943', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:01:34', 13, 1002001012, '访问令牌已过期', '2019-06-24 10:01:34');
INSERT INTO `access_log` VALUES (41996, '65.49.15613416935971907', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:01:34', 12, 1002001012, '访问令牌已过期', '2019-06-24 10:01:34');
INSERT INTO `access_log` VALUES (41997, '65.53.15613416935961891', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:01:34', 13, 1002001012, '访问令牌已过期', '2019-06-24 10:01:34');
INSERT INTO `access_log` VALUES (41998, '65.50.15613416957071911', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:01:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 10:01:36');
INSERT INTO `access_log` VALUES (41999, '65.54.15613417007601863', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:01:41', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 10:01:41');
INSERT INTO `access_log` VALUES (42000, '65.45.15613417080011899', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:01:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 10:01:48');
INSERT INTO `access_log` VALUES (42001, '65.52.15613417282791915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:08', 59, 0, '', '2019-06-24 10:02:08');
INSERT INTO `access_log` VALUES (42002, '65.47.15613417285541887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:09', 9, 0, '', '2019-06-24 10:02:09');
INSERT INTO `access_log` VALUES (42003, '65.53.15613417285571893', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:09', 9, 0, '', '2019-06-24 10:02:09');
INSERT INTO `access_log` VALUES (42004, '65.46.15613417285561945', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:09', 9, 2001001000, '服务端发生异常', '2019-06-24 10:02:09');
INSERT INTO `access_log` VALUES (42005, '65.50.15613417402961913', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:20', 10, 0, '', '2019-06-24 10:02:20');
INSERT INTO `access_log` VALUES (42006, '65.51.15613417403011939', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:20', 10, 2001001000, '服务端发生异常', '2019-06-24 10:02:20');
INSERT INTO `access_log` VALUES (42007, '65.54.15613417403041865', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:20', 8, 0, '', '2019-06-24 10:02:20');
INSERT INTO `access_log` VALUES (42008, '65.3607.15613417571753675', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:37', 9, 0, '', '2019-06-24 10:02:37');
INSERT INTO `access_log` VALUES (42009, '65.53.15613417571791895', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:37', 8, 0, '', '2019-06-24 10:02:37');
INSERT INTO `access_log` VALUES (42010, '65.52.15613417571791917', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:37', 10, 2001001000, '服务端发生异常', '2019-06-24 10:02:37');
INSERT INTO `access_log` VALUES (42011, '65.46.15613417579671947', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:38', 9, 0, '', '2019-06-24 10:02:38');
INSERT INTO `access_log` VALUES (42012, '65.47.15613417579681889', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:38', 10, 2001001000, '服务端发生异常', '2019-06-24 10:02:38');
INSERT INTO `access_log` VALUES (42013, '65.49.15613417579741911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:38', 9, 0, '', '2019-06-24 10:02:38');
INSERT INTO `access_log` VALUES (42014, '65.54.15613417587061867', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:39', 8, 0, '', '2019-06-24 10:02:39');
INSERT INTO `access_log` VALUES (42015, '65.51.15613417587091941', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:39', 8, 0, '', '2019-06-24 10:02:39');
INSERT INTO `access_log` VALUES (42016, '65.50.15613417587091915', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:02:39', 9, 2001001000, '服务端发生异常', '2019-06-24 10:02:39');
INSERT INTO `access_log` VALUES (42017, '65.52.15613417939221919', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:03:14', 9, 0, '', '2019-06-24 10:03:14');
INSERT INTO `access_log` VALUES (42018, '65.47.15613417939231891', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:03:14', 10, 2001001000, '服务端发生异常', '2019-06-24 10:03:14');
INSERT INTO `access_log` VALUES (42019, '65.49.15613417939241913', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:03:14', 8, 0, '', '2019-06-24 10:03:14');
INSERT INTO `access_log` VALUES (42020, '65.46.15613417944551949', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:03:14', 7, 0, '', '2019-06-24 10:03:14');
INSERT INTO `access_log` VALUES (42021, '65.51.15613417944581943', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:03:14', 8, 0, '', '2019-06-24 10:03:14');
INSERT INTO `access_log` VALUES (42022, '65.50.15613417944571917', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:03:14', 8, 2001001000, '服务端发生异常', '2019-06-24 10:03:14');
INSERT INTO `access_log` VALUES (42023, '65.54.15613417955091869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:03:16', 9, 0, '', '2019-06-24 10:03:16');
INSERT INTO `access_log` VALUES (42024, '65.45.15613417955111905', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:03:16', 10, 2001001000, '服务端发生异常', '2019-06-24 10:03:16');
INSERT INTO `access_log` VALUES (42025, '65.3607.15613417955133679', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.41.4', '2019-06-24 10:03:16', 8, 0, '', '2019-06-24 10:03:16');
INSERT INTO `access_log` VALUES (42026, '65.54.15613420459721873', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-24 10:07:26', 4, 1002001012, '访问令牌已过期', '2019-06-24 10:07:26');
INSERT INTO `access_log` VALUES (42027, '65.45.15613420459741909', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-24 10:07:26', 3, 1002001012, '访问令牌已过期', '2019-06-24 10:07:26');
INSERT INTO `access_log` VALUES (42028, '65.3607.15613420459833683', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-24 10:07:26', 3, 1002001012, '访问令牌已过期', '2019-06-24 10:07:26');
INSERT INTO `access_log` VALUES (42029, '65.53.15613420560401903', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-24 10:07:36', 67, 0, '', '2019-06-24 10:07:36');
INSERT INTO `access_log` VALUES (42030, '65.49.15613420564651919', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-24 10:07:36', 447, 0, '', '2019-06-24 10:07:37');
INSERT INTO `access_log` VALUES (42031, '65.52.15613420565181925', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-24 10:07:37', 395, 0, '', '2019-06-24 10:07:37');
INSERT INTO `access_log` VALUES (42032, '65.47.15613420564741897', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.246.90', '2019-06-24 10:07:36', 442, 2001001000, '服务端发生异常', '2019-06-24 10:07:37');
INSERT INTO `access_log` VALUES (42033, '65.51.15613460559222003', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 11:14:16', 32, 1002001012, '访问令牌已过期', '2019-06-24 11:14:16');
INSERT INTO `access_log` VALUES (42034, '65.47.15613460559191949', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 11:14:16', 35, 1002001012, '访问令牌已过期', '2019-06-24 11:14:16');
INSERT INTO `access_log` VALUES (42035, '65.46.15613460559192007', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 11:14:16', 35, 1002001012, '访问令牌已过期', '2019-06-24 11:14:16');
INSERT INTO `access_log` VALUES (42036, '65.45.15613460605621965', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 11:14:21', 71, 0, '', '2019-06-24 11:14:21');
INSERT INTO `access_log` VALUES (42037, '65.54.15613460609271929', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 11:14:21', 11, 0, '', '2019-06-24 11:14:21');
INSERT INTO `access_log` VALUES (42038, '65.50.15613460609351977', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 11:14:21', 11, 0, '', '2019-06-24 11:14:21');
INSERT INTO `access_log` VALUES (42039, '65.3607.15613460609363739', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 11:14:21', 11, 0, '', '2019-06-24 11:14:21');
INSERT INTO `access_log` VALUES (42040, '65.53.15613460637081959', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 11:14:24', 18, 0, '', '2019-06-24 11:14:24');
INSERT INTO `access_log` VALUES (42041, '65.49.15613460718971975', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 11:14:32', 14, 0, '', '2019-06-24 11:14:32');
INSERT INTO `access_log` VALUES (42042, '65.51.15613460793122005', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 11:14:39', 9, 0, '', '2019-06-24 11:14:39');
INSERT INTO `access_log` VALUES (42043, '65.47.15613460865501951', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.22.148.173', '2019-06-24 11:14:47', 17, 0, '', '2019-06-24 11:14:47');
INSERT INTO `access_log` VALUES (42044, '65.49.15613464693621981', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.113.89.88', '2019-06-24 11:21:09', 0, 1002001015, '账号未登陆', '2019-06-24 11:21:09');
INSERT INTO `access_log` VALUES (42045, '65.46.15613464693692015', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.113.89.88', '2019-06-24 11:21:09', 0, 1002001015, '账号未登陆', '2019-06-24 11:21:09');
INSERT INTO `access_log` VALUES (42046, '65.51.15613464693732011', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.113.89.88', '2019-06-24 11:21:09', 1, 1002001015, '账号未登陆', '2019-06-24 11:21:09');
INSERT INTO `access_log` VALUES (42047, '65.47.15613464769201957', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.113.89.88', '2019-06-24 11:21:17', 891, 0, '', '2019-06-24 11:21:18');
INSERT INTO `access_log` VALUES (42048, '65.45.15613464781111973', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.113.89.88', '2019-06-24 11:21:18', 9, 0, '', '2019-06-24 11:21:18');
INSERT INTO `access_log` VALUES (42049, '65.3607.15613464781173747', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.113.89.88', '2019-06-24 11:21:18', 8, 2001001000, '服务端发生异常', '2019-06-24 11:21:18');
INSERT INTO `access_log` VALUES (42050, '65.54.15613464781611937', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.113.89.88', '2019-06-24 11:21:18', 9, 0, '', '2019-06-24 11:21:18');
INSERT INTO `access_log` VALUES (42051, '59.71.15613464837570951', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:21:24', 11, 0, '', '2019-06-24 11:21:24');
INSERT INTO `access_log` VALUES (42052, '59.75.15613464837580953', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:21:24', 15, 2001001000, '服务端发生异常', '2019-06-24 11:21:24');
INSERT INTO `access_log` VALUES (42053, '65.52.15613464862721989', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.113.89.88', '2019-06-24 11:21:26', 9, 0, '', '2019-06-24 11:21:26');
INSERT INTO `access_log` VALUES (42054, '65.53.15613464862721967', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.113.89.88', '2019-06-24 11:21:26', 11, 2001001000, '服务端发生异常', '2019-06-24 11:21:26');
INSERT INTO `access_log` VALUES (42055, '65.46.15613464862752017', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.113.89.88', '2019-06-24 11:21:26', 9, 0, '', '2019-06-24 11:21:26');
INSERT INTO `access_log` VALUES (42056, '64.81.15613464876250965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:21:28', 11, 0, '', '2019-06-24 11:21:28');
INSERT INTO `access_log` VALUES (42057, '64.80.15613464877390967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:21:28', 2, 0, '', '2019-06-24 11:21:28');
INSERT INTO `access_log` VALUES (42058, '64.82.15613464891000979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:21:29', 2, 0, '', '2019-06-24 11:21:29');
INSERT INTO `access_log` VALUES (42059, '64.84.15613464897160959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:21:30', 2, 0, '', '2019-06-24 11:21:30');
INSERT INTO `access_log` VALUES (42060, '59.77.15613464925300935', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:21:33', 4, 0, '', '2019-06-24 11:21:33');
INSERT INTO `access_log` VALUES (42061, '59.80.15613464925310937', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:21:33', 15, 2001001000, '服务端发生异常', '2019-06-24 11:21:33');
INSERT INTO `access_log` VALUES (42062, '65.51.15613465006792013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:21:41', 0, 1002001015, '账号未登陆', '2019-06-24 11:21:41');
INSERT INTO `access_log` VALUES (42063, '65.47.15613465006871959', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:21:41', 1, 1002001015, '账号未登陆', '2019-06-24 11:21:41');
INSERT INTO `access_log` VALUES (42064, '65.3607.15613465006933749', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:21:41', 1, 1002001015, '账号未登陆', '2019-06-24 11:21:41');
INSERT INTO `access_log` VALUES (42065, '65.45.15613465026691975', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:21:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 11:21:43');
INSERT INTO `access_log` VALUES (42066, '65.50.15613465211521987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:22:01', 106, 0, '', '2019-06-24 11:22:01');
INSERT INTO `access_log` VALUES (42067, '65.53.15613465215941969', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:22:02', 8, 0, '', '2019-06-24 11:22:02');
INSERT INTO `access_log` VALUES (42068, '65.46.15613465216002019', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:22:02', 9, 2001001000, '服务端发生异常', '2019-06-24 11:22:02');
INSERT INTO `access_log` VALUES (42069, '65.52.15613465216041991', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:22:02', 8, 0, '', '2019-06-24 11:22:02');
INSERT INTO `access_log` VALUES (42070, '65.51.15613465465962015', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:22:27', 9, 0, '', '2019-06-24 11:22:27');
INSERT INTO `access_log` VALUES (42071, '65.3607.15613465466013751', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:22:27', 10, 2001001000, '服务端发生异常', '2019-06-24 11:22:27');
INSERT INTO `access_log` VALUES (42072, '65.45.15613465466061977', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:22:27', 8, 0, '', '2019-06-24 11:22:27');
INSERT INTO `access_log` VALUES (42073, '65.54.15613465500491941', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:22:30', 17, 0, '', '2019-06-24 11:22:30');
INSERT INTO `access_log` VALUES (42074, '65.50.15613465500551989', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:22:30', 16, 2001001000, '服务端发生异常', '2019-06-24 11:22:30');
INSERT INTO `access_log` VALUES (42075, '65.46.15613465500652021', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:22:30', 7, 0, '', '2019-06-24 11:22:30');
INSERT INTO `access_log` VALUES (42076, '65.52.15613465521631993', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:22:32', 9, 0, '', '2019-06-24 11:22:32');
INSERT INTO `access_log` VALUES (42077, '65.53.15613465521681971', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:22:32', 10, 2001001000, '服务端发生异常', '2019-06-24 11:22:32');
INSERT INTO `access_log` VALUES (42078, '65.49.15613465521711987', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.181.113', '2019-06-24 11:22:32', 8, 0, '', '2019-06-24 11:22:32');
INSERT INTO `access_log` VALUES (42079, '59.75.15613536347011049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-06-24 13:20:35', 15, 2001001000, '服务端发生异常', '2019-06-24 13:20:35');
INSERT INTO `access_log` VALUES (42080, '59.77.15613536347051031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-06-24 13:20:35', 18, 0, '', '2019-06-24 13:20:35');
INSERT INTO `access_log` VALUES (42081, '65.47.15613552699022079', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-06-24 13:47:50', 7, 1002001012, '访问令牌已过期', '2019-06-24 13:47:50');
INSERT INTO `access_log` VALUES (42082, '65.49.15613552699022105', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-06-24 13:47:50', 8, 1002001012, '访问令牌已过期', '2019-06-24 13:47:50');
INSERT INTO `access_log` VALUES (42083, '65.45.15613552699022095', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-06-24 13:47:50', 10, 1002001012, '访问令牌已过期', '2019-06-24 13:47:50');
INSERT INTO `access_log` VALUES (42084, '65.51.15613552720542133', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-06-24 13:47:52', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 13:47:52');
INSERT INTO `access_log` VALUES (42085, '65.3607.15613554771923873', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.212.226', '2019-06-24 13:51:17', 0, 1002001015, '账号未登陆', '2019-06-24 13:51:17');
INSERT INTO `access_log` VALUES (42086, '65.52.15613554771962113', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.212.226', '2019-06-24 13:51:17', 0, 1002001015, '账号未登陆', '2019-06-24 13:51:17');
INSERT INTO `access_log` VALUES (42087, '65.45.15613554772032099', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.212.226', '2019-06-24 13:51:17', 0, 1002001015, '账号未登陆', '2019-06-24 13:51:17');
INSERT INTO `access_log` VALUES (42088, '65.47.15613554793182083', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.212.226', '2019-06-24 13:51:19', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 13:51:19');
INSERT INTO `access_log` VALUES (42089, '65.49.15613554806332109', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.212.226', '2019-06-24 13:51:21', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 13:51:21');
INSERT INTO `access_log` VALUES (42090, '65.46.15613554870072145', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.212.226', '2019-06-24 13:51:27', 65, 0, '', '2019-06-24 13:51:27');
INSERT INTO `access_log` VALUES (42091, '65.50.15613554874172115', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.212.226', '2019-06-24 13:51:27', 12, 0, '', '2019-06-24 13:51:27');
INSERT INTO `access_log` VALUES (42092, '65.53.15613554874242093', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.212.226', '2019-06-24 13:51:27', 10, 2001001000, '服务端发生异常', '2019-06-24 13:51:27');
INSERT INTO `access_log` VALUES (42093, '65.54.15613554874362063', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.212.226', '2019-06-24 13:51:27', 9, 0, '', '2019-06-24 13:51:27');
INSERT INTO `access_log` VALUES (42094, '65.46.15613560005552153', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.227', '2019-06-24 14:00:01', 1, 1002001015, '账号未登陆', '2019-06-24 14:00:01');
INSERT INTO `access_log` VALUES (42095, '65.50.15613560050592123', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.91.62.99', '2019-06-24 14:00:05', 0, 1002001015, '账号未登陆', '2019-06-24 14:00:05');
INSERT INTO `access_log` VALUES (42096, '65.54.15613560126002071', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.227.139.161', '2019-06-24 14:00:13', 1, 1002001015, '账号未登陆', '2019-06-24 14:00:13');
INSERT INTO `access_log` VALUES (42097, '65.46.15613562535502157', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:04:14', 1, 1002001015, '账号未登陆', '2019-06-24 14:04:14');
INSERT INTO `access_log` VALUES (42098, '65.50.15613562535552127', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:04:14', 0, 1002001015, '账号未登陆', '2019-06-24 14:04:14');
INSERT INTO `access_log` VALUES (42099, '65.53.15613562535572105', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:04:14', 0, 1002001015, '账号未登陆', '2019-06-24 14:04:14');
INSERT INTO `access_log` VALUES (42100, '65.54.15613562577172075', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:04:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 14:04:18');
INSERT INTO `access_log` VALUES (42101, '65.45.15613562811532113', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:04:41', 84, 0, '', '2019-06-24 14:04:41');
INSERT INTO `access_log` VALUES (42102, '65.47.15613562815342097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:04:42', 9, 0, '', '2019-06-24 14:04:42');
INSERT INTO `access_log` VALUES (42103, '65.49.15613562815392123', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:04:42', 9, 2001001000, '服务端发生异常', '2019-06-24 14:04:42');
INSERT INTO `access_log` VALUES (42104, '65.51.15613562815482151', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:04:42', 9, 0, '', '2019-06-24 14:04:42');
INSERT INTO `access_log` VALUES (42105, '65.53.15613562964982107', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:04:56', 10, 0, '', '2019-06-24 14:04:57');
INSERT INTO `access_log` VALUES (42106, '65.50.15613562965012129', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:04:57', 12, 2001001000, '服务端发生异常', '2019-06-24 14:04:57');
INSERT INTO `access_log` VALUES (42107, '65.54.15613562965052077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:04:57', 9, 0, '', '2019-06-24 14:04:57');
INSERT INTO `access_log` VALUES (42108, '59.75.15613566044171089', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.118.190.227', '2019-06-24 14:10:04', 12, 0, '', '2019-06-24 14:10:04');
INSERT INTO `access_log` VALUES (42109, '59.77.15613566044201071', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.118.190.227', '2019-06-24 14:10:04', 21, 2001001000, '服务端发生异常', '2019-06-24 14:10:04');
INSERT INTO `access_log` VALUES (42110, '64.82.15613566121221113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:10:12', 11, 0, '', '2019-06-24 14:10:12');
INSERT INTO `access_log` VALUES (42111, '64.84.15613566123941095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:10:12', 3, 0, '', '2019-06-24 14:10:12');
INSERT INTO `access_log` VALUES (42112, '64.77.15613566136191101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:10:14', 3, 0, '', '2019-06-24 14:10:14');
INSERT INTO `access_log` VALUES (42113, '64.76.15613566143441089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:10:14', 2, 0, '', '2019-06-24 14:10:14');
INSERT INTO `access_log` VALUES (42114, '64.85.15613566150251119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:10:15', 2, 0, '', '2019-06-24 14:10:15');
INSERT INTO `access_log` VALUES (42115, '64.79.15613566156571111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:10:16', 1, 0, '', '2019-06-24 14:10:16');
INSERT INTO `access_log` VALUES (42116, '64.83.15613566162951097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:10:16', 2, 0, '', '2019-06-24 14:10:16');
INSERT INTO `access_log` VALUES (42117, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:10:16', 14, 0, '', '2019-06-24 14:10:16');
INSERT INTO `access_log` VALUES (42118, '64.78.15613566172971107', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:10:17', 8, 0, '', '2019-06-24 14:10:17');
INSERT INTO `access_log` VALUES (42119, '66.57.15613566350969339', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18682256725&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:10:35', 14, 1001003000, '验证码不存在', '2019-06-24 14:10:35');
INSERT INTO `access_log` VALUES (42120, '66.51.15613566374569349', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18682256725', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:10:37', 86, 0, '', '2019-06-24 14:10:38');
INSERT INTO `access_log` VALUES (42121, '66.56.15613566394439343', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18682256725&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:10:39', 228, 0, '', '2019-06-24 14:10:40');
INSERT INTO `access_log` VALUES (42122, '66.49.15613566412919341', 136, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:10:41', 5, 0, '', '2019-06-24 14:10:41');
INSERT INTO `access_log` VALUES (42123, '66.52.15613566434599337', 136, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:10:43', 6, 0, '', '2019-06-24 14:10:43');
INSERT INTO `access_log` VALUES (42124, '66.51.15613566927349351', 136, 1, 'user-application', '/user-api/users/address/add', 'name=陈飞龙&tel=18682256725&country=&province=广东省&city=深圳市&county=罗湖区&areaCode=440303&postalCode=&addressDetail=深城投中心&isDefault=true&address=深城投中心&areaNo=440303&mobile=18682256725&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:11:33', 94, 2001001000, '服务端发生异常', '2019-06-24 14:11:33');
INSERT INTO `access_log` VALUES (42125, '66.56.15613566948929345', 136, 1, 'user-application', '/user-api/users/address/add', 'name=陈飞龙&tel=18682256725&country=&province=广东省&city=深圳市&county=罗湖区&areaCode=440303&postalCode=&addressDetail=深城投中心&isDefault=true&address=深城投中心&areaNo=440303&mobile=18682256725&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:11:35', 70, 2001001000, '服务端发生异常', '2019-06-24 14:11:35');
INSERT INTO `access_log` VALUES (42126, '65.53.15613566994582113', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:11:39', 10, 0, '', '2019-06-24 14:11:39');
INSERT INTO `access_log` VALUES (42127, '65.54.15613566994862083', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:11:39', 10, 2001001000, '服务端发生异常', '2019-06-24 14:11:39');
INSERT INTO `access_log` VALUES (42128, '65.50.15613566994922135', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:11:39', 9, 0, '', '2019-06-24 14:11:40');
INSERT INTO `access_log` VALUES (42129, '66.49.15613567057889343', 136, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:11:46', 7, 0, '', '2019-06-24 14:11:46');
INSERT INTO `access_log` VALUES (42130, '66.50.15613567059379329', 136, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:11:46', 5, 0, '', '2019-06-24 14:11:46');
INSERT INTO `access_log` VALUES (42131, '64.79.15613567063011113', 136, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:11:46', 13, 0, '', '2019-06-24 14:11:46');
INSERT INTO `access_log` VALUES (42132, '64.78.15613567064931109', 136, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:11:46', 8, 0, '', '2019-06-24 14:11:47');
INSERT INTO `access_log` VALUES (42133, 'N/A', 136, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:11:47', 13, 0, '', '2019-06-24 14:11:47');
INSERT INTO `access_log` VALUES (42134, '65.45.15613567210152121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:12:01', 10, 2001001000, '服务端发生异常', '2019-06-24 14:12:01');
INSERT INTO `access_log` VALUES (42135, '65.52.15613567210102135', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:12:01', 174, 0, '', '2019-06-24 14:12:01');
INSERT INTO `access_log` VALUES (42136, '65.51.15613567210202159', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.57.148.106', '2019-06-24 14:12:01', 165, 0, '', '2019-06-24 14:12:01');
INSERT INTO `access_log` VALUES (42137, '59.75.15613576254801103', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.215.188.167', '2019-06-24 14:27:05', 3, 0, '', '2019-06-24 14:27:05');
INSERT INTO `access_log` VALUES (42138, '59.77.15613576254831085', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.215.188.167', '2019-06-24 14:27:05', 13, 2001001000, '服务端发生异常', '2019-06-24 14:27:06');
INSERT INTO `access_log` VALUES (42139, '59.80.15613576305351087', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.215.188.167', '2019-06-24 14:27:11', 3, 0, '', '2019-06-24 14:27:11');
INSERT INTO `access_log` VALUES (42140, '59.76.15613576305361095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.215.188.167', '2019-06-24 14:27:11', 18, 2001001000, '服务端发生异常', '2019-06-24 14:27:11');
INSERT INTO `access_log` VALUES (42141, '59.79.15613584102631115', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:40:10', 4, 0, '', '2019-06-24 14:40:10');
INSERT INTO `access_log` VALUES (42142, '59.73.15613584102651115', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:40:10', 23, 2001001000, '服务端发生异常', '2019-06-24 14:40:10');
INSERT INTO `access_log` VALUES (42143, '65.47.15613584579272127', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:40:58', 1, 1002001015, '账号未登陆', '2019-06-24 14:40:58');
INSERT INTO `access_log` VALUES (42144, '65.49.15613584579272153', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:40:58', 1, 1002001015, '账号未登陆', '2019-06-24 14:40:58');
INSERT INTO `access_log` VALUES (42145, '65.46.15613584579292191', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:40:58', 0, 1002001015, '账号未登陆', '2019-06-24 14:40:58');
INSERT INTO `access_log` VALUES (42146, '65.50.15613584601662161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:41:00', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 14:41:00');
INSERT INTO `access_log` VALUES (42147, '65.52.15613584630732161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:41:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 14:41:03');
INSERT INTO `access_log` VALUES (42148, '65.53.15613584641722139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:41:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 14:41:04');
INSERT INTO `access_log` VALUES (42149, '65.45.15613584862202147', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:41:26', 275, 0, '', '2019-06-24 14:41:26');
INSERT INTO `access_log` VALUES (42150, '65.51.15613584868442185', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:41:27', 9, 0, '', '2019-06-24 14:41:27');
INSERT INTO `access_log` VALUES (42151, '65.46.15613584868532193', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:41:27', 9, 2001001000, '服务端发生异常', '2019-06-24 14:41:27');
INSERT INTO `access_log` VALUES (42152, '65.47.15613584868552129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:41:27', 9, 0, '', '2019-06-24 14:41:27');
INSERT INTO `access_log` VALUES (42153, '65.50.15613585020822163', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:41:42', 17, 0, '', '2019-06-24 14:41:42');
INSERT INTO `access_log` VALUES (42154, '65.52.15613585020932163', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:41:42', 10, 2001001000, '服务端发生异常', '2019-06-24 14:41:42');
INSERT INTO `access_log` VALUES (42155, '65.53.15613585020952141', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.9 Safari/537.36', '219.137.140.112', '2019-06-24 14:41:42', 9, 0, '', '2019-06-24 14:41:42');
INSERT INTO `access_log` VALUES (42156, '65.54.15613597722442129', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.13.75.162', '2019-06-24 15:02:52', 0, 1002001015, '账号未登陆', '2019-06-24 15:02:52');
INSERT INTO `access_log` VALUES (42157, '65.51.15613597722512201', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.13.75.162', '2019-06-24 15:02:52', 0, 1002001015, '账号未登陆', '2019-06-24 15:02:52');
INSERT INTO `access_log` VALUES (42158, '65.47.15613597722682149', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.13.75.162', '2019-06-24 15:02:52', 0, 1002001015, '账号未登陆', '2019-06-24 15:02:52');
INSERT INTO `access_log` VALUES (42159, '65.52.15613597744012183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.13.75.162', '2019-06-24 15:02:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 15:02:54');
INSERT INTO `access_log` VALUES (42160, '65.49.15613597794922175', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.13.75.162', '2019-06-24 15:02:59', 117, 0, '', '2019-06-24 15:03:00');
INSERT INTO `access_log` VALUES (42161, '65.46.15613597798112213', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.13.75.162', '2019-06-24 15:03:00', 9, 0, '', '2019-06-24 15:03:00');
INSERT INTO `access_log` VALUES (42162, '65.50.15613597798232183', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.13.75.162', '2019-06-24 15:03:00', 9, 0, '', '2019-06-24 15:03:00');
INSERT INTO `access_log` VALUES (42163, '65.3607.15613597798243941', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.13.75.162', '2019-06-24 15:03:00', 10, 2001001000, '服务端发生异常', '2019-06-24 15:03:00');
INSERT INTO `access_log` VALUES (42164, '65.51.15613597997992203', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.13.75.162', '2019-06-24 15:03:20', 10, 0, '', '2019-06-24 15:03:20');
INSERT INTO `access_log` VALUES (42165, '65.54.15613597998032131', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.13.75.162', '2019-06-24 15:03:20', 9, 2001001000, '服务端发生异常', '2019-06-24 15:03:20');
INSERT INTO `access_log` VALUES (42166, '65.47.15613597998072151', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.13.75.162', '2019-06-24 15:03:20', 9, 0, '', '2019-06-24 15:03:20');
INSERT INTO `access_log` VALUES (42167, '59.75.15613600919631137', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.1.72.75', '2019-06-24 15:08:12', 3, 0, '', '2019-06-24 15:08:12');
INSERT INTO `access_log` VALUES (42168, '59.77.15613600919631119', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.1.72.75', '2019-06-24 15:08:12', 19, 2001001000, '服务端发生异常', '2019-06-24 15:08:12');
INSERT INTO `access_log` VALUES (42169, '64.79.15613601042371159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:08:24', 13, 0, '', '2019-06-24 15:08:24');
INSERT INTO `access_log` VALUES (42170, '64.83.15613601043641145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:08:24', 3, 0, '', '2019-06-24 15:08:24');
INSERT INTO `access_log` VALUES (42171, '59.76.15613601059651129', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:08:26', 2, 0, '', '2019-06-24 15:08:26');
INSERT INTO `access_log` VALUES (42172, '59.74.15613601059651133', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:08:26', 16, 2001001000, '服务端发生异常', '2019-06-24 15:08:26');
INSERT INTO `access_log` VALUES (42173, '64.78.15613601088261155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:08:29', 2, 0, '', '2019-06-24 15:08:29');
INSERT INTO `access_log` VALUES (42174, '64.81.15613601089761151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:08:29', 2, 0, '', '2019-06-24 15:08:29');
INSERT INTO `access_log` VALUES (42175, '66.57.15613601251009387', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18408221234&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:08:45', 17, 1001003000, '验证码不存在', '2019-06-24 15:08:45');
INSERT INTO `access_log` VALUES (42176, '66.52.15613601294529385', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18408221234&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:08:49', 9, 1001003000, '验证码不存在', '2019-06-24 15:08:49');
INSERT INTO `access_log` VALUES (42177, '66.48.15613601317069391', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18408221234', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:08:52', 60, 0, '', '2019-06-24 15:08:52');
INSERT INTO `access_log` VALUES (42178, '66.55.15613601340089377', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18408221234&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:08:54', 273, 0, '', '2019-06-24 15:08:54');
INSERT INTO `access_log` VALUES (42179, '64.77.15613601395601151', 137, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:09:00', 6, 0, '', '2019-06-24 15:09:00');
INSERT INTO `access_log` VALUES (42180, '64.85.15613601397221169', 137, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:09:00', 8, 0, '', '2019-06-24 15:09:00');
INSERT INTO `access_log` VALUES (42181, '66.49.15613601410899391', 137, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:09:01', 5, 0, '', '2019-06-24 15:09:01');
INSERT INTO `access_log` VALUES (42182, '66.50.15613601493269379', 137, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:09:09', 5, 0, '', '2019-06-24 15:09:09');
INSERT INTO `access_log` VALUES (42183, '66.52.15613601513099387', 137, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:09:11', 7, 0, '', '2019-06-24 15:09:11');
INSERT INTO `access_log` VALUES (42184, '59.74.15613602359901135', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.166.167', '2019-06-24 15:10:36', 3, 0, '', '2019-06-24 15:10:36');
INSERT INTO `access_log` VALUES (42185, '59.72.15613602360071133', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.166.167', '2019-06-24 15:10:36', 12, 2001001000, '服务端发生异常', '2019-06-24 15:10:36');
INSERT INTO `access_log` VALUES (42186, '64.77.15613602393961153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.166.167', '2019-06-24 15:10:39', 3, 0, '', '2019-06-24 15:10:39');
INSERT INTO `access_log` VALUES (42187, '64.76.15613602395241141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.166.167', '2019-06-24 15:10:40', 2, 0, '', '2019-06-24 15:10:40');
INSERT INTO `access_log` VALUES (42188, '64.85.15613602407331171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.166.167', '2019-06-24 15:10:41', 2, 0, '', '2019-06-24 15:10:41');
INSERT INTO `access_log` VALUES (42189, '64.79.15613602413571163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.166.167', '2019-06-24 15:10:41', 2, 0, '', '2019-06-24 15:10:41');
INSERT INTO `access_log` VALUES (42190, '64.83.15613602419011149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.166.167', '2019-06-24 15:10:42', 2, 0, '', '2019-06-24 15:10:42');
INSERT INTO `access_log` VALUES (42191, '64.78.15613602497621159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:10:50', 2, 0, '', '2019-06-24 15:10:50');
INSERT INTO `access_log` VALUES (42192, '64.81.15613602499841155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:10:50', 2, 0, '', '2019-06-24 15:10:50');
INSERT INTO `access_log` VALUES (42193, '59.73.15613602535311141', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:10:54', 2, 0, '', '2019-06-24 15:10:54');
INSERT INTO `access_log` VALUES (42194, '59.78.15613602535321133', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:10:54', 9, 2001001000, '服务端发生异常', '2019-06-24 15:10:54');
INSERT INTO `access_log` VALUES (42195, '59.71.15613602612571139', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:01', 9, 0, '', '2019-06-24 15:11:01');
INSERT INTO `access_log` VALUES (42196, '59.75.15613602612581141', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:01', 19, 2001001000, '服务端发生异常', '2019-06-24 15:11:01');
INSERT INTO `access_log` VALUES (42197, '59.80.15613602651701125', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:05', 2, 0, '', '2019-06-24 15:11:05');
INSERT INTO `access_log` VALUES (42198, '59.76.15613602651701133', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:05', 12, 2001001000, '服务端发生异常', '2019-06-24 15:11:05');
INSERT INTO `access_log` VALUES (42199, '64.84.15613602683001149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:08', 2, 0, '', '2019-06-24 15:11:08');
INSERT INTO `access_log` VALUES (42200, '64.77.15613602684101155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:08', 1, 0, '', '2019-06-24 15:11:08');
INSERT INTO `access_log` VALUES (42201, '64.76.15613602692481143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:09', 1, 0, '', '2019-06-24 15:11:09');
INSERT INTO `access_log` VALUES (42202, '64.85.15613602703101173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:10', 2, 0, '', '2019-06-24 15:11:10');
INSERT INTO `access_log` VALUES (42203, '64.79.15613602715591165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:12', 2, 0, '', '2019-06-24 15:11:12');
INSERT INTO `access_log` VALUES (42204, '64.83.15613602725741151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:13', 2, 0, '', '2019-06-24 15:11:13');
INSERT INTO `access_log` VALUES (42205, '64.78.15613602743461161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:14', 2, 0, '', '2019-06-24 15:11:14');
INSERT INTO `access_log` VALUES (42206, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:14', 7, 0, '', '2019-06-24 15:11:14');
INSERT INTO `access_log` VALUES (42207, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:16', 6, 0, '', '2019-06-24 15:11:16');
INSERT INTO `access_log` VALUES (42208, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:17', 6, 0, '', '2019-06-24 15:11:17');
INSERT INTO `access_log` VALUES (42209, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:18', 6, 0, '', '2019-06-24 15:11:18');
INSERT INTO `access_log` VALUES (42210, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:18', 7, 0, '', '2019-06-24 15:11:18');
INSERT INTO `access_log` VALUES (42211, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:21', 6, 0, '', '2019-06-24 15:11:21');
INSERT INTO `access_log` VALUES (42212, '64.80.15613602820531159', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:22', 8, 0, '', '2019-06-24 15:11:22');
INSERT INTO `access_log` VALUES (42213, '66.52.15613602867259389', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位', '2019-06-24 15:11:27');
INSERT INTO `access_log` VALUES (42214, '64.82.15613602944011169', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:34', 7, 0, '', '2019-06-24 15:11:34');
INSERT INTO `access_log` VALUES (42215, '64.77.15613602958771157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:36', 2, 0, '', '2019-06-24 15:11:36');
INSERT INTO `access_log` VALUES (42216, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:36', 7, 0, '', '2019-06-24 15:11:36');
INSERT INTO `access_log` VALUES (42217, '64.76.15613602971571145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:37', 2, 0, '', '2019-06-24 15:11:37');
INSERT INTO `access_log` VALUES (42218, '64.85.15613602973161175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.203.166.167', '2019-06-24 15:11:37', 2, 0, '', '2019-06-24 15:11:37');
INSERT INTO `access_log` VALUES (42219, '59.75.15613603489621143', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.218', '2019-06-24 15:12:29', 3, 0, '', '2019-06-24 15:12:29');
INSERT INTO `access_log` VALUES (42220, '59.71.15613603489631141', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.218', '2019-06-24 15:12:29', 14, 2001001000, '服务端发生异常', '2019-06-24 15:12:29');
INSERT INTO `access_log` VALUES (42221, '59.80.15613603591211127', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.218', '2019-06-24 15:12:39', 2, 0, '', '2019-06-24 15:12:39');
INSERT INTO `access_log` VALUES (42222, '59.76.15613603591221135', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.218', '2019-06-24 15:12:39', 10, 2001001000, '服务端发生异常', '2019-06-24 15:12:39');
INSERT INTO `access_log` VALUES (42223, '59.72.15613603630351137', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.218', '2019-06-24 15:12:43', 2, 0, '', '2019-06-24 15:12:43');
INSERT INTO `access_log` VALUES (42224, '59.74.15613603630371139', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.218', '2019-06-24 15:12:43', 17, 2001001000, '服务端发生异常', '2019-06-24 15:12:43');
INSERT INTO `access_log` VALUES (42225, '66.57.15613603925459393', 137, 1, 'user-application', '/user-api/users/address/add', 'name=123&tel=18408221234&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=2131&isDefault=true&address=2131&areaNo=110101&mobile=18408221234&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:13', 103, 2001001000, '服务端发生异常', '2019-06-24 15:13:13');
INSERT INTO `access_log` VALUES (42226, '66.54.15613603944939397', 137, 1, 'user-application', '/user-api/users/address/add', 'name=123&tel=18408221234&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=2131&isDefault=true&address=2131&areaNo=110101&mobile=18408221234&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:14', 66, 2001001000, '服务端发生异常', '2019-06-24 15:13:15');
INSERT INTO `access_log` VALUES (42227, '59.78.15613603948811137', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.218', '2019-06-24 15:13:15', 2, 0, '', '2019-06-24 15:13:15');
INSERT INTO `access_log` VALUES (42228, '59.75.15613603948821145', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.218', '2019-06-24 15:13:15', 12, 2001001000, '服务端发生异常', '2019-06-24 15:13:15');
INSERT INTO `access_log` VALUES (42229, '66.55.15613603964809383', 137, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:16', 6, 0, '', '2019-06-24 15:13:16');
INSERT INTO `access_log` VALUES (42230, '66.49.15613603973899397', 137, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:17', 6, 0, '', '2019-06-24 15:13:17');
INSERT INTO `access_log` VALUES (42231, '66.50.15613604125829385', 137, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:33', 6, 0, '', '2019-06-24 15:13:33');
INSERT INTO `access_log` VALUES (42232, '59.76.15613604135291137', 137, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:34', 8, 0, '', '2019-06-24 15:13:34');
INSERT INTO `access_log` VALUES (42233, '59.72.15613604135731139', 137, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:34', 24, 2001001000, '服务端发生异常', '2019-06-24 15:13:34');
INSERT INTO `access_log` VALUES (42234, '64.76.15613604153341147', 137, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:35', 7, 0, '', '2019-06-24 15:13:35');
INSERT INTO `access_log` VALUES (42235, '64.83.15613604155351155', 137, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:36', 6, 0, '', '2019-06-24 15:13:36');
INSERT INTO `access_log` VALUES (42236, '64.81.15613604166521161', 137, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:37', 6, 0, '', '2019-06-24 15:13:37');
INSERT INTO `access_log` VALUES (42237, 'N/A', 137, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:37', 14, 0, '', '2019-06-24 15:13:37');
INSERT INTO `access_log` VALUES (42238, '64.82.15613604197661173', 137, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:40', 12, 0, '', '2019-06-24 15:13:40');
INSERT INTO `access_log` VALUES (42239, '66.54.15613604241479399', 137, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:44', 5, 0, '', '2019-06-24 15:13:44');
INSERT INTO `access_log` VALUES (42240, '66.55.15613604281049385', 137, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:48', 1133, 0, '', '2019-06-24 15:13:49');
INSERT INTO `access_log` VALUES (42241, '66.49.15613604297799399', 137, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:50', 6, 0, '', '2019-06-24 15:13:50');
INSERT INTO `access_log` VALUES (42242, '65.54.15613605312362141', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.1.72.75', '2019-06-24 15:15:31', 1, 1002001015, '账号未登陆', '2019-06-24 15:15:31');
INSERT INTO `access_log` VALUES (42243, '65.53.15613605312362173', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.1.72.75', '2019-06-24 15:15:31', 0, 1002001015, '账号未登陆', '2019-06-24 15:15:31');
INSERT INTO `access_log` VALUES (42244, '65.52.15613605312442195', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.1.72.75', '2019-06-24 15:15:31', 0, 1002001015, '账号未登陆', '2019-06-24 15:15:31');
INSERT INTO `access_log` VALUES (42245, '65.49.15613605341612187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.1.72.75', '2019-06-24 15:15:34', 61, 0, '', '2019-06-24 15:15:34');
INSERT INTO `access_log` VALUES (42246, '65.3607.15613605344803953', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.1.72.75', '2019-06-24 15:15:34', 165, 0, '', '2019-06-24 15:15:35');
INSERT INTO `access_log` VALUES (42247, '65.46.15613605344832225', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.1.72.75', '2019-06-24 15:15:34', 162, 2001001000, '服务端发生异常', '2019-06-24 15:15:35');
INSERT INTO `access_log` VALUES (42248, '65.50.15613605344882195', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.1.72.75', '2019-06-24 15:15:34', 159, 0, '', '2019-06-24 15:15:35');
INSERT INTO `access_log` VALUES (42249, '65.47.15613616053622177', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.206.154.245', '2019-06-24 15:33:25', 0, 1002001015, '账号未登陆', '2019-06-24 15:33:25');
INSERT INTO `access_log` VALUES (42250, '65.53.15613616053622189', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.206.154.245', '2019-06-24 15:33:25', 0, 1002001015, '账号未登陆', '2019-06-24 15:33:25');
INSERT INTO `access_log` VALUES (42251, '65.52.15613616053652211', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.206.154.245', '2019-06-24 15:33:25', 0, 1002001015, '账号未登陆', '2019-06-24 15:33:25');
INSERT INTO `access_log` VALUES (42252, '65.54.15613616180932157', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.206.154.245', '2019-06-24 15:33:38', 86, 0, '', '2019-06-24 15:33:38');
INSERT INTO `access_log` VALUES (42253, '65.49.15613616183582203', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.206.154.245', '2019-06-24 15:33:38', 26, 0, '', '2019-06-24 15:33:38');
INSERT INTO `access_log` VALUES (42254, '65.3607.15613616183593969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.206.154.245', '2019-06-24 15:33:38', 26, 2001001000, '服务端发生异常', '2019-06-24 15:33:38');
INSERT INTO `access_log` VALUES (42255, '65.50.15613616183632211', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.206.154.245', '2019-06-24 15:33:38', 23, 0, '', '2019-06-24 15:33:38');
INSERT INTO `access_log` VALUES (42256, '59.73.15613644738391201', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-24 16:21:14', 17, 2001001000, '服务端发生异常', '2019-06-24 16:21:14');
INSERT INTO `access_log` VALUES (42257, '59.79.15613644738391201', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-24 16:21:14', 109, 0, '', '2019-06-24 16:21:14');
INSERT INTO `access_log` VALUES (42258, '64.77.15613644805861215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-24 16:21:21', 103, 0, '', '2019-06-24 16:21:21');
INSERT INTO `access_log` VALUES (42259, '64.76.15613644807891203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-24 16:21:21', 4, 0, '', '2019-06-24 16:21:21');
INSERT INTO `access_log` VALUES (42260, '64.85.15613644893421233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-24 16:21:29', 3, 0, '', '2019-06-24 16:21:29');
INSERT INTO `access_log` VALUES (42261, '64.79.15613644894771225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-24 16:21:29', 2, 0, '', '2019-06-24 16:21:29');
INSERT INTO `access_log` VALUES (42262, '59.71.15613644983631199', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-24 16:21:38', 4, 0, '', '2019-06-24 16:21:38');
INSERT INTO `access_log` VALUES (42263, '59.77.15613644983671183', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-24 16:21:38', 18, 2001001000, '服务端发生异常', '2019-06-24 16:21:38');
INSERT INTO `access_log` VALUES (42264, '65.3607.15613647166844011', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:25:17', 1, 1002001015, '账号未登陆', '2019-06-24 16:25:17');
INSERT INTO `access_log` VALUES (42265, '65.50.15613647166852253', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:25:17', 0, 1002001015, '账号未登陆', '2019-06-24 16:25:17');
INSERT INTO `access_log` VALUES (42266, '65.49.15613647167122245', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:25:17', 1, 1002001015, '账号未登陆', '2019-06-24 16:25:17');
INSERT INTO `access_log` VALUES (42267, '65.46.15613647232362283', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:25:23', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 16:25:23');
INSERT INTO `access_log` VALUES (42268, '65.51.15613647280822273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:25:28', 121, 0, '', '2019-06-24 16:25:28');
INSERT INTO `access_log` VALUES (42269, '65.47.15613647284652221', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:25:28', 11, 0, '', '2019-06-24 16:25:28');
INSERT INTO `access_log` VALUES (42270, '65.53.15613647284842233', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:25:28', 11, 0, '', '2019-06-24 16:25:28');
INSERT INTO `access_log` VALUES (42271, '65.52.15613647284842255', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:25:28', 12, 2001001000, '服务端发生异常', '2019-06-24 16:25:28');
INSERT INTO `access_log` VALUES (42272, '65.50.15613647465312255', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:25:47', 8, 0, '', '2019-06-24 16:25:47');
INSERT INTO `access_log` VALUES (42273, '65.49.15613647465392247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:25:47', 8, 0, '', '2019-06-24 16:25:47');
INSERT INTO `access_log` VALUES (42274, '65.3607.15613647465384013', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:25:47', 9, 2001001000, '服务端发生异常', '2019-06-24 16:25:47');
INSERT INTO `access_log` VALUES (42275, '65.46.15613647511762285', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:25:51', 10, 0, '', '2019-06-24 16:25:51');
INSERT INTO `access_log` VALUES (42276, '65.45.15613647511792237', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:25:51', 10, 2001001000, '服务端发生异常', '2019-06-24 16:25:51');
INSERT INTO `access_log` VALUES (42277, '65.51.15613647511822275', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:25:51', 8, 0, '', '2019-06-24 16:25:51');
INSERT INTO `access_log` VALUES (42278, '65.53.15613647607542235', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:26:01', 8, 0, '', '2019-06-24 16:26:01');
INSERT INTO `access_log` VALUES (42279, '65.47.15613647607602223', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:26:01', 16, 2001001000, '服务端发生异常', '2019-06-24 16:26:01');
INSERT INTO `access_log` VALUES (42280, '65.54.15613647607622203', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '219.148.28.170', '2019-06-24 16:26:01', 16, 0, '', '2019-06-24 16:26:01');
INSERT INTO `access_log` VALUES (42281, '65.53.15613650146332239', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.109.81.215', '2019-06-24 16:30:15', 1, 1002001015, '账号未登陆', '2019-06-24 16:30:15');
INSERT INTO `access_log` VALUES (42282, '65.54.15613650146332207', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.109.81.215', '2019-06-24 16:30:15', 0, 1002001015, '账号未登陆', '2019-06-24 16:30:15');
INSERT INTO `access_log` VALUES (42283, '65.47.15613650146572227', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.109.81.215', '2019-06-24 16:30:15', 0, 1002001015, '账号未登陆', '2019-06-24 16:30:15');
INSERT INTO `access_log` VALUES (42284, '65.50.15613650176912261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.109.81.215', '2019-06-24 16:30:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 16:30:18');
INSERT INTO `access_log` VALUES (42285, '65.3607.15613650220614019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.109.81.215', '2019-06-24 16:30:22', 66, 0, '', '2019-06-24 16:30:22');
INSERT INTO `access_log` VALUES (42286, '65.51.15613650262902281', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.109.81.215', '2019-06-24 16:30:26', 75, 0, '', '2019-06-24 16:30:26');
INSERT INTO `access_log` VALUES (42287, '65.46.15613650372382291', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.109.81.215', '2019-06-24 16:30:37', 108, 0, '', '2019-06-24 16:30:37');
INSERT INTO `access_log` VALUES (42288, '59.75.15613650432381209', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:30:43', 8, 0, '', '2019-06-24 16:30:43');
INSERT INTO `access_log` VALUES (42289, '59.78.15613650432381201', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:30:43', 12, 2001001000, '服务端发生异常', '2019-06-24 16:30:43');
INSERT INTO `access_log` VALUES (42290, '64.76.15613650460211211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:30:46', 3, 0, '', '2019-06-24 16:30:46');
INSERT INTO `access_log` VALUES (42291, '64.85.15613650461411241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:30:46', 2, 0, '', '2019-06-24 16:30:46');
INSERT INTO `access_log` VALUES (42292, '64.79.15613650471311233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:30:47', 2, 0, '', '2019-06-24 16:30:47');
INSERT INTO `access_log` VALUES (42293, '64.83.15613650475511219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:30:48', 1, 0, '', '2019-06-24 16:30:48');
INSERT INTO `access_log` VALUES (42294, '64.78.15613650479451229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:30:48', 2, 0, '', '2019-06-24 16:30:48');
INSERT INTO `access_log` VALUES (42295, '64.81.15613650486291225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:30:49', 2, 0, '', '2019-06-24 16:30:49');
INSERT INTO `access_log` VALUES (42296, '66.51.15613650506409471', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:30:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空\n账号长度为 11 位', '2019-06-24 16:30:51');
INSERT INTO `access_log` VALUES (42297, '64.82.15613650555381237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:30:56', 2, 0, '', '2019-06-24 16:30:56');
INSERT INTO `access_log` VALUES (42298, '64.84.15613650556291219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:30:56', 2, 0, '', '2019-06-24 16:30:56');
INSERT INTO `access_log` VALUES (42299, '65.53.15613650608142241', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.111.102.238', '2019-06-24 16:31:01', 1, 1002001015, '账号未登陆', '2019-06-24 16:31:01');
INSERT INTO `access_log` VALUES (42300, '65.47.15613650608202229', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.111.102.238', '2019-06-24 16:31:01', 0, 1002001015, '账号未登陆', '2019-06-24 16:31:01');
INSERT INTO `access_log` VALUES (42301, '65.54.15613650608232209', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.111.102.238', '2019-06-24 16:31:01', 0, 1002001015, '账号未登陆', '2019-06-24 16:31:01');
INSERT INTO `access_log` VALUES (42302, '65.50.15613650647212263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.111.102.238', '2019-06-24 16:31:05', 75, 0, '', '2019-06-24 16:31:05');
INSERT INTO `access_log` VALUES (42303, '65.3607.15613650650034021', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.111.102.238', '2019-06-24 16:31:05', 10, 0, '', '2019-06-24 16:31:05');
INSERT INTO `access_log` VALUES (42304, '65.51.15613650650102283', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.111.102.238', '2019-06-24 16:31:05', 9, 0, '', '2019-06-24 16:31:05');
INSERT INTO `access_log` VALUES (42305, '65.49.15613650650102255', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.111.102.238', '2019-06-24 16:31:05', 10, 2001001000, '服务端发生异常', '2019-06-24 16:31:05');
INSERT INTO `access_log` VALUES (42306, '59.80.15613650656521193', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:31:06', 2, 0, '', '2019-06-24 16:31:06');
INSERT INTO `access_log` VALUES (42307, '59.76.15613650656521201', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:31:06', 12, 2001001000, '服务端发生异常', '2019-06-24 16:31:06');
INSERT INTO `access_log` VALUES (42308, '64.76.15613650687861213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:31:09', 2, 0, '', '2019-06-24 16:31:09');
INSERT INTO `access_log` VALUES (42309, '64.85.15613650690271243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:31:09', 2, 0, '', '2019-06-24 16:31:09');
INSERT INTO `access_log` VALUES (42310, '64.79.15613650697381235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:31:10', 1, 0, '', '2019-06-24 16:31:10');
INSERT INTO `access_log` VALUES (42311, '64.83.15613650705111221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:31:11', 1, 0, '', '2019-06-24 16:31:11');
INSERT INTO `access_log` VALUES (42312, '64.78.15613650718251231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:31:12', 2, 0, '', '2019-06-24 16:31:12');
INSERT INTO `access_log` VALUES (42313, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:31:12', 7, 0, '', '2019-06-24 16:31:12');
INSERT INTO `access_log` VALUES (42314, '64.81.15613650729701227', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '180.109.81.215', '2019-06-24 16:31:13', 8, 0, '', '2019-06-24 16:31:13');
INSERT INTO `access_log` VALUES (42315, '59.71.15613659042741219', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-06-24 16:45:04', 3, 0, '', '2019-06-24 16:45:04');
INSERT INTO `access_log` VALUES (42316, '59.77.15613659042811203', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-06-24 16:45:04', 12, 2001001000, '服务端发生异常', '2019-06-24 16:45:04');
INSERT INTO `access_log` VALUES (42317, '64.79.15613659114521247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-06-24 16:45:11', 3, 0, '', '2019-06-24 16:45:11');
INSERT INTO `access_log` VALUES (42318, '64.83.15613659115591233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-06-24 16:45:12', 2, 0, '', '2019-06-24 16:45:12');
INSERT INTO `access_log` VALUES (42319, '64.78.15613659125391243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-06-24 16:45:13', 2, 0, '', '2019-06-24 16:45:13');
INSERT INTO `access_log` VALUES (42320, '64.81.15613659133911239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-06-24 16:45:13', 2, 0, '', '2019-06-24 16:45:13');
INSERT INTO `access_log` VALUES (42321, '65.52.15613674256312295', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 17:10:26', 1, 1002001015, '账号未登陆', '2019-06-24 17:10:26');
INSERT INTO `access_log` VALUES (42322, '65.47.15613674256312263', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 17:10:26', 0, 1002001015, '账号未登陆', '2019-06-24 17:10:26');
INSERT INTO `access_log` VALUES (42323, '65.53.15613674256592275', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 17:10:26', 0, 1002001015, '账号未登陆', '2019-06-24 17:10:26');
INSERT INTO `access_log` VALUES (42324, '65.54.15613674274892241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 17:10:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 17:10:27');
INSERT INTO `access_log` VALUES (42325, '65.49.15613674456412289', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 17:10:46', 116, 0, '', '2019-06-24 17:10:46');
INSERT INTO `access_log` VALUES (42326, '65.3607.15613674461444055', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 17:10:46', 11, 0, '', '2019-06-24 17:10:46');
INSERT INTO `access_log` VALUES (42327, '65.46.15613674461442327', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 17:10:46', 11, 0, '', '2019-06-24 17:10:46');
INSERT INTO `access_log` VALUES (42328, '65.51.15613674461442317', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 17:10:46', 14, 2001001000, '服务端发生异常', '2019-06-24 17:10:46');
INSERT INTO `access_log` VALUES (42329, '65.52.15613674579652297', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 17:10:58', 9, 0, '', '2019-06-24 17:10:58');
INSERT INTO `access_log` VALUES (42330, '65.47.15613674579662265', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 17:10:58', 9, 2001001000, '服务端发生异常', '2019-06-24 17:10:58');
INSERT INTO `access_log` VALUES (42331, '65.53.15613674579702277', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 17:10:58', 9, 0, '', '2019-06-24 17:10:58');
INSERT INTO `access_log` VALUES (42332, '59.74.15613676099851239', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:30', 3, 0, '', '2019-06-24 17:13:30');
INSERT INTO `access_log` VALUES (42333, '59.73.15613676099861245', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:30', 23, 2001001000, '服务端发生异常', '2019-06-24 17:13:30');
INSERT INTO `access_log` VALUES (42334, '64.77.15613676144281261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:34', 3, 0, '', '2019-06-24 17:13:34');
INSERT INTO `access_log` VALUES (42335, '64.76.15613676145231249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:35', 2, 0, '', '2019-06-24 17:13:35');
INSERT INTO `access_log` VALUES (42336, '64.79.15613676157041271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:36', 2, 0, '', '2019-06-24 17:13:36');
INSERT INTO `access_log` VALUES (42337, '64.83.15613676164561257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:36', 1, 0, '', '2019-06-24 17:13:36');
INSERT INTO `access_log` VALUES (42338, '64.78.15613676170401267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:37', 2, 0, '', '2019-06-24 17:13:37');
INSERT INTO `access_log` VALUES (42339, '64.81.15613676174401263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:37', 2, 0, '', '2019-06-24 17:13:37');
INSERT INTO `access_log` VALUES (42340, '64.80.15613676178161265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:38', 1, 0, '', '2019-06-24 17:13:38');
INSERT INTO `access_log` VALUES (42341, '64.82.15613676183451275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:38', 2, 0, '', '2019-06-24 17:13:38');
INSERT INTO `access_log` VALUES (42342, '64.84.15613676187371257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:39', 2, 0, '', '2019-06-24 17:13:39');
INSERT INTO `access_log` VALUES (42343, '64.77.15613676190801263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:39', 2, 0, '', '2019-06-24 17:13:39');
INSERT INTO `access_log` VALUES (42344, '64.76.15613676194251251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:39', 2, 0, '', '2019-06-24 17:13:39');
INSERT INTO `access_log` VALUES (42345, '64.85.15613676212141281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:41', 2, 0, '', '2019-06-24 17:13:41');
INSERT INTO `access_log` VALUES (42346, '64.79.15613676213101273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:41', 2, 0, '', '2019-06-24 17:13:41');
INSERT INTO `access_log` VALUES (42347, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:44', 7, 0, '', '2019-06-24 17:13:44');
INSERT INTO `access_log` VALUES (42348, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:44', 5, 0, '', '2019-06-24 17:13:44');
INSERT INTO `access_log` VALUES (42349, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:44', 12, 0, '', '2019-06-24 17:13:44');
INSERT INTO `access_log` VALUES (42350, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:44', 35, 0, '', '2019-06-24 17:13:44');
INSERT INTO `access_log` VALUES (42351, '64.83.15613676255741259', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:13:46', 7, 0, '', '2019-06-24 17:13:46');
INSERT INTO `access_log` VALUES (42352, '59.74.15613678703231243', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:17:50', 3, 0, '', '2019-06-24 17:17:50');
INSERT INTO `access_log` VALUES (42353, '59.73.15613678703261249', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:17:50', 12, 2001001000, '服务端发生异常', '2019-06-24 17:17:50');
INSERT INTO `access_log` VALUES (42354, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:17:54', 7, 0, '', '2019-06-24 17:17:54');
INSERT INTO `access_log` VALUES (42355, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:17:54', 4, 0, '', '2019-06-24 17:17:54');
INSERT INTO `access_log` VALUES (42356, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:17:54', 13, 0, '', '2019-06-24 17:17:54');
INSERT INTO `access_log` VALUES (42357, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:17:54', 11, 0, '', '2019-06-24 17:17:54');
INSERT INTO `access_log` VALUES (42358, '64.85.15613678755351285', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:17:56', 6, 0, '', '2019-06-24 17:17:56');
INSERT INTO `access_log` VALUES (42359, '64.79.15613678846491277', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:18:05', 6, 0, '', '2019-06-24 17:18:05');
INSERT INTO `access_log` VALUES (42360, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:18:05', 7, 0, '', '2019-06-24 17:18:05');
INSERT INTO `access_log` VALUES (42361, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:18:06', 4, 0, '', '2019-06-24 17:18:06');
INSERT INTO `access_log` VALUES (42362, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:18:06', 12, 0, '', '2019-06-24 17:18:06');
INSERT INTO `access_log` VALUES (42363, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:18:06', 10, 0, '', '2019-06-24 17:18:06');
INSERT INTO `access_log` VALUES (42364, '59.75.15613678864671249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:18:06', 2, 0, '', '2019-06-24 17:18:06');
INSERT INTO `access_log` VALUES (42365, '59.78.15613678864691241', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:18:06', 13, 2001001000, '服务端发生异常', '2019-06-24 17:18:06');
INSERT INTO `access_log` VALUES (42366, '59.80.15613679022001233', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:18:22', 2, 0, '', '2019-06-24 17:18:22');
INSERT INTO `access_log` VALUES (42367, '59.71.15613679022001247', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:18:22', 12, 2001001000, '服务端发生异常', '2019-06-24 17:18:22');
INSERT INTO `access_log` VALUES (42368, '64.82.15613679373321281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:18:57', 2, 0, '', '2019-06-24 17:18:57');
INSERT INTO `access_log` VALUES (42369, '64.84.15613679374651263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:18:57', 1, 0, '', '2019-06-24 17:18:57');
INSERT INTO `access_log` VALUES (42370, '64.77.15613679393561269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:18:59', 2, 0, '', '2019-06-24 17:18:59');
INSERT INTO `access_log` VALUES (42371, '64.76.15613679403261257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:00', 2, 0, '', '2019-06-24 17:19:00');
INSERT INTO `access_log` VALUES (42372, '64.85.15613679412511287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:01', 2, 0, '', '2019-06-24 17:19:01');
INSERT INTO `access_log` VALUES (42373, '64.79.15613679419491279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:02', 1, 0, '', '2019-06-24 17:19:02');
INSERT INTO `access_log` VALUES (42374, '64.83.15613679425481265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:03', 2, 0, '', '2019-06-24 17:19:03');
INSERT INTO `access_log` VALUES (42375, '64.78.15613679430541275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:03', 2, 0, '', '2019-06-24 17:19:03');
INSERT INTO `access_log` VALUES (42376, '64.81.15613679439911271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:04', 1, 0, '', '2019-06-24 17:19:04');
INSERT INTO `access_log` VALUES (42377, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:04', 7, 0, '', '2019-06-24 17:19:04');
INSERT INTO `access_log` VALUES (42378, '64.82.15613679461611283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:06', 2, 0, '', '2019-06-24 17:19:06');
INSERT INTO `access_log` VALUES (42379, '64.84.15613679462371265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:06', 2, 0, '', '2019-06-24 17:19:06');
INSERT INTO `access_log` VALUES (42380, '64.77.15613679470131271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:07', 2, 0, '', '2019-06-24 17:19:07');
INSERT INTO `access_log` VALUES (42381, '64.76.15613679476201259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:08', 2, 0, '', '2019-06-24 17:19:08');
INSERT INTO `access_log` VALUES (42382, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:08', 6, 0, '', '2019-06-24 17:19:08');
INSERT INTO `access_log` VALUES (42383, '64.85.15613679504171289', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:10', 8, 0, '', '2019-06-24 17:19:10');
INSERT INTO `access_log` VALUES (42384, '64.78.15613679798251277', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:40', 6, 0, '', '2019-06-24 17:19:40');
INSERT INTO `access_log` VALUES (42385, '64.81.15613679819981273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:42', 2, 0, '', '2019-06-24 17:19:42');
INSERT INTO `access_log` VALUES (42386, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:42', 7, 0, '', '2019-06-24 17:19:42');
INSERT INTO `access_log` VALUES (42387, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:44', 5, 0, '', '2019-06-24 17:19:44');
INSERT INTO `access_log` VALUES (42388, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:45', 7, 0, '', '2019-06-24 17:19:45');
INSERT INTO `access_log` VALUES (42389, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:45', 8, 0, '', '2019-06-24 17:19:45');
INSERT INTO `access_log` VALUES (42390, '64.80.15613679862131275', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:19:46', 6, 0, '', '2019-06-24 17:19:46');
INSERT INTO `access_log` VALUES (42391, '59.78.15613679975541243', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.74.234', '2019-06-24 17:19:58', 13, 2001001000, '服务端发生异常', '2019-06-24 17:19:58');
INSERT INTO `access_log` VALUES (42392, '59.77.15613679975781233', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.74.234', '2019-06-24 17:19:58', 3, 0, '', '2019-06-24 17:19:58');
INSERT INTO `access_log` VALUES (42393, '64.84.15613679999141267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:20:00', 2, 0, '', '2019-06-24 17:20:00');
INSERT INTO `access_log` VALUES (42394, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:20:00', 7, 0, '', '2019-06-24 17:20:00');
INSERT INTO `access_log` VALUES (42395, '64.77.15613680012141273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:20:01', 2, 0, '', '2019-06-24 17:20:01');
INSERT INTO `access_log` VALUES (42396, '64.76.15613680013031261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:20:01', 2, 0, '', '2019-06-24 17:20:01');
INSERT INTO `access_log` VALUES (42397, '64.85.15613680025001291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:20:03', 2, 0, '', '2019-06-24 17:20:03');
INSERT INTO `access_log` VALUES (42398, '64.79.15613680033671283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:20:03', 2, 0, '', '2019-06-24 17:20:03');
INSERT INTO `access_log` VALUES (42399, '64.83.15613680040991269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:20:04', 2, 0, '', '2019-06-24 17:20:04');
INSERT INTO `access_log` VALUES (42400, '64.78.15613680045421279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:20:05', 8, 0, '', '2019-06-24 17:20:05');
INSERT INTO `access_log` VALUES (42401, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:20:06', 8, 0, '', '2019-06-24 17:20:06');
INSERT INTO `access_log` VALUES (42402, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:20:06', 13, 0, '', '2019-06-24 17:20:06');
INSERT INTO `access_log` VALUES (42403, '64.80.15613680063361277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.74.234', '2019-06-24 17:20:06', 2, 0, '', '2019-06-24 17:20:06');
INSERT INTO `access_log` VALUES (42404, '64.82.15613680069711287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.74.234', '2019-06-24 17:20:07', 1, 0, '', '2019-06-24 17:20:07');
INSERT INTO `access_log` VALUES (42405, '64.84.15613680089941269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.74.234', '2019-06-24 17:20:09', 2, 0, '', '2019-06-24 17:20:09');
INSERT INTO `access_log` VALUES (42406, '64.77.15613680110651275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.74.234', '2019-06-24 17:20:11', 2, 0, '', '2019-06-24 17:20:11');
INSERT INTO `access_log` VALUES (42407, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:20:15', 8, 0, '', '2019-06-24 17:20:15');
INSERT INTO `access_log` VALUES (42408, '64.76.15613680169121263', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-06-24 17:20:17', 6, 0, '', '2019-06-24 17:20:17');
INSERT INTO `access_log` VALUES (42409, '65.49.15613680369762299', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:20:37', 1, 1002001015, '账号未登陆', '2019-06-24 17:20:37');
INSERT INTO `access_log` VALUES (42410, '65.3607.15613680369814069', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:20:37', 0, 1002001015, '账号未登陆', '2019-06-24 17:20:37');
INSERT INTO `access_log` VALUES (42411, '65.46.15613680369932337', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:20:37', 0, 1002001015, '账号未登陆', '2019-06-24 17:20:37');
INSERT INTO `access_log` VALUES (42412, '65.51.15613680388512331', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:20:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 17:20:39');
INSERT INTO `access_log` VALUES (42413, '65.52.15613680439332305', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.74.234', '2019-06-24 17:20:44', 0, 1002001015, '账号未登陆', '2019-06-24 17:20:44');
INSERT INTO `access_log` VALUES (42414, '65.47.15613680439362271', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.74.234', '2019-06-24 17:20:44', 0, 1002001015, '账号未登陆', '2019-06-24 17:20:44');
INSERT INTO `access_log` VALUES (42415, '65.53.15613680439402283', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.74.234', '2019-06-24 17:20:44', 0, 1002001015, '账号未登陆', '2019-06-24 17:20:44');
INSERT INTO `access_log` VALUES (42416, '65.50.15613680583652309', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.74.234', '2019-06-24 17:20:58', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 17:20:58');
INSERT INTO `access_log` VALUES (42417, '65.49.15613680668022301', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:21:07', 88, 0, '', '2019-06-24 17:21:07');
INSERT INTO `access_log` VALUES (42418, '65.3607.15613680672194071', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:21:07', 9, 0, '', '2019-06-24 17:21:07');
INSERT INTO `access_log` VALUES (42419, '65.45.15613680672322291', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:21:07', 9, 0, '', '2019-06-24 17:21:07');
INSERT INTO `access_log` VALUES (42420, '65.46.15613680672322339', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:21:07', 9, 2001001000, '服务端发生异常', '2019-06-24 17:21:07');
INSERT INTO `access_log` VALUES (42421, '65.47.15613680721472273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.74.234', '2019-06-24 17:21:12', 75, 0, '', '2019-06-24 17:21:12');
INSERT INTO `access_log` VALUES (42422, '65.53.15613680737192285', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.74.234', '2019-06-24 17:21:14', 9, 0, '', '2019-06-24 17:21:14');
INSERT INTO `access_log` VALUES (42423, '65.54.15613680737332253', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.74.234', '2019-06-24 17:21:14', 9, 0, '', '2019-06-24 17:21:14');
INSERT INTO `access_log` VALUES (42424, '65.52.15613680737332307', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.74.234', '2019-06-24 17:21:14', 9, 2001001000, '服务端发生异常', '2019-06-24 17:21:14');
INSERT INTO `access_log` VALUES (42425, '65.50.15613680830272311', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:21:23', 9, 0, '', '2019-06-24 17:21:23');
INSERT INTO `access_log` VALUES (42426, '65.49.15613680830312303', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:21:23', 11, 2001001000, '服务端发生异常', '2019-06-24 17:21:23');
INSERT INTO `access_log` VALUES (42427, '65.3607.15613680830344073', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:21:23', 9, 0, '', '2019-06-24 17:21:23');
INSERT INTO `access_log` VALUES (42428, '65.51.15613681049222335', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:21:45', 9, 0, '', '2019-06-24 17:21:45');
INSERT INTO `access_log` VALUES (42429, '65.47.15613681049252275', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:21:45', 11, 2001001000, '服务端发生异常', '2019-06-24 17:21:45');
INSERT INTO `access_log` VALUES (42430, '65.53.15613681049282287', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:21:45', 9, 0, '', '2019-06-24 17:21:45');
INSERT INTO `access_log` VALUES (42431, '65.52.15613681093902309', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:21:49', 9, 0, '', '2019-06-24 17:21:49');
INSERT INTO `access_log` VALUES (42432, '65.54.15613681093932255', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:21:49', 9, 0, '', '2019-06-24 17:21:49');
INSERT INTO `access_log` VALUES (42433, '65.50.15613681093942313', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-06-24 17:21:49', 9, 2001001000, '服务端发生异常', '2019-06-24 17:21:49');
INSERT INTO `access_log` VALUES (42434, '59.79.15613689855381265', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.247.8.186', '2019-06-24 17:36:26', 3, 0, '', '2019-06-24 17:36:26');
INSERT INTO `access_log` VALUES (42435, '59.75.15613689855531265', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.247.8.186', '2019-06-24 17:36:26', 13, 2001001000, '服务端发生异常', '2019-06-24 17:36:26');
INSERT INTO `access_log` VALUES (42436, '64.84.15613690173151283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.247.8.186', '2019-06-24 17:36:57', 21, 0, '', '2019-06-24 17:36:57');
INSERT INTO `access_log` VALUES (42437, '64.77.15613690188311289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.247.8.186', '2019-06-24 17:36:59', 1, 0, '', '2019-06-24 17:36:59');
INSERT INTO `access_log` VALUES (42438, '64.85.15613690356581307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.247.8.186', '2019-06-24 17:37:16', 2, 0, '', '2019-06-24 17:37:16');
INSERT INTO `access_log` VALUES (42439, '64.79.15613690378001299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.247.8.186', '2019-06-24 17:37:18', 2, 0, '', '2019-06-24 17:37:18');
INSERT INTO `access_log` VALUES (42440, '66.52.15613691692599511', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17621432283&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.247.8.186', '2019-06-24 17:39:29', 16, 1001003000, '验证码不存在', '2019-06-24 17:39:29');
INSERT INTO `access_log` VALUES (42441, '66.54.15613691723009517', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17621432283', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.247.8.186', '2019-06-24 17:39:32', 74, 0, '', '2019-06-24 17:39:32');
INSERT INTO `access_log` VALUES (42442, '66.55.15613691758099503', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17621432283&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.247.8.186', '2019-06-24 17:39:36', 171, 0, '', '2019-06-24 17:39:36');
INSERT INTO `access_log` VALUES (42443, '64.78.15613691869301297', 138, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.247.8.186', '2019-06-24 17:39:47', 5, 0, '', '2019-06-24 17:39:47');
INSERT INTO `access_log` VALUES (42444, '64.80.15613691870211295', 138, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.247.8.186', '2019-06-24 17:39:47', 4, 0, '', '2019-06-24 17:39:47');
INSERT INTO `access_log` VALUES (42445, '64.84.15613691906401287', 138, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.247.8.186', '2019-06-24 17:39:51', 5, 0, '', '2019-06-24 17:39:51');
INSERT INTO `access_log` VALUES (42446, '64.77.15613691909321293', 138, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.247.8.186', '2019-06-24 17:39:51', 5, 0, '', '2019-06-24 17:39:51');
INSERT INTO `access_log` VALUES (42447, '66.49.15613691923419517', 138, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '58.247.8.186', '2019-06-24 17:39:52', 6, 0, '', '2019-06-24 17:39:52');
INSERT INTO `access_log` VALUES (42448, '59.72.15613693496881263', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.151.252', '2019-06-24 17:42:30', 3, 0, '', '2019-06-24 17:42:30');
INSERT INTO `access_log` VALUES (42449, '59.76.15613693496881261', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.151.252', '2019-06-24 17:42:30', 13, 2001001000, '服务端发生异常', '2019-06-24 17:42:30');
INSERT INTO `access_log` VALUES (42450, '64.85.15613693577381313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.151.252', '2019-06-24 17:42:38', 3, 0, '', '2019-06-24 17:42:38');
INSERT INTO `access_log` VALUES (42451, '64.79.15613693578441305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.151.252', '2019-06-24 17:42:38', 2, 0, '', '2019-06-24 17:42:38');
INSERT INTO `access_log` VALUES (42452, '65.3607.15613695344654095', 0, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'displayName=男&enumValue=gender&sort=123&value=1&memo=你猜我猜不猜', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.210.160.13', '2019-06-24 17:45:34', 0, 1002001015, '账号未登陆', '2019-06-24 17:45:34');
INSERT INTO `access_log` VALUES (42453, '59.71.15613712444731293', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.143.195', '2019-06-24 18:14:04', 10, 0, '', '2019-06-24 18:14:04');
INSERT INTO `access_log` VALUES (42454, '59.76.15613712444741287', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.143.195', '2019-06-24 18:14:04', 15, 2001001000, '服务端发生异常', '2019-06-24 18:14:04');
INSERT INTO `access_log` VALUES (42455, '65.45.15613712593602337', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.143.195', '2019-06-24 18:14:19', 0, 1002001015, '账号未登陆', '2019-06-24 18:14:19');
INSERT INTO `access_log` VALUES (42456, '65.51.15613712593602377', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.143.195', '2019-06-24 18:14:19', 0, 1002001015, '账号未登陆', '2019-06-24 18:14:19');
INSERT INTO `access_log` VALUES (42457, '65.50.15613712593612355', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.143.195', '2019-06-24 18:14:19', 1, 1002001015, '账号未登陆', '2019-06-24 18:14:19');
INSERT INTO `access_log` VALUES (42458, '65.49.15613712799982347', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyunma&password=kong batch add plugins&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.143.195', '2019-06-24 18:14:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 18:14:40');
INSERT INTO `access_log` VALUES (42459, '65.3607.15613712929414121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.143.195', '2019-06-24 18:14:53', 83, 0, '', '2019-06-24 18:14:53');
INSERT INTO `access_log` VALUES (42460, '65.46.15613712933292387', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.143.195', '2019-06-24 18:14:53', 376, 0, '', '2019-06-24 18:14:54');
INSERT INTO `access_log` VALUES (42461, '65.47.15613712933372321', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.143.195', '2019-06-24 18:14:53', 372, 0, '', '2019-06-24 18:14:54');
INSERT INTO `access_log` VALUES (42462, '65.53.15613712933342333', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.143.195', '2019-06-24 18:14:53', 382, 2001001000, '服务端发生异常', '2019-06-24 18:14:54');
INSERT INTO `access_log` VALUES (42463, '65.52.15613713248342357', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.143.195', '2019-06-24 18:15:25', 10, 0, '', '2019-06-24 18:15:25');
INSERT INTO `access_log` VALUES (42464, '65.54.15613713248422303', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.143.195', '2019-06-24 18:15:25', 10, 2001001000, '服务端发生异常', '2019-06-24 18:15:25');
INSERT INTO `access_log` VALUES (42465, '65.49.15613713248462349', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.195.143.195', '2019-06-24 18:15:25', 9, 0, '', '2019-06-24 18:15:25');
INSERT INTO `access_log` VALUES (42466, '59.77.15613713471591279', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:15:47', 4, 0, '', '2019-06-24 18:15:47');
INSERT INTO `access_log` VALUES (42467, '59.80.15613713471591281', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:15:47', 14, 2001001000, '服务端发生异常', '2019-06-24 18:15:47');
INSERT INTO `access_log` VALUES (42468, '64.80.15613713511011325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:15:51', 9, 0, '', '2019-06-24 18:15:51');
INSERT INTO `access_log` VALUES (42469, '64.82.15613713512311335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:15:51', 2, 0, '', '2019-06-24 18:15:51');
INSERT INTO `access_log` VALUES (42470, '64.84.15613713525941317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:15:53', 1, 0, '', '2019-06-24 18:15:53');
INSERT INTO `access_log` VALUES (42471, '64.77.15613713529391323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:15:53', 2, 0, '', '2019-06-24 18:15:53');
INSERT INTO `access_log` VALUES (42472, '64.76.15613713534111311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:15:53', 2, 0, '', '2019-06-24 18:15:53');
INSERT INTO `access_log` VALUES (42473, '59.76.15613713546651289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:15:55', 3, 0, '', '2019-06-24 18:15:55');
INSERT INTO `access_log` VALUES (42474, '59.72.15613713546651291', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:15:55', 13, 2001001000, '服务端发生异常', '2019-06-24 18:15:55');
INSERT INTO `access_log` VALUES (42475, '64.85.15613713570271341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:15:57', 2, 0, '', '2019-06-24 18:15:57');
INSERT INTO `access_log` VALUES (42476, '64.79.15613713571741333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:15:57', 2, 0, '', '2019-06-24 18:15:57');
INSERT INTO `access_log` VALUES (42477, '64.83.15613713583321319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:15:58', 2, 0, '', '2019-06-24 18:15:58');
INSERT INTO `access_log` VALUES (42478, '64.78.15613713587081329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:15:59', 2, 0, '', '2019-06-24 18:15:59');
INSERT INTO `access_log` VALUES (42479, '59.73.15613713597311299', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:16:00', 2, 0, '', '2019-06-24 18:16:00');
INSERT INTO `access_log` VALUES (42480, '59.74.15613713597321293', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.112.57.190', '2019-06-24 18:16:00', 13, 2001001000, '服务端发生异常', '2019-06-24 18:16:00');
INSERT INTO `access_log` VALUES (42481, '59.73.15613725088271315', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '39.128.153.81', '2019-06-24 18:35:09', 3, 0, '', '2019-06-24 18:35:09');
INSERT INTO `access_log` VALUES (42482, '59.76.15613725088251305', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '39.128.153.81', '2019-06-24 18:35:09', 13, 2001001000, '服务端发生异常', '2019-06-24 18:35:09');
INSERT INTO `access_log` VALUES (42483, '64.79.15613725122671349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '39.128.153.81', '2019-06-24 18:35:12', 2, 0, '', '2019-06-24 18:35:12');
INSERT INTO `access_log` VALUES (42484, '64.83.15613725124241335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '39.128.153.81', '2019-06-24 18:35:12', 2, 0, '', '2019-06-24 18:35:12');
INSERT INTO `access_log` VALUES (42485, '64.78.15613725142181345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '39.128.153.81', '2019-06-24 18:35:14', 2, 0, '', '2019-06-24 18:35:14');
INSERT INTO `access_log` VALUES (42486, '64.81.15613725146911341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '39.128.153.81', '2019-06-24 18:35:15', 2, 0, '', '2019-06-24 18:35:15');
INSERT INTO `access_log` VALUES (42487, '59.73.15613763785801367', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 19:39:39', 17, 0, '', '2019-06-24 19:39:39');
INSERT INTO `access_log` VALUES (42488, '59.76.15613763785831357', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 19:39:39', 20, 2001001000, '服务端发生异常', '2019-06-24 19:39:39');
INSERT INTO `access_log` VALUES (42489, '64.78.15613763853551397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 19:39:45', 11, 0, '', '2019-06-24 19:39:45');
INSERT INTO `access_log` VALUES (42490, '64.81.15613763854491393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 19:39:45', 2, 0, '', '2019-06-24 19:39:45');
INSERT INTO `access_log` VALUES (42491, '64.80.15613763872931395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 19:39:47', 2, 0, '', '2019-06-24 19:39:47');
INSERT INTO `access_log` VALUES (42492, '64.82.15613763881901405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 19:39:48', 2, 0, '', '2019-06-24 19:39:48');
INSERT INTO `access_log` VALUES (42493, '64.77.15613763944561393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 19:39:54', 2, 0, '', '2019-06-24 19:39:54');
INSERT INTO `access_log` VALUES (42494, '64.76.15613763945641381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 19:39:55', 2, 0, '', '2019-06-24 19:39:55');
INSERT INTO `access_log` VALUES (42495, '59.79.15613763953781367', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 19:39:55', 9, 0, '', '2019-06-24 19:39:55');
INSERT INTO `access_log` VALUES (42496, '59.75.15613763953791367', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '42.120.73.162', '2019-06-24 19:39:55', 10, 2001001000, '服务端发生异常', '2019-06-24 19:39:55');
INSERT INTO `access_log` VALUES (42497, '65.53.15613779992232425', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.154.40.241', '2019-06-24 20:06:39', 1, 1002001015, '账号未登陆', '2019-06-24 20:06:39');
INSERT INTO `access_log` VALUES (42498, '65.50.15613779992242447', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.154.40.241', '2019-06-24 20:06:39', 0, 1002001015, '账号未登陆', '2019-06-24 20:06:39');
INSERT INTO `access_log` VALUES (42499, '65.51.15613779992242471', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.154.40.241', '2019-06-24 20:06:39', 0, 1002001015, '账号未登陆', '2019-06-24 20:06:39');
INSERT INTO `access_log` VALUES (42500, '65.45.15613780015832429', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.154.40.241', '2019-06-24 20:06:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 20:06:42');
INSERT INTO `access_log` VALUES (42501, '65.52.15613780087792449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.154.40.241', '2019-06-24 20:06:49', 100, 0, '', '2019-06-24 20:06:49');
INSERT INTO `access_log` VALUES (42502, '65.49.15613780090892441', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.154.40.241', '2019-06-24 20:06:49', 16, 0, '', '2019-06-24 20:06:49');
INSERT INTO `access_log` VALUES (42503, '65.3607.15613780090934213', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.154.40.241', '2019-06-24 20:06:49', 16, 2001001000, '服务端发生异常', '2019-06-24 20:06:49');
INSERT INTO `access_log` VALUES (42504, '65.46.15613780090962479', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.154.40.241', '2019-06-24 20:06:49', 17, 0, '', '2019-06-24 20:06:49');
INSERT INTO `access_log` VALUES (42505, '65.49.15613782868962445', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '43.254.89.90', '2019-06-24 20:11:27', 1, 1002001015, '账号未登陆', '2019-06-24 20:11:27');
INSERT INTO `access_log` VALUES (42506, '65.54.15613782868972399', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '43.254.89.90', '2019-06-24 20:11:27', 1, 1002001015, '账号未登陆', '2019-06-24 20:11:27');
INSERT INTO `access_log` VALUES (42507, '65.47.15613782869002417', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '43.254.89.90', '2019-06-24 20:11:27', 1, 1002001015, '账号未登陆', '2019-06-24 20:11:27');
INSERT INTO `access_log` VALUES (42508, '65.51.15613782895002477', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '43.254.89.90', '2019-06-24 20:11:30', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 20:11:30');
INSERT INTO `access_log` VALUES (42509, '65.50.15613782934432453', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '43.254.89.90', '2019-06-24 20:11:33', 89, 0, '', '2019-06-24 20:11:34');
INSERT INTO `access_log` VALUES (42510, '65.53.15613782937272431', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '43.254.89.90', '2019-06-24 20:11:34', 16, 0, '', '2019-06-24 20:11:34');
INSERT INTO `access_log` VALUES (42511, '65.45.15613782937302435', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '43.254.89.90', '2019-06-24 20:11:34', 17, 2001001000, '服务端发生异常', '2019-06-24 20:11:34');
INSERT INTO `access_log` VALUES (42512, '65.52.15613782937382455', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '43.254.89.90', '2019-06-24 20:11:34', 8, 0, '', '2019-06-24 20:11:34');
INSERT INTO `access_log` VALUES (42513, '65.46.15613783065082485', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '43.254.89.90', '2019-06-24 20:11:47', 8, 0, '', '2019-06-24 20:11:47');
INSERT INTO `access_log` VALUES (42514, '65.49.15613783065132447', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '43.254.89.90', '2019-06-24 20:11:47', 8, 2001001000, '服务端发生异常', '2019-06-24 20:11:47');
INSERT INTO `access_log` VALUES (42515, '65.54.15613783065152401', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '43.254.89.90', '2019-06-24 20:11:47', 7, 0, '', '2019-06-24 20:11:47');
INSERT INTO `access_log` VALUES (42516, '65.49.15613799227822469', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.214', '2019-06-24 20:38:43', 1, 1002001015, '账号未登陆', '2019-06-24 20:38:43');
INSERT INTO `access_log` VALUES (42517, '65.47.15613799227822441', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.212', '2019-06-24 20:38:43', 0, 1002001015, '账号未登陆', '2019-06-24 20:38:43');
INSERT INTO `access_log` VALUES (42518, '65.54.15613799227822423', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.212', '2019-06-24 20:38:43', 1, 1002001015, '账号未登陆', '2019-06-24 20:38:43');
INSERT INTO `access_log` VALUES (42519, '65.51.15613806071822509', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.237.50.142', '2019-06-24 20:50:07', 1, 1002001015, '账号未登陆', '2019-06-24 20:50:07');
INSERT INTO `access_log` VALUES (42520, '65.54.15613806071862433', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.237.50.142', '2019-06-24 20:50:07', 0, 1002001015, '账号未登陆', '2019-06-24 20:50:07');
INSERT INTO `access_log` VALUES (42521, '65.50.15613806071932485', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.237.50.142', '2019-06-24 20:50:07', 0, 1002001015, '账号未登陆', '2019-06-24 20:50:07');
INSERT INTO `access_log` VALUES (42522, '65.53.15613806206132465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.237.50.142', '2019-06-24 20:50:21', 91, 0, '', '2019-06-24 20:50:21');
INSERT INTO `access_log` VALUES (42523, '65.3607.15613806213684253', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.237.50.142', '2019-06-24 20:50:21', 10, 0, '', '2019-06-24 20:50:21');
INSERT INTO `access_log` VALUES (42524, '65.49.15613806213772481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.237.50.142', '2019-06-24 20:50:21', 10, 2001001000, '服务端发生异常', '2019-06-24 20:50:21');
INSERT INTO `access_log` VALUES (42525, '65.52.15613806213872489', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.237.50.142', '2019-06-24 20:50:21', 9, 0, '', '2019-06-24 20:50:21');
INSERT INTO `access_log` VALUES (42526, '65.50.15613806536742487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.237.50.142', '2019-06-24 20:50:54', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 20:50:54');
INSERT INTO `access_log` VALUES (42527, '65.54.15613806602092435', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.237.50.142', '2019-06-24 20:51:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 20:51:00');
INSERT INTO `access_log` VALUES (42528, '65.51.15613809253422515', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/75.0.3770.85 Mobile/15E148 Safari/605.1', '115.171.62.254', '2019-06-24 20:55:25', 1, 1002001015, '账号未登陆', '2019-06-24 20:55:25');
INSERT INTO `access_log` VALUES (42529, '65.45.15613809253462475', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/75.0.3770.85 Mobile/15E148 Safari/605.1', '115.171.62.254', '2019-06-24 20:55:25', 0, 1002001015, '账号未登陆', '2019-06-24 20:55:25');
INSERT INTO `access_log` VALUES (42530, '65.54.15613809253462439', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/75.0.3770.85 Mobile/15E148 Safari/605.1', '115.171.62.254', '2019-06-24 20:55:25', 1, 1002001015, '账号未登陆', '2019-06-24 20:55:25');
INSERT INTO `access_log` VALUES (42531, '65.53.15613809282782471', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/75.0.3770.85 Mobile/15E148 Safari/605.1', '115.171.62.254', '2019-06-24 20:55:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 20:55:28');
INSERT INTO `access_log` VALUES (42532, '65.3607.15613809431344259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/75.0.3770.85 Mobile/15E148 Safari/605.1', '115.171.62.254', '2019-06-24 20:55:43', 82, 0, '', '2019-06-24 20:55:43');
INSERT INTO `access_log` VALUES (42533, '65.49.15613809435772487', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/75.0.3770.85 Mobile/15E148 Safari/605.1', '115.171.62.254', '2019-06-24 20:55:44', 19, 2001001000, '服务端发生异常', '2019-06-24 20:55:44');
INSERT INTO `access_log` VALUES (42534, '65.46.15613809435772525', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/75.0.3770.85 Mobile/15E148 Safari/605.1', '115.171.62.254', '2019-06-24 20:55:44', 20, 0, '', '2019-06-24 20:55:44');
INSERT INTO `access_log` VALUES (42535, '65.47.15613809435862459', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/75.0.3770.85 Mobile/15E148 Safari/605.1', '115.171.62.254', '2019-06-24 20:55:44', 11, 0, '', '2019-06-24 20:55:44');
INSERT INTO `access_log` VALUES (42536, '65.45.15613809577752477', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/75.0.3770.85 Mobile/15E148 Safari/605.1', '115.171.62.254', '2019-06-24 20:55:58', 9, 0, '', '2019-06-24 20:55:58');
INSERT INTO `access_log` VALUES (42537, '65.51.15613809577792517', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/75.0.3770.85 Mobile/15E148 Safari/605.1', '115.171.62.254', '2019-06-24 20:55:58', 10, 2001001000, '服务端发生异常', '2019-06-24 20:55:58');
INSERT INTO `access_log` VALUES (42538, '65.54.15613809577822441', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/75.0.3770.85 Mobile/15E148 Safari/605.1', '115.171.62.254', '2019-06-24 20:55:58', 9, 0, '', '2019-06-24 20:55:58');
INSERT INTO `access_log` VALUES (42539, '65.47.15613810331002461', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.237.50.142', '2019-06-24 20:57:13', 104, 0, '', '2019-06-24 20:57:13');
INSERT INTO `access_log` VALUES (42540, '65.50.15613810336172495', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.237.50.142', '2019-06-24 20:57:14', 9, 0, '', '2019-06-24 20:57:14');
INSERT INTO `access_log` VALUES (42541, '65.51.15613810336282519', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.237.50.142', '2019-06-24 20:57:14', 10, 2001001000, '服务端发生异常', '2019-06-24 20:57:14');
INSERT INTO `access_log` VALUES (42542, '65.45.15613810336452479', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.237.50.142', '2019-06-24 20:57:14', 9, 0, '', '2019-06-24 20:57:14');
INSERT INTO `access_log` VALUES (42543, '65.45.15613826660242501', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.235.37.83', '2019-06-24 21:24:26', 0, 1002001015, '账号未登陆', '2019-06-24 21:24:26');
INSERT INTO `access_log` VALUES (42544, '65.54.15613826660252465', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.235.37.83', '2019-06-24 21:24:26', 0, 1002001015, '账号未登陆', '2019-06-24 21:24:26');
INSERT INTO `access_log` VALUES (42545, '65.53.15613826660292497', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.235.37.83', '2019-06-24 21:24:26', 0, 1002001015, '账号未登陆', '2019-06-24 21:24:26');
INSERT INTO `access_log` VALUES (42546, '65.52.15613826688082521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.235.37.83', '2019-06-24 21:24:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 21:24:29');
INSERT INTO `access_log` VALUES (42547, '65.46.15613826794692551', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.235.37.83', '2019-06-24 21:24:39', 123, 0, '', '2019-06-24 21:24:40');
INSERT INTO `access_log` VALUES (42548, '65.49.15613826798022513', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.235.37.83', '2019-06-24 21:24:40', 9, 0, '', '2019-06-24 21:24:40');
INSERT INTO `access_log` VALUES (42549, '65.47.15613826798022485', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.235.37.83', '2019-06-24 21:24:40', 11, 2001001000, '服务端发生异常', '2019-06-24 21:24:40');
INSERT INTO `access_log` VALUES (42550, '65.51.15613826798102543', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.235.37.83', '2019-06-24 21:24:40', 9, 0, '', '2019-06-24 21:24:40');
INSERT INTO `access_log` VALUES (42551, '59.71.15613834919921459', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:12', 13, 0, '', '2019-06-24 21:38:12');
INSERT INTO `access_log` VALUES (42552, '59.72.15613834919921455', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.12', '2019-06-24 21:38:12', 17, 2001001000, '服务端发生异常', '2019-06-24 21:38:12');
INSERT INTO `access_log` VALUES (42553, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=test&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:18', 7, 0, '', '2019-06-24 21:38:18');
INSERT INTO `access_log` VALUES (42554, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=test', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:19', 5, 0, '', '2019-06-24 21:38:19');
INSERT INTO `access_log` VALUES (42555, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:25', 7, 0, '', '2019-06-24 21:38:25');
INSERT INTO `access_log` VALUES (42556, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:25', 20, 0, '', '2019-06-24 21:38:25');
INSERT INTO `access_log` VALUES (42557, '64.81.15613835072081489', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:27', 7, 0, '', '2019-06-24 21:38:27');
INSERT INTO `access_log` VALUES (42558, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:30', 6, 0, '', '2019-06-24 21:38:30');
INSERT INTO `access_log` VALUES (42559, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.12', '2019-06-24 21:38:31', 5, 0, '', '2019-06-24 21:38:31');
INSERT INTO `access_log` VALUES (42560, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:31', 10, 0, '', '2019-06-24 21:38:31');
INSERT INTO `access_log` VALUES (42561, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:31', 10, 0, '', '2019-06-24 21:38:31');
INSERT INTO `access_log` VALUES (42562, '64.80.15613835123241491', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:32', 6, 0, '', '2019-06-24 21:38:32');
INSERT INTO `access_log` VALUES (42563, '66.55.15613835170229695', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空', '2019-06-24 21:38:37');
INSERT INTO `access_log` VALUES (42564, '64.84.15613835193561483', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:39', 7, 0, '', '2019-06-24 21:38:39');
INSERT INTO `access_log` VALUES (42565, '64.77.15613835222331489', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:42', 7, 0, '', '2019-06-24 21:38:42');
INSERT INTO `access_log` VALUES (42566, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:43', 7, 0, '', '2019-06-24 21:38:43');
INSERT INTO `access_log` VALUES (42567, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.12', '2019-06-24 21:38:43', 5, 0, '', '2019-06-24 21:38:43');
INSERT INTO `access_log` VALUES (42568, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.4', '2019-06-24 21:38:43', 11, 0, '', '2019-06-24 21:38:43');
INSERT INTO `access_log` VALUES (42569, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.12', '2019-06-24 21:38:43', 10, 0, '', '2019-06-24 21:38:43');
INSERT INTO `access_log` VALUES (42570, '64.76.15613835273481477', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '122.226.184.12', '2019-06-24 21:38:47', 6, 0, '', '2019-06-24 21:38:47');
INSERT INTO `access_log` VALUES (42571, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=test', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.89.19.197', '2019-06-24 21:39:23', 6, 0, '', '2019-06-24 21:39:23');
INSERT INTO `access_log` VALUES (42572, '59.78.15613835647491455', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.178.197', '2019-06-24 21:39:25', 4, 0, '', '2019-06-24 21:39:25');
INSERT INTO `access_log` VALUES (42573, '59.77.15613835686021445', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.60.110', '2019-06-24 21:39:29', 13, 2001001000, '服务端发生异常', '2019-06-24 21:39:29');
INSERT INTO `access_log` VALUES (42574, '64.78.15613835698351495', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.227.139.161', '2019-06-24 21:39:30', 7, 0, '', '2019-06-24 21:39:30');
INSERT INTO `access_log` VALUES (42575, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.178.174', '2019-06-24 21:39:33', 6, 0, '', '2019-06-24 21:39:33');
INSERT INTO `access_log` VALUES (42576, '64.81.15613835746261491', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.129.6.151', '2019-06-24 21:39:35', 6, 0, '', '2019-06-24 21:39:35');
INSERT INTO `access_log` VALUES (42577, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.129.6.151', '2019-06-24 21:39:36', 11, 0, '', '2019-06-24 21:39:36');
INSERT INTO `access_log` VALUES (42578, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.89.29.94', '2019-06-24 21:39:37', 7, 0, '', '2019-06-24 21:39:37');
INSERT INTO `access_log` VALUES (42579, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.91.60.107', '2019-06-24 21:39:45', 7, 0, '', '2019-06-24 21:39:46');
INSERT INTO `access_log` VALUES (42580, '64.84.15613836013521485', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.89.19.149', '2019-06-24 21:40:01', 6, 0, '', '2019-06-24 21:40:01');
INSERT INTO `access_log` VALUES (42581, '65.54.15613838150202481', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '116.232.205.34', '2019-06-24 21:43:35', 0, 1002001015, '账号未登陆', '2019-06-24 21:43:35');
INSERT INTO `access_log` VALUES (42582, '65.49.15613838164972527', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '116.232.205.34', '2019-06-24 21:43:36', 0, 1002001015, '账号未登陆', '2019-06-24 21:43:36');
INSERT INTO `access_log` VALUES (42583, '65.46.15613838170422569', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '116.232.205.34', '2019-06-24 21:43:37', 1, 1002001015, '账号未登陆', '2019-06-24 21:43:37');
INSERT INTO `access_log` VALUES (42584, '65.50.15613838172262535', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '116.232.205.34', '2019-06-24 21:43:37', 1, 1002001015, '账号未登陆', '2019-06-24 21:43:37');
INSERT INTO `access_log` VALUES (42585, '65.53.15613838195372517', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '116.232.205.34', '2019-06-24 21:43:40', 0, 1002001015, '账号未登陆', '2019-06-24 21:43:40');
INSERT INTO `access_log` VALUES (42586, '65.3607.15613842981994307', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '49.84.143.67', '2019-06-24 21:51:38', 1, 1002001015, '账号未登陆', '2019-06-24 21:51:38');
INSERT INTO `access_log` VALUES (42587, '65.46.15613842981982577', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '49.84.143.67', '2019-06-24 21:51:38', 1, 1002001015, '账号未登陆', '2019-06-24 21:51:38');
INSERT INTO `access_log` VALUES (42588, '65.54.15613842982002489', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '49.84.143.67', '2019-06-24 21:51:38', 1, 1002001015, '账号未登陆', '2019-06-24 21:51:38');
INSERT INTO `access_log` VALUES (42589, '65.53.15613842998642525', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '49.84.143.67', '2019-06-24 21:51:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 21:51:40');
INSERT INTO `access_log` VALUES (42590, '65.52.15613843120232547', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '49.84.143.67', '2019-06-24 21:51:52', 102, 0, '', '2019-06-24 21:51:52');
INSERT INTO `access_log` VALUES (42591, '65.51.15613843123742569', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '49.84.143.67', '2019-06-24 21:51:52', 9, 0, '', '2019-06-24 21:51:52');
INSERT INTO `access_log` VALUES (42592, '65.47.15613843123772509', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '49.84.143.67', '2019-06-24 21:51:52', 9, 2001001000, '服务端发生异常', '2019-06-24 21:51:52');
INSERT INTO `access_log` VALUES (42593, '65.50.15613843123812545', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '49.84.143.67', '2019-06-24 21:51:52', 7, 0, '', '2019-06-24 21:51:52');
INSERT INTO `access_log` VALUES (42594, '65.45.15613846684312535', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '49.84.143.67', '2019-06-24 21:57:48', 11, 0, '', '2019-06-24 21:57:48');
INSERT INTO `access_log` VALUES (42595, '65.53.15613846684332531', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '49.84.143.67', '2019-06-24 21:57:48', 10, 2001001000, '服务端发生异常', '2019-06-24 21:57:48');
INSERT INTO `access_log` VALUES (42596, '65.52.15613846684362553', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '49.84.143.67', '2019-06-24 21:57:48', 9, 0, '', '2019-06-24 21:57:48');
INSERT INTO `access_log` VALUES (42597, '59.74.15613867943361501', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.27.198.170', '2019-06-24 22:33:14', 17, 0, '', '2019-06-24 22:33:14');
INSERT INTO `access_log` VALUES (42598, '59.75.15613867943361507', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.27.198.170', '2019-06-24 22:33:14', 22, 2001001000, '服务端发生异常', '2019-06-24 22:33:14');
INSERT INTO `access_log` VALUES (42599, '64.79.15613867976211543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.27.198.170', '2019-06-24 22:33:18', 9, 0, '', '2019-06-24 22:33:18');
INSERT INTO `access_log` VALUES (42600, '64.83.15613867977401529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.27.198.170', '2019-06-24 22:33:18', 2, 0, '', '2019-06-24 22:33:18');
INSERT INTO `access_log` VALUES (42601, '64.78.15613867992081539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.27.198.170', '2019-06-24 22:33:19', 2, 0, '', '2019-06-24 22:33:19');
INSERT INTO `access_log` VALUES (42602, '64.81.15613868000841535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.27.198.170', '2019-06-24 22:33:20', 1, 0, '', '2019-06-24 22:33:20');
INSERT INTO `access_log` VALUES (42603, '64.82.15613868006341547', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.27.198.170', '2019-06-24 22:33:21', 2, 0, '', '2019-06-24 22:33:21');
INSERT INTO `access_log` VALUES (42604, '64.84.15613868011141529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.27.198.170', '2019-06-24 22:33:21', 1, 0, '', '2019-06-24 22:33:21');
INSERT INTO `access_log` VALUES (42605, '64.77.15613868016051535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.27.198.170', '2019-06-24 22:33:22', 2, 0, '', '2019-06-24 22:33:22');
INSERT INTO `access_log` VALUES (42606, '64.76.15613868019961523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.27.198.170', '2019-06-24 22:33:22', 2, 0, '', '2019-06-24 22:33:22');
INSERT INTO `access_log` VALUES (42607, '64.85.15613868024371553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.27.198.170', '2019-06-24 22:33:22', 2, 0, '', '2019-06-24 22:33:22');
INSERT INTO `access_log` VALUES (42608, '64.79.15613868027441545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.27.198.170', '2019-06-24 22:33:23', 1, 0, '', '2019-06-24 22:33:23');
INSERT INTO `access_log` VALUES (42609, '59.74.15613876777561513', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.127.148.18', '2019-06-24 22:47:58', 3, 0, '', '2019-06-24 22:47:58');
INSERT INTO `access_log` VALUES (42610, '59.79.15613876777571519', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.127.148.18', '2019-06-24 22:47:58', 17, 2001001000, '服务端发生异常', '2019-06-24 22:47:58');
INSERT INTO `access_log` VALUES (42611, '65.54.15613903112992571', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-24 23:31:51', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 23:31:51');
INSERT INTO `access_log` VALUES (42612, '65.52.15613903240362629', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-24 23:32:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-24 23:32:04');
INSERT INTO `access_log` VALUES (42613, '65.50.15613903298812627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-24 23:32:10', 5, 1002002001, '密码不正确', '2019-06-24 23:32:10');
INSERT INTO `access_log` VALUES (42614, '65.47.15613903368722591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-24 23:32:17', 62, 0, '', '2019-06-24 23:32:17');
INSERT INTO `access_log` VALUES (42615, '65.51.15613903372462651', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.212', '2019-06-24 23:32:17', 12, 0, '', '2019-06-24 23:32:17');
INSERT INTO `access_log` VALUES (42616, '65.49.15613903372522617', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-24 23:32:17', 16, 0, '', '2019-06-24 23:32:17');
INSERT INTO `access_log` VALUES (42617, '65.46.15613903372592661', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.212', '2019-06-24 23:32:17', 15, 0, '', '2019-06-24 23:32:17');
INSERT INTO `access_log` VALUES (42618, '62.83.15613903481541125', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.212', '2019-06-24 23:32:28', 33, 0, '', '2019-06-24 23:32:28');
INSERT INTO `access_log` VALUES (42619, '62.81.15613903610251097', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-24 23:32:41', 33, 0, '', '2019-06-24 23:32:41');
INSERT INTO `access_log` VALUES (42620, '64.85.15613903659771601', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.212', '2019-06-24 23:32:46', 18, 0, '', '2019-06-24 23:32:46');
INSERT INTO `access_log` VALUES (42621, '64.76.15613903659701571', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.213', '2019-06-24 23:32:46', 25, 0, '', '2019-06-24 23:32:46');
INSERT INTO `access_log` VALUES (42622, '59.78.15613903733641547', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.212', '2019-06-24 23:32:53', 26, 0, '', '2019-06-24 23:32:53');
INSERT INTO `access_log` VALUES (42623, '64.83.15613903748771579', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.212', '2019-06-24 23:32:55', 119, 0, '', '2019-06-24 23:32:55');
INSERT INTO `access_log` VALUES (42624, '64.81.15613903906121585', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.194.212', '2019-06-24 23:33:11', 11, 0, '', '2019-06-24 23:33:11');
INSERT INTO `access_log` VALUES (42625, '65.51.15613923890872679', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-25 00:06:29', 12, 1002001012, '访问令牌已过期', '2019-06-25 00:06:29');
INSERT INTO `access_log` VALUES (42626, '65.49.15613923890872645', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-25 00:06:29', 15, 1002001012, '访问令牌已过期', '2019-06-25 00:06:29');
INSERT INTO `access_log` VALUES (42627, '65.46.15613923891052689', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-25 00:06:29', 10, 1002001012, '访问令牌已过期', '2019-06-25 00:06:29');
INSERT INTO `access_log` VALUES (42628, '65.3607.15613923907454419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-25 00:06:31', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 00:06:31');
INSERT INTO `access_log` VALUES (42629, '65.52.15613924272522659', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-25 00:07:07', 76, 0, '', '2019-06-25 00:07:07');
INSERT INTO `access_log` VALUES (42630, '65.47.15613924275462621', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-25 00:07:08', 105, 0, '', '2019-06-25 00:07:08');
INSERT INTO `access_log` VALUES (42631, '65.45.15613924275432641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-25 00:07:08', 107, 2001001000, '服务端发生异常', '2019-06-25 00:07:08');
INSERT INTO `access_log` VALUES (42632, '65.50.15613924275442657', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-25 00:07:08', 107, 0, '', '2019-06-25 00:07:08');
INSERT INTO `access_log` VALUES (42633, '65.52.15613938453982679', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.0 Mobile/15E148 Safari/604.1', '27.17.160.147', '2019-06-25 00:30:45', 0, 1002001015, '账号未登陆', '2019-06-25 00:30:45');
INSERT INTO `access_log` VALUES (42634, '65.53.15613938453982657', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.0 Mobile/15E148 Safari/604.1', '27.17.160.147', '2019-06-25 00:30:45', 1, 1002001015, '账号未登陆', '2019-06-25 00:30:45');
INSERT INTO `access_log` VALUES (42635, '65.50.15613938454042677', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.0 Mobile/15E148 Safari/604.1', '27.17.160.147', '2019-06-25 00:30:45', 0, 1002001015, '账号未登陆', '2019-06-25 00:30:45');
INSERT INTO `access_log` VALUES (42636, '65.45.15613938496132661', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.0 Mobile/15E148 Safari/604.1', '27.17.160.147', '2019-06-25 00:30:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 00:30:50');
INSERT INTO `access_log` VALUES (42637, '65.51.15613938620362701', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.0 Mobile/15E148 Safari/604.1', '27.17.160.147', '2019-06-25 00:31:02', 79, 0, '', '2019-06-25 00:31:02');
INSERT INTO `access_log` VALUES (42638, '65.49.15613938624752667', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.0 Mobile/15E148 Safari/604.1', '27.17.160.147', '2019-06-25 00:31:02', 10, 0, '', '2019-06-25 00:31:02');
INSERT INTO `access_log` VALUES (42639, '65.46.15613938624792711', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.0 Mobile/15E148 Safari/604.1', '27.17.160.147', '2019-06-25 00:31:02', 11, 2001001000, '服务端发生异常', '2019-06-25 00:31:02');
INSERT INTO `access_log` VALUES (42640, '65.3607.15613938624824441', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.0 Mobile/15E148 Safari/604.1', '27.17.160.147', '2019-06-25 00:31:02', 10, 0, '', '2019-06-25 00:31:02');
INSERT INTO `access_log` VALUES (42641, '65.45.15614207745513019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '116.232.205.34', '2019-06-25 07:59:35', 20, 1002002001, '密码不正确', '2019-06-25 07:59:35');
INSERT INTO `access_log` VALUES (42642, '65.51.15614207755343061', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '116.232.205.34', '2019-06-25 07:59:36', 5, 1002002001, '密码不正确', '2019-06-25 07:59:36');
INSERT INTO `access_log` VALUES (42643, '65.47.15614207757192999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '116.232.205.34', '2019-06-25 07:59:36', 4, 1002002001, '密码不正确', '2019-06-25 07:59:36');
INSERT INTO `access_log` VALUES (42644, '65.49.15614207759083029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '116.232.205.34', '2019-06-25 07:59:36', 4, 1002002001, '密码不正确', '2019-06-25 07:59:36');
INSERT INTO `access_log` VALUES (42645, '65.46.15614207761003073', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '116.232.205.34', '2019-06-25 07:59:36', 4, 1002002001, '密码不正确', '2019-06-25 07:59:36');
INSERT INTO `access_log` VALUES (42646, '65.3607.15614207763064801', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '116.232.205.34', '2019-06-25 07:59:36', 5, 1002002001, '密码不正确', '2019-06-25 07:59:36');
INSERT INTO `access_log` VALUES (42647, '65.54.15614207765012981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.96 Safari/537.36', '116.232.205.34', '2019-06-25 07:59:37', 4, 1002002001, '密码不正确', '2019-06-25 07:59:37');
INSERT INTO `access_log` VALUES (42648, '59.79.15614237852412001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:49:45', 12, 2001001000, '服务端发生异常', '2019-06-25 08:49:45');
INSERT INTO `access_log` VALUES (42649, '59.74.15614237852381995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:49:45', 10, 0, '', '2019-06-25 08:49:45');
INSERT INTO `access_log` VALUES (42650, '64.83.15614237895872025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:49:50', 151, 0, '', '2019-06-25 08:49:50');
INSERT INTO `access_log` VALUES (42651, '64.78.15614237899002035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:49:50', 3, 0, '', '2019-06-25 08:49:50');
INSERT INTO `access_log` VALUES (42652, '65.45.15614238024803061', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:02', 0, 1002001015, '账号未登陆', '2019-06-25 08:50:02');
INSERT INTO `access_log` VALUES (42653, '65.51.15614238024813103', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:02', 1, 1002001015, '账号未登陆', '2019-06-25 08:50:02');
INSERT INTO `access_log` VALUES (42654, '65.47.15614238024813041', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:02', 0, 1002001015, '账号未登陆', '2019-06-25 08:50:02');
INSERT INTO `access_log` VALUES (42655, '65.49.15614238086483071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:09', 105, 0, '', '2019-06-25 08:50:09');
INSERT INTO `access_log` VALUES (42656, '65.3607.15614238090274843', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:09', 9, 0, '', '2019-06-25 08:50:09');
INSERT INTO `access_log` VALUES (42657, '65.54.15614238090293021', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:09', 10, 2001001000, '服务端发生异常', '2019-06-25 08:50:09');
INSERT INTO `access_log` VALUES (42658, '65.53.15614238090673061', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:09', 7, 0, '', '2019-06-25 08:50:09');
INSERT INTO `access_log` VALUES (42659, '65.52.15614238197403083', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:20', 11, 0, '', '2019-06-25 08:50:20');
INSERT INTO `access_log` VALUES (42660, '65.47.15614238197453043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:20', 10, 0, '', '2019-06-25 08:50:20');
INSERT INTO `access_log` VALUES (42661, '65.50.15614238197453083', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:20', 10, 2001001000, '服务端发生异常', '2019-06-25 08:50:20');
INSERT INTO `access_log` VALUES (42662, '65.51.15614238341073105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:34', 8, 0, '', '2019-06-25 08:50:34');
INSERT INTO `access_log` VALUES (42663, '65.49.15614238341103073', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:34', 7, 2001001000, '服务端发生异常', '2019-06-25 08:50:34');
INSERT INTO `access_log` VALUES (42664, '65.46.15614238341133117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:34', 7, 0, '', '2019-06-25 08:50:34');
INSERT INTO `access_log` VALUES (42665, '65.53.15614238364313063', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:36', 9, 0, '', '2019-06-25 08:50:36');
INSERT INTO `access_log` VALUES (42666, '65.54.15614238364303023', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:36', 9, 0, '', '2019-06-25 08:50:36');
INSERT INTO `access_log` VALUES (42667, '65.3607.15614238364304845', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:50:36', 11, 2001001000, '服务端发生异常', '2019-06-25 08:50:36');
INSERT INTO `access_log` VALUES (42668, '65.53.15614239398563065', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.238.246.187', '2019-06-25 08:52:20', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 08:52:20');
INSERT INTO `access_log` VALUES (42669, '65.3607.15614252907034865', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-25 09:14:51', 1038, 1002001012, '访问令牌已过期', '2019-06-25 09:14:52');
INSERT INTO `access_log` VALUES (42670, '65.54.15614252907043043', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-25 09:14:51', 1037, 1002001012, '访问令牌已过期', '2019-06-25 09:14:52');
INSERT INTO `access_log` VALUES (42671, '65.52.15614252907073105', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '171.217.92.76', '2019-06-25 09:14:51', 1034, 1002001012, '访问令牌已过期', '2019-06-25 09:14:52');
INSERT INTO `access_log` VALUES (42672, '59.72.15614263699052029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:32:50', 10, 0, '', '2019-06-25 09:32:50');
INSERT INTO `access_log` VALUES (42673, '59.71.15614263699052033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:32:50', 15, 2001001000, '服务端发生异常', '2019-06-25 09:32:50');
INSERT INTO `access_log` VALUES (42674, '64.84.15614263784602059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:32:58', 10, 0, '', '2019-06-25 09:32:58');
INSERT INTO `access_log` VALUES (42675, '64.77.15614263785902065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:32:59', 2, 0, '', '2019-06-25 09:32:59');
INSERT INTO `access_log` VALUES (42676, '64.76.15614263797762053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:33:00', 2, 0, '', '2019-06-25 09:33:00');
INSERT INTO `access_log` VALUES (42677, '64.85.15614263803232083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:33:00', 2, 0, '', '2019-06-25 09:33:00');
INSERT INTO `access_log` VALUES (42678, '64.79.15614263806612075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:33:01', 2, 0, '', '2019-06-25 09:33:01');
INSERT INTO `access_log` VALUES (42679, '59.73.15614263815522037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:33:02', 3, 0, '', '2019-06-25 09:33:02');
INSERT INTO `access_log` VALUES (42680, '59.76.15614263815572027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:33:02', 13, 2001001000, '服务端发生异常', '2019-06-25 09:33:02');
INSERT INTO `access_log` VALUES (42681, '59.78.15614264037782029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '218.4.150.14', '2019-06-25 09:33:24', 2, 0, '', '2019-06-25 09:33:24');
INSERT INTO `access_log` VALUES (42682, '59.79.15614264037782037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '218.4.150.14', '2019-06-25 09:33:24', 13, 2001001000, '服务端发生异常', '2019-06-25 09:33:24');
INSERT INTO `access_log` VALUES (42683, '64.81.15614264070462065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '218.4.150.14', '2019-06-25 09:33:27', 3, 0, '', '2019-06-25 09:33:27');
INSERT INTO `access_log` VALUES (42684, '64.80.15614264072622069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '218.4.150.14', '2019-06-25 09:33:27', 2, 0, '', '2019-06-25 09:33:27');
INSERT INTO `access_log` VALUES (42685, '64.82.15614264103992079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '218.4.150.14', '2019-06-25 09:33:30', 2, 0, '', '2019-06-25 09:33:30');
INSERT INTO `access_log` VALUES (42686, '64.84.15614264114642061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '218.4.150.14', '2019-06-25 09:33:31', 1, 0, '', '2019-06-25 09:33:31');
INSERT INTO `access_log` VALUES (42687, '64.76.15614264163342055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '218.4.150.14', '2019-06-25 09:33:36', 2, 0, '', '2019-06-25 09:33:36');
INSERT INTO `access_log` VALUES (42688, '64.85.15614264165092085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '218.4.150.14', '2019-06-25 09:33:37', 2, 0, '', '2019-06-25 09:33:37');
INSERT INTO `access_log` VALUES (42689, '59.80.15614264239962021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '218.4.150.14', '2019-06-25 09:33:44', 3, 0, '', '2019-06-25 09:33:44');
INSERT INTO `access_log` VALUES (42690, '59.71.15614264239992035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '218.4.150.14', '2019-06-25 09:33:44', 13, 2001001000, '服务端发生异常', '2019-06-25 09:33:44');
INSERT INTO `access_log` VALUES (42691, '65.51.15614264478073143', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:34:08', 0, 1002001015, '账号未登陆', '2019-06-25 09:34:08');
INSERT INTO `access_log` VALUES (42692, '65.53.15614264478113099', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:34:08', 0, 1002001015, '账号未登陆', '2019-06-25 09:34:08');
INSERT INTO `access_log` VALUES (42693, '65.46.15614265262873157', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:35:26', 92, 0, '', '2019-06-25 09:35:26');
INSERT INTO `access_log` VALUES (42694, '65.53.15614265268323101', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:35:27', 10, 0, '', '2019-06-25 09:35:27');
INSERT INTO `access_log` VALUES (42695, '65.49.15614265268293113', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:35:27', 12, 2001001000, '服务端发生异常', '2019-06-25 09:35:27');
INSERT INTO `access_log` VALUES (42696, '65.51.15614265269573145', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:35:27', 8, 0, '', '2019-06-25 09:35:27');
INSERT INTO `access_log` VALUES (42697, '65.52.15614265425463125', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:35:43', 10, 2001001000, '服务端发生异常', '2019-06-25 09:35:43');
INSERT INTO `access_log` VALUES (42698, '65.3607.15614265425524883', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:35:43', 9, 0, '', '2019-06-25 09:35:43');
INSERT INTO `access_log` VALUES (42699, '65.50.15614265426523125', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '218.4.150.14', '2019-06-25 09:35:43', 8, 0, '', '2019-06-25 09:35:43');
INSERT INTO `access_log` VALUES (42700, '65.54.15614266306683063', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.172.223', '2019-06-25 09:37:11', 0, 1002001015, '账号未登陆', '2019-06-25 09:37:11');
INSERT INTO `access_log` VALUES (42701, '65.3607.15614266306704885', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.172.223', '2019-06-25 09:37:11', 0, 1002001015, '账号未登陆', '2019-06-25 09:37:11');
INSERT INTO `access_log` VALUES (42702, '65.52.15614266306763127', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.172.223', '2019-06-25 09:37:11', 0, 1002001015, '账号未登陆', '2019-06-25 09:37:11');
INSERT INTO `access_log` VALUES (42703, '65.50.15614266333233127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.172.223', '2019-06-25 09:37:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 09:37:13');
INSERT INTO `access_log` VALUES (42704, '65.45.15614266464903105', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.172.223', '2019-06-25 09:37:26', 66, 0, '', '2019-06-25 09:37:27');
INSERT INTO `access_log` VALUES (42705, '65.46.15614266468073161', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.172.223', '2019-06-25 09:37:27', 9, 0, '', '2019-06-25 09:37:27');
INSERT INTO `access_log` VALUES (42706, '65.53.15614266468103105', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.172.223', '2019-06-25 09:37:27', 9, 2001001000, '服务端发生异常', '2019-06-25 09:37:27');
INSERT INTO `access_log` VALUES (42707, '65.49.15614266468123117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.172.223', '2019-06-25 09:37:27', 8, 0, '', '2019-06-25 09:37:27');
INSERT INTO `access_log` VALUES (42708, '65.51.15614266552713149', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.172.223', '2019-06-25 09:37:35', 8, 0, '', '2019-06-25 09:37:35');
INSERT INTO `access_log` VALUES (42709, '65.52.15614266552733129', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.172.223', '2019-06-25 09:37:35', 8, 2001001000, '服务端发生异常', '2019-06-25 09:37:35');
INSERT INTO `access_log` VALUES (42710, '65.3607.15614266552774887', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.172.223', '2019-06-25 09:37:35', 15, 0, '', '2019-06-25 09:37:35');
INSERT INTO `access_log` VALUES (42711, '65.3607.15614272363664895', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.238', '2019-06-25 09:47:16', 0, 1002001015, '账号未登陆', '2019-06-25 09:47:16');
INSERT INTO `access_log` VALUES (42712, '65.54.15614272364123073', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.238', '2019-06-25 09:47:16', 0, 1002001015, '账号未登陆', '2019-06-25 09:47:16');
INSERT INTO `access_log` VALUES (42713, '65.50.15614272364133137', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.238', '2019-06-25 09:47:16', 0, 1002001015, '账号未登陆', '2019-06-25 09:47:16');
INSERT INTO `access_log` VALUES (42714, '65.45.15614272503483115', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.238', '2019-06-25 09:47:30', 71, 0, '', '2019-06-25 09:47:30');
INSERT INTO `access_log` VALUES (42715, '65.53.15614272511733115', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.238', '2019-06-25 09:47:31', 9, 0, '', '2019-06-25 09:47:31');
INSERT INTO `access_log` VALUES (42716, '65.46.15614272512143171', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.238', '2019-06-25 09:47:31', 9, 0, '', '2019-06-25 09:47:31');
INSERT INTO `access_log` VALUES (42717, '65.49.15614272512273127', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.238', '2019-06-25 09:47:31', 9, 2001001000, '服务端发生异常', '2019-06-25 09:47:31');
INSERT INTO `access_log` VALUES (42718, '65.52.15614272609503139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.238', '2019-06-25 09:47:41', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 09:47:41');
INSERT INTO `access_log` VALUES (42719, '65.50.15614272746293139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.238', '2019-06-25 09:47:55', 112, 0, '', '2019-06-25 09:47:55');
INSERT INTO `access_log` VALUES (42720, '65.54.15614272750583075', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.238', '2019-06-25 09:47:55', 16, 0, '', '2019-06-25 09:47:55');
INSERT INTO `access_log` VALUES (42721, '65.47.15614272751013097', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.238', '2019-06-25 09:47:55', 10, 2001001000, '服务端发生异常', '2019-06-25 09:47:55');
INSERT INTO `access_log` VALUES (42722, '65.45.15614272751073117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.94 Safari/537.36', '101.89.64.238', '2019-06-25 09:47:55', 9, 0, '', '2019-06-25 09:47:55');
INSERT INTO `access_log` VALUES (42723, '59.74.15614275380662047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-25 09:52:18', 3, 0, '', '2019-06-25 09:52:18');
INSERT INTO `access_log` VALUES (42724, '59.79.15614275380752053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.115.55.63', '2019-06-25 09:52:18', 10, 2001001000, '服务端发生异常', '2019-06-25 09:52:18');
INSERT INTO `access_log` VALUES (42725, '59.71.15614275763502051', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:52:56', 2, 0, '', '2019-06-25 09:52:56');
INSERT INTO `access_log` VALUES (42726, '59.72.15614275763522047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:52:56', 13, 2001001000, '服务端发生异常', '2019-06-25 09:52:56');
INSERT INTO `access_log` VALUES (42727, '64.77.15614275834612083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:03', 3, 0, '', '2019-06-25 09:53:03');
INSERT INTO `access_log` VALUES (42728, '64.76.15614275835632071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:04', 1, 0, '', '2019-06-25 09:53:04');
INSERT INTO `access_log` VALUES (42729, '64.79.15614275856162093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:06', 2, 0, '', '2019-06-25 09:53:06');
INSERT INTO `access_log` VALUES (42730, '64.83.15614275866552079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:07', 2, 0, '', '2019-06-25 09:53:07');
INSERT INTO `access_log` VALUES (42731, '64.78.15614275876582089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:08', 2, 0, '', '2019-06-25 09:53:08');
INSERT INTO `access_log` VALUES (42732, '64.81.15614275882392083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:08', 2, 0, '', '2019-06-25 09:53:08');
INSERT INTO `access_log` VALUES (42733, '59.76.15614275899582045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:10', 2, 0, '', '2019-06-25 09:53:10');
INSERT INTO `access_log` VALUES (42734, '59.75.15614275899602055', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:10', 12, 2001001000, '服务端发生异常', '2019-06-25 09:53:10');
INSERT INTO `access_log` VALUES (42735, '64.80.15614275939912087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:14', 2, 0, '', '2019-06-25 09:53:14');
INSERT INTO `access_log` VALUES (42736, '64.82.15614275941502097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:14', 1, 0, '', '2019-06-25 09:53:14');
INSERT INTO `access_log` VALUES (42737, '64.84.15614275985832079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:19', 2, 0, '', '2019-06-25 09:53:19');
INSERT INTO `access_log` VALUES (42738, '64.77.15614275987632085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:19', 2, 0, '', '2019-06-25 09:53:19');
INSERT INTO `access_log` VALUES (42739, '64.85.15614276024482103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:22', 2, 0, '', '2019-06-25 09:53:22');
INSERT INTO `access_log` VALUES (42740, '64.79.15614276026492095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:23', 2, 0, '', '2019-06-25 09:53:23');
INSERT INTO `access_log` VALUES (42741, '64.78.15614276162002091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:36', 2, 0, '', '2019-06-25 09:53:36');
INSERT INTO `access_log` VALUES (42742, '64.81.15614276164802085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:36', 2, 0, '', '2019-06-25 09:53:36');
INSERT INTO `access_log` VALUES (42743, '59.77.15614276193532037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:39', 3, 0, '', '2019-06-25 09:53:39');
INSERT INTO `access_log` VALUES (42744, '59.78.15614276193532047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:39', 14, 2001001000, '服务端发生异常', '2019-06-25 09:53:39');
INSERT INTO `access_log` VALUES (42745, '64.80.15614276231102089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:43', 1, 0, '', '2019-06-25 09:53:43');
INSERT INTO `access_log` VALUES (42746, '64.82.15614276232272099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:43', 1, 0, '', '2019-06-25 09:53:43');
INSERT INTO `access_log` VALUES (42747, '66.49.15614276320530295', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13141186997', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:53:52', 105, 0, '', '2019-06-25 09:53:52');
INSERT INTO `access_log` VALUES (42748, '66.56.15614276462840303', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13141186997&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_4_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15G77 MicroMessenger/7.0.2(0x17000222) NetType/WIFI Language/zh_CN', '123.115.55.63', '2019-06-25 09:54:06', 229, 0, '', '2019-06-25 09:54:07');
INSERT INTO `access_log` VALUES (42749, '59.74.15614290920812071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:18:12', 3, 0, '', '2019-06-25 10:18:12');
INSERT INTO `access_log` VALUES (42750, '59.79.15614290920812077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:18:12', 10, 2001001000, '服务端发生异常', '2019-06-25 10:18:12');
INSERT INTO `access_log` VALUES (42751, '59.78.15614290960212069', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:18:16', 3, 0, '', '2019-06-25 10:18:16');
INSERT INTO `access_log` VALUES (42752, '59.77.15614290960222059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:18:16', 13, 2001001000, '服务端发生异常', '2019-06-25 10:18:16');
INSERT INTO `access_log` VALUES (42753, '64.77.15614291007782107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:18:21', 2, 0, '', '2019-06-25 10:18:21');
INSERT INTO `access_log` VALUES (42754, '64.76.15614291008972095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:18:21', 1, 0, '', '2019-06-25 10:18:21');
INSERT INTO `access_log` VALUES (42755, '64.85.15614291027012125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:18:23', 1, 0, '', '2019-06-25 10:18:23');
INSERT INTO `access_log` VALUES (42756, '64.79.15614291031592117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:18:23', 2, 0, '', '2019-06-25 10:18:23');
INSERT INTO `access_log` VALUES (42757, '65.47.15614291816073123', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-25 10:19:42', 1, 1002001015, '账号未登陆', '2019-06-25 10:19:42');
INSERT INTO `access_log` VALUES (42758, '65.54.15614291816063101', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-25 10:19:42', 1, 1002001015, '账号未登陆', '2019-06-25 10:19:42');
INSERT INTO `access_log` VALUES (42759, '65.45.15614291816293143', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-25 10:19:42', 0, 1002001015, '账号未登陆', '2019-06-25 10:19:42');
INSERT INTO `access_log` VALUES (42760, '65.53.15614291836043143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-25 10:19:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 10:19:44');
INSERT INTO `access_log` VALUES (42761, '65.46.15614291879343199', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-25 10:19:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 10:19:48');
INSERT INTO `access_log` VALUES (42762, '65.51.15614291973213187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-25 10:19:57', 61, 0, '', '2019-06-25 10:19:57');
INSERT INTO `access_log` VALUES (42763, '65.52.15614291976783167', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-25 10:19:58', 21, 0, '', '2019-06-25 10:19:58');
INSERT INTO `access_log` VALUES (42764, '65.50.15614291976853167', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-25 10:19:58', 18, 0, '', '2019-06-25 10:19:58');
INSERT INTO `access_log` VALUES (42765, '65.3607.15614291976854925', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-25 10:19:58', 18, 2001001000, '服务端发生异常', '2019-06-25 10:19:58');
INSERT INTO `access_log` VALUES (42766, '65.53.15614292483083145', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-25 10:20:48', 10, 0, '', '2019-06-25 10:20:48');
INSERT INTO `access_log` VALUES (42767, '65.46.15614292483103201', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-25 10:20:48', 10, 2001001000, '服务端发生异常', '2019-06-25 10:20:48');
INSERT INTO `access_log` VALUES (42768, '65.49.15614292483153157', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-25 10:20:48', 9, 0, '', '2019-06-25 10:20:48');
INSERT INTO `access_log` VALUES (42769, '59.75.15614293016502081', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.207.50', '2019-06-25 10:21:42', 2, 0, '', '2019-06-25 10:21:42');
INSERT INTO `access_log` VALUES (42770, '59.73.15614293016482081', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.207.50', '2019-06-25 10:21:42', 10, 2001001000, '服务端发生异常', '2019-06-25 10:21:42');
INSERT INTO `access_log` VALUES (42771, '65.47.15614293021763127', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:21:42', 0, 1002001015, '账号未登陆', '2019-06-25 10:21:42');
INSERT INTO `access_log` VALUES (42772, '65.54.15614293021783105', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:21:42', 0, 1002001015, '账号未登陆', '2019-06-25 10:21:42');
INSERT INTO `access_log` VALUES (42773, '65.45.15614293021813147', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:21:42', 0, 1002001015, '账号未登陆', '2019-06-25 10:21:42');
INSERT INTO `access_log` VALUES (42774, '65.53.15614293040283147', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:21:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 10:21:44');
INSERT INTO `access_log` VALUES (42775, '65.49.15614293077333159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:21:48', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 10:21:48');
INSERT INTO `access_log` VALUES (42776, '65.51.15614293166273191', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:21:57', 72, 0, '', '2019-06-25 10:21:57');
INSERT INTO `access_log` VALUES (42777, '65.52.15614293169813171', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:21:57', 9, 0, '', '2019-06-25 10:21:57');
INSERT INTO `access_log` VALUES (42778, '65.3607.15614293169834929', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:21:57', 9, 2001001000, '服务端发生异常', '2019-06-25 10:21:57');
INSERT INTO `access_log` VALUES (42779, '65.50.15614293169863171', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:21:57', 8, 0, '', '2019-06-25 10:21:57');
INSERT INTO `access_log` VALUES (42780, '65.53.15614293258253149', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.207.50', '2019-06-25 10:22:06', 0, 1002001015, '账号未登陆', '2019-06-25 10:22:06');
INSERT INTO `access_log` VALUES (42781, '65.47.15614293258163129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:22:06', 9, 0, '', '2019-06-25 10:22:06');
INSERT INTO `access_log` VALUES (42782, '65.45.15614293258193149', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:22:06', 10, 2001001000, '服务端发生异常', '2019-06-25 10:22:06');
INSERT INTO `access_log` VALUES (42783, '65.49.15614293258303161', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.207.50', '2019-06-25 10:22:06', 1, 1002001015, '账号未登陆', '2019-06-25 10:22:06');
INSERT INTO `access_log` VALUES (42784, '65.46.15614293258363205', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.207.50', '2019-06-25 10:22:06', 0, 1002001015, '账号未登陆', '2019-06-25 10:22:06');
INSERT INTO `access_log` VALUES (42785, '65.54.15614293258243107', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:22:06', 22, 0, '', '2019-06-25 10:22:06');
INSERT INTO `access_log` VALUES (42786, '65.3607.15614293308114931', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.207.50', '2019-06-25 10:22:11', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 10:22:11');
INSERT INTO `access_log` VALUES (42787, '65.52.15614293362113173', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:22:16', 13, 0, '', '2019-06-25 10:22:16');
INSERT INTO `access_log` VALUES (42788, '65.50.15614293362133173', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:22:16', 11, 2001001000, '服务端发生异常', '2019-06-25 10:22:16');
INSERT INTO `access_log` VALUES (42789, '65.49.15614293362193163', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.11.0.195', '2019-06-25 10:22:16', 9, 0, '', '2019-06-25 10:22:16');
INSERT INTO `access_log` VALUES (42790, '65.46.15614293415223207', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.207.50', '2019-06-25 10:22:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 10:22:22');
INSERT INTO `access_log` VALUES (42791, '65.53.15614293453793151', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.207.50', '2019-06-25 10:22:25', 97, 0, '', '2019-06-25 10:22:25');
INSERT INTO `access_log` VALUES (42792, '65.47.15614293456973131', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.207.50', '2019-06-25 10:22:26', 9, 0, '', '2019-06-25 10:22:26');
INSERT INTO `access_log` VALUES (42793, '65.45.15614293457003151', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.207.50', '2019-06-25 10:22:26', 10, 2001001000, '服务端发生异常', '2019-06-25 10:22:26');
INSERT INTO `access_log` VALUES (42794, '65.51.15614293457043195', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.207.50', '2019-06-25 10:22:26', 8, 0, '', '2019-06-25 10:22:26');
INSERT INTO `access_log` VALUES (42795, '65.3607.15614293585504933', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.11.0.195', '2019-06-25 10:22:39', 9, 0, '', '2019-06-25 10:22:39');
INSERT INTO `access_log` VALUES (42796, '65.52.15614293585553175', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.11.0.195', '2019-06-25 10:22:39', 10, 2001001000, '服务端发生异常', '2019-06-25 10:22:39');
INSERT INTO `access_log` VALUES (42797, '65.49.15614293585573165', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.11.0.195', '2019-06-25 10:22:39', 9, 0, '', '2019-06-25 10:22:39');
INSERT INTO `access_log` VALUES (42798, '59.73.15614313657022109', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.14.135.127', '2019-06-25 10:56:06', 11, 0, '', '2019-06-25 10:56:06');
INSERT INTO `access_log` VALUES (42799, '59.75.15614313657032109', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.14.135.127', '2019-06-25 10:56:06', 15, 2001001000, '服务端发生异常', '2019-06-25 10:56:06');
INSERT INTO `access_log` VALUES (42800, '64.78.15614313702332143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.14.135.127', '2019-06-25 10:56:10', 11, 0, '', '2019-06-25 10:56:10');
INSERT INTO `access_log` VALUES (42801, '64.81.15614313703682137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.14.135.127', '2019-06-25 10:56:10', 2, 0, '', '2019-06-25 10:56:10');
INSERT INTO `access_log` VALUES (42802, '64.80.15614313719402141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.14.135.127', '2019-06-25 10:56:12', 2, 0, '', '2019-06-25 10:56:12');
INSERT INTO `access_log` VALUES (42803, '64.82.15614313724812151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.14.135.127', '2019-06-25 10:56:12', 2, 0, '', '2019-06-25 10:56:12');
INSERT INTO `access_log` VALUES (42804, '64.84.15614313728452133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.14.135.127', '2019-06-25 10:56:13', 2, 0, '', '2019-06-25 10:56:13');
INSERT INTO `access_log` VALUES (42805, '64.77.15614313731352139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.14.135.127', '2019-06-25 10:56:13', 1, 0, '', '2019-06-25 10:56:13');
INSERT INTO `access_log` VALUES (42806, '59.74.15614313739002103', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.14.135.127', '2019-06-25 10:56:14', 4, 0, '', '2019-06-25 10:56:14');
INSERT INTO `access_log` VALUES (42807, '59.79.15614313738992109', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '183.14.135.127', '2019-06-25 10:56:14', 14, 2001001000, '服务端发生异常', '2019-06-25 10:56:14');
INSERT INTO `access_log` VALUES (42808, '59.74.15614316427922107', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.120.49.20', '2019-06-25 11:00:43', 3, 0, '', '2019-06-25 11:00:43');
INSERT INTO `access_log` VALUES (42809, '59.79.15614316427922113', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.120.49.20', '2019-06-25 11:00:43', 18, 2001001000, '服务端发生异常', '2019-06-25 11:00:43');
INSERT INTO `access_log` VALUES (42810, '59.77.15614316529942095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.120.49.20', '2019-06-25 11:00:53', 3, 0, '', '2019-06-25 11:00:53');
INSERT INTO `access_log` VALUES (42811, '59.80.15614316529962097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.120.49.20', '2019-06-25 11:00:53', 14, 2001001000, '服务端发生异常', '2019-06-25 11:00:53');
INSERT INTO `access_log` VALUES (42812, '65.3607.15614328310474983', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:20:31', 1, 1002001015, '账号未登陆', '2019-06-25 11:20:31');
INSERT INTO `access_log` VALUES (42813, '65.52.15614328310473223', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:20:31', 0, 1002001015, '账号未登陆', '2019-06-25 11:20:31');
INSERT INTO `access_log` VALUES (42814, '65.49.15614328310553213', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:20:31', 1, 1002001015, '账号未登陆', '2019-06-25 11:20:31');
INSERT INTO `access_log` VALUES (42815, '65.54.15614328333943159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:20:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 11:20:33');
INSERT INTO `access_log` VALUES (42816, '65.45.15614328603633201', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:21:00', 4, 1002002000, '账号不存在', '2019-06-25 11:21:00');
INSERT INTO `access_log` VALUES (42817, '65.47.15614328698003181', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:21:10', 91, 0, '', '2019-06-25 11:21:10');
INSERT INTO `access_log` VALUES (42818, '65.3607.15614328704444985', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:21:10', 13, 0, '', '2019-06-25 11:21:10');
INSERT INTO `access_log` VALUES (42819, '65.49.15614328704453215', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:21:10', 12, 0, '', '2019-06-25 11:21:10');
INSERT INTO `access_log` VALUES (42820, '65.50.15614328704443225', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:21:10', 14, 2001001000, '服务端发生异常', '2019-06-25 11:21:10');
INSERT INTO `access_log` VALUES (42821, '65.52.15614328779933225', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:21:18', 9, 0, '', '2019-06-25 11:21:18');
INSERT INTO `access_log` VALUES (42822, '65.54.15614328780063161', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:21:18', 13, 0, '', '2019-06-25 11:21:18');
INSERT INTO `access_log` VALUES (42823, '65.46.15614328780123259', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:21:18', 10, 2001001000, '服务端发生异常', '2019-06-25 11:21:18');
INSERT INTO `access_log` VALUES (42824, '65.51.15614329104363247', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:21:50', 9, 0, '', '2019-06-25 11:21:50');
INSERT INTO `access_log` VALUES (42825, '65.47.15614329104443183', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:21:50', 9, 2001001000, '服务端发生异常', '2019-06-25 11:21:50');
INSERT INTO `access_log` VALUES (42826, '65.50.15614329104463227', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.50.109.149', '2019-06-25 11:21:50', 8, 0, '', '2019-06-25 11:21:50');
INSERT INTO `access_log` VALUES (42827, '59.80.15614329658482115', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.254.220.32', '2019-06-25 11:22:46', 4, 0, '', '2019-06-25 11:22:46');
INSERT INTO `access_log` VALUES (42828, '59.78.15614329658482123', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.254.220.32', '2019-06-25 11:22:46', 15, 2001001000, '服务端发生异常', '2019-06-25 11:22:46');
INSERT INTO `access_log` VALUES (42829, '64.82.15614329732882173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '43.254.220.32', '2019-06-25 11:22:53', 2, 0, '', '2019-06-25 11:22:53');
INSERT INTO `access_log` VALUES (42830, '64.84.15614329734942155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '43.254.220.32', '2019-06-25 11:22:53', 2, 0, '', '2019-06-25 11:22:53');
INSERT INTO `access_log` VALUES (42831, '64.77.15614329766452161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '43.254.220.32', '2019-06-25 11:22:57', 2, 0, '', '2019-06-25 11:22:57');
INSERT INTO `access_log` VALUES (42832, '64.76.15614329767322149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '43.254.220.32', '2019-06-25 11:22:57', 1, 0, '', '2019-06-25 11:22:57');
INSERT INTO `access_log` VALUES (42833, '64.85.15614329777802179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '43.254.220.32', '2019-06-25 11:22:58', 2, 0, '', '2019-06-25 11:22:58');
INSERT INTO `access_log` VALUES (42834, '64.79.15614329783742171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '43.254.220.32', '2019-06-25 11:22:58', 2, 0, '', '2019-06-25 11:22:58');
INSERT INTO `access_log` VALUES (42835, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '43.254.220.32', '2019-06-25 11:22:58', 7, 0, '', '2019-06-25 11:22:58');
INSERT INTO `access_log` VALUES (42836, '64.83.15614329795122157', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '43.254.220.32', '2019-06-25 11:23:00', 8, 0, '', '2019-06-25 11:23:00');
INSERT INTO `access_log` VALUES (42837, '65.51.15614330289503249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:23:49', 104, 0, '', '2019-06-25 11:23:49');
INSERT INTO `access_log` VALUES (42838, '65.47.15614330295703185', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:23:50', 9, 0, '', '2019-06-25 11:23:50');
INSERT INTO `access_log` VALUES (42839, '65.49.15614330295713219', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:23:50', 10, 2001001000, '服务端发生异常', '2019-06-25 11:23:50');
INSERT INTO `access_log` VALUES (42840, '65.3607.15614330295734989', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:23:50', 9, 0, '', '2019-06-25 11:23:50');
INSERT INTO `access_log` VALUES (42841, '59.79.15614331976322135', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:38', 10, 0, '', '2019-06-25 11:26:38');
INSERT INTO `access_log` VALUES (42842, '59.74.15614331976332129', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:38', 19, 2001001000, '服务端发生异常', '2019-06-25 11:26:38');
INSERT INTO `access_log` VALUES (42843, '64.77.15614332016502165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:42', 3, 0, '', '2019-06-25 11:26:42');
INSERT INTO `access_log` VALUES (42844, '64.76.15614332019022153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:42', 2, 0, '', '2019-06-25 11:26:42');
INSERT INTO `access_log` VALUES (42845, '64.85.15614332036492183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:44', 2, 0, '', '2019-06-25 11:26:44');
INSERT INTO `access_log` VALUES (42846, '64.79.15614332046682175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:45', 2, 0, '', '2019-06-25 11:26:45');
INSERT INTO `access_log` VALUES (42847, '64.83.15614332052902161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:45', 2, 0, '', '2019-06-25 11:26:45');
INSERT INTO `access_log` VALUES (42848, '64.78.15614332056652171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:46', 2, 0, '', '2019-06-25 11:26:46');
INSERT INTO `access_log` VALUES (42849, '64.81.15614332059942165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:46', 3, 0, '', '2019-06-25 11:26:46');
INSERT INTO `access_log` VALUES (42850, '59.78.15614332116512127', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:52', 2, 0, '', '2019-06-25 11:26:52');
INSERT INTO `access_log` VALUES (42851, '59.77.15614332116522117', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:52', 14, 2001001000, '服务端发生异常', '2019-06-25 11:26:52');
INSERT INTO `access_log` VALUES (42852, '64.82.15614332145372179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:55', 2, 0, '', '2019-06-25 11:26:55');
INSERT INTO `access_log` VALUES (42853, '64.84.15614332146212161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:55', 2, 0, '', '2019-06-25 11:26:55');
INSERT INTO `access_log` VALUES (42854, '64.77.15614332161042167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:56', 2, 0, '', '2019-06-25 11:26:56');
INSERT INTO `access_log` VALUES (42855, '64.76.15614332165352155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:57', 2, 0, '', '2019-06-25 11:26:57');
INSERT INTO `access_log` VALUES (42856, '64.85.15614332170862185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:26:57', 2, 0, '', '2019-06-25 11:26:57');
INSERT INTO `access_log` VALUES (42857, '66.51.15614332314270383', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13720895280', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:27:11', 114, 0, '', '2019-06-25 11:27:12');
INSERT INTO `access_log` VALUES (42858, '66.54.15614332500340375', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13720895280&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:27:30', 188, 0, '', '2019-06-25 11:27:30');
INSERT INTO `access_log` VALUES (42859, '66.57.15614332731650371', 140, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:27:53', 7, 0, '', '2019-06-25 11:27:53');
INSERT INTO `access_log` VALUES (42860, '66.50.15614332757430361', 140, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:27:56', 25, 0, '', '2019-06-25 11:27:56');
INSERT INTO `access_log` VALUES (42861, '66.48.15614332874040377', 140, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:07', 6, 0, '', '2019-06-25 11:28:07');
INSERT INTO `access_log` VALUES (42862, '66.51.15614332900560385', 140, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:10', 6, 0, '', '2019-06-25 11:28:10');
INSERT INTO `access_log` VALUES (42863, '66.55.15614332951340361', 140, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:15', 6, 0, '', '2019-06-25 11:28:15');
INSERT INTO `access_log` VALUES (42864, '59.79.15614332972422137', 140, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:17', 12, 0, '', '2019-06-25 11:28:17');
INSERT INTO `access_log` VALUES (42865, '66.54.15614332986250377', 140, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:19', 5, 0, '', '2019-06-25 11:28:19');
INSERT INTO `access_log` VALUES (42866, '66.53.15614333057040365', 140, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:26', 5, 0, '', '2019-06-25 11:28:26');
INSERT INTO `access_log` VALUES (42867, '64.76.15614333180422157', 140, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:38', 9, 0, '', '2019-06-25 11:28:38');
INSERT INTO `access_log` VALUES (42868, '64.79.15614333182442179', 140, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:38', 8, 0, '', '2019-06-25 11:28:38');
INSERT INTO `access_log` VALUES (42869, 'N/A', 140, 1, 'search-application', '/search-api/users/product/page', 'keyword=kaf&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:44', 13, 0, '', '2019-06-25 11:28:44');
INSERT INTO `access_log` VALUES (42870, 'N/A', 140, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kaf', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:44', 10, 0, '', '2019-06-25 11:28:44');
INSERT INTO `access_log` VALUES (42871, 'N/A', 140, 1, 'search-application', '/search-api/users/product/page', 'keyword=kafka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:51', 11, 0, '', '2019-06-25 11:28:51');
INSERT INTO `access_log` VALUES (42872, 'N/A', 140, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kafka', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:51', 15, 0, '', '2019-06-25 11:28:51');
INSERT INTO `access_log` VALUES (42873, 'N/A', 140, 1, 'search-application', '/search-api/users/product/page', 'keyword=kafka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:56', 12, 0, '', '2019-06-25 11:28:56');
INSERT INTO `access_log` VALUES (42874, 'N/A', 140, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kafka', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:57', 13, 0, '', '2019-06-25 11:28:57');
INSERT INTO `access_log` VALUES (42875, '64.81.15614333385332169', 140, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:28:59', 10, 0, '', '2019-06-25 11:28:59');
INSERT INTO `access_log` VALUES (42876, '64.76.15614334048482159', 140, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:05', 12, 0, '', '2019-06-25 11:30:05');
INSERT INTO `access_log` VALUES (42877, 'N/A', 140, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:05', 11, 0, '', '2019-06-25 11:30:05');
INSERT INTO `access_log` VALUES (42878, 'N/A', 140, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:06', 17, 0, '', '2019-06-25 11:30:06');
INSERT INTO `access_log` VALUES (42879, '64.79.15614334058832181', 140, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:06', 6, 0, '', '2019-06-25 11:30:06');
INSERT INTO `access_log` VALUES (42880, '64.83.15614334059792167', 140, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:06', 4, 0, '', '2019-06-25 11:30:06');
INSERT INTO `access_log` VALUES (42881, '59.80.15614334062632123', 140, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:06', 7, 0, '', '2019-06-25 11:30:06');
INSERT INTO `access_log` VALUES (42882, '59.78.15614334062852131', 140, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:06', 17, 2001001000, '服务端发生异常', '2019-06-25 11:30:06');
INSERT INTO `access_log` VALUES (42883, '64.78.15614334065292177', 140, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:07', 12, 0, '', '2019-06-25 11:30:07');
INSERT INTO `access_log` VALUES (42884, '64.81.15614334066562171', 140, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:07', 7, 0, '', '2019-06-25 11:30:07');
INSERT INTO `access_log` VALUES (42885, '59.71.15614334090072137', 140, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:09', 8, 0, '', '2019-06-25 11:30:09');
INSERT INTO `access_log` VALUES (42886, '59.77.15614334090072121', 140, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:09', 18, 2001001000, '服务端发生异常', '2019-06-25 11:30:09');
INSERT INTO `access_log` VALUES (42887, '65.49.15614334386503225', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:39', 1, 1002001015, '账号未登陆', '2019-06-25 11:30:39');
INSERT INTO `access_log` VALUES (42888, '65.3607.15614334386514995', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:39', 1, 1002001015, '账号未登陆', '2019-06-25 11:30:39');
INSERT INTO `access_log` VALUES (42889, '65.47.15614334386543191', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:39', 0, 1002001015, '账号未登陆', '2019-06-25 11:30:39');
INSERT INTO `access_log` VALUES (42890, '65.46.15614334411383269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:30:41', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 11:30:41');
INSERT INTO `access_log` VALUES (42891, '65.53.15614334656953213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:31:06', 53, 0, '', '2019-06-25 11:31:06');
INSERT INTO `access_log` VALUES (42892, '65.45.15614334659543213', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:31:06', 10, 0, '', '2019-06-25 11:31:06');
INSERT INTO `access_log` VALUES (42893, '65.50.15614334659543237', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:31:06', 10, 2001001000, '服务端发生异常', '2019-06-25 11:31:06');
INSERT INTO `access_log` VALUES (42894, '65.51.15614334659573257', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:31:06', 9, 0, '', '2019-06-25 11:31:06');
INSERT INTO `access_log` VALUES (42895, '65.52.15614335011803237', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:31:41', 8, 0, '', '2019-06-25 11:31:41');
INSERT INTO `access_log` VALUES (42896, '65.46.15614335011843271', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:31:41', 8, 2001001000, '服务端发生异常', '2019-06-25 11:31:41');
INSERT INTO `access_log` VALUES (42897, '65.54.15614335011853173', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:31:41', 7, 0, '', '2019-06-25 11:31:41');
INSERT INTO `access_log` VALUES (42898, '65.50.15614345765853253', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:49:37', 72, 0, '', '2019-06-25 11:49:37');
INSERT INTO `access_log` VALUES (42899, '65.45.15614345768133229', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:49:37', 10, 0, '', '2019-06-25 11:49:37');
INSERT INTO `access_log` VALUES (42900, '65.51.15614345768193273', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:49:37', 8, 0, '', '2019-06-25 11:49:37');
INSERT INTO `access_log` VALUES (42901, '65.3607.15614345768205013', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:49:37', 9, 0, '', '2019-06-25 11:49:37');
INSERT INTO `access_log` VALUES (42902, '62.89.15614345899961725', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:49:50', 24, 0, '', '2019-06-25 11:49:50');
INSERT INTO `access_log` VALUES (42903, '62.84.15614346403011693', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-25 11:49:51&createEndTime=2019-06-25 11:49:51', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:50:40', 15, 0, '', '2019-06-25 11:50:40');
INSERT INTO `access_log` VALUES (42904, '62.81.15614346868651689', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:51:27', 19, 0, '', '2019-06-25 11:51:27');
INSERT INTO `access_log` VALUES (42905, '62.83.15614347036431717', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-25 11:51:28&createEndTime=2019-06-25 11:51:28', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:51:44', 38, 0, '', '2019-06-25 11:51:44');
INSERT INTO `access_log` VALUES (42906, '62.88.15614347134291701', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'createBeginTime=2019-06-25 11:49:51&createEndTime=2019-06-25 11:49:51&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:51:53', 13, 0, '', '2019-06-25 11:51:53');
INSERT INTO `access_log` VALUES (42907, '62.87.15614347185891711', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-25 11:49:51&createEndTime=2019-06-25 11:49:51', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:51:59', 13, 0, '', '2019-06-25 11:51:59');
INSERT INTO `access_log` VALUES (42908, '62.84.15614347210941695', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'createBeginTime=2019-06-25 11:51:28&createEndTime=2019-06-25 11:51:28&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:52:01', 12, 0, '', '2019-06-25 11:52:01');
INSERT INTO `access_log` VALUES (42909, '62.82.15614347226041707', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'createBeginTime=2019-06-25 11:49:51&createEndTime=2019-06-25 11:49:51&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:52:03', 16, 0, '', '2019-06-25 11:52:03');
INSERT INTO `access_log` VALUES (42910, '65.49.15614347270933245', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:52:07', 8, 0, '', '2019-06-25 11:52:07');
INSERT INTO `access_log` VALUES (42911, '65.47.15614347270953211', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:52:07', 8, 0, '', '2019-06-25 11:52:07');
INSERT INTO `access_log` VALUES (42912, '65.54.15614347271023191', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:52:07', 18, 0, '', '2019-06-25 11:52:07');
INSERT INTO `access_log` VALUES (42913, '62.86.15614347271761691', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:52:07', 12, 0, '', '2019-06-25 11:52:07');
INSERT INTO `access_log` VALUES (42914, '62.85.15614347725761703', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:52:53', 17, 0, '', '2019-06-25 11:52:53');
INSERT INTO `access_log` VALUES (42915, '62.87.15614347980041713', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=20', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:53:18', 15, 0, '', '2019-06-25 11:53:18');
INSERT INTO `access_log` VALUES (42916, '62.81.15614348490581693', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:54:09', 13, 0, '', '2019-06-25 11:54:09');
INSERT INTO `access_log` VALUES (42917, '62.89.15614348560991731', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:54:16', 12, 0, '', '2019-06-25 11:54:16');
INSERT INTO `access_log` VALUES (42918, '62.83.15614348579961721', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:54:18', 13, 0, '', '2019-06-25 11:54:18');
INSERT INTO `access_log` VALUES (42919, '62.85.15614348609791705', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=4&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:54:21', 12, 0, '', '2019-06-25 11:54:21');
INSERT INTO `access_log` VALUES (42920, '62.87.15614348649751715', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:54:25', 12, 0, '', '2019-06-25 11:54:25');
INSERT INTO `access_log` VALUES (42921, '62.84.15614348662571699', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:54:26', 10, 0, '', '2019-06-25 11:54:26');
INSERT INTO `access_log` VALUES (42922, '62.82.15614348666851711', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:54:27', 11, 0, '', '2019-06-25 11:54:27');
INSERT INTO `access_log` VALUES (42923, '62.86.15614348822641695', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=5&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:54:42', 12, 0, '', '2019-06-25 11:54:42');
INSERT INTO `access_log` VALUES (42924, '62.81.15614348874261695', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:54:47', 12, 0, '', '2019-06-25 11:54:47');
INSERT INTO `access_log` VALUES (42925, '62.83.15614348912321723', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:54:51', 11, 0, '', '2019-06-25 11:54:51');
INSERT INTO `access_log` VALUES (42926, '62.85.15614348926671707', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:54:53', 14, 0, '', '2019-06-25 11:54:53');
INSERT INTO `access_log` VALUES (42927, '64.82.15614349185042205', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:55:19', 23, 0, '', '2019-06-25 11:55:19');
INSERT INTO `access_log` VALUES (42928, '64.80.15614349185032195', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:55:19', 26, 0, '', '2019-06-25 11:55:19');
INSERT INTO `access_log` VALUES (42929, '65.45.15614349390003235', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:55:39', 3, 0, '', '2019-06-25 11:55:39');
INSERT INTO `access_log` VALUES (42930, '65.52.15614350038323259', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:56:44', 3, 0, '', '2019-06-25 11:56:44');
INSERT INTO `access_log` VALUES (42931, '65.46.15614350059713293', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:56:46', 4, 0, '', '2019-06-25 11:56:46');
INSERT INTO `access_log` VALUES (42932, '65.53.15614350084813237', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:56:48', 4, 0, '', '2019-06-25 11:56:48');
INSERT INTO `access_log` VALUES (42933, '65.45.15614350331143237', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:13', 9, 0, '', '2019-06-25 11:57:13');
INSERT INTO `access_log` VALUES (42934, '65.3607.15614350331185021', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:13', 11, 2001001000, '服务端发生异常', '2019-06-25 11:57:13');
INSERT INTO `access_log` VALUES (42935, '65.54.15614350331283197', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:13', 9, 0, '', '2019-06-25 11:57:13');
INSERT INTO `access_log` VALUES (42936, '65.47.15614350393093217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 11:57:19');
INSERT INTO `access_log` VALUES (42937, '65.52.15614350440103261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:24', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 11:57:24');
INSERT INTO `access_log` VALUES (42938, '65.46.15614350478603295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=password&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:28', 105, 0, '', '2019-06-25 11:57:28');
INSERT INTO `access_log` VALUES (42939, '65.50.15614350482273263', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:28', 8, 0, '', '2019-06-25 11:57:28');
INSERT INTO `access_log` VALUES (42940, '65.53.15614350482263239', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:28', 7, 0, '', '2019-06-25 11:57:28');
INSERT INTO `access_log` VALUES (42941, '65.51.15614350482343283', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:28', 8, 0, '', '2019-06-25 11:57:28');
INSERT INTO `access_log` VALUES (42942, '62.82.15614350548571715', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:35', 15, 0, '', '2019-06-25 11:57:35');
INSERT INTO `access_log` VALUES (42943, '66.54.15614350570410401', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:57:37', 15, 0, '', '2019-06-25 11:57:37');
INSERT INTO `access_log` VALUES (42944, '62.86.15614350599631699', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:40', 57, 0, '', '2019-06-25 11:57:40');
INSERT INTO `access_log` VALUES (42945, '66.49.15614350605790397', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:57:41', 12, 0, '', '2019-06-25 11:57:41');
INSERT INTO `access_log` VALUES (42946, '66.53.15614350621090389', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=3&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:57:42', 9, 0, '', '2019-06-25 11:57:42');
INSERT INTO `access_log` VALUES (42947, '66.56.15614350629210405', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=4&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:57:43', 12, 0, '', '2019-06-25 11:57:43');
INSERT INTO `access_log` VALUES (42948, '66.57.15614350673330397', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:47', 11, 0, '', '2019-06-25 11:57:47');
INSERT INTO `access_log` VALUES (42949, '59.76.15614350713002153', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:51', 15, 0, '', '2019-06-25 11:57:51');
INSERT INTO `access_log` VALUES (42950, '66.52.15614350744550397', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=5&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:57:54', 12, 0, '', '2019-06-25 11:57:54');
INSERT INTO `access_log` VALUES (42951, '66.48.15614350751570403', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=7&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:57:55', 13, 0, '', '2019-06-25 11:57:55');
INSERT INTO `access_log` VALUES (42952, '59.73.15614350762692163', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:56', 16, 2001001000, '服务端发生异常', '2019-06-25 11:57:56');
INSERT INTO `access_log` VALUES (42953, '59.75.15614350794262163', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:57:59', 12, 0, '', '2019-06-25 11:57:59');
INSERT INTO `access_log` VALUES (42954, '59.74.15614350818532157', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:58:02', 18, 0, '', '2019-06-25 11:58:02');
INSERT INTO `access_log` VALUES (42955, '59.80.15614350845942147', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.59.157', '2019-06-25 11:58:05', 12, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-25 11:58:05');
INSERT INTO `access_log` VALUES (42956, '59.71.15614351134822161', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:58:33', 12, 0, '', '2019-06-25 11:58:33');
INSERT INTO `access_log` VALUES (42957, '65.52.15614351179593263', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '180.167.120.186', '2019-06-25 11:58:38', 1, 1002001015, '账号未登陆', '2019-06-25 11:58:38');
INSERT INTO `access_log` VALUES (42958, '65.49.15614351179583253', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '180.167.120.186', '2019-06-25 11:58:38', 1, 1002001015, '账号未登陆', '2019-06-25 11:58:38');
INSERT INTO `access_log` VALUES (42959, '65.46.15614351179733297', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '180.167.120.186', '2019-06-25 11:58:38', 0, 1002001015, '账号未登陆', '2019-06-25 11:58:38');
INSERT INTO `access_log` VALUES (42960, '59.72.15614351216302157', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:58:42', 20, 2001001000, '服务端发生异常', '2019-06-25 11:58:42');
INSERT INTO `access_log` VALUES (42961, '65.50.15614351232603265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '180.167.120.186', '2019-06-25 11:58:43', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 11:58:43');
INSERT INTO `access_log` VALUES (42962, '59.76.15614351250182155', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:58:45', 10, 0, '', '2019-06-25 11:58:45');
INSERT INTO `access_log` VALUES (42963, '65.51.15614351272443285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '180.167.120.186', '2019-06-25 11:58:47', 70, 0, '', '2019-06-25 11:58:47');
INSERT INTO `access_log` VALUES (42964, '65.3607.15614351275835025', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '180.167.120.186', '2019-06-25 11:58:48', 9, 0, '', '2019-06-25 11:58:48');
INSERT INTO `access_log` VALUES (42965, '65.45.15614351275873241', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '180.167.120.186', '2019-06-25 11:58:48', 10, 2001001000, '服务端发生异常', '2019-06-25 11:58:48');
INSERT INTO `access_log` VALUES (42966, '65.54.15614351275953201', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '180.167.120.186', '2019-06-25 11:58:48', 9, 0, '', '2019-06-25 11:58:48');
INSERT INTO `access_log` VALUES (42967, '65.47.15614351337753221', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '180.167.120.186', '2019-06-25 11:58:54', 10, 0, '', '2019-06-25 11:58:54');
INSERT INTO `access_log` VALUES (42968, '65.52.15614351337783265', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '180.167.120.186', '2019-06-25 11:58:54', 10, 2001001000, '服务端发生异常', '2019-06-25 11:58:54');
INSERT INTO `access_log` VALUES (42969, '65.46.15614351337793299', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '180.167.120.186', '2019-06-25 11:58:54', 9, 0, '', '2019-06-25 11:58:54');
INSERT INTO `access_log` VALUES (42970, '64.83.15614351346522191', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 11:58:55', 147, 0, '', '2019-06-25 11:58:55');
INSERT INTO `access_log` VALUES (42971, '59.72.15614365973972177', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/4.0 (compatible;)', '219.233.201.34', '2019-06-25 12:23:17', 3, 0, '', '2019-06-25 12:23:17');
INSERT INTO `access_log` VALUES (42972, '64.84.15614384988352235', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:54:59', 17, 1002001012, '访问令牌已过期', '2019-06-25 12:54:59');
INSERT INTO `access_log` VALUES (42973, '65.54.15614385052683247', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:55:05', 91, 0, '', '2019-06-25 12:55:05');
INSERT INTO `access_log` VALUES (42974, '65.3607.15614385055785071', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:55:06', 18, 0, '', '2019-06-25 12:55:06');
INSERT INTO `access_log` VALUES (42975, '65.46.15614385055813345', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:55:06', 20, 0, '', '2019-06-25 12:55:06');
INSERT INTO `access_log` VALUES (42976, '65.52.15614385055833311', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:55:06', 20, 0, '', '2019-06-25 12:55:06');
INSERT INTO `access_log` VALUES (42977, '62.89.15614385105571783', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:55:11', 20, 0, '', '2019-06-25 12:55:11');
INSERT INTO `access_log` VALUES (42978, '64.85.15614385280782259', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:55:28', 28, 0, '', '2019-06-25 12:55:28');
INSERT INTO `access_log` VALUES (42979, '64.79.15614385280782251', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:55:28', 30, 0, '', '2019-06-25 12:55:28');
INSERT INTO `access_log` VALUES (42980, '64.78.15614385313362247', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:55:31', 17, 0, '', '2019-06-25 12:55:31');
INSERT INTO `access_log` VALUES (42981, '64.83.15614385313362237', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:55:31', 24, 0, '', '2019-06-25 12:55:31');
INSERT INTO `access_log` VALUES (42982, '64.77.15614385535772243', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:55:54', 8, 0, '', '2019-06-25 12:55:54');
INSERT INTO `access_log` VALUES (42983, '64.84.15614385535762237', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:55:54', 10, 0, '', '2019-06-25 12:55:54');
INSERT INTO `access_log` VALUES (42984, '64.82.15614385535752255', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=40', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:55:54', 14, 0, '', '2019-06-25 12:55:54');
INSERT INTO `access_log` VALUES (42985, '64.79.15614385665612253', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:56:07', 9, 0, '', '2019-06-25 12:56:07');
INSERT INTO `access_log` VALUES (42986, '66.53.15614385908900437', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:56:31', 21, 0, '', '2019-06-25 12:56:31');
INSERT INTO `access_log` VALUES (42987, '66.57.15614386040480445', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:56:44', 10, 0, '', '2019-06-25 12:56:44');
INSERT INTO `access_log` VALUES (42988, '66.52.15614386188450445', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=3&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:56:59', 12, 0, '', '2019-06-25 12:56:59');
INSERT INTO `access_log` VALUES (42989, '66.48.15614386208160451', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=4&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:57:01', 12, 0, '', '2019-06-25 12:57:01');
INSERT INTO `access_log` VALUES (42990, '66.51.15614386243770459', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=5&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:57:04', 12, 0, '', '2019-06-25 12:57:04');
INSERT INTO `access_log` VALUES (42991, '66.54.15614386284000451', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=6&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:57:08', 12, 0, '', '2019-06-25 12:57:08');
INSERT INTO `access_log` VALUES (42992, '66.49.15614386290810447', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=8&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:57:09', 12, 0, '', '2019-06-25 12:57:09');
INSERT INTO `access_log` VALUES (42993, '66.53.15614386307610439', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=13&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:57:11', 11, 0, '', '2019-06-25 12:57:11');
INSERT INTO `access_log` VALUES (42994, '66.56.15614386359330455', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=12&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:57:16', 14, 0, '', '2019-06-25 12:57:16');
INSERT INTO `access_log` VALUES (42995, '59.71.15614386454362209', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:57:25', 19, 0, '', '2019-06-25 12:57:25');
INSERT INTO `access_log` VALUES (42996, '59.76.15614386710332203', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:57:51', 21, 2001001000, '服务端发生异常', '2019-06-25 12:57:51');
INSERT INTO `access_log` VALUES (42997, '59.73.15614386748862213', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:57:55', 13, 0, '', '2019-06-25 12:57:55');
INSERT INTO `access_log` VALUES (42998, '59.74.15614386936282207', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:58:14', 14, 0, '', '2019-06-25 12:58:14');
INSERT INTO `access_log` VALUES (42999, '65.45.15614387198853291', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:58:40', 111, 0, '', '2019-06-25 12:58:40');
INSERT INTO `access_log` VALUES (43000, '65.46.15614387343723349', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:58:54', 16, 0, '', '2019-06-25 12:58:54');
INSERT INTO `access_log` VALUES (43001, '65.52.15614387461503315', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=26', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:59:06', 11, 0, '', '2019-06-25 12:59:06');
INSERT INTO `access_log` VALUES (43002, '65.47.15614387503833271', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:59:10', 24, 0, '', '2019-06-25 12:59:10');
INSERT INTO `access_log` VALUES (43003, '65.49.15614387541283305', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:59:14', 11, 0, '', '2019-06-25 12:59:14');
INSERT INTO `access_log` VALUES (43004, '65.50.15614387666723317', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:59:27', 9, 0, '', '2019-06-25 12:59:27');
INSERT INTO `access_log` VALUES (43005, '65.54.15614387942763253', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-25 12:59:54', 61, 0, '', '2019-06-25 12:59:54');
INSERT INTO `access_log` VALUES (43006, '65.51.15614418465233379', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.247.55.246', '2019-06-25 13:50:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 13:50:47');
INSERT INTO `access_log` VALUES (43007, '65.54.15614418588683295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.247.55.246', '2019-06-25 13:50:59', 92, 0, '', '2019-06-25 13:50:59');
INSERT INTO `access_log` VALUES (43008, '65.46.15614418593573393', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.247.55.246', '2019-06-25 13:50:59', 15, 0, '', '2019-06-25 13:50:59');
INSERT INTO `access_log` VALUES (43009, '65.52.15614418593613359', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.247.55.246', '2019-06-25 13:50:59', 15, 2001001000, '服务端发生异常', '2019-06-25 13:50:59');
INSERT INTO `access_log` VALUES (43010, '65.3607.15614418593685119', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.247.55.246', '2019-06-25 13:50:59', 14, 0, '', '2019-06-25 13:50:59');
INSERT INTO `access_log` VALUES (43011, '65.46.15614436263683417', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.26.132.194', '2019-06-25 14:20:26', 1, 1002001015, '账号未登陆', '2019-06-25 14:20:26');
INSERT INTO `access_log` VALUES (43012, '65.3607.15614436263975143', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.26.132.194', '2019-06-25 14:20:26', 1, 1002001015, '账号未登陆', '2019-06-25 14:20:26');
INSERT INTO `access_log` VALUES (43013, '65.47.15614436264033339', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.26.132.194', '2019-06-25 14:20:26', 0, 1002001015, '账号未登陆', '2019-06-25 14:20:26');
INSERT INTO `access_log` VALUES (43014, '65.49.15614436319103371', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.26.132.194', '2019-06-25 14:20:32', 91, 0, '', '2019-06-25 14:20:32');
INSERT INTO `access_log` VALUES (43015, '65.53.15614436324573359', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.26.132.194', '2019-06-25 14:20:32', 9, 0, '', '2019-06-25 14:20:32');
INSERT INTO `access_log` VALUES (43016, '65.50.15614436324673385', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.26.132.194', '2019-06-25 14:20:32', 11, 2001001000, '服务端发生异常', '2019-06-25 14:20:32');
INSERT INTO `access_log` VALUES (43017, '65.51.15614436324743405', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.26.132.194', '2019-06-25 14:20:32', 54, 0, '', '2019-06-25 14:20:33');
INSERT INTO `access_log` VALUES (43018, '65.46.15614436710443419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.26.132.194', '2019-06-25 14:21:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 14:21:11');
INSERT INTO `access_log` VALUES (43019, '59.78.15614445731742283', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '122.225.195.198', '2019-06-25 14:36:13', 12, 0, '', '2019-06-25 14:36:13');
INSERT INTO `access_log` VALUES (43020, '59.71.15614445731752289', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.221 Safari/537.36 SE 2.X MetaSr 1.0', '122.225.195.198', '2019-06-25 14:36:13', 15, 2001001000, '服务端发生异常', '2019-06-25 14:36:13');
INSERT INTO `access_log` VALUES (43021, '64.80.15614445827382327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:23', 12, 0, '', '2019-06-25 14:36:23');
INSERT INTO `access_log` VALUES (43022, '64.82.15614445831732335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:23', 3, 0, '', '2019-06-25 14:36:23');
INSERT INTO `access_log` VALUES (43023, '64.77.15614445952072323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:35', 2, 0, '', '2019-06-25 14:36:35');
INSERT INTO `access_log` VALUES (43024, '64.76.15614445952982313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:35', 2, 0, '', '2019-06-25 14:36:35');
INSERT INTO `access_log` VALUES (43025, '64.85.15614445964332343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:36', 2, 0, '', '2019-06-25 14:36:36');
INSERT INTO `access_log` VALUES (43026, '64.83.15614445972432321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:37', 2, 0, '', '2019-06-25 14:36:37');
INSERT INTO `access_log` VALUES (43027, '64.78.15614445986412331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:39', 3, 0, '', '2019-06-25 14:36:39');
INSERT INTO `access_log` VALUES (43028, '64.81.15614445993832325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:39', 2, 0, '', '2019-06-25 14:36:39');
INSERT INTO `access_log` VALUES (43029, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:39', 7, 0, '', '2019-06-25 14:36:39');
INSERT INTO `access_log` VALUES (43030, '64.84.15614446022612321', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:42', 7, 0, '', '2019-06-25 14:36:42');
INSERT INTO `access_log` VALUES (43031, '64.82.15614446158112337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:56', 2, 0, '', '2019-06-25 14:36:56');
INSERT INTO `access_log` VALUES (43032, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:56', 7, 0, '', '2019-06-25 14:36:56');
INSERT INTO `access_log` VALUES (43033, '64.77.15614446169802325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:57', 2, 0, '', '2019-06-25 14:36:57');
INSERT INTO `access_log` VALUES (43034, '64.79.15614446170742337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:57', 2, 0, '', '2019-06-25 14:36:57');
INSERT INTO `access_log` VALUES (43035, '64.76.15614446183932315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:58', 2, 0, '', '2019-06-25 14:36:58');
INSERT INTO `access_log` VALUES (43036, '64.85.15614446191602345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:36:59', 2, 0, '', '2019-06-25 14:36:59');
INSERT INTO `access_log` VALUES (43037, '64.83.15614446203092323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:37:00', 2, 0, '', '2019-06-25 14:37:00');
INSERT INTO `access_log` VALUES (43038, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:37:00', 6, 0, '', '2019-06-25 14:37:00');
INSERT INTO `access_log` VALUES (43039, '64.78.15614446222022333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:37:02', 3, 0, '', '2019-06-25 14:37:02');
INSERT INTO `access_log` VALUES (43040, '64.81.15614446226752327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:37:03', 2, 0, '', '2019-06-25 14:37:03');
INSERT INTO `access_log` VALUES (43041, '64.80.15614446284812331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:37:08', 3, 0, '', '2019-06-25 14:37:08');
INSERT INTO `access_log` VALUES (43042, '64.82.15614446287292339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:37:09', 2, 0, '', '2019-06-25 14:37:09');
INSERT INTO `access_log` VALUES (43043, '59.75.15614446328082293', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:37:13', 3, 0, '', '2019-06-25 14:37:13');
INSERT INTO `access_log` VALUES (43044, '59.74.15614446328082287', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '122.225.195.198', '2019-06-25 14:37:13', 13, 2001001000, '服务端发生异常', '2019-06-25 14:37:13');
INSERT INTO `access_log` VALUES (43045, '65.45.15614449565513379', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.192.37.249', '2019-06-25 14:42:37', 1, 1002001015, '账号未登陆', '2019-06-25 14:42:37');
INSERT INTO `access_log` VALUES (43046, '65.51.15614449565503423', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.192.37.249', '2019-06-25 14:42:37', 1, 1002001015, '账号未登陆', '2019-06-25 14:42:37');
INSERT INTO `access_log` VALUES (43047, '65.54.15614449565663339', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.192.37.249', '2019-06-25 14:42:37', 0, 1002001015, '账号未登陆', '2019-06-25 14:42:37');
INSERT INTO `access_log` VALUES (43048, '65.46.15614449633453437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.192.37.249', '2019-06-25 14:42:43', 96, 0, '', '2019-06-25 14:42:43');
INSERT INTO `access_log` VALUES (43049, '65.3607.15614449636385163', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.192.37.249', '2019-06-25 14:42:44', 9, 0, '', '2019-06-25 14:42:44');
INSERT INTO `access_log` VALUES (43050, '65.49.15614449636403391', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.192.37.249', '2019-06-25 14:42:44', 9, 0, '', '2019-06-25 14:42:44');
INSERT INTO `access_log` VALUES (43051, '65.47.15614449636393359', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.192.37.249', '2019-06-25 14:42:44', 9, 2001001000, '服务端发生异常', '2019-06-25 14:42:44');
INSERT INTO `access_log` VALUES (43052, '65.50.15614449858853405', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.192.37.249', '2019-06-25 14:43:06', 8, 0, '', '2019-06-25 14:43:06');
INSERT INTO `access_log` VALUES (43053, '65.51.15614449858873425', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.192.37.249', '2019-06-25 14:43:06', 8, 0, '', '2019-06-25 14:43:06');
INSERT INTO `access_log` VALUES (43054, '65.45.15614449858863381', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.192.37.249', '2019-06-25 14:43:06', 9, 2001001000, '服务端发生异常', '2019-06-25 14:43:06');
INSERT INTO `access_log` VALUES (43055, '65.52.15614449916013405', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.192.37.249', '2019-06-25 14:43:12', 9, 0, '', '2019-06-25 14:43:12');
INSERT INTO `access_log` VALUES (43056, '65.46.15614449916013439', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.192.37.249', '2019-06-25 14:43:12', 10, 2001001000, '服务端发生异常', '2019-06-25 14:43:12');
INSERT INTO `access_log` VALUES (43057, '65.47.15614449916423361', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.192.37.249', '2019-06-25 14:43:12', 9, 0, '', '2019-06-25 14:43:12');
INSERT INTO `access_log` VALUES (43058, '65.3607.15614449968935165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.192.37.249', '2019-06-25 14:43:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 14:43:17');
INSERT INTO `access_log` VALUES (43059, '64.83.15614452790432333', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:47:59', 14, 0, '', '2019-06-25 14:47:59');
INSERT INTO `access_log` VALUES (43060, '66.51.15614452835690549', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:48:04', 17, 0, '', '2019-06-25 14:48:04');
INSERT INTO `access_log` VALUES (43061, '66.49.15614452874470537', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:48:07', 9, 0, '', '2019-06-25 14:48:07');
INSERT INTO `access_log` VALUES (43062, '66.56.15614452953870545', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:48:15', 8, 0, '', '2019-06-25 14:48:15');
INSERT INTO `access_log` VALUES (43063, '66.48.15614453243420543', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:48:44', 7, 0, '', '2019-06-25 14:48:44');
INSERT INTO `access_log` VALUES (43064, '66.55.15614453269170527', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:48:47', 7, 0, '', '2019-06-25 14:48:47');
INSERT INTO `access_log` VALUES (43065, '64.77.15614453414652337', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:49:01', 15, 0, '', '2019-06-25 14:49:01');
INSERT INTO `access_log` VALUES (43066, '66.56.15614453467770547', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:49:07', 8, 0, '', '2019-06-25 14:49:07');
INSERT INTO `access_log` VALUES (43067, '64.85.15614453517192357', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:49:12', 18, 0, '', '2019-06-25 14:49:12');
INSERT INTO `access_log` VALUES (43068, '64.84.15614453769302335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:49:37', 9, 0, '', '2019-06-25 14:49:37');
INSERT INTO `access_log` VALUES (43069, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:49:37', 15, 0, '', '2019-06-25 14:49:37');
INSERT INTO `access_log` VALUES (43070, '64.82.15614453848922351', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:49:45', 11, 0, '', '2019-06-25 14:49:45');
INSERT INTO `access_log` VALUES (43071, '64.79.15614453899482351', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:49:50', 11, 0, '', '2019-06-25 14:49:50');
INSERT INTO `access_log` VALUES (43072, '64.83.15614453975372337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:49:58', 10, 0, '', '2019-06-25 14:49:58');
INSERT INTO `access_log` VALUES (43073, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:49:58', 15, 0, '', '2019-06-25 14:49:58');
INSERT INTO `access_log` VALUES (43074, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:49:59', 11, 0, '', '2019-06-25 14:49:59');
INSERT INTO `access_log` VALUES (43075, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:50:00', 12, 0, '', '2019-06-25 14:50:00');
INSERT INTO `access_log` VALUES (43076, '64.81.15614454005602341', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:50:01', 11, 0, '', '2019-06-25 14:50:01');
INSERT INTO `access_log` VALUES (43077, '66.54.15614454314930545', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 14:50:31', 10, 0, '', '2019-06-25 14:50:32');
INSERT INTO `access_log` VALUES (43078, '59.76.15614454655802295', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:51:06', 3, 0, '', '2019-06-25 14:51:06');
INSERT INTO `access_log` VALUES (43079, '59.73.15614454655802305', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:51:06', 12, 2001001000, '服务端发生异常', '2019-06-25 14:51:06');
INSERT INTO `access_log` VALUES (43080, '64.76.15614454715742331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:51:12', 3, 0, '', '2019-06-25 14:51:12');
INSERT INTO `access_log` VALUES (43081, '64.85.15614454716832361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:51:12', 1, 0, '', '2019-06-25 14:51:12');
INSERT INTO `access_log` VALUES (43082, '64.83.15614454735532339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:51:14', 2, 0, '', '2019-06-25 14:51:14');
INSERT INTO `access_log` VALUES (43083, '64.78.15614454747942349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:51:15', 2, 0, '', '2019-06-25 14:51:15');
INSERT INTO `access_log` VALUES (43084, '64.81.15614454756892343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:51:16', 1, 0, '', '2019-06-25 14:51:16');
INSERT INTO `access_log` VALUES (43085, '64.80.15614454809292347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:51:21', 2, 0, '', '2019-06-25 14:51:21');
INSERT INTO `access_log` VALUES (43086, '64.82.15614454810472355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:51:21', 2, 0, '', '2019-06-25 14:51:21');
INSERT INTO `access_log` VALUES (43087, '65.50.15614455092373413', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:51:49', 1, 1002001015, '账号未登陆', '2019-06-25 14:51:49');
INSERT INTO `access_log` VALUES (43088, '65.54.15614455092583349', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:51:49', 1, 1002001015, '账号未登陆', '2019-06-25 14:51:49');
INSERT INTO `access_log` VALUES (43089, '65.52.15614455092623413', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:51:49', 0, 1002001015, '账号未登陆', '2019-06-25 14:51:49');
INSERT INTO `access_log` VALUES (43090, '65.47.15614455193623369', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:51:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 14:51:59');
INSERT INTO `access_log` VALUES (43091, '65.49.15614455290503401', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:52:09', 64, 0, '', '2019-06-25 14:52:09');
INSERT INTO `access_log` VALUES (43092, '65.53.15614455295503389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:52:10', 10, 0, '', '2019-06-25 14:52:10');
INSERT INTO `access_log` VALUES (43093, '65.51.15614455295523435', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:52:10', 10, 2001001000, '服务端发生异常', '2019-06-25 14:52:10');
INSERT INTO `access_log` VALUES (43094, '65.45.15614455295543391', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.102.23.3', '2019-06-25 14:52:10', 8, 0, '', '2019-06-25 14:52:10');
INSERT INTO `access_log` VALUES (43095, '59.77.15614455587692287', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.206.238', '2019-06-25 14:52:39', 3, 0, '', '2019-06-25 14:52:39');
INSERT INTO `access_log` VALUES (43096, '59.72.15614455587732299', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.206.238', '2019-06-25 14:52:39', 13, 2001001000, '服务端发生异常', '2019-06-25 14:52:39');
INSERT INTO `access_log` VALUES (43097, '65.50.15614477921653445', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.200.193.19', '2019-06-25 15:29:52', 0, 1002001015, '账号未登陆', '2019-06-25 15:29:52');
INSERT INTO `access_log` VALUES (43098, '65.52.15614477921663445', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.200.193.19', '2019-06-25 15:29:52', 1, 1002001015, '账号未登陆', '2019-06-25 15:29:52');
INSERT INTO `access_log` VALUES (43099, '65.54.15614477921663381', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.200.193.19', '2019-06-25 15:29:52', 1, 1002001015, '账号未登陆', '2019-06-25 15:29:52');
INSERT INTO `access_log` VALUES (43100, '65.3607.15614478153275205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.200.193.19', '2019-06-25 15:30:15', 74, 0, '', '2019-06-25 15:30:15');
INSERT INTO `access_log` VALUES (43101, '65.49.15614478157183433', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.200.193.19', '2019-06-25 15:30:16', 9, 0, '', '2019-06-25 15:30:16');
INSERT INTO `access_log` VALUES (43102, '65.45.15614478157233423', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.200.193.19', '2019-06-25 15:30:16', 8, 0, '', '2019-06-25 15:30:16');
INSERT INTO `access_log` VALUES (43103, '65.53.15614478157223421', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.200.193.19', '2019-06-25 15:30:16', 12, 2001001000, '服务端发生异常', '2019-06-25 15:30:16');
INSERT INTO `access_log` VALUES (43104, '65.50.15614478439863447', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.200.193.19', '2019-06-25 15:30:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 15:30:44');
INSERT INTO `access_log` VALUES (43105, '59.79.15614484565262345', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.218.151.128', '2019-06-25 15:40:57', 10, 0, '', '2019-06-25 15:40:57');
INSERT INTO `access_log` VALUES (43106, '59.75.15614484565252345', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.218.151.128', '2019-06-25 15:40:57', 15, 2001001000, '服务端发生异常', '2019-06-25 15:40:57');
INSERT INTO `access_log` VALUES (43107, '59.71.15614484693202343', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.218.151.128', '2019-06-25 15:41:09', 3, 0, '', '2019-06-25 15:41:09');
INSERT INTO `access_log` VALUES (43108, '59.78.15614484693252337', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.218.151.128', '2019-06-25 15:41:09', 13, 2001001000, '服务端发生异常', '2019-06-25 15:41:09');
INSERT INTO `access_log` VALUES (43109, '64.77.15614484719862383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.218.151.128', '2019-06-25 15:41:12', 11, 0, '', '2019-06-25 15:41:12');
INSERT INTO `access_log` VALUES (43110, '64.79.15614484721252395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.218.151.128', '2019-06-25 15:41:12', 3, 0, '', '2019-06-25 15:41:12');
INSERT INTO `access_log` VALUES (43111, '64.76.15614484737352373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.218.151.128', '2019-06-25 15:41:14', 9, 0, '', '2019-06-25 15:41:14');
INSERT INTO `access_log` VALUES (43112, '64.85.15614484749722403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.218.151.128', '2019-06-25 15:41:15', 2, 0, '', '2019-06-25 15:41:15');
INSERT INTO `access_log` VALUES (43113, '64.83.15614484754672381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.218.151.128', '2019-06-25 15:41:15', 2, 0, '', '2019-06-25 15:41:15');
INSERT INTO `access_log` VALUES (43114, '59.72.15614490759722347', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-25 15:51:16', 3, 0, '', '2019-06-25 15:51:16');
INSERT INTO `access_log` VALUES (43115, '59.77.15614490759722335', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-25 15:51:16', 12, 2001001000, '服务端发生异常', '2019-06-25 15:51:16');
INSERT INTO `access_log` VALUES (43116, '64.78.15614490804942399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-25 15:51:20', 4, 0, '', '2019-06-25 15:51:20');
INSERT INTO `access_log` VALUES (43117, '64.84.15614490806492389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-25 15:51:21', 2, 0, '', '2019-06-25 15:51:21');
INSERT INTO `access_log` VALUES (43118, '64.80.15614490818922397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-25 15:51:22', 2, 0, '', '2019-06-25 15:51:22');
INSERT INTO `access_log` VALUES (43119, '64.82.15614490826422403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-25 15:51:23', 2, 0, '', '2019-06-25 15:51:23');
INSERT INTO `access_log` VALUES (43120, '64.77.15614490836152393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-25 15:51:24', 2, 0, '', '2019-06-25 15:51:24');
INSERT INTO `access_log` VALUES (43121, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=jk&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-25 15:51:27', 7, 0, '', '2019-06-25 15:51:27');
INSERT INTO `access_log` VALUES (43122, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=jk', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-25 15:51:27', 5, 0, '', '2019-06-25 15:51:27');
INSERT INTO `access_log` VALUES (43123, '65.51.15614509805233511', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-25 16:23:01', 0, 1002001015, '账号未登陆', '2019-06-25 16:23:01');
INSERT INTO `access_log` VALUES (43124, '65.53.15614509805243467', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-25 16:23:01', 0, 1002001015, '账号未登陆', '2019-06-25 16:23:01');
INSERT INTO `access_log` VALUES (43125, '65.50.15614509805253489', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-25 16:23:01', 0, 1002001015, '账号未登陆', '2019-06-25 16:23:01');
INSERT INTO `access_log` VALUES (43126, '65.52.15614509823263491', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-25 16:23:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 16:23:02');
INSERT INTO `access_log` VALUES (43127, '65.47.15614509935133447', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-25 16:23:14', 164, 0, '', '2019-06-25 16:23:14');
INSERT INTO `access_log` VALUES (43128, '65.54.15614509939483425', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-25 16:23:14', 11, 0, '', '2019-06-25 16:23:14');
INSERT INTO `access_log` VALUES (43129, '65.49.15614509939533477', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-25 16:23:14', 10, 2001001000, '服务端发生异常', '2019-06-25 16:23:14');
INSERT INTO `access_log` VALUES (43130, '65.3607.15614509939615251', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-25 16:23:14', 9, 0, '', '2019-06-25 16:23:14');
INSERT INTO `access_log` VALUES (43131, '65.51.15614512681683517', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:27:48', 0, 1002001015, '账号未登陆', '2019-06-25 16:27:48');
INSERT INTO `access_log` VALUES (43132, '65.50.15614512681733495', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:27:48', 0, 1002001015, '账号未登陆', '2019-06-25 16:27:48');
INSERT INTO `access_log` VALUES (43133, '65.52.15614512681753495', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:27:48', 1, 1002001015, '账号未登陆', '2019-06-25 16:27:48');
INSERT INTO `access_log` VALUES (43134, '65.46.15614512701993533', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:27:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 16:27:50');
INSERT INTO `access_log` VALUES (43135, '65.49.15614512748833481', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:27:55', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 16:27:55');
INSERT INTO `access_log` VALUES (43136, '59.77.15614512794862365', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:27:59', 14, 0, '', '2019-06-25 16:28:00');
INSERT INTO `access_log` VALUES (43137, '59.78.15614512794862375', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:27:59', 27, 2001001000, '服务端发生异常', '2019-06-25 16:28:00');
INSERT INTO `access_log` VALUES (43138, '64.84.15614512822132419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:28:02', 10, 0, '', '2019-06-25 16:28:02');
INSERT INTO `access_log` VALUES (43139, '64.80.15614512824352427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:28:02', 3, 0, '', '2019-06-25 16:28:02');
INSERT INTO `access_log` VALUES (43140, '64.82.15614512836512433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:28:04', 2, 0, '', '2019-06-25 16:28:04');
INSERT INTO `access_log` VALUES (43141, '64.77.15614512839262423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:28:04', 2, 0, '', '2019-06-25 16:28:04');
INSERT INTO `access_log` VALUES (43142, '64.79.15614512842922435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:28:04', 1, 0, '', '2019-06-25 16:28:04');
INSERT INTO `access_log` VALUES (43143, '64.76.15614512846522413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:28:05', 2, 0, '', '2019-06-25 16:28:05');
INSERT INTO `access_log` VALUES (43144, '64.85.15614512849442443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:28:05', 2, 0, '', '2019-06-25 16:28:05');
INSERT INTO `access_log` VALUES (43145, '59.76.15614512858852375', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:28:06', 3, 0, '', '2019-06-25 16:28:06');
INSERT INTO `access_log` VALUES (43146, '59.73.15614512858912385', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.53.191.130', '2019-06-25 16:28:06', 12, 2001001000, '服务端发生异常', '2019-06-25 16:28:06');
INSERT INTO `access_log` VALUES (43147, '59.75.15614528183782405', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.154.101.136', '2019-06-25 16:53:38', 3, 0, '', '2019-06-25 16:53:38');
INSERT INTO `access_log` VALUES (43148, '59.80.15614528183782389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.154.101.136', '2019-06-25 16:53:38', 13, 2001001000, '服务端发生异常', '2019-06-25 16:53:38');
INSERT INTO `access_log` VALUES (43149, '64.84.15614528241812441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.154.101.136', '2019-06-25 16:53:44', 3, 0, '', '2019-06-25 16:53:44');
INSERT INTO `access_log` VALUES (43150, '64.80.15614528243052449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.154.101.136', '2019-06-25 16:53:44', 2, 0, '', '2019-06-25 16:53:44');
INSERT INTO `access_log` VALUES (43151, '64.82.15614528254692455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.154.101.136', '2019-06-25 16:53:45', 2, 0, '', '2019-06-25 16:53:45');
INSERT INTO `access_log` VALUES (43152, '64.77.15614528262642445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.154.101.136', '2019-06-25 16:53:46', 2, 0, '', '2019-06-25 16:53:46');
INSERT INTO `access_log` VALUES (43153, '59.71.15614528276112403', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.154.101.136', '2019-06-25 16:53:48', 2, 0, '', '2019-06-25 16:53:48');
INSERT INTO `access_log` VALUES (43154, '59.77.15614528276122387', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.154.101.136', '2019-06-25 16:53:48', 12, 2001001000, '服务端发生异常', '2019-06-25 16:53:48');
INSERT INTO `access_log` VALUES (43155, '64.76.15614528337092435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.154.101.136', '2019-06-25 16:53:54', 2, 0, '', '2019-06-25 16:53:54');
INSERT INTO `access_log` VALUES (43156, '64.85.15614528338342465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '27.154.101.136', '2019-06-25 16:53:54', 2, 0, '', '2019-06-25 16:53:54');
INSERT INTO `access_log` VALUES (43157, '65.53.15614529780873497', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:56:18', 0, 1002001015, '账号未登陆', '2019-06-25 16:56:18');
INSERT INTO `access_log` VALUES (43158, '65.52.15614529780883519', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:56:18', 0, 1002001015, '账号未登陆', '2019-06-25 16:56:18');
INSERT INTO `access_log` VALUES (43159, '65.50.15614529780883519', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:56:18', 0, 1002001015, '账号未登陆', '2019-06-25 16:56:18');
INSERT INTO `access_log` VALUES (43160, '65.46.15614529960503557', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:56:36', 86, 0, '', '2019-06-25 16:56:36');
INSERT INTO `access_log` VALUES (43161, '65.47.15614529965653477', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:56:37', 10, 0, '', '2019-06-25 16:56:37');
INSERT INTO `access_log` VALUES (43162, '65.49.15614529965683505', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:56:37', 10, 2001001000, '服务端发生异常', '2019-06-25 16:56:37');
INSERT INTO `access_log` VALUES (43163, '65.3607.15614529965755281', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:56:37', 8, 0, '', '2019-06-25 16:56:37');
INSERT INTO `access_log` VALUES (43164, '65.50.15614530420453521', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:57:22', 10, 0, '', '2019-06-25 16:57:22');
INSERT INTO `access_log` VALUES (43165, '65.52.15614530420453521', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:57:22', 10, 2001001000, '服务端发生异常', '2019-06-25 16:57:22');
INSERT INTO `access_log` VALUES (43166, '65.51.15614530420543543', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:57:22', 8, 0, '', '2019-06-25 16:57:22');
INSERT INTO `access_log` VALUES (43167, '65.49.15614530489453507', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:57:29', 9, 0, '', '2019-06-25 16:57:29');
INSERT INTO `access_log` VALUES (43168, '65.47.15614530489463479', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:57:29', 10, 2001001000, '服务端发生异常', '2019-06-25 16:57:29');
INSERT INTO `access_log` VALUES (43169, '65.3607.15614530489605283', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:57:29', 8, 0, '', '2019-06-25 16:57:29');
INSERT INTO `access_log` VALUES (43170, '65.54.15614530595843457', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:57:40', 8, 0, '', '2019-06-25 16:57:40');
INSERT INTO `access_log` VALUES (43171, '65.53.15614530595903501', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:57:40', 7, 0, '', '2019-06-25 16:57:40');
INSERT INTO `access_log` VALUES (43172, '65.50.15614530595913523', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:57:40', 8, 2001001000, '服务端发生异常', '2019-06-25 16:57:40');
INSERT INTO `access_log` VALUES (43173, '65.51.15614530634053545', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:57:43', 9, 0, '', '2019-06-25 16:57:43');
INSERT INTO `access_log` VALUES (43174, '65.46.15614530634153561', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:57:43', 9, 0, '', '2019-06-25 16:57:43');
INSERT INTO `access_log` VALUES (43175, '65.52.15614530634143523', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.89.238.229', '2019-06-25 16:57:43', 9, 2001001000, '服务端发生异常', '2019-06-25 16:57:43');
INSERT INTO `access_log` VALUES (43176, '59.72.15614534378652407', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:03:58', 4, 0, '', '2019-06-25 17:03:58');
INSERT INTO `access_log` VALUES (43177, '59.73.15614534378672415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:03:58', 13, 2001001000, '服务端发生异常', '2019-06-25 17:03:58');
INSERT INTO `access_log` VALUES (43178, '64.83.15614534417762451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:02', 4, 0, '', '2019-06-25 17:04:02');
INSERT INTO `access_log` VALUES (43179, '64.81.15614534420602455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:02', 2, 0, '', '2019-06-25 17:04:02');
INSERT INTO `access_log` VALUES (43180, '64.78.15614534444852461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:04', 2, 0, '', '2019-06-25 17:04:04');
INSERT INTO `access_log` VALUES (43181, '64.84.15614534451712451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:05', 2, 0, '', '2019-06-25 17:04:05');
INSERT INTO `access_log` VALUES (43182, '64.82.15614534457822465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:06', 2, 0, '', '2019-06-25 17:04:06');
INSERT INTO `access_log` VALUES (43183, '64.77.15614534461182455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:06', 2, 0, '', '2019-06-25 17:04:06');
INSERT INTO `access_log` VALUES (43184, '59.74.15614534471352409', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:07', 8, 0, '', '2019-06-25 17:04:07');
INSERT INTO `access_log` VALUES (43185, '59.79.15614534471372415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:07', 9, 2001001000, '服务端发生异常', '2019-06-25 17:04:07');
INSERT INTO `access_log` VALUES (43186, '66.48.15614534523240653', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空', '2019-06-25 17:04:12');
INSERT INTO `access_log` VALUES (43187, '59.80.15614534691882399', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:29', 3, 0, '', '2019-06-25 17:04:29');
INSERT INTO `access_log` VALUES (43188, '59.71.15614534691892413', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:29', 13, 2001001000, '服务端发生异常', '2019-06-25 17:04:29');
INSERT INTO `access_log` VALUES (43189, '64.76.15614534708502445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:31', 2, 0, '', '2019-06-25 17:04:31');
INSERT INTO `access_log` VALUES (43190, '64.85.15614534709472475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:31', 2, 0, '', '2019-06-25 17:04:31');
INSERT INTO `access_log` VALUES (43191, '59.77.15614534721112397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:32', 2, 0, '', '2019-06-25 17:04:32');
INSERT INTO `access_log` VALUES (43192, '59.78.15614534721112407', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:04:32', 11, 2001001000, '服务端发生异常', '2019-06-25 17:04:32');
INSERT INTO `access_log` VALUES (43193, '65.52.15614535061283529', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:06', 0, 1002001015, '账号未登陆', '2019-06-25 17:05:06');
INSERT INTO `access_log` VALUES (43194, '65.3607.15614535061305291', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:06', 0, 1002001015, '账号未登陆', '2019-06-25 17:05:06');
INSERT INTO `access_log` VALUES (43195, '65.47.15614535061423487', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:06', 0, 1002001015, '账号未登陆', '2019-06-25 17:05:06');
INSERT INTO `access_log` VALUES (43196, '65.45.15614535117963509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:12', 72, 0, '', '2019-06-25 17:05:12');
INSERT INTO `access_log` VALUES (43197, '65.54.15614535121473465', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:12', 11, 0, '', '2019-06-25 17:05:12');
INSERT INTO `access_log` VALUES (43198, '65.53.15614535121493509', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:12', 9, 0, '', '2019-06-25 17:05:12');
INSERT INTO `access_log` VALUES (43199, '65.50.15614535121493531', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:12', 11, 2001001000, '服务端发生异常', '2019-06-25 17:05:12');
INSERT INTO `access_log` VALUES (43200, '65.3607.15614535495805293', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:50', 8, 0, '', '2019-06-25 17:05:50');
INSERT INTO `access_log` VALUES (43201, '65.52.15614535495833531', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:50', 9, 2001001000, '服务端发生异常', '2019-06-25 17:05:50');
INSERT INTO `access_log` VALUES (43202, '65.47.15614535495863489', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:50', 9, 0, '', '2019-06-25 17:05:50');
INSERT INTO `access_log` VALUES (43203, '65.49.15614535533393517', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:53', 9, 0, '', '2019-06-25 17:05:53');
INSERT INTO `access_log` VALUES (43204, '65.45.15614535533433511', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:53', 18, 2001001000, '服务端发生异常', '2019-06-25 17:05:53');
INSERT INTO `access_log` VALUES (43205, '65.50.15614535533473533', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:53', 16, 0, '', '2019-06-25 17:05:53');
INSERT INTO `access_log` VALUES (43206, '65.54.15614535553543467', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:55', 9, 0, '', '2019-06-25 17:05:55');
INSERT INTO `access_log` VALUES (43207, '65.51.15614535553583555', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:55', 10, 2001001000, '服务端发生异常', '2019-06-25 17:05:55');
INSERT INTO `access_log` VALUES (43208, '65.46.15614535553633571', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:55', 9, 0, '', '2019-06-25 17:05:55');
INSERT INTO `access_log` VALUES (43209, '65.52.15614535587783533', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:59', 10, 0, '', '2019-06-25 17:05:59');
INSERT INTO `access_log` VALUES (43210, '65.3607.15614535587845295', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:59', 10, 2001001000, '服务端发生异常', '2019-06-25 17:05:59');
INSERT INTO `access_log` VALUES (43211, '65.47.15614535587883491', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:05:59', 9, 0, '', '2019-06-25 17:05:59');
INSERT INTO `access_log` VALUES (43212, '65.54.15614539447033473', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:12:25', 10, 0, '', '2019-06-25 17:12:25');
INSERT INTO `access_log` VALUES (43213, '65.47.15614539447043497', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:12:25', 10, 2001001000, '服务端发生异常', '2019-06-25 17:12:25');
INSERT INTO `access_log` VALUES (43214, '65.3607.15614539447095301', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.212.25.25', '2019-06-25 17:12:25', 9, 0, '', '2019-06-25 17:12:25');
INSERT INTO `access_log` VALUES (43215, '59.77.15614545021122411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '58.132.207.109', '2019-06-25 17:21:42', 2, 0, '', '2019-06-25 17:21:42');
INSERT INTO `access_log` VALUES (43216, '59.72.15614545021142423', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '58.132.207.109', '2019-06-25 17:21:42', 10, 2001001000, '服务端发生异常', '2019-06-25 17:21:42');
INSERT INTO `access_log` VALUES (43217, '64.85.15614545063462489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '58.132.207.109', '2019-06-25 17:21:46', 3, 0, '', '2019-06-25 17:21:46');
INSERT INTO `access_log` VALUES (43218, '64.83.15614545065772467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '58.132.207.109', '2019-06-25 17:21:47', 2, 0, '', '2019-06-25 17:21:47');
INSERT INTO `access_log` VALUES (43219, '64.81.15614545077652471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '58.132.207.109', '2019-06-25 17:21:48', 2, 0, '', '2019-06-25 17:21:48');
INSERT INTO `access_log` VALUES (43220, '64.78.15614545082312477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '58.132.207.109', '2019-06-25 17:21:48', 2, 0, '', '2019-06-25 17:21:48');
INSERT INTO `access_log` VALUES (43221, '65.51.15614549006773575', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.220.252.156', '2019-06-25 17:28:21', 0, 1002001015, '账号未登陆', '2019-06-25 17:28:21');
INSERT INTO `access_log` VALUES (43222, '65.53.15614549006763531', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.220.252.156', '2019-06-25 17:28:21', 0, 1002001015, '账号未登陆', '2019-06-25 17:28:21');
INSERT INTO `access_log` VALUES (43223, '65.46.15614549006923591', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.220.252.156', '2019-06-25 17:28:21', 0, 1002001015, '账号未登陆', '2019-06-25 17:28:21');
INSERT INTO `access_log` VALUES (43224, '65.47.15614549128883511', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.220.252.156', '2019-06-25 17:28:33', 69, 0, '', '2019-06-25 17:28:33');
INSERT INTO `access_log` VALUES (43225, '65.3607.15614549131865315', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.220.252.156', '2019-06-25 17:28:33', 83, 0, '', '2019-06-25 17:28:33');
INSERT INTO `access_log` VALUES (43226, '65.52.15614549131893553', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.220.252.156', '2019-06-25 17:28:33', 83, 2001001000, '服务端发生异常', '2019-06-25 17:28:33');
INSERT INTO `access_log` VALUES (43227, '65.50.15614549131893553', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.220.252.156', '2019-06-25 17:28:33', 82, 0, '', '2019-06-25 17:28:33');
INSERT INTO `access_log` VALUES (43228, '59.76.15614554149542433', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:36:55', 3, 0, '', '2019-06-25 17:36:55');
INSERT INTO `access_log` VALUES (43229, '59.79.15614554149542443', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:36:55', 12, 2001001000, '服务端发生异常', '2019-06-25 17:36:55');
INSERT INTO `access_log` VALUES (43230, '64.80.15614554184872487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:36:58', 114, 0, '', '2019-06-25 17:36:59');
INSERT INTO `access_log` VALUES (43231, '64.82.15614554187792493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:36:59', 2, 0, '', '2019-06-25 17:36:59');
INSERT INTO `access_log` VALUES (43232, '64.77.15614554219132483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:37:02', 2, 0, '', '2019-06-25 17:37:02');
INSERT INTO `access_log` VALUES (43233, '64.79.15614554220412495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:37:02', 2, 0, '', '2019-06-25 17:37:02');
INSERT INTO `access_log` VALUES (43234, '59.74.15614554230672437', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:37:03', 3, 0, '', '2019-06-25 17:37:03');
INSERT INTO `access_log` VALUES (43235, '59.75.15614554230672443', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:37:03', 14, 2001001000, '服务端发生异常', '2019-06-25 17:37:03');
INSERT INTO `access_log` VALUES (43236, '65.51.15614556240833587', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:40:24', 4, 1002001012, '访问令牌已过期', '2019-06-25 17:40:24');
INSERT INTO `access_log` VALUES (43237, '65.53.15614556240923543', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:40:24', 3, 1002001012, '访问令牌已过期', '2019-06-25 17:40:24');
INSERT INTO `access_log` VALUES (43238, '65.46.15614556241163603', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:40:24', 3, 1002001012, '访问令牌已过期', '2019-06-25 17:40:24');
INSERT INTO `access_log` VALUES (43239, '65.54.15614556258983497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:40:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 17:40:26');
INSERT INTO `access_log` VALUES (43240, '65.3607.15614556348625327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:40:35', 91, 0, '', '2019-06-25 17:40:35');
INSERT INTO `access_log` VALUES (43241, '65.52.15614556353373565', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:40:35', 8, 0, '', '2019-06-25 17:40:35');
INSERT INTO `access_log` VALUES (43242, '65.47.15614556353453521', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:40:35', 17, 2001001000, '服务端发生异常', '2019-06-25 17:40:35');
INSERT INTO `access_log` VALUES (43243, '65.45.15614556353483545', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.11.147', '2019-06-25 17:40:35', 15, 0, '', '2019-06-25 17:40:35');
INSERT INTO `access_log` VALUES (43244, '64.76.15614556973202477', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 17:41:37', 13, 0, '', '2019-06-25 17:41:37');
INSERT INTO `access_log` VALUES (43245, '66.55.15614557031190667', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 17:41:43', 16, 0, '', '2019-06-25 17:41:43');
INSERT INTO `access_log` VALUES (43246, '59.75.15614557061612447', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.143', '2019-06-25 17:41:46', 3, 0, '', '2019-06-25 17:41:46');
INSERT INTO `access_log` VALUES (43247, '59.71.15614557061682445', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.143', '2019-06-25 17:41:46', 16, 2001001000, '服务端发生异常', '2019-06-25 17:41:46');
INSERT INTO `access_log` VALUES (43248, '64.83.15614557093232485', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 17:41:49', 11, 0, '', '2019-06-25 17:41:49');
INSERT INTO `access_log` VALUES (43249, '64.78.15614557094522495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 17:41:49', 8, 0, '', '2019-06-25 17:41:49');
INSERT INTO `access_log` VALUES (43250, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 17:41:49', 13, 0, '', '2019-06-25 17:41:49');
INSERT INTO `access_log` VALUES (43251, '64.82.15614557121572499', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 17:41:52', 10, 0, '', '2019-06-25 17:41:52');
INSERT INTO `access_log` VALUES (43252, '65.3607.15614557197705329', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.143', '2019-06-25 17:42:00', 1, 1002001015, '账号未登陆', '2019-06-25 17:42:00');
INSERT INTO `access_log` VALUES (43253, '65.47.15614557197753523', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.143', '2019-06-25 17:42:00', 0, 1002001015, '账号未登陆', '2019-06-25 17:42:00');
INSERT INTO `access_log` VALUES (43254, '65.52.15614557197793567', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.143', '2019-06-25 17:42:00', 0, 1002001015, '账号未登陆', '2019-06-25 17:42:00');
INSERT INTO `access_log` VALUES (43255, '65.45.15614557217303547', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.143', '2019-06-25 17:42:02', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 17:42:02');
INSERT INTO `access_log` VALUES (43256, '65.50.15614557264743567', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.143', '2019-06-25 17:42:06', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 17:42:06');
INSERT INTO `access_log` VALUES (43257, '66.56.15614557322950687', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 17:42:12', 7, 0, '', '2019-06-25 17:42:12');
INSERT INTO `access_log` VALUES (43258, '65.53.15614557339343547', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.143', '2019-06-25 17:42:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 17:42:14');
INSERT INTO `access_log` VALUES (43259, '66.50.15614557405080669', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 17:42:21', 10, 0, '', '2019-06-25 17:42:21');
INSERT INTO `access_log` VALUES (43260, '65.46.15614557503163607', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.143', '2019-06-25 17:42:30', 53, 0, '', '2019-06-25 17:42:30');
INSERT INTO `access_log` VALUES (43261, '65.54.15614557506573501', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.143', '2019-06-25 17:42:31', 9, 0, '', '2019-06-25 17:42:31');
INSERT INTO `access_log` VALUES (43262, '65.3607.15614557506605331', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.143', '2019-06-25 17:42:31', 10, 2001001000, '服务端发生异常', '2019-06-25 17:42:31');
INSERT INTO `access_log` VALUES (43263, '65.52.15614557506663569', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.143', '2019-06-25 17:42:31', 9, 0, '', '2019-06-25 17:42:31');
INSERT INTO `access_log` VALUES (43264, '66.55.15614557624590669', 0, 1, 'user-application', '/user-api/users/address/add', 'name=1&tel=18408221234&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=1&isDefault=false&address=1&areaNo=110101&mobile=18408221234&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 17:42:42', 101, 2001001000, '服务端发生异常', '2019-06-25 17:42:43');
INSERT INTO `access_log` VALUES (43265, '65.53.15614559452333551', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:45:45', 1, 1002001015, '账号未登陆', '2019-06-25 17:45:45');
INSERT INTO `access_log` VALUES (43266, '65.49.15614559452323557', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:45:45', 1, 1002001015, '账号未登陆', '2019-06-25 17:45:45');
INSERT INTO `access_log` VALUES (43267, '65.51.15614559452333595', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:45:45', 0, 1002001015, '账号未登陆', '2019-06-25 17:45:45');
INSERT INTO `access_log` VALUES (43268, '65.52.15614559553973573', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:45:55', 66, 0, '', '2019-06-25 17:45:55');
INSERT INTO `access_log` VALUES (43269, '65.3607.15614559559965335', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:45:56', 10, 0, '', '2019-06-25 17:45:56');
INSERT INTO `access_log` VALUES (43270, '65.47.15614559560003529', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:45:56', 8, 0, '', '2019-06-25 17:45:56');
INSERT INTO `access_log` VALUES (43271, '65.54.15614559559963505', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:45:56', 157, 2001001000, '服务端发生异常', '2019-06-25 17:45:56');
INSERT INTO `access_log` VALUES (43272, '65.53.15614559951393553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:46:35', 9, 0, '', '2019-06-25 17:46:35');
INSERT INTO `access_log` VALUES (43273, '65.51.15614559951393597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:46:35', 8, 0, '', '2019-06-25 17:46:35');
INSERT INTO `access_log` VALUES (43274, '65.49.15614559951403559', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:46:35', 9, 2001001000, '服务端发生异常', '2019-06-25 17:46:35');
INSERT INTO `access_log` VALUES (43275, '59.72.15614560294562445', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:47:09', 3, 0, '', '2019-06-25 17:47:09');
INSERT INTO `access_log` VALUES (43276, '59.77.15614560294562433', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:47:09', 13, 2001001000, '服务端发生异常', '2019-06-25 17:47:09');
INSERT INTO `access_log` VALUES (43277, '65.45.15614567209563563', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:58:41', 10, 0, '', '2019-06-25 17:58:41');
INSERT INTO `access_log` VALUES (43278, '65.51.15614567209573607', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:58:41', 9, 0, '', '2019-06-25 17:58:41');
INSERT INTO `access_log` VALUES (43279, '65.50.15614567209553585', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:48.0) Gecko/20100101 Firefox/48.0', '116.233.205.214', '2019-06-25 17:58:41', 11, 2001001000, '服务端发生异常', '2019-06-25 17:58:41');
INSERT INTO `access_log` VALUES (43280, '65.47.15614571788033547', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-06-25 18:06:19', 4, 1002001012, '访问令牌已过期', '2019-06-25 18:06:19');
INSERT INTO `access_log` VALUES (43281, '65.54.15614571788033525', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-06-25 18:06:19', 4, 1002001012, '访问令牌已过期', '2019-06-25 18:06:19');
INSERT INTO `access_log` VALUES (43282, '65.53.15614571788133573', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-06-25 18:06:19', 3, 1002001012, '访问令牌已过期', '2019-06-25 18:06:19');
INSERT INTO `access_log` VALUES (43283, '65.51.15614571838063615', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-06-25 18:06:24', 970, 0, '', '2019-06-25 18:06:25');
INSERT INTO `access_log` VALUES (43284, '65.3607.15614571849715355', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-06-25 18:06:25', 152, 0, '', '2019-06-25 18:06:25');
INSERT INTO `access_log` VALUES (43285, '65.45.15614571849683569', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-06-25 18:06:25', 153, 0, '', '2019-06-25 18:06:25');
INSERT INTO `access_log` VALUES (43286, '65.52.15614571849703591', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-06-25 18:06:25', 153, 2001001000, '服务端发生异常', '2019-06-25 18:06:25');
INSERT INTO `access_log` VALUES (43287, '65.50.15614579942053605', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.152.104.20', '2019-06-25 18:19:54', 0, 1002001015, '账号未登陆', '2019-06-25 18:19:54');
INSERT INTO `access_log` VALUES (43288, '65.54.15614579942053537', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.152.104.20', '2019-06-25 18:19:54', 0, 1002001015, '账号未登陆', '2019-06-25 18:19:54');
INSERT INTO `access_log` VALUES (43289, '65.51.15614579942073627', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.152.104.20', '2019-06-25 18:19:54', 0, 1002001015, '账号未登陆', '2019-06-25 18:19:54');
INSERT INTO `access_log` VALUES (43290, '65.3607.15614579990405367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.152.104.20', '2019-06-25 18:19:59', 175, 0, '', '2019-06-25 18:19:59');
INSERT INTO `access_log` VALUES (43291, '65.52.15614579994493603', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.152.104.20', '2019-06-25 18:19:59', 10, 0, '', '2019-06-25 18:19:59');
INSERT INTO `access_log` VALUES (43292, '65.45.15614579994513581', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.152.104.20', '2019-06-25 18:19:59', 11, 2001001000, '服务端发生异常', '2019-06-25 18:19:59');
INSERT INTO `access_log` VALUES (43293, '65.46.15614579994523645', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.152.104.20', '2019-06-25 18:19:59', 9, 0, '', '2019-06-25 18:19:59');
INSERT INTO `access_log` VALUES (43294, '65.53.15614580212703587', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.152.104.20', '2019-06-25 18:20:21', 11, 0, '', '2019-06-25 18:20:21');
INSERT INTO `access_log` VALUES (43295, '65.47.15614580212753561', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.152.104.20', '2019-06-25 18:20:21', 9, 2001001000, '服务端发生异常', '2019-06-25 18:20:21');
INSERT INTO `access_log` VALUES (43296, '65.51.15614580212763629', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.152.104.20', '2019-06-25 18:20:21', 11, 0, '', '2019-06-25 18:20:21');
INSERT INTO `access_log` VALUES (43297, '65.45.15614586712343591', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.236.208', '2019-06-25 18:31:11', 1, 1002001015, '账号未登陆', '2019-06-25 18:31:11');
INSERT INTO `access_log` VALUES (43298, '65.46.15614586712353655', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.236.208', '2019-06-25 18:31:11', 0, 1002001015, '账号未登陆', '2019-06-25 18:31:11');
INSERT INTO `access_log` VALUES (43299, '65.49.15614586712363603', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.236.208', '2019-06-25 18:31:11', 1, 1002001015, '账号未登陆', '2019-06-25 18:31:11');
INSERT INTO `access_log` VALUES (43300, '65.53.15614586800903597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.236.208', '2019-06-25 18:31:20', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 18:31:20');
INSERT INTO `access_log` VALUES (43301, '65.51.15614586842393639', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.236.208', '2019-06-25 18:31:24', 89, 0, '', '2019-06-25 18:31:24');
INSERT INTO `access_log` VALUES (43302, '65.50.15614586846243617', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.236.208', '2019-06-25 18:31:25', 10, 0, '', '2019-06-25 18:31:25');
INSERT INTO `access_log` VALUES (43303, '65.3607.15614586846295379', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.236.208', '2019-06-25 18:31:25', 10, 0, '', '2019-06-25 18:31:25');
INSERT INTO `access_log` VALUES (43304, '65.54.15614586846293549', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.236.208', '2019-06-25 18:31:25', 11, 2001001000, '服务端发生异常', '2019-06-25 18:31:25');
INSERT INTO `access_log` VALUES (43305, '65.53.15614587299713599', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.236.208', '2019-06-25 18:32:10', 339, 0, '', '2019-06-25 18:32:10');
INSERT INTO `access_log` VALUES (43306, '65.47.15614587305063573', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.236.208', '2019-06-25 18:32:11', 9, 0, '', '2019-06-25 18:32:11');
INSERT INTO `access_log` VALUES (43307, '65.3607.15614587305105381', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.236.208', '2019-06-25 18:32:11', 8, 0, '', '2019-06-25 18:32:11');
INSERT INTO `access_log` VALUES (43308, '65.51.15614587305103641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '111.204.236.208', '2019-06-25 18:32:11', 10, 2001001000, '服务端发生异常', '2019-06-25 18:32:11');
INSERT INTO `access_log` VALUES (43309, '65.46.15614653693393747', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-25 20:22:49', 14, 1002001012, '访问令牌已过期', '2019-06-25 20:22:49');
INSERT INTO `access_log` VALUES (43310, '65.52.15614653693393703', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-25 20:22:49', 12, 1002001012, '访问令牌已过期', '2019-06-25 20:22:49');
INSERT INTO `access_log` VALUES (43311, '65.45.15614653693403683', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-25 20:22:49', 17, 1002001012, '访问令牌已过期', '2019-06-25 20:22:49');
INSERT INTO `access_log` VALUES (43312, '65.53.15614653743063689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-25 20:22:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 20:22:54');
INSERT INTO `access_log` VALUES (43313, '65.51.15614653810863731', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-25 20:23:01', 95, 0, '', '2019-06-25 20:23:01');
INSERT INTO `access_log` VALUES (43314, '65.47.15614653813963663', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-25 20:23:01', 11, 0, '', '2019-06-25 20:23:01');
INSERT INTO `access_log` VALUES (43315, '65.50.15614653813973709', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-25 20:23:01', 12, 0, '', '2019-06-25 20:23:01');
INSERT INTO `access_log` VALUES (43316, '65.3607.15614653813965471', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.157.204.143', '2019-06-25 20:23:01', 13, 2001001000, '服务端发生异常', '2019-06-25 20:23:01');
INSERT INTO `access_log` VALUES (43317, '65.47.15614664032163677', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.223.178', '2019-06-25 20:40:03', 1, 1002001015, '账号未登陆', '2019-06-25 20:40:03');
INSERT INTO `access_log` VALUES (43318, '65.50.15614664032153723', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.223.178', '2019-06-25 20:40:03', 1, 1002001015, '账号未登陆', '2019-06-25 20:40:03');
INSERT INTO `access_log` VALUES (43319, '65.54.15614664032333655', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.223.178', '2019-06-25 20:40:03', 0, 1002001015, '账号未登陆', '2019-06-25 20:40:03');
INSERT INTO `access_log` VALUES (43320, '65.46.15614664058643763', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.223.178', '2019-06-25 20:40:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 20:40:06');
INSERT INTO `access_log` VALUES (43321, '65.52.15614664139953719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.223.178', '2019-06-25 20:40:14', 75, 0, '', '2019-06-25 20:40:14');
INSERT INTO `access_log` VALUES (43322, '65.49.15614664143023711', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.223.178', '2019-06-25 20:40:14', 9, 0, '', '2019-06-25 20:40:14');
INSERT INTO `access_log` VALUES (43323, '65.53.15614664143043705', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.223.178', '2019-06-25 20:40:14', 10, 2001001000, '服务端发生异常', '2019-06-25 20:40:14');
INSERT INTO `access_log` VALUES (43324, '65.51.15614664143073747', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.223.178', '2019-06-25 20:40:14', 9, 0, '', '2019-06-25 20:40:14');
INSERT INTO `access_log` VALUES (43325, '65.50.15614664253503725', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.223.178', '2019-06-25 20:40:25', 9, 0, '', '2019-06-25 20:40:25');
INSERT INTO `access_log` VALUES (43326, '65.47.15614664253533679', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.223.178', '2019-06-25 20:40:25', 9, 2001001000, '服务端发生异常', '2019-06-25 20:40:25');
INSERT INTO `access_log` VALUES (43327, '65.54.15614664253563657', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.223.178', '2019-06-25 20:40:25', 9, 0, '', '2019-06-25 20:40:25');
INSERT INTO `access_log` VALUES (43328, '65.51.15614687302943779', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.192.130.76', '2019-06-25 21:18:50', 12, 1002001012, '访问令牌已过期', '2019-06-25 21:18:50');
INSERT INTO `access_log` VALUES (43329, '65.53.15614687302963737', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.192.130.76', '2019-06-25 21:18:50', 13, 1002001012, '访问令牌已过期', '2019-06-25 21:18:50');
INSERT INTO `access_log` VALUES (43330, '65.49.15614687302963743', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.192.130.76', '2019-06-25 21:18:50', 18, 1002001012, '访问令牌已过期', '2019-06-25 21:18:50');
INSERT INTO `access_log` VALUES (43331, '65.3607.15614687332385519', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.192.130.76', '2019-06-25 21:18:53', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 21:18:53');
INSERT INTO `access_log` VALUES (43332, '65.47.15614687424533711', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.192.130.76', '2019-06-25 21:19:02', 4, 1002002000, '账号不存在', '2019-06-25 21:19:02');
INSERT INTO `access_log` VALUES (43333, '65.46.15614687514103797', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.192.130.76', '2019-06-25 21:19:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-25 21:19:11');
INSERT INTO `access_log` VALUES (43334, '65.45.15614687568903733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.192.130.76', '2019-06-25 21:19:17', 84, 0, '', '2019-06-25 21:19:17');
INSERT INTO `access_log` VALUES (43335, '65.52.15614687572623753', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.192.130.76', '2019-06-25 21:19:17', 10, 0, '', '2019-06-25 21:19:17');
INSERT INTO `access_log` VALUES (43336, '65.49.15614687572823745', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.192.130.76', '2019-06-25 21:19:17', 204, 0, '', '2019-06-25 21:19:17');
INSERT INTO `access_log` VALUES (43337, '65.53.15614687572763739', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.192.130.76', '2019-06-25 21:19:17', 210, 2001001000, '服务端发生异常', '2019-06-25 21:19:17');
INSERT INTO `access_log` VALUES (43338, '59.75.15614788983242757', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.97', '2019-06-26 00:08:18', 14, 0, '', '2019-06-26 00:08:18');
INSERT INTO `access_log` VALUES (43339, '59.71.15614788983242755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.97', '2019-06-26 00:08:18', 67, 2001001000, '服务端发生异常', '2019-06-26 00:08:18');
INSERT INTO `access_log` VALUES (43340, '64.84.15614789188192795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.97', '2019-06-26 00:08:39', 12, 0, '', '2019-06-26 00:08:39');
INSERT INTO `access_log` VALUES (43341, '64.80.15614789190192803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.97', '2019-06-26 00:08:39', 3, 0, '', '2019-06-26 00:08:39');
INSERT INTO `access_log` VALUES (43342, '64.82.15614789210182809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.97', '2019-06-26 00:08:41', 2, 0, '', '2019-06-26 00:08:41');
INSERT INTO `access_log` VALUES (43343, '64.77.15614789216932799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.97', '2019-06-26 00:08:42', 2, 0, '', '2019-06-26 00:08:42');
INSERT INTO `access_log` VALUES (43344, '59.72.15614789230082751', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.97', '2019-06-26 00:08:43', 3, 0, '', '2019-06-26 00:08:43');
INSERT INTO `access_log` VALUES (43345, '59.77.15614789230202739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '223.104.63.97', '2019-06-26 00:08:43', 19, 2001001000, '服务端发生异常', '2019-06-26 00:08:43');
INSERT INTO `access_log` VALUES (43346, '65.54.15614793321633831', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.229.39', '2019-06-26 00:15:32', 0, 1002001015, '账号未登陆', '2019-06-26 00:15:32');
INSERT INTO `access_log` VALUES (43347, '65.46.15614793321643939', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.229.39', '2019-06-26 00:15:32', 0, 1002001015, '账号未登陆', '2019-06-26 00:15:32');
INSERT INTO `access_log` VALUES (43348, '65.45.15614793321663877', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.229.39', '2019-06-26 00:15:32', 0, 1002001015, '账号未登陆', '2019-06-26 00:15:32');
INSERT INTO `access_log` VALUES (43349, '65.52.15614793384973895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.229.39', '2019-06-26 00:15:38', 74, 0, '', '2019-06-26 00:15:39');
INSERT INTO `access_log` VALUES (43350, '65.50.15614793389443901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.229.39', '2019-06-26 00:15:39', 11, 0, '', '2019-06-26 00:15:39');
INSERT INTO `access_log` VALUES (43351, '65.3607.15614793389405663', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.229.39', '2019-06-26 00:15:39', 15, 0, '', '2019-06-26 00:15:39');
INSERT INTO `access_log` VALUES (43352, '65.49.15614793389443891', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.229.39', '2019-06-26 00:15:39', 13, 2001001000, '服务端发生异常', '2019-06-26 00:15:39');
INSERT INTO `access_log` VALUES (43353, '59.74.15614797002752763', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.192.99', '2019-06-26 00:21:40', 3, 0, '', '2019-06-26 00:21:40');
INSERT INTO `access_log` VALUES (43354, '59.76.15614797002752759', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.192.99', '2019-06-26 00:21:40', 25, 2001001000, '服务端发生异常', '2019-06-26 00:21:40');
INSERT INTO `access_log` VALUES (43355, '59.80.15614797119862753', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.190.180', '2019-06-26 00:21:52', 3, 0, '', '2019-06-26 00:21:52');
INSERT INTO `access_log` VALUES (43356, '59.75.15614797119852769', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.190.180', '2019-06-26 00:21:52', 18, 2001001000, '服务端发生异常', '2019-06-26 00:21:52');
INSERT INTO `access_log` VALUES (43357, '59.73.15614802045242777', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.196.215.186', '2019-06-26 00:30:05', 3, 0, '', '2019-06-26 00:30:05');
INSERT INTO `access_log` VALUES (43358, '59.79.15614802045242777', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.196.215.186', '2019-06-26 00:30:05', 13, 2001001000, '服务端发生异常', '2019-06-26 00:30:05');
INSERT INTO `access_log` VALUES (43359, '64.84.15614802073212813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.196.215.186', '2019-06-26 00:30:07', 206, 0, '', '2019-06-26 00:30:08');
INSERT INTO `access_log` VALUES (43360, '64.80.15614802077532821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.196.215.186', '2019-06-26 00:30:08', 2, 0, '', '2019-06-26 00:30:08');
INSERT INTO `access_log` VALUES (43361, '64.82.15614802092942827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.196.215.186', '2019-06-26 00:30:09', 3, 0, '', '2019-06-26 00:30:09');
INSERT INTO `access_log` VALUES (43362, '64.77.15614802099832817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.196.215.186', '2019-06-26 00:30:10', 2, 0, '', '2019-06-26 00:30:10');
INSERT INTO `access_log` VALUES (43363, '64.79.15614802108542829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.196.215.186', '2019-06-26 00:30:11', 2, 0, '', '2019-06-26 00:30:11');
INSERT INTO `access_log` VALUES (43364, '59.76.15614802126292767', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.196.215.186', '2019-06-26 00:30:13', 2, 0, '', '2019-06-26 00:30:13');
INSERT INTO `access_log` VALUES (43365, '59.74.15614802126292771', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.196.215.186', '2019-06-26 00:30:13', 16, 2001001000, '服务端发生异常', '2019-06-26 00:30:13');
INSERT INTO `access_log` VALUES (43366, '64.76.15614802199412807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.196.215.186', '2019-06-26 00:30:20', 2, 0, '', '2019-06-26 00:30:20');
INSERT INTO `access_log` VALUES (43367, '64.85.15614802200532837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.196.215.186', '2019-06-26 00:30:20', 2, 0, '', '2019-06-26 00:30:20');
INSERT INTO `access_log` VALUES (43368, '64.83.15614802240212815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.196.215.186', '2019-06-26 00:30:24', 1, 0, '', '2019-06-26 00:30:24');
INSERT INTO `access_log` VALUES (43369, '64.78.15614802241252825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.196.215.186', '2019-06-26 00:30:24', 1, 0, '', '2019-06-26 00:30:24');
INSERT INTO `access_log` VALUES (43370, '59.79.15615035572653089', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.209.107.196', '2019-06-26 06:59:17', 15, 2001001000, '服务端发生异常', '2019-06-26 06:59:17');
INSERT INTO `access_log` VALUES (43371, '59.73.15615035572633089', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.209.107.196', '2019-06-26 06:59:17', 22, 0, '', '2019-06-26 06:59:17');
INSERT INTO `access_log` VALUES (43372, '64.81.15615035629453131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.209.107.196', '2019-06-26 06:59:23', 11, 0, '', '2019-06-26 06:59:23');
INSERT INTO `access_log` VALUES (43373, '64.83.15615035631853127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.209.107.196', '2019-06-26 06:59:23', 2, 0, '', '2019-06-26 06:59:23');
INSERT INTO `access_log` VALUES (43374, '64.78.15615035644373137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.209.107.196', '2019-06-26 06:59:24', 2, 0, '', '2019-06-26 06:59:24');
INSERT INTO `access_log` VALUES (43375, '64.84.15615035650993127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.209.107.196', '2019-06-26 06:59:25', 1, 0, '', '2019-06-26 06:59:25');
INSERT INTO `access_log` VALUES (43376, '59.74.15615035661713083', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.209.107.196', '2019-06-26 06:59:26', 3, 0, '', '2019-06-26 06:59:26');
INSERT INTO `access_log` VALUES (43377, '59.71.15615035661753087', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.209.107.196', '2019-06-26 06:59:26', 33, 2001001000, '服务端发生异常', '2019-06-26 06:59:26');
INSERT INTO `access_log` VALUES (43378, '59.74.15615078828243141', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3573.0 Safari/537.36', '58.38.121.68', '2019-06-26 08:11:23', 11, 0, '', '2019-06-26 08:11:23');
INSERT INTO `access_log` VALUES (43379, '59.71.15615078828243145', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3573.0 Safari/537.36', '58.38.121.68', '2019-06-26 08:11:23', 21, 2001001000, '服务端发生异常', '2019-06-26 08:11:23');
INSERT INTO `access_log` VALUES (43380, '64.78.15615078864073195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3573.0 Safari/537.36', '58.38.121.68', '2019-06-26 08:11:26', 11, 0, '', '2019-06-26 08:11:26');
INSERT INTO `access_log` VALUES (43381, '64.84.15615078865093185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3573.0 Safari/537.36', '58.38.121.68', '2019-06-26 08:11:27', 3, 0, '', '2019-06-26 08:11:27');
INSERT INTO `access_log` VALUES (43382, '59.80.15615078901803131', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3573.0 Safari/537.36', '58.38.121.68', '2019-06-26 08:11:30', 3, 0, '', '2019-06-26 08:11:30');
INSERT INTO `access_log` VALUES (43383, '59.75.15615078901823147', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3573.0 Safari/537.36', '58.38.121.68', '2019-06-26 08:11:30', 13, 2001001000, '服务端发生异常', '2019-06-26 08:11:30');
INSERT INTO `access_log` VALUES (43384, '64.80.15615078951413193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3573.0 Safari/537.36', '58.38.121.68', '2019-06-26 08:11:35', 2, 0, '', '2019-06-26 08:11:35');
INSERT INTO `access_log` VALUES (43385, '64.82.15615078952513199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3573.0 Safari/537.36', '58.38.121.68', '2019-06-26 08:11:35', 2, 0, '', '2019-06-26 08:11:35');
INSERT INTO `access_log` VALUES (43386, '64.79.15615078991013201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3573.0 Safari/537.36', '58.38.121.68', '2019-06-26 08:11:39', 2, 0, '', '2019-06-26 08:11:39');
INSERT INTO `access_log` VALUES (43387, '64.76.15615078992033179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3573.0 Safari/537.36', '58.38.121.68', '2019-06-26 08:11:39', 2, 0, '', '2019-06-26 08:11:39');
INSERT INTO `access_log` VALUES (43388, '59.72.15615079002493141', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3573.0 Safari/537.36', '58.38.121.68', '2019-06-26 08:11:40', 2, 0, '', '2019-06-26 08:11:40');
INSERT INTO `access_log` VALUES (43389, '59.77.15615079002493129', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3573.0 Safari/537.36', '58.38.121.68', '2019-06-26 08:11:40', 12, 2001001000, '服务端发生异常', '2019-06-26 08:11:40');
INSERT INTO `access_log` VALUES (43390, '65.52.15615088652384291', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.205.129.3', '2019-06-26 08:27:45', 4, 1002001012, '访问令牌已过期', '2019-06-26 08:27:45');
INSERT INTO `access_log` VALUES (43391, '65.47.15615088652384251', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.205.129.3', '2019-06-26 08:27:45', 5, 1002001012, '访问令牌已过期', '2019-06-26 08:27:45');
INSERT INTO `access_log` VALUES (43392, '65.54.15615088652434227', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.205.129.3', '2019-06-26 08:27:45', 12, 1002001012, '访问令牌已过期', '2019-06-26 08:27:45');
INSERT INTO `access_log` VALUES (43393, '65.53.15615088709724279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.205.129.3', '2019-06-26 08:27:51', 105, 0, '', '2019-06-26 08:27:51');
INSERT INTO `access_log` VALUES (43394, '65.45.15615088713554273', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.205.129.3', '2019-06-26 08:27:51', 11, 0, '', '2019-06-26 08:27:51');
INSERT INTO `access_log` VALUES (43395, '65.49.15615088713564287', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.205.129.3', '2019-06-26 08:27:51', 12, 2001001000, '服务端发生异常', '2019-06-26 08:27:51');
INSERT INTO `access_log` VALUES (43396, '65.50.15615088713594295', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '115.205.129.3', '2019-06-26 08:27:51', 11, 0, '', '2019-06-26 08:27:51');
INSERT INTO `access_log` VALUES (43397, '65.52.15615116255644329', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0.1; Nexus 5X Build/MMB29P) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2272.96 Mobile Safari/537.36 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', '203.208.60.82', '2019-06-26 09:13:46', 1, 1002001015, '账号未登陆', '2019-06-26 09:13:46');
INSERT INTO `access_log` VALUES (43398, '65.47.15615116260724289', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0.1; Nexus 5X Build/MMB29P) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2272.96 Mobile Safari/537.36 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', '203.208.60.65', '2019-06-26 09:13:46', 0, 1002001015, '账号未登陆', '2019-06-26 09:13:46');
INSERT INTO `access_log` VALUES (43399, '65.53.15615116278594317', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0.1; Nexus 5X Build/MMB29P) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/41.0.2272.96 Mobile Safari/537.36 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', '203.208.60.54', '2019-06-26 09:13:48', 0, 1002001015, '账号未登陆', '2019-06-26 09:13:48');
INSERT INTO `access_log` VALUES (43400, '59.79.15615116369483199', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.62.144.149', '2019-06-26 09:13:57', 18, 0, '', '2019-06-26 09:13:57');
INSERT INTO `access_log` VALUES (43401, '59.72.15615116369483191', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.62.144.149', '2019-06-26 09:13:57', 20, 2001001000, '服务端发生异常', '2019-06-26 09:13:57');
INSERT INTO `access_log` VALUES (43402, '65.47.15615121835804297', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.222.242.90', '2019-06-26 09:23:04', 0, 1002001015, '账号未登陆', '2019-06-26 09:23:04');
INSERT INTO `access_log` VALUES (43403, '65.52.15615121835794337', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.222.242.90', '2019-06-26 09:23:04', 1, 1002001015, '账号未登陆', '2019-06-26 09:23:04');
INSERT INTO `access_log` VALUES (43404, '65.53.15615121835964325', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.222.242.90', '2019-06-26 09:23:04', 0, 1002001015, '账号未登陆', '2019-06-26 09:23:04');
INSERT INTO `access_log` VALUES (43405, '65.45.15615121875564319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.222.242.90', '2019-06-26 09:23:08', 90, 0, '', '2019-06-26 09:23:08');
INSERT INTO `access_log` VALUES (43406, '65.49.15615121878954333', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.222.242.90', '2019-06-26 09:23:08', 13, 0, '', '2019-06-26 09:23:08');
INSERT INTO `access_log` VALUES (43407, '65.3607.15615121878976105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.222.242.90', '2019-06-26 09:23:08', 11, 0, '', '2019-06-26 09:23:08');
INSERT INTO `access_log` VALUES (43408, '65.50.15615121878944341', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.222.242.90', '2019-06-26 09:23:08', 15, 2001001000, '服务端发生异常', '2019-06-26 09:23:08');
INSERT INTO `access_log` VALUES (43409, '65.46.15615121943254383', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.222.242.90', '2019-06-26 09:23:14', 10, 0, '', '2019-06-26 09:23:14');
INSERT INTO `access_log` VALUES (43410, '65.53.15615121943284327', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.222.242.90', '2019-06-26 09:23:14', 8, 0, '', '2019-06-26 09:23:14');
INSERT INTO `access_log` VALUES (43411, '65.54.15615121943254275', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.222.242.90', '2019-06-26 09:23:14', 11, 2001001000, '服务端发生异常', '2019-06-26 09:23:14');
INSERT INTO `access_log` VALUES (43412, '65.52.15615122007384339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.222.242.90', '2019-06-26 09:23:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 09:23:21');
INSERT INTO `access_log` VALUES (43413, '65.47.15615122038344299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.222.242.90', '2019-06-26 09:23:24', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 09:23:24');
INSERT INTO `access_log` VALUES (43414, '59.72.15615129477213209', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:35:48', 4, 0, '', '2019-06-26 09:35:48');
INSERT INTO `access_log` VALUES (43415, '59.77.15615129477203197', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:35:48', 20, 2001001000, '服务端发生异常', '2019-06-26 09:35:48');
INSERT INTO `access_log` VALUES (43416, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=热门&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:35:56', 7, 0, '', '2019-06-26 09:35:56');
INSERT INTO `access_log` VALUES (43417, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=热门', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:35:56', 6, 0, '', '2019-06-26 09:35:56');
INSERT INTO `access_log` VALUES (43418, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=热门&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:35:59', 6, 0, '', '2019-06-26 09:35:59');
INSERT INTO `access_log` VALUES (43419, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=热门', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:35:59', 6, 0, '', '2019-06-26 09:35:59');
INSERT INTO `access_log` VALUES (43420, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=热门&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:00', 6, 0, '', '2019-06-26 09:36:00');
INSERT INTO `access_log` VALUES (43421, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=热门', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:00', 5, 0, '', '2019-06-26 09:36:00');
INSERT INTO `access_log` VALUES (43422, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=热门&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:00', 6, 0, '', '2019-06-26 09:36:00');
INSERT INTO `access_log` VALUES (43423, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=热门', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:00', 7, 0, '', '2019-06-26 09:36:00');
INSERT INTO `access_log` VALUES (43424, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=热门&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:01', 5, 0, '', '2019-06-26 09:36:01');
INSERT INTO `access_log` VALUES (43425, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=热门', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:01', 6, 0, '', '2019-06-26 09:36:01');
INSERT INTO `access_log` VALUES (43426, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=热门&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:01', 6, 0, '', '2019-06-26 09:36:01');
INSERT INTO `access_log` VALUES (43427, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=热门', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:01', 7, 0, '', '2019-06-26 09:36:01');
INSERT INTO `access_log` VALUES (43428, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=热门&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:01', 5, 0, '', '2019-06-26 09:36:01');
INSERT INTO `access_log` VALUES (43429, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=热门&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:01', 6, 0, '', '2019-06-26 09:36:01');
INSERT INTO `access_log` VALUES (43430, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=热门', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:01', 5, 0, '', '2019-06-26 09:36:01');
INSERT INTO `access_log` VALUES (43431, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=热门', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:01', 13, 0, '', '2019-06-26 09:36:01');
INSERT INTO `access_log` VALUES (43432, '59.73.15615129624713217', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:02', 2, 0, '', '2019-06-26 09:36:02');
INSERT INTO `access_log` VALUES (43433, '59.76.15615129624723207', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:02', 12, 2001001000, '服务端发生异常', '2019-06-26 09:36:02');
INSERT INTO `access_log` VALUES (43434, '64.79.15615129656193269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:06', 10, 0, '', '2019-06-26 09:36:06');
INSERT INTO `access_log` VALUES (43435, '64.76.15615129657483247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:06', 3, 0, '', '2019-06-26 09:36:06');
INSERT INTO `access_log` VALUES (43436, '64.85.15615129675713277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:08', 2, 0, '', '2019-06-26 09:36:08');
INSERT INTO `access_log` VALUES (43437, '64.81.15615129682073259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:08', 2, 0, '', '2019-06-26 09:36:08');
INSERT INTO `access_log` VALUES (43438, '59.74.15615129722353211', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:12', 2, 0, '', '2019-06-26 09:36:12');
INSERT INTO `access_log` VALUES (43439, '59.80.15615129722353201', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:12', 11, 2001001000, '服务端发生异常', '2019-06-26 09:36:12');
INSERT INTO `access_log` VALUES (43440, '65.3607.15615129873716117', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:27', 1, 1002001015, '账号未登陆', '2019-06-26 09:36:27');
INSERT INTO `access_log` VALUES (43441, '65.51.15615129873744377', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:27', 0, 1002001015, '账号未登陆', '2019-06-26 09:36:27');
INSERT INTO `access_log` VALUES (43442, '65.54.15615129873744287', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:27', 0, 1002001015, '账号未登陆', '2019-06-26 09:36:27');
INSERT INTO `access_log` VALUES (43443, '65.53.15615129917184339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 09:36:32');
INSERT INTO `access_log` VALUES (43444, '65.46.15615129956164395', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 09:36:36');
INSERT INTO `access_log` VALUES (43445, '65.52.15615129967724351', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 09:36:37');
INSERT INTO `access_log` VALUES (43446, '65.45.15615130065244333', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:47', 193, 0, '', '2019-06-26 09:36:47');
INSERT INTO `access_log` VALUES (43447, '65.50.15615130073484355', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:47', 9, 0, '', '2019-06-26 09:36:47');
INSERT INTO `access_log` VALUES (43448, '65.49.15615130073584347', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:47', 8, 2001001000, '服务端发生异常', '2019-06-26 09:36:47');
INSERT INTO `access_log` VALUES (43449, '65.51.15615130073714379', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:47', 8, 0, '', '2019-06-26 09:36:47');
INSERT INTO `access_log` VALUES (43450, '65.3607.15615130149806119', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:55', 9, 0, '', '2019-06-26 09:36:55');
INSERT INTO `access_log` VALUES (43451, '65.53.15615130150014341', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:55', 11, 2001001000, '服务端发生异常', '2019-06-26 09:36:55');
INSERT INTO `access_log` VALUES (43452, '65.46.15615130150114397', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:36:55', 8, 0, '', '2019-06-26 09:36:55');
INSERT INTO `access_log` VALUES (43453, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=商品', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:43:47', 12, 0, '', '2019-06-26 09:43:47');
INSERT INTO `access_log` VALUES (43454, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=电脑', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:44:19', 12, 0, '', '2019-06-26 09:44:19');
INSERT INTO `access_log` VALUES (43455, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=手机', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:44:23', 11, 0, '', '2019-06-26 09:44:23');
INSERT INTO `access_log` VALUES (43456, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=钱包', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:44:27', 6, 0, '', '2019-06-26 09:44:27');
INSERT INTO `access_log` VALUES (43457, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=apple', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:44:32', 6, 0, '', '2019-06-26 09:44:32');
INSERT INTO `access_log` VALUES (43458, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=iphone', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '119.18.198.135', '2019-06-26 09:44:37', 6, 0, '', '2019-06-26 09:44:37');
INSERT INTO `access_log` VALUES (43459, '65.53.15615139722434355', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.107.137.62', '2019-06-26 09:52:52', 4, 1002001012, '访问令牌已过期', '2019-06-26 09:52:52');
INSERT INTO `access_log` VALUES (43460, '65.3607.15615139722426133', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.107.137.62', '2019-06-26 09:52:52', 5, 1002001012, '访问令牌已过期', '2019-06-26 09:52:52');
INSERT INTO `access_log` VALUES (43461, '65.46.15615139722464411', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.107.137.62', '2019-06-26 09:52:52', 3, 1002001012, '访问令牌已过期', '2019-06-26 09:52:52');
INSERT INTO `access_log` VALUES (43462, '65.47.15615139753074327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.107.137.62', '2019-06-26 09:52:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 09:52:55');
INSERT INTO `access_log` VALUES (43463, '65.45.15615139842324349', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.107.137.62', '2019-06-26 09:53:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 09:53:04');
INSERT INTO `access_log` VALUES (43464, '65.54.15615141822374307', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.96.109.185', '2019-06-26 09:56:22', 0, 1002001015, '账号未登陆', '2019-06-26 09:56:22');
INSERT INTO `access_log` VALUES (43465, '65.46.15615141822384415', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.96.109.185', '2019-06-26 09:56:22', 0, 1002001015, '账号未登陆', '2019-06-26 09:56:22');
INSERT INTO `access_log` VALUES (43466, '65.53.15615141822394359', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.96.109.185', '2019-06-26 09:56:22', 0, 1002001015, '账号未登陆', '2019-06-26 09:56:22');
INSERT INTO `access_log` VALUES (43467, '65.52.15615141857874371', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.96.109.185', '2019-06-26 09:56:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 09:56:26');
INSERT INTO `access_log` VALUES (43468, '65.47.15615141898264331', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.96.109.185', '2019-06-26 09:56:30', 153, 0, '', '2019-06-26 09:56:30');
INSERT INTO `access_log` VALUES (43469, '65.45.15615141958544353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.96.109.185', '2019-06-26 09:56:36', 84, 0, '', '2019-06-26 09:56:36');
INSERT INTO `access_log` VALUES (43470, '65.49.15615142058234367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.96.109.185', '2019-06-26 09:56:46', 92, 0, '', '2019-06-26 09:56:46');
INSERT INTO `access_log` VALUES (43471, '65.53.15615142157274361', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.96.109.185', '2019-06-26 09:56:56', 64, 0, '', '2019-06-26 09:56:56');
INSERT INTO `access_log` VALUES (43472, '59.75.15615147725783241', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.39.89', '2019-06-26 10:06:13', 4, 0, '', '2019-06-26 10:06:13');
INSERT INTO `access_log` VALUES (43473, '59.78.15615147725803233', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.39.89', '2019-06-26 10:06:13', 150, 2001001000, '服务端发生异常', '2019-06-26 10:06:13');
INSERT INTO `access_log` VALUES (43474, '59.79.15615147792103243', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.39.89', '2019-06-26 10:06:19', 3, 0, '', '2019-06-26 10:06:19');
INSERT INTO `access_log` VALUES (43475, '59.77.15615147792073223', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.39.89', '2019-06-26 10:06:19', 12, 2001001000, '服务端发生异常', '2019-06-26 10:06:19');
INSERT INTO `access_log` VALUES (43476, '65.53.15615147919444369', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.39.89', '2019-06-26 10:06:32', 0, 1002001015, '账号未登陆', '2019-06-26 10:06:32');
INSERT INTO `access_log` VALUES (43477, '65.51.15615147919434407', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.39.89', '2019-06-26 10:06:32', 0, 1002001015, '账号未登陆', '2019-06-26 10:06:32');
INSERT INTO `access_log` VALUES (43478, '65.46.15615147919444425', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.39.89', '2019-06-26 10:06:32', 1, 1002001015, '账号未登陆', '2019-06-26 10:06:32');
INSERT INTO `access_log` VALUES (43479, '65.54.15615147944704317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.39.89', '2019-06-26 10:06:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 10:06:34');
INSERT INTO `access_log` VALUES (43480, '65.45.15615157411384375', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 10:22:21', 1, 1002001015, '账号未登陆', '2019-06-26 10:22:21');
INSERT INTO `access_log` VALUES (43481, '65.52.15615157411424393', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 10:22:21', 0, 1002001015, '账号未登陆', '2019-06-26 10:22:21');
INSERT INTO `access_log` VALUES (43482, '65.47.15615157411574355', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 10:22:21', 0, 1002001015, '账号未登陆', '2019-06-26 10:22:21');
INSERT INTO `access_log` VALUES (43483, '65.49.15615157479154391', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 10:22:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 10:22:28');
INSERT INTO `access_log` VALUES (43484, '65.53.15615157692294383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 10:22:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 10:22:49');
INSERT INTO `access_log` VALUES (43485, '59.79.15615157720133257', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.212.226', '2019-06-26 10:22:52', 3, 0, '', '2019-06-26 10:22:52');
INSERT INTO `access_log` VALUES (43486, '59.73.15615157720133257', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.129.212.226', '2019-06-26 10:22:52', 14, 2001001000, '服务端发生异常', '2019-06-26 10:22:52');
INSERT INTO `access_log` VALUES (43487, '65.51.15615157991774423', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-26 10:23:19', 4, 1002001012, '访问令牌已过期', '2019-06-26 10:23:19');
INSERT INTO `access_log` VALUES (43488, '65.52.15615157991894395', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-26 10:23:19', 3, 1002001012, '访问令牌已过期', '2019-06-26 10:23:19');
INSERT INTO `access_log` VALUES (43489, '65.45.15615157992054377', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-26 10:23:19', 3, 1002001012, '访问令牌已过期', '2019-06-26 10:23:19');
INSERT INTO `access_log` VALUES (43490, '65.50.15615158094494403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-26 10:23:29', 51, 0, '', '2019-06-26 10:23:30');
INSERT INTO `access_log` VALUES (43491, '65.49.15615158097634393', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-26 10:23:30', 10, 0, '', '2019-06-26 10:23:30');
INSERT INTO `access_log` VALUES (43492, '65.46.15615158097724443', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-26 10:23:30', 10, 2001001000, '服务端发生异常', '2019-06-26 10:23:30');
INSERT INTO `access_log` VALUES (43493, '65.53.15615158097774385', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.88.210', '2019-06-26 10:23:30', 8, 0, '', '2019-06-26 10:23:30');
INSERT INTO `access_log` VALUES (43494, '65.54.15615158175744333', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 10:23:38', 62, 0, '', '2019-06-26 10:23:38');
INSERT INTO `access_log` VALUES (43495, '65.3607.15615158180746161', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 10:23:38', 9, 0, '', '2019-06-26 10:23:38');
INSERT INTO `access_log` VALUES (43496, '65.52.15615158180824397', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 10:23:38', 11, 2001001000, '服务端发生异常', '2019-06-26 10:23:38');
INSERT INTO `access_log` VALUES (43497, '65.51.15615158181414425', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 10:23:38', 9, 0, '', '2019-06-26 10:23:38');
INSERT INTO `access_log` VALUES (43498, '65.54.15615159021434335', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.192.3.232', '2019-06-26 10:25:02', 1, 1002001015, '账号未登陆', '2019-06-26 10:25:02');
INSERT INTO `access_log` VALUES (43499, '65.3607.15615159021486163', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.192.3.232', '2019-06-26 10:25:02', 1, 1002001015, '账号未登陆', '2019-06-26 10:25:02');
INSERT INTO `access_log` VALUES (43500, '65.52.15615159021714399', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.192.3.232', '2019-06-26 10:25:02', 1, 1002001015, '账号未登陆', '2019-06-26 10:25:02');
INSERT INTO `access_log` VALUES (43501, '65.51.15615159060244427', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.192.3.232', '2019-06-26 10:25:06', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 10:25:06');
INSERT INTO `access_log` VALUES (43502, '65.45.15615159084734381', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.192.3.232', '2019-06-26 10:25:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 10:25:08');
INSERT INTO `access_log` VALUES (43503, '65.50.15615159154154407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.192.3.232', '2019-06-26 10:25:15', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 10:25:15');
INSERT INTO `access_log` VALUES (43504, '65.47.15615166059344373', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '223.166.151.197', '2019-06-26 10:36:46', 0, 1002001015, '账号未登陆', '2019-06-26 10:36:46');
INSERT INTO `access_log` VALUES (43505, '65.53.15615166322134399', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '58.246.221.162', '2019-06-26 10:37:12', 1, 1002001015, '账号未登陆', '2019-06-26 10:37:12');
INSERT INTO `access_log` VALUES (43506, '59.75.15615174865613279', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '218.26.104.163', '2019-06-26 10:51:27', 3, 0, '', '2019-06-26 10:51:27');
INSERT INTO `access_log` VALUES (43507, '59.78.15615174867333271', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '218.26.104.163', '2019-06-26 10:51:27', 29, 2001001000, '服务端发生异常', '2019-06-26 10:51:27');
INSERT INTO `access_log` VALUES (43508, '64.84.15615176544603317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '218.26.104.163', '2019-06-26 10:54:14', 11, 0, '', '2019-06-26 10:54:14');
INSERT INTO `access_log` VALUES (43509, '64.80.15615176556503325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '218.26.104.163', '2019-06-26 10:54:16', 3, 0, '', '2019-06-26 10:54:16');
INSERT INTO `access_log` VALUES (43510, '64.82.15615176578713331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '218.26.104.163', '2019-06-26 10:54:18', 2, 0, '', '2019-06-26 10:54:18');
INSERT INTO `access_log` VALUES (43511, '64.77.15615176591163319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '218.26.104.163', '2019-06-26 10:54:19', 2, 0, '', '2019-06-26 10:54:19');
INSERT INTO `access_log` VALUES (43512, '59.73.15615176769863283', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '218.26.104.163', '2019-06-26 10:54:37', 3, 0, '', '2019-06-26 10:54:37');
INSERT INTO `access_log` VALUES (43513, '59.76.15615176769873271', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '218.26.104.163', '2019-06-26 10:54:37', 13, 2001001000, '服务端发生异常', '2019-06-26 10:54:37');
INSERT INTO `access_log` VALUES (43514, '65.54.15615176874514363', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '220.195.67.53', '2019-06-26 10:54:47', 3, 1002001012, '访问令牌已过期', '2019-06-26 10:54:47');
INSERT INTO `access_log` VALUES (43515, '65.51.15615176874514451', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '220.195.67.53', '2019-06-26 10:54:47', 4, 1002001012, '访问令牌已过期', '2019-06-26 10:54:47');
INSERT INTO `access_log` VALUES (43516, '65.47.15615176874664389', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '220.195.67.53', '2019-06-26 10:54:47', 3, 1002001012, '访问令牌已过期', '2019-06-26 10:54:47');
INSERT INTO `access_log` VALUES (43517, '65.49.15615176954724425', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '220.195.67.53', '2019-06-26 10:54:55', 88, 0, '', '2019-06-26 10:54:56');
INSERT INTO `access_log` VALUES (43518, '65.53.15615176960714415', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '220.195.67.53', '2019-06-26 10:54:56', 10, 0, '', '2019-06-26 10:54:56');
INSERT INTO `access_log` VALUES (43519, '65.3607.15615176960806193', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '220.195.67.53', '2019-06-26 10:54:56', 9, 0, '', '2019-06-26 10:54:56');
INSERT INTO `access_log` VALUES (43520, '65.46.15615176960804471', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '220.195.67.53', '2019-06-26 10:54:56', 10, 2001001000, '服务端发生异常', '2019-06-26 10:54:56');
INSERT INTO `access_log` VALUES (43521, '65.3607.15615181142336199', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.88.195.125', '2019-06-26 11:01:54', 1, 1002001015, '账号未登陆', '2019-06-26 11:01:54');
INSERT INTO `access_log` VALUES (43522, '65.45.15615181142334415', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.88.195.125', '2019-06-26 11:01:54', 0, 1002001015, '账号未登陆', '2019-06-26 11:01:54');
INSERT INTO `access_log` VALUES (43523, '65.46.15615181142334477', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.88.195.125', '2019-06-26 11:01:54', 1, 1002001015, '账号未登陆', '2019-06-26 11:01:54');
INSERT INTO `access_log` VALUES (43524, '65.52.15615181163234433', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.88.195.125', '2019-06-26 11:01:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 11:01:56');
INSERT INTO `access_log` VALUES (43525, '65.51.15615181239224459', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.88.195.125', '2019-06-26 11:02:04', 65, 0, '', '2019-06-26 11:02:04');
INSERT INTO `access_log` VALUES (43526, '65.54.15615181242504371', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.88.195.125', '2019-06-26 11:02:04', 8, 0, '', '2019-06-26 11:02:04');
INSERT INTO `access_log` VALUES (43527, '65.47.15615181242594397', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.88.195.125', '2019-06-26 11:02:04', 8, 2001001000, '服务端发生异常', '2019-06-26 11:02:04');
INSERT INTO `access_log` VALUES (43528, '65.50.15615181242604439', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.88.195.125', '2019-06-26 11:02:04', 8, 0, '', '2019-06-26 11:02:04');
INSERT INTO `access_log` VALUES (43529, '65.53.15615181353454423', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.88.195.125', '2019-06-26 11:02:15', 9, 0, '', '2019-06-26 11:02:15');
INSERT INTO `access_log` VALUES (43530, '65.46.15615181353654479', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.88.195.125', '2019-06-26 11:02:15', 8, 0, '', '2019-06-26 11:02:15');
INSERT INTO `access_log` VALUES (43531, '65.3607.15615181353636201', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.88.195.125', '2019-06-26 11:02:15', 9, 2001001000, '服务端发生异常', '2019-06-26 11:02:15');
INSERT INTO `access_log` VALUES (43532, '65.47.15615182101544399', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.88.195.125', '2019-06-26 11:03:30', 10, 0, '', '2019-06-26 11:03:30');
INSERT INTO `access_log` VALUES (43533, '65.49.15615182101554435', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.88.195.125', '2019-06-26 11:03:30', 12, 0, '', '2019-06-26 11:03:30');
INSERT INTO `access_log` VALUES (43534, '65.53.15615182101574425', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.88.195.125', '2019-06-26 11:03:30', 9, 2001001000, '服务端发生异常', '2019-06-26 11:03:30');
INSERT INTO `access_log` VALUES (43535, '65.46.15615182220354481', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.88.195.125', '2019-06-26 11:03:42', 0, 1002001015, '账号未登陆', '2019-06-26 11:03:42');
INSERT INTO `access_log` VALUES (43536, '65.45.15615182220474419', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.88.195.125', '2019-06-26 11:03:42', 0, 1002001015, '账号未登陆', '2019-06-26 11:03:42');
INSERT INTO `access_log` VALUES (43537, '65.52.15615182220474437', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.88.195.125', '2019-06-26 11:03:42', 1, 1002001015, '账号未登陆', '2019-06-26 11:03:42');
INSERT INTO `access_log` VALUES (43538, '65.51.15615182241904463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.88.195.125', '2019-06-26 11:03:44', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 11:03:44');
INSERT INTO `access_log` VALUES (43539, '65.50.15615182456864443', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.88.195.125', '2019-06-26 11:04:06', 83, 0, '', '2019-06-26 11:04:06');
INSERT INTO `access_log` VALUES (43540, '65.53.15615182461874427', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.88.195.125', '2019-06-26 11:04:06', 9, 0, '', '2019-06-26 11:04:06');
INSERT INTO `access_log` VALUES (43541, '65.49.15615182461994437', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.88.195.125', '2019-06-26 11:04:06', 9, 2001001000, '服务端发生异常', '2019-06-26 11:04:06');
INSERT INTO `access_log` VALUES (43542, '65.47.15615182462444401', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.88.195.125', '2019-06-26 11:04:06', 9, 0, '', '2019-06-26 11:04:06');
INSERT INTO `access_log` VALUES (43543, '59.71.15615182746623287', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.88.80.73', '2019-06-26 11:04:35', 3, 0, '', '2019-06-26 11:04:35');
INSERT INTO `access_log` VALUES (43544, '59.74.15615182746623285', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.88.80.73', '2019-06-26 11:04:35', 12, 2001001000, '服务端发生异常', '2019-06-26 11:04:35');
INSERT INTO `access_log` VALUES (43545, '65.51.15615184371074467', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.118.132', '2019-06-26 11:07:17', 1, 1002001015, '账号未登陆', '2019-06-26 11:07:17');
INSERT INTO `access_log` VALUES (43546, '65.45.15615184371064423', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.118.132', '2019-06-26 11:07:17', 0, 1002001015, '账号未登陆', '2019-06-26 11:07:17');
INSERT INTO `access_log` VALUES (43547, '65.54.15615184371084379', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.118.132', '2019-06-26 11:07:17', 1, 1002001015, '账号未登陆', '2019-06-26 11:07:17');
INSERT INTO `access_log` VALUES (43548, '65.53.15615184467284431', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.118.132', '2019-06-26 11:07:27', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 11:07:27');
INSERT INTO `access_log` VALUES (43549, '65.49.15615184578444441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.118.132', '2019-06-26 11:07:38', 161, 0, '', '2019-06-26 11:07:38');
INSERT INTO `access_log` VALUES (43550, '65.47.15615184586944405', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.118.132', '2019-06-26 11:07:39', 18, 0, '', '2019-06-26 11:07:39');
INSERT INTO `access_log` VALUES (43551, '65.3607.15615184586986209', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.118.132', '2019-06-26 11:07:39', 17, 2001001000, '服务端发生异常', '2019-06-26 11:07:39');
INSERT INTO `access_log` VALUES (43552, '65.46.15615184587154487', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.118.132', '2019-06-26 11:07:39', 8, 0, '', '2019-06-26 11:07:39');
INSERT INTO `access_log` VALUES (43553, '65.45.15615184798744425', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.118.132', '2019-06-26 11:08:00', 9, 0, '', '2019-06-26 11:08:00');
INSERT INTO `access_log` VALUES (43554, '65.54.15615184798774381', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.118.132', '2019-06-26 11:08:00', 10, 2001001000, '服务端发生异常', '2019-06-26 11:08:00');
INSERT INTO `access_log` VALUES (43555, '65.50.15615184798804449', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.110.118.132', '2019-06-26 11:08:00', 9, 0, '', '2019-06-26 11:08:00');
INSERT INTO `access_log` VALUES (43556, '65.46.15615189451714495', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.45.103', '2019-06-26 11:15:45', 1, 1002001015, '账号未登陆', '2019-06-26 11:15:45');
INSERT INTO `access_log` VALUES (43557, '65.49.15615189451714449', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.45.103', '2019-06-26 11:15:45', 1, 1002001015, '账号未登陆', '2019-06-26 11:15:45');
INSERT INTO `access_log` VALUES (43558, '65.47.15615189451724413', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.45.103', '2019-06-26 11:15:45', 0, 1002001015, '账号未登陆', '2019-06-26 11:15:45');
INSERT INTO `access_log` VALUES (43559, '65.52.15615189560354451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.45.103', '2019-06-26 11:15:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 11:15:56');
INSERT INTO `access_log` VALUES (43560, '65.45.15615189712334433', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.45.103', '2019-06-26 11:16:11', 108, 0, '', '2019-06-26 11:16:11');
INSERT INTO `access_log` VALUES (43561, '65.50.15615189717574457', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.45.103', '2019-06-26 11:16:12', 11, 0, '', '2019-06-26 11:16:12');
INSERT INTO `access_log` VALUES (43562, '65.53.15615189717604441', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.45.103', '2019-06-26 11:16:12', 8, 0, '', '2019-06-26 11:16:12');
INSERT INTO `access_log` VALUES (43563, '65.54.15615189717574389', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.45.103', '2019-06-26 11:16:12', 11, 2001001000, '服务端发生异常', '2019-06-26 11:16:12');
INSERT INTO `access_log` VALUES (43564, '65.51.15615219018134517', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.38.144', '2019-06-26 12:05:02', 1, 1002001015, '账号未登陆', '2019-06-26 12:05:02');
INSERT INTO `access_log` VALUES (43565, '65.45.15615219018134473', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.38.144', '2019-06-26 12:05:02', 0, 1002001015, '账号未登陆', '2019-06-26 12:05:02');
INSERT INTO `access_log` VALUES (43566, '65.50.15615219018314497', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.38.144', '2019-06-26 12:05:02', 0, 1002001015, '账号未登陆', '2019-06-26 12:05:02');
INSERT INTO `access_log` VALUES (43567, '65.46.15615219248414537', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.38.144', '2019-06-26 12:05:25', 70, 0, '', '2019-06-26 12:05:25');
INSERT INTO `access_log` VALUES (43568, '65.49.15615219255704491', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.38.144', '2019-06-26 12:05:26', 9, 0, '', '2019-06-26 12:05:26');
INSERT INTO `access_log` VALUES (43569, '65.47.15615219255744455', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.38.144', '2019-06-26 12:05:26', 8, 2001001000, '服务端发生异常', '2019-06-26 12:05:26');
INSERT INTO `access_log` VALUES (43570, '65.3607.15615219255756259', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.38.144', '2019-06-26 12:05:26', 7, 0, '', '2019-06-26 12:05:26');
INSERT INTO `access_log` VALUES (43571, '59.80.15615224883373331', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '117.136.38.144', '2019-06-26 12:14:48', 12, 2001001000, '服务端发生异常', '2019-06-26 12:14:48');
INSERT INTO `access_log` VALUES (43572, '59.75.15615224886123347', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '117.136.38.144', '2019-06-26 12:14:49', 28, 0, '', '2019-06-26 12:14:49');
INSERT INTO `access_log` VALUES (43573, '59.72.15615224971373341', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '117.136.38.144', '2019-06-26 12:14:57', 6, 0, '', '2019-06-26 12:14:57');
INSERT INTO `access_log` VALUES (43574, '59.77.15615224971433329', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '117.136.38.144', '2019-06-26 12:14:57', 12, 2001001000, '服务端发生异常', '2019-06-26 12:14:57');
INSERT INTO `access_log` VALUES (43575, '65.47.15615225146994463', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '117.136.38.144', '2019-06-26 12:15:15', 0, 1002001015, '账号未登陆', '2019-06-26 12:15:15');
INSERT INTO `access_log` VALUES (43576, '65.52.15615225146994501', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '117.136.38.144', '2019-06-26 12:15:15', 0, 1002001015, '账号未登陆', '2019-06-26 12:15:15');
INSERT INTO `access_log` VALUES (43577, '65.51.15615225147024527', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '117.136.38.144', '2019-06-26 12:15:15', 1, 1002001015, '账号未登陆', '2019-06-26 12:15:15');
INSERT INTO `access_log` VALUES (43578, '65.50.15615226744834509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '117.136.38.144', '2019-06-26 12:17:54', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 12:17:54');
INSERT INTO `access_log` VALUES (43579, '65.54.15615226933574441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '117.136.38.144', '2019-06-26 12:18:13', 84, 0, '', '2019-06-26 12:18:13');
INSERT INTO `access_log` VALUES (43580, '65.49.15615226939134503', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '117.136.38.144', '2019-06-26 12:18:14', 12, 0, '', '2019-06-26 12:18:14');
INSERT INTO `access_log` VALUES (43581, '65.46.15615226939104549', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '117.136.38.144', '2019-06-26 12:18:14', 14, 0, '', '2019-06-26 12:18:14');
INSERT INTO `access_log` VALUES (43582, '65.3607.15615226939136271', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '117.136.38.144', '2019-06-26 12:18:14', 13, 2001001000, '服务端发生异常', '2019-06-26 12:18:14');
INSERT INTO `access_log` VALUES (43583, '59.72.15615229387693347', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.110.140.85', '2019-06-26 12:22:19', 3, 0, '', '2019-06-26 12:22:19');
INSERT INTO `access_log` VALUES (43584, '59.79.15615229387703355', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.110.140.85', '2019-06-26 12:22:19', 12, 2001001000, '服务端发生异常', '2019-06-26 12:22:19');
INSERT INTO `access_log` VALUES (43585, '64.77.15615233405553395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.110.140.85', '2019-06-26 12:29:01', 11, 0, '', '2019-06-26 12:29:01');
INSERT INTO `access_log` VALUES (43586, '64.79.15615233406543409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.110.140.85', '2019-06-26 12:29:01', 5, 0, '', '2019-06-26 12:29:01');
INSERT INTO `access_log` VALUES (43587, '64.76.15615233419053387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.110.140.85', '2019-06-26 12:29:02', 3, 0, '', '2019-06-26 12:29:02');
INSERT INTO `access_log` VALUES (43588, '64.85.15615233427443417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.110.140.85', '2019-06-26 12:29:03', 1, 0, '', '2019-06-26 12:29:03');
INSERT INTO `access_log` VALUES (43589, '59.80.15615274731033399', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:37:53', 14, 0, '', '2019-06-26 13:37:53');
INSERT INTO `access_log` VALUES (43590, '59.74.15615274731023409', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:37:53', 16, 2001001000, '服务端发生异常', '2019-06-26 13:37:53');
INSERT INTO `access_log` VALUES (43591, '64.77.15615274816743451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:02', 15, 0, '', '2019-06-26 13:38:02');
INSERT INTO `access_log` VALUES (43592, '64.79.15615274817973465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:02', 2, 0, '', '2019-06-26 13:38:02');
INSERT INTO `access_log` VALUES (43593, '64.76.15615274831623443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:03', 1, 0, '', '2019-06-26 13:38:03');
INSERT INTO `access_log` VALUES (43594, '64.85.15615274836913473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:04', 2, 0, '', '2019-06-26 13:38:04');
INSERT INTO `access_log` VALUES (43595, '59.78.15615274846893407', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:05', 8, 0, '', '2019-06-26 13:38:05');
INSERT INTO `access_log` VALUES (43596, '59.77.15615274846993397', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:05', 13, 2001001000, '服务端发生异常', '2019-06-26 13:38:05');
INSERT INTO `access_log` VALUES (43597, '64.83.15615274873673451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:07', 2, 0, '', '2019-06-26 13:38:07');
INSERT INTO `access_log` VALUES (43598, '64.78.15615274874803461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:07', 2, 0, '', '2019-06-26 13:38:07');
INSERT INTO `access_log` VALUES (43599, '64.84.15615274892643451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:09', 1, 0, '', '2019-06-26 13:38:09');
INSERT INTO `access_log` VALUES (43600, '64.80.15615274896763459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:10', 1, 0, '', '2019-06-26 13:38:10');
INSERT INTO `access_log` VALUES (43601, '59.72.15615274909283409', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:11', 2, 0, '', '2019-06-26 13:38:11');
INSERT INTO `access_log` VALUES (43602, '59.79.15615274909303417', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:11', 12, 2001001000, '服务端发生异常', '2019-06-26 13:38:11');
INSERT INTO `access_log` VALUES (43603, '66.54.15615275046691641', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:25', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字\n手机验证码必须都是数字\n手机号不能为空\n手机验证码长度为 4-6 位', '2019-06-26 13:38:25');
INSERT INTO `access_log` VALUES (43604, '66.49.15615275193061637', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12121212121212&code=9099', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-06-26 13:38:39');
INSERT INTO `access_log` VALUES (43605, '66.50.15615275322211627', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17863860115&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:38:52', 252, 1001003000, '验证码不存在', '2019-06-26 13:38:52');
INSERT INTO `access_log` VALUES (43606, '66.57.15615278129601643', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17863860115&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:43:33', 8, 1001003000, '验证码不存在', '2019-06-26 13:43:33');
INSERT INTO `access_log` VALUES (43607, '66.50.15615278154651631', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17863860115', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:43:35', 83, 0, '', '2019-06-26 13:43:36');
INSERT INTO `access_log` VALUES (43608, '66.52.15615278396241643', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17863860115', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:44:00', 5, 1001003005, '短信发送过于频率', '2019-06-26 13:44:00');
INSERT INTO `access_log` VALUES (43609, '66.55.15615278418121633', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17863860115', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:44:02', 6, 1001003005, '短信发送过于频率', '2019-06-26 13:44:02');
INSERT INTO `access_log` VALUES (43610, '66.51.15615278431171655', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17863860115', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:44:03', 4, 1001003005, '短信发送过于频率', '2019-06-26 13:44:03');
INSERT INTO `access_log` VALUES (43611, '66.54.15615278447011647', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17863860115', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:44:05', 5, 1001003005, '短信发送过于频率', '2019-06-26 13:44:05');
INSERT INTO `access_log` VALUES (43612, '66.49.15615278467961643', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17863860115&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:44:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-06-26 13:44:07');
INSERT INTO `access_log` VALUES (43613, '65.54.15615278776094511', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:44:38', 1, 1002001015, '账号未登陆', '2019-06-26 13:44:38');
INSERT INTO `access_log` VALUES (43614, '65.53.15615278776094563', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:44:38', 1, 1002001015, '账号未登陆', '2019-06-26 13:44:38');
INSERT INTO `access_log` VALUES (43615, '65.3607.15615278776096341', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:44:38', 0, 1002001015, '账号未登陆', '2019-06-26 13:44:38');
INSERT INTO `access_log` VALUES (43616, '65.51.15615279225014601', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:45:23', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 13:45:23');
INSERT INTO `access_log` VALUES (43617, '65.45.15615279324504557', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:45:32', 93, 0, '', '2019-06-26 13:45:33');
INSERT INTO `access_log` VALUES (43618, '65.50.15615279333244581', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:45:33', 10, 0, '', '2019-06-26 13:45:33');
INSERT INTO `access_log` VALUES (43619, '65.53.15615279333334565', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:45:33', 9, 2001001000, '服务端发生异常', '2019-06-26 13:45:33');
INSERT INTO `access_log` VALUES (43620, '65.54.15615279333524513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.75 Safari/537.36', '106.120.198.2', '2019-06-26 13:45:33', 9, 0, '', '2019-06-26 13:45:33');
INSERT INTO `access_log` VALUES (43621, '65.45.15615282991914565', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.129.232.18', '2019-06-26 13:51:39', 1, 1002001015, '账号未登陆', '2019-06-26 13:51:39');
INSERT INTO `access_log` VALUES (43622, '65.47.15615282991944545', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.129.232.18', '2019-06-26 13:51:39', 0, 1002001015, '账号未登陆', '2019-06-26 13:51:39');
INSERT INTO `access_log` VALUES (43623, '65.53.15615282991994571', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.129.232.18', '2019-06-26 13:51:39', 0, 1002001015, '账号未登陆', '2019-06-26 13:51:39');
INSERT INTO `access_log` VALUES (43624, '65.49.15615283079844583', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.129.232.18', '2019-06-26 13:51:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 13:51:48');
INSERT INTO `access_log` VALUES (43625, '65.52.15615283175544583', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.129.232.18', '2019-06-26 13:51:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 13:51:58');
INSERT INTO `access_log` VALUES (43626, '65.45.15615283342574567', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.129.232.18', '2019-06-26 13:52:14', 81, 0, '', '2019-06-26 13:52:14');
INSERT INTO `access_log` VALUES (43627, '65.47.15615283346514547', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.129.232.18', '2019-06-26 13:52:15', 11, 0, '', '2019-06-26 13:52:15');
INSERT INTO `access_log` VALUES (43628, '65.53.15615283346544573', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.129.232.18', '2019-06-26 13:52:15', 11, 2001001000, '服务端发生异常', '2019-06-26 13:52:15');
INSERT INTO `access_log` VALUES (43629, '65.3607.15615283346566349', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.129.232.18', '2019-06-26 13:52:15', 10, 0, '', '2019-06-26 13:52:15');
INSERT INTO `access_log` VALUES (43630, '65.50.15615283411954591', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.240.1.17', '2019-06-26 13:52:21', 1, 1002001015, '账号未登陆', '2019-06-26 13:52:21');
INSERT INTO `access_log` VALUES (43631, '65.52.15615283411994585', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.240.1.17', '2019-06-26 13:52:21', 1, 1002001015, '账号未登陆', '2019-06-26 13:52:21');
INSERT INTO `access_log` VALUES (43632, '65.54.15615283412084519', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.240.1.17', '2019-06-26 13:52:21', 0, 1002001015, '账号未登陆', '2019-06-26 13:52:21');
INSERT INTO `access_log` VALUES (43633, '65.47.15615283510534549', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.129.232.18', '2019-06-26 13:52:31', 8, 0, '', '2019-06-26 13:52:31');
INSERT INTO `access_log` VALUES (43634, '65.49.15615283510614585', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.129.232.18', '2019-06-26 13:52:31', 8, 0, '', '2019-06-26 13:52:31');
INSERT INTO `access_log` VALUES (43635, '65.53.15615283510584575', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.129.232.18', '2019-06-26 13:52:31', 9, 2001001000, '服务端发生异常', '2019-06-26 13:52:31');
INSERT INTO `access_log` VALUES (43636, '65.52.15615283554984587', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.240.1.17', '2019-06-26 13:52:35', 60, 0, '', '2019-06-26 13:52:36');
INSERT INTO `access_log` VALUES (43637, '65.54.15615283558424521', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.240.1.17', '2019-06-26 13:52:36', 9, 0, '', '2019-06-26 13:52:36');
INSERT INTO `access_log` VALUES (43638, '65.46.15615283558424627', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.240.1.17', '2019-06-26 13:52:36', 9, 2001001000, '服务端发生异常', '2019-06-26 13:52:36');
INSERT INTO `access_log` VALUES (43639, '65.51.15615283558464611', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.240.1.17', '2019-06-26 13:52:36', 8, 0, '', '2019-06-26 13:52:36');
INSERT INTO `access_log` VALUES (43640, '65.3607.15615283649596351', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.240.1.17', '2019-06-26 13:52:45', 9, 0, '', '2019-06-26 13:52:45');
INSERT INTO `access_log` VALUES (43641, '65.53.15615283649634577', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.240.1.17', '2019-06-26 13:52:45', 10, 2001001000, '服务端发生异常', '2019-06-26 13:52:45');
INSERT INTO `access_log` VALUES (43642, '65.49.15615283649694587', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '222.240.1.17', '2019-06-26 13:52:45', 10, 0, '', '2019-06-26 13:52:45');
INSERT INTO `access_log` VALUES (43643, '59.80.15615306796303443', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.176.33.236', '2019-06-26 14:31:20', 11, 0, '', '2019-06-26 14:31:20');
INSERT INTO `access_log` VALUES (43644, '59.74.15615306796303453', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.176.33.236', '2019-06-26 14:31:20', 15, 2001001000, '服务端发生异常', '2019-06-26 14:31:20');
INSERT INTO `access_log` VALUES (43645, '64.76.15615306870203487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.176.33.236', '2019-06-26 14:31:27', 11, 0, '', '2019-06-26 14:31:27');
INSERT INTO `access_log` VALUES (43646, '64.85.15615306871613517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.176.33.236', '2019-06-26 14:31:27', 3, 0, '', '2019-06-26 14:31:27');
INSERT INTO `access_log` VALUES (43647, '64.81.15615306883533499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.176.33.236', '2019-06-26 14:31:28', 2, 0, '', '2019-06-26 14:31:28');
INSERT INTO `access_log` VALUES (43648, '64.83.15615306885433495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.176.33.236', '2019-06-26 14:31:29', 2, 0, '', '2019-06-26 14:31:29');
INSERT INTO `access_log` VALUES (43649, '64.78.15615306889063505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.176.33.236', '2019-06-26 14:31:29', 2, 0, '', '2019-06-26 14:31:29');
INSERT INTO `access_log` VALUES (43650, '59.78.15615313083843459', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3710.0 Safari/537.36', '36.110.118.74', '2019-06-26 14:41:48', 4, 0, '', '2019-06-26 14:41:48');
INSERT INTO `access_log` VALUES (43651, '59.77.15615313083873449', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3710.0 Safari/537.36', '36.110.118.74', '2019-06-26 14:41:48', 14, 2001001000, '服务端发生异常', '2019-06-26 14:41:48');
INSERT INTO `access_log` VALUES (43652, '64.82.15615313164303517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3710.0 Safari/537.36', '36.110.118.74', '2019-06-26 14:41:56', 3, 0, '', '2019-06-26 14:41:56');
INSERT INTO `access_log` VALUES (43653, '64.77.15615313167673505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3710.0 Safari/537.36', '36.110.118.74', '2019-06-26 14:41:57', 2, 0, '', '2019-06-26 14:41:57');
INSERT INTO `access_log` VALUES (43654, '65.46.15615318773294677', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.127.172', '2019-06-26 14:51:17', 0, 1002001015, '账号未登陆', '2019-06-26 14:51:17');
INSERT INTO `access_log` VALUES (43655, '65.53.15615318773284627', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.127.172', '2019-06-26 14:51:17', 0, 1002001015, '账号未登陆', '2019-06-26 14:51:17');
INSERT INTO `access_log` VALUES (43656, '65.49.15615318773334635', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.127.172', '2019-06-26 14:51:17', 0, 1002001015, '账号未登陆', '2019-06-26 14:51:17');
INSERT INTO `access_log` VALUES (43657, '65.52.15615318790494633', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.127.172', '2019-06-26 14:51:19', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 14:51:19');
INSERT INTO `access_log` VALUES (43658, '65.54.15615319050654571', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.127.172', '2019-06-26 14:51:45', 77, 0, '', '2019-06-26 14:51:45');
INSERT INTO `access_log` VALUES (43659, '65.51.15615319054124661', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.127.172', '2019-06-26 14:51:45', 13, 0, '', '2019-06-26 14:51:45');
INSERT INTO `access_log` VALUES (43660, '65.3607.15615319054146405', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.127.172', '2019-06-26 14:51:45', 12, 0, '', '2019-06-26 14:51:45');
INSERT INTO `access_log` VALUES (43661, '65.45.15615319054124619', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.127.172', '2019-06-26 14:51:45', 14, 2001001000, '服务端发生异常', '2019-06-26 14:51:45');
INSERT INTO `access_log` VALUES (43662, '59.71.15615321044593475', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.154.179', '2019-06-26 14:55:04', 3, 0, '', '2019-06-26 14:55:04');
INSERT INTO `access_log` VALUES (43663, '59.80.15615321044613463', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.154.179', '2019-06-26 14:55:04', 12, 2001001000, '服务端发生异常', '2019-06-26 14:55:04');
INSERT INTO `access_log` VALUES (43664, '64.78.15615321083473525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.154.179', '2019-06-26 14:55:08', 3, 0, '', '2019-06-26 14:55:08');
INSERT INTO `access_log` VALUES (43665, '64.76.15615321084523509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.154.179', '2019-06-26 14:55:08', 2, 0, '', '2019-06-26 14:55:08');
INSERT INTO `access_log` VALUES (43666, '59.74.15615321100803473', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.154.179', '2019-06-26 14:55:10', 2, 0, '', '2019-06-26 14:55:10');
INSERT INTO `access_log` VALUES (43667, '59.75.15615321100833479', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.154.179', '2019-06-26 14:55:10', 15, 2001001000, '服务端发生异常', '2019-06-26 14:55:10');
INSERT INTO `access_log` VALUES (43668, '59.78.15615321141153471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.154.179', '2019-06-26 14:55:14', 3, 0, '', '2019-06-26 14:55:14');
INSERT INTO `access_log` VALUES (43669, '59.77.15615321141173461', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.154.179', '2019-06-26 14:55:14', 13, 2001001000, '服务端发生异常', '2019-06-26 14:55:14');
INSERT INTO `access_log` VALUES (43670, '66.56.15615321226821711', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=187098233331&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.154.179', '2019-06-26 14:55:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机验证码必须都是数字\n账号长度为 11 位\n手机验证码长度为 4-6 位', '2019-06-26 14:55:23');
INSERT INTO `access_log` VALUES (43671, '66.52.15615321273871701', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18709823333', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.154.179', '2019-06-26 14:55:27', 85, 0, '', '2019-06-26 14:55:27');
INSERT INTO `access_log` VALUES (43672, '66.51.15615321308491713', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18709823333&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.154.179', '2019-06-26 14:55:31', 154, 0, '', '2019-06-26 14:55:31');
INSERT INTO `access_log` VALUES (43673, '66.54.15615321347571705', 141, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.154.179', '2019-06-26 14:55:35', 9, 0, '', '2019-06-26 14:55:35');
INSERT INTO `access_log` VALUES (43674, '59.76.15615323063273471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.79.140', '2019-06-26 14:58:26', 2, 0, '', '2019-06-26 14:58:26');
INSERT INTO `access_log` VALUES (43675, '59.71.15615323063283479', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.79.140', '2019-06-26 14:58:26', 9, 2001001000, '服务端发生异常', '2019-06-26 14:58:26');
INSERT INTO `access_log` VALUES (43676, '64.77.15615323097583521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.79.140', '2019-06-26 14:58:30', 3, 0, '', '2019-06-26 14:58:30');
INSERT INTO `access_log` VALUES (43677, '64.80.15615323098433525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.79.140', '2019-06-26 14:58:30', 2, 0, '', '2019-06-26 14:58:30');
INSERT INTO `access_log` VALUES (43678, '64.79.15615323114563533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.79.140', '2019-06-26 14:58:31', 2, 0, '', '2019-06-26 14:58:31');
INSERT INTO `access_log` VALUES (43679, '64.84.15615323124183519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.79.140', '2019-06-26 14:58:32', 2, 0, '', '2019-06-26 14:58:32');
INSERT INTO `access_log` VALUES (43680, '65.53.15615326761144639', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-06-26 15:04:36', 1, 1002001015, '账号未登陆', '2019-06-26 15:04:36');
INSERT INTO `access_log` VALUES (43681, '65.49.15615326761144647', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-06-26 15:04:36', 0, 1002001015, '账号未登陆', '2019-06-26 15:04:36');
INSERT INTO `access_log` VALUES (43682, '65.52.15615326761174645', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-06-26 15:04:36', 0, 1002001015, '账号未登陆', '2019-06-26 15:04:36');
INSERT INTO `access_log` VALUES (43683, '65.47.15615326786984617', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-06-26 15:04:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 15:04:39');
INSERT INTO `access_log` VALUES (43684, '65.54.15615326881324583', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-06-26 15:04:48', 79, 0, '', '2019-06-26 15:04:48');
INSERT INTO `access_log` VALUES (43685, '65.3607.15615326886536417', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-06-26 15:04:49', 10, 0, '', '2019-06-26 15:04:49');
INSERT INTO `access_log` VALUES (43686, '65.51.15615326886584673', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-06-26 15:04:49', 10, 2001001000, '服务端发生异常', '2019-06-26 15:04:49');
INSERT INTO `access_log` VALUES (43687, '65.45.15615326886674631', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-06-26 15:04:49', 9, 0, '', '2019-06-26 15:04:49');
INSERT INTO `access_log` VALUES (43688, '65.52.15615326954224647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-06-26 15:04:55', 58, 0, '', '2019-06-26 15:04:55');
INSERT INTO `access_log` VALUES (43689, '65.49.15615326954474649', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-06-26 15:04:55', 40, 0, '', '2019-06-26 15:04:55');
INSERT INTO `access_log` VALUES (43690, '65.53.15615326954234641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-06-26 15:04:55', 64, 2001001000, '服务端发生异常', '2019-06-26 15:04:55');
INSERT INTO `access_log` VALUES (43691, '65.51.15615328992544677', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:19', 0, 1002001015, '账号未登陆', '2019-06-26 15:08:19');
INSERT INTO `access_log` VALUES (43692, '65.45.15615328992534635', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:19', 0, 1002001015, '账号未登陆', '2019-06-26 15:08:19');
INSERT INTO `access_log` VALUES (43693, '65.3607.15615328992546421', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:19', 0, 1002001015, '账号未登陆', '2019-06-26 15:08:19');
INSERT INTO `access_log` VALUES (43694, '65.46.15615329024424695', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 15:08:22');
INSERT INTO `access_log` VALUES (43695, '65.52.15615329061174651', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:26', 61, 0, '', '2019-06-26 15:08:26');
INSERT INTO `access_log` VALUES (43696, '65.47.15615329063944623', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:26', 9, 0, '', '2019-06-26 15:08:26');
INSERT INTO `access_log` VALUES (43697, '65.53.15615329063944645', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:26', 11, 2001001000, '服务端发生异常', '2019-06-26 15:08:26');
INSERT INTO `access_log` VALUES (43698, '65.50.15615329064024659', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:26', 9, 0, '', '2019-06-26 15:08:26');
INSERT INTO `access_log` VALUES (43699, '65.51.15615329257974679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 15:08:46');
INSERT INTO `access_log` VALUES (43700, '65.3607.15615329316616423', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:52', 64, 0, '', '2019-06-26 15:08:52');
INSERT INTO `access_log` VALUES (43701, '65.45.15615329319064637', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:52', 9, 0, '', '2019-06-26 15:08:52');
INSERT INTO `access_log` VALUES (43702, '65.46.15615329319104697', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:52', 9, 0, '', '2019-06-26 15:08:52');
INSERT INTO `access_log` VALUES (43703, '65.49.15615329319194655', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:52', 8, 0, '', '2019-06-26 15:08:52');
INSERT INTO `access_log` VALUES (43704, '64.81.15615329342243531', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:54', 15, 0, '', '2019-06-26 15:08:54');
INSERT INTO `access_log` VALUES (43705, '64.76.15615329342243521', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:08:54', 21, 0, '', '2019-06-26 15:08:54');
INSERT INTO `access_log` VALUES (43706, '64.82.15615329564693543', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:09:16', 10, 0, '', '2019-06-26 15:09:16');
INSERT INTO `access_log` VALUES (43707, '64.80.15615329598643535', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:09:20', 9, 0, '', '2019-06-26 15:09:20');
INSERT INTO `access_log` VALUES (43708, '64.77.15615329598623531', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:09:20', 16, 0, '', '2019-06-26 15:09:20');
INSERT INTO `access_log` VALUES (43709, '64.84.15615329633923529', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:09:23', 13, 0, '', '2019-06-26 15:09:23');
INSERT INTO `access_log` VALUES (43710, '64.85.15615329633923551', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:09:23', 13, 0, '', '2019-06-26 15:09:23');
INSERT INTO `access_log` VALUES (43711, '64.78.15615329660993539', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:09:26', 12, 0, '', '2019-06-26 15:09:26');
INSERT INTO `access_log` VALUES (43712, '62.89.15615329881903043', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:09:48', 58, 0, '', '2019-06-26 15:09:48');
INSERT INTO `access_log` VALUES (43713, '59.79.15615329919203493', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:09:52', 16, 0, '', '2019-06-26 15:09:52');
INSERT INTO `access_log` VALUES (43714, '59.73.15615329943883493', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '113.87.129.145', '2019-06-26 15:09:54', 398, 0, '', '2019-06-26 15:09:55');
INSERT INTO `access_log` VALUES (43715, '59.80.15615352828973507', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-26 15:48:03', 11, 0, '', '2019-06-26 15:48:03');
INSERT INTO `access_log` VALUES (43716, '59.74.15615352829013517', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-26 15:48:03', 22, 2001001000, '服务端发生异常', '2019-06-26 15:48:03');
INSERT INTO `access_log` VALUES (43717, '64.77.15615352871563563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-26 15:48:07', 11, 0, '', '2019-06-26 15:48:07');
INSERT INTO `access_log` VALUES (43718, '64.79.15615352872963575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-26 15:48:07', 2, 0, '', '2019-06-26 15:48:07');
INSERT INTO `access_log` VALUES (43719, '64.84.15615352890513561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-26 15:48:09', 2, 0, '', '2019-06-26 15:48:09');
INSERT INTO `access_log` VALUES (43720, '64.85.15615352897493583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-26 15:48:10', 2, 0, '', '2019-06-26 15:48:10');
INSERT INTO `access_log` VALUES (43721, '59.77.15615352917143505', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-26 15:48:12', 3, 0, '', '2019-06-26 15:48:12');
INSERT INTO `access_log` VALUES (43722, '59.78.15615352917133515', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-26 15:48:12', 16, 2001001000, '服务端发生异常', '2019-06-26 15:48:12');
INSERT INTO `access_log` VALUES (43723, '64.78.15615352968793571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-26 15:48:17', 2, 0, '', '2019-06-26 15:48:17');
INSERT INTO `access_log` VALUES (43724, '64.76.15615352969993555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-26 15:48:17', 2, 0, '', '2019-06-26 15:48:17');
INSERT INTO `access_log` VALUES (43725, '64.81.15615352983373565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-26 15:48:18', 3, 0, '', '2019-06-26 15:48:18');
INSERT INTO `access_log` VALUES (43726, '59.79.15615352995003525', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-26 15:48:20', 3, 0, '', '2019-06-26 15:48:20');
INSERT INTO `access_log` VALUES (43727, '59.73.15615352995013525', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '103.254.69.246', '2019-06-26 15:48:20', 13, 2001001000, '服务端发生异常', '2019-06-26 15:48:20');
INSERT INTO `access_log` VALUES (43728, '59.78.15615362829133529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:43', 3, 0, '', '2019-06-26 16:04:43');
INSERT INTO `access_log` VALUES (43729, '59.77.15615362829063519', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:43', 12, 2001001000, '服务端发生异常', '2019-06-26 16:04:43');
INSERT INTO `access_log` VALUES (43730, '64.85.15615362864523597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:46', 10, 0, '', '2019-06-26 16:04:46');
INSERT INTO `access_log` VALUES (43731, '64.78.15615362866243585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:47', 1, 0, '', '2019-06-26 16:04:47');
INSERT INTO `access_log` VALUES (43732, '64.76.15615362878023569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:48', 2, 0, '', '2019-06-26 16:04:48');
INSERT INTO `access_log` VALUES (43733, '64.81.15615362885943579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:49', 2, 0, '', '2019-06-26 16:04:49');
INSERT INTO `access_log` VALUES (43734, '64.83.15615362891203575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:49', 2, 0, '', '2019-06-26 16:04:49');
INSERT INTO `access_log` VALUES (43735, '64.82.15615362895243591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:50', 2, 0, '', '2019-06-26 16:04:50');
INSERT INTO `access_log` VALUES (43736, '64.77.15615362929353579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:53', 2, 0, '', '2019-06-26 16:04:53');
INSERT INTO `access_log` VALUES (43737, '64.79.15615362931363591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:53', 2, 0, '', '2019-06-26 16:04:53');
INSERT INTO `access_log` VALUES (43738, '64.84.15615362944293577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:54', 2, 0, '', '2019-06-26 16:04:54');
INSERT INTO `access_log` VALUES (43739, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:54', 6, 0, '', '2019-06-26 16:04:54');
INSERT INTO `access_log` VALUES (43740, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:56', 7, 0, '', '2019-06-26 16:04:56');
INSERT INTO `access_log` VALUES (43741, '64.85.15615362965663599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:57', 2, 0, '', '2019-06-26 16:04:57');
INSERT INTO `access_log` VALUES (43742, '64.78.15615362967453587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:57', 2, 0, '', '2019-06-26 16:04:57');
INSERT INTO `access_log` VALUES (43743, '59.79.15615362976793539', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:58', 2, 0, '', '2019-06-26 16:04:58');
INSERT INTO `access_log` VALUES (43744, '59.73.15615362976803539', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.62.230.105', '2019-06-26 16:04:58', 18, 2001001000, '服务端发生异常', '2019-06-26 16:04:58');
INSERT INTO `access_log` VALUES (43745, '65.52.15615365747794703', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.90.31.253', '2019-06-26 16:09:35', 1, 1002001015, '账号未登陆', '2019-06-26 16:09:35');
INSERT INTO `access_log` VALUES (43746, '65.49.15615365747794705', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.90.31.253', '2019-06-26 16:09:35', 1, 1002001015, '账号未登陆', '2019-06-26 16:09:35');
INSERT INTO `access_log` VALUES (43747, '65.50.15615365748014709', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.90.31.253', '2019-06-26 16:09:35', 0, 1002001015, '账号未登陆', '2019-06-26 16:09:35');
INSERT INTO `access_log` VALUES (43748, '65.54.15615365984714641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.90.31.253', '2019-06-26 16:09:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 16:09:58');
INSERT INTO `access_log` VALUES (43749, '65.51.15615366020584731', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.90.31.253', '2019-06-26 16:10:02', 71, 0, '', '2019-06-26 16:10:02');
INSERT INTO `access_log` VALUES (43750, '65.3607.15615366025316475', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.90.31.253', '2019-06-26 16:10:03', 11, 0, '', '2019-06-26 16:10:03');
INSERT INTO `access_log` VALUES (43751, '65.46.15615366025354749', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.90.31.253', '2019-06-26 16:10:03', 10, 2001001000, '服务端发生异常', '2019-06-26 16:10:03');
INSERT INTO `access_log` VALUES (43752, '65.45.15615366025654689', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.90.31.253', '2019-06-26 16:10:03', 9, 0, '', '2019-06-26 16:10:03');
INSERT INTO `access_log` VALUES (43753, '65.50.15615366076224711', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.90.31.253', '2019-06-26 16:10:08', 13, 0, '', '2019-06-26 16:10:08');
INSERT INTO `access_log` VALUES (43754, '65.49.15615366076244707', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.90.31.253', '2019-06-26 16:10:08', 13, 0, '', '2019-06-26 16:10:08');
INSERT INTO `access_log` VALUES (43755, '65.52.15615366076224705', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.90.31.253', '2019-06-26 16:10:08', 15, 2001001000, '服务端发生异常', '2019-06-26 16:10:08');
INSERT INTO `access_log` VALUES (43756, '65.46.15615372410834759', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-26 16:20:41', 0, 1002001015, '账号未登陆', '2019-06-26 16:20:41');
INSERT INTO `access_log` VALUES (43757, '65.51.15615372410784741', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-26 16:20:41', 0, 1002001015, '账号未登陆', '2019-06-26 16:20:41');
INSERT INTO `access_log` VALUES (43758, '65.3607.15615372410796485', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-26 16:20:41', 0, 1002001015, '账号未登陆', '2019-06-26 16:20:41');
INSERT INTO `access_log` VALUES (43759, '65.45.15615372444494699', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-26 16:20:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 16:20:44');
INSERT INTO `access_log` VALUES (43760, '65.52.15615372515804715', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-26 16:20:52', 63, 0, '', '2019-06-26 16:20:52');
INSERT INTO `access_log` VALUES (43761, '65.50.15615372520934721', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-26 16:20:52', 9, 0, '', '2019-06-26 16:20:52');
INSERT INTO `access_log` VALUES (43762, '65.49.15615372520954717', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-26 16:20:52', 10, 2001001000, '服务端发生异常', '2019-06-26 16:20:52');
INSERT INTO `access_log` VALUES (43763, '65.53.15615372521104707', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-26 16:20:52', 10, 0, '', '2019-06-26 16:20:52');
INSERT INTO `access_log` VALUES (43764, '65.51.15615372981744743', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-26 16:21:38', 8, 0, '', '2019-06-26 16:21:38');
INSERT INTO `access_log` VALUES (43765, '65.45.15615372981764701', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-26 16:21:38', 8, 0, '', '2019-06-26 16:21:38');
INSERT INTO `access_log` VALUES (43766, '65.3607.15615372981756487', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-26 16:21:38', 9, 2001001000, '服务端发生异常', '2019-06-26 16:21:38');
INSERT INTO `access_log` VALUES (43767, '65.49.15615372992534719', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-26 16:21:39', 9, 0, '', '2019-06-26 16:21:39');
INSERT INTO `access_log` VALUES (43768, '65.53.15615372992564709', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-26 16:21:39', 9, 2001001000, '服务端发生异常', '2019-06-26 16:21:39');
INSERT INTO `access_log` VALUES (43769, '65.50.15615372992574723', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-26 16:21:39', 9, 0, '', '2019-06-26 16:21:39');
INSERT INTO `access_log` VALUES (43770, '65.51.15615379495574753', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.40.252', '2019-06-26 16:32:30', 5, 1002001012, '访问令牌已过期', '2019-06-26 16:32:30');
INSERT INTO `access_log` VALUES (43771, '65.45.15615379495574711', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.40.252', '2019-06-26 16:32:30', 5, 1002001012, '访问令牌已过期', '2019-06-26 16:32:30');
INSERT INTO `access_log` VALUES (43772, '65.3607.15615379495696497', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.40.252', '2019-06-26 16:32:30', 3, 1002001012, '访问令牌已过期', '2019-06-26 16:32:30');
INSERT INTO `access_log` VALUES (43773, '65.52.15615379527454727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.40.252', '2019-06-26 16:32:33', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 16:32:33');
INSERT INTO `access_log` VALUES (43774, '65.53.15615379682934719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.40.252', '2019-06-26 16:32:48', 55, 0, '', '2019-06-26 16:32:48');
INSERT INTO `access_log` VALUES (43775, '65.47.15615379686844697', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.40.252', '2019-06-26 16:32:49', 10, 0, '', '2019-06-26 16:32:49');
INSERT INTO `access_log` VALUES (43776, '65.49.15615379686844729', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.40.252', '2019-06-26 16:32:49', 12, 2001001000, '服务端发生异常', '2019-06-26 16:32:49');
INSERT INTO `access_log` VALUES (43777, '65.54.15615379686924665', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.40.252', '2019-06-26 16:32:49', 9, 0, '', '2019-06-26 16:32:49');
INSERT INTO `access_log` VALUES (43778, '59.76.15615387131263559', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:45:13', 12, 0, '', '2019-06-26 16:45:13');
INSERT INTO `access_log` VALUES (43779, '59.80.15615387131263555', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:45:13', 17, 2001001000, '服务端发生异常', '2019-06-26 16:45:13');
INSERT INTO `access_log` VALUES (43780, '64.81.15615387165033613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:45:17', 11, 0, '', '2019-06-26 16:45:17');
INSERT INTO `access_log` VALUES (43781, '64.83.15615387166583609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:45:17', 3, 0, '', '2019-06-26 16:45:17');
INSERT INTO `access_log` VALUES (43782, '64.82.15615387175763625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:45:18', 2, 0, '', '2019-06-26 16:45:18');
INSERT INTO `access_log` VALUES (43783, '64.80.15615387182953617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:45:18', 2, 0, '', '2019-06-26 16:45:18');
INSERT INTO `access_log` VALUES (43784, '59.76.15615389701143563', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:49:30', 3, 0, '', '2019-06-26 16:49:30');
INSERT INTO `access_log` VALUES (43785, '59.71.15615389701133571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:49:30', 34, 2001001000, '服务端发生异常', '2019-06-26 16:49:30');
INSERT INTO `access_log` VALUES (43786, '64.83.15615389723603613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:49:32', 2, 0, '', '2019-06-26 16:49:32');
INSERT INTO `access_log` VALUES (43787, '64.82.15615389724663629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:49:32', 1, 0, '', '2019-06-26 16:49:32');
INSERT INTO `access_log` VALUES (43788, '59.80.15615389737743559', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:49:34', 3, 0, '', '2019-06-26 16:49:34');
INSERT INTO `access_log` VALUES (43789, '59.74.15615389737763569', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:49:34', 25, 2001001000, '服务端发生异常', '2019-06-26 16:49:34');
INSERT INTO `access_log` VALUES (43790, '64.77.15615389757343617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:49:36', 2, 0, '', '2019-06-26 16:49:36');
INSERT INTO `access_log` VALUES (43791, '64.79.15615389759133629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:49:36', 2, 0, '', '2019-06-26 16:49:36');
INSERT INTO `access_log` VALUES (43792, '64.84.15615389770103615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:49:37', 1, 0, '', '2019-06-26 16:49:37');
INSERT INTO `access_log` VALUES (43793, '64.85.15615389774653637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:49:37', 1, 0, '', '2019-06-26 16:49:37');
INSERT INTO `access_log` VALUES (43794, '64.78.15615389779123625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:49:38', 2, 0, '', '2019-06-26 16:49:38');
INSERT INTO `access_log` VALUES (43795, '59.77.15615389786933557', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:49:39', 3, 0, '', '2019-06-26 16:49:39');
INSERT INTO `access_log` VALUES (43796, '59.78.15615389786933567', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.65.129.174', '2019-06-26 16:49:39', 13, 2001001000, '服务端发生异常', '2019-06-26 16:49:39');
INSERT INTO `access_log` VALUES (43797, '65.47.15615397103684721', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.207.128.58', '2019-06-26 17:01:50', 0, 1002001015, '账号未登陆', '2019-06-26 17:01:50');
INSERT INTO `access_log` VALUES (43798, '65.53.15615397103674743', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.207.128.58', '2019-06-26 17:01:50', 1, 1002001015, '账号未登陆', '2019-06-26 17:01:50');
INSERT INTO `access_log` VALUES (43799, '65.54.15615397103694689', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.207.128.58', '2019-06-26 17:01:50', 0, 1002001015, '账号未登陆', '2019-06-26 17:01:50');
INSERT INTO `access_log` VALUES (43800, '65.49.15615397126144753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.207.128.58', '2019-06-26 17:01:53', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 17:01:53');
INSERT INTO `access_log` VALUES (43801, '65.3607.15615397193546523', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.207.128.58', '2019-06-26 17:01:59', 74, 0, '', '2019-06-26 17:01:59');
INSERT INTO `access_log` VALUES (43802, '65.52.15615397197364753', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.207.128.58', '2019-06-26 17:02:00', 14, 0, '', '2019-06-26 17:02:00');
INSERT INTO `access_log` VALUES (43803, '65.45.15615397197364737', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.207.128.58', '2019-06-26 17:02:00', 16, 0, '', '2019-06-26 17:02:00');
INSERT INTO `access_log` VALUES (43804, '65.51.15615397197364779', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.207.128.58', '2019-06-26 17:02:00', 16, 2001001000, '服务端发生异常', '2019-06-26 17:02:00');
INSERT INTO `access_log` VALUES (43805, '59.76.15615402173833581', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:17', 3, 0, '', '2019-06-26 17:10:17');
INSERT INTO `access_log` VALUES (43806, '59.73.15615402173833593', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:17', 18, 2001001000, '服务端发生异常', '2019-06-26 17:10:17');
INSERT INTO `access_log` VALUES (43807, '64.82.15615402266923647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:27', 4, 0, '', '2019-06-26 17:10:27');
INSERT INTO `access_log` VALUES (43808, '64.80.15615402267883639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:27', 2, 0, '', '2019-06-26 17:10:27');
INSERT INTO `access_log` VALUES (43809, '64.77.15615402282803635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:28', 2, 0, '', '2019-06-26 17:10:28');
INSERT INTO `access_log` VALUES (43810, '64.79.15615402288963647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:29', 2, 0, '', '2019-06-26 17:10:29');
INSERT INTO `access_log` VALUES (43811, '59.75.15615402299453593', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:30', 3, 0, '', '2019-06-26 17:10:30');
INSERT INTO `access_log` VALUES (43812, '59.74.15615402299453587', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:30', 31, 2001001000, '服务端发生异常', '2019-06-26 17:10:30');
INSERT INTO `access_log` VALUES (43813, '64.84.15615402343713633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:34', 2, 0, '', '2019-06-26 17:10:34');
INSERT INTO `access_log` VALUES (43814, '64.85.15615402345373655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:35', 2, 0, '', '2019-06-26 17:10:35');
INSERT INTO `access_log` VALUES (43815, '59.77.15615402358283575', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:36', 3, 0, '', '2019-06-26 17:10:36');
INSERT INTO `access_log` VALUES (43816, '59.78.15615402358283585', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:36', 12, 2001001000, '服务端发生异常', '2019-06-26 17:10:36');
INSERT INTO `access_log` VALUES (43817, '64.76.15615402476373627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:48', 2, 0, '', '2019-06-26 17:10:48');
INSERT INTO `access_log` VALUES (43818, '64.81.15615402477583637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:48', 2, 0, '', '2019-06-26 17:10:48');
INSERT INTO `access_log` VALUES (43819, '59.72.15615402483983587', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:48', 2, 0, '', '2019-06-26 17:10:48');
INSERT INTO `access_log` VALUES (43820, '59.79.15615402483993595', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:10:48', 23, 2001001000, '服务端发生异常', '2019-06-26 17:10:48');
INSERT INTO `access_log` VALUES (43821, '64.84.15615403214603635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:12:01', 2, 0, '', '2019-06-26 17:12:01');
INSERT INTO `access_log` VALUES (43822, '64.85.15615403216203657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:12:02', 2, 0, '', '2019-06-26 17:12:02');
INSERT INTO `access_log` VALUES (43823, '59.80.15615403222103579', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:12:02', 3, 0, '', '2019-06-26 17:12:02');
INSERT INTO `access_log` VALUES (43824, '59.77.15615403222443577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:12:02', 12, 2001001000, '服务端发生异常', '2019-06-26 17:12:02');
INSERT INTO `access_log` VALUES (43825, '64.78.15615403226973645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:12:03', 2, 0, '', '2019-06-26 17:12:03');
INSERT INTO `access_log` VALUES (43826, '64.76.15615403228463629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:12:03', 2, 0, '', '2019-06-26 17:12:03');
INSERT INTO `access_log` VALUES (43827, '59.78.15615403229363587', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:12:03', 2, 0, '', '2019-06-26 17:12:03');
INSERT INTO `access_log` VALUES (43828, '59.72.15615403229703589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:12:03', 13, 2001001000, '服务端发生异常', '2019-06-26 17:12:03');
INSERT INTO `access_log` VALUES (43829, '64.81.15615403233763639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:12:03', 2, 0, '', '2019-06-26 17:12:03');
INSERT INTO `access_log` VALUES (43830, '64.83.15615403235033635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:12:04', 2, 0, '', '2019-06-26 17:12:04');
INSERT INTO `access_log` VALUES (43831, '59.73.15615403243213597', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:12:04', 3, 0, '', '2019-06-26 17:12:04');
INSERT INTO `access_log` VALUES (43832, '59.76.15615403243213585', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.60.232.4', '2019-06-26 17:12:04', 13, 2001001000, '服务端发生异常', '2019-06-26 17:12:04');
INSERT INTO `access_log` VALUES (43833, '66.56.15615408940101829', 0, 1, 'user-application', '/user-api/users/address/add', 'name=1&tel=18408221234&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=1&isDefault=false&address=1&areaNo=110101&mobile=18408221234&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-26 17:21:34', 159, 2001001000, '服务端发生异常', '2019-06-26 17:21:34');
INSERT INTO `access_log` VALUES (43834, '59.74.15615412633383603', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-06-26 17:27:43', 3, 0, '', '2019-06-26 17:27:43');
INSERT INTO `access_log` VALUES (43835, '59.77.15615412633383591', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-06-26 17:27:43', 17, 2001001000, '服务端发生异常', '2019-06-26 17:27:43');
INSERT INTO `access_log` VALUES (43836, '64.84.15615412745803649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:27:55', 2, 0, '', '2019-06-26 17:27:55');
INSERT INTO `access_log` VALUES (43837, '64.85.15615412747183671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:27:55', 2, 0, '', '2019-06-26 17:27:55');
INSERT INTO `access_log` VALUES (43838, '64.78.15615412777103659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:27:58', 2, 0, '', '2019-06-26 17:27:58');
INSERT INTO `access_log` VALUES (43839, '64.76.15615412778493643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:27:58', 2, 0, '', '2019-06-26 17:27:58');
INSERT INTO `access_log` VALUES (43840, '59.78.15615412787923601', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:27:59', 3, 0, '', '2019-06-26 17:27:59');
INSERT INTO `access_log` VALUES (43841, '59.72.15615412787923603', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:27:59', 20, 2001001000, '服务端发生异常', '2019-06-26 17:27:59');
INSERT INTO `access_log` VALUES (43842, '64.81.15615412808953653', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:01', 2, 0, '', '2019-06-26 17:28:01');
INSERT INTO `access_log` VALUES (43843, '64.83.15615412810023649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:01', 2, 0, '', '2019-06-26 17:28:01');
INSERT INTO `access_log` VALUES (43844, '59.79.15615412828263611', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:03', 3, 0, '', '2019-06-26 17:28:03');
INSERT INTO `access_log` VALUES (43845, '59.73.15615412828263611', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:03', 16, 2001001000, '服务端发生异常', '2019-06-26 17:28:03');
INSERT INTO `access_log` VALUES (43846, '64.80.15615412905433657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:11', 2, 0, '', '2019-06-26 17:28:11');
INSERT INTO `access_log` VALUES (43847, '64.77.15615412906433653', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:11', 2, 0, '', '2019-06-26 17:28:11');
INSERT INTO `access_log` VALUES (43848, '64.79.15615412917923665', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:12', 2, 0, '', '2019-06-26 17:28:12');
INSERT INTO `access_log` VALUES (43849, '64.84.15615412923693651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:12', 2, 0, '', '2019-06-26 17:28:12');
INSERT INTO `access_log` VALUES (43850, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:12', 7, 0, '', '2019-06-26 17:28:12');
INSERT INTO `access_log` VALUES (43851, '64.85.15615412939273673', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:14', 38, 0, '', '2019-06-26 17:28:14');
INSERT INTO `access_log` VALUES (43852, '64.76.15615413021333645', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:22', 6, 0, '', '2019-06-26 17:28:22');
INSERT INTO `access_log` VALUES (43853, '64.81.15615413118333655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:32', 2, 0, '', '2019-06-26 17:28:32');
INSERT INTO `access_log` VALUES (43854, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:32', 6, 0, '', '2019-06-26 17:28:32');
INSERT INTO `access_log` VALUES (43855, '64.83.15615413126333651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:33', 2, 0, '', '2019-06-26 17:28:33');
INSERT INTO `access_log` VALUES (43856, '64.82.15615413127333667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:33', 1, 0, '', '2019-06-26 17:28:33');
INSERT INTO `access_log` VALUES (43857, '59.75.15615413132373611', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:33', 3, 0, '', '2019-06-26 17:28:33');
INSERT INTO `access_log` VALUES (43858, '59.74.15615413132403605', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:33', 19, 2001001000, '服务端发生异常', '2019-06-26 17:28:33');
INSERT INTO `access_log` VALUES (43859, '64.80.15615413136143659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:34', 2, 0, '', '2019-06-26 17:28:34');
INSERT INTO `access_log` VALUES (43860, '64.77.15615413137323655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:34', 2, 0, '', '2019-06-26 17:28:34');
INSERT INTO `access_log` VALUES (43861, '59.80.15615413145403595', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:35', 2, 0, '', '2019-06-26 17:28:35');
INSERT INTO `access_log` VALUES (43862, '59.78.15615413145403603', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:35', 13, 2001001000, '服务端发生异常', '2019-06-26 17:28:35');
INSERT INTO `access_log` VALUES (43863, '64.79.15615413154593667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:35', 2, 0, '', '2019-06-26 17:28:35');
INSERT INTO `access_log` VALUES (43864, '64.85.15615413155773675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:36', 2, 0, '', '2019-06-26 17:28:36');
INSERT INTO `access_log` VALUES (43865, '59.72.15615413161333605', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:36', 2, 0, '', '2019-06-26 17:28:36');
INSERT INTO `access_log` VALUES (43866, '59.73.15615413161333613', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.86.138', '2019-06-26 17:28:36', 10, 2001001000, '服务端发生异常', '2019-06-26 17:28:36');
INSERT INTO `access_log` VALUES (43867, '59.73.15615417323653619', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.128.11.254', '2019-06-26 17:35:32', 3, 0, '', '2019-06-26 17:35:32');
INSERT INTO `access_log` VALUES (43868, '59.78.15615417323653609', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.128.11.254', '2019-06-26 17:35:32', 14, 2001001000, '服务端发生异常', '2019-06-26 17:35:32');
INSERT INTO `access_log` VALUES (43869, '59.74.15615417801833613', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.128.11.254', '2019-06-26 17:36:20', 2, 0, '', '2019-06-26 17:36:20');
INSERT INTO `access_log` VALUES (43870, '59.75.15615417801843619', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.128.11.254', '2019-06-26 17:36:20', 13, 2001001000, '服务端发生异常', '2019-06-26 17:36:20');
INSERT INTO `access_log` VALUES (43871, '64.83.15615418132423659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:36:53', 3, 0, '', '2019-06-26 17:36:53');
INSERT INTO `access_log` VALUES (43872, '64.82.15615418133763675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:36:53', 2, 0, '', '2019-06-26 17:36:53');
INSERT INTO `access_log` VALUES (43873, '64.84.15615418417083661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:37:22', 2, 0, '', '2019-06-26 17:37:22');
INSERT INTO `access_log` VALUES (43874, '64.79.15615418427233675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:37:23', 1, 0, '', '2019-06-26 17:37:23');
INSERT INTO `access_log` VALUES (43875, '64.85.15615418487703683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:37:29', 2, 0, '', '2019-06-26 17:37:29');
INSERT INTO `access_log` VALUES (43876, '64.78.15615418489203671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:37:29', 2, 0, '', '2019-06-26 17:37:29');
INSERT INTO `access_log` VALUES (43877, '59.72.15615418503453613', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:37:30', 3, 0, '', '2019-06-26 17:37:30');
INSERT INTO `access_log` VALUES (43878, '59.79.15615418504343621', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:37:30', 12, 2001001000, '服务端发生异常', '2019-06-26 17:37:30');
INSERT INTO `access_log` VALUES (43879, '64.76.15615418541023655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:37:34', 1, 0, '', '2019-06-26 17:37:34');
INSERT INTO `access_log` VALUES (43880, '64.81.15615418544303665', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:37:34', 2, 0, '', '2019-06-26 17:37:34');
INSERT INTO `access_log` VALUES (43881, '59.75.15615418835613621', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-26 17:38:04', 8, 0, '', '2019-06-26 17:38:04');
INSERT INTO `access_log` VALUES (43882, '59.74.15615418835613615', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-26 17:38:04', 18, 2001001000, '服务端发生异常', '2019-06-26 17:38:04');
INSERT INTO `access_log` VALUES (43883, '64.77.15615418968413665', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-26 17:38:17', 2, 0, '', '2019-06-26 17:38:17');
INSERT INTO `access_log` VALUES (43884, '64.84.15615418969533663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-26 17:38:17', 2, 0, '', '2019-06-26 17:38:17');
INSERT INTO `access_log` VALUES (43885, '64.79.15615418978453677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-26 17:38:18', 2, 0, '', '2019-06-26 17:38:18');
INSERT INTO `access_log` VALUES (43886, '64.85.15615418983023685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.59.204.248', '2019-06-26 17:38:18', 2, 0, '', '2019-06-26 17:38:18');
INSERT INTO `access_log` VALUES (43887, '59.77.15615420231373605', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:40:23', 3, 0, '', '2019-06-26 17:40:23');
INSERT INTO `access_log` VALUES (43888, '59.80.15615420231383607', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:40:23', 15, 2001001000, '服务端发生异常', '2019-06-26 17:40:23');
INSERT INTO `access_log` VALUES (43889, '64.85.15615420252523687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:40:25', 3, 0, '', '2019-06-26 17:40:25');
INSERT INTO `access_log` VALUES (43890, '64.78.15615420254073675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:40:25', 1, 0, '', '2019-06-26 17:40:25');
INSERT INTO `access_log` VALUES (43891, '59.73.15615420267603625', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:40:27', 2, 0, '', '2019-06-26 17:40:27');
INSERT INTO `access_log` VALUES (43892, '59.78.15615420267603615', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:40:27', 12, 2001001000, '服务端发生异常', '2019-06-26 17:40:27');
INSERT INTO `access_log` VALUES (43893, '64.76.15615420325503659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:40:33', 2, 0, '', '2019-06-26 17:40:33');
INSERT INTO `access_log` VALUES (43894, '64.81.15615420326673669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:40:33', 2, 0, '', '2019-06-26 17:40:33');
INSERT INTO `access_log` VALUES (43895, '59.72.15615420338943617', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:40:34', 3, 0, '', '2019-06-26 17:40:34');
INSERT INTO `access_log` VALUES (43896, '59.79.15615420338943625', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '222.128.11.254', '2019-06-26 17:40:34', 12, 2001001000, '服务端发生异常', '2019-06-26 17:40:34');
INSERT INTO `access_log` VALUES (43897, '65.52.15615427212154795', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.37.178.2', '2019-06-26 17:52:01', 0, 1002001015, '账号未登陆', '2019-06-26 17:52:01');
INSERT INTO `access_log` VALUES (43898, '65.50.15615427212154797', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.37.178.2', '2019-06-26 17:52:01', 0, 1002001015, '账号未登陆', '2019-06-26 17:52:01');
INSERT INTO `access_log` VALUES (43899, '65.49.15615427212164793', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.37.178.2', '2019-06-26 17:52:01', 0, 1002001015, '账号未登陆', '2019-06-26 17:52:01');
INSERT INTO `access_log` VALUES (43900, '65.47.15615427407494763', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.37.178.2', '2019-06-26 17:52:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 17:52:21');
INSERT INTO `access_log` VALUES (43901, '65.46.15615427574464839', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.37.178.2', '2019-06-26 17:52:37', 133, 0, '', '2019-06-26 17:52:38');
INSERT INTO `access_log` VALUES (43902, '65.3607.15615427580656567', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.37.178.2', '2019-06-26 17:52:38', 9, 0, '', '2019-06-26 17:52:38');
INSERT INTO `access_log` VALUES (43903, '65.51.15615427580704823', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.37.178.2', '2019-06-26 17:52:38', 8, 0, '', '2019-06-26 17:52:38');
INSERT INTO `access_log` VALUES (43904, '65.45.15615427580694781', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.37.178.2', '2019-06-26 17:52:38', 9, 2001001000, '服务端发生异常', '2019-06-26 17:52:38');
INSERT INTO `access_log` VALUES (43905, '65.3607.15615431526146573', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 17:59:13', 1, 1002001015, '账号未登陆', '2019-06-26 17:59:13');
INSERT INTO `access_log` VALUES (43906, '65.45.15615431526204787', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 17:59:13', 0, 1002001015, '账号未登陆', '2019-06-26 17:59:13');
INSERT INTO `access_log` VALUES (43907, '65.51.15615431526264829', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 17:59:13', 0, 1002001015, '账号未登陆', '2019-06-26 17:59:13');
INSERT INTO `access_log` VALUES (43908, '65.50.15615431603324805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 17:59:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 17:59:20');
INSERT INTO `access_log` VALUES (43909, '65.52.15615431639754803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 17:59:24', 106, 0, '', '2019-06-26 17:59:24');
INSERT INTO `access_log` VALUES (43910, '65.53.15615431644454795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 17:59:24', 18, 0, '', '2019-06-26 17:59:24');
INSERT INTO `access_log` VALUES (43911, '65.47.15615431644614771', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 17:59:24', 9, 2001001000, '服务端发生异常', '2019-06-26 17:59:24');
INSERT INTO `access_log` VALUES (43912, '65.54.15615431644634741', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 17:59:24', 9, 0, '', '2019-06-26 17:59:24');
INSERT INTO `access_log` VALUES (43913, '65.51.15615431853654831', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 17:59:45', 9, 0, '', '2019-06-26 17:59:45');
INSERT INTO `access_log` VALUES (43914, '65.3607.15615431853756575', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 17:59:45', 10, 2001001000, '服务端发生异常', '2019-06-26 17:59:45');
INSERT INTO `access_log` VALUES (43915, '65.45.15615431853794789', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 17:59:45', 8, 0, '', '2019-06-26 17:59:45');
INSERT INTO `access_log` VALUES (43916, '65.52.15615431895204805', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 17:59:50', 9, 0, '', '2019-06-26 17:59:50');
INSERT INTO `access_log` VALUES (43917, '65.50.15615431895134807', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 17:59:50', 105, 0, '', '2019-06-26 17:59:50');
INSERT INTO `access_log` VALUES (43918, '65.49.15615431895164803', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 17:59:50', 103, 2001001000, '服务端发生异常', '2019-06-26 17:59:50');
INSERT INTO `access_log` VALUES (43919, '65.47.15615432107974773', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:00:11', 8, 0, '', '2019-06-26 18:00:11');
INSERT INTO `access_log` VALUES (43920, '65.46.15615432108024849', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:00:11', 9, 2001001000, '服务端发生异常', '2019-06-26 18:00:11');
INSERT INTO `access_log` VALUES (43921, '65.51.15615432108094833', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:00:11', 8, 0, '', '2019-06-26 18:00:11');
INSERT INTO `access_log` VALUES (43922, '65.52.15615432485964807', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:00:49', 9, 0, '', '2019-06-26 18:00:49');
INSERT INTO `access_log` VALUES (43923, '65.50.15615432486094809', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:00:49', 9, 2001001000, '服务端发生异常', '2019-06-26 18:00:49');
INSERT INTO `access_log` VALUES (43924, '65.49.15615432486184805', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:00:49', 9, 0, '', '2019-06-26 18:00:49');
INSERT INTO `access_log` VALUES (43925, '65.54.15615432592324745', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:00:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 18:00:59');
INSERT INTO `access_log` VALUES (43926, '65.51.15615432627074835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:01:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 18:01:03');
INSERT INTO `access_log` VALUES (43927, '65.46.15615432658284851', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:01:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 18:01:06');
INSERT INTO `access_log` VALUES (43928, '65.3607.15615432694966579', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:01:09', 4, 1002002001, '密码不正确', '2019-06-26 18:01:10');
INSERT INTO `access_log` VALUES (43929, '65.45.15615432739354793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:01:14', 57, 0, '', '2019-06-26 18:01:14');
INSERT INTO `access_log` VALUES (43930, '65.52.15615432743114809', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:01:14', 8, 0, '', '2019-06-26 18:01:14');
INSERT INTO `access_log` VALUES (43931, '65.50.15615432743164811', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:01:14', 8, 0, '', '2019-06-26 18:01:14');
INSERT INTO `access_log` VALUES (43932, '65.49.15615432743324807', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:01:14', 9, 0, '', '2019-06-26 18:01:14');
INSERT INTO `access_log` VALUES (43933, '64.84.15615432878853683', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:01:28', 17, 0, '', '2019-06-26 18:01:28');
INSERT INTO `access_log` VALUES (43934, '64.79.15615432878953697', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:01:28', 13, 0, '', '2019-06-26 18:01:28');
INSERT INTO `access_log` VALUES (43935, '64.85.15615432924603705', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:01:32', 15, 0, '', '2019-06-26 18:01:32');
INSERT INTO `access_log` VALUES (43936, '64.78.15615432924663693', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:01:32', 10, 0, '', '2019-06-26 18:01:32');
INSERT INTO `access_log` VALUES (43937, '64.81.15615433011133687', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.28.133.193', '2019-06-26 18:01:41', 15, 0, '', '2019-06-26 18:01:41');
INSERT INTO `access_log` VALUES (43938, '65.52.15615438385004817', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:10:39', 1, 1002001015, '账号未登陆', '2019-06-26 18:10:39');
INSERT INTO `access_log` VALUES (43939, '65.50.15615438385084819', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:10:39', 0, 1002001015, '账号未登陆', '2019-06-26 18:10:39');
INSERT INTO `access_log` VALUES (43940, '65.49.15615438385544815', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:10:39', 1, 1002001015, '账号未登陆', '2019-06-26 18:10:39');
INSERT INTO `access_log` VALUES (43941, '65.54.15615438415154755', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:10:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 18:10:42');
INSERT INTO `access_log` VALUES (43942, '65.51.15615438455074845', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:10:46', 5, 1002002000, '账号不存在', '2019-06-26 18:10:46');
INSERT INTO `access_log` VALUES (43943, '65.46.15615438526114861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:10:53', 115, 0, '', '2019-06-26 18:10:53');
INSERT INTO `access_log` VALUES (43944, '65.47.15615438530234785', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:10:53', 9, 0, '', '2019-06-26 18:10:53');
INSERT INTO `access_log` VALUES (43945, '65.3607.15615438530286589', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:10:53', 10, 2001001000, '服务端发生异常', '2019-06-26 18:10:53');
INSERT INTO `access_log` VALUES (43946, '65.45.15615438530384803', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:10:53', 16, 0, '', '2019-06-26 18:10:53');
INSERT INTO `access_log` VALUES (43947, '65.50.15615438659784821', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:11:06', 9, 0, '', '2019-06-26 18:11:06');
INSERT INTO `access_log` VALUES (43948, '65.49.15615438659844817', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:11:06', 10, 2001001000, '服务端发生异常', '2019-06-26 18:11:06');
INSERT INTO `access_log` VALUES (43949, '65.53.15615438659924811', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:11:06', 8, 0, '', '2019-06-26 18:11:06');
INSERT INTO `access_log` VALUES (43950, '65.51.15615438709594847', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:11:11', 8, 0, '', '2019-06-26 18:11:11');
INSERT INTO `access_log` VALUES (43951, '65.3607.15615438709676591', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:11:11', 9, 0, '', '2019-06-26 18:11:11');
INSERT INTO `access_log` VALUES (43952, '65.46.15615438709654863', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.110.86.162', '2019-06-26 18:11:11', 48, 2001001000, '服务端发生异常', '2019-06-26 18:11:11');
INSERT INTO `access_log` VALUES (43953, '65.45.15615520776734915', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:27:58', 0, 1002001015, '账号未登陆', '2019-06-26 20:27:58');
INSERT INTO `access_log` VALUES (43954, '65.52.15615520776734931', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:27:58', 0, 1002001015, '账号未登陆', '2019-06-26 20:27:58');
INSERT INTO `access_log` VALUES (43955, '65.53.15615520776744923', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:27:58', 0, 1002001015, '账号未登陆', '2019-06-26 20:27:58');
INSERT INTO `access_log` VALUES (43956, '65.49.15615520807274927', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:28:01', 100, 0, '', '2019-06-26 20:28:01');
INSERT INTO `access_log` VALUES (43957, '65.54.15615520810954867', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:28:01', 10, 0, '', '2019-06-26 20:28:01');
INSERT INTO `access_log` VALUES (43958, '65.51.15615520810964959', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:28:01', 10, 0, '', '2019-06-26 20:28:01');
INSERT INTO `access_log` VALUES (43959, '65.3607.15615520810976703', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:28:01', 11, 0, '', '2019-06-26 20:28:01');
INSERT INTO `access_log` VALUES (43960, '64.85.15615520858023823', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:28:06', 23, 0, '', '2019-06-26 20:28:06');
INSERT INTO `access_log` VALUES (43961, '65.46.15615521061024975', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:28:26', 4, 0, '', '2019-06-26 20:28:26');
INSERT INTO `access_log` VALUES (43962, '64.81.15615521147523805', 1, 2, 'product-application', '/product-api/admins/category/add', 'name=订单系统设计&pid=579&sort=5&description=sss&picUrl=http://static.shop.iocoder.cn/3fd98e94-ad50-415a-8f17-8bd8a998e508', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:28:35', 129, 0, '', '2019-06-26 20:28:35');
INSERT INTO `access_log` VALUES (43963, '64.83.15615521151053801', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:28:35', 11, 0, '', '2019-06-26 20:28:35');
INSERT INTO `access_log` VALUES (43964, '65.45.15615521443584917', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.91.60.104', '2019-06-26 20:29:04', 0, 1002001015, '账号未登陆', '2019-06-26 20:29:04');
INSERT INTO `access_log` VALUES (43965, '65.49.15615521485944929', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.89.239.230', '2019-06-26 20:29:09', 1, 1002001015, '账号未登陆', '2019-06-26 20:29:09');
INSERT INTO `access_log` VALUES (43966, '64.79.15615521560453815', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '180.97.118.219', '2019-06-26 20:29:16', 0, 1002001015, '账号未登陆', '2019-06-26 20:29:16');
INSERT INTO `access_log` VALUES (43967, '65.51.15615521623754961', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:29:22', 3, 0, '', '2019-06-26 20:29:22');
INSERT INTO `access_log` VALUES (43968, '65.47.15615521703034901', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.91.60.110', '2019-06-26 20:29:30', 1, 0, '', '2019-06-26 20:29:30');
INSERT INTO `access_log` VALUES (43969, '65.47.15615526104174907', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:36:50', 10, 0, '', '2019-06-26 20:36:50');
INSERT INTO `access_log` VALUES (43970, '65.50.15615526104194941', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:36:50', 9, 0, '', '2019-06-26 20:36:50');
INSERT INTO `access_log` VALUES (43971, '65.46.15615526104454983', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:36:50', 9, 0, '', '2019-06-26 20:36:50');
INSERT INTO `access_log` VALUES (43972, '64.78.15615526105113819', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:36:51', 12, 0, '', '2019-06-26 20:36:51');
INSERT INTO `access_log` VALUES (43973, '64.82.15615526791633825', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.147', '2019-06-26 20:37:59', 1, 1002001015, '账号未登陆', '2019-06-26 20:37:59');
INSERT INTO `access_log` VALUES (43974, '62.80.15615533536603307', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 20:49:14', 109, 0, '', '2019-06-26 20:49:14');
INSERT INTO `access_log` VALUES (43975, '62.85.15615534209653291', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.91.60.107', '2019-06-26 20:50:21', 1, 1002001015, '账号未登陆', '2019-06-26 20:50:21');
INSERT INTO `access_log` VALUES (43976, '59.77.15615534707743759', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.127.148.18', '2019-06-26 20:51:11', 11, 0, '', '2019-06-26 20:51:11');
INSERT INTO `access_log` VALUES (43977, '59.74.15615534707743771', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.127.148.18', '2019-06-26 20:51:11', 16, 2001001000, '服务端发生异常', '2019-06-26 20:51:11');
INSERT INTO `access_log` VALUES (43978, '65.45.15615535308184937', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.127.148.18', '2019-06-26 20:52:11', 4, 1002001012, '访问令牌已过期', '2019-06-26 20:52:11');
INSERT INTO `access_log` VALUES (43979, '65.49.15615535308214949', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.127.148.18', '2019-06-26 20:52:11', 3, 1002001012, '访问令牌已过期', '2019-06-26 20:52:11');
INSERT INTO `access_log` VALUES (43980, '65.54.15615535308264889', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.127.148.18', '2019-06-26 20:52:11', 3, 1002001012, '访问令牌已过期', '2019-06-26 20:52:11');
INSERT INTO `access_log` VALUES (43981, '65.51.15615535413034981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.127.148.18', '2019-06-26 20:52:21', 90, 0, '', '2019-06-26 20:52:21');
INSERT INTO `access_log` VALUES (43982, '65.3607.15615535416646725', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.127.148.18', '2019-06-26 20:52:22', 10, 0, '', '2019-06-26 20:52:22');
INSERT INTO `access_log` VALUES (43983, '65.50.15615535416684955', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.127.148.18', '2019-06-26 20:52:22', 20, 2001001000, '服务端发生异常', '2019-06-26 20:52:22');
INSERT INTO `access_log` VALUES (43984, '65.47.15615535416734921', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.127.148.18', '2019-06-26 20:52:22', 18, 0, '', '2019-06-26 20:52:22');
INSERT INTO `access_log` VALUES (43985, '65.52.15615544655594967', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.90.172.97', '2019-06-26 21:07:46', 4, 1002001012, '访问令牌已过期', '2019-06-26 21:07:46');
INSERT INTO `access_log` VALUES (43986, '65.49.15615544655604963', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.90.172.97', '2019-06-26 21:07:46', 4, 1002001012, '访问令牌已过期', '2019-06-26 21:07:46');
INSERT INTO `access_log` VALUES (43987, '65.45.15615544655744951', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.90.172.97', '2019-06-26 21:07:46', 3, 1002001012, '访问令牌已过期', '2019-06-26 21:07:46');
INSERT INTO `access_log` VALUES (43988, '65.51.15615544807304995', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.90.172.97', '2019-06-26 21:08:01', 288, 0, '', '2019-06-26 21:08:01');
INSERT INTO `access_log` VALUES (43989, '65.3607.15615544813446739', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.90.172.97', '2019-06-26 21:08:01', 10, 0, '', '2019-06-26 21:08:01');
INSERT INTO `access_log` VALUES (43990, '65.50.15615544813514969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.90.172.97', '2019-06-26 21:08:01', 9, 2001001000, '服务端发生异常', '2019-06-26 21:08:01');
INSERT INTO `access_log` VALUES (43991, '65.47.15615544813574935', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.90.172.97', '2019-06-26 21:08:01', 8, 0, '', '2019-06-26 21:08:01');
INSERT INTO `access_log` VALUES (43992, '64.77.15615546481013839', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 21:10:48', 24, 0, '', '2019-06-26 21:10:48');
INSERT INTO `access_log` VALUES (43993, '64.79.15615546481053849', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-26 21:10:48', 19, 0, '', '2019-06-26 21:10:48');
INSERT INTO `access_log` VALUES (43994, '64.83.15615547127573837', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.151.178.197', '2019-06-26 21:11:53', 1, 1002001015, '账号未登陆', '2019-06-26 21:11:53');
INSERT INTO `access_log` VALUES (43995, '59.75.15615589828493851', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.167.127.11', '2019-06-26 22:23:03', 11, 0, '', '2019-06-26 22:23:03');
INSERT INTO `access_log` VALUES (43996, '59.74.15615589828493845', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.167.127.11', '2019-06-26 22:23:03', 16, 2001001000, '服务端发生异常', '2019-06-26 22:23:03');
INSERT INTO `access_log` VALUES (43997, '64.84.15615589852993895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.167.127.11', '2019-06-26 22:23:05', 13, 0, '', '2019-06-26 22:23:05');
INSERT INTO `access_log` VALUES (43998, '64.85.15615589857333917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.167.127.11', '2019-06-26 22:23:06', 4, 0, '', '2019-06-26 22:23:06');
INSERT INTO `access_log` VALUES (43999, '64.76.15615589875573889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.167.127.11', '2019-06-26 22:23:08', 2, 0, '', '2019-06-26 22:23:08');
INSERT INTO `access_log` VALUES (44000, '64.81.15615589876593899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.167.127.11', '2019-06-26 22:23:08', 2, 0, '', '2019-06-26 22:23:08');
INSERT INTO `access_log` VALUES (44001, '59.80.15615589900333835', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.167.127.11', '2019-06-26 22:23:10', 5, 0, '', '2019-06-26 22:23:10');
INSERT INTO `access_log` VALUES (44002, '59.73.15615589900343853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.167.127.11', '2019-06-26 22:23:10', 14, 2001001000, '服务端发生异常', '2019-06-26 22:23:10');
INSERT INTO `access_log` VALUES (44003, '64.83.15615589979853895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.167.127.11', '2019-06-26 22:23:18', 2, 0, '', '2019-06-26 22:23:18');
INSERT INTO `access_log` VALUES (44004, '64.82.15615589980733911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.167.127.11', '2019-06-26 22:23:18', 2, 0, '', '2019-06-26 22:23:18');
INSERT INTO `access_log` VALUES (44005, '59.78.15615589986353843', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.167.127.11', '2019-06-26 22:23:19', 2, 0, '', '2019-06-26 22:23:19');
INSERT INTO `access_log` VALUES (44006, '59.79.15615589986353853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.167.127.11', '2019-06-26 22:23:19', 12, 2001001000, '服务端发生异常', '2019-06-26 22:23:19');
INSERT INTO `access_log` VALUES (44007, '65.3607.15615604375796819', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.78.102', '2019-06-26 22:47:18', 0, 1002001015, '账号未登陆', '2019-06-26 22:47:18');
INSERT INTO `access_log` VALUES (44008, '65.47.15615604375805015', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.78.102', '2019-06-26 22:47:18', 1, 1002001015, '账号未登陆', '2019-06-26 22:47:18');
INSERT INTO `access_log` VALUES (44009, '65.50.15615604375995049', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.78.102', '2019-06-26 22:47:18', 0, 1002001015, '账号未登陆', '2019-06-26 22:47:18');
INSERT INTO `access_log` VALUES (44010, '65.46.15615604400345091', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.78.102', '2019-06-26 22:47:20', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-26 22:47:20');
INSERT INTO `access_log` VALUES (44011, '65.49.15615604583525045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.78.102', '2019-06-26 22:47:38', 168, 0, '', '2019-06-26 22:47:39');
INSERT INTO `access_log` VALUES (44012, '65.52.15615604587185049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.78.102', '2019-06-26 22:47:39', 12, 0, '', '2019-06-26 22:47:39');
INSERT INTO `access_log` VALUES (44013, '65.54.15615604587224985', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.78.102', '2019-06-26 22:47:39', 10, 0, '', '2019-06-26 22:47:39');
INSERT INTO `access_log` VALUES (44014, '65.45.15615604587215033', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '125.120.78.102', '2019-06-26 22:47:39', 10, 2001001000, '服务端发生异常', '2019-06-26 22:47:39');
INSERT INTO `access_log` VALUES (44015, '59.77.15615865204404201', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '125.237.38.46', '2019-06-27 06:02:00', 12, 0, '', '2019-06-27 06:02:00');
INSERT INTO `access_log` VALUES (44016, '59.80.15615865204514203', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '125.237.38.46', '2019-06-27 06:02:00', 12, 2001001000, '服务端发生异常', '2019-06-27 06:02:00');
INSERT INTO `access_log` VALUES (44017, '59.76.15615976741764357', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '61.183.152.196', '2019-06-27 09:07:54', 10, 0, '', '2019-06-27 09:07:54');
INSERT INTO `access_log` VALUES (44018, '59.71.15615976741774365', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '61.183.152.196', '2019-06-27 09:07:54', 15, 2001001000, '服务端发生异常', '2019-06-27 09:07:54');
INSERT INTO `access_log` VALUES (44019, '64.80.15615976967734419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '61.183.152.196', '2019-06-27 09:08:17', 10, 0, '', '2019-06-27 09:08:17');
INSERT INTO `access_log` VALUES (44020, '64.79.15615976968934425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '61.183.152.196', '2019-06-27 09:08:17', 3, 0, '', '2019-06-27 09:08:17');
INSERT INTO `access_log` VALUES (44021, '59.80.15615976993754353', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '61.183.152.196', '2019-06-27 09:08:19', 3, 0, '', '2019-06-27 09:08:19');
INSERT INTO `access_log` VALUES (44022, '59.77.15615976993764351', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '61.183.152.196', '2019-06-27 09:08:19', 18, 2001001000, '服务端发生异常', '2019-06-27 09:08:19');
INSERT INTO `access_log` VALUES (44023, '59.73.15615977048194371', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '61.183.152.196', '2019-06-27 09:08:25', 3, 0, '', '2019-06-27 09:08:25');
INSERT INTO `access_log` VALUES (44024, '59.78.15615977048194361', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '61.183.152.196', '2019-06-27 09:08:25', 13, 2001001000, '服务端发生异常', '2019-06-27 09:08:25');
INSERT INTO `access_log` VALUES (44025, '64.84.15615978684114415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '61.183.152.196', '2019-06-27 09:11:08', 2, 0, '', '2019-06-27 09:11:08');
INSERT INTO `access_log` VALUES (44026, '64.85.15615978684934437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '61.183.152.196', '2019-06-27 09:11:08', 2, 0, '', '2019-06-27 09:11:08');
INSERT INTO `access_log` VALUES (44027, '59.74.15615979347714367', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.119.122.61', '2019-06-27 09:12:15', 3, 0, '', '2019-06-27 09:12:15');
INSERT INTO `access_log` VALUES (44028, '59.77.15615979347724355', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.119.122.61', '2019-06-27 09:12:15', 13, 2001001000, '服务端发生异常', '2019-06-27 09:12:15');
INSERT INTO `access_log` VALUES (44029, '59.79.15615988781364387', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '183.62.236.90', '2019-06-27 09:27:58', 3, 0, '', '2019-06-27 09:27:58');
INSERT INTO `access_log` VALUES (44030, '59.72.15615988781374379', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '183.62.236.90', '2019-06-27 09:27:58', 13, 2001001000, '服务端发生异常', '2019-06-27 09:27:58');
INSERT INTO `access_log` VALUES (44031, '64.78.15615988828984439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '183.62.236.90', '2019-06-27 09:28:03', 94, 0, '', '2019-06-27 09:28:03');
INSERT INTO `access_log` VALUES (44032, '64.84.15615988832314429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '183.62.236.90', '2019-06-27 09:28:03', 1, 0, '', '2019-06-27 09:28:03');
INSERT INTO `access_log` VALUES (44033, '64.85.15615988846674451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '183.62.236.90', '2019-06-27 09:28:05', 2, 0, '', '2019-06-27 09:28:05');
INSERT INTO `access_log` VALUES (44034, '64.76.15615988852594423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '183.62.236.90', '2019-06-27 09:28:05', 2, 0, '', '2019-06-27 09:28:05');
INSERT INTO `access_log` VALUES (44035, '66.48.15615988887532601', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '183.62.236.90', '2019-06-27 09:28:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-06-27 09:28:09');
INSERT INTO `access_log` VALUES (44036, '59.72.15615996092994389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.156.214.231', '2019-06-27 09:40:09', 3, 0, '', '2019-06-27 09:40:09');
INSERT INTO `access_log` VALUES (44037, '59.71.15615996092994393', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.156.214.231', '2019-06-27 09:40:09', 13, 2001001000, '服务端发生异常', '2019-06-27 09:40:09');
INSERT INTO `access_log` VALUES (44038, '65.53.15616003444185575', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 09:52:24', 1, 1002001015, '账号未登陆', '2019-06-27 09:52:24');
INSERT INTO `access_log` VALUES (44039, '65.45.15616003444195567', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 09:52:24', 1, 1002001015, '账号未登陆', '2019-06-27 09:52:24');
INSERT INTO `access_log` VALUES (44040, '65.46.15616003444195625', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 09:52:24', 1, 1002001015, '账号未登陆', '2019-06-27 09:52:24');
INSERT INTO `access_log` VALUES (44041, '65.52.15616006511025587', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 09:57:31', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 09:57:31');
INSERT INTO `access_log` VALUES (44042, '65.47.15616007112935555', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 09:58:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 09:58:31');
INSERT INTO `access_log` VALUES (44043, '59.72.15616008035804405', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:00:04', 3, 0, '', '2019-06-27 10:00:04');
INSERT INTO `access_log` VALUES (44044, '59.76.15616008035814401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:00:04', 19, 2001001000, '服务端发生异常', '2019-06-27 10:00:04');
INSERT INTO `access_log` VALUES (44045, '59.74.15616008093954407', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:00:09', 2, 0, '', '2019-06-27 10:00:09');
INSERT INTO `access_log` VALUES (44046, '59.77.15616008093964395', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:00:09', 12, 2001001000, '服务端发生异常', '2019-06-27 10:00:09');
INSERT INTO `access_log` VALUES (44047, '64.76.15616008149284449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:00:15', 10, 0, '', '2019-06-27 10:00:15');
INSERT INTO `access_log` VALUES (44048, '64.81.15616008151634459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:00:15', 3, 0, '', '2019-06-27 10:00:15');
INSERT INTO `access_log` VALUES (44049, '64.83.15616008174354455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:00:17', 3, 0, '', '2019-06-27 10:00:17');
INSERT INTO `access_log` VALUES (44050, '64.82.15616008181754471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:00:18', 2, 0, '', '2019-06-27 10:00:18');
INSERT INTO `access_log` VALUES (44051, '64.80.15616008185614463', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:00:19', 2, 0, '', '2019-06-27 10:00:19');
INSERT INTO `access_log` VALUES (44052, '65.53.15616013145905589', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:35', 4, 1002001012, '访问令牌已过期', '2019-06-27 10:08:35');
INSERT INTO `access_log` VALUES (44053, '65.50.15616013145895595', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:35', 4, 1002001012, '访问令牌已过期', '2019-06-27 10:08:35');
INSERT INTO `access_log` VALUES (44054, '65.46.15616013145975639', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:35', 3, 1002001012, '访问令牌已过期', '2019-06-27 10:08:35');
INSERT INTO `access_log` VALUES (44055, '65.45.15616013178205581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:38', 54, 0, '', '2019-06-27 10:08:38');
INSERT INTO `access_log` VALUES (44056, '65.52.15616013181365597', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:38', 281, 0, '', '2019-06-27 10:08:38');
INSERT INTO `access_log` VALUES (44057, '65.49.15616013181465593', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:38', 273, 0, '', '2019-06-27 10:08:38');
INSERT INTO `access_log` VALUES (44058, '65.51.15616013181445623', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:38', 276, 2001001000, '服务端发生异常', '2019-06-27 10:08:38');
INSERT INTO `access_log` VALUES (44059, '65.47.15616013249525565', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:45', 9, 0, '', '2019-06-27 10:08:45');
INSERT INTO `access_log` VALUES (44060, '65.3607.15616013249527369', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:45', 10, 0, '', '2019-06-27 10:08:45');
INSERT INTO `access_log` VALUES (44061, '65.46.15616013249535641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:45', 10, 2001001000, '服务端发生异常', '2019-06-27 10:08:45');
INSERT INTO `access_log` VALUES (44062, '65.53.15616013262235591', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:46', 19, 0, '', '2019-06-27 10:08:46');
INSERT INTO `access_log` VALUES (44063, '65.50.15616013262255597', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:46', 19, 2001001000, '服务端发生异常', '2019-06-27 10:08:46');
INSERT INTO `access_log` VALUES (44064, '65.45.15616013262375583', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:46', 8, 0, '', '2019-06-27 10:08:46');
INSERT INTO `access_log` VALUES (44065, '65.51.15616013272275625', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:47', 11, 2001001000, '服务端发生异常', '2019-06-27 10:08:47');
INSERT INTO `access_log` VALUES (44066, '65.49.15616013272305595', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:47', 8, 0, '', '2019-06-27 10:08:47');
INSERT INTO `access_log` VALUES (44067, '65.52.15616013272305599', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.40.26.62', '2019-06-27 10:08:47', 9, 0, '', '2019-06-27 10:08:47');
INSERT INTO `access_log` VALUES (44068, '65.54.15616013337615535', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:08:54', 59, 0, '', '2019-06-27 10:08:54');
INSERT INTO `access_log` VALUES (44069, '65.47.15616013340325567', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:08:54', 9, 0, '', '2019-06-27 10:08:54');
INSERT INTO `access_log` VALUES (44070, '65.46.15616013340385643', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:08:54', 8, 2001001000, '服务端发生异常', '2019-06-27 10:08:54');
INSERT INTO `access_log` VALUES (44071, '65.53.15616013340425593', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:08:54', 8, 0, '', '2019-06-27 10:08:54');
INSERT INTO `access_log` VALUES (44072, '65.52.15616013952875601', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:09:55', 9, 0, '', '2019-06-27 10:09:55');
INSERT INTO `access_log` VALUES (44073, '65.54.15616013952895537', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:09:55', 10, 2001001000, '服务端发生异常', '2019-06-27 10:09:55');
INSERT INTO `access_log` VALUES (44074, '65.3607.15616013952927373', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.64.1.85', '2019-06-27 10:09:55', 9, 0, '', '2019-06-27 10:09:55');
INSERT INTO `access_log` VALUES (44075, '59.78.15616021692304423', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:22:49', 3, 0, '', '2019-06-27 10:22:49');
INSERT INTO `access_log` VALUES (44076, '59.73.15616021692294433', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:22:49', 13, 2001001000, '服务端发生异常', '2019-06-27 10:22:49');
INSERT INTO `access_log` VALUES (44077, '64.77.15616021743934477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:22:54', 3, 0, '', '2019-06-27 10:22:54');
INSERT INTO `access_log` VALUES (44078, '64.78.15616021745564485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:22:55', 2, 0, '', '2019-06-27 10:22:55');
INSERT INTO `access_log` VALUES (44079, '64.84.15616021759284475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:22:56', 2, 0, '', '2019-06-27 10:22:56');
INSERT INTO `access_log` VALUES (44080, '64.85.15616021766474497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:22:57', 2, 0, '', '2019-06-27 10:22:57');
INSERT INTO `access_log` VALUES (44081, '64.76.15616021772124469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:22:57', 2, 0, '', '2019-06-27 10:22:57');
INSERT INTO `access_log` VALUES (44082, '64.81.15616021775974479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:22:58', 2, 0, '', '2019-06-27 10:22:58');
INSERT INTO `access_log` VALUES (44083, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:22:59', 7, 0, '', '2019-06-27 10:22:59');
INSERT INTO `access_log` VALUES (44084, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:22:59', 5, 0, '', '2019-06-27 10:22:59');
INSERT INTO `access_log` VALUES (44085, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:22:59', 13, 0, '', '2019-06-27 10:22:59');
INSERT INTO `access_log` VALUES (44086, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:22:59', 10, 0, '', '2019-06-27 10:22:59');
INSERT INTO `access_log` VALUES (44087, '64.83.15616021807814475', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:23:01', 6, 0, '', '2019-06-27 10:23:01');
INSERT INTO `access_log` VALUES (44088, '64.79.15616022046964489', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:23:25', 6, 0, '', '2019-06-27 10:23:25');
INSERT INTO `access_log` VALUES (44089, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:23:26', 7, 0, '', '2019-06-27 10:23:26');
INSERT INTO `access_log` VALUES (44090, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:23:26', 10, 0, '', '2019-06-27 10:23:26');
INSERT INTO `access_log` VALUES (44091, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:23:26', 4, 0, '', '2019-06-27 10:23:26');
INSERT INTO `access_log` VALUES (44092, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:23:26', 10, 0, '', '2019-06-27 10:23:26');
INSERT INTO `access_log` VALUES (44093, '64.77.15616022077164479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:23:28', 2, 0, '', '2019-06-27 10:23:28');
INSERT INTO `access_log` VALUES (44094, '64.78.15616022079864487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:23:28', 2, 0, '', '2019-06-27 10:23:28');
INSERT INTO `access_log` VALUES (44095, '59.76.15616022117704421', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:23:32', 3, 0, '', '2019-06-27 10:23:32');
INSERT INTO `access_log` VALUES (44096, '59.72.15616022117744425', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:23:32', 12, 2001001000, '服务端发生异常', '2019-06-27 10:23:32');
INSERT INTO `access_log` VALUES (44097, '59.74.15616022160104427', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:23:36', 2, 0, '', '2019-06-27 10:23:36');
INSERT INTO `access_log` VALUES (44098, '59.77.15616022160104415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.133.170.253', '2019-06-27 10:23:36', 11, 2001001000, '服务端发生异常', '2019-06-27 10:23:36');
INSERT INTO `access_log` VALUES (44099, '65.49.15616024012765611', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.92.137.127', '2019-06-27 10:26:41', 1, 1002001015, '账号未登陆', '2019-06-27 10:26:41');
INSERT INTO `access_log` VALUES (44100, '65.45.15616024012755603', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.92.137.127', '2019-06-27 10:26:41', 0, 1002001015, '账号未登陆', '2019-06-27 10:26:41');
INSERT INTO `access_log` VALUES (44101, '65.51.15616024012985641', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.92.137.127', '2019-06-27 10:26:41', 0, 1002001015, '账号未登陆', '2019-06-27 10:26:41');
INSERT INTO `access_log` VALUES (44102, '65.52.15616024031415619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.92.137.127', '2019-06-27 10:26:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 10:26:43');
INSERT INTO `access_log` VALUES (44103, '65.3607.15616024175987391', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.92.137.127', '2019-06-27 10:26:58', 451, 0, '', '2019-06-27 10:26:58');
INSERT INTO `access_log` VALUES (44104, '65.53.15616024183345613', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.92.137.127', '2019-06-27 10:26:58', 8, 0, '', '2019-06-27 10:26:58');
INSERT INTO `access_log` VALUES (44105, '65.46.15616024183325659', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.92.137.127', '2019-06-27 10:26:58', 9, 0, '', '2019-06-27 10:26:58');
INSERT INTO `access_log` VALUES (44106, '65.47.15616024183335581', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.92.137.127', '2019-06-27 10:26:58', 9, 2001001000, '服务端发生异常', '2019-06-27 10:26:58');
INSERT INTO `access_log` VALUES (44107, '59.78.15616040522954449', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:54:12', 11, 0, '', '2019-06-27 10:54:12');
INSERT INTO `access_log` VALUES (44108, '59.79.15616040522954459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:54:12', 23, 2001001000, '服务端发生异常', '2019-06-27 10:54:12');
INSERT INTO `access_log` VALUES (44109, '64.83.15616040618904501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:54:22', 12, 0, '', '2019-06-27 10:54:22');
INSERT INTO `access_log` VALUES (44110, '64.82.15616040620034517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:54:22', 4, 0, '', '2019-06-27 10:54:22');
INSERT INTO `access_log` VALUES (44111, '64.80.15616040636084509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:54:24', 2, 0, '', '2019-06-27 10:54:24');
INSERT INTO `access_log` VALUES (44112, '64.79.15616040642844515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:54:24', 2, 0, '', '2019-06-27 10:54:24');
INSERT INTO `access_log` VALUES (44113, '66.53.15616040860672657', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18210087003&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:54:46', 21, 1001003000, '验证码不存在', '2019-06-27 10:54:46');
INSERT INTO `access_log` VALUES (44114, '65.51.15616040999655665', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:55:00', 4, 1002001012, '访问令牌已过期', '2019-06-27 10:55:00');
INSERT INTO `access_log` VALUES (44115, '65.45.15616040999655627', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:55:00', 3, 1002001012, '访问令牌已过期', '2019-06-27 10:55:00');
INSERT INTO `access_log` VALUES (44116, '65.52.15616040999705643', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:55:00', 3, 1002001012, '访问令牌已过期', '2019-06-27 10:55:00');
INSERT INTO `access_log` VALUES (44117, '65.54.15616041024975577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:55:02', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 10:55:03');
INSERT INTO `access_log` VALUES (44118, '65.53.15616041182545637', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:55:18', 130, 0, '', '2019-06-27 10:55:18');
INSERT INTO `access_log` VALUES (44119, '65.46.15616041186115683', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:55:19', 8, 0, '', '2019-06-27 10:55:19');
INSERT INTO `access_log` VALUES (44120, '65.47.15616041186105605', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:55:19', 10, 2001001000, '服务端发生异常', '2019-06-27 10:55:19');
INSERT INTO `access_log` VALUES (44121, '65.50.15616041186135641', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:55:19', 9, 0, '', '2019-06-27 10:55:19');
INSERT INTO `access_log` VALUES (44122, '65.52.15616041260005645', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:55:26', 11, 0, '', '2019-06-27 10:55:26');
INSERT INTO `access_log` VALUES (44123, '65.51.15616041260085667', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:55:26', 10, 2001001000, '服务端发生异常', '2019-06-27 10:55:26');
INSERT INTO `access_log` VALUES (44124, '65.45.15616041260085629', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.192.187.95', '2019-06-27 10:55:26', 14, 0, '', '2019-06-27 10:55:26');
INSERT INTO `access_log` VALUES (44125, '66.57.15616043783142667', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-27 10:59:38', 9, 0, '', '2019-06-27 10:59:38');
INSERT INTO `access_log` VALUES (44126, '66.50.15616043793752657', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-27 10:59:39', 8, 0, '', '2019-06-27 10:59:39');
INSERT INTO `access_log` VALUES (44127, '64.84.15616043840514507', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-27 10:59:44', 18, 0, '', '2019-06-27 10:59:44');
INSERT INTO `access_log` VALUES (44128, '66.55.15616044073082657', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-27 11:00:07', 8, 0, '', '2019-06-27 11:00:07');
INSERT INTO `access_log` VALUES (44129, '66.49.15616044329272669', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-27 11:00:33', 8, 0, '', '2019-06-27 11:00:33');
INSERT INTO `access_log` VALUES (44130, '66.48.15616044345262677', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-27 11:00:35', 7, 0, '', '2019-06-27 11:00:35');
INSERT INTO `access_log` VALUES (44131, '65.49.15616047403645647', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.164', '2019-06-27 11:05:40', 4, 1002001012, '访问令牌已过期', '2019-06-27 11:05:40');
INSERT INTO `access_log` VALUES (44132, '65.51.15616047403645677', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.164', '2019-06-27 11:05:40', 3, 1002001012, '访问令牌已过期', '2019-06-27 11:05:40');
INSERT INTO `access_log` VALUES (44133, '65.46.15616047403745693', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.164', '2019-06-27 11:05:40', 3, 1002001012, '访问令牌已过期', '2019-06-27 11:05:40');
INSERT INTO `access_log` VALUES (44134, '65.54.15616047610485589', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.164', '2019-06-27 11:06:01', 72, 0, '', '2019-06-27 11:06:01');
INSERT INTO `access_log` VALUES (44135, '65.53.15616047614495647', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.164', '2019-06-27 11:06:01', 582, 2001001000, '服务端发生异常', '2019-06-27 11:06:02');
INSERT INTO `access_log` VALUES (44136, '65.3607.15616047614377425', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.164', '2019-06-27 11:06:01', 596, 0, '', '2019-06-27 11:06:02');
INSERT INTO `access_log` VALUES (44137, '65.45.15616047614575639', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.164', '2019-06-27 11:06:01', 576, 0, '', '2019-06-27 11:06:02');
INSERT INTO `access_log` VALUES (44138, '59.78.15616049044784461', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.16.203.225', '2019-06-27 11:08:24', 13, 2001001000, '服务端发生异常', '2019-06-27 11:08:24');
INSERT INTO `access_log` VALUES (44139, '59.73.15616049044764471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.16.203.225', '2019-06-27 11:08:24', 67, 0, '', '2019-06-27 11:08:25');
INSERT INTO `access_log` VALUES (44140, '64.80.15616049106514521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.16.203.225', '2019-06-27 11:08:31', 2, 0, '', '2019-06-27 11:08:31');
INSERT INTO `access_log` VALUES (44141, '64.79.15616049107804527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.16.203.225', '2019-06-27 11:08:31', 2, 0, '', '2019-06-27 11:08:31');
INSERT INTO `access_log` VALUES (44142, '64.77.15616049125944517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.16.203.225', '2019-06-27 11:08:33', 2, 0, '', '2019-06-27 11:08:33');
INSERT INTO `access_log` VALUES (44143, '64.78.15616049137394525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.16.203.225', '2019-06-27 11:08:34', 2, 0, '', '2019-06-27 11:08:34');
INSERT INTO `access_log` VALUES (44144, '59.75.15616049562894471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.173.215.115', '2019-06-27 11:09:16', 3, 0, '', '2019-06-27 11:09:16');
INSERT INTO `access_log` VALUES (44145, '59.72.15616049562884463', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.173.215.115', '2019-06-27 11:09:16', 24, 2001001000, '服务端发生异常', '2019-06-27 11:09:16');
INSERT INTO `access_log` VALUES (44146, '64.83.15616049653024515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.173.215.115', '2019-06-27 11:09:25', 3, 0, '', '2019-06-27 11:09:25');
INSERT INTO `access_log` VALUES (44147, '64.82.15616049653904531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.173.215.115', '2019-06-27 11:09:25', 1, 0, '', '2019-06-27 11:09:25');
INSERT INTO `access_log` VALUES (44148, '64.80.15616049664584523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.173.215.115', '2019-06-27 11:09:26', 2, 0, '', '2019-06-27 11:09:26');
INSERT INTO `access_log` VALUES (44149, '64.79.15616049669354529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.173.215.115', '2019-06-27 11:09:27', 2, 0, '', '2019-06-27 11:09:27');
INSERT INTO `access_log` VALUES (44150, '64.77.15616049673964519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.173.215.115', '2019-06-27 11:09:27', 2, 0, '', '2019-06-27 11:09:27');
INSERT INTO `access_log` VALUES (44151, '64.78.15616049678294527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.173.215.115', '2019-06-27 11:09:28', 2, 0, '', '2019-06-27 11:09:28');
INSERT INTO `access_log` VALUES (44152, '64.84.15616049685324517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.173.215.115', '2019-06-27 11:09:29', 2, 0, '', '2019-06-27 11:09:29');
INSERT INTO `access_log` VALUES (44153, '64.85.15616049689584539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.173.215.115', '2019-06-27 11:09:29', 2, 0, '', '2019-06-27 11:09:29');
INSERT INTO `access_log` VALUES (44154, '65.47.15616052851605625', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.202.78.72', '2019-06-27 11:14:45', 1, 1002001015, '账号未登陆', '2019-06-27 11:14:45');
INSERT INTO `access_log` VALUES (44155, '65.50.15616052851605659', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.202.78.72', '2019-06-27 11:14:45', 1, 1002001015, '账号未登陆', '2019-06-27 11:14:45');
INSERT INTO `access_log` VALUES (44156, '65.45.15616052851595647', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.202.78.72', '2019-06-27 11:14:45', 1, 1002001015, '账号未登陆', '2019-06-27 11:14:45');
INSERT INTO `access_log` VALUES (44157, '65.46.15616052876635703', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.202.78.72', '2019-06-27 11:14:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 11:14:48');
INSERT INTO `access_log` VALUES (44158, '65.51.15616052966985687', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.202.78.72', '2019-06-27 11:14:57', 215, 0, '', '2019-06-27 11:14:57');
INSERT INTO `access_log` VALUES (44159, '65.3607.15616052975337435', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.202.78.72', '2019-06-27 11:14:58', 58, 0, '', '2019-06-27 11:14:58');
INSERT INTO `access_log` VALUES (44160, '65.54.15616052974885599', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.202.78.72', '2019-06-27 11:14:57', 101, 0, '', '2019-06-27 11:14:58');
INSERT INTO `access_log` VALUES (44161, '65.52.15616052974885665', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.202.78.72', '2019-06-27 11:14:57', 103, 2001001000, '服务端发生异常', '2019-06-27 11:14:58');
INSERT INTO `access_log` VALUES (44162, '65.50.15616059111885669', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '104.168.234.214', '2019-06-27 11:25:11', 0, 1002001015, '账号未登陆', '2019-06-27 11:25:11');
INSERT INTO `access_log` VALUES (44163, '65.47.15616059111875635', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '104.168.234.214', '2019-06-27 11:25:11', 0, 1002001015, '账号未登陆', '2019-06-27 11:25:11');
INSERT INTO `access_log` VALUES (44164, '65.45.15616059112095657', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '104.168.234.214', '2019-06-27 11:25:11', 0, 1002001015, '账号未登陆', '2019-06-27 11:25:11');
INSERT INTO `access_log` VALUES (44165, '65.46.15616059209685713', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '104.168.234.214', '2019-06-27 11:25:21', 66, 0, '', '2019-06-27 11:25:21');
INSERT INTO `access_log` VALUES (44166, '65.49.15616059221835665', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '104.168.234.214', '2019-06-27 11:25:22', 9, 0, '', '2019-06-27 11:25:22');
INSERT INTO `access_log` VALUES (44167, '65.51.15616059221895697', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '104.168.234.214', '2019-06-27 11:25:22', 9, 0, '', '2019-06-27 11:25:22');
INSERT INTO `access_log` VALUES (44168, '65.52.15616059222045675', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '104.168.234.214', '2019-06-27 11:25:22', 9, 2001001000, '服务端发生异常', '2019-06-27 11:25:22');
INSERT INTO `access_log` VALUES (44169, '65.54.15616060605925611', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.26.86.178', '2019-06-27 11:27:41', 1, 1002001015, '账号未登陆', '2019-06-27 11:27:41');
INSERT INTO `access_log` VALUES (44170, '65.3607.15616060605937447', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.26.86.178', '2019-06-27 11:27:41', 0, 1002001015, '账号未登陆', '2019-06-27 11:27:41');
INSERT INTO `access_log` VALUES (44171, '65.53.15616060605945669', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.26.86.178', '2019-06-27 11:27:41', 1, 1002001015, '账号未登陆', '2019-06-27 11:27:41');
INSERT INTO `access_log` VALUES (44172, '65.50.15616060633505673', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.26.86.178', '2019-06-27 11:27:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 11:27:43');
INSERT INTO `access_log` VALUES (44173, '65.47.15616060677365639', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.26.86.178', '2019-06-27 11:27:48', 73, 0, '', '2019-06-27 11:27:48');
INSERT INTO `access_log` VALUES (44174, '65.45.15616060680145661', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.26.86.178', '2019-06-27 11:27:48', 9, 0, '', '2019-06-27 11:27:48');
INSERT INTO `access_log` VALUES (44175, '65.46.15616060680165717', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.26.86.178', '2019-06-27 11:27:48', 9, 2001001000, '服务端发生异常', '2019-06-27 11:27:48');
INSERT INTO `access_log` VALUES (44176, '65.51.15616060680195701', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.26.86.178', '2019-06-27 11:27:48', 9, 0, '', '2019-06-27 11:27:48');
INSERT INTO `access_log` VALUES (44177, '59.76.15616143376364585', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.223.96.91', '2019-06-27 13:45:38', 19, 2001001000, '服务端发生异常', '2019-06-27 13:45:38');
INSERT INTO `access_log` VALUES (44178, '59.71.15616143376354593', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.223.96.91', '2019-06-27 13:45:38', 23, 0, '', '2019-06-27 13:45:38');
INSERT INTO `access_log` VALUES (44179, '59.74.15616163175294617', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.60.58.117', '2019-06-27 14:18:38', 11, 0, '', '2019-06-27 14:18:38');
INSERT INTO `access_log` VALUES (44180, '59.77.15616163176694605', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.60.58.117', '2019-06-27 14:18:38', 17, 2001001000, '服务端发生异常', '2019-06-27 14:18:38');
INSERT INTO `access_log` VALUES (44181, '65.53.15616164308775809', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.27.66.204', '2019-06-27 14:20:31', 4, 1002001012, '访问令牌已过期', '2019-06-27 14:20:31');
INSERT INTO `access_log` VALUES (44182, '65.3607.15616164308777587', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.27.66.204', '2019-06-27 14:20:31', 6, 1002001012, '访问令牌已过期', '2019-06-27 14:20:31');
INSERT INTO `access_log` VALUES (44183, '65.47.15616164308965779', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.27.66.204', '2019-06-27 14:20:31', 11, 1002001012, '访问令牌已过期', '2019-06-27 14:20:31');
INSERT INTO `access_log` VALUES (44184, '65.50.15616164341895813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.27.66.204', '2019-06-27 14:20:34', 66, 0, '', '2019-06-27 14:20:34');
INSERT INTO `access_log` VALUES (44185, '65.51.15616164344815841', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.27.66.204', '2019-06-27 14:20:34', 9, 0, '', '2019-06-27 14:20:34');
INSERT INTO `access_log` VALUES (44186, '65.46.15616164344825859', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.27.66.204', '2019-06-27 14:20:34', 11, 2001001000, '服务端发生异常', '2019-06-27 14:20:34');
INSERT INTO `access_log` VALUES (44187, '65.52.15616164344825819', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '36.27.66.204', '2019-06-27 14:20:34', 11, 0, '', '2019-06-27 14:20:34');
INSERT INTO `access_log` VALUES (44188, '59.77.15616167599484611', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:00', 4, 0, '', '2019-06-27 14:26:00');
INSERT INTO `access_log` VALUES (44189, '59.80.15616167599634613', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:00', 12, 2001001000, '服务端发生异常', '2019-06-27 14:26:00');
INSERT INTO `access_log` VALUES (44190, '64.77.15616167626844677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:03', 10, 0, '', '2019-06-27 14:26:03');
INSERT INTO `access_log` VALUES (44191, '64.78.15616167628074685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:03', 3, 0, '', '2019-06-27 14:26:03');
INSERT INTO `access_log` VALUES (44192, '64.84.15616167642464675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:04', 2, 0, '', '2019-06-27 14:26:04');
INSERT INTO `access_log` VALUES (44193, '64.76.15616167656784669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:06', 2, 0, '', '2019-06-27 14:26:06');
INSERT INTO `access_log` VALUES (44194, '64.81.15616167662514679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:06', 2, 0, '', '2019-06-27 14:26:06');
INSERT INTO `access_log` VALUES (44195, '64.83.15616167669474675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:07', 2, 0, '', '2019-06-27 14:26:07');
INSERT INTO `access_log` VALUES (44196, '59.73.15616167678354631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:08', 2, 0, '', '2019-06-27 14:26:08');
INSERT INTO `access_log` VALUES (44197, '59.79.15616167678524631', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:08', 11, 2001001000, '服务端发生异常', '2019-06-27 14:26:08');
INSERT INTO `access_log` VALUES (44198, '59.71.15616167725594627', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:13', 2, 0, '', '2019-06-27 14:26:13');
INSERT INTO `access_log` VALUES (44199, '59.76.15616167725664619', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:13', 13, 2001001000, '服务端发生异常', '2019-06-27 14:26:13');
INSERT INTO `access_log` VALUES (44200, '64.82.15616167743864691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:14', 2, 0, '', '2019-06-27 14:26:14');
INSERT INTO `access_log` VALUES (44201, '64.80.15616167748234683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:15', 2, 0, '', '2019-06-27 14:26:15');
INSERT INTO `access_log` VALUES (44202, '64.79.15616167763384689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:16', 2, 0, '', '2019-06-27 14:26:16');
INSERT INTO `access_log` VALUES (44203, '64.77.15616167770334679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:17', 2, 0, '', '2019-06-27 14:26:17');
INSERT INTO `access_log` VALUES (44204, '65.3607.15616167938797593', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:34', 0, 1002001015, '账号未登陆', '2019-06-27 14:26:34');
INSERT INTO `access_log` VALUES (44205, '65.47.15616167939055785', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:34', 1, 1002001015, '账号未登陆', '2019-06-27 14:26:34');
INSERT INTO `access_log` VALUES (44206, '65.50.15616167939165819', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:34', 0, 1002001015, '账号未登陆', '2019-06-27 14:26:34');
INSERT INTO `access_log` VALUES (44207, '65.46.15616167954595865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:35', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 14:26:35');
INSERT INTO `access_log` VALUES (44208, '65.51.15616167970625847', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:37', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 14:26:37');
INSERT INTO `access_log` VALUES (44209, '65.52.15616167986235825', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 14:26:39');
INSERT INTO `access_log` VALUES (44210, '59.74.15616168047864625', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:26:45', 3, 0, '', '2019-06-27 14:26:45');
INSERT INTO `access_log` VALUES (44211, '59.77.15616168047864613', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:26:45', 17, 2001001000, '服务端发生异常', '2019-06-27 14:26:45');
INSERT INTO `access_log` VALUES (44212, '64.85.15616168092324699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:26:49', 2, 0, '', '2019-06-27 14:26:49');
INSERT INTO `access_log` VALUES (44213, '64.76.15616168093494671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:26:49', 2, 0, '', '2019-06-27 14:26:49');
INSERT INTO `access_log` VALUES (44214, '64.81.15616168104984681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:26:50', 1, 0, '', '2019-06-27 14:26:51');
INSERT INTO `access_log` VALUES (44215, '64.82.15616168110984693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:26:51', 1, 0, '', '2019-06-27 14:26:51');
INSERT INTO `access_log` VALUES (44216, '64.80.15616168116404685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:26:52', 2, 0, '', '2019-06-27 14:26:52');
INSERT INTO `access_log` VALUES (44217, '59.78.15616168141294623', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:26:54', 3, 0, '', '2019-06-27 14:26:54');
INSERT INTO `access_log` VALUES (44218, '59.73.15616168141294633', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:26:54', 23, 2001001000, '服务端发生异常', '2019-06-27 14:26:54');
INSERT INTO `access_log` VALUES (44219, '65.54.15616168159025759', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:56', 78, 0, '', '2019-06-27 14:26:56');
INSERT INTO `access_log` VALUES (44220, '65.53.15616168163355817', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:56', 9, 0, '', '2019-06-27 14:26:56');
INSERT INTO `access_log` VALUES (44221, '65.3607.15616168163407595', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:56', 16, 2001001000, '服务端发生异常', '2019-06-27 14:26:56');
INSERT INTO `access_log` VALUES (44222, '65.50.15616168163775821', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '223.112.85.2', '2019-06-27 14:26:56', 11, 0, '', '2019-06-27 14:26:56');
INSERT INTO `access_log` VALUES (44223, '66.49.15616168292372835', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=12341234122', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:27:09', 74, 0, '', '2019-06-27 14:27:09');
INSERT INTO `access_log` VALUES (44224, '66.57.15616168336872835', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12341234122&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:27:14', 172, 0, '', '2019-06-27 14:27:14');
INSERT INTO `access_log` VALUES (44225, '59.74.15616168429254627', 142, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:27:23', 9, 0, '', '2019-06-27 14:27:23');
INSERT INTO `access_log` VALUES (44226, '59.72.15616168429204625', 142, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:27:23', 20, 2001001000, '服务端发生异常', '2019-06-27 14:27:23');
INSERT INTO `access_log` VALUES (44227, '66.56.15616168458372845', 142, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:27:26', 6, 0, '', '2019-06-27 14:27:26');
INSERT INTO `access_log` VALUES (44228, '66.52.15616168504602835', 142, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:27:30', 5, 0, '', '2019-06-27 14:27:30');
INSERT INTO `access_log` VALUES (44229, '59.80.15616168548484617', 142, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:27:35', 7, 0, '', '2019-06-27 14:27:35');
INSERT INTO `access_log` VALUES (44230, '59.78.15616168548484625', 142, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:27:35', 18, 2001001000, '服务端发生异常', '2019-06-27 14:27:35');
INSERT INTO `access_log` VALUES (44231, '64.84.15616168550654679', 142, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:27:35', 6, 0, '', '2019-06-27 14:27:35');
INSERT INTO `access_log` VALUES (44232, '59.73.15616168551964635', 142, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:27:35', 5, 0, '', '2019-06-27 14:27:35');
INSERT INTO `access_log` VALUES (44233, '59.79.15616168552184635', 142, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:27:35', 15, 2001001000, '服务端发生异常', '2019-06-27 14:27:35');
INSERT INTO `access_log` VALUES (44234, '64.76.15616168552314673', 142, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.17.157.169', '2019-06-27 14:27:35', 6, 0, '', '2019-06-27 14:27:35');
INSERT INTO `access_log` VALUES (44235, '59.79.15616185799074657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.152.51.208', '2019-06-27 14:56:20', 4, 0, '', '2019-06-27 14:56:20');
INSERT INTO `access_log` VALUES (44236, '59.73.15616185800664659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.152.51.208', '2019-06-27 14:56:20', 12, 2001001000, '服务端发生异常', '2019-06-27 14:56:20');
INSERT INTO `access_log` VALUES (44237, '65.53.15616186018975841', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.152.51.208', '2019-06-27 14:56:42', 0, 1002001015, '账号未登陆', '2019-06-27 14:56:42');
INSERT INTO `access_log` VALUES (44238, '65.47.15616186018975811', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.152.51.208', '2019-06-27 14:56:42', 0, 1002001015, '账号未登陆', '2019-06-27 14:56:42');
INSERT INTO `access_log` VALUES (44239, '65.46.15616186018995891', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.152.51.208', '2019-06-27 14:56:42', 0, 1002001015, '账号未登陆', '2019-06-27 14:56:42');
INSERT INTO `access_log` VALUES (44240, '65.51.15616186048425873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.152.51.208', '2019-06-27 14:56:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 14:56:45');
INSERT INTO `access_log` VALUES (44241, '65.49.15616186153195841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.152.51.208', '2019-06-27 14:56:55', 66, 0, '', '2019-06-27 14:56:55');
INSERT INTO `access_log` VALUES (44242, '65.45.15616186158435837', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.152.51.208', '2019-06-27 14:56:56', 10, 0, '', '2019-06-27 14:56:56');
INSERT INTO `access_log` VALUES (44243, '65.54.15616186158515785', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.152.51.208', '2019-06-27 14:56:56', 10, 2001001000, '服务端发生异常', '2019-06-27 14:56:56');
INSERT INTO `access_log` VALUES (44244, '65.3607.15616186158577621', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '110.152.51.208', '2019-06-27 14:56:56', 9, 0, '', '2019-06-27 14:56:56');
INSERT INTO `access_log` VALUES (44245, '65.46.15616198348015909', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:17:15', 1, 1002001015, '账号未登陆', '2019-06-27 15:17:15');
INSERT INTO `access_log` VALUES (44246, '65.47.15616198348015829', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:17:15', 1, 1002001015, '账号未登陆', '2019-06-27 15:17:15');
INSERT INTO `access_log` VALUES (44247, '65.53.15616198348455859', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:17:15', 0, 1002001015, '账号未登陆', '2019-06-27 15:17:15');
INSERT INTO `access_log` VALUES (44248, '65.52.15616198550275869', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:17:35', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 15:17:35');
INSERT INTO `access_log` VALUES (44249, '65.54.15616198708275803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:17:51', 115, 0, '', '2019-06-27 15:17:51');
INSERT INTO `access_log` VALUES (44250, '65.3607.15616198712537639', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:17:51', 135, 0, '', '2019-06-27 15:17:51');
INSERT INTO `access_log` VALUES (44251, '65.50.15616198712605865', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:17:51', 130, 0, '', '2019-06-27 15:17:51');
INSERT INTO `access_log` VALUES (44252, '65.45.15616198712605855', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:17:51', 131, 2001001000, '服务端发生异常', '2019-06-27 15:17:51');
INSERT INTO `access_log` VALUES (44253, '65.53.15616198963615861', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:18:16', 9, 0, '', '2019-06-27 15:18:16');
INSERT INTO `access_log` VALUES (44254, '65.51.15616198963615893', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:18:16', 10, 2001001000, '服务端发生异常', '2019-06-27 15:18:16');
INSERT INTO `access_log` VALUES (44255, '65.52.15616198963935871', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:18:16', 10, 0, '', '2019-06-27 15:18:16');
INSERT INTO `access_log` VALUES (44256, '65.49.15616199009925861', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:18:21', 9, 0, '', '2019-06-27 15:18:21');
INSERT INTO `access_log` VALUES (44257, '65.54.15616199009935805', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:18:21', 10, 2001001000, '服务端发生异常', '2019-06-27 15:18:21');
INSERT INTO `access_log` VALUES (44258, '65.3607.15616199009967641', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:18:21', 8, 0, '', '2019-06-27 15:18:21');
INSERT INTO `access_log` VALUES (44259, '65.50.15616199088565867', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:18:29', 9, 0, '', '2019-06-27 15:18:29');
INSERT INTO `access_log` VALUES (44260, '65.46.15616199088595913', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:18:29', 9, 2001001000, '服务端发生异常', '2019-06-27 15:18:29');
INSERT INTO `access_log` VALUES (44261, '65.47.15616199088615833', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:18:29', 9, 0, '', '2019-06-27 15:18:29');
INSERT INTO `access_log` VALUES (44262, '59.75.15616199364564677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:18:56', 3, 0, '', '2019-06-27 15:18:56');
INSERT INTO `access_log` VALUES (44263, '59.71.15616199364564673', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '118.186.228.195', '2019-06-27 15:18:56', 14, 2001001000, '服务端发生异常', '2019-06-27 15:18:56');
INSERT INTO `access_log` VALUES (44264, '59.74.15616229363344711', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:08:56', 10, 0, '', '2019-06-27 16:08:56');
INSERT INTO `access_log` VALUES (44265, '59.72.15616229363394709', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:08:56', 14, 2001001000, '服务端发生异常', '2019-06-27 16:08:56');
INSERT INTO `access_log` VALUES (44266, '64.85.15616229469544783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:07', 11, 0, '', '2019-06-27 16:09:07');
INSERT INTO `access_log` VALUES (44267, '64.76.15616229470844755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:07', 3, 0, '', '2019-06-27 16:09:07');
INSERT INTO `access_log` VALUES (44268, '64.83.15616229484014761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:08', 2, 0, '', '2019-06-27 16:09:08');
INSERT INTO `access_log` VALUES (44269, '64.81.15616229490104765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:09', 2, 0, '', '2019-06-27 16:09:09');
INSERT INTO `access_log` VALUES (44270, '64.82.15616229495604775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:10', 2, 0, '', '2019-06-27 16:09:10');
INSERT INTO `access_log` VALUES (44271, '64.80.15616229499054769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:10', 2, 0, '', '2019-06-27 16:09:10');
INSERT INTO `access_log` VALUES (44272, '59.78.15616229507494707', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:11', 3, 0, '', '2019-06-27 16:09:11');
INSERT INTO `access_log` VALUES (44273, '59.77.15616229507444699', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:11', 13, 2001001000, '服务端发生异常', '2019-06-27 16:09:11');
INSERT INTO `access_log` VALUES (44274, '59.79.15616229589174717', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:19', 2, 0, '', '2019-06-27 16:09:19');
INSERT INTO `access_log` VALUES (44275, '59.80.15616229589164701', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:19', 14, 2001001000, '服务端发生异常', '2019-06-27 16:09:19');
INSERT INTO `access_log` VALUES (44276, '59.71.15616229619464715', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:22', 3, 0, '', '2019-06-27 16:09:22');
INSERT INTO `access_log` VALUES (44277, '59.75.15616229619484719', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:22', 18, 2001001000, '服务端发生异常', '2019-06-27 16:09:22');
INSERT INTO `access_log` VALUES (44278, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=测试&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:45', 5, 0, '', '2019-06-27 16:09:45');
INSERT INTO `access_log` VALUES (44279, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=测试', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:45', 8, 0, '', '2019-06-27 16:09:45');
INSERT INTO `access_log` VALUES (44280, '64.78.15616229866354773', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.191.47.53', '2019-06-27 16:09:47', 8, 0, '', '2019-06-27 16:09:47');
INSERT INTO `access_log` VALUES (44281, '64.76.15616230169124757', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.58.160.155', '2019-06-27 16:10:17', 6, 0, '', '2019-06-27 16:10:17');
INSERT INTO `access_log` VALUES (44282, '65.51.15616236425125945', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.201.136', '2019-06-27 16:20:43', 0, 1002001015, '账号未登陆', '2019-06-27 16:20:43');
INSERT INTO `access_log` VALUES (44283, '65.47.15616236425115883', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.201.136', '2019-06-27 16:20:43', 0, 1002001015, '账号未登陆', '2019-06-27 16:20:43');
INSERT INTO `access_log` VALUES (44284, '65.53.15616236425135913', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.201.136', '2019-06-27 16:20:43', 0, 1002001015, '账号未登陆', '2019-06-27 16:20:43');
INSERT INTO `access_log` VALUES (44285, '65.52.15616236444565923', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.201.136', '2019-06-27 16:20:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 16:20:44');
INSERT INTO `access_log` VALUES (44286, '65.3607.15616236463277693', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.201.136', '2019-06-27 16:20:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 16:20:46');
INSERT INTO `access_log` VALUES (44287, '65.50.15616237092185919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.201.136', '2019-06-27 16:21:49', 92, 0, '', '2019-06-27 16:21:49');
INSERT INTO `access_log` VALUES (44288, '65.47.15616237096185885', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.201.136', '2019-06-27 16:21:50', 13, 0, '', '2019-06-27 16:21:50');
INSERT INTO `access_log` VALUES (44289, '65.51.15616237096235947', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.201.136', '2019-06-27 16:21:50', 11, 2001001000, '服务端发生异常', '2019-06-27 16:21:50');
INSERT INTO `access_log` VALUES (44290, '65.53.15616237096635915', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.201.136', '2019-06-27 16:21:50', 11, 0, '', '2019-06-27 16:21:50');
INSERT INTO `access_log` VALUES (44291, '65.54.15616237373015859', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.201.136', '2019-06-27 16:22:17', 10, 0, '', '2019-06-27 16:22:17');
INSERT INTO `access_log` VALUES (44292, '65.45.15616237373295911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.201.136', '2019-06-27 16:22:17', 9, 0, '', '2019-06-27 16:22:17');
INSERT INTO `access_log` VALUES (44293, '65.49.15616237373285915', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.201.136', '2019-06-27 16:22:17', 10, 2001001000, '服务端发生异常', '2019-06-27 16:22:17');
INSERT INTO `access_log` VALUES (44294, '65.50.15616238931365923', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.71.210.38', '2019-06-27 16:24:53', 1, 1002001015, '账号未登陆', '2019-06-27 16:24:53');
INSERT INTO `access_log` VALUES (44295, '65.46.15616238931355969', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.71.210.38', '2019-06-27 16:24:53', 0, 1002001015, '账号未登陆', '2019-06-27 16:24:53');
INSERT INTO `access_log` VALUES (44296, '65.47.15616238931405889', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.71.210.38', '2019-06-27 16:24:53', 0, 1002001015, '账号未登陆', '2019-06-27 16:24:53');
INSERT INTO `access_log` VALUES (44297, '65.53.15616238956515919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.71.210.38', '2019-06-27 16:24:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 16:24:56');
INSERT INTO `access_log` VALUES (44298, '65.52.15616238992695929', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.71.210.38', '2019-06-27 16:24:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 16:24:59');
INSERT INTO `access_log` VALUES (44299, '59.72.15616249329834737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:42:13', 11, 0, '', '2019-06-27 16:42:13');
INSERT INTO `access_log` VALUES (44300, '59.76.15616249329844733', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:42:13', 15, 2001001000, '服务端发生异常', '2019-06-27 16:42:13');
INSERT INTO `access_log` VALUES (44301, '65.3607.15616249464947713', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:42:26', 0, 1002001015, '账号未登陆', '2019-06-27 16:42:26');
INSERT INTO `access_log` VALUES (44302, '65.45.15616249464955929', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:42:26', 1, 1002001015, '账号未登陆', '2019-06-27 16:42:26');
INSERT INTO `access_log` VALUES (44303, '65.54.15616249465065877', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:42:27', 1, 1002001015, '账号未登陆', '2019-06-27 16:42:27');
INSERT INTO `access_log` VALUES (44304, '65.49.15616249577495933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:42:38', 67, 0, '', '2019-06-27 16:42:38');
INSERT INTO `access_log` VALUES (44305, '65.50.15616249580525939', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:42:38', 8, 0, '', '2019-06-27 16:42:38');
INSERT INTO `access_log` VALUES (44306, '65.47.15616249580575905', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:42:38', 9, 2001001000, '服务端发生异常', '2019-06-27 16:42:38');
INSERT INTO `access_log` VALUES (44307, '65.46.15616249580625985', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:42:38', 8, 0, '', '2019-06-27 16:42:38');
INSERT INTO `access_log` VALUES (44308, '65.52.15616249840675945', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:43:04', 9, 0, '', '2019-06-27 16:43:04');
INSERT INTO `access_log` VALUES (44309, '65.45.15616249840765931', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:43:04', 10, 0, '', '2019-06-27 16:43:04');
INSERT INTO `access_log` VALUES (44310, '65.3607.15616249840767715', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:43:04', 10, 2001001000, '服务端发生异常', '2019-06-27 16:43:04');
INSERT INTO `access_log` VALUES (44311, '65.54.15616249871515879', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:43:07', 8, 0, '', '2019-06-27 16:43:07');
INSERT INTO `access_log` VALUES (44312, '65.49.15616249871545935', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:43:07', 8, 2001001000, '服务端发生异常', '2019-06-27 16:43:07');
INSERT INTO `access_log` VALUES (44313, '65.50.15616249871565941', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:43:07', 7, 0, '', '2019-06-27 16:43:07');
INSERT INTO `access_log` VALUES (44314, '65.47.15616249901635907', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:43:10', 9, 0, '', '2019-06-27 16:43:10');
INSERT INTO `access_log` VALUES (44315, '65.51.15616249901635969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:43:10', 10, 2001001000, '服务端发生异常', '2019-06-27 16:43:10');
INSERT INTO `access_log` VALUES (44316, '65.53.15616249901655937', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:43:10', 9, 0, '', '2019-06-27 16:43:10');
INSERT INTO `access_log` VALUES (44317, '64.79.15616250249874803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:43:45', 10, 0, '', '2019-06-27 16:43:45');
INSERT INTO `access_log` VALUES (44318, '64.77.15616250251064793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:43:45', 3, 0, '', '2019-06-27 16:43:45');
INSERT INTO `access_log` VALUES (44319, '59.71.15616250275164743', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:43:48', 4, 0, '', '2019-06-27 16:43:48');
INSERT INTO `access_log` VALUES (44320, '59.74.15616250275274741', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:43:48', 13, 2001001000, '服务端发生异常', '2019-06-27 16:43:48');
INSERT INTO `access_log` VALUES (44321, '64.84.15616250356504791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:43:56', 2, 0, '', '2019-06-27 16:43:56');
INSERT INTO `access_log` VALUES (44322, '64.85.15616250357914813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:43:56', 2, 0, '', '2019-06-27 16:43:56');
INSERT INTO `access_log` VALUES (44323, '64.76.15616250372494785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:43:57', 2, 0, '', '2019-06-27 16:43:57');
INSERT INTO `access_log` VALUES (44324, '64.83.15616250381164791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:43:58', 2, 0, '', '2019-06-27 16:43:58');
INSERT INTO `access_log` VALUES (44325, '64.81.15616250427424795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:44:03', 2, 0, '', '2019-06-27 16:44:03');
INSERT INTO `access_log` VALUES (44326, '64.82.15616250428554805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:44:03', 1, 0, '', '2019-06-27 16:44:03');
INSERT INTO `access_log` VALUES (44327, '59.78.15616250470094737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:44:07', 4, 0, '', '2019-06-27 16:44:07');
INSERT INTO `access_log` VALUES (44328, '59.77.15616250470094729', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:44:07', 20, 2001001000, '服务端发生异常', '2019-06-27 16:44:07');
INSERT INTO `access_log` VALUES (44329, '64.79.15616250491774805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:44:09', 1, 0, '', '2019-06-27 16:44:09');
INSERT INTO `access_log` VALUES (44330, '64.77.15616250492864795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:44:09', 1, 0, '', '2019-06-27 16:44:09');
INSERT INTO `access_log` VALUES (44331, '64.78.15616250505724803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:44:11', 2, 0, '', '2019-06-27 16:44:11');
INSERT INTO `access_log` VALUES (44332, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:44:11', 7, 0, '', '2019-06-27 16:44:11');
INSERT INTO `access_log` VALUES (44333, '64.84.15616250514194793', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:44:11', 69, 0, '', '2019-06-27 16:44:11');
INSERT INTO `access_log` VALUES (44334, '64.85.15616250582224815', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:44:18', 7, 0, '', '2019-06-27 16:44:18');
INSERT INTO `access_log` VALUES (44335, '64.76.15616250591784787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:44:19', 2, 0, '', '2019-06-27 16:44:19');
INSERT INTO `access_log` VALUES (44336, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:44:19', 6, 0, '', '2019-06-27 16:44:19');
INSERT INTO `access_log` VALUES (44337, '64.81.15616250616134797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:44:22', 2, 0, '', '2019-06-27 16:44:22');
INSERT INTO `access_log` VALUES (44338, '64.82.15616250616984807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.227.82', '2019-06-27 16:44:22', 2, 0, '', '2019-06-27 16:44:22');
INSERT INTO `access_log` VALUES (44339, '65.47.15616252869825913', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.227.82', '2019-06-27 16:48:07', 1, 0, '', '2019-06-27 16:48:07');
INSERT INTO `access_log` VALUES (44340, '59.78.15616259093364749', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 16:58:29', 3, 0, '', '2019-06-27 16:58:29');
INSERT INTO `access_log` VALUES (44341, '59.76.15616259093354747', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 16:58:29', 13, 2001001000, '服务端发生异常', '2019-06-27 16:58:29');
INSERT INTO `access_log` VALUES (44342, '64.76.15616259153364799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 16:58:35', 3, 0, '', '2019-06-27 16:58:35');
INSERT INTO `access_log` VALUES (44343, '64.83.15616259154584805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 16:58:35', 2, 0, '', '2019-06-27 16:58:35');
INSERT INTO `access_log` VALUES (44344, '64.82.15616259169424819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 16:58:37', 2, 0, '', '2019-06-27 16:58:37');
INSERT INTO `access_log` VALUES (44345, '64.80.15616259174314813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 16:58:37', 1, 0, '', '2019-06-27 16:58:37');
INSERT INTO `access_log` VALUES (44346, '65.49.15616259243235951', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 16:58:44', 0, 1002001015, '账号未登陆', '2019-06-27 16:58:44');
INSERT INTO `access_log` VALUES (44347, '65.54.15616259243225895', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 16:58:44', 0, 1002001015, '账号未登陆', '2019-06-27 16:58:44');
INSERT INTO `access_log` VALUES (44348, '65.50.15616259243245955', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 16:58:44', 0, 1002001015, '账号未登陆', '2019-06-27 16:58:44');
INSERT INTO `access_log` VALUES (44349, '65.46.15616259267376001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 16:58:47', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 16:58:47');
INSERT INTO `access_log` VALUES (44350, '65.51.15616259369505981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 16:58:57', 97, 0, '', '2019-06-27 16:58:57');
INSERT INTO `access_log` VALUES (44351, '65.47.15616259373125923', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 16:58:57', 18, 0, '', '2019-06-27 16:58:57');
INSERT INTO `access_log` VALUES (44352, '65.3607.15616259373137733', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 16:58:57', 17, 0, '', '2019-06-27 16:58:57');
INSERT INTO `access_log` VALUES (44353, '65.45.15616259373175947', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 16:58:57', 17, 0, '', '2019-06-27 16:58:57');
INSERT INTO `access_log` VALUES (44354, '65.49.15616259889605953', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.236.126', '2019-06-27 16:59:49', 1, 1002001015, '账号未登陆', '2019-06-27 16:59:49');
INSERT INTO `access_log` VALUES (44355, '65.46.15616259889666003', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.236.126', '2019-06-27 16:59:49', 0, 1002001015, '账号未登陆', '2019-06-27 16:59:49');
INSERT INTO `access_log` VALUES (44356, '65.53.15616259889825951', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.236.126', '2019-06-27 16:59:49', 1, 1002001015, '账号未登陆', '2019-06-27 16:59:49');
INSERT INTO `access_log` VALUES (44357, '65.3607.15616259944017735', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.236.126', '2019-06-27 16:59:54', 66, 0, '', '2019-06-27 16:59:54');
INSERT INTO `access_log` VALUES (44358, '65.45.15616259947655949', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.236.126', '2019-06-27 16:59:55', 9, 0, '', '2019-06-27 16:59:55');
INSERT INTO `access_log` VALUES (44359, '65.47.15616259947675925', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.236.126', '2019-06-27 16:59:55', 9, 2001001000, '服务端发生异常', '2019-06-27 16:59:55');
INSERT INTO `access_log` VALUES (44360, '65.52.15616259947715965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.236.126', '2019-06-27 16:59:55', 7, 0, '', '2019-06-27 16:59:55');
INSERT INTO `access_log` VALUES (44361, '65.50.15616260064615959', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.236.126', '2019-06-27 17:00:06', 9, 0, '', '2019-06-27 17:00:06');
INSERT INTO `access_log` VALUES (44362, '65.54.15616260064675899', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.236.126', '2019-06-27 17:00:06', 10, 2001001000, '服务端发生异常', '2019-06-27 17:00:06');
INSERT INTO `access_log` VALUES (44363, '65.46.15616260064726005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.236.126', '2019-06-27 17:00:06', 19, 0, '', '2019-06-27 17:00:06');
INSERT INTO `access_log` VALUES (44364, '65.53.15616260119975953', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.236.126', '2019-06-27 17:00:12', 9, 0, '', '2019-06-27 17:00:12');
INSERT INTO `access_log` VALUES (44365, '65.51.15616260120045985', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.236.126', '2019-06-27 17:00:12', 10, 2001001000, '服务端发生异常', '2019-06-27 17:00:12');
INSERT INTO `access_log` VALUES (44366, '65.3607.15616260120097737', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.236.126', '2019-06-27 17:00:12', 8, 0, '', '2019-06-27 17:00:12');
INSERT INTO `access_log` VALUES (44367, '65.45.15616260288645951', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '116.25.236.126', '2019-06-27 17:00:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 17:00:29');
INSERT INTO `access_log` VALUES (44368, '62.89.15616269482984297', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:15:48', 31, 0, '', '2019-06-27 17:15:48');
INSERT INTO `access_log` VALUES (44369, '62.80.15616269602954289', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:16:00', 18, 0, '', '2019-06-27 17:16:00');
INSERT INTO `access_log` VALUES (44370, '64.77.15616269667124823', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:16:07', 21, 0, '', '2019-06-27 17:16:07');
INSERT INTO `access_log` VALUES (44371, '64.79.15616269667094833', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:16:07', 25, 0, '', '2019-06-27 17:16:07');
INSERT INTO `access_log` VALUES (44372, '64.78.15616269706974831', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:16:11', 24, 0, '', '2019-06-27 17:16:11');
INSERT INTO `access_log` VALUES (44373, '64.84.15616269707124821', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:16:11', 9, 0, '', '2019-06-27 17:16:11');
INSERT INTO `access_log` VALUES (44374, '64.85.15616269781444843', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:16:18', 11, 0, '', '2019-06-27 17:16:18');
INSERT INTO `access_log` VALUES (44375, '64.81.15616269813484825', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:16:21', 9, 0, '', '2019-06-27 17:16:21');
INSERT INTO `access_log` VALUES (44376, '64.83.15616269831464821', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:16:23', 1140, 0, '', '2019-06-27 17:16:24');
INSERT INTO `access_log` VALUES (44377, '64.80.15616269856394829', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:16:26', 201, 0, '', '2019-06-27 17:16:26');
INSERT INTO `access_log` VALUES (44378, '64.82.15616269856384835', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:16:26', 202, 0, '', '2019-06-27 17:16:26');
INSERT INTO `access_log` VALUES (44379, '64.79.15616269967754835', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:16:37', 9, 0, '', '2019-06-27 17:16:37');
INSERT INTO `access_log` VALUES (44380, '66.56.15616270174612981', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:16:57', 21, 0, '', '2019-06-27 17:16:57');
INSERT INTO `access_log` VALUES (44381, '59.71.15616270265864771', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:17:07', 21, 0, '', '2019-06-27 17:17:07');
INSERT INTO `access_log` VALUES (44382, '59.74.15616270371524769', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:17:17', 15, 2001001000, '服务端发生异常', '2019-06-27 17:17:17');
INSERT INTO `access_log` VALUES (44383, '59.78.15616270411054765', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:17:21', 16, 0, '', '2019-06-27 17:17:21');
INSERT INTO `access_log` VALUES (44384, '64.76.15616270455324817', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:17:26', 13, 0, '', '2019-06-27 17:17:26');
INSERT INTO `access_log` VALUES (44385, '64.82.15616270732504837', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:17:53', 166, 0, '', '2019-06-27 17:17:53');
INSERT INTO `access_log` VALUES (44386, '59.79.15616270760204775', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:17:56', 19, 0, '', '2019-06-27 17:17:56');
INSERT INTO `access_log` VALUES (44387, '59.73.15616270859984777', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:18:06', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-06-27 17:18:06');
INSERT INTO `access_log` VALUES (44388, '65.3607.15616270890137753', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:18:09', 27, 0, '', '2019-06-27 17:18:09');
INSERT INTO `access_log` VALUES (44389, '65.53.15616270922405969', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:18:12', 11, 0, '', '2019-06-27 17:18:12');
INSERT INTO `access_log` VALUES (44390, '65.51.15616271014216001', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:18:21', 25, 0, '', '2019-06-27 17:18:21');
INSERT INTO `access_log` VALUES (44391, '65.45.15616271097395965', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:18:30', 13, 0, '', '2019-06-27 17:18:30');
INSERT INTO `access_log` VALUES (44392, '65.52.15616271181365983', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:18:38', 9, 0, '', '2019-06-27 17:18:38');
INSERT INTO `access_log` VALUES (44393, '65.3607.15616271650517755', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-06-27 17:19:25', 14, 0, '', '2019-06-27 17:19:25');
INSERT INTO `access_log` VALUES (44394, '59.76.15616277727664773', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:29:33', 3, 0, '', '2019-06-27 17:29:33');
INSERT INTO `access_log` VALUES (44395, '59.77.15616277727674767', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:29:33', 10, 2001001000, '服务端发生异常', '2019-06-27 17:29:33');
INSERT INTO `access_log` VALUES (44396, '64.81.15616277761284837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:29:36', 3, 0, '', '2019-06-27 17:29:36');
INSERT INTO `access_log` VALUES (44397, '64.83.15616277762654833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:29:36', 2, 0, '', '2019-06-27 17:29:36');
INSERT INTO `access_log` VALUES (44398, '64.82.15616277772234847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:29:37', 2, 0, '', '2019-06-27 17:29:37');
INSERT INTO `access_log` VALUES (44399, '64.80.15616277777224841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:29:38', 1, 0, '', '2019-06-27 17:29:38');
INSERT INTO `access_log` VALUES (44400, '59.80.15616277791224769', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:29:39', 2, 0, '', '2019-06-27 17:29:39');
INSERT INTO `access_log` VALUES (44401, '59.73.15616277791234787', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:29:39', 11, 2001001000, '服务端发生异常', '2019-06-27 17:29:39');
INSERT INTO `access_log` VALUES (44402, '64.77.15616277808994837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:29:41', 2, 0, '', '2019-06-27 17:29:41');
INSERT INTO `access_log` VALUES (44403, '64.79.15616277810164847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:29:41', 1, 0, '', '2019-06-27 17:29:41');
INSERT INTO `access_log` VALUES (44404, '59.71.15616277829954783', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:29:43', 2, 0, '', '2019-06-27 17:29:43');
INSERT INTO `access_log` VALUES (44405, '59.75.15616277829954787', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:29:43', 19, 2001001000, '服务端发生异常', '2019-06-27 17:29:43');
INSERT INTO `access_log` VALUES (44406, '65.45.15616278126825975', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:30:13', 0, 1002001015, '账号未登陆', '2019-06-27 17:30:13');
INSERT INTO `access_log` VALUES (44407, '65.52.15616278126845993', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:30:13', 0, 1002001015, '账号未登陆', '2019-06-27 17:30:13');
INSERT INTO `access_log` VALUES (44408, '65.46.15616278126866033', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:30:13', 0, 1002001015, '账号未登陆', '2019-06-27 17:30:13');
INSERT INTO `access_log` VALUES (44409, '65.50.15616278217535985', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:30:22', 101, 0, '', '2019-06-27 17:30:22');
INSERT INTO `access_log` VALUES (44410, '65.49.15616278221495983', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:30:22', 14, 0, '', '2019-06-27 17:30:22');
INSERT INTO `access_log` VALUES (44411, '65.54.15616278221505927', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:30:22', 16, 2001001000, '服务端发生异常', '2019-06-27 17:30:22');
INSERT INTO `access_log` VALUES (44412, '65.3607.15616278221527765', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:30:22', 14, 0, '', '2019-06-27 17:30:22');
INSERT INTO `access_log` VALUES (44413, '59.71.15616279068834785', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:31:47', 3, 0, '', '2019-06-27 17:31:47');
INSERT INTO `access_log` VALUES (44414, '59.75.15616279068824789', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.187.234', '2019-06-27 17:31:47', 13, 2001001000, '服务端发生异常', '2019-06-27 17:31:47');
INSERT INTO `access_log` VALUES (44415, '65.50.15616292779066007', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-06-27 17:54:38', 1, 1002001015, '账号未登陆', '2019-06-27 17:54:38');
INSERT INTO `access_log` VALUES (44416, '65.49.15616292779066005', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-06-27 17:54:38', 0, 1002001015, '账号未登陆', '2019-06-27 17:54:38');
INSERT INTO `access_log` VALUES (44417, '65.53.15616292779096001', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-06-27 17:54:38', 0, 1002001015, '账号未登陆', '2019-06-27 17:54:38');
INSERT INTO `access_log` VALUES (44418, '65.45.15616292801465995', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-06-27 17:54:40', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 17:54:40');
INSERT INTO `access_log` VALUES (44419, '65.54.15616292853005947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-06-27 17:54:45', 126, 0, '', '2019-06-27 17:54:45');
INSERT INTO `access_log` VALUES (44420, '65.51.15616292856456035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-06-27 17:54:46', 9, 0, '', '2019-06-27 17:54:46');
INSERT INTO `access_log` VALUES (44421, '65.47.15616292856475975', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-06-27 17:54:46', 9, 2001001000, '服务端发生异常', '2019-06-27 17:54:46');
INSERT INTO `access_log` VALUES (44422, '65.46.15616292856496057', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-06-27 17:54:46', 8, 0, '', '2019-06-27 17:54:46');
INSERT INTO `access_log` VALUES (44423, '59.72.15616358637404887', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:44:24', 22, 0, '', '2019-06-27 19:44:24');
INSERT INTO `access_log` VALUES (44424, '59.78.15616358637404885', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:44:24', 21, 2001001000, '服务端发生异常', '2019-06-27 19:44:24');
INSERT INTO `access_log` VALUES (44425, '64.85.15616359123944965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:12', 11, 0, '', '2019-06-27 19:45:12');
INSERT INTO `access_log` VALUES (44426, '64.76.15616359126344937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:13', 3, 0, '', '2019-06-27 19:45:13');
INSERT INTO `access_log` VALUES (44427, '64.81.15616359140134947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:14', 1, 0, '', '2019-06-27 19:45:14');
INSERT INTO `access_log` VALUES (44428, '64.83.15616359145784943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:15', 2, 0, '', '2019-06-27 19:45:15');
INSERT INTO `access_log` VALUES (44429, '64.82.15616359153284957', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:15', 2, 0, '', '2019-06-27 19:45:15');
INSERT INTO `access_log` VALUES (44430, '64.80.15616359157114951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:16', 1, 0, '', '2019-06-27 19:45:16');
INSERT INTO `access_log` VALUES (44431, '59.80.15616359173024879', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:17', 3, 0, '', '2019-06-27 19:45:17');
INSERT INTO `access_log` VALUES (44432, '59.73.15616359173064897', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:17', 12, 2001001000, '服务端发生异常', '2019-06-27 19:45:17');
INSERT INTO `access_log` VALUES (44433, '64.77.15616359196014947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:20', 2, 0, '', '2019-06-27 19:45:20');
INSERT INTO `access_log` VALUES (44434, '64.79.15616359197754957', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:20', 2, 0, '', '2019-06-27 19:45:20');
INSERT INTO `access_log` VALUES (44435, '59.71.15616359213184893', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:21', 3, 0, '', '2019-06-27 19:45:21');
INSERT INTO `access_log` VALUES (44436, '59.74.15616359213224891', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:21', 14, 2001001000, '服务端发生异常', '2019-06-27 19:45:21');
INSERT INTO `access_log` VALUES (44437, '64.78.15616359231684955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:23', 2, 0, '', '2019-06-27 19:45:23');
INSERT INTO `access_log` VALUES (44438, '59.72.15616359232454889', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.129.6.159', '2019-06-27 19:45:23', 2, 0, '', '2019-06-27 19:45:23');
INSERT INTO `access_log` VALUES (44439, '64.85.15616359233484967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:23', 2, 0, '', '2019-06-27 19:45:23');
INSERT INTO `access_log` VALUES (44440, '59.78.15616359243854887', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:24', 2, 0, '', '2019-06-27 19:45:24');
INSERT INTO `access_log` VALUES (44441, '59.76.15616359243854885', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:24', 13, 2001001000, '服务端发生异常', '2019-06-27 19:45:24');
INSERT INTO `access_log` VALUES (44442, '59.77.15616359251214879', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.129.6.227', '2019-06-27 19:45:25', 17, 2001001000, '服务端发生异常', '2019-06-27 19:45:25');
INSERT INTO `access_log` VALUES (44443, '64.76.15616359271184939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:27', 1, 0, '', '2019-06-27 19:45:27');
INSERT INTO `access_log` VALUES (44444, '64.81.15616359272284949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:27', 2, 0, '', '2019-06-27 19:45:27');
INSERT INTO `access_log` VALUES (44445, '64.82.15616359405474959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:41', 2, 0, '', '2019-06-27 19:45:41');
INSERT INTO `access_log` VALUES (44446, '64.80.15616359406754953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:41', 2, 0, '', '2019-06-27 19:45:41');
INSERT INTO `access_log` VALUES (44447, '64.77.15616359503834949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:50', 2, 0, '', '2019-06-27 19:45:50');
INSERT INTO `access_log` VALUES (44448, '64.84.15616359505544947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:51', 2, 0, '', '2019-06-27 19:45:51');
INSERT INTO `access_log` VALUES (44449, '59.80.15616359512504881', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:51', 2, 0, '', '2019-06-27 19:45:51');
INSERT INTO `access_log` VALUES (44450, '59.75.15616359512544899', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:45:51', 12, 2001001000, '服务端发生异常', '2019-06-27 19:45:51');
INSERT INTO `access_log` VALUES (44451, '64.85.15616359721874969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.91.60.105', '2019-06-27 19:46:12', 1, 0, '', '2019-06-27 19:46:12');
INSERT INTO `access_log` VALUES (44452, '64.76.15616359723114941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '180.97.118.223', '2019-06-27 19:46:12', 1, 0, '', '2019-06-27 19:46:12');
INSERT INTO `access_log` VALUES (44453, '64.81.15616359741284951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.129.6.251', '2019-06-27 19:46:14', 2, 0, '', '2019-06-27 19:46:14');
INSERT INTO `access_log` VALUES (44454, '64.83.15616359741804947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.207.141', '2019-06-27 19:46:14', 1, 0, '', '2019-06-27 19:46:14');
INSERT INTO `access_log` VALUES (44455, '64.82.15616359753854961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.227.139.161', '2019-06-27 19:46:15', 2, 0, '', '2019-06-27 19:46:15');
INSERT INTO `access_log` VALUES (44456, '65.47.15616360044976065', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:46:44', 0, 1002001015, '账号未登陆', '2019-06-27 19:46:44');
INSERT INTO `access_log` VALUES (44457, '65.46.15616360045256147', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:46:45', 0, 1002001015, '账号未登陆', '2019-06-27 19:46:45');
INSERT INTO `access_log` VALUES (44458, '65.52.15616360045266105', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:46:45', 0, 1002001015, '账号未登陆', '2019-06-27 19:46:45');
INSERT INTO `access_log` VALUES (44459, '65.50.15616360104916099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:46:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 19:46:51');
INSERT INTO `access_log` VALUES (44460, '65.53.15616360227746093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:47:03', 79, 0, '', '2019-06-27 19:47:03');
INSERT INTO `access_log` VALUES (44461, '65.3607.15616360234377879', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:47:03', 12, 0, '', '2019-06-27 19:47:03');
INSERT INTO `access_log` VALUES (44462, '65.45.15616360234376087', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:47:03', 13, 2001001000, '服务端发生异常', '2019-06-27 19:47:03');
INSERT INTO `access_log` VALUES (44463, '65.54.15616360234446039', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.118', '2019-06-27 19:47:03', 9, 0, '', '2019-06-27 19:47:03');
INSERT INTO `access_log` VALUES (44464, '65.47.15616360642426067', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.89.239.216', '2019-06-27 19:47:44', 0, 1002001015, '账号未登陆', '2019-06-27 19:47:44');
INSERT INTO `access_log` VALUES (44465, '59.76.15616374806014907', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.113.43', '2019-06-27 20:11:21', 2, 0, '', '2019-06-27 20:11:21');
INSERT INTO `access_log` VALUES (44466, '59.72.15616374806004911', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.113.40', '2019-06-27 20:11:21', 13, 2001001000, '服务端发生异常', '2019-06-27 20:11:21');
INSERT INTO `access_log` VALUES (44467, '59.79.15616375154314919', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-27 20:11:55', 3, 0, '', '2019-06-27 20:11:55');
INSERT INTO `access_log` VALUES (44468, '59.73.15616375154344921', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-27 20:11:55', 12, 2001001000, '服务端发生异常', '2019-06-27 20:11:55');
INSERT INTO `access_log` VALUES (44469, '65.52.15616375256976127', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-27 20:12:06', 4, 1002001012, '访问令牌已过期', '2019-06-27 20:12:06');
INSERT INTO `access_log` VALUES (44470, '65.46.15616375256986169', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-27 20:12:06', 4, 1002001012, '访问令牌已过期', '2019-06-27 20:12:06');
INSERT INTO `access_log` VALUES (44471, '65.47.15616375257266087', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-27 20:12:06', 4, 1002001012, '访问令牌已过期', '2019-06-27 20:12:06');
INSERT INTO `access_log` VALUES (44472, '65.50.15616375274526121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-27 20:12:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 20:12:07');
INSERT INTO `access_log` VALUES (44473, '65.53.15616375400226115', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-27 20:12:20', 101, 0, '', '2019-06-27 20:12:20');
INSERT INTO `access_log` VALUES (44474, '65.3607.15616375403877901', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-27 20:12:20', 10, 0, '', '2019-06-27 20:12:20');
INSERT INTO `access_log` VALUES (44475, '65.54.15616375403916061', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-27 20:12:20', 9, 0, '', '2019-06-27 20:12:20');
INSERT INTO `access_log` VALUES (44476, '65.45.15616375403906109', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-27 20:12:20', 17, 2001001000, '服务端发生异常', '2019-06-27 20:12:20');
INSERT INTO `access_log` VALUES (44477, '65.47.15616375744696089', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-27 20:12:54', 9, 0, '', '2019-06-27 20:12:54');
INSERT INTO `access_log` VALUES (44478, '65.49.15616375744886121', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-27 20:12:54', 9, 0, '', '2019-06-27 20:12:54');
INSERT INTO `access_log` VALUES (44479, '65.50.15616375744886123', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '117.36.75.166', '2019-06-27 20:12:54', 19, 2001001000, '服务端发生异常', '2019-06-27 20:12:55');
INSERT INTO `access_log` VALUES (44480, '65.49.15616378433386125', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-27 20:17:23', 4, 1002001012, '访问令牌已过期', '2019-06-27 20:17:23');
INSERT INTO `access_log` VALUES (44481, '65.50.15616378433376127', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-27 20:17:23', 4, 1002001012, '访问令牌已过期', '2019-06-27 20:17:23');
INSERT INTO `access_log` VALUES (44482, '65.47.15616378433386093', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-27 20:17:23', 4, 1002001012, '访问令牌已过期', '2019-06-27 20:17:23');
INSERT INTO `access_log` VALUES (44483, '59.72.15616383239864923', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:25:24', 3, 0, '', '2019-06-27 20:25:24');
INSERT INTO `access_log` VALUES (44484, '59.76.15616383239934919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:25:24', 12, 2001001000, '服务端发生异常', '2019-06-27 20:25:24');
INSERT INTO `access_log` VALUES (44485, '65.51.15616383278696161', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:25:28', 0, 1002001015, '账号未登陆', '2019-06-27 20:25:28');
INSERT INTO `access_log` VALUES (44486, '65.3607.15616383278697913', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:25:28', 0, 1002001015, '账号未登陆', '2019-06-27 20:25:28');
INSERT INTO `access_log` VALUES (44487, '65.46.15616383278756183', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:25:28', 0, 1002001015, '账号未登陆', '2019-06-27 20:25:28');
INSERT INTO `access_log` VALUES (44488, '64.77.15616383948994983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:35', 13, 0, '', '2019-06-27 20:26:35');
INSERT INTO `access_log` VALUES (44489, '64.79.15616383950504993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:35', 4, 0, '', '2019-06-27 20:26:35');
INSERT INTO `access_log` VALUES (44490, '64.78.15616383962324991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:36', 2, 0, '', '2019-06-27 20:26:36');
INSERT INTO `access_log` VALUES (44491, '64.85.15616383969605003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:37', 2, 0, '', '2019-06-27 20:26:37');
INSERT INTO `access_log` VALUES (44492, '64.76.15616383974194975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:37', 2, 0, '', '2019-06-27 20:26:37');
INSERT INTO `access_log` VALUES (44493, '64.81.15616383979294985', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:38', 2, 0, '', '2019-06-27 20:26:38');
INSERT INTO `access_log` VALUES (44494, '59.75.15616383991054933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:39', 3, 0, '', '2019-06-27 20:26:39');
INSERT INTO `access_log` VALUES (44495, '59.71.15616383991574929', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:39', 9, 2001001000, '服务端发生异常', '2019-06-27 20:26:39');
INSERT INTO `access_log` VALUES (44496, '64.83.15616384021134981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:42', 2, 0, '', '2019-06-27 20:26:42');
INSERT INTO `access_log` VALUES (44497, '64.82.15616384023524995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:42', 2, 0, '', '2019-06-27 20:26:42');
INSERT INTO `access_log` VALUES (44498, '64.80.15616384047564989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:45', 2, 0, '', '2019-06-27 20:26:45');
INSERT INTO `access_log` VALUES (44499, '64.77.15616384053024985', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:45', 2, 0, '', '2019-06-27 20:26:45');
INSERT INTO `access_log` VALUES (44500, '64.79.15616384058204995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:46', 2, 0, '', '2019-06-27 20:26:46');
INSERT INTO `access_log` VALUES (44501, '66.57.15616384100653125', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空\n账号长度为 11 位\n手机号不能为空', '2019-06-27 20:26:50');
INSERT INTO `access_log` VALUES (44502, '64.78.15616384157914993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:56', 2, 0, '', '2019-06-27 20:26:56');
INSERT INTO `access_log` VALUES (44503, '64.85.15616384158955005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:56', 1, 0, '', '2019-06-27 20:26:56');
INSERT INTO `access_log` VALUES (44504, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=jkj&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:59', 5, 0, '', '2019-06-27 20:26:59');
INSERT INTO `access_log` VALUES (44505, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=jkj', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:26:59', 5, 0, '', '2019-06-27 20:26:59');
INSERT INTO `access_log` VALUES (44506, '64.76.15616384231354977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:27:03', 2, 0, '', '2019-06-27 20:27:03');
INSERT INTO `access_log` VALUES (44507, '64.81.15616384232784987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:27:03', 2, 0, '', '2019-06-27 20:27:03');
INSERT INTO `access_log` VALUES (44508, '59.72.15616384248664925', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:27:05', 3, 0, '', '2019-06-27 20:27:05');
INSERT INTO `access_log` VALUES (44509, '59.78.15616384248664923', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:27:05', 14, 2001001000, '服务端发生异常', '2019-06-27 20:27:05');
INSERT INTO `access_log` VALUES (44510, '65.51.15616384293476163', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:27:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 20:27:09');
INSERT INTO `access_log` VALUES (44511, '65.46.15616384533556185', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:27:33', 113, 0, '', '2019-06-27 20:27:33');
INSERT INTO `access_log` VALUES (44512, '65.49.15616384538476135', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:27:34', 9, 0, '', '2019-06-27 20:27:34');
INSERT INTO `access_log` VALUES (44513, '65.52.15616384538466143', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:27:34', 11, 2001001000, '服务端发生异常', '2019-06-27 20:27:34');
INSERT INTO `access_log` VALUES (44514, '65.50.15616384538806137', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.236.99', '2019-06-27 20:27:34', 10, 0, '', '2019-06-27 20:27:34');
INSERT INTO `access_log` VALUES (44515, '65.53.15616387693556135', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.223.19.138', '2019-06-27 20:32:49', 0, 1002001015, '账号未登陆', '2019-06-27 20:32:49');
INSERT INTO `access_log` VALUES (44516, '65.54.15616387693726081', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.223.19.138', '2019-06-27 20:32:49', 0, 1002001015, '账号未登陆', '2019-06-27 20:32:49');
INSERT INTO `access_log` VALUES (44517, '65.45.15616387693756129', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.223.19.138', '2019-06-27 20:32:49', 0, 1002001015, '账号未登陆', '2019-06-27 20:32:49');
INSERT INTO `access_log` VALUES (44518, '65.3607.15616387753687921', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.223.19.138', '2019-06-27 20:32:55', 72, 0, '', '2019-06-27 20:32:55');
INSERT INTO `access_log` VALUES (44519, '65.46.15616387759166191', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.223.19.138', '2019-06-27 20:32:56', 10, 0, '', '2019-06-27 20:32:56');
INSERT INTO `access_log` VALUES (44520, '65.49.15616387759216141', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.223.19.138', '2019-06-27 20:32:56', 10, 2001001000, '服务端发生异常', '2019-06-27 20:32:56');
INSERT INTO `access_log` VALUES (44521, '65.52.15616387759246149', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.223.19.138', '2019-06-27 20:32:56', 9, 0, '', '2019-06-27 20:32:56');
INSERT INTO `access_log` VALUES (44522, '65.52.15616391882366155', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-27 20:39:48', 83, 0, '', '2019-06-27 20:39:48');
INSERT INTO `access_log` VALUES (44523, '65.46.15616391885826197', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-27 20:39:49', 10, 0, '', '2019-06-27 20:39:49');
INSERT INTO `access_log` VALUES (44524, '65.49.15616391885846147', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-27 20:39:49', 8, 0, '', '2019-06-27 20:39:49');
INSERT INTO `access_log` VALUES (44525, '65.50.15616391885906149', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.123.133.88', '2019-06-27 20:39:49', 9, 0, '', '2019-06-27 20:39:49');
INSERT INTO `access_log` VALUES (44526, '65.47.15616453232596197', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:03', 1, 1002001015, '账号未登陆', '2019-06-27 22:22:03');
INSERT INTO `access_log` VALUES (44527, '65.49.15616453232596229', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:03', 1, 1002001015, '账号未登陆', '2019-06-27 22:22:03');
INSERT INTO `access_log` VALUES (44528, '65.53.15616453232606225', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:03', 0, 1002001015, '账号未登陆', '2019-06-27 22:22:03');
INSERT INTO `access_log` VALUES (44529, '65.45.15616453305236219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yundaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:11', 99, 0, '', '2019-06-27 22:22:11');
INSERT INTO `access_log` VALUES (44530, '65.51.15616453309656259', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:11', 15, 0, '', '2019-06-27 22:22:11');
INSERT INTO `access_log` VALUES (44531, '65.3607.15616453309728011', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:11', 11, 0, '', '2019-06-27 22:22:11');
INSERT INTO `access_log` VALUES (44532, '65.52.15616453309756239', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:11', 10, 0, '', '2019-06-27 22:22:11');
INSERT INTO `access_log` VALUES (44533, '65.50.15616453366366233', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:17', 12, 0, '', '2019-06-27 22:22:17');
INSERT INTO `access_log` VALUES (44534, '65.46.15616453366416281', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:17', 11, 0, '', '2019-06-27 22:22:17');
INSERT INTO `access_log` VALUES (44535, '65.47.15616453366446199', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:17', 9, 0, '', '2019-06-27 22:22:17');
INSERT INTO `access_log` VALUES (44536, '65.53.15616453393836227', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:19', 9, 0, '', '2019-06-27 22:22:19');
INSERT INTO `access_log` VALUES (44537, '65.49.15616453393876231', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:19', 9, 0, '', '2019-06-27 22:22:19');
INSERT INTO `access_log` VALUES (44538, '65.54.15616453393936173', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:19', 9, 0, '', '2019-06-27 22:22:19');
INSERT INTO `access_log` VALUES (44539, '65.45.15616453424206221', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:22', 8, 0, '', '2019-06-27 22:22:22');
INSERT INTO `access_log` VALUES (44540, '65.3607.15616453424318013', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:22', 8, 0, '', '2019-06-27 22:22:22');
INSERT INTO `access_log` VALUES (44541, '65.51.15616453424366261', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:22', 8, 0, '', '2019-06-27 22:22:22');
INSERT INTO `access_log` VALUES (44542, '65.50.15616453470996235', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:27', 10, 0, '', '2019-06-27 22:22:27');
INSERT INTO `access_log` VALUES (44543, '65.46.15616453471076283', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:27', 9, 0, '', '2019-06-27 22:22:27');
INSERT INTO `access_log` VALUES (44544, '65.47.15616453471136201', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:27', 9, 0, '', '2019-06-27 22:22:27');
INSERT INTO `access_log` VALUES (44545, '62.80.15616453529064535', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:33', 22, 0, '', '2019-06-27 22:22:33');
INSERT INTO `access_log` VALUES (44546, '64.79.15616453579705089', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:38', 17, 0, '', '2019-06-27 22:22:38');
INSERT INTO `access_log` VALUES (44547, '64.77.15616453579655079', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:38', 24, 0, '', '2019-06-27 22:22:38');
INSERT INTO `access_log` VALUES (44548, '64.78.15616453682445087', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:48', 12, 0, '', '2019-06-27 22:22:48');
INSERT INTO `access_log` VALUES (44549, '64.84.15616453682425077', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:48', 14, 0, '', '2019-06-27 22:22:48');
INSERT INTO `access_log` VALUES (44550, '64.76.15616453755445071', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:22:56', 10, 0, '', '2019-06-27 22:22:56');
INSERT INTO `access_log` VALUES (44551, '64.83.15616453956675077', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:23:16', 12, 0, '', '2019-06-27 22:23:16');
INSERT INTO `access_log` VALUES (44552, '64.82.15616453956705091', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.185.134', '2019-06-27 22:23:16', 9, 0, '', '2019-06-27 22:23:16');
INSERT INTO `access_log` VALUES (44553, '65.47.15616460730016211', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.147.98.66', '2019-06-27 22:34:33', 0, 1002001015, '账号未登陆', '2019-06-27 22:34:33');
INSERT INTO `access_log` VALUES (44554, '65.46.15616460730046293', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.147.98.66', '2019-06-27 22:34:33', 0, 1002001015, '账号未登陆', '2019-06-27 22:34:33');
INSERT INTO `access_log` VALUES (44555, '65.49.15616460730146243', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.147.98.66', '2019-06-27 22:34:33', 1, 1002001015, '账号未登陆', '2019-06-27 22:34:33');
INSERT INTO `access_log` VALUES (44556, '65.45.15616461018206233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.147.98.66', '2019-06-27 22:35:02', 101, 0, '', '2019-06-27 22:35:02');
INSERT INTO `access_log` VALUES (44557, '65.51.15616461023376273', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.147.98.66', '2019-06-27 22:35:02', 74, 0, '', '2019-06-27 22:35:02');
INSERT INTO `access_log` VALUES (44558, '65.52.15616461023376253', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.147.98.66', '2019-06-27 22:35:02', 75, 0, '', '2019-06-27 22:35:02');
INSERT INTO `access_log` VALUES (44559, '65.3607.15616461023378025', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.147.98.66', '2019-06-27 22:35:02', 76, 2001001000, '服务端发生异常', '2019-06-27 22:35:02');
INSERT INTO `access_log` VALUES (44560, '65.49.15616461396286245', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.147.98.66', '2019-06-27 22:35:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-27 22:35:40');
INSERT INTO `access_log` VALUES (44561, '59.71.15616773585405449', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.215.93.142', '2019-06-28 07:15:59', 15, 0, '', '2019-06-28 07:15:59');
INSERT INTO `access_log` VALUES (44562, '59.74.15616773585475447', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.215.93.142', '2019-06-28 07:15:59', 25, 2001001000, '服务端发生异常', '2019-06-28 07:15:59');
INSERT INTO `access_log` VALUES (44563, '59.77.15616776806425439', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:21', 34, 2001001000, '服务端发生异常', '2019-06-28 07:21:21');
INSERT INTO `access_log` VALUES (44564, '59.72.15616776806405449', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:21', 56, 0, '', '2019-06-28 07:21:21');
INSERT INTO `access_log` VALUES (44565, '64.79.15616776836725523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:24', 12, 0, '', '2019-06-28 07:21:24');
INSERT INTO `access_log` VALUES (44566, '64.77.15616776838555513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:24', 4, 0, '', '2019-06-28 07:21:24');
INSERT INTO `access_log` VALUES (44567, '64.78.15616776850375521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:25', 3, 0, '', '2019-06-28 07:21:25');
INSERT INTO `access_log` VALUES (44568, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:25', 6, 0, '', '2019-06-28 07:21:25');
INSERT INTO `access_log` VALUES (44569, '64.84.15616776861215509', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:26', 8, 0, '', '2019-06-28 07:21:26');
INSERT INTO `access_log` VALUES (44570, '64.85.15616776901985531', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:30', 6, 0, '', '2019-06-28 07:21:30');
INSERT INTO `access_log` VALUES (44571, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:30', 6, 0, '', '2019-06-28 07:21:30');
INSERT INTO `access_log` VALUES (44572, '64.76.15616776906465505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:31', 2, 0, '', '2019-06-28 07:21:31');
INSERT INTO `access_log` VALUES (44573, '64.81.15616776906605513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:31', 2, 0, '', '2019-06-28 07:21:31');
INSERT INTO `access_log` VALUES (44574, '64.82.15616776907695523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:31', 2, 0, '', '2019-06-28 07:21:31');
INSERT INTO `access_log` VALUES (44575, '59.79.15616776916055457', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:32', 3, 0, '', '2019-06-28 07:21:32');
INSERT INTO `access_log` VALUES (44576, '59.73.15616776916105459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:32', 13, 2001001000, '服务端发生异常', '2019-06-28 07:21:32');
INSERT INTO `access_log` VALUES (44577, '65.3607.15616776970858447', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:37', 1, 1002001015, '账号未登陆', '2019-06-28 07:21:37');
INSERT INTO `access_log` VALUES (44578, '65.52.15616776970856675', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:37', 1, 1002001015, '账号未登陆', '2019-06-28 07:21:37');
INSERT INTO `access_log` VALUES (44579, '65.51.15616776970856695', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:37', 1, 1002001015, '账号未登陆', '2019-06-28 07:21:37');
INSERT INTO `access_log` VALUES (44580, '65.47.15616776993046635', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 07:21:39');
INSERT INTO `access_log` VALUES (44581, '65.46.15616777012536717', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 07:21:41');
INSERT INTO `access_log` VALUES (44582, '65.49.15616777031006667', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; EVR-AL00 Build/HUAWEIEVR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.64 HuaweiBrowser/9.1.2.312 Mobile Safari/537.36', '180.111.218.81', '2019-06-28 07:21:43', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 07:21:43');
INSERT INTO `access_log` VALUES (44583, '59.74.15616814780125503', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.230.207.197', '2019-06-28 08:24:38', 12, 0, '', '2019-06-28 08:24:38');
INSERT INTO `access_log` VALUES (44584, '59.76.15616814780205497', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.230.207.116', '2019-06-28 08:24:38', 23, 2001001000, '服务端发生异常', '2019-06-28 08:24:38');
INSERT INTO `access_log` VALUES (44585, '64.77.15616814817705565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.230.207.116', '2019-06-28 08:24:42', 11, 0, '', '2019-06-28 08:24:42');
INSERT INTO `access_log` VALUES (44586, '64.78.15616814819415573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.230.207.116', '2019-06-28 08:24:42', 3, 0, '', '2019-06-28 08:24:42');
INSERT INTO `access_log` VALUES (44587, '64.84.15616814851255561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.230.207.116', '2019-06-28 08:24:45', 3, 0, '', '2019-06-28 08:24:45');
INSERT INTO `access_log` VALUES (44588, '64.85.15616814852515583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.230.207.116', '2019-06-28 08:24:45', 3, 0, '', '2019-06-28 08:24:45');
INSERT INTO `access_log` VALUES (44589, '59.72.15616814977145501', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.197', '2019-06-28 08:24:58', 3, 0, '', '2019-06-28 08:24:58');
INSERT INTO `access_log` VALUES (44590, '59.77.15616814977195491', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:24:58', 10, 2001001000, '服务端发生异常', '2019-06-28 08:24:58');
INSERT INTO `access_log` VALUES (44591, '64.82.15616815074965575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:07', 2, 0, '', '2019-06-28 08:25:07');
INSERT INTO `access_log` VALUES (44592, '64.83.15616815076045561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:08', 2, 0, '', '2019-06-28 08:25:08');
INSERT INTO `access_log` VALUES (44593, '64.80.15616815091625571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:09', 2, 0, '', '2019-06-28 08:25:09');
INSERT INTO `access_log` VALUES (44594, '64.79.15616815099665577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:10', 2, 0, '', '2019-06-28 08:25:10');
INSERT INTO `access_log` VALUES (44595, '66.51.15616815250043711', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=111111111111&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:25', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-06-28 08:25:25');
INSERT INTO `access_log` VALUES (44596, '66.53.15616815458713695', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13855833793&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.197', '2019-06-28 08:25:46', 66, 1001003000, '验证码不存在', '2019-06-28 08:25:46');
INSERT INTO `access_log` VALUES (44597, '64.85.15616815506005585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.197', '2019-06-28 08:25:51', 2, 0, '', '2019-06-28 08:25:51');
INSERT INTO `access_log` VALUES (44598, '64.76.15616815506635559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.197', '2019-06-28 08:25:51', 2, 0, '', '2019-06-28 08:25:51');
INSERT INTO `access_log` VALUES (44599, '64.81.15616815523725567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:52', 2, 0, '', '2019-06-28 08:25:52');
INSERT INTO `access_log` VALUES (44600, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:52', 8, 0, '', '2019-06-28 08:25:52');
INSERT INTO `access_log` VALUES (44601, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:54', 5, 0, '', '2019-06-28 08:25:54');
INSERT INTO `access_log` VALUES (44602, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:55', 5, 0, '', '2019-06-28 08:25:55');
INSERT INTO `access_log` VALUES (44603, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:55', 6, 0, '', '2019-06-28 08:25:55');
INSERT INTO `access_log` VALUES (44604, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:56', 6, 0, '', '2019-06-28 08:25:56');
INSERT INTO `access_log` VALUES (44605, '64.82.15616815563265577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:56', 1, 0, '', '2019-06-28 08:25:56');
INSERT INTO `access_log` VALUES (44606, '64.83.15616815564185563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:56', 2, 0, '', '2019-06-28 08:25:56');
INSERT INTO `access_log` VALUES (44607, '64.80.15616815579715573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:58', 2, 0, '', '2019-06-28 08:25:58');
INSERT INTO `access_log` VALUES (44608, '64.79.15616815585585579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:59', 2, 0, '', '2019-06-28 08:25:59');
INSERT INTO `access_log` VALUES (44609, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:25:59', 6, 0, '', '2019-06-28 08:25:59');
INSERT INTO `access_log` VALUES (44610, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:26:00', 5, 0, '', '2019-06-28 08:26:00');
INSERT INTO `access_log` VALUES (44611, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:26:01', 6, 0, '', '2019-06-28 08:26:01');
INSERT INTO `access_log` VALUES (44612, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:26:01', 6, 0, '', '2019-06-28 08:26:01');
INSERT INTO `access_log` VALUES (44613, '64.78.15616815658455577', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.230.207.116', '2019-06-28 08:26:06', 7, 0, '', '2019-06-28 08:26:06');
INSERT INTO `access_log` VALUES (44614, '65.49.15616826235246733', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:43:44', 3, 1002001012, '访问令牌已过期', '2019-06-28 08:43:44');
INSERT INTO `access_log` VALUES (44615, '65.46.15616826235156783', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:43:44', 12, 1002001012, '访问令牌已过期', '2019-06-28 08:43:44');
INSERT INTO `access_log` VALUES (44616, '65.53.15616826235256729', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:43:44', 6, 1002001012, '访问令牌已过期', '2019-06-28 08:43:44');
INSERT INTO `access_log` VALUES (44617, '65.54.15616826253006675', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:43:45', 146, 0, '', '2019-06-28 08:43:45');
INSERT INTO `access_log` VALUES (44618, '65.45.15616826256306723', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:43:46', 10, 0, '', '2019-06-28 08:43:46');
INSERT INTO `access_log` VALUES (44619, '65.51.15616826256326763', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:43:46', 9, 0, '', '2019-06-28 08:43:46');
INSERT INTO `access_log` VALUES (44620, '65.52.15616826256326743', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:43:46', 10, 0, '', '2019-06-28 08:43:46');
INSERT INTO `access_log` VALUES (44621, '62.84.15616826296805011', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:43:50', 22, 0, '', '2019-06-28 08:43:50');
INSERT INTO `access_log` VALUES (44622, '64.76.15616826366785575', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:43:57', 19, 0, '', '2019-06-28 08:43:57');
INSERT INTO `access_log` VALUES (44623, '64.85.15616826366775601', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:43:57', 23, 0, '', '2019-06-28 08:43:57');
INSERT INTO `access_log` VALUES (44624, '64.80.15616826893675589', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:44:49', 14, 0, '', '2019-06-28 08:44:49');
INSERT INTO `access_log` VALUES (44625, '64.80.15616827993915591', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:46:39', 126, 0, '', '2019-06-28 08:46:40');
INSERT INTO `access_log` VALUES (44626, '64.83.15616827993895581', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:46:39', 131, 0, '', '2019-06-28 08:46:40');
INSERT INTO `access_log` VALUES (44627, '64.79.15616828046345597', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:46:45', 11, 0, '', '2019-06-28 08:46:45');
INSERT INTO `access_log` VALUES (44628, '64.77.15616828059415587', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:46:46', 10, 0, '', '2019-06-28 08:46:46');
INSERT INTO `access_log` VALUES (44629, '64.78.15616828086515595', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:46:49', 13, 0, '', '2019-06-28 08:46:49');
INSERT INTO `access_log` VALUES (44630, '65.45.15616830391336729', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:50:39', 10, 0, '', '2019-06-28 08:50:39');
INSERT INTO `access_log` VALUES (44631, '65.52.15616830391356749', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:50:39', 9, 0, '', '2019-06-28 08:50:39');
INSERT INTO `access_log` VALUES (44632, '65.3607.15616830391488521', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:50:39', 9, 0, '', '2019-06-28 08:50:39');
INSERT INTO `access_log` VALUES (44633, '64.79.15616830392275601', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:50:39', 10, 0, '', '2019-06-28 08:50:39');
INSERT INTO `access_log` VALUES (44634, '64.83.15616830392255585', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:50:39', 14, 0, '', '2019-06-28 08:50:39');
INSERT INTO `access_log` VALUES (44635, '64.78.15616830513795599', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:50:51', 10, 0, '', '2019-06-28 08:50:51');
INSERT INTO `access_log` VALUES (44636, '64.83.15616834261185591', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:57:06', 46, 0, '', '2019-06-28 08:57:06');
INSERT INTO `access_log` VALUES (44637, '64.79.15616834260995607', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:57:06', 68, 0, '', '2019-06-28 08:57:06');
INSERT INTO `access_log` VALUES (44638, '64.80.15616834260985601', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:57:06', 71, 0, '', '2019-06-28 08:57:06');
INSERT INTO `access_log` VALUES (44639, '64.77.15616834290495597', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:57:09', 8, 0, '', '2019-06-28 08:57:09');
INSERT INTO `access_log` VALUES (44640, '64.84.15616834332865593', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:57:13', 12, 0, '', '2019-06-28 08:57:13');
INSERT INTO `access_log` VALUES (44641, '64.78.15616834332855605', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 08:57:13', 14, 0, '', '2019-06-28 08:57:13');
INSERT INTO `access_log` VALUES (44642, '59.78.15616841470325535', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.35.114', '2019-06-28 09:09:07', 14, 0, '', '2019-06-28 09:09:07');
INSERT INTO `access_log` VALUES (44643, '59.77.15616841470325527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.35.114', '2019-06-28 09:09:07', 43, 2001001000, '服务端发生异常', '2019-06-28 09:09:07');
INSERT INTO `access_log` VALUES (44644, '64.84.15616841496305603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.35.114', '2019-06-28 09:09:10', 4, 0, '', '2019-06-28 09:09:10');
INSERT INTO `access_log` VALUES (44645, '64.78.15616841497665615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.35.114', '2019-06-28 09:09:10', 2, 0, '', '2019-06-28 09:09:10');
INSERT INTO `access_log` VALUES (44646, '64.85.15616841508755625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.35.114', '2019-06-28 09:09:11', 2, 0, '', '2019-06-28 09:09:11');
INSERT INTO `access_log` VALUES (44647, '64.76.15616841513155599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.35.114', '2019-06-28 09:09:11', 1, 0, '', '2019-06-28 09:09:11');
INSERT INTO `access_log` VALUES (44648, '64.81.15616841516915607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.35.114', '2019-06-28 09:09:12', 2, 0, '', '2019-06-28 09:09:12');
INSERT INTO `access_log` VALUES (44649, '59.72.15616841530565537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.35.114', '2019-06-28 09:09:13', 3, 0, '', '2019-06-28 09:09:13');
INSERT INTO `access_log` VALUES (44650, '59.73.15616841530575547', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.35.114', '2019-06-28 09:09:13', 13, 2001001000, '服务端发生异常', '2019-06-28 09:09:13');
INSERT INTO `access_log` VALUES (44651, '59.76.15616842127105535', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '58.247.206.156', '2019-06-28 09:10:13', 3, 0, '', '2019-06-28 09:10:13');
INSERT INTO `access_log` VALUES (44652, '64.77.15616842136325609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.89.19.197', '2019-06-28 09:10:14', 2, 0, '', '2019-06-28 09:10:14');
INSERT INTO `access_log` VALUES (44653, '66.54.15616842175933737', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15673316987&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.35.114', '2019-06-28 09:10:18', 41, 1001003000, '验证码不存在', '2019-06-28 09:10:18');
INSERT INTO `access_log` VALUES (44654, '59.77.15616842275045529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.35.114', '2019-06-28 09:10:28', 3, 0, '', '2019-06-28 09:10:28');
INSERT INTO `access_log` VALUES (44655, '59.78.15616842275095537', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '180.169.35.114', '2019-06-28 09:10:28', 32, 2001001000, '服务端发生异常', '2019-06-28 09:10:28');
INSERT INTO `access_log` VALUES (44656, '65.54.15616857047936719', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '59.63.204.196', '2019-06-28 09:35:05', 0, 1002001015, '账号未登陆', '2019-06-28 09:35:05');
INSERT INTO `access_log` VALUES (44657, '65.49.15616857047946777', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.238.194.162', '2019-06-28 09:35:05', 1, 1002001015, '账号未登陆', '2019-06-28 09:35:05');
INSERT INTO `access_log` VALUES (44658, '65.51.15616857048016807', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '36.102.223.20', '2019-06-28 09:35:05', 0, 1002001015, '账号未登陆', '2019-06-28 09:35:05');
INSERT INTO `access_log` VALUES (44659, '65.45.15616857167706765', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '36.102.223.20', '2019-06-28 09:35:17', 108, 0, '', '2019-06-28 09:35:17');
INSERT INTO `access_log` VALUES (44660, '65.50.15616857174096779', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.238.194.162', '2019-06-28 09:35:17', 11, 0, '', '2019-06-28 09:35:17');
INSERT INTO `access_log` VALUES (44661, '65.53.15616857174286775', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '36.102.223.20', '2019-06-28 09:35:17', 9, 0, '', '2019-06-28 09:35:17');
INSERT INTO `access_log` VALUES (44662, '65.47.15616857199716747', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '36.102.223.18', '2019-06-28 09:35:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 09:35:20');
INSERT INTO `access_log` VALUES (44663, '65.46.15616857296576827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '36.102.223.18', '2019-06-28 09:35:30', 103, 0, '', '2019-06-28 09:35:30');
INSERT INTO `access_log` VALUES (44664, '65.51.15616857301746809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '36.102.228.89', '2019-06-28 09:35:30', 10, 0, '', '2019-06-28 09:35:30');
INSERT INTO `access_log` VALUES (44665, '65.49.15616857301766779', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '36.102.223.18', '2019-06-28 09:35:30', 8, 0, '', '2019-06-28 09:35:30');
INSERT INTO `access_log` VALUES (44666, '65.54.15616857376396721', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.14.228', '2019-06-28 09:35:38', 0, 1002001015, '账号未登陆', '2019-06-28 09:35:38');
INSERT INTO `access_log` VALUES (44667, '65.3607.15616857376458559', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.14.228', '2019-06-28 09:35:38', 1, 1002001015, '账号未登陆', '2019-06-28 09:35:38');
INSERT INTO `access_log` VALUES (44668, '65.45.15616857376506767', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.14.228', '2019-06-28 09:35:38', 0, 1002001015, '账号未登陆', '2019-06-28 09:35:38');
INSERT INTO `access_log` VALUES (44669, '65.53.15616857394816777', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.14.228', '2019-06-28 09:35:39', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 09:35:39');
INSERT INTO `access_log` VALUES (44670, '59.79.15616857532325567', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '122.226.185.65', '2019-06-28 09:35:53', 3, 0, '', '2019-06-28 09:35:53');
INSERT INTO `access_log` VALUES (44671, '59.80.15616857532795551', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.228.89', '2019-06-28 09:35:53', 11, 2001001000, '服务端发生异常', '2019-06-28 09:35:53');
INSERT INTO `access_log` VALUES (44672, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.228.89', '2019-06-28 09:35:59', 8, 0, '', '2019-06-28 09:35:59');
INSERT INTO `access_log` VALUES (44673, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.228.89', '2019-06-28 09:35:59', 11, 0, '', '2019-06-28 09:35:59');
INSERT INTO `access_log` VALUES (44674, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '122.226.185.65', '2019-06-28 09:36:00', 5, 0, '', '2019-06-28 09:36:00');
INSERT INTO `access_log` VALUES (44675, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '122.226.185.65', '2019-06-28 09:36:00', 13, 0, '', '2019-06-28 09:36:00');
INSERT INTO `access_log` VALUES (44676, '64.81.15616857666555629', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '122.226.185.65', '2019-06-28 09:36:07', 7, 0, '', '2019-06-28 09:36:07');
INSERT INTO `access_log` VALUES (44677, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '122.226.185.65', '2019-06-28 09:36:15', 7, 0, '', '2019-06-28 09:36:15');
INSERT INTO `access_log` VALUES (44678, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '122.226.185.65', '2019-06-28 09:36:15', 13, 0, '', '2019-06-28 09:36:15');
INSERT INTO `access_log` VALUES (44679, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.228.89', '2019-06-28 09:36:15', 5, 0, '', '2019-06-28 09:36:15');
INSERT INTO `access_log` VALUES (44680, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.228.89', '2019-06-28 09:36:15', 11, 0, '', '2019-06-28 09:36:15');
INSERT INTO `access_log` VALUES (44681, '64.82.15616857772815639', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.228.89', '2019-06-28 09:36:17', 7, 0, '', '2019-06-28 09:36:17');
INSERT INTO `access_log` VALUES (44682, '65.46.15616857791356829', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.14.228', '2019-06-28 09:36:19', 122, 0, '', '2019-06-28 09:36:19');
INSERT INTO `access_log` VALUES (44683, '65.51.15616857796006811', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.14.228', '2019-06-28 09:36:20', 9, 0, '', '2019-06-28 09:36:20');
INSERT INTO `access_log` VALUES (44684, '65.49.15616857796046781', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.14.228', '2019-06-28 09:36:20', 10, 2001001000, '服务端发生异常', '2019-06-28 09:36:20');
INSERT INTO `access_log` VALUES (44685, '65.54.15616857796126723', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.14.228', '2019-06-28 09:36:20', 8, 0, '', '2019-06-28 09:36:20');
INSERT INTO `access_log` VALUES (44686, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.228.89', '2019-06-28 09:36:24', 8, 0, '', '2019-06-28 09:36:24');
INSERT INTO `access_log` VALUES (44687, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.228.89', '2019-06-28 09:36:24', 10, 0, '', '2019-06-28 09:36:24');
INSERT INTO `access_log` VALUES (44688, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '122.226.185.65', '2019-06-28 09:36:24', 5, 0, '', '2019-06-28 09:36:24');
INSERT INTO `access_log` VALUES (44689, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.228.89', '2019-06-28 09:36:24', 9, 0, '', '2019-06-28 09:36:24');
INSERT INTO `access_log` VALUES (44690, '64.80.15616857850675635', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '36.102.228.89', '2019-06-28 09:36:25', 6, 0, '', '2019-06-28 09:36:25');
INSERT INTO `access_log` VALUES (44691, '65.52.15616858579476791', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.14.228', '2019-06-28 09:37:38', 12, 0, '', '2019-06-28 09:37:38');
INSERT INTO `access_log` VALUES (44692, '65.46.15616858579506831', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.14.228', '2019-06-28 09:37:38', 10, 2001001000, '服务端发生异常', '2019-06-28 09:37:38');
INSERT INTO `access_log` VALUES (44693, '65.54.15616858579636725', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.14.228', '2019-06-28 09:37:38', 9, 0, '', '2019-06-28 09:37:38');
INSERT INTO `access_log` VALUES (44694, '65.45.15616863208706777', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 09:45:21', 0, 1002001015, '账号未登陆', '2019-06-28 09:45:21');
INSERT INTO `access_log` VALUES (44695, '65.51.15616863208696819', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 09:45:21', 0, 1002001015, '账号未登陆', '2019-06-28 09:45:21');
INSERT INTO `access_log` VALUES (44696, '65.3607.15616863208728569', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 09:45:21', 0, 1002001015, '账号未登陆', '2019-06-28 09:45:21');
INSERT INTO `access_log` VALUES (44697, '65.50.15616863224606791', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 09:45:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 09:45:22');
INSERT INTO `access_log` VALUES (44698, '65.52.15616863490756799', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 09:45:49', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 09:45:49');
INSERT INTO `access_log` VALUES (44699, '65.46.15616865140646841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '59.63.204.196', '2019-06-28 09:48:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 09:48:34');
INSERT INTO `access_log` VALUES (44700, '65.51.15616865267166823', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '59.63.204.196', '2019-06-28 09:48:47', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 09:48:47');
INSERT INTO `access_log` VALUES (44701, '59.79.15616867760175581', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.69.48.135', '2019-06-28 09:52:56', 3, 0, '', '2019-06-28 09:52:56');
INSERT INTO `access_log` VALUES (44702, '59.80.15616867760295565', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.69.48.135', '2019-06-28 09:52:56', 14, 2001001000, '服务端发生异常', '2019-06-28 09:52:56');
INSERT INTO `access_log` VALUES (44703, '65.49.15616867843226797', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.69.48.135', '2019-06-28 09:53:04', 0, 1002001015, '账号未登陆', '2019-06-28 09:53:04');
INSERT INTO `access_log` VALUES (44704, '65.46.15616867843226845', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.69.48.135', '2019-06-28 09:53:04', 0, 1002001015, '账号未登陆', '2019-06-28 09:53:04');
INSERT INTO `access_log` VALUES (44705, '65.51.15616867843256827', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.69.48.135', '2019-06-28 09:53:04', 0, 1002001015, '账号未登陆', '2019-06-28 09:53:04');
INSERT INTO `access_log` VALUES (44706, '65.3607.15616867946188577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.69.48.135', '2019-06-28 09:53:15', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 09:53:15');
INSERT INTO `access_log` VALUES (44707, '65.50.15616868036136799', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.69.48.135', '2019-06-28 09:53:24', 99, 0, '', '2019-06-28 09:53:24');
INSERT INTO `access_log` VALUES (44708, '65.53.15616868039076795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.69.48.135', '2019-06-28 09:53:24', 10, 0, '', '2019-06-28 09:53:24');
INSERT INTO `access_log` VALUES (44709, '65.52.15616868039116807', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.69.48.135', '2019-06-28 09:53:24', 8, 0, '', '2019-06-28 09:53:24');
INSERT INTO `access_log` VALUES (44710, '65.47.15616868039116767', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.69.48.135', '2019-06-28 09:53:24', 10, 2001001000, '服务端发生异常', '2019-06-28 09:53:24');
INSERT INTO `access_log` VALUES (44711, '59.72.15616871723905579', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 09:59:32', 3, 0, '', '2019-06-28 09:59:32');
INSERT INTO `access_log` VALUES (44712, '59.73.15616871723915589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 09:59:32', 13, 2001001000, '服务端发生异常', '2019-06-28 09:59:32');
INSERT INTO `access_log` VALUES (44713, '59.80.15616871766305571', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 09:59:37', 3, 0, '', '2019-06-28 09:59:37');
INSERT INTO `access_log` VALUES (44714, '59.75.15616871766305589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 09:59:37', 20, 2001001000, '服务端发生异常', '2019-06-28 09:59:37');
INSERT INTO `access_log` VALUES (44715, '64.78.15616871799665657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 09:59:40', 2, 0, '', '2019-06-28 09:59:40');
INSERT INTO `access_log` VALUES (44716, '64.85.15616871801055667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 09:59:40', 1, 0, '', '2019-06-28 09:59:40');
INSERT INTO `access_log` VALUES (44717, '64.76.15616871815395641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 09:59:42', 1, 0, '', '2019-06-28 09:59:42');
INSERT INTO `access_log` VALUES (44718, '64.81.15616871822455649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 09:59:42', 2, 0, '', '2019-06-28 09:59:42');
INSERT INTO `access_log` VALUES (44719, '59.71.15616871844395585', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 09:59:44', 2, 0, '', '2019-06-28 09:59:44');
INSERT INTO `access_log` VALUES (44720, '59.76.15616871844405577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 09:59:44', 17, 2001001000, '服务端发生异常', '2019-06-28 09:59:44');
INSERT INTO `access_log` VALUES (44721, '65.50.15616871970236805', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 09:59:57', 0, 1002001015, '账号未登陆', '2019-06-28 09:59:57');
INSERT INTO `access_log` VALUES (44722, '65.3607.15616871970278583', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 09:59:57', 0, 1002001015, '账号未登陆', '2019-06-28 09:59:57');
INSERT INTO `access_log` VALUES (44723, '65.54.15616871970336747', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 09:59:57', 0, 1002001015, '账号未登陆', '2019-06-28 09:59:57');
INSERT INTO `access_log` VALUES (44724, '65.47.15616871988026775', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 09:59:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 09:59:59');
INSERT INTO `access_log` VALUES (44725, '65.53.15616872048376801', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 10:00:05', 56, 0, '', '2019-06-28 10:00:05');
INSERT INTO `access_log` VALUES (44726, '65.52.15616872051586815', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 10:00:05', 8, 0, '', '2019-06-28 10:00:05');
INSERT INTO `access_log` VALUES (44727, '65.51.15616872051646837', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 10:00:05', 14, 2001001000, '服务端发生异常', '2019-06-28 10:00:05');
INSERT INTO `access_log` VALUES (44728, '65.46.15616872051696853', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.130.228.214', '2019-06-28 10:00:05', 14, 0, '', '2019-06-28 10:00:05');
INSERT INTO `access_log` VALUES (44729, '65.49.15616876490276813', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.247.102.61', '2019-06-28 10:07:29', 1, 1002001015, '账号未登陆', '2019-06-28 10:07:29');
INSERT INTO `access_log` VALUES (44730, '65.45.15616876490406801', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.247.102.61', '2019-06-28 10:07:29', 1, 1002001015, '账号未登陆', '2019-06-28 10:07:29');
INSERT INTO `access_log` VALUES (44731, '65.54.15616876490836755', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.247.102.61', '2019-06-28 10:07:29', 0, 1002001015, '账号未登陆', '2019-06-28 10:07:29');
INSERT INTO `access_log` VALUES (44732, '65.3607.15616876534128591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.247.102.61', '2019-06-28 10:07:33', 229, 0, '', '2019-06-28 10:07:34');
INSERT INTO `access_log` VALUES (44733, '65.50.15616876538826813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.247.102.61', '2019-06-28 10:07:34', 9, 0, '', '2019-06-28 10:07:34');
INSERT INTO `access_log` VALUES (44734, '65.47.15616876538866783', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.247.102.61', '2019-06-28 10:07:34', 10, 2001001000, '服务端发生异常', '2019-06-28 10:07:34');
INSERT INTO `access_log` VALUES (44735, '65.53.15616876538906809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.247.102.61', '2019-06-28 10:07:34', 9, 0, '', '2019-06-28 10:07:34');
INSERT INTO `access_log` VALUES (44736, '59.73.15616876691035597', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.247.102.61', '2019-06-28 10:07:49', 3, 0, '', '2019-06-28 10:07:49');
INSERT INTO `access_log` VALUES (44737, '59.72.15616876691045587', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.247.102.61', '2019-06-28 10:07:49', 13, 2001001000, '服务端发生异常', '2019-06-28 10:07:49');
INSERT INTO `access_log` VALUES (44738, '65.52.15616883192446833', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.20.55', '2019-06-28 10:18:39', 1, 0, '', '2019-06-28 10:18:39');
INSERT INTO `access_log` VALUES (44739, '65.51.15616883341736855', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.20.55', '2019-06-28 10:18:54', 5, 1002002001, '密码不正确', '2019-06-28 10:18:54');
INSERT INTO `access_log` VALUES (44740, '59.76.15616889287555601', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.191.185.242', '2019-06-28 10:28:49', 4, 0, '', '2019-06-28 10:28:49');
INSERT INTO `access_log` VALUES (44741, '59.71.15616889287565609', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.191.185.242', '2019-06-28 10:28:49', 12, 2001001000, '服务端发生异常', '2019-06-28 10:28:49');
INSERT INTO `access_log` VALUES (44742, '65.52.15616889404676841', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.191.185.242', '2019-06-28 10:29:00', 0, 1002001015, '账号未登陆', '2019-06-28 10:29:00');
INSERT INTO `access_log` VALUES (44743, '65.53.15616889404676827', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.191.185.242', '2019-06-28 10:29:00', 0, 1002001015, '账号未登陆', '2019-06-28 10:29:00');
INSERT INTO `access_log` VALUES (44744, '65.50.15616889404686835', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.191.185.242', '2019-06-28 10:29:00', 0, 1002001015, '账号未登陆', '2019-06-28 10:29:00');
INSERT INTO `access_log` VALUES (44745, '65.49.15616889472266837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.191.185.242', '2019-06-28 10:29:07', 624, 0, '', '2019-06-28 10:29:08');
INSERT INTO `access_log` VALUES (44746, '65.51.15616889480856863', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.191.185.242', '2019-06-28 10:29:08', 9, 0, '', '2019-06-28 10:29:08');
INSERT INTO `access_log` VALUES (44747, '65.45.15616889480896823', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.191.185.242', '2019-06-28 10:29:08', 9, 2001001000, '服务端发生异常', '2019-06-28 10:29:08');
INSERT INTO `access_log` VALUES (44748, '65.46.15616889480986883', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.191.185.242', '2019-06-28 10:29:08', 8, 0, '', '2019-06-28 10:29:08');
INSERT INTO `access_log` VALUES (44749, '65.49.15616892962136843', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 10:34:56', 89, 0, '', '2019-06-28 10:34:56');
INSERT INTO `access_log` VALUES (44750, '65.51.15616892964906869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 10:34:56', 10, 0, '', '2019-06-28 10:34:57');
INSERT INTO `access_log` VALUES (44751, '65.46.15616892964926889', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 10:34:56', 9, 2001001000, '服务端发生异常', '2019-06-28 10:34:57');
INSERT INTO `access_log` VALUES (44752, '65.45.15616892964926829', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 10:34:56', 9, 0, '', '2019-06-28 10:34:57');
INSERT INTO `access_log` VALUES (44753, '65.53.15616899765786843', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 10:46:17', 199, 0, '', '2019-06-28 10:46:17');
INSERT INTO `access_log` VALUES (44754, '65.52.15616899765806857', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 10:46:17', 198, 0, '', '2019-06-28 10:46:17');
INSERT INTO `access_log` VALUES (44755, '65.50.15616899765786853', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 10:46:17', 200, 2001001000, '服务端发生异常', '2019-06-28 10:46:17');
INSERT INTO `access_log` VALUES (44756, '65.45.15616900158276841', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 10:46:56', 8, 0, '', '2019-06-28 10:46:56');
INSERT INTO `access_log` VALUES (44757, '65.54.15616900158306795', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 10:46:56', 8, 0, '', '2019-06-28 10:46:56');
INSERT INTO `access_log` VALUES (44758, '65.47.15616900158296821', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 10:46:56', 9, 2001001000, '服务端发生异常', '2019-06-28 10:46:56');
INSERT INTO `access_log` VALUES (44759, '65.46.15616902547076905', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 10:50:55', 9, 0, '', '2019-06-28 10:50:55');
INSERT INTO `access_log` VALUES (44760, '65.47.15616902547086825', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 10:50:55', 10, 2001001000, '服务端发生异常', '2019-06-28 10:50:55');
INSERT INTO `access_log` VALUES (44761, '65.54.15616902547116799', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.74.41.1', '2019-06-28 10:50:55', 8, 0, '', '2019-06-28 10:50:55');
INSERT INTO `access_log` VALUES (44762, '59.76.15616913068005633', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.130.68', '2019-06-28 11:08:27', 10, 0, '', '2019-06-28 11:08:27');
INSERT INTO `access_log` VALUES (44763, '59.74.15616913068005639', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.130.68', '2019-06-28 11:08:27', 48, 2001001000, '服务端发生异常', '2019-06-28 11:08:27');
INSERT INTO `access_log` VALUES (44764, '64.78.15616913124385713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.130.68', '2019-06-28 11:08:32', 12, 0, '', '2019-06-28 11:08:32');
INSERT INTO `access_log` VALUES (44765, '64.79.15616913125465715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.130.68', '2019-06-28 11:08:33', 4, 0, '', '2019-06-28 11:08:33');
INSERT INTO `access_log` VALUES (44766, '65.45.15616923518796875', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:25:52', 0, 1002001015, '账号未登陆', '2019-06-28 11:25:52');
INSERT INTO `access_log` VALUES (44767, '65.52.15616923518816893', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:25:52', 1, 1002001015, '账号未登陆', '2019-06-28 11:25:52');
INSERT INTO `access_log` VALUES (44768, '65.53.15616923518966879', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:25:52', 1, 1002001015, '账号未登陆', '2019-06-28 11:25:52');
INSERT INTO `access_log` VALUES (44769, '65.50.15616923553796887', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:25:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 11:25:55');
INSERT INTO `access_log` VALUES (44770, '65.51.15616923609136915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:26:01', 91, 0, '', '2019-06-28 11:26:01');
INSERT INTO `access_log` VALUES (44771, '65.49.15616923612416889', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:26:01', 9, 0, '', '2019-06-28 11:26:01');
INSERT INTO `access_log` VALUES (44772, '65.46.15616923612456939', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:26:01', 9, 2001001000, '服务端发生异常', '2019-06-28 11:26:01');
INSERT INTO `access_log` VALUES (44773, '65.47.15616923612516857', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:26:01', 8, 0, '', '2019-06-28 11:26:01');
INSERT INTO `access_log` VALUES (44774, '59.80.15616925777325645', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-06-28 11:29:38', 5, 0, '', '2019-06-28 11:29:38');
INSERT INTO `access_log` VALUES (44775, '59.75.15616925777355663', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-06-28 11:29:38', 20, 2001001000, '服务端发生异常', '2019-06-28 11:29:38');
INSERT INTO `access_log` VALUES (44776, '65.46.15616925962646943', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-06-28 11:29:56', 0, 1002001015, '账号未登陆', '2019-06-28 11:29:56');
INSERT INTO `access_log` VALUES (44777, '65.47.15616925962646861', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-06-28 11:29:56', 0, 1002001015, '账号未登陆', '2019-06-28 11:29:56');
INSERT INTO `access_log` VALUES (44778, '65.54.15616925962686835', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-06-28 11:29:56', 0, 1002001015, '账号未登陆', '2019-06-28 11:29:56');
INSERT INTO `access_log` VALUES (44779, '65.53.15616925982446885', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-06-28 11:29:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 11:29:58');
INSERT INTO `access_log` VALUES (44780, '65.52.15616926056596899', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanam&password=yudaoyuanam&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-06-28 11:30:06', 5, 1002002000, '账号不存在', '2019-06-28 11:30:06');
INSERT INTO `access_log` VALUES (44781, '59.76.15616933468155661', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:42:27', 3, 0, '', '2019-06-28 11:42:27');
INSERT INTO `access_log` VALUES (44782, '59.74.15616933468165667', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:42:27', 13, 2001001000, '服务端发生异常', '2019-06-28 11:42:27');
INSERT INTO `access_log` VALUES (44783, '64.81.15616933498045731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:42:30', 11, 0, '', '2019-06-28 11:42:30');
INSERT INTO `access_log` VALUES (44784, '64.82.15616933499185741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:42:30', 3, 0, '', '2019-06-28 11:42:30');
INSERT INTO `access_log` VALUES (44785, '64.78.15616933516275741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:42:32', 1, 0, '', '2019-06-28 11:42:32');
INSERT INTO `access_log` VALUES (44786, '59.77.15616933529745655', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:42:33', 2, 0, '', '2019-06-28 11:42:33');
INSERT INTO `access_log` VALUES (44787, '59.78.15616933529755663', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '124.127.34.162', '2019-06-28 11:42:33', 12, 2001001000, '服务端发生异常', '2019-06-28 11:42:33');
INSERT INTO `access_log` VALUES (44788, '59.74.15616937490825673', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.245.58.88', '2019-06-28 11:49:09', 3, 0, '', '2019-06-28 11:49:09');
INSERT INTO `access_log` VALUES (44789, '59.77.15616937490835661', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.245.58.88', '2019-06-28 11:49:09', 15, 2001001000, '服务端发生异常', '2019-06-28 11:49:09');
INSERT INTO `access_log` VALUES (44790, '59.79.15616939420045681', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.212.178.95', '2019-06-28 11:52:22', 3, 0, '', '2019-06-28 11:52:22');
INSERT INTO `access_log` VALUES (44791, '59.80.15616939420155665', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.212.178.95', '2019-06-28 11:52:22', 11, 2001001000, '服务端发生异常', '2019-06-28 11:52:22');
INSERT INTO `access_log` VALUES (44792, '65.3607.15616939712698691', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.212.178.95', '2019-06-28 11:52:51', 0, 1002001015, '账号未登陆', '2019-06-28 11:52:51');
INSERT INTO `access_log` VALUES (44793, '65.50.15616939712696911', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.212.178.95', '2019-06-28 11:52:51', 0, 1002001015, '账号未登陆', '2019-06-28 11:52:51');
INSERT INTO `access_log` VALUES (44794, '65.51.15616939712716939', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.212.178.95', '2019-06-28 11:52:51', 0, 1002001015, '账号未登陆', '2019-06-28 11:52:51');
INSERT INTO `access_log` VALUES (44795, '65.49.15616939731006913', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.212.178.95', '2019-06-28 11:52:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 11:52:53');
INSERT INTO `access_log` VALUES (44796, '65.46.15616939944046963', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.212.178.95', '2019-06-28 11:53:14', 92, 0, '', '2019-06-28 11:53:14');
INSERT INTO `access_log` VALUES (44797, '65.53.15616939947726905', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.212.178.95', '2019-06-28 11:53:15', 10, 0, '', '2019-06-28 11:53:15');
INSERT INTO `access_log` VALUES (44798, '65.52.15616939947766919', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.212.178.95', '2019-06-28 11:53:15', 10, 2001001000, '服务端发生异常', '2019-06-28 11:53:15');
INSERT INTO `access_log` VALUES (44799, '65.45.15616939947796901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.212.178.95', '2019-06-28 11:53:15', 9, 0, '', '2019-06-28 11:53:15');
INSERT INTO `access_log` VALUES (44800, '65.51.15616949250656953', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-06-28 12:08:45', 0, 1002001015, '账号未登陆', '2019-06-28 12:08:45');
INSERT INTO `access_log` VALUES (44801, '65.49.15616949250766927', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-06-28 12:08:45', 0, 1002001015, '账号未登陆', '2019-06-28 12:08:45');
INSERT INTO `access_log` VALUES (44802, '65.47.15616949250776895', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-06-28 12:08:45', 1, 1002001015, '账号未登陆', '2019-06-28 12:08:45');
INSERT INTO `access_log` VALUES (44803, '65.46.15616949378926977', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-06-28 12:08:58', 132, 0, '', '2019-06-28 12:08:58');
INSERT INTO `access_log` VALUES (44804, '65.45.15616949383596915', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-06-28 12:08:58', 10, 0, '', '2019-06-28 12:08:58');
INSERT INTO `access_log` VALUES (44805, '65.52.15616949383616933', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-06-28 12:08:58', 10, 2001001000, '服务端发生异常', '2019-06-28 12:08:58');
INSERT INTO `access_log` VALUES (44806, '65.53.15616949383656919', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-06-28 12:08:58', 9, 0, '', '2019-06-28 12:08:58');
INSERT INTO `access_log` VALUES (44807, '59.72.15616949457325687', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; BND-AL10 Build/HONORBND-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '223.150.7.41', '2019-06-28 12:09:06', 3, 0, '', '2019-06-28 12:09:06');
INSERT INTO `access_log` VALUES (44808, '59.80.15616949457335679', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; BND-AL10 Build/HONORBND-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '223.150.7.41', '2019-06-28 12:09:06', 13, 2001001000, '服务端发生异常', '2019-06-28 12:09:06');
INSERT INTO `access_log` VALUES (44809, '64.81.15616949499235753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; BND-AL10 Build/HONORBND-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '223.150.7.41', '2019-06-28 12:09:10', 33, 0, '', '2019-06-28 12:09:10');
INSERT INTO `access_log` VALUES (44810, '64.82.15616949501775763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; BND-AL10 Build/HONORBND-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '223.150.7.41', '2019-06-28 12:09:10', 2, 0, '', '2019-06-28 12:09:10');
INSERT INTO `access_log` VALUES (44811, '64.78.15616949513475763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; BND-AL10 Build/HONORBND-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '223.150.7.41', '2019-06-28 12:09:11', 2, 0, '', '2019-06-28 12:09:11');
INSERT INTO `access_log` VALUES (44812, '64.79.15616949523065765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; BND-AL10 Build/HONORBND-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '223.150.7.41', '2019-06-28 12:09:12', 2, 0, '', '2019-06-28 12:09:12');
INSERT INTO `access_log` VALUES (44813, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; BND-AL10 Build/HONORBND-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '223.150.7.41', '2019-06-28 12:09:12', 8, 0, '', '2019-06-28 12:09:12');
INSERT INTO `access_log` VALUES (44814, '64.77.15616949537755757', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; BND-AL10 Build/HONORBND-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '223.150.7.41', '2019-06-28 12:09:14', 8, 0, '', '2019-06-28 12:09:14');
INSERT INTO `access_log` VALUES (44815, '64.77.15616962855085775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; BND-AL10 Build/HONORBND-AL10) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '223.150.7.41', '2019-06-28 12:31:26', 25, 0, '', '2019-06-28 12:31:26');
INSERT INTO `access_log` VALUES (44816, '65.3607.15617005978018781', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 13:43:18', 1, 1002001015, '账号未登陆', '2019-06-28 13:43:18');
INSERT INTO `access_log` VALUES (44817, '65.51.15617005978017031', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 13:43:18', 0, 1002001015, '账号未登陆', '2019-06-28 13:43:18');
INSERT INTO `access_log` VALUES (44818, '65.49.15617005978207005', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 13:43:18', 0, 1002001015, '账号未登陆', '2019-06-28 13:43:18');
INSERT INTO `access_log` VALUES (44819, '65.47.15617005997246975', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 13:43:20', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 13:43:20');
INSERT INTO `access_log` VALUES (44820, '65.54.15617006025036949', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 13:43:23', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 13:43:23');
INSERT INTO `access_log` VALUES (44821, '65.46.15617006138067053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 13:43:34', 109, 0, '', '2019-06-28 13:43:34');
INSERT INTO `access_log` VALUES (44822, '65.45.15617006142306995', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 13:43:34', 20, 0, '', '2019-06-28 13:43:34');
INSERT INTO `access_log` VALUES (44823, '65.50.15617006142337005', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 13:43:34', 10, 2001001000, '服务端发生异常', '2019-06-28 13:43:34');
INSERT INTO `access_log` VALUES (44824, '65.53.15617006142436999', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 13:43:34', 9, 0, '', '2019-06-28 13:43:34');
INSERT INTO `access_log` VALUES (44825, '65.49.15617006305807007', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 13:43:51', 8, 0, '', '2019-06-28 13:43:51');
INSERT INTO `access_log` VALUES (44826, '65.51.15617006305867033', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 13:43:51', 9, 2001001000, '服务端发生异常', '2019-06-28 13:43:51');
INSERT INTO `access_log` VALUES (44827, '65.47.15617006305906977', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 13:43:51', 8, 0, '', '2019-06-28 13:43:51');
INSERT INTO `access_log` VALUES (44828, '58.85.15617008649334917', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=&keyword=&pageNo=&pageSize=&sortField=&sortOrder=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 13:47:45', 409, 2001001000, '服务端发生异常', '2019-06-28 13:47:45');
INSERT INTO `access_log` VALUES (44829, '59.76.15617011071315767', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:51:47', 13, 0, '', '2019-06-28 13:51:47');
INSERT INTO `access_log` VALUES (44830, '59.77.15617011071325761', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:51:47', 15, 2001001000, '服务端发生异常', '2019-06-28 13:51:47');
INSERT INTO `access_log` VALUES (44831, '59.73.15617011122635781', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:51:52', 12, 2001001000, '服务端发生异常', '2019-06-28 13:51:52');
INSERT INTO `access_log` VALUES (44832, '59.78.15617011122615769', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:51:52', 50, 0, '', '2019-06-28 13:51:52');
INSERT INTO `access_log` VALUES (44833, '59.72.15617011165215771', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:51:57', 3, 0, '', '2019-06-28 13:51:57');
INSERT INTO `access_log` VALUES (44834, '59.80.15617011165285763', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:51:57', 11, 2001001000, '服务端发生异常', '2019-06-28 13:51:57');
INSERT INTO `access_log` VALUES (44835, '65.50.15617011195947013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.210.123', '2019-06-28 13:52:00', 4, 1002001012, '访问令牌已过期', '2019-06-28 13:52:00');
INSERT INTO `access_log` VALUES (44836, '65.53.15617011195957007', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.210.123', '2019-06-28 13:52:00', 4, 1002001012, '访问令牌已过期', '2019-06-28 13:52:00');
INSERT INTO `access_log` VALUES (44837, '65.45.15617011195977003', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.210.123', '2019-06-28 13:52:00', 2, 1002001012, '访问令牌已过期', '2019-06-28 13:52:00');
INSERT INTO `access_log` VALUES (44838, '65.3607.15617011231398791', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:52:03', 1, 1002001015, '账号未登陆', '2019-06-28 13:52:03');
INSERT INTO `access_log` VALUES (44839, '65.51.15617011231397041', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:52:03', 0, 1002001015, '账号未登陆', '2019-06-28 13:52:03');
INSERT INTO `access_log` VALUES (44840, '65.47.15617011231426985', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:52:03', 1, 1002001015, '账号未登陆', '2019-06-28 13:52:03');
INSERT INTO `access_log` VALUES (44841, '65.49.15617011251417015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:52:05', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 13:52:05');
INSERT INTO `access_log` VALUES (44842, '65.54.15617011252946959', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.210.123', '2019-06-28 13:52:05', 109, 0, '', '2019-06-28 13:52:05');
INSERT INTO `access_log` VALUES (44843, '65.52.15617011256827021', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.210.123', '2019-06-28 13:52:06', 9, 0, '', '2019-06-28 13:52:06');
INSERT INTO `access_log` VALUES (44844, '65.46.15617011256847063', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.210.123', '2019-06-28 13:52:06', 9, 2001001000, '服务端发生异常', '2019-06-28 13:52:06');
INSERT INTO `access_log` VALUES (44845, '65.50.15617011256887015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.210.123', '2019-06-28 13:52:06', 8, 0, '', '2019-06-28 13:52:06');
INSERT INTO `access_log` VALUES (44846, '65.53.15617011385297009', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:52:19', 5, 1002002000, '账号不存在', '2019-06-28 13:52:19');
INSERT INTO `access_log` VALUES (44847, '65.47.15617011398956987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.210.123', '2019-06-28 13:52:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 13:52:20');
INSERT INTO `access_log` VALUES (44848, '65.49.15617011511867017', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.152.29.155', '2019-06-28 13:52:31', 0, 1002001015, '账号未登陆', '2019-06-28 13:52:31');
INSERT INTO `access_log` VALUES (44849, '65.3607.15617011511868793', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.152.29.155', '2019-06-28 13:52:31', 0, 1002001015, '账号未登陆', '2019-06-28 13:52:31');
INSERT INTO `access_log` VALUES (44850, '65.54.15617011511946961', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.152.29.155', '2019-06-28 13:52:31', 0, 1002001015, '账号未登陆', '2019-06-28 13:52:31');
INSERT INTO `access_log` VALUES (44851, '65.52.15617011523847023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.210.123', '2019-06-28 13:52:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 13:52:32');
INSERT INTO `access_log` VALUES (44852, '65.50.15617011526707017', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:52:33', 81, 0, '', '2019-06-28 13:52:33');
INSERT INTO `access_log` VALUES (44853, '65.46.15617011530287065', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:52:33', 8, 0, '', '2019-06-28 13:52:33');
INSERT INTO `access_log` VALUES (44854, '65.45.15617011530307007', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:52:33', 9, 2001001000, '服务端发生异常', '2019-06-28 13:52:33');
INSERT INTO `access_log` VALUES (44855, '65.53.15617011530357011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.244.241', '2019-06-28 13:52:33', 8, 0, '', '2019-06-28 13:52:33');
INSERT INTO `access_log` VALUES (44856, '65.47.15617011551746989', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.152.29.155', '2019-06-28 13:52:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 13:52:35');
INSERT INTO `access_log` VALUES (44857, '65.54.15617011663346963', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.210.123', '2019-06-28 13:52:46', 75, 0, '', '2019-06-28 13:52:46');
INSERT INTO `access_log` VALUES (44858, '65.49.15617011665697019', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.210.123', '2019-06-28 13:52:47', 9, 0, '', '2019-06-28 13:52:47');
INSERT INTO `access_log` VALUES (44859, '65.52.15617011665717025', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.210.123', '2019-06-28 13:52:47', 8, 0, '', '2019-06-28 13:52:47');
INSERT INTO `access_log` VALUES (44860, '65.3607.15617011665718795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.210.123', '2019-06-28 13:52:47', 10, 2001001000, '服务端发生异常', '2019-06-28 13:52:47');
INSERT INTO `access_log` VALUES (44861, '65.50.15617011670587019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.152.29.155', '2019-06-28 13:52:47', 60, 0, '', '2019-06-28 13:52:47');
INSERT INTO `access_log` VALUES (44862, '65.46.15617011675317067', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.152.29.155', '2019-06-28 13:52:48', 15, 0, '', '2019-06-28 13:52:48');
INSERT INTO `access_log` VALUES (44863, '65.53.15617011675397013', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.152.29.155', '2019-06-28 13:52:48', 7, 0, '', '2019-06-28 13:52:48');
INSERT INTO `access_log` VALUES (44864, '65.45.15617011675417009', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.152.29.155', '2019-06-28 13:52:48', 9, 2001001000, '服务端发生异常', '2019-06-28 13:52:48');
INSERT INTO `access_log` VALUES (44865, '65.51.15617011821597047', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.152.29.155', '2019-06-28 13:53:02', 8, 0, '', '2019-06-28 13:53:02');
INSERT INTO `access_log` VALUES (44866, '65.54.15617011821666965', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.152.29.155', '2019-06-28 13:53:02', 8, 2001001000, '服务端发生异常', '2019-06-28 13:53:02');
INSERT INTO `access_log` VALUES (44867, '65.52.15617011821697027', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.152.29.155', '2019-06-28 13:53:02', 7, 0, '', '2019-06-28 13:53:02');
INSERT INTO `access_log` VALUES (44868, '65.49.15617011840137021', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.152.29.155', '2019-06-28 13:53:04', 9, 0, '', '2019-06-28 13:53:04');
INSERT INTO `access_log` VALUES (44869, '65.3607.15617011840178797', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.152.29.155', '2019-06-28 13:53:04', 9, 2001001000, '服务端发生异常', '2019-06-28 13:53:04');
INSERT INTO `access_log` VALUES (44870, '65.50.15617011840217021', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '36.152.29.155', '2019-06-28 13:53:04', 8, 0, '', '2019-06-28 13:53:04');
INSERT INTO `access_log` VALUES (44871, '65.45.15617019931677021', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 14:06:33', 0, 1002001015, '账号未登陆', '2019-06-28 14:06:33');
INSERT INTO `access_log` VALUES (44872, '65.51.15617019931717061', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 14:06:33', 0, 1002001015, '账号未登陆', '2019-06-28 14:06:33');
INSERT INTO `access_log` VALUES (44873, '65.47.15617019931747003', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 14:06:33', 0, 1002001015, '账号未登陆', '2019-06-28 14:06:33');
INSERT INTO `access_log` VALUES (44874, '65.49.15617020061037033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 14:06:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 14:06:46');
INSERT INTO `access_log` VALUES (44875, '65.3607.15617020134278811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 14:06:53', 233, 0, '', '2019-06-28 14:06:54');
INSERT INTO `access_log` VALUES (44876, '65.53.15617020139587027', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 14:06:54', 9, 0, '', '2019-06-28 14:06:54');
INSERT INTO `access_log` VALUES (44877, '65.46.15617020139627083', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 14:06:54', 9, 2001001000, '服务端发生异常', '2019-06-28 14:06:54');
INSERT INTO `access_log` VALUES (44878, '65.50.15617020139677033', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 14:06:54', 8, 0, '', '2019-06-28 14:06:54');
INSERT INTO `access_log` VALUES (44879, '64.79.15617025604905867', 0, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 14:16:00', 8, 1002001012, '访问令牌已过期', '2019-06-28 14:16:00');
INSERT INTO `access_log` VALUES (44880, '65.46.15617025716287091', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 14:16:12', 76, 0, '', '2019-06-28 14:16:12');
INSERT INTO `access_log` VALUES (44881, '65.50.15617025719827041', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 14:16:12', 126, 0, '', '2019-06-28 14:16:12');
INSERT INTO `access_log` VALUES (44882, '65.51.15617025719847071', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 14:16:12', 125, 0, '', '2019-06-28 14:16:12');
INSERT INTO `access_log` VALUES (44883, '65.53.15617025719827035', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.5.82.188', '2019-06-28 14:16:12', 129, 0, '', '2019-06-28 14:16:12');
INSERT INTO `access_log` VALUES (44884, '66.52.15617036558553995', 0, 2, 'user-application', '/user-api/admins/user/page', 'pageSize=10&nickname=小王&pageNo=1&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 14:34:16', 1, 1002001015, '账号未登陆', '2019-06-28 14:34:16');
INSERT INTO `access_log` VALUES (44885, '65.49.15617045698167069', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-28 14:49:30', 5, 1002001012, '访问令牌已过期', '2019-06-28 14:49:30');
INSERT INTO `access_log` VALUES (44886, '65.3607.15617045698168847', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-28 14:49:30', 5, 1002001012, '访问令牌已过期', '2019-06-28 14:49:30');
INSERT INTO `access_log` VALUES (44887, '65.54.15617045698307015', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-28 14:49:30', 12, 1002001012, '访问令牌已过期', '2019-06-28 14:49:30');
INSERT INTO `access_log` VALUES (44888, '65.46.15617045714707119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-28 14:49:31', 109, 0, '', '2019-06-28 14:49:32');
INSERT INTO `access_log` VALUES (44889, '65.51.15617045717897099', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-28 14:49:32', 9, 0, '', '2019-06-28 14:49:32');
INSERT INTO `access_log` VALUES (44890, '65.50.15617045717927069', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-28 14:49:32', 19, 0, '', '2019-06-28 14:49:32');
INSERT INTO `access_log` VALUES (44891, '65.53.15617045717937063', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.240.37.213', '2019-06-28 14:49:32', 18, 0, '', '2019-06-28 14:49:32');
INSERT INTO `access_log` VALUES (44892, '65.53.15617050118277069', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-06-28 14:56:52', 4, 1002001012, '访问令牌已过期', '2019-06-28 14:56:52');
INSERT INTO `access_log` VALUES (44893, '65.47.15617050118287047', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-06-28 14:56:52', 3, 1002001012, '访问令牌已过期', '2019-06-28 14:56:52');
INSERT INTO `access_log` VALUES (44894, '65.45.15617050123257065', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-06-28 14:56:52', 3, 1002001012, '访问令牌已过期', '2019-06-28 14:56:52');
INSERT INTO `access_log` VALUES (44895, '65.54.15617050520427023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-06-28 14:57:32', 80, 0, '', '2019-06-28 14:57:32');
INSERT INTO `access_log` VALUES (44896, '65.46.15617050544437127', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-06-28 14:57:34', 11, 2001001000, '服务端发生异常', '2019-06-28 14:57:34');
INSERT INTO `access_log` VALUES (44897, '65.51.15617050544477107', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-06-28 14:57:34', 16, 0, '', '2019-06-28 14:57:34');
INSERT INTO `access_log` VALUES (44898, '65.50.15617050544507077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-06-28 14:57:34', 17, 0, '', '2019-06-28 14:57:34');
INSERT INTO `access_log` VALUES (44899, '59.78.15617054042125827', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:60.0) Gecko/20100101 Firefox/60.0', '180.168.192.126', '2019-06-28 15:03:24', 17, 0, '', '2019-06-28 15:03:24');
INSERT INTO `access_log` VALUES (44900, '59.73.15617054042165839', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:60.0) Gecko/20100101 Firefox/60.0', '180.168.192.126', '2019-06-28 15:03:24', 19, 2001001000, '服务端发生异常', '2019-06-28 15:03:24');
INSERT INTO `access_log` VALUES (44901, '64.84.15617054094195893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:60.0) Gecko/20100101 Firefox/60.0', '180.168.192.126', '2019-06-28 15:03:29', 9, 0, '', '2019-06-28 15:03:29');
INSERT INTO `access_log` VALUES (44902, '64.85.15617054095175915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:60.0) Gecko/20100101 Firefox/60.0', '180.168.192.126', '2019-06-28 15:03:30', 2, 0, '', '2019-06-28 15:03:30');
INSERT INTO `access_log` VALUES (44903, '65.51.15617054736597113', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.182.28', '2019-06-28 15:04:34', 1, 1002001015, '账号未登陆', '2019-06-28 15:04:34');
INSERT INTO `access_log` VALUES (44904, '65.46.15617054736617133', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.182.28', '2019-06-28 15:04:34', 0, 1002001015, '账号未登陆', '2019-06-28 15:04:34');
INSERT INTO `access_log` VALUES (44905, '65.53.15617054736687077', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.182.28', '2019-06-28 15:04:34', 1, 1002001015, '账号未登陆', '2019-06-28 15:04:34');
INSERT INTO `access_log` VALUES (44906, '65.47.15617054785697055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.182.28', '2019-06-28 15:04:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 15:04:39');
INSERT INTO `access_log` VALUES (44907, '65.52.15617054895737093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.182.28', '2019-06-28 15:04:50', 92, 0, '', '2019-06-28 15:04:50');
INSERT INTO `access_log` VALUES (44908, '65.3607.15617054900348863', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.182.28', '2019-06-28 15:04:50', 11, 0, '', '2019-06-28 15:04:50');
INSERT INTO `access_log` VALUES (44909, '65.49.15617054900397085', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.182.28', '2019-06-28 15:04:50', 10, 2001001000, '服务端发生异常', '2019-06-28 15:04:50');
INSERT INTO `access_log` VALUES (44910, '65.54.15617054900437031', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.182.28', '2019-06-28 15:04:50', 8, 0, '', '2019-06-28 15:04:50');
INSERT INTO `access_log` VALUES (44911, '65.46.15617055006447135', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.182.28', '2019-06-28 15:05:01', 7, 0, '', '2019-06-28 15:05:01');
INSERT INTO `access_log` VALUES (44912, '65.53.15617055006637079', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.182.28', '2019-06-28 15:05:01', 8, 0, '', '2019-06-28 15:05:01');
INSERT INTO `access_log` VALUES (44913, '65.51.15617055006627115', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.182.28', '2019-06-28 15:05:01', 8, 2001001000, '服务端发生异常', '2019-06-28 15:05:01');
INSERT INTO `access_log` VALUES (44914, '65.47.15617055035077057', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.182.28', '2019-06-28 15:05:04', 9, 0, '', '2019-06-28 15:05:04');
INSERT INTO `access_log` VALUES (44915, '65.45.15617055035107075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.182.28', '2019-06-28 15:05:04', 10, 2001001000, '服务端发生异常', '2019-06-28 15:05:04');
INSERT INTO `access_log` VALUES (44916, '65.52.15617055035157095', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.182.28', '2019-06-28 15:05:04', 9, 0, '', '2019-06-28 15:05:04');
INSERT INTO `access_log` VALUES (44917, '59.73.15617055386725841', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:60.0) Gecko/20100101 Firefox/60.0', '180.168.192.126', '2019-06-28 15:05:39', 3, 0, '', '2019-06-28 15:05:39');
INSERT INTO `access_log` VALUES (44918, '59.72.15617055386735831', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:60.0) Gecko/20100101 Firefox/60.0', '180.168.192.126', '2019-06-28 15:05:39', 14, 2001001000, '服务端发生异常', '2019-06-28 15:05:39');
INSERT INTO `access_log` VALUES (44919, '65.3607.15617059442318871', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:12:24', 1, 1002001015, '账号未登陆', '2019-06-28 15:12:24');
INSERT INTO `access_log` VALUES (44920, '65.54.15617059442337039', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:12:24', 1, 1002001015, '账号未登陆', '2019-06-28 15:12:24');
INSERT INTO `access_log` VALUES (44921, '65.49.15617059442337093', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:12:24', 1, 1002001015, '账号未登陆', '2019-06-28 15:12:24');
INSERT INTO `access_log` VALUES (44922, '65.50.15617059464177093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:12:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 15:12:26');
INSERT INTO `access_log` VALUES (44923, '65.53.15617059652537087', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:12:45', 84, 0, '', '2019-06-28 15:12:45');
INSERT INTO `access_log` VALUES (44924, '65.47.15617059655937065', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:12:46', 9, 0, '', '2019-06-28 15:12:46');
INSERT INTO `access_log` VALUES (44925, '65.51.15617059655837123', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:12:46', 9, 0, '', '2019-06-28 15:12:46');
INSERT INTO `access_log` VALUES (44926, '65.52.15617059655937103', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:12:46', 10, 2001001000, '服务端发生异常', '2019-06-28 15:12:46');
INSERT INTO `access_log` VALUES (44927, '65.45.15617059703467083', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:12:50', 10, 0, '', '2019-06-28 15:12:50');
INSERT INTO `access_log` VALUES (44928, '65.54.15617059703487041', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:12:50', 9, 2001001000, '服务端发生异常', '2019-06-28 15:12:50');
INSERT INTO `access_log` VALUES (44929, '65.3607.15617059703508873', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:12:50', 9, 0, '', '2019-06-28 15:12:50');
INSERT INTO `access_log` VALUES (44930, '65.46.15617060014597145', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:13:21', 9, 0, '', '2019-06-28 15:13:21');
INSERT INTO `access_log` VALUES (44931, '65.53.15617060014697089', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:13:21', 10, 2001001000, '服务端发生异常', '2019-06-28 15:13:21');
INSERT INTO `access_log` VALUES (44932, '65.52.15617060014707105', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:13:21', 9, 0, '', '2019-06-28 15:13:21');
INSERT INTO `access_log` VALUES (44933, '65.45.15617060259047085', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:13:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 15:13:46');
INSERT INTO `access_log` VALUES (44934, '65.54.15617060406627043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:01', 581, 0, '', '2019-06-28 15:14:01');
INSERT INTO `access_log` VALUES (44935, '65.49.15617060426207097', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:03', 301, 0, '', '2019-06-28 15:14:03');
INSERT INTO `access_log` VALUES (44936, '65.50.15617060426217097', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:03', 299, 0, '', '2019-06-28 15:14:03');
INSERT INTO `access_log` VALUES (44937, '65.46.15617060426247147', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:03', 298, 0, '', '2019-06-28 15:14:03');
INSERT INTO `access_log` VALUES (44938, '64.81.15617060471835903', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:07', 12, 0, '', '2019-06-28 15:14:07');
INSERT INTO `access_log` VALUES (44939, '64.82.15617060472035913', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:07', 8, 0, '', '2019-06-28 15:14:07');
INSERT INTO `access_log` VALUES (44940, '64.79.15617060504075915', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:10', 9, 0, '', '2019-06-28 15:14:10');
INSERT INTO `access_log` VALUES (44941, '64.78.15617060504055913', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:10', 13, 0, '', '2019-06-28 15:14:10');
INSERT INTO `access_log` VALUES (44942, '64.84.15617060550795903', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:15', 20, 0, '', '2019-06-28 15:14:15');
INSERT INTO `access_log` VALUES (44943, '64.77.15617060550795905', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:15', 21, 0, '', '2019-06-28 15:14:15');
INSERT INTO `access_log` VALUES (44944, '66.54.15617060623724031', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:22', 22, 0, '', '2019-06-28 15:14:22');
INSERT INTO `access_log` VALUES (44945, '59.76.15617060647715835', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:25', 16, 0, '', '2019-06-28 15:14:25');
INSERT INTO `access_log` VALUES (44946, '65.47.15617060690357069', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:29', 28, 0, '', '2019-06-28 15:14:29');
INSERT INTO `access_log` VALUES (44947, '65.51.15617060704187127', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:30', 25, 0, '', '2019-06-28 15:14:30');
INSERT INTO `access_log` VALUES (44948, '59.71.15617060718575843', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:32', 14, 0, '', '2019-06-28 15:14:32');
INSERT INTO `access_log` VALUES (44949, '65.45.15617060739577087', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:34', 10, 0, '', '2019-06-28 15:14:34');
INSERT INTO `access_log` VALUES (44950, '65.3607.15617060748468877', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:35', 14, 0, '', '2019-06-28 15:14:35');
INSERT INTO `access_log` VALUES (44951, '62.85.15617060859665327', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:46', 23, 0, '', '2019-06-28 15:14:46');
INSERT INTO `access_log` VALUES (44952, '65.46.15617060944277149', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.99.16.191', '2019-06-28 15:14:54', 18, 0, '', '2019-06-28 15:14:54');
INSERT INTO `access_log` VALUES (44953, '65.47.15617064138547075', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '36.110.118.65', '2019-06-28 15:20:14', 0, 1002001015, '账号未登陆', '2019-06-28 15:20:14');
INSERT INTO `access_log` VALUES (44954, '65.53.15617064138537097', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '36.110.118.65', '2019-06-28 15:20:14', 0, 1002001015, '账号未登陆', '2019-06-28 15:20:14');
INSERT INTO `access_log` VALUES (44955, '65.52.15617064138537113', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '36.110.118.65', '2019-06-28 15:20:14', 0, 1002001015, '账号未登陆', '2019-06-28 15:20:14');
INSERT INTO `access_log` VALUES (44956, '65.51.15617064161557133', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '36.110.118.65', '2019-06-28 15:20:16', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 15:20:16');
INSERT INTO `access_log` VALUES (44957, '65.3607.15617064260648883', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '36.110.118.65', '2019-06-28 15:20:26', 55, 0, '', '2019-06-28 15:20:26');
INSERT INTO `access_log` VALUES (44958, '65.54.15617064263777051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '36.110.118.65', '2019-06-28 15:20:26', 9, 0, '', '2019-06-28 15:20:26');
INSERT INTO `access_log` VALUES (44959, '65.46.15617064263807155', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '36.110.118.65', '2019-06-28 15:20:26', 9, 0, '', '2019-06-28 15:20:26');
INSERT INTO `access_log` VALUES (44960, '65.50.15617064263787105', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '36.110.118.65', '2019-06-28 15:20:26', 11, 2001001000, '服务端发生异常', '2019-06-28 15:20:26');
INSERT INTO `access_log` VALUES (44961, '65.52.15617064467667115', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '36.110.118.65', '2019-06-28 15:20:47', 9, 0, '', '2019-06-28 15:20:47');
INSERT INTO `access_log` VALUES (44962, '65.53.15617064467697099', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '36.110.118.65', '2019-06-28 15:20:47', 9, 2001001000, '服务端发生异常', '2019-06-28 15:20:47');
INSERT INTO `access_log` VALUES (44963, '65.47.15617064467747077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '36.110.118.65', '2019-06-28 15:20:47', 9, 0, '', '2019-06-28 15:20:47');
INSERT INTO `access_log` VALUES (44964, '65.47.15617065471567079', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 15:22:27', 3, 1002001012, '访问令牌已过期', '2019-06-28 15:22:27');
INSERT INTO `access_log` VALUES (44965, '65.52.15617065471597117', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 15:22:27', 3, 1002001012, '访问令牌已过期', '2019-06-28 15:22:27');
INSERT INTO `access_log` VALUES (44966, '65.53.15617065471597101', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 15:22:27', 10, 1002001012, '访问令牌已过期', '2019-06-28 15:22:27');
INSERT INTO `access_log` VALUES (44967, '65.51.15617065522257137', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 15:22:32', 66, 0, '', '2019-06-28 15:22:32');
INSERT INTO `access_log` VALUES (44968, '65.3607.15617065525408887', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 15:22:33', 9, 2001001000, '服务端发生异常', '2019-06-28 15:22:33');
INSERT INTO `access_log` VALUES (44969, '65.45.15617065525367097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 15:22:33', 164, 0, '', '2019-06-28 15:22:33');
INSERT INTO `access_log` VALUES (44970, '65.46.15617065525437159', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.120.235.251', '2019-06-28 15:22:33', 158, 0, '', '2019-06-28 15:22:33');
INSERT INTO `access_log` VALUES (44971, '59.80.15617068570015841', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.15.178.95', '2019-06-28 15:27:37', 3, 0, '', '2019-06-28 15:27:37');
INSERT INTO `access_log` VALUES (44972, '59.79.15617068570025855', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.15.178.95', '2019-06-28 15:27:37', 12, 2001001000, '服务端发生异常', '2019-06-28 15:27:37');
INSERT INTO `access_log` VALUES (44973, '64.81.15617068709525915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.15.178.95', '2019-06-28 15:27:51', 3, 0, '', '2019-06-28 15:27:51');
INSERT INTO `access_log` VALUES (44974, '64.79.15617068710565927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.15.178.95', '2019-06-28 15:27:51', 1, 0, '', '2019-06-28 15:27:51');
INSERT INTO `access_log` VALUES (44975, '64.78.15617068728015925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.15.178.95', '2019-06-28 15:27:53', 2, 0, '', '2019-06-28 15:27:53');
INSERT INTO `access_log` VALUES (44976, '64.77.15617068730375917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.15.178.95', '2019-06-28 15:27:53', 1, 0, '', '2019-06-28 15:27:53');
INSERT INTO `access_log` VALUES (44977, '64.84.15617068735035915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.15.178.95', '2019-06-28 15:27:54', 2, 0, '', '2019-06-28 15:27:54');
INSERT INTO `access_log` VALUES (44978, '65.51.15617072471067147', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '218.75.104.34', '2019-06-28 15:34:07', 0, 1002001015, '账号未登陆', '2019-06-28 15:34:07');
INSERT INTO `access_log` VALUES (44979, '65.3607.15617072471098897', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '218.75.104.34', '2019-06-28 15:34:07', 1, 1002001015, '账号未登陆', '2019-06-28 15:34:07');
INSERT INTO `access_log` VALUES (44980, '65.46.15617072471097169', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '218.75.104.34', '2019-06-28 15:34:07', 0, 1002001015, '账号未登陆', '2019-06-28 15:34:07');
INSERT INTO `access_log` VALUES (44981, '65.54.15617072504227065', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '218.75.104.34', '2019-06-28 15:34:10', 175, 0, '', '2019-06-28 15:34:11');
INSERT INTO `access_log` VALUES (44982, '65.50.15617072508547119', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '218.75.104.34', '2019-06-28 15:34:11', 10, 0, '', '2019-06-28 15:34:11');
INSERT INTO `access_log` VALUES (44983, '65.49.15617072508637119', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '218.75.104.34', '2019-06-28 15:34:11', 9, 2001001000, '服务端发生异常', '2019-06-28 15:34:11');
INSERT INTO `access_log` VALUES (44984, '65.53.15617072508737113', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '218.75.104.34', '2019-06-28 15:34:11', 10, 0, '', '2019-06-28 15:34:11');
INSERT INTO `access_log` VALUES (44985, '66.48.15617077469714061', 0, 2, 'user-application', '/user-api/admins/user/page', 'pageSize=10&nickname=小王&pageNo=1&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.91 Safari/537.36', '120.236.216.180', '2019-06-28 15:42:27', 1, 1002001015, '账号未登陆', '2019-06-28 15:42:27');
INSERT INTO `access_log` VALUES (44986, '66.51.15617078504824071', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.91 Safari/537.36', '120.236.216.180', '2019-06-28 15:44:10', 1, 1002001015, '账号未登陆', '2019-06-28 15:44:10');
INSERT INTO `access_log` VALUES (44987, '66.55.15617078536424043', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.91 Safari/537.36', '120.236.216.180', '2019-06-28 15:44:14', 0, 1002001015, '账号未登陆', '2019-06-28 15:44:14');
INSERT INTO `access_log` VALUES (44988, '66.55.15617079875494045', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'code=1024&mobile=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.91 Safari/537.36', '120.236.216.180', '2019-06-28 15:46:28', 16, 1001003000, '验证码不存在', '2019-06-28 15:46:28');
INSERT INTO `access_log` VALUES (44989, '66.53.15617079888594053', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'code=1024&mobile=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.91 Safari/537.36', '120.236.216.180', '2019-06-28 15:46:29', 7, 1001003000, '验证码不存在', '2019-06-28 15:46:29');
INSERT INTO `access_log` VALUES (44990, '66.55.15617080551544047', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13660280367', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.91 Safari/537.36', '120.236.216.180', '2019-06-28 15:47:35', 64, 0, '', '2019-06-28 15:47:35');
INSERT INTO `access_log` VALUES (44991, '66.53.15617080555334055', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13660280367', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.91 Safari/537.36', '120.236.216.180', '2019-06-28 15:47:36', 4, 1001003005, '短信发送过于频率', '2019-06-28 15:47:36');
INSERT INTO `access_log` VALUES (44992, '66.56.15617080587964067', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13660280367', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.91 Safari/537.36', '120.236.216.180', '2019-06-28 15:47:39', 5, 1001003005, '短信发送过于频率', '2019-06-28 15:47:39');
INSERT INTO `access_log` VALUES (44993, '66.50.15617080591904045', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13660280367', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.91 Safari/537.36', '120.236.216.180', '2019-06-28 15:47:39', 5, 1001003005, '短信发送过于频率', '2019-06-28 15:47:39');
INSERT INTO `access_log` VALUES (44994, '66.54.15617080599754061', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13660280367', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.91 Safari/537.36', '120.236.216.180', '2019-06-28 15:47:40', 5, 1001003005, '短信发送过于频率', '2019-06-28 15:47:40');
INSERT INTO `access_log` VALUES (44995, '65.53.15617082811447127', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:21', 1, 1002001015, '账号未登陆', '2019-06-28 15:51:21');
INSERT INTO `access_log` VALUES (44996, '65.49.15617082811457133', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:21', 0, 1002001015, '账号未登陆', '2019-06-28 15:51:21');
INSERT INTO `access_log` VALUES (44997, '65.52.15617082811467143', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:21', 8, 1002001015, '账号未登陆', '2019-06-28 15:51:21');
INSERT INTO `access_log` VALUES (44998, '65.46.15617082814307185', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:21', 0, 1002001015, '账号未登陆', '2019-06-28 15:51:21');
INSERT INTO `access_log` VALUES (44999, '65.51.15617082814307163', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:21', 0, 1002001015, '账号未登陆', '2019-06-28 15:51:21');
INSERT INTO `access_log` VALUES (45000, '65.47.15617082814307105', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:21', 0, 1002001015, '账号未登陆', '2019-06-28 15:51:21');
INSERT INTO `access_log` VALUES (45001, '65.45.15617082865807123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:27', 82, 0, '', '2019-06-28 15:51:27');
INSERT INTO `access_log` VALUES (45002, '65.54.15617082868707081', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:27', 9, 0, '', '2019-06-28 15:51:27');
INSERT INTO `access_log` VALUES (45003, '65.50.15617082868737135', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:27', 10, 2001001000, '服务端发生异常', '2019-06-28 15:51:27');
INSERT INTO `access_log` VALUES (45004, '65.53.15617082868757129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:27', 9, 0, '', '2019-06-28 15:51:27');
INSERT INTO `access_log` VALUES (45005, '65.49.15617082869367135', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:27', 0, 1002001015, '账号未登陆', '2019-06-28 15:51:27');
INSERT INTO `access_log` VALUES (45006, '65.52.15617082869887145', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:27', 0, 1002001015, '账号未登陆', '2019-06-28 15:51:27');
INSERT INTO `access_log` VALUES (45007, '65.46.15617082869947187', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:27', 1, 1002001015, '账号未登陆', '2019-06-28 15:51:27');
INSERT INTO `access_log` VALUES (45008, '65.47.15617082925937107', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:33', 10, 0, '', '2019-06-28 15:51:33');
INSERT INTO `access_log` VALUES (45009, '65.51.15617082925957165', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:33', 11, 2001001000, '服务端发生异常', '2019-06-28 15:51:33');
INSERT INTO `access_log` VALUES (45010, '65.3607.15617082925978915', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:33', 10, 0, '', '2019-06-28 15:51:33');
INSERT INTO `access_log` VALUES (45011, '65.45.15617082926507125', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:33', 0, 1002001015, '账号未登陆', '2019-06-28 15:51:33');
INSERT INTO `access_log` VALUES (45012, '65.50.15617082927167137', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:33', 1, 1002001015, '账号未登陆', '2019-06-28 15:51:33');
INSERT INTO `access_log` VALUES (45013, '65.54.15617082927167083', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:33', 0, 1002001015, '账号未登陆', '2019-06-28 15:51:33');
INSERT INTO `access_log` VALUES (45014, '65.53.15617082939907131', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:34', 10, 0, '', '2019-06-28 15:51:34');
INSERT INTO `access_log` VALUES (45015, '65.49.15617082939957137', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:34', 9, 0, '', '2019-06-28 15:51:34');
INSERT INTO `access_log` VALUES (45016, '65.52.15617082939947147', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:34', 10, 2001001000, '服务端发生异常', '2019-06-28 15:51:34');
INSERT INTO `access_log` VALUES (45017, '65.46.15617082940527189', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:34', 1, 1002001015, '账号未登陆', '2019-06-28 15:51:34');
INSERT INTO `access_log` VALUES (45018, '65.51.15617082940917167', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:34', 0, 1002001015, '账号未登陆', '2019-06-28 15:51:34');
INSERT INTO `access_log` VALUES (45019, '65.47.15617082941367109', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.251.232.116', '2019-06-28 15:51:34', 0, 1002001015, '账号未登陆', '2019-06-28 15:51:34');
INSERT INTO `access_log` VALUES (45020, '59.77.15617083811615861', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-06-28 15:53:01', 13, 2001001000, '服务端发生异常', '2019-06-28 15:53:01');
INSERT INTO `access_log` VALUES (45021, '59.74.15617083811605873', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-06-28 15:53:01', 77, 0, '', '2019-06-28 15:53:01');
INSERT INTO `access_log` VALUES (45022, '65.3607.15617086612648921', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-06-28 15:57:41', 1, 1002001015, '账号未登陆', '2019-06-28 15:57:41');
INSERT INTO `access_log` VALUES (45023, '65.45.15617086613537133', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-06-28 15:57:41', 1, 1002001015, '账号未登陆', '2019-06-28 15:57:41');
INSERT INTO `access_log` VALUES (45024, '65.54.15617086613547091', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-06-28 15:57:41', 0, 1002001015, '账号未登陆', '2019-06-28 15:57:41');
INSERT INTO `access_log` VALUES (45025, '65.50.15617086728647143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-06-28 15:57:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 15:57:53');
INSERT INTO `access_log` VALUES (45026, '65.46.15617087027327197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-06-28 15:58:23', 89, 0, '', '2019-06-28 15:58:23');
INSERT INTO `access_log` VALUES (45027, '65.49.15617087031877145', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-06-28 15:58:23', 9, 0, '', '2019-06-28 15:58:23');
INSERT INTO `access_log` VALUES (45028, '65.51.15617087031937175', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-06-28 15:58:23', 10, 2001001000, '服务端发生异常', '2019-06-28 15:58:23');
INSERT INTO `access_log` VALUES (45029, '65.47.15617087031977117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-06-28 15:58:23', 9, 0, '', '2019-06-28 15:58:23');
INSERT INTO `access_log` VALUES (45030, '65.52.15617087764777157', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-06-28 15:59:36', 203, 0, '', '2019-06-28 15:59:37');
INSERT INTO `access_log` VALUES (45031, '65.46.15617087770447199', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-06-28 15:59:37', 8, 0, '', '2019-06-28 15:59:37');
INSERT INTO `access_log` VALUES (45032, '65.49.15617087770517147', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-06-28 15:59:37', 8, 0, '', '2019-06-28 15:59:37');
INSERT INTO `access_log` VALUES (45033, '65.47.15617087770507119', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-06-28 15:59:37', 8, 2001001000, '服务端发生异常', '2019-06-28 15:59:37');
INSERT INTO `access_log` VALUES (45034, '65.50.15617101688067165', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.112.74.236', '2019-06-28 16:22:49', 7, 1002001015, '账号未登陆', '2019-06-28 16:22:49');
INSERT INTO `access_log` VALUES (45035, '65.53.15617101688067161', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.112.74.236', '2019-06-28 16:22:49', 0, 1002001015, '账号未登陆', '2019-06-28 16:22:49');
INSERT INTO `access_log` VALUES (45036, '65.45.15617101688057155', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.112.74.236', '2019-06-28 16:22:49', 7, 1002001015, '账号未登陆', '2019-06-28 16:22:49');
INSERT INTO `access_log` VALUES (45037, '65.46.15617101804727219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.112.74.236', '2019-06-28 16:23:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 16:23:00');
INSERT INTO `access_log` VALUES (45038, '65.3607.15617102241808945', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.112.74.236', '2019-06-28 16:23:44', 140, 0, '', '2019-06-28 16:23:44');
INSERT INTO `access_log` VALUES (45039, '65.50.15617102249107167', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.112.74.236', '2019-06-28 16:23:45', 9, 0, '', '2019-06-28 16:23:45');
INSERT INTO `access_log` VALUES (45040, '65.54.15617102249107115', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.112.74.236', '2019-06-28 16:23:45', 11, 2001001000, '服务端发生异常', '2019-06-28 16:23:45');
INSERT INTO `access_log` VALUES (45041, '65.53.15617102250137163', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.112.74.236', '2019-06-28 16:23:45', 9, 0, '', '2019-06-28 16:23:45');
INSERT INTO `access_log` VALUES (45042, '65.51.15617102950707199', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.112.74.236', '2019-06-28 16:24:55', 8, 0, '', '2019-06-28 16:24:55');
INSERT INTO `access_log` VALUES (45043, '65.3607.15617102950798947', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.112.74.236', '2019-06-28 16:24:55', 9, 2001001000, '服务端发生异常', '2019-06-28 16:24:55');
INSERT INTO `access_log` VALUES (45044, '65.54.15617102950827117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '118.112.74.236', '2019-06-28 16:24:55', 7, 0, '', '2019-06-28 16:24:55');
INSERT INTO `access_log` VALUES (45045, '65.49.15617112832887183', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.211.245.59', '2019-06-28 16:41:23', 0, 1002001015, '账号未登陆', '2019-06-28 16:41:23');
INSERT INTO `access_log` VALUES (45046, '65.47.15617112832907155', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.211.245.59', '2019-06-28 16:41:23', 0, 1002001015, '账号未登陆', '2019-06-28 16:41:23');
INSERT INTO `access_log` VALUES (45047, '65.51.15617112833037213', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.211.245.59', '2019-06-28 16:41:23', 0, 1002001015, '账号未登陆', '2019-06-28 16:41:23');
INSERT INTO `access_log` VALUES (45048, '65.3607.15617112955138961', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.211.245.59', '2019-06-28 16:41:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 16:41:36');
INSERT INTO `access_log` VALUES (45049, '65.53.15617112990307179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.211.245.59', '2019-06-28 16:41:39', 62, 0, '', '2019-06-28 16:41:39');
INSERT INTO `access_log` VALUES (45050, '65.45.15617112993817173', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.211.245.59', '2019-06-28 16:41:39', 9, 0, '', '2019-06-28 16:41:39');
INSERT INTO `access_log` VALUES (45051, '65.52.15617112993847195', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.211.245.59', '2019-06-28 16:41:39', 10, 2001001000, '服务端发生异常', '2019-06-28 16:41:39');
INSERT INTO `access_log` VALUES (45052, '65.46.15617112993917237', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.211.245.59', '2019-06-28 16:41:39', 8, 0, '', '2019-06-28 16:41:39');
INSERT INTO `access_log` VALUES (45053, '65.47.15617127824627177', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.107.20.163', '2019-06-28 17:06:22', 1, 1002001015, '账号未登陆', '2019-06-28 17:06:22');
INSERT INTO `access_log` VALUES (45054, '65.46.15617127824617257', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.107.20.163', '2019-06-28 17:06:22', 0, 1002001015, '账号未登陆', '2019-06-28 17:06:22');
INSERT INTO `access_log` VALUES (45055, '65.45.15617127824627193', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.107.20.163', '2019-06-28 17:06:22', 0, 1002001015, '账号未登陆', '2019-06-28 17:06:22');
INSERT INTO `access_log` VALUES (45056, '65.51.15617127841267235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.107.20.163', '2019-06-28 17:06:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 17:06:24');
INSERT INTO `access_log` VALUES (45057, '65.54.15617127866387153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.107.20.163', '2019-06-28 17:06:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 17:06:27');
INSERT INTO `access_log` VALUES (45058, '65.3607.15617127938868983', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.107.20.163', '2019-06-28 17:06:34', 88, 0, '', '2019-06-28 17:06:34');
INSERT INTO `access_log` VALUES (45059, '65.50.15617127941937205', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.107.20.163', '2019-06-28 17:06:34', 8, 0, '', '2019-06-28 17:06:34');
INSERT INTO `access_log` VALUES (45060, '65.53.15617127941957201', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.107.20.163', '2019-06-28 17:06:34', 9, 2001001000, '服务端发生异常', '2019-06-28 17:06:34');
INSERT INTO `access_log` VALUES (45061, '65.52.15617127941997217', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.107.20.163', '2019-06-28 17:06:34', 8, 0, '', '2019-06-28 17:06:34');
INSERT INTO `access_log` VALUES (45062, '59.76.15617130300685929', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.154.156.35', '2019-06-28 17:10:30', 15, 0, '', '2019-06-28 17:10:30');
INSERT INTO `access_log` VALUES (45063, '59.71.15617130300695937', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.154.156.35', '2019-06-28 17:10:30', 20, 2001001000, '服务端发生异常', '2019-06-28 17:10:30');
INSERT INTO `access_log` VALUES (45064, '64.83.15617130424005997', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.156.35', '2019-06-28 17:10:42', 13, 0, '', '2019-06-28 17:10:42');
INSERT INTO `access_log` VALUES (45065, '64.76.15617130425025991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.156.35', '2019-06-28 17:10:43', 4, 0, '', '2019-06-28 17:10:43');
INSERT INTO `access_log` VALUES (45066, '64.82.15617130546706009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.156.35', '2019-06-28 17:10:55', 2, 0, '', '2019-06-28 17:10:55');
INSERT INTO `access_log` VALUES (45067, '64.81.15617130547665999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.156.35', '2019-06-28 17:10:55', 2, 0, '', '2019-06-28 17:10:55');
INSERT INTO `access_log` VALUES (45068, '59.79.15617130690615939', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.154.156.35', '2019-06-28 17:11:09', 3, 0, '', '2019-06-28 17:11:09');
INSERT INTO `access_log` VALUES (45069, '59.80.15617130690625925', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.154.156.35', '2019-06-28 17:11:09', 15, 2001001000, '服务端发生异常', '2019-06-28 17:11:09');
INSERT INTO `access_log` VALUES (45070, '65.47.15617132592197185', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '219.137.64.154', '2019-06-28 17:14:19', 0, 1002001015, '账号未登陆', '2019-06-28 17:14:19');
INSERT INTO `access_log` VALUES (45071, '65.45.15617132592197201', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '219.137.64.154', '2019-06-28 17:14:19', 0, 1002001015, '账号未登陆', '2019-06-28 17:14:19');
INSERT INTO `access_log` VALUES (45072, '65.49.15617132592227213', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '219.137.64.154', '2019-06-28 17:14:19', 0, 1002001015, '账号未登陆', '2019-06-28 17:14:19');
INSERT INTO `access_log` VALUES (45073, '65.51.15617132616147243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '219.137.64.154', '2019-06-28 17:14:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 17:14:22');
INSERT INTO `access_log` VALUES (45074, '65.3607.15617132642128991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '219.137.64.154', '2019-06-28 17:14:24', 62, 0, '', '2019-06-28 17:14:24');
INSERT INTO `access_log` VALUES (45075, '65.52.15617132645007225', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '219.137.64.154', '2019-06-28 17:14:25', 10, 0, '', '2019-06-28 17:14:25');
INSERT INTO `access_log` VALUES (45076, '65.50.15617132645047213', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '219.137.64.154', '2019-06-28 17:14:25', 11, 2001001000, '服务端发生异常', '2019-06-28 17:14:25');
INSERT INTO `access_log` VALUES (45077, '65.53.15617132645077209', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '219.137.64.154', '2019-06-28 17:14:25', 10, 0, '', '2019-06-28 17:14:25');
INSERT INTO `access_log` VALUES (45078, '65.46.15617132653217267', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:14:25', 0, 1002001015, '账号未登陆', '2019-06-28 17:14:25');
INSERT INTO `access_log` VALUES (45079, '65.47.15617132653257187', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:14:25', 0, 1002001015, '账号未登陆', '2019-06-28 17:14:25');
INSERT INTO `access_log` VALUES (45080, '65.45.15617132653277203', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:14:25', 0, 1002001015, '账号未登陆', '2019-06-28 17:14:25');
INSERT INTO `access_log` VALUES (45081, '65.51.15617132800877245', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:14:40', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 17:14:40');
INSERT INTO `access_log` VALUES (45082, '65.54.15617132844247163', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:14:44', 67, 0, '', '2019-06-28 17:14:44');
INSERT INTO `access_log` VALUES (45083, '65.53.15617132848027211', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:14:45', 8, 0, '', '2019-06-28 17:14:45');
INSERT INTO `access_log` VALUES (45084, '65.50.15617132848017215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:14:45', 84, 2001001000, '服务端发生异常', '2019-06-28 17:14:45');
INSERT INTO `access_log` VALUES (45085, '65.3607.15617132847998993', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:14:45', 87, 0, '', '2019-06-28 17:14:45');
INSERT INTO `access_log` VALUES (45086, '59.80.15617133535765929', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.223.194.58', '2019-06-28 17:15:54', 2, 0, '', '2019-06-28 17:15:54');
INSERT INTO `access_log` VALUES (45087, '59.75.15617133535765945', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.223.194.58', '2019-06-28 17:15:54', 12, 2001001000, '服务端发生异常', '2019-06-28 17:15:54');
INSERT INTO `access_log` VALUES (45088, '65.50.15617133720947217', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.223.194.58', '2019-06-28 17:16:12', 3, 1002001012, '访问令牌已过期', '2019-06-28 17:16:12');
INSERT INTO `access_log` VALUES (45089, '65.3607.15617133721018995', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.223.194.58', '2019-06-28 17:16:12', 3, 1002001012, '访问令牌已过期', '2019-06-28 17:16:12');
INSERT INTO `access_log` VALUES (45090, '65.52.15617133721037227', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.223.194.58', '2019-06-28 17:16:12', 3, 1002001012, '访问令牌已过期', '2019-06-28 17:16:12');
INSERT INTO `access_log` VALUES (45091, '65.46.15617133763037269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.223.194.58', '2019-06-28 17:16:16', 401, 0, '', '2019-06-28 17:16:17');
INSERT INTO `access_log` VALUES (45092, '65.47.15617133769647191', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.223.194.58', '2019-06-28 17:16:17', 9, 0, '', '2019-06-28 17:16:17');
INSERT INTO `access_log` VALUES (45093, '65.45.15617133769687207', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.223.194.58', '2019-06-28 17:16:17', 10, 2001001000, '服务端发生异常', '2019-06-28 17:16:17');
INSERT INTO `access_log` VALUES (45094, '65.51.15617133769717249', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.223.194.58', '2019-06-28 17:16:17', 8, 0, '', '2019-06-28 17:16:17');
INSERT INTO `access_log` VALUES (45095, '65.45.15617134842347209', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.93.113.123', '2019-06-28 17:18:04', 0, 1002001015, '账号未登陆', '2019-06-28 17:18:04');
INSERT INTO `access_log` VALUES (45096, '65.49.15617134842407221', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.93.113.123', '2019-06-28 17:18:04', 0, 1002001015, '账号未登陆', '2019-06-28 17:18:04');
INSERT INTO `access_log` VALUES (45097, '65.54.15617134842547169', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.93.113.123', '2019-06-28 17:18:04', 0, 1002001015, '账号未登陆', '2019-06-28 17:18:04');
INSERT INTO `access_log` VALUES (45098, '65.53.15617134875977217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.93.113.123', '2019-06-28 17:18:08', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 17:18:08');
INSERT INTO `access_log` VALUES (45099, '65.50.15617134935147221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.93.113.123', '2019-06-28 17:18:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 17:18:14');
INSERT INTO `access_log` VALUES (45100, '65.52.15617134997227231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.93.113.123', '2019-06-28 17:18:20', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 17:18:20');
INSERT INTO `access_log` VALUES (45101, '65.51.15617135257477253', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.93.113.123', '2019-06-28 17:18:46', 241, 0, '', '2019-06-28 17:18:46');
INSERT INTO `access_log` VALUES (45102, '65.45.15617135271697211', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.93.113.123', '2019-06-28 17:18:47', 793, 0, '', '2019-06-28 17:18:48');
INSERT INTO `access_log` VALUES (45103, '65.49.15617135271787223', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.93.113.123', '2019-06-28 17:18:47', 786, 2001001000, '服务端发生异常', '2019-06-28 17:18:48');
INSERT INTO `access_log` VALUES (45104, '65.54.15617135271857171', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.93.113.123', '2019-06-28 17:18:47', 778, 0, '', '2019-06-28 17:18:48');
INSERT INTO `access_log` VALUES (45105, '59.76.15617135534415937', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:13', 4, 0, '', '2019-06-28 17:19:13');
INSERT INTO `access_log` VALUES (45106, '59.78.15617135534415939', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:13', 13, 2001001000, '服务端发生异常', '2019-06-28 17:19:13');
INSERT INTO `access_log` VALUES (45107, '64.84.15617135579336005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:18', 3, 0, '', '2019-06-28 17:19:18');
INSERT INTO `access_log` VALUES (45108, '64.85.15617135580406027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:18', 2, 0, '', '2019-06-28 17:19:18');
INSERT INTO `access_log` VALUES (45109, '64.83.15617135592096005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:19', 2, 0, '', '2019-06-28 17:19:19');
INSERT INTO `access_log` VALUES (45110, '64.76.15617135598575999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:20', 2, 0, '', '2019-06-28 17:19:20');
INSERT INTO `access_log` VALUES (45111, '64.82.15617135606096017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:21', 2, 0, '', '2019-06-28 17:19:21');
INSERT INTO `access_log` VALUES (45112, '59.72.15617135627925941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:23', 3, 0, '', '2019-06-28 17:19:23');
INSERT INTO `access_log` VALUES (45113, '59.79.15617135627925947', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:23', 19, 2001001000, '服务端发生异常', '2019-06-28 17:19:23');
INSERT INTO `access_log` VALUES (45114, '64.81.15617135652236007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:25', 3, 0, '', '2019-06-28 17:19:25');
INSERT INTO `access_log` VALUES (45115, '64.79.15617135653396019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:25', 2, 0, '', '2019-06-28 17:19:25');
INSERT INTO `access_log` VALUES (45116, '59.80.15617135667765933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:27', 2, 0, '', '2019-06-28 17:19:27');
INSERT INTO `access_log` VALUES (45117, '59.75.15617135667765949', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:27', 12, 2001001000, '服务端发生异常', '2019-06-28 17:19:27');
INSERT INTO `access_log` VALUES (45118, '64.78.15617135672256017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:27', 2, 0, '', '2019-06-28 17:19:27');
INSERT INTO `access_log` VALUES (45119, '64.77.15617135673606009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:27', 2, 0, '', '2019-06-28 17:19:27');
INSERT INTO `access_log` VALUES (45120, '59.77.15617135678685933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:28', 3, 0, '', '2019-06-28 17:19:28');
INSERT INTO `access_log` VALUES (45121, '59.74.15617135678685945', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:28', 12, 2001001000, '服务端发生异常', '2019-06-28 17:19:28');
INSERT INTO `access_log` VALUES (45122, '59.71.15617135733475947', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:33', 3, 0, '', '2019-06-28 17:19:33');
INSERT INTO `access_log` VALUES (45123, '59.76.15617135733475939', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:33', 11, 2001001000, '服务端发生异常', '2019-06-28 17:19:33');
INSERT INTO `access_log` VALUES (45124, '65.46.15617135877897275', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:48', 93, 0, '', '2019-06-28 17:19:48');
INSERT INTO `access_log` VALUES (45125, '65.47.15617135881287197', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:48', 9, 0, '', '2019-06-28 17:19:48');
INSERT INTO `access_log` VALUES (45126, '65.51.15617135881327255', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:48', 8, 2001001000, '服务端发生异常', '2019-06-28 17:19:48');
INSERT INTO `access_log` VALUES (45127, '65.54.15617135881337173', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.76.52.117', '2019-06-28 17:19:48', 8, 0, '', '2019-06-28 17:19:48');
INSERT INTO `access_log` VALUES (45128, '59.80.15617136244085935', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.246.152.106', '2019-06-28 17:20:24', 2, 0, '', '2019-06-28 17:20:24');
INSERT INTO `access_log` VALUES (45129, '59.75.15617136244125951', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.246.152.106', '2019-06-28 17:20:24', 18, 2001001000, '服务端发生异常', '2019-06-28 17:20:24');
INSERT INTO `access_log` VALUES (45130, '59.75.15617140643015957', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '106.37.204.7', '2019-06-28 17:27:44', 3, 0, '', '2019-06-28 17:27:44');
INSERT INTO `access_log` VALUES (45131, '59.74.15617140643295953', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '106.37.204.7', '2019-06-28 17:27:44', 12, 2001001000, '服务端发生异常', '2019-06-28 17:27:44');
INSERT INTO `access_log` VALUES (45132, '65.49.15617140770577233', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '106.37.204.7', '2019-06-28 17:27:57', 0, 1002001015, '账号未登陆', '2019-06-28 17:27:57');
INSERT INTO `access_log` VALUES (45133, '65.53.15617140770587227', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '106.37.204.7', '2019-06-28 17:27:57', 0, 1002001015, '账号未登陆', '2019-06-28 17:27:57');
INSERT INTO `access_log` VALUES (45134, '65.52.15617140770817241', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '106.37.204.7', '2019-06-28 17:27:57', 0, 1002001015, '账号未登陆', '2019-06-28 17:27:57');
INSERT INTO `access_log` VALUES (45135, '65.3607.15617140792689011', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '106.37.204.7', '2019-06-28 17:27:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 17:27:59');
INSERT INTO `access_log` VALUES (45136, '65.50.15617140817277233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '106.37.204.7', '2019-06-28 17:28:02', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 17:28:02');
INSERT INTO `access_log` VALUES (45137, '65.47.15617140901367205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '106.37.204.7', '2019-06-28 17:28:10', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 17:28:10');
INSERT INTO `access_log` VALUES (45138, '65.46.15617194898447353', 0, 2, 'admin-application', '/admin-api/admins/data_dict/delete', 'id=100', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '27.152.130.126', '2019-06-28 18:58:10', 0, 1002001015, '账号未登陆', '2019-06-28 18:58:10');
INSERT INTO `access_log` VALUES (45139, '65.47.15617237803607337', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-28 20:09:40', 43, 1002001012, '访问令牌已过期', '2019-06-28 20:09:40');
INSERT INTO `access_log` VALUES (45140, '65.49.15617237803607369', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-28 20:09:40', 43, 1002001012, '访问令牌已过期', '2019-06-28 20:09:40');
INSERT INTO `access_log` VALUES (45141, '65.46.15617237803607415', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.102.200.120', '2019-06-28 20:09:40', 44, 1002001012, '访问令牌已过期', '2019-06-28 20:09:40');
INSERT INTO `access_log` VALUES (45142, '65.50.15617242220547381', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.68', '2019-06-28 20:17:02', 0, 1002001015, '账号未登陆', '2019-06-28 20:17:02');
INSERT INTO `access_log` VALUES (45143, '65.51.15617242220587405', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.68', '2019-06-28 20:17:02', 1, 1002001015, '账号未登陆', '2019-06-28 20:17:02');
INSERT INTO `access_log` VALUES (45144, '65.52.15617242220617379', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.68', '2019-06-28 20:17:02', 1, 1002001015, '账号未登陆', '2019-06-28 20:17:02');
INSERT INTO `access_log` VALUES (45145, '65.54.15617242235207323', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.68', '2019-06-28 20:17:04', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 20:17:04');
INSERT INTO `access_log` VALUES (45146, '65.47.15617242314477345', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.68', '2019-06-28 20:17:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 20:17:11');
INSERT INTO `access_log` VALUES (45147, '65.49.15617242379817377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.68', '2019-06-28 20:17:18', 6, 1002002001, '密码不正确', '2019-06-28 20:17:18');
INSERT INTO `access_log` VALUES (45148, '65.47.15617279362667395', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:18:56', 0, 1002001015, '账号未登陆', '2019-06-28 21:18:56');
INSERT INTO `access_log` VALUES (45149, '65.46.15617279362657473', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:18:56', 0, 1002001015, '账号未登陆', '2019-06-28 21:18:56');
INSERT INTO `access_log` VALUES (45150, '65.49.15617279362747427', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:18:56', 2, 1002001015, '账号未登陆', '2019-06-28 21:18:56');
INSERT INTO `access_log` VALUES (45151, '65.50.15617279906257433', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:19:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 21:19:51');
INSERT INTO `access_log` VALUES (45152, '65.51.15617279942897457', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:19:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 21:19:54');
INSERT INTO `access_log` VALUES (45153, '65.54.15617280061277375', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:20:06', 148, 0, '', '2019-06-28 21:20:06');
INSERT INTO `access_log` VALUES (45154, '65.46.15617280069247475', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:20:07', 13, 0, '', '2019-06-28 21:20:07');
INSERT INTO `access_log` VALUES (45155, '65.47.15617280069257397', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:20:07', 13, 0, '', '2019-06-28 21:20:07');
INSERT INTO `access_log` VALUES (45156, '65.49.15617280069267429', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:20:07', 13, 2001001000, '服务端发生异常', '2019-06-28 21:20:07');
INSERT INTO `access_log` VALUES (45157, '65.53.15617280128357425', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:20:13', 8, 0, '', '2019-06-28 21:20:13');
INSERT INTO `access_log` VALUES (45158, '65.45.15617280128467409', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:20:13', 11, 2001001000, '服务端发生异常', '2019-06-28 21:20:13');
INSERT INTO `access_log` VALUES (45159, '65.50.15617280128547435', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:20:13', 9, 0, '', '2019-06-28 21:20:13');
INSERT INTO `access_log` VALUES (45160, '65.51.15617280292777459', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:20:29', 8, 0, '', '2019-06-28 21:20:29');
INSERT INTO `access_log` VALUES (45161, '65.54.15617280292837377', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:20:29', 9, 2001001000, '服务端发生异常', '2019-06-28 21:20:29');
INSERT INTO `access_log` VALUES (45162, '65.46.15617280292937477', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.110.217', '2019-06-28 21:20:29', 8, 0, '', '2019-06-28 21:20:29');
INSERT INTO `access_log` VALUES (45163, '65.51.15617322646187517', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.5.46.242', '2019-06-28 22:31:05', 1, 1002001015, '账号未登陆', '2019-06-28 22:31:05');
INSERT INTO `access_log` VALUES (45164, '65.52.15617322646177491', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.5.46.242', '2019-06-28 22:31:05', 0, 1002001015, '账号未登陆', '2019-06-28 22:31:05');
INSERT INTO `access_log` VALUES (45165, '65.54.15617322646407435', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.5.46.242', '2019-06-28 22:31:05', 0, 1002001015, '账号未登陆', '2019-06-28 22:31:05');
INSERT INTO `access_log` VALUES (45166, '65.47.15617322676907457', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.5.46.242', '2019-06-28 22:31:08', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 22:31:08');
INSERT INTO `access_log` VALUES (45167, '65.50.15617323011727493', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.5.46.242', '2019-06-28 22:31:41', 76, 0, '', '2019-06-28 22:31:41');
INSERT INTO `access_log` VALUES (45168, '65.45.15617323017567467', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.5.46.242', '2019-06-28 22:31:42', 11, 0, '', '2019-06-28 22:31:42');
INSERT INTO `access_log` VALUES (45169, '65.53.15617323017607485', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.5.46.242', '2019-06-28 22:31:42', 10, 2001001000, '服务端发生异常', '2019-06-28 22:31:42');
INSERT INTO `access_log` VALUES (45170, '65.52.15617323018047493', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.5.46.242', '2019-06-28 22:31:42', 9, 0, '', '2019-06-28 22:31:42');
INSERT INTO `access_log` VALUES (45171, '65.47.15617323348017459', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.5.46.242', '2019-06-28 22:32:15', 11, 0, '', '2019-06-28 22:32:15');
INSERT INTO `access_log` VALUES (45172, '65.46.15617323348037537', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.5.46.242', '2019-06-28 22:32:15', 11, 2001001000, '服务端发生异常', '2019-06-28 22:32:15');
INSERT INTO `access_log` VALUES (45173, '65.49.15617323348167491', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '112.5.46.242', '2019-06-28 22:32:15', 8, 0, '', '2019-06-28 22:32:15');
INSERT INTO `access_log` VALUES (45174, '65.50.15617374860877563', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '60.186.217.88', '2019-06-28 23:58:06', 0, 1002001015, '账号未登陆', '2019-06-28 23:58:06');
INSERT INTO `access_log` VALUES (45175, '65.53.15617374860877557', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '60.186.217.88', '2019-06-28 23:58:06', 0, 1002001015, '账号未登陆', '2019-06-28 23:58:06');
INSERT INTO `access_log` VALUES (45176, '65.45.15617374860897539', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '60.186.217.88', '2019-06-28 23:58:06', 0, 1002001015, '账号未登陆', '2019-06-28 23:58:06');
INSERT INTO `access_log` VALUES (45177, '65.51.15617374918807591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '60.186.217.88', '2019-06-28 23:58:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 23:58:12');
INSERT INTO `access_log` VALUES (45178, '65.54.15617375011077509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '60.186.217.88', '2019-06-28 23:58:21', 68, 0, '', '2019-06-28 23:58:21');
INSERT INTO `access_log` VALUES (45179, '65.46.15617375096417607', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0) like Gecko', '60.186.217.88', '2019-06-28 23:58:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-28 23:58:30');
INSERT INTO `access_log` VALUES (45180, '65.54.15617376112317511', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.186.217.88', '2019-06-29 00:00:11', 130, 0, '', '2019-06-29 00:00:11');
INSERT INTO `access_log` VALUES (45181, '65.47.15617376123077531', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.186.217.88', '2019-06-29 00:00:12', 14, 0, '', '2019-06-29 00:00:12');
INSERT INTO `access_log` VALUES (45182, '65.46.15617376123087609', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.186.217.88', '2019-06-29 00:00:12', 16, 2001001000, '服务端发生异常', '2019-06-29 00:00:12');
INSERT INTO `access_log` VALUES (45183, '65.49.15617376123357563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.186.217.88', '2019-06-29 00:00:12', 9, 0, '', '2019-06-29 00:00:12');
INSERT INTO `access_log` VALUES (45184, '65.50.15617376241127567', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.186.217.88', '2019-06-29 00:00:24', 9, 0, '', '2019-06-29 00:00:24');
INSERT INTO `access_log` VALUES (45185, '65.45.15617376241217543', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.186.217.88', '2019-06-29 00:00:24', 11, 2001001000, '服务端发生异常', '2019-06-29 00:00:24');
INSERT INTO `access_log` VALUES (45186, '65.53.15617376241357561', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.186.217.88', '2019-06-29 00:00:24', 8, 0, '', '2019-06-29 00:00:24');
INSERT INTO `access_log` VALUES (45187, '59.79.15617421997326331', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.27.179.220', '2019-06-29 01:16:40', 16, 0, '', '2019-06-29 01:16:40');
INSERT INTO `access_log` VALUES (45188, '59.80.15617421997336317', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.27.179.220', '2019-06-29 01:16:40', 27, 2001001000, '服务端发生异常', '2019-06-29 01:16:40');
INSERT INTO `access_log` VALUES (45189, '65.51.15617711019958041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.170.154.20', '2019-06-29 09:18:22', 15, 1002001012, '访问令牌已过期', '2019-06-29 09:18:22');
INSERT INTO `access_log` VALUES (45190, '65.54.15617711019957959', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.170.154.20', '2019-06-29 09:18:22', 13, 1002001012, '访问令牌已过期', '2019-06-29 09:18:22');
INSERT INTO `access_log` VALUES (45191, '65.46.15617711019968057', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.131.162.68', '2019-06-29 09:18:22', 16, 1002001012, '访问令牌已过期', '2019-06-29 09:18:22');
INSERT INTO `access_log` VALUES (45192, '65.49.15617711075788011', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.170.154.20', '2019-06-29 09:18:28', 102, 0, '', '2019-06-29 09:18:28');
INSERT INTO `access_log` VALUES (45193, '65.3607.15617711079539793', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.170.154.20', '2019-06-29 09:18:28', 12, 2001001000, '服务端发生异常', '2019-06-29 09:18:28');
INSERT INTO `access_log` VALUES (45194, '65.50.15617711079578015', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.131.162.68', '2019-06-29 09:18:28', 9, 0, '', '2019-06-29 09:18:28');
INSERT INTO `access_log` VALUES (45195, '65.45.15617711079577991', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.170.154.20', '2019-06-29 09:18:28', 10, 0, '', '2019-06-29 09:18:28');
INSERT INTO `access_log` VALUES (45196, '59.76.15617713635976711', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.184.221', '2019-06-29 09:22:44', 9, 0, '', '2019-06-29 09:22:44');
INSERT INTO `access_log` VALUES (45197, '59.78.15617713635976713', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.184.221', '2019-06-29 09:22:44', 36, 2001001000, '服务端发生异常', '2019-06-29 09:22:44');
INSERT INTO `access_log` VALUES (45198, '64.80.15617713733926787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.184.221', '2019-06-29 09:22:53', 12, 0, '', '2019-06-29 09:22:53');
INSERT INTO `access_log` VALUES (45199, '64.82.15617713735146789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.184.221', '2019-06-29 09:22:54', 2, 0, '', '2019-06-29 09:22:54');
INSERT INTO `access_log` VALUES (45200, '64.81.15617713837076779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:04', 1, 0, '', '2019-06-29 09:23:04');
INSERT INTO `access_log` VALUES (45201, '59.79.15617713856526721', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:06', 3, 0, '', '2019-06-29 09:23:06');
INSERT INTO `access_log` VALUES (45202, '59.80.15617713856526707', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:06', 15, 2001001000, '服务端发生异常', '2019-06-29 09:23:06');
INSERT INTO `access_log` VALUES (45203, '59.74.15617713993336719', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:19', 3, 0, '', '2019-06-29 09:23:19');
INSERT INTO `access_log` VALUES (45204, '59.77.15617713993346707', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:19', 23, 2001001000, '服务端发生异常', '2019-06-29 09:23:19');
INSERT INTO `access_log` VALUES (45205, '64.77.15617714063786781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:26', 2, 0, '', '2019-06-29 09:23:26');
INSERT INTO `access_log` VALUES (45206, '64.84.15617714065276779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:27', 2, 0, '', '2019-06-29 09:23:27');
INSERT INTO `access_log` VALUES (45207, '64.85.15617714081826801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:28', 2, 0, '', '2019-06-29 09:23:28');
INSERT INTO `access_log` VALUES (45208, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:28', 7, 0, '', '2019-06-29 09:23:28');
INSERT INTO `access_log` VALUES (45209, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:31', 5, 0, '', '2019-06-29 09:23:31');
INSERT INTO `access_log` VALUES (45210, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:31', 5, 0, '', '2019-06-29 09:23:31');
INSERT INTO `access_log` VALUES (45211, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:32', 5, 0, '', '2019-06-29 09:23:32');
INSERT INTO `access_log` VALUES (45212, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:32', 4, 0, '', '2019-06-29 09:23:32');
INSERT INTO `access_log` VALUES (45213, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:32', 5, 0, '', '2019-06-29 09:23:32');
INSERT INTO `access_log` VALUES (45214, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:33', 6, 0, '', '2019-06-29 09:23:33');
INSERT INTO `access_log` VALUES (45215, '64.83.15617714135616779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:34', 2, 0, '', '2019-06-29 09:23:34');
INSERT INTO `access_log` VALUES (45216, '64.76.15617714137306773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:34', 2, 0, '', '2019-06-29 09:23:34');
INSERT INTO `access_log` VALUES (45217, '64.80.15617714145286789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:35', 2, 0, '', '2019-06-29 09:23:35');
INSERT INTO `access_log` VALUES (45218, '64.81.15617714156026781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:36', 2, 0, '', '2019-06-29 09:23:36');
INSERT INTO `access_log` VALUES (45219, '64.79.15617714173906793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:37', 2, 0, '', '2019-06-29 09:23:37');
INSERT INTO `access_log` VALUES (45220, '64.78.15617714175336791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:38', 2, 0, '', '2019-06-29 09:23:38');
INSERT INTO `access_log` VALUES (45221, '64.77.15617714185536783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:39', 2, 0, '', '2019-06-29 09:23:39');
INSERT INTO `access_log` VALUES (45222, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:39', 7, 0, '', '2019-06-29 09:23:39');
INSERT INTO `access_log` VALUES (45223, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:40', 6, 0, '', '2019-06-29 09:23:40');
INSERT INTO `access_log` VALUES (45224, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:41', 6, 0, '', '2019-06-29 09:23:41');
INSERT INTO `access_log` VALUES (45225, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:42', 7, 0, '', '2019-06-29 09:23:42');
INSERT INTO `access_log` VALUES (45226, '64.84.15617714248006781', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:23:45', 10, 0, '', '2019-06-29 09:23:45');
INSERT INTO `access_log` VALUES (45227, '64.83.15617714399046781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:00', 2, 0, '', '2019-06-29 09:24:00');
INSERT INTO `access_log` VALUES (45228, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:00', 6, 0, '', '2019-06-29 09:24:00');
INSERT INTO `access_log` VALUES (45229, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:02', 6, 0, '', '2019-06-29 09:24:02');
INSERT INTO `access_log` VALUES (45230, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:02', 5, 0, '', '2019-06-29 09:24:02');
INSERT INTO `access_log` VALUES (45231, '64.76.15617714428016775', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:03', 6, 0, '', '2019-06-29 09:24:03');
INSERT INTO `access_log` VALUES (45232, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:06', 6, 0, '', '2019-06-29 09:24:06');
INSERT INTO `access_log` VALUES (45233, '64.82.15617714457536793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:06', 2, 0, '', '2019-06-29 09:24:06');
INSERT INTO `access_log` VALUES (45234, '64.81.15617714481466783', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:08', 5, 0, '', '2019-06-29 09:24:08');
INSERT INTO `access_log` VALUES (45235, '64.79.15617714516616795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:12', 2, 0, '', '2019-06-29 09:24:12');
INSERT INTO `access_log` VALUES (45236, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:12', 5, 0, '', '2019-06-29 09:24:12');
INSERT INTO `access_log` VALUES (45237, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:13', 6, 0, '', '2019-06-29 09:24:13');
INSERT INTO `access_log` VALUES (45238, '64.78.15617714546666793', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:15', 6, 0, '', '2019-06-29 09:24:15');
INSERT INTO `access_log` VALUES (45239, '64.77.15617714573686785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:17', 2, 0, '', '2019-06-29 09:24:17');
INSERT INTO `access_log` VALUES (45240, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:17', 6, 0, '', '2019-06-29 09:24:17');
INSERT INTO `access_log` VALUES (45241, '64.84.15617714582126783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:18', 1, 0, '', '2019-06-29 09:24:18');
INSERT INTO `access_log` VALUES (45242, '64.85.15617714584006805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:18', 2, 0, '', '2019-06-29 09:24:18');
INSERT INTO `access_log` VALUES (45243, '64.83.15617714597636783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:20', 3, 0, '', '2019-06-29 09:24:20');
INSERT INTO `access_log` VALUES (45244, '64.80.15617714636026793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:24', 2, 0, '', '2019-06-29 09:24:24');
INSERT INTO `access_log` VALUES (45245, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:24', 6, 0, '', '2019-06-29 09:24:24');
INSERT INTO `access_log` VALUES (45246, '64.82.15617714665246795', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:27', 6, 0, '', '2019-06-29 09:24:27');
INSERT INTO `access_log` VALUES (45247, '64.79.15617714851296797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:45', 2, 0, '', '2019-06-29 09:24:45');
INSERT INTO `access_log` VALUES (45248, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:45', 6, 0, '', '2019-06-29 09:24:45');
INSERT INTO `access_log` VALUES (45249, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '113.118.184.221', '2019-06-29 09:24:47', 5, 0, '', '2019-06-29 09:24:47');
INSERT INTO `access_log` VALUES (45250, '65.46.15617730881598085', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '120.244.100.186', '2019-06-29 09:51:28', 0, 1002001015, '账号未登陆', '2019-06-29 09:51:28');
INSERT INTO `access_log` VALUES (45251, '65.51.15617730881598069', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '120.244.100.186', '2019-06-29 09:51:28', 0, 1002001015, '账号未登陆', '2019-06-29 09:51:28');
INSERT INTO `access_log` VALUES (45252, '65.54.15617730881597987', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '120.244.100.186', '2019-06-29 09:51:28', 0, 1002001015, '账号未登陆', '2019-06-29 09:51:28');
INSERT INTO `access_log` VALUES (45253, '65.46.15617786153548161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.240.83.67', '2019-06-29 11:23:35', 91, 0, '', '2019-06-29 11:23:35');
INSERT INTO `access_log` VALUES (45254, '65.49.15617786156418113', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.240.83.67', '2019-06-29 11:23:36', 16, 0, '', '2019-06-29 11:23:36');
INSERT INTO `access_log` VALUES (45255, '65.54.15617786156388063', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.240.83.67', '2019-06-29 11:23:36', 19, 0, '', '2019-06-29 11:23:36');
INSERT INTO `access_log` VALUES (45256, '65.53.15617786156388111', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.240.83.67', '2019-06-29 11:23:36', 22, 2001001000, '服务端发生异常', '2019-06-29 11:23:36');
INSERT INTO `access_log` VALUES (45257, '65.52.15617787241478119', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.149.232', '2019-06-29 11:25:24', 4, 1002001012, '访问令牌已过期', '2019-06-29 11:25:24');
INSERT INTO `access_log` VALUES (45258, '65.50.15617787241528119', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.149.232', '2019-06-29 11:25:24', 4, 1002001012, '访问令牌已过期', '2019-06-29 11:25:24');
INSERT INTO `access_log` VALUES (45259, '65.46.15617787241578163', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.149.232', '2019-06-29 11:25:24', 4, 1002001012, '访问令牌已过期', '2019-06-29 11:25:24');
INSERT INTO `access_log` VALUES (45260, '65.54.15617787284728067', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.149.232', '2019-06-29 11:25:28', 85, 0, '', '2019-06-29 11:25:29');
INSERT INTO `access_log` VALUES (45261, '65.53.15617787287658113', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.149.232', '2019-06-29 11:25:29', 8, 0, '', '2019-06-29 11:25:29');
INSERT INTO `access_log` VALUES (45262, '65.49.15617787287698117', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.149.232', '2019-06-29 11:25:29', 9, 2001001000, '服务端发生异常', '2019-06-29 11:25:29');
INSERT INTO `access_log` VALUES (45263, '65.45.15617787287748097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.149.232', '2019-06-29 11:25:29', 8, 0, '', '2019-06-29 11:25:29');
INSERT INTO `access_log` VALUES (45264, '65.54.15617788221448069', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.149.232', '2019-06-29 11:27:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 11:27:02');
INSERT INTO `access_log` VALUES (45265, '65.49.15617788265428119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.149.232', '2019-06-29 11:27:07', 80, 0, '', '2019-06-29 11:27:07');
INSERT INTO `access_log` VALUES (45266, '65.53.15617788267978115', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.149.232', '2019-06-29 11:27:07', 9, 0, '', '2019-06-29 11:27:07');
INSERT INTO `access_log` VALUES (45267, '65.51.15617788268098151', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.149.232', '2019-06-29 11:27:07', 9, 0, '', '2019-06-29 11:27:07');
INSERT INTO `access_log` VALUES (45268, '65.45.15617788268098099', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.149.232', '2019-06-29 11:27:07', 9, 2001001000, '服务端发生异常', '2019-06-29 11:27:07');
INSERT INTO `access_log` VALUES (45269, '59.71.15617789109906821', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.156.8', '2019-06-29 11:28:31', 11, 0, '', '2019-06-29 11:28:31');
INSERT INTO `access_log` VALUES (45270, '59.78.15617789109916815', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.156.8', '2019-06-29 11:28:31', 22, 2001001000, '服务端发生异常', '2019-06-29 11:28:31');
INSERT INTO `access_log` VALUES (45271, '64.81.15617789137406885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.156.8', '2019-06-29 11:28:34', 11, 0, '', '2019-06-29 11:28:34');
INSERT INTO `access_log` VALUES (45272, '64.78.15617789138996895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.156.8', '2019-06-29 11:28:34', 3, 0, '', '2019-06-29 11:28:34');
INSERT INTO `access_log` VALUES (45273, '64.85.15617789176456905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.156.8', '2019-06-29 11:28:38', 2, 0, '', '2019-06-29 11:28:38');
INSERT INTO `access_log` VALUES (45274, '64.80.15617789177566895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.156.8', '2019-06-29 11:28:38', 2, 0, '', '2019-06-29 11:28:38');
INSERT INTO `access_log` VALUES (45275, '59.72.15617789182616817', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.156.8', '2019-06-29 11:28:38', 3, 0, '', '2019-06-29 11:28:38');
INSERT INTO `access_log` VALUES (45276, '59.73.15617789182606827', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.156.8', '2019-06-29 11:28:38', 22, 2001001000, '服务端发生异常', '2019-06-29 11:28:38');
INSERT INTO `access_log` VALUES (45277, '59.73.15617790618136829', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.134.216.221', '2019-06-29 11:31:02', 3, 0, '', '2019-06-29 11:31:02');
INSERT INTO `access_log` VALUES (45278, '59.80.15617790618136811', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.134.216.221', '2019-06-29 11:31:02', 13, 2001001000, '服务端发生异常', '2019-06-29 11:31:02');
INSERT INTO `access_log` VALUES (45279, '59.74.15617790682856823', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:08', 2, 0, '', '2019-06-29 11:31:08');
INSERT INTO `access_log` VALUES (45280, '59.75.15617790682856827', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:08', 35, 2001001000, '服务端发生异常', '2019-06-29 11:31:08');
INSERT INTO `access_log` VALUES (45281, '64.83.15617790702426887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:10', 2, 0, '', '2019-06-29 11:31:10');
INSERT INTO `access_log` VALUES (45282, '64.76.15617790704376881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:10', 1, 0, '', '2019-06-29 11:31:10');
INSERT INTO `access_log` VALUES (45283, '64.79.15617790718226901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:12', 2, 0, '', '2019-06-29 11:31:12');
INSERT INTO `access_log` VALUES (45284, '64.84.15617790723986887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:12', 2, 0, '', '2019-06-29 11:31:12');
INSERT INTO `access_log` VALUES (45285, '64.82.15617790730736899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:13', 2, 0, '', '2019-06-29 11:31:13');
INSERT INTO `access_log` VALUES (45286, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:13', 5, 0, '', '2019-06-29 11:31:13');
INSERT INTO `access_log` VALUES (45287, '64.81.15617790744616889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:14', 2, 0, '', '2019-06-29 11:31:14');
INSERT INTO `access_log` VALUES (45288, '64.78.15617790747976899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:15', 1, 0, '', '2019-06-29 11:31:15');
INSERT INTO `access_log` VALUES (45289, '64.77.15617790757536889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:16', 2, 0, '', '2019-06-29 11:31:16');
INSERT INTO `access_log` VALUES (45290, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:16', 6, 0, '', '2019-06-29 11:31:16');
INSERT INTO `access_log` VALUES (45291, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:17', 6, 0, '', '2019-06-29 11:31:17');
INSERT INTO `access_log` VALUES (45292, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:18', 6, 0, '', '2019-06-29 11:31:18');
INSERT INTO `access_log` VALUES (45293, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:19', 5, 0, '', '2019-06-29 11:31:19');
INSERT INTO `access_log` VALUES (45294, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:20', 6, 0, '', '2019-06-29 11:31:20');
INSERT INTO `access_log` VALUES (45295, '64.85.15617790804226909', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:20', 8, 0, '', '2019-06-29 11:31:20');
INSERT INTO `access_log` VALUES (45296, '64.79.15617791135646903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:54', 2, 0, '', '2019-06-29 11:31:54');
INSERT INTO `access_log` VALUES (45297, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:54', 6, 0, '', '2019-06-29 11:31:54');
INSERT INTO `access_log` VALUES (45298, '64.84.15617791149196889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:55', 2, 0, '', '2019-06-29 11:31:55');
INSERT INTO `access_log` VALUES (45299, '64.82.15617791150506901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:31:55', 2, 0, '', '2019-06-29 11:31:55');
INSERT INTO `access_log` VALUES (45300, '64.81.15617791213706891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:32:01', 2, 0, '', '2019-06-29 11:32:01');
INSERT INTO `access_log` VALUES (45301, '64.78.15617791214836901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:32:01', 2, 0, '', '2019-06-29 11:32:01');
INSERT INTO `access_log` VALUES (45302, '59.72.15617791302836821', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:32:10', 4, 0, '', '2019-06-29 11:32:10');
INSERT INTO `access_log` VALUES (45303, '59.73.15617791302846831', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.134.216.221', '2019-06-29 11:32:10', 15, 2001001000, '服务端发生异常', '2019-06-29 11:32:10');
INSERT INTO `access_log` VALUES (45304, '65.51.15617817444018193', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '61.142.114.74', '2019-06-29 12:15:44', 1, 1002001015, '账号未登陆', '2019-06-29 12:15:44');
INSERT INTO `access_log` VALUES (45305, '65.49.15617817444018161', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '61.142.114.74', '2019-06-29 12:15:44', 1, 1002001015, '账号未登陆', '2019-06-29 12:15:44');
INSERT INTO `access_log` VALUES (45306, '65.45.15617817444018141', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '61.142.114.74', '2019-06-29 12:15:44', 0, 1002001015, '账号未登陆', '2019-06-29 12:15:44');
INSERT INTO `access_log` VALUES (45307, '65.53.15617817524478157', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '61.142.114.74', '2019-06-29 12:15:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 12:15:52');
INSERT INTO `access_log` VALUES (45308, '65.54.15617818169738111', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '61.142.114.74', '2019-06-29 12:16:57', 870, 0, '', '2019-06-29 12:16:58');
INSERT INTO `access_log` VALUES (45309, '65.51.15617818180848195', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '61.142.114.74', '2019-06-29 12:16:58', 10, 0, '', '2019-06-29 12:16:58');
INSERT INTO `access_log` VALUES (45310, '65.45.15617818180948143', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '61.142.114.74', '2019-06-29 12:16:58', 11, 2001001000, '服务端发生异常', '2019-06-29 12:16:58');
INSERT INTO `access_log` VALUES (45311, '65.49.15617818180978163', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '61.142.114.74', '2019-06-29 12:16:58', 9, 0, '', '2019-06-29 12:16:58');
INSERT INTO `access_log` VALUES (45312, '65.49.15617824073618171', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '54.186.178.251', '2019-06-29 12:26:47', 1, 1002001015, '账号未登陆', '2019-06-29 12:26:47');
INSERT INTO `access_log` VALUES (45313, '65.45.15617883234698233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '59.63.204.198', '2019-06-29 14:05:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 14:05:23');
INSERT INTO `access_log` VALUES (45314, '64.83.15617895185787029', 0, 2, 'product-application', '/product-api/admins/attr/update', 'id=1&name=颜色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.82.8.66', '2019-06-29 14:25:19', 1, 1002001015, '账号未登陆', '2019-06-29 14:25:19');
INSERT INTO `access_log` VALUES (45315, '59.71.15617909197296983', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.80.11.235', '2019-06-29 14:48:40', 19, 0, '', '2019-06-29 14:48:40');
INSERT INTO `access_log` VALUES (45316, '59.76.15617909197316975', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.80.11.235', '2019-06-29 14:48:40', 27, 2001001000, '服务端发生异常', '2019-06-29 14:48:40');
INSERT INTO `access_log` VALUES (45317, '64.81.15617909232837051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.80.11.235', '2019-06-29 14:48:43', 13, 0, '', '2019-06-29 14:48:43');
INSERT INTO `access_log` VALUES (45318, '64.78.15617909234167059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.80.11.235', '2019-06-29 14:48:43', 3, 0, '', '2019-06-29 14:48:43');
INSERT INTO `access_log` VALUES (45319, '64.77.15617909243857049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.80.11.235', '2019-06-29 14:48:44', 2, 0, '', '2019-06-29 14:48:44');
INSERT INTO `access_log` VALUES (45320, '64.85.15617909246907069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.80.11.235', '2019-06-29 14:48:45', 2, 0, '', '2019-06-29 14:48:45');
INSERT INTO `access_log` VALUES (45321, '65.54.15617909376888237', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.80.11.235', '2019-06-29 14:48:58', 1, 1002001015, '账号未登陆', '2019-06-29 14:48:58');
INSERT INTO `access_log` VALUES (45322, '65.46.15617909376888333', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.80.11.235', '2019-06-29 14:48:58', 1, 1002001015, '账号未登陆', '2019-06-29 14:48:58');
INSERT INTO `access_log` VALUES (45323, '65.47.15617909376888251', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.80.11.235', '2019-06-29 14:48:58', 1, 1002001015, '账号未登陆', '2019-06-29 14:48:58');
INSERT INTO `access_log` VALUES (45324, '65.3607.15617909394020065', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.80.11.235', '2019-06-29 14:48:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 14:48:59');
INSERT INTO `access_log` VALUES (45325, '65.45.15617909412068269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '114.80.11.235', '2019-06-29 14:49:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 14:49:01');
INSERT INTO `access_log` VALUES (45326, '65.51.15617926517198343', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.240', '2019-06-29 15:17:32', 4, 1002001012, '访问令牌已过期', '2019-06-29 15:17:32');
INSERT INTO `access_log` VALUES (45327, '65.54.15617926517228261', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.240', '2019-06-29 15:17:32', 3, 1002001012, '访问令牌已过期', '2019-06-29 15:17:32');
INSERT INTO `access_log` VALUES (45328, '65.46.15617926517378357', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.240', '2019-06-29 15:17:32', 11, 1002001012, '访问令牌已过期', '2019-06-29 15:17:32');
INSERT INTO `access_log` VALUES (45329, '65.3607.15617926608080089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.240', '2019-06-29 15:17:41', 82, 0, '', '2019-06-29 15:17:41');
INSERT INTO `access_log` VALUES (45330, '65.50.15617926612978309', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.240', '2019-06-29 15:17:41', 58, 0, '', '2019-06-29 15:17:41');
INSERT INTO `access_log` VALUES (45331, '65.52.15617926612888315', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.240', '2019-06-29 15:17:41', 68, 2001001000, '服务端发生异常', '2019-06-29 15:17:41');
INSERT INTO `access_log` VALUES (45332, '65.45.15617926612778293', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.240', '2019-06-29 15:17:41', 78, 0, '', '2019-06-29 15:17:41');
INSERT INTO `access_log` VALUES (45333, '65.53.15617926657298309', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.240', '2019-06-29 15:17:46', 8, 0, '', '2019-06-29 15:17:46');
INSERT INTO `access_log` VALUES (45334, '65.51.15617926657458345', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.240', '2019-06-29 15:17:46', 169, 0, '', '2019-06-29 15:17:46');
INSERT INTO `access_log` VALUES (45335, '65.49.15617926657378311', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.230.101.240', '2019-06-29 15:17:46', 178, 2001001000, '服务端发生异常', '2019-06-29 15:17:46');
INSERT INTO `access_log` VALUES (45336, '59.77.15617933958227003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.253.182', '2019-06-29 15:29:56', 17, 0, '', '2019-06-29 15:29:56');
INSERT INTO `access_log` VALUES (45337, '59.75.15617933958217019', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.253.182', '2019-06-29 15:29:56', 34, 2001001000, '服务端发生异常', '2019-06-29 15:29:56');
INSERT INTO `access_log` VALUES (45338, '59.78.15617934030637011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.188.71', '2019-06-29 15:30:03', 20, 2001001000, '服务端发生异常', '2019-06-29 15:30:03');
INSERT INTO `access_log` VALUES (45339, '59.71.15617934037697017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.188.103', '2019-06-29 15:30:04', 4, 0, '', '2019-06-29 15:30:04');
INSERT INTO `access_log` VALUES (45340, '59.73.15617938717457029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:37:52', 3, 0, '', '2019-06-29 15:37:52');
INSERT INTO `access_log` VALUES (45341, '59.80.15617938717457011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:37:52', 12, 2001001000, '服务端发生异常', '2019-06-29 15:37:52');
INSERT INTO `access_log` VALUES (45342, '59.79.15617938795197025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:38:00', 2, 0, '', '2019-06-29 15:38:00');
INSERT INTO `access_log` VALUES (45343, '59.74.15617938795197023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:38:00', 20, 2001001000, '服务端发生异常', '2019-06-29 15:38:00');
INSERT INTO `access_log` VALUES (45344, '65.54.15617938819428279', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:38:02', 4, 1002001012, '访问令牌已过期', '2019-06-29 15:38:02');
INSERT INTO `access_log` VALUES (45345, '65.47.15617938819438293', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:38:02', 4, 1002001012, '访问令牌已过期', '2019-06-29 15:38:02');
INSERT INTO `access_log` VALUES (45346, '65.3607.15617938819440107', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:38:02', 3, 1002001012, '访问令牌已过期', '2019-06-29 15:38:02');
INSERT INTO `access_log` VALUES (45347, '65.50.15617938863638327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:38:06', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 15:38:06');
INSERT INTO `access_log` VALUES (45348, '65.49.15617939210428329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:38:41', 101, 0, '', '2019-06-29 15:38:41');
INSERT INTO `access_log` VALUES (45349, '65.46.15617939214638377', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:38:41', 18, 0, '', '2019-06-29 15:38:41');
INSERT INTO `access_log` VALUES (45350, '65.51.15617939214628363', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:38:41', 18, 0, '', '2019-06-29 15:38:41');
INSERT INTO `access_log` VALUES (45351, '65.3607.15617939214630109', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:38:41', 19, 2001001000, '服务端发生异常', '2019-06-29 15:38:41');
INSERT INTO `access_log` VALUES (45352, '65.45.15617939467938313', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:39:07', 10, 0, '', '2019-06-29 15:39:07');
INSERT INTO `access_log` VALUES (45353, '65.54.15617939467938281', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:39:07', 9, 0, '', '2019-06-29 15:39:07');
INSERT INTO `access_log` VALUES (45354, '65.50.15617939467938329', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:39:07', 10, 2001001000, '服务端发生异常', '2019-06-29 15:39:07');
INSERT INTO `access_log` VALUES (45355, '64.79.15617939703527103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.180.222.26', '2019-06-29 15:39:30', 12, 0, '', '2019-06-29 15:39:30');
INSERT INTO `access_log` VALUES (45356, '64.84.15617939704947089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.180.222.26', '2019-06-29 15:39:30', 3, 0, '', '2019-06-29 15:39:30');
INSERT INTO `access_log` VALUES (45357, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.180.222.26', '2019-06-29 15:39:35', 6, 0, '', '2019-06-29 15:39:35');
INSERT INTO `access_log` VALUES (45358, '64.82.15617939752887103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.180.222.26', '2019-06-29 15:39:35', 1, 0, '', '2019-06-29 15:39:35');
INSERT INTO `access_log` VALUES (45359, '64.78.15617939799907101', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.180.222.26', '2019-06-29 15:39:40', 8, 0, '', '2019-06-29 15:39:40');
INSERT INTO `access_log` VALUES (45360, '64.85.15617939978127111', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.180.222.26', '2019-06-29 15:39:58', 6, 0, '', '2019-06-29 15:39:58');
INSERT INTO `access_log` VALUES (45361, '65.54.15617940451888283', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 15:40:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 15:40:45');
INSERT INTO `access_log` VALUES (45362, '65.54.15617955288088303', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.180.222.26', '2019-06-29 16:05:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 16:05:29');
INSERT INTO `access_log` VALUES (45363, '65.52.15617970567688377', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.216.34.20', '2019-06-29 16:30:57', 0, 1002001015, '账号未登陆', '2019-06-29 16:30:57');
INSERT INTO `access_log` VALUES (45364, '65.53.15617970567688371', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.216.34.20', '2019-06-29 16:30:57', 0, 1002001015, '账号未登陆', '2019-06-29 16:30:57');
INSERT INTO `access_log` VALUES (45365, '65.49.15617970567698373', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.216.34.20', '2019-06-29 16:30:57', 0, 1002001015, '账号未登陆', '2019-06-29 16:30:57');
INSERT INTO `access_log` VALUES (45366, '65.3607.15617970587530153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.216.34.20', '2019-06-29 16:30:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 16:30:59');
INSERT INTO `access_log` VALUES (45367, '65.46.15617970663198421', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.216.34.20', '2019-06-29 16:31:06', 85, 0, '', '2019-06-29 16:31:06');
INSERT INTO `access_log` VALUES (45368, '65.51.15617970666128407', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.216.34.20', '2019-06-29 16:31:07', 10, 0, '', '2019-06-29 16:31:07');
INSERT INTO `access_log` VALUES (45369, '65.47.15617970666158339', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.216.34.20', '2019-06-29 16:31:07', 10, 2001001000, '服务端发生异常', '2019-06-29 16:31:07');
INSERT INTO `access_log` VALUES (45370, '65.54.15617970666218325', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.216.34.20', '2019-06-29 16:31:07', 10, 0, '', '2019-06-29 16:31:07');
INSERT INTO `access_log` VALUES (45371, '65.45.15617970732408357', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.216.34.20', '2019-06-29 16:31:13', 139, 0, '', '2019-06-29 16:31:13');
INSERT INTO `access_log` VALUES (45372, '65.53.15617970732488373', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.216.34.20', '2019-06-29 16:31:13', 132, 0, '', '2019-06-29 16:31:13');
INSERT INTO `access_log` VALUES (45373, '65.52.15617970732448379', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.216.34.20', '2019-06-29 16:31:13', 137, 2001001000, '服务端发生异常', '2019-06-29 16:31:13');
INSERT INTO `access_log` VALUES (45374, '65.46.15618028155878501', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.46.232', '2019-06-29 18:06:56', 1, 1002001015, '账号未登陆', '2019-06-29 18:06:56');
INSERT INTO `access_log` VALUES (45375, '65.54.15618028155878401', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.46.232', '2019-06-29 18:06:56', 1, 1002001015, '账号未登陆', '2019-06-29 18:06:56');
INSERT INTO `access_log` VALUES (45376, '65.51.15618028155878485', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.46.232', '2019-06-29 18:06:56', 0, 1002001015, '账号未登陆', '2019-06-29 18:06:56');
INSERT INTO `access_log` VALUES (45377, '65.47.15618028186258417', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.46.232', '2019-06-29 18:06:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 18:06:59');
INSERT INTO `access_log` VALUES (45378, '65.53.15618028322698449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.46.232', '2019-06-29 18:07:12', 108, 0, '', '2019-06-29 18:07:12');
INSERT INTO `access_log` VALUES (45379, '65.45.15618028327808433', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.46.232', '2019-06-29 18:07:13', 12, 0, '', '2019-06-29 18:07:13');
INSERT INTO `access_log` VALUES (45380, '65.49.15618028327858455', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.46.232', '2019-06-29 18:07:13', 11, 0, '', '2019-06-29 18:07:13');
INSERT INTO `access_log` VALUES (45381, '65.52.15618028327858459', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.46.232', '2019-06-29 18:07:13', 12, 2001001000, '服务端发生异常', '2019-06-29 18:07:13');
INSERT INTO `access_log` VALUES (45382, '59.76.15618066732637187', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '42.102.192.142', '2019-06-29 19:11:13', 27, 2001001000, '服务端发生异常', '2019-06-29 19:11:13');
INSERT INTO `access_log` VALUES (45383, '59.71.15618066732637195', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '42.102.192.142', '2019-06-29 19:11:13', 79, 0, '', '2019-06-29 19:11:13');
INSERT INTO `access_log` VALUES (45384, '59.79.15618067036157197', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '42.102.192.142', '2019-06-29 19:11:44', 3, 0, '', '2019-06-29 19:11:44');
INSERT INTO `access_log` VALUES (45385, '59.73.15618067036157201', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '42.102.192.142', '2019-06-29 19:11:44', 14, 2001001000, '服务端发生异常', '2019-06-29 19:11:44');
INSERT INTO `access_log` VALUES (45386, '65.3607.15618067360110285', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '42.102.192.142', '2019-06-29 19:12:16', 0, 1002001015, '账号未登陆', '2019-06-29 19:12:16');
INSERT INTO `access_log` VALUES (45387, '65.45.15618067360118487', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '42.102.192.142', '2019-06-29 19:12:16', 0, 1002001015, '账号未登陆', '2019-06-29 19:12:16');
INSERT INTO `access_log` VALUES (45388, '65.54.15618067360438455', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '42.102.192.142', '2019-06-29 19:12:16', 0, 1002001015, '账号未登陆', '2019-06-29 19:12:16');
INSERT INTO `access_log` VALUES (45389, '65.50.15618067542988509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '42.102.192.142', '2019-06-29 19:12:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 19:12:34');
INSERT INTO `access_log` VALUES (45390, '65.51.15618069008478541', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-06-29 19:15:01', 1, 1002001015, '账号未登陆', '2019-06-29 19:15:01');
INSERT INTO `access_log` VALUES (45391, '65.47.15618069008478473', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-06-29 19:15:01', 1, 1002001015, '账号未登陆', '2019-06-29 19:15:01');
INSERT INTO `access_log` VALUES (45392, '65.53.15618069008548507', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-06-29 19:15:01', 0, 1002001015, '账号未登陆', '2019-06-29 19:15:01');
INSERT INTO `access_log` VALUES (45393, '65.49.15618069087838511', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-06-29 19:15:09', 78, 0, '', '2019-06-29 19:15:09');
INSERT INTO `access_log` VALUES (45394, '65.3607.15618069092320289', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-06-29 19:15:09', 9, 0, '', '2019-06-29 19:15:09');
INSERT INTO `access_log` VALUES (45395, '65.54.15618069092518459', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-06-29 19:15:09', 9, 0, '', '2019-06-29 19:15:09');
INSERT INTO `access_log` VALUES (45396, '65.45.15618069092518491', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-06-29 19:15:09', 9, 2001001000, '服务端发生异常', '2019-06-29 19:15:09');
INSERT INTO `access_log` VALUES (45397, '59.72.15618136418477287', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:07:22', 10, 0, '', '2019-06-29 21:07:22');
INSERT INTO `access_log` VALUES (45398, '59.80.15618136418547277', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:07:22', 41, 2001001000, '服务端发生异常', '2019-06-29 21:07:22');
INSERT INTO `access_log` VALUES (45399, '64.80.15618136566147361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:07:37', 10, 0, '', '2019-06-29 21:07:37');
INSERT INTO `access_log` VALUES (45400, '64.83.15618136569097351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:07:37', 3, 0, '', '2019-06-29 21:07:37');
INSERT INTO `access_log` VALUES (45401, '59.73.15618136587317295', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:07:39', 3, 0, '', '2019-06-29 21:07:39');
INSERT INTO `access_log` VALUES (45402, '59.74.15618136588047291', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:07:39', 17, 2001001000, '服务端发生异常', '2019-06-29 21:07:39');
INSERT INTO `access_log` VALUES (45403, '64.76.15618136619957351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:07:42', 2, 0, '', '2019-06-29 21:07:42');
INSERT INTO `access_log` VALUES (45404, '64.79.15618136621907369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:07:42', 2, 0, '', '2019-06-29 21:07:42');
INSERT INTO `access_log` VALUES (45405, '64.84.15618136639457355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:07:44', 2, 0, '', '2019-06-29 21:07:44');
INSERT INTO `access_log` VALUES (45406, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:07:44', 6, 0, '', '2019-06-29 21:07:44');
INSERT INTO `access_log` VALUES (45407, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:07:46', 6, 0, '', '2019-06-29 21:07:46');
INSERT INTO `access_log` VALUES (45408, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:07:46', 13, 0, '', '2019-06-29 21:07:46');
INSERT INTO `access_log` VALUES (45409, '64.81.15618136716407359', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:07:52', 7, 0, '', '2019-06-29 21:07:52');
INSERT INTO `access_log` VALUES (45410, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:08', 5, 0, '', '2019-06-29 21:08:08');
INSERT INTO `access_log` VALUES (45411, '64.77.15618136876997355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:08', 2, 0, '', '2019-06-29 21:08:08');
INSERT INTO `access_log` VALUES (45412, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:11', 5, 0, '', '2019-06-29 21:08:11');
INSERT INTO `access_log` VALUES (45413, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:11', 6, 0, '', '2019-06-29 21:08:11');
INSERT INTO `access_log` VALUES (45414, '64.85.15618136926787377', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:13', 5, 0, '', '2019-06-29 21:08:13');
INSERT INTO `access_log` VALUES (45415, '64.83.15618137085837353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:29', 2, 0, '', '2019-06-29 21:08:29');
INSERT INTO `access_log` VALUES (45416, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:29', 6, 0, '', '2019-06-29 21:08:29');
INSERT INTO `access_log` VALUES (45417, '64.76.15618137099227353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:30', 2, 0, '', '2019-06-29 21:08:30');
INSERT INTO `access_log` VALUES (45418, '64.79.15618137101287371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:30', 1, 0, '', '2019-06-29 21:08:30');
INSERT INTO `access_log` VALUES (45419, '59.71.15618137107667289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:31', 2, 0, '', '2019-06-29 21:08:31');
INSERT INTO `access_log` VALUES (45420, '59.76.15618137107997283', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:31', 12, 2001001000, '服务端发生异常', '2019-06-29 21:08:31');
INSERT INTO `access_log` VALUES (45421, '64.84.15618137114227357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:31', 2, 0, '', '2019-06-29 21:08:31');
INSERT INTO `access_log` VALUES (45422, '64.82.15618137116007371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:32', 2, 0, '', '2019-06-29 21:08:32');
INSERT INTO `access_log` VALUES (45423, '59.72.15618137138787289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:34', 3, 0, '', '2019-06-29 21:08:34');
INSERT INTO `access_log` VALUES (45424, '59.80.15618137138807279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 6.0.1; zh-CN; MI 5s Plus Build/MXB48T) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.8.3.963 Mobile Safari/537.36', '27.18.134.248', '2019-06-29 21:08:34', 18, 2001001000, '服务端发生异常', '2019-06-29 21:08:34');
INSERT INTO `access_log` VALUES (45425, '65.46.15618137188318653', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.226.185.71', '2019-06-29 21:08:39', 0, 1002001015, '账号未登陆', '2019-06-29 21:08:39');
INSERT INTO `access_log` VALUES (45426, '65.54.15618137188318549', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.226.185.71', '2019-06-29 21:08:39', 0, 1002001015, '账号未登陆', '2019-06-29 21:08:39');
INSERT INTO `access_log` VALUES (45427, '65.50.15618137188348605', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.223.1', '2019-06-29 21:08:39', 0, 1002001015, '账号未登陆', '2019-06-29 21:08:39');
INSERT INTO `access_log` VALUES (45428, '65.51.15618137241728633', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.83.221.183', '2019-06-29 21:08:44', 62, 0, '', '2019-06-29 21:08:44');
INSERT INTO `access_log` VALUES (45429, '65.52.15618137245588609', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.196', '2019-06-29 21:08:45', 15, 0, '', '2019-06-29 21:08:45');
INSERT INTO `access_log` VALUES (45430, '65.47.15618137245588565', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.83.221.183', '2019-06-29 21:08:45', 18, 2001001000, '服务端发生异常', '2019-06-29 21:08:45');
INSERT INTO `access_log` VALUES (45431, '65.49.15618137245828605', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.223.3', '2019-06-29 21:08:45', 7, 0, '', '2019-06-29 21:08:45');
INSERT INTO `access_log` VALUES (45432, '65.54.15618137559208551', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.83.221.183', '2019-06-29 21:09:16', 11, 0, '', '2019-06-29 21:09:16');
INSERT INTO `access_log` VALUES (45433, '65.50.15618137559198607', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.196', '2019-06-29 21:09:16', 12, 2001001000, '服务端发生异常', '2019-06-29 21:09:16');
INSERT INTO `access_log` VALUES (45434, '65.46.15618137559498655', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.223.3', '2019-06-29 21:09:16', 8, 0, '', '2019-06-29 21:09:16');
INSERT INTO `access_log` VALUES (45435, '65.53.15618137605648603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.223.3', '2019-06-29 21:09:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 21:09:21');
INSERT INTO `access_log` VALUES (45436, '65.51.15618137620118635', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.223.3', '2019-06-29 21:09:22', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 21:09:22');
INSERT INTO `access_log` VALUES (45437, '65.47.15618137641148567', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.223.3', '2019-06-29 21:09:24', 73, 0, '', '2019-06-29 21:09:24');
INSERT INTO `access_log` VALUES (45438, '65.49.15618137643868607', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.83.221.183', '2019-06-29 21:09:24', 9, 0, '', '2019-06-29 21:09:24');
INSERT INTO `access_log` VALUES (45439, '65.3607.15618137643880385', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.196', '2019-06-29 21:09:24', 9, 0, '', '2019-06-29 21:09:24');
INSERT INTO `access_log` VALUES (45440, '65.45.15618137644188587', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.223.3', '2019-06-29 21:09:24', 7, 0, '', '2019-06-29 21:09:24');
INSERT INTO `access_log` VALUES (45441, '65.45.15618154069468609', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.204.248.72', '2019-06-29 21:36:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 21:36:47');
INSERT INTO `access_log` VALUES (45442, '65.54.15618154091718575', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.204.248.72', '2019-06-29 21:36:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 21:36:49');
INSERT INTO `access_log` VALUES (45443, '65.53.15618154349378627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.204.248.72', '2019-06-29 21:37:15', 92, 0, '', '2019-06-29 21:37:15');
INSERT INTO `access_log` VALUES (45444, '65.51.15618154354678659', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.204.248.72', '2019-06-29 21:37:15', 8, 0, '', '2019-06-29 21:37:15');
INSERT INTO `access_log` VALUES (45445, '65.52.15618154354718635', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.204.248.72', '2019-06-29 21:37:15', 9, 2001001000, '服务端发生异常', '2019-06-29 21:37:15');
INSERT INTO `access_log` VALUES (45446, '65.47.15618154354778591', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.204.248.72', '2019-06-29 21:37:15', 8, 0, '', '2019-06-29 21:37:15');
INSERT INTO `access_log` VALUES (45447, '65.49.15618154486588631', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.204.248.72', '2019-06-29 21:37:29', 10, 0, '', '2019-06-29 21:37:29');
INSERT INTO `access_log` VALUES (45448, '65.45.15618154486628611', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.204.248.72', '2019-06-29 21:37:29', 10, 2001001000, '服务端发生异常', '2019-06-29 21:37:29');
INSERT INTO `access_log` VALUES (45449, '65.54.15618154486668577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.204.248.72', '2019-06-29 21:37:29', 8, 0, '', '2019-06-29 21:37:29');
INSERT INTO `access_log` VALUES (45450, '59.74.15618156755047319', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.204.248.72', '2019-06-29 21:41:16', 17, 2001001000, '服务端发生异常', '2019-06-29 21:41:16');
INSERT INTO `access_log` VALUES (45451, '59.73.15618156755037323', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.204.248.72', '2019-06-29 21:41:16', 139, 0, '', '2019-06-29 21:41:16');
INSERT INTO `access_log` VALUES (45452, '59.79.15618165196307333', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:55:20', 3, 0, '', '2019-06-29 21:55:20');
INSERT INTO `access_log` VALUES (45453, '59.74.15618165196307331', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:55:20', 20, 2001001000, '服务端发生异常', '2019-06-29 21:55:20');
INSERT INTO `access_log` VALUES (45454, '65.54.15618165798638593', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:20', 0, 1002001015, '账号未登陆', '2019-06-29 21:56:20');
INSERT INTO `access_log` VALUES (45455, '65.3607.15618165798630425', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:20', 0, 1002001015, '账号未登陆', '2019-06-29 21:56:20');
INSERT INTO `access_log` VALUES (45456, '65.52.15618165798638651', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:20', 0, 1002001015, '账号未登陆', '2019-06-29 21:56:20');
INSERT INTO `access_log` VALUES (45457, '65.49.15618165842148647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:24', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 21:56:24');
INSERT INTO `access_log` VALUES (45458, '59.71.15618165886647329', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.129.6.151', '2019-06-29 21:56:29', 13, 2001001000, '服务端发生异常', '2019-06-29 21:56:29');
INSERT INTO `access_log` VALUES (45459, '65.46.15618165893768697', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:29', 69, 0, '', '2019-06-29 21:56:29');
INSERT INTO `access_log` VALUES (45460, '59.76.15618165895027323', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.178.197', '2019-06-29 21:56:30', 4, 0, '', '2019-06-29 21:56:30');
INSERT INTO `access_log` VALUES (45461, '65.50.15618165903018649', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:30', 9, 0, '', '2019-06-29 21:56:30');
INSERT INTO `access_log` VALUES (45462, '65.53.15618165903108645', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:30', 7, 0, '', '2019-06-29 21:56:30');
INSERT INTO `access_log` VALUES (45463, '65.51.15618165903168677', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:30', 8, 0, '', '2019-06-29 21:56:30');
INSERT INTO `access_log` VALUES (45464, '64.85.15618165982147417', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:38', 23, 0, '', '2019-06-29 21:56:38');
INSERT INTO `access_log` VALUES (45465, '64.80.15618165982147403', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:38', 26, 0, '', '2019-06-29 21:56:38');
INSERT INTO `access_log` VALUES (45466, '64.83.15618166075387393', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:48', 13, 0, '', '2019-06-29 21:56:48');
INSERT INTO `access_log` VALUES (45467, '64.76.15618166093617393', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:49', 12, 0, '', '2019-06-29 21:56:49');
INSERT INTO `access_log` VALUES (45468, '64.84.15618166115647397', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:52', 18, 0, '', '2019-06-29 21:56:52');
INSERT INTO `access_log` VALUES (45469, '64.82.15618166122557411', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:52', 12, 0, '', '2019-06-29 21:56:52');
INSERT INTO `access_log` VALUES (45470, '64.81.15618166161037401', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:56', 14, 0, '', '2019-06-29 21:56:56');
INSERT INTO `access_log` VALUES (45471, '64.78.15618166161107407', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:56:56', 10, 0, '', '2019-06-29 21:56:56');
INSERT INTO `access_log` VALUES (45472, '65.3607.15618166393790427', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.129.6.251', '2019-06-29 21:57:19', 0, 1002001015, '账号未登陆', '2019-06-29 21:57:19');
INSERT INTO `access_log` VALUES (45473, '65.49.15618166457378649', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.178.174', '2019-06-29 21:57:26', 1, 1002001015, '账号未登陆', '2019-06-29 21:57:26');
INSERT INTO `access_log` VALUES (45474, '65.46.15618166475248699', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.60.107', '2019-06-29 21:57:28', 1, 1002001015, '账号未登陆', '2019-06-29 21:57:28');
INSERT INTO `access_log` VALUES (45475, '62.89.15618166562976831', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:57:36', 111, 0, '', '2019-06-29 21:57:36');
INSERT INTO `access_log` VALUES (45476, '64.83.15618166663567395', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.175', '2019-06-29 21:57:46', 1, 1002001015, '账号未登陆', '2019-06-29 21:57:46');
INSERT INTO `access_log` VALUES (45477, '64.76.15618166675357395', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.178.236', '2019-06-29 21:57:48', 0, 1002001015, '账号未登陆', '2019-06-29 21:57:48');
INSERT INTO `access_log` VALUES (45478, '64.84.15618166732097399', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.178.174', '2019-06-29 21:57:53', 0, 1002001015, '账号未登陆', '2019-06-29 21:57:53');
INSERT INTO `access_log` VALUES (45479, '64.82.15618166745677413', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.129.6.251', '2019-06-29 21:57:55', 0, 1002001015, '账号未登陆', '2019-06-29 21:57:55');
INSERT INTO `access_log` VALUES (45480, '66.49.15618166750165519', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:57:55', 19, 0, '', '2019-06-29 21:57:55');
INSERT INTO `access_log` VALUES (45481, '62.86.15618167209356795', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.227', '2019-06-29 21:58:41', 1, 1002001015, '账号未登陆', '2019-06-29 21:58:41');
INSERT INTO `access_log` VALUES (45482, '66.52.15618167351425513', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.174', '2019-06-29 21:58:55', 1, 1002001015, '账号未登陆', '2019-06-29 21:58:55');
INSERT INTO `access_log` VALUES (45483, '62.88.15618167915186811', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:59:52', 19, 0, '', '2019-06-29 21:59:52');
INSERT INTO `access_log` VALUES (45484, '64.84.15618167918427401', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:59:52', 14, 0, '', '2019-06-29 21:59:52');
INSERT INTO `access_log` VALUES (45485, '64.82.15618167918977415', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.238.229.37', '2019-06-29 21:59:52', 10, 0, '', '2019-06-29 21:59:52');
INSERT INTO `access_log` VALUES (45486, '59.75.15618169401267339', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.100.45.134', '2019-06-29 22:02:20', 3, 0, '', '2019-06-29 22:02:20');
INSERT INTO `access_log` VALUES (45487, '59.73.15618169401247341', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.100.45.134', '2019-06-29 22:02:20', 13, 2001001000, '服务端发生异常', '2019-06-29 22:02:20');
INSERT INTO `access_log` VALUES (45488, '59.78.15618169556327329', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '115.196.27.113', '2019-06-29 22:02:36', 2, 0, '', '2019-06-29 22:02:36');
INSERT INTO `access_log` VALUES (45489, '59.71.15618169556337335', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '115.196.27.113', '2019-06-29 22:02:36', 45, 2001001000, '服务端发生异常', '2019-06-29 22:02:36');
INSERT INTO `access_log` VALUES (45490, '64.81.15618169570267407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.100.45.134', '2019-06-29 22:02:37', 260, 0, '', '2019-06-29 22:02:37');
INSERT INTO `access_log` VALUES (45491, '64.77.15618169574107403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.100.45.134', '2019-06-29 22:02:37', 1, 0, '', '2019-06-29 22:02:37');
INSERT INTO `access_log` VALUES (45492, '64.85.15618169713527425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.100.45.134', '2019-06-29 22:02:51', 2, 0, '', '2019-06-29 22:02:51');
INSERT INTO `access_log` VALUES (45493, '64.83.15618169723037401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.100.45.134', '2019-06-29 22:02:52', 1, 0, '', '2019-06-29 22:02:52');
INSERT INTO `access_log` VALUES (45494, '59.80.15618169751437325', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.100.45.134', '2019-06-29 22:02:55', 2, 0, '', '2019-06-29 22:02:55');
INSERT INTO `access_log` VALUES (45495, '59.72.15618169751447335', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.100.45.134', '2019-06-29 22:02:55', 19, 2001001000, '服务端发生异常', '2019-06-29 22:02:55');
INSERT INTO `access_log` VALUES (45496, '59.75.15618171501747343', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:05:50', 3, 0, '', '2019-06-29 22:05:50');
INSERT INTO `access_log` VALUES (45497, '59.73.15618171501837345', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:05:50', 10, 2001001000, '服务端发生异常', '2019-06-29 22:05:50');
INSERT INTO `access_log` VALUES (45498, '64.84.15618171555277407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:05:56', 3, 0, '', '2019-06-29 22:05:56');
INSERT INTO `access_log` VALUES (45499, '64.82.15618171556337421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:05:56', 2, 0, '', '2019-06-29 22:05:56');
INSERT INTO `access_log` VALUES (45500, '64.78.15618171582837417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:05:58', 1, 0, '', '2019-06-29 22:05:58');
INSERT INTO `access_log` VALUES (45501, '64.81.15618171584107411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:05:58', 2, 0, '', '2019-06-29 22:05:58');
INSERT INTO `access_log` VALUES (45502, '64.77.15618171590107407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:05:59', 2, 0, '', '2019-06-29 22:05:59');
INSERT INTO `access_log` VALUES (45503, '64.80.15618171595617415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:06:00', 1, 0, '', '2019-06-29 22:06:00');
INSERT INTO `access_log` VALUES (45504, '65.52.15618171670538661', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:06:07', 0, 1002001015, '账号未登陆', '2019-06-29 22:06:07');
INSERT INTO `access_log` VALUES (45505, '65.54.15618171670528603', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:06:07', 0, 1002001015, '账号未登陆', '2019-06-29 22:06:07');
INSERT INTO `access_log` VALUES (45506, '65.3607.15618171670560435', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:06:07', 0, 1002001015, '账号未登陆', '2019-06-29 22:06:07');
INSERT INTO `access_log` VALUES (45507, '65.50.15618172050918659', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:06:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 22:06:45');
INSERT INTO `access_log` VALUES (45508, '65.53.15618172066598655', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:06:47', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 22:06:47');
INSERT INTO `access_log` VALUES (45509, '65.51.15618172075778687', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:06:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 22:06:48');
INSERT INTO `access_log` VALUES (45510, '65.47.15618172082678619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:06:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 22:06:48');
INSERT INTO `access_log` VALUES (45511, '65.52.15618172215228663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:07:02', 105, 0, '', '2019-06-29 22:07:02');
INSERT INTO `access_log` VALUES (45512, '65.45.15618172218758639', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:07:02', 11, 0, '', '2019-06-29 22:07:02');
INSERT INTO `access_log` VALUES (45513, '65.54.15618172218748605', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:07:02', 12, 2001001000, '服务端发生异常', '2019-06-29 22:07:02');
INSERT INTO `access_log` VALUES (45514, '65.49.15618172218798659', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:07:02', 9, 0, '', '2019-06-29 22:07:02');
INSERT INTO `access_log` VALUES (45515, '65.47.15618172879648621', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:08:08', 9, 0, '', '2019-06-29 22:08:08');
INSERT INTO `access_log` VALUES (45516, '65.3607.15618172879640439', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:08:08', 11, 2001001000, '服务端发生异常', '2019-06-29 22:08:08');
INSERT INTO `access_log` VALUES (45517, '65.52.15618172879728665', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-29 22:08:08', 9, 0, '', '2019-06-29 22:08:08');
INSERT INTO `access_log` VALUES (45518, '65.54.15618178795068615', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.41.50', '2019-06-29 22:18:00', 4, 1002001012, '访问令牌已过期', '2019-06-29 22:18:00');
INSERT INTO `access_log` VALUES (45519, '65.45.15618178795138649', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.41.50', '2019-06-29 22:18:00', 3, 1002001012, '访问令牌已过期', '2019-06-29 22:18:00');
INSERT INTO `access_log` VALUES (45520, '65.49.15618178795228669', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.41.50', '2019-06-29 22:18:00', 2, 1002001012, '访问令牌已过期', '2019-06-29 22:18:00');
INSERT INTO `access_log` VALUES (45521, '65.50.15618178913458671', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.41.50', '2019-06-29 22:18:11', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 22:18:11');
INSERT INTO `access_log` VALUES (45522, '65.53.15618178986228667', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.41.50', '2019-06-29 22:18:19', 70, 0, '', '2019-06-29 22:18:19');
INSERT INTO `access_log` VALUES (45523, '65.51.15618178994238699', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.41.50', '2019-06-29 22:18:19', 10, 2001001000, '服务端发生异常', '2019-06-29 22:18:19');
INSERT INTO `access_log` VALUES (45524, '65.47.15618178994318631', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.41.50', '2019-06-29 22:18:19', 7, 0, '', '2019-06-29 22:18:19');
INSERT INTO `access_log` VALUES (45525, '65.3607.15618178994340449', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.41.50', '2019-06-29 22:18:19', 7, 0, '', '2019-06-29 22:18:19');
INSERT INTO `access_log` VALUES (45526, '65.45.15618179065528651', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.41.50', '2019-06-29 22:18:27', 7, 0, '', '2019-06-29 22:18:27');
INSERT INTO `access_log` VALUES (45527, '65.49.15618179066148671', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.41.50', '2019-06-29 22:18:27', 9, 0, '', '2019-06-29 22:18:27');
INSERT INTO `access_log` VALUES (45528, '65.54.15618179066178617', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.41.50', '2019-06-29 22:18:27', 9, 2001001000, '服务端发生异常', '2019-06-29 22:18:27');
INSERT INTO `access_log` VALUES (45529, '59.75.15618205692807389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.53.17.85', '2019-06-29 23:02:49', 11, 0, '', '2019-06-29 23:02:49');
INSERT INTO `access_log` VALUES (45530, '59.73.15618205692817391', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.53.17.85', '2019-06-29 23:02:49', 23, 2001001000, '服务端发生异常', '2019-06-29 23:02:49');
INSERT INTO `access_log` VALUES (45531, '65.54.15618205813798653', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.53.17.85', '2019-06-29 23:03:01', 0, 1002001015, '账号未登陆', '2019-06-29 23:03:01');
INSERT INTO `access_log` VALUES (45532, '65.49.15618205813798707', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.53.17.85', '2019-06-29 23:03:01', 1, 1002001015, '账号未登陆', '2019-06-29 23:03:01');
INSERT INTO `access_log` VALUES (45533, '65.46.15618205813808757', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.53.17.85', '2019-06-29 23:03:01', 1, 1002001015, '账号未登陆', '2019-06-29 23:03:01');
INSERT INTO `access_log` VALUES (45534, '65.50.15618205832198709', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.53.17.85', '2019-06-29 23:03:03', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-29 23:03:03');
INSERT INTO `access_log` VALUES (45535, '65.47.15618206002148669', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.53.17.85', '2019-06-29 23:03:20', 102, 0, '', '2019-06-29 23:03:20');
INSERT INTO `access_log` VALUES (45536, '65.51.15618206005938737', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.53.17.85', '2019-06-29 23:03:21', 11, 0, '', '2019-06-29 23:03:21');
INSERT INTO `access_log` VALUES (45537, '65.3607.15618206005970487', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.53.17.85', '2019-06-29 23:03:21', 11, 2001001000, '服务端发生异常', '2019-06-29 23:03:21');
INSERT INTO `access_log` VALUES (45538, '65.52.15618206006008713', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.53.17.85', '2019-06-29 23:03:21', 11, 0, '', '2019-06-29 23:03:21');
INSERT INTO `access_log` VALUES (45539, '4cf8339e-41a2-4cc6-897e-989bf917847b', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:20:25', 1357, 1002001012, '访问令牌已过期', '2019-06-29 23:20:27');
INSERT INTO `access_log` VALUES (45540, '161df491-018e-46bd-b3e0-9dda14322936', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:20:25', 1386, 1002001012, '访问令牌已过期', '2019-06-29 23:20:27');
INSERT INTO `access_log` VALUES (45541, 'c80dddb4-60c1-48a3-ab59-6fccbd03b748', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:20:25', 1313, 1002001012, '访问令牌已过期', '2019-06-29 23:20:27');
INSERT INTO `access_log` VALUES (45542, '5651cc95-51d4-478a-9f61-82974a13b672', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:20:36', 511, 1002002001, '密码不正确', '2019-06-29 23:20:36');
INSERT INTO `access_log` VALUES (45543, '8f59ba8a-e9f1-4caf-b5e8-650008dd0b3c', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:20:43', 623, 0, '', '2019-06-29 23:20:43');
INSERT INTO `access_log` VALUES (45544, '94226a04-2b68-4ff5-b83e-db5706f3d6af', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:20:44', 286, 0, '', '2019-06-29 23:20:44');
INSERT INTO `access_log` VALUES (45545, '3f76546f-8d65-4e46-844f-5cee08a8e5af', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:20:44', 412, 0, '', '2019-06-29 23:20:44');
INSERT INTO `access_log` VALUES (45546, 'ec0f08f8-535c-45f9-9e78-6bf93892b0e6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:20:44', 312, 0, '', '2019-06-29 23:20:44');
INSERT INTO `access_log` VALUES (45547, '66504429-0ca6-486d-a226-0e1b3ba1ad76', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:21:14', 187, 0, '', '2019-06-29 23:21:14');
INSERT INTO `access_log` VALUES (45548, '640c6654-2efb-415b-aa87-8191f21b4efa', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:24:14', 305, 0, '', '2019-06-29 23:24:14');
INSERT INTO `access_log` VALUES (45549, '029565fa-8e6b-47ee-b884-3919555616f5', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:25:11', 151, 0, '', '2019-06-29 23:25:12');
INSERT INTO `access_log` VALUES (45550, 'a5654f86-518f-4fdc-85ab-ebd05b3175dd', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:28:45', 1312, 0, '', '2019-06-29 23:28:46');
INSERT INTO `access_log` VALUES (45551, 'f0e1439b-6a17-46d7-9c7e-d0d22fa20bb8', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:28:45', 2805, 0, '', '2019-06-29 23:28:48');
INSERT INTO `access_log` VALUES (45552, 'f5fb3341-93d4-4c34-baa2-6d0b6ff1dbdf', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:28:56', 223, 0, '', '2019-06-29 23:28:56');
INSERT INTO `access_log` VALUES (45553, '7315c930-7e98-4e6c-be44-48ae14baaf7b', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:28:58', 204, 0, '', '2019-06-29 23:28:58');
INSERT INTO `access_log` VALUES (45554, 'ebdd033a-dad7-4f90-b45c-5f53d3946d09', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:29:05', 161, 0, '', '2019-06-29 23:29:05');
INSERT INTO `access_log` VALUES (45555, '96190f29-f756-42f5-bac5-4b14580d190a', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:29:05', 347, 0, '', '2019-06-29 23:29:05');
INSERT INTO `access_log` VALUES (45556, '7d1d8493-832e-4ce2-8f54-fe24a346e0a1', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:29:16', 170, 0, '', '2019-06-29 23:29:16');
INSERT INTO `access_log` VALUES (45557, 'd6dbccca-840a-47ac-a013-231e87139890', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:29:23', 1141, 0, '', '2019-06-29 23:29:24');
INSERT INTO `access_log` VALUES (45558, '54e64de5-75e8-4e26-8776-9a5e9dd93b47', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-06-29 23:30:59', 471, 0, '', '2019-06-29 23:31:00');
INSERT INTO `access_log` VALUES (45559, '59.76.15618228759797409', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '130.105.217.241', '2019-06-29 23:41:16', 10, 0, '', '2019-06-29 23:41:16');
INSERT INTO `access_log` VALUES (45560, '59.80.15618228759827405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '130.105.217.241', '2019-06-29 23:41:16', 15, 2001001000, '服务端发生异常', '2019-06-29 23:41:16');
INSERT INTO `access_log` VALUES (45561, '64.82.15618229398037499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:42:20', 11, 0, '', '2019-06-29 23:42:20');
INSERT INTO `access_log` VALUES (45562, '64.78.15618229400047495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:42:20', 3, 0, '', '2019-06-29 23:42:20');
INSERT INTO `access_log` VALUES (45563, '59.77.15618229439877407', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:42:24', 5, 0, '', '2019-06-29 23:42:24');
INSERT INTO `access_log` VALUES (45564, '59.78.15618229441247411', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:42:24', 16, 2001001000, '服务端发生异常', '2019-06-29 23:42:24');
INSERT INTO `access_log` VALUES (45565, '66.57.15618229587285597', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:42:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机号不能为空\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空', '2019-06-29 23:42:39');
INSERT INTO `access_log` VALUES (45566, '64.76.15618230025657483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:43:23', 3, 0, '', '2019-06-29 23:43:23');
INSERT INTO `access_log` VALUES (45567, '64.79.15618230027677501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:43:23', 2, 0, '', '2019-06-29 23:43:23');
INSERT INTO `access_log` VALUES (45568, '64.84.15618230054437487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:43:25', 2, 0, '', '2019-06-29 23:43:25');
INSERT INTO `access_log` VALUES (45569, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:43:26', 5, 0, '', '2019-06-29 23:43:26');
INSERT INTO `access_log` VALUES (45570, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:43:28', 5, 0, '', '2019-06-29 23:43:28');
INSERT INTO `access_log` VALUES (45571, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:43:29', 4, 0, '', '2019-06-29 23:43:29');
INSERT INTO `access_log` VALUES (45572, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:43:30', 6, 0, '', '2019-06-29 23:43:30');
INSERT INTO `access_log` VALUES (45573, '64.82.15618230102297501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:43:30', 1, 0, '', '2019-06-29 23:43:30');
INSERT INTO `access_log` VALUES (45574, '64.78.15618230104197497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:43:30', 2, 0, '', '2019-06-29 23:43:30');
INSERT INTO `access_log` VALUES (45575, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=sasasa&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:43:33', 7, 0, '', '2019-06-29 23:43:33');
INSERT INTO `access_log` VALUES (45576, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=sasasa', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '130.105.217.241', '2019-06-29 23:43:33', 6, 0, '', '2019-06-29 23:43:33');
INSERT INTO `access_log` VALUES (45577, '59.72.15618237471127427', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.2.112 Mobile Safari/537.36', '183.160.237.225', '2019-06-29 23:55:47', 3, 0, '', '2019-06-29 23:55:47');
INSERT INTO `access_log` VALUES (45578, '59.79.15618237471147433', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.2.112 Mobile Safari/537.36', '183.160.237.225', '2019-06-29 23:55:47', 9, 2001001000, '服务端发生异常', '2019-06-29 23:55:47');
INSERT INTO `access_log` VALUES (45579, '64.78.15618237495857507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.2.112 Mobile Safari/537.36', '183.160.237.225', '2019-06-29 23:55:50', 3, 0, '', '2019-06-29 23:55:50');
INSERT INTO `access_log` VALUES (45580, '64.81.15618237497977501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.2.112 Mobile Safari/537.36', '183.160.237.225', '2019-06-29 23:55:50', 2, 0, '', '2019-06-29 23:55:50');
INSERT INTO `access_log` VALUES (45581, '64.80.15618237555287505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.2.112 Mobile Safari/537.36', '183.160.237.225', '2019-06-29 23:55:56', 2, 0, '', '2019-06-29 23:55:56');
INSERT INTO `access_log` VALUES (45582, '64.85.15618237569127519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.2.112 Mobile Safari/537.36', '183.160.237.225', '2019-06-29 23:55:57', 1, 0, '', '2019-06-29 23:55:57');
INSERT INTO `access_log` VALUES (45583, '64.83.15618237579987495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.2.112 Mobile Safari/537.36', '183.160.237.225', '2019-06-29 23:55:58', 2, 0, '', '2019-06-29 23:55:58');
INSERT INTO `access_log` VALUES (45584, '64.76.15618237586797495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.2.112 Mobile Safari/537.36', '183.160.237.225', '2019-06-29 23:55:59', 2, 0, '', '2019-06-29 23:55:59');
INSERT INTO `access_log` VALUES (45585, '64.84.15618237668617499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.2.112 Mobile Safari/537.36', '183.160.237.225', '2019-06-29 23:56:07', 2, 0, '', '2019-06-29 23:56:07');
INSERT INTO `access_log` VALUES (45586, '64.82.15618237670547513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.2.112 Mobile Safari/537.36', '183.160.237.225', '2019-06-29 23:56:07', 2, 0, '', '2019-06-29 23:56:07');
INSERT INTO `access_log` VALUES (45587, '59.77.15618237682957419', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.2.112 Mobile Safari/537.36', '183.160.237.225', '2019-06-29 23:56:08', 2, 0, '', '2019-06-29 23:56:08');
INSERT INTO `access_log` VALUES (45588, '59.73.15618237682957435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.2.112 Mobile Safari/537.36', '183.160.237.225', '2019-06-29 23:56:08', 12, 2001001000, '服务端发生异常', '2019-06-29 23:56:08');
INSERT INTO `access_log` VALUES (45589, '65.49.15618266423738789', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.83.151.21', '2019-06-30 00:44:02', 0, 1002001015, '账号未登陆', '2019-06-30 00:44:02');
INSERT INTO `access_log` VALUES (45590, '65.50.15618266423748791', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.83.151.21', '2019-06-30 00:44:02', 1, 1002001015, '账号未登陆', '2019-06-30 00:44:02');
INSERT INTO `access_log` VALUES (45591, '65.53.15618266423748787', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.83.151.21', '2019-06-30 00:44:02', 0, 1002001015, '账号未登陆', '2019-06-30 00:44:02');
INSERT INTO `access_log` VALUES (45592, '65.47.15618266443628751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.83.151.21', '2019-06-30 00:44:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 00:44:04');
INSERT INTO `access_log` VALUES (45593, '65.51.15618266583338819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.83.151.21', '2019-06-30 00:44:18', 67, 0, '', '2019-06-30 00:44:18');
INSERT INTO `access_log` VALUES (45594, '65.46.15618266590298841', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.83.151.21', '2019-06-30 00:44:19', 13, 0, '', '2019-06-30 00:44:19');
INSERT INTO `access_log` VALUES (45595, '65.52.15618266590278795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.83.151.21', '2019-06-30 00:44:19', 13, 0, '', '2019-06-30 00:44:19');
INSERT INTO `access_log` VALUES (45596, '65.45.15618266590298771', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.83.151.21', '2019-06-30 00:44:19', 17, 2001001000, '服务端发生异常', '2019-06-30 00:44:19');
INSERT INTO `access_log` VALUES (45597, '59.79.15618266919807473', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.83.151.21', '2019-06-30 00:44:52', 11, 0, '', '2019-06-30 00:44:52');
INSERT INTO `access_log` VALUES (45598, '59.74.15618266919817471', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.83.151.21', '2019-06-30 00:44:52', 15, 2001001000, '服务端发生异常', '2019-06-30 00:44:52');
INSERT INTO `access_log` VALUES (45599, '64.84.15618496879447845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-30 07:08:08', 14, 0, '', '2019-06-30 07:08:08');
INSERT INTO `access_log` VALUES (45600, '64.82.15618496880537859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-30 07:08:08', 3, 0, '', '2019-06-30 07:08:08');
INSERT INTO `access_log` VALUES (45601, '65.49.15618496891399097', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-30 07:08:09', 11, 1002001012, '访问令牌已过期', '2019-06-30 07:08:09');
INSERT INTO `access_log` VALUES (45602, '65.3607.15618496891420877', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-30 07:08:09', 10, 1002001012, '访问令牌已过期', '2019-06-30 07:08:09');
INSERT INTO `access_log` VALUES (45603, '65.51.15618496891489125', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.67.135.85', '2019-06-30 07:08:09', 7, 1002001012, '访问令牌已过期', '2019-06-30 07:08:09');
INSERT INTO `access_log` VALUES (45604, '65.47.15618610379869213', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.185.65', '2019-06-30 10:17:18', 1, 1002001015, '账号未登陆', '2019-06-30 10:17:18');
INSERT INTO `access_log` VALUES (45605, '65.53.15618610379859249', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.185.65', '2019-06-30 10:17:18', 1, 1002001015, '账号未登陆', '2019-06-30 10:17:18');
INSERT INTO `access_log` VALUES (45606, '65.50.15618610379869253', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.185.65', '2019-06-30 10:17:18', 0, 1002001015, '账号未登陆', '2019-06-30 10:17:18');
INSERT INTO `access_log` VALUES (45607, '65.49.15618610432289249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.185.65', '2019-06-30 10:17:23', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 10:17:23');
INSERT INTO `access_log` VALUES (45608, '65.3607.15618610583081029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.185.65', '2019-06-30 10:17:38', 108, 0, '', '2019-06-30 10:17:38');
INSERT INTO `access_log` VALUES (45609, '65.46.15618610586349305', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.185.65', '2019-06-30 10:17:39', 23, 2001001000, '服务端发生异常', '2019-06-30 10:17:39');
INSERT INTO `access_log` VALUES (45610, '65.45.15618610586369235', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.185.65', '2019-06-30 10:17:39', 21, 0, '', '2019-06-30 10:17:39');
INSERT INTO `access_log` VALUES (45611, '65.52.15618610586339257', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.185.65', '2019-06-30 10:17:39', 24, 0, '', '2019-06-30 10:17:39');
INSERT INTO `access_log` VALUES (45612, '65.50.15618610802309255', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.185.65', '2019-06-30 10:18:00', 10, 0, '', '2019-06-30 10:18:00');
INSERT INTO `access_log` VALUES (45613, '65.53.15618610802319251', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.185.65', '2019-06-30 10:18:00', 10, 2001001000, '服务端发生异常', '2019-06-30 10:18:00');
INSERT INTO `access_log` VALUES (45614, '65.49.15618610802349251', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '36.7.185.65', '2019-06-30 10:18:00', 10, 0, '', '2019-06-30 10:18:00');
INSERT INTO `access_log` VALUES (45615, '65.3607.15618610918981031', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '36.7.185.65', '2019-06-30 10:18:12', 9, 0, '', '2019-06-30 10:18:12');
INSERT INTO `access_log` VALUES (45616, '65.46.15618610918989307', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '36.7.185.65', '2019-06-30 10:18:12', 11, 2001001000, '服务端发生异常', '2019-06-30 10:18:12');
INSERT INTO `access_log` VALUES (45617, '65.52.15618610919129259', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '36.7.185.65', '2019-06-30 10:18:12', 9, 0, '', '2019-06-30 10:18:12');
INSERT INTO `access_log` VALUES (45618, '59.72.15618647330247975', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.87.7', '2019-06-30 11:18:53', 12, 0, '', '2019-06-30 11:18:53');
INSERT INTO `access_log` VALUES (45619, '59.76.15618647330247969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.87.7', '2019-06-30 11:18:53', 26, 2001001000, '服务端发生异常', '2019-06-30 11:18:53');
INSERT INTO `access_log` VALUES (45620, '59.73.15618665888118007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:49:49', 22, 2001001000, '服务端发生异常', '2019-06-30 11:49:49');
INSERT INTO `access_log` VALUES (45621, '59.77.15618665888117991', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:49:49', 63, 0, '', '2019-06-30 11:49:49');
INSERT INTO `access_log` VALUES (45622, '64.84.15618665958598071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:49:56', 12, 0, '', '2019-06-30 11:49:56');
INSERT INTO `access_log` VALUES (45623, '64.82.15618665959718085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:49:56', 3, 0, '', '2019-06-30 11:49:56');
INSERT INTO `access_log` VALUES (45624, '64.78.15618665974898081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:49:57', 2, 0, '', '2019-06-30 11:49:58');
INSERT INTO `access_log` VALUES (45625, '64.81.15618665982038073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:49:58', 2, 0, '', '2019-06-30 11:49:58');
INSERT INTO `access_log` VALUES (45626, '64.77.15618665987088071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:49:59', 2, 0, '', '2019-06-30 11:49:59');
INSERT INTO `access_log` VALUES (45627, '64.80.15618665990598079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:49:59', 3, 0, '', '2019-06-30 11:49:59');
INSERT INTO `access_log` VALUES (45628, '64.83.15618666080108069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:50:08', 2, 0, '', '2019-06-30 11:50:08');
INSERT INTO `access_log` VALUES (45629, '64.76.15618666081548069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:50:08', 2, 0, '', '2019-06-30 11:50:08');
INSERT INTO `access_log` VALUES (45630, '64.84.15618666250228073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:50:25', 2, 0, '', '2019-06-30 11:50:25');
INSERT INTO `access_log` VALUES (45631, '64.82.15618666251598087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:50:25', 2, 0, '', '2019-06-30 11:50:25');
INSERT INTO `access_log` VALUES (45632, '59.76.15618666264837995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:50:26', 3, 0, '', '2019-06-30 11:50:26');
INSERT INTO `access_log` VALUES (45633, '59.72.15618666264838001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:50:26', 23, 2001001000, '服务端发生异常', '2019-06-30 11:50:27');
INSERT INTO `access_log` VALUES (45634, '64.78.15618666304988083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:50:30', 2, 0, '', '2019-06-30 11:50:31');
INSERT INTO `access_log` VALUES (45635, '64.81.15618666306128075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:50:31', 2, 0, '', '2019-06-30 11:50:31');
INSERT INTO `access_log` VALUES (45636, '59.74.15618666318658005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:50:32', 4, 0, '', '2019-06-30 11:50:32');
INSERT INTO `access_log` VALUES (45637, '59.79.15618666318658007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.223.87.110', '2019-06-30 11:50:32', 27, 2001001000, '服务端发生异常', '2019-06-30 11:50:32');
INSERT INTO `access_log` VALUES (45638, '65.3607.15618727838341187', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:33:04', 0, 1002001015, '账号未登陆', '2019-06-30 13:33:04');
INSERT INTO `access_log` VALUES (45639, '65.45.15618727838359393', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:33:04', 1, 1002001015, '账号未登陆', '2019-06-30 13:33:04');
INSERT INTO `access_log` VALUES (45640, '65.54.15618727838369359', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:33:04', 0, 1002001015, '账号未登陆', '2019-06-30 13:33:04');
INSERT INTO `access_log` VALUES (45641, '65.47.15618727861969373', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:33:06', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 13:33:06');
INSERT INTO `access_log` VALUES (45642, '65.53.15618727905489409', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:33:11', 78, 0, '', '2019-06-30 13:33:11');
INSERT INTO `access_log` VALUES (45643, '65.49.15618727911319409', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:33:11', 12, 0, '', '2019-06-30 13:33:11');
INSERT INTO `access_log` VALUES (45644, '65.51.15618727911329439', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:33:11', 14, 2001001000, '服务端发生异常', '2019-06-30 13:33:11');
INSERT INTO `access_log` VALUES (45645, '65.52.15618727911369417', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:33:11', 11, 0, '', '2019-06-30 13:33:11');
INSERT INTO `access_log` VALUES (45646, '65.54.15618728073329361', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:33:27', 15, 0, '', '2019-06-30 13:33:27');
INSERT INTO `access_log` VALUES (45647, '65.3607.15618728073431189', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:33:27', 8, 0, '', '2019-06-30 13:33:27');
INSERT INTO `access_log` VALUES (45648, '65.45.15618728073439395', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:33:27', 9, 2001001000, '服务端发生异常', '2019-06-30 13:33:27');
INSERT INTO `access_log` VALUES (45649, '65.45.15618729100449397', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:35:10', 10, 0, '', '2019-06-30 13:35:10');
INSERT INTO `access_log` VALUES (45650, '65.3607.15618729100561191', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:35:10', 11, 2001001000, '服务端发生异常', '2019-06-30 13:35:10');
INSERT INTO `access_log` VALUES (45651, '65.54.15618729100609363', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:35:10', 9, 0, '', '2019-06-30 13:35:10');
INSERT INTO `access_log` VALUES (45652, '59.74.15618732019198093', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:40:02', 22, 0, '', '2019-06-30 13:40:02');
INSERT INTO `access_log` VALUES (45653, '59.79.15618732019198095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:40:02', 24, 2001001000, '服务端发生异常', '2019-06-30 13:40:02');
INSERT INTO `access_log` VALUES (45654, '64.81.15618732090488163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:40:09', 9, 0, '', '2019-06-30 13:40:09');
INSERT INTO `access_log` VALUES (45655, '64.77.15618732091818161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:40:09', 3, 0, '', '2019-06-30 13:40:09');
INSERT INTO `access_log` VALUES (45656, '64.80.15618732109708169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:40:11', 2, 0, '', '2019-06-30 13:40:11');
INSERT INTO `access_log` VALUES (45657, '64.85.15618732115608183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:40:12', 3, 0, '', '2019-06-30 13:40:12');
INSERT INTO `access_log` VALUES (45658, '59.73.15618732131768097', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:40:13', 3, 0, '', '2019-06-30 13:40:13');
INSERT INTO `access_log` VALUES (45659, '59.77.15618732131798081', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.221.211.253', '2019-06-30 13:40:13', 13, 2001001000, '服务端发生异常', '2019-06-30 13:40:13');
INSERT INTO `access_log` VALUES (45660, '65.50.15618741299559433', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.91.76.148', '2019-06-30 13:55:30', 1, 1002001015, '账号未登陆', '2019-06-30 13:55:30');
INSERT INTO `access_log` VALUES (45661, '65.53.15618741299639429', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.91.76.148', '2019-06-30 13:55:30', 1, 1002001015, '账号未登陆', '2019-06-30 13:55:30');
INSERT INTO `access_log` VALUES (45662, '65.52.15618741299789437', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.91.76.148', '2019-06-30 13:55:30', 0, 1002001015, '账号未登陆', '2019-06-30 13:55:30');
INSERT INTO `access_log` VALUES (45663, '65.51.15618741393719459', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.91.76.148', '2019-06-30 13:55:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 13:55:39');
INSERT INTO `access_log` VALUES (45664, '65.46.15618741437559485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.91.76.148', '2019-06-30 13:55:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 13:55:44');
INSERT INTO `access_log` VALUES (45665, '65.54.15618741697079381', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.91.76.148', '2019-06-30 13:56:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 13:56:10');
INSERT INTO `access_log` VALUES (45666, '65.52.15618768649419477', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.111.50.88', '2019-06-30 14:41:05', 0, 1002001015, '账号未登陆', '2019-06-30 14:41:05');
INSERT INTO `access_log` VALUES (45667, '65.47.15618768649419431', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.111.50.88', '2019-06-30 14:41:05', 0, 1002001015, '账号未登陆', '2019-06-30 14:41:05');
INSERT INTO `access_log` VALUES (45668, '65.53.15618768649429469', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.111.50.88', '2019-06-30 14:41:05', 1, 1002001015, '账号未登陆', '2019-06-30 14:41:05');
INSERT INTO `access_log` VALUES (45669, '65.49.15618768812369469', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.111.50.88', '2019-06-30 14:41:21', 104, 0, '', '2019-06-30 14:41:21');
INSERT INTO `access_log` VALUES (45670, '65.51.15618768816029497', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.111.50.88', '2019-06-30 14:41:22', 9, 0, '', '2019-06-30 14:41:22');
INSERT INTO `access_log` VALUES (45671, '65.3607.15618768816141247', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.111.50.88', '2019-06-30 14:41:22', 9, 2001001000, '服务端发生异常', '2019-06-30 14:41:22');
INSERT INTO `access_log` VALUES (45672, '65.46.15618768816179521', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.111.50.88', '2019-06-30 14:41:22', 10, 0, '', '2019-06-30 14:41:22');
INSERT INTO `access_log` VALUES (45673, '65.51.15618772981709503', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.102.10.136', '2019-06-30 14:48:18', 4, 1002001012, '访问令牌已过期', '2019-06-30 14:48:18');
INSERT INTO `access_log` VALUES (45674, '65.46.15618772981789527', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.102.10.136', '2019-06-30 14:48:18', 3, 1002001012, '访问令牌已过期', '2019-06-30 14:48:18');
INSERT INTO `access_log` VALUES (45675, '65.45.15618772981929461', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.102.10.136', '2019-06-30 14:48:18', 3, 1002001012, '访问令牌已过期', '2019-06-30 14:48:18');
INSERT INTO `access_log` VALUES (45676, '65.54.15618773031019427', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.102.10.136', '2019-06-30 14:48:23', 196, 0, '', '2019-06-30 14:48:23');
INSERT INTO `access_log` VALUES (45677, '65.53.15618773038049477', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.102.10.136', '2019-06-30 14:48:24', 10, 0, '', '2019-06-30 14:48:24');
INSERT INTO `access_log` VALUES (45678, '65.47.15618773038099439', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.102.10.136', '2019-06-30 14:48:24', 10, 2001001000, '服务端发生异常', '2019-06-30 14:48:24');
INSERT INTO `access_log` VALUES (45679, '65.52.15618773038169485', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.102.10.136', '2019-06-30 14:48:24', 8, 0, '', '2019-06-30 14:48:24');
INSERT INTO `access_log` VALUES (45680, '1b17b76d-f2ae-41f2-834e-a1781db763d3', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:42:24', 689, 1002001015, '账号未登陆', '2019-06-30 15:42:26');
INSERT INTO `access_log` VALUES (45681, 'aa380d07-dc9c-4507-b619-2b9b2eb460be', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:42:24', 689, 1002001015, '账号未登陆', '2019-06-30 15:42:26');
INSERT INTO `access_log` VALUES (45682, '2664af9b-f24a-4012-bf45-a563a5ee5476', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:42:24', 689, 1002001015, '账号未登陆', '2019-06-30 15:42:26');
INSERT INTO `access_log` VALUES (45683, 'dfb4c8b8-7513-4dcf-b700-13c4c7678441', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:46:07', 10833, 2001001000, '服务端发生异常', '2019-06-30 15:46:18');
INSERT INTO `access_log` VALUES (45684, 'a6e18bb8-eaec-4023-8e34-27494e1514f4', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:46:07', 10841, 0, '', '2019-06-30 15:46:18');
INSERT INTO `access_log` VALUES (45685, '7a700d7c-2713-444f-b5e4-e2af02d29e1d', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:46:23', 88, 0, '', '2019-06-30 15:46:23');
INSERT INTO `access_log` VALUES (45686, '0b952d62-156c-4cd9-a380-80a633135fcb', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:46:23', 438, 2001001000, '服务端发生异常', '2019-06-30 15:46:23');
INSERT INTO `access_log` VALUES (45687, '156e9b1f-ea82-4e94-b646-e5dff6aedb6c', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:46:24', 84, 0, '', '2019-06-30 15:46:25');
INSERT INTO `access_log` VALUES (45688, '8ff7117a-2773-4a1f-b58c-b33ef988f48d', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:46:19', 5029, 0, '', '2019-06-30 15:46:25');
INSERT INTO `access_log` VALUES (45689, 'e17f51d9-794c-451c-9e74-d77ca7f65c80', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:46:25', 75, 0, '', '2019-06-30 15:46:25');
INSERT INTO `access_log` VALUES (45690, '95d0d89e-d08c-4873-abb0-8a4f60990849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:46:25', 76, 0, '', '2019-06-30 15:46:25');
INSERT INTO `access_log` VALUES (45691, 'b8caef63-b623-4379-9e7b-433b1c8756ef', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:47:01', 1197, 1002002001, '密码不正确', '2019-06-30 15:47:02');
INSERT INTO `access_log` VALUES (45692, 'b725f278-c29a-4f4d-a5fa-388807483cbb', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:51:10', 161, 1002002001, '密码不正确', '2019-06-30 15:51:10');
INSERT INTO `access_log` VALUES (45693, '7969b214-e335-4306-9edb-f23a50aaa26a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:59:43', 378, 1002002001, '密码不正确', '2019-06-30 15:59:43');
INSERT INTO `access_log` VALUES (45694, '81333167-1f75-4d97-9dbc-20e8657506b3', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 16:01:44', 200, 1002002001, '密码不正确', '2019-06-30 16:01:44');
INSERT INTO `access_log` VALUES (45695, '0ec46550-9e50-4939-90f4-54488a4cc713', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 16:02:30', 95, 1002002001, '密码不正确', '2019-06-30 16:02:31');
INSERT INTO `access_log` VALUES (45696, '59.78.15618849130268241', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.141.255.194', '2019-06-30 16:55:13', 10, 0, '', '2019-06-30 16:55:13');
INSERT INTO `access_log` VALUES (45697, '59.71.15618849130278247', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.141.255.194', '2019-06-30 16:55:13', 17, 2001001000, '服务端发生异常', '2019-06-30 16:55:13');
INSERT INTO `access_log` VALUES (45698, '59.71.15618851777688251', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.88.56.217', '2019-06-30 16:59:38', 3, 0, '', '2019-06-30 16:59:38');
INSERT INTO `access_log` VALUES (45699, '59.78.15618851777798245', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.88.56.217', '2019-06-30 16:59:38', 33, 2001001000, '服务端发生异常', '2019-06-30 16:59:38');
INSERT INTO `access_log` VALUES (45700, '64.84.15618851827478321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.88.56.217', '2019-06-30 16:59:43', 11, 0, '', '2019-06-30 16:59:43');
INSERT INTO `access_log` VALUES (45701, '64.78.15618851830678331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.88.56.217', '2019-06-30 16:59:43', 2, 0, '', '2019-06-30 16:59:43');
INSERT INTO `access_log` VALUES (45702, '59.80.15618851890618241', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.88.56.217', '2019-06-30 16:59:49', 2, 0, '', '2019-06-30 16:59:49');
INSERT INTO `access_log` VALUES (45703, '59.76.15618851890618245', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.88.56.217', '2019-06-30 16:59:49', 14, 2001001000, '服务端发生异常', '2019-06-30 16:59:49');
INSERT INTO `access_log` VALUES (45704, '59.75.15618852082688257', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.88.56.217', '2019-06-30 17:00:08', 17, 2001001000, '服务端发生异常', '2019-06-30 17:00:08');
INSERT INTO `access_log` VALUES (45705, '59.79.15618852082678257', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.88.56.217', '2019-06-30 17:00:08', 2, 0, '', '2019-06-30 17:00:08');
INSERT INTO `access_log` VALUES (45706, '65.50.15618877207359621', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:42:01', 1, 1002001015, '账号未登陆', '2019-06-30 17:42:01');
INSERT INTO `access_log` VALUES (45707, '65.49.15618877207359615', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:42:01', 1, 1002001015, '账号未登陆', '2019-06-30 17:42:01');
INSERT INTO `access_log` VALUES (45708, '65.3607.15618877207411395', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:42:01', 1, 1002001015, '账号未登陆', '2019-06-30 17:42:01');
INSERT INTO `access_log` VALUES (45709, '65.51.15618877235159645', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:42:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 17:42:04');
INSERT INTO `access_log` VALUES (45710, '65.46.15618877274009667', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:42:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 17:42:07');
INSERT INTO `access_log` VALUES (45711, '65.47.15618877331819581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:42:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 17:42:13');
INSERT INTO `access_log` VALUES (45712, '65.50.15618877763019623', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:42:56', 125, 0, '', '2019-06-30 17:42:56');
INSERT INTO `access_log` VALUES (45713, '65.49.15618877766949617', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:42:57', 10, 0, '', '2019-06-30 17:42:57');
INSERT INTO `access_log` VALUES (45714, '65.3607.15618877767001397', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:42:57', 13, 2001001000, '服务端发生异常', '2019-06-30 17:42:57');
INSERT INTO `access_log` VALUES (45715, '65.51.15618877767069647', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:42:57', 15, 0, '', '2019-06-30 17:42:57');
INSERT INTO `access_log` VALUES (45716, '65.45.15618878004229605', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:43:20', 84, 0, '', '2019-06-30 17:43:21');
INSERT INTO `access_log` VALUES (45717, '65.47.15618878007899583', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:43:21', 9, 0, '', '2019-06-30 17:43:21');
INSERT INTO `access_log` VALUES (45718, '65.54.15618878007939571', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:43:21', 9, 2001001000, '服务端发生异常', '2019-06-30 17:43:21');
INSERT INTO `access_log` VALUES (45719, '65.53.15618878007989619', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:43:21', 8, 0, '', '2019-06-30 17:43:21');
INSERT INTO `access_log` VALUES (45720, '59.78.15618878073838281', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:43:27', 17, 0, '', '2019-06-30 17:43:27');
INSERT INTO `access_log` VALUES (45721, '59.72.15618878073838287', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.44.13', '2019-06-30 17:43:27', 22, 2001001000, '服务端发生异常', '2019-06-30 17:43:27');
INSERT INTO `access_log` VALUES (45722, '65.45.15618953878779707', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.57.228.77', '2019-06-30 19:49:48', 0, 1002001015, '账号未登陆', '2019-06-30 19:49:48');
INSERT INTO `access_log` VALUES (45723, '65.47.15618953878779685', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.57.228.77', '2019-06-30 19:49:48', 0, 1002001015, '账号未登陆', '2019-06-30 19:49:48');
INSERT INTO `access_log` VALUES (45724, '65.54.15618953878839673', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.57.228.77', '2019-06-30 19:49:48', 1, 1002001015, '账号未登陆', '2019-06-30 19:49:48');
INSERT INTO `access_log` VALUES (45725, '65.53.15618953909799721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.57.228.77', '2019-06-30 19:49:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 19:49:51');
INSERT INTO `access_log` VALUES (45726, '65.50.15618953960599727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.57.228.77', '2019-06-30 19:49:56', 144, 0, '', '2019-06-30 19:49:56');
INSERT INTO `access_log` VALUES (45727, '65.51.15618953966009751', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.57.228.77', '2019-06-30 19:49:57', 11, 2001001000, '服务端发生异常', '2019-06-30 19:49:57');
INSERT INTO `access_log` VALUES (45728, '65.3607.15618953966011501', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.57.228.77', '2019-06-30 19:49:57', 10, 0, '', '2019-06-30 19:49:57');
INSERT INTO `access_log` VALUES (45729, '65.49.15618953966009721', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.57.228.77', '2019-06-30 19:49:57', 13, 0, '', '2019-06-30 19:49:57');
INSERT INTO `access_log` VALUES (45730, '65.54.15618972444989699', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.226.62.81', '2019-06-30 20:20:44', 0, 1002001015, '账号未登陆', '2019-06-30 20:20:44');
INSERT INTO `access_log` VALUES (45731, '65.53.15618972444999747', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.226.62.81', '2019-06-30 20:20:44', 0, 1002001015, '账号未登陆', '2019-06-30 20:20:44');
INSERT INTO `access_log` VALUES (45732, '65.52.15618972445149757', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.226.62.81', '2019-06-30 20:20:45', 0, 1002001015, '账号未登陆', '2019-06-30 20:20:45');
INSERT INTO `access_log` VALUES (45733, '65.50.15618972472519753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.226.62.81', '2019-06-30 20:20:47', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 20:20:47');
INSERT INTO `access_log` VALUES (45734, '65.49.15618972592999747', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.226.62.81', '2019-06-30 20:20:59', 72, 0, '', '2019-06-30 20:20:59');
INSERT INTO `access_log` VALUES (45735, '65.46.15618972597319799', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.226.62.81', '2019-06-30 20:21:00', 65, 0, '', '2019-06-30 20:21:00');
INSERT INTO `access_log` VALUES (45736, '65.47.15618972597319713', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.226.62.81', '2019-06-30 20:21:00', 65, 0, '', '2019-06-30 20:21:00');
INSERT INTO `access_log` VALUES (45737, '65.51.15618972597319777', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.226.62.81', '2019-06-30 20:21:00', 65, 2001001000, '服务端发生异常', '2019-06-30 20:21:00');
INSERT INTO `access_log` VALUES (45738, '59.72.15618975082508417', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:25:08', 12, 0, '', '2019-06-30 20:25:08');
INSERT INTO `access_log` VALUES (45739, '59.71.15618975082468417', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:25:08', 26, 2001001000, '服务端发生异常', '2019-06-30 20:25:08');
INSERT INTO `access_log` VALUES (45740, '64.81.15618975166248489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:25:17', 10, 0, '', '2019-06-30 20:25:17');
INSERT INTO `access_log` VALUES (45741, '64.85.15618975168248509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:25:17', 4, 0, '', '2019-06-30 20:25:17');
INSERT INTO `access_log` VALUES (45742, '64.83.15618975197828485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:25:20', 3, 0, '', '2019-06-30 20:25:20');
INSERT INTO `access_log` VALUES (45743, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:25:20', 15, 0, '', '2019-06-30 20:25:20');
INSERT INTO `access_log` VALUES (45744, '64.77.15618975226138485', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:25:23', 8, 0, '', '2019-06-30 20:25:23');
INSERT INTO `access_log` VALUES (45745, '64.78.15618975425188497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:25:43', 2, 0, '', '2019-06-30 20:25:43');
INSERT INTO `access_log` VALUES (45746, '64.80.15618975425188497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:25:43', 4, 0, '', '2019-06-30 20:25:43');
INSERT INTO `access_log` VALUES (45747, '64.84.15618975425138487', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:25:43', 10, 0, '', '2019-06-30 20:25:43');
INSERT INTO `access_log` VALUES (45748, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:25:43', 7, 0, '', '2019-06-30 20:25:43');
INSERT INTO `access_log` VALUES (45749, '64.82.15618975430808503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:25:43', 5, 0, '', '2019-06-30 20:25:43');
INSERT INTO `access_log` VALUES (45750, '59.74.15618975466588421', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:25:47', 3, 0, '', '2019-06-30 20:25:47');
INSERT INTO `access_log` VALUES (45751, '59.76.15618975466588411', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:25:47', 21, 2001001000, '服务端发生异常', '2019-06-30 20:25:47');
INSERT INTO `access_log` VALUES (45752, '59.71.15618976140228419', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:26:54', 3, 0, '', '2019-06-30 20:26:54');
INSERT INTO `access_log` VALUES (45753, '59.78.15618976140228413', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:26:54', 22, 2001001000, '服务端发生异常', '2019-06-30 20:26:54');
INSERT INTO `access_log` VALUES (45754, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=JAVA&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:27:06', 7, 0, '', '2019-06-30 20:27:06');
INSERT INTO `access_log` VALUES (45755, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=JAVA', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:27:06', 17, 0, '', '2019-06-30 20:27:06');
INSERT INTO `access_log` VALUES (45756, '64.80.15618976285318499', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:27:09', 6, 0, '', '2019-06-30 20:27:09');
INSERT INTO `access_log` VALUES (45757, '66.54.15618976509796601', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13818938640', 'POST', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:27:31', 79, 0, '', '2019-06-30 20:27:31');
INSERT INTO `access_log` VALUES (45758, '66.53.15618976924106587', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13818938640&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:28:12', 178, 0, '', '2019-06-30 20:28:13');
INSERT INTO `access_log` VALUES (45759, '66.49.15618976949396601', 143, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:28:15', 8, 0, '', '2019-06-30 20:28:15');
INSERT INTO `access_log` VALUES (45760, '64.79.15618977089868507', 143, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:28:29', 13, 0, '', '2019-06-30 20:28:29');
INSERT INTO `access_log` VALUES (45761, '66.54.15618977333866603', 143, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:28:53', 6, 0, '', '2019-06-30 20:28:53');
INSERT INTO `access_log` VALUES (45762, '66.57.15618977448326595', 143, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:29:05', 6, 0, '', '2019-06-30 20:29:05');
INSERT INTO `access_log` VALUES (45763, '66.56.15618977953726605', 143, 1, 'user-application', '/user-api/users/address/add', 'name=单独&tel=13818938640&country=&province=上海市&city=上海市&county=黄浦区&areaCode=310101&postalCode=&addressDetail=123123&isDefault=true&address=123123&areaNo=310101&mobile=13818938640&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:29:55', 93, 2001001000, '服务端发生异常', '2019-06-30 20:29:55');
INSERT INTO `access_log` VALUES (45764, '66.52.15618977983276595', 143, 1, 'user-application', '/user-api/users/address/add', 'name=单独&tel=13818938640&country=&province=上海市&city=上海市&county=黄浦区&areaCode=310101&postalCode=&addressDetail=123123&isDefault=true&address=123123&areaNo=310101&mobile=13818938640&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:29:58', 109, 2001001000, '服务端发生异常', '2019-06-30 20:29:58');
INSERT INTO `access_log` VALUES (45765, '66.54.15618978036166605', 143, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:30:04', 6, 0, '', '2019-06-30 20:30:04');
INSERT INTO `access_log` VALUES (45766, '66.55.15618978053756583', 143, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:30:05', 6, 0, '', '2019-06-30 20:30:05');
INSERT INTO `access_log` VALUES (45767, '64.85.15618978069828515', 143, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:30:07', 15, 0, '', '2019-06-30 20:30:07');
INSERT INTO `access_log` VALUES (45768, '66.50.15618978108216591', 143, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:30:11', 6, 0, '', '2019-06-30 20:30:11');
INSERT INTO `access_log` VALUES (45769, '59.75.15618999932998459', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.133.218', '2019-06-30 21:06:33', 11, 0, '', '2019-06-30 21:06:33');
INSERT INTO `access_log` VALUES (45770, '59.73.15618999932998457', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.133.218', '2019-06-30 21:06:33', 19, 2001001000, '服务端发生异常', '2019-06-30 21:06:33');
INSERT INTO `access_log` VALUES (45771, '64.78.15618999965128531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.133.218', '2019-06-30 21:06:37', 11, 0, '', '2019-06-30 21:06:37');
INSERT INTO `access_log` VALUES (45772, '64.82.15618999965928537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.133.218', '2019-06-30 21:06:37', 3, 0, '', '2019-06-30 21:06:37');
INSERT INTO `access_log` VALUES (45773, '64.81.15618999978688525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.133.218', '2019-06-30 21:06:38', 2, 0, '', '2019-06-30 21:06:38');
INSERT INTO `access_log` VALUES (45774, '64.85.15618999984008545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.133.218', '2019-06-30 21:06:38', 3, 0, '', '2019-06-30 21:06:38');
INSERT INTO `access_log` VALUES (45775, '65.52.15619003026519801', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:11:43', 0, 1002001015, '账号未登陆', '2019-06-30 21:11:43');
INSERT INTO `access_log` VALUES (45776, '65.54.15619003026539741', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:11:43', 0, 1002001015, '账号未登陆', '2019-06-30 21:11:43');
INSERT INTO `access_log` VALUES (45777, '65.53.15619003026539789', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:11:43', 0, 1002001015, '账号未登陆', '2019-06-30 21:11:43');
INSERT INTO `access_log` VALUES (45778, '65.50.15619003065469797', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:11:47', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 21:11:47');
INSERT INTO `access_log` VALUES (45779, '65.49.15619003167739791', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:11:57', 70, 0, '', '2019-06-30 21:11:57');
INSERT INTO `access_log` VALUES (45780, '65.45.15619003170809779', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:11:57', 10, 2001001000, '服务端发生异常', '2019-06-30 21:11:57');
INSERT INTO `access_log` VALUES (45781, '65.46.15619003170809841', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:11:57', 11, 0, '', '2019-06-30 21:11:57');
INSERT INTO `access_log` VALUES (45782, '65.47.15619003170809755', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:11:57', 17, 0, '', '2019-06-30 21:11:57');
INSERT INTO `access_log` VALUES (45783, '65.52.15619003298969803', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:12:10', 11, 0, '', '2019-06-30 21:12:10');
INSERT INTO `access_log` VALUES (45784, '65.53.15619003299029791', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:12:10', 9, 0, '', '2019-06-30 21:12:10');
INSERT INTO `access_log` VALUES (45785, '65.54.15619003299029743', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:12:10', 10, 2001001000, '服务端发生异常', '2019-06-30 21:12:10');
INSERT INTO `access_log` VALUES (45786, '65.50.15619003321589799', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:12:12', 7, 0, '', '2019-06-30 21:12:12');
INSERT INTO `access_log` VALUES (45787, '65.3607.15619003321591571', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:12:12', 9, 2001001000, '服务端发生异常', '2019-06-30 21:12:12');
INSERT INTO `access_log` VALUES (45788, '65.49.15619003321599793', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:12:12', 7, 0, '', '2019-06-30 21:12:12');
INSERT INTO `access_log` VALUES (45789, '65.45.15619005077619783', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:15:08', 10, 0, '', '2019-06-30 21:15:08');
INSERT INTO `access_log` VALUES (45790, '65.46.15619005077669845', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:15:08', 10, 2001001000, '服务端发生异常', '2019-06-30 21:15:08');
INSERT INTO `access_log` VALUES (45791, '65.51.15619005077689825', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:15:08', 9, 0, '', '2019-06-30 21:15:08');
INSERT INTO `access_log` VALUES (45792, '59.75.15619020508988487', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:40:51', 16, 0, '', '2019-06-30 21:40:51');
INSERT INTO `access_log` VALUES (45793, '59.73.15619020508988485', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:40:51', 23, 2001001000, '服务端发生异常', '2019-06-30 21:40:51');
INSERT INTO `access_log` VALUES (45794, '64.82.15619020571558565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:40:57', 12, 0, '', '2019-06-30 21:40:57');
INSERT INTO `access_log` VALUES (45795, '64.81.15619020572558553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:40:57', 3, 0, '', '2019-06-30 21:40:57');
INSERT INTO `access_log` VALUES (45796, '64.85.15619020585718573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:40:59', 2, 0, '', '2019-06-30 21:40:59');
INSERT INTO `access_log` VALUES (45797, '64.83.15619020592608549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:40:59', 2, 0, '', '2019-06-30 21:40:59');
INSERT INTO `access_log` VALUES (45798, '64.79.15619020630908567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:03', 2, 0, '', '2019-06-30 21:41:03');
INSERT INTO `access_log` VALUES (45799, '64.77.15619020631738549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:03', 2, 0, '', '2019-06-30 21:41:03');
INSERT INTO `access_log` VALUES (45800, '64.76.15619020642488549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:04', 2, 0, '', '2019-06-30 21:41:04');
INSERT INTO `access_log` VALUES (45801, '59.79.15619020657388485', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:06', 3, 0, '', '2019-06-30 21:41:06');
INSERT INTO `access_log` VALUES (45802, '59.72.15619020657388481', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:06', 26, 2001001000, '服务端发生异常', '2019-06-30 21:41:06');
INSERT INTO `access_log` VALUES (45803, '64.84.15619020755558551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:16', 2, 0, '', '2019-06-30 21:41:16');
INSERT INTO `access_log` VALUES (45804, '64.78.15619020756788561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:16', 2, 0, '', '2019-06-30 21:41:16');
INSERT INTO `access_log` VALUES (45805, '64.82.15619020766868567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:17', 2, 0, '', '2019-06-30 21:41:17');
INSERT INTO `access_log` VALUES (45806, '64.81.15619020772008555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:17', 1, 0, '', '2019-06-30 21:41:17');
INSERT INTO `access_log` VALUES (45807, '64.85.15619020798278575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:20', 1, 0, '', '2019-06-30 21:41:20');
INSERT INTO `access_log` VALUES (45808, '64.83.15619020802018551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:20', 1, 0, '', '2019-06-30 21:41:20');
INSERT INTO `access_log` VALUES (45809, '64.77.15619020850178551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:25', 2, 0, '', '2019-06-30 21:41:25');
INSERT INTO `access_log` VALUES (45810, '64.76.15619020851468551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:25', 2, 0, '', '2019-06-30 21:41:25');
INSERT INTO `access_log` VALUES (45811, '59.78.15619020866338475', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:27', 3, 0, '', '2019-06-30 21:41:27');
INSERT INTO `access_log` VALUES (45812, '59.80.15619020866338469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.104.87', '2019-06-30 21:41:27', 14, 2001001000, '服务端发生异常', '2019-06-30 21:41:27');
INSERT INTO `access_log` VALUES (45813, '65.53.15619029226969827', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:55:23', 15, 0, '', '2019-06-30 21:55:23');
INSERT INTO `access_log` VALUES (45814, '65.54.15619029226969779', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:55:23', 16, 2001001000, '服务端发生异常', '2019-06-30 21:55:23');
INSERT INTO `access_log` VALUES (45815, '65.50.15619029226979835', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 21:55:23', 16, 0, '', '2019-06-30 21:55:23');
INSERT INTO `access_log` VALUES (45816, '59.72.15619069768408547', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:02:57', 11, 0, '', '2019-06-30 23:02:57');
INSERT INTO `access_log` VALUES (45817, '59.71.15619069768408547', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:02:57', 35, 2001001000, '服务端发生异常', '2019-06-30 23:02:57');
INSERT INTO `access_log` VALUES (45818, '64.83.15619069845058617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:03:05', 12, 0, '', '2019-06-30 23:03:05');
INSERT INTO `access_log` VALUES (45819, '64.79.15619069846008635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:03:05', 3, 0, '', '2019-06-30 23:03:05');
INSERT INTO `access_log` VALUES (45820, '64.76.15619069932788617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:03:13', 2, 0, '', '2019-06-30 23:03:13');
INSERT INTO `access_log` VALUES (45821, '64.80.15619069935078629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:03:14', 1, 0, '', '2019-06-30 23:03:14');
INSERT INTO `access_log` VALUES (45822, '59.74.15619070092868549', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:03:29', 3, 0, '', '2019-06-30 23:03:29');
INSERT INTO `access_log` VALUES (45823, '59.76.15619070092888541', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:03:29', 11, 2001001000, '服务端发生异常', '2019-06-30 23:03:29');
INSERT INTO `access_log` VALUES (45824, '64.82.15619070164718635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:03:36', 2, 0, '', '2019-06-30 23:03:36');
INSERT INTO `access_log` VALUES (45825, '64.81.15619070165838623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:03:37', 2, 0, '', '2019-06-30 23:03:37');
INSERT INTO `access_log` VALUES (45826, '59.73.15619070189998553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:03:39', 9, 0, '', '2019-06-30 23:03:39');
INSERT INTO `access_log` VALUES (45827, '59.77.15619070189998537', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:03:39', 18, 2001001000, '服务端发生异常', '2019-06-30 23:03:39');
INSERT INTO `access_log` VALUES (45828, '64.85.15619070226828643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:03:43', 2, 0, '', '2019-06-30 23:03:43');
INSERT INTO `access_log` VALUES (45829, '64.83.15619070227688619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:03:43', 2, 0, '', '2019-06-30 23:03:43');
INSERT INTO `access_log` VALUES (45830, '59.79.15619070251378553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:03:45', 3, 0, '', '2019-06-30 23:03:45');
INSERT INTO `access_log` VALUES (45831, '59.71.15619070251388549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:03:45', 12, 2001001000, '服务端发生异常', '2019-06-30 23:03:45');
INSERT INTO `access_log` VALUES (45832, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:04:02', 7, 0, '', '2019-06-30 23:04:02');
INSERT INTO `access_log` VALUES (45833, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=java', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:04:02', 11, 0, '', '2019-06-30 23:04:02');
INSERT INTO `access_log` VALUES (45834, '64.77.15619070433168619', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:04:03', 7, 0, '', '2019-06-30 23:04:03');
INSERT INTO `access_log` VALUES (45835, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:04:16', 13, 0, '', '2019-06-30 23:04:16');
INSERT INTO `access_log` VALUES (45836, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:04:16', 9, 0, '', '2019-06-30 23:04:16');
INSERT INTO `access_log` VALUES (45837, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:04:21', 5, 0, '', '2019-06-30 23:04:21');
INSERT INTO `access_log` VALUES (45838, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:04:21', 13, 0, '', '2019-06-30 23:04:21');
INSERT INTO `access_log` VALUES (45839, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=desc', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:04:31', 9, 0, '', '2019-06-30 23:04:31');
INSERT INTO `access_log` VALUES (45840, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=asc', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:04:33', 7, 0, '', '2019-06-30 23:04:33');
INSERT INTO `access_log` VALUES (45841, '59.74.15619070764838551', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:04:36', 2, 0, '', '2019-06-30 23:04:36');
INSERT INTO `access_log` VALUES (45842, '59.75.15619070764878557', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:04:36', 16, 2001001000, '服务端发生异常', '2019-06-30 23:04:37');
INSERT INTO `access_log` VALUES (45843, '64.78.15619070796708631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:04:40', 2, 0, '', '2019-06-30 23:04:40');
INSERT INTO `access_log` VALUES (45844, '64.82.15619070798178637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:04:40', 2, 0, '', '2019-06-30 23:04:40');
INSERT INTO `access_log` VALUES (45845, '66.50.15619070913526715', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15700082812', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 9_1 like Mac OS X) AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1', '36.22.249.23', '2019-06-30 23:04:51', 74, 0, '', '2019-06-30 23:04:51');
INSERT INTO `access_log` VALUES (45846, '65.46.15619071818759935', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:06:22', 5, 1002001012, '访问令牌已过期', '2019-06-30 23:06:22');
INSERT INTO `access_log` VALUES (45847, '65.45.15619071818759873', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:06:22', 5, 1002001012, '访问令牌已过期', '2019-06-30 23:06:22');
INSERT INTO `access_log` VALUES (45848, '65.52.15619071818919897', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:06:22', 11, 1002001012, '访问令牌已过期', '2019-06-30 23:06:22');
INSERT INTO `access_log` VALUES (45849, '65.53.15619071842579885', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:06:24', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 23:06:24');
INSERT INTO `access_log` VALUES (45850, '65.54.15619071973619837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:06:37', 72, 0, '', '2019-06-30 23:06:37');
INSERT INTO `access_log` VALUES (45851, '65.49.15619071976849887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:06:38', 11, 0, '', '2019-06-30 23:06:38');
INSERT INTO `access_log` VALUES (45852, '65.47.15619071976859851', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:06:38', 12, 0, '', '2019-06-30 23:06:38');
INSERT INTO `access_log` VALUES (45853, '65.3607.15619071976841665', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:06:38', 13, 2001001000, '服务端发生异常', '2019-06-30 23:06:38');
INSERT INTO `access_log` VALUES (45854, '65.46.15619072095109937', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:06:50', 9, 0, '', '2019-06-30 23:06:50');
INSERT INTO `access_log` VALUES (45855, '65.45.15619072095179875', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:06:50', 8, 0, '', '2019-06-30 23:06:50');
INSERT INTO `access_log` VALUES (45856, '65.52.15619072095179899', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:06:50', 10, 2001001000, '服务端发生异常', '2019-06-30 23:06:50');
INSERT INTO `access_log` VALUES (45857, '65.53.15619072260369887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:06', 8, 0, '', '2019-06-30 23:07:06');
INSERT INTO `access_log` VALUES (45858, '65.54.15619072260469839', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:06', 8, 2001001000, '服务端发生异常', '2019-06-30 23:07:06');
INSERT INTO `access_log` VALUES (45859, '65.3607.15619072260471667', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:06', 8, 0, '', '2019-06-30 23:07:06');
INSERT INTO `access_log` VALUES (45860, '65.47.15619072298469853', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:10', 9, 0, '', '2019-06-30 23:07:10');
INSERT INTO `access_log` VALUES (45861, '65.51.15619072298509919', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:10', 11, 2001001000, '服务端发生异常', '2019-06-30 23:07:10');
INSERT INTO `access_log` VALUES (45862, '65.52.15619072298609901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:10', 16, 0, '', '2019-06-30 23:07:10');
INSERT INTO `access_log` VALUES (45863, '65.45.15619072340749877', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:14', 8, 0, '', '2019-06-30 23:07:14');
INSERT INTO `access_log` VALUES (45864, '65.46.15619072340769939', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:14', 8, 2001001000, '服务端发生异常', '2019-06-30 23:07:14');
INSERT INTO `access_log` VALUES (45865, '65.50.15619072340779897', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:14', 8, 0, '', '2019-06-30 23:07:14');
INSERT INTO `access_log` VALUES (45866, '65.53.15619072387579889', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:19', 9, 0, '', '2019-06-30 23:07:19');
INSERT INTO `access_log` VALUES (45867, '65.3607.15619072387641669', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:19', 8, 0, '', '2019-06-30 23:07:19');
INSERT INTO `access_log` VALUES (45868, '65.54.15619072387649841', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:19', 10, 2001001000, '服务端发生异常', '2019-06-30 23:07:19');
INSERT INTO `access_log` VALUES (45869, '65.49.15619072422279891', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:22', 9, 0, '', '2019-06-30 23:07:22');
INSERT INTO `access_log` VALUES (45870, '65.47.15619072422279855', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:22', 10, 2001001000, '服务端发生异常', '2019-06-30 23:07:22');
INSERT INTO `access_log` VALUES (45871, '65.52.15619072422339903', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '36.22.249.23', '2019-06-30 23:07:22', 8, 0, '', '2019-06-30 23:07:22');
INSERT INTO `access_log` VALUES (45872, '59.79.15619078544628565', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.21.218', '2019-06-30 23:17:34', 3, 0, '', '2019-06-30 23:17:34');
INSERT INTO `access_log` VALUES (45873, '59.71.15619078544628561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.21.218', '2019-06-30 23:17:34', 19, 2001001000, '服务端发生异常', '2019-06-30 23:17:34');
INSERT INTO `access_log` VALUES (45874, '65.45.15619078628309887', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.21.218', '2019-06-30 23:17:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 23:17:43');
INSERT INTO `access_log` VALUES (45875, '65.46.15619078668989949', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.21.218', '2019-06-30 23:17:47', 65, 0, '', '2019-06-30 23:17:47');
INSERT INTO `access_log` VALUES (45876, '65.3607.15619078672671679', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.21.218', '2019-06-30 23:17:47', 9, 0, '', '2019-06-30 23:17:47');
INSERT INTO `access_log` VALUES (45877, '65.54.15619078672709851', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.21.218', '2019-06-30 23:17:47', 10, 2001001000, '服务端发生异常', '2019-06-30 23:17:47');
INSERT INTO `access_log` VALUES (45878, '65.53.15619078672739899', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.21.218', '2019-06-30 23:17:47', 10, 0, '', '2019-06-30 23:17:47');
INSERT INTO `access_log` VALUES (45879, '59.76.15619078904138555', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.21.218', '2019-06-30 23:18:10', 2, 0, '', '2019-06-30 23:18:10');
INSERT INTO `access_log` VALUES (45880, '59.80.15619078904138549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.21.218', '2019-06-30 23:18:10', 13, 2001001000, '服务端发生异常', '2019-06-30 23:18:10');
INSERT INTO `access_log` VALUES (45881, '64.77.15619078932588631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.21.218', '2019-06-30 23:18:13', 3, 0, '', '2019-06-30 23:18:13');
INSERT INTO `access_log` VALUES (45882, '64.76.15619078933918631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.21.218', '2019-06-30 23:18:13', 1, 0, '', '2019-06-30 23:18:13');
INSERT INTO `access_log` VALUES (45883, '64.80.15619078944048643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.21.218', '2019-06-30 23:18:14', 2, 0, '', '2019-06-30 23:18:14');
INSERT INTO `access_log` VALUES (45884, '59.77.15619086823258561', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.164', '2019-06-30 23:31:22', 3, 0, '', '2019-06-30 23:31:22');
INSERT INTO `access_log` VALUES (45885, '59.79.15619086823268577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.164', '2019-06-30 23:31:22', 10, 2001001000, '服务端发生异常', '2019-06-30 23:31:22');
INSERT INTO `access_log` VALUES (45886, '64.81.15619086876698647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.164', '2019-06-30 23:31:28', 3, 0, '', '2019-06-30 23:31:28');
INSERT INTO `access_log` VALUES (45887, '64.85.15619086877458667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.164', '2019-06-30 23:31:28', 2, 0, '', '2019-06-30 23:31:28');
INSERT INTO `access_log` VALUES (45888, '64.83.15619086890748643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.164', '2019-06-30 23:31:29', 2, 0, '', '2019-06-30 23:31:29');
INSERT INTO `access_log` VALUES (45889, '64.79.15619086897728661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.164', '2019-06-30 23:31:30', 1, 0, '', '2019-06-30 23:31:30');
INSERT INTO `access_log` VALUES (45890, '64.77.15619086903908643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.118.100.164', '2019-06-30 23:31:30', 2, 0, '', '2019-06-30 23:31:30');
INSERT INTO `access_log` VALUES (45891, '65.51.15619087683559943', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:32:48', 3, 1002001012, '访问令牌已过期', '2019-06-30 23:32:48');
INSERT INTO `access_log` VALUES (45892, '65.52.15619087683539925', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:32:48', 4, 1002001012, '访问令牌已过期', '2019-06-30 23:32:48');
INSERT INTO `access_log` VALUES (45893, '65.50.15619087683559921', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:32:48', 3, 1002001012, '访问令牌已过期', '2019-06-30 23:32:48');
INSERT INTO `access_log` VALUES (45894, '65.45.15619087702429901', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:32:50', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-06-30 23:32:50');
INSERT INTO `access_log` VALUES (45895, '65.46.15619087735059963', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:32:54', 89, 0, '', '2019-06-30 23:32:54');
INSERT INTO `access_log` VALUES (45896, '65.54.15619087737999865', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:32:54', 10, 0, '', '2019-06-30 23:32:54');
INSERT INTO `access_log` VALUES (45897, '65.53.15619087738079913', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:32:54', 8, 0, '', '2019-06-30 23:32:54');
INSERT INTO `access_log` VALUES (45898, '65.3607.15619087738081693', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:32:54', 9, 2001001000, '服务端发生异常', '2019-06-30 23:32:54');
INSERT INTO `access_log` VALUES (45899, '65.51.15619087809209945', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:33:01', 8, 0, '', '2019-06-30 23:33:01');
INSERT INTO `access_log` VALUES (45900, '65.50.15619087809199923', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:33:01', 10, 2001001000, '服务端发生异常', '2019-06-30 23:33:01');
INSERT INTO `access_log` VALUES (45901, '65.49.15619087809169915', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:33:01', 14, 0, '', '2019-06-30 23:33:01');
INSERT INTO `access_log` VALUES (45902, '65.52.15619087835099927', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:33:04', 9, 0, '', '2019-06-30 23:33:04');
INSERT INTO `access_log` VALUES (45903, '65.46.15619087835129965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:33:04', 9, 0, '', '2019-06-30 23:33:04');
INSERT INTO `access_log` VALUES (45904, '65.45.15619087835129903', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:33:04', 10, 2001001000, '服务端发生异常', '2019-06-30 23:33:04');
INSERT INTO `access_log` VALUES (45905, '65.49.15619088631239917', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:34:23', 9, 0, '', '2019-06-30 23:34:23');
INSERT INTO `access_log` VALUES (45906, '65.51.15619088631249947', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:34:23', 11, 2001001000, '服务端发生异常', '2019-06-30 23:34:23');
INSERT INTO `access_log` VALUES (45907, '65.52.15619088631289929', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:34:23', 9, 0, '', '2019-06-30 23:34:23');
INSERT INTO `access_log` VALUES (45908, '65.47.15619088859109883', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '123.118.25.28', '2019-06-30 23:34:46', 1, 1002001015, '账号未登陆', '2019-06-30 23:34:46');
INSERT INTO `access_log` VALUES (45909, '65.3607.15619088859111697', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '123.118.25.28', '2019-06-30 23:34:46', 0, 1002001015, '账号未登陆', '2019-06-30 23:34:46');
INSERT INTO `access_log` VALUES (45910, '65.54.15619088859129869', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '123.118.25.28', '2019-06-30 23:34:46', 1, 1002001015, '账号未登陆', '2019-06-30 23:34:46');
INSERT INTO `access_log` VALUES (45911, '65.53.15619088935769917', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '123.118.25.28', '2019-06-30 23:34:54', 85, 0, '', '2019-06-30 23:34:54');
INSERT INTO `access_log` VALUES (45912, '65.49.15619088942219919', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '123.118.25.28', '2019-06-30 23:34:54', 9, 0, '', '2019-06-30 23:34:54');
INSERT INTO `access_log` VALUES (45913, '65.52.15619088942219931', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '123.118.25.28', '2019-06-30 23:34:54', 8, 0, '', '2019-06-30 23:34:54');
INSERT INTO `access_log` VALUES (45914, '65.51.15619088942209949', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '123.118.25.28', '2019-06-30 23:34:54', 10, 2001001000, '服务端发生异常', '2019-06-30 23:34:54');
INSERT INTO `access_log` VALUES (45915, '65.3607.15619089312221699', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:35:31', 11, 2001001000, '服务端发生异常', '2019-06-30 23:35:31');
INSERT INTO `access_log` VALUES (45916, '65.54.15619089323969871', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:35:32', 10, 0, '', '2019-06-30 23:35:32');
INSERT INTO `access_log` VALUES (45917, '65.47.15619089324049885', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-06-30 23:35:32', 8, 0, '', '2019-06-30 23:35:32');
INSERT INTO `access_log` VALUES (45918, '59.75.15619105634568605', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-07-01 00:02:43', 11, 0, '', '2019-07-01 00:02:43');
INSERT INTO `access_log` VALUES (45919, '59.74.15619105634598599', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-07-01 00:02:43', 43, 2001001000, '服务端发生异常', '2019-07-01 00:02:44');
INSERT INTO `access_log` VALUES (45920, '59.79.15619105692458603', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-07-01 00:02:49', 3, 0, '', '2019-07-01 00:02:49');
INSERT INTO `access_log` VALUES (45921, '59.77.15619105692458587', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.25.28', '2019-07-01 00:02:49', 14, 2001001000, '服务端发生异常', '2019-07-01 00:02:49');
INSERT INTO `access_log` VALUES (45922, '65.51.15619106347939973', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:03:55', 0, 1002001015, '账号未登陆', '2019-07-01 00:03:55');
INSERT INTO `access_log` VALUES (45923, '65.45.15619106347939931', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:03:55', 0, 1002001015, '账号未登陆', '2019-07-01 00:03:55');
INSERT INTO `access_log` VALUES (45924, '65.46.15619106347949993', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:03:55', 1, 1002001015, '账号未登陆', '2019-07-01 00:03:55');
INSERT INTO `access_log` VALUES (45925, '65.3607.15619106424261723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:04:02', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 00:04:02');
INSERT INTO `access_log` VALUES (45926, '65.47.15619106449049909', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:04:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 00:04:05');
INSERT INTO `access_log` VALUES (45927, '65.54.15619106454649895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:04:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 00:04:05');
INSERT INTO `access_log` VALUES (45928, '65.50.15619106568509953', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:04:17', 78, 0, '', '2019-07-01 00:04:17');
INSERT INTO `access_log` VALUES (45929, '65.52.15619106571989957', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:04:17', 10, 0, '', '2019-07-01 00:04:17');
INSERT INTO `access_log` VALUES (45930, '65.51.15619106572059975', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:04:17', 8, 0, '', '2019-07-01 00:04:17');
INSERT INTO `access_log` VALUES (45931, '65.49.15619106572059945', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:04:17', 10, 2001001000, '服务端发生异常', '2019-07-01 00:04:17');
INSERT INTO `access_log` VALUES (45932, '65.46.15619106628159995', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:04:23', 10, 0, '', '2019-07-01 00:04:23');
INSERT INTO `access_log` VALUES (45933, '65.3607.15619106628191725', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:04:23', 8, 0, '', '2019-07-01 00:04:23');
INSERT INTO `access_log` VALUES (45934, '65.45.15619106628199933', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:04:23', 10, 2001001000, '服务端发生异常', '2019-07-01 00:04:23');
INSERT INTO `access_log` VALUES (45935, '59.71.15619107249048601', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:05:25', 3, 0, '', '2019-07-01 00:05:25');
INSERT INTO `access_log` VALUES (45936, '59.72.15619107249108601', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:05:25', 16, 2001001000, '服务端发生异常', '2019-07-01 00:05:25');
INSERT INTO `access_log` VALUES (45937, '59.76.15619107332408595', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:05:33', 3, 0, '', '2019-07-01 00:05:33');
INSERT INTO `access_log` VALUES (45938, '59.78.15619107332368595', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.65.30.82', '2019-07-01 00:05:33', 9, 2001001000, '服务端发生异常', '2019-07-01 00:05:33');
INSERT INTO `access_log` VALUES (45939, '65.45.15619107735619935', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.206.197.156', '2019-07-01 00:06:14', 0, 1002001015, '账号未登陆', '2019-07-01 00:06:14');
INSERT INTO `access_log` VALUES (45940, '65.46.15619107735889997', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.206.197.156', '2019-07-01 00:06:14', 0, 1002001015, '账号未登陆', '2019-07-01 00:06:14');
INSERT INTO `access_log` VALUES (45941, '65.47.15619107735939913', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.206.197.156', '2019-07-01 00:06:14', 1, 1002001015, '账号未登陆', '2019-07-01 00:06:14');
INSERT INTO `access_log` VALUES (45942, '65.54.15619107789579899', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.206.197.156', '2019-07-01 00:06:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 00:06:19');
INSERT INTO `access_log` VALUES (45943, '65.51.15619108048509979', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.206.197.156', '2019-07-01 00:06:45', 1715, 0, '', '2019-07-01 00:06:47');
INSERT INTO `access_log` VALUES (45944, '65.52.15619108074659961', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.206.197.156', '2019-07-01 00:06:47', 1827, 0, '', '2019-07-01 00:06:49');
INSERT INTO `access_log` VALUES (45945, '65.3607.15619108074721729', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.206.197.156', '2019-07-01 00:06:47', 1820, 0, '', '2019-07-01 00:06:49');
INSERT INTO `access_log` VALUES (45946, '65.49.15619108074709949', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.206.197.156', '2019-07-01 00:06:47', 1823, 2001001000, '服务端发生异常', '2019-07-01 00:06:49');
INSERT INTO `access_log` VALUES (45947, '65.45.15619108239609937', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.206.197.156', '2019-07-01 00:07:04', 9, 0, '', '2019-07-01 00:07:04');
INSERT INTO `access_log` VALUES (45948, '65.46.15619108239679999', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.206.197.156', '2019-07-01 00:07:04', 10, 2001001000, '服务端发生异常', '2019-07-01 00:07:04');
INSERT INTO `access_log` VALUES (45949, '65.54.15619108239889901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.206.197.156', '2019-07-01 00:07:04', 8, 0, '', '2019-07-01 00:07:04');
INSERT INTO `access_log` VALUES (45950, '59.76.15619130918248627', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.37.67', '2019-07-01 00:44:52', 10, 0, '', '2019-07-01 00:44:52');
INSERT INTO `access_log` VALUES (45951, '59.78.15619130918248627', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.37.67', '2019-07-01 00:44:52', 14, 2001001000, '服务端发生异常', '2019-07-01 00:44:52');
INSERT INTO `access_log` VALUES (45952, '59.75.15619445901059061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.53.192', '2019-07-01 09:29:50', 12, 0, '', '2019-07-01 09:29:50');
INSERT INTO `access_log` VALUES (45953, '59.80.15619445901059041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.53.192', '2019-07-01 09:29:50', 27, 2001001000, '服务端发生异常', '2019-07-01 09:29:50');
INSERT INTO `access_log` VALUES (45954, '59.71.15619458427229071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:50:43', 4, 0, '', '2019-07-01 09:50:43');
INSERT INTO `access_log` VALUES (45955, '59.77.15619458427229059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:50:43', 20, 2001001000, '服务端发生异常', '2019-07-01 09:50:43');
INSERT INTO `access_log` VALUES (45956, '59.78.15619458497509065', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:50:50', 8, 0, '', '2019-07-01 09:50:50');
INSERT INTO `access_log` VALUES (45957, '59.76.15619458497509065', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:50:50', 26, 2001001000, '服务端发生异常', '2019-07-01 09:50:50');
INSERT INTO `access_log` VALUES (45958, '64.79.15619458520529157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:50:52', 10, 0, '', '2019-07-01 09:50:52');
INSERT INTO `access_log` VALUES (45959, '64.77.15619458524009139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:50:52', 2, 0, '', '2019-07-01 09:50:52');
INSERT INTO `access_log` VALUES (45960, '64.76.15619458534479139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:50:53', 2, 0, '', '2019-07-01 09:50:53');
INSERT INTO `access_log` VALUES (45961, '64.80.15619458546139151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:50:55', 2, 0, '', '2019-07-01 09:50:55');
INSERT INTO `access_log` VALUES (45962, '64.84.15619458647819141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:05', 1, 0, '', '2019-07-01 09:51:05');
INSERT INTO `access_log` VALUES (45963, '64.78.15619458653819151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:05', 3, 0, '', '2019-07-01 09:51:05');
INSERT INTO `access_log` VALUES (45964, '59.74.15619458665359073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:07', 16, 2001001000, '服务端发生异常', '2019-07-01 09:51:07');
INSERT INTO `access_log` VALUES (45965, '59.75.15619458665359079', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:07', 61, 0, '', '2019-07-01 09:51:07');
INSERT INTO `access_log` VALUES (45966, '66.52.15619458778097237', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18761424986', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:18', 108, 0, '', '2019-07-01 09:51:18');
INSERT INTO `access_log` VALUES (45967, '66.55.15619458840457225', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18761424986&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:24', 180, 0, '', '2019-07-01 09:51:24');
INSERT INTO `access_log` VALUES (45968, '59.71.15619458903369073', 129, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:30', 10, 0, '', '2019-07-01 09:51:30');
INSERT INTO `access_log` VALUES (45969, '59.72.15619458903369073', 129, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:30', 19, 2001001000, '服务端发生异常', '2019-07-01 09:51:30');
INSERT INTO `access_log` VALUES (45970, '66.50.15619458922497233', 129, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:32', 6, 0, '', '2019-07-01 09:51:32');
INSERT INTO `access_log` VALUES (45971, '66.48.15619458991627253', 129, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:39', 6, 0, '', '2019-07-01 09:51:39');
INSERT INTO `access_log` VALUES (45972, '64.79.15619459017299159', 129, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:42', 6, 0, '', '2019-07-01 09:51:42');
INSERT INTO `access_log` VALUES (45973, '64.76.15619459018589141', 129, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:42', 9, 0, '', '2019-07-01 09:51:42');
INSERT INTO `access_log` VALUES (45974, '59.76.15619459026779067', 129, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:43', 6, 0, '', '2019-07-01 09:51:43');
INSERT INTO `access_log` VALUES (45975, '59.80.15619459026779061', 129, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:43', 21, 2001001000, '服务端发生异常', '2019-07-01 09:51:43');
INSERT INTO `access_log` VALUES (45976, '64.80.15619459053979153', 129, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:45', 7, 0, '', '2019-07-01 09:51:45');
INSERT INTO `access_log` VALUES (45977, '64.84.15619459054899143', 129, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:45', 6, 0, '', '2019-07-01 09:51:45');
INSERT INTO `access_log` VALUES (45978, '64.82.15619459064049159', 129, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:46', 6, 0, '', '2019-07-01 09:51:46');
INSERT INTO `access_log` VALUES (45979, '64.85.15619459086929167', 129, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:49', 4, 0, '', '2019-07-01 09:51:49');
INSERT INTO `access_log` VALUES (45980, '64.79.15619459124129161', 129, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:52', 5, 0, '', '2019-07-01 09:51:52');
INSERT INTO `access_log` VALUES (45981, '64.77.15619459130459143', 129, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:53', 7, 0, '', '2019-07-01 09:51:53');
INSERT INTO `access_log` VALUES (45982, '64.76.15619459179729143', 129, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:58', 5, 0, '', '2019-07-01 09:51:58');
INSERT INTO `access_log` VALUES (45983, '64.80.15619459185509155', 129, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:51:59', 5, 0, '', '2019-07-01 09:51:59');
INSERT INTO `access_log` VALUES (45984, '65.54.15619459364100371', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:52:16', 4, 1002001012, '访问令牌已过期', '2019-07-01 09:52:16');
INSERT INTO `access_log` VALUES (45985, '65.45.15619459364090407', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:52:16', 6, 1002001012, '访问令牌已过期', '2019-07-01 09:52:16');
INSERT INTO `access_log` VALUES (45986, '65.46.15619459364290469', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:52:16', 15, 1002001012, '访问令牌已过期', '2019-07-01 09:52:16');
INSERT INTO `access_log` VALUES (45987, '65.53.15619459413800417', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:52:21', 65, 0, '', '2019-07-01 09:52:21');
INSERT INTO `access_log` VALUES (45988, '65.50.15619459416230429', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:52:22', 9, 0, '', '2019-07-01 09:52:22');
INSERT INTO `access_log` VALUES (45989, '65.51.15619459416260451', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:52:22', 10, 2001001000, '服务端发生异常', '2019-07-01 09:52:22');
INSERT INTO `access_log` VALUES (45990, '65.3607.15619459416292199', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:52:22', 9, 0, '', '2019-07-01 09:52:22');
INSERT INTO `access_log` VALUES (45991, '65.49.15619459634210421', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:52:43', 9, 0, '', '2019-07-01 09:52:43');
INSERT INTO `access_log` VALUES (45992, '65.54.15619459634270373', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:52:43', 9, 0, '', '2019-07-01 09:52:43');
INSERT INTO `access_log` VALUES (45993, '65.45.15619459634280409', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:52:43', 10, 2001001000, '服务端发生异常', '2019-07-01 09:52:43');
INSERT INTO `access_log` VALUES (45994, '65.51.15619459967960453', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:53:17', 9, 0, '', '2019-07-01 09:53:17');
INSERT INTO `access_log` VALUES (45995, '65.3607.15619459968002201', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:53:17', 9, 0, '', '2019-07-01 09:53:17');
INSERT INTO `access_log` VALUES (45996, '65.50.15619459968000431', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:53:17', 10, 2001001000, '服务端发生异常', '2019-07-01 09:53:17');
INSERT INTO `access_log` VALUES (45997, '65.52.15619460010030435', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:53:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 09:53:21');
INSERT INTO `access_log` VALUES (45998, '65.47.15619460034500389', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:53:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 09:53:23');
INSERT INTO `access_log` VALUES (45999, '65.45.15619460075160411', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:53:28', 4, 1002002001, '密码不正确', '2019-07-01 09:53:28');
INSERT INTO `access_log` VALUES (46000, '65.49.15619460114900423', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:53:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 09:53:31');
INSERT INTO `access_log` VALUES (46001, '65.46.15619460122250473', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:53:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 09:53:32');
INSERT INTO `access_log` VALUES (46002, '65.53.15619460125720421', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:53:33', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 09:53:33');
INSERT INTO `access_log` VALUES (46003, '65.3607.15619460129042203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:53:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 09:53:33');
INSERT INTO `access_log` VALUES (46004, '65.51.15619460132210455', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:53:33', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 09:53:33');
INSERT INTO `access_log` VALUES (46005, '65.52.15619460336210437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminwangyunai&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:53:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 09:53:54');
INSERT INTO `access_log` VALUES (46006, '65.54.15619460365650377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=wangyunai&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:53:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 09:53:57');
INSERT INTO `access_log` VALUES (46007, '65.45.15619460410990413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=wangyunai&password=wangyunai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:54:01', 73, 0, '', '2019-07-01 09:54:01');
INSERT INTO `access_log` VALUES (46008, '65.49.15619460413350425', 22, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:54:01', 6, 0, '', '2019-07-01 09:54:01');
INSERT INTO `access_log` VALUES (46009, '65.46.15619460413370475', 22, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:54:01', 6, 0, '', '2019-07-01 09:54:01');
INSERT INTO `access_log` VALUES (46010, '65.53.15619460413410423', 22, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:54:01', 7, 0, '', '2019-07-01 09:54:01');
INSERT INTO `access_log` VALUES (46011, '65.51.15619460545700457', 22, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:54:15', 7, 0, '', '2019-07-01 09:54:15');
INSERT INTO `access_log` VALUES (46012, '65.50.15619460545720435', 22, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:54:15', 5, 0, '', '2019-07-01 09:54:15');
INSERT INTO `access_log` VALUES (46013, '65.52.15619460545760439', 22, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:54:15', 9, 0, '', '2019-07-01 09:54:15');
INSERT INTO `access_log` VALUES (46014, '65.47.15619460589720393', 22, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:54:19', 7, 0, '', '2019-07-01 09:54:19');
INSERT INTO `access_log` VALUES (46015, '65.54.15619460589750379', 22, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:54:19', 6, 0, '', '2019-07-01 09:54:19');
INSERT INTO `access_log` VALUES (46016, '65.45.15619460589780415', 22, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:54:19', 9, 0, '', '2019-07-01 09:54:19');
INSERT INTO `access_log` VALUES (46017, '65.46.15619460654180477', 22, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:54:25', 6, 0, '', '2019-07-01 09:54:25');
INSERT INTO `access_log` VALUES (46018, '65.53.15619460654500425', 22, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:54:25', 6, 0, '', '2019-07-01 09:54:25');
INSERT INTO `access_log` VALUES (46019, '65.3607.15619460654512207', 22, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.94.69.178', '2019-07-01 09:54:25', 9, 0, '', '2019-07-01 09:54:25');
INSERT INTO `access_log` VALUES (46020, '59.80.15619478283109087', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.24.229', '2019-07-01 10:23:48', 10, 0, '', '2019-07-01 10:23:48');
INSERT INTO `access_log` VALUES (46021, '59.76.15619478283489093', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.24.229', '2019-07-01 10:23:48', 13, 2001001000, '服务端发生异常', '2019-07-01 10:23:48');
INSERT INTO `access_log` VALUES (46022, '64.76.15619478375329169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.24.229', '2019-07-01 10:23:58', 11, 0, '', '2019-07-01 10:23:58');
INSERT INTO `access_log` VALUES (46023, '64.80.15619478378929181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.24.229', '2019-07-01 10:23:58', 3, 0, '', '2019-07-01 10:23:58');
INSERT INTO `access_log` VALUES (46024, '64.80.15619478378929181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.24.229', '2019-07-01 10:23:58', 3, 0, '', '2019-07-01 10:23:59');
INSERT INTO `access_log` VALUES (46025, '64.84.15619478395679171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.24.229', '2019-07-01 10:24:00', 2, 0, '', '2019-07-01 10:24:00');
INSERT INTO `access_log` VALUES (46026, '64.78.15619478400559181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.24.229', '2019-07-01 10:24:00', 2, 0, '', '2019-07-01 10:24:00');
INSERT INTO `access_log` VALUES (46027, '64.84.15619478395679171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.24.229', '2019-07-01 10:24:00', 2, 0, '', '2019-07-01 10:24:01');
INSERT INTO `access_log` VALUES (46028, '59.73.15619478515459105', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.24.229', '2019-07-01 10:24:12', 4, 0, '', '2019-07-01 10:24:12');
INSERT INTO `access_log` VALUES (46029, '59.79.15619478515479105', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.24.229', '2019-07-01 10:24:12', 32, 2001001000, '服务端发生异常', '2019-07-01 10:24:12');
INSERT INTO `access_log` VALUES (46030, '65.3607.15619480249232235', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-01 10:27:05', 0, 1002001015, '账号未登陆', '2019-07-01 10:27:05');
INSERT INTO `access_log` VALUES (46031, '65.49.15619480249230455', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-01 10:27:05', 0, 1002001015, '账号未登陆', '2019-07-01 10:27:05');
INSERT INTO `access_log` VALUES (46032, '65.46.15619480249320505', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-01 10:27:05', 0, 1002001015, '账号未登陆', '2019-07-01 10:27:05');
INSERT INTO `access_log` VALUES (46033, '65.51.15619480306290487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanmayudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-01 10:27:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 5-16 位', '2019-07-01 10:27:11');
INSERT INTO `access_log` VALUES (46034, '65.52.15619480368140469', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-01 10:27:17', 65, 0, '', '2019-07-01 10:27:17');
INSERT INTO `access_log` VALUES (46035, '65.50.15619480370840463', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-01 10:27:17', 8, 0, '', '2019-07-01 10:27:17');
INSERT INTO `access_log` VALUES (46036, '65.54.15619480370920409', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-01 10:27:17', 9, 2001001000, '服务端发生异常', '2019-07-01 10:27:17');
INSERT INTO `access_log` VALUES (46037, '65.47.15619480370970423', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-01 10:27:17', 8, 0, '', '2019-07-01 10:27:17');
INSERT INTO `access_log` VALUES (46038, '65.3607.15619480473682237', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-01 10:27:27', 10, 0, '', '2019-07-01 10:27:27');
INSERT INTO `access_log` VALUES (46039, '65.49.15619480473720457', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-01 10:27:27', 10, 2001001000, '服务端发生异常', '2019-07-01 10:27:27');
INSERT INTO `access_log` VALUES (46040, '65.46.15619480473750507', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-01 10:27:27', 8, 0, '', '2019-07-01 10:27:27');
INSERT INTO `access_log` VALUES (46041, '64.84.15619484101179179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '120.204.17.71', '2019-07-01 10:33:30', 2, 0, '', '2019-07-01 10:33:30');
INSERT INTO `access_log` VALUES (46042, '59.75.15619485566619117', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '183.192.164.214', '2019-07-01 10:35:57', 3, 0, '', '2019-07-01 10:35:57');
INSERT INTO `access_log` VALUES (46043, '64.78.15619485625989191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '183.192.164.71', '2019-07-01 10:36:03', 2, 0, '', '2019-07-01 10:36:03');
INSERT INTO `access_log` VALUES (46044, '64.81.15619485737509185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '183.192.164.85', '2019-07-01 10:36:14', 2, 0, '', '2019-07-01 10:36:14');
INSERT INTO `access_log` VALUES (46045, '65.51.15619500207380515', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.40.35.28', '2019-07-01 11:00:21', 0, 1002001015, '账号未登陆', '2019-07-01 11:00:21');
INSERT INTO `access_log` VALUES (46046, '65.52.15619500207380497', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.40.35.28', '2019-07-01 11:00:21', 0, 1002001015, '账号未登陆', '2019-07-01 11:00:21');
INSERT INTO `access_log` VALUES (46047, '65.54.15619500207400437', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.40.35.28', '2019-07-01 11:00:21', 0, 1002001015, '账号未登陆', '2019-07-01 11:00:21');
INSERT INTO `access_log` VALUES (46048, '65.3607.15619500628432265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.40.35.28', '2019-07-01 11:01:03', 99, 0, '', '2019-07-01 11:01:03');
INSERT INTO `access_log` VALUES (46049, '65.46.15619500632340535', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.40.35.28', '2019-07-01 11:01:03', 11, 0, '', '2019-07-01 11:01:03');
INSERT INTO `access_log` VALUES (46050, '65.53.15619500632440483', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.40.35.28', '2019-07-01 11:01:03', 11, 0, '', '2019-07-01 11:01:03');
INSERT INTO `access_log` VALUES (46051, '65.49.15619500632440485', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.40.35.28', '2019-07-01 11:01:03', 11, 2001001000, '服务端发生异常', '2019-07-01 11:01:03');
INSERT INTO `access_log` VALUES (46052, '65.49.15619515421870505', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '39.155.240.49', '2019-07-01 11:25:42', 1, 1002001015, '账号未登陆', '2019-07-01 11:25:42');
INSERT INTO `access_log` VALUES (46053, '65.52.15619515421870519', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '39.155.240.49', '2019-07-01 11:25:42', 1, 1002001015, '账号未登陆', '2019-07-01 11:25:42');
INSERT INTO `access_log` VALUES (46054, '65.51.15619515421900537', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '39.155.240.49', '2019-07-01 11:25:42', 0, 1002001015, '账号未登陆', '2019-07-01 11:25:42');
INSERT INTO `access_log` VALUES (46055, '65.54.15619515440240459', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '39.155.240.49', '2019-07-01 11:25:44', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 11:25:44');
INSERT INTO `access_log` VALUES (46056, '65.47.15619515648490473', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma &password=yudaoyuanma &type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '39.155.240.49', '2019-07-01 11:26:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号格式为数字以及字母', '2019-07-01 11:26:05');
INSERT INTO `access_log` VALUES (46057, '65.3607.15619515767892287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '39.155.240.49', '2019-07-01 11:26:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 11:26:17');
INSERT INTO `access_log` VALUES (46058, '65.46.15619515856310557', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma &password=yudaoyuanma &type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '39.155.240.49', '2019-07-01 11:26:26', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号格式为数字以及字母', '2019-07-01 11:26:26');
INSERT INTO `access_log` VALUES (46059, '59.77.15619541321509173', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.157.36.134', '2019-07-01 12:08:52', 19, 0, '', '2019-07-01 12:08:52');
INSERT INTO `access_log` VALUES (46060, '59.71.15619541321509185', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.157.36.134', '2019-07-01 12:08:52', 24, 2001001000, '服务端发生异常', '2019-07-01 12:08:52');
INSERT INTO `access_log` VALUES (46061, '59.72.15619541439709185', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.157.36.134', '2019-07-01 12:09:04', 4, 0, '', '2019-07-01 12:09:04');
INSERT INTO `access_log` VALUES (46062, '59.78.15619541439709179', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.157.36.134', '2019-07-01 12:09:04', 18, 2001001000, '服务端发生异常', '2019-07-01 12:09:04');
INSERT INTO `access_log` VALUES (46063, '64.79.15619541513219273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.157.36.134', '2019-07-01 12:09:11', 13, 0, '', '2019-07-01 12:09:11');
INSERT INTO `access_log` VALUES (46064, '64.77.15619541514249255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.157.36.134', '2019-07-01 12:09:11', 4, 0, '', '2019-07-01 12:09:11');
INSERT INTO `access_log` VALUES (46065, '64.76.15619541529559255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.157.36.134', '2019-07-01 12:09:13', 1, 0, '', '2019-07-01 12:09:13');
INSERT INTO `access_log` VALUES (46066, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.157.36.134', '2019-07-01 12:09:13', 7, 0, '', '2019-07-01 12:09:13');
INSERT INTO `access_log` VALUES (46067, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.157.36.134', '2019-07-01 12:09:16', 5, 0, '', '2019-07-01 12:09:16');
INSERT INTO `access_log` VALUES (46068, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.157.36.134', '2019-07-01 12:09:17', 6, 0, '', '2019-07-01 12:09:17');
INSERT INTO `access_log` VALUES (46069, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.157.36.134', '2019-07-01 12:09:18', 6, 0, '', '2019-07-01 12:09:18');
INSERT INTO `access_log` VALUES (46070, '64.80.15619541585039267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.157.36.134', '2019-07-01 12:09:19', 2, 0, '', '2019-07-01 12:09:19');
INSERT INTO `access_log` VALUES (46071, '64.84.15619541586239257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '183.157.36.134', '2019-07-01 12:09:19', 2, 0, '', '2019-07-01 12:09:19');
INSERT INTO `access_log` VALUES (46072, '65.50.15619541808240549', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.157.36.134', '2019-07-01 12:09:41', 0, 1002001015, '账号未登陆', '2019-07-01 12:09:41');
INSERT INTO `access_log` VALUES (46073, '65.54.15619541808240495', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.157.36.134', '2019-07-01 12:09:41', 0, 1002001015, '账号未登陆', '2019-07-01 12:09:41');
INSERT INTO `access_log` VALUES (46074, '65.47.15619541808250509', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.157.36.134', '2019-07-01 12:09:41', 1, 1002001015, '账号未登陆', '2019-07-01 12:09:41');
INSERT INTO `access_log` VALUES (46075, '65.3607.15619541985972323', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.157.36.134', '2019-07-01 12:09:59', 79, 0, '', '2019-07-01 12:09:59');
INSERT INTO `access_log` VALUES (46076, '65.53.15619541989600541', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.157.36.134', '2019-07-01 12:09:59', 11, 0, '', '2019-07-01 12:09:59');
INSERT INTO `access_log` VALUES (46077, '65.46.15619541989690593', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.157.36.134', '2019-07-01 12:09:59', 9, 2001001000, '服务端发生异常', '2019-07-01 12:09:59');
INSERT INTO `access_log` VALUES (46078, '65.52.15619541989780557', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.157.36.134', '2019-07-01 12:09:59', 9, 0, '', '2019-07-01 12:09:59');
INSERT INTO `access_log` VALUES (46079, '65.45.15619560854300557', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '115.192.121.142', '2019-07-01 12:41:25', 1, 1002001015, '账号未登陆', '2019-07-01 12:41:25');
INSERT INTO `access_log` VALUES (46080, '65.3607.15619560854292349', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '115.192.121.142', '2019-07-01 12:41:25', 1, 1002001015, '账号未登陆', '2019-07-01 12:41:25');
INSERT INTO `access_log` VALUES (46081, '65.54.15619560854290523', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '115.192.121.142', '2019-07-01 12:41:25', 1, 1002001015, '账号未登陆', '2019-07-01 12:41:25');
INSERT INTO `access_log` VALUES (46082, '65.53.15619560871660569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '115.192.121.142', '2019-07-01 12:41:27', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 12:41:27');
INSERT INTO `access_log` VALUES (46083, '59.74.15619562527649215', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.192.121.142', '2019-07-01 12:44:13', 18, 2001001000, '服务端发生异常', '2019-07-01 12:44:13');
INSERT INTO `access_log` VALUES (46084, '59.76.15619562527649207', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.192.121.142', '2019-07-01 12:44:13', 37, 0, '', '2019-07-01 12:44:13');
INSERT INTO `access_log` VALUES (46085, '59.76.15619596903949253', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '123.157.153.130', '2019-07-01 13:41:30', 12, 2001001000, '服务端发生异常', '2019-07-01 13:41:30');
INSERT INTO `access_log` VALUES (46086, '59.75.15619596914169267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '123.157.153.130', '2019-07-01 13:41:31', 9, 0, '', '2019-07-01 13:41:31');
INSERT INTO `access_log` VALUES (46087, '66.57.15619626069387463', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.1.73.64', '2019-07-01 14:30:07', 26, 0, '', '2019-07-01 14:30:07');
INSERT INTO `access_log` VALUES (46088, '65.53.15619639992180675', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.113.63.58', '2019-07-01 14:53:19', 0, 1002001015, '账号未登陆', '2019-07-01 14:53:19');
INSERT INTO `access_log` VALUES (46089, '65.45.15619639992180663', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.113.63.58', '2019-07-01 14:53:19', 0, 1002001015, '账号未登陆', '2019-07-01 14:53:19');
INSERT INTO `access_log` VALUES (46090, '65.52.15619639992190689', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.113.63.58', '2019-07-01 14:53:19', 0, 1002001015, '账号未登陆', '2019-07-01 14:53:19');
INSERT INTO `access_log` VALUES (46091, '65.46.15619640026890725', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.113.63.58', '2019-07-01 14:53:23', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 14:53:23');
INSERT INTO `access_log` VALUES (46092, '65.49.15619640116300675', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.113.63.58', '2019-07-01 14:53:32', 73, 0, '', '2019-07-01 14:53:32');
INSERT INTO `access_log` VALUES (46093, '65.47.15619640121790643', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.113.63.58', '2019-07-01 14:53:32', 14, 0, '', '2019-07-01 14:53:32');
INSERT INTO `access_log` VALUES (46094, '65.50.15619640121790685', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.113.63.58', '2019-07-01 14:53:32', 15, 2001001000, '服务端发生异常', '2019-07-01 14:53:32');
INSERT INTO `access_log` VALUES (46095, '65.54.15619640121900631', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.113.63.58', '2019-07-01 14:53:32', 9, 0, '', '2019-07-01 14:53:32');
INSERT INTO `access_log` VALUES (46096, '65.49.15619640900800677', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-07-01 14:54:50', 4, 1002001012, '访问令牌已过期', '2019-07-01 14:54:50');
INSERT INTO `access_log` VALUES (46097, '65.54.15619640900910633', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-07-01 14:54:50', 3, 1002001012, '访问令牌已过期', '2019-07-01 14:54:50');
INSERT INTO `access_log` VALUES (46098, '65.51.15619640900450711', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.254.252.189', '2019-07-01 14:54:50', 51, 1002001012, '访问令牌已过期', '2019-07-01 14:54:50');
INSERT INTO `access_log` VALUES (46099, '65.45.15619643619940671', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-07-01 14:59:22', 10, 1002001012, '访问令牌已过期', '2019-07-01 14:59:22');
INSERT INTO `access_log` VALUES (46100, '65.52.15619643620000697', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-07-01 14:59:22', 5, 1002001012, '访问令牌已过期', '2019-07-01 14:59:22');
INSERT INTO `access_log` VALUES (46101, '65.53.15619643619900683', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-07-01 14:59:22', 14, 1002001012, '访问令牌已过期', '2019-07-01 14:59:22');
INSERT INTO `access_log` VALUES (46102, '65.47.15619643680160649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-07-01 14:59:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 14:59:28');
INSERT INTO `access_log` VALUES (46103, '65.3607.15619643716162463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-07-01 14:59:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 14:59:32');
INSERT INTO `access_log` VALUES (46104, '65.52.15619643767120699', 0, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'roleIds=&id=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.244.114.2', '2019-07-01 14:59:37', 1, 1002001015, '账号未登陆', '2019-07-01 14:59:37');
INSERT INTO `access_log` VALUES (46105, '65.45.15619643777950673', 0, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'roleIds=&id=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.244.114.2', '2019-07-01 14:59:38', 1, 1002001015, '账号未登陆', '2019-07-01 14:59:38');
INSERT INTO `access_log` VALUES (46106, '65.46.15619643781050735', 0, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'roleIds=&id=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.244.114.2', '2019-07-01 14:59:38', 1, 1002001015, '账号未登陆', '2019-07-01 14:59:38');
INSERT INTO `access_log` VALUES (46107, '65.49.15619643786750683', 0, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'roleIds=&id=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.244.114.2', '2019-07-01 14:59:39', 0, 1002001015, '账号未登陆', '2019-07-01 14:59:39');
INSERT INTO `access_log` VALUES (46108, '65.54.15619643831150639', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-07-01 14:59:43', 139, 0, '', '2019-07-01 14:59:43');
INSERT INTO `access_log` VALUES (46109, '65.50.15619643835920695', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-07-01 14:59:44', 10, 0, '', '2019-07-01 14:59:44');
INSERT INTO `access_log` VALUES (46110, '65.3607.15619643836012465', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-07-01 14:59:44', 9, 0, '', '2019-07-01 14:59:44');
INSERT INTO `access_log` VALUES (46111, '65.47.15619643836000651', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '221.178.135.138', '2019-07-01 14:59:44', 11, 2001001000, '服务端发生异常', '2019-07-01 14:59:44');
INSERT INTO `access_log` VALUES (46112, '65.52.15619646955720705', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:04:56', 0, 1002001015, '账号未登陆', '2019-07-01 15:04:56');
INSERT INTO `access_log` VALUES (46113, '65.45.15619646955750679', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:04:56', 0, 1002001015, '账号未登陆', '2019-07-01 15:04:56');
INSERT INTO `access_log` VALUES (46114, '65.46.15619646955750741', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:04:56', 0, 1002001015, '账号未登陆', '2019-07-01 15:04:56');
INSERT INTO `access_log` VALUES (46115, '59.72.15619646985089327', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:04:59', 16, 0, '', '2019-07-01 15:04:59');
INSERT INTO `access_log` VALUES (46116, '59.78.15619646985089321', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:04:59', 20, 2001001000, '服务端发生异常', '2019-07-01 15:04:59');
INSERT INTO `access_log` VALUES (46117, '65.49.15619647017490689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 15:05:02');
INSERT INTO `access_log` VALUES (46118, '65.54.15619647089690645', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:09', 74, 0, '', '2019-07-01 15:05:09');
INSERT INTO `access_log` VALUES (46119, '65.50.15619647095260701', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:10', 10, 0, '', '2019-07-01 15:05:10');
INSERT INTO `access_log` VALUES (46120, '65.47.15619647095270657', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:10', 10, 2001001000, '服务端发生异常', '2019-07-01 15:05:10');
INSERT INTO `access_log` VALUES (46121, '65.3607.15619647095252471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:10', 11, 0, '', '2019-07-01 15:05:10');
INSERT INTO `access_log` VALUES (46122, '64.79.15619647245619415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:25', 10, 0, '', '2019-07-01 15:05:25');
INSERT INTO `access_log` VALUES (46123, '64.77.15619647247589397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:25', 3, 0, '', '2019-07-01 15:05:25');
INSERT INTO `access_log` VALUES (46124, '64.76.15619647262149397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:26', 2, 0, '', '2019-07-01 15:05:26');
INSERT INTO `access_log` VALUES (46125, '64.80.15619647268479409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:27', 2, 0, '', '2019-07-01 15:05:27');
INSERT INTO `access_log` VALUES (46126, '59.75.15619647285219335', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:29', 3, 0, '', '2019-07-01 15:05:29');
INSERT INTO `access_log` VALUES (46127, '59.76.15619647285219321', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:29', 14, 2001001000, '服务端发生异常', '2019-07-01 15:05:29');
INSERT INTO `access_log` VALUES (46128, '64.78.15619647355329409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:36', 2, 0, '', '2019-07-01 15:05:36');
INSERT INTO `access_log` VALUES (46129, '64.82.15619647358809415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:36', 2, 0, '', '2019-07-01 15:05:36');
INSERT INTO `access_log` VALUES (46130, '64.81.15619647394219403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:39', 1, 0, '', '2019-07-01 15:05:39');
INSERT INTO `access_log` VALUES (46131, '64.85.15619647395669423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.72.51.152', '2019-07-01 15:05:40', 1, 0, '', '2019-07-01 15:05:40');
INSERT INTO `access_log` VALUES (46132, '59.74.15619663275359351', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.141.64.13', '2019-07-01 15:32:08', 3, 0, '', '2019-07-01 15:32:08');
INSERT INTO `access_log` VALUES (46133, '59.75.15619663275409357', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.141.64.13', '2019-07-01 15:32:08', 10, 2001001000, '服务端发生异常', '2019-07-01 15:32:08');
INSERT INTO `access_log` VALUES (46134, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:32:28', 7, 0, '', '2019-07-01 15:32:28');
INSERT INTO `access_log` VALUES (46135, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:32:28', 3, 0, '', '2019-07-01 15:32:28');
INSERT INTO `access_log` VALUES (46136, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:32:28', 11, 0, '', '2019-07-01 15:32:28');
INSERT INTO `access_log` VALUES (46137, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:32:28', 9, 0, '', '2019-07-01 15:32:28');
INSERT INTO `access_log` VALUES (46138, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:32:49', 6, 0, '', '2019-07-01 15:32:49');
INSERT INTO `access_log` VALUES (46139, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=desc', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:32:51', 8, 0, '', '2019-07-01 15:32:51');
INSERT INTO `access_log` VALUES (46140, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=asc', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:32:55', 7, 0, '', '2019-07-01 15:32:55');
INSERT INTO `access_log` VALUES (46141, '59.72.15619664029349351', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:33:23', 4, 0, '', '2019-07-01 15:33:23');
INSERT INTO `access_log` VALUES (46142, '59.78.15619664029349345', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:33:23', 42, 2001001000, '服务端发生异常', '2019-07-01 15:33:23');
INSERT INTO `access_log` VALUES (46143, '64.79.15619664054059439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:33:25', 2, 0, '', '2019-07-01 15:33:25');
INSERT INTO `access_log` VALUES (46144, '64.77.15619664055379421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:33:26', 2, 0, '', '2019-07-01 15:33:26');
INSERT INTO `access_log` VALUES (46145, '64.76.15619664078179421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:33:28', 2, 0, '', '2019-07-01 15:33:28');
INSERT INTO `access_log` VALUES (46146, '64.80.15619664093539433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:33:29', 2, 0, '', '2019-07-01 15:33:29');
INSERT INTO `access_log` VALUES (46147, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=b&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:33:36', 6, 0, '', '2019-07-01 15:33:36');
INSERT INTO `access_log` VALUES (46148, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=b', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:33:37', 5, 0, '', '2019-07-01 15:33:37');
INSERT INTO `access_log` VALUES (46149, '64.78.15619664191599433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:33:39', 2, 0, '', '2019-07-01 15:33:39');
INSERT INTO `access_log` VALUES (46150, '64.82.15619664192699439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:33:39', 1, 0, '', '2019-07-01 15:33:39');
INSERT INTO `access_log` VALUES (46151, '59.74.15619664275969353', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-01 15:33:48', 2, 0, '', '2019-07-01 15:33:48');
INSERT INTO `access_log` VALUES (46152, '59.75.15619664275979359', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-01 15:33:48', 14, 2001001000, '服务端发生异常', '2019-07-01 15:33:48');
INSERT INTO `access_log` VALUES (46153, '64.81.15619664299249427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:33:50', 2, 0, '', '2019-07-01 15:33:50');
INSERT INTO `access_log` VALUES (46154, '64.85.15619664300489447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.141.64.13', '2019-07-01 15:33:50', 2, 0, '', '2019-07-01 15:33:50');
INSERT INTO `access_log` VALUES (46155, '64.79.15619664332169441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-01 15:33:53', 2, 0, '', '2019-07-01 15:33:53');
INSERT INTO `access_log` VALUES (46156, '64.77.15619664333249423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-01 15:33:53', 2, 0, '', '2019-07-01 15:33:53');
INSERT INTO `access_log` VALUES (46157, '64.76.15619664342499423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-01 15:33:54', 2, 0, '', '2019-07-01 15:33:54');
INSERT INTO `access_log` VALUES (46158, '64.80.15619664348369435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-01 15:33:55', 1, 0, '', '2019-07-01 15:33:55');
INSERT INTO `access_log` VALUES (46159, '59.80.15619665297279341', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.131.39.121', '2019-07-01 15:35:30', 2, 0, '', '2019-07-01 15:35:30');
INSERT INTO `access_log` VALUES (46160, '59.74.15619665297279355', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.131.39.121', '2019-07-01 15:35:30', 12, 2001001000, '服务端发生异常', '2019-07-01 15:35:30');
INSERT INTO `access_log` VALUES (46161, '64.79.15619665341829443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.131.39.121', '2019-07-01 15:35:34', 2, 0, '', '2019-07-01 15:35:34');
INSERT INTO `access_log` VALUES (46162, '64.77.15619665343069425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.131.39.121', '2019-07-01 15:35:34', 2, 0, '', '2019-07-01 15:35:34');
INSERT INTO `access_log` VALUES (46163, '64.76.15619665352579425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.131.39.121', '2019-07-01 15:35:35', 1, 0, '', '2019-07-01 15:35:35');
INSERT INTO `access_log` VALUES (46164, '64.84.15619665357449427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.131.39.121', '2019-07-01 15:35:36', 2, 0, '', '2019-07-01 15:35:36');
INSERT INTO `access_log` VALUES (46165, '64.78.15619665362179437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.131.39.121', '2019-07-01 15:35:36', 3, 0, '', '2019-07-01 15:35:36');
INSERT INTO `access_log` VALUES (46166, '64.82.15619665365609443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.131.39.121', '2019-07-01 15:35:37', 2, 0, '', '2019-07-01 15:35:37');
INSERT INTO `access_log` VALUES (46167, '64.81.15619665368869431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.131.39.121', '2019-07-01 15:35:37', 2, 0, '', '2019-07-01 15:35:37');
INSERT INTO `access_log` VALUES (46168, '64.85.15619665371359451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.131.39.121', '2019-07-01 15:35:37', 2, 0, '', '2019-07-01 15:35:37');
INSERT INTO `access_log` VALUES (46169, '59.71.15619665842589355', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.149.10.42', '2019-07-01 15:36:24', 2, 0, '', '2019-07-01 15:36:24');
INSERT INTO `access_log` VALUES (46170, '59.77.15619665842799343', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.149.10.42', '2019-07-01 15:36:24', 14, 2001001000, '服务端发生异常', '2019-07-01 15:36:24');
INSERT INTO `access_log` VALUES (46171, '59.73.15619666808049361', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.89.29.94', '2019-07-01 15:38:01', 13, 2001001000, '服务端发生异常', '2019-07-01 15:38:01');
INSERT INTO `access_log` VALUES (46172, '64.77.15619670188939433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.129.6.147', '2019-07-01 15:43:39', 2, 0, '', '2019-07-01 15:43:39');
INSERT INTO `access_log` VALUES (46173, '59.76.15619670941009355', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.207.186', '2019-07-01 15:44:54', 3, 0, '', '2019-07-01 15:44:54');
INSERT INTO `access_log` VALUES (46174, '64.77.15619671526039435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.89.239.232', '2019-07-01 15:45:53', 3, 0, '', '2019-07-01 15:45:53');
INSERT INTO `access_log` VALUES (46175, '65.54.15619683727050695', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.176.4.219', '2019-07-01 16:06:13', 4, 1002001012, '访问令牌已过期', '2019-07-01 16:06:13');
INSERT INTO `access_log` VALUES (46176, '65.47.15619683727050709', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.176.4.219', '2019-07-01 16:06:13', 4, 1002001012, '访问令牌已过期', '2019-07-01 16:06:13');
INSERT INTO `access_log` VALUES (46177, '65.3607.15619683727052521', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.176.4.219', '2019-07-01 16:06:13', 5, 1002001012, '访问令牌已过期', '2019-07-01 16:06:13');
INSERT INTO `access_log` VALUES (46178, '65.52.15619683780410757', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.176.4.219', '2019-07-01 16:06:18', 74, 0, '', '2019-07-01 16:06:18');
INSERT INTO `access_log` VALUES (46179, '65.45.15619683782900733', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.176.4.219', '2019-07-01 16:06:18', 9, 0, '', '2019-07-01 16:06:18');
INSERT INTO `access_log` VALUES (46180, '65.53.15619683782880743', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.176.4.219', '2019-07-01 16:06:18', 10, 0, '', '2019-07-01 16:06:18');
INSERT INTO `access_log` VALUES (46181, '65.46.15619683782890795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.176.4.219', '2019-07-01 16:06:18', 10, 2001001000, '服务端发生异常', '2019-07-01 16:06:18');
INSERT INTO `access_log` VALUES (46182, '59.72.15619689513819387', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.157.72.6', '2019-07-01 16:15:51', 11, 0, '', '2019-07-01 16:15:51');
INSERT INTO `access_log` VALUES (46183, '59.78.15619689513929381', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.157.72.6', '2019-07-01 16:15:51', 16, 2001001000, '服务端发生异常', '2019-07-01 16:15:51');
INSERT INTO `access_log` VALUES (46184, '59.71.15619690468849389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.108.210.47', '2019-07-01 16:17:27', 5, 0, '', '2019-07-01 16:17:27');
INSERT INTO `access_log` VALUES (46185, '59.77.15619690468849377', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.108.210.47', '2019-07-01 16:17:27', 14, 2001001000, '服务端发生异常', '2019-07-01 16:17:27');
INSERT INTO `access_log` VALUES (46186, '64.77.15619690970769461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '119.108.210.47', '2019-07-01 16:18:17', 11, 0, '', '2019-07-01 16:18:17');
INSERT INTO `access_log` VALUES (46187, '64.76.15619690977319461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '119.108.210.47', '2019-07-01 16:18:18', 3, 0, '', '2019-07-01 16:18:18');
INSERT INTO `access_log` VALUES (46188, '64.80.15619690999229473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '119.108.210.47', '2019-07-01 16:18:20', 2, 0, '', '2019-07-01 16:18:20');
INSERT INTO `access_log` VALUES (46189, '64.78.15619691007899473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '119.108.210.47', '2019-07-01 16:18:21', 2, 0, '', '2019-07-01 16:18:21');
INSERT INTO `access_log` VALUES (46190, '64.82.15619691030769479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '119.108.210.47', '2019-07-01 16:18:23', 2, 0, '', '2019-07-01 16:18:23');
INSERT INTO `access_log` VALUES (46191, '65.52.15619696460130775', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.213.99', '2019-07-01 16:27:26', 1, 1002001015, '账号未登陆', '2019-07-01 16:27:26');
INSERT INTO `access_log` VALUES (46192, '65.54.15619696460130713', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.213.99', '2019-07-01 16:27:26', 1, 1002001015, '账号未登陆', '2019-07-01 16:27:26');
INSERT INTO `access_log` VALUES (46193, '65.45.15619696460140751', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.213.99', '2019-07-01 16:27:26', 0, 1002001015, '账号未登陆', '2019-07-01 16:27:26');
INSERT INTO `access_log` VALUES (46194, '65.50.15619697114760771', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.213.99', '2019-07-01 16:28:31', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 16:28:31');
INSERT INTO `access_log` VALUES (46195, '65.3607.15619697145072541', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.213.99', '2019-07-01 16:28:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 16:28:35');
INSERT INTO `access_log` VALUES (46196, '65.45.15619697375140753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.213.99', '2019-07-01 16:28:58', 95, 0, '', '2019-07-01 16:28:58');
INSERT INTO `access_log` VALUES (46197, '65.52.15619697393360777', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.213.99', '2019-07-01 16:28:59', 9, 0, '', '2019-07-01 16:28:59');
INSERT INTO `access_log` VALUES (46198, '65.46.15619697393600815', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.213.99', '2019-07-01 16:28:59', 19, 2001001000, '服务端发生异常', '2019-07-01 16:28:59');
INSERT INTO `access_log` VALUES (46199, '65.53.15619697393790763', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.213.99', '2019-07-01 16:28:59', 10, 0, '', '2019-07-01 16:28:59');
INSERT INTO `access_log` VALUES (46200, '65.50.15619697491520773', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.213.99', '2019-07-01 16:29:09', 8, 0, '', '2019-07-01 16:29:09');
INSERT INTO `access_log` VALUES (46201, '65.49.15619697491520761', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.213.99', '2019-07-01 16:29:09', 11, 2001001000, '服务端发生异常', '2019-07-01 16:29:09');
INSERT INTO `access_log` VALUES (46202, '65.3607.15619697491972543', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.160.213.99', '2019-07-01 16:29:09', 9, 0, '', '2019-07-01 16:29:09');
INSERT INTO `access_log` VALUES (46203, '65.54.15619702209880723', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-01 16:37:01', 0, 1002001015, '账号未登陆', '2019-07-01 16:37:01');
INSERT INTO `access_log` VALUES (46204, '65.45.15619702210090761', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-01 16:37:01', 1, 1002001015, '账号未登陆', '2019-07-01 16:37:01');
INSERT INTO `access_log` VALUES (46205, '65.52.15619702210250785', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-01 16:37:01', 1, 1002001015, '账号未登陆', '2019-07-01 16:37:01');
INSERT INTO `access_log` VALUES (46206, '59.72.15619706900769411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-07-01 16:44:50', 3, 0, '', '2019-07-01 16:44:50');
INSERT INTO `access_log` VALUES (46207, '59.78.15619706900779405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-07-01 16:44:50', 13, 2001001000, '服务端发生异常', '2019-07-01 16:44:50');
INSERT INTO `access_log` VALUES (46208, '66.50.15619707205867565', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18512345678&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-07-01 16:45:21', 16, 1001003000, '验证码不存在', '2019-07-01 16:45:21');
INSERT INTO `access_log` VALUES (46209, '66.48.15619707335207585', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18512345678&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-07-01 16:45:34', 7, 1001003000, '验证码不存在', '2019-07-01 16:45:34');
INSERT INTO `access_log` VALUES (46210, '66.56.15619707614907581', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18512345678', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-07-01 16:46:01', 58, 0, '', '2019-07-01 16:46:02');
INSERT INTO `access_log` VALUES (46211, '66.52.15619707638337571', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18512345678&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-07-01 16:46:04', 184, 0, '', '2019-07-01 16:46:04');
INSERT INTO `access_log` VALUES (46212, '66.55.15619707652907557', 144, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-07-01 16:46:05', 6, 0, '', '2019-07-01 16:46:05');
INSERT INTO `access_log` VALUES (46213, '66.53.15619707706137567', 144, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.53.194', '2019-07-01 16:46:11', 6, 0, '', '2019-07-01 16:46:11');
INSERT INTO `access_log` VALUES (46214, '59.71.15619707781339413', 144, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:46:18', 7, 0, '', '2019-07-01 16:46:18');
INSERT INTO `access_log` VALUES (46215, '59.72.15619707781629413', 144, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:46:18', 18, 2001001000, '服务端发生异常', '2019-07-01 16:46:18');
INSERT INTO `access_log` VALUES (46216, '59.74.15619707970489415', 144, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:46:37', 5, 0, '', '2019-07-01 16:46:37');
INSERT INTO `access_log` VALUES (46217, '59.75.15619707970519421', 144, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:46:37', 16, 2001001000, '服务端发生异常', '2019-07-01 16:46:37');
INSERT INTO `access_log` VALUES (46218, '65.45.15619707977070769', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-01 16:46:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 16:46:38');
INSERT INTO `access_log` VALUES (46219, '65.53.15619708040830779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-01 16:46:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 16:46:44');
INSERT INTO `access_log` VALUES (46220, '65.51.15619708198810811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-01 16:47:00', 56, 0, '', '2019-07-01 16:47:00');
INSERT INTO `access_log` VALUES (46221, '65.49.15619708208300777', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-01 16:47:01', 128, 2001001000, '服务端发生异常', '2019-07-01 16:47:01');
INSERT INTO `access_log` VALUES (46222, '65.50.15619708208250789', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-01 16:47:01', 134, 0, '', '2019-07-01 16:47:01');
INSERT INTO `access_log` VALUES (46223, '65.3607.15619708208342559', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-01 16:47:01', 129, 0, '', '2019-07-01 16:47:01');
INSERT INTO `access_log` VALUES (46224, '64.76.15619708231179485', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:03', 8, 0, '', '2019-07-01 16:47:03');
INSERT INTO `access_log` VALUES (46225, '64.84.15619708232559487', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:03', 9, 0, '', '2019-07-01 16:47:03');
INSERT INTO `access_log` VALUES (46226, '64.81.15619708276349491', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:08', 6, 0, '', '2019-07-01 16:47:08');
INSERT INTO `access_log` VALUES (46227, '64.83.15619708290659487', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:09', 5, 0, '', '2019-07-01 16:47:09');
INSERT INTO `access_log` VALUES (46228, '64.79.15619708308869505', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:11', 5, 0, '', '2019-07-01 16:47:11');
INSERT INTO `access_log` VALUES (46229, '64.77.15619708319019487', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:12', 5, 0, '', '2019-07-01 16:47:12');
INSERT INTO `access_log` VALUES (46230, '64.76.15619708328379487', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:13', 4, 0, '', '2019-07-01 16:47:13');
INSERT INTO `access_log` VALUES (46231, '64.80.15619708336539499', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:14', 6, 0, '', '2019-07-01 16:47:14');
INSERT INTO `access_log` VALUES (46232, '64.84.15619708346549489', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:15', 6, 0, '', '2019-07-01 16:47:15');
INSERT INTO `access_log` VALUES (46233, '64.78.15619708357189499', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:16', 5, 0, '', '2019-07-01 16:47:16');
INSERT INTO `access_log` VALUES (46234, '64.82.15619708367339505', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:17', 7, 0, '', '2019-07-01 16:47:17');
INSERT INTO `access_log` VALUES (46235, '64.81.15619708375999493', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:18', 4, 0, '', '2019-07-01 16:47:18');
INSERT INTO `access_log` VALUES (46236, 'N/A', 144, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:18', 12, 0, '', '2019-07-01 16:47:18');
INSERT INTO `access_log` VALUES (46237, '64.85.15619708391889513', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:19', 5, 0, '', '2019-07-01 16:47:19');
INSERT INTO `access_log` VALUES (46238, '64.83.15619708392999489', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:19', 5, 0, '', '2019-07-01 16:47:19');
INSERT INTO `access_log` VALUES (46239, '64.77.15619708406439489', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:21', 4, 0, '', '2019-07-01 16:47:21');
INSERT INTO `access_log` VALUES (46240, 'N/A', 144, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:21', 12, 0, '', '2019-07-01 16:47:21');
INSERT INTO `access_log` VALUES (46241, '64.76.15619708422039489', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:22', 5, 0, '', '2019-07-01 16:47:22');
INSERT INTO `access_log` VALUES (46242, '64.80.15619708423299501', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:22', 4, 0, '', '2019-07-01 16:47:22');
INSERT INTO `access_log` VALUES (46243, '64.84.15619708435639491', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:24', 5, 0, '', '2019-07-01 16:47:24');
INSERT INTO `access_log` VALUES (46244, '64.78.15619708444299501', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:24', 5, 0, '', '2019-07-01 16:47:24');
INSERT INTO `access_log` VALUES (46245, '64.82.15619708455319507', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:26', 13, 0, '', '2019-07-01 16:47:26');
INSERT INTO `access_log` VALUES (46246, 'N/A', 144, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:26', 9, 0, '', '2019-07-01 16:47:26');
INSERT INTO `access_log` VALUES (46247, '64.85.15619708469709515', 144, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:27', 11, 0, '', '2019-07-01 16:47:27');
INSERT INTO `access_log` VALUES (46248, '66.55.15619708704367559', 144, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:50', 6, 0, '', '2019-07-01 16:47:50');
INSERT INTO `access_log` VALUES (46249, '64.77.15619708740379491', 144, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:54', 9, 0, '', '2019-07-01 16:47:54');
INSERT INTO `access_log` VALUES (46250, '64.76.15619708750879491', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:55', 5, 0, '', '2019-07-01 16:47:55');
INSERT INTO `access_log` VALUES (46251, 'N/A', 144, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:55', 10, 0, '', '2019-07-01 16:47:55');
INSERT INTO `access_log` VALUES (46252, '64.80.15619708757839503', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:56', 5, 0, '', '2019-07-01 16:47:56');
INSERT INTO `access_log` VALUES (46253, '64.84.15619708758939493', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:56', 4, 0, '', '2019-07-01 16:47:56');
INSERT INTO `access_log` VALUES (46254, '59.71.15619708775999415', 144, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:58', 5, 0, '', '2019-07-01 16:47:58');
INSERT INTO `access_log` VALUES (46255, '59.78.15619708776009409', 144, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:47:58', 13, 2001001000, '服务端发生异常', '2019-07-01 16:47:58');
INSERT INTO `access_log` VALUES (46256, '59.75.15619708871109423', 144, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:48:07', 5, 0, '', '2019-07-01 16:48:07');
INSERT INTO `access_log` VALUES (46257, '59.74.15619708871119417', 144, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:48:07', 13, 2001001000, '服务端发生异常', '2019-07-01 16:48:07');
INSERT INTO `access_log` VALUES (46258, '64.82.15619708907159509', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:48:11', 5, 0, '', '2019-07-01 16:48:11');
INSERT INTO `access_log` VALUES (46259, '64.81.15619708908389497', 144, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:48:11', 5, 0, '', '2019-07-01 16:48:11');
INSERT INTO `access_log` VALUES (46260, '66.50.15619708932677569', 144, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:48:13', 6, 0, '', '2019-07-01 16:48:13');
INSERT INTO `access_log` VALUES (46261, '66.49.15619708950037583', 144, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.127.53.194', '2019-07-01 16:48:15', 6, 0, '', '2019-07-01 16:48:15');
INSERT INTO `access_log` VALUES (46262, '59.72.15619718569319429', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:17', 2, 0, '', '2019-07-01 17:04:17');
INSERT INTO `access_log` VALUES (46263, '59.71.15619718569439429', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:17', 12, 2001001000, '服务端发生异常', '2019-07-01 17:04:17');
INSERT INTO `access_log` VALUES (46264, '64.80.15619718667659517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:27', 2, 0, '', '2019-07-01 17:04:27');
INSERT INTO `access_log` VALUES (46265, '64.84.15619718668839507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:27', 3, 0, '', '2019-07-01 17:04:27');
INSERT INTO `access_log` VALUES (46266, '64.78.15619718681059517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:28', 2, 0, '', '2019-07-01 17:04:28');
INSERT INTO `access_log` VALUES (46267, '64.82.15619718689339523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:29', 2, 0, '', '2019-07-01 17:04:29');
INSERT INTO `access_log` VALUES (46268, '64.81.15619718703419511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:30', 2, 0, '', '2019-07-01 17:04:30');
INSERT INTO `access_log` VALUES (46269, '64.85.15619718705929531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:31', 2, 0, '', '2019-07-01 17:04:31');
INSERT INTO `access_log` VALUES (46270, '64.79.15619718808359525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:41', 2, 0, '', '2019-07-01 17:04:41');
INSERT INTO `access_log` VALUES (46271, '64.77.15619718809579507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:41', 1, 0, '', '2019-07-01 17:04:41');
INSERT INTO `access_log` VALUES (46272, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=电脑&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:47', 6, 0, '', '2019-07-01 17:04:47');
INSERT INTO `access_log` VALUES (46273, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=电脑', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:47', 10, 0, '', '2019-07-01 17:04:47');
INSERT INTO `access_log` VALUES (46274, '64.76.15619718901439507', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:50', 7, 0, '', '2019-07-01 17:04:50');
INSERT INTO `access_log` VALUES (46275, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:53', 7, 0, '', '2019-07-01 17:04:53');
INSERT INTO `access_log` VALUES (46276, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:53', 13, 0, '', '2019-07-01 17:04:53');
INSERT INTO `access_log` VALUES (46277, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:55', 4, 0, '', '2019-07-01 17:04:55');
INSERT INTO `access_log` VALUES (46278, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:55', 9, 0, '', '2019-07-01 17:04:55');
INSERT INTO `access_log` VALUES (46279, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=僵尸&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:04:59', 5, 0, '', '2019-07-01 17:04:59');
INSERT INTO `access_log` VALUES (46280, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=僵尸', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:05:00', 8, 0, '', '2019-07-01 17:05:00');
INSERT INTO `access_log` VALUES (46281, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=jiangshi&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:05:08', 17, 0, '', '2019-07-01 17:05:08');
INSERT INTO `access_log` VALUES (46282, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=jiangshi', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:05:08', 15, 0, '', '2019-07-01 17:05:08');
INSERT INTO `access_log` VALUES (46283, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:05:16', 7, 0, '', '2019-07-01 17:05:16');
INSERT INTO `access_log` VALUES (46284, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:05:16', 10, 0, '', '2019-07-01 17:05:16');
INSERT INTO `access_log` VALUES (46285, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=系统&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:05:30', 7, 0, '', '2019-07-01 17:05:30');
INSERT INTO `access_log` VALUES (46286, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=系统', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:05:30', 10, 0, '', '2019-07-01 17:05:30');
INSERT INTO `access_log` VALUES (46287, '64.85.15619735677119555', 0, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=小王', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:32:48', 1, 1002001015, '账号未登陆', '2019-07-01 17:32:48');
INSERT INTO `access_log` VALUES (46288, '59.80.15619737767839441', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.51.181', '2019-07-01 17:36:17', 11, 0, '', '2019-07-01 17:36:17');
INSERT INTO `access_log` VALUES (46289, '59.75.15619737767849461', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.51.181', '2019-07-01 17:36:17', 15, 2001001000, '服务端发生异常', '2019-07-01 17:36:17');
INSERT INTO `access_log` VALUES (46290, '64.81.15619737797699539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.51.181', '2019-07-01 17:36:20', 12, 0, '', '2019-07-01 17:36:20');
INSERT INTO `access_log` VALUES (46291, '64.84.15619737798889537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.51.181', '2019-07-01 17:36:20', 3, 0, '', '2019-07-01 17:36:20');
INSERT INTO `access_log` VALUES (46292, '64.79.15619737811669553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.51.181', '2019-07-01 17:36:21', 2, 0, '', '2019-07-01 17:36:21');
INSERT INTO `access_log` VALUES (46293, '64.78.15619737819539545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.51.181', '2019-07-01 17:36:22', 2, 0, '', '2019-07-01 17:36:22');
INSERT INTO `access_log` VALUES (46294, '64.83.15619738052629537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.51.181', '2019-07-01 17:36:45', 2, 0, '', '2019-07-01 17:36:45');
INSERT INTO `access_log` VALUES (46295, '64.77.15619738060389533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.51.181', '2019-07-01 17:36:46', 2, 0, '', '2019-07-01 17:36:46');
INSERT INTO `access_log` VALUES (46296, '64.82.15619738063439553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.51.181', '2019-07-01 17:36:46', 1, 0, '', '2019-07-01 17:36:46');
INSERT INTO `access_log` VALUES (46297, '64.76.15619738068679533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.51.181', '2019-07-01 17:36:47', 2, 0, '', '2019-07-01 17:36:47');
INSERT INTO `access_log` VALUES (46298, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=7&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.51.181', '2019-07-01 17:36:48', 6, 0, '', '2019-07-01 17:36:48');
INSERT INTO `access_log` VALUES (46299, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=7', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.156.51.181', '2019-07-01 17:36:49', 5, 0, '', '2019-07-01 17:36:49');
INSERT INTO `access_log` VALUES (46300, '65.49.15619741595650821', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:42:40', 0, 1002001015, '账号未登陆', '2019-07-01 17:42:40');
INSERT INTO `access_log` VALUES (46301, '65.50.15619741595650833', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:42:40', 0, 1002001015, '账号未登陆', '2019-07-01 17:42:40');
INSERT INTO `access_log` VALUES (46302, '65.51.15619741595730859', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:42:40', 0, 1002001015, '账号未登陆', '2019-07-01 17:42:40');
INSERT INTO `access_log` VALUES (46303, '65.47.15619741612660791', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:42:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 17:42:41');
INSERT INTO `access_log` VALUES (46304, '65.54.15619741733740779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:42:53', 58, 0, '', '2019-07-01 17:42:53');
INSERT INTO `access_log` VALUES (46305, '65.45.15619741736760817', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:42:54', 10, 0, '', '2019-07-01 17:42:54');
INSERT INTO `access_log` VALUES (46306, '65.46.15619741736820879', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:42:54', 9, 0, '', '2019-07-01 17:42:54');
INSERT INTO `access_log` VALUES (46307, '65.53.15619741736780827', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:42:54', 13, 2001001000, '服务端发生异常', '2019-07-01 17:42:54');
INSERT INTO `access_log` VALUES (46308, '65.52.15619741876460841', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:43:08', 10, 0, '', '2019-07-01 17:43:08');
INSERT INTO `access_log` VALUES (46309, '65.49.15619741876480823', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:43:08', 10, 2001001000, '服务端发生异常', '2019-07-01 17:43:08');
INSERT INTO `access_log` VALUES (46310, '65.50.15619741876550835', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-01 17:43:08', 16, 0, '', '2019-07-01 17:43:08');
INSERT INTO `access_log` VALUES (46311, '59.79.15619747142429473', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:51:54', 3, 0, '', '2019-07-01 17:51:54');
INSERT INTO `access_log` VALUES (46312, '59.77.15619747142569457', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:51:54', 12, 2001001000, '服务端发生异常', '2019-07-01 17:51:54');
INSERT INTO `access_log` VALUES (46313, '64.84.15619747226129551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:52:03', 3, 0, '', '2019-07-01 17:52:03');
INSERT INTO `access_log` VALUES (46314, '64.80.15619747227329561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:52:03', 1, 0, '', '2019-07-01 17:52:03');
INSERT INTO `access_log` VALUES (46315, '64.78.15619747302279559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:52:10', 1, 0, '', '2019-07-01 17:52:10');
INSERT INTO `access_log` VALUES (46316, '64.85.15619747304579573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:52:10', 2, 0, '', '2019-07-01 17:52:10');
INSERT INTO `access_log` VALUES (46317, '59.72.15619747336169469', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:52:14', 3, 0, '', '2019-07-01 17:52:14');
INSERT INTO `access_log` VALUES (46318, '59.78.15619747336319463', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:52:14', 20, 2001001000, '服务端发生异常', '2019-07-01 17:52:14');
INSERT INTO `access_log` VALUES (46319, '65.47.15619747981850801', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:53:18', 0, 1002001015, '账号未登陆', '2019-07-01 17:53:18');
INSERT INTO `access_log` VALUES (46320, '65.54.15619747981930789', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:53:18', 0, 1002001015, '账号未登陆', '2019-07-01 17:53:18');
INSERT INTO `access_log` VALUES (46321, '65.45.15619747982120827', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:53:18', 1, 1002001015, '账号未登陆', '2019-07-01 17:53:18');
INSERT INTO `access_log` VALUES (46322, '65.3607.15619748206492617', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:53:41', 52, 0, '', '2019-07-01 17:53:41');
INSERT INTO `access_log` VALUES (46323, '65.52.15619748211320851', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:53:41', 8, 0, '', '2019-07-01 17:53:41');
INSERT INTO `access_log` VALUES (46324, '65.50.15619748211390845', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:53:41', 8, 0, '', '2019-07-01 17:53:41');
INSERT INTO `access_log` VALUES (46325, '65.49.15619748211390833', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:53:41', 9, 2001001000, '服务端发生异常', '2019-07-01 17:53:41');
INSERT INTO `access_log` VALUES (46326, '65.47.15619748508380803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:54:11', 82, 0, '', '2019-07-01 17:54:11');
INSERT INTO `access_log` VALUES (46327, '65.53.15619748511750839', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:54:11', 9, 0, '', '2019-07-01 17:54:11');
INSERT INTO `access_log` VALUES (46328, '65.45.15619748511750829', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:54:11', 11, 2001001000, '服务端发生异常', '2019-07-01 17:54:11');
INSERT INTO `access_log` VALUES (46329, '65.46.15619748511780891', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:54:11', 8, 0, '', '2019-07-01 17:54:11');
INSERT INTO `access_log` VALUES (46330, '59.72.15619751447389475', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:59:05', 3, 0, '', '2019-07-01 17:59:05');
INSERT INTO `access_log` VALUES (46331, '59.78.15619751447429469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:59:05', 12, 2001001000, '服务端发生异常', '2019-07-01 17:59:05');
INSERT INTO `access_log` VALUES (46332, '65.3607.15619751525252623', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:59:13', 1087, 0, '', '2019-07-01 17:59:14');
INSERT INTO `access_log` VALUES (46333, '65.52.15619751525440857', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:59:13', 1069, 0, '', '2019-07-01 17:59:14');
INSERT INTO `access_log` VALUES (46334, '65.50.15619751525440851', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.136.46.99', '2019-07-01 17:59:13', 1069, 2001001000, '服务端发生异常', '2019-07-01 17:59:14');
INSERT INTO `access_log` VALUES (46335, '59.76.15619768502279491', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.192.8', '2019-07-01 18:27:30', 3, 0, '', '2019-07-01 18:27:30');
INSERT INTO `access_log` VALUES (46336, '59.73.15619768502279503', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.192.8', '2019-07-01 18:27:30', 20, 2001001000, '服务端发生异常', '2019-07-01 18:27:30');
INSERT INTO `access_log` VALUES (46337, '65.50.15619773789960881', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/73.0.3683.68 Mobile/15E148 Safari/605.1', '106.121.64.136', '2019-07-01 18:36:19', 0, 1002001015, '账号未登陆', '2019-07-01 18:36:19');
INSERT INTO `access_log` VALUES (46338, '65.52.15619773790090887', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/73.0.3683.68 Mobile/15E148 Safari/605.1', '106.121.64.136', '2019-07-01 18:36:19', 1, 1002001015, '账号未登陆', '2019-07-01 18:36:19');
INSERT INTO `access_log` VALUES (46339, '65.49.15619773790090869', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/73.0.3683.68 Mobile/15E148 Safari/605.1', '106.121.64.136', '2019-07-01 18:36:19', 0, 1002001015, '账号未登陆', '2019-07-01 18:36:19');
INSERT INTO `access_log` VALUES (46340, '65.51.15619773812720907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/73.0.3683.68 Mobile/15E148 Safari/605.1', '106.121.64.136', '2019-07-01 18:36:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 18:36:21');
INSERT INTO `access_log` VALUES (46341, '65.54.15619773835280827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/73.0.3683.68 Mobile/15E148 Safari/605.1', '106.121.64.136', '2019-07-01 18:36:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 18:36:24');
INSERT INTO `access_log` VALUES (46342, '65.45.15619773849660865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/73.0.3683.68 Mobile/15E148 Safari/605.1', '106.121.64.136', '2019-07-01 18:36:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 18:36:25');
INSERT INTO `access_log` VALUES (46343, '59.75.15619773890739511', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/73.0.3683.68 Mobile/15E148 Safari/605.1', '106.121.64.136', '2019-07-01 18:36:29', 13, 2001001000, '服务端发生异常', '2019-07-01 18:36:29');
INSERT INTO `access_log` VALUES (46344, '59.74.15619773891039507', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/73.0.3683.68 Mobile/15E148 Safari/605.1', '106.121.64.136', '2019-07-01 18:36:29', 3, 0, '', '2019-07-01 18:36:29');
INSERT INTO `access_log` VALUES (46345, '66.55.15619774091857647', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=180853960055&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/73.0.3683.68 Mobile/15E148 Safari/605.1', '106.121.64.136', '2019-07-01 18:36:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-07-01 18:36:49');
INSERT INTO `access_log` VALUES (46346, '66.53.15619774134157657', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=180853960&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/73.0.3683.68 Mobile/15E148 Safari/605.1', '106.121.64.136', '2019-07-01 18:36:53', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-07-01 18:36:53');
INSERT INTO `access_log` VALUES (46347, '66.50.15619774229557657', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13775579730&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/73.0.3683.68 Mobile/15E148 Safari/605.1', '106.121.64.136', '2019-07-01 18:37:03', 17, 1001003000, '验证码不存在', '2019-07-01 18:37:03');
INSERT INTO `access_log` VALUES (46348, '66.49.15619774257957671', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13775579730', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/73.0.3683.68 Mobile/15E148 Safari/605.1', '106.121.64.136', '2019-07-01 18:37:06', 70, 0, '', '2019-07-01 18:37:06');
INSERT INTO `access_log` VALUES (46349, '66.51.15619774291267685', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13775579730&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) CriOS/73.0.3683.68 Mobile/15E148 Safari/605.1', '106.121.64.136', '2019-07-01 18:37:09', 826, 0, '', '2019-07-01 18:37:10');
INSERT INTO `access_log` VALUES (46350, '59.77.15619783590789509', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:52:39', 3, 0, '', '2019-07-01 18:52:39');
INSERT INTO `access_log` VALUES (46351, '59.76.15619783590789513', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:52:39', 13, 2001001000, '服务端发生异常', '2019-07-01 18:52:39');
INSERT INTO `access_log` VALUES (46352, '64.76.15619783664179595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:52:46', 10, 0, '', '2019-07-01 18:52:46');
INSERT INTO `access_log` VALUES (46353, '64.81.15619783666129603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:52:47', 3, 0, '', '2019-07-01 18:52:47');
INSERT INTO `access_log` VALUES (46354, '64.84.15619783681779601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:52:48', 2, 0, '', '2019-07-01 18:52:48');
INSERT INTO `access_log` VALUES (46355, '64.80.15619783690829611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:52:49', 3, 0, '', '2019-07-01 18:52:49');
INSERT INTO `access_log` VALUES (46356, '64.79.15619783701879617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:52:50', 1, 0, '', '2019-07-01 18:52:50');
INSERT INTO `access_log` VALUES (46357, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:52:50', 6, 0, '', '2019-07-01 18:52:50');
INSERT INTO `access_log` VALUES (46358, '64.85.15619783740029623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:52:54', 2, 0, '', '2019-07-01 18:52:54');
INSERT INTO `access_log` VALUES (46359, '64.83.15619783742029601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:52:54', 2, 0, '', '2019-07-01 18:52:54');
INSERT INTO `access_log` VALUES (46360, '64.77.15619783758279597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:52:56', 2, 0, '', '2019-07-01 18:52:56');
INSERT INTO `access_log` VALUES (46361, '64.82.15619783765779617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:52:57', 1, 0, '', '2019-07-01 18:52:57');
INSERT INTO `access_log` VALUES (46362, '64.76.15619783782479597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:52:58', 9, 0, '', '2019-07-01 18:52:58');
INSERT INTO `access_log` VALUES (46363, '64.81.15619783807729605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:01', 2, 0, '', '2019-07-01 18:53:01');
INSERT INTO `access_log` VALUES (46364, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:01', 6, 0, '', '2019-07-01 18:53:01');
INSERT INTO `access_log` VALUES (46365, '64.84.15619783835879603', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:04', 7, 0, '', '2019-07-01 18:53:04');
INSERT INTO `access_log` VALUES (46366, '64.80.15619783841529613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:04', 2, 0, '', '2019-07-01 18:53:04');
INSERT INTO `access_log` VALUES (46367, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:04', 5, 0, '', '2019-07-01 18:53:04');
INSERT INTO `access_log` VALUES (46368, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:05', 5, 0, '', '2019-07-01 18:53:05');
INSERT INTO `access_log` VALUES (46369, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:06', 5, 0, '', '2019-07-01 18:53:06');
INSERT INTO `access_log` VALUES (46370, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:07', 5, 0, '', '2019-07-01 18:53:07');
INSERT INTO `access_log` VALUES (46371, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:08', 5, 0, '', '2019-07-01 18:53:08');
INSERT INTO `access_log` VALUES (46372, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:08', 6, 0, '', '2019-07-01 18:53:08');
INSERT INTO `access_log` VALUES (46373, '64.78.15619783895429611', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:10', 5, 0, '', '2019-07-01 18:53:10');
INSERT INTO `access_log` VALUES (46374, '64.83.15619784031129603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:23', 2, 0, '', '2019-07-01 18:53:23');
INSERT INTO `access_log` VALUES (46375, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:23', 5, 0, '', '2019-07-01 18:53:23');
INSERT INTO `access_log` VALUES (46376, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:24', 5, 0, '', '2019-07-01 18:53:24');
INSERT INTO `access_log` VALUES (46377, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:25', 5, 0, '', '2019-07-01 18:53:25');
INSERT INTO `access_log` VALUES (46378, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:26', 6, 0, '', '2019-07-01 18:53:26');
INSERT INTO `access_log` VALUES (46379, '64.77.15619784062929599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:26', 2, 0, '', '2019-07-01 18:53:26');
INSERT INTO `access_log` VALUES (46380, '64.82.15619784065279619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:27', 2, 0, '', '2019-07-01 18:53:27');
INSERT INTO `access_log` VALUES (46381, '64.76.15619784078179599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:28', 1, 0, '', '2019-07-01 18:53:28');
INSERT INTO `access_log` VALUES (46382, '64.81.15619784085229607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:29', 2, 0, '', '2019-07-01 18:53:29');
INSERT INTO `access_log` VALUES (46383, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:31', 7, 0, '', '2019-07-01 18:53:31');
INSERT INTO `access_log` VALUES (46384, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:31', 14, 0, '', '2019-07-01 18:53:31');
INSERT INTO `access_log` VALUES (46385, '64.79.15619784356229621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:56', 2, 0, '', '2019-07-01 18:53:56');
INSERT INTO `access_log` VALUES (46386, '64.78.15619784358329613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:56', 2, 0, '', '2019-07-01 18:53:56');
INSERT INTO `access_log` VALUES (46387, '64.85.15619784374979627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:57', 1, 0, '', '2019-07-01 18:53:58');
INSERT INTO `access_log` VALUES (46388, '64.83.15619784386779605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:53:59', 2, 0, '', '2019-07-01 18:53:59');
INSERT INTO `access_log` VALUES (46389, '64.77.15619784397179601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:54:00', 2, 0, '', '2019-07-01 18:54:00');
INSERT INTO `access_log` VALUES (46390, '64.82.15619784402179621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:54:00', 2, 0, '', '2019-07-01 18:54:00');
INSERT INTO `access_log` VALUES (46391, '64.81.15619784555679609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:54:16', 2, 0, '', '2019-07-01 18:54:16');
INSERT INTO `access_log` VALUES (46392, '64.84.15619784556989607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:54:16', 2, 0, '', '2019-07-01 18:54:16');
INSERT INTO `access_log` VALUES (46393, '59.75.15619784567929527', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:54:17', 3, 0, '', '2019-07-01 18:54:17');
INSERT INTO `access_log` VALUES (46394, '59.73.15619784568189527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:54:17', 14, 2001001000, '服务端发生异常', '2019-07-01 18:54:17');
INSERT INTO `access_log` VALUES (46395, '64.80.15619784586879617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:54:19', 2, 0, '', '2019-07-01 18:54:19');
INSERT INTO `access_log` VALUES (46396, '64.79.15619784588339623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:54:19', 2, 0, '', '2019-07-01 18:54:19');
INSERT INTO `access_log` VALUES (46397, '59.76.15619784595139515', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:54:20', 3, 0, '', '2019-07-01 18:54:20');
INSERT INTO `access_log` VALUES (46398, '59.79.15619784595179527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:54:20', 21, 2001001000, '服务端发生异常', '2019-07-01 18:54:20');
INSERT INTO `access_log` VALUES (46399, '59.74.15619786786229527', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:57:59', 3, 0, '', '2019-07-01 18:57:59');
INSERT INTO `access_log` VALUES (46400, '59.75.15619786786279531', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:57:59', 12, 2001001000, '服务端发生异常', '2019-07-01 18:57:59');
INSERT INTO `access_log` VALUES (46401, '64.76.15619786825479605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:03', 2, 0, '', '2019-07-01 18:58:03');
INSERT INTO `access_log` VALUES (46402, '64.81.15619786827029613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:03', 2, 0, '', '2019-07-01 18:58:03');
INSERT INTO `access_log` VALUES (46403, '64.84.15619786854379611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:05', 2, 0, '', '2019-07-01 18:58:05');
INSERT INTO `access_log` VALUES (46404, '64.79.15619786856279627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:06', 2, 0, '', '2019-07-01 18:58:06');
INSERT INTO `access_log` VALUES (46405, '64.78.15619786872679619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:07', 2, 0, '', '2019-07-01 18:58:07');
INSERT INTO `access_log` VALUES (46406, '64.85.15619786874329633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:07', 1, 0, '', '2019-07-01 18:58:07');
INSERT INTO `access_log` VALUES (46407, '59.77.15619786882129515', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:08', 2, 0, '', '2019-07-01 18:58:08');
INSERT INTO `access_log` VALUES (46408, '59.79.15619786882279531', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:08', 12, 2001001000, '服务端发生异常', '2019-07-01 18:58:08');
INSERT INTO `access_log` VALUES (46409, '64.83.15619786942179611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:14', 2, 0, '', '2019-07-01 18:58:14');
INSERT INTO `access_log` VALUES (46410, '64.77.15619786943929607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:14', 2, 0, '', '2019-07-01 18:58:14');
INSERT INTO `access_log` VALUES (46411, '59.76.15619786949529519', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:15', 2, 0, '', '2019-07-01 18:58:15');
INSERT INTO `access_log` VALUES (46412, '59.71.15619786949549527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:15', 13, 2001001000, '服务端发生异常', '2019-07-01 18:58:15');
INSERT INTO `access_log` VALUES (46413, '64.82.15619786957979627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:16', 2, 0, '', '2019-07-01 18:58:16');
INSERT INTO `access_log` VALUES (46414, '64.76.15619786960429607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:16', 2, 0, '', '2019-07-01 18:58:16');
INSERT INTO `access_log` VALUES (46415, '64.81.15619786970229615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:17', 2, 0, '', '2019-07-01 18:58:17');
INSERT INTO `access_log` VALUES (46416, '64.80.15619786975839623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:18', 2, 0, '', '2019-07-01 18:58:18');
INSERT INTO `access_log` VALUES (46417, '64.84.15619786987039613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:19', 2, 0, '', '2019-07-01 18:58:19');
INSERT INTO `access_log` VALUES (46418, '64.79.15619786989129629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:19', 2, 0, '', '2019-07-01 18:58:19');
INSERT INTO `access_log` VALUES (46419, '59.80.15619787039839513', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:24', 3, 0, '', '2019-07-01 18:58:24');
INSERT INTO `access_log` VALUES (46420, '59.78.15619787039979521', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:24', 12, 2001001000, '服务端发生异常', '2019-07-01 18:58:24');
INSERT INTO `access_log` VALUES (46421, '64.85.15619787068129635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:27', 2, 0, '', '2019-07-01 18:58:27');
INSERT INTO `access_log` VALUES (46422, '64.83.15619787070029613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:27', 1, 0, '', '2019-07-01 18:58:27');
INSERT INTO `access_log` VALUES (46423, '64.77.15619787106129609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:31', 2, 0, '', '2019-07-01 18:58:31');
INSERT INTO `access_log` VALUES (46424, '64.82.15619787107839629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:31', 2, 0, '', '2019-07-01 18:58:31');
INSERT INTO `access_log` VALUES (46425, '59.74.15619787123029529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:32', 2, 0, '', '2019-07-01 18:58:32');
INSERT INTO `access_log` VALUES (46426, '59.75.15619787123629533', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 5X Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.4.8', '223.104.212.32', '2019-07-01 18:58:32', 12, 2001001000, '服务端发生异常', '2019-07-01 18:58:32');
INSERT INTO `access_log` VALUES (46427, '65.49.15619788589370891', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.251.218.217', '2019-07-01 19:00:59', 0, 1002001015, '账号未登陆', '2019-07-01 19:00:59');
INSERT INTO `access_log` VALUES (46428, '65.51.15619788589370929', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.251.218.217', '2019-07-01 19:00:59', 0, 1002001015, '账号未登陆', '2019-07-01 19:00:59');
INSERT INTO `access_log` VALUES (46429, '65.46.15619788589370945', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.251.218.217', '2019-07-01 19:00:59', 1, 1002001015, '账号未登陆', '2019-07-01 19:00:59');
INSERT INTO `access_log` VALUES (46430, '65.54.15619788626580849', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.251.218.217', '2019-07-01 19:01:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 19:01:03');
INSERT INTO `access_log` VALUES (46431, '65.47.15619788669510861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.251.218.217', '2019-07-01 19:01:07', 107, 0, '', '2019-07-01 19:01:07');
INSERT INTO `access_log` VALUES (46432, '65.45.15619788673490885', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.251.218.217', '2019-07-01 19:01:07', 9, 0, '', '2019-07-01 19:01:07');
INSERT INTO `access_log` VALUES (46433, '65.53.15619788673590895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.251.218.217', '2019-07-01 19:01:07', 10, 2001001000, '服务端发生异常', '2019-07-01 19:01:07');
INSERT INTO `access_log` VALUES (46434, '65.3607.15619788673792677', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.251.218.217', '2019-07-01 19:01:07', 9, 0, '', '2019-07-01 19:01:07');
INSERT INTO `access_log` VALUES (46435, '65.50.15619788730140905', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.251.218.217', '2019-07-01 19:01:13', 9, 0, '', '2019-07-01 19:01:13');
INSERT INTO `access_log` VALUES (46436, '65.51.15619788730240931', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.251.218.217', '2019-07-01 19:01:13', 18, 2001001000, '服务端发生异常', '2019-07-01 19:01:13');
INSERT INTO `access_log` VALUES (46437, '65.46.15619788730270947', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.251.218.217', '2019-07-01 19:01:13', 16, 0, '', '2019-07-01 19:01:13');
INSERT INTO `access_log` VALUES (46438, '65.52.15619789148570913', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.251.218.217', '2019-07-01 19:01:55', 9, 0, '', '2019-07-01 19:01:55');
INSERT INTO `access_log` VALUES (46439, '65.50.15619789148590907', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.251.218.217', '2019-07-01 19:01:55', 10, 2001001000, '服务端发生异常', '2019-07-01 19:01:55');
INSERT INTO `access_log` VALUES (46440, '65.46.15619789148620949', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '114.251.218.217', '2019-07-01 19:01:55', 9, 0, '', '2019-07-01 19:01:55');
INSERT INTO `access_log` VALUES (46441, '59.73.15619790136239537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.40.189.55', '2019-07-01 19:03:34', 3, 0, '', '2019-07-01 19:03:34');
INSERT INTO `access_log` VALUES (46442, '59.77.15619790136439521', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.40.189.55', '2019-07-01 19:03:34', 12, 2001001000, '服务端发生异常', '2019-07-01 19:03:34');
INSERT INTO `access_log` VALUES (46443, '64.84.15619790476049619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:04:08', 2, 0, '', '2019-07-01 19:04:08');
INSERT INTO `access_log` VALUES (46444, '64.79.15619790498869635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:04:10', 2, 0, '', '2019-07-01 19:04:10');
INSERT INTO `access_log` VALUES (46445, '64.78.15619790531369627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:04:13', 2, 0, '', '2019-07-01 19:04:13');
INSERT INTO `access_log` VALUES (46446, '64.85.15619790588479641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:04:19', 2, 0, '', '2019-07-01 19:04:19');
INSERT INTO `access_log` VALUES (46447, '64.83.15619790603239619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:04:20', 2, 0, '', '2019-07-01 19:04:20');
INSERT INTO `access_log` VALUES (46448, '64.82.15619790624979635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:04:22', 2, 0, '', '2019-07-01 19:04:23');
INSERT INTO `access_log` VALUES (46449, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:04:26', 5, 0, '', '2019-07-01 19:04:26');
INSERT INTO `access_log` VALUES (46450, '64.76.15619790662199615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:04:26', 2, 0, '', '2019-07-01 19:04:26');
INSERT INTO `access_log` VALUES (46451, '64.80.15619790780729631', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:04:38', 7, 0, '', '2019-07-01 19:04:38');
INSERT INTO `access_log` VALUES (46452, '66.55.15619791050237671', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13701501490&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:05:05', 9, 1001003000, '验证码不存在', '2019-07-01 19:05:05');
INSERT INTO `access_log` VALUES (46453, '66.53.15619791077607681', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13701501490', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:05:08', 67, 0, '', '2019-07-01 19:05:08');
INSERT INTO `access_log` VALUES (46454, '66.50.15619791097187681', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13701501490&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:05:10', 270, 0, '', '2019-07-01 19:05:10');
INSERT INTO `access_log` VALUES (46455, '66.49.15619791125097695', 146, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:05:13', 7, 0, '', '2019-07-01 19:05:13');
INSERT INTO `access_log` VALUES (46456, '66.56.15619791196427697', 146, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:05:20', 6, 0, '', '2019-07-01 19:05:20');
INSERT INTO `access_log` VALUES (46457, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '183.192.164.85', '2019-07-01 19:05:25', 8, 0, '', '2019-07-01 19:05:25');
INSERT INTO `access_log` VALUES (46458, '66.57.15619791419387689', 146, 1, 'user-application', '/user-api/users/address/add', 'name=jjj&tel=13701501490&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=jjjjjjj&isDefault=false&address=jjjjjjj&areaNo=110101&mobile=13701501490&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:05:42', 324, 2001001000, '服务端发生异常', '2019-07-01 19:05:42');
INSERT INTO `access_log` VALUES (46459, '64.83.15619791429779621', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '183.192.164.56', '2019-07-01 19:05:43', 10, 0, '', '2019-07-01 19:05:43');
INSERT INTO `access_log` VALUES (46460, '66.53.15619791459097683', 146, 1, 'user-application', '/user-api/users/address/add', 'name=jjj&tel=13701501490&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=jjjjjjj&isDefault=false&address=jjjjjjj&areaNo=110101&mobile=13701501490&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:05:46', 99, 2001001000, '服务端发生异常', '2019-07-01 19:05:46');
INSERT INTO `access_log` VALUES (46461, '66.50.15619791495987683', 146, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:05:50', 6, 0, '', '2019-07-01 19:05:50');
INSERT INTO `access_log` VALUES (46462, '66.51.15619791741297711', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '183.192.164.71', '2019-07-01 19:06:14', 3, 0, '', '2019-07-01 19:06:14');
INSERT INTO `access_log` VALUES (46463, '66.56.15619791802237699', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '183.192.164.85', '2019-07-01 19:06:20', 3, 0, '', '2019-07-01 19:06:20');
INSERT INTO `access_log` VALUES (46464, '59.71.15619808342689557', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '120.85.60.124', '2019-07-01 19:33:54', 4, 0, '', '2019-07-01 19:33:54');
INSERT INTO `access_log` VALUES (46465, '59.72.15619808342689557', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '120.85.60.124', '2019-07-01 19:33:54', 13, 2001001000, '服务端发生异常', '2019-07-01 19:33:54');
INSERT INTO `access_log` VALUES (46466, '64.81.15619808369419647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '120.85.60.124', '2019-07-01 19:33:57', 3, 0, '', '2019-07-01 19:33:57');
INSERT INTO `access_log` VALUES (46467, '64.80.15619808371109655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '120.85.60.124', '2019-07-01 19:33:57', 2, 0, '', '2019-07-01 19:33:57');
INSERT INTO `access_log` VALUES (46468, '59.78.15619808397209551', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '120.85.60.124', '2019-07-01 19:34:00', 2, 0, '', '2019-07-01 19:34:00');
INSERT INTO `access_log` VALUES (46469, '59.80.15619808397209543', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '120.85.60.124', '2019-07-01 19:34:00', 13, 2001001000, '服务端发生异常', '2019-07-01 19:34:00');
INSERT INTO `access_log` VALUES (46470, '65.45.15619831436010941', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.239.87', '2019-07-01 20:12:24', 1, 1002001015, '账号未登陆', '2019-07-01 20:12:24');
INSERT INTO `access_log` VALUES (46471, '65.3607.15619831436012737', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.239.87', '2019-07-01 20:12:24', 0, 1002001015, '账号未登陆', '2019-07-01 20:12:24');
INSERT INTO `access_log` VALUES (46472, '65.52.15619831436060971', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.239.87', '2019-07-01 20:12:24', 0, 1002001015, '账号未登陆', '2019-07-01 20:12:24');
INSERT INTO `access_log` VALUES (46473, '65.46.15619831455121007', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.239.87', '2019-07-01 20:12:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 20:12:26');
INSERT INTO `access_log` VALUES (46474, '65.51.15619831494240991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.239.87', '2019-07-01 20:12:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 20:12:29');
INSERT INTO `access_log` VALUES (46475, '65.49.15619831665000953', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.239.87', '2019-07-01 20:12:47', 85, 0, '', '2019-07-01 20:12:47');
INSERT INTO `access_log` VALUES (46476, '65.47.15619831668050921', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.239.87', '2019-07-01 20:12:47', 18, 0, '', '2019-07-01 20:12:47');
INSERT INTO `access_log` VALUES (46477, '65.53.15619831668070953', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.239.87', '2019-07-01 20:12:47', 18, 2001001000, '服务端发生异常', '2019-07-01 20:12:47');
INSERT INTO `access_log` VALUES (46478, '65.45.15619831668180943', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.239.87', '2019-07-01 20:12:47', 8, 0, '', '2019-07-01 20:12:47');
INSERT INTO `access_log` VALUES (46479, '65.3607.15619834566812745', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.239.87', '2019-07-01 20:17:37', 1, 1002001015, '账号未登陆', '2019-07-01 20:17:37');
INSERT INTO `access_log` VALUES (46480, '65.53.15619877034771015', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:28:23', 1, 1002001015, '账号未登陆', '2019-07-01 21:28:23');
INSERT INTO `access_log` VALUES (46481, '65.46.15619877034771069', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:28:23', 0, 1002001015, '账号未登陆', '2019-07-01 21:28:23');
INSERT INTO `access_log` VALUES (46482, '65.54.15619877034830973', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:28:23', 3, 1002001015, '账号未登陆', '2019-07-01 21:28:23');
INSERT INTO `access_log` VALUES (46483, '65.49.15619877057831017', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:28:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 21:28:26');
INSERT INTO `access_log` VALUES (46484, '65.3607.15619877147962803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:28:35', 77, 0, '', '2019-07-01 21:28:35');
INSERT INTO `access_log` VALUES (46485, '65.50.15619877151901029', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:28:35', 175, 0, '', '2019-07-01 21:28:35');
INSERT INTO `access_log` VALUES (46486, '65.51.15619877151951055', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:28:35', 172, 0, '', '2019-07-01 21:28:35');
INSERT INTO `access_log` VALUES (46487, '65.45.15619877151911007', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:28:35', 177, 2001001000, '服务端发生异常', '2019-07-01 21:28:35');
INSERT INTO `access_log` VALUES (46488, '65.53.15619877251811017', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:28:45', 37, 0, '', '2019-07-01 21:28:45');
INSERT INTO `access_log` VALUES (46489, '65.46.15619877251881071', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:28:45', 31, 0, '', '2019-07-01 21:28:45');
INSERT INTO `access_log` VALUES (46490, '65.54.15619877251850975', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:28:45', 34, 2001001000, '服务端发生异常', '2019-07-01 21:28:45');
INSERT INTO `access_log` VALUES (46491, '65.3607.15619877473002805', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:29:07', 8, 0, '', '2019-07-01 21:29:07');
INSERT INTO `access_log` VALUES (46492, '65.51.15619877473021057', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:29:07', 8, 0, '', '2019-07-01 21:29:07');
INSERT INTO `access_log` VALUES (46493, '65.49.15619877473001019', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:29:07', 19, 2001001000, '服务端发生异常', '2019-07-01 21:29:07');
INSERT INTO `access_log` VALUES (46494, '65.46.15619877506051073', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:29:11', 8, 0, '', '2019-07-01 21:29:11');
INSERT INTO `access_log` VALUES (46495, '65.50.15619877506041031', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:29:11', 11, 0, '', '2019-07-01 21:29:11');
INSERT INTO `access_log` VALUES (46496, '65.52.15619877506041039', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '113.87.12.188', '2019-07-01 21:29:11', 11, 2001001000, '服务端发生异常', '2019-07-01 21:29:11');
INSERT INTO `access_log` VALUES (46497, '59.74.15619883305869659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:38:51', 16, 2001001000, '服务端发生异常', '2019-07-01 21:38:51');
INSERT INTO `access_log` VALUES (46498, '59.75.15619883305869663', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:38:51', 171, 0, '', '2019-07-01 21:38:51');
INSERT INTO `access_log` VALUES (46499, '59.77.15619883370199647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:38:57', 3, 0, '', '2019-07-01 21:38:57');
INSERT INTO `access_log` VALUES (46500, '59.73.15619883370209663', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:38:57', 14, 2001001000, '服务端发生异常', '2019-07-01 21:38:57');
INSERT INTO `access_log` VALUES (46501, '59.79.15619883429759663', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:39:03', 2, 0, '', '2019-07-01 21:39:03');
INSERT INTO `access_log` VALUES (46502, '59.76.15619883429759651', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:39:03', 18, 2001001000, '服务端发生异常', '2019-07-01 21:39:03');
INSERT INTO `access_log` VALUES (46503, '66.51.15619885880907837', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15820459220&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:43:08', 14, 1001003000, '验证码不存在', '2019-07-01 21:43:08');
INSERT INTO `access_log` VALUES (46504, '66.56.15619885948907825', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15820459220&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:43:15', 8, 1001003000, '验证码不存在', '2019-07-01 21:43:15');
INSERT INTO `access_log` VALUES (46505, '66.52.15619885966197815', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15820459220', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:43:17', 62, 0, '', '2019-07-01 21:43:17');
INSERT INTO `access_log` VALUES (46506, '66.55.15619886139067801', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15820459220&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:43:34', 214, 0, '', '2019-07-01 21:43:34');
INSERT INTO `access_log` VALUES (46507, '66.50.15619886161737811', 147, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:43:36', 6, 0, '', '2019-07-01 21:43:36');
INSERT INTO `access_log` VALUES (46508, '59.71.15619886221089663', 147, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:43:42', 12, 0, '', '2019-07-01 21:43:42');
INSERT INTO `access_log` VALUES (46509, '59.78.15619886221429657', 147, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:43:42', 19, 2001001000, '服务端发生异常', '2019-07-01 21:43:42');
INSERT INTO `access_log` VALUES (46510, '66.48.15619886282257831', 147, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:43:48', 7, 0, '', '2019-07-01 21:43:48');
INSERT INTO `access_log` VALUES (46511, '66.54.15619886758557827', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:44:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空', '2019-07-01 21:44:36');
INSERT INTO `access_log` VALUES (46512, '66.55.15619886798627803', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:44:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空', '2019-07-01 21:44:40');
INSERT INTO `access_log` VALUES (46513, '66.57.15619886849717819', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:44:45', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-07-01 21:44:45');
INSERT INTO `access_log` VALUES (46514, '66.50.15619887022967813', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15820459220', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:45:02', 90, 0, '', '2019-07-01 21:45:02');
INSERT INTO `access_log` VALUES (46515, '66.49.15619887067967827', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15820459220&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:45:07', 180, 0, '', '2019-07-01 21:45:07');
INSERT INTO `access_log` VALUES (46516, '66.51.15619887083827841', 147, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:45:08', 6, 0, '', '2019-07-01 21:45:08');
INSERT INTO `access_log` VALUES (46517, '66.56.15619887198687829', 147, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '14.155.114.3', '2019-07-01 21:45:20', 6, 0, '', '2019-07-01 21:45:20');
INSERT INTO `access_log` VALUES (46518, '65.3607.15619909475322849', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '59.63.206.80', '2019-07-01 22:22:28', 1, 1002001015, '账号未登陆', '2019-07-01 22:22:28');
INSERT INTO `access_log` VALUES (46519, '65.47.15619909475351031', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '59.63.206.80', '2019-07-01 22:22:28', 1, 1002001015, '账号未登陆', '2019-07-01 22:22:28');
INSERT INTO `access_log` VALUES (46520, '65.51.15619909475351103', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '59.63.206.80', '2019-07-01 22:22:28', 1, 1002001015, '账号未登陆', '2019-07-01 22:22:28');
INSERT INTO `access_log` VALUES (46521, '65.49.15619909525891065', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '59.63.206.80', '2019-07-01 22:22:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 22:22:33');
INSERT INTO `access_log` VALUES (46522, '65.45.15619909671951053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '59.63.206.80', '2019-07-01 22:22:47', 107, 0, '', '2019-07-01 22:22:47');
INSERT INTO `access_log` VALUES (46523, '65.50.15619909678661077', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '59.63.206.80', '2019-07-01 22:22:48', 12, 0, '', '2019-07-01 22:22:48');
INSERT INTO `access_log` VALUES (46524, '65.46.15619909678711117', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '59.63.206.80', '2019-07-01 22:22:48', 11, 2001001000, '服务端发生异常', '2019-07-01 22:22:48');
INSERT INTO `access_log` VALUES (46525, '65.53.15619909678761065', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '59.63.206.80', '2019-07-01 22:22:48', 9, 0, '', '2019-07-01 22:22:48');
INSERT INTO `access_log` VALUES (46526, '65.51.15619910069041105', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '59.63.206.80', '2019-07-01 22:23:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 22:23:27');
INSERT INTO `access_log` VALUES (46527, '65.49.15619910085601067', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.174', '2019-07-01 22:23:29', 1, 1002001015, '账号未登陆', '2019-07-01 22:23:29');
INSERT INTO `access_log` VALUES (46528, '65.52.15619910176641085', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.177', '2019-07-01 22:23:38', 0, 1002001015, '账号未登陆', '2019-07-01 22:23:38');
INSERT INTO `access_log` VALUES (46529, '65.50.15619910238361079', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.91.60.104', '2019-07-01 22:23:44', 0, 1002001015, '账号未登陆', '2019-07-01 22:23:44');
INSERT INTO `access_log` VALUES (46530, '59.77.15619933222099715', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:02:02', 11, 0, '', '2019-07-01 23:02:02');
INSERT INTO `access_log` VALUES (46531, '59.73.15619933222519731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:02:02', 25, 2001001000, '服务端发生异常', '2019-07-01 23:02:02');
INSERT INTO `access_log` VALUES (46532, '64.85.15619933310499833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:02:11', 11, 0, '', '2019-07-01 23:02:11');
INSERT INTO `access_log` VALUES (46533, '64.83.15619933315409811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:02:12', 3, 0, '', '2019-07-01 23:02:12');
INSERT INTO `access_log` VALUES (46534, '64.77.15619933351309807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:02:15', 2, 0, '', '2019-07-01 23:02:15');
INSERT INTO `access_log` VALUES (46535, '64.82.15619933360799827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:02:16', 1, 0, '', '2019-07-01 23:02:16');
INSERT INTO `access_log` VALUES (46536, '66.57.15619933472817883', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:02:27', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-07-01 23:02:27');
INSERT INTO `access_log` VALUES (46537, '64.81.15619933500739815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:02:30', 2, 0, '', '2019-07-01 23:02:30');
INSERT INTO `access_log` VALUES (46538, '64.80.15619933502209823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:02:30', 2, 0, '', '2019-07-01 23:02:30');
INSERT INTO `access_log` VALUES (46539, '59.71.15619933678409727', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:02:48', 3, 0, '', '2019-07-01 23:02:48');
INSERT INTO `access_log` VALUES (46540, '59.78.15619933678869721', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:02:48', 15, 2001001000, '服务端发生异常', '2019-07-01 23:02:48');
INSERT INTO `access_log` VALUES (46541, '64.78.15619933783319821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:02:58', 2, 0, '', '2019-07-01 23:02:58');
INSERT INTO `access_log` VALUES (46542, '64.85.15619933786159835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:02:59', 2, 0, '', '2019-07-01 23:02:59');
INSERT INTO `access_log` VALUES (46543, '64.83.15619933796759813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:03:00', 2, 0, '', '2019-07-01 23:03:00');
INSERT INTO `access_log` VALUES (46544, '64.77.15619933808309809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:03:01', 2, 0, '', '2019-07-01 23:03:01');
INSERT INTO `access_log` VALUES (46545, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:03:01', 7, 0, '', '2019-07-01 23:03:01');
INSERT INTO `access_log` VALUES (46546, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:03:06', 6, 0, '', '2019-07-01 23:03:06');
INSERT INTO `access_log` VALUES (46547, '64.76.15619933886889809', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:03:09', 8, 0, '', '2019-07-01 23:03:09');
INSERT INTO `access_log` VALUES (46548, '64.80.15619934022219825', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:03:22', 6, 0, '', '2019-07-01 23:03:22');
INSERT INTO `access_log` VALUES (46549, '64.84.15619934077379815', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:03:28', 6, 0, '', '2019-07-01 23:03:28');
INSERT INTO `access_log` VALUES (46550, '66.48.15619934321367899', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13825809474&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:03:52', 14, 1001003000, '验证码不存在', '2019-07-01 23:03:52');
INSERT INTO `access_log` VALUES (46551, '66.50.15619934338607881', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13825809474&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:03:54', 8, 1001003000, '验证码不存在', '2019-07-01 23:03:54');
INSERT INTO `access_log` VALUES (46552, '66.49.15619934358967893', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13825809474', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:03:56', 59, 0, '', '2019-07-01 23:03:56');
INSERT INTO `access_log` VALUES (46553, '66.56.15619934526097891', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13825809474&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/4G Language/zh_CN', '117.136.41.75', '2019-07-01 23:04:13', 175, 0, '', '2019-07-01 23:04:13');
INSERT INTO `access_log` VALUES (46554, '65.45.15619935729121091', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.140.247.86', '2019-07-01 23:06:13', 1, 1002001015, '账号未登陆', '2019-07-01 23:06:13');
INSERT INTO `access_log` VALUES (46555, '65.46.15619935729131153', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.140.247.86', '2019-07-01 23:06:13', 0, 1002001015, '账号未登陆', '2019-07-01 23:06:13');
INSERT INTO `access_log` VALUES (46556, '65.54.15619935729141057', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.140.247.86', '2019-07-01 23:06:13', 0, 1002001015, '账号未登陆', '2019-07-01 23:06:13');
INSERT INTO `access_log` VALUES (46557, '65.53.15619935758911103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.140.247.86', '2019-07-01 23:06:16', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-01 23:06:16');
INSERT INTO `access_log` VALUES (46558, '65.47.15619935814051071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.140.247.86', '2019-07-01 23:06:21', 102, 0, '', '2019-07-01 23:06:22');
INSERT INTO `access_log` VALUES (46559, '65.51.15619935818301141', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.140.247.86', '2019-07-01 23:06:22', 12, 0, '', '2019-07-01 23:06:22');
INSERT INTO `access_log` VALUES (46560, '65.52.15619935818311123', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.140.247.86', '2019-07-01 23:06:22', 13, 0, '', '2019-07-01 23:06:22');
INSERT INTO `access_log` VALUES (46561, '65.3607.15619935818302887', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.140.247.86', '2019-07-01 23:06:22', 16, 2001001000, '服务端发生异常', '2019-07-01 23:06:22');
INSERT INTO `access_log` VALUES (46562, '65.49.15619935920681101', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.140.247.86', '2019-07-01 23:06:32', 7, 0, '', '2019-07-01 23:06:32');
INSERT INTO `access_log` VALUES (46563, '65.54.15619935920751059', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.140.247.86', '2019-07-01 23:06:32', 8, 0, '', '2019-07-01 23:06:32');
INSERT INTO `access_log` VALUES (46564, '65.46.15619935920751155', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.140.247.86', '2019-07-01 23:06:32', 9, 2001001000, '服务端发生异常', '2019-07-01 23:06:32');
INSERT INTO `access_log` VALUES (46565, '65.47.15619937653691075', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.140.247.86', '2019-07-01 23:09:25', 11, 0, '', '2019-07-01 23:09:25');
INSERT INTO `access_log` VALUES (46566, '65.51.15619937653741145', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.140.247.86', '2019-07-01 23:09:25', 11, 2001001000, '服务端发生异常', '2019-07-01 23:09:25');
INSERT INTO `access_log` VALUES (46567, '65.52.15619937653781127', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.140.247.86', '2019-07-01 23:09:25', 9, 0, '', '2019-07-01 23:09:25');
INSERT INTO `access_log` VALUES (46568, '64.80.15619941590329837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.247.86', '2019-07-01 23:15:59', 3, 0, '', '2019-07-01 23:15:59');
INSERT INTO `access_log` VALUES (46569, '64.84.15619941593019827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.247.86', '2019-07-01 23:15:59', 2, 0, '', '2019-07-01 23:15:59');
INSERT INTO `access_log` VALUES (46570, '65.54.15620263607371495', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.36.138', '2019-07-02 08:12:41', 1, 1002001015, '账号未登陆', '2019-07-02 08:12:41');
INSERT INTO `access_log` VALUES (46571, '65.49.15620263607371537', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.36.138', '2019-07-02 08:12:41', 1, 1002001015, '账号未登陆', '2019-07-02 08:12:41');
INSERT INTO `access_log` VALUES (46572, '65.46.15620263607401591', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.36.138', '2019-07-02 08:12:41', 0, 1002001015, '账号未登陆', '2019-07-02 08:12:41');
INSERT INTO `access_log` VALUES (46573, '65.3607.15620263637003329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.36.138', '2019-07-02 08:12:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 08:12:44');
INSERT INTO `access_log` VALUES (46574, '65.52.15620263873311567', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.36.138', '2019-07-02 08:13:07', 108, 0, '', '2019-07-02 08:13:07');
INSERT INTO `access_log` VALUES (46575, '65.51.15620263877311583', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.36.138', '2019-07-02 08:13:08', 10, 0, '', '2019-07-02 08:13:08');
INSERT INTO `access_log` VALUES (46576, '65.53.15620263877331543', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.36.138', '2019-07-02 08:13:08', 10, 2001001000, '服务端发生异常', '2019-07-02 08:13:08');
INSERT INTO `access_log` VALUES (46577, '65.47.15620263877561513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; LYA-AL10 Build/HUAWEILYA-AL10) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.111 HuaweiBrowser/9.1.1.302 Mobile Safari/537.36', '183.11.36.138', '2019-07-02 08:13:08', 8, 0, '', '2019-07-02 08:13:08');
INSERT INTO `access_log` VALUES (46578, '65.54.15620281785921521', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:42:59', 5, 1002001012, '访问令牌已过期', '2019-07-02 08:42:59');
INSERT INTO `access_log` VALUES (46579, '65.50.15620281785921581', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:42:59', 5, 1002001012, '访问令牌已过期', '2019-07-02 08:42:59');
INSERT INTO `access_log` VALUES (46580, '65.49.15620281785981563', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:42:59', 3, 1002001012, '访问令牌已过期', '2019-07-02 08:42:59');
INSERT INTO `access_log` VALUES (46581, '65.46.15620281819141617', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:43:02', 223, 0, '', '2019-07-02 08:43:02');
INSERT INTO `access_log` VALUES (46582, '65.3607.15620281823993355', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:43:02', 10, 0, '', '2019-07-02 08:43:02');
INSERT INTO `access_log` VALUES (46583, '65.52.15620281824011593', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:43:02', 9, 0, '', '2019-07-02 08:43:02');
INSERT INTO `access_log` VALUES (46584, '65.45.15620281824001559', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:43:02', 10, 0, '', '2019-07-02 08:43:02');
INSERT INTO `access_log` VALUES (46585, '62.81.15620281870529609', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:43:07', 27, 0, '', '2019-07-02 08:43:07');
INSERT INTO `access_log` VALUES (46586, '64.80.15620282047170291', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:43:25', 25, 0, '', '2019-07-02 08:43:25');
INSERT INTO `access_log` VALUES (46587, '64.84.15620282047360281', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:43:25', 13, 0, '', '2019-07-02 08:43:25');
INSERT INTO `access_log` VALUES (46588, '65.50.15620289568371593', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:55:57', 161, 0, '', '2019-07-02 08:55:57');
INSERT INTO `access_log` VALUES (46589, '65.49.15620289568431575', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:55:57', 156, 0, '', '2019-07-02 08:55:57');
INSERT INTO `access_log` VALUES (46590, '65.51.15620289568371619', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:55:57', 161, 0, '', '2019-07-02 08:55:57');
INSERT INTO `access_log` VALUES (46591, '64.78.15620289569630299', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:55:57', 41, 0, '', '2019-07-02 08:55:57');
INSERT INTO `access_log` VALUES (46592, '64.79.15620289569610307', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 08:55:57', 46, 0, '', '2019-07-02 08:55:57');
INSERT INTO `access_log` VALUES (46593, '59.79.15620290403310209', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.140.27.45', '2019-07-02 08:57:20', 9, 0, '', '2019-07-02 08:57:20');
INSERT INTO `access_log` VALUES (46594, '59.76.15620290403320197', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '61.140.27.45', '2019-07-02 08:57:20', 19, 2001001000, '服务端发生异常', '2019-07-02 08:57:20');
INSERT INTO `access_log` VALUES (46595, '59.72.15620290478750205', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '61.140.27.45', '2019-07-02 08:57:28', 3, 0, '', '2019-07-02 08:57:28');
INSERT INTO `access_log` VALUES (46596, '59.71.15620290478750205', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '61.140.27.45', '2019-07-02 08:57:28', 23, 2001001000, '服务端发生异常', '2019-07-02 08:57:28');
INSERT INTO `access_log` VALUES (46597, '59.78.15620290521050199', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:32', 2, 0, '', '2019-07-02 08:57:32');
INSERT INTO `access_log` VALUES (46598, '59.80.15620290521050191', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:32', 16, 2001001000, '服务端发生异常', '2019-07-02 08:57:32');
INSERT INTO `access_log` VALUES (46599, '64.84.15620290540070293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:34', 5, 0, '', '2019-07-02 08:57:34');
INSERT INTO `access_log` VALUES (46600, '64.80.15620290541270303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:34', 3, 0, '', '2019-07-02 08:57:34');
INSERT INTO `access_log` VALUES (46601, '64.79.15620290583910309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:38', 2, 0, '', '2019-07-02 08:57:38');
INSERT INTO `access_log` VALUES (46602, '64.85.15620290585290315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:39', 2, 0, '', '2019-07-02 08:57:39');
INSERT INTO `access_log` VALUES (46603, '64.83.15620290605830295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:41', 2, 0, '', '2019-07-02 08:57:41');
INSERT INTO `access_log` VALUES (46604, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:41', 6, 0, '', '2019-07-02 08:57:41');
INSERT INTO `access_log` VALUES (46605, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:42', 5, 0, '', '2019-07-02 08:57:42');
INSERT INTO `access_log` VALUES (46606, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:43', 6, 0, '', '2019-07-02 08:57:43');
INSERT INTO `access_log` VALUES (46607, '64.77.15620290641500287', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:44', 8, 0, '', '2019-07-02 08:57:44');
INSERT INTO `access_log` VALUES (46608, '64.76.15620290748400293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:55', 2, 0, '', '2019-07-02 08:57:55');
INSERT INTO `access_log` VALUES (46609, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:55', 6, 0, '', '2019-07-02 08:57:55');
INSERT INTO `access_log` VALUES (46610, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:56', 5, 0, '', '2019-07-02 08:57:56');
INSERT INTO `access_log` VALUES (46611, '64.81.15620290766580297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:57', 2, 0, '', '2019-07-02 08:57:57');
INSERT INTO `access_log` VALUES (46612, '64.84.15620290767900295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:57:57', 2, 0, '', '2019-07-02 08:57:57');
INSERT INTO `access_log` VALUES (46613, '64.80.15620290795650305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:58:00', 2, 0, '', '2019-07-02 08:58:00');
INSERT INTO `access_log` VALUES (46614, '64.78.15620290797150303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:58:00', 2, 0, '', '2019-07-02 08:58:00');
INSERT INTO `access_log` VALUES (46615, '59.77.15620290804090193', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:58:00', 2, 0, '', '2019-07-02 08:58:00');
INSERT INTO `access_log` VALUES (46616, '59.73.15620290804090211', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.27.45', '2019-07-02 08:58:00', 18, 2001001000, '服务端发生异常', '2019-07-02 08:58:00');
INSERT INTO `access_log` VALUES (46617, '64.80.15620293460810309', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 09:02:26', 14, 0, '', '2019-07-02 09:02:26');
INSERT INTO `access_log` VALUES (46618, '64.79.15620293497350315', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 09:02:30', 8, 0, '', '2019-07-02 09:02:30');
INSERT INTO `access_log` VALUES (46619, '64.78.15620293497330307', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 09:02:30', 24, 0, '', '2019-07-02 09:02:30');
INSERT INTO `access_log` VALUES (46620, '64.83.15620293527870301', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 09:02:33', 15, 0, '', '2019-07-02 09:02:33');
INSERT INTO `access_log` VALUES (46621, '64.85.15620293527870321', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 09:02:33', 17, 0, '', '2019-07-02 09:02:33');
INSERT INTO `access_log` VALUES (46622, '64.77.15620293528090293', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 09:02:33', 8, 0, '', '2019-07-02 09:02:33');
INSERT INTO `access_log` VALUES (46623, '65.54.15620306085891555', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-02 09:23:29', 3, 1002001012, '访问令牌已过期', '2019-07-02 09:23:29');
INSERT INTO `access_log` VALUES (46624, '65.46.15620306085901651', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-02 09:23:29', 3, 1002001012, '访问令牌已过期', '2019-07-02 09:23:29');
INSERT INTO `access_log` VALUES (46625, '65.52.15620306085971627', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-02 09:23:29', 3, 1002001012, '访问令牌已过期', '2019-07-02 09:23:29');
INSERT INTO `access_log` VALUES (46626, '65.3607.15620306101193389', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-02 09:23:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 09:23:30');
INSERT INTO `access_log` VALUES (46627, '65.47.15620306330961573', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-02 09:23:53', 122, 0, '', '2019-07-02 09:23:53');
INSERT INTO `access_log` VALUES (46628, '65.50.15620306359731617', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-02 09:23:56', 10, 0, '', '2019-07-02 09:23:56');
INSERT INTO `access_log` VALUES (46629, '65.49.15620306359781599', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-02 09:23:56', 10, 2001001000, '服务端发生异常', '2019-07-02 09:23:56');
INSERT INTO `access_log` VALUES (46630, '65.51.15620306359861643', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-02 09:23:56', 9, 0, '', '2019-07-02 09:23:56');
INSERT INTO `access_log` VALUES (46631, '65.3607.15620306502973391', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-02 09:24:10', 243, 0, '', '2019-07-02 09:24:11');
INSERT INTO `access_log` VALUES (46632, '65.52.15620306502921629', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-02 09:24:10', 249, 2001001000, '服务端发生异常', '2019-07-02 09:24:11');
INSERT INTO `access_log` VALUES (46633, '65.54.15620306502881557', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-02 09:24:10', 251, 0, '', '2019-07-02 09:24:11');
INSERT INTO `access_log` VALUES (46634, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-02 09:45:41', 7, 0, '', '2019-07-02 09:45:41');
INSERT INTO `access_log` VALUES (46635, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-02 09:45:42', 23, 0, '', '2019-07-02 09:45:42');
INSERT INTO `access_log` VALUES (46636, '64.83.15620320058300337', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.29.163', '2019-07-02 09:46:46', 9, 0, '', '2019-07-02 09:46:46');
INSERT INTO `access_log` VALUES (46637, '59.78.15620325825560247', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '58.213.29.221', '2019-07-02 09:56:23', 13, 0, '', '2019-07-02 09:56:23');
INSERT INTO `access_log` VALUES (46638, '59.80.15620325825560239', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '58.213.29.221', '2019-07-02 09:56:23', 15, 2001001000, '服务端发生异常', '2019-07-02 09:56:23');
INSERT INTO `access_log` VALUES (46639, '64.83.15620325893260345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '58.213.29.221', '2019-07-02 09:56:29', 2, 0, '', '2019-07-02 09:56:29');
INSERT INTO `access_log` VALUES (46640, '64.85.15620325894450365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '58.213.29.221', '2019-07-02 09:56:29', 1, 0, '', '2019-07-02 09:56:29');
INSERT INTO `access_log` VALUES (46641, '59.75.15620325916550259', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '58.213.29.221', '2019-07-02 09:56:32', 3, 0, '', '2019-07-02 09:56:32');
INSERT INTO `access_log` VALUES (46642, '59.74.15620325916550257', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '58.213.29.221', '2019-07-02 09:56:32', 33, 2001001000, '服务端发生异常', '2019-07-02 09:56:32');
INSERT INTO `access_log` VALUES (46643, '64.77.15620325954470337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '58.213.29.221', '2019-07-02 09:56:35', 2, 0, '', '2019-07-02 09:56:35');
INSERT INTO `access_log` VALUES (46644, '64.76.15620325955360343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '58.213.29.221', '2019-07-02 09:56:36', 2, 0, '', '2019-07-02 09:56:36');
INSERT INTO `access_log` VALUES (46645, '64.81.15620325968770347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '58.213.29.221', '2019-07-02 09:56:37', 2, 0, '', '2019-07-02 09:56:37');
INSERT INTO `access_log` VALUES (46646, '64.84.15620325976090345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '58.213.29.221', '2019-07-02 09:56:38', 2, 0, '', '2019-07-02 09:56:38');
INSERT INTO `access_log` VALUES (46647, '64.80.15620325992990355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '58.213.29.221', '2019-07-02 09:56:39', 2, 0, '', '2019-07-02 09:56:39');
INSERT INTO `access_log` VALUES (46648, '64.79.15620325999550361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '58.213.29.221', '2019-07-02 09:56:40', 2, 0, '', '2019-07-02 09:56:40');
INSERT INTO `access_log` VALUES (46649, '64.83.15620326123660347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '58.213.29.221', '2019-07-02 09:56:52', 2, 0, '', '2019-07-02 09:56:52');
INSERT INTO `access_log` VALUES (46650, '64.85.15620326124730367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '58.213.29.221', '2019-07-02 09:56:52', 2, 0, '', '2019-07-02 09:56:52');
INSERT INTO `access_log` VALUES (46651, '59.76.15620326132310247', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '58.213.29.221', '2019-07-02 09:56:53', 3, 0, '', '2019-07-02 09:56:53');
INSERT INTO `access_log` VALUES (46652, '59.79.15620326132310259', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '58.213.29.221', '2019-07-02 09:56:53', 15, 2001001000, '服务端发生异常', '2019-07-02 09:56:53');
INSERT INTO `access_log` VALUES (46653, '65.46.15620330599001687', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.122.107.218', '2019-07-02 10:04:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 10:04:20');
INSERT INTO `access_log` VALUES (46654, '65.50.15620330602561649', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.122.107.218', '2019-07-02 10:04:20', 0, 1002001015, '账号未登陆', '2019-07-02 10:04:20');
INSERT INTO `access_log` VALUES (46655, '65.52.15620330602581663', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.122.107.218', '2019-07-02 10:04:20', 0, 1002001015, '账号未登陆', '2019-07-02 10:04:20');
INSERT INTO `access_log` VALUES (46656, '65.54.15620330602591589', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.122.107.218', '2019-07-02 10:04:20', 1, 1002001015, '账号未登陆', '2019-07-02 10:04:20');
INSERT INTO `access_log` VALUES (46657, '65.52.15620331882271665', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.72.51.177', '2019-07-02 10:06:28', 89, 0, '', '2019-07-02 10:06:28');
INSERT INTO `access_log` VALUES (46658, '65.3607.15620331887003427', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.72.51.177', '2019-07-02 10:06:29', 9, 0, '', '2019-07-02 10:06:29');
INSERT INTO `access_log` VALUES (46659, '65.45.15620331887231631', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.72.51.177', '2019-07-02 10:06:29', 13, 0, '', '2019-07-02 10:06:29');
INSERT INTO `access_log` VALUES (46660, '65.47.15620331887231611', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.72.51.177', '2019-07-02 10:06:29', 12, 2001001000, '服务端发生异常', '2019-07-02 10:06:29');
INSERT INTO `access_log` VALUES (46661, '59.73.15620333094290269', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:08:29', 3, 0, '', '2019-07-02 10:08:29');
INSERT INTO `access_log` VALUES (46662, '59.77.15620333094300251', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:08:29', 13, 2001001000, '服务端发生异常', '2019-07-02 10:08:29');
INSERT INTO `access_log` VALUES (46663, '64.78.15620333159480363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:08:36', 2, 0, '', '2019-07-02 10:08:36');
INSERT INTO `access_log` VALUES (46664, '64.83.15620333161550357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:08:36', 2, 0, '', '2019-07-02 10:08:36');
INSERT INTO `access_log` VALUES (46665, '64.85.15620333178450377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:08:38', 2, 0, '', '2019-07-02 10:08:38');
INSERT INTO `access_log` VALUES (46666, '64.77.15620333192290349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:08:39', 2, 0, '', '2019-07-02 10:08:39');
INSERT INTO `access_log` VALUES (46667, '66.54.15620333476028427', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15111111111', 'POST', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:08', 114, 0, '', '2019-07-02 10:09:08');
INSERT INTO `access_log` VALUES (46668, '66.48.15620333542598435', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15111111111&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:14', 189, 0, '', '2019-07-02 10:09:14');
INSERT INTO `access_log` VALUES (46669, '64.80.15620333612830367', 149, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:21', 5, 0, '', '2019-07-02 10:09:21');
INSERT INTO `access_log` VALUES (46670, '64.78.15620333618990365', 149, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:22', 7, 0, '', '2019-07-02 10:09:22');
INSERT INTO `access_log` VALUES (46671, '64.83.15620333643800359', 149, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:24', 6, 0, '', '2019-07-02 10:09:24');
INSERT INTO `access_log` VALUES (46672, '64.85.15620333646220379', 149, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:25', 5, 0, '', '2019-07-02 10:09:25');
INSERT INTO `access_log` VALUES (46673, '66.49.15620333661528429', 149, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:26', 5, 0, '', '2019-07-02 10:09:26');
INSERT INTO `access_log` VALUES (46674, '66.56.15620333696098425', 149, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:30', 6, 0, '', '2019-07-02 10:09:30');
INSERT INTO `access_log` VALUES (46675, '66.54.15620333907868429', 149, 1, 'user-application', '/user-api/users/address/add', 'name=等红灯&tel=15111111111&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=好的&isDefault=true&address=好的&areaNo=110101&mobile=15111111111&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:51', 76, 2001001000, '服务端发生异常', '2019-07-02 10:09:51');
INSERT INTO `access_log` VALUES (46676, '66.48.15620333940248437', 149, 1, 'user-application', '/user-api/users/address/add', 'name=等红灯&tel=15111111111&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=好的&isDefault=true&address=好的&areaNo=110101&mobile=15111111111&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:54', 132, 2001001000, '服务端发生异常', '2019-07-02 10:09:54');
INSERT INTO `access_log` VALUES (46677, '66.53.15620333964238417', 149, 1, 'user-application', '/user-api/users/address/add', 'name=等红灯&tel=15111111111&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=好的&isDefault=true&address=好的&areaNo=110101&mobile=15111111111&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:56', 96, 2001001000, '服务端发生异常', '2019-07-02 10:09:57');
INSERT INTO `access_log` VALUES (46678, '66.50.15620333992538419', 149, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:59', 12, 0, '', '2019-07-02 10:09:59');
INSERT INTO `access_log` VALUES (46679, '66.49.15620333994878431', 149, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:59', 6, 0, '', '2019-07-02 10:09:59');
INSERT INTO `access_log` VALUES (46680, '59.74.15620334025410269', 149, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:03', 12, 0, '', '2019-07-02 10:10:03');
INSERT INTO `access_log` VALUES (46681, '59.77.15620334039790253', 149, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:04', 8, 0, '', '2019-07-02 10:10:04');
INSERT INTO `access_log` VALUES (46682, '59.72.15620334057050267', 149, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:06', 9, 0, '', '2019-07-02 10:10:06');
INSERT INTO `access_log` VALUES (46683, '66.56.15620334076208427', 149, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:08', 6, 0, '', '2019-07-02 10:10:08');
INSERT INTO `access_log` VALUES (46684, '66.51.15620334140348441', 149, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:14', 6, 0, '', '2019-07-02 10:10:14');
INSERT INTO `access_log` VALUES (46685, '66.52.15620334149878421', 149, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:15', 6, 0, '', '2019-07-02 10:10:15');
INSERT INTO `access_log` VALUES (46686, '66.48.15620334261008439', 149, 1, 'user-application', '/user-api/users/user/update_nickname', 'nickname=哈哈哈', 'POST', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:26', 88, 0, '', '2019-07-02 10:10:26');
INSERT INTO `access_log` VALUES (46687, '66.53.15620334356098419', 149, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:36', 6, 0, '', '2019-07-02 10:10:36');
INSERT INTO `access_log` VALUES (46688, '66.49.15620334463908433', 149, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:46', 6, 0, '', '2019-07-02 10:10:46');
INSERT INTO `access_log` VALUES (46689, '64.80.15620334485430369', 149, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:49', 6, 0, '', '2019-07-02 10:10:49');
INSERT INTO `access_log` VALUES (46690, '64.79.15620334488830375', 149, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:49', 5, 0, '', '2019-07-02 10:10:49');
INSERT INTO `access_log` VALUES (46691, '59.73.15620334505370273', 149, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:51', 5, 0, '', '2019-07-02 10:10:51');
INSERT INTO `access_log` VALUES (46692, '59.76.15620334505780261', 149, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:51', 12, 2001001000, '服务端发生异常', '2019-07-02 10:10:51');
INSERT INTO `access_log` VALUES (46693, '64.83.15620334591660361', 149, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:59', 5, 0, '', '2019-07-02 10:10:59');
INSERT INTO `access_log` VALUES (46694, '64.85.15620334594830381', 149, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:10:59', 4, 0, '', '2019-07-02 10:10:59');
INSERT INTO `access_log` VALUES (46695, '59.77.15620334617020255', 149, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:02', 6, 0, '', '2019-07-02 10:11:02');
INSERT INTO `access_log` VALUES (46696, '59.79.15620334617300273', 149, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:02', 23, 2001001000, '服务端发生异常', '2019-07-02 10:11:02');
INSERT INTO `access_log` VALUES (46697, '64.77.15620334634390353', 149, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:03', 4, 0, '', '2019-07-02 10:11:03');
INSERT INTO `access_log` VALUES (46698, '64.82.15620334635890375', 149, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:04', 5, 0, '', '2019-07-02 10:11:04');
INSERT INTO `access_log` VALUES (46699, '59.71.15620334655190269', 149, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:06', 5, 0, '', '2019-07-02 10:11:06');
INSERT INTO `access_log` VALUES (46700, '59.78.15620334655380263', 149, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:06', 16, 2001001000, '服务端发生异常', '2019-07-02 10:11:06');
INSERT INTO `access_log` VALUES (46701, '64.81.15620334693780363', 149, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:09', 5, 0, '', '2019-07-02 10:11:09');
INSERT INTO `access_log` VALUES (46702, '64.84.15620334695920361', 149, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:10', 5, 0, '', '2019-07-02 10:11:10');
INSERT INTO `access_log` VALUES (46703, 'N/A', 149, 1, 'search-application', '/search-api/users/product/page', 'keyword=都好都好&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:23', 12, 0, '', '2019-07-02 10:11:23');
INSERT INTO `access_log` VALUES (46704, 'N/A', 149, 1, 'search-application', '/search-api/users/product/condition', 'keyword=都好都好', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:23', 11, 0, '', '2019-07-02 10:11:23');
INSERT INTO `access_log` VALUES (46705, '64.79.15620334882780377', 149, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:28', 5, 0, '', '2019-07-02 10:11:28');
INSERT INTO `access_log` VALUES (46706, '64.78.15620334884890369', 149, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:28', 5, 0, '', '2019-07-02 10:11:28');
INSERT INTO `access_log` VALUES (46707, 'N/A', 149, 1, 'search-application', '/search-api/users/product/page', 'keyword=小米&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:34', 9, 0, '', '2019-07-02 10:11:34');
INSERT INTO `access_log` VALUES (46708, 'N/A', 149, 1, 'search-application', '/search-api/users/product/condition', 'keyword=小米', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:35', 13, 0, '', '2019-07-02 10:11:35');
INSERT INTO `access_log` VALUES (46709, '64.77.15620335002220355', 149, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:40', 10, 0, '', '2019-07-02 10:11:40');
INSERT INTO `access_log` VALUES (46710, '66.48.15620335162238441', 149, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:56', 7, 0, '', '2019-07-02 10:11:56');
INSERT INTO `access_log` VALUES (46711, '66.50.15620335177038423', 149, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:58', 6, 0, '', '2019-07-02 10:11:58');
INSERT INTO `access_log` VALUES (46712, '66.53.15620335194618421', 149, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:11:59', 6, 0, '', '2019-07-02 10:11:59');
INSERT INTO `access_log` VALUES (46713, '64.81.15620335372220365', 149, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:12:17', 10, 0, '', '2019-07-02 10:12:17');
INSERT INTO `access_log` VALUES (46714, 'N/A', 149, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:12:19', 11, 0, '', '2019-07-02 10:12:19');
INSERT INTO `access_log` VALUES (46715, 'N/A', 149, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:12:19', 15, 0, '', '2019-07-02 10:12:19');
INSERT INTO `access_log` VALUES (46716, '59.72.15620346325430285', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:30:33', 3, 0, '', '2019-07-02 10:30:33');
INSERT INTO `access_log` VALUES (46717, '59.71.15620346325440285', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:30:33', 14, 2001001000, '服务端发生异常', '2019-07-02 10:30:33');
INSERT INTO `access_log` VALUES (46718, '65.47.15620346500781631', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '61.140.125.240', '2019-07-02 10:30:50', 3, 1002001012, '访问令牌已过期', '2019-07-02 10:30:50');
INSERT INTO `access_log` VALUES (46719, '65.3607.15620346500783447', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '61.140.125.240', '2019-07-02 10:30:50', 3, 1002001012, '访问令牌已过期', '2019-07-02 10:30:50');
INSERT INTO `access_log` VALUES (46720, '65.45.15620346500801651', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '61.140.125.240', '2019-07-02 10:30:50', 2, 1002001012, '访问令牌已过期', '2019-07-02 10:30:50');
INSERT INTO `access_log` VALUES (46721, '65.50.15620347277661673', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:32:08', 101, 0, '', '2019-07-02 10:32:08');
INSERT INTO `access_log` VALUES (46722, '65.52.15620347288571687', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:32:09', 10, 0, '', '2019-07-02 10:32:09');
INSERT INTO `access_log` VALUES (46723, '65.47.15620347288801633', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:32:09', 10, 0, '', '2019-07-02 10:32:09');
INSERT INTO `access_log` VALUES (46724, '65.3607.15620347288803449', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:32:09', 11, 2001001000, '服务端发生异常', '2019-07-02 10:32:09');
INSERT INTO `access_log` VALUES (46725, '65.53.15620347530871663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:32:33', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 10:32:33');
INSERT INTO `access_log` VALUES (46726, '65.51.15620347577991703', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:32:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 10:32:38');
INSERT INTO `access_log` VALUES (46727, '65.54.15620347669631615', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:32:47', 62, 0, '', '2019-07-02 10:32:47');
INSERT INTO `access_log` VALUES (46728, '65.52.15620347672151689', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:32:47', 10, 0, '', '2019-07-02 10:32:47');
INSERT INTO `access_log` VALUES (46729, '65.50.15620347672151675', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:32:47', 10, 0, '', '2019-07-02 10:32:47');
INSERT INTO `access_log` VALUES (46730, '65.45.15620347672171655', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:32:47', 8, 0, '', '2019-07-02 10:32:47');
INSERT INTO `access_log` VALUES (46731, '62.81.15620347738899697', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:32:54', 26, 0, '', '2019-07-02 10:32:54');
INSERT INTO `access_log` VALUES (46732, '62.83.15620347788479737', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:32:59', 25, 0, '', '2019-07-02 10:32:59');
INSERT INTO `access_log` VALUES (46733, '64.78.15620347833820387', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:33:03', 12, 0, '', '2019-07-02 10:33:03');
INSERT INTO `access_log` VALUES (46734, '64.83.15620347833880381', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:33:03', 9, 0, '', '2019-07-02 10:33:03');
INSERT INTO `access_log` VALUES (46735, '64.77.15620347871690373', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:33:07', 11, 0, '', '2019-07-02 10:33:07');
INSERT INTO `access_log` VALUES (46736, '64.82.15620347871740395', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:33:07', 7, 0, '', '2019-07-02 10:33:07');
INSERT INTO `access_log` VALUES (46737, '66.55.15620347926978423', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:33:13', 13, 0, '', '2019-07-02 10:33:13');
INSERT INTO `access_log` VALUES (46738, '59.80.15620347944290273', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:33:14', 12, 0, '', '2019-07-02 10:33:14');
INSERT INTO `access_log` VALUES (46739, '65.49.15620347979741659', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:33:18', 26, 0, '', '2019-07-02 10:33:18');
INSERT INTO `access_log` VALUES (46740, '65.53.15620347996591665', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:33:20', 24, 0, '', '2019-07-02 10:33:20');
INSERT INTO `access_log` VALUES (46741, '65.51.15620348007101705', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:33:21', 10, 0, '', '2019-07-02 10:33:21');
INSERT INTO `access_log` VALUES (46742, '65.46.15620348017751715', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.48.96.195', '2019-07-02 10:33:22', 14, 0, '', '2019-07-02 10:33:22');
INSERT INTO `access_log` VALUES (46743, '59.78.15620356551500293', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '123.112.134.230', '2019-07-02 10:47:35', 2, 0, '', '2019-07-02 10:47:35');
INSERT INTO `access_log` VALUES (46744, '59.80.15620356551510285', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '123.112.134.230', '2019-07-02 10:47:35', 12, 2001001000, '服务端发生异常', '2019-07-02 10:47:35');
INSERT INTO `access_log` VALUES (46745, '64.82.15620356586780407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '123.112.134.230', '2019-07-02 10:47:39', 2, 0, '', '2019-07-02 10:47:39');
INSERT INTO `access_log` VALUES (46746, '64.77.15620356587930385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '123.112.134.230', '2019-07-02 10:47:39', 2, 0, '', '2019-07-02 10:47:39');
INSERT INTO `access_log` VALUES (46747, '64.76.15620356602290391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '123.112.134.230', '2019-07-02 10:47:40', 2, 0, '', '2019-07-02 10:47:40');
INSERT INTO `access_log` VALUES (46748, '64.81.15620356606840395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '123.112.134.230', '2019-07-02 10:47:41', 2, 0, '', '2019-07-02 10:47:41');
INSERT INTO `access_log` VALUES (46749, '59.75.15620356633710305', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '123.112.134.230', '2019-07-02 10:47:43', 2, 0, '', '2019-07-02 10:47:43');
INSERT INTO `access_log` VALUES (46750, '59.74.15620356633740303', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '123.112.134.230', '2019-07-02 10:47:43', 41, 2001001000, '服务端发生异常', '2019-07-02 10:47:43');
INSERT INTO `access_log` VALUES (46751, '65.54.15620356770701629', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.112.134.230', '2019-07-02 10:47:57', 1, 1002001015, '账号未登陆', '2019-07-02 10:47:57');
INSERT INTO `access_log` VALUES (46752, '65.46.15620356770701727', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.112.134.230', '2019-07-02 10:47:57', 1, 1002001015, '账号未登陆', '2019-07-02 10:47:57');
INSERT INTO `access_log` VALUES (46753, '65.50.15620356770721689', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.112.134.230', '2019-07-02 10:47:57', 1, 1002001015, '账号未登陆', '2019-07-02 10:47:57');
INSERT INTO `access_log` VALUES (46754, '65.45.15620356791301669', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.112.134.230', '2019-07-02 10:47:59', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 10:47:59');
INSERT INTO `access_log` VALUES (46755, '65.52.15620356838761703', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.112.134.230', '2019-07-02 10:48:04', 82, 0, '', '2019-07-02 10:48:04');
INSERT INTO `access_log` VALUES (46756, '65.3607.15620356863063465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.112.134.230', '2019-07-02 10:48:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 10:48:06');
INSERT INTO `access_log` VALUES (46757, '65.54.15620360691291635', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-07-02 10:54:29', 3, 1002001012, '访问令牌已过期', '2019-07-02 10:54:29');
INSERT INTO `access_log` VALUES (46758, '65.52.15620360691311709', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-07-02 10:54:29', 3, 1002001012, '访问令牌已过期', '2019-07-02 10:54:29');
INSERT INTO `access_log` VALUES (46759, '65.45.15620360691301675', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-07-02 10:54:29', 3, 1002001012, '访问令牌已过期', '2019-07-02 10:54:29');
INSERT INTO `access_log` VALUES (46760, '65.3607.15620360707323471', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-07-02 10:54:31', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 10:54:31');
INSERT INTO `access_log` VALUES (46761, '65.49.15620360910971679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-07-02 10:54:51', 253, 0, '', '2019-07-02 10:54:51');
INSERT INTO `access_log` VALUES (46762, '65.53.15620360915371685', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-07-02 10:54:52', 9, 0, '', '2019-07-02 10:54:52');
INSERT INTO `access_log` VALUES (46763, '65.51.15620360915381725', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-07-02 10:54:52', 11, 2001001000, '服务端发生异常', '2019-07-02 10:54:52');
INSERT INTO `access_log` VALUES (46764, '65.46.15620360915431735', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-07-02 10:54:52', 9, 0, '', '2019-07-02 10:54:52');
INSERT INTO `access_log` VALUES (46765, '65.54.15620360992311637', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-07-02 10:54:59', 16, 0, '', '2019-07-02 10:54:59');
INSERT INTO `access_log` VALUES (46766, '65.52.15620360992311711', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-07-02 10:54:59', 17, 2001001000, '服务端发生异常', '2019-07-02 10:54:59');
INSERT INTO `access_log` VALUES (46767, '65.45.15620360992401677', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-07-02 10:54:59', 9, 0, '', '2019-07-02 10:54:59');
INSERT INTO `access_log` VALUES (46768, '65.47.15620361108231657', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-07-02 10:55:11', 9, 0, '', '2019-07-02 10:55:11');
INSERT INTO `access_log` VALUES (46769, '65.51.15620361108231727', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-07-02 10:55:11', 9, 0, '', '2019-07-02 10:55:11');
INSERT INTO `access_log` VALUES (46770, '65.49.15620361108231681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '180.170.74.146', '2019-07-02 10:55:11', 11, 2001001000, '服务端发生异常', '2019-07-02 10:55:11');
INSERT INTO `access_log` VALUES (46771, '65.45.15620361930501679', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '58.246.221.61', '2019-07-02 10:56:33', 0, 1002001015, '账号未登陆', '2019-07-02 10:56:33');
INSERT INTO `access_log` VALUES (46772, '59.75.15620362262930313', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:06', 10, 0, '', '2019-07-02 10:57:06');
INSERT INTO `access_log` VALUES (46773, '59.74.15620362262930311', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:06', 23, 2001001000, '服务端发生异常', '2019-07-02 10:57:06');
INSERT INTO `access_log` VALUES (46774, '64.76.15620362310170399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:11', 2, 0, '', '2019-07-02 10:57:11');
INSERT INTO `access_log` VALUES (46775, '64.81.15620362311910403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:11', 1, 0, '', '2019-07-02 10:57:11');
INSERT INTO `access_log` VALUES (46776, '64.84.15620362343580401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:14', 2, 0, '', '2019-07-02 10:57:14');
INSERT INTO `access_log` VALUES (46777, '64.80.15620362360080411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:16', 2, 0, '', '2019-07-02 10:57:16');
INSERT INTO `access_log` VALUES (46778, '59.73.15620362384260313', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:18', 2, 0, '', '2019-07-02 10:57:18');
INSERT INTO `access_log` VALUES (46779, '59.76.15620362384260301', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:18', 13, 2001001000, '服务端发生异常', '2019-07-02 10:57:18');
INSERT INTO `access_log` VALUES (46780, '59.79.15620362442640313', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:24', 2, 0, '', '2019-07-02 10:57:24');
INSERT INTO `access_log` VALUES (46781, '59.72.15620362442650309', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:24', 12, 2001001000, '服务端发生异常', '2019-07-02 10:57:24');
INSERT INTO `access_log` VALUES (46782, '64.78.15620362487310409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:29', 2, 0, '', '2019-07-02 10:57:29');
INSERT INTO `access_log` VALUES (46783, '64.83.15620362488750403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:29', 2, 0, '', '2019-07-02 10:57:29');
INSERT INTO `access_log` VALUES (46784, '59.71.15620362504230309', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:30', 2, 0, '', '2019-07-02 10:57:30');
INSERT INTO `access_log` VALUES (46785, '59.78.15620362504300303', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:30', 9, 2001001000, '服务端发生异常', '2019-07-02 10:57:30');
INSERT INTO `access_log` VALUES (46786, '65.53.15620362647351689', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:45', 1, 1002001015, '账号未登陆', '2019-07-02 10:57:45');
INSERT INTO `access_log` VALUES (46787, '65.50.15620362647481701', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:45', 0, 1002001015, '账号未登陆', '2019-07-02 10:57:45');
INSERT INTO `access_log` VALUES (46788, '65.52.15620362647641715', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:45', 0, 1002001015, '账号未登陆', '2019-07-02 10:57:45');
INSERT INTO `access_log` VALUES (46789, '65.54.15620362668831641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 10:57:47');
INSERT INTO `access_log` VALUES (46790, '65.45.15620362705311681', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 10:57:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 10:57:51');
INSERT INTO `access_log` VALUES (46791, '65.45.15620363991931683', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '223.166.151.197', '2019-07-02 10:59:59', 0, 1002001015, '账号未登陆', '2019-07-02 10:59:59');
INSERT INTO `access_log` VALUES (46792, '65.46.15620364569571743', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 11:00:57', 339, 0, '', '2019-07-02 11:00:57');
INSERT INTO `access_log` VALUES (46793, '65.53.15620364578001693', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 11:00:58', 9, 0, '', '2019-07-02 11:00:58');
INSERT INTO `access_log` VALUES (46794, '65.50.15620364578071705', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 11:00:58', 9, 2001001000, '服务端发生异常', '2019-07-02 11:00:58');
INSERT INTO `access_log` VALUES (46795, '65.52.15620364578161719', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.119.72.100', '2019-07-02 11:00:58', 8, 0, '', '2019-07-02 11:00:58');
INSERT INTO `access_log` VALUES (46796, '65.50.15620367284651709', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:05:28', 1, 1002001015, '账号未登陆', '2019-07-02 11:05:28');
INSERT INTO `access_log` VALUES (46797, '65.53.15620367284651697', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:05:28', 1, 1002001015, '账号未登陆', '2019-07-02 11:05:28');
INSERT INTO `access_log` VALUES (46798, '65.54.15620367284701649', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:05:28', 0, 1002001015, '账号未登陆', '2019-07-02 11:05:28');
INSERT INTO `access_log` VALUES (46799, '65.45.15620367300631689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:05:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 11:05:30');
INSERT INTO `access_log` VALUES (46800, '65.3607.15620367320863485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:05:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 11:05:32');
INSERT INTO `access_log` VALUES (46801, '65.49.15620367330371693', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:05:33', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 11:05:33');
INSERT INTO `access_log` VALUES (46802, '65.51.15620367512151739', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:05:51', 85, 0, '', '2019-07-02 11:05:51');
INSERT INTO `access_log` VALUES (46803, '65.46.15620367515731749', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:05:52', 10, 0, '', '2019-07-02 11:05:52');
INSERT INTO `access_log` VALUES (46804, '65.52.15620367515801725', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:05:52', 10, 2001001000, '服务端发生异常', '2019-07-02 11:05:52');
INSERT INTO `access_log` VALUES (46805, '65.50.15620367515831711', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:05:52', 9, 0, '', '2019-07-02 11:05:52');
INSERT INTO `access_log` VALUES (46806, '65.54.15620367591651651', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:05:59', 17, 0, '', '2019-07-02 11:05:59');
INSERT INTO `access_log` VALUES (46807, '65.45.15620367591671691', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:05:59', 16, 2001001000, '服务端发生异常', '2019-07-02 11:05:59');
INSERT INTO `access_log` VALUES (46808, '65.3607.15620367591703487', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:05:59', 9, 0, '', '2019-07-02 11:05:59');
INSERT INTO `access_log` VALUES (46809, '65.49.15620367681191695', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:06:08', 8, 0, '', '2019-07-02 11:06:08');
INSERT INTO `access_log` VALUES (46810, '65.47.15620367681231671', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:06:08', 8, 2001001000, '服务端发生异常', '2019-07-02 11:06:08');
INSERT INTO `access_log` VALUES (46811, '65.51.15620367681271741', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:06:08', 9, 0, '', '2019-07-02 11:06:08');
INSERT INTO `access_log` VALUES (46812, '65.52.15620367730501727', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:06:13', 9, 0, '', '2019-07-02 11:06:13');
INSERT INTO `access_log` VALUES (46813, '65.50.15620367730531713', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:06:13', 9, 2001001000, '服务端发生异常', '2019-07-02 11:06:13');
INSERT INTO `access_log` VALUES (46814, '65.53.15620367730551701', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:06:13', 8, 0, '', '2019-07-02 11:06:13');
INSERT INTO `access_log` VALUES (46815, '65.54.15620367767211653', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:06:17', 9, 0, '', '2019-07-02 11:06:17');
INSERT INTO `access_log` VALUES (46816, '65.3607.15620367767243489', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:06:17', 10, 2001001000, '服务端发生异常', '2019-07-02 11:06:17');
INSERT INTO `access_log` VALUES (46817, '65.45.15620367767271693', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-02 11:06:17', 10, 0, '', '2019-07-02 11:06:17');
INSERT INTO `access_log` VALUES (46818, '65.3607.15620370245573493', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.221', '2019-07-02 11:10:25', 0, 1002001015, '账号未登陆', '2019-07-02 11:10:25');
INSERT INTO `access_log` VALUES (46819, '65.45.15620370245581697', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.221', '2019-07-02 11:10:25', 0, 1002001015, '账号未登陆', '2019-07-02 11:10:25');
INSERT INTO `access_log` VALUES (46820, '65.54.15620370245611657', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.221', '2019-07-02 11:10:25', 1, 1002001015, '账号未登陆', '2019-07-02 11:10:25');
INSERT INTO `access_log` VALUES (46821, '65.47.15620370417701677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.221', '2019-07-02 11:10:42', 82, 0, '', '2019-07-02 11:10:42');
INSERT INTO `access_log` VALUES (46822, '65.49.15620370421691701', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.221', '2019-07-02 11:10:42', 9, 0, '', '2019-07-02 11:10:42');
INSERT INTO `access_log` VALUES (46823, '65.52.15620370421761733', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.221', '2019-07-02 11:10:42', 9, 0, '', '2019-07-02 11:10:42');
INSERT INTO `access_log` VALUES (46824, '65.46.15620370421711757', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.74.221', '2019-07-02 11:10:42', 105, 2001001000, '服务端发生异常', '2019-07-02 11:10:42');
INSERT INTO `access_log` VALUES (46825, '59.77.15620372010220309', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:13:21', 19, 2001001000, '服务端发生异常', '2019-07-02 11:13:21');
INSERT INTO `access_log` VALUES (46826, '59.76.15620372010220315', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:13:21', 108, 0, '', '2019-07-02 11:13:21');
INSERT INTO `access_log` VALUES (46827, '64.81.15620372069480417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:13:27', 2, 0, '', '2019-07-02 11:13:27');
INSERT INTO `access_log` VALUES (46828, '64.84.15620372070670415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:13:27', 2, 0, '', '2019-07-02 11:13:27');
INSERT INTO `access_log` VALUES (46829, '64.80.15620372086070425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:13:29', 2, 0, '', '2019-07-02 11:13:29');
INSERT INTO `access_log` VALUES (46830, '64.79.15620372090390431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:13:29', 2, 0, '', '2019-07-02 11:13:29');
INSERT INTO `access_log` VALUES (46831, '64.78.15620372094640423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:13:29', 2, 0, '', '2019-07-02 11:13:29');
INSERT INTO `access_log` VALUES (46832, '66.50.15620372291498473', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13612345678', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:13:49', 123, 0, '', '2019-07-02 11:13:49');
INSERT INTO `access_log` VALUES (46833, '66.49.15620372324868485', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13612345678&code=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:13:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码长度为 4-6 位', '2019-07-02 11:13:52');
INSERT INTO `access_log` VALUES (46834, '66.57.15620372357038475', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13612345678&code=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:13:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码长度为 4-6 位', '2019-07-02 11:13:56');
INSERT INTO `access_log` VALUES (46835, '66.56.15620372410378481', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13612345678&code=1222', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:14:01', 7, 1001003003, '验证码不正确', '2019-07-02 11:14:01');
INSERT INTO `access_log` VALUES (46836, '66.52.15620372484308475', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13612345678&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:14:08', 266, 0, '', '2019-07-02 11:14:09');
INSERT INTO `access_log` VALUES (46837, '64.76.15620372564450415', 150, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:14:16', 4, 0, '', '2019-07-02 11:14:16');
INSERT INTO `access_log` VALUES (46838, '64.84.15620372566110417', 150, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:14:17', 6, 0, '', '2019-07-02 11:14:17');
INSERT INTO `access_log` VALUES (46839, '64.80.15620372599190427', 150, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:14:20', 5, 0, '', '2019-07-02 11:14:20');
INSERT INTO `access_log` VALUES (46840, '64.79.15620372600540433', 150, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:14:20', 4, 0, '', '2019-07-02 11:14:20');
INSERT INTO `access_log` VALUES (46841, '59.74.15620372617150327', 150, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:14:22', 6, 0, '', '2019-07-02 11:14:22');
INSERT INTO `access_log` VALUES (46842, '59.73.15620372617200329', 150, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:14:22', 15, 2001001000, '服务端发生异常', '2019-07-02 11:14:22');
INSERT INTO `access_log` VALUES (46843, '64.83.15620372640570419', 150, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:14:24', 5, 0, '', '2019-07-02 11:14:24');
INSERT INTO `access_log` VALUES (46844, '64.85.15620372643330439', 150, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:14:24', 5, 0, '', '2019-07-02 11:14:24');
INSERT INTO `access_log` VALUES (46845, '59.76.15620372683040317', 150, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:14:28', 7, 0, '', '2019-07-02 11:14:28');
INSERT INTO `access_log` VALUES (46846, '59.77.15620372683040311', 150, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '116.22.132.76', '2019-07-02 11:14:28', 16, 2001001000, '服务端发生异常', '2019-07-02 11:14:28');
INSERT INTO `access_log` VALUES (46847, '65.47.15620374401631683', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.129.6.227', '2019-07-02 11:17:20', 1, 1002001015, '账号未登陆', '2019-07-02 11:17:20');
INSERT INTO `access_log` VALUES (46848, '65.3607.15620375185843501', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:18:39', 4, 1002001012, '访问令牌已过期', '2019-07-02 11:18:39');
INSERT INTO `access_log` VALUES (46849, '65.54.15620375185831665', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:18:39', 4, 1002001012, '访问令牌已过期', '2019-07-02 11:18:39');
INSERT INTO `access_log` VALUES (46850, '65.45.15620375185871705', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:18:39', 3, 1002001012, '访问令牌已过期', '2019-07-02 11:18:39');
INSERT INTO `access_log` VALUES (46851, '65.47.15620375277741685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:18:48', 88, 0, '', '2019-07-02 11:18:48');
INSERT INTO `access_log` VALUES (46852, '65.49.15620375280711709', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:18:48', 9, 0, '', '2019-07-02 11:18:48');
INSERT INTO `access_log` VALUES (46853, '65.52.15620375280741741', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:18:48', 8, 0, '', '2019-07-02 11:18:48');
INSERT INTO `access_log` VALUES (46854, '65.46.15620375280771765', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:18:48', 9, 0, '', '2019-07-02 11:18:48');
INSERT INTO `access_log` VALUES (46855, '64.85.15620375322000443', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:18:52', 9, 0, '', '2019-07-02 11:18:52');
INSERT INTO `access_log` VALUES (46856, '64.83.15620375321980423', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:18:52', 13, 0, '', '2019-07-02 11:18:52');
INSERT INTO `access_log` VALUES (46857, '64.76.15620375721030421', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=3333', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:19:32', 102, 0, '', '2019-07-02 11:19:32');
INSERT INTO `access_log` VALUES (46858, '64.81.15620375723440425', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:19:32', 12, 0, '', '2019-07-02 11:19:32');
INSERT INTO `access_log` VALUES (46859, '59.80.15620376332330315', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.1.23', '2019-07-02 11:20:33', 3, 0, '', '2019-07-02 11:20:33');
INSERT INTO `access_log` VALUES (46860, '59.75.15620376332520335', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.1.23', '2019-07-02 11:20:33', 13, 2001001000, '服务端发生异常', '2019-07-02 11:20:33');
INSERT INTO `access_log` VALUES (46861, '64.85.15620376360460445', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:20:36', 16, 0, '', '2019-07-02 11:20:36');
INSERT INTO `access_log` VALUES (46862, '64.82.15620376360470439', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:20:36', 15, 0, '', '2019-07-02 11:20:36');
INSERT INTO `access_log` VALUES (46863, '64.77.15620376381730417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:38', 2, 0, '', '2019-07-02 11:20:38');
INSERT INTO `access_log` VALUES (46864, '64.76.15620376383600423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:38', 2, 0, '', '2019-07-02 11:20:38');
INSERT INTO `access_log` VALUES (46865, '64.84.15620376387690425', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:20:39', 10, 0, '', '2019-07-02 11:20:39');
INSERT INTO `access_log` VALUES (46866, '64.81.15620376387690427', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:20:39', 13, 0, '', '2019-07-02 11:20:39');
INSERT INTO `access_log` VALUES (46867, '64.80.15620376387990435', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:20:39', 9, 0, '', '2019-07-02 11:20:39');
INSERT INTO `access_log` VALUES (46868, '64.79.15620376397950441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:40', 2, 0, '', '2019-07-02 11:20:40');
INSERT INTO `access_log` VALUES (46869, '64.78.15620376406880433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:41', 2, 0, '', '2019-07-02 11:20:41');
INSERT INTO `access_log` VALUES (46870, '64.83.15620376416220427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:42', 2, 0, '', '2019-07-02 11:20:42');
INSERT INTO `access_log` VALUES (46871, '64.85.15620376425400447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:43', 2, 0, '', '2019-07-02 11:20:43');
INSERT INTO `access_log` VALUES (46872, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:43', 6, 0, '', '2019-07-02 11:20:43');
INSERT INTO `access_log` VALUES (46873, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:44', 5, 0, '', '2019-07-02 11:20:44');
INSERT INTO `access_log` VALUES (46874, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:45', 5, 0, '', '2019-07-02 11:20:45');
INSERT INTO `access_log` VALUES (46875, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:46', 5, 0, '', '2019-07-02 11:20:46');
INSERT INTO `access_log` VALUES (46876, '64.82.15620376470890441', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:47', 7, 0, '', '2019-07-02 11:20:47');
INSERT INTO `access_log` VALUES (46877, '65.52.15620376495381743', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:20:50', 9, 0, '', '2019-07-02 11:20:50');
INSERT INTO `access_log` VALUES (46878, '65.49.15620376495401711', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:20:50', 9, 0, '', '2019-07-02 11:20:50');
INSERT INTO `access_log` VALUES (46879, '65.53.15620376495411717', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:20:50', 9, 0, '', '2019-07-02 11:20:50');
INSERT INTO `access_log` VALUES (46880, '64.76.15620376497020425', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:20:50', 11, 0, '', '2019-07-02 11:20:50');
INSERT INTO `access_log` VALUES (46881, '64.81.15620376497060429', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:20:50', 9, 0, '', '2019-07-02 11:20:50');
INSERT INTO `access_log` VALUES (46882, '64.77.15620376497020419', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:20:50', 15, 0, '', '2019-07-02 11:20:50');
INSERT INTO `access_log` VALUES (46883, '66.56.15620376527418487', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空', '2019-07-02 11:20:53');
INSERT INTO `access_log` VALUES (46884, '64.80.15620376552040437', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:55', 10, 0, '', '2019-07-02 11:20:55');
INSERT INTO `access_log` VALUES (46885, '64.79.15620376557300443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:56', 3, 0, '', '2019-07-02 11:20:56');
INSERT INTO `access_log` VALUES (46886, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:56', 8, 0, '', '2019-07-02 11:20:56');
INSERT INTO `access_log` VALUES (46887, '64.78.15620376562640435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:56', 2, 0, '', '2019-07-02 11:20:56');
INSERT INTO `access_log` VALUES (46888, '64.83.15620376564730429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:56', 2, 0, '', '2019-07-02 11:20:56');
INSERT INTO `access_log` VALUES (46889, '64.85.15620376591510449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:59', 2, 0, '', '2019-07-02 11:20:59');
INSERT INTO `access_log` VALUES (46890, '64.82.15620376593460443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:20:59', 2, 0, '', '2019-07-02 11:20:59');
INSERT INTO `access_log` VALUES (46891, '59.77.15620376642620317', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:21:04', 2, 0, '', '2019-07-02 11:21:04');
INSERT INTO `access_log` VALUES (46892, '59.72.15620376642630331', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:21:04', 10, 2001001000, '服务端发生异常', '2019-07-02 11:21:04');
INSERT INTO `access_log` VALUES (46893, '64.77.15620376664850421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:21:06', 2, 0, '', '2019-07-02 11:21:06');
INSERT INTO `access_log` VALUES (46894, '64.81.15620376666510431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:21:07', 2, 0, '', '2019-07-02 11:21:07');
INSERT INTO `access_log` VALUES (46895, '62.86.15620376990149749', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:21:39', 28, 0, '', '2019-07-02 11:21:39');
INSERT INTO `access_log` VALUES (46896, '62.84.15620377103929749', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:21:50', 16, 0, '', '2019-07-02 11:21:50');
INSERT INTO `access_log` VALUES (46897, '64.83.15620377232680431', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:22:03', 9, 0, '', '2019-07-02 11:22:03');
INSERT INTO `access_log` VALUES (46898, '64.78.15620377232670437', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:22:03', 12, 0, '', '2019-07-02 11:22:03');
INSERT INTO `access_log` VALUES (46899, '64.85.15620377253410451', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:22:05', 9, 0, '', '2019-07-02 11:22:05');
INSERT INTO `access_log` VALUES (46900, '65.52.15620377575071745', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:22:38', 14, 0, '', '2019-07-02 11:22:38');
INSERT INTO `access_log` VALUES (46901, '65.3607.15620377927123507', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:23:13', 19, 0, '', '2019-07-02 11:23:13');
INSERT INTO `access_log` VALUES (46902, '59.72.15620378023210333', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:23:22', 21, 2001001000, '服务端发生异常', '2019-07-02 11:23:22');
INSERT INTO `access_log` VALUES (46903, '59.71.15620378154050333', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:23:35', 11, 0, '', '2019-07-02 11:23:35');
INSERT INTO `access_log` VALUES (46904, '62.81.15620378250289739', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:23:45', 15, 0, '', '2019-07-02 11:23:45');
INSERT INTO `access_log` VALUES (46905, '64.85.15620378306910453', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:23:51', 10, 0, '', '2019-07-02 11:23:51');
INSERT INTO `access_log` VALUES (46906, '64.83.15620378306910433', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:23:51', 11, 0, '', '2019-07-02 11:23:51');
INSERT INTO `access_log` VALUES (46907, '64.80.15620380548540445', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:27:35', 11, 0, '', '2019-07-02 11:27:35');
INSERT INTO `access_log` VALUES (46908, '64.84.15620380548540435', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:27:35', 13, 0, '', '2019-07-02 11:27:35');
INSERT INTO `access_log` VALUES (46909, '64.78.15620380566660443', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:27:37', 9, 0, '', '2019-07-02 11:27:37');
INSERT INTO `access_log` VALUES (46910, '64.85.15620380625760457', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:27:43', 9, 0, '', '2019-07-02 11:27:43');
INSERT INTO `access_log` VALUES (46911, '64.83.15620380648820437', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:27:45', 12, 0, '', '2019-07-02 11:27:45');
INSERT INTO `access_log` VALUES (46912, '64.76.15620380663800435', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:27:46', 9, 0, '', '2019-07-02 11:27:46');
INSERT INTO `access_log` VALUES (46913, '64.82.15620380663790451', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:27:46', 11, 0, '', '2019-07-02 11:27:46');
INSERT INTO `access_log` VALUES (46914, '64.77.15620380697390429', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:27:50', 9, 0, '', '2019-07-02 11:27:50');
INSERT INTO `access_log` VALUES (46915, '64.76.15620383079560439', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:31:48', 11, 0, '', '2019-07-02 11:31:48');
INSERT INTO `access_log` VALUES (46916, '64.83.15620383079560441', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:31:48', 13, 0, '', '2019-07-02 11:31:48');
INSERT INTO `access_log` VALUES (46917, '64.78.15620383953490449', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=123', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:33:15', 73, 0, '', '2019-07-02 11:33:15');
INSERT INTO `access_log` VALUES (46918, '64.85.15620383955770463', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:33:16', 11, 0, '', '2019-07-02 11:33:16');
INSERT INTO `access_log` VALUES (46919, '65.3607.15620384168123515', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:33:37', 4, 0, '', '2019-07-02 11:33:37');
INSERT INTO `access_log` VALUES (46920, '65.51.15620384440441769', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:34:04', 3, 0, '', '2019-07-02 11:34:04');
INSERT INTO `access_log` VALUES (46921, '64.77.15620385848570437', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=111&sellPoint=111&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/f97c1bce-48ff-4b26-8d34-d38137a306dd&skuStr=[{\"attrs\":[1,3],\"price\":111100,\"quantity\":1111},{\"attrs\":[2,3],\"price\":111100,\"quantity\":1111}]&description=<p>123</p><div class=\"media-wrap image-wrap align-center\" style=\"text-align:center\"><img src=\"http://static.shop.iocoder.cn/57aa3c2a-56d7-4491-92b4-61c2461b3412\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:36:25', 908, 2001001000, '服务端发生异常', '2019-07-02 11:36:26');
INSERT INTO `access_log` VALUES (46922, '64.84.15620385985330445', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=111&sellPoint=111&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/f97c1bce-48ff-4b26-8d34-d38137a306dd&skuStr=[{\"attrs\":[1,3],\"price\":111100,\"quantity\":1111},{\"attrs\":[2,3],\"price\":111100,\"quantity\":1111}]&description=<p>123</p><div class=\"media-wrap image-wrap align-center\" style=\"text-align:center\"><img src=\"http://static.shop.iocoder.cn/57aa3c2a-56d7-4491-92b4-61c2461b3412\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:36:39', 309, 2001001000, '服务端发生异常', '2019-07-02 11:36:39');
INSERT INTO `access_log` VALUES (46923, '64.76.15620386728860445', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=111&sellPoint=111&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/f97c1bce-48ff-4b26-8d34-d38137a306dd&skuStr=[{\"attrs\":[1,3,6],\"price\":11100,\"quantity\":111},{\"attrs\":[2,3,6],\"price\":11100,\"quantity\":111}]&description=<p>123</p><div class=\"media-wrap image-wrap align-center\" style=\"text-align:center\"><img src=\"http://static.shop.iocoder.cn/57aa3c2a-56d7-4491-92b4-61c2461b3412\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:37:53', 356, 2001001000, '服务端发生异常', '2019-07-02 11:37:53');
INSERT INTO `access_log` VALUES (46924, '59.77.15620394056310341', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:50:06', 3, 0, '', '2019-07-02 11:50:06');
INSERT INTO `access_log` VALUES (46925, '59.72.15620394056320355', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:50:06', 13, 2001001000, '服务端发生异常', '2019-07-02 11:50:06');
INSERT INTO `access_log` VALUES (46926, '64.82.15620394255340471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:50:26', 3, 0, '', '2019-07-02 11:50:26');
INSERT INTO `access_log` VALUES (46927, '64.77.15620394256310449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:50:26', 2, 0, '', '2019-07-02 11:50:26');
INSERT INTO `access_log` VALUES (46928, '64.81.15620394272100459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:50:27', 3, 0, '', '2019-07-02 11:50:27');
INSERT INTO `access_log` VALUES (46929, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:50:27', 6, 0, '', '2019-07-02 11:50:27');
INSERT INTO `access_log` VALUES (46930, '64.84.15620394284180457', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:50:28', 7, 0, '', '2019-07-02 11:50:28');
INSERT INTO `access_log` VALUES (46931, '64.82.15620395208480473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:01', 3, 0, '', '2019-07-02 11:52:01');
INSERT INTO `access_log` VALUES (46932, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:01', 6, 0, '', '2019-07-02 11:52:01');
INSERT INTO `access_log` VALUES (46933, '64.77.15620395220740451', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:02', 6, 0, '', '2019-07-02 11:52:02');
INSERT INTO `access_log` VALUES (46934, '64.84.15620395320430459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:12', 2, 0, '', '2019-07-02 11:52:12');
INSERT INTO `access_log` VALUES (46935, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:12', 6, 0, '', '2019-07-02 11:52:12');
INSERT INTO `access_log` VALUES (46936, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:13', 6, 0, '', '2019-07-02 11:52:13');
INSERT INTO `access_log` VALUES (46937, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:14', 5, 0, '', '2019-07-02 11:52:14');
INSERT INTO `access_log` VALUES (46938, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:15', 6, 0, '', '2019-07-02 11:52:15');
INSERT INTO `access_log` VALUES (46939, '64.80.15620395370520469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:17', 2, 0, '', '2019-07-02 11:52:17');
INSERT INTO `access_log` VALUES (46940, '64.79.15620395371510475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:17', 2, 0, '', '2019-07-02 11:52:17');
INSERT INTO `access_log` VALUES (46941, '64.78.15620395382810467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:18', 2, 0, '', '2019-07-02 11:52:18');
INSERT INTO `access_log` VALUES (46942, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:18', 6, 0, '', '2019-07-02 11:52:18');
INSERT INTO `access_log` VALUES (46943, '64.85.15620395394010481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:19', 2, 0, '', '2019-07-02 11:52:19');
INSERT INTO `access_log` VALUES (46944, '64.83.15620395395120461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:20', 2, 0, '', '2019-07-02 11:52:20');
INSERT INTO `access_log` VALUES (46945, '64.76.15620395400680459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:20', 1, 0, '', '2019-07-02 11:52:20');
INSERT INTO `access_log` VALUES (46946, '64.77.15620395410890453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:21', 2, 0, '', '2019-07-02 11:52:21');
INSERT INTO `access_log` VALUES (46947, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:21', 6, 0, '', '2019-07-02 11:52:21');
INSERT INTO `access_log` VALUES (46948, '64.81.15620395426910463', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:52:23', 7, 0, '', '2019-07-02 11:52:23');
INSERT INTO `access_log` VALUES (46949, '64.78.15620395874190469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:53:07', 2, 0, '', '2019-07-02 11:53:07');
INSERT INTO `access_log` VALUES (46950, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:53:07', 6, 0, '', '2019-07-02 11:53:07');
INSERT INTO `access_log` VALUES (46951, '64.85.15620395914820483', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:53:11', 6, 0, '', '2019-07-02 11:53:11');
INSERT INTO `access_log` VALUES (46952, '64.83.15620395956070463', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:53:16', 2, 0, '', '2019-07-02 11:53:16');
INSERT INTO `access_log` VALUES (46953, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:53:16', 7, 0, '', '2019-07-02 11:53:16');
INSERT INTO `access_log` VALUES (46954, '64.76.15620395969510461', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:53:17', 6, 0, '', '2019-07-02 11:53:17');
INSERT INTO `access_log` VALUES (46955, '64.81.15620396274350465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:53:47', 3, 0, '', '2019-07-02 11:53:47');
INSERT INTO `access_log` VALUES (46956, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:53:47', 7, 0, '', '2019-07-02 11:53:47');
INSERT INTO `access_log` VALUES (46957, '64.84.15620396297980463', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:53:50', 8, 0, '', '2019-07-02 11:53:50');
INSERT INTO `access_log` VALUES (46958, '64.85.15620396620650485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:54:22', 2, 0, '', '2019-07-02 11:54:22');
INSERT INTO `access_log` VALUES (46959, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:54:22', 6, 0, '', '2019-07-02 11:54:22');
INSERT INTO `access_log` VALUES (46960, '64.83.15620396634260465', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:54:23', 6, 0, '', '2019-07-02 11:54:23');
INSERT INTO `access_log` VALUES (46961, '64.82.15620396811480479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:54:41', 2, 0, '', '2019-07-02 11:54:41');
INSERT INTO `access_log` VALUES (46962, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:54:41', 6, 0, '', '2019-07-02 11:54:41');
INSERT INTO `access_log` VALUES (46963, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:54:43', 6, 0, '', '2019-07-02 11:54:43');
INSERT INTO `access_log` VALUES (46964, '64.77.15620396842040457', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:54:44', 6, 0, '', '2019-07-02 11:54:44');
INSERT INTO `access_log` VALUES (46965, '64.80.15620397118280475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:55:12', 2, 0, '', '2019-07-02 11:55:12');
INSERT INTO `access_log` VALUES (46966, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:55:12', 6, 0, '', '2019-07-02 11:55:12');
INSERT INTO `access_log` VALUES (46967, '64.79.15620397130590481', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 11:55:13', 6, 0, '', '2019-07-02 11:55:13');
INSERT INTO `access_log` VALUES (46968, '59.79.15620398562320365', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.1.23', '2019-07-02 11:57:36', 11, 0, '', '2019-07-02 11:57:36');
INSERT INTO `access_log` VALUES (46969, '59.71.15620398562420361', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.1.23', '2019-07-02 11:57:36', 19, 2001001000, '服务端发生异常', '2019-07-02 11:57:36');
INSERT INTO `access_log` VALUES (46970, '64.78.15620398616350475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:57:42', 2, 0, '', '2019-07-02 11:57:42');
INSERT INTO `access_log` VALUES (46971, '64.85.15620398617390489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:57:42', 2, 0, '', '2019-07-02 11:57:42');
INSERT INTO `access_log` VALUES (46972, '64.83.15620398658200469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:57:46', 2, 0, '', '2019-07-02 11:57:46');
INSERT INTO `access_log` VALUES (46973, '64.76.15620398659430467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:57:46', 2, 0, '', '2019-07-02 11:57:46');
INSERT INTO `access_log` VALUES (46974, '66.57.15620398800128511', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18611966723&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:00', 19, 1001003000, '验证码不存在', '2019-07-02 11:58:00');
INSERT INTO `access_log` VALUES (46975, '66.56.15620398821868517', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18611966723', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:02', 80, 0, '', '2019-07-02 11:58:02');
INSERT INTO `access_log` VALUES (46976, '66.51.15620398844578531', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18611966723&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:04', 179, 0, '', '2019-07-02 11:58:05');
INSERT INTO `access_log` VALUES (46977, '66.54.15620398914948521', 151, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:11', 6, 0, '', '2019-07-02 11:58:12');
INSERT INTO `access_log` VALUES (46978, '66.48.15620398956548529', 151, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:16', 6, 0, '', '2019-07-02 11:58:16');
INSERT INTO `access_log` VALUES (46979, '64.84.15620398975530469', 151, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:18', 4, 0, '', '2019-07-02 11:58:18');
INSERT INTO `access_log` VALUES (46980, '64.79.15620398977020485', 151, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:18', 4, 0, '', '2019-07-02 11:58:18');
INSERT INTO `access_log` VALUES (46981, '64.85.15620398989040491', 151, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:19', 5, 0, '', '2019-07-02 11:58:19');
INSERT INTO `access_log` VALUES (46982, '64.83.15620399000710471', 151, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:20', 4, 0, '', '2019-07-02 11:58:20');
INSERT INTO `access_log` VALUES (46983, 'N/A', 151, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:20', 7, 0, '', '2019-07-02 11:58:20');
INSERT INTO `access_log` VALUES (46984, '64.82.15620399017420485', 151, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:22', 5, 0, '', '2019-07-02 11:58:22');
INSERT INTO `access_log` VALUES (46985, '64.77.15620399019610463', 151, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:22', 5, 0, '', '2019-07-02 11:58:22');
INSERT INTO `access_log` VALUES (46986, '64.84.15620399027600471', 151, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:23', 5, 0, '', '2019-07-02 11:58:23');
INSERT INTO `access_log` VALUES (46987, '64.80.15620399036490481', 151, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:24', 6, 0, '', '2019-07-02 11:58:24');
INSERT INTO `access_log` VALUES (46988, 'N/A', 151, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:24', 9, 0, '', '2019-07-02 11:58:24');
INSERT INTO `access_log` VALUES (46989, '64.78.15620399051050479', 151, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:25', 9, 0, '', '2019-07-02 11:58:25');
INSERT INTO `access_log` VALUES (46990, '66.49.15620399111448523', 151, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:31', 5, 0, '', '2019-07-02 11:58:31');
INSERT INTO `access_log` VALUES (46991, '66.51.15620399166548533', 151, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:37', 6, 0, '', '2019-07-02 11:58:37');
INSERT INTO `access_log` VALUES (46992, '66.52.15620399193288513', 151, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:39', 6, 0, '', '2019-07-02 11:58:39');
INSERT INTO `access_log` VALUES (46993, '66.55.15620399199528495', 151, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:40', 6, 0, '', '2019-07-02 11:58:40');
INSERT INTO `access_log` VALUES (46994, '64.83.15620399219210473', 151, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:42', 9, 0, '', '2019-07-02 11:58:42');
INSERT INTO `access_log` VALUES (46995, '64.76.15620399228420471', 151, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:43', 5, 0, '', '2019-07-02 11:58:43');
INSERT INTO `access_log` VALUES (46996, 'N/A', 151, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:43', 12, 0, '', '2019-07-02 11:58:43');
INSERT INTO `access_log` VALUES (46997, '64.82.15620399238820487', 151, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:44', 5, 0, '', '2019-07-02 11:58:44');
INSERT INTO `access_log` VALUES (46998, '64.77.15620399240100465', 151, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:44', 5, 0, '', '2019-07-02 11:58:44');
INSERT INTO `access_log` VALUES (46999, '64.81.15620399256810475', 151, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:46', 4, 0, '', '2019-07-02 11:58:46');
INSERT INTO `access_log` VALUES (47000, 'N/A', 151, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:46', 9, 0, '', '2019-07-02 11:58:46');
INSERT INTO `access_log` VALUES (47001, '64.79.15620399339310489', 151, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:58:54', 9, 0, '', '2019-07-02 11:58:54');
INSERT INTO `access_log` VALUES (47002, '64.78.15620399406830481', 151, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:59:01', 5, 0, '', '2019-07-02 11:59:01');
INSERT INTO `access_log` VALUES (47003, 'N/A', 151, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.1.23', '2019-07-02 11:59:01', 12, 0, '', '2019-07-02 11:59:01');
INSERT INTO `access_log` VALUES (47004, '65.49.15620422289741773', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.125.50', '2019-07-02 12:37:09', 1, 1002001015, '账号未登陆', '2019-07-02 12:37:09');
INSERT INTO `access_log` VALUES (47005, '65.53.15620422289741781', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.125.50', '2019-07-02 12:37:09', 1, 1002001015, '账号未登陆', '2019-07-02 12:37:09');
INSERT INTO `access_log` VALUES (47006, '65.50.15620422289741793', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.125.50', '2019-07-02 12:37:09', 0, 1002001015, '账号未登陆', '2019-07-02 12:37:09');
INSERT INTO `access_log` VALUES (47007, '65.45.15620422447831773', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.125.50', '2019-07-02 12:37:25', 105, 0, '', '2019-07-02 12:37:25');
INSERT INTO `access_log` VALUES (47008, '65.54.15620422453301731', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.125.50', '2019-07-02 12:37:25', 12, 0, '', '2019-07-02 12:37:25');
INSERT INTO `access_log` VALUES (47009, '65.51.15620422453331821', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.125.50', '2019-07-02 12:37:25', 12, 2001001000, '服务端发生异常', '2019-07-02 12:37:25');
INSERT INTO `access_log` VALUES (47010, '65.47.15620422453361753', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.125.50', '2019-07-02 12:37:25', 12, 0, '', '2019-07-02 12:37:25');
INSERT INTO `access_log` VALUES (47011, '59.75.15620422989030399', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.125.50', '2019-07-02 12:38:19', 10, 0, '', '2019-07-02 12:38:19');
INSERT INTO `access_log` VALUES (47012, '59.74.15620422989070397', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.125.50', '2019-07-02 12:38:19', 15, 2001001000, '服务端发生异常', '2019-07-02 12:38:19');
INSERT INTO `access_log` VALUES (47013, '65.46.15620445544271865', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.209.34.1', '2019-07-02 13:15:54', 1, 1002001015, '账号未登陆', '2019-07-02 13:15:54');
INSERT INTO `access_log` VALUES (47014, '59.76.15620451507020425', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '101.83.42.146', '2019-07-02 13:25:51', 11, 0, '', '2019-07-02 13:25:51');
INSERT INTO `access_log` VALUES (47015, '59.72.15620451507030433', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '101.83.42.146', '2019-07-02 13:25:51', 40, 2001001000, '服务端发生异常', '2019-07-02 13:25:51');
INSERT INTO `access_log` VALUES (47016, '59.75.15620452319730439', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:27:12', 3, 0, '', '2019-07-02 13:27:12');
INSERT INTO `access_log` VALUES (47017, '59.74.15620452319750437', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:27:12', 26, 2001001000, '服务端发生异常', '2019-07-02 13:27:12');
INSERT INTO `access_log` VALUES (47018, '66.56.15620452558118591', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15221507213&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:27:36', 16, 1001003000, '验证码不存在', '2019-07-02 13:27:36');
INSERT INTO `access_log` VALUES (47019, '66.51.15620452581708605', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15221507213', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:27:38', 94, 0, '', '2019-07-02 13:27:38');
INSERT INTO `access_log` VALUES (47020, '66.55.15620452754348567', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15221507213&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:27:55', 152, 0, '', '2019-07-02 13:27:56');
INSERT INTO `access_log` VALUES (47021, '66.48.15620452841928603', 152, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:04', 6, 0, '', '2019-07-02 13:28:04');
INSERT INTO `access_log` VALUES (47022, '64.80.15620452858830555', 152, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:06', 24, 0, '', '2019-07-02 13:28:06');
INSERT INTO `access_log` VALUES (47023, '64.83.15620452860280547', 152, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:06', 6, 0, '', '2019-07-02 13:28:06');
INSERT INTO `access_log` VALUES (47024, '64.76.15620452897860545', 152, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:10', 5, 0, '', '2019-07-02 13:28:10');
INSERT INTO `access_log` VALUES (47025, '64.85.15620452898990567', 152, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:10', 4, 0, '', '2019-07-02 13:28:10');
INSERT INTO `access_log` VALUES (47026, '59.80.15620452914970421', 152, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:11', 8, 0, '', '2019-07-02 13:28:12');
INSERT INTO `access_log` VALUES (47027, '59.78.15620452914960429', 152, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:11', 33, 2001001000, '服务端发生异常', '2019-07-02 13:28:12');
INSERT INTO `access_log` VALUES (47028, '64.78.15620452936430557', 152, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:14', 6, 0, '', '2019-07-02 13:28:14');
INSERT INTO `access_log` VALUES (47029, '64.77.15620452937380541', 152, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:14', 5, 0, '', '2019-07-02 13:28:14');
INSERT INTO `access_log` VALUES (47030, '64.82.15620452948150561', 152, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:15', 5, 0, '', '2019-07-02 13:28:15');
INSERT INTO `access_log` VALUES (47031, '64.80.15620452951830557', 152, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:15', 4, 0, '', '2019-07-02 13:28:15');
INSERT INTO `access_log` VALUES (47032, '59.75.15620452961010441', 152, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:16', 8, 0, '', '2019-07-02 13:28:16');
INSERT INTO `access_log` VALUES (47033, '59.74.15620452961010439', 152, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:16', 21, 2001001000, '服务端发生异常', '2019-07-02 13:28:16');
INSERT INTO `access_log` VALUES (47034, '64.83.15620453008370549', 152, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:21', 5, 0, '', '2019-07-02 13:28:21');
INSERT INTO `access_log` VALUES (47035, '64.76.15620453009410547', 152, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:21', 5, 0, '', '2019-07-02 13:28:21');
INSERT INTO `access_log` VALUES (47036, '59.76.15620453015650429', 152, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:22', 5, 0, '', '2019-07-02 13:28:22');
INSERT INTO `access_log` VALUES (47037, '59.72.15620453015660437', 152, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:22', 14, 2001001000, '服务端发生异常', '2019-07-02 13:28:22');
INSERT INTO `access_log` VALUES (47038, '64.85.15620453020110569', 152, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:22', 15, 0, '', '2019-07-02 13:28:22');
INSERT INTO `access_log` VALUES (47039, '64.78.15620453021130559', 152, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:22', 3, 0, '', '2019-07-02 13:28:22');
INSERT INTO `access_log` VALUES (47040, '66.49.15620453023738597', 152, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:22', 6, 0, '', '2019-07-02 13:28:22');
INSERT INTO `access_log` VALUES (47041, '59.77.15620453028300423', 152, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:23', 5, 0, '', '2019-07-02 13:28:23');
INSERT INTO `access_log` VALUES (47042, '59.71.15620453028300437', 152, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '101.83.42.146', '2019-07-02 13:28:23', 22, 2001001000, '服务端发生异常', '2019-07-02 13:28:23');
INSERT INTO `access_log` VALUES (47043, '65.53.15620453167301823', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.83.42.146', '2019-07-02 13:28:37', 0, 1002001015, '账号未登陆', '2019-07-02 13:28:37');
INSERT INTO `access_log` VALUES (47044, '65.49.15620453167301815', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.83.42.146', '2019-07-02 13:28:37', 0, 1002001015, '账号未登陆', '2019-07-02 13:28:37');
INSERT INTO `access_log` VALUES (47045, '65.45.15620453167371815', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.83.42.146', '2019-07-02 13:28:37', 0, 1002001015, '账号未登陆', '2019-07-02 13:28:37');
INSERT INTO `access_log` VALUES (47046, '65.50.15620453211221837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.83.42.146', '2019-07-02 13:28:41', 135, 0, '', '2019-07-02 13:28:41');
INSERT INTO `access_log` VALUES (47047, '65.54.15620453267741775', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.83.42.146', '2019-07-02 13:28:47', 90, 0, '', '2019-07-02 13:28:47');
INSERT INTO `access_log` VALUES (47048, '65.51.15620453405331865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.83.42.146', '2019-07-02 13:29:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 13:29:01');
INSERT INTO `access_log` VALUES (47049, '65.52.15620453451911849', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.83.42.146', '2019-07-02 13:29:05', 456, 0, '', '2019-07-02 13:29:06');
INSERT INTO `access_log` VALUES (47050, '65.46.15620453459151877', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.83.42.146', '2019-07-02 13:29:06', 11, 0, '', '2019-07-02 13:29:06');
INSERT INTO `access_log` VALUES (47051, '65.49.15620453459171817', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.83.42.146', '2019-07-02 13:29:06', 11, 2001001000, '服务端发生异常', '2019-07-02 13:29:06');
INSERT INTO `access_log` VALUES (47052, '65.53.15620453459231825', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.83.42.146', '2019-07-02 13:29:06', 10, 0, '', '2019-07-02 13:29:06');
INSERT INTO `access_log` VALUES (47053, '59.76.15620466027830447', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.157.168.132', '2019-07-02 13:50:03', 4, 0, '', '2019-07-02 13:50:03');
INSERT INTO `access_log` VALUES (47054, '59.72.15620466027830455', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.157.168.132', '2019-07-02 13:50:03', 20, 2001001000, '服务端发生异常', '2019-07-02 13:50:03');
INSERT INTO `access_log` VALUES (47055, '64.82.15620466089400583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.157.168.132', '2019-07-02 13:50:09', 4, 0, '', '2019-07-02 13:50:09');
INSERT INTO `access_log` VALUES (47056, '64.79.15620466092190581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.157.168.132', '2019-07-02 13:50:09', 2, 0, '', '2019-07-02 13:50:09');
INSERT INTO `access_log` VALUES (47057, '64.80.15620466117320577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.157.168.132', '2019-07-02 13:50:12', 2, 0, '', '2019-07-02 13:50:12');
INSERT INTO `access_log` VALUES (47058, '64.81.15620466118660565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.157.168.132', '2019-07-02 13:50:12', 1, 0, '', '2019-07-02 13:50:12');
INSERT INTO `access_log` VALUES (47059, '65.52.15620466406071867', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.157.168.132', '2019-07-02 13:50:41', 1, 1002001015, '账号未登陆', '2019-07-02 13:50:41');
INSERT INTO `access_log` VALUES (47060, '65.49.15620466406071835', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.157.168.132', '2019-07-02 13:50:41', 0, 1002001015, '账号未登陆', '2019-07-02 13:50:41');
INSERT INTO `access_log` VALUES (47061, '65.53.15620466406091845', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.157.168.132', '2019-07-02 13:50:41', 0, 1002001015, '账号未登陆', '2019-07-02 13:50:41');
INSERT INTO `access_log` VALUES (47062, '65.45.15620466570701837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.157.168.132', '2019-07-02 13:50:57', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 13:50:57');
INSERT INTO `access_log` VALUES (47063, '65.3607.15620466617223627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.157.168.132', '2019-07-02 13:51:02', 92, 0, '', '2019-07-02 13:51:02');
INSERT INTO `access_log` VALUES (47064, '65.50.15620466621841857', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.157.168.132', '2019-07-02 13:51:02', 10, 0, '', '2019-07-02 13:51:02');
INSERT INTO `access_log` VALUES (47065, '65.54.15620466621851795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.157.168.132', '2019-07-02 13:51:02', 11, 2001001000, '服务端发生异常', '2019-07-02 13:51:02');
INSERT INTO `access_log` VALUES (47066, '65.47.15620466621891819', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.157.168.132', '2019-07-02 13:51:02', 9, 0, '', '2019-07-02 13:51:02');
INSERT INTO `access_log` VALUES (47067, '65.49.15620481873651857', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 14:16:27', 1, 1002001015, '账号未登陆', '2019-07-02 14:16:27');
INSERT INTO `access_log` VALUES (47068, '65.52.15620481873661889', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 14:16:27', 1, 1002001015, '账号未登陆', '2019-07-02 14:16:27');
INSERT INTO `access_log` VALUES (47069, '65.46.15620481873871919', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 14:16:27', 0, 1002001015, '账号未登陆', '2019-07-02 14:16:27');
INSERT INTO `access_log` VALUES (47070, '65.45.15620481927911859', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 14:16:33', 61, 0, '', '2019-07-02 14:16:33');
INSERT INTO `access_log` VALUES (47071, '65.3607.15620481931053649', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 14:16:33', 127, 0, '', '2019-07-02 14:16:33');
INSERT INTO `access_log` VALUES (47072, '65.50.15620481931211879', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 14:16:33', 113, 0, '', '2019-07-02 14:16:33');
INSERT INTO `access_log` VALUES (47073, '65.54.15620481931131817', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 14:16:33', 121, 2001001000, '服务端发生异常', '2019-07-02 14:16:33');
INSERT INTO `access_log` VALUES (47074, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 14:24:22', 7, 0, '', '2019-07-02 14:24:22');
INSERT INTO `access_log` VALUES (47075, '64.79.15620486621910609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.32.126.186', '2019-07-02 14:24:22', 11, 0, '', '2019-07-02 14:24:22');
INSERT INTO `access_log` VALUES (47076, '65.53.15620486767821875', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 14:24:37', 4, 1002001012, '访问令牌已过期', '2019-07-02 14:24:37');
INSERT INTO `access_log` VALUES (47077, '65.46.15620486767831927', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 14:24:37', 3, 1002001012, '访问令牌已过期', '2019-07-02 14:24:37');
INSERT INTO `access_log` VALUES (47078, '65.49.15620486767911865', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 14:24:37', 3, 1002001012, '访问令牌已过期', '2019-07-02 14:24:37');
INSERT INTO `access_log` VALUES (47079, '65.45.15620486858531867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 14:24:46', 100, 0, '', '2019-07-02 14:24:46');
INSERT INTO `access_log` VALUES (47080, '65.50.15620486861901887', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 14:24:46', 136, 0, '', '2019-07-02 14:24:46');
INSERT INTO `access_log` VALUES (47081, '65.3607.15620486861873657', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 14:24:46', 138, 0, '', '2019-07-02 14:24:46');
INSERT INTO `access_log` VALUES (47082, '65.54.15620486861921825', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 14:24:46', 134, 0, '', '2019-07-02 14:24:46');
INSERT INTO `access_log` VALUES (47083, '64.83.15620486904430597', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 14:24:50', 10, 0, '', '2019-07-02 14:24:50');
INSERT INTO `access_log` VALUES (47084, '64.81.15620486904420593', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 14:24:50', 14, 0, '', '2019-07-02 14:24:50');
INSERT INTO `access_log` VALUES (47085, '65.51.15620487009901917', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 14:25:01', 3, 0, '', '2019-07-02 14:25:01');
INSERT INTO `access_log` VALUES (47086, '59.77.15620488269660471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.85.18.146', '2019-07-02 14:27:07', 11, 0, '', '2019-07-02 14:27:07');
INSERT INTO `access_log` VALUES (47087, '59.72.15620488269660485', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.85.18.146', '2019-07-02 14:27:07', 15, 2001001000, '服务端发生异常', '2019-07-02 14:27:07');
INSERT INTO `access_log` VALUES (47088, '64.81.15620488323740595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.85.18.146', '2019-07-02 14:27:12', 6, 0, '', '2019-07-02 14:27:12');
INSERT INTO `access_log` VALUES (47089, '64.85.15620488325050617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.85.18.146', '2019-07-02 14:27:13', 4, 0, '', '2019-07-02 14:27:13');
INSERT INTO `access_log` VALUES (47090, '64.78.15620488337660611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.85.18.146', '2019-07-02 14:27:14', 3, 0, '', '2019-07-02 14:27:14');
INSERT INTO `access_log` VALUES (47091, '64.77.15620488345330589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.85.18.146', '2019-07-02 14:27:15', 2, 0, '', '2019-07-02 14:27:15');
INSERT INTO `access_log` VALUES (47092, '59.79.15620488360500489', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.85.18.146', '2019-07-02 14:27:16', 3, 0, '', '2019-07-02 14:27:16');
INSERT INTO `access_log` VALUES (47093, '59.71.15620488360500485', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.85.18.146', '2019-07-02 14:27:16', 12, 2001001000, '服务端发生异常', '2019-07-02 14:27:16');
INSERT INTO `access_log` VALUES (47094, '59.77.15620489200680473', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:28:40', 2, 0, '', '2019-07-02 14:28:40');
INSERT INTO `access_log` VALUES (47095, '59.72.15620489200730487', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:28:40', 11, 2001001000, '服务端发生异常', '2019-07-02 14:28:40');
INSERT INTO `access_log` VALUES (47096, '64.81.15620489233790597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:28:43', 3, 0, '', '2019-07-02 14:28:43');
INSERT INTO `access_log` VALUES (47097, '64.85.15620489235190619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:28:44', 2, 0, '', '2019-07-02 14:28:44');
INSERT INTO `access_log` VALUES (47098, '64.78.15620489251110613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:28:45', 2, 0, '', '2019-07-02 14:28:45');
INSERT INTO `access_log` VALUES (47099, '64.77.15620489263560591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:28:46', 2, 0, '', '2019-07-02 14:28:46');
INSERT INTO `access_log` VALUES (47100, '59.71.15620489298480487', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:28:50', 2, 0, '', '2019-07-02 14:28:50');
INSERT INTO `access_log` VALUES (47101, '59.78.15620489298520481', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:28:50', 12, 2001001000, '服务端发生异常', '2019-07-02 14:28:50');
INSERT INTO `access_log` VALUES (47102, '64.82.15620489324180617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:28:52', 2, 0, '', '2019-07-02 14:28:52');
INSERT INTO `access_log` VALUES (47103, '64.79.15620489325440615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:28:53', 2, 0, '', '2019-07-02 14:28:53');
INSERT INTO `access_log` VALUES (47104, '59.74.15620489345390491', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:28:55', 10, 0, '', '2019-07-02 14:28:55');
INSERT INTO `access_log` VALUES (47105, '59.80.15620489345390473', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:28:55', 14, 2001001000, '服务端发生异常', '2019-07-02 14:28:55');
INSERT INTO `access_log` VALUES (47106, '64.80.15620489401720611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:00', 2, 0, '', '2019-07-02 14:29:00');
INSERT INTO `access_log` VALUES (47107, '64.76.15620489404760601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:00', 2, 0, '', '2019-07-02 14:29:00');
INSERT INTO `access_log` VALUES (47108, '64.81.15620489484310599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:08', 2, 0, '', '2019-07-02 14:29:08');
INSERT INTO `access_log` VALUES (47109, '64.85.15620489485600621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:09', 2, 0, '', '2019-07-02 14:29:09');
INSERT INTO `access_log` VALUES (47110, '64.77.15620489644830593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:24', 2, 0, '', '2019-07-02 14:29:24');
INSERT INTO `access_log` VALUES (47111, '64.84.15620489646420603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:25', 2, 0, '', '2019-07-02 14:29:25');
INSERT INTO `access_log` VALUES (47112, '59.77.15620489651320475', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:25', 2, 0, '', '2019-07-02 14:29:25');
INSERT INTO `access_log` VALUES (47113, '59.76.15620489651300481', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:25', 18, 2001001000, '服务端发生异常', '2019-07-02 14:29:25');
INSERT INTO `access_log` VALUES (47114, '65.47.15620489764091853', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:36', 0, 1002001015, '账号未登陆', '2019-07-02 14:29:36');
INSERT INTO `access_log` VALUES (47115, '65.51.15620489764101921', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:36', 0, 1002001015, '账号未登陆', '2019-07-02 14:29:36');
INSERT INTO `access_log` VALUES (47116, '65.53.15620489764141881', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:36', 0, 1002001015, '账号未登陆', '2019-07-02 14:29:36');
INSERT INTO `access_log` VALUES (47117, '65.49.15620489792551871', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 14:29:39');
INSERT INTO `access_log` VALUES (47118, '65.45.15620489976221873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:58', 80, 0, '', '2019-07-02 14:29:58');
INSERT INTO `access_log` VALUES (47119, '65.54.15620489980451831', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:58', 8, 0, '', '2019-07-02 14:29:58');
INSERT INTO `access_log` VALUES (47120, '65.50.15620489980491893', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:58', 10, 2001001000, '服务端发生异常', '2019-07-02 14:29:58');
INSERT INTO `access_log` VALUES (47121, '65.3607.15620489980563663', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.241.84.14', '2019-07-02 14:29:58', 8, 0, '', '2019-07-02 14:29:58');
INSERT INTO `access_log` VALUES (47122, '65.51.15620496025841931', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.72.51.177', '2019-07-02 14:40:03', 20, 1002001012, '访问令牌已过期', '2019-07-02 14:40:03');
INSERT INTO `access_log` VALUES (47123, '65.47.15620496026041863', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.72.51.177', '2019-07-02 14:40:03', 3, 1002001012, '访问令牌已过期', '2019-07-02 14:40:03');
INSERT INTO `access_log` VALUES (47124, '65.53.15620496026051891', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.72.51.177', '2019-07-02 14:40:03', 3, 1002001012, '访问令牌已过期', '2019-07-02 14:40:03');
INSERT INTO `access_log` VALUES (47125, '65.46.15620496083831943', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.72.51.177', '2019-07-02 14:40:08', 211, 0, '', '2019-07-02 14:40:09');
INSERT INTO `access_log` VALUES (47126, '65.52.15620496089801913', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.72.51.177', '2019-07-02 14:40:09', 9, 0, '', '2019-07-02 14:40:09');
INSERT INTO `access_log` VALUES (47127, '65.3607.15620496090013673', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.72.51.177', '2019-07-02 14:40:09', 8, 0, '', '2019-07-02 14:40:09');
INSERT INTO `access_log` VALUES (47128, '65.45.15620496089991883', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.72.51.177', '2019-07-02 14:40:09', 10, 2001001000, '服务端发生异常', '2019-07-02 14:40:09');
INSERT INTO `access_log` VALUES (47129, '59.74.15620505201750513', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.186.157', '2019-07-02 14:55:20', 4, 0, '', '2019-07-02 14:55:20');
INSERT INTO `access_log` VALUES (47130, '59.80.15620505201750495', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.186.157', '2019-07-02 14:55:20', 13, 2001001000, '服务端发生异常', '2019-07-02 14:55:20');
INSERT INTO `access_log` VALUES (47131, '65.51.15620505282971945', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.186.157', '2019-07-02 14:55:28', 0, 1002001015, '账号未登陆', '2019-07-02 14:55:28');
INSERT INTO `access_log` VALUES (47132, '65.54.15620505282961853', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.186.157', '2019-07-02 14:55:28', 0, 1002001015, '账号未登陆', '2019-07-02 14:55:28');
INSERT INTO `access_log` VALUES (47133, '65.53.15620505283131905', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.186.157', '2019-07-02 14:55:28', 0, 1002001015, '账号未登陆', '2019-07-02 14:55:28');
INSERT INTO `access_log` VALUES (47134, '65.47.15620505353561877', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.186.157', '2019-07-02 14:55:35', 101, 0, '', '2019-07-02 14:55:35');
INSERT INTO `access_log` VALUES (47135, '65.46.15620505358731957', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.186.157', '2019-07-02 14:55:36', 9, 0, '', '2019-07-02 14:55:36');
INSERT INTO `access_log` VALUES (47136, '65.49.15620505358851895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.186.157', '2019-07-02 14:55:36', 10, 2001001000, '服务端发生异常', '2019-07-02 14:55:36');
INSERT INTO `access_log` VALUES (47137, '65.52.15620505359111927', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.186.157', '2019-07-02 14:55:36', 9, 0, '', '2019-07-02 14:55:36');
INSERT INTO `access_log` VALUES (47138, '65.45.15620505462231897', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.186.157', '2019-07-02 14:55:46', 9, 0, '', '2019-07-02 14:55:46');
INSERT INTO `access_log` VALUES (47139, '65.50.15620505462281917', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.186.157', '2019-07-02 14:55:46', 10, 2001001000, '服务端发生异常', '2019-07-02 14:55:46');
INSERT INTO `access_log` VALUES (47140, '65.53.15620505462341907', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.186.157', '2019-07-02 14:55:46', 9, 0, '', '2019-07-02 14:55:46');
INSERT INTO `access_log` VALUES (47141, '59.78.15620512279120513', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:07:08', 3, 0, '', '2019-07-02 15:07:08');
INSERT INTO `access_log` VALUES (47142, '59.74.15620512279130523', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:07:08', 18, 2001001000, '服务端发生异常', '2019-07-02 15:07:08');
INSERT INTO `access_log` VALUES (47143, '64.79.15620512316360647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:07:12', 11, 0, '', '2019-07-02 15:07:12');
INSERT INTO `access_log` VALUES (47144, '64.84.15620512317250635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:07:12', 3, 0, '', '2019-07-02 15:07:12');
INSERT INTO `access_log` VALUES (47145, '64.76.15620512326210633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:07:13', 2, 0, '', '2019-07-02 15:07:13');
INSERT INTO `access_log` VALUES (47146, '64.82.15620512333160651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:07:13', 1, 0, '', '2019-07-02 15:07:13');
INSERT INTO `access_log` VALUES (47147, '64.83.15620512338200637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:07:14', 2, 0, '', '2019-07-02 15:07:14');
INSERT INTO `access_log` VALUES (47148, '64.80.15620512340990645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:07:14', 2, 0, '', '2019-07-02 15:07:14');
INSERT INTO `access_log` VALUES (47149, '64.85.15620512343790653', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:07:14', 2, 0, '', '2019-07-02 15:07:14');
INSERT INTO `access_log` VALUES (47150, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=233&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:07:16', 6, 0, '', '2019-07-02 15:07:16');
INSERT INTO `access_log` VALUES (47151, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=233', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:07:16', 5, 0, '', '2019-07-02 15:07:16');
INSERT INTO `access_log` VALUES (47152, '65.45.15620517550221915', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:15:55', 0, 1002001015, '账号未登陆', '2019-07-02 15:15:55');
INSERT INTO `access_log` VALUES (47153, '65.46.15620517550211979', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:15:55', 0, 1002001015, '账号未登陆', '2019-07-02 15:15:55');
INSERT INTO `access_log` VALUES (47154, '65.47.15620517550191895', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:15:55', 0, 1002001015, '账号未登陆', '2019-07-02 15:15:55');
INSERT INTO `access_log` VALUES (47155, '65.52.15620517570901947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:15:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 15:15:57');
INSERT INTO `access_log` VALUES (47156, '65.3607.15620517654483705', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:16:05', 62, 0, '', '2019-07-02 15:16:06');
INSERT INTO `access_log` VALUES (47157, '65.53.15620517657501925', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:16:06', 10, 0, '', '2019-07-02 15:16:06');
INSERT INTO `access_log` VALUES (47158, '65.54.15620517657501877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:16:06', 10, 2001001000, '服务端发生异常', '2019-07-02 15:16:06');
INSERT INTO `access_log` VALUES (47159, '65.50.15620517657501935', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:16:06', 13, 0, '', '2019-07-02 15:16:06');
INSERT INTO `access_log` VALUES (47160, '65.47.15620517935651897', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:16:34', 121, 0, '', '2019-07-02 15:16:34');
INSERT INTO `access_log` VALUES (47161, '65.52.15620517938461949', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:16:34', 16, 0, '', '2019-07-02 15:16:34');
INSERT INTO `access_log` VALUES (47162, '65.45.15620517938451917', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:16:34', 16, 0, '', '2019-07-02 15:16:34');
INSERT INTO `access_log` VALUES (47163, '65.46.15620517938461981', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:16:34', 17, 2001001000, '服务端发生异常', '2019-07-02 15:16:34');
INSERT INTO `access_log` VALUES (47164, '59.80.15620518189910513', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:16:59', 3, 0, '', '2019-07-02 15:16:59');
INSERT INTO `access_log` VALUES (47165, '59.74.15620518189910531', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:16:59', 13, 2001001000, '服务端发生异常', '2019-07-02 15:16:59');
INSERT INTO `access_log` VALUES (47166, '64.78.15620518260770655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:17:06', 3, 0, '', '2019-07-02 15:17:06');
INSERT INTO `access_log` VALUES (47167, '64.77.15620518262030635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:17:06', 3, 0, '', '2019-07-02 15:17:06');
INSERT INTO `access_log` VALUES (47168, '59.73.15620518282870533', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:17:08', 3, 0, '', '2019-07-02 15:17:08');
INSERT INTO `access_log` VALUES (47169, '59.77.15620518282890515', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:17:08', 12, 2001001000, '服务端发生异常', '2019-07-02 15:17:08');
INSERT INTO `access_log` VALUES (47170, '59.72.15620518354060529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:17:15', 2, 0, '', '2019-07-02 15:17:15');
INSERT INTO `access_log` VALUES (47171, '59.76.15620518354050521', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.123.67.2', '2019-07-02 15:17:15', 19, 2001001000, '服务端发生异常', '2019-07-02 15:17:15');
INSERT INTO `access_log` VALUES (47172, '65.47.15620518800161899', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:18:00', 3, 1002001012, '访问令牌已过期', '2019-07-02 15:18:00');
INSERT INTO `access_log` VALUES (47173, '65.52.15620518800191951', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:18:00', 2, 1002001012, '访问令牌已过期', '2019-07-02 15:18:00');
INSERT INTO `access_log` VALUES (47174, '65.46.15620518800231983', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:18:00', 3, 1002001012, '访问令牌已过期', '2019-07-02 15:18:00');
INSERT INTO `access_log` VALUES (47175, '65.45.15620518817871919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:18:02', 50, 0, '', '2019-07-02 15:18:02');
INSERT INTO `access_log` VALUES (47176, '65.3607.15620518820133709', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:18:02', 10, 0, '', '2019-07-02 15:18:02');
INSERT INTO `access_log` VALUES (47177, '65.50.15620518820181939', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:18:02', 9, 0, '', '2019-07-02 15:18:02');
INSERT INTO `access_log` VALUES (47178, '65.54.15620518820191881', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:18:02', 8, 0, '', '2019-07-02 15:18:02');
INSERT INTO `access_log` VALUES (47179, '64.80.15620519130440655', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:18:33', 10, 0, '', '2019-07-02 15:18:33');
INSERT INTO `access_log` VALUES (47180, '64.83.15620519130410647', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:18:33', 13, 0, '', '2019-07-02 15:18:33');
INSERT INTO `access_log` VALUES (47181, '64.83.15620520067330649', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:20:07', 14, 0, '', '2019-07-02 15:20:07');
INSERT INTO `access_log` VALUES (47182, '64.82.15620520067330663', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:20:07', 17, 0, '', '2019-07-02 15:20:07');
INSERT INTO `access_log` VALUES (47183, '66.53.15620521779118677', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:22:58', 22, 0, '', '2019-07-02 15:22:58');
INSERT INTO `access_log` VALUES (47184, '59.72.15620522563630535', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:24:16', 16, 0, '', '2019-07-02 15:24:16');
INSERT INTO `access_log` VALUES (47185, '59.79.15620522608160539', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:24:21', 24, 2001001000, '服务端发生异常', '2019-07-02 15:24:21');
INSERT INTO `access_log` VALUES (47186, '59.71.15620522666360535', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:24:27', 13, 0, '', '2019-07-02 15:24:27');
INSERT INTO `access_log` VALUES (47187, '59.78.15620522697970529', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:24:30', 21, 2001001000, '服务端发生异常', '2019-07-02 15:24:30');
INSERT INTO `access_log` VALUES (47188, '59.80.15620522792980521', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:24:39', 11, 0, '', '2019-07-02 15:24:39');
INSERT INTO `access_log` VALUES (47189, '59.77.15620522892700523', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:24:49', 143, 0, '', '2019-07-02 15:24:49');
INSERT INTO `access_log` VALUES (47190, '65.54.15620523063921887', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:25:06', 20, 0, '', '2019-07-02 15:25:06');
INSERT INTO `access_log` VALUES (47191, '59.72.15620523109290537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '3.112.204.148', '2019-07-02 15:25:11', 2, 0, '', '2019-07-02 15:25:11');
INSERT INTO `access_log` VALUES (47192, '59.76.15620523112190529', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '3.112.204.148', '2019-07-02 15:25:11', 12, 2001001000, '服务端发生异常', '2019-07-02 15:25:11');
INSERT INTO `access_log` VALUES (47193, '65.53.15620523114311935', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=12', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:25:11', 10, 0, '', '2019-07-02 15:25:11');
INSERT INTO `access_log` VALUES (47194, '65.49.15620523150471925', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:25:15', 8, 0, '', '2019-07-02 15:25:15');
INSERT INTO `access_log` VALUES (47195, '64.80.15620523174370661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '3.112.204.148', '2019-07-02 15:25:17', 3, 0, '', '2019-07-02 15:25:17');
INSERT INTO `access_log` VALUES (47196, '64.85.15620523177600669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '3.112.204.148', '2019-07-02 15:25:18', 2, 0, '', '2019-07-02 15:25:18');
INSERT INTO `access_log` VALUES (47197, '65.46.15620523361731991', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-02 15:25:36', 13, 0, '', '2019-07-02 15:25:36');
INSERT INTO `access_log` VALUES (47198, '65.45.15620526660741931', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:31:06', 4, 1002001012, '访问令牌已过期', '2019-07-02 15:31:06');
INSERT INTO `access_log` VALUES (47199, '65.3607.15620526660843721', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:31:06', 3, 1002001012, '访问令牌已过期', '2019-07-02 15:31:06');
INSERT INTO `access_log` VALUES (47200, '65.54.15620526660891893', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:31:06', 10, 1002001012, '访问令牌已过期', '2019-07-02 15:31:06');
INSERT INTO `access_log` VALUES (47201, '65.53.15620526761481941', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:31:16', 78, 0, '', '2019-07-02 15:31:16');
INSERT INTO `access_log` VALUES (47202, '65.49.15620526764311931', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:31:16', 10, 0, '', '2019-07-02 15:31:16');
INSERT INTO `access_log` VALUES (47203, '65.51.15620526764361983', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:31:16', 9, 2001001000, '服务端发生异常', '2019-07-02 15:31:16');
INSERT INTO `access_log` VALUES (47204, '65.46.15620526764441997', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-02 15:31:16', 9, 0, '', '2019-07-02 15:31:16');
INSERT INTO `access_log` VALUES (47205, '59.73.15620546651400573', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:04:25', 11, 0, '', '2019-07-02 16:04:25');
INSERT INTO `access_log` VALUES (47206, '59.72.15620546651450569', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:04:25', 18, 2001001000, '服务端发生异常', '2019-07-02 16:04:25');
INSERT INTO `access_log` VALUES (47207, '64.80.15620546846560693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:04:45', 12, 0, '', '2019-07-02 16:04:45');
INSERT INTO `access_log` VALUES (47208, '64.85.15620546847860701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:04:45', 4, 0, '', '2019-07-02 16:04:45');
INSERT INTO `access_log` VALUES (47209, '64.78.15620546862520695', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:04:46', 2, 0, '', '2019-07-02 16:04:46');
INSERT INTO `access_log` VALUES (47210, '64.77.15620546871370675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:04:47', 2, 0, '', '2019-07-02 16:04:47');
INSERT INTO `access_log` VALUES (47211, '64.79.15620546930280697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:04:53', 2, 0, '', '2019-07-02 16:04:53');
INSERT INTO `access_log` VALUES (47212, '64.84.15620546937290685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:04:54', 3, 0, '', '2019-07-02 16:04:54');
INSERT INTO `access_log` VALUES (47213, '59.71.15620546938760569', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:04:54', 3, 0, '', '2019-07-02 16:04:54');
INSERT INTO `access_log` VALUES (47214, '59.78.15620546938880563', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:04:54', 12, 2001001000, '服务端发生异常', '2019-07-02 16:04:54');
INSERT INTO `access_log` VALUES (47215, '65.46.15620547194212025', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:05:19', 0, 1002001015, '账号未登陆', '2019-07-02 16:05:19');
INSERT INTO `access_log` VALUES (47216, '65.53.15620547194211969', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:05:19', 0, 1002001015, '账号未登陆', '2019-07-02 16:05:19');
INSERT INTO `access_log` VALUES (47217, '65.49.15620547194211959', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:05:19', 0, 1002001015, '账号未登陆', '2019-07-02 16:05:19');
INSERT INTO `access_log` VALUES (47218, '65.47.15620547321591941', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:05:32', 92, 0, '', '2019-07-02 16:05:32');
INSERT INTO `access_log` VALUES (47219, '65.52.15620547324741993', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:05:32', 11, 0, '', '2019-07-02 16:05:32');
INSERT INTO `access_log` VALUES (47220, '65.3607.15620547324783751', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:05:32', 10, 2001001000, '服务端发生异常', '2019-07-02 16:05:32');
INSERT INTO `access_log` VALUES (47221, '65.45.15620547324871961', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.184.171', '2019-07-02 16:05:32', 9, 0, '', '2019-07-02 16:05:32');
INSERT INTO `access_log` VALUES (47222, '59.79.15620549589840577', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.65.188', '2019-07-02 16:09:19', 2, 0, '', '2019-07-02 16:09:19');
INSERT INTO `access_log` VALUES (47223, '59.78.15620549591320567', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.65.188', '2019-07-02 16:09:19', 12, 2001001000, '服务端发生异常', '2019-07-02 16:09:19');
INSERT INTO `access_log` VALUES (47224, '64.79.15620549611470701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.65.188', '2019-07-02 16:09:21', 2, 0, '', '2019-07-02 16:09:21');
INSERT INTO `access_log` VALUES (47225, '64.84.15620549613060689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.65.188', '2019-07-02 16:09:21', 2, 0, '', '2019-07-02 16:09:21');
INSERT INTO `access_log` VALUES (47226, '59.74.15620549680810577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.65.188', '2019-07-02 16:09:28', 12, 2001001000, '服务端发生异常', '2019-07-02 16:09:28');
INSERT INTO `access_log` VALUES (47227, '59.80.15620549682160559', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:09:28', 2, 0, '', '2019-07-02 16:09:28');
INSERT INTO `access_log` VALUES (47228, '64.76.15620549701680687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:09:30', 2, 0, '', '2019-07-02 16:09:30');
INSERT INTO `access_log` VALUES (47229, '64.82.15620549702990705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:09:30', 2, 0, '', '2019-07-02 16:09:30');
INSERT INTO `access_log` VALUES (47230, '64.83.15620549714740691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:09:31', 2, 0, '', '2019-07-02 16:09:31');
INSERT INTO `access_log` VALUES (47231, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.65.188', '2019-07-02 16:09:31', 6, 0, '', '2019-07-02 16:09:31');
INSERT INTO `access_log` VALUES (47232, '64.83.15620549714740691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:09:31', 2, 0, '', '2019-07-02 16:09:32');
INSERT INTO `access_log` VALUES (47233, '64.80.15620549735700699', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:09:34', 7, 0, '', '2019-07-02 16:09:34');
INSERT INTO `access_log` VALUES (47234, '66.57.15620549771938719', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.65.188', '2019-07-02 16:09:37', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-07-02 16:09:37');
INSERT INTO `access_log` VALUES (47235, '66.49.15620549840588731', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.65.188', '2019-07-02 16:09:44', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空\n手机验证码不能为空\n手机号必须都是数字', '2019-07-02 16:09:44');
INSERT INTO `access_log` VALUES (47236, '66.54.15620549921218725', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=123456&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:09:52', 5, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-07-02 16:09:52');
INSERT INTO `access_log` VALUES (47237, '66.52.15620550013288715', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.65.188', '2019-07-02 16:10:01', 16, 1001003001, '验证码已过期', '2019-07-02 16:10:01');
INSERT INTO `access_log` VALUES (47238, '66.55.15620550046508699', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=12345678911', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:10:05', 71, 0, '', '2019-07-02 16:10:05');
INSERT INTO `access_log` VALUES (47239, '66.51.15620550065518737', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:10:07', 199, 0, '', '2019-07-02 16:10:07');
INSERT INTO `access_log` VALUES (47240, '66.56.15620550079138723', 153, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:10:08', 255, 0, '', '2019-07-02 16:10:08');
INSERT INTO `access_log` VALUES (47241, '66.49.15620550115118733', 153, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:10:12', 6, 0, '', '2019-07-02 16:10:12');
INSERT INTO `access_log` VALUES (47242, '66.52.15620550257128717', 153, 1, 'user-application', '/user-api/users/address/add', 'name=dasdad&tel=12345678911&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=dsadasdas&isDefault=true&address=dsadasdas&areaNo=110101&mobile=12345678911&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:10:26', 62, 2001001000, '服务端发生异常', '2019-07-02 16:10:26');
INSERT INTO `access_log` VALUES (47243, '66.55.15620550271198701', 153, 1, 'user-application', '/user-api/users/address/add', 'name=dasdad&tel=12345678911&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=dsadasdas&isDefault=true&address=dsadasdas&areaNo=110101&mobile=12345678911&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:10:27', 80, 2001001000, '服务端发生异常', '2019-07-02 16:10:27');
INSERT INTO `access_log` VALUES (47244, '65.53.15620558056101985', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:23:26', 0, 1002001015, '账号未登陆', '2019-07-02 16:23:26');
INSERT INTO `access_log` VALUES (47245, '65.49.15620558056101975', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:23:26', 1, 1002001015, '账号未登陆', '2019-07-02 16:23:26');
INSERT INTO `access_log` VALUES (47246, '65.46.15620558056112041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:23:26', 0, 1002001015, '账号未登陆', '2019-07-02 16:23:26');
INSERT INTO `access_log` VALUES (47247, '65.51.15620558133332027', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:23:33', 0, 1002001015, '账号未登陆', '2019-07-02 16:23:33');
INSERT INTO `access_log` VALUES (47248, '65.47.15620558133441957', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:23:33', 1, 1002001015, '账号未登陆', '2019-07-02 16:23:33');
INSERT INTO `access_log` VALUES (47249, '65.3607.15620558133583767', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:23:33', 0, 1002001015, '账号未登陆', '2019-07-02 16:23:33');
INSERT INTO `access_log` VALUES (47250, '65.45.15620558181071977', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:23:38', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 16:23:38');
INSERT INTO `access_log` VALUES (47251, '65.54.15620558239961939', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:23:44', 98, 0, '', '2019-07-02 16:23:44');
INSERT INTO `access_log` VALUES (47252, '65.50.15620558244691997', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:23:44', 11, 0, '', '2019-07-02 16:23:44');
INSERT INTO `access_log` VALUES (47253, '65.46.15620558244742043', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:23:44', 10, 2001001000, '服务端发生异常', '2019-07-02 16:23:44');
INSERT INTO `access_log` VALUES (47254, '65.49.15620558244821977', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:23:44', 9, 0, '', '2019-07-02 16:23:44');
INSERT INTO `access_log` VALUES (47255, '65.47.15620558706211959', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:24:31', 8, 0, '', '2019-07-02 16:24:31');
INSERT INTO `access_log` VALUES (47256, '65.45.15620558706321979', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:24:31', 10, 2001001000, '服务端发生异常', '2019-07-02 16:24:31');
INSERT INTO `access_log` VALUES (47257, '65.52.15620558706502011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:24:31', 8, 0, '', '2019-07-02 16:24:31');
INSERT INTO `access_log` VALUES (47258, '65.54.15620558747171941', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '106.39.89.34', '2019-07-02 16:24:35', 1, 1002001015, '账号未登陆', '2019-07-02 16:24:35');
INSERT INTO `access_log` VALUES (47259, '65.46.15620558747222045', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '106.39.89.34', '2019-07-02 16:24:35', 0, 1002001015, '账号未登陆', '2019-07-02 16:24:35');
INSERT INTO `access_log` VALUES (47260, '65.49.15620558747291979', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '106.39.89.34', '2019-07-02 16:24:35', 0, 1002001015, '账号未登陆', '2019-07-02 16:24:35');
INSERT INTO `access_log` VALUES (47261, '65.50.15620558783181999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:24:38', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 16:24:38');
INSERT INTO `access_log` VALUES (47262, '65.51.15620558829542031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:24:43', 129, 0, '', '2019-07-02 16:24:43');
INSERT INTO `access_log` VALUES (47263, '65.3607.15620558833423771', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:24:43', 9, 0, '', '2019-07-02 16:24:43');
INSERT INTO `access_log` VALUES (47264, '65.47.15620558833501961', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:24:43', 8, 0, '', '2019-07-02 16:24:43');
INSERT INTO `access_log` VALUES (47265, '65.45.15620558833561981', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.15.130.153', '2019-07-02 16:24:43', 8, 0, '', '2019-07-02 16:24:43');
INSERT INTO `access_log` VALUES (47266, '65.46.15620559044862047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '106.39.89.34', '2019-07-02 16:25:04', 106, 0, '', '2019-07-02 16:25:05');
INSERT INTO `access_log` VALUES (47267, '65.54.15620559051671943', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '106.39.89.34', '2019-07-02 16:25:05', 16, 0, '', '2019-07-02 16:25:05');
INSERT INTO `access_log` VALUES (47268, '65.49.15620559051671981', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '106.39.89.34', '2019-07-02 16:25:05', 18, 2001001000, '服务端发生异常', '2019-07-02 16:25:05');
INSERT INTO `access_log` VALUES (47269, '65.50.15620559051682001', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '106.39.89.34', '2019-07-02 16:25:05', 16, 0, '', '2019-07-02 16:25:05');
INSERT INTO `access_log` VALUES (47270, '65.3607.15620559317403773', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '106.39.89.34', '2019-07-02 16:25:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 16:25:32');
INSERT INTO `access_log` VALUES (47271, '59.73.15620560618550593', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.74.41.250', '2019-07-02 16:27:42', 3, 0, '', '2019-07-02 16:27:42');
INSERT INTO `access_log` VALUES (47272, '59.76.15620560618550581', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.74.41.250', '2019-07-02 16:27:42', 19, 2001001000, '服务端发生异常', '2019-07-02 16:27:42');
INSERT INTO `access_log` VALUES (47273, '59.77.15620564510340581', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:11', 3, 0, '', '2019-07-02 16:34:11');
INSERT INTO `access_log` VALUES (47274, '59.72.15620564510370595', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:11', 14, 2001001000, '服务端发生异常', '2019-07-02 16:34:11');
INSERT INTO `access_log` VALUES (47275, '59.76.15620564612080587', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:21', 2, 0, '', '2019-07-02 16:34:21');
INSERT INTO `access_log` VALUES (47276, '59.71.15620564612100595', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:21', 11, 2001001000, '服务端发生异常', '2019-07-02 16:34:21');
INSERT INTO `access_log` VALUES (47277, '64.85.15620564634790727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:23', 3, 0, '', '2019-07-02 16:34:23');
INSERT INTO `access_log` VALUES (47278, '64.78.15620564636000721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:24', 1, 0, '', '2019-07-02 16:34:24');
INSERT INTO `access_log` VALUES (47279, '64.77.15620564648010701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:25', 1, 0, '', '2019-07-02 16:34:25');
INSERT INTO `access_log` VALUES (47280, '64.81.15620564658680705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:26', 2, 0, '', '2019-07-02 16:34:26');
INSERT INTO `access_log` VALUES (47281, '64.79.15620564673890723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:27', 2, 0, '', '2019-07-02 16:34:27');
INSERT INTO `access_log` VALUES (47282, '59.79.15620564684960599', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:28', 3, 0, '', '2019-07-02 16:34:28');
INSERT INTO `access_log` VALUES (47283, '59.78.15620564684970589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:28', 13, 2001001000, '服务端发生异常', '2019-07-02 16:34:29');
INSERT INTO `access_log` VALUES (47284, '65.51.15620564738682041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:34', 0, 1002001015, '账号未登陆', '2019-07-02 16:34:34');
INSERT INTO `access_log` VALUES (47285, '65.49.15620564738671989', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:34', 0, 1002001015, '账号未登陆', '2019-07-02 16:34:34');
INSERT INTO `access_log` VALUES (47286, '65.53.15620564738671999', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:34', 0, 1002001015, '账号未登陆', '2019-07-02 16:34:34');
INSERT INTO `access_log` VALUES (47287, '65.3607.15620564755113781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 16:34:36');
INSERT INTO `access_log` VALUES (47288, '65.45.15620564878621991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:48', 78, 0, '', '2019-07-02 16:34:48');
INSERT INTO `access_log` VALUES (47289, '65.52.15620564882122023', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:48', 10, 0, '', '2019-07-02 16:34:48');
INSERT INTO `access_log` VALUES (47290, '65.46.15620564882122057', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:48', 11, 2001001000, '服务端发生异常', '2019-07-02 16:34:48');
INSERT INTO `access_log` VALUES (47291, '65.50.15620564882182011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:34:48', 9, 0, '', '2019-07-02 16:34:48');
INSERT INTO `access_log` VALUES (47292, '65.51.15620565270802043', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:35:27', 0, 1002001015, '账号未登陆', '2019-07-02 16:35:27');
INSERT INTO `access_log` VALUES (47293, '65.3607.15620565270843783', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:35:27', 1, 1002001015, '账号未登陆', '2019-07-02 16:35:27');
INSERT INTO `access_log` VALUES (47294, '65.47.15620565270881973', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:35:27', 0, 1002001015, '账号未登陆', '2019-07-02 16:35:27');
INSERT INTO `access_log` VALUES (47295, '65.45.15620565306811993', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:35:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 16:35:31');
INSERT INTO `access_log` VALUES (47296, '65.50.15620565408532013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:35:41', 108, 0, '', '2019-07-02 16:35:41');
INSERT INTO `access_log` VALUES (47297, '65.46.15620565414132059', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:35:41', 9, 0, '', '2019-07-02 16:35:41');
INSERT INTO `access_log` VALUES (47298, '65.54.15620565414171955', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:35:41', 10, 2001001000, '服务端发生异常', '2019-07-02 16:35:41');
INSERT INTO `access_log` VALUES (47299, '65.49.15620565414211993', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:35:41', 8, 0, '', '2019-07-02 16:35:41');
INSERT INTO `access_log` VALUES (47300, '65.53.15620565465692003', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.209.129', '2019-07-02 16:35:47', 4, 1002001012, '访问令牌已过期', '2019-07-02 16:35:47');
INSERT INTO `access_log` VALUES (47301, '65.3607.15620565465723785', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.209.129', '2019-07-02 16:35:47', 3, 1002001012, '访问令牌已过期', '2019-07-02 16:35:47');
INSERT INTO `access_log` VALUES (47302, '65.47.15620565465731975', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.209.129', '2019-07-02 16:35:47', 3, 1002001012, '访问令牌已过期', '2019-07-02 16:35:47');
INSERT INTO `access_log` VALUES (47303, '65.51.15620565488802045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.209.129', '2019-07-02 16:35:49', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 16:35:49');
INSERT INTO `access_log` VALUES (47304, '65.52.15620565543012027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.209.129', '2019-07-02 16:35:54', 85, 0, '', '2019-07-02 16:35:54');
INSERT INTO `access_log` VALUES (47305, '65.50.15620565545462015', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.209.129', '2019-07-02 16:35:55', 9, 0, '', '2019-07-02 16:35:55');
INSERT INTO `access_log` VALUES (47306, '65.46.15620565545492061', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.209.129', '2019-07-02 16:35:55', 9, 2001001000, '服务端发生异常', '2019-07-02 16:35:55');
INSERT INTO `access_log` VALUES (47307, '65.54.15620565545501957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.209.129', '2019-07-02 16:35:55', 9, 0, '', '2019-07-02 16:35:55');
INSERT INTO `access_log` VALUES (47308, '65.49.15620565580171995', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:35:58', 9, 0, '', '2019-07-02 16:35:58');
INSERT INTO `access_log` VALUES (47309, '65.53.15620565580212005', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:35:58', 8, 2001001000, '服务端发生异常', '2019-07-02 16:35:58');
INSERT INTO `access_log` VALUES (47310, '65.3607.15620565580243787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:35:58', 8, 0, '', '2019-07-02 16:35:58');
INSERT INTO `access_log` VALUES (47311, '65.47.15620565687831977', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.209.129', '2019-07-02 16:36:09', 8, 0, '', '2019-07-02 16:36:09');
INSERT INTO `access_log` VALUES (47312, '65.51.15620565687872047', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.209.129', '2019-07-02 16:36:09', 9, 2001001000, '服务端发生异常', '2019-07-02 16:36:09');
INSERT INTO `access_log` VALUES (47313, '65.45.15620565687871997', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.200.209.129', '2019-07-02 16:36:09', 8, 0, '', '2019-07-02 16:36:09');
INSERT INTO `access_log` VALUES (47314, '65.54.15620565700851959', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:36:10', 10, 0, '', '2019-07-02 16:36:10');
INSERT INTO `access_log` VALUES (47315, '65.50.15620565700882017', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:36:10', 10, 2001001000, '服务端发生异常', '2019-07-02 16:36:10');
INSERT INTO `access_log` VALUES (47316, '65.46.15620565700932063', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:36:10', 9, 0, '', '2019-07-02 16:36:10');
INSERT INTO `access_log` VALUES (47317, '65.3607.15620566082703789', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:36:48', 9, 0, '', '2019-07-02 16:36:48');
INSERT INTO `access_log` VALUES (47318, '65.47.15620566082851979', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:36:48', 10, 2001001000, '服务端发生异常', '2019-07-02 16:36:48');
INSERT INTO `access_log` VALUES (47319, '65.45.15620566082891999', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:36:48', 8, 0, '', '2019-07-02 16:36:48');
INSERT INTO `access_log` VALUES (47320, '59.72.15620566608490599', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:37:41', 4, 0, '', '2019-07-02 16:37:41');
INSERT INTO `access_log` VALUES (47321, '59.77.15620566608480585', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:37:41', 18, 2001001000, '服务端发生异常', '2019-07-02 16:37:41');
INSERT INTO `access_log` VALUES (47322, '64.83.15620566662250715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:37:46', 2, 0, '', '2019-07-02 16:37:46');
INSERT INTO `access_log` VALUES (47323, '64.80.15620566664060723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:37:46', 1, 0, '', '2019-07-02 16:37:46');
INSERT INTO `access_log` VALUES (47324, '64.85.15620566677030731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:37:48', 2, 0, '', '2019-07-02 16:37:48');
INSERT INTO `access_log` VALUES (47325, '64.78.15620566686220725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:37:49', 2, 0, '', '2019-07-02 16:37:49');
INSERT INTO `access_log` VALUES (47326, '64.81.15620566720480709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:37:52', 2, 0, '', '2019-07-02 16:37:52');
INSERT INTO `access_log` VALUES (47327, '64.79.15620566723640727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:37:52', 1, 0, '', '2019-07-02 16:37:52');
INSERT INTO `access_log` VALUES (47328, '59.76.15620566730990591', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:37:53', 2, 0, '', '2019-07-02 16:37:53');
INSERT INTO `access_log` VALUES (47329, '59.71.15620566731000599', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:37:53', 12, 2001001000, '服务端发生异常', '2019-07-02 16:37:53');
INSERT INTO `access_log` VALUES (47330, '64.82.15620567008510731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:38:21', 2, 0, '', '2019-07-02 16:38:21');
INSERT INTO `access_log` VALUES (47331, '64.83.15620567009510717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:38:21', 2, 0, '', '2019-07-02 16:38:21');
INSERT INTO `access_log` VALUES (47332, '59.74.15620567018430603', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:38:22', 3, 0, '', '2019-07-02 16:38:22');
INSERT INTO `access_log` VALUES (47333, '59.80.15620567018430585', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-02 16:38:22', 12, 2001001000, '服务端发生异常', '2019-07-02 16:38:22');
INSERT INTO `access_log` VALUES (47334, '65.47.15620568609581983', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:41:01', 19, 0, '', '2019-07-02 16:41:01');
INSERT INTO `access_log` VALUES (47335, '65.45.15620568609752003', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:41:01', 10, 2001001000, '服务端发生异常', '2019-07-02 16:41:01');
INSERT INTO `access_log` VALUES (47336, '65.3607.15620568609793793', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.249.194.120', '2019-07-02 16:41:01', 8, 0, '', '2019-07-02 16:41:01');
INSERT INTO `access_log` VALUES (47337, '65.45.15620574815452011', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.9', '2019-07-02 16:51:22', 1, 1002001015, '账号未登陆', '2019-07-02 16:51:22');
INSERT INTO `access_log` VALUES (47338, '65.51.15620574815452063', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.9', '2019-07-02 16:51:22', 1, 1002001015, '账号未登陆', '2019-07-02 16:51:22');
INSERT INTO `access_log` VALUES (47339, '65.52.15620574815802045', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.9', '2019-07-02 16:51:22', 0, 1002001015, '账号未登陆', '2019-07-02 16:51:22');
INSERT INTO `access_log` VALUES (47340, '65.54.15620574843321975', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.9', '2019-07-02 16:51:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 16:51:24');
INSERT INTO `access_log` VALUES (47341, '65.53.15620575091182021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.9', '2019-07-02 16:51:49', 51, 0, '', '2019-07-02 16:51:49');
INSERT INTO `access_log` VALUES (47342, '65.49.15620575095052011', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.9', '2019-07-02 16:51:50', 9, 0, '', '2019-07-02 16:51:50');
INSERT INTO `access_log` VALUES (47343, '65.47.15620575095091995', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.9', '2019-07-02 16:51:50', 9, 2001001000, '服务端发生异常', '2019-07-02 16:51:50');
INSERT INTO `access_log` VALUES (47344, '65.3607.15620575095163803', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.9', '2019-07-02 16:51:50', 8, 0, '', '2019-07-02 16:51:50');
INSERT INTO `access_log` VALUES (47345, '65.45.15620575321662013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.9', '2019-07-02 16:52:12', 80, 0, '', '2019-07-02 16:52:12');
INSERT INTO `access_log` VALUES (47346, '65.50.15620575324452033', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.9', '2019-07-02 16:52:12', 9, 0, '', '2019-07-02 16:52:12');
INSERT INTO `access_log` VALUES (47347, '65.54.15620575324721977', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.9', '2019-07-02 16:52:12', 9, 2001001000, '服务端发生异常', '2019-07-02 16:52:12');
INSERT INTO `access_log` VALUES (47348, '65.46.15620575324792081', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.9', '2019-07-02 16:52:12', 8, 0, '', '2019-07-02 16:52:12');
INSERT INTO `access_log` VALUES (47349, '65.45.15620582882822025', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:04:48', 4, 1002001012, '访问令牌已过期', '2019-07-02 17:04:48');
INSERT INTO `access_log` VALUES (47350, '65.46.15620582882872091', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:04:48', 3, 1002001012, '访问令牌已过期', '2019-07-02 17:04:48');
INSERT INTO `access_log` VALUES (47351, '65.3607.15620582882923817', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:04:48', 10, 1002001012, '访问令牌已过期', '2019-07-02 17:04:48');
INSERT INTO `access_log` VALUES (47352, '65.49.15620582923982025', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:04:52', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 17:04:52');
INSERT INTO `access_log` VALUES (47353, '65.53.15620582978852033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:04:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 17:04:58');
INSERT INTO `access_log` VALUES (47354, '65.51.15620583156582079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:05:16', 73, 0, '', '2019-07-02 17:05:16');
INSERT INTO `access_log` VALUES (47355, '65.54.15620583160811989', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:05:16', 18, 0, '', '2019-07-02 17:05:16');
INSERT INTO `access_log` VALUES (47356, '65.46.15620583160932093', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:05:16', 9, 0, '', '2019-07-02 17:05:16');
INSERT INTO `access_log` VALUES (47357, '65.50.15620583160932045', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:05:16', 9, 2001001000, '服务端发生异常', '2019-07-02 17:05:16');
INSERT INTO `access_log` VALUES (47358, '65.49.15620583426592027', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:05:43', 8, 0, '', '2019-07-02 17:05:43');
INSERT INTO `access_log` VALUES (47359, '65.47.15620583426652011', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:05:43', 8, 2001001000, '服务端发生异常', '2019-07-02 17:05:43');
INSERT INTO `access_log` VALUES (47360, '65.53.15620583426712035', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:05:43', 7, 0, '', '2019-07-02 17:05:43');
INSERT INTO `access_log` VALUES (47361, '65.51.15620583669142081', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:06:07', 9, 0, '', '2019-07-02 17:06:07');
INSERT INTO `access_log` VALUES (47362, '65.46.15620583669222095', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:06:07', 9, 2001001000, '服务端发生异常', '2019-07-02 17:06:07');
INSERT INTO `access_log` VALUES (47363, '65.50.15620583669462047', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:06:07', 9, 0, '', '2019-07-02 17:06:07');
INSERT INTO `access_log` VALUES (47364, '59.72.15620583799410623', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:06:20', 3, 0, '', '2019-07-02 17:06:20');
INSERT INTO `access_log` VALUES (47365, '59.73.15620583799410627', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:06:20', 19, 2001001000, '服务端发生异常', '2019-07-02 17:06:20');
INSERT INTO `access_log` VALUES (47366, '64.77.15620584071630729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:06:47', 3, 0, '', '2019-07-02 17:06:47');
INSERT INTO `access_log` VALUES (47367, '64.81.15620584072750733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:06:47', 1, 0, '', '2019-07-02 17:06:47');
INSERT INTO `access_log` VALUES (47368, '64.79.15620584102690751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:06:50', 2, 0, '', '2019-07-02 17:06:50');
INSERT INTO `access_log` VALUES (47369, '64.84.15620584103620739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:06:50', 1, 0, '', '2019-07-02 17:06:50');
INSERT INTO `access_log` VALUES (47370, '64.82.15620584187140755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:06:59', 2, 0, '', '2019-07-02 17:06:59');
INSERT INTO `access_log` VALUES (47371, '64.83.15620584188390741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:06:59', 2, 0, '', '2019-07-02 17:06:59');
INSERT INTO `access_log` VALUES (47372, '64.80.15620584201350749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:07:00', 2, 0, '', '2019-07-02 17:07:00');
INSERT INTO `access_log` VALUES (47373, '64.85.15620584207500757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:07:01', 1, 0, '', '2019-07-02 17:07:01');
INSERT INTO `access_log` VALUES (47374, '64.78.15620584215730751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:07:02', 2, 0, '', '2019-07-02 17:07:02');
INSERT INTO `access_log` VALUES (47375, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:07:02', 5, 0, '', '2019-07-02 17:07:02');
INSERT INTO `access_log` VALUES (47376, '64.77.15620584230920731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:07:03', 2, 0, '', '2019-07-02 17:07:03');
INSERT INTO `access_log` VALUES (47377, '64.81.15620584232290735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:07:03', 2, 0, '', '2019-07-02 17:07:03');
INSERT INTO `access_log` VALUES (47378, '59.78.15620584243130617', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:07:04', 2, 0, '', '2019-07-02 17:07:04');
INSERT INTO `access_log` VALUES (47379, '59.74.15620584243180627', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-07-02 17:07:04', 13, 2001001000, '服务端发生异常', '2019-07-02 17:07:04');
INSERT INTO `access_log` VALUES (47380, '59.73.15620598359760647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 17:30:36', 3, 0, '', '2019-07-02 17:30:36');
INSERT INTO `access_log` VALUES (47381, '59.76.15620598359780635', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 17:30:36', 12, 2001001000, '服务端发生异常', '2019-07-02 17:30:36');
INSERT INTO `access_log` VALUES (47382, '64.80.15620598400770769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 17:30:40', 4, 0, '', '2019-07-02 17:30:40');
INSERT INTO `access_log` VALUES (47383, '64.85.15620598402030777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 17:30:40', 2, 0, '', '2019-07-02 17:30:40');
INSERT INTO `access_log` VALUES (47384, '64.78.15620598423110771', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 17:30:42', 2, 0, '', '2019-07-02 17:30:42');
INSERT INTO `access_log` VALUES (47385, '64.77.15620598432260751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 17:30:43', 2, 0, '', '2019-07-02 17:30:43');
INSERT INTO `access_log` VALUES (47386, '64.81.15620598473990755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 17:30:47', 2, 0, '', '2019-07-02 17:30:47');
INSERT INTO `access_log` VALUES (47387, '64.79.15620598475700773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 17:30:48', 2, 0, '', '2019-07-02 17:30:48');
INSERT INTO `access_log` VALUES (47388, '59.79.15620598505770647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 17:30:51', 2, 0, '', '2019-07-02 17:30:51');
INSERT INTO `access_log` VALUES (47389, '59.78.15620598505780637', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 17:30:51', 17, 2001001000, '服务端发生异常', '2019-07-02 17:30:51');
INSERT INTO `access_log` VALUES (47390, '65.45.15620598588632049', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 17:30:59', 4, 1002001012, '访问令牌已过期', '2019-07-02 17:30:59');
INSERT INTO `access_log` VALUES (47391, '65.49.15620598588632049', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 17:30:59', 4, 1002001012, '访问令牌已过期', '2019-07-02 17:30:59');
INSERT INTO `access_log` VALUES (47392, '65.53.15620598588652057', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 17:30:59', 3, 1002001012, '访问令牌已过期', '2019-07-02 17:30:59');
INSERT INTO `access_log` VALUES (47393, '65.47.15620598610442033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.136.87.87', '2019-07-02 17:31:01', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 17:31:01');
INSERT INTO `access_log` VALUES (47394, '59.75.15620603440230655', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.242.193.201', '2019-07-02 17:39:04', 3, 0, '', '2019-07-02 17:39:04');
INSERT INTO `access_log` VALUES (47395, '59.77.15620603440240637', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.242.193.201', '2019-07-02 17:39:04', 16, 2001001000, '服务端发生异常', '2019-07-02 17:39:04');
INSERT INTO `access_log` VALUES (47396, '64.80.15620603491660777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.242.193.201', '2019-07-02 17:39:09', 2, 0, '', '2019-07-02 17:39:09');
INSERT INTO `access_log` VALUES (47397, '64.85.15620603492850785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.242.193.201', '2019-07-02 17:39:09', 2, 0, '', '2019-07-02 17:39:09');
INSERT INTO `access_log` VALUES (47398, '64.78.15620603506130779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.242.193.201', '2019-07-02 17:39:11', 2, 0, '', '2019-07-02 17:39:11');
INSERT INTO `access_log` VALUES (47399, '64.77.15620603512260759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.242.193.201', '2019-07-02 17:39:11', 1, 0, '', '2019-07-02 17:39:11');
INSERT INTO `access_log` VALUES (47400, '64.79.15620603613580781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.242.193.201', '2019-07-02 17:39:21', 2, 0, '', '2019-07-02 17:39:21');
INSERT INTO `access_log` VALUES (47401, '64.84.15620603614940769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.242.193.201', '2019-07-02 17:39:21', 1, 0, '', '2019-07-02 17:39:21');
INSERT INTO `access_log` VALUES (47402, '64.82.15620603784530785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.242.193.201', '2019-07-02 17:39:38', 2, 0, '', '2019-07-02 17:39:38');
INSERT INTO `access_log` VALUES (47403, '64.83.15620603789530771', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.242.193.201', '2019-07-02 17:39:39', 2, 0, '', '2019-07-02 17:39:39');
INSERT INTO `access_log` VALUES (47404, '59.79.15620603850690655', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.242.193.201', '2019-07-02 17:39:45', 3, 0, '', '2019-07-02 17:39:45');
INSERT INTO `access_log` VALUES (47405, '59.71.15620603850690651', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '114.242.193.201', '2019-07-02 17:39:45', 14, 2001001000, '服务端发生异常', '2019-07-02 17:39:45');
INSERT INTO `access_log` VALUES (47406, '65.54.15620616999602037', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '119.123.33.97', '2019-07-02 18:01:40', 0, 1002001015, '账号未登陆', '2019-07-02 18:01:40');
INSERT INTO `access_log` VALUES (47407, '65.50.15620616999602093', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '119.123.33.97', '2019-07-02 18:01:40', 0, 1002001015, '账号未登陆', '2019-07-02 18:01:40');
INSERT INTO `access_log` VALUES (47408, '65.3607.15620616999623867', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '119.123.33.97', '2019-07-02 18:01:40', 0, 1002001015, '账号未登陆', '2019-07-02 18:01:40');
INSERT INTO `access_log` VALUES (47409, '65.49.15620617178052075', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '119.123.33.97', '2019-07-02 18:01:58', 62, 0, '', '2019-07-02 18:01:58');
INSERT INTO `access_log` VALUES (47410, '65.45.15620617182042075', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '119.123.33.97', '2019-07-02 18:01:58', 12, 0, '', '2019-07-02 18:01:58');
INSERT INTO `access_log` VALUES (47411, '65.47.15620617182052059', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '119.123.33.97', '2019-07-02 18:01:58', 13, 0, '', '2019-07-02 18:01:58');
INSERT INTO `access_log` VALUES (47412, '65.52.15620617182052109', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '119.123.33.97', '2019-07-02 18:01:58', 13, 2001001000, '服务端发生异常', '2019-07-02 18:01:58');
INSERT INTO `access_log` VALUES (47413, '65.3607.15620617291943869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '119.123.33.97', '2019-07-02 18:02:09', 9, 0, '', '2019-07-02 18:02:09');
INSERT INTO `access_log` VALUES (47414, '65.51.15620617291942129', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '119.123.33.97', '2019-07-02 18:02:09', 11, 2001001000, '服务端发生异常', '2019-07-02 18:02:09');
INSERT INTO `access_log` VALUES (47415, '65.50.15620617291982095', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '119.123.33.97', '2019-07-02 18:02:09', 9, 0, '', '2019-07-02 18:02:09');
INSERT INTO `access_log` VALUES (47416, '65.51.15620618312382131', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.66.71.149', '2019-07-02 18:03:51', 427, 1002001012, '访问令牌已过期', '2019-07-02 18:03:52');
INSERT INTO `access_log` VALUES (47417, '65.3607.15620618312263871', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.66.71.149', '2019-07-02 18:03:51', 439, 1002001012, '访问令牌已过期', '2019-07-02 18:03:52');
INSERT INTO `access_log` VALUES (47418, '65.46.15620618312252145', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.66.71.149', '2019-07-02 18:03:51', 440, 1002001012, '访问令牌已过期', '2019-07-02 18:03:52');
INSERT INTO `access_log` VALUES (47419, '59.76.15620621271520667', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.75.47', '2019-07-02 18:08:47', 4, 0, '', '2019-07-02 18:08:47');
INSERT INTO `access_log` VALUES (47420, '59.73.15620621271520679', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.75.47', '2019-07-02 18:08:47', 14, 2001001000, '服务端发生异常', '2019-07-02 18:08:47');
INSERT INTO `access_log` VALUES (47421, '64.76.15620621312950791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.75.47', '2019-07-02 18:08:51', 2, 0, '', '2019-07-02 18:08:51');
INSERT INTO `access_log` VALUES (47422, '64.82.15620621314070809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.75.47', '2019-07-02 18:08:51', 2, 0, '', '2019-07-02 18:08:51');
INSERT INTO `access_log` VALUES (47423, '64.83.15620621324140795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.75.47', '2019-07-02 18:08:52', 2, 0, '', '2019-07-02 18:08:52');
INSERT INTO `access_log` VALUES (47424, '64.80.15620621332250803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '42.120.75.47', '2019-07-02 18:08:53', 2, 0, '', '2019-07-02 18:08:53');
INSERT INTO `access_log` VALUES (47425, '65.3607.15620630009183887', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.141', '2019-07-02 18:23:21', 0, 1002001015, '账号未登陆', '2019-07-02 18:23:21');
INSERT INTO `access_log` VALUES (47426, '65.50.15620630009202113', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.140', '2019-07-02 18:23:21', 0, 1002001015, '账号未登陆', '2019-07-02 18:23:21');
INSERT INTO `access_log` VALUES (47427, '65.46.15620630009202161', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.140', '2019-07-02 18:23:21', 0, 1002001015, '账号未登陆', '2019-07-02 18:23:21');
INSERT INTO `access_log` VALUES (47428, '65.54.15620630029292057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.141', '2019-07-02 18:23:23', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 18:23:23');
INSERT INTO `access_log` VALUES (47429, '65.49.15620630098612095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.141', '2019-07-02 18:23:30', 222, 0, '', '2019-07-02 18:23:30');
INSERT INTO `access_log` VALUES (47430, '65.52.15620630103132129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.140', '2019-07-02 18:23:30', 9, 0, '', '2019-07-02 18:23:30');
INSERT INTO `access_log` VALUES (47431, '65.45.15620630103182095', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.141', '2019-07-02 18:23:30', 9, 0, '', '2019-07-02 18:23:30');
INSERT INTO `access_log` VALUES (47432, '65.47.15620630103182079', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.141', '2019-07-02 18:23:30', 9, 2001001000, '服务端发生异常', '2019-07-02 18:23:30');
INSERT INTO `access_log` VALUES (47433, '59.72.15620665440960735', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.66.252.26', '2019-07-02 19:22:24', 11, 0, '', '2019-07-02 19:22:24');
INSERT INTO `access_log` VALUES (47434, '59.75.15620665440970739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.66.252.26', '2019-07-02 19:22:24', 15, 2001001000, '服务端发生异常', '2019-07-02 19:22:24');
INSERT INTO `access_log` VALUES (47435, '65.54.15620682298112129', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '36.61.170.139', '2019-07-02 19:50:30', 0, 1002001015, '账号未登陆', '2019-07-02 19:50:30');
INSERT INTO `access_log` VALUES (47436, '65.3607.15620682298113957', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '36.61.170.139', '2019-07-02 19:50:30', 0, 1002001015, '账号未登陆', '2019-07-02 19:50:30');
INSERT INTO `access_log` VALUES (47437, '65.50.15620682298132185', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '36.61.170.139', '2019-07-02 19:50:30', 1, 1002001015, '账号未登陆', '2019-07-02 19:50:30');
INSERT INTO `access_log` VALUES (47438, '65.49.15620682364172167', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '36.61.170.139', '2019-07-02 19:50:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 19:50:36');
INSERT INTO `access_log` VALUES (47439, '65.50.15620683519882187', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.141', '2019-07-02 19:52:32', 4, 1002001012, '访问令牌已过期', '2019-07-02 19:52:32');
INSERT INTO `access_log` VALUES (47440, '65.49.15620683519902169', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.140', '2019-07-02 19:52:32', 3, 1002001012, '访问令牌已过期', '2019-07-02 19:52:32');
INSERT INTO `access_log` VALUES (47441, '65.53.15620683519912177', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.140', '2019-07-02 19:52:32', 2, 1002001012, '访问令牌已过期', '2019-07-02 19:52:32');
INSERT INTO `access_log` VALUES (47442, '65.52.15620683634812203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.141', '2019-07-02 19:52:43', 188, 0, '', '2019-07-02 19:52:44');
INSERT INTO `access_log` VALUES (47443, '65.51.15620683639282223', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.141', '2019-07-02 19:52:44', 11, 0, '', '2019-07-02 19:52:44');
INSERT INTO `access_log` VALUES (47444, '65.45.15620683639272167', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.140', '2019-07-02 19:52:44', 13, 2001001000, '服务端发生异常', '2019-07-02 19:52:44');
INSERT INTO `access_log` VALUES (47445, '65.46.15620683639322237', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.245.141', '2019-07-02 19:52:44', 10, 0, '', '2019-07-02 19:52:44');
INSERT INTO `access_log` VALUES (47446, '59.80.15620702552420769', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:24:15', 10, 0, '', '2019-07-02 20:24:15');
INSERT INTO `access_log` VALUES (47447, '59.75.15620702552430789', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:24:15', 15, 2001001000, '服务端发生异常', '2019-07-02 20:24:15');
INSERT INTO `access_log` VALUES (47448, '64.78.15620702586280913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:24:19', 10, 0, '', '2019-07-02 20:24:19');
INSERT INTO `access_log` VALUES (47449, '64.77.15620702589030893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:24:19', 3, 0, '', '2019-07-02 20:24:19');
INSERT INTO `access_log` VALUES (47450, '64.81.15620702603080897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:24:20', 2, 0, '', '2019-07-02 20:24:20');
INSERT INTO `access_log` VALUES (47451, '64.84.15620702607430903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:24:21', 2, 0, '', '2019-07-02 20:24:21');
INSERT INTO `access_log` VALUES (47452, '64.76.15620702623370901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:24:22', 2, 0, '', '2019-07-02 20:24:22');
INSERT INTO `access_log` VALUES (47453, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:24:22', 7, 0, '', '2019-07-02 20:24:22');
INSERT INTO `access_log` VALUES (47454, '64.82.15620702645640919', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:24:25', 8, 0, '', '2019-07-02 20:24:25');
INSERT INTO `access_log` VALUES (47455, '66.54.15620702808888931', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=1233123123&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:24:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-07-02 20:24:41');
INSERT INTO `access_log` VALUES (47456, '66.52.15620702842538921', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=123312312311&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:24:44', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-07-02 20:24:44');
INSERT INTO `access_log` VALUES (47457, '66.50.15620702929498923', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12331231231&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:24:53', 17, 1001003000, '验证码不存在', '2019-07-02 20:24:53');
INSERT INTO `access_log` VALUES (47458, '66.51.15620702977238943', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=12331231231', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:24:58', 104, 0, '', '2019-07-02 20:24:58');
INSERT INTO `access_log` VALUES (47459, '66.48.15620703004848943', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12331231231&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:25:00', 165, 0, '', '2019-07-02 20:25:01');
INSERT INTO `access_log` VALUES (47460, '66.57.15620703020838927', 154, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:25:02', 7, 0, '', '2019-07-02 20:25:02');
INSERT INTO `access_log` VALUES (47461, '66.54.15620703112988933', 154, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:25:11', 5, 0, '', '2019-07-02 20:25:11');
INSERT INTO `access_log` VALUES (47462, '66.50.15620703287698925', 154, 1, 'user-application', '/user-api/users/address/add', 'name=sdfs&tel=13213232132&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=12321312&isDefault=false&address=12321312&areaNo=120102&mobile=13213232132&hasDefault=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:25:29', 90, 2001001000, '服务端发生异常', '2019-07-02 20:25:29');
INSERT INTO `access_log` VALUES (47463, '66.51.15620703310138945', 154, 1, 'user-application', '/user-api/users/address/add', 'name=sdfs&tel=13213232132&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=12321312&isDefault=false&address=12321312&areaNo=120102&mobile=13213232132&hasDefault=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:25:31', 74, 2001001000, '服务端发生异常', '2019-07-02 20:25:31');
INSERT INTO `access_log` VALUES (47464, '65.3607.15620740682674037', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-02 21:27:48', 13, 1002001012, '访问令牌已过期', '2019-07-02 21:27:48');
INSERT INTO `access_log` VALUES (47465, '65.54.15620740682672209', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-02 21:27:48', 26, 1002001012, '访问令牌已过期', '2019-07-02 21:27:48');
INSERT INTO `access_log` VALUES (47466, '65.50.15620740682862265', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-02 21:27:48', 10, 1002001012, '访问令牌已过期', '2019-07-02 21:27:48');
INSERT INTO `access_log` VALUES (47467, '65.53.15620740754602255', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-02 21:27:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 21:27:55');
INSERT INTO `access_log` VALUES (47468, '65.47.15620740857112231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-02 21:28:06', 64, 0, '', '2019-07-02 21:28:06');
INSERT INTO `access_log` VALUES (47469, '65.52.15620740861302281', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-02 21:28:06', 9, 0, '', '2019-07-02 21:28:06');
INSERT INTO `access_log` VALUES (47470, '65.45.15620740861312245', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-02 21:28:06', 11, 2001001000, '服务端发生异常', '2019-07-02 21:28:06');
INSERT INTO `access_log` VALUES (47471, '65.51.15620740861392301', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-02 21:28:06', 9, 0, '', '2019-07-02 21:28:06');
INSERT INTO `access_log` VALUES (47472, '65.3607.15620740901754039', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-02 21:28:10', 18, 0, '', '2019-07-02 21:28:10');
INSERT INTO `access_log` VALUES (47473, '65.54.15620740901782211', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-02 21:28:10', 17, 2001001000, '服务端发生异常', '2019-07-02 21:28:10');
INSERT INTO `access_log` VALUES (47474, '65.50.15620740901802267', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-02 21:28:10', 17, 0, '', '2019-07-02 21:28:10');
INSERT INTO `access_log` VALUES (47475, '59.75.15620740993100841', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-02 21:28:19', 15, 0, '', '2019-07-02 21:28:19');
INSERT INTO `access_log` VALUES (47476, '59.72.15620740993170837', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-02 21:28:19', 15, 2001001000, '服务端发生异常', '2019-07-02 21:28:19');
INSERT INTO `access_log` VALUES (47477, '59.77.15620741032370823', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.226.198', '2019-07-02 21:28:23', 8, 0, '', '2019-07-02 21:28:23');
INSERT INTO `access_log` VALUES (47478, '59.73.15620741032390841', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.226.198', '2019-07-02 21:28:23', 19, 2001001000, '服务端发生异常', '2019-07-02 21:28:23');
INSERT INTO `access_log` VALUES (47479, '64.84.15620741050690955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.226.198', '2019-07-02 21:28:25', 19, 0, '', '2019-07-02 21:28:25');
INSERT INTO `access_log` VALUES (47480, '64.82.15620741052570971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.92.226.198', '2019-07-02 21:28:25', 12, 0, '', '2019-07-02 21:28:25');
INSERT INTO `access_log` VALUES (47481, '59.73.15620766475970875', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.151.185.49', '2019-07-02 22:10:48', 15, 0, '', '2019-07-02 22:10:48');
INSERT INTO `access_log` VALUES (47482, '59.76.15620766475970863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.151.185.49', '2019-07-02 22:10:48', 17, 2001001000, '服务端发生异常', '2019-07-02 22:10:48');
INSERT INTO `access_log` VALUES (47483, '64.83.15620766539490991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-02 22:10:54', 12, 0, '', '2019-07-02 22:10:54');
INSERT INTO `access_log` VALUES (47484, '64.80.15620766540900999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-02 22:10:54', 2, 0, '', '2019-07-02 22:10:54');
INSERT INTO `access_log` VALUES (47485, '64.85.15620766559421007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-02 22:10:56', 2, 0, '', '2019-07-02 22:10:56');
INSERT INTO `access_log` VALUES (47486, '64.78.15620766566191001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-02 22:10:57', 2, 0, '', '2019-07-02 22:10:57');
INSERT INTO `access_log` VALUES (47487, '59.78.15620766626640865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-02 22:11:03', 3, 0, '', '2019-07-02 22:11:03');
INSERT INTO `access_log` VALUES (47488, '59.71.15620766626640871', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-02 22:11:03', 13, 2001001000, '服务端发生异常', '2019-07-02 22:11:03');
INSERT INTO `access_log` VALUES (47489, '59.71.15620769451540875', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.151.185.49', '2019-07-02 22:15:45', 3, 0, '', '2019-07-02 22:15:45');
INSERT INTO `access_log` VALUES (47490, '59.74.15620769452330879', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.151.185.49', '2019-07-02 22:15:45', 15, 2001001000, '服务端发生异常', '2019-07-02 22:15:45');
INSERT INTO `access_log` VALUES (47491, '64.77.15620769510110985', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-02 22:15:51', 3, 0, '', '2019-07-02 22:15:51');
INSERT INTO `access_log` VALUES (47492, '64.81.15620769513100989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-02 22:15:51', 2, 0, '', '2019-07-02 22:15:51');
INSERT INTO `access_log` VALUES (47493, '65.53.15620769661012295', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.151.185.49', '2019-07-02 22:16:06', 4, 1002001012, '访问令牌已过期', '2019-07-02 22:16:06');
INSERT INTO `access_log` VALUES (47494, '65.47.15620769661032271', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.151.185.49', '2019-07-02 22:16:06', 6, 1002001012, '访问令牌已过期', '2019-07-02 22:16:06');
INSERT INTO `access_log` VALUES (47495, '65.52.15620769661032321', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.151.185.49', '2019-07-02 22:16:06', 6, 1002001012, '访问令牌已过期', '2019-07-02 22:16:06');
INSERT INTO `access_log` VALUES (47496, '65.51.15620769680572341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.151.185.49', '2019-07-02 22:16:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 22:16:08');
INSERT INTO `access_log` VALUES (47497, '65.46.15620769721302355', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.151.185.49', '2019-07-02 22:16:12', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-02 22:16:12');
INSERT INTO `access_log` VALUES (47498, '65.50.15620769852452307', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.151.185.49', '2019-07-02 22:16:25', 81, 0, '', '2019-07-02 22:16:25');
INSERT INTO `access_log` VALUES (47499, '65.54.15620769856262251', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.151.185.49', '2019-07-02 22:16:26', 12, 0, '', '2019-07-02 22:16:26');
INSERT INTO `access_log` VALUES (47500, '65.49.15620769856342289', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.151.185.49', '2019-07-02 22:16:26', 11, 2001001000, '服务端发生异常', '2019-07-02 22:16:26');
INSERT INTO `access_log` VALUES (47501, '65.47.15620769856732273', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.151.185.49', '2019-07-02 22:16:26', 10, 0, '', '2019-07-02 22:16:26');
INSERT INTO `access_log` VALUES (47502, '64.77.15620782750311003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-02 22:37:55', 2, 0, '', '2019-07-02 22:37:55');
INSERT INTO `access_log` VALUES (47503, '64.81.15620782755931007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-02 22:37:56', 2, 0, '', '2019-07-02 22:37:56');
INSERT INTO `access_log` VALUES (47504, '64.85.15620801725971055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-02 23:09:33', 13, 0, '', '2019-07-02 23:09:33');
INSERT INTO `access_log` VALUES (47505, '59.73.15620846516060983', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; VTR-AL00 Build/HUAWEIVTR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.138.0.140', '2019-07-03 00:24:12', 10, 0, '', '2019-07-03 00:24:12');
INSERT INTO `access_log` VALUES (47506, '59.76.15620846516070971', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; VTR-AL00 Build/HUAWEIVTR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.138.0.140', '2019-07-03 00:24:12', 15, 2001001000, '服务端发生异常', '2019-07-03 00:24:12');
INSERT INTO `access_log` VALUES (47507, '64.85.15620846576541115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; VTR-AL00 Build/HUAWEIVTR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.138.0.140', '2019-07-03 00:24:18', 12, 0, '', '2019-07-03 00:24:18');
INSERT INTO `access_log` VALUES (47508, '64.78.15620846580361109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; VTR-AL00 Build/HUAWEIVTR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.138.0.140', '2019-07-03 00:24:18', 3, 0, '', '2019-07-03 00:24:18');
INSERT INTO `access_log` VALUES (47509, '64.81.15620846673301093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; VTR-AL00 Build/HUAWEIVTR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.138.0.140', '2019-07-03 00:24:27', 2, 0, '', '2019-07-03 00:24:27');
INSERT INTO `access_log` VALUES (47510, '64.79.15620846675781111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; VTR-AL00 Build/HUAWEIVTR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.138.0.140', '2019-07-03 00:24:28', 2, 0, '', '2019-07-03 00:24:28');
INSERT INTO `access_log` VALUES (47511, '64.76.15620846757381097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; VTR-AL00 Build/HUAWEIVTR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.138.0.140', '2019-07-03 00:24:36', 2, 0, '', '2019-07-03 00:24:36');
INSERT INTO `access_log` VALUES (47512, '64.82.15620846760251115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; VTR-AL00 Build/HUAWEIVTR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.138.0.140', '2019-07-03 00:24:36', 2, 0, '', '2019-07-03 00:24:36');
INSERT INTO `access_log` VALUES (47513, '59.71.15620846773970979', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; VTR-AL00 Build/HUAWEIVTR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.138.0.140', '2019-07-03 00:24:37', 3, 0, '', '2019-07-03 00:24:37');
INSERT INTO `access_log` VALUES (47514, '59.74.15620846774020983', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; VTR-AL00 Build/HUAWEIVTR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.138.0.140', '2019-07-03 00:24:37', 12, 2001001000, '服务端发生异常', '2019-07-03 00:24:37');
INSERT INTO `access_log` VALUES (47515, '64.80.15620857540601123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-03 00:42:34', 2, 0, '', '2019-07-03 00:42:34');
INSERT INTO `access_log` VALUES (47516, '64.85.15620857549871131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-03 00:42:35', 2, 0, '', '2019-07-03 00:42:35');
INSERT INTO `access_log` VALUES (47517, '64.77.15620857562641105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-03 00:42:36', 2, 0, '', '2019-07-03 00:42:36');
INSERT INTO `access_log` VALUES (47518, '64.81.15620857586721109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-03 00:42:39', 2, 0, '', '2019-07-03 00:42:39');
INSERT INTO `access_log` VALUES (47519, '64.79.15620857600781127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-03 00:42:40', 2, 0, '', '2019-07-03 00:42:40');
INSERT INTO `access_log` VALUES (47520, '64.84.15620857607531115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.151.185.49', '2019-07-03 00:42:41', 2, 0, '', '2019-07-03 00:42:41');
INSERT INTO `access_log` VALUES (47521, '59.78.15620915325641065', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Mobile Safari/537.36', '116.237.204.140', '2019-07-03 02:18:53', 11, 0, '', '2019-07-03 02:18:53');
INSERT INTO `access_log` VALUES (47522, '59.71.15620915325651071', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Mobile Safari/537.36', '116.237.204.140', '2019-07-03 02:18:53', 20, 2001001000, '服务端发生异常', '2019-07-03 02:18:53');
INSERT INTO `access_log` VALUES (47523, '59.80.15621143548711361', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:39:15', 13, 0, '', '2019-07-03 08:39:15');
INSERT INTO `access_log` VALUES (47524, '59.75.15621143548731381', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:39:15', 18, 2001001000, '服务端发生异常', '2019-07-03 08:39:15');
INSERT INTO `access_log` VALUES (47525, '64.81.15621143613221491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.135.163.82', '2019-07-03 08:39:21', 14, 0, '', '2019-07-03 08:39:21');
INSERT INTO `access_log` VALUES (47526, '64.79.15621143614321509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.135.163.82', '2019-07-03 08:39:21', 4, 0, '', '2019-07-03 08:39:21');
INSERT INTO `access_log` VALUES (47527, '64.84.15621143628611497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.135.163.82', '2019-07-03 08:39:23', 2, 0, '', '2019-07-03 08:39:23');
INSERT INTO `access_log` VALUES (47528, '64.76.15621143634521495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.135.163.82', '2019-07-03 08:39:23', 1, 0, '', '2019-07-03 08:39:23');
INSERT INTO `access_log` VALUES (47529, '64.82.15621143641221513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.135.163.82', '2019-07-03 08:39:24', 2, 0, '', '2019-07-03 08:39:24');
INSERT INTO `access_log` VALUES (47530, '64.83.15621143645911499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.135.163.82', '2019-07-03 08:39:25', 2, 0, '', '2019-07-03 08:39:25');
INSERT INTO `access_log` VALUES (47531, '59.76.15621143657711369', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.135.163.82', '2019-07-03 08:39:26', 4, 0, '', '2019-07-03 08:39:26');
INSERT INTO `access_log` VALUES (47532, '59.77.15621143657701363', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.135.163.82', '2019-07-03 08:39:26', 16, 2001001000, '服务端发生异常', '2019-07-03 08:39:26');
INSERT INTO `access_log` VALUES (47533, '65.46.15621143771762855', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '117.131.117.100', '2019-07-03 08:39:37', 0, 1002001015, '账号未登陆', '2019-07-03 08:39:37');
INSERT INTO `access_log` VALUES (47534, '65.45.15621143771762783', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '117.131.117.100', '2019-07-03 08:39:37', 0, 1002001015, '账号未登陆', '2019-07-03 08:39:37');
INSERT INTO `access_log` VALUES (47535, '65.3607.15621143771794579', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '117.131.117.100', '2019-07-03 08:39:37', 1, 1002001015, '账号未登陆', '2019-07-03 08:39:37');
INSERT INTO `access_log` VALUES (47536, '65.54.15621143798042751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '117.131.117.100', '2019-07-03 08:39:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 08:39:40');
INSERT INTO `access_log` VALUES (47537, '65.49.15621143875062789', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:39:48', 1, 1002001015, '账号未登陆', '2019-07-03 08:39:48');
INSERT INTO `access_log` VALUES (47538, '65.47.15621143875112773', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:39:48', 0, 1002001015, '账号未登陆', '2019-07-03 08:39:48');
INSERT INTO `access_log` VALUES (47539, '65.52.15621143875172823', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:39:48', 0, 1002001015, '账号未登陆', '2019-07-03 08:39:48');
INSERT INTO `access_log` VALUES (47540, '65.53.15621143898132797', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:39:50', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 08:39:50');
INSERT INTO `access_log` VALUES (47541, '65.3607.15621143952454581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai111&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:39:55', 113, 0, '', '2019-07-03 08:39:55');
INSERT INTO `access_log` VALUES (47542, '65.46.15621143955852857', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:39:56', 10, 0, '', '2019-07-03 08:39:56');
INSERT INTO `access_log` VALUES (47543, '65.50.15621143955932809', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:39:56', 10, 0, '', '2019-07-03 08:39:56');
INSERT INTO `access_log` VALUES (47544, '65.45.15621143955922785', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:39:56', 9, 0, '', '2019-07-03 08:39:56');
INSERT INTO `access_log` VALUES (47545, '65.54.15621143989072753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '117.131.117.100', '2019-07-03 08:39:59', 65, 0, '', '2019-07-03 08:39:59');
INSERT INTO `access_log` VALUES (47546, '65.49.15621143994762791', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '117.131.117.100', '2019-07-03 08:39:59', 19, 0, '', '2019-07-03 08:39:59');
INSERT INTO `access_log` VALUES (47547, '65.47.15621143994762775', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '117.131.117.100', '2019-07-03 08:39:59', 20, 2001001000, '服务端发生异常', '2019-07-03 08:39:59');
INSERT INTO `access_log` VALUES (47548, '65.52.15621143994782825', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '117.131.117.100', '2019-07-03 08:39:59', 20, 0, '', '2019-07-03 08:39:59');
INSERT INTO `access_log` VALUES (47549, '62.80.15621144031390793', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:40:03', 89, 0, '', '2019-07-03 08:40:03');
INSERT INTO `access_log` VALUES (47550, '64.81.15621144063421493', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:40:06', 11, 0, '', '2019-07-03 08:40:06');
INSERT INTO `access_log` VALUES (47551, '64.77.15621144063421489', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:40:06', 14, 0, '', '2019-07-03 08:40:06');
INSERT INTO `access_log` VALUES (47552, '65.53.15621144064342799', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '117.131.117.100', '2019-07-03 08:40:06', 9, 0, '', '2019-07-03 08:40:06');
INSERT INTO `access_log` VALUES (47553, '65.51.15621144064352845', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '117.131.117.100', '2019-07-03 08:40:06', 8, 2001001000, '服务端发生异常', '2019-07-03 08:40:06');
INSERT INTO `access_log` VALUES (47554, '65.3607.15621144064384583', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '117.131.117.100', '2019-07-03 08:40:06', 8, 0, '', '2019-07-03 08:40:06');
INSERT INTO `access_log` VALUES (47555, '66.51.15621144136049533', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:40:14', 25, 0, '', '2019-07-03 08:40:14');
INSERT INTO `access_log` VALUES (47556, '59.71.15621144161671377', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.91.60.107', '2019-07-03 08:40:16', 21, 2001001000, '服务端发生异常', '2019-07-03 08:40:16');
INSERT INTO `access_log` VALUES (47557, '59.74.15621144183401381', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:40:18', 16, 0, '', '2019-07-03 08:40:18');
INSERT INTO `access_log` VALUES (47558, '64.84.15621144211311499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.129.6.251', '2019-07-03 08:40:21', 5, 0, '', '2019-07-03 08:40:21');
INSERT INTO `access_log` VALUES (47559, '59.75.15621144211681383', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.89.239.230', '2019-07-03 08:40:21', 2, 0, '', '2019-07-03 08:40:21');
INSERT INTO `access_log` VALUES (47560, '64.76.15621144224661497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.177', '2019-07-03 08:40:22', 3, 0, '', '2019-07-03 08:40:22');
INSERT INTO `access_log` VALUES (47561, '65.45.15621144234932787', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:40:23', 25, 0, '', '2019-07-03 08:40:24');
INSERT INTO `access_log` VALUES (47562, '64.82.15621144264371515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.91.60.107', '2019-07-03 08:40:26', 1, 0, '', '2019-07-03 08:40:26');
INSERT INTO `access_log` VALUES (47563, '65.54.15621144268612755', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:40:27', 10, 0, '', '2019-07-03 08:40:27');
INSERT INTO `access_log` VALUES (47564, '65.47.15621144288062777', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:40:29', 10, 0, '', '2019-07-03 08:40:29');
INSERT INTO `access_log` VALUES (47565, '62.86.15621144362790775', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:40:36', 14, 0, '', '2019-07-03 08:40:36');
INSERT INTO `access_log` VALUES (47566, '64.80.15621144382051509', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:40:38', 11, 0, '', '2019-07-03 08:40:38');
INSERT INTO `access_log` VALUES (47567, '64.85.15621144382081517', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-03 08:40:38', 10, 0, '', '2019-07-03 08:40:38');
INSERT INTO `access_log` VALUES (47568, '62.81.15621144638080763', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '180.97.118.223', '2019-07-03 08:41:04', 1, 1002001015, '账号未登陆', '2019-07-03 08:41:04');
INSERT INTO `access_log` VALUES (47569, '64.81.15621144718821495', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.174', '2019-07-03 08:41:12', 1, 1002001015, '账号未登陆', '2019-07-03 08:41:12');
INSERT INTO `access_log` VALUES (47570, '66.53.15621144732259513', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '180.97.118.219', '2019-07-03 08:41:13', 0, 1002001015, '账号未登陆', '2019-07-03 08:41:13');
INSERT INTO `access_log` VALUES (47571, '59.79.15621144810881383', 0, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.207.186', '2019-07-03 08:41:21', 0, 1002001015, '账号未登陆', '2019-07-03 08:41:21');
INSERT INTO `access_log` VALUES (47572, '65.53.15621144865202801', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.89.29.86', '2019-07-03 08:41:27', 1, 1002001015, '账号未登陆', '2019-07-03 08:41:27');
INSERT INTO `access_log` VALUES (47573, '65.46.15621144882962861', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.227', '2019-07-03 08:41:28', 0, 1002001015, '账号未登陆', '2019-07-03 08:41:28');
INSERT INTO `access_log` VALUES (47574, '59.77.15621160977541387', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 09:08:18', 3, 0, '', '2019-07-03 09:08:18');
INSERT INTO `access_log` VALUES (47575, '59.73.15621160977571405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 09:08:18', 15, 2001001000, '服务端发生异常', '2019-07-03 09:08:18');
INSERT INTO `access_log` VALUES (47576, '64.81.15621161050991517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 09:08:25', 2, 0, '', '2019-07-03 09:08:25');
INSERT INTO `access_log` VALUES (47577, '64.79.15621161052291535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 09:08:25', 1, 0, '', '2019-07-03 09:08:25');
INSERT INTO `access_log` VALUES (47578, '65.52.15621170924062865', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 09:24:52', 0, 1002001015, '账号未登陆', '2019-07-03 09:24:52');
INSERT INTO `access_log` VALUES (47579, '65.53.15621170924072837', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 09:24:52', 0, 1002001015, '账号未登陆', '2019-07-03 09:24:52');
INSERT INTO `access_log` VALUES (47580, '65.3607.15621170924104623', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 09:24:52', 0, 1002001015, '账号未登陆', '2019-07-03 09:24:52');
INSERT INTO `access_log` VALUES (47581, '65.46.15621170945352891', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 09:24:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 09:24:55');
INSERT INTO `access_log` VALUES (47582, '59.76.15621170985841407', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.61.119.35', '2019-07-03 09:24:59', 3, 0, '', '2019-07-03 09:24:59');
INSERT INTO `access_log` VALUES (47583, '59.73.15621170985971419', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.61.119.35', '2019-07-03 09:24:59', 21, 2001001000, '服务端发生异常', '2019-07-03 09:24:59');
INSERT INTO `access_log` VALUES (47584, '64.78.15621171054481547', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.61.119.35', '2019-07-03 09:25:05', 2, 0, '', '2019-07-03 09:25:05');
INSERT INTO `access_log` VALUES (47585, '64.81.15621171056071531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.61.119.35', '2019-07-03 09:25:06', 2, 0, '', '2019-07-03 09:25:06');
INSERT INTO `access_log` VALUES (47586, '64.79.15621171074721549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.61.119.35', '2019-07-03 09:25:07', 2, 0, '', '2019-07-03 09:25:07');
INSERT INTO `access_log` VALUES (47587, '64.84.15621171081401537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.61.119.35', '2019-07-03 09:25:08', 2, 0, '', '2019-07-03 09:25:08');
INSERT INTO `access_log` VALUES (47588, '65.47.15621171109242813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 09:25:11', 75, 0, '', '2019-07-03 09:25:11');
INSERT INTO `access_log` VALUES (47589, '65.54.15621171112812795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 09:25:11', 9, 0, '', '2019-07-03 09:25:11');
INSERT INTO `access_log` VALUES (47590, '65.51.15621171112892885', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 09:25:11', 9, 2001001000, '服务端发生异常', '2019-07-03 09:25:11');
INSERT INTO `access_log` VALUES (47591, '65.49.15621171112922833', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 09:25:11', 8, 0, '', '2019-07-03 09:25:11');
INSERT INTO `access_log` VALUES (47592, '66.57.15621171244419553', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=lkjjjjjk&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.61.119.35', '2019-07-03 09:25:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号必须都是数字', '2019-07-03 09:25:24');
INSERT INTO `access_log` VALUES (47593, '66.49.15621171339569565', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15529031111&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.61.119.35', '2019-07-03 09:25:34', 16, 1001003000, '验证码不存在', '2019-07-03 09:25:34');
INSERT INTO `access_log` VALUES (47594, '66.54.15621171465649559', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15529031111&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.61.119.35', '2019-07-03 09:25:47', 7, 1001003000, '验证码不存在', '2019-07-03 09:25:47');
INSERT INTO `access_log` VALUES (47595, '65.3607.15621181830424639', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.155.7.13', '2019-07-03 09:43:03', 3, 1002001012, '访问令牌已过期', '2019-07-03 09:43:03');
INSERT INTO `access_log` VALUES (47596, '65.53.15621181830422853', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.155.7.13', '2019-07-03 09:43:03', 20, 1002001012, '访问令牌已过期', '2019-07-03 09:43:03');
INSERT INTO `access_log` VALUES (47597, '65.45.15621181830682847', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.155.7.13', '2019-07-03 09:43:03', 4, 1002001012, '访问令牌已过期', '2019-07-03 09:43:03');
INSERT INTO `access_log` VALUES (47598, '65.46.15621181873272907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.155.7.13', '2019-07-03 09:43:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 09:43:07');
INSERT INTO `access_log` VALUES (47599, '65.47.15621181904982829', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.150.46.89', '2019-07-03 09:43:10', 0, 1002001015, '账号未登陆', '2019-07-03 09:43:11');
INSERT INTO `access_log` VALUES (47600, '65.51.15621181904992901', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.150.46.89', '2019-07-03 09:43:11', 0, 1002001015, '账号未登陆', '2019-07-03 09:43:11');
INSERT INTO `access_log` VALUES (47601, '65.49.15621181904992849', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.150.46.89', '2019-07-03 09:43:11', 0, 1002001015, '账号未登陆', '2019-07-03 09:43:11');
INSERT INTO `access_log` VALUES (47602, '65.54.15621181913252811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.155.7.13', '2019-07-03 09:43:11', 67, 0, '', '2019-07-03 09:43:11');
INSERT INTO `access_log` VALUES (47603, '65.52.15621181916212883', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.155.7.13', '2019-07-03 09:43:12', 18, 0, '', '2019-07-03 09:43:12');
INSERT INTO `access_log` VALUES (47604, '65.53.15621181916282855', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.155.7.13', '2019-07-03 09:43:12', 17, 2001001000, '服务端发生异常', '2019-07-03 09:43:12');
INSERT INTO `access_log` VALUES (47605, '65.3607.15621181916384641', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.155.7.13', '2019-07-03 09:43:12', 9, 0, '', '2019-07-03 09:43:12');
INSERT INTO `access_log` VALUES (47606, '65.45.15621181950552849', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.150.46.89', '2019-07-03 09:43:15', 67, 0, '', '2019-07-03 09:43:15');
INSERT INTO `access_log` VALUES (47607, '65.46.15621181953562909', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.150.46.89', '2019-07-03 09:43:15', 9, 0, '', '2019-07-03 09:43:15');
INSERT INTO `access_log` VALUES (47608, '65.50.15621181953602871', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.150.46.89', '2019-07-03 09:43:15', 9, 2001001000, '服务端发生异常', '2019-07-03 09:43:15');
INSERT INTO `access_log` VALUES (47609, '65.51.15621181953662903', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.150.46.89', '2019-07-03 09:43:15', 9, 0, '', '2019-07-03 09:43:15');
INSERT INTO `access_log` VALUES (47610, '65.49.15621182032302851', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.155.7.13', '2019-07-03 09:43:23', 10, 0, '', '2019-07-03 09:43:23');
INSERT INTO `access_log` VALUES (47611, '65.47.15621182032342831', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.155.7.13', '2019-07-03 09:43:23', 9, 0, '', '2019-07-03 09:43:23');
INSERT INTO `access_log` VALUES (47612, '65.54.15621182032362813', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '219.155.7.13', '2019-07-03 09:43:23', 10, 2001001000, '服务端发生异常', '2019-07-03 09:43:23');
INSERT INTO `access_log` VALUES (47613, '65.53.15621182068292857', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.150.46.89', '2019-07-03 09:43:27', 10, 0, '', '2019-07-03 09:43:27');
INSERT INTO `access_log` VALUES (47614, '65.3607.15621182068344643', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.150.46.89', '2019-07-03 09:43:27', 9, 2001001000, '服务端发生异常', '2019-07-03 09:43:27');
INSERT INTO `access_log` VALUES (47615, '65.45.15621182068372851', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.150.46.89', '2019-07-03 09:43:27', 9, 0, '', '2019-07-03 09:43:27');
INSERT INTO `access_log` VALUES (47616, '59.72.15621182351401431', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.150.46.89', '2019-07-03 09:43:55', 3, 0, '', '2019-07-03 09:43:55');
INSERT INTO `access_log` VALUES (47617, '59.75.15621182351401435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.150.46.89', '2019-07-03 09:43:55', 12, 2001001000, '服务端发生异常', '2019-07-03 09:43:55');
INSERT INTO `access_log` VALUES (47618, '65.46.15621197111472933', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 10:08:31', 3, 1002001012, '访问令牌已过期', '2019-07-03 10:08:31');
INSERT INTO `access_log` VALUES (47619, '65.45.15621197111392871', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 10:08:31', 4, 1002001012, '访问令牌已过期', '2019-07-03 10:08:31');
INSERT INTO `access_log` VALUES (47620, '65.50.15621197111462895', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 10:08:31', 3, 1002001012, '访问令牌已过期', '2019-07-03 10:08:31');
INSERT INTO `access_log` VALUES (47621, '65.47.15621197130542853', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 10:08:33', 462, 0, '', '2019-07-03 10:08:34');
INSERT INTO `access_log` VALUES (47622, '65.49.15621197137962873', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 10:08:34', 9, 0, '', '2019-07-03 10:08:34');
INSERT INTO `access_log` VALUES (47623, '65.51.15621197137992925', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 10:08:34', 9, 0, '', '2019-07-03 10:08:34');
INSERT INTO `access_log` VALUES (47624, '65.54.15621197138012835', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 10:08:34', 9, 0, '', '2019-07-03 10:08:34');
INSERT INTO `access_log` VALUES (47625, '64.80.15621197180521581', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 10:08:38', 23, 0, '', '2019-07-03 10:08:38');
INSERT INTO `access_log` VALUES (47626, '66.51.15621212423509625', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 10:34:02', 120, 0, '', '2019-07-03 10:34:02');
INSERT INTO `access_log` VALUES (47627, '65.49.15621219422112903', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:45:42', 4, 1002001012, '访问令牌已过期', '2019-07-03 10:45:42');
INSERT INTO `access_log` VALUES (47628, '65.52.15621219422122939', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:45:42', 5, 1002001012, '访问令牌已过期', '2019-07-03 10:45:42');
INSERT INTO `access_log` VALUES (47629, '65.53.15621219422162909', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:45:42', 8, 1002001012, '访问令牌已过期', '2019-07-03 10:45:42');
INSERT INTO `access_log` VALUES (47630, '65.3607.15621219465234697', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:45:47', 84, 0, '', '2019-07-03 10:45:47');
INSERT INTO `access_log` VALUES (47631, '65.50.15621219468042927', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:45:47', 157, 0, '', '2019-07-03 10:45:47');
INSERT INTO `access_log` VALUES (47632, '65.45.15621219468052903', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:45:47', 157, 0, '', '2019-07-03 10:45:47');
INSERT INTO `access_log` VALUES (47633, '65.46.15621219468082965', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:45:47', 153, 0, '', '2019-07-03 10:45:47');
INSERT INTO `access_log` VALUES (47634, '64.77.15621219525211593', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:45:53', 21, 0, '', '2019-07-03 10:45:53');
INSERT INTO `access_log` VALUES (47635, '64.80.15621219525191611', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:45:53', 24, 0, '', '2019-07-03 10:45:53');
INSERT INTO `access_log` VALUES (47636, '59.74.15621220611351485', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.231.98.112', '2019-07-03 10:47:41', 16, 0, '', '2019-07-03 10:47:41');
INSERT INTO `access_log` VALUES (47637, '59.80.15621220611351467', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.231.98.112', '2019-07-03 10:47:41', 21, 2001001000, '服务端发生异常', '2019-07-03 10:47:41');
INSERT INTO `access_log` VALUES (47638, '65.47.15621220900082887', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.128.162.98', '2019-07-03 10:48:10', 0, 1002001015, '账号未登陆', '2019-07-03 10:48:10');
INSERT INTO `access_log` VALUES (47639, '65.54.15621220900092869', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.128.162.98', '2019-07-03 10:48:10', 0, 1002001015, '账号未登陆', '2019-07-03 10:48:10');
INSERT INTO `access_log` VALUES (47640, '65.51.15621220900092959', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.128.162.98', '2019-07-03 10:48:10', 0, 1002001015, '账号未登陆', '2019-07-03 10:48:10');
INSERT INTO `access_log` VALUES (47641, '65.53.15621220929582913', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.128.162.98', '2019-07-03 10:48:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 10:48:13');
INSERT INTO `access_log` VALUES (47642, '65.49.15621220979802907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.128.162.98', '2019-07-03 10:48:18', 316, 0, '', '2019-07-03 10:48:18');
INSERT INTO `access_log` VALUES (47643, '65.52.15621220987432943', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.128.162.98', '2019-07-03 10:48:19', 8, 0, '', '2019-07-03 10:48:19');
INSERT INTO `access_log` VALUES (47644, '65.3607.15621220987464701', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.128.162.98', '2019-07-03 10:48:19', 8, 2001001000, '服务端发生异常', '2019-07-03 10:48:19');
INSERT INTO `access_log` VALUES (47645, '65.46.15621220987492969', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.128.162.98', '2019-07-03 10:48:19', 7, 0, '', '2019-07-03 10:48:19');
INSERT INTO `access_log` VALUES (47646, '65.50.15621221059142931', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.128.162.98', '2019-07-03 10:48:26', 9, 0, '', '2019-07-03 10:48:26');
INSERT INTO `access_log` VALUES (47647, '65.51.15621221059152961', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.128.162.98', '2019-07-03 10:48:26', 9, 2001001000, '服务端发生异常', '2019-07-03 10:48:26');
INSERT INTO `access_log` VALUES (47648, '65.47.15621221059182889', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.128.162.98', '2019-07-03 10:48:26', 9, 0, '', '2019-07-03 10:48:26');
INSERT INTO `access_log` VALUES (47649, '64.79.15621221414491617', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:49:01', 13, 0, '', '2019-07-03 10:49:01');
INSERT INTO `access_log` VALUES (47650, '64.83.15621221626481607', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:49:23', 10, 0, '', '2019-07-03 10:49:23');
INSERT INTO `access_log` VALUES (47651, '64.82.15621221626461621', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:49:23', 15, 0, '', '2019-07-03 10:49:23');
INSERT INTO `access_log` VALUES (47652, '64.77.15621221711021597', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:49:31', 8, 0, '', '2019-07-03 10:49:31');
INSERT INTO `access_log` VALUES (47653, '64.85.15621221711011623', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:49:31', 12, 0, '', '2019-07-03 10:49:31');
INSERT INTO `access_log` VALUES (47654, '64.84.15621222055131607', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:50:06', 11, 0, '', '2019-07-03 10:50:06');
INSERT INTO `access_log` VALUES (47655, '64.79.15621222055131619', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:50:06', 13, 0, '', '2019-07-03 10:50:06');
INSERT INTO `access_log` VALUES (47656, '64.83.15621222076101609', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:50:08', 19, 0, '', '2019-07-03 10:50:08');
INSERT INTO `access_log` VALUES (47657, '64.76.15621222076091605', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:50:08', 22, 0, '', '2019-07-03 10:50:08');
INSERT INTO `access_log` VALUES (47658, '64.82.15621222076401623', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:50:08', 10, 0, '', '2019-07-03 10:50:08');
INSERT INTO `access_log` VALUES (47659, '64.77.15621222147421599', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:50:15', 9, 0, '', '2019-07-03 10:50:15');
INSERT INTO `access_log` VALUES (47660, '64.85.15621222147421625', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:50:15', 10, 0, '', '2019-07-03 10:50:15');
INSERT INTO `access_log` VALUES (47661, '64.78.15621222167021619', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:50:17', 10, 0, '', '2019-07-03 10:50:17');
INSERT INTO `access_log` VALUES (47662, '64.80.15621222167021617', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:50:17', 12, 0, '', '2019-07-03 10:50:17');
INSERT INTO `access_log` VALUES (47663, '64.83.15621222261261611', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:50:26', 9, 0, '', '2019-07-03 10:50:26');
INSERT INTO `access_log` VALUES (47664, '64.79.15621222261251621', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:50:26', 11, 0, '', '2019-07-03 10:50:26');
INSERT INTO `access_log` VALUES (47665, '64.84.15621222261241609', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:50:26', 16, 0, '', '2019-07-03 10:50:26');
INSERT INTO `access_log` VALUES (47666, '64.81.15621226134421609', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:56:53', 15, 0, '', '2019-07-03 10:56:53');
INSERT INTO `access_log` VALUES (47667, '64.83.15621226134421617', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:56:53', 15, 0, '', '2019-07-03 10:56:53');
INSERT INTO `access_log` VALUES (47668, '64.79.15621226177391627', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:56:58', 14, 0, '', '2019-07-03 10:56:58');
INSERT INTO `access_log` VALUES (47669, '64.84.15621226177401615', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:56:58', 14, 0, '', '2019-07-03 10:56:58');
INSERT INTO `access_log` VALUES (47670, '64.76.15621226177671613', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:56:58', 9, 0, '', '2019-07-03 10:56:58');
INSERT INTO `access_log` VALUES (47671, '59.71.15621226182241489', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-03 10:56:58', 4, 0, '', '2019-07-03 10:56:58');
INSERT INTO `access_log` VALUES (47672, '59.80.15621226182361475', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-03 10:56:58', 19, 2001001000, '服务端发生异常', '2019-07-03 10:56:58');
INSERT INTO `access_log` VALUES (47673, '64.82.15621226240511631', 1, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=false&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:57:04', 116, 2001001000, '服务端发生异常', '2019-07-03 10:57:04');
INSERT INTO `access_log` VALUES (47674, '64.80.15621226381651625', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:57:18', 7, 0, '', '2019-07-03 10:57:18');
INSERT INTO `access_log` VALUES (47675, '64.77.15621226381641607', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:57:18', 10, 0, '', '2019-07-03 10:57:18');
INSERT INTO `access_log` VALUES (47676, '64.81.15621226443611611', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:57:24', 7, 0, '', '2019-07-03 10:57:24');
INSERT INTO `access_log` VALUES (47677, '64.83.15621226443611619', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:57:24', 9, 0, '', '2019-07-03 10:57:24');
INSERT INTO `access_log` VALUES (47678, '59.76.15621228089921485', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '120.220.45.40', '2019-07-03 11:00:09', 4, 0, '', '2019-07-03 11:00:09');
INSERT INTO `access_log` VALUES (47679, '59.73.15621228089921497', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '120.220.45.40', '2019-07-03 11:00:09', 14, 2001001000, '服务端发生异常', '2019-07-03 11:00:09');
INSERT INTO `access_log` VALUES (47680, '64.79.15621228313401631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '120.220.45.40', '2019-07-03 11:00:31', 3, 0, '', '2019-07-03 11:00:31');
INSERT INTO `access_log` VALUES (47681, '64.82.15621228316511635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '120.220.45.40', '2019-07-03 11:00:32', 2, 0, '', '2019-07-03 11:00:32');
INSERT INTO `access_log` VALUES (47682, '64.80.15621228365571629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '120.220.45.40', '2019-07-03 11:00:37', 2, 0, '', '2019-07-03 11:00:37');
INSERT INTO `access_log` VALUES (47683, '64.77.15621228369111611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '120.220.45.40', '2019-07-03 11:00:37', 2, 0, '', '2019-07-03 11:00:37');
INSERT INTO `access_log` VALUES (47684, '59.78.15621231362291491', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.116.143.211', '2019-07-03 11:05:36', 3, 0, '', '2019-07-03 11:05:36');
INSERT INTO `access_log` VALUES (47685, '59.71.15621231362311497', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.116.143.211', '2019-07-03 11:05:36', 12, 2001001000, '服务端发生异常', '2019-07-03 11:05:36');
INSERT INTO `access_log` VALUES (47686, '64.78.15621231403431635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.116.143.211', '2019-07-03 11:05:40', 3, 0, '', '2019-07-03 11:05:40');
INSERT INTO `access_log` VALUES (47687, '64.83.15621231404611627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.116.143.211', '2019-07-03 11:05:40', 2, 0, '', '2019-07-03 11:05:40');
INSERT INTO `access_log` VALUES (47688, '64.81.15621231418011619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.116.143.211', '2019-07-03 11:05:42', 2, 0, '', '2019-07-03 11:05:42');
INSERT INTO `access_log` VALUES (47689, '64.76.15621231423531623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.116.143.211', '2019-07-03 11:05:42', 2, 0, '', '2019-07-03 11:05:42');
INSERT INTO `access_log` VALUES (47690, '64.85.15621231694431643', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 11:06:09', 7, 0, '', '2019-07-03 11:06:09');
INSERT INTO `access_log` VALUES (47691, '64.82.15621231694401641', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 11:06:09', 11, 0, '', '2019-07-03 11:06:09');
INSERT INTO `access_log` VALUES (47692, '64.83.15621233722961631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '120.220.45.40', '2019-07-03 11:09:32', 2, 0, '', '2019-07-03 11:09:32');
INSERT INTO `access_log` VALUES (47693, '64.81.15621233726211623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/4512 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '120.220.45.40', '2019-07-03 11:09:33', 2, 0, '', '2019-07-03 11:09:33');
INSERT INTO `access_log` VALUES (47694, '59.79.15621233840521503', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.2.112 Mobile Safari/537.36', '120.220.45.40', '2019-07-03 11:09:44', 3, 0, '', '2019-07-03 11:09:44');
INSERT INTO `access_log` VALUES (47695, '59.77.15621233840521487', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MI 6 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 Quark/3.3.2.112 Mobile Safari/537.36', '120.220.45.40', '2019-07-03 11:09:44', 12, 2001001000, '服务端发生异常', '2019-07-03 11:09:44');
INSERT INTO `access_log` VALUES (47696, '59.76.15621236439241497', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:14:04', 3, 0, '', '2019-07-03 11:14:04');
INSERT INTO `access_log` VALUES (47697, '59.79.15621236439241507', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:14:04', 16, 2001001000, '服务端发生异常', '2019-07-03 11:14:04');
INSERT INTO `access_log` VALUES (47698, '59.78.15621236527341499', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:14:13', 2, 0, '', '2019-07-03 11:14:13');
INSERT INTO `access_log` VALUES (47699, '59.71.15621236527391505', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:14:13', 10, 2001001000, '服务端发生异常', '2019-07-03 11:14:13');
INSERT INTO `access_log` VALUES (47700, '66.56.15621236600129643', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:14:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-07-03 11:14:20');
INSERT INTO `access_log` VALUES (47701, '66.49.15621236721159653', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15992086969', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:14:32', 67, 0, '', '2019-07-03 11:14:32');
INSERT INTO `access_log` VALUES (47702, '66.51.15621237391389659', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15992086969&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:15:39', 188, 0, '', '2019-07-03 11:15:39');
INSERT INTO `access_log` VALUES (47703, '59.78.15621237464161501', 155, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:15:46', 967, 0, '', '2019-07-03 11:15:47');
INSERT INTO `access_log` VALUES (47704, '59.71.15621237464681507', 155, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:15:46', 933, 2001001000, '服务端发生异常', '2019-07-03 11:15:47');
INSERT INTO `access_log` VALUES (47705, '64.77.15621237502051625', 155, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:15:50', 37, 0, '', '2019-07-03 11:15:50');
INSERT INTO `access_log` VALUES (47706, '64.81.15621237505321629', 155, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:15:51', 4, 0, '', '2019-07-03 11:15:51');
INSERT INTO `access_log` VALUES (47707, '64.84.15621237519371635', 155, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:15:52', 334, 0, '', '2019-07-03 11:15:52');
INSERT INTO `access_log` VALUES (47708, '64.85.15621237528021653', 155, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:15:53', 5, 0, '', '2019-07-03 11:15:53');
INSERT INTO `access_log` VALUES (47709, '64.82.15621237533721651', 155, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:15:53', 5, 0, '', '2019-07-03 11:15:53');
INSERT INTO `access_log` VALUES (47710, 'N/A', 155, 1, 'search-application', '/search-api/users/product/page', 'keyword=515&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:15:58', 10, 0, '', '2019-07-03 11:15:58');
INSERT INTO `access_log` VALUES (47711, 'N/A', 155, 1, 'search-application', '/search-api/users/product/condition', 'keyword=515', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '125.90.49.6', '2019-07-03 11:15:58', 337, 0, '', '2019-07-03 11:15:59');
INSERT INTO `access_log` VALUES (47712, '59.71.15621238781611509', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.12.130.209', '2019-07-03 11:17:58', 3, 0, '', '2019-07-03 11:17:58');
INSERT INTO `access_log` VALUES (47713, '59.80.15621238781611495', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.12.130.209', '2019-07-03 11:17:58', 19, 2001001000, '服务端发生异常', '2019-07-03 11:17:58');
INSERT INTO `access_log` VALUES (47714, '59.76.15621242530191507', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.128.233.58', '2019-07-03 11:24:13', 3, 0, '', '2019-07-03 11:24:13');
INSERT INTO `access_log` VALUES (47715, '59.77.15621242530211501', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.128.233.58', '2019-07-03 11:24:13', 19, 2001001000, '服务端发生异常', '2019-07-03 11:24:13');
INSERT INTO `access_log` VALUES (47716, '65.46.15621243185492999', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.128.233.58', '2019-07-03 11:25:19', 0, 1002001015, '账号未登陆', '2019-07-03 11:25:19');
INSERT INTO `access_log` VALUES (47717, '65.45.15621243185502939', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.128.233.58', '2019-07-03 11:25:19', 1, 1002001015, '账号未登陆', '2019-07-03 11:25:19');
INSERT INTO `access_log` VALUES (47718, '65.3607.15621243185504733', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.128.233.58', '2019-07-03 11:25:19', 0, 1002001015, '账号未登陆', '2019-07-03 11:25:19');
INSERT INTO `access_log` VALUES (47719, '65.50.15621243260272961', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.128.233.58', '2019-07-03 11:25:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 11:25:26');
INSERT INTO `access_log` VALUES (47720, '65.51.15621243297862991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.128.233.58', '2019-07-03 11:25:30', 108, 0, '', '2019-07-03 11:25:30');
INSERT INTO `access_log` VALUES (47721, '65.54.15621243302892901', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.128.233.58', '2019-07-03 11:25:30', 9, 0, '', '2019-07-03 11:25:30');
INSERT INTO `access_log` VALUES (47722, '65.53.15621243302922945', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.128.233.58', '2019-07-03 11:25:30', 9, 2001001000, '服务端发生异常', '2019-07-03 11:25:30');
INSERT INTO `access_log` VALUES (47723, '65.49.15621243302972939', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.128.233.58', '2019-07-03 11:25:30', 16, 0, '', '2019-07-03 11:25:30');
INSERT INTO `access_log` VALUES (47724, '65.52.15621247799552981', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:00', 0, 1002001015, '账号未登陆', '2019-07-03 11:33:00');
INSERT INTO `access_log` VALUES (47725, '65.46.15621247799603007', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:00', 0, 1002001015, '账号未登陆', '2019-07-03 11:33:00');
INSERT INTO `access_log` VALUES (47726, '65.45.15621247799682947', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:00', 0, 1002001015, '账号未登陆', '2019-07-03 11:33:00');
INSERT INTO `access_log` VALUES (47727, '65.53.15621247819982953', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 11:33:02');
INSERT INTO `access_log` VALUES (47728, '65.51.15621247849082999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 11:33:05');
INSERT INTO `access_log` VALUES (47729, '65.50.15621248064242971', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:26', 61, 0, '', '2019-07-03 11:33:26');
INSERT INTO `access_log` VALUES (47730, '65.3607.15621248068534743', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:27', 11, 0, '', '2019-07-03 11:33:27');
INSERT INTO `access_log` VALUES (47731, '65.53.15621248068562955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:27', 9, 0, '', '2019-07-03 11:33:27');
INSERT INTO `access_log` VALUES (47732, '65.51.15621248071443001', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:27', 9, 2001001000, '服务端发生异常', '2019-07-03 11:33:27');
INSERT INTO `access_log` VALUES (47733, '65.49.15621248129732949', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:33', 9, 0, '', '2019-07-03 11:33:33');
INSERT INTO `access_log` VALUES (47734, '65.52.15621248129782985', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:33', 9, 0, '', '2019-07-03 11:33:33');
INSERT INTO `access_log` VALUES (47735, '65.45.15621248129822949', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:33', 10, 2001001000, '服务端发生异常', '2019-07-03 11:33:33');
INSERT INTO `access_log` VALUES (47736, '65.54.15621248211472911', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:41', 199, 0, '', '2019-07-03 11:33:41');
INSERT INTO `access_log` VALUES (47737, '65.47.15621248211432929', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:41', 203, 0, '', '2019-07-03 11:33:41');
INSERT INTO `access_log` VALUES (47738, '65.50.15621248211482973', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:41', 203, 2001001000, '服务端发生异常', '2019-07-03 11:33:41');
INSERT INTO `access_log` VALUES (47739, '65.3607.15621248248634745', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:45', 9, 0, '', '2019-07-03 11:33:45');
INSERT INTO `access_log` VALUES (47740, '65.53.15621248248732957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:45', 8, 0, '', '2019-07-03 11:33:45');
INSERT INTO `access_log` VALUES (47741, '65.51.15621248248773003', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.249.248', '2019-07-03 11:33:45', 10, 2001001000, '服务端发生异常', '2019-07-03 11:33:45');
INSERT INTO `access_log` VALUES (47742, '66.54.15621250117979665', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=16625582773', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.91.141.220', '2019-07-03 11:36:52', 57, 0, '', '2019-07-03 11:36:52');
INSERT INTO `access_log` VALUES (47743, '66.52.15621250219969655', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=16625582773&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.91.141.220', '2019-07-03 11:37:02', 305, 0, '', '2019-07-03 11:37:02');
INSERT INTO `access_log` VALUES (47744, '64.84.15621250327081653', 156, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 11:37:13', 7, 0, '', '2019-07-03 11:37:13');
INSERT INTO `access_log` VALUES (47745, '64.85.15621250328491671', 156, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 11:37:13', 5, 0, '', '2019-07-03 11:37:13');
INSERT INTO `access_log` VALUES (47746, '59.72.15621250334381527', 156, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 11:37:13', 8, 0, '', '2019-07-03 11:37:13');
INSERT INTO `access_log` VALUES (47747, '59.75.15621250334641531', 156, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 11:37:13', 18, 2001001000, '服务端发生异常', '2019-07-03 11:37:13');
INSERT INTO `access_log` VALUES (47748, '64.82.15621250366431669', 156, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 11:37:17', 5, 0, '', '2019-07-03 11:37:17');
INSERT INTO `access_log` VALUES (47749, '64.80.15621250367691663', 156, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 11:37:17', 4, 0, '', '2019-07-03 11:37:17');
INSERT INTO `access_log` VALUES (47750, '64.78.15621250403741665', 156, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 11:37:20', 5, 0, '', '2019-07-03 11:37:20');
INSERT INTO `access_log` VALUES (47751, '64.76.15621250408011653', 156, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 11:37:21', 5, 0, '', '2019-07-03 11:37:21');
INSERT INTO `access_log` VALUES (47752, '64.84.15621250475961655', 156, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 11:37:28', 5, 0, '', '2019-07-03 11:37:28');
INSERT INTO `access_log` VALUES (47753, '64.79.15621250477141667', 156, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 11:37:28', 4, 0, '', '2019-07-03 11:37:28');
INSERT INTO `access_log` VALUES (47754, '59.79.15621250481291529', 156, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 11:37:28', 5, 0, '', '2019-07-03 11:37:28');
INSERT INTO `access_log` VALUES (47755, '59.76.15621250481301519', 156, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 11:37:28', 13, 2001001000, '服务端发生异常', '2019-07-03 11:37:28');
INSERT INTO `access_log` VALUES (47756, '65.53.15621250782132961', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.197.244.238', '2019-07-03 11:37:58', 1, 1002001015, '账号未登陆', '2019-07-03 11:37:58');
INSERT INTO `access_log` VALUES (47757, '65.3607.15621250782124749', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.197.244.238', '2019-07-03 11:37:58', 0, 1002001015, '账号未登陆', '2019-07-03 11:37:58');
INSERT INTO `access_log` VALUES (47758, '65.51.15621250782173007', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.197.244.238', '2019-07-03 11:37:58', 0, 1002001015, '账号未登陆', '2019-07-03 11:37:58');
INSERT INTO `access_log` VALUES (47759, '65.49.15621250810592955', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.197.244.238', '2019-07-03 11:38:01', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 11:38:01');
INSERT INTO `access_log` VALUES (47760, '65.52.15621250849922991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.197.244.238', '2019-07-03 11:38:05', 95, 0, '', '2019-07-03 11:38:05');
INSERT INTO `access_log` VALUES (47761, '65.45.15621250852762955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.197.244.238', '2019-07-03 11:38:05', 9, 0, '', '2019-07-03 11:38:05');
INSERT INTO `access_log` VALUES (47762, '65.46.15621250852773015', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.197.244.238', '2019-07-03 11:38:05', 10, 2001001000, '服务端发生异常', '2019-07-03 11:38:05');
INSERT INTO `access_log` VALUES (47763, '65.47.15621250852792935', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.197.244.238', '2019-07-03 11:38:05', 9, 0, '', '2019-07-03 11:38:05');
INSERT INTO `access_log` VALUES (47764, '65.3607.15621251063154751', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.197.244.238', '2019-07-03 11:38:26', 8, 0, '', '2019-07-03 11:38:26');
INSERT INTO `access_log` VALUES (47765, '65.53.15621251063222963', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.197.244.238', '2019-07-03 11:38:26', 8, 0, '', '2019-07-03 11:38:26');
INSERT INTO `access_log` VALUES (47766, '65.51.15621251063223009', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.197.244.238', '2019-07-03 11:38:26', 9, 2001001000, '服务端发生异常', '2019-07-03 11:38:26');
INSERT INTO `access_log` VALUES (47767, '65.45.15621276012822989', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-07-03 12:20:01', 81, 0, '', '2019-07-03 12:20:01');
INSERT INTO `access_log` VALUES (47768, '65.50.15621276020223015', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-07-03 12:20:02', 18, 0, '', '2019-07-03 12:20:02');
INSERT INTO `access_log` VALUES (47769, '65.53.15621276020222999', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-07-03 12:20:02', 21, 2001001000, '服务端发生异常', '2019-07-03 12:20:02');
INSERT INTO `access_log` VALUES (47770, '65.54.15621276020232953', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.228.245.94', '2019-07-03 12:20:02', 24, 0, '', '2019-07-03 12:20:02');
INSERT INTO `access_log` VALUES (47771, '65.3607.15621306062424825', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-03 13:10:06', 0, 1002001015, '账号未登陆', '2019-07-03 13:10:06');
INSERT INTO `access_log` VALUES (47772, '65.51.15621306062433083', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-03 13:10:06', 1, 1002001015, '账号未登陆', '2019-07-03 13:10:06');
INSERT INTO `access_log` VALUES (47773, '65.49.15621306062623033', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-03 13:10:06', 0, 1002001015, '账号未登陆', '2019-07-03 13:10:06');
INSERT INTO `access_log` VALUES (47774, '65.52.15621306088083067', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-03 13:10:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 13:10:09');
INSERT INTO `access_log` VALUES (47775, '65.45.15621306379203031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-03 13:10:38', 70, 0, '', '2019-07-03 13:10:38');
INSERT INTO `access_log` VALUES (47776, '65.53.15621306381953041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-03 13:10:38', 9, 0, '', '2019-07-03 13:10:38');
INSERT INTO `access_log` VALUES (47777, '65.50.15621306381993057', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-03 13:10:38', 8, 2001001000, '服务端发生异常', '2019-07-03 13:10:38');
INSERT INTO `access_log` VALUES (47778, '65.54.15621306382022995', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-03 13:10:38', 9, 0, '', '2019-07-03 13:10:38');
INSERT INTO `access_log` VALUES (47779, '65.49.15621306509963035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-03 13:10:51', 9, 0, '', '2019-07-03 13:10:51');
INSERT INTO `access_log` VALUES (47780, '65.51.15621306509993085', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-03 13:10:51', 10, 2001001000, '服务端发生异常', '2019-07-03 13:10:51');
INSERT INTO `access_log` VALUES (47781, '65.52.15621306510043069', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-03 13:10:51', 9, 0, '', '2019-07-03 13:10:51');
INSERT INTO `access_log` VALUES (47782, '65.50.15621307217333059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 13:12:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 13:12:02');
INSERT INTO `access_log` VALUES (47783, '65.3607.15621307232674829', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 13:12:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 13:12:03');
INSERT INTO `access_log` VALUES (47784, '65.52.15621307240773071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 13:12:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 13:12:04');
INSERT INTO `access_log` VALUES (47785, '65.49.15621307243563037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 13:12:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 13:12:04');
INSERT INTO `access_log` VALUES (47786, '65.51.15621307246813087', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 13:12:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 13:12:05');
INSERT INTO `access_log` VALUES (47787, '65.47.15621307250353017', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 13:12:05', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 13:12:05');
INSERT INTO `access_log` VALUES (47788, '65.46.15621307253403095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 13:12:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 13:12:05');
INSERT INTO `access_log` VALUES (47789, '65.45.15621307256393035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 13:12:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 13:12:06');
INSERT INTO `access_log` VALUES (47790, '65.54.15621307260062999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 13:12:06', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 13:12:06');
INSERT INTO `access_log` VALUES (47791, '65.51.15621307902913089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 13:13:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 13:13:10');
INSERT INTO `access_log` VALUES (47792, '65.47.15621308000963019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 13:13:20', 106, 0, '', '2019-07-03 13:13:20');
INSERT INTO `access_log` VALUES (47793, '65.46.15621308005853097', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 13:13:21', 11, 2001001000, '服务端发生异常', '2019-07-03 13:13:21');
INSERT INTO `access_log` VALUES (47794, '65.54.15621308005883001', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 13:13:21', 9, 0, '', '2019-07-03 13:13:21');
INSERT INTO `access_log` VALUES (47795, '65.45.15621308005883037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.115 Safari/537.36', '27.223.78.166', '2019-07-03 13:13:21', 9, 0, '', '2019-07-03 13:13:21');
INSERT INTO `access_log` VALUES (47796, '59.71.15621318267101617', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:30:27', 12, 0, '', '2019-07-03 13:30:27');
INSERT INTO `access_log` VALUES (47797, '59.80.15621318267201603', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:30:27', 19, 2001001000, '服务端发生异常', '2019-07-03 13:30:27');
INSERT INTO `access_log` VALUES (47798, '64.80.15621318317641755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:30:32', 11, 0, '', '2019-07-03 13:30:32');
INSERT INTO `access_log` VALUES (47799, '64.77.15621318319901737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:30:32', 2, 0, '', '2019-07-03 13:30:32');
INSERT INTO `access_log` VALUES (47800, '64.78.15621318338851757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:30:34', 2, 0, '', '2019-07-03 13:30:34');
INSERT INTO `access_log` VALUES (47801, '64.83.15621318344721749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:30:34', 2, 0, '', '2019-07-03 13:30:34');
INSERT INTO `access_log` VALUES (47802, '64.81.15621318351041741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:30:35', 2, 0, '', '2019-07-03 13:30:35');
INSERT INTO `access_log` VALUES (47803, '64.84.15621318356551747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:30:36', 2, 0, '', '2019-07-03 13:30:36');
INSERT INTO `access_log` VALUES (47804, '64.79.15621318381511759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:30:38', 1, 0, '', '2019-07-03 13:30:38');
INSERT INTO `access_log` VALUES (47805, '59.72.15621318404051619', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:30:40', 3, 0, '', '2019-07-03 13:30:40');
INSERT INTO `access_log` VALUES (47806, '59.75.15621318404181623', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:30:40', 13, 2001001000, '服务端发生异常', '2019-07-03 13:30:40');
INSERT INTO `access_log` VALUES (47807, '66.49.15621318544039763', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:30:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-07-03 13:30:54');
INSERT INTO `access_log` VALUES (47808, '59.76.15621318599181611', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:31:00', 3, 0, '', '2019-07-03 13:31:00');
INSERT INTO `access_log` VALUES (47809, '59.79.15621318599471621', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:31:00', 13, 2001001000, '服务端发生异常', '2019-07-03 13:31:00');
INSERT INTO `access_log` VALUES (47810, '64.82.15621318607931763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:31:01', 2, 0, '', '2019-07-03 13:31:01');
INSERT INTO `access_log` VALUES (47811, '64.80.15621318609561757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:31:01', 1, 0, '', '2019-07-03 13:31:01');
INSERT INTO `access_log` VALUES (47812, '59.77.15621318628591605', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:31:03', 3, 0, '', '2019-07-03 13:31:03');
INSERT INTO `access_log` VALUES (47813, '59.78.15621318628721613', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:31:03', 12, 2001001000, '服务端发生异常', '2019-07-03 13:31:03');
INSERT INTO `access_log` VALUES (47814, '65.49.15621318956723055', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:31:36', 1, 1002001015, '账号未登陆', '2019-07-03 13:31:36');
INSERT INTO `access_log` VALUES (47815, '65.52.15621318956723089', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:31:36', 1, 1002001015, '账号未登陆', '2019-07-03 13:31:36');
INSERT INTO `access_log` VALUES (47816, '65.51.15621318956893105', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:31:36', 0, 1002001015, '账号未登陆', '2019-07-03 13:31:36');
INSERT INTO `access_log` VALUES (47817, '65.46.15621318995603113', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:31:40', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 13:31:40');
INSERT INTO `access_log` VALUES (47818, '65.53.15621319359963063', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:32:16', 81, 0, '', '2019-07-03 13:32:16');
INSERT INTO `access_log` VALUES (47819, '65.50.15621319368523079', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:32:17', 10, 0, '', '2019-07-03 13:32:17');
INSERT INTO `access_log` VALUES (47820, '65.3607.15621319368814849', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:32:17', 11, 2001001000, '服务端发生异常', '2019-07-03 13:32:17');
INSERT INTO `access_log` VALUES (47821, '65.52.15621319369793091', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '121.35.244.66', '2019-07-03 13:32:17', 10, 0, '', '2019-07-03 13:32:17');
INSERT INTO `access_log` VALUES (47822, '65.51.15621321173083111', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.93.1.195', '2019-07-03 13:35:17', 0, 1002001015, '账号未登陆', '2019-07-03 13:35:17');
INSERT INTO `access_log` VALUES (47823, '65.49.15621321173083061', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.93.1.195', '2019-07-03 13:35:17', 0, 1002001015, '账号未登陆', '2019-07-03 13:35:17');
INSERT INTO `access_log` VALUES (47824, '65.47.15621321173113041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.93.1.195', '2019-07-03 13:35:17', 0, 1002001015, '账号未登陆', '2019-07-03 13:35:17');
INSERT INTO `access_log` VALUES (47825, '65.50.15621333630663099', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.160.66.90', '2019-07-03 13:56:03', 0, 1002001015, '账号未登陆', '2019-07-03 13:56:03');
INSERT INTO `access_log` VALUES (47826, '65.52.15621333630683113', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.160.66.90', '2019-07-03 13:56:03', 1, 1002001015, '账号未登陆', '2019-07-03 13:56:03');
INSERT INTO `access_log` VALUES (47827, '65.3607.15621333630684869', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.160.66.90', '2019-07-03 13:56:03', 1, 1002001015, '账号未登陆', '2019-07-03 13:56:03');
INSERT INTO `access_log` VALUES (47828, '65.47.15621333664133059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.160.66.90', '2019-07-03 13:56:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 13:56:06');
INSERT INTO `access_log` VALUES (47829, '65.51.15621333724583129', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.160.66.90', '2019-07-03 13:56:12', 142, 0, '', '2019-07-03 13:56:13');
INSERT INTO `access_log` VALUES (47830, '65.46.15621333729083137', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.160.66.90', '2019-07-03 13:56:13', 10, 0, '', '2019-07-03 13:56:13');
INSERT INTO `access_log` VALUES (47831, '65.54.15621333729093039', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.160.66.90', '2019-07-03 13:56:13', 10, 2001001000, '服务端发生异常', '2019-07-03 13:56:13');
INSERT INTO `access_log` VALUES (47832, '65.45.15621333729123075', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.160.66.90', '2019-07-03 13:56:13', 9, 0, '', '2019-07-03 13:56:13');
INSERT INTO `access_log` VALUES (47833, '65.3607.15621334242734871', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.160.66.90', '2019-07-03 13:57:04', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 13:57:04');
INSERT INTO `access_log` VALUES (47834, '65.54.15621339280953047', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:05:28', 3, 1002001012, '访问令牌已过期', '2019-07-03 14:05:28');
INSERT INTO `access_log` VALUES (47835, '65.45.15621339281033083', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:05:28', 3, 1002001012, '访问令牌已过期', '2019-07-03 14:05:28');
INSERT INTO `access_log` VALUES (47836, '65.53.15621339281033093', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:05:28', 2, 1002001012, '访问令牌已过期', '2019-07-03 14:05:28');
INSERT INTO `access_log` VALUES (47837, '66.57.15621339281559779', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:05:28', 5, 1002001012, '访问令牌已过期', '2019-07-03 14:05:28');
INSERT INTO `access_log` VALUES (47838, '65.52.15621339303333123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:05:30', 154, 0, '', '2019-07-03 14:05:30');
INSERT INTO `access_log` VALUES (47839, '65.50.15621339307303109', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:05:31', 9, 0, '', '2019-07-03 14:05:31');
INSERT INTO `access_log` VALUES (47840, '65.47.15621339307323069', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:05:31', 8, 0, '', '2019-07-03 14:05:31');
INSERT INTO `access_log` VALUES (47841, '65.3607.15621339307324879', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:05:31', 9, 0, '', '2019-07-03 14:05:31');
INSERT INTO `access_log` VALUES (47842, '66.49.15621339339639791', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:05:34', 21, 0, '', '2019-07-03 14:05:34');
INSERT INTO `access_log` VALUES (47843, '59.71.15621347279341657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.160.66.90', '2019-07-03 14:18:48', 11, 0, '', '2019-07-03 14:18:48');
INSERT INTO `access_log` VALUES (47844, '59.74.15621347279381661', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.160.66.90', '2019-07-03 14:18:48', 16, 2001001000, '服务端发生异常', '2019-07-03 14:18:48');
INSERT INTO `access_log` VALUES (47845, '59.79.15621347810371661', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.160.66.90', '2019-07-03 14:19:41', 4, 0, '', '2019-07-03 14:19:41');
INSERT INTO `access_log` VALUES (47846, '59.77.15621347810401645', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.160.66.90', '2019-07-03 14:19:41', 13, 2001001000, '服务端发生异常', '2019-07-03 14:19:41');
INSERT INTO `access_log` VALUES (47847, '59.78.15621350765871657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 14:24:37', 3, 0, '', '2019-07-03 14:24:37');
INSERT INTO `access_log` VALUES (47848, '59.80.15621350765881649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 14:24:37', 10, 2001001000, '服务端发生异常', '2019-07-03 14:24:37');
INSERT INTO `access_log` VALUES (47849, '64.84.15621350813641791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 14:24:41', 14, 0, '', '2019-07-03 14:24:41');
INSERT INTO `access_log` VALUES (47850, '64.79.15621350815451803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 14:24:42', 4, 0, '', '2019-07-03 14:24:42');
INSERT INTO `access_log` VALUES (47851, '64.85.15621350833791809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 14:24:43', 1, 0, '', '2019-07-03 14:24:43');
INSERT INTO `access_log` VALUES (47852, '64.82.15621350840031807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 14:24:44', 2, 0, '', '2019-07-03 14:24:44');
INSERT INTO `access_log` VALUES (47853, '59.80.15621355092381655', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:31:49', 12, 0, '', '2019-07-03 14:31:49');
INSERT INTO `access_log` VALUES (47854, '59.71.15621355147171669', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:31:55', 27, 2001001000, '服务端发生异常', '2019-07-03 14:31:55');
INSERT INTO `access_log` VALUES (47855, '59.74.15621355182681673', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:31:58', 11, 0, '', '2019-07-03 14:31:58');
INSERT INTO `access_log` VALUES (47856, '59.73.15621357029681677', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:35:03', 21, 2001001000, '服务端发生异常', '2019-07-03 14:35:03');
INSERT INTO `access_log` VALUES (47857, '59.79.15621357070511675', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:35:07', 10, 0, '', '2019-07-03 14:35:07');
INSERT INTO `access_log` VALUES (47858, '59.77.15621357104491659', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:35:10', 15, 0, '', '2019-07-03 14:35:10');
INSERT INTO `access_log` VALUES (47859, '59.79.15621359844741679', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:39:44', 12, 0, '', '2019-07-03 14:39:44');
INSERT INTO `access_log` VALUES (47860, '59.78.15621362985161675', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=20', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-03 14:44:59', 13, 0, '', '2019-07-03 14:44:59');
INSERT INTO `access_log` VALUES (47861, '65.52.15621364075133157', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '125.84.92.189', '2019-07-03 14:46:48', 0, 1002001015, '账号未登陆', '2019-07-03 14:46:48');
INSERT INTO `access_log` VALUES (47862, '65.45.15621364075133117', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '125.84.92.189', '2019-07-03 14:46:48', 0, 1002001015, '账号未登陆', '2019-07-03 14:46:48');
INSERT INTO `access_log` VALUES (47863, '65.47.15621364075183103', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '125.84.92.189', '2019-07-03 14:46:48', 0, 1002001015, '账号未登陆', '2019-07-03 14:46:48');
INSERT INTO `access_log` VALUES (47864, '65.50.15621364121603143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '125.84.92.189', '2019-07-03 14:46:52', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 14:46:52');
INSERT INTO `access_log` VALUES (47865, '65.49.15621364167583121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '125.84.92.189', '2019-07-03 14:46:57', 69, 0, '', '2019-07-03 14:46:57');
INSERT INTO `access_log` VALUES (47866, '65.51.15621364170853173', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '125.84.92.189', '2019-07-03 14:46:57', 10, 0, '', '2019-07-03 14:46:57');
INSERT INTO `access_log` VALUES (47867, '65.46.15621364170873181', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '125.84.92.189', '2019-07-03 14:46:57', 11, 2001001000, '服务端发生异常', '2019-07-03 14:46:57');
INSERT INTO `access_log` VALUES (47868, '65.54.15621364170903083', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '125.84.92.189', '2019-07-03 14:46:57', 9, 0, '', '2019-07-03 14:46:57');
INSERT INTO `access_log` VALUES (47869, '65.52.15621364316993159', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '125.84.92.189', '2019-07-03 14:47:12', 9, 0, '', '2019-07-03 14:47:12');
INSERT INTO `access_log` VALUES (47870, '65.47.15621364317063105', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '125.84.92.189', '2019-07-03 14:47:12', 8, 0, '', '2019-07-03 14:47:12');
INSERT INTO `access_log` VALUES (47871, '65.45.15621364317023119', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '125.84.92.189', '2019-07-03 14:47:12', 181, 2001001000, '服务端发生异常', '2019-07-03 14:47:12');
INSERT INTO `access_log` VALUES (47872, '59.78.15621389741141711', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:29:34', 14, 0, '', '2019-07-03 15:29:34');
INSERT INTO `access_log` VALUES (47873, '59.80.15621389741181703', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:29:34', 14, 2001001000, '服务端发生异常', '2019-07-03 15:29:34');
INSERT INTO `access_log` VALUES (47874, '64.80.15621389781921853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:29:38', 10, 0, '', '2019-07-03 15:29:38');
INSERT INTO `access_log` VALUES (47875, '64.77.15621389783251835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:29:38', 2, 0, '', '2019-07-03 15:29:38');
INSERT INTO `access_log` VALUES (47876, '64.78.15621389799351855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:29:40', 2, 0, '', '2019-07-03 15:29:40');
INSERT INTO `access_log` VALUES (47877, '64.83.15621389808381847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:29:41', 2, 0, '', '2019-07-03 15:29:41');
INSERT INTO `access_log` VALUES (47878, '64.81.15621389815181839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:29:42', 2, 0, '', '2019-07-03 15:29:42');
INSERT INTO `access_log` VALUES (47879, '64.76.15621389819501843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:29:42', 2, 0, '', '2019-07-03 15:29:42');
INSERT INTO `access_log` VALUES (47880, '64.84.15621389886971845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:29:49', 2, 0, '', '2019-07-03 15:29:49');
INSERT INTO `access_log` VALUES (47881, '64.79.15621389888511857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:29:49', 2, 0, '', '2019-07-03 15:29:49');
INSERT INTO `access_log` VALUES (47882, '59.72.15621389903591719', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:29:50', 3, 0, '', '2019-07-03 15:29:50');
INSERT INTO `access_log` VALUES (47883, '59.74.15621389903581721', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:29:50', 24, 2001001000, '服务端发生异常', '2019-07-03 15:29:50');
INSERT INTO `access_log` VALUES (47884, '64.82.15621389970891861', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:29:57', 1, 0, '', '2019-07-03 15:29:57');
INSERT INTO `access_log` VALUES (47885, '64.80.15621389972341855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:29:57', 3, 0, '', '2019-07-03 15:29:57');
INSERT INTO `access_log` VALUES (47886, '59.75.15621390002391723', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:30:00', 3, 0, '', '2019-07-03 15:30:00');
INSERT INTO `access_log` VALUES (47887, '59.73.15621390002401723', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.71.76.8', '2019-07-03 15:30:00', 13, 2001001000, '服务端发生异常', '2019-07-03 15:30:00');
INSERT INTO `access_log` VALUES (47888, '65.51.15621400613783225', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.148.159', '2019-07-03 15:47:41', 0, 1002001015, '账号未登陆', '2019-07-03 15:47:41');
INSERT INTO `access_log` VALUES (47889, '65.49.15621400613793173', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.148.159', '2019-07-03 15:47:41', 1, 1002001015, '账号未登陆', '2019-07-03 15:47:41');
INSERT INTO `access_log` VALUES (47890, '65.3607.15621400613784967', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.148.159', '2019-07-03 15:47:41', 0, 1002001015, '账号未登陆', '2019-07-03 15:47:41');
INSERT INTO `access_log` VALUES (47891, '65.50.15621400638863193', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.148.159', '2019-07-03 15:47:44', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 15:47:44');
INSERT INTO `access_log` VALUES (47892, '65.46.15621400852043233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=adminadmin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.148.159', '2019-07-03 15:48:05', 105, 0, '', '2019-07-03 15:48:05');
INSERT INTO `access_log` VALUES (47893, '65.53.15621400856043181', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.148.159', '2019-07-03 15:48:06', 21, 0, '', '2019-07-03 15:48:06');
INSERT INTO `access_log` VALUES (47894, '65.52.15621400856093209', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.148.159', '2019-07-03 15:48:06', 19, 0, '', '2019-07-03 15:48:06');
INSERT INTO `access_log` VALUES (47895, '65.45.15621400856093173', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.148.159', '2019-07-03 15:48:06', 21, 0, '', '2019-07-03 15:48:06');
INSERT INTO `access_log` VALUES (47896, '65.3607.15621401026584969', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.108.155.18', '2019-07-03 15:48:23', 0, 1002001015, '账号未登陆', '2019-07-03 15:48:23');
INSERT INTO `access_log` VALUES (47897, '65.49.15621401026583175', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.108.155.18', '2019-07-03 15:48:23', 1, 1002001015, '账号未登陆', '2019-07-03 15:48:23');
INSERT INTO `access_log` VALUES (47898, '65.51.15621401026583227', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.108.155.18', '2019-07-03 15:48:23', 1, 1002001015, '账号未登陆', '2019-07-03 15:48:23');
INSERT INTO `access_log` VALUES (47899, '59.73.15621401547031739', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '125.70.255.1', '2019-07-03 15:49:15', 3, 0, '', '2019-07-03 15:49:15');
INSERT INTO `access_log` VALUES (47900, '59.72.15621401547031735', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '125.70.255.1', '2019-07-03 15:49:15', 13, 2001001000, '服务端发生异常', '2019-07-03 15:49:15');
INSERT INTO `access_log` VALUES (47901, '65.47.15621401854673161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.108.155.18', '2019-07-03 15:49:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 15:49:45');
INSERT INTO `access_log` VALUES (47902, '59.77.15621401898421721', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 V1_AND_SQ_8.0.7_1204_YYB_D QQ/8.0.7.4085 NetType/4G WebP/0.3.0 Pixel/1080 StatusBarHeight/89', '117.136.62.29', '2019-07-03 15:49:50', 2, 0, '', '2019-07-03 15:49:50');
INSERT INTO `access_log` VALUES (47903, '59.78.15621401898971729', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 V1_AND_SQ_8.0.7_1204_YYB_D QQ/8.0.7.4085 NetType/4G WebP/0.3.0 Pixel/1080 StatusBarHeight/89', '117.136.62.29', '2019-07-03 15:49:50', 13, 2001001000, '服务端发生异常', '2019-07-03 15:49:50');
INSERT INTO `access_log` VALUES (47904, '64.77.15621401976401853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 V1_AND_SQ_8.0.7_1204_YYB_D QQ/8.0.7.4085 NetType/4G WebP/0.3.0 Pixel/1080 StatusBarHeight/89', '117.136.62.29', '2019-07-03 15:49:58', 3, 0, '', '2019-07-03 15:49:58');
INSERT INTO `access_log` VALUES (47905, '64.78.15621401979021873', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 V1_AND_SQ_8.0.7_1204_YYB_D QQ/8.0.7.4085 NetType/4G WebP/0.3.0 Pixel/1080 StatusBarHeight/89', '117.136.62.29', '2019-07-03 15:49:58', 2, 0, '', '2019-07-03 15:49:58');
INSERT INTO `access_log` VALUES (47906, '64.83.15621402005491865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 V1_AND_SQ_8.0.7_1204_YYB_D QQ/8.0.7.4085 NetType/4G WebP/0.3.0 Pixel/1080 StatusBarHeight/89', '117.136.62.29', '2019-07-03 15:50:01', 2, 0, '', '2019-07-03 15:50:01');
INSERT INTO `access_log` VALUES (47907, '64.81.15621402017521857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 V1_AND_SQ_8.0.7_1204_YYB_D QQ/8.0.7.4085 NetType/4G WebP/0.3.0 Pixel/1080 StatusBarHeight/89', '117.136.62.29', '2019-07-03 15:50:02', 2, 0, '', '2019-07-03 15:50:02');
INSERT INTO `access_log` VALUES (47908, '65.51.15621402091523229', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.108.155.18', '2019-07-03 15:50:09', 193, 0, '', '2019-07-03 15:50:09');
INSERT INTO `access_log` VALUES (47909, '59.71.15621402098901735', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 V1_AND_SQ_8.0.7_1204_YYB_D QQ/8.0.7.4085 NetType/4G WebP/0.3.0 Pixel/1080 StatusBarHeight/89', '117.136.62.29', '2019-07-03 15:50:10', 3, 0, '', '2019-07-03 15:50:10');
INSERT INTO `access_log` VALUES (47910, '59.74.15621402099071739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 V1_AND_SQ_8.0.7_1204_YYB_D QQ/8.0.7.4085 NetType/4G WebP/0.3.0 Pixel/1080 StatusBarHeight/89', '117.136.62.29', '2019-07-03 15:50:10', 12, 2001001000, '服务端发生异常', '2019-07-03 15:50:10');
INSERT INTO `access_log` VALUES (47911, '65.50.15621402101423197', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.108.155.18', '2019-07-03 15:50:10', 7, 0, '', '2019-07-03 15:50:10');
INSERT INTO `access_log` VALUES (47912, '65.54.15621402101423139', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.108.155.18', '2019-07-03 15:50:10', 9, 2001001000, '服务端发生异常', '2019-07-03 15:50:10');
INSERT INTO `access_log` VALUES (47913, '65.46.15621402101733237', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.108.155.18', '2019-07-03 15:50:10', 9, 0, '', '2019-07-03 15:50:10');
INSERT INTO `access_log` VALUES (47914, '64.84.15621402122901863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 V1_AND_SQ_8.0.7_1204_YYB_D QQ/8.0.7.4085 NetType/4G WebP/0.3.0 Pixel/1080 StatusBarHeight/89', '117.136.62.29', '2019-07-03 15:50:12', 2, 0, '', '2019-07-03 15:50:12');
INSERT INTO `access_log` VALUES (47915, '64.79.15621402125341875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 V1_AND_SQ_8.0.7_1204_YYB_D QQ/8.0.7.4085 NetType/4G WebP/0.3.0 Pixel/1080 StatusBarHeight/89', '117.136.62.29', '2019-07-03 15:50:13', 2, 0, '', '2019-07-03 15:50:13');
INSERT INTO `access_log` VALUES (47916, '59.72.15621402153311737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 V1_AND_SQ_8.0.7_1204_YYB_D QQ/8.0.7.4085 NetType/4G WebP/0.3.0 Pixel/1080 StatusBarHeight/89', '117.136.62.29', '2019-07-03 15:50:15', 2, 0, '', '2019-07-03 15:50:15');
INSERT INTO `access_log` VALUES (47917, '59.73.15621402153331741', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 V1_AND_SQ_8.0.7_1204_YYB_D QQ/8.0.7.4085 NetType/4G WebP/0.3.0 Pixel/1080 StatusBarHeight/89', '117.136.62.29', '2019-07-03 15:50:15', 12, 2001001000, '服务端发生异常', '2019-07-03 15:50:15');
INSERT INTO `access_log` VALUES (47918, '64.85.15621402186951881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 V1_AND_SQ_8.0.7_1204_YYB_D QQ/8.0.7.4085 NetType/4G WebP/0.3.0 Pixel/1080 StatusBarHeight/89', '117.136.62.29', '2019-07-03 15:50:19', 3, 0, '', '2019-07-03 15:50:19');
INSERT INTO `access_log` VALUES (47919, '64.82.15621402190861879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 V1_AND_SQ_8.0.7_1204_YYB_D QQ/8.0.7.4085 NetType/4G WebP/0.3.0 Pixel/1080 StatusBarHeight/89', '117.136.62.29', '2019-07-03 15:50:19', 2, 0, '', '2019-07-03 15:50:19');
INSERT INTO `access_log` VALUES (47920, '65.53.15621402284523185', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.108.155.18', '2019-07-03 15:50:28', 8, 0, '', '2019-07-03 15:50:28');
INSERT INTO `access_log` VALUES (47921, '65.45.15621402284543177', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.108.155.18', '2019-07-03 15:50:28', 8, 2001001000, '服务端发生异常', '2019-07-03 15:50:28');
INSERT INTO `access_log` VALUES (47922, '65.47.15621402284593163', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.108.155.18', '2019-07-03 15:50:28', 8, 0, '', '2019-07-03 15:50:28');
INSERT INTO `access_log` VALUES (47923, '66.52.15621402532899859', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.148.159', '2019-07-03 15:50:53', 26, 0, '', '2019-07-03 15:50:53');
INSERT INTO `access_log` VALUES (47924, '59.76.15621403830151731', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:03', 3, 0, '', '2019-07-03 15:53:03');
INSERT INTO `access_log` VALUES (47925, '59.79.15621403830161741', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:03', 12, 2001001000, '服务端发生异常', '2019-07-03 15:53:03');
INSERT INTO `access_log` VALUES (47926, '59.78.15621403870101733', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:07', 2, 0, '', '2019-07-03 15:53:07');
INSERT INTO `access_log` VALUES (47927, '59.80.15621403870111725', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:07', 12, 2001001000, '服务端发生异常', '2019-07-03 15:53:07');
INSERT INTO `access_log` VALUES (47928, '65.49.15621403974373181', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:17', 0, 1002001015, '账号未登陆', '2019-07-03 15:53:17');
INSERT INTO `access_log` VALUES (47929, '65.51.15621403974393233', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:17', 1, 1002001015, '账号未登陆', '2019-07-03 15:53:17');
INSERT INTO `access_log` VALUES (47930, '65.50.15621403974433201', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:17', 1, 1002001015, '账号未登陆', '2019-07-03 15:53:17');
INSERT INTO `access_log` VALUES (47931, '65.46.15621403995863241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 15:53:20');
INSERT INTO `access_log` VALUES (47932, '65.53.15621404240663189', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:44', 65, 0, '', '2019-07-03 15:53:44');
INSERT INTO `access_log` VALUES (47933, '65.47.15621404243903167', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:44', 9, 0, '', '2019-07-03 15:53:44');
INSERT INTO `access_log` VALUES (47934, '65.45.15621404243923181', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:44', 9, 2001001000, '服务端发生异常', '2019-07-03 15:53:44');
INSERT INTO `access_log` VALUES (47935, '65.3607.15621404243944977', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:44', 9, 0, '', '2019-07-03 15:53:44');
INSERT INTO `access_log` VALUES (47936, '65.49.15621404334843183', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:53', 9, 0, '', '2019-07-03 15:53:53');
INSERT INTO `access_log` VALUES (47937, '65.50.15621404334853203', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:53', 11, 2001001000, '服务端发生异常', '2019-07-03 15:53:53');
INSERT INTO `access_log` VALUES (47938, '65.51.15621404334873235', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '27.128.183.236', '2019-07-03 15:53:53', 9, 0, '', '2019-07-03 15:53:53');
INSERT INTO `access_log` VALUES (47939, '65.47.15621408049133173', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.129.8.179', '2019-07-03 16:00:05', 0, 1002001015, '账号未登陆', '2019-07-03 16:00:05');
INSERT INTO `access_log` VALUES (47940, '65.3607.15621408088164983', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.175', '2019-07-03 16:00:09', 1, 1002001015, '账号未登陆', '2019-07-03 16:00:09');
INSERT INTO `access_log` VALUES (47941, '65.51.15621408135193241', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.251', '2019-07-03 16:00:14', 0, 1002001015, '账号未登陆', '2019-07-03 16:00:14');
INSERT INTO `access_log` VALUES (47942, '59.78.15621412622001745', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:07:42', 4, 0, '', '2019-07-03 16:07:42');
INSERT INTO `access_log` VALUES (47943, '59.80.15621412622031737', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:07:42', 13, 2001001000, '服务端发生异常', '2019-07-03 16:07:42');
INSERT INTO `access_log` VALUES (47944, '59.74.15621412670591755', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:07:47', 2, 0, '', '2019-07-03 16:07:47');
INSERT INTO `access_log` VALUES (47945, '59.71.15621412670621751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:07:47', 10, 2001001000, '服务端发生异常', '2019-07-03 16:07:47');
INSERT INTO `access_log` VALUES (47946, '65.46.15621412800243255', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:08:00', 1, 1002001015, '账号未登陆', '2019-07-03 16:08:00');
INSERT INTO `access_log` VALUES (47947, '65.54.15621412800273157', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:08:00', 1, 1002001015, '账号未登陆', '2019-07-03 16:08:00');
INSERT INTO `access_log` VALUES (47948, '65.52.15621412800323231', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:08:00', 1, 1002001015, '账号未登陆', '2019-07-03 16:08:00');
INSERT INTO `access_log` VALUES (47949, '65.53.15621412822213203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:08:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 16:08:02');
INSERT INTO `access_log` VALUES (47950, '65.45.15621412865203195', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.255.1', '2019-07-03 16:08:07', 1, 1002001015, '账号未登陆', '2019-07-03 16:08:07');
INSERT INTO `access_log` VALUES (47951, '65.47.15621412865253181', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.255.1', '2019-07-03 16:08:07', 0, 1002001015, '账号未登陆', '2019-07-03 16:08:07');
INSERT INTO `access_log` VALUES (47952, '65.3607.15621412865324991', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.255.1', '2019-07-03 16:08:07', 0, 1002001015, '账号未登陆', '2019-07-03 16:08:07');
INSERT INTO `access_log` VALUES (47953, '65.51.15621412895793249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.255.1', '2019-07-03 16:08:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 16:08:10');
INSERT INTO `access_log` VALUES (47954, '65.49.15621413026043197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.255.1', '2019-07-03 16:08:23', 106, 0, '', '2019-07-03 16:08:23');
INSERT INTO `access_log` VALUES (47955, '65.54.15621413032783159', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.255.1', '2019-07-03 16:08:23', 18, 0, '', '2019-07-03 16:08:23');
INSERT INTO `access_log` VALUES (47956, '65.46.15621413032923257', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.255.1', '2019-07-03 16:08:23', 9, 0, '', '2019-07-03 16:08:23');
INSERT INTO `access_log` VALUES (47957, '65.52.15621413032843233', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.255.1', '2019-07-03 16:08:23', 10, 2001001000, '服务端发生异常', '2019-07-03 16:08:23');
INSERT INTO `access_log` VALUES (47958, '59.79.15621417689221761', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 16:16:09', 3, 0, '', '2019-07-03 16:16:09');
INSERT INTO `access_log` VALUES (47959, '59.77.15621417689221745', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 16:16:09', 14, 2001001000, '服务端发生异常', '2019-07-03 16:16:09');
INSERT INTO `access_log` VALUES (47960, '64.81.15621417720861879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 16:16:12', 3, 0, '', '2019-07-03 16:16:12');
INSERT INTO `access_log` VALUES (47961, '64.76.15621417721961883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 16:16:12', 2, 0, '', '2019-07-03 16:16:12');
INSERT INTO `access_log` VALUES (47962, '64.84.15621417734271885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 16:16:13', 2, 0, '', '2019-07-03 16:16:13');
INSERT INTO `access_log` VALUES (47963, '64.79.15621417737461897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 16:16:14', 1, 0, '', '2019-07-03 16:16:14');
INSERT INTO `access_log` VALUES (47964, '65.3607.15621417802614999', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 16:16:20', 0, 1002001015, '账号未登陆', '2019-07-03 16:16:20');
INSERT INTO `access_log` VALUES (47965, '65.45.15621417802633203', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 16:16:20', 0, 1002001015, '账号未登陆', '2019-07-03 16:16:20');
INSERT INTO `access_log` VALUES (47966, '65.50.15621417802643225', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 16:16:20', 0, 1002001015, '账号未登陆', '2019-07-03 16:16:20');
INSERT INTO `access_log` VALUES (47967, '65.49.15621417851133205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 16:16:25', 72, 0, '', '2019-07-03 16:16:25');
INSERT INTO `access_log` VALUES (47968, '65.54.15621417854693167', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 16:16:25', 10, 0, '', '2019-07-03 16:16:25');
INSERT INTO `access_log` VALUES (47969, '65.52.15621417854973241', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 16:16:25', 9, 0, '', '2019-07-03 16:16:26');
INSERT INTO `access_log` VALUES (47970, '65.46.15621417854983265', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.171.192.242', '2019-07-03 16:16:25', 10, 2001001000, '服务端发生异常', '2019-07-03 16:16:26');
INSERT INTO `access_log` VALUES (47971, '59.78.15621419185181755', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.198.88.240', '2019-07-03 16:18:39', 3, 0, '', '2019-07-03 16:18:39');
INSERT INTO `access_log` VALUES (47972, '59.80.15621419185221747', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.198.88.240', '2019-07-03 16:18:39', 15, 2001001000, '服务端发生异常', '2019-07-03 16:18:39');
INSERT INTO `access_log` VALUES (47973, '65.3607.15621421203265005', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:00', 1, 1002001015, '账号未登陆', '2019-07-03 16:22:00');
INSERT INTO `access_log` VALUES (47974, '65.50.15621421203263231', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:00', 0, 1002001015, '账号未登陆', '2019-07-03 16:22:00');
INSERT INTO `access_log` VALUES (47975, '65.45.15621421203263209', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:00', 0, 1002001015, '账号未登陆', '2019-07-03 16:22:00');
INSERT INTO `access_log` VALUES (47976, '65.51.15621421239803263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:04', 111, 0, '', '2019-07-03 16:22:04');
INSERT INTO `access_log` VALUES (47977, '65.49.15621421243193211', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:04', 10, 0, '', '2019-07-03 16:22:04');
INSERT INTO `access_log` VALUES (47978, '65.46.15621421243213271', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:04', 10, 0, '', '2019-07-03 16:22:04');
INSERT INTO `access_log` VALUES (47979, '65.54.15621421243203173', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:04', 15, 2001001000, '服务端发生异常', '2019-07-03 16:22:04');
INSERT INTO `access_log` VALUES (47980, '65.50.15621421323333233', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:12', 29, 0, '', '2019-07-03 16:22:12');
INSERT INTO `access_log` VALUES (47981, '65.53.15621421323283219', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:12', 34, 0, '', '2019-07-03 16:22:12');
INSERT INTO `access_log` VALUES (47982, '65.47.15621421323313197', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:12', 34, 2001001000, '服务端发生异常', '2019-07-03 16:22:12');
INSERT INTO `access_log` VALUES (47983, '65.45.15621421408493211', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 16:22:21');
INSERT INTO `access_log` VALUES (47984, '65.3607.15621421422795007', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 16:22:22');
INSERT INTO `access_log` VALUES (47985, '65.51.15621421432293265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 16:22:23');
INSERT INTO `access_log` VALUES (47986, '65.49.15621421458353213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:26', 86, 0, '', '2019-07-03 16:22:26');
INSERT INTO `access_log` VALUES (47987, '65.54.15621421460963175', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:26', 8, 0, '', '2019-07-03 16:22:26');
INSERT INTO `access_log` VALUES (47988, '65.52.15621421460963249', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:26', 10, 2001001000, '服务端发生异常', '2019-07-03 16:22:26');
INSERT INTO `access_log` VALUES (47989, '65.53.15621421461023221', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:26', 10, 0, '', '2019-07-03 16:22:26');
INSERT INTO `access_log` VALUES (47990, '65.47.15621421574473199', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:37', 9, 0, '', '2019-07-03 16:22:37');
INSERT INTO `access_log` VALUES (47991, '65.45.15621421574503213', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:37', 9, 0, '', '2019-07-03 16:22:37');
INSERT INTO `access_log` VALUES (47992, '65.50.15621421574503235', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:37', 10, 2001001000, '服务端发生异常', '2019-07-03 16:22:37');
INSERT INTO `access_log` VALUES (47993, '65.51.15621421615853267', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:42', 17, 0, '', '2019-07-03 16:22:42');
INSERT INTO `access_log` VALUES (47994, '65.46.15621421615853275', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:42', 18, 0, '', '2019-07-03 16:22:42');
INSERT INTO `access_log` VALUES (47995, '65.49.15621421615863215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.51.60', '2019-07-03 16:22:42', 17, 2001001000, '服务端发生异常', '2019-07-03 16:22:42');
INSERT INTO `access_log` VALUES (47996, '65.47.15621423617233203', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.48.104.34', '2019-07-03 16:26:02', 0, 1002001015, '账号未登陆', '2019-07-03 16:26:02');
INSERT INTO `access_log` VALUES (47997, '65.50.15621423617293239', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.48.104.34', '2019-07-03 16:26:02', 1, 1002001015, '账号未登陆', '2019-07-03 16:26:02');
INSERT INTO `access_log` VALUES (47998, '65.45.15621423617323217', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.48.104.34', '2019-07-03 16:26:02', 0, 1002001015, '账号未登陆', '2019-07-03 16:26:02');
INSERT INTO `access_log` VALUES (47999, '65.3607.15621423639525013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.48.104.34', '2019-07-03 16:26:04', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 16:26:04');
INSERT INTO `access_log` VALUES (48000, '65.51.15621423675983271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.48.104.34', '2019-07-03 16:26:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 16:26:08');
INSERT INTO `access_log` VALUES (48001, '65.54.15621424019613181', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.48.104.34', '2019-07-03 16:26:42', 60, 0, '', '2019-07-03 16:26:42');
INSERT INTO `access_log` VALUES (48002, '65.53.15621424023393227', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.48.104.34', '2019-07-03 16:26:42', 9, 0, '', '2019-07-03 16:26:42');
INSERT INTO `access_log` VALUES (48003, '65.47.15621424023453205', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.48.104.34', '2019-07-03 16:26:42', 10, 2001001000, '服务端发生异常', '2019-07-03 16:26:42');
INSERT INTO `access_log` VALUES (48004, '65.50.15621424024023241', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.48.104.34', '2019-07-03 16:26:42', 10, 0, '', '2019-07-03 16:26:42');
INSERT INTO `access_log` VALUES (48005, '59.74.15621425380091773', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:28:58', 3, 0, '', '2019-07-03 16:28:58');
INSERT INTO `access_log` VALUES (48006, '59.72.15621425380141771', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:28:58', 24, 2001001000, '服务端发生异常', '2019-07-03 16:28:58');
INSERT INTO `access_log` VALUES (48007, '64.80.15621425458681905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:29:06', 3, 0, '', '2019-07-03 16:29:06');
INSERT INTO `access_log` VALUES (48008, '64.77.15621425459751887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:29:06', 2, 0, '', '2019-07-03 16:29:06');
INSERT INTO `access_log` VALUES (48009, '64.78.15621425473071907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:29:07', 2, 0, '', '2019-07-03 16:29:07');
INSERT INTO `access_log` VALUES (48010, '64.83.15621425481521899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:29:08', 2, 0, '', '2019-07-03 16:29:08');
INSERT INTO `access_log` VALUES (48011, '64.81.15621425487151891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:29:09', 2, 0, '', '2019-07-03 16:29:09');
INSERT INTO `access_log` VALUES (48012, '64.76.15621425495001895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:29:10', 2, 0, '', '2019-07-03 16:29:10');
INSERT INTO `access_log` VALUES (48013, '64.84.15621425501511897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:29:10', 1, 0, '', '2019-07-03 16:29:10');
INSERT INTO `access_log` VALUES (48014, '64.79.15621425504491909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.120.207.130', '2019-07-03 16:29:10', 2, 0, '', '2019-07-03 16:29:10');
INSERT INTO `access_log` VALUES (48015, '65.51.15621425868243275', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.97', '2019-07-03 16:29:47', 1, 1002001015, '账号未登陆', '2019-07-03 16:29:47');
INSERT INTO `access_log` VALUES (48016, '65.46.15621425868253283', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.97', '2019-07-03 16:29:47', 0, 1002001015, '账号未登陆', '2019-07-03 16:29:47');
INSERT INTO `access_log` VALUES (48017, '65.49.15621425868313223', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.97', '2019-07-03 16:29:47', 1, 1002001015, '账号未登陆', '2019-07-03 16:29:47');
INSERT INTO `access_log` VALUES (48018, '65.52.15621425884123259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.97', '2019-07-03 16:29:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 16:29:48');
INSERT INTO `access_log` VALUES (48019, '65.54.15621425910493185', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.97', '2019-07-03 16:29:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 16:29:51');
INSERT INTO `access_log` VALUES (48020, '65.47.15621425930833209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.97', '2019-07-03 16:29:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 16:29:53');
INSERT INTO `access_log` VALUES (48021, '65.50.15621425970353245', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.97', '2019-07-03 16:29:57', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 16:29:57');
INSERT INTO `access_log` VALUES (48022, '65.3607.15621426171595019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.97', '2019-07-03 16:30:17', 334, 0, '', '2019-07-03 16:30:17');
INSERT INTO `access_log` VALUES (48023, '65.51.15621426177653277', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.97', '2019-07-03 16:30:18', 9, 0, '', '2019-07-03 16:30:18');
INSERT INTO `access_log` VALUES (48024, '65.49.15621426177623225', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.97', '2019-07-03 16:30:18', 11, 2001001000, '服务端发生异常', '2019-07-03 16:30:18');
INSERT INTO `access_log` VALUES (48025, '65.46.15621426177623285', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.97', '2019-07-03 16:30:18', 10, 0, '', '2019-07-03 16:30:18');
INSERT INTO `access_log` VALUES (48026, '64.81.15621426471581893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.198.88.240', '2019-07-03 16:30:47', 3, 0, '', '2019-07-03 16:30:47');
INSERT INTO `access_log` VALUES (48027, '64.76.15621426474331897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.198.88.240', '2019-07-03 16:30:47', 2, 0, '', '2019-07-03 16:30:47');
INSERT INTO `access_log` VALUES (48028, '64.84.15621426486791899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.198.88.240', '2019-07-03 16:30:49', 2, 0, '', '2019-07-03 16:30:49');
INSERT INTO `access_log` VALUES (48029, '64.79.15621426492051911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.198.88.240', '2019-07-03 16:30:49', 2, 0, '', '2019-07-03 16:30:49');
INSERT INTO `access_log` VALUES (48030, '64.82.15621426531641915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.198.88.240', '2019-07-03 16:30:53', 2, 0, '', '2019-07-03 16:30:53');
INSERT INTO `access_log` VALUES (48031, '64.80.15621426532661909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.198.88.240', '2019-07-03 16:30:53', 2, 0, '', '2019-07-03 16:30:53');
INSERT INTO `access_log` VALUES (48032, '65.54.15621441371863207', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.84.198', '2019-07-03 16:55:37', 0, 1002001015, '账号未登陆', '2019-07-03 16:55:37');
INSERT INTO `access_log` VALUES (48033, '65.47.15621441371883231', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.84.198', '2019-07-03 16:55:37', 0, 1002001015, '账号未登陆', '2019-07-03 16:55:37');
INSERT INTO `access_log` VALUES (48034, '65.53.15621441371973253', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.84.198', '2019-07-03 16:55:37', 1, 1002001015, '账号未登陆', '2019-07-03 16:55:37');
INSERT INTO `access_log` VALUES (48035, '65.45.15621441425973245', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.84.198', '2019-07-03 16:55:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 16:55:43');
INSERT INTO `access_log` VALUES (48036, '65.3607.15621441524085041', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.84.198', '2019-07-03 16:55:52', 65, 0, '', '2019-07-03 16:55:52');
INSERT INTO `access_log` VALUES (48037, '65.51.15621441532873299', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.84.198', '2019-07-03 16:55:53', 153, 0, '', '2019-07-03 16:55:53');
INSERT INTO `access_log` VALUES (48038, '65.46.15621441532773307', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.84.198', '2019-07-03 16:55:53', 162, 0, '', '2019-07-03 16:55:53');
INSERT INTO `access_log` VALUES (48039, '65.49.15621441532773247', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.84.198', '2019-07-03 16:55:53', 162, 2001001000, '服务端发生异常', '2019-07-03 16:55:53');
INSERT INTO `access_log` VALUES (48040, '65.54.15621441608263209', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.84.198', '2019-07-03 16:56:01', 9, 0, '', '2019-07-03 16:56:01');
INSERT INTO `access_log` VALUES (48041, '65.47.15621441608303233', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.84.198', '2019-07-03 16:56:01', 16, 2001001000, '服务端发生异常', '2019-07-03 16:56:01');
INSERT INTO `access_log` VALUES (48042, '65.53.15621441608343255', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.84.198', '2019-07-03 16:56:01', 16, 0, '', '2019-07-03 16:56:01');
INSERT INTO `access_log` VALUES (48043, '65.47.15621443007033235', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 16:58:21', 0, 1002001015, '账号未登陆', '2019-07-03 16:58:21');
INSERT INTO `access_log` VALUES (48044, '65.50.15621443007043271', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 16:58:21', 1, 1002001015, '账号未登陆', '2019-07-03 16:58:21');
INSERT INTO `access_log` VALUES (48045, '65.45.15621443007043249', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 16:58:21', 0, 1002001015, '账号未登陆', '2019-07-03 16:58:21');
INSERT INTO `access_log` VALUES (48046, '65.51.15621443409823303', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 16:59:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 16:59:01');
INSERT INTO `access_log` VALUES (48047, '65.52.15621443448343287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 16:59:05', 5, 1002002000, '账号不存在', '2019-07-03 16:59:05');
INSERT INTO `access_log` VALUES (48048, '65.53.15621443512113259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 16:59:11', 93, 0, '', '2019-07-03 16:59:11');
INSERT INTO `access_log` VALUES (48049, '65.50.15621443515873273', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 16:59:12', 8, 0, '', '2019-07-03 16:59:12');
INSERT INTO `access_log` VALUES (48050, '65.47.15621443515903237', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 16:59:12', 10, 2001001000, '服务端发生异常', '2019-07-03 16:59:12');
INSERT INTO `access_log` VALUES (48051, '65.45.15621443515963251', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 16:59:12', 7, 0, '', '2019-07-03 16:59:12');
INSERT INTO `access_log` VALUES (48052, '65.49.15621443921043253', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 16:59:52', 9, 0, '', '2019-07-03 16:59:52');
INSERT INTO `access_log` VALUES (48053, '65.51.15621443921103305', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 16:59:52', 10, 2001001000, '服务端发生异常', '2019-07-03 16:59:52');
INSERT INTO `access_log` VALUES (48054, '65.52.15621443921143289', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 16:59:52', 9, 0, '', '2019-07-03 16:59:52');
INSERT INTO `access_log` VALUES (48055, '65.47.15621444311703239', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 17:00:31', 9, 0, '', '2019-07-03 17:00:31');
INSERT INTO `access_log` VALUES (48056, '65.50.15621444311743275', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 17:00:31', 10, 2001001000, '服务端发生异常', '2019-07-03 17:00:31');
INSERT INTO `access_log` VALUES (48057, '65.3607.15621444311785049', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 17:00:31', 8, 0, '', '2019-07-03 17:00:31');
INSERT INTO `access_log` VALUES (48058, '65.52.15621444707873291', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '119.132.57.147', '2019-07-03 17:01:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 17:01:11');
INSERT INTO `access_log` VALUES (48059, '65.3607.15621445498775051', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.44.180.33', '2019-07-03 17:02:30', 0, 1002001015, '账号未登陆', '2019-07-03 17:02:30');
INSERT INTO `access_log` VALUES (48060, '65.46.15621445498903317', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.44.180.33', '2019-07-03 17:02:30', 0, 1002001015, '账号未登陆', '2019-07-03 17:02:30');
INSERT INTO `access_log` VALUES (48061, '65.51.15621445498943309', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.44.180.33', '2019-07-03 17:02:30', 0, 1002001015, '账号未登陆', '2019-07-03 17:02:30');
INSERT INTO `access_log` VALUES (48062, '65.49.15621445533383257', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.44.180.33', '2019-07-03 17:02:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 17:02:33');
INSERT INTO `access_log` VALUES (48063, '65.50.15621446051573281', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:03:25', 1, 1002001015, '账号未登陆', '2019-07-03 17:03:25');
INSERT INTO `access_log` VALUES (48064, '65.53.15621446051583265', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:03:25', 1, 1002001015, '账号未登陆', '2019-07-03 17:03:25');
INSERT INTO `access_log` VALUES (48065, '65.47.15621446051593245', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:03:25', 0, 1002001015, '账号未登陆', '2019-07-03 17:03:25');
INSERT INTO `access_log` VALUES (48066, '65.3607.15621446071045055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:03:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 17:03:27');
INSERT INTO `access_log` VALUES (48067, '65.45.15621446091673257', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:03:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 17:03:29');
INSERT INTO `access_log` VALUES (48068, '65.46.15621446133463319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:03:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 17:03:33');
INSERT INTO `access_log` VALUES (48069, '65.54.15621446193453221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:03:39', 5, 1002002001, '密码不正确', '2019-07-03 17:03:39');
INSERT INTO `access_log` VALUES (48070, '65.52.15621446271523297', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:03:47', 70, 0, '', '2019-07-03 17:03:47');
INSERT INTO `access_log` VALUES (48071, '65.47.15621446275623247', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:03:48', 10, 0, '', '2019-07-03 17:03:48');
INSERT INTO `access_log` VALUES (48072, '65.53.15621446275643267', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:03:48', 10, 2001001000, '服务端发生异常', '2019-07-03 17:03:48');
INSERT INTO `access_log` VALUES (48073, '65.50.15621446277863283', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:03:48', 10, 0, '', '2019-07-03 17:03:48');
INSERT INTO `access_log` VALUES (48074, '59.75.15621446566021803', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:04:17', 13, 2001001000, '服务端发生异常', '2019-07-03 17:04:17');
INSERT INTO `access_log` VALUES (48075, '59.76.15621446567641791', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:04:17', 10, 0, '', '2019-07-03 17:04:17');
INSERT INTO `access_log` VALUES (48076, '64.76.15621446615821925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:04:22', 10, 0, '', '2019-07-03 17:04:22');
INSERT INTO `access_log` VALUES (48077, '64.84.15621446618561927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:04:22', 3, 0, '', '2019-07-03 17:04:22');
INSERT INTO `access_log` VALUES (48078, '64.79.15621446666901939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:04:27', 1, 0, '', '2019-07-03 17:04:27');
INSERT INTO `access_log` VALUES (48079, '64.85.15621446667991945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:04:27', 1, 0, '', '2019-07-03 17:04:27');
INSERT INTO `access_log` VALUES (48080, '59.77.15621446713271785', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:04:31', 3, 0, '', '2019-07-03 17:04:31');
INSERT INTO `access_log` VALUES (48081, '59.80.15621446713281785', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:04:31', 12, 2001001000, '服务端发生异常', '2019-07-03 17:04:31');
INSERT INTO `access_log` VALUES (48082, '64.80.15621446770461937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '182.200.20.69', '2019-07-03 17:04:37', 2, 0, '', '2019-07-03 17:04:37');
INSERT INTO `access_log` VALUES (48083, '64.77.15621446774991919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '182.200.20.69', '2019-07-03 17:04:38', 2, 0, '', '2019-07-03 17:04:38');
INSERT INTO `access_log` VALUES (48084, '59.71.15621446781181799', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '182.200.20.69', '2019-07-03 17:04:38', 2, 0, '', '2019-07-03 17:04:38');
INSERT INTO `access_log` VALUES (48085, '59.74.15621446781191803', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '182.200.20.69', '2019-07-03 17:04:38', 12, 2001001000, '服务端发生异常', '2019-07-03 17:04:38');
INSERT INTO `access_log` VALUES (48086, '64.78.15621446809391939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '182.200.20.69', '2019-07-03 17:04:41', 2, 0, '', '2019-07-03 17:04:41');
INSERT INTO `access_log` VALUES (48087, '64.83.15621446812071931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '182.200.20.69', '2019-07-03 17:04:41', 2, 0, '', '2019-07-03 17:04:41');
INSERT INTO `access_log` VALUES (48088, '64.81.15621446860691923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '182.200.20.69', '2019-07-03 17:04:46', 2, 0, '', '2019-07-03 17:04:46');
INSERT INTO `access_log` VALUES (48089, '64.76.15621446861751927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '182.200.20.69', '2019-07-03 17:04:46', 2, 0, '', '2019-07-03 17:04:46');
INSERT INTO `access_log` VALUES (48090, '59.73.15621446900661805', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '182.200.20.69', '2019-07-03 17:04:50', 2, 0, '', '2019-07-03 17:04:50');
INSERT INTO `access_log` VALUES (48091, '59.75.15621446900661805', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '182.200.20.69', '2019-07-03 17:04:50', 9, 2001001000, '服务端发生异常', '2019-07-03 17:04:50');
INSERT INTO `access_log` VALUES (48092, '59.77.15621453235681795', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:24', 5, 0, '', '2019-07-03 17:15:24');
INSERT INTO `access_log` VALUES (48093, '59.80.15621453241451795', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:24', 10, 2001001000, '服务端发生异常', '2019-07-03 17:15:24');
INSERT INTO `access_log` VALUES (48094, '59.71.15621453369371809', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:37', 3, 0, '', '2019-07-03 17:15:37');
INSERT INTO `access_log` VALUES (48095, '59.74.15621453369371813', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:37', 13, 2001001000, '服务端发生异常', '2019-07-03 17:15:37');
INSERT INTO `access_log` VALUES (48096, '64.80.15621453487671947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:49', 3, 0, '', '2019-07-03 17:15:49');
INSERT INTO `access_log` VALUES (48097, '64.77.15621453489101929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:49', 2, 0, '', '2019-07-03 17:15:49');
INSERT INTO `access_log` VALUES (48098, '64.78.15621453504221949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:50', 2, 0, '', '2019-07-03 17:15:50');
INSERT INTO `access_log` VALUES (48099, '64.81.15621453508241933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:51', 2, 0, '', '2019-07-03 17:15:51');
INSERT INTO `access_log` VALUES (48100, '64.76.15621453514091937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:51', 2, 0, '', '2019-07-03 17:15:51');
INSERT INTO `access_log` VALUES (48101, '64.84.15621453521001939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:52', 2, 0, '', '2019-07-03 17:15:52');
INSERT INTO `access_log` VALUES (48102, '59.73.15621453532861815', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:53', 2, 0, '', '2019-07-03 17:15:53');
INSERT INTO `access_log` VALUES (48103, '59.75.15621453532861815', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:53', 12, 2001001000, '服务端发生异常', '2019-07-03 17:15:53');
INSERT INTO `access_log` VALUES (48104, '64.79.15621453570921951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:57', 2, 0, '', '2019-07-03 17:15:57');
INSERT INTO `access_log` VALUES (48105, '64.85.15621453573281957', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:57', 2, 0, '', '2019-07-03 17:15:57');
INSERT INTO `access_log` VALUES (48106, '59.76.15621453583541803', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:58', 2, 0, '', '2019-07-03 17:15:58');
INSERT INTO `access_log` VALUES (48107, '59.79.15621453583551813', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:15:58', 17, 2001001000, '服务端发生异常', '2019-07-03 17:15:58');
INSERT INTO `access_log` VALUES (48108, '64.82.15621453603231955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:16:00', 2, 0, '', '2019-07-03 17:16:00');
INSERT INTO `access_log` VALUES (48109, '64.80.15621453604441949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:16:00', 1, 0, '', '2019-07-03 17:16:00');
INSERT INTO `access_log` VALUES (48110, '59.77.15621453616981797', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:16:02', 2, 0, '', '2019-07-03 17:16:02');
INSERT INTO `access_log` VALUES (48111, '59.80.15621453616981797', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:16:02', 13, 2001001000, '服务端发生异常', '2019-07-03 17:16:02');
INSERT INTO `access_log` VALUES (48112, '64.77.15621453632861931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:16:03', 2, 0, '', '2019-07-03 17:16:03');
INSERT INTO `access_log` VALUES (48113, '64.83.15621453641251943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:16:04', 2, 0, '', '2019-07-03 17:16:04');
INSERT INTO `access_log` VALUES (48114, '59.74.15621453654291815', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:16:05', 2, 0, '', '2019-07-03 17:16:05');
INSERT INTO `access_log` VALUES (48115, '59.71.15621453658351811', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-03 17:16:06', 13, 2001001000, '服务端发生异常', '2019-07-03 17:16:06');
INSERT INTO `access_log` VALUES (48116, '59.78.15621457836851811', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:04', 3, 0, '', '2019-07-03 17:23:04');
INSERT INTO `access_log` VALUES (48117, '59.74.15621457836851821', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:04', 15, 2001001000, '服务端发生异常', '2019-07-03 17:23:04');
INSERT INTO `access_log` VALUES (48118, '59.72.15621457854681819', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:05', 2, 0, '', '2019-07-03 17:23:05');
INSERT INTO `access_log` VALUES (48119, '59.75.15621457854681823', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:05', 12, 2001001000, '服务端发生异常', '2019-07-03 17:23:05');
INSERT INTO `access_log` VALUES (48120, '65.3607.15621457912725075', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:11', 1, 1002001015, '账号未登陆', '2019-07-03 17:23:11');
INSERT INTO `access_log` VALUES (48121, '65.49.15621457912723277', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:11', 1, 1002001015, '账号未登陆', '2019-07-03 17:23:11');
INSERT INTO `access_log` VALUES (48122, '65.51.15621457912723325', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:11', 1, 1002001015, '账号未登陆', '2019-07-03 17:23:11');
INSERT INTO `access_log` VALUES (48123, '65.46.15621457928173339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 17:23:13');
INSERT INTO `access_log` VALUES (48124, '64.83.15621457959331949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '116.21.13.105', '2019-07-03 17:23:16', 3, 0, '', '2019-07-03 17:23:16');
INSERT INTO `access_log` VALUES (48125, '65.52.15621457960293313', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:16', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 17:23:16');
INSERT INTO `access_log` VALUES (48126, '64.78.15621457960501957', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '116.21.13.105', '2019-07-03 17:23:16', 2, 0, '', '2019-07-03 17:23:16');
INSERT INTO `access_log` VALUES (48127, '59.73.15621457978581823', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '116.21.13.105', '2019-07-03 17:23:18', 3, 0, '', '2019-07-03 17:23:18');
INSERT INTO `access_log` VALUES (48128, '59.76.15621457978581811', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '116.21.13.105', '2019-07-03 17:23:18', 12, 2001001000, '服务端发生异常', '2019-07-03 17:23:18');
INSERT INTO `access_log` VALUES (48129, '59.77.15621458018301805', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '116.21.13.105', '2019-07-03 17:23:22', 2, 0, '', '2019-07-03 17:23:22');
INSERT INTO `access_log` VALUES (48130, '59.80.15621458018301805', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '116.21.13.105', '2019-07-03 17:23:22', 12, 2001001000, '服务端发生异常', '2019-07-03 17:23:22');
INSERT INTO `access_log` VALUES (48131, '59.78.15621458052101813', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '116.21.13.105', '2019-07-03 17:23:25', 3, 0, '', '2019-07-03 17:23:25');
INSERT INTO `access_log` VALUES (48132, '59.74.15621458052101823', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '116.21.13.105', '2019-07-03 17:23:25', 13, 2001001000, '服务端发生异常', '2019-07-03 17:23:25');
INSERT INTO `access_log` VALUES (48133, '65.53.15621458067833285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:27', 93, 0, '', '2019-07-03 17:23:27');
INSERT INTO `access_log` VALUES (48134, '65.47.15621458071083265', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:27', 8, 0, '', '2019-07-03 17:23:27');
INSERT INTO `access_log` VALUES (48135, '65.50.15621458071123301', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:27', 8, 2001001000, '服务端发生异常', '2019-07-03 17:23:27');
INSERT INTO `access_log` VALUES (48136, '65.45.15621458071163277', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:27', 9, 0, '', '2019-07-03 17:23:27');
INSERT INTO `access_log` VALUES (48137, '65.49.15621458149403279', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:35', 10, 0, '', '2019-07-03 17:23:35');
INSERT INTO `access_log` VALUES (48138, '65.3607.15621458149435077', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:35', 10, 2001001000, '服务端发生异常', '2019-07-03 17:23:35');
INSERT INTO `access_log` VALUES (48139, '65.51.15621458149483327', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:35', 9, 0, '', '2019-07-03 17:23:35');
INSERT INTO `access_log` VALUES (48140, '65.46.15621458172143341', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:37', 0, 1002001015, '账号未登陆', '2019-07-03 17:23:37');
INSERT INTO `access_log` VALUES (48141, '65.52.15621458172153315', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:37', 0, 1002001015, '账号未登陆', '2019-07-03 17:23:37');
INSERT INTO `access_log` VALUES (48142, '65.54.15621458172153241', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:37', 0, 1002001015, '账号未登陆', '2019-07-03 17:23:37');
INSERT INTO `access_log` VALUES (48143, '65.47.15621458212013267', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:41', 9, 0, '', '2019-07-03 17:23:41');
INSERT INTO `access_log` VALUES (48144, '65.50.15621458212033303', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:41', 9, 2001001000, '服务端发生异常', '2019-07-03 17:23:41');
INSERT INTO `access_log` VALUES (48145, '65.45.15621458212053279', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:41', 8, 0, '', '2019-07-03 17:23:41');
INSERT INTO `access_log` VALUES (48146, '65.51.15621458265703329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:47', 82, 0, '', '2019-07-03 17:23:47');
INSERT INTO `access_log` VALUES (48147, '65.49.15621458269443281', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:47', 9, 0, '', '2019-07-03 17:23:47');
INSERT INTO `access_log` VALUES (48148, '65.46.15621458269463343', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:47', 8, 0, '', '2019-07-03 17:23:47');
INSERT INTO `access_log` VALUES (48149, '65.3607.15621458269445079', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-03 17:23:47', 10, 2001001000, '服务端发生异常', '2019-07-03 17:23:47');
INSERT INTO `access_log` VALUES (48150, '59.80.15621460478531809', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '116.21.13.105', '2019-07-03 17:27:28', 10, 0, '', '2019-07-03 17:27:28');
INSERT INTO `access_log` VALUES (48151, '59.77.15621460478561809', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '116.21.13.105', '2019-07-03 17:27:28', 14, 2001001000, '服务端发生异常', '2019-07-03 17:27:28');
INSERT INTO `access_log` VALUES (48152, '65.47.15621460528673271', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-03 17:27:33', 9, 0, '', '2019-07-03 17:27:33');
INSERT INTO `access_log` VALUES (48153, '65.51.15621460528763333', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-03 17:27:33', 9, 2001001000, '服务端发生异常', '2019-07-03 17:27:33');
INSERT INTO `access_log` VALUES (48154, '65.46.15621460528773347', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-03 17:27:33', 105, 0, '', '2019-07-03 17:27:33');
INSERT INTO `access_log` VALUES (48155, '65.54.15621460965203247', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.60.42', '2019-07-03 17:28:17', 1, 1002001015, '账号未登陆', '2019-07-03 17:28:17');
INSERT INTO `access_log` VALUES (48156, '65.53.15621460965213293', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.60.42', '2019-07-03 17:28:17', 0, 1002001015, '账号未登陆', '2019-07-03 17:28:17');
INSERT INTO `access_log` VALUES (48157, '65.50.15621460965243309', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.60.42', '2019-07-03 17:28:17', 0, 1002001015, '账号未登陆', '2019-07-03 17:28:17');
INSERT INTO `access_log` VALUES (48158, '65.45.15621461022173285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.60.42', '2019-07-03 17:28:22', 89, 0, '', '2019-07-03 17:28:22');
INSERT INTO `access_log` VALUES (48159, '65.47.15621461025603273', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.60.42', '2019-07-03 17:28:23', 9, 0, '', '2019-07-03 17:28:23');
INSERT INTO `access_log` VALUES (48160, '65.51.15621461025623335', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.60.42', '2019-07-03 17:28:23', 10, 2001001000, '服务端发生异常', '2019-07-03 17:28:23');
INSERT INTO `access_log` VALUES (48161, '65.46.15621461025683349', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.60.42', '2019-07-03 17:28:23', 9, 0, '', '2019-07-03 17:28:23');
INSERT INTO `access_log` VALUES (48162, '65.54.15621461716993249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.204.60.42', '2019-07-03 17:29:32', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 17:29:32');
INSERT INTO `access_log` VALUES (48163, '65.54.15621462927553251', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-07-03 17:31:33', 3, 1002001012, '访问令牌已过期', '2019-07-03 17:31:33');
INSERT INTO `access_log` VALUES (48164, '65.53.15621462927543297', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-07-03 17:31:33', 4, 1002001012, '访问令牌已过期', '2019-07-03 17:31:33');
INSERT INTO `access_log` VALUES (48165, '65.45.15621462927603289', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-07-03 17:31:33', 3, 1002001012, '访问令牌已过期', '2019-07-03 17:31:33');
INSERT INTO `access_log` VALUES (48166, '65.47.15621462961833277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-07-03 17:31:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 17:31:36');
INSERT INTO `access_log` VALUES (48167, '65.46.15621463138733353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-07-03 17:31:54', 66, 0, '', '2019-07-03 17:31:54');
INSERT INTO `access_log` VALUES (48168, '65.49.15621463141533291', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-07-03 17:31:54', 15, 0, '', '2019-07-03 17:31:54');
INSERT INTO `access_log` VALUES (48169, '65.52.15621463141613327', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-07-03 17:31:54', 8, 2001001000, '服务端发生异常', '2019-07-03 17:31:54');
INSERT INTO `access_log` VALUES (48170, '65.50.15621463141623315', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-07-03 17:31:54', 8, 0, '', '2019-07-03 17:31:54');
INSERT INTO `access_log` VALUES (48171, '65.45.15621463204063291', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-07-03 17:32:00', 99, 0, '', '2019-07-03 17:32:01');
INSERT INTO `access_log` VALUES (48172, '65.54.15621463204083253', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-07-03 17:32:00', 98, 2001001000, '服务端发生异常', '2019-07-03 17:32:01');
INSERT INTO `access_log` VALUES (48173, '65.53.15621463204093299', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.89.187', '2019-07-03 17:32:00', 97, 0, '', '2019-07-03 17:32:01');
INSERT INTO `access_log` VALUES (48174, '65.51.15621471145423353', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:45:15', 1, 1002001015, '账号未登陆', '2019-07-03 17:45:15');
INSERT INTO `access_log` VALUES (48175, '65.3607.15621471145455101', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:45:15', 0, 1002001015, '账号未登陆', '2019-07-03 17:45:15');
INSERT INTO `access_log` VALUES (48176, '65.46.15621471145513365', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:45:15', 1, 1002001015, '账号未登陆', '2019-07-03 17:45:15');
INSERT INTO `access_log` VALUES (48177, '65.50.15621471279743329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:45:28', 99, 0, '', '2019-07-03 17:45:28');
INSERT INTO `access_log` VALUES (48178, '65.52.15621471283863341', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:45:28', 18, 0, '', '2019-07-03 17:45:28');
INSERT INTO `access_log` VALUES (48179, '65.54.15621471283913267', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:45:28', 18, 2001001000, '服务端发生异常', '2019-07-03 17:45:28');
INSERT INTO `access_log` VALUES (48180, '65.53.15621471284043311', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:45:28', 9, 0, '', '2019-07-03 17:45:28');
INSERT INTO `access_log` VALUES (48181, '65.51.15621471870443355', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:46:27', 8, 0, '', '2019-07-03 17:46:27');
INSERT INTO `access_log` VALUES (48182, '65.49.15621471870503307', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:46:27', 9, 2001001000, '服务端发生异常', '2019-07-03 17:46:27');
INSERT INTO `access_log` VALUES (48183, '65.50.15621471870563331', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:46:27', 7, 0, '', '2019-07-03 17:46:27');
INSERT INTO `access_log` VALUES (48184, '65.52.15621472167273343', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:46:57', 1, 1002001015, '账号未登陆', '2019-07-03 17:46:57');
INSERT INTO `access_log` VALUES (48185, '65.45.15621472167333305', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:46:57', 0, 1002001015, '账号未登陆', '2019-07-03 17:46:57');
INSERT INTO `access_log` VALUES (48186, '65.47.15621472167383293', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:46:57', 1, 1002001015, '账号未登陆', '2019-07-03 17:46:57');
INSERT INTO `access_log` VALUES (48187, '65.3607.15621472182115105', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:46:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 17:46:58');
INSERT INTO `access_log` VALUES (48188, '65.46.15621472213923369', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 17:47:01', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 17:47:01');
INSERT INTO `access_log` VALUES (48189, '59.71.15621493814331867', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.60.159', '2019-07-03 18:23:01', 11, 0, '', '2019-07-03 18:23:01');
INSERT INTO `access_log` VALUES (48190, '59.75.15621493814331873', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.60.159', '2019-07-03 18:23:01', 16, 2001001000, '服务端发生异常', '2019-07-03 18:23:01');
INSERT INTO `access_log` VALUES (48191, '64.81.15621493860171989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.60.159', '2019-07-03 18:23:06', 11, 0, '', '2019-07-03 18:23:06');
INSERT INTO `access_log` VALUES (48192, '64.76.15621493862231993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.60.159', '2019-07-03 18:23:06', 3, 0, '', '2019-07-03 18:23:06');
INSERT INTO `access_log` VALUES (48193, '64.84.15621493872811995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.60.159', '2019-07-03 18:23:07', 2, 0, '', '2019-07-03 18:23:07');
INSERT INTO `access_log` VALUES (48194, '64.79.15621493879842007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.60.159', '2019-07-03 18:23:08', 2, 0, '', '2019-07-03 18:23:08');
INSERT INTO `access_log` VALUES (48195, '64.85.15621493886142013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.60.159', '2019-07-03 18:23:09', 2, 0, '', '2019-07-03 18:23:09');
INSERT INTO `access_log` VALUES (48196, '64.82.15621493889922011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.60.159', '2019-07-03 18:23:09', 1, 0, '', '2019-07-03 18:23:09');
INSERT INTO `access_log` VALUES (48197, '59.73.15621493899221873', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.60.159', '2019-07-03 18:23:10', 3, 0, '', '2019-07-03 18:23:10');
INSERT INTO `access_log` VALUES (48198, '59.76.15621493899221861', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.60.159', '2019-07-03 18:23:10', 13, 2001001000, '服务端发生异常', '2019-07-03 18:23:10');
INSERT INTO `access_log` VALUES (48199, '65.53.15621499411513351', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '140.207.47.226', '2019-07-03 18:32:21', 1, 1002001015, '账号未登陆', '2019-07-03 18:32:21');
INSERT INTO `access_log` VALUES (48200, '65.45.15621499411513343', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '140.207.47.226', '2019-07-03 18:32:21', 0, 1002001015, '账号未登陆', '2019-07-03 18:32:21');
INSERT INTO `access_log` VALUES (48201, '65.47.15621499411663329', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '140.207.47.226', '2019-07-03 18:32:21', 0, 1002001015, '账号未登陆', '2019-07-03 18:32:21');
INSERT INTO `access_log` VALUES (48202, '65.3607.15621499435685143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '140.207.47.226', '2019-07-03 18:32:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 18:32:24');
INSERT INTO `access_log` VALUES (48203, '65.51.15621499495703395', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '140.207.47.226', '2019-07-03 18:32:30', 81, 0, '', '2019-07-03 18:32:30');
INSERT INTO `access_log` VALUES (48204, '65.50.15621499499813371', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '140.207.47.226', '2019-07-03 18:32:30', 12, 0, '', '2019-07-03 18:32:30');
INSERT INTO `access_log` VALUES (48205, '65.54.15621499499813309', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '140.207.47.226', '2019-07-03 18:32:30', 13, 0, '', '2019-07-03 18:32:30');
INSERT INTO `access_log` VALUES (48206, '65.49.15621499499813347', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '140.207.47.226', '2019-07-03 18:32:30', 14, 2001001000, '服务端发生异常', '2019-07-03 18:32:30');
INSERT INTO `access_log` VALUES (48207, '65.52.15621508546373393', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.196.145', '2019-07-03 18:47:35', 0, 1002001015, '账号未登陆', '2019-07-03 18:47:35');
INSERT INTO `access_log` VALUES (48208, '65.53.15621508546373365', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.196.145', '2019-07-03 18:47:35', 0, 1002001015, '账号未登陆', '2019-07-03 18:47:35');
INSERT INTO `access_log` VALUES (48209, '65.45.15621508546433357', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.196.145', '2019-07-03 18:47:35', 0, 1002001015, '账号未登陆', '2019-07-03 18:47:35');
INSERT INTO `access_log` VALUES (48210, '65.47.15621508577053343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.196.145', '2019-07-03 18:47:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 18:47:38');
INSERT INTO `access_log` VALUES (48211, '65.46.15621508707933421', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.196.145', '2019-07-03 18:47:51', 78, 0, '', '2019-07-03 18:47:51');
INSERT INTO `access_log` VALUES (48212, '65.51.15621508710813409', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.196.145', '2019-07-03 18:47:51', 8, 0, '', '2019-07-03 18:47:51');
INSERT INTO `access_log` VALUES (48213, '65.49.15621508710843361', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.196.145', '2019-07-03 18:47:51', 14, 0, '', '2019-07-03 18:47:51');
INSERT INTO `access_log` VALUES (48214, '65.50.15621508710833385', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.193.196.145', '2019-07-03 18:47:51', 18, 2001001000, '服务端发生异常', '2019-07-03 18:47:51');
INSERT INTO `access_log` VALUES (48215, '64.82.15621513323772037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 18:55:32', 10, 0, '', '2019-07-03 18:55:32');
INSERT INTO `access_log` VALUES (48216, '64.80.15621513325382031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 18:55:33', 3, 0, '', '2019-07-03 18:55:33');
INSERT INTO `access_log` VALUES (48217, '64.77.15621513342952013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 18:55:34', 2, 0, '', '2019-07-03 18:55:34');
INSERT INTO `access_log` VALUES (48218, '64.83.15621513354422025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 18:55:35', 2, 0, '', '2019-07-03 18:55:35');
INSERT INTO `access_log` VALUES (48219, '64.81.15621513365332017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 18:55:37', 2, 0, '', '2019-07-03 18:55:37');
INSERT INTO `access_log` VALUES (48220, '59.79.15621513375201897', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 18:55:38', 8, 0, '', '2019-07-03 18:55:38');
INSERT INTO `access_log` VALUES (48221, '59.77.15621513375561881', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 18:55:38', 9, 2001001000, '服务端发生异常', '2019-07-03 18:55:38');
INSERT INTO `access_log` VALUES (48222, '66.56.15621513410330017', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 18:55:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-07-03 18:55:41');
INSERT INTO `access_log` VALUES (48223, '66.50.15621556538210069', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 20:07:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-07-03 20:07:34');
INSERT INTO `access_log` VALUES (48224, '59.79.15621556618121955', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 20:07:42', 12, 0, '', '2019-07-03 20:07:42');
INSERT INTO `access_log` VALUES (48225, '59.77.15621556618491939', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 20:07:42', 12, 2001001000, '服务端发生异常', '2019-07-03 20:07:42');
INSERT INTO `access_log` VALUES (48226, '64.83.15621556645372083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 20:07:45', 11, 0, '', '2019-07-03 20:07:45');
INSERT INTO `access_log` VALUES (48227, '64.81.15621556646922075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 20:07:45', 3, 0, '', '2019-07-03 20:07:45');
INSERT INTO `access_log` VALUES (48228, '64.76.15621556659802079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 20:07:46', 1, 0, '', '2019-07-03 20:07:46');
INSERT INTO `access_log` VALUES (48229, '64.84.15621556668002081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 20:07:47', 2, 0, '', '2019-07-03 20:07:47');
INSERT INTO `access_log` VALUES (48230, '64.79.15621556676282093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '125.82.189.55', '2019-07-03 20:07:48', 2, 0, '', '2019-07-03 20:07:48');
INSERT INTO `access_log` VALUES (48231, '59.80.15621573083901961', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '140.243.84.251', '2019-07-03 20:35:08', 3, 0, '', '2019-07-03 20:35:08');
INSERT INTO `access_log` VALUES (48232, '59.74.15621573083931979', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '140.243.84.251', '2019-07-03 20:35:08', 10, 2001001000, '服务端发生异常', '2019-07-03 20:35:08');
INSERT INTO `access_log` VALUES (48233, '64.85.15621573158142121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '140.243.84.251', '2019-07-03 20:35:16', 3, 0, '', '2019-07-03 20:35:16');
INSERT INTO `access_log` VALUES (48234, '64.82.15621573160012119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '140.243.84.251', '2019-07-03 20:35:16', 2, 0, '', '2019-07-03 20:35:16');
INSERT INTO `access_log` VALUES (48235, '64.80.15621573184542113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '140.243.84.251', '2019-07-03 20:35:18', 2, 0, '', '2019-07-03 20:35:18');
INSERT INTO `access_log` VALUES (48236, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=笔记本&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '140.243.84.251', '2019-07-03 20:35:29', 7, 0, '', '2019-07-03 20:35:29');
INSERT INTO `access_log` VALUES (48237, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=笔记本', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '140.243.84.251', '2019-07-03 20:35:29', 5, 0, '', '2019-07-03 20:35:29');
INSERT INTO `access_log` VALUES (48238, '64.78.15621573323892115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '140.243.84.251', '2019-07-03 20:35:32', 2, 0, '', '2019-07-03 20:35:32');
INSERT INTO `access_log` VALUES (48239, '64.83.15621573325522107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '140.243.84.251', '2019-07-03 20:35:33', 2, 0, '', '2019-07-03 20:35:33');
INSERT INTO `access_log` VALUES (48240, '59.75.15621573336541981', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '140.243.84.251', '2019-07-03 20:35:34', 2, 0, '', '2019-07-03 20:35:34');
INSERT INTO `access_log` VALUES (48241, '59.71.15621573336521975', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '140.243.84.251', '2019-07-03 20:35:34', 13, 2001001000, '服务端发生异常', '2019-07-03 20:35:34');
INSERT INTO `access_log` VALUES (48242, '65.46.15621577058903513', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 20:41:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 20:41:46');
INSERT INTO `access_log` VALUES (48243, '65.49.15621577326213453', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 20:42:13', 71, 0, '', '2019-07-03 20:42:13');
INSERT INTO `access_log` VALUES (48244, '65.54.15621577334563415', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 20:42:13', 12, 0, '', '2019-07-03 20:42:13');
INSERT INTO `access_log` VALUES (48245, '65.52.15621577334613487', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 20:42:13', 18, 0, '', '2019-07-03 20:42:13');
INSERT INTO `access_log` VALUES (48246, '65.53.15621577334613459', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 20:42:13', 18, 2001001000, '服务端发生异常', '2019-07-03 20:42:13');
INSERT INTO `access_log` VALUES (48247, '65.47.15621577553113437', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 20:42:35', 8, 0, '', '2019-07-03 20:42:35');
INSERT INTO `access_log` VALUES (48248, '65.46.15621577553123515', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 20:42:35', 46, 0, '', '2019-07-03 20:42:35');
INSERT INTO `access_log` VALUES (48249, '65.3607.15621577553115251', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.91.141.220', '2019-07-03 20:42:35', 50, 2001001000, '服务端发生异常', '2019-07-03 20:42:35');
INSERT INTO `access_log` VALUES (48250, '59.75.15621587948682001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '222.68.64.229', '2019-07-03 20:59:55', 3, 0, '', '2019-07-03 20:59:55');
INSERT INTO `access_log` VALUES (48251, '59.71.15621587948691995', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '222.68.64.229', '2019-07-03 20:59:55', 12, 2001001000, '服务端发生异常', '2019-07-03 20:59:55');
INSERT INTO `access_log` VALUES (48252, '65.46.15621588090073529', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '222.68.64.229', '2019-07-03 21:00:09', 1, 1002001015, '账号未登陆', '2019-07-03 21:00:09');
INSERT INTO `access_log` VALUES (48253, '65.3607.15621588090075269', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '222.68.64.229', '2019-07-03 21:00:09', 0, 1002001015, '账号未登陆', '2019-07-03 21:00:09');
INSERT INTO `access_log` VALUES (48254, '65.51.15621588090113519', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '222.68.64.229', '2019-07-03 21:00:09', 0, 1002001015, '账号未登陆', '2019-07-03 21:00:09');
INSERT INTO `access_log` VALUES (48255, '65.50.15621588125933493', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '222.68.64.229', '2019-07-03 21:00:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 21:00:13');
INSERT INTO `access_log` VALUES (48256, '65.52.15621588312923505', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '222.68.64.229', '2019-07-03 21:00:31', 104, 0, '', '2019-07-03 21:00:31');
INSERT INTO `access_log` VALUES (48257, '65.53.15621588317343475', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '222.68.64.229', '2019-07-03 21:00:32', 10, 0, '', '2019-07-03 21:00:32');
INSERT INTO `access_log` VALUES (48258, '65.54.15621588317373431', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '222.68.64.229', '2019-07-03 21:00:32', 10, 2001001000, '服务端发生异常', '2019-07-03 21:00:32');
INSERT INTO `access_log` VALUES (48259, '65.45.15621588317443467', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '222.68.64.229', '2019-07-03 21:00:32', 9, 0, '', '2019-07-03 21:00:32');
INSERT INTO `access_log` VALUES (48260, '59.73.15621642487762073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '114.84.56.69', '2019-07-03 22:30:49', 33, 2001001000, '服务端发生异常', '2019-07-03 22:30:49');
INSERT INTO `access_log` VALUES (48261, '59.76.15621642487702063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '114.84.56.69', '2019-07-03 22:30:49', 545, 0, '', '2019-07-03 22:30:49');
INSERT INTO `access_log` VALUES (48262, '65.51.15621642792373593', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.16.92.191', '2019-07-03 22:31:19', 4, 1002001012, '访问令牌已过期', '2019-07-03 22:31:19');
INSERT INTO `access_log` VALUES (48263, '65.45.15621642792403541', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.16.92.191', '2019-07-03 22:31:19', 4, 1002001012, '访问令牌已过期', '2019-07-03 22:31:19');
INSERT INTO `access_log` VALUES (48264, '65.49.15621642792473545', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.16.92.191', '2019-07-03 22:31:19', 11, 1002001012, '访问令牌已过期', '2019-07-03 22:31:19');
INSERT INTO `access_log` VALUES (48265, '65.50.15621642811633569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.16.92.191', '2019-07-03 22:31:21', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-03 22:31:21');
INSERT INTO `access_log` VALUES (48266, '65.46.15621642886003603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.16.92.191', '2019-07-03 22:31:29', 123, 0, '', '2019-07-03 22:31:29');
INSERT INTO `access_log` VALUES (48267, '65.3607.15621642889595345', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.16.92.191', '2019-07-03 22:31:29', 12, 0, '', '2019-07-03 22:31:29');
INSERT INTO `access_log` VALUES (48268, '65.52.15621642889653581', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.16.92.191', '2019-07-03 22:31:29', 10, 0, '', '2019-07-03 22:31:29');
INSERT INTO `access_log` VALUES (48269, '65.47.15621642889643529', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.16.92.191', '2019-07-03 22:31:29', 10, 2001001000, '服务端发生异常', '2019-07-03 22:31:29');
INSERT INTO `access_log` VALUES (48270, '65.49.15621642995633547', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.16.92.191', '2019-07-03 22:31:40', 9, 0, '', '2019-07-03 22:31:40');
INSERT INTO `access_log` VALUES (48271, '65.45.15621642995673543', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.16.92.191', '2019-07-03 22:31:40', 10, 2001001000, '服务端发生异常', '2019-07-03 22:31:40');
INSERT INTO `access_log` VALUES (48272, '65.51.15621642995723595', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.16.92.191', '2019-07-03 22:31:40', 9, 0, '', '2019-07-03 22:31:40');
INSERT INTO `access_log` VALUES (48273, '65.47.15621655507653547', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '114.250.190.230', '2019-07-03 22:52:31', 1, 1002001015, '账号未登陆', '2019-07-03 22:52:31');
INSERT INTO `access_log` VALUES (48274, '65.52.15621655507643599', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '114.250.190.230', '2019-07-03 22:52:31', 0, 1002001015, '账号未登陆', '2019-07-03 22:52:31');
INSERT INTO `access_log` VALUES (48275, '65.3607.15621655507835363', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '114.250.190.230', '2019-07-03 22:52:31', 1, 1002001015, '账号未登陆', '2019-07-03 22:52:31');
INSERT INTO `access_log` VALUES (48276, '65.49.15621655612703565', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '114.250.190.230', '2019-07-03 22:52:41', 65, 0, '', '2019-07-03 22:52:41');
INSERT INTO `access_log` VALUES (48277, '65.51.15621655619113613', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '114.250.190.230', '2019-07-03 22:52:42', 10, 0, '', '2019-07-03 22:52:42');
INSERT INTO `access_log` VALUES (48278, '65.45.15621655619133561', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '114.250.190.230', '2019-07-03 22:52:42', 10, 2001001000, '服务端发生异常', '2019-07-03 22:52:42');
INSERT INTO `access_log` VALUES (48279, '65.50.15621655619153589', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '114.250.190.230', '2019-07-03 22:52:42', 9, 0, '', '2019-07-03 22:52:42');
INSERT INTO `access_log` VALUES (48280, '65.47.15621655941463549', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '114.250.190.230', '2019-07-03 22:53:14', 10, 0, '', '2019-07-03 22:53:14');
INSERT INTO `access_log` VALUES (48281, '65.3607.15621655941505365', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '114.250.190.230', '2019-07-03 22:53:14', 9, 0, '', '2019-07-03 22:53:14');
INSERT INTO `access_log` VALUES (48282, '65.52.15621655941483601', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '114.250.190.230', '2019-07-03 22:53:14', 9, 2001001000, '服务端发生异常', '2019-07-03 22:53:14');
INSERT INTO `access_log` VALUES (48283, '65.49.15621656136573567', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '114.250.190.230', '2019-07-03 22:53:34', 9, 0, '', '2019-07-03 22:53:34');
INSERT INTO `access_log` VALUES (48284, '65.50.15621656136593591', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '114.250.190.230', '2019-07-03 22:53:34', 10, 2001001000, '服务端发生异常', '2019-07-03 22:53:34');
INSERT INTO `access_log` VALUES (48285, '65.51.15621656136633615', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3534.4 Safari/537.36', '114.250.190.230', '2019-07-03 22:53:34', 9, 0, '', '2019-07-03 22:53:34');
INSERT INTO `access_log` VALUES (48286, '65.53.15621782144913739', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:23:34', 0, 1002001015, '账号未登陆', '2019-07-04 02:23:34');
INSERT INTO `access_log` VALUES (48287, '65.45.15621782144913731', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:23:34', 0, 1002001015, '账号未登陆', '2019-07-04 02:23:34');
INSERT INTO `access_log` VALUES (48288, '65.46.15621782144973793', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:23:34', 1, 1002001015, '账号未登陆', '2019-07-04 02:23:34');
INSERT INTO `access_log` VALUES (48289, '65.47.15621782345323719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:23:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 02:23:55');
INSERT INTO `access_log` VALUES (48290, '65.50.15621782633073761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanm&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:24:23', 116, 0, '', '2019-07-04 02:24:23');
INSERT INTO `access_log` VALUES (48291, '65.49.15621782643433737', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:24:24', 20, 0, '', '2019-07-04 02:24:24');
INSERT INTO `access_log` VALUES (48292, '65.53.15621782643433741', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:24:24', 22, 2001001000, '服务端发生异常', '2019-07-04 02:24:24');
INSERT INTO `access_log` VALUES (48293, '65.46.15621782643993795', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:24:24', 10, 0, '', '2019-07-04 02:24:24');
INSERT INTO `access_log` VALUES (48294, '65.45.15621782741633733', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:24:34', 9, 0, '', '2019-07-04 02:24:34');
INSERT INTO `access_log` VALUES (48295, '65.52.15621782741713771', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:24:34', 10, 2001001000, '服务端发生异常', '2019-07-04 02:24:34');
INSERT INTO `access_log` VALUES (48296, '65.3607.15621782741985539', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:24:34', 9, 0, '', '2019-07-04 02:24:34');
INSERT INTO `access_log` VALUES (48297, '65.54.15621782903123699', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:24:50', 9, 0, '', '2019-07-04 02:24:50');
INSERT INTO `access_log` VALUES (48298, '65.50.15621782903193763', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:24:50', 10, 2001001000, '服务端发生异常', '2019-07-04 02:24:50');
INSERT INTO `access_log` VALUES (48299, '65.51.15621782903273787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:24:50', 19, 0, '', '2019-07-04 02:24:50');
INSERT INTO `access_log` VALUES (48300, '59.78.15621783037582251', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:25:04', 10, 0, '', '2019-07-04 02:25:04');
INSERT INTO `access_log` VALUES (48301, '59.79.15621783037592259', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:25:04', 14, 2001001000, '服务端发生异常', '2019-07-04 02:25:04');
INSERT INTO `access_log` VALUES (48302, '64.81.15621783094152381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:25:09', 12, 0, '', '2019-07-04 02:25:09');
INSERT INTO `access_log` VALUES (48303, '64.78.15621783096222399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:25:10', 3, 0, '', '2019-07-04 02:25:10');
INSERT INTO `access_log` VALUES (48304, '64.77.15621783138722377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:25:14', 2, 0, '', '2019-07-04 02:25:14');
INSERT INTO `access_log` VALUES (48305, '64.79.15621783141122395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:25:14', 2, 0, '', '2019-07-04 02:25:14');
INSERT INTO `access_log` VALUES (48306, '64.76.15621783249232387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:25:25', 2, 0, '', '2019-07-04 02:25:25');
INSERT INTO `access_log` VALUES (48307, '64.84.15621783252662387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:25:25', 3, 0, '', '2019-07-04 02:25:25');
INSERT INTO `access_log` VALUES (48308, '59.75.15621783257012267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:25:26', 3, 0, '', '2019-07-04 02:25:26');
INSERT INTO `access_log` VALUES (48309, '59.80.15621783257072243', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.115.206.90', '2019-07-04 02:25:26', 14, 2001001000, '服务端发生异常', '2019-07-04 02:25:26');
INSERT INTO `access_log` VALUES (48310, '59.73.15622014850182571', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:51:25', 26, 0, '', '2019-07-04 08:51:25');
INSERT INTO `access_log` VALUES (48311, '59.76.15622014850182561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:51:25', 56, 2001001000, '服务端发生异常', '2019-07-04 08:51:25');
INSERT INTO `access_log` VALUES (48312, '66.52.15622014894110677', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:51:29', 9, 1002001012, '访问令牌已过期', '2019-07-04 08:51:29');
INSERT INTO `access_log` VALUES (48313, '66.50.15622014895420681', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=f01298a699d84ba6b103fb608d8dff80', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:51:30', 11, 1002001018, '访问令牌已过期', '2019-07-04 08:51:30');
INSERT INTO `access_log` VALUES (48314, '66.57.15622015062240679', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13720895280', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:51:46', 72, 0, '', '2019-07-04 08:51:46');
INSERT INTO `access_log` VALUES (48315, '66.55.15622015105850659', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13720895280&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:51:51', 226, 0, '', '2019-07-04 08:51:51');
INSERT INTO `access_log` VALUES (48316, '66.51.15622015123480703', 140, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:51:52', 6, 0, '', '2019-07-04 08:51:52');
INSERT INTO `access_log` VALUES (48317, '66.49.15622015189910697', 140, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:51:59', 6, 0, '', '2019-07-04 08:51:59');
INSERT INTO `access_log` VALUES (48318, '59.77.15622015248792557', 140, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:52:05', 8, 0, '', '2019-07-04 08:52:05');
INSERT INTO `access_log` VALUES (48319, '59.72.15622015248792569', 140, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:52:05', 29, 2001001000, '服务端发生异常', '2019-07-04 08:52:05');
INSERT INTO `access_log` VALUES (48320, '64.76.15622015281042697', 140, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:52:08', 14, 0, '', '2019-07-04 08:52:08');
INSERT INTO `access_log` VALUES (48321, '64.83.15622015282292705', 140, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:52:08', 12, 0, '', '2019-07-04 08:52:08');
INSERT INTO `access_log` VALUES (48322, '64.82.15622015295822715', 140, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:52:10', 8, 0, '', '2019-07-04 08:52:10');
INSERT INTO `access_log` VALUES (48323, '64.81.15622015304572693', 140, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:52:10', 14, 0, '', '2019-07-04 08:52:10');
INSERT INTO `access_log` VALUES (48324, '64.78.15622015338402711', 140, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:52:14', 5, 0, '', '2019-07-04 08:52:14');
INSERT INTO `access_log` VALUES (48325, 'N/A', 140, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:52:14', 9, 0, '', '2019-07-04 08:52:14');
INSERT INTO `access_log` VALUES (48326, '64.79.15622015354782707', 140, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:52:15', 12, 0, '', '2019-07-04 08:52:15');
INSERT INTO `access_log` VALUES (48327, '64.84.15622015558152699', 140, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:52:36', 10, 0, '', '2019-07-04 08:52:36');
INSERT INTO `access_log` VALUES (48328, '64.85.15622016644152717', 140, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:54:24', 7, 0, '', '2019-07-04 08:54:24');
INSERT INTO `access_log` VALUES (48329, 'N/A', 140, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:54:24', 9, 0, '', '2019-07-04 08:54:24');
INSERT INTO `access_log` VALUES (48330, '64.76.15622016664732701', 140, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:54:26', 5, 0, '', '2019-07-04 08:54:26');
INSERT INTO `access_log` VALUES (48331, '64.84.15622016665782701', 140, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:54:27', 6, 0, '', '2019-07-04 08:54:27');
INSERT INTO `access_log` VALUES (48332, '59.72.15622016675402571', 140, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:54:28', 6, 0, '', '2019-07-04 08:54:28');
INSERT INTO `access_log` VALUES (48333, '59.74.15622016675412571', 140, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:54:28', 20, 2001001000, '服务端发生异常', '2019-07-04 08:54:28');
INSERT INTO `access_log` VALUES (48334, '66.56.15622016703310695', 140, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:54:30', 7, 0, '', '2019-07-04 08:54:30');
INSERT INTO `access_log` VALUES (48335, '59.79.15622016717742573', 140, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:54:32', 6, 0, '', '2019-07-04 08:54:32');
INSERT INTO `access_log` VALUES (48336, '59.78.15622016717742565', 140, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 08:54:32', 22, 2001001000, '服务端发生异常', '2019-07-04 08:54:32');
INSERT INTO `access_log` VALUES (48337, '65.54.15622024560704021', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 09:07:36', 5, 1002001012, '访问令牌已过期', '2019-07-04 09:07:36');
INSERT INTO `access_log` VALUES (48338, '65.51.15622024560704111', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 09:07:36', 8, 1002001012, '访问令牌已过期', '2019-07-04 09:07:36');
INSERT INTO `access_log` VALUES (48339, '65.53.15622024560794067', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 09:07:36', 9, 1002001012, '访问令牌已过期', '2019-07-04 09:07:36');
INSERT INTO `access_log` VALUES (48340, '65.49.15622024577014063', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 09:07:38', 106, 0, '', '2019-07-04 09:07:38');
INSERT INTO `access_log` VALUES (48341, '65.3607.15622024580325863', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 09:07:38', 10, 0, '', '2019-07-04 09:07:38');
INSERT INTO `access_log` VALUES (48342, '65.52.15622024580354097', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 09:07:38', 10, 0, '', '2019-07-04 09:07:38');
INSERT INTO `access_log` VALUES (48343, '65.46.15622024580304117', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 09:07:38', 16, 0, '', '2019-07-04 09:07:38');
INSERT INTO `access_log` VALUES (48344, '59.80.15622024615822567', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 09:07:42', 25, 2001001000, '服务端发生异常', '2019-07-04 09:07:42');
INSERT INTO `access_log` VALUES (48345, '59.79.15622025254762585', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 09:08:45', 16, 0, '', '2019-07-04 09:08:45');
INSERT INTO `access_log` VALUES (48346, '64.79.15622028022852725', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 09:13:22', 15, 0, '', '2019-07-04 09:13:22');
INSERT INTO `access_log` VALUES (48347, '65.49.15622028467234069', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:14:07', 1, 1002001015, '账号未登陆', '2019-07-04 09:14:07');
INSERT INTO `access_log` VALUES (48348, '65.3607.15622028467255869', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:14:07', 0, 1002001015, '账号未登陆', '2019-07-04 09:14:07');
INSERT INTO `access_log` VALUES (48349, '65.52.15622028467264103', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:14:07', 0, 1002001015, '账号未登陆', '2019-07-04 09:14:07');
INSERT INTO `access_log` VALUES (48350, '65.46.15622028482034123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:14:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 09:14:08');
INSERT INTO `access_log` VALUES (48351, '65.47.15622028521534053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:14:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 09:14:12');
INSERT INTO `access_log` VALUES (48352, '65.50.15622028581824095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:14:18', 4, 1002002001, '密码不正确', '2019-07-04 09:14:18');
INSERT INTO `access_log` VALUES (48353, '65.54.15622028695594029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:14:30', 77, 0, '', '2019-07-04 09:14:30');
INSERT INTO `access_log` VALUES (48354, '65.51.15622028698624119', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:14:30', 12, 0, '', '2019-07-04 09:14:30');
INSERT INTO `access_log` VALUES (48355, '65.52.15622028698634105', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:14:30', 11, 2001001000, '服务端发生异常', '2019-07-04 09:14:30');
INSERT INTO `access_log` VALUES (48356, '65.49.15622028698654071', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:14:30', 10, 0, '', '2019-07-04 09:14:30');
INSERT INTO `access_log` VALUES (48357, '65.47.15622028959214055', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:14:56', 17, 0, '', '2019-07-04 09:14:56');
INSERT INTO `access_log` VALUES (48358, '65.45.15622028959214067', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:14:56', 18, 2001001000, '服务端发生异常', '2019-07-04 09:14:56');
INSERT INTO `access_log` VALUES (48359, '65.50.15622028959234097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:14:56', 17, 0, '', '2019-07-04 09:14:56');
INSERT INTO `access_log` VALUES (48360, '65.53.15622029003414077', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:15:00', 13, 0, '', '2019-07-04 09:15:00');
INSERT INTO `access_log` VALUES (48361, '65.54.15622029003434031', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:15:00', 10, 2001001000, '服务端发生异常', '2019-07-04 09:15:00');
INSERT INTO `access_log` VALUES (48362, '65.52.15622029003454107', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:15:00', 9, 0, '', '2019-07-04 09:15:00');
INSERT INTO `access_log` VALUES (48363, '65.49.15622029065244073', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.184.47.170', '2019-07-04 09:15:07', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 09:15:07');
INSERT INTO `access_log` VALUES (48364, '59.74.15622030968092591', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:18:17', 3, 0, '', '2019-07-04 09:18:17');
INSERT INTO `access_log` VALUES (48365, '59.79.15622030968102593', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:18:17', 18, 2001001000, '服务端发生异常', '2019-07-04 09:18:17');
INSERT INTO `access_log` VALUES (48366, '64.85.15622031024912737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:18:22', 2, 0, '', '2019-07-04 09:18:22');
INSERT INTO `access_log` VALUES (48367, '64.76.15622031026342721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:18:23', 1, 0, '', '2019-07-04 09:18:23');
INSERT INTO `access_log` VALUES (48368, '64.84.15622031044852721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:18:24', 2, 0, '', '2019-07-04 09:18:24');
INSERT INTO `access_log` VALUES (48369, '64.83.15622031056522729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:18:26', 3, 0, '', '2019-07-04 09:18:26');
INSERT INTO `access_log` VALUES (48370, '59.73.15622031068712595', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:18:27', 2, 0, '', '2019-07-04 09:18:27');
INSERT INTO `access_log` VALUES (48371, '59.76.15622031068722585', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:18:27', 16, 2001001000, '服务端发生异常', '2019-07-04 09:18:27');
INSERT INTO `access_log` VALUES (48372, '65.3607.15622032131055877', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:20:13', 1, 1002001015, '账号未登陆', '2019-07-04 09:20:13');
INSERT INTO `access_log` VALUES (48373, '65.46.15622032131054131', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:20:13', 0, 1002001015, '账号未登陆', '2019-07-04 09:20:13');
INSERT INTO `access_log` VALUES (48374, '65.50.15622032131104103', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:20:13', 0, 1002001015, '账号未登陆', '2019-07-04 09:20:13');
INSERT INTO `access_log` VALUES (48375, '65.47.15622032153694061', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:20:15', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 09:20:15');
INSERT INTO `access_log` VALUES (48376, '65.45.15622032238954073', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:20:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 09:20:24');
INSERT INTO `access_log` VALUES (48377, '65.53.15622032316664083', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:20:32', 4, 1002002001, '密码不正确', '2019-07-04 09:20:32');
INSERT INTO `access_log` VALUES (48378, '65.51.15622032545494127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:20:55', 107, 0, '', '2019-07-04 09:20:55');
INSERT INTO `access_log` VALUES (48379, '65.50.15622032549164105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:20:55', 10, 0, '', '2019-07-04 09:20:55');
INSERT INTO `access_log` VALUES (48380, '65.46.15622032549194133', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:20:55', 10, 2001001000, '服务端发生异常', '2019-07-04 09:20:55');
INSERT INTO `access_log` VALUES (48381, '65.3607.15622032549225879', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '219.143.149.23', '2019-07-04 09:20:55', 10, 0, '', '2019-07-04 09:20:55');
INSERT INTO `access_log` VALUES (48382, '59.80.15622040132942589', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:33:33', 3, 0, '', '2019-07-04 09:33:33');
INSERT INTO `access_log` VALUES (48383, '59.75.15622040132922613', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:33:33', 32, 2001001000, '服务端发生异常', '2019-07-04 09:33:33');
INSERT INTO `access_log` VALUES (48384, '65.45.15622040475824085', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:34:08', 3, 1002001012, '访问令牌已过期', '2019-07-04 09:34:08');
INSERT INTO `access_log` VALUES (48385, '65.54.15622040475824049', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:34:08', 2, 1002001012, '访问令牌已过期', '2019-07-04 09:34:08');
INSERT INTO `access_log` VALUES (48386, '65.53.15622040475824095', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:34:08', 4, 1002001012, '访问令牌已过期', '2019-07-04 09:34:08');
INSERT INTO `access_log` VALUES (48387, '65.51.15622040523434139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:34:12', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 09:34:12');
INSERT INTO `access_log` VALUES (48388, '65.50.15622040590904117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:34:19', 59, 0, '', '2019-07-04 09:34:19');
INSERT INTO `access_log` VALUES (48389, '65.3607.15622040599365891', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:34:20', 10, 0, '', '2019-07-04 09:34:20');
INSERT INTO `access_log` VALUES (48390, '65.46.15622040599384145', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:34:20', 10, 2001001000, '服务端发生异常', '2019-07-04 09:34:20');
INSERT INTO `access_log` VALUES (48391, '65.47.15622040599504075', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:34:20', 9, 0, '', '2019-07-04 09:34:20');
INSERT INTO `access_log` VALUES (48392, '65.53.15622040642364097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:34:24', 9, 0, '', '2019-07-04 09:34:24');
INSERT INTO `access_log` VALUES (48393, '65.45.15622040642644087', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:34:24', 9, 0, '', '2019-07-04 09:34:24');
INSERT INTO `access_log` VALUES (48394, '65.54.15622040642634051', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:34:24', 10, 2001001000, '服务端发生异常', '2019-07-04 09:34:24');
INSERT INTO `access_log` VALUES (48395, '65.46.15622040940534147', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:34:54', 9, 0, '', '2019-07-04 09:34:54');
INSERT INTO `access_log` VALUES (48396, '65.50.15622040940524119', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:34:54', 8, 0, '', '2019-07-04 09:34:54');
INSERT INTO `access_log` VALUES (48397, '65.3607.15622040940535893', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:34:54', 10, 2001001000, '服务端发生异常', '2019-07-04 09:34:54');
INSERT INTO `access_log` VALUES (48398, '65.47.15622040995894077', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:00', 8, 0, '', '2019-07-04 09:35:00');
INSERT INTO `access_log` VALUES (48399, '65.53.15622040996174099', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:00', 8, 0, '', '2019-07-04 09:35:00');
INSERT INTO `access_log` VALUES (48400, '65.52.15622040996174129', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:00', 9, 2001001000, '服务端发生异常', '2019-07-04 09:35:00');
INSERT INTO `access_log` VALUES (48401, '65.49.15622041034714095', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:03', 15, 0, '', '2019-07-04 09:35:03');
INSERT INTO `access_log` VALUES (48402, '65.45.15622041034704089', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:03', 15, 0, '', '2019-07-04 09:35:03');
INSERT INTO `access_log` VALUES (48403, '65.54.15622041034684053', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:03', 19, 2001001000, '服务端发生异常', '2019-07-04 09:35:03');
INSERT INTO `access_log` VALUES (48404, '65.51.15622041039574143', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:04', 9, 0, '', '2019-07-04 09:35:04');
INSERT INTO `access_log` VALUES (48405, '65.46.15622041039574149', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:04', 9, 0, '', '2019-07-04 09:35:04');
INSERT INTO `access_log` VALUES (48406, '65.3607.15622041039575895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:04', 10, 2001001000, '服务端发生异常', '2019-07-04 09:35:04');
INSERT INTO `access_log` VALUES (48407, '65.50.15622041072884121', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:07', 11, 0, '', '2019-07-04 09:35:07');
INSERT INTO `access_log` VALUES (48408, '65.47.15622041072924079', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:07', 8, 0, '', '2019-07-04 09:35:07');
INSERT INTO `access_log` VALUES (48409, '65.52.15622041072934131', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:07', 9, 2001001000, '服务端发生异常', '2019-07-04 09:35:07');
INSERT INTO `access_log` VALUES (48410, '65.53.15622041079564101', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:08', 9, 0, '', '2019-07-04 09:35:08');
INSERT INTO `access_log` VALUES (48411, '65.45.15622041079584091', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:08', 8, 0, '', '2019-07-04 09:35:08');
INSERT INTO `access_log` VALUES (48412, '65.54.15622041079584055', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '123.139.82.190', '2019-07-04 09:35:08', 12, 2001001000, '服务端发生异常', '2019-07-04 09:35:08');
INSERT INTO `access_log` VALUES (48413, '64.78.15622042031672749', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 09:36:43', 11, 0, '', '2019-07-04 09:36:43');
INSERT INTO `access_log` VALUES (48414, '65.51.15622053967204163', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-04 09:56:37', 1, 1002001015, '账号未登陆', '2019-07-04 09:56:37');
INSERT INTO `access_log` VALUES (48415, '65.3607.15622053967195915', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-04 09:56:37', 0, 1002001015, '账号未登陆', '2019-07-04 09:56:37');
INSERT INTO `access_log` VALUES (48416, '65.52.15622053967304151', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-04 09:56:37', 1, 1002001015, '账号未登陆', '2019-07-04 09:56:37');
INSERT INTO `access_log` VALUES (48417, '65.50.15622054038074139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-04 09:56:44', 75, 0, '', '2019-07-04 09:56:44');
INSERT INTO `access_log` VALUES (48418, '65.47.15622054044344097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-04 09:56:44', 10, 0, '', '2019-07-04 09:56:44');
INSERT INTO `access_log` VALUES (48419, '65.53.15622054044374121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-04 09:56:44', 10, 2001001000, '服务端发生异常', '2019-07-04 09:56:44');
INSERT INTO `access_log` VALUES (48420, '65.54.15622054044434075', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-04 09:56:44', 9, 0, '', '2019-07-04 09:56:44');
INSERT INTO `access_log` VALUES (48421, '65.49.15622054202864115', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-04 09:57:00', 9, 0, '', '2019-07-04 09:57:00');
INSERT INTO `access_log` VALUES (48422, '65.51.15622054202914165', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-04 09:57:00', 10, 2001001000, '服务端发生异常', '2019-07-04 09:57:00');
INSERT INTO `access_log` VALUES (48423, '65.52.15622054203014153', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-04 09:57:00', 8, 0, '', '2019-07-04 09:57:00');
INSERT INTO `access_log` VALUES (48424, '59.74.15622056990992627', 0, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 10:01:39', 63, 1002001012, '访问令牌已过期', '2019-07-04 10:01:39');
INSERT INTO `access_log` VALUES (48425, '65.51.15622057009794169', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 10:01:41', 99, 0, '', '2019-07-04 10:01:41');
INSERT INTO `access_log` VALUES (48426, '65.3607.15622057013035921', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 10:01:41', 9, 0, '', '2019-07-04 10:01:41');
INSERT INTO `access_log` VALUES (48427, '65.46.15622057013064175', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 10:01:41', 9, 0, '', '2019-07-04 10:01:41');
INSERT INTO `access_log` VALUES (48428, '65.50.15622057013084145', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 10:01:41', 9, 0, '', '2019-07-04 10:01:41');
INSERT INTO `access_log` VALUES (48429, '59.79.15622057080562629', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 10:01:48', 18, 0, '', '2019-07-04 10:01:48');
INSERT INTO `access_log` VALUES (48430, '59.73.15622057188562631', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-04 10:01:59', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-04 10:01:59');
INSERT INTO `access_log` VALUES (48431, '65.53.15622058493164129', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.37.42', '2019-07-04 10:04:09', 0, 1002001015, '账号未登陆', '2019-07-04 10:04:09');
INSERT INTO `access_log` VALUES (48432, '65.54.15622058493154083', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.37.42', '2019-07-04 10:04:09', 1, 1002001015, '账号未登陆', '2019-07-04 10:04:09');
INSERT INTO `access_log` VALUES (48433, '65.47.15622058493164105', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.37.42', '2019-07-04 10:04:09', 0, 1002001015, '账号未登陆', '2019-07-04 10:04:09');
INSERT INTO `access_log` VALUES (48434, '65.45.15622058546644119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.37.42', '2019-07-04 10:04:15', 68, 0, '', '2019-07-04 10:04:15');
INSERT INTO `access_log` VALUES (48435, '65.49.15622058549434123', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.37.42', '2019-07-04 10:04:15', 9, 0, '', '2019-07-04 10:04:15');
INSERT INTO `access_log` VALUES (48436, '65.52.15622058549464161', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.37.42', '2019-07-04 10:04:15', 9, 2001001000, '服务端发生异常', '2019-07-04 10:04:15');
INSERT INTO `access_log` VALUES (48437, '65.51.15622058549474173', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.37.42', '2019-07-04 10:04:15', 10, 0, '', '2019-07-04 10:04:15');
INSERT INTO `access_log` VALUES (48438, '59.78.15622067327882635', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.126.2.238', '2019-07-04 10:18:53', 3, 0, '', '2019-07-04 10:18:53');
INSERT INTO `access_log` VALUES (48439, '59.73.15622067327892645', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.126.2.238', '2019-07-04 10:18:53', 15, 2001001000, '服务端发生异常', '2019-07-04 10:18:53');
INSERT INTO `access_log` VALUES (48440, '64.78.15622067376552783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.126.2.238', '2019-07-04 10:18:58', 11, 0, '', '2019-07-04 10:18:58');
INSERT INTO `access_log` VALUES (48441, '64.77.15622067377812761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.126.2.238', '2019-07-04 10:18:58', 3, 0, '', '2019-07-04 10:18:58');
INSERT INTO `access_log` VALUES (48442, '64.79.15622067394212779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.126.2.238', '2019-07-04 10:18:59', 2, 0, '', '2019-07-04 10:18:59');
INSERT INTO `access_log` VALUES (48443, '64.85.15622067399872787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.126.2.238', '2019-07-04 10:19:00', 2, 0, '', '2019-07-04 10:19:00');
INSERT INTO `access_log` VALUES (48444, '64.76.15622067405612771', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.126.2.238', '2019-07-04 10:19:01', 2, 0, '', '2019-07-04 10:19:01');
INSERT INTO `access_log` VALUES (48445, '66.56.15622067554290763', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18310116873', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.126.2.238', '2019-07-04 10:19:15', 107, 0, '', '2019-07-04 10:19:16');
INSERT INTO `access_log` VALUES (48446, '65.53.15622076011794155', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:33:21', 0, 1002001015, '账号未登陆', '2019-07-04 10:33:21');
INSERT INTO `access_log` VALUES (48447, '65.46.15622076011784203', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:33:21', 1, 1002001015, '账号未登陆', '2019-07-04 10:33:21');
INSERT INTO `access_log` VALUES (48448, '65.47.15622076011944131', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:33:21', 0, 1002001015, '账号未登陆', '2019-07-04 10:33:21');
INSERT INTO `access_log` VALUES (48449, '59.80.15622076459202639', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:06', 3, 0, '', '2019-07-04 10:34:06');
INSERT INTO `access_log` VALUES (48450, '59.75.15622076459202663', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:06', 12, 2001001000, '服务端发生异常', '2019-07-04 10:34:06');
INSERT INTO `access_log` VALUES (48451, '64.83.15622076497782791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:10', 3, 0, '', '2019-07-04 10:34:10');
INSERT INTO `access_log` VALUES (48452, '64.80.15622076499242795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:10', 1, 0, '', '2019-07-04 10:34:10');
INSERT INTO `access_log` VALUES (48453, '64.82.15622076569242801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:17', 2, 0, '', '2019-07-04 10:34:17');
INSERT INTO `access_log` VALUES (48454, '64.78.15622076609602797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:21', 2, 0, '', '2019-07-04 10:34:21');
INSERT INTO `access_log` VALUES (48455, '64.77.15622076624882775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:22', 2, 0, '', '2019-07-04 10:34:22');
INSERT INTO `access_log` VALUES (48456, '64.79.15622076629242793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:23', 2, 0, '', '2019-07-04 10:34:23');
INSERT INTO `access_log` VALUES (48457, '64.85.15622076634842801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:23', 2, 0, '', '2019-07-04 10:34:23');
INSERT INTO `access_log` VALUES (48458, '59.77.15622076650182643', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:25', 3, 0, '', '2019-07-04 10:34:25');
INSERT INTO `access_log` VALUES (48459, '59.72.15622076650282655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:25', 12, 2001001000, '服务端发生异常', '2019-07-04 10:34:25');
INSERT INTO `access_log` VALUES (48460, '64.76.15622076698702785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:30', 2, 0, '', '2019-07-04 10:34:30');
INSERT INTO `access_log` VALUES (48461, '64.84.15622076700272785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:30', 1, 0, '', '2019-07-04 10:34:30');
INSERT INTO `access_log` VALUES (48462, '64.83.15622076718382793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:32', 2, 0, '', '2019-07-04 10:34:32');
INSERT INTO `access_log` VALUES (48463, '64.80.15622076724162797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:32', 2, 0, '', '2019-07-04 10:34:32');
INSERT INTO `access_log` VALUES (48464, '59.79.15622076735532657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:34', 2, 0, '', '2019-07-04 10:34:34');
INSERT INTO `access_log` VALUES (48465, '59.74.15622076735532655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:34', 11, 2001001000, '服务端发生异常', '2019-07-04 10:34:34');
INSERT INTO `access_log` VALUES (48466, '64.81.15622076781982781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:38', 1, 0, '', '2019-07-04 10:34:38');
INSERT INTO `access_log` VALUES (48467, '64.78.15622076782992799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:38', 2, 0, '', '2019-07-04 10:34:38');
INSERT INTO `access_log` VALUES (48468, '64.77.15622076796202777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:40', 1, 0, '', '2019-07-04 10:34:40');
INSERT INTO `access_log` VALUES (48469, '64.79.15622076803232795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:40', 1, 0, '', '2019-07-04 10:34:40');
INSERT INTO `access_log` VALUES (48470, '64.85.15622076808302803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:41', 2, 0, '', '2019-07-04 10:34:41');
INSERT INTO `access_log` VALUES (48471, '64.84.15622076946932787', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.227.209.194', '2019-07-04 10:34:55', 3, 1003002003, 'Spu 只能添加在二级分类下', '2019-07-04 10:34:55');
INSERT INTO `access_log` VALUES (48472, '59.74.15622087005772669', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 10:51:41', 4, 0, '', '2019-07-04 10:51:41');
INSERT INTO `access_log` VALUES (48473, '59.78.15622087005782663', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 10:51:41', 16, 2001001000, '服务端发生异常', '2019-07-04 10:51:41');
INSERT INTO `access_log` VALUES (48474, '64.85.15622087066112817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 10:51:47', 3, 0, '', '2019-07-04 10:51:47');
INSERT INTO `access_log` VALUES (48475, '64.76.15622087067222801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 10:51:47', 2, 0, '', '2019-07-04 10:51:47');
INSERT INTO `access_log` VALUES (48476, '64.83.15622087115472809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 10:51:52', 2, 0, '', '2019-07-04 10:51:52');
INSERT INTO `access_log` VALUES (48477, '64.80.15622087126722813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 10:51:53', 2, 0, '', '2019-07-04 10:51:53');
INSERT INTO `access_log` VALUES (48478, '64.82.15622087206602819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 10:52:01', 2, 0, '', '2019-07-04 10:52:01');
INSERT INTO `access_log` VALUES (48479, '64.81.15622087207772797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 10:52:01', 1, 0, '', '2019-07-04 10:52:01');
INSERT INTO `access_log` VALUES (48480, '59.75.15622087300192679', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:52:10', 2, 0, '', '2019-07-04 10:52:10');
INSERT INTO `access_log` VALUES (48481, '59.80.15622087300192655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:52:10', 17, 2001001000, '服务端发生异常', '2019-07-04 10:52:10');
INSERT INTO `access_log` VALUES (48482, '64.77.15622087352392793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:52:15', 1, 0, '', '2019-07-04 10:52:15');
INSERT INTO `access_log` VALUES (48483, '64.79.15622087354162811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:52:15', 2, 0, '', '2019-07-04 10:52:15');
INSERT INTO `access_log` VALUES (48484, '64.85.15622087379962819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:52:18', 2, 0, '', '2019-07-04 10:52:18');
INSERT INTO `access_log` VALUES (48485, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:52:18', 11, 0, '', '2019-07-04 10:52:18');
INSERT INTO `access_log` VALUES (48486, '64.76.15622087402662803', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:52:20', 8, 0, '', '2019-07-04 10:52:20');
INSERT INTO `access_log` VALUES (48487, '64.80.15622087644572815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:52:44', 2, 0, '', '2019-07-04 10:52:44');
INSERT INTO `access_log` VALUES (48488, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:52:44', 6, 0, '', '2019-07-04 10:52:44');
INSERT INTO `access_log` VALUES (48489, '64.82.15622087659672821', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:52:46', 5, 0, '', '2019-07-04 10:52:46');
INSERT INTO `access_log` VALUES (48490, '64.78.15622087772502817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:52:57', 2, 0, '', '2019-07-04 10:52:57');
INSERT INTO `access_log` VALUES (48491, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:52:57', 7, 0, '', '2019-07-04 10:52:57');
INSERT INTO `access_log` VALUES (48492, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:53:02', 6, 0, '', '2019-07-04 10:53:02');
INSERT INTO `access_log` VALUES (48493, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:53:08', 5, 0, '', '2019-07-04 10:53:08');
INSERT INTO `access_log` VALUES (48494, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:53:09', 6, 0, '', '2019-07-04 10:53:09');
INSERT INTO `access_log` VALUES (48495, '64.79.15622087905742813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:53:11', 2, 0, '', '2019-07-04 10:53:11');
INSERT INTO `access_log` VALUES (48496, '64.85.15622087907292821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:53:11', 2, 0, '', '2019-07-04 10:53:11');
INSERT INTO `access_log` VALUES (48497, '64.76.15622087922002805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:53:12', 2, 0, '', '2019-07-04 10:53:12');
INSERT INTO `access_log` VALUES (48498, '64.84.15622087941932805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.108.50.70', '2019-07-04 10:53:14', 2, 0, '', '2019-07-04 10:53:14');
INSERT INTO `access_log` VALUES (48499, '65.51.15622088284154215', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 10:53:48', 1, 1002001015, '账号未登陆', '2019-07-04 10:53:48');
INSERT INTO `access_log` VALUES (48500, '65.49.15622088284154165', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 10:53:48', 1, 1002001015, '账号未登陆', '2019-07-04 10:53:48');
INSERT INTO `access_log` VALUES (48501, '65.52.15622088284174203', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 10:53:48', 0, 1002001015, '账号未登陆', '2019-07-04 10:53:48');
INSERT INTO `access_log` VALUES (48502, '59.78.15622089619292667', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:02', 3, 0, '', '2019-07-04 10:56:02');
INSERT INTO `access_log` VALUES (48503, '59.73.15622089619352677', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:02', 12, 2001001000, '服务端发生异常', '2019-07-04 10:56:02');
INSERT INTO `access_log` VALUES (48504, '64.80.15622089650082819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:05', 2, 0, '', '2019-07-04 10:56:05');
INSERT INTO `access_log` VALUES (48505, '64.82.15622089651772825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:05', 2, 0, '', '2019-07-04 10:56:05');
INSERT INTO `access_log` VALUES (48506, '64.78.15622089662932821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:06', 2, 0, '', '2019-07-04 10:56:06');
INSERT INTO `access_log` VALUES (48507, '64.77.15622089673312799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:07', 2, 0, '', '2019-07-04 10:56:07');
INSERT INTO `access_log` VALUES (48508, '59.75.15622089691862683', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:09', 2, 0, '', '2019-07-04 10:56:09');
INSERT INTO `access_log` VALUES (48509, '59.80.15622089691952659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:09', 46, 2001001000, '服务端发生异常', '2019-07-04 10:56:09');
INSERT INTO `access_log` VALUES (48510, '66.49.15622089730460797', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空', '2019-07-04 10:56:13');
INSERT INTO `access_log` VALUES (48511, '65.50.15622089930924193', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:33', 4, 1002001012, '访问令牌已过期', '2019-07-04 10:56:33');
INSERT INTO `access_log` VALUES (48512, '65.46.15622089931004223', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:33', 3, 1002001012, '访问令牌已过期', '2019-07-04 10:56:33');
INSERT INTO `access_log` VALUES (48513, '65.47.15622089931134151', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:33', 3, 1002001012, '访问令牌已过期', '2019-07-04 10:56:33');
INSERT INTO `access_log` VALUES (48514, '65.54.15622090055564129', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 10:56:46');
INSERT INTO `access_log` VALUES (48515, '65.45.15622090135924165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:54', 104, 0, '', '2019-07-04 10:56:54');
INSERT INTO `access_log` VALUES (48516, '65.51.15622090141904219', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:54', 10, 0, '', '2019-07-04 10:56:54');
INSERT INTO `access_log` VALUES (48517, '65.49.15622090142004169', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:54', 10, 2001001000, '服务端发生异常', '2019-07-04 10:56:54');
INSERT INTO `access_log` VALUES (48518, '65.3607.15622090142075971', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.100.213.234', '2019-07-04 10:56:54', 9, 0, '', '2019-07-04 10:56:54');
INSERT INTO `access_log` VALUES (48519, '65.47.15622092083184155', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:00:08', 4, 1002001012, '访问令牌已过期', '2019-07-04 11:00:08');
INSERT INTO `access_log` VALUES (48520, '65.53.15622092083264179', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:00:08', 3, 1002001012, '访问令牌已过期', '2019-07-04 11:00:08');
INSERT INTO `access_log` VALUES (48521, '65.54.15622092083424133', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:00:08', 3, 1002001012, '访问令牌已过期', '2019-07-04 11:00:08');
INSERT INTO `access_log` VALUES (48522, '65.52.15622092100454211', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:00:10', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 11:00:10');
INSERT INTO `access_log` VALUES (48523, '65.49.15622092355224173', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:00:36', 110, 0, '', '2019-07-04 11:00:36');
INSERT INTO `access_log` VALUES (48524, '65.3607.15622092360405975', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:00:36', 10, 0, '', '2019-07-04 11:00:36');
INSERT INTO `access_log` VALUES (48525, '65.50.15622092360434199', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:00:36', 11, 2001001000, '服务端发生异常', '2019-07-04 11:00:36');
INSERT INTO `access_log` VALUES (48526, '65.46.15622092360454229', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:00:36', 9, 0, '', '2019-07-04 11:00:36');
INSERT INTO `access_log` VALUES (48527, '59.80.15622092544202663', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:00:54', 3, 0, '', '2019-07-04 11:00:54');
INSERT INTO `access_log` VALUES (48528, '59.71.15622092544212679', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:00:54', 14, 2001001000, '服务端发生异常', '2019-07-04 11:00:54');
INSERT INTO `access_log` VALUES (48529, '65.54.15622092561454135', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 11:00:56', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 11:00:56');
INSERT INTO `access_log` VALUES (48530, '64.77.15622092604582803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:01:00', 2, 0, '', '2019-07-04 11:01:00');
INSERT INTO `access_log` VALUES (48531, '64.79.15622092606662821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:01:01', 2, 0, '', '2019-07-04 11:01:01');
INSERT INTO `access_log` VALUES (48532, '64.85.15622092614952829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:01:01', 2, 0, '', '2019-07-04 11:01:01');
INSERT INTO `access_log` VALUES (48533, '64.76.15622092620692813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:01:02', 2, 0, '', '2019-07-04 11:01:02');
INSERT INTO `access_log` VALUES (48534, '64.84.15622092629892813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:01:03', 2, 0, '', '2019-07-04 11:01:03');
INSERT INTO `access_log` VALUES (48535, '64.83.15622092632882821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-04 11:01:03', 1, 0, '', '2019-07-04 11:01:03');
INSERT INTO `access_log` VALUES (48536, '65.52.15622092782444213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 11:01:18', 96, 0, '', '2019-07-04 11:01:18');
INSERT INTO `access_log` VALUES (48537, '65.51.15622092786854225', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 11:01:19', 16, 0, '', '2019-07-04 11:01:19');
INSERT INTO `access_log` VALUES (48538, '65.49.15622092786874175', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 11:01:19', 17, 2001001000, '服务端发生异常', '2019-07-04 11:01:19');
INSERT INTO `access_log` VALUES (48539, '65.46.15622092787064231', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 11:01:19', 9, 0, '', '2019-07-04 11:01:19');
INSERT INTO `access_log` VALUES (48540, '65.47.15622092998934159', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 11:01:40', 9, 0, '', '2019-07-04 11:01:40');
INSERT INTO `access_log` VALUES (48541, '65.53.15622092998954183', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 11:01:40', 10, 2001001000, '服务端发生异常', '2019-07-04 11:01:40');
INSERT INTO `access_log` VALUES (48542, '65.54.15622092999174137', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 11:01:40', 8, 0, '', '2019-07-04 11:01:40');
INSERT INTO `access_log` VALUES (48543, '65.45.15622093037094173', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 11:01:44', 9, 0, '', '2019-07-04 11:01:44');
INSERT INTO `access_log` VALUES (48544, '65.52.15622093037094215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 11:01:44', 18, 2001001000, '服务端发生异常', '2019-07-04 11:01:44');
INSERT INTO `access_log` VALUES (48545, '65.49.15622093037144177', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.108.50.70', '2019-07-04 11:01:44', 17, 0, '', '2019-07-04 11:01:44');
INSERT INTO `access_log` VALUES (48546, '66.50.15622094485310789', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.1.73.64', '2019-07-04 11:04:09', 18, 0, '', '2019-07-04 11:04:09');
INSERT INTO `access_log` VALUES (48547, '59.78.15622102218602685', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.79.73.242', '2019-07-04 11:17:02', 3, 0, '', '2019-07-04 11:17:02');
INSERT INTO `access_log` VALUES (48548, '59.73.15622102218602695', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.79.73.242', '2019-07-04 11:17:02', 12, 2001001000, '服务端发生异常', '2019-07-04 11:17:02');
INSERT INTO `access_log` VALUES (48549, '64.77.15622102249402817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.79.73.242', '2019-07-04 11:17:05', 3, 0, '', '2019-07-04 11:17:05');
INSERT INTO `access_log` VALUES (48550, '64.79.15622102250342835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.79.73.242', '2019-07-04 11:17:05', 1, 0, '', '2019-07-04 11:17:05');
INSERT INTO `access_log` VALUES (48551, '64.76.15622102263312827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.79.73.242', '2019-07-04 11:17:06', 2, 0, '', '2019-07-04 11:17:06');
INSERT INTO `access_log` VALUES (48552, '64.84.15622102269382827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.79.73.242', '2019-07-04 11:17:07', 2, 0, '', '2019-07-04 11:17:07');
INSERT INTO `access_log` VALUES (48553, '64.83.15622102312432835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.79.73.242', '2019-07-04 11:17:11', 2, 0, '', '2019-07-04 11:17:11');
INSERT INTO `access_log` VALUES (48554, '64.80.15622102313162839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.79.73.242', '2019-07-04 11:17:11', 2, 0, '', '2019-07-04 11:17:11');
INSERT INTO `access_log` VALUES (48555, '59.79.15622108997122703', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:28:20', 13, 2001001000, '服务端发生异常', '2019-07-04 11:28:20');
INSERT INTO `access_log` VALUES (48556, '59.74.15622108997402701', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:28:20', 3, 0, '', '2019-07-04 11:28:20');
INSERT INTO `access_log` VALUES (48557, '65.52.15622109086094237', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:28:29', 1, 1002001015, '账号未登陆', '2019-07-04 11:28:29');
INSERT INTO `access_log` VALUES (48558, '65.49.15622109086114199', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:28:29', 0, 1002001015, '账号未登陆', '2019-07-04 11:28:29');
INSERT INTO `access_log` VALUES (48559, '65.45.15622109086184195', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:28:29', 0, 1002001015, '账号未登陆', '2019-07-04 11:28:29');
INSERT INTO `access_log` VALUES (48560, '65.46.15622109114404255', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:28:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 11:28:31');
INSERT INTO `access_log` VALUES (48561, '65.51.15622109160494249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:28:36', 83, 0, '', '2019-07-04 11:28:36');
INSERT INTO `access_log` VALUES (48562, '65.50.15622109163844225', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:28:36', 10, 0, '', '2019-07-04 11:28:36');
INSERT INTO `access_log` VALUES (48563, '65.3607.15622109163966001', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:28:36', 9, 2001001000, '服务端发生异常', '2019-07-04 11:28:36');
INSERT INTO `access_log` VALUES (48564, '65.47.15622109164054183', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:28:36', 9, 0, '', '2019-07-04 11:28:36');
INSERT INTO `access_log` VALUES (48565, '65.54.15622109292644161', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:28:49', 9, 0, '', '2019-07-04 11:28:49');
INSERT INTO `access_log` VALUES (48566, '65.52.15622109292684239', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:28:49', 11, 2001001000, '服务端发生异常', '2019-07-04 11:28:49');
INSERT INTO `access_log` VALUES (48567, '65.49.15622109292774201', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:28:49', 8, 0, '', '2019-07-04 11:28:49');
INSERT INTO `access_log` VALUES (48568, '59.76.15622109401652695', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:29:00', 2, 0, '', '2019-07-04 11:29:00');
INSERT INTO `access_log` VALUES (48569, '59.75.15622109402032711', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.134.132', '2019-07-04 11:29:00', 13, 2001001000, '服务端发生异常', '2019-07-04 11:29:00');
INSERT INTO `access_log` VALUES (48570, '65.3607.15622112671926007', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.145.60.8', '2019-07-04 11:34:27', 0, 1002001015, '账号未登陆', '2019-07-04 11:34:27');
INSERT INTO `access_log` VALUES (48571, '65.47.15622112671974189', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.145.60.8', '2019-07-04 11:34:27', 0, 1002001015, '账号未登陆', '2019-07-04 11:34:27');
INSERT INTO `access_log` VALUES (48572, '65.50.15622112671924231', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.145.60.8', '2019-07-04 11:34:27', 0, 1002001015, '账号未登陆', '2019-07-04 11:34:27');
INSERT INTO `access_log` VALUES (48573, '65.53.15622112689614213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.145.60.8', '2019-07-04 11:34:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 11:34:29');
INSERT INTO `access_log` VALUES (48574, '65.54.15622112719834167', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.145.60.8', '2019-07-04 11:34:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 11:34:32');
INSERT INTO `access_log` VALUES (48575, '59.78.15622114805562703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.197.94', '2019-07-04 11:38:01', 3, 0, '', '2019-07-04 11:38:01');
INSERT INTO `access_log` VALUES (48576, '59.73.15622114805582713', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.127.197.94', '2019-07-04 11:38:01', 17, 2001001000, '服务端发生异常', '2019-07-04 11:38:01');
INSERT INTO `access_log` VALUES (48577, '59.76.15622126714292719', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:57:51', 3, 0, '', '2019-07-04 11:57:51');
INSERT INTO `access_log` VALUES (48578, '59.75.15622126714332735', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:57:51', 9, 2001001000, '服务端发生异常', '2019-07-04 11:57:51');
INSERT INTO `access_log` VALUES (48579, '64.77.15622126742652851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:57:54', 11, 0, '', '2019-07-04 11:57:54');
INSERT INTO `access_log` VALUES (48580, '64.79.15622126744292869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:57:54', 2, 0, '', '2019-07-04 11:57:54');
INSERT INTO `access_log` VALUES (48581, '64.85.15622126758492877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:57:56', 2, 0, '', '2019-07-04 11:57:56');
INSERT INTO `access_log` VALUES (48582, '64.76.15622126765792861', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:57:57', 2, 0, '', '2019-07-04 11:57:57');
INSERT INTO `access_log` VALUES (48583, '64.84.15622126770502861', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:57:57', 2, 0, '', '2019-07-04 11:57:57');
INSERT INTO `access_log` VALUES (48584, '65.53.15622126872644233', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:58:07', 0, 1002001015, '账号未登陆', '2019-07-04 11:58:07');
INSERT INTO `access_log` VALUES (48585, '65.49.15622126872644227', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:58:07', 0, 1002001015, '账号未登陆', '2019-07-04 11:58:07');
INSERT INTO `access_log` VALUES (48586, '65.47.15622126872644209', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:58:07', 0, 1002001015, '账号未登陆', '2019-07-04 11:58:07');
INSERT INTO `access_log` VALUES (48587, '65.45.15622126890574221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:58:09', 43, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 11:58:09');
INSERT INTO `access_log` VALUES (48588, '65.51.15622127091094277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:58:29', 171, 0, '', '2019-07-04 11:58:29');
INSERT INTO `access_log` VALUES (48589, '65.3607.15622127095046029', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:58:30', 12, 0, '', '2019-07-04 11:58:30');
INSERT INTO `access_log` VALUES (48590, '65.50.15622127095104253', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:58:30', 9, 0, '', '2019-07-04 11:58:30');
INSERT INTO `access_log` VALUES (48591, '65.54.15622127095094189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.26.176.142', '2019-07-04 11:58:30', 9, 2001001000, '服务端发生异常', '2019-07-04 11:58:30');
INSERT INTO `access_log` VALUES (48592, '65.50.15622131141754259', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-04 12:05:14', 4, 1002001012, '访问令牌已过期', '2019-07-04 12:05:14');
INSERT INTO `access_log` VALUES (48593, '65.3607.15622131141756035', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-04 12:05:14', 4, 1002001012, '访问令牌已过期', '2019-07-04 12:05:14');
INSERT INTO `access_log` VALUES (48594, '65.54.15622131141774195', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-04 12:05:14', 4, 1002001012, '访问令牌已过期', '2019-07-04 12:05:14');
INSERT INTO `access_log` VALUES (48595, '59.79.15622133563182737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-04 12:09:16', 3, 0, '', '2019-07-04 12:09:16');
INSERT INTO `access_log` VALUES (48596, '59.78.15622133563192729', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '221.226.132.2', '2019-07-04 12:09:16', 13, 2001001000, '服务端发生异常', '2019-07-04 12:09:16');
INSERT INTO `access_log` VALUES (48597, '59.73.15622168067782785', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-04 13:06:47', 10, 0, '', '2019-07-04 13:06:47');
INSERT INTO `access_log` VALUES (48598, '59.76.15622168067792775', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-04 13:06:47', 13, 2001001000, '服务端发生异常', '2019-07-04 13:06:47');
INSERT INTO `access_log` VALUES (48599, '65.53.15622171660594295', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-04 13:12:46', 15, 1002001012, '访问令牌已过期', '2019-07-04 13:12:46');
INSERT INTO `access_log` VALUES (48600, '65.50.15622171660594315', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-04 13:12:46', 17, 1002001012, '访问令牌已过期', '2019-07-04 13:12:46');
INSERT INTO `access_log` VALUES (48601, '65.45.15622171660814281', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-04 13:12:46', 10, 1002001012, '访问令牌已过期', '2019-07-04 13:12:46');
INSERT INTO `access_log` VALUES (48602, '65.47.15622171695724273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-04 13:12:50', 89, 0, '', '2019-07-04 13:12:50');
INSERT INTO `access_log` VALUES (48603, '65.52.15622171700364327', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-04 13:12:50', 173, 0, '', '2019-07-04 13:12:50');
INSERT INTO `access_log` VALUES (48604, '65.49.15622171700304289', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-04 13:12:50', 179, 0, '', '2019-07-04 13:12:50');
INSERT INTO `access_log` VALUES (48605, '65.3607.15622171700326091', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.200.20.69', '2019-07-04 13:12:50', 178, 2001001000, '服务端发生异常', '2019-07-04 13:12:50');
INSERT INTO `access_log` VALUES (48606, '65.53.15622221800054363', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '218.241.181.230', '2019-07-04 14:36:20', 0, 1002001015, '账号未登陆', '2019-07-04 14:36:20');
INSERT INTO `access_log` VALUES (48607, '65.45.15622221800054349', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '218.241.181.230', '2019-07-04 14:36:20', 0, 1002001015, '账号未登陆', '2019-07-04 14:36:20');
INSERT INTO `access_log` VALUES (48608, '65.47.15622221800324341', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '218.241.181.230', '2019-07-04 14:36:20', 0, 1002001015, '账号未登陆', '2019-07-04 14:36:20');
INSERT INTO `access_log` VALUES (48609, '65.52.15622221841984395', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '218.241.181.230', '2019-07-04 14:36:24', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 14:36:24');
INSERT INTO `access_log` VALUES (48610, '65.51.15622222037534409', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '218.241.181.230', '2019-07-04 14:36:44', 66, 0, '', '2019-07-04 14:36:44');
INSERT INTO `access_log` VALUES (48611, '65.46.15622222041814415', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '218.241.181.230', '2019-07-04 14:36:44', 11, 0, '', '2019-07-04 14:36:44');
INSERT INTO `access_log` VALUES (48612, '65.54.15622222041864319', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '218.241.181.230', '2019-07-04 14:36:44', 11, 2001001000, '服务端发生异常', '2019-07-04 14:36:44');
INSERT INTO `access_log` VALUES (48613, '65.50.15622222041934385', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/60.0.3112.90 Safari/537.36', '218.241.181.230', '2019-07-04 14:36:44', 15, 0, '', '2019-07-04 14:36:44');
INSERT INTO `access_log` VALUES (48614, '59.73.15622227510212865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.75.109', '2019-07-04 14:45:51', 21, 0, '', '2019-07-04 14:45:51');
INSERT INTO `access_log` VALUES (48615, '59.79.15622227510082863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.75.109', '2019-07-04 14:45:51', 35, 2001001000, '服务端发生异常', '2019-07-04 14:45:51');
INSERT INTO `access_log` VALUES (48616, '64.82.15622227585163013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.75.109', '2019-07-04 14:45:59', 12, 0, '', '2019-07-04 14:45:59');
INSERT INTO `access_log` VALUES (48617, '64.81.15622227593712991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '10.249.75.109', '2019-07-04 14:45:59', 4, 0, '', '2019-07-04 14:45:59');
INSERT INTO `access_log` VALUES (48618, '65.51.15622228969534419', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.91.18', '2019-07-04 14:48:17', 1, 1002001015, '账号未登陆', '2019-07-04 14:48:17');
INSERT INTO `access_log` VALUES (48619, '65.46.15622228969534425', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.91.18', '2019-07-04 14:48:17', 0, 1002001015, '账号未登陆', '2019-07-04 14:48:17');
INSERT INTO `access_log` VALUES (48620, '65.50.15622228969574395', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.91.18', '2019-07-04 14:48:17', 1, 1002001015, '账号未登陆', '2019-07-04 14:48:17');
INSERT INTO `access_log` VALUES (48621, '65.54.15622228995664329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.91.18', '2019-07-04 14:48:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 14:48:20');
INSERT INTO `access_log` VALUES (48622, '65.3607.15622229091166171', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.91.18', '2019-07-04 14:48:29', 178, 0, '', '2019-07-04 14:48:29');
INSERT INTO `access_log` VALUES (48623, '65.52.15622229095164407', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.91.18', '2019-07-04 14:48:30', 9, 0, '', '2019-07-04 14:48:30');
INSERT INTO `access_log` VALUES (48624, '65.49.15622229095204369', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.91.18', '2019-07-04 14:48:30', 11, 2001001000, '服务端发生异常', '2019-07-04 14:48:30');
INSERT INTO `access_log` VALUES (48625, '65.51.15622229095274421', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.91.18', '2019-07-04 14:48:30', 10, 0, '', '2019-07-04 14:48:30');
INSERT INTO `access_log` VALUES (48626, '65.50.15622229147484397', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.91.18', '2019-07-04 14:48:35', 9, 0, '', '2019-07-04 14:48:35');
INSERT INTO `access_log` VALUES (48627, '65.46.15622229147524427', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.91.18', '2019-07-04 14:48:35', 10, 2001001000, '服务端发生异常', '2019-07-04 14:48:35');
INSERT INTO `access_log` VALUES (48628, '65.54.15622229147544331', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.91.18', '2019-07-04 14:48:35', 9, 0, '', '2019-07-04 14:48:35');
INSERT INTO `access_log` VALUES (48629, '59.71.15622229427702865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.91.18', '2019-07-04 14:49:03', 4, 0, '', '2019-07-04 14:49:03');
INSERT INTO `access_log` VALUES (48630, '59.80.15622229427702849', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.91.18', '2019-07-04 14:49:03', 13, 2001001000, '服务端发生异常', '2019-07-04 14:49:03');
INSERT INTO `access_log` VALUES (48631, '65.45.15622238781554377', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-07-04 15:04:38', 4, 1002001012, '访问令牌已过期', '2019-07-04 15:04:38');
INSERT INTO `access_log` VALUES (48632, '65.3607.15622238781606183', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-07-04 15:04:38', 3, 1002001012, '访问令牌已过期', '2019-07-04 15:04:38');
INSERT INTO `access_log` VALUES (48633, '65.49.15622238781624385', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-07-04 15:04:38', 5, 1002001012, '访问令牌已过期', '2019-07-04 15:04:38');
INSERT INTO `access_log` VALUES (48634, '65.46.15622238802534441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-07-04 15:04:40', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 15:04:40');
INSERT INTO `access_log` VALUES (48635, '65.54.15622238839504347', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-07-04 15:04:44', 123, 0, '', '2019-07-04 15:04:44');
INSERT INTO `access_log` VALUES (48636, '65.51.15622238843264437', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-07-04 15:04:44', 9, 0, '', '2019-07-04 15:04:44');
INSERT INTO `access_log` VALUES (48637, '65.50.15622238843274413', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-07-04 15:04:44', 10, 2001001000, '服务端发生异常', '2019-07-04 15:04:44');
INSERT INTO `access_log` VALUES (48638, '65.53.15622238843294391', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-07-04 15:04:44', 9, 0, '', '2019-07-04 15:04:44');
INSERT INTO `access_log` VALUES (48639, '59.79.15622239032752879', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-07-04 15:05:03', 3, 0, '', '2019-07-04 15:05:03');
INSERT INTO `access_log` VALUES (48640, '59.73.15622239032822881', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '120.196.48.101', '2019-07-04 15:05:03', 13, 2001001000, '服务端发生异常', '2019-07-04 15:05:03');
INSERT INTO `access_log` VALUES (48641, '59.80.15622240576272865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:07:38', 3, 0, '', '2019-07-04 15:07:38');
INSERT INTO `access_log` VALUES (48642, '59.75.15622240576262889', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:07:38', 13, 2001001000, '服务端发生异常', '2019-07-04 15:07:38');
INSERT INTO `access_log` VALUES (48643, '64.80.15622240598463025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:07:40', 3, 0, '', '2019-07-04 15:07:40');
INSERT INTO `access_log` VALUES (48644, '64.82.15622240599913031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:07:40', 1, 0, '', '2019-07-04 15:07:40');
INSERT INTO `access_log` VALUES (48645, '64.81.15622240610073009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:07:41', 2, 0, '', '2019-07-04 15:07:41');
INSERT INTO `access_log` VALUES (48646, '64.78.15622240614873027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:07:41', 3, 0, '', '2019-07-04 15:07:41');
INSERT INTO `access_log` VALUES (48647, '59.71.15622240625622881', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:07:43', 2, 0, '', '2019-07-04 15:07:43');
INSERT INTO `access_log` VALUES (48648, '59.77.15622240625632869', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:07:43', 13, 2001001000, '服务端发生异常', '2019-07-04 15:07:43');
INSERT INTO `access_log` VALUES (48649, '65.49.15622240707254389', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:07:51', 1, 1002001015, '账号未登陆', '2019-07-04 15:07:51');
INSERT INTO `access_log` VALUES (48650, '65.45.15622240707304381', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:07:51', 0, 1002001015, '账号未登陆', '2019-07-04 15:07:51');
INSERT INTO `access_log` VALUES (48651, '65.52.15622240707304427', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:07:51', 0, 1002001015, '账号未登陆', '2019-07-04 15:07:51');
INSERT INTO `access_log` VALUES (48652, '65.46.15622240729084445', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:07:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 15:07:53');
INSERT INTO `access_log` VALUES (48653, '65.53.15622240829314395', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:08:03', 79, 0, '', '2019-07-04 15:08:03');
INSERT INTO `access_log` VALUES (48654, '65.50.15622240832824417', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:08:03', 11, 0, '', '2019-07-04 15:08:03');
INSERT INTO `access_log` VALUES (48655, '65.51.15622240832854441', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:08:03', 10, 2001001000, '服务端发生异常', '2019-07-04 15:08:03');
INSERT INTO `access_log` VALUES (48656, '65.47.15622240832854373', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:08:03', 10, 0, '', '2019-07-04 15:08:03');
INSERT INTO `access_log` VALUES (48657, '65.49.15622240911164391', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:08:11', 8, 0, '', '2019-07-04 15:08:11');
INSERT INTO `access_log` VALUES (48658, '65.52.15622240911164429', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:08:11', 9, 2001001000, '服务端发生异常', '2019-07-04 15:08:11');
INSERT INTO `access_log` VALUES (48659, '65.45.15622240911194383', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:08:11', 8, 0, '', '2019-07-04 15:08:11');
INSERT INTO `access_log` VALUES (48660, '65.46.15622240981414447', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:08:18', 7, 0, '', '2019-07-04 15:08:18');
INSERT INTO `access_log` VALUES (48661, '65.53.15622240981434397', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:08:18', 8, 0, '', '2019-07-04 15:08:18');
INSERT INTO `access_log` VALUES (48662, '65.54.15622240981424353', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '182.150.22.50', '2019-07-04 15:08:18', 8, 2001001000, '服务端发生异常', '2019-07-04 15:08:18');
INSERT INTO `access_log` VALUES (48663, '59.72.15622245113412887', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:11', 3, 0, '', '2019-07-04 15:15:11');
INSERT INTO `access_log` VALUES (48664, '59.74.15622245113442887', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:11', 12, 2001001000, '服务端发生异常', '2019-07-04 15:15:11');
INSERT INTO `access_log` VALUES (48665, '64.77.15622245166673011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:17', 3, 0, '', '2019-07-04 15:15:17');
INSERT INTO `access_log` VALUES (48666, '64.79.15622245167763029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:17', 2, 0, '', '2019-07-04 15:15:17');
INSERT INTO `access_log` VALUES (48667, '66.51.15622245199111011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:20', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空', '2019-07-04 15:15:20');
INSERT INTO `access_log` VALUES (48668, '66.56.15622245303961001', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=2222', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:30', 17, 1001003001, '验证码已过期', '2019-07-04 15:15:30');
INSERT INTO `access_log` VALUES (48669, '66.48.15622245324521003', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=12345678911', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:32', 73, 0, '', '2019-07-04 15:15:33');
INSERT INTO `access_log` VALUES (48670, '66.52.15622245342320987', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=2222', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:34', 7, 1001003003, '验证码不正确', '2019-07-04 15:15:34');
INSERT INTO `access_log` VALUES (48671, '66.54.15622245432510997', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:43', 163, 0, '', '2019-07-04 15:15:43');
INSERT INTO `access_log` VALUES (48672, '64.83.15622245490353029', 153, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:49', 9, 0, '', '2019-07-04 15:15:49');
INSERT INTO `access_log` VALUES (48673, '64.82.15622245491593039', 153, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:49', 8, 0, '', '2019-07-04 15:15:49');
INSERT INTO `access_log` VALUES (48674, '64.78.15622245500293035', 153, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:50', 4, 0, '', '2019-07-04 15:15:50');
INSERT INTO `access_log` VALUES (48675, '64.85.15622245506133039', 153, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:51', 5, 0, '', '2019-07-04 15:15:51');
INSERT INTO `access_log` VALUES (48676, '59.71.15622245550422889', 153, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:55', 6, 0, '', '2019-07-04 15:15:55');
INSERT INTO `access_log` VALUES (48677, '59.80.15622245550402873', 153, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:55', 16, 2001001000, '服务端发生异常', '2019-07-04 15:15:55');
INSERT INTO `access_log` VALUES (48678, '64.76.15622245586813023', 153, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:59', 6, 0, '', '2019-07-04 15:15:59');
INSERT INTO `access_log` VALUES (48679, '64.84.15622245587623023', 153, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:15:59', 6, 0, '', '2019-07-04 15:15:59');
INSERT INTO `access_log` VALUES (48680, '59.77.15622245601592877', 153, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:16:00', 6, 0, '', '2019-07-04 15:16:00');
INSERT INTO `access_log` VALUES (48681, '59.72.15622245601612889', 153, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:16:00', 17, 2001001000, '服务端发生异常', '2019-07-04 15:16:00');
INSERT INTO `access_log` VALUES (48682, '65.47.15622245673954381', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:16:07', 0, 1002001015, '账号未登陆', '2019-07-04 15:16:07');
INSERT INTO `access_log` VALUES (48683, '65.50.15622245673944425', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:16:07', 0, 1002001015, '账号未登陆', '2019-07-04 15:16:07');
INSERT INTO `access_log` VALUES (48684, '65.3607.15622245673956197', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:16:07', 1, 1002001015, '账号未登陆', '2019-07-04 15:16:07');
INSERT INTO `access_log` VALUES (48685, '65.49.15622245692954399', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:16:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 15:16:09');
INSERT INTO `access_log` VALUES (48686, '65.45.15622245834124391', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:16:23', 61, 0, '', '2019-07-04 15:16:23');
INSERT INTO `access_log` VALUES (48687, '65.53.15622245836994405', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:16:24', 9, 0, '', '2019-07-04 15:16:24');
INSERT INTO `access_log` VALUES (48688, '65.46.15622245837004455', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:16:24', 9, 0, '', '2019-07-04 15:16:24');
INSERT INTO `access_log` VALUES (48689, '65.54.15622245836984361', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.187.31.34', '2019-07-04 15:16:24', 11, 2001001000, '服务端发生异常', '2019-07-04 15:16:24');
INSERT INTO `access_log` VALUES (48690, '65.51.15622254863574465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-04 15:31:26', 5, 1002002001, '密码不正确', '2019-07-04 15:31:26');
INSERT INTO `access_log` VALUES (48691, '65.50.15622254933734441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=9999&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-04 15:31:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 15:31:33');
INSERT INTO `access_log` VALUES (48692, '65.47.15622255017584395', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=123456&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-04 15:31:42', 67, 0, '', '2019-07-04 15:31:42');
INSERT INTO `access_log` VALUES (48693, '65.3607.15622263621866225', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-04 15:46:02', 47, 1002001012, '访问令牌已过期', '2019-07-04 15:46:02');
INSERT INTO `access_log` VALUES (48694, '65.50.15622263621854453', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-04 15:46:02', 47, 1002001012, '访问令牌已过期', '2019-07-04 15:46:02');
INSERT INTO `access_log` VALUES (48695, '65.47.15622263621864407', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-04 15:46:02', 47, 1002001012, '访问令牌已过期', '2019-07-04 15:46:02');
INSERT INTO `access_log` VALUES (48696, '65.52.15622263664614465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-04 15:46:06', 85, 0, '', '2019-07-04 15:46:07');
INSERT INTO `access_log` VALUES (48697, '65.49.15622263667604427', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-04 15:46:07', 11, 0, '', '2019-07-04 15:46:07');
INSERT INTO `access_log` VALUES (48698, '65.45.15622263667634415', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-04 15:46:07', 9, 0, '', '2019-07-04 15:46:07');
INSERT INTO `access_log` VALUES (48699, '65.46.15622263667664483', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-04 15:46:07', 9, 0, '', '2019-07-04 15:46:07');
INSERT INTO `access_log` VALUES (48700, '64.82.15622263692803065', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-04 15:46:09', 12, 0, '', '2019-07-04 15:46:09');
INSERT INTO `access_log` VALUES (48701, '64.80.15622263692803059', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-04 15:46:09', 15, 0, '', '2019-07-04 15:46:09');
INSERT INTO `access_log` VALUES (48702, '59.78.15622272527412919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:00:53', 9, 2001001000, '服务端发生异常', '2019-07-04 16:00:53');
INSERT INTO `access_log` VALUES (48703, '59.74.15622272527342925', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:00:53', 83, 0, '', '2019-07-04 16:00:53');
INSERT INTO `access_log` VALUES (48704, '64.82.15622272553863077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:00:55', 6, 0, '', '2019-07-04 16:00:55');
INSERT INTO `access_log` VALUES (48705, '64.81.15622272555223055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:00:56', 3, 0, '', '2019-07-04 16:00:56');
INSERT INTO `access_log` VALUES (48706, '64.78.15622272565743073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:00:57', 2, 0, '', '2019-07-04 16:00:57');
INSERT INTO `access_log` VALUES (48707, '64.77.15622272572933051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:00:57', 2, 0, '', '2019-07-04 16:00:57');
INSERT INTO `access_log` VALUES (48708, '59.73.15622272630762929', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:01:03', 3, 0, '', '2019-07-04 16:01:03');
INSERT INTO `access_log` VALUES (48709, '59.79.15622272630762927', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:01:03', 13, 2001001000, '服务端发生异常', '2019-07-04 16:01:03');
INSERT INTO `access_log` VALUES (48710, '64.79.15622272649913069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:01:05', 2, 0, '', '2019-07-04 16:01:05');
INSERT INTO `access_log` VALUES (48711, '64.85.15622272650943077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:01:05', 2, 0, '', '2019-07-04 16:01:05');
INSERT INTO `access_log` VALUES (48712, '59.75.15622272692092935', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:01:09', 3, 0, '', '2019-07-04 16:01:09');
INSERT INTO `access_log` VALUES (48713, '59.80.15622272692092911', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:01:09', 13, 2001001000, '服务端发生异常', '2019-07-04 16:01:09');
INSERT INTO `access_log` VALUES (48714, '64.84.15622272704883061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:01:10', 1, 0, '', '2019-07-04 16:01:10');
INSERT INTO `access_log` VALUES (48715, '64.83.15622272705763069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:01:11', 2, 0, '', '2019-07-04 16:01:11');
INSERT INTO `access_log` VALUES (48716, '59.71.15622272710052927', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:01:11', 2, 0, '', '2019-07-04 16:01:11');
INSERT INTO `access_log` VALUES (48717, '59.77.15622272710062915', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:01:11', 13, 2001001000, '服务端发生异常', '2019-07-04 16:01:11');
INSERT INTO `access_log` VALUES (48718, '59.73.15622280813392941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:14:41', 3, 0, '', '2019-07-04 16:14:41');
INSERT INTO `access_log` VALUES (48719, '59.76.15622280813392931', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:14:41', 12, 2001001000, '服务端发生异常', '2019-07-04 16:14:41');
INSERT INTO `access_log` VALUES (48720, '64.77.15622280834293063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:14:43', 2, 0, '', '2019-07-04 16:14:43');
INSERT INTO `access_log` VALUES (48721, '64.79.15622280835143081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.48.158.126', '2019-07-04 16:14:44', 2, 0, '', '2019-07-04 16:14:44');
INSERT INTO `access_log` VALUES (48722, '65.51.15622293764004519', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:16', 0, 1002001015, '账号未登陆', '2019-07-04 16:36:16');
INSERT INTO `access_log` VALUES (48723, '65.54.15622293764004425', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:16', 0, 1002001015, '账号未登陆', '2019-07-04 16:36:16');
INSERT INTO `access_log` VALUES (48724, '65.3607.15622293764016267', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:16', 0, 1002001015, '账号未登陆', '2019-07-04 16:36:16');
INSERT INTO `access_log` VALUES (48725, '65.50.15622293827554495', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:23', 81, 0, '', '2019-07-04 16:36:23');
INSERT INTO `access_log` VALUES (48726, '65.47.15622293832634449', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:23', 11, 0, '', '2019-07-04 16:36:23');
INSERT INTO `access_log` VALUES (48727, '65.52.15622293832684507', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:23', 10, 2001001000, '服务端发生异常', '2019-07-04 16:36:23');
INSERT INTO `access_log` VALUES (48728, '65.49.15622293832734469', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:23', 9, 0, '', '2019-07-04 16:36:23');
INSERT INTO `access_log` VALUES (48729, '65.53.15622294000624475', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:40', 88, 0, '', '2019-07-04 16:36:40');
INSERT INTO `access_log` VALUES (48730, '65.3607.15622294005306269', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:41', 9, 0, '', '2019-07-04 16:36:41');
INSERT INTO `access_log` VALUES (48731, '65.54.15622294005364427', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:41', 9, 2001001000, '服务端发生异常', '2019-07-04 16:36:41');
INSERT INTO `access_log` VALUES (48732, '65.51.15622294005534521', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:41', 9, 0, '', '2019-07-04 16:36:41');
INSERT INTO `access_log` VALUES (48733, '65.50.15622294136034497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:54', 104, 0, '', '2019-07-04 16:36:54');
INSERT INTO `access_log` VALUES (48734, '65.49.15622294140944471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:54', 9, 0, '', '2019-07-04 16:36:54');
INSERT INTO `access_log` VALUES (48735, '65.46.15622294141024527', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:54', 9, 0, '', '2019-07-04 16:36:54');
INSERT INTO `access_log` VALUES (48736, '65.52.15622294140944509', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5221.400 QQBrowser/10.0.1125.400', '58.58.40.171', '2019-07-04 16:36:54', 11, 2001001000, '服务端发生异常', '2019-07-04 16:36:54');
INSERT INTO `access_log` VALUES (48737, '59.80.15622296938702945', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 16:41:34', 8, 0, '', '2019-07-04 16:41:34');
INSERT INTO `access_log` VALUES (48738, '59.73.15622296938602963', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 16:41:34', 20, 2001001000, '服务端发生异常', '2019-07-04 16:41:34');
INSERT INTO `access_log` VALUES (48739, '65.51.15622312621944549', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:07:42', 1, 1002001015, '账号未登陆', '2019-07-04 17:07:42');
INSERT INTO `access_log` VALUES (48740, '65.54.15622312622134455', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:07:42', 0, 1002001015, '账号未登陆', '2019-07-04 17:07:42');
INSERT INTO `access_log` VALUES (48741, '65.53.15622312622194503', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:07:42', 1, 1002001015, '账号未登陆', '2019-07-04 17:07:42');
INSERT INTO `access_log` VALUES (48742, '65.50.15622312816954523', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:08:02', 79, 0, '', '2019-07-04 17:08:02');
INSERT INTO `access_log` VALUES (48743, '65.47.15622312820844477', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:08:02', 9, 0, '', '2019-07-04 17:08:02');
INSERT INTO `access_log` VALUES (48744, '65.49.15622312820894499', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:08:02', 8, 2001001000, '服务端发生异常', '2019-07-04 17:08:02');
INSERT INTO `access_log` VALUES (48745, '65.52.15622312821024535', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:08:02', 8, 0, '', '2019-07-04 17:08:02');
INSERT INTO `access_log` VALUES (48746, '59.80.15622312983022967', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:08:18', 3, 0, '', '2019-07-04 17:08:18');
INSERT INTO `access_log` VALUES (48747, '59.76.15622312983012975', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:08:18', 9, 2001001000, '服务端发生异常', '2019-07-04 17:08:18');
INSERT INTO `access_log` VALUES (48748, '64.78.15622313389193129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:08:59', 13, 0, '', '2019-07-04 17:08:59');
INSERT INTO `access_log` VALUES (48749, '64.77.15622313390823107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:08:59', 3, 0, '', '2019-07-04 17:08:59');
INSERT INTO `access_log` VALUES (48750, '64.85.15622313507073133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:09:11', 2, 0, '', '2019-07-04 17:09:11');
INSERT INTO `access_log` VALUES (48751, '64.76.15622313508363117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:09:11', 2, 0, '', '2019-07-04 17:09:11');
INSERT INTO `access_log` VALUES (48752, '64.84.15622313526693117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:09:13', 2, 0, '', '2019-07-04 17:09:13');
INSERT INTO `access_log` VALUES (48753, '59.72.15622313590142983', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:09:19', 3, 0, '', '2019-07-04 17:09:19');
INSERT INTO `access_log` VALUES (48754, '59.78.15622313590232977', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:09:19', 12, 2001001000, '服务端发生异常', '2019-07-04 17:09:19');
INSERT INTO `access_log` VALUES (48755, '65.47.15622313736564479', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:09:34', 9, 0, '', '2019-07-04 17:09:34');
INSERT INTO `access_log` VALUES (48756, '65.49.15622313736634501', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:09:34', 8, 0, '', '2019-07-04 17:09:34');
INSERT INTO `access_log` VALUES (48757, '65.46.15622313736644555', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:09:34', 10, 2001001000, '服务端发生异常', '2019-07-04 17:09:34');
INSERT INTO `access_log` VALUES (48758, '65.45.15622313765904489', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:09:37', 10, 0, '', '2019-07-04 17:09:37');
INSERT INTO `access_log` VALUES (48759, '65.54.15622313765934459', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:09:37', 9, 2001001000, '服务端发生异常', '2019-07-04 17:09:37');
INSERT INTO `access_log` VALUES (48760, '65.51.15622313765944553', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:09:37', 9, 0, '', '2019-07-04 17:09:37');
INSERT INTO `access_log` VALUES (48761, '65.50.15622313977474527', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:09:58', 9, 0, '', '2019-07-04 17:09:58');
INSERT INTO `access_log` VALUES (48762, '65.47.15622313977564481', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:09:58', 16, 0, '', '2019-07-04 17:09:58');
INSERT INTO `access_log` VALUES (48763, '65.52.15622313977554539', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.169.133.82', '2019-07-04 17:09:58', 18, 2001001000, '服务端发生异常', '2019-07-04 17:09:58');
INSERT INTO `access_log` VALUES (48764, '59.75.15622320001573001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:20:00', 9, 0, '', '2019-07-04 17:20:00');
INSERT INTO `access_log` VALUES (48765, '59.77.15622320001662981', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:20:00', 23, 2001001000, '服务端发生异常', '2019-07-04 17:20:00');
INSERT INTO `access_log` VALUES (48766, '64.85.15622320421113143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:20:42', 9, 0, '', '2019-07-04 17:20:42');
INSERT INTO `access_log` VALUES (48767, '64.84.15622320422913127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:20:42', 7, 0, '', '2019-07-04 17:20:42');
INSERT INTO `access_log` VALUES (48768, '59.78.15622320454572987', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:20:45', 11, 0, '', '2019-07-04 17:20:45');
INSERT INTO `access_log` VALUES (48769, '59.79.15622320454572995', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:20:45', 27, 2001001000, '服务端发生异常', '2019-07-04 17:20:45');
INSERT INTO `access_log` VALUES (48770, '59.76.15622320518232987', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:20:52', 9, 0, '', '2019-07-04 17:20:52');
INSERT INTO `access_log` VALUES (48771, '59.73.15622320518232997', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:20:52', 18, 2001001000, '服务端发生异常', '2019-07-04 17:20:52');
INSERT INTO `access_log` VALUES (48772, '66.55.15622320556271069', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:20:56', 6, 1002001012, '访问令牌已过期', '2019-07-04 17:20:56');
INSERT INTO `access_log` VALUES (48773, '66.51.15622320557741113', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=a953053b07b74f2287fa2b06a9e02d88', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:20:56', 11, 1002001018, '访问令牌已过期', '2019-07-04 17:20:56');
INSERT INTO `access_log` VALUES (48774, '59.74.15622321077692995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:21:48', 9, 0, '', '2019-07-04 17:21:48');
INSERT INTO `access_log` VALUES (48775, '59.72.15622321077702995', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:21:48', 18, 2001001000, '服务端发生异常', '2019-07-04 17:21:48');
INSERT INTO `access_log` VALUES (48776, '64.82.15622323692513149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:26:09', 8, 0, '', '2019-07-04 17:26:09');
INSERT INTO `access_log` VALUES (48777, '64.81.15622323693803127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:26:09', 7, 0, '', '2019-07-04 17:26:09');
INSERT INTO `access_log` VALUES (48778, '66.49.15622325074001113', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:28:27', 7, 1002001012, '访问令牌已过期', '2019-07-04 17:28:27');
INSERT INTO `access_log` VALUES (48779, '66.56.15622325075141109', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=a953053b07b74f2287fa2b06a9e02d88', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:28:28', 13, 1002001018, '访问令牌已过期', '2019-07-04 17:28:28');
INSERT INTO `access_log` VALUES (48780, '59.79.15622325463853003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.88.10.223', '2019-07-04 17:29:06', 4, 0, '', '2019-07-04 17:29:06');
INSERT INTO `access_log` VALUES (48781, '59.78.15622325463842995', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.88.10.223', '2019-07-04 17:29:06', 18, 2001001000, '服务端发生异常', '2019-07-04 17:29:06');
INSERT INTO `access_log` VALUES (48782, '64.79.15622325522723143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.88.10.223', '2019-07-04 17:29:12', 2, 0, '', '2019-07-04 17:29:12');
INSERT INTO `access_log` VALUES (48783, '64.85.15622325524673151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.88.10.223', '2019-07-04 17:29:12', 1, 0, '', '2019-07-04 17:29:12');
INSERT INTO `access_log` VALUES (48784, '64.76.15622325538853135', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.88.10.223', '2019-07-04 17:29:14', 2, 0, '', '2019-07-04 17:29:14');
INSERT INTO `access_log` VALUES (48785, '64.84.15622325544873135', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.88.10.223', '2019-07-04 17:29:14', 2, 0, '', '2019-07-04 17:29:14');
INSERT INTO `access_log` VALUES (48786, '65.50.15622325698844543', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.88.10.223', '2019-07-04 17:29:30', 0, 1002001015, '账号未登陆', '2019-07-04 17:29:30');
INSERT INTO `access_log` VALUES (48787, '65.47.15622325698904497', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.88.10.223', '2019-07-04 17:29:30', 0, 1002001015, '账号未登陆', '2019-07-04 17:29:30');
INSERT INTO `access_log` VALUES (48788, '65.46.15622325699294573', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.88.10.223', '2019-07-04 17:29:30', 0, 1002001015, '账号未登陆', '2019-07-04 17:29:30');
INSERT INTO `access_log` VALUES (48789, '65.49.15622325725084519', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.88.10.223', '2019-07-04 17:29:33', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 17:29:33');
INSERT INTO `access_log` VALUES (48790, '65.54.15622325796084477', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.88.10.223', '2019-07-04 17:29:40', 100, 0, '', '2019-07-04 17:29:40');
INSERT INTO `access_log` VALUES (48791, '65.45.15622325800364507', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.88.10.223', '2019-07-04 17:29:40', 10, 0, '', '2019-07-04 17:29:40');
INSERT INTO `access_log` VALUES (48792, '65.53.15622325800434525', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.88.10.223', '2019-07-04 17:29:40', 9, 2001001000, '服务端发生异常', '2019-07-04 17:29:40');
INSERT INTO `access_log` VALUES (48793, '65.3607.15622325800486317', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.88.10.223', '2019-07-04 17:29:40', 7, 0, '', '2019-07-04 17:29:40');
INSERT INTO `access_log` VALUES (48794, '65.51.15622326636864573', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:31:04', 4, 1002001012, '访问令牌已过期', '2019-07-04 17:31:04');
INSERT INTO `access_log` VALUES (48795, '65.54.15622326636894479', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:31:04', 3, 1002001012, '访问令牌已过期', '2019-07-04 17:31:04');
INSERT INTO `access_log` VALUES (48796, '65.45.15622326636924509', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:31:04', 2, 1002001012, '访问令牌已过期', '2019-07-04 17:31:04');
INSERT INTO `access_log` VALUES (48797, '65.3607.15622326654376319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:31:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 17:31:05');
INSERT INTO `access_log` VALUES (48798, '65.52.15622326705304559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:31:11', 97, 0, '', '2019-07-04 17:31:11');
INSERT INTO `access_log` VALUES (48799, '65.47.15622326708754501', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:31:11', 9, 0, '', '2019-07-04 17:31:11');
INSERT INTO `access_log` VALUES (48800, '65.50.15622326708794547', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:31:11', 10, 2001001000, '服务端发生异常', '2019-07-04 17:31:11');
INSERT INTO `access_log` VALUES (48801, '65.46.15622326708814577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:31:11', 8, 0, '', '2019-07-04 17:31:11');
INSERT INTO `access_log` VALUES (48802, '65.49.15622326787474523', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:31:19', 9, 0, '', '2019-07-04 17:31:19');
INSERT INTO `access_log` VALUES (48803, '65.54.15622326787514481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:31:19', 9, 2001001000, '服务端发生异常', '2019-07-04 17:31:19');
INSERT INTO `access_log` VALUES (48804, '65.45.15622326787544511', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:31:19', 8, 0, '', '2019-07-04 17:31:19');
INSERT INTO `access_log` VALUES (48805, '65.53.15622328549904531', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:34:15', 10, 0, '', '2019-07-04 17:34:15');
INSERT INTO `access_log` VALUES (48806, '65.52.15622328549954563', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:34:15', 10, 2001001000, '服务端发生异常', '2019-07-04 17:34:15');
INSERT INTO `access_log` VALUES (48807, '65.47.15622328550064505', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-04 17:34:15', 10, 0, '', '2019-07-04 17:34:15');
INSERT INTO `access_log` VALUES (48808, '65.54.15622343278184505', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.191.116.42', '2019-07-04 17:58:48', 1, 1002001015, '账号未登陆', '2019-07-04 17:58:48');
INSERT INTO `access_log` VALUES (48809, '65.46.15622343278184599', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.191.116.42', '2019-07-04 17:58:48', 1, 1002001015, '账号未登陆', '2019-07-04 17:58:48');
INSERT INTO `access_log` VALUES (48810, '65.45.15622343278184533', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.191.116.42', '2019-07-04 17:58:48', 0, 1002001015, '账号未登陆', '2019-07-04 17:58:48');
INSERT INTO `access_log` VALUES (48811, '65.47.15622343500574527', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.191.116.42', '2019-07-04 17:59:10', 86, 0, '', '2019-07-04 17:59:10');
INSERT INTO `access_log` VALUES (48812, '65.51.15622343504284599', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.191.116.42', '2019-07-04 17:59:10', 9, 0, '', '2019-07-04 17:59:10');
INSERT INTO `access_log` VALUES (48813, '65.50.15622343504364573', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.191.116.42', '2019-07-04 17:59:10', 14, 2001001000, '服务端发生异常', '2019-07-04 17:59:10');
INSERT INTO `access_log` VALUES (48814, '65.52.15622343504384585', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '60.191.116.42', '2019-07-04 17:59:10', 14, 0, '', '2019-07-04 17:59:10');
INSERT INTO `access_log` VALUES (48815, '59.74.15622345918233029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.207.137.122', '2019-07-04 18:03:12', 11, 0, '', '2019-07-04 18:03:12');
INSERT INTO `access_log` VALUES (48816, '59.72.15622345918583029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.207.137.122', '2019-07-04 18:03:12', 12, 2001001000, '服务端发生异常', '2019-07-04 18:03:12');
INSERT INTO `access_log` VALUES (48817, '64.79.15622345941403171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.207.137.122', '2019-07-04 18:03:14', 12, 0, '', '2019-07-04 18:03:14');
INSERT INTO `access_log` VALUES (48818, '64.85.15622345943133179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.207.137.122', '2019-07-04 18:03:14', 3, 0, '', '2019-07-04 18:03:14');
INSERT INTO `access_log` VALUES (48819, '65.50.15622346083214577', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.207.137.122', '2019-07-04 18:03:28', 0, 1002001015, '账号未登陆', '2019-07-04 18:03:28');
INSERT INTO `access_log` VALUES (48820, '65.52.15622346083224589', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.207.137.122', '2019-07-04 18:03:28', 1, 1002001015, '账号未登陆', '2019-07-04 18:03:28');
INSERT INTO `access_log` VALUES (48821, '65.51.15622346083264603', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.207.137.122', '2019-07-04 18:03:28', 0, 1002001015, '账号未登陆', '2019-07-04 18:03:28');
INSERT INTO `access_log` VALUES (48822, '65.49.15622346103324553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.207.137.122', '2019-07-04 18:03:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 18:03:30');
INSERT INTO `access_log` VALUES (48823, '65.54.15622346152394511', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.207.137.122', '2019-07-04 18:03:35', 174, 0, '', '2019-07-04 18:03:35');
INSERT INTO `access_log` VALUES (48824, '65.45.15622346157114539', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.207.137.122', '2019-07-04 18:03:36', 9, 0, '', '2019-07-04 18:03:36');
INSERT INTO `access_log` VALUES (48825, '65.46.15622346157124605', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.207.137.122', '2019-07-04 18:03:36', 9, 2001001000, '服务端发生异常', '2019-07-04 18:03:36');
INSERT INTO `access_log` VALUES (48826, '65.3607.15622346157166351', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.207.137.122', '2019-07-04 18:03:36', 8, 0, '', '2019-07-04 18:03:36');
INSERT INTO `access_log` VALUES (48827, '65.50.15622387038514633', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.234.146', '2019-07-04 19:11:44', 1, 1002001015, '账号未登陆', '2019-07-04 19:11:44');
INSERT INTO `access_log` VALUES (48828, '65.51.15622387038514659', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.234.146', '2019-07-04 19:11:44', 0, 1002001015, '账号未登陆', '2019-07-04 19:11:44');
INSERT INTO `access_log` VALUES (48829, '65.49.15622387038614609', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.234.146', '2019-07-04 19:11:44', 1, 1002001015, '账号未登陆', '2019-07-04 19:11:44');
INSERT INTO `access_log` VALUES (48830, '65.54.15622387065454567', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.234.146', '2019-07-04 19:11:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 19:11:47');
INSERT INTO `access_log` VALUES (48831, '65.52.15622387787054647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.234.146', '2019-07-04 19:12:59', 59, 0, '', '2019-07-04 19:12:59');
INSERT INTO `access_log` VALUES (48832, '65.50.15622387790724635', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.234.146', '2019-07-04 19:12:59', 11, 0, '', '2019-07-04 19:12:59');
INSERT INTO `access_log` VALUES (48833, '65.49.15622387790794611', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.234.146', '2019-07-04 19:12:59', 10, 2001001000, '服务端发生异常', '2019-07-04 19:12:59');
INSERT INTO `access_log` VALUES (48834, '65.51.15622387790804661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.234.146', '2019-07-04 19:12:59', 10, 0, '', '2019-07-04 19:12:59');
INSERT INTO `access_log` VALUES (48835, '59.71.15622391971613091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.90.35.163', '2019-07-04 19:19:57', 9, 0, '', '2019-07-04 19:19:57');
INSERT INTO `access_log` VALUES (48836, '59.74.15622391971633091', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.90.35.163', '2019-07-04 19:19:57', 12, 2001001000, '服务端发生异常', '2019-07-04 19:19:57');
INSERT INTO `access_log` VALUES (48837, '59.72.15622392033823091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.90.35.163', '2019-07-04 19:20:03', 3, 0, '', '2019-07-04 19:20:03');
INSERT INTO `access_log` VALUES (48838, '59.79.15622392033853093', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.90.35.163', '2019-07-04 19:20:03', 16, 2001001000, '服务端发生异常', '2019-07-04 19:20:03');
INSERT INTO `access_log` VALUES (48839, '59.78.15622392037453085', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.90.35.163', '2019-07-04 19:20:04', 2, 0, '', '2019-07-04 19:20:04');
INSERT INTO `access_log` VALUES (48840, '59.80.15622392037463077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.90.35.163', '2019-07-04 19:20:04', 11, 2001001000, '服务端发生异常', '2019-07-04 19:20:04');
INSERT INTO `access_log` VALUES (48841, '64.79.15622392064763233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.90.35.163', '2019-07-04 19:20:06', 10, 0, '', '2019-07-04 19:20:06');
INSERT INTO `access_log` VALUES (48842, '64.85.15622392066993241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.90.35.163', '2019-07-04 19:20:07', 3, 0, '', '2019-07-04 19:20:07');
INSERT INTO `access_log` VALUES (48843, '64.76.15622392078673225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.90.35.163', '2019-07-04 19:20:08', 1, 0, '', '2019-07-04 19:20:08');
INSERT INTO `access_log` VALUES (48844, '64.84.15622392084013225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.90.35.163', '2019-07-04 19:20:08', 1, 0, '', '2019-07-04 19:20:08');
INSERT INTO `access_log` VALUES (48845, '64.83.15622392089873233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.90.35.163', '2019-07-04 19:20:09', 2, 0, '', '2019-07-04 19:20:09');
INSERT INTO `access_log` VALUES (48846, '65.50.15622396334734647', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.37.42', '2019-07-04 19:27:13', 196, 1002001012, '访问令牌已过期', '2019-07-04 19:27:14');
INSERT INTO `access_log` VALUES (48847, '65.49.15622396334724623', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.37.42', '2019-07-04 19:27:13', 197, 1002001012, '访问令牌已过期', '2019-07-04 19:27:14');
INSERT INTO `access_log` VALUES (48848, '65.51.15622396334714673', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.37.42', '2019-07-04 19:27:13', 197, 1002001012, '访问令牌已过期', '2019-07-04 19:27:14');
INSERT INTO `access_log` VALUES (48849, '65.54.15622396404874581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.37.42', '2019-07-04 19:27:20', 137, 0, '', '2019-07-04 19:27:21');
INSERT INTO `access_log` VALUES (48850, '65.45.15622396409364609', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.37.42', '2019-07-04 19:27:21', 77, 0, '', '2019-07-04 19:27:21');
INSERT INTO `access_log` VALUES (48851, '65.3607.15622396409256421', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.37.42', '2019-07-04 19:27:21', 86, 0, '', '2019-07-04 19:27:21');
INSERT INTO `access_log` VALUES (48852, '65.46.15622396409274675', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.37.42', '2019-07-04 19:27:21', 86, 2001001000, '服务端发生异常', '2019-07-04 19:27:21');
INSERT INTO `access_log` VALUES (48853, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=商品', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-04 19:47:23', 167, 0, '', '2019-07-04 19:47:23');
INSERT INTO `access_log` VALUES (48854, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=商品', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.163.82', '2019-07-04 19:47:26', 11, 0, '', '2019-07-04 19:47:26');
INSERT INTO `access_log` VALUES (48855, '65.53.15622416783404657', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:01:18', 0, 1002001015, '账号未登陆', '2019-07-04 20:01:18');
INSERT INTO `access_log` VALUES (48856, '65.47.15622416783404631', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:01:18', 0, 1002001015, '账号未登陆', '2019-07-04 20:01:18');
INSERT INTO `access_log` VALUES (48857, '65.52.15622416783414687', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:01:18', 0, 1002001015, '账号未登陆', '2019-07-04 20:01:18');
INSERT INTO `access_log` VALUES (48858, '65.54.15622417161724611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:01:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 20:01:56');
INSERT INTO `access_log` VALUES (48859, '65.49.15622417261694653', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:02:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 20:02:06');
INSERT INTO `access_log` VALUES (48860, '65.46.15622417397654705', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:02:20', 58, 0, '', '2019-07-04 20:02:20');
INSERT INTO `access_log` VALUES (48861, '65.53.15622417400964659', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:02:20', 17, 0, '', '2019-07-04 20:02:20');
INSERT INTO `access_log` VALUES (48862, '65.52.15622417401004689', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:02:20', 18, 2001001000, '服务端发生异常', '2019-07-04 20:02:20');
INSERT INTO `access_log` VALUES (48863, '65.47.15622417401284633', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:02:20', 9, 0, '', '2019-07-04 20:02:20');
INSERT INTO `access_log` VALUES (48864, '65.46.15622418245334707', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:03:45', 0, 1002001015, '账号未登陆', '2019-07-04 20:03:45');
INSERT INTO `access_log` VALUES (48865, '65.52.15622418245374691', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:03:45', 0, 1002001015, '账号未登陆', '2019-07-04 20:03:45');
INSERT INTO `access_log` VALUES (48866, '65.53.15622418245414661', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:03:45', 0, 1002001015, '账号未登陆', '2019-07-04 20:03:45');
INSERT INTO `access_log` VALUES (48867, '65.47.15622418269124635', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:03:47', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 20:03:47');
INSERT INTO `access_log` VALUES (48868, '65.50.15622418364094681', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:03:56', 89, 0, '', '2019-07-04 20:03:56');
INSERT INTO `access_log` VALUES (48869, '65.3607.15622418367806455', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:03:57', 10, 0, '', '2019-07-04 20:03:57');
INSERT INTO `access_log` VALUES (48870, '65.54.15622418367844615', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:03:57', 9, 2001001000, '服务端发生异常', '2019-07-04 20:03:57');
INSERT INTO `access_log` VALUES (48871, '65.49.15622418367874657', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-04 20:03:57', 10, 0, '', '2019-07-04 20:03:57');
INSERT INTO `access_log` VALUES (48872, '65.3607.15622424241816465', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.160.17.218', '2019-07-04 20:13:44', 0, 1002001015, '账号未登陆', '2019-07-04 20:13:44');
INSERT INTO `access_log` VALUES (48873, '65.54.15622424241804623', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.160.17.218', '2019-07-04 20:13:44', 0, 1002001015, '账号未登陆', '2019-07-04 20:13:44');
INSERT INTO `access_log` VALUES (48874, '65.49.15622424241804667', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.160.17.218', '2019-07-04 20:13:44', 0, 1002001015, '账号未登陆', '2019-07-04 20:13:44');
INSERT INTO `access_log` VALUES (48875, '65.45.15622424419734651', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.160.17.218', '2019-07-04 20:14:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 20:14:02');
INSERT INTO `access_log` VALUES (48876, '65.53.15622424485684673', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.160.17.218', '2019-07-04 20:14:09', 232, 0, '', '2019-07-04 20:14:09');
INSERT INTO `access_log` VALUES (48877, '65.47.15622424492074647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.160.17.218', '2019-07-04 20:14:09', 9, 0, '', '2019-07-04 20:14:09');
INSERT INTO `access_log` VALUES (48878, '65.51.15622424492104715', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.160.17.218', '2019-07-04 20:14:09', 9, 2001001000, '服务端发生异常', '2019-07-04 20:14:09');
INSERT INTO `access_log` VALUES (48879, '65.50.15622424492134693', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.160.17.218', '2019-07-04 20:14:09', 7, 0, '', '2019-07-04 20:14:09');
INSERT INTO `access_log` VALUES (48880, '65.3607.15622424541126467', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.160.17.218', '2019-07-04 20:14:14', 9, 0, '', '2019-07-04 20:14:14');
INSERT INTO `access_log` VALUES (48881, '65.54.15622424541204625', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.160.17.218', '2019-07-04 20:14:14', 8, 0, '', '2019-07-04 20:14:14');
INSERT INTO `access_log` VALUES (48882, '65.49.15622424541194669', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '124.160.17.218', '2019-07-04 20:14:14', 12, 2001001000, '服务端发生异常', '2019-07-04 20:14:14');
INSERT INTO `access_log` VALUES (48883, '59.77.15622456659493167', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:07:46', 12, 2001001000, '服务端发生异常', '2019-07-04 21:07:46');
INSERT INTO `access_log` VALUES (48884, '59.73.15622456659283181', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:07:46', 197, 0, '', '2019-07-04 21:07:46');
INSERT INTO `access_log` VALUES (48885, '65.51.15622456821484759', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:08:02', 0, 1002001015, '账号未登陆', '2019-07-04 21:08:02');
INSERT INTO `access_log` VALUES (48886, '65.50.15622456821494737', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:08:02', 1, 1002001015, '账号未登陆', '2019-07-04 21:08:02');
INSERT INTO `access_log` VALUES (48887, '65.54.15622456821504669', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:08:02', 0, 1002001015, '账号未登陆', '2019-07-04 21:08:02');
INSERT INTO `access_log` VALUES (48888, '59.74.15622456858353179', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.93.185.118', '2019-07-04 21:08:06', 3, 0, '', '2019-07-04 21:08:06');
INSERT INTO `access_log` VALUES (48889, '59.72.15622456858393179', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.93.185.118', '2019-07-04 21:08:06', 17, 2001001000, '服务端发生异常', '2019-07-04 21:08:06');
INSERT INTO `access_log` VALUES (48890, '64.78.15622457014883325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.93.185.118', '2019-07-04 21:08:21', 11, 0, '', '2019-07-04 21:08:21');
INSERT INTO `access_log` VALUES (48891, '64.77.15622457015903303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.93.185.118', '2019-07-04 21:08:22', 3, 0, '', '2019-07-04 21:08:22');
INSERT INTO `access_log` VALUES (48892, '64.79.15622457029513321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.93.185.118', '2019-07-04 21:08:23', 2, 0, '', '2019-07-04 21:08:23');
INSERT INTO `access_log` VALUES (48893, '64.85.15622457035943329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.93.185.118', '2019-07-04 21:08:24', 2, 0, '', '2019-07-04 21:08:24');
INSERT INTO `access_log` VALUES (48894, '64.76.15622457042083313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.93.185.118', '2019-07-04 21:08:24', 2, 0, '', '2019-07-04 21:08:24');
INSERT INTO `access_log` VALUES (48895, '64.84.15622457054923313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.93.185.118', '2019-07-04 21:08:25', 2, 0, '', '2019-07-04 21:08:25');
INSERT INTO `access_log` VALUES (48896, '64.83.15622457059553321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.93.185.118', '2019-07-04 21:08:26', 2, 0, '', '2019-07-04 21:08:26');
INSERT INTO `access_log` VALUES (48897, '64.80.15622457067103325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.93.185.118', '2019-07-04 21:08:27', 2, 0, '', '2019-07-04 21:08:27');
INSERT INTO `access_log` VALUES (48898, '64.82.15622457075393331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.93.185.118', '2019-07-04 21:08:28', 2, 0, '', '2019-07-04 21:08:28');
INSERT INTO `access_log` VALUES (48899, '64.81.15622457084463309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.93.185.118', '2019-07-04 21:08:28', 2, 0, '', '2019-07-04 21:08:28');
INSERT INTO `access_log` VALUES (48900, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.93.185.118', '2019-07-04 21:08:28', 6, 0, '', '2019-07-04 21:08:28');
INSERT INTO `access_log` VALUES (48901, '64.78.15622457139453327', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.93.185.118', '2019-07-04 21:08:34', 8, 0, '', '2019-07-04 21:08:34');
INSERT INTO `access_log` VALUES (48902, '65.53.15622457526774719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:09:13', 144, 0, '', '2019-07-04 21:09:13');
INSERT INTO `access_log` VALUES (48903, '65.47.15622457531624693', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:09:13', 9, 0, '', '2019-07-04 21:09:13');
INSERT INTO `access_log` VALUES (48904, '65.54.15622457531804671', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:09:13', 17, 2001001000, '服务端发生异常', '2019-07-04 21:09:13');
INSERT INTO `access_log` VALUES (48905, '65.50.15622457537424739', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:09:14', 9, 0, '', '2019-07-04 21:09:14');
INSERT INTO `access_log` VALUES (48906, '65.47.15622458696064695', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:11:10', 10, 0, '', '2019-07-04 21:11:10');
INSERT INTO `access_log` VALUES (48907, '65.50.15622458696144741', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:11:10', 9, 2001001000, '服务端发生异常', '2019-07-04 21:11:10');
INSERT INTO `access_log` VALUES (48908, '65.51.15622458696274763', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:11:10', 9, 0, '', '2019-07-04 21:11:10');
INSERT INTO `access_log` VALUES (48909, '65.51.15622459771484765', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:12:57', 9, 0, '', '2019-07-04 21:12:57');
INSERT INTO `access_log` VALUES (48910, '65.47.15622459771714697', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:12:57', 11, 2001001000, '服务端发生异常', '2019-07-04 21:12:57');
INSERT INTO `access_log` VALUES (48911, '65.50.15622459771734743', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:12:57', 8, 0, '', '2019-07-04 21:12:57');
INSERT INTO `access_log` VALUES (48912, '65.49.15622459847004719', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:13:05', 7, 0, '', '2019-07-04 21:13:05');
INSERT INTO `access_log` VALUES (48913, '65.3607.15622459847026517', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:13:05', 8, 2001001000, '服务端发生异常', '2019-07-04 21:13:05');
INSERT INTO `access_log` VALUES (48914, '65.46.15622459847134769', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:13:05', 8, 0, '', '2019-07-04 21:13:05');
INSERT INTO `access_log` VALUES (48915, '65.51.15622460340444767', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:13:54', 10, 2001001000, '服务端发生异常', '2019-07-04 21:13:54');
INSERT INTO `access_log` VALUES (48916, '65.47.15622460340514699', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:13:54', 7, 0, '', '2019-07-04 21:13:54');
INSERT INTO `access_log` VALUES (48917, '65.50.15622460340534745', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:13:54', 8, 0, '', '2019-07-04 21:13:54');
INSERT INTO `access_log` VALUES (48918, '65.49.15622461879934723', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:16:28', 9, 0, '', '2019-07-04 21:16:28');
INSERT INTO `access_log` VALUES (48919, '65.46.15622461880034773', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:16:28', 10, 2001001000, '服务端发生异常', '2019-07-04 21:16:28');
INSERT INTO `access_log` VALUES (48920, '65.3607.15622461880146521', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:16:28', 9, 0, '', '2019-07-04 21:16:28');
INSERT INTO `access_log` VALUES (48921, '65.52.15622462008104757', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:16:41', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 21:16:41');
INSERT INTO `access_log` VALUES (48922, '65.53.15622462038084729', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:16:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 21:16:44');
INSERT INTO `access_log` VALUES (48923, '65.50.15622462490444749', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:17:29', 58, 0, '', '2019-07-04 21:17:29');
INSERT INTO `access_log` VALUES (48924, '65.46.15622462495134775', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:17:30', 9, 0, '', '2019-07-04 21:17:30');
INSERT INTO `access_log` VALUES (48925, '65.3607.15622462495326523', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:17:30', 10, 2001001000, '服务端发生异常', '2019-07-04 21:17:30');
INSERT INTO `access_log` VALUES (48926, '65.49.15622462495334725', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:17:30', 10, 0, '', '2019-07-04 21:17:30');
INSERT INTO `access_log` VALUES (48927, '65.45.15622462586594709', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:17:39', 9, 0, '', '2019-07-04 21:17:39');
INSERT INTO `access_log` VALUES (48928, '65.52.15622462586674759', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:17:39', 10, 2001001000, '服务端发生异常', '2019-07-04 21:17:39');
INSERT INTO `access_log` VALUES (48929, '65.53.15622462586734731', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:17:39', 8, 0, '', '2019-07-04 21:17:39');
INSERT INTO `access_log` VALUES (48930, '65.51.15622462652564773', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:17:45', 9, 0, '', '2019-07-04 21:17:45');
INSERT INTO `access_log` VALUES (48931, '65.47.15622462652674705', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:17:45', 9, 2001001000, '服务端发生异常', '2019-07-04 21:17:45');
INSERT INTO `access_log` VALUES (48932, '65.50.15622462652814751', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.185.118', '2019-07-04 21:17:45', 8, 0, '', '2019-07-04 21:17:45');
INSERT INTO `access_log` VALUES (48933, '59.80.15622497725273219', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:13', 10, 0, '', '2019-07-04 22:16:13');
INSERT INTO `access_log` VALUES (48934, '59.76.15622497725293227', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:13', 16, 2001001000, '服务端发生异常', '2019-07-04 22:16:13');
INSERT INTO `access_log` VALUES (48935, '64.85.15622497806843385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:21', 17, 0, '', '2019-07-04 22:16:21');
INSERT INTO `access_log` VALUES (48936, '64.76.15622497808083369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:21', 3, 0, '', '2019-07-04 22:16:21');
INSERT INTO `access_log` VALUES (48937, '64.84.15622497817803369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:22', 1, 0, '', '2019-07-04 22:16:22');
INSERT INTO `access_log` VALUES (48938, '64.83.15622497821213377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:22', 2, 0, '', '2019-07-04 22:16:22');
INSERT INTO `access_log` VALUES (48939, '64.80.15622497828623381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:23', 2, 0, '', '2019-07-04 22:16:23');
INSERT INTO `access_log` VALUES (48940, '64.82.15622497832323387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:23', 2, 0, '', '2019-07-04 22:16:23');
INSERT INTO `access_log` VALUES (48941, '59.73.15622497845393237', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:25', 3, 0, '', '2019-07-04 22:16:25');
INSERT INTO `access_log` VALUES (48942, '59.75.15622497845393243', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:25', 13, 2001001000, '服务端发生异常', '2019-07-04 22:16:25');
INSERT INTO `access_log` VALUES (48943, '64.81.15622497861023365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:26', 3, 0, '', '2019-07-04 22:16:26');
INSERT INTO `access_log` VALUES (48944, '64.78.15622497862193383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:26', 2, 0, '', '2019-07-04 22:16:26');
INSERT INTO `access_log` VALUES (48945, '64.77.15622497871033361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:27', 2, 0, '', '2019-07-04 22:16:27');
INSERT INTO `access_log` VALUES (48946, '64.79.15622497873873379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:27', 2, 0, '', '2019-07-04 22:16:27');
INSERT INTO `access_log` VALUES (48947, '59.71.15622497883793235', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:28', 9, 0, '', '2019-07-04 22:16:28');
INSERT INTO `access_log` VALUES (48948, '59.74.15622497883793235', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '103.47.242.231', '2019-07-04 22:16:28', 18, 2001001000, '服务端发生异常', '2019-07-04 22:16:28');
INSERT INTO `access_log` VALUES (48949, '59.80.15622503660933227', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.170.201.110', '2019-07-04 22:26:06', 4, 0, '', '2019-07-04 22:26:06');
INSERT INTO `access_log` VALUES (48950, '59.78.15622503660893237', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.170.201.110', '2019-07-04 22:26:06', 16, 2001001000, '服务端发生异常', '2019-07-04 22:26:06');
INSERT INTO `access_log` VALUES (48951, '64.79.15622503718973387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.170.201.110', '2019-07-04 22:26:12', 4, 0, '', '2019-07-04 22:26:12');
INSERT INTO `access_log` VALUES (48952, '64.85.15622503720123395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.170.201.110', '2019-07-04 22:26:12', 2, 0, '', '2019-07-04 22:26:12');
INSERT INTO `access_log` VALUES (48953, '65.45.15622503879744765', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.170.201.110', '2019-07-04 22:26:28', 1, 1002001015, '账号未登陆', '2019-07-04 22:26:28');
INSERT INTO `access_log` VALUES (48954, '65.54.15622503879754739', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.170.201.110', '2019-07-04 22:26:28', 1, 1002001015, '账号未登陆', '2019-07-04 22:26:28');
INSERT INTO `access_log` VALUES (48955, '65.50.15622503879774807', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.170.201.110', '2019-07-04 22:26:28', 0, 1002001015, '账号未登陆', '2019-07-04 22:26:28');
INSERT INTO `access_log` VALUES (48956, '65.51.15622503895384829', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.170.201.110', '2019-07-04 22:26:30', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 22:26:30');
INSERT INTO `access_log` VALUES (48957, '65.47.15622503954644761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.170.201.110', '2019-07-04 22:26:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 22:26:35');
INSERT INTO `access_log` VALUES (48958, '65.3607.15622504113896581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.170.201.110', '2019-07-04 22:26:51', 66, 0, '', '2019-07-04 22:26:51');
INSERT INTO `access_log` VALUES (48959, '65.52.15622504116634817', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.170.201.110', '2019-07-04 22:26:52', 13, 2001001000, '服务端发生异常', '2019-07-04 22:26:52');
INSERT INTO `access_log` VALUES (48960, '65.46.15622504116624833', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.170.201.110', '2019-07-04 22:26:52', 11, 0, '', '2019-07-04 22:26:52');
INSERT INTO `access_log` VALUES (48961, '65.53.15622504116664789', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.170.201.110', '2019-07-04 22:26:52', 15, 0, '', '2019-07-04 22:26:52');
INSERT INTO `access_log` VALUES (48962, '59.73.15622505552963249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:15', 3, 0, '', '2019-07-04 22:29:15');
INSERT INTO `access_log` VALUES (48963, '59.75.15622505552993255', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:15', 15, 2001001000, '服务端发生异常', '2019-07-04 22:29:15');
INSERT INTO `access_log` VALUES (48964, '65.54.15622505593754743', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:19', 0, 1002001015, '账号未登陆', '2019-07-04 22:29:19');
INSERT INTO `access_log` VALUES (48965, '65.50.15622505593754811', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:19', 0, 1002001015, '账号未登陆', '2019-07-04 22:29:19');
INSERT INTO `access_log` VALUES (48966, '65.45.15622505593794769', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.26', '2019-07-04 22:29:19', 0, 1002001015, '账号未登陆', '2019-07-04 22:29:19');
INSERT INTO `access_log` VALUES (48967, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=工村&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:24', 6, 0, '', '2019-07-04 22:29:24');
INSERT INTO `access_log` VALUES (48968, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=工村', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:24', 5, 0, '', '2019-07-04 22:29:24');
INSERT INTO `access_log` VALUES (48969, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=工村&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=desc', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:30', 7, 0, '', '2019-07-04 22:29:30');
INSERT INTO `access_log` VALUES (48970, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=工村&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:31', 6, 0, '', '2019-07-04 22:29:31');
INSERT INTO `access_log` VALUES (48971, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=工村', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:32', 5, 0, '', '2019-07-04 22:29:32');
INSERT INTO `access_log` VALUES (48972, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=工村&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=asc', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:33', 13, 0, '', '2019-07-04 22:29:33');
INSERT INTO `access_log` VALUES (48973, '59.72.15622505753303247', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:35', 3, 0, '', '2019-07-04 22:29:35');
INSERT INTO `access_log` VALUES (48974, '59.79.15622505753353249', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:35', 12, 2001001000, '服务端发生异常', '2019-07-04 22:29:35');
INSERT INTO `access_log` VALUES (48975, '64.82.15622505818513399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:42', 3, 0, '', '2019-07-04 22:29:42');
INSERT INTO `access_log` VALUES (48976, '64.81.15622505819753377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:42', 2, 0, '', '2019-07-04 22:29:42');
INSERT INTO `access_log` VALUES (48977, '64.78.15622505829773395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:43', 2, 0, '', '2019-07-04 22:29:43');
INSERT INTO `access_log` VALUES (48978, '64.77.15622505837103373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:44', 2, 0, '', '2019-07-04 22:29:44');
INSERT INTO `access_log` VALUES (48979, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=手机&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:47', 6, 0, '', '2019-07-04 22:29:47');
INSERT INTO `access_log` VALUES (48980, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=手机', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:47', 10, 0, '', '2019-07-04 22:29:47');
INSERT INTO `access_log` VALUES (48981, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=手机&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=desc', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:49', 6, 0, '', '2019-07-04 22:29:49');
INSERT INTO `access_log` VALUES (48982, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=手机&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=asc', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:51', 5, 0, '', '2019-07-04 22:29:51');
INSERT INTO `access_log` VALUES (48983, '64.85.15622505916403399', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:52', 7, 0, '', '2019-07-04 22:29:52');
INSERT INTO `access_log` VALUES (48984, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:56', 7, 0, '', '2019-07-04 22:29:56');
INSERT INTO `access_log` VALUES (48985, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:56', 9, 0, '', '2019-07-04 22:29:56');
INSERT INTO `access_log` VALUES (48986, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:56', 4, 0, '', '2019-07-04 22:29:56');
INSERT INTO `access_log` VALUES (48987, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:29:56', 9, 0, '', '2019-07-04 22:29:56');
INSERT INTO `access_log` VALUES (48988, '65.52.15622506107274821', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:30:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-04 22:30:11');
INSERT INTO `access_log` VALUES (48989, '65.46.15622506184764837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:30:18', 168, 0, '', '2019-07-04 22:30:19');
INSERT INTO `access_log` VALUES (48990, '65.54.15622506190564745', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:30:19', 10, 2001001000, '服务端发生异常', '2019-07-04 22:30:19');
INSERT INTO `access_log` VALUES (48991, '65.50.15622506190584813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.26', '2019-07-04 22:30:19', 9, 0, '', '2019-07-04 22:30:19');
INSERT INTO `access_log` VALUES (48992, '65.53.15622506190554793', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '113.107.218.24', '2019-07-04 22:30:19', 10, 0, '', '2019-07-04 22:30:19');
INSERT INTO `access_log` VALUES (48993, '59.74.15622811178313655', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.1; Trident/6.0; Touch; MAARJS)', '95.24.23.113', '2019-07-05 06:58:38', 18, 0, '', '2019-07-05 06:58:38');
INSERT INTO `access_log` VALUES (48994, '59.71.15622811178383655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.1; Trident/6.0; Touch; MAARJS)', '95.24.23.113', '2019-07-05 06:58:38', 31, 2001001000, '服务端发生异常', '2019-07-05 06:58:38');
INSERT INTO `access_log` VALUES (48995, '65.52.15622858763915293', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 08:17:56', 0, 1002001015, '账号未登陆', '2019-07-05 08:17:56');
INSERT INTO `access_log` VALUES (48996, '65.49.15622858763915257', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 08:17:56', 0, 1002001015, '账号未登陆', '2019-07-05 08:17:56');
INSERT INTO `access_log` VALUES (48997, '65.46.15622858763925309', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 08:17:56', 1, 1002001015, '账号未登陆', '2019-07-05 08:17:56');
INSERT INTO `access_log` VALUES (48998, '65.54.15622858806195217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 08:18:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 08:18:01');
INSERT INTO `access_log` VALUES (48999, '65.53.15622858917935263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 08:18:12', 68, 0, '', '2019-07-05 08:18:12');
INSERT INTO `access_log` VALUES (49000, '65.45.15622858920675243', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 08:18:12', 10, 0, '', '2019-07-05 08:18:12');
INSERT INTO `access_log` VALUES (49001, '65.51.15622858920715305', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 08:18:12', 8, 2001001000, '服务端发生异常', '2019-07-05 08:18:12');
INSERT INTO `access_log` VALUES (49002, '65.47.15622858920755239', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 08:18:12', 8, 0, '', '2019-07-05 08:18:12');
INSERT INTO `access_log` VALUES (49003, '65.54.15622859566525219', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 08:19:17', 11, 0, '', '2019-07-05 08:19:17');
INSERT INTO `access_log` VALUES (49004, '65.50.15622859566745287', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 08:19:17', 10, 2001001000, '服务端发生异常', '2019-07-05 08:19:17');
INSERT INTO `access_log` VALUES (49005, '65.53.15622859567795265', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 08:19:17', 18, 0, '', '2019-07-05 08:19:17');
INSERT INTO `access_log` VALUES (49006, '65.47.15622888108035279', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 09:06:51', 13, 1002001012, '访问令牌已过期', '2019-07-05 09:06:51');
INSERT INTO `access_log` VALUES (49007, '65.51.15622888108945345', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 09:06:51', 5, 1002001012, '访问令牌已过期', '2019-07-05 09:06:51');
INSERT INTO `access_log` VALUES (49008, '65.45.15622888108945283', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 09:06:51', 13, 1002001012, '访问令牌已过期', '2019-07-05 09:06:51');
INSERT INTO `access_log` VALUES (49009, '65.3607.15622888125817099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 09:06:53', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 09:06:53');
INSERT INTO `access_log` VALUES (49010, '65.52.15622888164925335', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 09:06:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 09:06:57');
INSERT INTO `access_log` VALUES (49011, '65.46.15622888207935351', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 09:07:01', 87, 0, '', '2019-07-05 09:07:01');
INSERT INTO `access_log` VALUES (49012, '65.50.15622888211915327', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 09:07:01', 11, 0, '', '2019-07-05 09:07:01');
INSERT INTO `access_log` VALUES (49013, '65.54.15622888211935259', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 09:07:01', 12, 2001001000, '服务端发生异常', '2019-07-05 09:07:01');
INSERT INTO `access_log` VALUES (49014, '65.53.15622888212005305', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 09:07:01', 13, 0, '', '2019-07-05 09:07:01');
INSERT INTO `access_log` VALUES (49015, '65.47.15622901708915299', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-05 09:29:31', 13, 1002001012, '访问令牌已过期', '2019-07-05 09:29:31');
INSERT INTO `access_log` VALUES (49016, '65.51.15622901708915365', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-05 09:29:31', 13, 1002001012, '访问令牌已过期', '2019-07-05 09:29:31');
INSERT INTO `access_log` VALUES (49017, '65.45.15622901708955303', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-05 09:29:31', 3, 1002001012, '访问令牌已过期', '2019-07-05 09:29:31');
INSERT INTO `access_log` VALUES (49018, '65.3607.15622901756507119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-05 09:29:36', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 09:29:36');
INSERT INTO `access_log` VALUES (49019, '65.45.15622902688125305', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.80.181.148', '2019-07-05 09:31:09', 1, 1002001015, '账号未登陆', '2019-07-05 09:31:09');
INSERT INTO `access_log` VALUES (49020, '65.47.15622902688125301', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.80.181.148', '2019-07-05 09:31:09', 1, 1002001015, '账号未登陆', '2019-07-05 09:31:09');
INSERT INTO `access_log` VALUES (49021, '65.51.15622902688155367', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.80.181.148', '2019-07-05 09:31:09', 0, 1002001015, '账号未登陆', '2019-07-05 09:31:09');
INSERT INTO `access_log` VALUES (49022, '65.49.15622902776265321', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=youdaoyuanma&password=youdaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.80.181.148', '2019-07-05 09:31:18', 4, 1002002000, '账号不存在', '2019-07-05 09:31:18');
INSERT INTO `access_log` VALUES (49023, '65.53.15622906373335331', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-05 09:37:17', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 09:37:17');
INSERT INTO `access_log` VALUES (49024, '65.51.15622906432695373', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admins&password=nicais&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-05 09:37:23', 5, 1002002000, '账号不存在', '2019-07-05 09:37:23');
INSERT INTO `access_log` VALUES (49025, '65.3607.15622906610087127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-05 09:37:41', 608, 0, '', '2019-07-05 09:37:42');
INSERT INTO `access_log` VALUES (49026, '65.49.15622906619375327', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-05 09:37:42', 9, 0, '', '2019-07-05 09:37:42');
INSERT INTO `access_log` VALUES (49027, '65.52.15622906619425363', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-05 09:37:42', 10, 2001001000, '服务端发生异常', '2019-07-05 09:37:42');
INSERT INTO `access_log` VALUES (49028, '65.46.15622906619755379', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.13.105', '2019-07-05 09:37:42', 10, 0, '', '2019-07-05 09:37:42');
INSERT INTO `access_log` VALUES (49029, '59.78.15622910370263781', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:43:57', 11, 0, '', '2019-07-05 09:43:57');
INSERT INTO `access_log` VALUES (49030, '59.79.15622910370263789', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:43:57', 37, 2001001000, '服务端发生异常', '2019-07-05 09:43:57');
INSERT INTO `access_log` VALUES (49031, '64.77.15622910570233913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:17', 10, 0, '', '2019-07-05 09:44:17');
INSERT INTO `access_log` VALUES (49032, '64.79.15622910571723931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:17', 3, 0, '', '2019-07-05 09:44:17');
INSERT INTO `access_log` VALUES (49033, '64.85.15622910585413939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:19', 2, 0, '', '2019-07-05 09:44:19');
INSERT INTO `access_log` VALUES (49034, '64.76.15622910596823923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:20', 1, 0, '', '2019-07-05 09:44:20');
INSERT INTO `access_log` VALUES (49035, '59.77.15622910614703777', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:21', 4, 0, '', '2019-07-05 09:44:21');
INSERT INTO `access_log` VALUES (49036, '59.73.15622910614713791', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:21', 23, 2001001000, '服务端发生异常', '2019-07-05 09:44:21');
INSERT INTO `access_log` VALUES (49037, '59.75.15622910716543797', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:32', 10, 2001001000, '服务端发生异常', '2019-07-05 09:44:32');
INSERT INTO `access_log` VALUES (49038, '59.74.15622910719033789', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:32', 3, 0, '', '2019-07-05 09:44:32');
INSERT INTO `access_log` VALUES (49039, '64.83.15622910724523931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:32', 2, 0, '', '2019-07-05 09:44:32');
INSERT INTO `access_log` VALUES (49040, '64.80.15622910728403935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:33', 2, 0, '', '2019-07-05 09:44:33');
INSERT INTO `access_log` VALUES (49041, '59.71.15622910730933789', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:33', 2, 0, '', '2019-07-05 09:44:33');
INSERT INTO `access_log` VALUES (49042, '59.72.15622910733453789', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:33', 15, 2001001000, '服务端发生异常', '2019-07-05 09:44:33');
INSERT INTO `access_log` VALUES (49043, '65.52.15622910900275369', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:50', 285, 1002001012, '访问令牌已过期', '2019-07-05 09:44:50');
INSERT INTO `access_log` VALUES (49044, '65.46.15622910900275385', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:50', 285, 1002001012, '访问令牌已过期', '2019-07-05 09:44:50');
INSERT INTO `access_log` VALUES (49045, '65.50.15622910900305361', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:44:50', 282, 1002001012, '访问令牌已过期', '2019-07-05 09:44:50');
INSERT INTO `access_log` VALUES (49046, '65.53.15622911339215341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:45:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 09:45:34');
INSERT INTO `access_log` VALUES (49047, '65.47.15622911391695315', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:45:39', 58, 0, '', '2019-07-05 09:45:39');
INSERT INTO `access_log` VALUES (49048, '65.49.15622911397785335', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:45:40', 120, 0, '', '2019-07-05 09:45:40');
INSERT INTO `access_log` VALUES (49049, '65.54.15622911397895293', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:45:40', 118, 0, '', '2019-07-05 09:45:40');
INSERT INTO `access_log` VALUES (49050, '65.3607.15622911397877137', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:45:40', 121, 2001001000, '服务端发生异常', '2019-07-05 09:45:40');
INSERT INTO `access_log` VALUES (49051, '59.80.15622912517993775', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:47:32', 3, 0, '', '2019-07-05 09:47:32');
INSERT INTO `access_log` VALUES (49052, '59.76.15622912518093783', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:47:32', 17, 2001001000, '服务端发生异常', '2019-07-05 09:47:32');
INSERT INTO `access_log` VALUES (49053, '65.54.15622912703805295', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:47:50', 11, 0, '', '2019-07-05 09:47:50');
INSERT INTO `access_log` VALUES (49054, '65.49.15622912705985337', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:47:51', 9, 0, '', '2019-07-05 09:47:51');
INSERT INTO `access_log` VALUES (49055, '65.50.15622912709025365', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:47:51', 11, 2001001000, '服务端发生异常', '2019-07-05 09:47:51');
INSERT INTO `access_log` VALUES (49056, '65.3607.15622913581607141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:49:18', 76, 0, '', '2019-07-05 09:49:18');
INSERT INTO `access_log` VALUES (49057, '65.54.15622913586055297', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:49:19', 7, 0, '', '2019-07-05 09:49:19');
INSERT INTO `access_log` VALUES (49058, '65.49.15622913586105339', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:49:19', 9, 2001001000, '服务端发生异常', '2019-07-05 09:49:19');
INSERT INTO `access_log` VALUES (49059, '65.50.15622913588655367', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:49:19', 17, 0, '', '2019-07-05 09:49:19');
INSERT INTO `access_log` VALUES (49060, '65.52.15622913764005377', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:49:36', 9, 0, '', '2019-07-05 09:49:36');
INSERT INTO `access_log` VALUES (49061, '65.51.15622913764075387', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:49:36', 9, 2001001000, '服务端发生异常', '2019-07-05 09:49:36');
INSERT INTO `access_log` VALUES (49062, '65.53.15622913766605347', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:49:37', 9, 0, '', '2019-07-05 09:49:37');
INSERT INTO `access_log` VALUES (49063, '65.49.15622914266065341', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:50:27', 9, 0, '', '2019-07-05 09:50:27');
INSERT INTO `access_log` VALUES (49064, '65.50.15622914266125369', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:50:27', 18, 2001001000, '服务端发生异常', '2019-07-05 09:50:27');
INSERT INTO `access_log` VALUES (49065, '65.46.15622914268715395', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '115.171.133.22', '2019-07-05 09:50:27', 10, 0, '', '2019-07-05 09:50:27');
INSERT INTO `access_log` VALUES (49066, '65.51.15622917249295393', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:25', 62, 0, '', '2019-07-05 09:55:25');
INSERT INTO `access_log` VALUES (49067, '65.52.15622917252945383', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:25', 9, 0, '', '2019-07-05 09:55:25');
INSERT INTO `access_log` VALUES (49068, '65.53.15622917252975353', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:25', 10, 2001001000, '服务端发生异常', '2019-07-05 09:55:25');
INSERT INTO `access_log` VALUES (49069, '65.45.15622917252995333', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:25', 9, 0, '', '2019-07-05 09:55:25');
INSERT INTO `access_log` VALUES (49070, '65.54.15622917318955305', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:32', 10, 0, '', '2019-07-05 09:55:32');
INSERT INTO `access_log` VALUES (49071, '65.47.15622917318955327', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:32', 9, 0, '', '2019-07-05 09:55:32');
INSERT INTO `access_log` VALUES (49072, '65.3607.15622917318957149', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:32', 11, 2001001000, '服务端发生异常', '2019-07-05 09:55:32');
INSERT INTO `access_log` VALUES (49073, '65.49.15622917329125347', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:33', 9, 0, '', '2019-07-05 09:55:33');
INSERT INTO `access_log` VALUES (49074, '65.50.15622917329145375', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:33', 9, 2001001000, '服务端发生异常', '2019-07-05 09:55:33');
INSERT INTO `access_log` VALUES (49075, '65.46.15622917329185401', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:33', 9, 0, '', '2019-07-05 09:55:33');
INSERT INTO `access_log` VALUES (49076, '65.51.15622917335805395', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:34', 9, 0, '', '2019-07-05 09:55:34');
INSERT INTO `access_log` VALUES (49077, '65.52.15622917335815385', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:34', 9, 0, '', '2019-07-05 09:55:34');
INSERT INTO `access_log` VALUES (49078, '65.53.15622917335805355', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:34', 10, 2001001000, '服务端发生异常', '2019-07-05 09:55:34');
INSERT INTO `access_log` VALUES (49079, '65.45.15622917343165335', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:34', 9, 0, '', '2019-07-05 09:55:34');
INSERT INTO `access_log` VALUES (49080, '65.54.15622917343185307', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:34', 9, 2001001000, '服务端发生异常', '2019-07-05 09:55:34');
INSERT INTO `access_log` VALUES (49081, '65.47.15622917343195329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:34', 8, 0, '', '2019-07-05 09:55:34');
INSERT INTO `access_log` VALUES (49082, '65.3607.15622917347727151', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:35', 9, 0, '', '2019-07-05 09:55:35');
INSERT INTO `access_log` VALUES (49083, '65.49.15622917347745349', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:35', 9, 0, '', '2019-07-05 09:55:35');
INSERT INTO `access_log` VALUES (49084, '65.50.15622917347745377', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '14.23.52.52', '2019-07-05 09:55:35', 9, 2001001000, '服务端发生异常', '2019-07-05 09:55:35');
INSERT INTO `access_log` VALUES (49085, '65.46.15622920246375407', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.207.141', '2019-07-05 10:00:25', 1, 1002001015, '账号未登陆', '2019-07-05 10:00:25');
INSERT INTO `access_log` VALUES (49086, '65.49.15622921410145355', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:02:21', 4, 1002001012, '访问令牌已过期', '2019-07-05 10:02:21');
INSERT INTO `access_log` VALUES (49087, '65.50.15622921410135383', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:02:21', 4, 1002001012, '访问令牌已过期', '2019-07-05 10:02:21');
INSERT INTO `access_log` VALUES (49088, '65.46.15622921410185409', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:02:21', 3, 1002001012, '访问令牌已过期', '2019-07-05 10:02:21');
INSERT INTO `access_log` VALUES (49089, '65.53.15622921446515363', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:02:25', 99, 0, '', '2019-07-05 10:02:25');
INSERT INTO `access_log` VALUES (49090, '65.52.15622921451155393', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:02:25', 8, 0, '', '2019-07-05 10:02:25');
INSERT INTO `access_log` VALUES (49091, '65.45.15622921451205343', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:02:25', 8, 0, '', '2019-07-05 10:02:25');
INSERT INTO `access_log` VALUES (49092, '65.47.15622921451255337', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:02:25', 7, 0, '', '2019-07-05 10:02:25');
INSERT INTO `access_log` VALUES (49093, '62.82.15622921561313163', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:02:36', 24, 0, '', '2019-07-05 10:02:36');
INSERT INTO `access_log` VALUES (49094, '62.83.15622921624803175', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:02:42', 22, 0, '', '2019-07-05 10:02:43');
INSERT INTO `access_log` VALUES (49095, '64.80.15622921645463951', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:02:45', 18, 0, '', '2019-07-05 10:02:45');
INSERT INTO `access_log` VALUES (49096, '64.81.15622921645513933', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:02:45', 17, 0, '', '2019-07-05 10:02:45');
INSERT INTO `access_log` VALUES (49097, '64.84.15622922489843941', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:04:09', 12, 0, '', '2019-07-05 10:04:09');
INSERT INTO `access_log` VALUES (49098, '64.83.15622922489853949', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:04:09', 15, 0, '', '2019-07-05 10:04:09');
INSERT INTO `access_log` VALUES (49099, '64.80.15622922560203953', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:04:16', 413, 0, '', '2019-07-05 10:04:16');
INSERT INTO `access_log` VALUES (49100, '59.80.15622922703623789', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:04:30', 16, 0, '', '2019-07-05 10:04:30');
INSERT INTO `access_log` VALUES (49101, '59.73.15622922750263809', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:04:35', 46, 2001001000, '服务端发生异常', '2019-07-05 10:04:35');
INSERT INTO `access_log` VALUES (49102, '59.77.15622922791713795', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:04:39', 15, 0, '', '2019-07-05 10:04:39');
INSERT INTO `access_log` VALUES (49103, '59.75.15622922844563815', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:04:44', 16, 0, '', '2019-07-05 10:04:44');
INSERT INTO `access_log` VALUES (49104, '59.74.15622922879393807', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:04:48', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-05 10:04:48');
INSERT INTO `access_log` VALUES (49105, '65.45.15622922903625345', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:04:50', 29, 0, '', '2019-07-05 10:04:50');
INSERT INTO `access_log` VALUES (49106, '65.3607.15622922960137161', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:04:56', 32, 0, '', '2019-07-05 10:04:56');
INSERT INTO `access_log` VALUES (49107, '65.49.15622922983365359', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:04:58', 10, 0, '', '2019-07-05 10:04:58');
INSERT INTO `access_log` VALUES (49108, '65.50.15622923043965387', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:05:04', 16, 0, '', '2019-07-05 10:05:04');
INSERT INTO `access_log` VALUES (49109, '65.53.15622923277315367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:05:28', 75, 0, '', '2019-07-05 10:05:28');
INSERT INTO `access_log` VALUES (49110, '65.52.15622923280105397', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:05:28', 9, 0, '', '2019-07-05 10:05:28');
INSERT INTO `access_log` VALUES (49111, '65.47.15622923280175341', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:05:28', 17, 0, '', '2019-07-05 10:05:28');
INSERT INTO `access_log` VALUES (49112, '65.45.15622923280405347', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:05:28', 9, 0, '', '2019-07-05 10:05:28');
INSERT INTO `access_log` VALUES (49113, '65.3607.15622923395987163', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.62.99', '2019-07-05 10:05:40', 0, 1002001015, '账号未登陆', '2019-07-05 10:05:40');
INSERT INTO `access_log` VALUES (49114, '59.78.15622926306573805', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.248.21.82', '2019-07-05 10:10:31', 3, 0, '', '2019-07-05 10:10:31');
INSERT INTO `access_log` VALUES (49115, '59.80.15622926306573795', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.248.21.82', '2019-07-05 10:10:31', 43, 2001001000, '服务端发生异常', '2019-07-05 10:10:31');
INSERT INTO `access_log` VALUES (49116, '65.51.15622929966485417', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=222222&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:16:37', 143, 0, '', '2019-07-05 10:16:37');
INSERT INTO `access_log` VALUES (49117, '65.53.15622929971055377', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:16:37', 8, 0, '', '2019-07-05 10:16:37');
INSERT INTO `access_log` VALUES (49118, '65.47.15622929971185351', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:16:37', 9, 0, '', '2019-07-05 10:16:37');
INSERT INTO `access_log` VALUES (49119, '65.52.15622929971205407', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:16:37', 8, 0, '', '2019-07-05 10:16:37');
INSERT INTO `access_log` VALUES (49120, '65.3607.15622930178127173', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=1&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:16:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 10:16:58');
INSERT INTO `access_log` VALUES (49121, '65.49.15622930254495371', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=444444&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:17:05', 271, 0, '', '2019-07-05 10:17:06');
INSERT INTO `access_log` VALUES (49122, '65.50.15622930260675399', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:17:06', 9, 0, '', '2019-07-05 10:17:06');
INSERT INTO `access_log` VALUES (49123, '65.46.15622930260675425', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:17:06', 11, 0, '', '2019-07-05 10:17:06');
INSERT INTO `access_log` VALUES (49124, '65.51.15622930260745419', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:17:06', 9, 0, '', '2019-07-05 10:17:06');
INSERT INTO `access_log` VALUES (49125, '65.47.15622934234465359', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:23:43', 9, 0, '', '2019-07-05 10:23:43');
INSERT INTO `access_log` VALUES (49126, '65.52.15622934234525413', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:23:43', 9, 0, '', '2019-07-05 10:23:43');
INSERT INTO `access_log` VALUES (49127, '65.45.15622934234845365', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:23:43', 8, 0, '', '2019-07-05 10:23:43');
INSERT INTO `access_log` VALUES (49128, '62.85.15622934273223175', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:23:47', 16, 0, '', '2019-07-05 10:23:47');
INSERT INTO `access_log` VALUES (49129, '65.49.15622934411215377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:24:01', 142, 0, '', '2019-07-05 10:24:01');
INSERT INTO `access_log` VALUES (49130, '65.54.15622934415745337', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:24:02', 9, 0, '', '2019-07-05 10:24:02');
INSERT INTO `access_log` VALUES (49131, '65.46.15622934415745433', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:24:02', 156, 0, '', '2019-07-05 10:24:02');
INSERT INTO `access_log` VALUES (49132, '65.51.15622934415815427', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:24:02', 155, 0, '', '2019-07-05 10:24:02');
INSERT INTO `access_log` VALUES (49133, '65.53.15622934483465387', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.242.248.246', '2019-07-05 10:24:08', 0, 1002001015, '账号未登陆', '2019-07-05 10:24:08');
INSERT INTO `access_log` VALUES (49134, '65.50.15622934483465407', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.242.248.246', '2019-07-05 10:24:08', 0, 1002001015, '账号未登陆', '2019-07-05 10:24:08');
INSERT INTO `access_log` VALUES (49135, '65.52.15622934483475415', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.242.248.246', '2019-07-05 10:24:08', 0, 1002001015, '账号未登陆', '2019-07-05 10:24:08');
INSERT INTO `access_log` VALUES (49136, '65.45.15622934614185367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.242.248.246', '2019-07-05 10:24:21', 67, 0, '', '2019-07-05 10:24:21');
INSERT INTO `access_log` VALUES (49137, '65.49.15622934618385379', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.242.248.246', '2019-07-05 10:24:22', 17, 0, '', '2019-07-05 10:24:22');
INSERT INTO `access_log` VALUES (49138, '65.54.15622934618405339', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.242.248.246', '2019-07-05 10:24:22', 16, 0, '', '2019-07-05 10:24:22');
INSERT INTO `access_log` VALUES (49139, '65.3607.15622934618387183', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '114.242.248.246', '2019-07-05 10:24:22', 19, 2001001000, '服务端发生异常', '2019-07-05 10:24:22');
INSERT INTO `access_log` VALUES (49140, '59.80.15622935070963807', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:25:07', 6, 0, '', '2019-07-05 10:25:07');
INSERT INTO `access_log` VALUES (49141, '59.76.15622935070973815', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:25:07', 15, 2001001000, '服务端发生异常', '2019-07-05 10:25:07');
INSERT INTO `access_log` VALUES (49142, '59.73.15622935121153827', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:25:12', 2, 0, '', '2019-07-05 10:25:12');
INSERT INTO `access_log` VALUES (49143, '59.77.15622935121193813', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:25:12', 13, 2001001000, '服务端发生异常', '2019-07-05 10:25:12');
INSERT INTO `access_log` VALUES (49144, '59.74.15622935236583825', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:25:24', 4, 0, '', '2019-07-05 10:25:24');
INSERT INTO `access_log` VALUES (49145, '59.71.15622935236603825', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:25:24', 13, 2001001000, '服务端发生异常', '2019-07-05 10:25:24');
INSERT INTO `access_log` VALUES (49146, '59.80.15622935660863809', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-05 10:26:06', 9, 0, '', '2019-07-05 10:26:06');
INSERT INTO `access_log` VALUES (49147, '65.46.15622937490615439', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 10:29:09', 4, 1002001012, '访问令牌已过期', '2019-07-05 10:29:09');
INSERT INTO `access_log` VALUES (49148, '65.51.15622937490615433', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 10:29:09', 4, 1002001012, '访问令牌已过期', '2019-07-05 10:29:09');
INSERT INTO `access_log` VALUES (49149, '65.52.15622937490645421', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 10:29:09', 2, 1002001012, '访问令牌已过期', '2019-07-05 10:29:09');
INSERT INTO `access_log` VALUES (49150, '65.50.15622937541925413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 10:29:14', 56, 0, '', '2019-07-05 10:29:14');
INSERT INTO `access_log` VALUES (49151, '65.53.15622937544845393', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 10:29:14', 9, 0, '', '2019-07-05 10:29:14');
INSERT INTO `access_log` VALUES (49152, '65.47.15622937544855367', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 10:29:14', 10, 0, '', '2019-07-05 10:29:14');
INSERT INTO `access_log` VALUES (49153, '65.45.15622937544875373', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 10:29:14', 10, 0, '', '2019-07-05 10:29:14');
INSERT INTO `access_log` VALUES (49154, '64.81.15622937568653955', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 10:29:17', 23, 0, '', '2019-07-05 10:29:17');
INSERT INTO `access_log` VALUES (49155, '64.82.15622937568673979', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 10:29:17', 19, 0, '', '2019-07-05 10:29:17');
INSERT INTO `access_log` VALUES (49156, '59.79.15622948776673845', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.225.221.242', '2019-07-05 10:47:58', 3, 0, '', '2019-07-05 10:47:58');
INSERT INTO `access_log` VALUES (49157, '59.78.15622948776683837', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.225.221.242', '2019-07-05 10:47:58', 13, 2001001000, '服务端发生异常', '2019-07-05 10:47:58');
INSERT INTO `access_log` VALUES (49158, '65.46.15622948861065455', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.225.221.242', '2019-07-05 10:48:06', 0, 1002001015, '账号未登陆', '2019-07-05 10:48:06');
INSERT INTO `access_log` VALUES (49159, '65.50.15622948861085429', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.225.221.242', '2019-07-05 10:48:06', 0, 1002001015, '账号未登陆', '2019-07-05 10:48:06');
INSERT INTO `access_log` VALUES (49160, '65.47.15622948861265383', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.225.221.242', '2019-07-05 10:48:06', 0, 1002001015, '账号未登陆', '2019-07-05 10:48:06');
INSERT INTO `access_log` VALUES (49161, '65.45.15622949013335389', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.225.221.242', '2019-07-05 10:48:21', 80, 0, '', '2019-07-05 10:48:21');
INSERT INTO `access_log` VALUES (49162, '65.54.15622949016455361', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.225.221.242', '2019-07-05 10:48:22', 10, 0, '', '2019-07-05 10:48:22');
INSERT INTO `access_log` VALUES (49163, '65.49.15622949016475401', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.225.221.242', '2019-07-05 10:48:22', 10, 2001001000, '服务端发生异常', '2019-07-05 10:48:22');
INSERT INTO `access_log` VALUES (49164, '65.3607.15622949016507205', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '122.225.221.242', '2019-07-05 10:48:22', 9, 0, '', '2019-07-05 10:48:22');
INSERT INTO `access_log` VALUES (49165, '65.45.15622949844665391', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.140.25.235', '2019-07-05 10:49:44', 0, 1002001015, '账号未登陆', '2019-07-05 10:49:44');
INSERT INTO `access_log` VALUES (49166, '65.3607.15622949844687207', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.140.25.235', '2019-07-05 10:49:44', 0, 1002001015, '账号未登陆', '2019-07-05 10:49:44');
INSERT INTO `access_log` VALUES (49167, '65.49.15622949844685403', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.140.25.235', '2019-07-05 10:49:44', 0, 1002001015, '账号未登陆', '2019-07-05 10:49:44');
INSERT INTO `access_log` VALUES (49168, '65.54.15622949861625363', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.140.25.235', '2019-07-05 10:49:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 10:49:46');
INSERT INTO `access_log` VALUES (49169, '59.75.15622953938683859', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:34', 3, 0, '', '2019-07-05 10:56:34');
INSERT INTO `access_log` VALUES (49170, '59.71.15622953949403851', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:35', 13, 2001001000, '服务端发生异常', '2019-07-05 10:56:35');
INSERT INTO `access_log` VALUES (49171, '59.72.15622954052903851', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:45', 2, 0, '', '2019-07-05 10:56:45');
INSERT INTO `access_log` VALUES (49172, '59.78.15622954052973845', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:45', 21, 2001001000, '服务端发生异常', '2019-07-05 10:56:45');
INSERT INTO `access_log` VALUES (49173, '64.76.15622954087823983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:49', 7, 0, '', '2019-07-05 10:56:49');
INSERT INTO `access_log` VALUES (49174, '64.84.15622954089183985', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:49', 2, 0, '', '2019-07-05 10:56:49');
INSERT INTO `access_log` VALUES (49175, '64.82.15622954106934003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:51', 2, 0, '', '2019-07-05 10:56:51');
INSERT INTO `access_log` VALUES (49176, '64.81.15622954117263979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:52', 1, 0, '', '2019-07-05 10:56:52');
INSERT INTO `access_log` VALUES (49177, '64.80.15622954123353997', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:52', 2, 0, '', '2019-07-05 10:56:52');
INSERT INTO `access_log` VALUES (49178, '59.80.15622954136563835', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:54', 3, 0, '', '2019-07-05 10:56:54');
INSERT INTO `access_log` VALUES (49179, '59.76.15622954141113843', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:54', 10, 2001001000, '服务端发生异常', '2019-07-05 10:56:54');
INSERT INTO `access_log` VALUES (49180, '64.77.15622954176413975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:58', 2, 0, '', '2019-07-05 10:56:58');
INSERT INTO `access_log` VALUES (49181, '64.79.15622954180163995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:58', 3, 0, '', '2019-07-05 10:56:58');
INSERT INTO `access_log` VALUES (49182, '59.73.15622954191583855', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:59', 38, 2001001000, '服务端发生异常', '2019-07-05 10:56:59');
INSERT INTO `access_log` VALUES (49183, '59.77.15622954194423841', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:56:59', 2, 0, '', '2019-07-05 10:56:59');
INSERT INTO `access_log` VALUES (49184, '64.85.15622954217944001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:02', 2, 0, '', '2019-07-05 10:57:02');
INSERT INTO `access_log` VALUES (49185, '64.78.15622954244273999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:04', 2, 0, '', '2019-07-05 10:57:04');
INSERT INTO `access_log` VALUES (49186, '64.84.15622954360013987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:16', 2, 0, '', '2019-07-05 10:57:16');
INSERT INTO `access_log` VALUES (49187, '64.83.15622954365063993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:17', 2, 0, '', '2019-07-05 10:57:17');
INSERT INTO `access_log` VALUES (49188, '59.74.15622954373853853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:17', 16, 2001001000, '服务端发生异常', '2019-07-05 10:57:17');
INSERT INTO `access_log` VALUES (49189, '59.71.15622954382633853', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:18', 2, 0, '', '2019-07-05 10:57:18');
INSERT INTO `access_log` VALUES (49190, '64.81.15622954426453981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:23', 2, 0, '', '2019-07-05 10:57:23');
INSERT INTO `access_log` VALUES (49191, '64.80.15622954427633999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:23', 2, 0, '', '2019-07-05 10:57:23');
INSERT INTO `access_log` VALUES (49192, '64.77.15622954444593977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:24', 2, 0, '', '2019-07-05 10:57:24');
INSERT INTO `access_log` VALUES (49193, '64.79.15622954449853997', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:25', 2, 0, '', '2019-07-05 10:57:25');
INSERT INTO `access_log` VALUES (49194, '64.85.15622954453144003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:25', 2, 0, '', '2019-07-05 10:57:25');
INSERT INTO `access_log` VALUES (49195, '59.72.15622954462613853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:26', 10, 2001001000, '服务端发生异常', '2019-07-05 10:57:26');
INSERT INTO `access_log` VALUES (49196, '59.79.15622954464263855', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:26', 2, 0, '', '2019-07-05 10:57:26');
INSERT INTO `access_log` VALUES (49197, '64.76.15622954662963987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:46', 2, 0, '', '2019-07-05 10:57:46');
INSERT INTO `access_log` VALUES (49198, '64.84.15622954666563989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:47', 1, 0, '', '2019-07-05 10:57:47');
INSERT INTO `access_log` VALUES (49199, '59.73.15622954691323857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:49', 2, 0, '', '2019-07-05 10:57:49');
INSERT INTO `access_log` VALUES (49200, '59.77.15622954692313843', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:49', 13, 2001001000, '服务端发生异常', '2019-07-05 10:57:49');
INSERT INTO `access_log` VALUES (49201, '64.83.15622954696033995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:50', 1, 0, '', '2019-07-05 10:57:50');
INSERT INTO `access_log` VALUES (49202, '64.82.15622954696884007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:50', 2, 0, '', '2019-07-05 10:57:50');
INSERT INTO `access_log` VALUES (49203, '64.81.15622954698853983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:50', 1, 0, '', '2019-07-05 10:57:50');
INSERT INTO `access_log` VALUES (49204, '59.75.15622954700753863', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:50', 2, 0, '', '2019-07-05 10:57:50');
INSERT INTO `access_log` VALUES (49205, '64.80.15622954703794001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:50', 2, 0, '', '2019-07-05 10:57:50');
INSERT INTO `access_log` VALUES (49206, '59.74.15622954704743855', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:50', 12, 2001001000, '服务端发生异常', '2019-07-05 10:57:50');
INSERT INTO `access_log` VALUES (49207, '64.79.15622954720273999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:52', 2, 0, '', '2019-07-05 10:57:52');
INSERT INTO `access_log` VALUES (49208, '64.85.15622954721384005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:52', 2, 0, '', '2019-07-05 10:57:52');
INSERT INTO `access_log` VALUES (49209, '59.71.15622954722413855', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:52', 17, 2001001000, '服务端发生异常', '2019-07-05 10:57:52');
INSERT INTO `access_log` VALUES (49210, '64.78.15622954726054003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:53', 2, 0, '', '2019-07-05 10:57:53');
INSERT INTO `access_log` VALUES (49211, '59.78.15622954727853849', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:53', 12, 2001001000, '服务端发生异常', '2019-07-05 10:57:53');
INSERT INTO `access_log` VALUES (49212, '59.72.15622954731503855', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:53', 2, 0, '', '2019-07-05 10:57:53');
INSERT INTO `access_log` VALUES (49213, '59.79.15622954732393857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:57:53', 2, 0, '', '2019-07-05 10:57:53');
INSERT INTO `access_log` VALUES (49214, '65.50.15622954846435439', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:58:05', 0, 1002001015, '账号未登陆', '2019-07-05 10:58:05');
INSERT INTO `access_log` VALUES (49215, '65.47.15622954846445393', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:58:05', 1, 1002001015, '账号未登陆', '2019-07-05 10:58:05');
INSERT INTO `access_log` VALUES (49216, '65.53.15622954846525419', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:58:05', 0, 1002001015, '账号未登陆', '2019-07-05 10:58:05');
INSERT INTO `access_log` VALUES (49217, '65.49.15622954867585411', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:58:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 10:58:07');
INSERT INTO `access_log` VALUES (49218, '65.3607.15622954885937215', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:58:09', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 10:58:09');
INSERT INTO `access_log` VALUES (49219, '65.54.15622954890375371', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:58:09', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 10:58:09');
INSERT INTO `access_log` VALUES (49220, '65.52.15622954894475449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:58:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 10:58:09');
INSERT INTO `access_log` VALUES (49221, '65.51.15622954898665461', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:58:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 10:58:10');
INSERT INTO `access_log` VALUES (49222, '65.46.15622954902555467', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:58:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 10:58:10');
INSERT INTO `access_log` VALUES (49223, '65.47.15622954906565395', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:58:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 10:58:11');
INSERT INTO `access_log` VALUES (49224, '65.50.15622955010375441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:58:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 10:58:21');
INSERT INTO `access_log` VALUES (49225, '65.3607.15622955296087217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:58:50', 66, 0, '', '2019-07-05 10:58:50');
INSERT INTO `access_log` VALUES (49226, '65.52.15622955549195451', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:59:15', 9, 0, '', '2019-07-05 10:59:15');
INSERT INTO `access_log` VALUES (49227, '65.51.15622955549285463', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:59:15', 10, 2001001000, '服务端发生异常', '2019-07-05 10:59:15');
INSERT INTO `access_log` VALUES (49228, '65.46.15622955550585469', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-05 10:59:15', 10, 0, '', '2019-07-05 10:59:15');
INSERT INTO `access_log` VALUES (49229, '65.54.15622958036995377', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.81.222.14', '2019-07-05 11:03:24', 0, 1002001015, '账号未登陆', '2019-07-05 11:03:24');
INSERT INTO `access_log` VALUES (49230, '65.52.15622958037095455', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.81.222.14', '2019-07-05 11:03:24', 0, 1002001015, '账号未登陆', '2019-07-05 11:03:24');
INSERT INTO `access_log` VALUES (49231, '65.51.15622958037305467', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.81.222.14', '2019-07-05 11:03:24', 0, 1002001015, '账号未登陆', '2019-07-05 11:03:24');
INSERT INTO `access_log` VALUES (49232, '65.47.15622958068445401', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.81.222.14', '2019-07-05 11:03:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 11:03:27');
INSERT INTO `access_log` VALUES (49233, '65.50.15622958103745447', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.81.222.14', '2019-07-05 11:03:30', 82, 0, '', '2019-07-05 11:03:30');
INSERT INTO `access_log` VALUES (49234, '65.53.15622958107435427', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.81.222.14', '2019-07-05 11:03:31', 7, 0, '', '2019-07-05 11:03:31');
INSERT INTO `access_log` VALUES (49235, '65.49.15622958107495419', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.81.222.14', '2019-07-05 11:03:31', 8, 2001001000, '服务端发生异常', '2019-07-05 11:03:31');
INSERT INTO `access_log` VALUES (49236, '65.3607.15622958107547223', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.81.222.14', '2019-07-05 11:03:31', 7, 0, '', '2019-07-05 11:03:31');
INSERT INTO `access_log` VALUES (49237, '65.47.15622963828875409', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.226.98.20', '2019-07-05 11:13:03', 0, 1002001015, '账号未登陆', '2019-07-05 11:13:03');
INSERT INTO `access_log` VALUES (49238, '65.50.15622963829015457', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.226.98.20', '2019-07-05 11:13:03', 1, 1002001015, '账号未登陆', '2019-07-05 11:13:03');
INSERT INTO `access_log` VALUES (49239, '65.53.15622963829055435', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.226.98.20', '2019-07-05 11:13:03', 0, 1002001015, '账号未登陆', '2019-07-05 11:13:03');
INSERT INTO `access_log` VALUES (49240, '65.54.15622964236685389', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '112.226.98.20', '2019-07-05 11:13:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 11:13:44');
INSERT INTO `access_log` VALUES (49241, '65.45.15622978254425437', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 11:37:05', 0, 1002001015, '账号未登陆', '2019-07-05 11:37:05');
INSERT INTO `access_log` VALUES (49242, '65.52.15622978254435485', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 11:37:05', 1, 1002001015, '账号未登陆', '2019-07-05 11:37:05');
INSERT INTO `access_log` VALUES (49243, '65.54.15622978254605409', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 11:37:05', 0, 1002001015, '账号未登陆', '2019-07-05 11:37:05');
INSERT INTO `access_log` VALUES (49244, '65.46.15622978348165503', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 11:37:15', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 11:37:15');
INSERT INTO `access_log` VALUES (49245, '65.53.15622978414255455', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 11:37:21', 73, 0, '', '2019-07-05 11:37:21');
INSERT INTO `access_log` VALUES (49246, '65.47.15622978629945429', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 11:37:43', 10, 0, '', '2019-07-05 11:37:43');
INSERT INTO `access_log` VALUES (49247, '65.49.15622978629975451', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 11:37:43', 10, 0, '', '2019-07-05 11:37:43');
INSERT INTO `access_log` VALUES (49248, '65.52.15622978629985487', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 11:37:43', 10, 2001001000, '服务端发生异常', '2019-07-05 11:37:43');
INSERT INTO `access_log` VALUES (49249, '65.46.15622979111295505', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.81.222.14', '2019-07-05 11:38:31', 8, 0, '', '2019-07-05 11:38:31');
INSERT INTO `access_log` VALUES (49250, '65.53.15622979111365457', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.81.222.14', '2019-07-05 11:38:31', 9, 2001001000, '服务端发生异常', '2019-07-05 11:38:31');
INSERT INTO `access_log` VALUES (49251, '65.3607.15622979111457253', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.81.222.14', '2019-07-05 11:38:31', 8, 0, '', '2019-07-05 11:38:31');
INSERT INTO `access_log` VALUES (49252, '65.50.15623061551495591', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 13:55:55', 16, 1002001012, '访问令牌已过期', '2019-07-05 13:55:55');
INSERT INTO `access_log` VALUES (49253, '65.47.15623061551495541', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 13:55:55', 13, 1002001012, '访问令牌已过期', '2019-07-05 13:55:55');
INSERT INTO `access_log` VALUES (49254, '65.49.15623061551505563', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 13:55:55', 17, 1002001012, '访问令牌已过期', '2019-07-05 13:55:55');
INSERT INTO `access_log` VALUES (49255, '65.45.15623061747155551', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 13:56:15', 146, 0, '', '2019-07-05 13:56:15');
INSERT INTO `access_log` VALUES (49256, '65.51.15623061751275613', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 13:56:15', 9, 0, '', '2019-07-05 13:56:15');
INSERT INTO `access_log` VALUES (49257, '65.3607.15623061751287365', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 13:56:15', 11, 0, '', '2019-07-05 13:56:15');
INSERT INTO `access_log` VALUES (49258, '65.54.15623061751265523', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-05 13:56:15', 13, 2001001000, '服务端发生异常', '2019-07-05 13:56:15');
INSERT INTO `access_log` VALUES (49259, '65.3607.15623073599607381', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '60.191.76.226', '2019-07-05 14:16:00', 0, 1002001015, '账号未登陆', '2019-07-05 14:16:00');
INSERT INTO `access_log` VALUES (49260, '65.52.15623075752775621', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '60.191.76.226', '2019-07-05 14:19:35', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 14:19:35');
INSERT INTO `access_log` VALUES (49261, '65.45.15623075773465573', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '60.191.76.226', '2019-07-05 14:19:37', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 14:19:37');
INSERT INTO `access_log` VALUES (49262, '65.51.15623075784645631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '60.191.76.226', '2019-07-05 14:19:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 14:19:38');
INSERT INTO `access_log` VALUES (49263, '65.54.15623075792565545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '60.191.76.226', '2019-07-05 14:19:39', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 14:19:39');
INSERT INTO `access_log` VALUES (49264, '59.74.15623088982734035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '211.138.20.168', '2019-07-05 14:41:38', 10, 0, '', '2019-07-05 14:41:38');
INSERT INTO `access_log` VALUES (49265, '59.71.15623088982734035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '211.138.20.168', '2019-07-05 14:41:38', 15, 2001001000, '服务端发生异常', '2019-07-05 14:41:38');
INSERT INTO `access_log` VALUES (49266, '59.78.15623089029224029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '211.138.20.168', '2019-07-05 14:41:43', 3, 0, '', '2019-07-05 14:41:43');
INSERT INTO `access_log` VALUES (49267, '59.72.15623089031694035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '211.138.20.168', '2019-07-05 14:41:43', 13, 2001001000, '服务端发生异常', '2019-07-05 14:41:43');
INSERT INTO `access_log` VALUES (49268, '65.3607.15623089098327403', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '211.138.20.168', '2019-07-05 14:41:50', 0, 1002001015, '账号未登陆', '2019-07-05 14:41:50');
INSERT INTO `access_log` VALUES (49269, '65.54.15623089098335563', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '211.138.20.168', '2019-07-05 14:41:50', 1, 1002001015, '账号未登陆', '2019-07-05 14:41:50');
INSERT INTO `access_log` VALUES (49270, '65.53.15623089098355609', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '211.138.20.168', '2019-07-05 14:41:50', 1, 1002001015, '账号未登陆', '2019-07-05 14:41:50');
INSERT INTO `access_log` VALUES (49271, '65.49.15623095169345609', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 14:51:57', 4, 1002001012, '访问令牌已过期', '2019-07-05 14:51:57');
INSERT INTO `access_log` VALUES (49272, '65.47.15623095169405589', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 14:51:57', 7, 1002001012, '访问令牌已过期', '2019-07-05 14:51:57');
INSERT INTO `access_log` VALUES (49273, '65.50.15623095169415637', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 14:51:57', 3, 1002001012, '访问令牌已过期', '2019-07-05 14:51:57');
INSERT INTO `access_log` VALUES (49274, '65.52.15623095235935649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 14:52:04', 66, 0, '', '2019-07-05 14:52:04');
INSERT INTO `access_log` VALUES (49275, '65.45.15623095239705601', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 14:52:04', 11, 0, '', '2019-07-05 14:52:04');
INSERT INTO `access_log` VALUES (49276, '65.3607.15623095239777413', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 14:52:04', 11, 0, '', '2019-07-05 14:52:04');
INSERT INTO `access_log` VALUES (49277, '65.51.15623095239765659', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 14:52:04', 12, 2001001000, '服务端发生异常', '2019-07-05 14:52:04');
INSERT INTO `access_log` VALUES (49278, '65.53.15623095406515619', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 14:52:21', 10, 0, '', '2019-07-05 14:52:21');
INSERT INTO `access_log` VALUES (49279, '65.46.15623095406555667', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 14:52:21', 10, 2001001000, '服务端发生异常', '2019-07-05 14:52:21');
INSERT INTO `access_log` VALUES (49280, '65.49.15623095406625611', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.137.3.151', '2019-07-05 14:52:21', 8, 0, '', '2019-07-05 14:52:21');
INSERT INTO `access_log` VALUES (49281, '65.45.15623096032335603', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.52.130.26', '2019-07-05 14:53:23', 1, 1002001015, '账号未登陆', '2019-07-05 14:53:23');
INSERT INTO `access_log` VALUES (49282, '65.3607.15623096032377415', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.52.130.26', '2019-07-05 14:53:23', 0, 1002001015, '账号未登陆', '2019-07-05 14:53:23');
INSERT INTO `access_log` VALUES (49283, '65.54.15623096032375575', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.52.130.26', '2019-07-05 14:53:23', 0, 1002001015, '账号未登陆', '2019-07-05 14:53:23');
INSERT INTO `access_log` VALUES (49284, '65.49.15623096124525613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.52.130.26', '2019-07-05 14:53:32', 90, 0, '', '2019-07-05 14:53:33');
INSERT INTO `access_log` VALUES (49285, '65.53.15623096128655621', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.52.130.26', '2019-07-05 14:53:33', 10, 0, '', '2019-07-05 14:53:33');
INSERT INTO `access_log` VALUES (49286, '65.50.15623096128655641', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.52.130.26', '2019-07-05 14:53:33', 10, 0, '', '2019-07-05 14:53:33');
INSERT INTO `access_log` VALUES (49287, '65.47.15623096128665593', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.52.130.26', '2019-07-05 14:53:33', 10, 2001001000, '服务端发生异常', '2019-07-05 14:53:33');
INSERT INTO `access_log` VALUES (49288, '59.74.15623097590944047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.52.130.26', '2019-07-05 14:55:59', 3, 0, '', '2019-07-05 14:55:59');
INSERT INTO `access_log` VALUES (49289, '59.78.15623097590944041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.52.130.26', '2019-07-05 14:55:59', 13, 2001001000, '服务端发生异常', '2019-07-05 14:55:59');
INSERT INTO `access_log` VALUES (49290, '65.45.15623101272575611', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:07', 0, 1002001015, '账号未登陆', '2019-07-05 15:02:07');
INSERT INTO `access_log` VALUES (49291, '65.46.15623101273605677', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:07', 0, 1002001015, '账号未登陆', '2019-07-05 15:02:07');
INSERT INTO `access_log` VALUES (49292, '65.49.15623101274585621', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:07', 1, 1002001015, '账号未登陆', '2019-07-05 15:02:07');
INSERT INTO `access_log` VALUES (49293, '65.47.15623101402425601', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:20', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 15:02:20');
INSERT INTO `access_log` VALUES (49294, '65.50.15623101424675649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 15:02:22');
INSERT INTO `access_log` VALUES (49295, '65.51.15623101472805671', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:27', 101, 0, '', '2019-07-05 15:02:27');
INSERT INTO `access_log` VALUES (49296, '65.54.15623101477115585', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:28', 9, 0, '', '2019-07-05 15:02:28');
INSERT INTO `access_log` VALUES (49297, '65.3607.15623101477427425', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:28', 10, 2001001000, '服务端发生异常', '2019-07-05 15:02:28');
INSERT INTO `access_log` VALUES (49298, '65.45.15623101477635613', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:28', 9, 0, '', '2019-07-05 15:02:28');
INSERT INTO `access_log` VALUES (49299, '65.46.15623101532105679', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:02:33', 1, 1002001015, '账号未登陆', '2019-07-05 15:02:33');
INSERT INTO `access_log` VALUES (49300, '65.49.15623101532155623', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:02:33', 0, 1002001015, '账号未登陆', '2019-07-05 15:02:33');
INSERT INTO `access_log` VALUES (49301, '65.53.15623101532205631', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:02:33', 1, 1002001015, '账号未登陆', '2019-07-05 15:02:33');
INSERT INTO `access_log` VALUES (49302, '65.47.15623101574445603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:02:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 15:02:37');
INSERT INTO `access_log` VALUES (49303, '65.50.15623101578585651', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:38', 9, 0, '', '2019-07-05 15:02:38');
INSERT INTO `access_log` VALUES (49304, '65.52.15623101578915663', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:38', 11, 2001001000, '服务端发生异常', '2019-07-05 15:02:38');
INSERT INTO `access_log` VALUES (49305, '65.51.15623101579165673', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:38', 9, 0, '', '2019-07-05 15:02:38');
INSERT INTO `access_log` VALUES (49306, '65.45.15623101635475615', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:02:44', 196, 0, '', '2019-07-05 15:02:44');
INSERT INTO `access_log` VALUES (49307, '65.3607.15623101650857427', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:02:45', 103, 2001001000, '服务端发生异常', '2019-07-05 15:02:45');
INSERT INTO `access_log` VALUES (49308, '65.46.15623101698265681', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:02:50', 73, 0, '', '2019-07-05 15:02:50');
INSERT INTO `access_log` VALUES (49309, '65.49.15623101702385625', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:02:50', 10, 0, '', '2019-07-05 15:02:50');
INSERT INTO `access_log` VALUES (49310, '65.53.15623101704325633', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:50', 9, 0, '', '2019-07-05 15:02:50');
INSERT INTO `access_log` VALUES (49311, '65.47.15623101704745605', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:50', 18, 2001001000, '服务端发生异常', '2019-07-05 15:02:50');
INSERT INTO `access_log` VALUES (49312, '65.50.15623101704985653', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:50', 9, 0, '', '2019-07-05 15:02:51');
INSERT INTO `access_log` VALUES (49313, '65.52.15623101759555665', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:56', 9, 0, '', '2019-07-05 15:02:56');
INSERT INTO `access_log` VALUES (49314, '65.54.15623101759935589', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:56', 10, 2001001000, '服务端发生异常', '2019-07-05 15:02:56');
INSERT INTO `access_log` VALUES (49315, '65.45.15623101760195617', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:02:56', 10, 0, '', '2019-07-05 15:02:56');
INSERT INTO `access_log` VALUES (49316, '65.3607.15623101761957429', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:02:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 15:02:56');
INSERT INTO `access_log` VALUES (49317, '65.46.15623101826975683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:03:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 15:03:03');
INSERT INTO `access_log` VALUES (49318, '65.49.15623101844405627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.22.162', '2019-07-05 15:03:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 15:03:04');
INSERT INTO `access_log` VALUES (49319, '65.52.15623102392455667', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:03:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 15:03:59');
INSERT INTO `access_log` VALUES (49320, '65.46.15623107362615691', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:12:16', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 15:12:16');
INSERT INTO `access_log` VALUES (49321, '65.52.15623108165795675', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:13:37', 70, 0, '', '2019-07-05 15:13:37');
INSERT INTO `access_log` VALUES (49322, '65.54.15623108170245599', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:13:37', 30, 0, '', '2019-07-05 15:13:37');
INSERT INTO `access_log` VALUES (49323, '65.3607.15623108170367439', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:13:37', 19, 0, '', '2019-07-05 15:13:37');
INSERT INTO `access_log` VALUES (49324, '65.45.15623108170305627', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:13:37', 26, 2001001000, '服务端发生异常', '2019-07-05 15:13:37');
INSERT INTO `access_log` VALUES (49325, '59.75.15623110471404073', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.248.13.142', '2019-07-05 15:17:27', 3, 0, '', '2019-07-05 15:17:27');
INSERT INTO `access_log` VALUES (49326, '59.71.15623110471424065', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.248.13.142', '2019-07-05 15:17:27', 12, 2001001000, '服务端发生异常', '2019-07-05 15:17:27');
INSERT INTO `access_log` VALUES (49327, '66.57.15623110559992145', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.248.13.142', '2019-07-05 15:17:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空', '2019-07-05 15:17:36');
INSERT INTO `access_log` VALUES (49328, '59.78.15623110628554059', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.248.13.142', '2019-07-05 15:17:43', 2, 0, '', '2019-07-05 15:17:43');
INSERT INTO `access_log` VALUES (49329, '59.72.15623110628554065', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.248.13.142', '2019-07-05 15:17:43', 19, 2001001000, '服务端发生异常', '2019-07-05 15:17:43');
INSERT INTO `access_log` VALUES (49330, '66.53.15623110672012153', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.248.13.142', '2019-07-05 15:17:47', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-07-05 15:17:47');
INSERT INTO `access_log` VALUES (49331, '65.45.15623110797625631', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.248.13.142', '2019-07-05 15:18:00', 0, 1002001015, '账号未登陆', '2019-07-05 15:18:00');
INSERT INTO `access_log` VALUES (49332, '65.3607.15623110797747443', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.248.13.142', '2019-07-05 15:18:00', 1, 1002001015, '账号未登陆', '2019-07-05 15:18:00');
INSERT INTO `access_log` VALUES (49333, '65.46.15623110797815697', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.248.13.142', '2019-07-05 15:18:00', 0, 1002001015, '账号未登陆', '2019-07-05 15:18:00');
INSERT INTO `access_log` VALUES (49334, '59.79.15623113603854071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:22:40', 3, 0, '', '2019-07-05 15:22:40');
INSERT INTO `access_log` VALUES (49335, '59.80.15623113603874053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:22:40', 13, 2001001000, '服务端发生异常', '2019-07-05 15:22:40');
INSERT INTO `access_log` VALUES (49336, '59.76.15623113645584061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:22:45', 2, 0, '', '2019-07-05 15:22:45');
INSERT INTO `access_log` VALUES (49337, '59.73.15623113645594073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:22:45', 10, 2001001000, '服务端发生异常', '2019-07-05 15:22:45');
INSERT INTO `access_log` VALUES (49338, '64.78.15623113681184215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:22:48', 12, 0, '', '2019-07-05 15:22:48');
INSERT INTO `access_log` VALUES (49339, '64.76.15623113683194201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:22:48', 3, 0, '', '2019-07-05 15:22:48');
INSERT INTO `access_log` VALUES (49340, '59.75.15623113698454079', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:22:50', 2, 0, '', '2019-07-05 15:22:50');
INSERT INTO `access_log` VALUES (49341, '59.71.15623113698464071', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:22:50', 13, 2001001000, '服务端发生异常', '2019-07-05 15:22:50');
INSERT INTO `access_log` VALUES (49342, '64.83.15623113731814209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:22:53', 2, 0, '', '2019-07-05 15:22:53');
INSERT INTO `access_log` VALUES (49343, '64.82.15623113732984221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:22:53', 1, 0, '', '2019-07-05 15:22:53');
INSERT INTO `access_log` VALUES (49344, '64.81.15623113742804197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:22:54', 2, 0, '', '2019-07-05 15:22:54');
INSERT INTO `access_log` VALUES (49345, '64.80.15623113749254215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:22:55', 3, 0, '', '2019-07-05 15:22:55');
INSERT INTO `access_log` VALUES (49346, '66.49.15623113888832167', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18058448853&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:09', 16, 1001003000, '验证码不存在', '2019-07-05 15:23:09');
INSERT INTO `access_log` VALUES (49347, '66.48.15623113908872167', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18058448853', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:11', 119, 0, '', '2019-07-05 15:23:11');
INSERT INTO `access_log` VALUES (49348, '66.56.15623113929162163', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18058448853&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:13', 184, 0, '', '2019-07-05 15:23:13');
INSERT INTO `access_log` VALUES (49349, '64.85.15623113986704219', 157, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:19', 9, 0, '', '2019-07-05 15:23:19');
INSERT INTO `access_log` VALUES (49350, '64.76.15623113987884203', 157, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:19', 9, 0, '', '2019-07-05 15:23:19');
INSERT INTO `access_log` VALUES (49351, '66.50.15623114004482149', 157, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:20', 6, 0, '', '2019-07-05 15:23:20');
INSERT INTO `access_log` VALUES (49352, '59.80.15623114041254055', 157, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:24', 110, 0, '', '2019-07-05 15:23:24');
INSERT INTO `access_log` VALUES (49353, '59.76.15623114053464063', 157, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:25', 6, 0, '', '2019-07-05 15:23:25');
INSERT INTO `access_log` VALUES (49354, '59.77.15623114060674061', 157, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:26', 6, 0, '', '2019-07-05 15:23:26');
INSERT INTO `access_log` VALUES (49355, '66.57.15623114073642151', 157, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:27', 5, 0, '', '2019-07-05 15:23:27');
INSERT INTO `access_log` VALUES (49356, '59.74.15623114088584073', 157, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:29', 5, 0, '', '2019-07-05 15:23:29');
INSERT INTO `access_log` VALUES (49357, '59.78.15623114088584067', 157, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:29', 16, 2001001000, '服务端发生异常', '2019-07-05 15:23:29');
INSERT INTO `access_log` VALUES (49358, '65.50.15623114296845673', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:50', 1, 1002001015, '账号未登陆', '2019-07-05 15:23:50');
INSERT INTO `access_log` VALUES (49359, '65.51.15623114296845695', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:50', 1, 1002001015, '账号未登陆', '2019-07-05 15:23:50');
INSERT INTO `access_log` VALUES (49360, '65.52.15623114296915685', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:23:50', 0, 1002001015, '账号未登陆', '2019-07-05 15:23:50');
INSERT INTO `access_log` VALUES (49361, '65.3607.15623114398137449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:24:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 15:24:00');
INSERT INTO `access_log` VALUES (49362, '65.46.15623114498695703', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:24:10', 77, 0, '', '2019-07-05 15:24:10');
INSERT INTO `access_log` VALUES (49363, '65.49.15623114501885647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:24:10', 9, 0, '', '2019-07-05 15:24:10');
INSERT INTO `access_log` VALUES (49364, '65.53.15623114501915655', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:24:10', 10, 2001001000, '服务端发生异常', '2019-07-05 15:24:10');
INSERT INTO `access_log` VALUES (49365, '65.47.15623114501945627', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:24:10', 8, 0, '', '2019-07-05 15:24:10');
INSERT INTO `access_log` VALUES (49366, '65.50.15623114821595675', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:24:42', 9, 0, '', '2019-07-05 15:24:42');
INSERT INTO `access_log` VALUES (49367, '65.54.15623114821625611', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:24:42', 9, 2001001000, '服务端发生异常', '2019-07-05 15:24:42');
INSERT INTO `access_log` VALUES (49368, '65.3607.15623114821647451', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.74.30.82', '2019-07-05 15:24:42', 8, 0, '', '2019-07-05 15:24:42');
INSERT INTO `access_log` VALUES (49369, '65.53.15623121229305665', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 15:35:23', 5, 0, '', '2019-07-05 15:35:23');
INSERT INTO `access_log` VALUES (49370, '65.52.15623121434495697', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 15:35:43', 4, 0, '', '2019-07-05 15:35:43');
INSERT INTO `access_log` VALUES (49371, '64.78.15623124170424231', 0, 2, 'product-application', '/product-api/admins/spu/add', 'name=aaaaa&sellPoint=a&cid=796&picUrls=http://static.shop.iocoder.cn/c1f5ca56-62eb-4fa1-adea-f1d7d64e6904&skuStr=[{\"attrs\":[3],\"price\":100,\"quantity\":1}]&description=<p>sss</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 15:40:17', 7, 1002001012, '访问令牌已过期', '2019-07-05 15:40:17');
INSERT INTO `access_log` VALUES (49372, '65.52.15623124292455701', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 15:40:29', 81, 0, '', '2019-07-05 15:40:29');
INSERT INTO `access_log` VALUES (49373, '65.51.15623124295345711', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 15:40:30', 88, 0, '', '2019-07-05 15:40:30');
INSERT INTO `access_log` VALUES (49374, '65.54.15623124295395625', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 15:40:30', 87, 0, '', '2019-07-05 15:40:30');
INSERT INTO `access_log` VALUES (49375, '65.50.15623124295365689', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 15:40:30', 89, 0, '', '2019-07-05 15:40:30');
INSERT INTO `access_log` VALUES (49376, '64.83.15623124316874225', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 15:40:32', 13, 0, '', '2019-07-05 15:40:32');
INSERT INTO `access_log` VALUES (49377, '64.84.15623124316864219', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 15:40:32', 16, 0, '', '2019-07-05 15:40:32');
INSERT INTO `access_log` VALUES (49378, '66.50.15623124322382165', 0, 2, 'user-application', '/user-api/admins/user/page', 'pageSize=10&nickname=小王&pageNo=1&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '60.191.76.226', '2019-07-05 15:40:32', 0, 1002001015, '账号未登陆', '2019-07-05 15:40:32');
INSERT INTO `access_log` VALUES (49379, '65.45.15623124450575653', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 15:40:45', 2, 0, '', '2019-07-05 15:40:45');
INSERT INTO `access_log` VALUES (49380, '64.80.15623124514164231', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=a', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 15:40:51', 96, 0, '', '2019-07-05 15:40:52');
INSERT INTO `access_log` VALUES (49381, '64.77.15623124516504209', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 15:40:52', 11, 0, '', '2019-07-05 15:40:52');
INSERT INTO `access_log` VALUES (49382, '64.79.15623124618034229', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=aaaa&sellPoint=a&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/c7f1a2c8-4015-4c28-bc64-a92ad72fbe12&skuStr=[{\"attrs\":[46],\"price\":1100,\"quantity\":1111},{\"attrs\":[4],\"price\":1100,\"quantity\":111}]&description=<p>111111111111111111111111</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 15:41:02', 298, 2001001000, '服务端发生异常', '2019-07-05 15:41:02');
INSERT INTO `access_log` VALUES (49383, '66.48.15623127522842185', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '60.191.76.226', '2019-07-05 15:45:52', 0, 1002001015, '账号未登陆', '2019-07-05 15:45:52');
INSERT INTO `access_log` VALUES (49384, '66.56.15623127536552185', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '60.191.76.226', '2019-07-05 15:45:54', 0, 1002001015, '账号未登陆', '2019-07-05 15:45:54');
INSERT INTO `access_log` VALUES (49385, '66.52.15623127548642167', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '60.191.76.226', '2019-07-05 15:45:55', 1, 1002001015, '账号未登陆', '2019-07-05 15:45:55');
INSERT INTO `access_log` VALUES (49386, '66.50.15623127555242171', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '60.191.76.226', '2019-07-05 15:45:56', 1, 1002001015, '账号未登陆', '2019-07-05 15:45:56');
INSERT INTO `access_log` VALUES (49387, '66.54.15623127561742177', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '60.191.76.226', '2019-07-05 15:45:56', 1, 1002001015, '账号未登陆', '2019-07-05 15:45:56');
INSERT INTO `access_log` VALUES (49388, '66.57.15623127573062171', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '60.191.76.226', '2019-07-05 15:45:57', 1, 1002001015, '账号未登陆', '2019-07-05 15:45:57');
INSERT INTO `access_log` VALUES (49389, '59.71.15623128422204093', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:47:22', 3, 0, '', '2019-07-05 15:47:22');
INSERT INTO `access_log` VALUES (49390, '59.75.15623128422194101', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:47:22', 12, 2001001000, '服务端发生异常', '2019-07-05 15:47:22');
INSERT INTO `access_log` VALUES (49391, '59.78.15623128538964087', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:47:34', 7, 0, '', '2019-07-05 15:47:34');
INSERT INTO `access_log` VALUES (49392, '59.74.15623128538964093', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:47:34', 13, 2001001000, '服务端发生异常', '2019-07-05 15:47:34');
INSERT INTO `access_log` VALUES (49393, '59.79.15623128643884095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:47:44', 3, 0, '', '2019-07-05 15:47:44');
INSERT INTO `access_log` VALUES (49394, '59.80.15623128643884077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:47:44', 13, 2001001000, '服务端发生异常', '2019-07-05 15:47:44');
INSERT INTO `access_log` VALUES (49395, '64.76.15623128727684225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:47:53', 3, 0, '', '2019-07-05 15:47:53');
INSERT INTO `access_log` VALUES (49396, '64.84.15623128729594225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:47:53', 2, 0, '', '2019-07-05 15:47:53');
INSERT INTO `access_log` VALUES (49397, '64.83.15623128745274231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:47:55', 2, 0, '', '2019-07-05 15:47:55');
INSERT INTO `access_log` VALUES (49398, '64.81.15623128754084221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:47:55', 2, 0, '', '2019-07-05 15:47:55');
INSERT INTO `access_log` VALUES (49399, '64.82.15623128763674245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:47:56', 2, 0, '', '2019-07-05 15:47:56');
INSERT INTO `access_log` VALUES (49400, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:47:58', 15, 0, '', '2019-07-05 15:47:58');
INSERT INTO `access_log` VALUES (49401, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:47:58', 15, 0, '', '2019-07-05 15:47:58');
INSERT INTO `access_log` VALUES (49402, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:48:00', 6, 0, '', '2019-07-05 15:48:00');
INSERT INTO `access_log` VALUES (49403, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:48:00', 10, 0, '', '2019-07-05 15:48:00');
INSERT INTO `access_log` VALUES (49404, '64.80.15623128897284239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:48:10', 2, 0, '', '2019-07-05 15:48:10');
INSERT INTO `access_log` VALUES (49405, '64.77.15623128898884217', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:48:10', 2, 0, '', '2019-07-05 15:48:10');
INSERT INTO `access_log` VALUES (49406, '64.85.15623128964684243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:48:16', 2, 0, '', '2019-07-05 15:48:16');
INSERT INTO `access_log` VALUES (49407, '64.78.15623128974874241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:48:17', 2, 0, '', '2019-07-05 15:48:17');
INSERT INTO `access_log` VALUES (49408, '64.76.15623128983194227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:48:18', 2, 0, '', '2019-07-05 15:48:18');
INSERT INTO `access_log` VALUES (49409, '59.71.15623129047474095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:48:25', 2, 0, '', '2019-07-05 15:48:25');
INSERT INTO `access_log` VALUES (49410, '59.75.15623129047484103', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:48:25', 12, 2001001000, '服务端发生异常', '2019-07-05 15:48:25');
INSERT INTO `access_log` VALUES (49411, '59.78.15623129113074089', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:48:31', 2, 0, '', '2019-07-05 15:48:31');
INSERT INTO `access_log` VALUES (49412, '59.74.15623129113074095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '43.250.200.74', '2019-07-05 15:48:31', 9, 2001001000, '服务端发生异常', '2019-07-05 15:48:31');
INSERT INTO `access_log` VALUES (49413, '59.74.15623130455514097', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.110.235.71', '2019-07-05 15:50:46', 3, 0, '', '2019-07-05 15:50:46');
INSERT INTO `access_log` VALUES (49414, '59.72.15623130455604097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.110.235.71', '2019-07-05 15:50:46', 12, 2001001000, '服务端发生异常', '2019-07-05 15:50:46');
INSERT INTO `access_log` VALUES (49415, '64.84.15623130480634229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.110.235.71', '2019-07-05 15:50:48', 3, 0, '', '2019-07-05 15:50:48');
INSERT INTO `access_log` VALUES (49416, '64.83.15623130481874235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.110.235.71', '2019-07-05 15:50:48', 2, 0, '', '2019-07-05 15:50:48');
INSERT INTO `access_log` VALUES (49417, '64.81.15623130492194225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.110.235.71', '2019-07-05 15:50:49', 2, 0, '', '2019-07-05 15:50:49');
INSERT INTO `access_log` VALUES (49418, '64.82.15623130496734249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.110.235.71', '2019-07-05 15:50:50', 2, 0, '', '2019-07-05 15:50:50');
INSERT INTO `access_log` VALUES (49419, '59.76.15623130504784089', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.110.235.71', '2019-07-05 15:50:50', 3, 0, '', '2019-07-05 15:50:50');
INSERT INTO `access_log` VALUES (49420, '59.80.15623130504784081', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.110.235.71', '2019-07-05 15:50:50', 20, 2001001000, '服务端发生异常', '2019-07-05 15:50:50');
INSERT INTO `access_log` VALUES (49421, '65.49.15623130773115671', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.110.235.71', '2019-07-05 15:51:17', 0, 1002001015, '账号未登陆', '2019-07-05 15:51:17');
INSERT INTO `access_log` VALUES (49422, '65.47.15623130773115651', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.110.235.71', '2019-07-05 15:51:17', 0, 1002001015, '账号未登陆', '2019-07-05 15:51:17');
INSERT INTO `access_log` VALUES (49423, '65.52.15623130773155711', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.110.235.71', '2019-07-05 15:51:17', 0, 1002001015, '账号未登陆', '2019-07-05 15:51:17');
INSERT INTO `access_log` VALUES (49424, '59.78.15623132726694095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:54:33', 3, 0, '', '2019-07-05 15:54:33');
INSERT INTO `access_log` VALUES (49425, '59.74.15623132726744101', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:54:33', 18, 2001001000, '服务端发生异常', '2019-07-05 15:54:33');
INSERT INTO `access_log` VALUES (49426, '65.45.15623132896495665', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:54:50', 0, 1002001015, '账号未登陆', '2019-07-05 15:54:50');
INSERT INTO `access_log` VALUES (49427, '65.46.15623132896515731', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:54:50', 0, 1002001015, '账号未登陆', '2019-07-05 15:54:50');
INSERT INTO `access_log` VALUES (49428, '65.53.15623132896565683', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:54:50', 0, 1002001015, '账号未登陆', '2019-07-05 15:54:50');
INSERT INTO `access_log` VALUES (49429, '65.47.15623132922025655', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:54:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 15:54:52');
INSERT INTO `access_log` VALUES (49430, '65.52.15623132970165715', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:54:57', 85, 0, '', '2019-07-05 15:54:57');
INSERT INTO `access_log` VALUES (49431, '65.50.15623132973265703', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:54:57', 9, 0, '', '2019-07-05 15:54:57');
INSERT INTO `access_log` VALUES (49432, '65.51.15623132973295725', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:54:57', 10, 2001001000, '服务端发生异常', '2019-07-05 15:54:57');
INSERT INTO `access_log` VALUES (49433, '65.54.15623132973385639', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:54:57', 8, 0, '', '2019-07-05 15:54:57');
INSERT INTO `access_log` VALUES (49434, '65.3607.15623133056797479', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:55:06', 57, 0, '', '2019-07-05 15:55:06');
INSERT INTO `access_log` VALUES (49435, '65.46.15623133056815733', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:55:06', 55, 0, '', '2019-07-05 15:55:06');
INSERT INTO `access_log` VALUES (49436, '65.45.15623133056815667', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:55:06', 57, 2001001000, '服务端发生异常', '2019-07-05 15:55:06');
INSERT INTO `access_log` VALUES (49437, '65.50.15623133397005705', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:55:40', 8, 0, '', '2019-07-05 15:55:40');
INSERT INTO `access_log` VALUES (49438, '65.52.15623133396995717', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:55:40', 10, 2001001000, '服务端发生异常', '2019-07-05 15:55:40');
INSERT INTO `access_log` VALUES (49439, '65.51.15623133397285727', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.236.84.95', '2019-07-05 15:55:40', 9, 0, '', '2019-07-05 15:55:40');
INSERT INTO `access_log` VALUES (49440, '59.77.15623148348104111', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.18.127.12', '2019-07-05 16:20:35', 2, 0, '', '2019-07-05 16:20:35');
INSERT INTO `access_log` VALUES (49441, '59.71.15623148348184123', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.18.127.12', '2019-07-05 16:20:35', 12, 2001001000, '服务端发生异常', '2019-07-05 16:20:35');
INSERT INTO `access_log` VALUES (49442, '64.79.15623148471204265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.18.127.12', '2019-07-05 16:20:47', 3, 0, '', '2019-07-05 16:20:47');
INSERT INTO `access_log` VALUES (49443, '64.80.15623148474614267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.18.127.12', '2019-07-05 16:20:47', 2, 0, '', '2019-07-05 16:20:47');
INSERT INTO `access_log` VALUES (49444, '59.74.15623148502024123', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.18.127.12', '2019-07-05 16:20:50', 2, 0, '', '2019-07-05 16:20:50');
INSERT INTO `access_log` VALUES (49445, '59.78.15623148502024117', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.18.127.12', '2019-07-05 16:20:50', 11, 2001001000, '服务端发生异常', '2019-07-05 16:20:50');
INSERT INTO `access_log` VALUES (49446, '59.74.15623178274434163', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.48.47.228', '2019-07-05 17:10:27', 11, 0, '', '2019-07-05 17:10:27');
INSERT INTO `access_log` VALUES (49447, '59.78.15623178274464157', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.48.47.228', '2019-07-05 17:10:27', 16, 2001001000, '服务端发生异常', '2019-07-05 17:10:27');
INSERT INTO `access_log` VALUES (49448, '59.74.15623179403394165', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.48.47.228', '2019-07-05 17:12:20', 2, 0, '', '2019-07-05 17:12:20');
INSERT INTO `access_log` VALUES (49449, '59.78.15623179403434159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.48.47.228', '2019-07-05 17:12:20', 13, 2001001000, '服务端发生异常', '2019-07-05 17:12:20');
INSERT INTO `access_log` VALUES (49450, '59.79.15623179584654167', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:38', 3, 0, '', '2019-07-05 17:12:38');
INSERT INTO `access_log` VALUES (49451, '59.76.15623179584654157', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:38', 17, 2001001000, '服务端发生异常', '2019-07-05 17:12:38');
INSERT INTO `access_log` VALUES (49452, '64.79.15623179610964307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:41', 9, 0, '', '2019-07-05 17:12:41');
INSERT INTO `access_log` VALUES (49453, '64.80.15623179612144309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:41', 3, 0, '', '2019-07-05 17:12:41');
INSERT INTO `access_log` VALUES (49454, '64.77.15623179642234287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:44', 2, 0, '', '2019-07-05 17:12:44');
INSERT INTO `access_log` VALUES (49455, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:44', 9, 0, '', '2019-07-05 17:12:44');
INSERT INTO `access_log` VALUES (49456, '64.85.15623179660704313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:46', 2, 0, '', '2019-07-05 17:12:46');
INSERT INTO `access_log` VALUES (49457, '64.78.15623179662494311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:46', 2, 0, '', '2019-07-05 17:12:46');
INSERT INTO `access_log` VALUES (49458, '59.80.15623179669124149', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:47', 3, 0, '', '2019-07-05 17:12:47');
INSERT INTO `access_log` VALUES (49459, '59.73.15623179669134169', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:47', 12, 2001001000, '服务端发生异常', '2019-07-05 17:12:47');
INSERT INTO `access_log` VALUES (49460, '64.76.15623179683644297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:48', 2, 0, '', '2019-07-05 17:12:48');
INSERT INTO `access_log` VALUES (49461, '64.84.15623179686754297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:49', 2, 0, '', '2019-07-05 17:12:49');
INSERT INTO `access_log` VALUES (49462, '59.71.15623179695224167', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:50', 3, 0, '', '2019-07-05 17:12:50');
INSERT INTO `access_log` VALUES (49463, '59.75.15623179695224175', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:50', 12, 2001001000, '服务端发生异常', '2019-07-05 17:12:50');
INSERT INTO `access_log` VALUES (49464, '59.74.15623179728754167', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:53', 3, 0, '', '2019-07-05 17:12:53');
INSERT INTO `access_log` VALUES (49465, '59.78.15623179728924161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:53', 13, 2001001000, '服务端发生异常', '2019-07-05 17:12:53');
INSERT INTO `access_log` VALUES (49466, '64.81.15623179748874293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:55', 2, 0, '', '2019-07-05 17:12:55');
INSERT INTO `access_log` VALUES (49467, '64.82.15623179750164317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:55', 1, 0, '', '2019-07-05 17:12:55');
INSERT INTO `access_log` VALUES (49468, '59.72.15623179755384167', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:56', 8, 0, '', '2019-07-05 17:12:56');
INSERT INTO `access_log` VALUES (49469, '59.79.15623179755384169', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:12:56', 18, 2001001000, '服务端发生异常', '2019-07-05 17:12:56');
INSERT INTO `access_log` VALUES (49470, '59.80.15623179869864151', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:07', 2, 0, '', '2019-07-05 17:13:07');
INSERT INTO `access_log` VALUES (49471, '59.73.15623179869874171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:07', 12, 2001001000, '服务端发生异常', '2019-07-05 17:13:07');
INSERT INTO `access_log` VALUES (49472, '64.80.15623179883914311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:08', 2, 0, '', '2019-07-05 17:13:08');
INSERT INTO `access_log` VALUES (49473, '64.77.15623179885264289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:09', 2, 0, '', '2019-07-05 17:13:09');
INSERT INTO `access_log` VALUES (49474, '64.85.15623179895934315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:10', 2, 0, '', '2019-07-05 17:13:10');
INSERT INTO `access_log` VALUES (49475, '64.78.15623179903524313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:10', 1, 0, '', '2019-07-05 17:13:10');
INSERT INTO `access_log` VALUES (49476, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:12', 6, 0, '', '2019-07-05 17:13:12');
INSERT INTO `access_log` VALUES (49477, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:12', 17, 0, '', '2019-07-05 17:13:12');
INSERT INTO `access_log` VALUES (49478, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:14', 6, 0, '', '2019-07-05 17:13:14');
INSERT INTO `access_log` VALUES (49479, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:14', 8, 0, '', '2019-07-05 17:13:14');
INSERT INTO `access_log` VALUES (49480, '64.76.15623179954154299', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:15', 8, 0, '', '2019-07-05 17:13:15');
INSERT INTO `access_log` VALUES (49481, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:19', 7, 0, '', '2019-07-05 17:13:19');
INSERT INTO `access_log` VALUES (49482, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:19', 10, 0, '', '2019-07-05 17:13:19');
INSERT INTO `access_log` VALUES (49483, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:20', 4, 0, '', '2019-07-05 17:13:20');
INSERT INTO `access_log` VALUES (49484, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:21', 9, 0, '', '2019-07-05 17:13:21');
INSERT INTO `access_log` VALUES (49485, '59.71.15623180045314169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:25', 3, 0, '', '2019-07-05 17:13:25');
INSERT INTO `access_log` VALUES (49486, '59.75.15623180045324177', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '183.48.47.228', '2019-07-05 17:13:25', 13, 2001001000, '服务端发生异常', '2019-07-05 17:13:25');
INSERT INTO `access_log` VALUES (49487, '59.78.15623181514764165', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.48.47.228', '2019-07-05 17:15:51', 3, 0, '', '2019-07-05 17:15:51');
INSERT INTO `access_log` VALUES (49488, '59.74.15623181514774171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.48.47.228', '2019-07-05 17:15:51', 11, 2001001000, '服务端发生异常', '2019-07-05 17:15:51');
INSERT INTO `access_log` VALUES (49489, '59.79.15623181545354173', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.48.47.228', '2019-07-05 17:15:55', 2, 0, '', '2019-07-05 17:15:55');
INSERT INTO `access_log` VALUES (49490, '59.72.15623181545374171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.48.47.228', '2019-07-05 17:15:55', 10, 2001001000, '服务端发生异常', '2019-07-05 17:15:55');
INSERT INTO `access_log` VALUES (49491, '59.77.15623188074674169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '203.90.248.122', '2019-07-05 17:26:47', 5, 0, '', '2019-07-05 17:26:47');
INSERT INTO `access_log` VALUES (49492, '59.71.15623188074674181', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '203.90.248.122', '2019-07-05 17:26:47', 20, 2001001000, '服务端发生异常', '2019-07-05 17:26:47');
INSERT INTO `access_log` VALUES (49493, '59.78.15623188245144175', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '203.90.248.122', '2019-07-05 17:27:05', 10, 0, '', '2019-07-05 17:27:05');
INSERT INTO `access_log` VALUES (49494, '59.79.15623188245164183', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '203.90.248.122', '2019-07-05 17:27:05', 12, 2001001000, '服务端发生异常', '2019-07-05 17:27:05');
INSERT INTO `access_log` VALUES (49495, '65.45.15623193859595749', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '123.157.153.130', '2019-07-05 17:36:26', 1, 1002001015, '账号未登陆', '2019-07-05 17:36:26');
INSERT INTO `access_log` VALUES (49496, '65.53.15623193859595767', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '123.157.153.130', '2019-07-05 17:36:26', 1, 1002001015, '账号未登陆', '2019-07-05 17:36:26');
INSERT INTO `access_log` VALUES (49497, '65.47.15623193859755739', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '123.157.153.130', '2019-07-05 17:36:26', 0, 1002001015, '账号未登陆', '2019-07-05 17:36:26');
INSERT INTO `access_log` VALUES (49498, '65.49.15623193883055759', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '123.157.153.130', '2019-07-05 17:36:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 17:36:28');
INSERT INTO `access_log` VALUES (49499, '65.52.15623194043505799', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '123.157.153.130', '2019-07-05 17:36:44', 72, 0, '', '2019-07-05 17:36:44');
INSERT INTO `access_log` VALUES (49500, '65.51.15623194049905809', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '123.157.153.130', '2019-07-05 17:36:45', 10, 0, '', '2019-07-05 17:36:45');
INSERT INTO `access_log` VALUES (49501, '65.54.15623194049955723', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '123.157.153.130', '2019-07-05 17:36:45', 13, 2001001000, '服务端发生异常', '2019-07-05 17:36:45');
INSERT INTO `access_log` VALUES (49502, '65.46.15623194050005817', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '123.157.153.130', '2019-07-05 17:36:45', 12, 0, '', '2019-07-05 17:36:45');
INSERT INTO `access_log` VALUES (49503, '65.45.15623194309555751', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '123.157.153.130', '2019-07-05 17:37:11', 10, 0, '', '2019-07-05 17:37:11');
INSERT INTO `access_log` VALUES (49504, '65.47.15623194309605741', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '123.157.153.130', '2019-07-05 17:37:11', 12, 2001001000, '服务端发生异常', '2019-07-05 17:37:11');
INSERT INTO `access_log` VALUES (49505, '65.49.15623194309655761', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '123.157.153.130', '2019-07-05 17:37:11', 10, 0, '', '2019-07-05 17:37:11');
INSERT INTO `access_log` VALUES (49506, '65.51.15623200836125819', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:48:04', 0, 1002001015, '账号未登陆', '2019-07-05 17:48:04');
INSERT INTO `access_log` VALUES (49507, '65.54.15623200836185733', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:48:04', 1, 1002001015, '账号未登陆', '2019-07-05 17:48:04');
INSERT INTO `access_log` VALUES (49508, '65.3607.15623200836207573', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:48:04', 0, 1002001015, '账号未登陆', '2019-07-05 17:48:04');
INSERT INTO `access_log` VALUES (49509, '65.53.15623200870025779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:48:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 17:48:07');
INSERT INTO `access_log` VALUES (49510, '65.45.15623200894425761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:48:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 17:48:09');
INSERT INTO `access_log` VALUES (49511, '65.47.15623200950145751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:48:15', 88, 0, '', '2019-07-05 17:48:15');
INSERT INTO `access_log` VALUES (49512, '65.50.15623200955975799', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:48:16', 10, 0, '', '2019-07-05 17:48:16');
INSERT INTO `access_log` VALUES (49513, '65.52.15623200956015811', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:48:16', 16, 2001001000, '服务端发生异常', '2019-07-05 17:48:16');
INSERT INTO `access_log` VALUES (49514, '65.46.15623200956185829', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:48:16', 9, 0, '', '2019-07-05 17:48:16');
INSERT INTO `access_log` VALUES (49515, '65.46.15623201784215831', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:49:38', 9, 0, '', '2019-07-05 17:49:38');
INSERT INTO `access_log` VALUES (49516, '65.45.15623201784205763', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:49:38', 9, 0, '', '2019-07-05 17:49:38');
INSERT INTO `access_log` VALUES (49517, '65.47.15623201784205753', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:49:38', 10, 2001001000, '服务端发生异常', '2019-07-05 17:49:38');
INSERT INTO `access_log` VALUES (49518, '65.52.15623201919385813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:49:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 17:49:52');
INSERT INTO `access_log` VALUES (49519, '65.51.15623201951775823', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:49:55', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 17:49:55');
INSERT INTO `access_log` VALUES (49520, '65.3607.15623201967977577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:49:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 17:49:57');
INSERT INTO `access_log` VALUES (49521, '65.53.15623202037575783', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:50:04', 104, 0, '', '2019-07-05 17:50:04');
INSERT INTO `access_log` VALUES (49522, '65.49.15623202041895775', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:50:04', 8, 0, '', '2019-07-05 17:50:04');
INSERT INTO `access_log` VALUES (49523, '65.45.15623202041975765', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:50:04', 9, 0, '', '2019-07-05 17:50:04');
INSERT INTO `access_log` VALUES (49524, '65.47.15623202041965755', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '43.242.180.26', '2019-07-05 17:50:04', 10, 2001001000, '服务端发生异常', '2019-07-05 17:50:04');
INSERT INTO `access_log` VALUES (49525, '59.79.15623218032794223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:16:43', 11, 0, '', '2019-07-05 18:16:43');
INSERT INTO `access_log` VALUES (49526, '59.78.15623218032904215', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:16:43', 28, 2001001000, '服务端发生异常', '2019-07-05 18:16:43');
INSERT INTO `access_log` VALUES (49527, '64.79.15623218067904361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:16:47', 11, 0, '', '2019-07-05 18:16:47');
INSERT INTO `access_log` VALUES (49528, '64.80.15623218071804363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:16:47', 2, 0, '', '2019-07-05 18:16:47');
INSERT INTO `access_log` VALUES (49529, '64.77.15623218080704341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:16:48', 2, 0, '', '2019-07-05 18:16:48');
INSERT INTO `access_log` VALUES (49530, '64.85.15623218084804367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:16:48', 2, 0, '', '2019-07-05 18:16:48');
INSERT INTO `access_log` VALUES (49531, '64.78.15623218087894365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:16:49', 2, 0, '', '2019-07-05 18:16:49');
INSERT INTO `access_log` VALUES (49532, '59.76.15623218120604213', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:16:52', 3, 0, '', '2019-07-05 18:16:52');
INSERT INTO `access_log` VALUES (49533, '59.80.15623218120614205', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:16:52', 21, 2001001000, '服务端发生异常', '2019-07-05 18:16:52');
INSERT INTO `access_log` VALUES (49534, '65.49.15623218236435797', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:17:04', 0, 1002001015, '账号未登陆', '2019-07-05 18:17:04');
INSERT INTO `access_log` VALUES (49535, '65.45.15623218236435787', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:17:04', 0, 1002001015, '账号未登陆', '2019-07-05 18:17:04');
INSERT INTO `access_log` VALUES (49536, '65.47.15623218236455777', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:17:04', 0, 1002001015, '账号未登陆', '2019-07-05 18:17:04');
INSERT INTO `access_log` VALUES (49537, '65.54.15623218419125763', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:17:22', 90, 0, '', '2019-07-05 18:17:22');
INSERT INTO `access_log` VALUES (49538, '65.51.15623218423435849', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:17:22', 8, 0, '', '2019-07-05 18:17:22');
INSERT INTO `access_log` VALUES (49539, '65.46.15623218423425857', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:17:22', 9, 0, '', '2019-07-05 18:17:22');
INSERT INTO `access_log` VALUES (49540, '65.52.15623218423425837', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '223.104.21.224', '2019-07-05 18:17:22', 12, 2001001000, '服务端发生异常', '2019-07-05 18:17:22');
INSERT INTO `access_log` VALUES (49541, '64.82.15623218668414371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '183.192.164.85', '2019-07-05 18:17:47', 2, 0, '', '2019-07-05 18:17:47');
INSERT INTO `access_log` VALUES (49542, '64.80.15623218752254365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '183.192.164.56', '2019-07-05 18:17:55', 2, 0, '', '2019-07-05 18:17:55');
INSERT INTO `access_log` VALUES (49543, '64.77.15623218773664343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '183.192.164.71', '2019-07-05 18:17:57', 1, 0, '', '2019-07-05 18:17:57');
INSERT INTO `access_log` VALUES (49544, '65.47.15623218860265779', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '120.204.17.71', '2019-07-05 18:18:06', 0, 1002001015, '账号未登陆', '2019-07-05 18:18:06');
INSERT INTO `access_log` VALUES (49545, '65.45.15623218868435789', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '183.192.164.85', '2019-07-05 18:18:07', 1, 1002001015, '账号未登陆', '2019-07-05 18:18:07');
INSERT INTO `access_log` VALUES (49546, '59.79.15623218875164225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '183.192.164.71', '2019-07-05 18:18:08', 23, 2001001000, '服务端发生异常', '2019-07-05 18:18:08');
INSERT INTO `access_log` VALUES (49547, '65.53.15623219683875809', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '183.192.164.214', '2019-07-05 18:19:28', 0, 1002001015, '账号未登陆', '2019-07-05 18:19:28');
INSERT INTO `access_log` VALUES (49548, '65.46.15623231203325875', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:38:40', 1, 1002001015, '账号未登陆', '2019-07-05 18:38:40');
INSERT INTO `access_log` VALUES (49549, '65.3607.15623231203347619', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:38:40', 0, 1002001015, '账号未登陆', '2019-07-05 18:38:40');
INSERT INTO `access_log` VALUES (49550, '65.53.15623231203355825', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:38:40', 1, 1002001015, '账号未登陆', '2019-07-05 18:38:40');
INSERT INTO `access_log` VALUES (49551, '65.49.15623231253245817', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:38:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 18:38:45');
INSERT INTO `access_log` VALUES (49552, '65.47.15623231298835797', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:38:50', 243, 0, '', '2019-07-05 18:38:50');
INSERT INTO `access_log` VALUES (49553, '65.45.15623231307645807', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:38:51', 9, 0, '', '2019-07-05 18:38:51');
INSERT INTO `access_log` VALUES (49554, '65.54.15623231307665783', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:38:51', 8, 0, '', '2019-07-05 18:38:51');
INSERT INTO `access_log` VALUES (49555, '65.50.15623231307655847', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:38:51', 10, 0, '', '2019-07-05 18:38:51');
INSERT INTO `access_log` VALUES (49556, '62.86.15623231404643565', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:39:00', 22, 0, '', '2019-07-05 18:39:00');
INSERT INTO `access_log` VALUES (49557, '66.51.15623231455712333', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:39:06', 22, 0, '', '2019-07-05 18:39:06');
INSERT INTO `access_log` VALUES (49558, '59.73.15623231490234243', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:39:09', 17, 0, '', '2019-07-05 18:39:09');
INSERT INTO `access_log` VALUES (49559, '65.3607.15623231554317621', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:39:15', 32, 0, '', '2019-07-05 18:39:15');
INSERT INTO `access_log` VALUES (49560, '65.46.15623231580455877', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:39:18', 14, 0, '', '2019-07-05 18:39:18');
INSERT INTO `access_log` VALUES (49561, '65.49.15623231719335819', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:39:32', 18, 0, '', '2019-07-05 18:39:32');
INSERT INTO `access_log` VALUES (49562, '59.71.15623231735734241', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:39:34', 11, 0, '', '2019-07-05 18:39:34');
INSERT INTO `access_log` VALUES (49563, '66.56.15623231742842325', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:39:34', 12, 0, '', '2019-07-05 18:39:34');
INSERT INTO `access_log` VALUES (49564, '65.46.15623232736755879', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:41:14', 23, 0, '', '2019-07-05 18:41:14');
INSERT INTO `access_log` VALUES (49565, '65.53.15623232820215829', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:41:22', 12, 0, '', '2019-07-05 18:41:22');
INSERT INTO `access_log` VALUES (49566, '62.83.15623235836793599', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:46:24', 14, 0, '', '2019-07-05 18:46:24');
INSERT INTO `access_log` VALUES (49567, '62.82.15623235857143583', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:46:26', 15, 0, '', '2019-07-05 18:46:26');
INSERT INTO `access_log` VALUES (49568, '59.71.15623235941584247', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:46:34', 12, 0, '', '2019-07-05 18:46:34');
INSERT INTO `access_log` VALUES (49569, '59.75.15623235967534255', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '223.104.21.247', '2019-07-05 18:46:37', 23, 2001001000, '服务端发生异常', '2019-07-05 18:46:37');
INSERT INTO `access_log` VALUES (49570, '59.76.15623254805284263', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:01', 10, 0, '', '2019-07-05 19:18:01');
INSERT INTO `access_log` VALUES (49571, '59.73.15623254805284275', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:01', 16, 2001001000, '服务端发生异常', '2019-07-05 19:18:01');
INSERT INTO `access_log` VALUES (49572, '64.85.15623254836394417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:04', 9, 0, '', '2019-07-05 19:18:04');
INSERT INTO `access_log` VALUES (49573, '64.78.15623254837774415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:04', 3, 0, '', '2019-07-05 19:18:04');
INSERT INTO `access_log` VALUES (49574, '64.76.15623254846634401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:05', 2, 0, '', '2019-07-05 19:18:05');
INSERT INTO `access_log` VALUES (49575, '64.84.15623254849934401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:05', 2, 0, '', '2019-07-05 19:18:05');
INSERT INTO `access_log` VALUES (49576, '64.83.15623254854074407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:05', 1, 0, '', '2019-07-05 19:18:05');
INSERT INTO `access_log` VALUES (49577, '64.82.15623254857694421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:06', 2, 0, '', '2019-07-05 19:18:06');
INSERT INTO `access_log` VALUES (49578, '59.71.15623254904034273', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:10', 3, 0, '', '2019-07-05 19:18:10');
INSERT INTO `access_log` VALUES (49579, '59.75.15623254904074281', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:10', 13, 2001001000, '服务端发生异常', '2019-07-05 19:18:10');
INSERT INTO `access_log` VALUES (49580, '65.49.15623255145245851', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:35', 0, 1002001015, '账号未登陆', '2019-07-05 19:18:35');
INSERT INTO `access_log` VALUES (49581, '65.53.15623255145245859', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:35', 0, 1002001015, '账号未登陆', '2019-07-05 19:18:35');
INSERT INTO `access_log` VALUES (49582, '65.47.15623255145255831', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:35', 1, 1002001015, '账号未登陆', '2019-07-05 19:18:35');
INSERT INTO `access_log` VALUES (49583, '65.50.15623255271415881', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:47', 91, 0, '', '2019-07-05 19:18:47');
INSERT INTO `access_log` VALUES (49584, '65.54.15623255275455817', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:48', 11, 0, '', '2019-07-05 19:18:48');
INSERT INTO `access_log` VALUES (49585, '65.51.15623255275495903', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:48', 10, 2001001000, '服务端发生异常', '2019-07-05 19:18:48');
INSERT INTO `access_log` VALUES (49586, '65.52.15623255275525891', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.66.2', '2019-07-05 19:18:48', 10, 0, '', '2019-07-05 19:18:48');
INSERT INTO `access_log` VALUES (49587, '65.3607.15623345191917775', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:48:39', 1, 1002001015, '账号未登陆', '2019-07-05 21:48:39');
INSERT INTO `access_log` VALUES (49588, '65.52.15623345191946011', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:48:39', 1, 1002001015, '账号未登陆', '2019-07-05 21:48:39');
INSERT INTO `access_log` VALUES (49589, '65.51.15623345191966023', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:48:39', 1, 1002001015, '账号未登陆', '2019-07-05 21:48:39');
INSERT INTO `access_log` VALUES (49590, '65.46.15623345230526033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:48:43', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 21:48:43');
INSERT INTO `access_log` VALUES (49591, '65.49.15623345303505973', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:48:50', 98, 0, '', '2019-07-05 21:48:50');
INSERT INTO `access_log` VALUES (49592, '65.47.15623345308125955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:48:51', 12, 0, '', '2019-07-05 21:48:51');
INSERT INTO `access_log` VALUES (49593, '65.45.15623345308205963', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:48:51', 11, 0, '', '2019-07-05 21:48:51');
INSERT INTO `access_log` VALUES (49594, '65.53.15623345308205983', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:48:51', 11, 2001001000, '服务端发生异常', '2019-07-05 21:48:51');
INSERT INTO `access_log` VALUES (49595, '65.52.15623345688226013', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:49:29', 11, 0, '', '2019-07-05 21:49:29');
INSERT INTO `access_log` VALUES (49596, '65.46.15623345688266035', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:49:29', 10, 0, '', '2019-07-05 21:49:29');
INSERT INTO `access_log` VALUES (49597, '65.3607.15623345688257777', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:49:29', 11, 2001001000, '服务端发生异常', '2019-07-05 21:49:29');
INSERT INTO `access_log` VALUES (49598, '65.49.15623345714805975', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:49:31', 8, 0, '', '2019-07-05 21:49:31');
INSERT INTO `access_log` VALUES (49599, '65.47.15623345714925957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:49:31', 10, 0, '', '2019-07-05 21:49:32');
INSERT INTO `access_log` VALUES (49600, '65.53.15623345714965985', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:49:31', 9, 2001001000, '服务端发生异常', '2019-07-05 21:49:32');
INSERT INTO `access_log` VALUES (49601, '65.45.15623345744625965', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:49:34', 9, 0, '', '2019-07-05 21:49:34');
INSERT INTO `access_log` VALUES (49602, '65.50.15623345744636007', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:49:34', 11, 2001001000, '服务端发生异常', '2019-07-05 21:49:34');
INSERT INTO `access_log` VALUES (49603, '65.54.15623345746155943', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.172.132.157', '2019-07-05 21:49:35', 10, 0, '', '2019-07-05 21:49:35');
INSERT INTO `access_log` VALUES (49604, '59.76.15623356120094399', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.100.115.27', '2019-07-05 22:06:52', 9, 0, '', '2019-07-05 22:06:52');
INSERT INTO `access_log` VALUES (49605, '59.73.15623356120214411', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.100.115.27', '2019-07-05 22:06:52', 14, 2001001000, '服务端发生异常', '2019-07-05 22:06:52');
INSERT INTO `access_log` VALUES (49606, '64.76.15623356183274537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.100.115.27', '2019-07-05 22:06:58', 11, 0, '', '2019-07-05 22:06:58');
INSERT INTO `access_log` VALUES (49607, '64.84.15623356184714537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.100.115.27', '2019-07-05 22:06:58', 3, 0, '', '2019-07-05 22:06:58');
INSERT INTO `access_log` VALUES (49608, '64.83.15623356200324543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.100.115.27', '2019-07-05 22:07:00', 2, 0, '', '2019-07-05 22:07:00');
INSERT INTO `access_log` VALUES (49609, '64.81.15623356207164533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.100.115.27', '2019-07-05 22:07:01', 2, 0, '', '2019-07-05 22:07:01');
INSERT INTO `access_log` VALUES (49610, '65.54.15623366621135971', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.99', '2019-07-05 22:24:22', 1, 1002001015, '账号未登陆', '2019-07-05 22:24:22');
INSERT INTO `access_log` VALUES (49611, '65.51.15623366621136055', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.24', '2019-07-05 22:24:22', 0, 1002001015, '账号未登陆', '2019-07-05 22:24:22');
INSERT INTO `access_log` VALUES (49612, '65.3607.15623366621397807', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.99', '2019-07-05 22:24:22', 0, 1002001015, '账号未登陆', '2019-07-05 22:24:22');
INSERT INTO `access_log` VALUES (49613, '65.52.15623366658896043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.25', '2019-07-05 22:24:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-05 22:24:26');
INSERT INTO `access_log` VALUES (49614, '65.49.15623366737586005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.25', '2019-07-05 22:24:34', 72, 0, '', '2019-07-05 22:24:34');
INSERT INTO `access_log` VALUES (49615, '65.53.15623366742226015', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.99', '2019-07-05 22:24:34', 18, 0, '', '2019-07-05 22:24:34');
INSERT INTO `access_log` VALUES (49616, '65.47.15623366742335987', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.25', '2019-07-05 22:24:34', 9, 0, '', '2019-07-05 22:24:34');
INSERT INTO `access_log` VALUES (49617, '65.50.15623366742346037', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.25', '2019-07-05 22:24:34', 9, 2001001000, '服务端发生异常', '2019-07-05 22:24:34');
INSERT INTO `access_log` VALUES (49618, '65.51.15623366930926057', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.24', '2019-07-05 22:24:53', 8, 0, '', '2019-07-05 22:24:53');
INSERT INTO `access_log` VALUES (49619, '65.54.15623366930955973', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.25', '2019-07-05 22:24:53', 8, 2001001000, '服务端发生异常', '2019-07-05 22:24:53');
INSERT INTO `access_log` VALUES (49620, '65.3607.15623366930987809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.99', '2019-07-05 22:24:53', 7, 0, '', '2019-07-05 22:24:53');
INSERT INTO `access_log` VALUES (49621, '59.78.15623367377214417', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.99', '2019-07-05 22:25:38', 33, 2001001000, '服务端发生异常', '2019-07-05 22:25:38');
INSERT INTO `access_log` VALUES (49622, '59.72.15623367379674423', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.99', '2019-07-05 22:25:38', 4, 0, '', '2019-07-05 22:25:38');
INSERT INTO `access_log` VALUES (49623, '66.49.15623367584112509', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13539336761&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '223.73.84.99', '2019-07-05 22:25:58', 17, 1001003000, '验证码不存在', '2019-07-05 22:25:58');
INSERT INTO `access_log` VALUES (49624, '59.80.15623386557774433', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.24', '2019-07-05 22:57:36', 10, 0, '', '2019-07-05 22:57:36');
INSERT INTO `access_log` VALUES (49625, '59.73.15623386557774453', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.24', '2019-07-05 22:57:36', 15, 2001001000, '服务端发生异常', '2019-07-05 22:57:36');
INSERT INTO `access_log` VALUES (49626, '64.77.15623386627864569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.24', '2019-07-05 22:57:43', 12, 0, '', '2019-07-05 22:57:43');
INSERT INTO `access_log` VALUES (49627, '64.85.15623386629494595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.24', '2019-07-05 22:57:43', 3, 0, '', '2019-07-05 22:57:43');
INSERT INTO `access_log` VALUES (49628, '59.77.15623386671384439', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.24', '2019-07-05 22:57:47', 3, 0, '', '2019-07-05 22:57:47');
INSERT INTO `access_log` VALUES (49629, '59.71.15623386671424451', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.24', '2019-07-05 22:57:47', 12, 2001001000, '服务端发生异常', '2019-07-05 22:57:47');
INSERT INTO `access_log` VALUES (49630, '59.72.15623386864514449', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.24', '2019-07-05 22:58:06', 2, 0, '', '2019-07-05 22:58:06');
INSERT INTO `access_log` VALUES (49631, '59.79.15623386864514453', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.24', '2019-07-05 22:58:06', 13, 2001001000, '服务端发生异常', '2019-07-05 22:58:06');
INSERT INTO `access_log` VALUES (49632, '64.84.15623386875274579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.24', '2019-07-05 22:58:08', 2, 0, '', '2019-07-05 22:58:08');
INSERT INTO `access_log` VALUES (49633, '64.83.15623386876434585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.24', '2019-07-05 22:58:08', 2, 0, '', '2019-07-05 22:58:08');
INSERT INTO `access_log` VALUES (49634, '59.76.15623739522784911', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.186.86', '2019-07-06 08:45:52', 12, 0, '', '2019-07-06 08:45:52');
INSERT INTO `access_log` VALUES (49635, '59.80.15623739522794905', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.35.186.86', '2019-07-06 08:45:52', 31, 2001001000, '服务端发生异常', '2019-07-06 08:45:52');
INSERT INTO `access_log` VALUES (49636, '65.54.15623770122326511', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:36:52', 1, 1002001015, '账号未登陆', '2019-07-06 09:36:52');
INSERT INTO `access_log` VALUES (49637, '65.46.15623770122336605', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:36:52', 0, 1002001015, '账号未登陆', '2019-07-06 09:36:52');
INSERT INTO `access_log` VALUES (49638, '65.51.15623770122336595', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:36:52', 1, 1002001015, '账号未登陆', '2019-07-06 09:36:52');
INSERT INTO `access_log` VALUES (49639, '65.49.15623770164166545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:36:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 09:36:56');
INSERT INTO `access_log` VALUES (49640, '65.50.15623770204756577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:37:00', 81, 0, '', '2019-07-06 09:37:01');
INSERT INTO `access_log` VALUES (49641, '65.47.15623770208306527', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:37:01', 12, 0, '', '2019-07-06 09:37:01');
INSERT INTO `access_log` VALUES (49642, '65.53.15623770208346555', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:37:01', 10, 0, '', '2019-07-06 09:37:01');
INSERT INTO `access_log` VALUES (49643, '65.45.15623770244286535', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:37:04', 74, 0, '', '2019-07-06 09:37:05');
INSERT INTO `access_log` VALUES (49644, '65.3607.15623770247628349', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:37:05', 7, 0, '', '2019-07-06 09:37:05');
INSERT INTO `access_log` VALUES (49645, '65.54.15623770247716513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:37:05', 7, 0, '', '2019-07-06 09:37:05');
INSERT INTO `access_log` VALUES (49646, '65.53.15623770867226557', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:07', 1, 1002001015, '账号未登陆', '2019-07-06 09:38:07');
INSERT INTO `access_log` VALUES (49647, '65.50.15623770867226579', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:07', 1, 1002001015, '账号未登陆', '2019-07-06 09:38:07');
INSERT INTO `access_log` VALUES (49648, '65.47.15623770867246529', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:07', 0, 1002001015, '账号未登陆', '2019-07-06 09:38:07');
INSERT INTO `access_log` VALUES (49649, '65.54.15623770914516515', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 09:38:11');
INSERT INTO `access_log` VALUES (49650, '65.3607.15623770969388351', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:17', 79, 0, '', '2019-07-06 09:38:17');
INSERT INTO `access_log` VALUES (49651, '65.51.15623770972486599', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:17', 9, 0, '', '2019-07-06 09:38:17');
INSERT INTO `access_log` VALUES (49652, '65.46.15623770972526609', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:17', 11, 2001001000, '服务端发生异常', '2019-07-06 09:38:17');
INSERT INTO `access_log` VALUES (49653, '65.52.15623770972546587', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:17', 10, 0, '', '2019-07-06 09:38:17');
INSERT INTO `access_log` VALUES (49654, '65.53.15623771090866559', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:29', 8, 0, '', '2019-07-06 09:38:29');
INSERT INTO `access_log` VALUES (49655, '65.50.15623771090886581', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:29', 8, 2001001000, '服务端发生异常', '2019-07-06 09:38:29');
INSERT INTO `access_log` VALUES (49656, '65.47.15623771090916531', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:29', 8, 0, '', '2019-07-06 09:38:29');
INSERT INTO `access_log` VALUES (49657, '65.45.15623771105566539', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:31', 9, 0, '', '2019-07-06 09:38:31');
INSERT INTO `access_log` VALUES (49658, '65.54.15623771105566517', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:31', 9, 2001001000, '服务端发生异常', '2019-07-06 09:38:31');
INSERT INTO `access_log` VALUES (49659, '65.3607.15623771105618353', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:31', 8, 0, '', '2019-07-06 09:38:31');
INSERT INTO `access_log` VALUES (49660, '65.46.15623771137176611', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:34', 9, 0, '', '2019-07-06 09:38:34');
INSERT INTO `access_log` VALUES (49661, '65.52.15623771137196589', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:34', 10, 2001001000, '服务端发生异常', '2019-07-06 09:38:34');
INSERT INTO `access_log` VALUES (49662, '65.51.15623771137226601', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.93.174', '2019-07-06 09:38:34', 9, 0, '', '2019-07-06 09:38:34');
INSERT INTO `access_log` VALUES (49663, '65.49.15623771148636551', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:38:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 09:38:35');
INSERT INTO `access_log` VALUES (49664, '65.46.15623772330716613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:40:33', 91, 0, '', '2019-07-06 09:40:33');
INSERT INTO `access_log` VALUES (49665, '65.49.15623772334606553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:40:33', 8, 0, '', '2019-07-06 09:40:33');
INSERT INTO `access_log` VALUES (49666, '65.47.15623772334696535', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:40:33', 9, 0, '', '2019-07-06 09:40:33');
INSERT INTO `access_log` VALUES (49667, '65.53.15623772365486563', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:40:37', 70, 0, '', '2019-07-06 09:40:37');
INSERT INTO `access_log` VALUES (49668, '65.50.15623772368816585', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:40:37', 9, 0, '', '2019-07-06 09:40:37');
INSERT INTO `access_log` VALUES (49669, '65.3607.15623772368878357', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:40:37', 9, 0, '', '2019-07-06 09:40:37');
INSERT INTO `access_log` VALUES (49670, '65.54.15623772487626521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:40:49', 102, 0, '', '2019-07-06 09:40:49');
INSERT INTO `access_log` VALUES (49671, '65.51.15623772491456605', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:40:49', 8, 0, '', '2019-07-06 09:40:49');
INSERT INTO `access_log` VALUES (49672, '65.52.15623772491536593', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.62.93.174', '2019-07-06 09:40:49', 7, 0, '', '2019-07-06 09:40:49');
INSERT INTO `access_log` VALUES (49673, '59.78.15623773445674961', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:25', 10, 0, '', '2019-07-06 09:42:25');
INSERT INTO `access_log` VALUES (49674, '59.79.15623773445674969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:25', 21, 2001001000, '服务端发生异常', '2019-07-06 09:42:25');
INSERT INTO `access_log` VALUES (49675, '64.76.15623773469805095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:27', 12, 0, '', '2019-07-06 09:42:27');
INSERT INTO `access_log` VALUES (49676, '64.84.15623773471435095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:27', 3, 0, '', '2019-07-06 09:42:27');
INSERT INTO `access_log` VALUES (49677, '64.83.15623773480705101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:28', 2, 0, '', '2019-07-06 09:42:28');
INSERT INTO `access_log` VALUES (49678, '64.81.15623773485805091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:29', 2, 0, '', '2019-07-06 09:42:29');
INSERT INTO `access_log` VALUES (49679, '64.82.15623773490355115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:29', 2, 0, '', '2019-07-06 09:42:29');
INSERT INTO `access_log` VALUES (49680, '64.79.15623773535495107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:34', 3, 0, '', '2019-07-06 09:42:34');
INSERT INTO `access_log` VALUES (49681, '64.80.15623773538545109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:34', 2, 0, '', '2019-07-06 09:42:34');
INSERT INTO `access_log` VALUES (49682, '64.85.15623773601635113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:40', 1, 0, '', '2019-07-06 09:42:40');
INSERT INTO `access_log` VALUES (49683, '64.78.15623773603255111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:40', 2, 0, '', '2019-07-06 09:42:40');
INSERT INTO `access_log` VALUES (49684, '59.73.15623773629554971', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:43', 3, 0, '', '2019-07-06 09:42:43');
INSERT INTO `access_log` VALUES (49685, '59.76.15623773629554957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:43', 29, 2001001000, '服务端发生异常', '2019-07-06 09:42:43');
INSERT INTO `access_log` VALUES (49686, '64.76.15623773647045097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:45', 2, 0, '', '2019-07-06 09:42:45');
INSERT INTO `access_log` VALUES (49687, '64.84.15623773648135097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:45', 1, 0, '', '2019-07-06 09:42:45');
INSERT INTO `access_log` VALUES (49688, '64.83.15623773656615103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:46', 1, 0, '', '2019-07-06 09:42:46');
INSERT INTO `access_log` VALUES (49689, '64.81.15623773659395093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:46', 2, 0, '', '2019-07-06 09:42:46');
INSERT INTO `access_log` VALUES (49690, '59.77.15623773669214957', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:47', 3, 0, '', '2019-07-06 09:42:47');
INSERT INTO `access_log` VALUES (49691, '59.71.15623773669214969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:47', 15, 2001001000, '服务端发生异常', '2019-07-06 09:42:47');
INSERT INTO `access_log` VALUES (49692, '64.79.15623773713765109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:51', 2, 0, '', '2019-07-06 09:42:51');
INSERT INTO `access_log` VALUES (49693, '64.80.15623773714725111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:51', 2, 0, '', '2019-07-06 09:42:51');
INSERT INTO `access_log` VALUES (49694, '59.74.15623773720444969', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:52', 2, 0, '', '2019-07-06 09:42:52');
INSERT INTO `access_log` VALUES (49695, '59.72.15623773720454967', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:52', 15, 2001001000, '服务端发生异常', '2019-07-06 09:42:52');
INSERT INTO `access_log` VALUES (49696, '64.77.15623773745985089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:55', 2, 0, '', '2019-07-06 09:42:55');
INSERT INTO `access_log` VALUES (49697, '64.85.15623773747085115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:55', 1, 0, '', '2019-07-06 09:42:55');
INSERT INTO `access_log` VALUES (49698, '59.78.15623773753324963', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:55', 2, 0, '', '2019-07-06 09:42:55');
INSERT INTO `access_log` VALUES (49699, '59.79.15623773753324971', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '58.62.93.174', '2019-07-06 09:42:55', 24, 2001001000, '服务端发生异常', '2019-07-06 09:42:55');
INSERT INTO `access_log` VALUES (49700, '65.54.15623782348546535', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-07-06 09:57:15', 4, 1002001012, '访问令牌已过期', '2019-07-06 09:57:15');
INSERT INTO `access_log` VALUES (49701, '65.45.15623782348546557', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-07-06 09:57:15', 4, 1002001012, '访问令牌已过期', '2019-07-06 09:57:15');
INSERT INTO `access_log` VALUES (49702, '65.52.15623782348656607', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-07-06 09:57:15', 3, 1002001012, '访问令牌已过期', '2019-07-06 09:57:15');
INSERT INTO `access_log` VALUES (49703, '65.51.15623782417706619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-07-06 09:57:22', 61, 0, '', '2019-07-06 09:57:22');
INSERT INTO `access_log` VALUES (49704, '65.46.15623782421956629', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-07-06 09:57:22', 98, 0, '', '2019-07-06 09:57:22');
INSERT INTO `access_log` VALUES (49705, '65.47.15623782422026551', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-07-06 09:57:22', 91, 0, '', '2019-07-06 09:57:22');
INSERT INTO `access_log` VALUES (49706, '65.49.15623782421986569', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-07-06 09:57:22', 96, 2001001000, '服务端发生异常', '2019-07-06 09:57:22');
INSERT INTO `access_log` VALUES (49707, '65.50.15623782706826601', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-07-06 09:57:51', 7, 0, '', '2019-07-06 09:57:51');
INSERT INTO `access_log` VALUES (49708, '65.54.15623782706916537', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-07-06 09:57:51', 8, 2001001000, '服务端发生异常', '2019-07-06 09:57:51');
INSERT INTO `access_log` VALUES (49709, '65.52.15623782707026609', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.101.51.168', '2019-07-06 09:57:51', 8, 0, '', '2019-07-06 09:57:51');
INSERT INTO `access_log` VALUES (49710, '65.52.15623798854756631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-06 10:24:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 10:24:45');
INSERT INTO `access_log` VALUES (49711, '59.79.15623799040785005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:04', 10, 0, '', '2019-07-06 10:25:04');
INSERT INTO `access_log` VALUES (49712, '59.80.15623799041044987', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:04', 10, 2001001000, '服务端发生异常', '2019-07-06 10:25:04');
INSERT INTO `access_log` VALUES (49713, '64.85.15623799090665149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:09', 11, 0, '', '2019-07-06 10:25:09');
INSERT INTO `access_log` VALUES (49714, '64.78.15623799092375147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:09', 5, 0, '', '2019-07-06 10:25:09');
INSERT INTO `access_log` VALUES (49715, '64.76.15623799105065133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:11', 3, 0, '', '2019-07-06 10:25:11');
INSERT INTO `access_log` VALUES (49716, '64.84.15623799110725133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:11', 2, 0, '', '2019-07-06 10:25:11');
INSERT INTO `access_log` VALUES (49717, '64.83.15623799114015139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:11', 2, 0, '', '2019-07-06 10:25:11');
INSERT INTO `access_log` VALUES (49718, '64.81.15623799116965129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:12', 2, 0, '', '2019-07-06 10:25:12');
INSERT INTO `access_log` VALUES (49719, '59.76.15623799125684993', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:13', 2, 0, '', '2019-07-06 10:25:13');
INSERT INTO `access_log` VALUES (49720, '59.73.15623799125545007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:13', 38, 2001001000, '服务端发生异常', '2019-07-06 10:25:13');
INSERT INTO `access_log` VALUES (49721, '64.82.15623799148265153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:15', 2, 0, '', '2019-07-06 10:25:15');
INSERT INTO `access_log` VALUES (49722, '64.79.15623799149415145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:15', 2, 0, '', '2019-07-06 10:25:15');
INSERT INTO `access_log` VALUES (49723, '59.71.15623799154605005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:15', 2, 0, '', '2019-07-06 10:25:15');
INSERT INTO `access_log` VALUES (49724, '59.77.15623799154754993', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:15', 10, 2001001000, '服务端发生异常', '2019-07-06 10:25:15');
INSERT INTO `access_log` VALUES (49725, '65.47.15623799278816575', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:28', 1, 1002001015, '账号未登陆', '2019-07-06 10:25:28');
INSERT INTO `access_log` VALUES (49726, '65.49.15623799278816593', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:28', 0, 1002001015, '账号未登陆', '2019-07-06 10:25:28');
INSERT INTO `access_log` VALUES (49727, '65.46.15623799278896653', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:28', 1, 1002001015, '账号未登陆', '2019-07-06 10:25:28');
INSERT INTO `access_log` VALUES (49728, '65.53.15623799345556603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:35', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 10:25:35');
INSERT INTO `access_log` VALUES (49729, '65.3607.15623799364388397', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:36', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 10:25:36');
INSERT INTO `access_log` VALUES (49730, '65.52.15623799468806633', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 10:25:47');
INSERT INTO `access_log` VALUES (49731, '65.45.15623799562536583', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:56', 78, 0, '', '2019-07-06 10:25:56');
INSERT INTO `access_log` VALUES (49732, '65.51.15623799565866645', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:57', 10, 0, '', '2019-07-06 10:25:57');
INSERT INTO `access_log` VALUES (49733, '65.49.15623799565876595', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:57', 11, 2001001000, '服务端发生异常', '2019-07-06 10:25:57');
INSERT INTO `access_log` VALUES (49734, '65.47.15623799565906577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:25:57', 17, 0, '', '2019-07-06 10:25:57');
INSERT INTO `access_log` VALUES (49735, '65.46.15623799663656655', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:26:06', 9, 0, '', '2019-07-06 10:26:06');
INSERT INTO `access_log` VALUES (49736, '65.3607.15623799663768399', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:26:06', 8, 0, '', '2019-07-06 10:26:06');
INSERT INTO `access_log` VALUES (49737, '65.53.15623799663766605', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '110.228.173.40', '2019-07-06 10:26:06', 10, 2001001000, '服务端发生异常', '2019-07-06 10:26:06');
INSERT INTO `access_log` VALUES (49738, '59.75.15623821618555043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.145.208.99', '2019-07-06 11:02:42', 10, 0, '', '2019-07-06 11:02:42');
INSERT INTO `access_log` VALUES (49739, '59.72.15623821618555033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.145.208.99', '2019-07-06 11:02:42', 24, 2001001000, '服务端发生异常', '2019-07-06 11:02:42');
INSERT INTO `access_log` VALUES (49740, '65.46.15623821726426685', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.99', '2019-07-06 11:02:53', 13, 1002001012, '访问令牌已过期', '2019-07-06 11:02:53');
INSERT INTO `access_log` VALUES (49741, '65.53.15623821726286635', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.99', '2019-07-06 11:02:53', 27, 1002001012, '访问令牌已过期', '2019-07-06 11:02:53');
INSERT INTO `access_log` VALUES (49742, '65.3607.15623821726288429', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.99', '2019-07-06 11:02:53', 27, 1002001012, '访问令牌已过期', '2019-07-06 11:02:53');
INSERT INTO `access_log` VALUES (49743, '65.52.15623821766096665', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.99', '2019-07-06 11:02:57', 75, 0, '', '2019-07-06 11:02:57');
INSERT INTO `access_log` VALUES (49744, '65.54.15623821818206593', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.145.208.99', '2019-07-06 11:03:02', 70, 0, '', '2019-07-06 11:03:02');
INSERT INTO `access_log` VALUES (49745, '65.51.15623821891956677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.145.208.99', '2019-07-06 11:03:09', 65, 0, '', '2019-07-06 11:03:09');
INSERT INTO `access_log` VALUES (49746, '65.49.15623821895336627', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.145.208.99', '2019-07-06 11:03:10', 9, 0, '', '2019-07-06 11:03:10');
INSERT INTO `access_log` VALUES (49747, '65.46.15623821895396687', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.145.208.99', '2019-07-06 11:03:10', 10, 0, '', '2019-07-06 11:03:10');
INSERT INTO `access_log` VALUES (49748, '65.47.15623821895396609', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.145.208.99', '2019-07-06 11:03:10', 10, 2001001000, '服务端发生异常', '2019-07-06 11:03:10');
INSERT INTO `access_log` VALUES (49749, '65.46.15623835134446705', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:25:13', 0, 1002001015, '账号未登陆', '2019-07-06 11:25:13');
INSERT INTO `access_log` VALUES (49750, '65.45.15623835134446637', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:25:13', 1, 1002001015, '账号未登陆', '2019-07-06 11:25:13');
INSERT INTO `access_log` VALUES (49751, '65.47.15623835134446629', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:25:13', 1, 1002001015, '账号未登陆', '2019-07-06 11:25:13');
INSERT INTO `access_log` VALUES (49752, '65.49.15623835159426645', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:25:16', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 11:25:16');
INSERT INTO `access_log` VALUES (49753, '65.53.15623835234086657', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:25:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 11:25:23');
INSERT INTO `access_log` VALUES (49754, '65.52.15623835440476685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:25:44', 64, 0, '', '2019-07-06 11:25:44');
INSERT INTO `access_log` VALUES (49755, '65.54.15623835444216613', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:25:44', 18, 0, '', '2019-07-06 11:25:44');
INSERT INTO `access_log` VALUES (49756, '65.51.15623835444236697', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:25:44', 18, 2001001000, '服务端发生异常', '2019-07-06 11:25:44');
INSERT INTO `access_log` VALUES (49757, '65.46.15623835444346707', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:25:44', 8, 0, '', '2019-07-06 11:25:44');
INSERT INTO `access_log` VALUES (49758, '65.49.15623835791466647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:26:19', 8, 0, '', '2019-07-06 11:26:19');
INSERT INTO `access_log` VALUES (49759, '65.53.15623835791486659', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:26:19', 8, 2001001000, '服务端发生异常', '2019-07-06 11:26:19');
INSERT INTO `access_log` VALUES (49760, '65.3607.15623835791538451', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:26:19', 8, 0, '', '2019-07-06 11:26:19');
INSERT INTO `access_log` VALUES (49761, '65.52.15623835877586687', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:26:28', 9, 0, '', '2019-07-06 11:26:28');
INSERT INTO `access_log` VALUES (49762, '65.51.15623835877626699', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:26:28', 10, 2001001000, '服务端发生异常', '2019-07-06 11:26:28');
INSERT INTO `access_log` VALUES (49763, '65.54.15623835877666615', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:26:28', 9, 0, '', '2019-07-06 11:26:28');
INSERT INTO `access_log` VALUES (49764, '65.49.15623838069106651', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:30:07', 11, 0, '', '2019-07-06 11:30:07');
INSERT INTO `access_log` VALUES (49765, '65.53.15623838069146663', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:30:07', 11, 2001001000, '服务端发生异常', '2019-07-06 11:30:07');
INSERT INTO `access_log` VALUES (49766, '65.50.15623838069186685', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:30:07', 9, 0, '', '2019-07-06 11:30:07');
INSERT INTO `access_log` VALUES (49767, '59.74.15623838190025057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:30:19', 4, 0, '', '2019-07-06 11:30:19');
INSERT INTO `access_log` VALUES (49768, '59.78.15623838190035051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:30:19', 16, 2001001000, '服务端发生异常', '2019-07-06 11:30:19');
INSERT INTO `access_log` VALUES (49769, '66.52.15623838625233115', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15118664756&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:31:03', 17, 1001003000, '验证码不存在', '2019-07-06 11:31:03');
INSERT INTO `access_log` VALUES (49770, '66.50.15623838681213119', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15118664756&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:31:08', 8, 1001003000, '验证码不存在', '2019-07-06 11:31:08');
INSERT INTO `access_log` VALUES (49771, '59.77.15623838911525047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:31:31', 3, 0, '', '2019-07-06 11:31:31');
INSERT INTO `access_log` VALUES (49772, '59.72.15623838911945057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:31:31', 12, 2001001000, '服务端发生异常', '2019-07-06 11:31:31');
INSERT INTO `access_log` VALUES (49773, '59.79.15623839129575061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:31:53', 3, 0, '', '2019-07-06 11:31:53');
INSERT INTO `access_log` VALUES (49774, '59.78.15623839129575053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:31:53', 14, 2001001000, '服务端发生异常', '2019-07-06 11:31:53');
INSERT INTO `access_log` VALUES (49775, '66.51.15623839414913149', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15119669623', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:32:21', 72, 0, '', '2019-07-06 11:32:22');
INSERT INTO `access_log` VALUES (49776, '66.56.15623839434413137', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15119669623&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '1.204.114.37', '2019-07-06 11:32:23', 348, 0, '', '2019-07-06 11:32:24');
INSERT INTO `access_log` VALUES (49777, '59.71.15623842260565065', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.119.86.89', '2019-07-06 11:37:06', 3, 0, '', '2019-07-06 11:37:06');
INSERT INTO `access_log` VALUES (49778, '59.77.15623842260575053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.119.86.89', '2019-07-06 11:37:06', 13, 2001001000, '服务端发生异常', '2019-07-06 11:37:06');
INSERT INTO `access_log` VALUES (49779, '59.72.15623842374135063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.119.86.89', '2019-07-06 11:37:17', 2, 0, '', '2019-07-06 11:37:17');
INSERT INTO `access_log` VALUES (49780, '59.75.15623842374145073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.119.86.89', '2019-07-06 11:37:17', 13, 2001001000, '服务端发生异常', '2019-07-06 11:37:17');
INSERT INTO `access_log` VALUES (49781, '65.45.15623924277716759', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.239', '2019-07-06 13:53:48', 22, 1002001012, '访问令牌已过期', '2019-07-06 13:53:48');
INSERT INTO `access_log` VALUES (49782, '65.46.15623924277726827', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.239', '2019-07-06 13:53:48', 24, 1002001012, '访问令牌已过期', '2019-07-06 13:53:48');
INSERT INTO `access_log` VALUES (49783, '65.47.15623924277726753', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.239', '2019-07-06 13:53:48', 31, 1002001012, '访问令牌已过期', '2019-07-06 13:53:48');
INSERT INTO `access_log` VALUES (49784, '65.3607.15623924323988573', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.239', '2019-07-06 13:53:52', 93, 0, '', '2019-07-06 13:53:52');
INSERT INTO `access_log` VALUES (49785, '65.49.15623924330706769', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.239', '2019-07-06 13:53:53', 13, 0, '', '2019-07-06 13:53:53');
INSERT INTO `access_log` VALUES (49786, '65.50.15623924330736801', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.239', '2019-07-06 13:53:53', 196, 0, '', '2019-07-06 13:53:53');
INSERT INTO `access_log` VALUES (49787, '65.53.15623924330786779', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.254.239', '2019-07-06 13:53:53', 195, 2001001000, '服务端发生异常', '2019-07-06 13:53:53');
INSERT INTO `access_log` VALUES (49788, '65.53.15623928544576785', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.221.55.225', '2019-07-06 14:00:54', 1, 1002001015, '账号未登陆', '2019-07-06 14:00:54');
INSERT INTO `access_log` VALUES (49789, '65.52.15623928544616815', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.221.55.225', '2019-07-06 14:00:54', 1, 1002001015, '账号未登陆', '2019-07-06 14:00:54');
INSERT INTO `access_log` VALUES (49790, '65.51.15623928544656825', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.221.55.225', '2019-07-06 14:00:54', 0, 1002001015, '账号未登陆', '2019-07-06 14:00:54');
INSERT INTO `access_log` VALUES (49791, '65.54.15623928562896743', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.221.55.225', '2019-07-06 14:00:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 14:00:56');
INSERT INTO `access_log` VALUES (49792, '65.47.15623928711716761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.221.55.225', '2019-07-06 14:01:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 14:01:11');
INSERT INTO `access_log` VALUES (49793, '65.45.15623928780726767', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.221.55.225', '2019-07-06 14:01:18', 6, 1002002001, '密码不正确', '2019-07-06 14:01:18');
INSERT INTO `access_log` VALUES (49794, '65.49.15623928887606777', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.221.55.225', '2019-07-06 14:01:29', 4, 1002002001, '密码不正确', '2019-07-06 14:01:29');
INSERT INTO `access_log` VALUES (49795, '65.46.15623929641046837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.221.55.225', '2019-07-06 14:02:44', 89, 0, '', '2019-07-06 14:02:44');
INSERT INTO `access_log` VALUES (49796, '65.47.15623929644646763', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.221.55.225', '2019-07-06 14:02:44', 9, 0, '', '2019-07-06 14:02:44');
INSERT INTO `access_log` VALUES (49797, '65.45.15623929644646769', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.221.55.225', '2019-07-06 14:02:44', 11, 2001001000, '服务端发生异常', '2019-07-06 14:02:44');
INSERT INTO `access_log` VALUES (49798, '65.3607.15623929644698583', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.221.55.225', '2019-07-06 14:02:44', 9, 0, '', '2019-07-06 14:02:44');
INSERT INTO `access_log` VALUES (49799, '65.49.15623929733566779', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.221.55.225', '2019-07-06 14:02:53', 9, 0, '', '2019-07-06 14:02:53');
INSERT INTO `access_log` VALUES (49800, '65.50.15623929733586811', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.221.55.225', '2019-07-06 14:02:53', 10, 2001001000, '服务端发生异常', '2019-07-06 14:02:53');
INSERT INTO `access_log` VALUES (49801, '65.51.15623929733636829', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '171.221.55.225', '2019-07-06 14:02:53', 9, 0, '', '2019-07-06 14:02:53');
INSERT INTO `access_log` VALUES (49802, '59.78.15623964107115221', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '36.102.237.131', '2019-07-06 15:00:11', 11, 0, '', '2019-07-06 15:00:11');
INSERT INTO `access_log` VALUES (49803, '59.80.15623964107145211', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '36.102.237.131', '2019-07-06 15:00:11', 46, 2001001000, '服务端发生异常', '2019-07-06 15:00:11');
INSERT INTO `access_log` VALUES (49804, '59.79.15623972681145241', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:28', 3, 0, '', '2019-07-06 15:14:28');
INSERT INTO `access_log` VALUES (49805, '59.78.15623972681275233', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:28', 15, 2001001000, '服务端发生异常', '2019-07-06 15:14:28');
INSERT INTO `access_log` VALUES (49806, '64.78.15623972710425379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:31', 10, 0, '', '2019-07-06 15:14:31');
INSERT INTO `access_log` VALUES (49807, '64.84.15623972711895369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:31', 3, 0, '', '2019-07-06 15:14:31');
INSERT INTO `access_log` VALUES (49808, '64.76.15623972722625365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:32', 2, 0, '', '2019-07-06 15:14:32');
INSERT INTO `access_log` VALUES (49809, '64.83.15623972726605371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:33', 2, 0, '', '2019-07-06 15:14:33');
INSERT INTO `access_log` VALUES (49810, '59.76.15623972737615229', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:34', 3, 0, '', '2019-07-06 15:14:34');
INSERT INTO `access_log` VALUES (49811, '59.80.15623972737615223', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:34', 13, 2001001000, '服务端发生异常', '2019-07-06 15:14:34');
INSERT INTO `access_log` VALUES (49812, '65.51.15623972821256887', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:42', 0, 1002001015, '账号未登陆', '2019-07-06 15:14:42');
INSERT INTO `access_log` VALUES (49813, '65.53.15623972821576847', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:42', 0, 1002001015, '账号未登陆', '2019-07-06 15:14:42');
INSERT INTO `access_log` VALUES (49814, '65.50.15623972821576869', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:42', 0, 1002001015, '账号未登陆', '2019-07-06 15:14:42');
INSERT INTO `access_log` VALUES (49815, '65.52.15623972844386877', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 15:14:44');
INSERT INTO `access_log` VALUES (49816, '65.54.15623972872276805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:47', 332, 0, '', '2019-07-06 15:14:48');
INSERT INTO `access_log` VALUES (49817, '65.46.15623972878406897', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:48', 11, 0, '', '2019-07-06 15:14:48');
INSERT INTO `access_log` VALUES (49818, '65.3607.15623972878438643', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:48', 13, 2001001000, '服务端发生异常', '2019-07-06 15:14:48');
INSERT INTO `access_log` VALUES (49819, '65.47.15623972878486823', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.215.104.211', '2019-07-06 15:14:48', 11, 0, '', '2019-07-06 15:14:48');
INSERT INTO `access_log` VALUES (49820, '59.73.15623977164965249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.30.61.180', '2019-07-06 15:21:56', 3, 0, '', '2019-07-06 15:21:56');
INSERT INTO `access_log` VALUES (49821, '59.71.15623977164965247', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.30.61.180', '2019-07-06 15:21:56', 16, 2001001000, '服务端发生异常', '2019-07-06 15:21:57');
INSERT INTO `access_log` VALUES (49822, '59.76.15623981126635241', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '39.89.3.64', '2019-07-06 15:28:33', 3, 0, '', '2019-07-06 15:28:33');
INSERT INTO `access_log` VALUES (49823, '59.80.15623981126645235', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '39.89.3.64', '2019-07-06 15:28:33', 12, 2001001000, '服务端发生异常', '2019-07-06 15:28:33');
INSERT INTO `access_log` VALUES (49824, '64.84.15623981289155381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '39.89.3.64', '2019-07-06 15:28:49', 143, 0, '', '2019-07-06 15:28:49');
INSERT INTO `access_log` VALUES (49825, '64.76.15623981293215377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '39.89.3.64', '2019-07-06 15:28:49', 2, 0, '', '2019-07-06 15:28:49');
INSERT INTO `access_log` VALUES (49826, '64.81.15623981314635373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '39.89.3.64', '2019-07-06 15:28:51', 2, 0, '', '2019-07-06 15:28:51');
INSERT INTO `access_log` VALUES (49827, '64.82.15623981323895403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '39.89.3.64', '2019-07-06 15:28:52', 2, 0, '', '2019-07-06 15:28:52');
INSERT INTO `access_log` VALUES (49828, '59.77.15623981338835241', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '39.89.3.64', '2019-07-06 15:28:54', 2, 0, '', '2019-07-06 15:28:54');
INSERT INTO `access_log` VALUES (49829, '59.72.15623981338835251', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '39.89.3.64', '2019-07-06 15:28:54', 12, 2001001000, '服务端发生异常', '2019-07-06 15:28:54');
INSERT INTO `access_log` VALUES (49830, '64.79.15623981373175389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '39.89.3.64', '2019-07-06 15:28:57', 2, 0, '', '2019-07-06 15:28:57');
INSERT INTO `access_log` VALUES (49831, '64.80.15623981374315393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '39.89.3.64', '2019-07-06 15:28:57', 2, 0, '', '2019-07-06 15:28:57');
INSERT INTO `access_log` VALUES (49832, '59.75.15624018750335311', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.138.233.103', '2019-07-06 16:31:15', 15, 0, '', '2019-07-06 16:31:15');
INSERT INTO `access_log` VALUES (49833, '59.78.15624018750405299', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.138.233.103', '2019-07-06 16:31:15', 19, 2001001000, '服务端发生异常', '2019-07-06 16:31:15');
INSERT INTO `access_log` VALUES (49834, '64.80.15624018791265443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.138.233.103', '2019-07-06 16:31:19', 11, 0, '', '2019-07-06 16:31:19');
INSERT INTO `access_log` VALUES (49835, '64.77.15624018793665417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.138.233.103', '2019-07-06 16:31:19', 2, 0, '', '2019-07-06 16:31:19');
INSERT INTO `access_log` VALUES (49836, '64.78.15624018807345443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.138.233.103', '2019-07-06 16:31:21', 2, 0, '', '2019-07-06 16:31:21');
INSERT INTO `access_log` VALUES (49837, '64.84.15624018813595433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.138.233.103', '2019-07-06 16:31:21', 2, 0, '', '2019-07-06 16:31:21');
INSERT INTO `access_log` VALUES (49838, '59.74.15624033928265327', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.195.61.127', '2019-07-06 16:56:33', 4, 0, '', '2019-07-06 16:56:33');
INSERT INTO `access_log` VALUES (49839, '59.76.15624033928275315', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.195.61.127', '2019-07-06 16:56:33', 19, 2001001000, '服务端发生异常', '2019-07-06 16:56:33');
INSERT INTO `access_log` VALUES (49840, '64.83.15624033958235455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.195.61.127', '2019-07-06 16:56:36', 3, 0, '', '2019-07-06 16:56:36');
INSERT INTO `access_log` VALUES (49841, '64.81.15624033959835445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.195.61.127', '2019-07-06 16:56:36', 2, 0, '', '2019-07-06 16:56:36');
INSERT INTO `access_log` VALUES (49842, '64.82.15624033989675475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.195.61.127', '2019-07-06 16:56:39', 2, 0, '', '2019-07-06 16:56:39');
INSERT INTO `access_log` VALUES (49843, '64.79.15624033991235461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.195.61.127', '2019-07-06 16:56:39', 2, 0, '', '2019-07-06 16:56:39');
INSERT INTO `access_log` VALUES (49844, '59.73.15624033997935329', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.195.61.127', '2019-07-06 16:56:40', 2, 0, '', '2019-07-06 16:56:40');
INSERT INTO `access_log` VALUES (49845, '59.71.15624033997935323', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.195.61.127', '2019-07-06 16:56:40', 12, 2001001000, '服务端发生异常', '2019-07-06 16:56:40');
INSERT INTO `access_log` VALUES (49846, '59.77.15624083531155379', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:19:13', 11, 0, '', '2019-07-06 18:19:13');
INSERT INTO `access_log` VALUES (49847, '59.72.15624083531175385', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:19:13', 31, 2001001000, '服务端发生异常', '2019-07-06 18:19:13');
INSERT INTO `access_log` VALUES (49848, '66.52.15624083726983443', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:19:33', 18, 1001003001, '验证码已过期', '2019-07-06 18:19:33');
INSERT INTO `access_log` VALUES (49849, '59.76.15624083868155383', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:19:47', 3, 0, '', '2019-07-06 18:19:47');
INSERT INTO `access_log` VALUES (49850, '59.79.15624083868155393', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:19:47', 26, 2001001000, '服务端发生异常', '2019-07-06 18:19:47');
INSERT INTO `access_log` VALUES (49851, '65.51.15624085830327039', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:23:03', 1, 1002001015, '账号未登陆', '2019-07-06 18:23:03');
INSERT INTO `access_log` VALUES (49852, '65.49.15624085830326991', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:23:03', 1, 1002001015, '账号未登陆', '2019-07-06 18:23:03');
INSERT INTO `access_log` VALUES (49853, '65.53.15624085830407001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:23:03', 0, 1002001015, '账号未登陆', '2019-07-06 18:23:03');
INSERT INTO `access_log` VALUES (49854, '65.52.15624085876577031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:23:08', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 18:23:08');
INSERT INTO `access_log` VALUES (49855, '65.47.15624086056046975', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:23:26', 76, 0, '', '2019-07-06 18:23:26');
INSERT INTO `access_log` VALUES (49856, '65.3607.15624086063438797', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:23:26', 16, 0, '', '2019-07-06 18:23:26');
INSERT INTO `access_log` VALUES (49857, '65.46.15624086063437049', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:23:26', 17, 2001001000, '服务端发生异常', '2019-07-06 18:23:26');
INSERT INTO `access_log` VALUES (49858, '65.45.15624086063606981', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:23:26', 9, 0, '', '2019-07-06 18:23:26');
INSERT INTO `access_log` VALUES (49859, '65.51.15624086192927041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:23:39', 10, 0, '', '2019-07-06 18:23:39');
INSERT INTO `access_log` VALUES (49860, '65.53.15624086193007003', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:23:39', 10, 2001001000, '服务端发生异常', '2019-07-06 18:23:39');
INSERT INTO `access_log` VALUES (49861, '65.52.15624086193077033', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:23:39', 9, 0, '', '2019-07-06 18:23:39');
INSERT INTO `access_log` VALUES (49862, '65.51.15624087465497043', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:25:47', 1, 1002001015, '账号未登陆', '2019-07-06 18:25:47');
INSERT INTO `access_log` VALUES (49863, '65.52.15624087465517035', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:25:47', 0, 1002001015, '账号未登陆', '2019-07-06 18:25:47');
INSERT INTO `access_log` VALUES (49864, '65.50.15624087465557027', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:25:47', 1, 1002001015, '账号未登陆', '2019-07-06 18:25:47');
INSERT INTO `access_log` VALUES (49865, '65.54.15624087496526961', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:25:50', 69, 0, '', '2019-07-06 18:25:50');
INSERT INTO `access_log` VALUES (49866, '65.47.15624087502926979', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:25:50', 10, 0, '', '2019-07-06 18:25:50');
INSERT INTO `access_log` VALUES (49867, '65.3607.15624087502968801', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:25:50', 10, 2001001000, '服务端发生异常', '2019-07-06 18:25:50');
INSERT INTO `access_log` VALUES (49868, '65.46.15624087503007053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:25:50', 8, 0, '', '2019-07-06 18:25:50');
INSERT INTO `access_log` VALUES (49869, '65.53.15624087638007007', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:26:04', 9, 0, '', '2019-07-06 18:26:04');
INSERT INTO `access_log` VALUES (49870, '65.49.15624087638006997', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:26:04', 19, 2001001000, '服务端发生异常', '2019-07-06 18:26:04');
INSERT INTO `access_log` VALUES (49871, '65.50.15624087638037029', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:26:04', 16, 0, '', '2019-07-06 18:26:04');
INSERT INTO `access_log` VALUES (49872, '65.51.15624087792337045', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:26:19', 9, 0, '', '2019-07-06 18:26:19');
INSERT INTO `access_log` VALUES (49873, '65.54.15624087792346963', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:26:19', 10, 2001001000, '服务端发生异常', '2019-07-06 18:26:19');
INSERT INTO `access_log` VALUES (49874, '65.47.15624087792426981', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:26:19', 8, 0, '', '2019-07-06 18:26:19');
INSERT INTO `access_log` VALUES (49875, '59.76.15624088023325389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:26:42', 3, 0, '', '2019-07-06 18:26:42');
INSERT INTO `access_log` VALUES (49876, '59.79.15624088023355399', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:26:42', 17, 2001001000, '服务端发生异常', '2019-07-06 18:26:42');
INSERT INTO `access_log` VALUES (49877, '64.80.15624088051145537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:26:45', 11, 0, '', '2019-07-06 18:26:45');
INSERT INTO `access_log` VALUES (49878, '64.77.15624088052765511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:26:45', 3, 0, '', '2019-07-06 18:26:45');
INSERT INTO `access_log` VALUES (49879, '64.85.15624088064255543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:26:46', 2, 0, '', '2019-07-06 18:26:46');
INSERT INTO `access_log` VALUES (49880, '64.78.15624088067665537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '1.193.28.7', '2019-07-06 18:26:47', 2, 0, '', '2019-07-06 18:26:47');
INSERT INTO `access_log` VALUES (49881, '65.46.15624090729797059', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:31:13', 10, 0, '', '2019-07-06 18:31:13');
INSERT INTO `access_log` VALUES (49882, '65.3607.15624090729868807', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:31:13', 10, 2001001000, '服务端发生异常', '2019-07-06 18:31:13');
INSERT INTO `access_log` VALUES (49883, '65.45.15624090729946991', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.3226.400 QQBrowser/9.6.11681.400', '58.101.144.128', '2019-07-06 18:31:13', 8, 0, '', '2019-07-06 18:31:13');
INSERT INTO `access_log` VALUES (49884, '65.50.15624108722207059', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.92.152.44', '2019-07-06 19:01:12', 0, 1002001015, '账号未登陆', '2019-07-06 19:01:12');
INSERT INTO `access_log` VALUES (49885, '65.49.15624108722207027', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.92.152.44', '2019-07-06 19:01:12', 0, 1002001015, '账号未登陆', '2019-07-06 19:01:12');
INSERT INTO `access_log` VALUES (49886, '65.53.15624108722217037', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.92.152.44', '2019-07-06 19:01:12', 0, 1002001015, '账号未登陆', '2019-07-06 19:01:12');
INSERT INTO `access_log` VALUES (49887, '65.52.15624194281097181', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.28.189.249', '2019-07-06 21:23:48', 0, 1002001015, '账号未登陆', '2019-07-06 21:23:48');
INSERT INTO `access_log` VALUES (49888, '65.51.15624194281097189', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.28.189.249', '2019-07-06 21:23:48', 0, 1002001015, '账号未登陆', '2019-07-06 21:23:48');
INSERT INTO `access_log` VALUES (49889, '65.54.15624194281107107', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.28.189.249', '2019-07-06 21:23:48', 0, 1002001015, '账号未登陆', '2019-07-06 21:23:48');
INSERT INTO `access_log` VALUES (49890, '65.47.15624194308747125', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.28.189.249', '2019-07-06 21:23:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 21:23:51');
INSERT INTO `access_log` VALUES (49891, '65.3607.15624194327588947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.28.189.249', '2019-07-06 21:23:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 21:23:53');
INSERT INTO `access_log` VALUES (49892, '65.51.15624223854927229', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; Redmi 5 Plus Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '218.88.125.222', '2019-07-06 22:13:05', 0, 1002001015, '账号未登陆', '2019-07-06 22:13:05');
INSERT INTO `access_log` VALUES (49893, '65.47.15624223855077165', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; Redmi 5 Plus Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '218.88.125.222', '2019-07-06 22:13:06', 0, 1002001015, '账号未登陆', '2019-07-06 22:13:06');
INSERT INTO `access_log` VALUES (49894, '65.3607.15624223855078987', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; Redmi 5 Plus Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '218.88.125.222', '2019-07-06 22:13:06', 0, 1002001015, '账号未登陆', '2019-07-06 22:13:06');
INSERT INTO `access_log` VALUES (49895, '65.45.15624223895367171', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; Redmi 5 Plus Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '218.88.125.222', '2019-07-06 22:13:10', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 22:13:10');
INSERT INTO `access_log` VALUES (49896, '65.53.15624224107297193', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; Redmi 5 Plus Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '218.88.125.222', '2019-07-06 22:13:31', 74, 0, '', '2019-07-06 22:13:31');
INSERT INTO `access_log` VALUES (49897, '65.49.15624224114427183', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; Redmi 5 Plus Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '218.88.125.222', '2019-07-06 22:13:31', 11, 0, '', '2019-07-06 22:13:31');
INSERT INTO `access_log` VALUES (49898, '65.54.15624224114617149', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; Redmi 5 Plus Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '218.88.125.222', '2019-07-06 22:13:31', 10, 2001001000, '服务端发生异常', '2019-07-06 22:13:31');
INSERT INTO `access_log` VALUES (49899, '65.52.15624224114767223', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; Redmi 5 Plus Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '218.88.125.222', '2019-07-06 22:13:31', 10, 0, '', '2019-07-06 22:13:31');
INSERT INTO `access_log` VALUES (49900, '59.71.15624232441725589', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:24', 11, 0, '', '2019-07-06 22:27:24');
INSERT INTO `access_log` VALUES (49901, '59.77.15624232441725579', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:24', 19, 2001001000, '服务端发生异常', '2019-07-06 22:27:24');
INSERT INTO `access_log` VALUES (49902, '64.81.15624232511415711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:31', 11, 0, '', '2019-07-06 22:27:31');
INSERT INTO `access_log` VALUES (49903, '64.82.15624232513095741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:31', 3, 0, '', '2019-07-06 22:27:31');
INSERT INTO `access_log` VALUES (49904, '64.79.15624232546175727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:35', 2, 0, '', '2019-07-06 22:27:35');
INSERT INTO `access_log` VALUES (49905, '59.78.15624232572145587', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:37', 3, 0, '', '2019-07-06 22:27:37');
INSERT INTO `access_log` VALUES (49906, '59.75.15624232572185599', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:37', 21, 2001001000, '服务端发生异常', '2019-07-06 22:27:37');
INSERT INTO `access_log` VALUES (49907, '64.77.15624232609405705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:41', 2, 0, '', '2019-07-06 22:27:41');
INSERT INTO `access_log` VALUES (49908, '64.85.15624232611805737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:41', 1, 0, '', '2019-07-06 22:27:41');
INSERT INTO `access_log` VALUES (49909, '59.79.15624232668385593', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:47', 2, 0, '', '2019-07-06 22:27:47');
INSERT INTO `access_log` VALUES (49910, '59.76.15624232668405583', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:47', 16, 2001001000, '服务端发生异常', '2019-07-06 22:27:47');
INSERT INTO `access_log` VALUES (49911, '64.78.15624232677565731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:48', 2, 0, '', '2019-07-06 22:27:48');
INSERT INTO `access_log` VALUES (49912, '64.84.15624232679245721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:48', 1, 0, '', '2019-07-06 22:27:48');
INSERT INTO `access_log` VALUES (49913, '59.74.15624232687865595', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:49', 2, 0, '', '2019-07-06 22:27:49');
INSERT INTO `access_log` VALUES (49914, '59.80.15624232687865571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.10.150', '2019-07-06 22:27:49', 13, 2001001000, '服务端发生异常', '2019-07-06 22:27:49');
INSERT INTO `access_log` VALUES (49915, '59.74.15624278867355657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.149.165.107', '2019-07-06 23:44:47', 9, 0, '', '2019-07-06 23:44:47');
INSERT INTO `access_log` VALUES (49916, '59.80.15624278867365633', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.149.165.107', '2019-07-06 23:44:47', 29, 2001001000, '服务端发生异常', '2019-07-06 23:44:47');
INSERT INTO `access_log` VALUES (49917, '65.53.15624278977547267', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.149.165.107', '2019-07-06 23:44:58', 1, 1002001015, '账号未登陆', '2019-07-06 23:44:58');
INSERT INTO `access_log` VALUES (49918, '65.54.15624278977697223', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.149.165.107', '2019-07-06 23:44:58', 0, 1002001015, '账号未登陆', '2019-07-06 23:44:58');
INSERT INTO `access_log` VALUES (49919, '65.49.15624278977707257', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.149.165.107', '2019-07-06 23:44:58', 0, 1002001015, '账号未登陆', '2019-07-06 23:44:58');
INSERT INTO `access_log` VALUES (49920, '65.47.15624279147357241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.149.165.107', '2019-07-06 23:45:15', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 23:45:15');
INSERT INTO `access_log` VALUES (49921, '65.51.15624279221197305', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.149.165.107', '2019-07-06 23:45:22', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-06 23:45:22');
INSERT INTO `access_log` VALUES (49922, '65.50.15624279567707291', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.149.165.107', '2019-07-06 23:45:57', 202, 0, '', '2019-07-06 23:45:57');
INSERT INTO `access_log` VALUES (49923, '65.53.15624279575867269', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.149.165.107', '2019-07-06 23:45:58', 16, 0, '', '2019-07-06 23:45:58');
INSERT INTO `access_log` VALUES (49924, '65.54.15624279575867225', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.149.165.107', '2019-07-06 23:45:58', 15, 0, '', '2019-07-06 23:45:58');
INSERT INTO `access_log` VALUES (49925, '65.49.15624279575877259', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.149.165.107', '2019-07-06 23:45:58', 18, 2001001000, '服务端发生异常', '2019-07-06 23:45:58');
INSERT INTO `access_log` VALUES (49926, '65.45.15624556331717617', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '171.34.210.123', '2019-07-07 07:27:13', 0, 1002001015, '账号未登陆', '2019-07-07 07:27:13');
INSERT INTO `access_log` VALUES (49927, '65.50.15624556331727661', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '171.34.210.123', '2019-07-07 07:27:13', 0, 1002001015, '账号未登陆', '2019-07-07 07:27:13');
INSERT INTO `access_log` VALUES (49928, '65.49.15624556331747629', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '171.34.210.123', '2019-07-07 07:27:13', 0, 1002001015, '账号未登陆', '2019-07-07 07:27:13');
INSERT INTO `access_log` VALUES (49929, '65.53.15624556354207639', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '171.34.210.123', '2019-07-07 07:27:15', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 07:27:15');
INSERT INTO `access_log` VALUES (49930, '65.51.15624556758017677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '171.34.210.123', '2019-07-07 07:27:56', 70, 0, '', '2019-07-07 07:27:56');
INSERT INTO `access_log` VALUES (49931, '65.3607.15624556761229435', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '171.34.210.123', '2019-07-07 07:27:56', 9, 0, '', '2019-07-07 07:27:56');
INSERT INTO `access_log` VALUES (49932, '65.45.15624556761297619', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '171.34.210.123', '2019-07-07 07:27:56', 8, 0, '', '2019-07-07 07:27:56');
INSERT INTO `access_log` VALUES (49933, '65.46.15624556761277687', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '171.34.210.123', '2019-07-07 07:27:56', 11, 2001001000, '服务端发生异常', '2019-07-07 07:27:56');
INSERT INTO `access_log` VALUES (49934, '65.50.15624556925897663', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '171.34.210.123', '2019-07-07 07:28:13', 10, 0, '', '2019-07-07 07:28:13');
INSERT INTO `access_log` VALUES (49935, '65.53.15624556925927641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '171.34.210.123', '2019-07-07 07:28:13', 11, 2001001000, '服务端发生异常', '2019-07-07 07:28:13');
INSERT INTO `access_log` VALUES (49936, '65.54.15624556925967597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.67 Mobile Safari/537.36', '171.34.210.123', '2019-07-07 07:28:13', 10, 0, '', '2019-07-07 07:28:13');
INSERT INTO `access_log` VALUES (49937, '59.80.15624640072246115', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.198', '2019-07-07 09:46:47', 11, 0, '', '2019-07-07 09:46:47');
INSERT INTO `access_log` VALUES (49938, '59.74.15624640072256139', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.196', '2019-07-07 09:46:47', 27, 2001001000, '服务端发生异常', '2019-07-07 09:46:47');
INSERT INTO `access_log` VALUES (49939, '64.85.15624640168636281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.198', '2019-07-07 09:46:57', 13, 0, '', '2019-07-07 09:46:57');
INSERT INTO `access_log` VALUES (49940, '64.78.15624640170376275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.198', '2019-07-07 09:46:57', 2, 0, '', '2019-07-07 09:46:57');
INSERT INTO `access_log` VALUES (49941, '64.84.15624640184616265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.198', '2019-07-07 09:46:58', 2, 0, '', '2019-07-07 09:46:58');
INSERT INTO `access_log` VALUES (49942, '64.76.15624640196226261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.198', '2019-07-07 09:47:00', 2, 0, '', '2019-07-07 09:47:00');
INSERT INTO `access_log` VALUES (49943, '64.83.15624640199056267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.198', '2019-07-07 09:47:00', 2, 0, '', '2019-07-07 09:47:00');
INSERT INTO `access_log` VALUES (49944, '64.81.15624640201326257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.198', '2019-07-07 09:47:00', 2, 0, '', '2019-07-07 09:47:00');
INSERT INTO `access_log` VALUES (49945, '59.71.15624640222216135', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.198', '2019-07-07 09:47:02', 4, 0, '', '2019-07-07 09:47:02');
INSERT INTO `access_log` VALUES (49946, '59.77.15624640222226125', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.196', '2019-07-07 09:47:02', 18, 2001001000, '服务端发生异常', '2019-07-07 09:47:02');
INSERT INTO `access_log` VALUES (49947, '65.49.15624648504087755', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.236.253.160', '2019-07-07 10:00:50', 1, 1002001015, '账号未登陆', '2019-07-07 10:00:50');
INSERT INTO `access_log` VALUES (49948, '65.47.15624648504107739', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.236.253.160', '2019-07-07 10:00:50', 0, 1002001015, '账号未登陆', '2019-07-07 10:00:50');
INSERT INTO `access_log` VALUES (49949, '65.3607.15624648504269561', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.236.253.160', '2019-07-07 10:00:50', 0, 1002001015, '账号未登陆', '2019-07-07 10:00:50');
INSERT INTO `access_log` VALUES (49950, '65.51.15624648527767803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.236.253.160', '2019-07-07 10:00:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 10:00:53');
INSERT INTO `access_log` VALUES (49951, '65.54.15624648724287721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.236.253.160', '2019-07-07 10:01:12', 106, 0, '', '2019-07-07 10:01:13');
INSERT INTO `access_log` VALUES (49952, '65.52.15624648730557797', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.236.253.160', '2019-07-07 10:01:13', 10, 0, '', '2019-07-07 10:01:13');
INSERT INTO `access_log` VALUES (49953, '65.53.15624648730637763', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.236.253.160', '2019-07-07 10:01:13', 10, 2001001000, '服务端发生异常', '2019-07-07 10:01:13');
INSERT INTO `access_log` VALUES (49954, '65.45.15624648730747745', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.236.253.160', '2019-07-07 10:01:13', 9, 0, '', '2019-07-07 10:01:13');
INSERT INTO `access_log` VALUES (49955, '59.80.15624652922756133', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.235.221.243', '2019-07-07 10:08:12', 4, 0, '', '2019-07-07 10:08:12');
INSERT INTO `access_log` VALUES (49956, '59.74.15624652922766157', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.235.221.243', '2019-07-07 10:08:12', 16, 2001001000, '服务端发生异常', '2019-07-07 10:08:12');
INSERT INTO `access_log` VALUES (49957, '64.78.15624652973316293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.235.221.243', '2019-07-07 10:08:17', 4, 0, '', '2019-07-07 10:08:17');
INSERT INTO `access_log` VALUES (49958, '64.84.15624652974206283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.235.221.243', '2019-07-07 10:08:17', 2, 0, '', '2019-07-07 10:08:17');
INSERT INTO `access_log` VALUES (49959, '64.76.15624652989506279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.235.221.243', '2019-07-07 10:08:19', 2, 0, '', '2019-07-07 10:08:19');
INSERT INTO `access_log` VALUES (49960, '64.83.15624652995006285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.235.221.243', '2019-07-07 10:08:20', 2, 0, '', '2019-07-07 10:08:20');
INSERT INTO `access_log` VALUES (49961, '66.53.15624653039024215', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '116.235.221.243', '2019-07-07 10:08:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空', '2019-07-07 10:08:24');
INSERT INTO `access_log` VALUES (49962, '64.79.15624653164106291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.235.221.243', '2019-07-07 10:08:36', 2, 0, '', '2019-07-07 10:08:36');
INSERT INTO `access_log` VALUES (49963, '64.80.15624653164836295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.235.221.243', '2019-07-07 10:08:36', 2, 0, '', '2019-07-07 10:08:36');
INSERT INTO `access_log` VALUES (49964, '59.72.15624653176406149', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.235.221.243', '2019-07-07 10:08:38', 3, 0, '', '2019-07-07 10:08:38');
INSERT INTO `access_log` VALUES (49965, '59.77.15624653176406143', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.235.221.243', '2019-07-07 10:08:38', 16, 2001001000, '服务端发生异常', '2019-07-07 10:08:38');
INSERT INTO `access_log` VALUES (49966, '64.77.15624653292966269', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.235.221.243', '2019-07-07 10:08:49', 5, 1003002003, 'Spu 只能添加在二级分类下', '2019-07-07 10:08:49');
INSERT INTO `access_log` VALUES (49967, '64.78.15624653389236295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.235.221.243', '2019-07-07 10:08:59', 1, 0, '', '2019-07-07 10:08:59');
INSERT INTO `access_log` VALUES (49968, '64.84.15624653390356285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.235.221.243', '2019-07-07 10:08:59', 1, 0, '', '2019-07-07 10:08:59');
INSERT INTO `access_log` VALUES (49969, '59.75.15624653405176163', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.235.221.243', '2019-07-07 10:09:01', 20, 2001001000, '服务端发生异常', '2019-07-07 10:09:01');
INSERT INTO `access_log` VALUES (49970, '59.79.15624653405366157', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.235.221.243', '2019-07-07 10:09:01', 2, 0, '', '2019-07-07 10:09:01');
INSERT INTO `access_log` VALUES (49971, '65.51.15624671640367835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-07 10:39:24', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 10:39:24');
INSERT INTO `access_log` VALUES (49972, '59.73.15624682310236199', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.192', '2019-07-07 10:57:11', 10, 0, '', '2019-07-07 10:57:11');
INSERT INTO `access_log` VALUES (49973, '59.71.15624682310246193', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.192', '2019-07-07 10:57:11', 25, 2001001000, '服务端发生异常', '2019-07-07 10:57:11');
INSERT INTO `access_log` VALUES (49974, '64.82.15624682371846345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.192', '2019-07-07 10:57:17', 14, 0, '', '2019-07-07 10:57:17');
INSERT INTO `access_log` VALUES (49975, '64.79.15624682373456331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.192', '2019-07-07 10:57:17', 4, 0, '', '2019-07-07 10:57:17');
INSERT INTO `access_log` VALUES (49976, '64.80.15624682391396335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.192', '2019-07-07 10:57:19', 2, 0, '', '2019-07-07 10:57:19');
INSERT INTO `access_log` VALUES (49977, '65.54.15624682536227767', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.192', '2019-07-07 10:57:34', 0, 1002001015, '账号未登陆', '2019-07-07 10:57:34');
INSERT INTO `access_log` VALUES (49978, '65.53.15624682536277809', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.192', '2019-07-07 10:57:34', 0, 1002001015, '账号未登陆', '2019-07-07 10:57:34');
INSERT INTO `access_log` VALUES (49979, '65.45.15624682536297791', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.192', '2019-07-07 10:57:34', 0, 1002001015, '账号未登陆', '2019-07-07 10:57:34');
INSERT INTO `access_log` VALUES (49980, '65.52.15624682564127843', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.192', '2019-07-07 10:57:36', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 10:57:36');
INSERT INTO `access_log` VALUES (49981, '65.49.15624682605427803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.192', '2019-07-07 10:57:41', 55, 0, '', '2019-07-07 10:57:41');
INSERT INTO `access_log` VALUES (49982, '65.3607.15624682608989609', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.192', '2019-07-07 10:57:41', 9, 0, '', '2019-07-07 10:57:41');
INSERT INTO `access_log` VALUES (49983, '65.51.15624682609017851', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.192', '2019-07-07 10:57:41', 10, 2001001000, '服务端发生异常', '2019-07-07 10:57:41');
INSERT INTO `access_log` VALUES (49984, '65.46.15624682609067861', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.204.192', '2019-07-07 10:57:41', 9, 0, '', '2019-07-07 10:57:41');
INSERT INTO `access_log` VALUES (49985, '65.50.15624747093337919', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.104.201.222', '2019-07-07 12:45:09', 18, 1002001012, '访问令牌已过期', '2019-07-07 12:45:09');
INSERT INTO `access_log` VALUES (49986, '65.3607.15624747093249695', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.104.201.222', '2019-07-07 12:45:09', 27, 1002001012, '访问令牌已过期', '2019-07-07 12:45:09');
INSERT INTO `access_log` VALUES (49987, '65.46.15624747093257947', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.104.201.222', '2019-07-07 12:45:09', 28, 1002001012, '访问令牌已过期', '2019-07-07 12:45:09');
INSERT INTO `access_log` VALUES (49988, '65.53.15624747163797897', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.104.201.222', '2019-07-07 12:45:16', 98, 0, '', '2019-07-07 12:45:16');
INSERT INTO `access_log` VALUES (49989, '65.54.15624747167787855', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.104.201.222', '2019-07-07 12:45:17', 11, 0, '', '2019-07-07 12:45:17');
INSERT INTO `access_log` VALUES (49990, '65.45.15624747167827879', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.104.201.222', '2019-07-07 12:45:17', 11, 2001001000, '服务端发生异常', '2019-07-07 12:45:17');
INSERT INTO `access_log` VALUES (49991, '65.52.15624747167887933', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.104.201.222', '2019-07-07 12:45:17', 161, 0, '', '2019-07-07 12:45:17');
INSERT INTO `access_log` VALUES (49992, '59.71.15624826011156385', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '171.221.147.94', '2019-07-07 14:56:41', 10, 0, '', '2019-07-07 14:56:41');
INSERT INTO `access_log` VALUES (49993, '59.73.15624826011156391', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '171.221.147.94', '2019-07-07 14:56:41', 12, 2001001000, '服务端发生异常', '2019-07-07 14:56:41');
INSERT INTO `access_log` VALUES (49994, '64.79.15624826067036523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '171.221.147.94', '2019-07-07 14:56:47', 11, 0, '', '2019-07-07 14:56:47');
INSERT INTO `access_log` VALUES (49995, '64.80.15624826068386527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '171.221.147.94', '2019-07-07 14:56:47', 4, 0, '', '2019-07-07 14:56:47');
INSERT INTO `access_log` VALUES (49996, '59.78.15624826105186383', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '171.221.147.94', '2019-07-07 14:56:51', 4, 0, '', '2019-07-07 14:56:51');
INSERT INTO `access_log` VALUES (49997, '59.77.15624826105186375', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '171.221.147.94', '2019-07-07 14:56:51', 33, 2001001000, '服务端发生异常', '2019-07-07 14:56:51');
INSERT INTO `access_log` VALUES (49998, '65.52.15624838524858055', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.82.49.73', '2019-07-07 15:17:32', 1, 1002001015, '账号未登陆', '2019-07-07 15:17:32');
INSERT INTO `access_log` VALUES (49999, '65.47.15624838524867997', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.82.49.73', '2019-07-07 15:17:32', 1, 1002001015, '账号未登陆', '2019-07-07 15:17:32');
INSERT INTO `access_log` VALUES (50000, '65.49.15624838524888013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.82.49.73', '2019-07-07 15:17:32', 0, 1002001015, '账号未登陆', '2019-07-07 15:17:32');
INSERT INTO `access_log` VALUES (50001, '65.51.15624838571768063', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.82.49.73', '2019-07-07 15:17:37', 124, 0, '', '2019-07-07 15:17:37');
INSERT INTO `access_log` VALUES (50002, '65.50.15624838573088043', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '171.221.147.94', '2019-07-07 15:17:37', 0, 1002001015, '账号未登陆', '2019-07-07 15:17:37');
INSERT INTO `access_log` VALUES (50003, '65.3607.15624838573099819', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '171.221.147.94', '2019-07-07 15:17:37', 1, 1002001015, '账号未登陆', '2019-07-07 15:17:37');
INSERT INTO `access_log` VALUES (50004, '65.46.15624838573188071', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '171.221.147.94', '2019-07-07 15:17:37', 0, 1002001015, '账号未登陆', '2019-07-07 15:17:37');
INSERT INTO `access_log` VALUES (50005, '65.53.15624838574818021', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.82.49.73', '2019-07-07 15:17:37', 127, 0, '', '2019-07-07 15:17:38');
INSERT INTO `access_log` VALUES (50006, '65.45.15624838574868003', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.82.49.73', '2019-07-07 15:17:37', 123, 0, '', '2019-07-07 15:17:38');
INSERT INTO `access_log` VALUES (50007, '65.54.15624838574857979', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.82.49.73', '2019-07-07 15:17:37', 124, 2001001000, '服务端发生异常', '2019-07-07 15:17:38');
INSERT INTO `access_log` VALUES (50008, '65.49.15624838601958015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '171.221.147.94', '2019-07-07 15:17:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 15:17:40');
INSERT INTO `access_log` VALUES (50009, '65.47.15624838676187999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '171.221.147.94', '2019-07-07 15:17:48', 78, 0, '', '2019-07-07 15:17:48');
INSERT INTO `access_log` VALUES (50010, '65.50.15624838679668045', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '171.221.147.94', '2019-07-07 15:17:48', 76, 0, '', '2019-07-07 15:17:48');
INSERT INTO `access_log` VALUES (50011, '65.46.15624838679748073', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '171.221.147.94', '2019-07-07 15:17:48', 69, 0, '', '2019-07-07 15:17:48');
INSERT INTO `access_log` VALUES (50012, '65.3607.15624838679719821', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '171.221.147.94', '2019-07-07 15:17:48', 73, 2001001000, '服务端发生异常', '2019-07-07 15:17:48');
INSERT INTO `access_log` VALUES (50013, '65.51.15624838723948065', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.82.49.73', '2019-07-07 15:17:52', 16, 0, '', '2019-07-07 15:17:52');
INSERT INTO `access_log` VALUES (50014, '65.54.15624838723957981', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.82.49.73', '2019-07-07 15:17:52', 15, 2001001000, '服务端发生异常', '2019-07-07 15:17:52');
INSERT INTO `access_log` VALUES (50015, '65.53.15624838723968023', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.82.49.73', '2019-07-07 15:17:52', 15, 0, '', '2019-07-07 15:17:52');
INSERT INTO `access_log` VALUES (50016, '65.45.15624838729418005', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.82.49.73', '2019-07-07 15:17:53', 9, 0, '', '2019-07-07 15:17:53');
INSERT INTO `access_log` VALUES (50017, '65.49.15624838729798017', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.82.49.73', '2019-07-07 15:17:53', 9, 0, '', '2019-07-07 15:17:53');
INSERT INTO `access_log` VALUES (50018, '65.52.15624838729788059', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.82.49.73', '2019-07-07 15:17:53', 10, 2001001000, '服务端发生异常', '2019-07-07 15:17:53');
INSERT INTO `access_log` VALUES (50019, '59.78.15624851389056417', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:38:59', 11, 0, '', '2019-07-07 15:38:59');
INSERT INTO `access_log` VALUES (50020, '59.77.15624851389946409', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:38:59', 15, 2001001000, '服务端发生异常', '2019-07-07 15:38:59');
INSERT INTO `access_log` VALUES (50021, '64.84.15624851910246551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:39:51', 74, 0, '', '2019-07-07 15:39:51');
INSERT INTO `access_log` VALUES (50022, '64.76.15624851912846547', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:39:51', 3, 0, '', '2019-07-07 15:39:51');
INSERT INTO `access_log` VALUES (50023, '64.83.15624851926046553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:39:53', 2, 0, '', '2019-07-07 15:39:53');
INSERT INTO `access_log` VALUES (50024, '64.81.15624851933046543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:39:53', 2, 0, '', '2019-07-07 15:39:53');
INSERT INTO `access_log` VALUES (50025, '64.82.15624851944246573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:39:54', 2, 0, '', '2019-07-07 15:39:54');
INSERT INTO `access_log` VALUES (50026, '64.79.15624851949746559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:39:55', 3, 0, '', '2019-07-07 15:39:55');
INSERT INTO `access_log` VALUES (50027, '59.80.15624851963946401', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:39:56', 4, 0, '', '2019-07-07 15:39:56');
INSERT INTO `access_log` VALUES (50028, '59.71.15624851963956421', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:39:56', 14, 2001001000, '服务端发生异常', '2019-07-07 15:39:56');
INSERT INTO `access_log` VALUES (50029, '64.80.15624851995246563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:40:00', 1, 0, '', '2019-07-07 15:40:00');
INSERT INTO `access_log` VALUES (50030, '64.77.15624851997246537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:40:00', 1, 0, '', '2019-07-07 15:40:00');
INSERT INTO `access_log` VALUES (50031, '65.53.15624852764608043', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:41:16', 0, 1002001015, '账号未登陆', '2019-07-07 15:41:16');
INSERT INTO `access_log` VALUES (50032, '65.54.15624852764608001', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:41:16', 0, 1002001015, '账号未登陆', '2019-07-07 15:41:16');
INSERT INTO `access_log` VALUES (50033, '65.51.15624852764598085', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:41:16', 0, 1002001015, '账号未登陆', '2019-07-07 15:41:16');
INSERT INTO `access_log` VALUES (50034, '65.54.15624853804598003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:43:00', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 15:43:00');
INSERT INTO `access_log` VALUES (50035, '65.53.15624853877888045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:43:08', 77, 0, '', '2019-07-07 15:43:08');
INSERT INTO `access_log` VALUES (50036, '65.51.15624853882788087', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:43:08', 26, 0, '', '2019-07-07 15:43:08');
INSERT INTO `access_log` VALUES (50037, '65.45.15624853882788027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:43:08', 28, 2001001000, '服务端发生异常', '2019-07-07 15:43:08');
INSERT INTO `access_log` VALUES (50038, '65.52.15624853883378081', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.64.150', '2019-07-07 15:43:08', 10, 0, '', '2019-07-07 15:43:08');
INSERT INTO `access_log` VALUES (50039, '2ac541fb-9695-4203-a723-8387a0d866e9', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 15:57:06', 2032, 1002001012, '访问令牌已过期', '2019-07-07 15:57:08');
INSERT INTO `access_log` VALUES (50040, 'be16f2d6-a6bd-469f-b8a1-38914e3ffa8e', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 15:57:06', 2032, 1002001012, '访问令牌已过期', '2019-07-07 15:57:08');
INSERT INTO `access_log` VALUES (50041, '8076aa4c-6fb0-42c6-a709-ac40d16c2884', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 15:57:06', 2032, 1002001012, '访问令牌已过期', '2019-07-07 15:57:08');
INSERT INTO `access_log` VALUES (50042, '006ab988-7f7b-4a98-ab4b-5bc625a128c2', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 15:57:19', 870, 1002002001, '密码不正确', '2019-07-07 15:57:20');
INSERT INTO `access_log` VALUES (50043, '1ca685bb-55ef-4359-bc3f-82c7a3f6dc4c', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 15:57:37', 561, 0, '', '2019-07-07 15:57:37');
INSERT INTO `access_log` VALUES (50044, '17991c6f-86de-45a2-911e-a88ea77fbfdb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 15:57:38', 554, 0, '', '2019-07-07 15:57:38');
INSERT INTO `access_log` VALUES (50045, 'c5014910-bac8-41f0-bacc-1ad54beb4d28', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 15:57:38', 535, 0, '', '2019-07-07 15:57:38');
INSERT INTO `access_log` VALUES (50046, 'e5efd078-66ee-4732-a4a1-f27478238239', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 15:57:38', 435, 0, '', '2019-07-07 15:57:39');
INSERT INTO `access_log` VALUES (50047, '5acd4ec7-763c-433c-9ff8-ff7a1c9184ac', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:01:30', 2840, 2001001000, '服务端发生异常', '2019-07-07 16:01:33');
INSERT INTO `access_log` VALUES (50048, '28151afa-0ad5-4555-ba75-b652e833e158', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:01:31', 3893, 0, '', '2019-07-07 16:01:34');
INSERT INTO `access_log` VALUES (50049, '5ac0e490-47d9-4c4c-91b2-deb49f3cb537', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:01:42', 841, 0, '', '2019-07-07 16:01:42');
INSERT INTO `access_log` VALUES (50050, 'b758aed8-cca0-42ef-9f9d-86ac467fccb5', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:01:46', 280, 0, '', '2019-07-07 16:01:46');
INSERT INTO `access_log` VALUES (50051, '3cf8e2ae-d22e-4048-af74-d8e9ca2a7e51', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:01:49', 136, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-07 16:01:50');
INSERT INTO `access_log` VALUES (50052, 'd1e6aae9-5519-477a-85b5-5fb049b3e565', 1, 2, 'order-impl', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:02:06', 3223, 0, '', '2019-07-07 16:02:09');
INSERT INTO `access_log` VALUES (50053, '59.73.15624865491096445', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.3.243', '2019-07-07 16:02:29', 2, 0, '', '2019-07-07 16:02:29');
INSERT INTO `access_log` VALUES (50054, '59.72.15624865491136435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.3.243', '2019-07-07 16:02:29', 12, 2001001000, '服务端发生异常', '2019-07-07 16:02:29');
INSERT INTO `access_log` VALUES (50055, '59.77.15624865600706429', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '121.35.3.243', '2019-07-07 16:02:40', 2, 0, '', '2019-07-07 16:02:40');
INSERT INTO `access_log` VALUES (50056, '59.75.15624865600716449', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '121.35.3.243', '2019-07-07 16:02:40', 11, 2001001000, '服务端发生异常', '2019-07-07 16:02:40');
INSERT INTO `access_log` VALUES (50057, '43211039-e847-4f9d-8061-a7d1704a87a7', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:03:45', 986, 2001001000, '服务端发生异常', '2019-07-07 16:03:46');
INSERT INTO `access_log` VALUES (50058, '6f1fe02c-6a34-4cb8-a477-3b8d6821a848', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:04:30', 519, 0, '', '2019-07-07 16:04:30');
INSERT INTO `access_log` VALUES (50059, '3994bd66-b76d-4cbc-a312-296d03df40b0', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:04:37', 527, 0, '', '2019-07-07 16:04:37');
INSERT INTO `access_log` VALUES (50060, 'e3dca42e-8118-44c1-b0af-93dd905a850a', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:04:40', 291, 0, '', '2019-07-07 16:04:40');
INSERT INTO `access_log` VALUES (50061, '7dde8ce7-7765-46c1-aa75-b54c651ac4d1', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:04:41', 270, 0, '', '2019-07-07 16:04:41');
INSERT INTO `access_log` VALUES (50062, '775645cb-5a4a-4272-bf98-030cb83b36d3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:04:43', 271, 0, '', '2019-07-07 16:04:43');
INSERT INTO `access_log` VALUES (50063, '8c8de55a-9efb-47e0-9e4b-8dba3956d47a', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:04:48', 5136, 0, '', '2019-07-07 16:04:53');
INSERT INTO `access_log` VALUES (50064, 'e8faa680-0820-487a-aaa7-a92211cc7cd6', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:04:48', 5109, 2001001000, '服务端发生异常', '2019-07-07 16:04:53');
INSERT INTO `access_log` VALUES (50065, 'f9b47018-b4c9-4b38-963c-5ba7f3b57b1f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:05:00', 353, 0, '', '2019-07-07 16:05:00');
INSERT INTO `access_log` VALUES (50066, 'af3a974d-b95c-46a9-aeab-0dedb0d7af0d', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:05:00', 2729, 0, '', '2019-07-07 16:05:03');
INSERT INTO `access_log` VALUES (50067, 'b4904fc9-0996-4cf3-87f8-420caf780cf3', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:05:11', 301, 0, '', '2019-07-07 16:05:11');
INSERT INTO `access_log` VALUES (50068, '6bc3f005-d903-452b-b409-4368f43554a4', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:05:17', 248, 0, '', '2019-07-07 16:05:17');
INSERT INTO `access_log` VALUES (50069, '2bac37c1-287f-4e16-bf99-83f8bba1197a', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:06:07', 173, 0, '', '2019-07-07 16:06:07');
INSERT INTO `access_log` VALUES (50070, '59.71.15624867706666443', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:06:11', 3, 0, '', '2019-07-07 16:06:11');
INSERT INTO `access_log` VALUES (50071, '59.73.15624867706676449', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:06:11', 9, 2001001000, '服务端发生异常', '2019-07-07 16:06:11');
INSERT INTO `access_log` VALUES (50072, '9154c665-f361-40fa-b105-b96ed19b0f83', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:06:28', 191, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-07 16:06:28');
INSERT INTO `access_log` VALUES (50073, '64.82.15624867883426595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:06:28', 3, 0, '', '2019-07-07 16:06:28');
INSERT INTO `access_log` VALUES (50074, '64.79.15624867885356581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:06:29', 2, 0, '', '2019-07-07 16:06:29');
INSERT INTO `access_log` VALUES (50075, '0429e56b-4bd7-42ed-bf0b-cff99fe7e36a', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:06:35', 577, 0, '', '2019-07-07 16:06:35');
INSERT INTO `access_log` VALUES (50076, '64.77.15624868059216559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:06:46', 2, 0, '', '2019-07-07 16:06:46');
INSERT INTO `access_log` VALUES (50077, '64.85.15624868060706591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:06:46', 1, 0, '', '2019-07-07 16:06:46');
INSERT INTO `access_log` VALUES (50078, '64.78.15624868072946585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:06:47', 2, 0, '', '2019-07-07 16:06:47');
INSERT INTO `access_log` VALUES (50079, '64.84.15624868079836575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:06:48', 2, 0, '', '2019-07-07 16:06:48');
INSERT INTO `access_log` VALUES (50080, '64.83.15624868115976577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:06:52', 2, 0, '', '2019-07-07 16:06:52');
INSERT INTO `access_log` VALUES (50081, '64.81.15624868119426567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:06:52', 2, 0, '', '2019-07-07 16:06:52');
INSERT INTO `access_log` VALUES (50082, '64.82.15624868145716597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:06:55', 2, 0, '', '2019-07-07 16:06:55');
INSERT INTO `access_log` VALUES (50083, '64.79.15624868147026583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:06:55', 2, 0, '', '2019-07-07 16:06:55');
INSERT INTO `access_log` VALUES (50084, '59.79.15624868291076447', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:07:09', 2, 0, '', '2019-07-07 16:07:09');
INSERT INTO `access_log` VALUES (50085, '59.76.15624868291106437', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:07:09', 15, 2001001000, '服务端发生异常', '2019-07-07 16:07:09');
INSERT INTO `access_log` VALUES (50086, '64.77.15624868315006561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:07:12', 2, 0, '', '2019-07-07 16:07:12');
INSERT INTO `access_log` VALUES (50087, '64.85.15624868316566593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.219.99.248', '2019-07-07 16:07:12', 1, 0, '', '2019-07-07 16:07:12');
INSERT INTO `access_log` VALUES (50088, '67d6d2ab-d65c-4a69-b21e-2ce38f99d251', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:07:13', 212, 0, '', '2019-07-07 16:07:13');
INSERT INTO `access_log` VALUES (50089, '805ca918-afbe-43e2-b981-486494279da3', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:07:29', 212, 0, '', '2019-07-07 16:07:29');
INSERT INTO `access_log` VALUES (50090, 'a8e768d8-ee81-414c-9062-74fdef70fa7d', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:07:40', 140, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-07 16:07:40');
INSERT INTO `access_log` VALUES (50091, '52108c55-3c40-40b4-a636-88f2c7019da1', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:09:48', 378, 0, '', '2019-07-07 16:09:49');
INSERT INTO `access_log` VALUES (50092, 'e5a203c5-7764-4564-802f-c0f08f6151af', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:09:48', 404, 0, '', '2019-07-07 16:09:49');
INSERT INTO `access_log` VALUES (50093, '65.50.15624870392418091', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.3.243', '2019-07-07 16:10:39', 0, 1002001015, '账号未登陆', '2019-07-07 16:10:39');
INSERT INTO `access_log` VALUES (50094, '65.49.15624870392488063', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.3.243', '2019-07-07 16:10:39', 0, 1002001015, '账号未登陆', '2019-07-07 16:10:39');
INSERT INTO `access_log` VALUES (50095, '65.52.15624870392578105', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.3.243', '2019-07-07 16:10:39', 0, 1002001015, '账号未登陆', '2019-07-07 16:10:39');
INSERT INTO `access_log` VALUES (50096, '65.51.15624870414418111', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.3.243', '2019-07-07 16:10:41', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 16:10:41');
INSERT INTO `access_log` VALUES (50097, '65.53.15624870454268069', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.3.243', '2019-07-07 16:10:45', 69, 0, '', '2019-07-07 16:10:45');
INSERT INTO `access_log` VALUES (50098, '65.47.15624870457018047', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.3.243', '2019-07-07 16:10:46', 9, 0, '', '2019-07-07 16:10:46');
INSERT INTO `access_log` VALUES (50099, '65.45.15624870457028051', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.3.243', '2019-07-07 16:10:46', 10, 2001001000, '服务端发生异常', '2019-07-07 16:10:46');
INSERT INTO `access_log` VALUES (50100, '65.3607.15624870457079867', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.3.243', '2019-07-07 16:10:46', 9, 0, '', '2019-07-07 16:10:46');
INSERT INTO `access_log` VALUES (50101, 'db0072eb-4bc6-4c00-9025-3470114867e8', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:11:15', 38095, 0, '', '2019-07-07 16:11:53');
INSERT INTO `access_log` VALUES (50102, '5fd093b3-1762-4af4-813d-3b599b5ba453', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:12:12', 179, 0, '', '2019-07-07 16:12:13');
INSERT INTO `access_log` VALUES (50103, '59.77.15624882705656453', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.15.244', '2019-07-07 16:31:11', 3, 0, '', '2019-07-07 16:31:11');
INSERT INTO `access_log` VALUES (50104, '59.75.15624882705676473', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.15.244', '2019-07-07 16:31:11', 12, 2001001000, '服务端发生异常', '2019-07-07 16:31:11');
INSERT INTO `access_log` VALUES (50105, '64.79.15624882762226603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.15.244', '2019-07-07 16:31:16', 2, 0, '', '2019-07-07 16:31:16');
INSERT INTO `access_log` VALUES (50106, '64.80.15624882763636607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.15.244', '2019-07-07 16:31:16', 2, 0, '', '2019-07-07 16:31:16');
INSERT INTO `access_log` VALUES (50107, '64.85.15624882818556613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.15.244', '2019-07-07 16:31:22', 2, 0, '', '2019-07-07 16:31:22');
INSERT INTO `access_log` VALUES (50108, '64.78.15624882819616607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.15.244', '2019-07-07 16:31:22', 1, 0, '', '2019-07-07 16:31:22');
INSERT INTO `access_log` VALUES (50109, '59.76.15624882876436457', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.15.244', '2019-07-07 16:31:28', 3, 0, '', '2019-07-07 16:31:28');
INSERT INTO `access_log` VALUES (50110, '59.74.15624882876436469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.15.244', '2019-07-07 16:31:28', 42, 2001001000, '服务端发生异常', '2019-07-07 16:31:28');
INSERT INTO `access_log` VALUES (50111, 'fb30f2a3-9c6e-4b47-abcc-7b73022af6b6', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:46:53', 1152, 1002001012, '访问令牌已过期', '2019-07-07 16:46:55');
INSERT INTO `access_log` VALUES (50112, 'ee84ed30-61c8-4fe1-86ed-880390063dfe', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:47:00', 649, 0, '', '2019-07-07 16:47:01');
INSERT INTO `access_log` VALUES (50113, 'd0bf2400-d21d-49fc-b924-340229636bd2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:47:01', 288, 0, '', '2019-07-07 16:47:02');
INSERT INTO `access_log` VALUES (50114, '11a1dd2a-d2d0-42cc-b507-eef307286c8e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:47:01', 319, 0, '', '2019-07-07 16:47:02');
INSERT INTO `access_log` VALUES (50115, '30f13691-1261-4eab-a308-c355d8c30e4a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:47:02', 295, 0, '', '2019-07-07 16:47:02');
INSERT INTO `access_log` VALUES (50116, 'b5b3c5e1-3358-4cb3-9343-7cac02d6389e', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:47:06', 749, 0, '', '2019-07-07 16:47:07');
INSERT INTO `access_log` VALUES (50117, 'ffd38a7e-ec59-4e7f-9947-d0371beb2f37', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:47:16', 169, 0, '', '2019-07-07 16:47:16');
INSERT INTO `access_log` VALUES (50118, '40e7a92b-e011-4eef-b17f-f6d507e153e7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:47:18', 245, 0, '', '2019-07-07 16:47:18');
INSERT INTO `access_log` VALUES (50119, 'e30056f0-fa86-4409-bf87-95800d360d7e', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:47:31', 169, 0, '', '2019-07-07 16:47:31');
INSERT INTO `access_log` VALUES (50120, '82df53aa-41e7-4e5d-8b21-8062011ab82a', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:47:54', 3241, 0, '', '2019-07-07 16:47:57');
INSERT INTO `access_log` VALUES (50121, 'dc4c5ffc-8961-4910-a554-74429d2312cc', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:50:58', 200, 0, '', '2019-07-07 16:50:58');
INSERT INTO `access_log` VALUES (50122, 'fa6ef384-36b2-4fda-9a41-050d73f47e2b', 1, 2, 'admin-application', '/admin-api/admins/resource/add', 'type=1&displayName=拼团管理&pid=23&sort=6&icon=user', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:51:47', 430, 0, '', '2019-07-07 16:51:47');
INSERT INTO `access_log` VALUES (50123, 'ca61a2d2-e6d4-43b2-ae20-a6e95b867908', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:51:48', 167, 0, '', '2019-07-07 16:51:48');
INSERT INTO `access_log` VALUES (50124, '1e09de71-b27f-41bc-a4cf-76eee98e1f04', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=54&type=1&sort=6&displayName=拼团管理&pid=23&icon= &createTime=2019-07-07T08:51:47.000+0000', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:52:30', 386, 0, '', '2019-07-07 16:52:31');
INSERT INTO `access_log` VALUES (50125, '599d6ccc-1036-422f-a1ec-37443d6de3ed', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:52:31', 165, 0, '', '2019-07-07 16:52:31');
INSERT INTO `access_log` VALUES (50126, 'befe0083-3a69-4407-9184-d2512ef40df2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:52:45', 164, 0, '', '2019-07-07 16:52:45');
INSERT INTO `access_log` VALUES (50127, '1188af31-90f9-4c32-9a81-214905f4edd5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:52:45', 200, 0, '', '2019-07-07 16:52:45');
INSERT INTO `access_log` VALUES (50128, '955e1ff7-dfa3-467a-8851-0fae35cf9c7a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:52:45', 199, 0, '', '2019-07-07 16:52:45');
INSERT INTO `access_log` VALUES (50129, '5ac8fe18-a073-4db9-86ba-bd3734e47122', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:52:45', 155, 0, '', '2019-07-07 16:52:46');
INSERT INTO `access_log` VALUES (50130, '2873995b-291d-4ca2-a429-8983ee5fe431', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=54&type=1&sort=6&displayName=拼团购&pid=23&handler=/promotion/group-buy-list&icon= &createTime=2019-07-07T08:51:47.000+0000', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:54:53', 390, 0, '', '2019-07-07 16:54:53');
INSERT INTO `access_log` VALUES (50131, 'e56a849f-6e33-48a2-b84f-f8d8ae5ac1f0', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:54:54', 155, 0, '', '2019-07-07 16:54:54');
INSERT INTO `access_log` VALUES (50132, 'e67499db-35e6-41e9-bc0e-7e6e579050b4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:57:18', 235, 0, '', '2019-07-07 16:57:18');
INSERT INTO `access_log` VALUES (50133, 'cce5bc39-2c43-4ac3-9930-5d887e29976b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:57:18', 272, 0, '', '2019-07-07 16:57:19');
INSERT INTO `access_log` VALUES (50134, '92c0c708-0c9e-416a-adaf-56961b8157df', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:57:18', 245, 0, '', '2019-07-07 16:57:18');
INSERT INTO `access_log` VALUES (50135, '66466286-5e1e-493b-b0d2-403cac8bc3f3', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:57:18', 614, 0, '', '2019-07-07 16:57:19');
INSERT INTO `access_log` VALUES (50136, 'd4f6c00d-a6be-4901-97d1-2995f58ab18d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:58:07', 195, 0, '', '2019-07-07 16:58:07');
INSERT INTO `access_log` VALUES (50137, '64d2be1d-c62b-408a-974b-13c7d7239ab9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:58:07', 162, 0, '', '2019-07-07 16:58:07');
INSERT INTO `access_log` VALUES (50138, '7f34f3fd-863b-43c9-ad27-8a14094a35b5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:58:07', 201, 0, '', '2019-07-07 16:58:07');
INSERT INTO `access_log` VALUES (50139, 'ef52ad52-693e-4e2f-bde0-de364626f3d5', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:58:09', 165, 0, '', '2019-07-07 16:58:09');
INSERT INTO `access_log` VALUES (50140, '65.49.15624905288038111', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.227.200.95', '2019-07-07 17:08:49', 0, 1002001015, '账号未登陆', '2019-07-07 17:08:49');
INSERT INTO `access_log` VALUES (50141, '65.50.15624905288038139', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.227.200.95', '2019-07-07 17:08:49', 0, 1002001015, '账号未登陆', '2019-07-07 17:08:49');
INSERT INTO `access_log` VALUES (50142, '65.52.15624905288048153', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.227.200.95', '2019-07-07 17:08:49', 1, 1002001015, '账号未登陆', '2019-07-07 17:08:49');
INSERT INTO `access_log` VALUES (50143, '65.51.15624905322718159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.227.200.95', '2019-07-07 17:08:52', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 17:08:52');
INSERT INTO `access_log` VALUES (50144, '65.45.15624905502678099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.227.200.95', '2019-07-07 17:09:10', 70, 0, '', '2019-07-07 17:09:10');
INSERT INTO `access_log` VALUES (50145, '65.3607.15624905507619915', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.227.200.95', '2019-07-07 17:09:11', 10, 0, '', '2019-07-07 17:09:11');
INSERT INTO `access_log` VALUES (50146, '65.46.15624905507708167', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.227.200.95', '2019-07-07 17:09:11', 9, 2001001000, '服务端发生异常', '2019-07-07 17:09:11');
INSERT INTO `access_log` VALUES (50147, '65.54.15624905508458077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.227.200.95', '2019-07-07 17:09:11', 11, 0, '', '2019-07-07 17:09:11');
INSERT INTO `access_log` VALUES (50148, '59.80.15624911422376483', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:02', 13, 0, '', '2019-07-07 17:19:02');
INSERT INTO `access_log` VALUES (50149, '59.71.15624911422376503', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:02', 22, 2001001000, '服务端发生异常', '2019-07-07 17:19:02');
INSERT INTO `access_log` VALUES (50150, '64.84.15624911423746635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:02', 11, 0, '', '2019-07-07 17:19:02');
INSERT INTO `access_log` VALUES (50151, '64.76.15624911425046631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:03', 9, 0, '', '2019-07-07 17:19:03');
INSERT INTO `access_log` VALUES (50152, '64.81.15624911486906627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:09', 2, 0, '', '2019-07-07 17:19:09');
INSERT INTO `access_log` VALUES (50153, '64.82.15624911488306657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:09', 2, 0, '', '2019-07-07 17:19:09');
INSERT INTO `access_log` VALUES (50154, '59.72.15624911530496499', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:13', 3, 0, '', '2019-07-07 17:19:13');
INSERT INTO `access_log` VALUES (50155, '59.78.15624911530786501', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:13', 12, 2001001000, '服务端发生异常', '2019-07-07 17:19:13');
INSERT INTO `access_log` VALUES (50156, '64.79.15624911550116643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:15', 2, 0, '', '2019-07-07 17:19:15');
INSERT INTO `access_log` VALUES (50157, '64.80.15624911551626647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:15', 1, 0, '', '2019-07-07 17:19:15');
INSERT INTO `access_log` VALUES (50158, '64.77.15624911567446621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:17', 2, 0, '', '2019-07-07 17:19:17');
INSERT INTO `access_log` VALUES (50159, '64.85.15624911573406653', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:17', 2, 0, '', '2019-07-07 17:19:17');
INSERT INTO `access_log` VALUES (50160, '64.78.15624911577446647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:18', 1, 0, '', '2019-07-07 17:19:18');
INSERT INTO `access_log` VALUES (50161, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=好&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:26', 5, 0, '', '2019-07-07 17:19:26');
INSERT INTO `access_log` VALUES (50162, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=好', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:26', 5, 0, '', '2019-07-07 17:19:26');
INSERT INTO `access_log` VALUES (50163, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=手机&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:33', 6, 0, '', '2019-07-07 17:19:33');
INSERT INTO `access_log` VALUES (50164, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=手机', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:33', 9, 0, '', '2019-07-07 17:19:33');
INSERT INTO `access_log` VALUES (50165, '64.83.15624911792166639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:39', 1, 0, '', '2019-07-07 17:19:39');
INSERT INTO `access_log` VALUES (50166, '64.81.15624911793316629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:39', 2, 0, '', '2019-07-07 17:19:39');
INSERT INTO `access_log` VALUES (50167, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=小米&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:46', 7, 0, '', '2019-07-07 17:19:46');
INSERT INTO `access_log` VALUES (50168, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=小米', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:46', 10, 0, '', '2019-07-07 17:19:46');
INSERT INTO `access_log` VALUES (50169, '64.79.15624911918576645', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '106.114.187.52', '2019-07-07 17:19:52', 23, 0, '', '2019-07-07 17:19:52');
INSERT INTO `access_log` VALUES (50170, 'd05d4680-ad84-4695-ad59-4af09360fbf5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 17:24:02', 1846, 0, '', '2019-07-07 17:24:04');
INSERT INTO `access_log` VALUES (50171, '8e0883fa-c39c-4672-a8d7-8d6ac4db7a0d', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 17:24:02', 1579, 0, '', '2019-07-07 17:24:04');
INSERT INTO `access_log` VALUES (50172, '7858d15f-f27e-4030-9f3e-f4e3bc995b3b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 17:24:02', 2037, 0, '', '2019-07-07 17:24:04');
INSERT INTO `access_log` VALUES (50173, '69b9b5a7-2756-4e7b-8150-a9c282eb93c1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 17:24:02', 2038, 0, '', '2019-07-07 17:24:04');
INSERT INTO `access_log` VALUES (50174, 'd74329c0-a329-43e8-a808-4255937805f8', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 17:39:46', 2264, 1002001012, '访问令牌已过期', '2019-07-07 17:39:48');
INSERT INTO `access_log` VALUES (50175, '8563403f-27d3-482c-8ac0-ed76a93e9db3', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 17:42:00', 412, 0, '', '2019-07-07 17:42:00');
INSERT INTO `access_log` VALUES (50176, '220c882f-4b4e-4d8c-9eb6-f965e4f06d85', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 17:42:01', 161, 0, '', '2019-07-07 17:42:01');
INSERT INTO `access_log` VALUES (50177, '00e48187-0baa-4b15-b597-a098028c0c8d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 17:42:01', 200, 0, '', '2019-07-07 17:42:01');
INSERT INTO `access_log` VALUES (50178, 'd2a85b17-cb73-41e7-9659-aaf2cf8d2594', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 17:42:01', 166, 0, '', '2019-07-07 17:42:01');
INSERT INTO `access_log` VALUES (50179, '59.78.15624933861226531', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:26', 14, 0, '', '2019-07-07 17:56:26');
INSERT INTO `access_log` VALUES (50180, '59.75.15624933861236543', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:26', 18, 2001001000, '服务端发生异常', '2019-07-07 17:56:26');
INSERT INTO `access_log` VALUES (50181, '64.83.15624933931686669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:33', 11, 0, '', '2019-07-07 17:56:33');
INSERT INTO `access_log` VALUES (50182, '64.81.15624933932736659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:33', 3, 0, '', '2019-07-07 17:56:33');
INSERT INTO `access_log` VALUES (50183, '64.79.15624933976516675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:38', 2, 0, '', '2019-07-07 17:56:38');
INSERT INTO `access_log` VALUES (50184, '64.80.15624933977826679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:38', 2, 0, '', '2019-07-07 17:56:38');
INSERT INTO `access_log` VALUES (50185, '59.79.15624933994686537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:39', 3, 0, '', '2019-07-07 17:56:39');
INSERT INTO `access_log` VALUES (50186, '59.76.15624933994706527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:39', 15, 2001001000, '服务端发生异常', '2019-07-07 17:56:39');
INSERT INTO `access_log` VALUES (50187, '64.77.15624934090236653', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:49', 1, 0, '', '2019-07-07 17:56:49');
INSERT INTO `access_log` VALUES (50188, '64.85.15624934091166685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:49', 2, 0, '', '2019-07-07 17:56:49');
INSERT INTO `access_log` VALUES (50189, '64.84.15624934108826669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:51', 3, 0, '', '2019-07-07 17:56:51');
INSERT INTO `access_log` VALUES (50190, '64.76.15624934114876665', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:51', 2, 0, '', '2019-07-07 17:56:51');
INSERT INTO `access_log` VALUES (50191, '59.80.15624934130686515', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:53', 2, 0, '', '2019-07-07 17:56:53');
INSERT INTO `access_log` VALUES (50192, '59.71.15624934130686535', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:53', 11, 2001001000, '服务端发生异常', '2019-07-07 17:56:53');
INSERT INTO `access_log` VALUES (50193, '64.83.15624934175066671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:58', 2, 0, '', '2019-07-07 17:56:58');
INSERT INTO `access_log` VALUES (50194, '64.81.15624934176316661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:58', 1, 0, '', '2019-07-07 17:56:58');
INSERT INTO `access_log` VALUES (50195, '64.82.15624934184386691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:56:58', 2, 0, '', '2019-07-07 17:56:58');
INSERT INTO `access_log` VALUES (50196, '66.54.15624934298794589', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18621093656', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:57:10', 62, 0, '', '2019-07-07 17:57:10');
INSERT INTO `access_log` VALUES (50197, '66.57.15624934404214585', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18621093656&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:57:20', 458, 0, '', '2019-07-07 17:57:21');
INSERT INTO `access_log` VALUES (50198, '64.85.15624934466996687', 159, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:57:27', 8, 0, '', '2019-07-07 17:57:27');
INSERT INTO `access_log` VALUES (50199, '64.84.15624934468506671', 159, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:57:27', 9, 0, '', '2019-07-07 17:57:27');
INSERT INTO `access_log` VALUES (50200, '66.53.15624934491994591', 159, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:57:29', 7, 0, '', '2019-07-07 17:57:29');
INSERT INTO `access_log` VALUES (50201, '66.52.15624934624604579', 159, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:57:42', 5, 0, '', '2019-07-07 17:57:42');
INSERT INTO `access_log` VALUES (50202, '66.48.15624934673424599', 159, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:57:47', 6, 0, '', '2019-07-07 17:57:47');
INSERT INTO `access_log` VALUES (50203, '66.50.15624934681714583', 159, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:57:48', 7, 0, '', '2019-07-07 17:57:48');
INSERT INTO `access_log` VALUES (50204, '66.49.15624934802844603', 159, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:58:00', 6, 0, '', '2019-07-07 17:58:00');
INSERT INTO `access_log` VALUES (50205, '59.76.15624934822136529', 159, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:58:02', 12, 0, '', '2019-07-07 17:58:02');
INSERT INTO `access_log` VALUES (50206, '59.74.15624934836046541', 159, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:58:04', 7, 0, '', '2019-07-07 17:58:04');
INSERT INTO `access_log` VALUES (50207, '59.73.15624934946976543', 159, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:58:15', 6, 0, '', '2019-07-07 17:58:15');
INSERT INTO `access_log` VALUES (50208, '66.55.15624934979064569', 159, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 17:58:18', 6, 0, '', '2019-07-07 17:58:18');
INSERT INTO `access_log` VALUES (50209, '65.54.15624936864658119', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 18:01:26', 1, 1002001015, '账号未登陆', '2019-07-07 18:01:26');
INSERT INTO `access_log` VALUES (50210, '65.50.15624936864658183', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 18:01:26', 1, 1002001015, '账号未登陆', '2019-07-07 18:01:26');
INSERT INTO `access_log` VALUES (50211, '65.49.15624936864838155', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 18:01:26', 0, 1002001015, '账号未登陆', '2019-07-07 18:01:26');
INSERT INTO `access_log` VALUES (50212, '65.52.15624936917338197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 18:01:32', 234, 0, '', '2019-07-07 18:01:32');
INSERT INTO `access_log` VALUES (50213, '65.51.15624936922568203', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 18:01:32', 11, 0, '', '2019-07-07 18:01:32');
INSERT INTO `access_log` VALUES (50214, '65.53.15624936923038161', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 18:01:32', 11, 2001001000, '服务端发生异常', '2019-07-07 18:01:32');
INSERT INTO `access_log` VALUES (50215, '65.47.15624936923058139', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 18:01:32', 11, 0, '', '2019-07-07 18:01:32');
INSERT INTO `access_log` VALUES (50216, '59.71.15624937274256541', 159, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 18:02:07', 9, 0, '', '2019-07-07 18:02:07');
INSERT INTO `access_log` VALUES (50217, '59.73.15624937274506547', 159, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.227.97.78', '2019-07-07 18:02:07', 21, 2001001000, '服务端发生异常', '2019-07-07 18:02:07');
INSERT INTO `access_log` VALUES (50218, '65.3607.15624952035979979', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:26:44', 1, 1002001015, '账号未登陆', '2019-07-07 18:26:44');
INSERT INTO `access_log` VALUES (50219, '65.46.15624952035988231', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:26:44', 0, 1002001015, '账号未登陆', '2019-07-07 18:26:44');
INSERT INTO `access_log` VALUES (50220, '65.50.15624952036038205', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:26:44', 1, 1002001015, '账号未登陆', '2019-07-07 18:26:44');
INSERT INTO `access_log` VALUES (50221, '65.54.15624952101608141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:26:50', 98, 0, '', '2019-07-07 18:26:50');
INSERT INTO `access_log` VALUES (50222, '65.49.15624952104668177', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:26:50', 172, 0, '', '2019-07-07 18:26:51');
INSERT INTO `access_log` VALUES (50223, '65.51.15624952104758225', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:26:50', 167, 0, '', '2019-07-07 18:26:51');
INSERT INTO `access_log` VALUES (50224, '65.52.15624952104708219', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:26:50', 172, 2001001000, '服务端发生异常', '2019-07-07 18:26:51');
INSERT INTO `access_log` VALUES (50225, '65.53.15624952236828183', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:27:04', 16, 0, '', '2019-07-07 18:27:04');
INSERT INTO `access_log` VALUES (50226, '65.45.15624952236938165', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:27:04', 9, 0, '', '2019-07-07 18:27:04');
INSERT INTO `access_log` VALUES (50227, '65.3607.15624952237009981', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:27:04', 9, 2001001000, '服务端发生异常', '2019-07-07 18:27:04');
INSERT INTO `access_log` VALUES (50228, '65.50.15624952297448207', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:27:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 18:27:10');
INSERT INTO `access_log` VALUES (50229, '65.54.15624952320138143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:27:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 18:27:12');
INSERT INTO `access_log` VALUES (50230, '65.49.15624952338118179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:27:14', 81, 0, '', '2019-07-07 18:27:14');
INSERT INTO `access_log` VALUES (50231, '65.52.15624952340648221', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:27:14', 7, 0, '', '2019-07-07 18:27:14');
INSERT INTO `access_log` VALUES (50232, '65.51.15624952340688227', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:27:14', 7, 0, '', '2019-07-07 18:27:14');
INSERT INTO `access_log` VALUES (50233, '65.47.15624952340748163', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:27:14', 7, 0, '', '2019-07-07 18:27:14');
INSERT INTO `access_log` VALUES (50234, '59.75.15624952442376571', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:27:24', 15, 0, '', '2019-07-07 18:27:24');
INSERT INTO `access_log` VALUES (50235, '59.78.15624952529416559', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:27:33', 15, 0, '', '2019-07-07 18:27:33');
INSERT INTO `access_log` VALUES (50236, '59.76.15624952585426555', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:27:39', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-07 18:27:39');
INSERT INTO `access_log` VALUES (50237, '65.3607.15624952733149983', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 18:27:53', 92, 0, '', '2019-07-07 18:27:53');
INSERT INTO `access_log` VALUES (50238, '59.80.15625035066946653', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:45:07', 10, 0, '', '2019-07-07 20:45:07');
INSERT INTO `access_log` VALUES (50239, '59.71.15625035066956673', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:45:07', 15, 2001001000, '服务端发生异常', '2019-07-07 20:45:07');
INSERT INTO `access_log` VALUES (50240, '64.81.15625035229846797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:45:23', 11, 0, '', '2019-07-07 20:45:23');
INSERT INTO `access_log` VALUES (50241, '64.82.15625035230926827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:45:23', 3, 0, '', '2019-07-07 20:45:23');
INSERT INTO `access_log` VALUES (50242, '64.79.15625035255456813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:45:26', 2, 0, '', '2019-07-07 20:45:26');
INSERT INTO `access_log` VALUES (50243, '64.80.15625035269826817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:45:27', 2, 0, '', '2019-07-07 20:45:27');
INSERT INTO `access_log` VALUES (50244, '64.77.15625035275486791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:45:28', 2, 0, '', '2019-07-07 20:45:28');
INSERT INTO `access_log` VALUES (50245, '64.85.15625035280466823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:45:28', 1, 0, '', '2019-07-07 20:45:28');
INSERT INTO `access_log` VALUES (50246, '65.52.15625035834228333', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:46:23', 3, 1002001012, '访问令牌已过期', '2019-07-07 20:46:23');
INSERT INTO `access_log` VALUES (50247, '65.47.15625035834228275', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:46:23', 3, 1002001012, '访问令牌已过期', '2019-07-07 20:46:23');
INSERT INTO `access_log` VALUES (50248, '65.51.15625035834368339', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:46:23', 12, 1002001012, '访问令牌已过期', '2019-07-07 20:46:23');
INSERT INTO `access_log` VALUES (50249, '65.45.15625035927398279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:46:33', 787, 0, '', '2019-07-07 20:46:34');
INSERT INTO `access_log` VALUES (50250, '65.3607.15625035937210095', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:46:34', 10, 0, '', '2019-07-07 20:46:34');
INSERT INTO `access_log` VALUES (50251, '65.46.15625035937258347', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:46:34', 11, 0, '', '2019-07-07 20:46:34');
INSERT INTO `access_log` VALUES (50252, '65.50.15625035937328321', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:46:34', 9, 0, '', '2019-07-07 20:46:34');
INSERT INTO `access_log` VALUES (50253, '59.79.15625036029956677', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:46:43', 14, 0, '', '2019-07-07 20:46:43');
INSERT INTO `access_log` VALUES (50254, '64.79.15625036148846815', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:46:55', 12, 0, '', '2019-07-07 20:46:55');
INSERT INTO `access_log` VALUES (50255, '64.77.15625036343866793', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:47:14', 10, 0, '', '2019-07-07 20:47:14');
INSERT INTO `access_log` VALUES (50256, '64.78.15625036533486819', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:47:33', 11, 0, '', '2019-07-07 20:47:33');
INSERT INTO `access_log` VALUES (50257, '64.76.15625036639396805', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:47:44', 11, 0, '', '2019-07-07 20:47:44');
INSERT INTO `access_log` VALUES (50258, '59.75.15625036806806685', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:48:01', 12, 0, '', '2019-07-07 20:48:01');
INSERT INTO `access_log` VALUES (50259, '59.76.15625036870596667', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:48:07', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-07 20:48:07');
INSERT INTO `access_log` VALUES (50260, '59.74.15625036949586681', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:48:15', 14, 0, '', '2019-07-07 20:48:15');
INSERT INTO `access_log` VALUES (50261, '64.82.15625036985286831', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:48:19', 10, 0, '', '2019-07-07 20:48:19');
INSERT INTO `access_log` VALUES (50262, '64.77.15625037161176795', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-07 20:48:36', 11, 0, '', '2019-07-07 20:48:36');
INSERT INTO `access_log` VALUES (50263, '65.47.15625040785218283', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9650 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.8 baiduboxapp/11.8.0.10 (Baidu; P1 9)', '117.93.141.104', '2019-07-07 20:54:39', 0, 1002001015, '账号未登陆', '2019-07-07 20:54:39');
INSERT INTO `access_log` VALUES (50264, '65.52.15625040785308341', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9650 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.8 baiduboxapp/11.8.0.10 (Baidu; P1 9)', '117.93.141.104', '2019-07-07 20:54:39', 0, 1002001015, '账号未登陆', '2019-07-07 20:54:39');
INSERT INTO `access_log` VALUES (50265, '65.51.15625040785338347', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9650 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.8 baiduboxapp/11.8.0.10 (Baidu; P1 9)', '117.93.141.104', '2019-07-07 20:54:39', 0, 1002001015, '账号未登陆', '2019-07-07 20:54:39');
INSERT INTO `access_log` VALUES (50266, '65.45.15625040807258287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; SM-G9650 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.8 baiduboxapp/11.8.0.10 (Baidu; P1 9)', '117.93.141.104', '2019-07-07 20:54:41', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 20:54:41');
INSERT INTO `access_log` VALUES (50267, '65.46.15625040983978355', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 9; SM-G9650 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.8 baiduboxapp/11.8.0.10 (Baidu; P1 9)', '117.93.141.104', '2019-07-07 20:54:58', 77, 0, '', '2019-07-07 20:54:58');
INSERT INTO `access_log` VALUES (50268, '65.54.15625040988938265', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9650 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.8 baiduboxapp/11.8.0.10 (Baidu; P1 9)', '117.93.141.104', '2019-07-07 20:54:59', 11, 0, '', '2019-07-07 20:54:59');
INSERT INTO `access_log` VALUES (50269, '65.49.15625040988978301', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9650 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.8 baiduboxapp/11.8.0.10 (Baidu; P1 9)', '117.93.141.104', '2019-07-07 20:54:59', 9, 0, '', '2019-07-07 20:54:59');
INSERT INTO `access_log` VALUES (50270, '65.50.15625040988938329', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; SM-G9650 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.8 baiduboxapp/11.8.0.10 (Baidu; P1 9)', '117.93.141.104', '2019-07-07 20:54:59', 12, 2001001000, '服务端发生异常', '2019-07-07 20:54:59');
INSERT INTO `access_log` VALUES (50271, '65.52.15625041281258343', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.12.4.155', '2019-07-07 20:55:28', 1, 1002001015, '账号未登陆', '2019-07-07 20:55:28');
INSERT INTO `access_log` VALUES (50272, '65.53.15625041281318307', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.12.4.155', '2019-07-07 20:55:28', 0, 1002001015, '账号未登陆', '2019-07-07 20:55:28');
INSERT INTO `access_log` VALUES (50273, '65.45.15625041281368289', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.12.4.155', '2019-07-07 20:55:28', 1, 1002001015, '账号未登陆', '2019-07-07 20:55:28');
INSERT INTO `access_log` VALUES (50274, '65.50.15625041742628331', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.12.4.155', '2019-07-07 20:56:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 20:56:14');
INSERT INTO `access_log` VALUES (50275, '65.47.15625041884838287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.12.4.155', '2019-07-07 20:56:28', 68, 0, '', '2019-07-07 20:56:29');
INSERT INTO `access_log` VALUES (50276, '65.52.15625041888298345', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.12.4.155', '2019-07-07 20:56:29', 132, 0, '', '2019-07-07 20:56:29');
INSERT INTO `access_log` VALUES (50277, '65.51.15625041888238351', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.12.4.155', '2019-07-07 20:56:29', 136, 0, '', '2019-07-07 20:56:29');
INSERT INTO `access_log` VALUES (50278, '65.53.15625041888318309', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.12.4.155', '2019-07-07 20:56:29', 131, 2001001000, '服务端发生异常', '2019-07-07 20:56:29');
INSERT INTO `access_log` VALUES (50279, '65.3607.15625041969620107', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.12.4.155', '2019-07-07 20:56:37', 9, 0, '', '2019-07-07 20:56:37');
INSERT INTO `access_log` VALUES (50280, '65.45.15625041969608291', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.12.4.155', '2019-07-07 20:56:37', 11, 2001001000, '服务端发生异常', '2019-07-07 20:56:37');
INSERT INTO `access_log` VALUES (50281, '65.46.15625041969658359', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.12.4.155', '2019-07-07 20:56:37', 9, 0, '', '2019-07-07 20:56:37');
INSERT INTO `access_log` VALUES (50282, '59.75.15625042270546693', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.12.4.155', '2019-07-07 20:57:07', 3, 0, '', '2019-07-07 20:57:07');
INSERT INTO `access_log` VALUES (50283, '59.78.15625042270566679', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '223.12.4.155', '2019-07-07 20:57:07', 15, 2001001000, '服务端发生异常', '2019-07-07 20:57:07');
INSERT INTO `access_log` VALUES (50284, '65.46.15625043051078361', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-07 20:58:25', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 20:58:25');
INSERT INTO `access_log` VALUES (50285, '65.45.15625043125668293', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-07 20:58:33', 67, 0, '', '2019-07-07 20:58:33');
INSERT INTO `access_log` VALUES (50286, '65.54.15625043132048271', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-07 20:58:33', 9, 0, '', '2019-07-07 20:58:33');
INSERT INTO `access_log` VALUES (50287, '65.50.15625043132148335', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-07 20:58:33', 10, 0, '', '2019-07-07 20:58:33');
INSERT INTO `access_log` VALUES (50288, '65.49.15625043132658307', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-07 20:58:33', 9, 0, '', '2019-07-07 20:58:33');
INSERT INTO `access_log` VALUES (50289, '62.83.15625043854346013', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-07 20:59:45', 29, 0, '', '2019-07-07 20:59:45');
INSERT INTO `access_log` VALUES (50290, '62.81.15625043902155971', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-07 20:59:50', 29, 0, '', '2019-07-07 20:59:50');
INSERT INTO `access_log` VALUES (50291, '62.84.15625044294365983', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-07 21:00:29', 14, 0, '', '2019-07-07 21:00:29');
INSERT INTO `access_log` VALUES (50292, '64.85.15625044707756837', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-07 21:01:11', 11, 0, '', '2019-07-07 21:01:11');
INSERT INTO `access_log` VALUES (50293, '65.52.15625044865018351', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:01:27', 0, 1002001015, '账号未登陆', '2019-07-07 21:01:27');
INSERT INTO `access_log` VALUES (50294, '65.53.15625044865058315', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:01:27', 0, 1002001015, '账号未登陆', '2019-07-07 21:01:27');
INSERT INTO `access_log` VALUES (50295, '65.3607.15625044865090113', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:01:27', 1, 1002001015, '账号未登陆', '2019-07-07 21:01:27');
INSERT INTO `access_log` VALUES (50296, '65.46.15625044925828365', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:01:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 21:01:33');
INSERT INTO `access_log` VALUES (50297, '65.50.15625045095918339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:01:50', 118, 0, '', '2019-07-07 21:01:50');
INSERT INTO `access_log` VALUES (50298, '65.54.15625045100198275', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:01:50', 9, 0, '', '2019-07-07 21:01:50');
INSERT INTO `access_log` VALUES (50299, '65.49.15625045100448311', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:01:50', 9, 2001001000, '服务端发生异常', '2019-07-07 21:01:50');
INSERT INTO `access_log` VALUES (50300, '65.47.15625045100478295', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:01:50', 8, 0, '', '2019-07-07 21:01:50');
INSERT INTO `access_log` VALUES (50301, '65.45.15625045744378299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:02:54', 88, 0, '', '2019-07-07 21:02:55');
INSERT INTO `access_log` VALUES (50302, '65.50.15625045748878341', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:02:55', 42, 0, '', '2019-07-07 21:02:55');
INSERT INTO `access_log` VALUES (50303, '65.54.15625045748948277', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:02:55', 40, 0, '', '2019-07-07 21:02:55');
INSERT INTO `access_log` VALUES (50304, '65.47.15625045748898297', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:02:55', 47, 2001001000, '服务端发生异常', '2019-07-07 21:02:55');
INSERT INTO `access_log` VALUES (50305, '59.73.15625052164846703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:13:36', 3, 0, '', '2019-07-07 21:13:36');
INSERT INTO `access_log` VALUES (50306, '59.72.15625052164846693', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:13:36', 16, 2001001000, '服务端发生异常', '2019-07-07 21:13:37');
INSERT INTO `access_log` VALUES (50307, '64.78.15625052193106841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:13:39', 3, 0, '', '2019-07-07 21:13:39');
INSERT INTO `access_log` VALUES (50308, '64.84.15625052194766831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:13:39', 2, 0, '', '2019-07-07 21:13:39');
INSERT INTO `access_log` VALUES (50309, '64.76.15625052205316827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:13:41', 2, 0, '', '2019-07-07 21:13:41');
INSERT INTO `access_log` VALUES (50310, '64.83.15625052211476833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:13:41', 2, 0, '', '2019-07-07 21:13:41');
INSERT INTO `access_log` VALUES (50311, '59.78.15625052226906693', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:13:43', 2, 0, '', '2019-07-07 21:13:43');
INSERT INTO `access_log` VALUES (50312, '59.75.15625052226926707', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.54.156.9', '2019-07-07 21:13:43', 16, 2001001000, '服务端发生异常', '2019-07-07 21:13:43');
INSERT INTO `access_log` VALUES (50313, '59.77.15625081215286725', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '59.172.181.121', '2019-07-07 22:02:02', 10, 0, '', '2019-07-07 22:02:02');
INSERT INTO `access_log` VALUES (50314, '59.80.15625081215296717', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '59.172.181.121', '2019-07-07 22:02:02', 21, 2001001000, '服务端发生异常', '2019-07-07 22:02:02');
INSERT INTO `access_log` VALUES (50315, '64.77.15625081264646855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '59.172.181.121', '2019-07-07 22:02:06', 11, 0, '', '2019-07-07 22:02:06');
INSERT INTO `access_log` VALUES (50316, '64.85.15625081265616887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '59.172.181.121', '2019-07-07 22:02:07', 3, 0, '', '2019-07-07 22:02:07');
INSERT INTO `access_log` VALUES (50317, '65.47.15625099700408369', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:32:50', 0, 1002001015, '账号未登陆', '2019-07-07 22:32:50');
INSERT INTO `access_log` VALUES (50318, '65.49.15625099700458385', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:32:50', 1, 1002001015, '账号未登陆', '2019-07-07 22:32:50');
INSERT INTO `access_log` VALUES (50319, '65.51.15625099700628433', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:32:50', 0, 1002001015, '账号未登陆', '2019-07-07 22:32:50');
INSERT INTO `access_log` VALUES (50320, '65.3607.15625099931560189', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:33:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 22:33:13');
INSERT INTO `access_log` VALUES (50321, '65.46.15625100007248441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:33:21', 293, 0, '', '2019-07-07 22:33:21');
INSERT INTO `access_log` VALUES (50322, '65.45.15625100013618373', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:33:21', 212, 0, '', '2019-07-07 22:33:22');
INSERT INTO `access_log` VALUES (50323, '65.50.15625100013748415', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:33:21', 202, 0, '', '2019-07-07 22:33:22');
INSERT INTO `access_log` VALUES (50324, '65.54.15625100013658351', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:33:21', 212, 2001001000, '服务端发生异常', '2019-07-07 22:33:22');
INSERT INTO `access_log` VALUES (50325, '65.49.15625100151258387', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:33:35', 8, 0, '', '2019-07-07 22:33:35');
INSERT INTO `access_log` VALUES (50326, '65.52.15625100151348429', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:33:35', 8, 0, '', '2019-07-07 22:33:35');
INSERT INTO `access_log` VALUES (50327, '65.51.15625100151298435', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:33:35', 614, 2001001000, '服务端发生异常', '2019-07-07 22:33:36');
INSERT INTO `access_log` VALUES (50328, '65.3607.15625100231010191', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:33:43', 17, 0, '', '2019-07-07 22:33:43');
INSERT INTO `access_log` VALUES (50329, '65.50.15625100231158417', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:33:43', 8, 0, '', '2019-07-07 22:33:43');
INSERT INTO `access_log` VALUES (50330, '65.46.15625100231078443', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:33:43', 17, 2001001000, '服务端发生异常', '2019-07-07 22:33:43');
INSERT INTO `access_log` VALUES (50331, '65.54.15625101703698355', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:36:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-07 22:36:10');
INSERT INTO `access_log` VALUES (50332, '65.45.15625101838938377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:36:24', 62, 0, '', '2019-07-07 22:36:24');
INSERT INTO `access_log` VALUES (50333, '65.52.15625101841448433', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:36:24', 9, 0, '', '2019-07-07 22:36:24');
INSERT INTO `access_log` VALUES (50334, '65.49.15625101841468391', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:36:24', 9, 2001001000, '服务端发生异常', '2019-07-07 22:36:24');
INSERT INTO `access_log` VALUES (50335, '65.51.15625101841878439', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '180.212.235.225', '2019-07-07 22:36:24', 10, 0, '', '2019-07-07 22:36:24');
INSERT INTO `access_log` VALUES (50336, '59.76.15625123917676785', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.197.245.241', '2019-07-07 23:13:12', 16, 0, '', '2019-07-07 23:13:12');
INSERT INTO `access_log` VALUES (50337, '59.74.15625123917686799', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.197.245.241', '2019-07-07 23:13:12', 21, 2001001000, '服务端发生异常', '2019-07-07 23:13:12');
INSERT INTO `access_log` VALUES (50338, '64.81.15625123983196919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '115.197.245.241', '2019-07-07 23:13:18', 13, 0, '', '2019-07-07 23:13:18');
INSERT INTO `access_log` VALUES (50339, '64.82.15625123984326949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '115.197.245.241', '2019-07-07 23:13:18', 4, 0, '', '2019-07-07 23:13:18');
INSERT INTO `access_log` VALUES (50340, '64.79.15625124002456935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '115.197.245.241', '2019-07-07 23:13:20', 2, 0, '', '2019-07-07 23:13:20');
INSERT INTO `access_log` VALUES (50341, '64.77.15625124008896913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '115.197.245.241', '2019-07-07 23:13:21', 2, 0, '', '2019-07-07 23:13:21');
INSERT INTO `access_log` VALUES (50342, '64.85.15625124018426945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '115.197.245.241', '2019-07-07 23:13:22', 2, 0, '', '2019-07-07 23:13:22');
INSERT INTO `access_log` VALUES (50343, '64.78.15625124023036939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '115.197.245.241', '2019-07-07 23:13:22', 2, 0, '', '2019-07-07 23:13:22');
INSERT INTO `access_log` VALUES (50344, '64.84.15625124025996929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '115.197.245.241', '2019-07-07 23:13:23', 2, 0, '', '2019-07-07 23:13:23');
INSERT INTO `access_log` VALUES (50345, '64.76.15625124060576925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '115.197.245.241', '2019-07-07 23:13:26', 2, 0, '', '2019-07-07 23:13:26');
INSERT INTO `access_log` VALUES (50346, '64.83.15625124061486931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '115.197.245.241', '2019-07-07 23:13:26', 2, 0, '', '2019-07-07 23:13:26');
INSERT INTO `access_log` VALUES (50347, '59.73.15625460544047249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:34:14', 17, 0, '', '2019-07-08 08:34:14');
INSERT INTO `access_log` VALUES (50348, '59.72.15625460544067239', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:34:14', 35, 2001001000, '服务端发生异常', '2019-07-08 08:34:14');
INSERT INTO `access_log` VALUES (50349, '59.74.15625460684337249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:34:28', 3, 0, '', '2019-07-08 08:34:28');
INSERT INTO `access_log` VALUES (50350, '59.78.15625460684337239', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:34:28', 18, 2001001000, '服务端发生异常', '2019-07-08 08:34:28');
INSERT INTO `access_log` VALUES (50351, '65.54.15625460952828835', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:34:55', 0, 1002001015, '账号未登陆', '2019-07-08 08:34:55');
INSERT INTO `access_log` VALUES (50352, '65.47.15625460952848855', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:34:55', 0, 1002001015, '账号未登陆', '2019-07-08 08:34:55');
INSERT INTO `access_log` VALUES (50353, '65.45.15625460953058857', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:34:55', 1, 1002001015, '账号未登陆', '2019-07-08 08:34:55');
INSERT INTO `access_log` VALUES (50354, '65.52.15625461064628913', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:35:06', 0, 1002001015, '账号未登陆', '2019-07-08 08:35:06');
INSERT INTO `access_log` VALUES (50355, '65.49.15625461064628871', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:35:06', 0, 1002001015, '账号未登陆', '2019-07-08 08:35:06');
INSERT INTO `access_log` VALUES (50356, '65.51.15625461064668919', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:35:06', 0, 1002001015, '账号未登陆', '2019-07-08 08:35:06');
INSERT INTO `access_log` VALUES (50357, '65.46.15625461150808927', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:35:15', 88, 0, '', '2019-07-08 08:35:15');
INSERT INTO `access_log` VALUES (50358, '65.3607.15625461156760675', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:35:16', 19, 0, '', '2019-07-08 08:35:16');
INSERT INTO `access_log` VALUES (50359, '65.50.15625461156808901', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:35:16', 17, 2001001000, '服务端发生异常', '2019-07-08 08:35:16');
INSERT INTO `access_log` VALUES (50360, '65.54.15625461156818837', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:35:16', 18, 0, '', '2019-07-08 08:35:16');
INSERT INTO `access_log` VALUES (50361, '65.51.15625461465368921', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:35:47', 18, 0, '', '2019-07-08 08:35:47');
INSERT INTO `access_log` VALUES (50362, '65.52.15625461465378915', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:35:47', 19, 0, '', '2019-07-08 08:35:47');
INSERT INTO `access_log` VALUES (50363, '65.49.15625461465378873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:35:47', 19, 2001001000, '服务端发生异常', '2019-07-08 08:35:47');
INSERT INTO `access_log` VALUES (50364, '65.46.15625461549948929', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.17.125.171', '2019-07-08 08:35:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 08:35:55');
INSERT INTO `access_log` VALUES (50365, '59.75.15625485736687287', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.184.38.8', '2019-07-08 09:16:14', 18, 2001001000, '服务端发生异常', '2019-07-08 09:16:14');
INSERT INTO `access_log` VALUES (50366, '59.78.15625485736687273', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.184.38.8', '2019-07-08 09:16:14', 8, 0, '', '2019-07-08 09:16:14');
INSERT INTO `access_log` VALUES (50367, '65.50.15625492953788945', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 09:28:15', 6, 1002001012, '访问令牌已过期', '2019-07-08 09:28:15');
INSERT INTO `access_log` VALUES (50368, '65.46.15625492953788971', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 09:28:15', 5, 1002001012, '访问令牌已过期', '2019-07-08 09:28:15');
INSERT INTO `access_log` VALUES (50369, '65.3607.15625492953780719', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 09:28:15', 5, 1002001012, '访问令牌已过期', '2019-07-08 09:28:15');
INSERT INTO `access_log` VALUES (50370, '65.54.15625493032908881', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 09:28:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 09:28:23');
INSERT INTO `access_log` VALUES (50371, '65.46.15625495397298975', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 09:32:20', 61, 0, '', '2019-07-08 09:32:20');
INSERT INTO `access_log` VALUES (50372, '65.50.15625495400558949', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 09:32:20', 11, 0, '', '2019-07-08 09:32:20');
INSERT INTO `access_log` VALUES (50373, '65.3607.15625495400580723', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 09:32:20', 10, 2001001000, '服务端发生异常', '2019-07-08 09:32:20');
INSERT INTO `access_log` VALUES (50374, '65.54.15625495400878885', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 09:32:20', 8, 0, '', '2019-07-08 09:32:20');
INSERT INTO `access_log` VALUES (50375, '59.76.15625512891497305', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.213.37', '2019-07-08 10:01:29', 9, 0, '', '2019-07-08 10:01:29');
INSERT INTO `access_log` VALUES (50376, '59.79.15625512891697317', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.213.37', '2019-07-08 10:01:29', 18, 2001001000, '服务端发生异常', '2019-07-08 10:01:29');
INSERT INTO `access_log` VALUES (50377, '59.75.15625518298547331', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.210.31.151', '2019-07-08 10:10:30', 4, 0, '', '2019-07-08 10:10:30');
INSERT INTO `access_log` VALUES (50378, '59.74.15625518302577327', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.210.31.151', '2019-07-08 10:10:30', 12, 2001001000, '服务端发生异常', '2019-07-08 10:10:30');
INSERT INTO `access_log` VALUES (50379, '64.76.15625518333217451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.210.31.151', '2019-07-08 10:10:33', 12, 0, '', '2019-07-08 10:10:33');
INSERT INTO `access_log` VALUES (50380, '64.83.15625518334327457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.210.31.151', '2019-07-08 10:10:33', 3, 0, '', '2019-07-08 10:10:33');
INSERT INTO `access_log` VALUES (50381, '64.81.15625518352897447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.210.31.151', '2019-07-08 10:10:35', 1, 0, '', '2019-07-08 10:10:35');
INSERT INTO `access_log` VALUES (50382, '64.79.15625518357867463', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.210.31.151', '2019-07-08 10:10:36', 2, 0, '', '2019-07-08 10:10:36');
INSERT INTO `access_log` VALUES (50383, '59.76.15625518367577313', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.210.31.151', '2019-07-08 10:10:37', 2, 0, '', '2019-07-08 10:10:37');
INSERT INTO `access_log` VALUES (50384, '59.77.15625518367627311', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.210.31.151', '2019-07-08 10:10:37', 16, 2001001000, '服务端发生异常', '2019-07-08 10:10:37');
INSERT INTO `access_log` VALUES (50385, '64.80.15625518404377467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.210.31.151', '2019-07-08 10:10:40', 2, 0, '', '2019-07-08 10:10:40');
INSERT INTO `access_log` VALUES (50386, '64.77.15625518406137441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.210.31.151', '2019-07-08 10:10:41', 3, 0, '', '2019-07-08 10:10:41');
INSERT INTO `access_log` VALUES (50387, '59.80.15625518413917303', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.210.31.151', '2019-07-08 10:10:41', 3, 0, '', '2019-07-08 10:10:41');
INSERT INTO `access_log` VALUES (50388, '59.71.15625518413917323', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.210.31.151', '2019-07-08 10:10:41', 16, 2001001000, '服务端发生异常', '2019-07-08 10:10:41');
INSERT INTO `access_log` VALUES (50389, '59.79.15625520655287329', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.30.113.37', '2019-07-08 10:14:26', 3, 0, '', '2019-07-08 10:14:26');
INSERT INTO `access_log` VALUES (50390, '59.77.15625520655287315', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.30.113.37', '2019-07-08 10:14:26', 40, 2001001000, '服务端发生异常', '2019-07-08 10:14:26');
INSERT INTO `access_log` VALUES (50391, '64.82.15625520802997481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.30.113.37', '2019-07-08 10:14:40', 2, 0, '', '2019-07-08 10:14:40');
INSERT INTO `access_log` VALUES (50392, '64.79.15625520804217467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.30.113.37', '2019-07-08 10:14:40', 1, 0, '', '2019-07-08 10:14:40');
INSERT INTO `access_log` VALUES (50393, '64.80.15625520874487471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.30.113.37', '2019-07-08 10:14:47', 1, 0, '', '2019-07-08 10:14:47');
INSERT INTO `access_log` VALUES (50394, '64.77.15625520875537445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.30.113.37', '2019-07-08 10:14:48', 2, 0, '', '2019-07-08 10:14:48');
INSERT INTO `access_log` VALUES (50395, '59.72.15625521081297323', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.30.113.37', '2019-07-08 10:15:08', 2, 0, '', '2019-07-08 10:15:08');
INSERT INTO `access_log` VALUES (50396, '59.73.15625521081297333', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.30.113.37', '2019-07-08 10:15:08', 15, 2001001000, '服务端发生异常', '2019-07-08 10:15:08');
INSERT INTO `access_log` VALUES (50397, '64.84.15625521196597461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.30.113.37', '2019-07-08 10:15:20', 2, 0, '', '2019-07-08 10:15:20');
INSERT INTO `access_log` VALUES (50398, '64.76.15625521198167457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.30.113.37', '2019-07-08 10:15:20', 2, 0, '', '2019-07-08 10:15:20');
INSERT INTO `access_log` VALUES (50399, '64.81.15625521214187453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.30.113.37', '2019-07-08 10:15:21', 2, 0, '', '2019-07-08 10:15:21');
INSERT INTO `access_log` VALUES (50400, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.30.113.37', '2019-07-08 10:15:21', 6, 0, '', '2019-07-08 10:15:21');
INSERT INTO `access_log` VALUES (50401, '64.82.15625521240037483', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.30.113.37', '2019-07-08 10:15:24', 8, 0, '', '2019-07-08 10:15:24');
INSERT INTO `access_log` VALUES (50402, '64.79.15625521340157469', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.30.113.37', '2019-07-08 10:15:34', 6, 0, '', '2019-07-08 10:15:34');
INSERT INTO `access_log` VALUES (50403, '65.50.15625551878459025', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:06:28', 0, 1002001015, '账号未登陆', '2019-07-08 11:06:28');
INSERT INTO `access_log` VALUES (50404, '65.54.15625551878458961', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:06:28', 0, 1002001015, '账号未登陆', '2019-07-08 11:06:28');
INSERT INTO `access_log` VALUES (50405, '65.3607.15625551878440799', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:06:28', 1, 1002001015, '账号未登陆', '2019-07-08 11:06:28');
INSERT INTO `access_log` VALUES (50406, '65.47.15625551925588981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:06:33', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 11:06:33');
INSERT INTO `access_log` VALUES (50407, '65.45.15625551965738983', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:06:37', 69, 0, '', '2019-07-08 11:06:37');
INSERT INTO `access_log` VALUES (50408, '65.52.15625551968519039', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:06:37', 20, 0, '', '2019-07-08 11:06:37');
INSERT INTO `access_log` VALUES (50409, '65.51.15625551968559045', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:06:37', 17, 0, '', '2019-07-08 11:06:37');
INSERT INTO `access_log` VALUES (50410, '65.49.15625551968528997', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:06:37', 22, 2001001000, '服务端发生异常', '2019-07-08 11:06:37');
INSERT INTO `access_log` VALUES (50411, '65.50.15625552255929027', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:07:06', 10, 0, '', '2019-07-08 11:07:06');
INSERT INTO `access_log` VALUES (50412, '65.54.15625552255978963', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:07:06', 8, 0, '', '2019-07-08 11:07:06');
INSERT INTO `access_log` VALUES (50413, '65.3607.15625552255970801', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:07:06', 9, 2001001000, '服务端发生异常', '2019-07-08 11:07:06');
INSERT INTO `access_log` VALUES (50414, '65.51.15625552455329047', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:07:26', 0, 1002001015, '账号未登陆', '2019-07-08 11:07:26');
INSERT INTO `access_log` VALUES (50415, '65.49.15625552455348999', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:07:26', 0, 1002001015, '账号未登陆', '2019-07-08 11:07:26');
INSERT INTO `access_log` VALUES (50416, '65.52.15625552456299041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:07:26', 1, 1002001015, '账号未登陆', '2019-07-08 11:07:26');
INSERT INTO `access_log` VALUES (50417, '65.53.15625552472659005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:07:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 11:07:27');
INSERT INTO `access_log` VALUES (50418, '65.46.15625552491799055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:07:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 11:07:29');
INSERT INTO `access_log` VALUES (50419, '65.3607.15625552498010803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:07:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 11:07:30');
INSERT INTO `access_log` VALUES (50420, '65.50.15625552502869029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:07:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 11:07:30');
INSERT INTO `access_log` VALUES (50421, '65.54.15625552509968965', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:07:31', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 11:07:31');
INSERT INTO `access_log` VALUES (50422, '65.45.15625552616498987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:07:42', 84, 0, '', '2019-07-08 11:07:42');
INSERT INTO `access_log` VALUES (50423, '65.51.15625552618889049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:07:42', 8, 0, '', '2019-07-08 11:07:42');
INSERT INTO `access_log` VALUES (50424, '65.49.15625552618889001', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:07:42', 10, 2001001000, '服务端发生异常', '2019-07-08 11:07:42');
INSERT INTO `access_log` VALUES (50425, '65.52.15625552618909043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.28', '2019-07-08 11:07:42', 8, 0, '', '2019-07-08 11:07:42');
INSERT INTO `access_log` VALUES (50426, '65.46.15625552744139057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:07:54', 110, 0, '', '2019-07-08 11:07:55');
INSERT INTO `access_log` VALUES (50427, '65.3607.15625552754060805', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:07:55', 10, 0, '', '2019-07-08 11:07:55');
INSERT INTO `access_log` VALUES (50428, '65.50.15625552754069031', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:07:55', 11, 2001001000, '服务端发生异常', '2019-07-08 11:07:55');
INSERT INTO `access_log` VALUES (50429, '65.54.15625552754188967', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:07:55', 9, 0, '', '2019-07-08 11:07:55');
INSERT INTO `access_log` VALUES (50430, '65.51.15625553078549051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:08:28', 11, 0, '', '2019-07-08 11:08:28');
INSERT INTO `access_log` VALUES (50431, '65.49.15625553078589003', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:08:28', 10, 2001001000, '服务端发生异常', '2019-07-08 11:08:28');
INSERT INTO `access_log` VALUES (50432, '65.52.15625553078629045', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.217.4', '2019-07-08 11:08:28', 16, 0, '', '2019-07-08 11:08:28');
INSERT INTO `access_log` VALUES (50433, '59.79.15625565282807389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.155.198.235', '2019-07-08 11:28:48', 12, 0, '', '2019-07-08 11:28:48');
INSERT INTO `access_log` VALUES (50434, '59.76.15625565282807377', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.155.198.235', '2019-07-08 11:28:48', 17, 2001001000, '服务端发生异常', '2019-07-08 11:28:48');
INSERT INTO `access_log` VALUES (50435, '64.84.15625565326937521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.155.198.235', '2019-07-08 11:28:53', 9, 0, '', '2019-07-08 11:28:53');
INSERT INTO `access_log` VALUES (50436, '64.76.15625565327987517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.155.198.235', '2019-07-08 11:28:53', 3, 0, '', '2019-07-08 11:28:53');
INSERT INTO `access_log` VALUES (50437, '64.83.15625565345017523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.155.198.235', '2019-07-08 11:28:55', 2, 0, '', '2019-07-08 11:28:55');
INSERT INTO `access_log` VALUES (50438, '64.81.15625565351267513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.155.198.235', '2019-07-08 11:28:55', 1, 0, '', '2019-07-08 11:28:55');
INSERT INTO `access_log` VALUES (50439, '64.82.15625565360867543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.155.198.235', '2019-07-08 11:28:56', 1, 0, '', '2019-07-08 11:28:56');
INSERT INTO `access_log` VALUES (50440, '59.71.15625565374197387', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.155.198.235', '2019-07-08 11:28:57', 3, 0, '', '2019-07-08 11:28:57');
INSERT INTO `access_log` VALUES (50441, '59.72.15625565374197383', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.155.198.235', '2019-07-08 11:28:57', 13, 2001001000, '服务端发生异常', '2019-07-08 11:28:57');
INSERT INTO `access_log` VALUES (50442, '65.45.15625565538089009', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.155.198.235', '2019-07-08 11:29:14', 0, 1002001015, '账号未登陆', '2019-07-08 11:29:14');
INSERT INTO `access_log` VALUES (50443, '65.3607.15625565538080823', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.155.198.235', '2019-07-08 11:29:14', 1, 1002001015, '账号未登陆', '2019-07-08 11:29:14');
INSERT INTO `access_log` VALUES (50444, '65.51.15625565538349069', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.155.198.235', '2019-07-08 11:29:14', 0, 1002001015, '账号未登陆', '2019-07-08 11:29:14');
INSERT INTO `access_log` VALUES (50445, '65.53.15625565560349025', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.155.198.235', '2019-07-08 11:29:16', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 11:29:16');
INSERT INTO `access_log` VALUES (50446, '65.49.15625577954139037', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 11:49:55', 1, 1002001015, '账号未登陆', '2019-07-08 11:49:55');
INSERT INTO `access_log` VALUES (50447, '65.47.15625577954149023', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 11:49:55', 0, 1002001015, '账号未登陆', '2019-07-08 11:49:55');
INSERT INTO `access_log` VALUES (50448, '65.52.15625577957429079', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 11:49:56', 0, 1002001015, '账号未登陆', '2019-07-08 11:49:56');
INSERT INTO `access_log` VALUES (50449, '65.3607.15625577986320841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 11:49:59', 77, 0, '', '2019-07-08 11:49:59');
INSERT INTO `access_log` VALUES (50450, '65.45.15625577988719027', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 11:49:59', 10, 0, '', '2019-07-08 11:49:59');
INSERT INTO `access_log` VALUES (50451, '65.51.15625577988749087', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 11:49:59', 9, 0, '', '2019-07-08 11:49:59');
INSERT INTO `access_log` VALUES (50452, '65.53.15625577988759043', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 11:49:59', 9, 2001001000, '服务端发生异常', '2019-07-08 11:49:59');
INSERT INTO `access_log` VALUES (50453, '59.80.15625671398367509', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-08 14:25:40', 10, 0, '', '2019-07-08 14:25:40');
INSERT INTO `access_log` VALUES (50454, '59.71.15625671398627529', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-08 14:25:40', 13, 2001001000, '服务端发生异常', '2019-07-08 14:25:40');
INSERT INTO `access_log` VALUES (50455, '64.83.15625671448527665', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-08 14:25:45', 11, 0, '', '2019-07-08 14:25:45');
INSERT INTO `access_log` VALUES (50456, '64.81.15625671450017655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-08 14:25:45', 4, 0, '', '2019-07-08 14:25:45');
INSERT INTO `access_log` VALUES (50457, '59.73.15625671464187535', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-08 14:25:46', 3, 0, '', '2019-07-08 14:25:46');
INSERT INTO `access_log` VALUES (50458, '59.72.15625671464187525', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.23.150.218', '2019-07-08 14:25:46', 18, 2001001000, '服务端发生异常', '2019-07-08 14:25:46');
INSERT INTO `access_log` VALUES (50459, '65.45.15625679631109163', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-08 14:39:23', 1, 1002001015, '账号未登陆', '2019-07-08 14:39:23');
INSERT INTO `access_log` VALUES (50460, '65.51.15625679631109223', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-08 14:39:23', 0, 1002001015, '账号未登陆', '2019-07-08 14:39:23');
INSERT INTO `access_log` VALUES (50461, '65.53.15625679631139179', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-08 14:39:23', 0, 1002001015, '账号未登陆', '2019-07-08 14:39:23');
INSERT INTO `access_log` VALUES (50462, '65.46.15625679685679231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-08 14:39:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 14:39:29');
INSERT INTO `access_log` VALUES (50463, '65.54.15625679762159141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-08 14:39:36', 135, 0, '', '2019-07-08 14:39:36');
INSERT INTO `access_log` VALUES (50464, '65.49.15625679766189175', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-08 14:39:37', 14, 0, '', '2019-07-08 14:39:37');
INSERT INTO `access_log` VALUES (50465, '65.47.15625679766229161', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-08 14:39:37', 12, 2001001000, '服务端发生异常', '2019-07-08 14:39:37');
INSERT INTO `access_log` VALUES (50466, '65.52.15625679766229217', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-08 14:39:37', 12, 0, '', '2019-07-08 14:39:37');
INSERT INTO `access_log` VALUES (50467, '59.72.15625680164847537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-08 14:40:16', 3, 0, '', '2019-07-08 14:40:16');
INSERT INTO `access_log` VALUES (50468, '59.73.15625680164857547', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-08 14:40:16', 15, 2001001000, '服务端发生异常', '2019-07-08 14:40:17');
INSERT INTO `access_log` VALUES (50469, '64.81.15625680206347667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-08 14:40:21', 4, 0, '', '2019-07-08 14:40:21');
INSERT INTO `access_log` VALUES (50470, '64.82.15625680207677697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-08 14:40:21', 2, 0, '', '2019-07-08 14:40:21');
INSERT INTO `access_log` VALUES (50471, '64.79.15625680240387683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-08 14:40:24', 2, 0, '', '2019-07-08 14:40:24');
INSERT INTO `access_log` VALUES (50472, '64.80.15625680241957687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-08 14:40:24', 1, 0, '', '2019-07-08 14:40:24');
INSERT INTO `access_log` VALUES (50473, '65.54.15625694137029161', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5959.400 SLBrowser/10.0.3544.400', '60.247.104.66', '2019-07-08 15:03:34', 0, 1002001015, '账号未登陆', '2019-07-08 15:03:34');
INSERT INTO `access_log` VALUES (50474, '65.47.15625694137039181', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5959.400 SLBrowser/10.0.3544.400', '60.247.104.66', '2019-07-08 15:03:34', 1, 1002001015, '账号未登陆', '2019-07-08 15:03:34');
INSERT INTO `access_log` VALUES (50475, '65.49.15625694137049195', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5959.400 SLBrowser/10.0.3544.400', '60.247.104.66', '2019-07-08 15:03:34', 0, 1002001015, '账号未登陆', '2019-07-08 15:03:34');
INSERT INTO `access_log` VALUES (50476, '65.52.15625694163959237', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5959.400 SLBrowser/10.0.3544.400', '60.247.104.66', '2019-07-08 15:03:36', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 15:03:36');
INSERT INTO `access_log` VALUES (50477, '65.53.15625694315869201', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5959.400 SLBrowser/10.0.3544.400', '60.247.104.66', '2019-07-08 15:03:52', 98, 0, '', '2019-07-08 15:03:52');
INSERT INTO `access_log` VALUES (50478, '65.51.15625694319339245', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5959.400 SLBrowser/10.0.3544.400', '60.247.104.66', '2019-07-08 15:03:52', 10, 0, '', '2019-07-08 15:03:52');
INSERT INTO `access_log` VALUES (50479, '65.50.15625694319369227', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5959.400 SLBrowser/10.0.3544.400', '60.247.104.66', '2019-07-08 15:03:52', 10, 0, '', '2019-07-08 15:03:52');
INSERT INTO `access_log` VALUES (50480, '65.45.15625694319369185', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.5959.400 SLBrowser/10.0.3544.400', '60.247.104.66', '2019-07-08 15:03:52', 10, 2001001000, '服务端发生异常', '2019-07-08 15:03:52');
INSERT INTO `access_log` VALUES (50481, '59.75.15625698283017575', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 15:10:28', 3, 0, '', '2019-07-08 15:10:28');
INSERT INTO `access_log` VALUES (50482, '59.74.15625698283077571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 15:10:28', 16, 2001001000, '服务端发生异常', '2019-07-08 15:10:28');
INSERT INTO `access_log` VALUES (50483, '64.77.15625698335087685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:10:34', 3, 0, '', '2019-07-08 15:10:34');
INSERT INTO `access_log` VALUES (50484, '64.85.15625698336367717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:10:34', 2, 0, '', '2019-07-08 15:10:34');
INSERT INTO `access_log` VALUES (50485, '64.84.15625698365787701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:10:37', 2, 0, '', '2019-07-08 15:10:37');
INSERT INTO `access_log` VALUES (50486, '64.76.15625698366997697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:10:37', 1, 0, '', '2019-07-08 15:10:37');
INSERT INTO `access_log` VALUES (50487, '59.76.15625698375787557', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:10:38', 3, 0, '', '2019-07-08 15:10:38');
INSERT INTO `access_log` VALUES (50488, '59.79.15625698375737569', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:10:38', 43, 2001001000, '服务端发生异常', '2019-07-08 15:10:38');
INSERT INTO `access_log` VALUES (50489, '64.83.15625698493597703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:10:49', 2, 0, '', '2019-07-08 15:10:49');
INSERT INTO `access_log` VALUES (50490, '64.81.15625698494697693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:10:49', 1, 0, '', '2019-07-08 15:10:49');
INSERT INTO `access_log` VALUES (50491, '64.82.15625698504137723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:10:50', 2, 0, '', '2019-07-08 15:10:50');
INSERT INTO `access_log` VALUES (50492, '64.80.15625698513407713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:10:51', 2, 0, '', '2019-07-08 15:10:51');
INSERT INTO `access_log` VALUES (50493, '64.77.15625698520997687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:10:52', 2, 0, '', '2019-07-08 15:10:52');
INSERT INTO `access_log` VALUES (50494, '64.85.15625698529957719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:10:53', 1, 0, '', '2019-07-08 15:10:53');
INSERT INTO `access_log` VALUES (50495, '64.78.15625698548367713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:10:55', 2, 0, '', '2019-07-08 15:10:55');
INSERT INTO `access_log` VALUES (50496, '64.84.15625698563647703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:10:56', 2, 0, '', '2019-07-08 15:10:56');
INSERT INTO `access_log` VALUES (50497, '64.83.15625698687657705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:11:09', 2, 0, '', '2019-07-08 15:11:09');
INSERT INTO `access_log` VALUES (50498, '64.81.15625698698847695', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:11:10', 1, 0, '', '2019-07-08 15:11:10');
INSERT INTO `access_log` VALUES (50499, '64.79.15625698729657711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:11:13', 2, 0, '', '2019-07-08 15:11:13');
INSERT INTO `access_log` VALUES (50500, '65.47.15625700413299191', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.160.213.2', '2019-07-08 15:14:01', 0, 1002001015, '账号未登陆', '2019-07-08 15:14:01');
INSERT INTO `access_log` VALUES (50501, '65.49.15625700413309205', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.160.213.2', '2019-07-08 15:14:01', 0, 1002001015, '账号未登陆', '2019-07-08 15:14:01');
INSERT INTO `access_log` VALUES (50502, '65.54.15625700413299171', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.160.213.2', '2019-07-08 15:14:01', 0, 1002001015, '账号未登陆', '2019-07-08 15:14:01');
INSERT INTO `access_log` VALUES (50503, '65.52.15625700452859247', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.160.213.2', '2019-07-08 15:14:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 15:14:05');
INSERT INTO `access_log` VALUES (50504, '65.53.15625700564719211', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.160.213.2', '2019-07-08 15:14:16', 59, 0, '', '2019-07-08 15:14:17');
INSERT INTO `access_log` VALUES (50505, '65.51.15625700569469255', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.160.213.2', '2019-07-08 15:14:17', 9, 0, '', '2019-07-08 15:14:17');
INSERT INTO `access_log` VALUES (50506, '65.45.15625700569539195', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.160.213.2', '2019-07-08 15:14:17', 9, 0, '', '2019-07-08 15:14:17');
INSERT INTO `access_log` VALUES (50507, '65.50.15625700569539237', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.160.213.2', '2019-07-08 15:14:17', 9, 2001001000, '服务端发生异常', '2019-07-08 15:14:17');
INSERT INTO `access_log` VALUES (50508, '65.46.15625702041069265', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-08 15:16:44', 1, 1002001015, '账号未登陆', '2019-07-08 15:16:44');
INSERT INTO `access_log` VALUES (50509, '65.47.15625702041079195', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-08 15:16:44', 1, 1002001015, '账号未登陆', '2019-07-08 15:16:44');
INSERT INTO `access_log` VALUES (50510, '65.54.15625702041099175', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-08 15:16:44', 1, 1002001015, '账号未登陆', '2019-07-08 15:16:44');
INSERT INTO `access_log` VALUES (50511, '64.85.15625702106107725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:16:51', 2, 0, '', '2019-07-08 15:16:51');
INSERT INTO `access_log` VALUES (50512, '64.78.15625702120197719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:16:52', 2, 0, '', '2019-07-08 15:16:52');
INSERT INTO `access_log` VALUES (50513, '64.84.15625702146597709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:16:55', 2, 0, '', '2019-07-08 15:16:55');
INSERT INTO `access_log` VALUES (50514, '65.52.15625702166839251', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-08 15:16:57', 81, 0, '', '2019-07-08 15:16:57');
INSERT INTO `access_log` VALUES (50515, '65.3607.15625702170251013', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-08 15:16:57', 8, 0, '', '2019-07-08 15:16:57');
INSERT INTO `access_log` VALUES (50516, '65.53.15625702170279215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-08 15:16:57', 9, 2001001000, '服务端发生异常', '2019-07-08 15:16:57');
INSERT INTO `access_log` VALUES (50517, '65.51.15625702170299259', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.197', '2019-07-08 15:16:57', 7, 0, '', '2019-07-08 15:16:57');
INSERT INTO `access_log` VALUES (50518, '59.75.15625702191927581', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:16:59', 2, 0, '', '2019-07-08 15:16:59');
INSERT INTO `access_log` VALUES (50519, '59.74.15625702192017577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:16:59', 16, 2001001000, '服务端发生异常', '2019-07-08 15:16:59');
INSERT INTO `access_log` VALUES (50520, '64.83.15625702274347711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:17:07', 2, 0, '', '2019-07-08 15:17:07');
INSERT INTO `access_log` VALUES (50521, '64.81.15625702275457701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:17:08', 2, 0, '', '2019-07-08 15:17:08');
INSERT INTO `access_log` VALUES (50522, '59.76.15625702285657563', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:17:09', 2, 0, '', '2019-07-08 15:17:09');
INSERT INTO `access_log` VALUES (50523, '59.79.15625702285787575', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:17:09', 15, 2001001000, '服务端发生异常', '2019-07-08 15:17:09');
INSERT INTO `access_log` VALUES (50524, '64.79.15625702299187717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:17:10', 2, 0, '', '2019-07-08 15:17:10');
INSERT INTO `access_log` VALUES (50525, '64.82.15625702300217731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:17:10', 2, 0, '', '2019-07-08 15:17:10');
INSERT INTO `access_log` VALUES (50526, '59.71.15625702313167573', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:17:11', 9, 2001001000, '服务端发生异常', '2019-07-08 15:17:11');
INSERT INTO `access_log` VALUES (50527, '59.80.15625702313307553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:17:11', 1, 0, '', '2019-07-08 15:17:11');
INSERT INTO `access_log` VALUES (50528, '64.80.15625702326857721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:17:13', 2, 0, '', '2019-07-08 15:17:13');
INSERT INTO `access_log` VALUES (50529, '64.77.15625702327907695', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:17:13', 2, 0, '', '2019-07-08 15:17:13');
INSERT INTO `access_log` VALUES (50530, '59.72.15625702342367569', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:17:14', 16, 2001001000, '服务端发生异常', '2019-07-08 15:17:14');
INSERT INTO `access_log` VALUES (50531, '59.73.15625702342497579', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 15:17:14', 2, 0, '', '2019-07-08 15:17:14');
INSERT INTO `access_log` VALUES (50532, '65.46.15625702524099267', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 15:17:32', 3, 1002001012, '访问令牌已过期', '2019-07-08 15:17:32');
INSERT INTO `access_log` VALUES (50533, '65.47.15625702524099197', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 15:17:32', 3, 1002001012, '访问令牌已过期', '2019-07-08 15:17:32');
INSERT INTO `access_log` VALUES (50534, '65.54.15625702524129177', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 15:17:32', 2, 1002001012, '访问令牌已过期', '2019-07-08 15:17:32');
INSERT INTO `access_log` VALUES (50535, '65.52.15625702602719253', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 15:17:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 15:17:40');
INSERT INTO `access_log` VALUES (50536, '65.53.15625707393749223', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '58.247.212.141', '2019-07-08 15:25:39', 0, 1002001015, '账号未登陆', '2019-07-08 15:25:39');
INSERT INTO `access_log` VALUES (50537, '65.45.15625707596409207', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '58.246.221.162', '2019-07-08 15:26:00', 1, 1002001015, '账号未登陆', '2019-07-08 15:26:00');
INSERT INTO `access_log` VALUES (50538, '65.46.15625707741679275', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '58.247.204.63', '2019-07-08 15:26:14', 1, 1002001015, '账号未登陆', '2019-07-08 15:26:14');
INSERT INTO `access_log` VALUES (50539, '65.54.15625716474539197', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:40:47', 0, 1002001015, '账号未登陆', '2019-07-08 15:40:47');
INSERT INTO `access_log` VALUES (50540, '65.46.15625716474619287', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:40:47', 0, 1002001015, '账号未登陆', '2019-07-08 15:40:47');
INSERT INTO `access_log` VALUES (50541, '65.47.15625716474919217', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:40:47', 1, 1002001015, '账号未登陆', '2019-07-08 15:40:47');
INSERT INTO `access_log` VALUES (50542, '65.49.15625716535269231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:40:54', 74, 0, '', '2019-07-08 15:40:54');
INSERT INTO `access_log` VALUES (50543, '65.3607.15625716539661035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:40:54', 9, 0, '', '2019-07-08 15:40:54');
INSERT INTO `access_log` VALUES (50544, '65.51.15625716539759281', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:40:54', 10, 2001001000, '服务端发生异常', '2019-07-08 15:40:54');
INSERT INTO `access_log` VALUES (50545, '65.53.15625716539819237', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:40:54', 9, 0, '', '2019-07-08 15:40:54');
INSERT INTO `access_log` VALUES (50546, '65.50.15625716647539263', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:41:05', 9, 0, '', '2019-07-08 15:41:05');
INSERT INTO `access_log` VALUES (50547, '65.45.15625716647619221', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:41:05', 9, 2001001000, '服务端发生异常', '2019-07-08 15:41:05');
INSERT INTO `access_log` VALUES (50548, '65.54.15625716647759199', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:41:05', 9, 0, '', '2019-07-08 15:41:05');
INSERT INTO `access_log` VALUES (50549, '65.49.15625716974339233', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:41:37', 9, 0, '', '2019-07-08 15:41:37');
INSERT INTO `access_log` VALUES (50550, '65.52.15625716974519275', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:41:37', 10, 2001001000, '服务端发生异常', '2019-07-08 15:41:37');
INSERT INTO `access_log` VALUES (50551, '65.3607.15625716974871037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:41:37', 9, 0, '', '2019-07-08 15:41:37');
INSERT INTO `access_log` VALUES (50552, '65.53.15625717073939239', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:41:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 15:41:47');
INSERT INTO `access_log` VALUES (50553, '65.54.15625717096919201', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:41:50', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 15:41:50');
INSERT INTO `access_log` VALUES (50554, '65.50.15625717106699265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:41:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 15:41:51');
INSERT INTO `access_log` VALUES (50555, '65.45.15625717115559223', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:41:52', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 15:41:52');
INSERT INTO `access_log` VALUES (50556, '65.46.15625717123609291', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '124.205.133.18', '2019-07-08 15:41:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 15:41:52');
INSERT INTO `access_log` VALUES (50557, '65.51.15625719193349287', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '140.207.82.170', '2019-07-08 15:45:19', 0, 1002001015, '账号未登陆', '2019-07-08 15:45:19');
INSERT INTO `access_log` VALUES (50558, '65.53.15625719193369243', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '140.206.181.53', '2019-07-08 15:45:19', 0, 1002001015, '账号未登陆', '2019-07-08 15:45:19');
INSERT INTO `access_log` VALUES (50559, '65.54.15625719193499205', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '140.206.181.53', '2019-07-08 15:45:19', 0, 1002001015, '账号未登陆', '2019-07-08 15:45:19');
INSERT INTO `access_log` VALUES (50560, '65.45.15625719374829227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '140.206.181.53', '2019-07-08 15:45:37', 256, 0, '', '2019-07-08 15:45:38');
INSERT INTO `access_log` VALUES (50561, '65.46.15625719381669295', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '140.206.181.53', '2019-07-08 15:45:38', 9, 0, '', '2019-07-08 15:45:38');
INSERT INTO `access_log` VALUES (50562, '65.47.15625719381779225', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '140.206.181.53', '2019-07-08 15:45:38', 10, 2001001000, '服务端发生异常', '2019-07-08 15:45:38');
INSERT INTO `access_log` VALUES (50563, '65.49.15625719381879239', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/62.0.3202.75 Safari/537.36', '140.206.181.53', '2019-07-08 15:45:38', 16, 0, '', '2019-07-08 15:45:38');
INSERT INTO `access_log` VALUES (50564, '59.75.15625726402317615', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '36.7.87.91', '2019-07-08 15:57:20', 10, 0, '', '2019-07-08 15:57:20');
INSERT INTO `access_log` VALUES (50565, '59.74.15625726402317611', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '36.7.87.91', '2019-07-08 15:57:20', 15, 2001001000, '服务端发生异常', '2019-07-08 15:57:20');
INSERT INTO `access_log` VALUES (50566, '65.52.15625728644649293', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.116.110.232', '2019-07-08 16:01:04', 1, 1002001015, '账号未登陆', '2019-07-08 16:01:04');
INSERT INTO `access_log` VALUES (50567, '65.3607.15625728644661055', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.116.110.232', '2019-07-08 16:01:04', 1, 1002001015, '账号未登陆', '2019-07-08 16:01:04');
INSERT INTO `access_log` VALUES (50568, '65.53.15625728644699259', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.116.110.232', '2019-07-08 16:01:04', 0, 1002001015, '账号未登陆', '2019-07-08 16:01:04');
INSERT INTO `access_log` VALUES (50569, '65.51.15625728659759303', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.116.110.232', '2019-07-08 16:01:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 16:01:06');
INSERT INTO `access_log` VALUES (50570, '65.45.15625728692949243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.116.110.232', '2019-07-08 16:01:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 16:01:09');
INSERT INTO `access_log` VALUES (50571, '65.50.15625728706049285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.116.110.232', '2019-07-08 16:01:11', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 16:01:11');
INSERT INTO `access_log` VALUES (50572, '65.46.15625728789469309', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.116.110.232', '2019-07-08 16:01:19', 85, 0, '', '2019-07-08 16:01:19');
INSERT INTO `access_log` VALUES (50573, '65.47.15625728793289239', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.116.110.232', '2019-07-08 16:01:19', 10, 0, '', '2019-07-08 16:01:19');
INSERT INTO `access_log` VALUES (50574, '65.49.15625728793319253', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.116.110.232', '2019-07-08 16:01:19', 9, 2001001000, '服务端发生异常', '2019-07-08 16:01:19');
INSERT INTO `access_log` VALUES (50575, '65.53.15625728793409261', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '118.116.110.232', '2019-07-08 16:01:19', 8, 0, '', '2019-07-08 16:01:19');
INSERT INTO `access_log` VALUES (50576, '59.74.15625729127587615', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.221.125.222', '2019-07-08 16:01:53', 3, 0, '', '2019-07-08 16:01:53');
INSERT INTO `access_log` VALUES (50577, '59.75.15625729127787619', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.221.125.222', '2019-07-08 16:01:53', 18, 2001001000, '服务端发生异常', '2019-07-08 16:01:53');
INSERT INTO `access_log` VALUES (50578, '65.54.15625729159439223', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.221.125.222', '2019-07-08 16:01:56', 1, 1002001015, '账号未登陆', '2019-07-08 16:01:56');
INSERT INTO `access_log` VALUES (50579, '65.45.15625729159789245', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.221.125.222', '2019-07-08 16:01:56', 1, 1002001015, '账号未登陆', '2019-07-08 16:01:56');
INSERT INTO `access_log` VALUES (50580, '65.50.15625729159959287', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.221.125.222', '2019-07-08 16:01:56', 1, 1002001015, '账号未登陆', '2019-07-08 16:01:56');
INSERT INTO `access_log` VALUES (50581, '65.3607.15625729998611059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.221.125.222', '2019-07-08 16:03:20', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 16:03:20');
INSERT INTO `access_log` VALUES (50582, '65.50.15625730216979289', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.221.125.222', '2019-07-08 16:03:42', 186, 0, '', '2019-07-08 16:03:42');
INSERT INTO `access_log` VALUES (50583, '65.45.15625730221469247', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.221.125.222', '2019-07-08 16:03:42', 9, 0, '', '2019-07-08 16:03:42');
INSERT INTO `access_log` VALUES (50584, '65.46.15625730221469313', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.221.125.222', '2019-07-08 16:03:42', 10, 2001001000, '服务端发生异常', '2019-07-08 16:03:42');
INSERT INTO `access_log` VALUES (50585, '65.49.15625730221679257', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.221.125.222', '2019-07-08 16:03:42', 8, 0, '', '2019-07-08 16:03:42');
INSERT INTO `access_log` VALUES (50586, '65.52.15625730607989299', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.230.207.116', '2019-07-08 16:04:21', 1, 1002001015, '账号未登陆', '2019-07-08 16:04:21');
INSERT INTO `access_log` VALUES (50587, '65.3607.15625730608061061', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.230.207.116', '2019-07-08 16:04:21', 1, 1002001015, '账号未登陆', '2019-07-08 16:04:21');
INSERT INTO `access_log` VALUES (50588, '65.51.15625730608069309', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.230.207.116', '2019-07-08 16:04:21', 0, 1002001015, '账号未登陆', '2019-07-08 16:04:21');
INSERT INTO `access_log` VALUES (50589, '65.54.15625730634079227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.230.207.116', '2019-07-08 16:04:23', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 16:04:23');
INSERT INTO `access_log` VALUES (50590, '65.45.15625730735379249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.230.207.116', '2019-07-08 16:04:34', 75, 0, '', '2019-07-08 16:04:34');
INSERT INTO `access_log` VALUES (50591, '65.46.15625730778139315', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.230.207.116', '2019-07-08 16:04:38', 88, 0, '', '2019-07-08 16:04:38');
INSERT INTO `access_log` VALUES (50592, '65.53.15625730826099267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '101.230.207.116', '2019-07-08 16:04:43', 90, 0, '', '2019-07-08 16:04:43');
INSERT INTO `access_log` VALUES (50593, '65.53.15625742706989283', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.52.234', '2019-07-08 16:24:31', 0, 1002001015, '账号未登陆', '2019-07-08 16:24:31');
INSERT INTO `access_log` VALUES (50594, '65.47.15625742706989261', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.52.234', '2019-07-08 16:24:31', 0, 1002001015, '账号未登陆', '2019-07-08 16:24:31');
INSERT INTO `access_log` VALUES (50595, '65.3607.15625742706991079', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.52.234', '2019-07-08 16:24:31', 0, 1002001015, '账号未登陆', '2019-07-08 16:24:31');
INSERT INTO `access_log` VALUES (50596, '65.52.15625742860079317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma &password=yudaoyuanma &type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.52.234', '2019-07-08 16:24:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号格式为数字以及字母', '2019-07-08 16:24:46');
INSERT INTO `access_log` VALUES (50597, '65.54.15625742924129245', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.52.234', '2019-07-08 16:24:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 16:24:52');
INSERT INTO `access_log` VALUES (50598, '65.45.15625743070229267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.52.234', '2019-07-08 16:25:07', 57, 0, '', '2019-07-08 16:25:07');
INSERT INTO `access_log` VALUES (50599, '65.46.15625743073329333', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.52.234', '2019-07-08 16:25:07', 9, 0, '', '2019-07-08 16:25:07');
INSERT INTO `access_log` VALUES (50600, '65.49.15625743073329277', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.52.234', '2019-07-08 16:25:07', 9, 2001001000, '服务端发生异常', '2019-07-08 16:25:07');
INSERT INTO `access_log` VALUES (50601, '65.3607.15625743073381081', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.52.234', '2019-07-08 16:25:07', 8, 0, '', '2019-07-08 16:25:07');
INSERT INTO `access_log` VALUES (50602, '65.3607.15625744309821083', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.75.39', '2019-07-08 16:27:11', 1, 1002001015, '账号未登陆', '2019-07-08 16:27:11');
INSERT INTO `access_log` VALUES (50603, '65.47.15625744309959265', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.75.39', '2019-07-08 16:27:11', 0, 1002001015, '账号未登陆', '2019-07-08 16:27:11');
INSERT INTO `access_log` VALUES (50604, '65.53.15625744310099287', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.75.39', '2019-07-08 16:27:11', 0, 1002001015, '账号未登陆', '2019-07-08 16:27:11');
INSERT INTO `access_log` VALUES (50605, '65.51.15625744336199331', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.75.39', '2019-07-08 16:27:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 16:27:14');
INSERT INTO `access_log` VALUES (50606, '65.52.15625744426269321', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.75.39', '2019-07-08 16:27:23', 84, 0, '', '2019-07-08 16:27:23');
INSERT INTO `access_log` VALUES (50607, '65.54.15625744431599249', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.75.39', '2019-07-08 16:27:23', 10, 0, '', '2019-07-08 16:27:23');
INSERT INTO `access_log` VALUES (50608, '65.45.15625744431679271', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.75.39', '2019-07-08 16:27:23', 9, 0, '', '2019-07-08 16:27:23');
INSERT INTO `access_log` VALUES (50609, '65.50.15625744431679313', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.75.39', '2019-07-08 16:27:23', 9, 2001001000, '服务端发生异常', '2019-07-08 16:27:23');
INSERT INTO `access_log` VALUES (50610, '65.46.15625744553319337', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.75.39', '2019-07-08 16:27:35', 9, 0, '', '2019-07-08 16:27:35');
INSERT INTO `access_log` VALUES (50611, '65.47.15625744553449267', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.75.39', '2019-07-08 16:27:35', 10, 2001001000, '服务端发生异常', '2019-07-08 16:27:35');
INSERT INTO `access_log` VALUES (50612, '65.3607.15625744553451085', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.75.39', '2019-07-08 16:27:35', 8, 0, '', '2019-07-08 16:27:35');
INSERT INTO `access_log` VALUES (50613, '59.79.15625745921287635', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.75.39', '2019-07-08 16:29:52', 3, 0, '', '2019-07-08 16:29:52');
INSERT INTO `access_log` VALUES (50614, '59.80.15625745921397613', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.75.39', '2019-07-08 16:29:52', 16, 2001001000, '服务端发生异常', '2019-07-08 16:29:52');
INSERT INTO `access_log` VALUES (50615, '65.53.15625749008389295', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.119.104', '2019-07-08 16:35:01', 4, 1002001012, '访问令牌已过期', '2019-07-08 16:35:01');
INSERT INTO `access_log` VALUES (50616, '65.51.15625749008409339', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.119.104', '2019-07-08 16:35:01', 3, 1002001012, '访问令牌已过期', '2019-07-08 16:35:01');
INSERT INTO `access_log` VALUES (50617, '65.52.15625749008529329', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.119.104', '2019-07-08 16:35:01', 3, 1002001012, '访问令牌已过期', '2019-07-08 16:35:01');
INSERT INTO `access_log` VALUES (50618, '65.50.15625749143639321', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.119.104', '2019-07-08 16:35:14', 89, 0, '', '2019-07-08 16:35:14');
INSERT INTO `access_log` VALUES (50619, '65.45.15625749148539279', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.119.104', '2019-07-08 16:35:15', 21, 0, '', '2019-07-08 16:35:15');
INSERT INTO `access_log` VALUES (50620, '65.46.15625749148639345', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.119.104', '2019-07-08 16:35:15', 10, 0, '', '2019-07-08 16:35:15');
INSERT INTO `access_log` VALUES (50621, '65.49.15625749148569289', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.119.104', '2019-07-08 16:35:15', 18, 2001001000, '服务端发生异常', '2019-07-08 16:35:15');
INSERT INTO `access_log` VALUES (50622, '59.75.15625757249437657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-08 16:48:45', 8, 0, '', '2019-07-08 16:48:45');
INSERT INTO `access_log` VALUES (50623, '59.77.15625757249457637', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-08 16:48:45', 13, 2001001000, '服务端发生异常', '2019-07-08 16:48:45');
INSERT INTO `access_log` VALUES (50624, '64.79.15625757285207791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-08 16:48:49', 10, 0, '', '2019-07-08 16:48:49');
INSERT INTO `access_log` VALUES (50625, '64.82.15625757286157805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-08 16:48:49', 3, 0, '', '2019-07-08 16:48:49');
INSERT INTO `access_log` VALUES (50626, '64.80.15625757297127795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-08 16:48:50', 2, 0, '', '2019-07-08 16:48:50');
INSERT INTO `access_log` VALUES (50627, '64.77.15625757301097769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-08 16:48:50', 1, 0, '', '2019-07-08 16:48:50');
INSERT INTO `access_log` VALUES (50628, '64.85.15625757303967801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-08 16:48:50', 2, 0, '', '2019-07-08 16:48:50');
INSERT INTO `access_log` VALUES (50629, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-08 16:48:52', 7, 0, '', '2019-07-08 16:48:52');
INSERT INTO `access_log` VALUES (50630, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-08 16:48:52', 5, 0, '', '2019-07-08 16:48:52');
INSERT INTO `access_log` VALUES (50631, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-08 16:48:52', 11, 0, '', '2019-07-08 16:48:52');
INSERT INTO `access_log` VALUES (50632, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-08 16:48:52', 10, 0, '', '2019-07-08 16:48:52');
INSERT INTO `access_log` VALUES (50633, '64.84.15625757335777785', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-08 16:48:54', 7, 0, '', '2019-07-08 16:48:54');
INSERT INTO `access_log` VALUES (50634, '66.52.15625757394035677', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-08 16:48:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空', '2019-07-08 16:48:59');
INSERT INTO `access_log` VALUES (50635, '65.49.15625757779879301', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-07-08 16:49:38', 97, 0, '', '2019-07-08 16:49:38');
INSERT INTO `access_log` VALUES (50636, '65.45.15625757784429291', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-07-08 16:49:38', 10, 0, '', '2019-07-08 16:49:38');
INSERT INTO `access_log` VALUES (50637, '65.46.15625757784469357', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-07-08 16:49:38', 16, 2001001000, '服务端发生异常', '2019-07-08 16:49:38');
INSERT INTO `access_log` VALUES (50638, '65.3607.15625757784601105', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-07-08 16:49:38', 9, 0, '', '2019-07-08 16:49:38');
INSERT INTO `access_log` VALUES (50639, '66.52.15625760257465681', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18758051658&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 16:53:46', 16, 1001003000, '验证码不存在', '2019-07-08 16:53:46');
INSERT INTO `access_log` VALUES (50640, '66.48.15625760273595701', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18758051658', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 16:53:47', 173, 0, '', '2019-07-08 16:53:48');
INSERT INTO `access_log` VALUES (50641, '66.50.15625760303745685', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18758051658&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 16:53:50', 296, 0, '', '2019-07-08 16:53:51');
INSERT INTO `access_log` VALUES (50642, '66.57.15625760317475689', 160, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 16:53:52', 8, 0, '', '2019-07-08 16:53:52');
INSERT INTO `access_log` VALUES (50643, '66.55.15625760356325671', 160, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 16:53:56', 6, 0, '', '2019-07-08 16:53:56');
INSERT INTO `access_log` VALUES (50644, '66.53.15625760367105695', 160, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 16:53:57', 6, 0, '', '2019-07-08 16:53:57');
INSERT INTO `access_log` VALUES (50645, '66.51.15625760379925715', 160, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 16:53:58', 6, 0, '', '2019-07-08 16:53:58');
INSERT INTO `access_log` VALUES (50646, '66.52.15625760489025683', 160, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 16:54:09', 6, 0, '', '2019-07-08 16:54:09');
INSERT INTO `access_log` VALUES (50647, '66.48.15625760522955703', 160, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 16:54:12', 7, 0, '', '2019-07-08 16:54:12');
INSERT INTO `access_log` VALUES (50648, '59.72.15625761833137651', 160, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 16:56:23', 8, 0, '', '2019-07-08 16:56:23');
INSERT INTO `access_log` VALUES (50649, '59.71.15625761833137655', 160, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 16:56:23', 18, 2001001000, '服务端发生异常', '2019-07-08 16:56:23');
INSERT INTO `access_log` VALUES (50650, '162f545d-d8f8-4173-bc01-e444fed284a5', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-08 17:21:01', 58, 0, '', '2019-07-08 17:21:01');
INSERT INTO `access_log` VALUES (50651, '3a3c007e-199e-4cf4-9b21-ee082b0c6247', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-08 17:20:58', 1744, 0, '', '2019-07-08 17:21:01');
INSERT INTO `access_log` VALUES (50652, '3a3c007e-199e-4cf4-9b21-ee082b0c6247', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-08 17:20:58', 1744, 0, '', '2019-07-08 17:21:01');
INSERT INTO `access_log` VALUES (50653, '3a3c007e-199e-4cf4-9b21-ee082b0c6247', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-08 17:20:58', 1744, 0, '', '2019-07-08 17:21:02');
INSERT INTO `access_log` VALUES (50654, '162f545d-d8f8-4173-bc01-e444fed284a5', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-08 17:21:01', 58, 0, '', '2019-07-08 17:21:02');
INSERT INTO `access_log` VALUES (50655, '7f64108c-fc46-4917-9d82-49371d44eff9', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-08 17:20:58', 5127, 2001001000, '服务端发生异常', '2019-07-08 17:21:03');
INSERT INTO `access_log` VALUES (50656, 'db8d9949-e3dc-40f6-a4eb-5a67abe8c22d', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-08 17:21:03', 3376, 2001001000, '服务端发生异常', '2019-07-08 17:21:06');
INSERT INTO `access_log` VALUES (50657, '958c6e6a-e001-44d9-a31a-650018f18c9c', 0, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:21:24', 90, 1002001015, '账号未登陆', '2019-07-08 17:21:24');
INSERT INTO `access_log` VALUES (50658, 'f73e3151-907f-4666-a00c-a19728cdc1ba', 0, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:21:23', 393, 1002001015, '账号未登陆', '2019-07-08 17:21:24');
INSERT INTO `access_log` VALUES (50659, '7632081d-8aff-4af9-a89a-ce3d54373ba9', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-08 17:21:50', 581, 0, '', '2019-07-08 17:21:51');
INSERT INTO `access_log` VALUES (50660, 'b6170fa8-dcc2-4eae-a3ea-4a26ec6cbdc0', 30, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:22:18', 1257, 0, '', '2019-07-08 17:22:20');
INSERT INTO `access_log` VALUES (50661, 'f0f6ef4a-aeb1-432d-a9de-b3aef0b92929', 30, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:22:28', 329, 0, '', '2019-07-08 17:22:28');
INSERT INTO `access_log` VALUES (50662, 'ca916f81-353c-49f1-b0e2-5e5a2e6f511b', 30, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:22:28', 454, 0, '', '2019-07-08 17:22:28');
INSERT INTO `access_log` VALUES (50663, '14af5b29-aaac-4d69-9dd9-ff3b34769c34', 30, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:22:34', 164, 0, '', '2019-07-08 17:22:34');
INSERT INTO `access_log` VALUES (50664, 'dedd75ab-89a8-49ba-b48b-9e6a4c7253e6', 30, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:22:34', 586, 0, '', '2019-07-08 17:22:34');
INSERT INTO `access_log` VALUES (50665, '4649044b-88cd-4f82-9b9c-2d17095a5972', 30, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:22:35', 669, 0, '', '2019-07-08 17:22:35');
INSERT INTO `access_log` VALUES (50666, 'e81da295-c6ca-4637-8419-833287999d81', 30, 1, 'order-impl', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:22:41', 571, 0, '', '2019-07-08 17:22:41');
INSERT INTO `access_log` VALUES (50667, 'c8e3a994-369d-46e9-a1fd-5d3b8a51490a', 30, 1, 'order-impl', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:23:36', 421, 0, '', '2019-07-08 17:23:36');
INSERT INTO `access_log` VALUES (50668, 'b824ada9-749a-431f-8d8d-aef5a0005aa3', 30, 1, 'order-impl', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:24:01', 422, 0, '', '2019-07-08 17:24:01');
INSERT INTO `access_log` VALUES (50669, '4b689a47-6580-43b9-b327-8f5fed3fbe52', 30, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:24:02', 200, 0, '', '2019-07-08 17:24:03');
INSERT INTO `access_log` VALUES (50670, '33eb8304-9285-4ac3-9868-fc0cc843fd22', 30, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:24:02', 385, 0, '', '2019-07-08 17:24:03');
INSERT INTO `access_log` VALUES (50671, '33329c47-3f76-4fdd-9e61-4f626313e689', 30, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:24:03', 184, 0, '', '2019-07-08 17:24:03');
INSERT INTO `access_log` VALUES (50672, '9dc5433f-7bd3-42dd-8e2d-e57137971803', 30, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:24:04', 130, 0, '', '2019-07-08 17:24:04');
INSERT INTO `access_log` VALUES (50673, '24903951-a2e3-4249-a946-d4c7162ac003', 30, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:24:06', 124, 0, '', '2019-07-08 17:24:06');
INSERT INTO `access_log` VALUES (50674, '80d95004-3052-475d-a0d3-ad1ac2a69cba', 30, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:24:06', 329, 0, '', '2019-07-08 17:24:06');
INSERT INTO `access_log` VALUES (50675, '0f784d58-498c-4b25-ab93-c9fc0f2b329b', 30, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:24:07', 191, 0, '', '2019-07-08 17:24:07');
INSERT INTO `access_log` VALUES (50676, '7f4f1ee7-32b8-4c12-a252-70e28aa0cbab', 30, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:24:11', 202, 0, '', '2019-07-08 17:24:11');
INSERT INTO `access_log` VALUES (50677, '677ff53e-8e8f-475b-866a-0114173915cb', 30, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '127.0.0.1', '2019-07-08 17:24:11', 189, 0, '', '2019-07-08 17:24:11');
INSERT INTO `access_log` VALUES (50678, '65.52.15625780884549375', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:28:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 17:28:08');
INSERT INTO `access_log` VALUES (50679, '65.50.15625781061289365', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoy7uanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:28:26', 104, 0, '', '2019-07-08 17:28:26');
INSERT INTO `access_log` VALUES (50680, '65.49.15625781064729335', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:28:26', 16, 0, '', '2019-07-08 17:28:26');
INSERT INTO `access_log` VALUES (50681, '65.46.15625781064739389', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:28:26', 16, 2001001000, '服务端发生异常', '2019-07-08 17:28:26');
INSERT INTO `access_log` VALUES (50682, '65.51.15625781064739387', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:28:26', 20, 0, '', '2019-07-08 17:28:26');
INSERT INTO `access_log` VALUES (50683, '65.3607.15625781205941139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:28:41', 4, 1002002001, '密码不正确', '2019-07-08 17:28:41');
INSERT INTO `access_log` VALUES (50684, '65.47.15625781254829321', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:28:45', 150, 0, '', '2019-07-08 17:28:46');
INSERT INTO `access_log` VALUES (50685, '65.53.15625781258089341', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:28:46', 17, 0, '', '2019-07-08 17:28:46');
INSERT INTO `access_log` VALUES (50686, '65.52.15625781258089377', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:28:46', 17, 0, '', '2019-07-08 17:28:46');
INSERT INTO `access_log` VALUES (50687, '65.54.15625781258119303', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:28:46', 10, 0, '', '2019-07-08 17:28:46');
INSERT INTO `access_log` VALUES (50688, '62.81.15625781312456957', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:28:51', 130, 0, '', '2019-07-08 17:28:51');
INSERT INTO `access_log` VALUES (50689, '62.83.15625781349607001', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:28:55', 37, 0, '', '2019-07-08 17:28:55');
INSERT INTO `access_log` VALUES (50690, '66.54.15625781383795723', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:28:58', 20, 0, '', '2019-07-08 17:28:58');
INSERT INTO `access_log` VALUES (50691, '59.73.15625781418447687', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:29:02', 23, 0, '', '2019-07-08 17:29:02');
INSERT INTO `access_log` VALUES (50692, '59.74.15625781450497687', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:29:05', 22, 2001001000, '服务端发生异常', '2019-07-08 17:29:05');
INSERT INTO `access_log` VALUES (50693, '59.75.15625781490007691', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-08 17:29:09', 23, 0, '', '2019-07-08 17:29:09');
INSERT INTO `access_log` VALUES (50694, '1271d873-3eb0-4f8b-bebf-8e709c3f439f', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-08 17:40:13', 255, 1002001015, '账号未登陆', '2019-07-08 17:40:14');
INSERT INTO `access_log` VALUES (50695, 'c9d4b8bf-fcb7-44bc-9a23-c94ed6fa3dff', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-08 17:40:13', 255, 1002001015, '账号未登陆', '2019-07-08 17:40:14');
INSERT INTO `access_log` VALUES (50696, '6359093b-b007-44f1-b68e-4bc3467c45fd', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-08 17:40:13', 255, 1002001015, '账号未登陆', '2019-07-08 17:40:14');
INSERT INTO `access_log` VALUES (50697, '64.78.15625789929407839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:13', 19, 0, '', '2019-07-08 17:43:13');
INSERT INTO `access_log` VALUES (50698, '64.76.15625789930717825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:13', 12, 0, '', '2019-07-08 17:43:13');
INSERT INTO `access_log` VALUES (50699, '64.81.15625789956377821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:16', 7, 0, '', '2019-07-08 17:43:16');
INSERT INTO `access_log` VALUES (50700, '64.82.15625789980057851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:18', 9, 0, '', '2019-07-08 17:43:18');
INSERT INTO `access_log` VALUES (50701, '64.80.15625789983747841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:18', 9, 0, '', '2019-07-08 17:43:18');
INSERT INTO `access_log` VALUES (50702, '64.77.15625789998157815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:20', 9, 0, '', '2019-07-08 17:43:20');
INSERT INTO `access_log` VALUES (50703, '64.78.15625790011037841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:21', 10, 0, '', '2019-07-08 17:43:21');
INSERT INTO `access_log` VALUES (50704, '64.84.15625790025687831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:23', 10, 0, '', '2019-07-08 17:43:23');
INSERT INTO `access_log` VALUES (50705, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:23', 13, 0, '', '2019-07-08 17:43:23');
INSERT INTO `access_log` VALUES (50706, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:24', 16, 0, '', '2019-07-08 17:43:24');
INSERT INTO `access_log` VALUES (50707, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:29', 14, 0, '', '2019-07-08 17:43:29');
INSERT INTO `access_log` VALUES (50708, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:30', 11, 0, '', '2019-07-08 17:43:30');
INSERT INTO `access_log` VALUES (50709, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:30', 21, 0, '', '2019-07-08 17:43:30');
INSERT INTO `access_log` VALUES (50710, '64.83.15625790112967833', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:31', 14, 0, '', '2019-07-08 17:43:31');
INSERT INTO `access_log` VALUES (50711, '66.49.15625790363465747', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:56', 10, 0, '', '2019-07-08 17:43:56');
INSERT INTO `access_log` VALUES (50712, '66.55.15625790384455713', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:43:58', 8, 0, '', '2019-07-08 17:43:58');
INSERT INTO `access_log` VALUES (50713, '66.56.15625790530915743', 0, 1, 'user-application', '/user-api/users/address/add', 'name=1&tel=18758051655&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=12&isDefault=true&address=12&areaNo=110101&mobile=18758051655&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:13', 95, 2001001000, '服务端发生异常', '2019-07-08 17:44:13');
INSERT INTO `access_log` VALUES (50714, '66.52.15625790550905725', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:15', 8, 0, '', '2019-07-08 17:44:15');
INSERT INTO `access_log` VALUES (50715, '66.48.15625790574355745', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:17', 11, 0, '', '2019-07-08 17:44:17');
INSERT INTO `access_log` VALUES (50716, '64.80.15625790587487843', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:19', 11, 0, '', '2019-07-08 17:44:19');
INSERT INTO `access_log` VALUES (50717, '64.85.15625790608427849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:21', 8, 0, '', '2019-07-08 17:44:21');
INSERT INTO `access_log` VALUES (50718, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:21', 14, 0, '', '2019-07-08 17:44:21');
INSERT INTO `access_log` VALUES (50719, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:22', 14, 0, '', '2019-07-08 17:44:22');
INSERT INTO `access_log` VALUES (50720, '64.84.15625790638587833', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:24', 14, 0, '', '2019-07-08 17:44:24');
INSERT INTO `access_log` VALUES (50721, '64.83.15625790816127835', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:42', 14, 0, '', '2019-07-08 17:44:42');
INSERT INTO `access_log` VALUES (50722, '64.81.15625790823787825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:42', 8, 0, '', '2019-07-08 17:44:42');
INSERT INTO `access_log` VALUES (50723, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:42', 13, 0, '', '2019-07-08 17:44:42');
INSERT INTO `access_log` VALUES (50724, '64.79.15625790834677841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:43', 7, 0, '', '2019-07-08 17:44:43');
INSERT INTO `access_log` VALUES (50725, '64.82.15625790835487855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:44', 7, 0, '', '2019-07-08 17:44:44');
INSERT INTO `access_log` VALUES (50726, '64.80.15625790875547845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:48', 8, 0, '', '2019-07-08 17:44:48');
INSERT INTO `access_log` VALUES (50727, '64.77.15625790876607819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:48', 7, 0, '', '2019-07-08 17:44:48');
INSERT INTO `access_log` VALUES (50728, '66.57.15625790889475733', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:49', 6, 1002001012, '访问令牌已过期', '2019-07-08 17:44:49');
INSERT INTO `access_log` VALUES (50729, '66.55.15625790890425715', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=5d47b7b80abf407f8ef11f792f103fe1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:49', 395, 0, '', '2019-07-08 17:44:49');
INSERT INTO `access_log` VALUES (50730, '66.53.15625790895525739', 160, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:50', 7, 0, '', '2019-07-08 17:44:50');
INSERT INTO `access_log` VALUES (50731, '66.56.15625790912335745', 160, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:51', 6, 0, '', '2019-07-08 17:44:51');
INSERT INTO `access_log` VALUES (50732, '66.52.15625790951105727', 160, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:55', 6, 0, '', '2019-07-08 17:44:55');
INSERT INTO `access_log` VALUES (50733, '66.48.15625791030405747', 160, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:45:03', 6, 0, '', '2019-07-08 17:45:03');
INSERT INTO `access_log` VALUES (50734, '66.49.15625791094785751', 160, 1, 'user-application', '/user-api/users/user/update_nickname', 'nickname=AA', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:45:09', 68, 0, '', '2019-07-08 17:45:10');
INSERT INTO `access_log` VALUES (50735, '66.57.15625791133335735', 160, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:45:13', 5, 0, '', '2019-07-08 17:45:13');
INSERT INTO `access_log` VALUES (50736, '59.75.15625791445497705', 160, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:45:45', 7, 0, '', '2019-07-08 17:45:45');
INSERT INTO `access_log` VALUES (50737, '59.74.15625791445477701', 160, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:45:45', 18, 2001001000, '服务端发生异常', '2019-07-08 17:45:45');
INSERT INTO `access_log` VALUES (50738, '59.79.15625794707007703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:11', 4, 0, '', '2019-07-08 17:51:11');
INSERT INTO `access_log` VALUES (50739, '59.80.15625794707007681', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:11', 14, 2001001000, '服务端发生异常', '2019-07-08 17:51:11');
INSERT INTO `access_log` VALUES (50740, '65.50.15625794727279387', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:13', 4, 1002001012, '访问令牌已过期', '2019-07-08 17:51:13');
INSERT INTO `access_log` VALUES (50741, '65.49.15625794727299357', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:13', 3, 1002001012, '访问令牌已过期', '2019-07-08 17:51:13');
INSERT INTO `access_log` VALUES (50742, '65.46.15625794727299409', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:13', 3, 1002001012, '访问令牌已过期', '2019-07-08 17:51:13');
INSERT INTO `access_log` VALUES (50743, '64.79.15625794740857847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:14', 111, 0, '', '2019-07-08 17:51:14');
INSERT INTO `access_log` VALUES (50744, '64.82.15625794743167861', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:14', 2, 0, '', '2019-07-08 17:51:14');
INSERT INTO `access_log` VALUES (50745, '66.52.15625794761835733', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:16', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-07-08 17:51:16');
INSERT INTO `access_log` VALUES (50746, '64.80.15625794781167851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:18', 2, 0, '', '2019-07-08 17:51:18');
INSERT INTO `access_log` VALUES (50747, '64.77.15625794781817825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:18', 2, 0, '', '2019-07-08 17:51:18');
INSERT INTO `access_log` VALUES (50748, '64.85.15625794792807857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:19', 2, 0, '', '2019-07-08 17:51:19');
INSERT INTO `access_log` VALUES (50749, '64.78.15625794801927851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:20', 1, 0, '', '2019-07-08 17:51:20');
INSERT INTO `access_log` VALUES (50750, '65.52.15625794832219397', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:23', 78, 0, '', '2019-07-08 17:51:23');
INSERT INTO `access_log` VALUES (50751, '65.51.15625794837599409', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:24', 11, 2001001000, '服务端发生异常', '2019-07-08 17:51:24');
INSERT INTO `access_log` VALUES (50752, '65.45.15625794838779345', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:24', 10, 0, '', '2019-07-08 17:51:24');
INSERT INTO `access_log` VALUES (50753, '65.47.15625794840329341', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:24', 8, 0, '', '2019-07-08 17:51:24');
INSERT INTO `access_log` VALUES (50754, '65.53.15625794902369361', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:30', 8, 0, '', '2019-07-08 17:51:30');
INSERT INTO `access_log` VALUES (50755, '65.54.15625794902419323', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:30', 10, 2001001000, '服务端发生异常', '2019-07-08 17:51:30');
INSERT INTO `access_log` VALUES (50756, '65.50.15625794902449389', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:30', 9, 0, '', '2019-07-08 17:51:30');
INSERT INTO `access_log` VALUES (50757, '65.49.15625794941849359', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.120.186', '2019-07-08 17:51:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 17:51:34');
INSERT INTO `access_log` VALUES (50758, '59.74.15625795304157707', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '183.15.176.230', '2019-07-08 17:52:10', 3, 0, '', '2019-07-08 17:52:10');
INSERT INTO `access_log` VALUES (50759, '59.75.15625795304207711', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '183.15.176.230', '2019-07-08 17:52:10', 12, 2001001000, '服务端发生异常', '2019-07-08 17:52:10');
INSERT INTO `access_log` VALUES (50760, '65.45.15625807435589363', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:12:24', 1, 1002001015, '账号未登陆', '2019-07-08 18:12:24');
INSERT INTO `access_log` VALUES (50761, '65.3607.15625807435571177', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:12:24', 0, 1002001015, '账号未登陆', '2019-07-08 18:12:24');
INSERT INTO `access_log` VALUES (50762, '65.47.15625807435779359', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:12:24', 0, 1002001015, '账号未登陆', '2019-07-08 18:12:24');
INSERT INTO `access_log` VALUES (50763, '65.50.15625807453169407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:12:25', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 18:12:25');
INSERT INTO `access_log` VALUES (50764, '65.54.15625807491799341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:12:29', 81, 0, '', '2019-07-08 18:12:29');
INSERT INTO `access_log` VALUES (50765, '65.49.15625807494359377', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:12:29', 10, 0, '', '2019-07-08 18:12:29');
INSERT INTO `access_log` VALUES (50766, '65.46.15625807494369429', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:12:29', 10, 2001001000, '服务端发生异常', '2019-07-08 18:12:29');
INSERT INTO `access_log` VALUES (50767, '65.52.15625807494459417', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:12:29', 16, 0, '', '2019-07-08 18:12:29');
INSERT INTO `access_log` VALUES (50768, '65.45.15625807841489365', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:13:04', 17, 0, '', '2019-07-08 18:13:04');
INSERT INTO `access_log` VALUES (50769, '65.47.15625807841499361', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:13:04', 18, 2001001000, '服务端发生异常', '2019-07-08 18:13:04');
INSERT INTO `access_log` VALUES (50770, '65.53.15625807841629381', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:13:04', 9, 0, '', '2019-07-08 18:13:04');
INSERT INTO `access_log` VALUES (50771, '65.46.15625807875959431', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:13:08', 7, 0, '', '2019-07-08 18:13:08');
INSERT INTO `access_log` VALUES (50772, '65.54.15625807875949343', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:13:08', 8, 2001001000, '服务端发生异常', '2019-07-08 18:13:08');
INSERT INTO `access_log` VALUES (50773, '65.50.15625807875949409', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:13:08', 10, 0, '', '2019-07-08 18:13:08');
INSERT INTO `access_log` VALUES (50774, '65.49.15625807900359379', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:13:10', 9, 0, '', '2019-07-08 18:13:10');
INSERT INTO `access_log` VALUES (50775, '65.51.15625807900369431', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:13:10', 8, 2001001000, '服务端发生异常', '2019-07-08 18:13:10');
INSERT INTO `access_log` VALUES (50776, '65.3607.15625807900381181', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:13:10', 7, 0, '', '2019-07-08 18:13:10');
INSERT INTO `access_log` VALUES (50777, '65.53.15625807932199383', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:13:13', 9, 0, '', '2019-07-08 18:13:13');
INSERT INTO `access_log` VALUES (50778, '65.47.15625807932249363', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:13:13', 10, 2001001000, '服务端发生异常', '2019-07-08 18:13:13');
INSERT INTO `access_log` VALUES (50779, '65.45.15625807932349367', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-08 18:13:13', 9, 0, '', '2019-07-08 18:13:13');
INSERT INTO `access_log` VALUES (50780, '65.50.15625811164949415', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '113.109.114.86', '2019-07-08 18:18:36', 0, 1002001015, '账号未登陆', '2019-07-08 18:18:36');
INSERT INTO `access_log` VALUES (50781, '65.54.15625811165079349', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '113.109.114.86', '2019-07-08 18:18:37', 0, 1002001015, '账号未登陆', '2019-07-08 18:18:37');
INSERT INTO `access_log` VALUES (50782, '65.52.15625811165109425', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '113.68.128.23', '2019-07-08 18:18:37', 0, 1002001015, '账号未登陆', '2019-07-08 18:18:37');
INSERT INTO `access_log` VALUES (50783, '65.49.15625811199809385', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '113.109.114.86', '2019-07-08 18:18:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 18:18:40');
INSERT INTO `access_log` VALUES (50784, '65.51.15625811276369437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '113.109.114.86', '2019-07-08 18:18:48', 115, 0, '', '2019-07-08 18:18:48');
INSERT INTO `access_log` VALUES (50785, '65.53.15625811283339389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '113.109.114.86', '2019-07-08 18:18:48', 18, 0, '', '2019-07-08 18:18:48');
INSERT INTO `access_log` VALUES (50786, '65.45.15625811283459373', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '113.109.114.86', '2019-07-08 18:18:48', 9, 0, '', '2019-07-08 18:18:48');
INSERT INTO `access_log` VALUES (50787, '65.47.15625811283459369', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '113.68.128.23', '2019-07-08 18:18:48', 15, 2001001000, '服务端发生异常', '2019-07-08 18:18:48');
INSERT INTO `access_log` VALUES (50788, '65.50.15625811360719417', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '113.109.114.86', '2019-07-08 18:18:56', 11, 2001001000, '服务端发生异常', '2019-07-08 18:18:56');
INSERT INTO `access_log` VALUES (50789, '65.52.15625811360749427', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '113.109.114.6', '2019-07-08 18:18:56', 9, 0, '', '2019-07-08 18:18:56');
INSERT INTO `access_log` VALUES (50790, '65.54.15625811360749351', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '113.68.128.23', '2019-07-08 18:18:56', 8, 0, '', '2019-07-08 18:18:56');
INSERT INTO `access_log` VALUES (50791, '65.50.15625838143769453', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.65.120.91', '2019-07-08 19:03:34', 0, 1002001015, '账号未登陆', '2019-07-08 19:03:34');
INSERT INTO `access_log` VALUES (50792, '65.54.15625838143769387', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.65.120.91', '2019-07-08 19:03:34', 0, 1002001015, '账号未登陆', '2019-07-08 19:03:34');
INSERT INTO `access_log` VALUES (50793, '65.3607.15625838143771225', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.65.120.91', '2019-07-08 19:03:34', 1, 1002001015, '账号未登陆', '2019-07-08 19:03:34');
INSERT INTO `access_log` VALUES (50794, '65.49.15625838170989423', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.65.120.91', '2019-07-08 19:03:37', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 19:03:37');
INSERT INTO `access_log` VALUES (50795, '65.47.15625838221769407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.65.120.91', '2019-07-08 19:03:42', 63, 0, '', '2019-07-08 19:03:42');
INSERT INTO `access_log` VALUES (50796, '65.45.15625838224439411', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.65.120.91', '2019-07-08 19:03:42', 11, 2001001000, '服务端发生异常', '2019-07-08 19:03:42');
INSERT INTO `access_log` VALUES (50797, '65.46.15625838224459477', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.65.120.91', '2019-07-08 19:03:42', 11, 0, '', '2019-07-08 19:03:42');
INSERT INTO `access_log` VALUES (50798, '65.53.15625838224379427', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.65.120.91', '2019-07-08 19:03:42', 16, 0, '', '2019-07-08 19:03:42');
INSERT INTO `access_log` VALUES (50799, '65.54.15625838469299389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.65.120.91', '2019-07-08 19:04:07', 9, 0, '', '2019-07-08 19:04:07');
INSERT INTO `access_log` VALUES (50800, '65.50.15625838469399455', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.65.120.91', '2019-07-08 19:04:07', 9, 2001001000, '服务端发生异常', '2019-07-08 19:04:07');
INSERT INTO `access_log` VALUES (50801, '65.3607.15625838469391227', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.65.120.91', '2019-07-08 19:04:07', 9, 0, '', '2019-07-08 19:04:07');
INSERT INTO `access_log` VALUES (50802, '59.78.15625839899247757', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:06:30', 11, 0, '', '2019-07-08 19:06:30');
INSERT INTO `access_log` VALUES (50803, '59.75.15625839899247771', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:06:30', 15, 2001001000, '服务端发生异常', '2019-07-08 19:06:30');
INSERT INTO `access_log` VALUES (50804, '64.76.15625839924877897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:06:32', 11, 0, '', '2019-07-08 19:06:33');
INSERT INTO `access_log` VALUES (50805, '64.83.15625839926027903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:06:33', 3, 0, '', '2019-07-08 19:06:33');
INSERT INTO `access_log` VALUES (50806, '64.81.15625839935107893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:06:34', 2, 0, '', '2019-07-08 19:06:34');
INSERT INTO `access_log` VALUES (50807, '64.79.15625839943087909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:06:34', 2, 0, '', '2019-07-08 19:06:34');
INSERT INTO `access_log` VALUES (50808, '59.77.15625839953577751', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:06:35', 3, 0, '', '2019-07-08 19:06:35');
INSERT INTO `access_log` VALUES (50809, '59.76.15625839953617753', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:06:35', 12, 2001001000, '服务端发生异常', '2019-07-08 19:06:35');
INSERT INTO `access_log` VALUES (50810, '65.51.15625840095579479', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:06:50', 0, 1002001015, '账号未登陆', '2019-07-08 19:06:50');
INSERT INTO `access_log` VALUES (50811, '65.47.15625840095589411', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:06:50', 0, 1002001015, '账号未登陆', '2019-07-08 19:06:50');
INSERT INTO `access_log` VALUES (50812, '65.53.15625840095589431', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:06:50', 1, 1002001015, '账号未登陆', '2019-07-08 19:06:50');
INSERT INTO `access_log` VALUES (50813, '65.46.15625840123569481', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:06:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 19:06:52');
INSERT INTO `access_log` VALUES (50814, '65.52.15625840149789469', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:06:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 19:06:55');
INSERT INTO `access_log` VALUES (50815, '65.54.15625840163619393', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:06:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 19:06:56');
INSERT INTO `access_log` VALUES (50816, '65.3607.15625840381511231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:07:18', 62, 0, '', '2019-07-08 19:07:18');
INSERT INTO `access_log` VALUES (50817, '65.49.15625840387799429', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:07:19', 9, 0, '', '2019-07-08 19:07:19');
INSERT INTO `access_log` VALUES (50818, '65.51.15625840389259481', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:07:19', 10, 0, '', '2019-07-08 19:07:19');
INSERT INTO `access_log` VALUES (50819, '65.47.15625840389259413', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '180.103.176.108', '2019-07-08 19:07:19', 10, 2001001000, '服务端发生异常', '2019-07-08 19:07:19');
INSERT INTO `access_log` VALUES (50820, '59.79.15625943429607903', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 21:59:03', 10, 0, '', '2019-07-08 21:59:03');
INSERT INTO `access_log` VALUES (50821, '59.77.15625943429607889', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 21:59:03', 22, 2001001000, '服务端发生异常', '2019-07-08 21:59:03');
INSERT INTO `access_log` VALUES (50822, '64.80.15625943540688051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 21:59:14', 10, 0, '', '2019-07-08 21:59:14');
INSERT INTO `access_log` VALUES (50823, '64.77.15625943545308025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 21:59:15', 5, 0, '', '2019-07-08 21:59:15');
INSERT INTO `access_log` VALUES (50824, '64.85.15625943564688057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 21:59:16', 3, 0, '', '2019-07-08 21:59:16');
INSERT INTO `access_log` VALUES (50825, '64.78.15625943571928051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 21:59:17', 1, 0, '', '2019-07-08 21:59:17');
INSERT INTO `access_log` VALUES (50826, '64.76.15625943617208037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 21:59:22', 2, 0, '', '2019-07-08 21:59:22');
INSERT INTO `access_log` VALUES (50827, '64.83.15625943620798043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 21:59:22', 2, 0, '', '2019-07-08 21:59:22');
INSERT INTO `access_log` VALUES (50828, '65.45.15625944536529557', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 22:00:54', 1, 1002001015, '账号未登陆', '2019-07-08 22:00:54');
INSERT INTO `access_log` VALUES (50829, '65.52.15625944536529609', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 22:00:54', 1, 1002001015, '账号未登陆', '2019-07-08 22:00:54');
INSERT INTO `access_log` VALUES (50830, '65.54.15625944536619533', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 22:00:54', 1, 1002001015, '账号未登陆', '2019-07-08 22:00:54');
INSERT INTO `access_log` VALUES (50831, '65.50.15625944610129601', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 22:01:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 22:01:01');
INSERT INTO `access_log` VALUES (50832, '65.51.15625944767529623', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 22:01:17', 374, 0, '', '2019-07-08 22:01:17');
INSERT INTO `access_log` VALUES (50833, '65.53.15625944786169573', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 22:01:19', 13, 0, '', '2019-07-08 22:01:19');
INSERT INTO `access_log` VALUES (50834, '65.46.15625944786169623', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 22:01:19', 12, 0, '', '2019-07-08 22:01:19');
INSERT INTO `access_log` VALUES (50835, '65.47.15625944786169553', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.13.15.114', '2019-07-08 22:01:19', 16, 2001001000, '服务端发生异常', '2019-07-08 22:01:19');
INSERT INTO `access_log` VALUES (50836, '59.77.15625959774427911', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.74.130.69', '2019-07-08 22:26:17', 3, 0, '', '2019-07-08 22:26:17');
INSERT INTO `access_log` VALUES (50837, '59.80.15625959774447903', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.74.130.69', '2019-07-08 22:26:17', 15, 2001001000, '服务端发生异常', '2019-07-08 22:26:17');
INSERT INTO `access_log` VALUES (50838, '65.49.15625959901579595', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.74.130.69', '2019-07-08 22:26:30', 1, 1002001015, '账号未登陆', '2019-07-08 22:26:30');
INSERT INTO `access_log` VALUES (50839, '65.53.15625959901579599', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.74.130.69', '2019-07-08 22:26:30', 1, 1002001015, '账号未登陆', '2019-07-08 22:26:30');
INSERT INTO `access_log` VALUES (50840, '65.45.15625959901619579', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.74.130.69', '2019-07-08 22:26:30', 0, 1002001015, '账号未登陆', '2019-07-08 22:26:30');
INSERT INTO `access_log` VALUES (50841, '65.51.15625959928179653', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.74.130.69', '2019-07-08 22:26:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 22:26:33');
INSERT INTO `access_log` VALUES (50842, '65.52.15625960223609631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.74.130.69', '2019-07-08 22:27:02', 86, 0, '', '2019-07-08 22:27:02');
INSERT INTO `access_log` VALUES (50843, '65.46.15625960227149645', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.74.130.69', '2019-07-08 22:27:03', 8, 0, '', '2019-07-08 22:27:03');
INSERT INTO `access_log` VALUES (50844, '65.54.15625960227129555', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.74.130.69', '2019-07-08 22:27:03', 11, 2001001000, '服务端发生异常', '2019-07-08 22:27:03');
INSERT INTO `access_log` VALUES (50845, '65.3607.15625960227151395', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.74.130.69', '2019-07-08 22:27:03', 10, 0, '', '2019-07-08 22:27:03');
INSERT INTO `access_log` VALUES (50846, '65.45.15625961849259583', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-08 22:29:45', 4, 1002001012, '访问令牌已过期', '2019-07-08 22:29:45');
INSERT INTO `access_log` VALUES (50847, '65.49.15625961849289599', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-08 22:29:45', 2, 1002001012, '访问令牌已过期', '2019-07-08 22:29:45');
INSERT INTO `access_log` VALUES (50848, '65.51.15625961849669657', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-08 22:29:45', 3, 1002001012, '访问令牌已过期', '2019-07-08 22:29:45');
INSERT INTO `access_log` VALUES (50849, '64.79.15625961851468073', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-08 22:29:45', 9, 1002001012, '访问令牌已过期', '2019-07-08 22:29:45');
INSERT INTO `access_log` VALUES (50850, '65.50.15625961882819625', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-08 22:29:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 22:29:48');
INSERT INTO `access_log` VALUES (50851, '65.52.15625961955359635', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-08 22:29:56', 4, 1002002001, '密码不正确', '2019-07-08 22:29:56');
INSERT INTO `access_log` VALUES (50852, '65.46.15625962040469649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-08 22:30:04', 4, 1002002001, '密码不正确', '2019-07-08 22:30:04');
INSERT INTO `access_log` VALUES (50853, '65.3607.15625962149151399', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-08 22:30:15', 5, 1002002001, '密码不正确', '2019-07-08 22:30:15');
INSERT INTO `access_log` VALUES (50854, '65.51.15625962543199659', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-08 22:30:54', 5, 1002002001, '密码不正确', '2019-07-08 22:30:54');
INSERT INTO `access_log` VALUES (50855, '65.50.15625962663419627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-08 22:31:06', 4, 1002002001, '密码不正确', '2019-07-08 22:31:06');
INSERT INTO `access_log` VALUES (50856, '65.53.15625962994599607', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.74.130.69', '2019-07-08 22:31:39', 8, 0, '', '2019-07-08 22:31:39');
INSERT INTO `access_log` VALUES (50857, '65.54.15625962994589561', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.74.130.69', '2019-07-08 22:31:39', 10, 0, '', '2019-07-08 22:31:39');
INSERT INTO `access_log` VALUES (50858, '65.3607.15625962994591401', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.74.130.69', '2019-07-08 22:31:39', 9, 2001001000, '服务端发生异常', '2019-07-08 22:31:39');
INSERT INTO `access_log` VALUES (50859, '65.49.15625963104749603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-08 22:31:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 22:31:50');
INSERT INTO `access_log` VALUES (50860, '65.51.15625963207209661', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '106.37.239.65', '2019-07-08 22:32:01', 4, 1002002001, '密码不正确', '2019-07-08 22:32:01');
INSERT INTO `access_log` VALUES (50861, '65.47.15625963350469585', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.37.239.65', '2019-07-08 22:32:15', 4, 1002002001, '密码不正确', '2019-07-08 22:32:15');
INSERT INTO `access_log` VALUES (50862, '65.52.15625963353049639', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.37.239.65', '2019-07-08 22:32:15', 1, 1002001015, '账号未登陆', '2019-07-08 22:32:15');
INSERT INTO `access_log` VALUES (50863, '65.46.15625963353089653', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.37.239.65', '2019-07-08 22:32:15', 0, 1002001015, '账号未登陆', '2019-07-08 22:32:15');
INSERT INTO `access_log` VALUES (50864, '65.53.15625963353099609', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.37.239.65', '2019-07-08 22:32:15', 0, 1002001015, '账号未登陆', '2019-07-08 22:32:15');
INSERT INTO `access_log` VALUES (50865, '65.3607.15625963446331403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.37.239.65', '2019-07-08 22:32:25', 4, 1002002001, '密码不正确', '2019-07-08 22:32:25');
INSERT INTO `access_log` VALUES (50866, '65.49.15625963502139605', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.37.239.65', '2019-07-08 22:32:30', 4, 1002002001, '密码不正确', '2019-07-08 22:32:30');
INSERT INTO `access_log` VALUES (50867, '65.45.15625963517669589', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.37.239.65', '2019-07-08 22:32:32', 5, 1002002001, '密码不正确', '2019-07-08 22:32:32');
INSERT INTO `access_log` VALUES (50868, '65.51.15625963524779663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.37.239.65', '2019-07-08 22:32:32', 4, 1002002001, '密码不正确', '2019-07-08 22:32:32');
INSERT INTO `access_log` VALUES (50869, '65.50.15625963527569631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.37.239.65', '2019-07-08 22:32:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 22:32:33');
INSERT INTO `access_log` VALUES (50870, '65.47.15625963530609587', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.37.239.65', '2019-07-08 22:32:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 22:32:33');
INSERT INTO `access_log` VALUES (50871, '65.53.15625963533489611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.37.239.65', '2019-07-08 22:32:33', 5, 1002002001, '密码不正确', '2019-07-08 22:32:33');
INSERT INTO `access_log` VALUES (50872, '65.52.15625963537639641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.37.239.65', '2019-07-08 22:32:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 22:32:34');
INSERT INTO `access_log` VALUES (50873, '65.46.15625963540449655', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.37.239.65', '2019-07-08 22:32:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 22:32:34');
INSERT INTO `access_log` VALUES (50874, '59.72.15625965706857927', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.181.39.148', '2019-07-08 22:36:11', 3, 0, '', '2019-07-08 22:36:11');
INSERT INTO `access_log` VALUES (50875, '59.71.15625965706857931', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.181.39.148', '2019-07-08 22:36:11', 13, 2001001000, '服务端发生异常', '2019-07-08 22:36:11');
INSERT INTO `access_log` VALUES (50876, '59.75.15625965799787941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:36:20', 2, 0, '', '2019-07-08 22:36:20');
INSERT INTO `access_log` VALUES (50877, '59.78.15625965799837927', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:36:20', 17, 2001001000, '服务端发生异常', '2019-07-08 22:36:20');
INSERT INTO `access_log` VALUES (50878, '64.83.15625965864348073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:36:26', 10, 0, '', '2019-07-08 22:36:26');
INSERT INTO `access_log` VALUES (50879, '64.81.15625965865738063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:36:27', 3, 0, '', '2019-07-08 22:36:27');
INSERT INTO `access_log` VALUES (50880, '64.79.15625965878248079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:36:28', 1, 0, '', '2019-07-08 22:36:28');
INSERT INTO `access_log` VALUES (50881, '64.82.15625965885568093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:36:29', 2, 0, '', '2019-07-08 22:36:29');
INSERT INTO `access_log` VALUES (50882, '64.77.15625966025038057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:36:43', 2, 0, '', '2019-07-08 22:36:43');
INSERT INTO `access_log` VALUES (50883, '64.85.15625966038668089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:36:44', 2, 0, '', '2019-07-08 22:36:44');
INSERT INTO `access_log` VALUES (50884, '64.78.15625966044428083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:36:44', 2, 0, '', '2019-07-08 22:36:44');
INSERT INTO `access_log` VALUES (50885, '64.84.15625966050978073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:36:45', 2, 0, '', '2019-07-08 22:36:45');
INSERT INTO `access_log` VALUES (50886, '64.76.15625966056668069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:36:46', 2, 0, '', '2019-07-08 22:36:46');
INSERT INTO `access_log` VALUES (50887, '66.49.15625966220195985', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18268252687', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:02', 106, 0, '', '2019-07-08 22:37:02');
INSERT INTO `access_log` VALUES (50888, '66.55.15625966281005951', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18268252687&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:08', 183, 0, '', '2019-07-08 22:37:08');
INSERT INTO `access_log` VALUES (50889, '64.82.15625966330998095', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:13', 4, 0, '', '2019-07-08 22:37:13');
INSERT INTO `access_log` VALUES (50890, '64.77.15625966332818059', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:13', 5, 0, '', '2019-07-08 22:37:13');
INSERT INTO `access_log` VALUES (50891, '64.85.15625966364538091', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:16', 5, 0, '', '2019-07-08 22:37:16');
INSERT INTO `access_log` VALUES (50892, '64.78.15625966365518085', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:17', 4, 0, '', '2019-07-08 22:37:17');
INSERT INTO `access_log` VALUES (50893, '66.51.15625966376005995', 161, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:18', 7, 0, '', '2019-07-08 22:37:18');
INSERT INTO `access_log` VALUES (50894, '66.56.15625966387975981', 161, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:19', 6, 0, '', '2019-07-08 22:37:19');
INSERT INTO `access_log` VALUES (50895, '66.52.15625966404205963', 161, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:20', 6, 0, '', '2019-07-08 22:37:20');
INSERT INTO `access_log` VALUES (50896, '66.54.15625966456395975', 161, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:26', 6, 0, '', '2019-07-08 22:37:26');
INSERT INTO `access_log` VALUES (50897, '66.50.15625966475395967', 161, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:28', 6, 0, '', '2019-07-08 22:37:28');
INSERT INTO `access_log` VALUES (50898, '66.57.15625966619765971', 161, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:42', 6, 0, '', '2019-07-08 22:37:42');
INSERT INTO `access_log` VALUES (50899, '59.73.15625966636037939', 161, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:44', 6, 0, '', '2019-07-08 22:37:44');
INSERT INTO `access_log` VALUES (50900, '59.75.15625966636257943', 161, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:44', 15, 2001001000, '服务端发生异常', '2019-07-08 22:37:44');
INSERT INTO `access_log` VALUES (50901, '64.83.15625966669218077', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:47', 4, 0, '', '2019-07-08 22:37:47');
INSERT INTO `access_log` VALUES (50902, '64.81.15625966670528067', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:47', 4, 0, '', '2019-07-08 22:37:47');
INSERT INTO `access_log` VALUES (50903, '59.78.15625966685287929', 161, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:49', 5, 0, '', '2019-07-08 22:37:49');
INSERT INTO `access_log` VALUES (50904, '59.74.15625966685367939', 161, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:49', 14, 2001001000, '服务端发生异常', '2019-07-08 22:37:49');
INSERT INTO `access_log` VALUES (50905, '64.79.15625966703458083', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:50', 4, 0, '', '2019-07-08 22:37:50');
INSERT INTO `access_log` VALUES (50906, '64.82.15625966704778097', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:50', 3, 0, '', '2019-07-08 22:37:50');
INSERT INTO `access_log` VALUES (50907, '59.80.15625966734607915', 161, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:53', 6, 0, '', '2019-07-08 22:37:53');
INSERT INTO `access_log` VALUES (50908, '59.79.15625966734607937', 161, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:37:53', 15, 2001001000, '服务端发生异常', '2019-07-08 22:37:53');
INSERT INTO `access_log` VALUES (50909, '59.71.15625966815647935', 161, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:38:02', 6, 0, '', '2019-07-08 22:38:02');
INSERT INTO `access_log` VALUES (50910, '59.73.15625966815827941', 161, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:38:02', 15, 2001001000, '服务端发生异常', '2019-07-08 22:38:02');
INSERT INTO `access_log` VALUES (50911, '64.77.15625968102808063', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:10', 5, 0, '', '2019-07-08 22:40:10');
INSERT INTO `access_log` VALUES (50912, '64.78.15625968106448089', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:11', 4, 0, '', '2019-07-08 22:40:11');
INSERT INTO `access_log` VALUES (50913, '64.84.15625968116148079', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:12', 6, 0, '', '2019-07-08 22:40:12');
INSERT INTO `access_log` VALUES (50914, 'N/A', 161, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:12', 10, 0, '', '2019-07-08 22:40:12');
INSERT INTO `access_log` VALUES (50915, 'N/A', 161, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:13', 8, 0, '', '2019-07-08 22:40:13');
INSERT INTO `access_log` VALUES (50916, 'N/A', 161, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:15', 11, 0, '', '2019-07-08 22:40:15');
INSERT INTO `access_log` VALUES (50917, 'N/A', 161, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:15', 8, 0, '', '2019-07-08 22:40:15');
INSERT INTO `access_log` VALUES (50918, '64.83.15625968170968081', 161, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:17', 9, 0, '', '2019-07-08 22:40:17');
INSERT INTO `access_log` VALUES (50919, '66.56.15625968423415985', 161, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:42', 51, 0, '', '2019-07-08 22:40:42');
INSERT INTO `access_log` VALUES (50920, '64.82.15625968546718101', 161, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:55', 9, 0, '', '2019-07-08 22:40:55');
INSERT INTO `access_log` VALUES (50921, '64.77.15625968553218065', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:55', 6, 0, '', '2019-07-08 22:40:55');
INSERT INTO `access_log` VALUES (50922, 'N/A', 161, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:55', 118, 0, '', '2019-07-08 22:40:55');
INSERT INTO `access_log` VALUES (50923, '64.85.15625968559098097', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:56', 5, 0, '', '2019-07-08 22:40:56');
INSERT INTO `access_log` VALUES (50924, '64.78.15625968560128091', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:56', 4, 0, '', '2019-07-08 22:40:56');
INSERT INTO `access_log` VALUES (50925, '59.74.15625968567477943', 161, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:57', 6, 0, '', '2019-07-08 22:40:57');
INSERT INTO `access_log` VALUES (50926, '59.76.15625968567487929', 161, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:57', 15, 2001001000, '服务端发生异常', '2019-07-08 22:40:57');
INSERT INTO `access_log` VALUES (50927, '64.84.15625968573788081', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:57', 5, 0, '', '2019-07-08 22:40:57');
INSERT INTO `access_log` VALUES (50928, '64.76.15625968576278077', 161, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '60.181.39.148', '2019-07-08 22:40:58', 4, 0, '', '2019-07-08 22:40:58');
INSERT INTO `access_log` VALUES (50929, '65.53.15625968983919619', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.181.39.148', '2019-07-08 22:41:38', 0, 1002001015, '账号未登陆', '2019-07-08 22:41:38');
INSERT INTO `access_log` VALUES (50930, '65.47.15625968983919595', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.181.39.148', '2019-07-08 22:41:38', 1, 1002001015, '账号未登陆', '2019-07-08 22:41:38');
INSERT INTO `access_log` VALUES (50931, '65.52.15625968983949649', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.181.39.148', '2019-07-08 22:41:38', 0, 1002001015, '账号未登陆', '2019-07-08 22:41:38');
INSERT INTO `access_log` VALUES (50932, '65.54.15625969074159573', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.181.39.148', '2019-07-08 22:41:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 22:41:47');
INSERT INTO `access_log` VALUES (50933, '65.45.15625969363899599', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.181.39.148', '2019-07-08 22:42:16', 59, 0, '', '2019-07-08 22:42:16');
INSERT INTO `access_log` VALUES (50934, '65.51.15625969368209673', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.181.39.148', '2019-07-08 22:42:17', 9, 0, '', '2019-07-08 22:42:17');
INSERT INTO `access_log` VALUES (50935, '65.50.15625969368309641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.181.39.148', '2019-07-08 22:42:17', 12, 2001001000, '服务端发生异常', '2019-07-08 22:42:17');
INSERT INTO `access_log` VALUES (50936, '65.47.15625969368369597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.181.39.148', '2019-07-08 22:42:17', 9, 0, '', '2019-07-08 22:42:17');
INSERT INTO `access_log` VALUES (50937, '65.47.15625983995299617', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.160.251.222', '2019-07-08 23:06:40', 1, 1002001015, '账号未登陆', '2019-07-08 23:06:40');
INSERT INTO `access_log` VALUES (50938, '65.50.15625983995299661', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.160.250.182', '2019-07-08 23:06:40', 1, 1002001015, '账号未登陆', '2019-07-08 23:06:40');
INSERT INTO `access_log` VALUES (50939, '65.52.15625983995309671', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.160.251.222', '2019-07-08 23:06:40', 1, 1002001015, '账号未登陆', '2019-07-08 23:06:40');
INSERT INTO `access_log` VALUES (50940, '65.53.15625984118959641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.160.251.222', '2019-07-08 23:06:52', 89, 0, '', '2019-07-08 23:06:52');
INSERT INTO `access_log` VALUES (50941, '65.45.15625984726969621', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '124.160.250.182', '2019-07-08 23:07:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 23:07:53');
INSERT INTO `access_log` VALUES (50942, '59.75.15625998015357987', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:30:02', 9, 0, '', '2019-07-08 23:30:02');
INSERT INTO `access_log` VALUES (50943, '59.78.15625998015687973', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:30:02', 19, 2001001000, '服务端发生异常', '2019-07-08 23:30:02');
INSERT INTO `access_log` VALUES (50944, '64.78.15625998105438131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:30:11', 10, 0, '', '2019-07-08 23:30:11');
INSERT INTO `access_log` VALUES (50945, '64.84.15625998107328121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:30:11', 3, 0, '', '2019-07-08 23:30:11');
INSERT INTO `access_log` VALUES (50946, '64.81.15625998445378113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:30:45', 2, 0, '', '2019-07-08 23:30:45');
INSERT INTO `access_log` VALUES (50947, '64.79.15625998457988129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:30:46', 2, 0, '', '2019-07-08 23:30:46');
INSERT INTO `access_log` VALUES (50948, '59.79.15625998473017981', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:30:47', 3, 0, '', '2019-07-08 23:30:47');
INSERT INTO `access_log` VALUES (50949, '59.72.15625998473027975', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:30:47', 13, 2001001000, '服务端发生异常', '2019-07-08 23:30:47');
INSERT INTO `access_log` VALUES (50950, '64.82.15625998531638143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:30:53', 2, 0, '', '2019-07-08 23:30:53');
INSERT INTO `access_log` VALUES (50951, '64.77.15625998533458107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:30:53', 2, 0, '', '2019-07-08 23:30:53');
INSERT INTO `access_log` VALUES (50952, '64.85.15625998624808139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:31:02', 2, 0, '', '2019-07-08 23:31:02');
INSERT INTO `access_log` VALUES (50953, '64.78.15625998626238133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:31:03', 2, 0, '', '2019-07-08 23:31:03');
INSERT INTO `access_log` VALUES (50954, '65.49.15625999298669657', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:32:10', 1, 1002001015, '账号未登陆', '2019-07-08 23:32:10');
INSERT INTO `access_log` VALUES (50955, '65.45.15625999298829641', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:32:10', 0, 1002001015, '账号未登陆', '2019-07-08 23:32:10');
INSERT INTO `access_log` VALUES (50956, '65.51.15625999299259715', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:32:10', 0, 1002001015, '账号未登陆', '2019-07-08 23:32:10');
INSERT INTO `access_log` VALUES (50957, '65.52.15625999367929693', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:32:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-08 23:32:17');
INSERT INTO `access_log` VALUES (50958, '65.50.15625999428929683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:32:23', 85, 0, '', '2019-07-08 23:32:23');
INSERT INTO `access_log` VALUES (50959, '65.47.15625999435879639', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:32:24', 9, 0, '', '2019-07-08 23:32:24');
INSERT INTO `access_log` VALUES (50960, '65.53.15625999435979663', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:32:24', 9, 2001001000, '服务端发生异常', '2019-07-08 23:32:24');
INSERT INTO `access_log` VALUES (50961, '65.46.15625999439269707', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:32:24', 10, 0, '', '2019-07-08 23:32:24');
INSERT INTO `access_log` VALUES (50962, '65.3607.15625999561761457', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:32:36', 9, 0, '', '2019-07-08 23:32:36');
INSERT INTO `access_log` VALUES (50963, '65.49.15625999561859659', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:32:36', 10, 2001001000, '服务端发生异常', '2019-07-08 23:32:36');
INSERT INTO `access_log` VALUES (50964, '65.45.15625999562129643', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '117.182.52.211', '2019-07-08 23:32:36', 9, 0, '', '2019-07-08 23:32:36');
INSERT INTO `access_log` VALUES (50965, '65.51.15626312981440135', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:14:58', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 08:14:58');
INSERT INTO `access_log` VALUES (50966, '65.52.15626313031160113', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:15:03', 39, 1002002001, '密码不正确', '2019-07-09 08:15:03');
INSERT INTO `access_log` VALUES (50967, '65.50.15626313082750103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:15:08', 71, 0, '', '2019-07-09 08:15:08');
INSERT INTO `access_log` VALUES (50968, '65.47.15626313087810059', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:15:09', 25, 0, '', '2019-07-09 08:15:09');
INSERT INTO `access_log` VALUES (50969, '65.53.15626313087780083', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:15:09', 27, 0, '', '2019-07-09 08:15:09');
INSERT INTO `access_log` VALUES (50970, '65.54.15626313087870037', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:15:09', 23, 0, '', '2019-07-09 08:15:09');
INSERT INTO `access_log` VALUES (50971, '3ed726af-2521-436c-bf6e-aa124142c128', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 08:20:52', 83, 1002001015, '账号未登陆', '2019-07-09 08:20:53');
INSERT INTO `access_log` VALUES (50972, '65b50ce9-8a9d-4f8c-9148-0398755bec9b', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 08:20:52', 83, 1002001015, '账号未登陆', '2019-07-09 08:20:53');
INSERT INTO `access_log` VALUES (50973, '28df9c07-2a63-4990-a4f0-a91fa9cd8f47', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 08:20:52', 83, 1002001015, '账号未登陆', '2019-07-09 08:20:53');
INSERT INTO `access_log` VALUES (50974, '66.54.15626318228676445', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:23:43', 24, 0, '', '2019-07-09 08:23:43');
INSERT INTO `access_log` VALUES (50975, '59.75.15626318409578415', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:24:01', 25, 0, '', '2019-07-09 08:24:01');
INSERT INTO `access_log` VALUES (50976, '66.57.15626318498266441', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:24:10', 12, 0, '', '2019-07-09 08:24:10');
INSERT INTO `access_log` VALUES (50977, '62.83.15626322605857723', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:31:01', 93, 0, '', '2019-07-09 08:31:01');
INSERT INTO `access_log` VALUES (50978, '62.80.15626322665277711', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:31:07', 134, 0, '', '2019-07-09 08:31:07');
INSERT INTO `access_log` VALUES (50979, '64.83.15626322764888557', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:31:16', 28, 0, '', '2019-07-09 08:31:17');
INSERT INTO `access_log` VALUES (50980, '64.76.15626322764888551', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:31:16', 31, 0, '', '2019-07-09 08:31:17');
INSERT INTO `access_log` VALUES (50981, '64.79.15626322809768563', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:31:21', 23, 0, '', '2019-07-09 08:31:21');
INSERT INTO `access_log` VALUES (50982, '64.80.15626322809788567', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:31:21', 14, 0, '', '2019-07-09 08:31:21');
INSERT INTO `access_log` VALUES (50983, '64.82.15626322870048577', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.131.94.114', '2019-07-09 08:31:27', 14, 0, '', '2019-07-09 08:31:27');
INSERT INTO `access_log` VALUES (50984, '65.54.15626332271670063', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.205.131.15', '2019-07-09 08:47:07', 4, 1002001012, '访问令牌已过期', '2019-07-09 08:47:07');
INSERT INTO `access_log` VALUES (50985, '65.53.15626332271670109', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.205.131.15', '2019-07-09 08:47:07', 4, 1002001012, '访问令牌已过期', '2019-07-09 08:47:07');
INSERT INTO `access_log` VALUES (50986, '65.46.15626332271670153', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.205.131.15', '2019-07-09 08:47:07', 5, 1002001012, '访问令牌已过期', '2019-07-09 08:47:07');
INSERT INTO `access_log` VALUES (50987, '65.49.15626332338170105', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.205.131.15', '2019-07-09 08:47:14', 82, 0, '', '2019-07-09 08:47:14');
INSERT INTO `access_log` VALUES (50988, '65.45.15626332340660089', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.205.131.15', '2019-07-09 08:47:14', 10, 0, '', '2019-07-09 08:47:14');
INSERT INTO `access_log` VALUES (50989, '65.51.15626332340690163', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.205.131.15', '2019-07-09 08:47:14', 8, 2001001000, '服务端发生异常', '2019-07-09 08:47:14');
INSERT INTO `access_log` VALUES (50990, '65.52.15626332340720141', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.205.131.15', '2019-07-09 08:47:14', 8, 0, '', '2019-07-09 08:47:14');
INSERT INTO `access_log` VALUES (50991, '65.45.15626340935170101', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.57.181.190', '2019-07-09 09:01:34', 190, 0, '', '2019-07-09 09:01:34');
INSERT INTO `access_log` VALUES (50992, '65.52.15626340935180153', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.57.181.190', '2019-07-09 09:01:34', 189, 0, '', '2019-07-09 09:01:34');
INSERT INTO `access_log` VALUES (50993, '65.51.15626340935160175', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.57.181.190', '2019-07-09 09:01:34', 189, 0, '', '2019-07-09 09:01:34');
INSERT INTO `access_log` VALUES (50994, '62.86.15626343357587727', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.57.181.190', '2019-07-09 09:05:36', 9, 1002001012, '访问令牌已过期', '2019-07-09 09:05:36');
INSERT INTO `access_log` VALUES (50995, '65.51.15626343437740179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.57.181.190', '2019-07-09 09:05:44', 156, 0, '', '2019-07-09 09:05:44');
INSERT INTO `access_log` VALUES (50996, '65.45.15626343448130105', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.57.181.190', '2019-07-09 09:05:45', 9, 0, '', '2019-07-09 09:05:45');
INSERT INTO `access_log` VALUES (50997, '65.52.15626343448140157', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.57.181.190', '2019-07-09 09:05:45', 10, 0, '', '2019-07-09 09:05:45');
INSERT INTO `access_log` VALUES (50998, '65.50.15626343448140147', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.57.181.190', '2019-07-09 09:05:45', 9, 0, '', '2019-07-09 09:05:45');
INSERT INTO `access_log` VALUES (50999, '64.80.15626343482338595', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.57.181.190', '2019-07-09 09:05:48', 24, 0, '', '2019-07-09 09:05:48');
INSERT INTO `access_log` VALUES (51000, '64.79.15626343482348591', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.57.181.190', '2019-07-09 09:05:48', 20, 0, '', '2019-07-09 09:05:48');
INSERT INTO `access_log` VALUES (51001, '62.85.15626343576937731', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.57.181.190', '2019-07-09 09:05:58', 23, 0, '', '2019-07-09 09:05:58');
INSERT INTO `access_log` VALUES (51002, '59.74.15626365040458473', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.204.90.239', '2019-07-09 09:41:44', 11, 0, '', '2019-07-09 09:41:44');
INSERT INTO `access_log` VALUES (51003, '59.76.15626365040508459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.204.90.239', '2019-07-09 09:41:44', 30, 2001001000, '服务端发生异常', '2019-07-09 09:41:44');
INSERT INTO `access_log` VALUES (51004, '59.79.15626365109728471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.204.90.239', '2019-07-09 09:41:51', 3, 0, '', '2019-07-09 09:41:51');
INSERT INTO `access_log` VALUES (51005, '59.72.15626365109788465', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.204.90.239', '2019-07-09 09:41:51', 16, 2001001000, '服务端发生异常', '2019-07-09 09:41:51');
INSERT INTO `access_log` VALUES (51006, '59.78.15626367216398467', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.244.248.194', '2019-07-09 09:45:22', 3, 0, '', '2019-07-09 09:45:22');
INSERT INTO `access_log` VALUES (51007, '59.76.15626367216418463', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.244.248.194', '2019-07-09 09:45:22', 16, 2001001000, '服务端发生异常', '2019-07-09 09:45:22');
INSERT INTO `access_log` VALUES (51008, '59.80.15626368884088455', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.104.90.212', '2019-07-09 09:48:08', 4, 0, '', '2019-07-09 09:48:08');
INSERT INTO `access_log` VALUES (51009, '59.72.15626368884258471', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.104.90.212', '2019-07-09 09:48:08', 12, 2001001000, '服务端发生异常', '2019-07-09 09:48:08');
INSERT INTO `access_log` VALUES (51010, '59.75.15626395086258519', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 10:31:49', 10, 0, '', '2019-07-09 10:31:49');
INSERT INTO `access_log` VALUES (51011, '59.78.15626395086288505', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 10:31:49', 16, 2001001000, '服务端发生异常', '2019-07-09 10:31:49');
INSERT INTO `access_log` VALUES (51012, '65.49.15626395153060191', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 10:31:55', 0, 1002001015, '账号未登陆', '2019-07-09 10:31:55');
INSERT INTO `access_log` VALUES (51013, '65.51.15626395153090249', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 10:31:55', 2, 1002001015, '账号未登陆', '2019-07-09 10:31:55');
INSERT INTO `access_log` VALUES (51014, '65.50.15626395153130217', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 10:31:55', 0, 1002001015, '账号未登陆', '2019-07-09 10:31:55');
INSERT INTO `access_log` VALUES (51015, '65.52.15626395237570227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 10:32:04', 63, 0, '', '2019-07-09 10:32:04');
INSERT INTO `access_log` VALUES (51016, '65.45.15626395243570175', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 10:32:04', 9, 0, '', '2019-07-09 10:32:04');
INSERT INTO `access_log` VALUES (51017, '65.47.15626395243690173', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 10:32:04', 17, 0, '', '2019-07-09 10:32:04');
INSERT INTO `access_log` VALUES (51018, '65.54.15626395243780151', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 10:32:04', 9, 2001001000, '服务端发生异常', '2019-07-09 10:32:04');
INSERT INTO `access_log` VALUES (51019, '65.3607.15626395555561991', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:32:36', 4, 1002001012, '访问令牌已过期', '2019-07-09 10:32:36');
INSERT INTO `access_log` VALUES (51020, '65.49.15626395555570193', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:32:36', 12, 1002001012, '访问令牌已过期', '2019-07-09 10:32:36');
INSERT INTO `access_log` VALUES (51021, '65.50.15626395555610219', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:32:36', 11, 1002001012, '访问令牌已过期', '2019-07-09 10:32:36');
INSERT INTO `access_log` VALUES (51022, '62.80.15626395557467809', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:32:36', 8, 1002001012, '访问令牌已过期', '2019-07-09 10:32:36');
INSERT INTO `access_log` VALUES (51023, '65.54.15626395894900153', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 10:33:09', 9, 0, '', '2019-07-09 10:33:10');
INSERT INTO `access_log` VALUES (51024, '65.53.15626395895350199', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 10:33:10', 11, 0, '', '2019-07-09 10:33:10');
INSERT INTO `access_log` VALUES (51025, '65.47.15626395895340175', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 10:33:10', 12, 2001001000, '服务端发生异常', '2019-07-09 10:33:10');
INSERT INTO `access_log` VALUES (51026, '59.77.15626404673598511', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.233.220.36', '2019-07-09 10:47:47', 20, 2001001000, '服务端发生异常', '2019-07-09 10:47:47');
INSERT INTO `access_log` VALUES (51027, '59.79.15626404673578525', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.233.220.36', '2019-07-09 10:47:47', 45, 0, '', '2019-07-09 10:47:47');
INSERT INTO `access_log` VALUES (51028, '65.53.15626404762040211', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.233.220.36', '2019-07-09 10:47:56', 1, 1002001015, '账号未登陆', '2019-07-09 10:47:56');
INSERT INTO `access_log` VALUES (51029, '65.46.15626404762040255', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.233.220.36', '2019-07-09 10:47:56', 1, 1002001015, '账号未登陆', '2019-07-09 10:47:56');
INSERT INTO `access_log` VALUES (51030, '65.50.15626404762040233', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.233.220.36', '2019-07-09 10:47:56', 0, 1002001015, '账号未登陆', '2019-07-09 10:47:56');
INSERT INTO `access_log` VALUES (51031, '65.3607.15626404822082005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.233.220.36', '2019-07-09 10:48:02', 120, 0, '', '2019-07-09 10:48:02');
INSERT INTO `access_log` VALUES (51032, '65.49.15626404826200207', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.233.220.36', '2019-07-09 10:48:03', 10, 0, '', '2019-07-09 10:48:03');
INSERT INTO `access_log` VALUES (51033, '65.51.15626404826260265', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.233.220.36', '2019-07-09 10:48:03', 10, 2001001000, '服务端发生异常', '2019-07-09 10:48:03');
INSERT INTO `access_log` VALUES (51034, '65.52.15626404826320243', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.233.220.36', '2019-07-09 10:48:03', 9, 0, '', '2019-07-09 10:48:03');
INSERT INTO `access_log` VALUES (51035, '59.80.15626407049958507', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.23.83', '2019-07-09 10:51:45', 3, 0, '', '2019-07-09 10:51:45');
INSERT INTO `access_log` VALUES (51036, '59.72.15626407049968523', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.23.83', '2019-07-09 10:51:45', 13, 2001001000, '服务端发生异常', '2019-07-09 10:51:45');
INSERT INTO `access_log` VALUES (51037, '65.3607.15626407182182009', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:51:58', 180, 0, '', '2019-07-09 10:51:58');
INSERT INTO `access_log` VALUES (51038, '65.51.15626407188070269', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:51:59', 10, 0, '', '2019-07-09 10:51:59');
INSERT INTO `access_log` VALUES (51039, '65.52.15626407188110247', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:51:59', 9, 0, '', '2019-07-09 10:51:59');
INSERT INTO `access_log` VALUES (51040, '65.49.15626407188680211', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:51:59', 10, 0, '', '2019-07-09 10:51:59');
INSERT INTO `access_log` VALUES (51041, '66.53.15626407228856565', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:52:03', 21, 0, '', '2019-07-09 10:52:03');
INSERT INTO `access_log` VALUES (51042, '65.54.15626407378400171', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:52:18', 36, 0, '', '2019-07-09 10:52:18');
INSERT INTO `access_log` VALUES (51043, '65.46.15626407445860261', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:52:25', 11, 0, '', '2019-07-09 10:52:25');
INSERT INTO `access_log` VALUES (51044, '65.50.15626407505620239', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:52:31', 24, 0, '', '2019-07-09 10:52:31');
INSERT INTO `access_log` VALUES (51045, '65.54.15626409859340175', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:56:26', 11, 0, '', '2019-07-09 10:56:26');
INSERT INTO `access_log` VALUES (51046, '65.47.15626409960950197', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:56:36', 14, 0, '', '2019-07-09 10:56:36');
INSERT INTO `access_log` VALUES (51047, '65.46.15626409976460265', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:56:38', 11, 0, '', '2019-07-09 10:56:38');
INSERT INTO `access_log` VALUES (51048, '65.50.15626409988080243', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:56:39', 19, 0, '', '2019-07-09 10:56:39');
INSERT INTO `access_log` VALUES (51049, '59.77.15626410036588519', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:56:44', 44, 2001001000, '服务端发生异常', '2019-07-09 10:56:44');
INSERT INTO `access_log` VALUES (51050, '66.53.15626410086026569', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 10:56:49', 11, 0, '', '2019-07-09 10:56:49');
INSERT INTO `access_log` VALUES (51051, '65.53.15626414368630227', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-07-09 11:03:57', 5, 1002001012, '访问令牌已过期', '2019-07-09 11:03:57');
INSERT INTO `access_log` VALUES (51052, '65.3607.15626414368642021', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-07-09 11:03:57', 4, 1002001012, '访问令牌已过期', '2019-07-09 11:03:57');
INSERT INTO `access_log` VALUES (51053, '65.51.15626414368690281', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-07-09 11:03:57', 3, 1002001012, '访问令牌已过期', '2019-07-09 11:03:57');
INSERT INTO `access_log` VALUES (51054, '62.81.15626414374707803', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 11:03:57', 23, 0, '', '2019-07-09 11:03:57');
INSERT INTO `access_log` VALUES (51055, '65.52.15626414480390259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-07-09 11:04:08', 107, 0, '', '2019-07-09 11:04:08');
INSERT INTO `access_log` VALUES (51056, '65.49.15626414483690223', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-07-09 11:04:08', 179, 0, '', '2019-07-09 11:04:09');
INSERT INTO `access_log` VALUES (51057, '65.54.15626414483760183', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-07-09 11:04:08', 177, 0, '', '2019-07-09 11:04:09');
INSERT INTO `access_log` VALUES (51058, '65.45.15626414483690207', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-07-09 11:04:08', 184, 2001001000, '服务端发生异常', '2019-07-09 11:04:09');
INSERT INTO `access_log` VALUES (51059, '65.3607.15626414860522023', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.119.174.153', '2019-07-09 11:04:46', 1, 1002001015, '账号未登陆', '2019-07-09 11:04:46');
INSERT INTO `access_log` VALUES (51060, '65.53.15626414860540229', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.48.70.156', '2019-07-09 11:04:46', 0, 1002001015, '账号未登陆', '2019-07-09 11:04:46');
INSERT INTO `access_log` VALUES (51061, '65.51.15626414860590283', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.119.174.195', '2019-07-09 11:04:46', 1, 1002001015, '账号未登陆', '2019-07-09 11:04:46');
INSERT INTO `access_log` VALUES (51062, '65.49.15626414950180225', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.119.174.195', '2019-07-09 11:04:55', 70, 0, '', '2019-07-09 11:04:55');
INSERT INTO `access_log` VALUES (51063, '65.54.15626414953100185', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.119.174.195', '2019-07-09 11:04:55', 159, 0, '', '2019-07-09 11:04:55');
INSERT INTO `access_log` VALUES (51064, '65.45.15626414953160209', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.119.174.153', '2019-07-09 11:04:55', 154, 0, '', '2019-07-09 11:04:55');
INSERT INTO `access_log` VALUES (51065, '65.47.15626414953140207', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.119.174.195', '2019-07-09 11:04:55', 158, 2001001000, '服务端发生异常', '2019-07-09 11:04:55');
INSERT INTO `access_log` VALUES (51066, '59.71.15626419081878543', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-07-09 11:11:48', 3, 0, '', '2019-07-09 11:11:48');
INSERT INTO `access_log` VALUES (51067, '59.79.15626419081878545', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-07-09 11:11:48', 14, 2001001000, '服务端发生异常', '2019-07-09 11:11:48');
INSERT INTO `access_log` VALUES (51068, '64.83.15626419121298687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-07-09 11:11:52', 12, 0, '', '2019-07-09 11:11:52');
INSERT INTO `access_log` VALUES (51069, '64.76.15626419122258681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-07-09 11:11:52', 4, 0, '', '2019-07-09 11:11:52');
INSERT INTO `access_log` VALUES (51070, '64.81.15626419135088677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-07-09 11:11:54', 2, 0, '', '2019-07-09 11:11:54');
INSERT INTO `access_log` VALUES (51071, '64.80.15626419143758697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.82.98', '2019-07-09 11:11:54', 2, 0, '', '2019-07-09 11:11:54');
INSERT INTO `access_log` VALUES (51072, '10b2e7e6-5f4c-4e26-bb22-a692cce48b20', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:15:56', 138, 1002001015, '账号未登陆', '2019-07-09 11:15:57');
INSERT INTO `access_log` VALUES (51073, 'ca50f39b-0151-4e9d-b2fc-85b051cf3f72', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:15:56', 142, 1002001015, '账号未登陆', '2019-07-09 11:15:57');
INSERT INTO `access_log` VALUES (51074, '02da5aba-0f3f-4849-b761-ef3bf9b166f9', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:15:56', 142, 1002001015, '账号未登陆', '2019-07-09 11:15:57');
INSERT INTO `access_log` VALUES (51075, '5fd9501a-97bb-4e88-b904-0f4bc3cf39e8', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:16:05', 463, 1002002001, '密码不正确', '2019-07-09 11:16:06');
INSERT INTO `access_log` VALUES (51076, '0bfc78fd-a75a-4078-985c-53b701ac20c2', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:16:11', 56, 1002002001, '密码不正确', '2019-07-09 11:16:11');
INSERT INTO `access_log` VALUES (51077, '59.77.15626423081568537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.222.238', '2019-07-09 11:18:28', 3, 0, '', '2019-07-09 11:18:28');
INSERT INTO `access_log` VALUES (51078, '59.71.15626423081568549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.222.238', '2019-07-09 11:18:28', 22, 2001001000, '服务端发生异常', '2019-07-09 11:18:28');
INSERT INTO `access_log` VALUES (51079, '65.3607.15626423180592035', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.222.238', '2019-07-09 11:18:38', 0, 1002001015, '账号未登陆', '2019-07-09 11:18:38');
INSERT INTO `access_log` VALUES (51080, '65.52.15626423180600273', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.222.238', '2019-07-09 11:18:38', 0, 1002001015, '账号未登陆', '2019-07-09 11:18:38');
INSERT INTO `access_log` VALUES (51081, '65.49.15626423180640237', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.222.238', '2019-07-09 11:18:38', 0, 1002001015, '账号未登陆', '2019-07-09 11:18:38');
INSERT INTO `access_log` VALUES (51082, '65.47.15626423198910219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.222.238', '2019-07-09 11:18:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 11:18:40');
INSERT INTO `access_log` VALUES (51083, '65.45.15626423216070221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.222.238', '2019-07-09 11:18:42', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 11:18:42');
INSERT INTO `access_log` VALUES (51084, '65.46.15626423306280287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.222.238', '2019-07-09 11:18:51', 205, 0, '', '2019-07-09 11:18:51');
INSERT INTO `access_log` VALUES (51085, '65.50.15626423312170265', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.222.238', '2019-07-09 11:18:51', 28, 0, '', '2019-07-09 11:18:51');
INSERT INTO `access_log` VALUES (51086, '65.51.15626423312210297', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.222.238', '2019-07-09 11:18:51', 27, 2001001000, '服务端发生异常', '2019-07-09 11:18:51');
INSERT INTO `access_log` VALUES (51087, '65.53.15626423312410243', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.222.238', '2019-07-09 11:18:51', 7, 0, '', '2019-07-09 11:18:51');
INSERT INTO `access_log` VALUES (51088, '65.47.15626429807120229', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 11:29:41', 4, 1002001012, '访问令牌已过期', '2019-07-09 11:29:41');
INSERT INTO `access_log` VALUES (51089, '65.45.15626429807140231', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 11:29:41', 4, 1002001012, '访问令牌已过期', '2019-07-09 11:29:41');
INSERT INTO `access_log` VALUES (51090, '65.46.15626429807140297', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 11:29:41', 5, 1002001012, '访问令牌已过期', '2019-07-09 11:29:41');
INSERT INTO `access_log` VALUES (51091, '65.50.15626429863820275', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 11:29:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 11:29:46');
INSERT INTO `access_log` VALUES (51092, '65.53.15626429970810253', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 11:29:57', 76, 0, '', '2019-07-09 11:29:57');
INSERT INTO `access_log` VALUES (51093, '65.52.15626429975920285', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 11:29:58', 137, 0, '', '2019-07-09 11:29:58');
INSERT INTO `access_log` VALUES (51094, '65.3607.15626429975992047', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 11:29:58', 130, 0, '', '2019-07-09 11:29:58');
INSERT INTO `access_log` VALUES (51095, '65.49.15626429975920249', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 11:29:58', 139, 2001001000, '服务端发生异常', '2019-07-09 11:29:58');
INSERT INTO `access_log` VALUES (51096, '6cdabdf3-2418-4c27-ba71-78fb1ce8dbc1', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:34:34', 960, 1002002001, '密码不正确', '2019-07-09 11:34:35');
INSERT INTO `access_log` VALUES (51097, '116f4d1a-a82c-42f5-8d96-7bd8abf4bbd9', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:34:46', 66, 1002002001, '密码不正确', '2019-07-09 11:34:46');
INSERT INTO `access_log` VALUES (51098, '9a4703ff-40d1-4573-b641-f57d6d4f99fe', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:35:08', 71, 1002002001, '密码不正确', '2019-07-09 11:35:08');
INSERT INTO `access_log` VALUES (51099, '214b73b5-267a-4ada-bf78-742a22aaa0fa', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:41:47', 376, 1002002001, '密码不正确', '2019-07-09 11:41:47');
INSERT INTO `access_log` VALUES (51100, '5bf7212e-4f9c-4b98-972f-e53f3d7b3033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:42:37', 91, 1002002001, '密码不正确', '2019-07-09 11:42:37');
INSERT INTO `access_log` VALUES (51101, 'daf4b9e3-1460-49e9-8fe7-6f7dddc3714b', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:43:30', 72, 1002002001, '密码不正确', '2019-07-09 11:43:30');
INSERT INTO `access_log` VALUES (51102, 'dac12992-faba-483e-a9a6-d48854624334', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:44:27', 45682, 1002002001, '密码不正确', '2019-07-09 11:45:13');
INSERT INTO `access_log` VALUES (51103, 'd36059b0-29b0-4fdd-8046-38bb43c70d3d', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:58:39', 52229, 1002002001, '密码不正确', '2019-07-09 11:59:32');
INSERT INTO `access_log` VALUES (51104, 'dd89aff5-7c0f-4b4f-9c21-9e942718da10', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:59:37', 2018, 1002002001, '密码不正确', '2019-07-09 11:59:39');
INSERT INTO `access_log` VALUES (51105, '2b453b9e-49c3-4e64-8c0d-f19e0a519f5e', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:59:51', 189, 1002002001, '密码不正确', '2019-07-09 11:59:52');
INSERT INTO `access_log` VALUES (51106, '945f5c09-3710-4514-b812-fe61d23c0522', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 11:59:55', 83, 1002002001, '密码不正确', '2019-07-09 11:59:56');
INSERT INTO `access_log` VALUES (51107, 'afa3f184-6c1b-4f90-854c-ddf4c63b6d71', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 12:00:06', 1957934, 1002002001, '密码不正确', '2019-07-09 12:32:43');
INSERT INTO `access_log` VALUES (51108, 'fe38a111-2216-486b-9fc1-935681d5be36', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-09 12:39:53', 5421, 1002002001, '密码不正确', '2019-07-09 12:39:58');
INSERT INTO `access_log` VALUES (51109, '59.80.15626513790558651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-09 13:49:39', 27, 0, '', '2019-07-09 13:49:39');
INSERT INTO `access_log` VALUES (51110, '59.77.15626513790868659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-09 13:49:39', 27, 2001001000, '服务端发生异常', '2019-07-09 13:49:39');
INSERT INTO `access_log` VALUES (51111, '59.79.15626513881808673', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:49:48', 15, 0, '', '2019-07-09 13:49:48');
INSERT INTO `access_log` VALUES (51112, '59.71.15626513881708671', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:49:48', 32, 2001001000, '服务端发生异常', '2019-07-09 13:49:48');
INSERT INTO `access_log` VALUES (51113, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=aa&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:50:08', 20, 0, '', '2019-07-09 13:50:08');
INSERT INTO `access_log` VALUES (51114, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=aa', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:50:08', 13, 0, '', '2019-07-09 13:50:08');
INSERT INTO `access_log` VALUES (51115, '59.75.15626514097168681', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:50:10', 8, 0, '', '2019-07-09 13:50:10');
INSERT INTO `access_log` VALUES (51116, '59.76.15626514097278663', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:50:10', 20, 2001001000, '服务端发生异常', '2019-07-09 13:50:10');
INSERT INTO `access_log` VALUES (51117, '59.73.15626514913808679', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:51:31', 10, 0, '', '2019-07-09 13:51:31');
INSERT INTO `access_log` VALUES (51118, '59.71.15626514913808673', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:51:31', 22, 2001001000, '服务端发生异常', '2019-07-09 13:51:31');
INSERT INTO `access_log` VALUES (51119, '59.75.15626514972178683', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:51:37', 12, 0, '', '2019-07-09 13:51:37');
INSERT INTO `access_log` VALUES (51120, '59.76.15626514972188665', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:51:37', 22, 2001001000, '服务端发生异常', '2019-07-09 13:51:37');
INSERT INTO `access_log` VALUES (51121, '64.84.15626515843128815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:53:04', 20, 0, '', '2019-07-09 13:53:04');
INSERT INTO `access_log` VALUES (51122, '64.76.15626515844458811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:53:04', 12, 0, '', '2019-07-09 13:53:04');
INSERT INTO `access_log` VALUES (51123, '59.73.15626515867988681', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:53:07', 8, 0, '', '2019-07-09 13:53:07');
INSERT INTO `access_log` VALUES (51124, '59.78.15626515868128671', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:53:07', 57, 2001001000, '服务端发生异常', '2019-07-09 13:53:07');
INSERT INTO `access_log` VALUES (51125, '64.80.15626515913678827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:53:11', 9, 0, '', '2019-07-09 13:53:11');
INSERT INTO `access_log` VALUES (51126, '64.79.15626515915568823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:53:12', 9, 0, '', '2019-07-09 13:53:12');
INSERT INTO `access_log` VALUES (51127, '64.82.15626515954158837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:53:15', 9, 0, '', '2019-07-09 13:53:15');
INSERT INTO `access_log` VALUES (51128, '64.77.15626515955018801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:53:16', 9, 0, '', '2019-07-09 13:53:16');
INSERT INTO `access_log` VALUES (51129, '64.85.15626515982078833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:53:18', 8, 0, '', '2019-07-09 13:53:18');
INSERT INTO `access_log` VALUES (51130, '64.78.15626515983288827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:53:18', 6, 0, '', '2019-07-09 13:53:18');
INSERT INTO `access_log` VALUES (51131, '66.57.15626515991516705', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:53:19', 5, 1002001012, '访问令牌已过期', '2019-07-09 13:53:19');
INSERT INTO `access_log` VALUES (51132, '66.55.15626515994626687', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=5d47b7b80abf407f8ef11f792f103fe1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:53:19', 8, 1002001018, '访问令牌已过期', '2019-07-09 13:53:19');
INSERT INTO `access_log` VALUES (51133, '59.76.15626516036118667', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:53:24', 11, 0, '', '2019-07-09 13:53:24');
INSERT INTO `access_log` VALUES (51134, '59.74.15626516036128681', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 13:53:24', 20, 2001001000, '服务端发生异常', '2019-07-09 13:53:24');
INSERT INTO `access_log` VALUES (51135, '59.75.15626518621908689', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.58.18', '2019-07-09 13:57:42', 4, 0, '', '2019-07-09 13:57:42');
INSERT INTO `access_log` VALUES (51136, '59.76.15626518621918671', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.58.18', '2019-07-09 13:57:42', 13, 2001001000, '服务端发生异常', '2019-07-09 13:57:42');
INSERT INTO `access_log` VALUES (51137, '65.45.15626518649920353', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.58.18', '2019-07-09 13:57:45', 0, 1002001015, '账号未登陆', '2019-07-09 13:57:45');
INSERT INTO `access_log` VALUES (51138, '65.49.15626518649920365', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.58.18', '2019-07-09 13:57:45', 0, 1002001015, '账号未登陆', '2019-07-09 13:57:45');
INSERT INTO `access_log` VALUES (51139, '65.47.15626518649930351', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.58.18', '2019-07-09 13:57:45', 1, 1002001015, '账号未登陆', '2019-07-09 13:57:45');
INSERT INTO `access_log` VALUES (51140, '65.54.15626518688870329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.58.18', '2019-07-09 13:57:49', 96, 0, '', '2019-07-09 13:57:49');
INSERT INTO `access_log` VALUES (51141, '65.46.15626518692280419', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.58.18', '2019-07-09 13:57:49', 11, 0, '', '2019-07-09 13:57:49');
INSERT INTO `access_log` VALUES (51142, '65.51.15626518692390429', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.58.18', '2019-07-09 13:57:49', 9, 0, '', '2019-07-09 13:57:49');
INSERT INTO `access_log` VALUES (51143, '65.53.15626518692390375', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.58.18', '2019-07-09 13:57:49', 10, 2001001000, '服务端发生异常', '2019-07-09 13:57:49');
INSERT INTO `access_log` VALUES (51144, '65.50.15626518887720397', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.191.58.18', '2019-07-09 13:58:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 13:58:09');
INSERT INTO `access_log` VALUES (51145, '59.74.15626521625918689', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 14:02:43', 3, 0, '', '2019-07-09 14:02:43');
INSERT INTO `access_log` VALUES (51146, '59.72.15626521625928681', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 14:02:43', 13, 2001001000, '服务端发生异常', '2019-07-09 14:02:43');
INSERT INTO `access_log` VALUES (51147, '64.78.15626521716068835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 14:02:52', 3, 0, '', '2019-07-09 14:02:52');
INSERT INTO `access_log` VALUES (51148, '64.84.15626521718298825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 14:02:52', 2, 0, '', '2019-07-09 14:02:52');
INSERT INTO `access_log` VALUES (51149, '64.82.15626523861428849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 14:06:26', 8, 0, '', '2019-07-09 14:06:26');
INSERT INTO `access_log` VALUES (51150, '64.85.15626523862388845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 14:06:26', 8, 0, '', '2019-07-09 14:06:26');
INSERT INTO `access_log` VALUES (51151, '59.76.15626523875948679', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 14:06:28', 9, 0, '', '2019-07-09 14:06:28');
INSERT INTO `access_log` VALUES (51152, '59.74.15626523875998693', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 14:06:28', 17, 2001001000, '服务端发生异常', '2019-07-09 14:06:28');
INSERT INTO `access_log` VALUES (51153, '59.77.15626523997628677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 14:06:40', 9, 0, '', '2019-07-09 14:06:40');
INSERT INTO `access_log` VALUES (51154, '59.80.15626523997608669', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 14:06:40', 21, 2001001000, '服务端发生异常', '2019-07-09 14:06:40');
INSERT INTO `access_log` VALUES (51155, '66.54.15626524082266721', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 14:06:48', 7, 1002001012, '访问令牌已过期', '2019-07-09 14:06:48');
INSERT INTO `access_log` VALUES (51156, '66.50.15626524083346713', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=5d47b7b80abf407f8ef11f792f103fe1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 14:06:48', 8, 1002001018, '访问令牌已过期', '2019-07-09 14:06:48');
INSERT INTO `access_log` VALUES (51157, '59.74.15626524975418695', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 14:08:18', 9, 0, '', '2019-07-09 14:08:18');
INSERT INTO `access_log` VALUES (51158, '59.72.15626524975488687', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 14:08:18', 16, 2001001000, '服务端发生异常', '2019-07-09 14:08:18');
INSERT INTO `access_log` VALUES (51159, '66.53.15626527430926727', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 14:12:23', 6, 1002001012, '访问令牌已过期', '2019-07-09 14:12:23');
INSERT INTO `access_log` VALUES (51160, '65.52.15626527471220417', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 14:12:27', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 14:12:27');
INSERT INTO `access_log` VALUES (51161, '65.50.15626527516360409', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 14:12:32', 59, 0, '', '2019-07-09 14:12:32');
INSERT INTO `access_log` VALUES (51162, '65.3607.15626527523242179', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 14:12:32', 10, 0, '', '2019-07-09 14:12:32');
INSERT INTO `access_log` VALUES (51163, '65.49.15626527523270379', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 14:12:32', 9, 0, '', '2019-07-09 14:12:32');
INSERT INTO `access_log` VALUES (51164, '65.45.15626527523280367', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 14:12:32', 9, 0, '', '2019-07-09 14:12:32');
INSERT INTO `access_log` VALUES (51165, '66.51.15626527556136747', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-09 14:12:36', 21, 0, '', '2019-07-09 14:12:36');
INSERT INTO `access_log` VALUES (51166, '59.76.15626530431098689', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:17:23', 10, 0, '', '2019-07-09 14:17:23');
INSERT INTO `access_log` VALUES (51167, '59.74.15626530431118703', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:17:23', 18, 2001001000, '服务端发生异常', '2019-07-09 14:17:23');
INSERT INTO `access_log` VALUES (51168, '65.47.15626530454240369', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 14:17:25', 4, 1002001012, '访问令牌已过期', '2019-07-09 14:17:25');
INSERT INTO `access_log` VALUES (51169, '65.54.15626530454250347', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 14:17:25', 3, 1002001012, '访问令牌已过期', '2019-07-09 14:17:25');
INSERT INTO `access_log` VALUES (51170, '65.51.15626530454320447', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 14:17:25', 3, 1002001012, '访问令牌已过期', '2019-07-09 14:17:25');
INSERT INTO `access_log` VALUES (51171, '65.46.15626530479130437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 14:17:28', 116, 0, '', '2019-07-09 14:17:28');
INSERT INTO `access_log` VALUES (51172, '65.53.15626530484600393', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 14:17:28', 8, 0, '', '2019-07-09 14:17:28');
INSERT INTO `access_log` VALUES (51173, '65.52.15626530484650423', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 14:17:28', 8, 2001001000, '服务端发生异常', '2019-07-09 14:17:28');
INSERT INTO `access_log` VALUES (51174, '65.50.15626530484790415', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '60.247.104.74', '2019-07-09 14:17:28', 8, 0, '', '2019-07-09 14:17:28');
INSERT INTO `access_log` VALUES (51175, '64.80.15626530582828849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:17:38', 10, 0, '', '2019-07-09 14:17:38');
INSERT INTO `access_log` VALUES (51176, '64.79.15626530586508845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:17:39', 2, 0, '', '2019-07-09 14:17:39');
INSERT INTO `access_log` VALUES (51177, '64.82.15626530601118859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:17:40', 2, 0, '', '2019-07-09 14:17:40');
INSERT INTO `access_log` VALUES (51178, '64.77.15626530609748823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:17:41', 3, 0, '', '2019-07-09 14:17:41');
INSERT INTO `access_log` VALUES (51179, '64.85.15626530615478855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:17:42', 2, 0, '', '2019-07-09 14:17:42');
INSERT INTO `access_log` VALUES (51180, '66.52.15626530682416719', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:17:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字', '2019-07-09 14:17:48');
INSERT INTO `access_log` VALUES (51181, '64.84.15626530715488839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:17:52', 3, 0, '', '2019-07-09 14:17:52');
INSERT INTO `access_log` VALUES (51182, '64.83.15626530718418841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:17:52', 1, 0, '', '2019-07-09 14:17:52');
INSERT INTO `access_log` VALUES (51183, '64.76.15626530853178835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:05', 893, 0, '', '2019-07-09 14:18:06');
INSERT INTO `access_log` VALUES (51184, '64.80.15626530863788851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:06', 430, 0, '', '2019-07-09 14:18:07');
INSERT INTO `access_log` VALUES (51185, '64.79.15626530912128847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:11', 2, 0, '', '2019-07-09 14:18:11');
INSERT INTO `access_log` VALUES (51186, '64.82.15626530913718861', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:11', 1, 0, '', '2019-07-09 14:18:11');
INSERT INTO `access_log` VALUES (51187, '64.77.15626530960488825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:16', 2, 0, '', '2019-07-09 14:18:16');
INSERT INTO `access_log` VALUES (51188, '64.85.15626530966888857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:17', 67, 0, '', '2019-07-09 14:18:17');
INSERT INTO `access_log` VALUES (51189, '64.78.15626530981428851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:18', 1, 0, '', '2019-07-09 14:18:18');
INSERT INTO `access_log` VALUES (51190, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:18', 5, 0, '', '2019-07-09 14:18:18');
INSERT INTO `access_log` VALUES (51191, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:20', 5, 0, '', '2019-07-09 14:18:20');
INSERT INTO `access_log` VALUES (51192, '64.83.15626531011008843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:21', 2, 0, '', '2019-07-09 14:18:21');
INSERT INTO `access_log` VALUES (51193, '64.81.15626531014918833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:21', 2, 0, '', '2019-07-09 14:18:21');
INSERT INTO `access_log` VALUES (51194, '64.76.15626531019838837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:22', 2, 0, '', '2019-07-09 14:18:22');
INSERT INTO `access_log` VALUES (51195, '64.80.15626531026038853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:23', 2, 0, '', '2019-07-09 14:18:23');
INSERT INTO `access_log` VALUES (51196, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:23', 6, 0, '', '2019-07-09 14:18:23');
INSERT INTO `access_log` VALUES (51197, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:26', 5, 0, '', '2019-07-09 14:18:26');
INSERT INTO `access_log` VALUES (51198, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:27', 5, 0, '', '2019-07-09 14:18:27');
INSERT INTO `access_log` VALUES (51199, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:28', 5, 0, '', '2019-07-09 14:18:28');
INSERT INTO `access_log` VALUES (51200, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:29', 6, 0, '', '2019-07-09 14:18:29');
INSERT INTO `access_log` VALUES (51201, '64.79.15626531099458849', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '1.119.195.146', '2019-07-09 14:18:30', 8, 0, '', '2019-07-09 14:18:30');
INSERT INTO `access_log` VALUES (51202, '65.50.15626531854640417', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:19:45', 0, 1002001015, '账号未登陆', '2019-07-09 14:19:45');
INSERT INTO `access_log` VALUES (51203, '65.45.15626531854640375', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:19:45', 0, 1002001015, '账号未登陆', '2019-07-09 14:19:45');
INSERT INTO `access_log` VALUES (51204, '65.49.15626531854660387', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:19:45', 1, 1002001015, '账号未登陆', '2019-07-09 14:19:45');
INSERT INTO `access_log` VALUES (51205, '65.47.15626531980720373', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:19:58', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 14:19:58');
INSERT INTO `access_log` VALUES (51206, '65.51.15626532031860451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:20:03', 68, 0, '', '2019-07-09 14:20:03');
INSERT INTO `access_log` VALUES (51207, '65.54.15626532037540351', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:20:04', 9, 0, '', '2019-07-09 14:20:04');
INSERT INTO `access_log` VALUES (51208, '65.46.15626532037610441', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:20:04', 10, 2001001000, '服务端发生异常', '2019-07-09 14:20:04');
INSERT INTO `access_log` VALUES (51209, '65.53.15626532037660397', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:20:04', 8, 0, '', '2019-07-09 14:20:04');
INSERT INTO `access_log` VALUES (51210, '65.45.15626532254020377', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:20:25', 9, 0, '', '2019-07-09 14:20:25');
INSERT INTO `access_log` VALUES (51211, '65.49.15626532254010389', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:20:25', 10, 2001001000, '服务端发生异常', '2019-07-09 14:20:25');
INSERT INTO `access_log` VALUES (51212, '65.3607.15626532255502189', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:20:26', 16, 0, '', '2019-07-09 14:20:26');
INSERT INTO `access_log` VALUES (51213, '65.54.15626532693150353', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:21:09', 9, 0, '', '2019-07-09 14:21:09');
INSERT INTO `access_log` VALUES (51214, '65.53.15626532693210399', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:21:09', 10, 2001001000, '服务端发生异常', '2019-07-09 14:21:09');
INSERT INTO `access_log` VALUES (51215, '65.52.15626532693300429', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:21:09', 9, 0, '', '2019-07-09 14:21:09');
INSERT INTO `access_log` VALUES (51216, '65.49.15626532762380391', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:21:16', 8, 0, '', '2019-07-09 14:21:16');
INSERT INTO `access_log` VALUES (51217, '65.45.15626532762390379', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:21:16', 8, 0, '', '2019-07-09 14:21:16');
INSERT INTO `access_log` VALUES (51218, '65.50.15626532762380421', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:21:16', 11, 2001001000, '服务端发生异常', '2019-07-09 14:21:16');
INSERT INTO `access_log` VALUES (51219, '65.3607.15626532795772191', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:21:20', 7, 0, '', '2019-07-09 14:21:20');
INSERT INTO `access_log` VALUES (51220, '65.47.15626532795830377', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:21:20', 8, 2001001000, '服务端发生异常', '2019-07-09 14:21:20');
INSERT INTO `access_log` VALUES (51221, '65.51.15626532795890455', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.119.195.146', '2019-07-09 14:21:20', 8, 0, '', '2019-07-09 14:21:20');
INSERT INTO `access_log` VALUES (51222, '64.82.15626534000798867', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 14:23:20', 9, 0, '', '2019-07-09 14:23:20');
INSERT INTO `access_log` VALUES (51223, '64.85.15626534002088863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 14:23:20', 7, 0, '', '2019-07-09 14:23:20');
INSERT INTO `access_log` VALUES (51224, '59.78.15626534007688699', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 14:23:21', 10, 0, '', '2019-07-09 14:23:21');
INSERT INTO `access_log` VALUES (51225, '59.75.15626534007788713', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-09 14:23:21', 16, 2001001000, '服务端发生异常', '2019-07-09 14:23:21');
INSERT INTO `access_log` VALUES (51226, '65.53.15626539424970411', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-09 14:32:22', 60, 0, '', '2019-07-09 14:32:23');
INSERT INTO `access_log` VALUES (51227, '65.50.15626539428920431', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-09 14:32:23', 43, 0, '', '2019-07-09 14:32:23');
INSERT INTO `access_log` VALUES (51228, '65.45.15626539428980391', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-09 14:32:23', 41, 0, '', '2019-07-09 14:32:23');
INSERT INTO `access_log` VALUES (51229, '65.3607.15626539428972203', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-09 14:32:23', 42, 2001001000, '服务端发生异常', '2019-07-09 14:32:23');
INSERT INTO `access_log` VALUES (51230, '65.47.15626539546440389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-09 14:32:35', 9, 0, '', '2019-07-09 14:32:35');
INSERT INTO `access_log` VALUES (51231, '65.46.15626539546440457', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-09 14:32:35', 9, 0, '', '2019-07-09 14:32:35');
INSERT INTO `access_log` VALUES (51232, '65.52.15626539546450439', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-09 14:32:35', 10, 2001001000, '服务端发生异常', '2019-07-09 14:32:35');
INSERT INTO `access_log` VALUES (51233, '65.49.15626539569970401', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-09 14:32:37', 10, 0, '', '2019-07-09 14:32:37');
INSERT INTO `access_log` VALUES (51234, '65.53.15626539569990413', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-09 14:32:37', 9, 0, '', '2019-07-09 14:32:37');
INSERT INTO `access_log` VALUES (51235, '65.54.15626539569990365', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-09 14:32:37', 10, 2001001000, '服务端发生异常', '2019-07-09 14:32:37');
INSERT INTO `access_log` VALUES (51236, '66.54.15626541255226745', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 14:35:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-07-09 14:35:26');
INSERT INTO `access_log` VALUES (51237, '66.50.15626541255556737', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 14:35:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-07-09 14:35:26');
INSERT INTO `access_log` VALUES (51238, '66.57.15626541400486741', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18516602911', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 14:35:40', 148, 0, '', '2019-07-09 14:35:40');
INSERT INTO `access_log` VALUES (51239, '66.55.15626541461166723', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18516602911&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 14:35:46', 147, 0, '', '2019-07-09 14:35:46');
INSERT INTO `access_log` VALUES (51240, '64.83.15626541542218859', 162, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 14:35:54', 6, 0, '', '2019-07-09 14:35:54');
INSERT INTO `access_log` VALUES (51241, '64.76.15626541545018853', 162, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 14:35:55', 5, 0, '', '2019-07-09 14:35:55');
INSERT INTO `access_log` VALUES (51242, '59.77.15626541562108703', 162, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 14:35:56', 15, 2001001000, '服务端发生异常', '2019-07-09 14:35:56');
INSERT INTO `access_log` VALUES (51243, '59.72.15626541561388711', 162, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 14:35:56', 230, 0, '', '2019-07-09 14:35:56');
INSERT INTO `access_log` VALUES (51244, '66.51.15626541589236767', 162, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 14:35:59', 5, 0, '', '2019-07-09 14:35:59');
INSERT INTO `access_log` VALUES (51245, '66.52.15626541621216735', 162, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '144.123.25.246', '2019-07-09 14:36:02', 5, 0, '', '2019-07-09 14:36:02');
INSERT INTO `access_log` VALUES (51246, '66.54.15626541749356747', 162, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '144.123.25.246', '2019-07-09 14:36:15', 6, 0, '', '2019-07-09 14:36:15');
INSERT INTO `access_log` VALUES (51247, '66.49.15626541770776759', 162, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '144.123.25.246', '2019-07-09 14:36:17', 86, 0, '', '2019-07-09 14:36:17');
INSERT INTO `access_log` VALUES (51248, '66.55.15626541848586725', 162, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '144.123.25.246', '2019-07-09 14:36:25', 5, 0, '', '2019-07-09 14:36:25');
INSERT INTO `access_log` VALUES (51249, '66.53.15626541857986749', 162, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '144.123.25.246', '2019-07-09 14:36:26', 6, 0, '', '2019-07-09 14:36:26');
INSERT INTO `access_log` VALUES (51250, '59.80.15626547623008703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.76.170.129', '2019-07-09 14:46:02', 4, 0, '', '2019-07-09 14:46:02');
INSERT INTO `access_log` VALUES (51251, '59.79.15626547623108725', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.76.170.129', '2019-07-09 14:46:02', 13, 2001001000, '服务端发生异常', '2019-07-09 14:46:02');
INSERT INTO `access_log` VALUES (51252, '64.80.15626547650408877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.76.170.129', '2019-07-09 14:46:05', 3, 0, '', '2019-07-09 14:46:05');
INSERT INTO `access_log` VALUES (51253, '64.79.15626547652838873', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.76.170.129', '2019-07-09 14:46:05', 2, 0, '', '2019-07-09 14:46:05');
INSERT INTO `access_log` VALUES (51254, '64.77.15626547662268851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.76.170.129', '2019-07-09 14:46:06', 3, 0, '', '2019-07-09 14:46:06');
INSERT INTO `access_log` VALUES (51255, '64.85.15626547666988883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.76.170.129', '2019-07-09 14:46:07', 2, 0, '', '2019-07-09 14:46:07');
INSERT INTO `access_log` VALUES (51256, '65.47.15626547747260401', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.76.170.129', '2019-07-09 14:46:15', 1, 1002001015, '账号未登陆', '2019-07-09 14:46:15');
INSERT INTO `access_log` VALUES (51257, '65.46.15626547747330469', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.76.170.129', '2019-07-09 14:46:15', 0, 1002001015, '账号未登陆', '2019-07-09 14:46:15');
INSERT INTO `access_log` VALUES (51258, '65.49.15626547747440413', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.76.170.129', '2019-07-09 14:46:15', 0, 1002001015, '账号未登陆', '2019-07-09 14:46:15');
INSERT INTO `access_log` VALUES (51259, '65.45.15626548188810405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.76.170.129', '2019-07-09 14:46:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 14:46:59');
INSERT INTO `access_log` VALUES (51260, '59.79.15626548757508727', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.34.242.74', '2019-07-09 14:47:56', 3, 0, '', '2019-07-09 14:47:56');
INSERT INTO `access_log` VALUES (51261, '59.80.15626548757508705', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.34.242.74', '2019-07-09 14:47:56', 10, 2001001000, '服务端发生异常', '2019-07-09 14:47:56');
INSERT INTO `access_log` VALUES (51262, '59.73.15626548866728731', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.34.242.74', '2019-07-09 14:48:07', 3, 0, '', '2019-07-09 14:48:07');
INSERT INTO `access_log` VALUES (51263, '59.78.15626548866848721', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.34.242.74', '2019-07-09 14:48:07', 12, 2001001000, '服务端发生异常', '2019-07-09 14:48:07');
INSERT INTO `access_log` VALUES (51264, '64.77.15626548924918853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.34.242.74', '2019-07-09 14:48:12', 3, 0, '', '2019-07-09 14:48:12');
INSERT INTO `access_log` VALUES (51265, '64.85.15626548926178885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.34.242.74', '2019-07-09 14:48:13', 2, 0, '', '2019-07-09 14:48:13');
INSERT INTO `access_log` VALUES (51266, '59.72.15626565859728745', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.124.215', '2019-07-09 15:16:26', 3, 0, '', '2019-07-09 15:16:26');
INSERT INTO `access_log` VALUES (51267, '59.77.15626565859758737', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.124.215', '2019-07-09 15:16:26', 11, 2001001000, '服务端发生异常', '2019-07-09 15:16:26');
INSERT INTO `access_log` VALUES (51268, '65.3607.15626585519452267', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.134', '183.66.221.22', '2019-07-09 15:49:12', 1, 1002001015, '账号未登陆', '2019-07-09 15:49:12');
INSERT INTO `access_log` VALUES (51269, '65.45.15626585519450455', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.134', '183.66.221.22', '2019-07-09 15:49:12', 1, 1002001015, '账号未登陆', '2019-07-09 15:49:12');
INSERT INTO `access_log` VALUES (51270, '65.51.15626585519450529', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.134', '183.66.221.22', '2019-07-09 15:49:12', 0, 1002001015, '账号未登陆', '2019-07-09 15:49:12');
INSERT INTO `access_log` VALUES (51271, '65.49.15626585646020465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.134', '183.66.221.22', '2019-07-09 15:49:25', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 15:49:25');
INSERT INTO `access_log` VALUES (51272, '65.46.15626585716340521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.134', '183.66.221.22', '2019-07-09 15:49:32', 66, 0, '', '2019-07-09 15:49:32');
INSERT INTO `access_log` VALUES (51273, '65.47.15626585719680453', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.134', '183.66.221.22', '2019-07-09 15:49:32', 13, 0, '', '2019-07-09 15:49:32');
INSERT INTO `access_log` VALUES (51274, '65.53.15626585719700477', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.134', '183.66.221.22', '2019-07-09 15:49:32', 12, 0, '', '2019-07-09 15:49:32');
INSERT INTO `access_log` VALUES (51275, '65.54.15626585719680429', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.134', '183.66.221.22', '2019-07-09 15:49:32', 13, 2001001000, '服务端发生异常', '2019-07-09 15:49:32');
INSERT INTO `access_log` VALUES (51276, '65.50.15626585787510497', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.134', '183.66.221.22', '2019-07-09 15:49:39', 9, 0, '', '2019-07-09 15:49:39');
INSERT INTO `access_log` VALUES (51277, '65.51.15626585787550531', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.134', '183.66.221.22', '2019-07-09 15:49:39', 9, 0, '', '2019-07-09 15:49:39');
INSERT INTO `access_log` VALUES (51278, '65.45.15626585787560457', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.134', '183.66.221.22', '2019-07-09 15:49:39', 9, 2001001000, '服务端发生异常', '2019-07-09 15:49:39');
INSERT INTO `access_log` VALUES (51279, '65.52.15626585860100505', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.134', '183.66.221.22', '2019-07-09 15:49:46', 22, 0, '', '2019-07-09 15:49:46');
INSERT INTO `access_log` VALUES (51280, '65.49.15626585860130467', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.134', '183.66.221.22', '2019-07-09 15:49:46', 21, 0, '', '2019-07-09 15:49:46');
INSERT INTO `access_log` VALUES (51281, '65.46.15626585860150523', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/607.2.6 (KHTML, like Gecko) Version/12.1.1 Safari/607.2.6 Maxthon/5.1.134', '183.66.221.22', '2019-07-09 15:49:46', 22, 2001001000, '服务端发生异常', '2019-07-09 15:49:46');
INSERT INTO `access_log` VALUES (51282, '59.79.15626586897118779', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.85.112.149', '2019-07-09 15:51:30', 10, 0, '', '2019-07-09 15:51:30');
INSERT INTO `access_log` VALUES (51283, '59.80.15626586897118757', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.85.112.149', '2019-07-09 15:51:30', 15, 2001001000, '服务端发生异常', '2019-07-09 15:51:30');
INSERT INTO `access_log` VALUES (51284, '65.49.15626591351200475', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.127.45.81', '2019-07-09 15:58:55', 1, 1002001015, '账号未登陆', '2019-07-09 15:58:55');
INSERT INTO `access_log` VALUES (51285, '65.52.15626591351190513', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.127.45.81', '2019-07-09 15:58:55', 1, 1002001015, '账号未登陆', '2019-07-09 15:58:55');
INSERT INTO `access_log` VALUES (51286, '65.46.15626591351310531', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.127.45.81', '2019-07-09 15:58:55', 1, 1002001015, '账号未登陆', '2019-07-09 15:58:55');
INSERT INTO `access_log` VALUES (51287, '65.54.15626591376320439', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.127.45.81', '2019-07-09 15:58:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 15:58:58');
INSERT INTO `access_log` VALUES (51288, '65.53.15626591407720487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.127.45.81', '2019-07-09 15:59:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 15:59:01');
INSERT INTO `access_log` VALUES (51289, '65.47.15626591418400463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.127.45.81', '2019-07-09 15:59:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 15:59:02');
INSERT INTO `access_log` VALUES (51290, '65.50.15626591422720507', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.127.45.81', '2019-07-09 15:59:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 15:59:02');
INSERT INTO `access_log` VALUES (51291, '59.74.15626593666928791', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.173.241.186', '2019-07-09 16:02:47', 5, 0, '', '2019-07-09 16:02:47');
INSERT INTO `access_log` VALUES (51292, '59.72.15626593666958783', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.173.241.186', '2019-07-09 16:02:47', 14, 2001001000, '服务端发生异常', '2019-07-09 16:02:47');
INSERT INTO `access_log` VALUES (51293, '65.47.15626594079360467', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3829.0 Safari/537.36 Edg/77.0.197.1', '120.196.48.101', '2019-07-09 16:03:28', 0, 1002001015, '账号未登陆', '2019-07-09 16:03:28');
INSERT INTO `access_log` VALUES (51294, '65.50.15626594079390511', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3829.0 Safari/537.36 Edg/77.0.197.1', '120.196.48.101', '2019-07-09 16:03:28', 1, 1002001015, '账号未登陆', '2019-07-09 16:03:28');
INSERT INTO `access_log` VALUES (51295, '65.51.15626594079440545', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3829.0 Safari/537.36 Edg/77.0.197.1', '120.196.48.101', '2019-07-09 16:03:28', 0, 1002001015, '账号未登陆', '2019-07-09 16:03:28');
INSERT INTO `access_log` VALUES (51296, '65.46.15626594522730537', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3829.0 Safari/537.36 Edg/77.0.197.1', '120.196.48.101', '2019-07-09 16:04:12', 190, 0, '', '2019-07-09 16:04:12');
INSERT INTO `access_log` VALUES (51297, '65.49.15626594528720481', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3829.0 Safari/537.36 Edg/77.0.197.1', '120.196.48.101', '2019-07-09 16:04:13', 10, 0, '', '2019-07-09 16:04:13');
INSERT INTO `access_log` VALUES (51298, '65.54.15626594528720445', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3829.0 Safari/537.36 Edg/77.0.197.1', '120.196.48.101', '2019-07-09 16:04:13', 10, 2001001000, '服务端发生异常', '2019-07-09 16:04:13');
INSERT INTO `access_log` VALUES (51299, '65.53.15626594531330493', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3829.0 Safari/537.36 Edg/77.0.197.1', '120.196.48.101', '2019-07-09 16:04:13', 74, 0, '', '2019-07-09 16:04:13');
INSERT INTO `access_log` VALUES (51300, '64.79.15626594855948937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:04:46', 12, 0, '', '2019-07-09 16:04:46');
INSERT INTO `access_log` VALUES (51301, '64.82.15626594857298951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:04:46', 3, 0, '', '2019-07-09 16:04:46');
INSERT INTO `access_log` VALUES (51302, '64.77.15626594873178915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:04:47', 2, 0, '', '2019-07-09 16:04:47');
INSERT INTO `access_log` VALUES (51303, '64.85.15626594885038947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:04:49', 1, 0, '', '2019-07-09 16:04:49');
INSERT INTO `access_log` VALUES (51304, '64.78.15626594898108941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:04:50', 2, 0, '', '2019-07-09 16:04:50');
INSERT INTO `access_log` VALUES (51305, '64.83.15626594910788933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:04:51', 2, 0, '', '2019-07-09 16:04:51');
INSERT INTO `access_log` VALUES (51306, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:04:51', 7, 0, '', '2019-07-09 16:04:51');
INSERT INTO `access_log` VALUES (51307, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:04:55', 5, 0, '', '2019-07-09 16:04:55');
INSERT INTO `access_log` VALUES (51308, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:04:56', 7, 0, '', '2019-07-09 16:04:56');
INSERT INTO `access_log` VALUES (51309, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:04:58', 5, 0, '', '2019-07-09 16:04:58');
INSERT INTO `access_log` VALUES (51310, '64.81.15626594989048923', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:04:59', 8, 0, '', '2019-07-09 16:04:59');
INSERT INTO `access_log` VALUES (51311, '64.80.15626595149138943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:05:15', 2, 0, '', '2019-07-09 16:05:15');
INSERT INTO `access_log` VALUES (51312, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:05:15', 6, 0, '', '2019-07-09 16:05:15');
INSERT INTO `access_log` VALUES (51313, '64.82.15626595244178953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:05:24', 2, 0, '', '2019-07-09 16:05:24');
INSERT INTO `access_log` VALUES (51314, '64.77.15626595245348917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:05:25', 2, 0, '', '2019-07-09 16:05:25');
INSERT INTO `access_log` VALUES (51315, '64.85.15626595309038949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:05:31', 1, 0, '', '2019-07-09 16:05:31');
INSERT INTO `access_log` VALUES (51316, '64.78.15626595310678943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:05:31', 1, 0, '', '2019-07-09 16:05:31');
INSERT INTO `access_log` VALUES (51317, '59.71.15626595360018789', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:05:36', 13, 2001001000, '服务端发生异常', '2019-07-09 16:05:36');
INSERT INTO `access_log` VALUES (51318, '59.80.15626595360018769', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:05:36', 118, 0, '', '2019-07-09 16:05:36');
INSERT INTO `access_log` VALUES (51319, '64.83.15626595478128935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:05:48', 2, 0, '', '2019-07-09 16:05:48');
INSERT INTO `access_log` VALUES (51320, '64.81.15626595479498925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:05:48', 2, 0, '', '2019-07-09 16:05:48');
INSERT INTO `access_log` VALUES (51321, '59.73.15626595486968795', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:05:49', 3, 0, '', '2019-07-09 16:05:49');
INSERT INTO `access_log` VALUES (51322, '59.78.15626595486968785', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '59.173.241.186', '2019-07-09 16:05:49', 18, 2001001000, '服务端发生异常', '2019-07-09 16:05:49');
INSERT INTO `access_log` VALUES (51323, '64.80.15626595625828945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.236', '2019-07-09 16:06:03', 2, 0, '', '2019-07-09 16:06:03');
INSERT INTO `access_log` VALUES (51324, '65.53.15626595866900495', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.173.241.186', '2019-07-09 16:06:27', 1, 1002001015, '账号未登陆', '2019-07-09 16:06:27');
INSERT INTO `access_log` VALUES (51325, '65.50.15626595866940515', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.173.241.186', '2019-07-09 16:06:27', 1, 1002001015, '账号未登陆', '2019-07-09 16:06:27');
INSERT INTO `access_log` VALUES (51326, '65.47.15626595867040471', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.173.241.186', '2019-07-09 16:06:27', 1, 1002001015, '账号未登陆', '2019-07-09 16:06:27');
INSERT INTO `access_log` VALUES (51327, '65.45.15626596010070475', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.173.241.186', '2019-07-09 16:06:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 16:06:41');
INSERT INTO `access_log` VALUES (51328, '65.3607.15626596065142287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.173.241.186', '2019-07-09 16:06:47', 66, 0, '', '2019-07-09 16:06:47');
INSERT INTO `access_log` VALUES (51329, '65.52.15626596068250523', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.173.241.186', '2019-07-09 16:06:47', 10, 0, '', '2019-07-09 16:06:47');
INSERT INTO `access_log` VALUES (51330, '65.46.15626596068290541', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.173.241.186', '2019-07-09 16:06:47', 10, 2001001000, '服务端发生异常', '2019-07-09 16:06:47');
INSERT INTO `access_log` VALUES (51331, '65.49.15626596068330485', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.173.241.186', '2019-07-09 16:06:47', 9, 0, '', '2019-07-09 16:06:47');
INSERT INTO `access_log` VALUES (51332, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.178.166', '2019-07-09 16:12:14', 6, 0, '', '2019-07-09 16:12:14');
INSERT INTO `access_log` VALUES (51333, '65.3607.15626599958552293', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.151.178.165', '2019-07-09 16:13:16', 0, 1002001015, '账号未登陆', '2019-07-09 16:13:16');
INSERT INTO `access_log` VALUES (51334, '65.54.15626600488990455', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.89.239.216', '2019-07-09 16:14:09', 0, 1002001015, '账号未登陆', '2019-07-09 16:14:09');
INSERT INTO `access_log` VALUES (51335, '59.79.15626600661808799', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.129.6.251', '2019-07-09 16:14:26', 3, 0, '', '2019-07-09 16:14:26');
INSERT INTO `access_log` VALUES (51336, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.151.178.236', '2019-07-09 16:14:35', 6, 0, '', '2019-07-09 16:14:35');
INSERT INTO `access_log` VALUES (51337, '64.76.15626601349488937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.89.239.230', '2019-07-09 16:15:35', 4, 0, '', '2019-07-09 16:15:35');
INSERT INTO `access_log` VALUES (51338, '64.80.15626601350298953', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.151.178.197', '2019-07-09 16:15:35', 6, 0, '', '2019-07-09 16:15:35');
INSERT INTO `access_log` VALUES (51339, '64.82.15626601357478963', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.129.7.235', '2019-07-09 16:15:36', 2, 0, '', '2019-07-09 16:15:36');
INSERT INTO `access_log` VALUES (51340, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.251', '2019-07-09 16:16:37', 6, 0, '', '2019-07-09 16:16:37');
INSERT INTO `access_log` VALUES (51341, '64.81.15626602133908935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.29.94', '2019-07-09 16:16:53', 2, 0, '', '2019-07-09 16:16:53');
INSERT INTO `access_log` VALUES (51342, '65.46.15626602966510551', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.60.104', '2019-07-09 16:18:17', 1, 1002001015, '账号未登陆', '2019-07-09 16:18:17');
INSERT INTO `access_log` VALUES (51343, '59.74.15626620915538829', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:12', 12, 0, '', '2019-07-09 16:48:12');
INSERT INTO `access_log` VALUES (51344, '59.76.15626620915538815', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:12', 18, 2001001000, '服务端发生异常', '2019-07-09 16:48:12');
INSERT INTO `access_log` VALUES (51345, '59.72.15626620946928821', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:15', 4, 0, '', '2019-07-09 16:48:15');
INSERT INTO `access_log` VALUES (51346, '59.77.15626620946948813', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:15', 13, 2001001000, '服务端发生异常', '2019-07-09 16:48:15');
INSERT INTO `access_log` VALUES (51347, '64.78.15626621035808979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:24', 11, 0, '', '2019-07-09 16:48:24');
INSERT INTO `access_log` VALUES (51348, '64.84.15626621036658969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:24', 3, 0, '', '2019-07-09 16:48:24');
INSERT INTO `access_log` VALUES (51349, '64.83.15626621050128971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:25', 2, 0, '', '2019-07-09 16:48:25');
INSERT INTO `access_log` VALUES (51350, '64.81.15626621057938961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:26', 2, 0, '', '2019-07-09 16:48:26');
INSERT INTO `access_log` VALUES (51351, '59.80.15626621078238805', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:28', 3, 0, '', '2019-07-09 16:48:28');
INSERT INTO `access_log` VALUES (51352, '59.71.15626621078238825', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:28', 13, 2001001000, '服务端发生异常', '2019-07-09 16:48:28');
INSERT INTO `access_log` VALUES (51353, '59.73.15626621149258831', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:35', 3, 0, '', '2019-07-09 16:48:35');
INSERT INTO `access_log` VALUES (51354, '59.75.15626621149278835', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:35', 13, 2001001000, '服务端发生异常', '2019-07-09 16:48:35');
INSERT INTO `access_log` VALUES (51355, '59.76.15626621282418817', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:48', 3, 0, '', '2019-07-09 16:48:48');
INSERT INTO `access_log` VALUES (51356, '59.74.15626621282418831', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:48', 19, 2001001000, '服务端发生异常', '2019-07-09 16:48:48');
INSERT INTO `access_log` VALUES (51357, '64.79.15626621318848977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:52', 2, 0, '', '2019-07-09 16:48:52');
INSERT INTO `access_log` VALUES (51358, '64.82.15626621319768991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:52', 1, 0, '', '2019-07-09 16:48:52');
INSERT INTO `access_log` VALUES (51359, '64.77.15626621333138955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:53', 2, 0, '', '2019-07-09 16:48:53');
INSERT INTO `access_log` VALUES (51360, '64.85.15626621340518987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:54', 2, 0, '', '2019-07-09 16:48:54');
INSERT INTO `access_log` VALUES (51361, '59.77.15626621355748815', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:56', 3, 0, '', '2019-07-09 16:48:56');
INSERT INTO `access_log` VALUES (51362, '59.79.15626621355758829', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.79 Safari/537.36', '36.7.136.208', '2019-07-09 16:48:56', 13, 2001001000, '服务端发生异常', '2019-07-09 16:48:56');
INSERT INTO `access_log` VALUES (51363, '65.53.15626638946210555', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '139.227.253.194', '2019-07-09 17:18:15', 1, 1002001015, '账号未登陆', '2019-07-09 17:18:15');
INSERT INTO `access_log` VALUES (51364, '65.49.15626638946200543', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '139.227.253.194', '2019-07-09 17:18:15', 1, 1002001015, '账号未登陆', '2019-07-09 17:18:15');
INSERT INTO `access_log` VALUES (51365, '65.54.15626638946380507', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '139.227.253.194', '2019-07-09 17:18:15', 0, 1002001015, '账号未登陆', '2019-07-09 17:18:15');
INSERT INTO `access_log` VALUES (51366, '65.47.15626638971050531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '139.227.253.194', '2019-07-09 17:18:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 17:18:17');
INSERT INTO `access_log` VALUES (51367, '65.50.15626638986540575', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '139.227.253.194', '2019-07-09 17:18:19', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 17:18:19');
INSERT INTO `access_log` VALUES (51368, '65.45.15626639187700535', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '139.227.253.194', '2019-07-09 17:18:39', 68, 0, '', '2019-07-09 17:18:39');
INSERT INTO `access_log` VALUES (51369, '65.52.15626639191580583', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '139.227.253.194', '2019-07-09 17:18:39', 11, 0, '', '2019-07-09 17:18:39');
INSERT INTO `access_log` VALUES (51370, '65.46.15626639191660601', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '139.227.253.194', '2019-07-09 17:18:39', 9, 2001001000, '服务端发生异常', '2019-07-09 17:18:39');
INSERT INTO `access_log` VALUES (51371, '65.49.15626639191670545', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '139.227.253.194', '2019-07-09 17:18:39', 8, 0, '', '2019-07-09 17:18:39');
INSERT INTO `access_log` VALUES (51372, '59.72.15626644461398855', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.145.1.243', '2019-07-09 17:27:26', 12, 0, '', '2019-07-09 17:27:26');
INSERT INTO `access_log` VALUES (51373, '59.77.15626644461408845', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.145.1.243', '2019-07-09 17:27:26', 17, 2001001000, '服务端发生异常', '2019-07-09 17:27:26');
INSERT INTO `access_log` VALUES (51374, '64.80.15626644600479013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.145.1.243', '2019-07-09 17:27:40', 11, 0, '', '2019-07-09 17:27:40');
INSERT INTO `access_log` VALUES (51375, '64.79.15626644601709009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.145.1.243', '2019-07-09 17:27:40', 3, 0, '', '2019-07-09 17:27:40');
INSERT INTO `access_log` VALUES (51376, '64.82.15626644618039023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.145.1.243', '2019-07-09 17:27:42', 2, 0, '', '2019-07-09 17:27:42');
INSERT INTO `access_log` VALUES (51377, '64.77.15626644625908987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.145.1.243', '2019-07-09 17:27:43', 2, 0, '', '2019-07-09 17:27:43');
INSERT INTO `access_log` VALUES (51378, '64.85.15626644633749019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.145.1.243', '2019-07-09 17:27:43', 2, 0, '', '2019-07-09 17:27:43');
INSERT INTO `access_log` VALUES (51379, '64.78.15626644641409013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.145.1.243', '2019-07-09 17:27:44', 2, 0, '', '2019-07-09 17:27:44');
INSERT INTO `access_log` VALUES (51380, '64.84.15626644648079003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.145.1.243', '2019-07-09 17:27:45', 2, 0, '', '2019-07-09 17:27:45');
INSERT INTO `access_log` VALUES (51381, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.145.1.243', '2019-07-09 17:27:45', 6, 0, '', '2019-07-09 17:27:45');
INSERT INTO `access_log` VALUES (51382, '64.83.15626644666789005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.145.1.243', '2019-07-09 17:27:47', 2, 0, '', '2019-07-09 17:27:47');
INSERT INTO `access_log` VALUES (51383, '64.81.15626644668088995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.145.1.243', '2019-07-09 17:27:47', 2, 0, '', '2019-07-09 17:27:47');
INSERT INTO `access_log` VALUES (51384, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=sss&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.145.1.243', '2019-07-09 17:27:50', 6, 0, '', '2019-07-09 17:27:50');
INSERT INTO `access_log` VALUES (51385, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=sss', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.145.1.243', '2019-07-09 17:27:50', 5, 0, '', '2019-07-09 17:27:50');
INSERT INTO `access_log` VALUES (51386, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=sss&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=desc', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.145.1.243', '2019-07-09 17:27:57', 6, 0, '', '2019-07-09 17:27:57');
INSERT INTO `access_log` VALUES (51387, '59.80.15626647633788843', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.157.54.193', '2019-07-09 17:32:43', 4, 0, '', '2019-07-09 17:32:43');
INSERT INTO `access_log` VALUES (51388, '59.71.15626647633848863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.157.54.193', '2019-07-09 17:32:43', 12, 2001001000, '服务端发生异常', '2019-07-09 17:32:43');
INSERT INTO `access_log` VALUES (51389, '59.76.15626647855328855', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.157.54.193', '2019-07-09 17:33:06', 2, 0, '', '2019-07-09 17:33:06');
INSERT INTO `access_log` VALUES (51390, '59.73.15626647855328869', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.157.54.193', '2019-07-09 17:33:06', 11, 2001001000, '服务端发生异常', '2019-07-09 17:33:06');
INSERT INTO `access_log` VALUES (51391, '64.79.15626647873349015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.157.54.193', '2019-07-09 17:33:07', 2, 0, '', '2019-07-09 17:33:07');
INSERT INTO `access_log` VALUES (51392, '64.82.15626647874199029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.157.54.193', '2019-07-09 17:33:07', 1, 0, '', '2019-07-09 17:33:07');
INSERT INTO `access_log` VALUES (51393, '64.77.15626647912048993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.157.54.193', '2019-07-09 17:33:11', 2, 0, '', '2019-07-09 17:33:11');
INSERT INTO `access_log` VALUES (51394, '64.85.15626647912899025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.157.54.193', '2019-07-09 17:33:11', 2, 0, '', '2019-07-09 17:33:11');
INSERT INTO `access_log` VALUES (51395, '59.74.15626647923288869', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.157.54.193', '2019-07-09 17:33:12', 3, 0, '', '2019-07-09 17:33:12');
INSERT INTO `access_log` VALUES (51396, '59.77.15626647923288851', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.157.54.193', '2019-07-09 17:33:12', 12, 2001001000, '服务端发生异常', '2019-07-09 17:33:12');
INSERT INTO `access_log` VALUES (51397, '64.78.15626647940019019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.157.54.193', '2019-07-09 17:33:14', 3, 0, '', '2019-07-09 17:33:14');
INSERT INTO `access_log` VALUES (51398, '64.84.15626647941319009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.157.54.193', '2019-07-09 17:33:14', 2, 0, '', '2019-07-09 17:33:14');
INSERT INTO `access_log` VALUES (51399, '64.83.15626647950389011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.157.54.193', '2019-07-09 17:33:15', 2, 0, '', '2019-07-09 17:33:15');
INSERT INTO `access_log` VALUES (51400, '64.81.15626647955669001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.157.54.193', '2019-07-09 17:33:16', 2, 0, '', '2019-07-09 17:33:16');
INSERT INTO `access_log` VALUES (51401, '65.54.15626649908520523', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.166.122', '2019-07-09 17:36:31', 1, 1002001015, '账号未登陆', '2019-07-09 17:36:31');
INSERT INTO `access_log` VALUES (51402, '65.47.15626649908520547', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.166.122', '2019-07-09 17:36:31', 1, 1002001015, '账号未登陆', '2019-07-09 17:36:31');
INSERT INTO `access_log` VALUES (51403, '65.50.15626649908530591', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.166.122', '2019-07-09 17:36:31', 0, 1002001015, '账号未登陆', '2019-07-09 17:36:31');
INSERT INTO `access_log` VALUES (51404, '65.51.15626649978220625', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.166.122', '2019-07-09 17:36:38', 181, 0, '', '2019-07-09 17:36:38');
INSERT INTO `access_log` VALUES (51405, '65.45.15626649983050551', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.166.122', '2019-07-09 17:36:38', 8, 0, '', '2019-07-09 17:36:38');
INSERT INTO `access_log` VALUES (51406, '65.3607.15626649983082363', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.166.122', '2019-07-09 17:36:38', 10, 2001001000, '服务端发生异常', '2019-07-09 17:36:38');
INSERT INTO `access_log` VALUES (51407, '65.49.15626649983180561', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.166.122', '2019-07-09 17:36:38', 9, 0, '', '2019-07-09 17:36:38');
INSERT INTO `access_log` VALUES (51408, '65.52.15626650004300599', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36 QQBrowser/4.4.108.400', '115.238.229.49', '2019-07-09 17:36:40', 0, 1002001015, '账号未登陆', '2019-07-09 17:36:40');
INSERT INTO `access_log` VALUES (51409, '65.53.15626650004370573', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36 QQBrowser/4.4.108.400', '115.238.229.49', '2019-07-09 17:36:40', 0, 1002001015, '账号未登陆', '2019-07-09 17:36:40');
INSERT INTO `access_log` VALUES (51410, '65.54.15626650004440525', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36 QQBrowser/4.4.108.400', '115.238.229.49', '2019-07-09 17:36:40', 0, 1002001015, '账号未登陆', '2019-07-09 17:36:40');
INSERT INTO `access_log` VALUES (51411, '65.50.15626650044570593', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36 QQBrowser/4.4.108.400', '115.238.229.49', '2019-07-09 17:36:44', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 17:36:44');
INSERT INTO `access_log` VALUES (51412, '65.47.15626650081360549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36 QQBrowser/4.4.108.400', '115.238.229.49', '2019-07-09 17:36:48', 63, 0, '', '2019-07-09 17:36:48');
INSERT INTO `access_log` VALUES (51413, '65.51.15626650084900627', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36 QQBrowser/4.4.108.400', '115.238.229.49', '2019-07-09 17:36:48', 84, 0, '', '2019-07-09 17:36:49');
INSERT INTO `access_log` VALUES (51414, '65.45.15626650084950553', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36 QQBrowser/4.4.108.400', '115.238.229.49', '2019-07-09 17:36:48', 81, 0, '', '2019-07-09 17:36:49');
INSERT INTO `access_log` VALUES (51415, '65.3607.15626650084942365', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36 QQBrowser/4.4.108.400', '115.238.229.49', '2019-07-09 17:36:48', 88, 2001001000, '服务端发生异常', '2019-07-09 17:36:49');
INSERT INTO `access_log` VALUES (51416, '65.46.15626650203660619', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36 QQBrowser/4.4.108.400', '115.238.229.49', '2019-07-09 17:37:00', 9, 0, '', '2019-07-09 17:37:00');
INSERT INTO `access_log` VALUES (51417, '65.52.15626650203690601', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36 QQBrowser/4.4.108.400', '115.238.229.49', '2019-07-09 17:37:00', 9, 2001001000, '服务端发生异常', '2019-07-09 17:37:00');
INSERT INTO `access_log` VALUES (51418, '65.53.15626650203720575', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36 QQBrowser/4.4.108.400', '115.238.229.49', '2019-07-09 17:37:00', 8, 0, '', '2019-07-09 17:37:00');
INSERT INTO `access_log` VALUES (51419, '65.54.15626650235250527', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36 QQBrowser/4.4.108.400', '115.238.229.49', '2019-07-09 17:37:04', 9, 0, '', '2019-07-09 17:37:04');
INSERT INTO `access_log` VALUES (51420, '65.50.15626650235300595', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36 QQBrowser/4.4.108.400', '115.238.229.49', '2019-07-09 17:37:04', 17, 2001001000, '服务端发生异常', '2019-07-09 17:37:04');
INSERT INTO `access_log` VALUES (51421, '65.47.15626650235330551', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36 QQBrowser/4.4.108.400', '115.238.229.49', '2019-07-09 17:37:04', 16, 0, '', '2019-07-09 17:37:04');
INSERT INTO `access_log` VALUES (51422, '59.75.15626662126498893', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:56:53', 3, 0, '', '2019-07-09 17:56:53');
INSERT INTO `access_log` VALUES (51423, '59.76.15626662126508875', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:56:53', 13, 2001001000, '服务端发生异常', '2019-07-09 17:56:53');
INSERT INTO `access_log` VALUES (51424, '64.85.15626662189809045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:56:59', 2, 0, '', '2019-07-09 17:56:59');
INSERT INTO `access_log` VALUES (51425, '64.78.15626662190979039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:56:59', 1, 0, '', '2019-07-09 17:56:59');
INSERT INTO `access_log` VALUES (51426, '64.84.15626662246569029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:57:05', 3, 0, '', '2019-07-09 17:57:05');
INSERT INTO `access_log` VALUES (51427, '64.83.15626662247879031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:57:05', 2, 0, '', '2019-07-09 17:57:05');
INSERT INTO `access_log` VALUES (51428, '59.77.15626662501728871', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:57:30', 2, 0, '', '2019-07-09 17:57:30');
INSERT INTO `access_log` VALUES (51429, '59.72.15626662501748881', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:57:30', 10, 2001001000, '服务端发生异常', '2019-07-09 17:57:30');
INSERT INTO `access_log` VALUES (51430, '64.80.15626662531379041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:57:33', 2, 0, '', '2019-07-09 17:57:33');
INSERT INTO `access_log` VALUES (51431, '64.79.15626662532759037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:57:33', 2, 0, '', '2019-07-09 17:57:33');
INSERT INTO `access_log` VALUES (51432, '64.82.15626662541849051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:57:34', 2, 0, '', '2019-07-09 17:57:34');
INSERT INTO `access_log` VALUES (51433, '64.77.15626662546779015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:57:35', 2, 0, '', '2019-07-09 17:57:35');
INSERT INTO `access_log` VALUES (51434, '66.49.15626662748536921', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18611899696&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:57:55', 16, 1001003000, '验证码不存在', '2019-07-09 17:57:55');
INSERT INTO `access_log` VALUES (51435, '66.57.15626662772046905', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18611899696', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:57:57', 113, 0, '', '2019-07-09 17:57:57');
INSERT INTO `access_log` VALUES (51436, '66.55.15626662791056887', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18611899696&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:57:59', 182, 0, '', '2019-07-09 17:57:59');
INSERT INTO `access_log` VALUES (51437, '64.83.15626662848399033', 163, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:58:05', 7, 0, '', '2019-07-09 17:58:05');
INSERT INTO `access_log` VALUES (51438, '64.76.15626662850249027', 163, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:58:05', 5, 0, '', '2019-07-09 17:58:05');
INSERT INTO `access_log` VALUES (51439, '66.51.15626662858146931', 163, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:58:06', 6, 0, '', '2019-07-09 17:58:06');
INSERT INTO `access_log` VALUES (51440, '59.75.15626662897518895', 163, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:58:10', 10, 0, '', '2019-07-09 17:58:10');
INSERT INTO `access_log` VALUES (51441, '59.73.15626662906848891', 163, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:58:11', 6, 0, '', '2019-07-09 17:58:11');
INSERT INTO `access_log` VALUES (51442, '59.77.15626662911988873', 163, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:58:11', 7, 0, '', '2019-07-09 17:58:11');
INSERT INTO `access_log` VALUES (51443, '66.52.15626662931266899', 163, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:58:13', 5, 0, '', '2019-07-09 17:58:13');
INSERT INTO `access_log` VALUES (51444, '59.71.15626662944808887', 163, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:58:14', 5, 0, '', '2019-07-09 17:58:14');
INSERT INTO `access_log` VALUES (51445, '59.80.15626662944818867', 163, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:58:14', 15, 2001001000, '服务端发生异常', '2019-07-09 17:58:14');
INSERT INTO `access_log` VALUES (51446, '64.83.15626663833759035', 163, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:59:43', 5, 0, '', '2019-07-09 17:59:43');
INSERT INTO `access_log` VALUES (51447, '64.81.15626663834889025', 163, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:59:43', 4, 0, '', '2019-07-09 17:59:43');
INSERT INTO `access_log` VALUES (51448, '59.72.15626663850438885', 163, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:59:45', 6, 0, '', '2019-07-09 17:59:45');
INSERT INTO `access_log` VALUES (51449, '59.79.15626663850848889', 163, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:59:45', 16, 2001001000, '服务端发生异常', '2019-07-09 17:59:45');
INSERT INTO `access_log` VALUES (51450, '64.76.15626663864999029', 163, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:59:47', 5, 0, '', '2019-07-09 17:59:47');
INSERT INTO `access_log` VALUES (51451, '64.80.15626663866629045', 163, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:59:47', 7, 0, '', '2019-07-09 17:59:47');
INSERT INTO `access_log` VALUES (51452, '59.71.15626663882688889', 163, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:59:48', 6, 0, '', '2019-07-09 17:59:48');
INSERT INTO `access_log` VALUES (51453, '59.80.15626663882688869', 163, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:59:48', 15, 2001001000, '服务端发生异常', '2019-07-09 17:59:48');
INSERT INTO `access_log` VALUES (51454, '64.79.15626663898619041', 163, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:59:50', 5, 0, '', '2019-07-09 17:59:50');
INSERT INTO `access_log` VALUES (51455, '64.82.15626663899689055', 163, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:59:50', 5, 0, '', '2019-07-09 17:59:50');
INSERT INTO `access_log` VALUES (51456, '59.76.15626663960598881', 163, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:59:56', 5, 0, '', '2019-07-09 17:59:56');
INSERT INTO `access_log` VALUES (51457, '59.75.15626663960588899', 163, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.69.42.78', '2019-07-09 17:59:56', 16, 2001001000, '服务端发生异常', '2019-07-09 17:59:56');
INSERT INTO `access_log` VALUES (51458, '59.79.15626667618858895', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.25.179.165', '2019-07-09 18:06:02', 3, 0, '', '2019-07-09 18:06:02');
INSERT INTO `access_log` VALUES (51459, '59.71.15626667618878895', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.25.179.165', '2019-07-09 18:06:02', 14, 2001001000, '服务端发生异常', '2019-07-09 18:06:02');
INSERT INTO `access_log` VALUES (51460, '64.80.15626667833159051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPad; CPU OS 11_0 like Mac OS X) AppleWebKit/604.1.34 (KHTML, like Gecko) Version/11.0 Mobile/15A5341f Safari/604.1', '60.25.179.165', '2019-07-09 18:06:23', 3, 0, '', '2019-07-09 18:06:23');
INSERT INTO `access_log` VALUES (51461, '64.79.15626667834369047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPad; CPU OS 11_0 like Mac OS X) AppleWebKit/604.1.34 (KHTML, like Gecko) Version/11.0 Mobile/15A5341f Safari/604.1', '60.25.179.165', '2019-07-09 18:06:23', 2, 0, '', '2019-07-09 18:06:23');
INSERT INTO `access_log` VALUES (51462, '64.82.15626667843309061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPad; CPU OS 11_0 like Mac OS X) AppleWebKit/604.1.34 (KHTML, like Gecko) Version/11.0 Mobile/15A5341f Safari/604.1', '60.25.179.165', '2019-07-09 18:06:24', 2, 0, '', '2019-07-09 18:06:24');
INSERT INTO `access_log` VALUES (51463, '64.77.15626667848819025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPad; CPU OS 11_0 like Mac OS X) AppleWebKit/604.1.34 (KHTML, like Gecko) Version/11.0 Mobile/15A5341f Safari/604.1', '60.25.179.165', '2019-07-09 18:06:25', 2, 0, '', '2019-07-09 18:06:25');
INSERT INTO `access_log` VALUES (51464, '64.85.15626667852339057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPad; CPU OS 11_0 like Mac OS X) AppleWebKit/604.1.34 (KHTML, like Gecko) Version/11.0 Mobile/15A5341f Safari/604.1', '60.25.179.165', '2019-07-09 18:06:25', 2, 0, '', '2019-07-09 18:06:25');
INSERT INTO `access_log` VALUES (51465, '59.75.15626667984958905', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 11_0 like Mac OS X) AppleWebKit/604.1.34 (KHTML, like Gecko) Version/11.0 Mobile/15A5341f Safari/604.1', '60.25.179.165', '2019-07-09 18:06:38', 2, 0, '', '2019-07-09 18:06:38');
INSERT INTO `access_log` VALUES (51466, '59.73.15626667985008901', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 11_0 like Mac OS X) AppleWebKit/604.1.34 (KHTML, like Gecko) Version/11.0 Mobile/15A5341f Safari/604.1', '60.25.179.165', '2019-07-09 18:06:39', 12, 2001001000, '服务端发生异常', '2019-07-09 18:06:39');
INSERT INTO `access_log` VALUES (51467, '59.72.15626669859618895', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-09 18:09:46', 3, 0, '', '2019-07-09 18:09:46');
INSERT INTO `access_log` VALUES (51468, '59.79.15626669859698899', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-09 18:09:46', 19, 2001001000, '服务端发生异常', '2019-07-09 18:09:46');
INSERT INTO `access_log` VALUES (51469, '59.76.15626670195908891', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '182.33.160.82', '2019-07-09 18:10:20', 2, 0, '', '2019-07-09 18:10:20');
INSERT INTO `access_log` VALUES (51470, '59.73.15626670195918905', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '182.33.160.82', '2019-07-09 18:10:20', 20, 2001001000, '服务端发生异常', '2019-07-09 18:10:20');
INSERT INTO `access_log` VALUES (51471, '64.79.15626670238819051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '182.33.160.82', '2019-07-09 18:10:24', 2, 0, '', '2019-07-09 18:10:24');
INSERT INTO `access_log` VALUES (51472, '64.82.15626670239879065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '182.33.160.82', '2019-07-09 18:10:24', 2, 0, '', '2019-07-09 18:10:24');
INSERT INTO `access_log` VALUES (51473, '59.73.15626690957208933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '182.33.160.82', '2019-07-09 18:44:56', 10, 0, '', '2019-07-09 18:44:56');
INSERT INTO `access_log` VALUES (51474, '59.76.15626690957208919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '182.33.160.82', '2019-07-09 18:44:56', 21, 2001001000, '服务端发生异常', '2019-07-09 18:44:56');
INSERT INTO `access_log` VALUES (51475, '65.54.15626700674210595', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-07-09 19:01:07', 1, 1002001015, '账号未登陆', '2019-07-09 19:01:07');
INSERT INTO `access_log` VALUES (51476, '65.53.15626700674200643', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-07-09 19:01:07', 1, 1002001015, '账号未登陆', '2019-07-09 19:01:07');
INSERT INTO `access_log` VALUES (51477, '65.47.15626700674210619', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-07-09 19:01:07', 1, 1002001015, '账号未登陆', '2019-07-09 19:01:07');
INSERT INTO `access_log` VALUES (51478, '65.51.15626700736850697', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-07-09 19:01:14', 86, 0, '', '2019-07-09 19:01:14');
INSERT INTO `access_log` VALUES (51479, '65.45.15626700739920623', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-07-09 19:01:14', 14, 0, '', '2019-07-09 19:01:14');
INSERT INTO `access_log` VALUES (51480, '65.49.15626700739940633', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-07-09 19:01:14', 13, 0, '', '2019-07-09 19:01:14');
INSERT INTO `access_log` VALUES (51481, '65.3607.15626700739922435', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-07-09 19:01:14', 18, 2001001000, '服务端发生异常', '2019-07-09 19:01:14');
INSERT INTO `access_log` VALUES (51482, '65.47.15626718899510645', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-09 19:31:30', 15, 1002001012, '访问令牌已过期', '2019-07-09 19:31:30');
INSERT INTO `access_log` VALUES (51483, '65.52.15626718899510695', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-09 19:31:30', 14, 1002001012, '访问令牌已过期', '2019-07-09 19:31:30');
INSERT INTO `access_log` VALUES (51484, '65.54.15626718899630621', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-09 19:31:30', 9, 1002001012, '访问令牌已过期', '2019-07-09 19:31:30');
INSERT INTO `access_log` VALUES (51485, '65.54.15626720154800623', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-09 19:33:35', 4, 1002001012, '访问令牌已过期', '2019-07-09 19:33:35');
INSERT INTO `access_log` VALUES (51486, '65.52.15626720154930697', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-09 19:33:35', 4, 1002001012, '访问令牌已过期', '2019-07-09 19:33:35');
INSERT INTO `access_log` VALUES (51487, '65.53.15626720154970671', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-09 19:33:35', 3, 1002001012, '访问令牌已过期', '2019-07-09 19:33:36');
INSERT INTO `access_log` VALUES (51488, '65.50.15626720172510691', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-09 19:33:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 19:33:37');
INSERT INTO `access_log` VALUES (51489, '65.3607.15626720200422463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-09 19:33:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 19:33:40');
INSERT INTO `access_log` VALUES (51490, '65.45.15626720406360651', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-09 19:34:01', 101, 0, '', '2019-07-09 19:34:01');
INSERT INTO `access_log` VALUES (51491, '65.46.15626720409770717', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-09 19:34:01', 11, 0, '', '2019-07-09 19:34:01');
INSERT INTO `access_log` VALUES (51492, '65.47.15626720409830649', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-09 19:34:01', 10, 2001001000, '服务端发生异常', '2019-07-09 19:34:01');
INSERT INTO `access_log` VALUES (51493, '65.53.15626720409920673', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-09 19:34:01', 11, 0, '', '2019-07-09 19:34:01');
INSERT INTO `access_log` VALUES (51494, '59.74.15626724047098977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-09 19:40:05', 10, 0, '', '2019-07-09 19:40:05');
INSERT INTO `access_log` VALUES (51495, '59.77.15626724047108959', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.125.153', '2019-07-09 19:40:05', 15, 2001001000, '服务端发生异常', '2019-07-09 19:40:05');
INSERT INTO `access_log` VALUES (51496, '64.82.15626724108219137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-07-09 19:40:11', 10, 0, '', '2019-07-09 19:40:11');
INSERT INTO `access_log` VALUES (51497, '64.77.15626724111659101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-07-09 19:40:11', 2, 0, '', '2019-07-09 19:40:11');
INSERT INTO `access_log` VALUES (51498, '64.85.15626724146159133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-07-09 19:40:15', 2, 0, '', '2019-07-09 19:40:15');
INSERT INTO `access_log` VALUES (51499, '64.78.15626724153769127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-07-09 19:40:15', 2, 0, '', '2019-07-09 19:40:15');
INSERT INTO `access_log` VALUES (51500, '59.79.15626724196108973', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-07-09 19:40:20', 3, 0, '', '2019-07-09 19:40:20');
INSERT INTO `access_log` VALUES (51501, '59.71.15626724196108973', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-07-09 19:40:20', 13, 2001001000, '服务端发生异常', '2019-07-09 19:40:20');
INSERT INTO `access_log` VALUES (51502, '59.73.15626724381008979', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-07-09 19:40:38', 2, 0, '', '2019-07-09 19:40:38');
INSERT INTO `access_log` VALUES (51503, '59.78.15626724381008969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-07-09 19:40:38', 17, 2001001000, '服务端发生异常', '2019-07-09 19:40:38');
INSERT INTO `access_log` VALUES (51504, '59.79.15626725251478975', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-07-09 19:42:05', 3, 0, '', '2019-07-09 19:42:05');
INSERT INTO `access_log` VALUES (51505, '59.80.15626725251498955', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-07-09 19:42:05', 11, 2001001000, '服务端发生异常', '2019-07-09 19:42:05');
INSERT INTO `access_log` VALUES (51506, '64.85.15626725256119135', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-07-09 19:42:06', 2, 0, '', '2019-07-09 19:42:06');
INSERT INTO `access_log` VALUES (51507, '64.78.15626725256869129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-07-09 19:42:06', 2, 0, '', '2019-07-09 19:42:06');
INSERT INTO `access_log` VALUES (51508, '59.78.15626725261918971', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-07-09 19:42:06', 2, 0, '', '2019-07-09 19:42:06');
INSERT INTO `access_log` VALUES (51509, '59.73.15626725261928981', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '122.224.125.153', '2019-07-09 19:42:06', 13, 2001001000, '服务端发生异常', '2019-07-09 19:42:06');
INSERT INTO `access_log` VALUES (51510, '59.79.15626748664809007', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:06', 14, 0, '', '2019-07-09 20:21:06');
INSERT INTO `access_log` VALUES (51511, '59.80.15626748664808987', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:06', 19, 2001001000, '服务端发生异常', '2019-07-09 20:21:07');
INSERT INTO `access_log` VALUES (51512, '64.82.15626748719209171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:12', 11, 0, '', '2019-07-09 20:21:12');
INSERT INTO `access_log` VALUES (51513, '64.77.15626748720989135', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:12', 3, 0, '', '2019-07-09 20:21:12');
INSERT INTO `access_log` VALUES (51514, '59.78.15626748761339003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:16', 3, 0, '', '2019-07-09 20:21:16');
INSERT INTO `access_log` VALUES (51515, '59.73.15626748761339013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:16', 12, 2001001000, '服务端发生异常', '2019-07-09 20:21:16');
INSERT INTO `access_log` VALUES (51516, '64.85.15626748780619167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:18', 2, 0, '', '2019-07-09 20:21:18');
INSERT INTO `access_log` VALUES (51517, '64.78.15626748781909161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:18', 1, 0, '', '2019-07-09 20:21:18');
INSERT INTO `access_log` VALUES (51518, '59.75.15626748797499017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:20', 2, 0, '', '2019-07-09 20:21:20');
INSERT INTO `access_log` VALUES (51519, '59.74.15626748797499013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:20', 18, 2001001000, '服务端发生异常', '2019-07-09 20:21:20');
INSERT INTO `access_log` VALUES (51520, '64.83.15626748814409153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:21', 1, 0, '', '2019-07-09 20:21:21');
INSERT INTO `access_log` VALUES (51521, '64.81.15626748815689143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:22', 1, 0, '', '2019-07-09 20:21:22');
INSERT INTO `access_log` VALUES (51522, '59.77.15626748832178995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:23', 2, 0, '', '2019-07-09 20:21:23');
INSERT INTO `access_log` VALUES (51523, '59.72.15626748832179005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:23', 12, 2001001000, '服务端发生异常', '2019-07-09 20:21:23');
INSERT INTO `access_log` VALUES (51524, '59.71.15626748905739009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:31', 2, 0, '', '2019-07-09 20:21:31');
INSERT INTO `access_log` VALUES (51525, '59.79.15626748905739009', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:21:31', 11, 2001001000, '服务端发生异常', '2019-07-09 20:21:31');
INSERT INTO `access_log` VALUES (51526, '64.76.15626750351369149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:23:55', 2, 0, '', '2019-07-09 20:23:55');
INSERT INTO `access_log` VALUES (51527, '64.80.15626750352629165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:23:55', 1, 0, '', '2019-07-09 20:23:55');
INSERT INTO `access_log` VALUES (51528, '59.80.15626750390968991', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:23:59', 3, 0, '', '2019-07-09 20:23:59');
INSERT INTO `access_log` VALUES (51529, '59.73.15626750391329017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:23:59', 12, 2001001000, '服务端发生异常', '2019-07-09 20:23:59');
INSERT INTO `access_log` VALUES (51530, '59.72.15626750967739009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:24:57', 3, 0, '', '2019-07-09 20:24:57');
INSERT INTO `access_log` VALUES (51531, '59.77.15626750967738999', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:24:57', 13, 2001001000, '服务端发生异常', '2019-07-09 20:24:57');
INSERT INTO `access_log` VALUES (51532, '66.51.15626751160467049', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15820459220', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:16', 214, 0, '', '2019-07-09 20:25:16');
INSERT INTO `access_log` VALUES (51533, '66.48.15626751210397037', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15820459220&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:21', 171, 0, '', '2019-07-09 20:25:21');
INSERT INTO `access_log` VALUES (51534, '66.50.15626751224927021', 147, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:22', 6, 0, '', '2019-07-09 20:25:22');
INSERT INTO `access_log` VALUES (51535, '59.76.15626751255439005', 147, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:26', 5, 0, '', '2019-07-09 20:25:26');
INSERT INTO `access_log` VALUES (51536, '59.78.15626751255439009', 147, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:26', 15, 2001001000, '服务端发生异常', '2019-07-09 20:25:26');
INSERT INTO `access_log` VALUES (51537, '64.81.15626751274179147', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:27', 6, 0, '', '2019-07-09 20:25:27');
INSERT INTO `access_log` VALUES (51538, '64.80.15626751276029167', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:28', 5, 0, '', '2019-07-09 20:25:28');
INSERT INTO `access_log` VALUES (51539, '59.75.15626751289009023', 147, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:29', 7, 0, '', '2019-07-09 20:25:29');
INSERT INTO `access_log` VALUES (51540, '59.74.15626751289009019', 147, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:29', 16, 2001001000, '服务端发生异常', '2019-07-09 20:25:29');
INSERT INTO `access_log` VALUES (51541, '59.71.15626751347199015', 147, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:35', 5, 0, '', '2019-07-09 20:25:35');
INSERT INTO `access_log` VALUES (51542, '59.72.15626751347199011', 147, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:35', 13, 2001001000, '服务端发生异常', '2019-07-09 20:25:35');
INSERT INTO `access_log` VALUES (51543, '64.77.15626751563609141', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:56', 5, 0, '', '2019-07-09 20:25:56');
INSERT INTO `access_log` VALUES (51544, '64.85.15626751564699173', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:56', 4, 0, '', '2019-07-09 20:25:56');
INSERT INTO `access_log` VALUES (51545, '64.84.15626751574349157', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:57', 5, 0, '', '2019-07-09 20:25:57');
INSERT INTO `access_log` VALUES (51546, '64.81.15626751581299149', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:58', 5, 0, '', '2019-07-09 20:25:58');
INSERT INTO `access_log` VALUES (51547, '64.76.15626751593449153', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:25:59', 5, 0, '', '2019-07-09 20:25:59');
INSERT INTO `access_log` VALUES (51548, '64.80.15626751596589169', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:00', 5, 0, '', '2019-07-09 20:26:00');
INSERT INTO `access_log` VALUES (51549, '64.79.15626751600109165', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:00', 5, 0, '', '2019-07-09 20:26:00');
INSERT INTO `access_log` VALUES (51550, '64.82.15626751603919179', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:00', 4, 0, '', '2019-07-09 20:26:00');
INSERT INTO `access_log` VALUES (51551, '64.77.15626751607069143', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:01', 5, 0, '', '2019-07-09 20:26:01');
INSERT INTO `access_log` VALUES (51552, '64.85.15626751609789175', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:01', 5, 0, '', '2019-07-09 20:26:01');
INSERT INTO `access_log` VALUES (51553, '64.78.15626751612679169', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:01', 5, 0, '', '2019-07-09 20:26:01');
INSERT INTO `access_log` VALUES (51554, '64.84.15626751615419159', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:02', 5, 0, '', '2019-07-09 20:26:02');
INSERT INTO `access_log` VALUES (51555, '64.83.15626751618649161', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:02', 5, 0, '', '2019-07-09 20:26:02');
INSERT INTO `access_log` VALUES (51556, '64.81.15626751621459151', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:02', 4, 0, '', '2019-07-09 20:26:02');
INSERT INTO `access_log` VALUES (51557, '64.76.15626751624369155', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:02', 5, 0, '', '2019-07-09 20:26:02');
INSERT INTO `access_log` VALUES (51558, '64.80.15626751628349171', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:03', 5, 0, '', '2019-07-09 20:26:03');
INSERT INTO `access_log` VALUES (51559, '64.79.15626751631229167', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:03', 4, 0, '', '2019-07-09 20:26:03');
INSERT INTO `access_log` VALUES (51560, '64.82.15626751634239181', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:03', 5, 0, '', '2019-07-09 20:26:03');
INSERT INTO `access_log` VALUES (51561, '64.77.15626751636909145', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:04', 5, 0, '', '2019-07-09 20:26:04');
INSERT INTO `access_log` VALUES (51562, '64.85.15626751639659177', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:04', 5, 0, '', '2019-07-09 20:26:04');
INSERT INTO `access_log` VALUES (51563, '64.78.15626751642459171', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:04', 4, 0, '', '2019-07-09 20:26:04');
INSERT INTO `access_log` VALUES (51564, '64.83.15626751655139163', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:06', 6, 0, '', '2019-07-09 20:26:06');
INSERT INTO `access_log` VALUES (51565, '64.81.15626751658529153', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:06', 5, 0, '', '2019-07-09 20:26:06');
INSERT INTO `access_log` VALUES (51566, '64.76.15626751662799157', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:06', 5, 0, '', '2019-07-09 20:26:06');
INSERT INTO `access_log` VALUES (51567, '64.80.15626751665439173', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:07', 4, 0, '', '2019-07-09 20:26:07');
INSERT INTO `access_log` VALUES (51568, '64.79.15626751668339169', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:07', 5, 0, '', '2019-07-09 20:26:07');
INSERT INTO `access_log` VALUES (51569, '64.82.15626751671169183', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:07', 4, 0, '', '2019-07-09 20:26:07');
INSERT INTO `access_log` VALUES (51570, '64.77.15626751674029147', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:07', 5, 0, '', '2019-07-09 20:26:07');
INSERT INTO `access_log` VALUES (51571, '64.85.15626751676239179', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:08', 5, 0, '', '2019-07-09 20:26:08');
INSERT INTO `access_log` VALUES (51572, '64.83.15626751975439165', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:38', 5, 0, '', '2019-07-09 20:26:38');
INSERT INTO `access_log` VALUES (51573, '64.81.15626751982009155', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:38', 5, 0, '', '2019-07-09 20:26:38');
INSERT INTO `access_log` VALUES (51574, '64.76.15626751987529159', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:39', 5, 0, '', '2019-07-09 20:26:39');
INSERT INTO `access_log` VALUES (51575, '64.80.15626751993149175', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:39', 5, 0, '', '2019-07-09 20:26:39');
INSERT INTO `access_log` VALUES (51576, '64.79.15626751996319171', 147, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:40', 4, 0, '', '2019-07-09 20:26:40');
INSERT INTO `access_log` VALUES (51577, '65.46.15626752091690761', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:49', 3, 1002001012, '访问令牌已过期', '2019-07-09 20:26:49');
INSERT INTO `access_log` VALUES (51578, '65.53.15626752091690715', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:49', 4, 1002001012, '访问令牌已过期', '2019-07-09 20:26:49');
INSERT INTO `access_log` VALUES (51579, '65.54.15626752091810669', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:49', 11, 1002001012, '访问令牌已过期', '2019-07-09 20:26:49');
INSERT INTO `access_log` VALUES (51580, '65.52.15626752107160741', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:26:51', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 20:26:51');
INSERT INTO `access_log` VALUES (51581, '65.51.15626752256300771', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:27:06', 95, 0, '', '2019-07-09 20:27:06');
INSERT INTO `access_log` VALUES (51582, '65.49.15626752259940707', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:27:06', 35, 0, '', '2019-07-09 20:27:06');
INSERT INTO `access_log` VALUES (51583, '65.47.15626752259990693', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:27:06', 31, 0, '', '2019-07-09 20:27:06');
INSERT INTO `access_log` VALUES (51584, '65.3607.15626752259912509', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:27:06', 39, 0, '', '2019-07-09 20:27:06');
INSERT INTO `access_log` VALUES (51585, '64.78.15626752307869175', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:27:11', 9, 0, '', '2019-07-09 20:27:11');
INSERT INTO `access_log` VALUES (51586, '64.85.15626752307769181', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:27:11', 21, 0, '', '2019-07-09 20:27:11');
INSERT INTO `access_log` VALUES (51587, '64.83.15626752367549167', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:27:17', 15, 0, '', '2019-07-09 20:27:17');
INSERT INTO `access_log` VALUES (51588, '64.84.15626752367529165', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:27:17', 23, 0, '', '2019-07-09 20:27:17');
INSERT INTO `access_log` VALUES (51589, '64.78.15626753133939177', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:28:33', 12, 0, '', '2019-07-09 20:28:33');
INSERT INTO `access_log` VALUES (51590, '64.77.15626753133939151', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:28:33', 14, 0, '', '2019-07-09 20:28:33');
INSERT INTO `access_log` VALUES (51591, '65.49.15626753309750709', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:28:51', 4, 0, '', '2019-07-09 20:28:51');
INSERT INTO `access_log` VALUES (51592, '65.3607.15626753413272511', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:29:01', 3, 0, '', '2019-07-09 20:29:01');
INSERT INTO `access_log` VALUES (51593, '64.76.15626753704699163', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=测试&sellPoint=测试&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/1b4195db-93b9-4f8d-b8bb-3a88df28459d&skuStr=[{\"attrs\":[3],\"price\":21213300,\"quantity\":23123}]&description=<p>21121212121</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:29:30', 322, 2001001000, '服务端发生异常', '2019-07-09 20:29:31');
INSERT INTO `access_log` VALUES (51594, '64.79.15626753802749175', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=测试&sellPoint=测试&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/1b4195db-93b9-4f8d-b8bb-3a88df28459d&skuStr=[{\"attrs\":[3],\"price\":21213300,\"quantity\":23123}]&description=<p>21121212121</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:29:40', 283, 2001001000, '服务端发生异常', '2019-07-09 20:29:41');
INSERT INTO `access_log` VALUES (51595, '65.47.15626754542000697', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:30:54', 4, 0, '', '2019-07-09 20:30:54');
INSERT INTO `access_log` VALUES (51596, '64.77.15626755467139155', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=测试&sellPoint=测试&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/124519dc-5b11-4bf1-96e3-ac29d18a603b&skuStr=[{\"attrs\":[3],\"price\":21213300,\"quantity\":23123}]&description=<p>21121212121</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:32:27', 547, 2001001000, '服务端发生异常', '2019-07-09 20:32:27');
INSERT INTO `access_log` VALUES (51597, '65.54.15626757840040679', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.25.162', '2019-07-09 20:36:24', 1, 1002001015, '账号未登陆', '2019-07-09 20:36:24');
INSERT INTO `access_log` VALUES (51598, '65.46.15626757840060771', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.25.162', '2019-07-09 20:36:24', 0, 1002001015, '账号未登陆', '2019-07-09 20:36:24');
INSERT INTO `access_log` VALUES (51599, '65.53.15626757840110725', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.25.162', '2019-07-09 20:36:24', 0, 1002001015, '账号未登陆', '2019-07-09 20:36:24');
INSERT INTO `access_log` VALUES (51600, '65.52.15626757869260751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.25.162', '2019-07-09 20:36:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 20:36:27');
INSERT INTO `access_log` VALUES (51601, '65.51.15626757995530781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.25.162', '2019-07-09 20:36:40', 101, 0, '', '2019-07-09 20:36:40');
INSERT INTO `access_log` VALUES (51602, '65.49.15626757999410717', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.25.162', '2019-07-09 20:36:40', 9, 0, '', '2019-07-09 20:36:40');
INSERT INTO `access_log` VALUES (51603, '65.47.15626757999450703', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.25.162', '2019-07-09 20:36:40', 10, 2001001000, '服务端发生异常', '2019-07-09 20:36:40');
INSERT INTO `access_log` VALUES (51604, '65.3607.15626757999482519', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.25.162', '2019-07-09 20:36:40', 10, 0, '', '2019-07-09 20:36:40');
INSERT INTO `access_log` VALUES (51605, '59.77.15626758322059011', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.25.162', '2019-07-09 20:37:12', 4, 0, '', '2019-07-09 20:37:12');
INSERT INTO `access_log` VALUES (51606, '59.74.15626758322049029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.25.162', '2019-07-09 20:37:12', 13, 2001001000, '服务端发生异常', '2019-07-09 20:37:12');
INSERT INTO `access_log` VALUES (51607, '65.54.15626758371850681', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.229.59', '2019-07-09 20:37:17', 0, 1002001015, '账号未登陆', '2019-07-09 20:37:17');
INSERT INTO `access_log` VALUES (51608, '65.53.15626758373660727', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.229.59', '2019-07-09 20:37:17', 0, 1002001015, '账号未登陆', '2019-07-09 20:37:17');
INSERT INTO `access_log` VALUES (51609, '65.52.15626758373660753', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.229.59', '2019-07-09 20:37:17', 0, 1002001015, '账号未登陆', '2019-07-09 20:37:17');
INSERT INTO `access_log` VALUES (51610, '65.50.15626758418020747', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.229.59', '2019-07-09 20:37:22', 60, 0, '', '2019-07-09 20:37:22');
INSERT INTO `access_log` VALUES (51611, '65.51.15626758420950783', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.229.59', '2019-07-09 20:37:22', 9, 0, '', '2019-07-09 20:37:22');
INSERT INTO `access_log` VALUES (51612, '65.49.15626758421010719', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.229.59', '2019-07-09 20:37:22', 9, 0, '', '2019-07-09 20:37:22');
INSERT INTO `access_log` VALUES (51613, '65.47.15626758420990705', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.229.59', '2019-07-09 20:37:22', 10, 2001001000, '服务端发生异常', '2019-07-09 20:37:22');
INSERT INTO `access_log` VALUES (51614, '59.71.15626758436909025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:37:24', 2, 0, '', '2019-07-09 20:37:24');
INSERT INTO `access_log` VALUES (51615, '59.79.15626758436909025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:37:24', 12, 2001001000, '服务端发生异常', '2019-07-09 20:37:24');
INSERT INTO `access_log` VALUES (51616, '65.45.15626758454980709', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.25.162', '2019-07-09 20:37:25', 18, 0, '', '2019-07-09 20:37:26');
INSERT INTO `access_log` VALUES (51617, '65.46.15626758455020775', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.25.162', '2019-07-09 20:37:26', 18, 2001001000, '服务端发生异常', '2019-07-09 20:37:26');
INSERT INTO `access_log` VALUES (51618, '65.54.15626758455150683', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.25.162', '2019-07-09 20:37:26', 8, 0, '', '2019-07-09 20:37:26');
INSERT INTO `access_log` VALUES (51619, '59.77.15626760782419015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '211.140.94.10', '2019-07-09 20:41:18', 5, 0, '', '2019-07-09 20:41:18');
INSERT INTO `access_log` VALUES (51620, '59.74.15626760782779033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '211.140.94.10', '2019-07-09 20:41:18', 15, 2001001000, '服务端发生异常', '2019-07-09 20:41:18');
INSERT INTO `access_log` VALUES (51621, '65.3607.15626760880222525', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.88', '2019-07-09 20:41:28', 1, 1002001015, '账号未登陆', '2019-07-09 20:41:28');
INSERT INTO `access_log` VALUES (51622, '65.46.15626760880260779', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.88', '2019-07-09 20:41:28', 0, 1002001015, '账号未登陆', '2019-07-09 20:41:28');
INSERT INTO `access_log` VALUES (51623, '65.45.15626760880270713', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.131.110.88', '2019-07-09 20:41:28', 0, 1002001015, '账号未登陆', '2019-07-09 20:41:28');
INSERT INTO `access_log` VALUES (51624, '65.54.15626760901620687', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '211.140.94.10', '2019-07-09 20:41:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 20:41:30');
INSERT INTO `access_log` VALUES (51625, '65.53.15626760938730733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '211.140.94.10', '2019-07-09 20:41:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 20:41:34');
INSERT INTO `access_log` VALUES (51626, '65.45.15626762938620717', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:44:54', 0, 1002001015, '账号未登陆', '2019-07-09 20:44:54');
INSERT INTO `access_log` VALUES (51627, '65.54.15626762938880691', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:44:54', 0, 1002001015, '账号未登陆', '2019-07-09 20:44:54');
INSERT INTO `access_log` VALUES (51628, '65.53.15626762939000737', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:44:54', 1, 1002001015, '账号未登陆', '2019-07-09 20:44:54');
INSERT INTO `access_log` VALUES (51629, '65.49.15626763154440727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:45:15', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 20:45:15');
INSERT INTO `access_log` VALUES (51630, '59.78.15626763169719027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:45:17', 3, 0, '', '2019-07-09 20:45:17');
INSERT INTO `access_log` VALUES (51631, '59.75.15626763169719041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:45:17', 14, 2001001000, '服务端发生异常', '2019-07-09 20:45:17');
INSERT INTO `access_log` VALUES (51632, '65.3607.15626763449072531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:45:45', 73, 0, '', '2019-07-09 20:45:45');
INSERT INTO `access_log` VALUES (51633, '65.47.15626763454180715', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:45:45', 9, 0, '', '2019-07-09 20:45:45');
INSERT INTO `access_log` VALUES (51634, '65.45.15626763454220719', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:45:45', 11, 2001001000, '服务端发生异常', '2019-07-09 20:45:45');
INSERT INTO `access_log` VALUES (51635, '65.52.15626763454280765', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:45:45', 8, 0, '', '2019-07-09 20:45:45');
INSERT INTO `access_log` VALUES (51636, '65.53.15626763516690739', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:45:52', 8, 0, '', '2019-07-09 20:45:52');
INSERT INTO `access_log` VALUES (51637, '65.54.15626763516740693', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:45:52', 9, 2001001000, '服务端发生异常', '2019-07-09 20:45:52');
INSERT INTO `access_log` VALUES (51638, '65.50.15626763516780757', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:45:52', 9, 0, '', '2019-07-09 20:45:52');
INSERT INTO `access_log` VALUES (51639, '64.77.15626763783399165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:46:18', 3, 0, '', '2019-07-09 20:46:18');
INSERT INTO `access_log` VALUES (51640, '64.78.15626763784909193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:46:18', 1, 0, '', '2019-07-09 20:46:18');
INSERT INTO `access_log` VALUES (51641, '64.85.15626763804659199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:46:20', 1, 0, '', '2019-07-09 20:46:20');
INSERT INTO `access_log` VALUES (51642, '64.84.15626763813919183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:46:21', 2, 0, '', '2019-07-09 20:46:21');
INSERT INTO `access_log` VALUES (51643, '64.81.15626763910219175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.88.246.130', '2019-07-09 20:46:31', 2, 0, '', '2019-07-09 20:46:31');
INSERT INTO `access_log` VALUES (51644, '64.76.15626763919639179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.88.246.130', '2019-07-09 20:46:32', 2, 0, '', '2019-07-09 20:46:32');
INSERT INTO `access_log` VALUES (51645, '64.80.15626763925969195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.88.246.130', '2019-07-09 20:46:33', 2, 0, '', '2019-07-09 20:46:33');
INSERT INTO `access_log` VALUES (51646, '64.79.15626763935599191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.88.246.130', '2019-07-09 20:46:34', 1, 0, '', '2019-07-09 20:46:34');
INSERT INTO `access_log` VALUES (51647, '64.82.15626763942769203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.88.246.130', '2019-07-09 20:46:34', 2, 0, '', '2019-07-09 20:46:34');
INSERT INTO `access_log` VALUES (51648, '64.77.15626763948019167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '101.88.246.130', '2019-07-09 20:46:35', 2, 0, '', '2019-07-09 20:46:35');
INSERT INTO `access_log` VALUES (51649, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=kafka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:48:46', 13, 0, '', '2019-07-09 20:48:47');
INSERT INTO `access_log` VALUES (51650, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kafka', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:48:47', 13, 0, '', '2019-07-09 20:48:47');
INSERT INTO `access_log` VALUES (51651, '64.77.15626765290719169', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:48:49', 7, 0, '', '2019-07-09 20:48:49');
INSERT INTO `access_log` VALUES (51652, '66.49.15626765573007061', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13501831986', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:49:17', 88, 0, '', '2019-07-09 20:49:17');
INSERT INTO `access_log` VALUES (51653, '66.48.15626765614597057', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13501831986&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:49:21', 176, 0, '', '2019-07-09 20:49:22');
INSERT INTO `access_log` VALUES (51654, '66.53.15626765630757051', 164, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:49:23', 6, 0, '', '2019-07-09 20:49:23');
INSERT INTO `access_log` VALUES (51655, '66.54.15626765909247051', 164, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:49:51', 140, 0, '', '2019-07-09 20:49:51');
INSERT INTO `access_log` VALUES (51656, '66.48.15626766293687059', 164, 1, 'user-application', '/user-api/users/address/add', 'name=c&tel=13501831986&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail= 测试路129号&isDefault=false&address= 测试路129号&areaNo=110101&mobile=13501831986&hasDefault=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:50:29', 85, 2001001000, '服务端发生异常', '2019-07-09 20:50:29');
INSERT INTO `access_log` VALUES (51657, '66.53.15626766334687053', 164, 1, 'user-application', '/user-api/users/address/add', 'name=c&tel=13501831986&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail= 测试路129号&isDefault=true&address= 测试路129号&areaNo=110101&mobile=13501831986&hasDefault=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:50:33', 73, 2001001000, '服务端发生异常', '2019-07-09 20:50:34');
INSERT INTO `access_log` VALUES (51658, '66.52.15626766405317039', 164, 1, 'user-application', '/user-api/users/address/add', 'name=测试&tel=13501831986&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail= 测试路129号&isDefault=true&address= 测试路129号&areaNo=110101&mobile=13501831986&hasDefault=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:50:41', 93, 2001001000, '服务端发生异常', '2019-07-09 20:50:41');
INSERT INTO `access_log` VALUES (51659, '65.47.15626779127990737', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.108.108.207', '2019-07-09 21:11:53', 1, 1002001015, '账号未登陆', '2019-07-09 21:11:53');
INSERT INTO `access_log` VALUES (51660, '65.45.15626779128000741', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.108.108.207', '2019-07-09 21:11:53', 1, 1002001015, '账号未登陆', '2019-07-09 21:11:53');
INSERT INTO `access_log` VALUES (51661, '65.52.15626779128020787', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.108.108.207', '2019-07-09 21:11:53', 1, 1002001015, '账号未登陆', '2019-07-09 21:11:53');
INSERT INTO `access_log` VALUES (51662, '65.54.15626779156550715', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.108.108.207', '2019-07-09 21:11:56', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 21:11:56');
INSERT INTO `access_log` VALUES (51663, '65.53.15626779208790761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.108.108.207', '2019-07-09 21:12:01', 287, 0, '', '2019-07-09 21:12:01');
INSERT INTO `access_log` VALUES (51664, '65.49.15626779215260751', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.108.108.207', '2019-07-09 21:12:02', 10, 0, '', '2019-07-09 21:12:02');
INSERT INTO `access_log` VALUES (51665, '65.51.15626779215340817', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.108.108.207', '2019-07-09 21:12:02', 9, 2001001000, '服务端发生异常', '2019-07-09 21:12:02');
INSERT INTO `access_log` VALUES (51666, '65.46.15626779215350809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.108.108.207', '2019-07-09 21:12:02', 8, 0, '', '2019-07-09 21:12:02');
INSERT INTO `access_log` VALUES (51667, '65.3607.15626803139712587', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.37.239.65', '2019-07-09 21:51:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 21:51:54');
INSERT INTO `access_log` VALUES (51668, '59.75.15626806393289099', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 SE Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.5.1', '117.136.12.93', '2019-07-09 21:57:19', 17, 0, '', '2019-07-09 21:57:19');
INSERT INTO `access_log` VALUES (51669, '59.77.15626806393439077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 SE Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.5.1', '117.136.12.93', '2019-07-09 21:57:19', 13, 2001001000, '服务端发生异常', '2019-07-09 21:57:19');
INSERT INTO `access_log` VALUES (51670, '64.76.15626806420529237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 SE Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.5.1', '117.136.12.93', '2019-07-09 21:57:22', 9, 0, '', '2019-07-09 21:57:22');
INSERT INTO `access_log` VALUES (51671, '64.80.15626806422219253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 SE Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.5.1', '117.136.12.93', '2019-07-09 21:57:22', 3, 0, '', '2019-07-09 21:57:22');
INSERT INTO `access_log` VALUES (51672, '59.74.15626806462519095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 SE Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.5.1', '117.136.12.93', '2019-07-09 21:57:26', 3, 0, '', '2019-07-09 21:57:26');
INSERT INTO `access_log` VALUES (51673, '59.72.15626806462529087', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 SE Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.5.1', '117.136.12.93', '2019-07-09 21:57:26', 13, 2001001000, '服务端发生异常', '2019-07-09 21:57:26');
INSERT INTO `access_log` VALUES (51674, '64.79.15626806530709249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 SE Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.5.1', '117.136.12.93', '2019-07-09 21:57:33', 2, 0, '', '2019-07-09 21:57:33');
INSERT INTO `access_log` VALUES (51675, '64.82.15626806532939261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 SE Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.5.1', '117.136.12.93', '2019-07-09 21:57:33', 2, 0, '', '2019-07-09 21:57:33');
INSERT INTO `access_log` VALUES (51676, '64.77.15626806549439225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 SE Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.5.1', '117.136.12.93', '2019-07-09 21:57:35', 2, 0, '', '2019-07-09 21:57:35');
INSERT INTO `access_log` VALUES (51677, '64.83.15626806555709245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 SE Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.5.1', '117.136.12.93', '2019-07-09 21:57:36', 2, 0, '', '2019-07-09 21:57:36');
INSERT INTO `access_log` VALUES (51678, '64.85.15626806647559259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 SE Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.5.1', '117.136.12.93', '2019-07-09 21:57:45', 2, 0, '', '2019-07-09 21:57:45');
INSERT INTO `access_log` VALUES (51679, '64.84.15626806649489243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 SE Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.5.1', '117.136.12.93', '2019-07-09 21:57:45', 2, 0, '', '2019-07-09 21:57:45');
INSERT INTO `access_log` VALUES (51680, '59.79.15626806661309091', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 SE Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.5.1', '117.136.12.93', '2019-07-09 21:57:46', 10, 2001001000, '服务端发生异常', '2019-07-09 21:57:46');
INSERT INTO `access_log` VALUES (51681, '59.80.15626806661769071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 SE Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.5.1', '117.136.12.93', '2019-07-09 21:57:46', 2, 0, '', '2019-07-09 21:57:46');
INSERT INTO `access_log` VALUES (51682, '65.54.15626835145960791', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3341.400', '111.197.241.226', '2019-07-09 22:45:15', 0, 1002001015, '账号未登陆', '2019-07-09 22:45:15');
INSERT INTO `access_log` VALUES (51683, '65.50.15626835145960855', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3341.400', '111.197.241.226', '2019-07-09 22:45:15', 0, 1002001015, '账号未登陆', '2019-07-09 22:45:15');
INSERT INTO `access_log` VALUES (51684, '65.53.15626835146180837', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3341.400', '111.197.241.226', '2019-07-09 22:45:15', 0, 1002001015, '账号未登陆', '2019-07-09 22:45:15');
INSERT INTO `access_log` VALUES (51685, '65.46.15626835490060885', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3341.400', '111.197.241.226', '2019-07-09 22:45:49', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 22:45:49');
INSERT INTO `access_log` VALUES (51686, '65.52.15626835624780865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3341.400', '111.197.241.226', '2019-07-09 22:46:02', 76, 0, '', '2019-07-09 22:46:03');
INSERT INTO `access_log` VALUES (51687, '65.45.15626835629150819', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3341.400', '111.197.241.226', '2019-07-09 22:46:03', 11, 0, '', '2019-07-09 22:46:03');
INSERT INTO `access_log` VALUES (51688, '65.47.15626835629150815', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3341.400', '111.197.241.226', '2019-07-09 22:46:03', 13, 2001001000, '服务端发生异常', '2019-07-09 22:46:03');
INSERT INTO `access_log` VALUES (51689, '65.54.15626835629490793', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3341.400', '111.197.241.226', '2019-07-09 22:46:03', 10, 0, '', '2019-07-09 22:46:03');
INSERT INTO `access_log` VALUES (51690, '65.50.15626835744450857', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3341.400', '111.197.241.226', '2019-07-09 22:46:14', 13, 0, '', '2019-07-09 22:46:14');
INSERT INTO `access_log` VALUES (51691, '65.49.15626835744550829', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3341.400', '111.197.241.226', '2019-07-09 22:46:14', 10, 2001001000, '服务端发生异常', '2019-07-09 22:46:14');
INSERT INTO `access_log` VALUES (51692, '65.51.15626835744560895', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3341.400', '111.197.241.226', '2019-07-09 22:46:14', 8, 0, '', '2019-07-09 22:46:14');
INSERT INTO `access_log` VALUES (51693, '65.51.15626838589880899', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:50:59', 1, 1002001015, '账号未登陆', '2019-07-09 22:50:59');
INSERT INTO `access_log` VALUES (51694, '65.46.15626838590270891', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:50:59', 0, 1002001015, '账号未登陆', '2019-07-09 22:50:59');
INSERT INTO `access_log` VALUES (51695, '65.3607.15626838590502637', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:50:59', 0, 1002001015, '账号未登陆', '2019-07-09 22:50:59');
INSERT INTO `access_log` VALUES (51696, '65.52.15626838612610871', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:51:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 22:51:01');
INSERT INTO `access_log` VALUES (51697, '65.45.15626838857210825', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:51:26', 76, 0, '', '2019-07-09 22:51:26');
INSERT INTO `access_log` VALUES (51698, '65.53.15626838861260845', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:51:26', 9, 0, '', '2019-07-09 22:51:26');
INSERT INTO `access_log` VALUES (51699, '65.50.15626838861310863', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:51:26', 9, 2001001000, '服务端发生异常', '2019-07-09 22:51:26');
INSERT INTO `access_log` VALUES (51700, '65.49.15626838861790835', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:51:26', 10, 0, '', '2019-07-09 22:51:26');
INSERT INTO `access_log` VALUES (51701, '59.79.15626840777279137', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:54:38', 10, 0, '', '2019-07-09 22:54:38');
INSERT INTO `access_log` VALUES (51702, '59.80.15626840777279117', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:54:38', 15, 2001001000, '服务端发生异常', '2019-07-09 22:54:38');
INSERT INTO `access_log` VALUES (51703, '59.73.15626840877849143', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:54:48', 3, 0, '', '2019-07-09 22:54:48');
INSERT INTO `access_log` VALUES (51704, '59.76.15626840877989129', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:54:48', 12, 2001001000, '服务端发生异常', '2019-07-09 22:54:48');
INSERT INTO `access_log` VALUES (51705, '65.47.15626841085540825', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:55:09', 10, 0, '', '2019-07-09 22:55:09');
INSERT INTO `access_log` VALUES (51706, '65.54.15626841085560803', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:55:09', 10, 2001001000, '服务端发生异常', '2019-07-09 22:55:09');
INSERT INTO `access_log` VALUES (51707, '65.45.15626841085630829', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '106.45.167.27', '2019-07-09 22:55:09', 9, 0, '', '2019-07-09 22:55:09');
INSERT INTO `access_log` VALUES (51708, '59.72.15626850425129147', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.136.79.250', '2019-07-09 23:10:43', 3, 0, '', '2019-07-09 23:10:43');
INSERT INTO `access_log` VALUES (51709, '59.71.15626850425139151', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.136.79.250', '2019-07-09 23:10:43', 17, 2001001000, '服务端发生异常', '2019-07-09 23:10:43');
INSERT INTO `access_log` VALUES (51710, '59.74.15626863516579173', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:32:32', 3, 0, '', '2019-07-09 23:32:32');
INSERT INTO `access_log` VALUES (51711, '59.71.15626863516589169', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:32:32', 13, 2001001000, '服务端发生异常', '2019-07-09 23:32:32');
INSERT INTO `access_log` VALUES (51712, '64.79.15626863562309325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:32:36', 12, 0, '', '2019-07-09 23:32:36');
INSERT INTO `access_log` VALUES (51713, '64.77.15626863563229303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:32:36', 3, 0, '', '2019-07-09 23:32:36');
INSERT INTO `access_log` VALUES (51714, '64.84.15626863606599319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:32:41', 2, 0, '', '2019-07-09 23:32:41');
INSERT INTO `access_log` VALUES (51715, '64.82.15626863607599339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:32:41', 2, 0, '', '2019-07-09 23:32:41');
INSERT INTO `access_log` VALUES (51716, '64.81.15626863621519313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:32:42', 2, 0, '', '2019-07-09 23:32:42');
INSERT INTO `access_log` VALUES (51717, '64.85.15626863627289337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:32:43', 2, 0, '', '2019-07-09 23:32:43');
INSERT INTO `access_log` VALUES (51718, '59.79.15626863639419169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:32:44', 2, 0, '', '2019-07-09 23:32:44');
INSERT INTO `access_log` VALUES (51719, '59.80.15626863639459149', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:32:44', 13, 2001001000, '服务端发生异常', '2019-07-09 23:32:44');
INSERT INTO `access_log` VALUES (51720, '64.78.15626863726619331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:32:53', 2, 0, '', '2019-07-09 23:32:53');
INSERT INTO `access_log` VALUES (51721, '64.80.15626863727669331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:32:53', 2, 0, '', '2019-07-09 23:32:53');
INSERT INTO `access_log` VALUES (51722, '64.76.15626863812709317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:33:01', 2, 0, '', '2019-07-09 23:33:01');
INSERT INTO `access_log` VALUES (51723, '64.79.15626863813509327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:33:01', 2, 0, '', '2019-07-09 23:33:01');
INSERT INTO `access_log` VALUES (51724, '59.76.15626863819119161', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:33:02', 2, 0, '', '2019-07-09 23:33:02');
INSERT INTO `access_log` VALUES (51725, '59.78.15626863819129165', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:33:02', 13, 2001001000, '服务端发生异常', '2019-07-09 23:33:02');
INSERT INTO `access_log` VALUES (51726, '64.77.15626863825089305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:33:03', 2, 0, '', '2019-07-09 23:33:03');
INSERT INTO `access_log` VALUES (51727, '64.84.15626863825929321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:33:03', 2, 0, '', '2019-07-09 23:33:03');
INSERT INTO `access_log` VALUES (51728, '59.75.15626863834349179', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:33:03', 2, 0, '', '2019-07-09 23:33:03');
INSERT INTO `access_log` VALUES (51729, '59.77.15626863834359157', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:33:03', 13, 2001001000, '服务端发生异常', '2019-07-09 23:33:03');
INSERT INTO `access_log` VALUES (51730, '65.51.15626863910330935', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:33:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-09 23:33:11');
INSERT INTO `access_log` VALUES (51731, '65.46.15626863988740927', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yuandaoyuanma&password=yuandaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:33:19', 125, 1002002000, '账号不存在', '2019-07-09 23:33:19');
INSERT INTO `access_log` VALUES (51732, '65.52.15626864097620907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:33:30', 166, 0, '', '2019-07-09 23:33:30');
INSERT INTO `access_log` VALUES (51733, '65.54.15626864103530835', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:33:30', 12, 2001001000, '服务端发生异常', '2019-07-09 23:33:30');
INSERT INTO `access_log` VALUES (51734, '65.45.15626864103530861', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:33:30', 12, 0, '', '2019-07-09 23:33:30');
INSERT INTO `access_log` VALUES (51735, '65.47.15626864103510857', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '114.94.119.228', '2019-07-09 23:33:30', 12, 0, '', '2019-07-09 23:33:30');
INSERT INTO `access_log` VALUES (51736, '65.49.15626891217070907', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.129.115.174', '2019-07-10 00:18:42', 0, 1002001015, '账号未登陆', '2019-07-10 00:18:42');
INSERT INTO `access_log` VALUES (51737, '65.50.15626891217080935', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.129.115.174', '2019-07-10 00:18:42', 0, 1002001015, '账号未登陆', '2019-07-10 00:18:42');
INSERT INTO `access_log` VALUES (51738, '65.51.15626891217100973', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.129.115.174', '2019-07-10 00:18:42', 0, 1002001015, '账号未登陆', '2019-07-10 00:18:42');
INSERT INTO `access_log` VALUES (51739, '65.46.15626891250130965', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.129.115.174', '2019-07-10 00:18:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 00:18:45');
INSERT INTO `access_log` VALUES (51740, '65.3607.15626891299212711', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.129.115.174', '2019-07-10 00:18:50', 93, 0, '', '2019-07-10 00:18:50');
INSERT INTO `access_log` VALUES (51741, '65.52.15626891306020945', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.129.115.174', '2019-07-10 00:18:51', 11, 0, '', '2019-07-10 00:18:51');
INSERT INTO `access_log` VALUES (51742, '65.54.15626891306120873', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.129.115.174', '2019-07-10 00:18:51', 11, 0, '', '2019-07-10 00:18:51');
INSERT INTO `access_log` VALUES (51743, '65.45.15626891306120899', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '119.129.115.174', '2019-07-10 00:18:51', 11, 2001001000, '服务端发生异常', '2019-07-10 00:18:51');
INSERT INTO `access_log` VALUES (51744, '65.47.15627198552811305', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.5.3.170', '2019-07-10 08:50:55', 1, 1002001015, '账号未登陆', '2019-07-10 08:50:55');
INSERT INTO `access_log` VALUES (51745, '65.53.15627198552831329', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.5.3.170', '2019-07-10 08:50:55', 1, 1002001015, '账号未登陆', '2019-07-10 08:50:55');
INSERT INTO `access_log` VALUES (51746, '65.54.15627198552801283', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.5.3.170', '2019-07-10 08:50:55', 1, 1002001015, '账号未登陆', '2019-07-10 08:50:55');
INSERT INTO `access_log` VALUES (51747, '65.49.15627198577941319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.5.3.170', '2019-07-10 08:50:58', 20, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 08:50:58');
INSERT INTO `access_log` VALUES (51748, '59.75.15627214491259647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.114.246.88', '2019-07-10 09:17:29', 11, 0, '', '2019-07-10 09:17:29');
INSERT INTO `access_log` VALUES (51749, '59.77.15627214491259625', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.114.246.88', '2019-07-10 09:17:29', 25, 2001001000, '服务端发生异常', '2019-07-10 09:17:29');
INSERT INTO `access_log` VALUES (51750, '65.50.15627214593381369', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.114.246.88', '2019-07-10 09:17:39', 1, 1002001015, '账号未登陆', '2019-07-10 09:17:39');
INSERT INTO `access_log` VALUES (51751, '65.46.15627214593381397', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.114.246.88', '2019-07-10 09:17:39', 1, 1002001015, '账号未登陆', '2019-07-10 09:17:39');
INSERT INTO `access_log` VALUES (51752, '65.51.15627214593381407', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.114.246.88', '2019-07-10 09:17:39', 0, 1002001015, '账号未登陆', '2019-07-10 09:17:39');
INSERT INTO `access_log` VALUES (51753, '65.54.15627214909691307', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.114.246.88', '2019-07-10 09:18:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 09:18:11');
INSERT INTO `access_log` VALUES (51754, '65.52.15627215017661379', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.114.246.88', '2019-07-10 09:18:22', 108, 0, '', '2019-07-10 09:18:22');
INSERT INTO `access_log` VALUES (51755, '65.53.15627215022111355', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.114.246.88', '2019-07-10 09:18:22', 19, 0, '', '2019-07-10 09:18:22');
INSERT INTO `access_log` VALUES (51756, '65.49.15627215022161343', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.114.246.88', '2019-07-10 09:18:22', 16, 0, '', '2019-07-10 09:18:22');
INSERT INTO `access_log` VALUES (51757, '65.47.15627215022131329', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.114.246.88', '2019-07-10 09:18:22', 20, 2001001000, '服务端发生异常', '2019-07-10 09:18:22');
INSERT INTO `access_log` VALUES (51758, '65.45.15627215341311337', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.114.246.88', '2019-07-10 09:18:54', 11, 2001001000, '服务端发生异常', '2019-07-10 09:18:54');
INSERT INTO `access_log` VALUES (51759, '65.54.15627215341331309', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.114.246.88', '2019-07-10 09:18:54', 181, 0, '', '2019-07-10 09:18:54');
INSERT INTO `access_log` VALUES (51760, '65.3607.15627215341273149', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '118.114.246.88', '2019-07-10 09:18:54', 186, 0, '', '2019-07-10 09:18:54');
INSERT INTO `access_log` VALUES (51761, '59.74.15627225163909657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.7.74.209', '2019-07-10 09:35:16', 3, 0, '', '2019-07-10 09:35:16');
INSERT INTO `access_log` VALUES (51762, '59.72.15627225163959649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.7.74.209', '2019-07-10 09:35:16', 14, 2001001000, '服务端发生异常', '2019-07-10 09:35:16');
INSERT INTO `access_log` VALUES (51763, '65.51.15627225350191423', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.7.74.209', '2019-07-10 09:35:35', 1, 1002001015, '账号未登陆', '2019-07-10 09:35:35');
INSERT INTO `access_log` VALUES (51764, '65.45.15627225350201351', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.7.74.209', '2019-07-10 09:35:35', 1, 1002001015, '账号未登陆', '2019-07-10 09:35:35');
INSERT INTO `access_log` VALUES (51765, '65.54.15627225350311323', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.7.74.209', '2019-07-10 09:35:35', 0, 1002001015, '账号未登陆', '2019-07-10 09:35:35');
INSERT INTO `access_log` VALUES (51766, '65.47.15627225555181345', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.7.74.209', '2019-07-10 09:35:56', 195, 0, '', '2019-07-10 09:35:56');
INSERT INTO `access_log` VALUES (51767, '65.53.15627225561731371', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.7.74.209', '2019-07-10 09:35:56', 10, 0, '', '2019-07-10 09:35:56');
INSERT INTO `access_log` VALUES (51768, '65.46.15627225561751415', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.7.74.209', '2019-07-10 09:35:56', 10, 0, '', '2019-07-10 09:35:56');
INSERT INTO `access_log` VALUES (51769, '65.49.15627225561731359', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.7.74.209', '2019-07-10 09:35:56', 12, 2001001000, '服务端发生异常', '2019-07-10 09:35:56');
INSERT INTO `access_log` VALUES (51770, '59.79.15627226622959655', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-10 09:37:42', 3, 0, '', '2019-07-10 09:37:42');
INSERT INTO `access_log` VALUES (51771, '59.80.15627226623589635', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-10 09:37:42', 17, 2001001000, '服务端发生异常', '2019-07-10 09:37:42');
INSERT INTO `access_log` VALUES (51772, '64.84.15627226661069805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-10 09:37:46', 11, 0, '', '2019-07-10 09:37:46');
INSERT INTO `access_log` VALUES (51773, '64.82.15627226664099825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-10 09:37:46', 3, 0, '', '2019-07-10 09:37:46');
INSERT INTO `access_log` VALUES (51774, '64.85.15627226791409823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-10 09:37:59', 2, 0, '', '2019-07-10 09:37:59');
INSERT INTO `access_log` VALUES (51775, '59.77.15627254056529679', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 10:23:26', 11, 0, '', '2019-07-10 10:23:26');
INSERT INTO `access_log` VALUES (51776, '59.75.15627254056619701', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 10:23:26', 22, 2001001000, '服务端发生异常', '2019-07-10 10:23:26');
INSERT INTO `access_log` VALUES (51777, '64.80.15627254117249853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 10:23:32', 207, 0, '', '2019-07-10 10:23:32');
INSERT INTO `access_log` VALUES (51778, '64.76.15627254120839839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 10:23:32', 3, 0, '', '2019-07-10 10:23:32');
INSERT INTO `access_log` VALUES (51779, '64.79.15627254142659849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 10:23:34', 2, 0, '', '2019-07-10 10:23:34');
INSERT INTO `access_log` VALUES (51780, '64.77.15627254148899827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 10:23:35', 2, 0, '', '2019-07-10 10:23:35');
INSERT INTO `access_log` VALUES (51781, '64.84.15627254152349843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 10:23:35', 1, 0, '', '2019-07-10 10:23:35');
INSERT INTO `access_log` VALUES (51782, '65.51.15627254307341463', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 10:23:51', 0, 1002001015, '账号未登陆', '2019-07-10 10:23:51');
INSERT INTO `access_log` VALUES (51783, '65.54.15627254307341363', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 10:23:51', 0, 1002001015, '账号未登陆', '2019-07-10 10:23:51');
INSERT INTO `access_log` VALUES (51784, '65.45.15627254307351391', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 10:23:51', 1, 1002001015, '账号未登陆', '2019-07-10 10:23:51');
INSERT INTO `access_log` VALUES (51785, '65.52.15627254421461435', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 10:24:02', 166, 0, '', '2019-07-10 10:24:02');
INSERT INTO `access_log` VALUES (51786, '65.46.15627254426011455', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 10:24:03', 11, 2001001000, '服务端发生异常', '2019-07-10 10:24:03');
INSERT INTO `access_log` VALUES (51787, '65.47.15627254426001385', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 10:24:03', 14, 0, '', '2019-07-10 10:24:03');
INSERT INTO `access_log` VALUES (51788, '65.53.15627254426051411', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 10:24:03', 10, 0, '', '2019-07-10 10:24:03');
INSERT INTO `access_log` VALUES (51789, '59.75.15627286976489745', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.57.46', '2019-07-10 11:18:18', 18, 0, '', '2019-07-10 11:18:18');
INSERT INTO `access_log` VALUES (51790, '59.71.15627286976529737', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.57.46', '2019-07-10 11:18:18', 22, 2001001000, '服务端发生异常', '2019-07-10 11:18:18');
INSERT INTO `access_log` VALUES (51791, '64.84.15627287007009889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.57.46', '2019-07-10 11:18:21', 11, 0, '', '2019-07-10 11:18:21');
INSERT INTO `access_log` VALUES (51792, '64.82.15627287008109907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.57.46', '2019-07-10 11:18:21', 3, 0, '', '2019-07-10 11:18:21');
INSERT INTO `access_log` VALUES (51793, '64.81.15627287035549881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.57.46', '2019-07-10 11:18:24', 2, 0, '', '2019-07-10 11:18:24');
INSERT INTO `access_log` VALUES (51794, '64.85.15627287040239907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.57.46', '2019-07-10 11:18:24', 2, 0, '', '2019-07-10 11:18:24');
INSERT INTO `access_log` VALUES (51795, '64.83.15627287047059893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.57.46', '2019-07-10 11:18:25', 2, 0, '', '2019-07-10 11:18:25');
INSERT INTO `access_log` VALUES (51796, '64.78.15627287064519897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.57.46', '2019-07-10 11:18:26', 2, 0, '', '2019-07-10 11:18:26');
INSERT INTO `access_log` VALUES (51797, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.57.46', '2019-07-10 11:18:26', 5, 0, '', '2019-07-10 11:18:26');
INSERT INTO `access_log` VALUES (51798, '64.80.15627287096119899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.57.46', '2019-07-10 11:18:30', 2, 0, '', '2019-07-10 11:18:30');
INSERT INTO `access_log` VALUES (51799, '64.76.15627287096859887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.57.46', '2019-07-10 11:18:30', 3, 0, '', '2019-07-10 11:18:30');
INSERT INTO `access_log` VALUES (51800, '59.79.15627287149209737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.57.46', '2019-07-10 11:18:35', 3, 0, '', '2019-07-10 11:18:35');
INSERT INTO `access_log` VALUES (51801, '59.80.15627287149209717', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.57.46', '2019-07-10 11:18:35', 20, 2001001000, '服务端发生异常', '2019-07-10 11:18:35');
INSERT INTO `access_log` VALUES (51802, '65.45.15627296063031449', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.64.142.110', '2019-07-10 11:33:26', 0, 1002001015, '账号未登陆', '2019-07-10 11:33:26');
INSERT INTO `access_log` VALUES (51803, '65.3607.15627296063043259', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.64.142.110', '2019-07-10 11:33:26', 0, 1002001015, '账号未登陆', '2019-07-10 11:33:26');
INSERT INTO `access_log` VALUES (51804, '65.52.15627296063051493', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.64.142.110', '2019-07-10 11:33:26', 1, 1002001015, '账号未登陆', '2019-07-10 11:33:26');
INSERT INTO `access_log` VALUES (51805, '65.53.15627296082991469', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.64.142.110', '2019-07-10 11:33:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 11:33:28');
INSERT INTO `access_log` VALUES (51806, '65.46.15627296121611513', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.64.142.110', '2019-07-10 11:33:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 11:33:32');
INSERT INTO `access_log` VALUES (51807, '65.47.15627296150801443', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.64.142.110', '2019-07-10 11:33:35', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 11:33:35');
INSERT INTO `access_log` VALUES (51808, '65.50.15627296284541485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.64.142.110', '2019-07-10 11:33:48', 175, 0, '', '2019-07-10 11:33:49');
INSERT INTO `access_log` VALUES (51809, '65.54.15627296288801423', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.64.142.110', '2019-07-10 11:33:49', 16, 0, '', '2019-07-10 11:33:49');
INSERT INTO `access_log` VALUES (51810, '65.3607.15627296288823261', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.64.142.110', '2019-07-10 11:33:49', 14, 0, '', '2019-07-10 11:33:49');
INSERT INTO `access_log` VALUES (51811, '65.51.15627296288821521', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.64.142.110', '2019-07-10 11:33:49', 15, 2001001000, '服务端发生异常', '2019-07-10 11:33:49');
INSERT INTO `access_log` VALUES (51812, '59.71.15627296928579751', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.88.168.243', '2019-07-10 11:34:53', 2, 0, '', '2019-07-10 11:34:53');
INSERT INTO `access_log` VALUES (51813, '59.74.15627296928579755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '113.88.168.243', '2019-07-10 11:34:53', 15, 2001001000, '服务端发生异常', '2019-07-10 11:34:53');
INSERT INTO `access_log` VALUES (51814, '59.72.15627296983639747', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.64.142.110', '2019-07-10 11:34:58', 2, 0, '', '2019-07-10 11:34:58');
INSERT INTO `access_log` VALUES (51815, '59.79.15627296983699751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.64.142.110', '2019-07-10 11:34:58', 49, 2001001000, '服务端发生异常', '2019-07-10 11:34:58');
INSERT INTO `access_log` VALUES (51816, '64.83.15627297016929907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.64.142.110', '2019-07-10 11:35:02', 3, 0, '', '2019-07-10 11:35:02');
INSERT INTO `access_log` VALUES (51817, '64.78.15627297018239911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '112.64.142.110', '2019-07-10 11:35:02', 2, 0, '', '2019-07-10 11:35:02');
INSERT INTO `access_log` VALUES (51818, '59.78.15627300288319751', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:29', 3, 0, '', '2019-07-10 11:40:29');
INSERT INTO `access_log` VALUES (51819, '59.76.15627300288309747', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:29', 13, 2001001000, '服务端发生异常', '2019-07-10 11:40:29');
INSERT INTO `access_log` VALUES (51820, '64.79.15627300316559913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:32', 2, 0, '', '2019-07-10 11:40:32');
INSERT INTO `access_log` VALUES (51821, '64.77.15627300317779893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:32', 2, 0, '', '2019-07-10 11:40:32');
INSERT INTO `access_log` VALUES (51822, '64.84.15627300328599909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:33', 1, 0, '', '2019-07-10 11:40:33');
INSERT INTO `access_log` VALUES (51823, '64.82.15627300333819927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:33', 2, 0, '', '2019-07-10 11:40:33');
INSERT INTO `access_log` VALUES (51824, '64.81.15627300339879901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:34', 2, 0, '', '2019-07-10 11:40:34');
INSERT INTO `access_log` VALUES (51825, '64.83.15627300395109913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:40', 2, 0, '', '2019-07-10 11:40:40');
INSERT INTO `access_log` VALUES (51826, '64.78.15627300396039917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:40', 2, 0, '', '2019-07-10 11:40:40');
INSERT INTO `access_log` VALUES (51827, '59.75.15627300447619765', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:45', 2, 0, '', '2019-07-10 11:40:45');
INSERT INTO `access_log` VALUES (51828, '59.74.15627300447629761', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:45', 14, 2001001000, '服务端发生异常', '2019-07-10 11:40:45');
INSERT INTO `access_log` VALUES (51829, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:50', 8, 0, '', '2019-07-10 11:40:50');
INSERT INTO `access_log` VALUES (51830, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:50', 11, 0, '', '2019-07-10 11:40:50');
INSERT INTO `access_log` VALUES (51831, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:52', 6, 0, '', '2019-07-10 11:40:52');
INSERT INTO `access_log` VALUES (51832, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:52', 11, 0, '', '2019-07-10 11:40:52');
INSERT INTO `access_log` VALUES (51833, '64.76.15627300530109907', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '61.154.229.133', '2019-07-10 11:40:53', 8, 0, '', '2019-07-10 11:40:53');
INSERT INTO `access_log` VALUES (51834, '59.74.15627307768489771', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '125.121.233.26', '2019-07-10 11:52:57', 4, 0, '', '2019-07-10 11:52:57');
INSERT INTO `access_log` VALUES (51835, '59.71.15627307768489767', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '125.121.233.26', '2019-07-10 11:52:57', 14, 2001001000, '服务端发生异常', '2019-07-10 11:52:57');
INSERT INTO `access_log` VALUES (51836, '64.80.15627307852659929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '125.121.233.26', '2019-07-10 11:53:05', 3, 0, '', '2019-07-10 11:53:05');
INSERT INTO `access_log` VALUES (51837, '64.76.15627307854189917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '125.121.233.26', '2019-07-10 11:53:05', 2, 0, '', '2019-07-10 11:53:05');
INSERT INTO `access_log` VALUES (51838, '59.79.15627307890959767', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '125.121.233.26', '2019-07-10 11:53:09', 9, 0, '', '2019-07-10 11:53:09');
INSERT INTO `access_log` VALUES (51839, '59.80.15627307890959747', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '125.121.233.26', '2019-07-10 11:53:09', 19, 2001001000, '服务端发生异常', '2019-07-10 11:53:09');
INSERT INTO `access_log` VALUES (51840, '66.49.15627307962837785', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '125.121.233.26', '2019-07-10 11:53:16', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-07-10 11:53:16');
INSERT INTO `access_log` VALUES (51841, '59.78.15627308013719763', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '125.121.233.26', '2019-07-10 11:53:21', 3, 0, '', '2019-07-10 11:53:21');
INSERT INTO `access_log` VALUES (51842, '59.76.15627308013719759', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '125.121.233.26', '2019-07-10 11:53:21', 13, 2001001000, '服务端发生异常', '2019-07-10 11:53:21');
INSERT INTO `access_log` VALUES (51843, '64.84.15627308043039921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '125.121.233.26', '2019-07-10 11:53:24', 1, 0, '', '2019-07-10 11:53:24');
INSERT INTO `access_log` VALUES (51844, '64.82.15627308043809939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '125.121.233.26', '2019-07-10 11:53:24', 2, 0, '', '2019-07-10 11:53:24');
INSERT INTO `access_log` VALUES (51845, '64.81.15627308057489913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '125.121.233.26', '2019-07-10 11:53:26', 1, 0, '', '2019-07-10 11:53:26');
INSERT INTO `access_log` VALUES (51846, '64.85.15627308063539939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '125.121.233.26', '2019-07-10 11:53:26', 2, 0, '', '2019-07-10 11:53:26');
INSERT INTO `access_log` VALUES (51847, '65.45.15627378336331561', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.245.94', '2019-07-10 13:50:34', 13, 1002001012, '访问令牌已过期', '2019-07-10 13:50:34');
INSERT INTO `access_log` VALUES (51848, '65.53.15627378336341579', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.245.94', '2019-07-10 13:50:34', 16, 1002001012, '访问令牌已过期', '2019-07-10 13:50:34');
INSERT INTO `access_log` VALUES (51849, '65.49.15627378336521567', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.245.94', '2019-07-10 13:50:34', 10, 1002001012, '访问令牌已过期', '2019-07-10 13:50:34');
INSERT INTO `access_log` VALUES (51850, '65.50.15627378375371597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.245.94', '2019-07-10 13:50:38', 5, 1002002000, '账号不存在', '2019-07-10 13:50:38');
INSERT INTO `access_log` VALUES (51851, '59.76.15627387459619865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:05:46', 10, 0, '', '2019-07-10 14:05:46');
INSERT INTO `access_log` VALUES (51852, '59.77.15627387459649861', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:05:46', 14, 2001001000, '服务端发生异常', '2019-07-10 14:05:46');
INSERT INTO `access_log` VALUES (51853, '64.78.15627387505780035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:05:51', 72, 0, '', '2019-07-10 14:05:51');
INSERT INTO `access_log` VALUES (51854, '64.77.15627387507620013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:05:51', 4, 0, '', '2019-07-10 14:05:51');
INSERT INTO `access_log` VALUES (51855, '64.79.15627387523700033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:05:52', 2, 0, '', '2019-07-10 14:05:52');
INSERT INTO `access_log` VALUES (51856, '64.84.15627387528890029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:05:53', 2, 0, '', '2019-07-10 14:05:53');
INSERT INTO `access_log` VALUES (51857, '64.82.15627387532600047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:05:53', 2, 0, '', '2019-07-10 14:05:53');
INSERT INTO `access_log` VALUES (51858, '64.81.15627387574880021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:05:57', 2, 0, '', '2019-07-10 14:05:57');
INSERT INTO `access_log` VALUES (51859, '64.85.15627387576160045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:05:58', 1, 0, '', '2019-07-10 14:05:58');
INSERT INTO `access_log` VALUES (51860, '59.71.15627387588959875', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:05:59', 3, 0, '', '2019-07-10 14:05:59');
INSERT INTO `access_log` VALUES (51861, '59.74.15627387588969879', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:05:59', 17, 2001001000, '服务端发生异常', '2019-07-10 14:05:59');
INSERT INTO `access_log` VALUES (51862, '59.79.15627387684449875', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:08', 3, 0, '', '2019-07-10 14:06:08');
INSERT INTO `access_log` VALUES (51863, '59.80.15627387684459855', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:08', 41, 2001001000, '服务端发生异常', '2019-07-10 14:06:08');
INSERT INTO `access_log` VALUES (51864, '64.80.15627387689870039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:09', 2, 0, '', '2019-07-10 14:06:09');
INSERT INTO `access_log` VALUES (51865, '64.76.15627387691170027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:09', 2, 0, '', '2019-07-10 14:06:09');
INSERT INTO `access_log` VALUES (51866, '59.78.15627387714889871', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:11', 3, 0, '', '2019-07-10 14:06:11');
INSERT INTO `access_log` VALUES (51867, '59.73.15627387714889881', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:11', 14, 2001001000, '服务端发生异常', '2019-07-10 14:06:12');
INSERT INTO `access_log` VALUES (51868, '65.3607.15627387767503385', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:17', 1, 1002001015, '账号未登陆', '2019-07-10 14:06:17');
INSERT INTO `access_log` VALUES (51869, '65.54.15627387767511545', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:17', 0, 1002001015, '账号未登陆', '2019-07-10 14:06:17');
INSERT INTO `access_log` VALUES (51870, '65.52.15627387767591619', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:17', 1, 1002001015, '账号未登陆', '2019-07-10 14:06:17');
INSERT INTO `access_log` VALUES (51871, '65.53.15627387788681593', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 14:06:19');
INSERT INTO `access_log` VALUES (51872, '65.45.15627387829371575', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:23', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 14:06:23');
INSERT INTO `access_log` VALUES (51873, '65.50.15627387895081611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:30', 6, 1002002001, '密码不正确', '2019-07-10 14:06:30');
INSERT INTO `access_log` VALUES (51874, '65.47.15627388062271569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:46', 66, 0, '', '2019-07-10 14:06:46');
INSERT INTO `access_log` VALUES (51875, '65.51.15627388065451647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:47', 39, 0, '', '2019-07-10 14:06:47');
INSERT INTO `access_log` VALUES (51876, '65.3607.15627388065473387', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:47', 37, 2001001000, '服务端发生异常', '2019-07-10 14:06:47');
INSERT INTO `access_log` VALUES (51877, '65.52.15627388065531621', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.123.176.233', '2019-07-10 14:06:47', 33, 0, '', '2019-07-10 14:06:47');
INSERT INTO `access_log` VALUES (51878, '59.71.15627388237119877', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.129.6.251', '2019-07-10 14:07:04', 13, 2001001000, '服务端发生异常', '2019-07-10 14:07:04');
INSERT INTO `access_log` VALUES (51879, '59.74.15627388237299881', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '180.97.118.223', '2019-07-10 14:07:04', 2, 0, '', '2019-07-10 14:07:04');
INSERT INTO `access_log` VALUES (51880, '64.82.15627388304340049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.129.8.179', '2019-07-10 14:07:10', 2, 0, '', '2019-07-10 14:07:10');
INSERT INTO `access_log` VALUES (51881, '65.51.15627390717011651', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.129.8.179', '2019-07-10 14:11:12', 1, 1002001015, '账号未登陆', '2019-07-10 14:11:12');
INSERT INTO `access_log` VALUES (51882, '59.78.15627393102739879', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.118.131', '2019-07-10 14:15:10', 4, 0, '', '2019-07-10 14:15:10');
INSERT INTO `access_log` VALUES (51883, '59.73.15627393102749889', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.118.131', '2019-07-10 14:15:10', 14, 2001001000, '服务端发生异常', '2019-07-10 14:15:10');
INSERT INTO `access_log` VALUES (51884, '65.3607.15627399532123403', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.197.100.98', '2019-07-10 14:25:53', 1, 1002001015, '账号未登陆', '2019-07-10 14:25:53');
INSERT INTO `access_log` VALUES (51885, '65.51.15627399532181663', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.197.100.98', '2019-07-10 14:25:53', 0, 1002001015, '账号未登陆', '2019-07-10 14:25:53');
INSERT INTO `access_log` VALUES (51886, '65.52.15627399532231637', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.197.100.98', '2019-07-10 14:25:53', 1, 1002001015, '账号未登陆', '2019-07-10 14:25:53');
INSERT INTO `access_log` VALUES (51887, '65.53.15627399564951611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.197.100.98', '2019-07-10 14:25:56', 172, 0, '', '2019-07-10 14:25:57');
INSERT INTO `access_log` VALUES (51888, '65.45.15627399569881593', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.197.100.98', '2019-07-10 14:25:57', 12, 2001001000, '服务端发生异常', '2019-07-10 14:25:57');
INSERT INTO `access_log` VALUES (51889, '65.49.15627399569911599', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.197.100.98', '2019-07-10 14:25:57', 9, 0, '', '2019-07-10 14:25:57');
INSERT INTO `access_log` VALUES (51890, '65.50.15627399569911629', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.197.100.98', '2019-07-10 14:25:57', 9, 0, '', '2019-07-10 14:25:57');
INSERT INTO `access_log` VALUES (51891, '65.47.15627399828081587', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.197.100.98', '2019-07-10 14:26:23', 9, 0, '', '2019-07-10 14:26:23');
INSERT INTO `access_log` VALUES (51892, '65.51.15627399828141665', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.197.100.98', '2019-07-10 14:26:23', 10, 2001001000, '服务端发生异常', '2019-07-10 14:26:23');
INSERT INTO `access_log` VALUES (51893, '65.52.15627399828191639', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.197.100.98', '2019-07-10 14:26:23', 10, 0, '', '2019-07-10 14:26:23');
INSERT INTO `access_log` VALUES (51894, '65.54.15627399869231565', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.197.100.98', '2019-07-10 14:26:27', 9, 0, '', '2019-07-10 14:26:27');
INSERT INTO `access_log` VALUES (51895, '65.53.15627399869241613', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.197.100.98', '2019-07-10 14:26:27', 10, 2001001000, '服务端发生异常', '2019-07-10 14:26:27');
INSERT INTO `access_log` VALUES (51896, '65.45.15627399869411595', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.197.100.98', '2019-07-10 14:26:27', 8, 0, '', '2019-07-10 14:26:27');
INSERT INTO `access_log` VALUES (51897, '65.47.15627400526831589', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-10 14:27:33', 0, 1002001015, '账号未登陆', '2019-07-10 14:27:33');
INSERT INTO `access_log` VALUES (51898, '65.52.15627400526861641', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-10 14:27:33', 1, 1002001015, '账号未登陆', '2019-07-10 14:27:33');
INSERT INTO `access_log` VALUES (51899, '65.3607.15627400526943407', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-10 14:27:33', 0, 1002001015, '账号未登陆', '2019-07-10 14:27:33');
INSERT INTO `access_log` VALUES (51900, '65.53.15627400546401615', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-10 14:27:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 14:27:35');
INSERT INTO `access_log` VALUES (51901, '59.76.15627433819029929', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 15:23:02', 10, 0, '', '2019-07-10 15:23:02');
INSERT INTO `access_log` VALUES (51902, '59.75.15627433819089947', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 15:23:02', 13, 2001001000, '服务端发生异常', '2019-07-10 15:23:02');
INSERT INTO `access_log` VALUES (51903, '59.72.15627434118289935', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 15:23:32', 3, 0, '', '2019-07-10 15:23:32');
INSERT INTO `access_log` VALUES (51904, '59.79.15627434118289939', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 15:23:32', 14, 2001001000, '服务端发生异常', '2019-07-10 15:23:32');
INSERT INTO `access_log` VALUES (51905, '59.80.15627434122149919', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:23:32', 3, 0, '', '2019-07-10 15:23:32');
INSERT INTO `access_log` VALUES (51906, '59.78.15627434122149935', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:23:32', 12, 2001001000, '服务端发生异常', '2019-07-10 15:23:32');
INSERT INTO `access_log` VALUES (51907, '65.47.15627434969291637', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:24:57', 0, 1002001015, '账号未登陆', '2019-07-10 15:24:57');
INSERT INTO `access_log` VALUES (51908, '65.53.15627434972691663', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:24:57', 1, 1002001015, '账号未登陆', '2019-07-10 15:24:57');
INSERT INTO `access_log` VALUES (51909, '65.45.15627434974971645', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:24:57', 1, 1002001015, '账号未登陆', '2019-07-10 15:24:57');
INSERT INTO `access_log` VALUES (51910, '65.54.15627435020461613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:25:02', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 15:25:02');
INSERT INTO `access_log` VALUES (51911, '65.51.15627435130771715', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:25:13', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 15:25:13');
INSERT INTO `access_log` VALUES (51912, '65.50.15627435230391679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:25:23', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 15:25:23');
INSERT INTO `access_log` VALUES (51913, '59.73.15627437052999949', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.20.121', '2019-07-10 15:28:25', 2, 0, '', '2019-07-10 15:28:25');
INSERT INTO `access_log` VALUES (51914, '59.77.15627437053009931', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.20.121', '2019-07-10 15:28:25', 10, 2001001000, '服务端发生异常', '2019-07-10 15:28:25');
INSERT INTO `access_log` VALUES (51915, '64.83.15627437132300099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.20.121', '2019-07-10 15:28:33', 11, 0, '', '2019-07-10 15:28:33');
INSERT INTO `access_log` VALUES (51916, '64.85.15627437134210111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.20.121', '2019-07-10 15:28:33', 3, 0, '', '2019-07-10 15:28:33');
INSERT INTO `access_log` VALUES (51917, '59.75.15627437146969953', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.20.121', '2019-07-10 15:28:35', 2, 0, '', '2019-07-10 15:28:35');
INSERT INTO `access_log` VALUES (51918, '59.74.15627437146999949', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.20.121', '2019-07-10 15:28:35', 19, 2001001000, '服务端发生异常', '2019-07-10 15:28:35');
INSERT INTO `access_log` VALUES (51919, '65.3607.15627441386803463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:35:39', 99, 0, '', '2019-07-10 15:35:39');
INSERT INTO `access_log` VALUES (51920, '65.47.15627441390891647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:35:39', 9, 0, '', '2019-07-10 15:35:39');
INSERT INTO `access_log` VALUES (51921, '65.45.15627441391131655', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:35:39', 21, 0, '', '2019-07-10 15:35:39');
INSERT INTO `access_log` VALUES (51922, '65.53.15627441391131673', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:35:39', 27, 2001001000, '服务端发生异常', '2019-07-10 15:35:39');
INSERT INTO `access_log` VALUES (51923, '65.3607.15627443718023467', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:39:32', 15, 0, '', '2019-07-10 15:39:32');
INSERT INTO `access_log` VALUES (51924, '65.52.15627443718121703', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:39:32', 10, 2001001000, '服务端发生异常', '2019-07-10 15:39:32');
INSERT INTO `access_log` VALUES (51925, '65.47.15627443718241651', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '180.172.57.53', '2019-07-10 15:39:32', 9, 0, '', '2019-07-10 15:39:32');
INSERT INTO `access_log` VALUES (51926, '59.79.15627470344279989', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:23:54', 11, 0, '', '2019-07-10 16:23:54');
INSERT INTO `access_log` VALUES (51927, '59.72.15627470344339985', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:23:54', 30, 2001001000, '服务端发生异常', '2019-07-10 16:23:54');
INSERT INTO `access_log` VALUES (51928, '64.78.15627470395360149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:24:00', 11, 0, '', '2019-07-10 16:24:00');
INSERT INTO `access_log` VALUES (51929, '64.77.15627470396800127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:24:00', 5, 0, '', '2019-07-10 16:24:00');
INSERT INTO `access_log` VALUES (51930, '64.79.15627470414250147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:24:01', 3, 0, '', '2019-07-10 16:24:01');
INSERT INTO `access_log` VALUES (51931, '64.84.15627470425470141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:24:03', 2, 0, '', '2019-07-10 16:24:03');
INSERT INTO `access_log` VALUES (51932, '64.82.15627470433180161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:24:03', 2, 0, '', '2019-07-10 16:24:03');
INSERT INTO `access_log` VALUES (51933, '64.85.15627470629360157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:24:23', 3, 0, '', '2019-07-10 16:24:23');
INSERT INTO `access_log` VALUES (51934, '64.80.15627470631450153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:24:23', 2, 0, '', '2019-07-10 16:24:23');
INSERT INTO `access_log` VALUES (51935, '59.73.15627470660889995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:24:26', 3, 0, '', '2019-07-10 16:24:26');
INSERT INTO `access_log` VALUES (51936, '59.77.15627470660939977', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:24:26', 20, 2001001000, '服务端发生异常', '2019-07-10 16:24:26');
INSERT INTO `access_log` VALUES (51937, '64.76.15627470688560141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:24:29', 2, 0, '', '2019-07-10 16:24:29');
INSERT INTO `access_log` VALUES (51938, '64.78.15627470689850151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:24:29', 1, 0, '', '2019-07-10 16:24:29');
INSERT INTO `access_log` VALUES (51939, '64.77.15627470728200129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:24:33', 1, 0, '', '2019-07-10 16:24:33');
INSERT INTO `access_log` VALUES (51940, '64.79.15627470731950149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:24:33', 1, 0, '', '2019-07-10 16:24:33');
INSERT INTO `access_log` VALUES (51941, '64.84.15627470745150143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:24:35', 2, 0, '', '2019-07-10 16:24:35');
INSERT INTO `access_log` VALUES (51942, '64.81.15627470757120137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:24:36', 2, 0, '', '2019-07-10 16:24:36');
INSERT INTO `access_log` VALUES (51943, '64.83.15627470896680147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:24:50', 2, 0, '', '2019-07-10 16:24:50');
INSERT INTO `access_log` VALUES (51944, '64.80.15627471010750155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:25:01', 1, 0, '', '2019-07-10 16:25:01');
INSERT INTO `access_log` VALUES (51945, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:25:01', 5, 0, '', '2019-07-10 16:25:01');
INSERT INTO `access_log` VALUES (51946, '64.78.15627471071750153', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:25:07', 7, 0, '', '2019-07-10 16:25:07');
INSERT INTO `access_log` VALUES (51947, '64.77.15627471138920131', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:25:14', 6, 0, '', '2019-07-10 16:25:14');
INSERT INTO `access_log` VALUES (51948, '64.79.15627471174170151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:25:17', 2, 0, '', '2019-07-10 16:25:17');
INSERT INTO `access_log` VALUES (51949, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:25:17', 7, 0, '', '2019-07-10 16:25:17');
INSERT INTO `access_log` VALUES (51950, '64.84.15627471179050145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:25:18', 2, 0, '', '2019-07-10 16:25:18');
INSERT INTO `access_log` VALUES (51951, '64.82.15627471180510165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:25:18', 2, 0, '', '2019-07-10 16:25:18');
INSERT INTO `access_log` VALUES (51952, '59.71.15627471184889991', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:25:18', 2, 0, '', '2019-07-10 16:25:18');
INSERT INTO `access_log` VALUES (51953, '59.79.15627471184919991', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:25:18', 17, 2001001000, '服务端发生异常', '2019-07-10 16:25:19');
INSERT INTO `access_log` VALUES (51954, '64.81.15627471193940139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:25:19', 2, 0, '', '2019-07-10 16:25:19');
INSERT INTO `access_log` VALUES (51955, '64.83.15627471195200149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:25:20', 2, 0, '', '2019-07-10 16:25:20');
INSERT INTO `access_log` VALUES (51956, '59.78.15627471226679987', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:25:23', 3, 0, '', '2019-07-10 16:25:23');
INSERT INTO `access_log` VALUES (51957, '59.80.15627471226689971', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '182.50.114.226', '2019-07-10 16:25:23', 16, 2001001000, '服务端发生异常', '2019-07-10 16:25:23');
INSERT INTO `access_log` VALUES (51958, '65.52.15627471748191739', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:26:15', 0, 1002001015, '账号未登陆', '2019-07-10 16:26:15');
INSERT INTO `access_log` VALUES (51959, '65.54.15627471748191663', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:26:15', 0, 1002001015, '账号未登陆', '2019-07-10 16:26:15');
INSERT INTO `access_log` VALUES (51960, '65.53.15627471748411717', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:26:15', 1, 1002001015, '账号未登陆', '2019-07-10 16:26:15');
INSERT INTO `access_log` VALUES (51961, '65.3607.15627472702353507', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:27:50', 1, 1002001015, '账号未登陆', '2019-07-10 16:27:50');
INSERT INTO `access_log` VALUES (51962, '65.52.15627472702361741', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:27:50', 0, 1002001015, '账号未登陆', '2019-07-10 16:27:50');
INSERT INTO `access_log` VALUES (51963, '65.54.15627472702411665', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:27:50', 0, 1002001015, '账号未登陆', '2019-07-10 16:27:50');
INSERT INTO `access_log` VALUES (51964, '65.53.15627472726011719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:27:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 16:27:53');
INSERT INTO `access_log` VALUES (51965, '65.50.15627473017631733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:28:22', 103, 0, '', '2019-07-10 16:28:22');
INSERT INTO `access_log` VALUES (51966, '65.45.15627473020671701', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:28:22', 13, 0, '', '2019-07-10 16:28:22');
INSERT INTO `access_log` VALUES (51967, '65.46.15627473020681765', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:28:22', 12, 0, '', '2019-07-10 16:28:22');
INSERT INTO `access_log` VALUES (51968, '65.49.15627473020691705', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:28:22', 12, 2001001000, '服务端发生异常', '2019-07-10 16:28:22');
INSERT INTO `access_log` VALUES (51969, '65.54.15627473213821667', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:28:41', 9, 0, '', '2019-07-10 16:28:41');
INSERT INTO `access_log` VALUES (51970, '65.47.15627473213861697', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:28:41', 9, 0, '', '2019-07-10 16:28:41');
INSERT INTO `access_log` VALUES (51971, '65.53.15627473213861721', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:28:41', 10, 2001001000, '服务端发生异常', '2019-07-10 16:28:41');
INSERT INTO `access_log` VALUES (51972, '65.46.15627473665511767', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:29:27', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 16:29:27');
INSERT INTO `access_log` VALUES (51973, '65.3607.15627473928013511', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:29:53', 117, 0, '', '2019-07-10 16:29:53');
INSERT INTO `access_log` VALUES (51974, '65.53.15627474147701723', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:30:15', 8, 0, '', '2019-07-10 16:30:15');
INSERT INTO `access_log` VALUES (51975, '65.51.15627474147961773', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:30:15', 9, 0, '', '2019-07-10 16:30:15');
INSERT INTO `access_log` VALUES (51976, '65.47.15627474147951699', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:30:15', 10, 2001001000, '服务端发生异常', '2019-07-10 16:30:15');
INSERT INTO `access_log` VALUES (51977, '65.49.15627474268741709', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-07-10 16:30:27', 3, 1002001012, '访问令牌已过期', '2019-07-10 16:30:27');
INSERT INTO `access_log` VALUES (51978, '65.45.15627474268731705', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-07-10 16:30:27', 3, 1002001012, '访问令牌已过期', '2019-07-10 16:30:27');
INSERT INTO `access_log` VALUES (51979, '65.46.15627474268741769', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-07-10 16:30:27', 3, 1002001012, '访问令牌已过期', '2019-07-10 16:30:27');
INSERT INTO `access_log` VALUES (51980, '65.3607.15627474378063513', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-07-10 16:30:38', 140, 0, '', '2019-07-10 16:30:38');
INSERT INTO `access_log` VALUES (51981, '65.52.15627474382581747', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-07-10 16:30:38', 9, 0, '', '2019-07-10 16:30:38');
INSERT INTO `access_log` VALUES (51982, '65.54.15627474382631671', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-07-10 16:30:38', 9, 2001001000, '服务端发生异常', '2019-07-10 16:30:38');
INSERT INTO `access_log` VALUES (51983, '65.47.15627474382701701', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-07-10 16:30:38', 8, 0, '', '2019-07-10 16:30:38');
INSERT INTO `access_log` VALUES (51984, '65.46.15627474602071771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:31:00', 9, 0, '', '2019-07-10 16:31:00');
INSERT INTO `access_log` VALUES (51985, '65.50.15627474602061739', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:31:00', 8, 0, '', '2019-07-10 16:31:00');
INSERT INTO `access_log` VALUES (51986, '65.49.15627474602071711', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.50.114.226', '2019-07-10 16:31:00', 10, 2001001000, '服务端发生异常', '2019-07-10 16:31:00');
INSERT INTO `access_log` VALUES (51987, '65.3607.15627474741223515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-07-10 16:31:14', 41, 0, '', '2019-07-10 16:31:14');
INSERT INTO `access_log` VALUES (51988, '65.47.15627474741421703', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-07-10 16:31:14', 21, 0, '', '2019-07-10 16:31:14');
INSERT INTO `access_log` VALUES (51989, '65.52.15627474741241749', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.108.86.138', '2019-07-10 16:31:14', 48, 2001001000, '服务端发生异常', '2019-07-10 16:31:14');
INSERT INTO `access_log` VALUES (51990, '59.71.15627476344519999', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:33:54', 4, 0, '', '2019-07-10 16:33:54');
INSERT INTO `access_log` VALUES (51991, '59.75.15627476344510007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:33:54', 17, 2001001000, '服务端发生异常', '2019-07-10 16:33:54');
INSERT INTO `access_log` VALUES (51992, '64.79.15627476390300159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:33:59', 2, 0, '', '2019-07-10 16:33:59');
INSERT INTO `access_log` VALUES (51993, '64.84.15627476391660153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:33:59', 2, 0, '', '2019-07-10 16:33:59');
INSERT INTO `access_log` VALUES (51994, '64.82.15627476405160173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:01', 2, 0, '', '2019-07-10 16:34:01');
INSERT INTO `access_log` VALUES (51995, '64.81.15627476411250147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:01', 2, 0, '', '2019-07-10 16:34:01');
INSERT INTO `access_log` VALUES (51996, '64.83.15627476416590157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:02', 2, 0, '', '2019-07-10 16:34:02');
INSERT INTO `access_log` VALUES (51997, '64.85.15627476420440169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:02', 1, 0, '', '2019-07-10 16:34:02');
INSERT INTO `access_log` VALUES (51998, '64.80.15627476423370165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:02', 2, 0, '', '2019-07-10 16:34:02');
INSERT INTO `access_log` VALUES (51999, '64.78.15627476478510163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:08', 2, 0, '', '2019-07-10 16:34:08');
INSERT INTO `access_log` VALUES (52000, '64.77.15627476479770141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:08', 2, 0, '', '2019-07-10 16:34:08');
INSERT INTO `access_log` VALUES (52001, '59.72.15627476494889995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:09', 3, 0, '', '2019-07-10 16:34:09');
INSERT INTO `access_log` VALUES (52002, '59.78.15627476494889995', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:09', 19, 2001001000, '服务端发生异常', '2019-07-10 16:34:10');
INSERT INTO `access_log` VALUES (52003, '59.77.15627476562879987', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:16', 2, 0, '', '2019-07-10 16:34:16');
INSERT INTO `access_log` VALUES (52004, '59.80.15627476562879979', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:16', 13, 2001001000, '服务端发生异常', '2019-07-10 16:34:16');
INSERT INTO `access_log` VALUES (52005, '64.79.15627476567040161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:17', 2, 0, '', '2019-07-10 16:34:17');
INSERT INTO `access_log` VALUES (52006, '64.84.15627476567950155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:17', 2, 0, '', '2019-07-10 16:34:17');
INSERT INTO `access_log` VALUES (52007, '59.73.15627476574090005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:17', 2, 0, '', '2019-07-10 16:34:17');
INSERT INTO `access_log` VALUES (52008, '59.76.15627476574109991', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:34:17', 37, 2001001000, '服务端发生异常', '2019-07-10 16:34:17');
INSERT INTO `access_log` VALUES (52009, '65.47.15627478917751709', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:38:12', 1, 1002001015, '账号未登陆', '2019-07-10 16:38:12');
INSERT INTO `access_log` VALUES (52010, '65.52.15627478917771755', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:38:12', 0, 1002001015, '账号未登陆', '2019-07-10 16:38:12');
INSERT INTO `access_log` VALUES (52011, '65.54.15627478917881679', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:38:12', 1, 1002001015, '账号未登陆', '2019-07-10 16:38:12');
INSERT INTO `access_log` VALUES (52012, '65.53.15627478945431733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:38:15', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 16:38:15');
INSERT INTO `access_log` VALUES (52013, '65.46.15627479061551779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:38:26', 188, 0, '', '2019-07-10 16:38:26');
INSERT INTO `access_log` VALUES (52014, '65.49.15627479066151719', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:38:27', 10, 0, '', '2019-07-10 16:38:27');
INSERT INTO `access_log` VALUES (52015, '65.50.15627479066221747', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:38:27', 9, 2001001000, '服务端发生异常', '2019-07-10 16:38:27');
INSERT INTO `access_log` VALUES (52016, '65.45.15627479066311715', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.49.193.181', '2019-07-10 16:38:27', 9, 0, '', '2019-07-10 16:38:27');
INSERT INTO `access_log` VALUES (52017, '65.51.15627484324541791', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:47:12', 11, 0, '', '2019-07-10 16:47:12');
INSERT INTO `access_log` VALUES (52018, '65.46.15627484324541787', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:47:12', 13, 2001001000, '服务端发生异常', '2019-07-10 16:47:12');
INSERT INTO `access_log` VALUES (52019, '65.49.15627484324641727', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:47:12', 8, 0, '', '2019-07-10 16:47:12');
INSERT INTO `access_log` VALUES (52020, '59.78.15627484821490007', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:48:02', 2, 0, '', '2019-07-10 16:48:02');
INSERT INTO `access_log` VALUES (52021, '59.77.15627484821499999', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 16:48:02', 12, 2001001000, '服务端发生异常', '2019-07-10 16:48:02');
INSERT INTO `access_log` VALUES (52022, '59.74.15627495636440031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 17:06:04', 3, 0, '', '2019-07-10 17:06:04');
INSERT INTO `access_log` VALUES (52023, '59.76.15627495636440017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '120.32.92.134', '2019-07-10 17:06:04', 13, 2001001000, '服务端发生异常', '2019-07-10 17:06:04');
INSERT INTO `access_log` VALUES (52024, '65.46.15627495942981803', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Mobile Safari/537.36', '120.32.92.134', '2019-07-10 17:06:34', 10, 0, '', '2019-07-10 17:06:34');
INSERT INTO `access_log` VALUES (52025, '65.49.15627495942991743', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Mobile Safari/537.36', '120.32.92.134', '2019-07-10 17:06:34', 10, 0, '', '2019-07-10 17:06:34');
INSERT INTO `access_log` VALUES (52026, '65.51.15627495942981807', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Mobile Safari/537.36', '120.32.92.134', '2019-07-10 17:06:34', 12, 2001001000, '服务端发生异常', '2019-07-10 17:06:34');
INSERT INTO `access_log` VALUES (52027, '59.76.15627496733900019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:07:53', 3, 0, '', '2019-07-10 17:07:53');
INSERT INTO `access_log` VALUES (52028, '59.74.15627496733910033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:07:53', 16, 2001001000, '服务端发生异常', '2019-07-10 17:07:53');
INSERT INTO `access_log` VALUES (52029, '64.76.15627496798800181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:08:00', 11, 0, '', '2019-07-10 17:08:00');
INSERT INTO `access_log` VALUES (52030, '64.78.15627496799850191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:08:00', 3, 0, '', '2019-07-10 17:08:00');
INSERT INTO `access_log` VALUES (52031, '59.77.15627497356130017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-07-10 17:08:56', 22, 2001001000, '服务端发生异常', '2019-07-10 17:08:56');
INSERT INTO `access_log` VALUES (52032, '59.78.15627497356120025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.108.127.98', '2019-07-10 17:08:56', 2, 0, '', '2019-07-10 17:08:56');
INSERT INTO `access_log` VALUES (52033, '65.46.15627497887701805', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:09:49', 0, 1002001015, '账号未登陆', '2019-07-10 17:09:49');
INSERT INTO `access_log` VALUES (52034, '65.45.15627497887701743', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:09:49', 0, 1002001015, '账号未登陆', '2019-07-10 17:09:49');
INSERT INTO `access_log` VALUES (52035, '65.51.15627497887741811', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:09:49', 1, 1002001015, '账号未登陆', '2019-07-10 17:09:49');
INSERT INTO `access_log` VALUES (52036, '65.52.15627498004191785', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:10:00', 153, 0, '', '2019-07-10 17:10:01');
INSERT INTO `access_log` VALUES (52037, '65.47.15627498007211739', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:10:01', 17, 0, '', '2019-07-10 17:10:01');
INSERT INTO `access_log` VALUES (52038, '65.49.15627498007241749', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:10:01', 18, 2001001000, '服务端发生异常', '2019-07-10 17:10:01');
INSERT INTO `access_log` VALUES (52039, '65.50.15627498007371775', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:10:01', 8, 0, '', '2019-07-10 17:10:01');
INSERT INTO `access_log` VALUES (52040, '65.51.15627498267331813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:10:27', 10, 0, '', '2019-07-10 17:10:27');
INSERT INTO `access_log` VALUES (52041, '65.46.15627498267351807', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:10:27', 10, 2001001000, '服务端发生异常', '2019-07-10 17:10:27');
INSERT INTO `access_log` VALUES (52042, '65.45.15627498267381745', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:10:27', 9, 0, '', '2019-07-10 17:10:27');
INSERT INTO `access_log` VALUES (52043, '65.49.15627498724561751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:11:12', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 17:11:12');
INSERT INTO `access_log` VALUES (52044, '65.54.15627498839421709', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:11:24', 89, 0, '', '2019-07-10 17:11:24');
INSERT INTO `access_log` VALUES (52045, '65.53.15627498841681765', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:11:24', 9, 0, '', '2019-07-10 17:11:24');
INSERT INTO `access_log` VALUES (52046, '65.51.15627498841751815', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:11:24', 10, 2001001000, '服务端发生异常', '2019-07-10 17:11:24');
INSERT INTO `access_log` VALUES (52047, '65.45.15627498841771747', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:11:24', 9, 0, '', '2019-07-10 17:11:24');
INSERT INTO `access_log` VALUES (52048, '65.46.15627498937881809', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:11:34', 10, 0, '', '2019-07-10 17:11:34');
INSERT INTO `access_log` VALUES (52049, '65.52.15627498937941789', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:11:34', 8, 0, '', '2019-07-10 17:11:34');
INSERT INTO `access_log` VALUES (52050, '65.3607.15627498937933555', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.172.240.228', '2019-07-10 17:11:34', 9, 2001001000, '服务端发生异常', '2019-07-10 17:11:34');
INSERT INTO `access_log` VALUES (52051, '59.78.15627521022650057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '42.120.74.106', '2019-07-10 17:48:22', 10, 0, '', '2019-07-10 17:48:22');
INSERT INTO `access_log` VALUES (52052, '59.77.15627521022650049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '42.120.74.106', '2019-07-10 17:48:22', 18, 2001001000, '服务端发生异常', '2019-07-10 17:48:22');
INSERT INTO `access_log` VALUES (52053, '64.84.15627521076220215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '42.120.74.106', '2019-07-10 17:48:28', 13, 0, '', '2019-07-10 17:48:28');
INSERT INTO `access_log` VALUES (52054, '64.82.15627521077460235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '42.120.74.106', '2019-07-10 17:48:28', 3, 0, '', '2019-07-10 17:48:28');
INSERT INTO `access_log` VALUES (52055, '65.52.15627521528301821', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.185', '2019-07-10 17:49:13', 0, 1002001015, '账号未登陆', '2019-07-10 17:49:13');
INSERT INTO `access_log` VALUES (52056, '65.3607.15627521528293589', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.185', '2019-07-10 17:49:13', 0, 1002001015, '账号未登陆', '2019-07-10 17:49:13');
INSERT INTO `access_log` VALUES (52057, '65.46.15627521528431843', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.185', '2019-07-10 17:49:13', 0, 1002001015, '账号未登陆', '2019-07-10 17:49:13');
INSERT INTO `access_log` VALUES (52058, '65.50.15627521548861809', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.185', '2019-07-10 17:49:15', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 17:49:15');
INSERT INTO `access_log` VALUES (52059, '65.47.15627521667711775', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.185', '2019-07-10 17:49:27', 318, 0, '', '2019-07-10 17:49:27');
INSERT INTO `access_log` VALUES (52060, '65.45.15627521674651781', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.185', '2019-07-10 17:49:27', 12, 0, '', '2019-07-10 17:49:27');
INSERT INTO `access_log` VALUES (52061, '65.53.15627521674711797', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.185', '2019-07-10 17:49:27', 10, 2001001000, '服务端发生异常', '2019-07-10 17:49:27');
INSERT INTO `access_log` VALUES (52062, '65.54.15627521674721745', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.185', '2019-07-10 17:49:27', 10, 0, '', '2019-07-10 17:49:27');
INSERT INTO `access_log` VALUES (52063, '65.3607.15627521837003591', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.185', '2019-07-10 17:49:44', 10, 0, '', '2019-07-10 17:49:44');
INSERT INTO `access_log` VALUES (52064, '65.52.15627521837091823', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.185', '2019-07-10 17:49:44', 11, 2001001000, '服务端发生异常', '2019-07-10 17:49:44');
INSERT INTO `access_log` VALUES (52065, '65.46.15627521837131845', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.185', '2019-07-10 17:49:44', 9, 0, '', '2019-07-10 17:49:44');
INSERT INTO `access_log` VALUES (52066, '65.51.15627527250871857', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 17:58:45', 1, 1002001015, '账号未登陆', '2019-07-10 17:58:45');
INSERT INTO `access_log` VALUES (52067, '65.3607.15627527250893599', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 17:58:45', 0, 1002001015, '账号未登陆', '2019-07-10 17:58:45');
INSERT INTO `access_log` VALUES (52068, '65.52.15627527250961831', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 17:58:45', 0, 1002001015, '账号未登陆', '2019-07-10 17:58:45');
INSERT INTO `access_log` VALUES (52069, '65.46.15627527273041853', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 17:58:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 17:58:47');
INSERT INTO `access_log` VALUES (52070, '65.50.15627527313971819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 17:58:51', 68, 0, '', '2019-07-10 17:58:51');
INSERT INTO `access_log` VALUES (52071, '65.49.15627527317611791', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 17:58:52', 10, 0, '', '2019-07-10 17:58:52');
INSERT INTO `access_log` VALUES (52072, '65.47.15627527317611785', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 17:58:52', 19, 2001001000, '服务端发生异常', '2019-07-10 17:58:52');
INSERT INTO `access_log` VALUES (52073, '65.53.15627527317641807', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 17:58:52', 17, 0, '', '2019-07-10 17:58:52');
INSERT INTO `access_log` VALUES (52074, '65.52.15627527561901833', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 17:59:16', 26, 0, '', '2019-07-10 17:59:16');
INSERT INTO `access_log` VALUES (52075, '65.51.15627527561891859', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 17:59:16', 27, 0, '', '2019-07-10 17:59:16');
INSERT INTO `access_log` VALUES (52076, '65.3607.15627527561893601', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 17:59:16', 29, 2001001000, '服务端发生异常', '2019-07-10 17:59:16');
INSERT INTO `access_log` VALUES (52077, '65.46.15627527575231855', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 17:59:18', 16, 0, '', '2019-07-10 17:59:18');
INSERT INTO `access_log` VALUES (52078, '65.50.15627527575251821', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 17:59:18', 18, 0, '', '2019-07-10 17:59:18');
INSERT INTO `access_log` VALUES (52079, '65.49.15627527575261793', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 17:59:18', 18, 2001001000, '服务端发生异常', '2019-07-10 17:59:18');
INSERT INTO `access_log` VALUES (52080, '65.53.15627527658331809', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '209.146.24.206', '2019-07-10 17:59:26', 0, 1002001015, '账号未登陆', '2019-07-10 17:59:26');
INSERT INTO `access_log` VALUES (52081, '65.54.15627527658361757', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '209.146.24.206', '2019-07-10 17:59:26', 0, 1002001015, '账号未登陆', '2019-07-10 17:59:26');
INSERT INTO `access_log` VALUES (52082, '65.45.15627527658391793', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '209.146.24.206', '2019-07-10 17:59:26', 0, 1002001015, '账号未登陆', '2019-07-10 17:59:26');
INSERT INTO `access_log` VALUES (52083, '65.52.15627527774351835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '209.146.24.206', '2019-07-10 17:59:37', 80, 0, '', '2019-07-10 17:59:38');
INSERT INTO `access_log` VALUES (52084, '65.51.15627527778371861', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '209.146.24.206', '2019-07-10 17:59:38', 9, 0, '', '2019-07-10 17:59:38');
INSERT INTO `access_log` VALUES (52085, '65.3607.15627527778403603', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '209.146.24.206', '2019-07-10 17:59:38', 9, 0, '', '2019-07-10 17:59:38');
INSERT INTO `access_log` VALUES (52086, '65.50.15627527778421823', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '209.146.24.206', '2019-07-10 17:59:38', 9, 2001001000, '服务端发生异常', '2019-07-10 17:59:38');
INSERT INTO `access_log` VALUES (52087, '65.53.15627555100701847', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3815.0 Safari/537.36', '113.116.157.159', '2019-07-10 18:45:10', 1, 1002001015, '账号未登陆', '2019-07-10 18:45:10');
INSERT INTO `access_log` VALUES (52088, '65.45.15627555100701831', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3815.0 Safari/537.36', '113.116.157.159', '2019-07-10 18:45:10', 1, 1002001015, '账号未登陆', '2019-07-10 18:45:10');
INSERT INTO `access_log` VALUES (52089, '65.54.15627555100721795', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3815.0 Safari/537.36', '113.116.157.159', '2019-07-10 18:45:10', 0, 1002001015, '账号未登陆', '2019-07-10 18:45:10');
INSERT INTO `access_log` VALUES (52090, '65.52.15627555142031873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3815.0 Safari/537.36', '113.116.157.159', '2019-07-10 18:45:14', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 18:45:14');
INSERT INTO `access_log` VALUES (52091, '65.3607.15627555198683641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3815.0 Safari/537.36', '113.116.157.159', '2019-07-10 18:45:20', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 18:45:20');
INSERT INTO `access_log` VALUES (52092, '65.50.15627555321891861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3815.0 Safari/537.36', '113.116.157.159', '2019-07-10 18:45:32', 72, 0, '', '2019-07-10 18:45:32');
INSERT INTO `access_log` VALUES (52093, '65.46.15627555324981895', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3815.0 Safari/537.36', '113.116.157.159', '2019-07-10 18:45:32', 14, 0, '', '2019-07-10 18:45:33');
INSERT INTO `access_log` VALUES (52094, '65.49.15627555325021833', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3815.0 Safari/537.36', '113.116.157.159', '2019-07-10 18:45:33', 11, 2001001000, '服务端发生异常', '2019-07-10 18:45:33');
INSERT INTO `access_log` VALUES (52095, '65.47.15627555325051827', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3815.0 Safari/537.36', '113.116.157.159', '2019-07-10 18:45:33', 10, 0, '', '2019-07-10 18:45:33');
INSERT INTO `access_log` VALUES (52096, '59.77.15627576197740123', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.57.196.185', '2019-07-10 19:20:20', 11, 0, '', '2019-07-10 19:20:20');
INSERT INTO `access_log` VALUES (52097, '59.78.15627576197740131', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.57.196.185', '2019-07-10 19:20:20', 15, 2001001000, '服务端发生异常', '2019-07-10 19:20:20');
INSERT INTO `access_log` VALUES (52098, '64.84.15627576244980289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.57.196.185', '2019-07-10 19:20:24', 12, 0, '', '2019-07-10 19:20:25');
INSERT INTO `access_log` VALUES (52099, '64.82.15627576246370309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.57.196.185', '2019-07-10 19:20:25', 3, 0, '', '2019-07-10 19:20:25');
INSERT INTO `access_log` VALUES (52100, '64.81.15627576264210283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.57.196.185', '2019-07-10 19:20:26', 2, 0, '', '2019-07-10 19:20:26');
INSERT INTO `access_log` VALUES (52101, '59.80.15627576287370115', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.57.196.185', '2019-07-10 19:20:29', 10, 2001001000, '服务端发生异常', '2019-07-10 19:20:29');
INSERT INTO `access_log` VALUES (52102, '59.73.15627576287380141', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '59.57.196.185', '2019-07-10 19:20:29', 73, 0, '', '2019-07-10 19:20:29');
INSERT INTO `access_log` VALUES (52103, '64.80.15627587022630315', 0, 2, 'product-application', '/product-api/admins/spu/add', 'cid=反正我是信了&description=你就说强不强 MQ 骚操作&name=厮大牛逼&picUrls=http://www.iocoder.cn&sellPoint=各种 MQ 骚操作&skuStr=[{\"attrs\": [1,3 ], \"price\": 1, \"quantity\": 100, \"picUrl\": \"http://www.iocoder.cn\"}]&visible=true', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:38:22', 1, 1002001015, '账号未登陆', '2019-07-10 19:38:22');
INSERT INTO `access_log` VALUES (52104, '64.79.15627587199370311', 0, 2, 'product-application', '/product-api/admins/spu/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:38:40', 1, 1002001015, '账号未登陆', '2019-07-10 19:38:40');
INSERT INTO `access_log` VALUES (52105, '64.84.15627587279080305', 0, 2, 'product-application', '/product-api/admins/spu/add', 'cid=反正我是信了&description=你就说强不强 MQ 骚操作&name=厮大牛逼&picUrls=http://www.iocoder.cn&sellPoint=各种 MQ 骚操作&skuStr=[{\"attrs\": [1,3 ], \"price\": 1, \"quantity\": 100, \"picUrl\": \"http://www.iocoder.cn\"}]&visible=true', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:38:48', 1, 1002001015, '账号未登陆', '2019-07-10 19:38:48');
INSERT INTO `access_log` VALUES (52106, '59.77.15627589163450141', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:41:56', 3, 0, '', '2019-07-10 19:41:56');
INSERT INTO `access_log` VALUES (52107, '59.78.15627589163510149', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:41:56', 32, 2001001000, '服务端发生异常', '2019-07-10 19:41:56');
INSERT INTO `access_log` VALUES (52108, '66.54.15627589497698155', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18296874638', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:42:30', 168, 0, '', '2019-07-10 19:42:30');
INSERT INTO `access_log` VALUES (52109, '66.50.15627589520238149', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18296874638&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:42:32', 210, 0, '', '2019-07-10 19:42:32');
INSERT INTO `access_log` VALUES (52110, '66.53.15627589583658155', 165, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:42:38', 6, 0, '', '2019-07-10 19:42:38');
INSERT INTO `access_log` VALUES (52111, '66.49.15627589601818167', 165, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:42:40', 6, 0, '', '2019-07-10 19:42:40');
INSERT INTO `access_log` VALUES (52112, '66.52.15627589648048139', 165, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:42:45', 6, 0, '', '2019-07-10 19:42:45');
INSERT INTO `access_log` VALUES (52113, '66.56.15627589657498159', 165, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:42:46', 6, 0, '', '2019-07-10 19:42:46');
INSERT INTO `access_log` VALUES (52114, '66.51.15627589680508173', 165, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:42:48', 5, 0, '', '2019-07-10 19:42:48');
INSERT INTO `access_log` VALUES (52115, '64.78.15627589689850317', 165, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:42:49', 8, 0, '', '2019-07-10 19:42:49');
INSERT INTO `access_log` VALUES (52116, '64.79.15627589691900317', 165, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:42:49', 5, 0, '', '2019-07-10 19:42:49');
INSERT INTO `access_log` VALUES (52117, '64.82.15627589730950331', 165, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:42:53', 8, 0, '', '2019-07-10 19:42:53');
INSERT INTO `access_log` VALUES (52118, '64.81.15627589732010301', 165, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:42:53', 5, 0, '', '2019-07-10 19:42:53');
INSERT INTO `access_log` VALUES (52119, '59.72.15627589741480151', 165, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:42:54', 7, 0, '', '2019-07-10 19:42:54');
INSERT INTO `access_log` VALUES (52120, '59.79.15627589741430155', 165, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-10 19:42:54', 19, 2001001000, '服务端发生异常', '2019-07-10 19:42:54');
INSERT INTO `access_log` VALUES (52121, '65.46.15627600526711955', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '209.146.24.206', '2019-07-10 20:00:53', 6, 1002001012, '访问令牌已过期', '2019-07-10 20:00:53');
INSERT INTO `access_log` VALUES (52122, '65.51.15627600526711959', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '209.146.24.206', '2019-07-10 20:00:53', 12, 1002001012, '访问令牌已过期', '2019-07-10 20:00:53');
INSERT INTO `access_log` VALUES (52123, '65.49.15627600526721893', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '209.146.24.206', '2019-07-10 20:00:53', 12, 1002001012, '访问令牌已过期', '2019-07-10 20:00:53');
INSERT INTO `access_log` VALUES (52124, '65.54.15627600556881859', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '209.146.24.206', '2019-07-10 20:00:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 20:00:56');
INSERT INTO `access_log` VALUES (52125, '59.75.15627601318540179', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.19.95.9', '2019-07-10 20:02:12', 3, 0, '', '2019-07-10 20:02:12');
INSERT INTO `access_log` VALUES (52126, '59.79.15627601318550171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.19.95.9', '2019-07-10 20:02:12', 12, 2001001000, '服务端发生异常', '2019-07-10 20:02:12');
INSERT INTO `access_log` VALUES (52127, '65.46.15627601379051957', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.19.95.9', '2019-07-10 20:02:18', 0, 1002001015, '账号未登陆', '2019-07-10 20:02:18');
INSERT INTO `access_log` VALUES (52128, '65.49.15627601379091895', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.19.95.9', '2019-07-10 20:02:18', 0, 1002001015, '账号未登陆', '2019-07-10 20:02:18');
INSERT INTO `access_log` VALUES (52129, '65.51.15627601379181961', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.19.95.9', '2019-07-10 20:02:18', 0, 1002001015, '账号未登陆', '2019-07-10 20:02:18');
INSERT INTO `access_log` VALUES (52130, '65.50.15627602262831925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.19.95.9', '2019-07-10 20:03:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 20:03:46');
INSERT INTO `access_log` VALUES (52131, '65.51.15627602296311963', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.19.95.9', '2019-07-10 20:03:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 20:03:50');
INSERT INTO `access_log` VALUES (52132, '59.71.15627602354800173', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.19.95.9', '2019-07-10 20:03:55', 3, 0, '', '2019-07-10 20:03:55');
INSERT INTO `access_log` VALUES (52133, '59.79.15627602354810173', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.19.95.9', '2019-07-10 20:03:55', 11, 2001001000, '服务端发生异常', '2019-07-10 20:03:55');
INSERT INTO `access_log` VALUES (52134, '65.45.15627604377541899', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 20:07:18', 5, 1002001012, '访问令牌已过期', '2019-07-10 20:07:18');
INSERT INTO `access_log` VALUES (52135, '65.53.15627604377531917', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 20:07:18', 6, 1002001012, '访问令牌已过期', '2019-07-10 20:07:18');
INSERT INTO `access_log` VALUES (52136, '65.52.15627604377561943', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 20:07:18', 4, 1002001012, '访问令牌已过期', '2019-07-10 20:07:18');
INSERT INTO `access_log` VALUES (52137, '65.3607.15627604436263709', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 20:07:24', 91, 0, '', '2019-07-10 20:07:24');
INSERT INTO `access_log` VALUES (52138, '65.51.15627604440121967', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 20:07:24', 10, 0, '', '2019-07-10 20:07:24');
INSERT INTO `access_log` VALUES (52139, '65.46.15627604440191963', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 20:07:24', 10, 2001001000, '服务端发生异常', '2019-07-10 20:07:24');
INSERT INTO `access_log` VALUES (52140, '65.49.15627604440231901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '209.146.24.206', '2019-07-10 20:07:24', 9, 0, '', '2019-07-10 20:07:24');
INSERT INTO `access_log` VALUES (52141, '59.71.15627629045830211', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.118.131', '2019-07-10 20:48:25', 10, 0, '', '2019-07-10 20:48:25');
INSERT INTO `access_log` VALUES (52142, '59.76.15627629045830201', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.118.131', '2019-07-10 20:48:25', 15, 2001001000, '服务端发生异常', '2019-07-10 20:48:25');
INSERT INTO `access_log` VALUES (52143, '59.75.15627629123660217', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.118.131', '2019-07-10 20:48:32', 14, 0, '', '2019-07-10 20:48:32');
INSERT INTO `access_log` VALUES (52144, '59.79.15627629123660209', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.118.131', '2019-07-10 20:48:32', 19, 2001001000, '服务端发生异常', '2019-07-10 20:48:32');
INSERT INTO `access_log` VALUES (52145, '65.54.15627667461061951', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.228.0.224', '2019-07-10 21:52:26', 1, 1002001015, '账号未登陆', '2019-07-10 21:52:26');
INSERT INTO `access_log` VALUES (52146, '65.47.15627667461061983', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.228.0.224', '2019-07-10 21:52:26', 1, 1002001015, '账号未登陆', '2019-07-10 21:52:26');
INSERT INTO `access_log` VALUES (52147, '65.52.15627667461222029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.228.0.224', '2019-07-10 21:52:26', 1, 1002001015, '账号未登陆', '2019-07-10 21:52:26');
INSERT INTO `access_log` VALUES (52148, '65.45.15627667506101985', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.228.0.224', '2019-07-10 21:52:31', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 21:52:31');
INSERT INTO `access_log` VALUES (52149, '65.53.15627667556582003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.228.0.224', '2019-07-10 21:52:36', 68, 0, '', '2019-07-10 21:52:36');
INSERT INTO `access_log` VALUES (52150, '65.50.15627667559652015', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.228.0.224', '2019-07-10 21:52:36', 23, 0, '', '2019-07-10 21:52:36');
INSERT INTO `access_log` VALUES (52151, '65.51.15627667559682053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.228.0.224', '2019-07-10 21:52:36', 22, 0, '', '2019-07-10 21:52:36');
INSERT INTO `access_log` VALUES (52152, '65.3607.15627667559653795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.228.0.224', '2019-07-10 21:52:36', 26, 2001001000, '服务端发生异常', '2019-07-10 21:52:36');
INSERT INTO `access_log` VALUES (52153, '65.46.15627667664482049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.228.0.224', '2019-07-10 21:52:46', 10, 0, '', '2019-07-10 21:52:46');
INSERT INTO `access_log` VALUES (52154, '65.52.15627667664492031', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.228.0.224', '2019-07-10 21:52:46', 10, 0, '', '2019-07-10 21:52:46');
INSERT INTO `access_log` VALUES (52155, '65.47.15627667664491985', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.228.0.224', '2019-07-10 21:52:46', 12, 2001001000, '服务端发生异常', '2019-07-10 21:52:46');
INSERT INTO `access_log` VALUES (52156, '65.53.15627669535392007', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.17.232.89', '2019-07-10 21:55:54', 1, 1002001015, '账号未登陆', '2019-07-10 21:55:54');
INSERT INTO `access_log` VALUES (52157, '65.51.15627669535402057', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.17.232.89', '2019-07-10 21:55:54', 0, 1002001015, '账号未登陆', '2019-07-10 21:55:54');
INSERT INTO `access_log` VALUES (52158, '65.50.15627669535452019', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.17.232.89', '2019-07-10 21:55:54', 0, 1002001015, '账号未登陆', '2019-07-10 21:55:54');
INSERT INTO `access_log` VALUES (52159, '65.49.15627669557371991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.17.232.89', '2019-07-10 21:55:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 21:55:56');
INSERT INTO `access_log` VALUES (52160, '65.46.15627669673682053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuama&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.17.232.89', '2019-07-10 21:56:07', 66, 0, '', '2019-07-10 21:56:07');
INSERT INTO `access_log` VALUES (52161, '65.52.15627669676592035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.17.232.89', '2019-07-10 21:56:08', 9, 0, '', '2019-07-10 21:56:08');
INSERT INTO `access_log` VALUES (52162, '65.47.15627669676591989', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.17.232.89', '2019-07-10 21:56:08', 10, 2001001000, '服务端发生异常', '2019-07-10 21:56:08');
INSERT INTO `access_log` VALUES (52163, '65.54.15627669676691957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '27.17.232.89', '2019-07-10 21:56:08', 8, 0, '', '2019-07-10 21:56:08');
INSERT INTO `access_log` VALUES (52164, '65.47.15627672179721993', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:00:18', 0, 1002001015, '账号未登陆', '2019-07-10 22:00:18');
INSERT INTO `access_log` VALUES (52165, '65.54.15627672179721961', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:00:18', 0, 1002001015, '账号未登陆', '2019-07-10 22:00:18');
INSERT INTO `access_log` VALUES (52166, '65.52.15627672179722039', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:00:18', 0, 1002001015, '账号未登陆', '2019-07-10 22:00:18');
INSERT INTO `access_log` VALUES (52167, '65.45.15627672228981995', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:00:23', 0, 1002001015, '账号未登陆', '2019-07-10 22:00:23');
INSERT INTO `access_log` VALUES (52168, '65.53.15627672229142013', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:00:23', 0, 1002001015, '账号未登陆', '2019-07-10 22:00:23');
INSERT INTO `access_log` VALUES (52169, '65.51.15627672229142063', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:00:23', 0, 1002001015, '账号未登陆', '2019-07-10 22:00:23');
INSERT INTO `access_log` VALUES (52170, '65.3607.15627672290663805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:00:29', 196, 0, '', '2019-07-10 22:00:29');
INSERT INTO `access_log` VALUES (52171, '65.46.15627672296322059', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:00:30', 14, 0, '', '2019-07-10 22:00:30');
INSERT INTO `access_log` VALUES (52172, '65.49.15627672296301997', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:00:30', 18, 0, '', '2019-07-10 22:00:30');
INSERT INTO `access_log` VALUES (52173, '65.54.15627672296371963', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:00:30', 17, 2001001000, '服务端发生异常', '2019-07-10 22:00:30');
INSERT INTO `access_log` VALUES (52174, '65.51.15627672554902065', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:00:55', 9, 0, '', '2019-07-10 22:00:56');
INSERT INTO `access_log` VALUES (52175, '65.45.15627672554901997', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:00:55', 11, 2001001000, '服务端发生异常', '2019-07-10 22:00:56');
INSERT INTO `access_log` VALUES (52176, '65.53.15627672555662015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:00:56', 10, 0, '', '2019-07-10 22:00:56');
INSERT INTO `access_log` VALUES (52177, '59.78.15627672879360263', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:01:28', 10, 0, '', '2019-07-10 22:01:28');
INSERT INTO `access_log` VALUES (52178, '59.73.15627672879490273', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:01:28', 13, 2001001000, '服务端发生异常', '2019-07-10 22:01:28');
INSERT INTO `access_log` VALUES (52179, '64.79.15627672951530429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:01:35', 9, 0, '', '2019-07-10 22:01:35');
INSERT INTO `access_log` VALUES (52180, '64.83.15627672953040425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:01:35', 2, 0, '', '2019-07-10 22:01:35');
INSERT INTO `access_log` VALUES (52181, '64.77.15627672972750409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:01:37', 2, 0, '', '2019-07-10 22:01:37');
INSERT INTO `access_log` VALUES (52182, '64.81.15627672980020413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/59.0.3071.104 Safari/537.36', '183.42.34.125', '2019-07-10 22:01:38', 2, 0, '', '2019-07-10 22:01:38');
INSERT INTO `access_log` VALUES (52183, '59.77.15627690194760279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '61.144.117.234', '2019-07-10 22:30:19', 12, 2001001000, '服务端发生异常', '2019-07-10 22:30:19');
INSERT INTO `access_log` VALUES (52184, '59.72.15627690194760289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '61.144.117.234', '2019-07-10 22:30:19', 73, 0, '', '2019-07-10 22:30:20');
INSERT INTO `access_log` VALUES (52185, '64.83.15627690440770449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.144.117.234', '2019-07-10 22:30:44', 2, 0, '', '2019-07-10 22:30:44');
INSERT INTO `access_log` VALUES (52186, '64.78.15627690442240457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.144.117.234', '2019-07-10 22:30:44', 2, 0, '', '2019-07-10 22:30:44');
INSERT INTO `access_log` VALUES (52187, '64.77.15627690463910433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.144.117.234', '2019-07-10 22:30:46', 2, 0, '', '2019-07-10 22:30:46');
INSERT INTO `access_log` VALUES (52188, '64.81.15627690471780437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.144.117.234', '2019-07-10 22:30:47', 2, 0, '', '2019-07-10 22:30:47');
INSERT INTO `access_log` VALUES (52189, '64.84.15627690478350447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.144.117.234', '2019-07-10 22:30:48', 3, 0, '', '2019-07-10 22:30:48');
INSERT INTO `access_log` VALUES (52190, '59.80.15627690492560271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.144.117.234', '2019-07-10 22:30:49', 3, 0, '', '2019-07-10 22:30:49');
INSERT INTO `access_log` VALUES (52191, '59.74.15627690492560299', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.144.117.234', '2019-07-10 22:30:49', 12, 2001001000, '服务端发生异常', '2019-07-10 22:30:49');
INSERT INTO `access_log` VALUES (52192, '59.78.15627691482180289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '183.61.6.243', '2019-07-10 22:32:28', 3, 0, '', '2019-07-10 22:32:28');
INSERT INTO `access_log` VALUES (52193, '59.73.15627691482170299', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '183.61.6.243', '2019-07-10 22:32:28', 13, 2001001000, '服务端发生异常', '2019-07-10 22:32:28');
INSERT INTO `access_log` VALUES (52194, '65.45.15627691599702023', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '183.61.6.243', '2019-07-10 22:32:40', 1, 1002001015, '账号未登陆', '2019-07-10 22:32:40');
INSERT INTO `access_log` VALUES (52195, '65.51.15627691599692091', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '183.61.6.243', '2019-07-10 22:32:40', 1, 1002001015, '账号未登陆', '2019-07-10 22:32:40');
INSERT INTO `access_log` VALUES (52196, '65.53.15627691599752041', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '183.61.6.243', '2019-07-10 22:32:40', 0, 1002001015, '账号未登陆', '2019-07-10 22:32:40');
INSERT INTO `access_log` VALUES (52197, '64.81.15627691649730439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '183.61.6.243', '2019-07-10 22:32:45', 4, 0, '', '2019-07-10 22:32:45');
INSERT INTO `access_log` VALUES (52198, '64.84.15627691651590449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '183.61.6.243', '2019-07-10 22:32:45', 2, 0, '', '2019-07-10 22:32:45');
INSERT INTO `access_log` VALUES (52199, '65.3607.15627691795743833', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '183.61.6.243', '2019-07-10 22:33:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 22:33:00');
INSERT INTO `access_log` VALUES (52200, '65.46.15627691854682087', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '183.61.6.243', '2019-07-10 22:33:05', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 22:33:05');
INSERT INTO `access_log` VALUES (52201, '65.45.15627692694952025', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:34:29', 0, 1002001015, '账号未登陆', '2019-07-10 22:34:29');
INSERT INTO `access_log` VALUES (52202, '65.50.15627692694962055', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:34:29', 0, 1002001015, '账号未登陆', '2019-07-10 22:34:29');
INSERT INTO `access_log` VALUES (52203, '65.3607.15627692694993835', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:34:29', 1, 1002001015, '账号未登陆', '2019-07-10 22:34:30');
INSERT INTO `access_log` VALUES (52204, '65.46.15627692708542089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:34:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 22:34:31');
INSERT INTO `access_log` VALUES (52205, '65.49.15627692732242027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:34:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 22:34:33');
INSERT INTO `access_log` VALUES (52206, '65.52.15627692941882071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:34:54', 85, 0, '', '2019-07-10 22:34:54');
INSERT INTO `access_log` VALUES (52207, '65.51.15627692945002095', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:34:55', 16, 0, '', '2019-07-10 22:34:55');
INSERT INTO `access_log` VALUES (52208, '65.53.15627692945002045', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:34:55', 17, 2001001000, '服务端发生异常', '2019-07-10 22:34:55');
INSERT INTO `access_log` VALUES (52209, '65.3607.15627692945033837', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:34:55', 11, 0, '', '2019-07-10 22:34:55');
INSERT INTO `access_log` VALUES (52210, '65.45.15627693129552027', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:35:13', 9, 0, '', '2019-07-10 22:35:13');
INSERT INTO `access_log` VALUES (52211, '65.46.15627693129572091', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:35:13', 10, 2001001000, '服务端发生异常', '2019-07-10 22:35:13');
INSERT INTO `access_log` VALUES (52212, '65.49.15627693129612029', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:35:13', 9, 0, '', '2019-07-10 22:35:13');
INSERT INTO `access_log` VALUES (52213, '65.47.15627693259982027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:35:26', 332, 0, '', '2019-07-10 22:35:26');
INSERT INTO `access_log` VALUES (52214, '65.52.15627693264992073', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:35:27', 8, 0, '', '2019-07-10 22:35:27');
INSERT INTO `access_log` VALUES (52215, '65.53.15627693265012047', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:35:27', 9, 2001001000, '服务端发生异常', '2019-07-10 22:35:27');
INSERT INTO `access_log` VALUES (52216, '65.51.15627693265032097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:35:27', 8, 0, '', '2019-07-10 22:35:27');
INSERT INTO `access_log` VALUES (52217, '59.76.15627693374150289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:35:37', 3, 0, '', '2019-07-10 22:35:37');
INSERT INTO `access_log` VALUES (52218, '59.79.15627693374150297', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:35:37', 14, 2001001000, '服务端发生异常', '2019-07-10 22:35:37');
INSERT INTO `access_log` VALUES (52219, '64.76.15627693452440451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:35:45', 2, 0, '', '2019-07-10 22:35:45');
INSERT INTO `access_log` VALUES (52220, '64.82.15627693453820471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-10 22:35:45', 2, 0, '', '2019-07-10 22:35:45');
INSERT INTO `access_log` VALUES (52221, '65.47.15627706470022045', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0; SE 2.X MetaSr 1.0) like Gecko', '36.102.228.96', '2019-07-10 22:57:27', 1, 1002001015, '账号未登陆', '2019-07-10 22:57:27');
INSERT INTO `access_log` VALUES (52222, '65.45.15627706470032047', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0; SE 2.X MetaSr 1.0) like Gecko', '36.102.228.96', '2019-07-10 22:57:27', 0, 1002001015, '账号未登陆', '2019-07-10 22:57:27');
INSERT INTO `access_log` VALUES (52223, '65.46.15627706470122113', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0; SE 2.X MetaSr 1.0) like Gecko', '36.102.228.96', '2019-07-10 22:57:27', 0, 1002001015, '账号未登陆', '2019-07-10 22:57:27');
INSERT INTO `access_log` VALUES (52224, '65.3607.15627706528483859', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0; SE 2.X MetaSr 1.0) like Gecko', '36.102.228.96', '2019-07-10 22:57:33', 80, 0, '', '2019-07-10 22:57:33');
INSERT INTO `access_log` VALUES (52225, '65.52.15627706533232093', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0; SE 2.X MetaSr 1.0) like Gecko', '36.102.228.96', '2019-07-10 22:57:33', 102, 2001001000, '服务端发生异常', '2019-07-10 22:57:33');
INSERT INTO `access_log` VALUES (52226, '65.50.15627706533282077', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0; SE 2.X MetaSr 1.0) like Gecko', '36.102.228.96', '2019-07-10 22:57:33', 98, 0, '', '2019-07-10 22:57:33');
INSERT INTO `access_log` VALUES (52227, '65.49.15627706533282049', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0; SE 2.X MetaSr 1.0) like Gecko', '36.102.228.96', '2019-07-10 22:57:33', 98, 0, '', '2019-07-10 22:57:33');
INSERT INTO `access_log` VALUES (52228, '65.54.15627706623112015', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0; SE 2.X MetaSr 1.0) like Gecko', '36.102.228.96', '2019-07-10 22:57:42', 9, 2001001000, '服务端发生异常', '2019-07-10 22:57:42');
INSERT INTO `access_log` VALUES (52229, '65.51.15627706623142117', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0; SE 2.X MetaSr 1.0) like Gecko', '36.102.228.96', '2019-07-10 22:57:42', 9, 0, '', '2019-07-10 22:57:42');
INSERT INTO `access_log` VALUES (52230, '65.47.15627706623182047', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; LCTE; rv:11.0; SE 2.X MetaSr 1.0) like Gecko', '36.102.228.96', '2019-07-10 22:57:42', 7, 0, '', '2019-07-10 22:57:42');
INSERT INTO `access_log` VALUES (52231, '65.3607.15627709996053865', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.82.233.147', '2019-07-10 23:03:20', 0, 1002001015, '账号未登陆', '2019-07-10 23:03:20');
INSERT INTO `access_log` VALUES (52232, '65.50.15627709996062083', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.82.233.147', '2019-07-10 23:03:20', 1, 1002001015, '账号未登陆', '2019-07-10 23:03:20');
INSERT INTO `access_log` VALUES (52233, '65.52.15627709996102099', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.82.233.147', '2019-07-10 23:03:20', 0, 1002001015, '账号未登陆', '2019-07-10 23:03:20');
INSERT INTO `access_log` VALUES (52234, '65.49.15627710019912055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.82.233.147', '2019-07-10 23:03:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 23:03:22');
INSERT INTO `access_log` VALUES (52235, '65.54.15627710476242021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.82.233.147', '2019-07-10 23:04:08', 66, 0, '', '2019-07-10 23:04:08');
INSERT INTO `access_log` VALUES (52236, '65.45.15627710478502055', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.82.233.147', '2019-07-10 23:04:08', 9, 0, '', '2019-07-10 23:04:08');
INSERT INTO `access_log` VALUES (52237, '65.46.15627710478502121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.82.233.147', '2019-07-10 23:04:08', 10, 2001001000, '服务端发生异常', '2019-07-10 23:04:08');
INSERT INTO `access_log` VALUES (52238, '65.3607.15627710478563867', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.82.233.147', '2019-07-10 23:04:08', 9, 0, '', '2019-07-10 23:04:08');
INSERT INTO `access_log` VALUES (52239, '65.49.15627710656212057', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.82.233.147', '2019-07-10 23:04:26', 9, 0, '', '2019-07-10 23:04:26');
INSERT INTO `access_log` VALUES (52240, '65.53.15627710656222075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.82.233.147', '2019-07-10 23:04:26', 10, 2001001000, '服务端发生异常', '2019-07-10 23:04:26');
INSERT INTO `access_log` VALUES (52241, '65.47.15627710656252055', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.82.233.147', '2019-07-10 23:04:26', 8, 0, '', '2019-07-10 23:04:26');
INSERT INTO `access_log` VALUES (52242, '65.54.15627710768012023', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.219.140', '2019-07-10 23:04:37', 0, 1002001015, '账号未登陆', '2019-07-10 23:04:37');
INSERT INTO `access_log` VALUES (52243, '65.51.15627710768012125', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.219.140', '2019-07-10 23:04:37', 0, 1002001015, '账号未登陆', '2019-07-10 23:04:37');
INSERT INTO `access_log` VALUES (52244, '65.46.15627710768042123', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.219.140', '2019-07-10 23:04:37', 0, 1002001015, '账号未登陆', '2019-07-10 23:04:37');
INSERT INTO `access_log` VALUES (52245, '65.3607.15627710835023869', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.219.140', '2019-07-10 23:04:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 23:04:44');
INSERT INTO `access_log` VALUES (52246, '65.52.15627710963642103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.219.140', '2019-07-10 23:04:56', 96, 0, '', '2019-07-10 23:04:56');
INSERT INTO `access_log` VALUES (52247, '65.47.15627710966912057', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.219.140', '2019-07-10 23:04:57', 8, 0, '', '2019-07-10 23:04:57');
INSERT INTO `access_log` VALUES (52248, '65.53.15627710967022077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.219.140', '2019-07-10 23:04:57', 109, 0, '', '2019-07-10 23:04:57');
INSERT INTO `access_log` VALUES (52249, '65.49.15627710966922059', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.219.140', '2019-07-10 23:04:57', 126, 2001001000, '服务端发生异常', '2019-07-10 23:04:57');
INSERT INTO `access_log` VALUES (52250, '59.72.15627716254840325', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.219.140', '2019-07-10 23:13:45', 12, 0, '', '2019-07-10 23:13:45');
INSERT INTO `access_log` VALUES (52251, '59.78.15627716254840323', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.219.140', '2019-07-10 23:13:45', 16, 2001001000, '服务端发生异常', '2019-07-10 23:13:46');
INSERT INTO `access_log` VALUES (52252, '65.50.15627729643092113', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:04', 1, 1002001015, '账号未登陆', '2019-07-10 23:36:04');
INSERT INTO `access_log` VALUES (52253, '65.3607.15627729643093895', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:04', 1, 1002001015, '账号未登陆', '2019-07-10 23:36:04');
INSERT INTO `access_log` VALUES (52254, '65.52.15627729643092129', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:04', 1, 1002001015, '账号未登陆', '2019-07-10 23:36:04');
INSERT INTO `access_log` VALUES (52255, '65.47.15627729663122083', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 23:36:06');
INSERT INTO `access_log` VALUES (52256, '65.53.15627729699872103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 23:36:10');
INSERT INTO `access_log` VALUES (52257, '65.54.15627729709272051', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-10 23:36:11');
INSERT INTO `access_log` VALUES (52258, '65.51.15627729799602153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:20', 112, 0, '', '2019-07-10 23:36:20');
INSERT INTO `access_log` VALUES (52259, '65.46.15627729803312151', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:20', 17, 0, '', '2019-07-10 23:36:20');
INSERT INTO `access_log` VALUES (52260, '65.45.15627729803332085', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:20', 17, 2001001000, '服务端发生异常', '2019-07-10 23:36:20');
INSERT INTO `access_log` VALUES (52261, '65.50.15627729803362115', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:20', 16, 0, '', '2019-07-10 23:36:20');
INSERT INTO `access_log` VALUES (52262, '65.47.15627729853492085', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:25', 9, 0, '', '2019-07-10 23:36:25');
INSERT INTO `access_log` VALUES (52263, '65.49.15627729853492087', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:25', 9, 0, '', '2019-07-10 23:36:25');
INSERT INTO `access_log` VALUES (52264, '65.3607.15627729853493897', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:25', 10, 2001001000, '服务端发生异常', '2019-07-10 23:36:25');
INSERT INTO `access_log` VALUES (52265, '65.53.15627729863572105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:26', 8, 0, '', '2019-07-10 23:36:26');
INSERT INTO `access_log` VALUES (52266, '65.54.15627729863572053', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:26', 9, 2001001000, '服务端发生异常', '2019-07-10 23:36:26');
INSERT INTO `access_log` VALUES (52267, '65.51.15627729863582155', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:26', 7, 0, '', '2019-07-10 23:36:26');
INSERT INTO `access_log` VALUES (52268, '65.50.15627729915512117', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:32', 9, 0, '', '2019-07-10 23:36:32');
INSERT INTO `access_log` VALUES (52269, '65.46.15627729915522153', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:32', 11, 2001001000, '服务端发生异常', '2019-07-10 23:36:32');
INSERT INTO `access_log` VALUES (52270, '65.45.15627729915542087', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.244.56.95', '2019-07-10 23:36:32', 9, 0, '', '2019-07-10 23:36:32');
INSERT INTO `access_log` VALUES (52271, '59.73.15627762692520395', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.109.111.211', '2019-07-11 00:31:09', 11, 0, '', '2019-07-11 00:31:09');
INSERT INTO `access_log` VALUES (52272, '59.80.15627762692530369', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.109.111.211', '2019-07-11 00:31:09', 14, 2001001000, '服务端发生异常', '2019-07-11 00:31:09');
INSERT INTO `access_log` VALUES (52273, '59.71.15627762753760393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.109.111.211', '2019-07-11 00:31:15', 4, 0, '', '2019-07-11 00:31:15');
INSERT INTO `access_log` VALUES (52274, '59.74.15627762753760397', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.109.111.211', '2019-07-11 00:31:15', 13, 2001001000, '服务端发生异常', '2019-07-11 00:31:15');
INSERT INTO `access_log` VALUES (52275, '66.51.15627762829358409', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.109.111.211', '2019-07-11 00:31:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-07-11 00:31:23');
INSERT INTO `access_log` VALUES (52276, '59.77.15627763034040379', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.109.111.211', '2019-07-11 00:31:43', 2, 0, '', '2019-07-11 00:31:43');
INSERT INTO `access_log` VALUES (52277, '59.75.15627763034040399', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.109.111.211', '2019-07-11 00:31:43', 19, 2001001000, '服务端发生异常', '2019-07-11 00:31:43');
INSERT INTO `access_log` VALUES (52278, '65.53.15628012425642483', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.1.3.53', '2019-07-11 07:27:23', 1, 1002001015, '账号未登陆', '2019-07-11 07:27:23');
INSERT INTO `access_log` VALUES (52279, '65.47.15628012425642463', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.1.3.53', '2019-07-11 07:27:23', 1, 1002001015, '账号未登陆', '2019-07-11 07:27:23');
INSERT INTO `access_log` VALUES (52280, '65.54.15628012425812431', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.1.3.53', '2019-07-11 07:27:23', 0, 1002001015, '账号未登陆', '2019-07-11 07:27:23');
INSERT INTO `access_log` VALUES (52281, '65.46.15628012509272531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.1.3.53', '2019-07-11 07:27:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 07:27:31');
INSERT INTO `access_log` VALUES (52282, '65.45.15628012570722465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.1.3.53', '2019-07-11 07:27:37', 90, 0, '', '2019-07-11 07:27:37');
INSERT INTO `access_log` VALUES (52283, '65.50.15628012576172495', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.1.3.53', '2019-07-11 07:27:38', 11, 0, '', '2019-07-11 07:27:38');
INSERT INTO `access_log` VALUES (52284, '65.52.15628012576352511', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.1.3.53', '2019-07-11 07:27:38', 11, 2001001000, '服务端发生异常', '2019-07-11 07:27:38');
INSERT INTO `access_log` VALUES (52285, '65.49.15628012576362467', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.1.3.53', '2019-07-11 07:27:38', 10, 0, '', '2019-07-11 07:27:38');
INSERT INTO `access_log` VALUES (52286, '65.53.15628012760612485', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.1.3.53', '2019-07-11 07:27:56', 8, 0, '', '2019-07-11 07:27:56');
INSERT INTO `access_log` VALUES (52287, '65.47.15628012760712465', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.1.3.53', '2019-07-11 07:27:56', 9, 2001001000, '服务端发生异常', '2019-07-11 07:27:56');
INSERT INTO `access_log` VALUES (52288, '65.51.15628012760772535', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.1.3.53', '2019-07-11 07:27:56', 8, 0, '', '2019-07-11 07:27:56');
INSERT INTO `access_log` VALUES (52289, '65.46.15628014293172535', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.1.3.53', '2019-07-11 07:30:29', 10, 0, '', '2019-07-11 07:30:29');
INSERT INTO `access_log` VALUES (52290, '65.45.15628014293202469', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.1.3.53', '2019-07-11 07:30:29', 10, 2001001000, '服务端发生异常', '2019-07-11 07:30:29');
INSERT INTO `access_log` VALUES (52291, '65.50.15628014293262499', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.1.3.53', '2019-07-11 07:30:29', 9, 0, '', '2019-07-11 07:30:29');
INSERT INTO `access_log` VALUES (52292, '59.78.15628070519270797', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:12', 12, 0, '', '2019-07-11 09:04:12');
INSERT INTO `access_log` VALUES (52293, '59.72.15628070519270799', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:12', 15, 2001001000, '服务端发生异常', '2019-07-11 09:04:12');
INSERT INTO `access_log` VALUES (52294, '65.53.15628070567782565', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:17', 1, 1002001015, '账号未登陆', '2019-07-11 09:04:17');
INSERT INTO `access_log` VALUES (52295, '65.54.15628070567782511', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:17', 1, 1002001015, '账号未登陆', '2019-07-11 09:04:17');
INSERT INTO `access_log` VALUES (52296, '65.51.15628070567782615', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:17', 0, 1002001015, '账号未登陆', '2019-07-11 09:04:17');
INSERT INTO `access_log` VALUES (52297, '64.81.15628070602390945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:20', 14, 0, '', '2019-07-11 09:04:20');
INSERT INTO `access_log` VALUES (52298, '64.84.15628070603550955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:20', 3, 0, '', '2019-07-11 09:04:20');
INSERT INTO `access_log` VALUES (52299, '64.80.15628070612790969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:21', 2, 0, '', '2019-07-11 09:04:21');
INSERT INTO `access_log` VALUES (52300, '64.76.15628070620090955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:22', 2, 0, '', '2019-07-11 09:04:22');
INSERT INTO `access_log` VALUES (52301, '64.82.15628070626300975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:23', 2, 0, '', '2019-07-11 09:04:23');
INSERT INTO `access_log` VALUES (52302, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=手机&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:28', 6, 0, '', '2019-07-11 09:04:28');
INSERT INTO `access_log` VALUES (52303, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=手机', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:28', 10, 0, '', '2019-07-11 09:04:28');
INSERT INTO `access_log` VALUES (52304, '64.79.15628070690570963', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:29', 7, 0, '', '2019-07-11 09:04:29');
INSERT INTO `access_log` VALUES (52305, '66.50.15628070927008797', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13422129567', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:53', 81, 0, '', '2019-07-11 09:04:53');
INSERT INTO `access_log` VALUES (52306, '66.55.15628070990198779', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13422129567&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:04:59', 163, 0, '', '2019-07-11 09:04:59');
INSERT INTO `access_log` VALUES (52307, '66.48.15628071005648807', 166, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:05:01', 8, 0, '', '2019-07-11 09:05:01');
INSERT INTO `access_log` VALUES (52308, '66.49.15628071098588813', 166, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:05:10', 6, 0, '', '2019-07-11 09:05:10');
INSERT INTO `access_log` VALUES (52309, '66.55.15628071598338781', 166, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=13422129567&country=&province=广东省&city=广州市&county=天河区&areaCode=440106&postalCode=&addressDetail=五楼&isDefault=false&address=五楼&areaNo=440106&mobile=13422129567&hasDefault=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:06:00', 98, 2001001000, '服务端发生异常', '2019-07-11 09:06:00');
INSERT INTO `access_log` VALUES (52310, '66.54.15628071620048801', 166, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=13422129567&country=&province=广东省&city=广州市&county=天河区&areaCode=440106&postalCode=&addressDetail=五楼&isDefault=false&address=五楼&areaNo=440106&mobile=13422129567&hasDefault=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:06:02', 107, 2001001000, '服务端发生异常', '2019-07-11 09:06:02');
INSERT INTO `access_log` VALUES (52311, '66.48.15628071647208809', 166, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:06:05', 5, 0, '', '2019-07-11 09:06:05');
INSERT INTO `access_log` VALUES (52312, '66.53.15628071653568801', 166, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:06:05', 5, 0, '', '2019-07-11 09:06:05');
INSERT INTO `access_log` VALUES (52313, '64.82.15628071666710977', 166, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:06:07', 13, 0, '', '2019-07-11 09:06:07');
INSERT INTO `access_log` VALUES (52314, '64.79.15628071721590965', 166, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:06:12', 13, 0, '', '2019-07-11 09:06:12');
INSERT INTO `access_log` VALUES (52315, '65.54.15628071974692513', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:06:37', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 09:06:37');
INSERT INTO `access_log` VALUES (52316, '65.45.15628072034952547', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:06:43', 91, 0, '', '2019-07-11 09:06:44');
INSERT INTO `access_log` VALUES (52317, '65.46.15628072039152615', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:06:44', 246, 0, '', '2019-07-11 09:06:44');
INSERT INTO `access_log` VALUES (52318, '65.49.15628072039192551', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:06:44', 245, 0, '', '2019-07-11 09:06:44');
INSERT INTO `access_log` VALUES (52319, '65.50.15628072039182577', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:06:44', 245, 2001001000, '服务端发生异常', '2019-07-11 09:06:44');
INSERT INTO `access_log` VALUES (52320, '65.53.15628072314162569', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:07:11', 10, 0, '', '2019-07-11 09:07:11');
INSERT INTO `access_log` VALUES (52321, '65.51.15628072314212619', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:07:11', 10, 2001001000, '服务端发生异常', '2019-07-11 09:07:11');
INSERT INTO `access_log` VALUES (52322, '65.54.15628072314212515', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:07:11', 10, 0, '', '2019-07-11 09:07:11');
INSERT INTO `access_log` VALUES (52323, '65.47.15628072347952547', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:07:15', 17, 0, '', '2019-07-11 09:07:15');
INSERT INTO `access_log` VALUES (52324, '65.45.15628072347982549', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:07:15', 17, 2001001000, '服务端发生异常', '2019-07-11 09:07:15');
INSERT INTO `access_log` VALUES (52325, '65.50.15628072348012579', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:07:15', 158, 0, '', '2019-07-11 09:07:15');
INSERT INTO `access_log` VALUES (52326, '65.46.15628072365362617', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:07:17', 9, 0, '', '2019-07-11 09:07:17');
INSERT INTO `access_log` VALUES (52327, '65.49.15628072365392553', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:07:17', 9, 2001001000, '服务端发生异常', '2019-07-11 09:07:17');
INSERT INTO `access_log` VALUES (52328, '65.52.15628072365412597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:07:17', 9, 0, '', '2019-07-11 09:07:17');
INSERT INTO `access_log` VALUES (52329, '65.50.15628073299962581', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:08:50', 10, 0, '', '2019-07-11 09:08:50');
INSERT INTO `access_log` VALUES (52330, '65.52.15628073299982599', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:08:50', 10, 2001001000, '服务端发生异常', '2019-07-11 09:08:50');
INSERT INTO `access_log` VALUES (52331, '65.49.15628073300022555', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:08:50', 16, 0, '', '2019-07-11 09:08:50');
INSERT INTO `access_log` VALUES (52332, '65.46.15628073317812619', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:08:52', 10, 0, '', '2019-07-11 09:08:52');
INSERT INTO `access_log` VALUES (52333, '65.3607.15628073317844363', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:08:52', 10, 2001001000, '服务端发生异常', '2019-07-11 09:08:52');
INSERT INTO `access_log` VALUES (52334, '65.54.15628073317872519', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:08:52', 8, 0, '', '2019-07-11 09:08:52');
INSERT INTO `access_log` VALUES (52335, '59.74.15628075439800815', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.41.163.45', '2019-07-11 09:12:24', 4, 0, '', '2019-07-11 09:12:24');
INSERT INTO `access_log` VALUES (52336, '59.76.15628075439800801', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.41.163.45', '2019-07-11 09:12:24', 18, 2001001000, '服务端发生异常', '2019-07-11 09:12:24');
INSERT INTO `access_log` VALUES (52337, '64.85.15628075521170981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.41.163.45', '2019-07-11 09:12:32', 2, 0, '', '2019-07-11 09:12:32');
INSERT INTO `access_log` VALUES (52338, '64.80.15628075522510977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.41.163.45', '2019-07-11 09:12:32', 1, 0, '', '2019-07-11 09:12:32');
INSERT INTO `access_log` VALUES (52339, '64.76.15628075534030963', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.41.163.45', '2019-07-11 09:12:33', 2, 0, '', '2019-07-11 09:12:33');
INSERT INTO `access_log` VALUES (52340, '64.82.15628075542430983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.41.163.45', '2019-07-11 09:12:34', 2, 0, '', '2019-07-11 09:12:34');
INSERT INTO `access_log` VALUES (52341, '59.77.15628081729910805', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:22:53', 3, 0, '', '2019-07-11 09:22:53');
INSERT INTO `access_log` VALUES (52342, '59.78.15628081729920813', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:22:53', 13, 2001001000, '服务端发生异常', '2019-07-11 09:22:53');
INSERT INTO `access_log` VALUES (52343, '64.85.15628082341640991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:23:54', 2, 0, '', '2019-07-11 09:23:54');
INSERT INTO `access_log` VALUES (52344, '64.80.15628082342550987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:23:54', 2, 0, '', '2019-07-11 09:23:54');
INSERT INTO `access_log` VALUES (52345, '59.74.15628082377230825', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:23:58', 3, 0, '', '2019-07-11 09:23:58');
INSERT INTO `access_log` VALUES (52346, '59.76.15628082377240811', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:23:58', 14, 2001001000, '服务端发生异常', '2019-07-11 09:23:58');
INSERT INTO `access_log` VALUES (52347, '65.50.15628082677782595', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:24:28', 1, 1002001015, '账号未登陆', '2019-07-11 09:24:28');
INSERT INTO `access_log` VALUES (52348, '65.45.15628082677772565', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:24:28', 0, 1002001015, '账号未登陆', '2019-07-11 09:24:28');
INSERT INTO `access_log` VALUES (52349, '65.52.15628082677922613', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:24:28', 1, 1002001015, '账号未登陆', '2019-07-11 09:24:28');
INSERT INTO `access_log` VALUES (52350, '65.49.15628082703342569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:24:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 09:24:30');
INSERT INTO `access_log` VALUES (52351, '65.54.15628082767452533', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:24:37', 64, 0, '', '2019-07-11 09:24:37');
INSERT INTO `access_log` VALUES (52352, '65.3607.15628082770334377', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:24:37', 10, 0, '', '2019-07-11 09:24:37');
INSERT INTO `access_log` VALUES (52353, '65.46.15628082770342633', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:24:37', 10, 2001001000, '服务端发生异常', '2019-07-11 09:24:37');
INSERT INTO `access_log` VALUES (52354, '65.51.15628082770412637', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:24:37', 9, 0, '', '2019-07-11 09:24:37');
INSERT INTO `access_log` VALUES (52355, '65.45.15628083150982567', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:25:15', 8, 0, '', '2019-07-11 09:25:15');
INSERT INTO `access_log` VALUES (52356, '65.49.15628083151012571', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:25:15', 7, 0, '', '2019-07-11 09:25:15');
INSERT INTO `access_log` VALUES (52357, '65.52.15628083150982615', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:25:15', 10, 2001001000, '服务端发生异常', '2019-07-11 09:25:15');
INSERT INTO `access_log` VALUES (52358, '65.54.15628083197682535', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:25:20', 9, 0, '', '2019-07-11 09:25:20');
INSERT INTO `access_log` VALUES (52359, '65.3607.15628083197724379', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:25:20', 9, 0, '', '2019-07-11 09:25:20');
INSERT INTO `access_log` VALUES (52360, '65.46.15628083197712635', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:25:20', 9, 2001001000, '服务端发生异常', '2019-07-11 09:25:20');
INSERT INTO `access_log` VALUES (52361, '65.51.15628083235692639', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:25:24', 9, 0, '', '2019-07-11 09:25:24');
INSERT INTO `access_log` VALUES (52362, '65.47.15628083235722567', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:25:24', 9, 0, '', '2019-07-11 09:25:24');
INSERT INTO `access_log` VALUES (52363, '65.53.15628083235712589', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:25:24', 9, 2001001000, '服务端发生异常', '2019-07-11 09:25:24');
INSERT INTO `access_log` VALUES (52364, '65.45.15628083391972569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:25:39', 140, 0, '', '2019-07-11 09:25:39');
INSERT INTO `access_log` VALUES (52365, '65.52.15628083395122617', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:25:40', 9, 0, '', '2019-07-11 09:25:40');
INSERT INTO `access_log` VALUES (52366, '65.46.15628083395162637', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:25:40', 9, 0, '', '2019-07-11 09:25:40');
INSERT INTO `access_log` VALUES (52367, '65.3607.15628083395154381', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.36.131.162', '2019-07-11 09:25:40', 10, 2001001000, '服务端发生异常', '2019-07-11 09:25:40');
INSERT INTO `access_log` VALUES (52368, '65.49.15628097533922593', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:49:13', 11, 0, '', '2019-07-11 09:49:13');
INSERT INTO `access_log` VALUES (52369, '65.50.15628097533922619', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:49:13', 11, 0, '', '2019-07-11 09:49:13');
INSERT INTO `access_log` VALUES (52370, '65.45.15628097534142589', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:49:13', 10, 2001001000, '服务端发生异常', '2019-07-11 09:49:13');
INSERT INTO `access_log` VALUES (52371, '65.46.15628098993642659', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.145.233.224', '2019-07-11 09:51:39', 0, 1002001015, '账号未登陆', '2019-07-11 09:51:39');
INSERT INTO `access_log` VALUES (52372, '65.3607.15628098993644403', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.145.233.224', '2019-07-11 09:51:39', 0, 1002001015, '账号未登陆', '2019-07-11 09:51:39');
INSERT INTO `access_log` VALUES (52373, '65.52.15628098993672639', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.145.233.224', '2019-07-11 09:51:39', 0, 1002001015, '账号未登陆', '2019-07-11 09:51:39');
INSERT INTO `access_log` VALUES (52374, '64.84.15628100008880997', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.65.249.27', '2019-07-11 09:53:21', 1, 1002001015, '账号未登陆', '2019-07-11 09:53:21');
INSERT INTO `access_log` VALUES (52375, '65.3607.15628100427724405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.145.233.224', '2019-07-11 09:54:03', 75, 0, '', '2019-07-11 09:54:03');
INSERT INTO `access_log` VALUES (52376, '65.54.15628100431292561', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.145.233.224', '2019-07-11 09:54:03', 10, 0, '', '2019-07-11 09:54:03');
INSERT INTO `access_log` VALUES (52377, '65.53.15628100431322615', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.145.233.224', '2019-07-11 09:54:03', 10, 2001001000, '服务端发生异常', '2019-07-11 09:54:03');
INSERT INTO `access_log` VALUES (52378, '65.51.15628100431332665', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.145.233.224', '2019-07-11 09:54:03', 10, 0, '', '2019-07-11 09:54:03');
INSERT INTO `access_log` VALUES (52379, '65.50.15628100516982625', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.145.233.224', '2019-07-11 09:54:12', 7, 2001001000, '服务端发生异常', '2019-07-11 09:54:12');
INSERT INTO `access_log` VALUES (52380, '65.49.15628100516952599', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.145.233.224', '2019-07-11 09:54:12', 89, 0, '', '2019-07-11 09:54:12');
INSERT INTO `access_log` VALUES (52381, '65.45.15628100517012595', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.145.233.224', '2019-07-11 09:54:12', 90, 0, '', '2019-07-11 09:54:12');
INSERT INTO `access_log` VALUES (52382, '64.76.15628109559681011', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.102 Safari/537.36 Vivaldi/2.6.1566.44', '182.48.114.141', '2019-07-11 10:09:16', 1, 1002001015, '账号未登陆', '2019-07-11 10:09:16');
INSERT INTO `access_log` VALUES (52383, '64.83.15628109845221013', 0, 2, 'product-application', '/product-api/admins/attr/update', 'id=1&name=颜色', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.102 Safari/537.36 Vivaldi/2.6.1566.44', '182.48.114.141', '2019-07-11 10:09:45', 1, 1002001015, '账号未登陆', '2019-07-11 10:09:45');
INSERT INTO `access_log` VALUES (52384, '65.53.15628111440242631', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.107.134.128', '2019-07-11 10:12:24', 0, 1002001015, '账号未登陆', '2019-07-11 10:12:24');
INSERT INTO `access_log` VALUES (52385, '65.51.15628111440242681', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.107.134.128', '2019-07-11 10:12:24', 1, 1002001015, '账号未登陆', '2019-07-11 10:12:24');
INSERT INTO `access_log` VALUES (52386, '65.54.15628111440442577', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.107.134.128', '2019-07-11 10:12:24', 0, 1002001015, '账号未登陆', '2019-07-11 10:12:24');
INSERT INTO `access_log` VALUES (52387, '65.47.15628111460992609', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.107.134.128', '2019-07-11 10:12:26', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 10:12:26');
INSERT INTO `access_log` VALUES (52388, '59.72.15628111523050855', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '61.163.211.171', '2019-07-11 10:12:32', 13, 0, '', '2019-07-11 10:12:32');
INSERT INTO `access_log` VALUES (52389, '59.73.15628111523130863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '61.163.211.171', '2019-07-11 10:12:32', 12, 2001001000, '服务端发生异常', '2019-07-11 10:12:32');
INSERT INTO `access_log` VALUES (52390, '64.85.15628111908171035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.163.211.171', '2019-07-11 10:13:11', 13, 0, '', '2019-07-11 10:13:11');
INSERT INTO `access_log` VALUES (52391, '64.80.15628111917361027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.163.211.171', '2019-07-11 10:13:12', 3, 0, '', '2019-07-11 10:13:12');
INSERT INTO `access_log` VALUES (52392, '64.76.15628111950901015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.163.211.171', '2019-07-11 10:13:15', 2, 0, '', '2019-07-11 10:13:15');
INSERT INTO `access_log` VALUES (52393, '64.82.15628111985651037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.163.211.171', '2019-07-11 10:13:19', 2, 0, '', '2019-07-11 10:13:19');
INSERT INTO `access_log` VALUES (52394, '59.77.15628115490760851', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.167.148', '2019-07-11 10:19:09', 4, 0, '', '2019-07-11 10:19:09');
INSERT INTO `access_log` VALUES (52395, '59.73.15628115490790869', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.167.148', '2019-07-11 10:19:09', 28, 2001001000, '服务端发生异常', '2019-07-11 10:19:09');
INSERT INTO `access_log` VALUES (52396, '65.51.15628115575282687', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.167.148', '2019-07-11 10:19:18', 1, 1002001015, '账号未登陆', '2019-07-11 10:19:18');
INSERT INTO `access_log` VALUES (52397, '65.53.15628115575312637', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.167.148', '2019-07-11 10:19:18', 0, 1002001015, '账号未登陆', '2019-07-11 10:19:18');
INSERT INTO `access_log` VALUES (52398, '65.47.15628115575412615', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.167.148', '2019-07-11 10:19:18', 1, 1002001015, '账号未登陆', '2019-07-11 10:19:18');
INSERT INTO `access_log` VALUES (52399, '59.72.15628115588860861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.167.148', '2019-07-11 10:19:19', 2, 0, '', '2019-07-11 10:19:19');
INSERT INTO `access_log` VALUES (52400, '59.80.15628115588960843', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.167.148', '2019-07-11 10:19:19', 12, 2001001000, '服务端发生异常', '2019-07-11 10:19:19');
INSERT INTO `access_log` VALUES (52401, '65.50.15628115627022647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.110.167.148', '2019-07-11 10:19:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 10:19:23');
INSERT INTO `access_log` VALUES (52402, '59.80.15628135834630871', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-11 10:53:03', 28, 0, '', '2019-07-11 10:53:03');
INSERT INTO `access_log` VALUES (52403, '59.73.15628135834630897', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-07-11 10:53:03', 31, 2001001000, '服务端发生异常', '2019-07-11 10:53:03');
INSERT INTO `access_log` VALUES (52404, '59.76.15628136019010885', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.223.196.221', '2019-07-11 10:53:22', 3, 0, '', '2019-07-11 10:53:22');
INSERT INTO `access_log` VALUES (52405, '59.74.15628136019010899', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '223.223.196.221', '2019-07-11 10:53:22', 17, 2001001000, '服务端发生异常', '2019-07-11 10:53:22');
INSERT INTO `access_log` VALUES (52406, '59.75.15628136123800901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 10:53:32', 3, 0, '', '2019-07-11 10:53:32');
INSERT INTO `access_log` VALUES (52407, '59.79.15628136123800893', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 10:53:32', 23, 2001001000, '服务端发生异常', '2019-07-11 10:53:32');
INSERT INTO `access_log` VALUES (52408, '59.77.15628136161050881', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 10:53:36', 2, 0, '', '2019-07-11 10:53:36');
INSERT INTO `access_log` VALUES (52409, '59.80.15628136161050873', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 10:53:36', 13, 2001001000, '服务端发生异常', '2019-07-11 10:53:36');
INSERT INTO `access_log` VALUES (52410, '59.73.15628137683490901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 10:56:08', 3, 0, '', '2019-07-11 10:56:08');
INSERT INTO `access_log` VALUES (52411, '59.72.15628137683650893', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 10:56:08', 12, 2001001000, '服务端发生异常', '2019-07-11 10:56:08');
INSERT INTO `access_log` VALUES (52412, '59.76.15628137712970889', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 10:56:11', 2, 0, '', '2019-07-11 10:56:11');
INSERT INTO `access_log` VALUES (52413, '59.71.15628137712880899', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 10:56:11', 16, 2001001000, '服务端发生异常', '2019-07-11 10:56:11');
INSERT INTO `access_log` VALUES (52414, '59.79.15628137810410897', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:56:21', 2, 0, '', '2019-07-11 10:56:21');
INSERT INTO `access_log` VALUES (52415, '59.75.15628137810290905', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:56:21', 18, 2001001000, '服务端发生异常', '2019-07-11 10:56:21');
INSERT INTO `access_log` VALUES (52416, '64.83.15628137839171053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:56:24', 11, 0, '', '2019-07-11 10:56:24');
INSERT INTO `access_log` VALUES (52417, '64.79.15628137841051057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:56:24', 3, 0, '', '2019-07-11 10:56:24');
INSERT INTO `access_log` VALUES (52418, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:56:26', 6, 0, '', '2019-07-11 10:56:26');
INSERT INTO `access_log` VALUES (52419, '64.78.15628137860051061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:56:26', 2, 0, '', '2019-07-11 10:56:26');
INSERT INTO `access_log` VALUES (52420, '64.77.15628137872971039', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:56:27', 7, 0, '', '2019-07-11 10:56:27');
INSERT INTO `access_log` VALUES (52421, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:56:33', 7, 0, '', '2019-07-11 10:56:33');
INSERT INTO `access_log` VALUES (52422, '64.84.15628137925101051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:56:33', 2, 0, '', '2019-07-11 10:56:33');
INSERT INTO `access_log` VALUES (52423, '64.76.15628138195891053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:00', 2, 0, '', '2019-07-11 10:57:00');
INSERT INTO `access_log` VALUES (52424, '64.82.15628138197491075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:00', 2, 0, '', '2019-07-11 10:57:00');
INSERT INTO `access_log` VALUES (52425, '66.55.15628138413348871', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18608715600', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:21', 89, 0, '', '2019-07-11 10:57:21');
INSERT INTO `access_log` VALUES (52426, '66.54.15628138467748891', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18608715600&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:27', 215, 0, '', '2019-07-11 10:57:27');
INSERT INTO `access_log` VALUES (52427, '66.51.15628138541468913', 167, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:34', 6, 0, '', '2019-07-11 10:57:34');
INSERT INTO `access_log` VALUES (52428, '66.49.15628138570748905', 167, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:37', 6, 0, '', '2019-07-11 10:57:37');
INSERT INTO `access_log` VALUES (52429, '59.74.15628138587250905', 167, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:39', 13, 0, '', '2019-07-11 10:57:39');
INSERT INTO `access_log` VALUES (52430, '59.75.15628138587580907', 167, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:39', 16, 2001001000, '服务端发生异常', '2019-07-11 10:57:39');
INSERT INTO `access_log` VALUES (52431, '64.77.15628138614931041', 167, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:41', 6, 0, '', '2019-07-11 10:57:42');
INSERT INTO `access_log` VALUES (52432, '64.81.15628138617181041', 167, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:42', 6, 0, '', '2019-07-11 10:57:42');
INSERT INTO `access_log` VALUES (52433, '64.85.15628138664051073', 167, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:46', 5, 0, '', '2019-07-11 10:57:46');
INSERT INTO `access_log` VALUES (52434, 'N/A', 167, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:47', 10, 0, '', '2019-07-11 10:57:47');
INSERT INTO `access_log` VALUES (52435, 'N/A', 167, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:48', 11, 0, '', '2019-07-11 10:57:48');
INSERT INTO `access_log` VALUES (52436, 'N/A', 167, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:49', 9, 0, '', '2019-07-11 10:57:49');
INSERT INTO `access_log` VALUES (52437, '64.76.15628138696341055', 167, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:50', 7, 0, '', '2019-07-11 10:57:50');
INSERT INTO `access_log` VALUES (52438, '64.82.15628138698261077', 167, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:50', 5, 0, '', '2019-07-11 10:57:50');
INSERT INTO `access_log` VALUES (52439, '64.83.15628138710271057', 167, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:51', 5, 0, '', '2019-07-11 10:57:51');
INSERT INTO `access_log` VALUES (52440, 'N/A', 167, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:51', 10, 0, '', '2019-07-11 10:57:51');
INSERT INTO `access_log` VALUES (52441, '64.78.15628138721061065', 167, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:52', 10, 0, '', '2019-07-11 10:57:52');
INSERT INTO `access_log` VALUES (52442, '66.52.15628138777918879', 167, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 10:57:58', 6, 0, '', '2019-07-11 10:57:58');
INSERT INTO `access_log` VALUES (52443, '66.53.15628140822188895', 167, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 11:01:22', 7, 0, '', '2019-07-11 11:01:22');
INSERT INTO `access_log` VALUES (52444, '65.3607.15628141620554463', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.36.226.54', '2019-07-11 11:02:42', 1, 1002001015, '账号未登陆', '2019-07-11 11:02:42');
INSERT INTO `access_log` VALUES (52445, '65.54.15628141620552619', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.36.226.54', '2019-07-11 11:02:42', 0, 1002001015, '账号未登陆', '2019-07-11 11:02:42');
INSERT INTO `access_log` VALUES (52446, '65.53.15628141620732673', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.36.226.54', '2019-07-11 11:02:42', 0, 1002001015, '账号未登陆', '2019-07-11 11:02:42');
INSERT INTO `access_log` VALUES (52447, '65.51.15628141640982723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.36.226.54', '2019-07-11 11:02:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 11:02:44');
INSERT INTO `access_log` VALUES (52448, '66.55.15628141646198877', 167, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 11:02:45', 6, 0, '', '2019-07-11 11:02:45');
INSERT INTO `access_log` VALUES (52449, '66.54.15628141652458897', 167, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 11:02:45', 5, 0, '', '2019-07-11 11:02:45');
INSERT INTO `access_log` VALUES (52450, '66.48.15628141691258905', 167, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 11:02:49', 6, 0, '', '2019-07-11 11:02:49');
INSERT INTO `access_log` VALUES (52451, '65.50.15628141746772683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.36.226.54', '2019-07-11 11:02:55', 182, 0, '', '2019-07-11 11:02:55');
INSERT INTO `access_log` VALUES (52452, '65.49.15628141750702657', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.36.226.54', '2019-07-11 11:02:55', 106, 0, '', '2019-07-11 11:02:55');
INSERT INTO `access_log` VALUES (52453, '65.46.15628141750772721', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.36.226.54', '2019-07-11 11:02:55', 99, 0, '', '2019-07-11 11:02:55');
INSERT INTO `access_log` VALUES (52454, '65.45.15628141750742653', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '120.36.226.54', '2019-07-11 11:02:55', 104, 2001001000, '服务端发生异常', '2019-07-11 11:02:55');
INSERT INTO `access_log` VALUES (52455, '66.56.15628141990428905', 167, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=15287456321&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=10010&isDefault=false&address=10010&areaNo=110101&mobile=15287456321&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 11:03:19', 106, 2001001000, '服务端发生异常', '2019-07-11 11:03:19');
INSERT INTO `access_log` VALUES (52456, '66.52.15628142012108885', 167, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=15287456321&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=10010&isDefault=false&address=10010&areaNo=110101&mobile=15287456321&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 11:03:21', 231, 2001001000, '服务端发生异常', '2019-07-11 11:03:21');
INSERT INTO `access_log` VALUES (52457, '66.50.15628142036508897', 167, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 11:03:24', 6, 0, '', '2019-07-11 11:03:24');
INSERT INTO `access_log` VALUES (52458, '66.55.15628142053428879', 167, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 11:03:25', 6, 0, '', '2019-07-11 11:03:25');
INSERT INTO `access_log` VALUES (52459, '65.3607.15628142254724465', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:03:45', 1, 1002001015, '账号未登陆', '2019-07-11 11:03:45');
INSERT INTO `access_log` VALUES (52460, '65.51.15628142254722725', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:03:45', 1, 1002001015, '账号未登陆', '2019-07-11 11:03:45');
INSERT INTO `access_log` VALUES (52461, '65.47.15628142254762653', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:03:45', 0, 1002001015, '账号未登陆', '2019-07-11 11:03:45');
INSERT INTO `access_log` VALUES (52462, '65.50.15628142284692685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:03:48', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 11:03:48');
INSERT INTO `access_log` VALUES (52463, '65.49.15628142370132659', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:03:57', 86, 0, '', '2019-07-11 11:03:57');
INSERT INTO `access_log` VALUES (52464, '65.45.15628142374082655', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:03:57', 7, 0, '', '2019-07-11 11:03:57');
INSERT INTO `access_log` VALUES (52465, '65.52.15628142374082703', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:03:57', 9, 2001001000, '服务端发生异常', '2019-07-11 11:03:57');
INSERT INTO `access_log` VALUES (52466, '65.53.15628142374392677', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:03:57', 8, 0, '', '2019-07-11 11:03:57');
INSERT INTO `access_log` VALUES (52467, '65.3607.15628142811754467', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:04:41', 9, 0, '', '2019-07-11 11:04:41');
INSERT INTO `access_log` VALUES (52468, '65.50.15628142811762687', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:04:41', 10, 2001001000, '服务端发生异常', '2019-07-11 11:04:41');
INSERT INTO `access_log` VALUES (52469, '65.46.15628142812432725', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:04:41', 10, 0, '', '2019-07-11 11:04:41');
INSERT INTO `access_log` VALUES (52470, '59.78.15628143216780901', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '223.167.152.53', '2019-07-11 11:05:22', 10, 2001001000, '服务端发生异常', '2019-07-11 11:05:22');
INSERT INTO `access_log` VALUES (52471, '65.54.15628143360802625', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:05:36', 8, 0, '', '2019-07-11 11:05:36');
INSERT INTO `access_log` VALUES (52472, '65.51.15628143360802729', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:05:36', 9, 0, '', '2019-07-11 11:05:36');
INSERT INTO `access_log` VALUES (52473, '65.53.15628143360802679', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:05:36', 9, 2001001000, '服务端发生异常', '2019-07-11 11:05:36');
INSERT INTO `access_log` VALUES (52474, '65.3607.15628143476684469', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.130.2.80', '2019-07-11 11:05:48', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 11:05:48');
INSERT INTO `access_log` VALUES (52475, '59.71.15628144014610909', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 11:06:41', 3, 0, '', '2019-07-11 11:06:41');
INSERT INTO `access_log` VALUES (52476, '59.74.15628144014640913', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 11:06:41', 13, 2001001000, '服务端发生异常', '2019-07-11 11:06:41');
INSERT INTO `access_log` VALUES (52477, '64.83.15628144080741065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 11:06:48', 4, 0, '', '2019-07-11 11:06:48');
INSERT INTO `access_log` VALUES (52478, '64.79.15628144082231069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 11:06:48', 2, 0, '', '2019-07-11 11:06:48');
INSERT INTO `access_log` VALUES (52479, '64.77.15628144127721051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 11:06:53', 2, 0, '', '2019-07-11 11:06:53');
INSERT INTO `access_log` VALUES (52480, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 11:06:53', 6, 0, '', '2019-07-11 11:06:53');
INSERT INTO `access_log` VALUES (52481, '64.84.15628144136971063', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 11:06:54', 7, 0, '', '2019-07-11 11:06:54');
INSERT INTO `access_log` VALUES (52482, '64.81.15628144189341051', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 11:06:59', 6, 0, '', '2019-07-11 11:06:59');
INSERT INTO `access_log` VALUES (52483, '66.48.15628144367368911', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13464832222&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 11:07:17', 8, 1001003000, '验证码不存在', '2019-07-11 11:07:17');
INSERT INTO `access_log` VALUES (52484, '66.51.15628144386888925', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13464832222', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 11:07:19', 85, 0, '', '2019-07-11 11:07:19');
INSERT INTO `access_log` VALUES (52485, '66.52.15628144406648891', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13464832222&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 11:07:21', 187, 0, '', '2019-07-11 11:07:21');
INSERT INTO `access_log` VALUES (52486, '66.55.15628144421278883', 168, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 11:07:22', 7, 0, '', '2019-07-11 11:07:22');
INSERT INTO `access_log` VALUES (52487, '66.48.15628144454378913', 168, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.223.196.221', '2019-07-11 11:07:25', 6, 0, '', '2019-07-11 11:07:25');
INSERT INTO `access_log` VALUES (52488, '59.71.15628146680110913', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:08', 3, 0, '', '2019-07-11 11:11:08');
INSERT INTO `access_log` VALUES (52489, '59.74.15628146680110917', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:08', 19, 2001001000, '服务端发生异常', '2019-07-11 11:11:08');
INSERT INTO `access_log` VALUES (52490, '64.77.15628146708091055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:11', 3, 0, '', '2019-07-11 11:11:11');
INSERT INTO `access_log` VALUES (52491, '64.84.15628146709941067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:11', 2, 0, '', '2019-07-11 11:11:11');
INSERT INTO `access_log` VALUES (52492, '64.81.15628146720041055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:12', 2, 0, '', '2019-07-11 11:11:12');
INSERT INTO `access_log` VALUES (52493, '59.75.15628146729800919', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:13', 2, 0, '', '2019-07-11 11:11:13');
INSERT INTO `access_log` VALUES (52494, '59.79.15628146729800911', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:13', 18, 2001001000, '服务端发生异常', '2019-07-11 11:11:13');
INSERT INTO `access_log` VALUES (52495, '64.85.15628146749101087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:15', 2, 0, '', '2019-07-11 11:11:15');
INSERT INTO `access_log` VALUES (52496, '64.76.15628146750271069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:15', 2, 0, '', '2019-07-11 11:11:15');
INSERT INTO `access_log` VALUES (52497, '59.78.15628146761770907', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:16', 2, 0, '', '2019-07-11 11:11:16');
INSERT INTO `access_log` VALUES (52498, '59.77.15628146761830899', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:16', 12, 2001001000, '服务端发生异常', '2019-07-11 11:11:16');
INSERT INTO `access_log` VALUES (52499, '65.52.15628146920732711', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:32', 0, 1002001015, '账号未登陆', '2019-07-11 11:11:32');
INSERT INTO `access_log` VALUES (52500, '65.45.15628146920782663', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:32', 1, 1002001015, '账号未登陆', '2019-07-11 11:11:32');
INSERT INTO `access_log` VALUES (52501, '65.51.15628146920802735', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:32', 0, 1002001015, '账号未登陆', '2019-07-11 11:11:32');
INSERT INTO `access_log` VALUES (52502, '65.54.15628146949032631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:35', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 11:11:35');
INSERT INTO `access_log` VALUES (52503, '65.47.15628146991462663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:39', 87, 0, '', '2019-07-11 11:11:39');
INSERT INTO `access_log` VALUES (52504, '65.3607.15628146994824475', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:39', 7, 0, '', '2019-07-11 11:11:39');
INSERT INTO `access_log` VALUES (52505, '65.46.15628146994972733', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:39', 8, 0, '', '2019-07-11 11:11:40');
INSERT INTO `access_log` VALUES (52506, '65.50.15628146994972695', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.16.165.133', '2019-07-11 11:11:39', 9, 2001001000, '服务端发生异常', '2019-07-11 11:11:40');
INSERT INTO `access_log` VALUES (52507, '59.71.15628147275590915', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:12:08', 2, 0, '', '2019-07-11 11:12:08');
INSERT INTO `access_log` VALUES (52508, '59.74.15628147275590919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:12:08', 18, 2001001000, '服务端发生异常', '2019-07-11 11:12:08');
INSERT INTO `access_log` VALUES (52509, '64.78.15628147308551079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:12:11', 2, 0, '', '2019-07-11 11:12:11');
INSERT INTO `access_log` VALUES (52510, '64.77.15628147309771057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:12:11', 2, 0, '', '2019-07-11 11:12:11');
INSERT INTO `access_log` VALUES (52511, '64.84.15628147322521069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:12:12', 2, 0, '', '2019-07-11 11:12:12');
INSERT INTO `access_log` VALUES (52512, '64.81.15628147325391057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:12:13', 2, 0, '', '2019-07-11 11:12:13');
INSERT INTO `access_log` VALUES (52513, '64.85.15628147333801089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:12:13', 2, 0, '', '2019-07-11 11:12:13');
INSERT INTO `access_log` VALUES (52514, '59.79.15628147349460913', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:12:15', 2, 0, '', '2019-07-11 11:12:15');
INSERT INTO `access_log` VALUES (52515, '59.75.15628147349460921', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:12:15', 12, 2001001000, '服务端发生异常', '2019-07-11 11:12:15');
INSERT INTO `access_log` VALUES (52516, '64.76.15628147370591071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:12:17', 2, 0, '', '2019-07-11 11:12:17');
INSERT INTO `access_log` VALUES (52517, '64.82.15628147373071093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:12:17', 2, 0, '', '2019-07-11 11:12:17');
INSERT INTO `access_log` VALUES (52518, '59.77.15628147451120901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:12:25', 2, 0, '', '2019-07-11 11:12:25');
INSERT INTO `access_log` VALUES (52519, '59.80.15628147451120893', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:12:25', 12, 2001001000, '服务端发生异常', '2019-07-11 11:12:25');
INSERT INTO `access_log` VALUES (52520, '65.49.15628148372112671', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:13:57', 1, 1002001015, '账号未登陆', '2019-07-11 11:13:57');
INSERT INTO `access_log` VALUES (52521, '65.50.15628148372102697', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:13:57', 0, 1002001015, '账号未登陆', '2019-07-11 11:13:57');
INSERT INTO `access_log` VALUES (52522, '65.52.15628148372132715', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:13:57', 1, 1002001015, '账号未登陆', '2019-07-11 11:13:57');
INSERT INTO `access_log` VALUES (52523, '65.51.15628148399242739', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:14:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 11:14:00');
INSERT INTO `access_log` VALUES (52524, '65.53.15628148683252689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:14:28', 66, 0, '', '2019-07-11 11:14:28');
INSERT INTO `access_log` VALUES (52525, '65.47.15628148686132667', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:14:29', 9, 0, '', '2019-07-11 11:14:29');
INSERT INTO `access_log` VALUES (52526, '65.46.15628148686152737', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:14:29', 9, 0, '', '2019-07-11 11:14:29');
INSERT INTO `access_log` VALUES (52527, '65.3607.15628148686144479', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:14:29', 10, 2001001000, '服务端发生异常', '2019-07-11 11:14:29');
INSERT INTO `access_log` VALUES (52528, '65.54.15628149402192637', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:15:40', 8, 0, '', '2019-07-11 11:15:40');
INSERT INTO `access_log` VALUES (52529, '65.46.15628149402242739', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:15:40', 9, 0, '', '2019-07-11 11:15:40');
INSERT INTO `access_log` VALUES (52530, '65.53.15628149402242691', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '211.103.167.65', '2019-07-11 11:15:40', 10, 2001001000, '服务端发生异常', '2019-07-11 11:15:40');
INSERT INTO `access_log` VALUES (52531, '59.72.15628151952940917', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.213.26', '2019-07-11 11:19:55', 3, 0, '', '2019-07-11 11:19:55');
INSERT INTO `access_log` VALUES (52532, '59.73.15628151952940925', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.213.26', '2019-07-11 11:19:55', 13, 2001001000, '服务端发生异常', '2019-07-11 11:19:55');
INSERT INTO `access_log` VALUES (52533, '64.83.15628151971741079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.213.26', '2019-07-11 11:19:57', 2, 0, '', '2019-07-11 11:19:57');
INSERT INTO `access_log` VALUES (52534, '64.79.15628151972591083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.213.26', '2019-07-11 11:19:57', 1, 0, '', '2019-07-11 11:19:57');
INSERT INTO `access_log` VALUES (52535, '59.78.15628170595500941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.129.148.2', '2019-07-11 11:51:00', 10, 0, '', '2019-07-11 11:51:00');
INSERT INTO `access_log` VALUES (52536, '59.77.15628170595510933', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.129.148.2', '2019-07-11 11:51:00', 21, 2001001000, '服务端发生异常', '2019-07-11 11:51:00');
INSERT INTO `access_log` VALUES (52537, '65.52.15628177354472757', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.203.233.4', '2019-07-11 12:02:15', 1, 1002001015, '账号未登陆', '2019-07-11 12:02:15');
INSERT INTO `access_log` VALUES (52538, '65.51.15628177354472779', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.203.233.4', '2019-07-11 12:02:15', 1, 1002001015, '账号未登陆', '2019-07-11 12:02:15');
INSERT INTO `access_log` VALUES (52539, '65.45.15628177354522709', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.203.233.4', '2019-07-11 12:02:15', 1, 1002001015, '账号未登陆', '2019-07-11 12:02:15');
INSERT INTO `access_log` VALUES (52540, '65.54.15628177374592677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.203.233.4', '2019-07-11 12:02:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 12:02:17');
INSERT INTO `access_log` VALUES (52541, '65.53.15628177391822727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.203.233.4', '2019-07-11 12:02:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 12:02:19');
INSERT INTO `access_log` VALUES (52542, '65.3607.15628177529754521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.203.233.4', '2019-07-11 12:02:33', 113, 0, '', '2019-07-11 12:02:33');
INSERT INTO `access_log` VALUES (52543, '65.47.15628177534112707', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.203.233.4', '2019-07-11 12:02:33', 10, 0, '', '2019-07-11 12:02:33');
INSERT INTO `access_log` VALUES (52544, '65.50.15628177534202741', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.203.233.4', '2019-07-11 12:02:33', 10, 2001001000, '服务端发生异常', '2019-07-11 12:02:33');
INSERT INTO `access_log` VALUES (52545, '65.46.15628177534302779', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.203.233.4', '2019-07-11 12:02:33', 8, 0, '', '2019-07-11 12:02:33');
INSERT INTO `access_log` VALUES (52546, '65.51.15628177722122781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '209.146.24.206', '2019-07-11 12:02:52', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 12:02:52');
INSERT INTO `access_log` VALUES (52547, '59.78.15628192800790971', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.242.230', '2019-07-11 12:28:00', 10, 0, '', '2019-07-11 12:28:00');
INSERT INTO `access_log` VALUES (52548, '59.77.15628192800800963', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.242.230', '2019-07-11 12:28:00', 16, 2001001000, '服务端发生异常', '2019-07-11 12:28:00');
INSERT INTO `access_log` VALUES (52549, '64.81.15628192888381119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.242.230', '2019-07-11 12:28:09', 11, 0, '', '2019-07-11 12:28:09');
INSERT INTO `access_log` VALUES (52550, '64.85.15628192889271151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.222.242.230', '2019-07-11 12:28:09', 3, 0, '', '2019-07-11 12:28:09');
INSERT INTO `access_log` VALUES (52551, '59.79.15628193017060977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:28:22', 3, 0, '', '2019-07-11 12:28:22');
INSERT INTO `access_log` VALUES (52552, '59.72.15628193017110973', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:28:22', 12, 2001001000, '服务端发生异常', '2019-07-11 12:28:22');
INSERT INTO `access_log` VALUES (52553, '64.82.15628193049301155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:28:25', 2, 0, '', '2019-07-11 12:28:25');
INSERT INTO `access_log` VALUES (52554, '64.80.15628193050311145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:28:25', 2, 0, '', '2019-07-11 12:28:25');
INSERT INTO `access_log` VALUES (52555, '59.74.15628193081070983', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:28:28', 2, 0, '', '2019-07-11 12:28:28');
INSERT INTO `access_log` VALUES (52556, '59.75.15628193081070985', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:28:28', 13, 2001001000, '服务端发生异常', '2019-07-11 12:28:28');
INSERT INTO `access_log` VALUES (52557, '64.77.15628195046251123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:45', 3, 0, '', '2019-07-11 12:31:45');
INSERT INTO `access_log` VALUES (52558, '64.84.15628195047521135', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:45', 2, 0, '', '2019-07-11 12:31:45');
INSERT INTO `access_log` VALUES (52559, '64.81.15628195062391123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:46', 2, 0, '', '2019-07-11 12:31:46');
INSERT INTO `access_log` VALUES (52560, '64.85.15628195070901155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:47', 2, 0, '', '2019-07-11 12:31:47');
INSERT INTO `access_log` VALUES (52561, '64.76.15628195077131137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:48', 2, 0, '', '2019-07-11 12:31:48');
INSERT INTO `access_log` VALUES (52562, '64.82.15628195082321159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:48', 2, 0, '', '2019-07-11 12:31:48');
INSERT INTO `access_log` VALUES (52563, '64.80.15628195091991149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:49', 2, 0, '', '2019-07-11 12:31:49');
INSERT INTO `access_log` VALUES (52564, '64.83.15628195100031139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:50', 2, 0, '', '2019-07-11 12:31:50');
INSERT INTO `access_log` VALUES (52565, '64.78.15628195118761147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:52', 2, 0, '', '2019-07-11 12:31:52');
INSERT INTO `access_log` VALUES (52566, '64.77.15628195126921125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:53', 2, 0, '', '2019-07-11 12:31:53');
INSERT INTO `access_log` VALUES (52567, '64.84.15628195133271137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:53', 2, 0, '', '2019-07-11 12:31:53');
INSERT INTO `access_log` VALUES (52568, '64.81.15628195145091125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:55', 2, 0, '', '2019-07-11 12:31:55');
INSERT INTO `access_log` VALUES (52569, '64.85.15628195151201157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:55', 2, 0, '', '2019-07-11 12:31:55');
INSERT INTO `access_log` VALUES (52570, '64.76.15628195161061139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:56', 2, 0, '', '2019-07-11 12:31:56');
INSERT INTO `access_log` VALUES (52571, '64.82.15628195174401161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:57', 2, 0, '', '2019-07-11 12:31:57');
INSERT INTO `access_log` VALUES (52572, '64.80.15628195186331151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:59', 2, 0, '', '2019-07-11 12:31:59');
INSERT INTO `access_log` VALUES (52573, '64.83.15628195193101141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:31:59', 2, 0, '', '2019-07-11 12:31:59');
INSERT INTO `access_log` VALUES (52574, '64.79.15628195199461145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:32:00', 2, 0, '', '2019-07-11 12:32:00');
INSERT INTO `access_log` VALUES (52575, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:32:00', 6, 0, '', '2019-07-11 12:32:00');
INSERT INTO `access_log` VALUES (52576, '64.77.15628195306301127', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:32:11', 7, 0, '', '2019-07-11 12:32:11');
INSERT INTO `access_log` VALUES (52577, '66.55.15628195682388951', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15324490545', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:32:48', 100, 0, '', '2019-07-11 12:32:48');
INSERT INTO `access_log` VALUES (52578, '66.48.15628195759748981', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15324490545&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:32:56', 420, 0, '', '2019-07-11 12:32:56');
INSERT INTO `access_log` VALUES (52579, '64.80.15628195867321153', 169, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:07', 11, 0, '', '2019-07-11 12:33:07');
INSERT INTO `access_log` VALUES (52580, '64.83.15628195955961143', 169, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:16', 10, 0, '', '2019-07-11 12:33:16');
INSERT INTO `access_log` VALUES (52581, '64.78.15628195962771151', 169, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:16', 7, 0, '', '2019-07-11 12:33:16');
INSERT INTO `access_log` VALUES (52582, 'N/A', 169, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:16', 10, 0, '', '2019-07-11 12:33:16');
INSERT INTO `access_log` VALUES (52583, 'N/A', 169, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:19', 10, 0, '', '2019-07-11 12:33:19');
INSERT INTO `access_log` VALUES (52584, '64.81.15628196011571129', 169, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:21', 12, 0, '', '2019-07-11 12:33:21');
INSERT INTO `access_log` VALUES (52585, '64.76.15628196012921143', 169, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:21', 6, 0, '', '2019-07-11 12:33:21');
INSERT INTO `access_log` VALUES (52586, '64.82.15628196061221165', 169, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:26', 4, 0, '', '2019-07-11 12:33:26');
INSERT INTO `access_log` VALUES (52587, '64.80.15628196062381155', 169, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:26', 4, 0, '', '2019-07-11 12:33:26');
INSERT INTO `access_log` VALUES (52588, '66.52.15628196098338965', 169, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:30', 6, 0, '', '2019-07-11 12:33:30');
INSERT INTO `access_log` VALUES (52589, '66.50.15628196123478969', 169, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:32', 6, 0, '', '2019-07-11 12:33:32');
INSERT INTO `access_log` VALUES (52590, '66.53.15628196186868975', 169, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:39', 6, 0, '', '2019-07-11 12:33:39');
INSERT INTO `access_log` VALUES (52591, '66.55.15628196205318953', 169, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:41', 6, 0, '', '2019-07-11 12:33:41');
INSERT INTO `access_log` VALUES (52592, '66.54.15628196230138977', 169, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:43', 6, 0, '', '2019-07-11 12:33:43');
INSERT INTO `access_log` VALUES (52593, '66.48.15628196277478983', 169, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:48', 5, 0, '', '2019-07-11 12:33:48');
INSERT INTO `access_log` VALUES (52594, '59.71.15628196299010985', 169, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:50', 6, 0, '', '2019-07-11 12:33:50');
INSERT INTO `access_log` VALUES (52595, '59.76.15628196299010973', 169, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:33:50', 16, 2001001000, '服务端发生异常', '2019-07-11 12:33:50');
INSERT INTO `access_log` VALUES (52596, '66.52.15628196664228967', 169, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:34:26', 6, 0, '', '2019-07-11 12:34:26');
INSERT INTO `access_log` VALUES (52597, '64.84.15628196675751143', 169, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:34:28', 5, 0, '', '2019-07-11 12:34:28');
INSERT INTO `access_log` VALUES (52598, '64.81.15628196677101131', 169, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:34:28', 15, 0, '', '2019-07-11 12:34:28');
INSERT INTO `access_log` VALUES (52599, '59.75.15628196683530991', 169, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:34:28', 5, 0, '', '2019-07-11 12:34:28');
INSERT INTO `access_log` VALUES (52600, '59.74.15628196683530989', 169, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '114.222.242.230', '2019-07-11 12:34:28', 17, 2001001000, '服务端发生异常', '2019-07-11 12:34:28');
INSERT INTO `access_log` VALUES (52601, '65.49.15628210919422759', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.202.199', '2019-07-11 12:58:12', 0, 1002001015, '账号未登陆', '2019-07-11 12:58:12');
INSERT INTO `access_log` VALUES (52602, '65.3607.15628210919424567', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.202.199', '2019-07-11 12:58:12', 0, 1002001015, '账号未登陆', '2019-07-11 12:58:12');
INSERT INTO `access_log` VALUES (52603, '65.53.15628210919422773', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.202.199', '2019-07-11 12:58:12', 0, 1002001015, '账号未登陆', '2019-07-11 12:58:12');
INSERT INTO `access_log` VALUES (52604, '65.50.15628211061542787', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.202.199', '2019-07-11 12:58:26', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 12:58:26');
INSERT INTO `access_log` VALUES (52605, '65.52.15628211202142805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.202.199', '2019-07-11 12:58:40', 97, 0, '', '2019-07-11 12:58:40');
INSERT INTO `access_log` VALUES (52606, '65.51.15628211205722827', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.202.199', '2019-07-11 12:58:41', 9, 0, '', '2019-07-11 12:58:41');
INSERT INTO `access_log` VALUES (52607, '65.45.15628211205742757', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.202.199', '2019-07-11 12:58:41', 10, 2001001000, '服务端发生异常', '2019-07-11 12:58:41');
INSERT INTO `access_log` VALUES (52608, '65.54.15628211205782725', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.202.199', '2019-07-11 12:58:41', 9, 0, '', '2019-07-11 12:58:41');
INSERT INTO `access_log` VALUES (52609, '65.3607.15628211625264569', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.202.199', '2019-07-11 12:59:23', 9, 0, '', '2019-07-11 12:59:23');
INSERT INTO `access_log` VALUES (52610, '65.47.15628211625292755', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.202.199', '2019-07-11 12:59:23', 10, 2001001000, '服务端发生异常', '2019-07-11 12:59:23');
INSERT INTO `access_log` VALUES (52611, '65.50.15628211625412789', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.202.199', '2019-07-11 12:59:23', 8, 0, '', '2019-07-11 12:59:23');
INSERT INTO `access_log` VALUES (52612, '65.52.15628211668682807', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.202.199', '2019-07-11 12:59:27', 8, 0, '', '2019-07-11 12:59:27');
INSERT INTO `access_log` VALUES (52613, '65.51.15628211668722829', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.202.199', '2019-07-11 12:59:27', 9, 2001001000, '服务端发生异常', '2019-07-11 12:59:27');
INSERT INTO `access_log` VALUES (52614, '65.54.15628211668902727', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.62.202.199', '2019-07-11 12:59:27', 121, 0, '', '2019-07-11 12:59:27');
INSERT INTO `access_log` VALUES (52615, '59.74.15628230603041035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.213.26', '2019-07-11 13:31:00', 90, 0, '', '2019-07-11 13:31:00');
INSERT INTO `access_log` VALUES (52616, '59.75.15628230603051037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.213.26', '2019-07-11 13:31:00', 95, 2001001000, '服务端发生异常', '2019-07-11 13:31:00');
INSERT INTO `access_log` VALUES (52617, '64.77.15628230623571177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.213.26', '2019-07-11 13:31:02', 18, 0, '', '2019-07-11 13:31:02');
INSERT INTO `access_log` VALUES (52618, '64.81.15628230624781177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.213.26', '2019-07-11 13:31:02', 8, 0, '', '2019-07-11 13:31:02');
INSERT INTO `access_log` VALUES (52619, '64.76.15628230637611191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.213.26', '2019-07-11 13:31:04', 8, 0, '', '2019-07-11 13:31:04');
INSERT INTO `access_log` VALUES (52620, '64.80.15628230642481203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.213.26', '2019-07-11 13:31:04', 8, 0, '', '2019-07-11 13:31:04');
INSERT INTO `access_log` VALUES (52621, '64.83.15628230650161193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.213.26', '2019-07-11 13:31:05', 8, 0, '', '2019-07-11 13:31:05');
INSERT INTO `access_log` VALUES (52622, '64.79.15628230651241197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.167.213.26', '2019-07-11 13:31:05', 8, 0, '', '2019-07-11 13:31:05');
INSERT INTO `access_log` VALUES (52623, '65.50.15628243173532831', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.176.52', '2019-07-11 13:51:57', 0, 1002001015, '账号未登陆', '2019-07-11 13:51:57');
INSERT INTO `access_log` VALUES (52624, '65.3607.15628243173524613', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.176.52', '2019-07-11 13:51:57', 0, 1002001015, '账号未登陆', '2019-07-11 13:51:57');
INSERT INTO `access_log` VALUES (52625, '65.46.15628243173552871', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.176.52', '2019-07-11 13:51:57', 0, 1002001015, '账号未登陆', '2019-07-11 13:51:57');
INSERT INTO `access_log` VALUES (52626, '65.51.15628243357742873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.176.52', '2019-07-11 13:52:16', 170, 0, '', '2019-07-11 13:52:16');
INSERT INTO `access_log` VALUES (52627, '65.54.15628243362052771', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.176.52', '2019-07-11 13:52:16', 20, 0, '', '2019-07-11 13:52:16');
INSERT INTO `access_log` VALUES (52628, '65.49.15628243362182807', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.176.52', '2019-07-11 13:52:16', 10, 0, '', '2019-07-11 13:52:16');
INSERT INTO `access_log` VALUES (52629, '65.45.15628243362092803', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.176.52', '2019-07-11 13:52:16', 19, 2001001000, '服务端发生异常', '2019-07-11 13:52:16');
INSERT INTO `access_log` VALUES (52630, '59.78.15628245802791045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:20', 4, 0, '', '2019-07-11 13:56:20');
INSERT INTO `access_log` VALUES (52631, '59.77.15628245802801037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:20', 13, 2001001000, '服务端发生异常', '2019-07-11 13:56:20');
INSERT INTO `access_log` VALUES (52632, '64.84.15628245850951211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:25', 11, 0, '', '2019-07-11 13:56:25');
INSERT INTO `access_log` VALUES (52633, '64.81.15628245852311199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:25', 1, 0, '', '2019-07-11 13:56:25');
INSERT INTO `access_log` VALUES (52634, '64.85.15628245888691231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:29', 2, 0, '', '2019-07-11 13:56:29');
INSERT INTO `access_log` VALUES (52635, '64.76.15628245889881213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:29', 1, 0, '', '2019-07-11 13:56:29');
INSERT INTO `access_log` VALUES (52636, '64.80.15628246002131225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:40', 2, 0, '', '2019-07-11 13:56:40');
INSERT INTO `access_log` VALUES (52637, '64.83.15628246003511215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:40', 2, 0, '', '2019-07-11 13:56:40');
INSERT INTO `access_log` VALUES (52638, '59.76.15628246011151041', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:41', 3, 0, '', '2019-07-11 13:56:41');
INSERT INTO `access_log` VALUES (52639, '59.72.15628246011151047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:41', 14, 2001001000, '服务端发生异常', '2019-07-11 13:56:41');
INSERT INTO `access_log` VALUES (52640, '64.79.15628246036771219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:44', 2, 0, '', '2019-07-11 13:56:44');
INSERT INTO `access_log` VALUES (52641, '64.78.15628246042391223', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:44', 2, 0, '', '2019-07-11 13:56:44');
INSERT INTO `access_log` VALUES (52642, '64.77.15628246042461201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:44', 2, 0, '', '2019-07-11 13:56:44');
INSERT INTO `access_log` VALUES (52643, '59.79.15628246043801051', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:44', 2, 0, '', '2019-07-11 13:56:44');
INSERT INTO `access_log` VALUES (52644, '59.75.15628246043811059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:44', 12, 2001001000, '服务端发生异常', '2019-07-11 13:56:44');
INSERT INTO `access_log` VALUES (52645, '64.84.15628246044091213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:44', 2, 0, '', '2019-07-11 13:56:44');
INSERT INTO `access_log` VALUES (52646, '65.53.15628246143792823', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:54', 1, 1002001015, '账号未登陆', '2019-07-11 13:56:54');
INSERT INTO `access_log` VALUES (52647, '65.54.15628246143782775', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:54', 1, 1002001015, '账号未登陆', '2019-07-11 13:56:54');
INSERT INTO `access_log` VALUES (52648, '65.47.15628246143842805', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:54', 0, 1002001015, '账号未登陆', '2019-07-11 13:56:54');
INSERT INTO `access_log` VALUES (52649, '65.3607.15628246159134619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:56:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 13:56:56');
INSERT INTO `access_log` VALUES (52650, '65.46.15628246235612877', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:57:04', 79, 0, '', '2019-07-11 13:57:04');
INSERT INTO `access_log` VALUES (52651, '65.50.15628246239102837', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:57:04', 11, 0, '', '2019-07-11 13:57:04');
INSERT INTO `access_log` VALUES (52652, '65.52.15628246239152857', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:57:04', 9, 0, '', '2019-07-11 13:57:04');
INSERT INTO `access_log` VALUES (52653, '65.51.15628246239172879', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.67.94.96', '2019-07-11 13:57:04', 18, 2001001000, '服务端发生异常', '2019-07-11 13:57:04');
INSERT INTO `access_log` VALUES (52654, '59.75.15628248925601063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:01:33', 3, 0, '', '2019-07-11 14:01:33');
INSERT INTO `access_log` VALUES (52655, '59.74.15628248925611061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:01:33', 13, 2001001000, '服务端发生异常', '2019-07-11 14:01:33');
INSERT INTO `access_log` VALUES (52656, '64.83.15628248955971221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:01:36', 3, 0, '', '2019-07-11 14:01:36');
INSERT INTO `access_log` VALUES (52657, '64.85.15628248957051239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:01:36', 2, 0, '', '2019-07-11 14:01:36');
INSERT INTO `access_log` VALUES (52658, '64.77.15628248971221207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:01:37', 3, 0, '', '2019-07-11 14:01:37');
INSERT INTO `access_log` VALUES (52659, '64.78.15628248977231229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:01:38', 2, 0, '', '2019-07-11 14:01:38');
INSERT INTO `access_log` VALUES (52660, '66.52.15628249004399037', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:01:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空', '2019-07-11 14:01:40');
INSERT INTO `access_log` VALUES (52661, '64.80.15628249037131231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:01:44', 2, 0, '', '2019-07-11 14:01:44');
INSERT INTO `access_log` VALUES (52662, '64.84.15628249038211219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:01:44', 2, 0, '', '2019-07-11 14:01:44');
INSERT INTO `access_log` VALUES (52663, '59.73.15628249043051059', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:01:44', 2, 0, '', '2019-07-11 14:01:44');
INSERT INTO `access_log` VALUES (52664, '59.78.15628249043121051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:01:44', 12, 2001001000, '服务端发生异常', '2019-07-11 14:01:44');
INSERT INTO `access_log` VALUES (52665, '65.45.15628249208862813', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:02:01', 0, 1002001015, '账号未登陆', '2019-07-11 14:02:01');
INSERT INTO `access_log` VALUES (52666, '65.49.15628249208862817', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:02:01', 0, 1002001015, '账号未登陆', '2019-07-11 14:02:01');
INSERT INTO `access_log` VALUES (52667, '65.53.15628249208942829', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:02:01', 0, 1002001015, '账号未登陆', '2019-07-11 14:02:01');
INSERT INTO `access_log` VALUES (52668, '65.47.15628249241892811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:02:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 14:02:04');
INSERT INTO `access_log` VALUES (52669, '65.3607.15628249293454625', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:02:09', 170, 0, '', '2019-07-11 14:02:10');
INSERT INTO `access_log` VALUES (52670, '65.46.15628249300232883', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:02:10', 10, 0, '', '2019-07-11 14:02:10');
INSERT INTO `access_log` VALUES (52671, '65.50.15628249300312843', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:02:10', 11, 2001001000, '服务端发生异常', '2019-07-11 14:02:10');
INSERT INTO `access_log` VALUES (52672, '65.52.15628249300382863', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-11 14:02:10', 9, 0, '', '2019-07-11 14:02:10');
INSERT INTO `access_log` VALUES (52673, '65.47.15628254510262819', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.103.23.39', '2019-07-11 14:10:51', 0, 1002001015, '账号未登陆', '2019-07-11 14:10:51');
INSERT INTO `access_log` VALUES (52674, '65.54.15628254510432789', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.103.23.39', '2019-07-11 14:10:51', 0, 1002001015, '账号未登陆', '2019-07-11 14:10:51');
INSERT INTO `access_log` VALUES (52675, '65.3607.15628254510444633', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.103.23.39', '2019-07-11 14:10:51', 1, 1002001015, '账号未登陆', '2019-07-11 14:10:51');
INSERT INTO `access_log` VALUES (52676, '65.50.15628254576412851', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.103.23.39', '2019-07-11 14:10:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 14:10:58');
INSERT INTO `access_log` VALUES (52677, '65.51.15628254704542893', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyunanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.103.23.39', '2019-07-11 14:11:10', 157, 0, '', '2019-07-11 14:11:11');
INSERT INTO `access_log` VALUES (52678, '65.49.15628254709642827', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.103.23.39', '2019-07-11 14:11:11', 10, 0, '', '2019-07-11 14:11:11');
INSERT INTO `access_log` VALUES (52679, '65.45.15628254709662823', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.103.23.39', '2019-07-11 14:11:11', 10, 0, '', '2019-07-11 14:11:11');
INSERT INTO `access_log` VALUES (52680, '65.53.15628254709642839', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.103.23.39', '2019-07-11 14:11:11', 12, 2001001000, '服务端发生异常', '2019-07-11 14:11:11');
INSERT INTO `access_log` VALUES (52681, '65.45.15628259135342829', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.64.233.189', '2019-07-11 14:18:34', 1, 1002001015, '账号未登陆', '2019-07-11 14:18:34');
INSERT INTO `access_log` VALUES (52682, '65.47.15628259135342827', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.64.233.189', '2019-07-11 14:18:34', 0, 1002001015, '账号未登陆', '2019-07-11 14:18:34');
INSERT INTO `access_log` VALUES (52683, '65.54.15628259135392797', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.64.233.189', '2019-07-11 14:18:34', 1, 1002001015, '账号未登陆', '2019-07-11 14:18:34');
INSERT INTO `access_log` VALUES (52684, '65.46.15628259291132899', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.64.233.189', '2019-07-11 14:18:49', 80, 0, '', '2019-07-11 14:18:49');
INSERT INTO `access_log` VALUES (52685, '65.50.15628259294582859', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.64.233.189', '2019-07-11 14:18:49', 288, 0, '', '2019-07-11 14:18:50');
INSERT INTO `access_log` VALUES (52686, '65.52.15628259294612879', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.64.233.189', '2019-07-11 14:18:49', 288, 2001001000, '服务端发生异常', '2019-07-11 14:18:50');
INSERT INTO `access_log` VALUES (52687, '65.51.15628259294642901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.64.233.189', '2019-07-11 14:18:49', 285, 0, '', '2019-07-11 14:18:50');
INSERT INTO `access_log` VALUES (52688, '65.47.15628259577232829', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.64.233.189', '2019-07-11 14:19:18', 9, 0, '', '2019-07-11 14:19:18');
INSERT INTO `access_log` VALUES (52689, '65.54.15628259577272799', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.64.233.189', '2019-07-11 14:19:18', 9, 2001001000, '服务端发生异常', '2019-07-11 14:19:18');
INSERT INTO `access_log` VALUES (52690, '65.45.15628259577322831', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.64.233.189', '2019-07-11 14:19:18', 9, 0, '', '2019-07-11 14:19:18');
INSERT INTO `access_log` VALUES (52691, '65.46.15628259751772901', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.64.233.189', '2019-07-11 14:19:35', 9, 0, '', '2019-07-11 14:19:35');
INSERT INTO `access_log` VALUES (52692, '65.50.15628259751802861', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.64.233.189', '2019-07-11 14:19:35', 9, 2001001000, '服务端发生异常', '2019-07-11 14:19:35');
INSERT INTO `access_log` VALUES (52693, '65.52.15628259751862881', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.64.233.189', '2019-07-11 14:19:35', 8, 0, '', '2019-07-11 14:19:35');
INSERT INTO `access_log` VALUES (52694, '64.79.15628261351701241', 0, 2, 'product-application', '/product-api/admins/category/add', 'description=1&name=admin/info&pid=1&sort=1&picUrl=http://www.iocoder.cn/images/common/wechat_mp_2017_07_31_bak.jpg/', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.57.195.180', '2019-07-11 14:22:15', 1, 1002001015, '账号未登陆', '2019-07-11 14:22:15');
INSERT INTO `access_log` VALUES (52695, '64.82.15628261532161257', 0, 2, 'product-application', '/product-api/admins/category/add', 'name=admin/info&pid=1&sort=1&picUrl=http://www.iocoder.cn/images/common/wechat_mp_2017_07_31_bak.jpg/', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.57.195.180', '2019-07-11 14:22:33', 1, 1002001015, '账号未登陆', '2019-07-11 14:22:33');
INSERT INTO `access_log` VALUES (52696, '64.78.15628261881281247', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.57.195.180', '2019-07-11 14:23:08', 0, 1002001015, '账号未登陆', '2019-07-11 14:23:08');
INSERT INTO `access_log` VALUES (52697, '59.79.15628263058221075', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.78.191.24', '2019-07-11 14:25:06', 3, 0, '', '2019-07-11 14:25:06');
INSERT INTO `access_log` VALUES (52698, '59.74.15628263058241081', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.78.191.24', '2019-07-11 14:25:06', 12, 2001001000, '服务端发生异常', '2019-07-11 14:25:06');
INSERT INTO `access_log` VALUES (52699, '64.77.15628263101301229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.78.191.24', '2019-07-11 14:25:10', 153, 0, '', '2019-07-11 14:25:10');
INSERT INTO `access_log` VALUES (52700, '64.78.15628263103991249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.78.191.24', '2019-07-11 14:25:10', 2, 0, '', '2019-07-11 14:25:10');
INSERT INTO `access_log` VALUES (52701, '64.80.15628263118701253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.78.191.24', '2019-07-11 14:25:12', 2, 0, '', '2019-07-11 14:25:12');
INSERT INTO `access_log` VALUES (52702, '64.84.15628263125571241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.78.191.24', '2019-07-11 14:25:13', 1, 0, '', '2019-07-11 14:25:13');
INSERT INTO `access_log` VALUES (52703, '59.75.15628263153761083', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.78.191.24', '2019-07-11 14:25:15', 2, 0, '', '2019-07-11 14:25:15');
INSERT INTO `access_log` VALUES (52704, '59.80.15628263153841055', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.78.191.24', '2019-07-11 14:25:15', 12, 2001001000, '服务端发生异常', '2019-07-11 14:25:15');
INSERT INTO `access_log` VALUES (52705, '65.53.15628267602322861', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:32:40', 1, 1002001015, '账号未登陆', '2019-07-11 14:32:40');
INSERT INTO `access_log` VALUES (52706, '65.49.15628267602582849', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:32:40', 1, 1002001015, '账号未登陆', '2019-07-11 14:32:40');
INSERT INTO `access_log` VALUES (52707, '65.45.15628267603152843', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:32:40', 0, 1002001015, '账号未登陆', '2019-07-11 14:32:40');
INSERT INTO `access_log` VALUES (52708, '65.47.15628267708062843', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.57.193.95', '2019-07-11 14:32:51', 1, 1002001015, '账号未登陆', '2019-07-11 14:32:51');
INSERT INTO `access_log` VALUES (52709, '65.46.15628267708062915', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.57.193.95', '2019-07-11 14:32:51', 0, 1002001015, '账号未登陆', '2019-07-11 14:32:51');
INSERT INTO `access_log` VALUES (52710, '65.52.15628267708092893', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.57.193.95', '2019-07-11 14:32:51', 0, 1002001015, '账号未登陆', '2019-07-11 14:32:51');
INSERT INTO `access_log` VALUES (52711, '65.54.15628267756752811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.57.193.95', '2019-07-11 14:32:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 14:32:56');
INSERT INTO `access_log` VALUES (52712, '65.50.15628267786072875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.57.193.95', '2019-07-11 14:32:59', 96, 0, '', '2019-07-11 14:32:59');
INSERT INTO `access_log` VALUES (52713, '65.53.15628267790112863', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.57.193.95', '2019-07-11 14:32:59', 10, 0, '', '2019-07-11 14:32:59');
INSERT INTO `access_log` VALUES (52714, '65.49.15628267790142851', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.57.193.95', '2019-07-11 14:32:59', 16, 2001001000, '服务端发生异常', '2019-07-11 14:32:59');
INSERT INTO `access_log` VALUES (52715, '65.45.15628267790152845', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.57.193.95', '2019-07-11 14:32:59', 15, 0, '', '2019-07-11 14:32:59');
INSERT INTO `access_log` VALUES (52716, '65.51.15628267789212915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:32:59', 166, 0, '', '2019-07-11 14:32:59');
INSERT INTO `access_log` VALUES (52717, '65.46.15628267794532917', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:32:59', 11, 0, '', '2019-07-11 14:32:59');
INSERT INTO `access_log` VALUES (52718, '65.47.15628267794552845', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:32:59', 10, 2001001000, '服务端发生异常', '2019-07-11 14:32:59');
INSERT INTO `access_log` VALUES (52719, '65.52.15628267794592895', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:32:59', 16, 0, '', '2019-07-11 14:32:59');
INSERT INTO `access_log` VALUES (52720, '59.75.15628270326781093', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:37:13', 3, 0, '', '2019-07-11 14:37:13');
INSERT INTO `access_log` VALUES (52721, '59.80.15628270326791065', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:37:13', 12, 2001001000, '服务端发生异常', '2019-07-11 14:37:13');
INSERT INTO `access_log` VALUES (52722, '64.76.15628270409191249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:37:21', 2, 0, '', '2019-07-11 14:37:21');
INSERT INTO `access_log` VALUES (52723, '64.79.15628270410311255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:37:21', 2, 0, '', '2019-07-11 14:37:21');
INSERT INTO `access_log` VALUES (52724, '64.81.15628270430181239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:37:23', 2, 0, '', '2019-07-11 14:37:23');
INSERT INTO `access_log` VALUES (52725, '64.82.15628270438091271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:37:24', 2, 0, '', '2019-07-11 14:37:24');
INSERT INTO `access_log` VALUES (52726, '64.83.15628270452411253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:37:25', 2, 0, '', '2019-07-11 14:37:25');
INSERT INTO `access_log` VALUES (52727, '59.78.15628270469281081', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:37:27', 2, 0, '', '2019-07-11 14:37:27');
INSERT INTO `access_log` VALUES (52728, '59.77.15628270469301073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:37:27', 13, 2001001000, '服务端发生异常', '2019-07-11 14:37:27');
INSERT INTO `access_log` VALUES (52729, '65.50.15628274075662885', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:43:28', 11, 0, '', '2019-07-11 14:43:28');
INSERT INTO `access_log` VALUES (52730, '65.49.15628274075692861', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:43:28', 11, 2001001000, '服务端发生异常', '2019-07-11 14:43:28');
INSERT INTO `access_log` VALUES (52731, '65.53.15628274075742873', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.15.178.244', '2019-07-11 14:43:28', 9, 0, '', '2019-07-11 14:43:28');
INSERT INTO `access_log` VALUES (52732, '59.77.15628280717281087', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.113.96.136', '2019-07-11 14:54:32', 3, 0, '', '2019-07-11 14:54:32');
INSERT INTO `access_log` VALUES (52733, '59.78.15628280717281095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.113.96.136', '2019-07-11 14:54:32', 14, 2001001000, '服务端发生异常', '2019-07-11 14:54:32');
INSERT INTO `access_log` VALUES (52734, '64.82.15628286655091293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.113.96.136', '2019-07-11 15:04:26', 2, 0, '', '2019-07-11 15:04:26');
INSERT INTO `access_log` VALUES (52735, '64.83.15628286656171275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.113.96.136', '2019-07-11 15:04:26', 1, 0, '', '2019-07-11 15:04:26');
INSERT INTO `access_log` VALUES (52736, '64.85.15628286667281293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.113.96.136', '2019-07-11 15:04:27', 1, 0, '', '2019-07-11 15:04:27');
INSERT INTO `access_log` VALUES (52737, '64.77.15628286674951263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.113.96.136', '2019-07-11 15:04:27', 2, 0, '', '2019-07-11 15:04:27');
INSERT INTO `access_log` VALUES (52738, '64.78.15628286679631283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.113.96.136', '2019-07-11 15:04:28', 2, 0, '', '2019-07-11 15:04:28');
INSERT INTO `access_log` VALUES (52739, '64.80.15628286683601287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.113.96.136', '2019-07-11 15:04:28', 2, 0, '', '2019-07-11 15:04:28');
INSERT INTO `access_log` VALUES (52740, '66.52.15628286719809089', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.113.96.136', '2019-07-11 15:04:32', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空', '2019-07-11 15:04:32');
INSERT INTO `access_log` VALUES (52741, '64.84.15628286745231275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.113.96.136', '2019-07-11 15:04:35', 2, 0, '', '2019-07-11 15:04:35');
INSERT INTO `access_log` VALUES (52742, '64.76.15628286746331273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.113.96.136', '2019-07-11 15:04:35', 2, 0, '', '2019-07-11 15:04:35');
INSERT INTO `access_log` VALUES (52743, '65.3607.15628292935514691', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-11 15:14:54', 5, 1002001012, '访问令牌已过期', '2019-07-11 15:14:54');
INSERT INTO `access_log` VALUES (52744, '65.54.15628292935522847', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-11 15:14:54', 4, 1002001012, '访问令牌已过期', '2019-07-11 15:14:54');
INSERT INTO `access_log` VALUES (52745, '65.53.15628292935562899', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-11 15:14:54', 3, 1002001012, '访问令牌已过期', '2019-07-11 15:14:54');
INSERT INTO `access_log` VALUES (52746, '65.50.15628293036882911', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-11 15:15:04', 94, 0, '', '2019-07-11 15:15:04');
INSERT INTO `access_log` VALUES (52747, '65.45.15628293040282881', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-11 15:15:04', 125, 0, '', '2019-07-11 15:15:04');
INSERT INTO `access_log` VALUES (52748, '65.51.15628293040292951', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-11 15:15:04', 127, 2001001000, '服务端发生异常', '2019-07-11 15:15:04');
INSERT INTO `access_log` VALUES (52749, '65.52.15628293040292931', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-11 15:15:04', 127, 0, '', '2019-07-11 15:15:04');
INSERT INTO `access_log` VALUES (52750, '59.80.15628300828421107', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:28:03', 21, 2001001000, '服务端发生异常', '2019-07-11 15:28:03');
INSERT INTO `access_log` VALUES (52751, '59.79.15628300828411127', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:28:03', 262, 0, '', '2019-07-11 15:28:03');
INSERT INTO `access_log` VALUES (52752, '64.77.15628300870581283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:28:07', 2, 0, '', '2019-07-11 15:28:07');
INSERT INTO `access_log` VALUES (52753, '64.78.15628300872601303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:28:07', 2, 0, '', '2019-07-11 15:28:07');
INSERT INTO `access_log` VALUES (52754, '64.80.15628300901491307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:28:10', 2, 0, '', '2019-07-11 15:28:10');
INSERT INTO `access_log` VALUES (52755, '64.84.15628300902541295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:28:10', 1, 0, '', '2019-07-11 15:28:10');
INSERT INTO `access_log` VALUES (52756, '65.49.15628301215192899', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:28:42', 0, 1002001015, '账号未登陆', '2019-07-11 15:28:42');
INSERT INTO `access_log` VALUES (52757, '65.50.15628301215322923', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:28:42', 1, 1002001015, '账号未登陆', '2019-07-11 15:28:42');
INSERT INTO `access_log` VALUES (52758, '65.52.15628301215682943', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:28:42', 1, 1002001015, '账号未登陆', '2019-07-11 15:28:42');
INSERT INTO `access_log` VALUES (52759, '65.51.15628301247462963', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:28:45', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 15:28:45');
INSERT INTO `access_log` VALUES (52760, '65.46.15628301348072965', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:28:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 15:28:55');
INSERT INTO `access_log` VALUES (52761, '65.47.15628301397072893', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:29:00', 74, 0, '', '2019-07-11 15:29:00');
INSERT INTO `access_log` VALUES (52762, '65.54.15628301406182861', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:29:01', 9, 0, '', '2019-07-11 15:29:01');
INSERT INTO `access_log` VALUES (52763, '65.53.15628301406442913', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:29:01', 9, 0, '', '2019-07-11 15:29:01');
INSERT INTO `access_log` VALUES (52764, '65.3607.15628301406444705', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.228.226.146', '2019-07-11 15:29:01', 10, 2001001000, '服务端发生异常', '2019-07-11 15:29:01');
INSERT INTO `access_log` VALUES (52765, '65.49.15628317847212923', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.138.182.8', '2019-07-11 15:56:25', 0, 1002001015, '账号未登陆', '2019-07-11 15:56:25');
INSERT INTO `access_log` VALUES (52766, '65.50.15628317847212947', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.138.182.8', '2019-07-11 15:56:25', 0, 1002001015, '账号未登陆', '2019-07-11 15:56:25');
INSERT INTO `access_log` VALUES (52767, '65.52.15628317847232967', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.138.182.8', '2019-07-11 15:56:25', 0, 1002001015, '账号未登陆', '2019-07-11 15:56:25');
INSERT INTO `access_log` VALUES (52768, '65.51.15628317962952987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.138.182.8', '2019-07-11 15:56:36', 176, 0, '', '2019-07-11 15:56:36');
INSERT INTO `access_log` VALUES (52769, '65.45.15628317967512917', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.138.182.8', '2019-07-11 15:56:37', 17, 0, '', '2019-07-11 15:56:37');
INSERT INTO `access_log` VALUES (52770, '65.46.15628317967512989', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.138.182.8', '2019-07-11 15:56:37', 19, 2001001000, '服务端发生异常', '2019-07-11 15:56:37');
INSERT INTO `access_log` VALUES (52771, '65.47.15628317967542917', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.138.182.8', '2019-07-11 15:56:37', 17, 0, '', '2019-07-11 15:56:37');
INSERT INTO `access_log` VALUES (52772, '65.51.15628318083912989', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.138.182.8', '2019-07-11 15:56:48', 10, 0, '', '2019-07-11 15:56:48');
INSERT INTO `access_log` VALUES (52773, '65.46.15628318083932991', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.138.182.8', '2019-07-11 15:56:48', 9, 0, '', '2019-07-11 15:56:48');
INSERT INTO `access_log` VALUES (52774, '65.45.15628318083932919', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '182.138.182.8', '2019-07-11 15:56:48', 10, 2001001000, '服务端发生异常', '2019-07-11 15:56:48');
INSERT INTO `access_log` VALUES (52775, '59.71.15628320714381157', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.204.30.28', '2019-07-11 16:01:11', 11, 0, '', '2019-07-11 16:01:11');
INSERT INTO `access_log` VALUES (52776, '59.78.15628320714381149', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.204.30.28', '2019-07-11 16:01:11', 22, 2001001000, '服务端发生异常', '2019-07-11 16:01:11');
INSERT INTO `access_log` VALUES (52777, '59.80.15628321103141135', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.8.458 V1_IPH_SQ_8.0.8_1_APP_A Pixel/1080 Core/WKWebView Device/Apple(iPhone 8Plus) NetType/4G QBWebViewType/1 WKType/1', '124.64.19.248', '2019-07-11 16:01:50', 3, 0, '', '2019-07-11 16:01:50');
INSERT INTO `access_log` VALUES (52778, '59.79.15628321103241155', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.8.458 V1_IPH_SQ_8.0.8_1_APP_A Pixel/1080 Core/WKWebView Device/Apple(iPhone 8Plus) NetType/4G QBWebViewType/1 WKType/1', '124.64.19.248', '2019-07-11 16:01:50', 18, 2001001000, '服务端发生异常', '2019-07-11 16:01:50');
INSERT INTO `access_log` VALUES (52779, '64.85.15628321135171341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.8.458 V1_IPH_SQ_8.0.8_1_APP_A Pixel/1080 Core/WKWebView Device/Apple(iPhone 8Plus) NetType/4G QBWebViewType/1 WKType/1', '111.204.30.28', '2019-07-11 16:01:54', 12, 0, '', '2019-07-11 16:01:54');
INSERT INTO `access_log` VALUES (52780, '64.77.15628321136751311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.8.458 V1_IPH_SQ_8.0.8_1_APP_A Pixel/1080 Core/WKWebView Device/Apple(iPhone 8Plus) NetType/4G QBWebViewType/1 WKType/1', '111.204.30.28', '2019-07-11 16:01:54', 3, 0, '', '2019-07-11 16:01:54');
INSERT INTO `access_log` VALUES (52781, '64.78.15628321151991331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.8.458 V1_IPH_SQ_8.0.8_1_APP_A Pixel/1080 Core/WKWebView Device/Apple(iPhone 8Plus) NetType/4G QBWebViewType/1 WKType/1', '111.204.30.28', '2019-07-11 16:01:55', 2, 0, '', '2019-07-11 16:01:55');
INSERT INTO `access_log` VALUES (52782, '64.80.15628321160031335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.8.458 V1_IPH_SQ_8.0.8_1_APP_A Pixel/1080 Core/WKWebView Device/Apple(iPhone 8Plus) NetType/4G QBWebViewType/1 WKType/1', '111.204.30.28', '2019-07-11 16:01:56', 1, 0, '', '2019-07-11 16:01:56');
INSERT INTO `access_log` VALUES (52783, '59.75.15628321218011163', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.8.458 V1_IPH_SQ_8.0.8_1_APP_A Pixel/1080 Core/WKWebView Device/Apple(iPhone 8Plus) NetType/4G QBWebViewType/1 WKType/1', '111.204.30.28', '2019-07-11 16:02:02', 2, 0, '', '2019-07-11 16:02:02');
INSERT INTO `access_log` VALUES (52784, '59.73.15628321218331159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 QQ/8.0.8.458 V1_IPH_SQ_8.0.8_1_APP_A Pixel/1080 Core/WKWebView Device/Apple(iPhone 8Plus) NetType/4G QBWebViewType/1 WKType/1', '111.204.30.28', '2019-07-11 16:02:02', 13, 2001001000, '服务端发生异常', '2019-07-11 16:02:02');
INSERT INTO `access_log` VALUES (52785, '65.51.15628323228562997', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.204.30.28', '2019-07-11 16:05:23', 0, 1002001015, '账号未登陆', '2019-07-11 16:05:23');
INSERT INTO `access_log` VALUES (52786, '65.49.15628323228622933', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.204.30.28', '2019-07-11 16:05:23', 0, 1002001015, '账号未登陆', '2019-07-11 16:05:23');
INSERT INTO `access_log` VALUES (52787, '65.54.15628323228662893', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.204.30.28', '2019-07-11 16:05:23', 1, 1002001015, '账号未登陆', '2019-07-11 16:05:23');
INSERT INTO `access_log` VALUES (52788, '65.47.15628323339042927', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.204.30.28', '2019-07-11 16:05:34', 79, 0, '', '2019-07-11 16:05:34');
INSERT INTO `access_log` VALUES (52789, '65.53.15628323342312943', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.204.30.28', '2019-07-11 16:05:34', 206, 0, '', '2019-07-11 16:05:34');
INSERT INTO `access_log` VALUES (52790, '65.52.15628323342412979', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.204.30.28', '2019-07-11 16:05:34', 200, 0, '', '2019-07-11 16:05:34');
INSERT INTO `access_log` VALUES (52791, '65.50.15628323342352959', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.204.30.28', '2019-07-11 16:05:34', 206, 2001001000, '服务端发生异常', '2019-07-11 16:05:34');
INSERT INTO `access_log` VALUES (52792, '65.51.15628323686862999', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.204.30.28', '2019-07-11 16:06:09', 9, 0, '', '2019-07-11 16:06:09');
INSERT INTO `access_log` VALUES (52793, '65.49.15628323686892935', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.204.30.28', '2019-07-11 16:06:09', 9, 2001001000, '服务端发生异常', '2019-07-11 16:06:09');
INSERT INTO `access_log` VALUES (52794, '65.54.15628323687062895', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.204.30.28', '2019-07-11 16:06:09', 9, 0, '', '2019-07-11 16:06:09');
INSERT INTO `access_log` VALUES (52795, '65.50.15628344910092989', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.30.196.131', '2019-07-11 16:41:31', 1, 1002001015, '账号未登陆', '2019-07-11 16:41:31');
INSERT INTO `access_log` VALUES (52796, '65.53.15628344910102973', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.30.196.131', '2019-07-11 16:41:31', 1, 1002001015, '账号未登陆', '2019-07-11 16:41:31');
INSERT INTO `access_log` VALUES (52797, '65.52.15628344910093009', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.30.196.131', '2019-07-11 16:41:31', 1, 1002001015, '账号未登陆', '2019-07-11 16:41:31');
INSERT INTO `access_log` VALUES (52798, '65.46.15628344930663031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.30.196.131', '2019-07-11 16:41:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 16:41:33');
INSERT INTO `access_log` VALUES (52799, '65.51.15628345060393029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.30.196.131', '2019-07-11 16:41:46', 73, 0, '', '2019-07-11 16:41:46');
INSERT INTO `access_log` VALUES (52800, '65.54.15628345063722925', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.30.196.131', '2019-07-11 16:41:46', 15, 0, '', '2019-07-11 16:41:46');
INSERT INTO `access_log` VALUES (52801, '65.3607.15628345063774767', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.30.196.131', '2019-07-11 16:41:46', 11, 0, '', '2019-07-11 16:41:46');
INSERT INTO `access_log` VALUES (52802, '65.49.15628345063762965', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.30.196.131', '2019-07-11 16:41:46', 11, 2001001000, '服务端发生异常', '2019-07-11 16:41:46');
INSERT INTO `access_log` VALUES (52803, '65.52.15628345331083011', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.30.196.131', '2019-07-11 16:42:13', 11, 0, '', '2019-07-11 16:42:13');
INSERT INTO `access_log` VALUES (52804, '65.46.15628345331123033', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.30.196.131', '2019-07-11 16:42:13', 9, 0, '', '2019-07-11 16:42:13');
INSERT INTO `access_log` VALUES (52805, '65.50.15628345331102991', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.30.196.131', '2019-07-11 16:42:13', 12, 2001001000, '服务端发生异常', '2019-07-11 16:42:13');
INSERT INTO `access_log` VALUES (52806, '59.75.15628356894761211', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '36.5.246.17', '2019-07-11 17:01:29', 14, 0, '', '2019-07-11 17:01:29');
INSERT INTO `access_log` VALUES (52807, '59.73.15628356894761207', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '36.5.246.17', '2019-07-11 17:01:29', 25, 2001001000, '服务端发生异常', '2019-07-11 17:01:30');
INSERT INTO `access_log` VALUES (52808, '59.78.15628370467511217', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.226.159.170', '2019-07-11 17:24:07', 7, 0, '', '2019-07-11 17:24:07');
INSERT INTO `access_log` VALUES (52809, '59.71.15628370467511225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.226.159.170', '2019-07-11 17:24:07', 22, 2001001000, '服务端发生异常', '2019-07-11 17:24:07');
INSERT INTO `access_log` VALUES (52810, '64.76.15628370874781387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:24:47', 132, 0, '', '2019-07-11 17:24:48');
INSERT INTO `access_log` VALUES (52811, '64.79.15628370877311393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:24:48', 3, 0, '', '2019-07-11 17:24:48');
INSERT INTO `access_log` VALUES (52812, '64.81.15628370891431377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:24:49', 2, 0, '', '2019-07-11 17:24:49');
INSERT INTO `access_log` VALUES (52813, '64.82.15628370895981409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:24:50', 2, 0, '', '2019-07-11 17:24:50');
INSERT INTO `access_log` VALUES (52814, '64.85.15628370906051409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:24:51', 1, 0, '', '2019-07-11 17:24:51');
INSERT INTO `access_log` VALUES (52815, '64.77.15628370909661379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:24:51', 2, 0, '', '2019-07-11 17:24:51');
INSERT INTO `access_log` VALUES (52816, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:24:52', 9, 0, '', '2019-07-11 17:24:52');
INSERT INTO `access_log` VALUES (52817, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:24:52', 10, 0, '', '2019-07-11 17:24:52');
INSERT INTO `access_log` VALUES (52818, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:24:54', 6, 0, '', '2019-07-11 17:24:54');
INSERT INTO `access_log` VALUES (52819, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:24:54', 13, 0, '', '2019-07-11 17:24:55');
INSERT INTO `access_log` VALUES (52820, '64.78.15628371030211399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:25:03', 2, 0, '', '2019-07-11 17:25:03');
INSERT INTO `access_log` VALUES (52821, '64.80.15628371031441403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:25:03', 2, 0, '', '2019-07-11 17:25:03');
INSERT INTO `access_log` VALUES (52822, '64.84.15628371042121391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:25:04', 2, 0, '', '2019-07-11 17:25:04');
INSERT INTO `access_log` VALUES (52823, '64.76.15628371046921389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:25:05', 2, 0, '', '2019-07-11 17:25:05');
INSERT INTO `access_log` VALUES (52824, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:25:06', 6, 0, '', '2019-07-11 17:25:06');
INSERT INTO `access_log` VALUES (52825, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:25:06', 12, 0, '', '2019-07-11 17:25:06');
INSERT INTO `access_log` VALUES (52826, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:25:08', 6, 0, '', '2019-07-11 17:25:08');
INSERT INTO `access_log` VALUES (52827, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:25:08', 11, 0, '', '2019-07-11 17:25:08');
INSERT INTO `access_log` VALUES (52828, '64.82.15628371311811411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:25:31', 2, 0, '', '2019-07-11 17:25:31');
INSERT INTO `access_log` VALUES (52829, '64.83.15628371312571393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:25:31', 1, 0, '', '2019-07-11 17:25:31');
INSERT INTO `access_log` VALUES (52830, '59.73.15628371319671227', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:25:32', 3, 0, '', '2019-07-11 17:25:32');
INSERT INTO `access_log` VALUES (52831, '59.75.15628371319771231', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '221.226.159.170', '2019-07-11 17:25:32', 19, 2001001000, '服务端发生异常', '2019-07-11 17:25:32');
INSERT INTO `access_log` VALUES (52832, '59.79.15628372355521225', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '124.239.138.11', '2019-07-11 17:27:16', 3, 0, '', '2019-07-11 17:27:16');
INSERT INTO `access_log` VALUES (52833, '59.73.15628372355521229', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '124.239.138.11', '2019-07-11 17:27:16', 13, 2001001000, '服务端发生异常', '2019-07-11 17:27:16');
INSERT INTO `access_log` VALUES (52834, '64.81.15628372387161381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '124.239.138.11', '2019-07-11 17:27:19', 2, 0, '', '2019-07-11 17:27:19');
INSERT INTO `access_log` VALUES (52835, '64.82.15628372388601413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '124.239.138.11', '2019-07-11 17:27:19', 2, 0, '', '2019-07-11 17:27:19');
INSERT INTO `access_log` VALUES (52836, '65.52.15628372396513047', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:27:20', 1, 1002001015, '账号未登陆', '2019-07-11 17:27:20');
INSERT INTO `access_log` VALUES (52837, '65.46.15628372396543071', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:27:20', 0, 1002001015, '账号未登陆', '2019-07-11 17:27:20');
INSERT INTO `access_log` VALUES (52838, '65.45.15628372396732995', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:27:20', 0, 1002001015, '账号未登陆', '2019-07-11 17:27:20');
INSERT INTO `access_log` VALUES (52839, '65.51.15628372422233069', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:27:22', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 17:27:22');
INSERT INTO `access_log` VALUES (52840, '66.53.15628372426949213', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '124.239.138.11', '2019-07-11 17:27:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机号不能为空\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空', '2019-07-11 17:27:23');
INSERT INTO `access_log` VALUES (52841, '65.49.15628372467673003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:27:27', 90, 0, '', '2019-07-11 17:27:27');
INSERT INTO `access_log` VALUES (52842, '64.85.15628372470171413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '124.239.138.11', '2019-07-11 17:27:27', 2, 0, '', '2019-07-11 17:27:27');
INSERT INTO `access_log` VALUES (52843, '64.77.15628372471631383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '124.239.138.11', '2019-07-11 17:27:27', 2, 0, '', '2019-07-11 17:27:27');
INSERT INTO `access_log` VALUES (52844, '65.47.15628372472022997', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:27:27', 139, 0, '', '2019-07-11 17:27:27');
INSERT INTO `access_log` VALUES (52845, '65.54.15628372471792965', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:27:27', 161, 0, '', '2019-07-11 17:27:27');
INSERT INTO `access_log` VALUES (52846, '65.53.15628372471803013', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:27:27', 163, 2001001000, '服务端发生异常', '2019-07-11 17:27:27');
INSERT INTO `access_log` VALUES (52847, '59.74.15628373166541233', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:28:37', 2, 0, '', '2019-07-11 17:28:37');
INSERT INTO `access_log` VALUES (52848, '59.80.15628373166541207', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:28:37', 13, 2001001000, '服务端发生异常', '2019-07-11 17:28:37');
INSERT INTO `access_log` VALUES (52849, '64.81.15628373218631383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:28:42', 2, 0, '', '2019-07-11 17:28:42');
INSERT INTO `access_log` VALUES (52850, '64.82.15628373219751415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:28:42', 2, 0, '', '2019-07-11 17:28:42');
INSERT INTO `access_log` VALUES (52851, '64.83.15628373232371397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:28:43', 2, 0, '', '2019-07-11 17:28:43');
INSERT INTO `access_log` VALUES (52852, '64.85.15628373237391415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:28:44', 1, 0, '', '2019-07-11 17:28:44');
INSERT INTO `access_log` VALUES (52853, '64.77.15628373245221385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:28:45', 2, 0, '', '2019-07-11 17:28:45');
INSERT INTO `access_log` VALUES (52854, '66.52.15628373340509205', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=11111111111', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:28:54', 97, 0, '', '2019-07-11 17:28:54');
INSERT INTO `access_log` VALUES (52855, '66.56.15628373360819219', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=1111', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:28:56', 8, 1001003003, '验证码不正确', '2019-07-11 17:28:56');
INSERT INTO `access_log` VALUES (52856, '66.50.15628373405689207', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:29:01', 336, 0, '', '2019-07-11 17:29:01');
INSERT INTO `access_log` VALUES (52857, '64.76.15628373486681395', 128, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:29:09', 7, 0, '', '2019-07-11 17:29:09');
INSERT INTO `access_log` VALUES (52858, '64.81.15628373488381385', 128, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:29:09', 6, 0, '', '2019-07-11 17:29:09');
INSERT INTO `access_log` VALUES (52859, '66.54.15628373500989217', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:29:10', 5, 0, '', '2019-07-11 17:29:10');
INSERT INTO `access_log` VALUES (52860, '66.48.15628373550059221', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:29:15', 8, 0, '', '2019-07-11 17:29:15');
INSERT INTO `access_log` VALUES (52861, '59.71.15628373561951231', 128, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:29:16', 6, 0, '', '2019-07-11 17:29:16');
INSERT INTO `access_log` VALUES (52862, '59.78.15628373561961223', 128, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:29:16', 16, 2001001000, '服务端发生异常', '2019-07-11 17:29:16');
INSERT INTO `access_log` VALUES (52863, '59.79.15628373682731229', 128, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:29:28', 5, 0, '', '2019-07-11 17:29:28');
INSERT INTO `access_log` VALUES (52864, '59.80.15628373682731209', 128, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:29:28', 15, 2001001000, '服务端发生异常', '2019-07-11 17:29:28');
INSERT INTO `access_log` VALUES (52865, '66.49.15628373689799227', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:29:29', 6, 0, '', '2019-07-11 17:29:29');
INSERT INTO `access_log` VALUES (52866, '64.85.15628373713281417', 128, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:29:31', 4, 0, '', '2019-07-11 17:29:31');
INSERT INTO `access_log` VALUES (52867, '64.78.15628373715281407', 128, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:29:32', 6, 0, '', '2019-07-11 17:29:32');
INSERT INTO `access_log` VALUES (52868, '59.73.15628373718151233', 128, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:29:32', 12, 0, '', '2019-07-11 17:29:32');
INSERT INTO `access_log` VALUES (52869, '59.75.15628373718151237', 128, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.104.146.33', '2019-07-11 17:29:32', 28, 2001001000, '服务端发生异常', '2019-07-11 17:29:32');
INSERT INTO `access_log` VALUES (52870, '59.77.15628388720041237', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.90.237.146', '2019-07-11 17:54:32', 3, 0, '', '2019-07-11 17:54:32');
INSERT INTO `access_log` VALUES (52871, '59.71.15628388720091253', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.90.237.146', '2019-07-11 17:54:32', 18, 2001001000, '服务端发生异常', '2019-07-11 17:54:32');
INSERT INTO `access_log` VALUES (52872, '59.72.15628388781801247', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.90.237.146', '2019-07-11 17:54:38', 2, 0, '', '2019-07-11 17:54:38');
INSERT INTO `access_log` VALUES (52873, '59.76.15628388781801241', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.90.237.146', '2019-07-11 17:54:38', 13, 2001001000, '服务端发生异常', '2019-07-11 17:54:38');
INSERT INTO `access_log` VALUES (52874, '64.84.15628388809361419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.90.237.146', '2019-07-11 17:54:41', 2, 0, '', '2019-07-11 17:54:41');
INSERT INTO `access_log` VALUES (52875, '64.76.15628388810531417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '113.90.237.146', '2019-07-11 17:54:41', 2, 0, '', '2019-07-11 17:54:41');
INSERT INTO `access_log` VALUES (52876, '65.50.15628389033533053', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.90.237.146', '2019-07-11 17:55:03', 0, 1002001015, '账号未登陆', '2019-07-11 17:55:03');
INSERT INTO `access_log` VALUES (52877, '65.45.15628389033533019', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.90.237.146', '2019-07-11 17:55:03', 0, 1002001015, '账号未登陆', '2019-07-11 17:55:03');
INSERT INTO `access_log` VALUES (52878, '65.46.15628389033563095', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.90.237.146', '2019-07-11 17:55:03', 1, 1002001015, '账号未登陆', '2019-07-11 17:55:03');
INSERT INTO `access_log` VALUES (52879, '65.52.15628389056733071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.90.237.146', '2019-07-11 17:55:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 17:55:06');
INSERT INTO `access_log` VALUES (52880, '65.3607.15628389171424831', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.90.237.146', '2019-07-11 17:55:17', 86, 0, '', '2019-07-11 17:55:17');
INSERT INTO `access_log` VALUES (52881, '65.49.15628389175603027', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.90.237.146', '2019-07-11 17:55:18', 190, 0, '', '2019-07-11 17:55:18');
INSERT INTO `access_log` VALUES (52882, '65.54.15628389175662989', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.90.237.146', '2019-07-11 17:55:18', 281, 2001001000, '服务端发生异常', '2019-07-11 17:55:18');
INSERT INTO `access_log` VALUES (52883, '65.47.15628389218603021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.90.237.146', '2019-07-11 17:55:22', 57, 0, '', '2019-07-11 17:55:22');
INSERT INTO `access_log` VALUES (52884, '65.53.15628389221723037', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.90.237.146', '2019-07-11 17:55:22', 16, 0, '', '2019-07-11 17:55:22');
INSERT INTO `access_log` VALUES (52885, '65.50.15628389221793055', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.90.237.146', '2019-07-11 17:55:22', 16, 0, '', '2019-07-11 17:55:22');
INSERT INTO `access_log` VALUES (52886, '65.52.15628389420943073', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.197.1.242', '2019-07-11 17:55:42', 1, 1002001015, '账号未登陆', '2019-07-11 17:55:42');
INSERT INTO `access_log` VALUES (52887, '65.51.15628389420953095', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.197.1.242', '2019-07-11 17:55:42', 0, 1002001015, '账号未登陆', '2019-07-11 17:55:42');
INSERT INTO `access_log` VALUES (52888, '65.3607.15628389421014833', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.197.1.242', '2019-07-11 17:55:42', 0, 1002001015, '账号未登陆', '2019-07-11 17:55:42');
INSERT INTO `access_log` VALUES (52889, '59.72.15628404586391269', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-11 18:20:59', 10, 0, '', '2019-07-11 18:20:59');
INSERT INTO `access_log` VALUES (52890, '59.78.15628404586381267', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-11 18:20:59', 26, 2001001000, '服务端发生异常', '2019-07-11 18:20:59');
INSERT INTO `access_log` VALUES (52891, '64.78.15628404638601449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-11 18:21:04', 14, 0, '', '2019-07-11 18:21:04');
INSERT INTO `access_log` VALUES (52892, '64.84.15628404640101441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-11 18:21:04', 7, 0, '', '2019-07-11 18:21:04');
INSERT INTO `access_log` VALUES (52893, '64.79.15628404656421445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-11 18:21:06', 8, 0, '', '2019-07-11 18:21:06');
INSERT INTO `access_log` VALUES (52894, '64.82.15628404659991461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-11 18:21:06', 9, 0, '', '2019-07-11 18:21:06');
INSERT INTO `access_log` VALUES (52895, '64.83.15628404685981443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-11 18:21:09', 8, 0, '', '2019-07-11 18:21:09');
INSERT INTO `access_log` VALUES (52896, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-11 18:21:09', 13, 0, '', '2019-07-11 18:21:09');
INSERT INTO `access_log` VALUES (52897, '64.77.15628404711151431', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.5.82.188', '2019-07-11 18:21:11', 13, 0, '', '2019-07-11 18:21:11');
INSERT INTO `access_log` VALUES (52898, '59.72.15628405730721271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.87.161.108', '2019-07-11 18:22:53', 3, 0, '', '2019-07-11 18:22:53');
INSERT INTO `access_log` VALUES (52899, '59.78.15628405730781269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.87.161.108', '2019-07-11 18:22:53', 13, 2001001000, '服务端发生异常', '2019-07-11 18:22:53');
INSERT INTO `access_log` VALUES (52900, '64.83.15628407251591447', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.5.82.188', '2019-07-11 18:25:25', 14, 0, '', '2019-07-11 18:25:25');
INSERT INTO `access_log` VALUES (52901, '64.80.15628409262631461', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '218.5.82.188', '2019-07-11 18:28:46', 15, 0, '', '2019-07-11 18:28:46');
INSERT INTO `access_log` VALUES (52902, '59.79.15628433224901311', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.88.37.210', '2019-07-11 19:08:42', 12, 0, '', '2019-07-11 19:08:43');
INSERT INTO `access_log` VALUES (52903, '59.73.15628433224911315', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.88.37.210', '2019-07-11 19:08:42', 25, 2001001000, '服务端发生异常', '2019-07-11 19:08:43');
INSERT INTO `access_log` VALUES (52904, '59.78.15628439839221315', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-11 19:19:44', 4, 0, '', '2019-07-11 19:19:44');
INSERT INTO `access_log` VALUES (52905, '59.76.15628439839241311', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.95.111.254', '2019-07-11 19:19:44', 21, 2001001000, '服务端发生异常', '2019-07-11 19:19:44');
INSERT INTO `access_log` VALUES (52906, '64.77.15628440092791479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '101.95.111.254', '2019-07-11 19:20:09', 16, 0, '', '2019-07-11 19:20:09');
INSERT INTO `access_log` VALUES (52907, '64.78.15628440093981499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '101.95.111.254', '2019-07-11 19:20:09', 4, 0, '', '2019-07-11 19:20:09');
INSERT INTO `access_log` VALUES (52908, '64.85.15628440111361509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '101.95.111.254', '2019-07-11 19:20:11', 2, 0, '', '2019-07-11 19:20:11');
INSERT INTO `access_log` VALUES (52909, '64.84.15628440123191489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '101.95.111.254', '2019-07-11 19:20:12', 2, 0, '', '2019-07-11 19:20:12');
INSERT INTO `access_log` VALUES (52910, '65.50.15628511534533219', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '101.229.209.149', '2019-07-11 21:19:13', 0, 1002001015, '账号未登陆', '2019-07-11 21:19:13');
INSERT INTO `access_log` VALUES (52911, '65.46.15628511534543261', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '101.229.209.149', '2019-07-11 21:19:13', 0, 1002001015, '账号未登陆', '2019-07-11 21:19:13');
INSERT INTO `access_log` VALUES (52912, '65.45.15628511534553185', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '101.229.209.149', '2019-07-11 21:19:13', 1, 1002001015, '账号未登陆', '2019-07-11 21:19:13');
INSERT INTO `access_log` VALUES (52913, '65.51.15628511718533259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '101.229.209.149', '2019-07-11 21:19:32', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 21:19:32');
INSERT INTO `access_log` VALUES (52914, '65.46.15628516923853269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '101.229.209.149', '2019-07-11 21:28:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 21:28:12');
INSERT INTO `access_log` VALUES (52915, '59.79.15628524118241433', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.3', '2019-07-11 21:40:12', 11, 0, '', '2019-07-11 21:40:12');
INSERT INTO `access_log` VALUES (52916, '59.73.15628524118261437', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.68', '2019-07-11 21:40:12', 19, 2001001000, '服务端发生异常', '2019-07-11 21:40:12');
INSERT INTO `access_log` VALUES (52917, '59.75.15628558530001487', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:37:33', 10, 0, '', '2019-07-11 22:37:33');
INSERT INTO `access_log` VALUES (52918, '59.73.15628558530001483', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:37:33', 19, 2001001000, '服务端发生异常', '2019-07-11 22:37:33');
INSERT INTO `access_log` VALUES (52919, '64.76.15628558571171649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:37:37', 12, 0, '', '2019-07-11 22:37:37');
INSERT INTO `access_log` VALUES (52920, '64.81.15628558572631637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:37:37', 3, 0, '', '2019-07-11 22:37:37');
INSERT INTO `access_log` VALUES (52921, '59.72.15628558611511477', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:37:41', 3, 0, '', '2019-07-11 22:37:41');
INSERT INTO `access_log` VALUES (52922, '59.71.15628558611481483', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:37:41', 17, 2001001000, '服务端发生异常', '2019-07-11 22:37:41');
INSERT INTO `access_log` VALUES (52923, '59.76.15628558679611471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:37:48', 3, 0, '', '2019-07-11 22:37:48');
INSERT INTO `access_log` VALUES (52924, '59.78.15628558679581475', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:37:48', 21, 2001001000, '服务端发生异常', '2019-07-11 22:37:48');
INSERT INTO `access_log` VALUES (52925, '64.79.15628558773431653', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:37:57', 2, 0, '', '2019-07-11 22:37:57');
INSERT INTO `access_log` VALUES (52926, '64.82.15628558774551669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:37:57', 1, 0, '', '2019-07-11 22:37:57');
INSERT INTO `access_log` VALUES (52927, '59.79.15628558783551481', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:37:58', 2, 0, '', '2019-07-11 22:37:58');
INSERT INTO `access_log` VALUES (52928, '59.80.15628558783521461', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:37:58', 12, 2001001000, '服务端发生异常', '2019-07-11 22:37:58');
INSERT INTO `access_log` VALUES (52929, '64.83.15628558800971651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:00', 1, 0, '', '2019-07-11 22:38:00');
INSERT INTO `access_log` VALUES (52930, '64.77.15628558802311639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:00', 3, 0, '', '2019-07-11 22:38:00');
INSERT INTO `access_log` VALUES (52931, '64.78.15628558816951659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:02', 2, 0, '', '2019-07-11 22:38:02');
INSERT INTO `access_log` VALUES (52932, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:02', 5, 0, '', '2019-07-11 22:38:02');
INSERT INTO `access_log` VALUES (52933, '64.85.15628558832881669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:03', 2, 0, '', '2019-07-11 22:38:03');
INSERT INTO `access_log` VALUES (52934, '64.84.15628558834211649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:03', 2, 0, '', '2019-07-11 22:38:03');
INSERT INTO `access_log` VALUES (52935, '64.76.15628558847851651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:05', 2, 0, '', '2019-07-11 22:38:05');
INSERT INTO `access_log` VALUES (52936, '64.80.15628558857851663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:06', 2, 0, '', '2019-07-11 22:38:06');
INSERT INTO `access_log` VALUES (52937, '59.77.15628558898601469', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:10', 2, 0, '', '2019-07-11 22:38:10');
INSERT INTO `access_log` VALUES (52938, '59.73.15628558898571485', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:10', 16, 2001001000, '服务端发生异常', '2019-07-11 22:38:10');
INSERT INTO `access_log` VALUES (52939, '64.79.15628558932031655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:13', 2, 0, '', '2019-07-11 22:38:13');
INSERT INTO `access_log` VALUES (52940, '64.82.15628558933401671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:13', 2, 0, '', '2019-07-11 22:38:13');
INSERT INTO `access_log` VALUES (52941, '59.71.15628558952221485', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:15', 2, 0, '', '2019-07-11 22:38:15');
INSERT INTO `access_log` VALUES (52942, '59.72.15628558952191479', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:15', 12, 2001001000, '服务端发生异常', '2019-07-11 22:38:15');
INSERT INTO `access_log` VALUES (52943, '64.77.15628559099421641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:30', 2, 0, '', '2019-07-11 22:38:30');
INSERT INTO `access_log` VALUES (52944, '64.78.15628559101121661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:30', 2, 0, '', '2019-07-11 22:38:30');
INSERT INTO `access_log` VALUES (52945, '64.85.15628559129281671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:33', 2, 0, '', '2019-07-11 22:38:33');
INSERT INTO `access_log` VALUES (52946, '64.84.15628559130741651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:33', 2, 0, '', '2019-07-11 22:38:33');
INSERT INTO `access_log` VALUES (52947, '59.74.15628559189171489', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:39', 3, 0, '', '2019-07-11 22:38:39');
INSERT INTO `access_log` VALUES (52948, '59.79.15628559189171483', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '223.73.60.161', '2019-07-11 22:38:39', 20, 2001001000, '服务端发生异常', '2019-07-11 22:38:39');
INSERT INTO `access_log` VALUES (52949, '59.79.15628560555791485', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:40:56', 3, 0, '', '2019-07-11 22:40:56');
INSERT INTO `access_log` VALUES (52950, '59.80.15628560555851465', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:40:56', 18, 2001001000, '服务端发生异常', '2019-07-11 22:40:56');
INSERT INTO `access_log` VALUES (52951, '59.75.15628560597371493', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:00', 3, 0, '', '2019-07-11 22:41:00');
INSERT INTO `access_log` VALUES (52952, '59.73.15628560597371489', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:00', 12, 2001001000, '服务端发生异常', '2019-07-11 22:41:00');
INSERT INTO `access_log` VALUES (52953, '64.76.15628560628811655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:03', 2, 0, '', '2019-07-11 22:41:03');
INSERT INTO `access_log` VALUES (52954, '64.81.15628560630001643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:03', 1, 0, '', '2019-07-11 22:41:03');
INSERT INTO `access_log` VALUES (52955, '64.79.15628560664891659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:06', 2, 0, '', '2019-07-11 22:41:06');
INSERT INTO `access_log` VALUES (52956, '64.82.15628560666141675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:07', 2, 0, '', '2019-07-11 22:41:07');
INSERT INTO `access_log` VALUES (52957, '64.83.15628560703321657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:10', 2, 0, '', '2019-07-11 22:41:10');
INSERT INTO `access_log` VALUES (52958, '64.77.15628560704321645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:10', 2, 0, '', '2019-07-11 22:41:10');
INSERT INTO `access_log` VALUES (52959, '59.78.15628560809761481', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.30.233.39', '2019-07-11 22:41:21', 3, 0, '', '2019-07-11 22:41:21');
INSERT INTO `access_log` VALUES (52960, '59.71.15628560809761489', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.30.233.39', '2019-07-11 22:41:21', 13, 2001001000, '服务端发生异常', '2019-07-11 22:41:21');
INSERT INTO `access_log` VALUES (52961, '65.52.15628560976923303', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:38', 0, 1002001015, '账号未登陆', '2019-07-11 22:41:38');
INSERT INTO `access_log` VALUES (52962, '65.45.15628560976933251', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:38', 1, 1002001015, '账号未登陆', '2019-07-11 22:41:38');
INSERT INTO `access_log` VALUES (52963, '65.51.15628560977123325', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:38', 1, 1002001015, '账号未登陆', '2019-07-11 22:41:38');
INSERT INTO `access_log` VALUES (52964, '65.49.15628561030243261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 22:41:43');
INSERT INTO `access_log` VALUES (52965, '65.54.15628561062503221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:46', 58, 0, '', '2019-07-11 22:41:46');
INSERT INTO `access_log` VALUES (52966, '65.47.15628561065473255', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:47', 12, 0, '', '2019-07-11 22:41:47');
INSERT INTO `access_log` VALUES (52967, '65.53.15628561065493271', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:47', 11, 2001001000, '服务端发生异常', '2019-07-11 22:41:47');
INSERT INTO `access_log` VALUES (52968, '65.46.15628561065543329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:47', 10, 0, '', '2019-07-11 22:41:47');
INSERT INTO `access_log` VALUES (52969, '65.52.15628561187513305', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:59', 10, 0, '', '2019-07-11 22:41:59');
INSERT INTO `access_log` VALUES (52970, '65.51.15628561187533327', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:59', 11, 2001001000, '服务端发生异常', '2019-07-11 22:41:59');
INSERT INTO `access_log` VALUES (52971, '65.45.15628561187693253', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '117.30.233.39', '2019-07-11 22:41:59', 8, 0, '', '2019-07-11 22:41:59');
INSERT INTO `access_log` VALUES (52972, '65.50.15628582977543319', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.210.88', '2019-07-11 23:18:18', 0, 1002001015, '账号未登陆', '2019-07-11 23:18:18');
INSERT INTO `access_log` VALUES (52973, '65.47.15628582977543285', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.210.88', '2019-07-11 23:18:18', 1, 1002001015, '账号未登陆', '2019-07-11 23:18:18');
INSERT INTO `access_log` VALUES (52974, '65.51.15628582977543357', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.210.88', '2019-07-11 23:18:18', 0, 1002001015, '账号未登陆', '2019-07-11 23:18:18');
INSERT INTO `access_log` VALUES (52975, '65.52.15628583011723335', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.210.88', '2019-07-11 23:18:21', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 23:18:21');
INSERT INTO `access_log` VALUES (52976, '65.3607.15628583089765097', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.210.88', '2019-07-11 23:18:29', 65, 0, '', '2019-07-11 23:18:29');
INSERT INTO `access_log` VALUES (52977, '65.49.15628583092653293', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.210.88', '2019-07-11 23:18:29', 11, 0, '', '2019-07-11 23:18:29');
INSERT INTO `access_log` VALUES (52978, '65.54.15628583092653253', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.210.88', '2019-07-11 23:18:29', 12, 2001001000, '服务端发生异常', '2019-07-11 23:18:29');
INSERT INTO `access_log` VALUES (52979, '65.53.15628583092693303', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.210.88', '2019-07-11 23:18:29', 10, 0, '', '2019-07-11 23:18:29');
INSERT INTO `access_log` VALUES (52980, '59.78.15628596505741529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '101.87.69.60', '2019-07-11 23:40:51', 10, 0, '', '2019-07-11 23:40:51');
INSERT INTO `access_log` VALUES (52981, '59.71.15628596505741537', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '101.87.69.60', '2019-07-11 23:40:51', 15, 2001001000, '服务端发生异常', '2019-07-11 23:40:51');
INSERT INTO `access_log` VALUES (52982, '59.74.15628596659621541', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.87.69.60', '2019-07-11 23:41:06', 3, 0, '', '2019-07-11 23:41:06');
INSERT INTO `access_log` VALUES (52983, '59.80.15628596659671515', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.87.69.60', '2019-07-11 23:41:06', 18, 2001001000, '服务端发生异常', '2019-07-11 23:41:06');
INSERT INTO `access_log` VALUES (52984, '64.78.15628596738931713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.87.69.60', '2019-07-11 23:41:14', 13, 0, '', '2019-07-11 23:41:14');
INSERT INTO `access_log` VALUES (52985, '64.85.15628596740531723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.87.69.60', '2019-07-11 23:41:14', 3, 0, '', '2019-07-11 23:41:14');
INSERT INTO `access_log` VALUES (52986, '64.84.15628596755841703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.87.69.60', '2019-07-11 23:41:16', 2, 0, '', '2019-07-11 23:41:16');
INSERT INTO `access_log` VALUES (52987, '64.76.15628596762421705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.87.69.60', '2019-07-11 23:41:16', 2, 0, '', '2019-07-11 23:41:16');
INSERT INTO `access_log` VALUES (52988, '64.81.15628596768721693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.87.69.60', '2019-07-11 23:41:17', 2, 0, '', '2019-07-11 23:41:17');
INSERT INTO `access_log` VALUES (52989, '64.80.15628596773351717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.87.69.60', '2019-07-11 23:41:17', 2, 0, '', '2019-07-11 23:41:17');
INSERT INTO `access_log` VALUES (52990, '64.79.15628596780111709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.87.69.60', '2019-07-11 23:41:18', 2, 0, '', '2019-07-11 23:41:18');
INSERT INTO `access_log` VALUES (52991, '64.83.15628596814091707', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.87.69.60', '2019-07-11 23:41:21', 2, 0, '', '2019-07-11 23:41:21');
INSERT INTO `access_log` VALUES (52992, '64.77.15628596818521695', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.87.69.60', '2019-07-11 23:41:22', 2, 0, '', '2019-07-11 23:41:22');
INSERT INTO `access_log` VALUES (52993, '59.78.15628597311401531', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.87.69.60', '2019-07-11 23:42:11', 2, 0, '', '2019-07-11 23:42:11');
INSERT INTO `access_log` VALUES (52994, '59.72.15628597311381533', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '101.87.69.60', '2019-07-11 23:42:11', 12, 2001001000, '服务端发生异常', '2019-07-11 23:42:11');
INSERT INTO `access_log` VALUES (52995, '65.53.15628597574783323', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '101.87.69.60', '2019-07-11 23:42:37', 0, 1002001015, '账号未登陆', '2019-07-11 23:42:37');
INSERT INTO `access_log` VALUES (52996, '65.3607.15628597574785117', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '101.87.69.60', '2019-07-11 23:42:37', 0, 1002001015, '账号未登陆', '2019-07-11 23:42:37');
INSERT INTO `access_log` VALUES (52997, '65.54.15628597574833273', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '101.87.69.60', '2019-07-11 23:42:37', 0, 1002001015, '账号未登陆', '2019-07-11 23:42:37');
INSERT INTO `access_log` VALUES (52998, '65.46.15628597597733381', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '101.87.69.60', '2019-07-11 23:42:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-11 23:42:40');
INSERT INTO `access_log` VALUES (52999, '65.51.15628597650773379', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '101.87.69.60', '2019-07-11 23:42:45', 99, 0, '', '2019-07-11 23:42:45');
INSERT INTO `access_log` VALUES (53000, '65.47.15628597655273307', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '101.87.69.60', '2019-07-11 23:42:46', 9, 0, '', '2019-07-11 23:42:46');
INSERT INTO `access_log` VALUES (53001, '65.50.15628597655253341', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '101.87.69.60', '2019-07-11 23:42:46', 10, 2001001000, '服务端发生异常', '2019-07-11 23:42:46');
INSERT INTO `access_log` VALUES (53002, '65.52.15628597655293357', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '101.87.69.60', '2019-07-11 23:42:46', 8, 0, '', '2019-07-11 23:42:46');
INSERT INTO `access_log` VALUES (53003, '65.52.15628600304653361', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.89.4.38', '2019-07-11 23:47:10', 0, 1002001015, '账号未登陆', '2019-07-11 23:47:10');
INSERT INTO `access_log` VALUES (53004, '65.47.15628600304783311', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.89.4.38', '2019-07-11 23:47:10', 0, 1002001015, '账号未登陆', '2019-07-11 23:47:10');
INSERT INTO `access_log` VALUES (53005, '65.45.15628600304783309', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.89.4.38', '2019-07-11 23:47:10', 0, 1002001015, '账号未登陆', '2019-07-11 23:47:10');
INSERT INTO `access_log` VALUES (53006, '65.54.15628600348873279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.30.5.207', '2019-07-11 23:47:15', 63, 0, '', '2019-07-11 23:47:15');
INSERT INTO `access_log` VALUES (53007, '65.3607.15628600352605123', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.30.5.207', '2019-07-11 23:47:15', 170, 0, '', '2019-07-11 23:47:15');
INSERT INTO `access_log` VALUES (53008, '65.49.15628600352693319', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.89.4.38', '2019-07-11 23:47:15', 163, 0, '', '2019-07-11 23:47:15');
INSERT INTO `access_log` VALUES (53009, '65.53.15628600352693329', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.30.5.207', '2019-07-11 23:47:15', 164, 2001001000, '服务端发生异常', '2019-07-11 23:47:15');
INSERT INTO `access_log` VALUES (53010, '65.46.15628600416693387', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.30.5.207', '2019-07-11 23:47:22', 10, 0, '', '2019-07-11 23:47:22');
INSERT INTO `access_log` VALUES (53011, '65.51.15628600416733385', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.30.5.207', '2019-07-11 23:47:22', 9, 2001001000, '服务端发生异常', '2019-07-11 23:47:22');
INSERT INTO `access_log` VALUES (53012, '65.50.15628600416833347', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.89.4.38', '2019-07-11 23:47:22', 9, 0, '', '2019-07-11 23:47:22');
INSERT INTO `access_log` VALUES (53013, '65.3607.15628600901285125', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.129.6.227', '2019-07-11 23:48:10', 1, 1002001015, '账号未登陆', '2019-07-11 23:48:10');
INSERT INTO `access_log` VALUES (53014, '65.53.15628600901463331', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.89.239.120', '2019-07-11 23:48:10', 0, 1002001015, '账号未登陆', '2019-07-11 23:48:10');
INSERT INTO `access_log` VALUES (53015, '65.49.15628600901663321', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.91.60.104', '2019-07-11 23:48:10', 0, 1002001015, '账号未登陆', '2019-07-11 23:48:10');
INSERT INTO `access_log` VALUES (53016, '65.51.15628600940763387', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.89.4.38', '2019-07-11 23:48:14', 10, 0, '', '2019-07-11 23:48:14');
INSERT INTO `access_log` VALUES (53017, '65.50.15628600941153349', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.30.5.207', '2019-07-11 23:48:14', 9, 0, '', '2019-07-11 23:48:14');
INSERT INTO `access_log` VALUES (53018, '65.46.15628600941143389', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.89.4.38', '2019-07-11 23:48:14', 10, 2001001000, '服务端发生异常', '2019-07-11 23:48:14');
INSERT INTO `access_log` VALUES (53019, '65.47.15628600974683315', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '116.30.5.207', '2019-07-11 23:48:17', 9, 0, '', '2019-07-11 23:48:17');
INSERT INTO `access_log` VALUES (53020, '65.45.15628600974723313', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.89.4.38', '2019-07-11 23:48:17', 8, 0, '', '2019-07-11 23:48:17');
INSERT INTO `access_log` VALUES (53021, '65.52.15628600977603365', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.89.4.38', '2019-07-11 23:48:18', 10, 2001001000, '服务端发生异常', '2019-07-11 23:48:18');
INSERT INTO `access_log` VALUES (53022, '65.3607.15628601079225127', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.89.4.38', '2019-07-11 23:48:28', 10, 0, '', '2019-07-11 23:48:28');
INSERT INTO `access_log` VALUES (53023, '65.53.15628601079283333', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.89.4.38', '2019-07-11 23:48:28', 9, 0, '', '2019-07-11 23:48:28');
INSERT INTO `access_log` VALUES (53024, '65.49.15628601079273323', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.89.4.38', '2019-07-11 23:48:28', 9, 2001001000, '服务端发生异常', '2019-07-11 23:48:28');
INSERT INTO `access_log` VALUES (53025, '59.72.15628604709401543', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; PAR-AL00 Build/HUAWEIPAR-AL00) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.188.7.156', '2019-07-11 23:54:31', 3, 0, '', '2019-07-11 23:54:31');
INSERT INTO `access_log` VALUES (53026, '59.71.15628604709411549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; PAR-AL00 Build/HUAWEIPAR-AL00) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.188.7.156', '2019-07-11 23:54:31', 13, 2001001000, '服务端发生异常', '2019-07-11 23:54:31');
INSERT INTO `access_log` VALUES (53027, '64.76.15628604762031717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; PAR-AL00 Build/HUAWEIPAR-AL00) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.188.7.156', '2019-07-11 23:54:36', 4, 0, '', '2019-07-11 23:54:36');
INSERT INTO `access_log` VALUES (53028, '64.81.15628604764071705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; PAR-AL00 Build/HUAWEIPAR-AL00) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.188.7.156', '2019-07-11 23:54:36', 2, 0, '', '2019-07-11 23:54:36');
INSERT INTO `access_log` VALUES (53029, '64.80.15628604784331729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; PAR-AL00 Build/HUAWEIPAR-AL00) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.188.7.156', '2019-07-11 23:54:38', 2, 0, '', '2019-07-11 23:54:38');
INSERT INTO `access_log` VALUES (53030, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; PAR-AL00 Build/HUAWEIPAR-AL00) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.188.7.156', '2019-07-11 23:54:38', 5, 0, '', '2019-07-11 23:54:38');
INSERT INTO `access_log` VALUES (53031, '64.79.15628604808631721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; PAR-AL00 Build/HUAWEIPAR-AL00) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.188.7.156', '2019-07-11 23:54:41', 2, 0, '', '2019-07-11 23:54:41');
INSERT INTO `access_log` VALUES (53032, '64.82.15628604810831737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; PAR-AL00 Build/HUAWEIPAR-AL00) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.188.7.156', '2019-07-11 23:54:41', 2, 0, '', '2019-07-11 23:54:41');
INSERT INTO `access_log` VALUES (53033, '59.74.15628604823271553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; PAR-AL00 Build/HUAWEIPAR-AL00) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.188.7.156', '2019-07-11 23:54:42', 2, 0, '', '2019-07-11 23:54:42');
INSERT INTO `access_log` VALUES (53034, '59.80.15628604823291527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9;zh-cn; PAR-AL00 Build/HUAWEIPAR-AL00) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.188.7.156', '2019-07-11 23:54:42', 13, 2001001000, '服务端发生异常', '2019-07-11 23:54:42');
INSERT INTO `access_log` VALUES (53035, '65.47.15628897136043711', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:01:54', 0, 1002001015, '账号未登陆', '2019-07-12 08:01:54');
INSERT INTO `access_log` VALUES (53036, '65.52.15628897193303761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:01:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 08:01:59');
INSERT INTO `access_log` VALUES (53037, '65.54.15628897239113679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:02:04', 5, 1002002001, '密码不正确', '2019-07-12 08:02:04');
INSERT INTO `access_log` VALUES (53038, '65.51.15628897598093785', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:02:40', 63, 0, '', '2019-07-12 08:02:40');
INSERT INTO `access_log` VALUES (53039, '65.46.15628897602213787', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:02:40', 25, 0, '', '2019-07-12 08:02:40');
INSERT INTO `access_log` VALUES (53040, '65.47.15628897602233713', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:02:40', 29, 0, '', '2019-07-12 08:02:40');
INSERT INTO `access_log` VALUES (53041, '65.50.15628897602173747', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:02:40', 36, 0, '', '2019-07-12 08:02:40');
INSERT INTO `access_log` VALUES (53042, '65.45.15628897635613711', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:02:44', 16, 0, '', '2019-07-12 08:02:44');
INSERT INTO `access_log` VALUES (53043, '65.54.15628897758793681', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:02:56', 10, 0, '', '2019-07-12 08:02:56');
INSERT INTO `access_log` VALUES (53044, '65.53.15628897872103731', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:03:07', 22, 0, '', '2019-07-12 08:03:07');
INSERT INTO `access_log` VALUES (53045, '65.49.15628897890123721', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:03:09', 9, 0, '', '2019-07-12 08:03:09');
INSERT INTO `access_log` VALUES (53046, '65.49.15628906243193733', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:17:04', 98, 0, '', '2019-07-12 08:17:04');
INSERT INTO `access_log` VALUES (53047, '65.51.15628906272023799', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:17:07', 31, 0, '', '2019-07-12 08:17:07');
INSERT INTO `access_log` VALUES (53048, '65.46.15628906323203801', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:17:12', 12, 0, '', '2019-07-12 08:17:12');
INSERT INTO `access_log` VALUES (53049, '65.50.15628906370613759', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:17:17', 10, 0, '', '2019-07-12 08:17:17');
INSERT INTO `access_log` VALUES (53050, '65.52.15628906550543777', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:17:35', 9, 0, '', '2019-07-12 08:17:35');
INSERT INTO `access_log` VALUES (53051, '65.53.15628906594643745', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:17:39', 12, 0, '', '2019-07-12 08:17:39');
INSERT INTO `access_log` VALUES (53052, '65.3607.15628906656025539', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:17:46', 10, 0, '', '2019-07-12 08:17:46');
INSERT INTO `access_log` VALUES (53053, '59.71.15628913204331961', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.90.147', '2019-07-12 08:28:40', 11, 0, '', '2019-07-12 08:28:40');
INSERT INTO `access_log` VALUES (53054, '59.76.15628913204341949', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.90.147', '2019-07-12 08:28:40', 25, 2001001000, '服务端发生异常', '2019-07-12 08:28:40');
INSERT INTO `access_log` VALUES (53055, '64.80.15628913318682141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.90.147', '2019-07-12 08:28:52', 12, 0, '', '2019-07-12 08:28:52');
INSERT INTO `access_log` VALUES (53056, '64.79.15628913319872133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.90.147', '2019-07-12 08:28:52', 3, 0, '', '2019-07-12 08:28:52');
INSERT INTO `access_log` VALUES (53057, '64.82.15628913370452149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.90.147', '2019-07-12 08:28:57', 2, 0, '', '2019-07-12 08:28:57');
INSERT INTO `access_log` VALUES (53058, '64.83.15628913371632131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.90.147', '2019-07-12 08:28:57', 1, 0, '', '2019-07-12 08:28:57');
INSERT INTO `access_log` VALUES (53059, '59.79.15628913464631959', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.90.147', '2019-07-12 08:29:06', 3, 0, '', '2019-07-12 08:29:06');
INSERT INTO `access_log` VALUES (53060, '59.75.15628913464641967', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.90.147', '2019-07-12 08:29:06', 19, 2001001000, '服务端发生异常', '2019-07-12 08:29:06');
INSERT INTO `access_log` VALUES (53061, '59.76.15628913911671951', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.90.147', '2019-07-12 08:29:51', 2, 0, '', '2019-07-12 08:29:51');
INSERT INTO `access_log` VALUES (53062, '59.72.15628913911671957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.90.147', '2019-07-12 08:29:51', 15, 2001001000, '服务端发生异常', '2019-07-12 08:29:51');
INSERT INTO `access_log` VALUES (53063, '65.49.15628917167043749', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:35:17', 12, 0, '', '2019-07-12 08:35:17');
INSERT INTO `access_log` VALUES (53064, '65.47.15628917277223743', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:35:28', 20, 0, '', '2019-07-12 08:35:28');
INSERT INTO `access_log` VALUES (53065, '64.79.15628917356312139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.30.194.225', '2019-07-12 08:35:36', 2, 0, '', '2019-07-12 08:35:36');
INSERT INTO `access_log` VALUES (53066, '64.82.15628917357292155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.30.194.225', '2019-07-12 08:35:36', 3, 0, '', '2019-07-12 08:35:36');
INSERT INTO `access_log` VALUES (53067, '59.79.15628917380251965', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.30.194.225', '2019-07-12 08:35:38', 4, 0, '', '2019-07-12 08:35:38');
INSERT INTO `access_log` VALUES (53068, '59.75.15628917380591973', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.30.194.225', '2019-07-12 08:35:38', 16, 2001001000, '服务端发生异常', '2019-07-12 08:35:38');
INSERT INTO `access_log` VALUES (53069, '64.83.15628917401652137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.30.194.225', '2019-07-12 08:35:40', 2, 0, '', '2019-07-12 08:35:40');
INSERT INTO `access_log` VALUES (53070, '64.77.15628917402552125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.30.194.225', '2019-07-12 08:35:40', 1, 0, '', '2019-07-12 08:35:40');
INSERT INTO `access_log` VALUES (53071, '65.50.15628917424983775', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:35:42', 11, 0, '', '2019-07-12 08:35:43');
INSERT INTO `access_log` VALUES (53072, '59.77.15628917427611953', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.30.194.225', '2019-07-12 08:35:43', 3, 0, '', '2019-07-12 08:35:43');
INSERT INTO `access_log` VALUES (53073, '59.73.15628917427611969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.30.194.225', '2019-07-12 08:35:43', 17, 2001001000, '服务端发生异常', '2019-07-12 08:35:43');
INSERT INTO `access_log` VALUES (53074, '65.45.15628917439473741', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:35:44', 10, 0, '', '2019-07-12 08:35:44');
INSERT INTO `access_log` VALUES (53075, '64.78.15628917448652145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.30.194.225', '2019-07-12 08:35:45', 1, 0, '', '2019-07-12 08:35:45');
INSERT INTO `access_log` VALUES (53076, '64.85.15628917449692155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.30.194.225', '2019-07-12 08:35:45', 2, 0, '', '2019-07-12 08:35:45');
INSERT INTO `access_log` VALUES (53077, '65.52.15628917452203793', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:35:45', 15, 0, '', '2019-07-12 08:35:45');
INSERT INTO `access_log` VALUES (53078, '65.53.15628917544693761', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:35:54', 18, 0, '', '2019-07-12 08:35:54');
INSERT INTO `access_log` VALUES (53079, '65.46.15628918276243819', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:37:08', 12, 0, '', '2019-07-12 08:37:08');
INSERT INTO `access_log` VALUES (53080, '65.45.15628918362863743', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:37:16', 11, 0, '', '2019-07-12 08:37:16');
INSERT INTO `access_log` VALUES (53081, '64.84.15628918873432137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.90.147', '2019-07-12 08:38:07', 3, 0, '', '2019-07-12 08:38:07');
INSERT INTO `access_log` VALUES (53082, '64.76.15628918874732139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.90.147', '2019-07-12 08:38:07', 2, 0, '', '2019-07-12 08:38:07');
INSERT INTO `access_log` VALUES (53083, '64.80.15628919081822151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.90.147', '2019-07-12 08:38:28', 2, 0, '', '2019-07-12 08:38:28');
INSERT INTO `access_log` VALUES (53084, '64.79.15628919109532143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.90.147', '2019-07-12 08:38:31', 2, 0, '', '2019-07-12 08:38:31');
INSERT INTO `access_log` VALUES (53085, '65.50.15628921005763781', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 08:41:41', 12, 0, '', '2019-07-12 08:41:41');
INSERT INTO `access_log` VALUES (53086, '59.79.15628921291381971', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.128.169.238', '2019-07-12 08:42:09', 3, 0, '', '2019-07-12 08:42:09');
INSERT INTO `access_log` VALUES (53087, '59.75.15628921291381979', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.128.169.238', '2019-07-12 08:42:09', 16, 2001001000, '服务端发生异常', '2019-07-12 08:42:09');
INSERT INTO `access_log` VALUES (53088, '65.47.15628930954553763', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.62.130', '2019-07-12 08:58:15', 4, 1002001012, '访问令牌已过期', '2019-07-12 08:58:15');
INSERT INTO `access_log` VALUES (53089, '65.51.15628930954553835', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.62.130', '2019-07-12 08:58:15', 4, 1002001012, '访问令牌已过期', '2019-07-12 08:58:15');
INSERT INTO `access_log` VALUES (53090, '65.46.15628930954573837', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.62.130', '2019-07-12 08:58:15', 3, 1002001012, '访问令牌已过期', '2019-07-12 08:58:15');
INSERT INTO `access_log` VALUES (53091, '65.45.15628931074933761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.62.130', '2019-07-12 08:58:27', 67, 0, '', '2019-07-12 08:58:28');
INSERT INTO `access_log` VALUES (53092, '65.52.15628931077853813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.62.130', '2019-07-12 08:58:28', 11, 0, '', '2019-07-12 08:58:28');
INSERT INTO `access_log` VALUES (53093, '65.54.15628931077853729', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.62.130', '2019-07-12 08:58:28', 13, 2001001000, '服务端发生异常', '2019-07-12 08:58:28');
INSERT INTO `access_log` VALUES (53094, '65.53.15628931077873781', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.62.130', '2019-07-12 08:58:28', 11, 0, '', '2019-07-12 08:58:28');
INSERT INTO `access_log` VALUES (53095, '65.54.15628932489873731', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.160.132.185', '2019-07-12 09:00:49', 1, 1002001015, '账号未登陆', '2019-07-12 09:00:49');
INSERT INTO `access_log` VALUES (53096, '65.3607.15628932489915577', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.160.132.185', '2019-07-12 09:00:49', 1, 1002001015, '账号未登陆', '2019-07-12 09:00:49');
INSERT INTO `access_log` VALUES (53097, '65.49.15628932489933773', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.160.132.185', '2019-07-12 09:00:49', 0, 1002001015, '账号未登陆', '2019-07-12 09:00:49');
INSERT INTO `access_log` VALUES (53098, '65.47.15628932613213767', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.160.132.185', '2019-07-12 09:01:01', 60, 0, '', '2019-07-12 09:01:01');
INSERT INTO `access_log` VALUES (53099, '65.45.15628932616293765', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.160.132.185', '2019-07-12 09:01:02', 8, 0, '', '2019-07-12 09:01:02');
INSERT INTO `access_log` VALUES (53100, '65.46.15628932616233841', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.160.132.185', '2019-07-12 09:01:02', 50, 0, '', '2019-07-12 09:01:02');
INSERT INTO `access_log` VALUES (53101, '65.50.15628932616263799', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.160.132.185', '2019-07-12 09:01:02', 54, 2001001000, '服务端发生异常', '2019-07-12 09:01:02');
INSERT INTO `access_log` VALUES (53102, '65.46.15628948715453865', 0, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 09:27:52', 4, 1002001012, '访问令牌已过期', '2019-07-12 09:27:52');
INSERT INTO `access_log` VALUES (53103, '65.51.15628948759003863', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 09:27:56', 88, 0, '', '2019-07-12 09:27:56');
INSERT INTO `access_log` VALUES (53104, '65.45.15628948762613789', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 09:27:56', 17, 0, '', '2019-07-12 09:27:56');
INSERT INTO `access_log` VALUES (53105, '65.52.15628948762733839', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 09:27:56', 9, 0, '', '2019-07-12 09:27:56');
INSERT INTO `access_log` VALUES (53106, '65.50.15628948762653821', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 09:27:56', 9, 0, '', '2019-07-12 09:27:56');
INSERT INTO `access_log` VALUES (53107, '65.53.15628948785643809', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 09:27:59', 18, 0, '', '2019-07-12 09:27:59');
INSERT INTO `access_log` VALUES (53108, '65.3607.15628948795105603', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 09:28:00', 10, 0, '', '2019-07-12 09:28:00');
INSERT INTO `access_log` VALUES (53109, '65.49.15628948834183797', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 09:28:03', 18, 0, '', '2019-07-12 09:28:03');
INSERT INTO `access_log` VALUES (53110, '65.54.15628948871003755', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 09:28:07', 10, 0, '', '2019-07-12 09:28:07');
INSERT INTO `access_log` VALUES (53111, '65.54.15628959046193769', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.128.134.135', '2019-07-12 09:45:05', 0, 1002001015, '账号未登陆', '2019-07-12 09:45:05');
INSERT INTO `access_log` VALUES (53112, '65.49.15628959046173811', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.128.134.135', '2019-07-12 09:45:05', 1, 1002001015, '账号未登陆', '2019-07-12 09:45:05');
INSERT INTO `access_log` VALUES (53113, '65.46.15628959046193881', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.128.134.135', '2019-07-12 09:45:05', 0, 1002001015, '账号未登陆', '2019-07-12 09:45:05');
INSERT INTO `access_log` VALUES (53114, '65.51.15628959118753879', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.128.134.135', '2019-07-12 09:45:12', 158, 0, '', '2019-07-12 09:45:12');
INSERT INTO `access_log` VALUES (53115, '65.45.15628959144643805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.128.134.135', '2019-07-12 09:45:14', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 09:45:14');
INSERT INTO `access_log` VALUES (53116, '65.52.15628959164983855', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.129.68.5', '2019-07-12 09:45:16', 1, 1002001015, '账号未登陆', '2019-07-12 09:45:16');
INSERT INTO `access_log` VALUES (53117, '65.50.15628959164983837', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.129.68.5', '2019-07-12 09:45:16', 1, 1002001015, '账号未登陆', '2019-07-12 09:45:16');
INSERT INTO `access_log` VALUES (53118, '65.53.15628959164993825', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.129.68.5', '2019-07-12 09:45:16', 0, 1002001015, '账号未登陆', '2019-07-12 09:45:16');
INSERT INTO `access_log` VALUES (53119, '65.3607.15628959197565619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.128.134.135', '2019-07-12 09:45:20', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 09:45:20');
INSERT INTO `access_log` VALUES (53120, '65.49.15628959241843813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '61.128.134.135', '2019-07-12 09:45:24', 89, 0, '', '2019-07-12 09:45:24');
INSERT INTO `access_log` VALUES (53121, '65.45.15628961271693809', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.67.157.13', '2019-07-12 09:48:47', 1, 1002001015, '账号未登陆', '2019-07-12 09:48:47');
INSERT INTO `access_log` VALUES (53122, '65.52.15628961271693859', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.67.157.13', '2019-07-12 09:48:47', 0, 1002001015, '账号未登陆', '2019-07-12 09:48:47');
INSERT INTO `access_log` VALUES (53123, '65.53.15628961271733829', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.67.157.13', '2019-07-12 09:48:47', 1, 1002001015, '账号未登陆', '2019-07-12 09:48:47');
INSERT INTO `access_log` VALUES (53124, '65.50.15628961281583841', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.151.207.186', '2019-07-12 09:48:48', 0, 1002001015, '账号未登陆', '2019-07-12 09:48:48');
INSERT INTO `access_log` VALUES (53125, '65.3607.15628961321735623', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.67.157.13', '2019-07-12 09:48:52', 106, 0, '', '2019-07-12 09:48:52');
INSERT INTO `access_log` VALUES (53126, '65.46.15628961324773887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.67.157.13', '2019-07-12 09:48:52', 9, 0, '', '2019-07-12 09:48:52');
INSERT INTO `access_log` VALUES (53127, '65.54.15628961324813775', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.67.157.13', '2019-07-12 09:48:52', 9, 0, '', '2019-07-12 09:48:52');
INSERT INTO `access_log` VALUES (53128, '65.49.15628961324803817', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.67.157.13', '2019-07-12 09:48:52', 10, 2001001000, '服务端发生异常', '2019-07-12 09:48:52');
INSERT INTO `access_log` VALUES (53129, '65.51.15628961395143885', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.67.157.13', '2019-07-12 09:49:00', 9, 0, '', '2019-07-12 09:49:00');
INSERT INTO `access_log` VALUES (53130, '65.53.15628961395163831', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.67.157.13', '2019-07-12 09:49:00', 8, 0, '', '2019-07-12 09:49:00');
INSERT INTO `access_log` VALUES (53131, '65.52.15628961395163861', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.67.157.13', '2019-07-12 09:49:00', 10, 2001001000, '服务端发生异常', '2019-07-12 09:49:00');
INSERT INTO `access_log` VALUES (53132, '65.3607.15628961740045625', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 09:49:34', 19, 0, '', '2019-07-12 09:49:34');
INSERT INTO `access_log` VALUES (53133, '65.51.15628962505073887', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.129.68.5', '2019-07-12 09:50:51', 86, 0, '', '2019-07-12 09:50:51');
INSERT INTO `access_log` VALUES (53134, '65.45.15628962549843813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.129.68.5', '2019-07-12 09:50:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 09:50:55');
INSERT INTO `access_log` VALUES (53135, '65.50.15628962624203845', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.129.68.5', '2019-07-12 09:51:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 09:51:02');
INSERT INTO `access_log` VALUES (53136, '65.3607.15628962684525627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.129.68.5', '2019-07-12 09:51:08', 73, 0, '', '2019-07-12 09:51:09');
INSERT INTO `access_log` VALUES (53137, '65.46.15628962762333891', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.129.68.5', '2019-07-12 09:51:16', 57, 0, '', '2019-07-12 09:51:16');
INSERT INTO `access_log` VALUES (53138, '65.50.15628968115453853', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:00:12', 1, 1002001015, '账号未登陆', '2019-07-12 10:00:12');
INSERT INTO `access_log` VALUES (53139, '65.3607.15628968115595635', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:00:12', 0, 1002001015, '账号未登陆', '2019-07-12 10:00:12');
INSERT INTO `access_log` VALUES (53140, '65.49.15628968115783829', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:00:12', 0, 1002001015, '账号未登陆', '2019-07-12 10:00:12');
INSERT INTO `access_log` VALUES (53141, '65.46.15628968157113899', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:00:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 10:00:16');
INSERT INTO `access_log` VALUES (53142, '65.47.15628968295113823', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:00:30', 70, 0, '', '2019-07-12 10:00:30');
INSERT INTO `access_log` VALUES (53143, '65.53.15628968299403843', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:00:30', 17, 0, '', '2019-07-12 10:00:30');
INSERT INTO `access_log` VALUES (53144, '65.51.15628968299603897', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:00:30', 9, 0, '', '2019-07-12 10:00:30');
INSERT INTO `access_log` VALUES (53145, '65.52.15628968299613873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:00:30', 9, 2001001000, '服务端发生异常', '2019-07-12 10:00:30');
INSERT INTO `access_log` VALUES (53146, '59.75.15628970240532045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:03:44', 10, 0, '', '2019-07-12 10:03:44');
INSERT INTO `access_log` VALUES (53147, '59.73.15628970240532041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:03:44', 18, 2001001000, '服务端发生异常', '2019-07-12 10:03:44');
INSERT INTO `access_log` VALUES (53148, '64.83.15628970279272209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:03:48', 11, 0, '', '2019-07-12 10:03:48');
INSERT INTO `access_log` VALUES (53149, '64.77.15628970280872197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:03:48', 3, 0, '', '2019-07-12 10:03:48');
INSERT INTO `access_log` VALUES (53150, '64.78.15628970296572217', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:03:50', 2, 0, '', '2019-07-12 10:03:50');
INSERT INTO `access_log` VALUES (53151, '64.85.15628970301372227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:03:50', 2, 0, '', '2019-07-12 10:03:50');
INSERT INTO `access_log` VALUES (53152, '66.49.15628970463080023', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13212341234', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '223.104.213.27', '2019-07-12 10:04:06', 272, 0, '', '2019-07-12 10:04:07');
INSERT INTO `access_log` VALUES (53153, '66.56.15628970649170017', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13212341234', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:25', 5, 1001003005, '短信发送过于频率', '2019-07-12 10:04:25');
INSERT INTO `access_log` VALUES (53154, '64.80.15628970727572221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:33', 2, 0, '', '2019-07-12 10:04:33');
INSERT INTO `access_log` VALUES (53155, '64.79.15628970728772213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:33', 2, 0, '', '2019-07-12 10:04:33');
INSERT INTO `access_log` VALUES (53156, '64.82.15628970738572229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:34', 2, 0, '', '2019-07-12 10:04:34');
INSERT INTO `access_log` VALUES (53157, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:34', 8, 0, '', '2019-07-12 10:04:34');
INSERT INTO `access_log` VALUES (53158, '64.77.15628970761772199', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:36', 94, 0, '', '2019-07-12 10:04:36');
INSERT INTO `access_log` VALUES (53159, '64.78.15628970867222219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:47', 2, 0, '', '2019-07-12 10:04:47');
INSERT INTO `access_log` VALUES (53160, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:47', 6, 0, '', '2019-07-12 10:04:47');
INSERT INTO `access_log` VALUES (53161, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:50', 5, 0, '', '2019-07-12 10:04:50');
INSERT INTO `access_log` VALUES (53162, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:50', 5, 0, '', '2019-07-12 10:04:50');
INSERT INTO `access_log` VALUES (53163, '64.84.15628970914272209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:51', 2, 0, '', '2019-07-12 10:04:51');
INSERT INTO `access_log` VALUES (53164, '64.76.15628970917782211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:52', 2, 0, '', '2019-07-12 10:04:52');
INSERT INTO `access_log` VALUES (53165, '64.81.15628970925332199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:53', 2, 0, '', '2019-07-12 10:04:53');
INSERT INTO `access_log` VALUES (53166, '64.80.15628970934222223', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:53', 2, 0, '', '2019-07-12 10:04:53');
INSERT INTO `access_log` VALUES (53167, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:53', 6, 0, '', '2019-07-12 10:04:53');
INSERT INTO `access_log` VALUES (53168, '64.79.15628970957172215', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:04:56', 7, 0, '', '2019-07-12 10:04:56');
INSERT INTO `access_log` VALUES (53169, '64.82.15628971021982231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:05:02', 2, 0, '', '2019-07-12 10:05:02');
INSERT INTO `access_log` VALUES (53170, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:05:02', 6, 0, '', '2019-07-12 10:05:02');
INSERT INTO `access_log` VALUES (53171, '64.83.15628971029472213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:05:03', 3, 0, '', '2019-07-12 10:05:03');
INSERT INTO `access_log` VALUES (53172, '64.77.15628971030772201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.213.27', '2019-07-12 10:05:03', 2, 0, '', '2019-07-12 10:05:03');
INSERT INTO `access_log` VALUES (53173, '59.71.15628973835662045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.135.29', '2019-07-12 10:09:44', 3, 0, '', '2019-07-12 10:09:44');
INSERT INTO `access_log` VALUES (53174, '59.74.15628973835672047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.135.29', '2019-07-12 10:09:44', 33, 2001001000, '服务端发生异常', '2019-07-12 10:09:44');
INSERT INTO `access_log` VALUES (53175, '65.53.15628973993973851', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.135.29', '2019-07-12 10:09:59', 1, 1002001015, '账号未登陆', '2019-07-12 10:09:59');
INSERT INTO `access_log` VALUES (53176, '65.52.15628973994333881', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.135.29', '2019-07-12 10:09:59', 1, 1002001015, '账号未登陆', '2019-07-12 10:09:59');
INSERT INTO `access_log` VALUES (53177, '65.45.15628973994363831', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.135.29', '2019-07-12 10:09:59', 0, 1002001015, '账号未登陆', '2019-07-12 10:09:59');
INSERT INTO `access_log` VALUES (53178, '65.3607.15628974044495645', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.135.29', '2019-07-12 10:10:04', 71, 0, '', '2019-07-12 10:10:05');
INSERT INTO `access_log` VALUES (53179, '65.50.15628974049813863', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.135.29', '2019-07-12 10:10:05', 10, 0, '', '2019-07-12 10:10:05');
INSERT INTO `access_log` VALUES (53180, '65.49.15628974049923839', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.135.29', '2019-07-12 10:10:05', 11, 2001001000, '服务端发生异常', '2019-07-12 10:10:05');
INSERT INTO `access_log` VALUES (53181, '65.46.15628974050033909', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.135.29', '2019-07-12 10:10:05', 9, 0, '', '2019-07-12 10:10:05');
INSERT INTO `access_log` VALUES (53182, '65.53.15628975906873855', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.227.203.219', '2019-07-12 10:13:11', 1, 1002001015, '账号未登陆', '2019-07-12 10:13:11');
INSERT INTO `access_log` VALUES (53183, '65.52.15628975906903885', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.227.203.219', '2019-07-12 10:13:11', 0, 1002001015, '账号未登陆', '2019-07-12 10:13:11');
INSERT INTO `access_log` VALUES (53184, '65.45.15628975906953835', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.227.203.219', '2019-07-12 10:13:11', 1, 1002001015, '账号未登陆', '2019-07-12 10:13:11');
INSERT INTO `access_log` VALUES (53185, '65.3607.15628975945345649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.227.203.219', '2019-07-12 10:13:15', 420, 0, '', '2019-07-12 10:13:15');
INSERT INTO `access_log` VALUES (53186, '65.46.15628975953123913', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.227.203.219', '2019-07-12 10:13:15', 10, 0, '', '2019-07-12 10:13:15');
INSERT INTO `access_log` VALUES (53187, '65.50.15628975953123867', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.227.203.219', '2019-07-12 10:13:15', 10, 0, '', '2019-07-12 10:13:15');
INSERT INTO `access_log` VALUES (53188, '65.49.15628975953143843', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.227.203.219', '2019-07-12 10:13:15', 10, 2001001000, '服务端发生异常', '2019-07-12 10:13:15');
INSERT INTO `access_log` VALUES (53189, '65.54.15628976032833801', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.227.203.219', '2019-07-12 10:13:23', 9, 0, '', '2019-07-12 10:13:23');
INSERT INTO `access_log` VALUES (53190, '65.47.15628976032913837', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.227.203.219', '2019-07-12 10:13:23', 10, 2001001000, '服务端发生异常', '2019-07-12 10:13:23');
INSERT INTO `access_log` VALUES (53191, '65.51.15628976033023911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.227.203.219', '2019-07-12 10:13:23', 9, 0, '', '2019-07-12 10:13:23');
INSERT INTO `access_log` VALUES (53192, '65.46.15628976528213915', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:14:13', 185, 0, '', '2019-07-12 10:14:13');
INSERT INTO `access_log` VALUES (53193, '65.50.15628976554273869', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.12.69.66', '2019-07-12 10:14:15', 0, 1002001015, '账号未登陆', '2019-07-12 10:14:15');
INSERT INTO `access_log` VALUES (53194, '65.49.15628976554283845', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.12.69.66', '2019-07-12 10:14:15', 1, 1002001015, '账号未登陆', '2019-07-12 10:14:15');
INSERT INTO `access_log` VALUES (53195, '65.47.15628976554303839', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.12.69.66', '2019-07-12 10:14:15', 0, 1002001015, '账号未登陆', '2019-07-12 10:14:15');
INSERT INTO `access_log` VALUES (53196, '65.51.15628976569003913', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=6', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:14:17', 10, 0, '', '2019-07-12 10:14:17');
INSERT INTO `access_log` VALUES (53197, '65.54.15628976633833803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.12.69.66', '2019-07-12 10:14:23', 66, 0, '', '2019-07-12 10:14:23');
INSERT INTO `access_log` VALUES (53198, '65.53.15628976637933859', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.12.69.66', '2019-07-12 10:14:24', 10, 0, '', '2019-07-12 10:14:24');
INSERT INTO `access_log` VALUES (53199, '65.52.15628976638013889', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.12.69.66', '2019-07-12 10:14:24', 10, 2001001000, '服务端发生异常', '2019-07-12 10:14:24');
INSERT INTO `access_log` VALUES (53200, '65.45.15628976638053839', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.12.69.66', '2019-07-12 10:14:24', 9, 0, '', '2019-07-12 10:14:24');
INSERT INTO `access_log` VALUES (53201, '65.46.15628976652173917', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:14:25', 1, 1002001015, '账号未登陆', '2019-07-12 10:14:25');
INSERT INTO `access_log` VALUES (53202, '65.47.15628976652253841', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:14:25', 0, 1002001015, '账号未登陆', '2019-07-12 10:14:25');
INSERT INTO `access_log` VALUES (53203, '65.50.15628976652313871', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:14:25', 0, 1002001015, '账号未登陆', '2019-07-12 10:14:25');
INSERT INTO `access_log` VALUES (53204, '65.49.15628976690283847', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:14:29', 11, 0, '', '2019-07-12 10:14:29');
INSERT INTO `access_log` VALUES (53205, '65.51.15628976715473915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:14:32', 88, 0, '', '2019-07-12 10:14:32');
INSERT INTO `access_log` VALUES (53206, '65.52.15628976719423891', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:14:32', 9, 2001001000, '服务端发生异常', '2019-07-12 10:14:32');
INSERT INTO `access_log` VALUES (53207, '65.45.15628976719493841', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:14:32', 8, 0, '', '2019-07-12 10:14:32');
INSERT INTO `access_log` VALUES (53208, '65.54.15628976719373805', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:14:32', 257, 0, '', '2019-07-12 10:14:32');
INSERT INTO `access_log` VALUES (53209, '59.71.15628976737302049', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.12.69.66', '2019-07-12 10:14:34', 3, 0, '', '2019-07-12 10:14:34');
INSERT INTO `access_log` VALUES (53210, '59.80.15628976737322027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.12.69.66', '2019-07-12 10:14:34', 20, 2001001000, '服务端发生异常', '2019-07-12 10:14:34');
INSERT INTO `access_log` VALUES (53211, '65.47.15628976978613843', 1, 2, 'admin-application', '/admin-api/admins/role/add', 'name=商品管理员', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:14:58', 97, 0, '', '2019-07-12 10:14:58');
INSERT INTO `access_log` VALUES (53212, '65.46.15628976981093919', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:14:58', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-07-12 10:14:58');
INSERT INTO `access_log` VALUES (53213, '65.50.15628977022863873', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:15:02', 0, 1002001015, '账号未登陆', '2019-07-12 10:15:02');
INSERT INTO `access_log` VALUES (53214, '65.49.15628977022873849', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:15:02', 0, 1002001015, '账号未登陆', '2019-07-12 10:15:02');
INSERT INTO `access_log` VALUES (53215, '65.51.15628977022933917', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:15:02', 0, 1002001015, '账号未登陆', '2019-07-12 10:15:02');
INSERT INTO `access_log` VALUES (53216, '65.52.15628977026543893', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:15:03', 9, 0, '', '2019-07-12 10:15:03');
INSERT INTO `access_log` VALUES (53217, '65.45.15628977035723843', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:15:04', 10, 0, '', '2019-07-12 10:15:04');
INSERT INTO `access_log` VALUES (53218, '65.54.15628977040873807', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:15:04', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 10:15:04');
INSERT INTO `access_log` VALUES (53219, '65.53.15628977064303863', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:15:06', 18, 0, '', '2019-07-12 10:15:06');
INSERT INTO `access_log` VALUES (53220, '65.3607.15628977075345657', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:15:08', 11, 0, '', '2019-07-12 10:15:08');
INSERT INTO `access_log` VALUES (53221, '65.46.15628977134003921', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:15:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 10:15:13');
INSERT INTO `access_log` VALUES (53222, '65.51.15628977168483919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:15:17', 176, 0, '', '2019-07-12 10:15:17');
INSERT INTO `access_log` VALUES (53223, '65.50.15628977181143875', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:15:18', 9, 0, '', '2019-07-12 10:15:18');
INSERT INTO `access_log` VALUES (53224, '65.49.15628977181183851', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:15:18', 9, 2001001000, '服务端发生异常', '2019-07-12 10:15:18');
INSERT INTO `access_log` VALUES (53225, '65.52.15628977181193895', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:15:18', 8, 0, '', '2019-07-12 10:15:18');
INSERT INTO `access_log` VALUES (53226, '65.52.15628978423163897', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:17:22', 4, 1002001012, '访问令牌已过期', '2019-07-12 10:17:22');
INSERT INTO `access_log` VALUES (53227, '65.45.15628978472293847', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:17:27', 269, 0, '', '2019-07-12 10:17:27');
INSERT INTO `access_log` VALUES (53228, '65.54.15628978477673811', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:17:28', 10, 0, '', '2019-07-12 10:17:28');
INSERT INTO `access_log` VALUES (53229, '65.53.15628978477693867', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:17:28', 8, 0, '', '2019-07-12 10:17:28');
INSERT INTO `access_log` VALUES (53230, '65.3607.15628978477695661', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:17:28', 9, 0, '', '2019-07-12 10:17:28');
INSERT INTO `access_log` VALUES (53231, '65.47.15628978509963849', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:17:31', 10, 0, '', '2019-07-12 10:17:31');
INSERT INTO `access_log` VALUES (53232, '65.46.15628978538153925', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:17:34', 10, 0, '', '2019-07-12 10:17:34');
INSERT INTO `access_log` VALUES (53233, '65.51.15628978561203923', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 10:17:36', 9, 0, '', '2019-07-12 10:17:36');
INSERT INTO `access_log` VALUES (53234, '65.53.15628985454863877', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.11.185.13', '2019-07-12 10:29:05', 1, 1002001015, '账号未登陆', '2019-07-12 10:29:05');
INSERT INTO `access_log` VALUES (53235, '65.47.15628985454983859', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.11.185.13', '2019-07-12 10:29:05', 1, 1002001015, '账号未登陆', '2019-07-12 10:29:05');
INSERT INTO `access_log` VALUES (53236, '65.46.15628985454983935', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.11.185.13', '2019-07-12 10:29:05', 0, 1002001015, '账号未登陆', '2019-07-12 10:29:05');
INSERT INTO `access_log` VALUES (53237, '65.50.15628985503413889', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.11.185.13', '2019-07-12 10:29:10', 135, 0, '', '2019-07-12 10:29:10');
INSERT INTO `access_log` VALUES (53238, '65.52.15628985507883909', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.11.185.13', '2019-07-12 10:29:11', 112, 0, '', '2019-07-12 10:29:11');
INSERT INTO `access_log` VALUES (53239, '65.45.15628985508003859', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.11.185.13', '2019-07-12 10:29:11', 100, 0, '', '2019-07-12 10:29:11');
INSERT INTO `access_log` VALUES (53240, '65.49.15628985507973865', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '111.11.185.13', '2019-07-12 10:29:11', 104, 2001001000, '服务端发生异常', '2019-07-12 10:29:11');
INSERT INTO `access_log` VALUES (53241, '59.74.15628988148692067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.35', '2019-07-12 10:33:35', 3, 0, '', '2019-07-12 10:33:35');
INSERT INTO `access_log` VALUES (53242, '59.80.15628988148862043', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.64.119.35', '2019-07-12 10:33:35', 12, 2001001000, '服务端发生异常', '2019-07-12 10:33:35');
INSERT INTO `access_log` VALUES (53243, '65.47.15628988866303865', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:34:47', 1, 1002001015, '账号未登陆', '2019-07-12 10:34:47');
INSERT INTO `access_log` VALUES (53244, '65.46.15628988866323941', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:34:47', 0, 1002001015, '账号未登陆', '2019-07-12 10:34:47');
INSERT INTO `access_log` VALUES (53245, '65.53.15628988866383883', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:34:47', 1, 1002001015, '账号未登陆', '2019-07-12 10:34:47');
INSERT INTO `access_log` VALUES (53246, '65.51.15628988923883939', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-12 10:34:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 10:34:52');
INSERT INTO `access_log` VALUES (53247, '59.71.15629004593082087', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.50.114', '2019-07-12 11:00:59', 3, 0, '', '2019-07-12 11:00:59');
INSERT INTO `access_log` VALUES (53248, '59.80.15629004593062065', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.50.114', '2019-07-12 11:00:59', 13, 2001001000, '服务端发生异常', '2019-07-12 11:00:59');
INSERT INTO `access_log` VALUES (53249, '59.73.15629013682412101', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.97.101', '2019-07-12 11:16:08', 3, 0, '', '2019-07-12 11:16:08');
INSERT INTO `access_log` VALUES (53250, '59.75.15629013682422105', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.97.101', '2019-07-12 11:16:08', 13, 2001001000, '服务端发生异常', '2019-07-12 11:16:08');
INSERT INTO `access_log` VALUES (53251, '64.80.15629013737972281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.97.101', '2019-07-12 11:16:14', 66, 0, '', '2019-07-12 11:16:14');
INSERT INTO `access_log` VALUES (53252, '64.79.15629013739692273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.97.101', '2019-07-12 11:16:14', 3, 0, '', '2019-07-12 11:16:14');
INSERT INTO `access_log` VALUES (53253, '64.82.15629013782222289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.97.101', '2019-07-12 11:16:18', 2, 0, '', '2019-07-12 11:16:18');
INSERT INTO `access_log` VALUES (53254, '64.83.15629013784242271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.97.101', '2019-07-12 11:16:18', 2, 0, '', '2019-07-12 11:16:18');
INSERT INTO `access_log` VALUES (53255, '59.78.15629013816362093', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.97.101', '2019-07-12 11:16:22', 2, 0, '', '2019-07-12 11:16:22');
INSERT INTO `access_log` VALUES (53256, '59.76.15629013816832089', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.97.101', '2019-07-12 11:16:22', 18, 2001001000, '服务端发生异常', '2019-07-12 11:16:22');
INSERT INTO `access_log` VALUES (53257, '64.78.15629013885352279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.97.101', '2019-07-12 11:16:29', 2, 0, '', '2019-07-12 11:16:29');
INSERT INTO `access_log` VALUES (53258, '64.85.15629013887032289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.97.101', '2019-07-12 11:16:29', 1, 0, '', '2019-07-12 11:16:29');
INSERT INTO `access_log` VALUES (53259, '59.72.15629013904522093', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.97.101', '2019-07-12 11:16:30', 2, 0, '', '2019-07-12 11:16:30');
INSERT INTO `access_log` VALUES (53260, '59.74.15629013904682103', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.194.97.101', '2019-07-12 11:16:30', 16, 2001001000, '服务端发生异常', '2019-07-12 11:16:30');
INSERT INTO `access_log` VALUES (53261, '65.49.15629017659073909', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.125', '2019-07-12 11:22:46', 1, 1002001015, '账号未登陆', '2019-07-12 11:22:46');
INSERT INTO `access_log` VALUES (53262, '65.45.15629017659073903', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.125', '2019-07-12 11:22:46', 0, 1002001015, '账号未登陆', '2019-07-12 11:22:46');
INSERT INTO `access_log` VALUES (53263, '65.3607.15629017659355717', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.125', '2019-07-12 11:22:46', 1, 1002001015, '账号未登陆', '2019-07-12 11:22:46');
INSERT INTO `access_log` VALUES (53264, '65.54.15629017673953867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.125', '2019-07-12 11:22:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 11:22:47');
INSERT INTO `access_log` VALUES (53265, '65.46.15629017687473981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.125', '2019-07-12 11:22:49', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 11:22:49');
INSERT INTO `access_log` VALUES (53266, '65.53.15629017816753923', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.125', '2019-07-12 11:23:02', 116, 0, '', '2019-07-12 11:23:02');
INSERT INTO `access_log` VALUES (53267, '65.51.15629017820203979', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.125', '2019-07-12 11:23:02', 10, 0, '', '2019-07-12 11:23:02');
INSERT INTO `access_log` VALUES (53268, '65.50.15629017820213935', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.125', '2019-07-12 11:23:02', 11, 2001001000, '服务端发生异常', '2019-07-12 11:23:02');
INSERT INTO `access_log` VALUES (53269, '65.52.15629017820253955', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.67.158.125', '2019-07-12 11:23:02', 8, 0, '', '2019-07-12 11:23:02');
INSERT INTO `access_log` VALUES (53270, '59.76.15629020968042099', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '111.205.32.126', '2019-07-12 11:28:17', 4, 0, '', '2019-07-12 11:28:17');
INSERT INTO `access_log` VALUES (53271, '59.74.15629020968082113', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '111.205.32.126', '2019-07-12 11:28:17', 16, 2001001000, '服务端发生异常', '2019-07-12 11:28:17');
INSERT INTO `access_log` VALUES (53272, '64.77.15629020997212269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '111.205.32.126', '2019-07-12 11:28:20', 4, 0, '', '2019-07-12 11:28:20');
INSERT INTO `access_log` VALUES (53273, '64.78.15629020998332289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '111.205.32.126', '2019-07-12 11:28:20', 2, 0, '', '2019-07-12 11:28:20');
INSERT INTO `access_log` VALUES (53274, '64.84.15629021027972279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '111.205.32.126', '2019-07-12 11:28:23', 2, 0, '', '2019-07-12 11:28:23');
INSERT INTO `access_log` VALUES (53275, '59.75.15629033539872133', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 11:49:14', 4, 0, '', '2019-07-12 11:49:14');
INSERT INTO `access_log` VALUES (53276, '59.73.15629033539882129', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 11:49:14', 41, 2001001000, '服务端发生异常', '2019-07-12 11:49:14');
INSERT INTO `access_log` VALUES (53277, '65.53.15629033599193945', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 11:49:20', 0, 1002001015, '账号未登陆', '2019-07-12 11:49:20');
INSERT INTO `access_log` VALUES (53278, '65.47.15629033599193927', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 11:49:20', 0, 1002001015, '账号未登陆', '2019-07-12 11:49:20');
INSERT INTO `access_log` VALUES (53279, '65.51.15629033599204001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 11:49:20', 0, 1002001015, '账号未登陆', '2019-07-12 11:49:20');
INSERT INTO `access_log` VALUES (53280, '65.49.15629033875753933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 11:49:48', 65, 0, '', '2019-07-12 11:49:48');
INSERT INTO `access_log` VALUES (53281, '65.3607.15629033879725741', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 11:49:48', 11, 0, '', '2019-07-12 11:49:48');
INSERT INTO `access_log` VALUES (53282, '65.45.15629033879713927', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 11:49:48', 12, 2001001000, '服务端发生异常', '2019-07-12 11:49:48');
INSERT INTO `access_log` VALUES (53283, '65.54.15629033879863891', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 11:49:48', 8, 0, '', '2019-07-12 11:49:48');
INSERT INTO `access_log` VALUES (53284, '65.51.15629033949224003', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 11:49:55', 9, 0, '', '2019-07-12 11:49:55');
INSERT INTO `access_log` VALUES (53285, '65.47.15629033949263929', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 11:49:55', 10, 2001001000, '服务端发生异常', '2019-07-12 11:49:55');
INSERT INTO `access_log` VALUES (53286, '65.53.15629033949443947', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 11:49:55', 8, 0, '', '2019-07-12 11:49:55');
INSERT INTO `access_log` VALUES (53287, '62.83.15629039553811363', 0, 1, 'pay-application', '/pay-api/users/refund/pingxx_refund_success', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.13.14.198', '2019-07-12 11:59:15', 388, 2001001000, '服务端发生异常', '2019-07-12 11:59:16');
INSERT INTO `access_log` VALUES (53288, '62.80.15629039664691351', 0, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=1024', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.13.14.198', '2019-07-12 11:59:26', 47, 2001001002, '参数校验不正确\n\n详细错误如下：\n用户编号不能为空', '2019-07-12 11:59:27');
INSERT INTO `access_log` VALUES (53289, '59.77.15629064989412155', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '121.23.67.240', '2019-07-12 12:41:39', 12, 0, '', '2019-07-12 12:41:39');
INSERT INTO `access_log` VALUES (53290, '59.78.15629064989412163', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '121.23.67.240', '2019-07-12 12:41:39', 18, 2001001000, '服务端发生异常', '2019-07-12 12:41:39');
INSERT INTO `access_log` VALUES (53291, '65.3607.15629075929675799', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.116.159.239', '2019-07-12 12:59:53', 0, 1002001015, '账号未登陆', '2019-07-12 12:59:53');
INSERT INTO `access_log` VALUES (53292, '65.45.15629075929673983', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.116.159.239', '2019-07-12 12:59:53', 1, 1002001015, '账号未登陆', '2019-07-12 12:59:53');
INSERT INTO `access_log` VALUES (53293, '65.46.15629075929854063', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.116.159.239', '2019-07-12 12:59:53', 0, 1002001015, '账号未登陆', '2019-07-12 12:59:53');
INSERT INTO `access_log` VALUES (53294, '65.51.15629075951784061', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.116.159.239', '2019-07-12 12:59:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 12:59:55');
INSERT INTO `access_log` VALUES (53295, '65.47.15629076135563987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.116.159.239', '2019-07-12 13:00:14', 125, 0, '', '2019-07-12 13:00:14');
INSERT INTO `access_log` VALUES (53296, '65.50.15629076139614017', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.116.159.239', '2019-07-12 13:00:14', 21, 0, '', '2019-07-12 13:00:14');
INSERT INTO `access_log` VALUES (53297, '65.52.15629076139734037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.116.159.239', '2019-07-12 13:00:14', 10, 0, '', '2019-07-12 13:00:14');
INSERT INTO `access_log` VALUES (53298, '65.49.15629076139643993', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.116.159.239', '2019-07-12 13:00:14', 19, 2001001000, '服务端发生异常', '2019-07-12 13:00:14');
INSERT INTO `access_log` VALUES (53299, '59.77.15629096235612197', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:33:44', 11, 0, '', '2019-07-12 13:33:44');
INSERT INTO `access_log` VALUES (53300, '59.78.15629096235622205', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:33:44', 26, 2001001000, '服务端发生异常', '2019-07-12 13:33:44');
INSERT INTO `access_log` VALUES (53301, '65.46.15629098647244095', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:37:45', 0, 1002001015, '账号未登陆', '2019-07-12 13:37:45');
INSERT INTO `access_log` VALUES (53302, '65.3607.15629098647245831', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:37:45', 0, 1002001015, '账号未登陆', '2019-07-12 13:37:45');
INSERT INTO `access_log` VALUES (53303, '65.45.15629098647254015', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:37:45', 0, 1002001015, '账号未登陆', '2019-07-12 13:37:45');
INSERT INTO `access_log` VALUES (53304, '65.54.15629098666983979', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:37:47', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 13:37:47');
INSERT INTO `access_log` VALUES (53305, '65.53.15629098829904037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:38:03', 135, 0, '', '2019-07-12 13:38:03');
INSERT INTO `access_log` VALUES (53306, '65.47.15629098833754019', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:38:03', 11, 0, '', '2019-07-12 13:38:03');
INSERT INTO `access_log` VALUES (53307, '65.49.15629098833804025', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:38:03', 10, 2001001000, '服务端发生异常', '2019-07-12 13:38:03');
INSERT INTO `access_log` VALUES (53308, '65.50.15629098833904049', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:38:03', 9, 0, '', '2019-07-12 13:38:03');
INSERT INTO `access_log` VALUES (53309, '65.54.15629099102823981', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:38:30', 10, 0, '', '2019-07-12 13:38:30');
INSERT INTO `access_log` VALUES (53310, '65.45.15629099102794017', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:38:30', 103, 2001001000, '服务端发生异常', '2019-07-12 13:38:30');
INSERT INTO `access_log` VALUES (53311, '65.3607.15629099102765833', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:38:30', 110, 0, '', '2019-07-12 13:38:30');
INSERT INTO `access_log` VALUES (53312, '59.75.15629100093762223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:40:09', 4, 0, '', '2019-07-12 13:40:09');
INSERT INTO `access_log` VALUES (53313, '59.73.15629100093772219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:40:09', 13, 2001001000, '服务端发生异常', '2019-07-12 13:40:09');
INSERT INTO `access_log` VALUES (53314, '59.80.15629100817332197', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:41:22', 4, 0, '', '2019-07-12 13:41:22');
INSERT INTO `access_log` VALUES (53315, '59.71.15629100817412219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:41:22', 15, 2001001000, '服务端发生异常', '2019-07-12 13:41:22');
INSERT INTO `access_log` VALUES (53316, '64.80.15629100896422399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:41:30', 13, 0, '', '2019-07-12 13:41:30');
INSERT INTO `access_log` VALUES (53317, '64.79.15629100897452391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:41:30', 4, 0, '', '2019-07-12 13:41:30');
INSERT INTO `access_log` VALUES (53318, '64.82.15629100917482407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:41:32', 2, 0, '', '2019-07-12 13:41:32');
INSERT INTO `access_log` VALUES (53319, '64.83.15629100923642389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:41:32', 1, 0, '', '2019-07-12 13:41:32');
INSERT INTO `access_log` VALUES (53320, '65.50.15629106820514061', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 13:51:22', 84, 1002001012, '访问令牌已过期', '2019-07-12 13:51:22');
INSERT INTO `access_log` VALUES (53321, '65.47.15629106820514031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 13:51:22', 84, 1002001012, '访问令牌已过期', '2019-07-12 13:51:22');
INSERT INTO `access_log` VALUES (53322, '65.53.15629106820434049', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 13:51:22', 92, 1002001012, '访问令牌已过期', '2019-07-12 13:51:22');
INSERT INTO `access_log` VALUES (53323, '65.52.15629106879954081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 13:51:28', 122, 0, '', '2019-07-12 13:51:28');
INSERT INTO `access_log` VALUES (53324, '65.46.15629106883914109', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 13:51:28', 10, 0, '', '2019-07-12 13:51:28');
INSERT INTO `access_log` VALUES (53325, '65.54.15629106883913993', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 13:51:28', 9, 0, '', '2019-07-12 13:51:28');
INSERT INTO `access_log` VALUES (53326, '65.3607.15629106883925845', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 13:51:28', 10, 2001001000, '服务端发生异常', '2019-07-12 13:51:28');
INSERT INTO `access_log` VALUES (53327, '64.76.15629107438712397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 13:52:24', 4, 0, '', '2019-07-12 13:52:24');
INSERT INTO `access_log` VALUES (53328, '64.81.15629107439962385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 13:52:24', 2, 0, '', '2019-07-12 13:52:24');
INSERT INTO `access_log` VALUES (53329, '64.80.15629107457332409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 13:52:26', 2, 0, '', '2019-07-12 13:52:26');
INSERT INTO `access_log` VALUES (53330, '64.79.15629107467392401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 13:52:27', 1, 0, '', '2019-07-12 13:52:27');
INSERT INTO `access_log` VALUES (53331, '59.77.15629107493162213', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 13:52:29', 3, 0, '', '2019-07-12 13:52:29');
INSERT INTO `access_log` VALUES (53332, '59.76.15629107493182217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.14.53.184', '2019-07-12 13:52:29', 12, 2001001000, '服务端发生异常', '2019-07-12 13:52:29');
INSERT INTO `access_log` VALUES (53333, '65.53.15629107580894051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:52:38', 9, 0, '', '2019-07-12 13:52:38');
INSERT INTO `access_log` VALUES (53334, '65.49.15629107580934039', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:52:38', 9, 2001001000, '服务端发生异常', '2019-07-12 13:52:38');
INSERT INTO `access_log` VALUES (53335, '65.52.15629107581084083', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.115.69.138', '2019-07-12 13:52:38', 9, 0, '', '2019-07-12 13:52:38');
INSERT INTO `access_log` VALUES (53336, '59.78.15629108554362223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.239.185', '2019-07-12 13:54:15', 3, 0, '', '2019-07-12 13:54:15');
INSERT INTO `access_log` VALUES (53337, '59.77.15629108554372215', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.239.185', '2019-07-12 13:54:15', 14, 2001001000, '服务端发生异常', '2019-07-12 13:54:15');
INSERT INTO `access_log` VALUES (53338, '64.81.15629108580362387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.239.185', '2019-07-12 13:54:18', 2, 0, '', '2019-07-12 13:54:18');
INSERT INTO `access_log` VALUES (53339, '64.80.15629108581772411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.239.185', '2019-07-12 13:54:18', 1, 0, '', '2019-07-12 13:54:18');
INSERT INTO `access_log` VALUES (53340, '64.79.15629108589732403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.239.185', '2019-07-12 13:54:19', 2, 0, '', '2019-07-12 13:54:19');
INSERT INTO `access_log` VALUES (53341, '64.82.15629108595082419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.239.185', '2019-07-12 13:54:20', 1, 0, '', '2019-07-12 13:54:20');
INSERT INTO `access_log` VALUES (53342, '65.49.15629111514484045', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.239.185', '2019-07-12 13:59:11', 0, 1002001015, '账号未登陆', '2019-07-12 13:59:11');
INSERT INTO `access_log` VALUES (53343, '65.53.15629111514524057', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.239.185', '2019-07-12 13:59:11', 1, 1002001015, '账号未登陆', '2019-07-12 13:59:11');
INSERT INTO `access_log` VALUES (53344, '65.52.15629111514554089', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.239.185', '2019-07-12 13:59:11', 1, 1002001015, '账号未登陆', '2019-07-12 13:59:11');
INSERT INTO `access_log` VALUES (53345, '65.3607.15629111533265853', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.239.185', '2019-07-12 13:59:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 13:59:13');
INSERT INTO `access_log` VALUES (53346, '65.54.15629111552624001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.239.185', '2019-07-12 13:59:15', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 13:59:15');
INSERT INTO `access_log` VALUES (53347, '65.46.15629111596744117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.239.185', '2019-07-12 13:59:20', 4, 1002002001, '密码不正确', '2019-07-12 13:59:20');
INSERT INTO `access_log` VALUES (53348, '65.53.15629113639804061', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 14:02:44', 4, 1002001012, '访问令牌已过期', '2019-07-12 14:02:44');
INSERT INTO `access_log` VALUES (53349, '65.49.15629113685004049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 14:02:49', 73, 0, '', '2019-07-12 14:02:49');
INSERT INTO `access_log` VALUES (53350, '65.52.15629113688454093', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 14:02:49', 148, 0, '', '2019-07-12 14:02:49');
INSERT INTO `access_log` VALUES (53351, '65.54.15629113688514005', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 14:02:49', 154, 0, '', '2019-07-12 14:02:49');
INSERT INTO `access_log` VALUES (53352, '65.3607.15629113688515857', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 14:02:49', 153, 0, '', '2019-07-12 14:02:49');
INSERT INTO `access_log` VALUES (53353, '66.57.15629113730830203', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 14:02:53', 22, 0, '', '2019-07-12 14:02:53');
INSERT INTO `access_log` VALUES (53354, '65.45.15629113769854041', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 14:02:57', 19, 0, '', '2019-07-12 14:02:57');
INSERT INTO `access_log` VALUES (53355, '65.51.15629113836584119', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 14:03:04', 11, 0, '', '2019-07-12 14:03:04');
INSERT INTO `access_log` VALUES (53356, '59.76.15629117518032231', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:09:12', 3, 0, '', '2019-07-12 14:09:12');
INSERT INTO `access_log` VALUES (53357, '59.74.15629117518042245', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:09:12', 12, 2001001000, '服务端发生异常', '2019-07-12 14:09:12');
INSERT INTO `access_log` VALUES (53358, '64.83.15629117546432413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:09:15', 3, 0, '', '2019-07-12 14:09:15');
INSERT INTO `access_log` VALUES (53359, '64.77.15629117547572401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:09:15', 2, 0, '', '2019-07-12 14:09:15');
INSERT INTO `access_log` VALUES (53360, '66.55.15629117567680185', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:09:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字', '2019-07-12 14:09:17');
INSERT INTO `access_log` VALUES (53361, '64.78.15629117596922421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:09:20', 2, 0, '', '2019-07-12 14:09:20');
INSERT INTO `access_log` VALUES (53362, '64.85.15629117598382431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:09:20', 2, 0, '', '2019-07-12 14:09:20');
INSERT INTO `access_log` VALUES (53363, '66.48.15629117641270215', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:09:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空', '2019-07-12 14:09:24');
INSERT INTO `access_log` VALUES (53364, '66.51.15629117724860233', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13527003831', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:09:32', 87, 0, '', '2019-07-12 14:09:33');
INSERT INTO `access_log` VALUES (53365, '66.49.15629117759030221', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13527003831', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:09:36', 5, 1001003005, '短信发送过于频率', '2019-07-12 14:09:36');
INSERT INTO `access_log` VALUES (53366, '66.56.15629117984530215', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13520003000&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:09:58', 7, 1001003000, '验证码不存在', '2019-07-12 14:09:58');
INSERT INTO `access_log` VALUES (53367, '65.45.15629118087814047', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:10:09', 4, 1002001012, '访问令牌已过期', '2019-07-12 14:10:09');
INSERT INTO `access_log` VALUES (53368, '65.51.15629118087844125', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:10:09', 3, 1002001012, '访问令牌已过期', '2019-07-12 14:10:09');
INSERT INTO `access_log` VALUES (53369, '65.47.15629118087854051', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:10:09', 3, 1002001012, '访问令牌已过期', '2019-07-12 14:10:09');
INSERT INTO `access_log` VALUES (53370, '65.53.15629118103804069', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:10:10', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 14:10:10');
INSERT INTO `access_log` VALUES (53371, '65.49.15629118125544057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:10:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 14:10:13');
INSERT INTO `access_log` VALUES (53372, '65.54.15629118203474013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:10:20', 154, 0, '', '2019-07-12 14:10:21');
INSERT INTO `access_log` VALUES (53373, '65.52.15629118207844101', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:10:21', 10, 0, '', '2019-07-12 14:10:21');
INSERT INTO `access_log` VALUES (53374, '65.3607.15629118207885865', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:10:21', 10, 2001001000, '服务端发生异常', '2019-07-12 14:10:21');
INSERT INTO `access_log` VALUES (53375, '65.46.15629118207914129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:10:21', 10, 0, '', '2019-07-12 14:10:21');
INSERT INTO `access_log` VALUES (53376, '65.45.15629118529044049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:10:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 14:10:53');
INSERT INTO `access_log` VALUES (53377, '65.53.15629118555514071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:10:56', 60, 0, '', '2019-07-12 14:10:56');
INSERT INTO `access_log` VALUES (53378, '65.49.15629118557804059', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:10:56', 9, 0, '', '2019-07-12 14:10:56');
INSERT INTO `access_log` VALUES (53379, '65.54.15629118557834015', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:10:56', 9, 0, '', '2019-07-12 14:10:56');
INSERT INTO `access_log` VALUES (53380, '65.3607.15629118557865867', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:10:56', 8, 0, '', '2019-07-12 14:10:56');
INSERT INTO `access_log` VALUES (53381, '62.83.15629118633291469', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:03', 27, 0, '', '2019-07-12 14:11:03');
INSERT INTO `access_log` VALUES (53382, '62.85.15629118685871445', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:09', 25, 0, '', '2019-07-12 14:11:09');
INSERT INTO `access_log` VALUES (53383, '64.85.15629118708052433', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:11', 14, 0, '', '2019-07-12 14:11:11');
INSERT INTO `access_log` VALUES (53384, '64.78.15629118708042423', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:11', 19, 0, '', '2019-07-12 14:11:11');
INSERT INTO `access_log` VALUES (53385, '64.76.15629118733072415', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:13', 14, 0, '', '2019-07-12 14:11:13');
INSERT INTO `access_log` VALUES (53386, '64.84.15629118733072413', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:13', 21, 0, '', '2019-07-12 14:11:13');
INSERT INTO `access_log` VALUES (53387, '64.81.15629118788992403', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:19', 10, 0, '', '2019-07-12 14:11:19');
INSERT INTO `access_log` VALUES (53388, '66.57.15629118827290211', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:23', 13, 0, '', '2019-07-12 14:11:23');
INSERT INTO `access_log` VALUES (53389, '59.76.15629118850762233', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:25', 16, 0, '', '2019-07-12 14:11:25');
INSERT INTO `access_log` VALUES (53390, '59.72.15629118867512237', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:27', 24, 2001001000, '服务端发生异常', '2019-07-12 14:11:27');
INSERT INTO `access_log` VALUES (53391, '59.71.15629118908122245', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:31', 15, 0, '', '2019-07-12 14:11:31');
INSERT INTO `access_log` VALUES (53392, '59.79.15629118988602243', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:39', 16, 0, '', '2019-07-12 14:11:39');
INSERT INTO `access_log` VALUES (53393, '59.75.15629119029272251', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:43', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-12 14:11:43');
INSERT INTO `access_log` VALUES (53394, '65.51.15629119067834129', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:47', 20, 0, '', '2019-07-12 14:11:47');
INSERT INTO `access_log` VALUES (53395, '65.45.15629119087324051', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:49', 9, 0, '', '2019-07-12 14:11:49');
INSERT INTO `access_log` VALUES (53396, '65.50.15629119109884085', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:51', 10, 0, '', '2019-07-12 14:11:51');
INSERT INTO `access_log` VALUES (53397, '65.3607.15629119187855869', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:11:59', 14, 0, '', '2019-07-12 14:11:59');
INSERT INTO `access_log` VALUES (53398, '62.89.15629119210911459', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.215.104.211', '2019-07-12 14:12:01', 14, 0, '', '2019-07-12 14:12:01');
INSERT INTO `access_log` VALUES (53399, '59.79.15629124526872251', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:60.0) Gecko/20100101 Firefox/60.0', '60.216.63.26', '2019-07-12 14:20:53', 3, 0, '', '2019-07-12 14:20:53');
INSERT INTO `access_log` VALUES (53400, '59.80.15629124526852231', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:60.0) Gecko/20100101 Firefox/60.0', '60.216.63.26', '2019-07-12 14:20:53', 14, 2001001000, '服务端发生异常', '2019-07-12 14:20:53');
INSERT INTO `access_log` VALUES (53401, '59.73.15629124675462255', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-12 14:21:08', 2, 0, '', '2019-07-12 14:21:08');
INSERT INTO `access_log` VALUES (53402, '59.78.15629124675472247', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-12 14:21:08', 12, 2001001000, '服务端发生异常', '2019-07-12 14:21:08');
INSERT INTO `access_log` VALUES (53403, '64.80.15629124763032435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '60.216.63.26', '2019-07-12 14:21:16', 3, 0, '', '2019-07-12 14:21:16');
INSERT INTO `access_log` VALUES (53404, '64.79.15629124764502427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '60.216.63.26', '2019-07-12 14:21:16', 1, 0, '', '2019-07-12 14:21:16');
INSERT INTO `access_log` VALUES (53405, '64.82.15629124786712443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '60.216.63.26', '2019-07-12 14:21:19', 2, 0, '', '2019-07-12 14:21:19');
INSERT INTO `access_log` VALUES (53406, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '60.216.63.26', '2019-07-12 14:21:19', 6, 0, '', '2019-07-12 14:21:19');
INSERT INTO `access_log` VALUES (53407, '64.83.15629124797542425', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '60.216.63.26', '2019-07-12 14:21:20', 6, 0, '', '2019-07-12 14:21:20');
INSERT INTO `access_log` VALUES (53408, '64.78.15629124840882433', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '60.216.63.26', '2019-07-12 14:21:24', 5, 0, '', '2019-07-12 14:21:24');
INSERT INTO `access_log` VALUES (53409, '64.85.15629124847912443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '60.216.63.26', '2019-07-12 14:21:25', 2, 0, '', '2019-07-12 14:21:25');
INSERT INTO `access_log` VALUES (53410, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '60.216.63.26', '2019-07-12 14:21:25', 6, 0, '', '2019-07-12 14:21:25');
INSERT INTO `access_log` VALUES (53411, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '60.216.63.26', '2019-07-12 14:21:26', 7, 0, '', '2019-07-12 14:21:26');
INSERT INTO `access_log` VALUES (53412, '64.76.15629124872162425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '60.216.63.26', '2019-07-12 14:21:27', 2, 0, '', '2019-07-12 14:21:27');
INSERT INTO `access_log` VALUES (53413, '64.84.15629124873202423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '60.216.63.26', '2019-07-12 14:21:27', 2, 0, '', '2019-07-12 14:21:27');
INSERT INTO `access_log` VALUES (53414, '66.56.15629125191370225', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=26333265696&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '60.216.63.26', '2019-07-12 14:21:59', 10, 1001003000, '验证码不存在', '2019-07-12 14:21:59');
INSERT INTO `access_log` VALUES (53415, '66.50.15629125218960213', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=26333265696&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '60.216.63.26', '2019-07-12 14:22:02', 7, 1001003000, '验证码不存在', '2019-07-12 14:22:02');
INSERT INTO `access_log` VALUES (53416, '59.79.15629125632822253', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:22:43', 3, 0, '', '2019-07-12 14:22:43');
INSERT INTO `access_log` VALUES (53417, '59.75.15629125632832261', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:22:43', 19, 2001001000, '服务端发生异常', '2019-07-12 14:22:43');
INSERT INTO `access_log` VALUES (53418, '64.77.15629125685472415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:22:49', 2, 0, '', '2019-07-12 14:22:49');
INSERT INTO `access_log` VALUES (53419, '64.78.15629125686752435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:22:49', 2, 0, '', '2019-07-12 14:22:49');
INSERT INTO `access_log` VALUES (53420, '64.85.15629125698842445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:22:50', 2, 0, '', '2019-07-12 14:22:50');
INSERT INTO `access_log` VALUES (53421, '64.76.15629125703252427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:22:50', 2, 0, '', '2019-07-12 14:22:50');
INSERT INTO `access_log` VALUES (53422, '64.81.15629125706662415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:22:51', 2, 0, '', '2019-07-12 14:22:51');
INSERT INTO `access_log` VALUES (53423, '64.80.15629125738882439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:22:54', 2, 0, '', '2019-07-12 14:22:54');
INSERT INTO `access_log` VALUES (53424, '64.79.15629125739822431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:22:54', 2, 0, '', '2019-07-12 14:22:54');
INSERT INTO `access_log` VALUES (53425, '65.47.15629125789054065', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:22:59', 0, 1002001015, '账号未登陆', '2019-07-12 14:22:59');
INSERT INTO `access_log` VALUES (53426, '65.51.15629125789114139', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:22:59', 1, 1002001015, '账号未登陆', '2019-07-12 14:22:59');
INSERT INTO `access_log` VALUES (53427, '65.45.15629125789264061', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:22:59', 0, 1002001015, '账号未登陆', '2019-07-12 14:22:59');
INSERT INTO `access_log` VALUES (53428, '65.50.15629125884764095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:23:08', 110, 0, '', '2019-07-12 14:23:09');
INSERT INTO `access_log` VALUES (53429, '65.3607.15629125889465879', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:23:09', 12, 0, '', '2019-07-12 14:23:09');
INSERT INTO `access_log` VALUES (53430, '65.49.15629125889514071', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:23:09', 11, 2001001000, '服务端发生异常', '2019-07-12 14:23:09');
INSERT INTO `access_log` VALUES (53431, '65.54.15629125889604027', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.218.1.209', '2019-07-12 14:23:09', 8, 0, '', '2019-07-12 14:23:09');
INSERT INTO `access_log` VALUES (53432, '65.50.15629126690554097', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-12 14:24:29', 1, 1002001015, '账号未登陆', '2019-07-12 14:24:29');
INSERT INTO `access_log` VALUES (53433, '65.53.15629126690554085', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-12 14:24:29', 0, 1002001015, '账号未登陆', '2019-07-12 14:24:29');
INSERT INTO `access_log` VALUES (53434, '65.54.15629126690604029', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-12 14:24:29', 1, 1002001015, '账号未登陆', '2019-07-12 14:24:29');
INSERT INTO `access_log` VALUES (53435, '65.49.15629126753754073', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-12 14:24:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 14:24:35');
INSERT INTO `access_log` VALUES (53436, '65.52.15629126837064117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-12 14:24:44', 53, 0, '', '2019-07-12 14:24:44');
INSERT INTO `access_log` VALUES (53437, '65.46.15629126839724145', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-12 14:24:44', 10, 0, '', '2019-07-12 14:24:44');
INSERT INTO `access_log` VALUES (53438, '65.47.15629126839894069', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-12 14:24:44', 8, 0, '', '2019-07-12 14:24:44');
INSERT INTO `access_log` VALUES (53439, '65.51.15629126839874143', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '60.216.63.26', '2019-07-12 14:24:44', 9, 2001001000, '服务端发生异常', '2019-07-12 14:24:44');
INSERT INTO `access_log` VALUES (53440, '65.47.15629128186074071', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.155.222.235', '2019-07-12 14:26:59', 0, 1002001015, '账号未登陆', '2019-07-12 14:26:59');
INSERT INTO `access_log` VALUES (53441, '65.45.15629128186174067', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.155.222.235', '2019-07-12 14:26:59', 0, 1002001015, '账号未登陆', '2019-07-12 14:26:59');
INSERT INTO `access_log` VALUES (53442, '65.53.15629128186324089', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.155.222.235', '2019-07-12 14:26:59', 1, 1002001015, '账号未登陆', '2019-07-12 14:26:59');
INSERT INTO `access_log` VALUES (53443, '65.47.15629129229594073', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.155.222.235', '2019-07-12 14:28:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 14:28:43');
INSERT INTO `access_log` VALUES (53444, '65.45.15629129284614069', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.155.222.235', '2019-07-12 14:28:48', 97, 0, '', '2019-07-12 14:28:49');
INSERT INTO `access_log` VALUES (53445, '65.53.15629129289314091', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.155.222.235', '2019-07-12 14:28:49', 10, 0, '', '2019-07-12 14:28:49');
INSERT INTO `access_log` VALUES (53446, '65.50.15629129289414103', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.155.222.235', '2019-07-12 14:28:49', 10, 2001001000, '服务端发生异常', '2019-07-12 14:28:49');
INSERT INTO `access_log` VALUES (53447, '65.54.15629129289894035', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.155.222.235', '2019-07-12 14:28:49', 10, 0, '', '2019-07-12 14:28:49');
INSERT INTO `access_log` VALUES (53448, '65.3607.15629129439825887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.155.222.235', '2019-07-12 14:29:04', 9, 0, '', '2019-07-12 14:29:04');
INSERT INTO `access_log` VALUES (53449, '65.51.15629129439974149', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.155.222.235', '2019-07-12 14:29:04', 9, 0, '', '2019-07-12 14:29:04');
INSERT INTO `access_log` VALUES (53450, '65.52.15629129439914123', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.155.222.235', '2019-07-12 14:29:04', 11, 2001001000, '服务端发生异常', '2019-07-12 14:29:04');
INSERT INTO `access_log` VALUES (53451, '59.79.15629131387222261', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:19', 3, 0, '', '2019-07-12 14:32:19');
INSERT INTO `access_log` VALUES (53452, '59.75.15629131387232269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:19', 12, 2001001000, '服务端发生异常', '2019-07-12 14:32:19');
INSERT INTO `access_log` VALUES (53453, '64.80.15629131454902447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:25', 3, 0, '', '2019-07-12 14:32:25');
INSERT INTO `access_log` VALUES (53454, '64.79.15629131456152439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:26', 2, 0, '', '2019-07-12 14:32:26');
INSERT INTO `access_log` VALUES (53455, '64.82.15629131470352455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:27', 1, 0, '', '2019-07-12 14:32:27');
INSERT INTO `access_log` VALUES (53456, '64.83.15629131477192437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:28', 1, 0, '', '2019-07-12 14:32:28');
INSERT INTO `access_log` VALUES (53457, '65.50.15629131540124107', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:34', 0, 1002001015, '账号未登陆', '2019-07-12 14:32:34');
INSERT INTO `access_log` VALUES (53458, '65.54.15629131540194039', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:34', 0, 1002001015, '账号未登陆', '2019-07-12 14:32:34');
INSERT INTO `access_log` VALUES (53459, '65.49.15629131540254083', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:34', 1, 1002001015, '账号未登陆', '2019-07-12 14:32:34');
INSERT INTO `access_log` VALUES (53460, '65.51.15629131611994153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:41', 112, 0, '', '2019-07-12 14:32:41');
INSERT INTO `access_log` VALUES (53461, '65.52.15629131615584127', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:42', 10, 0, '', '2019-07-12 14:32:42');
INSERT INTO `access_log` VALUES (53462, '65.46.15629131615604155', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:42', 9, 2001001000, '服务端发生异常', '2019-07-12 14:32:42');
INSERT INTO `access_log` VALUES (53463, '65.47.15629131615614079', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:42', 9, 0, '', '2019-07-12 14:32:42');
INSERT INTO `access_log` VALUES (53464, '65.45.15629131729664075', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:53', 9, 0, '', '2019-07-12 14:32:53');
INSERT INTO `access_log` VALUES (53465, '65.53.15629131729724097', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:53', 9, 2001001000, '服务端发生异常', '2019-07-12 14:32:53');
INSERT INTO `access_log` VALUES (53466, '65.50.15629131729764109', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '1.202.15.246', '2019-07-12 14:32:53', 9, 0, '', '2019-07-12 14:32:53');
INSERT INTO `access_log` VALUES (53467, '65.49.15629133386084087', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.254.68.219', '2019-07-12 14:35:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 14:35:39');
INSERT INTO `access_log` VALUES (53468, '65.51.15629133409864157', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.254.68.219', '2019-07-12 14:35:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 14:35:41');
INSERT INTO `access_log` VALUES (53469, '65.52.15629133592114131', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.254.68.219', '2019-07-12 14:35:59', 73, 0, '', '2019-07-12 14:35:59');
INSERT INTO `access_log` VALUES (53470, '65.46.15629133599574159', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.254.68.219', '2019-07-12 14:36:00', 9, 0, '', '2019-07-12 14:36:00');
INSERT INTO `access_log` VALUES (53471, '65.50.15629133599584113', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.254.68.219', '2019-07-12 14:36:00', 11, 2001001000, '服务端发生异常', '2019-07-12 14:36:00');
INSERT INTO `access_log` VALUES (53472, '65.53.15629133599604101', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.254.68.219', '2019-07-12 14:36:00', 10, 0, '', '2019-07-12 14:36:00');
INSERT INTO `access_log` VALUES (53473, '65.47.15629137187514091', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:41:59', 1, 1002001015, '账号未登陆', '2019-07-12 14:41:59');
INSERT INTO `access_log` VALUES (53474, '65.51.15629137187614165', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:41:59', 0, 1002001015, '账号未登陆', '2019-07-12 14:41:59');
INSERT INTO `access_log` VALUES (53475, '65.3607.15629137187655901', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:41:59', 0, 1002001015, '账号未登陆', '2019-07-12 14:41:59');
INSERT INTO `access_log` VALUES (53476, '65.49.15629137205994095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 14:42:01');
INSERT INTO `access_log` VALUES (53477, '65.52.15629137249874139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 14:42:05');
INSERT INTO `access_log` VALUES (53478, '65.53.15629137319024107', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:12', 98, 0, '', '2019-07-12 14:42:12');
INSERT INTO `access_log` VALUES (53479, '65.46.15629137323034167', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:12', 417, 0, '', '2019-07-12 14:42:13');
INSERT INTO `access_log` VALUES (53480, '65.45.15629137323004085', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:12', 422, 2001001000, '服务端发生异常', '2019-07-12 14:42:13');
INSERT INTO `access_log` VALUES (53481, '65.54.15629137323074051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:12', 415, 0, '', '2019-07-12 14:42:13');
INSERT INTO `access_log` VALUES (53482, '65.3607.15629137410245903', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:21', 9, 0, '', '2019-07-12 14:42:21');
INSERT INTO `access_log` VALUES (53483, '65.47.15629137410274093', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:21', 10, 2001001000, '服务端发生异常', '2019-07-12 14:42:21');
INSERT INTO `access_log` VALUES (53484, '65.51.15629137410334167', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:21', 9, 0, '', '2019-07-12 14:42:21');
INSERT INTO `access_log` VALUES (53485, '65.52.15629137522144141', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:32', 16, 0, '', '2019-07-12 14:42:32');
INSERT INTO `access_log` VALUES (53486, '65.50.15629137522194121', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:32', 16, 0, '', '2019-07-12 14:42:32');
INSERT INTO `access_log` VALUES (53487, '65.53.15629137524904109', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:32', 11, 2001001000, '服务端发生异常', '2019-07-12 14:42:33');
INSERT INTO `access_log` VALUES (53488, '65.54.15629137606654053', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:41', 9, 0, '', '2019-07-12 14:42:41');
INSERT INTO `access_log` VALUES (53489, '65.45.15629137606674087', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:41', 10, 2001001000, '服务端发生异常', '2019-07-12 14:42:41');
INSERT INTO `access_log` VALUES (53490, '65.3607.15629137606735905', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:42:41', 9, 0, '', '2019-07-12 14:42:41');
INSERT INTO `access_log` VALUES (53491, '65.49.15629137899864099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.19.171.206', '2019-07-12 14:43:10', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 14:43:10');
INSERT INTO `access_log` VALUES (53492, '59.74.15629146579692287', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 14:57:38', 3, 0, '', '2019-07-12 14:57:38');
INSERT INTO `access_log` VALUES (53493, '59.77.15629146579682269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 14:57:38', 18, 2001001000, '服务端发生异常', '2019-07-12 14:57:38');
INSERT INTO `access_log` VALUES (53494, '64.78.15629146598312465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 14:57:40', 2, 0, '', '2019-07-12 14:57:40');
INSERT INTO `access_log` VALUES (53495, '64.85.15629146599622475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 14:57:40', 2, 0, '', '2019-07-12 14:57:40');
INSERT INTO `access_log` VALUES (53496, '64.76.15629146608312457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 14:57:41', 3, 0, '', '2019-07-12 14:57:41');
INSERT INTO `access_log` VALUES (53497, '64.84.15629146614662455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 14:57:41', 2, 0, '', '2019-07-12 14:57:41');
INSERT INTO `access_log` VALUES (53498, '64.81.15629146621512445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 14:57:42', 2, 0, '', '2019-07-12 14:57:42');
INSERT INTO `access_log` VALUES (53499, '66.48.15629146640520255', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 14:57:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空', '2019-07-12 14:57:44');
INSERT INTO `access_log` VALUES (53500, '64.80.15629146663032469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 14:57:46', 2, 0, '', '2019-07-12 14:57:46');
INSERT INTO `access_log` VALUES (53501, '64.79.15629146663962461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 14:57:46', 2, 0, '', '2019-07-12 14:57:46');
INSERT INTO `access_log` VALUES (53502, '59.76.15629146669662273', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 14:57:47', 2, 0, '', '2019-07-12 14:57:47');
INSERT INTO `access_log` VALUES (53503, '59.72.15629146669682277', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 14:57:47', 12, 2001001000, '服务端发生异常', '2019-07-12 14:57:47');
INSERT INTO `access_log` VALUES (53504, '65.49.15629151329774117', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.202.239.245', '2019-07-12 15:05:33', 0, 1002001015, '账号未登陆', '2019-07-12 15:05:33');
INSERT INTO `access_log` VALUES (53505, '65.52.15629151329774161', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.202.239.245', '2019-07-12 15:05:33', 0, 1002001015, '账号未登陆', '2019-07-12 15:05:33');
INSERT INTO `access_log` VALUES (53506, '65.50.15629151329794141', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.202.239.245', '2019-07-12 15:05:33', 0, 1002001015, '账号未登陆', '2019-07-12 15:05:33');
INSERT INTO `access_log` VALUES (53507, '65.46.15629151389374189', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.202.239.245', '2019-07-12 15:05:39', 83, 0, '', '2019-07-12 15:05:39');
INSERT INTO `access_log` VALUES (53508, '65.3607.15629151393445925', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.202.239.245', '2019-07-12 15:05:39', 140, 0, '', '2019-07-12 15:05:39');
INSERT INTO `access_log` VALUES (53509, '65.45.15629151393594107', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.202.239.245', '2019-07-12 15:05:39', 127, 0, '', '2019-07-12 15:05:39');
INSERT INTO `access_log` VALUES (53510, '65.54.15629151393524073', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.202.239.245', '2019-07-12 15:05:39', 136, 2001001000, '服务端发生异常', '2019-07-12 15:05:39');
INSERT INTO `access_log` VALUES (53511, '65.51.15629151578934189', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.202.239.245', '2019-07-12 15:05:58', 9, 0, '', '2019-07-12 15:05:58');
INSERT INTO `access_log` VALUES (53512, '65.49.15629151578954119', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.202.239.245', '2019-07-12 15:05:58', 8, 0, '', '2019-07-12 15:05:58');
INSERT INTO `access_log` VALUES (53513, '65.52.15629151578934163', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.202.239.245', '2019-07-12 15:05:58', 10, 2001001000, '服务端发生异常', '2019-07-12 15:05:58');
INSERT INTO `access_log` VALUES (53514, '65.53.15629154757264135', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:16', 1, 1002001015, '账号未登陆', '2019-07-12 15:11:16');
INSERT INTO `access_log` VALUES (53515, '65.46.15629154757334195', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:16', 1, 1002001015, '账号未登陆', '2019-07-12 15:11:16');
INSERT INTO `access_log` VALUES (53516, '65.3607.15629154757395931', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:16', 0, 1002001015, '账号未登陆', '2019-07-12 15:11:16');
INSERT INTO `access_log` VALUES (53517, '65.54.15629154805774079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 15:11:21');
INSERT INTO `access_log` VALUES (53518, '65.47.15629154925884121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:33', 64, 0, '', '2019-07-12 15:11:33');
INSERT INTO `access_log` VALUES (53519, '65.52.15629154932894169', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:33', 110, 0, '', '2019-07-12 15:11:33');
INSERT INTO `access_log` VALUES (53520, '65.49.15629154932994125', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:33', 105, 0, '', '2019-07-12 15:11:33');
INSERT INTO `access_log` VALUES (53521, '65.51.15629154932944195', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:33', 109, 2001001000, '服务端发生异常', '2019-07-12 15:11:33');
INSERT INTO `access_log` VALUES (53522, '65.3607.15629155035225933', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:44', 9, 0, '', '2019-07-12 15:11:44');
INSERT INTO `access_log` VALUES (53523, '65.53.15629155035364137', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:44', 11, 2001001000, '服务端发生异常', '2019-07-12 15:11:44');
INSERT INTO `access_log` VALUES (53524, '65.46.15629155035404197', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:44', 9, 0, '', '2019-07-12 15:11:44');
INSERT INTO `access_log` VALUES (53525, '65.54.15629155117774081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 15:11:52');
INSERT INTO `access_log` VALUES (53526, '65.47.15629155165654123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=12345678&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:57', 76, 0, '', '2019-07-12 15:11:57');
INSERT INTO `access_log` VALUES (53527, '65.51.15629155170794197', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:57', 9, 0, '', '2019-07-12 15:11:57');
INSERT INTO `access_log` VALUES (53528, '65.49.15629155170794127', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:57', 22, 0, '', '2019-07-12 15:11:57');
INSERT INTO `access_log` VALUES (53529, '65.52.15629155170794171', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:11:57', 23, 0, '', '2019-07-12 15:11:57');
INSERT INTO `access_log` VALUES (53530, '65.53.15629155342924139', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:12:14', 18, 0, '', '2019-07-12 15:12:14');
INSERT INTO `access_log` VALUES (53531, '65.3607.15629155395305935', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:12:20', 11, 0, '', '2019-07-12 15:12:20');
INSERT INTO `access_log` VALUES (53532, '65.54.15629155493974083', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:12:29', 10, 0, '', '2019-07-12 15:12:29');
INSERT INTO `access_log` VALUES (53533, '65.45.15629155537464117', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:12:34', 12, 0, '', '2019-07-12 15:12:34');
INSERT INTO `access_log` VALUES (53534, '65.51.15629155686554199', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:12:49', 88, 0, '', '2019-07-12 15:12:49');
INSERT INTO `access_log` VALUES (53535, '65.53.15629156144474141', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:13:34', 14, 0, '', '2019-07-12 15:13:34');
INSERT INTO `access_log` VALUES (53536, '64.76.15629156400792471', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:14:00', 13, 0, '', '2019-07-12 15:14:00');
INSERT INTO `access_log` VALUES (53537, '64.84.15629156401002469', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:14:00', 10, 0, '', '2019-07-12 15:14:00');
INSERT INTO `access_log` VALUES (53538, '64.81.15629156431582459', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:14:03', 11, 0, '', '2019-07-12 15:14:03');
INSERT INTO `access_log` VALUES (53539, '64.83.15629156895502473', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:14:50', 11, 0, '', '2019-07-12 15:14:50');
INSERT INTO `access_log` VALUES (53540, '64.77.15629156895542461', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:14:50', 12, 0, '', '2019-07-12 15:14:50');
INSERT INTO `access_log` VALUES (53541, '64.85.15629156940852491', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:14:54', 14, 0, '', '2019-07-12 15:14:54');
INSERT INTO `access_log` VALUES (53542, '64.84.15629156940962471', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:14:54', 8, 0, '', '2019-07-12 15:14:54');
INSERT INTO `access_log` VALUES (53543, '64.81.15629157084112461', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:15:08', 9, 0, '', '2019-07-12 15:15:08');
INSERT INTO `access_log` VALUES (53544, '64.82.15629157411452493', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:15:41', 11, 0, '', '2019-07-12 15:15:41');
INSERT INTO `access_log` VALUES (53545, '64.77.15629157411552463', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:15:41', 10, 0, '', '2019-07-12 15:15:41');
INSERT INTO `access_log` VALUES (53546, '64.83.15629157443822475', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:15:44', 9, 0, '', '2019-07-12 15:15:44');
INSERT INTO `access_log` VALUES (53547, '64.85.15629157476742493', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:15:48', 10, 0, '', '2019-07-12 15:15:48');
INSERT INTO `access_log` VALUES (53548, '64.78.15629157476712483', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:15:48', 12, 0, '', '2019-07-12 15:15:48');
INSERT INTO `access_log` VALUES (53549, '64.81.15629157522442463', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:15:52', 13, 0, '', '2019-07-12 15:15:52');
INSERT INTO `access_log` VALUES (53550, '64.76.15629157522422475', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:15:52', 15, 0, '', '2019-07-12 15:15:52');
INSERT INTO `access_log` VALUES (53551, '64.79.15629157777342479', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:16:18', 12, 0, '', '2019-07-12 15:16:18');
INSERT INTO `access_log` VALUES (53552, '64.83.15629157861092477', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:16:26', 9, 0, '', '2019-07-12 15:16:26');
INSERT INTO `access_log` VALUES (53553, '64.82.15629157861062495', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:16:26', 12, 0, '', '2019-07-12 15:16:26');
INSERT INTO `access_log` VALUES (53554, '62.89.15629157924281509', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:16:32', 24, 0, '', '2019-07-12 15:16:32');
INSERT INTO `access_log` VALUES (53555, '65.54.15629157984554087', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:16:38', 14, 0, '', '2019-07-12 15:16:38');
INSERT INTO `access_log` VALUES (53556, '64.84.15629158129242475', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:16:53', 12, 0, '', '2019-07-12 15:16:53');
INSERT INTO `access_log` VALUES (53557, '64.81.15629158129262465', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:16:53', 9, 0, '', '2019-07-12 15:16:53');
INSERT INTO `access_log` VALUES (53558, '59.74.15629158201562303', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '112.64.68.49', '2019-07-12 15:17:00', 3, 0, '', '2019-07-12 15:17:00');
INSERT INTO `access_log` VALUES (53559, '59.72.15629158201632293', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '112.64.68.49', '2019-07-12 15:17:00', 12, 2001001000, '服务端发生异常', '2019-07-12 15:17:00');
INSERT INTO `access_log` VALUES (53560, '64.80.15629158233472489', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:17:03', 9, 0, '', '2019-07-12 15:17:03');
INSERT INTO `access_log` VALUES (53561, '64.76.15629158233452477', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:17:03', 10, 0, '', '2019-07-12 15:17:03');
INSERT INTO `access_log` VALUES (53562, '64.77.15629158281122467', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:17:08', 11, 0, '', '2019-07-12 15:17:08');
INSERT INTO `access_log` VALUES (53563, '65.52.15629158345604177', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '112.64.68.49', '2019-07-12 15:17:15', 0, 1002001015, '账号未登陆', '2019-07-12 15:17:15');
INSERT INTO `access_log` VALUES (53564, '65.49.15629158345624133', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '112.64.68.49', '2019-07-12 15:17:15', 0, 1002001015, '账号未登陆', '2019-07-12 15:17:15');
INSERT INTO `access_log` VALUES (53565, '65.50.15629158345634157', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '112.64.68.49', '2019-07-12 15:17:15', 1, 1002001015, '账号未登陆', '2019-07-12 15:17:15');
INSERT INTO `access_log` VALUES (53566, '65.53.15629158427274145', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '112.64.68.49', '2019-07-12 15:17:23', 91, 0, '', '2019-07-12 15:17:23');
INSERT INTO `access_log` VALUES (53567, '65.3607.15629158431105941', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '112.64.68.49', '2019-07-12 15:17:23', 8, 0, '', '2019-07-12 15:17:23');
INSERT INTO `access_log` VALUES (53568, '65.46.15629158431124205', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '112.64.68.49', '2019-07-12 15:17:23', 9, 2001001000, '服务端发生异常', '2019-07-12 15:17:23');
INSERT INTO `access_log` VALUES (53569, '65.54.15629158431504089', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '112.64.68.49', '2019-07-12 15:17:23', 9, 0, '', '2019-07-12 15:17:23');
INSERT INTO `access_log` VALUES (53570, '66.52.15629158584950257', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:17:38', 19, 0, '', '2019-07-12 15:17:39');
INSERT INTO `access_log` VALUES (53571, '59.79.15629158680282299', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:17:48', 12, 0, '', '2019-07-12 15:17:48');
INSERT INTO `access_log` VALUES (53572, '65.51.15629158704134205', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '112.64.68.49', '2019-07-12 15:17:50', 9, 0, '', '2019-07-12 15:17:50');
INSERT INTO `access_log` VALUES (53573, '65.50.15629158704304159', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '112.64.68.49', '2019-07-12 15:17:50', 8, 0, '', '2019-07-12 15:17:50');
INSERT INTO `access_log` VALUES (53574, '65.49.15629158704304135', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '112.64.68.49', '2019-07-12 15:17:50', 9, 2001001000, '服务端发生异常', '2019-07-12 15:17:50');
INSERT INTO `access_log` VALUES (53575, '59.73.15629158813742303', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:18:01', 20, 2001001000, '服务端发生异常', '2019-07-12 15:18:01');
INSERT INTO `access_log` VALUES (53576, '59.77.15629158855302287', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:18:06', 19, 0, '', '2019-07-12 15:18:06');
INSERT INTO `access_log` VALUES (53577, '64.84.15629158871402477', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:18:07', 9, 0, '', '2019-07-12 15:18:07');
INSERT INTO `access_log` VALUES (53578, '64.81.15629158990392467', 1, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=j', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:18:19', 11, 0, '', '2019-07-12 15:18:19');
INSERT INTO `access_log` VALUES (53579, '64.80.15629159003492491', 1, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=h', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:18:20', 9, 0, '', '2019-07-12 15:18:20');
INSERT INTO `access_log` VALUES (53580, '64.76.15629159004022479', 1, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=ho', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:18:20', 18, 0, '', '2019-07-12 15:18:20');
INSERT INTO `access_log` VALUES (53581, '64.77.15629159010102469', 1, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=h', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:18:21', 8, 0, '', '2019-07-12 15:18:21');
INSERT INTO `access_log` VALUES (53582, '64.83.15629159017102481', 1, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=u', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:18:22', 10, 0, '', '2019-07-12 15:18:22');
INSERT INTO `access_log` VALUES (53583, '64.82.15629159026422499', 1, 2, 'product-application', '/product-api/admins/spu/search_list', 'name=j', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:18:23', 17, 0, '', '2019-07-12 15:18:23');
INSERT INTO `access_log` VALUES (53584, '64.85.15629159073752499', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:18:27', 9, 0, '', '2019-07-12 15:18:27');
INSERT INTO `access_log` VALUES (53585, '59.74.15629159100002305', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:18:30', 1311, 0, '', '2019-07-12 15:18:31');
INSERT INTO `access_log` VALUES (53586, '59.71.15629159165662303', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '210.83.240.178', '2019-07-12 15:18:37', 12, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-12 15:18:37');
INSERT INTO `access_log` VALUES (53587, '59.75.15629170037062323', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '42.120.74.114', '2019-07-12 15:36:44', 3, 0, '', '2019-07-12 15:36:44');
INSERT INTO `access_log` VALUES (53588, '59.73.15629170037072319', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '42.120.74.114', '2019-07-12 15:36:44', 19, 2001001000, '服务端发生异常', '2019-07-12 15:36:44');
INSERT INTO `access_log` VALUES (53589, '64.80.15629170102952507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '42.120.74.114', '2019-07-12 15:36:50', 3, 0, '', '2019-07-12 15:36:50');
INSERT INTO `access_log` VALUES (53590, '64.76.15629170104112495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '42.120.74.114', '2019-07-12 15:36:50', 1, 0, '', '2019-07-12 15:36:50');
INSERT INTO `access_log` VALUES (53591, '65.50.15629170585324175', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.67.157.99', '2019-07-12 15:37:39', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 15:37:39');
INSERT INTO `access_log` VALUES (53592, '65.52.15629170812594197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.67.157.99', '2019-07-12 15:38:01', 56, 0, '', '2019-07-12 15:38:01');
INSERT INTO `access_log` VALUES (53593, '65.53.15629170816244163', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.67.157.99', '2019-07-12 15:38:02', 10, 0, '', '2019-07-12 15:38:02');
INSERT INTO `access_log` VALUES (53594, '65.3607.15629170816275961', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.67.157.99', '2019-07-12 15:38:02', 10, 2001001000, '服务端发生异常', '2019-07-12 15:38:02');
INSERT INTO `access_log` VALUES (53595, '65.46.15629170816334225', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.67.157.99', '2019-07-12 15:38:02', 9, 0, '', '2019-07-12 15:38:02');
INSERT INTO `access_log` VALUES (53596, '65.47.15629171127844151', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 15:38:33', 0, 1002001015, '账号未登陆', '2019-07-12 15:38:33');
INSERT INTO `access_log` VALUES (53597, '65.50.15629171127864177', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 15:38:33', 0, 1002001015, '账号未登陆', '2019-07-12 15:38:33');
INSERT INTO `access_log` VALUES (53598, '65.49.15629171127904153', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 15:38:33', 0, 1002001015, '账号未登陆', '2019-07-12 15:38:33');
INSERT INTO `access_log` VALUES (53599, '65.52.15629171313044199', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 15:38:51', 87, 0, '', '2019-07-12 15:38:51');
INSERT INTO `access_log` VALUES (53600, '65.53.15629171316094165', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 15:38:52', 9, 0, '', '2019-07-12 15:38:52');
INSERT INTO `access_log` VALUES (53601, '65.3607.15629171316125963', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 15:38:52', 9, 0, '', '2019-07-12 15:38:52');
INSERT INTO `access_log` VALUES (53602, '65.46.15629171316114227', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 15:38:52', 9, 2001001000, '服务端发生异常', '2019-07-12 15:38:52');
INSERT INTO `access_log` VALUES (53603, '65.45.15629171425994145', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 15:39:03', 9, 0, '', '2019-07-12 15:39:03');
INSERT INTO `access_log` VALUES (53604, '65.47.15629171426004153', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 15:39:03', 10, 2001001000, '服务端发生异常', '2019-07-12 15:39:03');
INSERT INTO `access_log` VALUES (53605, '65.49.15629171426024155', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.67.157.99', '2019-07-12 15:39:03', 9, 0, '', '2019-07-12 15:39:03');
INSERT INTO `access_log` VALUES (53606, '65.50.15629171485614179', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.67.157.99', '2019-07-12 15:39:09', 9, 0, '', '2019-07-12 15:39:09');
INSERT INTO `access_log` VALUES (53607, '65.51.15629171485664225', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.67.157.99', '2019-07-12 15:39:09', 10, 2001001000, '服务端发生异常', '2019-07-12 15:39:09');
INSERT INTO `access_log` VALUES (53608, '65.52.15629171485694201', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.67.157.99', '2019-07-12 15:39:09', 9, 0, '', '2019-07-12 15:39:09');
INSERT INTO `access_log` VALUES (53609, '65.54.15629174876154115', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.67.157.99', '2019-07-12 15:44:48', 10, 0, '', '2019-07-12 15:44:48');
INSERT INTO `access_log` VALUES (53610, '65.45.15629174876174151', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.67.157.99', '2019-07-12 15:44:48', 9, 0, '', '2019-07-12 15:44:48');
INSERT INTO `access_log` VALUES (53611, '65.49.15629174876154161', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.67.157.99', '2019-07-12 15:44:48', 12, 2001001000, '服务端发生异常', '2019-07-12 15:44:48');
INSERT INTO `access_log` VALUES (53612, '59.72.15629177877402321', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.19.98.11', '2019-07-12 15:49:48', 3, 0, '', '2019-07-12 15:49:48');
INSERT INTO `access_log` VALUES (53613, '59.74.15629177877402331', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.19.98.11', '2019-07-12 15:49:48', 19, 2001001000, '服务端发生异常', '2019-07-12 15:49:48');
INSERT INTO `access_log` VALUES (53614, '64.82.15629177918022525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.19.98.11', '2019-07-12 15:49:52', 2, 0, '', '2019-07-12 15:49:52');
INSERT INTO `access_log` VALUES (53615, '64.85.15629177919102525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.19.98.11', '2019-07-12 15:49:52', 2, 0, '', '2019-07-12 15:49:52');
INSERT INTO `access_log` VALUES (53616, '64.78.15629177964652515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.19.98.11', '2019-07-12 15:49:56', 2, 0, '', '2019-07-12 15:49:56');
INSERT INTO `access_log` VALUES (53617, '64.84.15629177965902505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.19.98.11', '2019-07-12 15:49:57', 2, 0, '', '2019-07-12 15:49:57');
INSERT INTO `access_log` VALUES (53618, '59.71.15629177972242329', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.19.98.11', '2019-07-12 15:49:57', 3, 0, '', '2019-07-12 15:49:57');
INSERT INTO `access_log` VALUES (53619, '59.80.15629177972242307', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.19.98.11', '2019-07-12 15:49:57', 12, 2001001000, '服务端发生异常', '2019-07-12 15:49:57');
INSERT INTO `access_log` VALUES (53620, '65.51.15629179608534237', 0, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 15:52:41', 4, 1002001012, '访问令牌已过期', '2019-07-12 15:52:41');
INSERT INTO `access_log` VALUES (53621, '65.52.15629179648784213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123123&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 15:52:45', 80, 0, '', '2019-07-12 15:52:45');
INSERT INTO `access_log` VALUES (53622, '65.3607.15629179652395977', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 15:52:45', 9, 0, '', '2019-07-12 15:52:45');
INSERT INTO `access_log` VALUES (53623, '65.53.15629179652474179', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 15:52:45', 9, 0, '', '2019-07-12 15:52:45');
INSERT INTO `access_log` VALUES (53624, '65.46.15629179652484241', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 15:52:45', 9, 0, '', '2019-07-12 15:52:45');
INSERT INTO `access_log` VALUES (53625, '65.49.15629179670234169', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 15:52:47', 19, 0, '', '2019-07-12 15:52:47');
INSERT INTO `access_log` VALUES (53626, '65.45.15629179683964159', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 15:52:48', 11, 0, '', '2019-07-12 15:52:48');
INSERT INTO `access_log` VALUES (53627, '65.47.15629179751164167', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.214.218.151', '2019-07-12 15:52:55', 11, 0, '', '2019-07-12 15:52:55');
INSERT INTO `access_log` VALUES (53628, '59.76.15629182063682323', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.228.216.18', '2019-07-12 15:56:46', 3, 0, '', '2019-07-12 15:56:46');
INSERT INTO `access_log` VALUES (53629, '59.71.15629182063692335', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.228.216.18', '2019-07-12 15:56:46', 13, 2001001000, '服务端发生异常', '2019-07-12 15:56:46');
INSERT INTO `access_log` VALUES (53630, '64.78.15629182166442521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.228.216.18', '2019-07-12 15:56:57', 3, 0, '', '2019-07-12 15:56:57');
INSERT INTO `access_log` VALUES (53631, '64.84.15629182167182511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.228.216.18', '2019-07-12 15:56:57', 2, 0, '', '2019-07-12 15:56:57');
INSERT INTO `access_log` VALUES (53632, '64.81.15629182197052501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.228.216.18', '2019-07-12 15:57:00', 2, 0, '', '2019-07-12 15:57:00');
INSERT INTO `access_log` VALUES (53633, '64.80.15629182207522525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.228.216.18', '2019-07-12 15:57:01', 2, 0, '', '2019-07-12 15:57:01');
INSERT INTO `access_log` VALUES (53634, '65.53.15629213559414227', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '222.182.192.30', '2019-07-12 16:49:16', 1, 1002001015, '账号未登陆', '2019-07-12 16:49:16');
INSERT INTO `access_log` VALUES (53635, '65.52.15629213559424261', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '222.182.192.30', '2019-07-12 16:49:16', 1, 1002001015, '账号未登陆', '2019-07-12 16:49:16');
INSERT INTO `access_log` VALUES (53636, '65.45.15629213559494207', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '222.182.192.30', '2019-07-12 16:49:16', 1, 1002001015, '账号未登陆', '2019-07-12 16:49:16');
INSERT INTO `access_log` VALUES (53637, '65.46.15629213611124287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '222.182.192.30', '2019-07-12 16:49:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 16:49:21');
INSERT INTO `access_log` VALUES (53638, '65.50.15629213675044241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '222.182.192.30', '2019-07-12 16:49:28', 83, 0, '', '2019-07-12 16:49:28');
INSERT INTO `access_log` VALUES (53639, '65.54.15629213678384169', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '222.182.192.30', '2019-07-12 16:49:28', 21, 0, '', '2019-07-12 16:49:28');
INSERT INTO `access_log` VALUES (53640, '65.47.15629213678444215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '222.182.192.30', '2019-07-12 16:49:28', 17, 2001001000, '服务端发生异常', '2019-07-12 16:49:28');
INSERT INTO `access_log` VALUES (53641, '65.51.15629213678464285', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '222.182.192.30', '2019-07-12 16:49:28', 9, 0, '', '2019-07-12 16:49:28');
INSERT INTO `access_log` VALUES (53642, '65.53.15629213807064229', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '222.182.192.30', '2019-07-12 16:49:41', 11, 0, '', '2019-07-12 16:49:41');
INSERT INTO `access_log` VALUES (53643, '65.52.15629213807114263', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '222.182.192.30', '2019-07-12 16:49:41', 10, 2001001000, '服务端发生异常', '2019-07-12 16:49:41');
INSERT INTO `access_log` VALUES (53644, '65.45.15629213807174209', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '222.182.192.30', '2019-07-12 16:49:41', 8, 0, '', '2019-07-12 16:49:41');
INSERT INTO `access_log` VALUES (53645, '59.72.15629218910732377', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.29.178', '2019-07-12 16:58:11', 15, 0, '', '2019-07-12 16:58:11');
INSERT INTO `access_log` VALUES (53646, '59.74.15629218910782387', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.29.178', '2019-07-12 16:58:11', 17, 2001001000, '服务端发生异常', '2019-07-12 16:58:11');
INSERT INTO `access_log` VALUES (53647, '64.85.15629218940862581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.29.178', '2019-07-12 16:58:14', 13, 0, '', '2019-07-12 16:58:14');
INSERT INTO `access_log` VALUES (53648, '64.78.15629218941792571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.29.178', '2019-07-12 16:58:14', 4, 0, '', '2019-07-12 16:58:14');
INSERT INTO `access_log` VALUES (53649, '64.84.15629219003522561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.29.178', '2019-07-12 16:58:20', 2, 0, '', '2019-07-12 16:58:20');
INSERT INTO `access_log` VALUES (53650, '64.81.15629219004382551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.29.178', '2019-07-12 16:58:20', 2, 0, '', '2019-07-12 16:58:20');
INSERT INTO `access_log` VALUES (53651, '64.76.15629219015652563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.29.178', '2019-07-12 16:58:22', 2, 0, '', '2019-07-12 16:58:22');
INSERT INTO `access_log` VALUES (53652, '64.79.15629219025382567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.29.178', '2019-07-12 16:58:23', 2, 0, '', '2019-07-12 16:58:23');
INSERT INTO `access_log` VALUES (53653, '59.71.15629219037062385', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.29.178', '2019-07-12 16:58:24', 3, 0, '', '2019-07-12 16:58:24');
INSERT INTO `access_log` VALUES (53654, '59.80.15629219037132363', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.29.178', '2019-07-12 16:58:24', 14, 2001001000, '服务端发生异常', '2019-07-12 16:58:24');
INSERT INTO `access_log` VALUES (53655, '59.75.15629219142842391', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.29.178', '2019-07-12 16:58:34', 9, 0, '', '2019-07-12 16:58:34');
INSERT INTO `access_log` VALUES (53656, '59.73.15629219142842387', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.167.29.178', '2019-07-12 16:58:34', 18, 2001001000, '服务端发生异常', '2019-07-12 16:58:34');
INSERT INTO `access_log` VALUES (53657, '65.49.15629225265644233', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.202.152.56', '2019-07-12 17:08:47', 5, 1002001012, '访问令牌已过期', '2019-07-12 17:08:47');
INSERT INTO `access_log` VALUES (53658, '65.52.15629225265654279', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.202.152.56', '2019-07-12 17:08:47', 5, 1002001012, '访问令牌已过期', '2019-07-12 17:08:47');
INSERT INTO `access_log` VALUES (53659, '65.53.15629225265664245', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.202.152.56', '2019-07-12 17:08:47', 4, 1002001012, '访问令牌已过期', '2019-07-12 17:08:47');
INSERT INTO `access_log` VALUES (53660, '65.3607.15629227085736043', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.250.149.170', '2019-07-12 17:11:49', 1, 1002001015, '账号未登陆', '2019-07-12 17:11:49');
INSERT INTO `access_log` VALUES (53661, '65.50.15629227085764261', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.250.149.170', '2019-07-12 17:11:49', 0, 1002001015, '账号未登陆', '2019-07-12 17:11:49');
INSERT INTO `access_log` VALUES (53662, '65.47.15629227085774235', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.250.149.170', '2019-07-12 17:11:49', 1, 1002001015, '账号未登陆', '2019-07-12 17:11:49');
INSERT INTO `access_log` VALUES (53663, '65.51.15629227238424305', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.250.149.170', '2019-07-12 17:12:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:12:04');
INSERT INTO `access_log` VALUES (53664, '65.49.15629227268854237', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.250.149.170', '2019-07-12 17:12:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:12:07');
INSERT INTO `access_log` VALUES (53665, '65.53.15629227325964249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.250.149.170', '2019-07-12 17:12:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:12:13');
INSERT INTO `access_log` VALUES (53666, '65.46.15629227543654309', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.250.149.170', '2019-07-12 17:12:34', 364, 0, '', '2019-07-12 17:12:35');
INSERT INTO `access_log` VALUES (53667, '65.50.15629227550984263', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.250.149.170', '2019-07-12 17:12:35', 281, 0, '', '2019-07-12 17:12:35');
INSERT INTO `access_log` VALUES (53668, '65.47.15629227551014237', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.250.149.170', '2019-07-12 17:12:35', 279, 0, '', '2019-07-12 17:12:35');
INSERT INTO `access_log` VALUES (53669, '65.3607.15629227551016045', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.250.149.170', '2019-07-12 17:12:35', 280, 2001001000, '服务端发生异常', '2019-07-12 17:12:35');
INSERT INTO `access_log` VALUES (53670, '65.51.15629227724194307', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.250.149.170', '2019-07-12 17:12:52', 9, 0, '', '2019-07-12 17:12:52');
INSERT INTO `access_log` VALUES (53671, '65.52.15629227724244285', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.250.149.170', '2019-07-12 17:12:52', 9, 0, '', '2019-07-12 17:12:52');
INSERT INTO `access_log` VALUES (53672, '65.49.15629227724244239', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '114.250.149.170', '2019-07-12 17:12:52', 10, 2001001000, '服务端发生异常', '2019-07-12 17:12:52');
INSERT INTO `access_log` VALUES (53673, '59.80.15629243506962397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.144.198.130', '2019-07-12 17:39:11', 11, 0, '', '2019-07-12 17:39:11');
INSERT INTO `access_log` VALUES (53674, '59.75.15629243506962425', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.144.198.130', '2019-07-12 17:39:11', 16, 2001001000, '服务端发生异常', '2019-07-12 17:39:11');
INSERT INTO `access_log` VALUES (53675, '64.85.15629243578392615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.144.198.130', '2019-07-12 17:39:18', 12, 0, '', '2019-07-12 17:39:18');
INSERT INTO `access_log` VALUES (53676, '64.78.15629243579912605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.144.198.130', '2019-07-12 17:39:18', 3, 0, '', '2019-07-12 17:39:18');
INSERT INTO `access_log` VALUES (53677, '65.47.15629243774544261', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.144.198.130', '2019-07-12 17:39:37', 1, 1002001015, '账号未登陆', '2019-07-12 17:39:37');
INSERT INTO `access_log` VALUES (53678, '65.51.15629243774574329', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.144.198.130', '2019-07-12 17:39:37', 0, 1002001015, '账号未登陆', '2019-07-12 17:39:37');
INSERT INTO `access_log` VALUES (53679, '65.54.15629243774574215', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.144.198.130', '2019-07-12 17:39:37', 1, 1002001015, '账号未登陆', '2019-07-12 17:39:37');
INSERT INTO `access_log` VALUES (53680, '65.49.15629243799384261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.144.198.130', '2019-07-12 17:39:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:39:40');
INSERT INTO `access_log` VALUES (53681, '65.53.15629243860944275', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.144.198.130', '2019-07-12 17:39:46', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:39:46');
INSERT INTO `access_log` VALUES (53682, '65.46.15629243981984333', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.144.198.130', '2019-07-12 17:39:58', 218, 0, '', '2019-07-12 17:39:58');
INSERT INTO `access_log` VALUES (53683, '65.50.15629243987054287', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.144.198.130', '2019-07-12 17:39:59', 9, 0, '', '2019-07-12 17:39:59');
INSERT INTO `access_log` VALUES (53684, '65.3607.15629243987056069', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.144.198.130', '2019-07-12 17:39:59', 11, 2001001000, '服务端发生异常', '2019-07-12 17:39:59');
INSERT INTO `access_log` VALUES (53685, '65.47.15629243987084263', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.144.198.130', '2019-07-12 17:39:59', 9, 0, '', '2019-07-12 17:39:59');
INSERT INTO `access_log` VALUES (53686, '59.79.15629249492212425', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.45.24', '2019-07-12 17:49:09', 4, 0, '', '2019-07-12 17:49:09');
INSERT INTO `access_log` VALUES (53687, '59.74.15629249492272429', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.45.24', '2019-07-12 17:49:09', 13, 2001001000, '服务端发生异常', '2019-07-12 17:49:09');
INSERT INTO `access_log` VALUES (53688, '65.50.15629249602474295', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.45.24', '2019-07-12 17:49:20', 0, 1002001015, '账号未登陆', '2019-07-12 17:49:20');
INSERT INTO `access_log` VALUES (53689, '65.3607.15629249602546077', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.45.24', '2019-07-12 17:49:20', 0, 1002001015, '账号未登陆', '2019-07-12 17:49:20');
INSERT INTO `access_log` VALUES (53690, '65.47.15629249602584271', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.45.24', '2019-07-12 17:49:20', 0, 1002001015, '账号未登陆', '2019-07-12 17:49:20');
INSERT INTO `access_log` VALUES (53691, '65.51.15629249619974339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.45.24', '2019-07-12 17:49:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:49:22');
INSERT INTO `access_log` VALUES (53692, '65.52.15629249702314319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.45.24', '2019-07-12 17:49:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:49:30');
INSERT INTO `access_log` VALUES (53693, '65.53.15629249880984285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.45.24', '2019-07-12 17:49:48', 269, 0, '', '2019-07-12 17:49:48');
INSERT INTO `access_log` VALUES (53694, '65.45.15629249886714265', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.45.24', '2019-07-12 17:49:49', 12, 0, '', '2019-07-12 17:49:49');
INSERT INTO `access_log` VALUES (53695, '65.46.15629249886804343', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.45.24', '2019-07-12 17:49:49', 10, 0, '', '2019-07-12 17:49:49');
INSERT INTO `access_log` VALUES (53696, '65.50.15629249886804297', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.45.24', '2019-07-12 17:49:49', 9, 2001001000, '服务端发生异常', '2019-07-12 17:49:49');
INSERT INTO `access_log` VALUES (53697, '59.79.15629252268532429', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:53:47', 3, 0, '', '2019-07-12 17:53:47');
INSERT INTO `access_log` VALUES (53698, '59.74.15629252268552433', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:53:47', 12, 2001001000, '服务端发生异常', '2019-07-12 17:53:47');
INSERT INTO `access_log` VALUES (53699, '64.78.15629252313542617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:53:51', 3, 0, '', '2019-07-12 17:53:51');
INSERT INTO `access_log` VALUES (53700, '64.84.15629252314532607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:53:51', 2, 0, '', '2019-07-12 17:53:51');
INSERT INTO `access_log` VALUES (53701, '64.81.15629252338362597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:53:54', 2, 0, '', '2019-07-12 17:53:54');
INSERT INTO `access_log` VALUES (53702, '64.80.15629252347212621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:53:55', 2, 0, '', '2019-07-12 17:53:55');
INSERT INTO `access_log` VALUES (53703, '59.78.15629252364312423', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:53:56', 3, 0, '', '2019-07-12 17:53:56');
INSERT INTO `access_log` VALUES (53704, '59.77.15629252364312417', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:53:56', 13, 2001001000, '服务端发生异常', '2019-07-12 17:53:56');
INSERT INTO `access_log` VALUES (53705, '59.71.15629252435132433', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:54:04', 2, 0, '', '2019-07-12 17:54:04');
INSERT INTO `access_log` VALUES (53706, '59.72.15629252435132425', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:54:04', 18, 2001001000, '服务端发生异常', '2019-07-12 17:54:04');
INSERT INTO `access_log` VALUES (53707, '64.79.15629252515992613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:54:12', 2, 0, '', '2019-07-12 17:54:12');
INSERT INTO `access_log` VALUES (53708, '64.77.15629252518602599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:54:12', 2, 0, '', '2019-07-12 17:54:12');
INSERT INTO `access_log` VALUES (53709, '65.50.15629252758824301', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:54:36', 1, 1002001015, '账号未登陆', '2019-07-12 17:54:36');
INSERT INTO `access_log` VALUES (53710, '65.3607.15629252758836083', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:54:36', 0, 1002001015, '账号未登陆', '2019-07-12 17:54:36');
INSERT INTO `access_log` VALUES (53711, '65.47.15629252758874277', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:54:36', 0, 1002001015, '账号未登陆', '2019-07-12 17:54:36');
INSERT INTO `access_log` VALUES (53712, '65.51.15629252778984345', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:54:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:54:38');
INSERT INTO `access_log` VALUES (53713, '65.52.15629252810334325', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:54:41', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:54:41');
INSERT INTO `access_log` VALUES (53714, '65.49.15629252820874277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:54:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:54:42');
INSERT INTO `access_log` VALUES (53715, '65.53.15629252828954291', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:54:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:54:43');
INSERT INTO `access_log` VALUES (53716, '65.45.15629252835034271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:54:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:54:44');
INSERT INTO `access_log` VALUES (53717, '65.46.15629252839114349', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:54:44', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:54:44');
INSERT INTO `access_log` VALUES (53718, '65.3607.15629252842976085', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:54:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:54:44');
INSERT INTO `access_log` VALUES (53719, '59.74.15629253007282435', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.52.201', '2019-07-12 17:55:01', 3, 0, '', '2019-07-12 17:55:01');
INSERT INTO `access_log` VALUES (53720, '59.73.15629253025172433', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.63.83.26', '2019-07-12 17:55:03', 13, 2001001000, '服务端发生异常', '2019-07-12 17:55:03');
INSERT INTO `access_log` VALUES (53721, '65.51.15629253139004347', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:55:14', 722, 0, '', '2019-07-12 17:55:15');
INSERT INTO `access_log` VALUES (53722, '65.54.15629253149804233', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:55:15', 9, 0, '', '2019-07-12 17:55:15');
INSERT INTO `access_log` VALUES (53723, '65.52.15629253149814327', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:55:15', 10, 2001001000, '服务端发生异常', '2019-07-12 17:55:15');
INSERT INTO `access_log` VALUES (53724, '65.49.15629253149854279', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:55:15', 8, 0, '', '2019-07-12 17:55:15');
INSERT INTO `access_log` VALUES (53725, '65.53.15629253223484293', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:55:22', 9, 0, '', '2019-07-12 17:55:22');
INSERT INTO `access_log` VALUES (53726, '65.45.15629253223524273', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:55:22', 10, 2001001000, '服务端发生异常', '2019-07-12 17:55:22');
INSERT INTO `access_log` VALUES (53727, '65.46.15629253223534351', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.108.59.242', '2019-07-12 17:55:22', 9, 0, '', '2019-07-12 17:55:22');
INSERT INTO `access_log` VALUES (53728, '65.3607.15629253234556087', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.159.184', '2019-07-12 17:55:23', 4, 1002001012, '访问令牌已过期', '2019-07-12 17:55:23');
INSERT INTO `access_log` VALUES (53729, '65.50.15629253234604305', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.52.201', '2019-07-12 17:55:23', 2, 1002001012, '访问令牌已过期', '2019-07-12 17:55:23');
INSERT INTO `access_log` VALUES (53730, '65.47.15629253234644281', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.159.184', '2019-07-12 17:55:23', 2, 1002001012, '访问令牌已过期', '2019-07-12 17:55:23');
INSERT INTO `access_log` VALUES (53731, '65.52.15629253297154329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.159.184', '2019-07-12 17:55:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 17:55:30');
INSERT INTO `access_log` VALUES (53732, '65.54.15629253458944235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.52.201', '2019-07-12 17:55:46', 98, 0, '', '2019-07-12 17:55:46');
INSERT INTO `access_log` VALUES (53733, '65.46.15629253476804353', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.67.159.184', '2019-07-12 17:55:48', 9, 0, '', '2019-07-12 17:55:48');
INSERT INTO `access_log` VALUES (53734, '65.45.15629253476834275', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.52.201', '2019-07-12 17:55:48', 9, 2001001000, '服务端发生异常', '2019-07-12 17:55:48');
INSERT INTO `access_log` VALUES (53735, '65.53.15629253492274295', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.52.201', '2019-07-12 17:55:49', 10, 0, '', '2019-07-12 17:55:49');
INSERT INTO `access_log` VALUES (53736, '65.50.15629253526924307', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.63.83.26', '2019-07-12 17:55:53', 9, 0, '', '2019-07-12 17:55:53');
INSERT INTO `access_log` VALUES (53737, '65.47.15629253526944283', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.52.201', '2019-07-12 17:55:53', 9, 0, '', '2019-07-12 17:55:53');
INSERT INTO `access_log` VALUES (53738, '65.3607.15629253526916089', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.63.83.26', '2019-07-12 17:55:53', 11, 2001001000, '服务端发生异常', '2019-07-12 17:55:53');
INSERT INTO `access_log` VALUES (53739, '59.75.15629253645862441', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.166', '2019-07-12 17:56:05', 3, 0, '', '2019-07-12 17:56:05');
INSERT INTO `access_log` VALUES (53740, '65.49.15629253759514283', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.52.201', '2019-07-12 17:56:16', 9, 0, '', '2019-07-12 17:56:16');
INSERT INTO `access_log` VALUES (53741, '59.80.15629253776302413', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.91.60.110', '2019-07-12 17:56:18', 15, 2001001000, '服务端发生异常', '2019-07-12 17:56:18');
INSERT INTO `access_log` VALUES (53742, '65.54.15629253779014237', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.52.201', '2019-07-12 17:56:18', 10, 2001001000, '服务端发生异常', '2019-07-12 17:56:18');
INSERT INTO `access_log` VALUES (53743, '65.46.15629253779044355', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.62.52.201', '2019-07-12 17:56:18', 9, 0, '', '2019-07-12 17:56:18');
INSERT INTO `access_log` VALUES (53744, '65.51.15629265707724371', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.181.38.112', '2019-07-12 18:16:11', 0, 1002001015, '账号未登陆', '2019-07-12 18:16:11');
INSERT INTO `access_log` VALUES (53745, '65.3607.15629265707736107', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.181.38.112', '2019-07-12 18:16:11', 1, 1002001015, '账号未登陆', '2019-07-12 18:16:11');
INSERT INTO `access_log` VALUES (53746, '65.50.15629265707724323', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.181.38.112', '2019-07-12 18:16:11', 0, 1002001015, '账号未登陆', '2019-07-12 18:16:11');
INSERT INTO `access_log` VALUES (53747, '65.52.15629265808144349', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yuandaoyuanma&password=yuandaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.181.38.112', '2019-07-12 18:16:21', 4, 1002002000, '账号不存在', '2019-07-12 18:16:21');
INSERT INTO `access_log` VALUES (53748, '65.46.15629265961844371', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.181.38.112', '2019-07-12 18:16:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 18:16:36');
INSERT INTO `access_log` VALUES (53749, '65.53.15629265997244317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.181.38.112', '2019-07-12 18:16:40', 70, 0, '', '2019-07-12 18:16:40');
INSERT INTO `access_log` VALUES (53750, '65.47.15629266001104303', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.181.38.112', '2019-07-12 18:16:40', 9, 0, '', '2019-07-12 18:16:40');
INSERT INTO `access_log` VALUES (53751, '65.54.15629266001094255', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.181.38.112', '2019-07-12 18:16:40', 11, 2001001000, '服务端发生异常', '2019-07-12 18:16:40');
INSERT INTO `access_log` VALUES (53752, '65.50.15629266001144325', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '220.181.38.112', '2019-07-12 18:16:40', 9, 0, '', '2019-07-12 18:16:40');
INSERT INTO `access_log` VALUES (53753, '59.71.15629269599122457', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.121.61.161', '2019-07-12 18:22:40', 4, 0, '', '2019-07-12 18:22:40');
INSERT INTO `access_log` VALUES (53754, '59.76.15629269599122445', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.121.61.161', '2019-07-12 18:22:40', 19, 2001001000, '服务端发生异常', '2019-07-12 18:22:40');
INSERT INTO `access_log` VALUES (53755, '64.81.15629269774642621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.121.61.161', '2019-07-12 18:22:57', 2, 0, '', '2019-07-12 18:22:57');
INSERT INTO `access_log` VALUES (53756, '64.80.15629269789882645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.121.61.161', '2019-07-12 18:22:59', 2, 0, '', '2019-07-12 18:22:59');
INSERT INTO `access_log` VALUES (53757, '59.77.15629369586272575', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-12 21:09:19', 13, 0, '', '2019-07-12 21:09:19');
INSERT INTO `access_log` VALUES (53758, '59.72.15629369586272583', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-12 21:09:19', 16, 2001001000, '服务端发生异常', '2019-07-12 21:09:19');
INSERT INTO `access_log` VALUES (53759, '64.78.15629369687682775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.33.160.82', '2019-07-12 21:09:29', 11, 0, '', '2019-07-12 21:09:29');
INSERT INTO `access_log` VALUES (53760, '64.84.15629369688942765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.33.160.82', '2019-07-12 21:09:29', 3, 0, '', '2019-07-12 21:09:29');
INSERT INTO `access_log` VALUES (53761, '64.81.15629369723852755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.33.160.82', '2019-07-12 21:09:32', 2, 0, '', '2019-07-12 21:09:32');
INSERT INTO `access_log` VALUES (53762, '64.80.15629369725062779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.33.160.82', '2019-07-12 21:09:33', 2, 0, '', '2019-07-12 21:09:33');
INSERT INTO `access_log` VALUES (53763, '64.79.15629369759292771', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.33.160.82', '2019-07-12 21:09:36', 2, 0, '', '2019-07-12 21:09:36');
INSERT INTO `access_log` VALUES (53764, '64.77.15629369762752757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.33.160.82', '2019-07-12 21:09:36', 1, 0, '', '2019-07-12 21:09:36');
INSERT INTO `access_log` VALUES (53765, '59.75.15629369801452597', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.33.160.82', '2019-07-12 21:09:40', 4, 0, '', '2019-07-12 21:09:40');
INSERT INTO `access_log` VALUES (53766, '59.80.15629369801452569', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.33.160.82', '2019-07-12 21:09:40', 15, 2001001000, '服务端发生异常', '2019-07-12 21:09:40');
INSERT INTO `access_log` VALUES (53767, '64.83.15629369835832769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.33.160.82', '2019-07-12 21:09:44', 2, 0, '', '2019-07-12 21:09:44');
INSERT INTO `access_log` VALUES (53768, '64.82.15629369837012787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.33.160.82', '2019-07-12 21:09:44', 2, 0, '', '2019-07-12 21:09:44');
INSERT INTO `access_log` VALUES (53769, '64.85.15629369852302787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.33.160.82', '2019-07-12 21:09:45', 2, 0, '', '2019-07-12 21:09:45');
INSERT INTO `access_log` VALUES (53770, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.33.160.82', '2019-07-12 21:09:45', 6, 0, '', '2019-07-12 21:09:45');
INSERT INTO `access_log` VALUES (53771, '64.78.15629369871912777', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '182.33.160.82', '2019-07-12 21:09:47', 8, 0, '', '2019-07-12 21:09:47');
INSERT INTO `access_log` VALUES (53772, '65.45.15629370040164437', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-12 21:10:04', 1, 1002001015, '账号未登陆', '2019-07-12 21:10:04');
INSERT INTO `access_log` VALUES (53773, '65.50.15629370040164465', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-12 21:10:04', 1, 1002001015, '账号未登陆', '2019-07-12 21:10:04');
INSERT INTO `access_log` VALUES (53774, '65.54.15629370040614395', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-12 21:10:04', 1, 1002001015, '账号未登陆', '2019-07-12 21:10:04');
INSERT INTO `access_log` VALUES (53775, '65.47.15629370083144443', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-12 21:10:08', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 21:10:08');
INSERT INTO `access_log` VALUES (53776, '65.49.15629370125874443', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-12 21:10:13', 82, 0, '', '2019-07-12 21:10:13');
INSERT INTO `access_log` VALUES (53777, '65.51.15629370129064515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-12 21:10:13', 14, 0, '', '2019-07-12 21:10:13');
INSERT INTO `access_log` VALUES (53778, '65.52.15629370129074491', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-12 21:10:13', 14, 0, '', '2019-07-12 21:10:13');
INSERT INTO `access_log` VALUES (53779, '65.46.15629370129094513', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-12 21:10:13', 14, 2001001000, '服务端发生异常', '2019-07-12 21:10:13');
INSERT INTO `access_log` VALUES (53780, '65.45.15629370224334439', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-12 21:10:22', 8, 0, '', '2019-07-12 21:10:22');
INSERT INTO `access_log` VALUES (53781, '65.53.15629370224314457', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-12 21:10:22', 11, 2001001000, '服务端发生异常', '2019-07-12 21:10:22');
INSERT INTO `access_log` VALUES (53782, '65.50.15629370224314467', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.33.160.82', '2019-07-12 21:10:22', 11, 0, '', '2019-07-12 21:10:22');
INSERT INTO `access_log` VALUES (53783, '59.79.15629401262392631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '112.28.148.218', '2019-07-12 22:02:06', 11, 0, '', '2019-07-12 22:02:06');
INSERT INTO `access_log` VALUES (53784, '59.74.15629401263272635', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '112.28.148.218', '2019-07-12 22:02:06', 13, 2001001000, '服务端发生异常', '2019-07-12 22:02:06');
INSERT INTO `access_log` VALUES (53785, '64.79.15629401370112813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '112.28.148.218', '2019-07-12 22:02:17', 10, 0, '', '2019-07-12 22:02:17');
INSERT INTO `access_log` VALUES (53786, '64.76.15629401371812809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '112.28.148.218', '2019-07-12 22:02:17', 3, 0, '', '2019-07-12 22:02:17');
INSERT INTO `access_log` VALUES (53787, '59.78.15629401400502625', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '112.28.148.218', '2019-07-12 22:02:20', 3, 0, '', '2019-07-12 22:02:20');
INSERT INTO `access_log` VALUES (53788, '59.72.15629401407552627', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '112.28.148.218', '2019-07-12 22:02:21', 11, 2001001000, '服务端发生异常', '2019-07-12 22:02:21');
INSERT INTO `access_log` VALUES (53789, '65.54.15629401715914439', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '112.28.148.218', '2019-07-12 22:02:52', 0, 1002001015, '账号未登陆', '2019-07-12 22:02:52');
INSERT INTO `access_log` VALUES (53790, '65.3607.15629401715916293', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '112.28.148.218', '2019-07-12 22:02:52', 0, 1002001015, '账号未登陆', '2019-07-12 22:02:52');
INSERT INTO `access_log` VALUES (53791, '65.47.15629401715914487', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '112.28.148.218', '2019-07-12 22:02:52', 0, 1002001015, '账号未登陆', '2019-07-12 22:02:52');
INSERT INTO `access_log` VALUES (53792, '65.46.15629401895204557', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '112.28.148.218', '2019-07-12 22:03:10', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 22:03:10');
INSERT INTO `access_log` VALUES (53793, '65.52.15629402028634535', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '112.28.148.218', '2019-07-12 22:03:23', 103, 0, '', '2019-07-12 22:03:23');
INSERT INTO `access_log` VALUES (53794, '65.45.15629402032204483', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '112.28.148.218', '2019-07-12 22:03:23', 13, 0, '', '2019-07-12 22:03:23');
INSERT INTO `access_log` VALUES (53795, '65.50.15629402032214511', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '112.28.148.218', '2019-07-12 22:03:23', 12, 2001001000, '服务端发生异常', '2019-07-12 22:03:23');
INSERT INTO `access_log` VALUES (53796, '65.53.15629402032264501', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '112.28.148.218', '2019-07-12 22:03:23', 11, 0, '', '2019-07-12 22:03:23');
INSERT INTO `access_log` VALUES (53797, '65.51.15629450541214625', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.238.194.189', '2019-07-12 23:24:14', 1, 1002001015, '账号未登陆', '2019-07-12 23:24:14');
INSERT INTO `access_log` VALUES (53798, '65.52.15629450541394601', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.238.194.205', '2019-07-12 23:24:14', 0, 1002001015, '账号未登陆', '2019-07-12 23:24:14');
INSERT INTO `access_log` VALUES (53799, '65.46.15629450541394623', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.238.194.189', '2019-07-12 23:24:14', 0, 1002001015, '账号未登陆', '2019-07-12 23:24:14');
INSERT INTO `access_log` VALUES (53800, '65.45.15629450786914549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.238.194.205', '2019-07-12 23:24:39', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 23:24:39');
INSERT INTO `access_log` VALUES (53801, '65.54.15629450857074507', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.238.194.205', '2019-07-12 23:24:46', 13, 1002002001, '密码不正确', '2019-07-12 23:24:46');
INSERT INTO `access_log` VALUES (53802, '65.47.15629454016614559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.238.194.205', '2019-07-12 23:30:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 23:30:02');
INSERT INTO `access_log` VALUES (53803, '65.51.15629454108454631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin &password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '115.238.194.205', '2019-07-12 23:30:11', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号格式为数字以及字母\n密码长度为 6-16 位', '2019-07-12 23:30:11');
INSERT INTO `access_log` VALUES (53804, '59.71.15629460062872713', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:40:06', 10, 0, '', '2019-07-12 23:40:06');
INSERT INTO `access_log` VALUES (53805, '59.76.15629460062872701', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:40:06', 15, 2001001000, '服务端发生异常', '2019-07-12 23:40:06');
INSERT INTO `access_log` VALUES (53806, '65.52.15629460203354615', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:40:20', 1, 1002001015, '账号未登陆', '2019-07-12 23:40:20');
INSERT INTO `access_log` VALUES (53807, '65.46.15629460203354637', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:40:20', 0, 1002001015, '账号未登陆', '2019-07-12 23:40:20');
INSERT INTO `access_log` VALUES (53808, '65.50.15629460203374591', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:40:20', 1, 1002001015, '账号未登陆', '2019-07-12 23:40:20');
INSERT INTO `access_log` VALUES (53809, '65.53.15629460245484581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:40:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-12 23:40:25');
INSERT INTO `access_log` VALUES (53810, '65.54.15629460334484521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:40:33', 92, 0, '', '2019-07-12 23:40:34');
INSERT INTO `access_log` VALUES (53811, '65.3607.15629460337956375', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:40:34', 15, 0, '', '2019-07-12 23:40:34');
INSERT INTO `access_log` VALUES (53812, '65.47.15629460337994569', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:40:34', 15, 2001001000, '服务端发生异常', '2019-07-12 23:40:34');
INSERT INTO `access_log` VALUES (53813, '65.49.15629460338024569', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:40:34', 22, 0, '', '2019-07-12 23:40:34');
INSERT INTO `access_log` VALUES (53814, '65.50.15629460712024593', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:41:11', 10, 0, '', '2019-07-12 23:41:11');
INSERT INTO `access_log` VALUES (53815, '65.45.15629460712054565', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:41:11', 10, 2001001000, '服务端发生异常', '2019-07-12 23:41:11');
INSERT INTO `access_log` VALUES (53816, '65.53.15629460712104583', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:41:11', 8, 0, '', '2019-07-12 23:41:11');
INSERT INTO `access_log` VALUES (53817, '65.54.15629460749984523', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:41:15', 15, 0, '', '2019-07-12 23:41:15');
INSERT INTO `access_log` VALUES (53818, '65.47.15629460750064571', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:41:15', 10, 2001001000, '服务端发生异常', '2019-07-12 23:41:15');
INSERT INTO `access_log` VALUES (53819, '65.49.15629460750124571', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.87.83.159', '2019-07-12 23:41:15', 8, 0, '', '2019-07-12 23:41:15');
INSERT INTO `access_log` VALUES (53820, '59.80.15629478204082715', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:10:20', 4, 0, '', '2019-07-13 00:10:20');
INSERT INTO `access_log` VALUES (53821, '59.79.15629478204092735', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:10:20', 13, 2001001000, '服务端发生异常', '2019-07-13 00:10:20');
INSERT INTO `access_log` VALUES (53822, '64.82.15629478232272933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:10:23', 14, 0, '', '2019-07-13 00:10:23');
INSERT INTO `access_log` VALUES (53823, '64.78.15629478233392923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:10:23', 3, 0, '', '2019-07-13 00:10:23');
INSERT INTO `access_log` VALUES (53824, '64.84.15629478243672915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:10:24', 2, 0, '', '2019-07-13 00:10:24');
INSERT INTO `access_log` VALUES (53825, '64.81.15629478248052903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:10:25', 2, 0, '', '2019-07-13 00:10:25');
INSERT INTO `access_log` VALUES (53826, '64.80.15629478251842927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:10:25', 2, 0, '', '2019-07-13 00:10:25');
INSERT INTO `access_log` VALUES (53827, '64.79.15629478256992917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:10:26', 2, 0, '', '2019-07-13 00:10:26');
INSERT INTO `access_log` VALUES (53828, '64.76.15629478294412913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:10:29', 3, 0, '', '2019-07-13 00:10:29');
INSERT INTO `access_log` VALUES (53829, '64.83.15629478295662915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:10:30', 2, 0, '', '2019-07-13 00:10:30');
INSERT INTO `access_log` VALUES (53830, '59.73.15629478307322737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:10:31', 2, 0, '', '2019-07-13 00:10:31');
INSERT INTO `access_log` VALUES (53831, '59.74.15629478307322739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:10:31', 17, 2001001000, '服务端发生异常', '2019-07-13 00:10:31');
INSERT INTO `access_log` VALUES (53832, '64.77.15629478324362905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:10:32', 2, 0, '', '2019-07-13 00:10:32');
INSERT INTO `access_log` VALUES (53833, '64.85.15629478325482935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:10:33', 2, 0, '', '2019-07-13 00:10:33');
INSERT INTO `access_log` VALUES (53834, '65.46.15629479059054665', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:11:46', 0, 1002001015, '账号未登陆', '2019-07-13 00:11:46');
INSERT INTO `access_log` VALUES (53835, '65.52.15629479059044643', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:11:46', 0, 1002001015, '账号未登陆', '2019-07-13 00:11:46');
INSERT INTO `access_log` VALUES (53836, '65.50.15629479059144619', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:11:46', 0, 1002001015, '账号未登陆', '2019-07-13 00:11:46');
INSERT INTO `access_log` VALUES (53837, '65.45.15629479076984591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:11:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-13 00:11:48');
INSERT INTO `access_log` VALUES (53838, '65.47.15629479157044597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:11:56', 449, 0, '', '2019-07-13 00:11:56');
INSERT INTO `access_log` VALUES (53839, '65.54.15629479163814549', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:11:56', 18, 0, '', '2019-07-13 00:11:56');
INSERT INTO `access_log` VALUES (53840, '65.49.15629479163874597', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:11:56', 17, 2001001000, '服务端发生异常', '2019-07-13 00:11:56');
INSERT INTO `access_log` VALUES (53841, '65.3607.15629479163896403', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:11:56', 15, 0, '', '2019-07-13 00:11:56');
INSERT INTO `access_log` VALUES (53842, '65.46.15629479367604667', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:12:17', 69, 0, '', '2019-07-13 00:12:17');
INSERT INTO `access_log` VALUES (53843, '65.50.15629479367704621', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:12:17', 59, 0, '', '2019-07-13 00:12:17');
INSERT INTO `access_log` VALUES (53844, '65.52.15629479367664645', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '111.167.86.194', '2019-07-13 00:12:17', 63, 2001001000, '服务端发生异常', '2019-07-13 00:12:17');
INSERT INTO `access_log` VALUES (53845, '65.46.15629708522244973', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI 8 Lite) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.105 Mobile Safari/537.36', '125.70.30.2', '2019-07-13 06:34:12', 1, 1002001015, '账号未登陆', '2019-07-13 06:34:12');
INSERT INTO `access_log` VALUES (53846, '65.50.15629708522234927', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI 8 Lite) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.105 Mobile Safari/537.36', '125.70.30.2', '2019-07-13 06:34:12', 1, 1002001015, '账号未登陆', '2019-07-13 06:34:12');
INSERT INTO `access_log` VALUES (53847, '65.45.15629708522434899', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI 8 Lite) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.105 Mobile Safari/537.36', '125.70.30.2', '2019-07-13 06:34:12', 0, 1002001015, '账号未登陆', '2019-07-13 06:34:12');
INSERT INTO `access_log` VALUES (53848, '65.53.15629708550584917', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1.0; MI 8 Lite) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.105 Mobile Safari/537.36', '125.70.30.2', '2019-07-13 06:34:15', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-13 06:34:15');
INSERT INTO `access_log` VALUES (53849, '65.54.15629708805894857', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1.0; MI 8 Lite) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.105 Mobile Safari/537.36', '125.70.30.2', '2019-07-13 06:34:41', 62, 0, '', '2019-07-13 06:34:41');
INSERT INTO `access_log` VALUES (53850, '65.3607.15629708813596711', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI 8 Lite) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.105 Mobile Safari/537.36', '125.70.30.2', '2019-07-13 06:34:41', 12, 0, '', '2019-07-13 06:34:41');
INSERT INTO `access_log` VALUES (53851, '65.51.15629708813674977', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI 8 Lite) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.105 Mobile Safari/537.36', '125.70.30.2', '2019-07-13 06:34:41', 10, 2001001000, '服务端发生异常', '2019-07-13 06:34:41');
INSERT INTO `access_log` VALUES (53852, '65.52.15629708813734953', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI 8 Lite) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.105 Mobile Safari/537.36', '125.70.30.2', '2019-07-13 06:34:41', 9, 0, '', '2019-07-13 06:34:41');
INSERT INTO `access_log` VALUES (53853, '59.72.15629769450463119', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.239.185', '2019-07-13 08:15:45', 12, 0, '', '2019-07-13 08:15:45');
INSERT INTO `access_log` VALUES (53854, '59.77.15629769450473111', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.238.239.185', '2019-07-13 08:15:45', 21, 2001001000, '服务端发生异常', '2019-07-13 08:15:45');
INSERT INTO `access_log` VALUES (53855, '59.71.15629794901753161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.233.91', '2019-07-13 08:58:10', 25, 2001001000, '服务端发生异常', '2019-07-13 08:58:10');
INSERT INTO `access_log` VALUES (53856, '59.76.15629794901713149', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.233.91', '2019-07-13 08:58:10', 34, 0, '', '2019-07-13 08:58:10');
INSERT INTO `access_log` VALUES (53857, '65.49.15629794934215021', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.233.91', '2019-07-13 08:58:13', 3, 1002001012, '访问令牌已过期', '2019-07-13 08:58:13');
INSERT INTO `access_log` VALUES (53858, '65.47.15629794934205021', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.233.91', '2019-07-13 08:58:13', 4, 1002001012, '访问令牌已过期', '2019-07-13 08:58:13');
INSERT INTO `access_log` VALUES (53859, '65.54.15629794934214973', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.192.233.91', '2019-07-13 08:58:13', 5, 1002001012, '访问令牌已过期', '2019-07-13 08:58:13');
INSERT INTO `access_log` VALUES (53860, '59.77.15629797321423149', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:02:12', 5, 0, '', '2019-07-13 09:02:12');
INSERT INTO `access_log` VALUES (53861, '59.72.15629797321453157', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:02:12', 22, 2001001000, '服务端发生异常', '2019-07-13 09:02:12');
INSERT INTO `access_log` VALUES (53862, '59.71.15629797405833165', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:02:21', 4, 0, '', '2019-07-13 09:02:21');
INSERT INTO `access_log` VALUES (53863, '59.75.15629797405843171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:02:21', 18, 2001001000, '服务端发生异常', '2019-07-13 09:02:21');
INSERT INTO `access_log` VALUES (53864, '59.80.15629797464343143', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:02:26', 2, 0, '', '2019-07-13 09:02:26');
INSERT INTO `access_log` VALUES (53865, '59.79.15629797464353163', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:02:26', 13, 2001001000, '服务端发生异常', '2019-07-13 09:02:26');
INSERT INTO `access_log` VALUES (53866, '59.74.15629797636683167', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:02:44', 3, 0, '', '2019-07-13 09:02:44');
INSERT INTO `access_log` VALUES (53867, '59.78.15629797636693157', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:02:44', 17, 2001001000, '服务端发生异常', '2019-07-13 09:02:44');
INSERT INTO `access_log` VALUES (53868, '59.71.15629797996193167', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:03:20', 2, 0, '', '2019-07-13 09:03:20');
INSERT INTO `access_log` VALUES (53869, '59.75.15629797996183173', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:03:20', 13, 2001001000, '服务端发生异常', '2019-07-13 09:03:20');
INSERT INTO `access_log` VALUES (53870, '59.79.15629798104383165', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:03:30', 3, 0, '', '2019-07-13 09:03:30');
INSERT INTO `access_log` VALUES (53871, '59.80.15629798104413145', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:03:30', 39, 2001001000, '服务端发生异常', '2019-07-13 09:03:30');
INSERT INTO `access_log` VALUES (53872, '59.74.15629798217803169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:03:42', 2, 0, '', '2019-07-13 09:03:42');
INSERT INTO `access_log` VALUES (53873, '59.78.15629798217823159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:03:42', 16, 2001001000, '服务端发生异常', '2019-07-13 09:03:42');
INSERT INTO `access_log` VALUES (53874, '64.84.15629798257613343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:03:46', 12, 0, '', '2019-07-13 09:03:46');
INSERT INTO `access_log` VALUES (53875, '64.81.15629798259053331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:03:46', 2, 0, '', '2019-07-13 09:03:46');
INSERT INTO `access_log` VALUES (53876, '64.82.15629798275643361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:03:48', 2, 0, '', '2019-07-13 09:03:48');
INSERT INTO `access_log` VALUES (53877, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:03:48', 6, 0, '', '2019-07-13 09:03:48');
INSERT INTO `access_log` VALUES (53878, '64.79.15629798291543345', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:03:49', 7, 0, '', '2019-07-13 09:03:49');
INSERT INTO `access_log` VALUES (53879, '64.80.15629798317343357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:03:52', 2, 0, '', '2019-07-13 09:03:52');
INSERT INTO `access_log` VALUES (53880, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:03:52', 6, 0, '', '2019-07-13 09:03:52');
INSERT INTO `access_log` VALUES (53881, '59.80.15629798777103147', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:04:38', 3, 0, '', '2019-07-13 09:04:38');
INSERT INTO `access_log` VALUES (53882, '59.71.15629798777073169', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:04:38', 21, 2001001000, '服务端发生异常', '2019-07-13 09:04:38');
INSERT INTO `access_log` VALUES (53883, '59.73.15629799038723169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:05:04', 2, 0, '', '2019-07-13 09:05:04');
INSERT INTO `access_log` VALUES (53884, '59.78.15629799038743161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:05:04', 12, 2001001000, '服务端发生异常', '2019-07-13 09:05:04');
INSERT INTO `access_log` VALUES (53885, '64.81.15629799065443333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:05:07', 3, 0, '', '2019-07-13 09:05:07');
INSERT INTO `access_log` VALUES (53886, '64.82.15629799067513363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:05:07', 2, 0, '', '2019-07-13 09:05:07');
INSERT INTO `access_log` VALUES (53887, '64.79.15629799082283347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:05:08', 2, 0, '', '2019-07-13 09:05:08');
INSERT INTO `access_log` VALUES (53888, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:05:08', 6, 0, '', '2019-07-13 09:05:08');
INSERT INTO `access_log` VALUES (53889, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:05:10', 6, 0, '', '2019-07-13 09:05:10');
INSERT INTO `access_log` VALUES (53890, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:05:11', 4, 0, '', '2019-07-13 09:05:11');
INSERT INTO `access_log` VALUES (53891, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:05:12', 5, 0, '', '2019-07-13 09:05:12');
INSERT INTO `access_log` VALUES (53892, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:05:14', 6, 0, '', '2019-07-13 09:05:14');
INSERT INTO `access_log` VALUES (53893, '64.76.15629799146983343', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.5.10) com.laiwang.DingTalk/10421306 Channel/201200 language/zh-Hans-CN', '27.192.233.91', '2019-07-13 09:05:15', 7, 0, '', '2019-07-13 09:05:15');
INSERT INTO `access_log` VALUES (53894, '65.3607.15629810877336849', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:24:48', 1, 1002001015, '账号未登陆', '2019-07-13 09:24:48');
INSERT INTO `access_log` VALUES (53895, '65.52.15629810877335091', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:24:48', 0, 1002001015, '账号未登陆', '2019-07-13 09:24:48');
INSERT INTO `access_log` VALUES (53896, '65.46.15629810877385111', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:24:48', 0, 1002001015, '账号未登陆', '2019-07-13 09:24:48');
INSERT INTO `access_log` VALUES (53897, '65.51.15629810924375115', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:24:52', 81, 0, '', '2019-07-13 09:24:53');
INSERT INTO `access_log` VALUES (53898, '65.50.15629810927215067', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:24:53', 9, 0, '', '2019-07-13 09:24:53');
INSERT INTO `access_log` VALUES (53899, '65.45.15629810927245039', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:24:53', 11, 2001001000, '服务端发生异常', '2019-07-13 09:24:53');
INSERT INTO `access_log` VALUES (53900, '65.53.15629810927295057', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:24:53', 10, 0, '', '2019-07-13 09:24:53');
INSERT INTO `access_log` VALUES (53901, '65.49.15629811005155043', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:25:01', 10, 0, '', '2019-07-13 09:25:01');
INSERT INTO `access_log` VALUES (53902, '65.54.15629811005194997', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:25:01', 9, 2001001000, '服务端发生异常', '2019-07-13 09:25:01');
INSERT INTO `access_log` VALUES (53903, '65.46.15629811005225113', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:25:01', 8, 0, '', '2019-07-13 09:25:01');
INSERT INTO `access_log` VALUES (53904, '65.53.15629811480275059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:25:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-13 09:25:48');
INSERT INTO `access_log` VALUES (53905, '65.50.15629811533005069', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:25:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-13 09:25:53');
INSERT INTO `access_log` VALUES (53906, '65.47.15629811604505047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:26:00', 55, 0, '', '2019-07-13 09:26:01');
INSERT INTO `access_log` VALUES (53907, '65.54.15629811606684999', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:26:01', 9, 0, '', '2019-07-13 09:26:01');
INSERT INTO `access_log` VALUES (53908, '65.46.15629811606715115', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:26:01', 9, 0, '', '2019-07-13 09:26:01');
INSERT INTO `access_log` VALUES (53909, '65.49.15629811606715045', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:26:01', 10, 2001001000, '服务端发生异常', '2019-07-13 09:26:01');
INSERT INTO `access_log` VALUES (53910, '65.3607.15629811645086853', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:26:05', 11, 0, '', '2019-07-13 09:26:05');
INSERT INTO `access_log` VALUES (53911, '65.52.15629811645125095', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:26:05', 10, 2001001000, '服务端发生异常', '2019-07-13 09:26:05');
INSERT INTO `access_log` VALUES (53912, '65.51.15629811645155119', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.179.5', '2019-07-13 09:26:05', 8, 0, '', '2019-07-13 09:26:05');
INSERT INTO `access_log` VALUES (53913, '65.52.15629820351585107', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:40:35', 4, 1002001012, '访问令牌已过期', '2019-07-13 09:40:35');
INSERT INTO `access_log` VALUES (53914, '65.51.15629820351685131', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:40:35', 3, 1002001012, '访问令牌已过期', '2019-07-13 09:40:35');
INSERT INTO `access_log` VALUES (53915, '65.53.15629820351915073', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:40:35', 3, 1002001012, '访问令牌已过期', '2019-07-13 09:40:35');
INSERT INTO `access_log` VALUES (53916, '65.50.15629820377465083', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:40:38', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-13 09:40:38');
INSERT INTO `access_log` VALUES (53917, '65.47.15629820503875061', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:40:50', 96, 0, '', '2019-07-13 09:40:50');
INSERT INTO `access_log` VALUES (53918, '65.49.15629820509475059', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:40:51', 10, 0, '', '2019-07-13 09:40:51');
INSERT INTO `access_log` VALUES (53919, '65.46.15629820509485129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:40:51', 11, 0, '', '2019-07-13 09:40:51');
INSERT INTO `access_log` VALUES (53920, '65.54.15629820509495013', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:40:51', 10, 2001001000, '服务端发生异常', '2019-07-13 09:40:51');
INSERT INTO `access_log` VALUES (53921, '65.51.15629820637195133', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:41:04', 10, 0, '', '2019-07-13 09:41:04');
INSERT INTO `access_log` VALUES (53922, '65.53.15629820637275075', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:41:04', 9, 0, '', '2019-07-13 09:41:04');
INSERT INTO `access_log` VALUES (53923, '65.52.15629820637275109', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:41:04', 10, 2001001000, '服务端发生异常', '2019-07-13 09:41:04');
INSERT INTO `access_log` VALUES (53924, '59.73.15629822702843201', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:44:30', 12, 0, '', '2019-07-13 09:44:30');
INSERT INTO `access_log` VALUES (53925, '59.78.15629822702843193', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:44:30', 23, 2001001000, '服务端发生异常', '2019-07-13 09:44:30');
INSERT INTO `access_log` VALUES (53926, '64.79.15629822756443379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:44:36', 12, 0, '', '2019-07-13 09:44:36');
INSERT INTO `access_log` VALUES (53927, '64.76.15629822758243375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.136.46', '2019-07-13 09:44:36', 2, 0, '', '2019-07-13 09:44:36');
INSERT INTO `access_log` VALUES (53928, '65.46.15629862389275187', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:50:39', 0, 1002001015, '账号未登陆', '2019-07-13 10:50:39');
INSERT INTO `access_log` VALUES (53929, '65.54.15629862389285071', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:50:39', 1, 1002001015, '账号未登陆', '2019-07-13 10:50:39');
INSERT INTO `access_log` VALUES (53930, '65.3607.15629862389346925', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:50:39', 1, 1002001015, '账号未登陆', '2019-07-13 10:50:39');
INSERT INTO `access_log` VALUES (53931, '65.49.15629862437575117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:50:44', 93, 0, '', '2019-07-13 10:50:44');
INSERT INTO `access_log` VALUES (53932, '65.53.15629862441255133', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:50:44', 11, 0, '', '2019-07-13 10:50:44');
INSERT INTO `access_log` VALUES (53933, '65.52.15629862441405167', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:50:44', 9, 0, '', '2019-07-13 10:50:44');
INSERT INTO `access_log` VALUES (53934, '65.51.15629862441465189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:50:44', 13, 2001001000, '服务端发生异常', '2019-07-13 10:50:44');
INSERT INTO `access_log` VALUES (53935, '65.45.15629862643095115', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:51:04', 140, 0, '', '2019-07-13 10:51:04');
INSERT INTO `access_log` VALUES (53936, '65.47.15629862646635121', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:51:05', 11, 0, '', '2019-07-13 10:51:05');
INSERT INTO `access_log` VALUES (53937, '65.54.15629862646675073', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:51:05', 13, 2001001000, '服务端发生异常', '2019-07-13 10:51:05');
INSERT INTO `access_log` VALUES (53938, '65.3607.15629862646776927', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:51:05', 9, 0, '', '2019-07-13 10:51:05');
INSERT INTO `access_log` VALUES (53939, '65.49.15629862796605119', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:51:20', 0, 1002001015, '账号未登陆', '2019-07-13 10:51:20');
INSERT INTO `access_log` VALUES (53940, '65.53.15629862796605135', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:51:20', 0, 1002001015, '账号未登陆', '2019-07-13 10:51:20');
INSERT INTO `access_log` VALUES (53941, '65.51.15629862796665191', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:51:20', 0, 1002001015, '账号未登陆', '2019-07-13 10:51:20');
INSERT INTO `access_log` VALUES (53942, '65.50.15629862879725143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:51:28', 106, 0, '', '2019-07-13 10:51:28');
INSERT INTO `access_log` VALUES (53943, '65.45.15629862883895117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:51:28', 10, 0, '', '2019-07-13 10:51:28');
INSERT INTO `access_log` VALUES (53944, '65.47.15629862883955123', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:51:28', 9, 0, '', '2019-07-13 10:51:28');
INSERT INTO `access_log` VALUES (53945, '65.54.15629862883975075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '36.102.228.109', '2019-07-13 10:51:28', 9, 2001001000, '服务端发生异常', '2019-07-13 10:51:28');
INSERT INTO `access_log` VALUES (53946, '59.80.15629910347283297', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.238.44.173', '2019-07-13 12:10:35', 15, 0, '', '2019-07-13 12:10:35');
INSERT INTO `access_log` VALUES (53947, '59.71.15629910347283319', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.238.44.173', '2019-07-13 12:10:35', 24, 2001001000, '服务端发生异常', '2019-07-13 12:10:35');
INSERT INTO `access_log` VALUES (53948, '59.72.15629965074313385', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.64.68.37', '2019-07-13 13:41:47', 15, 2001001000, '服务端发生异常', '2019-07-13 13:41:47');
INSERT INTO `access_log` VALUES (53949, '59.77.15629965074313377', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.64.68.37', '2019-07-13 13:41:47', 373, 0, '', '2019-07-13 13:41:48');
INSERT INTO `access_log` VALUES (53950, '64.76.15629965117503565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.64.68.37', '2019-07-13 13:41:52', 12, 0, '', '2019-07-13 13:41:52');
INSERT INTO `access_log` VALUES (53951, '64.80.15629965118993581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.64.68.37', '2019-07-13 13:41:52', 3, 0, '', '2019-07-13 13:41:52');
INSERT INTO `access_log` VALUES (53952, '64.83.15629965134313569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.64.68.37', '2019-07-13 13:41:53', 2, 0, '', '2019-07-13 13:41:53');
INSERT INTO `access_log` VALUES (53953, '64.85.15629965140503587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.64.68.37', '2019-07-13 13:41:54', 2, 0, '', '2019-07-13 13:41:54');
INSERT INTO `access_log` VALUES (53954, '65.51.15629965220855329', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.64.68.37', '2019-07-13 13:42:02', 1, 1002001015, '账号未登陆', '2019-07-13 13:42:02');
INSERT INTO `access_log` VALUES (53955, '65.46.15629965220855329', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.64.68.37', '2019-07-13 13:42:02', 0, 1002001015, '账号未登陆', '2019-07-13 13:42:02');
INSERT INTO `access_log` VALUES (53956, '65.53.15629965220865273', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.64.68.37', '2019-07-13 13:42:02', 0, 1002001015, '账号未登陆', '2019-07-13 13:42:02');
INSERT INTO `access_log` VALUES (53957, '65.52.15629965249355307', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.64.68.37', '2019-07-13 13:42:05', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-13 13:42:05');
INSERT INTO `access_log` VALUES (53958, '65.54.15629965300755213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.64.68.37', '2019-07-13 13:42:10', 69, 0, '', '2019-07-13 13:42:10');
INSERT INTO `access_log` VALUES (53959, '65.50.15629965306225281', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.64.68.37', '2019-07-13 13:42:11', 113, 0, '', '2019-07-13 13:42:11');
INSERT INTO `access_log` VALUES (53960, '65.45.15629965306415257', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.64.68.37', '2019-07-13 13:42:11', 99, 0, '', '2019-07-13 13:42:11');
INSERT INTO `access_log` VALUES (53961, '65.47.15629965306335261', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.64.68.37', '2019-07-13 13:42:11', 108, 2001001000, '服务端发生异常', '2019-07-13 13:42:11');
INSERT INTO `access_log` VALUES (53962, '65.52.15629970519065315', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.109.21.180', '2019-07-13 13:50:52', 1, 1002001015, '账号未登陆', '2019-07-13 13:50:52');
INSERT INTO `access_log` VALUES (53963, '65.49.15629970519215265', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.109.21.180', '2019-07-13 13:50:52', 0, 1002001015, '账号未登陆', '2019-07-13 13:50:52');
INSERT INTO `access_log` VALUES (53964, '65.54.15629970519665221', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.109.21.180', '2019-07-13 13:50:52', 0, 1002001015, '账号未登陆', '2019-07-13 13:50:52');
INSERT INTO `access_log` VALUES (53965, '65.52.15629971454955317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.109.21.180', '2019-07-13 13:52:25', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-13 13:52:26');
INSERT INTO `access_log` VALUES (53966, '65.49.15629971487645267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.109.21.180', '2019-07-13 13:52:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-13 13:52:29');
INSERT INTO `access_log` VALUES (53967, '65.49.15630004047545311', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.48.132', '2019-07-13 14:46:45', 0, 1002001015, '账号未登陆', '2019-07-13 14:46:45');
INSERT INTO `access_log` VALUES (53968, '65.53.15630004047545327', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.48.132', '2019-07-13 14:46:45', 1, 1002001015, '账号未登陆', '2019-07-13 14:46:45');
INSERT INTO `access_log` VALUES (53969, '65.52.15630004047545361', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.48.132', '2019-07-13 14:46:45', 1, 1002001015, '账号未登陆', '2019-07-13 14:46:45');
INSERT INTO `access_log` VALUES (53970, '59.75.15630004162753451', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.48.132', '2019-07-13 14:46:56', 10, 0, '', '2019-07-13 14:46:56');
INSERT INTO `access_log` VALUES (53971, '59.71.15630004162773445', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.48.132', '2019-07-13 14:46:56', 15, 2001001000, '服务端发生异常', '2019-07-13 14:46:56');
INSERT INTO `access_log` VALUES (53972, '65.47.15630004262195315', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.90.201.7', '2019-07-13 14:47:06', 0, 1002001015, '账号未登陆', '2019-07-13 14:47:06');
INSERT INTO `access_log` VALUES (53973, '65.50.15630004262225335', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.90.201.7', '2019-07-13 14:47:06', 1, 1002001015, '账号未登陆', '2019-07-13 14:47:06');
INSERT INTO `access_log` VALUES (53974, '65.45.15630004262225311', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.90.201.7', '2019-07-13 14:47:06', 0, 1002001015, '账号未登陆', '2019-07-13 14:47:06');
INSERT INTO `access_log` VALUES (53975, '65.3607.15630004277637123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.90.201.7', '2019-07-13 14:47:08', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-13 14:47:08');
INSERT INTO `access_log` VALUES (53976, '65.51.15630004293565385', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.90.201.7', '2019-07-13 14:47:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-13 14:47:09');
INSERT INTO `access_log` VALUES (53977, '65.52.15630004333505363', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.90.201.7', '2019-07-13 14:47:13', 295, 0, '', '2019-07-13 14:47:14');
INSERT INTO `access_log` VALUES (53978, '65.49.15630004338745313', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.90.201.7', '2019-07-13 14:47:14', 27, 0, '', '2019-07-13 14:47:14');
INSERT INTO `access_log` VALUES (53979, '65.54.15630004338745269', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.90.201.7', '2019-07-13 14:47:14', 28, 2001001000, '服务端发生异常', '2019-07-13 14:47:14');
INSERT INTO `access_log` VALUES (53980, '65.53.15630004338745329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.90.201.7', '2019-07-13 14:47:14', 28, 0, '', '2019-07-13 14:47:14');
INSERT INTO `access_log` VALUES (53981, '65.50.15630034697255379', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:37:50', 1, 1002001015, '账号未登陆', '2019-07-13 15:37:50');
INSERT INTO `access_log` VALUES (53982, '65.45.15630034697265355', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:37:50', 0, 1002001015, '账号未登陆', '2019-07-13 15:37:50');
INSERT INTO `access_log` VALUES (53983, '65.3607.15630034697297167', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:37:50', 0, 1002001015, '账号未登陆', '2019-07-13 15:37:50');
INSERT INTO `access_log` VALUES (53984, '65.46.15630034747495427', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:37:55', 82, 0, '', '2019-07-13 15:37:55');
INSERT INTO `access_log` VALUES (53985, '65.51.15630034750645427', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:37:55', 11, 0, '', '2019-07-13 15:37:55');
INSERT INTO `access_log` VALUES (53986, '65.52.15630034750685405', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:37:55', 10, 2001001000, '服务端发生异常', '2019-07-13 15:37:55');
INSERT INTO `access_log` VALUES (53987, '65.53.15630034750725373', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:37:55', 8, 0, '', '2019-07-13 15:37:55');
INSERT INTO `access_log` VALUES (53988, '65.3607.15630034961457169', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:38:16', 10, 0, '', '2019-07-13 15:38:16');
INSERT INTO `access_log` VALUES (53989, '65.49.15630034961445355', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:38:16', 11, 2001001000, '服务端发生异常', '2019-07-13 15:38:16');
INSERT INTO `access_log` VALUES (53990, '65.50.15630034961495381', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:38:16', 9, 0, '', '2019-07-13 15:38:16');
INSERT INTO `access_log` VALUES (53991, '59.74.15630037716063491', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:42:52', 10, 0, '', '2019-07-13 15:42:52');
INSERT INTO `access_log` VALUES (53992, '59.77.15630037716143475', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:42:52', 40, 2001001000, '服务端发生异常', '2019-07-13 15:42:52');
INSERT INTO `access_log` VALUES (53993, '64.82.15630037763763683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:42:56', 11, 0, '', '2019-07-13 15:42:56');
INSERT INTO `access_log` VALUES (53994, '64.79.15630037765183667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:42:57', 3, 0, '', '2019-07-13 15:42:57');
INSERT INTO `access_log` VALUES (53995, '64.76.15630037776533663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:42:58', 2, 0, '', '2019-07-13 15:42:58');
INSERT INTO `access_log` VALUES (53996, '64.80.15630037782543679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:42:58', 2, 0, '', '2019-07-13 15:42:58');
INSERT INTO `access_log` VALUES (53997, '64.83.15630037787953667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:42:59', 2, 0, '', '2019-07-13 15:42:59');
INSERT INTO `access_log` VALUES (53998, '64.85.15630037792403685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:42:59', 2, 0, '', '2019-07-13 15:42:59');
INSERT INTO `access_log` VALUES (53999, '59.76.15630037801893479', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:43:00', 3, 0, '', '2019-07-13 15:43:00');
INSERT INTO `access_log` VALUES (54000, '59.72.15630037801893483', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:43:00', 14, 2001001000, '服务端发生异常', '2019-07-13 15:43:00');
INSERT INTO `access_log` VALUES (54001, '64.77.15630037824793657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:43:02', 2, 0, '', '2019-07-13 15:43:02');
INSERT INTO `access_log` VALUES (54002, '64.78.15630037826143677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:43:03', 2, 0, '', '2019-07-13 15:43:03');
INSERT INTO `access_log` VALUES (54003, '64.84.15630037835713667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:43:04', 2, 0, '', '2019-07-13 15:43:04');
INSERT INTO `access_log` VALUES (54004, '64.81.15630037840733655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:43:04', 2, 0, '', '2019-07-13 15:43:04');
INSERT INTO `access_log` VALUES (54005, '59.75.15630037849823497', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:43:05', 3, 0, '', '2019-07-13 15:43:05');
INSERT INTO `access_log` VALUES (54006, '59.80.15630037849823469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:43:05', 18, 2001001000, '服务端发生异常', '2019-07-13 15:43:05');
INSERT INTO `access_log` VALUES (54007, '59.74.15630039908413495', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:46:31', 3, 0, '', '2019-07-13 15:46:31');
INSERT INTO `access_log` VALUES (54008, '59.77.15630039908413479', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.144.132.210', '2019-07-13 15:46:31', 13, 2001001000, '服务端发生异常', '2019-07-13 15:46:31');
INSERT INTO `access_log` VALUES (54009, '59.79.15630097507483569', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.92.226.192', '2019-07-13 17:22:31', 31, 2001001000, '服务端发生异常', '2019-07-13 17:22:31');
INSERT INTO `access_log` VALUES (54010, '59.75.15630097507483577', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.92.226.192', '2019-07-13 17:22:31', 56, 0, '', '2019-07-13 17:22:31');
INSERT INTO `access_log` VALUES (54011, '64.81.15630097562713735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.92.226.192', '2019-07-13 17:22:36', 11, 0, '', '2019-07-13 17:22:36');
INSERT INTO `access_log` VALUES (54012, '64.82.15630097563783765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.92.226.192', '2019-07-13 17:22:36', 3, 0, '', '2019-07-13 17:22:36');
INSERT INTO `access_log` VALUES (54013, '59.73.15630097634743571', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.92.226.192', '2019-07-13 17:22:43', 3, 0, '', '2019-07-13 17:22:43');
INSERT INTO `access_log` VALUES (54014, '59.74.15630097634743573', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.92.226.192', '2019-07-13 17:22:43', 18, 2001001000, '服务端发生异常', '2019-07-13 17:22:43');
INSERT INTO `access_log` VALUES (54015, '59.76.15630097736803561', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.50.125.102', '2019-07-13 17:22:54', 3, 0, '', '2019-07-13 17:22:54');
INSERT INTO `access_log` VALUES (54016, '59.72.15630097736803565', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.50.125.102', '2019-07-13 17:22:54', 19, 2001001000, '服务端发生异常', '2019-07-13 17:22:54');
INSERT INTO `access_log` VALUES (54017, '65.52.15630098659855491', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.50.125.102', '2019-07-13 17:24:26', 0, 1002001015, '账号未登陆', '2019-07-13 17:24:26');
INSERT INTO `access_log` VALUES (54018, '65.54.15630098659855397', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.50.125.102', '2019-07-13 17:24:26', 0, 1002001015, '账号未登陆', '2019-07-13 17:24:26');
INSERT INTO `access_log` VALUES (54019, '65.3607.15630098659877255', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.50.125.102', '2019-07-13 17:24:26', 1, 1002001015, '账号未登陆', '2019-07-13 17:24:26');
INSERT INTO `access_log` VALUES (54020, '65.49.15630098717175441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.50.125.102', '2019-07-13 17:24:32', 75, 0, '', '2019-07-13 17:24:32');
INSERT INTO `access_log` VALUES (54021, '65.47.15630098720535447', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.50.125.102', '2019-07-13 17:24:32', 13, 0, '', '2019-07-13 17:24:32');
INSERT INTO `access_log` VALUES (54022, '65.45.15630098720535443', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.50.125.102', '2019-07-13 17:24:32', 12, 0, '', '2019-07-13 17:24:32');
INSERT INTO `access_log` VALUES (54023, '65.50.15630098720535467', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.50.125.102', '2019-07-13 17:24:32', 22, 2001001000, '服务端发生异常', '2019-07-13 17:24:32');
INSERT INTO `access_log` VALUES (54024, '65.51.15630099001995515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.50.125.102', '2019-07-13 17:25:00', 11, 0, '', '2019-07-13 17:25:00');
INSERT INTO `access_log` VALUES (54025, '65.52.15630099002075493', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.50.125.102', '2019-07-13 17:25:00', 17, 2001001000, '服务端发生异常', '2019-07-13 17:25:00');
INSERT INTO `access_log` VALUES (54026, '65.3607.15630099002097257', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.50.125.102', '2019-07-13 17:25:00', 16, 0, '', '2019-07-13 17:25:00');
INSERT INTO `access_log` VALUES (54027, '59.78.15630143145283625', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.144.125.174', '2019-07-13 18:38:35', 17, 2001001000, '服务端发生异常', '2019-07-13 18:38:35');
INSERT INTO `access_log` VALUES (54028, '59.75.15630143145273639', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.144.125.174', '2019-07-13 18:38:35', 155, 0, '', '2019-07-13 18:38:35');
INSERT INTO `access_log` VALUES (54029, '59.77.15630194508673687', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.151.242', '2019-07-13 20:04:11', 18, 0, '', '2019-07-13 20:04:11');
INSERT INTO `access_log` VALUES (54030, '59.76.15630194508703691', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.151.242', '2019-07-13 20:04:11', 26, 2001001000, '服务端发生异常', '2019-07-13 20:04:11');
INSERT INTO `access_log` VALUES (54031, '64.78.15630194555603887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.151.242', '2019-07-13 20:04:16', 11, 0, '', '2019-07-13 20:04:16');
INSERT INTO `access_log` VALUES (54032, '64.84.15630194557203877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.22.151.242', '2019-07-13 20:04:16', 3, 0, '', '2019-07-13 20:04:16');
INSERT INTO `access_log` VALUES (54033, '59.75.15630199671903715', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; MHA-AL00 Build/HUAWEIMHA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/3.24.1', '112.10.74.190', '2019-07-13 20:12:47', 18, 2001001000, '服务端发生异常', '2019-07-13 20:12:47');
INSERT INTO `access_log` VALUES (54034, '59.78.15630199669353701', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; MHA-AL00 Build/HUAWEIMHA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/3.24.1', '112.10.74.190', '2019-07-13 20:12:47', 280, 0, '', '2019-07-13 20:12:47');
INSERT INTO `access_log` VALUES (54035, '64.83.15630199753073885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; MHA-AL00 Build/HUAWEIMHA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/3.24.1', '112.10.74.190', '2019-07-13 20:12:55', 4, 0, '', '2019-07-13 20:12:55');
INSERT INTO `access_log` VALUES (54036, '64.85.15630199755283903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; MHA-AL00 Build/HUAWEIMHA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/3.24.1', '112.10.74.190', '2019-07-13 20:12:56', 2, 0, '', '2019-07-13 20:12:56');
INSERT INTO `access_log` VALUES (54037, '64.77.15630199781253875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; MHA-AL00 Build/HUAWEIMHA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/3.24.1', '112.10.74.190', '2019-07-13 20:12:58', 2, 0, '', '2019-07-13 20:12:58');
INSERT INTO `access_log` VALUES (54038, '64.78.15630199803183895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; MHA-AL00 Build/HUAWEIMHA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/3.24.1', '112.10.74.190', '2019-07-13 20:13:00', 2, 0, '', '2019-07-13 20:13:00');
INSERT INTO `access_log` VALUES (54039, '64.84.15630199818743885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; MHA-AL00 Build/HUAWEIMHA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/3.24.1', '112.10.74.190', '2019-07-13 20:13:02', 3, 0, '', '2019-07-13 20:13:02');
INSERT INTO `access_log` VALUES (54040, '59.74.15630199826953711', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; MHA-AL00 Build/HUAWEIMHA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/3.24.1', '112.10.74.190', '2019-07-13 20:13:03', 2, 0, '', '2019-07-13 20:13:03');
INSERT INTO `access_log` VALUES (54041, '59.77.15630199827163695', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; MHA-AL00 Build/HUAWEIMHA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/3.24.1', '112.10.74.190', '2019-07-13 20:13:03', 18, 2001001000, '服务端发生异常', '2019-07-13 20:13:03');
INSERT INTO `access_log` VALUES (54042, '64.81.15630199853153873', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; MHA-AL00 Build/HUAWEIMHA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/3.24.1', '112.10.74.190', '2019-07-13 20:13:05', 1, 0, '', '2019-07-13 20:13:05');
INSERT INTO `access_log` VALUES (54043, '64.79.15630199855233887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; MHA-AL00 Build/HUAWEIMHA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/3.24.1', '112.10.74.190', '2019-07-13 20:13:06', 3, 0, '', '2019-07-13 20:13:06');
INSERT INTO `access_log` VALUES (54044, '64.76.15630199950353883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; MHA-AL00 Build/HUAWEIMHA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/3.24.1', '112.10.74.190', '2019-07-13 20:13:15', 2, 0, '', '2019-07-13 20:13:15');
INSERT INTO `access_log` VALUES (54045, '64.80.15630199952213899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; MHA-AL00 Build/HUAWEIMHA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.132 MQQBrowser/6.2 TBS/044328 Mobile Safari/537.36 xiaomiquan/3.24.1', '112.10.74.190', '2019-07-13 20:13:15', 2, 0, '', '2019-07-13 20:13:15');
INSERT INTO `access_log` VALUES (54046, '65.54.15630201054955535', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.241.243.9', '2019-07-13 20:15:05', 1, 1002001015, '账号未登陆', '2019-07-13 20:15:05');
INSERT INTO `access_log` VALUES (54047, '65.49.15630201054955579', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.241.243.9', '2019-07-13 20:15:05', 1, 1002001015, '账号未登陆', '2019-07-13 20:15:05');
INSERT INTO `access_log` VALUES (54048, '65.47.15630201054995585', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.241.243.9', '2019-07-13 20:15:05', 1, 1002001015, '账号未登陆', '2019-07-13 20:15:06');
INSERT INTO `access_log` VALUES (54049, '65.51.15630201864875653', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.241.243.9', '2019-07-13 20:16:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-13 20:16:26');
INSERT INTO `access_log` VALUES (54050, '65.49.15630201995195581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.241.243.9', '2019-07-13 20:16:40', 84, 0, '', '2019-07-13 20:16:40');
INSERT INTO `access_log` VALUES (54051, '65.47.15630202027925587', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.241.243.9', '2019-07-13 20:16:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-13 20:16:43');
INSERT INTO `access_log` VALUES (54052, '65.50.15630202162115607', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.241.243.9', '2019-07-13 20:16:56', 297, 0, '', '2019-07-13 20:16:57');
INSERT INTO `access_log` VALUES (54053, '65.46.15630202240375655', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.241.243.9', '2019-07-13 20:17:04', 69, 0, '', '2019-07-13 20:17:04');
INSERT INTO `access_log` VALUES (54054, '59.75.15630238010413767', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3837.0 Safari/537.36 Edg/77.0.211.3', '223.166.112.162', '2019-07-13 21:16:41', 10, 0, '', '2019-07-13 21:16:41');
INSERT INTO `access_log` VALUES (54055, '59.78.15630238010413753', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3837.0 Safari/537.36 Edg/77.0.211.3', '223.166.112.162', '2019-07-13 21:16:41', 168, 2001001000, '服务端发生异常', '2019-07-13 21:16:41');
INSERT INTO `access_log` VALUES (54056, '64.84.15630238090283937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3837.0 Safari/537.36 Edg/77.0.211.3', '223.166.112.162', '2019-07-13 21:16:49', 15, 0, '', '2019-07-13 21:16:49');
INSERT INTO `access_log` VALUES (54057, '64.81.15630238091473925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3837.0 Safari/537.36 Edg/77.0.211.3', '223.166.112.162', '2019-07-13 21:16:49', 3, 0, '', '2019-07-13 21:16:49');
INSERT INTO `access_log` VALUES (54058, '59.76.15630388468003951', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 01:27:27', 16, 0, '', '2019-07-14 01:27:27');
INSERT INTO `access_log` VALUES (54059, '59.72.15630388468063955', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 01:27:27', 28, 2001001000, '服务端发生异常', '2019-07-14 01:27:27');
INSERT INTO `access_log` VALUES (54060, '64.80.15630388551414151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 01:27:35', 12, 0, '', '2019-07-14 01:27:35');
INSERT INTO `access_log` VALUES (54061, '64.83.15630388553294139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 01:27:35', 3, 0, '', '2019-07-14 01:27:35');
INSERT INTO `access_log` VALUES (54062, '59.80.15630388673663941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:27:47', 3, 0, '', '2019-07-14 01:27:47');
INSERT INTO `access_log` VALUES (54063, '59.79.15630388673693961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:27:47', 23, 2001001000, '服务端发生异常', '2019-07-14 01:27:47');
INSERT INTO `access_log` VALUES (54064, '64.78.15630388791944149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:27:59', 2, 0, '', '2019-07-14 01:27:59');
INSERT INTO `access_log` VALUES (54065, '64.84.15630388794664139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:27:59', 2, 0, '', '2019-07-14 01:27:59');
INSERT INTO `access_log` VALUES (54066, '64.81.15630388814884127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:01', 1, 0, '', '2019-07-14 01:28:01');
INSERT INTO `access_log` VALUES (54067, '64.79.15630388864614141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:06', 2, 0, '', '2019-07-14 01:28:06');
INSERT INTO `access_log` VALUES (54068, '64.76.15630388866024137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:07', 2, 0, '', '2019-07-14 01:28:07');
INSERT INTO `access_log` VALUES (54069, '59.73.15630388949843963', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:15', 3, 0, '', '2019-07-14 01:28:15');
INSERT INTO `access_log` VALUES (54070, '59.74.15630388949863965', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:15', 22, 2001001000, '服务端发生异常', '2019-07-14 01:28:15');
INSERT INTO `access_log` VALUES (54071, '64.83.15630389014814141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:21', 2, 0, '', '2019-07-14 01:28:21');
INSERT INTO `access_log` VALUES (54072, '64.85.15630389017814159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:22', 2, 0, '', '2019-07-14 01:28:22');
INSERT INTO `access_log` VALUES (54073, '64.77.15630389032104131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:23', 2, 0, '', '2019-07-14 01:28:23');
INSERT INTO `access_log` VALUES (54074, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:23', 7, 0, '', '2019-07-14 01:28:23');
INSERT INTO `access_log` VALUES (54075, '64.78.15630389054274151', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:25', 8, 0, '', '2019-07-14 01:28:25');
INSERT INTO `access_log` VALUES (54076, '64.84.15630389114924141', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:31', 7, 0, '', '2019-07-14 01:28:32');
INSERT INTO `access_log` VALUES (54077, '64.81.15630389122924129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:32', 1, 0, '', '2019-07-14 01:28:32');
INSERT INTO `access_log` VALUES (54078, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:32', 6, 0, '', '2019-07-14 01:28:32');
INSERT INTO `access_log` VALUES (54079, '64.79.15630389165764143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:37', 2, 0, '', '2019-07-14 01:28:37');
INSERT INTO `access_log` VALUES (54080, '64.76.15630389167484139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '59.63.206.38', '2019-07-14 01:28:37', 2, 0, '', '2019-07-14 01:28:37');
INSERT INTO `access_log` VALUES (54081, '65.49.15630708273536255', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.30.192.13', '2019-07-14 10:20:27', 1, 1002001015, '账号未登陆', '2019-07-14 10:20:27');
INSERT INTO `access_log` VALUES (54082, '65.50.15630708831896285', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=小王&offset=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.30.192.13', '2019-07-14 10:21:23', 1, 1002001015, '账号未登陆', '2019-07-14 10:21:23');
INSERT INTO `access_log` VALUES (54083, '65.50.15630848162296471', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:13:36', 0, 1002001015, '账号未登陆', '2019-07-14 14:13:36');
INSERT INTO `access_log` VALUES (54084, '65.53.15630848162296467', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:13:36', 0, 1002001015, '账号未登陆', '2019-07-14 14:13:36');
INSERT INTO `access_log` VALUES (54085, '65.3607.15630848162318261', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:13:36', 1, 1002001015, '账号未登陆', '2019-07-14 14:13:36');
INSERT INTO `access_log` VALUES (54086, '65.51.15630848185916521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:13:39', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-14 14:13:39');
INSERT INTO `access_log` VALUES (54087, '59.72.15630851276564573', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:18:48', 11, 0, '', '2019-07-14 14:18:48');
INSERT INTO `access_log` VALUES (54088, '59.71.15630851276594581', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:18:48', 31, 2001001000, '服务端发生异常', '2019-07-14 14:18:48');
INSERT INTO `access_log` VALUES (54089, '64.84.15630851307064759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:18:51', 12, 0, '', '2019-07-14 14:18:51');
INSERT INTO `access_log` VALUES (54090, '64.81.15630851308394747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:18:51', 3, 0, '', '2019-07-14 14:18:51');
INSERT INTO `access_log` VALUES (54091, '64.82.15630851319864777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:18:52', 2, 0, '', '2019-07-14 14:18:52');
INSERT INTO `access_log` VALUES (54092, '64.79.15630851325524761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:18:53', 2, 0, '', '2019-07-14 14:18:53');
INSERT INTO `access_log` VALUES (54093, '64.76.15630851331304757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:18:53', 2, 0, '', '2019-07-14 14:18:53');
INSERT INTO `access_log` VALUES (54094, '59.79.15630851338184579', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:18:54', 4, 0, '', '2019-07-14 14:18:54');
INSERT INTO `access_log` VALUES (54095, '59.75.15630851338224587', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:18:54', 19, 2001001000, '服务端发生异常', '2019-07-14 14:18:54');
INSERT INTO `access_log` VALUES (54096, '64.80.15630851357564773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:18:56', 3, 0, '', '2019-07-14 14:18:56');
INSERT INTO `access_log` VALUES (54097, '64.83.15630851358564759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:18:56', 1, 0, '', '2019-07-14 14:18:56');
INSERT INTO `access_log` VALUES (54098, '59.78.15630851366864573', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:18:57', 2, 0, '', '2019-07-14 14:18:57');
INSERT INTO `access_log` VALUES (54099, '59.74.15630851366884583', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '123.120.29.235', '2019-07-14 14:18:57', 15, 2001001000, '服务端发生异常', '2019-07-14 14:18:57');
INSERT INTO `access_log` VALUES (54100, '65.50.15630873074566505', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 14:55:07', 0, 1002001015, '账号未登陆', '2019-07-14 14:55:07');
INSERT INTO `access_log` VALUES (54101, '65.53.15630873074566501', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 14:55:07', 0, 1002001015, '账号未登陆', '2019-07-14 14:55:07');
INSERT INTO `access_log` VALUES (54102, '65.3607.15630873077128295', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 14:55:08', 1, 1002001015, '账号未登陆', '2019-07-14 14:55:08');
INSERT INTO `access_log` VALUES (54103, '65.52.15630873106376533', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 14:55:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-14 14:55:11');
INSERT INTO `access_log` VALUES (54104, '65.49.15630873323426477', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 14:55:32', 108, 0, '', '2019-07-14 14:55:32');
INSERT INTO `access_log` VALUES (54105, '65.45.15630873329276481', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 14:55:33', 22, 0, '', '2019-07-14 14:55:33');
INSERT INTO `access_log` VALUES (54106, '65.46.15630873329346555', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 14:55:33', 16, 0, '', '2019-07-14 14:55:33');
INSERT INTO `access_log` VALUES (54107, '65.47.15630873329276487', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 14:55:33', 26, 2001001000, '服务端发生异常', '2019-07-14 14:55:33');
INSERT INTO `access_log` VALUES (54108, '65.3607.15630873602848297', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 14:56:00', 12, 0, '', '2019-07-14 14:56:00');
INSERT INTO `access_log` VALUES (54109, '65.51.15630873602846557', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 14:56:00', 12, 2001001000, '服务端发生异常', '2019-07-14 14:56:00');
INSERT INTO `access_log` VALUES (54110, '65.52.15630873602866535', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.38', '2019-07-14 14:56:00', 11, 0, '', '2019-07-14 14:56:00');
INSERT INTO `access_log` VALUES (54111, '59.77.15630891987644621', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.163.115', '2019-07-14 15:26:39', 11, 0, '', '2019-07-14 15:26:39');
INSERT INTO `access_log` VALUES (54112, '59.71.15630891998144635', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.163.115', '2019-07-14 15:26:40', 15, 2001001000, '服务端发生异常', '2019-07-14 15:26:40');
INSERT INTO `access_log` VALUES (54113, '59.78.15630892197904629', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.163.115', '2019-07-14 15:27:00', 4, 0, '', '2019-07-14 15:27:00');
INSERT INTO `access_log` VALUES (54114, '59.80.15630892197914615', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.163.115', '2019-07-14 15:27:00', 15, 2001001000, '服务端发生异常', '2019-07-14 15:27:00');
INSERT INTO `access_log` VALUES (54115, '65.51.15630892474086583', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.163.115', '2019-07-14 15:27:27', 0, 1002001015, '账号未登陆', '2019-07-14 15:27:27');
INSERT INTO `access_log` VALUES (54116, '65.52.15630892474086561', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.163.115', '2019-07-14 15:27:27', 0, 1002001015, '账号未登陆', '2019-07-14 15:27:27');
INSERT INTO `access_log` VALUES (54117, '65.50.15630892474086533', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.163.115', '2019-07-14 15:27:27', 0, 1002001015, '账号未登陆', '2019-07-14 15:27:27');
INSERT INTO `access_log` VALUES (54118, '65.47.15630892904036515', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.163.115', '2019-07-14 15:28:10', 64, 0, '', '2019-07-14 15:28:10');
INSERT INTO `access_log` VALUES (54119, '65.46.15630892908296583', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.163.115', '2019-07-14 15:28:11', 11, 0, '', '2019-07-14 15:28:11');
INSERT INTO `access_log` VALUES (54120, '65.45.15630892908296509', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.163.115', '2019-07-14 15:28:11', 12, 2001001000, '服务端发生异常', '2019-07-14 15:28:11');
INSERT INTO `access_log` VALUES (54121, '65.53.15630892908626531', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.163.115', '2019-07-14 15:28:11', 10, 0, '', '2019-07-14 15:28:11');
INSERT INTO `access_log` VALUES (54122, '65.52.15630893083326563', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.163.115', '2019-07-14 15:28:28', 11, 0, '', '2019-07-14 15:28:28');
INSERT INTO `access_log` VALUES (54123, '65.51.15630893083346585', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.163.115', '2019-07-14 15:28:28', 12, 0, '', '2019-07-14 15:28:28');
INSERT INTO `access_log` VALUES (54124, '65.3607.15630893083388325', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.93.189.12', '2019-07-14 15:28:28', 11, 2001001000, '服务端发生异常', '2019-07-14 15:28:28');
INSERT INTO `access_log` VALUES (54125, '59.71.15630945598714707', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '110.229.110.182', '2019-07-14 16:56:00', 12, 0, '', '2019-07-14 16:56:00');
INSERT INTO `access_log` VALUES (54126, '59.79.15630945598714705', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '110.229.110.182', '2019-07-14 16:56:00', 30, 2001001000, '服务端发生异常', '2019-07-14 16:56:00');
INSERT INTO `access_log` VALUES (54127, '64.83.15630945704414885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '110.229.110.182', '2019-07-14 16:56:10', 11, 0, '', '2019-07-14 16:56:10');
INSERT INTO `access_log` VALUES (54128, '64.85.15630945705514905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '110.229.110.182', '2019-07-14 16:56:11', 3, 0, '', '2019-07-14 16:56:11');
INSERT INTO `access_log` VALUES (54129, '64.77.15630945726814877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '110.229.110.182', '2019-07-14 16:56:13', 2, 0, '', '2019-07-14 16:56:13');
INSERT INTO `access_log` VALUES (54130, '64.78.15630945735614895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '110.229.110.182', '2019-07-14 16:56:14', 2, 0, '', '2019-07-14 16:56:14');
INSERT INTO `access_log` VALUES (54131, '64.84.15630945742904887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '110.229.110.182', '2019-07-14 16:56:14', 2, 0, '', '2019-07-14 16:56:14');
INSERT INTO `access_log` VALUES (54132, '64.81.15630945792804875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '110.229.110.182', '2019-07-14 16:56:19', 3, 0, '', '2019-07-14 16:56:19');
INSERT INTO `access_log` VALUES (54133, '64.82.15630945794304905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '110.229.110.182', '2019-07-14 16:56:19', 2, 0, '', '2019-07-14 16:56:19');
INSERT INTO `access_log` VALUES (54134, '64.80.15630946020114901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '110.229.110.182', '2019-07-14 16:56:42', 2, 0, '', '2019-07-14 16:56:42');
INSERT INTO `access_log` VALUES (54135, '64.83.15630946021204887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '110.229.110.182', '2019-07-14 16:56:42', 2, 0, '', '2019-07-14 16:56:42');
INSERT INTO `access_log` VALUES (54136, '59.73.15630946034114709', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '110.229.110.182', '2019-07-14 16:56:43', 3, 0, '', '2019-07-14 16:56:43');
INSERT INTO `access_log` VALUES (54137, '59.75.15630946034414715', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '110.229.110.182', '2019-07-14 16:56:43', 16, 2001001000, '服务端发生异常', '2019-07-14 16:56:43');
INSERT INTO `access_log` VALUES (54138, '65.3607.15631152609948673', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-14 22:41:01', 24, 1002001012, '访问令牌已过期', '2019-07-14 22:41:01');
INSERT INTO `access_log` VALUES (54139, '65.51.15631152609956933', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-14 22:41:01', 29, 1002001012, '访问令牌已过期', '2019-07-14 22:41:01');
INSERT INTO `access_log` VALUES (54140, '65.50.15631152609956883', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-14 22:41:01', 32, 1002001012, '访问令牌已过期', '2019-07-14 22:41:01');
INSERT INTO `access_log` VALUES (54141, '65.52.15631152653976911', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-14 22:41:05', 71, 0, '', '2019-07-14 22:41:05');
INSERT INTO `access_log` VALUES (54142, '65.49.15631152656366853', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-14 22:41:06', 139, 0, '', '2019-07-14 22:41:06');
INSERT INTO `access_log` VALUES (54143, '65.46.15631152656366931', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-14 22:41:06', 141, 2001001000, '服务端发生异常', '2019-07-14 22:41:06');
INSERT INTO `access_log` VALUES (54144, '65.54.15631152656346809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.235.187.186', '2019-07-14 22:41:06', 144, 0, '', '2019-07-14 22:41:06');
INSERT INTO `access_log` VALUES (54145, '65.3607.15631249214058803', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'xiaomiquan/4.3.0 Android/Phone/9 HONOR_COL-AL10', '223.104.227.200', '2019-07-15 01:22:01', 1, 1002001015, '账号未登陆', '2019-07-15 01:22:01');
INSERT INTO `access_log` VALUES (54146, '65.51.15631249214047063', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'xiaomiquan/4.3.0 Android/Phone/9 HONOR_COL-AL10', '223.104.227.200', '2019-07-15 01:22:01', 1, 1002001015, '账号未登陆', '2019-07-15 01:22:01');
INSERT INTO `access_log` VALUES (54147, '65.52.15631249214117041', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'xiaomiquan/4.3.0 Android/Phone/9 HONOR_COL-AL10', '223.104.227.200', '2019-07-15 01:22:01', 0, 1002001015, '账号未登陆', '2019-07-15 01:22:01');
INSERT INTO `access_log` VALUES (54148, '65.54.15631249243486939', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'xiaomiquan/4.3.0 Android/Phone/9 HONOR_COL-AL10', '223.104.227.200', '2019-07-15 01:22:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 01:22:04');
INSERT INTO `access_log` VALUES (54149, '65.47.15631249471776995', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'xiaomiquan/4.3.0 Android/Phone/9 HONOR_COL-AL10', '223.104.227.200', '2019-07-15 01:22:27', 60, 0, '', '2019-07-15 01:22:27');
INSERT INTO `access_log` VALUES (54150, '65.45.15631249477466989', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'xiaomiquan/4.3.0 Android/Phone/9 HONOR_COL-AL10', '223.104.227.200', '2019-07-15 01:22:28', 10, 0, '', '2019-07-15 01:22:28');
INSERT INTO `access_log` VALUES (54151, '65.53.15631249477407011', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'xiaomiquan/4.3.0 Android/Phone/9 HONOR_COL-AL10', '223.104.227.200', '2019-07-15 01:22:28', 17, 2001001000, '服务端发生异常', '2019-07-15 01:22:28');
INSERT INTO `access_log` VALUES (54152, '65.50.15631249477627015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'xiaomiquan/4.3.0 Android/Phone/9 HONOR_COL-AL10', '223.104.227.200', '2019-07-15 01:22:28', 9, 0, '', '2019-07-15 01:22:28');
INSERT INTO `access_log` VALUES (54153, '65.54.15631249834926941', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'xiaomiquan/4.3.0 Android/Phone/9 HONOR_COL-AL10', '223.104.227.200', '2019-07-15 01:23:03', 11, 2001001000, '服务端发生异常', '2019-07-15 01:23:04');
INSERT INTO `access_log` VALUES (54154, '65.52.15631249834917043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'xiaomiquan/4.3.0 Android/Phone/9 HONOR_COL-AL10', '223.104.227.200', '2019-07-15 01:23:03', 12, 0, '', '2019-07-15 01:23:04');
INSERT INTO `access_log` VALUES (54155, '65.46.15631249834967063', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'xiaomiquan/4.3.0 Android/Phone/9 HONOR_COL-AL10', '223.104.227.200', '2019-07-15 01:23:03', 10, 0, '', '2019-07-15 01:23:04');
INSERT INTO `access_log` VALUES (54156, '59.75.15631479637355427', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.44', '2019-07-15 07:46:04', 12, 0, '', '2019-07-15 07:46:04');
INSERT INTO `access_log` VALUES (54157, '59.76.15631479637355411', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.44', '2019-07-15 07:46:04', 33, 2001001000, '服务端发生异常', '2019-07-15 07:46:04');
INSERT INTO `access_log` VALUES (54158, '65.45.15631580560967435', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.136.112.179', '2019-07-15 10:34:16', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 10:34:16');
INSERT INTO `access_log` VALUES (54159, '59.80.15631580699585533', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.136.112.179', '2019-07-15 10:34:30', 10, 0, '', '2019-07-15 10:34:30');
INSERT INTO `access_log` VALUES (54160, '59.74.15631580699605559', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.136.112.179', '2019-07-15 10:34:30', 20, 2001001000, '服务端发生异常', '2019-07-15 10:34:30');
INSERT INTO `access_log` VALUES (54161, '64.84.15631580753415735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.136.112.179', '2019-07-15 10:34:35', 115, 0, '', '2019-07-15 10:34:35');
INSERT INTO `access_log` VALUES (54162, '64.82.15631580756005751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.136.112.179', '2019-07-15 10:34:36', 3, 0, '', '2019-07-15 10:34:36');
INSERT INTO `access_log` VALUES (54163, '66.55.15631580822943473', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.136.112.179', '2019-07-15 10:34:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空', '2019-07-15 10:34:42');
INSERT INTO `access_log` VALUES (54164, '65.3607.15631582163139249', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 10:36:56', 0, 1002001015, '账号未登陆', '2019-07-15 10:36:56');
INSERT INTO `access_log` VALUES (54165, '65.51.15631582163127513', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 10:36:56', 0, 1002001015, '账号未登陆', '2019-07-15 10:36:56');
INSERT INTO `access_log` VALUES (54166, '65.46.15631582163147509', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 10:36:56', 0, 1002001015, '账号未登陆', '2019-07-15 10:36:56');
INSERT INTO `access_log` VALUES (54167, '65.53.15631582404987457', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 10:37:20', 105, 0, '', '2019-07-15 10:37:21');
INSERT INTO `access_log` VALUES (54168, '65.52.15631582407757489', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 10:37:21', 13, 0, '', '2019-07-15 10:37:21');
INSERT INTO `access_log` VALUES (54169, '65.54.15631582407757389', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 10:37:21', 15, 0, '', '2019-07-15 10:37:21');
INSERT INTO `access_log` VALUES (54170, '65.49.15631582407747433', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 10:37:21', 15, 2001001000, '服务端发生异常', '2019-07-15 10:37:21');
INSERT INTO `access_log` VALUES (54171, '65.54.15631586379017395', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:43:58', 0, 1002001015, '账号未登陆', '2019-07-15 10:43:58');
INSERT INTO `access_log` VALUES (54172, '65.52.15631586379017495', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:43:58', 0, 1002001015, '账号未登陆', '2019-07-15 10:43:58');
INSERT INTO `access_log` VALUES (54173, '65.49.15631586379007439', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:43:58', 1, 1002001015, '账号未登陆', '2019-07-15 10:43:58');
INSERT INTO `access_log` VALUES (54174, '65.45.15631586484317445', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:08', 74, 0, '', '2019-07-15 10:44:09');
INSERT INTO `access_log` VALUES (54175, '65.50.15631586487607471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:09', 11, 0, '', '2019-07-15 10:44:09');
INSERT INTO `access_log` VALUES (54176, '65.51.15631586487657521', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:09', 9, 0, '', '2019-07-15 10:44:09');
INSERT INTO `access_log` VALUES (54177, '65.3607.15631586487689257', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:09', 9, 2001001000, '服务端发生异常', '2019-07-15 10:44:09');
INSERT INTO `access_log` VALUES (54178, '65.47.15631586571907447', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:17', 10, 0, '', '2019-07-15 10:44:17');
INSERT INTO `access_log` VALUES (54179, '65.53.15631586571967465', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:17', 9, 0, '', '2019-07-15 10:44:17');
INSERT INTO `access_log` VALUES (54180, '65.54.15631586571997397', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:17', 10, 2001001000, '服务端发生异常', '2019-07-15 10:44:17');
INSERT INTO `access_log` VALUES (54181, '65.49.15631586635457441', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:24', 9, 0, '', '2019-07-15 10:44:24');
INSERT INTO `access_log` VALUES (54182, '65.52.15631586635457497', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:24', 10, 2001001000, '服务端发生异常', '2019-07-15 10:44:24');
INSERT INTO `access_log` VALUES (54183, '65.45.15631586635487447', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:24', 9, 0, '', '2019-07-15 10:44:24');
INSERT INTO `access_log` VALUES (54184, '65.51.15631586707437523', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 10:44:31');
INSERT INTO `access_log` VALUES (54185, '65.3607.15631586759909259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:36', 92, 0, '', '2019-07-15 10:44:36');
INSERT INTO `access_log` VALUES (54186, '65.54.15631586762567399', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:36', 9, 0, '', '2019-07-15 10:44:36');
INSERT INTO `access_log` VALUES (54187, '65.47.15631586762567449', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:36', 9, 0, '', '2019-07-15 10:44:36');
INSERT INTO `access_log` VALUES (54188, '65.46.15631586762557519', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:36', 9, 0, '', '2019-07-15 10:44:36');
INSERT INTO `access_log` VALUES (54189, '62.82.15631586926394741', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:44:53', 43, 0, '', '2019-07-15 10:44:53');
INSERT INTO `access_log` VALUES (54190, '66.54.15631587076033507', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:45:08', 141, 0, '', '2019-07-15 10:45:08');
INSERT INTO `access_log` VALUES (54191, '59.76.15631587097915555', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:45:10', 24, 0, '', '2019-07-15 10:45:10');
INSERT INTO `access_log` VALUES (54192, '65.49.15631587134617443', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:45:13', 26, 0, '', '2019-07-15 10:45:13');
INSERT INTO `access_log` VALUES (54193, '65.50.15631587165617475', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:45:17', 10, 0, '', '2019-07-15 10:45:17');
INSERT INTO `access_log` VALUES (54194, '59.72.15631587314655559', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '182.200.186.210', '2019-07-15 10:45:31', 14, 0, '', '2019-07-15 10:45:31');
INSERT INTO `access_log` VALUES (54195, '65.45.15631600114837467', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:06:51', 1, 1002001015, '账号未登陆', '2019-07-15 11:06:51');
INSERT INTO `access_log` VALUES (54196, '65.52.15631600114837517', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:06:51', 0, 1002001015, '账号未登陆', '2019-07-15 11:06:51');
INSERT INTO `access_log` VALUES (54197, '65.49.15631600114857461', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:06:51', 0, 1002001015, '账号未登陆', '2019-07-15 11:06:51');
INSERT INTO `access_log` VALUES (54198, '65.51.15631600144947543', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:06:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 11:06:55');
INSERT INTO `access_log` VALUES (54199, '65.54.15631600289457419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:09', 142, 0, '', '2019-07-15 11:07:09');
INSERT INTO `access_log` VALUES (54200, '65.53.15631600293397487', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:09', 17, 0, '', '2019-07-15 11:07:09');
INSERT INTO `access_log` VALUES (54201, '65.47.15631600293377469', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:09', 19, 2001001000, '服务端发生异常', '2019-07-15 11:07:09');
INSERT INTO `access_log` VALUES (54202, '65.46.15631600293387539', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:09', 19, 0, '', '2019-07-15 11:07:09');
INSERT INTO `access_log` VALUES (54203, '65.52.15631600398977519', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:20', 9, 0, '', '2019-07-15 11:07:20');
INSERT INTO `access_log` VALUES (54204, '65.45.15631600398997469', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:20', 9, 0, '', '2019-07-15 11:07:20');
INSERT INTO `access_log` VALUES (54205, '65.49.15631600398987463', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:20', 10, 2001001000, '服务端发生异常', '2019-07-15 11:07:20');
INSERT INTO `access_log` VALUES (54206, '65.51.15631600510497545', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:31', 9, 0, '', '2019-07-15 11:07:31');
INSERT INTO `access_log` VALUES (54207, '65.3607.15631600510519281', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:31', 9, 2001001000, '服务端发生异常', '2019-07-15 11:07:31');
INSERT INTO `access_log` VALUES (54208, '65.54.15631600510547421', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:31', 8, 0, '', '2019-07-15 11:07:31');
INSERT INTO `access_log` VALUES (54209, '65.46.15631600514047541', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:31', 9, 0, '', '2019-07-15 11:07:31');
INSERT INTO `access_log` VALUES (54210, '65.53.15631600514077489', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:31', 9, 2001001000, '服务端发生异常', '2019-07-15 11:07:31');
INSERT INTO `access_log` VALUES (54211, '65.47.15631600514097471', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:31', 8, 0, '', '2019-07-15 11:07:31');
INSERT INTO `access_log` VALUES (54212, '65.45.15631600517617471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:32', 9, 0, '', '2019-07-15 11:07:32');
INSERT INTO `access_log` VALUES (54213, '65.52.15631600517657521', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:32', 9, 0, '', '2019-07-15 11:07:32');
INSERT INTO `access_log` VALUES (54214, '65.49.15631600517657465', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:32', 10, 2001001000, '服务端发生异常', '2019-07-15 11:07:32');
INSERT INTO `access_log` VALUES (54215, '65.50.15631600521737497', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:32', 8, 0, '', '2019-07-15 11:07:32');
INSERT INTO `access_log` VALUES (54216, '65.54.15631600521757423', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:32', 10, 2001001000, '服务端发生异常', '2019-07-15 11:07:32');
INSERT INTO `access_log` VALUES (54217, '65.3607.15631600521809283', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-15 11:07:32', 9, 0, '', '2019-07-15 11:07:32');
INSERT INTO `access_log` VALUES (54218, '65.50.15631611187627513', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.105.23', '2019-07-15 11:25:19', 0, 1002001015, '账号未登陆', '2019-07-15 11:25:19');
INSERT INTO `access_log` VALUES (54219, '65.45.15631611187617485', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.105.23', '2019-07-15 11:25:19', 0, 1002001015, '账号未登陆', '2019-07-15 11:25:19');
INSERT INTO `access_log` VALUES (54220, '65.51.15631611187767563', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.105.23', '2019-07-15 11:25:19', 0, 1002001015, '账号未登陆', '2019-07-15 11:25:19');
INSERT INTO `access_log` VALUES (54221, '65.54.15631611258137439', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.105.23', '2019-07-15 11:25:26', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 11:25:26');
INSERT INTO `access_log` VALUES (54222, '65.46.15631611343447559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.105.23', '2019-07-15 11:25:34', 66, 0, '', '2019-07-15 11:25:34');
INSERT INTO `access_log` VALUES (54223, '65.52.15631611346187537', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.105.23', '2019-07-15 11:25:35', 10, 0, '', '2019-07-15 11:25:35');
INSERT INTO `access_log` VALUES (54224, '65.53.15631611346207507', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.105.23', '2019-07-15 11:25:35', 9, 0, '', '2019-07-15 11:25:35');
INSERT INTO `access_log` VALUES (54225, '65.47.15631611346187489', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.105.23', '2019-07-15 11:25:35', 13, 2001001000, '服务端发生异常', '2019-07-15 11:25:35');
INSERT INTO `access_log` VALUES (54226, '59.71.15631626127375615', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.88.163.180', '2019-07-15 11:50:13', 17, 0, '', '2019-07-15 11:50:13');
INSERT INTO `access_log` VALUES (54227, '59.72.15631626127375611', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.88.163.180', '2019-07-15 11:50:13', 20, 2001001000, '服务端发生异常', '2019-07-15 11:50:13');
INSERT INTO `access_log` VALUES (54228, '65.49.15631675279307567', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.50.81.199', '2019-07-15 13:12:08', 1, 1002001015, '账号未登陆', '2019-07-15 13:12:08');
INSERT INTO `access_log` VALUES (54229, '65.50.15631675279307603', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.50.81.199', '2019-07-15 13:12:08', 0, 1002001015, '账号未登陆', '2019-07-15 13:12:08');
INSERT INTO `access_log` VALUES (54230, '65.45.15631675279307573', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.50.81.199', '2019-07-15 13:12:08', 0, 1002001015, '账号未登陆', '2019-07-15 13:12:08');
INSERT INTO `access_log` VALUES (54231, '65.3607.15631675300309387', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.50.81.199', '2019-07-15 13:12:10', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 13:12:10');
INSERT INTO `access_log` VALUES (54232, '65.54.15631675322597525', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.50.81.199', '2019-07-15 13:12:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 13:12:12');
INSERT INTO `access_log` VALUES (54233, '65.47.15631675331177579', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.50.81.199', '2019-07-15 13:12:13', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 13:12:13');
INSERT INTO `access_log` VALUES (54234, '65.52.15631675339427627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.50.81.199', '2019-07-15 13:12:14', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 13:12:14');
INSERT INTO `access_log` VALUES (54235, '65.46.15631675481077649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.50.81.199', '2019-07-15 13:12:28', 74, 0, '', '2019-07-15 13:12:28');
INSERT INTO `access_log` VALUES (54236, '65.45.15631675484817575', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.50.81.199', '2019-07-15 13:12:28', 14, 0, '', '2019-07-15 13:12:28');
INSERT INTO `access_log` VALUES (54237, '65.50.15631675484887605', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.50.81.199', '2019-07-15 13:12:28', 11, 2001001000, '服务端发生异常', '2019-07-15 13:12:29');
INSERT INTO `access_log` VALUES (54238, '65.49.15631675484927569', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.50.81.199', '2019-07-15 13:12:28', 12, 0, '', '2019-07-15 13:12:29');
INSERT INTO `access_log` VALUES (54239, '65.54.15631675833517527', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.50.81.199', '2019-07-15 13:13:03', 9, 0, '', '2019-07-15 13:13:03');
INSERT INTO `access_log` VALUES (54240, '65.47.15631675833707581', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.50.81.199', '2019-07-15 13:13:03', 11, 2001001000, '服务端发生异常', '2019-07-15 13:13:03');
INSERT INTO `access_log` VALUES (54241, '65.52.15631675833727629', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.50.81.199', '2019-07-15 13:13:03', 10, 0, '', '2019-07-15 13:13:03');
INSERT INTO `access_log` VALUES (54242, '59.75.15631685314655703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:28:51', 12, 0, '', '2019-07-15 13:28:51');
INSERT INTO `access_log` VALUES (54243, '59.76.15631685314665687', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:28:51', 20, 2001001000, '服务端发生异常', '2019-07-15 13:28:51');
INSERT INTO `access_log` VALUES (54244, '65.50.15631685476077619', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:29:08', 1, 1002001015, '账号未登陆', '2019-07-15 13:29:08');
INSERT INTO `access_log` VALUES (54245, '65.51.15631685476107667', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:29:08', 1, 1002001015, '账号未登陆', '2019-07-15 13:29:08');
INSERT INTO `access_log` VALUES (54246, '65.3607.15631685476129403', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:29:08', 0, 1002001015, '账号未登陆', '2019-07-15 13:29:08');
INSERT INTO `access_log` VALUES (54247, '65.47.15631685497767595', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:29:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 13:29:10');
INSERT INTO `access_log` VALUES (54248, '65.53.15631685655667611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:29:26', 107, 0, '', '2019-07-15 13:29:26');
INSERT INTO `access_log` VALUES (54249, '65.46.15631685659377665', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:29:26', 10, 0, '', '2019-07-15 13:29:26');
INSERT INTO `access_log` VALUES (54250, '65.49.15631685659397585', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:29:26', 10, 2001001000, '服务端发生异常', '2019-07-15 13:29:26');
INSERT INTO `access_log` VALUES (54251, '65.45.15631685659407591', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:29:26', 9, 0, '', '2019-07-15 13:29:26');
INSERT INTO `access_log` VALUES (54252, '65.47.15631686059237597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:30:06', 10, 0, '', '2019-07-15 13:30:06');
INSERT INTO `access_log` VALUES (54253, '65.51.15631686059237669', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:30:06', 11, 0, '', '2019-07-15 13:30:06');
INSERT INTO `access_log` VALUES (54254, '65.54.15631686059237543', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:30:06', 10, 2001001000, '服务端发生异常', '2019-07-15 13:30:06');
INSERT INTO `access_log` VALUES (54255, '65.52.15631686086847645', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:30:09', 17, 0, '', '2019-07-15 13:30:09');
INSERT INTO `access_log` VALUES (54256, '65.49.15631686086887587', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:30:09', 16, 0, '', '2019-07-15 13:30:09');
INSERT INTO `access_log` VALUES (54257, '65.53.15631686086867613', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:30:09', 18, 2001001000, '服务端发生异常', '2019-07-15 13:30:09');
INSERT INTO `access_log` VALUES (54258, '65.46.15631686120837667', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:30:12', 9, 0, '', '2019-07-15 13:30:12');
INSERT INTO `access_log` VALUES (54259, '65.50.15631686120887623', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:30:12', 9, 2001001000, '服务端发生异常', '2019-07-15 13:30:12');
INSERT INTO `access_log` VALUES (54260, '65.3607.15631686120889407', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.37.140.37', '2019-07-15 13:30:12', 10, 0, '', '2019-07-15 13:30:12');
INSERT INTO `access_log` VALUES (54261, '59.80.15631698030325691', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '192.168.25.95', '2019-07-15 13:50:03', 5, 0, '', '2019-07-15 13:50:03');
INSERT INTO `access_log` VALUES (54262, '59.74.15631698030355717', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '192.168.25.95', '2019-07-15 13:50:03', 21, 2001001000, '服务端发生异常', '2019-07-15 13:50:03');
INSERT INTO `access_log` VALUES (54263, '64.80.15631698078905907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '192.168.25.95', '2019-07-15 13:50:08', 12, 0, '', '2019-07-15 13:50:08');
INSERT INTO `access_log` VALUES (54264, '64.83.15631698080365893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '192.168.25.95', '2019-07-15 13:50:08', 3, 0, '', '2019-07-15 13:50:08');
INSERT INTO `access_log` VALUES (54265, '64.85.15631698094835913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '192.168.25.95', '2019-07-15 13:50:09', 2, 0, '', '2019-07-15 13:50:09');
INSERT INTO `access_log` VALUES (54266, '64.77.15631698103085885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '192.168.25.95', '2019-07-15 13:50:10', 2, 0, '', '2019-07-15 13:50:10');
INSERT INTO `access_log` VALUES (54267, '65.51.15631701413817691', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.105.23', '2019-07-15 13:55:41', 5, 1002001012, '访问令牌已过期', '2019-07-15 13:55:41');
INSERT INTO `access_log` VALUES (54268, '65.52.15631701413827667', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.105.23', '2019-07-15 13:55:41', 4, 1002001012, '访问令牌已过期', '2019-07-15 13:55:41');
INSERT INTO `access_log` VALUES (54269, '65.53.15631701414127635', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.105.23', '2019-07-15 13:55:41', 3, 1002001012, '访问令牌已过期', '2019-07-15 13:55:41');
INSERT INTO `access_log` VALUES (54270, '65.49.15631701433717609', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.105.23', '2019-07-15 13:55:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 13:55:43');
INSERT INTO `access_log` VALUES (54271, '65.46.15631701550977689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.105.23', '2019-07-15 13:55:55', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 13:55:55');
INSERT INTO `access_log` VALUES (54272, '65.47.15631712467517635', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '220.197.191.79', '2019-07-15 14:14:07', 1, 1002001015, '账号未登陆', '2019-07-15 14:14:07');
INSERT INTO `access_log` VALUES (54273, '65.54.15631712467517581', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '220.197.191.79', '2019-07-15 14:14:07', 0, 1002001015, '账号未登陆', '2019-07-15 14:14:07');
INSERT INTO `access_log` VALUES (54274, '65.52.15631712467647683', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '220.197.191.79', '2019-07-15 14:14:07', 1, 1002001015, '账号未登陆', '2019-07-15 14:14:07');
INSERT INTO `access_log` VALUES (54275, '65.53.15631712494057651', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '220.197.191.79', '2019-07-15 14:14:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 14:14:09');
INSERT INTO `access_log` VALUES (54276, '65.45.15631712744827631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '220.197.191.79', '2019-07-15 14:14:34', 90, 0, '', '2019-07-15 14:14:35');
INSERT INTO `access_log` VALUES (54277, '65.46.15631712748897705', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '220.197.191.79', '2019-07-15 14:14:35', 18, 0, '', '2019-07-15 14:14:35');
INSERT INTO `access_log` VALUES (54278, '65.3607.15631712749009445', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '220.197.191.79', '2019-07-15 14:14:35', 10, 2001001000, '服务端发生异常', '2019-07-15 14:14:35');
INSERT INTO `access_log` VALUES (54279, '65.50.15631712749237661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '220.197.191.79', '2019-07-15 14:14:35', 10, 0, '', '2019-07-15 14:14:35');
INSERT INTO `access_log` VALUES (54280, '59.76.15631714945715727', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.23.161.107', '2019-07-15 14:18:15', 3, 0, '', '2019-07-15 14:18:15');
INSERT INTO `access_log` VALUES (54281, '59.77.15631714945725723', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.23.161.107', '2019-07-15 14:18:15', 17, 2001001000, '服务端发生异常', '2019-07-15 14:18:15');
INSERT INTO `access_log` VALUES (54282, '64.84.15631714970685915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.23.161.107', '2019-07-15 14:18:17', 2, 0, '', '2019-07-15 14:18:17');
INSERT INTO `access_log` VALUES (54283, '64.82.15631714971725931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.23.161.107', '2019-07-15 14:18:17', 3, 0, '', '2019-07-15 14:18:17');
INSERT INTO `access_log` VALUES (54284, '64.79.15631714985475917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.23.161.107', '2019-07-15 14:18:19', 2, 0, '', '2019-07-15 14:18:19');
INSERT INTO `access_log` VALUES (54285, '64.76.15631714988605915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.23.161.107', '2019-07-15 14:18:19', 2, 0, '', '2019-07-15 14:18:19');
INSERT INTO `access_log` VALUES (54286, '64.80.15631714993135931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.23.161.107', '2019-07-15 14:18:19', 2, 0, '', '2019-07-15 14:18:19');
INSERT INTO `access_log` VALUES (54287, '64.85.15631715025535937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.23.161.107', '2019-07-15 14:18:23', 2, 0, '', '2019-07-15 14:18:23');
INSERT INTO `access_log` VALUES (54288, '59.71.15631715032325735', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.23.161.107', '2019-07-15 14:18:23', 2, 0, '', '2019-07-15 14:18:23');
INSERT INTO `access_log` VALUES (54289, '59.79.15631715032325737', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.23.161.107', '2019-07-15 14:18:23', 13, 2001001000, '服务端发生异常', '2019-07-15 14:18:23');
INSERT INTO `access_log` VALUES (54290, '59.78.15631718562555735', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.49.131.138', '2019-07-15 14:24:16', 3, 0, '', '2019-07-15 14:24:16');
INSERT INTO `access_log` VALUES (54291, '59.75.15631718562575749', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.49.131.138', '2019-07-15 14:24:16', 32, 2001001000, '服务端发生异常', '2019-07-15 14:24:16');
INSERT INTO `access_log` VALUES (54292, '59.77.15631718690375729', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.49.131.138', '2019-07-15 14:24:29', 2, 0, '', '2019-07-15 14:24:29');
INSERT INTO `access_log` VALUES (54293, '59.72.15631718690405737', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.49.131.138', '2019-07-15 14:24:29', 15, 2001001000, '服务端发生异常', '2019-07-15 14:24:29');
INSERT INTO `access_log` VALUES (54294, '64.82.15631718753925937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.49.131.138', '2019-07-15 14:24:35', 2, 0, '', '2019-07-15 14:24:35');
INSERT INTO `access_log` VALUES (54295, '64.76.15631718755185921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.49.131.138', '2019-07-15 14:24:36', 1, 0, '', '2019-07-15 14:24:36');
INSERT INTO `access_log` VALUES (54296, '64.80.15631718767255937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.49.131.138', '2019-07-15 14:24:37', 2, 0, '', '2019-07-15 14:24:37');
INSERT INTO `access_log` VALUES (54297, '64.83.15631718775725923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.49.131.138', '2019-07-15 14:24:38', 1, 0, '', '2019-07-15 14:24:38');
INSERT INTO `access_log` VALUES (54298, '64.85.15631718780835943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.49.131.138', '2019-07-15 14:24:38', 2, 0, '', '2019-07-15 14:24:38');
INSERT INTO `access_log` VALUES (54299, '64.77.15631718783465915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.49.131.138', '2019-07-15 14:24:38', 3, 0, '', '2019-07-15 14:24:38');
INSERT INTO `access_log` VALUES (54300, '59.73.15631723728945751', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:32:53', 3, 0, '', '2019-07-15 14:32:53');
INSERT INTO `access_log` VALUES (54301, '59.78.15631723728955743', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:32:53', 13, 2001001000, '服务端发生异常', '2019-07-15 14:32:53');
INSERT INTO `access_log` VALUES (54302, '64.82.15631723764175945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:32:56', 3, 0, '', '2019-07-15 14:32:56');
INSERT INTO `access_log` VALUES (54303, '64.79.15631723765605931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:32:57', 2, 0, '', '2019-07-15 14:32:57');
INSERT INTO `access_log` VALUES (54304, '64.76.15631723777345929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:32:58', 2, 0, '', '2019-07-15 14:32:58');
INSERT INTO `access_log` VALUES (54305, '64.80.15631723781405945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:32:58', 2, 0, '', '2019-07-15 14:32:58');
INSERT INTO `access_log` VALUES (54306, '64.83.15631723787045931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:32:59', 2, 0, '', '2019-07-15 14:32:59');
INSERT INTO `access_log` VALUES (54307, '64.85.15631723792425951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:32:59', 2, 0, '', '2019-07-15 14:32:59');
INSERT INTO `access_log` VALUES (54308, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:33:00', 14, 0, '', '2019-07-15 14:33:00');
INSERT INTO `access_log` VALUES (54309, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:33:00', 5, 0, '', '2019-07-15 14:33:00');
INSERT INTO `access_log` VALUES (54310, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:33:00', 15, 0, '', '2019-07-15 14:33:00');
INSERT INTO `access_log` VALUES (54311, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:33:00', 10, 0, '', '2019-07-15 14:33:00');
INSERT INTO `access_log` VALUES (54312, '64.77.15631723850985923', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:33:05', 282, 0, '', '2019-07-15 14:33:05');
INSERT INTO `access_log` VALUES (54313, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:33:10', 7, 0, '', '2019-07-15 14:33:10');
INSERT INTO `access_log` VALUES (54314, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:33:10', 12, 0, '', '2019-07-15 14:33:10');
INSERT INTO `access_log` VALUES (54315, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:33:11', 5, 0, '', '2019-07-15 14:33:11');
INSERT INTO `access_log` VALUES (54316, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:33:11', 13, 0, '', '2019-07-15 14:33:11');
INSERT INTO `access_log` VALUES (54317, '64.81.15631723910945919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:33:11', 2, 0, '', '2019-07-15 14:33:11');
INSERT INTO `access_log` VALUES (54318, '64.84.15631723912365931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:33:11', 2, 0, '', '2019-07-15 14:33:11');
INSERT INTO `access_log` VALUES (54319, '59.76.15631723930935741', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:33:13', 2, 0, '', '2019-07-15 14:33:13');
INSERT INTO `access_log` VALUES (54320, '59.72.15631723930945745', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.249.201.130', '2019-07-15 14:33:13', 9, 2001001000, '服务端发生异常', '2019-07-15 14:33:13');
INSERT INTO `access_log` VALUES (54321, '59.75.15631729418165765', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:42:22', 4, 0, '', '2019-07-15 14:42:22');
INSERT INTO `access_log` VALUES (54322, '59.76.15631729418175749', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:42:22', 17, 2001001000, '服务端发生异常', '2019-07-15 14:42:22');
INSERT INTO `access_log` VALUES (54323, '64.78.15631729500265949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:42:30', 3, 0, '', '2019-07-15 14:42:30');
INSERT INTO `access_log` VALUES (54324, '64.81.15631729501505927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:42:30', 2, 0, '', '2019-07-15 14:42:30');
INSERT INTO `access_log` VALUES (54325, '64.84.15631729516105939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:42:32', 2, 0, '', '2019-07-15 14:42:32');
INSERT INTO `access_log` VALUES (54326, '64.82.15631729526735955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:42:33', 1, 0, '', '2019-07-15 14:42:33');
INSERT INTO `access_log` VALUES (54327, '64.79.15631729544425941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:42:34', 3, 0, '', '2019-07-15 14:42:34');
INSERT INTO `access_log` VALUES (54328, '64.76.15631729547745939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:42:35', 2, 0, '', '2019-07-15 14:42:35');
INSERT INTO `access_log` VALUES (54329, '64.80.15631729551135955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:42:35', 2, 0, '', '2019-07-15 14:42:35');
INSERT INTO `access_log` VALUES (54330, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:42:46', 7, 0, '', '2019-07-15 14:42:46');
INSERT INTO `access_log` VALUES (54331, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:42:46', 6, 0, '', '2019-07-15 14:42:46');
INSERT INTO `access_log` VALUES (54332, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:42:46', 13, 0, '', '2019-07-15 14:42:46');
INSERT INTO `access_log` VALUES (54333, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:42:46', 10, 0, '', '2019-07-15 14:42:46');
INSERT INTO `access_log` VALUES (54334, '64.85.15631729692195961', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:42:49', 7, 0, '', '2019-07-15 14:42:49');
INSERT INTO `access_log` VALUES (54335, '66.51.15631729795943719', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:43:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空', '2019-07-15 14:43:00');
INSERT INTO `access_log` VALUES (54336, '65.45.15631729977337655', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:43:18', 0, 1002001015, '账号未登陆', '2019-07-15 14:43:18');
INSERT INTO `access_log` VALUES (54337, '65.49.15631729977337649', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:43:18', 0, 1002001015, '账号未登陆', '2019-07-15 14:43:18');
INSERT INTO `access_log` VALUES (54338, '65.46.15631729977597729', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:43:18', 0, 1002001015, '账号未登陆', '2019-07-15 14:43:18');
INSERT INTO `access_log` VALUES (54339, '65.50.15631730063977685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:43:26', 68, 0, '', '2019-07-15 14:43:26');
INSERT INTO `access_log` VALUES (54340, '65.52.15631730067097709', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:43:27', 163, 0, '', '2019-07-15 14:43:27');
INSERT INTO `access_log` VALUES (54341, '65.54.15631730067117607', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:43:27', 162, 2001001000, '服务端发生异常', '2019-07-15 14:43:27');
INSERT INTO `access_log` VALUES (54342, '65.47.15631730067147661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.17.79.156', '2019-07-15 14:43:27', 168, 0, '', '2019-07-15 14:43:27');
INSERT INTO `access_log` VALUES (54343, '65.49.15631745472147671', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.222.193.95', '2019-07-15 15:09:07', 0, 1002001015, '账号未登陆', '2019-07-15 15:09:07');
INSERT INTO `access_log` VALUES (54344, '65.46.15631745472147751', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.222.193.95', '2019-07-15 15:09:07', 0, 1002001015, '账号未登陆', '2019-07-15 15:09:07');
INSERT INTO `access_log` VALUES (54345, '65.45.15631745472147677', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.222.193.95', '2019-07-15 15:09:07', 0, 1002001015, '账号未登陆', '2019-07-15 15:09:07');
INSERT INTO `access_log` VALUES (54346, '65.50.15631745513277707', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.222.193.95', '2019-07-15 15:09:11', 87, 0, '', '2019-07-15 15:09:11');
INSERT INTO `access_log` VALUES (54347, '65.47.15631745543997683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.222.193.95', '2019-07-15 15:09:14', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 15:09:14');
INSERT INTO `access_log` VALUES (54348, '65.52.15631745591917731', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.222.193.95', '2019-07-15 15:09:19', 100, 0, '', '2019-07-15 15:09:19');
INSERT INTO `access_log` VALUES (54349, '65.51.15631745693477755', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.222.193.95', '2019-07-15 15:09:29', 182, 0, '', '2019-07-15 15:09:30');
INSERT INTO `access_log` VALUES (54350, '65.3607.15631746268959493', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.88.163.180', '2019-07-15 15:10:27', 1, 1002001015, '账号未登陆', '2019-07-15 15:10:27');
INSERT INTO `access_log` VALUES (54351, '65.50.15631746268977709', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.88.163.180', '2019-07-15 15:10:27', 0, 1002001015, '账号未登陆', '2019-07-15 15:10:27');
INSERT INTO `access_log` VALUES (54352, '65.47.15631746269017685', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.88.163.180', '2019-07-15 15:10:27', 0, 1002001015, '账号未登陆', '2019-07-15 15:10:27');
INSERT INTO `access_log` VALUES (54353, '65.52.15631746334057733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.88.163.180', '2019-07-15 15:10:33', 78, 0, '', '2019-07-15 15:10:33');
INSERT INTO `access_log` VALUES (54354, '65.54.15631746337097631', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.88.163.180', '2019-07-15 15:10:34', 10, 0, '', '2019-07-15 15:10:34');
INSERT INTO `access_log` VALUES (54355, '65.53.15631746337117701', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.88.163.180', '2019-07-15 15:10:34', 9, 0, '', '2019-07-15 15:10:34');
INSERT INTO `access_log` VALUES (54356, '65.51.15631746337097757', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.88.163.180', '2019-07-15 15:10:34', 10, 2001001000, '服务端发生异常', '2019-07-15 15:10:34');
INSERT INTO `access_log` VALUES (54357, '65.45.15631776340947721', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:00:34', 1, 1002001015, '账号未登陆', '2019-07-15 16:00:34');
INSERT INTO `access_log` VALUES (54358, '65.46.15631776340937795', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:00:34', 1, 1002001015, '账号未登陆', '2019-07-15 16:00:34');
INSERT INTO `access_log` VALUES (54359, '65.49.15631776341057715', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:00:34', 0, 1002001015, '账号未登陆', '2019-07-15 16:00:34');
INSERT INTO `access_log` VALUES (54360, '65.50.15631776485767751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:00:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 16:00:49');
INSERT INTO `access_log` VALUES (54361, '65.47.15631776534827727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:00:53', 56, 0, '', '2019-07-15 16:00:54');
INSERT INTO `access_log` VALUES (54362, '65.51.15631776538237799', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:00:54', 11, 0, '', '2019-07-15 16:00:54');
INSERT INTO `access_log` VALUES (54363, '65.52.15631776538237775', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:00:54', 19, 2001001000, '服务端发生异常', '2019-07-15 16:00:54');
INSERT INTO `access_log` VALUES (54364, '65.53.15631776538537743', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:00:54', 12, 0, '', '2019-07-15 16:00:54');
INSERT INTO `access_log` VALUES (54365, '65.54.15631781945837681', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:09:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 16:09:55');
INSERT INTO `access_log` VALUES (54366, '65.53.15631782100387751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:10:10', 114, 0, '', '2019-07-15 16:10:10');
INSERT INTO `access_log` VALUES (54367, '65.51.15631782103977807', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:10:10', 10, 0, '', '2019-07-15 16:10:10');
INSERT INTO `access_log` VALUES (54368, '65.45.15631782104057731', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:10:10', 9, 0, '', '2019-07-15 16:10:10');
INSERT INTO `access_log` VALUES (54369, '65.46.15631782104337805', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:10:10', 131, 0, '', '2019-07-15 16:10:11');
INSERT INTO `access_log` VALUES (54370, '64.78.15631782158756021', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:10:16', 36, 0, '', '2019-07-15 16:10:16');
INSERT INTO `access_log` VALUES (54371, '64.77.15631782158756003', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:10:16', 38, 0, '', '2019-07-15 16:10:16');
INSERT INTO `access_log` VALUES (54372, '62.80.15631783098755011', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:11:50', 30, 0, '', '2019-07-15 16:11:50');
INSERT INTO `access_log` VALUES (54373, '59.75.15631783382385837', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:12:18', 487, 0, '', '2019-07-15 16:12:19');
INSERT INTO `access_log` VALUES (54374, '66.48.15631783449723773', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:12:25', 23, 0, '', '2019-07-15 16:12:25');
INSERT INTO `access_log` VALUES (54375, '62.81.15631783532524973', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:12:33', 16, 0, '', '2019-07-15 16:12:33');
INSERT INTO `access_log` VALUES (54376, '65.46.15631783566507807', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:12:37', 26, 0, '', '2019-07-15 16:12:37');
INSERT INTO `access_log` VALUES (54377, '65.3607.15631783637649547', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:12:44', 10, 0, '', '2019-07-15 16:12:44');
INSERT INTO `access_log` VALUES (54378, '65.50.15631783717787763', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:12:52', 24, 0, '', '2019-07-15 16:12:52');
INSERT INTO `access_log` VALUES (54379, '65.54.15631783747587685', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:12:55', 10, 0, '', '2019-07-15 16:12:55');
INSERT INTO `access_log` VALUES (54380, '65.53.15631783970177755', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-15 16:13:17', 21, 0, '', '2019-07-15 16:13:17');
INSERT INTO `access_log` VALUES (54381, '65.49.15631797916897747', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.207.82.170', '2019-07-15 16:36:32', 0, 1002001015, '账号未登陆', '2019-07-15 16:36:32');
INSERT INTO `access_log` VALUES (54382, '65.3607.15631797916909567', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.206.181.53', '2019-07-15 16:36:32', 1, 1002001015, '账号未登陆', '2019-07-15 16:36:32');
INSERT INTO `access_log` VALUES (54383, '65.50.15631797917127783', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.207.82.170', '2019-07-15 16:36:32', 0, 1002001015, '账号未登陆', '2019-07-15 16:36:32');
INSERT INTO `access_log` VALUES (54384, '65.47.15631797953467759', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.206.181.53', '2019-07-15 16:36:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 16:36:35');
INSERT INTO `access_log` VALUES (54385, '65.52.15631798006477807', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.206.181.53', '2019-07-15 16:36:41', 54, 0, '', '2019-07-15 16:36:41');
INSERT INTO `access_log` VALUES (54386, '65.53.15631798009757775', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.206.181.53', '2019-07-15 16:36:41', 9, 0, '', '2019-07-15 16:36:41');
INSERT INTO `access_log` VALUES (54387, '65.51.15631798009897831', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.206.181.53', '2019-07-15 16:36:41', 11, 2001001000, '服务端发生异常', '2019-07-15 16:36:41');
INSERT INTO `access_log` VALUES (54388, '65.45.15631798009957755', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.207.82.170', '2019-07-15 16:36:41', 9, 0, '', '2019-07-15 16:36:41');
INSERT INTO `access_log` VALUES (54389, '65.46.15631798086087829', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.206.181.53', '2019-07-15 16:36:49', 10, 0, '', '2019-07-15 16:36:49');
INSERT INTO `access_log` VALUES (54390, '65.3607.15631798086129569', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.206.181.53', '2019-07-15 16:36:49', 10, 2001001000, '服务端发生异常', '2019-07-15 16:36:49');
INSERT INTO `access_log` VALUES (54391, '65.50.15631798086157785', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.207.82.170', '2019-07-15 16:36:49', 8, 0, '', '2019-07-15 16:36:49');
INSERT INTO `access_log` VALUES (54392, '65.46.15631804679067839', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.88.25.235', '2019-07-15 16:47:48', 4, 1002001012, '访问令牌已过期', '2019-07-15 16:47:48');
INSERT INTO `access_log` VALUES (54393, '65.54.15631804679107717', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.88.25.235', '2019-07-15 16:47:48', 3, 1002001012, '访问令牌已过期', '2019-07-15 16:47:48');
INSERT INTO `access_log` VALUES (54394, '65.49.15631804679157759', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.88.25.235', '2019-07-15 16:47:48', 3, 1002001012, '访问令牌已过期', '2019-07-15 16:47:48');
INSERT INTO `access_log` VALUES (54395, '65.52.15631804715787819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.88.25.235', '2019-07-15 16:47:52', 83, 0, '', '2019-07-15 16:47:52');
INSERT INTO `access_log` VALUES (54396, '65.51.15631804719067843', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.88.25.235', '2019-07-15 16:47:52', 134, 0, '', '2019-07-15 16:47:52');
INSERT INTO `access_log` VALUES (54397, '65.53.15631804719127787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.88.25.235', '2019-07-15 16:47:52', 130, 0, '', '2019-07-15 16:47:52');
INSERT INTO `access_log` VALUES (54398, '65.50.15631804719087795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.88.25.235', '2019-07-15 16:47:52', 133, 2001001000, '服务端发生异常', '2019-07-15 16:47:52');
INSERT INTO `access_log` VALUES (54399, '59.77.15631805894145847', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.240.69', '2019-07-15 16:49:49', 10, 0, '', '2019-07-15 16:49:49');
INSERT INTO `access_log` VALUES (54400, '59.71.15631805894165859', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.206.181.53', '2019-07-15 16:49:49', 17, 2001001000, '服务端发生异常', '2019-07-15 16:49:49');
INSERT INTO `access_log` VALUES (54401, '64.77.15631806035236035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.240.69', '2019-07-15 16:50:04', 10, 0, '', '2019-07-15 16:50:04');
INSERT INTO `access_log` VALUES (54402, '64.81.15631806036536031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.240.69', '2019-07-15 16:50:04', 3, 0, '', '2019-07-15 16:50:04');
INSERT INTO `access_log` VALUES (54403, '64.82.15631806055856059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.240.69', '2019-07-15 16:50:06', 2, 0, '', '2019-07-15 16:50:06');
INSERT INTO `access_log` VALUES (54404, '64.79.15631806060646045', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.240.69', '2019-07-15 16:50:06', 2, 0, '', '2019-07-15 16:50:06');
INSERT INTO `access_log` VALUES (54405, '65.47.15631806134457773', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.240.69', '2019-07-15 16:50:13', 1, 1002001015, '账号未登陆', '2019-07-15 16:50:13');
INSERT INTO `access_log` VALUES (54406, '65.45.15631806134607767', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.207.82.170', '2019-07-15 16:50:13', 0, 1002001015, '账号未登陆', '2019-07-15 16:50:13');
INSERT INTO `access_log` VALUES (54407, '65.3607.15631806134649581', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.206.181.53', '2019-07-15 16:50:13', 1, 1002001015, '账号未登陆', '2019-07-15 16:50:13');
INSERT INTO `access_log` VALUES (54408, '65.54.15631806280527721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.207.82.170', '2019-07-15 16:50:28', 60, 0, '', '2019-07-15 16:50:28');
INSERT INTO `access_log` VALUES (54409, '65.46.15631806285087843', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.206.181.53', '2019-07-15 16:50:29', 11, 0, '', '2019-07-15 16:50:29');
INSERT INTO `access_log` VALUES (54410, '65.52.15631806285147823', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.207.82.170', '2019-07-15 16:50:29', 10, 2001001000, '服务端发生异常', '2019-07-15 16:50:29');
INSERT INTO `access_log` VALUES (54411, '65.53.15631806285237791', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.207.82.170', '2019-07-15 16:50:29', 8, 0, '', '2019-07-15 16:50:29');
INSERT INTO `access_log` VALUES (54412, '65.45.15631806549897769', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.240.69', '2019-07-15 16:50:55', 9, 0, '', '2019-07-15 16:50:55');
INSERT INTO `access_log` VALUES (54413, '65.3607.15631806550049583', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.240.69', '2019-07-15 16:50:55', 10, 0, '', '2019-07-15 16:50:55');
INSERT INTO `access_log` VALUES (54414, '65.47.15631806550047775', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.207.82.170', '2019-07-15 16:50:55', 9, 2001001000, '服务端发生异常', '2019-07-15 16:50:55');
INSERT INTO `access_log` VALUES (54415, '65.49.15631806630947765', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.207.82.170', '2019-07-15 16:51:03', 10, 0, '', '2019-07-15 16:51:03');
INSERT INTO `access_log` VALUES (54416, '65.54.15631806631017723', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.240.69', '2019-07-15 16:51:03', 9, 2001001000, '服务端发生异常', '2019-07-15 16:51:03');
INSERT INTO `access_log` VALUES (54417, '65.46.15631806631187845', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.207.82.170', '2019-07-15 16:51:03', 9, 0, '', '2019-07-15 16:51:03');
INSERT INTO `access_log` VALUES (54418, '65.51.15631806893697849', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.207.82.170', '2019-07-15 16:51:29', 9, 0, '', '2019-07-15 16:51:29');
INSERT INTO `access_log` VALUES (54419, '65.50.15631806893967801', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.169.240.69', '2019-07-15 16:51:29', 10, 2001001000, '服务端发生异常', '2019-07-15 16:51:29');
INSERT INTO `access_log` VALUES (54420, '65.45.15631806894047771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '140.206.181.53', '2019-07-15 16:51:29', 8, 0, '', '2019-07-15 16:51:29');
INSERT INTO `access_log` VALUES (54421, '59.77.15631816111275861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.91.148.203', '2019-07-15 17:06:51', 3, 0, '', '2019-07-15 17:06:51');
INSERT INTO `access_log` VALUES (54422, '59.71.15631816111285873', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.91.148.203', '2019-07-15 17:06:51', 11, 2001001000, '服务端发生异常', '2019-07-15 17:06:51');
INSERT INTO `access_log` VALUES (54423, '65.49.15631816503177779', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.91.148.203', '2019-07-15 17:07:30', 1, 1002001015, '账号未登陆', '2019-07-15 17:07:30');
INSERT INTO `access_log` VALUES (54424, '65.53.15631816503177807', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.91.148.203', '2019-07-15 17:07:30', 1, 1002001015, '账号未登陆', '2019-07-15 17:07:30');
INSERT INTO `access_log` VALUES (54425, '65.52.15631816503217839', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.91.148.203', '2019-07-15 17:07:30', 1, 1002001015, '账号未登陆', '2019-07-15 17:07:30');
INSERT INTO `access_log` VALUES (54426, '65.51.15631816525017863', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.91.148.203', '2019-07-15 17:07:33', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 17:07:33');
INSERT INTO `access_log` VALUES (54427, '65.45.15631816547937785', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.91.148.203', '2019-07-15 17:07:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 17:07:35');
INSERT INTO `access_log` VALUES (54428, '65.53.15631817345747809', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.91.148.203', '2019-07-15 17:08:55', 55, 0, '', '2019-07-15 17:08:55');
INSERT INTO `access_log` VALUES (54429, '65.52.15631817352297841', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.91.148.203', '2019-07-15 17:08:55', 10, 0, '', '2019-07-15 17:08:55');
INSERT INTO `access_log` VALUES (54430, '65.51.15631817352347865', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.91.148.203', '2019-07-15 17:08:55', 9, 2001001000, '服务端发生异常', '2019-07-15 17:08:55');
INSERT INTO `access_log` VALUES (54431, '65.45.15631817352387787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.91.148.203', '2019-07-15 17:08:55', 8, 0, '', '2019-07-15 17:08:55');
INSERT INTO `access_log` VALUES (54432, '65.51.15631842825177899', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.170.139.166', '2019-07-15 17:51:23', 16, 1002001012, '访问令牌已过期', '2019-07-15 17:51:23');
INSERT INTO `access_log` VALUES (54433, '65.3607.15631842825189635', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.170.139.166', '2019-07-15 17:51:23', 19, 1002001012, '访问令牌已过期', '2019-07-15 17:51:23');
INSERT INTO `access_log` VALUES (54434, '65.50.15631842825187851', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.170.139.166', '2019-07-15 17:51:23', 20, 1002001012, '访问令牌已过期', '2019-07-15 17:51:23');
INSERT INTO `access_log` VALUES (54435, '65.46.15631842840747897', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.170.139.166', '2019-07-15 17:51:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 17:51:24');
INSERT INTO `access_log` VALUES (54436, '65.49.15631843011717817', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.170.139.166', '2019-07-15 17:51:41', 72, 0, '', '2019-07-15 17:51:41');
INSERT INTO `access_log` VALUES (54437, '65.53.15631843014227845', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.170.139.166', '2019-07-15 17:51:41', 11, 0, '', '2019-07-15 17:51:41');
INSERT INTO `access_log` VALUES (54438, '65.52.15631843014237877', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.170.139.166', '2019-07-15 17:51:41', 9, 0, '', '2019-07-15 17:51:41');
INSERT INTO `access_log` VALUES (54439, '65.45.15631843014237823', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.170.139.166', '2019-07-15 17:51:41', 13, 2001001000, '服务端发生异常', '2019-07-15 17:51:41');
INSERT INTO `access_log` VALUES (54440, '65.51.15631843136587901', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.170.139.166', '2019-07-15 17:51:54', 16, 0, '', '2019-07-15 17:51:54');
INSERT INTO `access_log` VALUES (54441, '65.3607.15631843136599637', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.170.139.166', '2019-07-15 17:51:54', 16, 2001001000, '服务端发生异常', '2019-07-15 17:51:54');
INSERT INTO `access_log` VALUES (54442, '65.50.15631843136607853', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.170.139.166', '2019-07-15 17:51:54', 16, 0, '', '2019-07-15 17:51:54');
INSERT INTO `access_log` VALUES (54443, '65.54.15631856909867795', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 18:14:51', 5, 1002001012, '访问令牌已过期', '2019-07-15 18:14:51');
INSERT INTO `access_log` VALUES (54444, '65.49.15631856909867837', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 18:14:51', 5, 1002001012, '访问令牌已过期', '2019-07-15 18:14:51');
INSERT INTO `access_log` VALUES (54445, '65.45.15631856909877843', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 18:14:51', 4, 1002001012, '访问令牌已过期', '2019-07-15 18:14:51');
INSERT INTO `access_log` VALUES (54446, '65.53.15631856926797865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 18:14:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 18:14:53');
INSERT INTO `access_log` VALUES (54447, '65.51.15631856967177921', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 18:14:57', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 18:14:57');
INSERT INTO `access_log` VALUES (54448, '65.3607.15631857075929657', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 18:15:08', 174, 0, '', '2019-07-15 18:15:08');
INSERT INTO `access_log` VALUES (54449, '65.50.15631857079507873', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 18:15:08', 10, 0, '', '2019-07-15 18:15:08');
INSERT INTO `access_log` VALUES (54450, '65.47.15631857079537849', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 18:15:08', 10, 2001001000, '服务端发生异常', '2019-07-15 18:15:08');
INSERT INTO `access_log` VALUES (54451, '65.46.15631857079547919', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-15 18:15:08', 9, 0, '', '2019-07-15 18:15:08');
INSERT INTO `access_log` VALUES (54452, '65.51.15631865015287933', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.5.105', '2019-07-15 18:28:22', 1, 1002001015, '账号未登陆', '2019-07-15 18:28:22');
INSERT INTO `access_log` VALUES (54453, '65.52.15631865015287909', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.5.105', '2019-07-15 18:28:22', 1, 1002001015, '账号未登陆', '2019-07-15 18:28:22');
INSERT INTO `access_log` VALUES (54454, '65.53.15631865015277877', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.5.105', '2019-07-15 18:28:22', 0, 1002001015, '账号未登陆', '2019-07-15 18:28:22');
INSERT INTO `access_log` VALUES (54455, '65.50.15631865143707885', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.5.105', '2019-07-15 18:28:34', 65, 0, '', '2019-07-15 18:28:34');
INSERT INTO `access_log` VALUES (54456, '65.46.15631865148687931', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.5.105', '2019-07-15 18:28:35', 340, 2001001000, '服务端发生异常', '2019-07-15 18:28:35');
INSERT INTO `access_log` VALUES (54457, '65.47.15631865148687861', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.5.105', '2019-07-15 18:28:35', 341, 0, '', '2019-07-15 18:28:35');
INSERT INTO `access_log` VALUES (54458, '65.54.15631865148687809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.121.5.105', '2019-07-15 18:28:35', 340, 0, '', '2019-07-15 18:28:35');
INSERT INTO `access_log` VALUES (54459, '59.71.15631867081735941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:31:48', 10, 0, '', '2019-07-15 18:31:48');
INSERT INTO `access_log` VALUES (54460, '59.79.15631867081845943', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:31:48', 13, 2001001000, '服务端发生异常', '2019-07-15 18:31:48');
INSERT INTO `access_log` VALUES (54461, '59.73.15631867116535945', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:31:52', 3, 0, '', '2019-07-15 18:31:52');
INSERT INTO `access_log` VALUES (54462, '59.80.15631867116505921', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:31:52', 45, 2001001000, '服务端发生异常', '2019-07-15 18:31:52');
INSERT INTO `access_log` VALUES (54463, '64.76.15631867608476125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:32:41', 12, 0, '', '2019-07-15 18:32:41');
INSERT INTO `access_log` VALUES (54464, '64.80.15631867609756141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:32:41', 5, 0, '', '2019-07-15 18:32:41');
INSERT INTO `access_log` VALUES (54465, '64.83.15631867621866127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:32:42', 3, 0, '', '2019-07-15 18:32:42');
INSERT INTO `access_log` VALUES (54466, '64.85.15631867627866147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:32:43', 2, 0, '', '2019-07-15 18:32:43');
INSERT INTO `access_log` VALUES (54467, '65.47.15631867628017865', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:32:43', 0, 1002001015, '账号未登陆', '2019-07-15 18:32:43');
INSERT INTO `access_log` VALUES (54468, '65.54.15631867628027813', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:32:43', 0, 1002001015, '账号未登陆', '2019-07-15 18:32:43');
INSERT INTO `access_log` VALUES (54469, '65.46.15631867628027935', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:32:43', 1, 1002001015, '账号未登陆', '2019-07-15 18:32:43');
INSERT INTO `access_log` VALUES (54470, '64.78.15631867632816137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:32:43', 2, 0, '', '2019-07-15 18:32:43');
INSERT INTO `access_log` VALUES (54471, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:32:45', 7, 0, '', '2019-07-15 18:32:45');
INSERT INTO `access_log` VALUES (54472, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:32:45', 6, 0, '', '2019-07-15 18:32:45');
INSERT INTO `access_log` VALUES (54473, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:32:45', 13, 0, '', '2019-07-15 18:32:45');
INSERT INTO `access_log` VALUES (54474, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:32:45', 10, 0, '', '2019-07-15 18:32:45');
INSERT INTO `access_log` VALUES (54475, '64.77.15631867662946119', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:32:46', 7, 0, '', '2019-07-15 18:32:46');
INSERT INTO `access_log` VALUES (54476, '65.49.15631867823427855', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:33:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 18:33:02');
INSERT INTO `access_log` VALUES (54477, '65.51.15631867988347939', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:33:19', 5, 1002002000, '账号不存在', '2019-07-15 18:33:19');
INSERT INTO `access_log` VALUES (54478, '65.3607.15631868072679675', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma &password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:33:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号格式为数字以及字母', '2019-07-15 18:33:27');
INSERT INTO `access_log` VALUES (54479, '65.47.15631868226067867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma &password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.216.180', '2019-07-15 18:33:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号格式为数字以及字母', '2019-07-15 18:33:43');
INSERT INTO `access_log` VALUES (54480, '65.50.15631878394797905', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.70.0.154', '2019-07-15 18:50:39', 0, 1002001015, '账号未登陆', '2019-07-15 18:50:39');
INSERT INTO `access_log` VALUES (54481, '65.47.15631878394807881', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.70.0.154', '2019-07-15 18:50:39', 0, 1002001015, '账号未登陆', '2019-07-15 18:50:39');
INSERT INTO `access_log` VALUES (54482, '65.46.15631878394837951', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.70.0.154', '2019-07-15 18:50:39', 0, 1002001015, '账号未登陆', '2019-07-15 18:50:39');
INSERT INTO `access_log` VALUES (54483, '65.54.15631878498147829', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.70.0.154', '2019-07-15 18:50:50', 92, 0, '', '2019-07-15 18:50:50');
INSERT INTO `access_log` VALUES (54484, '65.45.15631878502377877', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.70.0.154', '2019-07-15 18:50:50', 125, 0, '', '2019-07-15 18:50:50');
INSERT INTO `access_log` VALUES (54485, '65.53.15631878502557899', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.70.0.154', '2019-07-15 18:50:50', 109, 0, '', '2019-07-15 18:50:50');
INSERT INTO `access_log` VALUES (54486, '65.49.15631878502557871', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.70.0.154', '2019-07-15 18:50:50', 110, 2001001000, '服务端发生异常', '2019-07-15 18:50:50');
INSERT INTO `access_log` VALUES (54487, '59.78.15631879123545953', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.70.0.154', '2019-07-15 18:51:52', 3, 0, '', '2019-07-15 18:51:52');
INSERT INTO `access_log` VALUES (54488, '59.76.15631879123565951', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.70.0.154', '2019-07-15 18:51:52', 14, 2001001000, '服务端发生异常', '2019-07-15 18:51:52');
INSERT INTO `access_log` VALUES (54489, '65.45.15631879224037879', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.70.0.154', '2019-07-15 18:52:02', 10, 0, '', '2019-07-15 18:52:02');
INSERT INTO `access_log` VALUES (54490, '65.47.15631879224027883', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.70.0.154', '2019-07-15 18:52:02', 11, 0, '', '2019-07-15 18:52:02');
INSERT INTO `access_log` VALUES (54491, '65.54.15631879224027831', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.70.0.154', '2019-07-15 18:52:02', 13, 2001001000, '服务端发生异常', '2019-07-15 18:52:02');
INSERT INTO `access_log` VALUES (54492, '65.47.15631914707547931', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:11', 0, 1002001015, '账号未登陆', '2019-07-15 19:51:11');
INSERT INTO `access_log` VALUES (54493, '65.45.15631914707557927', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:11', 1, 1002001015, '账号未登陆', '2019-07-15 19:51:11');
INSERT INTO `access_log` VALUES (54494, '65.54.15631914707567879', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:11', 0, 1002001015, '账号未登陆', '2019-07-15 19:51:11');
INSERT INTO `access_log` VALUES (54495, '65.53.15631914726507949', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 19:51:13');
INSERT INTO `access_log` VALUES (54496, '65.49.15631914806607921', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 19:51:21');
INSERT INTO `access_log` VALUES (54497, '65.52.15631914848527981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:25', 73, 0, '', '2019-07-15 19:51:25');
INSERT INTO `access_log` VALUES (54498, '65.3607.15631914852079741', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:25', 11, 0, '', '2019-07-15 19:51:25');
INSERT INTO `access_log` VALUES (54499, '65.50.15631914852427957', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:25', 11, 0, '', '2019-07-15 19:51:25');
INSERT INTO `access_log` VALUES (54500, '65.46.15631914852428003', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:25', 11, 0, '', '2019-07-15 19:51:25');
INSERT INTO `access_log` VALUES (54501, '62.80.15631914908625189', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:31', 22, 0, '', '2019-07-15 19:51:31');
INSERT INTO `access_log` VALUES (54502, '62.87.15631914963735173', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:36', 82, 0, '', '2019-07-15 19:51:36');
INSERT INTO `access_log` VALUES (54503, '64.85.15631914987626211', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:39', 30, 0, '', '2019-07-15 19:51:39');
INSERT INTO `access_log` VALUES (54504, '64.83.15631914987626191', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:39', 35, 0, '', '2019-07-15 19:51:39');
INSERT INTO `access_log` VALUES (54505, '64.77.15631915037536183', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:44', 25, 0, '', '2019-07-15 19:51:44');
INSERT INTO `access_log` VALUES (54506, '64.78.15631915037536201', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:44', 32, 0, '', '2019-07-15 19:51:44');
INSERT INTO `access_log` VALUES (54507, '64.84.15631915187286191', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:51:59', 11, 0, '', '2019-07-15 19:51:59');
INSERT INTO `access_log` VALUES (54508, '65.52.15631915797947983', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:53:00', 19, 0, '', '2019-07-15 19:53:00');
INSERT INTO `access_log` VALUES (54509, '65.50.15631915821867959', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:53:02', 10, 0, '', '2019-07-15 19:53:02');
INSERT INTO `access_log` VALUES (54510, '65.46.15631915847058005', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:53:05', 9, 0, '', '2019-07-15 19:53:05');
INSERT INTO `access_log` VALUES (54511, '65.47.15631916034837935', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.15.114', '2019-07-15 19:53:23', 15, 0, '', '2019-07-15 19:53:23');
INSERT INTO `access_log` VALUES (54512, '65.47.15631939570477967', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '171.212.185.220', '2019-07-15 20:32:37', 0, 1002001015, '账号未登陆', '2019-07-15 20:32:37');
INSERT INTO `access_log` VALUES (54513, '65.46.15631939570478037', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '171.212.185.220', '2019-07-15 20:32:37', 1, 1002001015, '账号未登陆', '2019-07-15 20:32:37');
INSERT INTO `access_log` VALUES (54514, '65.3607.15631939570479775', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '171.212.185.220', '2019-07-15 20:32:37', 1, 1002001015, '账号未登陆', '2019-07-15 20:32:37');
INSERT INTO `access_log` VALUES (54515, '65.54.15631939595377915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '171.212.185.220', '2019-07-15 20:32:40', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 20:32:40');
INSERT INTO `access_log` VALUES (54516, '65.53.15631939635347985', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '171.212.185.220', '2019-07-15 20:32:44', 95, 0, '', '2019-07-15 20:32:44');
INSERT INTO `access_log` VALUES (54517, '65.49.15631939638807957', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '171.212.185.220', '2019-07-15 20:32:44', 11, 0, '', '2019-07-15 20:32:44');
INSERT INTO `access_log` VALUES (54518, '65.51.15631939638828041', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '171.212.185.220', '2019-07-15 20:32:44', 11, 2001001000, '服务端发生异常', '2019-07-15 20:32:44');
INSERT INTO `access_log` VALUES (54519, '65.52.15631939638858017', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '171.212.185.220', '2019-07-15 20:32:44', 10, 0, '', '2019-07-15 20:32:44');
INSERT INTO `access_log` VALUES (54520, '65.47.15631950665157983', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.45.197', '2019-07-15 20:51:07', 1, 1002001015, '账号未登陆', '2019-07-15 20:51:07');
INSERT INTO `access_log` VALUES (54521, '65.54.15631950665167931', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.45.197', '2019-07-15 20:51:07', 0, 1002001015, '账号未登陆', '2019-07-15 20:51:07');
INSERT INTO `access_log` VALUES (54522, '65.45.15631950665167979', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.45.197', '2019-07-15 20:51:07', 0, 1002001015, '账号未登陆', '2019-07-15 20:51:07');
INSERT INTO `access_log` VALUES (54523, '65.49.15631950693297973', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.45.197', '2019-07-15 20:51:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 20:51:09');
INSERT INTO `access_log` VALUES (54524, '65.52.15631950872988033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuma&password=yudaoyuma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.45.197', '2019-07-15 20:51:27', 4, 1002002000, '账号不存在', '2019-07-15 20:51:27');
INSERT INTO `access_log` VALUES (54525, '65.3607.15631951025779793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.45.197', '2019-07-15 20:51:43', 84, 0, '', '2019-07-15 20:51:43');
INSERT INTO `access_log` VALUES (54526, '65.46.15631951031188055', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.45.197', '2019-07-15 20:51:43', 10, 0, '', '2019-07-15 20:51:43');
INSERT INTO `access_log` VALUES (54527, '65.45.15631951031327981', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.45.197', '2019-07-15 20:51:43', 13, 2001001000, '服务端发生异常', '2019-07-15 20:51:43');
INSERT INTO `access_log` VALUES (54528, '65.54.15631951031367933', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.45.197', '2019-07-15 20:51:43', 13, 0, '', '2019-07-15 20:51:43');
INSERT INTO `access_log` VALUES (54529, '65.3607.15631965462679813', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.136.21.100', '2019-07-15 21:15:46', 0, 1002001015, '账号未登陆', '2019-07-15 21:15:46');
INSERT INTO `access_log` VALUES (54530, '65.46.15631965462678075', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.149', '2019-07-15 21:15:46', 0, 1002001015, '账号未登陆', '2019-07-15 21:15:46');
INSERT INTO `access_log` VALUES (54531, '65.54.15631965465127953', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.170.50.52', '2019-07-15 21:15:47', 1, 1002001015, '账号未登陆', '2019-07-15 21:15:47');
INSERT INTO `access_log` VALUES (54532, '65.45.15631965487198001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.136.21.100', '2019-07-15 21:15:49', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 21:15:49');
INSERT INTO `access_log` VALUES (54533, '65.47.15631965527348005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.136.21.100', '2019-07-15 21:15:53', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 21:15:53');
INSERT INTO `access_log` VALUES (54534, '65.49.15631965678217995', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.39.216.124', '2019-07-15 21:16:08', 115, 0, '', '2019-07-15 21:16:08');
INSERT INTO `access_log` VALUES (54535, '65.51.15631965683758079', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '119.39.216.124', '2019-07-15 21:16:08', 10, 0, '', '2019-07-15 21:16:08');
INSERT INTO `access_log` VALUES (54536, '65.52.15631965683798055', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.206.149', '2019-07-15 21:16:08', 10, 0, '', '2019-07-15 21:16:08');
INSERT INTO `access_log` VALUES (54537, '65.50.15631965683848031', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.136.21.100', '2019-07-15 21:16:08', 11, 2001001000, '服务端发生异常', '2019-07-15 21:16:08');
INSERT INTO `access_log` VALUES (54538, '65.45.15631966034418003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.10.17.243', '2019-07-15 21:16:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 21:16:43');
INSERT INTO `access_log` VALUES (54539, '65.53.15631966183798025', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '183.192.164.85', '2019-07-15 21:16:58', 0, 1002001015, '账号未登陆', '2019-07-15 21:16:58');
INSERT INTO `access_log` VALUES (54540, '65.49.15631966183797997', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '183.192.164.85', '2019-07-15 21:16:58', 0, 1002001015, '账号未登陆', '2019-07-15 21:16:58');
INSERT INTO `access_log` VALUES (54541, '65.52.15631966218508057', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '183.192.164.56', '2019-07-15 21:17:02', 1, 1002001015, '账号未登陆', '2019-07-15 21:17:02');
INSERT INTO `access_log` VALUES (54542, '65.54.15631969743777961', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.153.95.68', '2019-07-15 21:22:54', 0, 1002001015, '账号未登陆', '2019-07-15 21:22:54');
INSERT INTO `access_log` VALUES (54543, '65.45.15631969743818009', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.153.95.68', '2019-07-15 21:22:54', 0, 1002001015, '账号未登陆', '2019-07-15 21:22:54');
INSERT INTO `access_log` VALUES (54544, '65.47.15631969744198013', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.153.95.71', '2019-07-15 21:22:54', 0, 1002001015, '账号未登陆', '2019-07-15 21:22:54');
INSERT INTO `access_log` VALUES (54545, '65.49.15631969766488003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.6.17', '2019-07-15 21:22:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 21:22:57');
INSERT INTO `access_log` VALUES (54546, '65.53.15631969792508031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.102.6.17', '2019-07-15 21:22:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 21:22:59');
INSERT INTO `access_log` VALUES (54547, '65.46.15632009119878137', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.14.139.226', '2019-07-15 22:28:32', 1, 1002001015, '账号未登陆', '2019-07-15 22:28:32');
INSERT INTO `access_log` VALUES (54548, '65.51.15632009119878139', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.14.139.226', '2019-07-15 22:28:32', 1, 1002001015, '账号未登陆', '2019-07-15 22:28:32');
INSERT INTO `access_log` VALUES (54549, '65.3607.15632009119899875', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.14.139.226', '2019-07-15 22:28:32', 1, 1002001015, '账号未登陆', '2019-07-15 22:28:32');
INSERT INTO `access_log` VALUES (54550, '65.45.15632009140318063', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.14.139.226', '2019-07-15 22:28:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 22:28:34');
INSERT INTO `access_log` VALUES (54551, '65.54.15632009194878015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.14.139.226', '2019-07-15 22:28:39', 108, 0, '', '2019-07-15 22:28:40');
INSERT INTO `access_log` VALUES (54552, '65.53.15632009199338085', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.14.139.226', '2019-07-15 22:28:40', 12, 0, '', '2019-07-15 22:28:40');
INSERT INTO `access_log` VALUES (54553, '65.52.15632009199338117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.14.139.226', '2019-07-15 22:28:40', 11, 0, '', '2019-07-15 22:28:40');
INSERT INTO `access_log` VALUES (54554, '65.49.15632009199318057', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.14.139.226', '2019-07-15 22:28:40', 14, 2001001000, '服务端发生异常', '2019-07-15 22:28:40');
INSERT INTO `access_log` VALUES (54555, '65.46.15632009380158139', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.14.139.226', '2019-07-15 22:28:58', 12, 2001001000, '服务端发生异常', '2019-07-15 22:28:58');
INSERT INTO `access_log` VALUES (54556, '65.3607.15632009380209877', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.14.139.226', '2019-07-15 22:28:58', 10, 0, '', '2019-07-15 22:28:58');
INSERT INTO `access_log` VALUES (54557, '65.51.15632009380228141', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.14.139.226', '2019-07-15 22:28:58', 9, 0, '', '2019-07-15 22:28:58');
INSERT INTO `access_log` VALUES (54558, '65.45.15632009481398065', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.14.139.226', '2019-07-15 22:29:08', 9, 0, '', '2019-07-15 22:29:08');
INSERT INTO `access_log` VALUES (54559, '65.47.15632009481418069', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.14.139.226', '2019-07-15 22:29:08', 8, 2001001000, '服务端发生异常', '2019-07-15 22:29:08');
INSERT INTO `access_log` VALUES (54560, '65.54.15632009481478017', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.14.139.226', '2019-07-15 22:29:08', 8, 0, '', '2019-07-15 22:29:08');
INSERT INTO `access_log` VALUES (54561, '65.3607.15632032616579911', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:07:42', 1, 1002001015, '账号未登陆', '2019-07-15 23:07:42');
INSERT INTO `access_log` VALUES (54562, '65.51.15632032616708173', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:07:42', 0, 1002001015, '账号未登陆', '2019-07-15 23:07:42');
INSERT INTO `access_log` VALUES (54563, '65.49.15632032616578091', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:07:42', 0, 1002001015, '账号未登陆', '2019-07-15 23:07:42');
INSERT INTO `access_log` VALUES (54564, '65.47.15632032649458103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:07:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 23:07:45');
INSERT INTO `access_log` VALUES (54565, '65.45.15632032743238099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:07:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 23:07:54');
INSERT INTO `access_log` VALUES (54566, '65.52.15632032783758151', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:07:58', 60, 0, '', '2019-07-15 23:07:58');
INSERT INTO `access_log` VALUES (54567, '65.54.15632032786678049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:07:59', 17, 0, '', '2019-07-15 23:07:59');
INSERT INTO `access_log` VALUES (54568, '65.46.15632032786728173', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:07:59', 19, 2001001000, '服务端发生异常', '2019-07-15 23:07:59');
INSERT INTO `access_log` VALUES (54569, '65.53.15632032786768121', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:07:59', 8, 0, '', '2019-07-15 23:07:59');
INSERT INTO `access_log` VALUES (54570, '65.3607.15632033012739913', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:08:21', 11, 0, '', '2019-07-15 23:08:21');
INSERT INTO `access_log` VALUES (54571, '65.47.15632033012748105', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:08:21', 11, 0, '', '2019-07-15 23:08:21');
INSERT INTO `access_log` VALUES (54572, '65.49.15632033012748093', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:08:21', 12, 2001001000, '服务端发生异常', '2019-07-15 23:08:21');
INSERT INTO `access_log` VALUES (54573, '65.45.15632033072848101', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:08:27', 9, 0, '', '2019-07-15 23:08:27');
INSERT INTO `access_log` VALUES (54574, '65.52.15632033072878153', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:08:27', 9, 0, '', '2019-07-15 23:08:27');
INSERT INTO `access_log` VALUES (54575, '65.46.15632033072888175', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:08:27', 10, 2001001000, '服务端发生异常', '2019-07-15 23:08:27');
INSERT INTO `access_log` VALUES (54576, '65.53.15632033118988123', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:08:32', 8, 0, '', '2019-07-15 23:08:32');
INSERT INTO `access_log` VALUES (54577, '65.54.15632033118988051', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:08:32', 9, 0, '', '2019-07-15 23:08:32');
INSERT INTO `access_log` VALUES (54578, '65.51.15632033118998177', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:08:32', 10, 2001001000, '服务端发生异常', '2019-07-15 23:08:32');
INSERT INTO `access_log` VALUES (54579, '65.3607.15632033160889915', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:08:36', 9, 0, '', '2019-07-15 23:08:36');
INSERT INTO `access_log` VALUES (54580, '65.47.15632033160928107', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:08:36', 9, 2001001000, '服务端发生异常', '2019-07-15 23:08:36');
INSERT INTO `access_log` VALUES (54581, '65.49.15632033160968095', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:08:36', 9, 0, '', '2019-07-15 23:08:36');
INSERT INTO `access_log` VALUES (54582, '65.50.15632034615148133', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:11:02', 9, 0, '', '2019-07-15 23:11:02');
INSERT INTO `access_log` VALUES (54583, '65.52.15632034615368157', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:11:02', 17, 0, '', '2019-07-15 23:11:02');
INSERT INTO `access_log` VALUES (54584, '65.45.15632034615368105', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:11:02', 16, 2001001000, '服务端发生异常', '2019-07-15 23:11:02');
INSERT INTO `access_log` VALUES (54585, '65.46.15632034686188179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:11:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 23:11:09');
INSERT INTO `access_log` VALUES (54586, '65.54.15632034745458055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:11:15', 5, 1002002001, '密码不正确', '2019-07-15 23:11:15');
INSERT INTO `access_log` VALUES (54587, '65.51.15632034789988181', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=test&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:11:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 23:11:19');
INSERT INTO `access_log` VALUES (54588, '65.3607.15632034839839919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=zxcvbnm&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:11:24', 91, 0, '', '2019-07-15 23:11:24');
INSERT INTO `access_log` VALUES (54589, '65.49.15632034842408099', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:11:24', 10, 0, '', '2019-07-15 23:11:24');
INSERT INTO `access_log` VALUES (54590, '65.50.15632034842808135', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:11:24', 10, 0, '', '2019-07-15 23:11:24');
INSERT INTO `access_log` VALUES (54591, '65.45.15632034842838107', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:11:24', 9, 0, '', '2019-07-15 23:11:24');
INSERT INTO `access_log` VALUES (54592, '62.83.15632035035545361', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:11:44', 26, 0, '', '2019-07-15 23:11:44');
INSERT INTO `access_log` VALUES (54593, '62.86.15632035121635325', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:11:52', 26, 0, '', '2019-07-15 23:11:52');
INSERT INTO `access_log` VALUES (54594, '64.79.15632035152706353', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:11:55', 19, 0, '', '2019-07-15 23:11:55');
INSERT INTO `access_log` VALUES (54595, '64.82.15632035152616367', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:11:55', 31, 0, '', '2019-07-15 23:11:55');
INSERT INTO `access_log` VALUES (54596, '64.80.15632035225746367', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:12:03', 13, 0, '', '2019-07-15 23:12:03');
INSERT INTO `access_log` VALUES (54597, '64.76.15632035225746351', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:12:03', 15, 0, '', '2019-07-15 23:12:03');
INSERT INTO `access_log` VALUES (54598, '65.51.15632035495008183', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:12:30', 3, 0, '', '2019-07-15 23:12:30');
INSERT INTO `access_log` VALUES (54599, '64.81.15632035629846341', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:12:43', 9, 0, '', '2019-07-15 23:12:43');
INSERT INTO `access_log` VALUES (54600, '64.77.15632035629836345', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:12:43', 12, 0, '', '2019-07-15 23:12:43');
INSERT INTO `access_log` VALUES (54601, '64.82.15632035727546369', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:12:53', 17, 0, '', '2019-07-15 23:12:53');
INSERT INTO `access_log` VALUES (54602, '66.52.15632035925504093', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:13:13', 34, 0, '', '2019-07-15 23:13:13');
INSERT INTO `access_log` VALUES (54603, '59.73.15632036018546171', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:13:22', 30, 0, '', '2019-07-15 23:13:22');
INSERT INTO `access_log` VALUES (54604, '59.80.15632036131646147', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:13:33', 31, 2001001000, '服务端发生异常', '2019-07-15 23:13:33');
INSERT INTO `access_log` VALUES (54605, '59.76.15632036195986161', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:13:40', 36, 0, '', '2019-07-15 23:13:40');
INSERT INTO `access_log` VALUES (54606, '59.75.15632036238466177', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:13:44', 15, 0, '', '2019-07-15 23:13:44');
INSERT INTO `access_log` VALUES (54607, '59.72.15632036276186165', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:13:48', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-15 23:13:48');
INSERT INTO `access_log` VALUES (54608, '65.52.15632036334758161', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:13:53', 27, 0, '', '2019-07-15 23:13:54');
INSERT INTO `access_log` VALUES (54609, '65.53.15632036438428131', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:14:04', 12, 0, '', '2019-07-15 23:14:04');
INSERT INTO `access_log` VALUES (54610, '65.54.15632036474028059', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:14:07', 10, 0, '', '2019-07-15 23:14:07');
INSERT INTO `access_log` VALUES (54611, '65.47.15632036507578115', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:14:11', 10, 0, '', '2019-07-15 23:14:11');
INSERT INTO `access_log` VALUES (54612, '65.3607.15632036587729923', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:14:19', 23, 0, '', '2019-07-15 23:14:19');
INSERT INTO `access_log` VALUES (54613, '65.45.15632036745908111', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:14:35', 9, 0, '', '2019-07-15 23:14:35');
INSERT INTO `access_log` VALUES (54614, '65.50.15632036752488139', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:14:35', 10, 0, '', '2019-07-15 23:14:35');
INSERT INTO `access_log` VALUES (54615, '65.52.15632036756918163', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:14:36', 18, 0, '', '2019-07-15 23:14:36');
INSERT INTO `access_log` VALUES (54616, '59.73.15632036761456173', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:14:36', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-15 23:14:36');
INSERT INTO `access_log` VALUES (54617, '59.80.15632036766286149', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:14:37', 12, 0, '', '2019-07-15 23:14:37');
INSERT INTO `access_log` VALUES (54618, '59.78.15632036771456165', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:14:37', 14, 0, '', '2019-07-15 23:14:37');
INSERT INTO `access_log` VALUES (54619, '59.76.15632036776906163', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:14:38', 26, 2001001000, '服务端发生异常', '2019-07-15 23:14:38');
INSERT INTO `access_log` VALUES (54620, '59.75.15632036782906179', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:14:38', 10, 0, '', '2019-07-15 23:14:38');
INSERT INTO `access_log` VALUES (54621, '66.51.15632036786344129', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:14:39', 21, 0, '', '2019-07-15 23:14:39');
INSERT INTO `access_log` VALUES (54622, '59.75.15632038133866181', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:16:53', 3, 0, '', '2019-07-15 23:16:53');
INSERT INTO `access_log` VALUES (54623, '59.72.15632038133876169', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:16:53', 22, 2001001000, '服务端发生异常', '2019-07-15 23:16:53');
INSERT INTO `access_log` VALUES (54624, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:17:06', 7, 0, '', '2019-07-15 23:17:06');
INSERT INTO `access_log` VALUES (54625, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:17:06', 16, 0, '', '2019-07-15 23:17:06');
INSERT INTO `access_log` VALUES (54626, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:17:11', 5, 0, '', '2019-07-15 23:17:11');
INSERT INTO `access_log` VALUES (54627, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:17:11', 10, 0, '', '2019-07-15 23:17:11');
INSERT INTO `access_log` VALUES (54628, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:17:20', 6, 0, '', '2019-07-15 23:17:20');
INSERT INTO `access_log` VALUES (54629, '59.71.15632038421056173', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:17:22', 3, 0, '', '2019-07-15 23:17:22');
INSERT INTO `access_log` VALUES (54630, '59.74.15632038421456179', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:17:22', 13, 2001001000, '服务端发生异常', '2019-07-15 23:17:22');
INSERT INTO `access_log` VALUES (54631, '64.84.15632038456196357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:17:26', 2, 0, '', '2019-07-15 23:17:26');
INSERT INTO `access_log` VALUES (54632, '64.82.15632038457166373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:17:26', 2, 0, '', '2019-07-15 23:17:26');
INSERT INTO `access_log` VALUES (54633, '64.79.15632038472746359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:17:27', 3, 0, '', '2019-07-15 23:17:27');
INSERT INTO `access_log` VALUES (54634, '64.80.15632038482646373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:17:28', 2, 0, '', '2019-07-15 23:17:28');
INSERT INTO `access_log` VALUES (54635, '66.52.15632038699244097', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=111111111111111111111111111111&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:17:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-07-15 23:17:50');
INSERT INTO `access_log` VALUES (54636, '66.56.15632038885134117', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=45522565665&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:18:09', 8, 1001003000, '验证码不存在', '2019-07-15 23:18:09');
INSERT INTO `access_log` VALUES (54637, '66.54.15632039014154113', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=45522565665&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:18:21', 13, 1001003000, '验证码不存在', '2019-07-15 23:18:21');
INSERT INTO `access_log` VALUES (54638, '66.55.15632039069834087', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=45522565665&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:18:27', 7, 1001003000, '验证码不存在', '2019-07-15 23:18:27');
INSERT INTO `access_log` VALUES (54639, '66.53.15632039169604109', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15281074230&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:18:37', 7, 1001003000, '验证码不存在', '2019-07-15 23:18:37');
INSERT INTO `access_log` VALUES (54640, '64.81.15632039199756347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:18:40', 2, 0, '', '2019-07-15 23:18:40');
INSERT INTO `access_log` VALUES (54641, '64.84.15632039201366359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:18:40', 2, 0, '', '2019-07-15 23:18:40');
INSERT INTO `access_log` VALUES (54642, '59.71.15632039652946175', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:19:25', 2, 0, '', '2019-07-15 23:19:25');
INSERT INTO `access_log` VALUES (54643, '59.74.15632039653356181', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '110.185.89.92', '2019-07-15 23:19:25', 16, 2001001000, '服务端发生异常', '2019-07-15 23:19:25');
INSERT INTO `access_log` VALUES (54644, '64.83.15632039939936361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:19:54', 4, 0, '', '2019-07-15 23:19:54');
INSERT INTO `access_log` VALUES (54645, '64.78.15632039941126371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:19:54', 2, 0, '', '2019-07-15 23:19:54');
INSERT INTO `access_log` VALUES (54646, '59.76.15632039943646169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:19:54', 3, 0, '', '2019-07-15 23:19:54');
INSERT INTO `access_log` VALUES (54647, '59.78.15632039943646171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:19:54', 17, 2001001000, '服务端发生异常', '2019-07-15 23:19:54');
INSERT INTO `access_log` VALUES (54648, '65.47.15632040306268121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:20:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 23:20:31');
INSERT INTO `access_log` VALUES (54649, '65.3607.15632040374979929', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:20:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-15 23:20:38');
INSERT INTO `access_log` VALUES (54650, '65.45.15632040439278117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=zxcvbnm&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:20:44', 97, 0, '', '2019-07-15 23:20:44');
INSERT INTO `access_log` VALUES (54651, '65.50.15632040442548145', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:20:44', 9, 0, '', '2019-07-15 23:20:44');
INSERT INTO `access_log` VALUES (54652, '65.52.15632040442968169', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:20:44', 17, 0, '', '2019-07-15 23:20:44');
INSERT INTO `access_log` VALUES (54653, '65.46.15632040443098191', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:20:44', 9, 0, '', '2019-07-15 23:20:44');
INSERT INTO `access_log` VALUES (54654, '64.79.15632040471876363', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:20:47', 10, 0, '', '2019-07-15 23:20:47');
INSERT INTO `access_log` VALUES (54655, '64.82.15632040471856377', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:20:47', 13, 0, '', '2019-07-15 23:20:47');
INSERT INTO `access_log` VALUES (54656, '65.51.15632040694238193', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.185.89.92', '2019-07-15 23:21:09', 4, 0, '', '2019-07-15 23:21:09');
INSERT INTO `access_log` VALUES (54657, '59.72.15632044541116179', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:34', 2, 0, '', '2019-07-15 23:27:34');
INSERT INTO `access_log` VALUES (54658, '59.77.15632044541116171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:34', 18, 2001001000, '服务端发生异常', '2019-07-15 23:27:34');
INSERT INTO `access_log` VALUES (54659, '64.79.15632044570816369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:37', 2, 0, '', '2019-07-15 23:27:37');
INSERT INTO `access_log` VALUES (54660, '64.82.15632044572426383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:37', 2, 0, '', '2019-07-15 23:27:37');
INSERT INTO `access_log` VALUES (54661, '64.80.15632044596516383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:40', 2, 0, '', '2019-07-15 23:27:40');
INSERT INTO `access_log` VALUES (54662, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:40', 5, 0, '', '2019-07-15 23:27:40');
INSERT INTO `access_log` VALUES (54663, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:41', 5, 0, '', '2019-07-15 23:27:41');
INSERT INTO `access_log` VALUES (54664, '64.76.15632044630786367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:43', 1, 0, '', '2019-07-15 23:27:43');
INSERT INTO `access_log` VALUES (54665, '64.85.15632044632176389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:43', 2, 0, '', '2019-07-15 23:27:43');
INSERT INTO `access_log` VALUES (54666, '64.83.15632044658446369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:46', 2, 0, '', '2019-07-15 23:27:46');
INSERT INTO `access_log` VALUES (54667, '64.78.15632044659946379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:46', 2, 0, '', '2019-07-15 23:27:46');
INSERT INTO `access_log` VALUES (54668, '59.79.15632044668256185', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:47', 2, 0, '', '2019-07-15 23:27:47');
INSERT INTO `access_log` VALUES (54669, '59.71.15632044668266183', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:47', 32, 2001001000, '服务端发生异常', '2019-07-15 23:27:47');
INSERT INTO `access_log` VALUES (54670, '64.77.15632044701416361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:50', 2, 0, '', '2019-07-15 23:27:50');
INSERT INTO `access_log` VALUES (54671, '64.81.15632044703266357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:50', 1, 0, '', '2019-07-15 23:27:50');
INSERT INTO `access_log` VALUES (54672, '64.79.15632044718266371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:52', 2, 0, '', '2019-07-15 23:27:52');
INSERT INTO `access_log` VALUES (54673, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:52', 5, 0, '', '2019-07-15 23:27:52');
INSERT INTO `access_log` VALUES (54674, '64.82.15632044731536385', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:27:53', 6, 0, '', '2019-07-15 23:27:53');
INSERT INTO `access_log` VALUES (54675, '64.80.15632044848886385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:28:05', 2, 0, '', '2019-07-15 23:28:05');
INSERT INTO `access_log` VALUES (54676, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:28:05', 6, 0, '', '2019-07-15 23:28:05');
INSERT INTO `access_log` VALUES (54677, '64.85.15632044859676391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:28:06', 1, 0, '', '2019-07-15 23:28:06');
INSERT INTO `access_log` VALUES (54678, '64.83.15632044861376371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:28:06', 2, 0, '', '2019-07-15 23:28:06');
INSERT INTO `access_log` VALUES (54679, '59.80.15632044874286163', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:28:07', 3, 0, '', '2019-07-15 23:28:07');
INSERT INTO `access_log` VALUES (54680, '59.78.15632044874296179', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:28:07', 14, 2001001000, '服务端发生异常', '2019-07-15 23:28:07');
INSERT INTO `access_log` VALUES (54681, '64.78.15632044881526381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:28:08', 2, 0, '', '2019-07-15 23:28:08');
INSERT INTO `access_log` VALUES (54682, '64.77.15632044883696363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:28:08', 2, 0, '', '2019-07-15 23:28:08');
INSERT INTO `access_log` VALUES (54683, '59.76.15632044896396177', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:28:10', 2, 0, '', '2019-07-15 23:28:10');
INSERT INTO `access_log` VALUES (54684, '59.75.15632044896406193', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 6 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.1', '180.141.204.3', '2019-07-15 23:28:10', 13, 2001001000, '服务端发生异常', '2019-07-15 23:28:10');
INSERT INTO `access_log` VALUES (54685, '59.76.15632109172866263', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '36.102.228.45', '2019-07-16 01:15:17', 21, 2001001000, '服务端发生异常', '2019-07-16 01:15:17');
INSERT INTO `access_log` VALUES (54686, '59.75.15632109173096279', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '36.102.228.45', '2019-07-16 01:15:17', 9, 0, '', '2019-07-16 01:15:17');
INSERT INTO `access_log` VALUES (54687, '59.71.15632223449946423', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.36.224.248', '2019-07-16 04:25:45', 11, 0, '', '2019-07-16 04:25:45');
INSERT INTO `access_log` VALUES (54688, '59.79.15632223449956425', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.36.224.248', '2019-07-16 04:25:45', 26, 2001001000, '服务端发生异常', '2019-07-16 04:25:45');
INSERT INTO `access_log` VALUES (54689, '64.79.15632223507546611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.36.224.248', '2019-07-16 04:25:51', 14, 0, '', '2019-07-16 04:25:51');
INSERT INTO `access_log` VALUES (54690, '64.82.15632223509256625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.36.224.248', '2019-07-16 04:25:51', 4, 0, '', '2019-07-16 04:25:51');
INSERT INTO `access_log` VALUES (54691, '59.80.15632223524466403', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.36.224.248', '2019-07-16 04:25:52', 3, 0, '', '2019-07-16 04:25:52');
INSERT INTO `access_log` VALUES (54692, '59.73.15632223524466427', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.36.224.248', '2019-07-16 04:25:52', 12, 2001001000, '服务端发生异常', '2019-07-16 04:25:52');
INSERT INTO `access_log` VALUES (54693, '64.80.15632223556746625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.36.224.248', '2019-07-16 04:25:56', 2, 0, '', '2019-07-16 04:25:56');
INSERT INTO `access_log` VALUES (54694, '64.76.15632223558466609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.36.224.248', '2019-07-16 04:25:56', 2, 0, '', '2019-07-16 04:25:56');
INSERT INTO `access_log` VALUES (54695, '64.85.15632223567786631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.36.224.248', '2019-07-16 04:25:57', 2, 0, '', '2019-07-16 04:25:57');
INSERT INTO `access_log` VALUES (54696, '64.83.15632223573336611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.36.224.248', '2019-07-16 04:25:57', 3, 0, '', '2019-07-16 04:25:57');
INSERT INTO `access_log` VALUES (54697, '65.53.15632386358348601', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '171.212.185.220', '2019-07-16 08:57:16', 24, 1002001012, '访问令牌已过期', '2019-07-16 08:57:16');
INSERT INTO `access_log` VALUES (54698, '65.46.15632386358348653', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '171.212.185.220', '2019-07-16 08:57:16', 22, 1002001012, '访问令牌已过期', '2019-07-16 08:57:16');
INSERT INTO `access_log` VALUES (54699, '65.54.15632386358348527', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '171.212.185.220', '2019-07-16 08:57:16', 48, 1002001012, '访问令牌已过期', '2019-07-16 08:57:16');
INSERT INTO `access_log` VALUES (54700, '65.46.15632390579788659', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-16 09:04:18', 5, 1002001012, '访问令牌已过期', '2019-07-16 09:04:18');
INSERT INTO `access_log` VALUES (54701, '65.54.15632390579798533', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-16 09:04:18', 4, 1002001012, '访问令牌已过期', '2019-07-16 09:04:18');
INSERT INTO `access_log` VALUES (54702, '65.51.15632390579808661', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-16 09:04:18', 4, 1002001012, '访问令牌已过期', '2019-07-16 09:04:18');
INSERT INTO `access_log` VALUES (54703, '65.47.15632390580728591', 0, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '59.42.74.79', '2019-07-16 09:04:18', 11, 1002001012, '访问令牌已过期', '2019-07-16 09:04:18');
INSERT INTO `access_log` VALUES (54704, '59.74.15632418154256689', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 09:50:15', 13, 0, '', '2019-07-16 09:50:15');
INSERT INTO `access_log` VALUES (54705, '59.73.15632418154286687', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 09:50:15', 32, 2001001000, '服务端发生异常', '2019-07-16 09:50:15');
INSERT INTO `access_log` VALUES (54706, '64.83.15632418265266871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 09:50:27', 12, 0, '', '2019-07-16 09:50:27');
INSERT INTO `access_log` VALUES (54707, '64.78.15632418266606881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 09:50:27', 3, 0, '', '2019-07-16 09:50:27');
INSERT INTO `access_log` VALUES (54708, '64.77.15632418283946863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 09:50:28', 2, 0, '', '2019-07-16 09:50:28');
INSERT INTO `access_log` VALUES (54709, '64.81.15632418292846859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 09:50:29', 1, 0, '', '2019-07-16 09:50:29');
INSERT INTO `access_log` VALUES (54710, '64.84.15632418300896869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 09:50:30', 2, 0, '', '2019-07-16 09:50:30');
INSERT INTO `access_log` VALUES (54711, '65.54.15632418453518571', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 09:50:45', 0, 1002001015, '账号未登陆', '2019-07-16 09:50:45');
INSERT INTO `access_log` VALUES (54712, '65.46.15632418453518697', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 09:50:45', 0, 1002001015, '账号未登陆', '2019-07-16 09:50:45');
INSERT INTO `access_log` VALUES (54713, '65.51.15632418453608699', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 09:50:45', 0, 1002001015, '账号未登陆', '2019-07-16 09:50:45');
INSERT INTO `access_log` VALUES (54714, '59.76.15632418469856677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 09:50:47', 3, 0, '', '2019-07-16 09:50:47');
INSERT INTO `access_log` VALUES (54715, '59.75.15632418469926693', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 09:50:47', 24, 2001001000, '服务端发生异常', '2019-07-16 09:50:47');
INSERT INTO `access_log` VALUES (54716, '59.79.15632418810996687', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.105.136.106', '2019-07-16 09:51:21', 2, 0, '', '2019-07-16 09:51:21');
INSERT INTO `access_log` VALUES (54717, '59.74.15632418810996691', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.105.136.106', '2019-07-16 09:51:21', 12, 2001001000, '服务端发生异常', '2019-07-16 09:51:21');
INSERT INTO `access_log` VALUES (54718, '64.81.15632419514126861', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:52:31', 3, 0, '', '2019-07-16 09:52:31');
INSERT INTO `access_log` VALUES (54719, '64.84.15632419515606871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:52:32', 2, 0, '', '2019-07-16 09:52:32');
INSERT INTO `access_log` VALUES (54720, '64.79.15632419542146875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:52:34', 2, 0, '', '2019-07-16 09:52:34');
INSERT INTO `access_log` VALUES (54721, '64.82.15632419553196887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:52:35', 2, 0, '', '2019-07-16 09:52:35');
INSERT INTO `access_log` VALUES (54722, '64.76.15632419564176873', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:52:36', 2, 0, '', '2019-07-16 09:52:36');
INSERT INTO `access_log` VALUES (54723, '64.85.15632419568326895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:52:37', 2, 0, '', '2019-07-16 09:52:37');
INSERT INTO `access_log` VALUES (54724, '66.53.15632419706784617', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13870418040&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:52:51', 17, 1001003000, '验证码不存在', '2019-07-16 09:52:51');
INSERT INTO `access_log` VALUES (54725, '66.51.15632419741164645', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13870418040', 'POST', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:52:54', 60, 0, '', '2019-07-16 09:52:54');
INSERT INTO `access_log` VALUES (54726, '66.50.15632419761644613', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13870418040&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:52:56', 192, 0, '', '2019-07-16 09:52:56');
INSERT INTO `access_log` VALUES (54727, '64.77.15632419812416867', 170, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:53:01', 8, 0, '', '2019-07-16 09:53:01');
INSERT INTO `access_log` VALUES (54728, '64.84.15632419813936873', 170, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:53:01', 8, 0, '', '2019-07-16 09:53:01');
INSERT INTO `access_log` VALUES (54729, '66.56.15632419824634629', 170, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:53:02', 6, 0, '', '2019-07-16 09:53:02');
INSERT INTO `access_log` VALUES (54730, '66.48.15632419867264627', 170, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:53:07', 6, 0, '', '2019-07-16 09:53:07');
INSERT INTO `access_log` VALUES (54731, '59.74.15632419880296693', 170, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:53:08', 8, 0, '', '2019-07-16 09:53:08');
INSERT INTO `access_log` VALUES (54732, '59.73.15632419880666691', 170, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:53:08', 20, 2001001000, '服务端发生异常', '2019-07-16 09:53:08');
INSERT INTO `access_log` VALUES (54733, '64.82.15632419903426889', 170, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:53:10', 6, 0, '', '2019-07-16 09:53:10');
INSERT INTO `access_log` VALUES (54734, '64.80.15632419904546891', 170, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:53:10', 5, 0, '', '2019-07-16 09:53:10');
INSERT INTO `access_log` VALUES (54735, '64.76.15632419916116875', 170, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:53:12', 8, 0, '', '2019-07-16 09:53:12');
INSERT INTO `access_log` VALUES (54736, 'N/A', 170, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:53:12', 12, 0, '', '2019-07-16 09:53:12');
INSERT INTO `access_log` VALUES (54737, '64.83.15632419930076877', 170, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '202.105.136.106', '2019-07-16 09:53:13', 10, 0, '', '2019-07-16 09:53:13');
INSERT INTO `access_log` VALUES (54738, '59.80.15632419950316667', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 09:53:15', 2, 0, '', '2019-07-16 09:53:15');
INSERT INTO `access_log` VALUES (54739, '59.78.15632419950606683', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 09:53:15', 12, 2001001000, '服务端发生异常', '2019-07-16 09:53:15');
INSERT INTO `access_log` VALUES (54740, '59.75.15632434868246717', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:18:07', 3, 0, '', '2019-07-16 10:18:07');
INSERT INTO `access_log` VALUES (54741, '59.76.15632434868326701', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:18:07', 18, 2001001000, '服务端发生异常', '2019-07-16 10:18:07');
INSERT INTO `access_log` VALUES (54742, '64.78.15632434958316907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:18:16', 3, 0, '', '2019-07-16 10:18:16');
INSERT INTO `access_log` VALUES (54743, '64.77.15632434959566889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:18:16', 2, 0, '', '2019-07-16 10:18:16');
INSERT INTO `access_log` VALUES (54744, '64.81.15632434970166885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:18:17', 43, 0, '', '2019-07-16 10:18:17');
INSERT INTO `access_log` VALUES (54745, '64.84.15632434978826895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:18:18', 2, 0, '', '2019-07-16 10:18:18');
INSERT INTO `access_log` VALUES (54746, '64.79.15632434983146899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:18:18', 2, 0, '', '2019-07-16 10:18:18');
INSERT INTO `access_log` VALUES (54747, '64.82.15632434989866911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:18:19', 1, 0, '', '2019-07-16 10:18:19');
INSERT INTO `access_log` VALUES (54748, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=手机&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:18:26', 6, 0, '', '2019-07-16 10:18:26');
INSERT INTO `access_log` VALUES (54749, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=手机', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:18:26', 10, 0, '', '2019-07-16 10:18:26');
INSERT INTO `access_log` VALUES (54750, '64.76.15632435092966897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:18:29', 3, 0, '', '2019-07-16 10:18:29');
INSERT INTO `access_log` VALUES (54751, '64.85.15632435094296919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:18:29', 2, 0, '', '2019-07-16 10:18:29');
INSERT INTO `access_log` VALUES (54752, '64.78.15632435159516909', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:18:36', 4, 1003002003, 'Spu 只能添加在二级分类下', '2019-07-16 10:18:36');
INSERT INTO `access_log` VALUES (54753, '65.52.15632435544028697', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:19:14', 1, 1002001015, '账号未登陆', '2019-07-16 10:19:14');
INSERT INTO `access_log` VALUES (54754, '65.53.15632435544028669', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:19:14', 1, 1002001015, '账号未登陆', '2019-07-16 10:19:14');
INSERT INTO `access_log` VALUES (54755, '65.50.15632435544028675', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:19:14', 1, 1002001015, '账号未登陆', '2019-07-16 10:19:14');
INSERT INTO `access_log` VALUES (54756, '65.46.15632435582708721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:19:18', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 10:19:18');
INSERT INTO `access_log` VALUES (54757, '65.51.15632435652938723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:19:25', 93, 0, '', '2019-07-16 10:19:25');
INSERT INTO `access_log` VALUES (54758, '65.47.15632435657628653', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:19:26', 10, 0, '', '2019-07-16 10:19:26');
INSERT INTO `access_log` VALUES (54759, '65.3607.15632435657650461', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:19:26', 12, 2001001000, '服务端发生异常', '2019-07-16 10:19:26');
INSERT INTO `access_log` VALUES (54760, '65.49.15632435657688641', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:19:26', 13, 0, '', '2019-07-16 10:19:26');
INSERT INTO `access_log` VALUES (54761, '65.46.15632439351298727', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:25:35', 9, 0, '', '2019-07-16 10:25:35');
INSERT INTO `access_log` VALUES (54762, '65.51.15632439351468729', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:25:35', 16, 0, '', '2019-07-16 10:25:35');
INSERT INTO `access_log` VALUES (54763, '65.54.15632439351468601', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:25:35', 16, 2001001000, '服务端发生异常', '2019-07-16 10:25:35');
INSERT INTO `access_log` VALUES (54764, '65.49.15632439422718647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:25:42', 10, 0, '', '2019-07-16 10:25:42');
INSERT INTO `access_log` VALUES (54765, '65.47.15632439422758659', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:25:42', 10, 2001001000, '服务端发生异常', '2019-07-16 10:25:42');
INSERT INTO `access_log` VALUES (54766, '65.45.15632439422798655', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.200.213.41', '2019-07-16 10:25:42', 9, 0, '', '2019-07-16 10:25:42');
INSERT INTO `access_log` VALUES (54767, '65.54.15632447597308613', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.217.92.217', '2019-07-16 10:39:20', 0, 1002001015, '账号未登陆', '2019-07-16 10:39:20');
INSERT INTO `access_log` VALUES (54768, '65.46.15632447597318739', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.217.92.217', '2019-07-16 10:39:20', 0, 1002001015, '账号未登陆', '2019-07-16 10:39:20');
INSERT INTO `access_log` VALUES (54769, '65.3607.15632447597350479', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.217.92.217', '2019-07-16 10:39:20', 0, 1002001015, '账号未登陆', '2019-07-16 10:39:20');
INSERT INTO `access_log` VALUES (54770, '65.49.15632447726258659', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.217.92.217', '2019-07-16 10:39:33', 67, 0, '', '2019-07-16 10:39:33');
INSERT INTO `access_log` VALUES (54771, '65.47.15632447730078671', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.217.92.217', '2019-07-16 10:39:33', 17, 0, '', '2019-07-16 10:39:33');
INSERT INTO `access_log` VALUES (54772, '65.53.15632447730218689', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.217.92.217', '2019-07-16 10:39:33', 10, 0, '', '2019-07-16 10:39:33');
INSERT INTO `access_log` VALUES (54773, '65.50.15632447730218695', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.217.92.217', '2019-07-16 10:39:33', 11, 2001001000, '服务端发生异常', '2019-07-16 10:39:33');
INSERT INTO `access_log` VALUES (54774, '65.51.15632447797178743', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.217.92.217', '2019-07-16 10:39:40', 9, 0, '', '2019-07-16 10:39:40');
INSERT INTO `access_log` VALUES (54775, '65.46.15632447797228741', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.217.92.217', '2019-07-16 10:39:40', 11, 2001001000, '服务端发生异常', '2019-07-16 10:39:40');
INSERT INTO `access_log` VALUES (54776, '65.54.15632447797298615', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.217.92.217', '2019-07-16 10:39:40', 9, 0, '', '2019-07-16 10:39:40');
INSERT INTO `access_log` VALUES (54777, '65.51.15632462827508763', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:04:43', 4, 1002001012, '访问令牌已过期', '2019-07-16 11:04:43');
INSERT INTO `access_log` VALUES (54778, '65.54.15632462827508635', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:04:43', 4, 1002001012, '访问令牌已过期', '2019-07-16 11:04:43');
INSERT INTO `access_log` VALUES (54779, '65.46.15632462827668763', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:04:43', 3, 1002001012, '访问令牌已过期', '2019-07-16 11:04:43');
INSERT INTO `access_log` VALUES (54780, '65.3607.15632462902580501', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:04:50', 96, 0, '', '2019-07-16 11:04:50');
INSERT INTO `access_log` VALUES (54781, '65.45.15632462905898691', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:04:51', 10, 0, '', '2019-07-16 11:04:51');
INSERT INTO `access_log` VALUES (54782, '65.49.15632462905898683', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:04:51', 11, 0, '', '2019-07-16 11:04:51');
INSERT INTO `access_log` VALUES (54783, '65.47.15632462905898693', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:04:51', 11, 2001001000, '服务端发生异常', '2019-07-16 11:04:51');
INSERT INTO `access_log` VALUES (54784, '65.49.15632465476968687', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:09:08', 352, 2001001000, '服务端发生异常', '2019-07-16 11:09:08');
INSERT INTO `access_log` VALUES (54785, '65.45.15632465477028695', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:09:08', 347, 0, '', '2019-07-16 11:09:08');
INSERT INTO `access_log` VALUES (54786, '65.47.15632465476958697', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:09:08', 354, 0, '', '2019-07-16 11:09:08');
INSERT INTO `access_log` VALUES (54787, '65.54.15632466053658641', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:10:05', 10, 0, '', '2019-07-16 11:10:05');
INSERT INTO `access_log` VALUES (54788, '65.3607.15632466053700507', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:10:05', 10, 0, '', '2019-07-16 11:10:05');
INSERT INTO `access_log` VALUES (54789, '65.46.15632466053698769', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:10:05', 11, 2001001000, '服务端发生异常', '2019-07-16 11:10:05');
INSERT INTO `access_log` VALUES (54790, '65.49.15632466082388689', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:10:08', 9, 0, '', '2019-07-16 11:10:08');
INSERT INTO `access_log` VALUES (54791, '65.47.15632466082398699', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:10:08', 10, 2001001000, '服务端发生异常', '2019-07-16 11:10:08');
INSERT INTO `access_log` VALUES (54792, '65.45.15632466082448697', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:10:08', 8, 0, '', '2019-07-16 11:10:08');
INSERT INTO `access_log` VALUES (54793, '65.53.15632466338258719', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:10:34', 9, 0, '', '2019-07-16 11:10:34');
INSERT INTO `access_log` VALUES (54794, '65.46.15632466338288771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:10:34', 9, 0, '', '2019-07-16 11:10:34');
INSERT INTO `access_log` VALUES (54795, '65.51.15632466338268771', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:10:34', 12, 2001001000, '服务端发生异常', '2019-07-16 11:10:34');
INSERT INTO `access_log` VALUES (54796, '65.49.15632466466918691', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:10:47', 28, 0, '', '2019-07-16 11:10:47');
INSERT INTO `access_log` VALUES (54797, '65.3607.15632466466840509', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:10:47', 33, 0, '', '2019-07-16 11:10:47');
INSERT INTO `access_log` VALUES (54798, '65.45.15632466466878699', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 11:10:47', 31, 2001001000, '服务端发生异常', '2019-07-16 11:10:47');
INSERT INTO `access_log` VALUES (54799, '59.79.15632468291256755', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.47.147.2', '2019-07-16 11:13:49', 9, 0, '', '2019-07-16 11:13:49');
INSERT INTO `access_log` VALUES (54800, '59.74.15632468291466759', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.47.147.2', '2019-07-16 11:13:49', 15, 2001001000, '服务端发生异常', '2019-07-16 11:13:49');
INSERT INTO `access_log` VALUES (54801, '64.79.15632468716436945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.47.147.2', '2019-07-16 11:14:32', 11, 0, '', '2019-07-16 11:14:32');
INSERT INTO `access_log` VALUES (54802, '64.82.15632468720236957', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.47.147.2', '2019-07-16 11:14:32', 3, 0, '', '2019-07-16 11:14:32');
INSERT INTO `access_log` VALUES (54803, '64.76.15632468769226943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.47.147.2', '2019-07-16 11:14:37', 2, 0, '', '2019-07-16 11:14:37');
INSERT INTO `access_log` VALUES (54804, '64.85.15632468773446965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.47.147.2', '2019-07-16 11:14:37', 2, 0, '', '2019-07-16 11:14:37');
INSERT INTO `access_log` VALUES (54805, '59.76.15632468796226747', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.47.147.2', '2019-07-16 11:14:40', 3, 0, '', '2019-07-16 11:14:40');
INSERT INTO `access_log` VALUES (54806, '59.75.15632468796226763', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.47.147.2', '2019-07-16 11:14:40', 34, 2001001000, '服务端发生异常', '2019-07-16 11:14:40');
INSERT INTO `access_log` VALUES (54807, '64.83.15632468833436945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.47.147.2', '2019-07-16 11:14:43', 3, 0, '', '2019-07-16 11:14:43');
INSERT INTO `access_log` VALUES (54808, '64.78.15632468837036955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.47.147.2', '2019-07-16 11:14:44', 2, 0, '', '2019-07-16 11:14:44');
INSERT INTO `access_log` VALUES (54809, '64.77.15632468851406937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.47.147.2', '2019-07-16 11:14:45', 2, 0, '', '2019-07-16 11:14:45');
INSERT INTO `access_log` VALUES (54810, '64.81.15632468857546933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.47.147.2', '2019-07-16 11:14:46', 2, 0, '', '2019-07-16 11:14:46');
INSERT INTO `access_log` VALUES (54811, '64.84.15632468863036943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.47.147.2', '2019-07-16 11:14:46', 2, 0, '', '2019-07-16 11:14:46');
INSERT INTO `access_log` VALUES (54812, '64.79.15632468867236947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '103.47.147.2', '2019-07-16 11:14:47', 2, 0, '', '2019-07-16 11:14:47');
INSERT INTO `access_log` VALUES (54813, '65.45.15632488728058731', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.112.4.2', '2019-07-16 11:47:53', 0, 1002001015, '账号未登陆', '2019-07-16 11:47:53');
INSERT INTO `access_log` VALUES (54814, '65.52.15632488728048779', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.112.4.2', '2019-07-16 11:47:53', 0, 1002001015, '账号未登陆', '2019-07-16 11:47:53');
INSERT INTO `access_log` VALUES (54815, '65.46.15632488728058803', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.112.4.2', '2019-07-16 11:47:53', 0, 1002001015, '账号未登陆', '2019-07-16 11:47:53');
INSERT INTO `access_log` VALUES (54816, '65.47.15632488844418733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.112.4.2', '2019-07-16 11:48:04', 96, 0, '', '2019-07-16 11:48:05');
INSERT INTO `access_log` VALUES (54817, '65.3607.15632488847830541', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.112.4.2', '2019-07-16 11:48:05', 112, 0, '', '2019-07-16 11:48:05');
INSERT INTO `access_log` VALUES (54818, '65.49.15632488847878721', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.112.4.2', '2019-07-16 11:48:05', 108, 0, '', '2019-07-16 11:48:05');
INSERT INTO `access_log` VALUES (54819, '65.51.15632488847838803', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.112.4.2', '2019-07-16 11:48:05', 112, 2001001000, '服务端发生异常', '2019-07-16 11:48:05');
INSERT INTO `access_log` VALUES (54820, '65.50.15632525098208805', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '144.123.40.242', '2019-07-16 12:48:30', 1, 1002001015, '账号未登陆', '2019-07-16 12:48:30');
INSERT INTO `access_log` VALUES (54821, '65.46.15632525098258855', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '144.123.40.242', '2019-07-16 12:48:30', 0, 1002001015, '账号未登陆', '2019-07-16 12:48:30');
INSERT INTO `access_log` VALUES (54822, '65.53.15632525098218803', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '144.123.40.242', '2019-07-16 12:48:30', 1, 1002001015, '账号未登陆', '2019-07-16 12:48:30');
INSERT INTO `access_log` VALUES (54823, '65.45.15632525120648781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '144.123.40.242', '2019-07-16 12:48:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 12:48:32');
INSERT INTO `access_log` VALUES (54824, '65.54.15632525261218727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '144.123.40.242', '2019-07-16 12:48:46', 102, 0, '', '2019-07-16 12:48:46');
INSERT INTO `access_log` VALUES (54825, '65.47.15632525265148783', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '144.123.40.242', '2019-07-16 12:48:47', 11, 0, '', '2019-07-16 12:48:47');
INSERT INTO `access_log` VALUES (54826, '65.3607.15632525265180591', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '144.123.40.242', '2019-07-16 12:48:47', 10, 2001001000, '服务端发生异常', '2019-07-16 12:48:47');
INSERT INTO `access_log` VALUES (54827, '65.49.15632525265308771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '144.123.40.242', '2019-07-16 12:48:47', 9, 0, '', '2019-07-16 12:48:47');
INSERT INTO `access_log` VALUES (54828, '65.51.15632525325508855', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '144.123.40.242', '2019-07-16 12:48:53', 10, 0, '', '2019-07-16 12:48:53');
INSERT INTO `access_log` VALUES (54829, '65.50.15632525325518807', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '144.123.40.242', '2019-07-16 12:48:53', 10, 0, '', '2019-07-16 12:48:53');
INSERT INTO `access_log` VALUES (54830, '65.53.15632525325508805', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '144.123.40.242', '2019-07-16 12:48:53', 11, 2001001000, '服务端发生异常', '2019-07-16 12:48:53');
INSERT INTO `access_log` VALUES (54831, '66.51.15632539461904807', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 13:12:26', 0, 1002001015, '账号未登陆', '2019-07-16 13:12:26');
INSERT INTO `access_log` VALUES (54832, '66.56.15632539728884791', 0, 1, 'user-application', '/user-api/users/user/update_avatar', 'avatar=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 13:12:53', 1, 1002001015, '账号未登陆', '2019-07-16 13:12:53');
INSERT INTO `access_log` VALUES (54833, '59.73.15632540040466853', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 13:13:24', 10, 0, '', '2019-07-16 13:13:24');
INSERT INTO `access_log` VALUES (54834, '59.80.15632540040476829', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 13:13:24', 25, 2001001000, '服务端发生异常', '2019-07-16 13:13:24');
INSERT INTO `access_log` VALUES (54835, '65.49.15632554444598809', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yunaiyuanma&password=yunaiyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 13:37:24', 5, 1002002000, '账号不存在', '2019-07-16 13:37:24');
INSERT INTO `access_log` VALUES (54836, '65.50.15632554822348847', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 13:38:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 13:38:02');
INSERT INTO `access_log` VALUES (54837, '65.54.15632555273358769', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 13:38:47', 68, 0, '', '2019-07-16 13:38:47');
INSERT INTO `access_log` VALUES (54838, '65.47.15632555276028825', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 13:38:48', 18, 0, '', '2019-07-16 13:38:48');
INSERT INTO `access_log` VALUES (54839, '65.3607.15632555276070633', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 13:38:48', 30, 2001001000, '服务端发生异常', '2019-07-16 13:38:48');
INSERT INTO `access_log` VALUES (54840, '65.49.15632555276158811', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 13:38:48', 21, 0, '', '2019-07-16 13:38:48');
INSERT INTO `access_log` VALUES (54841, '65.52.15632555868338875', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:39:47', 1, 1002001015, '账号未登陆', '2019-07-16 13:39:47');
INSERT INTO `access_log` VALUES (54842, '65.45.15632555868338825', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:39:47', 1, 1002001015, '账号未登陆', '2019-07-16 13:39:47');
INSERT INTO `access_log` VALUES (54843, '65.54.15632555868368771', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:39:47', 0, 1002001015, '账号未登陆', '2019-07-16 13:39:47');
INSERT INTO `access_log` VALUES (54844, '65.49.15632555893978813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:39:49', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 13:39:49');
INSERT INTO `access_log` VALUES (54845, '65.47.15632556012268827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:40:01', 82, 0, '', '2019-07-16 13:40:01');
INSERT INTO `access_log` VALUES (54846, '65.53.15632556015868849', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:40:02', 10, 0, '', '2019-07-16 13:40:02');
INSERT INTO `access_log` VALUES (54847, '65.50.15632556015928851', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:40:02', 9, 0, '', '2019-07-16 13:40:02');
INSERT INTO `access_log` VALUES (54848, '65.51.15632556015928899', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:40:02', 11, 2001001000, '服务端发生异常', '2019-07-16 13:40:02');
INSERT INTO `access_log` VALUES (54849, '65.54.15632556228148773', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:40:23', 27, 0, '', '2019-07-16 13:40:23');
INSERT INTO `access_log` VALUES (54850, '65.52.15632556228128877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:40:23', 31, 2001001000, '服务端发生异常', '2019-07-16 13:40:23');
INSERT INTO `access_log` VALUES (54851, '65.45.15632556228798827', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:40:23', 9, 0, '', '2019-07-16 13:40:23');
INSERT INTO `access_log` VALUES (54852, '65.47.15632556292098829', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:40:29', 7, 0, '', '2019-07-16 13:40:29');
INSERT INTO `access_log` VALUES (54853, '65.3607.15632556292080637', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:40:29', 10, 0, '', '2019-07-16 13:40:29');
INSERT INTO `access_log` VALUES (54854, '65.50.15632556292108853', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:40:29', 10, 2001001000, '服务端发生异常', '2019-07-16 13:40:29');
INSERT INTO `access_log` VALUES (54855, '65.51.15632556331768901', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:40:33', 10, 2001001000, '服务端发生异常', '2019-07-16 13:40:33');
INSERT INTO `access_log` VALUES (54856, '65.53.15632556331808851', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:40:33', 8, 0, '', '2019-07-16 13:40:33');
INSERT INTO `access_log` VALUES (54857, '65.46.15632556331828903', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:40:33', 9, 0, '', '2019-07-16 13:40:33');
INSERT INTO `access_log` VALUES (54858, '65.45.15632559565598833', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.67.37.109', '2019-07-16 13:45:57', 1, 1002001015, '账号未登陆', '2019-07-16 13:45:57');
INSERT INTO `access_log` VALUES (54859, '65.49.15632559565648821', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.67.39.158', '2019-07-16 13:45:57', 0, 1002001015, '账号未登陆', '2019-07-16 13:45:57');
INSERT INTO `access_log` VALUES (54860, '65.47.15632559565718835', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.67.39.158', '2019-07-16 13:45:57', 1, 1002001015, '账号未登陆', '2019-07-16 13:45:57');
INSERT INTO `access_log` VALUES (54861, '59.77.15632560236236865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:47:04', 12, 0, '', '2019-07-16 13:47:04');
INSERT INTO `access_log` VALUES (54862, '59.71.15632560236246877', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:47:04', 15, 2001001000, '服务端发生异常', '2019-07-16 13:47:04');
INSERT INTO `access_log` VALUES (54863, '59.79.15632560381446879', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:47:18', 3, 0, '', '2019-07-16 13:47:18');
INSERT INTO `access_log` VALUES (54864, '59.73.15632560381456881', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:47:18', 14, 2001001000, '服务端发生异常', '2019-07-16 13:47:18');
INSERT INTO `access_log` VALUES (54865, '65.47.15632560736328837', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:47:54', 12, 0, '', '2019-07-16 13:47:54');
INSERT INTO `access_log` VALUES (54866, '65.49.15632560736328823', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:47:54', 13, 2001001000, '服务端发生异常', '2019-07-16 13:47:54');
INSERT INTO `access_log` VALUES (54867, '65.45.15632560736378835', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '112.45.97.80', '2019-07-16 13:47:54', 10, 0, '', '2019-07-16 13:47:54');
INSERT INTO `access_log` VALUES (54868, '65.52.15632563087138889', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.67.37.109', '2019-07-16 13:51:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 13:51:49');
INSERT INTO `access_log` VALUES (54869, '65.49.15632563135128827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.67.39.158', '2019-07-16 13:51:54', 74, 0, '', '2019-07-16 13:51:54');
INSERT INTO `access_log` VALUES (54870, '65.47.15632563137818841', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.67.39.158', '2019-07-16 13:51:54', 10, 0, '', '2019-07-16 13:51:54');
INSERT INTO `access_log` VALUES (54871, '65.45.15632563137818839', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.67.39.158', '2019-07-16 13:51:54', 10, 2001001000, '服务端发生异常', '2019-07-16 13:51:54');
INSERT INTO `access_log` VALUES (54872, '65.50.15632563137868865', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.67.37.109', '2019-07-16 13:51:54', 9, 0, '', '2019-07-16 13:51:54');
INSERT INTO `access_log` VALUES (54873, '65.53.15632563466938863', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 13:52:27', 9, 0, '', '2019-07-16 13:52:27');
INSERT INTO `access_log` VALUES (54874, '65.52.15632563466998891', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 13:52:27', 8, 0, '', '2019-07-16 13:52:27');
INSERT INTO `access_log` VALUES (54875, '65.54.15632563466988787', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 13:52:27', 9, 2001001000, '服务端发生异常', '2019-07-16 13:52:27');
INSERT INTO `access_log` VALUES (54876, '65.47.15632567024898847', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.118.83', '2019-07-16 13:58:22', 0, 1002001015, '账号未登陆', '2019-07-16 13:58:22');
INSERT INTO `access_log` VALUES (54877, '65.3607.15632567029370655', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.118.83', '2019-07-16 13:58:23', 0, 1002001015, '账号未登陆', '2019-07-16 13:58:23');
INSERT INTO `access_log` VALUES (54878, '65.51.15632567031258919', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.118.83', '2019-07-16 13:58:23', 0, 1002001015, '账号未登陆', '2019-07-16 13:58:23');
INSERT INTO `access_log` VALUES (54879, '65.52.15632567075508897', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.118.83', '2019-07-16 13:58:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 13:58:28');
INSERT INTO `access_log` VALUES (54880, '65.54.15632567174828793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.118.83', '2019-07-16 13:58:37', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 13:58:37');
INSERT INTO `access_log` VALUES (54881, '65.49.15632567330998835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.118.83', '2019-07-16 13:58:53', 106, 0, '', '2019-07-16 13:58:53');
INSERT INTO `access_log` VALUES (54882, '65.47.15632567339378849', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.118.83', '2019-07-16 13:58:54', 9, 0, '', '2019-07-16 13:58:54');
INSERT INTO `access_log` VALUES (54883, '65.50.15632567339368873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.118.83', '2019-07-16 13:58:54', 11, 2001001000, '服务端发生异常', '2019-07-16 13:58:54');
INSERT INTO `access_log` VALUES (54884, '65.45.15632567339368847', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.87.118.83', '2019-07-16 13:58:54', 11, 0, '', '2019-07-16 13:58:54');
INSERT INTO `access_log` VALUES (54885, '66.57.15632567384174821', 0, 1, 'user-application', '/user-api/users/user/update_avatar', 'avatar=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.203.80.2', '2019-07-16 13:58:58', 1, 1002001015, '账号未登陆', '2019-07-16 13:58:58');
INSERT INTO `access_log` VALUES (54886, '65.3607.15632573662090667', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.221.4.22', '2019-07-16 14:09:26', 0, 1002001015, '账号未登陆', '2019-07-16 14:09:26');
INSERT INTO `access_log` VALUES (54887, '65.50.15632573662098881', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.221.4.22', '2019-07-16 14:09:26', 0, 1002001015, '账号未登陆', '2019-07-16 14:09:26');
INSERT INTO `access_log` VALUES (54888, '65.47.15632573662228859', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.221.4.22', '2019-07-16 14:09:26', 1, 1002001015, '账号未登陆', '2019-07-16 14:09:26');
INSERT INTO `access_log` VALUES (54889, '65.45.15632573677588857', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.221.4.22', '2019-07-16 14:09:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 14:09:28');
INSERT INTO `access_log` VALUES (54890, '65.51.15632573755388929', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.221.4.22', '2019-07-16 14:09:36', 61, 0, '', '2019-07-16 14:09:36');
INSERT INTO `access_log` VALUES (54891, '65.52.15632573757988909', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.221.4.22', '2019-07-16 14:09:36', 10, 0, '', '2019-07-16 14:09:36');
INSERT INTO `access_log` VALUES (54892, '65.46.15632573758058933', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.221.4.22', '2019-07-16 14:09:36', 11, 2001001000, '服务端发生异常', '2019-07-16 14:09:36');
INSERT INTO `access_log` VALUES (54893, '65.54.15632573758088805', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.221.4.22', '2019-07-16 14:09:36', 8, 0, '', '2019-07-16 14:09:36');
INSERT INTO `access_log` VALUES (54894, '65.49.15632573840158847', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.221.4.22', '2019-07-16 14:09:44', 9, 0, '', '2019-07-16 14:09:44');
INSERT INTO `access_log` VALUES (54895, '65.50.15632573840178883', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.221.4.22', '2019-07-16 14:09:44', 10, 2001001000, '服务端发生异常', '2019-07-16 14:09:44');
INSERT INTO `access_log` VALUES (54896, '65.3607.15632573840190669', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.221.4.22', '2019-07-16 14:09:44', 9, 0, '', '2019-07-16 14:09:44');
INSERT INTO `access_log` VALUES (54897, '59.76.15632574062366889', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.221.4.22', '2019-07-16 14:10:06', 4, 0, '', '2019-07-16 14:10:06');
INSERT INTO `access_log` VALUES (54898, '59.75.15632574062386905', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '58.221.4.22', '2019-07-16 14:10:06', 19, 2001001000, '服务端发生异常', '2019-07-16 14:10:06');
INSERT INTO `access_log` VALUES (54899, '65.52.15632592105818935', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '49.72.242.116', '2019-07-16 14:40:11', 1, 1002001015, '账号未登陆', '2019-07-16 14:40:11');
INSERT INTO `access_log` VALUES (54900, '65.51.15632592105808955', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '49.72.242.116', '2019-07-16 14:40:11', 0, 1002001015, '账号未登陆', '2019-07-16 14:40:11');
INSERT INTO `access_log` VALUES (54901, '65.46.15632592105828959', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '49.72.242.116', '2019-07-16 14:40:11', 0, 1002001015, '账号未登陆', '2019-07-16 14:40:11');
INSERT INTO `access_log` VALUES (54902, '65.54.15632592196968831', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '49.72.242.116', '2019-07-16 14:40:20', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 14:40:20');
INSERT INTO `access_log` VALUES (54903, '65.49.15632592607848873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '49.72.242.116', '2019-07-16 14:41:01', 71, 0, '', '2019-07-16 14:41:01');
INSERT INTO `access_log` VALUES (54904, '65.47.15632592614388887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '49.72.242.116', '2019-07-16 14:41:01', 8, 0, '', '2019-07-16 14:41:01');
INSERT INTO `access_log` VALUES (54905, '65.45.15632592614518885', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '49.72.242.116', '2019-07-16 14:41:01', 8, 2001001000, '服务端发生异常', '2019-07-16 14:41:01');
INSERT INTO `access_log` VALUES (54906, '65.46.15632592614628961', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '49.72.242.116', '2019-07-16 14:41:01', 7, 0, '', '2019-07-16 14:41:01');
INSERT INTO `access_log` VALUES (54907, '65.54.15632592877898833', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '49.72.242.116', '2019-07-16 14:41:28', 9, 0, '', '2019-07-16 14:41:28');
INSERT INTO `access_log` VALUES (54908, '65.53.15632592877978909', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '49.72.242.116', '2019-07-16 14:41:28', 9, 2001001000, '服务端发生异常', '2019-07-16 14:41:28');
INSERT INTO `access_log` VALUES (54909, '65.3607.15632592878160697', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '49.72.242.116', '2019-07-16 14:41:28', 9, 0, '', '2019-07-16 14:41:28');
INSERT INTO `access_log` VALUES (54910, '65.50.15632592975978911', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '49.72.242.116', '2019-07-16 14:41:38', 9, 0, '', '2019-07-16 14:41:38');
INSERT INTO `access_log` VALUES (54911, '65.49.15632592976058875', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '49.72.242.116', '2019-07-16 14:41:38', 11, 2001001000, '服务端发生异常', '2019-07-16 14:41:38');
INSERT INTO `access_log` VALUES (54912, '65.45.15632592976148887', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '49.72.242.116', '2019-07-16 14:41:38', 9, 0, '', '2019-07-16 14:41:38');
INSERT INTO `access_log` VALUES (54913, '59.75.15632605327506947', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.222.191.122', '2019-07-16 15:02:13', 11, 0, '', '2019-07-16 15:02:13');
INSERT INTO `access_log` VALUES (54914, '59.76.15632605327506931', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.222.191.122', '2019-07-16 15:02:13', 21, 2001001000, '服务端发生异常', '2019-07-16 15:02:13');
INSERT INTO `access_log` VALUES (54915, '64.82.15632605374717143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.222.191.122', '2019-07-16 15:02:17', 12, 0, '', '2019-07-16 15:02:17');
INSERT INTO `access_log` VALUES (54916, '64.80.15632605377037143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.222.191.122', '2019-07-16 15:02:18', 3, 0, '', '2019-07-16 15:02:18');
INSERT INTO `access_log` VALUES (54917, '64.76.15632605392067127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.222.191.122', '2019-07-16 15:02:19', 2, 0, '', '2019-07-16 15:02:19');
INSERT INTO `access_log` VALUES (54918, '64.85.15632605402947151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.222.191.122', '2019-07-16 15:02:20', 1, 0, '', '2019-07-16 15:02:20');
INSERT INTO `access_log` VALUES (54919, '64.83.15632605411297131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.222.191.122', '2019-07-16 15:02:21', 2, 0, '', '2019-07-16 15:02:21');
INSERT INTO `access_log` VALUES (54920, '59.77.15632605421696927', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.222.191.122', '2019-07-16 15:02:22', 3, 0, '', '2019-07-16 15:02:22');
INSERT INTO `access_log` VALUES (54921, '59.71.15632605421716939', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.222.191.122', '2019-07-16 15:02:22', 13, 2001001000, '服务端发生异常', '2019-07-16 15:02:22');
INSERT INTO `access_log` VALUES (54922, '64.84.15632605453207127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.222.191.122', '2019-07-16 15:02:25', 3, 0, '', '2019-07-16 15:02:25');
INSERT INTO `access_log` VALUES (54923, '64.81.15632605454047117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.222.191.122', '2019-07-16 15:02:25', 2, 0, '', '2019-07-16 15:02:25');
INSERT INTO `access_log` VALUES (54924, '65.53.15632605874348927', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-16 15:03:07', 4, 1002001012, '访问令牌已过期', '2019-07-16 15:03:07');
INSERT INTO `access_log` VALUES (54925, '65.49.15632605874388893', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-16 15:03:07', 3, 1002001012, '访问令牌已过期', '2019-07-16 15:03:07');
INSERT INTO `access_log` VALUES (54926, '65.45.15632605878608905', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-16 15:03:08', 4, 1002001012, '访问令牌已过期', '2019-07-16 15:03:08');
INSERT INTO `access_log` VALUES (54927, '65.47.15632605966328907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-16 15:03:17', 67, 0, '', '2019-07-16 15:03:17');
INSERT INTO `access_log` VALUES (54928, '65.52.15632606002108957', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-16 15:03:20', 884, 0, '', '2019-07-16 15:03:21');
INSERT INTO `access_log` VALUES (54929, '65.51.15632606002148977', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-16 15:03:20', 881, 0, '', '2019-07-16 15:03:21');
INSERT INTO `access_log` VALUES (54930, '65.46.15632606002108981', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-16 15:03:20', 885, 2001001000, '服务端发生异常', '2019-07-16 15:03:21');
INSERT INTO `access_log` VALUES (54931, '59.75.15632606299136949', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:03:50', 3, 0, '', '2019-07-16 15:03:50');
INSERT INTO `access_log` VALUES (54932, '59.72.15632606299136937', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:03:50', 17, 2001001000, '服务端发生异常', '2019-07-16 15:03:50');
INSERT INTO `access_log` VALUES (54933, '64.78.15632606346107141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:03:55', 2, 0, '', '2019-07-16 15:03:55');
INSERT INTO `access_log` VALUES (54934, '64.83.15632606347267133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:03:55', 2, 0, '', '2019-07-16 15:03:55');
INSERT INTO `access_log` VALUES (54935, '64.84.15632606361027129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:03:56', 2, 0, '', '2019-07-16 15:03:56');
INSERT INTO `access_log` VALUES (54936, '64.81.15632606370067119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:03:57', 2, 0, '', '2019-07-16 15:03:57');
INSERT INTO `access_log` VALUES (54937, '64.77.15632606374057125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:03:57', 2, 0, '', '2019-07-16 15:03:57');
INSERT INTO `access_log` VALUES (54938, '64.79.15632606408267135', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:01', 2, 0, '', '2019-07-16 15:04:01');
INSERT INTO `access_log` VALUES (54939, '64.82.15632606409357147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:01', 2, 0, '', '2019-07-16 15:04:01');
INSERT INTO `access_log` VALUES (54940, '66.50.15632606710474865', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15978905836&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:31', 40, 1001003000, '验证码不存在', '2019-07-16 15:04:31');
INSERT INTO `access_log` VALUES (54941, '66.54.15632606731304873', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15978905836', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:33', 105, 0, '', '2019-07-16 15:04:33');
INSERT INTO `access_log` VALUES (54942, '66.49.15632606766884879', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15978905836&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:37', 178, 0, '', '2019-07-16 15:04:37');
INSERT INTO `access_log` VALUES (54943, '66.48.15632606862884879', 171, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:46', 8, 0, '', '2019-07-16 15:04:46');
INSERT INTO `access_log` VALUES (54944, '59.78.15632606884866937', 171, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:48', 8, 0, '', '2019-07-16 15:04:48');
INSERT INTO `access_log` VALUES (54945, '59.80.15632606884866921', 171, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:48', 50, 2001001000, '服务端发生异常', '2019-07-16 15:04:49');
INSERT INTO `access_log` VALUES (54946, '64.83.15632606904297135', 171, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:50', 6, 0, '', '2019-07-16 15:04:50');
INSERT INTO `access_log` VALUES (54947, '64.77.15632606905427127', 171, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:51', 7, 0, '', '2019-07-16 15:04:51');
INSERT INTO `access_log` VALUES (54948, '64.82.15632606914647149', 171, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:51', 6, 0, '', '2019-07-16 15:04:51');
INSERT INTO `access_log` VALUES (54949, '64.76.15632606919887133', 171, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:52', 6, 0, '', '2019-07-16 15:04:52');
INSERT INTO `access_log` VALUES (54950, '64.85.15632606924597157', 171, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:52', 6, 0, '', '2019-07-16 15:04:52');
INSERT INTO `access_log` VALUES (54951, '59.75.15632606936506951', 171, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:54', 5, 0, '', '2019-07-16 15:04:54');
INSERT INTO `access_log` VALUES (54952, '59.72.15632606936506939', 171, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:54', 18, 2001001000, '服务端发生异常', '2019-07-16 15:04:54');
INSERT INTO `access_log` VALUES (54953, '64.78.15632606967247145', 171, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:57', 6, 0, '', '2019-07-16 15:04:57');
INSERT INTO `access_log` VALUES (54954, '64.83.15632606968127137', 171, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:57', 5, 0, '', '2019-07-16 15:04:57');
INSERT INTO `access_log` VALUES (54955, '64.81.15632606978187123', 171, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:58', 8, 0, '', '2019-07-16 15:04:58');
INSERT INTO `access_log` VALUES (54956, '64.84.15632606982277133', 171, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:04:58', 5, 0, '', '2019-07-16 15:04:58');
INSERT INTO `access_log` VALUES (54957, '65.52.15632607020188959', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.4.236.185', '2019-07-16 15:05:02', 4, 1002001012, '访问令牌已过期', '2019-07-16 15:05:02');
INSERT INTO `access_log` VALUES (54958, '65.51.15632607020198979', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.4.236.185', '2019-07-16 15:05:02', 3, 1002001012, '访问令牌已过期', '2019-07-16 15:05:02');
INSERT INTO `access_log` VALUES (54959, '65.46.15632607020238983', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.4.236.185', '2019-07-16 15:05:02', 3, 1002001012, '访问令牌已过期', '2019-07-16 15:05:02');
INSERT INTO `access_log` VALUES (54960, '64.77.15632607030537129', 171, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:05:03', 5, 0, '', '2019-07-16 15:05:03');
INSERT INTO `access_log` VALUES (54961, '64.79.15632607031707139', 171, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:05:03', 6, 0, '', '2019-07-16 15:05:03');
INSERT INTO `access_log` VALUES (54962, '64.80.15632607059747151', 171, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:05:06', 6, 0, '', '2019-07-16 15:05:06');
INSERT INTO `access_log` VALUES (54963, 'N/A', 171, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:05:06', 12, 0, '', '2019-07-16 15:05:06');
INSERT INTO `access_log` VALUES (54964, '65.54.15632607067158855', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.4.236.185', '2019-07-16 15:05:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 15:05:07');
INSERT INTO `access_log` VALUES (54965, '64.85.15632607076047159', 171, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:05:08', 11, 0, '', '2019-07-16 15:05:08');
INSERT INTO `access_log` VALUES (54966, '65.3607.15632607083020719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.4.236.185', '2019-07-16 15:05:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 15:05:08');
INSERT INTO `access_log` VALUES (54967, '65.49.15632607129458897', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.4.236.185', '2019-07-16 15:05:13', 74, 0, '', '2019-07-16 15:05:13');
INSERT INTO `access_log` VALUES (54968, '65.45.15632607132598909', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.4.236.185', '2019-07-16 15:05:13', 9, 0, '', '2019-07-16 15:05:13');
INSERT INTO `access_log` VALUES (54969, '65.50.15632607132598933', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.4.236.185', '2019-07-16 15:05:13', 9, 2001001000, '服务端发生异常', '2019-07-16 15:05:13');
INSERT INTO `access_log` VALUES (54970, '65.47.15632607132648911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.4.236.185', '2019-07-16 15:05:13', 9, 0, '', '2019-07-16 15:05:13');
INSERT INTO `access_log` VALUES (54971, '66.51.15632607196364899', 171, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:05:20', 6, 0, '', '2019-07-16 15:05:20');
INSERT INTO `access_log` VALUES (54972, '66.56.15632607272734883', 171, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '115.236.62.130', '2019-07-16 15:05:27', 6, 0, '', '2019-07-16 15:05:27');
INSERT INTO `access_log` VALUES (54973, '65.47.15632615681738923', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:19:28', 0, 1002001015, '账号未登陆', '2019-07-16 15:19:28');
INSERT INTO `access_log` VALUES (54974, '65.50.15632615681758945', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:19:28', 0, 1002001015, '账号未登陆', '2019-07-16 15:19:28');
INSERT INTO `access_log` VALUES (54975, '65.45.15632615681768921', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:19:28', 0, 1002001015, '账号未登陆', '2019-07-16 15:19:28');
INSERT INTO `access_log` VALUES (54976, '65.52.15632615698698973', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:19:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 15:19:30');
INSERT INTO `access_log` VALUES (54977, '65.46.15632615803488997', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:19:40', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 15:19:40');
INSERT INTO `access_log` VALUES (54978, '65.54.15632615810688869', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:19:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 15:19:41');
INSERT INTO `access_log` VALUES (54979, '65.3607.15632615815220733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:19:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 15:19:42');
INSERT INTO `access_log` VALUES (54980, '65.53.15632615824248945', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:19:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 15:19:42');
INSERT INTO `access_log` VALUES (54981, '65.49.15632615864608911', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:19:46', 5, 1002002001, '密码不正确', '2019-07-16 15:19:46');
INSERT INTO `access_log` VALUES (54982, '65.45.15632615876978923', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:19:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 15:19:48');
INSERT INTO `access_log` VALUES (54983, '65.50.15632615881798947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:19:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 15:19:48');
INSERT INTO `access_log` VALUES (54984, '65.47.15632615884688925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:19:48', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 15:19:48');
INSERT INTO `access_log` VALUES (54985, '65.50.15632617076248949', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-07-16 15:21:48', 4, 1002001012, '访问令牌已过期', '2019-07-16 15:21:48');
INSERT INTO `access_log` VALUES (54986, '65.47.15632617076258927', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-07-16 15:21:48', 4, 1002001012, '访问令牌已过期', '2019-07-16 15:21:48');
INSERT INTO `access_log` VALUES (54987, '65.52.15632617076268977', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-07-16 15:21:48', 3, 1002001012, '访问令牌已过期', '2019-07-16 15:21:48');
INSERT INTO `access_log` VALUES (54988, '65.51.15632617103138997', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-07-16 15:21:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 15:21:50');
INSERT INTO `access_log` VALUES (54989, '65.54.15632617260188873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-07-16 15:22:06', 71, 0, '', '2019-07-16 15:22:06');
INSERT INTO `access_log` VALUES (54990, '65.49.15632617564158915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.236.62.130', '2019-07-16 15:22:36', 66, 0, '', '2019-07-16 15:22:36');
INSERT INTO `access_log` VALUES (54991, '65.45.15632617570308927', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.236.62.130', '2019-07-16 15:22:37', 10, 0, '', '2019-07-16 15:22:37');
INSERT INTO `access_log` VALUES (54992, '65.52.15632617570348979', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.236.62.130', '2019-07-16 15:22:37', 9, 0, '', '2019-07-16 15:22:37');
INSERT INTO `access_log` VALUES (54993, '65.50.15632617570318951', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.236.62.130', '2019-07-16 15:22:37', 13, 2001001000, '服务端发生异常', '2019-07-16 15:22:37');
INSERT INTO `access_log` VALUES (54994, '65.51.15632617699128999', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.236.62.130', '2019-07-16 15:22:50', 8, 0, '', '2019-07-16 15:22:50');
INSERT INTO `access_log` VALUES (54995, '65.46.15632617699179003', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.236.62.130', '2019-07-16 15:22:50', 10, 2001001000, '服务端发生异常', '2019-07-16 15:22:50');
INSERT INTO `access_log` VALUES (54996, '65.54.15632617699238875', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.236.62.130', '2019-07-16 15:22:50', 9, 0, '', '2019-07-16 15:22:50');
INSERT INTO `access_log` VALUES (54997, '65.3607.15632619215130741', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:25:22', 222, 0, '', '2019-07-16 15:25:22');
INSERT INTO `access_log` VALUES (54998, '65.53.15632619219438953', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:25:22', 8, 0, '', '2019-07-16 15:25:22');
INSERT INTO `access_log` VALUES (54999, '65.49.15632619219448919', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:25:22', 11, 2001001000, '服务端发生异常', '2019-07-16 15:25:22');
INSERT INTO `access_log` VALUES (55000, '65.45.15632619219478931', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:25:22', 9, 0, '', '2019-07-16 15:25:22');
INSERT INTO `access_log` VALUES (55001, '65.50.15632619295978955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:25:30', 9, 0, '', '2019-07-16 15:25:30');
INSERT INTO `access_log` VALUES (55002, '65.47.15632619295978933', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:25:30', 10, 2001001000, '服务端发生异常', '2019-07-16 15:25:30');
INSERT INTO `access_log` VALUES (55003, '65.54.15632619296018879', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:25:30', 9, 0, '', '2019-07-16 15:25:30');
INSERT INTO `access_log` VALUES (55004, '65.3607.15632619626020743', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:26:03', 9, 0, '', '2019-07-16 15:26:03');
INSERT INTO `access_log` VALUES (55005, '65.49.15632619626078921', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:26:03', 16, 0, '', '2019-07-16 15:26:03');
INSERT INTO `access_log` VALUES (55006, '65.45.15632619626068933', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:26:03', 16, 2001001000, '服务端发生异常', '2019-07-16 15:26:03');
INSERT INTO `access_log` VALUES (55007, '59.77.15632621758526951', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:29:36', 3, 0, '', '2019-07-16 15:29:36');
INSERT INTO `access_log` VALUES (55008, '59.72.15632621758476959', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 15:29:36', 13, 2001001000, '服务端发生异常', '2019-07-16 15:29:36');
INSERT INTO `access_log` VALUES (55009, '59.79.15632646075986997', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.218.103.38', '2019-07-16 16:10:08', 11, 0, '', '2019-07-16 16:10:08');
INSERT INTO `access_log` VALUES (55010, '59.73.15632646075986999', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.218.103.38', '2019-07-16 16:10:08', 19, 2001001000, '服务端发生异常', '2019-07-16 16:10:08');
INSERT INTO `access_log` VALUES (55011, '65.45.15632646223158969', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.218.103.38', '2019-07-16 16:10:22', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 16:10:22');
INSERT INTO `access_log` VALUES (55012, '65.54.15632675880498955', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 16:59:48', 161, 1002001012, '访问令牌已过期', '2019-07-16 16:59:48');
INSERT INTO `access_log` VALUES (55013, '65.46.15632675880509085', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 16:59:48', 161, 1002001012, '访问令牌已过期', '2019-07-16 16:59:48');
INSERT INTO `access_log` VALUES (55014, '65.51.15632675880499079', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 16:59:48', 161, 1002001012, '访问令牌已过期', '2019-07-16 16:59:48');
INSERT INTO `access_log` VALUES (55015, '65.45.15632675907449009', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 16:59:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 16:59:51');
INSERT INTO `access_log` VALUES (55016, '65.49.15632675999149001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 17:00:00', 98, 0, '', '2019-07-16 17:00:00');
INSERT INTO `access_log` VALUES (55017, '65.52.15632676002349061', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 17:00:00', 12, 0, '', '2019-07-16 17:00:00');
INSERT INTO `access_log` VALUES (55018, '65.53.15632676002419031', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 17:00:00', 12, 2001001000, '服务端发生异常', '2019-07-16 17:00:00');
INSERT INTO `access_log` VALUES (55019, '65.47.15632676002549015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-16 17:00:00', 8, 0, '', '2019-07-16 17:00:00');
INSERT INTO `access_log` VALUES (55020, '59.78.15632676028647031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.79.235', '2019-07-16 17:00:03', 13, 2001001000, '服务端发生异常', '2019-07-16 17:00:03');
INSERT INTO `access_log` VALUES (55021, '59.73.15632676026977039', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.79.235', '2019-07-16 17:00:03', 498, 0, '', '2019-07-16 17:00:03');
INSERT INTO `access_log` VALUES (55022, '59.72.15632700555747065', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.66.200.39', '2019-07-16 17:40:56', 11, 0, '', '2019-07-16 17:40:56');
INSERT INTO `access_log` VALUES (55023, '59.71.15632700555747069', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.66.200.39', '2019-07-16 17:40:56', 15, 2001001000, '服务端发生异常', '2019-07-16 17:40:56');
INSERT INTO `access_log` VALUES (55024, '64.81.15632700661927251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.66.200.39', '2019-07-16 17:41:06', 11, 0, '', '2019-07-16 17:41:06');
INSERT INTO `access_log` VALUES (55025, '64.77.15632700663157255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.66.200.39', '2019-07-16 17:41:06', 3, 0, '', '2019-07-16 17:41:06');
INSERT INTO `access_log` VALUES (55026, '59.78.15632700766867065', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.66.200.39', '2019-07-16 17:41:17', 5, 0, '', '2019-07-16 17:41:17');
INSERT INTO `access_log` VALUES (55027, '59.79.15632700766867071', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.66.200.39', '2019-07-16 17:41:17', 18, 2001001000, '服务端发生异常', '2019-07-16 17:41:17');
INSERT INTO `access_log` VALUES (55028, '65.49.15632700866609035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-07-16 17:41:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 17:41:27');
INSERT INTO `access_log` VALUES (55029, '64.82.15632700868597279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.66.200.39', '2019-07-16 17:41:27', 2, 0, '', '2019-07-16 17:41:27');
INSERT INTO `access_log` VALUES (55030, '64.80.15632700869957277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.66.200.39', '2019-07-16 17:41:27', 1, 0, '', '2019-07-16 17:41:27');
INSERT INTO `access_log` VALUES (55031, '59.78.15632703394717069', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:45:39', 3, 0, '', '2019-07-16 17:45:39');
INSERT INTO `access_log` VALUES (55032, '59.79.15632703394717075', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:45:39', 13, 2001001000, '服务端发生异常', '2019-07-16 17:45:39');
INSERT INTO `access_log` VALUES (55033, '64.79.15632703440357271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:45:44', 2, 0, '', '2019-07-16 17:45:44');
INSERT INTO `access_log` VALUES (55034, '64.82.15632703441167283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:45:44', 2, 0, '', '2019-07-16 17:45:44');
INSERT INTO `access_log` VALUES (55035, '59.73.15632703478857077', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:45:48', 3, 0, '', '2019-07-16 17:45:48');
INSERT INTO `access_log` VALUES (55036, '59.80.15632703478867053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:45:48', 13, 2001001000, '服务端发生异常', '2019-07-16 17:45:48');
INSERT INTO `access_log` VALUES (55037, '65.3607.15632703599440859', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:46:00', 0, 1002001015, '账号未登陆', '2019-07-16 17:46:00');
INSERT INTO `access_log` VALUES (55038, '65.49.15632703599479039', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:46:00', 0, 1002001015, '账号未登陆', '2019-07-16 17:46:00');
INSERT INTO `access_log` VALUES (55039, '65.47.15632703599479053', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:46:00', 1, 1002001015, '账号未登陆', '2019-07-16 17:46:00');
INSERT INTO `access_log` VALUES (55040, '65.53.15632703668669069', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:46:07', 76, 0, '', '2019-07-16 17:46:07');
INSERT INTO `access_log` VALUES (55041, '65.52.15632703671269099', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:46:07', 11, 0, '', '2019-07-16 17:46:07');
INSERT INTO `access_log` VALUES (55042, '65.46.15632703671299125', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:46:07', 9, 0, '', '2019-07-16 17:46:07');
INSERT INTO `access_log` VALUES (55043, '65.50.15632703671289075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:46:07', 11, 2001001000, '服务端发生异常', '2019-07-16 17:46:07');
INSERT INTO `access_log` VALUES (55044, '65.51.15632703792329119', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:46:19', 11, 0, '', '2019-07-16 17:46:19');
INSERT INTO `access_log` VALUES (55045, '65.45.15632703792339049', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:46:19', 11, 2001001000, '服务端发生异常', '2019-07-16 17:46:19');
INSERT INTO `access_log` VALUES (55046, '65.47.15632703792379055', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 17:46:19', 9, 0, '', '2019-07-16 17:46:19');
INSERT INTO `access_log` VALUES (55047, '65.52.15632711698209111', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:30', 1, 1002001015, '账号未登陆', '2019-07-16 17:59:30');
INSERT INTO `access_log` VALUES (55048, '65.50.15632711698229087', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:30', 0, 1002001015, '账号未登陆', '2019-07-16 17:59:30');
INSERT INTO `access_log` VALUES (55049, '65.46.15632711698229137', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:30', 0, 1002001015, '账号未登陆', '2019-07-16 17:59:30');
INSERT INTO `access_log` VALUES (55050, '65.47.15632711699699067', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:30', 0, 1002001015, '账号未登陆', '2019-07-16 17:59:30');
INSERT INTO `access_log` VALUES (55051, '65.45.15632711699689061', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:30', 0, 1002001015, '账号未登陆', '2019-07-16 17:59:30');
INSERT INTO `access_log` VALUES (55052, '65.54.15632711699689007', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:30', 0, 1002001015, '账号未登陆', '2019-07-16 17:59:30');
INSERT INTO `access_log` VALUES (55053, '65.51.15632711729829131', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:33', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 17:59:33');
INSERT INTO `access_log` VALUES (55054, '59.79.15632711809297087', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.121.146', '2019-07-16 17:59:41', 3, 0, '', '2019-07-16 17:59:41');
INSERT INTO `access_log` VALUES (55055, '59.78.15632711809287081', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.121.146', '2019-07-16 17:59:41', 13, 2001001000, '服务端发生异常', '2019-07-16 17:59:41');
INSERT INTO `access_log` VALUES (55056, '65.54.15632711892349009', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:49', 79, 0, '', '2019-07-16 17:59:49');
INSERT INTO `access_log` VALUES (55057, '65.3607.15632711895560875', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:50', 10, 0, '', '2019-07-16 17:59:50');
INSERT INTO `access_log` VALUES (55058, '65.46.15632711895579141', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:50', 10, 0, '', '2019-07-16 17:59:50');
INSERT INTO `access_log` VALUES (55059, '65.49.15632711895569053', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:50', 11, 2001001000, '服务端发生异常', '2019-07-16 17:59:50');
INSERT INTO `access_log` VALUES (55060, '65.53.15632711897569085', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:50', 1, 1002001015, '账号未登陆', '2019-07-16 17:59:50');
INSERT INTO `access_log` VALUES (55061, '65.50.15632711897899089', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:50', 1, 1002001015, '账号未登陆', '2019-07-16 17:59:50');
INSERT INTO `access_log` VALUES (55062, '65.52.15632711897909115', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:50', 0, 1002001015, '账号未登陆', '2019-07-16 17:59:50');
INSERT INTO `access_log` VALUES (55063, '65.51.15632711939179133', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:54', 10, 0, '', '2019-07-16 17:59:54');
INSERT INTO `access_log` VALUES (55064, '65.47.15632711939169069', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:54', 9, 0, '', '2019-07-16 17:59:54');
INSERT INTO `access_log` VALUES (55065, '65.45.15632711939169063', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:54', 10, 2001001000, '服务端发生异常', '2019-07-16 17:59:54');
INSERT INTO `access_log` VALUES (55066, '65.49.15632711940309055', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:54', 0, 1002001015, '账号未登陆', '2019-07-16 17:59:54');
INSERT INTO `access_log` VALUES (55067, '65.3607.15632711941350877', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:54', 0, 1002001015, '账号未登陆', '2019-07-16 17:59:54');
INSERT INTO `access_log` VALUES (55068, '65.46.15632711941369143', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.204.236.208', '2019-07-16 17:59:54', 0, 1002001015, '账号未登陆', '2019-07-16 17:59:54');
INSERT INTO `access_log` VALUES (55069, '65.53.15632712037109087', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.121.146', '2019-07-16 18:00:04', 1, 1002001015, '账号未登陆', '2019-07-16 18:00:04');
INSERT INTO `access_log` VALUES (55070, '65.50.15632712037279091', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.121.146', '2019-07-16 18:00:04', 0, 1002001015, '账号未登陆', '2019-07-16 18:00:04');
INSERT INTO `access_log` VALUES (55071, '65.52.15632712037349117', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.121.146', '2019-07-16 18:00:04', 0, 1002001015, '账号未登陆', '2019-07-16 18:00:04');
INSERT INTO `access_log` VALUES (55072, '65.54.15632712055999013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.121.146', '2019-07-16 18:00:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 18:00:06');
INSERT INTO `access_log` VALUES (55073, '65.45.15632712188029065', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.121.146', '2019-07-16 18:00:19', 108, 0, '', '2019-07-16 18:00:19');
INSERT INTO `access_log` VALUES (55074, '65.49.15632712192349057', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.121.146', '2019-07-16 18:00:19', 9, 2001001000, '服务端发生异常', '2019-07-16 18:00:19');
INSERT INTO `access_log` VALUES (55075, '65.46.15632712192379145', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.121.146', '2019-07-16 18:00:19', 8, 0, '', '2019-07-16 18:00:19');
INSERT INTO `access_log` VALUES (55076, '65.51.15632712192269135', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '122.224.121.146', '2019-07-16 18:00:19', 36, 0, '', '2019-07-16 18:00:19');
INSERT INTO `access_log` VALUES (55077, '59.79.15632720495867099', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:10', 3, 0, '', '2019-07-16 18:14:10');
INSERT INTO `access_log` VALUES (55078, '59.78.15632720495877093', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:10', 19, 2001001000, '服务端发生异常', '2019-07-16 18:14:10');
INSERT INTO `access_log` VALUES (55079, '64.84.15632720556227287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:16', 131, 0, '', '2019-07-16 18:14:16');
INSERT INTO `access_log` VALUES (55080, '64.83.15632720559317291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:16', 2, 0, '', '2019-07-16 18:14:16');
INSERT INTO `access_log` VALUES (55081, '66.51.15632720727485051', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=19901637004&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:33', 18, 1001003000, '验证码不存在', '2019-07-16 18:14:33');
INSERT INTO `access_log` VALUES (55082, '66.54.15632720757405027', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=19901637004', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:36', 88, 0, '', '2019-07-16 18:14:36');
INSERT INTO `access_log` VALUES (55083, '66.56.15632720795565035', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=19901637004&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:40', 162, 0, '', '2019-07-16 18:14:40');
INSERT INTO `access_log` VALUES (55084, '64.82.15632720860487307', 172, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:46', 4, 0, '', '2019-07-16 18:14:46');
INSERT INTO `access_log` VALUES (55085, '64.76.15632720861607291', 172, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:46', 4, 0, '', '2019-07-16 18:14:46');
INSERT INTO `access_log` VALUES (55086, '64.78.15632720874097301', 172, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:47', 5, 0, '', '2019-07-16 18:14:47');
INSERT INTO `access_log` VALUES (55087, '64.83.15632720881897293', 172, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:48', 6, 0, '', '2019-07-16 18:14:48');
INSERT INTO `access_log` VALUES (55088, '64.77.15632720919797285', 172, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:52', 5, 0, '', '2019-07-16 18:14:52');
INSERT INTO `access_log` VALUES (55089, '64.79.15632720920777297', 172, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:52', 4, 0, '', '2019-07-16 18:14:52');
INSERT INTO `access_log` VALUES (55090, '66.48.15632720935335033', 172, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:54', 7, 0, '', '2019-07-16 18:14:54');
INSERT INTO `access_log` VALUES (55091, '66.52.15632720990085013', 172, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:14:59', 5, 0, '', '2019-07-16 18:14:59');
INSERT INTO `access_log` VALUES (55092, '59.77.15632721022657087', 172, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '124.78.7.165', '2019-07-16 18:15:02', 13, 0, '', '2019-07-16 18:15:02');
INSERT INTO `access_log` VALUES (55093, '65.3607.15632731660010905', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 18:32:46', 14, 0, '', '2019-07-16 18:32:46');
INSERT INTO `access_log` VALUES (55094, '65.50.15632731660029119', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 18:32:46', 16, 2001001000, '服务端发生异常', '2019-07-16 18:32:46');
INSERT INTO `access_log` VALUES (55095, '65.53.15632731660029115', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12) AppleWebKit/602.1.50 (KHTML, like Gecko) Version/10.0 Safari/602.1.50', '36.5.74.131', '2019-07-16 18:32:46', 16, 0, '', '2019-07-16 18:32:46');
INSERT INTO `access_log` VALUES (55096, '65.54.15632731869049041', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.5.74.131', '2019-07-16 18:33:07', 0, 1002001015, '账号未登陆', '2019-07-16 18:33:07');
INSERT INTO `access_log` VALUES (55097, '65.47.15632731869099099', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.5.74.131', '2019-07-16 18:33:07', 1, 1002001015, '账号未登陆', '2019-07-16 18:33:07');
INSERT INTO `access_log` VALUES (55098, '65.45.15632731869119093', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.5.74.131', '2019-07-16 18:33:07', 0, 1002001015, '账号未登陆', '2019-07-16 18:33:07');
INSERT INTO `access_log` VALUES (55099, '65.49.15632731893549085', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.5.74.131', '2019-07-16 18:33:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 18:33:09');
INSERT INTO `access_log` VALUES (55100, '65.50.15632732072059121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.5.74.131', '2019-07-16 18:33:27', 68, 0, '', '2019-07-16 18:33:27');
INSERT INTO `access_log` VALUES (55101, '65.53.15632732074949117', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.5.74.131', '2019-07-16 18:33:27', 17, 0, '', '2019-07-16 18:33:28');
INSERT INTO `access_log` VALUES (55102, '65.52.15632732075059147', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.5.74.131', '2019-07-16 18:33:28', 10, 0, '', '2019-07-16 18:33:28');
INSERT INTO `access_log` VALUES (55103, '65.3607.15632732074960907', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.5.74.131', '2019-07-16 18:33:27', 18, 2001001000, '服务端发生异常', '2019-07-16 18:33:28');
INSERT INTO `access_log` VALUES (55104, '65.49.15632760543399125', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '175.167.154.247', '2019-07-16 19:20:54', 0, 1002001015, '账号未登陆', '2019-07-16 19:20:54');
INSERT INTO `access_log` VALUES (55105, '65.51.15632760543409203', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '175.167.154.247', '2019-07-16 19:20:54', 0, 1002001015, '账号未登陆', '2019-07-16 19:20:54');
INSERT INTO `access_log` VALUES (55106, '65.52.15632760543559185', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '175.167.154.247', '2019-07-16 19:20:54', 3, 1002001015, '账号未登陆', '2019-07-16 19:20:54');
INSERT INTO `access_log` VALUES (55107, '65.50.15632760615549159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '175.167.154.247', '2019-07-16 19:21:02', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 19:21:02');
INSERT INTO `access_log` VALUES (55108, '65.45.15632760664359135', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '175.167.154.247', '2019-07-16 19:21:06', 303, 0, '', '2019-07-16 19:21:07');
INSERT INTO `access_log` VALUES (55109, '65.47.15632760670869141', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '175.167.154.247', '2019-07-16 19:21:07', 11, 0, '', '2019-07-16 19:21:07');
INSERT INTO `access_log` VALUES (55110, '65.54.15632760670989083', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '175.167.154.247', '2019-07-16 19:21:07', 10, 2001001000, '服务端发生异常', '2019-07-16 19:21:07');
INSERT INTO `access_log` VALUES (55111, '65.46.15632760671089215', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '175.167.154.247', '2019-07-16 19:21:07', 10, 0, '', '2019-07-16 19:21:07');
INSERT INTO `access_log` VALUES (55112, '65.3607.15632760751910947', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '175.167.154.247', '2019-07-16 19:21:15', 10, 0, '', '2019-07-16 19:21:15');
INSERT INTO `access_log` VALUES (55113, '65.49.15632760751969127', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '175.167.154.247', '2019-07-16 19:21:15', 9, 0, '', '2019-07-16 19:21:15');
INSERT INTO `access_log` VALUES (55114, '65.51.15632760751969205', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '175.167.154.247', '2019-07-16 19:21:15', 11, 2001001000, '服务端发生异常', '2019-07-16 19:21:15');
INSERT INTO `access_log` VALUES (55115, '59.76.15632761073377145', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '175.167.154.247', '2019-07-16 19:21:47', 10, 0, '', '2019-07-16 19:21:47');
INSERT INTO `access_log` VALUES (55116, '59.75.15632761073417161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '175.167.154.247', '2019-07-16 19:21:47', 15, 2001001000, '服务端发生异常', '2019-07-16 19:21:47');
INSERT INTO `access_log` VALUES (55117, '65.47.15632783630869173', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-16 19:59:23', 13, 1002001012, '访问令牌已过期', '2019-07-16 19:59:23');
INSERT INTO `access_log` VALUES (55118, '65.45.15632783630869167', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-16 19:59:23', 20, 1002001012, '访问令牌已过期', '2019-07-16 19:59:23');
INSERT INTO `access_log` VALUES (55119, '65.54.15632783630869115', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-16 19:59:23', 19, 1002001012, '访问令牌已过期', '2019-07-16 19:59:23');
INSERT INTO `access_log` VALUES (55120, '65.53.15632783752539189', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-16 19:59:35', 177, 0, '', '2019-07-16 19:59:35');
INSERT INTO `access_log` VALUES (55121, '65.51.15632783757679237', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-16 19:59:36', 10, 0, '', '2019-07-16 19:59:36');
INSERT INTO `access_log` VALUES (55122, '65.3607.15632783757670979', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-16 19:59:36', 10, 2001001000, '服务端发生异常', '2019-07-16 19:59:36');
INSERT INTO `access_log` VALUES (55123, '65.49.15632783757709159', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-07-16 19:59:36', 9, 0, '', '2019-07-16 19:59:36');
INSERT INTO `access_log` VALUES (55124, '59.74.15632817007427233', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.205.170.23', '2019-07-16 20:55:01', 10, 0, '', '2019-07-16 20:55:01');
INSERT INTO `access_log` VALUES (55125, '59.79.15632817007427229', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.205.170.23', '2019-07-16 20:55:01', 16, 2001001000, '服务端发生异常', '2019-07-16 20:55:01');
INSERT INTO `access_log` VALUES (55126, '64.80.15632817071137435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.205.170.23', '2019-07-16 20:55:07', 10, 0, '', '2019-07-16 20:55:07');
INSERT INTO `access_log` VALUES (55127, '64.76.15632817072997421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.205.170.23', '2019-07-16 20:55:07', 3, 0, '', '2019-07-16 20:55:07');
INSERT INTO `access_log` VALUES (55128, '64.85.15632817145437443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.205.170.23', '2019-07-16 20:55:15', 2, 0, '', '2019-07-16 20:55:15');
INSERT INTO `access_log` VALUES (55129, '64.78.15632817148337431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.205.170.23', '2019-07-16 20:55:15', 2, 0, '', '2019-07-16 20:55:15');
INSERT INTO `access_log` VALUES (55130, '64.84.15632817200187419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.205.170.23', '2019-07-16 20:55:20', 2, 0, '', '2019-07-16 20:55:20');
INSERT INTO `access_log` VALUES (55131, '64.83.15632817201167423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.205.170.23', '2019-07-16 20:55:20', 2, 0, '', '2019-07-16 20:55:20');
INSERT INTO `access_log` VALUES (55132, '59.75.15632817333707237', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.205.170.23', '2019-07-16 20:55:33', 3, 0, '', '2019-07-16 20:55:33');
INSERT INTO `access_log` VALUES (55133, '59.80.15632817333707207', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.205.170.23', '2019-07-16 20:55:33', 13, 2001001000, '服务端发生异常', '2019-07-16 20:55:33');
INSERT INTO `access_log` VALUES (55134, '59.77.15632859484117273', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.194.165.65', '2019-07-16 22:05:48', 11, 0, '', '2019-07-16 22:05:48');
INSERT INTO `access_log` VALUES (55135, '59.72.15632859484127281', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.194.165.65', '2019-07-16 22:05:48', 20, 2001001000, '服务端发生异常', '2019-07-16 22:05:48');
INSERT INTO `access_log` VALUES (55136, '65.54.15632859573789217', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.194.165.65', '2019-07-16 22:05:57', 0, 1002001015, '账号未登陆', '2019-07-16 22:05:57');
INSERT INTO `access_log` VALUES (55137, '65.46.15632859573789349', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.194.165.65', '2019-07-16 22:05:57', 0, 1002001015, '账号未登陆', '2019-07-16 22:05:57');
INSERT INTO `access_log` VALUES (55138, '65.53.15632859573999291', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.194.165.65', '2019-07-16 22:05:57', 1, 1002001015, '账号未登陆', '2019-07-16 22:05:57');
INSERT INTO `access_log` VALUES (55139, '65.45.15632860401429271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.194.165.65', '2019-07-16 22:07:20', 58, 0, '', '2019-07-16 22:07:20');
INSERT INTO `access_log` VALUES (55140, '65.47.15632860406899277', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.194.165.65', '2019-07-16 22:07:21', 13, 0, '', '2019-07-16 22:07:21');
INSERT INTO `access_log` VALUES (55141, '65.54.15632860406919219', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.194.165.65', '2019-07-16 22:07:21', 11, 0, '', '2019-07-16 22:07:21');
INSERT INTO `access_log` VALUES (55142, '65.53.15632860406899293', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.194.165.65', '2019-07-16 22:07:21', 14, 2001001000, '服务端发生异常', '2019-07-16 22:07:21');
INSERT INTO `access_log` VALUES (55143, '65.54.15632900422709277', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.154.70.242', '2019-07-16 23:14:02', 0, 1002001015, '账号未登陆', '2019-07-16 23:14:02');
INSERT INTO `access_log` VALUES (55144, '65.53.15632900422719349', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.154.70.242', '2019-07-16 23:14:02', 0, 1002001015, '账号未登陆', '2019-07-16 23:14:02');
INSERT INTO `access_log` VALUES (55145, '65.50.15632900422719351', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.154.70.242', '2019-07-16 23:14:02', 1, 1002001015, '账号未登陆', '2019-07-16 23:14:02');
INSERT INTO `access_log` VALUES (55146, '65.51.15632900458669397', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.154.70.242', '2019-07-16 23:14:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-16 23:14:06');
INSERT INTO `access_log` VALUES (55147, '59.79.15632914995027361', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.131.110.25', '2019-07-16 23:38:20', 9, 0, '', '2019-07-16 23:38:20');
INSERT INTO `access_log` VALUES (55148, '59.74.15632914996997365', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.131.110.99', '2019-07-16 23:38:20', 17, 2001001000, '服务端发生异常', '2019-07-16 23:38:20');
INSERT INTO `access_log` VALUES (55149, '59.75.15632915379687369', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.131.110.99', '2019-07-16 23:38:58', 4, 0, '', '2019-07-16 23:38:58');
INSERT INTO `access_log` VALUES (55150, '59.80.15632915379687339', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '183.131.110.25', '2019-07-16 23:38:58', 23, 2001001000, '服务端发生异常', '2019-07-16 23:38:58');
INSERT INTO `access_log` VALUES (55151, '65.46.15632933937559451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.87.104.8', '2019-07-17 00:09:54', 14, 1002002001, '密码不正确', '2019-07-17 00:09:54');
INSERT INTO `access_log` VALUES (55152, '59.76.15633197362217729', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:28:56', 13, 0, '', '2019-07-17 07:28:56');
INSERT INTO `access_log` VALUES (55153, '59.72.15633197362217733', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:28:56', 33, 2001001000, '服务端发生异常', '2019-07-17 07:28:56');
INSERT INTO `access_log` VALUES (55154, '64.76.15633197453087929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:29:05', 13, 0, '', '2019-07-17 07:29:05');
INSERT INTO `access_log` VALUES (55155, '64.78.15633197455247939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:29:06', 3, 0, '', '2019-07-17 07:29:06');
INSERT INTO `access_log` VALUES (55156, '64.84.15633197491307927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:29:09', 2, 0, '', '2019-07-17 07:29:09');
INSERT INTO `access_log` VALUES (55157, '64.83.15633197503487931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:29:10', 2, 0, '', '2019-07-17 07:29:10');
INSERT INTO `access_log` VALUES (55158, '66.49.15633197755955669', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13256189181&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:29:36', 16, 1001003000, '验证码不存在', '2019-07-17 07:29:36');
INSERT INTO `access_log` VALUES (55159, '66.57.15633197777695667', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13256189181', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:29:38', 106, 0, '', '2019-07-17 07:29:38');
INSERT INTO `access_log` VALUES (55160, '66.52.15633197803225651', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13256189181&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:29:40', 198, 0, '', '2019-07-17 07:29:41');
INSERT INTO `access_log` VALUES (55161, '66.53.15633199524255665', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13256189181&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:32:32', 9, 1001003002, '验证码已使用', '2019-07-17 07:32:32');
INSERT INTO `access_log` VALUES (55162, '66.50.15633199567945661', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13256189181', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:32:37', 70, 0, '', '2019-07-17 07:32:37');
INSERT INTO `access_log` VALUES (55163, '66.54.15633199590125669', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13256189181&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:32:39', 482, 0, '', '2019-07-17 07:32:39');
INSERT INTO `access_log` VALUES (55164, '65.52.15633200187019781', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:33:39', 1, 1002001015, '账号未登陆', '2019-07-17 07:33:39');
INSERT INTO `access_log` VALUES (55165, '65.47.15633200187029733', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:33:39', 1, 1002001015, '账号未登陆', '2019-07-17 07:33:39');
INSERT INTO `access_log` VALUES (55166, '65.45.15633200187029729', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:33:39', 1, 1002001015, '账号未登陆', '2019-07-17 07:33:39');
INSERT INTO `access_log` VALUES (55167, '65.46.15633200218929807', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:33:42', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 07:33:42');
INSERT INTO `access_log` VALUES (55168, '65.49.15633200452659723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:34:05', 97, 0, '', '2019-07-17 07:34:05');
INSERT INTO `access_log` VALUES (55169, '65.51.15633200457789799', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:34:06', 17, 0, '', '2019-07-17 07:34:06');
INSERT INTO `access_log` VALUES (55170, '65.50.15633200457769751', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:34:06', 23, 0, '', '2019-07-17 07:34:06');
INSERT INTO `access_log` VALUES (55171, '65.53.15633200457779751', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:34:06', 22, 2001001000, '服务端发生异常', '2019-07-17 07:34:06');
INSERT INTO `access_log` VALUES (55172, '65.47.15633200530749735', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:34:13', 11, 2001001000, '服务端发生异常', '2019-07-17 07:34:13');
INSERT INTO `access_log` VALUES (55173, '65.3607.15633200530771543', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:34:13', 9, 0, '', '2019-07-17 07:34:13');
INSERT INTO `access_log` VALUES (55174, '65.45.15633200530779731', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/607.2.6 (KHTML, like Gecko) Mobile/16F203 QHBrowser/317 QihooBrowser/4.0.10', '119.164.200.189', '2019-07-17 07:34:13', 11, 0, '', '2019-07-17 07:34:13');
INSERT INTO `access_log` VALUES (55175, '65.50.15633250633109819', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.25.32.210', '2019-07-17 08:57:43', 13, 1002001012, '访问令牌已过期', '2019-07-17 08:57:43');
INSERT INTO `access_log` VALUES (55176, '65.53.15633250633119819', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.25.32.210', '2019-07-17 08:57:43', 15, 1002001012, '访问令牌已过期', '2019-07-17 08:57:43');
INSERT INTO `access_log` VALUES (55177, '65.52.15633250633289851', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.25.32.210', '2019-07-17 08:57:43', 13, 1002001012, '访问令牌已过期', '2019-07-17 08:57:43');
INSERT INTO `access_log` VALUES (55178, '65.3607.15633250656561611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.25.32.210', '2019-07-17 08:57:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 08:57:46');
INSERT INTO `access_log` VALUES (55179, '65.47.15633250785979803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=test&password=test&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.25.32.210', '2019-07-17 08:57:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 5-16 位\n密码长度为 6-16 位', '2019-07-17 08:57:59');
INSERT INTO `access_log` VALUES (55180, '65.46.15633252333719879', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.118.83', '2019-07-17 09:00:33', 5, 1002001012, '访问令牌已过期', '2019-07-17 09:00:33');
INSERT INTO `access_log` VALUES (55181, '65.54.15633252333779751', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.118.83', '2019-07-17 09:00:33', 3, 1002001012, '访问令牌已过期', '2019-07-17 09:00:33');
INSERT INTO `access_log` VALUES (55182, '65.49.15633252333849795', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.118.83', '2019-07-17 09:00:33', 3, 1002001012, '访问令牌已过期', '2019-07-17 09:00:33');
INSERT INTO `access_log` VALUES (55183, '65.51.15633252385589871', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.118.83', '2019-07-17 09:00:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 09:00:39');
INSERT INTO `access_log` VALUES (55184, '59.79.15633255230627819', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:05:23', 10, 0, '', '2019-07-17 09:05:23');
INSERT INTO `access_log` VALUES (55185, '59.74.15633255230637823', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:05:23', 16, 2001001000, '服务端发生异常', '2019-07-17 09:05:23');
INSERT INTO `access_log` VALUES (55186, '65.53.15633255258189827', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:05:26', 51, 1002001012, '访问令牌已过期', '2019-07-17 09:05:26');
INSERT INTO `access_log` VALUES (55187, '65.52.15633255258249859', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:05:26', 46, 1002001012, '访问令牌已过期', '2019-07-17 09:05:26');
INSERT INTO `access_log` VALUES (55188, '65.50.15633255258149827', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:05:26', 56, 1002001012, '访问令牌已过期', '2019-07-17 09:05:26');
INSERT INTO `access_log` VALUES (55189, '65.3607.15633255370071619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:05:37', 74, 0, '', '2019-07-17 09:05:37');
INSERT INTO `access_log` VALUES (55190, '65.45.15633255373019807', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:05:37', 10, 0, '', '2019-07-17 09:05:37');
INSERT INTO `access_log` VALUES (55191, '65.47.15633255373049811', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:05:37', 9, 2001001000, '服务端发生异常', '2019-07-17 09:05:37');
INSERT INTO `access_log` VALUES (55192, '65.54.15633255373079757', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:05:37', 8, 0, '', '2019-07-17 09:05:37');
INSERT INTO `access_log` VALUES (55193, '64.78.15633257584198021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:09:18', 15, 0, '', '2019-07-17 09:09:18');
INSERT INTO `access_log` VALUES (55194, '64.84.15633257585218009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:09:19', 3, 0, '', '2019-07-17 09:09:19');
INSERT INTO `access_log` VALUES (55195, '64.83.15633257593588013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:09:19', 2, 0, '', '2019-07-17 09:09:19');
INSERT INTO `access_log` VALUES (55196, '64.81.15633257597988001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:09:20', 2, 0, '', '2019-07-17 09:09:20');
INSERT INTO `access_log` VALUES (55197, '64.77.15633257601088005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:09:20', 2, 0, '', '2019-07-17 09:09:20');
INSERT INTO `access_log` VALUES (55198, '64.79.15633257603688017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.60.232', '2019-07-17 09:09:20', 3, 0, '', '2019-07-17 09:09:20');
INSERT INTO `access_log` VALUES (55199, '59.77.15633263655957817', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.17.202', '2019-07-17 09:19:26', 4, 0, '', '2019-07-17 09:19:26');
INSERT INTO `access_log` VALUES (55200, '59.71.15633263656057829', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.17.202', '2019-07-17 09:19:26', 17, 2001001000, '服务端发生异常', '2019-07-17 09:19:26');
INSERT INTO `access_log` VALUES (55201, '65.54.15633263813819769', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.17.202', '2019-07-17 09:19:41', 0, 1002001015, '账号未登陆', '2019-07-17 09:19:41');
INSERT INTO `access_log` VALUES (55202, '65.45.15633263813819819', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.17.202', '2019-07-17 09:19:41', 0, 1002001015, '账号未登陆', '2019-07-17 09:19:41');
INSERT INTO `access_log` VALUES (55203, '65.47.15633263813829823', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.17.202', '2019-07-17 09:19:41', 0, 1002001015, '账号未登陆', '2019-07-17 09:19:41');
INSERT INTO `access_log` VALUES (55204, '65.47.15633265206269825', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.17.202', '2019-07-17 09:22:01', 86, 0, '', '2019-07-17 09:22:01');
INSERT INTO `access_log` VALUES (55205, '65.49.15633265218469815', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.17.202', '2019-07-17 09:22:02', 10, 0, '', '2019-07-17 09:22:02');
INSERT INTO `access_log` VALUES (55206, '65.46.15633265219259899', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.17.202', '2019-07-17 09:22:02', 10, 2001001000, '服务端发生异常', '2019-07-17 09:22:02');
INSERT INTO `access_log` VALUES (55207, '65.51.15633265223659891', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.17.202', '2019-07-17 09:22:02', 17, 0, '', '2019-07-17 09:22:02');
INSERT INTO `access_log` VALUES (55208, '65.53.15633265358719843', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.17.202', '2019-07-17 09:22:16', 9, 0, '', '2019-07-17 09:22:16');
INSERT INTO `access_log` VALUES (55209, '65.50.15633265359459843', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.17.202', '2019-07-17 09:22:16', 11, 2001001000, '服务端发生异常', '2019-07-17 09:22:16');
INSERT INTO `access_log` VALUES (55210, '65.3607.15633265360251635', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.64.17.202', '2019-07-17 09:22:16', 10, 0, '', '2019-07-17 09:22:16');
INSERT INTO `access_log` VALUES (55211, '65.54.15633290869429807', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '59.63.224.118', '2019-07-17 10:04:47', 0, 1002001015, '账号未登陆', '2019-07-17 10:04:47');
INSERT INTO `access_log` VALUES (55212, '65.45.15633290869429857', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '59.63.224.118', '2019-07-17 10:04:47', 0, 1002001015, '账号未登陆', '2019-07-17 10:04:47');
INSERT INTO `access_log` VALUES (55213, '65.47.15633290869439861', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '59.63.224.118', '2019-07-17 10:04:47', 0, 1002001015, '账号未登陆', '2019-07-17 10:04:47');
INSERT INTO `access_log` VALUES (55214, '65.49.15633290905069851', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '59.63.224.118', '2019-07-17 10:04:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 10:04:51');
INSERT INTO `access_log` VALUES (55215, '65.51.15633291044959927', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '59.63.224.118', '2019-07-17 10:05:04', 79, 0, '', '2019-07-17 10:05:05');
INSERT INTO `access_log` VALUES (55216, '65.52.15633291048739911', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '59.63.224.118', '2019-07-17 10:05:05', 15, 0, '', '2019-07-17 10:05:05');
INSERT INTO `access_log` VALUES (55217, '65.53.15633291048759879', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '59.63.224.118', '2019-07-17 10:05:05', 14, 2001001000, '服务端发生异常', '2019-07-17 10:05:05');
INSERT INTO `access_log` VALUES (55218, '65.50.15633291048789879', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '59.63.224.118', '2019-07-17 10:05:05', 14, 0, '', '2019-07-17 10:05:05');
INSERT INTO `access_log` VALUES (55219, '65.54.15633298872209819', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.216.207.218', '2019-07-17 10:18:07', 0, 1002001015, '账号未登陆', '2019-07-17 10:18:07');
INSERT INTO `access_log` VALUES (55220, '65.47.15633298872239873', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.216.207.218', '2019-07-17 10:18:07', 1, 1002001015, '账号未登陆', '2019-07-17 10:18:07');
INSERT INTO `access_log` VALUES (55221, '65.49.15633298872249863', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.216.207.218', '2019-07-17 10:18:07', 0, 1002001015, '账号未登陆', '2019-07-17 10:18:07');
INSERT INTO `access_log` VALUES (55222, '65.51.15633298892479939', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.216.207.218', '2019-07-17 10:18:09', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 10:18:09');
INSERT INTO `access_log` VALUES (55223, '65.53.15633298920069891', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.216.207.218', '2019-07-17 10:18:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 10:18:12');
INSERT INTO `access_log` VALUES (55224, '65.52.15633298925079923', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.216.207.218', '2019-07-17 10:18:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 10:18:13');
INSERT INTO `access_log` VALUES (55225, '65.3607.15633299044761683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.216.207.218', '2019-07-17 10:18:24', 142, 0, '', '2019-07-17 10:18:25');
INSERT INTO `access_log` VALUES (55226, '65.45.15633299048379871', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.216.207.218', '2019-07-17 10:18:25', 11, 0, '', '2019-07-17 10:18:25');
INSERT INTO `access_log` VALUES (55227, '65.49.15633299048379865', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.216.207.218', '2019-07-17 10:18:25', 19, 2001001000, '服务端发生异常', '2019-07-17 10:18:25');
INSERT INTO `access_log` VALUES (55228, '65.47.15633299048419875', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.216.207.218', '2019-07-17 10:18:25', 17, 0, '', '2019-07-17 10:18:25');
INSERT INTO `access_log` VALUES (55229, '59.72.15633315404987895', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '1.80.92.82', '2019-07-17 10:45:40', 17, 0, '', '2019-07-17 10:45:41');
INSERT INTO `access_log` VALUES (55230, '59.76.15633315404997891', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '1.80.92.82', '2019-07-17 10:45:40', 24, 2001001000, '服务端发生异常', '2019-07-17 10:45:41');
INSERT INTO `access_log` VALUES (55231, '64.83.15633315459828091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '1.80.92.82', '2019-07-17 10:45:46', 13, 0, '', '2019-07-17 10:45:46');
INSERT INTO `access_log` VALUES (55232, '64.81.15633315461068079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '1.80.92.82', '2019-07-17 10:45:46', 3, 0, '', '2019-07-17 10:45:46');
INSERT INTO `access_log` VALUES (55233, '64.79.15633315515448095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '1.80.92.82', '2019-07-17 10:45:52', 2, 0, '', '2019-07-17 10:45:52');
INSERT INTO `access_log` VALUES (55234, '64.82.15633315516628107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '1.80.92.82', '2019-07-17 10:45:52', 2, 0, '', '2019-07-17 10:45:52');
INSERT INTO `access_log` VALUES (55235, '59.78.15633322042647903', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:56:44', 11, 0, '', '2019-07-17 10:56:44');
INSERT INTO `access_log` VALUES (55236, '59.73.15633322042647911', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:56:44', 25, 2001001000, '服务端发生异常', '2019-07-17 10:56:44');
INSERT INTO `access_log` VALUES (55237, '64.78.15633322099878109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:56:50', 4, 0, '', '2019-07-17 10:56:50');
INSERT INTO `access_log` VALUES (55238, '64.84.15633322102458097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:56:50', 2, 0, '', '2019-07-17 10:56:50');
INSERT INTO `access_log` VALUES (55239, '59.80.15633322121277887', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:56:52', 2, 0, '', '2019-07-17 10:56:52');
INSERT INTO `access_log` VALUES (55240, '59.72.15633322121277905', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:56:52', 16, 2001001000, '服务端发生异常', '2019-07-17 10:56:52');
INSERT INTO `access_log` VALUES (55241, '64.81.15633322246298089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:57:05', 2, 0, '', '2019-07-17 10:57:05');
INSERT INTO `access_log` VALUES (55242, '64.77.15633322247048093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:57:05', 2, 0, '', '2019-07-17 10:57:05');
INSERT INTO `access_log` VALUES (55243, '64.82.15633322261798117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:57:06', 2, 0, '', '2019-07-17 10:57:06');
INSERT INTO `access_log` VALUES (55244, '64.80.15633322269148115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:57:07', 3, 0, '', '2019-07-17 10:57:07');
INSERT INTO `access_log` VALUES (55245, '64.76.15633322276198101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:57:08', 2, 0, '', '2019-07-17 10:57:08');
INSERT INTO `access_log` VALUES (55246, '64.85.15633322283698123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:57:08', 2, 0, '', '2019-07-17 10:57:08');
INSERT INTO `access_log` VALUES (55247, '64.78.15633322285078111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:57:09', 2, 0, '', '2019-07-17 10:57:09');
INSERT INTO `access_log` VALUES (55248, '64.84.15633322288828099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:57:09', 2, 0, '', '2019-07-17 10:57:09');
INSERT INTO `access_log` VALUES (55249, '64.83.15633322295628103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:57:10', 2, 0, '', '2019-07-17 10:57:10');
INSERT INTO `access_log` VALUES (55250, '64.81.15633322299308091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.229.244.147', '2019-07-17 10:57:10', 2, 0, '', '2019-07-17 10:57:10');
INSERT INTO `access_log` VALUES (55251, '59.75.15633351784597957', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.163.242', '2019-07-17 11:46:18', 10, 0, '', '2019-07-17 11:46:18');
INSERT INTO `access_log` VALUES (55252, '59.80.15633351784667927', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.163.242', '2019-07-17 11:46:18', 17, 2001001000, '服务端发生异常', '2019-07-17 11:46:18');
INSERT INTO `access_log` VALUES (55253, '65.52.15633351883689995', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.163.242', '2019-07-17 11:46:28', 1, 1002001015, '账号未登陆', '2019-07-17 11:46:28');
INSERT INTO `access_log` VALUES (55254, '65.53.15633351883679963', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.163.242', '2019-07-17 11:46:28', 0, 1002001015, '账号未登陆', '2019-07-17 11:46:28');
INSERT INTO `access_log` VALUES (55255, '65.50.15633351883789963', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.163.242', '2019-07-17 11:46:28', 0, 1002001015, '账号未登陆', '2019-07-17 11:46:28');
INSERT INTO `access_log` VALUES (55256, '65.3607.15633351904821755', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.163.242', '2019-07-17 11:46:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 11:46:30');
INSERT INTO `access_log` VALUES (55257, '65.47.15633351976059947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.163.242', '2019-07-17 11:46:38', 57, 0, '', '2019-07-17 11:46:38');
INSERT INTO `access_log` VALUES (55258, '65.45.15633351978989941', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.163.242', '2019-07-17 11:46:38', 11, 0, '', '2019-07-17 11:46:38');
INSERT INTO `access_log` VALUES (55259, '65.49.15633351979269937', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.163.242', '2019-07-17 11:46:38', 11, 0, '', '2019-07-17 11:46:38');
INSERT INTO `access_log` VALUES (55260, '65.54.15633351979269893', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.163.242', '2019-07-17 11:46:38', 11, 2001001000, '服务端发生异常', '2019-07-17 11:46:38');
INSERT INTO `access_log` VALUES (55261, '65.46.15633366949860041', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:11:35', 0, 1002001015, '账号未登陆', '2019-07-17 12:11:35');
INSERT INTO `access_log` VALUES (55262, '65.50.15633366949879985', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:11:35', 0, 1002001015, '账号未登陆', '2019-07-17 12:11:35');
INSERT INTO `access_log` VALUES (55263, '65.51.15633366949860033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:11:35', 0, 1002001015, '账号未登陆', '2019-07-17 12:11:35');
INSERT INTO `access_log` VALUES (55264, '65.53.15633366990859985', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:11:39', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 12:11:39');
INSERT INTO `access_log` VALUES (55265, '65.3607.15633367074421777', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:11:47', 78, 0, '', '2019-07-17 12:11:48');
INSERT INTO `access_log` VALUES (55266, '65.47.15633367081109969', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:11:48', 9, 0, '', '2019-07-17 12:11:48');
INSERT INTO `access_log` VALUES (55267, '65.54.15633367081129915', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:11:48', 9, 0, '', '2019-07-17 12:11:48');
INSERT INTO `access_log` VALUES (55268, '65.45.15633367081109963', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:11:48', 11, 2001001000, '服务端发生异常', '2019-07-17 12:11:48');
INSERT INTO `access_log` VALUES (55269, '65.46.15633367187710043', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:11:59', 9, 0, '', '2019-07-17 12:11:59');
INSERT INTO `access_log` VALUES (55270, '65.50.15633367187759987', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:11:59', 8, 0, '', '2019-07-17 12:11:59');
INSERT INTO `access_log` VALUES (55271, '65.51.15633367187740035', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:11:59', 9, 2001001000, '服务端发生异常', '2019-07-17 12:11:59');
INSERT INTO `access_log` VALUES (55272, '65.53.15633367326699987', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:13', 16, 0, '', '2019-07-17 12:12:13');
INSERT INTO `access_log` VALUES (55273, '65.54.15633367326719917', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:13', 16, 0, '', '2019-07-17 12:12:13');
INSERT INTO `access_log` VALUES (55274, '65.3607.15633367326711779', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:13', 17, 2001001000, '服务端发生异常', '2019-07-17 12:12:13');
INSERT INTO `access_log` VALUES (55275, '65.47.15633367348439971', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:15', 9, 0, '', '2019-07-17 12:12:15');
INSERT INTO `access_log` VALUES (55276, '65.45.15633367348439965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:15', 10, 0, '', '2019-07-17 12:12:15');
INSERT INTO `access_log` VALUES (55277, '65.49.15633367348439961', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:15', 11, 2001001000, '服务端发生异常', '2019-07-17 12:12:15');
INSERT INTO `access_log` VALUES (55278, '65.50.15633367350739989', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:15', 8, 0, '', '2019-07-17 12:12:15');
INSERT INTO `access_log` VALUES (55279, '65.46.15633367350750045', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:15', 8, 2001001000, '服务端发生异常', '2019-07-17 12:12:15');
INSERT INTO `access_log` VALUES (55280, '65.51.15633367350780037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:15', 8, 0, '', '2019-07-17 12:12:15');
INSERT INTO `access_log` VALUES (55281, '65.52.15633367371790021', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:17', 9, 0, '', '2019-07-17 12:12:17');
INSERT INTO `access_log` VALUES (55282, '65.3607.15633367371801781', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:17', 10, 0, '', '2019-07-17 12:12:17');
INSERT INTO `access_log` VALUES (55283, '65.53.15633367371809989', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:17', 9, 2001001000, '服务端发生异常', '2019-07-17 12:12:17');
INSERT INTO `access_log` VALUES (55284, '65.54.15633367374379919', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:17', 9, 0, '', '2019-07-17 12:12:17');
INSERT INTO `access_log` VALUES (55285, '65.47.15633367374399973', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:17', 9, 0, '', '2019-07-17 12:12:17');
INSERT INTO `access_log` VALUES (55286, '65.45.15633367374399967', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.116.124.243', '2019-07-17 12:12:17', 11, 2001001000, '服务端发生异常', '2019-07-17 12:12:17');
INSERT INTO `access_log` VALUES (55287, '64.80.15633376721618189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '1.80.92.82', '2019-07-17 12:27:52', 11, 0, '', '2019-07-17 12:27:52');
INSERT INTO `access_log` VALUES (55288, '59.78.15633376721627977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '1.80.92.82', '2019-07-17 12:27:52', 10, 0, '', '2019-07-17 12:27:52');
INSERT INTO `access_log` VALUES (55289, '59.75.15633376721647991', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '1.80.92.82', '2019-07-17 12:27:52', 32, 2001001000, '服务端发生异常', '2019-07-17 12:27:52');
INSERT INTO `access_log` VALUES (55290, '64.76.15633376723028175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '1.80.92.82', '2019-07-17 12:27:52', 2, 0, '', '2019-07-17 12:27:52');
INSERT INTO `access_log` VALUES (55291, '64.85.15633376742968197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '1.80.92.82', '2019-07-17 12:27:54', 2, 0, '', '2019-07-17 12:27:54');
INSERT INTO `access_log` VALUES (55292, '64.78.15633376744648185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '1.80.92.82', '2019-07-17 12:27:54', 2, 0, '', '2019-07-17 12:27:54');
INSERT INTO `access_log` VALUES (55293, '59.77.15633404192118007', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:13:39', 11, 0, '', '2019-07-17 13:13:39');
INSERT INTO `access_log` VALUES (55294, '59.71.15633404192138017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:13:39', 24, 2001001000, '服务端发生异常', '2019-07-17 13:13:39');
INSERT INTO `access_log` VALUES (55295, '64.77.15633404222268205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:13:42', 13, 0, '', '2019-07-17 13:13:42');
INSERT INTO `access_log` VALUES (55296, '64.79.15633404223238217', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:13:42', 3, 0, '', '2019-07-17 13:13:42');
INSERT INTO `access_log` VALUES (55297, '64.82.15633404236788229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:13:44', 2, 0, '', '2019-07-17 13:13:44');
INSERT INTO `access_log` VALUES (55298, '64.80.15633404243978227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:13:44', 2, 0, '', '2019-07-17 13:13:44');
INSERT INTO `access_log` VALUES (55299, '64.76.15633404251178213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:13:45', 2, 0, '', '2019-07-17 13:13:45');
INSERT INTO `access_log` VALUES (55300, '64.85.15633404254768235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:13:45', 2, 0, '', '2019-07-17 13:13:45');
INSERT INTO `access_log` VALUES (55301, '66.53.15633404388585939', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17665163825', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:13:59', 92, 0, '', '2019-07-17 13:13:59');
INSERT INTO `access_log` VALUES (55302, '66.50.15633404489085937', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17665163825&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:14:09', 180, 0, '', '2019-07-17 13:14:09');
INSERT INTO `access_log` VALUES (55303, '66.56.15633404503965955', 174, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:14:10', 7, 0, '', '2019-07-17 13:14:10');
INSERT INTO `access_log` VALUES (55304, '66.48.15633404545375953', 174, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:14:15', 6, 0, '', '2019-07-17 13:14:15');
INSERT INTO `access_log` VALUES (55305, '66.55.15633404550455925', 174, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:14:15', 5, 0, '', '2019-07-17 13:14:15');
INSERT INTO `access_log` VALUES (55306, '66.49.15633404599675951', 174, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:14:20', 5, 0, '', '2019-07-17 13:14:20');
INSERT INTO `access_log` VALUES (55307, '59.72.15633404614408017', 174, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:14:21', 15, 0, '', '2019-07-17 13:14:21');
INSERT INTO `access_log` VALUES (55308, '59.80.15633404614407999', 174, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:14:21', 24, 2001001000, '服务端发生异常', '2019-07-17 13:14:21');
INSERT INTO `access_log` VALUES (55309, '59.76.15633404661858013', 174, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:14:26', 5, 0, '', '2019-07-17 13:14:26');
INSERT INTO `access_log` VALUES (55310, '59.77.15633404661868009', 174, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.120.216.50', '2019-07-17 13:14:26', 17, 2001001000, '服务端发生异常', '2019-07-17 13:14:26');
INSERT INTO `access_log` VALUES (55311, '59.74.15633404836188027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.207.186', '2019-07-17 13:14:44', 19, 2001001000, '服务端发生异常', '2019-07-17 13:14:44');
INSERT INTO `access_log` VALUES (55312, '64.79.15633404925448219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.8.179', '2019-07-17 13:14:53', 2, 0, '', '2019-07-17 13:14:53');
INSERT INTO `access_log` VALUES (55313, '64.82.15633404933568231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.129.6.251', '2019-07-17 13:14:53', 1, 0, '', '2019-07-17 13:14:53');
INSERT INTO `access_log` VALUES (55314, '64.80.15633404988588229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.239.232', '2019-07-17 13:14:59', 2, 0, '', '2019-07-17 13:14:59');
INSERT INTO `access_log` VALUES (55315, '66.54.15633405207535945', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.207.186', '2019-07-17 13:15:21', 0, 1002001015, '账号未登陆', '2019-07-17 13:15:21');
INSERT INTO `access_log` VALUES (55316, '59.72.15633405368578019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.91.60.104', '2019-07-17 13:15:37', 2, 0, '', '2019-07-17 13:15:37');
INSERT INTO `access_log` VALUES (55317, '64.85.15633406651448239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.175', '2019-07-17 13:17:45', 2, 0, '', '2019-07-17 13:17:45');
INSERT INTO `access_log` VALUES (55318, '59.73.15633409277818031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:08', 3, 0, '', '2019-07-17 13:22:08');
INSERT INTO `access_log` VALUES (55319, '59.75.15633409277818035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:08', 13, 2001001000, '服务端发生异常', '2019-07-17 13:22:08');
INSERT INTO `access_log` VALUES (55320, '64.76.15633409316338221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:12', 3, 0, '', '2019-07-17 13:22:12');
INSERT INTO `access_log` VALUES (55321, '64.85.15633409317638243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:12', 2, 0, '', '2019-07-17 13:22:12');
INSERT INTO `access_log` VALUES (55322, '64.78.15633409350158231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:15', 2, 0, '', '2019-07-17 13:22:15');
INSERT INTO `access_log` VALUES (55323, '64.84.15633409351518219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:15', 1, 0, '', '2019-07-17 13:22:15');
INSERT INTO `access_log` VALUES (55324, '64.81.15633409405888211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:21', 2, 0, '', '2019-07-17 13:22:21');
INSERT INTO `access_log` VALUES (55325, '64.77.15633409408238215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:21', 2, 0, '', '2019-07-17 13:22:21');
INSERT INTO `access_log` VALUES (55326, '64.79.15633409420448227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:22', 2, 0, '', '2019-07-17 13:22:22');
INSERT INTO `access_log` VALUES (55327, '64.82.15633409434988239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:23', 2, 0, '', '2019-07-17 13:22:24');
INSERT INTO `access_log` VALUES (55328, '59.72.15633409437968025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:24', 2, 0, '', '2019-07-17 13:22:24');
INSERT INTO `access_log` VALUES (55329, '59.80.15633409437968007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:24', 14, 2001001000, '服务端发生异常', '2019-07-17 13:22:24');
INSERT INTO `access_log` VALUES (55330, '64.80.15633409457898237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:26', 2, 0, '', '2019-07-17 13:22:26');
INSERT INTO `access_log` VALUES (55331, '64.76.15633409459068223', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:26', 2, 0, '', '2019-07-17 13:22:26');
INSERT INTO `access_log` VALUES (55332, '59.77.15633409475458017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:28', 3, 0, '', '2019-07-17 13:22:28');
INSERT INTO `access_log` VALUES (55333, '59.76.15633409475458021', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:28', 22, 2001001000, '服务端发生异常', '2019-07-17 13:22:28');
INSERT INTO `access_log` VALUES (55334, '64.85.15633409494258245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:29', 2, 0, '', '2019-07-17 13:22:29');
INSERT INTO `access_log` VALUES (55335, '64.78.15633409495568233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:30', 2, 0, '', '2019-07-17 13:22:30');
INSERT INTO `access_log` VALUES (55336, '59.74.15633409511668035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:31', 3, 0, '', '2019-07-17 13:22:31');
INSERT INTO `access_log` VALUES (55337, '59.71.15633409511668027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:31', 38, 2001001000, '服务端发生异常', '2019-07-17 13:22:31');
INSERT INTO `access_log` VALUES (55338, '64.83.15633409571658225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:37', 2, 0, '', '2019-07-17 13:22:37');
INSERT INTO `access_log` VALUES (55339, '64.81.15633409573008213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:37', 2, 0, '', '2019-07-17 13:22:37');
INSERT INTO `access_log` VALUES (55340, '59.73.15633409578358033', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:38', 3, 0, '', '2019-07-17 13:22:38');
INSERT INTO `access_log` VALUES (55341, '59.75.15633409578358037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '171.221.151.89', '2019-07-17 13:22:38', 17, 2001001000, '服务端发生异常', '2019-07-17 13:22:38');
INSERT INTO `access_log` VALUES (55342, '59.76.15633428239508047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:53:44', 10, 0, '', '2019-07-17 13:53:44');
INSERT INTO `access_log` VALUES (55343, '59.74.15633428239508061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:53:44', 16, 2001001000, '服务端发生异常', '2019-07-17 13:53:44');
INSERT INTO `access_log` VALUES (55344, '64.85.15633428337948271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:53:54', 11, 0, '', '2019-07-17 13:53:54');
INSERT INTO `access_log` VALUES (55345, '64.78.15633428341198259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:53:54', 3, 0, '', '2019-07-17 13:53:54');
INSERT INTO `access_log` VALUES (55346, '64.84.15633428362908247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:53:56', 2, 0, '', '2019-07-17 13:53:56');
INSERT INTO `access_log` VALUES (55347, '64.83.15633428374358251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:53:57', 2, 0, '', '2019-07-17 13:53:57');
INSERT INTO `access_log` VALUES (55348, '59.79.15633428432108057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:03', 3, 0, '', '2019-07-17 13:54:03');
INSERT INTO `access_log` VALUES (55349, '59.73.15633428432118059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:03', 17, 2001001000, '服务端发生异常', '2019-07-17 13:54:03');
INSERT INTO `access_log` VALUES (55350, '64.77.15633428491508243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:09', 2, 0, '', '2019-07-17 13:54:09');
INSERT INTO `access_log` VALUES (55351, '64.79.15633428494048255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:09', 2, 0, '', '2019-07-17 13:54:09');
INSERT INTO `access_log` VALUES (55352, '59.78.15633428512138053', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:11', 2, 0, '', '2019-07-17 13:54:11');
INSERT INTO `access_log` VALUES (55353, '59.72.15633428512138053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:11', 12, 2001001000, '服务端发生异常', '2019-07-17 13:54:11');
INSERT INTO `access_log` VALUES (55354, '64.82.15633428538058267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:14', 1, 0, '', '2019-07-17 13:54:14');
INSERT INTO `access_log` VALUES (55355, '64.80.15633428540518265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:14', 1, 0, '', '2019-07-17 13:54:14');
INSERT INTO `access_log` VALUES (55356, '64.78.15633428779878261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:38', 2, 0, '', '2019-07-17 13:54:38');
INSERT INTO `access_log` VALUES (55357, '64.84.15633428791968249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:39', 1, 0, '', '2019-07-17 13:54:39');
INSERT INTO `access_log` VALUES (55358, '59.76.15633428883758049', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:48', 2, 0, '', '2019-07-17 13:54:48');
INSERT INTO `access_log` VALUES (55359, '59.74.15633428883758063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:48', 12, 2001001000, '服务端发生异常', '2019-07-17 13:54:48');
INSERT INTO `access_log` VALUES (55360, '64.83.15633428891808253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:49', 2, 0, '', '2019-07-17 13:54:49');
INSERT INTO `access_log` VALUES (55361, '59.73.15633428895578061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:50', 3, 0, '', '2019-07-17 13:54:50');
INSERT INTO `access_log` VALUES (55362, '59.79.15633428898098059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:50', 19, 2001001000, '服务端发生异常', '2019-07-17 13:54:50');
INSERT INTO `access_log` VALUES (55363, '64.81.15633428898458241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:50', 1, 0, '', '2019-07-17 13:54:50');
INSERT INTO `access_log` VALUES (55364, '64.79.15633428912918257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:51', 2, 0, '', '2019-07-17 13:54:51');
INSERT INTO `access_log` VALUES (55365, '64.82.15633428915178269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:52', 1, 0, '', '2019-07-17 13:54:52');
INSERT INTO `access_log` VALUES (55366, '59.72.15633428919978055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:52', 2, 0, '', '2019-07-17 13:54:52');
INSERT INTO `access_log` VALUES (55367, '59.75.15633428919978065', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.175.140.229', '2019-07-17 13:54:52', 12, 2001001000, '服务端发生异常', '2019-07-17 13:54:52');
INSERT INTO `access_log` VALUES (55368, '65.45.15633430162380051', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:56:56', 1, 1002001015, '账号未登陆', '2019-07-17 13:56:56');
INSERT INTO `access_log` VALUES (55369, '65.49.15633430162560047', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:56:56', 0, 1002001015, '账号未登陆', '2019-07-17 13:56:56');
INSERT INTO `access_log` VALUES (55370, '65.50.15633430189190075', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:56:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 13:56:59');
INSERT INTO `access_log` VALUES (55371, '65.51.15633430225530123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:57:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 13:57:03');
INSERT INTO `access_log` VALUES (55372, '65.3607.15633430323851867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:57:12', 96, 0, '', '2019-07-17 13:57:12');
INSERT INTO `access_log` VALUES (55373, '65.52.15633430328250107', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:57:13', 12, 0, '', '2019-07-17 13:57:13');
INSERT INTO `access_log` VALUES (55374, '65.53.15633430328250075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:57:13', 12, 2001001000, '服务端发生异常', '2019-07-17 13:57:13');
INSERT INTO `access_log` VALUES (55375, '65.54.15633430328350005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:57:13', 14, 0, '', '2019-07-17 13:57:13');
INSERT INTO `access_log` VALUES (55376, '65.45.15633430525400053', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:57:33', 18, 0, '', '2019-07-17 13:57:33');
INSERT INTO `access_log` VALUES (55377, '65.49.15633430525410049', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:57:33', 20, 2001001000, '服务端发生异常', '2019-07-17 13:57:33');
INSERT INTO `access_log` VALUES (55378, '65.50.15633430525430077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:57:33', 17, 0, '', '2019-07-17 13:57:33');
INSERT INTO `access_log` VALUES (55379, '65.51.15633430561880125', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:57:36', 9, 0, '', '2019-07-17 13:57:36');
INSERT INTO `access_log` VALUES (55380, '65.3607.15633430561921869', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:57:36', 9, 0, '', '2019-07-17 13:57:36');
INSERT INTO `access_log` VALUES (55381, '65.46.15633430561900133', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:57:36', 9, 2001001000, '服务端发生异常', '2019-07-17 13:57:36');
INSERT INTO `access_log` VALUES (55382, '65.54.15633430747210007', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:57:55', 17, 0, '', '2019-07-17 13:57:55');
INSERT INTO `access_log` VALUES (55383, '65.47.15633430747210061', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:57:55', 18, 2001001000, '服务端发生异常', '2019-07-17 13:57:55');
INSERT INTO `access_log` VALUES (55384, '65.45.15633430747250055', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.217.137', '2019-07-17 13:57:55', 15, 0, '', '2019-07-17 13:57:55');
INSERT INTO `access_log` VALUES (55385, '65.50.15633430860660079', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.104.217.137', '2019-07-17 13:58:06', 0, 1002001015, '账号未登陆', '2019-07-17 13:58:06');
INSERT INTO `access_log` VALUES (55386, '65.49.15633430860650051', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.104.217.137', '2019-07-17 13:58:06', 0, 1002001015, '账号未登陆', '2019-07-17 13:58:06');
INSERT INTO `access_log` VALUES (55387, '65.46.15633430860680135', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.104.217.137', '2019-07-17 13:58:06', 0, 1002001015, '账号未登陆', '2019-07-17 13:58:06');
INSERT INTO `access_log` VALUES (55388, '65.3607.15633431026421871', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.104.217.137', '2019-07-17 13:58:23', 92, 0, '', '2019-07-17 13:58:23');
INSERT INTO `access_log` VALUES (55389, '65.53.15633431030220079', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.104.217.137', '2019-07-17 13:58:23', 17, 0, '', '2019-07-17 13:58:23');
INSERT INTO `access_log` VALUES (55390, '65.54.15633431030230009', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.104.217.137', '2019-07-17 13:58:23', 17, 0, '', '2019-07-17 13:58:23');
INSERT INTO `access_log` VALUES (55391, '65.52.15633431030220111', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.104.217.137', '2019-07-17 13:58:23', 17, 2001001000, '服务端发生异常', '2019-07-17 13:58:23');
INSERT INTO `access_log` VALUES (55392, '59.77.15633433812448053', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:01', 3, 0, '', '2019-07-17 14:03:01');
INSERT INTO `access_log` VALUES (55393, '59.76.15633433812488057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:01', 12, 2001001000, '服务端发生异常', '2019-07-17 14:03:01');
INSERT INTO `access_log` VALUES (55394, '64.78.15633433873368269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:07', 4, 0, '', '2019-07-17 14:03:07');
INSERT INTO `access_log` VALUES (55395, '64.84.15633433874228257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:07', 2, 0, '', '2019-07-17 14:03:07');
INSERT INTO `access_log` VALUES (55396, '64.83.15633433896228261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:10', 2, 0, '', '2019-07-17 14:03:10');
INSERT INTO `access_log` VALUES (55397, '64.81.15633433903508249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:10', 2, 0, '', '2019-07-17 14:03:10');
INSERT INTO `access_log` VALUES (55398, '64.77.15633433913988253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:11', 2, 0, '', '2019-07-17 14:03:11');
INSERT INTO `access_log` VALUES (55399, '64.79.15633433922158265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:12', 2, 0, '', '2019-07-17 14:03:12');
INSERT INTO `access_log` VALUES (55400, '64.82.15633433940628277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:14', 1, 0, '', '2019-07-17 14:03:14');
INSERT INTO `access_log` VALUES (55401, '59.71.15633433974808063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:17', 2, 0, '', '2019-07-17 14:03:17');
INSERT INTO `access_log` VALUES (55402, '59.73.15633433974818069', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:17', 18, 2001001000, '服务端发生异常', '2019-07-17 14:03:18');
INSERT INTO `access_log` VALUES (55403, '64.76.15633434030468261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:23', 2, 0, '', '2019-07-17 14:03:23');
INSERT INTO `access_log` VALUES (55404, '64.85.15633434031408283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:23', 2, 0, '', '2019-07-17 14:03:23');
INSERT INTO `access_log` VALUES (55405, '64.78.15633434040948271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:24', 2, 0, '', '2019-07-17 14:03:24');
INSERT INTO `access_log` VALUES (55406, '64.84.15633434051988259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:25', 2, 0, '', '2019-07-17 14:03:25');
INSERT INTO `access_log` VALUES (55407, '59.72.15633434115598063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:32', 3, 0, '', '2019-07-17 14:03:32');
INSERT INTO `access_log` VALUES (55408, '59.75.15633434115608073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:32', 12, 2001001000, '服务端发生异常', '2019-07-17 14:03:32');
INSERT INTO `access_log` VALUES (55409, '64.77.15633434353718255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:55', 2, 0, '', '2019-07-17 14:03:55');
INSERT INTO `access_log` VALUES (55410, '64.79.15633434355288267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:56', 2, 0, '', '2019-07-17 14:03:56');
INSERT INTO `access_log` VALUES (55411, '59.77.15633434365378055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:57', 2, 0, '', '2019-07-17 14:03:57');
INSERT INTO `access_log` VALUES (55412, '59.76.15633434365398059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.49.26.42', '2019-07-17 14:03:57', 12, 2001001000, '服务端发生异常', '2019-07-17 14:03:57');
INSERT INTO `access_log` VALUES (55413, '65.51.15633446641850149', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.172.4.170', '2019-07-17 14:24:24', 0, 1002001015, '账号未登陆', '2019-07-17 14:24:24');
INSERT INTO `access_log` VALUES (55414, '65.3607.15633446641861893', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.172.4.170', '2019-07-17 14:24:24', 1, 1002001015, '账号未登陆', '2019-07-17 14:24:24');
INSERT INTO `access_log` VALUES (55415, '65.54.15633446641930031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.172.4.170', '2019-07-17 14:24:24', 0, 1002001015, '账号未登陆', '2019-07-17 14:24:24');
INSERT INTO `access_log` VALUES (55416, '65.53.15633446725850101', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.172.4.170', '2019-07-17 14:24:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 14:24:33');
INSERT INTO `access_log` VALUES (55417, '65.45.15633447009990079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.172.4.170', '2019-07-17 14:25:01', 83, 0, '', '2019-07-17 14:25:01');
INSERT INTO `access_log` VALUES (55418, '65.50.15633447012900103', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.172.4.170', '2019-07-17 14:25:01', 10, 0, '', '2019-07-17 14:25:01');
INSERT INTO `access_log` VALUES (55419, '65.46.15633447012930159', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.172.4.170', '2019-07-17 14:25:01', 10, 2001001000, '服务端发生异常', '2019-07-17 14:25:01');
INSERT INTO `access_log` VALUES (55420, '65.49.15633447012970075', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.172.4.170', '2019-07-17 14:25:01', 9, 0, '', '2019-07-17 14:25:01');
INSERT INTO `access_log` VALUES (55421, '65.54.15633447086780033', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.172.4.170', '2019-07-17 14:25:09', 9, 0, '', '2019-07-17 14:25:09');
INSERT INTO `access_log` VALUES (55422, '65.3607.15633447086811895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.172.4.170', '2019-07-17 14:25:09', 10, 2001001000, '服务端发生异常', '2019-07-17 14:25:09');
INSERT INTO `access_log` VALUES (55423, '65.51.15633447086850151', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.172.4.170', '2019-07-17 14:25:09', 9, 0, '', '2019-07-17 14:25:09');
INSERT INTO `access_log` VALUES (55424, '59.75.15633454418298101', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '125.70.255.1', '2019-07-17 14:37:22', 17, 0, '', '2019-07-17 14:37:22');
INSERT INTO `access_log` VALUES (55425, '59.72.15633454418328091', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '125.70.255.1', '2019-07-17 14:37:22', 20, 2001001000, '服务端发生异常', '2019-07-17 14:37:22');
INSERT INTO `access_log` VALUES (55426, '64.78.15633454467498299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '125.70.255.1', '2019-07-17 14:37:27', 14, 0, '', '2019-07-17 14:37:27');
INSERT INTO `access_log` VALUES (55427, '64.84.15633454468798287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '125.70.255.1', '2019-07-17 14:37:27', 4, 0, '', '2019-07-17 14:37:27');
INSERT INTO `access_log` VALUES (55428, '66.54.15633454585946011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '125.70.255.1', '2019-07-17 14:37:39', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-07-17 14:37:39');
INSERT INTO `access_log` VALUES (55429, '64.81.15633454634468279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '125.70.255.1', '2019-07-17 14:37:43', 2, 0, '', '2019-07-17 14:37:43');
INSERT INTO `access_log` VALUES (55430, '64.77.15633454635998283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '125.70.255.1', '2019-07-17 14:37:44', 2, 0, '', '2019-07-17 14:37:44');
INSERT INTO `access_log` VALUES (55431, '59.80.15633454648228073', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '125.70.255.1', '2019-07-17 14:37:45', 3, 0, '', '2019-07-17 14:37:45');
INSERT INTO `access_log` VALUES (55432, '59.77.15633454648228083', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '125.70.255.1', '2019-07-17 14:37:45', 12, 2001001000, '服务端发生异常', '2019-07-17 14:37:45');
INSERT INTO `access_log` VALUES (55433, '65.53.15633456079990115', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:40:08', 1, 1002001015, '账号未登陆', '2019-07-17 14:40:08');
INSERT INTO `access_log` VALUES (55434, '65.52.15633456080070147', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:40:08', 0, 1002001015, '账号未登陆', '2019-07-17 14:40:08');
INSERT INTO `access_log` VALUES (55435, '65.47.15633456080120099', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:40:08', 0, 1002001015, '账号未登陆', '2019-07-17 14:40:08');
INSERT INTO `access_log` VALUES (55436, '65.50.15633456115630117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:40:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 14:40:12');
INSERT INTO `access_log` VALUES (55437, '65.46.15633456186140173', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:40:19', 99, 0, '', '2019-07-17 14:40:19');
INSERT INTO `access_log` VALUES (55438, '65.49.15633456190330089', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:40:19', 9, 0, '', '2019-07-17 14:40:19');
INSERT INTO `access_log` VALUES (55439, '65.3607.15633456190531909', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:40:19', 9, 0, '', '2019-07-17 14:40:19');
INSERT INTO `access_log` VALUES (55440, '65.54.15633456190450047', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:40:19', 10, 2001001000, '服务端发生异常', '2019-07-17 14:40:19');
INSERT INTO `access_log` VALUES (55441, '65.47.15633456418260101', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:40:42', 10, 2001001000, '服务端发生异常', '2019-07-17 14:40:42');
INSERT INTO `access_log` VALUES (55442, '65.53.15633456418240117', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:40:42', 12, 0, '', '2019-07-17 14:40:42');
INSERT INTO `access_log` VALUES (55443, '65.45.15633456418310095', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:40:42', 8, 0, '', '2019-07-17 14:40:42');
INSERT INTO `access_log` VALUES (55444, '65.46.15633456602790175', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:41:00', 9, 0, '', '2019-07-17 14:41:00');
INSERT INTO `access_log` VALUES (55445, '65.49.15633456602840091', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:41:00', 10, 2001001000, '服务端发生异常', '2019-07-17 14:41:00');
INSERT INTO `access_log` VALUES (55446, '65.54.15633456602930049', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:41:00', 9, 0, '', '2019-07-17 14:41:00');
INSERT INTO `access_log` VALUES (55447, '65.51.15633456710160167', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:41:11', 61, 0, '', '2019-07-17 14:41:11');
INSERT INTO `access_log` VALUES (55448, '65.52.15633456714080151', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:41:11', 9, 0, '', '2019-07-17 14:41:11');
INSERT INTO `access_log` VALUES (55449, '65.47.15633456714080103', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:41:11', 11, 2001001000, '服务端发生异常', '2019-07-17 14:41:11');
INSERT INTO `access_log` VALUES (55450, '65.45.15633456714130097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.30.179.229', '2019-07-17 14:41:11', 9, 0, '', '2019-07-17 14:41:11');
INSERT INTO `access_log` VALUES (55451, '59.75.15633458427808107', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.197', '2019-07-17 14:44:03', 3, 0, '', '2019-07-17 14:44:03');
INSERT INTO `access_log` VALUES (55452, '59.72.15633458427818097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:03', 13, 2001001000, '服务端发生异常', '2019-07-17 14:44:03');
INSERT INTO `access_log` VALUES (55453, '64.84.15633458469348293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:07', 2, 0, '', '2019-07-17 14:44:07');
INSERT INTO `access_log` VALUES (55454, '64.83.15633458470088297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:07', 2, 0, '', '2019-07-17 14:44:07');
INSERT INTO `access_log` VALUES (55455, '64.81.15633458522828285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:12', 2, 0, '', '2019-07-17 14:44:12');
INSERT INTO `access_log` VALUES (55456, '64.77.15633458523808289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:12', 2, 0, '', '2019-07-17 14:44:12');
INSERT INTO `access_log` VALUES (55457, '59.77.15633458543918089', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:14', 2, 0, '', '2019-07-17 14:44:14');
INSERT INTO `access_log` VALUES (55458, '59.80.15633458543928079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.197', '2019-07-17 14:44:14', 12, 2001001000, '服务端发生异常', '2019-07-17 14:44:14');
INSERT INTO `access_log` VALUES (55459, '65.53.15633458617180121', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:22', 3, 1002001012, '访问令牌已过期', '2019-07-17 14:44:22');
INSERT INTO `access_log` VALUES (55460, '65.46.15633458617210181', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:22', 3, 1002001012, '访问令牌已过期', '2019-07-17 14:44:22');
INSERT INTO `access_log` VALUES (55461, '65.50.15633458617210125', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:22', 3, 1002001012, '访问令牌已过期', '2019-07-17 14:44:22');
INSERT INTO `access_log` VALUES (55462, '65.54.15633458637990055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 14:44:24');
INSERT INTO `access_log` VALUES (55463, '65.3607.15633458713021915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 14:44:31');
INSERT INTO `access_log` VALUES (55464, '65.45.15633458836710101', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:44', 5, 1002002000, '账号不存在', '2019-07-17 14:44:44');
INSERT INTO `access_log` VALUES (55465, '65.52.15633458965550155', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:57', 85, 0, '', '2019-07-17 14:44:57');
INSERT INTO `access_log` VALUES (55466, '65.53.15633458968420123', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:57', 18, 0, '', '2019-07-17 14:44:57');
INSERT INTO `access_log` VALUES (55467, '65.46.15633458968440183', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:57', 18, 2001001000, '服务端发生异常', '2019-07-17 14:44:57');
INSERT INTO `access_log` VALUES (55468, '65.50.15633458968530127', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:44:57', 9, 0, '', '2019-07-17 14:44:57');
INSERT INTO `access_log` VALUES (55469, '65.49.15633459152480097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:45:15', 10, 0, '', '2019-07-17 14:45:15');
INSERT INTO `access_log` VALUES (55470, '65.3607.15633459152501917', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:45:15', 10, 2001001000, '服务端发生异常', '2019-07-17 14:45:15');
INSERT INTO `access_log` VALUES (55471, '65.51.15633459152550175', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:45:15', 10, 0, '', '2019-07-17 14:45:15');
INSERT INTO `access_log` VALUES (55472, '65.50.15633459649420129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:46:05', 9, 0, '', '2019-07-17 14:46:05');
INSERT INTO `access_log` VALUES (55473, '65.46.15633459649430185', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:46:05', 9, 2001001000, '服务端发生异常', '2019-07-17 14:46:05');
INSERT INTO `access_log` VALUES (55474, '65.53.15633459649460125', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:46:05', 9, 0, '', '2019-07-17 14:46:05');
INSERT INTO `access_log` VALUES (55475, '65.47.15633461794940115', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.91.60.110', '2019-07-17 14:49:39', 0, 1002001015, '账号未登陆', '2019-07-17 14:49:39');
INSERT INTO `access_log` VALUES (55476, '65.47.15633463229670117', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.197', '2019-07-17 14:52:03', 11, 0, '', '2019-07-17 14:52:03');
INSERT INTO `access_log` VALUES (55477, '65.52.15633463229670163', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:52:03', 11, 0, '', '2019-07-17 14:52:03');
INSERT INTO `access_log` VALUES (55478, '65.50.15633463229680135', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.230.207.116', '2019-07-17 14:52:03', 12, 2001001000, '服务端发生异常', '2019-07-17 14:52:03');
INSERT INTO `access_log` VALUES (55479, '59.73.15633466512368115', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.3', '2019-07-17 14:57:31', 3, 0, '', '2019-07-17 14:57:31');
INSERT INTO `access_log` VALUES (55480, '59.79.15633466512378113', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.3', '2019-07-17 14:57:31', 13, 2001001000, '服务端发生异常', '2019-07-17 14:57:31');
INSERT INTO `access_log` VALUES (55481, '65.51.15633466593270187', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.3', '2019-07-17 14:57:39', 496, 1002001012, '访问令牌已过期', '2019-07-17 14:57:40');
INSERT INTO `access_log` VALUES (55482, '65.3607.15633466593271929', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.3', '2019-07-17 14:57:39', 496, 1002001012, '访问令牌已过期', '2019-07-17 14:57:40');
INSERT INTO `access_log` VALUES (55483, '65.49.15633466593260109', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.3', '2019-07-17 14:57:39', 497, 1002001012, '访问令牌已过期', '2019-07-17 14:57:40');
INSERT INTO `access_log` VALUES (55484, '65.45.15633466618650115', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.3', '2019-07-17 14:57:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 14:57:42');
INSERT INTO `access_log` VALUES (55485, '65.47.15633466720350123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.3', '2019-07-17 14:57:52', 59, 0, '', '2019-07-17 14:57:52');
INSERT INTO `access_log` VALUES (55486, '65.50.15633466723170141', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.3', '2019-07-17 14:57:52', 9, 0, '', '2019-07-17 14:57:52');
INSERT INTO `access_log` VALUES (55487, '65.52.15633466723190169', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.3', '2019-07-17 14:57:52', 9, 2001001000, '服务端发生异常', '2019-07-17 14:57:52');
INSERT INTO `access_log` VALUES (55488, '65.53.15633466723210137', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.3', '2019-07-17 14:57:52', 9, 0, '', '2019-07-17 14:57:52');
INSERT INTO `access_log` VALUES (55489, '65.45.15633470088620121', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.66.184.173', '2019-07-17 15:03:29', 0, 1002001015, '账号未登陆', '2019-07-17 15:03:29');
INSERT INTO `access_log` VALUES (55490, '65.49.15633470088620115', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.66.184.173', '2019-07-17 15:03:29', 1, 1002001015, '账号未登陆', '2019-07-17 15:03:29');
INSERT INTO `access_log` VALUES (55491, '65.51.15633470088620193', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.66.184.173', '2019-07-17 15:03:29', 1, 1002001015, '账号未登陆', '2019-07-17 15:03:29');
INSERT INTO `access_log` VALUES (55492, '65.47.15633470123780129', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.66.184.173', '2019-07-17 15:03:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 15:03:32');
INSERT INTO `access_log` VALUES (55493, '65.50.15633470229720147', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.66.184.173', '2019-07-17 15:03:43', 324, 0, '', '2019-07-17 15:03:43');
INSERT INTO `access_log` VALUES (55494, '65.53.15633470238830143', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.66.184.173', '2019-07-17 15:03:44', 11, 0, '', '2019-07-17 15:03:44');
INSERT INTO `access_log` VALUES (55495, '65.54.15633470238850077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.66.184.173', '2019-07-17 15:03:44', 9, 0, '', '2019-07-17 15:03:44');
INSERT INTO `access_log` VALUES (55496, '65.46.15633470238850203', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.66.184.173', '2019-07-17 15:03:44', 11, 2001001000, '服务端发生异常', '2019-07-17 15:03:44');
INSERT INTO `access_log` VALUES (55497, '65.45.15633470407020123', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.66.184.173', '2019-07-17 15:04:01', 8, 0, '', '2019-07-17 15:04:01');
INSERT INTO `access_log` VALUES (55498, '65.49.15633470407580117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.66.184.173', '2019-07-17 15:04:01', 10, 0, '', '2019-07-17 15:04:01');
INSERT INTO `access_log` VALUES (55499, '65.51.15633470407570195', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.66.184.173', '2019-07-17 15:04:01', 10, 2001001000, '服务端发生异常', '2019-07-17 15:04:01');
INSERT INTO `access_log` VALUES (55500, '59.76.15633486622098131', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:31:02', 15, 2001001000, '服务端发生异常', '2019-07-17 15:31:02');
INSERT INTO `access_log` VALUES (55501, '59.80.15633486622088117', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:31:02', 160, 0, '', '2019-07-17 15:31:02');
INSERT INTO `access_log` VALUES (55502, '65.49.15633486692670139', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:31:09', 0, 1002001015, '账号未登陆', '2019-07-17 15:31:09');
INSERT INTO `access_log` VALUES (55503, '65.47.15633486693010153', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:31:09', 0, 1002001015, '账号未登陆', '2019-07-17 15:31:09');
INSERT INTO `access_log` VALUES (55504, '65.52.15633486693300199', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:31:09', 1, 1002001015, '账号未登陆', '2019-07-17 15:31:09');
INSERT INTO `access_log` VALUES (55505, '64.80.15633487266608349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:32:07', 11, 0, '', '2019-07-17 15:32:07');
INSERT INTO `access_log` VALUES (55506, '64.76.15633487267908335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:32:07', 2, 0, '', '2019-07-17 15:32:07');
INSERT INTO `access_log` VALUES (55507, '64.85.15633487284008357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:32:08', 2, 0, '', '2019-07-17 15:32:08');
INSERT INTO `access_log` VALUES (55508, '64.78.15633487290418345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:32:09', 2, 0, '', '2019-07-17 15:32:09');
INSERT INTO `access_log` VALUES (55509, '59.72.15633487305698137', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:32:11', 5, 0, '', '2019-07-17 15:32:11');
INSERT INTO `access_log` VALUES (55510, '59.78.15633487306158137', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:32:11', 13, 2001001000, '服务端发生异常', '2019-07-17 15:32:11');
INSERT INTO `access_log` VALUES (55511, '65.3607.15633487364171961', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:32:16', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 15:32:16');
INSERT INTO `access_log` VALUES (55512, '65.49.15633487717300141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:32:52', 86, 0, '', '2019-07-17 15:32:52');
INSERT INTO `access_log` VALUES (55513, '65.47.15633487724500155', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:32:52', 9, 0, '', '2019-07-17 15:32:52');
INSERT INTO `access_log` VALUES (55514, '65.52.15633487724650201', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:32:52', 10, 2001001000, '服务端发生异常', '2019-07-17 15:32:52');
INSERT INTO `access_log` VALUES (55515, '65.50.15633487725290173', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.47.47.234', '2019-07-17 15:32:53', 9, 0, '', '2019-07-17 15:32:53');
INSERT INTO `access_log` VALUES (55516, '65.47.15633499036510171', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '118.114.245.44', '2019-07-17 15:51:44', 0, 1002001015, '账号未登陆', '2019-07-17 15:51:44');
INSERT INTO `access_log` VALUES (55517, '65.49.15633499036510157', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '118.114.245.44', '2019-07-17 15:51:44', 0, 1002001015, '账号未登陆', '2019-07-17 15:51:44');
INSERT INTO `access_log` VALUES (55518, '65.52.15633499036670217', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '118.114.245.44', '2019-07-17 15:51:44', 0, 1002001015, '账号未登陆', '2019-07-17 15:51:44');
INSERT INTO `access_log` VALUES (55519, '65.50.15633499064140189', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '118.114.245.44', '2019-07-17 15:51:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 15:51:46');
INSERT INTO `access_log` VALUES (55520, '65.53.15633499104720185', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '118.114.245.44', '2019-07-17 15:51:50', 70, 0, '', '2019-07-17 15:51:51');
INSERT INTO `access_log` VALUES (55521, '65.54.15633499107570119', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '118.114.245.44', '2019-07-17 15:51:51', 10, 0, '', '2019-07-17 15:51:51');
INSERT INTO `access_log` VALUES (55522, '65.46.15633499107600245', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '118.114.245.44', '2019-07-17 15:51:51', 9, 2001001000, '服务端发生异常', '2019-07-17 15:51:51');
INSERT INTO `access_log` VALUES (55523, '65.3607.15633499107621979', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '118.114.245.44', '2019-07-17 15:51:51', 9, 0, '', '2019-07-17 15:51:51');
INSERT INTO `access_log` VALUES (55524, '65.53.15633501538850189', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.210', '2019-07-17 15:55:54', 0, 1002001015, '账号未登陆', '2019-07-17 15:55:54');
INSERT INTO `access_log` VALUES (55525, '65.54.15633501538860123', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.210', '2019-07-17 15:55:54', 0, 1002001015, '账号未登陆', '2019-07-17 15:55:54');
INSERT INTO `access_log` VALUES (55526, '65.3607.15633501538861983', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.210', '2019-07-17 15:55:54', 1, 1002001015, '账号未登陆', '2019-07-17 15:55:54');
INSERT INTO `access_log` VALUES (55527, '65.45.15633501558690169', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.210', '2019-07-17 15:55:56', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 15:55:56');
INSERT INTO `access_log` VALUES (55528, '65.47.15633501745750177', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.210', '2019-07-17 15:56:15', 88, 0, '', '2019-07-17 15:56:15');
INSERT INTO `access_log` VALUES (55529, '65.49.15633501748990163', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.210', '2019-07-17 15:56:15', 9, 0, '', '2019-07-17 15:56:15');
INSERT INTO `access_log` VALUES (55530, '65.50.15633501749040195', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.210', '2019-07-17 15:56:15', 9, 0, '', '2019-07-17 15:56:15');
INSERT INTO `access_log` VALUES (55531, '65.52.15633501749020223', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.210', '2019-07-17 15:56:15', 9, 2001001000, '服务端发生异常', '2019-07-17 15:56:15');
INSERT INTO `access_log` VALUES (55532, '65.54.15633501877180125', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.210', '2019-07-17 15:56:28', 9, 0, '', '2019-07-17 15:56:28');
INSERT INTO `access_log` VALUES (55533, '65.3607.15633501877201985', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.210', '2019-07-17 15:56:28', 10, 2001001000, '服务端发生异常', '2019-07-17 15:56:28');
INSERT INTO `access_log` VALUES (55534, '65.53.15633501877220191', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.210', '2019-07-17 15:56:28', 9, 0, '', '2019-07-17 15:56:28');
INSERT INTO `access_log` VALUES (55535, '65.52.15633503918470227', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 15:59:52', 0, 1002001015, '账号未登陆', '2019-07-17 15:59:52');
INSERT INTO `access_log` VALUES (55536, '65.49.15633503918470167', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 15:59:52', 0, 1002001015, '账号未登陆', '2019-07-17 15:59:52');
INSERT INTO `access_log` VALUES (55537, '65.50.15633503918520199', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 15:59:52', 0, 1002001015, '账号未登陆', '2019-07-17 15:59:52');
INSERT INTO `access_log` VALUES (55538, '65.54.15633503950090129', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 15:59:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 15:59:55');
INSERT INTO `access_log` VALUES (55539, '65.53.15633503986930195', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 15:59:59', 106, 0, '', '2019-07-17 15:59:59');
INSERT INTO `access_log` VALUES (55540, '65.3607.15633503990341989', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 15:59:59', 9, 0, '', '2019-07-17 15:59:59');
INSERT INTO `access_log` VALUES (55541, '65.45.15633503990370175', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 15:59:59', 10, 2001001000, '服务端发生异常', '2019-07-17 15:59:59');
INSERT INTO `access_log` VALUES (55542, '65.51.15633503990420247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 15:59:59', 9, 0, '', '2019-07-17 15:59:59');
INSERT INTO `access_log` VALUES (55543, '65.49.15633504342020169', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 16:00:34', 9, 0, '', '2019-07-17 16:00:34');
INSERT INTO `access_log` VALUES (55544, '65.52.15633504342120229', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 16:00:34', 8, 2001001000, '服务端发生异常', '2019-07-17 16:00:34');
INSERT INTO `access_log` VALUES (55545, '65.46.15633504342160257', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 16:00:34', 8, 0, '', '2019-07-17 16:00:34');
INSERT INTO `access_log` VALUES (55546, '65.53.15633504508220197', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 16:00:51', 9, 0, '', '2019-07-17 16:00:51');
INSERT INTO `access_log` VALUES (55547, '65.3607.15633504508261991', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 16:00:51', 9, 0, '', '2019-07-17 16:00:51');
INSERT INTO `access_log` VALUES (55548, '65.45.15633504508260177', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 16:00:51', 10, 2001001000, '服务端发生异常', '2019-07-17 16:00:51');
INSERT INTO `access_log` VALUES (55549, '65.45.15633505750990179', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 16:02:55', 9, 0, '', '2019-07-17 16:02:55');
INSERT INTO `access_log` VALUES (55550, '65.47.15633505751030187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 16:02:55', 9, 0, '', '2019-07-17 16:02:55');
INSERT INTO `access_log` VALUES (55551, '65.51.15633505751010251', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.28.112.230', '2019-07-17 16:02:55', 11, 2001001000, '服务端发生异常', '2019-07-17 16:02:55');
INSERT INTO `access_log` VALUES (55552, '65.49.15633505973630173', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.226.141.116', '2019-07-17 16:03:17', 1, 1002001015, '账号未登陆', '2019-07-17 16:03:17');
INSERT INTO `access_log` VALUES (55553, '65.52.15633505973630233', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.226.141.116', '2019-07-17 16:03:17', 0, 1002001015, '账号未登陆', '2019-07-17 16:03:17');
INSERT INTO `access_log` VALUES (55554, '65.46.15633505973640261', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.226.141.116', '2019-07-17 16:03:17', 0, 1002001015, '账号未登陆', '2019-07-17 16:03:17');
INSERT INTO `access_log` VALUES (55555, '65.54.15633506005990135', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.226.141.116', '2019-07-17 16:03:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 16:03:21');
INSERT INTO `access_log` VALUES (55556, '65.45.15633506281530181', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.226.141.116', '2019-07-17 16:03:48', 82, 0, '', '2019-07-17 16:03:48');
INSERT INTO `access_log` VALUES (55557, '65.51.15633506285670253', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.226.141.116', '2019-07-17 16:03:49', 8, 0, '', '2019-07-17 16:03:49');
INSERT INTO `access_log` VALUES (55558, '65.50.15633506285810207', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.226.141.116', '2019-07-17 16:03:49', 9, 0, '', '2019-07-17 16:03:49');
INSERT INTO `access_log` VALUES (55559, '65.47.15633506285730189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.226.141.116', '2019-07-17 16:03:49', 143, 2001001000, '服务端发生异常', '2019-07-17 16:03:49');
INSERT INTO `access_log` VALUES (55560, '59.76.15633506916798159', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.226.141.116', '2019-07-17 16:04:52', 11, 0, '', '2019-07-17 16:04:52');
INSERT INTO `access_log` VALUES (55561, '59.80.15633506916798145', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '139.226.141.116', '2019-07-17 16:04:52', 16, 2001001000, '服务端发生异常', '2019-07-17 16:04:52');
INSERT INTO `access_log` VALUES (55562, '65.3607.15633529155072027', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-17 16:41:56', 18, 1002001012, '访问令牌已过期', '2019-07-17 16:41:56');
INSERT INTO `access_log` VALUES (55563, '65.54.15633529155070167', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-17 16:41:56', 20, 1002001012, '访问令牌已过期', '2019-07-17 16:41:56');
INSERT INTO `access_log` VALUES (55564, '65.53.15633529155080233', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-17 16:41:56', 23, 1002001012, '访问令牌已过期', '2019-07-17 16:41:56');
INSERT INTO `access_log` VALUES (55565, '65.51.15633529318670285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-17 16:42:12', 59, 0, '', '2019-07-17 16:42:12');
INSERT INTO `access_log` VALUES (55566, '65.47.15633529321280221', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-17 16:42:12', 9, 2001001000, '服务端发生异常', '2019-07-17 16:42:12');
INSERT INTO `access_log` VALUES (55567, '65.50.15633529321240239', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-17 16:42:12', 12, 0, '', '2019-07-17 16:42:12');
INSERT INTO `access_log` VALUES (55568, '65.52.15633529321300267', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-17 16:42:12', 9, 0, '', '2019-07-17 16:42:12');
INSERT INTO `access_log` VALUES (55569, '66.56.15633550259346151', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '60.191.76.226', '2019-07-17 17:17:06', 1, 1002001015, '账号未登陆', '2019-07-17 17:17:06');
INSERT INTO `access_log` VALUES (55570, '65.49.15633552078620237', 0, 2, 'admin-application', '/admin-api/admins/admin/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '60.191.76.226', '2019-07-17 17:20:08', 0, 1002001015, '账号未登陆', '2019-07-17 17:20:08');
INSERT INTO `access_log` VALUES (55571, '59.73.15633592728938285', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:27:53', 11, 0, '', '2019-07-17 18:27:53');
INSERT INTO `access_log` VALUES (55572, '59.79.15633592728938283', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:27:53', 24, 2001001000, '服务端发生异常', '2019-07-17 18:27:53');
INSERT INTO `access_log` VALUES (55573, '65.51.15633592827230371', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:03', 1, 1002001015, '账号未登陆', '2019-07-17 18:28:03');
INSERT INTO `access_log` VALUES (55574, '65.3607.15633592827232115', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:03', 1, 1002001015, '账号未登陆', '2019-07-17 18:28:03');
INSERT INTO `access_log` VALUES (55575, '65.45.15633592827520299', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:03', 1, 1002001015, '账号未登陆', '2019-07-17 18:28:03');
INSERT INTO `access_log` VALUES (55576, '65.52.15633592845660353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 18:28:05');
INSERT INTO `access_log` VALUES (55577, '59.80.15633593173468261', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:37', 3, 0, '', '2019-07-17 18:28:37');
INSERT INTO `access_log` VALUES (55578, '59.77.15633593173468271', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:37', 20, 2001001000, '服务端发生异常', '2019-07-17 18:28:37');
INSERT INTO `access_log` VALUES (55579, '64.80.15633593229428491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:43', 12, 0, '', '2019-07-17 18:28:43');
INSERT INTO `access_log` VALUES (55580, '64.76.15633593230468477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:43', 3, 0, '', '2019-07-17 18:28:43');
INSERT INTO `access_log` VALUES (55581, '59.76.15633593248848275', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:45', 3, 0, '', '2019-07-17 18:28:45');
INSERT INTO `access_log` VALUES (55582, '59.74.15633593248858289', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:45', 17, 2001001000, '服务端发生异常', '2019-07-17 18:28:45');
INSERT INTO `access_log` VALUES (55583, '64.85.15633593277508499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:48', 2, 0, '', '2019-07-17 18:28:48');
INSERT INTO `access_log` VALUES (55584, '64.78.15633593278398487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:48', 1, 0, '', '2019-07-17 18:28:48');
INSERT INTO `access_log` VALUES (55585, '64.84.15633593291448475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:49', 2, 0, '', '2019-07-17 18:28:49');
INSERT INTO `access_log` VALUES (55586, '64.83.15633593299358479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:50', 2, 0, '', '2019-07-17 18:28:50');
INSERT INTO `access_log` VALUES (55587, '64.77.15633593337498471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:54', 2, 0, '', '2019-07-17 18:28:54');
INSERT INTO `access_log` VALUES (55588, '64.79.15633593338388483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:54', 1, 0, '', '2019-07-17 18:28:54');
INSERT INTO `access_log` VALUES (55589, '59.79.15633593352318285', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:55', 3, 0, '', '2019-07-17 18:28:55');
INSERT INTO `access_log` VALUES (55590, '59.73.15633593352328287', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:55', 16, 2001001000, '服务端发生异常', '2019-07-17 18:28:55');
INSERT INTO `access_log` VALUES (55591, '64.82.15633593372188495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:57', 2, 0, '', '2019-07-17 18:28:57');
INSERT INTO `access_log` VALUES (55592, '64.80.15633593373528493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:28:57', 1, 0, '', '2019-07-17 18:28:57');
INSERT INTO `access_log` VALUES (55593, '64.85.15633593478428501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:29:08', 2, 0, '', '2019-07-17 18:29:08');
INSERT INTO `access_log` VALUES (55594, '64.78.15633593479798489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:29:08', 2, 0, '', '2019-07-17 18:29:08');
INSERT INTO `access_log` VALUES (55595, '64.84.15633593493278477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:29:09', 2, 0, '', '2019-07-17 18:29:09');
INSERT INTO `access_log` VALUES (55596, '64.83.15633593500168481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:29:10', 2, 0, '', '2019-07-17 18:29:10');
INSERT INTO `access_log` VALUES (55597, '64.81.15633593507508469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:29:11', 2, 0, '', '2019-07-17 18:29:11');
INSERT INTO `access_log` VALUES (55598, '64.77.15633593512858473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:29:11', 2, 0, '', '2019-07-17 18:29:11');
INSERT INTO `access_log` VALUES (55599, '59.72.15633593524698281', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:29:12', 5, 0, '', '2019-07-17 18:29:12');
INSERT INTO `access_log` VALUES (55600, '59.78.15633593524698281', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:29:12', 17, 2001001000, '服务端发生异常', '2019-07-17 18:29:12');
INSERT INTO `access_log` VALUES (55601, '64.79.15633593555698485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:29:16', 1, 0, '', '2019-07-17 18:29:16');
INSERT INTO `access_log` VALUES (55602, '64.82.15633593556668497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:29:16', 2, 0, '', '2019-07-17 18:29:16');
INSERT INTO `access_log` VALUES (55603, '64.80.15633593571268495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:29:17', 2, 0, '', '2019-07-17 18:29:17');
INSERT INTO `access_log` VALUES (55604, '64.76.15633593578418481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:29:18', 1, 0, '', '2019-07-17 18:29:18');
INSERT INTO `access_log` VALUES (55605, '59.80.15633595042468265', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:31:44', 3, 0, '', '2019-07-17 18:31:44');
INSERT INTO `access_log` VALUES (55606, '59.77.15633595042478275', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.171.148', '2019-07-17 18:31:44', 25, 2001001000, '服务端发生异常', '2019-07-17 18:31:44');
INSERT INTO `access_log` VALUES (55607, '65.53.15633599459360331', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-cn) AppleWebKit/601.1.46 (KHTML, like Gecko) Mobile/16F203 Quark/3.3.3.953 Mobile', '223.104.247.248', '2019-07-17 18:39:06', 1, 1002001015, '账号未登陆', '2019-07-17 18:39:06');
INSERT INTO `access_log` VALUES (55608, '65.54.15633599459350265', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-cn) AppleWebKit/601.1.46 (KHTML, like Gecko) Mobile/16F203 Quark/3.3.3.953 Mobile', '223.104.247.248', '2019-07-17 18:39:06', 0, 1002001015, '账号未登陆', '2019-07-17 18:39:06');
INSERT INTO `access_log` VALUES (55609, '65.3607.15633599459372125', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-cn) AppleWebKit/601.1.46 (KHTML, like Gecko) Mobile/16F203 Quark/3.3.3.953 Mobile', '223.104.247.248', '2019-07-17 18:39:06', 0, 1002001015, '账号未登陆', '2019-07-17 18:39:06');
INSERT INTO `access_log` VALUES (55610, '65.50.15633604359040343', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:47:16', 5, 1002001012, '访问令牌已过期', '2019-07-17 18:47:16');
INSERT INTO `access_log` VALUES (55611, '65.47.15633604359090323', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:47:16', 3, 1002001012, '访问令牌已过期', '2019-07-17 18:47:16');
INSERT INTO `access_log` VALUES (55612, '65.49.15633604359140309', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:47:16', 3, 1002001012, '访问令牌已过期', '2019-07-17 18:47:16');
INSERT INTO `access_log` VALUES (55613, '65.46.15633604409470395', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:47:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 18:47:21');
INSERT INTO `access_log` VALUES (55614, '65.54.15633604468700273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:47:27', 171, 0, '', '2019-07-17 18:47:27');
INSERT INTO `access_log` VALUES (55615, '65.3607.15633604473512133', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:47:27', 10, 0, '', '2019-07-17 18:47:27');
INSERT INTO `access_log` VALUES (55616, '65.51.15633604473700389', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:47:27', 10, 0, '', '2019-07-17 18:47:27');
INSERT INTO `access_log` VALUES (55617, '65.45.15633604473850317', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:47:27', 10, 0, '', '2019-07-17 18:47:27');
INSERT INTO `access_log` VALUES (55618, '62.81.15633604582927419', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:47:38', 31, 0, '', '2019-07-17 18:47:38');
INSERT INTO `access_log` VALUES (55619, '62.83.15633604707837467', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:47:51', 22, 0, '', '2019-07-17 18:47:51');
INSERT INTO `access_log` VALUES (55620, '64.79.15633604821588501', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:48:02', 11, 0, '', '2019-07-17 18:48:02');
INSERT INTO `access_log` VALUES (55621, '64.77.15633604821558489', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:48:02', 16, 0, '', '2019-07-17 18:48:02');
INSERT INTO `access_log` VALUES (55622, '65.50.15633604882500345', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:48:08', 27, 0, '', '2019-07-17 18:48:08');
INSERT INTO `access_log` VALUES (55623, '65.46.15633604905230397', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:48:11', 11, 0, '', '2019-07-17 18:48:11');
INSERT INTO `access_log` VALUES (55624, '65.53.15633604945120341', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:48:15', 23, 0, '', '2019-07-17 18:48:15');
INSERT INTO `access_log` VALUES (55625, '65.54.15633604978170275', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:48:18', 10, 0, '', '2019-07-17 18:48:18');
INSERT INTO `access_log` VALUES (55626, '65.3607.15633605108912135', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:48:31', 15, 0, '', '2019-07-17 18:48:31');
INSERT INTO `access_log` VALUES (55627, '59.80.15633605181288279', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:48:38', 13, 0, '', '2019-07-17 18:48:38');
INSERT INTO `access_log` VALUES (55628, '64.78.15633605273068507', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:48:47', 12, 0, '', '2019-07-17 18:48:47');
INSERT INTO `access_log` VALUES (55629, '64.85.15633605273038519', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:48:47', 301, 0, '', '2019-07-17 18:48:48');
INSERT INTO `access_log` VALUES (55630, '64.77.15633605684418491', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:49:28', 19, 0, '', '2019-07-17 18:49:28');
INSERT INTO `access_log` VALUES (55631, '64.79.15633605684558503', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:49:28', 14, 0, '', '2019-07-17 18:49:28');
INSERT INTO `access_log` VALUES (55632, '64.80.15633605813618513', 1, 2, 'product-application', '/product-api/admins/spu/update_sort', 'id=32&sort=-4', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:49:41', 217, 2001001000, '服务端发生异常', '2019-07-17 18:49:42');
INSERT INTO `access_log` VALUES (55633, '64.78.15633605957148509', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:49:56', 10, 0, '', '2019-07-17 18:49:56');
INSERT INTO `access_log` VALUES (55634, '66.53.15633606263026213', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:50:26', 23, 0, '', '2019-07-17 18:50:26');
INSERT INTO `access_log` VALUES (55635, '66.52.15633606320226203', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:50:32', 76, 0, '', '2019-07-17 18:50:32');
INSERT INTO `access_log` VALUES (55636, '65.54.15633640442220323', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.24.67.90', '2019-07-17 19:47:24', 1, 1002001015, '账号未登陆', '2019-07-17 19:47:24');
INSERT INTO `access_log` VALUES (55637, '65.53.15633640442220389', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.24.67.90', '2019-07-17 19:47:24', 1, 1002001015, '账号未登陆', '2019-07-17 19:47:24');
INSERT INTO `access_log` VALUES (55638, '65.51.15633640442230439', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.24.67.90', '2019-07-17 19:47:24', 0, 1002001015, '账号未登陆', '2019-07-17 19:47:24');
INSERT INTO `access_log` VALUES (55639, '65.3607.15633640460822183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.24.67.90', '2019-07-17 19:47:26', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 19:47:26');
INSERT INTO `access_log` VALUES (55640, '65.45.15633640530070367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.24.67.90', '2019-07-17 19:47:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 19:47:33');
INSERT INTO `access_log` VALUES (55641, '65.47.15633640595210375', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai6&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.24.67.90', '2019-07-17 19:47:40', 80, 0, '', '2019-07-17 19:47:40');
INSERT INTO `access_log` VALUES (55642, '65.50.15633640598500395', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.24.67.90', '2019-07-17 19:47:40', 58, 0, '', '2019-07-17 19:47:40');
INSERT INTO `access_log` VALUES (55643, '65.49.15633640598540361', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.24.67.90', '2019-07-17 19:47:40', 58, 0, '', '2019-07-17 19:47:40');
INSERT INTO `access_log` VALUES (55644, '65.46.15633640598560447', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.24.67.90', '2019-07-17 19:47:40', 56, 0, '', '2019-07-17 19:47:40');
INSERT INTO `access_log` VALUES (55645, '62.85.15633640832377501', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.24.67.90', '2019-07-17 19:48:03', 31, 0, '', '2019-07-17 19:48:03');
INSERT INTO `access_log` VALUES (55646, '59.73.15633655452778371', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.24.67.90', '2019-07-17 20:12:25', 21, 0, '', '2019-07-17 20:12:25');
INSERT INTO `access_log` VALUES (55647, '59.78.15633655765738365', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.24.67.90', '2019-07-17 20:12:57', 20, 2001001000, '服务端发生异常', '2019-07-17 20:12:57');
INSERT INTO `access_log` VALUES (55648, '59.77.15633658945278361', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:15', 3, 0, '', '2019-07-17 20:18:15');
INSERT INTO `access_log` VALUES (55649, '59.74.15633658945278379', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:15', 32, 2001001000, '服务端发生异常', '2019-07-17 20:18:15');
INSERT INTO `access_log` VALUES (55650, '64.81.15633658983728559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:18', 12, 0, '', '2019-07-17 20:18:18');
INSERT INTO `access_log` VALUES (55651, '64.77.15633658984628563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:18', 2, 0, '', '2019-07-17 20:18:18');
INSERT INTO `access_log` VALUES (55652, '64.82.15633659023118587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:22', 3, 0, '', '2019-07-17 20:18:22');
INSERT INTO `access_log` VALUES (55653, '64.80.15633659024268585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:22', 2, 0, '', '2019-07-17 20:18:22');
INSERT INTO `access_log` VALUES (55654, '59.71.15633659055688371', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:26', 3, 0, '', '2019-07-17 20:18:26');
INSERT INTO `access_log` VALUES (55655, '59.79.15633659055688375', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:26', 13, 2001001000, '服务端发生异常', '2019-07-17 20:18:26');
INSERT INTO `access_log` VALUES (55656, '64.76.15633659086638571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:29', 2, 0, '', '2019-07-17 20:18:29');
INSERT INTO `access_log` VALUES (55657, '64.78.15633659087428581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:29', 2, 0, '', '2019-07-17 20:18:29');
INSERT INTO `access_log` VALUES (55658, '59.73.15633659112858377', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:31', 2, 0, '', '2019-07-17 20:18:31');
INSERT INTO `access_log` VALUES (55659, '59.75.15633659112858381', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:31', 12, 2001001000, '服务端发生异常', '2019-07-17 20:18:31');
INSERT INTO `access_log` VALUES (55660, '65.45.15633659193750393', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:39', 0, 1002001015, '账号未登陆', '2019-07-17 20:18:39');
INSERT INTO `access_log` VALUES (55661, '65.47.15633659193770401', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:39', 0, 1002001015, '账号未登陆', '2019-07-17 20:18:39');
INSERT INTO `access_log` VALUES (55662, '65.52.15633659193770447', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:39', 0, 1002001015, '账号未登陆', '2019-07-17 20:18:39');
INSERT INTO `access_log` VALUES (55663, '65.49.15633659214930387', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:18:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 20:18:42');
INSERT INTO `access_log` VALUES (55664, '65.50.15633659451140421', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:19:05', 88, 0, '', '2019-07-17 20:19:05');
INSERT INTO `access_log` VALUES (55665, '65.51.15633659456460467', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:19:06', 12, 0, '', '2019-07-17 20:19:06');
INSERT INTO `access_log` VALUES (55666, '65.53.15633659456490417', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:19:06', 11, 2001001000, '服务端发生异常', '2019-07-17 20:19:06');
INSERT INTO `access_log` VALUES (55667, '65.54.15633659456490351', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-17 20:19:06', 12, 0, '', '2019-07-17 20:19:06');
INSERT INTO `access_log` VALUES (55668, '59.76.15633661310788369', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.24.67.90', '2019-07-17 20:22:11', 20, 0, '', '2019-07-17 20:22:11');
INSERT INTO `access_log` VALUES (55669, '65.3607.15633670589642227', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-17 20:37:39', 4, 1002001012, '访问令牌已过期', '2019-07-17 20:37:39');
INSERT INTO `access_log` VALUES (55670, '65.50.15633670589640439', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-17 20:37:39', 3, 1002001012, '访问令牌已过期', '2019-07-17 20:37:39');
INSERT INTO `access_log` VALUES (55671, '65.45.15633670589640413', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-17 20:37:39', 4, 1002001012, '访问令牌已过期', '2019-07-17 20:37:39');
INSERT INTO `access_log` VALUES (55672, '65.51.15633670736590485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-17 20:37:54', 76, 0, '', '2019-07-17 20:37:54');
INSERT INTO `access_log` VALUES (55673, '65.47.15633670744200417', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-17 20:37:54', 9, 0, '', '2019-07-17 20:37:54');
INSERT INTO `access_log` VALUES (55674, '65.46.15633670744240489', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-17 20:37:54', 10, 2001001000, '服务端发生异常', '2019-07-17 20:37:54');
INSERT INTO `access_log` VALUES (55675, '65.54.15633670746230369', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '120.220.45.40', '2019-07-17 20:37:55', 10, 0, '', '2019-07-17 20:37:55');
INSERT INTO `access_log` VALUES (55676, '65.54.15633676735150377', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.11.255.104', '2019-07-17 20:47:54', 0, 1002001015, '账号未登陆', '2019-07-17 20:47:54');
INSERT INTO `access_log` VALUES (55677, '65.52.15633676735220473', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.11.255.104', '2019-07-17 20:47:54', 0, 1002001015, '账号未登陆', '2019-07-17 20:47:54');
INSERT INTO `access_log` VALUES (55678, '65.49.15633676735390413', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.11.255.104', '2019-07-17 20:47:54', 0, 1002001015, '账号未登陆', '2019-07-17 20:47:54');
INSERT INTO `access_log` VALUES (55679, '65.53.15633678776350445', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.11.255.104', '2019-07-17 20:51:18', 75, 0, '', '2019-07-17 20:51:18');
INSERT INTO `access_log` VALUES (55680, '65.46.15633678781580501', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.11.255.104', '2019-07-17 20:51:18', 10, 0, '', '2019-07-17 20:51:18');
INSERT INTO `access_log` VALUES (55681, '65.47.15633678781650429', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.11.255.104', '2019-07-17 20:51:18', 10, 2001001000, '服务端发生异常', '2019-07-17 20:51:18');
INSERT INTO `access_log` VALUES (55682, '65.52.15633678781840477', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.11.255.104', '2019-07-17 20:51:18', 9, 0, '', '2019-07-17 20:51:18');
INSERT INTO `access_log` VALUES (55683, '59.73.15633706420858439', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:22', 10, 0, '', '2019-07-17 21:37:22');
INSERT INTO `access_log` VALUES (55684, '59.75.15633706422108445', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:22', 19, 2001001000, '服务端发生异常', '2019-07-17 21:37:22');
INSERT INTO `access_log` VALUES (55685, '64.82.15633706478938651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:28', 12, 0, '', '2019-07-17 21:37:28');
INSERT INTO `access_log` VALUES (55686, '64.80.15633706480478649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:28', 3, 0, '', '2019-07-17 21:37:28');
INSERT INTO `access_log` VALUES (55687, '64.76.15633706489818635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:29', 2, 0, '', '2019-07-17 21:37:29');
INSERT INTO `access_log` VALUES (55688, '64.78.15633706496688645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:30', 2, 0, '', '2019-07-17 21:37:30');
INSERT INTO `access_log` VALUES (55689, '64.85.15633706503688657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:30', 2, 0, '', '2019-07-17 21:37:30');
INSERT INTO `access_log` VALUES (55690, '64.84.15633706507458633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:31', 2, 0, '', '2019-07-17 21:37:31');
INSERT INTO `access_log` VALUES (55691, '59.72.15633706517268435', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:32', 4, 0, '', '2019-07-17 21:37:32');
INSERT INTO `access_log` VALUES (55692, '59.78.15633706517288435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:32', 13, 2001001000, '服务端发生异常', '2019-07-17 21:37:32');
INSERT INTO `access_log` VALUES (55693, '65.46.15633706603050539', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:40', 1, 1002001015, '账号未登陆', '2019-07-17 21:37:40');
INSERT INTO `access_log` VALUES (55694, '65.52.15633706603050515', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:40', 1, 1002001015, '账号未登陆', '2019-07-17 21:37:40');
INSERT INTO `access_log` VALUES (55695, '65.47.15633706603050467', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:40', 0, 1002001015, '账号未登陆', '2019-07-17 21:37:40');
INSERT INTO `access_log` VALUES (55696, '66.52.15633706608806337', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:41', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-07-17 21:37:41');
INSERT INTO `access_log` VALUES (55697, '66.50.15633706652886343', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:45', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机号不能为空\n手机验证码长度为 4-6 位', '2019-07-17 21:37:45');
INSERT INTO `access_log` VALUES (55698, '66.51.15633706652886375', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:45', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位', '2019-07-17 21:37:45');
INSERT INTO `access_log` VALUES (55699, '59.74.15633706699098445', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:50', 3, 0, '', '2019-07-17 21:37:50');
INSERT INTO `access_log` VALUES (55700, '59.76.15633706699098431', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:37:50', 19, 2001001000, '服务端发生异常', '2019-07-17 21:37:50');
INSERT INTO `access_log` VALUES (55701, '65.54.15633706800480419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:38:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-17 21:38:00');
INSERT INTO `access_log` VALUES (55702, '65.50.15633706915540491', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:38:12', 206, 0, '', '2019-07-17 21:38:12');
INSERT INTO `access_log` VALUES (55703, '65.3607.15633706921042279', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:38:12', 77, 0, '', '2019-07-17 21:38:12');
INSERT INTO `access_log` VALUES (55704, '65.51.15633706921140535', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:38:12', 69, 2001001000, '服务端发生异常', '2019-07-17 21:38:12');
INSERT INTO `access_log` VALUES (55705, '65.53.15633706921140485', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.126', '2019-07-17 21:38:12', 70, 0, '', '2019-07-17 21:38:12');
INSERT INTO `access_log` VALUES (55706, '65.52.15633720668520535', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.237.121.207', '2019-07-17 22:01:07', 0, 1002001015, '账号未登陆', '2019-07-17 22:01:07');
INSERT INTO `access_log` VALUES (55707, '65.47.15633720668520487', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.237.121.207', '2019-07-17 22:01:07', 0, 1002001015, '账号未登陆', '2019-07-17 22:01:07');
INSERT INTO `access_log` VALUES (55708, '65.53.15633720668510505', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.237.121.207', '2019-07-17 22:01:07', 0, 1002001015, '账号未登陆', '2019-07-17 22:01:07');
INSERT INTO `access_log` VALUES (55709, '65.49.15633720722100475', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.237.121.207', '2019-07-17 22:01:12', 109, 0, '', '2019-07-17 22:01:12');
INSERT INTO `access_log` VALUES (55710, '65.54.15633720725820441', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.237.121.207', '2019-07-17 22:01:13', 13, 0, '', '2019-07-17 22:01:13');
INSERT INTO `access_log` VALUES (55711, '65.50.15633720725890513', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.237.121.207', '2019-07-17 22:01:13', 13, 2001001000, '服务端发生异常', '2019-07-17 22:01:13');
INSERT INTO `access_log` VALUES (55712, '65.45.15633720725950485', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.237.121.207', '2019-07-17 22:01:13', 9, 0, '', '2019-07-17 22:01:13');
INSERT INTO `access_log` VALUES (55713, '65.3607.15633720827982301', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.237.121.207', '2019-07-17 22:01:23', 11, 0, '', '2019-07-17 22:01:23');
INSERT INTO `access_log` VALUES (55714, '65.51.15633720828060555', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.237.121.207', '2019-07-17 22:01:23', 10, 2001001000, '服务端发生异常', '2019-07-17 22:01:23');
INSERT INTO `access_log` VALUES (55715, '65.47.15633720828100489', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.237.121.207', '2019-07-17 22:01:23', 9, 0, '', '2019-07-17 22:01:23');
INSERT INTO `access_log` VALUES (55716, '59.76.15633723123368453', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:05:12', 3, 0, '', '2019-07-17 22:05:12');
INSERT INTO `access_log` VALUES (55717, '59.71.15633723123508459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:05:12', 13, 2001001000, '服务端发生异常', '2019-07-17 22:05:12');
INSERT INTO `access_log` VALUES (55718, '64.81.15633723160668647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:05:16', 3, 0, '', '2019-07-17 22:05:16');
INSERT INTO `access_log` VALUES (55719, '64.77.15633723168088651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:05:17', 2, 0, '', '2019-07-17 22:05:17');
INSERT INTO `access_log` VALUES (55720, '64.79.15633723183218663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:05:18', 2, 0, '', '2019-07-17 22:05:18');
INSERT INTO `access_log` VALUES (55721, '64.82.15633723192898675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:05:19', 2, 0, '', '2019-07-17 22:05:19');
INSERT INTO `access_log` VALUES (55722, '59.73.15633723209068463', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:05:21', 3, 0, '', '2019-07-17 22:05:21');
INSERT INTO `access_log` VALUES (55723, '59.75.15633723209068469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:05:21', 13, 2001001000, '服务端发生异常', '2019-07-17 22:05:21');
INSERT INTO `access_log` VALUES (55724, '64.76.15633723243358659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:05:24', 2, 0, '', '2019-07-17 22:05:24');
INSERT INTO `access_log` VALUES (55725, '64.78.15633723244488669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:05:24', 2, 0, '', '2019-07-17 22:05:24');
INSERT INTO `access_log` VALUES (55726, '64.85.15633724734218683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:07:53', 2, 0, '', '2019-07-17 22:07:53');
INSERT INTO `access_log` VALUES (55727, '64.84.15633724742348659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:07:54', 2, 0, '', '2019-07-17 22:07:54');
INSERT INTO `access_log` VALUES (55728, '64.83.15633724814058663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:08:01', 2, 0, '', '2019-07-17 22:08:01');
INSERT INTO `access_log` VALUES (55729, '64.81.15633724815198651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:08:02', 2, 0, '', '2019-07-17 22:08:02');
INSERT INTO `access_log` VALUES (55730, '59.78.15633724947878461', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:08:15', 3, 0, '', '2019-07-17 22:08:15');
INSERT INTO `access_log` VALUES (55731, '59.80.15633724948358443', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:08:15', 39, 2001001000, '服务端发生异常', '2019-07-17 22:08:15');
INSERT INTO `access_log` VALUES (55732, '64.79.15633724954438667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:08:15', 1, 0, '', '2019-07-17 22:08:15');
INSERT INTO `access_log` VALUES (55733, '64.82.15633724955998679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:08:16', 2, 0, '', '2019-07-17 22:08:16');
INSERT INTO `access_log` VALUES (55734, '59.74.15633724962708471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:08:16', 3, 0, '', '2019-07-17 22:08:16');
INSERT INTO `access_log` VALUES (55735, '59.77.15633724962698453', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '14.155.16.176', '2019-07-17 22:08:16', 14, 2001001000, '服务端发生异常', '2019-07-17 22:08:16');
INSERT INTO `access_log` VALUES (55736, '59.80.15633773893158509', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.89.96.36', '2019-07-17 23:29:49', 10, 0, '', '2019-07-17 23:29:49');
INSERT INTO `access_log` VALUES (55737, '59.74.15633773893178537', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.89.96.36', '2019-07-17 23:29:49', 14, 2001001000, '服务端发生异常', '2019-07-17 23:29:49');
INSERT INTO `access_log` VALUES (55738, '59.77.15633773997238519', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.89.96.36', '2019-07-17 23:30:00', 3, 0, '', '2019-07-17 23:30:00');
INSERT INTO `access_log` VALUES (55739, '59.71.15633773997238529', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.89.96.36', '2019-07-17 23:30:00', 17, 2001001000, '服务端发生异常', '2019-07-17 23:30:00');
INSERT INTO `access_log` VALUES (55740, '64.85.15633774255678751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.89.96.36', '2019-07-17 23:30:26', 12, 0, '', '2019-07-17 23:30:26');
INSERT INTO `access_log` VALUES (55741, '64.84.15633774256978725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.89.96.36', '2019-07-17 23:30:26', 3, 0, '', '2019-07-17 23:30:26');
INSERT INTO `access_log` VALUES (55742, '64.81.15633774328628719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.89.96.36', '2019-07-17 23:30:33', 2, 0, '', '2019-07-17 23:30:33');
INSERT INTO `access_log` VALUES (55743, '64.83.15633774333448731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.89.96.36', '2019-07-17 23:30:33', 2, 0, '', '2019-07-17 23:30:33');
INSERT INTO `access_log` VALUES (55744, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.89.96.36', '2019-07-17 23:30:34', 7, 0, '', '2019-07-17 23:30:34');
INSERT INTO `access_log` VALUES (55745, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.89.96.36', '2019-07-17 23:30:34', 6, 0, '', '2019-07-17 23:30:34');
INSERT INTO `access_log` VALUES (55746, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.89.96.36', '2019-07-17 23:30:34', 12, 0, '', '2019-07-17 23:30:34');
INSERT INTO `access_log` VALUES (55747, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.89.96.36', '2019-07-17 23:30:34', 12, 0, '', '2019-07-17 23:30:34');
INSERT INTO `access_log` VALUES (55748, '64.76.15633774358618731', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.89.96.36', '2019-07-17 23:30:36', 8, 0, '', '2019-07-17 23:30:36');
INSERT INTO `access_log` VALUES (55749, '66.48.15633774417186449', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.89.96.36', '2019-07-17 23:30:42', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-07-17 23:30:42');
INSERT INTO `access_log` VALUES (55750, '59.72.15633774492348529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.166', '2019-07-17 23:30:49', 2, 0, '', '2019-07-17 23:30:49');
INSERT INTO `access_log` VALUES (55751, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.91.60.104', '2019-07-17 23:31:34', 7, 0, '', '2019-07-17 23:31:34');
INSERT INTO `access_log` VALUES (55752, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.178.165', '2019-07-17 23:31:34', 9, 0, '', '2019-07-17 23:31:34');
INSERT INTO `access_log` VALUES (55753, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.151.178.166', '2019-07-17 23:31:34', 4, 0, '', '2019-07-17 23:31:34');
INSERT INTO `access_log` VALUES (55754, '64.82.15633774950968747', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.251', '2019-07-17 23:31:35', 5, 0, '', '2019-07-17 23:31:35');
INSERT INTO `access_log` VALUES (55755, '65.47.15634069780690955', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.153.95.69', '2019-07-18 07:42:58', 1, 1002001015, '账号未登陆', '2019-07-18 07:42:58');
INSERT INTO `access_log` VALUES (55756, '65.46.15634069780701029', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.153.95.69', '2019-07-18 07:42:58', 1, 1002001015, '账号未登陆', '2019-07-18 07:42:58');
INSERT INTO `access_log` VALUES (55757, '65.45.15634069780690953', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.153.95.69', '2019-07-18 07:42:58', 1, 1002001015, '账号未登陆', '2019-07-18 07:42:58');
INSERT INTO `access_log` VALUES (55758, '65.51.15634070457371023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.153.95.71', '2019-07-18 07:44:06', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 07:44:06');
INSERT INTO `access_log` VALUES (55759, '59.78.15634077608368933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:01', 12, 0, '', '2019-07-18 07:56:01');
INSERT INTO `access_log` VALUES (55760, '59.80.15634077608378915', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:01', 25, 2001001000, '服务端发生异常', '2019-07-18 07:56:01');
INSERT INTO `access_log` VALUES (55761, '64.82.15634077690369151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:09', 12, 0, '', '2019-07-18 07:56:09');
INSERT INTO `access_log` VALUES (55762, '64.85.15634077691359157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:09', 3, 0, '', '2019-07-18 07:56:09');
INSERT INTO `access_log` VALUES (55763, '64.84.15634077703359131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:10', 2, 0, '', '2019-07-18 07:56:10');
INSERT INTO `access_log` VALUES (55764, '64.81.15634077707459125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:11', 2, 0, '', '2019-07-18 07:56:11');
INSERT INTO `access_log` VALUES (55765, '64.83.15634077710399137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:11', 2, 0, '', '2019-07-18 07:56:11');
INSERT INTO `access_log` VALUES (55766, '59.77.15634077716738925', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:12', 3, 0, '', '2019-07-18 07:56:12');
INSERT INTO `access_log` VALUES (55767, '59.71.15634077716798935', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:12', 23, 2001001000, '服务端发生异常', '2019-07-18 07:56:12');
INSERT INTO `access_log` VALUES (55768, '64.76.15634077915359137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:32', 3, 0, '', '2019-07-18 07:56:32');
INSERT INTO `access_log` VALUES (55769, '64.79.15634077916609141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:32', 2, 0, '', '2019-07-18 07:56:32');
INSERT INTO `access_log` VALUES (55770, '64.80.15634077946169151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:35', 2, 0, '', '2019-07-18 07:56:35');
INSERT INTO `access_log` VALUES (55771, '64.78.15634077951579147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:35', 2, 0, '', '2019-07-18 07:56:35');
INSERT INTO `access_log` VALUES (55772, '64.85.15634078077189159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:48', 2, 0, '', '2019-07-18 07:56:48');
INSERT INTO `access_log` VALUES (55773, '64.84.15634078078299133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:48', 2, 0, '', '2019-07-18 07:56:48');
INSERT INTO `access_log` VALUES (55774, '59.73.15634078080338939', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:48', 3, 0, '', '2019-07-18 07:56:48');
INSERT INTO `access_log` VALUES (55775, '59.75.15634078080368945', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:48', 22, 2001001000, '服务端发生异常', '2019-07-18 07:56:48');
INSERT INTO `access_log` VALUES (55776, '64.83.15634078110069139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:51', 2, 0, '', '2019-07-18 07:56:51');
INSERT INTO `access_log` VALUES (55777, '64.77.15634078111179129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:51', 2, 0, '', '2019-07-18 07:56:51');
INSERT INTO `access_log` VALUES (55778, '64.76.15634078142749139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:54', 2, 0, '', '2019-07-18 07:56:54');
INSERT INTO `access_log` VALUES (55779, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:54', 5, 0, '', '2019-07-18 07:56:54');
INSERT INTO `access_log` VALUES (55780, '64.79.15634078155619143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:56', 2, 0, '', '2019-07-18 07:56:56');
INSERT INTO `access_log` VALUES (55781, '64.80.15634078160299153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:56', 3, 0, '', '2019-07-18 07:56:56');
INSERT INTO `access_log` VALUES (55782, '64.78.15634078182489149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:58', 2, 0, '', '2019-07-18 07:56:58');
INSERT INTO `access_log` VALUES (55783, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:58', 5, 0, '', '2019-07-18 07:56:58');
INSERT INTO `access_log` VALUES (55784, '64.82.15634078191609155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:59', 2, 0, '', '2019-07-18 07:56:59');
INSERT INTO `access_log` VALUES (55785, '64.85.15634078192539161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:56:59', 2, 0, '', '2019-07-18 07:56:59');
INSERT INTO `access_log` VALUES (55786, '64.84.15634078235449135', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:57:04', 2, 0, '', '2019-07-18 07:57:04');
INSERT INTO `access_log` VALUES (55787, '64.81.15634078246859129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:57:05', 2, 0, '', '2019-07-18 07:57:05');
INSERT INTO `access_log` VALUES (55788, '64.83.15634078253499141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:57:05', 2, 0, '', '2019-07-18 07:57:05');
INSERT INTO `access_log` VALUES (55789, '64.76.15634078258979141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:57:06', 2, 0, '', '2019-07-18 07:57:06');
INSERT INTO `access_log` VALUES (55790, '64.79.15634078262229145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:57:06', 2, 0, '', '2019-07-18 07:57:06');
INSERT INTO `access_log` VALUES (55791, '64.80.15634078264759155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:57:06', 2, 0, '', '2019-07-18 07:57:06');
INSERT INTO `access_log` VALUES (55792, '59.80.15634078282518917', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:57:08', 3, 0, '', '2019-07-18 07:57:08');
INSERT INTO `access_log` VALUES (55793, '59.74.15634078282528945', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:62.0) Gecko/20100101 Firefox/62.0', '60.177.37.215', '2019-07-18 07:57:08', 13, 2001001000, '服务端发生异常', '2019-07-18 07:57:08');
INSERT INTO `access_log` VALUES (55794, '65.47.15634118468811021', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.252.82.130', '2019-07-18 09:04:07', 1, 1002001015, '账号未登陆', '2019-07-18 09:04:07');
INSERT INTO `access_log` VALUES (55795, '65.49.15634118468821011', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.252.82.130', '2019-07-18 09:04:07', 1, 1002001015, '账号未登陆', '2019-07-18 09:04:07');
INSERT INTO `access_log` VALUES (55796, '65.53.15634118468821039', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.252.82.130', '2019-07-18 09:04:07', 1, 1002001015, '账号未登陆', '2019-07-18 09:04:07');
INSERT INTO `access_log` VALUES (55797, '65.45.15634118545241019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.252.82.130', '2019-07-18 09:04:15', 98, 0, '', '2019-07-18 09:04:15');
INSERT INTO `access_log` VALUES (55798, '65.3607.15634118549232833', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.252.82.130', '2019-07-18 09:04:15', 19, 0, '', '2019-07-18 09:04:15');
INSERT INTO `access_log` VALUES (55799, '65.50.15634118549231047', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.252.82.130', '2019-07-18 09:04:15', 22, 2001001000, '服务端发生异常', '2019-07-18 09:04:15');
INSERT INTO `access_log` VALUES (55800, '65.46.15634118549281097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '116.252.82.130', '2019-07-18 09:04:15', 16, 0, '', '2019-07-18 09:04:15');
INSERT INTO `access_log` VALUES (55801, '65.51.15634119303511091', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.60.232.4', '2019-07-18 09:05:30', 1, 1002001015, '账号未登陆', '2019-07-18 09:05:30');
INSERT INTO `access_log` VALUES (55802, '65.45.15634119303611021', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.60.232.4', '2019-07-18 09:05:30', 0, 1002001015, '账号未登陆', '2019-07-18 09:05:30');
INSERT INTO `access_log` VALUES (55803, '65.46.15634119303781099', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.60.232.4', '2019-07-18 09:05:30', 0, 1002001015, '账号未登陆', '2019-07-18 09:05:30');
INSERT INTO `access_log` VALUES (55804, '65.3607.15634119356522835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.60.232.4', '2019-07-18 09:05:36', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 09:05:36');
INSERT INTO `access_log` VALUES (55805, '65.52.15634119400131071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.60.232.4', '2019-07-18 09:05:40', 91, 0, '', '2019-07-18 09:05:40');
INSERT INTO `access_log` VALUES (55806, '65.54.15634119404900977', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.60.232.4', '2019-07-18 09:05:40', 11, 0, '', '2019-07-18 09:05:41');
INSERT INTO `access_log` VALUES (55807, '65.53.15634119404981043', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.60.232.4', '2019-07-18 09:05:40', 11, 2001001000, '服务端发生异常', '2019-07-18 09:05:41');
INSERT INTO `access_log` VALUES (55808, '65.47.15634119405121025', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.60.232.4', '2019-07-18 09:05:41', 9, 0, '', '2019-07-18 09:05:41');
INSERT INTO `access_log` VALUES (55809, '59.80.15634123042868977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:11:44', 11, 0, '', '2019-07-18 09:11:44');
INSERT INTO `access_log` VALUES (55810, '59.74.15634123043989005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:11:44', 25, 2001001000, '服务端发生异常', '2019-07-18 09:11:44');
INSERT INTO `access_log` VALUES (55811, '65.51.15634123941701099', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:14', 0, 1002001015, '账号未登陆', '2019-07-18 09:13:14');
INSERT INTO `access_log` VALUES (55812, '65.49.15634123941701021', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:14', 0, 1002001015, '账号未登陆', '2019-07-18 09:13:14');
INSERT INTO `access_log` VALUES (55813, '65.45.15634123941721029', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:14', 0, 1002001015, '账号未登陆', '2019-07-18 09:13:14');
INSERT INTO `access_log` VALUES (55814, '65.46.15634124014861107', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:21', 103, 0, '', '2019-07-18 09:13:22');
INSERT INTO `access_log` VALUES (55815, '65.52.15634124018541079', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:22', 10, 0, '', '2019-07-18 09:13:22');
INSERT INTO `access_log` VALUES (55816, '65.50.15634124018541057', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:22', 11, 2001001000, '服务端发生异常', '2019-07-18 09:13:22');
INSERT INTO `access_log` VALUES (55817, '65.3607.15634124018532843', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:22', 13, 0, '', '2019-07-18 09:13:22');
INSERT INTO `access_log` VALUES (55818, '65.53.15634124086861051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:29', 9, 0, '', '2019-07-18 09:13:29');
INSERT INTO `access_log` VALUES (55819, '65.47.15634124086861033', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:29', 11, 2001001000, '服务端发生异常', '2019-07-18 09:13:29');
INSERT INTO `access_log` VALUES (55820, '65.51.15634124086901101', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:29', 9, 0, '', '2019-07-18 09:13:29');
INSERT INTO `access_log` VALUES (55821, '65.45.15634124185601031', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:39', 10, 2001001000, '服务端发生异常', '2019-07-18 09:13:39');
INSERT INTO `access_log` VALUES (55822, '65.49.15634124185601023', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:39', 12, 0, '', '2019-07-18 09:13:39');
INSERT INTO `access_log` VALUES (55823, '65.46.15634124185651109', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:39', 9, 0, '', '2019-07-18 09:13:39');
INSERT INTO `access_log` VALUES (55824, '65.3607.15634124365152845', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:57', 10, 0, '', '2019-07-18 09:13:57');
INSERT INTO `access_log` VALUES (55825, '65.54.15634124365160987', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:57', 11, 2001001000, '服务端发生异常', '2019-07-18 09:13:57');
INSERT INTO `access_log` VALUES (55826, '65.47.15634124365211035', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:13:57', 9, 0, '', '2019-07-18 09:13:57');
INSERT INTO `access_log` VALUES (55827, '65.51.15634124458351103', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:14:06', 9, 0, '', '2019-07-18 09:14:06');
INSERT INTO `access_log` VALUES (55828, '65.53.15634124458351053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:14:06', 10, 0, '', '2019-07-18 09:14:06');
INSERT INTO `access_log` VALUES (55829, '65.46.15634124458351111', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.133 Safari/537.36', '171.88.41.118', '2019-07-18 09:14:06', 11, 2001001000, '服务端发生异常', '2019-07-18 09:14:06');
INSERT INTO `access_log` VALUES (55830, '65.50.15634139757941081', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.88.5.46', '2019-07-18 09:39:36', 0, 1002001015, '账号未登陆', '2019-07-18 09:39:36');
INSERT INTO `access_log` VALUES (55831, '65.52.15634139757951103', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.88.5.46', '2019-07-18 09:39:36', 0, 1002001015, '账号未登陆', '2019-07-18 09:39:36');
INSERT INTO `access_log` VALUES (55832, '65.47.15634139758001057', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.88.5.46', '2019-07-18 09:39:36', 0, 1002001015, '账号未登陆', '2019-07-18 09:39:36');
INSERT INTO `access_log` VALUES (55833, '65.3607.15634139801092867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.88.5.46', '2019-07-18 09:39:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 09:39:40');
INSERT INTO `access_log` VALUES (55834, '65.53.15634139883441075', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.88.5.46', '2019-07-18 09:39:48', 70, 0, '', '2019-07-18 09:39:48');
INSERT INTO `access_log` VALUES (55835, '65.46.15634139886631133', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.88.5.46', '2019-07-18 09:39:49', 10, 0, '', '2019-07-18 09:39:49');
INSERT INTO `access_log` VALUES (55836, '65.51.15634139886701125', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.88.5.46', '2019-07-18 09:39:49', 10, 2001001000, '服务端发生异常', '2019-07-18 09:39:49');
INSERT INTO `access_log` VALUES (55837, '65.49.15634139886751047', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.88.5.46', '2019-07-18 09:39:49', 9, 0, '', '2019-07-18 09:39:49');
INSERT INTO `access_log` VALUES (55838, '65.50.15634140003791083', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.88.5.46', '2019-07-18 09:40:00', 31, 0, '', '2019-07-18 09:40:00');
INSERT INTO `access_log` VALUES (55839, '65.47.15634140003881059', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.88.5.46', '2019-07-18 09:40:00', 23, 0, '', '2019-07-18 09:40:00');
INSERT INTO `access_log` VALUES (55840, '65.52.15634140003841105', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.88.5.46', '2019-07-18 09:40:00', 28, 2001001000, '服务端发生异常', '2019-07-18 09:40:00');
INSERT INTO `access_log` VALUES (55841, '65.54.15634140034821011', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.88.5.46', '2019-07-18 09:40:03', 9, 0, '', '2019-07-18 09:40:03');
INSERT INTO `access_log` VALUES (55842, '65.3607.15634140034882869', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.88.5.46', '2019-07-18 09:40:03', 10, 2001001000, '服务端发生异常', '2019-07-18 09:40:03');
INSERT INTO `access_log` VALUES (55843, '65.53.15634140034921077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.88.5.46', '2019-07-18 09:40:03', 8, 0, '', '2019-07-18 09:40:04');
INSERT INTO `access_log` VALUES (55844, '59.75.15634140226689029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.88.5.46', '2019-07-18 09:40:23', 4, 0, '', '2019-07-18 09:40:23');
INSERT INTO `access_log` VALUES (55845, '59.72.15634140226689019', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.88.5.46', '2019-07-18 09:40:23', 19, 2001001000, '服务端发生异常', '2019-07-18 09:40:23');
INSERT INTO `access_log` VALUES (55846, '64.77.15634140798979215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:20', 14, 0, '', '2019-07-18 09:41:20');
INSERT INTO `access_log` VALUES (55847, '64.76.15634140799989225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:20', 4, 0, '', '2019-07-18 09:41:20');
INSERT INTO `access_log` VALUES (55848, '64.80.15634140813079239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:21', 2, 0, '', '2019-07-18 09:41:21');
INSERT INTO `access_log` VALUES (55849, '64.78.15634140819029235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:22', 1, 0, '', '2019-07-18 09:41:22');
INSERT INTO `access_log` VALUES (55850, '64.82.15634140823839241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:22', 2, 0, '', '2019-07-18 09:41:22');
INSERT INTO `access_log` VALUES (55851, '64.85.15634140829699247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:23', 3, 0, '', '2019-07-18 09:41:23');
INSERT INTO `access_log` VALUES (55852, '64.84.15634140858979221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:26', 2, 0, '', '2019-07-18 09:41:26');
INSERT INTO `access_log` VALUES (55853, '64.81.15634140862199215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:26', 2, 0, '', '2019-07-18 09:41:26');
INSERT INTO `access_log` VALUES (55854, '64.83.15634140865459227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:27', 2, 0, '', '2019-07-18 09:41:27');
INSERT INTO `access_log` VALUES (55855, '64.77.15634140871199217', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:27', 2, 0, '', '2019-07-18 09:41:27');
INSERT INTO `access_log` VALUES (55856, '64.76.15634140874029227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:27', 2, 0, '', '2019-07-18 09:41:27');
INSERT INTO `access_log` VALUES (55857, '59.71.15634140882279021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:28', 2, 0, '', '2019-07-18 09:41:28');
INSERT INTO `access_log` VALUES (55858, '59.76.15634140882369015', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:28', 14, 2001001000, '服务端发生异常', '2019-07-18 09:41:28');
INSERT INTO `access_log` VALUES (55859, '66.48.15634141037066941', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13333333333&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:44', 16, 1001003001, '验证码已过期', '2019-07-18 09:41:44');
INSERT INTO `access_log` VALUES (55860, '66.57.15634141061106931', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13333333333&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:46', 8, 1001003001, '验证码已过期', '2019-07-18 09:41:46');
INSERT INTO `access_log` VALUES (55861, '66.51.15634141107036957', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13333333330&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:51', 7, 1001003000, '验证码不存在', '2019-07-18 09:41:51');
INSERT INTO `access_log` VALUES (55862, '66.53.15634141128596929', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13333333330', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:53', 77, 0, '', '2019-07-18 09:41:53');
INSERT INTO `access_log` VALUES (55863, '66.50.15634141149736925', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13333333330&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:41:55', 207, 0, '', '2019-07-18 09:41:55');
INSERT INTO `access_log` VALUES (55864, '59.78.15634141205109021', 175, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:42:01', 10, 0, '', '2019-07-18 09:42:01');
INSERT INTO `access_log` VALUES (55865, '59.80.15634141205119003', 175, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:42:01', 23, 2001001000, '服务端发生异常', '2019-07-18 09:42:01');
INSERT INTO `access_log` VALUES (55866, '66.55.15634141234196913', 175, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:42:03', 5, 0, '', '2019-07-18 09:42:03');
INSERT INTO `access_log` VALUES (55867, '66.48.15634141284776943', 175, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:42:08', 6, 0, '', '2019-07-18 09:42:08');
INSERT INTO `access_log` VALUES (55868, '59.79.15634141303459027', 175, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:42:10', 6, 0, '', '2019-07-18 09:42:10');
INSERT INTO `access_log` VALUES (55869, '59.76.15634141303449017', 175, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.88.5.46', '2019-07-18 09:42:10', 19, 2001001000, '服务端发生异常', '2019-07-18 09:42:10');
INSERT INTO `access_log` VALUES (55870, '59.74.15634146529579039', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 09:50:53', 3, 0, '', '2019-07-18 09:50:53');
INSERT INTO `access_log` VALUES (55871, '59.71.15634146529579031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 09:50:53', 17, 2001001000, '服务端发生异常', '2019-07-18 09:50:53');
INSERT INTO `access_log` VALUES (55872, '59.80.15634158118169027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.3.152.10', '2019-07-18 10:10:12', 3, 0, '', '2019-07-18 10:10:12');
INSERT INTO `access_log` VALUES (55873, '59.74.15634158118169055', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '218.3.152.10', '2019-07-18 10:10:12', 16, 2001001000, '服务端发生异常', '2019-07-18 10:10:12');
INSERT INTO `access_log` VALUES (55874, '65.46.15634165577671169', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.183.95', '2019-07-18 10:22:38', 0, 1002001015, '账号未登陆', '2019-07-18 10:22:38');
INSERT INTO `access_log` VALUES (55875, '65.49.15634165577681083', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.183.95', '2019-07-18 10:22:38', 0, 1002001015, '账号未登陆', '2019-07-18 10:22:38');
INSERT INTO `access_log` VALUES (55876, '65.51.15634165577691161', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.183.95', '2019-07-18 10:22:38', 1, 1002001015, '账号未登陆', '2019-07-18 10:22:38');
INSERT INTO `access_log` VALUES (55877, '65.50.15634165593841119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.183.95', '2019-07-18 10:22:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 10:22:39');
INSERT INTO `access_log` VALUES (55878, '65.47.15634165811581095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.183.95', '2019-07-18 10:23:01', 52, 0, '', '2019-07-18 10:23:01');
INSERT INTO `access_log` VALUES (55879, '65.53.15634165814681113', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.183.95', '2019-07-18 10:23:01', 12, 0, '', '2019-07-18 10:23:01');
INSERT INTO `access_log` VALUES (55880, '65.54.15634165814721047', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.183.95', '2019-07-18 10:23:01', 10, 0, '', '2019-07-18 10:23:01');
INSERT INTO `access_log` VALUES (55881, '65.3607.15634165814702905', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.183.95', '2019-07-18 10:23:01', 13, 2001001000, '服务端发生异常', '2019-07-18 10:23:01');
INSERT INTO `access_log` VALUES (55882, '65.49.15634166094201085', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.183.95', '2019-07-18 10:23:29', 9, 0, '', '2019-07-18 10:23:29');
INSERT INTO `access_log` VALUES (55883, '65.45.15634166094201093', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.183.95', '2019-07-18 10:23:29', 10, 2001001000, '服务端发生异常', '2019-07-18 10:23:29');
INSERT INTO `access_log` VALUES (55884, '65.50.15634166095681121', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.183.95', '2019-07-18 10:23:30', 10, 0, '', '2019-07-18 10:23:30');
INSERT INTO `access_log` VALUES (55885, '59.74.15634167004469067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.103.9.7', '2019-07-18 10:25:00', 3, 0, '', '2019-07-18 10:25:00');
INSERT INTO `access_log` VALUES (55886, '59.71.15634167004699059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.103.9.7', '2019-07-18 10:25:00', 30, 2001001000, '服务端发生异常', '2019-07-18 10:25:01');
INSERT INTO `access_log` VALUES (55887, '64.84.15634167072529257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.103.9.7', '2019-07-18 10:25:07', 11, 0, '', '2019-07-18 10:25:07');
INSERT INTO `access_log` VALUES (55888, '64.81.15634167073989251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.103.9.7', '2019-07-18 10:25:07', 3, 0, '', '2019-07-18 10:25:07');
INSERT INTO `access_log` VALUES (55889, '59.79.15634167102329063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.103.9.7', '2019-07-18 10:25:10', 2, 0, '', '2019-07-18 10:25:10');
INSERT INTO `access_log` VALUES (55890, '59.76.15634167102329053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.103.9.7', '2019-07-18 10:25:10', 13, 2001001000, '服务端发生异常', '2019-07-18 10:25:10');
INSERT INTO `access_log` VALUES (55891, '65.52.15634167614701145', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.103.9.7', '2019-07-18 10:26:01', 1, 1002001015, '账号未登陆', '2019-07-18 10:26:01');
INSERT INTO `access_log` VALUES (55892, '65.47.15634167614781099', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.103.9.7', '2019-07-18 10:26:01', 0, 1002001015, '账号未登陆', '2019-07-18 10:26:01');
INSERT INTO `access_log` VALUES (55893, '65.3607.15634167615272909', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.103.9.7', '2019-07-18 10:26:02', 1, 1002001015, '账号未登陆', '2019-07-18 10:26:02');
INSERT INTO `access_log` VALUES (55894, '59.75.15634173046779077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.157.203.159', '2019-07-18 10:35:05', 16, 2001001000, '服务端发生异常', '2019-07-18 10:35:05');
INSERT INTO `access_log` VALUES (55895, '59.73.15634173046779071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.157.203.159', '2019-07-18 10:35:05', 112, 0, '', '2019-07-18 10:35:05');
INSERT INTO `access_log` VALUES (55896, '65.52.15634173143891153', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.157.203.159', '2019-07-18 10:35:14', 0, 1002001015, '账号未登陆', '2019-07-18 10:35:14');
INSERT INTO `access_log` VALUES (55897, '65.47.15634173143921107', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.157.203.159', '2019-07-18 10:35:14', 1, 1002001015, '账号未登陆', '2019-07-18 10:35:14');
INSERT INTO `access_log` VALUES (55898, '65.3607.15634173143952917', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.157.203.159', '2019-07-18 10:35:14', 0, 1002001015, '账号未登陆', '2019-07-18 10:35:14');
INSERT INTO `access_log` VALUES (55899, '65.54.15634173163531059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.157.203.159', '2019-07-18 10:35:16', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 10:35:16');
INSERT INTO `access_log` VALUES (55900, '65.46.15634173271521183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.157.203.159', '2019-07-18 10:35:27', 83, 0, '', '2019-07-18 10:35:27');
INSERT INTO `access_log` VALUES (55901, '65.51.15634173274891175', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.157.203.159', '2019-07-18 10:35:27', 10, 0, '', '2019-07-18 10:35:28');
INSERT INTO `access_log` VALUES (55902, '65.49.15634173274951097', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.157.203.159', '2019-07-18 10:35:27', 11, 2001001000, '服务端发生异常', '2019-07-18 10:35:28');
INSERT INTO `access_log` VALUES (55903, '65.45.15634173274981105', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.157.203.159', '2019-07-18 10:35:27', 8, 0, '', '2019-07-18 10:35:28');
INSERT INTO `access_log` VALUES (55904, '65.52.15634178022271161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.103.9.7', '2019-07-18 10:43:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 10:43:22');
INSERT INTO `access_log` VALUES (55905, '65.47.15634178059491115', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '123.103.9.7', '2019-07-18 10:43:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 10:43:26');
INSERT INTO `access_log` VALUES (55906, '65.53.15634192939741153', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 11:08:14', 1, 1002001015, '账号未登陆', '2019-07-18 11:08:14');
INSERT INTO `access_log` VALUES (55907, '65.50.15634192939751163', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 11:08:14', 0, 1002001015, '账号未登陆', '2019-07-18 11:08:14');
INSERT INTO `access_log` VALUES (55908, '65.49.15634192939801127', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 11:08:14', 0, 1002001015, '账号未登陆', '2019-07-18 11:08:14');
INSERT INTO `access_log` VALUES (55909, '65.51.15634193082601203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 11:08:28', 81, 0, '', '2019-07-18 11:08:28');
INSERT INTO `access_log` VALUES (55910, '65.54.15634193085671089', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 11:08:29', 114, 0, '', '2019-07-18 11:08:29');
INSERT INTO `access_log` VALUES (55911, '65.52.15634193085711183', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 11:08:29', 111, 2001001000, '服务端发生异常', '2019-07-18 11:08:29');
INSERT INTO `access_log` VALUES (55912, '65.47.15634193085751139', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 11:08:29', 108, 0, '', '2019-07-18 11:08:29');
INSERT INTO `access_log` VALUES (55913, '65.50.15634193362121165', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 11:08:56', 9, 0, '', '2019-07-18 11:08:56');
INSERT INTO `access_log` VALUES (55914, '65.49.15634193362171129', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 11:08:56', 9, 2001001000, '服务端发生异常', '2019-07-18 11:08:56');
INSERT INTO `access_log` VALUES (55915, '65.53.15634193362181155', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 11:08:56', 9, 0, '', '2019-07-18 11:08:56');
INSERT INTO `access_log` VALUES (55916, '65.3607.15634193407502949', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 11:09:01', 9, 0, '', '2019-07-18 11:09:01');
INSERT INTO `access_log` VALUES (55917, '65.51.15634193407511205', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 11:09:01', 9, 2001001000, '服务端发生异常', '2019-07-18 11:09:01');
INSERT INTO `access_log` VALUES (55918, '65.47.15634193407631141', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.32.14.16', '2019-07-18 11:09:01', 8, 0, '', '2019-07-18 11:09:01');
INSERT INTO `access_log` VALUES (55919, '65.47.15634202128161153', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.64.248.255', '2019-07-18 11:23:33', 4, 1002001012, '访问令牌已过期', '2019-07-18 11:23:33');
INSERT INTO `access_log` VALUES (55920, '65.51.15634202128151217', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.64.248.255', '2019-07-18 11:23:33', 5, 1002001012, '访问令牌已过期', '2019-07-18 11:23:33');
INSERT INTO `access_log` VALUES (55921, '65.54.15634202128171103', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.64.248.255', '2019-07-18 11:23:33', 4, 1002001012, '访问令牌已过期', '2019-07-18 11:23:33');
INSERT INTO `access_log` VALUES (55922, '65.52.15634202144741197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.64.248.255', '2019-07-18 11:23:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 11:23:34');
INSERT INTO `access_log` VALUES (55923, '65.46.15634202175771227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.64.248.255', '2019-07-18 11:23:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 11:23:38');
INSERT INTO `access_log` VALUES (55924, '65.50.15634202223451179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.64.248.255', '2019-07-18 11:23:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 11:23:42');
INSERT INTO `access_log` VALUES (55925, '65.53.15634202456941169', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.64.248.255', '2019-07-18 11:24:06', 236, 0, '', '2019-07-18 11:24:06');
INSERT INTO `access_log` VALUES (55926, '65.3607.15634202461262963', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.64.248.255', '2019-07-18 11:24:06', 9, 0, '', '2019-07-18 11:24:06');
INSERT INTO `access_log` VALUES (55927, '65.51.15634202461271219', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.64.248.255', '2019-07-18 11:24:06', 10, 2001001000, '服务端发生异常', '2019-07-18 11:24:06');
INSERT INTO `access_log` VALUES (55928, '65.54.15634202461301105', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.64.248.255', '2019-07-18 11:24:06', 15, 0, '', '2019-07-18 11:24:06');
INSERT INTO `access_log` VALUES (55929, '59.71.15634206768899113', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 11:31:17', 10, 0, '', '2019-07-18 11:31:17');
INSERT INTO `access_log` VALUES (55930, '59.77.15634206768899103', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 11:31:17', 15, 2001001000, '服务端发生异常', '2019-07-18 11:31:17');
INSERT INTO `access_log` VALUES (55931, '64.78.15634206829519325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 11:31:23', 11, 0, '', '2019-07-18 11:31:23');
INSERT INTO `access_log` VALUES (55932, '64.82.15634206830989331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 11:31:23', 3, 0, '', '2019-07-18 11:31:23');
INSERT INTO `access_log` VALUES (55933, '59.76.15634206851789107', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 11:31:25', 3, 0, '', '2019-07-18 11:31:25');
INSERT INTO `access_log` VALUES (55934, '59.73.15634206851789117', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 11:31:25', 14, 2001001000, '服务端发生异常', '2019-07-18 11:31:25');
INSERT INTO `access_log` VALUES (55935, '59.72.15634206943219113', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 11:31:34', 2, 0, '', '2019-07-18 11:31:34');
INSERT INTO `access_log` VALUES (55936, '59.78.15634206943219113', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 11:31:34', 13, 2001001000, '服务端发生异常', '2019-07-18 11:31:34');
INSERT INTO `access_log` VALUES (55937, '64.84.15634206969719311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 11:31:37', 2, 0, '', '2019-07-18 11:31:37');
INSERT INTO `access_log` VALUES (55938, '64.81.15634206970829305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 11:31:37', 1, 0, '', '2019-07-18 11:31:37');
INSERT INTO `access_log` VALUES (55939, '64.83.15634206990559317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 11:31:39', 2, 0, '', '2019-07-18 11:31:39');
INSERT INTO `access_log` VALUES (55940, '64.77.15634206996959307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 11:31:40', 2, 0, '', '2019-07-18 11:31:40');
INSERT INTO `access_log` VALUES (55941, '59.74.15634207167729123', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 11:31:57', 2, 0, '', '2019-07-18 11:31:57');
INSERT INTO `access_log` VALUES (55942, '59.71.15634207167729115', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 11:31:57', 21, 2001001000, '服务端发生异常', '2019-07-18 11:31:57');
INSERT INTO `access_log` VALUES (55943, '59.76.15634207434879109', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:23', 3, 0, '', '2019-07-18 11:32:23');
INSERT INTO `access_log` VALUES (55944, '59.73.15634207434899119', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:23', 13, 2001001000, '服务端发生异常', '2019-07-18 11:32:24');
INSERT INTO `access_log` VALUES (55945, '64.78.15634207465579327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:27', 2, 0, '', '2019-07-18 11:32:27');
INSERT INTO `access_log` VALUES (55946, '64.82.15634207466879333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:27', 1, 0, '', '2019-07-18 11:32:27');
INSERT INTO `access_log` VALUES (55947, '64.85.15634207499529339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:30', 2, 0, '', '2019-07-18 11:32:30');
INSERT INTO `access_log` VALUES (55948, '64.84.15634207501329313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:30', 1, 0, '', '2019-07-18 11:32:30');
INSERT INTO `access_log` VALUES (55949, '64.83.15634207596179319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:40', 2, 0, '', '2019-07-18 11:32:40');
INSERT INTO `access_log` VALUES (55950, '64.77.15634207607829309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:41', 2, 0, '', '2019-07-18 11:32:41');
INSERT INTO `access_log` VALUES (55951, '64.76.15634207616509319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:42', 2, 0, '', '2019-07-18 11:32:42');
INSERT INTO `access_log` VALUES (55952, '64.79.15634207620629323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:42', 1, 0, '', '2019-07-18 11:32:42');
INSERT INTO `access_log` VALUES (55953, '64.78.15634207724429329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:52', 2, 0, '', '2019-07-18 11:32:52');
INSERT INTO `access_log` VALUES (55954, '64.82.15634207728219335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:53', 2, 0, '', '2019-07-18 11:32:53');
INSERT INTO `access_log` VALUES (55955, '59.80.15634207737089097', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:54', 2, 0, '', '2019-07-18 11:32:54');
INSERT INTO `access_log` VALUES (55956, '59.78.15634207737079115', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:54', 41, 2001001000, '服务端发生异常', '2019-07-18 11:32:54');
INSERT INTO `access_log` VALUES (55957, '64.85.15634207793639341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:32:59', 1, 0, '', '2019-07-18 11:32:59');
INSERT INTO `access_log` VALUES (55958, '64.84.15634207802879315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:00', 2, 0, '', '2019-07-18 11:33:00');
INSERT INTO `access_log` VALUES (55959, '59.74.15634207813049125', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:01', 2, 0, '', '2019-07-18 11:33:01');
INSERT INTO `access_log` VALUES (55960, '59.71.15634207813049117', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:01', 14, 2001001000, '服务端发生异常', '2019-07-18 11:33:01');
INSERT INTO `access_log` VALUES (55961, '64.81.15634207837019309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:04', 3, 0, '', '2019-07-18 11:33:04');
INSERT INTO `access_log` VALUES (55962, '64.77.15634207865279311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:07', 1, 0, '', '2019-07-18 11:33:07');
INSERT INTO `access_log` VALUES (55963, '64.76.15634207975259321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:18', 2, 0, '', '2019-07-18 11:33:18');
INSERT INTO `access_log` VALUES (55964, '64.79.15634207976829325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:18', 2, 0, '', '2019-07-18 11:33:18');
INSERT INTO `access_log` VALUES (55965, '64.78.15634208128419331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:33', 2, 0, '', '2019-07-18 11:33:33');
INSERT INTO `access_log` VALUES (55966, '64.82.15634208139619337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:34', 2, 0, '', '2019-07-18 11:33:34');
INSERT INTO `access_log` VALUES (55967, '59.76.15634208146869111', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:35', 12, 2001001000, '服务端发生异常', '2019-07-18 11:33:35');
INSERT INTO `access_log` VALUES (55968, '59.75.15634208151089127', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:35', 2, 0, '', '2019-07-18 11:33:35');
INSERT INTO `access_log` VALUES (55969, '64.84.15634208230099317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:43', 2, 0, '', '2019-07-18 11:33:43');
INSERT INTO `access_log` VALUES (55970, '64.81.15634208231629311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:43', 2, 0, '', '2019-07-18 11:33:43');
INSERT INTO `access_log` VALUES (55971, '64.83.15634208263019323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:46', 2, 0, '', '2019-07-18 11:33:46');
INSERT INTO `access_log` VALUES (55972, '64.77.15634208270999313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:47', 2, 0, '', '2019-07-18 11:33:47');
INSERT INTO `access_log` VALUES (55973, '59.72.15634208273849117', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:47', 2, 0, '', '2019-07-18 11:33:47');
INSERT INTO `access_log` VALUES (55974, '59.80.15634208274179099', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:47', 12, 2001001000, '服务端发生异常', '2019-07-18 11:33:47');
INSERT INTO `access_log` VALUES (55975, '64.79.15634208360999327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:56', 2, 0, '', '2019-07-18 11:33:56');
INSERT INTO `access_log` VALUES (55976, '64.80.15634208374049337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:57', 2, 0, '', '2019-07-18 11:33:57');
INSERT INTO `access_log` VALUES (55977, '64.78.15634208388059333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:33:59', 2, 0, '', '2019-07-18 11:33:59');
INSERT INTO `access_log` VALUES (55978, '64.82.15634208403049339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:00', 2, 0, '', '2019-07-18 11:34:00');
INSERT INTO `access_log` VALUES (55979, '59.71.15634208411579119', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:01', 2, 0, '', '2019-07-18 11:34:01');
INSERT INTO `access_log` VALUES (55980, '59.74.15634208411579127', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:01', 14, 2001001000, '服务端发生异常', '2019-07-18 11:34:01');
INSERT INTO `access_log` VALUES (55981, '59.73.15634208514109123', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:11', 2, 0, '', '2019-07-18 11:34:11');
INSERT INTO `access_log` VALUES (55982, '59.79.15634208514109123', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:11', 17, 2001001000, '服务端发生异常', '2019-07-18 11:34:11');
INSERT INTO `access_log` VALUES (55983, '59.76.15634208554839113', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:15', 2, 0, '', '2019-07-18 11:34:15');
INSERT INTO `access_log` VALUES (55984, '59.75.15634208554849129', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:15', 18, 2001001000, '服务端发生异常', '2019-07-18 11:34:16');
INSERT INTO `access_log` VALUES (55985, '64.84.15634208580909319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:18', 2, 0, '', '2019-07-18 11:34:18');
INSERT INTO `access_log` VALUES (55986, '64.81.15634208582899313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:18', 2, 0, '', '2019-07-18 11:34:18');
INSERT INTO `access_log` VALUES (55987, '64.77.15634208606919315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:21', 2, 0, '', '2019-07-18 11:34:21');
INSERT INTO `access_log` VALUES (55988, '59.80.15634208617189101', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:22', 3, 0, '', '2019-07-18 11:34:22');
INSERT INTO `access_log` VALUES (55989, '64.76.15634208617639325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:22', 2, 0, '', '2019-07-18 11:34:22');
INSERT INTO `access_log` VALUES (55990, '59.78.15634208621349119', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:22', 12, 2001001000, '服务端发生异常', '2019-07-18 11:34:22');
INSERT INTO `access_log` VALUES (55991, '64.79.15634208750809329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:35', 2, 0, '', '2019-07-18 11:34:35');
INSERT INTO `access_log` VALUES (55992, '64.80.15634208752129339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:35', 1, 0, '', '2019-07-18 11:34:35');
INSERT INTO `access_log` VALUES (55993, '59.77.15634208763299111', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:36', 2, 0, '', '2019-07-18 11:34:36');
INSERT INTO `access_log` VALUES (55994, '59.74.15634208763289129', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:36', 12, 2001001000, '服务端发生异常', '2019-07-18 11:34:36');
INSERT INTO `access_log` VALUES (55995, '64.82.15634208887379341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:49', 2, 0, '', '2019-07-18 11:34:49');
INSERT INTO `access_log` VALUES (55996, '64.85.15634208897519347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:50', 2, 0, '', '2019-07-18 11:34:50');
INSERT INTO `access_log` VALUES (55997, '59.76.15634208950039115', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:55', 3, 0, '', '2019-07-18 11:34:55');
INSERT INTO `access_log` VALUES (55998, '59.79.15634208950039125', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:55', 13, 2001001000, '服务端发生异常', '2019-07-18 11:34:55');
INSERT INTO `access_log` VALUES (55999, '64.81.15634208987699315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:59', 2, 0, '', '2019-07-18 11:34:59');
INSERT INTO `access_log` VALUES (56000, '59.75.15634208994749131', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:59', 2, 0, '', '2019-07-18 11:34:59');
INSERT INTO `access_log` VALUES (56001, '59.72.15634208994799121', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:34:59', 11, 2001001000, '服务端发生异常', '2019-07-18 11:34:59');
INSERT INTO `access_log` VALUES (56002, '64.83.15634208995329327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:35:00', 2, 0, '', '2019-07-18 11:35:00');
INSERT INTO `access_log` VALUES (56003, '64.77.15634209022499317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:35:02', 2, 0, '', '2019-07-18 11:35:02');
INSERT INTO `access_log` VALUES (56004, '59.80.15634209028169103', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:35:03', 3, 0, '', '2019-07-18 11:35:03');
INSERT INTO `access_log` VALUES (56005, '59.78.15634209028169121', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:35:03', 18, 2001001000, '服务端发生异常', '2019-07-18 11:35:03');
INSERT INTO `access_log` VALUES (56006, '64.76.15634209028399327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:35:03', 1, 0, '', '2019-07-18 11:35:03');
INSERT INTO `access_log` VALUES (56007, '64.83.15634217503719339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:49:10', 685, 0, '', '2019-07-18 11:49:11');
INSERT INTO `access_log` VALUES (56008, '64.77.15634217521959329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:49:12', 2, 0, '', '2019-07-18 11:49:12');
INSERT INTO `access_log` VALUES (56009, '64.77.15634217521959329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:49:12', 2, 0, '', '2019-07-18 11:49:13');
INSERT INTO `access_log` VALUES (56010, '64.76.15634217549359339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:49:15', 440, 0, '', '2019-07-18 11:49:15');
INSERT INTO `access_log` VALUES (56011, '59.75.15634217557819143', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:49:16', 13, 2001001000, '服务端发生异常', '2019-07-18 11:49:16');
INSERT INTO `access_log` VALUES (56012, '64.79.15634217558059343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:49:16', 964, 0, '', '2019-07-18 11:49:17');
INSERT INTO `access_log` VALUES (56013, '59.80.15634217559059115', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:49:16', 864, 0, '', '2019-07-18 11:49:17');
INSERT INTO `access_log` VALUES (56014, '59.75.15634217557819143', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:49:16', 13, 2001001000, '服务端发生异常', '2019-07-18 11:49:17');
INSERT INTO `access_log` VALUES (56015, '64.80.15634217574089353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:49:17', 1296, 0, '', '2019-07-18 11:49:19');
INSERT INTO `access_log` VALUES (56016, '64.78.15634217592259349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:49:19', 50, 0, '', '2019-07-18 11:49:19');
INSERT INTO `access_log` VALUES (56017, '64.82.15634217600719355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:49:20', 297, 0, '', '2019-07-18 11:49:20');
INSERT INTO `access_log` VALUES (56018, '64.84.15634217636289335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:49:24', 2, 0, '', '2019-07-18 11:49:24');
INSERT INTO `access_log` VALUES (56019, '64.81.15634217654549329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:49:25', 2, 0, '', '2019-07-18 11:49:25');
INSERT INTO `access_log` VALUES (56020, '64.79.15634218202389345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:50:20', 2, 0, '', '2019-07-18 11:50:20');
INSERT INTO `access_log` VALUES (56021, '59.76.15634218238479129', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '117.23.80.34', '2019-07-18 11:50:24', 3, 0, '', '2019-07-18 11:50:24');
INSERT INTO `access_log` VALUES (56022, '59.72.15634218413909135', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; CLT-AL00 Build/HUAWEICLT-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.1.52 Mobile Safari/537.36 AliApp(DingTalk/4.6.25) com.alibaba.android.rimet/11281457 Channel/227200 language/zh-CN', '117.23.82.46', '2019-07-18 11:50:41', 7, 0, '', '2019-07-18 11:50:41');
INSERT INTO `access_log` VALUES (56023, '59.80.15634218413919117', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; CLT-AL00 Build/HUAWEICLT-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.1.52 Mobile Safari/537.36 AliApp(DingTalk/4.6.25) com.alibaba.android.rimet/11281457 Channel/227200 language/zh-CN', '117.23.82.46', '2019-07-18 11:50:41', 12, 2001001000, '服务端发生异常', '2019-07-18 11:50:41');
INSERT INTO `access_log` VALUES (56024, '64.85.15634218532509363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; CLT-AL00 Build/HUAWEICLT-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.1.52 Mobile Safari/537.36 AliApp(DingTalk/4.6.25) com.alibaba.android.rimet/11281457 Channel/227200 language/zh-CN', '117.23.82.46', '2019-07-18 11:50:53', 2, 0, '', '2019-07-18 11:50:53');
INSERT INTO `access_log` VALUES (56025, '64.84.15634218534029337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; CLT-AL00 Build/HUAWEICLT-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.1.52 Mobile Safari/537.36 AliApp(DingTalk/4.6.25) com.alibaba.android.rimet/11281457 Channel/227200 language/zh-CN', '117.23.82.46', '2019-07-18 11:50:53', 2, 0, '', '2019-07-18 11:50:53');
INSERT INTO `access_log` VALUES (56026, '64.81.15634218573999331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; CLT-AL00 Build/HUAWEICLT-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.1.52 Mobile Safari/537.36 AliApp(DingTalk/4.6.25) com.alibaba.android.rimet/11281457 Channel/227200 language/zh-CN', '117.23.82.46', '2019-07-18 11:50:57', 2, 0, '', '2019-07-18 11:50:57');
INSERT INTO `access_log` VALUES (56027, '64.83.15634218575849343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; CLT-AL00 Build/HUAWEICLT-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.1.52 Mobile Safari/537.36 AliApp(DingTalk/4.6.25) com.alibaba.android.rimet/11281457 Channel/227200 language/zh-CN', '117.23.82.46', '2019-07-18 11:50:58', 2, 0, '', '2019-07-18 11:50:58');
INSERT INTO `access_log` VALUES (56028, '64.77.15634218614429333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; CLT-AL00 Build/HUAWEICLT-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.1.52 Mobile Safari/537.36 AliApp(DingTalk/4.6.25) com.alibaba.android.rimet/11281457 Channel/227200 language/zh-CN', '117.23.82.46', '2019-07-18 11:51:01', 2, 0, '', '2019-07-18 11:51:01');
INSERT INTO `access_log` VALUES (56029, '64.76.15634218615659343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; CLT-AL00 Build/HUAWEICLT-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.1.52 Mobile Safari/537.36 AliApp(DingTalk/4.6.25) com.alibaba.android.rimet/11281457 Channel/227200 language/zh-CN', '117.23.82.46', '2019-07-18 11:51:02', 2, 0, '', '2019-07-18 11:51:02');
INSERT INTO `access_log` VALUES (56030, '59.78.15634218624839135', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; CLT-AL00 Build/HUAWEICLT-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.1.52 Mobile Safari/537.36 AliApp(DingTalk/4.6.25) com.alibaba.android.rimet/11281457 Channel/227200 language/zh-CN', '117.23.82.46', '2019-07-18 11:51:02', 3, 0, '', '2019-07-18 11:51:02');
INSERT INTO `access_log` VALUES (56031, '59.71.15634218624879137', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; CLT-AL00 Build/HUAWEICLT-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.1.52 Mobile Safari/537.36 AliApp(DingTalk/4.6.25) com.alibaba.android.rimet/11281457 Channel/227200 language/zh-CN', '117.23.82.46', '2019-07-18 11:51:02', 13, 2001001000, '服务端发生异常', '2019-07-18 11:51:03');
INSERT INTO `access_log` VALUES (56032, '59.73.15634229398679155', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:09:00', 3, 0, '', '2019-07-18 12:09:00');
INSERT INTO `access_log` VALUES (56033, '59.76.15634229398679145', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:09:00', 13, 2001001000, '服务端发生异常', '2019-07-18 12:09:00');
INSERT INTO `access_log` VALUES (56034, '64.78.15634229451659367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:09:05', 3, 0, '', '2019-07-18 12:09:05');
INSERT INTO `access_log` VALUES (56035, '64.82.15634229452759373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:09:05', 2, 0, '', '2019-07-18 12:09:05');
INSERT INTO `access_log` VALUES (56036, '64.84.15634229463509353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:09:06', 2, 0, '', '2019-07-18 12:09:06');
INSERT INTO `access_log` VALUES (56037, '64.81.15634229469199347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:09:07', 2, 0, '', '2019-07-18 12:09:07');
INSERT INTO `access_log` VALUES (56038, '59.80.15634229485649133', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:09:09', 3, 0, '', '2019-07-18 12:09:09');
INSERT INTO `access_log` VALUES (56039, '59.72.15634229485649151', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:09:09', 23, 2001001000, '服务端发生异常', '2019-07-18 12:09:09');
INSERT INTO `access_log` VALUES (56040, '59.75.15634229583919161', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:09:18', 3, 0, '', '2019-07-18 12:09:18');
INSERT INTO `access_log` VALUES (56041, '59.78.15634229583919151', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:09:18', 13, 2001001000, '服务端发生异常', '2019-07-18 12:09:18');
INSERT INTO `access_log` VALUES (56042, '59.76.15634230162799147', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:10:16', 3, 0, '', '2019-07-18 12:10:16');
INSERT INTO `access_log` VALUES (56043, '59.79.15634230162799157', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:10:16', 13, 2001001000, '服务端发生异常', '2019-07-18 12:10:16');
INSERT INTO `access_log` VALUES (56044, '64.80.15634230170469373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:10:17', 3, 0, '', '2019-07-18 12:10:17');
INSERT INTO `access_log` VALUES (56045, '64.78.15634230171389369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:10:17', 1, 0, '', '2019-07-18 12:10:17');
INSERT INTO `access_log` VALUES (56046, '59.80.15634230173479135', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:10:17', 7, 0, '', '2019-07-18 12:10:17');
INSERT INTO `access_log` VALUES (56047, '59.72.15634230173479153', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:10:17', 18, 2001001000, '服务端发生异常', '2019-07-18 12:10:17');
INSERT INTO `access_log` VALUES (56048, '65.3607.15634230749653001', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:11:15', 1, 1002001015, '账号未登陆', '2019-07-18 12:11:15');
INSERT INTO `access_log` VALUES (56049, '65.53.15634230749881207', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:11:15', 0, 1002001015, '账号未登陆', '2019-07-18 12:11:15');
INSERT INTO `access_log` VALUES (56050, '65.47.15634230750251193', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:11:15', 0, 1002001015, '账号未登陆', '2019-07-18 12:11:15');
INSERT INTO `access_log` VALUES (56051, '65.52.15634230878761237', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:11:28', 87, 0, '', '2019-07-18 12:11:28');
INSERT INTO `access_log` VALUES (56052, '65.49.15634230884911183', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:11:28', 12, 0, '', '2019-07-18 12:11:29');
INSERT INTO `access_log` VALUES (56053, '65.50.15634230884911221', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:11:28', 13, 0, '', '2019-07-18 12:11:29');
INSERT INTO `access_log` VALUES (56054, '65.45.15634230884911191', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:11:28', 14, 2001001000, '服务端发生异常', '2019-07-18 12:11:29');
INSERT INTO `access_log` VALUES (56055, '65.3607.15634231300893003', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:12:10', 9, 0, '', '2019-07-18 12:12:10');
INSERT INTO `access_log` VALUES (56056, '65.47.15634231300961195', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:12:10', 10, 2001001000, '服务端发生异常', '2019-07-18 12:12:10');
INSERT INTO `access_log` VALUES (56057, '65.46.15634231301041269', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:12:10', 8, 0, '', '2019-07-18 12:12:10');
INSERT INTO `access_log` VALUES (56058, '65.52.15634231354791239', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:12:15', 9, 0, '', '2019-07-18 12:12:15');
INSERT INTO `access_log` VALUES (56059, '65.45.15634231354911193', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:12:15', 9, 2001001000, '服务端发生异常', '2019-07-18 12:12:16');
INSERT INTO `access_log` VALUES (56060, '65.49.15634231355011185', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.81.182.10', '2019-07-18 12:12:16', 9, 0, '', '2019-07-18 12:12:16');
INSERT INTO `access_log` VALUES (56061, '59.80.15634234366199141', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '222.209.83.2', '2019-07-18 12:17:17', 3, 0, '', '2019-07-18 12:17:17');
INSERT INTO `access_log` VALUES (56062, '59.72.15634234366219159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '222.209.83.2', '2019-07-18 12:17:17', 12, 2001001000, '服务端发生异常', '2019-07-18 12:17:17');
INSERT INTO `access_log` VALUES (56063, '65.45.15634234490221197', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '222.209.83.2', '2019-07-18 12:17:29', 0, 1002001015, '账号未登陆', '2019-07-18 12:17:29');
INSERT INTO `access_log` VALUES (56064, '65.50.15634234490221229', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '222.209.83.2', '2019-07-18 12:17:29', 0, 1002001015, '账号未登陆', '2019-07-18 12:17:29');
INSERT INTO `access_log` VALUES (56065, '65.51.15634234490271269', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '222.209.83.2', '2019-07-18 12:17:29', 0, 1002001015, '账号未登陆', '2019-07-18 12:17:29');
INSERT INTO `access_log` VALUES (56066, '65.53.15634234511881217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '222.209.83.2', '2019-07-18 12:17:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 12:17:31');
INSERT INTO `access_log` VALUES (56067, '65.54.15634234647671153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '222.209.83.2', '2019-07-18 12:17:45', 192, 0, '', '2019-07-18 12:17:45');
INSERT INTO `access_log` VALUES (56068, '65.47.15634234653051203', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '222.209.83.2', '2019-07-18 12:17:45', 158, 0, '', '2019-07-18 12:17:45');
INSERT INTO `access_log` VALUES (56069, '65.49.15634234653101191', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '222.209.83.2', '2019-07-18 12:17:45', 156, 0, '', '2019-07-18 12:17:45');
INSERT INTO `access_log` VALUES (56070, '65.46.15634234653081275', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '222.209.83.2', '2019-07-18 12:17:45', 158, 2001001000, '服务端发生异常', '2019-07-18 12:17:45');
INSERT INTO `access_log` VALUES (56071, '65.50.15634272292181281', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '112.10.4.65', '2019-07-18 13:20:29', 1, 1002001015, '账号未登陆', '2019-07-18 13:20:29');
INSERT INTO `access_log` VALUES (56072, '65.45.15634272292181249', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '112.10.4.65', '2019-07-18 13:20:29', 1, 1002001015, '账号未登陆', '2019-07-18 13:20:29');
INSERT INTO `access_log` VALUES (56073, '65.51.15634272292221321', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '112.10.4.65', '2019-07-18 13:20:29', 0, 1002001015, '账号未登陆', '2019-07-18 13:20:29');
INSERT INTO `access_log` VALUES (56074, '65.53.15634272312511269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '112.10.4.65', '2019-07-18 13:20:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 13:20:31');
INSERT INTO `access_log` VALUES (56075, '65.54.15634272413601205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '112.10.4.65', '2019-07-18 13:20:41', 55, 0, '', '2019-07-18 13:20:41');
INSERT INTO `access_log` VALUES (56076, '65.47.15634272415901255', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '112.10.4.65', '2019-07-18 13:20:42', 24, 2001001000, '服务端发生异常', '2019-07-18 13:20:42');
INSERT INTO `access_log` VALUES (56077, '65.49.15634272415911243', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '112.10.4.65', '2019-07-18 13:20:42', 22, 0, '', '2019-07-18 13:20:42');
INSERT INTO `access_log` VALUES (56078, '65.46.15634272416011327', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '112.10.4.65', '2019-07-18 13:20:42', 17, 0, '', '2019-07-18 13:20:42');
INSERT INTO `access_log` VALUES (56079, '65.45.15634272838641251', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '112.10.4.65', '2019-07-18 13:21:24', 10, 0, '', '2019-07-18 13:21:24');
INSERT INTO `access_log` VALUES (56080, '65.51.15634272838651323', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '112.10.4.65', '2019-07-18 13:21:24', 10, 0, '', '2019-07-18 13:21:24');
INSERT INTO `access_log` VALUES (56081, '65.53.15634272838651271', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '112.10.4.65', '2019-07-18 13:21:24', 11, 2001001000, '服务端发生异常', '2019-07-18 13:21:24');
INSERT INTO `access_log` VALUES (56082, '65.45.15634292005351277', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:21', 0, 1002001015, '账号未登陆', '2019-07-18 13:53:21');
INSERT INTO `access_log` VALUES (56083, '65.53.15634292005351297', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:21', 0, 1002001015, '账号未登陆', '2019-07-18 13:53:21');
INSERT INTO `access_log` VALUES (56084, '65.3607.15634292005363091', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:21', 0, 1002001015, '账号未登陆', '2019-07-18 13:53:21');
INSERT INTO `access_log` VALUES (56085, '65.47.15634292114481283', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 13:53:31');
INSERT INTO `access_log` VALUES (56086, '65.46.15634292179181355', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:38', 84, 0, '', '2019-07-18 13:53:38');
INSERT INTO `access_log` VALUES (56087, '65.49.15634292181961271', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:38', 12, 0, '', '2019-07-18 13:53:38');
INSERT INTO `access_log` VALUES (56088, '65.52.15634292181971325', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:38', 12, 2001001000, '服务端发生异常', '2019-07-18 13:53:38');
INSERT INTO `access_log` VALUES (56089, '65.50.15634292182021311', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:38', 10, 0, '', '2019-07-18 13:53:38');
INSERT INTO `access_log` VALUES (56090, '65.53.15634292220351299', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:42', 9, 0, '', '2019-07-18 13:53:42');
INSERT INTO `access_log` VALUES (56091, '65.3607.15634292220423093', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:42', 8, 0, '', '2019-07-18 13:53:42');
INSERT INTO `access_log` VALUES (56092, '65.45.15634292220421279', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:42', 8, 2001001000, '服务端发生异常', '2019-07-18 13:53:42');
INSERT INTO `access_log` VALUES (56093, '65.54.15634292314871235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 13:53:51');
INSERT INTO `access_log` VALUES (56094, '65.47.15634292327021285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 13:53:53');
INSERT INTO `access_log` VALUES (56095, '65.46.15634292330481357', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 13:53:53');
INSERT INTO `access_log` VALUES (56096, '65.49.15634292333861273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 13:53:53');
INSERT INTO `access_log` VALUES (56097, '65.52.15634292338811327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 13:53:54');
INSERT INTO `access_log` VALUES (56098, '65.51.15634292343791353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.174.125.20', '2019-07-18 13:53:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 13:53:54');
INSERT INTO `access_log` VALUES (56099, '59.75.15634307979749267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 14:19:58', 11, 0, '', '2019-07-18 14:19:58');
INSERT INTO `access_log` VALUES (56100, '59.71.15634307979759259', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 14:19:58', 15, 2001001000, '服务端发生异常', '2019-07-18 14:19:58');
INSERT INTO `access_log` VALUES (56101, '59.78.15634313504799265', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-18 14:29:10', 36, 0, '', '2019-07-18 14:29:11');
INSERT INTO `access_log` VALUES (56102, '59.75.15634313505999275', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-18 14:29:11', 13, 2001001000, '服务端发生异常', '2019-07-18 14:29:11');
INSERT INTO `access_log` VALUES (56103, '59.77.15634313683209257', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-18 14:29:28', 3, 0, '', '2019-07-18 14:29:28');
INSERT INTO `access_log` VALUES (56104, '59.74.15634313683289275', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-18 14:29:28', 12, 2001001000, '服务端发生异常', '2019-07-18 14:29:28');
INSERT INTO `access_log` VALUES (56105, '64.79.15634313713219475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-18 14:29:31', 11, 0, '', '2019-07-18 14:29:31');
INSERT INTO `access_log` VALUES (56106, '64.80.15634313714859485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-18 14:29:31', 3, 0, '', '2019-07-18 14:29:31');
INSERT INTO `access_log` VALUES (56107, '64.78.15634313730269481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-18 14:29:33', 2, 0, '', '2019-07-18 14:29:33');
INSERT INTO `access_log` VALUES (56108, '64.82.15634313737969487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-18 14:29:34', 2, 0, '', '2019-07-18 14:29:34');
INSERT INTO `access_log` VALUES (56109, '59.79.15634313771069271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-18 14:29:37', 2, 0, '', '2019-07-18 14:29:37');
INSERT INTO `access_log` VALUES (56110, '59.76.15634313771049261', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-18 14:29:37', 12, 2001001000, '服务端发生异常', '2019-07-18 14:29:37');
INSERT INTO `access_log` VALUES (56111, '65.45.15634313872391311', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.17.169.238', '2019-07-18 14:29:47', 0, 1002001015, '账号未登陆', '2019-07-18 14:29:47');
INSERT INTO `access_log` VALUES (56112, '65.51.15634313872391383', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.17.169.238', '2019-07-18 14:29:47', 1, 1002001015, '账号未登陆', '2019-07-18 14:29:47');
INSERT INTO `access_log` VALUES (56113, '65.54.15634313872391267', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.17.169.238', '2019-07-18 14:29:47', 0, 1002001015, '账号未登陆', '2019-07-18 14:29:47');
INSERT INTO `access_log` VALUES (56114, '65.47.15634314195181317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.17.169.238', '2019-07-18 14:30:20', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 14:30:20');
INSERT INTO `access_log` VALUES (56115, '65.52.15634319173801363', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 14:38:37', 0, 1002001015, '账号未登陆', '2019-07-18 14:38:37');
INSERT INTO `access_log` VALUES (56116, '65.54.15634319174191275', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 14:38:37', 1, 1002001015, '账号未登陆', '2019-07-18 14:38:37');
INSERT INTO `access_log` VALUES (56117, '65.51.15634319174641391', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 14:38:37', 0, 1002001015, '账号未登陆', '2019-07-18 14:38:37');
INSERT INTO `access_log` VALUES (56118, '65.53.15634319262611339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 14:38:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 14:38:46');
INSERT INTO `access_log` VALUES (56119, '65.47.15634319352941325', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 14:38:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 14:38:55');
INSERT INTO `access_log` VALUES (56120, '65.49.15634319441151313', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 14:39:04', 121, 0, '', '2019-07-18 14:39:04');
INSERT INTO `access_log` VALUES (56121, '65.3607.15634319448143135', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 14:39:05', 10, 0, '', '2019-07-18 14:39:05');
INSERT INTO `access_log` VALUES (56122, '65.50.15634319448571351', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 14:39:05', 10, 2001001000, '服务端发生异常', '2019-07-18 14:39:05');
INSERT INTO `access_log` VALUES (56123, '65.52.15634319448831365', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 14:39:05', 9, 0, '', '2019-07-18 14:39:05');
INSERT INTO `access_log` VALUES (56124, '65.45.15634319698661321', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 14:39:30', 10, 0, '', '2019-07-18 14:39:30');
INSERT INTO `access_log` VALUES (56125, '65.53.15634319698791341', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 14:39:30', 10, 2001001000, '服务端发生异常', '2019-07-18 14:39:30');
INSERT INTO `access_log` VALUES (56126, '65.46.15634319698931397', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 14:39:30', 8, 0, '', '2019-07-18 14:39:30');
INSERT INTO `access_log` VALUES (56127, '65.52.15634329164361379', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.61.184.178', '2019-07-18 14:55:16', 1, 1002001015, '账号未登陆', '2019-07-18 14:55:16');
INSERT INTO `access_log` VALUES (56128, '65.50.15634329164361365', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.61.184.178', '2019-07-18 14:55:16', 1, 1002001015, '账号未登陆', '2019-07-18 14:55:16');
INSERT INTO `access_log` VALUES (56129, '65.51.15634329164431407', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.61.184.178', '2019-07-18 14:55:16', 0, 1002001015, '账号未登陆', '2019-07-18 14:55:16');
INSERT INTO `access_log` VALUES (56130, '65.46.15634329616391411', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.61.184.178', '2019-07-18 14:56:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 14:56:02');
INSERT INTO `access_log` VALUES (56131, '65.47.15634329649171341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.61.184.178', '2019-07-18 14:56:05', 91, 0, '', '2019-07-18 14:56:05');
INSERT INTO `access_log` VALUES (56132, '65.49.15634329653361329', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.61.184.178', '2019-07-18 14:56:05', 9, 0, '', '2019-07-18 14:56:05');
INSERT INTO `access_log` VALUES (56133, '65.3607.15634329653403151', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.61.184.178', '2019-07-18 14:56:05', 9, 2001001000, '服务端发生异常', '2019-07-18 14:56:05');
INSERT INTO `access_log` VALUES (56134, '65.51.15634329653491409', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.61.184.178', '2019-07-18 14:56:05', 9, 0, '', '2019-07-18 14:56:05');
INSERT INTO `access_log` VALUES (56135, '65.46.15634330409071413', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.61.184.178', '2019-07-18 14:57:21', 9, 0, '', '2019-07-18 14:57:21');
INSERT INTO `access_log` VALUES (56136, '65.47.15634330409091343', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.61.184.178', '2019-07-18 14:57:21', 9, 0, '', '2019-07-18 14:57:21');
INSERT INTO `access_log` VALUES (56137, '65.3607.15634330409123153', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.61.184.178', '2019-07-18 14:57:21', 9, 2001001000, '服务端发生异常', '2019-07-18 14:57:21');
INSERT INTO `access_log` VALUES (56138, '65.52.15634330883001383', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.129.6.159', '2019-07-18 14:58:08', 1, 1002001015, '账号未登陆', '2019-07-18 14:58:08');
INSERT INTO `access_log` VALUES (56139, '59.80.15634334827519277', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 15:04:43', 10, 0, '', '2019-07-18 15:04:43');
INSERT INTO `access_log` VALUES (56140, '59.78.15634334827539295', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 15:04:43', 14, 2001001000, '服务端发生异常', '2019-07-18 15:04:43');
INSERT INTO `access_log` VALUES (56141, '64.84.15634334896299495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 15:04:50', 179, 0, '', '2019-07-18 15:04:50');
INSERT INTO `access_log` VALUES (56142, '64.81.15634334900679489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 15:04:50', 3, 0, '', '2019-07-18 15:04:50');
INSERT INTO `access_log` VALUES (56143, '64.77.15634334932049491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 15:04:53', 2, 0, '', '2019-07-18 15:04:53');
INSERT INTO `access_log` VALUES (56144, '64.76.15634334968229501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 15:04:57', 2, 0, '', '2019-07-18 15:04:57');
INSERT INTO `access_log` VALUES (56145, '64.79.15634334978579505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 15:04:58', 2, 0, '', '2019-07-18 15:04:58');
INSERT INTO `access_log` VALUES (56146, '64.80.15634334985089515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 15:04:59', 2, 0, '', '2019-07-18 15:04:59');
INSERT INTO `access_log` VALUES (56147, '64.78.15634335054789511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 15:05:05', 2, 0, '', '2019-07-18 15:05:05');
INSERT INTO `access_log` VALUES (56148, '64.85.15634335056709523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.191.249.11', '2019-07-18 15:05:06', 2, 0, '', '2019-07-18 15:05:06');
INSERT INTO `access_log` VALUES (56149, '59.79.15634353610009325', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:36:01', 11, 0, '', '2019-07-18 15:36:01');
INSERT INTO `access_log` VALUES (56150, '59.76.15634353610019313', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:36:01', 22, 2001001000, '服务端发生异常', '2019-07-18 15:36:01');
INSERT INTO `access_log` VALUES (56151, '64.76.15634353671939527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:36:07', 11, 0, '', '2019-07-18 15:36:07');
INSERT INTO `access_log` VALUES (56152, '64.79.15634353673579531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:36:07', 3, 0, '', '2019-07-18 15:36:07');
INSERT INTO `access_log` VALUES (56153, '66.54.15634353843007213', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13222222222&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:36:24', 17, 1001003000, '验证码不存在', '2019-07-18 15:36:24');
INSERT INTO `access_log` VALUES (56154, '66.49.15634353871527219', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13222222222', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:36:27', 85, 0, '', '2019-07-18 15:36:27');
INSERT INTO `access_log` VALUES (56155, '66.48.15634353890567227', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13222222222&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:36:29', 309, 0, '', '2019-07-18 15:36:29');
INSERT INTO `access_log` VALUES (56156, '64.85.15634353979269549', 176, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:36:38', 9, 0, '', '2019-07-18 15:36:38');
INSERT INTO `access_log` VALUES (56157, '64.81.15634353981039517', 176, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:36:38', 8, 0, '', '2019-07-18 15:36:38');
INSERT INTO `access_log` VALUES (56158, '66.51.15634353996047243', 176, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:36:40', 6, 0, '', '2019-07-18 15:36:40');
INSERT INTO `access_log` VALUES (56159, '65.51.15634354198511443', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:37:00', 1, 1002001015, '账号未登陆', '2019-07-18 15:37:00');
INSERT INTO `access_log` VALUES (56160, '65.50.15634354198521401', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:37:00', 1, 1002001015, '账号未登陆', '2019-07-18 15:37:00');
INSERT INTO `access_log` VALUES (56161, '65.52.15634354198641415', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:37:00', 0, 1002001015, '账号未登陆', '2019-07-18 15:37:00');
INSERT INTO `access_log` VALUES (56162, '65.54.15634354249531327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:37:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 15:37:05');
INSERT INTO `access_log` VALUES (56163, '65.45.15634354288001371', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:37:09', 304, 0, '', '2019-07-18 15:37:09');
INSERT INTO `access_log` VALUES (56164, '65.3607.15634354294593187', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:37:09', 10, 0, '', '2019-07-18 15:37:09');
INSERT INTO `access_log` VALUES (56165, '65.47.15634354294721377', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:37:09', 11, 0, '', '2019-07-18 15:37:09');
INSERT INTO `access_log` VALUES (56166, '65.46.15634354294711447', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.65.209.215', '2019-07-18 15:37:09', 12, 2001001000, '服务端发生异常', '2019-07-18 15:37:09');
INSERT INTO `access_log` VALUES (56167, '59.79.15634365127139341', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '171.113.84.171', '2019-07-18 15:55:13', 3, 0, '', '2019-07-18 15:55:13');
INSERT INTO `access_log` VALUES (56168, '59.73.15634365127139341', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.139.214.166', '2019-07-18 15:55:13', 16, 2001001000, '服务端发生异常', '2019-07-18 15:55:13');
INSERT INTO `access_log` VALUES (56169, '64.80.15634365193049557', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.113.84.171', '2019-07-18 15:55:19', 4, 0, '', '2019-07-18 15:55:19');
INSERT INTO `access_log` VALUES (56170, '64.82.15634365194079559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.113.84.171', '2019-07-18 15:55:19', 2, 0, '', '2019-07-18 15:55:19');
INSERT INTO `access_log` VALUES (56171, '64.85.15634365211229565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.113.84.171', '2019-07-18 15:55:21', 2, 0, '', '2019-07-18 15:55:21');
INSERT INTO `access_log` VALUES (56172, '64.84.15634365215549539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.113.84.171', '2019-07-18 15:55:22', 2, 0, '', '2019-07-18 15:55:22');
INSERT INTO `access_log` VALUES (56173, '64.81.15634365223339533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.113.84.171', '2019-07-18 15:55:22', 1, 0, '', '2019-07-18 15:55:22');
INSERT INTO `access_log` VALUES (56174, '64.83.15634365233669545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.139.214.166', '2019-07-18 15:55:23', 3, 0, '', '2019-07-18 15:55:23');
INSERT INTO `access_log` VALUES (56175, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.113.84.171', '2019-07-18 15:55:23', 7, 0, '', '2019-07-18 15:55:23');
INSERT INTO `access_log` VALUES (56176, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.113.84.171', '2019-07-18 15:55:24', 5, 0, '', '2019-07-18 15:55:24');
INSERT INTO `access_log` VALUES (56177, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.113.84.171', '2019-07-18 15:55:25', 5, 0, '', '2019-07-18 15:55:25');
INSERT INTO `access_log` VALUES (56178, '64.77.15634365260649535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.113.84.171', '2019-07-18 15:55:26', 2, 0, '', '2019-07-18 15:55:26');
INSERT INTO `access_log` VALUES (56179, '64.76.15634365261609545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.113.84.171', '2019-07-18 15:55:26', 2, 0, '', '2019-07-18 15:55:26');
INSERT INTO `access_log` VALUES (56180, '59.72.15634365308999337', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.113.84.171', '2019-07-18 15:55:31', 4, 0, '', '2019-07-18 15:55:31');
INSERT INTO `access_log` VALUES (56181, '59.78.15634365309019337', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.139.214.166', '2019-07-18 15:55:31', 15, 2001001000, '服务端发生异常', '2019-07-18 15:55:31');
INSERT INTO `access_log` VALUES (56182, '59.80.15634365337469319', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.113.84.171', '2019-07-18 15:55:34', 3, 0, '', '2019-07-18 15:55:34');
INSERT INTO `access_log` VALUES (56183, '59.75.15634365337469347', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.139.214.166', '2019-07-18 15:55:34', 12, 2001001000, '服务端发生异常', '2019-07-18 15:55:34');
INSERT INTO `access_log` VALUES (56184, '59.77.15634365342629329', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.139.214.166', '2019-07-18 15:55:34', 3, 0, '', '2019-07-18 15:55:34');
INSERT INTO `access_log` VALUES (56185, '59.74.15634365342629347', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.113.84.171', '2019-07-18 15:55:34', 19, 2001001000, '服务端发生异常', '2019-07-18 15:55:34');
INSERT INTO `access_log` VALUES (56186, '59.71.15634369426499345', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 16:02:23', 3, 0, '', '2019-07-18 16:02:23');
INSERT INTO `access_log` VALUES (56187, '59.74.15634369426519353', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 16:02:23', 16, 2001001000, '服务端发生异常', '2019-07-18 16:02:23');
INSERT INTO `access_log` VALUES (56188, '59.79.15634369773659349', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 16:02:57', 3, 0, '', '2019-07-18 16:02:57');
INSERT INTO `access_log` VALUES (56189, '59.76.15634369773659337', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 16:02:57', 13, 2001001000, '服务端发生异常', '2019-07-18 16:02:57');
INSERT INTO `access_log` VALUES (56190, '59.73.15634375092249357', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:11:49', 3, 0, '', '2019-07-18 16:11:49');
INSERT INTO `access_log` VALUES (56191, '59.77.15634375092239343', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:11:49', 13, 2001001000, '服务端发生异常', '2019-07-18 16:11:49');
INSERT INTO `access_log` VALUES (56192, '64.81.15634375192059547', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:11:59', 3, 0, '', '2019-07-18 16:11:59');
INSERT INTO `access_log` VALUES (56193, '64.83.15634375194249559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:11:59', 2, 0, '', '2019-07-18 16:11:59');
INSERT INTO `access_log` VALUES (56194, '64.77.15634375204179549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:12:00', 2, 0, '', '2019-07-18 16:12:00');
INSERT INTO `access_log` VALUES (56195, '64.79.15634375331959563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:12:13', 2, 0, '', '2019-07-18 16:12:13');
INSERT INTO `access_log` VALUES (56196, '64.80.15634375338119573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:12:14', 2, 0, '', '2019-07-18 16:12:14');
INSERT INTO `access_log` VALUES (56197, '64.82.15634375341879575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:12:14', 2, 0, '', '2019-07-18 16:12:14');
INSERT INTO `access_log` VALUES (56198, '64.85.15634375466189581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:12:27', 2, 0, '', '2019-07-18 16:12:27');
INSERT INTO `access_log` VALUES (56199, '64.84.15634375467199555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:12:27', 2, 0, '', '2019-07-18 16:12:27');
INSERT INTO `access_log` VALUES (56200, '65.52.15634376579751449', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:14:18', 0, 1002001015, '账号未登陆', '2019-07-18 16:14:18');
INSERT INTO `access_log` VALUES (56201, '65.50.15634376579761435', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:14:18', 0, 1002001015, '账号未登陆', '2019-07-18 16:14:18');
INSERT INTO `access_log` VALUES (56202, '65.47.15634376579871409', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:14:18', 0, 1002001015, '账号未登陆', '2019-07-18 16:14:18');
INSERT INTO `access_log` VALUES (56203, '65.54.15634376603741361', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:14:20', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 16:14:20');
INSERT INTO `access_log` VALUES (56204, '65.53.15634376779161421', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=youdaoyuanma&password=youdaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:14:38', 4, 1002002000, '账号不存在', '2019-07-18 16:14:38');
INSERT INTO `access_log` VALUES (56205, '65.46.15634381400981483', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:22:20', 81, 0, '', '2019-07-18 16:22:20');
INSERT INTO `access_log` VALUES (56206, '65.45.15634381407371409', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:22:21', 9, 0, '', '2019-07-18 16:22:21');
INSERT INTO `access_log` VALUES (56207, '65.50.15634381407391443', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:22:21', 10, 0, '', '2019-07-18 16:22:21');
INSERT INTO `access_log` VALUES (56208, '65.49.15634381407371403', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:22:21', 11, 2001001000, '服务端发生异常', '2019-07-18 16:22:21');
INSERT INTO `access_log` VALUES (56209, '65.54.15634381718271369', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:22:52', 10, 0, '', '2019-07-18 16:22:52');
INSERT INTO `access_log` VALUES (56210, '65.53.15634381718311429', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:22:52', 8, 0, '', '2019-07-18 16:22:52');
INSERT INTO `access_log` VALUES (56211, '65.51.15634381718291483', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:22:52', 11, 2001001000, '服务端发生异常', '2019-07-18 16:22:52');
INSERT INTO `access_log` VALUES (56212, '65.50.15634381975401445', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:23:18', 9, 0, '', '2019-07-18 16:23:18');
INSERT INTO `access_log` VALUES (56213, '65.49.15634381975421405', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:23:18', 9, 2001001000, '服务端发生异常', '2019-07-18 16:23:18');
INSERT INTO `access_log` VALUES (56214, '65.45.15634381975441411', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '39.153.169.100', '2019-07-18 16:23:18', 9, 0, '', '2019-07-18 16:23:18');
INSERT INTO `access_log` VALUES (56215, '65.54.15634382535251371', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:24:14', 0, 1002001015, '账号未登陆', '2019-07-18 16:24:14');
INSERT INTO `access_log` VALUES (56216, '65.3607.15634382535273229', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:24:14', 1, 1002001015, '账号未登陆', '2019-07-18 16:24:14');
INSERT INTO `access_log` VALUES (56217, '65.46.15634382535301487', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:24:14', 1, 1002001015, '账号未登陆', '2019-07-18 16:24:14');
INSERT INTO `access_log` VALUES (56218, '65.49.15634382579981407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:24:18', 67, 0, '', '2019-07-18 16:24:18');
INSERT INTO `access_log` VALUES (56219, '65.45.15634382583241413', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:24:18', 8, 0, '', '2019-07-18 16:24:18');
INSERT INTO `access_log` VALUES (56220, '65.50.15634382583281447', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:24:18', 15, 2001001000, '服务端发生异常', '2019-07-18 16:24:18');
INSERT INTO `access_log` VALUES (56221, '65.52.15634382583311461', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:24:18', 15, 0, '', '2019-07-18 16:24:18');
INSERT INTO `access_log` VALUES (56222, '65.53.15634382773641433', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:24:37', 9, 0, '', '2019-07-18 16:24:37');
INSERT INTO `access_log` VALUES (56223, '65.51.15634382773681487', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:24:37', 9, 2001001000, '服务端发生异常', '2019-07-18 16:24:37');
INSERT INTO `access_log` VALUES (56224, '65.3607.15634382773903231', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:24:37', 9, 0, '', '2019-07-18 16:24:37');
INSERT INTO `access_log` VALUES (56225, '59.78.15634385964749367', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.224.244.183', '2019-07-18 16:29:56', 9, 0, '', '2019-07-18 16:29:56');
INSERT INTO `access_log` VALUES (56226, '59.72.15634385964769367', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.224.244.183', '2019-07-18 16:29:56', 12, 2001001000, '服务端发生异常', '2019-07-18 16:29:56');
INSERT INTO `access_log` VALUES (56227, '64.81.15634385996199563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.224.244.183', '2019-07-18 16:30:00', 3, 0, '', '2019-07-18 16:30:00');
INSERT INTO `access_log` VALUES (56228, '64.83.15634385997849575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.224.244.183', '2019-07-18 16:30:00', 2, 0, '', '2019-07-18 16:30:00');
INSERT INTO `access_log` VALUES (56229, '64.77.15634386008189565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.224.244.183', '2019-07-18 16:30:01', 2, 0, '', '2019-07-18 16:30:01');
INSERT INTO `access_log` VALUES (56230, '64.76.15634386011409575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.224.244.183', '2019-07-18 16:30:01', 1, 0, '', '2019-07-18 16:30:01');
INSERT INTO `access_log` VALUES (56231, '59.80.15634386025099349', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.224.244.183', '2019-07-18 16:30:03', 2, 0, '', '2019-07-18 16:30:03');
INSERT INTO `access_log` VALUES (56232, '59.75.15634386025089377', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.224.244.183', '2019-07-18 16:30:03', 16, 2001001000, '服务端发生异常', '2019-07-18 16:30:03');
INSERT INTO `access_log` VALUES (56233, '65.50.15634386303601453', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.224.244.183', '2019-07-18 16:30:30', 115, 0, '', '2019-07-18 16:30:30');
INSERT INTO `access_log` VALUES (56234, '65.52.15634386311591467', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.224.244.183', '2019-07-18 16:30:31', 154, 0, '', '2019-07-18 16:30:31');
INSERT INTO `access_log` VALUES (56235, '65.53.15634386311711439', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.224.244.183', '2019-07-18 16:30:31', 145, 0, '', '2019-07-18 16:30:31');
INSERT INTO `access_log` VALUES (56236, '65.47.15634386311671427', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.224.244.183', '2019-07-18 16:30:31', 150, 2001001000, '服务端发生异常', '2019-07-18 16:30:31');
INSERT INTO `access_log` VALUES (56237, '59.77.15634389227149363', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.110.226.65', '2019-07-18 16:35:23', 21, 2001001000, '服务端发生异常', '2019-07-18 16:35:23');
INSERT INTO `access_log` VALUES (56238, '59.73.15634389227149377', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '113.110.226.65', '2019-07-18 16:35:23', 39, 0, '', '2019-07-18 16:35:23');
INSERT INTO `access_log` VALUES (56239, '59.77.15634397868319375', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '27.205.146.185', '2019-07-18 16:49:47', 3, 0, '', '2019-07-18 16:49:47');
INSERT INTO `access_log` VALUES (56240, '59.75.15634397868359393', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '27.205.146.185', '2019-07-18 16:49:47', 14, 2001001000, '服务端发生异常', '2019-07-18 16:49:47');
INSERT INTO `access_log` VALUES (56241, '64.79.15634397936299595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '27.205.146.185', '2019-07-18 16:49:54', 3, 0, '', '2019-07-18 16:49:54');
INSERT INTO `access_log` VALUES (56242, '64.80.15634397938089605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '27.205.146.185', '2019-07-18 16:49:54', 2, 0, '', '2019-07-18 16:49:54');
INSERT INTO `access_log` VALUES (56243, '64.82.15634397952399607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '27.205.146.185', '2019-07-18 16:49:55', 2, 0, '', '2019-07-18 16:49:55');
INSERT INTO `access_log` VALUES (56244, '64.78.15634397961299601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '27.205.146.185', '2019-07-18 16:49:56', 2, 0, '', '2019-07-18 16:49:56');
INSERT INTO `access_log` VALUES (56245, '65.53.15634400734631459', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:54:33', 11, 0, '', '2019-07-18 16:54:33');
INSERT INTO `access_log` VALUES (56246, '65.47.15634400734641447', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:54:33', 11, 0, '', '2019-07-18 16:54:33');
INSERT INTO `access_log` VALUES (56247, '65.50.15634400734631473', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:54:33', 13, 2001001000, '服务端发生异常', '2019-07-18 16:54:33');
INSERT INTO `access_log` VALUES (56248, '65.52.15634400757311487', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:54:36', 8, 0, '', '2019-07-18 16:54:36');
INSERT INTO `access_log` VALUES (56249, '65.3607.15634400757373257', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:54:36', 10, 2001001000, '服务端发生异常', '2019-07-18 16:54:36');
INSERT INTO `access_log` VALUES (56250, '65.51.15634400757421513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.86.109.139', '2019-07-18 16:54:36', 8, 0, '', '2019-07-18 16:54:36');
INSERT INTO `access_log` VALUES (56251, '65.50.15634401465611475', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.236.233.130', '2019-07-18 16:55:47', 0, 1002001015, '账号未登陆', '2019-07-18 16:55:47');
INSERT INTO `access_log` VALUES (56252, '65.47.15634401465641449', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.236.233.130', '2019-07-18 16:55:47', 1, 1002001015, '账号未登陆', '2019-07-18 16:55:47');
INSERT INTO `access_log` VALUES (56253, '65.3607.15634401465703259', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.236.233.130', '2019-07-18 16:55:47', 0, 1002001015, '账号未登陆', '2019-07-18 16:55:47');
INSERT INTO `access_log` VALUES (56254, '65.51.15634401485061515', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.236.233.130', '2019-07-18 16:55:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 16:55:49');
INSERT INTO `access_log` VALUES (56255, '65.46.15634401557551517', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.236.233.130', '2019-07-18 16:55:56', 149, 0, '', '2019-07-18 16:55:56');
INSERT INTO `access_log` VALUES (56256, '65.54.15634401561471401', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.236.233.130', '2019-07-18 16:55:56', 7, 0, '', '2019-07-18 16:55:56');
INSERT INTO `access_log` VALUES (56257, '65.49.15634401561471437', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.236.233.130', '2019-07-18 16:55:56', 8, 2001001000, '服务端发生异常', '2019-07-18 16:55:56');
INSERT INTO `access_log` VALUES (56258, '65.45.15634401561541443', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.236.233.130', '2019-07-18 16:55:56', 8, 0, '', '2019-07-18 16:55:56');
INSERT INTO `access_log` VALUES (56259, '59.78.15634402475539391', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.84.176.35', '2019-07-18 16:57:28', 11, 0, '', '2019-07-18 16:57:28');
INSERT INTO `access_log` VALUES (56260, '59.72.15634402475539391', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.84.176.35', '2019-07-18 16:57:28', 20, 2001001000, '服务端发生异常', '2019-07-18 16:57:28');
INSERT INTO `access_log` VALUES (56261, '64.85.15634402518669619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.84.176.35', '2019-07-18 16:57:32', 3, 0, '', '2019-07-18 16:57:32');
INSERT INTO `access_log` VALUES (56262, '64.84.15634402520689593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.84.176.35', '2019-07-18 16:57:32', 1, 0, '', '2019-07-18 16:57:32');
INSERT INTO `access_log` VALUES (56263, '64.83.15634402568809599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.84.176.35', '2019-07-18 16:57:37', 5, 0, '', '2019-07-18 16:57:37');
INSERT INTO `access_log` VALUES (56264, '64.77.15634402572919589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '125.84.176.35', '2019-07-18 16:57:37', 9, 0, '', '2019-07-18 16:57:37');
INSERT INTO `access_log` VALUES (56265, '65.54.15634404299331405', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.7.229.92', '2019-07-18 17:00:30', 0, 1002001015, '账号未登陆', '2019-07-18 17:00:30');
INSERT INTO `access_log` VALUES (56266, '65.45.15634404299341447', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.7.229.92', '2019-07-18 17:00:30', 1, 1002001015, '账号未登陆', '2019-07-18 17:00:30');
INSERT INTO `access_log` VALUES (56267, '65.53.15634404299371467', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.7.229.92', '2019-07-18 17:00:30', 0, 1002001015, '账号未登陆', '2019-07-18 17:00:30');
INSERT INTO `access_log` VALUES (56268, '65.3607.15634404323823265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.7.229.92', '2019-07-18 17:00:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 17:00:32');
INSERT INTO `access_log` VALUES (56269, '65.50.15634404397931481', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.7.229.92', '2019-07-18 17:00:40', 4, 1002002001, '密码不正确', '2019-07-18 17:00:40');
INSERT INTO `access_log` VALUES (56270, '65.51.15634404445151521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.7.229.92', '2019-07-18 17:00:45', 4, 1002002000, '账号不存在', '2019-07-18 17:00:45');
INSERT INTO `access_log` VALUES (56271, '65.52.15634404722411497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.7.229.92', '2019-07-18 17:01:12', 74, 0, '', '2019-07-18 17:01:12');
INSERT INTO `access_log` VALUES (56272, '65.46.15634404726221523', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.7.229.92', '2019-07-18 17:01:13', 9, 0, '', '2019-07-18 17:01:13');
INSERT INTO `access_log` VALUES (56273, '65.45.15634404726231451', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.7.229.92', '2019-07-18 17:01:13', 9, 0, '', '2019-07-18 17:01:13');
INSERT INTO `access_log` VALUES (56274, '65.49.15634404726221443', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '116.7.229.92', '2019-07-18 17:01:13', 10, 2001001000, '服务端发生异常', '2019-07-18 17:01:13');
INSERT INTO `access_log` VALUES (56275, '65.51.15634405193811525', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '180.159.13.163', '2019-07-18 17:01:59', 1, 1002001015, '账号未登陆', '2019-07-18 17:01:59');
INSERT INTO `access_log` VALUES (56276, '65.3607.15634405193813267', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '180.159.13.163', '2019-07-18 17:01:59', 1, 1002001015, '账号未登陆', '2019-07-18 17:01:59');
INSERT INTO `access_log` VALUES (56277, '65.52.15634405193811499', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '180.159.13.163', '2019-07-18 17:01:59', 0, 1002001015, '账号未登陆', '2019-07-18 17:01:59');
INSERT INTO `access_log` VALUES (56278, '65.45.15634405212661453', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '180.159.13.163', '2019-07-18 17:02:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 17:02:01');
INSERT INTO `access_log` VALUES (56279, '65.46.15634405364861525', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '180.159.13.163', '2019-07-18 17:02:16', 206, 0, '', '2019-07-18 17:02:17');
INSERT INTO `access_log` VALUES (56280, '65.54.15634405373671409', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '180.159.13.163', '2019-07-18 17:02:17', 9, 0, '', '2019-07-18 17:02:17');
INSERT INTO `access_log` VALUES (56281, '65.47.15634405373681459', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '180.159.13.163', '2019-07-18 17:02:17', 9, 0, '', '2019-07-18 17:02:17');
INSERT INTO `access_log` VALUES (56282, '65.53.15634405373681471', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '180.159.13.163', '2019-07-18 17:02:17', 10, 2001001000, '服务端发生异常', '2019-07-18 17:02:17');
INSERT INTO `access_log` VALUES (56283, '65.51.15634405470871527', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '180.159.13.163', '2019-07-18 17:02:27', 10, 0, '', '2019-07-18 17:02:27');
INSERT INTO `access_log` VALUES (56284, '65.3607.15634405470893269', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '180.159.13.163', '2019-07-18 17:02:27', 8, 0, '', '2019-07-18 17:02:27');
INSERT INTO `access_log` VALUES (56285, '65.52.15634405470881501', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '180.159.13.163', '2019-07-18 17:02:27', 10, 2001001000, '服务端发生异常', '2019-07-18 17:02:27');
INSERT INTO `access_log` VALUES (56286, '59.78.15634406520199397', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 17:04:12', 13, 2001001000, '服务端发生异常', '2019-07-18 17:04:12');
INSERT INTO `access_log` VALUES (56287, '59.76.15634406520189389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 17:04:12', 74, 0, '', '2019-07-18 17:04:12');
INSERT INTO `access_log` VALUES (56288, '65.47.15634407656751463', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 17:06:06', 0, 1002001015, '账号未登陆', '2019-07-18 17:06:06');
INSERT INTO `access_log` VALUES (56289, '65.54.15634407656741413', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 17:06:06', 0, 1002001015, '账号未登陆', '2019-07-18 17:06:06');
INSERT INTO `access_log` VALUES (56290, '65.50.15634407656781491', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 17:06:06', 0, 1002001015, '账号未登陆', '2019-07-18 17:06:06');
INSERT INTO `access_log` VALUES (56291, '65.3607.15634407679823273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 17:06:08', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 17:06:08');
INSERT INTO `access_log` VALUES (56292, '65.52.15634407709801505', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 17:06:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 17:06:11');
INSERT INTO `access_log` VALUES (56293, '65.45.15634407724121459', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 17:06:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 17:06:12');
INSERT INTO `access_log` VALUES (56294, '65.49.15634407753431451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 17:06:15', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 17:06:15');
INSERT INTO `access_log` VALUES (56295, '65.46.15634407817621531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 17:06:22', 5, 1002002001, '密码不正确', '2019-07-18 17:06:22');
INSERT INTO `access_log` VALUES (56296, '65.47.15634407910181465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 17:06:31', 79, 0, '', '2019-07-18 17:06:31');
INSERT INTO `access_log` VALUES (56297, '65.54.15634407913211415', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 17:06:31', 11, 0, '', '2019-07-18 17:06:31');
INSERT INTO `access_log` VALUES (56298, '65.3607.15634407913233275', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 17:06:31', 10, 0, '', '2019-07-18 17:06:31');
INSERT INTO `access_log` VALUES (56299, '65.50.15634407913211493', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-18 17:06:31', 12, 2001001000, '服务端发生异常', '2019-07-18 17:06:31');
INSERT INTO `access_log` VALUES (56300, '65.46.15634408570381533', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.246.253.6', '2019-07-18 17:07:37', 1, 1002001015, '账号未登陆', '2019-07-18 17:07:37');
INSERT INTO `access_log` VALUES (56301, '65.53.15634408570411479', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.246.253.6', '2019-07-18 17:07:37', 1, 1002001015, '账号未登陆', '2019-07-18 17:07:37');
INSERT INTO `access_log` VALUES (56302, '65.47.15634408570481467', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.246.253.6', '2019-07-18 17:07:37', 0, 1002001015, '账号未登陆', '2019-07-18 17:07:37');
INSERT INTO `access_log` VALUES (56303, '65.3607.15634408670183277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.246.253.6', '2019-07-18 17:07:47', 74, 0, '', '2019-07-18 17:07:47');
INSERT INTO `access_log` VALUES (56304, '65.3607.15634409818503279', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:09:42', 0, 1002001015, '账号未登陆', '2019-07-18 17:09:42');
INSERT INTO `access_log` VALUES (56305, '65.54.15634409818501419', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:09:42', 1, 1002001015, '账号未登陆', '2019-07-18 17:09:42');
INSERT INTO `access_log` VALUES (56306, '65.50.15634409818491497', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:09:42', 0, 1002001015, '账号未登陆', '2019-07-18 17:09:42');
INSERT INTO `access_log` VALUES (56307, '65.51.15634409900501537', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:09:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 17:09:50');
INSERT INTO `access_log` VALUES (56308, '65.3607.15634410915133281', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.246.253.6', '2019-07-18 17:11:32', 103, 0, '', '2019-07-18 17:11:32');
INSERT INTO `access_log` VALUES (56309, '65.54.15634410920681421', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.246.253.6', '2019-07-18 17:11:32', 10, 0, '', '2019-07-18 17:11:32');
INSERT INTO `access_log` VALUES (56310, '65.51.15634410920991539', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.246.253.6', '2019-07-18 17:11:32', 10, 2001001000, '服务端发生异常', '2019-07-18 17:11:32');
INSERT INTO `access_log` VALUES (56311, '65.52.15634410921171513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.246.253.6', '2019-07-18 17:11:32', 9, 0, '', '2019-07-18 17:11:32');
INSERT INTO `access_log` VALUES (56312, '65.45.15634410966821467', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:11:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 17:11:37');
INSERT INTO `access_log` VALUES (56313, '65.46.15634411069521539', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.246.253.6', '2019-07-18 17:11:47', 111, 2001001000, '服务端发生异常', '2019-07-18 17:11:47');
INSERT INTO `access_log` VALUES (56314, '65.53.15634411069441485', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.246.253.6', '2019-07-18 17:11:47', 109, 0, '', '2019-07-18 17:11:47');
INSERT INTO `access_log` VALUES (56315, '65.47.15634411069621473', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.246.253.6', '2019-07-18 17:11:47', 103, 0, '', '2019-07-18 17:11:47');
INSERT INTO `access_log` VALUES (56316, '65.51.15634411430171541', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:12:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 17:12:23');
INSERT INTO `access_log` VALUES (56317, '65.52.15634411557751515', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:12:36', 116, 0, '', '2019-07-18 17:12:36');
INSERT INTO `access_log` VALUES (56318, '65.45.15634411562001469', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:12:36', 8, 0, '', '2019-07-18 17:12:36');
INSERT INTO `access_log` VALUES (56319, '65.49.15634411562011461', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:12:36', 9, 0, '', '2019-07-18 17:12:36');
INSERT INTO `access_log` VALUES (56320, '65.53.15634411562021487', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:12:36', 10, 2001001000, '服务端发生异常', '2019-07-18 17:12:36');
INSERT INTO `access_log` VALUES (56321, '65.47.15634411623271475', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:12:42', 10, 0, '', '2019-07-18 17:12:42');
INSERT INTO `access_log` VALUES (56322, '65.50.15634411623301503', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:12:42', 9, 0, '', '2019-07-18 17:12:42');
INSERT INTO `access_log` VALUES (56323, '65.3607.15634411623313285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:12:42', 10, 2001001000, '服务端发生异常', '2019-07-18 17:12:42');
INSERT INTO `access_log` VALUES (56324, '65.54.15634411866891425', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:13:07', 18, 0, '', '2019-07-18 17:13:07');
INSERT INTO `access_log` VALUES (56325, '65.52.15634411866891517', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:13:07', 19, 2001001000, '服务端发生异常', '2019-07-18 17:13:07');
INSERT INTO `access_log` VALUES (56326, '65.49.15634411867011463', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:13:07', 9, 0, '', '2019-07-18 17:13:07');
INSERT INTO `access_log` VALUES (56327, '65.3607.15634412253953287', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:13:45', 9, 0, '', '2019-07-18 17:13:45');
INSERT INTO `access_log` VALUES (56328, '65.50.15634412253981505', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:13:45', 10, 2001001000, '服务端发生异常', '2019-07-18 17:13:45');
INSERT INTO `access_log` VALUES (56329, '65.47.15634412254211477', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:13:45', 10, 0, '', '2019-07-18 17:13:45');
INSERT INTO `access_log` VALUES (56330, '59.76.15634412427789397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.128.130.124', '2019-07-18 17:14:03', 3, 0, '', '2019-07-18 17:14:03');
INSERT INTO `access_log` VALUES (56331, '59.72.15634412427799405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.128.130.124', '2019-07-18 17:14:03', 13, 2001001000, '服务端发生异常', '2019-07-18 17:14:03');
INSERT INTO `access_log` VALUES (56332, '64.84.15634412476599607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.128.130.124', '2019-07-18 17:14:08', 3, 0, '', '2019-07-18 17:14:08');
INSERT INTO `access_log` VALUES (56333, '64.81.15634412478089601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.128.130.124', '2019-07-18 17:14:08', 2, 0, '', '2019-07-18 17:14:08');
INSERT INTO `access_log` VALUES (56334, '64.83.15634412490909613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.128.130.124', '2019-07-18 17:14:09', 2, 0, '', '2019-07-18 17:14:09');
INSERT INTO `access_log` VALUES (56335, '64.77.15634412500309603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.128.130.124', '2019-07-18 17:14:10', 1, 0, '', '2019-07-18 17:14:10');
INSERT INTO `access_log` VALUES (56336, '59.79.15634412511169409', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.128.130.124', '2019-07-18 17:14:11', 2, 0, '', '2019-07-18 17:14:11');
INSERT INTO `access_log` VALUES (56337, '59.73.15634412511179411', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.128.130.124', '2019-07-18 17:14:11', 14, 2001001000, '服务端发生异常', '2019-07-18 17:14:11');
INSERT INTO `access_log` VALUES (56338, '65.53.15634412886381491', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:14:49', 9, 0, '', '2019-07-18 17:14:49');
INSERT INTO `access_log` VALUES (56339, '65.45.15634412886441473', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:14:49', 9, 2001001000, '服务端发生异常', '2019-07-18 17:14:49');
INSERT INTO `access_log` VALUES (56340, '65.46.15634412886591545', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '220.168.209.100', '2019-07-18 17:14:49', 9, 0, '', '2019-07-18 17:14:49');
INSERT INTO `access_log` VALUES (56341, '65.45.15634418346241481', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:23:55', 1, 1002001015, '账号未登陆', '2019-07-18 17:23:55');
INSERT INTO `access_log` VALUES (56342, '65.53.15634418346231499', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:23:55', 0, 1002001015, '账号未登陆', '2019-07-18 17:23:55');
INSERT INTO `access_log` VALUES (56343, '65.46.15634418346281553', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:23:55', 0, 1002001015, '账号未登陆', '2019-07-18 17:23:55');
INSERT INTO `access_log` VALUES (56344, '65.50.15634418393991515', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:23:59', 88, 0, '', '2019-07-18 17:23:59');
INSERT INTO `access_log` VALUES (56345, '65.3607.15634418397303297', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:24:00', 10, 0, '', '2019-07-18 17:24:00');
INSERT INTO `access_log` VALUES (56346, '65.47.15634418397331487', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:24:00', 10, 2001001000, '服务端发生异常', '2019-07-18 17:24:00');
INSERT INTO `access_log` VALUES (56347, '65.51.15634418397391555', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:24:00', 9, 0, '', '2019-07-18 17:24:00');
INSERT INTO `access_log` VALUES (56348, '59.75.15634418785239423', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:24:39', 3, 0, '', '2019-07-18 17:24:39');
INSERT INTO `access_log` VALUES (56349, '59.77.15634418785239405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:24:39', 13, 2001001000, '服务端发生异常', '2019-07-18 17:24:39');
INSERT INTO `access_log` VALUES (56350, '64.80.15634418819569635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:24:42', 94, 0, '', '2019-07-18 17:24:42');
INSERT INTO `access_log` VALUES (56351, '64.82.15634418826949637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:24:43', 8, 0, '', '2019-07-18 17:24:43');
INSERT INTO `access_log` VALUES (56352, '64.78.15634418835189631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:24:44', 2, 0, '', '2019-07-18 17:24:44');
INSERT INTO `access_log` VALUES (56353, '64.85.15634418842269643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:24:44', 2, 0, '', '2019-07-18 17:24:44');
INSERT INTO `access_log` VALUES (56354, '64.84.15634418903389617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:24:50', 2, 0, '', '2019-07-18 17:24:50');
INSERT INTO `access_log` VALUES (56355, '64.83.15634418905449623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:24:51', 2, 0, '', '2019-07-18 17:24:51');
INSERT INTO `access_log` VALUES (56356, '59.72.15634418911159415', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:24:51', 3, 0, '', '2019-07-18 17:24:51');
INSERT INTO `access_log` VALUES (56357, '59.76.15634418911159407', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '180.170.215.199', '2019-07-18 17:24:51', 19, 2001001000, '服务端发生异常', '2019-07-18 17:24:51');
INSERT INTO `access_log` VALUES (56358, '65.54.15634423120391443', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '118.112.94.196', '2019-07-18 17:31:52', 0, 1002001015, '账号未登陆', '2019-07-18 17:31:52');
INSERT INTO `access_log` VALUES (56359, '65.49.15634423120401481', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '118.112.94.196', '2019-07-18 17:31:52', 1, 1002001015, '账号未登陆', '2019-07-18 17:31:52');
INSERT INTO `access_log` VALUES (56360, '65.53.15634423120461507', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '118.112.94.196', '2019-07-18 17:31:52', 0, 1002001015, '账号未登陆', '2019-07-18 17:31:52');
INSERT INTO `access_log` VALUES (56361, '65.45.15634423137551489', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '118.112.94.196', '2019-07-18 17:31:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 17:31:54');
INSERT INTO `access_log` VALUES (56362, '65.50.15634423176331523', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '118.112.94.196', '2019-07-18 17:31:58', 5, 1002002001, '密码不正确', '2019-07-18 17:31:58');
INSERT INTO `access_log` VALUES (56363, '59.74.15634423945069431', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '116.25.96.65', '2019-07-18 17:33:15', 3, 0, '', '2019-07-18 17:33:15');
INSERT INTO `access_log` VALUES (56364, '59.71.15634423945079423', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '116.25.96.65', '2019-07-18 17:33:15', 12, 2001001000, '服务端发生异常', '2019-07-18 17:33:15');
INSERT INTO `access_log` VALUES (56365, '64.82.15634424018649645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '116.25.96.65', '2019-07-18 17:33:22', 3, 0, '', '2019-07-18 17:33:22');
INSERT INTO `access_log` VALUES (56366, '64.78.15634424020189639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '116.25.96.65', '2019-07-18 17:33:22', 2, 0, '', '2019-07-18 17:33:22');
INSERT INTO `access_log` VALUES (56367, '66.57.15634424063707311', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3833.0 Safari/537.36', '116.25.96.65', '2019-07-18 17:33:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字', '2019-07-18 17:33:26');
INSERT INTO `access_log` VALUES (56368, '59.80.15634459019139449', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.75.215.53', '2019-07-18 18:31:42', 22, 2001001000, '服务端发生异常', '2019-07-18 18:31:42');
INSERT INTO `access_log` VALUES (56369, '59.76.15634459019139461', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.75.215.53', '2019-07-18 18:31:42', 11, 0, '', '2019-07-18 18:31:42');
INSERT INTO `access_log` VALUES (56370, '64.83.15634459083529677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.75.215.53', '2019-07-18 18:31:48', 11, 0, '', '2019-07-18 18:31:48');
INSERT INTO `access_log` VALUES (56371, '64.77.15634459084829667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.75.215.53', '2019-07-18 18:31:48', 2, 0, '', '2019-07-18 18:31:48');
INSERT INTO `access_log` VALUES (56372, '64.76.15634459097589677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.75.215.53', '2019-07-18 18:31:50', 2, 0, '', '2019-07-18 18:31:50');
INSERT INTO `access_log` VALUES (56373, '64.79.15634459101599681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.75.215.53', '2019-07-18 18:31:50', 2, 0, '', '2019-07-18 18:31:50');
INSERT INTO `access_log` VALUES (56374, '64.82.15634459105509693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.75.215.53', '2019-07-18 18:31:51', 2, 0, '', '2019-07-18 18:31:51');
INSERT INTO `access_log` VALUES (56375, '59.73.15634459115639475', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.75.215.53', '2019-07-18 18:31:52', 4, 0, '', '2019-07-18 18:31:52');
INSERT INTO `access_log` VALUES (56376, '59.74.15634459115699479', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.75.215.53', '2019-07-18 18:31:52', 16, 2001001000, '服务端发生异常', '2019-07-18 18:31:52');
INSERT INTO `access_log` VALUES (56377, '64.78.15634459139919687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.75.215.53', '2019-07-18 18:31:54', 1, 0, '', '2019-07-18 18:31:54');
INSERT INTO `access_log` VALUES (56378, '64.85.15634459141729699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.75.215.53', '2019-07-18 18:31:54', 2, 0, '', '2019-07-18 18:31:54');
INSERT INTO `access_log` VALUES (56379, '65.47.15634507346731609', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-18 19:52:15', 12, 1002001012, '访问令牌已过期', '2019-07-18 19:52:15');
INSERT INTO `access_log` VALUES (56380, '65.52.15634507346731649', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-18 19:52:15', 14, 1002001012, '访问令牌已过期', '2019-07-18 19:52:15');
INSERT INTO `access_log` VALUES (56381, '65.53.15634507346801619', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-18 19:52:15', 9, 1002001012, '访问令牌已过期', '2019-07-18 19:52:15');
INSERT INTO `access_log` VALUES (56382, '65.54.15634507373631561', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-18 19:52:17', 109, 0, '', '2019-07-18 19:52:17');
INSERT INTO `access_log` VALUES (56383, '65.49.15634507377831593', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-18 19:52:18', 14, 0, '', '2019-07-18 19:52:18');
INSERT INTO `access_log` VALUES (56384, '65.45.15634507377851599', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-18 19:52:18', 12, 0, '', '2019-07-18 19:52:18');
INSERT INTO `access_log` VALUES (56385, '65.46.15634507377901677', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-18 19:52:18', 9, 0, '', '2019-07-18 19:52:18');
INSERT INTO `access_log` VALUES (56386, '65.47.15634624647111767', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '39.188.47.63', '2019-07-18 23:07:45', 0, 1002001015, '账号未登陆', '2019-07-18 23:07:45');
INSERT INTO `access_log` VALUES (56387, '65.52.15634624647111807', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '39.188.47.63', '2019-07-18 23:07:45', 0, 1002001015, '账号未登陆', '2019-07-18 23:07:45');
INSERT INTO `access_log` VALUES (56388, '65.53.15634624647121777', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '39.188.47.63', '2019-07-18 23:07:45', 0, 1002001015, '账号未登陆', '2019-07-18 23:07:45');
INSERT INTO `access_log` VALUES (56389, '65.54.15634624661601719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '39.188.47.63', '2019-07-18 23:07:46', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 23:07:46');
INSERT INTO `access_log` VALUES (56390, '65.46.15634624683321835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '39.188.47.63', '2019-07-18 23:07:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 23:07:48');
INSERT INTO `access_log` VALUES (56391, '65.45.15634624696201757', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '39.188.47.63', '2019-07-18 23:07:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 23:07:50');
INSERT INTO `access_log` VALUES (56392, '65.50.15634624852671795', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '39.188.47.63', '2019-07-18 23:08:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-18 23:08:05');
INSERT INTO `access_log` VALUES (56393, '59.75.15634633218979711', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:02', 10, 0, '', '2019-07-18 23:22:02');
INSERT INTO `access_log` VALUES (56394, '59.71.15634633218979703', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:02', 25, 2001001000, '服务端发生异常', '2019-07-18 23:22:02');
INSERT INTO `access_log` VALUES (56395, '64.81.15634633294029899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:09', 15, 0, '', '2019-07-18 23:22:09');
INSERT INTO `access_log` VALUES (56396, '64.83.15634633296379911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:10', 4, 0, '', '2019-07-18 23:22:10');
INSERT INTO `access_log` VALUES (56397, '64.77.15634633309029901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:11', 2, 0, '', '2019-07-18 23:22:11');
INSERT INTO `access_log` VALUES (56398, '64.76.15634633321199911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:12', 1, 0, '', '2019-07-18 23:22:12');
INSERT INTO `access_log` VALUES (56399, '59.72.15634633335299703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:14', 4, 0, '', '2019-07-18 23:22:14');
INSERT INTO `access_log` VALUES (56400, '59.78.15634633335299703', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:14', 20, 2001001000, '服务端发生异常', '2019-07-18 23:22:14');
INSERT INTO `access_log` VALUES (56401, '64.79.15634633355889915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:16', 2, 0, '', '2019-07-18 23:22:16');
INSERT INTO `access_log` VALUES (56402, '64.80.15634633357389925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:16', 2, 0, '', '2019-07-18 23:22:16');
INSERT INTO `access_log` VALUES (56403, '64.78.15634633442559921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:24', 2, 0, '', '2019-07-18 23:22:24');
INSERT INTO `access_log` VALUES (56404, '64.85.15634633444599933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:24', 2, 0, '', '2019-07-18 23:22:24');
INSERT INTO `access_log` VALUES (56405, '59.79.15634633497189707', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:30', 3, 0, '', '2019-07-18 23:22:30');
INSERT INTO `access_log` VALUES (56406, '59.80.15634633497179683', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:30', 18, 2001001000, '服务端发生异常', '2019-07-18 23:22:30');
INSERT INTO `access_log` VALUES (56407, '64.81.15634633560999901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:36', 1, 0, '', '2019-07-18 23:22:36');
INSERT INTO `access_log` VALUES (56408, '64.83.15634633563049913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:36', 1, 0, '', '2019-07-18 23:22:36');
INSERT INTO `access_log` VALUES (56409, '64.77.15634633600519903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:40', 2, 0, '', '2019-07-18 23:22:40');
INSERT INTO `access_log` VALUES (56410, '64.76.15634633609849913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:41', 2, 0, '', '2019-07-18 23:22:41');
INSERT INTO `access_log` VALUES (56411, '59.74.15634633620209713', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:42', 2, 0, '', '2019-07-18 23:22:42');
INSERT INTO `access_log` VALUES (56412, '59.71.15634633620459705', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:42', 16, 2001001000, '服务端发生异常', '2019-07-18 23:22:42');
INSERT INTO `access_log` VALUES (56413, '64.79.15634633649249917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:45', 2, 0, '', '2019-07-18 23:22:45');
INSERT INTO `access_log` VALUES (56414, '64.80.15634633653359927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:45', 2, 0, '', '2019-07-18 23:22:45');
INSERT INTO `access_log` VALUES (56415, '59.77.15634633657469695', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:46', 2, 0, '', '2019-07-18 23:22:46');
INSERT INTO `access_log` VALUES (56416, '59.75.15634633657419713', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:46', 15, 2001001000, '服务端发生异常', '2019-07-18 23:22:46');
INSERT INTO `access_log` VALUES (56417, '64.82.15634633663549929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:46', 2, 0, '', '2019-07-18 23:22:46');
INSERT INTO `access_log` VALUES (56418, '64.78.15634633665409923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:47', 2, 0, '', '2019-07-18 23:22:47');
INSERT INTO `access_log` VALUES (56419, '59.72.15634633666039705', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:47', 2, 0, '', '2019-07-18 23:22:47');
INSERT INTO `access_log` VALUES (56420, '59.78.15634633666119705', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-cn; MI 8 Lite Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.4 Mobile Safari/537.36', '113.102.160.25', '2019-07-18 23:22:47', 16, 2001001000, '服务端发生异常', '2019-07-18 23:22:47');
INSERT INTO `access_log` VALUES (56421, '65.47.15634635641181783', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:04', 3, 1002001012, '访问令牌已过期', '2019-07-18 23:26:04');
INSERT INTO `access_log` VALUES (56422, '65.53.15634635641181793', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:04', 2, 1002001012, '访问令牌已过期', '2019-07-18 23:26:04');
INSERT INTO `access_log` VALUES (56423, '65.52.15634635641271823', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:04', 3, 1002001012, '访问令牌已过期', '2019-07-18 23:26:04');
INSERT INTO `access_log` VALUES (56424, '65.46.15634635718741851', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:12', 235, 0, '', '2019-07-18 23:26:12');
INSERT INTO `access_log` VALUES (56425, '65.45.15634635726161773', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:13', 9, 0, '', '2019-07-18 23:26:13');
INSERT INTO `access_log` VALUES (56426, '65.49.15634635726261767', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:13', 11, 2001001000, '服务端发生异常', '2019-07-18 23:26:13');
INSERT INTO `access_log` VALUES (56427, '65.50.15634635726581811', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:13', 11, 0, '', '2019-07-18 23:26:13');
INSERT INTO `access_log` VALUES (56428, '65.51.15634635793001851', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:19', 9, 0, '', '2019-07-18 23:26:19');
INSERT INTO `access_log` VALUES (56429, '65.3607.15634635793083595', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:19', 10, 2001001000, '服务端发生异常', '2019-07-18 23:26:19');
INSERT INTO `access_log` VALUES (56430, '65.53.15634635793151795', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:19', 9, 0, '', '2019-07-18 23:26:19');
INSERT INTO `access_log` VALUES (56431, '65.47.15634635896801785', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:30', 9, 0, '', '2019-07-18 23:26:30');
INSERT INTO `access_log` VALUES (56432, '65.54.15634635896901737', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:30', 10, 2001001000, '服务端发生异常', '2019-07-18 23:26:30');
INSERT INTO `access_log` VALUES (56433, '65.46.15634635897201853', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:30', 9, 0, '', '2019-07-18 23:26:30');
INSERT INTO `access_log` VALUES (56434, '65.45.15634635930041775', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:33', 8, 0, '', '2019-07-18 23:26:33');
INSERT INTO `access_log` VALUES (56435, '65.50.15634635930121813', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:33', 9, 2001001000, '服务端发生异常', '2019-07-18 23:26:33');
INSERT INTO `access_log` VALUES (56436, '65.49.15634635930311769', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:33', 8, 0, '', '2019-07-18 23:26:33');
INSERT INTO `access_log` VALUES (56437, '65.3607.15634635978673597', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:38', 9, 0, '', '2019-07-18 23:26:38');
INSERT INTO `access_log` VALUES (56438, '65.51.15634635978721853', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:38', 9, 2001001000, '服务端发生异常', '2019-07-18 23:26:38');
INSERT INTO `access_log` VALUES (56439, '65.53.15634635978931797', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.206.47', '2019-07-18 23:26:38', 9, 0, '', '2019-07-18 23:26:38');
INSERT INTO `access_log` VALUES (56440, '65.52.15634641977781835', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.19', '2019-07-18 23:36:38', 4, 1002001012, '访问令牌已过期', '2019-07-18 23:36:38');
INSERT INTO `access_log` VALUES (56441, '65.46.15634641977871863', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.19', '2019-07-18 23:36:38', 3, 1002001012, '访问令牌已过期', '2019-07-18 23:36:38');
INSERT INTO `access_log` VALUES (56442, '65.47.15634641977881795', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.19', '2019-07-18 23:36:38', 3, 1002001012, '访问令牌已过期', '2019-07-18 23:36:38');
INSERT INTO `access_log` VALUES (56443, '65.49.15634642049341779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.19', '2019-07-18 23:36:45', 71, 0, '', '2019-07-18 23:36:45');
INSERT INTO `access_log` VALUES (56444, '65.50.15634642053581823', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.19', '2019-07-18 23:36:45', 127, 0, '', '2019-07-18 23:36:45');
INSERT INTO `access_log` VALUES (56445, '65.45.15634642053711785', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.19', '2019-07-18 23:36:45', 116, 2001001000, '服务端发生异常', '2019-07-18 23:36:45');
INSERT INTO `access_log` VALUES (56446, '65.3607.15634642054153607', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.102.19', '2019-07-18 23:36:45', 71, 0, '', '2019-07-18 23:36:45');
INSERT INTO `access_log` VALUES (56447, '65.53.15634879108572123', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.101.29.133', '2019-07-19 06:11:51', 0, 1002001015, '账号未登陆', '2019-07-19 06:11:51');
INSERT INTO `access_log` VALUES (56448, '65.51.15634879108572179', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.101.29.133', '2019-07-19 06:11:51', 0, 1002001015, '账号未登陆', '2019-07-19 06:11:51');
INSERT INTO `access_log` VALUES (56449, '65.52.15634879108572153', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.101.29.133', '2019-07-19 06:11:51', 0, 1002001015, '账号未登陆', '2019-07-19 06:11:51');
INSERT INTO `access_log` VALUES (56450, '65.47.15634879159782113', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.101.29.133', '2019-07-19 06:11:56', 113, 0, '', '2019-07-19 06:11:56');
INSERT INTO `access_log` VALUES (56451, '65.49.15634879164122097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.101.29.133', '2019-07-19 06:11:56', 136, 0, '', '2019-07-19 06:11:57');
INSERT INTO `access_log` VALUES (56452, '65.45.15634879164122103', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.101.29.133', '2019-07-19 06:11:56', 139, 0, '', '2019-07-19 06:11:57');
INSERT INTO `access_log` VALUES (56453, '65.54.15634879164122065', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.101.29.133', '2019-07-19 06:11:56', 142, 2001001000, '服务端发生异常', '2019-07-19 06:11:57');
INSERT INTO `access_log` VALUES (56454, '65.3607.15634879300583925', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.101.29.133', '2019-07-19 06:12:10', 17, 0, '', '2019-07-19 06:12:10');
INSERT INTO `access_log` VALUES (56455, '65.51.15634879300622181', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.101.29.133', '2019-07-19 06:12:10', 19, 2001001000, '服务端发生异常', '2019-07-19 06:12:10');
INSERT INTO `access_log` VALUES (56456, '65.52.15634879301042155', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.101.29.133', '2019-07-19 06:12:10', 10, 0, '', '2019-07-19 06:12:10');
INSERT INTO `access_log` VALUES (56457, '59.73.15634977529080169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-19 08:55:53', 12, 0, '', '2019-07-19 08:55:53');
INSERT INTO `access_log` VALUES (56458, '59.74.15634977529080173', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '117.23.80.34', '2019-07-19 08:55:53', 26, 2001001000, '服务端发生异常', '2019-07-19 08:55:53');
INSERT INTO `access_log` VALUES (56459, '62.80.15634982102409289', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-19 09:03:30', 12, 1002001012, '访问令牌已过期', '2019-07-19 09:03:30');
INSERT INTO `access_log` VALUES (56460, '65.54.15634982123932203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-19 09:03:32', 71, 0, '', '2019-07-19 09:03:32');
INSERT INTO `access_log` VALUES (56461, '65.50.15634982128712279', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-19 09:03:33', 18, 0, '', '2019-07-19 09:03:33');
INSERT INTO `access_log` VALUES (56462, '65.45.15634982128702241', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-19 09:03:33', 18, 0, '', '2019-07-19 09:03:33');
INSERT INTO `access_log` VALUES (56463, '65.49.15634982128712237', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-19 09:03:33', 20, 0, '', '2019-07-19 09:03:33');
INSERT INTO `access_log` VALUES (56464, '59.77.15635017992160209', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.111.187.173', '2019-07-19 10:03:19', 10, 0, '', '2019-07-19 10:03:19');
INSERT INTO `access_log` VALUES (56465, '59.71.15635017992160219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36', '180.111.187.173', '2019-07-19 10:03:19', 21, 2001001000, '服务端发生异常', '2019-07-19 10:03:19');
INSERT INTO `access_log` VALUES (56466, '65.53.15635021546552317', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.78.226', '2019-07-19 10:09:15', 0, 1002001015, '账号未登陆', '2019-07-19 10:09:15');
INSERT INTO `access_log` VALUES (56467, '65.47.15635021546562307', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.78.226', '2019-07-19 10:09:15', 0, 1002001015, '账号未登陆', '2019-07-19 10:09:15');
INSERT INTO `access_log` VALUES (56468, '65.46.15635021546562373', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.78.226', '2019-07-19 10:09:15', 1, 1002001015, '账号未登陆', '2019-07-19 10:09:15');
INSERT INTO `access_log` VALUES (56469, '65.50.15635021849422333', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.78.226', '2019-07-19 10:09:45', 67, 0, '', '2019-07-19 10:09:45');
INSERT INTO `access_log` VALUES (56470, '65.45.15635021852412295', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.78.226', '2019-07-19 10:09:45', 88, 0, '', '2019-07-19 10:09:45');
INSERT INTO `access_log` VALUES (56471, '65.51.15635021852482375', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.78.226', '2019-07-19 10:09:45', 82, 0, '', '2019-07-19 10:09:45');
INSERT INTO `access_log` VALUES (56472, '65.3607.15635021852454119', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.78.226', '2019-07-19 10:09:45', 86, 2001001000, '服务端发生异常', '2019-07-19 10:09:45');
INSERT INTO `access_log` VALUES (56473, '65.52.15635021894902347', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.78.226', '2019-07-19 10:09:49', 10, 0, '', '2019-07-19 10:09:50');
INSERT INTO `access_log` VALUES (56474, '65.46.15635021894922375', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.78.226', '2019-07-19 10:09:49', 9, 2001001000, '服务端发生异常', '2019-07-19 10:09:50');
INSERT INTO `access_log` VALUES (56475, '65.53.15635021894942319', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.78.226', '2019-07-19 10:09:49', 10, 0, '', '2019-07-19 10:09:50');
INSERT INTO `access_log` VALUES (56476, '65.46.15635033588102391', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-19 10:29:19', 4, 1002001012, '访问令牌已过期', '2019-07-19 10:29:19');
INSERT INTO `access_log` VALUES (56477, '65.53.15635033588092335', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-19 10:29:19', 4, 1002001012, '访问令牌已过期', '2019-07-19 10:29:19');
INSERT INTO `access_log` VALUES (56478, '65.47.15635033588302325', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-19 10:29:19', 3, 1002001012, '访问令牌已过期', '2019-07-19 10:29:19');
INSERT INTO `access_log` VALUES (56479, '65.49.15635033664082309', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-19 10:29:26', 116, 0, '', '2019-07-19 10:29:27');
INSERT INTO `access_log` VALUES (56480, '65.3607.15635033667954137', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-19 10:29:27', 153, 0, '', '2019-07-19 10:29:27');
INSERT INTO `access_log` VALUES (56481, '65.45.15635033667892313', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-19 10:29:27', 158, 2001001000, '服务端发生异常', '2019-07-19 10:29:27');
INSERT INTO `access_log` VALUES (56482, '65.50.15635033667872351', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.232.33.1', '2019-07-19 10:29:27', 159, 0, '', '2019-07-19 10:29:27');
INSERT INTO `access_log` VALUES (56483, '65.45.15635040701142323', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.89.239.232', '2019-07-19 10:41:10', 0, 1002001015, '账号未登陆', '2019-07-19 10:41:10');
INSERT INTO `access_log` VALUES (56484, '65.50.15635040785212361', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.129.6.151', '2019-07-19 10:41:19', 0, 1002001015, '账号未登陆', '2019-07-19 10:41:19');
INSERT INTO `access_log` VALUES (56485, '65.46.15635045613302409', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.212.15', '2019-07-19 10:49:21', 1, 1002001015, '账号未登陆', '2019-07-19 10:49:21');
INSERT INTO `access_log` VALUES (56486, '65.52.15635045613292381', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.212.15', '2019-07-19 10:49:21', 1, 1002001015, '账号未登陆', '2019-07-19 10:49:21');
INSERT INTO `access_log` VALUES (56487, '65.53.15635045613302353', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.212.15', '2019-07-19 10:49:21', 0, 1002001015, '账号未登陆', '2019-07-19 10:49:21');
INSERT INTO `access_log` VALUES (56488, '65.54.15635045645612293', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.212.15', '2019-07-19 10:49:25', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-19 10:49:25');
INSERT INTO `access_log` VALUES (56489, '65.49.15635045696822327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.212.15', '2019-07-19 10:49:30', 87, 0, '', '2019-07-19 10:49:30');
INSERT INTO `access_log` VALUES (56490, '65.50.15635045841972369', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.212.15', '2019-07-19 10:49:44', 109, 0, '', '2019-07-19 10:49:44');
INSERT INTO `access_log` VALUES (56491, '65.3607.15635045911704155', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.212.15', '2019-07-19 10:49:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-19 10:49:51');
INSERT INTO `access_log` VALUES (56492, '65.46.15635045978362411', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.212.15', '2019-07-19 10:49:58', 86, 0, '', '2019-07-19 10:49:58');
INSERT INTO `access_log` VALUES (56493, '65.53.15635046167882355', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:50:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-19 10:50:17');
INSERT INTO `access_log` VALUES (56494, '65.47.15635046173252345', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:50:17', 1, 1002001015, '账号未登陆', '2019-07-19 10:50:17');
INSERT INTO `access_log` VALUES (56495, '65.54.15635046173322295', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:50:17', 0, 1002001015, '账号未登陆', '2019-07-19 10:50:17');
INSERT INTO `access_log` VALUES (56496, '65.49.15635046173332329', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:50:17', 1, 1002001015, '账号未登陆', '2019-07-19 10:50:17');
INSERT INTO `access_log` VALUES (56497, '65.3607.15635046437214157', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:50:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-19 10:50:44');
INSERT INTO `access_log` VALUES (56498, '65.51.15635046492182413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:50:49', 55, 0, '', '2019-07-19 10:50:49');
INSERT INTO `access_log` VALUES (56499, '65.46.15635046495772413', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:50:50', 92, 0, '', '2019-07-19 10:50:50');
INSERT INTO `access_log` VALUES (56500, '65.53.15635046495862357', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:50:50', 85, 2001001000, '服务端发生异常', '2019-07-19 10:50:50');
INSERT INTO `access_log` VALUES (56501, '65.52.15635046495832385', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:50:50', 89, 0, '', '2019-07-19 10:50:50');
INSERT INTO `access_log` VALUES (56502, '65.54.15635046788792297', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:51:19', 9, 0, '', '2019-07-19 10:51:19');
INSERT INTO `access_log` VALUES (56503, '65.45.15635046788802335', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:51:19', 10, 2001001000, '服务端发生异常', '2019-07-19 10:51:19');
INSERT INTO `access_log` VALUES (56504, '65.50.15635046788952373', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:51:19', 9, 0, '', '2019-07-19 10:51:19');
INSERT INTO `access_log` VALUES (56505, '65.51.15635046840032415', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:51:24', 9, 0, '', '2019-07-19 10:51:24');
INSERT INTO `access_log` VALUES (56506, '65.52.15635046840032387', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:51:24', 9, 0, '', '2019-07-19 10:51:24');
INSERT INTO `access_log` VALUES (56507, '65.53.15635046840072359', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:51:24', 10, 2001001000, '服务端发生异常', '2019-07-19 10:51:24');
INSERT INTO `access_log` VALUES (56508, '65.46.15635046901862415', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:51:30', 16, 0, '', '2019-07-19 10:51:30');
INSERT INTO `access_log` VALUES (56509, '65.49.15635046901932333', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:51:30', 16, 0, '', '2019-07-19 10:51:30');
INSERT INTO `access_log` VALUES (56510, '65.47.15635046901922349', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.236.212.15', '2019-07-19 10:51:30', 16, 2001001000, '服务端发生异常', '2019-07-19 10:51:30');
INSERT INTO `access_log` VALUES (56511, '65.45.15635046953022337', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-19 10:51:35', 4, 1002001012, '访问令牌已过期', '2019-07-19 10:51:35');
INSERT INTO `access_log` VALUES (56512, '65.54.15635046953122299', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-19 10:51:35', 3, 1002001012, '访问令牌已过期', '2019-07-19 10:51:35');
INSERT INTO `access_log` VALUES (56513, '65.50.15635046953312375', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-19 10:51:35', 3, 1002001012, '访问令牌已过期', '2019-07-19 10:51:35');
INSERT INTO `access_log` VALUES (56514, '65.3607.15635046970454161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '120.33.203.186', '2019-07-19 10:51:37', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-19 10:51:37');
INSERT INTO `access_log` VALUES (56515, '59.74.15635047628150267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.209.154.78', '2019-07-19 10:52:43', 10, 0, '', '2019-07-19 10:52:43');
INSERT INTO `access_log` VALUES (56516, '59.77.15635047628150249', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.209.154.78', '2019-07-19 10:52:43', 19, 2001001000, '服务端发生异常', '2019-07-19 10:52:43');
INSERT INTO `access_log` VALUES (56517, '59.79.15635052867330269', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.188.200', '2019-07-19 11:01:27', 4, 0, '', '2019-07-19 11:01:27');
INSERT INTO `access_log` VALUES (56518, '59.80.15635052878190245', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.188.67', '2019-07-19 11:01:28', 15, 2001001000, '服务端发生异常', '2019-07-19 11:01:28');
INSERT INTO `access_log` VALUES (56519, '59.74.15635063714150289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.12.50.117', '2019-07-19 11:19:31', 3, 0, '', '2019-07-19 11:19:31');
INSERT INTO `access_log` VALUES (56520, '59.71.15635063714160281', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.12.50.117', '2019-07-19 11:19:31', 22, 2001001000, '服务端发生异常', '2019-07-19 11:19:31');
INSERT INTO `access_log` VALUES (56521, '64.80.15635063740280499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.12.50.117', '2019-07-19 11:19:34', 13, 0, '', '2019-07-19 11:19:34');
INSERT INTO `access_log` VALUES (56522, '64.82.15635063741560503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.12.50.117', '2019-07-19 11:19:34', 4, 0, '', '2019-07-19 11:19:34');
INSERT INTO `access_log` VALUES (56523, '59.72.15635063766780281', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.12.50.117', '2019-07-19 11:19:37', 2, 0, '', '2019-07-19 11:19:37');
INSERT INTO `access_log` VALUES (56524, '59.78.15635063766780281', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.12.50.117', '2019-07-19 11:19:37', 16, 2001001000, '服务端发生异常', '2019-07-19 11:19:37');
INSERT INTO `access_log` VALUES (56525, '65.46.15635063823912439', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.12.50.117', '2019-07-19 11:19:42', 1, 1002001015, '账号未登陆', '2019-07-19 11:19:42');
INSERT INTO `access_log` VALUES (56526, '65.49.15635063823922357', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.12.50.117', '2019-07-19 11:19:42', 1, 1002001015, '账号未登陆', '2019-07-19 11:19:42');
INSERT INTO `access_log` VALUES (56527, '65.47.15635063823942373', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.12.50.117', '2019-07-19 11:19:42', 0, 1002001015, '账号未登陆', '2019-07-19 11:19:42');
INSERT INTO `access_log` VALUES (56528, '65.45.15635063854592361', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36 OPR/62.0.3331.72', '223.223.183.2', '2019-07-19 11:19:45', 1, 1002001015, '账号未登陆', '2019-07-19 11:19:45');
INSERT INTO `access_log` VALUES (56529, '65.54.15635063854672323', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36 OPR/62.0.3331.72', '223.223.183.2', '2019-07-19 11:19:45', 0, 1002001015, '账号未登陆', '2019-07-19 11:19:45');
INSERT INTO `access_log` VALUES (56530, '65.50.15635063854692399', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36 OPR/62.0.3331.72', '223.223.183.2', '2019-07-19 11:19:45', 1, 1002001015, '账号未登陆', '2019-07-19 11:19:45');
INSERT INTO `access_log` VALUES (56531, '65.52.15635064077942413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.12.50.117', '2019-07-19 11:20:08', 103, 0, '', '2019-07-19 11:20:08');
INSERT INTO `access_log` VALUES (56532, '65.53.15635064082562385', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.12.50.117', '2019-07-19 11:20:08', 9, 0, '', '2019-07-19 11:20:08');
INSERT INTO `access_log` VALUES (56533, '65.51.15635064082692441', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.12.50.117', '2019-07-19 11:20:08', 10, 2001001000, '服务端发生异常', '2019-07-19 11:20:08');
INSERT INTO `access_log` VALUES (56534, '65.47.15635064082732375', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.12.50.117', '2019-07-19 11:20:08', 9, 0, '', '2019-07-19 11:20:08');
INSERT INTO `access_log` VALUES (56535, '59.79.15635120918400361', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '27.192.233.91', '2019-07-19 12:54:52', 10, 0, '', '2019-07-19 12:54:52');
INSERT INTO `access_log` VALUES (56536, '59.80.15635120918420337', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '27.192.233.91', '2019-07-19 12:54:52', 26, 2001001000, '服务端发生异常', '2019-07-19 12:54:52');
INSERT INTO `access_log` VALUES (56537, '59.74.15635121276160367', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '27.192.233.91', '2019-07-19 12:55:28', 2, 0, '', '2019-07-19 12:55:28');
INSERT INTO `access_log` VALUES (56538, '59.71.15635121278240359', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.6.39) com.laiwang.DingTalk/11611146 Channel/201200 language/zh-Hans-CN WK', '27.192.233.91', '2019-07-19 12:55:28', 18, 2001001000, '服务端发生异常', '2019-07-19 12:55:28');
INSERT INTO `access_log` VALUES (56539, '65.54.15635124545202405', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.68.105.25', '2019-07-19 13:00:55', 0, 1002001015, '账号未登陆', '2019-07-19 13:00:55');
INSERT INTO `access_log` VALUES (56540, '65.3607.15635124545214267', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.68.105.25', '2019-07-19 13:00:55', 1, 1002001015, '账号未登陆', '2019-07-19 13:00:55');
INSERT INTO `access_log` VALUES (56541, '65.52.15635124545352495', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.68.105.25', '2019-07-19 13:00:55', 0, 1002001015, '账号未登陆', '2019-07-19 13:00:55');
INSERT INTO `access_log` VALUES (56542, '65.47.15635124602172457', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.68.105.25', '2019-07-19 13:01:00', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-19 13:01:00');
INSERT INTO `access_log` VALUES (56543, '65.53.15635124665832467', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.68.105.25', '2019-07-19 13:01:07', 52, 0, '', '2019-07-19 13:01:07');
INSERT INTO `access_log` VALUES (56544, '65.51.15635124669382523', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.68.105.25', '2019-07-19 13:01:07', 10, 0, '', '2019-07-19 13:01:07');
INSERT INTO `access_log` VALUES (56545, '59.72.15635127368270367', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.135.153', '2019-07-19 13:05:37', 4, 0, '', '2019-07-19 13:05:37');
INSERT INTO `access_log` VALUES (56546, '59.78.15635127368290367', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.135.153', '2019-07-19 13:05:37', 17, 2001001000, '服务端发生异常', '2019-07-19 13:05:37');
INSERT INTO `access_log` VALUES (56547, '64.77.15635127443880563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.135.153', '2019-07-19 13:05:44', 11, 0, '', '2019-07-19 13:05:44');
INSERT INTO `access_log` VALUES (56548, '64.76.15635127447470573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.135.153', '2019-07-19 13:05:45', 3, 0, '', '2019-07-19 13:05:45');
INSERT INTO `access_log` VALUES (56549, '59.76.15635139384040375', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.40.225.132', '2019-07-19 13:25:38', 4, 0, '', '2019-07-19 13:25:38');
INSERT INTO `access_log` VALUES (56550, '59.79.15635139384040387', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.40.225.132', '2019-07-19 13:25:38', 16, 2001001000, '服务端发生异常', '2019-07-19 13:25:38');
INSERT INTO `access_log` VALUES (56551, '64.79.15635139441800595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.40.225.132', '2019-07-19 13:25:44', 4, 0, '', '2019-07-19 13:25:44');
INSERT INTO `access_log` VALUES (56552, '64.80.15635139443390601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.40.225.132', '2019-07-19 13:25:44', 3, 0, '', '2019-07-19 13:25:44');
INSERT INTO `access_log` VALUES (56553, '64.82.15635139460020605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.40.225.132', '2019-07-19 13:25:46', 2, 0, '', '2019-07-19 13:25:46');
INSERT INTO `access_log` VALUES (56554, '64.78.15635139467220601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.40.225.132', '2019-07-19 13:25:47', 2, 0, '', '2019-07-19 13:25:47');
INSERT INTO `access_log` VALUES (56555, '65.50.15635150493882517', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.77.204', '2019-07-19 13:44:09', 0, 1002001015, '账号未登陆', '2019-07-19 13:44:09');
INSERT INTO `access_log` VALUES (56556, '65.3607.15635150493894303', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.77.204', '2019-07-19 13:44:09', 0, 1002001015, '账号未登陆', '2019-07-19 13:44:09');
INSERT INTO `access_log` VALUES (56557, '65.54.15635150493892441', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.77.204', '2019-07-19 13:44:09', 1, 1002001015, '账号未登陆', '2019-07-19 13:44:09');
INSERT INTO `access_log` VALUES (56558, '65.52.15635150517552531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.77.204', '2019-07-19 13:44:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-19 13:44:12');
INSERT INTO `access_log` VALUES (56559, '65.53.15635150556182503', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.40.225.132', '2019-07-19 13:44:16', 0, 1002001015, '账号未登陆', '2019-07-19 13:44:16');
INSERT INTO `access_log` VALUES (56560, '65.47.15635150556182493', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.40.225.132', '2019-07-19 13:44:16', 1, 1002001015, '账号未登陆', '2019-07-19 13:44:16');
INSERT INTO `access_log` VALUES (56561, '65.51.15635150556182559', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.40.225.132', '2019-07-19 13:44:16', 0, 1002001015, '账号未登陆', '2019-07-19 13:44:16');
INSERT INTO `access_log` VALUES (56562, '65.46.15635150593992559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.77.204', '2019-07-19 13:44:19', 65, 0, '', '2019-07-19 13:44:19');
INSERT INTO `access_log` VALUES (56563, '65.45.15635150678552481', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.40.225.132', '2019-07-19 13:44:28', 105, 0, '', '2019-07-19 13:44:28');
INSERT INTO `access_log` VALUES (56564, '65.50.15635150683322519', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.40.225.132', '2019-07-19 13:44:28', 51, 0, '', '2019-07-19 13:44:28');
INSERT INTO `access_log` VALUES (56565, '65.3607.15635150683304305', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.40.225.132', '2019-07-19 13:44:28', 52, 0, '', '2019-07-19 13:44:28');
INSERT INTO `access_log` VALUES (56566, '65.54.15635150683302443', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.40.225.132', '2019-07-19 13:44:28', 53, 2001001000, '服务端发生异常', '2019-07-19 13:44:28');
INSERT INTO `access_log` VALUES (56567, '65.53.15635151014752505', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.77.204', '2019-07-19 13:45:01', 10, 0, '', '2019-07-19 13:45:01');
INSERT INTO `access_log` VALUES (56568, '65.47.15635151014812495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.77.204', '2019-07-19 13:45:01', 10, 2001001000, '服务端发生异常', '2019-07-19 13:45:01');
INSERT INTO `access_log` VALUES (56569, '65.46.15635151015002561', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.77.204', '2019-07-19 13:45:02', 9, 0, '', '2019-07-19 13:45:02');
INSERT INTO `access_log` VALUES (56570, '65.54.15635151243452445', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.77.204', '2019-07-19 13:45:24', 9, 0, '', '2019-07-19 13:45:24');
INSERT INTO `access_log` VALUES (56571, '65.50.15635151243552521', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.77.204', '2019-07-19 13:45:24', 8, 0, '', '2019-07-19 13:45:24');
INSERT INTO `access_log` VALUES (56572, '65.3607.15635151243534307', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.77.204', '2019-07-19 13:45:24', 9, 2001001000, '服务端发生异常', '2019-07-19 13:45:24');
INSERT INTO `access_log` VALUES (56573, '65.47.15635151960832497', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.77.204', '2019-07-19 13:46:36', 8, 0, '', '2019-07-19 13:46:36');
INSERT INTO `access_log` VALUES (56574, '65.49.15635151960842481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.77.204', '2019-07-19 13:46:36', 9, 2001001000, '服务端发生异常', '2019-07-19 13:46:36');
INSERT INTO `access_log` VALUES (56575, '65.45.15635151960892485', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.77.204', '2019-07-19 13:46:36', 8, 0, '', '2019-07-19 13:46:36');
INSERT INTO `access_log` VALUES (56576, '59.79.15635200781190469', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-19 15:07:58', 10, 0, '', '2019-07-19 15:07:58');
INSERT INTO `access_log` VALUES (56577, '59.80.15635200781200445', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-19 15:07:58', 18, 2001001000, '服务端发生异常', '2019-07-19 15:07:58');
INSERT INTO `access_log` VALUES (56578, '64.78.15635200814920683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-19 15:08:01', 11, 0, '', '2019-07-19 15:08:02');
INSERT INTO `access_log` VALUES (56579, '64.84.15635200817160669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-19 15:08:02', 3, 0, '', '2019-07-19 15:08:02');
INSERT INTO `access_log` VALUES (56580, '64.85.15635200830500695', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-19 15:08:03', 2, 0, '', '2019-07-19 15:08:03');
INSERT INTO `access_log` VALUES (56581, '64.81.15635200839580663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-19 15:08:04', 1, 0, '', '2019-07-19 15:08:04');
INSERT INTO `access_log` VALUES (56582, '64.77.15635200884370663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-19 15:08:08', 2, 0, '', '2019-07-19 15:08:08');
INSERT INTO `access_log` VALUES (56583, '64.76.15635200885440673', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-19 15:08:09', 2, 0, '', '2019-07-19 15:08:09');
INSERT INTO `access_log` VALUES (56584, '59.77.15635200919380457', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-19 15:08:12', 4, 0, '', '2019-07-19 15:08:12');
INSERT INTO `access_log` VALUES (56585, '59.74.15635200919380475', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-19 15:08:12', 19, 2001001000, '服务端发生异常', '2019-07-19 15:08:12');
INSERT INTO `access_log` VALUES (56586, '65.47.15635201456842563', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '111.49.201.45', '2019-07-19 15:09:06', 0, 1002001015, '账号未登陆', '2019-07-19 15:09:06');
INSERT INTO `access_log` VALUES (56587, '65.53.15635201456842575', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '111.49.201.45', '2019-07-19 15:09:06', 1, 1002001015, '账号未登陆', '2019-07-19 15:09:06');
INSERT INTO `access_log` VALUES (56588, '65.3607.15635201478694375', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '111.49.201.45', '2019-07-19 15:09:08', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-19 15:09:08');
INSERT INTO `access_log` VALUES (56589, '65.52.15635201574362607', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '111.49.201.45', '2019-07-19 15:09:17', 201, 0, '', '2019-07-19 15:09:18');
INSERT INTO `access_log` VALUES (56590, '65.54.15635201579842513', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '111.49.201.45', '2019-07-19 15:09:18', 18, 0, '', '2019-07-19 15:09:18');
INSERT INTO `access_log` VALUES (56591, '65.46.15635201579872635', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '111.49.201.45', '2019-07-19 15:09:18', 17, 0, '', '2019-07-19 15:09:18');
INSERT INTO `access_log` VALUES (56592, '65.50.15635201579872591', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '111.49.201.45', '2019-07-19 15:09:18', 27, 2001001000, '服务端发生异常', '2019-07-19 15:09:18');
INSERT INTO `access_log` VALUES (56593, '59.79.15635216746420491', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-19 15:34:35', 3, 0, '', '2019-07-19 15:34:35');
INSERT INTO `access_log` VALUES (56594, '59.73.15635216746600493', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.236.39.210', '2019-07-19 15:34:35', 13, 2001001000, '服务端发生异常', '2019-07-19 15:34:35');
INSERT INTO `access_log` VALUES (56595, '64.81.15635216879310685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.39.210', '2019-07-19 15:34:48', 78, 0, '', '2019-07-19 15:34:48');
INSERT INTO `access_log` VALUES (56596, '64.83.15635216884090697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.39.210', '2019-07-19 15:34:48', 2, 0, '', '2019-07-19 15:34:48');
INSERT INTO `access_log` VALUES (56597, '64.77.15635216904070685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.39.210', '2019-07-19 15:34:50', 2, 0, '', '2019-07-19 15:34:50');
INSERT INTO `access_log` VALUES (56598, '64.79.15635216910300701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.39.210', '2019-07-19 15:34:51', 1, 0, '', '2019-07-19 15:34:51');
INSERT INTO `access_log` VALUES (56599, '59.79.15635228304050507', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.157.194.227', '2019-07-19 15:53:50', 4, 0, '', '2019-07-19 15:53:50');
INSERT INTO `access_log` VALUES (56600, '59.80.15635228304050483', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.157.194.227', '2019-07-19 15:53:50', 38, 2001001000, '服务端发生异常', '2019-07-19 15:53:50');
INSERT INTO `access_log` VALUES (56601, '64.83.15635228337010713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.157.194.227', '2019-07-19 15:53:54', 137, 0, '', '2019-07-19 15:53:54');
INSERT INTO `access_log` VALUES (56602, '64.77.15635228339610701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.157.194.227', '2019-07-19 15:53:54', 2, 0, '', '2019-07-19 15:53:54');
INSERT INTO `access_log` VALUES (56603, '64.76.15635228355660711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.157.194.227', '2019-07-19 15:53:56', 2, 0, '', '2019-07-19 15:53:56');
INSERT INTO `access_log` VALUES (56604, '64.79.15635228367030717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.157.194.227', '2019-07-19 15:53:57', 1, 0, '', '2019-07-19 15:53:57');
INSERT INTO `access_log` VALUES (56605, '64.80.15635228375130723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.157.194.227', '2019-07-19 15:53:58', 2, 0, '', '2019-07-19 15:53:58');
INSERT INTO `access_log` VALUES (56606, '64.82.15635228381760727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.157.194.227', '2019-07-19 15:53:58', 2, 0, '', '2019-07-19 15:53:58');
INSERT INTO `access_log` VALUES (56607, '64.78.15635228384680723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.157.194.227', '2019-07-19 15:53:58', 2, 0, '', '2019-07-19 15:53:58');
INSERT INTO `access_log` VALUES (56608, '59.73.15635228403130509', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.157.194.227', '2019-07-19 15:54:00', 3, 0, '', '2019-07-19 15:54:00');
INSERT INTO `access_log` VALUES (56609, '59.77.15635228403130495', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.157.194.227', '2019-07-19 15:54:00', 13, 2001001000, '服务端发生异常', '2019-07-19 15:54:00');
INSERT INTO `access_log` VALUES (56610, '59.72.15635255711260541', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.14.28.215', '2019-07-19 16:39:31', 9, 2001001000, '服务端发生异常', '2019-07-19 16:39:31');
INSERT INTO `access_log` VALUES (56611, '59.75.15635255711200549', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.14.28.215', '2019-07-19 16:39:31', 166, 0, '', '2019-07-19 16:39:31');
INSERT INTO `access_log` VALUES (56612, '64.83.15635255759130751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.14.28.215', '2019-07-19 16:39:36', 11, 0, '', '2019-07-19 16:39:36');
INSERT INTO `access_log` VALUES (56613, '64.77.15635255760260739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.14.28.215', '2019-07-19 16:39:36', 3, 0, '', '2019-07-19 16:39:36');
INSERT INTO `access_log` VALUES (56614, '64.76.15635255794380749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.14.28.215', '2019-07-19 16:39:39', 2, 0, '', '2019-07-19 16:39:39');
INSERT INTO `access_log` VALUES (56615, '64.79.15635255797740755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.14.28.215', '2019-07-19 16:39:40', 2, 0, '', '2019-07-19 16:39:40');
INSERT INTO `access_log` VALUES (56616, '59.76.15635255799840533', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.14.28.215', '2019-07-19 16:39:40', 3, 0, '', '2019-07-19 16:39:40');
INSERT INTO `access_log` VALUES (56617, '59.79.15635255799840545', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '183.14.28.215', '2019-07-19 16:39:40', 13, 2001001000, '服务端发生异常', '2019-07-19 16:39:40');
INSERT INTO `access_log` VALUES (56618, '59.74.15635257642660553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.65.137.211', '2019-07-19 16:42:44', 3, 0, '', '2019-07-19 16:42:44');
INSERT INTO `access_log` VALUES (56619, '59.77.15635257642650535', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.65.137.211', '2019-07-19 16:42:44', 16, 2001001000, '服务端发生异常', '2019-07-19 16:42:44');
INSERT INTO `access_log` VALUES (56620, '59.73.15635263120580557', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:51:52', 3, 0, '', '2019-07-19 16:51:52');
INSERT INTO `access_log` VALUES (56621, '59.77.15635263120590543', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:51:52', 11, 2001001000, '服务端发生异常', '2019-07-19 16:51:52');
INSERT INTO `access_log` VALUES (56622, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=54444&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:02', 14, 0, '', '2019-07-19 16:52:02');
INSERT INTO `access_log` VALUES (56623, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=54444', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:02', 7, 0, '', '2019-07-19 16:52:02');
INSERT INTO `access_log` VALUES (56624, '59.71.15635263280850553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:08', 2, 0, '', '2019-07-19 16:52:08');
INSERT INTO `access_log` VALUES (56625, '59.75.15635263280850561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:08', 14, 2001001000, '服务端发生异常', '2019-07-19 16:52:08');
INSERT INTO `access_log` VALUES (56626, '65.49.15635263394572631', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:19', 0, 1002001015, '账号未登陆', '2019-07-19 16:52:19');
INSERT INTO `access_log` VALUES (56627, '65.47.15635263394582647', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:19', 0, 1002001015, '账号未登陆', '2019-07-19 16:52:19');
INSERT INTO `access_log` VALUES (56628, '65.45.15635263394572639', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:19', 2, 1002001015, '账号未登陆', '2019-07-19 16:52:19');
INSERT INTO `access_log` VALUES (56629, '65.53.15635263419622663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-19 16:52:22');
INSERT INTO `access_log` VALUES (56630, '65.51.15635263462182719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:26', 65, 0, '', '2019-07-19 16:52:26');
INSERT INTO `access_log` VALUES (56631, '65.52.15635263464602691', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:26', 12, 0, '', '2019-07-19 16:52:26');
INSERT INTO `access_log` VALUES (56632, '65.46.15635263464642719', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:26', 11, 2001001000, '服务端发生异常', '2019-07-19 16:52:26');
INSERT INTO `access_log` VALUES (56633, '65.54.15635263464692599', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:26', 10, 0, '', '2019-07-19 16:52:26');
INSERT INTO `access_log` VALUES (56634, '65.49.15635263747802633', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:55', 85, 2001001000, '服务端发生异常', '2019-07-19 16:52:55');
INSERT INTO `access_log` VALUES (56635, '65.47.15635263747792649', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:55', 90, 0, '', '2019-07-19 16:52:55');
INSERT INTO `access_log` VALUES (56636, '65.53.15635263747842665', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 16:52:55', 87, 0, '', '2019-07-19 16:52:55');
INSERT INTO `access_log` VALUES (56637, '65.54.15635286174902629', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 17:30:17', 28, 0, '', '2019-07-19 17:30:18');
INSERT INTO `access_log` VALUES (56638, '65.53.15635286174902697', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 17:30:17', 30, 2001001000, '服务端发生异常', '2019-07-19 17:30:18');
INSERT INTO `access_log` VALUES (56639, '65.3607.15635286174914491', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 17:30:17', 30, 0, '', '2019-07-19 17:30:18');
INSERT INTO `access_log` VALUES (56640, '65.49.15635286280682665', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 17:30:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-19 17:30:28');
INSERT INTO `access_log` VALUES (56641, '65.51.15635286335132753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 17:30:34', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-19 17:30:34');
INSERT INTO `access_log` VALUES (56642, '65.45.15635286465092675', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 17:30:47', 79, 0, '', '2019-07-19 17:30:47');
INSERT INTO `access_log` VALUES (56643, '65.52.15635286467572723', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 17:30:47', 10, 0, '', '2019-07-19 17:30:47');
INSERT INTO `access_log` VALUES (56644, '65.47.15635286467592681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 17:30:47', 10, 2001001000, '服务端发生异常', '2019-07-19 17:30:47');
INSERT INTO `access_log` VALUES (56645, '65.3607.15635286467634493', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-19 17:30:47', 8, 0, '', '2019-07-19 17:30:47');
INSERT INTO `access_log` VALUES (56646, '59.80.15635290779500569', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '59.108.127.98', '2019-07-19 17:37:58', 10, 0, '', '2019-07-19 17:37:58');
INSERT INTO `access_log` VALUES (56647, '59.76.15635290779490581', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '59.108.127.98', '2019-07-19 17:37:58', 15, 2001001000, '服务端发生异常', '2019-07-19 17:37:58');
INSERT INTO `access_log` VALUES (56648, '64.84.15635290831480793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '59.108.127.98', '2019-07-19 17:38:03', 153, 0, '', '2019-07-19 17:38:03');
INSERT INTO `access_log` VALUES (56649, '64.85.15635290834310819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '59.108.127.98', '2019-07-19 17:38:03', 4, 0, '', '2019-07-19 17:38:03');
INSERT INTO `access_log` VALUES (56650, '64.81.15635290849640787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '59.108.127.98', '2019-07-19 17:38:05', 2, 0, '', '2019-07-19 17:38:05');
INSERT INTO `access_log` VALUES (56651, '64.77.15635290855700787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '59.108.127.98', '2019-07-19 17:38:06', 2, 0, '', '2019-07-19 17:38:06');
INSERT INTO `access_log` VALUES (56652, '64.76.15635290892590797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '59.108.127.98', '2019-07-19 17:38:09', 2, 0, '', '2019-07-19 17:38:09');
INSERT INTO `access_log` VALUES (56653, '64.79.15635290895360803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36 QQBrowser/4.5.123.400', '59.108.127.98', '2019-07-19 17:38:10', 2, 0, '', '2019-07-19 17:38:10');
INSERT INTO `access_log` VALUES (56654, '59.71.15635319859140629', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '119.248.58.69', '2019-07-19 18:26:26', 11, 0, '', '2019-07-19 18:26:26');
INSERT INTO `access_log` VALUES (56655, '59.72.15635319859160629', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '119.248.58.69', '2019-07-19 18:26:26', 45, 2001001000, '服务端发生异常', '2019-07-19 18:26:26');
INSERT INTO `access_log` VALUES (56656, '64.84.15635319918030833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '119.248.58.69', '2019-07-19 18:26:32', 11, 0, '', '2019-07-19 18:26:32');
INSERT INTO `access_log` VALUES (56657, '64.85.15635319919500859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '119.248.58.69', '2019-07-19 18:26:32', 3, 0, '', '2019-07-19 18:26:32');
INSERT INTO `access_log` VALUES (56658, '64.81.15635319936990827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '119.248.58.69', '2019-07-19 18:26:34', 1, 0, '', '2019-07-19 18:26:34');
INSERT INTO `access_log` VALUES (56659, '64.83.15635319946610839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '119.248.58.69', '2019-07-19 18:26:35', 2, 0, '', '2019-07-19 18:26:35');
INSERT INTO `access_log` VALUES (56660, '64.76.15635319957160837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '119.248.58.69', '2019-07-19 18:26:36', 2, 0, '', '2019-07-19 18:26:36');
INSERT INTO `access_log` VALUES (56661, '64.79.15635319979390843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '119.248.58.69', '2019-07-19 18:26:38', 1, 0, '', '2019-07-19 18:26:38');
INSERT INTO `access_log` VALUES (56662, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '119.248.58.69', '2019-07-19 18:26:38', 6, 0, '', '2019-07-19 18:26:38');
INSERT INTO `access_log` VALUES (56663, '59.74.15635380742960719', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-19 20:07:54', 19, 0, '', '2019-07-19 20:07:54');
INSERT INTO `access_log` VALUES (56664, '59.75.15635380742970719', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-19 20:07:54', 25, 2001001000, '服务端发生异常', '2019-07-19 20:07:54');
INSERT INTO `access_log` VALUES (56665, '64.81.15635380781440909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-19 20:07:58', 11, 0, '', '2019-07-19 20:07:58');
INSERT INTO `access_log` VALUES (56666, '64.83.15635380782320921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-19 20:07:58', 2, 0, '', '2019-07-19 20:07:58');
INSERT INTO `access_log` VALUES (56667, '59.72.15635380887110711', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:09', 4, 0, '', '2019-07-19 20:08:09');
INSERT INTO `access_log` VALUES (56668, '59.78.15635380887110711', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:09', 17, 2001001000, '服务端发生异常', '2019-07-19 20:08:09');
INSERT INTO `access_log` VALUES (56669, '59.76.15635380935990703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-19 20:08:14', 2, 0, '', '2019-07-19 20:08:14');
INSERT INTO `access_log` VALUES (56670, '59.79.15635380935990715', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-19 20:08:14', 13, 2001001000, '服务端发生异常', '2019-07-19 20:08:14');
INSERT INTO `access_log` VALUES (56671, '59.80.15635380969490691', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:17', 3, 0, '', '2019-07-19 20:08:17');
INSERT INTO `access_log` VALUES (56672, '59.73.15635380969530717', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:17', 22, 2001001000, '服务端发生异常', '2019-07-19 20:08:17');
INSERT INTO `access_log` VALUES (56673, '64.76.15635380995880919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:20', 2, 0, '', '2019-07-19 20:08:20');
INSERT INTO `access_log` VALUES (56674, '64.79.15635380997980925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:20', 2, 0, '', '2019-07-19 20:08:20');
INSERT INTO `access_log` VALUES (56675, '64.82.15635381037300935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:24', 2, 0, '', '2019-07-19 20:08:24');
INSERT INTO `access_log` VALUES (56676, '64.78.15635381039000931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:24', 2, 0, '', '2019-07-19 20:08:24');
INSERT INTO `access_log` VALUES (56677, '59.74.15635381057770721', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:26', 3, 0, '', '2019-07-19 20:08:26');
INSERT INTO `access_log` VALUES (56678, '59.75.15635381057780721', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:26', 15, 2001001000, '服务端发生异常', '2019-07-19 20:08:26');
INSERT INTO `access_log` VALUES (56679, '64.84.15635381090500917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:29', 2, 0, '', '2019-07-19 20:08:29');
INSERT INTO `access_log` VALUES (56680, '64.85.15635381094030943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:29', 2, 0, '', '2019-07-19 20:08:29');
INSERT INTO `access_log` VALUES (56681, '64.81.15635381108500911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:31', 2, 0, '', '2019-07-19 20:08:31');
INSERT INTO `access_log` VALUES (56682, '64.83.15635381119120923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:32', 2, 0, '', '2019-07-19 20:08:32');
INSERT INTO `access_log` VALUES (56683, '64.77.15635381129840911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:33', 2, 0, '', '2019-07-19 20:08:33');
INSERT INTO `access_log` VALUES (56684, '64.76.15635381137260921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:34', 2, 0, '', '2019-07-19 20:08:34');
INSERT INTO `access_log` VALUES (56685, '59.72.15635381160420713', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:36', 2, 0, '', '2019-07-19 20:08:36');
INSERT INTO `access_log` VALUES (56686, '59.78.15635381160500713', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Build/PKQ1.180729.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/61.0.3163.128 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.8.3', '223.104.217.121', '2019-07-19 20:08:36', 21, 2001001000, '服务端发生异常', '2019-07-19 20:08:36');
INSERT INTO `access_log` VALUES (56687, '66.52.15635381160198577', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17774007125', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-19 20:08:36', 62, 0, '', '2019-07-19 20:08:36');
INSERT INTO `access_log` VALUES (56688, '66.53.15635381355818587', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17774007125&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '112.17.169.238', '2019-07-19 20:08:56', 176, 0, '', '2019-07-19 20:08:56');
INSERT INTO `access_log` VALUES (56689, '59.78.15635431972220781', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.85.77.98', '2019-07-19 21:33:17', 10, 0, '', '2019-07-19 21:33:17');
INSERT INTO `access_log` VALUES (56690, '59.72.15635431973700781', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.85.77.98', '2019-07-19 21:33:17', 19, 2001001000, '服务端发生异常', '2019-07-19 21:33:17');
INSERT INTO `access_log` VALUES (56691, '64.79.15635432059940995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.85.77.98', '2019-07-19 21:33:26', 10, 0, '', '2019-07-19 21:33:26');
INSERT INTO `access_log` VALUES (56692, '64.80.15635432061471001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.85.77.98', '2019-07-19 21:33:26', 5, 0, '', '2019-07-19 21:33:26');
INSERT INTO `access_log` VALUES (56693, '65.3607.15635432163884689', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.85.77.98', '2019-07-19 21:33:36', 0, 1002001015, '账号未登陆', '2019-07-19 21:33:36');
INSERT INTO `access_log` VALUES (56694, '65.53.15635432163902893', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.85.77.98', '2019-07-19 21:33:36', 0, 1002001015, '账号未登陆', '2019-07-19 21:33:36');
INSERT INTO `access_log` VALUES (56695, '65.54.15635432163902825', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.85.77.98', '2019-07-19 21:33:36', 0, 1002001015, '账号未登陆', '2019-07-19 21:33:36');
INSERT INTO `access_log` VALUES (56696, '65.50.15635432179502905', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.85.77.98', '2019-07-19 21:33:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-19 21:33:38');
INSERT INTO `access_log` VALUES (56697, '65.51.15635432298912949', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.85.77.98', '2019-07-19 21:33:50', 429, 0, '', '2019-07-19 21:33:50');
INSERT INTO `access_log` VALUES (56698, '65.46.15635432308852951', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.85.77.98', '2019-07-19 21:33:51', 12, 0, '', '2019-07-19 21:33:51');
INSERT INTO `access_log` VALUES (56699, '65.45.15635432308892871', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.85.77.98', '2019-07-19 21:33:51', 11, 2001001000, '服务端发生异常', '2019-07-19 21:33:51');
INSERT INTO `access_log` VALUES (56700, '65.47.15635432308942877', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.85.77.98', '2019-07-19 21:33:51', 10, 0, '', '2019-07-19 21:33:51');
INSERT INTO `access_log` VALUES (56701, '59.77.15635493885730855', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.129.41.86', '2019-07-19 23:16:29', 32, 2001001000, '服务端发生异常', '2019-07-19 23:16:29');
INSERT INTO `access_log` VALUES (56702, '59.73.15635493885730869', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.129.41.86', '2019-07-19 23:16:29', 170, 0, '', '2019-07-19 23:16:29');
INSERT INTO `access_log` VALUES (56703, '64.84.15635493961981069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.129.41.86', '2019-07-19 23:16:36', 54, 0, '', '2019-07-19 23:16:36');
INSERT INTO `access_log` VALUES (56704, '64.85.15635493963671097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.129.41.86', '2019-07-19 23:16:36', 3, 0, '', '2019-07-19 23:16:36');
INSERT INTO `access_log` VALUES (56705, '64.83.15635493979581075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.129.41.86', '2019-07-19 23:16:38', 2, 0, '', '2019-07-19 23:16:38');
INSERT INTO `access_log` VALUES (56706, '59.71.15635493989310865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.129.41.86', '2019-07-19 23:16:39', 3, 0, '', '2019-07-19 23:16:39');
INSERT INTO `access_log` VALUES (56707, '59.75.15635493989310873', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.129.41.86', '2019-07-19 23:16:39', 18, 2001001000, '服务端发生异常', '2019-07-19 23:16:39');
INSERT INTO `access_log` VALUES (56708, '65.46.15635510191723061', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.38.241.21', '2019-07-19 23:43:39', 0, 1002001015, '账号未登陆', '2019-07-19 23:43:39');
INSERT INTO `access_log` VALUES (56709, '65.50.15635510191743013', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.38.241.21', '2019-07-19 23:43:39', 1, 1002001015, '账号未登陆', '2019-07-19 23:43:39');
INSERT INTO `access_log` VALUES (56710, '65.49.15635510191802971', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.38.241.21', '2019-07-19 23:43:39', 0, 1002001015, '账号未登陆', '2019-07-19 23:43:39');
INSERT INTO `access_log` VALUES (56711, '65.51.15635510235273053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.38.241.21', '2019-07-19 23:43:44', 68, 0, '', '2019-07-19 23:43:44');
INSERT INTO `access_log` VALUES (56712, '65.53.15635510238552999', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.38.241.21', '2019-07-19 23:43:44', 19, 0, '', '2019-07-19 23:43:44');
INSERT INTO `access_log` VALUES (56713, '65.52.15635510238573027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.38.241.21', '2019-07-19 23:43:44', 19, 2001001000, '服务端发生异常', '2019-07-19 23:43:44');
INSERT INTO `access_log` VALUES (56714, '65.3607.15635510238614797', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.38.241.21', '2019-07-19 23:43:44', 18, 0, '', '2019-07-19 23:43:44');
INSERT INTO `access_log` VALUES (56715, '65.47.15635510478102985', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.38.241.21', '2019-07-19 23:44:08', 9, 0, '', '2019-07-19 23:44:08');
INSERT INTO `access_log` VALUES (56716, '65.45.15635510478142979', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.38.241.21', '2019-07-19 23:44:08', 10, 2001001000, '服务端发生异常', '2019-07-19 23:44:08');
INSERT INTO `access_log` VALUES (56717, '65.50.15635510478283015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.38.241.21', '2019-07-19 23:44:08', 9, 0, '', '2019-07-19 23:44:08');
INSERT INTO `access_log` VALUES (56718, '59.76.15635524220900897', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '183.13.14.162', '2019-07-20 00:07:02', 9, 0, '', '2019-07-20 00:07:02');
INSERT INTO `access_log` VALUES (56719, '59.72.15635524220880905', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1 Safari/605.1.15', '183.13.14.162', '2019-07-20 00:07:02', 14, 2001001000, '服务端发生异常', '2019-07-20 00:07:02');
INSERT INTO `access_log` VALUES (56720, '65.53.15635799445413387', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.101.29.133', '2019-07-20 07:45:45', 33, 1002001012, '访问令牌已过期', '2019-07-20 07:45:45');
INSERT INTO `access_log` VALUES (56721, '65.52.15635799445413415', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.101.29.133', '2019-07-20 07:45:45', 28, 1002001012, '访问令牌已过期', '2019-07-20 07:45:45');
INSERT INTO `access_log` VALUES (56722, '65.47.15635799445473375', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.101.29.133', '2019-07-20 07:45:45', 15, 1002001012, '访问令牌已过期', '2019-07-20 07:45:45');
INSERT INTO `access_log` VALUES (56723, '65.54.15635799509053321', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.101.29.133', '2019-07-20 07:45:51', 99, 0, '', '2019-07-20 07:45:51');
INSERT INTO `access_log` VALUES (56724, '65.50.15635799513363401', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.101.29.133', '2019-07-20 07:45:51', 12, 0, '', '2019-07-20 07:45:51');
INSERT INTO `access_log` VALUES (56725, '65.46.15635799513413449', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.101.29.133', '2019-07-20 07:45:51', 12, 2001001000, '服务端发生异常', '2019-07-20 07:45:51');
INSERT INTO `access_log` VALUES (56726, '65.45.15635799513443365', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.101.29.133', '2019-07-20 07:45:51', 13, 0, '', '2019-07-20 07:45:51');
INSERT INTO `access_log` VALUES (56727, '59.76.15635799763171265', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.101.29.133', '2019-07-20 07:46:16', 11, 0, '', '2019-07-20 07:46:16');
INSERT INTO `access_log` VALUES (56728, '59.78.15635799763171273', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.101.29.133', '2019-07-20 07:46:16', 30, 2001001000, '服务端发生异常', '2019-07-20 07:46:16');
INSERT INTO `access_log` VALUES (56729, '65.47.15635848225583441', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.139.112.160', '2019-07-20 09:07:03', 0, 1002001015, '账号未登陆', '2019-07-20 09:07:03');
INSERT INTO `access_log` VALUES (56730, '65.54.15635848225583387', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.139.112.160', '2019-07-20 09:07:03', 0, 1002001015, '账号未登陆', '2019-07-20 09:07:03');
INSERT INTO `access_log` VALUES (56731, '65.50.15635848225583467', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.139.112.160', '2019-07-20 09:07:03', 0, 1002001015, '账号未登陆', '2019-07-20 09:07:03');
INSERT INTO `access_log` VALUES (56732, '65.45.15635848250303431', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.139.112.160', '2019-07-20 09:07:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 09:07:05');
INSERT INTO `access_log` VALUES (56733, '65.46.15635848268413515', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.139.112.160', '2019-07-20 09:07:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 09:07:07');
INSERT INTO `access_log` VALUES (56734, '65.3607.15635848350255253', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.139.112.160', '2019-07-20 09:07:15', 103, 0, '', '2019-07-20 09:07:15');
INSERT INTO `access_log` VALUES (56735, '65.49.15635848354493427', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.139.112.160', '2019-07-20 09:07:15', 11, 0, '', '2019-07-20 09:07:15');
INSERT INTO `access_log` VALUES (56736, '65.52.15635848354493483', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.139.112.160', '2019-07-20 09:07:15', 13, 2001001000, '服务端发生异常', '2019-07-20 09:07:15');
INSERT INTO `access_log` VALUES (56737, '65.53.15635848354553455', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.139.112.160', '2019-07-20 09:07:15', 10, 0, '', '2019-07-20 09:07:15');
INSERT INTO `access_log` VALUES (56738, '65.45.15635848865283433', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.139.112.160', '2019-07-20 09:08:07', 11, 0, '', '2019-07-20 09:08:07');
INSERT INTO `access_log` VALUES (56739, '65.46.15635848865313517', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.139.112.160', '2019-07-20 09:08:07', 11, 2001001000, '服务端发生异常', '2019-07-20 09:08:07');
INSERT INTO `access_log` VALUES (56740, '65.51.15635848865393509', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.139.112.160', '2019-07-20 09:08:07', 8, 0, '', '2019-07-20 09:08:07');
INSERT INTO `access_log` VALUES (56741, '65.47.15635864415163465', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '210.22.130.114', '2019-07-20 09:34:02', 0, 1002001015, '账号未登陆', '2019-07-20 09:34:02');
INSERT INTO `access_log` VALUES (56742, '65.54.15635864415163411', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '210.22.130.114', '2019-07-20 09:34:02', 1, 1002001015, '账号未登陆', '2019-07-20 09:34:02');
INSERT INTO `access_log` VALUES (56743, '65.50.15635864415183491', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '210.22.130.114', '2019-07-20 09:34:02', 0, 1002001015, '账号未登陆', '2019-07-20 09:34:02');
INSERT INTO `access_log` VALUES (56744, '65.3607.15635864848465277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '210.22.130.114', '2019-07-20 09:34:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 09:34:45');
INSERT INTO `access_log` VALUES (56745, '65.49.15635864904983451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '210.22.130.114', '2019-07-20 09:34:50', 84, 0, '', '2019-07-20 09:34:51');
INSERT INTO `access_log` VALUES (56746, '65.52.15635865027983507', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '210.22.130.114', '2019-07-20 09:35:03', 148, 0, '', '2019-07-20 09:35:03');
INSERT INTO `access_log` VALUES (56747, '65.50.15635865032253493', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '210.22.130.114', '2019-07-20 09:35:03', 9, 0, '', '2019-07-20 09:35:03');
INSERT INTO `access_log` VALUES (56748, '65.47.15635865032293467', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '210.22.130.114', '2019-07-20 09:35:03', 11, 2001001000, '服务端发生异常', '2019-07-20 09:35:03');
INSERT INTO `access_log` VALUES (56749, '65.54.15635865032333413', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '210.22.130.114', '2019-07-20 09:35:03', 9, 0, '', '2019-07-20 09:35:03');
INSERT INTO `access_log` VALUES (56750, '59.75.15635868289271373', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '210.22.130.114', '2019-07-20 09:40:29', 10, 0, '', '2019-07-20 09:40:29');
INSERT INTO `access_log` VALUES (56751, '59.76.15635868289301357', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '210.22.130.114', '2019-07-20 09:40:29', 18, 2001001000, '服务端发生异常', '2019-07-20 09:40:29');
INSERT INTO `access_log` VALUES (56752, '64.85.15635868362931595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '210.22.130.114', '2019-07-20 09:40:36', 12, 0, '', '2019-07-20 09:40:36');
INSERT INTO `access_log` VALUES (56753, '64.83.15635868364111575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '210.22.130.114', '2019-07-20 09:40:36', 4, 0, '', '2019-07-20 09:40:36');
INSERT INTO `access_log` VALUES (56754, '64.82.15635868376911589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '210.22.130.114', '2019-07-20 09:40:38', 2, 0, '', '2019-07-20 09:40:38');
INSERT INTO `access_log` VALUES (56755, '64.77.15635868393071563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '210.22.130.114', '2019-07-20 09:40:39', 2, 0, '', '2019-07-20 09:40:39');
INSERT INTO `access_log` VALUES (56756, '64.81.15635868396691565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '210.22.130.114', '2019-07-20 09:40:40', 2, 0, '', '2019-07-20 09:40:40');
INSERT INTO `access_log` VALUES (56757, '64.76.15635868399081575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '210.22.130.114', '2019-07-20 09:40:40', 3, 0, '', '2019-07-20 09:40:40');
INSERT INTO `access_log` VALUES (56758, '64.79.15635868403711581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '210.22.130.114', '2019-07-20 09:40:40', 2, 0, '', '2019-07-20 09:40:40');
INSERT INTO `access_log` VALUES (56759, '59.79.15635868410091369', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '210.22.130.114', '2019-07-20 09:40:41', 4, 0, '', '2019-07-20 09:40:41');
INSERT INTO `access_log` VALUES (56760, '59.72.15635868410091365', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '210.22.130.114', '2019-07-20 09:40:41', 16, 2001001000, '服务端发生异常', '2019-07-20 09:40:41');
INSERT INTO `access_log` VALUES (56761, '66.49.15635868533799239', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17521167506', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '210.22.130.114', '2019-07-20 09:40:53', 95, 0, '', '2019-07-20 09:40:53');
INSERT INTO `access_log` VALUES (56762, '66.53.15635868601519237', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17521167506&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '210.22.130.114', '2019-07-20 09:41:00', 192, 0, '', '2019-07-20 09:41:00');
INSERT INTO `access_log` VALUES (56763, '59.77.15635879094351371', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:29', 3, 0, '', '2019-07-20 09:58:29');
INSERT INTO `access_log` VALUES (56764, '59.73.15635879094371385', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:29', 20, 2001001000, '服务端发生异常', '2019-07-20 09:58:29');
INSERT INTO `access_log` VALUES (56765, '64.78.15635879133631597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:33', 3, 0, '', '2019-07-20 09:58:33');
INSERT INTO `access_log` VALUES (56766, '64.84.15635879135051585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:34', 2, 0, '', '2019-07-20 09:58:34');
INSERT INTO `access_log` VALUES (56767, '59.71.15635879150431381', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:35', 3, 0, '', '2019-07-20 09:58:35');
INSERT INTO `access_log` VALUES (56768, '59.75.15635879150431389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:35', 10, 2001001000, '服务端发生异常', '2019-07-20 09:58:35');
INSERT INTO `access_log` VALUES (56769, '59.76.15635879194171373', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:39', 3, 0, '', '2019-07-20 09:58:39');
INSERT INTO `access_log` VALUES (56770, '59.78.15635879194171381', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:39', 16, 2001001000, '服务端发生异常', '2019-07-20 09:58:39');
INSERT INTO `access_log` VALUES (56771, '65.53.15635879295633499', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:50', 0, 1002001015, '账号未登陆', '2019-07-20 09:58:50');
INSERT INTO `access_log` VALUES (56772, '65.52.15635879296053527', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:50', 0, 1002001015, '账号未登陆', '2019-07-20 09:58:50');
INSERT INTO `access_log` VALUES (56773, '65.50.15635879296283513', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:50', 0, 1002001015, '账号未登陆', '2019-07-20 09:58:50');
INSERT INTO `access_log` VALUES (56774, '65.47.15635879326623487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 09:58:53');
INSERT INTO `access_log` VALUES (56775, '65.46.15635879381403561', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:58', 74, 0, '', '2019-07-20 09:58:58');
INSERT INTO `access_log` VALUES (56776, '65.51.15635879385563553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:59', 10, 0, '', '2019-07-20 09:58:59');
INSERT INTO `access_log` VALUES (56777, '65.45.15635879385783477', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:59', 10, 2001001000, '服务端发生异常', '2019-07-20 09:58:59');
INSERT INTO `access_log` VALUES (56778, '65.3607.15635879386095299', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.131.188', '2019-07-20 09:58:59', 9, 0, '', '2019-07-20 09:58:59');
INSERT INTO `access_log` VALUES (56779, '65.46.15635883262903567', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:05:26', 0, 1002001015, '账号未登陆', '2019-07-20 10:05:26');
INSERT INTO `access_log` VALUES (56780, '65.51.15635883263053559', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:05:26', 0, 1002001015, '账号未登陆', '2019-07-20 10:05:26');
INSERT INTO `access_log` VALUES (56781, '65.45.15635883263063483', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:05:26', 0, 1002001015, '账号未登陆', '2019-07-20 10:05:26');
INSERT INTO `access_log` VALUES (56782, '65.3607.15635883367305305', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:05:37', 1, 1002001015, '账号未登陆', '2019-07-20 10:05:37');
INSERT INTO `access_log` VALUES (56783, '65.49.15635883367333479', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:05:37', 1, 1002001015, '账号未登陆', '2019-07-20 10:05:37');
INSERT INTO `access_log` VALUES (56784, '65.53.15635883367373507', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:05:37', 1, 1002001015, '账号未登陆', '2019-07-20 10:05:37');
INSERT INTO `access_log` VALUES (56785, '65.50.15635883404503521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:05:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 10:05:40');
INSERT INTO `access_log` VALUES (56786, '65.47.15635883469853495', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:05:47', 195, 0, '', '2019-07-20 10:05:47');
INSERT INTO `access_log` VALUES (56787, '65.45.15635883476363485', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:05:48', 11, 0, '', '2019-07-20 10:05:48');
INSERT INTO `access_log` VALUES (56788, '65.51.15635883476373561', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:05:48', 10, 0, '', '2019-07-20 10:05:48');
INSERT INTO `access_log` VALUES (56789, '65.54.15635883476353441', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:05:48', 13, 2001001000, '服务端发生异常', '2019-07-20 10:05:48');
INSERT INTO `access_log` VALUES (56790, '65.3607.15635883539735307', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:05:54', 8, 0, '', '2019-07-20 10:05:54');
INSERT INTO `access_log` VALUES (56791, '65.53.15635883539773509', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:05:54', 9, 0, '', '2019-07-20 10:05:54');
INSERT INTO `access_log` VALUES (56792, '65.49.15635883539763481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:05:54', 9, 2001001000, '服务端发生异常', '2019-07-20 10:05:54');
INSERT INTO `access_log` VALUES (56793, '59.79.15635883760611391', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:06:16', 3, 0, '', '2019-07-20 10:06:16');
INSERT INTO `access_log` VALUES (56794, '59.72.15635883760611387', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '61.144.55.170', '2019-07-20 10:06:16', 17, 2001001000, '服务端发生异常', '2019-07-20 10:06:16');
INSERT INTO `access_log` VALUES (56795, '65.54.15635893499973453', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.201.228.232', '2019-07-20 10:22:30', 0, 1002001015, '账号未登陆', '2019-07-20 10:22:30');
INSERT INTO `access_log` VALUES (56796, '65.51.15635893499973577', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.201.228.232', '2019-07-20 10:22:30', 1, 1002001015, '账号未登陆', '2019-07-20 10:22:30');
INSERT INTO `access_log` VALUES (56797, '65.46.15635893500003585', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.201.228.232', '2019-07-20 10:22:30', 0, 1002001015, '账号未登陆', '2019-07-20 10:22:30');
INSERT INTO `access_log` VALUES (56798, '65.3607.15635893523325321', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.201.228.232', '2019-07-20 10:22:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 10:22:32');
INSERT INTO `access_log` VALUES (56799, '65.49.15635893586433495', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.201.228.232', '2019-07-20 10:22:39', 1703, 0, '', '2019-07-20 10:22:40');
INSERT INTO `access_log` VALUES (56800, '65.52.15635893606793553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.201.228.232', '2019-07-20 10:22:41', 10, 0, '', '2019-07-20 10:22:41');
INSERT INTO `access_log` VALUES (56801, '65.50.15635893606843537', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.201.228.232', '2019-07-20 10:22:41', 10, 2001001000, '服务端发生异常', '2019-07-20 10:22:41');
INSERT INTO `access_log` VALUES (56802, '65.47.15635893606863509', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.201.228.232', '2019-07-20 10:22:41', 9, 0, '', '2019-07-20 10:22:41');
INSERT INTO `access_log` VALUES (56803, '65.46.15635895999293587', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.111.198.102', '2019-07-20 10:26:40', 0, 1002001015, '账号未登陆', '2019-07-20 10:26:40');
INSERT INTO `access_log` VALUES (56804, '65.3607.15635895999345327', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.111.198.102', '2019-07-20 10:26:40', 0, 1002001015, '账号未登陆', '2019-07-20 10:26:40');
INSERT INTO `access_log` VALUES (56805, '65.53.15635895999443529', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.111.198.102', '2019-07-20 10:26:40', 0, 1002001015, '账号未登陆', '2019-07-20 10:26:40');
INSERT INTO `access_log` VALUES (56806, '65.52.15635896031073559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.111.198.102', '2019-07-20 10:26:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 10:26:43');
INSERT INTO `access_log` VALUES (56807, '65.47.15635896069673511', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.111.198.102', '2019-07-20 10:26:47', 63, 0, '', '2019-07-20 10:26:47');
INSERT INTO `access_log` VALUES (56808, '65.50.15635896073163543', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.111.198.102', '2019-07-20 10:26:47', 10, 0, '', '2019-07-20 10:26:47');
INSERT INTO `access_log` VALUES (56809, '65.45.15635896073243505', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.111.198.102', '2019-07-20 10:26:47', 10, 2001001000, '服务端发生异常', '2019-07-20 10:26:47');
INSERT INTO `access_log` VALUES (56810, '65.51.15635896073283585', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.111.198.102', '2019-07-20 10:26:47', 9, 0, '', '2019-07-20 10:26:47');
INSERT INTO `access_log` VALUES (56811, '59.72.15635917936181433', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '119.139.196.37', '2019-07-20 11:03:14', 11, 0, '', '2019-07-20 11:03:14');
INSERT INTO `access_log` VALUES (56812, '59.79.15635917936211437', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '119.139.196.37', '2019-07-20 11:03:14', 33, 2001001000, '服务端发生异常', '2019-07-20 11:03:14');
INSERT INTO `access_log` VALUES (56813, '64.84.15635917975951637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '119.139.196.37', '2019-07-20 11:03:18', 12, 0, '', '2019-07-20 11:03:18');
INSERT INTO `access_log` VALUES (56814, '64.85.15635917977631663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '119.139.196.37', '2019-07-20 11:03:18', 3, 0, '', '2019-07-20 11:03:18');
INSERT INTO `access_log` VALUES (56815, '64.83.15635917989411643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '119.139.196.37', '2019-07-20 11:03:19', 2, 0, '', '2019-07-20 11:03:19');
INSERT INTO `access_log` VALUES (56816, '64.82.15635917993751657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '119.139.196.37', '2019-07-20 11:03:19', 1, 0, '', '2019-07-20 11:03:19');
INSERT INTO `access_log` VALUES (56817, '66.56.15635918019699311', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '119.139.196.37', '2019-07-20 11:03:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空\n手机验证码不能为空\n手机号必须都是数字', '2019-07-20 11:03:22');
INSERT INTO `access_log` VALUES (56818, '64.81.15635918057281633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '119.139.196.37', '2019-07-20 11:03:26', 2, 0, '', '2019-07-20 11:03:26');
INSERT INTO `access_log` VALUES (56819, '64.76.15635918063101643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '119.139.196.37', '2019-07-20 11:03:26', 3, 0, '', '2019-07-20 11:03:26');
INSERT INTO `access_log` VALUES (56820, '59.73.15635918093441439', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '119.139.196.37', '2019-07-20 11:03:29', 3, 0, '', '2019-07-20 11:03:29');
INSERT INTO `access_log` VALUES (56821, '59.77.15635918093451425', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '119.139.196.37', '2019-07-20 11:03:29', 14, 2001001000, '服务端发生异常', '2019-07-20 11:03:29');
INSERT INTO `access_log` VALUES (56822, '59.72.15635930752381451', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.236.45.107', '2019-07-20 11:24:35', 4, 0, '', '2019-07-20 11:24:35');
INSERT INTO `access_log` VALUES (56823, '59.79.15635930752391455', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.236.45.107', '2019-07-20 11:24:35', 15, 2001001000, '服务端发生异常', '2019-07-20 11:24:35');
INSERT INTO `access_log` VALUES (56824, '65.45.15635961347623593', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:35', 1, 1002001015, '账号未登陆', '2019-07-20 12:15:35');
INSERT INTO `access_log` VALUES (56825, '65.51.15635961347613673', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:35', 1, 1002001015, '账号未登陆', '2019-07-20 12:15:35');
INSERT INTO `access_log` VALUES (56826, '65.50.15635961347663631', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:35', 0, 1002001015, '账号未登陆', '2019-07-20 12:15:35');
INSERT INTO `access_log` VALUES (56827, '65.3607.15635961408835415', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:41', 100, 0, '', '2019-07-20 12:15:41');
INSERT INTO `access_log` VALUES (56828, '65.53.15635961411943617', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:41', 17, 0, '', '2019-07-20 12:15:41');
INSERT INTO `access_log` VALUES (56829, '65.46.15635961411933677', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:41', 19, 2001001000, '服务端发生异常', '2019-07-20 12:15:41');
INSERT INTO `access_log` VALUES (56830, '65.49.15635961411993587', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:41', 14, 0, '', '2019-07-20 12:15:41');
INSERT INTO `access_log` VALUES (56831, '65.47.15635961483163601', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:48', 12, 2001001000, '服务端发生异常', '2019-07-20 12:15:48');
INSERT INTO `access_log` VALUES (56832, '65.45.15635961483183595', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:48', 11, 0, '', '2019-07-20 12:15:48');
INSERT INTO `access_log` VALUES (56833, '65.52.15635961483163649', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:48', 12, 0, '', '2019-07-20 12:15:48');
INSERT INTO `access_log` VALUES (56834, '65.51.15635961547873675', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:55', 9, 0, '', '2019-07-20 12:15:55');
INSERT INTO `access_log` VALUES (56835, '65.54.15635961547883551', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:55', 11, 2001001000, '服务端发生异常', '2019-07-20 12:15:55');
INSERT INTO `access_log` VALUES (56836, '65.3607.15635961547925417', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:55', 8, 0, '', '2019-07-20 12:15:55');
INSERT INTO `access_log` VALUES (56837, '65.53.15635961585243619', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:59', 9, 0, '', '2019-07-20 12:15:59');
INSERT INTO `access_log` VALUES (56838, '65.46.15635961585273679', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:59', 9, 2001001000, '服务端发生异常', '2019-07-20 12:15:59');
INSERT INTO `access_log` VALUES (56839, '65.49.15635961585323589', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.181.18', '2019-07-20 12:15:59', 25, 0, '', '2019-07-20 12:15:59');
INSERT INTO `access_log` VALUES (56840, '59.80.15636062732091607', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.200.194', '2019-07-20 15:04:33', 20, 2001001000, '服务端发生异常', '2019-07-20 15:04:33');
INSERT INTO `access_log` VALUES (56841, '59.79.15636062732031631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.200.194', '2019-07-20 15:04:33', 441, 0, '', '2019-07-20 15:04:34');
INSERT INTO `access_log` VALUES (56842, '65.54.15636062915763685', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.200.194', '2019-07-20 15:04:52', 1, 1002001015, '账号未登陆', '2019-07-20 15:04:52');
INSERT INTO `access_log` VALUES (56843, '65.46.15636062915763815', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.200.194', '2019-07-20 15:04:52', 0, 1002001015, '账号未登陆', '2019-07-20 15:04:52');
INSERT INTO `access_log` VALUES (56844, '65.53.15636062915803755', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.200.194', '2019-07-20 15:04:52', 0, 1002001015, '账号未登陆', '2019-07-20 15:04:52');
INSERT INTO `access_log` VALUES (56845, '65.49.15636062939403725', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.180.200.194', '2019-07-20 15:04:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 15:04:54');
INSERT INTO `access_log` VALUES (56846, '65.49.15636086882403757', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 15:44:48', 22, 1002001012, '访问令牌已过期', '2019-07-20 15:44:48');
INSERT INTO `access_log` VALUES (56847, '65.45.15636086882413765', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 15:44:48', 22, 1002001012, '访问令牌已过期', '2019-07-20 15:44:48');
INSERT INTO `access_log` VALUES (56848, '65.47.15636086882433771', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 15:44:48', 22, 1002001012, '访问令牌已过期', '2019-07-20 15:44:48');
INSERT INTO `access_log` VALUES (56849, '65.50.15636086902983803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 15:44:50', 439, 0, '', '2019-07-20 15:44:51');
INSERT INTO `access_log` VALUES (56850, '65.51.15636086909793845', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 15:44:51', 12, 0, '', '2019-07-20 15:44:51');
INSERT INTO `access_log` VALUES (56851, '65.3607.15636086909855587', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 15:44:51', 9, 0, '', '2019-07-20 15:44:51');
INSERT INTO `access_log` VALUES (56852, '65.53.15636086909893789', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 15:44:51', 8, 0, '', '2019-07-20 15:44:51');
INSERT INTO `access_log` VALUES (56853, '62.82.15636087129540765', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 15:45:13', 57, 0, '', '2019-07-20 15:45:13');
INSERT INTO `access_log` VALUES (56854, '64.81.15636087197471859', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 15:45:20', 22, 0, '', '2019-07-20 15:45:20');
INSERT INTO `access_log` VALUES (56855, '64.77.15636087197431857', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 15:45:20', 27, 0, '', '2019-07-20 15:45:20');
INSERT INTO `access_log` VALUES (56856, '59.71.15636087333981661', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 15:45:33', 23, 0, '', '2019-07-20 15:45:33');
INSERT INTO `access_log` VALUES (56857, '62.80.15636096361510779', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 16:00:36', 17, 0, '', '2019-07-20 16:00:36');
INSERT INTO `access_log` VALUES (56858, '66.56.15636096408859549', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 16:00:41', 20, 0, '', '2019-07-20 16:00:41');
INSERT INTO `access_log` VALUES (56859, '59.76.15636096460881665', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 16:00:46', 14, 0, '', '2019-07-20 16:00:46');
INSERT INTO `access_log` VALUES (56860, '65.49.15636096506363771', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 16:00:51', 65, 0, '', '2019-07-20 16:00:51');
INSERT INTO `access_log` VALUES (56861, '65.50.15636096549883817', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 16:00:55', 492, 0, '', '2019-07-20 16:00:55');
INSERT INTO `access_log` VALUES (56862, '65.53.15636096672553803', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 16:01:07', 9, 0, '', '2019-07-20 16:01:07');
INSERT INTO `access_log` VALUES (56863, '65.51.15636096694023859', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '124.205.46.242', '2019-07-20 16:01:09', 21, 0, '', '2019-07-20 16:01:09');
INSERT INTO `access_log` VALUES (56864, '59.73.15636145004381743', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.133.101.36', '2019-07-20 17:21:40', 11, 0, '', '2019-07-20 17:21:40');
INSERT INTO `access_log` VALUES (56865, '59.74.15636145004411747', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.133.101.36', '2019-07-20 17:21:40', 30, 2001001000, '服务端发生异常', '2019-07-20 17:21:40');
INSERT INTO `access_log` VALUES (56866, '65.45.15636145135693845', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.133.101.36', '2019-07-20 17:21:54', 0, 1002001015, '账号未登陆', '2019-07-20 17:21:54');
INSERT INTO `access_log` VALUES (56867, '65.52.15636145135693899', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.133.101.36', '2019-07-20 17:21:54', 0, 1002001015, '账号未登陆', '2019-07-20 17:21:54');
INSERT INTO `access_log` VALUES (56868, '65.49.15636145135793837', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.133.101.36', '2019-07-20 17:21:54', 0, 1002001015, '账号未登陆', '2019-07-20 17:21:54');
INSERT INTO `access_log` VALUES (56869, '65.50.15636145188663883', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.133.101.36', '2019-07-20 17:21:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 17:21:59');
INSERT INTO `access_log` VALUES (56870, '65.3607.15636145301515667', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.133.101.36', '2019-07-20 17:22:10', 85, 0, '', '2019-07-20 17:22:10');
INSERT INTO `access_log` VALUES (56871, '65.46.15636145305523929', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.133.101.36', '2019-07-20 17:22:11', 13, 0, '', '2019-07-20 17:22:11');
INSERT INTO `access_log` VALUES (56872, '65.51.15636145305513925', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.133.101.36', '2019-07-20 17:22:11', 15, 2001001000, '服务端发生异常', '2019-07-20 17:22:11');
INSERT INTO `access_log` VALUES (56873, '65.54.15636145305573799', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '219.133.101.36', '2019-07-20 17:22:11', 17, 0, '', '2019-07-20 17:22:11');
INSERT INTO `access_log` VALUES (56874, '59.78.15636158853871757', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:44:45', 4, 0, '', '2019-07-20 17:44:45');
INSERT INTO `access_log` VALUES (56875, '59.76.15636158853881749', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:44:45', 20, 2001001000, '服务端发生异常', '2019-07-20 17:44:45');
INSERT INTO `access_log` VALUES (56876, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:44:52', 9, 0, '', '2019-07-20 17:44:52');
INSERT INTO `access_log` VALUES (56877, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:44:52', 22, 0, '', '2019-07-20 17:44:52');
INSERT INTO `access_log` VALUES (56878, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:45:01', 5, 0, '', '2019-07-20 17:45:01');
INSERT INTO `access_log` VALUES (56879, '64.76.15636159027501965', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:45:03', 10, 0, '', '2019-07-20 17:45:03');
INSERT INTO `access_log` VALUES (56880, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:45:13', 8, 0, '', '2019-07-20 17:45:13');
INSERT INTO `access_log` VALUES (56881, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:45:13', 9, 0, '', '2019-07-20 17:45:13');
INSERT INTO `access_log` VALUES (56882, '59.79.15636159135231761', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:45:14', 2, 0, '', '2019-07-20 17:45:14');
INSERT INTO `access_log` VALUES (56883, '59.77.15636159135591749', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:45:14', 16, 2001001000, '服务端发生异常', '2019-07-20 17:45:14');
INSERT INTO `access_log` VALUES (56884, '59.75.15636159358931767', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:45:36', 3, 0, '', '2019-07-20 17:45:36');
INSERT INTO `access_log` VALUES (56885, '59.71.15636159359041759', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:45:36', 16, 2001001000, '服务端发生异常', '2019-07-20 17:45:36');
INSERT INTO `access_log` VALUES (56886, '59.78.15636159453241759', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.166', '2019-07-20 17:45:45', 2, 0, '', '2019-07-20 17:45:45');
INSERT INTO `access_log` VALUES (56887, '59.76.15636159479461751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.89.19.197', '2019-07-20 17:45:48', 12, 2001001000, '服务端发生异常', '2019-07-20 17:45:48');
INSERT INTO `access_log` VALUES (56888, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.60.107', '2019-07-20 17:45:51', 11, 0, '', '2019-07-20 17:45:51');
INSERT INTO `access_log` VALUES (56889, '65.53.15636159620773889', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:46:02', 1, 1002001015, '账号未登陆', '2019-07-20 17:46:02');
INSERT INTO `access_log` VALUES (56890, '65.3607.15636159620875687', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:46:02', 0, 1002001015, '账号未登陆', '2019-07-20 17:46:02');
INSERT INTO `access_log` VALUES (56891, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.151.178.175', '2019-07-20 17:46:02', 5, 0, '', '2019-07-20 17:46:02');
INSERT INTO `access_log` VALUES (56892, '65.46.15636159621173949', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:46:02', 0, 1002001015, '账号未登陆', '2019-07-20 17:46:02');
INSERT INTO `access_log` VALUES (56893, '64.79.15636159686241973', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.89.239.230', '2019-07-20 17:46:09', 6, 0, '', '2019-07-20 17:46:09');
INSERT INTO `access_log` VALUES (56894, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.91.60.107', '2019-07-20 17:46:17', 9, 0, '', '2019-07-20 17:46:17');
INSERT INTO `access_log` VALUES (56895, '65.52.15636159865673921', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:46:27', 102, 0, '', '2019-07-20 17:46:27');
INSERT INTO `access_log` VALUES (56896, '65.49.15636159870223859', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:46:27', 10, 0, '', '2019-07-20 17:46:27');
INSERT INTO `access_log` VALUES (56897, '65.47.15636159870233873', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:46:27', 11, 0, '', '2019-07-20 17:46:27');
INSERT INTO `access_log` VALUES (56898, '65.45.15636159870223867', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:46:27', 12, 2001001000, '服务端发生异常', '2019-07-20 17:46:27');
INSERT INTO `access_log` VALUES (56899, '65.3607.15636160003275689', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:46:40', 18, 0, '', '2019-07-20 17:46:40');
INSERT INTO `access_log` VALUES (56900, '65.53.15636160003273891', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:46:40', 19, 2001001000, '服务端发生异常', '2019-07-20 17:46:40');
INSERT INTO `access_log` VALUES (56901, '65.46.15636160003433951', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.44.166.19', '2019-07-20 17:46:40', 9, 0, '', '2019-07-20 17:46:40');
INSERT INTO `access_log` VALUES (56902, '65.54.15636160222733821', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.60.107', '2019-07-20 17:47:02', 0, 1002001015, '账号未登陆', '2019-07-20 17:47:02');
INSERT INTO `access_log` VALUES (56903, '65.54.15636183732083853', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:26:13', 0, 1002001015, '账号未登陆', '2019-07-20 18:26:13');
INSERT INTO `access_log` VALUES (56904, '65.51.15636183732073979', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:26:13', 0, 1002001015, '账号未登陆', '2019-07-20 18:26:13');
INSERT INTO `access_log` VALUES (56905, '65.46.15636183732073983', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:26:13', 0, 1002001015, '账号未登陆', '2019-07-20 18:26:13');
INSERT INTO `access_log` VALUES (56906, '65.52.15636183758613955', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:26:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 18:26:16');
INSERT INTO `access_log` VALUES (56907, '65.45.15636183795213901', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:26:20', 204, 0, '', '2019-07-20 18:26:20');
INSERT INTO `access_log` VALUES (56908, '65.47.15636183800843907', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:26:20', 12, 0, '', '2019-07-20 18:26:20');
INSERT INTO `access_log` VALUES (56909, '65.49.15636183800903893', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:26:20', 10, 2001001000, '服务端发生异常', '2019-07-20 18:26:20');
INSERT INTO `access_log` VALUES (56910, '65.50.15636183800903939', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:26:20', 13, 0, '', '2019-07-20 18:26:20');
INSERT INTO `access_log` VALUES (56911, '65.54.15636184092773855', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:26:49', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 18:26:49');
INSERT INTO `access_log` VALUES (56912, '65.46.15636184166233985', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:26:57', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 18:26:57');
INSERT INTO `access_log` VALUES (56913, '65.52.15636184197823957', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:27:00', 374, 0, '', '2019-07-20 18:27:00');
INSERT INTO `access_log` VALUES (56914, '65.45.15636184203913903', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:27:00', 9, 0, '', '2019-07-20 18:27:00');
INSERT INTO `access_log` VALUES (56915, '65.50.15636184203933941', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:27:00', 11, 2001001000, '服务端发生异常', '2019-07-20 18:27:00');
INSERT INTO `access_log` VALUES (56916, '65.47.15636184203973909', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:27:00', 10, 0, '', '2019-07-20 18:27:00');
INSERT INTO `access_log` VALUES (56917, '59.71.15636184340361793', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:27:14', 13, 0, '', '2019-07-20 18:27:14');
INSERT INTO `access_log` VALUES (56918, '59.75.15636184340391801', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:27:14', 25, 2001001000, '服务端发生异常', '2019-07-20 18:27:14');
INSERT INTO `access_log` VALUES (56919, '59.76.15636184410791785', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '60.247.104.77', '2019-07-20 18:27:21', 4, 0, '', '2019-07-20 18:27:21');
INSERT INTO `access_log` VALUES (56920, '59.72.15636184410811793', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '60.247.104.77', '2019-07-20 18:27:21', 17, 2001001000, '服务端发生异常', '2019-07-20 18:27:21');
INSERT INTO `access_log` VALUES (56921, '64.82.15636184439842017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '60.247.104.77', '2019-07-20 18:27:24', 11, 0, '', '2019-07-20 18:27:24');
INSERT INTO `access_log` VALUES (56922, '64.83.15636184441482001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '60.247.104.77', '2019-07-20 18:27:24', 3, 0, '', '2019-07-20 18:27:24');
INSERT INTO `access_log` VALUES (56923, '65.47.15636191243563919', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:38:44', 9, 0, '', '2019-07-20 18:38:44');
INSERT INTO `access_log` VALUES (56924, '65.45.15636191243603913', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:38:44', 10, 2001001000, '服务端发生异常', '2019-07-20 18:38:44');
INSERT INTO `access_log` VALUES (56925, '65.50.15636191243713951', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:38:44', 9, 0, '', '2019-07-20 18:38:44');
INSERT INTO `access_log` VALUES (56926, '65.3607.15636191375205735', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-20 18:38:58', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 18:38:58');
INSERT INTO `access_log` VALUES (56927, '59.79.15636213150111835', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) baidu.sogo.uc.Chrome/36.0.1985.125 Safari/537.36', '180.163.220.5', '2019-07-20 19:15:15', 10, 0, '', '2019-07-20 19:15:15');
INSERT INTO `access_log` VALUES (56928, '59.77.15636213150121823', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) baidu.sogo.uc.Chrome/36.0.1985.125 Safari/537.36', '180.163.220.66', '2019-07-20 19:15:15', 40, 2001001000, '服务端发生异常', '2019-07-20 19:15:15');
INSERT INTO `access_log` VALUES (56929, '65.52.15636265546114067', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.192.119.51', '2019-07-20 20:42:35', 12, 1002001012, '访问令牌已过期', '2019-07-20 20:42:35');
INSERT INTO `access_log` VALUES (56930, '65.45.15636265546254013', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.192.119.51', '2019-07-20 20:42:35', 11, 1002001012, '访问令牌已过期', '2019-07-20 20:42:35');
INSERT INTO `access_log` VALUES (56931, '65.50.15636265546344051', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.192.119.51', '2019-07-20 20:42:35', 3, 1002001012, '访问令牌已过期', '2019-07-20 20:42:35');
INSERT INTO `access_log` VALUES (56932, '65.47.15636265568784019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.192.119.51', '2019-07-20 20:42:37', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 20:42:37');
INSERT INTO `access_log` VALUES (56933, '65.3607.15636265595765835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.192.119.51', '2019-07-20 20:42:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-20 20:42:40');
INSERT INTO `access_log` VALUES (56934, '65.53.15636265704014037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.192.119.51', '2019-07-20 20:42:50', 53, 0, '', '2019-07-20 20:42:50');
INSERT INTO `access_log` VALUES (56935, '65.46.15636265706354097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.192.119.51', '2019-07-20 20:42:51', 142, 0, '', '2019-07-20 20:42:51');
INSERT INTO `access_log` VALUES (56936, '65.54.15636265706303967', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.192.119.51', '2019-07-20 20:42:51', 145, 0, '', '2019-07-20 20:42:51');
INSERT INTO `access_log` VALUES (56937, '65.51.15636265706324093', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.192.119.51', '2019-07-20 20:42:51', 144, 2001001000, '服务端发生异常', '2019-07-20 20:42:51');
INSERT INTO `access_log` VALUES (56938, '65.46.15636272767284107', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-07-20 20:54:37', 0, 1002001015, '账号未登陆', '2019-07-20 20:54:37');
INSERT INTO `access_log` VALUES (56939, '65.51.15636272767314103', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-07-20 20:54:37', 0, 1002001015, '账号未登陆', '2019-07-20 20:54:37');
INSERT INTO `access_log` VALUES (56940, '65.54.15636272767363977', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-07-20 20:54:37', 0, 1002001015, '账号未登陆', '2019-07-20 20:54:37');
INSERT INTO `access_log` VALUES (56941, '65.52.15636272837104079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-07-20 20:54:44', 89, 0, '', '2019-07-20 20:54:44');
INSERT INTO `access_log` VALUES (56942, '65.50.15636272840304063', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-07-20 20:54:44', 9, 0, '', '2019-07-20 20:54:44');
INSERT INTO `access_log` VALUES (56943, '65.49.15636272840324017', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-07-20 20:54:44', 8, 0, '', '2019-07-20 20:54:44');
INSERT INTO `access_log` VALUES (56944, '65.47.15636272840324031', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-07-20 20:54:44', 9, 2001001000, '服务端发生异常', '2019-07-20 20:54:44');
INSERT INTO `access_log` VALUES (56945, '65.46.15636273067864109', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-07-20 20:55:07', 10, 0, '', '2019-07-20 20:55:07');
INSERT INTO `access_log` VALUES (56946, '65.53.15636273067864049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-07-20 20:55:07', 9, 0, '', '2019-07-20 20:55:07');
INSERT INTO `access_log` VALUES (56947, '65.51.15636273067864105', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-07-20 20:55:07', 12, 2001001000, '服务端发生异常', '2019-07-20 20:55:07');
INSERT INTO `access_log` VALUES (56948, '65.50.15636273435044065', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '183.192.164.85', '2019-07-20 20:55:44', 0, 1002001015, '账号未登陆', '2019-07-20 20:55:44');
INSERT INTO `access_log` VALUES (56949, '59.75.15636288502301941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.118.217.151', '2019-07-20 21:20:50', 9, 0, '', '2019-07-20 21:20:50');
INSERT INTO `access_log` VALUES (56950, '59.78.15636288502311933', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.196.60.95', '2019-07-20 21:20:50', 17, 2001001000, '服务端发生异常', '2019-07-20 21:20:50');
INSERT INTO `access_log` VALUES (56951, '59.78.15636381293992057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:55:29', 10, 0, '', '2019-07-20 23:55:29');
INSERT INTO `access_log` VALUES (56952, '59.76.15636381294192049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:55:29', 18, 2001001000, '服务端发生异常', '2019-07-20 23:55:29');
INSERT INTO `access_log` VALUES (56953, '64.79.15636381328232269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:55:33', 38, 0, '', '2019-07-20 23:55:33');
INSERT INTO `access_log` VALUES (56954, '64.85.15636381329942287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:55:33', 2, 0, '', '2019-07-20 23:55:33');
INSERT INTO `access_log` VALUES (56955, '64.84.15636381341872257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:55:34', 2, 0, '', '2019-07-20 23:55:34');
INSERT INTO `access_log` VALUES (56956, '64.77.15636381350772251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:55:35', 1, 0, '', '2019-07-20 23:55:35');
INSERT INTO `access_log` VALUES (56957, '64.81.15636381355362257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:55:36', 2, 0, '', '2019-07-20 23:55:36');
INSERT INTO `access_log` VALUES (56958, '64.82.15636381358872281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:55:36', 2, 0, '', '2019-07-20 23:55:36');
INSERT INTO `access_log` VALUES (56959, '64.83.15636381382102265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:55:38', 2, 0, '', '2019-07-20 23:55:38');
INSERT INTO `access_log` VALUES (56960, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:55:38', 9, 0, '', '2019-07-20 23:55:38');
INSERT INTO `access_log` VALUES (56961, '64.78.15636381400152273', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:55:40', 8, 0, '', '2019-07-20 23:55:40');
INSERT INTO `access_log` VALUES (56962, '66.51.15636381697689949', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15978903456&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:56:10', 17, 1001003000, '验证码不存在', '2019-07-20 23:56:10');
INSERT INTO `access_log` VALUES (56963, '66.52.15636381739649911', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15978903456&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:56:14', 7, 1001003000, '验证码不存在', '2019-07-20 23:56:14');
INSERT INTO `access_log` VALUES (56964, '66.49.15636381801569925', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15978903456&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:56:20', 8, 1001003000, '验证码不存在', '2019-07-20 23:56:20');
INSERT INTO `access_log` VALUES (56965, '66.50.15636381855889919', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15978903456', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:56:26', 56, 0, '', '2019-07-20 23:56:26');
INSERT INTO `access_log` VALUES (56966, '66.56.15636381878119931', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15978903456&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.226.197.246', '2019-07-20 23:56:28', 212, 0, '', '2019-07-20 23:56:28');
INSERT INTO `access_log` VALUES (56967, '59.73.15636381895692063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '183.192.164.71', '2019-07-20 23:56:30', 3, 0, '', '2019-07-20 23:56:30');
INSERT INTO `access_log` VALUES (56968, '64.84.15636381920392259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '183.192.164.71', '2019-07-20 23:56:32', 2, 0, '', '2019-07-20 23:56:32');
INSERT INTO `access_log` VALUES (56969, '64.77.15636381922302253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '183.192.164.85', '2019-07-20 23:56:32', 2, 0, '', '2019-07-20 23:56:32');
INSERT INTO `access_log` VALUES (56970, '64.76.15636381944122265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '183.192.164.85', '2019-07-20 23:56:34', 1, 0, '', '2019-07-20 23:56:34');
INSERT INTO `access_log` VALUES (56971, '64.82.15636381955752283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '183.192.164.56', '2019-07-20 23:56:36', 3, 0, '', '2019-07-20 23:56:36');
INSERT INTO `access_log` VALUES (56972, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '183.192.164.85', '2019-07-20 23:56:39', 6, 0, '', '2019-07-20 23:56:39');
INSERT INTO `access_log` VALUES (56973, '64.83.15636382020892267', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '120.204.17.71', '2019-07-20 23:56:42', 7, 0, '', '2019-07-20 23:56:42');
INSERT INTO `access_log` VALUES (56974, '65.46.15636395189954273', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.79.82', '2019-07-21 00:18:39', 1, 1002001015, '账号未登陆', '2019-07-21 00:18:39');
INSERT INTO `access_log` VALUES (56975, '65.3607.15636395189956011', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.79.82', '2019-07-21 00:18:39', 8, 1002001015, '账号未登陆', '2019-07-21 00:18:39');
INSERT INTO `access_log` VALUES (56976, '65.51.15636395189954269', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.79.82', '2019-07-21 00:18:39', 0, 1002001015, '账号未登陆', '2019-07-21 00:18:39');
INSERT INTO `access_log` VALUES (56977, '65.53.15636395211274213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.79.82', '2019-07-21 00:18:41', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-21 00:18:41');
INSERT INTO `access_log` VALUES (56978, '65.45.15636395373164191', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.79.82', '2019-07-21 00:18:57', 83, 0, '', '2019-07-21 00:18:57');
INSERT INTO `access_log` VALUES (56979, '65.52.15636395378454245', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.79.82', '2019-07-21 00:18:58', 15, 0, '', '2019-07-21 00:18:58');
INSERT INTO `access_log` VALUES (56980, '65.50.15636395378484229', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.79.82', '2019-07-21 00:18:58', 13, 2001001000, '服务端发生异常', '2019-07-21 00:18:58');
INSERT INTO `access_log` VALUES (56981, '65.49.15636395378594183', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.79.82', '2019-07-21 00:18:58', 11, 0, '', '2019-07-21 00:18:58');
INSERT INTO `access_log` VALUES (56982, '65.45.15636732315094641', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.163.200', '2019-07-21 09:40:32', 0, 1002001015, '账号未登陆', '2019-07-21 09:40:32');
INSERT INTO `access_log` VALUES (56983, '65.54.15636732315084593', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.163.200', '2019-07-21 09:40:32', 1, 1002001015, '账号未登陆', '2019-07-21 09:40:32');
INSERT INTO `access_log` VALUES (56984, '65.50.15636732315124679', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.163.200', '2019-07-21 09:40:32', 2, 1002001015, '账号未登陆', '2019-07-21 09:40:32');
INSERT INTO `access_log` VALUES (56985, '65.52.15636732440434697', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.163.200', '2019-07-21 09:40:44', 115, 0, '', '2019-07-21 09:40:44');
INSERT INTO `access_log` VALUES (56986, '65.47.15636732444104649', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.163.200', '2019-07-21 09:40:44', 164, 0, '', '2019-07-21 09:40:45');
INSERT INTO `access_log` VALUES (56987, '65.46.15636732444134725', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.163.200', '2019-07-21 09:40:44', 164, 0, '', '2019-07-21 09:40:45');
INSERT INTO `access_log` VALUES (56988, '65.3607.15636732444116463', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.163.200', '2019-07-21 09:40:44', 167, 2001001000, '服务端发生异常', '2019-07-21 09:40:45');
INSERT INTO `access_log` VALUES (56989, '65.53.15636732551954665', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.163.200', '2019-07-21 09:40:55', 21, 0, '', '2019-07-21 09:40:55');
INSERT INTO `access_log` VALUES (56990, '65.54.15636732551984595', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.163.200', '2019-07-21 09:40:55', 21, 2001001000, '服务端发生异常', '2019-07-21 09:40:55');
INSERT INTO `access_log` VALUES (56991, '65.45.15636732552134643', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.163.200', '2019-07-21 09:40:55', 8, 0, '', '2019-07-21 09:40:55');
INSERT INTO `access_log` VALUES (56992, '65.50.15636732580654681', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.163.200', '2019-07-21 09:40:58', 9, 0, '', '2019-07-21 09:40:58');
INSERT INTO `access_log` VALUES (56993, '65.49.15636732580654637', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.163.200', '2019-07-21 09:40:58', 11, 2001001000, '服务端发生异常', '2019-07-21 09:40:58');
INSERT INTO `access_log` VALUES (56994, '65.52.15636732580684699', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.163.200', '2019-07-21 09:40:58', 9, 0, '', '2019-07-21 09:40:58');
INSERT INTO `access_log` VALUES (56995, '65.52.15636754807274729', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 10:18:01', 0, 1002001015, '账号未登陆', '2019-07-21 10:18:01');
INSERT INTO `access_log` VALUES (56996, '65.50.15636754807274711', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 10:18:01', 0, 1002001015, '账号未登陆', '2019-07-21 10:18:01');
INSERT INTO `access_log` VALUES (56997, '65.3607.15636754807326495', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 10:18:01', 0, 1002001015, '账号未登陆', '2019-07-21 10:18:01');
INSERT INTO `access_log` VALUES (56998, '65.46.15636754928144757', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma &type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 10:18:13', 206, 0, '', '2019-07-21 10:18:13');
INSERT INTO `access_log` VALUES (56999, '65.51.15636754933364755', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 10:18:13', 11, 0, '', '2019-07-21 10:18:13');
INSERT INTO `access_log` VALUES (57000, '65.53.15636754933474697', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 10:18:13', 10, 0, '', '2019-07-21 10:18:13');
INSERT INTO `access_log` VALUES (57001, '65.45.15636754933474675', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 10:18:13', 13, 2001001000, '服务端发生异常', '2019-07-21 10:18:13');
INSERT INTO `access_log` VALUES (57002, '65.51.15636763430974767', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:32:23', 0, 1002001015, '账号未登陆', '2019-07-21 10:32:23');
INSERT INTO `access_log` VALUES (57003, '65.46.15636763430974769', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:32:23', 0, 1002001015, '账号未登陆', '2019-07-21 10:32:23');
INSERT INTO `access_log` VALUES (57004, '65.53.15636763431014709', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:32:23', 1, 1002001015, '账号未登陆', '2019-07-21 10:32:23');
INSERT INTO `access_log` VALUES (57005, '65.54.15636763493574639', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:32:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-21 10:32:29');
INSERT INTO `access_log` VALUES (57006, '65.50.15636763606664725', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:32:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-21 10:32:41');
INSERT INTO `access_log` VALUES (57007, '65.3607.15636763788246509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:32:59', 75, 0, '', '2019-07-21 10:32:59');
INSERT INTO `access_log` VALUES (57008, '65.47.15636763791194695', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:32:59', 9, 0, '', '2019-07-21 10:32:59');
INSERT INTO `access_log` VALUES (57009, '65.51.15636763791194769', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:32:59', 11, 2001001000, '服务端发生异常', '2019-07-21 10:32:59');
INSERT INTO `access_log` VALUES (57010, '65.46.15636763791284771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:32:59', 8, 0, '', '2019-07-21 10:32:59');
INSERT INTO `access_log` VALUES (57011, '65.53.15636763865514711', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:33:07', 11, 0, '', '2019-07-21 10:33:07');
INSERT INTO `access_log` VALUES (57012, '65.54.15636763865564641', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:33:07', 9, 0, '', '2019-07-21 10:33:07');
INSERT INTO `access_log` VALUES (57013, '65.45.15636763865564689', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:33:07', 9, 2001001000, '服务端发生异常', '2019-07-21 10:33:07');
INSERT INTO `access_log` VALUES (57014, '65.50.15636763983384727', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:33:18', 9, 0, '', '2019-07-21 10:33:18');
INSERT INTO `access_log` VALUES (57015, '65.52.15636763983404745', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:33:18', 9, 2001001000, '服务端发生异常', '2019-07-21 10:33:18');
INSERT INTO `access_log` VALUES (57016, '65.3607.15636763983426511', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:33:18', 8, 0, '', '2019-07-21 10:33:18');
INSERT INTO `access_log` VALUES (57017, '65.47.15636764061064697', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.91.60.104', '2019-07-21 10:33:26', 0, 1002001015, '账号未登陆', '2019-07-21 10:33:26');
INSERT INTO `access_log` VALUES (57018, '65.46.15636764063214773', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:33:26', 9, 0, '', '2019-07-21 10:33:26');
INSERT INTO `access_log` VALUES (57019, '65.53.15636764063244713', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:33:26', 9, 2001001000, '服务端发生异常', '2019-07-21 10:33:26');
INSERT INTO `access_log` VALUES (57020, '65.54.15636764063264643', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:33:26', 8, 0, '', '2019-07-21 10:33:26');
INSERT INTO `access_log` VALUES (57021, '65.45.15636764104654691', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.178.166', '2019-07-21 10:33:30', 0, 1002001015, '账号未登陆', '2019-07-21 10:33:30');
INSERT INTO `access_log` VALUES (57022, '65.49.15636764137174685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:33:34', 64, 0, '', '2019-07-21 10:33:34');
INSERT INTO `access_log` VALUES (57023, '65.50.15636764139194729', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:33:34', 8, 0, '', '2019-07-21 10:33:34');
INSERT INTO `access_log` VALUES (57024, '65.3607.15636764139226513', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:33:34', 9, 0, '', '2019-07-21 10:33:34');
INSERT INTO `access_log` VALUES (57025, '65.52.15636764139244747', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:33:34', 8, 0, '', '2019-07-21 10:33:34');
INSERT INTO `access_log` VALUES (57026, '62.83.15636764293821681', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 10:33:49', 32, 0, '', '2019-07-21 10:33:49');
INSERT INTO `access_log` VALUES (57027, '62.82.15636764991621671', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.236', '2019-07-21 10:34:59', 1, 1002001015, '账号未登陆', '2019-07-21 10:34:59');
INSERT INTO `access_log` VALUES (57028, '7a833b41-c126-4bd4-84d8-c77c334d1b0e', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma', 'POST', 'PostmanRuntime/7.15.0', '0:0:0:0:0:0:0:1', '2019-07-21 10:37:01', 187, 1002002001, '密码不正确', '2019-07-21 10:37:01');
INSERT INTO `access_log` VALUES (57029, '6a7c1fb7-b17e-4eed-be7b-01be3d5ea843', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma', 'POST', 'PostmanRuntime/7.15.0', '0:0:0:0:0:0:0:1', '2019-07-21 10:37:14', 20, 1002002001, '密码不正确', '2019-07-21 10:37:14');
INSERT INTO `access_log` VALUES (57030, '14d7d84f-7c98-4a3f-b8bc-cdd78a4ec4b0', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456', 'POST', 'PostmanRuntime/7.15.0', '0:0:0:0:0:0:0:1', '2019-07-21 10:38:11', 585, 0, '', '2019-07-21 10:38:12');
INSERT INTO `access_log` VALUES (57031, 'e1e78b32-47e8-40bd-8a1d-46c60651ea81', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456', 'POST', 'PostmanRuntime/7.15.0', '0:0:0:0:0:0:0:1', '2019-07-21 10:39:46', 58864, 0, '', '2019-07-21 10:40:45');
INSERT INTO `access_log` VALUES (57032, '59.72.15636784203372595', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.173.28.108', '2019-07-21 11:07:00', 11, 0, '', '2019-07-21 11:07:00');
INSERT INTO `access_log` VALUES (57033, '59.80.15636784203372577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.173.28.108', '2019-07-21 11:07:00', 25, 2001001000, '服务端发生异常', '2019-07-21 11:07:00');
INSERT INTO `access_log` VALUES (57034, '64.81.15636784263812799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.173.28.108', '2019-07-21 11:07:06', 12, 0, '', '2019-07-21 11:07:06');
INSERT INTO `access_log` VALUES (57035, '64.83.15636784265122805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.173.28.108', '2019-07-21 11:07:07', 4, 0, '', '2019-07-21 11:07:07');
INSERT INTO `access_log` VALUES (57036, '64.79.15636784312342811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.173.28.108', '2019-07-21 11:07:11', 2, 0, '', '2019-07-21 11:07:11');
INSERT INTO `access_log` VALUES (57037, '64.80.15636784313602811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.173.28.108', '2019-07-21 11:07:11', 2, 0, '', '2019-07-21 11:07:11');
INSERT INTO `access_log` VALUES (57038, '64.78.15636784361412815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.173.28.108', '2019-07-21 11:07:16', 2, 0, '', '2019-07-21 11:07:16');
INSERT INTO `access_log` VALUES (57039, '64.77.15636784362412793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.173.28.108', '2019-07-21 11:07:16', 2, 0, '', '2019-07-21 11:07:16');
INSERT INTO `access_log` VALUES (57040, '59.74.15636784392382607', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.173.28.108', '2019-07-21 11:07:19', 3, 0, '', '2019-07-21 11:07:19');
INSERT INTO `access_log` VALUES (57041, '59.73.15636784392372603', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.173.28.108', '2019-07-21 11:07:19', 21, 2001001000, '服务端发生异常', '2019-07-21 11:07:19');
INSERT INTO `access_log` VALUES (57042, '65.46.15636805010854831', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.191.146.48', '2019-07-21 11:41:41', 0, 1002001015, '账号未登陆', '2019-07-21 11:41:41');
INSERT INTO `access_log` VALUES (57043, '65.45.15636805010864749', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.191.146.48', '2019-07-21 11:41:41', 0, 1002001015, '账号未登陆', '2019-07-21 11:41:41');
INSERT INTO `access_log` VALUES (57044, '65.53.15636805010884769', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.191.146.48', '2019-07-21 11:41:41', 0, 1002001015, '账号未登陆', '2019-07-21 11:41:41');
INSERT INTO `access_log` VALUES (57045, '65.54.15636805030134699', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.191.146.48', '2019-07-21 11:41:43', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-21 11:41:43');
INSERT INTO `access_log` VALUES (57046, '65.49.15636805065404743', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.191.146.48', '2019-07-21 11:41:47', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-21 11:41:47');
INSERT INTO `access_log` VALUES (57047, '65.3607.15636805161256571', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.191.146.48', '2019-07-21 11:41:56', 73, 0, '', '2019-07-21 11:41:56');
INSERT INTO `access_log` VALUES (57048, '65.52.15636805165214803', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.191.146.48', '2019-07-21 11:41:57', 11, 0, '', '2019-07-21 11:41:57');
INSERT INTO `access_log` VALUES (57049, '65.51.15636805165334829', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.191.146.48', '2019-07-21 11:41:57', 9, 0, '', '2019-07-21 11:41:57');
INSERT INTO `access_log` VALUES (57050, '65.47.15636805165364757', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.191.146.48', '2019-07-21 11:41:57', 9, 2001001000, '服务端发生异常', '2019-07-21 11:41:57');
INSERT INTO `access_log` VALUES (57051, '65.45.15636808402244755', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '121.32.71.83', '2019-07-21 11:47:20', 1, 1002001015, '账号未登陆', '2019-07-21 11:47:20');
INSERT INTO `access_log` VALUES (57052, '65.53.15636808402294775', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '121.32.71.83', '2019-07-21 11:47:20', 0, 1002001015, '账号未登陆', '2019-07-21 11:47:20');
INSERT INTO `access_log` VALUES (57053, '65.54.15636808402344705', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '121.32.71.83', '2019-07-21 11:47:20', 0, 1002001015, '账号未登陆', '2019-07-21 11:47:20');
INSERT INTO `access_log` VALUES (57054, '65.50.15636808462384789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '121.32.71.83', '2019-07-21 11:47:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-21 11:47:26');
INSERT INTO `access_log` VALUES (57055, '65.3607.15636808530556577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '121.32.71.83', '2019-07-21 11:47:33', 76, 0, '', '2019-07-21 11:47:33');
INSERT INTO `access_log` VALUES (57056, '65.51.15636808534884835', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '121.32.71.83', '2019-07-21 11:47:33', 10, 0, '', '2019-07-21 11:47:33');
INSERT INTO `access_log` VALUES (57057, '65.52.15636808534954809', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '121.32.71.83', '2019-07-21 11:47:33', 10, 2001001000, '服务端发生异常', '2019-07-21 11:47:34');
INSERT INTO `access_log` VALUES (57058, '65.47.15636808535004763', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '121.32.71.83', '2019-07-21 11:47:34', 8, 0, '', '2019-07-21 11:47:34');
INSERT INTO `access_log` VALUES (57059, '65.54.15636808722064707', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '121.32.71.83', '2019-07-21 11:47:52', 10, 0, '', '2019-07-21 11:47:52');
INSERT INTO `access_log` VALUES (57060, '65.53.15636808724744777', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '121.32.71.83', '2019-07-21 11:47:52', 9, 0, '', '2019-07-21 11:47:52');
INSERT INTO `access_log` VALUES (57061, '65.45.15636808724824757', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '121.32.71.83', '2019-07-21 11:47:52', 10, 2001001000, '服务端发生异常', '2019-07-21 11:47:52');
INSERT INTO `access_log` VALUES (57062, '65.50.15636808809584791', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '121.32.71.83', '2019-07-21 11:48:01', 8, 0, '', '2019-07-21 11:48:01');
INSERT INTO `access_log` VALUES (57063, '65.3607.15636808809636579', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '121.32.71.83', '2019-07-21 11:48:01', 9, 2001001000, '服务端发生异常', '2019-07-21 11:48:01');
INSERT INTO `access_log` VALUES (57064, '65.51.15636808809684837', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '121.32.71.83', '2019-07-21 11:48:01', 8, 0, '', '2019-07-21 11:48:01');
INSERT INTO `access_log` VALUES (57065, 'ec8c3fda-db7f-4178-8131-694360be4cad', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456', 'POST', 'PostmanRuntime/7.15.0', '0:0:0:0:0:0:0:1', '2019-07-21 13:40:09', 347, 0, '', '2019-07-21 13:40:10');
INSERT INTO `access_log` VALUES (57066, '9fd617e7-42d5-46cf-91e2-a0402825f0e7', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'PostmanRuntime/7.15.0', '0:0:0:0:0:0:0:1', '2019-07-21 13:45:48', 225, 2001001000, '服务端发生异常', '2019-07-21 13:45:48');
INSERT INTO `access_log` VALUES (57067, '470ec249-384f-4aae-8e1f-d1958f0679fa', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'PostmanRuntime/7.15.0', '0:0:0:0:0:0:0:1', '2019-07-21 13:45:50', 263, 2001001000, '服务端发生异常', '2019-07-21 13:45:51');
INSERT INTO `access_log` VALUES (57068, 'c0584a21-10cf-4328-8ab0-499a189b6281', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'PostmanRuntime/7.15.0', '0:0:0:0:0:0:0:1', '2019-07-21 13:45:58', 187, 2001001000, '服务端发生异常', '2019-07-21 13:45:58');
INSERT INTO `access_log` VALUES (57069, 'fedb50c2-5f72-40e7-96f6-940748cb5b52', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/page', '', 'GET', 'PostmanRuntime/7.15.0', '0:0:0:0:0:0:0:1', '2019-07-21 13:46:30', 148, 2001001000, '服务端发生异常', '2019-07-21 13:46:30');
INSERT INTO `access_log` VALUES (57070, 'e2a4b235-d0c6-4263-9cc9-ebfe27dc587a', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'PostmanRuntime/7.15.0', '0:0:0:0:0:0:0:1', '2019-07-21 13:48:06', 105, 0, '', '2019-07-21 13:48:06');
INSERT INTO `access_log` VALUES (57071, '59.74.15636893632782753', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 14:09:23', 10, 0, '', '2019-07-21 14:09:23');
INSERT INTO `access_log` VALUES (57072, '59.73.15636893632802749', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 14:09:23', 18, 2001001000, '服务端发生异常', '2019-07-21 14:09:23');
INSERT INTO `access_log` VALUES (57073, '59.75.15636893669712753', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 14:09:27', 3, 0, '', '2019-07-21 14:09:27');
INSERT INTO `access_log` VALUES (57074, '59.71.15636893669712745', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 14:09:27', 11, 2001001000, '服务端发生异常', '2019-07-21 14:09:27');
INSERT INTO `access_log` VALUES (57075, '64.77.15636893746812939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 14:09:35', 11, 0, '', '2019-07-21 14:09:35');
INSERT INTO `access_log` VALUES (57076, '64.85.15636893747952977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 14:09:35', 3, 0, '', '2019-07-21 14:09:35');
INSERT INTO `access_log` VALUES (57077, '64.82.15636893758542969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 14:09:36', 2, 0, '', '2019-07-21 14:09:36');
INSERT INTO `access_log` VALUES (57078, '64.76.15636893762692953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.196.177.248', '2019-07-21 14:09:36', 2, 0, '', '2019-07-21 14:09:36');
INSERT INTO `access_log` VALUES (57079, '59.79.15636894261782749', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.91.60.11', '2019-07-21 14:10:26', 17, 2001001000, '服务端发生异常', '2019-07-21 14:10:26');
INSERT INTO `access_log` VALUES (57080, '64.78.15636894358092963', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.89.29.94', '2019-07-21 14:10:36', 2, 0, '', '2019-07-21 14:10:36');
INSERT INTO `access_log` VALUES (57081, '64.77.15636894402652941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.129.6.159', '2019-07-21 14:10:40', 2, 0, '', '2019-07-21 14:10:40');
INSERT INTO `access_log` VALUES (57082, '65.46.15636899843354963', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.253.30.98', '2019-07-21 14:19:44', 5, 1002001012, '访问令牌已过期', '2019-07-21 14:19:44');
INSERT INTO `access_log` VALUES (57083, '65.54.15636899843374829', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.253.30.98', '2019-07-21 14:19:44', 5, 1002001012, '访问令牌已过期', '2019-07-21 14:19:44');
INSERT INTO `access_log` VALUES (57084, '65.52.15636899843354933', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.253.30.98', '2019-07-21 14:19:44', 5, 1002001012, '访问令牌已过期', '2019-07-21 14:19:44');
INSERT INTO `access_log` VALUES (57085, '65.53.15636899876614899', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.253.30.98', '2019-07-21 14:19:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-21 14:19:48');
INSERT INTO `access_log` VALUES (57086, '65.45.15636899932094881', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.253.30.98', '2019-07-21 14:19:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-21 14:19:53');
INSERT INTO `access_log` VALUES (57087, '65.3607.15636899983796703', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.253.30.98', '2019-07-21 14:19:58', 96, 0, '', '2019-07-21 14:19:58');
INSERT INTO `access_log` VALUES (57088, '65.50.15636899988144915', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.253.30.98', '2019-07-21 14:19:59', 135, 0, '', '2019-07-21 14:19:59');
INSERT INTO `access_log` VALUES (57089, '65.47.15636899988244889', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.253.30.98', '2019-07-21 14:19:59', 125, 0, '', '2019-07-21 14:19:59');
INSERT INTO `access_log` VALUES (57090, '65.51.15636899988214961', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.253.30.98', '2019-07-21 14:19:59', 129, 2001001000, '服务端发生异常', '2019-07-21 14:19:59');
INSERT INTO `access_log` VALUES (57091, '59.76.15636947664852809', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.146', '2019-07-21 15:39:26', 14, 0, '', '2019-07-21 15:39:27');
INSERT INTO `access_log` VALUES (57092, '59.72.15636947664882815', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.146', '2019-07-21 15:39:26', 31, 2001001000, '服务端发生异常', '2019-07-21 15:39:27');
INSERT INTO `access_log` VALUES (57093, '65.45.15636968046864973', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:25', 12, 1002001012, '访问令牌已过期', '2019-07-21 16:13:25');
INSERT INTO `access_log` VALUES (57094, '65.49.15636968046864967', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:25', 14, 1002001012, '访问令牌已过期', '2019-07-21 16:13:25');
INSERT INTO `access_log` VALUES (57095, '65.3607.15636968047056795', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:25', 15, 1002001012, '访问令牌已过期', '2019-07-21 16:13:25');
INSERT INTO `access_log` VALUES (57096, '65.50.15636968065895007', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-21 16:13:27');
INSERT INTO `access_log` VALUES (57097, '65.47.15636968128364981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:33', 154, 0, '', '2019-07-21 16:13:33');
INSERT INTO `access_log` VALUES (57098, '65.51.15636968132555053', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:33', 18, 0, '', '2019-07-21 16:13:33');
INSERT INTO `access_log` VALUES (57099, '65.46.15636968132555057', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:33', 20, 2001001000, '服务端发生异常', '2019-07-21 16:13:33');
INSERT INTO `access_log` VALUES (57100, '65.52.15636968132765027', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:33', 10, 0, '', '2019-07-21 16:13:33');
INSERT INTO `access_log` VALUES (57101, '65.54.15636968177964923', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:38', 10, 0, '', '2019-07-21 16:13:38');
INSERT INTO `access_log` VALUES (57102, '65.53.15636968177984993', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:38', 11, 2001001000, '服务端发生异常', '2019-07-21 16:13:38');
INSERT INTO `access_log` VALUES (57103, '65.3607.15636968178026797', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:38', 9, 0, '', '2019-07-21 16:13:38');
INSERT INTO `access_log` VALUES (57104, '59.80.15636968208412825', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:41', 63, 0, '', '2019-07-21 16:13:41');
INSERT INTO `access_log` VALUES (57105, '59.72.15636968208392843', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:41', 74, 2001001000, '服务端发生异常', '2019-07-21 16:13:41');
INSERT INTO `access_log` VALUES (57106, '64.76.15636968226803053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:43', 21, 0, '', '2019-07-21 16:13:43');
INSERT INTO `access_log` VALUES (57107, '64.83.15636968228693053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:43', 13, 0, '', '2019-07-21 16:13:43');
INSERT INTO `access_log` VALUES (57108, '64.79.15636968254883059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:45', 8, 0, '', '2019-07-21 16:13:45');
INSERT INTO `access_log` VALUES (57109, '64.80.15636968256223059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:46', 8, 0, '', '2019-07-21 16:13:46');
INSERT INTO `access_log` VALUES (57110, '59.79.15636968258682849', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:46', 18, 0, '', '2019-07-21 16:13:46');
INSERT INTO `access_log` VALUES (57111, '59.77.15636968258702835', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.194', '2019-07-21 16:13:46', 29, 2001001000, '服务端发生异常', '2019-07-21 16:13:46');
INSERT INTO `access_log` VALUES (57112, '59.79.15636975191752859', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.210.61.19', '2019-07-21 16:25:19', 16, 2001001000, '服务端发生异常', '2019-07-21 16:25:19');
INSERT INTO `access_log` VALUES (57113, '59.72.15636975191742853', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.210.61.19', '2019-07-21 16:25:19', 150, 0, '', '2019-07-21 16:25:19');
INSERT INTO `access_log` VALUES (57114, '64.83.15636975266433063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.210.61.19', '2019-07-21 16:25:27', 3, 0, '', '2019-07-21 16:25:27');
INSERT INTO `access_log` VALUES (57115, '64.79.15636975268133069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.210.61.19', '2019-07-21 16:25:27', 2, 0, '', '2019-07-21 16:25:27');
INSERT INTO `access_log` VALUES (57116, '64.80.15636975313533069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.210.61.19', '2019-07-21 16:25:31', 2, 0, '', '2019-07-21 16:25:31');
INSERT INTO `access_log` VALUES (57117, '64.78.15636975332463073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.210.61.19', '2019-07-21 16:25:33', 2, 0, '', '2019-07-21 16:25:33');
INSERT INTO `access_log` VALUES (57118, '64.77.15636975348343051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.210.61.19', '2019-07-21 16:25:35', 2, 0, '', '2019-07-21 16:25:35');
INSERT INTO `access_log` VALUES (57119, '59.73.15636975364892861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.210.61.19', '2019-07-21 16:25:36', 3, 0, '', '2019-07-21 16:25:36');
INSERT INTO `access_log` VALUES (57120, '59.74.15636975364902865', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.210.61.19', '2019-07-21 16:25:36', 16, 2001001000, '服务端发生异常', '2019-07-21 16:25:37');
INSERT INTO `access_log` VALUES (57121, '59.71.15636975526302857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.210.61.19', '2019-07-21 16:25:53', 2, 0, '', '2019-07-21 16:25:53');
INSERT INTO `access_log` VALUES (57122, '59.78.15636975526302857', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.210.61.19', '2019-07-21 16:25:53', 26, 2001001000, '服务端发生异常', '2019-07-21 16:25:53');
INSERT INTO `access_log` VALUES (57123, '59.80.15636975720122837', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.210.61.19', '2019-07-21 16:26:12', 3, 0, '', '2019-07-21 16:26:12');
INSERT INTO `access_log` VALUES (57124, '59.72.15636975720122855', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.210.61.19', '2019-07-21 16:26:12', 13, 2001001000, '服务端发生异常', '2019-07-21 16:26:12');
INSERT INTO `access_log` VALUES (57125, '65.49.15636975785034979', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.190.58.167', '2019-07-21 16:26:19', 0, 1002001015, '账号未登陆', '2019-07-21 16:26:19');
INSERT INTO `access_log` VALUES (57126, '65.50.15636975785065019', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.190.58.167', '2019-07-21 16:26:19', 1, 1002001015, '账号未登陆', '2019-07-21 16:26:19');
INSERT INTO `access_log` VALUES (57127, '65.47.15636975785124993', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.190.58.167', '2019-07-21 16:26:19', 1, 1002001015, '账号未登陆', '2019-07-21 16:26:19');
INSERT INTO `access_log` VALUES (57128, '65.51.15636975808225065', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.190.58.167', '2019-07-21 16:26:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-21 16:26:21');
INSERT INTO `access_log` VALUES (57129, '65.46.15636975836925069', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.190.58.167', '2019-07-21 16:26:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-21 16:26:24');
INSERT INTO `access_log` VALUES (57130, '65.3607.15636975924346809', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.190.58.167', '2019-07-21 16:26:32', 85, 0, '', '2019-07-21 16:26:33');
INSERT INTO `access_log` VALUES (57131, '65.54.15636975928324935', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.190.58.167', '2019-07-21 16:26:33', 10, 0, '', '2019-07-21 16:26:33');
INSERT INTO `access_log` VALUES (57132, '65.53.15636975928355005', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.190.58.167', '2019-07-21 16:26:33', 9, 0, '', '2019-07-21 16:26:33');
INSERT INTO `access_log` VALUES (57133, '65.45.15636975928414987', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.190.58.167', '2019-07-21 16:26:33', 10, 2001001000, '服务端发生异常', '2019-07-21 16:26:33');
INSERT INTO `access_log` VALUES (57134, '65.49.15636976027854981', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.190.58.167', '2019-07-21 16:26:43', 10, 2001001000, '服务端发生异常', '2019-07-21 16:26:43');
INSERT INTO `access_log` VALUES (57135, '65.50.15636976027895021', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.190.58.167', '2019-07-21 16:26:43', 10, 0, '', '2019-07-21 16:26:43');
INSERT INTO `access_log` VALUES (57136, '65.51.15636976027945067', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '39.190.58.167', '2019-07-21 16:26:43', 8, 0, '', '2019-07-21 16:26:43');
INSERT INTO `access_log` VALUES (57137, '59.73.15636977445172865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:05', 3, 0, '', '2019-07-21 16:29:05');
INSERT INTO `access_log` VALUES (57138, '59.74.15636977445172869', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:05', 35, 2001001000, '服务端发生异常', '2019-07-21 16:29:05');
INSERT INTO `access_log` VALUES (57139, '64.83.15636977490173067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:09', 2, 0, '', '2019-07-21 16:29:09');
INSERT INTO `access_log` VALUES (57140, '64.79.15636977491713073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:09', 2, 0, '', '2019-07-21 16:29:09');
INSERT INTO `access_log` VALUES (57141, '64.80.15636977517323073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:12', 2, 0, '', '2019-07-21 16:29:12');
INSERT INTO `access_log` VALUES (57142, '64.78.15636977531653077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:13', 2, 0, '', '2019-07-21 16:29:13');
INSERT INTO `access_log` VALUES (57143, '64.77.15636977545583055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:15', 2, 0, '', '2019-07-21 16:29:15');
INSERT INTO `access_log` VALUES (57144, '64.85.15636977602803093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:20', 1, 0, '', '2019-07-21 16:29:20');
INSERT INTO `access_log` VALUES (57145, '64.84.15636977604213063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:20', 2, 0, '', '2019-07-21 16:29:20');
INSERT INTO `access_log` VALUES (57146, '64.76.15636977613233069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:21', 2, 0, '', '2019-07-21 16:29:21');
INSERT INTO `access_log` VALUES (57147, '59.71.15636977627332861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:23', 2, 0, '', '2019-07-21 16:29:23');
INSERT INTO `access_log` VALUES (57148, '59.78.15636977627342861', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:23', 13, 2001001000, '服务端发生异常', '2019-07-21 16:29:23');
INSERT INTO `access_log` VALUES (57149, '64.81.15636977670573063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:27', 2, 0, '', '2019-07-21 16:29:27');
INSERT INTO `access_log` VALUES (57150, '64.83.15636977674083069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:27', 2, 0, '', '2019-07-21 16:29:27');
INSERT INTO `access_log` VALUES (57151, '59.76.15636977680812853', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:28', 2, 0, '', '2019-07-21 16:29:28');
INSERT INTO `access_log` VALUES (57152, '59.80.15636977680822841', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.72.39.188', '2019-07-21 16:29:28', 22, 2001001000, '服务端发生异常', '2019-07-21 16:29:28');
INSERT INTO `access_log` VALUES (57153, '59.78.15636992024852881', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.52.53', '2019-07-21 16:53:22', 3, 0, '', '2019-07-21 16:53:22');
INSERT INTO `access_log` VALUES (57154, '59.71.15636992024852881', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.52.53', '2019-07-21 16:53:22', 16, 2001001000, '服务端发生异常', '2019-07-21 16:53:23');
INSERT INTO `access_log` VALUES (57155, '64.82.15636992067533105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.52.53', '2019-07-21 16:53:27', 3, 0, '', '2019-07-21 16:53:27');
INSERT INTO `access_log` VALUES (57156, '64.76.15636992069383089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.52.53', '2019-07-21 16:53:27', 2, 0, '', '2019-07-21 16:53:27');
INSERT INTO `access_log` VALUES (57157, '64.81.15636992105763083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.52.53', '2019-07-21 16:53:31', 2, 0, '', '2019-07-21 16:53:31');
INSERT INTO `access_log` VALUES (57158, '64.83.15636992107053089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.52.53', '2019-07-21 16:53:31', 1, 0, '', '2019-07-21 16:53:31');
INSERT INTO `access_log` VALUES (57159, '64.79.15636992127733095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.52.53', '2019-07-21 16:53:33', 2, 0, '', '2019-07-21 16:53:33');
INSERT INTO `access_log` VALUES (57160, '64.80.15636992128963095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.52.53', '2019-07-21 16:53:33', 1, 0, '', '2019-07-21 16:53:33');
INSERT INTO `access_log` VALUES (57161, '59.80.15636992137312861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.52.53', '2019-07-21 16:53:34', 2, 0, '', '2019-07-21 16:53:34');
INSERT INTO `access_log` VALUES (57162, '59.76.15636992137312873', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.52.53', '2019-07-21 16:53:34', 19, 2001001000, '服务端发生异常', '2019-07-21 16:53:34');
INSERT INTO `access_log` VALUES (57163, '65.54.15637015655534989', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.61.6.231', '2019-07-21 17:32:46', 1, 1002001015, '账号未登陆', '2019-07-21 17:32:46');
INSERT INTO `access_log` VALUES (57164, '65.49.15637015655545035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.61.6.231', '2019-07-21 17:32:46', 0, 1002001015, '账号未登陆', '2019-07-21 17:32:46');
INSERT INTO `access_log` VALUES (57165, '65.47.15637015655545049', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.61.6.233', '2019-07-21 17:32:46', 0, 1002001015, '账号未登陆', '2019-07-21 17:32:46');
INSERT INTO `access_log` VALUES (57166, '65.51.15637015722025121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.61.6.231', '2019-07-21 17:32:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-21 17:32:52');
INSERT INTO `access_log` VALUES (57167, '65.46.15637015763545125', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.61.6.231', '2019-07-21 17:32:56', 150, 0, '', '2019-07-21 17:32:57');
INSERT INTO `access_log` VALUES (57168, '65.52.15637015768855093', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.61.6.231', '2019-07-21 17:32:57', 12, 0, '', '2019-07-21 17:32:57');
INSERT INTO `access_log` VALUES (57169, '65.3607.15637015768906865', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.61.6.231', '2019-07-21 17:32:57', 18, 2001001000, '服务端发生异常', '2019-07-21 17:32:57');
INSERT INTO `access_log` VALUES (57170, '65.45.15637015768955043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.61.6.231', '2019-07-21 17:32:57', 17, 0, '', '2019-07-21 17:32:57');
INSERT INTO `access_log` VALUES (57171, '59.74.15637016298732923', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.61.6.233', '2019-07-21 17:33:50', 11, 0, '', '2019-07-21 17:33:50');
INSERT INTO `access_log` VALUES (57172, '59.73.15637016298732919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.61.6.233', '2019-07-21 17:33:50', 16, 2001001000, '服务端发生异常', '2019-07-21 17:33:50');
INSERT INTO `access_log` VALUES (57173, '64.83.15637017022133123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.61.6.231', '2019-07-21 17:35:02', 12, 0, '', '2019-07-21 17:35:02');
INSERT INTO `access_log` VALUES (57174, '64.79.15637017023713129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.61.6.231', '2019-07-21 17:35:02', 3, 0, '', '2019-07-21 17:35:02');
INSERT INTO `access_log` VALUES (57175, '64.80.15637017033773129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.61.6.231', '2019-07-21 17:35:03', 2, 0, '', '2019-07-21 17:35:03');
INSERT INTO `access_log` VALUES (57176, '64.78.15637017038423133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '183.61.6.231', '2019-07-21 17:35:04', 2, 0, '', '2019-07-21 17:35:04');
INSERT INTO `access_log` VALUES (57177, '59.80.15637043780952931', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:19:38', 11, 0, '', '2019-07-21 18:19:38');
INSERT INTO `access_log` VALUES (57178, '59.76.15637043780962943', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:19:38', 15, 2001001000, '服务端发生异常', '2019-07-21 18:19:38');
INSERT INTO `access_log` VALUES (57179, '59.72.15637043890722949', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:19:49', 3, 0, '', '2019-07-21 18:19:49');
INSERT INTO `access_log` VALUES (57180, '59.79.15637043890742955', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:19:49', 14, 2001001000, '服务端发生异常', '2019-07-21 18:19:49');
INSERT INTO `access_log` VALUES (57181, '64.77.15637043931003147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:19:53', 165, 0, '', '2019-07-21 18:19:53');
INSERT INTO `access_log` VALUES (57182, '64.85.15637043934053185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:19:53', 5, 0, '', '2019-07-21 18:19:53');
INSERT INTO `access_log` VALUES (57183, '64.84.15637043969723155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:19:57', 2, 0, '', '2019-07-21 18:19:57');
INSERT INTO `access_log` VALUES (57184, '64.82.15637043983813175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:19:58', 2, 0, '', '2019-07-21 18:19:58');
INSERT INTO `access_log` VALUES (57185, '59.73.15637044001352957', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:20:00', 3, 0, '', '2019-07-21 18:20:00');
INSERT INTO `access_log` VALUES (57186, '59.74.15637044001462961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:20:00', 31, 2001001000, '服务端发生异常', '2019-07-21 18:20:00');
INSERT INTO `access_log` VALUES (57187, '65.52.15637044143755135', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:20:14', 5, 1002001012, '访问令牌已过期', '2019-07-21 18:20:14');
INSERT INTO `access_log` VALUES (57188, '65.53.15637044143765093', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:20:14', 5, 1002001012, '访问令牌已过期', '2019-07-21 18:20:14');
INSERT INTO `access_log` VALUES (57189, '65.54.15637044143765027', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:20:14', 6, 1002001012, '访问令牌已过期', '2019-07-21 18:20:14');
INSERT INTO `access_log` VALUES (57190, '65.47.15637044237845089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:20:24', 68, 0, '', '2019-07-21 18:20:24');
INSERT INTO `access_log` VALUES (57191, '65.51.15637044241605163', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:20:24', 9, 0, '', '2019-07-21 18:20:24');
INSERT INTO `access_log` VALUES (57192, '65.50.15637044241655119', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:20:24', 9, 2001001000, '服务端发生异常', '2019-07-21 18:20:24');
INSERT INTO `access_log` VALUES (57193, '65.46.15637044241695167', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:20:24', 8, 0, '', '2019-07-21 18:20:24');
INSERT INTO `access_log` VALUES (57194, '64.77.15637044931063149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:21:33', 2, 0, '', '2019-07-21 18:21:33');
INSERT INTO `access_log` VALUES (57195, '64.85.15637044932323187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:21:33', 2, 0, '', '2019-07-21 18:21:33');
INSERT INTO `access_log` VALUES (57196, '64.84.15637044945883157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:21:35', 2, 0, '', '2019-07-21 18:21:35');
INSERT INTO `access_log` VALUES (57197, '64.82.15637044949853177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:21:35', 2, 0, '', '2019-07-21 18:21:35');
INSERT INTO `access_log` VALUES (57198, '59.72.15637044961932951', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:21:36', 3, 0, '', '2019-07-21 18:21:36');
INSERT INTO `access_log` VALUES (57199, '59.73.15637044962302959', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:21:36', 12, 2001001000, '服务端发生异常', '2019-07-21 18:21:36');
INSERT INTO `access_log` VALUES (57200, '65.47.15637045120305091', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:21:52', 9, 0, '', '2019-07-21 18:21:52');
INSERT INTO `access_log` VALUES (57201, '65.49.15637045120395079', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:21:52', 8, 2001001000, '服务端发生异常', '2019-07-21 18:21:52');
INSERT INTO `access_log` VALUES (57202, '65.50.15637045120475121', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:21:52', 8, 0, '', '2019-07-21 18:21:52');
INSERT INTO `access_log` VALUES (57203, '65.46.15637045180425169', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.194', '2019-07-21 18:21:58', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-21 18:21:58');
INSERT INTO `access_log` VALUES (57204, '59.75.15637067641842991', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.77.117', '2019-07-21 18:59:24', 10, 0, '', '2019-07-21 18:59:24');
INSERT INTO `access_log` VALUES (57205, '59.71.15637067641892985', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.77.117', '2019-07-21 18:59:24', 13, 2001001000, '服务端发生异常', '2019-07-21 18:59:24');
INSERT INTO `access_log` VALUES (57206, '64.83.15637067721913193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.77.117', '2019-07-21 18:59:32', 11, 0, '', '2019-07-21 18:59:32');
INSERT INTO `access_log` VALUES (57207, '64.79.15637067723473199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.77.117', '2019-07-21 18:59:32', 3, 0, '', '2019-07-21 18:59:32');
INSERT INTO `access_log` VALUES (57208, '64.80.15637067752293199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.77.117', '2019-07-21 18:59:35', 2, 0, '', '2019-07-21 18:59:35');
INSERT INTO `access_log` VALUES (57209, '64.78.15637067753763203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.77.117', '2019-07-21 18:59:35', 2, 0, '', '2019-07-21 18:59:35');
INSERT INTO `access_log` VALUES (57210, '65.51.15637075809645207', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-07-21 19:13:01', 85, 0, '', '2019-07-21 19:13:01');
INSERT INTO `access_log` VALUES (57211, '65.54.15637075814455071', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-07-21 19:13:01', 10, 0, '', '2019-07-21 19:13:01');
INSERT INTO `access_log` VALUES (57212, '65.49.15637075814475123', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-07-21 19:13:01', 11, 2001001000, '服务端发生异常', '2019-07-21 19:13:01');
INSERT INTO `access_log` VALUES (57213, '65.53.15637075814665139', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.236.62.130', '2019-07-21 19:13:01', 17, 0, '', '2019-07-21 19:13:01');
INSERT INTO `access_log` VALUES (57214, '65.46.15637191911355367', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '111.197.245.220', '2019-07-21 22:26:31', 0, 1002001015, '账号未登陆', '2019-07-21 22:26:31');
INSERT INTO `access_log` VALUES (57215, '65.3607.15637191911367103', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '111.197.245.220', '2019-07-21 22:26:31', 0, 1002001015, '账号未登陆', '2019-07-21 22:26:31');
INSERT INTO `access_log` VALUES (57216, '65.51.15637191911585363', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '111.197.245.220', '2019-07-21 22:26:31', 0, 1002001015, '账号未登陆', '2019-07-21 22:26:31');
INSERT INTO `access_log` VALUES (57217, '65.53.15637192042295295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '111.197.245.220', '2019-07-21 22:26:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-21 22:26:44');
INSERT INTO `access_log` VALUES (57218, '65.49.15637192105315279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '111.197.245.220', '2019-07-21 22:26:51', 58, 0, '', '2019-07-21 22:26:51');
INSERT INTO `access_log` VALUES (57219, '65.50.15637192115205321', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '111.197.245.220', '2019-07-21 22:26:52', 13, 0, '', '2019-07-21 22:26:52');
INSERT INTO `access_log` VALUES (57220, '65.47.15637192115205291', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '111.197.245.220', '2019-07-21 22:26:52', 12, 0, '', '2019-07-21 22:26:52');
INSERT INTO `access_log` VALUES (57221, '65.45.15637192115205287', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '111.197.245.220', '2019-07-21 22:26:52', 14, 2001001000, '服务端发生异常', '2019-07-21 22:26:52');
INSERT INTO `access_log` VALUES (57222, '65.3607.15637192230447105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '111.197.245.220', '2019-07-21 22:27:03', 11, 0, '', '2019-07-21 22:27:03');
INSERT INTO `access_log` VALUES (57223, '65.51.15637192230485365', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '111.197.245.220', '2019-07-21 22:27:03', 9, 0, '', '2019-07-21 22:27:03');
INSERT INTO `access_log` VALUES (57224, '65.46.15637192230485369', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '111.197.245.220', '2019-07-21 22:27:03', 9, 2001001000, '服务端发生异常', '2019-07-21 22:27:03');
INSERT INTO `access_log` VALUES (57225, '65.47.15637213746075321', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.109.204.156', '2019-07-21 23:02:55', 0, 1002001015, '账号未登陆', '2019-07-21 23:02:55');
INSERT INTO `access_log` VALUES (57226, '65.50.15637213746135351', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.109.204.156', '2019-07-21 23:02:55', 0, 1002001015, '账号未登陆', '2019-07-21 23:02:55');
INSERT INTO `access_log` VALUES (57227, '65.52.15637213746135365', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.109.204.156', '2019-07-21 23:02:55', 1, 1002001015, '账号未登陆', '2019-07-21 23:02:55');
INSERT INTO `access_log` VALUES (57228, '65.53.15637251946425377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.109.204.156', '2019-07-22 00:06:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 00:06:35');
INSERT INTO `access_log` VALUES (57229, '65.45.15637252019835369', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.109.204.156', '2019-07-22 00:06:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 00:06:42');
INSERT INTO `access_log` VALUES (57230, '59.74.15637545788463631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.4.249', '2019-07-22 08:16:19', 11, 0, '', '2019-07-22 08:16:19');
INSERT INTO `access_log` VALUES (57231, '59.75.15637545788583629', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.4.249', '2019-07-22 08:16:19', 23, 2001001000, '服务端发生异常', '2019-07-22 08:16:19');
INSERT INTO `access_log` VALUES (57232, '65.52.15637545882455809', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.4.249', '2019-07-22 08:16:28', 1, 1002001015, '账号未登陆', '2019-07-22 08:16:28');
INSERT INTO `access_log` VALUES (57233, '65.45.15637545882455761', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.4.249', '2019-07-22 08:16:28', 1, 1002001015, '账号未登陆', '2019-07-22 08:16:28');
INSERT INTO `access_log` VALUES (57234, '65.47.15637545882465765', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.4.249', '2019-07-22 08:16:28', 1, 1002001015, '账号未登陆', '2019-07-22 08:16:28');
INSERT INTO `access_log` VALUES (57235, '65.50.15637545904345795', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '36.102.4.249', '2019-07-22 08:16:30', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 08:16:30');
INSERT INTO `access_log` VALUES (57236, '65.50.15637574193685833', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '211.97.7.140', '2019-07-22 09:03:39', 25, 1002001012, '访问令牌已过期', '2019-07-22 09:03:39');
INSERT INTO `access_log` VALUES (57237, '65.51.15637574193685877', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '211.97.7.140', '2019-07-22 09:03:39', 31, 1002001012, '访问令牌已过期', '2019-07-22 09:03:39');
INSERT INTO `access_log` VALUES (57238, '65.46.15637574193935881', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '211.97.7.140', '2019-07-22 09:03:39', 6, 1002001012, '访问令牌已过期', '2019-07-22 09:03:39');
INSERT INTO `access_log` VALUES (57239, '65.53.15637574195705809', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '211.97.7.140', '2019-07-22 09:03:40', 4, 1002001012, '访问令牌已过期', '2019-07-22 09:03:40');
INSERT INTO `access_log` VALUES (57240, '65.3607.15637574195707617', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '211.97.7.140', '2019-07-22 09:03:40', 5, 1002001012, '访问令牌已过期', '2019-07-22 09:03:40');
INSERT INTO `access_log` VALUES (57241, '65.54.15637574195705741', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '211.97.7.140', '2019-07-22 09:03:40', 5, 1002001012, '访问令牌已过期', '2019-07-22 09:03:40');
INSERT INTO `access_log` VALUES (57242, '65.49.15637574216855793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '211.97.7.140', '2019-07-22 09:03:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 09:03:42');
INSERT INTO `access_log` VALUES (57243, '65.45.15637574449795801', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '211.97.7.140', '2019-07-22 09:04:05', 158, 0, '', '2019-07-22 09:04:05');
INSERT INTO `access_log` VALUES (57244, '65.52.15637574455495849', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '211.97.7.140', '2019-07-22 09:04:06', 10, 0, '', '2019-07-22 09:04:06');
INSERT INTO `access_log` VALUES (57245, '65.50.15637574455495835', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '211.97.7.140', '2019-07-22 09:04:06', 11, 2001001000, '服务端发生异常', '2019-07-22 09:04:06');
INSERT INTO `access_log` VALUES (57246, '65.51.15637574455815879', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '211.97.7.140', '2019-07-22 09:04:06', 13, 0, '', '2019-07-22 09:04:06');
INSERT INTO `access_log` VALUES (57247, '65.52.15637578557325855', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-22 09:10:56', 5, 1002001012, '访问令牌已过期', '2019-07-22 09:10:56');
INSERT INTO `access_log` VALUES (57248, '65.50.15637578557355841', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-22 09:10:56', 3, 1002001012, '访问令牌已过期', '2019-07-22 09:10:56');
INSERT INTO `access_log` VALUES (57249, '65.46.15637578557405889', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-22 09:10:56', 3, 1002001012, '访问令牌已过期', '2019-07-22 09:10:56');
INSERT INTO `access_log` VALUES (57250, '65.53.15637578590165817', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-22 09:10:59', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 09:10:59');
INSERT INTO `access_log` VALUES (57251, '65.54.15637578638215749', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-22 09:11:04', 244, 0, '', '2019-07-22 09:11:04');
INSERT INTO `access_log` VALUES (57252, '65.3607.15637578642487625', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-22 09:11:04', 51, 0, '', '2019-07-22 09:11:04');
INSERT INTO `access_log` VALUES (57253, '65.47.15637578642485813', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-22 09:11:04', 51, 0, '', '2019-07-22 09:11:04');
INSERT INTO `access_log` VALUES (57254, '65.49.15637578642485801', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-22 09:11:04', 52, 2001001000, '服务端发生异常', '2019-07-22 09:11:04');
INSERT INTO `access_log` VALUES (57255, '65.53.15637580808365821', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-22 09:14:41', 10, 0, '', '2019-07-22 09:14:41');
INSERT INTO `access_log` VALUES (57256, '65.54.15637580808375753', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-22 09:14:41', 12, 2001001000, '服务端发生异常', '2019-07-22 09:14:41');
INSERT INTO `access_log` VALUES (57257, '65.49.15637580808385805', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-22 09:14:41', 10, 0, '', '2019-07-22 09:14:41');
INSERT INTO `access_log` VALUES (57258, '65.50.15637581240005847', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-22 09:15:24', 11, 0, '', '2019-07-22 09:15:24');
INSERT INTO `access_log` VALUES (57259, '65.51.15637581239935891', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-22 09:15:24', 17, 0, '', '2019-07-22 09:15:24');
INSERT INTO `access_log` VALUES (57260, '65.46.15637581239965895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-22 09:15:24', 22, 2001001000, '服务端发生异常', '2019-07-22 09:15:24');
INSERT INTO `access_log` VALUES (57261, '65.51.15637582626175893', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.214.178', '2019-07-22 09:17:43', 1, 1002001015, '账号未登陆', '2019-07-22 09:17:43');
INSERT INTO `access_log` VALUES (57262, '65.52.15637582626245863', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.214.178', '2019-07-22 09:17:43', 0, 1002001015, '账号未登陆', '2019-07-22 09:17:43');
INSERT INTO `access_log` VALUES (57263, '65.54.15637582626315757', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.214.178', '2019-07-22 09:17:43', 0, 1002001015, '账号未登陆', '2019-07-22 09:17:43');
INSERT INTO `access_log` VALUES (57264, '65.49.15637582678105809', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.214.178', '2019-07-22 09:17:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 09:17:48');
INSERT INTO `access_log` VALUES (57265, '65.53.15637582734755825', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.214.178', '2019-07-22 09:17:53', 77, 0, '', '2019-07-22 09:17:54');
INSERT INTO `access_log` VALUES (57266, '65.3607.15637582738717633', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.214.178', '2019-07-22 09:17:54', 20, 0, '', '2019-07-22 09:17:54');
INSERT INTO `access_log` VALUES (57267, '65.47.15637582738775821', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.214.178', '2019-07-22 09:17:54', 19, 2001001000, '服务端发生异常', '2019-07-22 09:17:54');
INSERT INTO `access_log` VALUES (57268, '65.45.15637582738905817', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.214.178', '2019-07-22 09:17:54', 8, 0, '', '2019-07-22 09:17:54');
INSERT INTO `access_log` VALUES (57269, '65.51.15637583047455895', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.214.178', '2019-07-22 09:18:25', 10, 0, '', '2019-07-22 09:18:25');
INSERT INTO `access_log` VALUES (57270, '65.54.15637583047515759', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.214.178', '2019-07-22 09:18:25', 11, 2001001000, '服务端发生异常', '2019-07-22 09:18:25');
INSERT INTO `access_log` VALUES (57271, '65.49.15637583047555811', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.249.214.178', '2019-07-22 09:18:25', 9, 0, '', '2019-07-22 09:18:25');
INSERT INTO `access_log` VALUES (57272, '65.53.15637602744415853', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '113.116.115.125', '2019-07-22 09:51:14', 0, 1002001015, '账号未登陆', '2019-07-22 09:51:14');
INSERT INTO `access_log` VALUES (57273, '65.45.15637602744415847', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '113.116.115.125', '2019-07-22 09:51:14', 0, 1002001015, '账号未登陆', '2019-07-22 09:51:14');
INSERT INTO `access_log` VALUES (57274, '65.46.15637602744435927', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '113.116.115.125', '2019-07-22 09:51:14', 0, 1002001015, '账号未登陆', '2019-07-22 09:51:14');
INSERT INTO `access_log` VALUES (57275, '65.47.15637602789285851', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '113.116.115.125', '2019-07-22 09:51:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 09:51:19');
INSERT INTO `access_log` VALUES (57276, '65.52.15637602964305895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '113.116.115.125', '2019-07-22 09:51:36', 428, 0, '', '2019-07-22 09:51:37');
INSERT INTO `access_log` VALUES (57277, '65.50.15637602975155879', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '113.116.115.125', '2019-07-22 09:51:38', 11, 0, '', '2019-07-22 09:51:38');
INSERT INTO `access_log` VALUES (57278, '65.51.15637602975585925', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '113.116.115.125', '2019-07-22 09:51:38', 11, 0, '', '2019-07-22 09:51:38');
INSERT INTO `access_log` VALUES (57279, '65.54.15637602975575787', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '113.116.115.125', '2019-07-22 09:51:38', 11, 2001001000, '服务端发生异常', '2019-07-22 09:51:38');
INSERT INTO `access_log` VALUES (57280, '65.49.15637607452605843', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.60.55.52', '2019-07-22 09:59:05', 0, 1002001015, '账号未登陆', '2019-07-22 09:59:05');
INSERT INTO `access_log` VALUES (57281, '65.46.15637607452625935', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.60.55.52', '2019-07-22 09:59:05', 1, 1002001015, '账号未登陆', '2019-07-22 09:59:05');
INSERT INTO `access_log` VALUES (57282, '65.45.15637607452735855', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.60.55.52', '2019-07-22 09:59:05', 0, 1002001015, '账号未登陆', '2019-07-22 09:59:05');
INSERT INTO `access_log` VALUES (57283, '65.53.15637608985505863', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.60.55.52', '2019-07-22 10:01:39', 63, 0, '', '2019-07-22 10:01:39');
INSERT INTO `access_log` VALUES (57284, '65.3607.15637608989547673', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.60.55.52', '2019-07-22 10:01:39', 13, 2001001000, '服务端发生异常', '2019-07-22 10:01:39');
INSERT INTO `access_log` VALUES (57285, '65.52.15637608989585905', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.60.55.52', '2019-07-22 10:01:39', 11, 0, '', '2019-07-22 10:01:39');
INSERT INTO `access_log` VALUES (57286, '65.50.15637608989595889', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.60.55.52', '2019-07-22 10:01:39', 10, 0, '', '2019-07-22 10:01:39');
INSERT INTO `access_log` VALUES (57287, '65.51.15637609067845935', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.60.55.52', '2019-07-22 10:01:47', 10, 0, '', '2019-07-22 10:01:47');
INSERT INTO `access_log` VALUES (57288, '65.54.15637609067865797', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.60.55.52', '2019-07-22 10:01:47', 10, 2001001000, '服务端发生异常', '2019-07-22 10:01:47');
INSERT INTO `access_log` VALUES (57289, '65.49.15637609067915847', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.60.55.52', '2019-07-22 10:01:47', 12, 0, '', '2019-07-22 10:01:47');
INSERT INTO `access_log` VALUES (57290, '65.45.15637609152145859', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.60.55.52', '2019-07-22 10:01:55', 9, 0, '', '2019-07-22 10:01:55');
INSERT INTO `access_log` VALUES (57291, '65.53.15637609152245865', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.60.55.52', '2019-07-22 10:01:55', 10, 2001001000, '服务端发生异常', '2019-07-22 10:01:55');
INSERT INTO `access_log` VALUES (57292, '65.47.15637609152275863', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.60.55.52', '2019-07-22 10:01:55', 8, 0, '', '2019-07-22 10:01:55');
INSERT INTO `access_log` VALUES (57293, '65.3607.15637610782627677', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-22 10:04:38', 4, 1002001012, '访问令牌已过期', '2019-07-22 10:04:38');
INSERT INTO `access_log` VALUES (57294, '65.52.15637610782675909', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-22 10:04:38', 3, 1002001012, '访问令牌已过期', '2019-07-22 10:04:38');
INSERT INTO `access_log` VALUES (57295, '65.50.15637610782705893', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-22 10:04:38', 3, 1002001012, '访问令牌已过期', '2019-07-22 10:04:38');
INSERT INTO `access_log` VALUES (57296, '65.51.15637610828365939', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-22 10:04:43', 79, 0, '', '2019-07-22 10:04:43');
INSERT INTO `access_log` VALUES (57297, '65.49.15637610831375851', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-22 10:04:43', 8, 0, '', '2019-07-22 10:04:43');
INSERT INTO `access_log` VALUES (57298, '65.46.15637610831375943', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-22 10:04:43', 218, 2001001000, '服务端发生异常', '2019-07-22 10:04:43');
INSERT INTO `access_log` VALUES (57299, '65.45.15637610831385863', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.173.235.168', '2019-07-22 10:04:43', 218, 0, '', '2019-07-22 10:04:43');
INSERT INTO `access_log` VALUES (57300, '59.74.15637615952113725', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.251.26', '2019-07-22 10:13:15', 10, 0, '', '2019-07-22 10:13:15');
INSERT INTO `access_log` VALUES (57301, '59.75.15637615952113723', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.202.251.26', '2019-07-22 10:13:15', 19, 2001001000, '服务端发生异常', '2019-07-22 10:13:15');
INSERT INTO `access_log` VALUES (57302, '65.47.15637621571345881', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-22 10:22:37', 1, 1002001015, '账号未登陆', '2019-07-22 10:22:37');
INSERT INTO `access_log` VALUES (57303, '65.50.15637621571355909', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-22 10:22:37', 1, 1002001015, '账号未登陆', '2019-07-22 10:22:37');
INSERT INTO `access_log` VALUES (57304, '65.52.15637621571365925', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-22 10:22:37', 7, 1002001015, '账号未登陆', '2019-07-22 10:22:37');
INSERT INTO `access_log` VALUES (57305, '65.54.15637621716465817', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-22 10:22:52', 139, 0, '', '2019-07-22 10:22:52');
INSERT INTO `access_log` VALUES (57306, '65.51.15637621720095955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-22 10:22:52', 9, 0, '', '2019-07-22 10:22:52');
INSERT INTO `access_log` VALUES (57307, '65.49.15637621720115867', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-22 10:22:52', 9, 0, '', '2019-07-22 10:22:52');
INSERT INTO `access_log` VALUES (57308, '65.45.15637621720165879', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.48.158.126', '2019-07-22 10:22:52', 9, 2001001000, '服务端发生异常', '2019-07-22 10:22:52');
INSERT INTO `access_log` VALUES (57309, '59.73.15637625905013735', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:29:51', 3, 0, '', '2019-07-22 10:29:51');
INSERT INTO `access_log` VALUES (57310, '59.74.15637625905033739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:29:51', 18, 2001001000, '服务端发生异常', '2019-07-22 10:29:51');
INSERT INTO `access_log` VALUES (57311, '64.84.15637625969413933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:29:57', 12, 0, '', '2019-07-22 10:29:57');
INSERT INTO `access_log` VALUES (57312, '64.82.15637625973023953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:29:57', 3, 0, '', '2019-07-22 10:29:57');
INSERT INTO `access_log` VALUES (57313, '64.76.15637625982343939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:29:58', 2, 0, '', '2019-07-22 10:29:58');
INSERT INTO `access_log` VALUES (57314, '64.81.15637625988413933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:29:59', 2, 0, '', '2019-07-22 10:29:59');
INSERT INTO `access_log` VALUES (57315, '64.83.15637625993633939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:29:59', 2, 0, '', '2019-07-22 10:29:59');
INSERT INTO `access_log` VALUES (57316, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=法国和&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:01', 235, 0, '', '2019-07-22 10:30:01');
INSERT INTO `access_log` VALUES (57317, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=法国和', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:02', 10, 0, '', '2019-07-22 10:30:02');
INSERT INTO `access_log` VALUES (57318, '64.79.15637626032713945', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:03', 8, 0, '', '2019-07-22 10:30:03');
INSERT INTO `access_log` VALUES (57319, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:12', 7, 0, '', '2019-07-22 10:30:12');
INSERT INTO `access_log` VALUES (57320, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:12', 4, 0, '', '2019-07-22 10:30:12');
INSERT INTO `access_log` VALUES (57321, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:12', 12, 0, '', '2019-07-22 10:30:12');
INSERT INTO `access_log` VALUES (57322, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:12', 9, 0, '', '2019-07-22 10:30:12');
INSERT INTO `access_log` VALUES (57323, '64.78.15637626123913949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:12', 2, 0, '', '2019-07-22 10:30:12');
INSERT INTO `access_log` VALUES (57324, '64.77.15637626125673927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:13', 2, 0, '', '2019-07-22 10:30:13');
INSERT INTO `access_log` VALUES (57325, '64.85.15637626137613965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:14', 3, 0, '', '2019-07-22 10:30:14');
INSERT INTO `access_log` VALUES (57326, '64.84.15637626143123935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:14', 2, 0, '', '2019-07-22 10:30:14');
INSERT INTO `access_log` VALUES (57327, '64.82.15637626144643955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:14', 2, 0, '', '2019-07-22 10:30:14');
INSERT INTO `access_log` VALUES (57328, '64.76.15637626155803941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:16', 2, 0, '', '2019-07-22 10:30:16');
INSERT INTO `access_log` VALUES (57329, '64.81.15637626157183935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:16', 3, 0, '', '2019-07-22 10:30:16');
INSERT INTO `access_log` VALUES (57330, '64.83.15637626162743941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:16', 2, 0, '', '2019-07-22 10:30:16');
INSERT INTO `access_log` VALUES (57331, '64.79.15637626165253947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:17', 2, 0, '', '2019-07-22 10:30:17');
INSERT INTO `access_log` VALUES (57332, '64.80.15637626168823947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:17', 3, 0, '', '2019-07-22 10:30:17');
INSERT INTO `access_log` VALUES (57333, '64.78.15637626170023951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:17', 2, 0, '', '2019-07-22 10:30:17');
INSERT INTO `access_log` VALUES (57334, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword= &pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:20', 7, 0, '', '2019-07-22 10:30:20');
INSERT INTO `access_log` VALUES (57335, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword= ', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:20', 9, 0, '', '2019-07-22 10:30:20');
INSERT INTO `access_log` VALUES (57336, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword= &pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:20', 5, 0, '', '2019-07-22 10:30:20');
INSERT INTO `access_log` VALUES (57337, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword= ', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:20', 10, 0, '', '2019-07-22 10:30:20');
INSERT INTO `access_log` VALUES (57338, '64.85.15637626240453967', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:24', 7, 0, '', '2019-07-22 10:30:24');
INSERT INTO `access_log` VALUES (57339, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:27', 7, 0, '', '2019-07-22 10:30:27');
INSERT INTO `access_log` VALUES (57340, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:27', 4, 0, '', '2019-07-22 10:30:27');
INSERT INTO `access_log` VALUES (57341, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:27', 14, 0, '', '2019-07-22 10:30:27');
INSERT INTO `access_log` VALUES (57342, '64.84.15637626271633937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:27', 2, 0, '', '2019-07-22 10:30:27');
INSERT INTO `access_log` VALUES (57343, '64.82.15637626272903957', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:27', 1, 0, '', '2019-07-22 10:30:27');
INSERT INTO `access_log` VALUES (57344, '59.78.15637626274243731', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:27', 3, 0, '', '2019-07-22 10:30:27');
INSERT INTO `access_log` VALUES (57345, '59.76.15637626274253723', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:27', 16, 2001001000, '服务端发生异常', '2019-07-22 10:30:27');
INSERT INTO `access_log` VALUES (57346, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:30:27', 9, 0, '', '2019-07-22 10:30:28');
INSERT INTO `access_log` VALUES (57347, '65.53.15637626305555891', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-22 10:30:31', 0, 1002001015, '账号未登陆', '2019-07-22 10:30:31');
INSERT INTO `access_log` VALUES (57348, '65.52.15637626305565933', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-22 10:30:31', 0, 1002001015, '账号未登陆', '2019-07-22 10:30:31');
INSERT INTO `access_log` VALUES (57349, '65.50.15637626305575917', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-22 10:30:31', 1, 1002001015, '账号未登陆', '2019-07-22 10:30:31');
INSERT INTO `access_log` VALUES (57350, '65.47.15637626333365889', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-22 10:30:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 10:30:33');
INSERT INTO `access_log` VALUES (57351, '65.54.15637626482835825', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-22 10:30:48', 164, 0, '', '2019-07-22 10:30:48');
INSERT INTO `access_log` VALUES (57352, '65.45.15637626487735887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-22 10:30:49', 18, 0, '', '2019-07-22 10:30:49');
INSERT INTO `access_log` VALUES (57353, '65.49.15637626487765875', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-22 10:30:49', 18, 2001001000, '服务端发生异常', '2019-07-22 10:30:49');
INSERT INTO `access_log` VALUES (57354, '65.51.15637626487785963', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-22 10:30:49', 18, 0, '', '2019-07-22 10:30:49');
INSERT INTO `access_log` VALUES (57355, '65.45.15637627292355889', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:32:09', 1, 1002001015, '账号未登陆', '2019-07-22 10:32:09');
INSERT INTO `access_log` VALUES (57356, '65.54.15637627292345827', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:32:09', 1, 1002001015, '账号未登陆', '2019-07-22 10:32:09');
INSERT INTO `access_log` VALUES (57357, '65.49.15637627292365877', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:32:09', 0, 1002001015, '账号未登陆', '2019-07-22 10:32:09');
INSERT INTO `access_log` VALUES (57358, '65.51.15637627309775965', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:32:11', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 10:32:11');
INSERT INTO `access_log` VALUES (57359, '65.46.15637627394415969', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:32:19', 53, 0, '', '2019-07-22 10:32:19');
INSERT INTO `access_log` VALUES (57360, '65.50.15637627397095921', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:32:20', 9, 0, '', '2019-07-22 10:32:20');
INSERT INTO `access_log` VALUES (57361, '65.53.15637627397095895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:32:20', 12, 2001001000, '服务端发生异常', '2019-07-22 10:32:20');
INSERT INTO `access_log` VALUES (57362, '65.52.15637627397135937', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '39.155.188.22', '2019-07-22 10:32:20', 9, 0, '', '2019-07-22 10:32:20');
INSERT INTO `access_log` VALUES (57363, '65.50.15637637648995935', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 10:49:25', 0, 1002001015, '账号未登陆', '2019-07-22 10:49:25');
INSERT INTO `access_log` VALUES (57364, '65.47.15637637649025907', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 10:49:25', 0, 1002001015, '账号未登陆', '2019-07-22 10:49:25');
INSERT INTO `access_log` VALUES (57365, '65.3607.15637637649067719', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 10:49:25', 0, 1002001015, '账号未登陆', '2019-07-22 10:49:25');
INSERT INTO `access_log` VALUES (57366, '65.54.15637637719205843', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 10:49:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 10:49:32');
INSERT INTO `access_log` VALUES (57367, '65.49.15637637778505893', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 10:49:38', 78, 0, '', '2019-07-22 10:49:38');
INSERT INTO `access_log` VALUES (57368, '65.45.15637637782795905', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 10:49:38', 10, 0, '', '2019-07-22 10:49:38');
INSERT INTO `access_log` VALUES (57369, '65.51.15637637782835981', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 10:49:38', 10, 0, '', '2019-07-22 10:49:38');
INSERT INTO `access_log` VALUES (57370, '65.46.15637637782835985', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 10:49:38', 10, 2001001000, '服务端发生异常', '2019-07-22 10:49:38');
INSERT INTO `access_log` VALUES (57371, '65.50.15637638043615937', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 10:50:04', 11, 2001001000, '服务端发生异常', '2019-07-22 10:50:04');
INSERT INTO `access_log` VALUES (57372, '65.3607.15637638043667721', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 10:50:04', 9, 0, '', '2019-07-22 10:50:04');
INSERT INTO `access_log` VALUES (57373, '65.47.15637638043685909', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 10:50:04', 9, 0, '', '2019-07-22 10:50:04');
INSERT INTO `access_log` VALUES (57374, '65.45.15637638302765907', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 10:50:30', 9, 0, '', '2019-07-22 10:50:30');
INSERT INTO `access_log` VALUES (57375, '65.51.15637638302765983', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 10:50:30', 10, 0, '', '2019-07-22 10:50:30');
INSERT INTO `access_log` VALUES (57376, '65.46.15637638302975987', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 10:50:30', 9, 2001001000, '服务端发生异常', '2019-07-22 10:50:30');
INSERT INTO `access_log` VALUES (57377, '59.80.15637641109793731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; EML-L09) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '142.169.78.120', '2019-07-22 10:55:11', 15, 2001001000, '服务端发生异常', '2019-07-22 10:55:11');
INSERT INTO `access_log` VALUES (57378, '59.76.15637641109693743', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; EML-L09) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '142.169.78.120', '2019-07-22 10:55:11', 53, 0, '', '2019-07-22 10:55:11');
INSERT INTO `access_log` VALUES (57379, '64.82.15637641203573977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; EML-L09) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '142.169.78.120', '2019-07-22 10:55:20', 2, 0, '', '2019-07-22 10:55:20');
INSERT INTO `access_log` VALUES (57380, '64.81.15637641209143957', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; EML-L09) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '142.169.78.120', '2019-07-22 10:55:21', 2, 0, '', '2019-07-22 10:55:21');
INSERT INTO `access_log` VALUES (57381, '64.83.15637641239953963', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; EML-L09) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '142.169.78.120', '2019-07-22 10:55:24', 103, 0, '', '2019-07-22 10:55:24');
INSERT INTO `access_log` VALUES (57382, '64.79.15637641256193969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; EML-L09) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '142.169.78.120', '2019-07-22 10:55:26', 2, 0, '', '2019-07-22 10:55:26');
INSERT INTO `access_log` VALUES (57383, '64.80.15637641272193969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; EML-L09) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '142.169.78.120', '2019-07-22 10:55:27', 2, 0, '', '2019-07-22 10:55:27');
INSERT INTO `access_log` VALUES (57384, '64.78.15637641289713973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; EML-L09) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '142.169.78.120', '2019-07-22 10:55:29', 2, 0, '', '2019-07-22 10:55:29');
INSERT INTO `access_log` VALUES (57385, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; EML-L09) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '142.169.78.120', '2019-07-22 10:55:29', 8, 0, '', '2019-07-22 10:55:29');
INSERT INTO `access_log` VALUES (57386, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; EML-L09) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '142.169.78.120', '2019-07-22 10:55:32', 5, 0, '', '2019-07-22 10:55:32');
INSERT INTO `access_log` VALUES (57387, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; EML-L09) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '142.169.78.120', '2019-07-22 10:55:33', 5, 0, '', '2019-07-22 10:55:33');
INSERT INTO `access_log` VALUES (57388, '64.77.15637641351793951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; EML-L09) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '142.169.78.120', '2019-07-22 10:55:35', 2, 0, '', '2019-07-22 10:55:35');
INSERT INTO `access_log` VALUES (57389, '64.84.15637641356313959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; EML-L09) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '142.169.78.120', '2019-07-22 10:55:36', 2, 0, '', '2019-07-22 10:55:36');
INSERT INTO `access_log` VALUES (57390, '59.79.15637645825433761', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:03:03', 2, 0, '', '2019-07-22 11:03:03');
INSERT INTO `access_log` VALUES (57391, '59.72.15637645825453755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:03:03', 16, 2001001000, '服务端发生异常', '2019-07-22 11:03:03');
INSERT INTO `access_log` VALUES (57392, '65.52.15637645895105965', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:03:10', 1, 1002001015, '账号未登陆', '2019-07-22 11:03:10');
INSERT INTO `access_log` VALUES (57393, '65.50.15637645895135949', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:03:10', 0, 1002001015, '账号未登陆', '2019-07-22 11:03:10');
INSERT INTO `access_log` VALUES (57394, '65.47.15637645895135921', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:03:10', 0, 1002001015, '账号未登陆', '2019-07-22 11:03:10');
INSERT INTO `access_log` VALUES (57395, '64.80.15637646715463977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:04:32', 3, 0, '', '2019-07-22 11:04:32');
INSERT INTO `access_log` VALUES (57396, '64.78.15637646716513981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:04:32', 1, 0, '', '2019-07-22 11:04:32');
INSERT INTO `access_log` VALUES (57397, '64.77.15637646733063959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:04:33', 2, 0, '', '2019-07-22 11:04:33');
INSERT INTO `access_log` VALUES (57398, '64.85.15637646738973997', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:04:34', 1, 0, '', '2019-07-22 11:04:34');
INSERT INTO `access_log` VALUES (57399, '64.76.15637646772393973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:04:37', 2, 0, '', '2019-07-22 11:04:37');
INSERT INTO `access_log` VALUES (57400, '64.82.15637646773673987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:04:37', 2, 0, '', '2019-07-22 11:04:37');
INSERT INTO `access_log` VALUES (57401, '59.77.15637646802253749', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:04:40', 2, 0, '', '2019-07-22 11:04:40');
INSERT INTO `access_log` VALUES (57402, '59.79.15637646802583763', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:04:40', 12, 2001001000, '服务端发生异常', '2019-07-22 11:04:40');
INSERT INTO `access_log` VALUES (57403, '64.81.15637646821343967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:04:42', 2, 0, '', '2019-07-22 11:04:42');
INSERT INTO `access_log` VALUES (57404, '64.83.15637646822393973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:04:42', 2, 0, '', '2019-07-22 11:04:42');
INSERT INTO `access_log` VALUES (57405, '64.79.15637646833463979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:04:43', 2, 0, '', '2019-07-22 11:04:43');
INSERT INTO `access_log` VALUES (57406, '65.53.15637646852915925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:04:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 11:04:45');
INSERT INTO `access_log` VALUES (57407, '65.52.15637646874555967', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:04:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 11:04:47');
INSERT INTO `access_log` VALUES (57408, '65.50.15637647085585951', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:05:09', 59, 0, '', '2019-07-22 11:05:09');
INSERT INTO `access_log` VALUES (57409, '65.3607.15637647088867735', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:05:09', 9, 0, '', '2019-07-22 11:05:09');
INSERT INTO `access_log` VALUES (57410, '65.54.15637647088875859', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:05:09', 11, 2001001000, '服务端发生异常', '2019-07-22 11:05:09');
INSERT INTO `access_log` VALUES (57411, '65.49.15637647089215909', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:05:09', 9, 0, '', '2019-07-22 11:05:09');
INSERT INTO `access_log` VALUES (57412, '65.46.15637647314556001', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:05:31', 9, 0, '', '2019-07-22 11:05:31');
INSERT INTO `access_log` VALUES (57413, '65.53.15637647314555927', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:05:31', 10, 2001001000, '服务端发生异常', '2019-07-22 11:05:31');
INSERT INTO `access_log` VALUES (57414, '65.52.15637647314575969', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.189.85', '2019-07-22 11:05:31', 8, 0, '', '2019-07-22 11:05:31');
INSERT INTO `access_log` VALUES (57415, '65.47.15637659300915941', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.22.5.66', '2019-07-22 11:25:30', 1, 1002001015, '账号未登陆', '2019-07-22 11:25:30');
INSERT INTO `access_log` VALUES (57416, '65.50.15637659300925969', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.22.5.66', '2019-07-22 11:25:30', 1, 1002001015, '账号未登陆', '2019-07-22 11:25:30');
INSERT INTO `access_log` VALUES (57417, '65.45.15637659300955939', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.22.5.66', '2019-07-22 11:25:30', 0, 1002001015, '账号未登陆', '2019-07-22 11:25:30');
INSERT INTO `access_log` VALUES (57418, '65.3607.15637659323777753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.22.5.66', '2019-07-22 11:25:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 11:25:32');
INSERT INTO `access_log` VALUES (57419, '65.49.15637659481155927', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.22.5.66', '2019-07-22 11:25:48', 87, 0, '', '2019-07-22 11:25:48');
INSERT INTO `access_log` VALUES (57420, '65.52.15637659484065987', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.22.5.66', '2019-07-22 11:25:48', 9, 0, '', '2019-07-22 11:25:48');
INSERT INTO `access_log` VALUES (57421, '65.51.15637659484066015', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.22.5.66', '2019-07-22 11:25:48', 10, 0, '', '2019-07-22 11:25:48');
INSERT INTO `access_log` VALUES (57422, '65.46.15637659484066019', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.22.5.66', '2019-07-22 11:25:48', 10, 2001001000, '服务端发生异常', '2019-07-22 11:25:48');
INSERT INTO `access_log` VALUES (57423, '65.50.15637659540695971', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.22.5.66', '2019-07-22 11:25:54', 8, 0, '', '2019-07-22 11:25:54');
INSERT INTO `access_log` VALUES (57424, '65.47.15637659541055943', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.22.5.66', '2019-07-22 11:25:54', 10, 2001001000, '服务端发生异常', '2019-07-22 11:25:54');
INSERT INTO `access_log` VALUES (57425, '65.45.15637659541055941', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.22.5.66', '2019-07-22 11:25:54', 8, 0, '', '2019-07-22 11:25:54');
INSERT INTO `access_log` VALUES (57426, '65.53.15637720512836027', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.199.71', '2019-07-22 13:07:31', 1, 1002001015, '账号未登陆', '2019-07-22 13:07:31');
INSERT INTO `access_log` VALUES (57427, '65.50.15637720512836053', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.199.71', '2019-07-22 13:07:31', 1, 1002001015, '账号未登陆', '2019-07-22 13:07:31');
INSERT INTO `access_log` VALUES (57428, '65.45.15637720512836023', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.199.71', '2019-07-22 13:07:31', 0, 1002001015, '账号未登陆', '2019-07-22 13:07:31');
INSERT INTO `access_log` VALUES (57429, '65.54.15637720748555961', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.199.71', '2019-07-22 13:07:55', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 13:07:55');
INSERT INTO `access_log` VALUES (57430, '65.51.15637720917776099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.199.71', '2019-07-22 13:08:12', 189, 0, '', '2019-07-22 13:08:12');
INSERT INTO `access_log` VALUES (57431, '65.52.15637720922716071', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.199.71', '2019-07-22 13:08:12', 11, 0, '', '2019-07-22 13:08:12');
INSERT INTO `access_log` VALUES (57432, '65.46.15637720922756103', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.199.71', '2019-07-22 13:08:12', 9, 2001001000, '服务端发生异常', '2019-07-22 13:08:12');
INSERT INTO `access_log` VALUES (57433, '65.53.15637720922796029', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.199.71', '2019-07-22 13:08:12', 8, 0, '', '2019-07-22 13:08:12');
INSERT INTO `access_log` VALUES (57434, '65.45.15637721042806025', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.199.71', '2019-07-22 13:08:24', 10, 0, '', '2019-07-22 13:08:24');
INSERT INTO `access_log` VALUES (57435, '65.47.15637721042836027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.199.71', '2019-07-22 13:08:24', 11, 2001001000, '服务端发生异常', '2019-07-22 13:08:24');
INSERT INTO `access_log` VALUES (57436, '65.3607.15637721042987839', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '171.221.199.71', '2019-07-22 13:08:24', 12, 0, '', '2019-07-22 13:08:24');
INSERT INTO `access_log` VALUES (57437, '59.76.15637757408363899', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.220.48', '2019-07-22 14:09:01', 11, 0, '', '2019-07-22 14:09:01');
INSERT INTO `access_log` VALUES (57438, '59.77.15637757408373897', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.220.48', '2019-07-22 14:09:01', 27, 2001001000, '服务端发生异常', '2019-07-22 14:09:01');
INSERT INTO `access_log` VALUES (57439, '64.81.15637757441914115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.220.48', '2019-07-22 14:09:04', 12, 0, '', '2019-07-22 14:09:04');
INSERT INTO `access_log` VALUES (57440, '64.83.15637757443174121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.220.48', '2019-07-22 14:09:04', 3, 0, '', '2019-07-22 14:09:04');
INSERT INTO `access_log` VALUES (57441, '64.80.15637757456564127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.220.48', '2019-07-22 14:09:06', 2, 0, '', '2019-07-22 14:09:06');
INSERT INTO `access_log` VALUES (57442, '64.78.15637757464114131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.220.48', '2019-07-22 14:09:06', 1, 0, '', '2019-07-22 14:09:06');
INSERT INTO `access_log` VALUES (57443, '64.77.15637757500014109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.220.48', '2019-07-22 14:09:10', 11, 0, '', '2019-07-22 14:09:10');
INSERT INTO `access_log` VALUES (57444, '64.85.15637757508874147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.220.48', '2019-07-22 14:09:11', 3, 0, '', '2019-07-22 14:09:11');
INSERT INTO `access_log` VALUES (57445, '64.84.15637757568994117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.220.48', '2019-07-22 14:09:17', 2, 0, '', '2019-07-22 14:09:17');
INSERT INTO `access_log` VALUES (57446, '64.76.15637757573464123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.220.48', '2019-07-22 14:09:17', 2, 0, '', '2019-07-22 14:09:17');
INSERT INTO `access_log` VALUES (57447, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.220.48', '2019-07-22 14:09:19', 5, 0, '', '2019-07-22 14:09:19');
INSERT INTO `access_log` VALUES (57448, '64.82.15637757587514137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '60.186.220.48', '2019-07-22 14:09:19', 2, 0, '', '2019-07-22 14:09:19');
INSERT INTO `access_log` VALUES (57449, '65.3607.15637757597107889', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=zlc&password=zlc&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '210.22.4.227', '2019-07-22 14:09:20', 0, 1002001015, '账号未登陆', '2019-07-22 14:09:20');
INSERT INTO `access_log` VALUES (57450, '65.46.15637757911896153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.220.48', '2019-07-22 14:09:51', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 14:09:51');
INSERT INTO `access_log` VALUES (57451, '65.53.15637758080606079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.220.48', '2019-07-22 14:10:08', 108, 0, '', '2019-07-22 14:10:08');
INSERT INTO `access_log` VALUES (57452, '65.50.15637758084466107', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.220.48', '2019-07-22 14:10:08', 80, 0, '', '2019-07-22 14:10:09');
INSERT INTO `access_log` VALUES (57453, '65.47.15637758084516077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.220.48', '2019-07-22 14:10:08', 75, 0, '', '2019-07-22 14:10:09');
INSERT INTO `access_log` VALUES (57454, '65.45.15637758084496081', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.186.220.48', '2019-07-22 14:10:08', 81, 2001001000, '服务端发生异常', '2019-07-22 14:10:09');
INSERT INTO `access_log` VALUES (57455, '59.73.15637765239753923', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.149.12.173', '2019-07-22 14:22:04', 17, 2001001000, '服务端发生异常', '2019-07-22 14:22:04');
INSERT INTO `access_log` VALUES (57456, '59.74.15637765239753927', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.149.12.173', '2019-07-22 14:22:04', 51, 0, '', '2019-07-22 14:22:04');
INSERT INTO `access_log` VALUES (57457, '64.79.15637765275174139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.149.12.173', '2019-07-22 14:22:08', 3, 0, '', '2019-07-22 14:22:08');
INSERT INTO `access_log` VALUES (57458, '64.80.15637765276344139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.149.12.173', '2019-07-22 14:22:08', 2, 0, '', '2019-07-22 14:22:08');
INSERT INTO `access_log` VALUES (57459, '64.78.15637765293884143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.149.12.173', '2019-07-22 14:22:09', 2, 0, '', '2019-07-22 14:22:09');
INSERT INTO `access_log` VALUES (57460, '64.77.15637765302304121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.149.12.173', '2019-07-22 14:22:10', 2, 0, '', '2019-07-22 14:22:10');
INSERT INTO `access_log` VALUES (57461, '59.73.15637772456793933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:06', 3, 0, '', '2019-07-22 14:34:06');
INSERT INTO `access_log` VALUES (57462, '59.75.15637772456793935', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:06', 23, 2001001000, '服务端发生异常', '2019-07-22 14:34:06');
INSERT INTO `access_log` VALUES (57463, '65.3607.15637772546227911', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:15', 1, 1002001015, '账号未登陆', '2019-07-22 14:34:15');
INSERT INTO `access_log` VALUES (57464, '65.51.15637772546226177', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:15', 0, 1002001015, '账号未登陆', '2019-07-22 14:34:15');
INSERT INTO `access_log` VALUES (57465, '65.47.15637772546236097', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:15', 0, 1002001015, '账号未登陆', '2019-07-22 14:34:15');
INSERT INTO `access_log` VALUES (57466, '65.53.15637772570506101', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:17', 228, 0, '', '2019-07-22 14:34:17');
INSERT INTO `access_log` VALUES (57467, '65.49.15637772575156087', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:18', 20, 0, '', '2019-07-22 14:34:18');
INSERT INTO `access_log` VALUES (57468, '65.46.15637772575206175', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:18', 18, 0, '', '2019-07-22 14:34:18');
INSERT INTO `access_log` VALUES (57469, '65.45.15637772575226103', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:18', 11, 2001001000, '服务端发生异常', '2019-07-22 14:34:18');
INSERT INTO `access_log` VALUES (57470, '65.54.15637772619496035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:22', 9, 0, '', '2019-07-22 14:34:22');
INSERT INTO `access_log` VALUES (57471, '65.50.15637772619576129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:22', 280, 0, '', '2019-07-22 14:34:22');
INSERT INTO `access_log` VALUES (57472, '65.52.15637772619576147', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:22', 287, 2001001000, '服务端发生异常', '2019-07-22 14:34:22');
INSERT INTO `access_log` VALUES (57473, '65.51.15637772703256179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 14:34:30');
INSERT INTO `access_log` VALUES (57474, '65.3607.15637772728087913', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=a yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:33', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号格式为数字以及字母', '2019-07-22 14:34:33');
INSERT INTO `access_log` VALUES (57475, '65.53.15637772762596103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:36', 148, 0, '', '2019-07-22 14:34:36');
INSERT INTO `access_log` VALUES (57476, '65.45.15637772765856105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:37', 10, 0, '', '2019-07-22 14:34:37');
INSERT INTO `access_log` VALUES (57477, '65.46.15637772765946177', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:37', 9, 0, '', '2019-07-22 14:34:37');
INSERT INTO `access_log` VALUES (57478, '65.49.15637772765946089', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:34:37', 10, 2001001000, '服务端发生异常', '2019-07-22 14:34:37');
INSERT INTO `access_log` VALUES (57479, '59.79.15637773294913933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:35:29', 3, 0, '', '2019-07-22 14:35:29');
INSERT INTO `access_log` VALUES (57480, '59.72.15637773294943927', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.163', '2019-07-22 14:35:29', 20, 2001001000, '服务端发生异常', '2019-07-22 14:35:30');
INSERT INTO `access_log` VALUES (57481, '65.46.15637783947476193', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 14:53:15', 4, 1002001012, '访问令牌已过期', '2019-07-22 14:53:15');
INSERT INTO `access_log` VALUES (57482, '65.53.15637783947476119', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 14:53:15', 5, 1002001012, '访问令牌已过期', '2019-07-22 14:53:15');
INSERT INTO `access_log` VALUES (57483, '65.3607.15637783947477929', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 14:53:15', 5, 1002001012, '访问令牌已过期', '2019-07-22 14:53:15');
INSERT INTO `access_log` VALUES (57484, '65.45.15637784020136121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 14:53:22', 64, 0, '', '2019-07-22 14:53:22');
INSERT INTO `access_log` VALUES (57485, '65.52.15637784023446165', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 14:53:22', 9, 0, '', '2019-07-22 14:53:22');
INSERT INTO `access_log` VALUES (57486, '65.54.15637784023446053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 14:53:22', 10, 0, '', '2019-07-22 14:53:22');
INSERT INTO `access_log` VALUES (57487, '65.49.15637784023426105', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 14:53:22', 12, 2001001000, '服务端发生异常', '2019-07-22 14:53:22');
INSERT INTO `access_log` VALUES (57488, '65.51.15637784334156197', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 14:53:53', 10, 0, '', '2019-07-22 14:53:53');
INSERT INTO `access_log` VALUES (57489, '65.46.15637784334186195', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 14:53:53', 11, 2001001000, '服务端发生异常', '2019-07-22 14:53:53');
INSERT INTO `access_log` VALUES (57490, '65.53.15637784334206121', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.204.220.250', '2019-07-22 14:53:53', 9, 0, '', '2019-07-22 14:53:53');
INSERT INTO `access_log` VALUES (57491, '59.71.15637787051143949', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:58:25', 3, 0, '', '2019-07-22 14:58:25');
INSERT INTO `access_log` VALUES (57492, '59.75.15637787051143955', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:58:25', 10, 2001001000, '服务端发生异常', '2019-07-22 14:58:25');
INSERT INTO `access_log` VALUES (57493, '64.83.15637787093594163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:58:29', 13, 0, '', '2019-07-22 14:58:29');
INSERT INTO `access_log` VALUES (57494, '64.79.15637787094714169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:58:29', 3, 0, '', '2019-07-22 14:58:29');
INSERT INTO `access_log` VALUES (57495, '64.80.15637787137074169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:58:34', 3, 0, '', '2019-07-22 14:58:34');
INSERT INTO `access_log` VALUES (57496, '64.78.15637787138314173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:58:34', 2, 0, '', '2019-07-22 14:58:34');
INSERT INTO `access_log` VALUES (57497, '59.80.15637787142903929', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:58:34', 2, 0, '', '2019-07-22 14:58:34');
INSERT INTO `access_log` VALUES (57498, '59.76.15637787142923941', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:58:34', 23, 2001001000, '服务端发生异常', '2019-07-22 14:58:34');
INSERT INTO `access_log` VALUES (57499, '65.3607.15637787233987935', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:58:43', 0, 1002001015, '账号未登陆', '2019-07-22 14:58:43');
INSERT INTO `access_log` VALUES (57500, '65.45.15637787234006127', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:58:43', 0, 1002001015, '账号未登陆', '2019-07-22 14:58:43');
INSERT INTO `access_log` VALUES (57501, '65.54.15637787234036059', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:58:43', 0, 1002001015, '账号未登陆', '2019-07-22 14:58:43');
INSERT INTO `access_log` VALUES (57502, '65.52.15637787311576171', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:58:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 14:58:51');
INSERT INTO `access_log` VALUES (57503, '65.49.15637787339106111', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:58:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 14:58:54');
INSERT INTO `access_log` VALUES (57504, '65.51.15637787443906203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:59:04', 114, 0, '', '2019-07-22 14:59:05');
INSERT INTO `access_log` VALUES (57505, '65.54.15637787447066061', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:59:05', 19, 0, '', '2019-07-22 14:59:05');
INSERT INTO `access_log` VALUES (57506, '65.45.15637787447066129', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:59:05', 20, 2001001000, '服务端发生异常', '2019-07-22 14:59:05');
INSERT INTO `access_log` VALUES (57507, '65.52.15637787447106173', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:59:05', 16, 0, '', '2019-07-22 14:59:05');
INSERT INTO `access_log` VALUES (57508, '65.49.15637787504656113', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:59:10', 10, 2001001000, '服务端发生异常', '2019-07-22 14:59:10');
INSERT INTO `access_log` VALUES (57509, '65.50.15637787504636155', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:59:10', 13, 0, '', '2019-07-22 14:59:10');
INSERT INTO `access_log` VALUES (57510, '65.47.15637787504706123', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.188', '2019-07-22 14:59:10', 8, 0, '', '2019-07-22 14:59:10');
INSERT INTO `access_log` VALUES (57511, '59.73.15637828340904009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:14', 21, 0, '', '2019-07-22 16:07:14');
INSERT INTO `access_log` VALUES (57512, '59.75.15637828340924011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:14', 24, 2001001000, '服务端发生异常', '2019-07-22 16:07:14');
INSERT INTO `access_log` VALUES (57513, '65.49.15637828454546167', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:25', 0, 1002001015, '账号未登陆', '2019-07-22 16:07:25');
INSERT INTO `access_log` VALUES (57514, '65.50.15637828454546211', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:25', 0, 1002001015, '账号未登陆', '2019-07-22 16:07:25');
INSERT INTO `access_log` VALUES (57515, '65.47.15637828454546177', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:25', 0, 1002001015, '账号未登陆', '2019-07-22 16:07:25');
INSERT INTO `access_log` VALUES (57516, '64.82.15637828465034235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:27', 11, 0, '', '2019-07-22 16:07:27');
INSERT INTO `access_log` VALUES (57517, '64.81.15637828466404215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:27', 3, 0, '', '2019-07-22 16:07:27');
INSERT INTO `access_log` VALUES (57518, '64.80.15637828482884225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:28', 2, 0, '', '2019-07-22 16:07:28');
INSERT INTO `access_log` VALUES (57519, '64.77.15637828488334207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:29', 2, 0, '', '2019-07-22 16:07:29');
INSERT INTO `access_log` VALUES (57520, '59.78.15637828497404005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:30', 3, 0, '', '2019-07-22 16:07:30');
INSERT INTO `access_log` VALUES (57521, '59.80.15637828497423985', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:30', 35, 2001001000, '服务端发生异常', '2019-07-22 16:07:30');
INSERT INTO `access_log` VALUES (57522, '65.53.15637828586396185', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 16:07:39');
INSERT INTO `access_log` VALUES (57523, '65.46.15637828647426259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:45', 86, 0, '', '2019-07-22 16:07:45');
INSERT INTO `access_log` VALUES (57524, '65.52.15637828650856231', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:45', 12, 0, '', '2019-07-22 16:07:45');
INSERT INTO `access_log` VALUES (57525, '65.54.15637828650866119', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:45', 13, 2001001000, '服务端发生异常', '2019-07-22 16:07:45');
INSERT INTO `access_log` VALUES (57526, '65.45.15637828650886187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.134.100', '2019-07-22 16:07:45', 10, 0, '', '2019-07-22 16:07:45');
INSERT INTO `access_log` VALUES (57527, '59.74.15637832067164019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.2.174', '2019-07-22 16:13:27', 3, 0, '', '2019-07-22 16:13:27');
INSERT INTO `access_log` VALUES (57528, '59.75.15637832067184017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.2.174', '2019-07-22 16:13:27', 16, 2001001000, '服务端发生异常', '2019-07-22 16:13:27');
INSERT INTO `access_log` VALUES (57529, '65.49.15637832067686173', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:13:27', 5, 1002001012, '访问令牌已过期', '2019-07-22 16:13:27');
INSERT INTO `access_log` VALUES (57530, '65.53.15637832067696191', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:13:27', 4, 1002001012, '访问令牌已过期', '2019-07-22 16:13:27');
INSERT INTO `access_log` VALUES (57531, '65.51.15637832067726267', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:13:27', 2, 1002001012, '访问令牌已过期', '2019-07-22 16:13:27');
INSERT INTO `access_log` VALUES (57532, '59.73.15637832116224015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.2.174', '2019-07-22 16:13:32', 2, 0, '', '2019-07-22 16:13:32');
INSERT INTO `access_log` VALUES (57533, '59.71.15637832116234011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.2.174', '2019-07-22 16:13:32', 12, 2001001000, '服务端发生异常', '2019-07-22 16:13:32');
INSERT INTO `access_log` VALUES (57534, '65.46.15637832170166265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:13:37', 69, 0, '', '2019-07-22 16:13:37');
INSERT INTO `access_log` VALUES (57535, '65.54.15637832173696125', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:13:37', 17, 0, '', '2019-07-22 16:13:37');
INSERT INTO `access_log` VALUES (57536, '65.45.15637832173716193', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:13:37', 19, 2001001000, '服务端发生异常', '2019-07-22 16:13:37');
INSERT INTO `access_log` VALUES (57537, '65.52.15637832173746237', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:13:37', 17, 0, '', '2019-07-22 16:13:37');
INSERT INTO `access_log` VALUES (57538, '65.50.15637832248536219', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:13:45', 9, 0, '', '2019-07-22 16:13:45');
INSERT INTO `access_log` VALUES (57539, '65.53.15637832248596193', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:13:45', 9, 0, '', '2019-07-22 16:13:45');
INSERT INTO `access_log` VALUES (57540, '65.47.15637832248586185', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:13:45', 9, 2001001000, '服务端发生异常', '2019-07-22 16:13:45');
INSERT INTO `access_log` VALUES (57541, '65.51.15637832358566269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:13:56', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 16:13:56');
INSERT INTO `access_log` VALUES (57542, '65.46.15637832399366267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:14:00', 511, 0, '', '2019-07-22 16:14:00');
INSERT INTO `access_log` VALUES (57543, '65.45.15637832406896195', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:14:01', 8, 0, '', '2019-07-22 16:14:01');
INSERT INTO `access_log` VALUES (57544, '65.52.15637832406936239', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:14:01', 9, 0, '', '2019-07-22 16:14:01');
INSERT INTO `access_log` VALUES (57545, '65.54.15637832406896127', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:14:01', 15, 0, '', '2019-07-22 16:14:01');
INSERT INTO `access_log` VALUES (57546, '64.81.15637832552694221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.2.174', '2019-07-22 16:14:15', 3, 0, '', '2019-07-22 16:14:15');
INSERT INTO `access_log` VALUES (57547, '64.80.15637832554244231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.2.174', '2019-07-22 16:14:15', 2, 0, '', '2019-07-22 16:14:15');
INSERT INTO `access_log` VALUES (57548, '62.89.15637832598683105', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:14:20', 32, 0, '', '2019-07-22 16:14:20');
INSERT INTO `access_log` VALUES (57549, '64.79.15637832622114233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.2.174', '2019-07-22 16:14:22', 2, 0, '', '2019-07-22 16:14:22');
INSERT INTO `access_log` VALUES (57550, '62.88.15637832842563087', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:14:44', 24, 0, '', '2019-07-22 16:14:44');
INSERT INTO `access_log` VALUES (57551, '64.78.15637832863214237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.2.174', '2019-07-22 16:14:46', 1, 0, '', '2019-07-22 16:14:46');
INSERT INTO `access_log` VALUES (57552, '64.76.15637832933704227', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:14:53', 11, 0, '', '2019-07-22 16:14:53');
INSERT INTO `access_log` VALUES (57553, '64.84.15637832933704221', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:14:53', 15, 0, '', '2019-07-22 16:14:53');
INSERT INTO `access_log` VALUES (57554, '64.81.15637832971394223', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:14:57', 11, 0, '', '2019-07-22 16:14:57');
INSERT INTO `access_log` VALUES (57555, '64.82.15637832971374243', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:14:57', 21, 0, '', '2019-07-22 16:14:57');
INSERT INTO `access_log` VALUES (57556, '64.77.15637833092384215', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:15:09', 17, 0, '', '2019-07-22 16:15:09');
INSERT INTO `access_log` VALUES (57557, '66.54.15637833302011865', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:15:30', 105, 0, '', '2019-07-22 16:15:30');
INSERT INTO `access_log` VALUES (57558, '59.71.15637833383274013', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:15:38', 15, 0, '', '2019-07-22 16:15:38');
INSERT INTO `access_log` VALUES (57559, '59.80.15637833610153993', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:16:01', 25, 2001001000, '服务端发生异常', '2019-07-22 16:16:01');
INSERT INTO `access_log` VALUES (57560, '59.77.15637833727354003', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:16:13', 17, 0, '', '2019-07-22 16:16:13');
INSERT INTO `access_log` VALUES (57561, '64.76.15637833742064229', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:16:14', 72, 0, '', '2019-07-22 16:16:14');
INSERT INTO `access_log` VALUES (57562, '64.84.15637833774244223', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:16:17', 9, 0, '', '2019-07-22 16:16:17');
INSERT INTO `access_log` VALUES (57563, '64.81.15637833784024225', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:16:18', 10, 0, '', '2019-07-22 16:16:18');
INSERT INTO `access_log` VALUES (57564, '64.80.15637833856274235', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:16:26', 10, 0, '', '2019-07-22 16:16:26');
INSERT INTO `access_log` VALUES (57565, '64.79.15637833960794237', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:16:36', 10, 0, '', '2019-07-22 16:16:36');
INSERT INTO `access_log` VALUES (57566, '64.83.15637834097734229', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:16:50', 12, 0, '', '2019-07-22 16:16:50');
INSERT INTO `access_log` VALUES (57567, '59.73.15637834267514019', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:07', 16, 0, '', '2019-07-22 16:17:07');
INSERT INTO `access_log` VALUES (57568, '59.71.15637834285714015', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:09', 12, 0, '', '2019-07-22 16:17:09');
INSERT INTO `access_log` VALUES (57569, '59.78.15637834290854015', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:09', 11, 0, '', '2019-07-22 16:17:09');
INSERT INTO `access_log` VALUES (57570, '59.80.15637834294713995', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:09', 10, 0, '', '2019-07-22 16:17:09');
INSERT INTO `access_log` VALUES (57571, '59.76.15637834303484007', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:10', 12, 0, '', '2019-07-22 16:17:10');
INSERT INTO `access_log` VALUES (57572, '59.77.15637834308194005', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:11', 10, 0, '', '2019-07-22 16:17:11');
INSERT INTO `access_log` VALUES (57573, '59.79.15637834315744019', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=INVALID&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:12', 11, 0, '', '2019-07-22 16:17:12');
INSERT INTO `access_log` VALUES (57574, '59.72.15637834349594013', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=ALL&activityType=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:15', 13, 0, '', '2019-07-22 16:17:15');
INSERT INTO `access_log` VALUES (57575, '59.75.15637834395244023', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:20', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-22 16:17:20');
INSERT INTO `access_log` VALUES (57576, '59.73.15637834407404021', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:21', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-22 16:17:21');
INSERT INTO `access_log` VALUES (57577, '59.71.15637834415554017', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:22', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-22 16:17:22');
INSERT INTO `access_log` VALUES (57578, '65.49.15637834479736179', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:28', 26, 0, '', '2019-07-22 16:17:28');
INSERT INTO `access_log` VALUES (57579, '65.51.15637834513876273', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=5', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:31', 11, 0, '', '2019-07-22 16:17:31');
INSERT INTO `access_log` VALUES (57580, '65.46.15637834565296271', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:37', 18, 0, '', '2019-07-22 16:17:37');
INSERT INTO `access_log` VALUES (57581, '65.54.15637834583686131', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:38', 20, 0, '', '2019-07-22 16:17:38');
INSERT INTO `access_log` VALUES (57582, '65.45.15637834673056199', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:17:47', 10, 0, '', '2019-07-22 16:17:47');
INSERT INTO `access_log` VALUES (57583, '65.54.15637835675036133', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.204.51.60', '2019-07-22 16:19:28', 17, 0, '', '2019-07-22 16:19:28');
INSERT INTO `access_log` VALUES (57584, '2fd140c3-abd2-40dc-84bc-ed4aac7b109a', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '0:0:0:0:0:0:0:1', '2019-07-22 16:24:29', 118, 0, '', '2019-07-22 16:24:29');
INSERT INTO `access_log` VALUES (57585, '710f67d0-53b8-4cc9-be68-e292af7531da', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '0:0:0:0:0:0:0:1', '2019-07-22 16:25:19', 8654, 0, '', '2019-07-22 16:25:27');
INSERT INTO `access_log` VALUES (57586, '59.74.15637839924434033', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.2.174', '2019-07-22 16:26:32', 4, 0, '', '2019-07-22 16:26:32');
INSERT INTO `access_log` VALUES (57587, '59.75.15637839924464031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.2.174', '2019-07-22 16:26:32', 13, 2001001000, '服务端发生异常', '2019-07-22 16:26:32');
INSERT INTO `access_log` VALUES (57588, '59.71.15637839975044025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.2.174', '2019-07-22 16:26:38', 2, 0, '', '2019-07-22 16:26:38');
INSERT INTO `access_log` VALUES (57589, '59.78.15637839975044025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.2.174', '2019-07-22 16:26:38', 13, 2001001000, '服务端发生异常', '2019-07-22 16:26:38');
INSERT INTO `access_log` VALUES (57590, '59.80.15637840051514005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.2.174', '2019-07-22 16:26:45', 18, 2001001000, '服务端发生异常', '2019-07-22 16:26:45');
INSERT INTO `access_log` VALUES (57591, 'f41976e4-b88b-41e8-8685-818b03adc8fc', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '0:0:0:0:0:0:0:1', '2019-07-22 16:29:28', 1784, 0, '', '2019-07-22 16:29:30');
INSERT INTO `access_log` VALUES (57592, 'f41976e4-b88b-41e8-8685-818b03adc8fc', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '0:0:0:0:0:0:0:1', '2019-07-22 16:29:28', 1784, 0, '', '2019-07-22 16:29:31');
INSERT INTO `access_log` VALUES (57593, '65.52.15637850774426265', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 16:44:37', 1, 1002001015, '账号未登陆', '2019-07-22 16:44:37');
INSERT INTO `access_log` VALUES (57594, '65.3607.15637850774478029', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 16:44:37', 1, 1002001015, '账号未登陆', '2019-07-22 16:44:37');
INSERT INTO `access_log` VALUES (57595, '65.45.15637850774426221', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 16:44:37', 0, 1002001015, '账号未登陆', '2019-07-22 16:44:37');
INSERT INTO `access_log` VALUES (57596, '65.50.15637850795606247', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 16:44:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 16:44:40');
INSERT INTO `access_log` VALUES (57597, '65.53.15637850830776221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 16:44:43', 117, 0, '', '2019-07-22 16:44:43');
INSERT INTO `access_log` VALUES (57598, '65.49.15637850835206203', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 16:44:44', 10, 0, '', '2019-07-22 16:44:44');
INSERT INTO `access_log` VALUES (57599, '65.51.15637850835216297', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 16:44:44', 11, 2001001000, '服务端发生异常', '2019-07-22 16:44:44');
INSERT INTO `access_log` VALUES (57600, '65.46.15637850835246295', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 16:44:44', 9, 0, '', '2019-07-22 16:44:44');
INSERT INTO `access_log` VALUES (57601, '65.52.15637850946886267', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 16:44:55', 16, 0, '', '2019-07-22 16:44:55');
INSERT INTO `access_log` VALUES (57602, '65.3607.15637850946908031', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 16:44:55', 17, 0, '', '2019-07-22 16:44:55');
INSERT INTO `access_log` VALUES (57603, '65.45.15637850946926223', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 16:44:55', 16, 2001001000, '服务端发生异常', '2019-07-22 16:44:55');
INSERT INTO `access_log` VALUES (57604, '65.50.15637852858336251', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 16:48:06', 1, 0, '', '2019-07-22 16:48:06');
INSERT INTO `access_log` VALUES (57605, '59.74.15637855457514055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.180.73', '2019-07-22 16:52:26', 2, 0, '', '2019-07-22 16:52:26');
INSERT INTO `access_log` VALUES (57606, '59.72.15637855457484043', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.180.73', '2019-07-22 16:52:26', 12, 2001001000, '服务端发生异常', '2019-07-22 16:52:26');
INSERT INTO `access_log` VALUES (57607, '602f50c0-8800-4e0b-b736-8acb5bbbcf54', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '0:0:0:0:0:0:0:1', '2019-07-22 16:53:57', 3459, 0, '', '2019-07-22 16:54:02');
INSERT INTO `access_log` VALUES (57608, '602f50c0-8800-4e0b-b736-8acb5bbbcf54', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '0:0:0:0:0:0:0:1', '2019-07-22 16:53:57', 3459, 0, '', '2019-07-22 16:54:01');
INSERT INTO `access_log` VALUES (57609, '59.74.15637861155654063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 17:01:56', 2, 0, '', '2019-07-22 17:01:56');
INSERT INTO `access_log` VALUES (57610, '59.72.15637861155594051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 17:01:56', 39, 2001001000, '服务端发生异常', '2019-07-22 17:01:56');
INSERT INTO `access_log` VALUES (57611, '64.85.15637861197394293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 17:02:00', 11, 0, '', '2019-07-22 17:02:00');
INSERT INTO `access_log` VALUES (57612, '64.76.15637861198914267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 17:02:00', 3, 0, '', '2019-07-22 17:02:00');
INSERT INTO `access_log` VALUES (57613, '64.84.15637861230684261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 17:02:03', 2, 0, '', '2019-07-22 17:02:03');
INSERT INTO `access_log` VALUES (57614, '64.81.15637861232744263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 17:02:03', 1, 0, '', '2019-07-22 17:02:03');
INSERT INTO `access_log` VALUES (57615, '59.75.15637861237724061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 17:02:04', 2, 0, '', '2019-07-22 17:02:04');
INSERT INTO `access_log` VALUES (57616, '59.73.15637861237764059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3746.0 Safari/537.36', '183.224.87.48', '2019-07-22 17:02:04', 15, 2001001000, '服务端发生异常', '2019-07-22 17:02:04');
INSERT INTO `access_log` VALUES (57617, '59.80.15637863039414037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.238.135.244', '2019-07-22 17:05:04', 3, 0, '', '2019-07-22 17:05:04');
INSERT INTO `access_log` VALUES (57618, '59.76.15637863039444049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.238.135.244', '2019-07-22 17:05:04', 20, 2001001000, '服务端发生异常', '2019-07-22 17:05:04');
INSERT INTO `access_log` VALUES (57619, '65.50.15637871736116277', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:19:34', 0, 1002001015, '账号未登陆', '2019-07-22 17:19:34');
INSERT INTO `access_log` VALUES (57620, '65.47.15637871736106245', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:19:34', 0, 1002001015, '账号未登陆', '2019-07-22 17:19:34');
INSERT INTO `access_log` VALUES (57621, '65.53.15637871736236255', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:19:34', 0, 1002001015, '账号未登陆', '2019-07-22 17:19:34');
INSERT INTO `access_log` VALUES (57622, '65.46.15637871762876329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:19:36', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 17:19:36');
INSERT INTO `access_log` VALUES (57623, '65.51.15637871812236331', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:19:41', 169, 0, '', '2019-07-22 17:19:41');
INSERT INTO `access_log` VALUES (57624, '65.54.15637871816286187', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:19:42', 12, 0, '', '2019-07-22 17:19:42');
INSERT INTO `access_log` VALUES (57625, '65.52.15637871816326297', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:19:42', 9, 2001001000, '服务端发生异常', '2019-07-22 17:19:42');
INSERT INTO `access_log` VALUES (57626, '65.3607.15637871816368061', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:19:42', 9, 0, '', '2019-07-22 17:19:42');
INSERT INTO `access_log` VALUES (57627, '65.46.15637872471836331', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:20:47', 10, 0, '', '2019-07-22 17:20:47');
INSERT INTO `access_log` VALUES (57628, '65.49.15637872471906235', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:20:47', 10, 2001001000, '服务端发生异常', '2019-07-22 17:20:47');
INSERT INTO `access_log` VALUES (57629, '65.51.15637872472006333', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:20:47', 8, 0, '', '2019-07-22 17:20:47');
INSERT INTO `access_log` VALUES (57630, '65.52.15637872622586299', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:21:02', 9, 0, '', '2019-07-22 17:21:02');
INSERT INTO `access_log` VALUES (57631, '65.54.15637872622666189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:21:02', 10, 2001001000, '服务端发生异常', '2019-07-22 17:21:02');
INSERT INTO `access_log` VALUES (57632, '65.45.15637872622696257', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:21:02', 9, 0, '', '2019-07-22 17:21:02');
INSERT INTO `access_log` VALUES (57633, '59.71.15637872724354071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:21:12', 3, 0, '', '2019-07-22 17:21:12');
INSERT INTO `access_log` VALUES (57634, '59.73.15637872724354075', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:21:12', 13, 2001001000, '服务端发生异常', '2019-07-22 17:21:12');
INSERT INTO `access_log` VALUES (57635, '64.81.15637872826304281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:21:23', 3, 0, '', '2019-07-22 17:21:23');
INSERT INTO `access_log` VALUES (57636, '64.82.15637872827484299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:21:23', 2, 0, '', '2019-07-22 17:21:23');
INSERT INTO `access_log` VALUES (57637, '64.80.15637872840104291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:21:24', 3, 0, '', '2019-07-22 17:21:24');
INSERT INTO `access_log` VALUES (57638, '64.77.15637872849234271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-07-22 17:21:25', 2, 0, '', '2019-07-22 17:21:25');
INSERT INTO `access_log` VALUES (57639, '65.45.15637879801786267', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.238.135.244', '2019-07-22 17:33:00', 0, 1002001015, '账号未登陆', '2019-07-22 17:33:00');
INSERT INTO `access_log` VALUES (57640, '65.54.15637879801796199', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.238.135.244', '2019-07-22 17:33:00', 1, 1002001015, '账号未登陆', '2019-07-22 17:33:00');
INSERT INTO `access_log` VALUES (57641, '65.47.15637879801866259', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.238.135.244', '2019-07-22 17:33:00', 1, 1002001015, '账号未登陆', '2019-07-22 17:33:00');
INSERT INTO `access_log` VALUES (57642, '65.53.15637879983646269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.238.135.244', '2019-07-22 17:33:18', 61, 0, '', '2019-07-22 17:33:18');
INSERT INTO `access_log` VALUES (57643, '65.46.15637879986966343', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.238.135.244', '2019-07-22 17:33:19', 9, 0, '', '2019-07-22 17:33:19');
INSERT INTO `access_log` VALUES (57644, '65.49.15637879986996247', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.238.135.244', '2019-07-22 17:33:19', 9, 2001001000, '服务端发生异常', '2019-07-22 17:33:19');
INSERT INTO `access_log` VALUES (57645, '65.51.15637879987106345', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.238.135.244', '2019-07-22 17:33:19', 9, 0, '', '2019-07-22 17:33:19');
INSERT INTO `access_log` VALUES (57646, '65.46.15637885706536351', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-22 17:42:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 17:42:51');
INSERT INTO `access_log` VALUES (57647, '65.49.15637885738606255', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-22 17:42:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 17:42:54');
INSERT INTO `access_log` VALUES (57648, '65.52.15637885826176319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-22 17:43:03', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 17:43:03');
INSERT INTO `access_log` VALUES (57649, '65.45.15637885847006277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-22 17:43:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 17:43:05');
INSERT INTO `access_log` VALUES (57650, '65.50.15637886065396301', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.247.104.77', '2019-07-22 17:43:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 17:43:27');
INSERT INTO `access_log` VALUES (57651, '65.49.15637889674506261', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:49:27', 0, 1002001015, '账号未登陆', '2019-07-22 17:49:27');
INSERT INTO `access_log` VALUES (57652, '65.52.15637889674576325', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:49:27', 0, 1002001015, '账号未登陆', '2019-07-22 17:49:27');
INSERT INTO `access_log` VALUES (57653, '65.45.15637889674576283', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:49:27', 0, 1002001015, '账号未登陆', '2019-07-22 17:49:27');
INSERT INTO `access_log` VALUES (57654, '65.54.15637889701876215', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:49:30', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 17:49:30');
INSERT INTO `access_log` VALUES (57655, '65.47.15637889734366275', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:49:33', 68, 0, '', '2019-07-22 17:49:34');
INSERT INTO `access_log` VALUES (57656, '65.50.15637889736816307', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:49:34', 9, 0, '', '2019-07-22 17:49:34');
INSERT INTO `access_log` VALUES (57657, '65.53.15637889736916285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:49:34', 9, 2001001000, '服务端发生异常', '2019-07-22 17:49:34');
INSERT INTO `access_log` VALUES (57658, '65.51.15637889736956361', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:49:34', 8, 0, '', '2019-07-22 17:49:34');
INSERT INTO `access_log` VALUES (57659, '65.45.15637890043596285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 17:50:04');
INSERT INTO `access_log` VALUES (57660, '65.52.15637890087616327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:09', 350, 0, '', '2019-07-22 17:50:09');
INSERT INTO `access_log` VALUES (57661, '65.54.15637890092676217', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:09', 10, 0, '', '2019-07-22 17:50:09');
INSERT INTO `access_log` VALUES (57662, '65.50.15637890092736309', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:09', 9, 0, '', '2019-07-22 17:50:09');
INSERT INTO `access_log` VALUES (57663, '65.47.15637890092726277', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:09', 9, 0, '', '2019-07-22 17:50:09');
INSERT INTO `access_log` VALUES (57664, '62.84.15637890150203151', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:15', 22, 0, '', '2019-07-22 17:50:15');
INSERT INTO `access_log` VALUES (57665, '64.81.15637890233774305', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:23', 12, 0, '', '2019-07-22 17:50:23');
INSERT INTO `access_log` VALUES (57666, '64.82.15637890233814323', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:23', 9, 0, '', '2019-07-22 17:50:23');
INSERT INTO `access_log` VALUES (57667, '64.80.15637890292804315', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:29', 13, 0, '', '2019-07-22 17:50:29');
INSERT INTO `access_log` VALUES (57668, '64.77.15637890292834295', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:29', 10, 0, '', '2019-07-22 17:50:29');
INSERT INTO `access_log` VALUES (57669, '66.48.15637890350841949', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:35', 34, 0, '', '2019-07-22 17:50:35');
INSERT INTO `access_log` VALUES (57670, '59.73.15637890439284099', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:44', 3, 0, '', '2019-07-22 17:50:44');
INSERT INTO `access_log` VALUES (57671, '59.71.15637890439284095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:44', 12, 2001001000, '服务端发生异常', '2019-07-22 17:50:44');
INSERT INTO `access_log` VALUES (57672, '64.83.15637890499304309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:50', 12, 0, '', '2019-07-22 17:50:50');
INSERT INTO `access_log` VALUES (57673, '64.85.15637890500264337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:50', 4, 0, '', '2019-07-22 17:50:50');
INSERT INTO `access_log` VALUES (57674, '64.76.15637890513924309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:51', 3, 0, '', '2019-07-22 17:50:51');
INSERT INTO `access_log` VALUES (57675, '64.84.15637890524584303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '180.168.56.210', '2019-07-22 17:50:52', 1, 0, '', '2019-07-22 17:50:52');
INSERT INTO `access_log` VALUES (57676, '59.78.15637896400984103', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:00:40', 3, 0, '', '2019-07-22 18:00:40');
INSERT INTO `access_log` VALUES (57677, '59.80.15637896400984083', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:00:40', 13, 2001001000, '服务端发生异常', '2019-07-22 18:00:40');
INSERT INTO `access_log` VALUES (57678, '64.84.15637896442914311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:00:44', 3, 0, '', '2019-07-22 18:00:44');
INSERT INTO `access_log` VALUES (57679, '64.82.15637896443904333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:00:44', 2, 0, '', '2019-07-22 18:00:44');
INSERT INTO `access_log` VALUES (57680, '64.81.15637896478194315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:00:48', 2, 0, '', '2019-07-22 18:00:48');
INSERT INTO `access_log` VALUES (57681, '64.80.15637896479544325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:00:48', 2, 0, '', '2019-07-22 18:00:48');
INSERT INTO `access_log` VALUES (57682, '59.77.15637896490494093', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:00:49', 3, 0, '', '2019-07-22 18:00:49');
INSERT INTO `access_log` VALUES (57683, '59.76.15637896490494095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:00:49', 13, 2001001000, '服务端发生异常', '2019-07-22 18:00:49');
INSERT INTO `access_log` VALUES (57684, '59.75.15637896710174111', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:11', 3, 0, '', '2019-07-22 18:01:11');
INSERT INTO `access_log` VALUES (57685, '59.72.15637896710174101', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:11', 13, 2001001000, '服务端发生异常', '2019-07-22 18:01:11');
INSERT INTO `access_log` VALUES (57686, '64.83.15637896768274319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:17', 2, 0, '', '2019-07-22 18:01:17');
INSERT INTO `access_log` VALUES (57687, '64.85.15637896769444347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:17', 2, 0, '', '2019-07-22 18:01:17');
INSERT INTO `access_log` VALUES (57688, '64.78.15637896780534331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:18', 2, 0, '', '2019-07-22 18:01:18');
INSERT INTO `access_log` VALUES (57689, '64.76.15637896785584319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:19', 2, 0, '', '2019-07-22 18:01:19');
INSERT INTO `access_log` VALUES (57690, '64.84.15637896791814313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:19', 2, 0, '', '2019-07-22 18:01:19');
INSERT INTO `access_log` VALUES (57691, '59.73.15637896811674109', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:21', 2, 0, '', '2019-07-22 18:01:21');
INSERT INTO `access_log` VALUES (57692, '59.78.15637896811684105', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:21', 11, 2001001000, '服务端发生异常', '2019-07-22 18:01:21');
INSERT INTO `access_log` VALUES (57693, '64.81.15637896843314317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:24', 2, 0, '', '2019-07-22 18:01:24');
INSERT INTO `access_log` VALUES (57694, '64.80.15637896844864327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:24', 2, 0, '', '2019-07-22 18:01:24');
INSERT INTO `access_log` VALUES (57695, '64.79.15637896970264327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:37', 2, 0, '', '2019-07-22 18:01:37');
INSERT INTO `access_log` VALUES (57696, '64.83.15637896971264321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:37', 2, 0, '', '2019-07-22 18:01:37');
INSERT INTO `access_log` VALUES (57697, '59.79.15637896975624109', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:38', 3, 0, '', '2019-07-22 18:01:38');
INSERT INTO `access_log` VALUES (57698, '59.76.15637896975624097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:38', 12, 2001001000, '服务端发生异常', '2019-07-22 18:01:38');
INSERT INTO `access_log` VALUES (57699, '64.85.15637896980274349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:38', 2, 0, '', '2019-07-22 18:01:38');
INSERT INTO `access_log` VALUES (57700, '64.78.15637896981604333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:38', 2, 0, '', '2019-07-22 18:01:38');
INSERT INTO `access_log` VALUES (57701, '59.77.15637896985584095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:39', 2, 0, '', '2019-07-22 18:01:39');
INSERT INTO `access_log` VALUES (57702, '59.74.15637896985584115', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:39', 12, 2001001000, '服务端发生异常', '2019-07-22 18:01:39');
INSERT INTO `access_log` VALUES (57703, '64.76.15637896990344321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:39', 2, 0, '', '2019-07-22 18:01:39');
INSERT INTO `access_log` VALUES (57704, '64.84.15637896991364315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:39', 2, 0, '', '2019-07-22 18:01:39');
INSERT INTO `access_log` VALUES (57705, '59.75.15637896995284113', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:40', 2, 0, '', '2019-07-22 18:01:40');
INSERT INTO `access_log` VALUES (57706, '59.72.15637896995284103', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '1.80.217.255', '2019-07-22 18:01:40', 12, 2001001000, '服务端发生异常', '2019-07-22 18:01:40');
INSERT INTO `access_log` VALUES (57707, '59.74.15637914617674139', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.52.210.206', '2019-07-22 18:31:02', 4, 0, '', '2019-07-22 18:31:02');
INSERT INTO `access_log` VALUES (57708, '59.75.15637914617704137', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '110.52.210.206', '2019-07-22 18:31:02', 19, 2001001000, '服务端发生异常', '2019-07-22 18:31:02');
INSERT INTO `access_log` VALUES (57709, '59.71.15637920781944139', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:18', 3, 0, '', '2019-07-22 18:41:18');
INSERT INTO `access_log` VALUES (57710, '59.73.15637920781944143', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:18', 15, 2001001000, '服务端发生异常', '2019-07-22 18:41:18');
INSERT INTO `access_log` VALUES (57711, '64.84.15637920837674347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:24', 12, 0, '', '2019-07-22 18:41:24');
INSERT INTO `access_log` VALUES (57712, '64.82.15637920840054369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:24', 3, 0, '', '2019-07-22 18:41:24');
INSERT INTO `access_log` VALUES (57713, '64.81.15637920875194351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:28', 2, 0, '', '2019-07-22 18:41:28');
INSERT INTO `access_log` VALUES (57714, '64.80.15637920905624361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:31', 2, 0, '', '2019-07-22 18:41:31');
INSERT INTO `access_log` VALUES (57715, '65.49.15637920951056305', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:35', 3, 1002001012, '访问令牌已过期', '2019-07-22 18:41:35');
INSERT INTO `access_log` VALUES (57716, '65.52.15637920951066369', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:35', 10, 1002001012, '访问令牌已过期', '2019-07-22 18:41:35');
INSERT INTO `access_log` VALUES (57717, '65.47.15637920951076319', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:35', 10, 1002001012, '访问令牌已过期', '2019-07-22 18:41:35');
INSERT INTO `access_log` VALUES (57718, '65.50.15637921013876351', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:41', 58, 0, '', '2019-07-22 18:41:41');
INSERT INTO `access_log` VALUES (57719, '65.51.15637921021006405', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:42', 11, 2001001000, '服务端发生异常', '2019-07-22 18:41:42');
INSERT INTO `access_log` VALUES (57720, '65.53.15637921021006329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:42', 10, 0, '', '2019-07-22 18:41:42');
INSERT INTO `access_log` VALUES (57721, '65.46.15637921021006403', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:42', 11, 0, '', '2019-07-22 18:41:42');
INSERT INTO `access_log` VALUES (57722, '65.3607.15637921138378135', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:54', 9, 0, '', '2019-07-22 18:41:54');
INSERT INTO `access_log` VALUES (57723, '65.45.15637921138416329', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:54', 16, 2001001000, '服务端发生异常', '2019-07-22 18:41:54');
INSERT INTO `access_log` VALUES (57724, '65.49.15637921138446307', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:54', 16, 0, '', '2019-07-22 18:41:54');
INSERT INTO `access_log` VALUES (57725, '65.47.15637921182856321', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:41:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 18:41:58');
INSERT INTO `access_log` VALUES (57726, '65.54.15637921211866261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-22 18:42:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 18:42:01');
INSERT INTO `access_log` VALUES (57727, '65.53.15637990430606423', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.237.208', '2019-07-22 20:37:23', 1, 1002001015, '账号未登陆', '2019-07-22 20:37:23');
INSERT INTO `access_log` VALUES (57728, '65.46.15637990430606497', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.237.208', '2019-07-22 20:37:23', 1, 1002001015, '账号未登陆', '2019-07-22 20:37:23');
INSERT INTO `access_log` VALUES (57729, '65.51.15637990430606499', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.237.208', '2019-07-22 20:37:23', 0, 1002001015, '账号未登陆', '2019-07-22 20:37:23');
INSERT INTO `access_log` VALUES (57730, '65.45.15637990450376423', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.237.208', '2019-07-22 20:37:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-22 20:37:25');
INSERT INTO `access_log` VALUES (57731, '65.52.15637990548606465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.237.208', '2019-07-22 20:37:35', 396, 0, '', '2019-07-22 20:37:35');
INSERT INTO `access_log` VALUES (57732, '65.49.15637990556066401', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.237.208', '2019-07-22 20:37:36', 12, 0, '', '2019-07-22 20:37:36');
INSERT INTO `access_log` VALUES (57733, '65.47.15637990556076415', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.237.208', '2019-07-22 20:37:36', 12, 2001001000, '服务端发生异常', '2019-07-22 20:37:36');
INSERT INTO `access_log` VALUES (57734, '65.54.15637990556086355', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.89.237.208', '2019-07-22 20:37:36', 12, 0, '', '2019-07-22 20:37:36');
INSERT INTO `access_log` VALUES (57735, '65.47.15638015914046449', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '120.239.72.97', '2019-07-22 21:19:51', 0, 1002001015, '账号未登陆', '2019-07-22 21:19:51');
INSERT INTO `access_log` VALUES (57736, '65.49.15638015914046435', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '120.239.72.97', '2019-07-22 21:19:51', 0, 1002001015, '账号未登陆', '2019-07-22 21:19:51');
INSERT INTO `access_log` VALUES (57737, '65.53.15638015914066461', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '120.239.72.97', '2019-07-22 21:19:51', 0, 1002001015, '账号未登陆', '2019-07-22 21:19:51');
INSERT INTO `access_log` VALUES (57738, '65.46.15638016027396535', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '120.239.72.97', '2019-07-22 21:20:03', 140, 0, '', '2019-07-22 21:20:03');
INSERT INTO `access_log` VALUES (57739, '65.45.15638016031906459', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '120.239.72.97', '2019-07-22 21:20:03', 112, 0, '', '2019-07-22 21:20:03');
INSERT INTO `access_log` VALUES (57740, '65.50.15638016031976483', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '120.239.72.97', '2019-07-22 21:20:03', 107, 0, '', '2019-07-22 21:20:03');
INSERT INTO `access_log` VALUES (57741, '65.3607.15638016031928265', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '120.239.72.97', '2019-07-22 21:20:03', 114, 2001001000, '服务端发生异常', '2019-07-22 21:20:03');
INSERT INTO `access_log` VALUES (57742, '65.52.15638332092496923', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.219.91', '2019-07-23 06:06:49', 0, 1002001015, '账号未登陆', '2019-07-23 06:06:49');
INSERT INTO `access_log` VALUES (57743, '65.45.15638332092506881', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.219.91', '2019-07-23 06:06:49', 0, 1002001015, '账号未登陆', '2019-07-23 06:06:49');
INSERT INTO `access_log` VALUES (57744, '65.50.15638332092496903', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.219.91', '2019-07-23 06:06:49', 0, 1002001015, '账号未登陆', '2019-07-23 06:06:49');
INSERT INTO `access_log` VALUES (57745, '65.51.15638332146646957', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.219.91', '2019-07-23 06:06:55', 98, 0, '', '2019-07-23 06:06:55');
INSERT INTO `access_log` VALUES (57746, '65.54.15638332149816817', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.219.91', '2019-07-23 06:06:55', 175, 0, '', '2019-07-23 06:06:55');
INSERT INTO `access_log` VALUES (57747, '65.46.15638332149796959', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.219.91', '2019-07-23 06:06:55', 178, 2001001000, '服务端发生异常', '2019-07-23 06:06:55');
INSERT INTO `access_log` VALUES (57748, '65.49.15638332149786861', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.219.91', '2019-07-23 06:06:55', 178, 0, '', '2019-07-23 06:06:55');
INSERT INTO `access_log` VALUES (57749, '65.53.15638332404626885', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.67.219.91', '2019-07-23 06:07:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 06:07:20');
INSERT INTO `access_log` VALUES (57750, '65.47.15638340867446887', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.234.61', '2019-07-23 06:21:27', 4, 1002001012, '访问令牌已过期', '2019-07-23 06:21:27');
INSERT INTO `access_log` VALUES (57751, '65.3607.15638340867468701', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.234.61', '2019-07-23 06:21:27', 3, 1002001012, '访问令牌已过期', '2019-07-23 06:21:27');
INSERT INTO `access_log` VALUES (57752, '65.49.15638340867616875', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.234.61', '2019-07-23 06:21:27', 4, 1002001012, '访问令牌已过期', '2019-07-23 06:21:27');
INSERT INTO `access_log` VALUES (57753, '65.53.15638340899816899', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.234.61', '2019-07-23 06:21:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 06:21:30');
INSERT INTO `access_log` VALUES (57754, '65.54.15638341042376831', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.234.61', '2019-07-23 06:21:44', 61, 0, '', '2019-07-23 06:21:44');
INSERT INTO `access_log` VALUES (57755, '65.51.15638341047046973', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.234.61', '2019-07-23 06:21:45', 10, 0, '', '2019-07-23 06:21:45');
INSERT INTO `access_log` VALUES (57756, '65.52.15638341047056939', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.234.61', '2019-07-23 06:21:45', 11, 0, '', '2019-07-23 06:21:45');
INSERT INTO `access_log` VALUES (57757, '65.45.15638341047046897', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.234.61', '2019-07-23 06:21:45', 12, 2001001000, '服务端发生异常', '2019-07-23 06:21:45');
INSERT INTO `access_log` VALUES (57758, '65.50.15638343383316921', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.234.61', '2019-07-23 06:25:38', 10, 0, '', '2019-07-23 06:25:38');
INSERT INTO `access_log` VALUES (57759, '65.54.15638343383336835', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.234.61', '2019-07-23 06:25:38', 18, 2001001000, '服务端发生异常', '2019-07-23 06:25:38');
INSERT INTO `access_log` VALUES (57760, '65.45.15638343383616901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.234.61', '2019-07-23 06:25:38', 9, 0, '', '2019-07-23 06:25:38');
INSERT INTO `access_log` VALUES (57761, '65.51.15638343516216977', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.234.61', '2019-07-23 06:25:52', 10, 2001001000, '服务端发生异常', '2019-07-23 06:25:52');
INSERT INTO `access_log` VALUES (57762, '65.46.15638343516246977', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.234.61', '2019-07-23 06:25:52', 9, 0, '', '2019-07-23 06:25:52');
INSERT INTO `access_log` VALUES (57763, '65.3607.15638343516258707', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.234.234.61', '2019-07-23 06:25:52', 8, 0, '', '2019-07-23 06:25:52');
INSERT INTO `access_log` VALUES (57764, '65.45.15638408228246989', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.4', '2019-07-23 08:13:43', 31, 1002001012, '访问令牌已过期', '2019-07-23 08:13:43');
INSERT INTO `access_log` VALUES (57765, '65.54.15638408228246925', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.4', '2019-07-23 08:13:43', 21, 1002001012, '访问令牌已过期', '2019-07-23 08:13:43');
INSERT INTO `access_log` VALUES (57766, '65.47.15638408228546981', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.4', '2019-07-23 08:13:43', 3, 1002001012, '访问令牌已过期', '2019-07-23 08:13:43');
INSERT INTO `access_log` VALUES (57767, '65.46.15638408293277065', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.4', '2019-07-23 08:13:49', 85, 0, '', '2019-07-23 08:13:49');
INSERT INTO `access_log` VALUES (57768, '65.49.15638408296536969', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.4', '2019-07-23 08:13:50', 15, 0, '', '2019-07-23 08:13:50');
INSERT INTO `access_log` VALUES (57769, '65.52.15638408296567031', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.4', '2019-07-23 08:13:50', 17, 2001001000, '服务端发生异常', '2019-07-23 08:13:50');
INSERT INTO `access_log` VALUES (57770, '65.50.15638408296567011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.4', '2019-07-23 08:13:50', 18, 0, '', '2019-07-23 08:13:50');
INSERT INTO `access_log` VALUES (57771, '65.3607.15638408399428795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.4', '2019-07-23 08:14:00', 17, 0, '', '2019-07-23 08:14:00');
INSERT INTO `access_log` VALUES (57772, '65.45.15638408399526991', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.4', '2019-07-23 08:14:00', 8, 0, '', '2019-07-23 08:14:00');
INSERT INTO `access_log` VALUES (57773, '65.53.15638408399526993', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.4', '2019-07-23 08:14:00', 10, 2001001000, '服务端发生异常', '2019-07-23 08:14:00');
INSERT INTO `access_log` VALUES (57774, '59.78.15638452971284849', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-23 09:28:17', 17, 0, '', '2019-07-23 09:28:17');
INSERT INTO `access_log` VALUES (57775, '59.79.15638452971294853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.71.50', '2019-07-23 09:28:17', 30, 2001001000, '服务端发生异常', '2019-07-23 09:28:17');
INSERT INTO `access_log` VALUES (57776, '59.73.15638455333484857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 09:32:13', 5, 0, '', '2019-07-23 09:32:13');
INSERT INTO `access_log` VALUES (57777, '59.80.15638455333474831', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 09:32:13', 19, 2001001000, '服务端发生异常', '2019-07-23 09:32:13');
INSERT INTO `access_log` VALUES (57778, '64.78.15638455449075079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.22.44.252', '2019-07-23 09:32:25', 13, 0, '', '2019-07-23 09:32:25');
INSERT INTO `access_log` VALUES (57779, '64.76.15638455450205067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.22.44.252', '2019-07-23 09:32:25', 3, 0, '', '2019-07-23 09:32:25');
INSERT INTO `access_log` VALUES (57780, '66.50.15638455472922685', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.22.44.252', '2019-07-23 09:32:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-07-23 09:32:27');
INSERT INTO `access_log` VALUES (57781, '65.45.15638456384387057', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.167.30.144', '2019-07-23 09:33:58', 1, 1002001015, '账号未登陆', '2019-07-23 09:33:58');
INSERT INTO `access_log` VALUES (57782, '65.53.15638456384387057', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.167.30.144', '2019-07-23 09:33:58', 1, 1002001015, '账号未登陆', '2019-07-23 09:33:58');
INSERT INTO `access_log` VALUES (57783, '65.54.15638456384416993', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.167.30.144', '2019-07-23 09:33:58', 1, 1002001015, '账号未登陆', '2019-07-23 09:33:58');
INSERT INTO `access_log` VALUES (57784, '65.47.15638456448797047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.167.30.144', '2019-07-23 09:34:05', 92, 0, '', '2019-07-23 09:34:05');
INSERT INTO `access_log` VALUES (57785, '65.46.15638456451557131', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.167.30.144', '2019-07-23 09:34:05', 10, 0, '', '2019-07-23 09:34:05');
INSERT INTO `access_log` VALUES (57786, '65.52.15638456451597097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.167.30.144', '2019-07-23 09:34:05', 9, 0, '', '2019-07-23 09:34:05');
INSERT INTO `access_log` VALUES (57787, '65.50.15638456451597079', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.167.30.144', '2019-07-23 09:34:05', 9, 2001001000, '服务端发生异常', '2019-07-23 09:34:05');
INSERT INTO `access_log` VALUES (57788, '65.52.15638473011267121', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:01:41', 0, 1002001015, '账号未登陆', '2019-07-23 10:01:41');
INSERT INTO `access_log` VALUES (57789, '65.51.15638473011277155', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:01:41', 1, 1002001015, '账号未登陆', '2019-07-23 10:01:41');
INSERT INTO `access_log` VALUES (57790, '65.3607.15638473011278885', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:01:41', 0, 1002001015, '账号未登陆', '2019-07-23 10:01:41');
INSERT INTO `access_log` VALUES (57791, '65.49.15638473025157059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:01:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 10:01:43');
INSERT INTO `access_log` VALUES (57792, '65.53.15638473085217083', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:01:49', 75, 0, '', '2019-07-23 10:01:49');
INSERT INTO `access_log` VALUES (57793, '65.54.15638473088197017', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:01:49', 18, 0, '', '2019-07-23 10:01:49');
INSERT INTO `access_log` VALUES (57794, '65.45.15638473088227083', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:01:49', 19, 2001001000, '服务端发生异常', '2019-07-23 10:01:49');
INSERT INTO `access_log` VALUES (57795, '65.47.15638473088237073', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:01:49', 18, 0, '', '2019-07-23 10:01:49');
INSERT INTO `access_log` VALUES (57796, '65.46.15638473205197157', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:02:01', 11, 0, '', '2019-07-23 10:02:01');
INSERT INTO `access_log` VALUES (57797, '65.51.15638473205217157', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:02:01', 10, 0, '', '2019-07-23 10:02:01');
INSERT INTO `access_log` VALUES (57798, '65.52.15638473205217123', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:02:01', 10, 2001001000, '服务端发生异常', '2019-07-23 10:02:01');
INSERT INTO `access_log` VALUES (57799, '65.49.15638473321067061', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:02:12', 89, 0, '', '2019-07-23 10:02:12');
INSERT INTO `access_log` VALUES (57800, '65.53.15638473324037085', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:02:12', 9, 0, '', '2019-07-23 10:02:12');
INSERT INTO `access_log` VALUES (57801, '65.45.15638473324057085', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:02:12', 9, 0, '', '2019-07-23 10:02:12');
INSERT INTO `access_log` VALUES (57802, '65.47.15638473324047075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:02:12', 10, 2001001000, '服务端发生异常', '2019-07-23 10:02:12');
INSERT INTO `access_log` VALUES (57803, '65.50.15638473458757105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:02:26', 10, 0, '', '2019-07-23 10:02:26');
INSERT INTO `access_log` VALUES (57804, '65.46.15638473458787159', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:02:26', 10, 2001001000, '服务端发生异常', '2019-07-23 10:02:26');
INSERT INTO `access_log` VALUES (57805, '65.51.15638473458827159', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.22.44.252', '2019-07-23 10:02:26', 9, 0, '', '2019-07-23 10:02:26');
INSERT INTO `access_log` VALUES (57806, '59.79.15638485421174897', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.97.145.139', '2019-07-23 10:22:22', 10, 0, '', '2019-07-23 10:22:22');
INSERT INTO `access_log` VALUES (57807, '59.76.15638485421274885', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.97.145.139', '2019-07-23 10:22:22', 16, 2001001000, '服务端发生异常', '2019-07-23 10:22:22');
INSERT INTO `access_log` VALUES (57808, '59.75.15638485718314901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36 OPR/62.0.3331.72', '223.223.183.2', '2019-07-23 10:22:52', 4, 0, '', '2019-07-23 10:22:52');
INSERT INTO `access_log` VALUES (57809, '59.71.15638485719494893', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36 OPR/62.0.3331.72', '223.223.183.2', '2019-07-23 10:22:52', 12, 2001001000, '服务端发生异常', '2019-07-23 10:22:52');
INSERT INTO `access_log` VALUES (57810, '65.51.15638486508347177', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36 OPR/62.0.3331.72', '223.223.183.2', '2019-07-23 10:24:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 10:24:11');
INSERT INTO `access_log` VALUES (57811, '59.79.15638493798854909', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.107.134.128', '2019-07-23 10:36:20', 3, 0, '', '2019-07-23 10:36:20');
INSERT INTO `access_log` VALUES (57812, '59.76.15638493798844897', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.107.134.128', '2019-07-23 10:36:20', 13, 2001001000, '服务端发生异常', '2019-07-23 10:36:20');
INSERT INTO `access_log` VALUES (57813, '65.49.15638493872727093', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.107.134.128', '2019-07-23 10:36:27', 1, 1002001015, '账号未登陆', '2019-07-23 10:36:27');
INSERT INTO `access_log` VALUES (57814, '65.45.15638493872777113', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.107.134.128', '2019-07-23 10:36:27', 1, 1002001015, '账号未登陆', '2019-07-23 10:36:27');
INSERT INTO `access_log` VALUES (57815, '65.53.15638493872947115', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.107.134.128', '2019-07-23 10:36:27', 1, 1002001015, '账号未登陆', '2019-07-23 10:36:27');
INSERT INTO `access_log` VALUES (57816, '65.51.15638493893047189', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.107.134.128', '2019-07-23 10:36:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 10:36:29');
INSERT INTO `access_log` VALUES (57817, '65.54.15638494028327047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.107.134.128', '2019-07-23 10:36:43', 77, 0, '', '2019-07-23 10:36:43');
INSERT INTO `access_log` VALUES (57818, '65.46.15638494032217189', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.107.134.128', '2019-07-23 10:36:43', 10, 0, '', '2019-07-23 10:36:43');
INSERT INTO `access_log` VALUES (57819, '65.52.15638494032257155', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.107.134.128', '2019-07-23 10:36:43', 10, 2001001000, '服务端发生异常', '2019-07-23 10:36:43');
INSERT INTO `access_log` VALUES (57820, '65.3607.15638494032308919', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.107.134.128', '2019-07-23 10:36:43', 9, 0, '', '2019-07-23 10:36:43');
INSERT INTO `access_log` VALUES (57821, '65.47.15638497100537111', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.107.134.128', '2019-07-23 10:41:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 10:41:50');
INSERT INTO `access_log` VALUES (57822, '59.72.15638503478984915', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:52:28', 3, 0, '', '2019-07-23 10:52:28');
INSERT INTO `access_log` VALUES (57823, '59.80.15638503479054897', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:52:28', 19, 2001001000, '服务端发生异常', '2019-07-23 10:52:28');
INSERT INTO `access_log` VALUES (57824, '59.78.15638503548094919', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:52:35', 3, 0, '', '2019-07-23 10:52:35');
INSERT INTO `access_log` VALUES (57825, '59.79.15638503548094923', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:52:35', 13, 2001001000, '服务端发生异常', '2019-07-23 10:52:35');
INSERT INTO `access_log` VALUES (57826, '64.82.15638503610795147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:52:41', 12, 0, '', '2019-07-23 10:52:41');
INSERT INTO `access_log` VALUES (57827, '64.81.15638503611875129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:52:41', 3, 0, '', '2019-07-23 10:52:41');
INSERT INTO `access_log` VALUES (57828, '64.80.15638503644115139', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:52:44', 2, 0, '', '2019-07-23 10:52:44');
INSERT INTO `access_log` VALUES (57829, '64.77.15638503645355119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:52:45', 3, 0, '', '2019-07-23 10:52:45');
INSERT INTO `access_log` VALUES (57830, '65.54.15638503834737061', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:53:03', 1, 1002001015, '账号未登陆', '2019-07-23 10:53:03');
INSERT INTO `access_log` VALUES (57831, '65.3607.15638503834838933', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:53:03', 0, 1002001015, '账号未登陆', '2019-07-23 10:53:03');
INSERT INTO `access_log` VALUES (57832, '65.52.15638503834947169', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:53:03', 0, 1002001015, '账号未登陆', '2019-07-23 10:53:03');
INSERT INTO `access_log` VALUES (57833, '65.47.15638503912157121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin &password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:53:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位\n账号格式为数字以及字母', '2019-07-23 10:53:11');
INSERT INTO `access_log` VALUES (57834, '65.49.15638503962077109', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:53:16', 73, 0, '', '2019-07-23 10:53:16');
INSERT INTO `access_log` VALUES (57835, '65.45.15638503965297129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:53:17', 9, 0, '', '2019-07-23 10:53:17');
INSERT INTO `access_log` VALUES (57836, '65.53.15638503965467131', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:53:17', 10, 2001001000, '服务端发生异常', '2019-07-23 10:53:17');
INSERT INTO `access_log` VALUES (57837, '65.51.15638503965507205', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '116.247.112.152', '2019-07-23 10:53:17', 8, 0, '', '2019-07-23 10:53:17');
INSERT INTO `access_log` VALUES (57838, '65.49.15638513849007123', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:09:45', 0, 1002001015, '账号未登陆', '2019-07-23 11:09:45');
INSERT INTO `access_log` VALUES (57839, '65.51.15638513849237219', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:09:45', 1, 1002001015, '账号未登陆', '2019-07-23 11:09:45');
INSERT INTO `access_log` VALUES (57840, '65.45.15638513849557143', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:09:45', 1, 1002001015, '账号未登陆', '2019-07-23 11:09:45');
INSERT INTO `access_log` VALUES (57841, '65.53.15638513889287145', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:09:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 11:09:49');
INSERT INTO `access_log` VALUES (57842, '65.50.15638513936907167', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:09:54', 317, 0, '', '2019-07-23 11:09:54');
INSERT INTO `access_log` VALUES (57843, '65.3607.15638513943408949', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:09:54', 18, 0, '', '2019-07-23 11:09:54');
INSERT INTO `access_log` VALUES (57844, '65.54.15638513943557077', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:09:54', 9, 0, '', '2019-07-23 11:09:54');
INSERT INTO `access_log` VALUES (57845, '65.46.15638513943567219', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:09:54', 9, 0, '', '2019-07-23 11:09:54');
INSERT INTO `access_log` VALUES (57846, '62.88.15638514073124001', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:10:07', 206, 0, '', '2019-07-23 11:10:08');
INSERT INTO `access_log` VALUES (57847, '62.89.15638514463124015', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:10:46', 17, 0, '', '2019-07-23 11:10:46');
INSERT INTO `access_log` VALUES (57848, '62.83.15638514527274015', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:10:53', 23, 0, '', '2019-07-23 11:10:53');
INSERT INTO `access_log` VALUES (57849, '64.78.15638514584885159', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:10:58', 15, 0, '', '2019-07-23 11:10:59');
INSERT INTO `access_log` VALUES (57850, '64.76.15638514584895147', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:10:58', 19, 0, '', '2019-07-23 11:10:59');
INSERT INTO `access_log` VALUES (57851, '59.78.15638516848214937', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:14:45', 18, 0, '', '2019-07-23 11:14:45');
INSERT INTO `access_log` VALUES (57852, '65.47.15638516972037141', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:14:57', 26, 0, '', '2019-07-23 11:14:57');
INSERT INTO `access_log` VALUES (57853, '65.49.15638517036477129', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:15:04', 19, 0, '', '2019-07-23 11:15:04');
INSERT INTO `access_log` VALUES (57854, '65.51.15638517041377225', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '111.38.219.240', '2019-07-23 11:15:04', 0, 1002001015, '账号未登陆', '2019-07-23 11:15:04');
INSERT INTO `access_log` VALUES (57855, '65.45.15638517041567149', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '111.38.219.240', '2019-07-23 11:15:04', 0, 1002001015, '账号未登陆', '2019-07-23 11:15:04');
INSERT INTO `access_log` VALUES (57856, '65.53.15638517041567151', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '111.38.219.240', '2019-07-23 11:15:04', 1, 1002001015, '账号未登陆', '2019-07-23 11:15:04');
INSERT INTO `access_log` VALUES (57857, '65.52.15638517067967191', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:15:07', 10, 0, '', '2019-07-23 11:15:07');
INSERT INTO `access_log` VALUES (57858, '65.50.15638517087737173', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '111.38.219.240', '2019-07-23 11:15:09', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 11:15:09');
INSERT INTO `access_log` VALUES (57859, '65.54.15638517147587083', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:15:15', 14, 0, '', '2019-07-23 11:15:15');
INSERT INTO `access_log` VALUES (57860, '59.74.15638517266814947', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:15:27', 10, 0, '', '2019-07-23 11:15:27');
INSERT INTO `access_log` VALUES (57861, '59.75.15638517287494945', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:15:29', 16, 0, '', '2019-07-23 11:15:29');
INSERT INTO `access_log` VALUES (57862, '64.76.15638517387415151', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:15:39', 15, 0, '', '2019-07-23 11:15:39');
INSERT INTO `access_log` VALUES (57863, '64.82.15638517513565167', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:15:51', 13, 0, '', '2019-07-23 11:15:51');
INSERT INTO `access_log` VALUES (57864, '65.51.15638517907657227', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; INE-AL00 Build/HUAWEIINE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/2293 MicroMessenger/7.0.5.1440(0x27000537) Process/tools NetType/WIFI Language/zh_CN', '111.38.219.240', '2019-07-23 11:16:31', 1, 1002001015, '账号未登陆', '2019-07-23 11:16:31');
INSERT INTO `access_log` VALUES (57865, '65.52.15638517907737193', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; INE-AL00 Build/HUAWEIINE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/2293 MicroMessenger/7.0.5.1440(0x27000537) Process/tools NetType/WIFI Language/zh_CN', '111.38.219.240', '2019-07-23 11:16:31', 1, 1002001015, '账号未登陆', '2019-07-23 11:16:31');
INSERT INTO `access_log` VALUES (57866, '65.50.15638517907857175', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; INE-AL00 Build/HUAWEIINE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/2293 MicroMessenger/7.0.5.1440(0x27000537) Process/tools NetType/WIFI Language/zh_CN', '111.38.219.240', '2019-07-23 11:16:31', 0, 1002001015, '账号未登陆', '2019-07-23 11:16:31');
INSERT INTO `access_log` VALUES (57867, '65.47.15638518293157145', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '111.38.219.240', '2019-07-23 11:17:09', 74, 0, '', '2019-07-23 11:17:09');
INSERT INTO `access_log` VALUES (57868, '65.49.15638518297017133', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '111.38.219.240', '2019-07-23 11:17:10', 9, 0, '', '2019-07-23 11:17:10');
INSERT INTO `access_log` VALUES (57869, '65.53.15638518297017155', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '111.38.219.240', '2019-07-23 11:17:10', 10, 2001001000, '服务端发生异常', '2019-07-23 11:17:10');
INSERT INTO `access_log` VALUES (57870, '65.45.15638518297487153', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '111.38.219.240', '2019-07-23 11:17:10', 9, 0, '', '2019-07-23 11:17:10');
INSERT INTO `access_log` VALUES (57871, '65.54.15638519004317087', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:18:20', 10, 0, '', '2019-07-23 11:18:20');
INSERT INTO `access_log` VALUES (57872, '65.46.15638519004387229', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:18:20', 10, 0, '', '2019-07-23 11:18:20');
INSERT INTO `access_log` VALUES (57873, '65.47.15638519004447147', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:18:20', 9, 0, '', '2019-07-23 11:18:20');
INSERT INTO `access_log` VALUES (57874, '62.88.15638519423804009', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:19:02', 13, 0, '', '2019-07-23 11:19:02');
INSERT INTO `access_log` VALUES (57875, '59.79.15638519502814945', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.241.98', '2019-07-23 11:19:10', 12, 0, '', '2019-07-23 11:19:10');
INSERT INTO `access_log` VALUES (57876, '59.72.15638554780544985', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.237.154.211', '2019-07-23 12:17:58', 11, 0, '', '2019-07-23 12:17:58');
INSERT INTO `access_log` VALUES (57877, '59.80.15638554780554967', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.237.154.211', '2019-07-23 12:17:58', 34, 2001001000, '服务端发生异常', '2019-07-23 12:17:58');
INSERT INTO `access_log` VALUES (57878, '64.80.15638554842735209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.237.154.211', '2019-07-23 12:18:04', 12, 0, '', '2019-07-23 12:18:04');
INSERT INTO `access_log` VALUES (57879, '64.81.15638554844235199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.237.154.211', '2019-07-23 12:18:04', 3, 0, '', '2019-07-23 12:18:04');
INSERT INTO `access_log` VALUES (57880, '59.75.15638555623324997', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '211.97.128.160', '2019-07-23 12:19:22', 4, 0, '', '2019-07-23 12:19:22');
INSERT INTO `access_log` VALUES (57881, '59.71.15638555623454989', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '211.97.128.160', '2019-07-23 12:19:22', 20, 2001001000, '服务端发生异常', '2019-07-23 12:19:22');
INSERT INTO `access_log` VALUES (57882, '59.72.15638555707654987', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:31', 2, 0, '', '2019-07-23 12:19:31');
INSERT INTO `access_log` VALUES (57883, '59.80.15638555707564969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:31', 12, 2001001000, '服务端发生异常', '2019-07-23 12:19:31');
INSERT INTO `access_log` VALUES (57884, '64.82.15638555739385219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:34', 4, 0, '', '2019-07-23 12:19:34');
INSERT INTO `access_log` VALUES (57885, '64.77.15638555741725193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:34', 2, 0, '', '2019-07-23 12:19:34');
INSERT INTO `access_log` VALUES (57886, '64.81.15638555813405201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:41', 3, 0, '', '2019-07-23 12:19:41');
INSERT INTO `access_log` VALUES (57887, '64.85.15638555815525233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:42', 2, 0, '', '2019-07-23 12:19:42');
INSERT INTO `access_log` VALUES (57888, '64.83.15638555835425205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:44', 2, 0, '', '2019-07-23 12:19:44');
INSERT INTO `access_log` VALUES (57889, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:44', 6, 0, '', '2019-07-23 12:19:44');
INSERT INTO `access_log` VALUES (57890, '64.79.15638555853095211', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:45', 8, 0, '', '2019-07-23 12:19:45');
INSERT INTO `access_log` VALUES (57891, '64.76.15638555929345205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:53', 2, 0, '', '2019-07-23 12:19:53');
INSERT INTO `access_log` VALUES (57892, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:53', 6, 0, '', '2019-07-23 12:19:53');
INSERT INTO `access_log` VALUES (57893, '64.84.15638555936535201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:54', 2, 0, '', '2019-07-23 12:19:54');
INSERT INTO `access_log` VALUES (57894, '64.82.15638555938205221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:54', 2, 0, '', '2019-07-23 12:19:54');
INSERT INTO `access_log` VALUES (57895, '59.79.15638555944904995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:54', 2, 0, '', '2019-07-23 12:19:54');
INSERT INTO `access_log` VALUES (57896, '59.76.15638555945024983', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '211.97.128.160', '2019-07-23 12:19:55', 18, 2001001000, '服务端发生异常', '2019-07-23 12:19:55');
INSERT INTO `access_log` VALUES (57897, '59.80.15638592719595019', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.129.148.2', '2019-07-23 13:21:12', 10, 0, '', '2019-07-23 13:21:12');
INSERT INTO `access_log` VALUES (57898, '59.73.15638592719605045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.129.148.2', '2019-07-23 13:21:12', 15, 2001001000, '服务端发生异常', '2019-07-23 13:21:12');
INSERT INTO `access_log` VALUES (57899, '59.77.15638603543755047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:39:14', 4, 0, '', '2019-07-23 13:39:14');
INSERT INTO `access_log` VALUES (57900, '59.76.15638603543745047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:39:14', 17, 2001001000, '服务端发生异常', '2019-07-23 13:39:14');
INSERT INTO `access_log` VALUES (57901, '64.82.15638603779265285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:38', 13, 0, '', '2019-07-23 13:39:38');
INSERT INTO `access_log` VALUES (57902, '64.77.15638603780425259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:38', 3, 0, '', '2019-07-23 13:39:38');
INSERT INTO `access_log` VALUES (57903, '64.80.15638603801265277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:40', 2, 0, '', '2019-07-23 13:39:40');
INSERT INTO `access_log` VALUES (57904, '64.81.15638603810135267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:41', 2, 0, '', '2019-07-23 13:39:41');
INSERT INTO `access_log` VALUES (57905, '64.85.15638603822625299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:42', 2, 0, '', '2019-07-23 13:39:42');
INSERT INTO `access_log` VALUES (57906, '64.83.15638603829745271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:43', 2, 0, '', '2019-07-23 13:39:43');
INSERT INTO `access_log` VALUES (57907, '64.79.15638603836885277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:44', 2, 0, '', '2019-07-23 13:39:44');
INSERT INTO `access_log` VALUES (57908, '64.78.15638603844155283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:44', 2, 0, '', '2019-07-23 13:39:44');
INSERT INTO `access_log` VALUES (57909, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:44', 6, 0, '', '2019-07-23 13:39:44');
INSERT INTO `access_log` VALUES (57910, '64.76.15638603861165271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:46', 2, 0, '', '2019-07-23 13:39:46');
INSERT INTO `access_log` VALUES (57911, '64.84.15638603862085267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:46', 2, 0, '', '2019-07-23 13:39:46');
INSERT INTO `access_log` VALUES (57912, '64.82.15638603871165287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:47', 2, 0, '', '2019-07-23 13:39:47');
INSERT INTO `access_log` VALUES (57913, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:47', 5, 0, '', '2019-07-23 13:39:47');
INSERT INTO `access_log` VALUES (57914, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:49', 5, 0, '', '2019-07-23 13:39:49');
INSERT INTO `access_log` VALUES (57915, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:50', 4, 0, '', '2019-07-23 13:39:50');
INSERT INTO `access_log` VALUES (57916, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:51', 4, 0, '', '2019-07-23 13:39:51');
INSERT INTO `access_log` VALUES (57917, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:51', 6, 0, '', '2019-07-23 13:39:51');
INSERT INTO `access_log` VALUES (57918, '64.80.15638603920245279', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:39:52', 7, 0, '', '2019-07-23 13:39:52');
INSERT INTO `access_log` VALUES (57919, '64.85.15638604160935301', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:16', 7, 0, '', '2019-07-23 13:40:16');
INSERT INTO `access_log` VALUES (57920, '64.83.15638604170455273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:17', 2, 0, '', '2019-07-23 13:40:17');
INSERT INTO `access_log` VALUES (57921, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:17', 6, 0, '', '2019-07-23 13:40:17');
INSERT INTO `access_log` VALUES (57922, '64.79.15638604178595279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:18', 2, 0, '', '2019-07-23 13:40:18');
INSERT INTO `access_log` VALUES (57923, '64.78.15638604179515285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:18', 2, 0, '', '2019-07-23 13:40:18');
INSERT INTO `access_log` VALUES (57924, '66.55.15638604337412873', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18225636355&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:34', 16, 1001003000, '验证码不存在', '2019-07-23 13:40:34');
INSERT INTO `access_log` VALUES (57925, '64.82.15638604418615289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:42', 2, 0, '', '2019-07-23 13:40:42');
INSERT INTO `access_log` VALUES (57926, '64.77.15638604420095263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:42', 2, 0, '', '2019-07-23 13:40:42');
INSERT INTO `access_log` VALUES (57927, '64.80.15638604438525281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:44', 3, 0, '', '2019-07-23 13:40:44');
INSERT INTO `access_log` VALUES (57928, '64.81.15638604441995271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:44', 3, 0, '', '2019-07-23 13:40:44');
INSERT INTO `access_log` VALUES (57929, '64.85.15638604447585303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:45', 2, 0, '', '2019-07-23 13:40:45');
INSERT INTO `access_log` VALUES (57930, '64.83.15638604451575275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:45', 2, 0, '', '2019-07-23 13:40:45');
INSERT INTO `access_log` VALUES (57931, '64.79.15638604454865281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:45', 2, 0, '', '2019-07-23 13:40:45');
INSERT INTO `access_log` VALUES (57932, '59.78.15638604463045057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:46', 3, 0, '', '2019-07-23 13:40:46');
INSERT INTO `access_log` VALUES (57933, '59.79.15638604463065061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '14.29.252.47', '2019-07-23 13:40:46', 19, 2001001000, '服务端发生异常', '2019-07-23 13:40:46');
INSERT INTO `access_log` VALUES (57934, '65.53.15638604561977273', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:40:56', 1, 1002001015, '账号未登陆', '2019-07-23 13:40:56');
INSERT INTO `access_log` VALUES (57935, '65.54.15638604561977203', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:40:56', 0, 1002001015, '账号未登陆', '2019-07-23 13:40:56');
INSERT INTO `access_log` VALUES (57936, '65.3607.15638604562219075', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:40:56', 1, 1002001015, '账号未登陆', '2019-07-23 13:40:56');
INSERT INTO `access_log` VALUES (57937, '65.50.15638604581737293', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:40:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 13:40:58');
INSERT INTO `access_log` VALUES (57938, '65.46.15638604640667347', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:41:04', 4, 1002002001, '密码不正确', '2019-07-23 13:41:04');
INSERT INTO `access_log` VALUES (57939, '65.45.15638604801657271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:41:20', 60, 0, '', '2019-07-23 13:41:20');
INSERT INTO `access_log` VALUES (57940, '65.47.15638604804577263', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:41:20', 9, 0, '', '2019-07-23 13:41:20');
INSERT INTO `access_log` VALUES (57941, '65.52.15638604804597313', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:41:20', 9, 0, '', '2019-07-23 13:41:20');
INSERT INTO `access_log` VALUES (57942, '65.51.15638604804607347', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:41:20', 9, 2001001000, '服务端发生异常', '2019-07-23 13:41:20');
INSERT INTO `access_log` VALUES (57943, '65.53.15638604981167275', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:41:38', 10, 0, '', '2019-07-23 13:41:38');
INSERT INTO `access_log` VALUES (57944, '65.3607.15638604981179077', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:41:38', 12, 2001001000, '服务端发生异常', '2019-07-23 13:41:38');
INSERT INTO `access_log` VALUES (57945, '65.50.15638604981197295', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:41:38', 9, 0, '', '2019-07-23 13:41:38');
INSERT INTO `access_log` VALUES (57946, '65.49.15638605086637253', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:41:49', 17, 0, '', '2019-07-23 13:41:49');
INSERT INTO `access_log` VALUES (57947, '65.45.15638605086647273', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:41:49', 17, 2001001000, '服务端发生异常', '2019-07-23 13:41:49');
INSERT INTO `access_log` VALUES (57948, '65.51.15638605086677349', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '14.29.252.47', '2019-07-23 13:41:49', 16, 0, '', '2019-07-23 13:41:49');
INSERT INTO `access_log` VALUES (57949, '59.75.15638618325075083', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:03:53', 4, 0, '', '2019-07-23 14:03:53');
INSERT INTO `access_log` VALUES (57950, '59.71.15638618325075075', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:03:53', 13, 2001001000, '服务端发生异常', '2019-07-23 14:03:53');
INSERT INTO `access_log` VALUES (57951, '64.82.15638618375695309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:03:58', 164, 0, '', '2019-07-23 14:03:58');
INSERT INTO `access_log` VALUES (57952, '64.77.15638618378985283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:03:58', 1, 0, '', '2019-07-23 14:03:58');
INSERT INTO `access_log` VALUES (57953, '64.80.15638618394385301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:03:59', 2, 0, '', '2019-07-23 14:03:59');
INSERT INTO `access_log` VALUES (57954, '64.81.15638618404435291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:00', 2, 0, '', '2019-07-23 14:04:00');
INSERT INTO `access_log` VALUES (57955, '64.85.15638618413675323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:01', 2, 0, '', '2019-07-23 14:04:01');
INSERT INTO `access_log` VALUES (57956, '64.83.15638618421455295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:02', 2, 0, '', '2019-07-23 14:04:02');
INSERT INTO `access_log` VALUES (57957, '64.79.15638618440555301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:04', 2, 0, '', '2019-07-23 14:04:04');
INSERT INTO `access_log` VALUES (57958, '64.78.15638618446175307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:05', 2, 0, '', '2019-07-23 14:04:05');
INSERT INTO `access_log` VALUES (57959, '64.84.15638618501995291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:10', 2, 0, '', '2019-07-23 14:04:10');
INSERT INTO `access_log` VALUES (57960, '64.82.15638618503125311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:10', 1, 0, '', '2019-07-23 14:04:10');
INSERT INTO `access_log` VALUES (57961, '59.73.15638618565925081', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:17', 2, 0, '', '2019-07-23 14:04:17');
INSERT INTO `access_log` VALUES (57962, '59.80.15638618565925055', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:17', 38, 2001001000, '服务端发生异常', '2019-07-23 14:04:17');
INSERT INTO `access_log` VALUES (57963, '64.80.15638618605745303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:21', 2, 0, '', '2019-07-23 14:04:21');
INSERT INTO `access_log` VALUES (57964, '64.81.15638618606705293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:21', 2, 0, '', '2019-07-23 14:04:21');
INSERT INTO `access_log` VALUES (57965, '65.53.15638618797047295', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:40', 4, 1002001012, '访问令牌已过期', '2019-07-23 14:04:40');
INSERT INTO `access_log` VALUES (57966, '65.3607.15638618797049097', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:40', 4, 1002001012, '访问令牌已过期', '2019-07-23 14:04:40');
INSERT INTO `access_log` VALUES (57967, '65.54.15638618797037225', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:40', 4, 1002001012, '访问令牌已过期', '2019-07-23 14:04:40');
INSERT INTO `access_log` VALUES (57968, '65.50.15638618819157315', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:42', 103, 0, '', '2019-07-23 14:04:42');
INSERT INTO `access_log` VALUES (57969, '65.45.15638618822047293', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:42', 326, 2001001000, '服务端发生异常', '2019-07-23 14:04:43');
INSERT INTO `access_log` VALUES (57970, '65.46.15638618822017369', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:42', 330, 0, '', '2019-07-23 14:04:43');
INSERT INTO `access_log` VALUES (57971, '65.51.15638618822057369', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '60.166.12.138', '2019-07-23 14:04:42', 326, 0, '', '2019-07-23 14:04:43');
INSERT INTO `access_log` VALUES (57972, '59.73.15638636260805105', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-23 14:33:46', 10, 0, '', '2019-07-23 14:33:46');
INSERT INTO `access_log` VALUES (57973, '59.80.15638636260805079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '183.128.161.227', '2019-07-23 14:33:46', 19, 2001001000, '服务端发生异常', '2019-07-23 14:33:46');
INSERT INTO `access_log` VALUES (57974, '59.77.15638641058645099', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:41:46', 3, 0, '', '2019-07-23 14:41:46');
INSERT INTO `access_log` VALUES (57975, '59.76.15638641060045099', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:41:46', 16, 2001001000, '服务端发生异常', '2019-07-23 14:41:46');
INSERT INTO `access_log` VALUES (57976, '64.85.15638641122945355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:41:52', 13, 0, '', '2019-07-23 14:41:52');
INSERT INTO `access_log` VALUES (57977, '64.83.15638641124625327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:41:52', 4, 0, '', '2019-07-23 14:41:52');
INSERT INTO `access_log` VALUES (57978, '64.79.15638641139285333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:41:54', 2, 0, '', '2019-07-23 14:41:54');
INSERT INTO `access_log` VALUES (57979, '64.78.15638641149135339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:41:55', 2, 0, '', '2019-07-23 14:41:55');
INSERT INTO `access_log` VALUES (57980, '64.76.15638641161975327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:41:56', 1, 0, '', '2019-07-23 14:41:56');
INSERT INTO `access_log` VALUES (57981, '66.48.15638641418662953', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13838389438', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:22', 99, 0, '', '2019-07-23 14:42:22');
INSERT INTO `access_log` VALUES (57982, '66.55.15638641439192923', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13838389438&code=sdfsd', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字', '2019-07-23 14:42:24');
INSERT INTO `access_log` VALUES (57983, '66.57.15638641505412945', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13838389438&code=1123', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:31', 7, 1001003003, '验证码不正确', '2019-07-23 14:42:31');
INSERT INTO `access_log` VALUES (57984, '66.51.15638641580562967', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13838389438&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:38', 182, 0, '', '2019-07-23 14:42:38');
INSERT INTO `access_log` VALUES (57985, '64.81.15638641654505325', 180, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:45', 6, 0, '', '2019-07-23 14:42:45');
INSERT INTO `access_log` VALUES (57986, '64.83.15638641656665329', 180, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:46', 8, 0, '', '2019-07-23 14:42:46');
INSERT INTO `access_log` VALUES (57987, '59.78.15638641671985109', 180, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:47', 8, 0, '', '2019-07-23 14:42:47');
INSERT INTO `access_log` VALUES (57988, '59.79.15638641672375113', 180, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:47', 157, 2001001000, '服务端发生异常', '2019-07-23 14:42:47');
INSERT INTO `access_log` VALUES (57989, '64.79.15638641696555335', 180, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:50', 6, 0, '', '2019-07-23 14:42:50');
INSERT INTO `access_log` VALUES (57990, '64.78.15638641698095341', 180, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:50', 5, 0, '', '2019-07-23 14:42:50');
INSERT INTO `access_log` VALUES (57991, '64.84.15638641737325325', 180, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:54', 4, 0, '', '2019-07-23 14:42:54');
INSERT INTO `access_log` VALUES (57992, '64.82.15638641738645345', 180, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:54', 6, 0, '', '2019-07-23 14:42:54');
INSERT INTO `access_log` VALUES (57993, '64.80.15638641747705337', 180, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:55', 6, 0, '', '2019-07-23 14:42:55');
INSERT INTO `access_log` VALUES (57994, '64.85.15638641755205359', 180, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:56', 6, 0, '', '2019-07-23 14:42:56');
INSERT INTO `access_log` VALUES (57995, '66.49.15638641765472943', 180, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:57', 6, 0, '', '2019-07-23 14:42:57');
INSERT INTO `access_log` VALUES (57996, '59.74.15638641783645119', 180, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:42:58', 9, 0, '', '2019-07-23 14:42:58');
INSERT INTO `access_log` VALUES (57997, '59.71.15638641795375109', 180, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:43:00', 5, 0, '', '2019-07-23 14:43:00');
INSERT INTO `access_log` VALUES (57998, '59.80.15638641803945089', 180, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:43:00', 7, 0, '', '2019-07-23 14:43:00');
INSERT INTO `access_log` VALUES (57999, '66.50.15638641853232935', 180, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:43:05', 5, 0, '', '2019-07-23 14:43:05');
INSERT INTO `access_log` VALUES (58000, '66.48.15638641908362955', 180, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:43:11', 5, 0, '', '2019-07-23 14:43:11');
INSERT INTO `access_log` VALUES (58001, '64.78.15638641958905343', 180, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:43:16', 8, 1003002003, 'Spu 只能添加在二级分类下', '2019-07-23 14:43:16');
INSERT INTO `access_log` VALUES (58002, '64.84.15638642051485327', 180, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:43:25', 5, 1003002003, 'Spu 只能添加在二级分类下', '2019-07-23 14:43:25');
INSERT INTO `access_log` VALUES (58003, '65.46.15638642427567401', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:44:03', 19, 1002001012, '访问令牌已过期', '2019-07-23 14:44:03');
INSERT INTO `access_log` VALUES (58004, '65.45.15638642427537325', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:44:03', 21, 1002001012, '访问令牌已过期', '2019-07-23 14:44:03');
INSERT INTO `access_log` VALUES (58005, '65.51.15638642427827401', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:44:03', 12, 1002001012, '访问令牌已过期', '2019-07-23 14:44:03');
INSERT INTO `access_log` VALUES (58006, '65.52.15638642548167367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:44:15', 59, 0, '', '2019-07-23 14:44:15');
INSERT INTO `access_log` VALUES (58007, '65.47.15638642551887317', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:44:15', 9, 0, '', '2019-07-23 14:44:15');
INSERT INTO `access_log` VALUES (58008, '65.3607.15638642551949131', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:44:15', 10, 2001001000, '服务端发生异常', '2019-07-23 14:44:15');
INSERT INTO `access_log` VALUES (58009, '65.53.15638642551987329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:44:15', 9, 0, '', '2019-07-23 14:44:15');
INSERT INTO `access_log` VALUES (58010, '65.46.15638642879007403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-07-23 14:44:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 14:44:48');
INSERT INTO `access_log` VALUES (58011, '65.49.15638654823047323', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 15:04:42', 1, 1002001015, '账号未登陆', '2019-07-23 15:04:42');
INSERT INTO `access_log` VALUES (58012, '65.51.15638654823037419', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 15:04:42', 1, 1002001015, '账号未登陆', '2019-07-23 15:04:42');
INSERT INTO `access_log` VALUES (58013, '65.45.15638654823037343', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 15:04:42', 1, 1002001015, '账号未登陆', '2019-07-23 15:04:42');
INSERT INTO `access_log` VALUES (58014, '65.52.15638654851717385', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 15:04:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 15:04:45');
INSERT INTO `access_log` VALUES (58015, '65.3607.15638654895309149', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 15:04:50', 69, 0, '', '2019-07-23 15:04:50');
INSERT INTO `access_log` VALUES (58016, '65.54.15638654898267277', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 15:04:50', 9, 0, '', '2019-07-23 15:04:50');
INSERT INTO `access_log` VALUES (58017, '65.47.15638654898247335', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 15:04:50', 10, 0, '', '2019-07-23 15:04:50');
INSERT INTO `access_log` VALUES (58018, '65.53.15638654898247347', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 15:04:50', 11, 2001001000, '服务端发生异常', '2019-07-23 15:04:50');
INSERT INTO `access_log` VALUES (58019, '65.49.15638655280707325', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 15:05:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 15:05:28');
INSERT INTO `access_log` VALUES (58020, '65.45.15638655331787345', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 15:05:33', 4, 1002002001, '密码不正确', '2019-07-23 15:05:33');
INSERT INTO `access_log` VALUES (58021, '59.71.15638657874845131', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.38.27', '2019-07-23 15:09:47', 3, 0, '', '2019-07-23 15:09:47');
INSERT INTO `access_log` VALUES (58022, '59.72.15638657874845129', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.38.27', '2019-07-23 15:09:47', 18, 2001001000, '服务端发生异常', '2019-07-23 15:09:48');
INSERT INTO `access_log` VALUES (58023, '64.79.15638657933405359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.38.27', '2019-07-23 15:09:53', 2, 0, '', '2019-07-23 15:09:53');
INSERT INTO `access_log` VALUES (58024, '64.78.15638657934925365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.38.27', '2019-07-23 15:09:53', 2, 0, '', '2019-07-23 15:09:53');
INSERT INTO `access_log` VALUES (58025, '64.76.15638657990745353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.38.27', '2019-07-23 15:09:59', 2, 0, '', '2019-07-23 15:09:59');
INSERT INTO `access_log` VALUES (58026, '64.84.15638657992075349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.38.27', '2019-07-23 15:09:59', 2, 0, '', '2019-07-23 15:09:59');
INSERT INTO `access_log` VALUES (58027, '59.73.15638657998705137', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.38.27', '2019-07-23 15:10:00', 2, 0, '', '2019-07-23 15:10:00');
INSERT INTO `access_log` VALUES (58028, '59.78.15638657998705133', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.38.27', '2019-07-23 15:10:00', 12, 2001001000, '服务端发生异常', '2019-07-23 15:10:00');
INSERT INTO `access_log` VALUES (58029, '59.79.15638658014335137', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:01', 2, 0, '', '2019-07-23 15:10:01');
INSERT INTO `access_log` VALUES (58030, '59.77.15638658014345125', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:01', 13, 2001001000, '服务端发生异常', '2019-07-23 15:10:01');
INSERT INTO `access_log` VALUES (58031, '64.82.15638658049185369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:05', 2, 0, '', '2019-07-23 15:10:05');
INSERT INTO `access_log` VALUES (58032, '64.77.15638658050155343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:05', 2, 0, '', '2019-07-23 15:10:05');
INSERT INTO `access_log` VALUES (58033, '64.81.15638658061915351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:06', 2, 0, '', '2019-07-23 15:10:06');
INSERT INTO `access_log` VALUES (58034, '64.85.15638658068145383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:07', 2, 0, '', '2019-07-23 15:10:07');
INSERT INTO `access_log` VALUES (58035, '64.83.15638658074945355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:07', 2, 0, '', '2019-07-23 15:10:07');
INSERT INTO `access_log` VALUES (58036, '59.74.15638658086455143', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:09', 2, 0, '', '2019-07-23 15:10:09');
INSERT INTO `access_log` VALUES (58037, '59.75.15638658086525141', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:09', 13, 2001001000, '服务端发生异常', '2019-07-23 15:10:09');
INSERT INTO `access_log` VALUES (58038, '64.79.15638658124645361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:12', 2, 0, '', '2019-07-23 15:10:12');
INSERT INTO `access_log` VALUES (58039, '64.78.15638658125745367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:13', 2, 0, '', '2019-07-23 15:10:13');
INSERT INTO `access_log` VALUES (58040, '64.76.15638658134795355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:13', 2, 0, '', '2019-07-23 15:10:13');
INSERT INTO `access_log` VALUES (58041, '64.84.15638658138155351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:14', 1, 0, '', '2019-07-23 15:10:14');
INSERT INTO `access_log` VALUES (58042, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=丰东股份&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:17', 6, 0, '', '2019-07-23 15:10:17');
INSERT INTO `access_log` VALUES (58043, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=丰东股份', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:17', 5, 0, '', '2019-07-23 15:10:17');
INSERT INTO `access_log` VALUES (58044, '64.82.15638658204115371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:20', 2, 0, '', '2019-07-23 15:10:20');
INSERT INTO `access_log` VALUES (58045, '64.80.15638658205045363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:21', 2, 0, '', '2019-07-23 15:10:21');
INSERT INTO `access_log` VALUES (58046, '59.71.15638658209305133', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:21', 3, 0, '', '2019-07-23 15:10:21');
INSERT INTO `access_log` VALUES (58047, '59.80.15638658209465113', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:21', 15, 2001001000, '服务端发生异常', '2019-07-23 15:10:21');
INSERT INTO `access_log` VALUES (58048, '65.52.15638658312927391', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:31', 0, 1002001015, '账号未登陆', '2019-07-23 15:10:31');
INSERT INTO `access_log` VALUES (58049, '65.3607.15638658312939155', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:31', 1, 1002001015, '账号未登陆', '2019-07-23 15:10:31');
INSERT INTO `access_log` VALUES (58050, '65.54.15638658313017283', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:31', 1, 1002001015, '账号未登陆', '2019-07-23 15:10:31');
INSERT INTO `access_log` VALUES (58051, '65.47.15638658333607341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 15:10:33');
INSERT INTO `access_log` VALUES (58052, '65.46.15638658572777427', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:57', 52, 0, '', '2019-07-23 15:10:57');
INSERT INTO `access_log` VALUES (58053, '65.51.15638658575727427', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:58', 9, 0, '', '2019-07-23 15:10:58');
INSERT INTO `access_log` VALUES (58054, '65.49.15638658575767331', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:58', 10, 0, '', '2019-07-23 15:10:58');
INSERT INTO `access_log` VALUES (58055, '65.45.15638658575777351', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:10:58', 9, 2001001000, '服务端发生异常', '2019-07-23 15:10:58');
INSERT INTO `access_log` VALUES (58056, '65.3607.15638658764889157', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:11:16', 10, 0, '', '2019-07-23 15:11:16');
INSERT INTO `access_log` VALUES (58057, '65.54.15638658764947285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:11:16', 9, 2001001000, '服务端发生异常', '2019-07-23 15:11:17');
INSERT INTO `access_log` VALUES (58058, '65.47.15638658764957343', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '112.17.103.39', '2019-07-23 15:11:16', 8, 0, '', '2019-07-23 15:11:17');
INSERT INTO `access_log` VALUES (58059, '65.46.15638677666727455', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 15:42:47', 1, 1002001015, '账号未登陆', '2019-07-23 15:42:47');
INSERT INTO `access_log` VALUES (58060, '65.45.15638677666717379', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 15:42:47', 1, 1002001015, '账号未登陆', '2019-07-23 15:42:47');
INSERT INTO `access_log` VALUES (58061, '65.49.15638677666807359', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 15:42:47', 1, 1002001015, '账号未登陆', '2019-07-23 15:42:47');
INSERT INTO `access_log` VALUES (58062, '65.52.15638677721307419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 15:42:52', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 15:42:52');
INSERT INTO `access_log` VALUES (58063, '65.47.15638677801517369', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 15:43:00', 90, 0, '', '2019-07-23 15:43:00');
INSERT INTO `access_log` VALUES (58064, '65.54.15638677805917315', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 15:43:01', 13, 0, '', '2019-07-23 15:43:01');
INSERT INTO `access_log` VALUES (58065, '65.3607.15638677805979189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 15:43:01', 10, 2001001000, '服务端发生异常', '2019-07-23 15:43:01');
INSERT INTO `access_log` VALUES (58066, '65.51.15638677806067457', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 15:43:01', 9, 0, '', '2019-07-23 15:43:01');
INSERT INTO `access_log` VALUES (58067, '65.54.15638686368427327', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 15:57:17', 11, 0, '', '2019-07-23 15:57:17');
INSERT INTO `access_log` VALUES (58068, '65.51.15638686368447469', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 15:57:17', 11, 2001001000, '服务端发生异常', '2019-07-23 15:57:17');
INSERT INTO `access_log` VALUES (58069, '65.3607.15638686368529201', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 15:57:17', 16, 0, '', '2019-07-23 15:57:17');
INSERT INTO `access_log` VALUES (58070, '65.45.15638686663837393', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '124.207.17.50', '2019-07-23 15:57:46', 0, 1002001015, '账号未登陆', '2019-07-23 15:57:46');
INSERT INTO `access_log` VALUES (58071, '65.49.15638686663887373', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '124.207.17.50', '2019-07-23 15:57:46', 0, 1002001015, '账号未登陆', '2019-07-23 15:57:46');
INSERT INTO `access_log` VALUES (58072, '65.52.15638686663947433', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '124.207.17.50', '2019-07-23 15:57:46', 0, 1002001015, '账号未登陆', '2019-07-23 15:57:46');
INSERT INTO `access_log` VALUES (58073, '65.47.15638686745437383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '124.207.17.50', '2019-07-23 15:57:55', 56, 0, '', '2019-07-23 15:57:55');
INSERT INTO `access_log` VALUES (58074, '65.54.15638686752947329', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '124.207.17.50', '2019-07-23 15:57:55', 10, 0, '', '2019-07-23 15:57:55');
INSERT INTO `access_log` VALUES (58075, '65.51.15638686753077471', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '124.207.17.50', '2019-07-23 15:57:55', 9, 0, '', '2019-07-23 15:57:55');
INSERT INTO `access_log` VALUES (58076, '65.3607.15638686753089203', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '124.207.17.50', '2019-07-23 15:57:55', 10, 2001001000, '服务端发生异常', '2019-07-23 15:57:55');
INSERT INTO `access_log` VALUES (58077, '65.50.15638686874867415', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 15:58:07', 10, 0, '', '2019-07-23 15:58:07');
INSERT INTO `access_log` VALUES (58078, '65.46.15638686874947471', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 15:58:07', 10, 2001001000, '服务端发生异常', '2019-07-23 15:58:08');
INSERT INTO `access_log` VALUES (58079, '65.52.15638686874997435', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 15:58:07', 9, 0, '', '2019-07-23 15:58:08');
INSERT INTO `access_log` VALUES (58080, '65.3607.15638687505809205', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-07-23 15:59:11', 0, 1002001015, '账号未登陆', '2019-07-23 15:59:11');
INSERT INTO `access_log` VALUES (58081, '65.46.15638687505847473', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-07-23 15:59:11', 0, 1002001015, '账号未登陆', '2019-07-23 15:59:11');
INSERT INTO `access_log` VALUES (58082, '65.51.15638687505827473', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-07-23 15:59:11', 0, 1002001015, '账号未登陆', '2019-07-23 15:59:11');
INSERT INTO `access_log` VALUES (58083, '65.52.15638687531157437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-07-23 15:59:13', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 15:59:13');
INSERT INTO `access_log` VALUES (58084, '65.49.15638687721887377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-07-23 15:59:32', 88, 0, '', '2019-07-23 15:59:32');
INSERT INTO `access_log` VALUES (58085, '65.45.15638687724907397', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-07-23 15:59:32', 18, 0, '', '2019-07-23 15:59:33');
INSERT INTO `access_log` VALUES (58086, '65.53.15638687724927399', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-07-23 15:59:32', 18, 2001001000, '服务端发生异常', '2019-07-23 15:59:33');
INSERT INTO `access_log` VALUES (58087, '65.47.15638687724967387', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-07-23 15:59:32', 17, 0, '', '2019-07-23 15:59:33');
INSERT INTO `access_log` VALUES (58088, '65.46.15638687895667475', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-07-23 15:59:50', 9, 0, '', '2019-07-23 15:59:50');
INSERT INTO `access_log` VALUES (58089, '65.3607.15638687895689207', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-07-23 15:59:50', 9, 2001001000, '服务端发生异常', '2019-07-23 15:59:50');
INSERT INTO `access_log` VALUES (58090, '65.51.15638687895687475', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.90.47.66', '2019-07-23 15:59:50', 9, 0, '', '2019-07-23 15:59:50');
INSERT INTO `access_log` VALUES (58091, '59.73.15638709376055207', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:38', 13, 0, '', '2019-07-23 16:35:38');
INSERT INTO `access_log` VALUES (58092, '59.79.15638709376055207', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:38', 27, 2001001000, '服务端发生异常', '2019-07-23 16:35:38');
INSERT INTO `access_log` VALUES (58093, '64.85.15638709484415453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:48', 11, 0, '', '2019-07-23 16:35:48');
INSERT INTO `access_log` VALUES (58094, '64.83.15638709485485425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:49', 3, 0, '', '2019-07-23 16:35:49');
INSERT INTO `access_log` VALUES (58095, '64.79.15638709495775431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:50', 2, 0, '', '2019-07-23 16:35:50');
INSERT INTO `access_log` VALUES (58096, '64.78.15638709501985437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:50', 2, 0, '', '2019-07-23 16:35:50');
INSERT INTO `access_log` VALUES (58097, '64.84.15638709509825421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:51', 2, 0, '', '2019-07-23 16:35:51');
INSERT INTO `access_log` VALUES (58098, '59.76.15638709522275195', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:52', 3, 0, '', '2019-07-23 16:35:52');
INSERT INTO `access_log` VALUES (58099, '59.74.15638709522275213', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:52', 24, 2001001000, '服务端发生异常', '2019-07-23 16:35:52');
INSERT INTO `access_log` VALUES (58100, '64.82.15638709547645441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:55', 2, 0, '', '2019-07-23 16:35:55');
INSERT INTO `access_log` VALUES (58101, '64.77.15638709548695415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:55', 2, 0, '', '2019-07-23 16:35:55');
INSERT INTO `access_log` VALUES (58102, '64.80.15638709558645433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:56', 2, 0, '', '2019-07-23 16:35:56');
INSERT INTO `access_log` VALUES (58103, '64.81.15638709563125423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:56', 2, 0, '', '2019-07-23 16:35:56');
INSERT INTO `access_log` VALUES (58104, '59.72.15638709576735201', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:58', 2, 0, '', '2019-07-23 16:35:58');
INSERT INTO `access_log` VALUES (58105, '59.75.15638709576735211', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:35:58', 16, 2001001000, '服务端发生异常', '2019-07-23 16:35:58');
INSERT INTO `access_log` VALUES (58106, '59.74.15638710627785215', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:37:43', 4, 0, '', '2019-07-23 16:37:43');
INSERT INTO `access_log` VALUES (58107, '59.72.15638710627895203', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:37:43', 20, 2001001000, '服务端发生异常', '2019-07-23 16:37:43');
INSERT INTO `access_log` VALUES (58108, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=123&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:38:06', 5, 0, '', '2019-07-23 16:38:06');
INSERT INTO `access_log` VALUES (58109, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=123', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:38:06', 5, 0, '', '2019-07-23 16:38:06');
INSERT INTO `access_log` VALUES (58110, '59.80.15638710940385185', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:38:14', 2, 0, '', '2019-07-23 16:38:14');
INSERT INTO `access_log` VALUES (58111, '59.78.15638710940385207', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:38:14', 18, 2001001000, '服务端发生异常', '2019-07-23 16:38:14');
INSERT INTO `access_log` VALUES (58112, '64.81.15638711000825425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:38:20', 2, 0, '', '2019-07-23 16:38:20');
INSERT INTO `access_log` VALUES (58113, '64.85.15638711002265457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:38:20', 2, 0, '', '2019-07-23 16:38:20');
INSERT INTO `access_log` VALUES (58114, '64.78.15638711290445441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:38:49', 2, 0, '', '2019-07-23 16:38:49');
INSERT INTO `access_log` VALUES (58115, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:38:49', 6, 0, '', '2019-07-23 16:38:49');
INSERT INTO `access_log` VALUES (58116, '64.84.15638711380695425', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.132.202.235', '2019-07-23 16:38:58', 8, 0, '', '2019-07-23 16:38:58');
INSERT INTO `access_log` VALUES (58117, '59.72.15638714686745209', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 16:44:29', 3, 0, '', '2019-07-23 16:44:29');
INSERT INTO `access_log` VALUES (58118, '59.75.15638714686745219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 16:44:29', 21, 2001001000, '服务端发生异常', '2019-07-23 16:44:29');
INSERT INTO `access_log` VALUES (58119, '64.80.15638714749215441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 16:44:35', 2, 0, '', '2019-07-23 16:44:35');
INSERT INTO `access_log` VALUES (58120, '64.81.15638714750395431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 16:44:35', 2, 0, '', '2019-07-23 16:44:35');
INSERT INTO `access_log` VALUES (58121, '64.83.15638714764155435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 16:44:36', 2, 0, '', '2019-07-23 16:44:36');
INSERT INTO `access_log` VALUES (58122, '64.79.15638714769995441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 16:44:37', 2, 0, '', '2019-07-23 16:44:37');
INSERT INTO `access_log` VALUES (58123, '65.50.15638714950247455', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 16:44:55', 4, 1002001012, '访问令牌已过期', '2019-07-23 16:44:55');
INSERT INTO `access_log` VALUES (58124, '65.49.15638714950297415', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 16:44:55', 3, 1002001012, '访问令牌已过期', '2019-07-23 16:44:55');
INSERT INTO `access_log` VALUES (58125, '65.53.15638714950577437', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 16:44:55', 12, 1002001012, '访问令牌已过期', '2019-07-23 16:44:55');
INSERT INTO `access_log` VALUES (58126, '65.47.15638715004087425', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 16:45:00', 96, 0, '', '2019-07-23 16:45:01');
INSERT INTO `access_log` VALUES (58127, '65.45.15638715008487435', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 16:45:01', 11, 0, '', '2019-07-23 16:45:01');
INSERT INTO `access_log` VALUES (58128, '65.54.15638715008527371', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 16:45:01', 11, 2001001000, '服务端发生异常', '2019-07-23 16:45:01');
INSERT INTO `access_log` VALUES (58129, '65.46.15638715008577513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 16:45:01', 10, 0, '', '2019-07-23 16:45:01');
INSERT INTO `access_log` VALUES (58130, '64.82.15638716814935453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '58.132.202.235', '2019-07-23 16:48:01', 3, 0, '', '2019-07-23 16:48:01');
INSERT INTO `access_log` VALUES (58131, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '58.132.202.235', '2019-07-23 16:48:01', 8, 0, '', '2019-07-23 16:48:02');
INSERT INTO `access_log` VALUES (58132, '64.77.15638716831265427', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '58.132.202.235', '2019-07-23 16:48:03', 7, 0, '', '2019-07-23 16:48:03');
INSERT INTO `access_log` VALUES (58133, '64.81.15638716945895435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '58.132.202.235', '2019-07-23 16:48:15', 2, 0, '', '2019-07-23 16:48:15');
INSERT INTO `access_log` VALUES (58134, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '58.132.202.235', '2019-07-23 16:48:15', 6, 0, '', '2019-07-23 16:48:15');
INSERT INTO `access_log` VALUES (58135, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '58.132.202.235', '2019-07-23 16:48:16', 5, 0, '', '2019-07-23 16:48:16');
INSERT INTO `access_log` VALUES (58136, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '58.132.202.235', '2019-07-23 16:48:17', 5, 0, '', '2019-07-23 16:48:17');
INSERT INTO `access_log` VALUES (58137, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '58.132.202.235', '2019-07-23 16:48:18', 7, 0, '', '2019-07-23 16:48:18');
INSERT INTO `access_log` VALUES (58138, '59.75.15638720510125227', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.42.241.116', '2019-07-23 16:54:11', 3, 0, '', '2019-07-23 16:54:11');
INSERT INTO `access_log` VALUES (58139, '59.71.15638720510135219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.42.241.116', '2019-07-23 16:54:11', 13, 2001001000, '服务端发生异常', '2019-07-23 16:54:11');
INSERT INTO `access_log` VALUES (58140, '65.45.15638720703787443', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.42.241.116', '2019-07-23 16:54:30', 3, 1002001012, '访问令牌已过期', '2019-07-23 16:54:30');
INSERT INTO `access_log` VALUES (58141, '65.46.15638720703817521', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.42.241.116', '2019-07-23 16:54:30', 2, 1002001012, '访问令牌已过期', '2019-07-23 16:54:30');
INSERT INTO `access_log` VALUES (58142, '65.3607.15638720703849253', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.42.241.116', '2019-07-23 16:54:30', 3, 1002001012, '访问令牌已过期', '2019-07-23 16:54:30');
INSERT INTO `access_log` VALUES (58143, '65.51.15638720723407521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.42.241.116', '2019-07-23 16:54:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 16:54:32');
INSERT INTO `access_log` VALUES (58144, '65.46.15638726344607531', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '220.197.193.45', '2019-07-23 17:03:54', 1, 1002001015, '账号未登陆', '2019-07-23 17:03:54');
INSERT INTO `access_log` VALUES (58145, '64.77.15638726986065443', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '220.197.193.45', '2019-07-23 17:04:59', 1, 1002001015, '账号未登陆', '2019-07-23 17:04:59');
INSERT INTO `access_log` VALUES (58146, '64.85.15638727271505481', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=100', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '220.197.193.45', '2019-07-23 17:05:27', 3, 1003002003, 'Spu 只能添加在二级分类下', '2019-07-23 17:05:27');
INSERT INTO `access_log` VALUES (58147, '64.83.15638727317715453', 0, 1, 'product-application', '/product-api/users/spu/info', '7=100', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '220.197.193.45', '2019-07-23 17:05:32', 3, 2001001001, '参数缺失:Required Integer parameter \'id\' is not present', '2019-07-23 17:05:32');
INSERT INTO `access_log` VALUES (58148, '64.81.15638727358505451', 0, 1, 'product-application', '/product-api/users/spu/info', '0=100', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '220.197.193.45', '2019-07-23 17:05:36', 3, 2001001001, '参数缺失:Required Integer parameter \'id\' is not present', '2019-07-23 17:05:36');
INSERT INTO `access_log` VALUES (58149, '64.78.15638727423355465', 0, 1, 'product-application', '/product-api/users/spu/info', 'null=100', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '220.197.193.45', '2019-07-23 17:05:42', 3, 2001001001, '参数缺失:Required Integer parameter \'id\' is not present', '2019-07-23 17:05:42');
INSERT INTO `access_log` VALUES (58150, '59.76.15638779159825291', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 18:31:56', 11, 0, '', '2019-07-23 18:31:56');
INSERT INTO `access_log` VALUES (58151, '59.74.15638779159885309', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 18:31:56', 34, 2001001000, '服务端发生异常', '2019-07-23 18:31:56');
INSERT INTO `access_log` VALUES (58152, '64.85.15638779183425551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 18:31:58', 11, 0, '', '2019-07-23 18:31:58');
INSERT INTO `access_log` VALUES (58153, '64.83.15638779184615523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 18:31:58', 3, 0, '', '2019-07-23 18:31:58');
INSERT INTO `access_log` VALUES (58154, '66.52.15638792969543135', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-23 18:54:57', 1, 1002001015, '账号未登陆', '2019-07-23 18:54:57');
INSERT INTO `access_log` VALUES (58155, '65.51.15638819722097655', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '120.40.37.34', '2019-07-23 19:39:32', 1, 1002001015, '账号未登陆', '2019-07-23 19:39:32');
INSERT INTO `access_log` VALUES (58156, '65.50.15638819722087599', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '120.40.37.34', '2019-07-23 19:39:32', 1, 1002001015, '账号未登陆', '2019-07-23 19:39:32');
INSERT INTO `access_log` VALUES (58157, '65.46.15638819722107657', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '120.40.37.34', '2019-07-23 19:39:32', 0, 1002001015, '账号未登陆', '2019-07-23 19:39:32');
INSERT INTO `access_log` VALUES (58158, '65.47.15638819849957571', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '120.40.37.34', '2019-07-23 19:39:45', 87, 0, '', '2019-07-23 19:39:45');
INSERT INTO `access_log` VALUES (58159, '65.54.15638819858637513', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '120.40.37.34', '2019-07-23 19:39:46', 322, 2001001000, '服务端发生异常', '2019-07-23 19:39:46');
INSERT INTO `access_log` VALUES (58160, '65.52.15638819858437619', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '120.40.37.34', '2019-07-23 19:39:46', 346, 0, '', '2019-07-23 19:39:46');
INSERT INTO `access_log` VALUES (58161, '65.53.15638819858917583', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '120.40.37.34', '2019-07-23 19:39:46', 298, 0, '', '2019-07-23 19:39:46');
INSERT INTO `access_log` VALUES (58162, '65.45.15638819970857583', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '120.40.37.34', '2019-07-23 19:39:57', 9, 0, '', '2019-07-23 19:39:57');
INSERT INTO `access_log` VALUES (58163, '65.51.15638819970917657', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '120.40.37.34', '2019-07-23 19:39:57', 8, 2001001000, '服务端发生异常', '2019-07-23 19:39:57');
INSERT INTO `access_log` VALUES (58164, '65.46.15638819970987659', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '120.40.37.34', '2019-07-23 19:39:57', 8, 0, '', '2019-07-23 19:39:57');
INSERT INTO `access_log` VALUES (58165, '65.46.15638840981387689', 0, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'roleIds=&id=1', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.91.141.148', '2019-07-23 20:14:58', 0, 1002001015, '账号未登陆', '2019-07-23 20:14:58');
INSERT INTO `access_log` VALUES (58166, '65.47.15638841169147601', 0, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'roleIds=1&id=1', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.91.141.148', '2019-07-23 20:15:17', 1, 1002001015, '账号未登陆', '2019-07-23 20:15:17');
INSERT INTO `access_log` VALUES (58167, '59.71.15638857220215401', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.77.106', '2019-07-23 20:42:02', 9, 0, '', '2019-07-23 20:42:02');
INSERT INTO `access_log` VALUES (58168, '59.80.15638857220285381', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.77.106', '2019-07-23 20:42:02', 16, 2001001000, '服务端发生异常', '2019-07-23 20:42:02');
INSERT INTO `access_log` VALUES (58169, '65.54.15638857436637565', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.77.106', '2019-07-23 20:42:24', 4, 1002001012, '访问令牌已过期', '2019-07-23 20:42:24');
INSERT INTO `access_log` VALUES (58170, '65.47.15638857436637623', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.77.106', '2019-07-23 20:42:24', 3, 1002001012, '访问令牌已过期', '2019-07-23 20:42:24');
INSERT INTO `access_log` VALUES (58171, '65.52.15638857436837671', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.77.106', '2019-07-23 20:42:24', 14, 1002001012, '访问令牌已过期', '2019-07-23 20:42:24');
INSERT INTO `access_log` VALUES (58172, '65.53.15638857469047633', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.77.106', '2019-07-23 20:42:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 20:42:27');
INSERT INTO `access_log` VALUES (58173, '65.51.15638857536877709', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.77.106', '2019-07-23 20:42:34', 5, 1002002000, '账号不存在', '2019-07-23 20:42:34');
INSERT INTO `access_log` VALUES (58174, '65.3607.15638857637659443', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.77.106', '2019-07-23 20:42:44', 86, 0, '', '2019-07-23 20:42:44');
INSERT INTO `access_log` VALUES (58175, '65.50.15638857640747653', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.77.106', '2019-07-23 20:42:44', 14, 0, '', '2019-07-23 20:42:44');
INSERT INTO `access_log` VALUES (58176, '65.47.15638857640767625', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.77.106', '2019-07-23 20:42:44', 15, 0, '', '2019-07-23 20:42:44');
INSERT INTO `access_log` VALUES (58177, '65.46.15638857640747713', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.141.77.106', '2019-07-23 20:42:44', 17, 2001001000, '服务端发生异常', '2019-07-23 20:42:44');
INSERT INTO `access_log` VALUES (58178, '59.73.15638878340185435', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.37.5.15', '2019-07-23 21:17:14', 13, 0, '', '2019-07-23 21:17:14');
INSERT INTO `access_log` VALUES (58179, '59.78.15638878340185433', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.37.5.15', '2019-07-23 21:17:14', 18, 2001001000, '服务端发生异常', '2019-07-23 21:17:14');
INSERT INTO `access_log` VALUES (58180, '64.81.15638878366955653', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.37.5.15', '2019-07-23 21:17:17', 12, 0, '', '2019-07-23 21:17:17');
INSERT INTO `access_log` VALUES (58181, '64.78.15638878368185667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.37.5.15', '2019-07-23 21:17:17', 11, 0, '', '2019-07-23 21:17:17');
INSERT INTO `access_log` VALUES (58182, '64.76.15638878381475657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.37.5.15', '2019-07-23 21:17:18', 2, 0, '', '2019-07-23 21:17:18');
INSERT INTO `access_log` VALUES (58183, '64.84.15638878389595649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.37.5.15', '2019-07-23 21:17:19', 2, 0, '', '2019-07-23 21:17:19');
INSERT INTO `access_log` VALUES (58184, '64.77.15638878395915647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.37.5.15', '2019-07-23 21:17:20', 2, 0, '', '2019-07-23 21:17:20');
INSERT INTO `access_log` VALUES (58185, '59.74.15638878409065443', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.37.5.15', '2019-07-23 21:17:21', 3, 0, '', '2019-07-23 21:17:21');
INSERT INTO `access_log` VALUES (58186, '59.77.15638878409065425', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '58.37.5.15', '2019-07-23 21:17:21', 13, 2001001000, '服务端发生异常', '2019-07-23 21:17:21');
INSERT INTO `access_log` VALUES (58187, '65.52.15638878807097701', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.37.5.15', '2019-07-23 21:18:01', 0, 1002001015, '账号未登陆', '2019-07-23 21:18:01');
INSERT INTO `access_log` VALUES (58188, '65.49.15638878807097645', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.37.5.15', '2019-07-23 21:18:01', 0, 1002001015, '账号未登陆', '2019-07-23 21:18:01');
INSERT INTO `access_log` VALUES (58189, '65.53.15638878807117663', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.37.5.15', '2019-07-23 21:18:01', 0, 1002001015, '账号未登陆', '2019-07-23 21:18:01');
INSERT INTO `access_log` VALUES (58190, '65.51.15638878845557739', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.37.5.15', '2019-07-23 21:18:05', 78, 0, '', '2019-07-23 21:18:05');
INSERT INTO `access_log` VALUES (58191, '65.45.15638878867127667', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.37.5.15', '2019-07-23 21:18:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 21:18:07');
INSERT INTO `access_log` VALUES (58192, '65.46.15638878921007743', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.37.5.15', '2019-07-23 21:18:12', 58, 0, '', '2019-07-23 21:18:12');
INSERT INTO `access_log` VALUES (58193, '59.80.15638878942225411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.239.232', '2019-07-23 21:18:14', 2, 0, '', '2019-07-23 21:18:14');
INSERT INTO `access_log` VALUES (58194, '59.79.15638878944935439', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.151.178.165', '2019-07-23 21:18:14', 19, 2001001000, '服务端发生异常', '2019-07-23 21:18:15');
INSERT INTO `access_log` VALUES (58195, '64.79.15638878966035663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '180.97.118.219', '2019-07-23 21:18:17', 2, 0, '', '2019-07-23 21:18:17');
INSERT INTO `access_log` VALUES (58196, '64.81.15638878979055655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.89.239.238', '2019-07-23 21:18:18', 2, 0, '', '2019-07-23 21:18:18');
INSERT INTO `access_log` VALUES (58197, '64.76.15638879006655659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.151.178.197', '2019-07-23 21:18:21', 2, 0, '', '2019-07-23 21:18:21');
INSERT INTO `access_log` VALUES (58198, '64.84.15638879021505651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.129.6.227', '2019-07-23 21:18:22', 2, 0, '', '2019-07-23 21:18:22');
INSERT INTO `access_log` VALUES (58199, '65.49.15638879406117647', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.227.139.161', '2019-07-23 21:19:01', 0, 1002001015, '账号未登陆', '2019-07-23 21:19:01');
INSERT INTO `access_log` VALUES (58200, '65.52.15638879509287703', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.178.165', '2019-07-23 21:19:11', 1, 1002001015, '账号未登陆', '2019-07-23 21:19:11');
INSERT INTO `access_log` VALUES (58201, '65.51.15638914033467787', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 22:16:43', 1, 1002001015, '账号未登陆', '2019-07-23 22:16:43');
INSERT INTO `access_log` VALUES (58202, '65.45.15638914033467715', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 22:16:43', 0, 1002001015, '账号未登陆', '2019-07-23 22:16:43');
INSERT INTO `access_log` VALUES (58203, '65.3607.15638914033659521', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 22:16:43', 0, 1002001015, '账号未登陆', '2019-07-23 22:16:43');
INSERT INTO `access_log` VALUES (58204, '65.46.15638914063637791', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 22:16:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-23 22:16:46');
INSERT INTO `access_log` VALUES (58205, '65.50.15638914156867731', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 22:16:56', 80, 0, '', '2019-07-23 22:16:56');
INSERT INTO `access_log` VALUES (58206, '65.54.15638914160197645', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 22:16:56', 19, 0, '', '2019-07-23 22:16:56');
INSERT INTO `access_log` VALUES (58207, '65.49.15638914160197695', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 22:16:56', 19, 2001001000, '服务端发生异常', '2019-07-23 22:16:56');
INSERT INTO `access_log` VALUES (58208, '65.53.15638914160227713', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 22:16:56', 18, 0, '', '2019-07-23 22:16:56');
INSERT INTO `access_log` VALUES (58209, '65.3607.15638914197859523', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 22:17:00', 10, 0, '', '2019-07-23 22:17:00');
INSERT INTO `access_log` VALUES (58210, '65.52.15638914197847751', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 22:17:00', 11, 2001001000, '服务端发生异常', '2019-07-23 22:17:00');
INSERT INTO `access_log` VALUES (58211, '65.51.15638914197867789', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-23 22:17:00', 11, 0, '', '2019-07-23 22:17:00');
INSERT INTO `access_log` VALUES (58212, '59.79.15638935589225515', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:39', 11, 0, '', '2019-07-23 22:52:39');
INSERT INTO `access_log` VALUES (58213, '59.80.15638935589225487', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:39', 27, 2001001000, '服务端发生异常', '2019-07-23 22:52:39');
INSERT INTO `access_log` VALUES (58214, '64.78.15638935676725745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:48', 11, 0, '', '2019-07-23 22:52:48');
INSERT INTO `access_log` VALUES (58215, '64.76.15638935678285735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:48', 3, 0, '', '2019-07-23 22:52:48');
INSERT INTO `access_log` VALUES (58216, '64.84.15638935693195727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:49', 2, 0, '', '2019-07-23 22:52:49');
INSERT INTO `access_log` VALUES (58217, '64.77.15638935699855725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:50', 2, 0, '', '2019-07-23 22:52:50');
INSERT INTO `access_log` VALUES (58218, '64.80.15638935706035743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:51', 2, 0, '', '2019-07-23 22:52:51');
INSERT INTO `access_log` VALUES (58219, '59.78.15638935724725511', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:52', 3, 0, '', '2019-07-23 22:52:52');
INSERT INTO `access_log` VALUES (58220, '59.76.15638935724725503', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:52', 14, 2001001000, '服务端发生异常', '2019-07-23 22:52:52');
INSERT INTO `access_log` VALUES (58221, '64.85.15638935750335763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:55', 1, 0, '', '2019-07-23 22:52:55');
INSERT INTO `access_log` VALUES (58222, '64.83.15638935752125735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:55', 2, 0, '', '2019-07-23 22:52:55');
INSERT INTO `access_log` VALUES (58223, '64.79.15638935773555741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:57', 2, 0, '', '2019-07-23 22:52:57');
INSERT INTO `access_log` VALUES (58224, '64.81.15638935775455733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:58', 2, 0, '', '2019-07-23 22:52:58');
INSERT INTO `access_log` VALUES (58225, '59.77.15638935780405503', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:58', 3, 0, '', '2019-07-23 22:52:58');
INSERT INTO `access_log` VALUES (58226, '59.74.15638935780415521', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:58', 16, 2001001000, '服务端发生异常', '2019-07-23 22:52:58');
INSERT INTO `access_log` VALUES (58227, '64.78.15638935785345747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:59', 2, 0, '', '2019-07-23 22:52:59');
INSERT INTO `access_log` VALUES (58228, '64.76.15638935786925737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:52:59', 2, 0, '', '2019-07-23 22:52:59');
INSERT INTO `access_log` VALUES (58229, '59.72.15638935796715507', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:53:00', 2, 0, '', '2019-07-23 22:53:00');
INSERT INTO `access_log` VALUES (58230, '59.75.15638935796715519', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:53:00', 47, 2001001000, '服务端发生异常', '2019-07-23 22:53:00');
INSERT INTO `access_log` VALUES (58231, '65.49.15638935972127725', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:53:17', 0, 1002001015, '账号未登陆', '2019-07-23 22:53:17');
INSERT INTO `access_log` VALUES (58232, '65.53.15638935972127743', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:53:17', 0, 1002001015, '账号未登陆', '2019-07-23 22:53:17');
INSERT INTO `access_log` VALUES (58233, '65.52.15638935972137781', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:53:17', 0, 1002001015, '账号未登陆', '2019-07-23 22:53:17');
INSERT INTO `access_log` VALUES (58234, '65.51.15638936173957819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:53:37', 89, 0, '', '2019-07-23 22:53:37');
INSERT INTO `access_log` VALUES (58235, '65.45.15638936178357747', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:53:38', 11, 0, '', '2019-07-23 22:53:38');
INSERT INTO `access_log` VALUES (58236, '65.46.15638936178367823', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:53:38', 13, 2001001000, '服务端发生异常', '2019-07-23 22:53:38');
INSERT INTO `access_log` VALUES (58237, '65.47.15638936178447735', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '14.113.139.97', '2019-07-23 22:53:38', 15, 0, '', '2019-07-23 22:53:38');
INSERT INTO `access_log` VALUES (58238, '65.53.15638955906277771', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.10.95.239', '2019-07-23 23:26:31', 12, 1002001012, '访问令牌已过期', '2019-07-23 23:26:31');
INSERT INTO `access_log` VALUES (58239, '65.49.15638955906277753', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.10.95.239', '2019-07-23 23:26:31', 24, 1002001012, '访问令牌已过期', '2019-07-23 23:26:31');
INSERT INTO `access_log` VALUES (58240, '65.52.15638955906277809', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.10.95.239', '2019-07-23 23:26:31', 23, 1002001012, '访问令牌已过期', '2019-07-23 23:26:31');
INSERT INTO `access_log` VALUES (58241, '65.45.15638956149107775', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.10.95.239', '2019-07-23 23:26:55', 97, 0, '', '2019-07-23 23:26:55');
INSERT INTO `access_log` VALUES (58242, '65.47.15638956152297763', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.10.95.239', '2019-07-23 23:26:55', 12, 0, '', '2019-07-23 23:26:55');
INSERT INTO `access_log` VALUES (58243, '65.46.15638956152327851', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.10.95.239', '2019-07-23 23:26:55', 11, 2001001000, '服务端发生异常', '2019-07-23 23:26:55');
INSERT INTO `access_log` VALUES (58244, '65.50.15638956152367791', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.10.95.239', '2019-07-23 23:26:55', 9, 0, '', '2019-07-23 23:26:55');
INSERT INTO `access_log` VALUES (58245, '65.47.15639296854048217', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-24 08:54:45', 24, 1002001012, '访问令牌已过期', '2019-07-24 08:54:45');
INSERT INTO `access_log` VALUES (58246, '65.46.15639296854048305', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-24 08:54:45', 31, 1002001012, '访问令牌已过期', '2019-07-24 08:54:45');
INSERT INTO `access_log` VALUES (58247, '65.49.15639296854048209', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-24 08:54:45', 23, 1002001012, '访问令牌已过期', '2019-07-24 08:54:45');
INSERT INTO `access_log` VALUES (58248, '65.54.15639296905908159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-24 08:54:51', 806, 0, '', '2019-07-24 08:54:51');
INSERT INTO `access_log` VALUES (58249, '65.51.15639296916118301', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-24 08:54:52', 162, 0, '', '2019-07-24 08:54:52');
INSERT INTO `access_log` VALUES (58250, '65.53.15639296916138231', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-24 08:54:52', 159, 0, '', '2019-07-24 08:54:52');
INSERT INTO `access_log` VALUES (58251, '65.45.15639296916118231', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-24 08:54:52', 163, 2001001000, '服务端发生异常', '2019-07-24 08:54:52');
INSERT INTO `access_log` VALUES (58252, '65.46.15639319924788337', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:33:12', 1, 1002001015, '账号未登陆', '2019-07-24 09:33:12');
INSERT INTO `access_log` VALUES (58253, '65.47.15639319924778249', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:33:12', 1, 1002001015, '账号未登陆', '2019-07-24 09:33:12');
INSERT INTO `access_log` VALUES (58254, '65.54.15639319924788191', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:33:12', 1, 1002001015, '账号未登陆', '2019-07-24 09:33:12');
INSERT INTO `access_log` VALUES (58255, '65.51.15639319964378333', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:33:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 09:33:16');
INSERT INTO `access_log` VALUES (58256, '65.45.15639320103148263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:33:30', 93, 0, '', '2019-07-24 09:33:30');
INSERT INTO `access_log` VALUES (58257, '65.52.15639320255868299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:33:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 09:33:46');
INSERT INTO `access_log` VALUES (58258, '65.3607.15639320326440071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:33:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 09:33:53');
INSERT INTO `access_log` VALUES (58259, '65.53.15639320974668265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:34:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 09:34:57');
INSERT INTO `access_log` VALUES (58260, '65.45.15639320995048265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:35:00', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 09:35:00');
INSERT INTO `access_log` VALUES (58261, '65.50.15639321060648281', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:35:06', 64, 0, '', '2019-07-24 09:35:06');
INSERT INTO `access_log` VALUES (58262, '65.52.15639321064538301', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:35:06', 10, 0, '', '2019-07-24 09:35:06');
INSERT INTO `access_log` VALUES (58263, '65.3607.15639321064620073', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:35:06', 9, 0, '', '2019-07-24 09:35:06');
INSERT INTO `access_log` VALUES (58264, '65.49.15639321064688245', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:35:06', 10, 0, '', '2019-07-24 09:35:06');
INSERT INTO `access_log` VALUES (58265, '62.80.15639321206295089', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:35:21', 40, 0, '', '2019-07-24 09:35:21');
INSERT INTO `access_log` VALUES (58266, '64.82.15639321428286267', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:35:43', 24, 0, '', '2019-07-24 09:35:43');
INSERT INTO `access_log` VALUES (58267, '64.77.15639321428216241', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:35:43', 33, 0, '', '2019-07-24 09:35:43');
INSERT INTO `access_log` VALUES (58268, '65.53.15639321666938267', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:36:07', 27, 0, '', '2019-07-24 09:36:07');
INSERT INTO `access_log` VALUES (58269, '65.3607.15639321872480075', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:36:27', 19, 0, '', '2019-07-24 09:36:27');
INSERT INTO `access_log` VALUES (58270, '65.49.15639321945968247', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:36:35', 9, 0, '', '2019-07-24 09:36:35');
INSERT INTO `access_log` VALUES (58271, '65.47.15639321995368255', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:36:40', 15, 0, '', '2019-07-24 09:36:40');
INSERT INTO `access_log` VALUES (58272, '64.81.15639322086766249', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:36:49', 18, 0, '', '2019-07-24 09:36:49');
INSERT INTO `access_log` VALUES (58273, '66.51.15639322223103881', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:37:02', 27, 0, '', '2019-07-24 09:37:02');
INSERT INTO `access_log` VALUES (58274, '59.74.15639322318866037', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:37:12', 25, 0, '', '2019-07-24 09:37:12');
INSERT INTO `access_log` VALUES (58275, '59.75.15639322391396035', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:37:19', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-07-24 09:37:19');
INSERT INTO `access_log` VALUES (58276, '59.71.15639322434356025', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:37:23', 18, 0, '', '2019-07-24 09:37:23');
INSERT INTO `access_log` VALUES (58277, '62.87.15639322594175079', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.78.78', '2019-07-24 09:37:39', 22, 0, '', '2019-07-24 09:37:39');
INSERT INTO `access_log` VALUES (58278, '65.50.15639331822988297', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:53:02', 1, 1002001015, '账号未登陆', '2019-07-24 09:53:02');
INSERT INTO `access_log` VALUES (58279, '65.3607.15639331822980089', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:53:02', 0, 1002001015, '账号未登陆', '2019-07-24 09:53:02');
INSERT INTO `access_log` VALUES (58280, '65.49.15639331823018261', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:53:02', 0, 1002001015, '账号未登陆', '2019-07-24 09:53:02');
INSERT INTO `access_log` VALUES (58281, '65.47.15639332028948269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:53:23', 136, 0, '', '2019-07-24 09:53:23');
INSERT INTO `access_log` VALUES (58282, '65.51.15639332033178353', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:53:23', 169, 0, '', '2019-07-24 09:53:23');
INSERT INTO `access_log` VALUES (58283, '65.54.15639332033138211', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:53:23', 172, 0, '', '2019-07-24 09:53:23');
INSERT INTO `access_log` VALUES (58284, '65.46.15639332033158357', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:53:23', 171, 2001001000, '服务端发生异常', '2019-07-24 09:53:23');
INSERT INTO `access_log` VALUES (58285, '65.45.15639332116188283', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:53:32', 9, 0, '', '2019-07-24 09:53:32');
INSERT INTO `access_log` VALUES (58286, '65.50.15639332116198299', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:53:32', 10, 0, '', '2019-07-24 09:53:32');
INSERT INTO `access_log` VALUES (58287, '65.3607.15639332116190091', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:53:32', 11, 2001001000, '服务端发生异常', '2019-07-24 09:53:32');
INSERT INTO `access_log` VALUES (58288, '65.46.15639332492408359', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:54:09', 16, 0, '', '2019-07-24 09:54:09');
INSERT INTO `access_log` VALUES (58289, '65.51.15639332492458355', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:54:09', 151, 0, '', '2019-07-24 09:54:09');
INSERT INTO `access_log` VALUES (58290, '65.54.15639332492408213', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:54:09', 157, 2001001000, '服务端发生异常', '2019-07-24 09:54:09');
INSERT INTO `access_log` VALUES (58291, '65.53.15639332534868285', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:54:13', 11, 0, '', '2019-07-24 09:54:13');
INSERT INTO `access_log` VALUES (58292, '65.45.15639332534918285', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:54:13', 9, 0, '', '2019-07-24 09:54:14');
INSERT INTO `access_log` VALUES (58293, '65.50.15639332534928301', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.88.24.189', '2019-07-24 09:54:13', 10, 2001001000, '服务端发生异常', '2019-07-24 09:54:14');
INSERT INTO `access_log` VALUES (58294, '65.45.15639341257548297', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.86.125.185', '2019-07-24 10:08:46', 1, 1002001015, '账号未登陆', '2019-07-24 10:08:46');
INSERT INTO `access_log` VALUES (58295, '65.53.15639341257538297', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.86.125.185', '2019-07-24 10:08:46', 0, 1002001015, '账号未登陆', '2019-07-24 10:08:46');
INSERT INTO `access_log` VALUES (58296, '65.3607.15639341257590105', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.86.125.185', '2019-07-24 10:08:46', 1, 1002001015, '账号未登陆', '2019-07-24 10:08:46');
INSERT INTO `access_log` VALUES (58297, '65.49.15639341319418277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.86.125.185', '2019-07-24 10:08:52', 88, 0, '', '2019-07-24 10:08:52');
INSERT INTO `access_log` VALUES (58298, '65.52.15639341322368333', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.86.125.185', '2019-07-24 10:08:52', 9, 0, '', '2019-07-24 10:08:52');
INSERT INTO `access_log` VALUES (58299, '65.47.15639341322408285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.86.125.185', '2019-07-24 10:08:52', 10, 2001001000, '服务端发生异常', '2019-07-24 10:08:52');
INSERT INTO `access_log` VALUES (58300, '65.46.15639341322428373', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.86.125.185', '2019-07-24 10:08:52', 9, 0, '', '2019-07-24 10:08:52');
INSERT INTO `access_log` VALUES (58301, '65.50.15639341495778315', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.86.125.185', '2019-07-24 10:09:10', 9, 0, '', '2019-07-24 10:09:10');
INSERT INTO `access_log` VALUES (58302, '65.53.15639341495798299', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.86.125.185', '2019-07-24 10:09:10', 8, 0, '', '2019-07-24 10:09:10');
INSERT INTO `access_log` VALUES (58303, '65.45.15639341495798299', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '120.86.125.185', '2019-07-24 10:09:10', 10, 2001001000, '服务端发生异常', '2019-07-24 10:09:10');
INSERT INTO `access_log` VALUES (58304, '65.47.15639351172118299', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.234.61.189', '2019-07-24 10:25:17', 5, 1002001012, '访问令牌已过期', '2019-07-24 10:25:17');
INSERT INTO `access_log` VALUES (58305, '65.51.15639351172118383', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.234.61.189', '2019-07-24 10:25:17', 5, 1002001012, '访问令牌已过期', '2019-07-24 10:25:17');
INSERT INTO `access_log` VALUES (58306, '65.54.15639351172208241', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.234.61.189', '2019-07-24 10:25:17', 3, 1002001012, '访问令牌已过期', '2019-07-24 10:25:17');
INSERT INTO `access_log` VALUES (58307, '65.50.15639351288948329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.234.61.189', '2019-07-24 10:25:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 10:25:29');
INSERT INTO `access_log` VALUES (58308, '65.53.15639351387638313', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.234.61.189', '2019-07-24 10:25:39', 55, 0, '', '2019-07-24 10:25:39');
INSERT INTO `access_log` VALUES (58309, '65.49.15639351390298293', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.234.61.189', '2019-07-24 10:25:39', 17, 0, '', '2019-07-24 10:25:39');
INSERT INTO `access_log` VALUES (58310, '65.52.15639351390408349', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.234.61.189', '2019-07-24 10:25:39', 8, 0, '', '2019-07-24 10:25:39');
INSERT INTO `access_log` VALUES (58311, '65.46.15639351390408389', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.234.61.189', '2019-07-24 10:25:39', 9, 2001001000, '服务端发生异常', '2019-07-24 10:25:39');
INSERT INTO `access_log` VALUES (58312, '59.77.15639359042076069', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '218.56.56.106', '2019-07-24 10:38:24', 10, 0, '', '2019-07-24 10:38:24');
INSERT INTO `access_log` VALUES (58313, '59.76.15639359042076069', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '218.56.56.106', '2019-07-24 10:38:24', 22, 2001001000, '服务端发生异常', '2019-07-24 10:38:24');
INSERT INTO `access_log` VALUES (58314, '59.71.15639377512706099', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-24 11:09:11', 10, 0, '', '2019-07-24 11:09:11');
INSERT INTO `access_log` VALUES (58315, '59.80.15639377512716079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-24 11:09:11', 21, 2001001000, '服务端发生异常', '2019-07-24 11:09:11');
INSERT INTO `access_log` VALUES (58316, '65.3607.15639377613360157', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-24 11:09:21', 62, 1002001012, '访问令牌已过期', '2019-07-24 11:09:21');
INSERT INTO `access_log` VALUES (58317, '65.53.15639377613348349', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-24 11:09:21', 64, 1002001012, '访问令牌已过期', '2019-07-24 11:09:21');
INSERT INTO `access_log` VALUES (58318, '65.50.15639377613348365', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-24 11:09:21', 65, 1002001012, '访问令牌已过期', '2019-07-24 11:09:21');
INSERT INTO `access_log` VALUES (58319, '64.76.15639377613946327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-24 11:09:21', 11, 0, '', '2019-07-24 11:09:21');
INSERT INTO `access_log` VALUES (58320, '64.84.15639377615406319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-24 11:09:22', 3, 0, '', '2019-07-24 11:09:22');
INSERT INTO `access_log` VALUES (58321, '64.77.15639377628486317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-24 11:09:23', 2, 0, '', '2019-07-24 11:09:23');
INSERT INTO `access_log` VALUES (58322, '64.82.15639377635166343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-24 11:09:24', 2, 0, '', '2019-07-24 11:09:24');
INSERT INTO `access_log` VALUES (58323, '64.80.15639377643936335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-24 11:09:24', 2, 0, '', '2019-07-24 11:09:24');
INSERT INTO `access_log` VALUES (58324, '65.52.15639377726438385', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-24 11:09:33', 76, 0, '', '2019-07-24 11:09:33');
INSERT INTO `access_log` VALUES (58325, '65.46.15639377730418425', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-24 11:09:33', 12, 0, '', '2019-07-24 11:09:33');
INSERT INTO `access_log` VALUES (58326, '65.47.15639377730538337', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-24 11:09:33', 9, 0, '', '2019-07-24 11:09:33');
INSERT INTO `access_log` VALUES (58327, '65.51.15639377730498421', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-24 11:09:33', 15, 2001001000, '服务端发生异常', '2019-07-24 11:09:33');
INSERT INTO `access_log` VALUES (58328, '59.75.15639416137046161', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.156.68.210', '2019-07-24 12:13:34', 11, 0, '', '2019-07-24 12:13:34');
INSERT INTO `access_log` VALUES (58329, '59.80.15639416137046131', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.156.68.210', '2019-07-24 12:13:34', 24, 2001001000, '服务端发生异常', '2019-07-24 12:13:34');
INSERT INTO `access_log` VALUES (58330, '65.45.15639416162898403', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.156.68.210', '2019-07-24 12:13:36', 1, 1002001015, '账号未登陆', '2019-07-24 12:13:36');
INSERT INTO `access_log` VALUES (58331, '65.54.15639416162888331', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.156.68.210', '2019-07-24 12:13:36', 0, 1002001015, '账号未登陆', '2019-07-24 12:13:36');
INSERT INTO `access_log` VALUES (58332, '65.3607.15639416163060211', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.156.68.210', '2019-07-24 12:13:36', 0, 1002001015, '账号未登陆', '2019-07-24 12:13:36');
INSERT INTO `access_log` VALUES (58333, '65.50.15639416192858419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.156.68.210', '2019-07-24 12:13:39', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 12:13:39');
INSERT INTO `access_log` VALUES (58334, '65.49.15639416246898383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.156.68.210', '2019-07-24 12:13:45', 78, 0, '', '2019-07-24 12:13:45');
INSERT INTO `access_log` VALUES (58335, '65.52.15639416249288437', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.156.68.210', '2019-07-24 12:13:45', 10, 0, '', '2019-07-24 12:13:45');
INSERT INTO `access_log` VALUES (58336, '65.47.15639416249328391', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.156.68.210', '2019-07-24 12:13:45', 9, 0, '', '2019-07-24 12:13:45');
INSERT INTO `access_log` VALUES (58337, '65.46.15639416249308479', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.156.68.210', '2019-07-24 12:13:45', 10, 2001001000, '服务端发生异常', '2019-07-24 12:13:45');
INSERT INTO `access_log` VALUES (58338, '64.82.15639416385106395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.156.68.210', '2019-07-24 12:13:59', 10, 0, '', '2019-07-24 12:13:59');
INSERT INTO `access_log` VALUES (58339, '64.80.15639416386296387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.156.68.210', '2019-07-24 12:13:59', 3, 0, '', '2019-07-24 12:13:59');
INSERT INTO `access_log` VALUES (58340, '64.85.15639416396426407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.156.68.210', '2019-07-24 12:14:00', 2, 0, '', '2019-07-24 12:14:00');
INSERT INTO `access_log` VALUES (58341, '64.83.15639416404596379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.156.68.210', '2019-07-24 12:14:00', 2, 0, '', '2019-07-24 12:14:00');
INSERT INTO `access_log` VALUES (58342, '59.77.15639421128676153', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '182.148.48.165', '2019-07-24 12:21:53', 4, 0, '', '2019-07-24 12:21:53');
INSERT INTO `access_log` VALUES (58343, '59.76.15639421128696153', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '182.148.48.165', '2019-07-24 12:21:53', 18, 2001001000, '服务端发生异常', '2019-07-24 12:21:53');
INSERT INTO `access_log` VALUES (58344, '65.52.15639423395038447', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.194.243.137', '2019-07-24 12:25:40', 0, 1002001015, '账号未登陆', '2019-07-24 12:25:40');
INSERT INTO `access_log` VALUES (58345, '65.47.15639423395268401', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.194.243.137', '2019-07-24 12:25:40', 1, 1002001015, '账号未登陆', '2019-07-24 12:25:40');
INSERT INTO `access_log` VALUES (58346, '65.51.15639423395278485', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.194.243.137', '2019-07-24 12:25:40', 0, 1002001015, '账号未登陆', '2019-07-24 12:25:40');
INSERT INTO `access_log` VALUES (58347, '65.3607.15639423660280223', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.194.243.137', '2019-07-24 12:26:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 12:26:06');
INSERT INTO `access_log` VALUES (58348, '65.53.15639423773028413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.194.243.137', '2019-07-24 12:26:17', 186, 0, '', '2019-07-24 12:26:17');
INSERT INTO `access_log` VALUES (58349, '65.50.15639423779178431', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.194.243.137', '2019-07-24 12:26:18', 10, 0, '', '2019-07-24 12:26:18');
INSERT INTO `access_log` VALUES (58350, '65.49.15639423779238395', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.194.243.137', '2019-07-24 12:26:18', 11, 2001001000, '服务端发生异常', '2019-07-24 12:26:18');
INSERT INTO `access_log` VALUES (58351, '65.46.15639423779268491', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.194.243.137', '2019-07-24 12:26:18', 9, 0, '', '2019-07-24 12:26:18');
INSERT INTO `access_log` VALUES (58352, '65.50.15639453432278471', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-24 13:15:43', 14, 1002001012, '访问令牌已过期', '2019-07-24 13:15:43');
INSERT INTO `access_log` VALUES (58353, '65.46.15639453432278531', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-24 13:15:43', 20, 1002001012, '访问令牌已过期', '2019-07-24 13:15:43');
INSERT INTO `access_log` VALUES (58354, '65.52.15639453432278489', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-24 13:15:43', 22, 1002001012, '访问令牌已过期', '2019-07-24 13:15:43');
INSERT INTO `access_log` VALUES (58355, '65.51.15639453451608527', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-24 13:15:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 13:15:45');
INSERT INTO `access_log` VALUES (58356, '65.45.15639453540978457', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-24 13:15:54', 84, 0, '', '2019-07-24 13:15:54');
INSERT INTO `access_log` VALUES (58357, '65.3607.15639453544630265', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-24 13:15:54', 20, 0, '', '2019-07-24 13:15:54');
INSERT INTO `access_log` VALUES (58358, '65.53.15639453544678455', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-24 13:15:54', 18, 0, '', '2019-07-24 13:15:54');
INSERT INTO `access_log` VALUES (58359, '65.54.15639453544678385', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.5.34.85', '2019-07-24 13:15:54', 19, 2001001000, '服务端发生异常', '2019-07-24 13:15:54');
INSERT INTO `access_log` VALUES (58360, '65.3607.15639468126290283', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.164', '2019-07-24 13:40:13', 0, 1002001015, '账号未登陆', '2019-07-24 13:40:13');
INSERT INTO `access_log` VALUES (58361, '65.52.15639468126298515', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.164', '2019-07-24 13:40:13', 0, 1002001015, '账号未登陆', '2019-07-24 13:40:13');
INSERT INTO `access_log` VALUES (58362, '65.49.15639468126308459', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.164', '2019-07-24 13:40:13', 0, 1002001015, '账号未登陆', '2019-07-24 13:40:13');
INSERT INTO `access_log` VALUES (58363, '65.46.15639468191148553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.164', '2019-07-24 13:40:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 13:40:19');
INSERT INTO `access_log` VALUES (58364, '65.51.15639468269988549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.164', '2019-07-24 13:40:27', 54, 0, '', '2019-07-24 13:40:27');
INSERT INTO `access_log` VALUES (58365, '65.47.15639468272918465', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.164', '2019-07-24 13:40:27', 10, 0, '', '2019-07-24 13:40:27');
INSERT INTO `access_log` VALUES (58366, '65.45.15639468273008479', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.164', '2019-07-24 13:40:27', 10, 2001001000, '服务端发生异常', '2019-07-24 13:40:27');
INSERT INTO `access_log` VALUES (58367, '65.53.15639468273068475', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.164', '2019-07-24 13:40:27', 9, 0, '', '2019-07-24 13:40:27');
INSERT INTO `access_log` VALUES (58368, '65.54.15639468324278407', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.164', '2019-07-24 13:40:32', 9, 0, '', '2019-07-24 13:40:32');
INSERT INTO `access_log` VALUES (58369, '65.49.15639468324288461', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.164', '2019-07-24 13:40:32', 9, 2001001000, '服务端发生异常', '2019-07-24 13:40:32');
INSERT INTO `access_log` VALUES (58370, '65.3607.15639468324360285', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.76.251.164', '2019-07-24 13:40:32', 9, 0, '', '2019-07-24 13:40:32');
INSERT INTO `access_log` VALUES (58371, '65.45.15639476134948491', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:53:33', 0, 1002001015, '账号未登陆', '2019-07-24 13:53:33');
INSERT INTO `access_log` VALUES (58372, '65.50.15639476134948505', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:53:33', 1, 1002001015, '账号未登陆', '2019-07-24 13:53:33');
INSERT INTO `access_log` VALUES (58373, '65.51.15639476134948561', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:53:33', 1, 1002001015, '账号未登陆', '2019-07-24 13:53:33');
INSERT INTO `access_log` VALUES (58374, '65.47.15639476163368477', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:53:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 13:53:36');
INSERT INTO `access_log` VALUES (58375, '65.3607.15639476331580297', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:53:53', 81, 0, '', '2019-07-24 13:53:53');
INSERT INTO `access_log` VALUES (58376, '65.54.15639476334958419', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:53:53', 9, 0, '', '2019-07-24 13:53:54');
INSERT INTO `access_log` VALUES (58377, '65.49.15639476334998473', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:53:54', 10, 2001001000, '服务端发生异常', '2019-07-24 13:53:54');
INSERT INTO `access_log` VALUES (58378, '65.52.15639476335038529', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:53:54', 9, 0, '', '2019-07-24 13:53:54');
INSERT INTO `access_log` VALUES (58379, '65.51.15639476404548563', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:54:00', 10, 0, '', '2019-07-24 13:54:00');
INSERT INTO `access_log` VALUES (58380, '65.50.15639476404578507', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:54:00', 10, 2001001000, '服务端发生异常', '2019-07-24 13:54:00');
INSERT INTO `access_log` VALUES (58381, '65.45.15639476404658493', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:54:00', 9, 0, '', '2019-07-24 13:54:00');
INSERT INTO `access_log` VALUES (58382, '65.53.15639476527608489', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:54:13', 8, 0, '', '2019-07-24 13:54:13');
INSERT INTO `access_log` VALUES (58383, '65.3607.15639476527640299', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:54:13', 10, 2001001000, '服务端发生异常', '2019-07-24 13:54:13');
INSERT INTO `access_log` VALUES (58384, '65.49.15639476527668475', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:54:13', 9, 0, '', '2019-07-24 13:54:13');
INSERT INTO `access_log` VALUES (58385, '65.54.15639476727858421', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:54:33', 9, 0, '', '2019-07-24 13:54:33');
INSERT INTO `access_log` VALUES (58386, '65.46.15639476727898569', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:54:33', 9, 2001001000, '服务端发生异常', '2019-07-24 13:54:33');
INSERT INTO `access_log` VALUES (58387, '65.51.15639476727958565', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.190.25.106', '2019-07-24 13:54:33', 8, 0, '', '2019-07-24 13:54:33');
INSERT INTO `access_log` VALUES (58388, '65.53.15639497034768517', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.116.109.53', '2019-07-24 14:28:23', 13, 1002001012, '访问令牌已过期', '2019-07-24 14:28:23');
INSERT INTO `access_log` VALUES (58389, '65.52.15639497034778559', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.116.109.53', '2019-07-24 14:28:23', 18, 1002001012, '访问令牌已过期', '2019-07-24 14:28:23');
INSERT INTO `access_log` VALUES (58390, '65.46.15639497034818597', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.116.109.53', '2019-07-24 14:28:23', 17, 1002001012, '访问令牌已过期', '2019-07-24 14:28:23');
INSERT INTO `access_log` VALUES (58391, '65.54.15639497098658449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.116.109.53', '2019-07-24 14:28:30', 80, 0, '', '2019-07-24 14:28:30');
INSERT INTO `access_log` VALUES (58392, '65.50.15639497102038537', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.116.109.53', '2019-07-24 14:28:30', 11, 0, '', '2019-07-24 14:28:30');
INSERT INTO `access_log` VALUES (58393, '65.45.15639497102118523', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.116.109.53', '2019-07-24 14:28:30', 10, 2001001000, '服务端发生异常', '2019-07-24 14:28:30');
INSERT INTO `access_log` VALUES (58394, '65.47.15639497102198509', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.116.109.53', '2019-07-24 14:28:30', 8, 0, '', '2019-07-24 14:28:30');
INSERT INTO `access_log` VALUES (58395, '65.3607.15639497161390329', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.116.109.53', '2019-07-24 14:28:36', 20, 0, '', '2019-07-24 14:28:36');
INSERT INTO `access_log` VALUES (58396, '65.52.15639497161408561', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.116.109.53', '2019-07-24 14:28:36', 21, 0, '', '2019-07-24 14:28:36');
INSERT INTO `access_log` VALUES (58397, '65.49.15639497161408505', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.116.109.53', '2019-07-24 14:28:36', 21, 2001001000, '服务端发生异常', '2019-07-24 14:28:36');
INSERT INTO `access_log` VALUES (58398, '59.75.15639498052646271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:30:05', 17, 0, '', '2019-07-24 14:30:05');
INSERT INTO `access_log` VALUES (58399, '59.71.15639498052666261', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:30:05', 29, 2001001000, '服务端发生异常', '2019-07-24 14:30:05');
INSERT INTO `access_log` VALUES (58400, '64.77.15639498095526479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:30:10', 15, 0, '', '2019-07-24 14:30:10');
INSERT INTO `access_log` VALUES (58401, '64.82.15639498097096505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:30:10', 4, 0, '', '2019-07-24 14:30:10');
INSERT INTO `access_log` VALUES (58402, '59.79.15639498125366269', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:30:13', 3, 0, '', '2019-07-24 14:30:13');
INSERT INTO `access_log` VALUES (58403, '59.73.15639498125366267', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:30:13', 19, 2001001000, '服务端发生异常', '2019-07-24 14:30:13');
INSERT INTO `access_log` VALUES (58404, '65.3607.15639498256840331', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:30:26', 1, 1002001015, '账号未登陆', '2019-07-24 14:30:26');
INSERT INTO `access_log` VALUES (58405, '65.49.15639498256868507', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:30:26', 1, 1002001015, '账号未登陆', '2019-07-24 14:30:26');
INSERT INTO `access_log` VALUES (58406, '65.53.15639498256968521', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:30:26', 0, 1002001015, '账号未登陆', '2019-07-24 14:30:26');
INSERT INTO `access_log` VALUES (58407, '65.46.15639498297638601', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:30:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 14:30:30');
INSERT INTO `access_log` VALUES (58408, '65.51.15639498350098597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:30:35', 201, 0, '', '2019-07-24 14:30:35');
INSERT INTO `access_log` VALUES (58409, '65.54.15639498354648453', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:30:35', 9, 0, '', '2019-07-24 14:30:35');
INSERT INTO `access_log` VALUES (58410, '65.47.15639498354668513', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:30:35', 10, 2001001000, '服务端发生异常', '2019-07-24 14:30:35');
INSERT INTO `access_log` VALUES (58411, '65.45.15639498354688527', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:30:35', 8, 0, '', '2019-07-24 14:30:35');
INSERT INTO `access_log` VALUES (58412, '65.49.15639498784708509', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:31:18', 9, 0, '', '2019-07-24 14:31:18');
INSERT INTO `access_log` VALUES (58413, '65.46.15639498784708603', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:31:18', 9, 0, '', '2019-07-24 14:31:18');
INSERT INTO `access_log` VALUES (58414, '65.53.15639498784708523', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:31:18', 11, 2001001000, '服务端发生异常', '2019-07-24 14:31:18');
INSERT INTO `access_log` VALUES (58415, '65.54.15639498934848455', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:31:33', 9, 0, '', '2019-07-24 14:31:33');
INSERT INTO `access_log` VALUES (58416, '65.45.15639498934888529', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:31:33', 10, 2001001000, '服务端发生异常', '2019-07-24 14:31:33');
INSERT INTO `access_log` VALUES (58417, '65.47.15639498934928515', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 14:31:33', 8, 0, '', '2019-07-24 14:31:34');
INSERT INTO `access_log` VALUES (58418, '65.3607.15639500755790337', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.103.156', '2019-07-24 14:34:36', 1, 1002001015, '账号未登陆', '2019-07-24 14:34:36');
INSERT INTO `access_log` VALUES (58419, '65.49.15639500755818513', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.103.156', '2019-07-24 14:34:36', 0, 1002001015, '账号未登陆', '2019-07-24 14:34:36');
INSERT INTO `access_log` VALUES (58420, '65.46.15639500755818607', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.103.156', '2019-07-24 14:34:36', 0, 1002001015, '账号未登陆', '2019-07-24 14:34:36');
INSERT INTO `access_log` VALUES (58421, '65.51.15639500813498603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.103.156', '2019-07-24 14:34:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 14:34:41');
INSERT INTO `access_log` VALUES (58422, '65.47.15639500987208519', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.103.156', '2019-07-24 14:34:59', 93, 0, '', '2019-07-24 14:34:59');
INSERT INTO `access_log` VALUES (58423, '65.45.15639501073818533', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.103.156', '2019-07-24 14:35:07', 92, 0, '', '2019-07-24 14:35:07');
INSERT INTO `access_log` VALUES (58424, '59.73.15639502391836273', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:19', 3, 0, '', '2019-07-24 14:37:19');
INSERT INTO `access_log` VALUES (58425, '59.78.15639502391846271', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:19', 14, 2001001000, '服务端发生异常', '2019-07-24 14:37:19');
INSERT INTO `access_log` VALUES (58426, '64.82.15639502439906513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:24', 3, 0, '', '2019-07-24 14:37:24');
INSERT INTO `access_log` VALUES (58427, '64.85.15639502441336525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:24', 2, 0, '', '2019-07-24 14:37:24');
INSERT INTO `access_log` VALUES (58428, '64.84.15639502457246487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:26', 2, 0, '', '2019-07-24 14:37:26');
INSERT INTO `access_log` VALUES (58429, '64.80.15639502465146503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:27', 2, 0, '', '2019-07-24 14:37:27');
INSERT INTO `access_log` VALUES (58430, '64.77.15639502471066485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:27', 2, 0, '', '2019-07-24 14:37:27');
INSERT INTO `access_log` VALUES (58431, '59.76.15639502493766263', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:29', 3, 0, '', '2019-07-24 14:37:29');
INSERT INTO `access_log` VALUES (58432, '59.77.15639502493766263', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:29', 16, 2001001000, '服务端发生异常', '2019-07-24 14:37:29');
INSERT INTO `access_log` VALUES (58433, '64.83.15639502530286497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:33', 1, 0, '', '2019-07-24 14:37:33');
INSERT INTO `access_log` VALUES (58434, '64.79.15639502531786501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:33', 2, 0, '', '2019-07-24 14:37:33');
INSERT INTO `access_log` VALUES (58435, '64.81.15639502549266495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:35', 2, 0, '', '2019-07-24 14:37:35');
INSERT INTO `access_log` VALUES (58436, '64.78.15639502553486509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:35', 2, 0, '', '2019-07-24 14:37:35');
INSERT INTO `access_log` VALUES (58437, '64.82.15639502559556515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:36', 2, 0, '', '2019-07-24 14:37:36');
INSERT INTO `access_log` VALUES (58438, '64.85.15639502562796527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:36', 2, 0, '', '2019-07-24 14:37:36');
INSERT INTO `access_log` VALUES (58439, '59.72.15639502574076267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:37', 2, 0, '', '2019-07-24 14:37:37');
INSERT INTO `access_log` VALUES (58440, '59.80.15639502574076249', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 14:37:37', 15, 2001001000, '服务端发生异常', '2019-07-24 14:37:37');
INSERT INTO `access_log` VALUES (58441, '65.49.15639504298058519', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.103.156', '2019-07-24 14:40:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 14:40:30');
INSERT INTO `access_log` VALUES (58442, '65.53.15639506071058535', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.103.156', '2019-07-24 14:43:27', 103, 0, '', '2019-07-24 14:43:27');
INSERT INTO `access_log` VALUES (58443, '65.51.15639506075548611', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.103.156', '2019-07-24 14:43:28', 10, 0, '', '2019-07-24 14:43:28');
INSERT INTO `access_log` VALUES (58444, '65.54.15639506075608467', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.103.156', '2019-07-24 14:43:28', 10, 2001001000, '服务端发生异常', '2019-07-24 14:43:28');
INSERT INTO `access_log` VALUES (58445, '65.47.15639506075648527', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.103.156', '2019-07-24 14:43:28', 9, 0, '', '2019-07-24 14:43:28');
INSERT INTO `access_log` VALUES (58446, '65.46.15639506784788617', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.103.156', '2019-07-24 14:44:38', 1, 1002001015, '账号未登陆', '2019-07-24 14:44:38');
INSERT INTO `access_log` VALUES (58447, '65.3607.15639506784780347', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.103.156', '2019-07-24 14:44:38', 1, 1002001015, '账号未登陆', '2019-07-24 14:44:38');
INSERT INTO `access_log` VALUES (58448, '65.53.15639506787288537', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.103.156', '2019-07-24 14:44:39', 1, 1002001015, '账号未登陆', '2019-07-24 14:44:39');
INSERT INTO `access_log` VALUES (58449, '65.47.15639506971968529', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.103.156', '2019-07-24 14:44:57', 76, 0, '', '2019-07-24 14:44:57');
INSERT INTO `access_log` VALUES (58450, '65.45.15639506977308543', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.103.156', '2019-07-24 14:44:58', 9, 0, '', '2019-07-24 14:44:58');
INSERT INTO `access_log` VALUES (58451, '65.50.15639506977378557', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.103.156', '2019-07-24 14:44:58', 9, 2001001000, '服务端发生异常', '2019-07-24 14:44:58');
INSERT INTO `access_log` VALUES (58452, '65.52.15639506977478581', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.103.156', '2019-07-24 14:44:58', 17, 0, '', '2019-07-24 14:44:58');
INSERT INTO `access_log` VALUES (58453, '59.71.15639510112126279', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '182.148.13.90', '2019-07-24 14:50:11', 3, 0, '', '2019-07-24 14:50:11');
INSERT INTO `access_log` VALUES (58454, '59.75.15639510112136289', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '182.148.13.90', '2019-07-24 14:50:11', 27, 2001001000, '服务端发生异常', '2019-07-24 14:50:11');
INSERT INTO `access_log` VALUES (58455, '64.84.15639510164116499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '182.148.13.90', '2019-07-24 14:50:16', 3, 0, '', '2019-07-24 14:50:16');
INSERT INTO `access_log` VALUES (58456, '64.80.15639510165586515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '182.148.13.90', '2019-07-24 14:50:17', 2, 0, '', '2019-07-24 14:50:17');
INSERT INTO `access_log` VALUES (58457, '64.83.15639510229906509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '182.148.13.90', '2019-07-24 14:50:23', 2, 0, '', '2019-07-24 14:50:23');
INSERT INTO `access_log` VALUES (58458, '64.79.15639510231996513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '182.148.13.90', '2019-07-24 14:50:23', 2, 0, '', '2019-07-24 14:50:23');
INSERT INTO `access_log` VALUES (58459, '64.81.15639510273626507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '182.148.13.90', '2019-07-24 14:50:27', 2, 0, '', '2019-07-24 14:50:27');
INSERT INTO `access_log` VALUES (58460, '64.78.15639510274776521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '182.148.13.90', '2019-07-24 14:50:27', 2, 0, '', '2019-07-24 14:50:27');
INSERT INTO `access_log` VALUES (58461, '59.78.15639510281626283', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '182.148.13.90', '2019-07-24 14:50:28', 2, 0, '', '2019-07-24 14:50:28');
INSERT INTO `access_log` VALUES (58462, '59.73.15639510281626285', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '182.148.13.90', '2019-07-24 14:50:28', 15, 2001001000, '服务端发生异常', '2019-07-24 14:50:28');
INSERT INTO `access_log` VALUES (58463, '65.50.15639510993478563', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:51:39', 0, 1002001015, '账号未登陆', '2019-07-24 14:51:39');
INSERT INTO `access_log` VALUES (58464, '65.45.15639510993608549', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:51:39', 0, 1002001015, '账号未登陆', '2019-07-24 14:51:39');
INSERT INTO `access_log` VALUES (58465, '65.52.15639510993618587', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:51:39', 1, 1002001015, '账号未登陆', '2019-07-24 14:51:39');
INSERT INTO `access_log` VALUES (58466, '65.49.15639511051178531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:51:45', 106, 0, '', '2019-07-24 14:51:45');
INSERT INTO `access_log` VALUES (58467, '65.46.15639511056918625', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:51:46', 16, 2001001000, '服务端发生异常', '2019-07-24 14:51:46');
INSERT INTO `access_log` VALUES (58468, '65.53.15639511056938545', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:51:46', 17, 0, '', '2019-07-24 14:51:46');
INSERT INTO `access_log` VALUES (58469, '65.3607.15639511056910355', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:51:46', 18, 0, '', '2019-07-24 14:51:46');
INSERT INTO `access_log` VALUES (58470, '65.51.15639511271188621', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:52:07', 9, 0, '', '2019-07-24 14:52:07');
INSERT INTO `access_log` VALUES (58471, '65.47.15639511271228537', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:52:07', 10, 2001001000, '服务端发生异常', '2019-07-24 14:52:07');
INSERT INTO `access_log` VALUES (58472, '65.50.15639511271268565', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:52:07', 8, 0, '', '2019-07-24 14:52:07');
INSERT INTO `access_log` VALUES (58473, '65.52.15639511301398589', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:52:10', 9, 0, '', '2019-07-24 14:52:10');
INSERT INTO `access_log` VALUES (58474, '65.49.15639511301428533', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:52:10', 9, 2001001000, '服务端发生异常', '2019-07-24 14:52:10');
INSERT INTO `access_log` VALUES (58475, '65.53.15639511301478547', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:52:10', 9, 0, '', '2019-07-24 14:52:10');
INSERT INTO `access_log` VALUES (58476, '65.46.15639511366208627', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:52:17', 9, 0, '', '2019-07-24 14:52:17');
INSERT INTO `access_log` VALUES (58477, '65.3607.15639511366230357', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:52:17', 10, 2001001000, '服务端发生异常', '2019-07-24 14:52:17');
INSERT INTO `access_log` VALUES (58478, '65.54.15639511366288479', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '182.148.13.90', '2019-07-24 14:52:17', 8, 0, '', '2019-07-24 14:52:17');
INSERT INTO `access_log` VALUES (58479, '65.3607.15639597185330475', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.212.105.89', '2019-07-24 17:15:19', 24, 1002001012, '访问令牌已过期', '2019-07-24 17:15:19');
INSERT INTO `access_log` VALUES (58480, '65.50.15639597185348681', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.212.105.89', '2019-07-24 17:15:19', 24, 1002001012, '访问令牌已过期', '2019-07-24 17:15:19');
INSERT INTO `access_log` VALUES (58481, '65.47.15639597185368657', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.212.105.89', '2019-07-24 17:15:19', 25, 1002001012, '访问令牌已过期', '2019-07-24 17:15:19');
INSERT INTO `access_log` VALUES (58482, '65.54.15639597263598597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.212.105.89', '2019-07-24 17:15:26', 80, 0, '', '2019-07-24 17:15:26');
INSERT INTO `access_log` VALUES (58483, '65.53.15639597267058665', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.212.105.89', '2019-07-24 17:15:27', 11, 0, '', '2019-07-24 17:15:27');
INSERT INTO `access_log` VALUES (58484, '65.49.15639597267098651', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.212.105.89', '2019-07-24 17:15:27', 11, 2001001000, '服务端发生异常', '2019-07-24 17:15:27');
INSERT INTO `access_log` VALUES (58485, '65.52.15639597267118707', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '118.212.105.89', '2019-07-24 17:15:27', 11, 0, '', '2019-07-24 17:15:27');
INSERT INTO `access_log` VALUES (58486, '59.76.15639631153126435', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 18:11:55', 10, 0, '', '2019-07-24 18:11:55');
INSERT INTO `access_log` VALUES (58487, '59.77.15639631153126437', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 18:11:55', 39, 2001001000, '服务端发生异常', '2019-07-24 18:11:55');
INSERT INTO `access_log` VALUES (58488, '64.76.15639631187556671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 18:11:59', 12, 0, '', '2019-07-24 18:11:59');
INSERT INTO `access_log` VALUES (58489, '64.82.15639631191586689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 18:11:59', 3, 0, '', '2019-07-24 18:11:59');
INSERT INTO `access_log` VALUES (58490, '64.84.15639631232446665', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 18:12:03', 605, 0, '', '2019-07-24 18:12:04');
INSERT INTO `access_log` VALUES (58491, '64.85.15639631225496703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 18:12:03', 1300, 0, '', '2019-07-24 18:12:04');
INSERT INTO `access_log` VALUES (58492, '65.53.15639631357708711', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 18:12:16', 4, 1002001012, '访问令牌已过期', '2019-07-24 18:12:16');
INSERT INTO `access_log` VALUES (58493, '65.49.15639631357718697', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 18:12:16', 4, 1002001012, '访问令牌已过期', '2019-07-24 18:12:16');
INSERT INTO `access_log` VALUES (58494, '65.52.15639631357728753', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 18:12:16', 6, 1002001012, '访问令牌已过期', '2019-07-24 18:12:16');
INSERT INTO `access_log` VALUES (58495, '65.47.15639631645398705', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 18:12:45', 62, 0, '', '2019-07-24 18:12:45');
INSERT INTO `access_log` VALUES (58496, '65.50.15639631648408729', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 18:12:45', 11, 0, '', '2019-07-24 18:12:45');
INSERT INTO `access_log` VALUES (58497, '65.3607.15639631648430523', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 18:12:45', 11, 2001001000, '服务端发生异常', '2019-07-24 18:12:45');
INSERT INTO `access_log` VALUES (58498, '65.45.15639631648468717', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.148.13.90', '2019-07-24 18:12:45', 10, 0, '', '2019-07-24 18:12:45');
INSERT INTO `access_log` VALUES (58499, '59.74.15639641704856469', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.96.196.201', '2019-07-24 18:29:30', 4, 0, '', '2019-07-24 18:29:30');
INSERT INTO `access_log` VALUES (58500, '59.72.15639641704866451', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '119.96.196.201', '2019-07-24 18:29:30', 15, 2001001000, '服务端发生异常', '2019-07-24 18:29:31');
INSERT INTO `access_log` VALUES (58501, '65.46.15639660733128831', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 19:01:13', 1, 1002001015, '账号未登陆', '2019-07-24 19:01:13');
INSERT INTO `access_log` VALUES (58502, '65.51.15639660733118825', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 19:01:13', 1, 1002001015, '账号未登陆', '2019-07-24 19:01:13');
INSERT INTO `access_log` VALUES (58503, '65.47.15639660733388745', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 19:01:13', 0, 1002001015, '账号未登陆', '2019-07-24 19:01:13');
INSERT INTO `access_log` VALUES (58504, '65.3607.15639660751690563', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 19:01:15', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 19:01:15');
INSERT INTO `access_log` VALUES (58505, '65.50.15639660789428769', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 19:01:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 19:01:19');
INSERT INTO `access_log` VALUES (58506, '65.54.15639660954368685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 19:01:35', 98, 0, '', '2019-07-24 19:01:36');
INSERT INTO `access_log` VALUES (58507, '65.53.15639660958558753', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 19:01:36', 12, 0, '', '2019-07-24 19:01:36');
INSERT INTO `access_log` VALUES (58508, '65.52.15639660958568795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 19:01:36', 14, 2001001000, '服务端发生异常', '2019-07-24 19:01:36');
INSERT INTO `access_log` VALUES (58509, '65.49.15639660958608739', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 19:01:36', 11, 0, '', '2019-07-24 19:01:36');
INSERT INTO `access_log` VALUES (58510, '65.46.15639661049178833', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 19:01:45', 10, 0, '', '2019-07-24 19:01:45');
INSERT INTO `access_log` VALUES (58511, '65.47.15639661049228747', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 19:01:45', 9, 2001001000, '服务端发生异常', '2019-07-24 19:01:45');
INSERT INTO `access_log` VALUES (58512, '65.3607.15639661049250565', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-24 19:01:45', 9, 0, '', '2019-07-24 19:01:45');
INSERT INTO `access_log` VALUES (58513, '59.72.15639673045266493', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-24 19:21:45', 10, 0, '', '2019-07-24 19:21:45');
INSERT INTO `access_log` VALUES (58514, '59.80.15639673045316479', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-24 19:21:45', 15, 2001001000, '服务端发生异常', '2019-07-24 19:21:45');
INSERT INTO `access_log` VALUES (58515, '65.3607.15639673976680583', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-24 19:23:18', 56, 1002001012, '访问令牌已过期', '2019-07-24 19:23:18');
INSERT INTO `access_log` VALUES (58516, '65.51.15639673976688845', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-24 19:23:18', 56, 1002001012, '访问令牌已过期', '2019-07-24 19:23:18');
INSERT INTO `access_log` VALUES (58517, '65.46.15639673976698851', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-24 19:23:18', 56, 1002001012, '访问令牌已过期', '2019-07-24 19:23:18');
INSERT INTO `access_log` VALUES (58518, '65.50.15639674044788789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-24 19:23:24', 70, 0, '', '2019-07-24 19:23:25');
INSERT INTO `access_log` VALUES (58519, '65.45.15639674048028777', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-24 19:23:25', 10, 0, '', '2019-07-24 19:23:25');
INSERT INTO `access_log` VALUES (58520, '65.49.15639674048058759', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-24 19:23:25', 9, 0, '', '2019-07-24 19:23:25');
INSERT INTO `access_log` VALUES (58521, '65.54.15639674048038705', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.250.60.9', '2019-07-24 19:23:25', 11, 2001001000, '服务端发生异常', '2019-07-24 19:23:25');
INSERT INTO `access_log` VALUES (58522, '59.77.15639702360786533', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.247.68.37', '2019-07-24 20:10:36', 15, 0, '', '2019-07-24 20:10:36');
INSERT INTO `access_log` VALUES (58523, '59.74.15639702360816551', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.247.68.37', '2019-07-24 20:10:36', 35, 2001001000, '服务端发生异常', '2019-07-24 20:10:36');
INSERT INTO `access_log` VALUES (58524, '64.78.15639702402396781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.247.68.37', '2019-07-24 20:10:40', 12, 0, '', '2019-07-24 20:10:40');
INSERT INTO `access_log` VALUES (58525, '64.76.15639702403696767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.247.68.37', '2019-07-24 20:10:40', 3, 0, '', '2019-07-24 20:10:40');
INSERT INTO `access_log` VALUES (58526, '64.82.15639702437906785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.247.68.37', '2019-07-24 20:10:44', 2, 0, '', '2019-07-24 20:10:44');
INSERT INTO `access_log` VALUES (58527, '64.85.15639702439036799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.247.68.37', '2019-07-24 20:10:44', 2, 0, '', '2019-07-24 20:10:44');
INSERT INTO `access_log` VALUES (58528, '59.72.15639702454826533', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.247.68.37', '2019-07-24 20:10:45', 3, 0, '', '2019-07-24 20:10:45');
INSERT INTO `access_log` VALUES (58529, '59.80.15639702454836519', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.247.68.37', '2019-07-24 20:10:45', 17, 2001001000, '服务端发生异常', '2019-07-24 20:10:46');
INSERT INTO `access_log` VALUES (58530, '65.47.15639733519188845', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-24 21:02:32', 13, 1002001012, '访问令牌已过期', '2019-07-24 21:02:32');
INSERT INTO `access_log` VALUES (58531, '65.50.15639733519188871', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-24 21:02:32', 16, 1002001012, '访问令牌已过期', '2019-07-24 21:02:32');
INSERT INTO `access_log` VALUES (58532, '65.45.15639733519198859', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-24 21:02:32', 26, 1002001012, '访问令牌已过期', '2019-07-24 21:02:32');
INSERT INTO `access_log` VALUES (58533, '59.71.15639733538036581', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-24 21:02:34', 17, 0, '', '2019-07-24 21:02:34');
INSERT INTO `access_log` VALUES (58534, '59.80.15639733537966561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-24 21:02:34', 29, 2001001000, '服务端发生异常', '2019-07-24 21:02:34');
INSERT INTO `access_log` VALUES (58535, '65.54.15639733563958785', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-24 21:02:36', 63, 0, '', '2019-07-24 21:02:36');
INSERT INTO `access_log` VALUES (58536, '65.49.15639733567298839', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-24 21:02:37', 10, 0, '', '2019-07-24 21:02:37');
INSERT INTO `access_log` VALUES (58537, '65.52.15639733567338897', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-24 21:02:37', 10, 2001001000, '服务端发生异常', '2019-07-24 21:02:37');
INSERT INTO `access_log` VALUES (58538, '65.53.15639733567368853', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-24 21:02:37', 10, 0, '', '2019-07-24 21:02:37');
INSERT INTO `access_log` VALUES (58539, '64.85.15639733619616841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-24 21:02:42', 18, 0, '', '2019-07-24 21:02:42');
INSERT INTO `access_log` VALUES (58540, '64.80.15639733621266819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.92.226.198', '2019-07-24 21:02:42', 19, 0, '', '2019-07-24 21:02:42');
INSERT INTO `access_log` VALUES (58541, '59.79.15639775437856645', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.84.118.203', '2019-07-24 22:12:24', 12, 0, '', '2019-07-24 22:12:24');
INSERT INTO `access_log` VALUES (58542, '59.75.15639775437866647', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.84.118.203', '2019-07-24 22:12:24', 20, 2001001000, '服务端发生异常', '2019-07-24 22:12:24');
INSERT INTO `access_log` VALUES (58543, '64.80.15639775514276875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.84.118.203', '2019-07-24 22:12:31', 11, 0, '', '2019-07-24 22:12:31');
INSERT INTO `access_log` VALUES (58544, '64.83.15639775515496869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.84.118.203', '2019-07-24 22:12:32', 3, 0, '', '2019-07-24 22:12:32');
INSERT INTO `access_log` VALUES (58545, '65.45.15639782006298925', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.115.186.129', '2019-07-24 22:23:21', 1, 1002001015, '账号未登陆', '2019-07-24 22:23:21');
INSERT INTO `access_log` VALUES (58546, '65.47.15639782006338911', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.115.186.129', '2019-07-24 22:23:21', 0, 1002001015, '账号未登陆', '2019-07-24 22:23:21');
INSERT INTO `access_log` VALUES (58547, '65.50.15639782006348937', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.115.186.129', '2019-07-24 22:23:21', 0, 1002001015, '账号未登陆', '2019-07-24 22:23:21');
INSERT INTO `access_log` VALUES (58548, '65.49.15639782077228905', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.115.186.129', '2019-07-24 22:23:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-24 22:23:28');
INSERT INTO `access_log` VALUES (58549, '65.53.15639782147548919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.115.186.129', '2019-07-24 22:23:35', 98, 0, '', '2019-07-24 22:23:35');
INSERT INTO `access_log` VALUES (58550, '65.52.15639782153018963', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.115.186.129', '2019-07-24 22:23:35', 13, 0, '', '2019-07-24 22:23:35');
INSERT INTO `access_log` VALUES (58551, '65.51.15639782153058993', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.115.186.129', '2019-07-24 22:23:35', 12, 2001001000, '服务端发生异常', '2019-07-24 22:23:35');
INSERT INTO `access_log` VALUES (58552, '65.46.15639782153079001', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.115.186.129', '2019-07-24 22:23:35', 11, 0, '', '2019-07-24 22:23:35');
INSERT INTO `access_log` VALUES (58553, '65.45.15639782236728927', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.115.186.129', '2019-07-24 22:23:44', 9, 0, '', '2019-07-24 22:23:44');
INSERT INTO `access_log` VALUES (58554, '65.47.15639782236758913', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.115.186.129', '2019-07-24 22:23:44', 10, 2001001000, '服务端发生异常', '2019-07-24 22:23:44');
INSERT INTO `access_log` VALUES (58555, '65.50.15639782236838939', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.115.186.129', '2019-07-24 22:23:44', 9, 0, '', '2019-07-24 22:23:44');
INSERT INTO `access_log` VALUES (58556, '59.80.15639823064146681', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:31:46', 10, 0, '', '2019-07-24 23:31:46');
INSERT INTO `access_log` VALUES (58557, '59.79.15639823064166709', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:31:46', 18, 2001001000, '服务端发生异常', '2019-07-24 23:31:46');
INSERT INTO `access_log` VALUES (58558, '59.72.15639823626946697', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:32:43', 3, 0, '', '2019-07-24 23:32:43');
INSERT INTO `access_log` VALUES (58559, '59.77.15639823626936697', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:32:43', 18, 2001001000, '服务端发生异常', '2019-07-24 23:32:43');
INSERT INTO `access_log` VALUES (58560, '64.77.15639823658866919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:32:46', 10, 0, '', '2019-07-24 23:32:46');
INSERT INTO `access_log` VALUES (58561, '64.81.15639823660016929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:32:46', 6, 0, '', '2019-07-24 23:32:46');
INSERT INTO `access_log` VALUES (58562, '66.52.15639823828614513', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13127501091&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:33:03', 17, 1001003000, '验证码不存在', '2019-07-24 23:33:03');
INSERT INTO `access_log` VALUES (58563, '64.84.15639824208216925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:33:41', 3, 0, '', '2019-07-24 23:33:41');
INSERT INTO `access_log` VALUES (58564, '64.80.15639824209476941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:33:41', 2, 0, '', '2019-07-24 23:33:41');
INSERT INTO `access_log` VALUES (58565, '59.78.15639824261506707', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:33:46', 2, 0, '', '2019-07-24 23:33:46');
INSERT INTO `access_log` VALUES (58566, '59.75.15639824261486713', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:33:46', 12, 2001001000, '服务端发生异常', '2019-07-24 23:33:46');
INSERT INTO `access_log` VALUES (58567, '65.49.15639824389928963', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:33:59', 0, 1002001015, '账号未登陆', '2019-07-24 23:33:59');
INSERT INTO `access_log` VALUES (58568, '65.53.15639824389958977', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:33:59', 1, 1002001015, '账号未登陆', '2019-07-24 23:33:59');
INSERT INTO `access_log` VALUES (58569, '65.52.15639824389989021', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:33:59', 0, 1002001015, '账号未登陆', '2019-07-24 23:33:59');
INSERT INTO `access_log` VALUES (58570, '65.46.15639824440849059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:34:04', 162, 0, '', '2019-07-24 23:34:04');
INSERT INTO `access_log` VALUES (58571, '65.51.15639824444919051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:34:04', 12, 0, '', '2019-07-24 23:34:05');
INSERT INTO `access_log` VALUES (58572, '65.3607.15639824444960789', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:34:04', 16, 2001001000, '服务端发生异常', '2019-07-24 23:34:05');
INSERT INTO `access_log` VALUES (58573, '65.47.15639824444998971', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.157.220.244', '2019-07-24 23:34:04', 15, 0, '', '2019-07-24 23:34:05');
INSERT INTO `access_log` VALUES (58574, '59.73.15639866174966765', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:43:37', 11, 0, '', '2019-07-25 00:43:38');
INSERT INTO `access_log` VALUES (58575, '59.76.15639866174976753', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:43:37', 34, 2001001000, '服务端发生异常', '2019-07-25 00:43:38');
INSERT INTO `access_log` VALUES (58576, '64.83.15639866211966991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:43:41', 11, 0, '', '2019-07-25 00:43:41');
INSERT INTO `access_log` VALUES (58577, '64.79.15639866213506993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:43:41', 3, 0, '', '2019-07-25 00:43:41');
INSERT INTO `access_log` VALUES (58578, '64.77.15639866223106977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:43:42', 2, 0, '', '2019-07-25 00:43:42');
INSERT INTO `access_log` VALUES (58579, '64.81.15639866227406987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:43:43', 2, 0, '', '2019-07-25 00:43:43');
INSERT INTO `access_log` VALUES (58580, '59.77.15639866236796755', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:43:44', 3, 0, '', '2019-07-25 00:43:44');
INSERT INTO `access_log` VALUES (58581, '59.72.15639866236796755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:43:44', 20, 2001001000, '服务端发生异常', '2019-07-25 00:43:44');
INSERT INTO `access_log` VALUES (58582, '65.45.15639866390919041', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:43:59', 1, 1002001015, '账号未登陆', '2019-07-25 00:43:59');
INSERT INTO `access_log` VALUES (58583, '65.50.15639866390929053', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:43:59', 1, 1002001015, '账号未登陆', '2019-07-25 00:43:59');
INSERT INTO `access_log` VALUES (58584, '65.54.15639866390948967', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:43:59', 0, 1002001015, '账号未登陆', '2019-07-25 00:43:59');
INSERT INTO `access_log` VALUES (58585, '65.49.15639866435049021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:44:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 00:44:04');
INSERT INTO `access_log` VALUES (58586, '65.52.15639866509949079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:44:11', 54, 0, '', '2019-07-25 00:44:11');
INSERT INTO `access_log` VALUES (58587, '65.46.15639866513819117', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:44:11', 25, 0, '', '2019-07-25 00:44:11');
INSERT INTO `access_log` VALUES (58588, '65.47.15639866513999029', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:44:11', 12, 0, '', '2019-07-25 00:44:11');
INSERT INTO `access_log` VALUES (58589, '65.3607.15639866513900847', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.92.226.181', '2019-07-25 00:44:11', 22, 2001001000, '服务端发生异常', '2019-07-25 00:44:11');
INSERT INTO `access_log` VALUES (58590, '65.54.15640154378249353', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.103.156', '2019-07-25 08:43:58', 9, 1002001012, '访问令牌已过期', '2019-07-25 08:43:58');
INSERT INTO `access_log` VALUES (58591, '65.3607.15640154378031231', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.103.156', '2019-07-25 08:43:58', 31, 1002001012, '访问令牌已过期', '2019-07-25 08:43:58');
INSERT INTO `access_log` VALUES (58592, '65.51.15640154378039493', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.103.156', '2019-07-25 08:43:58', 33, 1002001012, '访问令牌已过期', '2019-07-25 08:43:58');
INSERT INTO `access_log` VALUES (58593, '65.53.15640154890929421', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '153.3.219.43', '2019-07-25 08:44:49', 1, 1002001015, '账号未登陆', '2019-07-25 08:44:49');
INSERT INTO `access_log` VALUES (58594, '65.52.15640154890959465', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '153.3.219.43', '2019-07-25 08:44:49', 0, 1002001015, '账号未登陆', '2019-07-25 08:44:49');
INSERT INTO `access_log` VALUES (58595, '65.46.15640154890979503', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '153.3.219.43', '2019-07-25 08:44:49', 1, 1002001015, '账号未登陆', '2019-07-25 08:44:49');
INSERT INTO `access_log` VALUES (58596, '65.3607.15640155105181233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '153.3.219.43', '2019-07-25 08:45:11', 87, 0, '', '2019-07-25 08:45:11');
INSERT INTO `access_log` VALUES (58597, '65.50.15640155108409441', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '153.3.219.43', '2019-07-25 08:45:11', 79, 0, '', '2019-07-25 08:45:11');
INSERT INTO `access_log` VALUES (58598, '65.51.15640155108399495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '153.3.219.43', '2019-07-25 08:45:11', 81, 2001001000, '服务端发生异常', '2019-07-25 08:45:11');
INSERT INTO `access_log` VALUES (58599, '65.45.15640155108439429', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '153.3.219.43', '2019-07-25 08:45:11', 80, 0, '', '2019-07-25 08:45:11');
INSERT INTO `access_log` VALUES (58600, '65.49.15640155216939409', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '153.3.219.43', '2019-07-25 08:45:22', 9, 0, '', '2019-07-25 08:45:22');
INSERT INTO `access_log` VALUES (58601, '65.46.15640155216999505', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '153.3.219.43', '2019-07-25 08:45:22', 10, 0, '', '2019-07-25 08:45:22');
INSERT INTO `access_log` VALUES (58602, '65.53.15640155216989423', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '153.3.219.43', '2019-07-25 08:45:22', 11, 2001001000, '服务端发生异常', '2019-07-25 08:45:22');
INSERT INTO `access_log` VALUES (58603, '65.3607.15640191559481283', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-25 09:45:56', 13, 1002001012, '访问令牌已过期', '2019-07-25 09:45:56');
INSERT INTO `access_log` VALUES (58604, '65.51.15640191559489545', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-25 09:45:56', 16, 1002001012, '访问令牌已过期', '2019-07-25 09:45:56');
INSERT INTO `access_log` VALUES (58605, '65.50.15640191559509491', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-25 09:45:56', 17, 1002001012, '访问令牌已过期', '2019-07-25 09:45:56');
INSERT INTO `access_log` VALUES (58606, '65.45.15640191651319479', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-25 09:46:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 09:46:05');
INSERT INTO `access_log` VALUES (58607, '65.53.15640191675509473', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-25 09:46:08', 87, 0, '', '2019-07-25 09:46:08');
INSERT INTO `access_log` VALUES (58608, '65.46.15640191678169555', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-25 09:46:08', 11, 0, '', '2019-07-25 09:46:08');
INSERT INTO `access_log` VALUES (58609, '65.49.15640191678159459', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-25 09:46:08', 12, 2001001000, '服务端发生异常', '2019-07-25 09:46:08');
INSERT INTO `access_log` VALUES (58610, '65.52.15640191681149517', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.17.169.238', '2019-07-25 09:46:08', 8, 0, '', '2019-07-25 09:46:08');
INSERT INTO `access_log` VALUES (58611, '59.71.15640212933317223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:33', 12, 0, '', '2019-07-25 10:21:33');
INSERT INTO `access_log` VALUES (58612, '64.85.15640212933357483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:33', 11, 0, '', '2019-07-25 10:21:33');
INSERT INTO `access_log` VALUES (58613, '59.79.15640212933347231', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:33', 25, 2001001000, '服务端发生异常', '2019-07-25 10:21:33');
INSERT INTO `access_log` VALUES (58614, '59.80.15640212936327203', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:34', 4, 0, '', '2019-07-25 10:21:34');
INSERT INTO `access_log` VALUES (58615, '59.75.15640212936357233', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:34', 15, 2001001000, '服务端发生异常', '2019-07-25 10:21:34');
INSERT INTO `access_log` VALUES (58616, '64.83.15640212936397455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:34', 3, 0, '', '2019-07-25 10:21:34');
INSERT INTO `access_log` VALUES (58617, '64.80.15640212936667461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:34', 2, 0, '', '2019-07-25 10:21:34');
INSERT INTO `access_log` VALUES (58618, '59.78.15640212937897227', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:34', 3, 0, '', '2019-07-25 10:21:34');
INSERT INTO `access_log` VALUES (58619, '64.77.15640212937887441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:34', 1, 0, '', '2019-07-25 10:21:34');
INSERT INTO `access_log` VALUES (58620, '64.79.15640212937897457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:34', 1, 0, '', '2019-07-25 10:21:34');
INSERT INTO `access_log` VALUES (58621, '59.73.15640212937977229', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:34', 16, 2001001000, '服务端发生异常', '2019-07-25 10:21:34');
INSERT INTO `access_log` VALUES (58622, '59.76.15640212938707217', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:34', 3, 0, '', '2019-07-25 10:21:34');
INSERT INTO `access_log` VALUES (58623, '64.81.15640212938787451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:34', 3, 0, '', '2019-07-25 10:21:34');
INSERT INTO `access_log` VALUES (58624, '64.78.15640212938857465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:34', 1, 0, '', '2019-07-25 10:21:34');
INSERT INTO `access_log` VALUES (58625, '59.72.15640212939337219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:34', 21, 2001001000, '服务端发生异常', '2019-07-25 10:21:34');
INSERT INTO `access_log` VALUES (58626, '64.82.15640212939787471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3851.0 Safari/537.36 Edg/77.0.228.0', '222.174.182.148', '2019-07-25 10:21:34', 2, 0, '', '2019-07-25 10:21:34');
INSERT INTO `access_log` VALUES (58627, '65.47.15640214300379499', 0, 2, 'admin-application', '/admin-api/admins/data_dict/update', 'displayName=男&enumValue=gender&id=1&sort=123&value=1&memo=你猜我猜不猜', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.86.138', '2019-07-25 10:23:50', 0, 1002001015, '账号未登陆', '2019-07-25 10:23:50');
INSERT INTO `access_log` VALUES (58628, '65.54.15640214313359439', 0, 2, 'admin-application', '/admin-api/admins/data_dict/update', 'displayName=男&enumValue=gender&id=1&sort=123&value=1&memo=你猜我猜不猜', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.86.138', '2019-07-25 10:23:51', 1, 1002001015, '账号未登陆', '2019-07-25 10:23:51');
INSERT INTO `access_log` VALUES (58629, '65.3607.15640214317491315', 0, 2, 'admin-application', '/admin-api/admins/data_dict/update', 'displayName=男&enumValue=gender&id=1&sort=123&value=1&memo=你猜我猜不猜', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.86.138', '2019-07-25 10:23:52', 1, 1002001015, '账号未登陆', '2019-07-25 10:23:52');
INSERT INTO `access_log` VALUES (58630, '65.51.15640214326079579', 0, 2, 'admin-application', '/admin-api/admins/data_dict/update', 'displayName=男&enumValue=gender&id=1&sort=123&value=1&memo=你猜我猜不猜', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.86.138', '2019-07-25 10:23:53', 1, 1002001015, '账号未登陆', '2019-07-25 10:23:53');
INSERT INTO `access_log` VALUES (58631, '65.45.15640214334359511', 0, 2, 'admin-application', '/admin-api/admins/data_dict/update', 'displayName=男&enumValue=gender&id=1&sort=123&value=1&memo=你猜我猜不猜', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.86.138', '2019-07-25 10:23:53', 1, 1002001015, '账号未登陆', '2019-07-25 10:23:53');
INSERT INTO `access_log` VALUES (58632, '65.53.15640214340179505', 0, 2, 'admin-application', '/admin-api/admins/data_dict/update', 'displayName=男&enumValue=gender&id=1&sort=123&value=1&memo=你猜我猜不猜', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.86.138', '2019-07-25 10:23:54', 1, 1002001015, '账号未登陆', '2019-07-25 10:23:54');
INSERT INTO `access_log` VALUES (58633, '65.49.15640214345149491', 0, 2, 'admin-application', '/admin-api/admins/data_dict/update', 'displayName=男&enumValue=gender&id=1&sort=123&value=1&memo=你猜我猜不猜', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.86.138', '2019-07-25 10:23:55', 1, 1002001015, '账号未登陆', '2019-07-25 10:23:55');
INSERT INTO `access_log` VALUES (58634, '65.52.15640214353769551', 0, 2, 'admin-application', '/admin-api/admins/data_dict/update', 'displayName=男&enumValue=gender&id=1&sort=123&value=1&memo=你猜我猜不猜', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.86.138', '2019-07-25 10:23:55', 1, 1002001015, '账号未登陆', '2019-07-25 10:23:55');
INSERT INTO `access_log` VALUES (58635, '65.50.15640221932209533', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.94.214.236', '2019-07-25 10:36:33', 177, 0, '', '2019-07-25 10:36:33');
INSERT INTO `access_log` VALUES (58636, '65.47.15640221937399511', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.94.214.236', '2019-07-25 10:36:34', 12, 0, '', '2019-07-25 10:36:34');
INSERT INTO `access_log` VALUES (58637, '65.54.15640221937489451', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.94.214.236', '2019-07-25 10:36:34', 11, 0, '', '2019-07-25 10:36:34');
INSERT INTO `access_log` VALUES (58638, '65.3607.15640221937481327', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.94.214.236', '2019-07-25 10:36:34', 10, 2001001000, '服务端发生异常', '2019-07-25 10:36:34');
INSERT INTO `access_log` VALUES (58639, '65.45.15640222018549523', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.94.214.236', '2019-07-25 10:36:42', 11, 0, '', '2019-07-25 10:36:42');
INSERT INTO `access_log` VALUES (58640, '65.46.15640222018569599', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.94.214.236', '2019-07-25 10:36:42', 12, 2001001000, '服务端发生异常', '2019-07-25 10:36:42');
INSERT INTO `access_log` VALUES (58641, '65.53.15640222018639517', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.94.214.236', '2019-07-25 10:36:42', 9, 0, '', '2019-07-25 10:36:42');
INSERT INTO `access_log` VALUES (58642, '59.75.15640237405917267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:21', 10, 0, '', '2019-07-25 11:02:21');
INSERT INTO `access_log` VALUES (58643, '59.80.15640237405937237', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:21', 19, 2001001000, '服务端发生异常', '2019-07-25 11:02:21');
INSERT INTO `access_log` VALUES (58644, '65.47.15640237459729533', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:26', 0, 1002001015, '账号未登陆', '2019-07-25 11:02:26');
INSERT INTO `access_log` VALUES (58645, '65.54.15640237459829473', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:26', 1, 1002001015, '账号未登陆', '2019-07-25 11:02:26');
INSERT INTO `access_log` VALUES (58646, '65.3607.15640237459991349', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:26', 0, 1002001015, '账号未登陆', '2019-07-25 11:02:26');
INSERT INTO `access_log` VALUES (58647, '64.80.15640237506797495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:31', 12, 0, '', '2019-07-25 11:02:31');
INSERT INTO `access_log` VALUES (58648, '64.77.15640237508937475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:31', 4, 0, '', '2019-07-25 11:02:31');
INSERT INTO `access_log` VALUES (58649, '64.79.15640237523527491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:32', 1, 0, '', '2019-07-25 11:02:32');
INSERT INTO `access_log` VALUES (58650, '64.78.15640237528967499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:33', 2, 0, '', '2019-07-25 11:02:33');
INSERT INTO `access_log` VALUES (58651, '65.51.15640237552469613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 11:02:35');
INSERT INTO `access_log` VALUES (58652, '65.53.15640237620169539', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:42', 81, 0, '', '2019-07-25 11:02:42');
INSERT INTO `access_log` VALUES (58653, '65.46.15640237623929621', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:42', 11, 0, '', '2019-07-25 11:02:42');
INSERT INTO `access_log` VALUES (58654, '65.49.15640237623969525', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:42', 10, 2001001000, '服务端发生异常', '2019-07-25 11:02:42');
INSERT INTO `access_log` VALUES (58655, '65.52.15640237624009585', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:42', 9, 0, '', '2019-07-25 11:02:42');
INSERT INTO `access_log` VALUES (58656, '65.54.15640237753659475', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:55', 10, 0, '', '2019-07-25 11:02:55');
INSERT INTO `access_log` VALUES (58657, '65.47.15640237753719535', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:55', 9, 2001001000, '服务端发生异常', '2019-07-25 11:02:55');
INSERT INTO `access_log` VALUES (58658, '65.3607.15640237753731351', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.60', '2019-07-25 11:02:55', 8, 0, '', '2019-07-25 11:02:55');
INSERT INTO `access_log` VALUES (58659, '65.49.15640238538949527', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.112.177.103', '2019-07-25 11:04:14', 1, 1002001015, '账号未登陆', '2019-07-25 11:04:14');
INSERT INTO `access_log` VALUES (58660, '65.50.15640238538949559', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.112.177.103', '2019-07-25 11:04:14', 1, 1002001015, '账号未登陆', '2019-07-25 11:04:14');
INSERT INTO `access_log` VALUES (58661, '65.54.15640238539019477', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.112.177.103', '2019-07-25 11:04:14', 0, 1002001015, '账号未登陆', '2019-07-25 11:04:14');
INSERT INTO `access_log` VALUES (58662, '65.47.15640238572139537', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.112.177.103', '2019-07-25 11:04:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 11:04:17');
INSERT INTO `access_log` VALUES (58663, '65.3607.15640238596051353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.112.177.103', '2019-07-25 11:04:20', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 11:04:20');
INSERT INTO `access_log` VALUES (58664, '65.45.15640238696699549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.112.177.103', '2019-07-25 11:04:30', 118, 0, '', '2019-07-25 11:04:30');
INSERT INTO `access_log` VALUES (58665, '65.53.15640238701699543', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.112.177.103', '2019-07-25 11:04:30', 9, 0, '', '2019-07-25 11:04:30');
INSERT INTO `access_log` VALUES (58666, '65.52.15640238701729589', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.112.177.103', '2019-07-25 11:04:30', 10, 2001001000, '服务端发生异常', '2019-07-25 11:04:30');
INSERT INTO `access_log` VALUES (58667, '65.46.15640238702019625', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.112.177.103', '2019-07-25 11:04:30', 9, 0, '', '2019-07-25 11:04:30');
INSERT INTO `access_log` VALUES (58668, '65.45.15640239561569551', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 11:05:56', 0, 1002001015, '账号未登陆', '2019-07-25 11:05:56');
INSERT INTO `access_log` VALUES (58669, '65.52.15640239561739591', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 11:05:56', 1, 1002001015, '账号未登陆', '2019-07-25 11:05:56');
INSERT INTO `access_log` VALUES (58670, '65.53.15640239561739545', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 11:05:56', 0, 1002001015, '账号未登陆', '2019-07-25 11:05:56');
INSERT INTO `access_log` VALUES (58671, '65.46.15640239586989627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 11:05:59', 123, 0, '', '2019-07-25 11:05:59');
INSERT INTO `access_log` VALUES (58672, '65.50.15640239591279563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 11:05:59', 9, 0, '', '2019-07-25 11:05:59');
INSERT INTO `access_log` VALUES (58673, '65.49.15640239590879531', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 11:05:59', 363, 0, '', '2019-07-25 11:05:59');
INSERT INTO `access_log` VALUES (58674, '65.54.15640239590889481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 11:05:59', 362, 2001001000, '服务端发生异常', '2019-07-25 11:05:59');
INSERT INTO `access_log` VALUES (58675, '65.47.15640239678779541', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 11:06:08', 8, 0, '', '2019-07-25 11:06:08');
INSERT INTO `access_log` VALUES (58676, '65.3607.15640239679071357', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 11:06:08', 9, 0, '', '2019-07-25 11:06:08');
INSERT INTO `access_log` VALUES (58677, '65.51.15640239679079621', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 11:06:08', 9, 2001001000, '服务端发生异常', '2019-07-25 11:06:08');
INSERT INTO `access_log` VALUES (58678, '59.75.15640277200117321', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.5.3.170', '2019-07-25 12:08:40', 19, 2001001000, '服务端发生异常', '2019-07-25 12:08:40');
INSERT INTO `access_log` VALUES (58679, '59.73.15640277200117317', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.5.3.170', '2019-07-25 12:08:40', 171, 0, '', '2019-07-25 12:08:40');
INSERT INTO `access_log` VALUES (58680, '64.83.15640277235177543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.5.3.170', '2019-07-25 12:08:44', 14, 0, '', '2019-07-25 12:08:44');
INSERT INTO `access_log` VALUES (58681, '64.80.15640277236467549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.5.3.170', '2019-07-25 12:08:44', 4, 0, '', '2019-07-25 12:08:44');
INSERT INTO `access_log` VALUES (58682, '64.77.15640277247817529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.5.3.170', '2019-07-25 12:08:45', 2, 0, '', '2019-07-25 12:08:45');
INSERT INTO `access_log` VALUES (58683, '64.79.15640277262317545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.5.3.170', '2019-07-25 12:08:46', 2, 0, '', '2019-07-25 12:08:46');
INSERT INTO `access_log` VALUES (58684, '59.78.15640277282257315', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.5.3.170', '2019-07-25 12:08:48', 4, 0, '', '2019-07-25 12:08:48');
INSERT INTO `access_log` VALUES (58685, '59.76.15640277282257305', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.5.3.170', '2019-07-25 12:08:48', 17, 2001001000, '服务端发生异常', '2019-07-25 12:08:48');
INSERT INTO `access_log` VALUES (58686, '64.78.15640277303137553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.5.3.170', '2019-07-25 12:08:50', 2, 0, '', '2019-07-25 12:08:50');
INSERT INTO `access_log` VALUES (58687, '64.81.15640277304307539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '210.5.3.170', '2019-07-25 12:08:50', 2, 0, '', '2019-07-25 12:08:50');
INSERT INTO `access_log` VALUES (58688, '65.47.15640325469979657', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.190.105.186', '2019-07-25 13:29:07', 1, 1002001015, '账号未登陆', '2019-07-25 13:29:07');
INSERT INTO `access_log` VALUES (58689, '65.51.15640325469979737', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.190.105.186', '2019-07-25 13:29:07', 0, 1002001015, '账号未登陆', '2019-07-25 13:29:07');
INSERT INTO `access_log` VALUES (58690, '65.45.15640325470179669', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.190.105.186', '2019-07-25 13:29:07', 0, 1002001015, '账号未登陆', '2019-07-25 13:29:07');
INSERT INTO `access_log` VALUES (58691, '65.53.15640325497169663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.190.105.186', '2019-07-25 13:29:10', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 13:29:10');
INSERT INTO `access_log` VALUES (58692, '65.46.15640325598439743', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.190.105.186', '2019-07-25 13:29:20', 86, 0, '', '2019-07-25 13:29:20');
INSERT INTO `access_log` VALUES (58693, '65.50.15640325601849683', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.190.105.186', '2019-07-25 13:29:20', 12, 0, '', '2019-07-25 13:29:20');
INSERT INTO `access_log` VALUES (58694, '65.49.15640325601879649', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.190.105.186', '2019-07-25 13:29:20', 13, 2001001000, '服务端发生异常', '2019-07-25 13:29:20');
INSERT INTO `access_log` VALUES (58695, '65.54.15640325601909597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.190.105.186', '2019-07-25 13:29:20', 11, 0, '', '2019-07-25 13:29:20');
INSERT INTO `access_log` VALUES (58696, '65.51.15640325915409739', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.190.105.186', '2019-07-25 13:29:52', 68, 0, '', '2019-07-25 13:29:52');
INSERT INTO `access_log` VALUES (58697, '65.45.15640325917579671', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.190.105.186', '2019-07-25 13:29:52', 17, 2001001000, '服务端发生异常', '2019-07-25 13:29:52');
INSERT INTO `access_log` VALUES (58698, '65.53.15640325917699665', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.190.105.186', '2019-07-25 13:29:52', 8, 0, '', '2019-07-25 13:29:52');
INSERT INTO `access_log` VALUES (58699, '65.52.15640325917589711', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.190.105.186', '2019-07-25 13:29:52', 62, 0, '', '2019-07-25 13:29:52');
INSERT INTO `access_log` VALUES (58700, '59.79.15640340878397403', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.101.191.115', '2019-07-25 13:54:48', 13, 0, '', '2019-07-25 13:54:48');
INSERT INTO `access_log` VALUES (58701, '59.74.15640340878427409', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.101.191.115', '2019-07-25 13:54:48', 43, 2001001000, '服务端发生异常', '2019-07-25 13:54:48');
INSERT INTO `access_log` VALUES (58702, '64.83.15640340904437629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.101.191.115', '2019-07-25 13:54:50', 11, 0, '', '2019-07-25 13:54:50');
INSERT INTO `access_log` VALUES (58703, '64.77.15640340905327615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.101.191.115', '2019-07-25 13:54:51', 3, 0, '', '2019-07-25 13:54:51');
INSERT INTO `access_log` VALUES (58704, '64.79.15640340916267631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.101.191.115', '2019-07-25 13:54:52', 2, 0, '', '2019-07-25 13:54:52');
INSERT INTO `access_log` VALUES (58705, '64.78.15640340921077639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.101.191.115', '2019-07-25 13:54:52', 1, 0, '', '2019-07-25 13:54:52');
INSERT INTO `access_log` VALUES (58706, '64.81.15640340927747625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.101.191.115', '2019-07-25 13:54:53', 2, 0, '', '2019-07-25 13:54:53');
INSERT INTO `access_log` VALUES (58707, '59.75.15640340949567407', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.101.191.115', '2019-07-25 13:54:55', 3, 0, '', '2019-07-25 13:54:55');
INSERT INTO `access_log` VALUES (58708, '59.76.15640340949577391', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.101.191.115', '2019-07-25 13:54:55', 17, 2001001000, '服务端发生异常', '2019-07-25 13:54:55');
INSERT INTO `access_log` VALUES (58709, '59.71.15640340998217397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.101.191.115', '2019-07-25 13:55:00', 2, 0, '', '2019-07-25 13:55:00');
INSERT INTO `access_log` VALUES (58710, '59.78.15640340998207401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.101.191.115', '2019-07-25 13:55:00', 19, 2001001000, '服务端发生异常', '2019-07-25 13:55:00');
INSERT INTO `access_log` VALUES (58711, '59.79.15640344465337409', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.226.217.140', '2019-07-25 14:00:47', 3, 0, '', '2019-07-25 14:00:47');
INSERT INTO `access_log` VALUES (58712, '59.74.15640344465427415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.226.217.140', '2019-07-25 14:00:47', 18, 2001001000, '服务端发生异常', '2019-07-25 14:00:47');
INSERT INTO `access_log` VALUES (58713, '59.75.15640344519017413', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.226.217.140', '2019-07-25 14:00:52', 2, 0, '', '2019-07-25 14:00:52');
INSERT INTO `access_log` VALUES (58714, '59.76.15640344518987397', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.226.217.140', '2019-07-25 14:00:52', 12, 2001001000, '服务端发生异常', '2019-07-25 14:00:52');
INSERT INTO `access_log` VALUES (58715, '59.80.15640349327897389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 14:08:53', 3, 0, '', '2019-07-25 14:08:53');
INSERT INTO `access_log` VALUES (58716, '59.72.15640349328047405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 14:08:53', 11, 2001001000, '服务端发生异常', '2019-07-25 14:08:53');
INSERT INTO `access_log` VALUES (58717, '64.77.15640349380157627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 14:08:58', 3, 0, '', '2019-07-25 14:08:58');
INSERT INTO `access_log` VALUES (58718, '64.79.15640349381467643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 14:08:58', 1, 0, '', '2019-07-25 14:08:58');
INSERT INTO `access_log` VALUES (58719, '64.78.15640349390947651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 14:08:59', 2, 0, '', '2019-07-25 14:08:59');
INSERT INTO `access_log` VALUES (58720, '64.81.15640349395307637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.93.160.68', '2019-07-25 14:09:00', 2, 0, '', '2019-07-25 14:09:00');
INSERT INTO `access_log` VALUES (58721, '59.78.15640356254057423', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.191.26.140', '2019-07-25 14:20:25', 3, 0, '', '2019-07-25 14:20:25');
INSERT INTO `access_log` VALUES (58722, '59.71.15640356254067419', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.191.26.140', '2019-07-25 14:20:25', 13, 2001001000, '服务端发生异常', '2019-07-25 14:20:25');
INSERT INTO `access_log` VALUES (58723, '65.3607.15640356382601519', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.191.26.140', '2019-07-25 14:20:38', 0, 1002001015, '账号未登陆', '2019-07-25 14:20:38');
INSERT INTO `access_log` VALUES (58724, '65.54.15640356382609639', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.191.26.140', '2019-07-25 14:20:38', 0, 1002001015, '账号未登陆', '2019-07-25 14:20:38');
INSERT INTO `access_log` VALUES (58725, '65.47.15640356382639701', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.191.26.140', '2019-07-25 14:20:38', 1, 1002001015, '账号未登陆', '2019-07-25 14:20:38');
INSERT INTO `access_log` VALUES (58726, '65.47.15640363694129711', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-25 14:32:49', 0, 1002001015, '账号未登陆', '2019-07-25 14:32:49');
INSERT INTO `access_log` VALUES (58727, '65.51.15640363694139791', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-25 14:32:49', 1, 1002001015, '账号未登陆', '2019-07-25 14:32:49');
INSERT INTO `access_log` VALUES (58728, '65.45.15640363694139723', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-25 14:32:49', 0, 1002001015, '账号未登陆', '2019-07-25 14:32:49');
INSERT INTO `access_log` VALUES (58729, '65.53.15640363720969717', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-25 14:32:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 14:32:52');
INSERT INTO `access_log` VALUES (58730, '65.46.15640363821959797', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-25 14:33:02', 76, 0, '', '2019-07-25 14:33:02');
INSERT INTO `access_log` VALUES (58731, '65.49.15640363828379703', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-25 14:33:03', 13, 2001001000, '服务端发生异常', '2019-07-25 14:33:03');
INSERT INTO `access_log` VALUES (58732, '65.50.15640363828429737', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-25 14:33:03', 9, 0, '', '2019-07-25 14:33:03');
INSERT INTO `access_log` VALUES (58733, '65.54.15640363829049651', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-25 14:33:03', 9, 0, '', '2019-07-25 14:33:03');
INSERT INTO `access_log` VALUES (58734, '65.54.15640411781369717', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:52:58', 15, 1002001012, '访问令牌已过期', '2019-07-25 15:52:58');
INSERT INTO `access_log` VALUES (58735, '65.3607.15640411781381593', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:52:58', 16, 1002001012, '访问令牌已过期', '2019-07-25 15:52:58');
INSERT INTO `access_log` VALUES (58736, '65.45.15640411781449791', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:52:58', 10, 1002001012, '访问令牌已过期', '2019-07-25 15:52:58');
INSERT INTO `access_log` VALUES (58737, '65.51.15640411802139857', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:53:00', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 15:53:00');
INSERT INTO `access_log` VALUES (58738, '65.47.15640411872529779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:53:07', 5, 1002002001, '密码不正确', '2019-07-25 15:53:07');
INSERT INTO `access_log` VALUES (58739, '65.52.15640411964459829', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:53:16', 83, 0, '', '2019-07-25 15:53:17');
INSERT INTO `access_log` VALUES (58740, '65.46.15640411967389863', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:53:17', 9, 0, '', '2019-07-25 15:53:17');
INSERT INTO `access_log` VALUES (58741, '65.50.15640411967459805', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:53:17', 9, 0, '', '2019-07-25 15:53:17');
INSERT INTO `access_log` VALUES (58742, '65.49.15640411967489771', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:53:17', 8, 0, '', '2019-07-25 15:53:17');
INSERT INTO `access_log` VALUES (58743, '62.89.15640412036066543', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:53:24', 31, 0, '', '2019-07-25 15:53:24');
INSERT INTO `access_log` VALUES (58744, '64.79.15640412076797727', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:53:28', 27, 0, '', '2019-07-25 15:53:28');
INSERT INTO `access_log` VALUES (58745, '64.78.15640412076807737', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:53:28', 23, 0, '', '2019-07-25 15:53:28');
INSERT INTO `access_log` VALUES (58746, '66.49.15640412225515311', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:53:43', 21, 0, '', '2019-07-25 15:53:43');
INSERT INTO `access_log` VALUES (58747, '66.48.15640412299025323', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:53:50', 20, 0, '', '2019-07-25 15:53:50');
INSERT INTO `access_log` VALUES (58748, '66.52.15640412345355301', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=4&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:53:55', 11, 0, '', '2019-07-25 15:53:55');
INSERT INTO `access_log` VALUES (58749, '66.51.15640412423935331', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.168.49.246', '2019-07-25 15:54:02', 11, 0, '', '2019-07-25 15:54:02');
INSERT INTO `access_log` VALUES (58750, '59.75.15640414167707507', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:56:57', 11, 0, '', '2019-07-25 15:56:57');
INSERT INTO `access_log` VALUES (58751, '59.76.15640414167717491', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:56:57', 17, 2001001000, '服务端发生异常', '2019-07-25 15:56:57');
INSERT INTO `access_log` VALUES (58752, '64.80.15640414320737735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:12', 3, 0, '', '2019-07-25 15:57:12');
INSERT INTO `access_log` VALUES (58753, '64.83.15640414321707729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:12', 2, 0, '', '2019-07-25 15:57:12');
INSERT INTO `access_log` VALUES (58754, '64.77.15640414336587717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:14', 2, 0, '', '2019-07-25 15:57:14');
INSERT INTO `access_log` VALUES (58755, '64.78.15640414345247741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:15', 2, 0, '', '2019-07-25 15:57:15');
INSERT INTO `access_log` VALUES (58756, '64.79.15640414350087731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:15', 1, 0, '', '2019-07-25 15:57:15');
INSERT INTO `access_log` VALUES (58757, '64.81.15640414353137725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:15', 2, 0, '', '2019-07-25 15:57:15');
INSERT INTO `access_log` VALUES (58758, '59.71.15640414383237497', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:18', 8, 0, '', '2019-07-25 15:57:18');
INSERT INTO `access_log` VALUES (58759, '59.72.15640414383237493', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:18', 41, 2001001000, '服务端发生异常', '2019-07-25 15:57:18');
INSERT INTO `access_log` VALUES (58760, '64.82.15640414403017745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:20', 2, 0, '', '2019-07-25 15:57:20');
INSERT INTO `access_log` VALUES (58761, '64.84.15640414403867723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:20', 2, 0, '', '2019-07-25 15:57:20');
INSERT INTO `access_log` VALUES (58762, '64.85.15640414413897761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:21', 2, 0, '', '2019-07-25 15:57:21');
INSERT INTO `access_log` VALUES (58763, '64.80.15640414416917737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:22', 2, 0, '', '2019-07-25 15:57:22');
INSERT INTO `access_log` VALUES (58764, '65.50.15640414499919809', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:30', 3, 1002001012, '访问令牌已过期', '2019-07-25 15:57:30');
INSERT INTO `access_log` VALUES (58765, '65.49.15640414499899775', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:30', 6, 1002001012, '访问令牌已过期', '2019-07-25 15:57:30');
INSERT INTO `access_log` VALUES (58766, '65.46.15640414499939867', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:30', 2, 1002001012, '访问令牌已过期', '2019-07-25 15:57:30');
INSERT INTO `access_log` VALUES (58767, '65.54.15640414550339723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:35', 64, 0, '', '2019-07-25 15:57:35');
INSERT INTO `access_log` VALUES (58768, '65.3607.15640414553041599', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:35', 9, 0, '', '2019-07-25 15:57:35');
INSERT INTO `access_log` VALUES (58769, '65.45.15640414553099797', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:35', 9, 2001001000, '服务端发生异常', '2019-07-25 15:57:35');
INSERT INTO `access_log` VALUES (58770, '65.51.15640414553139863', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:35', 8, 0, '', '2019-07-25 15:57:35');
INSERT INTO `access_log` VALUES (58771, '65.53.15640414616619789', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.143', '2019-07-25 15:57:42', 9, 0, '', '2019-07-25 15:57:42');
INSERT INTO `access_log` VALUES (58772, '65.46.15640414616639869', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:42', 10, 0, '', '2019-07-25 15:57:42');
INSERT INTO `access_log` VALUES (58773, '65.52.15640414616629835', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.224.22.131', '2019-07-25 15:57:42', 9, 2001001000, '服务端发生异常', '2019-07-25 15:57:42');
INSERT INTO `access_log` VALUES (58774, '59.72.15640422965477505', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.247.8.186', '2019-07-25 16:11:37', 8, 0, '', '2019-07-25 16:11:37');
INSERT INTO `access_log` VALUES (58775, '59.71.15640422965747509', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.247.8.186', '2019-07-25 16:11:37', 13, 2001001000, '服务端发生异常', '2019-07-25 16:11:37');
INSERT INTO `access_log` VALUES (58776, '64.85.15640423207617773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.247.8.186', '2019-07-25 16:12:01', 3, 0, '', '2019-07-25 16:12:01');
INSERT INTO `access_log` VALUES (58777, '64.80.15640423211017749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.247.8.186', '2019-07-25 16:12:01', 2, 0, '', '2019-07-25 16:12:01');
INSERT INTO `access_log` VALUES (58778, '64.78.15640423415647755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.247.8.186', '2019-07-25 16:12:22', 2, 0, '', '2019-07-25 16:12:22');
INSERT INTO `access_log` VALUES (58779, '64.81.15640423616067739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.247.8.186', '2019-07-25 16:12:42', 3, 0, '', '2019-07-25 16:12:42');
INSERT INTO `access_log` VALUES (58780, '64.82.15640423701887759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '58.247.8.186', '2019-07-25 16:12:50', 2, 0, '', '2019-07-25 16:12:50');
INSERT INTO `access_log` VALUES (58781, '65.54.15640441734209761', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.119.233', '2019-07-25 16:42:53', 1, 1002001015, '账号未登陆', '2019-07-25 16:42:53');
INSERT INTO `access_log` VALUES (58782, '65.49.15640441734209813', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.119.233', '2019-07-25 16:42:53', 1, 1002001015, '账号未登陆', '2019-07-25 16:42:53');
INSERT INTO `access_log` VALUES (58783, '65.45.15640441734209835', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.119.233', '2019-07-25 16:42:53', 0, 1002001015, '账号未登陆', '2019-07-25 16:42:53');
INSERT INTO `access_log` VALUES (58784, '65.51.15640441767589901', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.119.233', '2019-07-25 16:42:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 16:42:57');
INSERT INTO `access_log` VALUES (58785, '65.47.15640441816489823', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.119.233', '2019-07-25 16:43:02', 60, 0, '', '2019-07-25 16:43:02');
INSERT INTO `access_log` VALUES (58786, '65.52.15640441822079873', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.119.233', '2019-07-25 16:43:02', 11, 0, '', '2019-07-25 16:43:02');
INSERT INTO `access_log` VALUES (58787, '65.53.15640441822129825', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.119.233', '2019-07-25 16:43:02', 9, 2001001000, '服务端发生异常', '2019-07-25 16:43:02');
INSERT INTO `access_log` VALUES (58788, '65.46.15640441822179907', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.119.233', '2019-07-25 16:43:02', 9, 0, '', '2019-07-25 16:43:02');
INSERT INTO `access_log` VALUES (58789, '65.46.15640443028149909', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.119.233', '2019-07-25 16:45:03', 103, 0, '', '2019-07-25 16:45:03');
INSERT INTO `access_log` VALUES (58790, '65.45.15640443028479839', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.119.233', '2019-07-25 16:45:03', 71, 0, '', '2019-07-25 16:45:03');
INSERT INTO `access_log` VALUES (58791, '65.50.15640443028229851', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.119.233', '2019-07-25 16:45:03', 103, 2001001000, '服务端发生异常', '2019-07-25 16:45:03');
INSERT INTO `access_log` VALUES (58792, '59.77.15640448695867539', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.55.27', '2019-07-25 16:54:30', 14, 0, '', '2019-07-25 16:54:30');
INSERT INTO `access_log` VALUES (58793, '59.74.15640448695867557', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.55.27', '2019-07-25 16:54:30', 15, 2001001000, '服务端发生异常', '2019-07-25 16:54:30');
INSERT INTO `access_log` VALUES (58794, '64.79.15640448717257779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.55.27', '2019-07-25 16:54:32', 11, 0, '', '2019-07-25 16:54:32');
INSERT INTO `access_log` VALUES (58795, '64.81.15640448720477773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.55.27', '2019-07-25 16:54:32', 3, 0, '', '2019-07-25 16:54:32');
INSERT INTO `access_log` VALUES (58796, '59.73.15640448751577551', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.55.27', '2019-07-25 16:54:35', 2, 0, '', '2019-07-25 16:54:35');
INSERT INTO `access_log` VALUES (58797, '59.76.15640448751577539', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.55.27', '2019-07-25 16:54:35', 11, 2001001000, '服务端发生异常', '2019-07-25 16:54:35');
INSERT INTO `access_log` VALUES (58798, '64.80.15640449245687785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:55:25', 2, 0, '', '2019-07-25 16:55:25');
INSERT INTO `access_log` VALUES (58799, '64.83.15640449248407779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:55:25', 2, 0, '', '2019-07-25 16:55:25');
INSERT INTO `access_log` VALUES (58800, '59.72.15640449262127541', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:55:26', 2, 0, '', '2019-07-25 16:55:26');
INSERT INTO `access_log` VALUES (58801, '59.80.15640449262127525', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:55:26', 19, 2001001000, '服务端发生异常', '2019-07-25 16:55:26');
INSERT INTO `access_log` VALUES (58802, '64.82.15640449909547795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:56:31', 3, 0, '', '2019-07-25 16:56:31');
INSERT INTO `access_log` VALUES (58803, '64.84.15640449910837773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:56:31', 2, 0, '', '2019-07-25 16:56:31');
INSERT INTO `access_log` VALUES (58804, '59.76.15640449927207541', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:56:33', 3, 0, '', '2019-07-25 16:56:33');
INSERT INTO `access_log` VALUES (58805, '59.75.15640449927517557', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:56:33', 13, 2001001000, '服务端发生异常', '2019-07-25 16:56:33');
INSERT INTO `access_log` VALUES (58806, '64.76.15640449942087777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:56:34', 2, 0, '', '2019-07-25 16:56:34');
INSERT INTO `access_log` VALUES (58807, '64.85.15640449943217811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:56:34', 2, 0, '', '2019-07-25 16:56:34');
INSERT INTO `access_log` VALUES (58808, '59.71.15640449956597547', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:56:36', 3, 0, '', '2019-07-25 16:56:36');
INSERT INTO `access_log` VALUES (58809, '59.72.15640449956607543', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:56:36', 18, 2001001000, '服务端发生异常', '2019-07-25 16:56:36');
INSERT INTO `access_log` VALUES (58810, '59.77.15640450139587543', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:56:54', 2, 0, '', '2019-07-25 16:56:54');
INSERT INTO `access_log` VALUES (58811, '59.74.15640450139587561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:56:54', 12, 2001001000, '服务端发生异常', '2019-07-25 16:56:54');
INSERT INTO `access_log` VALUES (58812, '64.76.15640451136767779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:34', 3, 0, '', '2019-07-25 16:58:34');
INSERT INTO `access_log` VALUES (58813, '64.85.15640451138007813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:34', 2, 0, '', '2019-07-25 16:58:34');
INSERT INTO `access_log` VALUES (58814, '64.80.15640451144607789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:34', 2, 0, '', '2019-07-25 16:58:34');
INSERT INTO `access_log` VALUES (58815, '64.83.15640451148697783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:35', 2, 0, '', '2019-07-25 16:58:35');
INSERT INTO `access_log` VALUES (58816, '64.78.15640451155087795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:36', 2, 0, '', '2019-07-25 16:58:36');
INSERT INTO `access_log` VALUES (58817, '64.79.15640451159167785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:36', 2, 0, '', '2019-07-25 16:58:36');
INSERT INTO `access_log` VALUES (58818, '64.81.15640451164867779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:36', 2, 0, '', '2019-07-25 16:58:36');
INSERT INTO `access_log` VALUES (58819, '64.82.15640451167347799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:37', 2, 0, '', '2019-07-25 16:58:37');
INSERT INTO `access_log` VALUES (58820, '64.84.15640451171087777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:37', 2, 0, '', '2019-07-25 16:58:37');
INSERT INTO `access_log` VALUES (58821, '64.76.15640451173727781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:37', 2, 0, '', '2019-07-25 16:58:37');
INSERT INTO `access_log` VALUES (58822, '64.85.15640451176547815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:38', 2, 0, '', '2019-07-25 16:58:38');
INSERT INTO `access_log` VALUES (58823, '64.80.15640451180207791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:38', 2, 0, '', '2019-07-25 16:58:38');
INSERT INTO `access_log` VALUES (58824, '64.83.15640451182687785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:38', 2, 0, '', '2019-07-25 16:58:38');
INSERT INTO `access_log` VALUES (58825, '64.77.15640451185177773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:39', 2, 0, '', '2019-07-25 16:58:39');
INSERT INTO `access_log` VALUES (58826, '64.78.15640451282767797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:48', 2, 0, '', '2019-07-25 16:58:48');
INSERT INTO `access_log` VALUES (58827, '64.79.15640451287497787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:49', 2, 0, '', '2019-07-25 16:58:49');
INSERT INTO `access_log` VALUES (58828, '64.81.15640451290517781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:49', 1, 0, '', '2019-07-25 16:58:49');
INSERT INTO `access_log` VALUES (58829, '64.82.15640451292917801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:49', 1, 0, '', '2019-07-25 16:58:49');
INSERT INTO `access_log` VALUES (58830, '59.77.15640451311417545', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:51', 3, 0, '', '2019-07-25 16:58:51');
INSERT INTO `access_log` VALUES (58831, '59.74.15640451311737563', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 16:58:51', 12, 2001001000, '服务端发生异常', '2019-07-25 16:58:51');
INSERT INTO `access_log` VALUES (58832, '65.53.15640452754269841', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:15', 0, 1002001015, '账号未登陆', '2019-07-25 17:01:15');
INSERT INTO `access_log` VALUES (58833, '65.52.15640452754319889', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:15', 1, 1002001015, '账号未登陆', '2019-07-25 17:01:15');
INSERT INTO `access_log` VALUES (58834, '65.46.15640452754389923', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:15', 0, 1002001015, '账号未登陆', '2019-07-25 17:01:15');
INSERT INTO `access_log` VALUES (58835, '65.45.15640452772359853', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 17:01:17');
INSERT INTO `access_log` VALUES (58836, '65.50.15640452812339865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 17:01:21');
INSERT INTO `access_log` VALUES (58837, '65.54.15640452913829777', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:31', 71, 0, '', '2019-07-25 17:01:31');
INSERT INTO `access_log` VALUES (58838, '65.3607.15640452917081655', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:32', 10, 0, '', '2019-07-25 17:01:32');
INSERT INTO `access_log` VALUES (58839, '65.47.15640452917129841', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:32', 9, 0, '', '2019-07-25 17:01:32');
INSERT INTO `access_log` VALUES (58840, '65.51.15640452917129919', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:32', 10, 2001001000, '服务端发生异常', '2019-07-25 17:01:32');
INSERT INTO `access_log` VALUES (58841, '65.46.15640452997169925', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:40', 10, 0, '', '2019-07-25 17:01:40');
INSERT INTO `access_log` VALUES (58842, '65.52.15640452997189891', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:40', 11, 2001001000, '服务端发生异常', '2019-07-25 17:01:40');
INSERT INTO `access_log` VALUES (58843, '65.45.15640452997229855', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:40', 9, 0, '', '2019-07-25 17:01:40');
INSERT INTO `access_log` VALUES (58844, '65.49.15640453154079833', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:55', 9, 0, '', '2019-07-25 17:01:55');
INSERT INTO `access_log` VALUES (58845, '65.54.15640453154119779', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:55', 12, 2001001000, '服务端发生异常', '2019-07-25 17:01:55');
INSERT INTO `access_log` VALUES (58846, '65.3607.15640453154171657', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:01:55', 10, 0, '', '2019-07-25 17:01:55');
INSERT INTO `access_log` VALUES (58847, '65.51.15640453211679921', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:02:01', 8, 0, '', '2019-07-25 17:02:01');
INSERT INTO `access_log` VALUES (58848, '65.47.15640453211679843', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:02:01', 9, 2001001000, '服务端发生异常', '2019-07-25 17:02:01');
INSERT INTO `access_log` VALUES (58849, '65.53.15640453211739845', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.127.99.32', '2019-07-25 17:02:01', 7, 0, '', '2019-07-25 17:02:01');
INSERT INTO `access_log` VALUES (58850, '59.71.15640453615897553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '183.67.61.50', '2019-07-25 17:02:42', 3, 0, '', '2019-07-25 17:02:42');
INSERT INTO `access_log` VALUES (58851, '59.72.15640453615897549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '183.67.61.50', '2019-07-25 17:02:42', 21, 2001001000, '服务端发生异常', '2019-07-25 17:02:42');
INSERT INTO `access_log` VALUES (58852, '59.74.15640453862687567', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '183.67.61.50', '2019-07-25 17:03:06', 2, 0, '', '2019-07-25 17:03:06');
INSERT INTO `access_log` VALUES (58853, '59.79.15640453862687561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '183.67.61.50', '2019-07-25 17:03:06', 13, 2001001000, '服务端发生异常', '2019-07-25 17:03:06');
INSERT INTO `access_log` VALUES (58854, '64.81.15640453893107785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '183.67.61.50', '2019-07-25 17:03:09', 3, 0, '', '2019-07-25 17:03:09');
INSERT INTO `access_log` VALUES (58855, '64.82.15640453894407805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '183.67.61.50', '2019-07-25 17:03:09', 2, 0, '', '2019-07-25 17:03:09');
INSERT INTO `access_log` VALUES (58856, '64.84.15640453930867783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '183.67.61.50', '2019-07-25 17:03:13', 2, 0, '', '2019-07-25 17:03:13');
INSERT INTO `access_log` VALUES (58857, '64.76.15640453932217787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '183.67.61.50', '2019-07-25 17:03:13', 2, 0, '', '2019-07-25 17:03:13');
INSERT INTO `access_log` VALUES (58858, '59.73.15640453938447561', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '183.67.61.50', '2019-07-25 17:03:14', 2, 0, '', '2019-07-25 17:03:14');
INSERT INTO `access_log` VALUES (58859, '59.76.15640453938447549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '183.67.61.50', '2019-07-25 17:03:14', 12, 2001001000, '服务端发生异常', '2019-07-25 17:03:14');
INSERT INTO `access_log` VALUES (58860, '59.76.15640462590547561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:39', 9, 2001001000, '服务端发生异常', '2019-07-25 17:17:39');
INSERT INTO `access_log` VALUES (58861, '59.73.15640462590547573', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:39', 71, 0, '', '2019-07-25 17:17:39');
INSERT INTO `access_log` VALUES (58862, '64.84.15640462617497795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:42', 3, 0, '', '2019-07-25 17:17:42');
INSERT INTO `access_log` VALUES (58863, '64.76.15640462618387799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:42', 1, 0, '', '2019-07-25 17:17:42');
INSERT INTO `access_log` VALUES (58864, '64.85.15640462627217833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:43', 2, 0, '', '2019-07-25 17:17:43');
INSERT INTO `access_log` VALUES (58865, '64.80.15640462631107809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:43', 1, 0, '', '2019-07-25 17:17:43');
INSERT INTO `access_log` VALUES (58866, '64.83.15640462634117803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:43', 2, 0, '', '2019-07-25 17:17:43');
INSERT INTO `access_log` VALUES (58867, '59.75.15640462645717577', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:45', 3, 0, '', '2019-07-25 17:17:45');
INSERT INTO `access_log` VALUES (58868, '59.78.15640462645717571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:45', 13, 2001001000, '服务端发生异常', '2019-07-25 17:17:45');
INSERT INTO `access_log` VALUES (58869, '64.77.15640462669967791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:47', 1, 0, '', '2019-07-25 17:17:47');
INSERT INTO `access_log` VALUES (58870, '64.78.15640462670707815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:47', 2, 0, '', '2019-07-25 17:17:47');
INSERT INTO `access_log` VALUES (58871, '64.79.15640462685297805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:49', 2, 0, '', '2019-07-25 17:17:49');
INSERT INTO `access_log` VALUES (58872, '64.81.15640462688797799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:49', 2, 0, '', '2019-07-25 17:17:49');
INSERT INTO `access_log` VALUES (58873, '59.71.15640462705247567', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:51', 2, 0, '', '2019-07-25 17:17:51');
INSERT INTO `access_log` VALUES (58874, '59.80.15640462705287547', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:17:51', 18, 2001001000, '服务端发生异常', '2019-07-25 17:17:51');
INSERT INTO `access_log` VALUES (58875, '65.54.15640462880339793', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:18:08', 0, 1002001015, '账号未登陆', '2019-07-25 17:18:08');
INSERT INTO `access_log` VALUES (58876, '65.52.15640462880329905', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:18:08', 0, 1002001015, '账号未登陆', '2019-07-25 17:18:08');
INSERT INTO `access_log` VALUES (58877, '65.3607.15640462880321671', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:18:08', 0, 1002001015, '账号未登陆', '2019-07-25 17:18:08');
INSERT INTO `access_log` VALUES (58878, '65.47.15640462907269859', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:18:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 17:18:11');
INSERT INTO `access_log` VALUES (58879, '65.49.15640462921099849', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:18:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 17:18:12');
INSERT INTO `access_log` VALUES (58880, '65.51.15640462930519937', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:18:13', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 17:18:13');
INSERT INTO `access_log` VALUES (58881, '65.45.15640462936299871', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:18:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 17:18:14');
INSERT INTO `access_log` VALUES (58882, '65.50.15640463055629883', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:18:26', 72, 0, '', '2019-07-25 17:18:26');
INSERT INTO `access_log` VALUES (58883, '65.3607.15640463059781673', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:18:26', 9, 0, '', '2019-07-25 17:18:26');
INSERT INTO `access_log` VALUES (58884, '65.54.15640463059859795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:18:26', 9, 2001001000, '服务端发生异常', '2019-07-25 17:18:26');
INSERT INTO `access_log` VALUES (58885, '65.52.15640463060259907', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '221.226.105.82', '2019-07-25 17:18:26', 10, 0, '', '2019-07-25 17:18:26');
INSERT INTO `access_log` VALUES (58886, '64.85.15640470581897845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:30:58', 3, 0, '', '2019-07-25 17:30:58');
INSERT INTO `access_log` VALUES (58887, '64.80.15640470582937821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:30:58', 2, 0, '', '2019-07-25 17:30:58');
INSERT INTO `access_log` VALUES (58888, '59.79.15640470590407585', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:30:59', 4, 0, '', '2019-07-25 17:30:59');
INSERT INTO `access_log` VALUES (58889, '59.73.15640470590757585', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:30:59', 17, 2001001000, '服务端发生异常', '2019-07-25 17:30:59');
INSERT INTO `access_log` VALUES (58890, '64.83.15640470618957815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:02', 2, 0, '', '2019-07-25 17:31:02');
INSERT INTO `access_log` VALUES (58891, '64.77.15640470620077803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:02', 2, 0, '', '2019-07-25 17:31:02');
INSERT INTO `access_log` VALUES (58892, '64.79.15640470679337817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:08', 2, 0, '', '2019-07-25 17:31:08');
INSERT INTO `access_log` VALUES (58893, '64.81.15640470690157811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:09', 1, 0, '', '2019-07-25 17:31:09');
INSERT INTO `access_log` VALUES (58894, '64.82.15640470701557831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:10', 2, 0, '', '2019-07-25 17:31:10');
INSERT INTO `access_log` VALUES (58895, '64.84.15640470712297809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:11', 2, 0, '', '2019-07-25 17:31:11');
INSERT INTO `access_log` VALUES (58896, '64.76.15640470722977813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:12', 2, 0, '', '2019-07-25 17:31:12');
INSERT INTO `access_log` VALUES (58897, '64.85.15640470741407847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:14', 2, 0, '', '2019-07-25 17:31:14');
INSERT INTO `access_log` VALUES (58898, '64.80.15640470757017823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:16', 2, 0, '', '2019-07-25 17:31:16');
INSERT INTO `access_log` VALUES (58899, '64.83.15640470765247817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:17', 2, 0, '', '2019-07-25 17:31:17');
INSERT INTO `access_log` VALUES (58900, '64.77.15640470773967805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:17', 2, 0, '', '2019-07-25 17:31:17');
INSERT INTO `access_log` VALUES (58901, '64.78.15640470777707829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:18', 2, 0, '', '2019-07-25 17:31:18');
INSERT INTO `access_log` VALUES (58902, '64.79.15640470789087819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:19', 2, 0, '', '2019-07-25 17:31:19');
INSERT INTO `access_log` VALUES (58903, '64.82.15640470815967833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:22', 1, 0, '', '2019-07-25 17:31:22');
INSERT INTO `access_log` VALUES (58904, '64.84.15640470821787811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:22', 2, 0, '', '2019-07-25 17:31:22');
INSERT INTO `access_log` VALUES (58905, '64.76.15640470827727815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:23', 2, 0, '', '2019-07-25 17:31:23');
INSERT INTO `access_log` VALUES (58906, '64.85.15640470896887849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:30', 3, 0, '', '2019-07-25 17:31:30');
INSERT INTO `access_log` VALUES (58907, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:30', 19, 0, '', '2019-07-25 17:31:30');
INSERT INTO `access_log` VALUES (58908, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:32', 5, 0, '', '2019-07-25 17:31:32');
INSERT INTO `access_log` VALUES (58909, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:33', 6, 0, '', '2019-07-25 17:31:33');
INSERT INTO `access_log` VALUES (58910, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:34', 6, 0, '', '2019-07-25 17:31:34');
INSERT INTO `access_log` VALUES (58911, '64.83.15640470958697819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:36', 2, 0, '', '2019-07-25 17:31:36');
INSERT INTO `access_log` VALUES (58912, '64.77.15640470960257807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:36', 2, 0, '', '2019-07-25 17:31:36');
INSERT INTO `access_log` VALUES (58913, '64.78.15640470971587831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:37', 2, 0, '', '2019-07-25 17:31:37');
INSERT INTO `access_log` VALUES (58914, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:37', 6, 0, '', '2019-07-25 17:31:37');
INSERT INTO `access_log` VALUES (58915, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:38', 5, 0, '', '2019-07-25 17:31:38');
INSERT INTO `access_log` VALUES (58916, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:39', 5, 0, '', '2019-07-25 17:31:39');
INSERT INTO `access_log` VALUES (58917, '64.79.15640470995457821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:40', 2, 0, '', '2019-07-25 17:31:40');
INSERT INTO `access_log` VALUES (58918, '64.81.15640470996937815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:40', 2, 0, '', '2019-07-25 17:31:40');
INSERT INTO `access_log` VALUES (58919, '64.82.15640471013667835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:41', 2, 0, '', '2019-07-25 17:31:41');
INSERT INTO `access_log` VALUES (58920, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:41', 5, 0, '', '2019-07-25 17:31:41');
INSERT INTO `access_log` VALUES (58921, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:42', 4, 0, '', '2019-07-25 17:31:42');
INSERT INTO `access_log` VALUES (58922, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:44', 15, 0, '', '2019-07-25 17:31:44');
INSERT INTO `access_log` VALUES (58923, '64.84.15640471042177813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:44', 3, 0, '', '2019-07-25 17:31:44');
INSERT INTO `access_log` VALUES (58924, '64.76.15640471043217817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:31:44', 3, 0, '', '2019-07-25 17:31:44');
INSERT INTO `access_log` VALUES (58925, '62.81.15640473182136599', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'createBeginTime=&createEndTime=&finishBeginTime=&finishEndTime=&pageNo=1&pageSize=10&payChannel=&status=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '60.191.26.140', '2019-07-25 17:35:18', 1, 1002001015, '账号未登陆', '2019-07-25 17:35:18');
INSERT INTO `access_log` VALUES (58926, '64.78.15640485190257851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:55:19', 3, 0, '', '2019-07-25 17:55:19');
INSERT INTO `access_log` VALUES (58927, '59.79.15640485197437605', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:55:20', 3, 0, '', '2019-07-25 17:55:20');
INSERT INTO `access_log` VALUES (58928, '59.73.15640485197867605', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:55:20', 13, 2001001000, '服务端发生异常', '2019-07-25 17:55:20');
INSERT INTO `access_log` VALUES (58929, '64.80.15640486026337847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:56:43', 2, 0, '', '2019-07-25 17:56:43');
INSERT INTO `access_log` VALUES (58930, '64.83.15640486027287841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.27', '2019-07-25 17:56:43', 2, 0, '', '2019-07-25 17:56:43');
INSERT INTO `access_log` VALUES (58931, '65.51.15640492259069979', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:06', 0, 1002001015, '账号未登陆', '2019-07-25 18:07:06');
INSERT INTO `access_log` VALUES (58932, '65.45.15640492259069913', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:06', 0, 1002001015, '账号未登陆', '2019-07-25 18:07:06');
INSERT INTO `access_log` VALUES (58933, '65.49.15640492259069889', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:06', 0, 1002001015, '账号未登陆', '2019-07-25 18:07:06');
INSERT INTO `access_log` VALUES (58934, '65.46.15640492318789985', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:12', 141, 0, '', '2019-07-25 18:07:12');
INSERT INTO `access_log` VALUES (58935, '65.3607.15640492323341713', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:12', 30, 0, '', '2019-07-25 18:07:12');
INSERT INTO `access_log` VALUES (58936, '65.52.15640492323449947', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:12', 23, 0, '', '2019-07-25 18:07:12');
INSERT INTO `access_log` VALUES (58937, '65.54.15640492323449835', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:12', 24, 2001001000, '服务端发生异常', '2019-07-25 18:07:12');
INSERT INTO `access_log` VALUES (58938, '65.47.15640492361559901', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:16', 10, 0, '', '2019-07-25 18:07:16');
INSERT INTO `access_log` VALUES (58939, '65.53.15640492361589903', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:16', 9, 2001001000, '服务端发生异常', '2019-07-25 18:07:16');
INSERT INTO `access_log` VALUES (58940, '65.51.15640492361619981', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:16', 8, 0, '', '2019-07-25 18:07:16');
INSERT INTO `access_log` VALUES (58941, '65.49.15640492374289891', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:17', 9, 0, '', '2019-07-25 18:07:17');
INSERT INTO `access_log` VALUES (58942, '65.50.15640492374319927', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:17', 8, 0, '', '2019-07-25 18:07:17');
INSERT INTO `access_log` VALUES (58943, '65.45.15640492374309915', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:17', 10, 2001001000, '服务端发生异常', '2019-07-25 18:07:17');
INSERT INTO `access_log` VALUES (58944, '59.76.15640492448417603', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:25', 234, 0, '', '2019-07-25 18:07:25');
INSERT INTO `access_log` VALUES (58945, '59.78.15640492448417613', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:25', 244, 2001001000, '服务端发生异常', '2019-07-25 18:07:25');
INSERT INTO `access_log` VALUES (58946, '59.75.15640492471947619', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:27', 8, 0, '', '2019-07-25 18:07:27');
INSERT INTO `access_log` VALUES (58947, '59.72.15640492471957605', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.117.5.224', '2019-07-25 18:07:27', 24, 2001001000, '服务端发生异常', '2019-07-25 18:07:27');
INSERT INTO `access_log` VALUES (58948, '64.82.15640492517587865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:32', 15, 0, '', '2019-07-25 18:07:32');
INSERT INTO `access_log` VALUES (58949, '64.76.15640492519237847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:32', 9, 0, '', '2019-07-25 18:07:32');
INSERT INTO `access_log` VALUES (58950, '64.80.15640492532677857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:33', 8, 0, '', '2019-07-25 18:07:33');
INSERT INTO `access_log` VALUES (58951, '64.77.15640492536517839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:34', 7, 0, '', '2019-07-25 18:07:34');
INSERT INTO `access_log` VALUES (58952, '64.78.15640492544097863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:34', 9, 0, '', '2019-07-25 18:07:34');
INSERT INTO `access_log` VALUES (58953, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:34', 13, 0, '', '2019-07-25 18:07:34');
INSERT INTO `access_log` VALUES (58954, '64.81.15640492555187847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:36', 8, 0, '', '2019-07-25 18:07:36');
INSERT INTO `access_log` VALUES (58955, '64.82.15640492556477867', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:36', 9, 0, '', '2019-07-25 18:07:36');
INSERT INTO `access_log` VALUES (58956, '64.84.15640492579587845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:38', 10, 0, '', '2019-07-25 18:07:38');
INSERT INTO `access_log` VALUES (58957, '64.76.15640492580737849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:38', 7, 0, '', '2019-07-25 18:07:38');
INSERT INTO `access_log` VALUES (58958, '66.48.15640492590245431', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:39', 6, 1002001012, '访问令牌已过期', '2019-07-25 18:07:39');
INSERT INTO `access_log` VALUES (58959, '66.53.15640492591415415', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=ab1fe7008d51409b95cbfb5ee150e69a', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:39', 10, 1002001018, '访问令牌已过期', '2019-07-25 18:07:39');
INSERT INTO `access_log` VALUES (58960, '66.52.15640492613565409', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:41', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空\n账号长度为 11 位\n手机号不能为空', '2019-07-25 18:07:41');
INSERT INTO `access_log` VALUES (58961, '66.51.15640492676405439', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12341234123412341234&code=2134234', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码长度为 4-6 位\n账号长度为 11 位', '2019-07-25 18:07:48');
INSERT INTO `access_log` VALUES (58962, '66.55.15640492761855399', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12341234123412341234&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:07:56', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-07-25 18:07:56');
INSERT INTO `access_log` VALUES (58963, '66.57.15640492823535425', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=1234123412&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:08:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-07-25 18:08:02');
INSERT INTO `access_log` VALUES (58964, '66.50.15640492908555415', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=1234123455&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:08:11', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-07-25 18:08:11');
INSERT INTO `access_log` VALUES (58965, '66.49.15640492997995421', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18611966723&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '123.117.5.224', '2019-07-25 18:08:20', 16, 1001003001, '验证码已过期', '2019-07-25 18:08:20');
INSERT INTO `access_log` VALUES (58966, '59.75.15640493716837621', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '223.166.151.197', '2019-07-25 18:09:32', 18, 2001001000, '服务端发生异常', '2019-07-25 18:09:32');
INSERT INTO `access_log` VALUES (58967, '59.77.15640494168837607', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '116.128.128.79', '2019-07-25 18:10:17', 3, 0, '', '2019-07-25 18:10:17');
INSERT INTO `access_log` VALUES (58968, '64.83.15640494480087855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '58.246.221.163', '2019-07-25 18:10:48', 2, 0, '', '2019-07-25 18:10:48');
INSERT INTO `access_log` VALUES (58969, '65.53.15640494496779907', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '223.166.151.191', '2019-07-25 18:10:50', 0, 1002001015, '账号未登陆', '2019-07-25 18:10:50');
INSERT INTO `access_log` VALUES (58970, '64.81.15640494949487851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '223.166.151.197', '2019-07-25 18:11:35', 2, 0, '', '2019-07-25 18:11:35');
INSERT INTO `access_log` VALUES (58971, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '223.166.151.197', '2019-07-25 18:11:43', 4, 0, '', '2019-07-25 18:11:43');
INSERT INTO `access_log` VALUES (58972, '64.76.15640495218927853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '223.166.151.197', '2019-07-25 18:12:02', 2, 0, '', '2019-07-25 18:12:02');
INSERT INTO `access_log` VALUES (58973, '65.46.15640495220059991', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '223.166.151.199', '2019-07-25 18:12:02', 1, 1002001015, '账号未登陆', '2019-07-25 18:12:02');
INSERT INTO `access_log` VALUES (58974, '66.57.15640495327335429', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '223.166.151.197', '2019-07-25 18:12:13', 0, 1002001015, '账号未登陆', '2019-07-25 18:12:13');
INSERT INTO `access_log` VALUES (58975, '64.80.15640495373067863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '223.166.151.199', '2019-07-25 18:12:17', 3, 0, '', '2019-07-25 18:12:17');
INSERT INTO `access_log` VALUES (58976, '65.52.15640495402989953', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '223.166.151.197', '2019-07-25 18:12:20', 0, 1002001015, '账号未登陆', '2019-07-25 18:12:20');
INSERT INTO `access_log` VALUES (58977, '65.49.15640602272290039', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:10:27', 0, 1002001015, '账号未登陆', '2019-07-25 21:10:27');
INSERT INTO `access_log` VALUES (58978, '65.51.15640602272290129', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:10:27', 0, 1002001015, '账号未登陆', '2019-07-25 21:10:27');
INSERT INTO `access_log` VALUES (58979, '65.45.15640602272320063', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:10:27', 1, 1002001015, '账号未登陆', '2019-07-25 21:10:27');
INSERT INTO `access_log` VALUES (58980, '65.50.15640602334410075', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:10:33', 76, 0, '', '2019-07-25 21:10:34');
INSERT INTO `access_log` VALUES (58981, '65.54.15640602339399985', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:10:34', 20, 0, '', '2019-07-25 21:10:34');
INSERT INTO `access_log` VALUES (58982, '65.46.15640602339380135', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:10:34', 23, 2001001000, '服务端发生异常', '2019-07-25 21:10:34');
INSERT INTO `access_log` VALUES (58983, '65.52.15640602339400097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:10:34', 22, 0, '', '2019-07-25 21:10:34');
INSERT INTO `access_log` VALUES (58984, '65.53.15640602405840053', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:10:41', 11, 0, '', '2019-07-25 21:10:41');
INSERT INTO `access_log` VALUES (58985, '65.47.15640602405910051', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:10:41', 10, 2001001000, '服务端发生异常', '2019-07-25 21:10:41');
INSERT INTO `access_log` VALUES (58986, '65.51.15640602405970131', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:10:41', 9, 0, '', '2019-07-25 21:10:41');
INSERT INTO `access_log` VALUES (58987, '65.49.15640602516570041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:10:52', 9, 0, '', '2019-07-25 21:10:52');
INSERT INTO `access_log` VALUES (58988, '65.45.15640602516590065', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:10:52', 10, 2001001000, '服务端发生异常', '2019-07-25 21:10:52');
INSERT INTO `access_log` VALUES (58989, '65.50.15640602516650077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:10:52', 8, 0, '', '2019-07-25 21:10:52');
INSERT INTO `access_log` VALUES (58990, '59.75.15640602879127767', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:11:28', 10, 0, '', '2019-07-25 21:11:28');
INSERT INTO `access_log` VALUES (58991, '59.72.15640602879147753', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '118.112.59.242', '2019-07-25 21:11:28', 23, 2001001000, '服务端发生异常', '2019-07-25 21:11:28');
INSERT INTO `access_log` VALUES (58992, '65.52.15640682442360205', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.80.97', '2019-07-25 23:24:04', 1, 1002001015, '账号未登陆', '2019-07-25 23:24:04');
INSERT INTO `access_log` VALUES (58993, '65.46.15640682442360245', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.80.97', '2019-07-25 23:24:04', 1, 1002001015, '账号未登陆', '2019-07-25 23:24:04');
INSERT INTO `access_log` VALUES (58994, '65.3607.15640682442361973', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.80.97', '2019-07-25 23:24:04', 0, 1002001015, '账号未登陆', '2019-07-25 23:24:04');
INSERT INTO `access_log` VALUES (58995, '65.53.15640682459910161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.80.97', '2019-07-25 23:24:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-25 23:24:06');
INSERT INTO `access_log` VALUES (58996, '65.51.15640682576540241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.80.97', '2019-07-25 23:24:18', 73, 0, '', '2019-07-25 23:24:18');
INSERT INTO `access_log` VALUES (58997, '65.50.15640682580560185', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.80.97', '2019-07-25 23:24:18', 13, 0, '', '2019-07-25 23:24:18');
INSERT INTO `access_log` VALUES (58998, '65.49.15640682580570149', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.80.97', '2019-07-25 23:24:18', 14, 2001001000, '服务端发生异常', '2019-07-25 23:24:18');
INSERT INTO `access_log` VALUES (58999, '65.45.15640682580630175', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.80.97', '2019-07-25 23:24:18', 12, 0, '', '2019-07-25 23:24:18');
INSERT INTO `access_log` VALUES (59000, '65.3607.15640682713351975', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.80.97', '2019-07-25 23:24:31', 11, 2001001000, '服务端发生异常', '2019-07-25 23:24:31');
INSERT INTO `access_log` VALUES (59001, '65.52.15640682713410207', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.80.97', '2019-07-25 23:24:31', 8, 0, '', '2019-07-25 23:24:31');
INSERT INTO `access_log` VALUES (59002, '65.46.15640682713520247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.80.97', '2019-07-25 23:24:31', 9, 0, '', '2019-07-25 23:24:31');
INSERT INTO `access_log` VALUES (59003, '65.50.15640716208350231', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '211.97.121.134', '2019-07-26 00:20:21', 0, 1002001015, '账号未登陆', '2019-07-26 00:20:21');
INSERT INTO `access_log` VALUES (59004, '65.49.15640716208370195', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '211.97.121.134', '2019-07-26 00:20:21', 1, 1002001015, '账号未登陆', '2019-07-26 00:20:21');
INSERT INTO `access_log` VALUES (59005, '65.45.15640716208500221', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '211.97.121.134', '2019-07-26 00:20:21', 1, 1002001015, '账号未登陆', '2019-07-26 00:20:21');
INSERT INTO `access_log` VALUES (59006, '65.3607.15640716246692021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '211.97.121.134', '2019-07-26 00:20:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 00:20:25');
INSERT INTO `access_log` VALUES (59007, '65.52.15640716410320253', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '211.97.121.134', '2019-07-26 00:20:41', 79, 0, '', '2019-07-26 00:20:41');
INSERT INTO `access_log` VALUES (59008, '65.53.15640716422300209', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '211.97.121.134', '2019-07-26 00:20:42', 11, 0, '', '2019-07-26 00:20:42');
INSERT INTO `access_log` VALUES (59009, '65.47.15640716422540209', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '211.97.121.134', '2019-07-26 00:20:42', 9, 2001001000, '服务端发生异常', '2019-07-26 00:20:42');
INSERT INTO `access_log` VALUES (59010, '65.51.15640716422690289', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '211.97.121.134', '2019-07-26 00:20:42', 9, 0, '', '2019-07-26 00:20:42');
INSERT INTO `access_log` VALUES (59011, '65.50.15640716516470233', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '211.97.121.134', '2019-07-26 00:20:52', 9, 0, '', '2019-07-26 00:20:52');
INSERT INTO `access_log` VALUES (59012, '65.45.15640716516600223', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '211.97.121.134', '2019-07-26 00:20:52', 10, 2001001000, '服务端发生异常', '2019-07-26 00:20:52');
INSERT INTO `access_log` VALUES (59013, '65.49.15640716516730197', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '211.97.121.134', '2019-07-26 00:20:52', 7, 0, '', '2019-07-26 00:20:52');
INSERT INTO `access_log` VALUES (59014, '65.47.15640720356370215', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.231.190.125', '2019-07-26 00:27:16', 0, 1002001015, '账号未登陆', '2019-07-26 00:27:16');
INSERT INTO `access_log` VALUES (59015, '65.49.15640720356390203', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.231.190.125', '2019-07-26 00:27:16', 0, 1002001015, '账号未登陆', '2019-07-26 00:27:16');
INSERT INTO `access_log` VALUES (59016, '65.50.15640720356420239', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.231.190.125', '2019-07-26 00:27:16', 0, 1002001015, '账号未登陆', '2019-07-26 00:27:16');
INSERT INTO `access_log` VALUES (59017, '65.45.15640720379190229', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.231.190.125', '2019-07-26 00:27:18', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 00:27:18');
INSERT INTO `access_log` VALUES (59018, '65.54.15640720389540149', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.18.194', '2019-07-26 00:27:19', 0, 1002001015, '账号未登陆', '2019-07-26 00:27:19');
INSERT INTO `access_log` VALUES (59019, '65.3607.15640720389572029', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.236.195.195', '2019-07-26 00:27:19', 0, 1002001015, '账号未登陆', '2019-07-26 00:27:19');
INSERT INTO `access_log` VALUES (59020, '65.46.15640720389580301', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.18.194', '2019-07-26 00:27:19', 1, 1002001015, '账号未登陆', '2019-07-26 00:27:19');
INSERT INTO `access_log` VALUES (59021, '65.52.15640720438630261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.18.194', '2019-07-26 00:27:24', 89, 0, '', '2019-07-26 00:27:24');
INSERT INTO `access_log` VALUES (59022, '65.51.15640720441550297', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.18.194', '2019-07-26 00:27:24', 15, 0, '', '2019-07-26 00:27:24');
INSERT INTO `access_log` VALUES (59023, '65.49.15640720441640205', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.18.194', '2019-07-26 00:27:24', 9, 0, '', '2019-07-26 00:27:24');
INSERT INTO `access_log` VALUES (59024, '65.50.15640720441640241', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.18.194', '2019-07-26 00:27:24', 10, 2001001000, '服务端发生异常', '2019-07-26 00:27:24');
INSERT INTO `access_log` VALUES (59025, '65.3607.15640720910052031', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.18.194', '2019-07-26 00:28:11', 9, 0, '', '2019-07-26 00:28:11');
INSERT INTO `access_log` VALUES (59026, '65.53.15640720910080219', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.18.194', '2019-07-26 00:28:11', 10, 0, '', '2019-07-26 00:28:11');
INSERT INTO `access_log` VALUES (59027, '65.46.15640720910070303', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.18.194', '2019-07-26 00:28:11', 10, 2001001000, '服务端发生异常', '2019-07-26 00:28:11');
INSERT INTO `access_log` VALUES (59028, '65.52.15640720980790263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.231.190.125', '2019-07-26 00:28:18', 98, 0, '', '2019-07-26 00:28:18');
INSERT INTO `access_log` VALUES (59029, '65.51.15640720983990299', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.231.190.125', '2019-07-26 00:28:18', 9, 0, '', '2019-07-26 00:28:18');
INSERT INTO `access_log` VALUES (59030, '65.49.15640720984030207', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.231.190.125', '2019-07-26 00:28:18', 9, 0, '', '2019-07-26 00:28:18');
INSERT INTO `access_log` VALUES (59031, '65.50.15640720984030243', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.231.190.125', '2019-07-26 00:28:18', 10, 2001001000, '服务端发生异常', '2019-07-26 00:28:18');
INSERT INTO `access_log` VALUES (59032, '65.47.15640720989830219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.18.194', '2019-07-26 00:28:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 00:28:19');
INSERT INTO `access_log` VALUES (59033, '65.45.15640721014390233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.18.194', '2019-07-26 00:28:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 00:28:21');
INSERT INTO `access_log` VALUES (59034, '65.46.15640721043390305', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.18.194', '2019-07-26 00:28:24', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 00:28:24');
INSERT INTO `access_log` VALUES (59035, '65.3607.15640721113942033', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.68.18.194', '2019-07-26 00:28:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 00:28:31');
INSERT INTO `access_log` VALUES (59036, '59.72.15640806585308025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:50:59', 11, 0, '', '2019-07-26 02:50:59');
INSERT INTO `access_log` VALUES (59037, '59.75.15640806585308039', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:50:59', 25, 2001001000, '服务端发生异常', '2019-07-26 02:50:59');
INSERT INTO `access_log` VALUES (59038, '64.82.15640806632958287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:51:03', 12, 0, '', '2019-07-26 02:51:03');
INSERT INTO `access_log` VALUES (59039, '64.84.15640806634278265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:51:03', 3, 0, '', '2019-07-26 02:51:03');
INSERT INTO `access_log` VALUES (59040, '64.76.15640806645198269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:51:05', 2, 0, '', '2019-07-26 02:51:05');
INSERT INTO `access_log` VALUES (59041, '64.85.15640806650418303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:51:05', 2, 0, '', '2019-07-26 02:51:05');
INSERT INTO `access_log` VALUES (59042, '65.50.15640807699390359', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:52:50', 0, 1002001015, '账号未登陆', '2019-07-26 02:52:50');
INSERT INTO `access_log` VALUES (59043, '65.53.15640807699340337', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:52:50', 1, 1002001015, '账号未登陆', '2019-07-26 02:52:50');
INSERT INTO `access_log` VALUES (59044, '65.54.15640807699390271', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:52:50', 0, 1002001015, '账号未登陆', '2019-07-26 02:52:50');
INSERT INTO `access_log` VALUES (59045, '65.51.15640807812250417', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:53:01', 61, 0, '', '2019-07-26 02:53:01');
INSERT INTO `access_log` VALUES (59046, '65.52.15640807815940381', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:53:02', 15, 0, '', '2019-07-26 02:53:02');
INSERT INTO `access_log` VALUES (59047, '65.45.15640807816040351', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:53:02', 13, 2001001000, '服务端发生异常', '2019-07-26 02:53:02');
INSERT INTO `access_log` VALUES (59048, '65.49.15640807816060325', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:53:02', 13, 0, '', '2019-07-26 02:53:02');
INSERT INTO `access_log` VALUES (59049, '65.3607.15640807869432151', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:53:07', 10, 0, '', '2019-07-26 02:53:07');
INSERT INTO `access_log` VALUES (59050, '65.46.15640807869470423', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:53:07', 10, 2001001000, '服务端发生异常', '2019-07-26 02:53:07');
INSERT INTO `access_log` VALUES (59051, '65.54.15640807869500273', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:53:07', 8, 0, '', '2019-07-26 02:53:07');
INSERT INTO `access_log` VALUES (59052, '65.53.15640807926480339', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:53:13', 9, 0, '', '2019-07-26 02:53:13');
INSERT INTO `access_log` VALUES (59053, '65.47.15640807926540339', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:53:13', 10, 2001001000, '服务端发生异常', '2019-07-26 02:53:13');
INSERT INTO `access_log` VALUES (59054, '65.51.15640807926560419', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.47.5.231', '2019-07-26 02:53:13', 9, 0, '', '2019-07-26 02:53:13');
INSERT INTO `access_log` VALUES (59055, '59.77.15641040904358337', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-26 09:21:30', 11, 0, '', '2019-07-26 09:21:30');
INSERT INTO `access_log` VALUES (59056, '59.74.15641040904468355', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-26 09:21:30', 21, 2001001000, '服务端发生异常', '2019-07-26 09:21:30');
INSERT INTO `access_log` VALUES (59057, '64.81.15641040996248581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-26 09:21:40', 12, 0, '', '2019-07-26 09:21:40');
INSERT INTO `access_log` VALUES (59058, '64.82.15641040997648601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-26 09:21:40', 3, 0, '', '2019-07-26 09:21:40');
INSERT INTO `access_log` VALUES (59059, '66.50.15641042965506149', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13812340001&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-26 09:24:57', 16, 1001003000, '验证码不存在', '2019-07-26 09:24:57');
INSERT INTO `access_log` VALUES (59060, '65.54.15641044645620593', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.238.58.49', '2019-07-26 09:27:45', 1, 1002001015, '账号未登陆', '2019-07-26 09:27:45');
INSERT INTO `access_log` VALUES (59061, '65.51.15641044645620735', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.238.58.49', '2019-07-26 09:27:45', 1, 1002001015, '账号未登陆', '2019-07-26 09:27:45');
INSERT INTO `access_log` VALUES (59062, '65.3607.15641044645622469', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.238.58.49', '2019-07-26 09:27:45', 0, 1002001015, '账号未登陆', '2019-07-26 09:27:45');
INSERT INTO `access_log` VALUES (59063, '65.45.15641044753560673', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.238.58.49', '2019-07-26 09:27:55', 155, 0, '', '2019-07-26 09:27:56');
INSERT INTO `access_log` VALUES (59064, '65.50.15641044757710677', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.238.58.49', '2019-07-26 09:27:56', 13, 0, '', '2019-07-26 09:27:56');
INSERT INTO `access_log` VALUES (59065, '65.52.15641044757740699', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.238.58.49', '2019-07-26 09:27:56', 11, 0, '', '2019-07-26 09:27:56');
INSERT INTO `access_log` VALUES (59066, '65.47.15641044757750659', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.238.58.49', '2019-07-26 09:27:56', 11, 2001001000, '服务端发生异常', '2019-07-26 09:27:56');
INSERT INTO `access_log` VALUES (59067, '65.3607.15641045013502471', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-26 09:28:21', 4, 1002001012, '访问令牌已过期', '2019-07-26 09:28:21');
INSERT INTO `access_log` VALUES (59068, '65.53.15641045013500659', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-26 09:28:21', 4, 1002001012, '访问令牌已过期', '2019-07-26 09:28:21');
INSERT INTO `access_log` VALUES (59069, '65.51.15641045013530737', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-26 09:28:21', 3, 1002001012, '访问令牌已过期', '2019-07-26 09:28:21');
INSERT INTO `access_log` VALUES (59070, '65.49.15641045040780649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-26 09:28:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 09:28:24');
INSERT INTO `access_log` VALUES (59071, '65.45.15641045089350675', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-26 09:28:29', 57, 0, '', '2019-07-26 09:28:29');
INSERT INTO `access_log` VALUES (59072, '65.50.15641045095690679', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-26 09:28:30', 10, 0, '', '2019-07-26 09:28:30');
INSERT INTO `access_log` VALUES (59073, '65.52.15641045095810701', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-26 09:28:30', 9, 2001001000, '服务端发生异常', '2019-07-26 09:28:30');
INSERT INTO `access_log` VALUES (59074, '65.47.15641045095880661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '122.224.90.226', '2019-07-26 09:28:30', 8, 0, '', '2019-07-26 09:28:30');
INSERT INTO `access_log` VALUES (59075, '65.51.15641045274250739', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.238.58.49', '2019-07-26 09:28:47', 9, 0, '', '2019-07-26 09:28:47');
INSERT INTO `access_log` VALUES (59076, '65.3607.15641045274322473', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.238.58.49', '2019-07-26 09:28:47', 9, 0, '', '2019-07-26 09:28:47');
INSERT INTO `access_log` VALUES (59077, '65.53.15641045274310661', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.238.58.49', '2019-07-26 09:28:47', 9, 2001001000, '服务端发生异常', '2019-07-26 09:28:47');
INSERT INTO `access_log` VALUES (59078, '65.54.15641045312140597', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.238.58.49', '2019-07-26 09:28:51', 9, 0, '', '2019-07-26 09:28:51');
INSERT INTO `access_log` VALUES (59079, '65.49.15641045312180651', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.238.58.49', '2019-07-26 09:28:51', 9, 2001001000, '服务端发生异常', '2019-07-26 09:28:51');
INSERT INTO `access_log` VALUES (59080, '65.45.15641045312210677', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.238.58.49', '2019-07-26 09:28:51', 9, 0, '', '2019-07-26 09:28:51');
INSERT INTO `access_log` VALUES (59081, '64.85.15641063933868647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.137.55.100', '2019-07-26 09:59:53', 10, 0, '', '2019-07-26 09:59:53');
INSERT INTO `access_log` VALUES (59082, '64.78.15641074955438641', 0, 2, 'product-application', '/product-api/admins/attr/add', 'name=颜色', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.229.232.191', '2019-07-26 10:18:16', 0, 1002001015, '账号未登陆', '2019-07-26 10:18:16');
INSERT INTO `access_log` VALUES (59083, '65.50.15641075201740721', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:18:40', 12, 1002001012, '访问令牌已过期', '2019-07-26 10:18:40');
INSERT INTO `access_log` VALUES (59084, '65.52.15641075201750743', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:18:40', 11, 1002001012, '访问令牌已过期', '2019-07-26 10:18:40');
INSERT INTO `access_log` VALUES (59085, '65.47.15641075201760703', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:18:40', 13, 1002001012, '访问令牌已过期', '2019-07-26 10:18:40');
INSERT INTO `access_log` VALUES (59086, '65.46.15641075218960789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:18:42', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 10:18:42');
INSERT INTO `access_log` VALUES (59087, '65.53.15641075277810703', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:18:48', 155, 0, '', '2019-07-26 10:18:48');
INSERT INTO `access_log` VALUES (59088, '65.3607.15641075280912515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:18:48', 11, 0, '', '2019-07-26 10:18:48');
INSERT INTO `access_log` VALUES (59089, '65.51.15641075280920781', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:18:48', 13, 2001001000, '服务端发生异常', '2019-07-26 10:18:48');
INSERT INTO `access_log` VALUES (59090, '65.45.15641075280940719', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:18:48', 12, 0, '', '2019-07-26 10:18:48');
INSERT INTO `access_log` VALUES (59091, '65.50.15641075583810723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:19:18', 51, 0, '', '2019-07-26 10:19:18');
INSERT INTO `access_log` VALUES (59092, '65.52.15641075585710745', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:19:19', 9, 0, '', '2019-07-26 10:19:19');
INSERT INTO `access_log` VALUES (59093, '65.47.15641075585720705', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:19:19', 10, 0, '', '2019-07-26 10:19:19');
INSERT INTO `access_log` VALUES (59094, '65.46.15641075585720791', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:19:19', 9, 0, '', '2019-07-26 10:19:19');
INSERT INTO `access_log` VALUES (59095, '64.85.15641075667778665', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:19:27', 22, 0, '', '2019-07-26 10:19:27');
INSERT INTO `access_log` VALUES (59096, '64.80.15641075667778639', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:19:27', 27, 0, '', '2019-07-26 10:19:27');
INSERT INTO `access_log` VALUES (59097, '65.46.15641076610540793', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.229.232.191', '2019-07-26 10:21:01', 0, 1002001015, '账号未登陆', '2019-07-26 10:21:01');
INSERT INTO `access_log` VALUES (59098, '65.45.15641076610550723', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.229.232.191', '2019-07-26 10:21:01', 0, 1002001015, '账号未登陆', '2019-07-26 10:21:01');
INSERT INTO `access_log` VALUES (59099, '65.51.15641076610600785', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.229.232.191', '2019-07-26 10:21:01', 1, 1002001015, '账号未登陆', '2019-07-26 10:21:01');
INSERT INTO `access_log` VALUES (59100, '65.3607.15641076662542519', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.229.232.191', '2019-07-26 10:21:06', 66, 0, '', '2019-07-26 10:21:06');
INSERT INTO `access_log` VALUES (59101, '65.54.15641076665430643', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.229.232.191', '2019-07-26 10:21:07', 9, 0, '', '2019-07-26 10:21:07');
INSERT INTO `access_log` VALUES (59102, '65.49.15641076665500697', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.229.232.191', '2019-07-26 10:21:07', 10, 2001001000, '服务端发生异常', '2019-07-26 10:21:07');
INSERT INTO `access_log` VALUES (59103, '65.50.15641076665560725', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.229.232.191', '2019-07-26 10:21:07', 9, 0, '', '2019-07-26 10:21:07');
INSERT INTO `access_log` VALUES (59104, '65.53.15641077883400709', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.17.107.226', '2019-07-26 10:23:08', 0, 1002001015, '账号未登陆', '2019-07-26 10:23:08');
INSERT INTO `access_log` VALUES (59105, '65.45.15641077883520725', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.17.107.226', '2019-07-26 10:23:08', 0, 1002001015, '账号未登陆', '2019-07-26 10:23:08');
INSERT INTO `access_log` VALUES (59106, '65.51.15641077883650787', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.17.107.226', '2019-07-26 10:23:08', 1, 1002001015, '账号未登陆', '2019-07-26 10:23:08');
INSERT INTO `access_log` VALUES (59107, '65.49.15641078136610701', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.17.107.226', '2019-07-26 10:23:34', 154, 0, '', '2019-07-26 10:23:34');
INSERT INTO `access_log` VALUES (59108, '65.54.15641078140780647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.17.107.226', '2019-07-26 10:23:34', 160, 0, '', '2019-07-26 10:23:34');
INSERT INTO `access_log` VALUES (59109, '65.52.15641078140800753', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.17.107.226', '2019-07-26 10:23:34', 161, 0, '', '2019-07-26 10:23:34');
INSERT INTO `access_log` VALUES (59110, '65.50.15641078140790729', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.17.107.226', '2019-07-26 10:23:34', 162, 2001001000, '服务端发生异常', '2019-07-26 10:23:34');
INSERT INTO `access_log` VALUES (59111, '65.53.15641078302890711', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.17.107.226', '2019-07-26 10:23:50', 10, 0, '', '2019-07-26 10:23:50');
INSERT INTO `access_log` VALUES (59112, '65.45.15641078302930727', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.17.107.226', '2019-07-26 10:23:50', 9, 2001001000, '服务端发生异常', '2019-07-26 10:23:50');
INSERT INTO `access_log` VALUES (59113, '65.51.15641078302950789', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '218.17.107.226', '2019-07-26 10:23:50', 9, 0, '', '2019-07-26 10:23:50');
INSERT INTO `access_log` VALUES (59114, '65.54.15641080516940651', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:27:32', 11, 0, '', '2019-07-26 10:27:32');
INSERT INTO `access_log` VALUES (59115, '65.47.15641080516940717', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:27:32', 12, 0, '', '2019-07-26 10:27:32');
INSERT INTO `access_log` VALUES (59116, '65.53.15641080517080715', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:27:32', 9, 0, '', '2019-07-26 10:27:32');
INSERT INTO `access_log` VALUES (59117, '64.78.15641080518348649', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:27:32', 56, 0, '', '2019-07-26 10:27:32');
INSERT INTO `access_log` VALUES (59118, '64.81.15641080518388637', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.160.49.183', '2019-07-26 10:27:32', 51, 0, '', '2019-07-26 10:27:32');
INSERT INTO `access_log` VALUES (59119, '59.75.15641128107148469', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.112.8.202', '2019-07-26 11:46:51', 11, 0, '', '2019-07-26 11:46:51');
INSERT INTO `access_log` VALUES (59120, '59.71.15641128107168459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.112.8.202', '2019-07-26 11:46:51', 20, 2001001000, '服务端发生异常', '2019-07-26 11:46:51');
INSERT INTO `access_log` VALUES (59121, '64.81.15641128147098701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.112.8.202', '2019-07-26 11:46:55', 11, 0, '', '2019-07-26 11:46:55');
INSERT INTO `access_log` VALUES (59122, '64.78.15641128149218713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.112.8.202', '2019-07-26 11:46:55', 3, 0, '', '2019-07-26 11:46:55');
INSERT INTO `access_log` VALUES (59123, '64.79.15641128161818705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.112.8.202', '2019-07-26 11:46:56', 2, 0, '', '2019-07-26 11:46:56');
INSERT INTO `access_log` VALUES (59124, '64.84.15641128165818697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.112.8.202', '2019-07-26 11:46:57', 2, 0, '', '2019-07-26 11:46:57');
INSERT INTO `access_log` VALUES (59125, '64.82.15641128171768721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.112.8.202', '2019-07-26 11:46:57', 1, 0, '', '2019-07-26 11:46:57');
INSERT INTO `access_log` VALUES (59126, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.112.8.202', '2019-07-26 11:47:00', 7, 0, '', '2019-07-26 11:47:00');
INSERT INTO `access_log` VALUES (59127, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.112.8.202', '2019-07-26 11:47:00', 5, 0, '', '2019-07-26 11:47:00');
INSERT INTO `access_log` VALUES (59128, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.112.8.202', '2019-07-26 11:47:00', 13, 0, '', '2019-07-26 11:47:00');
INSERT INTO `access_log` VALUES (59129, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.112.8.202', '2019-07-26 11:47:00', 10, 0, '', '2019-07-26 11:47:00');
INSERT INTO `access_log` VALUES (59130, '64.76.15641128221178701', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.112.8.202', '2019-07-26 11:47:02', 6, 0, '', '2019-07-26 11:47:02');
INSERT INTO `access_log` VALUES (59131, '66.50.15641128368256263', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:47:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-07-26 11:47:17');
INSERT INTO `access_log` VALUES (59132, '64.80.15641128396568711', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:47:20', 7, 0, '', '2019-07-26 11:47:20');
INSERT INTO `access_log` VALUES (59133, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:47:20', 7, 0, '', '2019-07-26 11:47:20');
INSERT INTO `access_log` VALUES (59134, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:47:21', 12, 0, '', '2019-07-26 11:47:21');
INSERT INTO `access_log` VALUES (59135, '64.77.15641128413568693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:47:21', 2, 0, '', '2019-07-26 11:47:21');
INSERT INTO `access_log` VALUES (59136, '64.81.15641128414888703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:47:21', 2, 0, '', '2019-07-26 11:47:21');
INSERT INTO `access_log` VALUES (59137, '59.73.15641128417448467', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:47:22', 3, 0, '', '2019-07-26 11:47:22');
INSERT INTO `access_log` VALUES (59138, '59.80.15641128417448439', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:47:22', 17, 2001001000, '服务端发生异常', '2019-07-26 11:47:22');
INSERT INTO `access_log` VALUES (59139, '64.78.15641128454598715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:47:25', 2, 0, '', '2019-07-26 11:47:25');
INSERT INTO `access_log` VALUES (59140, '64.79.15641128459278707', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:47:26', 1, 0, '', '2019-07-26 11:47:26');
INSERT INTO `access_log` VALUES (59141, '64.84.15641128477778699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:47:28', 1, 0, '', '2019-07-26 11:47:28');
INSERT INTO `access_log` VALUES (59142, '64.82.15641128478968723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:47:28', 2, 0, '', '2019-07-26 11:47:28');
INSERT INTO `access_log` VALUES (59143, '59.79.15641128492998467', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:47:29', 9, 0, '', '2019-07-26 11:47:29');
INSERT INTO `access_log` VALUES (59144, '59.78.15641128493088465', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:47:29', 12, 2001001000, '服务端发生异常', '2019-07-26 11:47:29');
INSERT INTO `access_log` VALUES (59145, '65.49.15641128587930769', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:47:39', 1, 1002001015, '账号未登陆', '2019-07-26 11:47:39');
INSERT INTO `access_log` VALUES (59146, '65.52.15641128588010825', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:47:39', 0, 1002001015, '账号未登陆', '2019-07-26 11:47:39');
INSERT INTO `access_log` VALUES (59147, '65.53.15641128588190785', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:47:39', 1, 1002001015, '账号未登陆', '2019-07-26 11:47:39');
INSERT INTO `access_log` VALUES (59148, '66.53.15641128589606265', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18510344250&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:47:39', 16, 1001003000, '验证码不存在', '2019-07-26 11:47:39');
INSERT INTO `access_log` VALUES (59149, '66.52.15641128614746259', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18510344250', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:47:41', 105, 0, '', '2019-07-26 11:47:42');
INSERT INTO `access_log` VALUES (59150, '65.50.15641128705370795', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:47:51', 102, 0, '', '2019-07-26 11:47:51');
INSERT INTO `access_log` VALUES (59151, '65.47.15641128710010787', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:47:51', 11, 0, '', '2019-07-26 11:47:51');
INSERT INTO `access_log` VALUES (59152, '65.51.15641128710080861', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:47:51', 9, 2001001000, '服务端发生异常', '2019-07-26 11:47:51');
INSERT INTO `access_log` VALUES (59153, '65.45.15641128710130791', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:47:51', 9, 0, '', '2019-07-26 11:47:51');
INSERT INTO `access_log` VALUES (59154, '66.56.15641128738226283', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18510344250&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:47:54', 180, 0, '', '2019-07-26 11:47:54');
INSERT INTO `access_log` VALUES (59155, '64.83.15641128835288707', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:04', 7, 0, '', '2019-07-26 11:48:04');
INSERT INTO `access_log` VALUES (59156, '64.81.15641128836938705', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:04', 6, 0, '', '2019-07-26 11:48:04');
INSERT INTO `access_log` VALUES (59157, '66.57.15641128850266275', 181, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:05', 6, 0, '', '2019-07-26 11:48:05');
INSERT INTO `access_log` VALUES (59158, '65.46.15641128867050869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:48:07', 12, 0, '', '2019-07-26 11:48:07');
INSERT INTO `access_log` VALUES (59159, '65.52.15641128867120827', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:48:07', 11, 2001001000, '服务端发生异常', '2019-07-26 11:48:07');
INSERT INTO `access_log` VALUES (59160, '65.49.15641128867150771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '119.137.52.204', '2019-07-26 11:48:07', 10, 0, '', '2019-07-26 11:48:07');
INSERT INTO `access_log` VALUES (59161, '66.50.15641128901806265', 181, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:10', 6, 0, '', '2019-07-26 11:48:10');
INSERT INTO `access_log` VALUES (59162, '59.76.15641128913778455', 181, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:11', 7, 0, '', '2019-07-26 11:48:11');
INSERT INTO `access_log` VALUES (59163, '59.73.15641128914068469', 181, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:11', 18, 2001001000, '服务端发生异常', '2019-07-26 11:48:11');
INSERT INTO `access_log` VALUES (59164, '64.79.15641128939908709', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:14', 7, 0, '', '2019-07-26 11:48:14');
INSERT INTO `access_log` VALUES (59165, '64.84.15641128940968701', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:14', 7, 0, '', '2019-07-26 11:48:14');
INSERT INTO `access_log` VALUES (59166, '64.82.15641128952188725', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:15', 6, 0, '', '2019-07-26 11:48:15');
INSERT INTO `access_log` VALUES (59167, 'N/A', 181, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:15', 12, 0, '', '2019-07-26 11:48:15');
INSERT INTO `access_log` VALUES (59168, '64.85.15641128976128741', 181, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:18', 16, 0, '', '2019-07-26 11:48:18');
INSERT INTO `access_log` VALUES (59169, '66.48.15641129004186283', 181, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:20', 25, 0, '', '2019-07-26 11:48:20');
INSERT INTO `access_log` VALUES (59170, '66.51.15641129039626291', 181, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:24', 5, 0, '', '2019-07-26 11:48:24');
INSERT INTO `access_log` VALUES (59171, '66.55.15641129305236251', 181, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:51', 5, 0, '', '2019-07-26 11:48:51');
INSERT INTO `access_log` VALUES (59172, '66.54.15641129310056275', 181, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:51', 6, 0, '', '2019-07-26 11:48:51');
INSERT INTO `access_log` VALUES (59173, '64.81.15641129314658707', 181, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:51', 8, 0, '', '2019-07-26 11:48:51');
INSERT INTO `access_log` VALUES (59174, '64.78.15641129324158719', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:52', 5, 0, '', '2019-07-26 11:48:52');
INSERT INTO `access_log` VALUES (59175, 'N/A', 181, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:52', 12, 0, '', '2019-07-26 11:48:52');
INSERT INTO `access_log` VALUES (59176, '64.79.15641129329508711', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:53', 5, 0, '', '2019-07-26 11:48:53');
INSERT INTO `access_log` VALUES (59177, '64.84.15641129330988703', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:53', 4, 0, '', '2019-07-26 11:48:53');
INSERT INTO `access_log` VALUES (59178, '64.76.15641129345588707', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:55', 5, 0, '', '2019-07-26 11:48:55');
INSERT INTO `access_log` VALUES (59179, '64.80.15641129353188717', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:55', 4, 0, '', '2019-07-26 11:48:55');
INSERT INTO `access_log` VALUES (59180, '64.83.15641129365568711', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:57', 6, 0, '', '2019-07-26 11:48:57');
INSERT INTO `access_log` VALUES (59181, 'N/A', 181, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:57', 9, 0, '', '2019-07-26 11:48:57');
INSERT INTO `access_log` VALUES (59182, '64.77.15641129381268699', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:58', 6, 0, '', '2019-07-26 11:48:58');
INSERT INTO `access_log` VALUES (59183, '64.81.15641129382528709', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:48:58', 5, 0, '', '2019-07-26 11:48:58');
INSERT INTO `access_log` VALUES (59184, 'N/A', 181, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:00', 10, 0, '', '2019-07-26 11:49:00');
INSERT INTO `access_log` VALUES (59185, 'N/A', 181, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:00', 20, 0, '', '2019-07-26 11:49:00');
INSERT INTO `access_log` VALUES (59186, 'N/A', 181, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:01', 10, 0, '', '2019-07-26 11:49:01');
INSERT INTO `access_log` VALUES (59187, 'N/A', 181, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:01', 16, 0, '', '2019-07-26 11:49:01');
INSERT INTO `access_log` VALUES (59188, 'N/A', 181, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:16', 8, 0, '', '2019-07-26 11:49:16');
INSERT INTO `access_log` VALUES (59189, 'N/A', 181, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:16', 11, 0, '', '2019-07-26 11:49:16');
INSERT INTO `access_log` VALUES (59190, '64.84.15641129570748705', 181, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:17', 9, 0, '', '2019-07-26 11:49:17');
INSERT INTO `access_log` VALUES (59191, '66.49.15641129597196273', 181, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:20', 6, 0, '', '2019-07-26 11:49:20');
INSERT INTO `access_log` VALUES (59192, '64.76.15641129679938709', 181, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:28', 10, 0, '', '2019-07-26 11:49:28');
INSERT INTO `access_log` VALUES (59193, 'N/A', 181, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:29', 12, 0, '', '2019-07-26 11:49:29');
INSERT INTO `access_log` VALUES (59194, 'N/A', 181, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:29', 14, 0, '', '2019-07-26 11:49:29');
INSERT INTO `access_log` VALUES (59195, '64.85.15641129694558745', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:29', 5, 0, '', '2019-07-26 11:49:29');
INSERT INTO `access_log` VALUES (59196, '64.80.15641129695798719', 181, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:30', 12, 0, '', '2019-07-26 11:49:30');
INSERT INTO `access_log` VALUES (59197, '59.75.15641129716578473', 181, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:32', 6, 0, '', '2019-07-26 11:49:32');
INSERT INTO `access_log` VALUES (59198, '59.71.15641129716588463', 181, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '36.112.8.202', '2019-07-26 11:49:32', 22, 2001001000, '服务端发生异常', '2019-07-26 11:49:32');
INSERT INTO `access_log` VALUES (59199, '59.78.15641130409978469', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.252.226', '2019-07-26 11:50:41', 3, 0, '', '2019-07-26 11:50:41');
INSERT INTO `access_log` VALUES (59200, '59.74.15641130409998477', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.252.226', '2019-07-26 11:50:41', 15, 2001001000, '服务端发生异常', '2019-07-26 11:50:41');
INSERT INTO `access_log` VALUES (59201, '59.74.15641133261698481', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:26', 3, 0, '', '2019-07-26 11:55:26');
INSERT INTO `access_log` VALUES (59202, '59.72.15641133261698465', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:26', 33, 2001001000, '服务端发生异常', '2019-07-26 11:55:26');
INSERT INTO `access_log` VALUES (59203, '64.79.15641133300468719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:30', 4, 0, '', '2019-07-26 11:55:30');
INSERT INTO `access_log` VALUES (59204, '64.84.15641133302238711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:30', 2, 0, '', '2019-07-26 11:55:30');
INSERT INTO `access_log` VALUES (59205, '64.82.15641133313708735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:31', 1, 0, '', '2019-07-26 11:55:31');
INSERT INTO `access_log` VALUES (59206, '64.76.15641133322298715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:32', 2, 0, '', '2019-07-26 11:55:32');
INSERT INTO `access_log` VALUES (59207, '64.85.15641133330358751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:33', 2, 0, '', '2019-07-26 11:55:33');
INSERT INTO `access_log` VALUES (59208, '64.80.15641133349588725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:35', 2, 0, '', '2019-07-26 11:55:35');
INSERT INTO `access_log` VALUES (59209, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:35', 6, 0, '', '2019-07-26 11:55:35');
INSERT INTO `access_log` VALUES (59210, '64.77.15641133365988707', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:37', 8, 0, '', '2019-07-26 11:55:37');
INSERT INTO `access_log` VALUES (59211, '64.81.15641133496038717', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:50', 7, 0, '', '2019-07-26 11:55:50');
INSERT INTO `access_log` VALUES (59212, '64.79.15641133506998721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:51', 2, 0, '', '2019-07-26 11:55:51');
INSERT INTO `access_log` VALUES (59213, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:51', 6, 0, '', '2019-07-26 11:55:51');
INSERT INTO `access_log` VALUES (59214, '64.84.15641133524088713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:52', 2, 0, '', '2019-07-26 11:55:52');
INSERT INTO `access_log` VALUES (59215, '64.82.15641133525588737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:53', 2, 0, '', '2019-07-26 11:55:53');
INSERT INTO `access_log` VALUES (59216, '64.76.15641133544628717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:55:54', 2, 0, '', '2019-07-26 11:55:54');
INSERT INTO `access_log` VALUES (59217, '59.77.15641133619348463', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:56:02', 3, 0, '', '2019-07-26 11:56:02');
INSERT INTO `access_log` VALUES (59218, '59.76.15641133619358463', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.52.204', '2019-07-26 11:56:02', 16, 2001001000, '服务端发生异常', '2019-07-26 11:56:02');
INSERT INTO `access_log` VALUES (59219, '65.53.15641134757340795', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-26 11:57:56', 0, 1002001015, '账号未登陆', '2019-07-26 11:57:56');
INSERT INTO `access_log` VALUES (59220, '65.54.15641134757380723', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-26 11:57:56', 1, 1002001015, '账号未登陆', '2019-07-26 11:57:56');
INSERT INTO `access_log` VALUES (59221, '65.50.15641134758520805', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-26 11:57:56', 1, 1002001015, '账号未登陆', '2019-07-26 11:57:56');
INSERT INTO `access_log` VALUES (59222, '65.45.15641134802040801', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-26 11:58:00', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 11:58:00');
INSERT INTO `access_log` VALUES (59223, '65.54.15641135648360725', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-26 11:59:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 11:59:25');
INSERT INTO `access_log` VALUES (59224, '65.50.15641135839430807', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyunama&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-26 11:59:44', 5, 1002002000, '账号不存在', '2019-07-26 11:59:44');
INSERT INTO `access_log` VALUES (59225, '65.51.15641136019280873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-26 12:00:02', 71, 0, '', '2019-07-26 12:00:02');
INSERT INTO `access_log` VALUES (59226, '65.49.15641136022710783', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-26 12:00:02', 28, 0, '', '2019-07-26 12:00:02');
INSERT INTO `access_log` VALUES (59227, '65.47.15641136022410799', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-26 12:00:02', 57, 0, '', '2019-07-26 12:00:02');
INSERT INTO `access_log` VALUES (59228, '65.3607.15641136022442609', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-26 12:00:02', 55, 2001001000, '服务端发生异常', '2019-07-26 12:00:02');
INSERT INTO `access_log` VALUES (59229, '65.52.15641136088330839', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-26 12:00:09', 9, 0, '', '2019-07-26 12:00:09');
INSERT INTO `access_log` VALUES (59230, '65.46.15641136088370881', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-26 12:00:09', 9, 2001001000, '服务端发生异常', '2019-07-26 12:00:09');
INSERT INTO `access_log` VALUES (59231, '65.54.15641136088390727', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-26 12:00:09', 8, 0, '', '2019-07-26 12:00:09');
INSERT INTO `access_log` VALUES (59232, '59.72.15641137330258471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.113', '2019-07-26 12:02:13', 3, 0, '', '2019-07-26 12:02:13');
INSERT INTO `access_log` VALUES (59233, '59.75.15641137330268485', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.113', '2019-07-26 12:02:13', 21, 2001001000, '服务端发生异常', '2019-07-26 12:02:13');
INSERT INTO `access_log` VALUES (59234, '65.54.15641137407640729', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.113', '2019-07-26 12:02:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 12:02:21');
INSERT INTO `access_log` VALUES (59235, '65.50.15641137442460811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.113', '2019-07-26 12:02:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 12:02:24');
INSERT INTO `access_log` VALUES (59236, '64.79.15641137497928727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.113', '2019-07-26 12:02:30', 3, 0, '', '2019-07-26 12:02:30');
INSERT INTO `access_log` VALUES (59237, '64.84.15641137498948719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.113', '2019-07-26 12:02:30', 1, 0, '', '2019-07-26 12:02:30');
INSERT INTO `access_log` VALUES (59238, '65.52.15641199785410925', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.28.180', '2019-07-26 13:46:19', 1, 1002001015, '账号未登陆', '2019-07-26 13:46:19');
INSERT INTO `access_log` VALUES (59239, '65.46.15641199785400967', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.28.180', '2019-07-26 13:46:19', 1, 1002001015, '账号未登陆', '2019-07-26 13:46:19');
INSERT INTO `access_log` VALUES (59240, '65.54.15641199785420813', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.28.180', '2019-07-26 13:46:19', 1, 1002001015, '账号未登陆', '2019-07-26 13:46:19');
INSERT INTO `access_log` VALUES (59241, '65.53.15641199819290885', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.28.180', '2019-07-26 13:46:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 13:46:22');
INSERT INTO `access_log` VALUES (59242, '65.45.15641199888240891', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.28.180', '2019-07-26 13:46:29', 76, 0, '', '2019-07-26 13:46:29');
INSERT INTO `access_log` VALUES (59243, '65.51.15641199892510961', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.28.180', '2019-07-26 13:46:29', 10, 0, '', '2019-07-26 13:46:29');
INSERT INTO `access_log` VALUES (59244, '65.3607.15641199892552697', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.28.180', '2019-07-26 13:46:29', 9, 2001001000, '服务端发生异常', '2019-07-26 13:46:29');
INSERT INTO `access_log` VALUES (59245, '65.47.15641199930870887', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.28.180', '2019-07-26 13:46:33', 152, 0, '', '2019-07-26 13:46:33');
INSERT INTO `access_log` VALUES (59246, '65.49.15641199937040871', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.28.180', '2019-07-26 13:46:34', 10, 0, '', '2019-07-26 13:46:34');
INSERT INTO `access_log` VALUES (59247, '65.52.15641199937110927', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.28.180', '2019-07-26 13:46:34', 9, 2001001000, '服务端发生异常', '2019-07-26 13:46:34');
INSERT INTO `access_log` VALUES (59248, '65.46.15641200001940969', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.28.180', '2019-07-26 13:46:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 13:46:40');
INSERT INTO `access_log` VALUES (59249, '65.53.15641200052110887', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.28.180', '2019-07-26 13:46:45', 193, 0, '', '2019-07-26 13:46:45');
INSERT INTO `access_log` VALUES (59250, '65.50.15641200057870897', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.28.180', '2019-07-26 13:46:46', 8, 0, '', '2019-07-26 13:46:46');
INSERT INTO `access_log` VALUES (59251, '65.45.15641200057940893', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.28.180', '2019-07-26 13:46:46', 8, 2001001000, '服务端发生异常', '2019-07-26 13:46:46');
INSERT INTO `access_log` VALUES (59252, '65.54.15641203857380821', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-26 13:53:06', 4, 1002001012, '访问令牌已过期', '2019-07-26 13:53:06');
INSERT INTO `access_log` VALUES (59253, '65.46.15641203857430975', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-26 13:53:06', 3, 1002001012, '访问令牌已过期', '2019-07-26 13:53:06');
INSERT INTO `access_log` VALUES (59254, '65.53.15641203857520893', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-26 13:53:06', 4, 1002001012, '访问令牌已过期', '2019-07-26 13:53:06');
INSERT INTO `access_log` VALUES (59255, '65.45.15641203897250899', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-26 13:53:10', 51, 0, '', '2019-07-26 13:53:10');
INSERT INTO `access_log` VALUES (59256, '65.51.15641203901010969', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-26 13:53:10', 189, 0, '', '2019-07-26 13:53:10');
INSERT INTO `access_log` VALUES (59257, '65.47.15641203901090895', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-26 13:53:10', 182, 0, '', '2019-07-26 13:53:10');
INSERT INTO `access_log` VALUES (59258, '65.3607.15641203901052705', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.207.17.50', '2019-07-26 13:53:10', 187, 2001001000, '服务端发生异常', '2019-07-26 13:53:10');
INSERT INTO `access_log` VALUES (59259, '65.51.15641215341520985', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.128.6.109', '2019-07-26 14:12:14', 1, 1002001015, '账号未登陆', '2019-07-26 14:12:14');
INSERT INTO `access_log` VALUES (59260, '65.3607.15641215341692721', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.128.6.109', '2019-07-26 14:12:14', 0, 1002001015, '账号未登陆', '2019-07-26 14:12:14');
INSERT INTO `access_log` VALUES (59261, '65.49.15641215377100895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.128.6.109', '2019-07-26 14:12:18', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 14:12:18');
INSERT INTO `access_log` VALUES (59262, '65.54.15641215510640837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.128.6.109', '2019-07-26 14:12:31', 51, 0, '', '2019-07-26 14:12:31');
INSERT INTO `access_log` VALUES (59263, '65.45.15641215518140917', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.128.6.109', '2019-07-26 14:12:32', 10, 0, '', '2019-07-26 14:12:32');
INSERT INTO `access_log` VALUES (59264, '65.50.15641215518150921', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.128.6.109', '2019-07-26 14:12:32', 11, 2001001000, '服务端发生异常', '2019-07-26 14:12:32');
INSERT INTO `access_log` VALUES (59265, '65.46.15641215518250993', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.128.6.109', '2019-07-26 14:12:32', 16, 0, '', '2019-07-26 14:12:32');
INSERT INTO `access_log` VALUES (59266, '65.3607.15641215810052723', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.128.6.109', '2019-07-26 14:13:01', 9, 0, '', '2019-07-26 14:13:01');
INSERT INTO `access_log` VALUES (59267, '65.51.15641215810060987', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.128.6.109', '2019-07-26 14:13:01', 10, 2001001000, '服务端发生异常', '2019-07-26 14:13:01');
INSERT INTO `access_log` VALUES (59268, '65.49.15641215811510897', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.128.6.109', '2019-07-26 14:13:01', 8, 0, '', '2019-07-26 14:13:01');
INSERT INTO `access_log` VALUES (59269, '65.54.15641248523480885', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.80.109.37', '2019-07-26 15:07:32', 0, 1002001015, '账号未登陆', '2019-07-26 15:07:32');
INSERT INTO `access_log` VALUES (59270, '65.53.15641248523490955', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.80.109.37', '2019-07-26 15:07:32', 0, 1002001015, '账号未登陆', '2019-07-26 15:07:32');
INSERT INTO `access_log` VALUES (59271, '65.51.15641248523511033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.80.109.37', '2019-07-26 15:07:32', 0, 1002001015, '账号未登陆', '2019-07-26 15:07:32');
INSERT INTO `access_log` VALUES (59272, '65.52.15641248552800997', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.80.109.37', '2019-07-26 15:07:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 15:07:35');
INSERT INTO `access_log` VALUES (59273, '65.47.15641248598310957', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.80.109.37', '2019-07-26 15:07:40', 71, 0, '', '2019-07-26 15:07:40');
INSERT INTO `access_log` VALUES (59274, '65.46.15641248601941039', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.80.109.37', '2019-07-26 15:07:40', 13, 0, '', '2019-07-26 15:07:40');
INSERT INTO `access_log` VALUES (59275, '65.50.15641248601990969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.80.109.37', '2019-07-26 15:07:40', 12, 2001001000, '服务端发生异常', '2019-07-26 15:07:40');
INSERT INTO `access_log` VALUES (59276, '65.45.15641248603810965', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.80.109.37', '2019-07-26 15:07:40', 9, 0, '', '2019-07-26 15:07:40');
INSERT INTO `access_log` VALUES (59277, '65.49.15641248693180943', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.80.109.37', '2019-07-26 15:07:49', 9, 0, '', '2019-07-26 15:07:49');
INSERT INTO `access_log` VALUES (59278, '65.54.15641248693230887', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.80.109.37', '2019-07-26 15:07:49', 9, 2001001000, '服务端发生异常', '2019-07-26 15:07:49');
INSERT INTO `access_log` VALUES (59279, '65.53.15641248693260957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.80.109.37', '2019-07-26 15:07:49', 9, 0, '', '2019-07-26 15:07:49');
INSERT INTO `access_log` VALUES (59280, '65.51.15641259160241049', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:25:16', 1, 1002001015, '账号未登陆', '2019-07-26 15:25:16');
INSERT INTO `access_log` VALUES (59281, '65.52.15641259160241013', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:25:16', 0, 1002001015, '账号未登陆', '2019-07-26 15:25:16');
INSERT INTO `access_log` VALUES (59282, '65.3607.15641259160432783', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:25:16', 0, 1002001015, '账号未登陆', '2019-07-26 15:25:16');
INSERT INTO `access_log` VALUES (59283, '65.46.15641259356821055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:25:36', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 15:25:36');
INSERT INTO `access_log` VALUES (59284, '65.45.15641259487500981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:25:49', 73, 0, '', '2019-07-26 15:25:49');
INSERT INTO `access_log` VALUES (59285, '65.54.15641259495320903', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:25:50', 10, 0, '', '2019-07-26 15:25:50');
INSERT INTO `access_log` VALUES (59286, '65.49.15641259495490959', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:25:50', 20, 0, '', '2019-07-26 15:25:50');
INSERT INTO `access_log` VALUES (59287, '65.53.15641259495560973', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:25:50', 18, 0, '', '2019-07-26 15:25:50');
INSERT INTO `access_log` VALUES (59288, '62.83.15641259615637685', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:02', 104, 0, '', '2019-07-26 15:26:02');
INSERT INTO `access_log` VALUES (59289, '62.89.15641259644827679', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:04', 74, 0, '', '2019-07-26 15:26:05');
INSERT INTO `access_log` VALUES (59290, '64.81.15641259677898887', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:08', 20, 0, '', '2019-07-26 15:26:08');
INSERT INTO `access_log` VALUES (59291, '64.77.15641259677798877', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:08', 31, 0, '', '2019-07-26 15:26:08');
INSERT INTO `access_log` VALUES (59292, '59.74.15641259810368651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:21', 10, 0, '', '2019-07-26 15:26:21');
INSERT INTO `access_log` VALUES (59293, '59.75.15641259810378649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:21', 22, 2001001000, '服务端发生异常', '2019-07-26 15:26:21');
INSERT INTO `access_log` VALUES (59294, '59.72.15641259865178635', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:27', 22, 2001001000, '服务端发生异常', '2019-07-26 15:26:27');
INSERT INTO `access_log` VALUES (59295, '59.71.15641259865398639', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:27', 4, 0, '', '2019-07-26 15:26:27');
INSERT INTO `access_log` VALUES (59296, '64.79.15641259901678891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:30', 6, 0, '', '2019-07-26 15:26:30');
INSERT INTO `access_log` VALUES (59297, '64.84.15641259905928883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:31', 4, 0, '', '2019-07-26 15:26:31');
INSERT INTO `access_log` VALUES (59298, '64.82.15641259940468907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:34', 2, 0, '', '2019-07-26 15:26:34');
INSERT INTO `access_log` VALUES (59299, '64.76.15641259942318887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:34', 1, 0, '', '2019-07-26 15:26:34');
INSERT INTO `access_log` VALUES (59300, '64.80.15641260089598897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:49', 2, 0, '', '2019-07-26 15:26:49');
INSERT INTO `access_log` VALUES (59301, '64.83.15641260091528891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:49', 2, 0, '', '2019-07-26 15:26:49');
INSERT INTO `access_log` VALUES (59302, '59.73.15641260104878647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:50', 3, 0, '', '2019-07-26 15:26:50');
INSERT INTO `access_log` VALUES (59303, '59.80.15641260104978619', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:50', 20, 2001001000, '服务端发生异常', '2019-07-26 15:26:51');
INSERT INTO `access_log` VALUES (59304, '59.79.15641260193058647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:59', 2, 0, '', '2019-07-26 15:26:59');
INSERT INTO `access_log` VALUES (59305, '59.78.15641260193068645', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:26:59', 16, 2001001000, '服务端发生异常', '2019-07-26 15:26:59');
INSERT INTO `access_log` VALUES (59306, '64.84.15641262193218887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:30:19', 2, 0, '', '2019-07-26 15:30:19');
INSERT INTO `access_log` VALUES (59307, '64.82.15641262195158911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:30:20', 2, 0, '', '2019-07-26 15:30:20');
INSERT INTO `access_log` VALUES (59308, '64.85.15641262216718927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:30:22', 2, 0, '', '2019-07-26 15:30:22');
INSERT INTO `access_log` VALUES (59309, '64.80.15641262226758901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:30:23', 2, 0, '', '2019-07-26 15:30:23');
INSERT INTO `access_log` VALUES (59310, '64.83.15641262234318895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:30:23', 1, 0, '', '2019-07-26 15:30:23');
INSERT INTO `access_log` VALUES (59311, '64.81.15641262238628893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:30:24', 2, 0, '', '2019-07-26 15:30:24');
INSERT INTO `access_log` VALUES (59312, '64.77.15641262245478883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:30:25', 3, 0, '', '2019-07-26 15:30:25');
INSERT INTO `access_log` VALUES (59313, '64.78.15641262275958905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:30:28', 2, 0, '', '2019-07-26 15:30:28');
INSERT INTO `access_log` VALUES (59314, '64.79.15641262277698897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:30:28', 2, 0, '', '2019-07-26 15:30:28');
INSERT INTO `access_log` VALUES (59315, '64.82.15641262401368913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:30:40', 2, 0, '', '2019-07-26 15:30:40');
INSERT INTO `access_log` VALUES (59316, '64.76.15641262403168893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:30:40', 2, 0, '', '2019-07-26 15:30:40');
INSERT INTO `access_log` VALUES (59317, '59.77.15641262411128637', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:30:41', 3, 0, '', '2019-07-26 15:30:41');
INSERT INTO `access_log` VALUES (59318, '59.73.15641262411138651', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.159.26.86', '2019-07-26 15:30:41', 15, 2001001000, '服务端发生异常', '2019-07-26 15:30:41');
INSERT INTO `access_log` VALUES (59319, '65.45.15641270748480997', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.83.31.38', '2019-07-26 15:44:35', 0, 1002001015, '账号未登陆', '2019-07-26 15:44:35');
INSERT INTO `access_log` VALUES (59320, '65.54.15641270748490919', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.83.31.38', '2019-07-26 15:44:35', 0, 1002001015, '账号未登陆', '2019-07-26 15:44:35');
INSERT INTO `access_log` VALUES (59321, '65.50.15641270748481001', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.83.31.38', '2019-07-26 15:44:35', 0, 1002001015, '账号未登陆', '2019-07-26 15:44:35');
INSERT INTO `access_log` VALUES (59322, '65.53.15641270768360989', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.83.31.38', '2019-07-26 15:44:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 15:44:37');
INSERT INTO `access_log` VALUES (59323, '65.52.15641270869191031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.83.31.38', '2019-07-26 15:44:47', 187, 0, '', '2019-07-26 15:44:47');
INSERT INTO `access_log` VALUES (59324, '65.3607.15641270874202801', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.83.31.38', '2019-07-26 15:44:47', 371, 0, '', '2019-07-26 15:44:48');
INSERT INTO `access_log` VALUES (59325, '65.51.15641270874231067', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.83.31.38', '2019-07-26 15:44:47', 370, 2001001000, '服务端发生异常', '2019-07-26 15:44:48');
INSERT INTO `access_log` VALUES (59326, '65.47.15641270874300991', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.83.31.38', '2019-07-26 15:44:47', 529, 0, '', '2019-07-26 15:44:48');
INSERT INTO `access_log` VALUES (59327, '65.50.15641302764101045', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.0.2', '2019-07-26 16:37:56', 0, 1002001015, '账号未登陆', '2019-07-26 16:37:56');
INSERT INTO `access_log` VALUES (59328, '65.53.15641302764101033', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.0.2', '2019-07-26 16:37:56', 0, 1002001015, '账号未登陆', '2019-07-26 16:37:56');
INSERT INTO `access_log` VALUES (59329, '65.49.15641302764131019', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.0.2', '2019-07-26 16:37:56', 0, 1002001015, '账号未登陆', '2019-07-26 16:37:56');
INSERT INTO `access_log` VALUES (59330, '65.52.15641302827001075', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.0.2', '2019-07-26 16:38:03', 681, 0, '', '2019-07-26 16:38:03');
INSERT INTO `access_log` VALUES (59331, '65.3607.15641302837822845', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.0.2', '2019-07-26 16:38:04', 13, 0, '', '2019-07-26 16:38:04');
INSERT INTO `access_log` VALUES (59332, '65.51.15641302837821111', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.0.2', '2019-07-26 16:38:04', 13, 2001001000, '服务端发生异常', '2019-07-26 16:38:04');
INSERT INTO `access_log` VALUES (59333, '65.47.15641302837971035', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.0.2', '2019-07-26 16:38:04', 9, 0, '', '2019-07-26 16:38:04');
INSERT INTO `access_log` VALUES (59334, '65.54.15641303032540967', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.0.2', '2019-07-26 16:38:23', 10, 0, '', '2019-07-26 16:38:23');
INSERT INTO `access_log` VALUES (59335, '65.53.15641303032661035', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.0.2', '2019-07-26 16:38:23', 8, 0, '', '2019-07-26 16:38:23');
INSERT INTO `access_log` VALUES (59336, '65.45.15641303032651045', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.0.2', '2019-07-26 16:38:23', 17, 2001001000, '服务端发生异常', '2019-07-26 16:38:23');
INSERT INTO `access_log` VALUES (59337, '59.78.15641303182818703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.0.2', '2019-07-26 16:38:38', 10, 0, '', '2019-07-26 16:38:38');
INSERT INTO `access_log` VALUES (59338, '59.74.15641303182928711', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.0.2', '2019-07-26 16:38:38', 16, 2001001000, '服务端发生异常', '2019-07-26 16:38:38');
INSERT INTO `access_log` VALUES (59339, '65.51.15641306419111117', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.129.236', '2019-07-26 16:44:02', 0, 1002001015, '账号未登陆', '2019-07-26 16:44:02');
INSERT INTO `access_log` VALUES (59340, '65.3607.15641306419132851', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.129.236', '2019-07-26 16:44:02', 0, 1002001015, '账号未登陆', '2019-07-26 16:44:02');
INSERT INTO `access_log` VALUES (59341, '65.47.15641306419191041', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.129.236', '2019-07-26 16:44:02', 1, 1002001015, '账号未登陆', '2019-07-26 16:44:02');
INSERT INTO `access_log` VALUES (59342, '65.46.15641306447701123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.129.236', '2019-07-26 16:44:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 16:44:05');
INSERT INTO `access_log` VALUES (59343, '65.53.15641306563351041', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.129.236', '2019-07-26 16:44:16', 74, 0, '', '2019-07-26 16:44:16');
INSERT INTO `access_log` VALUES (59344, '65.45.15641306567491051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.129.236', '2019-07-26 16:44:17', 11, 0, '', '2019-07-26 16:44:17');
INSERT INTO `access_log` VALUES (59345, '65.50.15641306567591053', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.129.236', '2019-07-26 16:44:17', 17, 2001001000, '服务端发生异常', '2019-07-26 16:44:17');
INSERT INTO `access_log` VALUES (59346, '65.49.15641306567601027', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.129.236', '2019-07-26 16:44:17', 16, 0, '', '2019-07-26 16:44:17');
INSERT INTO `access_log` VALUES (59347, '65.51.15641306654521119', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.129.236', '2019-07-26 16:44:25', 9, 0, '', '2019-07-26 16:44:25');
INSERT INTO `access_log` VALUES (59348, '65.3607.15641306654552853', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.129.236', '2019-07-26 16:44:25', 9, 2001001000, '服务端发生异常', '2019-07-26 16:44:25');
INSERT INTO `access_log` VALUES (59349, '65.47.15641306654631043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.129.236', '2019-07-26 16:44:25', 8, 0, '', '2019-07-26 16:44:25');
INSERT INTO `access_log` VALUES (59350, '65.52.15641316667911097', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Python-urllib/3.6', '180.168.174.128', '2019-07-26 17:01:07', 1, 1002001015, '账号未登陆', '2019-07-26 17:01:07');
INSERT INTO `access_log` VALUES (59351, '59.79.15641326814978737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:18:01', 9, 0, '', '2019-07-26 17:18:02');
INSERT INTO `access_log` VALUES (59352, '59.74.15641326814988743', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:18:01', 18, 2001001000, '服务端发生异常', '2019-07-26 17:18:02');
INSERT INTO `access_log` VALUES (59353, '64.85.15641326865459015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:18:07', 11, 0, '', '2019-07-26 17:18:07');
INSERT INTO `access_log` VALUES (59354, '64.80.15641326866468989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:18:07', 3, 0, '', '2019-07-26 17:18:07');
INSERT INTO `access_log` VALUES (59355, '64.83.15641326879188983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:18:08', 2, 0, '', '2019-07-26 17:18:08');
INSERT INTO `access_log` VALUES (59356, '64.81.15641326886628981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:18:09', 2, 0, '', '2019-07-26 17:18:09');
INSERT INTO `access_log` VALUES (59357, '64.77.15641326891188971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:18:09', 1, 0, '', '2019-07-26 17:18:09');
INSERT INTO `access_log` VALUES (59358, '64.78.15641326935558993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:18:14', 2, 0, '', '2019-07-26 17:18:14');
INSERT INTO `access_log` VALUES (59359, '64.79.15641326936568985', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:18:14', 2, 0, '', '2019-07-26 17:18:14');
INSERT INTO `access_log` VALUES (59360, '59.72.15641327017758727', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:18:22', 3, 0, '', '2019-07-26 17:18:22');
INSERT INTO `access_log` VALUES (59361, '59.71.15641327017768731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:18:22', 36, 2001001000, '服务端发生异常', '2019-07-26 17:18:22');
INSERT INTO `access_log` VALUES (59362, '65.3607.15641327134272881', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:18:33', 1, 1002001015, '账号未登陆', '2019-07-26 17:18:33');
INSERT INTO `access_log` VALUES (59363, '65.51.15641327134261147', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.187.64.82', '2019-07-26 17:18:33', 1, 1002001015, '账号未登陆', '2019-07-26 17:18:33');
INSERT INTO `access_log` VALUES (59364, '65.47.15641327134291071', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:18:33', 0, 1002001015, '账号未登陆', '2019-07-26 17:18:33');
INSERT INTO `access_log` VALUES (59365, '65.46.15641327158141153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.187.64.82', '2019-07-26 17:18:36', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 17:18:36');
INSERT INTO `access_log` VALUES (59366, '65.53.15641327280041071', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.187.64.82', '2019-07-26 17:18:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 17:18:48');
INSERT INTO `access_log` VALUES (59367, '65.50.15641327491881083', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.187.64.82', '2019-07-26 17:19:09', 78, 0, '', '2019-07-26 17:19:09');
INSERT INTO `access_log` VALUES (59368, '65.52.15641327494801113', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.187.64.82', '2019-07-26 17:19:09', 11, 0, '', '2019-07-26 17:19:09');
INSERT INTO `access_log` VALUES (59369, '65.51.15641327494851149', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:19:09', 11, 2001001000, '服务端发生异常', '2019-07-26 17:19:09');
INSERT INTO `access_log` VALUES (59370, '65.3607.15641327494872883', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:19:09', 10, 0, '', '2019-07-26 17:19:09');
INSERT INTO `access_log` VALUES (59371, '65.47.15641327548221073', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:19:15', 11, 0, '', '2019-07-26 17:19:15');
INSERT INTO `access_log` VALUES (59372, '65.46.15641327548251155', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:19:15', 10, 2001001000, '服务端发生异常', '2019-07-26 17:19:15');
INSERT INTO `access_log` VALUES (59373, '65.54.15641327548271005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.187.64.82', '2019-07-26 17:19:15', 9, 0, '', '2019-07-26 17:19:15');
INSERT INTO `access_log` VALUES (59374, '65.49.15641327805801059', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.187.64.82', '2019-07-26 17:19:41', 9, 0, '', '2019-07-26 17:19:41');
INSERT INTO `access_log` VALUES (59375, '65.50.15641327805811085', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.187.64.82', '2019-07-26 17:19:41', 9, 2001001000, '服务端发生异常', '2019-07-26 17:19:41');
INSERT INTO `access_log` VALUES (59376, '65.3607.15641327805892885', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:19:41', 8, 0, '', '2019-07-26 17:19:41');
INSERT INTO `access_log` VALUES (59377, '65.54.15641327859101007', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.76.42.66', '2019-07-26 17:19:46', 9, 0, '', '2019-07-26 17:19:46');
INSERT INTO `access_log` VALUES (59378, '65.51.15641327859091151', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.187.64.82', '2019-07-26 17:19:46', 9, 0, '', '2019-07-26 17:19:46');
INSERT INTO `access_log` VALUES (59379, '65.52.15641327859091115', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.77.56.210', '2019-07-26 17:19:46', 9, 2001001000, '服务端发生异常', '2019-07-26 17:19:46');
INSERT INTO `access_log` VALUES (59380, '59.75.15641338576408757', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.239.42.66', '2019-07-26 17:37:38', 3, 0, '', '2019-07-26 17:37:38');
INSERT INTO `access_log` VALUES (59381, '59.72.15641338576468743', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.239.42.66', '2019-07-26 17:37:38', 15, 2001001000, '服务端发生异常', '2019-07-26 17:37:38');
INSERT INTO `access_log` VALUES (59382, '65.47.15641338738681089', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.239.42.66', '2019-07-26 17:37:54', 0, 1002001015, '账号未登陆', '2019-07-26 17:37:54');
INSERT INTO `access_log` VALUES (59383, '65.46.15641338738681171', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.239.42.66', '2019-07-26 17:37:54', 1, 1002001015, '账号未登陆', '2019-07-26 17:37:54');
INSERT INTO `access_log` VALUES (59384, '65.53.15641338738731091', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.239.42.66', '2019-07-26 17:37:54', 1, 1002001015, '账号未登陆', '2019-07-26 17:37:54');
INSERT INTO `access_log` VALUES (59385, '65.50.15641338761111103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.239.42.66', '2019-07-26 17:37:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 17:37:56');
INSERT INTO `access_log` VALUES (59386, '65.49.15641338929151075', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.239.42.66', '2019-07-26 17:38:13', 73, 0, '', '2019-07-26 17:38:13');
INSERT INTO `access_log` VALUES (59387, '65.54.15641338933261025', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.239.42.66', '2019-07-26 17:38:13', 10, 0, '', '2019-07-26 17:38:13');
INSERT INTO `access_log` VALUES (59388, '65.52.15641338933341133', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.239.42.66', '2019-07-26 17:38:13', 10, 2001001000, '服务端发生异常', '2019-07-26 17:38:13');
INSERT INTO `access_log` VALUES (59389, '65.51.15641338933381169', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.239.42.66', '2019-07-26 17:38:13', 9, 0, '', '2019-07-26 17:38:13');
INSERT INTO `access_log` VALUES (59390, '65.3607.15641346624942913', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:02', 4, 1002001012, '访问令牌已过期', '2019-07-26 17:51:02');
INSERT INTO `access_log` VALUES (59391, '65.49.15641346624971087', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:02', 4, 1002001012, '访问令牌已过期', '2019-07-26 17:51:03');
INSERT INTO `access_log` VALUES (59392, '65.51.15641346625031179', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:03', 3, 1002001012, '访问令牌已过期', '2019-07-26 17:51:03');
INSERT INTO `access_log` VALUES (59393, '65.52.15641346653191145', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 17:51:05');
INSERT INTO `access_log` VALUES (59394, '65.47.15641346832931103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:23', 118, 0, '', '2019-07-26 17:51:23');
INSERT INTO `access_log` VALUES (59395, '65.53.15641346838391105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:24', 10, 0, '', '2019-07-26 17:51:24');
INSERT INTO `access_log` VALUES (59396, '65.46.15641346838421185', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:24', 9, 2001001000, '服务端发生异常', '2019-07-26 17:51:24');
INSERT INTO `access_log` VALUES (59397, '65.45.15641346838471113', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:24', 10, 0, '', '2019-07-26 17:51:24');
INSERT INTO `access_log` VALUES (59398, '65.51.15641346953991181', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:35', 8, 0, '', '2019-07-26 17:51:35');
INSERT INTO `access_log` VALUES (59399, '65.49.15641346954981089', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:35', 8, 0, '', '2019-07-26 17:51:36');
INSERT INTO `access_log` VALUES (59400, '65.3607.15641346954972915', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:35', 10, 2001001000, '服务端发生异常', '2019-07-26 17:51:36');
INSERT INTO `access_log` VALUES (59401, '65.54.15641346990791039', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:39', 7, 0, '', '2019-07-26 17:51:39');
INSERT INTO `access_log` VALUES (59402, '65.47.15641346990831105', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:39', 7, 2001001000, '服务端发生异常', '2019-07-26 17:51:39');
INSERT INTO `access_log` VALUES (59403, '65.46.15641346990841187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:39', 7, 0, '', '2019-07-26 17:51:39');
INSERT INTO `access_log` VALUES (59404, '65.45.15641347024121115', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:42', 16, 0, '', '2019-07-26 17:51:42');
INSERT INTO `access_log` VALUES (59405, '65.53.15641347024151107', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:42', 16, 2001001000, '服务端发生异常', '2019-07-26 17:51:42');
INSERT INTO `access_log` VALUES (59406, '65.50.15641347024181117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.13.90', '2019-07-26 17:51:42', 15, 0, '', '2019-07-26 17:51:42');
INSERT INTO `access_log` VALUES (59407, '59.73.15641469231858929', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:23', 13, 2001001000, '服务端发生异常', '2019-07-26 21:15:23');
INSERT INTO `access_log` VALUES (59408, '59.76.15641469231848915', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:23', 19, 0, '', '2019-07-26 21:15:23');
INSERT INTO `access_log` VALUES (59409, '64.84.15641469261409167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:26', 11, 0, '', '2019-07-26 21:15:26');
INSERT INTO `access_log` VALUES (59410, '64.82.15641469262509191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:26', 3, 0, '', '2019-07-26 21:15:26');
INSERT INTO `access_log` VALUES (59411, '64.77.15641469273369163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:27', 2, 0, '', '2019-07-26 21:15:27');
INSERT INTO `access_log` VALUES (59412, '64.85.15641469278059209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:28', 2, 0, '', '2019-07-26 21:15:28');
INSERT INTO `access_log` VALUES (59413, '64.76.15641469280809171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:28', 2, 0, '', '2019-07-26 21:15:28');
INSERT INTO `access_log` VALUES (59414, '64.80.15641469283199183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:28', 3, 0, '', '2019-07-26 21:15:28');
INSERT INTO `access_log` VALUES (59415, '59.80.15641469296628901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:30', 3, 0, '', '2019-07-26 21:15:30');
INSERT INTO `access_log` VALUES (59416, '59.77.15641469296618915', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:30', 14, 2001001000, '服务端发生异常', '2019-07-26 21:15:30');
INSERT INTO `access_log` VALUES (59417, '64.83.15641469316919175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:32', 3, 0, '', '2019-07-26 21:15:32');
INSERT INTO `access_log` VALUES (59418, '64.81.15641469318229175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:32', 2, 0, '', '2019-07-26 21:15:32');
INSERT INTO `access_log` VALUES (59419, '59.74.15641469333968935', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.77.182.19', '2019-07-26 21:15:33', 2, 0, '', '2019-07-26 21:15:33');
INSERT INTO `access_log` VALUES (59420, '59.79.15641469333998929', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.77.182.19', '2019-07-26 21:15:33', 16, 2001001000, '服务端发生异常', '2019-07-26 21:15:33');
INSERT INTO `access_log` VALUES (59421, '64.79.15641469346789177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:35', 2, 0, '', '2019-07-26 21:15:35');
INSERT INTO `access_log` VALUES (59422, '64.78.15641469348219183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:35', 2, 0, '', '2019-07-26 21:15:35');
INSERT INTO `access_log` VALUES (59423, '59.75.15641469402898933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:40', 3, 0, '', '2019-07-26 21:15:40');
INSERT INTO `access_log` VALUES (59424, '59.72.15641469402908919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:40', 12, 2001001000, '服务端发生异常', '2019-07-26 21:15:40');
INSERT INTO `access_log` VALUES (59425, '64.82.15641469431419193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:43', 2, 0, '', '2019-07-26 21:15:43');
INSERT INTO `access_log` VALUES (59426, '64.77.15641469432719165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:43', 2, 0, '', '2019-07-26 21:15:43');
INSERT INTO `access_log` VALUES (59427, '64.85.15641469439579211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '49.77.182.19', '2019-07-26 21:15:44', 2, 0, '', '2019-07-26 21:15:44');
INSERT INTO `access_log` VALUES (59428, '64.76.15641469440819173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '49.77.182.19', '2019-07-26 21:15:44', 2, 0, '', '2019-07-26 21:15:44');
INSERT INTO `access_log` VALUES (59429, '64.80.15641469441589185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:44', 2, 0, '', '2019-07-26 21:15:44');
INSERT INTO `access_log` VALUES (59430, '64.83.15641469444129177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.255.44.139', '2019-07-26 21:15:44', 2, 0, '', '2019-07-26 21:15:44');
INSERT INTO `access_log` VALUES (59431, '64.81.15641469450299177', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '49.77.182.19', '2019-07-26 21:15:45', 2, 0, '', '2019-07-26 21:15:45');
INSERT INTO `access_log` VALUES (59432, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '49.77.182.19', '2019-07-26 21:15:45', 6, 0, '', '2019-07-26 21:15:45');
INSERT INTO `access_log` VALUES (59433, '64.79.15641469471229179', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '49.77.182.19', '2019-07-26 21:15:47', 7, 0, '', '2019-07-26 21:15:47');
INSERT INTO `access_log` VALUES (59434, '64.82.15641469742559195', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:14', 6, 0, '', '2019-07-26 21:16:14');
INSERT INTO `access_log` VALUES (59435, '64.77.15641469760939167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:16', 1, 0, '', '2019-07-26 21:16:16');
INSERT INTO `access_log` VALUES (59436, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:16', 6, 0, '', '2019-07-26 21:16:16');
INSERT INTO `access_log` VALUES (59437, '64.85.15641469771789213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:17', 2, 0, '', '2019-07-26 21:16:17');
INSERT INTO `access_log` VALUES (59438, '64.76.15641469772799175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:17', 2, 0, '', '2019-07-26 21:16:17');
INSERT INTO `access_log` VALUES (59439, '64.80.15641469781899187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:18', 2, 0, '', '2019-07-26 21:16:18');
INSERT INTO `access_log` VALUES (59440, '64.83.15641469788179179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:19', 2, 0, '', '2019-07-26 21:16:19');
INSERT INTO `access_log` VALUES (59441, '59.77.15641469798178917', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:20', 2, 0, '', '2019-07-26 21:16:20');
INSERT INTO `access_log` VALUES (59442, '59.80.15641469798198903', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:20', 13, 2001001000, '服务端发生异常', '2019-07-26 21:16:20');
INSERT INTO `access_log` VALUES (59443, '64.79.15641469815309181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:22', 2, 0, '', '2019-07-26 21:16:22');
INSERT INTO `access_log` VALUES (59444, '64.78.15641469817339187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:22', 3, 0, '', '2019-07-26 21:16:22');
INSERT INTO `access_log` VALUES (59445, '64.84.15641469853369173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:25', 2, 0, '', '2019-07-26 21:16:25');
INSERT INTO `access_log` VALUES (59446, '64.82.15641469855099197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:26', 2, 0, '', '2019-07-26 21:16:26');
INSERT INTO `access_log` VALUES (59447, '59.74.15641469886128937', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:29', 3, 0, '', '2019-07-26 21:16:29');
INSERT INTO `access_log` VALUES (59448, '59.79.15641469886128931', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.77.182.19', '2019-07-26 21:16:29', 14, 2001001000, '服务端发生异常', '2019-07-26 21:16:29');
INSERT INTO `access_log` VALUES (59449, '65.51.15641551161041455', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-26 23:31:56', 0, 1002001015, '账号未登陆', '2019-07-26 23:31:56');
INSERT INTO `access_log` VALUES (59450, '65.50.15641551161031391', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-26 23:31:56', 0, 1002001015, '账号未登陆', '2019-07-26 23:31:56');
INSERT INTO `access_log` VALUES (59451, '65.49.15641551161041363', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-26 23:31:56', 0, 1002001015, '账号未登陆', '2019-07-26 23:31:56');
INSERT INTO `access_log` VALUES (59452, '65.52.15641551191911421', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-26 23:31:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-26 23:31:59');
INSERT INTO `access_log` VALUES (59453, '65.47.15641551345791381', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-26 23:32:15', 106, 0, '', '2019-07-26 23:32:15');
INSERT INTO `access_log` VALUES (59454, '65.54.15641551354151313', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-26 23:32:15', 11, 0, '', '2019-07-26 23:32:15');
INSERT INTO `access_log` VALUES (59455, '65.46.15641551354151463', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-26 23:32:15', 13, 2001001000, '服务端发生异常', '2019-07-26 23:32:15');
INSERT INTO `access_log` VALUES (59456, '65.53.15641551354451383', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-26 23:32:15', 9, 0, '', '2019-07-26 23:32:15');
INSERT INTO `access_log` VALUES (59457, '59.71.15641594714529091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:44:31', 10, 0, '', '2019-07-27 00:44:31');
INSERT INTO `access_log` VALUES (59458, '59.72.15641594714529087', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:44:31', 28, 2001001000, '服务端发生异常', '2019-07-27 00:44:31');
INSERT INTO `access_log` VALUES (59459, '59.80.15641594972469071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.32.106', '2019-07-27 00:44:57', 9, 0, '', '2019-07-27 00:44:57');
INSERT INTO `access_log` VALUES (59460, '59.77.15641594972469085', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.32.106', '2019-07-27 00:44:57', 24, 2001001000, '服务端发生异常', '2019-07-27 00:44:57');
INSERT INTO `access_log` VALUES (59461, '64.76.15641595003589343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.32.106', '2019-07-27 00:45:00', 11, 0, '', '2019-07-27 00:45:00');
INSERT INTO `access_log` VALUES (59462, '64.80.15641595008419357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.32.106', '2019-07-27 00:45:01', 3, 0, '', '2019-07-27 00:45:01');
INSERT INTO `access_log` VALUES (59463, '59.74.15641595025819105', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.32.106', '2019-07-27 00:45:03', 2, 0, '', '2019-07-27 00:45:03');
INSERT INTO `access_log` VALUES (59464, '59.79.15641595025949099', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.32.106', '2019-07-27 00:45:03', 13, 2001001000, '服务端发生异常', '2019-07-27 00:45:03');
INSERT INTO `access_log` VALUES (59465, '66.48.15641595180426905', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15766501707', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.32.106', '2019-07-27 00:45:18', 81, 0, '', '2019-07-27 00:45:18');
INSERT INTO `access_log` VALUES (59466, '66.51.15641595267686915', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15766501707&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_3 like Mac OS X) AppleWebKit/603.3.8 (KHTML, like Gecko) Mobile/14G60 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.32.106', '2019-07-27 00:45:27', 169, 0, '', '2019-07-27 00:45:27');
INSERT INTO `access_log` VALUES (59467, '65.50.15641595644341451', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '117.136.32.106', '2019-07-27 00:46:04', 0, 1002001015, '账号未登陆', '2019-07-27 00:46:04');
INSERT INTO `access_log` VALUES (59468, '65.52.15641595644421483', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '117.136.32.106', '2019-07-27 00:46:04', 0, 1002001015, '账号未登陆', '2019-07-27 00:46:04');
INSERT INTO `access_log` VALUES (59469, '65.3607.15641595644533249', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '117.136.32.106', '2019-07-27 00:46:04', 0, 1002001015, '账号未登陆', '2019-07-27 00:46:04');
INSERT INTO `access_log` VALUES (59470, '65.54.15641595794441375', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '117.136.32.106', '2019-07-27 00:46:19', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 00:46:19');
INSERT INTO `access_log` VALUES (59471, '65.46.15641596097291523', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '117.136.32.106', '2019-07-27 00:46:50', 92, 0, '', '2019-07-27 00:46:50');
INSERT INTO `access_log` VALUES (59472, '65.49.15641596106231425', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '117.136.32.106', '2019-07-27 00:46:51', 16, 0, '', '2019-07-27 00:46:51');
INSERT INTO `access_log` VALUES (59473, '65.51.15641596135151519', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '117.136.32.106', '2019-07-27 00:46:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 00:46:54');
INSERT INTO `access_log` VALUES (59474, '65.50.15641596170851453', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '117.136.32.106', '2019-07-27 00:46:57', 77, 0, '', '2019-07-27 00:46:57');
INSERT INTO `access_log` VALUES (59475, '65.3607.15641596176263251', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '117.136.32.106', '2019-07-27 00:46:58', 9, 0, '', '2019-07-27 00:46:58');
INSERT INTO `access_log` VALUES (59476, '65.51.15641597184971521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '117.136.32.106', '2019-07-27 00:48:38', 84, 0, '', '2019-07-27 00:48:39');
INSERT INTO `access_log` VALUES (59477, '65.50.15641597191161455', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '117.136.32.106', '2019-07-27 00:48:39', 9, 0, '', '2019-07-27 00:48:39');
INSERT INTO `access_log` VALUES (59478, '65.47.15641597406251447', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:01', 100, 0, '', '2019-07-27 00:49:01');
INSERT INTO `access_log` VALUES (59479, '65.54.15641597412471379', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:01', 12, 0, '', '2019-07-27 00:49:01');
INSERT INTO `access_log` VALUES (59480, '65.53.15641597412481447', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:01', 11, 0, '', '2019-07-27 00:49:01');
INSERT INTO `access_log` VALUES (59481, '65.45.15641597412481457', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:01', 14, 2001001000, '服务端发生异常', '2019-07-27 00:49:01');
INSERT INTO `access_log` VALUES (59482, '65.49.15641597515051429', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 00:49:12');
INSERT INTO `access_log` VALUES (59483, '65.51.15641597556981523', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:16', 52, 0, '', '2019-07-27 00:49:16');
INSERT INTO `access_log` VALUES (59484, '65.50.15641597559841457', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:16', 10, 0, '', '2019-07-27 00:49:16');
INSERT INTO `access_log` VALUES (59485, '65.52.15641597559841489', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:16', 12, 0, '', '2019-07-27 00:49:16');
INSERT INTO `access_log` VALUES (59486, '65.3607.15641597559883255', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:16', 9, 0, '', '2019-07-27 00:49:16');
INSERT INTO `access_log` VALUES (59487, '65.45.15641597651361459', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:25', 296, 0, '', '2019-07-27 00:49:25');
INSERT INTO `access_log` VALUES (59488, '65.53.15641597709891449', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:31', 11, 0, '', '2019-07-27 00:49:31');
INSERT INTO `access_log` VALUES (59489, '65.54.15641597754471381', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:35', 19, 0, '', '2019-07-27 00:49:35');
INSERT INTO `access_log` VALUES (59490, '65.46.15641597777701529', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:38', 20, 0, '', '2019-07-27 00:49:38');
INSERT INTO `access_log` VALUES (59491, '65.51.15641597812741525', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:41', 13, 0, '', '2019-07-27 00:49:41');
INSERT INTO `access_log` VALUES (59492, '65.52.15641597846001491', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:49:45', 13, 0, '', '2019-07-27 00:49:45');
INSERT INTO `access_log` VALUES (59493, '65.50.15641598071221459', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:50:07', 19, 0, '', '2019-07-27 00:50:07');
INSERT INTO `access_log` VALUES (59494, '65.45.15641599650561463', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:52:45', 9, 0, '', '2019-07-27 00:52:45');
INSERT INTO `access_log` VALUES (59495, '65.53.15641599650611453', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:52:45', 9, 0, '', '2019-07-27 00:52:45');
INSERT INTO `access_log` VALUES (59496, '65.54.15641599650701385', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:52:45', 9, 0, '', '2019-07-27 00:52:45');
INSERT INTO `access_log` VALUES (59497, '65.46.15641599733151533', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.32.106', '2019-07-27 00:52:53', 10, 0, '', '2019-07-27 00:52:53');
INSERT INTO `access_log` VALUES (59498, '59.75.15641834458099423', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.100 Safari/537.36', '122.226.184.9', '2019-07-27 07:24:06', 12, 0, '', '2019-07-27 07:24:06');
INSERT INTO `access_log` VALUES (59499, '59.72.15641834458099409', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.100 Safari/537.36', '122.226.184.10', '2019-07-27 07:24:06', 26, 2001001000, '服务端发生异常', '2019-07-27 07:24:06');
INSERT INTO `access_log` VALUES (59500, '59.74.15641938758269565', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.180.4.83', '2019-07-27 10:17:56', 13, 0, '', '2019-07-27 10:17:56');
INSERT INTO `access_log` VALUES (59501, '59.79.15641938758499559', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.180.4.83', '2019-07-27 10:17:56', 16, 2001001000, '服务端发生异常', '2019-07-27 10:17:56');
INSERT INTO `access_log` VALUES (59502, '65.47.15641959787131937', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 10:52:59', 8, 1002001012, '访问令牌已过期', '2019-07-27 10:52:59');
INSERT INTO `access_log` VALUES (59503, '65.53.15641959786941937', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 10:52:59', 25, 1002001012, '访问令牌已过期', '2019-07-27 10:52:59');
INSERT INTO `access_log` VALUES (59504, '65.45.15641959786941947', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 10:52:59', 20, 1002001012, '访问令牌已过期', '2019-07-27 10:52:59');
INSERT INTO `access_log` VALUES (59505, '65.3607.15641959887963739', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoytuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 10:53:09', 13, 1002002000, '账号不存在', '2019-07-27 10:53:09');
INSERT INTO `access_log` VALUES (59506, '65.46.15641960015612015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 10:53:22', 114, 0, '', '2019-07-27 10:53:22');
INSERT INTO `access_log` VALUES (59507, '65.50.15641960019071943', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 10:53:22', 11, 0, '', '2019-07-27 10:53:22');
INSERT INTO `access_log` VALUES (59508, '65.49.15641960019081919', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 10:53:22', 13, 2001001000, '服务端发生异常', '2019-07-27 10:53:22');
INSERT INTO `access_log` VALUES (59509, '65.52.15641960019211979', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 10:53:22', 12, 0, '', '2019-07-27 10:53:22');
INSERT INTO `access_log` VALUES (59510, '65.54.15641962150981871', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:56:55', 10, 1002001012, '访问令牌已过期', '2019-07-27 10:56:55');
INSERT INTO `access_log` VALUES (59511, '65.49.15641962151101923', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:56:55', 3, 1002001012, '访问令牌已过期', '2019-07-27 10:56:55');
INSERT INTO `access_log` VALUES (59512, '65.46.15641962151102019', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:56:55', 3, 1002001012, '访问令牌已过期', '2019-07-27 10:56:55');
INSERT INTO `access_log` VALUES (59513, '65.50.15641962163381947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:56:56', 54, 0, '', '2019-07-27 10:56:56');
INSERT INTO `access_log` VALUES (59514, '65.52.15641962166221983', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:56:57', 10, 0, '', '2019-07-27 10:56:57');
INSERT INTO `access_log` VALUES (59515, '65.51.15641962166262015', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:56:57', 10, 0, '', '2019-07-27 10:56:57');
INSERT INTO `access_log` VALUES (59516, '65.53.15641962166301943', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:56:57', 10, 0, '', '2019-07-27 10:56:57');
INSERT INTO `access_log` VALUES (59517, '66.48.15641962224417395', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:57:02', 24, 0, '', '2019-07-27 10:57:02');
INSERT INTO `access_log` VALUES (59518, '59.77.15641962272589577', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:57:07', 23, 0, '', '2019-07-27 10:57:07');
INSERT INTO `access_log` VALUES (59519, '59.74.15641962308189597', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:57:11', 24, 2001001000, '服务端发生异常', '2019-07-27 10:57:11');
INSERT INTO `access_log` VALUES (59520, '59.78.15641962403089589', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:57:20', 16, 0, '', '2019-07-27 10:57:20');
INSERT INTO `access_log` VALUES (59521, '66.50.15641962478517379', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:57:28', 14, 0, '', '2019-07-27 10:57:28');
INSERT INTO `access_log` VALUES (59522, '64.77.15641962589249827', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:57:39', 37, 0, '', '2019-07-27 10:57:39');
INSERT INTO `access_log` VALUES (59523, '64.79.15641962589179841', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:57:39', 45, 0, '', '2019-07-27 10:57:39');
INSERT INTO `access_log` VALUES (59524, '64.82.15641962617359855', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:57:42', 15, 0, '', '2019-07-27 10:57:42');
INSERT INTO `access_log` VALUES (59525, '64.78.15641962617359847', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:57:42', 23, 0, '', '2019-07-27 10:57:42');
INSERT INTO `access_log` VALUES (59526, '59.71.15641962717309585', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:57:52', 18, 0, '', '2019-07-27 10:57:52');
INSERT INTO `access_log` VALUES (59527, '59.80.15641963047019565', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:58:25', 13, 0, '', '2019-07-27 10:58:25');
INSERT INTO `access_log` VALUES (59528, '62.88.15641963120938615', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:58:32', 30, 0, '', '2019-07-27 10:58:32');
INSERT INTO `access_log` VALUES (59529, '59.74.15641963205809599', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:58:41', 2, 0, '', '2019-07-27 10:58:41');
INSERT INTO `access_log` VALUES (59530, '59.79.15641963205839593', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:58:41', 16, 2001001000, '服务端发生异常', '2019-07-27 10:58:41');
INSERT INTO `access_log` VALUES (59531, '64.81.15641963242389841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:58:44', 4, 0, '', '2019-07-27 10:58:44');
INSERT INTO `access_log` VALUES (59532, '64.83.15641963243829839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:58:44', 1, 0, '', '2019-07-27 10:58:44');
INSERT INTO `access_log` VALUES (59533, '64.79.15641963279799843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:58:48', 2, 0, '', '2019-07-27 10:58:48');
INSERT INTO `access_log` VALUES (59534, '64.77.15641963281119829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:58:48', 2, 0, '', '2019-07-27 10:58:48');
INSERT INTO `access_log` VALUES (59535, '59.75.15641963291049597', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:58:49', 8, 0, '', '2019-07-27 10:58:49');
INSERT INTO `access_log` VALUES (59536, '59.72.15641963291049583', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 10:58:49', 21, 2001001000, '服务端发生异常', '2019-07-27 10:58:49');
INSERT INTO `access_log` VALUES (59537, '64.81.15641964155309843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 11:00:16', 3, 0, '', '2019-07-27 11:00:16');
INSERT INTO `access_log` VALUES (59538, '64.83.15641964157829841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 11:00:16', 2, 0, '', '2019-07-27 11:00:16');
INSERT INTO `access_log` VALUES (59539, '64.79.15641964171779845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 11:00:17', 2, 0, '', '2019-07-27 11:00:17');
INSERT INTO `access_log` VALUES (59540, '64.77.15641964177029831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 11:00:18', 2, 0, '', '2019-07-27 11:00:18');
INSERT INTO `access_log` VALUES (59541, '64.78.15641964184589851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 11:00:18', 2, 0, '', '2019-07-27 11:00:18');
INSERT INTO `access_log` VALUES (59542, '64.82.15641964203279859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 11:00:20', 3, 0, '', '2019-07-27 11:00:20');
INSERT INTO `access_log` VALUES (59543, '59.77.15641965415329583', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 11:02:22', 3, 0, '', '2019-07-27 11:02:22');
INSERT INTO `access_log` VALUES (59544, '59.74.15641965415359603', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 11:02:22', 19, 2001001000, '服务端发生异常', '2019-07-27 11:02:22');
INSERT INTO `access_log` VALUES (59545, '64.84.15641965634939837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 11:02:43', 127, 0, '', '2019-07-27 11:02:44');
INSERT INTO `access_log` VALUES (59546, '64.85.15641965637559881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 11:02:44', 2, 0, '', '2019-07-27 11:02:44');
INSERT INTO `access_log` VALUES (59547, '65.49.15641965821951929', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 11:03:02', 10, 0, '', '2019-07-27 11:03:02');
INSERT INTO `access_log` VALUES (59548, '65.46.15641965821972025', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 11:03:02', 10, 0, '', '2019-07-27 11:03:02');
INSERT INTO `access_log` VALUES (59549, '65.50.15641965822001953', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.240.37.213', '2019-07-27 11:03:02', 9, 0, '', '2019-07-27 11:03:02');
INSERT INTO `access_log` VALUES (59550, '65.49.15642001450871977', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.36.172.122', '2019-07-27 12:02:25', 1, 1002001015, '账号未登陆', '2019-07-27 12:02:25');
INSERT INTO `access_log` VALUES (59551, '65.45.15642001450892007', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.36.172.122', '2019-07-27 12:02:25', 0, 1002001015, '账号未登陆', '2019-07-27 12:02:25');
INSERT INTO `access_log` VALUES (59552, '65.54.15642001450951927', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.36.172.122', '2019-07-27 12:02:25', 1, 1002001015, '账号未登陆', '2019-07-27 12:02:25');
INSERT INTO `access_log` VALUES (59553, '65.46.15642001484562075', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.36.172.122', '2019-07-27 12:02:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 12:02:28');
INSERT INTO `access_log` VALUES (59554, '65.53.15642001559111999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.36.172.122', '2019-07-27 12:02:36', 95, 0, '', '2019-07-27 12:02:36');
INSERT INTO `access_log` VALUES (59555, '65.51.15642001564212069', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.36.172.122', '2019-07-27 12:02:36', 13, 0, '', '2019-07-27 12:02:36');
INSERT INTO `access_log` VALUES (59556, '65.52.15642001564212039', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.36.172.122', '2019-07-27 12:02:36', 14, 2001001000, '服务端发生异常', '2019-07-27 12:02:36');
INSERT INTO `access_log` VALUES (59557, '65.3607.15642001564273799', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '111.36.172.122', '2019-07-27 12:02:36', 10, 0, '', '2019-07-27 12:02:36');
INSERT INTO `access_log` VALUES (59558, '65.45.15642066495132097', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 13:50:50', 925, 1002001012, '访问令牌已过期', '2019-07-27 13:50:50');
INSERT INTO `access_log` VALUES (59559, '65.50.15642066495072089', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 13:50:50', 930, 1002001012, '访问令牌已过期', '2019-07-27 13:50:50');
INSERT INTO `access_log` VALUES (59560, '65.49.15642066495082067', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 13:50:50', 930, 1002001012, '访问令牌已过期', '2019-07-27 13:50:50');
INSERT INTO `access_log` VALUES (59561, '65.46.15642066663882163', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 13:51:06', 232, 0, '', '2019-07-27 13:51:07');
INSERT INTO `access_log` VALUES (59562, '65.53.15642066669312087', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 13:51:07', 13, 0, '', '2019-07-27 13:51:07');
INSERT INTO `access_log` VALUES (59563, '65.52.15642066669332129', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 13:51:07', 14, 2001001000, '服务端发生异常', '2019-07-27 13:51:07');
INSERT INTO `access_log` VALUES (59564, '65.3607.15642066669373887', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 13:51:07', 12, 0, '', '2019-07-27 13:51:07');
INSERT INTO `access_log` VALUES (59565, '59.78.15642070685979735', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.38.173', '2019-07-27 13:57:49', 11, 0, '', '2019-07-27 13:57:49');
INSERT INTO `access_log` VALUES (59566, '59.72.15642070686029727', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.136.38.173', '2019-07-27 13:57:49', 25, 2001001000, '服务端发生异常', '2019-07-27 13:57:49');
INSERT INTO `access_log` VALUES (59567, '65.45.15642088131052127', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.89.86.156', '2019-07-27 14:26:53', 1, 1002001015, '账号未登陆', '2019-07-27 14:26:53');
INSERT INTO `access_log` VALUES (59568, '65.50.15642088131062119', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.89.86.156', '2019-07-27 14:26:53', 0, 1002001015, '账号未登陆', '2019-07-27 14:26:53');
INSERT INTO `access_log` VALUES (59569, '65.54.15642088131202045', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.89.86.156', '2019-07-27 14:26:53', 0, 1002001015, '账号未登陆', '2019-07-27 14:26:53');
INSERT INTO `access_log` VALUES (59570, '65.52.15642089689432161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.89.86.156', '2019-07-27 14:29:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 14:29:29');
INSERT INTO `access_log` VALUES (59571, '65.53.15642089721242119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.89.86.156', '2019-07-27 14:29:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 14:29:32');
INSERT INTO `access_log` VALUES (59572, '65.47.15642096059892127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.89.86.156', '2019-07-27 14:40:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 14:40:06');
INSERT INTO `access_log` VALUES (59573, '65.50.15642096131602131', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.89.86.156', '2019-07-27 14:40:13', 5, 1002002001, '密码不正确', '2019-07-27 14:40:13');
INSERT INTO `access_log` VALUES (59574, '65.3607.15642110344183947', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.17.169.238', '2019-07-27 15:03:54', 0, 1002001015, '账号未登陆', '2019-07-27 15:03:54');
INSERT INTO `access_log` VALUES (59575, '65.51.15642110344202219', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.17.169.238', '2019-07-27 15:03:54', 0, 1002001015, '账号未登陆', '2019-07-27 15:03:54');
INSERT INTO `access_log` VALUES (59576, '65.47.15642110344202147', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.17.169.238', '2019-07-27 15:03:54', 1, 1002001015, '账号未登陆', '2019-07-27 15:03:54');
INSERT INTO `access_log` VALUES (59577, '65.49.15642110375232129', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.17.169.238', '2019-07-27 15:03:58', 138, 0, '', '2019-07-27 15:03:58');
INSERT INTO `access_log` VALUES (59578, '65.52.15642110973962191', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '120.204.17.73', '2019-07-27 15:04:57', 1, 1002001015, '账号未登陆', '2019-07-27 15:04:57');
INSERT INTO `access_log` VALUES (59579, '65.53.15642110993372149', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '121.51.32.144', '2019-07-27 15:04:59', 1, 1002001015, '账号未登陆', '2019-07-27 15:04:59');
INSERT INTO `access_log` VALUES (59580, '65.47.15642111076392149', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '183.192.164.214', '2019-07-27 15:05:08', 0, 1002001015, '账号未登陆', '2019-07-27 15:05:08');
INSERT INTO `access_log` VALUES (59581, '65.49.15642115757282137', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.169.238', '2019-07-27 15:12:56', 71, 0, '', '2019-07-27 15:12:56');
INSERT INTO `access_log` VALUES (59582, '65.50.15642115760832159', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.169.238', '2019-07-27 15:12:56', 12, 0, '', '2019-07-27 15:12:56');
INSERT INTO `access_log` VALUES (59583, '65.45.15642115760832167', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.169.238', '2019-07-27 15:12:56', 21, 2001001000, '服务端发生异常', '2019-07-27 15:12:56');
INSERT INTO `access_log` VALUES (59584, '65.54.15642115761022085', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.169.238', '2019-07-27 15:12:56', 9, 0, '', '2019-07-27 15:12:56');
INSERT INTO `access_log` VALUES (59585, '59.74.15642119419519809', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:02', 15, 0, '', '2019-07-27 15:19:02');
INSERT INTO `access_log` VALUES (59586, '59.77.15642119419519789', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:02', 25, 2001001000, '服务端发生异常', '2019-07-27 15:19:02');
INSERT INTO `access_log` VALUES (59587, '64.77.15642119449340039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:05', 13, 0, '', '2019-07-27 15:19:05');
INSERT INTO `access_log` VALUES (59588, '64.78.15642119451160059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:05', 5, 0, '', '2019-07-27 15:19:05');
INSERT INTO `access_log` VALUES (59589, '59.78.15642119467269801', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:07', 3, 0, '', '2019-07-27 15:19:07');
INSERT INTO `access_log` VALUES (59590, '59.72.15642119467269793', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:07', 17, 2001001000, '服务端发生异常', '2019-07-27 15:19:07');
INSERT INTO `access_log` VALUES (59591, '64.84.15642119491170043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:09', 3, 0, '', '2019-07-27 15:19:09');
INSERT INTO `access_log` VALUES (59592, '64.85.15642119492850087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:09', 2, 0, '', '2019-07-27 15:19:09');
INSERT INTO `access_log` VALUES (59593, '64.76.15642119502120047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:10', 2, 0, '', '2019-07-27 15:19:10');
INSERT INTO `access_log` VALUES (59594, '64.80.15642119507300061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:11', 2, 0, '', '2019-07-27 15:19:11');
INSERT INTO `access_log` VALUES (59595, '64.81.15642119559100053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:16', 2, 0, '', '2019-07-27 15:19:16');
INSERT INTO `access_log` VALUES (59596, '64.83.15642119560340051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:16', 2, 0, '', '2019-07-27 15:19:16');
INSERT INTO `access_log` VALUES (59597, '59.75.15642119563989807', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:16', 3, 0, '', '2019-07-27 15:19:16');
INSERT INTO `access_log` VALUES (59598, '59.71.15642119564029797', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:16', 19, 2001001000, '服务端发生异常', '2019-07-27 15:19:16');
INSERT INTO `access_log` VALUES (59599, '64.79.15642119566800055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:17', 2, 0, '', '2019-07-27 15:19:17');
INSERT INTO `access_log` VALUES (59600, '64.77.15642119568320041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:17', 2, 0, '', '2019-07-27 15:19:17');
INSERT INTO `access_log` VALUES (59601, '59.73.15642119572749805', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:17', 3, 0, '', '2019-07-27 15:19:17');
INSERT INTO `access_log` VALUES (59602, '59.76.15642119572739791', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:17', 15, 2001001000, '服务端发生异常', '2019-07-27 15:19:17');
INSERT INTO `access_log` VALUES (59603, '65.45.15642119685482173', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:29', 0, 1002001015, '账号未登陆', '2019-07-27 15:19:29');
INSERT INTO `access_log` VALUES (59604, '65.49.15642119685482143', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:29', 1, 1002001015, '账号未登陆', '2019-07-27 15:19:29');
INSERT INTO `access_log` VALUES (59605, '65.50.15642119685522165', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:29', 0, 1002001015, '账号未登陆', '2019-07-27 15:19:29');
INSERT INTO `access_log` VALUES (59606, '65.54.15642119720832091', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:32', 483, 0, '', '2019-07-27 15:19:33');
INSERT INTO `access_log` VALUES (59607, '65.46.15642119728742239', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:33', 11, 0, '', '2019-07-27 15:19:33');
INSERT INTO `access_log` VALUES (59608, '65.52.15642119728802205', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:33', 11, 2001001000, '服务端发生异常', '2019-07-27 15:19:33');
INSERT INTO `access_log` VALUES (59609, '65.53.15642119728812163', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:33', 9, 0, '', '2019-07-27 15:19:33');
INSERT INTO `access_log` VALUES (59610, '65.51.15642119852512235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '14.18.147.234', '2019-07-27 15:19:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 15:19:45');
INSERT INTO `access_log` VALUES (59611, '65.47.15642131545272179', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 15:39:15', 4, 1002001012, '访问令牌已过期', '2019-07-27 15:39:15');
INSERT INTO `access_log` VALUES (59612, '65.3607.15642131545333979', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 15:39:15', 3, 1002001012, '访问令牌已过期', '2019-07-27 15:39:15');
INSERT INTO `access_log` VALUES (59613, '65.51.15642131545332251', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 15:39:15', 3, 1002001012, '访问令牌已过期', '2019-07-27 15:39:15');
INSERT INTO `access_log` VALUES (59614, '65.49.15642131704602161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 15:39:30', 72, 0, '', '2019-07-27 15:39:31');
INSERT INTO `access_log` VALUES (59615, '65.45.15642131707972191', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 15:39:31', 115, 0, '', '2019-07-27 15:39:31');
INSERT INTO `access_log` VALUES (59616, '65.52.15642131708032223', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 15:39:31', 110, 0, '', '2019-07-27 15:39:31');
INSERT INTO `access_log` VALUES (59617, '65.54.15642131707982109', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.169.238', '2019-07-27 15:39:31', 116, 2001001000, '服务端发生异常', '2019-07-27 15:39:31');
INSERT INTO `access_log` VALUES (59618, '59.74.15642133162099829', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:41:56', 3, 0, '', '2019-07-27 15:41:56');
INSERT INTO `access_log` VALUES (59619, '59.77.15642133162109809', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:41:56', 15, 2001001000, '服务端发生异常', '2019-07-27 15:41:56');
INSERT INTO `access_log` VALUES (59620, '64.82.15642133252340087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:05', 3, 0, '', '2019-07-27 15:42:05');
INSERT INTO `access_log` VALUES (59621, '64.84.15642133253740063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:05', 2, 0, '', '2019-07-27 15:42:05');
INSERT INTO `access_log` VALUES (59622, '66.50.15642133386247607', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=123&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:19', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-07-27 15:42:19');
INSERT INTO `access_log` VALUES (59623, '66.53.15642133444077609', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:24', 16, 1001003001, '验证码已过期', '2019-07-27 15:42:24');
INSERT INTO `access_log` VALUES (59624, '66.49.15642133469827615', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:27', 12, 1001003001, '验证码已过期', '2019-07-27 15:42:27');
INSERT INTO `access_log` VALUES (59625, '64.80.15642133487120081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:29', 2, 0, '', '2019-07-27 15:42:29');
INSERT INTO `access_log` VALUES (59626, '64.81.15642133488270073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:29', 2, 0, '', '2019-07-27 15:42:29');
INSERT INTO `access_log` VALUES (59627, '64.83.15642133505720071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:31', 2, 0, '', '2019-07-27 15:42:31');
INSERT INTO `access_log` VALUES (59628, '64.79.15642133515350075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:32', 2, 0, '', '2019-07-27 15:42:32');
INSERT INTO `access_log` VALUES (59629, '64.77.15642133523040061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:32', 2, 0, '', '2019-07-27 15:42:32');
INSERT INTO `access_log` VALUES (59630, '64.78.15642133528960081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:33', 2, 0, '', '2019-07-27 15:42:33');
INSERT INTO `access_log` VALUES (59631, '64.82.15642133534960089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:34', 2, 0, '', '2019-07-27 15:42:34');
INSERT INTO `access_log` VALUES (59632, '64.84.15642133541490065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:34', 2, 0, '', '2019-07-27 15:42:34');
INSERT INTO `access_log` VALUES (59633, '64.85.15642133545820109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:35', 2, 0, '', '2019-07-27 15:42:35');
INSERT INTO `access_log` VALUES (59634, '64.80.15642133587260083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:39', 2, 0, '', '2019-07-27 15:42:39');
INSERT INTO `access_log` VALUES (59635, '64.81.15642133588630075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:39', 2, 0, '', '2019-07-27 15:42:39');
INSERT INTO `access_log` VALUES (59636, '64.83.15642133609880073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:41', 2, 0, '', '2019-07-27 15:42:41');
INSERT INTO `access_log` VALUES (59637, '64.79.15642133611190077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:41', 2, 0, '', '2019-07-27 15:42:41');
INSERT INTO `access_log` VALUES (59638, '59.71.15642133621259817', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:42', 2, 0, '', '2019-07-27 15:42:42');
INSERT INTO `access_log` VALUES (59639, '59.75.15642133621249827', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:42', 18, 2001001000, '服务端发生异常', '2019-07-27 15:42:42');
INSERT INTO `access_log` VALUES (59640, '64.77.15642133677610063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:48', 2, 0, '', '2019-07-27 15:42:48');
INSERT INTO `access_log` VALUES (59641, '64.78.15642133679020083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:48', 1, 0, '', '2019-07-27 15:42:48');
INSERT INTO `access_log` VALUES (59642, '59.76.15642133698969811', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:50', 2, 0, '', '2019-07-27 15:42:50');
INSERT INTO `access_log` VALUES (59643, '59.80.15642133698969797', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:42:50', 34, 2001001000, '服务端发生异常', '2019-07-27 15:42:50');
INSERT INTO `access_log` VALUES (59644, '64.85.15642133975550111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:43:18', 2, 0, '', '2019-07-27 15:43:18');
INSERT INTO `access_log` VALUES (59645, '64.76.15642133976790071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:43:18', 2, 0, '', '2019-07-27 15:43:18');
INSERT INTO `access_log` VALUES (59646, '59.77.15642133983979811', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:43:18', 3, 0, '', '2019-07-27 15:43:18');
INSERT INTO `access_log` VALUES (59647, '59.79.15642133983979825', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:43:18', 17, 2001001000, '服务端发生异常', '2019-07-27 15:43:18');
INSERT INTO `access_log` VALUES (59648, '64.80.15642134004270085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:43:20', 2, 0, '', '2019-07-27 15:43:20');
INSERT INTO `access_log` VALUES (59649, '64.83.15642134005450075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:43:21', 2, 0, '', '2019-07-27 15:43:21');
INSERT INTO `access_log` VALUES (59650, '64.79.15642134013640079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:43:21', 2, 0, '', '2019-07-27 15:43:21');
INSERT INTO `access_log` VALUES (59651, '64.77.15642134019420065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:43:22', 1, 0, '', '2019-07-27 15:43:22');
INSERT INTO `access_log` VALUES (59652, '64.78.15642134142640085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:43:34', 2, 0, '', '2019-07-27 15:43:34');
INSERT INTO `access_log` VALUES (59653, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:43:34', 5, 0, '', '2019-07-27 15:43:34');
INSERT INTO `access_log` VALUES (59654, '64.84.15642134194550069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:43:39', 2, 0, '', '2019-07-27 15:43:39');
INSERT INTO `access_log` VALUES (59655, '64.85.15642134195950113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:43:40', 2, 0, '', '2019-07-27 15:43:40');
INSERT INTO `access_log` VALUES (59656, '64.76.15642134242500073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:43:44', 2, 0, '', '2019-07-27 15:43:44');
INSERT INTO `access_log` VALUES (59657, '64.79.15642134722440081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:44:32', 2, 0, '', '2019-07-27 15:44:32');
INSERT INTO `access_log` VALUES (59658, '64.77.15642134724040067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:44:32', 2, 0, '', '2019-07-27 15:44:32');
INSERT INTO `access_log` VALUES (59659, '59.76.15642134736179813', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:44:34', 3, 0, '', '2019-07-27 15:44:34');
INSERT INTO `access_log` VALUES (59660, '59.80.15642134736189799', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:44:34', 12, 2001001000, '服务端发生异常', '2019-07-27 15:44:34');
INSERT INTO `access_log` VALUES (59661, '64.82.15642134759190095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:44:36', 2, 0, '', '2019-07-27 15:44:36');
INSERT INTO `access_log` VALUES (59662, '64.84.15642134760380071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:44:36', 2, 0, '', '2019-07-27 15:44:36');
INSERT INTO `access_log` VALUES (59663, '64.85.15642134794140115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:44:39', 2, 0, '', '2019-07-27 15:44:39');
INSERT INTO `access_log` VALUES (59664, '64.76.15642134795700075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:44:40', 2, 0, '', '2019-07-27 15:44:40');
INSERT INTO `access_log` VALUES (59665, '59.79.15642134801009827', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:44:40', 2, 0, '', '2019-07-27 15:44:40');
INSERT INTO `access_log` VALUES (59666, '59.77.15642134801009813', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.137.249', '2019-07-27 15:44:40', 13, 2001001000, '服务端发生异常', '2019-07-27 15:44:40');
INSERT INTO `access_log` VALUES (59667, '65.49.15642135447812167', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:45:45', 0, 1002001015, '账号未登陆', '2019-07-27 15:45:45');
INSERT INTO `access_log` VALUES (59668, '65.50.15642135447812189', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:45:45', 0, 1002001015, '账号未登陆', '2019-07-27 15:45:45');
INSERT INTO `access_log` VALUES (59669, '65.54.15642135447822115', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:45:45', 0, 1002001015, '账号未登陆', '2019-07-27 15:45:45');
INSERT INTO `access_log` VALUES (59670, '65.52.15642135484032229', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:45:48', 94, 0, '', '2019-07-27 15:45:48');
INSERT INTO `access_log` VALUES (59671, '65.45.15642135487282197', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:45:49', 139, 0, '', '2019-07-27 15:45:49');
INSERT INTO `access_log` VALUES (59672, '65.46.15642135487312263', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:45:49', 138, 0, '', '2019-07-27 15:45:49');
INSERT INTO `access_log` VALUES (59673, '65.53.15642135487302187', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:45:49', 148, 2001001000, '服务端发生异常', '2019-07-27 15:45:49');
INSERT INTO `access_log` VALUES (59674, '65.47.15642135723982187', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:46:12', 16, 0, '', '2019-07-27 15:46:12');
INSERT INTO `access_log` VALUES (59675, '65.50.15642135724022191', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:46:12', 17, 0, '', '2019-07-27 15:46:12');
INSERT INTO `access_log` VALUES (59676, '65.49.15642135724012169', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:46:12', 17, 2001001000, '服务端发生异常', '2019-07-27 15:46:12');
INSERT INTO `access_log` VALUES (59677, '65.54.15642135743772117', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:46:14', 10, 0, '', '2019-07-27 15:46:14');
INSERT INTO `access_log` VALUES (59678, '65.52.15642135743782231', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:46:14', 10, 2001001000, '服务端发生异常', '2019-07-27 15:46:14');
INSERT INTO `access_log` VALUES (59679, '65.53.15642135743812189', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.137.249', '2019-07-27 15:46:14', 9, 0, '', '2019-07-27 15:46:14');
INSERT INTO `access_log` VALUES (59680, '65.49.15642138076872173', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:50:08', 1, 1002001015, '账号未登陆', '2019-07-27 15:50:08');
INSERT INTO `access_log` VALUES (59681, '65.53.15642138077112193', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:50:08', 0, 1002001015, '账号未登陆', '2019-07-27 15:50:08');
INSERT INTO `access_log` VALUES (59682, '65.50.15642138077102195', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:50:08', 0, 1002001015, '账号未登陆', '2019-07-27 15:50:08');
INSERT INTO `access_log` VALUES (59683, '65.52.15642138116752235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:50:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 15:50:12');
INSERT INTO `access_log` VALUES (59684, '65.45.15642138179702203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:50:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 15:50:18');
INSERT INTO `access_log` VALUES (59685, '65.51.15642138409952265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:50:41', 331, 0, '', '2019-07-27 15:50:41');
INSERT INTO `access_log` VALUES (59686, '65.47.15642138416902193', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:50:42', 9, 0, '', '2019-07-27 15:50:42');
INSERT INTO `access_log` VALUES (59687, '65.49.15642138416922175', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:50:42', 10, 2001001000, '服务端发生异常', '2019-07-27 15:50:42');
INSERT INTO `access_log` VALUES (59688, '65.53.15642138417012195', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:50:42', 9, 0, '', '2019-07-27 15:50:42');
INSERT INTO `access_log` VALUES (59689, '65.50.15642138517012197', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:50:52', 17, 0, '', '2019-07-27 15:50:52');
INSERT INTO `access_log` VALUES (59690, '65.54.15642138517212123', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:50:52', 10, 2001001000, '服务端发生异常', '2019-07-27 15:50:52');
INSERT INTO `access_log` VALUES (59691, '65.52.15642138517312237', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:50:52', 9, 0, '', '2019-07-27 15:50:52');
INSERT INTO `access_log` VALUES (59692, '65.49.15642138738892177', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:51:14', 8, 0, '', '2019-07-27 15:51:14');
INSERT INTO `access_log` VALUES (59693, '65.3607.15642138738893995', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:51:14', 10, 0, '', '2019-07-27 15:51:14');
INSERT INTO `access_log` VALUES (59694, '65.51.15642138738892267', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:51:14', 12, 2001001000, '服务端发生异常', '2019-07-27 15:51:14');
INSERT INTO `access_log` VALUES (59695, '65.54.15642139038172125', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:51:44', 10, 0, '', '2019-07-27 15:51:44');
INSERT INTO `access_log` VALUES (59696, '65.52.15642139038172239', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:51:44', 9, 0, '', '2019-07-27 15:51:44');
INSERT INTO `access_log` VALUES (59697, '65.50.15642139038172199', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:51:44', 10, 2001001000, '服务端发生异常', '2019-07-27 15:51:44');
INSERT INTO `access_log` VALUES (59698, '65.45.15642139077442207', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:51:48', 9, 0, '', '2019-07-27 15:51:48');
INSERT INTO `access_log` VALUES (59699, '65.46.15642139077442273', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:51:48', 10, 2001001000, '服务端发生异常', '2019-07-27 15:51:48');
INSERT INTO `access_log` VALUES (59700, '65.51.15642139077522269', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '172.31.1.171', '2019-07-27 15:51:48', 9, 0, '', '2019-07-27 15:51:48');
INSERT INTO `access_log` VALUES (59701, '65.52.15642144226152247', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '172.31.1.171', '2019-07-27 16:00:23', 1, 1002001015, '账号未登陆', '2019-07-27 16:00:23');
INSERT INTO `access_log` VALUES (59702, '65.54.15642144226152133', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '172.31.1.171', '2019-07-27 16:00:23', 1, 1002001015, '账号未登陆', '2019-07-27 16:00:23');
INSERT INTO `access_log` VALUES (59703, '65.50.15642144226142207', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '172.31.1.171', '2019-07-27 16:00:23', 0, 1002001015, '账号未登陆', '2019-07-27 16:00:23');
INSERT INTO `access_log` VALUES (59704, '65.46.15642144282472281', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '172.31.1.171', '2019-07-27 16:00:28', 173, 0, '', '2019-07-27 16:00:28');
INSERT INTO `access_log` VALUES (59705, '65.51.15642144286652277', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '172.31.1.171', '2019-07-27 16:00:29', 228, 0, '', '2019-07-27 16:00:29');
INSERT INTO `access_log` VALUES (59706, '65.49.15642144287002187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '172.31.1.171', '2019-07-27 16:00:29', 196, 0, '', '2019-07-27 16:00:29');
INSERT INTO `access_log` VALUES (59707, '65.3607.15642144286674005', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '172.31.1.171', '2019-07-27 16:00:29', 229, 2001001000, '服务端发生异常', '2019-07-27 16:00:29');
INSERT INTO `access_log` VALUES (59708, '59.78.15642161790239861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.14.240', '2019-07-27 16:29:39', 10, 0, '', '2019-07-27 16:29:39');
INSERT INTO `access_log` VALUES (59709, '59.72.15642161790249853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.14.240', '2019-07-27 16:29:39', 14, 2001001000, '服务端发生异常', '2019-07-27 16:29:39');
INSERT INTO `access_log` VALUES (59710, '64.80.15642161824460125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.14.240', '2019-07-27 16:29:42', 11, 0, '', '2019-07-27 16:29:42');
INSERT INTO `access_log` VALUES (59711, '64.81.15642161825950117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.14.240', '2019-07-27 16:29:43', 3, 0, '', '2019-07-27 16:29:43');
INSERT INTO `access_log` VALUES (59712, '64.83.15642161834600115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.14.240', '2019-07-27 16:29:43', 2, 0, '', '2019-07-27 16:29:43');
INSERT INTO `access_log` VALUES (59713, '64.79.15642161843370119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.14.240', '2019-07-27 16:29:44', 1, 0, '', '2019-07-27 16:29:44');
INSERT INTO `access_log` VALUES (59714, '64.77.15642161849550105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.108.14.240', '2019-07-27 16:29:45', 2, 0, '', '2019-07-27 16:29:45');
INSERT INTO `access_log` VALUES (59715, '64.82.15642161958390133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:29:56', 3, 0, '', '2019-07-27 16:29:56');
INSERT INTO `access_log` VALUES (59716, '64.84.15642161959780109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:29:56', 1, 0, '', '2019-07-27 16:29:56');
INSERT INTO `access_log` VALUES (59717, '64.85.15642161971740153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:29:57', 2, 0, '', '2019-07-27 16:29:57');
INSERT INTO `access_log` VALUES (59718, '64.76.15642161976940113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:29:58', 2, 0, '', '2019-07-27 16:29:58');
INSERT INTO `access_log` VALUES (59719, '64.80.15642161982670127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:29:58', 1, 0, '', '2019-07-27 16:29:58');
INSERT INTO `access_log` VALUES (59720, '64.81.15642161989000119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:29:59', 2, 0, '', '2019-07-27 16:29:59');
INSERT INTO `access_log` VALUES (59721, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:29:59', 6, 0, '', '2019-07-27 16:29:59');
INSERT INTO `access_log` VALUES (59722, '64.83.15642162006000117', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:01', 8, 0, '', '2019-07-27 16:30:01');
INSERT INTO `access_log` VALUES (59723, '64.77.15642162113680107', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:11', 7, 0, '', '2019-07-27 16:30:11');
INSERT INTO `access_log` VALUES (59724, '64.78.15642162173890127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:17', 2, 0, '', '2019-07-27 16:30:17');
INSERT INTO `access_log` VALUES (59725, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:17', 6, 0, '', '2019-07-27 16:30:17');
INSERT INTO `access_log` VALUES (59726, '64.82.15642162179590135', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:18', 2, 0, '', '2019-07-27 16:30:18');
INSERT INTO `access_log` VALUES (59727, '64.84.15642162180850111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:18', 2, 0, '', '2019-07-27 16:30:18');
INSERT INTO `access_log` VALUES (59728, '59.80.15642162196379837', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:20', 4, 0, '', '2019-07-27 16:30:20');
INSERT INTO `access_log` VALUES (59729, '59.76.15642162196379851', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:20', 17, 2001001000, '服务端发生异常', '2019-07-27 16:30:20');
INSERT INTO `access_log` VALUES (59730, '64.76.15642162273740115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:27', 2, 0, '', '2019-07-27 16:30:27');
INSERT INTO `access_log` VALUES (59731, '64.80.15642162275030129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:28', 2, 0, '', '2019-07-27 16:30:28');
INSERT INTO `access_log` VALUES (59732, '59.74.15642162288429871', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:29', 2, 0, '', '2019-07-27 16:30:29');
INSERT INTO `access_log` VALUES (59733, '59.79.15642162288439865', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:29', 19, 2001001000, '服务端发生异常', '2019-07-27 16:30:29');
INSERT INTO `access_log` VALUES (59734, '64.83.15642162385330119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:39', 2, 0, '', '2019-07-27 16:30:39');
INSERT INTO `access_log` VALUES (59735, '64.79.15642162386490123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:39', 3, 0, '', '2019-07-27 16:30:39');
INSERT INTO `access_log` VALUES (59736, '64.77.15642162399370109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:40', 2, 0, '', '2019-07-27 16:30:40');
INSERT INTO `access_log` VALUES (59737, '64.78.15642162408020129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:41', 2, 0, '', '2019-07-27 16:30:41');
INSERT INTO `access_log` VALUES (59738, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:41', 6, 0, '', '2019-07-27 16:30:41');
INSERT INTO `access_log` VALUES (59739, '64.82.15642162435400137', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:44', 7, 0, '', '2019-07-27 16:30:44');
INSERT INTO `access_log` VALUES (59740, '66.48.15642162473047663', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '202.108.14.240', '2019-07-27 16:30:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空', '2019-07-27 16:30:47');
INSERT INTO `access_log` VALUES (59741, '65.3607.15642180735234055', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.110.58.26', '2019-07-27 17:01:14', 0, 1002001015, '账号未登陆', '2019-07-27 17:01:14');
INSERT INTO `access_log` VALUES (59742, '65.53.15642180735232257', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.110.58.26', '2019-07-27 17:01:14', 0, 1002001015, '账号未登陆', '2019-07-27 17:01:14');
INSERT INTO `access_log` VALUES (59743, '65.47.15642180735472253', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.110.58.26', '2019-07-27 17:01:14', 0, 1002001015, '账号未登陆', '2019-07-27 17:01:14');
INSERT INTO `access_log` VALUES (59744, '65.54.15642180774152185', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '36.110.58.26', '2019-07-27 17:01:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 17:01:17');
INSERT INTO `access_log` VALUES (59745, '59.78.15642193892049905', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '115.238.229.56', '2019-07-27 17:23:09', 10, 0, '', '2019-07-27 17:23:09');
INSERT INTO `access_log` VALUES (59746, '59.72.15642193892059897', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '115.238.229.56', '2019-07-27 17:23:09', 14, 2001001000, '服务端发生异常', '2019-07-27 17:23:09');
INSERT INTO `access_log` VALUES (59747, '64.85.15642193926340199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '115.238.229.56', '2019-07-27 17:23:13', 11, 0, '', '2019-07-27 17:23:13');
INSERT INTO `access_log` VALUES (59748, '64.76.15642193927890159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '115.238.229.56', '2019-07-27 17:23:13', 3, 0, '', '2019-07-27 17:23:13');
INSERT INTO `access_log` VALUES (59749, '64.80.15642193939290173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '115.238.229.56', '2019-07-27 17:23:14', 2, 0, '', '2019-07-27 17:23:14');
INSERT INTO `access_log` VALUES (59750, '64.81.15642193944760165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '115.238.229.56', '2019-07-27 17:23:14', 2, 0, '', '2019-07-27 17:23:14');
INSERT INTO `access_log` VALUES (59751, '59.71.15642193958749901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '115.238.229.56', '2019-07-27 17:23:16', 3, 0, '', '2019-07-27 17:23:16');
INSERT INTO `access_log` VALUES (59752, '59.75.15642193958749911', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '115.238.229.56', '2019-07-27 17:23:16', 39, 2001001000, '服务端发生异常', '2019-07-27 17:23:16');
INSERT INTO `access_log` VALUES (59753, '65.52.15642194964592319', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.87.104.8', '2019-07-27 17:24:56', 1, 1002001015, '账号未登陆', '2019-07-27 17:24:56');
INSERT INTO `access_log` VALUES (59754, '65.45.15642194964602285', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.87.104.8', '2019-07-27 17:24:56', 1, 1002001015, '账号未登陆', '2019-07-27 17:24:56');
INSERT INTO `access_log` VALUES (59755, '65.46.15642194964612351', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.87.104.8', '2019-07-27 17:24:56', 0, 1002001015, '账号未登陆', '2019-07-27 17:24:56');
INSERT INTO `access_log` VALUES (59756, '65.51.15642194984192347', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.87.104.8', '2019-07-27 17:24:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 17:24:58');
INSERT INTO `access_log` VALUES (59757, '65.53.15642195149782279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.87.104.8', '2019-07-27 17:25:15', 75, 0, '', '2019-07-27 17:25:15');
INSERT INTO `access_log` VALUES (59758, '65.3607.15642195153794077', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.87.104.8', '2019-07-27 17:25:15', 9, 0, '', '2019-07-27 17:25:15');
INSERT INTO `access_log` VALUES (59759, '65.47.15642195154242275', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.87.104.8', '2019-07-27 17:25:15', 10, 2001001000, '服务端发生异常', '2019-07-27 17:25:15');
INSERT INTO `access_log` VALUES (59760, '65.54.15642195154572207', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.87.104.8', '2019-07-27 17:25:15', 10, 0, '', '2019-07-27 17:25:15');
INSERT INTO `access_log` VALUES (59761, '65.45.15642195301902287', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.87.104.8', '2019-07-27 17:25:30', 17, 0, '', '2019-07-27 17:25:30');
INSERT INTO `access_log` VALUES (59762, '65.46.15642195301932353', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.87.104.8', '2019-07-27 17:25:30', 16, 2001001000, '服务端发生异常', '2019-07-27 17:25:30');
INSERT INTO `access_log` VALUES (59763, '65.52.15642195302032321', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.87.104.8', '2019-07-27 17:25:30', 8, 0, '', '2019-07-27 17:25:30');
INSERT INTO `access_log` VALUES (59764, '59.77.15642227653999939', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.102.228.115', '2019-07-27 18:19:25', 9, 0, '', '2019-07-27 18:19:25');
INSERT INTO `access_log` VALUES (59765, '59.78.15642227654189951', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.102.228.115', '2019-07-27 18:19:25', 14, 2001001000, '服务端发生异常', '2019-07-27 18:19:25');
INSERT INTO `access_log` VALUES (59766, '65.50.15642227685452325', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.102.228.115', '2019-07-27 18:19:29', 1, 1002001015, '账号未登陆', '2019-07-27 18:19:29');
INSERT INTO `access_log` VALUES (59767, '65.45.15642227685472331', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.102.228.115', '2019-07-27 18:19:29', 0, 1002001015, '账号未登陆', '2019-07-27 18:19:29');
INSERT INTO `access_log` VALUES (59768, '65.52.15642227685522365', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.102.228.115', '2019-07-27 18:19:29', 0, 1002001015, '账号未登陆', '2019-07-27 18:19:29');
INSERT INTO `access_log` VALUES (59769, '65.46.15642227772792397', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.102.228.115', '2019-07-27 18:19:37', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 18:19:37');
INSERT INTO `access_log` VALUES (59770, '65.49.15642227856282303', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.102.228.115', '2019-07-27 18:19:46', 63, 0, '', '2019-07-27 18:19:46');
INSERT INTO `access_log` VALUES (59771, '65.53.15642227860092325', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.102.228.115', '2019-07-27 18:19:46', 13, 0, '', '2019-07-27 18:19:46');
INSERT INTO `access_log` VALUES (59772, '65.3607.15642227860134123', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.102.228.115', '2019-07-27 18:19:46', 13, 2001001000, '服务端发生异常', '2019-07-27 18:19:46');
INSERT INTO `access_log` VALUES (59773, '65.47.15642227860182321', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '36.102.228.115', '2019-07-27 18:19:46', 11, 0, '', '2019-07-27 18:19:46');
INSERT INTO `access_log` VALUES (59774, '65.52.15642241620732385', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.67.134.157', '2019-07-27 18:42:42', 1, 1002001015, '账号未登陆', '2019-07-27 18:42:42');
INSERT INTO `access_log` VALUES (59775, '65.54.15642241620732273', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.67.134.157', '2019-07-27 18:42:42', 1, 1002001015, '账号未登陆', '2019-07-27 18:42:42');
INSERT INTO `access_log` VALUES (59776, '65.53.15642241620902347', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.67.134.157', '2019-07-27 18:42:42', 1, 1002001015, '账号未登陆', '2019-07-27 18:42:42');
INSERT INTO `access_log` VALUES (59777, '65.45.15642241635692353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.67.134.157', '2019-07-27 18:42:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 18:42:44');
INSERT INTO `access_log` VALUES (59778, '65.49.15642241872492323', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.67.134.157', '2019-07-27 18:43:07', 66, 0, '', '2019-07-27 18:43:07');
INSERT INTO `access_log` VALUES (59779, '65.46.15642241875982417', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.67.134.157', '2019-07-27 18:43:08', 10, 0, '', '2019-07-27 18:43:08');
INSERT INTO `access_log` VALUES (59780, '65.47.15642241875992343', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.67.134.157', '2019-07-27 18:43:08', 11, 2001001000, '服务端发生异常', '2019-07-27 18:43:08');
INSERT INTO `access_log` VALUES (59781, '65.50.15642241876052345', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.67.134.157', '2019-07-27 18:43:08', 9, 0, '', '2019-07-27 18:43:08');
INSERT INTO `access_log` VALUES (59782, '59.72.15642245649379967', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-27 18:49:25', 7, 0, '', '2019-07-27 18:49:25');
INSERT INTO `access_log` VALUES (59783, '59.75.15642245649399981', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-27 18:49:25', 13, 2001001000, '服务端发生异常', '2019-07-27 18:49:25');
INSERT INTO `access_log` VALUES (59784, '64.80.15642245696150243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-27 18:49:30', 11, 0, '', '2019-07-27 18:49:30');
INSERT INTO `access_log` VALUES (59785, '64.81.15642245698670235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-27 18:49:30', 3, 0, '', '2019-07-27 18:49:30');
INSERT INTO `access_log` VALUES (59786, '64.79.15642245713860237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-27 18:49:31', 2, 0, '', '2019-07-27 18:49:31');
INSERT INTO `access_log` VALUES (59787, '64.77.15642245720250225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-27 18:49:32', 2, 0, '', '2019-07-27 18:49:32');
INSERT INTO `access_log` VALUES (59788, '64.84.15642245975450225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-27 18:49:58', 2, 0, '', '2019-07-27 18:49:58');
INSERT INTO `access_log` VALUES (59789, '64.85.15642245977960273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-27 18:49:58', 2, 0, '', '2019-07-27 18:49:58');
INSERT INTO `access_log` VALUES (59790, '59.74.15642245987079985', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-27 18:49:59', 3, 0, '', '2019-07-27 18:49:59');
INSERT INTO `access_log` VALUES (59791, '59.76.15642245987059965', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.173.227.171', '2019-07-27 18:49:59', 14, 2001001000, '服务端发生异常', '2019-07-27 18:49:59');
INSERT INTO `access_log` VALUES (59792, '65.45.15642312773882449', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:41:17', 17, 1002001012, '访问令牌已过期', '2019-07-27 20:41:17');
INSERT INTO `access_log` VALUES (59793, '65.52.15642312773882481', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:41:17', 15, 1002001012, '访问令牌已过期', '2019-07-27 20:41:17');
INSERT INTO `access_log` VALUES (59794, '65.51.15642312773892509', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:41:17', 21, 1002001012, '访问令牌已过期', '2019-07-27 20:41:17');
INSERT INTO `access_log` VALUES (59795, '65.49.15642312817702419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:41:22', 84, 0, '', '2019-07-27 20:41:22');
INSERT INTO `access_log` VALUES (59796, '65.46.15642312820462513', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:41:22', 15, 0, '', '2019-07-27 20:41:22');
INSERT INTO `access_log` VALUES (59797, '65.47.15642312820462439', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:41:22', 17, 2001001000, '服务端发生异常', '2019-07-27 20:41:22');
INSERT INTO `access_log` VALUES (59798, '65.50.15642312820582441', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:41:22', 9, 0, '', '2019-07-27 20:41:22');
INSERT INTO `access_log` VALUES (59799, '65.53.15642313108302445', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:41:51', 10, 0, '', '2019-07-27 20:41:51');
INSERT INTO `access_log` VALUES (59800, '65.45.15642313108302451', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:41:51', 11, 2001001000, '服务端发生异常', '2019-07-27 20:41:51');
INSERT INTO `access_log` VALUES (59801, '65.51.15642313108342511', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:41:51', 9, 0, '', '2019-07-27 20:41:51');
INSERT INTO `access_log` VALUES (59802, '65.49.15642319312092429', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:52:11', 11, 0, '', '2019-07-27 20:52:11');
INSERT INTO `access_log` VALUES (59803, '65.50.15642319312102453', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:52:11', 10, 0, '', '2019-07-27 20:52:11');
INSERT INTO `access_log` VALUES (59804, '65.52.15642319312102491', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:52:11', 12, 2001001000, '服务端发生异常', '2019-07-27 20:52:11');
INSERT INTO `access_log` VALUES (59805, '65.46.15642319435912525', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:52:24', 5, 1002002001, '密码不正确', '2019-07-27 20:52:24');
INSERT INTO `access_log` VALUES (59806, '65.53.15642319491102455', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=111111&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:52:29', 64, 0, '', '2019-07-27 20:52:29');
INSERT INTO `access_log` VALUES (59807, '65.54.15642319493472383', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:52:29', 9, 0, '', '2019-07-27 20:52:29');
INSERT INTO `access_log` VALUES (59808, '65.3607.15642319493474251', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:52:29', 9, 0, '', '2019-07-27 20:52:29');
INSERT INTO `access_log` VALUES (59809, '65.51.15642319493522523', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:52:29', 9, 0, '', '2019-07-27 20:52:29');
INSERT INTO `access_log` VALUES (59810, '62.88.15642319601739091', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:52:40', 32, 0, '', '2019-07-27 20:52:40');
INSERT INTO `access_log` VALUES (59811, '66.54.15642319645827869', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:52:45', 19, 0, '', '2019-07-27 20:52:45');
INSERT INTO `access_log` VALUES (59812, '65.50.15642319695292455', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:52:50', 27, 0, '', '2019-07-27 20:52:50');
INSERT INTO `access_log` VALUES (59813, '65.46.15642319965012527', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:53:17', 19, 0, '', '2019-07-27 20:53:17');
INSERT INTO `access_log` VALUES (59814, '65.47.15642320028482451', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:53:23', 19, 0, '', '2019-07-27 20:53:23');
INSERT INTO `access_log` VALUES (59815, '65.51.15642320431142525', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:54:03', 9, 0, '', '2019-07-27 20:54:03');
INSERT INTO `access_log` VALUES (59816, '65.45.15642320431762465', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:54:03', 9, 0, '', '2019-07-27 20:54:03');
INSERT INTO `access_log` VALUES (59817, '65.50.15642320432312457', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:54:03', 9, 0, '', '2019-07-27 20:54:03');
INSERT INTO `access_log` VALUES (59818, '65.49.15642320432752433', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:54:03', 16, 0, '', '2019-07-27 20:54:03');
INSERT INTO `access_log` VALUES (59819, '59.80.15642320512270049', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:54:11', 24, 0, '', '2019-07-27 20:54:11');
INSERT INTO `access_log` VALUES (59820, '65.3607.15642321030514255', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:55:03', 18, 0, '', '2019-07-27 20:55:03');
INSERT INTO `access_log` VALUES (59821, '65.51.15642321100612527', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:55:10', 19, 0, '', '2019-07-27 20:55:10');
INSERT INTO `access_log` VALUES (59822, '65.45.15642321142572467', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:55:14', 9, 0, '', '2019-07-27 20:55:14');
INSERT INTO `access_log` VALUES (59823, '65.50.15642321171422459', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 20:55:17', 14, 0, '', '2019-07-27 20:55:17');
INSERT INTO `access_log` VALUES (59824, '64.81.15642325705390343', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 21:02:51', 27, 0, '', '2019-07-27 21:02:51');
INSERT INTO `access_log` VALUES (59825, '64.80.15642325705390351', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 21:02:51', 30, 0, '', '2019-07-27 21:02:51');
INSERT INTO `access_log` VALUES (59826, '64.77.15642325791650333', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 21:02:59', 17, 0, '', '2019-07-27 21:02:59');
INSERT INTO `access_log` VALUES (59827, '64.79.15642325791650345', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 21:02:59', 19, 0, '', '2019-07-27 21:02:59');
INSERT INTO `access_log` VALUES (59828, '64.78.15642325791790349', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.234.121.203', '2019-07-27 21:02:59', 11, 0, '', '2019-07-27 21:02:59');
INSERT INTO `access_log` VALUES (59829, '65.50.15642367474812521', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:12:27', 0, 1002001015, '账号未登陆', '2019-07-27 22:12:27');
INSERT INTO `access_log` VALUES (59830, '65.49.15642367474812497', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:12:27', 0, 1002001015, '账号未登陆', '2019-07-27 22:12:27');
INSERT INTO `access_log` VALUES (59831, '65.52.15642367475092559', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:12:28', 0, 1002001015, '账号未登陆', '2019-07-27 22:12:28');
INSERT INTO `access_log` VALUES (59832, '65.46.15642367492732593', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:12:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 22:12:29');
INSERT INTO `access_log` VALUES (59833, '65.53.15642367605352523', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:12:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 22:12:41');
INSERT INTO `access_log` VALUES (59834, '65.3607.15642367656134319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:12:46', 5, 1002002001, '密码不正确', '2019-07-27 22:12:46');
INSERT INTO `access_log` VALUES (59835, '65.51.15642367771782591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:12:57', 105, 0, '', '2019-07-27 22:12:57');
INSERT INTO `access_log` VALUES (59836, '65.45.15642367775642531', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:12:58', 11, 0, '', '2019-07-27 22:12:58');
INSERT INTO `access_log` VALUES (59837, '65.50.15642367775662523', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:12:58', 10, 0, '', '2019-07-27 22:12:58');
INSERT INTO `access_log` VALUES (59838, '65.49.15642367775642499', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:12:58', 13, 2001001000, '服务端发生异常', '2019-07-27 22:12:58');
INSERT INTO `access_log` VALUES (59839, '65.46.15642367897202595', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:13:10', 9, 0, '', '2019-07-27 22:13:10');
INSERT INTO `access_log` VALUES (59840, '65.47.15642367897202519', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:13:10', 13, 2001001000, '服务端发生异常', '2019-07-27 22:13:10');
INSERT INTO `access_log` VALUES (59841, '65.53.15642367897232525', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:13:10', 10, 0, '', '2019-07-27 22:13:10');
INSERT INTO `access_log` VALUES (59842, '59.76.15642368658250129', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:26', 17, 0, '', '2019-07-27 22:14:26');
INSERT INTO `access_log` VALUES (59843, '59.77.15642368658250129', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:26', 28, 2001001000, '服务端发生异常', '2019-07-27 22:14:26');
INSERT INTO `access_log` VALUES (59844, '64.81.15642368691020401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:29', 9, 0, '', '2019-07-27 22:14:29');
INSERT INTO `access_log` VALUES (59845, '64.79.15642368692080403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:29', 3, 0, '', '2019-07-27 22:14:29');
INSERT INTO `access_log` VALUES (59846, '64.78.15642368704640407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:30', 2, 0, '', '2019-07-27 22:14:30');
INSERT INTO `access_log` VALUES (59847, '64.77.15642368709790391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:31', 2, 0, '', '2019-07-27 22:14:31');
INSERT INTO `access_log` VALUES (59848, '64.82.15642368735730415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:34', 2, 0, '', '2019-07-27 22:14:34');
INSERT INTO `access_log` VALUES (59849, '64.84.15642368737780391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:34', 2, 0, '', '2019-07-27 22:14:34');
INSERT INTO `access_log` VALUES (59850, '64.76.15642368814350397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:41', 2, 0, '', '2019-07-27 22:14:41');
INSERT INTO `access_log` VALUES (59851, '64.83.15642368816590399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:42', 2, 0, '', '2019-07-27 22:14:42');
INSERT INTO `access_log` VALUES (59852, '59.78.15642368817550143', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:42', 4, 0, '', '2019-07-27 22:14:42');
INSERT INTO `access_log` VALUES (59853, '59.71.15642368817870137', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:42', 17, 2001001000, '服务端发生异常', '2019-07-27 22:14:42');
INSERT INTO `access_log` VALUES (59854, '64.80.15642368837240411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:44', 2, 0, '', '2019-07-27 22:14:44');
INSERT INTO `access_log` VALUES (59855, '64.81.15642368838410403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:44', 2, 0, '', '2019-07-27 22:14:44');
INSERT INTO `access_log` VALUES (59856, '64.79.15642368882130405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:48', 1, 0, '', '2019-07-27 22:14:48');
INSERT INTO `access_log` VALUES (59857, '64.78.15642368883970409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:48', 2, 0, '', '2019-07-27 22:14:48');
INSERT INTO `access_log` VALUES (59858, '64.77.15642368894990393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:49', 2, 0, '', '2019-07-27 22:14:50');
INSERT INTO `access_log` VALUES (59859, '64.82.15642368897720417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:50', 2, 0, '', '2019-07-27 22:14:50');
INSERT INTO `access_log` VALUES (59860, '64.84.15642368900440393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:50', 2, 0, '', '2019-07-27 22:14:50');
INSERT INTO `access_log` VALUES (59861, '59.75.15642368909230147', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:51', 3, 0, '', '2019-07-27 22:14:51');
INSERT INTO `access_log` VALUES (59862, '59.73.15642368909230143', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.118.26.245', '2019-07-27 22:14:51', 16, 2001001000, '服务端发生异常', '2019-07-27 22:14:51');
INSERT INTO `access_log` VALUES (59863, '65.53.15642386954662551', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.166.239.18', '2019-07-27 22:44:55', 0, 1002001015, '账号未登陆', '2019-07-27 22:44:55');
INSERT INTO `access_log` VALUES (59864, '65.46.15642386954712621', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.166.239.18', '2019-07-27 22:44:55', 0, 1002001015, '账号未登陆', '2019-07-27 22:44:55');
INSERT INTO `access_log` VALUES (59865, '65.47.15642386954892545', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.166.239.18', '2019-07-27 22:44:55', 0, 1002001015, '账号未登陆', '2019-07-27 22:44:55');
INSERT INTO `access_log` VALUES (59866, '65.3607.15642386976874347', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.166.239.18', '2019-07-27 22:44:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 22:44:58');
INSERT INTO `access_log` VALUES (59867, '65.54.15642387011172479', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.166.239.18', '2019-07-27 22:45:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-27 22:45:01');
INSERT INTO `access_log` VALUES (59868, '59.80.15642424411310189', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:47:21', 9, 0, '', '2019-07-27 23:47:21');
INSERT INTO `access_log` VALUES (59869, '59.74.15642424411400225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:47:21', 9, 2001001000, '服务端发生异常', '2019-07-27 23:47:21');
INSERT INTO `access_log` VALUES (59870, '64.76.15642424465830473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:47:27', 11, 0, '', '2019-07-27 23:47:27');
INSERT INTO `access_log` VALUES (59871, '64.83.15642424467070475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:47:27', 3, 0, '', '2019-07-27 23:47:27');
INSERT INTO `access_log` VALUES (59872, '64.80.15642424484310487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:47:28', 2, 0, '', '2019-07-27 23:47:28');
INSERT INTO `access_log` VALUES (59873, '64.81.15642424491490479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:47:29', 2, 0, '', '2019-07-27 23:47:29');
INSERT INTO `access_log` VALUES (59874, '64.79.15642424530630481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:47:33', 2, 0, '', '2019-07-27 23:47:33');
INSERT INTO `access_log` VALUES (59875, '64.78.15642424531830485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:47:33', 2, 0, '', '2019-07-27 23:47:33');
INSERT INTO `access_log` VALUES (59876, '66.52.15642424826187995', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13422294047&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:48:03', 16, 1001003000, '验证码不存在', '2019-07-27 23:48:03');
INSERT INTO `access_log` VALUES (59877, '66.48.15642424846028015', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13422294047', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:48:05', 109, 0, '', '2019-07-27 23:48:05');
INSERT INTO `access_log` VALUES (59878, '66.57.15642424862028011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13422294047&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:48:06', 173, 0, '', '2019-07-27 23:48:06');
INSERT INTO `access_log` VALUES (59879, '66.50.15642424933248001', 183, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:48:13', 6, 0, '', '2019-07-27 23:48:13');
INSERT INTO `access_log` VALUES (59880, '66.55.15642424986487983', 183, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:48:19', 6, 0, '', '2019-07-27 23:48:19');
INSERT INTO `access_log` VALUES (59881, '64.76.15642424987440475', 183, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:48:19', 5, 0, '', '2019-07-27 23:48:19');
INSERT INTO `access_log` VALUES (59882, '64.80.15642424991980489', 183, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:48:19', 5, 0, '', '2019-07-27 23:48:19');
INSERT INTO `access_log` VALUES (59883, '64.78.15642425012080487', 183, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:48:21', 7, 0, '', '2019-07-27 23:48:21');
INSERT INTO `access_log` VALUES (59884, '59.73.15642425025240219', 183, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:48:23', 8, 0, '', '2019-07-27 23:48:23');
INSERT INTO `access_log` VALUES (59885, '59.75.15642425025260223', 183, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '27.37.165.236', '2019-07-27 23:48:23', 21, 2001001000, '服务端发生异常', '2019-07-27 23:48:23');
INSERT INTO `access_log` VALUES (59886, '65.54.15642673334262861', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36', '66.249.70.31', '2019-07-28 06:42:13', 0, 1002001015, '账号未登陆', '2019-07-28 06:42:13');
INSERT INTO `access_log` VALUES (59887, '65.51.15642673351823001', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36', '66.249.70.29', '2019-07-28 06:42:15', 0, 1002001015, '账号未登陆', '2019-07-28 06:42:15');
INSERT INTO `access_log` VALUES (59888, '65.49.15642673369502909', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36', '66.249.70.29', '2019-07-28 06:42:17', 0, 1002001015, '账号未登陆', '2019-07-28 06:42:17');
INSERT INTO `access_log` VALUES (59889, '65.52.15642744024703065', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 08:40:02', 20, 1002001012, '访问令牌已过期', '2019-07-28 08:40:02');
INSERT INTO `access_log` VALUES (59890, '65.46.15642744024703099', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 08:40:02', 23, 1002001012, '访问令牌已过期', '2019-07-28 08:40:02');
INSERT INTO `access_log` VALUES (59891, '65.45.15642744024743035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 08:40:02', 22, 1002001012, '访问令牌已过期', '2019-07-28 08:40:02');
INSERT INTO `access_log` VALUES (59892, '65.3607.15642744304254825', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 08:40:30', 130, 0, '', '2019-07-28 08:40:31');
INSERT INTO `access_log` VALUES (59893, '65.53.15642744307243029', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 08:40:31', 13, 0, '', '2019-07-28 08:40:31');
INSERT INTO `access_log` VALUES (59894, '65.50.15642744307293027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 08:40:31', 13, 2001001000, '服务端发生异常', '2019-07-28 08:40:31');
INSERT INTO `access_log` VALUES (59895, '65.51.15642744307323097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 08:40:31', 12, 0, '', '2019-07-28 08:40:31');
INSERT INTO `access_log` VALUES (59896, '65.53.15642753060813041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 08:55:06', 9, 0, '', '2019-07-28 08:55:06');
INSERT INTO `access_log` VALUES (59897, '65.49.15642753060823019', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 08:55:06', 9, 0, '', '2019-07-28 08:55:06');
INSERT INTO `access_log` VALUES (59898, '65.51.15642753060813109', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 08:55:06', 10, 2001001000, '服务端发生异常', '2019-07-28 08:55:06');
INSERT INTO `access_log` VALUES (59899, '59.75.15642753211020661', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 08:55:21', 12, 0, '', '2019-07-28 08:55:21');
INSERT INTO `access_log` VALUES (59900, '59.73.15642753211020657', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 08:55:21', 26, 2001001000, '服务端发生异常', '2019-07-28 08:55:21');
INSERT INTO `access_log` VALUES (59901, '59.76.15642806012420715', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:23:21', 10, 0, '', '2019-07-28 10:23:21');
INSERT INTO `access_log` VALUES (59902, '59.77.15642806012430715', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:23:21', 19, 2001001000, '服务端发生异常', '2019-07-28 10:23:21');
INSERT INTO `access_log` VALUES (59903, '59.79.15642806068020731', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:23:27', 3, 0, '', '2019-07-28 10:23:27');
INSERT INTO `access_log` VALUES (59904, '59.78.15642806068030729', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:23:27', 14, 2001001000, '服务端发生异常', '2019-07-28 10:23:27');
INSERT INTO `access_log` VALUES (59905, '64.77.15642806116200979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:23:32', 11, 0, '', '2019-07-28 10:23:32');
INSERT INTO `access_log` VALUES (59906, '64.82.15642806117661003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:23:32', 3, 0, '', '2019-07-28 10:23:32');
INSERT INTO `access_log` VALUES (59907, '64.84.15642806132850979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:23:33', 2, 0, '', '2019-07-28 10:23:33');
INSERT INTO `access_log` VALUES (59908, '64.85.15642806139961027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:23:34', 1, 0, '', '2019-07-28 10:23:34');
INSERT INTO `access_log` VALUES (59909, '64.76.15642806146430985', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:23:35', 2, 0, '', '2019-07-28 10:23:35');
INSERT INTO `access_log` VALUES (59910, '65.53.15642806421183113', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:24:02', 1, 1002001015, '账号未登陆', '2019-07-28 10:24:02');
INSERT INTO `access_log` VALUES (59911, '65.52.15642806421183149', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:24:02', 1, 1002001015, '账号未登陆', '2019-07-28 10:24:02');
INSERT INTO `access_log` VALUES (59912, '65.45.15642806421183119', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:24:02', 0, 1002001015, '账号未登陆', '2019-07-28 10:24:02');
INSERT INTO `access_log` VALUES (59913, '65.46.15642806447603187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:24:05', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-28 10:24:05');
INSERT INTO `access_log` VALUES (59914, '65.54.15642806494013043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:24:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-28 10:24:09');
INSERT INTO `access_log` VALUES (59915, '65.49.15642807074843093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:25:07', 62, 0, '', '2019-07-28 10:25:08');
INSERT INTO `access_log` VALUES (59916, '65.53.15642807081013115', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:25:08', 16, 0, '', '2019-07-28 10:25:08');
INSERT INTO `access_log` VALUES (59917, '65.45.15642807081013121', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:25:08', 15, 0, '', '2019-07-28 10:25:08');
INSERT INTO `access_log` VALUES (59918, '65.52.15642807081023151', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '222.209.17.69', '2019-07-28 10:25:08', 16, 2001001000, '服务端发生异常', '2019-07-28 10:25:08');
INSERT INTO `access_log` VALUES (59919, '59.79.15642819246450749', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; RNE-AL00 Build/HUAWEIRNE-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.2.46 Mobile Safari/537.36 AliApp(DingTalk/4.6.41) com.alibaba.android.rimet/11709550 Channel/10002068 language/zh-CN', '117.136.95.27', '2019-07-28 10:45:25', 5, 0, '', '2019-07-28 10:45:25');
INSERT INTO `access_log` VALUES (59920, '59.78.15642819246450747', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; RNE-AL00 Build/HUAWEIRNE-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.2.46 Mobile Safari/537.36 AliApp(DingTalk/4.6.41) com.alibaba.android.rimet/11709550 Channel/10002068 language/zh-CN', '117.136.95.27', '2019-07-28 10:45:25', 17, 2001001000, '服务端发生异常', '2019-07-28 10:45:25');
INSERT INTO `access_log` VALUES (59921, '59.75.15642821280750753', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:48:48', 3, 0, '', '2019-07-28 10:48:48');
INSERT INTO `access_log` VALUES (59922, '59.80.15642821280760721', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:48:48', 16, 2001001000, '服务端发生异常', '2019-07-28 10:48:48');
INSERT INTO `access_log` VALUES (59923, '64.81.15642821441371011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:49:04', 3, 0, '', '2019-07-28 10:49:04');
INSERT INTO `access_log` VALUES (59924, '64.79.15642821442711013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:49:04', 2, 0, '', '2019-07-28 10:49:04');
INSERT INTO `access_log` VALUES (59925, '64.78.15642821454851017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:49:05', 3, 0, '', '2019-07-28 10:49:05');
INSERT INTO `access_log` VALUES (59926, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:49:05', 15, 0, '', '2019-07-28 10:49:06');
INSERT INTO `access_log` VALUES (59927, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:49:07', 4, 0, '', '2019-07-28 10:49:07');
INSERT INTO `access_log` VALUES (59928, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:49:07', 6, 0, '', '2019-07-28 10:49:07');
INSERT INTO `access_log` VALUES (59929, '64.82.15642821490441025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:49:09', 2, 0, '', '2019-07-28 10:49:09');
INSERT INTO `access_log` VALUES (59930, '64.84.15642821491791001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:49:09', 2, 0, '', '2019-07-28 10:49:09');
INSERT INTO `access_log` VALUES (59931, '59.76.15642821509530737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:49:11', 2, 0, '', '2019-07-28 10:49:11');
INSERT INTO `access_log` VALUES (59932, '59.78.15642821509540751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:49:11', 26, 2001001000, '服务端发生异常', '2019-07-28 10:49:11');
INSERT INTO `access_log` VALUES (59933, '64.85.15642821558111049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:49:16', 1, 0, '', '2019-07-28 10:49:16');
INSERT INTO `access_log` VALUES (59934, '64.76.15642821559011007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:49:16', 2, 0, '', '2019-07-28 10:49:16');
INSERT INTO `access_log` VALUES (59935, '64.80.15642821686011021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:49:29', 2, 0, '', '2019-07-28 10:49:29');
INSERT INTO `access_log` VALUES (59936, '64.81.15642821686931013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:49:29', 1, 0, '', '2019-07-28 10:49:29');
INSERT INTO `access_log` VALUES (59937, '64.82.15642822195921027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:50:20', 2, 0, '', '2019-07-28 10:50:20');
INSERT INTO `access_log` VALUES (59938, '64.84.15642822196791003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:50:20', 3, 0, '', '2019-07-28 10:50:20');
INSERT INTO `access_log` VALUES (59939, '64.76.15642822213711009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:50:21', 2, 0, '', '2019-07-28 10:50:21');
INSERT INTO `access_log` VALUES (59940, '64.83.15642822221351011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:50:22', 2, 0, '', '2019-07-28 10:50:22');
INSERT INTO `access_log` VALUES (59941, '64.80.15642822237711023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:50:24', 2, 0, '', '2019-07-28 10:50:24');
INSERT INTO `access_log` VALUES (59942, '64.81.15642822245221015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:50:25', 2, 0, '', '2019-07-28 10:50:25');
INSERT INTO `access_log` VALUES (59943, '64.79.15642822250081017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:50:25', 2, 0, '', '2019-07-28 10:50:25');
INSERT INTO `access_log` VALUES (59944, '64.77.15642822256671005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:50:26', 2, 0, '', '2019-07-28 10:50:26');
INSERT INTO `access_log` VALUES (59945, '64.78.15642822261391021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:50:26', 2, 0, '', '2019-07-28 10:50:26');
INSERT INTO `access_log` VALUES (59946, '59.80.15642822305060723', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:50:31', 3, 0, '', '2019-07-28 10:50:31');
INSERT INTO `access_log` VALUES (59947, '59.74.15642822305210759', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:50:31', 16, 2001001000, '服务端发生异常', '2019-07-28 10:50:31');
INSERT INTO `access_log` VALUES (59948, '64.82.15642822350961029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:50:35', 2, 0, '', '2019-07-28 10:50:35');
INSERT INTO `access_log` VALUES (59949, '64.84.15642822351781005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 10:50:35', 2, 0, '', '2019-07-28 10:50:35');
INSERT INTO `access_log` VALUES (59950, '64.81.15642822922651017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:32', 2, 0, '', '2019-07-28 10:51:32');
INSERT INTO `access_log` VALUES (59951, '64.79.15642822931251019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:33', 2, 0, '', '2019-07-28 10:51:33');
INSERT INTO `access_log` VALUES (59952, '64.77.15642822939291007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:34', 2, 0, '', '2019-07-28 10:51:34');
INSERT INTO `access_log` VALUES (59953, '64.82.15642822960231031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:36', 2, 0, '', '2019-07-28 10:51:36');
INSERT INTO `access_log` VALUES (59954, '64.84.15642822961181007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:36', 2, 0, '', '2019-07-28 10:51:36');
INSERT INTO `access_log` VALUES (59955, '59.72.15642822966950743', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:37', 3, 0, '', '2019-07-28 10:51:37');
INSERT INTO `access_log` VALUES (59956, '59.73.15642822967030753', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:37', 38, 2001001000, '服务端发生异常', '2019-07-28 10:51:37');
INSERT INTO `access_log` VALUES (59957, '64.85.15642823001891055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:40', 2, 0, '', '2019-07-28 10:51:40');
INSERT INTO `access_log` VALUES (59958, '64.76.15642823003251013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:40', 2, 0, '', '2019-07-28 10:51:40');
INSERT INTO `access_log` VALUES (59959, '64.83.15642823015891015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:42', 2, 0, '', '2019-07-28 10:51:42');
INSERT INTO `access_log` VALUES (59960, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:42', 8, 0, '', '2019-07-28 10:51:42');
INSERT INTO `access_log` VALUES (59961, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:43', 5, 0, '', '2019-07-28 10:51:43');
INSERT INTO `access_log` VALUES (59962, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:44', 13, 0, '', '2019-07-28 10:51:44');
INSERT INTO `access_log` VALUES (59963, '64.80.15642823051081027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:45', 1, 0, '', '2019-07-28 10:51:45');
INSERT INTO `access_log` VALUES (59964, '64.81.15642823052191019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:45', 2, 0, '', '2019-07-28 10:51:45');
INSERT INTO `access_log` VALUES (59965, '64.79.15642823076211021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:48', 1, 0, '', '2019-07-28 10:51:48');
INSERT INTO `access_log` VALUES (59966, '64.78.15642823108311025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:51', 1, 0, '', '2019-07-28 10:51:51');
INSERT INTO `access_log` VALUES (59967, '64.82.15642823127291033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:53', 2, 0, '', '2019-07-28 10:51:53');
INSERT INTO `access_log` VALUES (59968, '64.84.15642823132171009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:53', 2, 0, '', '2019-07-28 10:51:53');
INSERT INTO `access_log` VALUES (59969, '59.80.15642823172180725', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:57', 2, 0, '', '2019-07-28 10:51:57');
INSERT INTO `access_log` VALUES (59970, '59.74.15642823172180761', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:51:57', 13, 2001001000, '服务端发生异常', '2019-07-28 10:51:57');
INSERT INTO `access_log` VALUES (59971, '59.76.15642823248200741', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:52:05', 2, 0, '', '2019-07-28 10:52:05');
INSERT INTO `access_log` VALUES (59972, '59.78.15642823248200755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Mobile Safari/537.36', '101.224.167.77', '2019-07-28 10:52:05', 12, 2001001000, '服务端发生异常', '2019-07-28 10:52:05');
INSERT INTO `access_log` VALUES (59973, '65.50.15642829741103145', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 11:02:54', 4, 1002001012, '访问令牌已过期', '2019-07-28 11:02:54');
INSERT INTO `access_log` VALUES (59974, '65.49.15642829741103125', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 11:02:54', 4, 1002001012, '访问令牌已过期', '2019-07-28 11:02:54');
INSERT INTO `access_log` VALUES (59975, '65.45.15642829741313153', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 11:02:54', 12, 1002001012, '访问令牌已过期', '2019-07-28 11:02:54');
INSERT INTO `access_log` VALUES (59976, '65.53.15642829780433147', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 11:02:58', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-28 11:02:58');
INSERT INTO `access_log` VALUES (59977, '65.46.15642829974283221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 11:03:17', 406, 0, '', '2019-07-28 11:03:18');
INSERT INTO `access_log` VALUES (59978, '65.3607.15642829980014945', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 11:03:18', 15, 0, '', '2019-07-28 11:03:18');
INSERT INTO `access_log` VALUES (59979, '65.47.15642829979933143', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 11:03:18', 19, 0, '', '2019-07-28 11:03:18');
INSERT INTO `access_log` VALUES (59980, '65.54.15642829979933075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '101.224.167.77', '2019-07-28 11:03:18', 24, 2001001000, '服务端发生异常', '2019-07-28 11:03:18');
INSERT INTO `access_log` VALUES (59981, '59.78.15642873973160823', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:16:37', 10, 0, '', '2019-07-28 12:16:37');
INSERT INTO `access_log` VALUES (59982, '59.76.15642873973160809', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:16:37', 15, 2001001000, '服务端发生异常', '2019-07-28 12:16:37');
INSERT INTO `access_log` VALUES (59983, '65.52.15642874081003243', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:16:48', 1, 1002001015, '账号未登陆', '2019-07-28 12:16:48');
INSERT INTO `access_log` VALUES (59984, '65.53.15642874081003207', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:16:48', 1, 1002001015, '账号未登陆', '2019-07-28 12:16:48');
INSERT INTO `access_log` VALUES (59985, '65.46.15642874081493281', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:16:48', 1, 1002001015, '账号未登陆', '2019-07-28 12:16:48');
INSERT INTO `access_log` VALUES (59986, '64.85.15642874115101125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:16:52', 11, 0, '', '2019-07-28 12:16:52');
INSERT INTO `access_log` VALUES (59987, '64.76.15642874118171083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:16:52', 2, 0, '', '2019-07-28 12:16:52');
INSERT INTO `access_log` VALUES (59988, '64.83.15642874145181085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:16:55', 2, 0, '', '2019-07-28 12:16:55');
INSERT INTO `access_log` VALUES (59989, '64.80.15642874152901097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:16:55', 2, 0, '', '2019-07-28 12:16:55');
INSERT INTO `access_log` VALUES (59990, '64.81.15642874200131089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:17:00', 2, 0, '', '2019-07-28 12:17:00');
INSERT INTO `access_log` VALUES (59991, '64.79.15642874201571091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:17:00', 1, 0, '', '2019-07-28 12:17:00');
INSERT INTO `access_log` VALUES (59992, '65.47.15642874261183203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:17:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-28 12:17:06');
INSERT INTO `access_log` VALUES (59993, '65.51.15642874305303277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:17:11', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-28 12:17:11');
INSERT INTO `access_log` VALUES (59994, '65.49.15642874407403187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:17:21', 6, 1002002001, '密码不正确', '2019-07-28 12:17:21');
INSERT INTO `access_log` VALUES (59995, '65.53.15642874690383209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:17:49', 83, 0, '', '2019-07-28 12:17:49');
INSERT INTO `access_log` VALUES (59996, '65.52.15642874696093245', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:17:50', 112, 0, '', '2019-07-28 12:17:50');
INSERT INTO `access_log` VALUES (59997, '65.54.15642874696313137', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:17:50', 93, 0, '', '2019-07-28 12:17:50');
INSERT INTO `access_log` VALUES (59998, '65.46.15642874696223283', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.215.76.45', '2019-07-28 12:17:50', 101, 2001001000, '服务端发生异常', '2019-07-28 12:17:50');
INSERT INTO `access_log` VALUES (59999, '65.47.15642909204283251', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '113.87.88.58', '2019-07-28 13:15:20', 1, 1002001015, '账号未登陆', '2019-07-28 13:15:20');
INSERT INTO `access_log` VALUES (60000, '65.3607.15642909204445053', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '113.87.88.85', '2019-07-28 13:15:20', 1, 1002001015, '账号未登陆', '2019-07-28 13:15:20');
INSERT INTO `access_log` VALUES (60001, '65.51.15642909204483325', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '113.116.158.227', '2019-07-28 13:15:20', 0, 1002001015, '账号未登陆', '2019-07-28 13:15:20');
INSERT INTO `access_log` VALUES (60002, '65.49.15642909223273235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '113.87.88.85', '2019-07-28 13:15:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-28 13:15:22');
INSERT INTO `access_log` VALUES (60003, '65.45.15642909303273263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '113.87.88.85', '2019-07-28 13:15:30', 104, 0, '', '2019-07-28 13:15:30');
INSERT INTO `access_log` VALUES (60004, '65.53.15642909306683257', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '113.87.88.85', '2019-07-28 13:15:31', 20, 0, '', '2019-07-28 13:15:31');
INSERT INTO `access_log` VALUES (60005, '65.52.15642909306703293', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '113.116.158.227', '2019-07-28 13:15:31', 17, 2001001000, '服务端发生异常', '2019-07-28 13:15:31');
INSERT INTO `access_log` VALUES (60006, '65.46.15642909306723331', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '113.87.88.85', '2019-07-28 13:15:31', 17, 0, '', '2019-07-28 13:15:31');
INSERT INTO `access_log` VALUES (60007, '59.76.15642944352140903', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '223.104.64.153', '2019-07-28 14:13:55', 10, 0, '', '2019-07-28 14:13:55');
INSERT INTO `access_log` VALUES (60008, '59.79.15642944352160919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '223.104.64.153', '2019-07-28 14:13:55', 15, 2001001000, '服务端发生异常', '2019-07-28 14:13:55');
INSERT INTO `access_log` VALUES (60009, '64.79.15642944465751185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '223.104.64.153', '2019-07-28 14:14:07', 11, 0, '', '2019-07-28 14:14:07');
INSERT INTO `access_log` VALUES (60010, '64.77.15642944467351173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '223.104.64.153', '2019-07-28 14:14:07', 3, 0, '', '2019-07-28 14:14:07');
INSERT INTO `access_log` VALUES (60011, '64.78.15642944507871189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '223.104.64.153', '2019-07-28 14:14:11', 1, 0, '', '2019-07-28 14:14:11');
INSERT INTO `access_log` VALUES (60012, '64.82.15642944518571197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '223.104.64.153', '2019-07-28 14:14:12', 2, 0, '', '2019-07-28 14:14:12');
INSERT INTO `access_log` VALUES (60013, '64.85.15642944704831221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '223.104.64.153', '2019-07-28 14:14:30', 2, 0, '', '2019-07-28 14:14:30');
INSERT INTO `access_log` VALUES (60014, '64.76.15642944706271179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '223.104.64.153', '2019-07-28 14:14:31', 1, 0, '', '2019-07-28 14:14:31');
INSERT INTO `access_log` VALUES (60015, '59.73.15642944710270917', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '223.104.64.153', '2019-07-28 14:14:31', 3, 0, '', '2019-07-28 14:14:31');
INSERT INTO `access_log` VALUES (60016, '59.75.15642944710330921', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '223.104.64.153', '2019-07-28 14:14:31', 10, 2001001000, '服务端发生异常', '2019-07-28 14:14:31');
INSERT INTO `access_log` VALUES (60017, '59.76.15642964716590931', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.118.131', '2019-07-28 14:47:52', 10, 0, '', '2019-07-28 14:47:52');
INSERT INTO `access_log` VALUES (60018, '59.79.15642964716610947', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '36.110.118.131', '2019-07-28 14:47:52', 15, 2001001000, '服务端发生异常', '2019-07-28 14:47:52');
INSERT INTO `access_log` VALUES (60019, '59.74.15642965315850953', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.91.60.110', '2019-07-28 14:48:52', 3, 0, '', '2019-07-28 14:48:52');
INSERT INTO `access_log` VALUES (60020, '59.80.15642965324850917', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.159', '2019-07-28 14:48:52', 21, 2001001000, '服务端发生异常', '2019-07-28 14:48:53');
INSERT INTO `access_log` VALUES (60021, '65.50.15643032994983421', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '183.131.110.63', '2019-07-28 16:41:39', 0, 1002001015, '账号未登陆', '2019-07-28 16:41:39');
INSERT INTO `access_log` VALUES (60022, '65.45.15643032994983429', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '183.131.110.63', '2019-07-28 16:41:39', 0, 1002001015, '账号未登陆', '2019-07-28 16:41:39');
INSERT INTO `access_log` VALUES (60023, '65.53.15643032994983423', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '183.131.110.63', '2019-07-28 16:41:39', 0, 1002001015, '账号未登陆', '2019-07-28 16:41:39');
INSERT INTO `access_log` VALUES (60024, '65.52.15643033023433459', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '183.131.110.63', '2019-07-28 16:41:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-28 16:41:42');
INSERT INTO `access_log` VALUES (60025, '65.54.15643033257033351', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudanyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '183.131.110.63', '2019-07-28 16:42:06', 4, 1002002000, '账号不存在', '2019-07-28 16:42:06');
INSERT INTO `access_log` VALUES (60026, '65.45.15643060818363467', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.115.229.58', '2019-07-28 17:28:02', 0, 1002001015, '账号未登陆', '2019-07-28 17:28:02');
INSERT INTO `access_log` VALUES (60027, '65.53.15643060818373461', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.115.229.58', '2019-07-28 17:28:02', 0, 1002001015, '账号未登陆', '2019-07-28 17:28:02');
INSERT INTO `access_log` VALUES (60028, '65.50.15643060818403459', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.115.229.58', '2019-07-28 17:28:02', 0, 1002001015, '账号未登陆', '2019-07-28 17:28:02');
INSERT INTO `access_log` VALUES (60029, '65.52.15643060855943497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.115.229.58', '2019-07-28 17:28:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-28 17:28:06');
INSERT INTO `access_log` VALUES (60030, '65.3607.15643061055995259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.115.229.58', '2019-07-28 17:28:26', 111, 0, '', '2019-07-28 17:28:26');
INSERT INTO `access_log` VALUES (60031, '65.47.15643061089163457', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '123.115.229.58', '2019-07-28 17:28:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-28 17:28:29');
INSERT INTO `access_log` VALUES (60032, '65.51.15643061184723531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '123.115.229.58', '2019-07-28 17:28:38', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-28 17:28:38');
INSERT INTO `access_log` VALUES (60033, '65.45.15643061190743469', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '123.115.229.58', '2019-07-28 17:28:39', 0, 1002001015, '账号未登陆', '2019-07-28 17:28:39');
INSERT INTO `access_log` VALUES (60034, '65.53.15643061190743463', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '123.115.229.58', '2019-07-28 17:28:39', 0, 1002001015, '账号未登陆', '2019-07-28 17:28:39');
INSERT INTO `access_log` VALUES (60035, '65.50.15643061190813461', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '123.115.229.58', '2019-07-28 17:28:39', 0, 1002001015, '账号未登陆', '2019-07-28 17:28:39');
INSERT INTO `access_log` VALUES (60036, '65.52.15643061236383499', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '123.115.229.58', '2019-07-28 17:28:44', 60, 0, '', '2019-07-28 17:28:44');
INSERT INTO `access_log` VALUES (60037, '65.46.15643061241513537', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '123.115.229.58', '2019-07-28 17:28:44', 15, 0, '', '2019-07-28 17:28:44');
INSERT INTO `access_log` VALUES (60038, '65.54.15643061241553391', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '123.115.229.58', '2019-07-28 17:28:44', 13, 2001001000, '服务端发生异常', '2019-07-28 17:28:44');
INSERT INTO `access_log` VALUES (60039, '65.3607.15643061241625261', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '123.115.229.58', '2019-07-28 17:28:44', 10, 0, '', '2019-07-28 17:28:44');
INSERT INTO `access_log` VALUES (60040, '65.47.15643061315963459', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '123.115.229.58', '2019-07-28 17:28:52', 11, 0, '', '2019-07-28 17:28:52');
INSERT INTO `access_log` VALUES (60041, '65.51.15643061316043533', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '123.115.229.58', '2019-07-28 17:28:52', 9, 2001001000, '服务端发生异常', '2019-07-28 17:28:52');
INSERT INTO `access_log` VALUES (60042, '65.49.15643061316353443', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '123.115.229.58', '2019-07-28 17:28:52', 10, 0, '', '2019-07-28 17:28:52');
INSERT INTO `access_log` VALUES (60043, '59.75.15643074301511095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '49.80.252.162', '2019-07-28 17:50:30', 11, 0, '', '2019-07-28 17:50:30');
INSERT INTO `access_log` VALUES (60044, '59.73.15643074301511091', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '49.80.252.162', '2019-07-28 17:50:30', 26, 2001001000, '服务端发生异常', '2019-07-28 17:50:30');
INSERT INTO `access_log` VALUES (60045, '65.49.15643074402493461', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '49.80.252.162', '2019-07-28 17:50:40', 1, 1002001015, '账号未登陆', '2019-07-28 17:50:40');
INSERT INTO `access_log` VALUES (60046, '65.51.15643074402543551', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '49.80.252.162', '2019-07-28 17:50:40', 1, 1002001015, '账号未登陆', '2019-07-28 17:50:40');
INSERT INTO `access_log` VALUES (60047, '65.45.15643074402563489', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '49.80.252.162', '2019-07-28 17:50:40', 0, 1002001015, '账号未登陆', '2019-07-28 17:50:40');
INSERT INTO `access_log` VALUES (60048, '65.53.15643074432483483', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '49.80.252.162', '2019-07-28 17:50:43', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-28 17:50:43');
INSERT INTO `access_log` VALUES (60049, '59.79.15643074902941095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.89.239.216', '2019-07-28 17:51:30', 4, 0, '', '2019-07-28 17:51:30');
INSERT INTO `access_log` VALUES (60050, '65.3607.15643075002155281', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.207.186', '2019-07-28 17:51:40', 1, 1002001015, '账号未登陆', '2019-07-28 17:51:40');
INSERT INTO `access_log` VALUES (60051, '65.46.15643223239773755', 0, 2, 'admin-application', '/admin-api/admins/resource/add', 'permissions=&displayName=商品管理&pid=1&sort=1&type=1&handler=/order/list&icon=add', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '221.232.181.151', '2019-07-28 21:58:44', 0, 1002001015, '账号未登陆', '2019-07-28 21:58:44');
INSERT INTO `access_log` VALUES (60052, '59.71.15643245788901313', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.86.117.36', '2019-07-28 22:36:19', 10, 0, '', '2019-07-28 22:36:19');
INSERT INTO `access_log` VALUES (60053, '59.76.15643245788901307', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.86.117.36', '2019-07-28 22:36:19', 27, 2001001000, '服务端发生异常', '2019-07-28 22:36:19');
INSERT INTO `access_log` VALUES (60054, '64.85.15643245812271623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.86.117.36', '2019-07-28 22:36:21', 16, 0, '', '2019-07-28 22:36:21');
INSERT INTO `access_log` VALUES (60055, '64.76.15643245813491581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.86.117.36', '2019-07-28 22:36:21', 3, 0, '', '2019-07-28 22:36:21');
INSERT INTO `access_log` VALUES (60056, '64.83.15643245823111583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.86.117.36', '2019-07-28 22:36:22', 2, 0, '', '2019-07-28 22:36:22');
INSERT INTO `access_log` VALUES (60057, '64.80.15643245828381595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.86.117.36', '2019-07-28 22:36:23', 2, 0, '', '2019-07-28 22:36:23');
INSERT INTO `access_log` VALUES (60058, '59.75.15643245836891325', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.86.117.36', '2019-07-28 22:36:24', 3, 0, '', '2019-07-28 22:36:24');
INSERT INTO `access_log` VALUES (60059, '59.73.15643245836891321', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.86.117.36', '2019-07-28 22:36:24', 16, 2001001000, '服务端发生异常', '2019-07-28 22:36:24');
INSERT INTO `access_log` VALUES (60060, '59.77.15643246186131309', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:36:59', 2, 0, '', '2019-07-28 22:36:59');
INSERT INTO `access_log` VALUES (60061, '59.78.15643246186151323', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:36:59', 16, 2001001000, '服务端发生异常', '2019-07-28 22:36:59');
INSERT INTO `access_log` VALUES (60062, '64.77.15643246217581577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:02', 2, 0, '', '2019-07-28 22:37:02');
INSERT INTO `access_log` VALUES (60063, '64.78.15643246218381593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:02', 2, 0, '', '2019-07-28 22:37:02');
INSERT INTO `access_log` VALUES (60064, '64.82.15643246234361601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:03', 2, 0, '', '2019-07-28 22:37:03');
INSERT INTO `access_log` VALUES (60065, '64.84.15643246243131577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:04', 1, 0, '', '2019-07-28 22:37:04');
INSERT INTO `access_log` VALUES (60066, '64.85.15643246253101625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:05', 1, 0, '', '2019-07-28 22:37:05');
INSERT INTO `access_log` VALUES (60067, '64.83.15643246259951585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:06', 2, 0, '', '2019-07-28 22:37:06');
INSERT INTO `access_log` VALUES (60068, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:06', 7, 0, '', '2019-07-28 22:37:06');
INSERT INTO `access_log` VALUES (60069, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:08', 5, 0, '', '2019-07-28 22:37:08');
INSERT INTO `access_log` VALUES (60070, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:09', 6, 0, '', '2019-07-28 22:37:09');
INSERT INTO `access_log` VALUES (60071, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:10', 7, 0, '', '2019-07-28 22:37:10');
INSERT INTO `access_log` VALUES (60072, '64.80.15643246335941597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:14', 2, 0, '', '2019-07-28 22:37:14');
INSERT INTO `access_log` VALUES (60073, '64.81.15643246336671589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:14', 2, 0, '', '2019-07-28 22:37:14');
INSERT INTO `access_log` VALUES (60074, '64.79.15643246346481591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:15', 2, 0, '', '2019-07-28 22:37:15');
INSERT INTO `access_log` VALUES (60075, '64.77.15643246360771579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:16', 1, 0, '', '2019-07-28 22:37:16');
INSERT INTO `access_log` VALUES (60076, '64.78.15643246366211595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:17', 2, 0, '', '2019-07-28 22:37:17');
INSERT INTO `access_log` VALUES (60077, '64.82.15643246373911603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:17', 2, 0, '', '2019-07-28 22:37:17');
INSERT INTO `access_log` VALUES (60078, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:17', 6, 0, '', '2019-07-28 22:37:17');
INSERT INTO `access_log` VALUES (60079, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:21', 5, 0, '', '2019-07-28 22:37:21');
INSERT INTO `access_log` VALUES (60080, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:22', 5, 0, '', '2019-07-28 22:37:22');
INSERT INTO `access_log` VALUES (60081, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:22', 5, 0, '', '2019-07-28 22:37:22');
INSERT INTO `access_log` VALUES (60082, '64.85.15643246454901627', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:25', 9, 0, '', '2019-07-28 22:37:26');
INSERT INTO `access_log` VALUES (60083, '59.72.15643246619781313', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:42', 2, 0, '', '2019-07-28 22:37:42');
INSERT INTO `access_log` VALUES (60084, '59.73.15643246619781323', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:42', 16, 2001001000, '服务端发生异常', '2019-07-28 22:37:42');
INSERT INTO `access_log` VALUES (60085, '59.75.15643246646661327', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:45', 3, 0, '', '2019-07-28 22:37:45');
INSERT INTO `access_log` VALUES (60086, '59.74.15643246646661331', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:45', 26, 2001001000, '服务端发生异常', '2019-07-28 22:37:45');
INSERT INTO `access_log` VALUES (60087, '59.77.15643246748771311', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:55', 2, 0, '', '2019-07-28 22:37:55');
INSERT INTO `access_log` VALUES (60088, '59.78.15643246748771325', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '114.86.117.36', '2019-07-28 22:37:55', 13, 2001001000, '服务端发生异常', '2019-07-28 22:37:55');
INSERT INTO `access_log` VALUES (60089, '65.47.15643265068133735', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:08:27', 0, 1002001015, '账号未登陆', '2019-07-28 23:08:27');
INSERT INTO `access_log` VALUES (60090, '65.46.15643265068133811', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:08:27', 1, 1002001015, '账号未登陆', '2019-07-28 23:08:27');
INSERT INTO `access_log` VALUES (60091, '65.51.15643265068133809', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:08:27', 1, 1002001015, '账号未登陆', '2019-07-28 23:08:27');
INSERT INTO `access_log` VALUES (60092, '65.52.15643265094623775', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:08:29', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-28 23:08:29');
INSERT INTO `access_log` VALUES (60093, '65.45.15643265182193747', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:08:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-28 23:08:38');
INSERT INTO `access_log` VALUES (60094, '65.49.15643265521933721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:09:12', 260, 0, '', '2019-07-28 23:09:12');
INSERT INTO `access_log` VALUES (60095, '65.54.15643265557943665', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:09:16', 11, 0, '', '2019-07-28 23:09:16');
INSERT INTO `access_log` VALUES (60096, '65.51.15643265557993811', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:09:16', 11, 2001001000, '服务端发生异常', '2019-07-28 23:09:16');
INSERT INTO `access_log` VALUES (60097, '65.47.15643265558013737', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:09:16', 11, 0, '', '2019-07-28 23:09:16');
INSERT INTO `access_log` VALUES (60098, '65.52.15643265769413777', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:09:37', 11, 0, '', '2019-07-28 23:09:37');
INSERT INTO `access_log` VALUES (60099, '65.45.15643265769463749', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:09:37', 11, 2001001000, '服务端发生异常', '2019-07-28 23:09:37');
INSERT INTO `access_log` VALUES (60100, '65.50.15643265769563741', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:09:37', 9, 0, '', '2019-07-28 23:09:37');
INSERT INTO `access_log` VALUES (60101, '65.49.15643265949053723', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:09:55', 17, 0, '', '2019-07-28 23:09:55');
INSERT INTO `access_log` VALUES (60102, '65.51.15643265949153813', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:09:55', 10, 2001001000, '服务端发生异常', '2019-07-28 23:09:55');
INSERT INTO `access_log` VALUES (60103, '65.54.15643265949183667', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:09:55', 8, 0, '', '2019-07-28 23:09:55');
INSERT INTO `access_log` VALUES (60104, '65.47.15643266014433739', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:10:01', 8, 0, '', '2019-07-28 23:10:01');
INSERT INTO `access_log` VALUES (60105, '65.46.15643266014453815', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:10:01', 10, 2001001000, '服务端发生异常', '2019-07-28 23:10:01');
INSERT INTO `access_log` VALUES (60106, '65.45.15643266014563751', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:10:01', 8, 0, '', '2019-07-28 23:10:01');
INSERT INTO `access_log` VALUES (60107, '65.52.15643266044333779', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:10:04', 9, 0, '', '2019-07-28 23:10:04');
INSERT INTO `access_log` VALUES (60108, '65.50.15643266044363743', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:10:04', 10, 2001001000, '服务端发生异常', '2019-07-28 23:10:04');
INSERT INTO `access_log` VALUES (60109, '65.53.15643266044393743', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.236.51', '2019-07-28 23:10:04', 9, 0, '', '2019-07-28 23:10:04');
INSERT INTO `access_log` VALUES (60110, '65.46.15643275769573829', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.10.65.161', '2019-07-28 23:26:17', 4, 1002001012, '访问令牌已过期', '2019-07-28 23:26:17');
INSERT INTO `access_log` VALUES (60111, '65.45.15643275769613765', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.10.65.161', '2019-07-28 23:26:17', 3, 1002001012, '访问令牌已过期', '2019-07-28 23:26:17');
INSERT INTO `access_log` VALUES (60112, '65.50.15643275769683757', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.10.65.161', '2019-07-28 23:26:17', 3, 1002001012, '访问令牌已过期', '2019-07-28 23:26:17');
INSERT INTO `access_log` VALUES (60113, '65.53.15643275867303757', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.10.65.161', '2019-07-28 23:26:27', 70, 0, '', '2019-07-28 23:26:27');
INSERT INTO `access_log` VALUES (60114, '65.3607.15643275870855553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.10.65.161', '2019-07-28 23:26:27', 9, 0, '', '2019-07-28 23:26:27');
INSERT INTO `access_log` VALUES (60115, '65.54.15643275870933683', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.10.65.161', '2019-07-28 23:26:27', 10, 2001001000, '服务端发生异常', '2019-07-28 23:26:27');
INSERT INTO `access_log` VALUES (60116, '65.49.15643275870983739', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '112.10.65.161', '2019-07-28 23:26:27', 8, 0, '', '2019-07-28 23:26:27');
INSERT INTO `access_log` VALUES (60117, '59.71.15643570799041749', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.9.96.85', '2019-07-29 07:38:00', 14, 0, '', '2019-07-29 07:38:00');
INSERT INTO `access_log` VALUES (60118, '59.75.15643570799001761', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.9.96.85', '2019-07-29 07:38:00', 31, 2001001000, '服务端发生异常', '2019-07-29 07:38:00');
INSERT INTO `access_log` VALUES (60119, '59.78.15643570910141759', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.9.96.85', '2019-07-29 07:38:11', 3, 0, '', '2019-07-29 07:38:11');
INSERT INTO `access_log` VALUES (60120, '59.80.15643570910151731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.9.96.85', '2019-07-29 07:38:11', 20, 2001001000, '服务端发生异常', '2019-07-29 07:38:11');
INSERT INTO `access_log` VALUES (60121, '64.76.15643571143702019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.9.96.85', '2019-07-29 07:38:34', 12, 0, '', '2019-07-29 07:38:34');
INSERT INTO `access_log` VALUES (60122, '64.81.15643571151742023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.9.96.85', '2019-07-29 07:38:35', 3, 0, '', '2019-07-29 07:38:35');
INSERT INTO `access_log` VALUES (60123, '64.82.15643571166232039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.9.96.85', '2019-07-29 07:38:37', 2, 0, '', '2019-07-29 07:38:37');
INSERT INTO `access_log` VALUES (60124, '64.84.15643571182782013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.9.96.85', '2019-07-29 07:38:38', 1, 0, '', '2019-07-29 07:38:38');
INSERT INTO `access_log` VALUES (60125, '64.85.15643571185032063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.9.96.85', '2019-07-29 07:38:39', 2, 0, '', '2019-07-29 07:38:39');
INSERT INTO `access_log` VALUES (60126, '64.79.15643571272282025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.9.96.85', '2019-07-29 07:38:47', 3, 0, '', '2019-07-29 07:38:47');
INSERT INTO `access_log` VALUES (60127, '64.78.15643571297782031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.9.96.85', '2019-07-29 07:38:50', 2, 0, '', '2019-07-29 07:38:50');
INSERT INTO `access_log` VALUES (60128, '64.83.15643571297782021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.9.96.85', '2019-07-29 07:38:50', 2, 0, '', '2019-07-29 07:38:50');
INSERT INTO `access_log` VALUES (60129, '59.72.15643571303081749', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.9.96.85', '2019-07-29 07:38:50', 2, 0, '', '2019-07-29 07:38:50');
INSERT INTO `access_log` VALUES (60130, '59.73.15643571303101757', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.9.96.85', '2019-07-29 07:38:50', 17, 2001001000, '服务端发生异常', '2019-07-29 07:38:50');
INSERT INTO `access_log` VALUES (60131, '64.76.15643571386202021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.9.96.85', '2019-07-29 07:38:59', 5, 0, '', '2019-07-29 07:38:59');
INSERT INTO `access_log` VALUES (60132, '64.81.15643571390172025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.9.96.85', '2019-07-29 07:38:59', 3, 0, '', '2019-07-29 07:38:59');
INSERT INTO `access_log` VALUES (60133, '65.46.15643623391604293', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.189.22', '2019-07-29 09:05:39', 1, 1002001015, '账号未登陆', '2019-07-29 09:05:39');
INSERT INTO `access_log` VALUES (60134, '65.53.15643623391654223', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.189.22', '2019-07-29 09:05:39', 0, 1002001015, '账号未登陆', '2019-07-29 09:05:39');
INSERT INTO `access_log` VALUES (60135, '65.51.15643623391654293', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.189.22', '2019-07-29 09:05:39', 0, 1002001015, '账号未登陆', '2019-07-29 09:05:39');
INSERT INTO `access_log` VALUES (60136, '65.3607.15643623475806019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.189.22', '2019-07-29 09:05:48', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 09:05:48');
INSERT INTO `access_log` VALUES (60137, '65.47.15643623531084219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.189.22', '2019-07-29 09:05:53', 75, 0, '', '2019-07-29 09:05:53');
INSERT INTO `access_log` VALUES (60138, '65.49.15643623534664205', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.189.22', '2019-07-29 09:05:53', 19, 0, '', '2019-07-29 09:05:53');
INSERT INTO `access_log` VALUES (60139, '65.54.15643623534714149', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.189.22', '2019-07-29 09:05:53', 15, 2001001000, '服务端发生异常', '2019-07-29 09:05:53');
INSERT INTO `access_log` VALUES (60140, '65.50.15643623534754223', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.189.22', '2019-07-29 09:05:53', 14, 0, '', '2019-07-29 09:05:53');
INSERT INTO `access_log` VALUES (60141, '65.45.15643623591204233', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.189.22', '2019-07-29 09:05:59', 18, 0, '', '2019-07-29 09:05:59');
INSERT INTO `access_log` VALUES (60142, '65.46.15643623591234295', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.189.22', '2019-07-29 09:05:59', 17, 2001001000, '服务端发生异常', '2019-07-29 09:05:59');
INSERT INTO `access_log` VALUES (60143, '65.51.15643623591334295', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.71.189.22', '2019-07-29 09:05:59', 10, 0, '', '2019-07-29 09:05:59');
INSERT INTO `access_log` VALUES (60144, '65.52.15643627455844265', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.15.88', '2019-07-29 09:12:26', 12, 1002001012, '访问令牌已过期', '2019-07-29 09:12:26');
INSERT INTO `access_log` VALUES (60145, '65.46.15643627455874301', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.15.88', '2019-07-29 09:12:26', 11, 1002001012, '访问令牌已过期', '2019-07-29 09:12:26');
INSERT INTO `access_log` VALUES (60146, '65.51.15643627455954301', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.15.88', '2019-07-29 09:12:26', 3, 1002001012, '访问令牌已过期', '2019-07-29 09:12:26');
INSERT INTO `access_log` VALUES (60147, '65.49.15643632541124219', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.163.9.243', '2019-07-29 09:20:54', 0, 1002001015, '账号未登陆', '2019-07-29 09:20:54');
INSERT INTO `access_log` VALUES (60148, '65.50.15643632541144237', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.163.9.243', '2019-07-29 09:20:54', 1, 1002001015, '账号未登陆', '2019-07-29 09:20:54');
INSERT INTO `access_log` VALUES (60149, '65.54.15643632541154163', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.163.9.243', '2019-07-29 09:20:54', 0, 1002001015, '账号未登陆', '2019-07-29 09:20:54');
INSERT INTO `access_log` VALUES (60150, '65.46.15643632710244309', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.163.9.243', '2019-07-29 09:21:11', 209, 0, '', '2019-07-29 09:21:11');
INSERT INTO `access_log` VALUES (60151, '65.51.15643632715184309', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.163.9.243', '2019-07-29 09:21:12', 10, 0, '', '2019-07-29 09:21:12');
INSERT INTO `access_log` VALUES (60152, '65.45.15643632715194247', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.163.9.243', '2019-07-29 09:21:12', 10, 2001001000, '服务端发生异常', '2019-07-29 09:21:12');
INSERT INTO `access_log` VALUES (60153, '65.53.15643632715224239', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.163.9.243', '2019-07-29 09:21:12', 9, 0, '', '2019-07-29 09:21:12');
INSERT INTO `access_log` VALUES (60154, '59.78.15643634777471845', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.163.9.243', '2019-07-29 09:24:38', 10, 0, '', '2019-07-29 09:24:38');
INSERT INTO `access_log` VALUES (60155, '59.80.15643634777471817', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.163.9.243', '2019-07-29 09:24:38', 18, 2001001000, '服务端发生异常', '2019-07-29 09:24:38');
INSERT INTO `access_log` VALUES (60156, '64.79.15643634930572111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:24:53', 14, 0, '', '2019-07-29 09:24:53');
INSERT INTO `access_log` VALUES (60157, '64.78.15643634932112117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:24:53', 4, 0, '', '2019-07-29 09:24:53');
INSERT INTO `access_log` VALUES (60158, '64.83.15643634959912107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:24:56', 2, 0, '', '2019-07-29 09:24:56');
INSERT INTO `access_log` VALUES (60159, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:24:56', 6, 0, '', '2019-07-29 09:24:56');
INSERT INTO `access_log` VALUES (60160, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:24:59', 6, 0, '', '2019-07-29 09:24:59');
INSERT INTO `access_log` VALUES (60161, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:01', 5, 0, '', '2019-07-29 09:25:01');
INSERT INTO `access_log` VALUES (60162, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:02', 6, 0, '', '2019-07-29 09:25:02');
INSERT INTO `access_log` VALUES (60163, '64.80.15643635021682119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:02', 2, 0, '', '2019-07-29 09:25:02');
INSERT INTO `access_log` VALUES (60164, '64.76.15643635023052107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:02', 1, 0, '', '2019-07-29 09:25:02');
INSERT INTO `access_log` VALUES (60165, '64.81.15643635041412111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:04', 2, 0, '', '2019-07-29 09:25:04');
INSERT INTO `access_log` VALUES (60166, '64.82.15643635056862127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:06', 2, 0, '', '2019-07-29 09:25:06');
INSERT INTO `access_log` VALUES (60167, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:06', 12, 0, '', '2019-07-29 09:25:06');
INSERT INTO `access_log` VALUES (60168, '64.84.15643635073812101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:07', 2, 0, '', '2019-07-29 09:25:07');
INSERT INTO `access_log` VALUES (60169, '64.85.15643635075262151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:08', 2, 0, '', '2019-07-29 09:25:08');
INSERT INTO `access_log` VALUES (60170, '64.79.15643635140462113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:14', 2, 0, '', '2019-07-29 09:25:14');
INSERT INTO `access_log` VALUES (60171, '64.78.15643635141772119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:14', 2, 0, '', '2019-07-29 09:25:14');
INSERT INTO `access_log` VALUES (60172, '59.77.15643635158371829', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:16', 3, 0, '', '2019-07-29 09:25:16');
INSERT INTO `access_log` VALUES (60173, '59.72.15643635158371835', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:16', 14, 2001001000, '服务端发生异常', '2019-07-29 09:25:16');
INSERT INTO `access_log` VALUES (60174, '64.80.15643635213332121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:21', 2, 0, '', '2019-07-29 09:25:21');
INSERT INTO `access_log` VALUES (60175, '64.76.15643635214862109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:21', 1, 0, '', '2019-07-29 09:25:21');
INSERT INTO `access_log` VALUES (60176, '59.71.15643635252521837', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:25', 2, 0, '', '2019-07-29 09:25:25');
INSERT INTO `access_log` VALUES (60177, '59.75.15643635252521849', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '220.163.9.243', '2019-07-29 09:25:25', 27, 2001001000, '服务端发生异常', '2019-07-29 09:25:25');
INSERT INTO `access_log` VALUES (60178, '59.79.15643635556851847', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.163.9.243', '2019-07-29 09:25:56', 2, 0, '', '2019-07-29 09:25:56');
INSERT INTO `access_log` VALUES (60179, '59.78.15643635556851847', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.163.9.243', '2019-07-29 09:25:56', 13, 2001001000, '服务端发生异常', '2019-07-29 09:25:56');
INSERT INTO `access_log` VALUES (60180, '64.82.15643635581722129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.163.9.243', '2019-07-29 09:25:58', 2, 0, '', '2019-07-29 09:25:58');
INSERT INTO `access_log` VALUES (60181, '64.84.15643635582952103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.163.9.243', '2019-07-29 09:25:58', 2, 0, '', '2019-07-29 09:25:58');
INSERT INTO `access_log` VALUES (60182, '59.79.15643660745541881', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.167.203.2', '2019-07-29 10:07:55', 10, 0, '', '2019-07-29 10:07:55');
INSERT INTO `access_log` VALUES (60183, '59.78.15643660745541881', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.167.203.2', '2019-07-29 10:07:55', 33, 2001001000, '服务端发生异常', '2019-07-29 10:07:55');
INSERT INTO `access_log` VALUES (60184, '64.84.15643660916782137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.167.203.2', '2019-07-29 10:08:12', 11, 0, '', '2019-07-29 10:08:12');
INSERT INTO `access_log` VALUES (60185, '64.85.15643660917792187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.167.203.2', '2019-07-29 10:08:12', 2, 0, '', '2019-07-29 10:08:12');
INSERT INTO `access_log` VALUES (60186, '64.79.15643660932152149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.167.203.2', '2019-07-29 10:08:13', 2, 0, '', '2019-07-29 10:08:13');
INSERT INTO `access_log` VALUES (60187, '64.78.15643660937592155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.167.203.2', '2019-07-29 10:08:14', 2, 0, '', '2019-07-29 10:08:14');
INSERT INTO `access_log` VALUES (60188, '64.80.15643661023832157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.167.203.2', '2019-07-29 10:08:22', 2, 0, '', '2019-07-29 10:08:22');
INSERT INTO `access_log` VALUES (60189, '64.76.15643661025152145', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.167.203.2', '2019-07-29 10:08:23', 2, 0, '', '2019-07-29 10:08:23');
INSERT INTO `access_log` VALUES (60190, '59.72.15643661033411871', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.167.203.2', '2019-07-29 10:08:23', 3, 0, '', '2019-07-29 10:08:23');
INSERT INTO `access_log` VALUES (60191, '59.73.15643661033421879', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.167.203.2', '2019-07-29 10:08:23', 13, 2001001000, '服务端发生异常', '2019-07-29 10:08:23');
INSERT INTO `access_log` VALUES (60192, '65.54.15643676901774223', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.2.224.6', '2019-07-29 10:34:50', 1, 1002001015, '账号未登陆', '2019-07-29 10:34:50');
INSERT INTO `access_log` VALUES (60193, '65.46.15643676901794369', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.2.224.6', '2019-07-29 10:34:50', 0, 1002001015, '账号未登陆', '2019-07-29 10:34:50');
INSERT INTO `access_log` VALUES (60194, '65.52.15643676901774333', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.2.224.6', '2019-07-29 10:34:50', 1, 1002001015, '账号未登陆', '2019-07-29 10:34:50');
INSERT INTO `access_log` VALUES (60195, '65.51.15643676927034369', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.2.224.6', '2019-07-29 10:34:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 10:34:53');
INSERT INTO `access_log` VALUES (60196, '65.53.15643676960444299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.2.224.6', '2019-07-29 10:34:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 10:34:56');
INSERT INTO `access_log` VALUES (60197, '65.47.15643677147834295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.2.224.6', '2019-07-29 10:35:15', 81, 0, '', '2019-07-29 10:35:15');
INSERT INTO `access_log` VALUES (60198, '65.50.15643677152604299', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.2.224.6', '2019-07-29 10:35:15', 13, 0, '', '2019-07-29 10:35:15');
INSERT INTO `access_log` VALUES (60199, '65.49.15643677152654281', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.2.224.6', '2019-07-29 10:35:15', 12, 2001001000, '服务端发生异常', '2019-07-29 10:35:15');
INSERT INTO `access_log` VALUES (60200, '65.54.15643677152704225', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.2.224.6', '2019-07-29 10:35:15', 10, 0, '', '2019-07-29 10:35:15');
INSERT INTO `access_log` VALUES (60201, '65.46.15643677277774371', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.2.224.6', '2019-07-29 10:35:28', 10, 0, '', '2019-07-29 10:35:28');
INSERT INTO `access_log` VALUES (60202, '65.51.15643677277804371', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.2.224.6', '2019-07-29 10:35:28', 9, 2001001000, '服务端发生异常', '2019-07-29 10:35:28');
INSERT INTO `access_log` VALUES (60203, '65.45.15643677277884309', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.2.224.6', '2019-07-29 10:35:28', 9, 0, '', '2019-07-29 10:35:28');
INSERT INTO `access_log` VALUES (60204, '59.73.15643696789561927', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:07:59', 9, 0, '', '2019-07-29 11:07:59');
INSERT INTO `access_log` VALUES (60205, '59.72.15643696789561919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:07:59', 18, 2001001000, '服务端发生异常', '2019-07-29 11:07:59');
INSERT INTO `access_log` VALUES (60206, '64.76.15643696856642193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:08:06', 12, 0, '', '2019-07-29 11:08:06');
INSERT INTO `access_log` VALUES (60207, '64.81.15643696857812197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:08:06', 3, 0, '', '2019-07-29 11:08:06');
INSERT INTO `access_log` VALUES (60208, '59.75.15643696871771933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:08:07', 3, 0, '', '2019-07-29 11:08:07');
INSERT INTO `access_log` VALUES (60209, '59.74.15643696871781937', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:08:07', 14, 2001001000, '服务端发生异常', '2019-07-29 11:08:07');
INSERT INTO `access_log` VALUES (60210, '59.80.15643696934911903', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:08:13', 3, 0, '', '2019-07-29 11:08:13');
INSERT INTO `access_log` VALUES (60211, '59.79.15643696934921931', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:08:13', 13, 2001001000, '服务端发生异常', '2019-07-29 11:08:14');
INSERT INTO `access_log` VALUES (60212, '65.49.15643697130894309', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:08:33', 0, 1002001015, '账号未登陆', '2019-07-29 11:08:33');
INSERT INTO `access_log` VALUES (60213, '65.47.15643697130894323', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:08:33', 0, 1002001015, '账号未登陆', '2019-07-29 11:08:33');
INSERT INTO `access_log` VALUES (60214, '65.54.15643697130904253', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:08:33', 1, 1002001015, '账号未登陆', '2019-07-29 11:08:33');
INSERT INTO `access_log` VALUES (60215, '59.71.15643697678981923', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', '106.38.115.25', '2019-07-29 11:09:28', 3, 0, '', '2019-07-29 11:09:28');
INSERT INTO `access_log` VALUES (60216, '59.75.15643697678981935', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', '106.38.115.25', '2019-07-29 11:09:28', 12, 2001001000, '服务端发生异常', '2019-07-29 11:09:28');
INSERT INTO `access_log` VALUES (60217, '65.45.15643697682644337', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:09:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 11:09:28');
INSERT INTO `access_log` VALUES (60218, '65.53.15643697695914329', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', '106.38.115.25', '2019-07-29 11:09:30', 1, 1002001015, '账号未登陆', '2019-07-29 11:09:30');
INSERT INTO `access_log` VALUES (60219, '65.3607.15643697695966125', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', '106.38.115.25', '2019-07-29 11:09:30', 1, 1002001015, '账号未登陆', '2019-07-29 11:09:30');
INSERT INTO `access_log` VALUES (60220, '65.47.15643697695994325', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', '106.38.115.25', '2019-07-29 11:09:30', 1, 1002001015, '账号未登陆', '2019-07-29 11:09:30');
INSERT INTO `access_log` VALUES (60221, '65.54.15643697795174255', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:09:40', 325, 0, '', '2019-07-29 11:09:40');
INSERT INTO `access_log` VALUES (60222, '65.50.15643697801394329', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:09:40', 12, 0, '', '2019-07-29 11:09:40');
INSERT INTO `access_log` VALUES (60223, '65.52.15643697801414365', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:09:40', 10, 2001001000, '服务端发生异常', '2019-07-29 11:09:40');
INSERT INTO `access_log` VALUES (60224, '65.46.15643697801804401', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '61.186.159.230', '2019-07-29 11:09:40', 10, 0, '', '2019-07-29 11:09:40');
INSERT INTO `access_log` VALUES (60225, '65.52.15643698890844367', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36', '106.38.115.25', '2019-07-29 11:11:29', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 11:11:29');
INSERT INTO `access_log` VALUES (60226, '59.72.15643707498151935', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:25:50', 3, 0, '', '2019-07-29 11:25:50');
INSERT INTO `access_log` VALUES (60227, '59.73.15643707498161943', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:25:50', 13, 2001001000, '服务端发生异常', '2019-07-29 11:25:50');
INSERT INTO `access_log` VALUES (60228, '64.82.15643707562842227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:25:56', 2, 0, '', '2019-07-29 11:25:56');
INSERT INTO `access_log` VALUES (60229, '64.84.15643707564192201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:25:56', 2, 0, '', '2019-07-29 11:25:56');
INSERT INTO `access_log` VALUES (60230, '64.85.15643707597542251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:26:00', 1, 0, '', '2019-07-29 11:26:00');
INSERT INTO `access_log` VALUES (60231, '64.79.15643707605432213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:26:01', 2, 0, '', '2019-07-29 11:26:01');
INSERT INTO `access_log` VALUES (60232, '59.75.15643707626391949', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:26:03', 2, 0, '', '2019-07-29 11:26:03');
INSERT INTO `access_log` VALUES (60233, '59.71.15643707626401937', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:26:03', 16, 2001001000, '服务端发生异常', '2019-07-29 11:26:03');
INSERT INTO `access_log` VALUES (60234, '65.46.15643707742974415', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:26:14', 1, 1002001015, '账号未登陆', '2019-07-29 11:26:14');
INSERT INTO `access_log` VALUES (60235, '65.52.15643707742964379', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:26:14', 0, 1002001015, '账号未登陆', '2019-07-29 11:26:14');
INSERT INTO `access_log` VALUES (60236, '65.51.15643707743024415', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:26:14', 0, 1002001015, '账号未登陆', '2019-07-29 11:26:14');
INSERT INTO `access_log` VALUES (60237, '65.45.15643707768614353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:26:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 11:26:17');
INSERT INTO `access_log` VALUES (60238, '65.47.15643707991994341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:26:39', 69, 0, '', '2019-07-29 11:26:39');
INSERT INTO `access_log` VALUES (60239, '65.49.15643707996104327', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:26:40', 11, 0, '', '2019-07-29 11:26:40');
INSERT INTO `access_log` VALUES (60240, '65.54.15643707996144269', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:26:40', 11, 2001001000, '服务端发生异常', '2019-07-29 11:26:40');
INSERT INTO `access_log` VALUES (60241, '65.50.15643707996194345', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:26:40', 10, 0, '', '2019-07-29 11:26:40');
INSERT INTO `access_log` VALUES (60242, '65.51.15643708325184417', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:27:13', 10, 0, '', '2019-07-29 11:27:13');
INSERT INTO `access_log` VALUES (60243, '65.45.15643708325214355', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:27:13', 10, 2001001000, '服务端发生异常', '2019-07-29 11:27:13');
INSERT INTO `access_log` VALUES (60244, '65.53.15643708325244347', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:27:13', 9, 0, '', '2019-07-29 11:27:13');
INSERT INTO `access_log` VALUES (60245, '65.3607.15643708368686143', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:27:17', 17, 0, '', '2019-07-29 11:27:17');
INSERT INTO `access_log` VALUES (60246, '65.47.15643708368714343', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:27:17', 16, 2001001000, '服务端发生异常', '2019-07-29 11:27:17');
INSERT INTO `access_log` VALUES (60247, '65.54.15643708368824271', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:27:17', 8, 0, '', '2019-07-29 11:27:17');
INSERT INTO `access_log` VALUES (60248, '65.49.15643708440734329', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:27:24', 7, 0, '', '2019-07-29 11:27:24');
INSERT INTO `access_log` VALUES (60249, '65.52.15643708440774383', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:27:24', 8, 2001001000, '服务端发生异常', '2019-07-29 11:27:24');
INSERT INTO `access_log` VALUES (60250, '65.46.15643708440804419', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:27:24', 8, 0, '', '2019-07-29 11:27:24');
INSERT INTO `access_log` VALUES (60251, '65.53.15643708879704349', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:28:08', 10, 0, '', '2019-07-29 11:28:08');
INSERT INTO `access_log` VALUES (60252, '65.3607.15643708879726145', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:28:08', 10, 2001001000, '服务端发生异常', '2019-07-29 11:28:08');
INSERT INTO `access_log` VALUES (60253, '65.47.15643708879804345', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:28:08', 8, 0, '', '2019-07-29 11:28:08');
INSERT INTO `access_log` VALUES (60254, '65.50.15643708982224349', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:28:18', 74, 0, '', '2019-07-29 11:28:18');
INSERT INTO `access_log` VALUES (60255, '65.49.15643708985314331', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:28:19', 16, 0, '', '2019-07-29 11:28:19');
INSERT INTO `access_log` VALUES (60256, '65.46.15643708985424421', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:28:19', 9, 0, '', '2019-07-29 11:28:19');
INSERT INTO `access_log` VALUES (60257, '65.52.15643708985404385', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.231.203', '2019-07-29 11:28:19', 9, 2001001000, '服务端发生异常', '2019-07-29 11:28:19');
INSERT INTO `access_log` VALUES (60258, '59.76.15643724665341953', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.146', '2019-07-29 11:54:27', 3, 0, '', '2019-07-29 11:54:27');
INSERT INTO `access_log` VALUES (60259, '59.77.15643724665381953', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.146', '2019-07-29 11:54:27', 46, 2001001000, '服务端发生异常', '2019-07-29 11:54:27');
INSERT INTO `access_log` VALUES (60260, '64.78.15643724695022243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.146', '2019-07-29 11:54:30', 3, 0, '', '2019-07-29 11:54:30');
INSERT INTO `access_log` VALUES (60261, '64.83.15643724696542231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.146', '2019-07-29 11:54:30', 2, 0, '', '2019-07-29 11:54:30');
INSERT INTO `access_log` VALUES (60262, '64.80.15643724707602245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.146', '2019-07-29 11:54:31', 1, 0, '', '2019-07-29 11:54:31');
INSERT INTO `access_log` VALUES (60263, '64.76.15643724712112233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.146', '2019-07-29 11:54:31', 1, 0, '', '2019-07-29 11:54:31');
INSERT INTO `access_log` VALUES (60264, '64.81.15643724716552237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.146', '2019-07-29 11:54:32', 2, 0, '', '2019-07-29 11:54:32');
INSERT INTO `access_log` VALUES (60265, '65.46.15643739942424463', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 12:19:54', 1, 1002001015, '账号未登陆', '2019-07-29 12:19:54');
INSERT INTO `access_log` VALUES (60266, '65.52.15643739948274427', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 12:19:55', 1, 1002001015, '账号未登陆', '2019-07-29 12:19:55');
INSERT INTO `access_log` VALUES (60267, '65.49.15643739949824373', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 12:19:55', 0, 1002001015, '账号未登陆', '2019-07-29 12:19:55');
INSERT INTO `access_log` VALUES (60268, '65.45.15643740000624401', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 12:20:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 12:20:00');
INSERT INTO `access_log` VALUES (60269, '65.3607.15643740215076189', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 12:20:22', 60, 0, '', '2019-07-29 12:20:22');
INSERT INTO `access_log` VALUES (60270, '65.47.15643740221344389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 12:20:22', 8, 0, '', '2019-07-29 12:20:22');
INSERT INTO `access_log` VALUES (60271, '65.53.15643740221764393', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 12:20:22', 9, 0, '', '2019-07-29 12:20:22');
INSERT INTO `access_log` VALUES (60272, '65.54.15643740222364317', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 12:20:22', 17, 2001001000, '服务端发生异常', '2019-07-29 12:20:22');
INSERT INTO `access_log` VALUES (60273, '65.50.15643749021964405', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3400.400', '221.219.247.36', '2019-07-29 12:35:02', 0, 1002001015, '账号未登陆', '2019-07-29 12:35:02');
INSERT INTO `access_log` VALUES (60274, '65.54.15643749021954329', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3400.400', '221.219.247.36', '2019-07-29 12:35:02', 0, 1002001015, '账号未登陆', '2019-07-29 12:35:02');
INSERT INTO `access_log` VALUES (60275, '65.46.15643749022044477', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3400.400', '221.219.247.36', '2019-07-29 12:35:02', 0, 1002001015, '账号未登陆', '2019-07-29 12:35:02');
INSERT INTO `access_log` VALUES (60276, '65.52.15643749040944441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3400.400', '221.219.247.36', '2019-07-29 12:35:04', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 12:35:04');
INSERT INTO `access_log` VALUES (60277, '65.45.15643749169474415', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3400.400', '221.219.247.36', '2019-07-29 12:35:17', 90, 0, '', '2019-07-29 12:35:17');
INSERT INTO `access_log` VALUES (60278, '65.51.15643749172684477', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3400.400', '221.219.247.36', '2019-07-29 12:35:17', 11, 0, '', '2019-07-29 12:35:17');
INSERT INTO `access_log` VALUES (60279, '65.3607.15643749172706203', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3400.400', '221.219.247.36', '2019-07-29 12:35:17', 11, 2001001000, '服务端发生异常', '2019-07-29 12:35:17');
INSERT INTO `access_log` VALUES (60280, '65.47.15643749172724403', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3400.400', '221.219.247.36', '2019-07-29 12:35:17', 9, 0, '', '2019-07-29 12:35:17');
INSERT INTO `access_log` VALUES (60281, '65.49.15643769646714417', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3400.400', '221.219.247.36', '2019-07-29 13:09:25', 28, 0, '', '2019-07-29 13:09:25');
INSERT INTO `access_log` VALUES (60282, '65.45.15643769646714443', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3400.400', '221.219.247.36', '2019-07-29 13:09:25', 34, 0, '', '2019-07-29 13:09:25');
INSERT INTO `access_log` VALUES (60283, '65.47.15643769646874433', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3400.400', '221.219.247.36', '2019-07-29 13:09:25', 18, 2001001000, '服务端发生异常', '2019-07-29 13:09:25');
INSERT INTO `access_log` VALUES (60284, '65.3607.15643769955466231', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3400.400', '221.219.247.36', '2019-07-29 13:09:56', 9, 0, '', '2019-07-29 13:09:56');
INSERT INTO `access_log` VALUES (60285, '65.54.15643769955654359', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3400.400', '221.219.247.36', '2019-07-29 13:09:56', 10, 2001001000, '服务端发生异常', '2019-07-29 13:09:56');
INSERT INTO `access_log` VALUES (60286, '65.50.15643769955704437', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3650.400 QQBrowser/10.4.3400.400', '221.219.247.36', '2019-07-29 13:09:56', 9, 0, '', '2019-07-29 13:09:56');
INSERT INTO `access_log` VALUES (60287, '59.79.15643789988222057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:43:19', 11, 0, '', '2019-07-29 13:43:19');
INSERT INTO `access_log` VALUES (60288, '59.80.15643789988222029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:43:19', 32, 2001001000, '服务端发生异常', '2019-07-29 13:43:19');
INSERT INTO `access_log` VALUES (60289, '64.85.15643790012782363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:43:21', 11, 0, '', '2019-07-29 13:43:21');
INSERT INTO `access_log` VALUES (60290, '64.79.15643790013522325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:43:21', 3, 0, '', '2019-07-29 13:43:21');
INSERT INTO `access_log` VALUES (60291, '64.78.15643790031712331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:43:23', 2, 0, '', '2019-07-29 13:43:23');
INSERT INTO `access_log` VALUES (60292, '64.83.15643790038282321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:43:24', 1, 0, '', '2019-07-29 13:43:24');
INSERT INTO `access_log` VALUES (60293, '64.80.15643790066822335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:43:27', 2, 0, '', '2019-07-29 13:43:27');
INSERT INTO `access_log` VALUES (60294, '64.76.15643790067502321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:43:27', 1, 0, '', '2019-07-29 13:43:27');
INSERT INTO `access_log` VALUES (60295, '59.77.15643790116442041', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:43:32', 4, 0, '', '2019-07-29 13:43:32');
INSERT INTO `access_log` VALUES (60296, '59.76.15643790116442041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:43:32', 20, 2001001000, '服务端发生异常', '2019-07-29 13:43:32');
INSERT INTO `access_log` VALUES (60297, '64.85.15643790753612365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:44:35', 3, 0, '', '2019-07-29 13:44:35');
INSERT INTO `access_log` VALUES (60298, '64.79.15643790754782327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:44:35', 2, 0, '', '2019-07-29 13:44:35');
INSERT INTO `access_log` VALUES (60299, '64.83.15643790768742323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:44:37', 2, 0, '', '2019-07-29 13:44:37');
INSERT INTO `access_log` VALUES (60300, '64.80.15643790773052337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:44:37', 2, 0, '', '2019-07-29 13:44:37');
INSERT INTO `access_log` VALUES (60301, '59.79.15643791033962059', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:45:03', 3, 0, '', '2019-07-29 13:45:03');
INSERT INTO `access_log` VALUES (60302, '59.78.15643791034012059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:45:03', 22, 2001001000, '服务端发生异常', '2019-07-29 13:45:03');
INSERT INTO `access_log` VALUES (60303, '64.80.15643792193582339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:46:59', 5, 0, '', '2019-07-29 13:46:59');
INSERT INTO `access_log` VALUES (60304, '64.76.15643792195222325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:00', 2, 0, '', '2019-07-29 13:47:00');
INSERT INTO `access_log` VALUES (60305, '64.81.15643792221562329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:02', 2, 0, '', '2019-07-29 13:47:02');
INSERT INTO `access_log` VALUES (60306, '64.77.15643792222492323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:02', 2, 0, '', '2019-07-29 13:47:02');
INSERT INTO `access_log` VALUES (60307, '64.84.15643792334032321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:13', 2, 0, '', '2019-07-29 13:47:13');
INSERT INTO `access_log` VALUES (60308, '64.85.15643792335102369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:14', 2, 0, '', '2019-07-29 13:47:14');
INSERT INTO `access_log` VALUES (60309, '59.78.15643792338102061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:14', 4, 0, '', '2019-07-29 13:47:14');
INSERT INTO `access_log` VALUES (60310, '59.76.15643792338142045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:14', 15, 2001001000, '服务端发生异常', '2019-07-29 13:47:14');
INSERT INTO `access_log` VALUES (60311, '64.78.15643792342542337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:14', 2, 0, '', '2019-07-29 13:47:14');
INSERT INTO `access_log` VALUES (60312, '64.79.15643792343722331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:14', 1, 0, '', '2019-07-29 13:47:14');
INSERT INTO `access_log` VALUES (60313, '59.77.15643792348242045', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:15', 2, 0, '', '2019-07-29 13:47:15');
INSERT INTO `access_log` VALUES (60314, '59.73.15643792348242059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:15', 13, 2001001000, '服务端发生异常', '2019-07-29 13:47:15');
INSERT INTO `access_log` VALUES (60315, '64.83.15643792353732327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:15', 2, 0, '', '2019-07-29 13:47:15');
INSERT INTO `access_log` VALUES (60316, '64.80.15643792354752341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:15', 2, 0, '', '2019-07-29 13:47:15');
INSERT INTO `access_log` VALUES (60317, '59.72.15643792356002051', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:16', 2, 0, '', '2019-07-29 13:47:16');
INSERT INTO `access_log` VALUES (60318, '59.75.15643792356072065', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3667.0 Safari/537.36', '116.226.45.158', '2019-07-29 13:47:16', 15, 2001001000, '服务端发生异常', '2019-07-29 13:47:16');
INSERT INTO `access_log` VALUES (60319, '65.49.15643795704084453', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.93.223.104', '2019-07-29 13:52:50', 0, 1002001015, '账号未登陆', '2019-07-29 13:52:50');
INSERT INTO `access_log` VALUES (60320, '65.52.15643795704074507', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.93.223.104', '2019-07-29 13:52:50', 0, 1002001015, '账号未登陆', '2019-07-29 13:52:50');
INSERT INTO `access_log` VALUES (60321, '65.47.15643795704084469', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.93.223.104', '2019-07-29 13:52:50', 0, 1002001015, '账号未登陆', '2019-07-29 13:52:50');
INSERT INTO `access_log` VALUES (60322, '65.51.15643795747844543', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.93.223.104', '2019-07-29 13:52:55', 60, 0, '', '2019-07-29 13:52:55');
INSERT INTO `access_log` VALUES (60323, '65.53.15643795749924471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.93.223.104', '2019-07-29 13:52:55', 12, 0, '', '2019-07-29 13:52:55');
INSERT INTO `access_log` VALUES (60324, '65.54.15643795749934395', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.93.223.104', '2019-07-29 13:52:55', 13, 2001001000, '服务端发生异常', '2019-07-29 13:52:55');
INSERT INTO `access_log` VALUES (60325, '65.3607.15643795749926267', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.93.223.104', '2019-07-29 13:52:55', 16, 0, '', '2019-07-29 13:52:55');
INSERT INTO `access_log` VALUES (60326, '65.50.15643797288984475', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.200.208.58', '2019-07-29 13:55:29', 4, 1002001012, '访问令牌已过期', '2019-07-29 13:55:29');
INSERT INTO `access_log` VALUES (60327, '65.46.15643797289024545', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.200.208.58', '2019-07-29 13:55:29', 2, 1002001012, '访问令牌已过期', '2019-07-29 13:55:29');
INSERT INTO `access_log` VALUES (60328, '65.52.15643797289034511', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.200.208.58', '2019-07-29 13:55:29', 3, 1002001012, '访问令牌已过期', '2019-07-29 13:55:29');
INSERT INTO `access_log` VALUES (60329, '65.49.15643797309104457', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.200.208.58', '2019-07-29 13:55:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 13:55:31');
INSERT INTO `access_log` VALUES (60330, '65.46.15643799865964549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.200.208.58', '2019-07-29 13:59:47', 409, 0, '', '2019-07-29 13:59:47');
INSERT INTO `access_log` VALUES (60331, '65.52.15643799872624515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.200.208.58', '2019-07-29 13:59:47', 10, 0, '', '2019-07-29 13:59:47');
INSERT INTO `access_log` VALUES (60332, '65.49.15643799872664461', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.200.208.58', '2019-07-29 13:59:47', 9, 2001001000, '服务端发生异常', '2019-07-29 13:59:47');
INSERT INTO `access_log` VALUES (60333, '65.47.15643799872674477', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '115.200.208.58', '2019-07-29 13:59:47', 9, 0, '', '2019-07-29 13:59:47');
INSERT INTO `access_log` VALUES (60334, '65.45.15643811919394503', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.33.196.242', '2019-07-29 14:19:52', 1, 1002001015, '账号未登陆', '2019-07-29 14:19:52');
INSERT INTO `access_log` VALUES (60335, '65.51.15643811919544567', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.33.196.242', '2019-07-29 14:19:52', 0, 1002001015, '账号未登陆', '2019-07-29 14:19:52');
INSERT INTO `access_log` VALUES (60336, '65.54.15643811919554419', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.33.196.242', '2019-07-29 14:19:52', 0, 1002001015, '账号未登陆', '2019-07-29 14:19:52');
INSERT INTO `access_log` VALUES (60337, '65.3607.15643811964206291', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.33.196.242', '2019-07-29 14:19:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 14:19:56');
INSERT INTO `access_log` VALUES (60338, '65.50.15643812054354497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.33.196.242', '2019-07-29 14:20:05', 75, 0, '', '2019-07-29 14:20:06');
INSERT INTO `access_log` VALUES (60339, '65.46.15643812058724567', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.33.196.242', '2019-07-29 14:20:06', 9, 0, '', '2019-07-29 14:20:06');
INSERT INTO `access_log` VALUES (60340, '65.52.15643812058744533', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.33.196.242', '2019-07-29 14:20:06', 10, 2001001000, '服务端发生异常', '2019-07-29 14:20:06');
INSERT INTO `access_log` VALUES (60341, '65.49.15643812058844479', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.33.196.242', '2019-07-29 14:20:06', 8, 0, '', '2019-07-29 14:20:06');
INSERT INTO `access_log` VALUES (60342, '59.76.15643824606862089', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:01', 9, 0, '', '2019-07-29 14:41:01');
INSERT INTO `access_log` VALUES (60343, '59.77.15643824606862089', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:01', 22, 2001001000, '服务端发生异常', '2019-07-29 14:41:01');
INSERT INTO `access_log` VALUES (60344, '64.78.15643824663432381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:06', 13, 0, '', '2019-07-29 14:41:06');
INSERT INTO `access_log` VALUES (60345, '64.79.15643824665102375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:07', 4, 0, '', '2019-07-29 14:41:07');
INSERT INTO `access_log` VALUES (60346, '64.83.15643824693142371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:09', 2, 0, '', '2019-07-29 14:41:09');
INSERT INTO `access_log` VALUES (60347, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:09', 6, 0, '', '2019-07-29 14:41:09');
INSERT INTO `access_log` VALUES (60348, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:13', 5, 0, '', '2019-07-29 14:41:13');
INSERT INTO `access_log` VALUES (60349, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:14', 5, 0, '', '2019-07-29 14:41:14');
INSERT INTO `access_log` VALUES (60350, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:15', 13, 0, '', '2019-07-29 14:41:15');
INSERT INTO `access_log` VALUES (60351, '64.80.15643824769152385', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:17', 7, 0, '', '2019-07-29 14:41:17');
INSERT INTO `access_log` VALUES (60352, '59.75.15643824798792109', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-29 14:41:20', 3, 0, '', '2019-07-29 14:41:20');
INSERT INTO `access_log` VALUES (60353, '59.71.15643824798792097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-29 14:41:20', 34, 2001001000, '服务端发生异常', '2019-07-29 14:41:20');
INSERT INTO `access_log` VALUES (60354, '64.81.15643824905442375', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:31', 7, 0, '', '2019-07-29 14:41:31');
INSERT INTO `access_log` VALUES (60355, '64.77.15643824919262369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:32', 2, 0, '', '2019-07-29 14:41:32');
INSERT INTO `access_log` VALUES (60356, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:32', 6, 0, '', '2019-07-29 14:41:32');
INSERT INTO `access_log` VALUES (60357, '64.82.15643824920252391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-29 14:41:32', 2, 0, '', '2019-07-29 14:41:32');
INSERT INTO `access_log` VALUES (60358, '64.84.15643824921112367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-29 14:41:32', 2, 0, '', '2019-07-29 14:41:32');
INSERT INTO `access_log` VALUES (60359, '64.85.15643824931302415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:33', 2, 0, '', '2019-07-29 14:41:33');
INSERT INTO `access_log` VALUES (60360, '64.78.15643824932392383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:33', 1, 0, '', '2019-07-29 14:41:33');
INSERT INTO `access_log` VALUES (60361, '59.79.15643824947492107', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-29 14:41:35', 3, 0, '', '2019-07-29 14:41:35');
INSERT INTO `access_log` VALUES (60362, '59.80.15643824947492079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-29 14:41:35', 15, 2001001000, '服务端发生异常', '2019-07-29 14:41:35');
INSERT INTO `access_log` VALUES (60363, '59.76.15643824957862091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:36', 3, 0, '', '2019-07-29 14:41:36');
INSERT INTO `access_log` VALUES (60364, '59.78.15643824957862107', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:41:36', 13, 2001001000, '服务端发生异常', '2019-07-29 14:41:36');
INSERT INTO `access_log` VALUES (60365, '64.82.15643827241902395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:45:24', 3, 0, '', '2019-07-29 14:45:24');
INSERT INTO `access_log` VALUES (60366, '64.84.15643827243392371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:45:24', 3, 0, '', '2019-07-29 14:45:24');
INSERT INTO `access_log` VALUES (60367, '64.85.15643827253612419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:45:25', 2, 0, '', '2019-07-29 14:45:25');
INSERT INTO `access_log` VALUES (60368, '64.78.15643827259772387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:45:26', 2, 0, '', '2019-07-29 14:45:26');
INSERT INTO `access_log` VALUES (60369, '59.74.15643827285592117', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:45:29', 3, 0, '', '2019-07-29 14:45:29');
INSERT INTO `access_log` VALUES (60370, '59.79.15643827286082111', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:45:29', 15, 2001001000, '服务端发生异常', '2019-07-29 14:45:29');
INSERT INTO `access_log` VALUES (60371, '64.79.15643827304262381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:45:30', 2, 0, '', '2019-07-29 14:45:30');
INSERT INTO `access_log` VALUES (60372, '64.83.15643827305522377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:45:31', 2, 0, '', '2019-07-29 14:45:31');
INSERT INTO `access_log` VALUES (60373, '65.54.15643827328854441', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.226.45.158', '2019-07-29 14:45:33', 1, 1002001015, '账号未登陆', '2019-07-29 14:45:33');
INSERT INTO `access_log` VALUES (60374, '65.45.15643827328854525', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.226.45.158', '2019-07-29 14:45:33', 1, 1002001015, '账号未登陆', '2019-07-29 14:45:33');
INSERT INTO `access_log` VALUES (60375, '65.53.15643827328934517', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.226.45.158', '2019-07-29 14:45:33', 0, 1002001015, '账号未登陆', '2019-07-29 14:45:33');
INSERT INTO `access_log` VALUES (60376, '64.80.15643827334562391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:45:33', 2, 0, '', '2019-07-29 14:45:33');
INSERT INTO `access_log` VALUES (60377, '64.76.15643827336122377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 14:45:34', 2, 0, '', '2019-07-29 14:45:34');
INSERT INTO `access_log` VALUES (60378, '65.3607.15643827354206313', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.226.45.158', '2019-07-29 14:45:35', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 14:45:35');
INSERT INTO `access_log` VALUES (60379, '65.52.15643827518594555', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.226.45.158', '2019-07-29 14:45:52', 69, 0, '', '2019-07-29 14:45:52');
INSERT INTO `access_log` VALUES (60380, '65.46.15643827522364589', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.226.45.158', '2019-07-29 14:45:52', 11, 2001001000, '服务端发生异常', '2019-07-29 14:45:52');
INSERT INTO `access_log` VALUES (60381, '65.47.15643827556724517', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.226.45.158', '2019-07-29 14:45:56', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 14:45:56');
INSERT INTO `access_log` VALUES (60382, '65.51.15643827591834591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.226.45.158', '2019-07-29 14:45:59', 63, 0, '', '2019-07-29 14:45:59');
INSERT INTO `access_log` VALUES (60383, '65.54.15643827596224443', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.226.45.158', '2019-07-29 14:46:00', 10, 2001001000, '服务端发生异常', '2019-07-29 14:46:00');
INSERT INTO `access_log` VALUES (60384, '65.45.15643827643144527', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.226.45.158', '2019-07-29 14:46:04', 96, 0, '', '2019-07-29 14:46:04');
INSERT INTO `access_log` VALUES (60385, '65.54.15643828862574445', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 14:48:06', 4, 1002001012, '访问令牌已过期', '2019-07-29 14:48:06');
INSERT INTO `access_log` VALUES (60386, '65.45.15643828862664529', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 14:48:06', 3, 1002001012, '访问令牌已过期', '2019-07-29 14:48:06');
INSERT INTO `access_log` VALUES (60387, '65.3607.15643828934986317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 14:48:13', 155, 0, '', '2019-07-29 14:48:14');
INSERT INTO `access_log` VALUES (60388, '65.50.15643828945544523', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 14:48:15', 10, 0, '', '2019-07-29 14:48:15');
INSERT INTO `access_log` VALUES (60389, '65.52.15643828945734559', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 14:48:15', 10, 2001001000, '服务端发生异常', '2019-07-29 14:48:15');
INSERT INTO `access_log` VALUES (60390, '65.46.15643828995434593', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 14:48:20', 9, 0, '', '2019-07-29 14:48:20');
INSERT INTO `access_log` VALUES (60391, '65.53.15643829730744523', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 14:49:33', 18, 2001001000, '服务端发生异常', '2019-07-29 14:49:33');
INSERT INTO `access_log` VALUES (60392, '65.3607.15643829730786319', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 14:49:33', 17, 0, '', '2019-07-29 14:49:33');
INSERT INTO `access_log` VALUES (60393, '65.52.15643829730834561', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 14:49:33', 8, 0, '', '2019-07-29 14:49:33');
INSERT INTO `access_log` VALUES (60394, '65.46.15643829851884595', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 14:49:45', 9, 0, '', '2019-07-29 14:49:45');
INSERT INTO `access_log` VALUES (60395, '65.49.15643829851934507', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 14:49:45', 9, 2001001000, '服务端发生异常', '2019-07-29 14:49:45');
INSERT INTO `access_log` VALUES (60396, '65.47.15643829852284523', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.75 Safari/537.36', '117.136.78.53', '2019-07-29 14:49:45', 9, 0, '', '2019-07-29 14:49:45');
INSERT INTO `access_log` VALUES (60397, '59.75.15643831127972119', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.89.239.238', '2019-07-29 14:51:53', 13, 2001001000, '服务端发生异常', '2019-07-29 14:51:53');
INSERT INTO `access_log` VALUES (60398, '64.76.15643831668232383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.251', '2019-07-29 14:52:47', 2, 0, '', '2019-07-29 14:52:47');
INSERT INTO `access_log` VALUES (60399, '59.79.15643834459562121', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:57:26', 3, 0, '', '2019-07-29 14:57:26');
INSERT INTO `access_log` VALUES (60400, '59.80.15643834459562093', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:57:26', 13, 2001001000, '服务端发生异常', '2019-07-29 14:57:26');
INSERT INTO `access_log` VALUES (60401, '64.76.15643834522522387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:57:32', 3, 0, '', '2019-07-29 14:57:32');
INSERT INTO `access_log` VALUES (60402, '64.81.15643834523442391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:57:32', 2, 0, '', '2019-07-29 14:57:32');
INSERT INTO `access_log` VALUES (60403, '59.76.15643834558272105', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:57:36', 2, 0, '', '2019-07-29 14:57:36');
INSERT INTO `access_log` VALUES (60404, '59.77.15643834558272105', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:57:36', 12, 2001001000, '服务端发生异常', '2019-07-29 14:57:36');
INSERT INTO `access_log` VALUES (60405, '64.82.15643834655902407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:57:46', 1, 0, '', '2019-07-29 14:57:46');
INSERT INTO `access_log` VALUES (60406, '64.84.15643834656992383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:57:46', 2, 0, '', '2019-07-29 14:57:46');
INSERT INTO `access_log` VALUES (60407, '64.78.15643834785622399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:57:59', 2, 0, '', '2019-07-29 14:57:59');
INSERT INTO `access_log` VALUES (60408, '64.79.15643834786362393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:57:59', 2, 0, '', '2019-07-29 14:57:59');
INSERT INTO `access_log` VALUES (60409, '59.75.15643834794832125', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:57:59', 2, 0, '', '2019-07-29 14:57:59');
INSERT INTO `access_log` VALUES (60410, '59.72.15643834794832111', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:57:59', 13, 2001001000, '服务端发生异常', '2019-07-29 14:57:59');
INSERT INTO `access_log` VALUES (60411, '64.83.15643834803102389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:58:00', 2, 0, '', '2019-07-29 14:58:00');
INSERT INTO `access_log` VALUES (60412, '64.80.15643834803902403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:58:00', 2, 0, '', '2019-07-29 14:58:00');
INSERT INTO `access_log` VALUES (60413, '59.74.15643834837322129', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:58:04', 3, 0, '', '2019-07-29 14:58:04');
INSERT INTO `access_log` VALUES (60414, '59.71.15643834837322113', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.226.45.158', '2019-07-29 14:58:04', 45, 2001001000, '服务端发生异常', '2019-07-29 14:58:04');
INSERT INTO `access_log` VALUES (60415, '59.72.15643844811242125', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '139.205.171.161', '2019-07-29 15:14:41', 3, 0, '', '2019-07-29 15:14:41');
INSERT INTO `access_log` VALUES (60416, '59.74.15643844811262143', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '139.205.171.161', '2019-07-29 15:14:41', 14, 2001001000, '服务端发生异常', '2019-07-29 15:14:41');
INSERT INTO `access_log` VALUES (60417, '64.79.15643844836392407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '139.205.171.161', '2019-07-29 15:14:44', 3, 0, '', '2019-07-29 15:14:44');
INSERT INTO `access_log` VALUES (60418, '64.83.15643844837642403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '139.205.171.161', '2019-07-29 15:14:44', 1, 0, '', '2019-07-29 15:14:44');
INSERT INTO `access_log` VALUES (60419, '64.80.15643844847172417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '139.205.171.161', '2019-07-29 15:14:45', 2, 0, '', '2019-07-29 15:14:45');
INSERT INTO `access_log` VALUES (60420, '64.76.15643844850112403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '139.205.171.161', '2019-07-29 15:14:45', 2, 0, '', '2019-07-29 15:14:45');
INSERT INTO `access_log` VALUES (60421, '65.52.15643866061914611', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36', '106.39.149.136', '2019-07-29 15:50:06', 1, 1002001015, '账号未登陆', '2019-07-29 15:50:06');
INSERT INTO `access_log` VALUES (60422, '65.46.15643866061914643', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36', '106.39.149.136', '2019-07-29 15:50:06', 1, 1002001015, '账号未登陆', '2019-07-29 15:50:06');
INSERT INTO `access_log` VALUES (60423, '65.3607.15643866062196371', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36', '106.39.149.136', '2019-07-29 15:50:06', 0, 1002001015, '账号未登陆', '2019-07-29 15:50:06');
INSERT INTO `access_log` VALUES (60424, '65.45.15643866090424583', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36', '106.39.149.136', '2019-07-29 15:50:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 15:50:09');
INSERT INTO `access_log` VALUES (60425, '65.50.15643866188694577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36', '106.39.149.136', '2019-07-29 15:50:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 15:50:19');
INSERT INTO `access_log` VALUES (60426, '64.76.15643870542732437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 15:57:34', 11, 0, '', '2019-07-29 15:57:34');
INSERT INTO `access_log` VALUES (60427, '64.81.15643870544342443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 15:57:34', 3, 0, '', '2019-07-29 15:57:34');
INSERT INTO `access_log` VALUES (60428, '59.78.15643870547812171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 15:57:35', 13, 2001001000, '服务端发生异常', '2019-07-29 15:57:35');
INSERT INTO `access_log` VALUES (60429, '59.80.15643870547412143', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 15:57:35', 112, 0, '', '2019-07-29 15:57:35');
INSERT INTO `access_log` VALUES (60430, '64.84.15643870573172435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 15:57:37', 2, 0, '', '2019-07-29 15:57:37');
INSERT INTO `access_log` VALUES (60431, '64.85.15643870576262481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 15:57:38', 1, 0, '', '2019-07-29 15:57:38');
INSERT INTO `access_log` VALUES (60432, '59.76.15643870585082155', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 15:57:39', 3, 0, '', '2019-07-29 15:57:39');
INSERT INTO `access_log` VALUES (60433, '59.77.15643870585092155', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 15:57:39', 13, 2001001000, '服务端发生异常', '2019-07-29 15:57:39');
INSERT INTO `access_log` VALUES (60434, '64.78.15643870593962449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 15:57:39', 1, 0, '', '2019-07-29 15:57:39');
INSERT INTO `access_log` VALUES (60435, '64.77.15643870596512437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 15:57:40', 2, 0, '', '2019-07-29 15:57:40');
INSERT INTO `access_log` VALUES (60436, '59.73.15643870613672169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 15:57:41', 2, 0, '', '2019-07-29 15:57:41');
INSERT INTO `access_log` VALUES (60437, '59.75.15643870613672175', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 15:57:41', 14, 2001001000, '服务端发生异常', '2019-07-29 15:57:41');
INSERT INTO `access_log` VALUES (60438, '65.3607.15643890670436405', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 16:31:07', 1, 1002001015, '账号未登陆', '2019-07-29 16:31:07');
INSERT INTO `access_log` VALUES (60439, '65.47.15643890670434609', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 16:31:07', 1, 1002001015, '账号未登陆', '2019-07-29 16:31:07');
INSERT INTO `access_log` VALUES (60440, '65.52.15643890670444645', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 16:31:07', 0, 1002001015, '账号未登陆', '2019-07-29 16:31:07');
INSERT INTO `access_log` VALUES (60441, '65.45.15643890852364617', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 16:31:25', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 16:31:25');
INSERT INTO `access_log` VALUES (60442, '65.50.15643890933674611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 16:31:33', 80, 0, '', '2019-07-29 16:31:33');
INSERT INTO `access_log` VALUES (60443, '65.54.15643890937434533', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 16:31:34', 12, 0, '', '2019-07-29 16:31:34');
INSERT INTO `access_log` VALUES (60444, '65.51.15643890937434681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 16:31:34', 13, 2001001000, '服务端发生异常', '2019-07-29 16:31:34');
INSERT INTO `access_log` VALUES (60445, '65.49.15643890937764591', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 16:31:34', 9, 0, '', '2019-07-29 16:31:34');
INSERT INTO `access_log` VALUES (60446, '65.3607.15643890979766407', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 16:31:38', 10, 0, '', '2019-07-29 16:31:38');
INSERT INTO `access_log` VALUES (60447, '65.47.15643890979794611', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 16:31:38', 11, 2001001000, '服务端发生异常', '2019-07-29 16:31:38');
INSERT INTO `access_log` VALUES (60448, '65.52.15643890979824647', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 16:31:38', 10, 0, '', '2019-07-29 16:31:38');
INSERT INTO `access_log` VALUES (60449, '65.50.15643891294174613', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 16:32:09', 9, 0, '', '2019-07-29 16:32:09');
INSERT INTO `access_log` VALUES (60450, '65.54.15643891294414535', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 16:32:09', 10, 2001001000, '服务端发生异常', '2019-07-29 16:32:09');
INSERT INTO `access_log` VALUES (60451, '65.51.15643891294434683', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 16:32:09', 8, 0, '', '2019-07-29 16:32:09');
INSERT INTO `access_log` VALUES (60452, '59.71.15643896402472199', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-29 16:40:40', 17, 2001001000, '服务端发生异常', '2019-07-29 16:40:40');
INSERT INTO `access_log` VALUES (60453, '59.74.15643896402402215', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-29 16:40:40', 153, 0, '', '2019-07-29 16:40:40');
INSERT INTO `access_log` VALUES (60454, '64.80.15643896428382487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-29 16:40:43', 11, 0, '', '2019-07-29 16:40:43');
INSERT INTO `access_log` VALUES (60455, '64.76.15643896429752473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-29 16:40:43', 5, 0, '', '2019-07-29 16:40:43');
INSERT INTO `access_log` VALUES (60456, '65.46.15643896506364689', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '123.160.230.132', '2019-07-29 16:40:51', 0, 1002001015, '账号未登陆', '2019-07-29 16:40:51');
INSERT INTO `access_log` VALUES (60457, '65.3607.15643899499886421', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.97.32', '2019-07-29 16:45:50', 1, 1002001015, '账号未登陆', '2019-07-29 16:45:50');
INSERT INTO `access_log` VALUES (60458, '65.51.15643899499934695', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.97.32', '2019-07-29 16:45:50', 0, 1002001015, '账号未登陆', '2019-07-29 16:45:50');
INSERT INTO `access_log` VALUES (60459, '65.53.15643899500054623', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.97.32', '2019-07-29 16:45:50', 1, 1002001015, '账号未登陆', '2019-07-29 16:45:50');
INSERT INTO `access_log` VALUES (60460, '65.45.15643899535514633', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.97.32', '2019-07-29 16:45:54', 96, 0, '', '2019-07-29 16:45:54');
INSERT INTO `access_log` VALUES (60461, '65.54.15643899539454549', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.97.32', '2019-07-29 16:45:54', 141, 0, '', '2019-07-29 16:45:54');
INSERT INTO `access_log` VALUES (60462, '65.49.15643899539514607', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.97.32', '2019-07-29 16:45:54', 137, 2001001000, '服务端发生异常', '2019-07-29 16:45:54');
INSERT INTO `access_log` VALUES (60463, '65.52.15643899539564661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.144.97.32', '2019-07-29 16:45:54', 131, 0, '', '2019-07-29 16:45:54');
INSERT INTO `access_log` VALUES (60464, '65.47.15643920631554651', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:21:03', 1, 1002001015, '账号未登陆', '2019-07-29 17:21:03');
INSERT INTO `access_log` VALUES (60465, '65.46.15643920631554723', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:21:03', 0, 1002001015, '账号未登陆', '2019-07-29 17:21:03');
INSERT INTO `access_log` VALUES (60466, '65.3607.15643920631556451', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:21:03', 0, 1002001015, '账号未登陆', '2019-07-29 17:21:03');
INSERT INTO `access_log` VALUES (60467, '65.51.15643920654194725', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:21:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 17:21:05');
INSERT INTO `access_log` VALUES (60468, '65.50.15643920962414655', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:21:36', 70, 0, '', '2019-07-29 17:21:36');
INSERT INTO `access_log` VALUES (60469, '65.54.15643920968984579', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:21:37', 21, 2001001000, '服务端发生异常', '2019-07-29 17:21:37');
INSERT INTO `access_log` VALUES (60470, '65.52.15643920968984691', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:21:37', 19, 0, '', '2019-07-29 17:21:37');
INSERT INTO `access_log` VALUES (60471, '65.49.15643920969024637', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:21:37', 18, 0, '', '2019-07-29 17:21:37');
INSERT INTO `access_log` VALUES (60472, '65.51.15643921367574727', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:22:17', 11, 0, '', '2019-07-29 17:22:17');
INSERT INTO `access_log` VALUES (60473, '65.53.15643921367614655', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:22:17', 10, 2001001000, '服务端发生异常', '2019-07-29 17:22:17');
INSERT INTO `access_log` VALUES (60474, '65.45.15643921367964665', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:22:17', 10, 0, '', '2019-07-29 17:22:17');
INSERT INTO `access_log` VALUES (60475, '65.45.15643922730624667', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:24:33', 11, 0, '', '2019-07-29 17:24:33');
INSERT INTO `access_log` VALUES (60476, '65.52.15643922730704695', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:24:33', 9, 0, '', '2019-07-29 17:24:33');
INSERT INTO `access_log` VALUES (60477, '65.50.15643922730704659', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:24:33', 11, 2001001000, '服务端发生异常', '2019-07-29 17:24:33');
INSERT INTO `access_log` VALUES (60478, '65.54.15643922782524583', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:24:38', 9, 0, '', '2019-07-29 17:24:38');
INSERT INTO `access_log` VALUES (60479, '65.3607.15643922782636457', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:24:38', 8, 0, '', '2019-07-29 17:24:38');
INSERT INTO `access_log` VALUES (60480, '65.49.15643922782634641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '218.75.127.235', '2019-07-29 17:24:38', 10, 2001001000, '服务端发生异常', '2019-07-29 17:24:38');
INSERT INTO `access_log` VALUES (60481, '59.73.15643927116662245', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 17:31:52', 10, 0, '', '2019-07-29 17:31:52');
INSERT INTO `access_log` VALUES (60482, '59.75.15643927116732253', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 17:31:52', 12, 2001001000, '服务端发生异常', '2019-07-29 17:31:52');
INSERT INTO `access_log` VALUES (60483, '64.77.15643927192042513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 17:31:59', 12, 0, '', '2019-07-29 17:31:59');
INSERT INTO `access_log` VALUES (60484, '64.79.15643927193282519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 17:31:59', 3, 0, '', '2019-07-29 17:31:59');
INSERT INTO `access_log` VALUES (60485, '64.83.15643927205032517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 17:32:01', 2, 0, '', '2019-07-29 17:32:01');
INSERT INTO `access_log` VALUES (60486, '64.80.15643927210902529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 17:32:01', 2, 0, '', '2019-07-29 17:32:01');
INSERT INTO `access_log` VALUES (60487, '59.72.15643927233582239', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 17:32:03', 3, 0, '', '2019-07-29 17:32:03');
INSERT INTO `access_log` VALUES (60488, '59.74.15643927233582257', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.24', '2019-07-29 17:32:03', 13, 2001001000, '服务端发生异常', '2019-07-29 17:32:03');
INSERT INTO `access_log` VALUES (60489, '59.79.15643927331222249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 17:32:13', 2, 0, '', '2019-07-29 17:32:13');
INSERT INTO `access_log` VALUES (60490, '59.78.15643927331252249', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 17:32:13', 13, 2001001000, '服务端发生异常', '2019-07-29 17:32:13');
INSERT INTO `access_log` VALUES (60491, '64.82.15643927418242537', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 17:32:22', 1, 0, '', '2019-07-29 17:32:22');
INSERT INTO `access_log` VALUES (60492, '64.84.15643927419552513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 17:32:22', 2, 0, '', '2019-07-29 17:32:22');
INSERT INTO `access_log` VALUES (60493, '59.76.15643927427652231', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 17:32:23', 2, 0, '', '2019-07-29 17:32:23');
INSERT INTO `access_log` VALUES (60494, '59.77.15643927427682237', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 17:32:23', 13, 2001001000, '服务端发生异常', '2019-07-29 17:32:23');
INSERT INTO `access_log` VALUES (60495, '64.83.15643928096552519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 17:33:30', 3, 0, '', '2019-07-29 17:33:30');
INSERT INTO `access_log` VALUES (60496, '64.80.15643928097692531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 17:33:30', 2, 0, '', '2019-07-29 17:33:30');
INSERT INTO `access_log` VALUES (60497, '64.76.15643928110232517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 17:33:31', 1, 0, '', '2019-07-29 17:33:31');
INSERT INTO `access_log` VALUES (60498, '64.81.15643928116902523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 17:33:32', 2, 0, '', '2019-07-29 17:33:32');
INSERT INTO `access_log` VALUES (60499, '59.79.15643928213632251', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 17:33:41', 3, 0, '', '2019-07-29 17:33:41');
INSERT INTO `access_log` VALUES (60500, '59.78.15643928213942251', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '106.38.115.24', '2019-07-29 17:33:41', 12, 2001001000, '服务端发生异常', '2019-07-29 17:33:41');
INSERT INTO `access_log` VALUES (60501, '59.71.15643932302082249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:40:30', 3, 0, '', '2019-07-29 17:40:30');
INSERT INTO `access_log` VALUES (60502, '59.79.15643932302092257', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:40:30', 18, 2001001000, '服务端发生异常', '2019-07-29 17:40:30');
INSERT INTO `access_log` VALUES (60503, '64.76.15643932347952523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:40:35', 3, 0, '', '2019-07-29 17:40:35');
INSERT INTO `access_log` VALUES (60504, '64.81.15643932348712529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:40:35', 2, 0, '', '2019-07-29 17:40:35');
INSERT INTO `access_log` VALUES (60505, '59.80.15643932379242227', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:40:38', 2, 0, '', '2019-07-29 17:40:38');
INSERT INTO `access_log` VALUES (60506, '59.76.15643932379252239', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:40:38', 12, 2001001000, '服务端发生异常', '2019-07-29 17:40:38');
INSERT INTO `access_log` VALUES (60507, '64.78.15643932695962535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 4.1.2; zh-cn; Chitanda/Akari) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30 MicroMessenger/6.0.0.58_r884092.501 NetType/WIFI', '116.232.196.218', '2019-07-29 17:41:10', 2, 0, '', '2019-07-29 17:41:10');
INSERT INTO `access_log` VALUES (60508, '64.77.15643932697052523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 4.1.2; zh-cn; Chitanda/Akari) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30 MicroMessenger/6.0.0.58_r884092.501 NetType/WIFI', '116.232.196.218', '2019-07-29 17:41:10', 2, 0, '', '2019-07-29 17:41:10');
INSERT INTO `access_log` VALUES (60509, '64.79.15643932711332529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 4.1.2; zh-cn; Chitanda/Akari) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30 MicroMessenger/6.0.0.58_r884092.501 NetType/WIFI', '116.232.196.218', '2019-07-29 17:41:11', 2, 0, '', '2019-07-29 17:41:11');
INSERT INTO `access_log` VALUES (60510, '64.83.15643932718622527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 4.1.2; zh-cn; Chitanda/Akari) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30 MicroMessenger/6.0.0.58_r884092.501 NetType/WIFI', '116.232.196.218', '2019-07-29 17:41:12', 2, 0, '', '2019-07-29 17:41:12');
INSERT INTO `access_log` VALUES (60511, '64.80.15643932728492539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 4.1.2; zh-cn; Chitanda/Akari) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30 MicroMessenger/6.0.0.58_r884092.501 NetType/WIFI', '116.232.196.218', '2019-07-29 17:41:13', 2, 0, '', '2019-07-29 17:41:13');
INSERT INTO `access_log` VALUES (60512, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 4.1.2; zh-cn; Chitanda/Akari) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30 MicroMessenger/6.0.0.58_r884092.501 NetType/WIFI', '116.232.196.218', '2019-07-29 17:41:13', 5, 0, '', '2019-07-29 17:41:13');
INSERT INTO `access_log` VALUES (60513, '64.76.15643932745282525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 4.1.2; zh-cn; Chitanda/Akari) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30 MicroMessenger/6.0.0.58_r884092.501 NetType/WIFI', '116.232.196.218', '2019-07-29 17:41:15', 1, 0, '', '2019-07-29 17:41:15');
INSERT INTO `access_log` VALUES (60514, '64.81.15643932746352531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 4.1.2; zh-cn; Chitanda/Akari) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30 MicroMessenger/6.0.0.58_r884092.501 NetType/WIFI', '116.232.196.218', '2019-07-29 17:41:15', 2, 0, '', '2019-07-29 17:41:15');
INSERT INTO `access_log` VALUES (60515, '59.72.15643932891572249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:41:29', 3, 0, '', '2019-07-29 17:41:29');
INSERT INTO `access_log` VALUES (60516, '59.74.15643932891572267', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:41:29', 12, 2001001000, '服务端发生异常', '2019-07-29 17:41:29');
INSERT INTO `access_log` VALUES (60517, '65.3607.15643932962736471', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:41:36', 1, 1002001015, '账号未登陆', '2019-07-29 17:41:36');
INSERT INTO `access_log` VALUES (60518, '65.49.15643932962744655', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:41:36', 1, 1002001015, '账号未登陆', '2019-07-29 17:41:36');
INSERT INTO `access_log` VALUES (60519, '65.47.15643932962744671', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:41:36', 0, 1002001015, '账号未登陆', '2019-07-29 17:41:36');
INSERT INTO `access_log` VALUES (60520, '65.51.15643932993724745', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:41:39', 1, 1002001015, '账号未登陆', '2019-07-29 17:41:39');
INSERT INTO `access_log` VALUES (60521, '65.53.15643932993744673', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:41:39', 1, 1002001015, '账号未登陆', '2019-07-29 17:41:39');
INSERT INTO `access_log` VALUES (60522, '65.45.15643932993814683', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:41:39', 0, 1002001015, '账号未登陆', '2019-07-29 17:41:39');
INSERT INTO `access_log` VALUES (60523, '65.50.15643933015484675', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:41:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 17:41:42');
INSERT INTO `access_log` VALUES (60524, '65.52.15643933039604711', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:41:44', 126, 0, '', '2019-07-29 17:41:44');
INSERT INTO `access_log` VALUES (60525, '65.54.15643933043144599', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:41:44', 10, 0, '', '2019-07-29 17:41:44');
INSERT INTO `access_log` VALUES (60526, '65.3607.15643933043206473', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:41:44', 9, 2001001000, '服务端发生异常', '2019-07-29 17:41:44');
INSERT INTO `access_log` VALUES (60527, '65.49.15643933043234657', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:41:44', 9, 0, '', '2019-07-29 17:41:44');
INSERT INTO `access_log` VALUES (60528, '65.47.15643933058354673', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:41:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 17:41:46');
INSERT INTO `access_log` VALUES (60529, '65.53.15643933172834675', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:41:57', 59, 0, '', '2019-07-29 17:41:57');
INSERT INTO `access_log` VALUES (60530, '65.51.15643933175934747', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:41:58', 10, 0, '', '2019-07-29 17:41:58');
INSERT INTO `access_log` VALUES (60531, '65.45.15643933175984685', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:41:58', 10, 2001001000, '服务端发生异常', '2019-07-29 17:41:58');
INSERT INTO `access_log` VALUES (60532, '65.50.15643933176024677', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:41:58', 8, 0, '', '2019-07-29 17:41:58');
INSERT INTO `access_log` VALUES (60533, '65.52.15643933275544713', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:08', 9, 0, '', '2019-07-29 17:42:08');
INSERT INTO `access_log` VALUES (60534, '65.49.15643933275564659', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:08', 9, 0, '', '2019-07-29 17:42:08');
INSERT INTO `access_log` VALUES (60535, '65.3607.15643933275566475', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:08', 10, 2001001000, '服务端发生异常', '2019-07-29 17:42:08');
INSERT INTO `access_log` VALUES (60536, '65.47.15643933379324675', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:18', 18, 0, '', '2019-07-29 17:42:18');
INSERT INTO `access_log` VALUES (60537, '65.46.15643933379354747', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:18', 19, 2001001000, '服务端发生异常', '2019-07-29 17:42:18');
INSERT INTO `access_log` VALUES (60538, '65.53.15643933379504677', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:18', 9, 0, '', '2019-07-29 17:42:18');
INSERT INTO `access_log` VALUES (60539, '65.45.15643933418474687', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:22', 9, 0, '', '2019-07-29 17:42:22');
INSERT INTO `access_log` VALUES (60540, '65.51.15643933418514749', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:22', 9, 2001001000, '服务端发生异常', '2019-07-29 17:42:22');
INSERT INTO `access_log` VALUES (60541, '65.50.15643933418534679', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:22', 9, 0, '', '2019-07-29 17:42:22');
INSERT INTO `access_log` VALUES (60542, '65.52.15643933460444715', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:26', 10, 0, '', '2019-07-29 17:42:26');
INSERT INTO `access_log` VALUES (60543, '65.49.15643933460494661', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:26', 9, 2001001000, '服务端发生异常', '2019-07-29 17:42:26');
INSERT INTO `access_log` VALUES (60544, '65.54.15643933460524603', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:26', 7, 0, '', '2019-07-29 17:42:26');
INSERT INTO `access_log` VALUES (60545, '65.46.15643933590364749', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:39', 8, 0, '', '2019-07-29 17:42:39');
INSERT INTO `access_log` VALUES (60546, '65.53.15643933590434679', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:39', 9, 2001001000, '服务端发生异常', '2019-07-29 17:42:39');
INSERT INTO `access_log` VALUES (60547, '65.50.15643933590504681', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-29 17:42:39', 9, 0, '', '2019-07-29 17:42:39');
INSERT INTO `access_log` VALUES (60548, '65.51.15643933605994751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:42:41', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 17:42:41');
INSERT INTO `access_log` VALUES (60549, '65.45.15643933621064689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:42:42', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 17:42:42');
INSERT INTO `access_log` VALUES (60550, '65.52.15643935462394719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:45:46', 135, 0, '', '2019-07-29 17:45:46');
INSERT INTO `access_log` VALUES (60551, '65.49.15643935466404665', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:45:47', 10, 0, '', '2019-07-29 17:45:47');
INSERT INTO `access_log` VALUES (60552, '65.47.15643935466464681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:45:47', 11, 2001001000, '服务端发生异常', '2019-07-29 17:45:47');
INSERT INTO `access_log` VALUES (60553, '65.53.15643935466494683', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:45:47', 10, 0, '', '2019-07-29 17:45:47');
INSERT INTO `access_log` VALUES (60554, '65.46.15643935517704753', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:45:52', 9, 0, '', '2019-07-29 17:45:52');
INSERT INTO `access_log` VALUES (60555, '65.51.15643935517734755', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:45:52', 9, 0, '', '2019-07-29 17:45:52');
INSERT INTO `access_log` VALUES (60556, '65.50.15643935517724685', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:45:52', 9, 2001001000, '服务端发生异常', '2019-07-29 17:45:52');
INSERT INTO `access_log` VALUES (60557, '65.52.15643935544174721', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:45:54', 9, 0, '', '2019-07-29 17:45:54');
INSERT INTO `access_log` VALUES (60558, '65.3607.15643935544166483', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:45:54', 17, 0, '', '2019-07-29 17:45:54');
INSERT INTO `access_log` VALUES (60559, '65.54.15643935544164609', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-07-29 17:45:54', 17, 2001001000, '服务端发生异常', '2019-07-29 17:45:54');
INSERT INTO `access_log` VALUES (60560, '59.80.15643951242032253', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:04', 3, 0, '', '2019-07-29 18:12:04');
INSERT INTO `access_log` VALUES (60561, '59.76.15643951242092265', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:04', 13, 2001001000, '服务端发生异常', '2019-07-29 18:12:04');
INSERT INTO `access_log` VALUES (60562, '64.77.15643951311342549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:11', 14, 0, '', '2019-07-29 18:12:11');
INSERT INTO `access_log` VALUES (60563, '64.79.15643951312992555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:11', 3, 0, '', '2019-07-29 18:12:11');
INSERT INTO `access_log` VALUES (60564, '64.83.15643951339382553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:14', 2, 0, '', '2019-07-29 18:12:14');
INSERT INTO `access_log` VALUES (60565, '64.80.15643951340872565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:14', 2, 0, '', '2019-07-29 18:12:14');
INSERT INTO `access_log` VALUES (60566, '59.77.15643951349062271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:15', 9, 0, '', '2019-07-29 18:12:15');
INSERT INTO `access_log` VALUES (60567, '59.73.15643951349062281', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:15', 13, 2001001000, '服务端发生异常', '2019-07-29 18:12:15');
INSERT INTO `access_log` VALUES (60568, '65.51.15643951414014777', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:21', 0, 1002001015, '账号未登陆', '2019-07-29 18:12:21');
INSERT INTO `access_log` VALUES (60569, '65.45.15643951414024715', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:21', 0, 1002001015, '账号未登陆', '2019-07-29 18:12:21');
INSERT INTO `access_log` VALUES (60570, '65.52.15643951414064743', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:21', 0, 1002001015, '账号未登陆', '2019-07-29 18:12:21');
INSERT INTO `access_log` VALUES (60571, '65.54.15643951438564631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 18:12:24');
INSERT INTO `access_log` VALUES (60572, '65.47.15643951648424705', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:45', 60, 0, '', '2019-07-29 18:12:45');
INSERT INTO `access_log` VALUES (60573, '65.49.15643951652294689', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:45', 10, 0, '', '2019-07-29 18:12:45');
INSERT INTO `access_log` VALUES (60574, '65.50.15643951652364709', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:45', 9, 2001001000, '服务端发生异常', '2019-07-29 18:12:45');
INSERT INTO `access_log` VALUES (60575, '65.46.15643951652414777', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:12:45', 8, 0, '', '2019-07-29 18:12:45');
INSERT INTO `access_log` VALUES (60576, '65.53.15643952441814709', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:14:04', 8, 0, '', '2019-07-29 18:14:04');
INSERT INTO `access_log` VALUES (60577, '65.47.15643952441984707', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:14:04', 9, 2001001000, '服务端发生异常', '2019-07-29 18:14:04');
INSERT INTO `access_log` VALUES (60578, '65.49.15643952441994691', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.23', '2019-07-29 18:14:04', 9, 0, '', '2019-07-29 18:14:04');
INSERT INTO `access_log` VALUES (60579, '65.45.15643954175104721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.15.88', '2019-07-29 18:16:58', 109, 0, '', '2019-07-29 18:16:58');
INSERT INTO `access_log` VALUES (60580, '65.51.15643954179494783', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.15.88', '2019-07-29 18:16:58', 9, 0, '', '2019-07-29 18:16:58');
INSERT INTO `access_log` VALUES (60581, '65.52.15643954179524749', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.15.88', '2019-07-29 18:16:58', 10, 2001001000, '服务端发生异常', '2019-07-29 18:16:58');
INSERT INTO `access_log` VALUES (60582, '65.54.15643954179564637', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.15.88', '2019-07-29 18:16:58', 10, 0, '', '2019-07-29 18:16:58');
INSERT INTO `access_log` VALUES (60583, '65.53.15643954407714713', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.15.88', '2019-07-29 18:17:21', 10, 0, '', '2019-07-29 18:17:21');
INSERT INTO `access_log` VALUES (60584, '65.49.15643954407754695', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.15.88', '2019-07-29 18:17:21', 9, 2001001000, '服务端发生异常', '2019-07-29 18:17:21');
INSERT INTO `access_log` VALUES (60585, '65.47.15643954407814711', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.15.88', '2019-07-29 18:17:21', 9, 0, '', '2019-07-29 18:17:21');
INSERT INTO `access_log` VALUES (60586, '65.54.15643955049394639', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.15.88', '2019-07-29 18:18:25', 66, 0, '', '2019-07-29 18:18:25');
INSERT INTO `access_log` VALUES (60587, '65.3607.15643955053526513', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.15.88', '2019-07-29 18:18:25', 10, 0, '', '2019-07-29 18:18:25');
INSERT INTO `access_log` VALUES (60588, '65.53.15643955053554715', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.15.88', '2019-07-29 18:18:25', 10, 2001001000, '服务端发生异常', '2019-07-29 18:18:25');
INSERT INTO `access_log` VALUES (60589, '65.49.15643955053604697', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.148.15.88', '2019-07-29 18:18:25', 9, 0, '', '2019-07-29 18:18:25');
INSERT INTO `access_log` VALUES (60590, '65.52.15643959834294759', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '113.111.6.189', '2019-07-29 18:26:23', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 18:26:23');
INSERT INTO `access_log` VALUES (60591, '65.47.15643967810084729', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.170.139.166', '2019-07-29 18:39:41', 4, 1002001012, '访问令牌已过期', '2019-07-29 18:39:41');
INSERT INTO `access_log` VALUES (60592, '65.46.15643967810104801', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.170.139.166', '2019-07-29 18:39:41', 3, 1002001012, '访问令牌已过期', '2019-07-29 18:39:41');
INSERT INTO `access_log` VALUES (60593, '65.50.15643967810114735', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.170.139.166', '2019-07-29 18:39:41', 15, 1002001012, '访问令牌已过期', '2019-07-29 18:39:41');
INSERT INTO `access_log` VALUES (60594, '65.45.15643967911384743', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.170.139.166', '2019-07-29 18:39:51', 77, 0, '', '2019-07-29 18:39:51');
INSERT INTO `access_log` VALUES (60595, '65.51.15643967914344805', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.170.139.166', '2019-07-29 18:39:51', 10, 0, '', '2019-07-29 18:39:51');
INSERT INTO `access_log` VALUES (60596, '65.52.15643967914354771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.170.139.166', '2019-07-29 18:39:51', 10, 0, '', '2019-07-29 18:39:51');
INSERT INTO `access_log` VALUES (60597, '65.54.15643967914354659', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.170.139.166', '2019-07-29 18:39:51', 11, 2001001000, '服务端发生异常', '2019-07-29 18:39:51');
INSERT INTO `access_log` VALUES (60598, '59.73.15643982514942323', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:11', 14, 0, '', '2019-07-29 19:04:12');
INSERT INTO `access_log` VALUES (60599, '59.77.15643982514942313', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:11', 26, 2001001000, '服务端发生异常', '2019-07-29 19:04:12');
INSERT INTO `access_log` VALUES (60600, '64.83.15643982576732595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:18', 11, 0, '', '2019-07-29 19:04:18');
INSERT INTO `access_log` VALUES (60601, '64.80.15643982577942607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:18', 3, 0, '', '2019-07-29 19:04:18');
INSERT INTO `access_log` VALUES (60602, '64.81.15643982633622599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:23', 2, 0, '', '2019-07-29 19:04:23');
INSERT INTO `access_log` VALUES (60603, '64.82.15643982634432615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:23', 1, 0, '', '2019-07-29 19:04:23');
INSERT INTO `access_log` VALUES (60604, '59.72.15643982649782317', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:25', 4, 0, '', '2019-07-29 19:04:25');
INSERT INTO `access_log` VALUES (60605, '59.74.15643982649782335', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:25', 16, 2001001000, '服务端发生异常', '2019-07-29 19:04:25');
INSERT INTO `access_log` VALUES (60606, '64.84.15643982685032591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:29', 2, 0, '', '2019-07-29 19:04:29');
INSERT INTO `access_log` VALUES (60607, '64.85.15643982686592637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:29', 2, 0, '', '2019-07-29 19:04:29');
INSERT INTO `access_log` VALUES (60608, '64.78.15643982697582605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:30', 2, 0, '', '2019-07-29 19:04:30');
INSERT INTO `access_log` VALUES (60609, '65.53.15643982806794755', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:41', 1, 1002001015, '账号未登陆', '2019-07-29 19:04:41');
INSERT INTO `access_log` VALUES (60610, '65.3607.15643982806796553', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:41', 1, 1002001015, '账号未登陆', '2019-07-29 19:04:41');
INSERT INTO `access_log` VALUES (60611, '65.49.15643982806794737', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:41', 0, 1002001015, '账号未登陆', '2019-07-29 19:04:41');
INSERT INTO `access_log` VALUES (60612, '65.47.15643982832234751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:43', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 19:04:43');
INSERT INTO `access_log` VALUES (60613, '65.50.15643982988554757', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:59', 137, 0, '', '2019-07-29 19:04:59');
INSERT INTO `access_log` VALUES (60614, '65.52.15643982992474793', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:59', 9, 0, '', '2019-07-29 19:04:59');
INSERT INTO `access_log` VALUES (60615, '65.45.15643982992474765', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:59', 11, 2001001000, '服务端发生异常', '2019-07-29 19:04:59');
INSERT INTO `access_log` VALUES (60616, '65.51.15643982992544827', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:04:59', 9, 0, '', '2019-07-29 19:04:59');
INSERT INTO `access_log` VALUES (60617, '65.46.15643985623544829', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.187.31.34', '2019-07-29 19:09:22', 0, 1002001015, '账号未登陆', '2019-07-29 19:09:22');
INSERT INTO `access_log` VALUES (60618, '65.50.15643991953234771', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '116.226.45.158', '2019-07-29 19:19:55', 0, 1002001015, '账号未登陆', '2019-07-29 19:19:55');
INSERT INTO `access_log` VALUES (60619, '65.46.15643991953254839', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '116.226.45.158', '2019-07-29 19:19:55', 0, 1002001015, '账号未登陆', '2019-07-29 19:19:55');
INSERT INTO `access_log` VALUES (60620, '65.47.15643991953254765', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '116.226.45.158', '2019-07-29 19:19:55', 0, 1002001015, '账号未登陆', '2019-07-29 19:19:55');
INSERT INTO `access_log` VALUES (60621, '65.45.15643991976954781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '116.226.45.158', '2019-07-29 19:19:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 19:19:58');
INSERT INTO `access_log` VALUES (60622, '65.51.15643992042604843', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '116.226.45.158', '2019-07-29 19:20:04', 66, 0, '', '2019-07-29 19:20:04');
INSERT INTO `access_log` VALUES (60623, '65.49.15643992046014753', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '116.226.45.158', '2019-07-29 19:20:05', 9, 0, '', '2019-07-29 19:20:05');
INSERT INTO `access_log` VALUES (60624, '65.53.15643992046054771', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '116.226.45.158', '2019-07-29 19:20:05', 11, 2001001000, '服务端发生异常', '2019-07-29 19:20:05');
INSERT INTO `access_log` VALUES (60625, '65.54.15643992046104695', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '116.226.45.158', '2019-07-29 19:20:05', 8, 0, '', '2019-07-29 19:20:05');
INSERT INTO `access_log` VALUES (60626, '59.75.15643992721492345', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '116.226.45.158', '2019-07-29 19:21:12', 3, 0, '', '2019-07-29 19:21:12');
INSERT INTO `access_log` VALUES (60627, '59.74.15643992721492349', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '116.226.45.158', '2019-07-29 19:21:12', 22, 2001001000, '服务端发生异常', '2019-07-29 19:21:12');
INSERT INTO `access_log` VALUES (60628, '59.73.15644026583932383', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.190.105.186', '2019-07-29 20:17:38', 11, 0, '', '2019-07-29 20:17:38');
INSERT INTO `access_log` VALUES (60629, '59.77.15644026584952373', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.2.35.18', '2019-07-29 20:17:38', 23, 2001001000, '服务端发生异常', '2019-07-29 20:17:39');
INSERT INTO `access_log` VALUES (60630, '65.50.15644026789584819', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.80.133.216', '2019-07-29 20:17:59', 0, 1002001015, '账号未登陆', '2019-07-29 20:17:59');
INSERT INTO `access_log` VALUES (60631, '65.46.15644026789594887', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.222.100.91', '2019-07-29 20:17:59', 0, 1002001015, '账号未登陆', '2019-07-29 20:17:59');
INSERT INTO `access_log` VALUES (60632, '65.47.15644026789594813', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.222.100.159', '2019-07-29 20:17:59', 0, 1002001015, '账号未登陆', '2019-07-29 20:17:59');
INSERT INTO `access_log` VALUES (60633, '65.51.15644026934974891', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.2.35.18', '2019-07-29 20:18:13', 92, 0, '', '2019-07-29 20:18:14');
INSERT INTO `access_log` VALUES (60634, '65.53.15644026940584819', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.2.35.18', '2019-07-29 20:18:14', 11, 0, '', '2019-07-29 20:18:14');
INSERT INTO `access_log` VALUES (60635, '65.49.15644026941854801', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.190.105.186', '2019-07-29 20:18:14', 10, 0, '', '2019-07-29 20:18:14');
INSERT INTO `access_log` VALUES (60636, '65.54.15644026941854743', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.80.133.216', '2019-07-29 20:18:14', 12, 2001001000, '服务端发生异常', '2019-07-29 20:18:14');
INSERT INTO `access_log` VALUES (60637, '59.80.15644046935602383', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.208.61.56', '2019-07-29 20:51:34', 13, 0, '', '2019-07-29 20:51:34');
INSERT INTO `access_log` VALUES (60638, '59.78.15644046935592413', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.208.61.56', '2019-07-29 20:51:34', 21, 2001001000, '服务端发生异常', '2019-07-29 20:51:34');
INSERT INTO `access_log` VALUES (60639, '64.78.15644046991442691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.208.61.56', '2019-07-29 20:51:39', 10, 0, '', '2019-07-29 20:51:39');
INSERT INTO `access_log` VALUES (60640, '64.77.15644046993082679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.208.61.56', '2019-07-29 20:51:39', 3, 0, '', '2019-07-29 20:51:39');
INSERT INTO `access_log` VALUES (60641, '64.79.15644047029062685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.208.61.56', '2019-07-29 20:51:43', 2, 0, '', '2019-07-29 20:51:43');
INSERT INTO `access_log` VALUES (60642, '64.83.15644047030152683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.208.61.56', '2019-07-29 20:51:43', 2, 0, '', '2019-07-29 20:51:43');
INSERT INTO `access_log` VALUES (60643, '59.73.15644047043652411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.208.61.56', '2019-07-29 20:51:44', 4, 0, '', '2019-07-29 20:51:44');
INSERT INTO `access_log` VALUES (60644, '59.77.15644047043672401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '222.208.61.56', '2019-07-29 20:51:44', 25, 2001001000, '服务端发生异常', '2019-07-29 20:51:44');
INSERT INTO `access_log` VALUES (60645, '65.51.15644047241024919', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.208.61.56', '2019-07-29 20:52:04', 0, 1002001015, '账号未登陆', '2019-07-29 20:52:04');
INSERT INTO `access_log` VALUES (60646, '65.45.15644047241024857', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.208.61.56', '2019-07-29 20:52:04', 1, 1002001015, '账号未登陆', '2019-07-29 20:52:04');
INSERT INTO `access_log` VALUES (60647, '65.53.15644047241234847', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.208.61.56', '2019-07-29 20:52:04', 0, 1002001015, '账号未登陆', '2019-07-29 20:52:04');
INSERT INTO `access_log` VALUES (60648, '65.49.15644047262534829', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.208.61.56', '2019-07-29 20:52:06', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 20:52:06');
INSERT INTO `access_log` VALUES (60649, '65.52.15644047295144885', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.208.61.56', '2019-07-29 20:52:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 20:52:10');
INSERT INTO `access_log` VALUES (60650, '65.50.15644047476584849', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.208.61.56', '2019-07-29 20:52:28', 75, 0, '', '2019-07-29 20:52:28');
INSERT INTO `access_log` VALUES (60651, '65.46.15644047480564917', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.208.61.56', '2019-07-29 20:52:28', 12, 0, '', '2019-07-29 20:52:28');
INSERT INTO `access_log` VALUES (60652, '65.47.15644047480584843', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.208.61.56', '2019-07-29 20:52:28', 12, 2001001000, '服务端发生异常', '2019-07-29 20:52:28');
INSERT INTO `access_log` VALUES (60653, '65.45.15644047480644859', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.208.61.56', '2019-07-29 20:52:28', 8, 0, '', '2019-07-29 20:52:28');
INSERT INTO `access_log` VALUES (60654, '65.51.15644047553484921', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.208.61.56', '2019-07-29 20:52:35', 10, 0, '', '2019-07-29 20:52:35');
INSERT INTO `access_log` VALUES (60655, '65.53.15644047553504849', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.208.61.56', '2019-07-29 20:52:35', 11, 2001001000, '服务端发生异常', '2019-07-29 20:52:35');
INSERT INTO `access_log` VALUES (60656, '65.49.15644047553564831', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '222.208.61.56', '2019-07-29 20:52:35', 9, 0, '', '2019-07-29 20:52:35');
INSERT INTO `access_log` VALUES (60657, '65.45.15644057087974873', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.96.106.123', '2019-07-29 21:08:29', 4, 1002001012, '访问令牌已过期', '2019-07-29 21:08:29');
INSERT INTO `access_log` VALUES (60658, '65.47.15644057088134857', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.96.106.123', '2019-07-29 21:08:29', 3, 1002001012, '访问令牌已过期', '2019-07-29 21:08:29');
INSERT INTO `access_log` VALUES (60659, '65.46.15644057088334931', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.96.106.123', '2019-07-29 21:08:29', 4, 1002001012, '访问令牌已过期', '2019-07-29 21:08:29');
INSERT INTO `access_log` VALUES (60660, '65.51.15644057195744935', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.96.106.123', '2019-07-29 21:08:40', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 21:08:40');
INSERT INTO `access_log` VALUES (60661, '65.49.15644057321534845', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.96.106.123', '2019-07-29 21:08:52', 76, 0, '', '2019-07-29 21:08:52');
INSERT INTO `access_log` VALUES (60662, '65.54.15644057329044787', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.96.106.123', '2019-07-29 21:08:53', 10, 0, '', '2019-07-29 21:08:53');
INSERT INTO `access_log` VALUES (60663, '65.3607.15644057329246661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.96.106.123', '2019-07-29 21:08:53', 9, 0, '', '2019-07-29 21:08:53');
INSERT INTO `access_log` VALUES (60664, '65.52.15644057329244901', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.96.106.123', '2019-07-29 21:08:53', 10, 2001001000, '服务端发生异常', '2019-07-29 21:08:53');
INSERT INTO `access_log` VALUES (60665, '65.49.15644058106244847', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.96.106.123', '2019-07-29 21:10:11', 0, 1002001015, '账号未登陆', '2019-07-29 21:10:11');
INSERT INTO `access_log` VALUES (60666, '65.52.15644058106944903', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.96.106.123', '2019-07-29 21:10:11', 0, 1002001015, '账号未登陆', '2019-07-29 21:10:11');
INSERT INTO `access_log` VALUES (60667, '65.3607.15644058106956663', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.96.106.123', '2019-07-29 21:10:11', 1, 1002001015, '账号未登陆', '2019-07-29 21:10:11');
INSERT INTO `access_log` VALUES (60668, '65.54.15644058219044789', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.96.106.123', '2019-07-29 21:10:22', 0, 1002001015, '账号未登陆', '2019-07-29 21:10:22');
INSERT INTO `access_log` VALUES (60669, '59.79.15644062429552435', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:23', 3, 0, '', '2019-07-29 21:17:23');
INSERT INTO `access_log` VALUES (60670, '59.71.15644062429552427', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:23', 22, 2001001000, '服务端发生异常', '2019-07-29 21:17:23');
INSERT INTO `access_log` VALUES (60671, '64.82.15644062487712723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:29', 3, 0, '', '2019-07-29 21:17:29');
INSERT INTO `access_log` VALUES (60672, '64.84.15644062489712699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:29', 2, 0, '', '2019-07-29 21:17:29');
INSERT INTO `access_log` VALUES (60673, '64.85.15644062500222745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:30', 2, 0, '', '2019-07-29 21:17:30');
INSERT INTO `access_log` VALUES (60674, '64.78.15644062527952713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:33', 1, 0, '', '2019-07-29 21:17:33');
INSERT INTO `access_log` VALUES (60675, '64.77.15644062529032701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:33', 2, 0, '', '2019-07-29 21:17:33');
INSERT INTO `access_log` VALUES (60676, '59.78.15644062537952435', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:34', 3, 0, '', '2019-07-29 21:17:34');
INSERT INTO `access_log` VALUES (60677, '59.80.15644062537952405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:34', 32, 2001001000, '服务端发生异常', '2019-07-29 21:17:34');
INSERT INTO `access_log` VALUES (60678, '65.50.15644062607054873', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:41', 0, 1002001015, '账号未登陆', '2019-07-29 21:17:41');
INSERT INTO `access_log` VALUES (60679, '65.45.15644062607064883', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:41', 0, 1002001015, '账号未登陆', '2019-07-29 21:17:41');
INSERT INTO `access_log` VALUES (60680, '65.47.15644062607134867', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:41', 0, 1002001015, '账号未登陆', '2019-07-29 21:17:41');
INSERT INTO `access_log` VALUES (60681, '65.46.15644062638744941', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 21:17:44');
INSERT INTO `access_log` VALUES (60682, '65.53.15644062673044873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-29 21:17:47');
INSERT INTO `access_log` VALUES (60683, '65.49.15644062752964855', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:55', 53, 0, '', '2019-07-29 21:17:55');
INSERT INTO `access_log` VALUES (60684, '65.52.15644062756504911', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:56', 10, 0, '', '2019-07-29 21:17:56');
INSERT INTO `access_log` VALUES (60685, '65.3607.15644062756576671', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:56', 9, 2001001000, '服务端发生异常', '2019-07-29 21:17:56');
INSERT INTO `access_log` VALUES (60686, '65.54.15644062756654797', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:17:56', 9, 0, '', '2019-07-29 21:17:56');
INSERT INTO `access_log` VALUES (60687, '65.54.15644067510764803', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:25:51', 10, 0, '', '2019-07-29 21:25:51');
INSERT INTO `access_log` VALUES (60688, '65.45.15644067510784893', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:25:51', 8, 2001001000, '服务端发生异常', '2019-07-29 21:25:51');
INSERT INTO `access_log` VALUES (60689, '65.50.15644067510974881', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.144.216.88', '2019-07-29 21:25:51', 8, 0, '', '2019-07-29 21:25:51');
INSERT INTO `access_log` VALUES (60690, '59.78.15644153725682557', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.238.194.168', '2019-07-29 23:49:33', 10, 0, '', '2019-07-29 23:49:33');
INSERT INTO `access_log` VALUES (60691, '59.80.15644153725692527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.238.194.169', '2019-07-29 23:49:33', 19, 2001001000, '服务端发生异常', '2019-07-29 23:49:33');
INSERT INTO `access_log` VALUES (60692, '64.77.15644153781192823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.238.194.169', '2019-07-29 23:49:38', 12, 0, '', '2019-07-29 23:49:38');
INSERT INTO `access_log` VALUES (60693, '64.79.15644153783172829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.238.194.169', '2019-07-29 23:49:38', 4, 0, '', '2019-07-29 23:49:38');
INSERT INTO `access_log` VALUES (60694, '64.83.15644153803652827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.238.194.169', '2019-07-29 23:49:40', 2, 0, '', '2019-07-29 23:49:40');
INSERT INTO `access_log` VALUES (60695, '64.80.15644153811892839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.2; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.238.194.169', '2019-07-29 23:49:41', 2, 0, '', '2019-07-29 23:49:41');
INSERT INTO `access_log` VALUES (60696, '65.54.15644458635045325', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-30 08:17:44', 18, 1002001012, '访问令牌已过期', '2019-07-30 08:17:44');
INSERT INTO `access_log` VALUES (60697, '65.50.15644458635085403', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-30 08:17:44', 16, 1002001012, '访问令牌已过期', '2019-07-30 08:17:44');
INSERT INTO `access_log` VALUES (60698, '65.47.15644458635085399', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-30 08:17:44', 17, 1002001012, '访问令牌已过期', '2019-07-30 08:17:44');
INSERT INTO `access_log` VALUES (60699, '65.46.15644458728155471', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-30 08:17:53', 81, 0, '', '2019-07-30 08:17:53');
INSERT INTO `access_log` VALUES (60700, '65.53.15644458731245403', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-30 08:17:53', 13, 0, '', '2019-07-30 08:17:53');
INSERT INTO `access_log` VALUES (60701, '65.51.15644458731305477', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-30 08:17:53', 13, 2001001000, '服务端发生异常', '2019-07-30 08:17:53');
INSERT INTO `access_log` VALUES (60702, '65.49.15644458731315387', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-30 08:17:53', 15, 0, '', '2019-07-30 08:17:53');
INSERT INTO `access_log` VALUES (60703, '65.3607.15644458874027201', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-30 08:18:07', 9, 0, '', '2019-07-30 08:18:07');
INSERT INTO `access_log` VALUES (60704, '65.45.15644458874045417', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-30 08:18:07', 10, 2001001000, '服务端发生异常', '2019-07-30 08:18:07');
INSERT INTO `access_log` VALUES (60705, '65.50.15644458874085405', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-30 08:18:07', 9, 0, '', '2019-07-30 08:18:07');
INSERT INTO `access_log` VALUES (60706, '65.47.15644459027055401', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-30 08:18:23', 9, 0, '', '2019-07-30 08:18:23');
INSERT INTO `access_log` VALUES (60707, '65.46.15644459027115473', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-30 08:18:23', 8, 2001001000, '服务端发生异常', '2019-07-30 08:18:23');
INSERT INTO `access_log` VALUES (60708, '65.53.15644459027135405', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.236.62.130', '2019-07-30 08:18:23', 8, 0, '', '2019-07-30 08:18:23');
INSERT INTO `access_log` VALUES (60709, '65.51.15644490517535521', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.210.222', '2019-07-30 09:10:52', 0, 1002001015, '账号未登陆', '2019-07-30 09:10:52');
INSERT INTO `access_log` VALUES (60710, '65.49.15644490517535431', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.210.222', '2019-07-30 09:10:52', 0, 1002001015, '账号未登陆', '2019-07-30 09:10:52');
INSERT INTO `access_log` VALUES (60711, '65.52.15644490517705487', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.210.222', '2019-07-30 09:10:52', 1, 1002001015, '账号未登陆', '2019-07-30 09:10:52');
INSERT INTO `access_log` VALUES (60712, '65.50.15644490570375449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.210.222', '2019-07-30 09:10:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 09:10:57');
INSERT INTO `access_log` VALUES (60713, '65.3607.15644490614597245', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.210.222', '2019-07-30 09:11:01', 66, 0, '', '2019-07-30 09:11:02');
INSERT INTO `access_log` VALUES (60714, '65.54.15644490619095371', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.210.222', '2019-07-30 09:11:02', 10, 0, '', '2019-07-30 09:11:02');
INSERT INTO `access_log` VALUES (60715, '65.53.15644490619135449', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.210.222', '2019-07-30 09:11:02', 12, 2001001000, '服务端发生异常', '2019-07-30 09:11:02');
INSERT INTO `access_log` VALUES (60716, '65.46.15644490619175517', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.210.222', '2019-07-30 09:11:02', 10, 0, '', '2019-07-30 09:11:02');
INSERT INTO `access_log` VALUES (60717, '65.47.15644490890455445', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.210.222', '2019-07-30 09:11:29', 10, 0, '', '2019-07-30 09:11:29');
INSERT INTO `access_log` VALUES (60718, '65.49.15644490890505435', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.210.222', '2019-07-30 09:11:29', 8, 0, '', '2019-07-30 09:11:29');
INSERT INTO `access_log` VALUES (60719, '65.51.15644490890485525', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.210.222', '2019-07-30 09:11:29', 11, 2001001000, '服务端发生异常', '2019-07-30 09:11:29');
INSERT INTO `access_log` VALUES (60720, '65.45.15644491095975463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.126.210.222', '2019-07-30 09:11:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 09:11:50');
INSERT INTO `access_log` VALUES (60721, '59.78.15644501415213021', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:02', 11, 0, '', '2019-07-30 09:29:02');
INSERT INTO `access_log` VALUES (60722, '59.80.15644501415232991', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:02', 26, 2001001000, '服务端发生异常', '2019-07-30 09:29:02');
INSERT INTO `access_log` VALUES (60723, '65.49.15644501446425449', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:05', 1, 1002001015, '账号未登陆', '2019-07-30 09:29:05');
INSERT INTO `access_log` VALUES (60724, '65.52.15644501446455505', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:05', 0, 1002001015, '账号未登陆', '2019-07-30 09:29:05');
INSERT INTO `access_log` VALUES (60725, '65.45.15644501446475479', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:05', 0, 1002001015, '账号未登陆', '2019-07-30 09:29:05');
INSERT INTO `access_log` VALUES (60726, '64.83.15644501498903291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:10', 13, 0, '', '2019-07-30 09:29:10');
INSERT INTO `access_log` VALUES (60727, '64.80.15644501499963303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:10', 3, 0, '', '2019-07-30 09:29:10');
INSERT INTO `access_log` VALUES (60728, '64.76.15644501539023289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:14', 2, 0, '', '2019-07-30 09:29:14');
INSERT INTO `access_log` VALUES (60729, '64.81.15644501539983295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:14', 2, 0, '', '2019-07-30 09:29:14');
INSERT INTO `access_log` VALUES (60730, '64.82.15644501575333311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:18', 2, 0, '', '2019-07-30 09:29:18');
INSERT INTO `access_log` VALUES (60731, '64.84.15644501576313287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:18', 3, 0, '', '2019-07-30 09:29:18');
INSERT INTO `access_log` VALUES (60732, '64.85.15644501584433333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:18', 1, 0, '', '2019-07-30 09:29:18');
INSERT INTO `access_log` VALUES (60733, '64.78.15644501589633301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:19', 1, 0, '', '2019-07-30 09:29:19');
INSERT INTO `access_log` VALUES (60734, '64.79.15644501646223295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:25', 1, 0, '', '2019-07-30 09:29:25');
INSERT INTO `access_log` VALUES (60735, '64.83.15644501647313293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:25', 2, 0, '', '2019-07-30 09:29:25');
INSERT INTO `access_log` VALUES (60736, '59.77.15644501665713009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:27', 3, 0, '', '2019-07-30 09:29:27');
INSERT INTO `access_log` VALUES (60737, '59.75.15644501665713027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:27', 19, 2001001000, '服务端发生异常', '2019-07-30 09:29:27');
INSERT INTO `access_log` VALUES (60738, '65.3607.15644501706797265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 09:29:31');
INSERT INTO `access_log` VALUES (60739, '65.46.15644501843255533', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:44', 73, 0, '', '2019-07-30 09:29:44');
INSERT INTO `access_log` VALUES (60740, '65.47.15644501846665463', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:45', 10, 0, '', '2019-07-30 09:29:45');
INSERT INTO `access_log` VALUES (60741, '65.51.15644501846675541', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:45', 12, 2001001000, '服务端发生异常', '2019-07-30 09:29:45');
INSERT INTO `access_log` VALUES (60742, '65.49.15644501846705451', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '220.175.55.181', '2019-07-30 09:29:45', 13, 0, '', '2019-07-30 09:29:45');
INSERT INTO `access_log` VALUES (60743, '65.51.15644504287695545', 0, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'displayName=男&enumValue=gender&sort=123&value=1&memo=你猜我猜不猜', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.78.31.80', '2019-07-30 09:33:49', 1, 1002001015, '账号未登陆', '2019-07-30 09:33:49');
INSERT INTO `access_log` VALUES (60744, '59.71.15644538182473063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.62.201.36', '2019-07-30 10:30:18', 15, 0, '', '2019-07-30 10:30:18');
INSERT INTO `access_log` VALUES (60745, '59.80.15644538182483041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.62.201.36', '2019-07-30 10:30:18', 27, 2001001000, '服务端发生异常', '2019-07-30 10:30:18');
INSERT INTO `access_log` VALUES (60746, '64.81.15644538374013347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.62.201.36', '2019-07-30 10:30:37', 10, 0, '', '2019-07-30 10:30:37');
INSERT INTO `access_log` VALUES (60747, '64.84.15644538434833339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.62.201.36', '2019-07-30 10:30:43', 3, 0, '', '2019-07-30 10:30:43');
INSERT INTO `access_log` VALUES (60748, '65.46.15644538787545583', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.62.201.36', '2019-07-30 10:31:19', 1, 1002001015, '账号未登陆', '2019-07-30 10:31:19');
INSERT INTO `access_log` VALUES (60749, '65.51.15644538787545591', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.62.201.36', '2019-07-30 10:31:19', 0, 1002001015, '账号未登陆', '2019-07-30 10:31:19');
INSERT INTO `access_log` VALUES (60750, '65.49.15644538787565503', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.62.201.36', '2019-07-30 10:31:19', 1, 1002001015, '账号未登陆', '2019-07-30 10:31:19');
INSERT INTO `access_log` VALUES (60751, '59.77.15644553061333079', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.14', '2019-07-30 10:55:06', 4, 0, '', '2019-07-30 10:55:06');
INSERT INTO `access_log` VALUES (60752, '59.75.15644553061333097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.14', '2019-07-30 10:55:06', 13, 2001001000, '服务端发生异常', '2019-07-30 10:55:06');
INSERT INTO `access_log` VALUES (60753, '64.81.15644553097733367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.14', '2019-07-30 10:55:10', 52, 0, '', '2019-07-30 10:55:10');
INSERT INTO `access_log` VALUES (60754, '64.84.15644553099503359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.14', '2019-07-30 10:55:10', 2, 0, '', '2019-07-30 10:55:10');
INSERT INTO `access_log` VALUES (60755, '64.85.15644553126023405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.14', '2019-07-30 10:55:13', 2, 0, '', '2019-07-30 10:55:13');
INSERT INTO `access_log` VALUES (60756, '64.77.15644553127363359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.14', '2019-07-30 10:55:13', 3, 0, '', '2019-07-30 10:55:13');
INSERT INTO `access_log` VALUES (60757, '59.74.15644553154253101', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.14', '2019-07-30 10:55:15', 3, 0, '', '2019-07-30 10:55:15');
INSERT INTO `access_log` VALUES (60758, '59.72.15644553154253083', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.139.197.14', '2019-07-30 10:55:15', 14, 2001001000, '服务端发生异常', '2019-07-30 10:55:15');
INSERT INTO `access_log` VALUES (60759, '65.47.15644553379405533', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.62.201.36', '2019-07-30 10:55:38', 69, 0, '', '2019-07-30 10:55:38');
INSERT INTO `access_log` VALUES (60760, '65.45.15644553384625551', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.62.201.36', '2019-07-30 10:55:38', 20, 0, '', '2019-07-30 10:55:38');
INSERT INTO `access_log` VALUES (60761, '65.52.15644553384625577', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.62.201.36', '2019-07-30 10:55:38', 20, 2001001000, '服务端发生异常', '2019-07-30 10:55:38');
INSERT INTO `access_log` VALUES (60762, '65.50.15644553384975541', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.62.201.36', '2019-07-30 10:55:38', 9, 0, '', '2019-07-30 10:55:39');
INSERT INTO `access_log` VALUES (60763, '65.47.15644566060925551', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.46.67', '2019-07-30 11:16:46', 0, 1002001015, '账号未登陆', '2019-07-30 11:16:46');
INSERT INTO `access_log` VALUES (60764, '65.49.15644566060925541', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.46.67', '2019-07-30 11:16:46', 1, 1002001015, '账号未登陆', '2019-07-30 11:16:46');
INSERT INTO `access_log` VALUES (60765, '65.52.15644566060965595', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.46.67', '2019-07-30 11:16:46', 0, 1002001015, '账号未登陆', '2019-07-30 11:16:46');
INSERT INTO `access_log` VALUES (60766, '65.45.15644566084245569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.46.67', '2019-07-30 11:16:48', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 11:16:48');
INSERT INTO `access_log` VALUES (60767, '65.50.15644566128525559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.46.67', '2019-07-30 11:16:53', 90, 0, '', '2019-07-30 11:16:53');
INSERT INTO `access_log` VALUES (60768, '65.3607.15644566132047355', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.46.67', '2019-07-30 11:16:53', 12, 0, '', '2019-07-30 11:16:53');
INSERT INTO `access_log` VALUES (60769, '65.53.15644566132045559', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.46.67', '2019-07-30 11:16:53', 13, 0, '', '2019-07-30 11:16:53');
INSERT INTO `access_log` VALUES (60770, '65.54.15644566132045479', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '117.136.46.67', '2019-07-30 11:16:53', 14, 2001001000, '服务端发生异常', '2019-07-30 11:16:53');
INSERT INTO `access_log` VALUES (60771, '59.78.15644579008753127', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '36.7.154.161', '2019-07-30 11:38:21', 10, 0, '', '2019-07-30 11:38:21');
INSERT INTO `access_log` VALUES (60772, '59.76.15644579008763109', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '36.7.154.161', '2019-07-30 11:38:21', 28, 2001001000, '服务端发生异常', '2019-07-30 11:38:21');
INSERT INTO `access_log` VALUES (60773, '64.76.15644579031193397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '36.7.154.161', '2019-07-30 11:38:23', 9, 0, '', '2019-07-30 11:38:23');
INSERT INTO `access_log` VALUES (60774, '64.80.15644579032283409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '36.7.154.161', '2019-07-30 11:38:23', 2, 0, '', '2019-07-30 11:38:23');
INSERT INTO `access_log` VALUES (60775, '64.82.15644579043843419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '36.7.154.161', '2019-07-30 11:38:24', 2, 0, '', '2019-07-30 11:38:24');
INSERT INTO `access_log` VALUES (60776, '64.81.15644579046673403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '36.7.154.161', '2019-07-30 11:38:25', 2, 0, '', '2019-07-30 11:38:25');
INSERT INTO `access_log` VALUES (60777, '64.84.15644579050483395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '36.7.154.161', '2019-07-30 11:38:25', 2, 0, '', '2019-07-30 11:38:25');
INSERT INTO `access_log` VALUES (60778, '59.73.15644579059473125', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '36.7.154.161', '2019-07-30 11:38:26', 3, 0, '', '2019-07-30 11:38:26');
INSERT INTO `access_log` VALUES (60779, '59.77.15644579059493115', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '36.7.154.161', '2019-07-30 11:38:26', 15, 2001001000, '服务端发生异常', '2019-07-30 11:38:26');
INSERT INTO `access_log` VALUES (60780, '59.74.15644585230363145', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:48:43', 3, 0, '', '2019-07-30 11:48:43');
INSERT INTO `access_log` VALUES (60781, '59.72.15644585230363127', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:48:43', 34, 2001001000, '服务端发生异常', '2019-07-30 11:48:43');
INSERT INTO `access_log` VALUES (60782, '65.53.15644586727085587', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:51:13', 5, 1002001012, '访问令牌已过期', '2019-07-30 11:51:13');
INSERT INTO `access_log` VALUES (60783, '65.54.15644586727105507', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:51:13', 4, 1002001012, '访问令牌已过期', '2019-07-30 11:51:13');
INSERT INTO `access_log` VALUES (60784, '65.46.15644586727295651', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:51:13', 14, 1002001012, '访问令牌已过期', '2019-07-30 11:51:13');
INSERT INTO `access_log` VALUES (60785, '65.51.15644586823315659', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:51:22', 6, 1002002000, '账号不存在', '2019-07-30 11:51:22');
INSERT INTO `access_log` VALUES (60786, '65.52.15644586862065625', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:51:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 11:51:26');
INSERT INTO `access_log` VALUES (60787, '65.47.15644586907425581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:51:31', 73, 0, '', '2019-07-30 11:51:31');
INSERT INTO `access_log` VALUES (60788, '65.45.15644586912185599', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:51:31', 10, 0, '', '2019-07-30 11:51:31');
INSERT INTO `access_log` VALUES (60789, '65.50.15644586912215589', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:51:31', 9, 0, '', '2019-07-30 11:51:31');
INSERT INTO `access_log` VALUES (60790, '65.3607.15644586912277385', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:51:31', 9, 0, '', '2019-07-30 11:51:31');
INSERT INTO `access_log` VALUES (60791, '62.86.15644586962832107', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:51:36', 36, 0, '', '2019-07-30 11:51:36');
INSERT INTO `access_log` VALUES (60792, '62.84.15644586988942113', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:51:39', 22, 0, '', '2019-07-30 11:51:39');
INSERT INTO `access_log` VALUES (60793, '66.48.15644587033320899', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:51:43', 20, 0, '', '2019-07-30 11:51:43');
INSERT INTO `access_log` VALUES (60794, '59.80.15644587053213107', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:51:45', 16, 0, '', '2019-07-30 11:51:45');
INSERT INTO `access_log` VALUES (60795, '65.54.15644587071015509', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:51:47', 19, 0, '', '2019-07-30 11:51:47');
INSERT INTO `access_log` VALUES (60796, '65.3607.15644588146707387', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:53:35', 93, 0, '', '2019-07-30 11:53:35');
INSERT INTO `access_log` VALUES (60797, '65.53.15644588156005591', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:53:36', 10, 0, '', '2019-07-30 11:53:36');
INSERT INTO `access_log` VALUES (60798, '65.54.15644588166775511', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:53:37', 625, 0, '', '2019-07-30 11:53:37');
INSERT INTO `access_log` VALUES (60799, '65.46.15644588176175655', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:53:38', 28, 0, '', '2019-07-30 11:53:38');
INSERT INTO `access_log` VALUES (60800, '59.71.15644588212163133', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:53:41', 26, 2001001000, '服务端发生异常', '2019-07-30 11:53:41');
INSERT INTO `access_log` VALUES (60801, '59.80.15644588260883109', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 11:53:46', 14, 0, '', '2019-07-30 11:53:46');
INSERT INTO `access_log` VALUES (60802, '59.79.15644589135833141', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.222.36.207', '2019-07-30 11:55:14', 3, 0, '', '2019-07-30 11:55:14');
INSERT INTO `access_log` VALUES (60803, '59.72.15644589135833133', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.222.36.207', '2019-07-30 11:55:14', 13, 2001001000, '服务端发生异常', '2019-07-30 11:55:14');
INSERT INTO `access_log` VALUES (60804, '59.71.15644589172623135', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.222.36.207', '2019-07-30 11:55:17', 2, 0, '', '2019-07-30 11:55:17');
INSERT INTO `access_log` VALUES (60805, '59.80.15644589172653111', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.222.36.207', '2019-07-30 11:55:17', 16, 2001001000, '服务端发生异常', '2019-07-30 11:55:17');
INSERT INTO `access_log` VALUES (60806, '65.53.15644589224645593', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.222.36.207', '2019-07-30 11:55:22', 1, 1002001015, '账号未登陆', '2019-07-30 11:55:22');
INSERT INTO `access_log` VALUES (60807, '65.54.15644589224675513', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.222.36.207', '2019-07-30 11:55:22', 1, 1002001015, '账号未登陆', '2019-07-30 11:55:22');
INSERT INTO `access_log` VALUES (60808, '65.46.15644589224705657', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.222.36.207', '2019-07-30 11:55:22', 0, 1002001015, '账号未登陆', '2019-07-30 11:55:22');
INSERT INTO `access_log` VALUES (60809, '65.49.15644589241415577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.222.36.207', '2019-07-30 11:55:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 11:55:24');
INSERT INTO `access_log` VALUES (60810, '59.79.15644682887303267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.234.29.130', '2019-07-30 14:31:29', 10, 0, '', '2019-07-30 14:31:29');
INSERT INTO `access_log` VALUES (60811, '59.74.15644682887303277', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.234.29.130', '2019-07-30 14:31:29', 15, 2001001000, '服务端发生异常', '2019-07-30 14:31:29');
INSERT INTO `access_log` VALUES (60812, '64.82.15644682940033559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.234.29.130', '2019-07-30 14:31:34', 1092, 0, '', '2019-07-30 14:31:35');
INSERT INTO `access_log` VALUES (60813, '64.85.15644682955923581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '42.234.29.130', '2019-07-30 14:31:36', 3, 0, '', '2019-07-30 14:31:36');
INSERT INTO `access_log` VALUES (60814, '59.76.15644684957433253', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-30 14:34:56', 4, 0, '', '2019-07-30 14:34:56');
INSERT INTO `access_log` VALUES (60815, '59.73.15644684957443269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-30 14:34:56', 14, 2001001000, '服务端发生异常', '2019-07-30 14:34:56');
INSERT INTO `access_log` VALUES (60816, '65.51.15644685014075793', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-30 14:35:01', 11, 1002001012, '访问令牌已过期', '2019-07-30 14:35:01');
INSERT INTO `access_log` VALUES (60817, '65.49.15644685014075705', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-30 14:35:01', 11, 1002001012, '访问令牌已过期', '2019-07-30 14:35:01');
INSERT INTO `access_log` VALUES (60818, '65.52.15644685014095759', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-30 14:35:01', 14, 1002001012, '访问令牌已过期', '2019-07-30 14:35:01');
INSERT INTO `access_log` VALUES (60819, '65.47.15644685042095715', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-30 14:35:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 14:35:04');
INSERT INTO `access_log` VALUES (60820, '65.50.15644685070685723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-30 14:35:07', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 14:35:07');
INSERT INTO `access_log` VALUES (60821, '65.3607.15644685222447519', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-30 14:35:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 14:35:22');
INSERT INTO `access_log` VALUES (60822, '65.53.15644685522785723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-30 14:35:52', 5, 1002002000, '账号不存在', '2019-07-30 14:35:52');
INSERT INTO `access_log` VALUES (60823, '65.52.15644685591375761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-30 14:35:59', 211, 0, '', '2019-07-30 14:35:59');
INSERT INTO `access_log` VALUES (60824, '65.51.15644685597575795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-30 14:36:00', 18, 0, '', '2019-07-30 14:36:00');
INSERT INTO `access_log` VALUES (60825, '65.47.15644685597615717', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-30 14:36:00', 17, 2001001000, '服务端发生异常', '2019-07-30 14:36:00');
INSERT INTO `access_log` VALUES (60826, '65.50.15644685597625725', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-30 14:36:00', 18, 0, '', '2019-07-30 14:36:00');
INSERT INTO `access_log` VALUES (60827, '59.75.15644686440913279', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.130.109.194', '2019-07-30 14:37:24', 3, 0, '', '2019-07-30 14:37:24');
INSERT INTO `access_log` VALUES (60828, '59.77.15644686440913261', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.130.109.194', '2019-07-30 14:37:24', 13, 2001001000, '服务端发生异常', '2019-07-30 14:37:24');
INSERT INTO `access_log` VALUES (60829, '64.79.15644686489943543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.130.109.194', '2019-07-30 14:37:29', 2, 0, '', '2019-07-30 14:37:29');
INSERT INTO `access_log` VALUES (60830, '64.76.15644686490763543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.130.109.194', '2019-07-30 14:37:29', 2, 0, '', '2019-07-30 14:37:29');
INSERT INTO `access_log` VALUES (60831, '64.80.15644686505403555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.130.109.194', '2019-07-30 14:37:31', 2, 0, '', '2019-07-30 14:37:31');
INSERT INTO `access_log` VALUES (60832, '64.84.15644686513113541', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.130.109.194', '2019-07-30 14:37:31', 1, 0, '', '2019-07-30 14:37:31');
INSERT INTO `access_log` VALUES (60833, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=123&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.130.109.194', '2019-07-30 14:37:33', 6, 0, '', '2019-07-30 14:37:33');
INSERT INTO `access_log` VALUES (60834, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=123', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.130.109.194', '2019-07-30 14:37:33', 7, 0, '', '2019-07-30 14:37:33');
INSERT INTO `access_log` VALUES (60835, '64.81.15644686551713549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.130.109.194', '2019-07-30 14:37:35', 2, 0, '', '2019-07-30 14:37:35');
INSERT INTO `access_log` VALUES (60836, '64.82.15644686552743565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.130.109.194', '2019-07-30 14:37:35', 2, 0, '', '2019-07-30 14:37:35');
INSERT INTO `access_log` VALUES (60837, '59.74.15644686575173283', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.130.109.194', '2019-07-30 14:37:38', 2, 0, '', '2019-07-30 14:37:38');
INSERT INTO `access_log` VALUES (60838, '59.72.15644686575193265', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.130.109.194', '2019-07-30 14:37:38', 19, 2001001000, '服务端发生异常', '2019-07-30 14:37:38');
INSERT INTO `access_log` VALUES (60839, '64.77.15644686603543541', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.130.109.194', '2019-07-30 14:37:40', 2, 0, '', '2019-07-30 14:37:40');
INSERT INTO `access_log` VALUES (60840, '64.78.15644686604633553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.130.109.194', '2019-07-30 14:37:40', 2, 0, '', '2019-07-30 14:37:40');
INSERT INTO `access_log` VALUES (60841, '65.46.15644703904565813', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.132.215.24', '2019-07-30 15:06:30', 0, 1002001015, '账号未登陆', '2019-07-30 15:06:30');
INSERT INTO `access_log` VALUES (60842, '65.54.15644703904565671', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.132.215.24', '2019-07-30 15:06:30', 0, 1002001015, '账号未登陆', '2019-07-30 15:06:30');
INSERT INTO `access_log` VALUES (60843, '65.3607.15644703904567547', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.132.215.24', '2019-07-30 15:06:30', 0, 1002001015, '账号未登陆', '2019-07-30 15:06:30');
INSERT INTO `access_log` VALUES (60844, '65.53.15644703948435749', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.132.215.24', '2019-07-30 15:06:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 15:06:35');
INSERT INTO `access_log` VALUES (60845, '65.52.15644704004345789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.132.215.24', '2019-07-30 15:06:40', 83, 0, '', '2019-07-30 15:06:41');
INSERT INTO `access_log` VALUES (60846, '65.47.15644704010605743', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.132.215.24', '2019-07-30 15:06:41', 18, 0, '', '2019-07-30 15:06:41');
INSERT INTO `access_log` VALUES (60847, '65.51.15644704010615821', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.132.215.24', '2019-07-30 15:06:41', 18, 2001001000, '服务端发生异常', '2019-07-30 15:06:41');
INSERT INTO `access_log` VALUES (60848, '65.50.15644704010995751', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.132.215.24', '2019-07-30 15:06:41', 9, 0, '', '2019-07-30 15:06:41');
INSERT INTO `access_log` VALUES (60849, '65.45.15644704081075761', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.132.215.24', '2019-07-30 15:06:48', 10, 0, '', '2019-07-30 15:06:48');
INSERT INTO `access_log` VALUES (60850, '65.46.15644704081075815', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.132.215.24', '2019-07-30 15:06:48', 12, 2001001000, '服务端发生异常', '2019-07-30 15:06:48');
INSERT INTO `access_log` VALUES (60851, '65.3607.15644704081097549', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.132.215.24', '2019-07-30 15:06:48', 9, 0, '', '2019-07-30 15:06:48');
INSERT INTO `access_log` VALUES (60852, '59.79.15644704157763297', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '106.57.85.239', '2019-07-30 15:06:56', 3, 0, '', '2019-07-30 15:06:56');
INSERT INTO `access_log` VALUES (60853, '59.74.15644704157763307', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '106.57.85.239', '2019-07-30 15:06:56', 39, 2001001000, '服务端发生异常', '2019-07-30 15:06:56');
INSERT INTO `access_log` VALUES (60854, '59.72.15644704237843289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.132.215.24', '2019-07-30 15:07:04', 2, 0, '', '2019-07-30 15:07:04');
INSERT INTO `access_log` VALUES (60855, '59.71.15644704237853291', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.132.215.24', '2019-07-30 15:07:04', 14, 2001001000, '服务端发生异常', '2019-07-30 15:07:04');
INSERT INTO `access_log` VALUES (60856, '59.71.15644708548963297', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:15', 2, 0, '', '2019-07-30 15:14:15');
INSERT INTO `access_log` VALUES (60857, '59.80.15644708548963273', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:15', 19, 2001001000, '服务端发生异常', '2019-07-30 15:14:15');
INSERT INTO `access_log` VALUES (60858, '64.85.15644708619203617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:22', 11, 0, '', '2019-07-30 15:14:22');
INSERT INTO `access_log` VALUES (60859, '64.77.15644708620453571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:22', 3, 0, '', '2019-07-30 15:14:22');
INSERT INTO `access_log` VALUES (60860, '64.78.15644708658783583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:26', 2, 0, '', '2019-07-30 15:14:26');
INSERT INTO `access_log` VALUES (60861, '64.83.15644708660033573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:26', 2, 0, '', '2019-07-30 15:14:26');
INSERT INTO `access_log` VALUES (60862, '64.79.15644708704443575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:30', 2, 0, '', '2019-07-30 15:14:30');
INSERT INTO `access_log` VALUES (60863, '64.76.15644708705283575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:31', 2, 0, '', '2019-07-30 15:14:31');
INSERT INTO `access_log` VALUES (60864, '64.84.15644708755643573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:36', 2, 0, '', '2019-07-30 15:14:36');
INSERT INTO `access_log` VALUES (60865, '64.81.15644708756703581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:36', 2, 0, '', '2019-07-30 15:14:36');
INSERT INTO `access_log` VALUES (60866, '59.73.15644708796713303', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:40', 2, 0, '', '2019-07-30 15:14:40');
INSERT INTO `access_log` VALUES (60867, '59.75.15644708796773311', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:40', 13, 2001001000, '服务端发生异常', '2019-07-30 15:14:40');
INSERT INTO `access_log` VALUES (60868, '64.82.15644708836253597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:44', 2, 0, '', '2019-07-30 15:14:44');
INSERT INTO `access_log` VALUES (60869, '64.85.15644708838413619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:44', 2, 0, '', '2019-07-30 15:14:44');
INSERT INTO `access_log` VALUES (60870, '64.77.15644708855843573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:46', 2, 0, '', '2019-07-30 15:14:46');
INSERT INTO `access_log` VALUES (60871, '64.78.15644708863283585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:46', 2, 0, '', '2019-07-30 15:14:46');
INSERT INTO `access_log` VALUES (60872, '64.83.15644708870563575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:47', 2, 0, '', '2019-07-30 15:14:47');
INSERT INTO `access_log` VALUES (60873, '59.79.15644708886483305', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:49', 2, 0, '', '2019-07-30 15:14:49');
INSERT INTO `access_log` VALUES (60874, '59.77.15644708886483293', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:14:49', 14, 2001001000, '服务端发生异常', '2019-07-30 15:14:49');
INSERT INTO `access_log` VALUES (60875, '65.47.15644709296885751', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:15:30', 1, 1002001015, '账号未登陆', '2019-07-30 15:15:30');
INSERT INTO `access_log` VALUES (60876, '65.50.15644709296885759', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:15:30', 1, 1002001015, '账号未登陆', '2019-07-30 15:15:30');
INSERT INTO `access_log` VALUES (60877, '65.3607.15644709296947557', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:15:30', 0, 1002001015, '账号未登陆', '2019-07-30 15:15:30');
INSERT INTO `access_log` VALUES (60878, '65.45.15644709316595769', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:15:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 15:15:32');
INSERT INTO `access_log` VALUES (60879, '65.54.15644709441905681', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:15:44', 172, 0, '', '2019-07-30 15:15:44');
INSERT INTO `access_log` VALUES (60880, '65.53.15644709446285759', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:15:45', 9, 0, '', '2019-07-30 15:15:45');
INSERT INTO `access_log` VALUES (60881, '65.49.15644709446325745', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:15:45', 10, 2001001000, '服务端发生异常', '2019-07-30 15:15:45');
INSERT INTO `access_log` VALUES (60882, '65.52.15644709446385799', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:15:45', 9, 0, '', '2019-07-30 15:15:45');
INSERT INTO `access_log` VALUES (60883, '65.50.15644709706145761', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:16:11', 17, 0, '', '2019-07-30 15:16:11');
INSERT INTO `access_log` VALUES (60884, '65.47.15644709706255753', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:16:11', 9, 0, '', '2019-07-30 15:16:11');
INSERT INTO `access_log` VALUES (60885, '65.45.15644709706255771', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:16:11', 9, 2001001000, '服务端发生异常', '2019-07-30 15:16:11');
INSERT INTO `access_log` VALUES (60886, '65.46.15644709742915825', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:16:14', 9, 0, '', '2019-07-30 15:16:14');
INSERT INTO `access_log` VALUES (60887, '65.54.15644709742945683', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:16:14', 9, 2001001000, '服务端发生异常', '2019-07-30 15:16:14');
INSERT INTO `access_log` VALUES (60888, '65.52.15644709743015801', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.235.254.57', '2019-07-30 15:16:14', 9, 0, '', '2019-07-30 15:16:14');
INSERT INTO `access_log` VALUES (60889, '59.74.15644717596753327', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.58.90', '2019-07-30 15:29:20', 3, 0, '', '2019-07-30 15:29:20');
INSERT INTO `access_log` VALUES (60890, '59.77.15644717596753305', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.58.90', '2019-07-30 15:29:20', 13, 2001001000, '服务端发生异常', '2019-07-30 15:29:20');
INSERT INTO `access_log` VALUES (60891, '59.79.15644738170653345', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.185.111.50', '2019-07-30 16:03:37', 11, 0, '', '2019-07-30 16:03:37');
INSERT INTO `access_log` VALUES (60892, '59.74.15644738170763355', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.185.111.50', '2019-07-30 16:03:37', 25, 2001001000, '服务端发生异常', '2019-07-30 16:03:37');
INSERT INTO `access_log` VALUES (60893, '59.80.15644751960993333', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-07-30 16:26:36', 4, 0, '', '2019-07-30 16:26:36');
INSERT INTO `access_log` VALUES (60894, '59.71.15644751961043357', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-07-30 16:26:36', 16, 2001001000, '服务端发生异常', '2019-07-30 16:26:36');
INSERT INTO `access_log` VALUES (60895, '64.79.15644752267693635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-07-30 16:27:07', 14, 0, '', '2019-07-30 16:27:07');
INSERT INTO `access_log` VALUES (60896, '64.76.15644752269083635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-07-30 16:27:07', 3, 0, '', '2019-07-30 16:27:07');
INSERT INTO `access_log` VALUES (60897, '64.80.15644752280023647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-07-30 16:27:08', 2, 0, '', '2019-07-30 16:27:08');
INSERT INTO `access_log` VALUES (60898, '64.84.15644752283283633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-07-30 16:27:08', 1, 0, '', '2019-07-30 16:27:08');
INSERT INTO `access_log` VALUES (60899, '64.81.15644752287703641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-07-30 16:27:09', 2, 0, '', '2019-07-30 16:27:09');
INSERT INTO `access_log` VALUES (60900, '64.82.15644752291303657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-07-30 16:27:09', 2, 0, '', '2019-07-30 16:27:09');
INSERT INTO `access_log` VALUES (60901, '59.75.15644752298813371', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-07-30 16:27:10', 3, 0, '', '2019-07-30 16:27:10');
INSERT INTO `access_log` VALUES (60902, '59.73.15644752298783363', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-07-30 16:27:10', 16, 2001001000, '服务端发生异常', '2019-07-30 16:27:10');
INSERT INTO `access_log` VALUES (60903, '64.85.15644752325353679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-07-30 16:27:13', 2, 0, '', '2019-07-30 16:27:13');
INSERT INTO `access_log` VALUES (60904, '64.77.15644752326593633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-07-30 16:27:13', 2, 0, '', '2019-07-30 16:27:13');
INSERT INTO `access_log` VALUES (60905, '66.50.15644752345521107', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-07-30 16:27:15', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-07-30 16:27:15');
INSERT INTO `access_log` VALUES (60906, '65.3607.15644779631487655', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:12:43', 41, 1002001012, '访问令牌已过期', '2019-07-30 17:12:43');
INSERT INTO `access_log` VALUES (60907, '65.45.15644779653415865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:12:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 17:12:45');
INSERT INTO `access_log` VALUES (60908, '65.47.15644779681445845', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:12:48', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 17:12:48');
INSERT INTO `access_log` VALUES (60909, '65.50.15644779735035857', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:12:54', 57, 0, '', '2019-07-30 17:12:54');
INSERT INTO `access_log` VALUES (60910, '65.46.15644779738415923', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:12:54', 16, 0, '', '2019-07-30 17:12:54');
INSERT INTO `access_log` VALUES (60911, '65.54.15644779738455779', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:12:54', 22, 0, '', '2019-07-30 17:12:54');
INSERT INTO `access_log` VALUES (60912, '65.52.15644779738495901', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:12:54', 21, 0, '', '2019-07-30 17:12:54');
INSERT INTO `access_log` VALUES (60913, '62.88.15644779829242375', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:13:03', 27, 0, '', '2019-07-30 17:13:03');
INSERT INTO `access_log` VALUES (60914, '62.81.15644779856882347', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:13:06', 19, 0, '', '2019-07-30 17:13:06');
INSERT INTO `access_log` VALUES (60915, '64.81.15644780079033679', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:13:28', 29, 0, '', '2019-07-30 17:13:28');
INSERT INTO `access_log` VALUES (60916, '64.84.15644780079023671', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:13:28', 39, 0, '', '2019-07-30 17:13:28');
INSERT INTO `access_log` VALUES (60917, '64.77.15644780226253671', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:13:43', 13, 0, '', '2019-07-30 17:13:43');
INSERT INTO `access_log` VALUES (60918, '64.85.15644780226223717', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:13:43', 22, 0, '', '2019-07-30 17:13:43');
INSERT INTO `access_log` VALUES (60919, '64.79.15644780445293675', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:14:05', 12, 0, '', '2019-07-30 17:14:05');
INSERT INTO `access_log` VALUES (60920, '64.76.15644780445303675', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:14:05', 15, 0, '', '2019-07-30 17:14:05');
INSERT INTO `access_log` VALUES (60921, '64.83.15644780445293673', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:14:05', 17, 0, '', '2019-07-30 17:14:05');
INSERT INTO `access_log` VALUES (60922, '62.88.15644780810912377', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:14:41', 35, 0, '', '2019-07-30 17:14:41');
INSERT INTO `access_log` VALUES (60923, '64.85.15644780948823719', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:14:55', 14, 0, '', '2019-07-30 17:14:55');
INSERT INTO `access_log` VALUES (60924, '64.77.15644780948813673', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:14:55', 18, 0, '', '2019-07-30 17:14:55');
INSERT INTO `access_log` VALUES (60925, '64.81.15644781761633683', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:16:16', 11, 0, '', '2019-07-30 17:16:16');
INSERT INTO `access_log` VALUES (60926, '64.84.15644781761623675', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:16:16', 14, 0, '', '2019-07-30 17:16:16');
INSERT INTO `access_log` VALUES (60927, '65.47.15644781939255849', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.212.134.209', '2019-07-30 17:16:34', 1, 1002001015, '账号未登陆', '2019-07-30 17:16:34');
INSERT INTO `access_log` VALUES (60928, '65.54.15644781939375783', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.212.134.209', '2019-07-30 17:16:34', 0, 1002001015, '账号未登陆', '2019-07-30 17:16:34');
INSERT INTO `access_log` VALUES (60929, '65.50.15644781939375861', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.212.134.209', '2019-07-30 17:16:34', 0, 1002001015, '账号未登陆', '2019-07-30 17:16:34');
INSERT INTO `access_log` VALUES (60930, '65.52.15644781977625905', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.212.134.209', '2019-07-30 17:16:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 17:16:38');
INSERT INTO `access_log` VALUES (60931, '59.73.15644782027863403', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.48.96.195', '2019-07-30 17:16:43', 160, 2001001000, '服务端发生异常', '2019-07-30 17:16:43');
INSERT INTO `access_log` VALUES (60932, '59.79.15644782160713405', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.212.134.209', '2019-07-30 17:16:56', 10, 0, '', '2019-07-30 17:16:56');
INSERT INTO `access_log` VALUES (60933, '59.74.15644782160713415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.212.134.209', '2019-07-30 17:16:56', 14, 2001001000, '服务端发生异常', '2019-07-30 17:16:56');
INSERT INTO `access_log` VALUES (60934, '65.51.15644782303055933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.212.134.209', '2019-07-30 17:17:10', 84, 0, '', '2019-07-30 17:17:10');
INSERT INTO `access_log` VALUES (60935, '65.3607.15644782309497661', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.212.134.209', '2019-07-30 17:17:11', 10, 0, '', '2019-07-30 17:17:11');
INSERT INTO `access_log` VALUES (60936, '65.45.15644782309535871', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.212.134.209', '2019-07-30 17:17:11', 10, 2001001000, '服务端发生异常', '2019-07-30 17:17:11');
INSERT INTO `access_log` VALUES (60937, '65.50.15644782309765863', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.212.134.209', '2019-07-30 17:17:11', 9, 0, '', '2019-07-30 17:17:11');
INSERT INTO `access_log` VALUES (60938, '65.47.15644782383875851', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.212.134.209', '2019-07-30 17:17:18', 9, 0, '', '2019-07-30 17:17:18');
INSERT INTO `access_log` VALUES (60939, '65.54.15644782383995785', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.212.134.209', '2019-07-30 17:17:18', 17, 2001001000, '服务端发生异常', '2019-07-30 17:17:18');
INSERT INTO `access_log` VALUES (60940, '65.52.15644782384105907', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.212.134.209', '2019-07-30 17:17:18', 9, 0, '', '2019-07-30 17:17:18');
INSERT INTO `access_log` VALUES (60941, '59.80.15644788510213383', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.205.69.123', '2019-07-30 17:27:31', 4, 0, '', '2019-07-30 17:27:31');
INSERT INTO `access_log` VALUES (60942, '59.71.15644788510223407', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.205.69.123', '2019-07-30 17:27:31', 15, 2001001000, '服务端发生异常', '2019-07-30 17:27:31');
INSERT INTO `access_log` VALUES (60943, '65.53.15644788631035871', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.205.69.123', '2019-07-30 17:27:43', 1, 1002001015, '账号未登陆', '2019-07-30 17:27:43');
INSERT INTO `access_log` VALUES (60944, '65.51.15644788631085943', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.205.69.123', '2019-07-30 17:27:43', 0, 1002001015, '账号未登陆', '2019-07-30 17:27:43');
INSERT INTO `access_log` VALUES (60945, '65.3607.15644788631117671', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.205.69.123', '2019-07-30 17:27:43', 1, 1002001015, '账号未登陆', '2019-07-30 17:27:43');
INSERT INTO `access_log` VALUES (60946, '65.45.15644788662565881', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.205.69.123', '2019-07-30 17:27:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 17:27:46');
INSERT INTO `access_log` VALUES (60947, '65.47.15644788811345861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.205.69.123', '2019-07-30 17:28:01', 88, 0, '', '2019-07-30 17:28:01');
INSERT INTO `access_log` VALUES (60948, '65.54.15644788815445795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.205.69.123', '2019-07-30 17:28:02', 10, 0, '', '2019-07-30 17:28:02');
INSERT INTO `access_log` VALUES (60949, '65.46.15644788815505939', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.205.69.123', '2019-07-30 17:28:02', 8, 0, '', '2019-07-30 17:28:02');
INSERT INTO `access_log` VALUES (60950, '65.52.15644788815505917', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '115.205.69.123', '2019-07-30 17:28:02', 10, 2001001000, '服务端发生异常', '2019-07-30 17:28:02');
INSERT INTO `access_log` VALUES (60951, '59.79.15644817350063453', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '180.174.202.204', '2019-07-30 18:15:35', 10, 0, '', '2019-07-30 18:15:35');
INSERT INTO `access_log` VALUES (60952, '59.75.15644817350063459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '180.174.202.204', '2019-07-30 18:15:35', 18, 2001001000, '服务端发生异常', '2019-07-30 18:15:35');
INSERT INTO `access_log` VALUES (60953, '64.84.15644817423113723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '180.174.202.204', '2019-07-30 18:15:42', 11, 0, '', '2019-07-30 18:15:42');
INSERT INTO `access_log` VALUES (60954, '64.81.15644817424923731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '180.174.202.204', '2019-07-30 18:15:42', 4, 0, '', '2019-07-30 18:15:42');
INSERT INTO `access_log` VALUES (60955, '64.82.15644817441413747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '180.174.202.204', '2019-07-30 18:15:44', 1, 0, '', '2019-07-30 18:15:44');
INSERT INTO `access_log` VALUES (60956, '64.85.15644817450813769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '180.174.202.204', '2019-07-30 18:15:45', 2, 0, '', '2019-07-30 18:15:45');
INSERT INTO `access_log` VALUES (60957, '64.77.15644817503483723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '180.174.202.204', '2019-07-30 18:15:50', 2, 0, '', '2019-07-30 18:15:50');
INSERT INTO `access_log` VALUES (60958, '64.83.15644817508133725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '180.174.202.204', '2019-07-30 18:15:51', 1, 0, '', '2019-07-30 18:15:51');
INSERT INTO `access_log` VALUES (60959, '59.72.15644817512043445', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '180.174.202.204', '2019-07-30 18:15:51', 3, 0, '', '2019-07-30 18:15:51');
INSERT INTO `access_log` VALUES (60960, '59.77.15644817511993441', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '180.174.202.204', '2019-07-30 18:15:51', 16, 2001001000, '服务端发生异常', '2019-07-30 18:15:51');
INSERT INTO `access_log` VALUES (60961, '65.53.15644820722735917', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '42.234.29.130', '2019-07-30 18:21:12', 0, 1002001015, '账号未登陆', '2019-07-30 18:21:12');
INSERT INTO `access_log` VALUES (60962, '65.51.15644820722725989', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '42.234.29.130', '2019-07-30 18:21:12', 1, 1002001015, '账号未登陆', '2019-07-30 18:21:12');
INSERT INTO `access_log` VALUES (60963, '65.3607.15644820722987717', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '42.234.29.130', '2019-07-30 18:21:12', 0, 1002001015, '账号未登陆', '2019-07-30 18:21:12');
INSERT INTO `access_log` VALUES (60964, '65.45.15644820743285927', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '42.234.29.130', '2019-07-30 18:21:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 18:21:14');
INSERT INTO `access_log` VALUES (60965, '65.47.15644820966525907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '42.234.29.130', '2019-07-30 18:21:37', 101, 0, '', '2019-07-30 18:21:37');
INSERT INTO `access_log` VALUES (60966, '65.54.15644820972775839', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '42.234.29.130', '2019-07-30 18:21:37', 12, 0, '', '2019-07-30 18:21:37');
INSERT INTO `access_log` VALUES (60967, '65.52.15644820972785963', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '42.234.29.130', '2019-07-30 18:21:37', 12, 0, '', '2019-07-30 18:21:37');
INSERT INTO `access_log` VALUES (60968, '65.49.15644820972815903', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPad; CPU OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '42.234.29.130', '2019-07-30 18:21:37', 11, 2001001000, '服务端发生异常', '2019-07-30 18:21:37');
INSERT INTO `access_log` VALUES (60969, '59.80.15644912260803549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.188.26.105', '2019-07-30 20:53:46', 20, 2001001000, '服务端发生异常', '2019-07-30 20:53:46');
INSERT INTO `access_log` VALUES (60970, '59.78.15644912260803581', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.188.26.105', '2019-07-30 20:53:46', 58, 0, '', '2019-07-30 20:53:46');
INSERT INTO `access_log` VALUES (60971, '64.79.15644912299293853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.188.26.105', '2019-07-30 20:53:50', 11, 0, '', '2019-07-30 20:53:50');
INSERT INTO `access_log` VALUES (60972, '64.80.15644912301343865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.188.26.105', '2019-07-30 20:53:50', 2, 0, '', '2019-07-30 20:53:50');
INSERT INTO `access_log` VALUES (60973, '64.81.15644912312233859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.188.26.105', '2019-07-30 20:53:51', 2, 0, '', '2019-07-30 20:53:51');
INSERT INTO `access_log` VALUES (60974, '59.75.15644912319633587', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.188.26.105', '2019-07-30 20:53:52', 3, 0, '', '2019-07-30 20:53:52');
INSERT INTO `access_log` VALUES (60975, '59.73.15644912319633579', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.188.26.105', '2019-07-30 20:53:52', 13, 2001001000, '服务端发生异常', '2019-07-30 20:53:52');
INSERT INTO `access_log` VALUES (60976, '59.78.15644929825983605', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.216.129', '2019-07-30 21:23:03', 3, 0, '', '2019-07-30 21:23:03');
INSERT INTO `access_log` VALUES (60977, '59.76.15644929825983587', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.216.129', '2019-07-30 21:23:03', 13, 2001001000, '服务端发生异常', '2019-07-30 21:23:03');
INSERT INTO `access_log` VALUES (60978, '64.80.15644929880573889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.216.129', '2019-07-30 21:23:08', 3, 0, '', '2019-07-30 21:23:08');
INSERT INTO `access_log` VALUES (60979, '64.84.15644929881423875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.216.129', '2019-07-30 21:23:08', 1, 0, '', '2019-07-30 21:23:08');
INSERT INTO `access_log` VALUES (60980, '66.49.15644929983381349', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.216.129', '2019-07-30 21:23:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号必须都是数字\n手机号不能为空', '2019-07-30 21:23:18');
INSERT INTO `access_log` VALUES (60981, '66.48.15644930012861357', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.216.129', '2019-07-30 21:23:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n账号长度为 11 位\n手机号必须都是数字', '2019-07-30 21:23:21');
INSERT INTO `access_log` VALUES (60982, '64.82.15644930088183899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.216.129', '2019-07-30 21:23:29', 2, 0, '', '2019-07-30 21:23:29');
INSERT INTO `access_log` VALUES (60983, '64.85.15644930089183921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.216.129', '2019-07-30 21:23:29', 2, 0, '', '2019-07-30 21:23:29');
INSERT INTO `access_log` VALUES (60984, '59.78.15644969973793659', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:29:57', 10, 0, '', '2019-07-30 22:29:57');
INSERT INTO `access_log` VALUES (60985, '59.75.15644969973803665', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:29:57', 18, 2001001000, '服务端发生异常', '2019-07-30 22:29:57');
INSERT INTO `access_log` VALUES (60986, '64.84.15644970050463929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:05', 11, 0, '', '2019-07-30 22:30:05');
INSERT INTO `access_log` VALUES (60987, '64.81.15644970051433937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:05', 3, 0, '', '2019-07-30 22:30:05');
INSERT INTO `access_log` VALUES (60988, '64.85.15644970067173975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:07', 2, 0, '', '2019-07-30 22:30:07');
INSERT INTO `access_log` VALUES (60989, '64.77.15644970073943929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:07', 2, 0, '', '2019-07-30 22:30:07');
INSERT INTO `access_log` VALUES (60990, '64.78.15644970114413941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:11', 2, 0, '', '2019-07-30 22:30:11');
INSERT INTO `access_log` VALUES (60991, '64.83.15644970116123931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:12', 2, 0, '', '2019-07-30 22:30:12');
INSERT INTO `access_log` VALUES (60992, '66.52.15644970316421391', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13800000000&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:32', 16, 1001003000, '验证码不存在', '2019-07-30 22:30:32');
INSERT INTO `access_log` VALUES (60993, '66.48.15644970338671411', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13800000000', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:34', 65, 0, '', '2019-07-30 22:30:34');
INSERT INTO `access_log` VALUES (60994, '66.57.15644970362431407', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13800000000&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:36', 168, 0, '', '2019-07-30 22:30:36');
INSERT INTO `access_log` VALUES (60995, '59.77.15644970381153645', 184, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:38', 11, 0, '', '2019-07-30 22:30:38');
INSERT INTO `access_log` VALUES (60996, '66.51.15644970420211423', 184, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:42', 6, 0, '', '2019-07-30 22:30:42');
INSERT INTO `access_log` VALUES (60997, '66.53.15644970455751399', 184, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:46', 8, 0, '', '2019-07-30 22:30:46');
INSERT INTO `access_log` VALUES (60998, '66.55.15644970486081383', 184, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:49', 6, 0, '', '2019-07-30 22:30:49');
INSERT INTO `access_log` VALUES (60999, '66.49.15644970547121405', 184, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:55', 6, 0, '', '2019-07-30 22:30:55');
INSERT INTO `access_log` VALUES (61000, '64.81.15644970559503939', 184, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:56', 4, 0, '', '2019-07-30 22:30:56');
INSERT INTO `access_log` VALUES (61001, '64.85.15644970560993977', 184, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:56', 4, 0, '', '2019-07-30 22:30:56');
INSERT INTO `access_log` VALUES (61002, '64.78.15644970584533943', 184, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:58', 4, 0, '', '2019-07-30 22:30:58');
INSERT INTO `access_log` VALUES (61003, '64.76.15644970590343935', 184, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:30:59', 5, 0, '', '2019-07-30 22:30:59');
INSERT INTO `access_log` VALUES (61004, '59.78.15644970602063661', 184, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:00', 6, 0, '', '2019-07-30 22:31:00');
INSERT INTO `access_log` VALUES (61005, '59.75.15644970602053667', 184, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:00', 16, 2001001000, '服务端发生异常', '2019-07-30 22:31:00');
INSERT INTO `access_log` VALUES (61006, '64.79.15644970627623935', 184, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:03', 6, 0, '', '2019-07-30 22:31:03');
INSERT INTO `access_log` VALUES (61007, '64.80.15644970628543947', 184, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:03', 6, 0, '', '2019-07-30 22:31:03');
INSERT INTO `access_log` VALUES (61008, '65.45.15644970851626127', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:25', 11, 1002001012, '访问令牌已过期', '2019-07-30 22:31:25');
INSERT INTO `access_log` VALUES (61009, '65.47.15644970851626109', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:25', 10, 1002001012, '访问令牌已过期', '2019-07-30 22:31:25');
INSERT INTO `access_log` VALUES (61010, '65.50.15644970851836121', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:25', 12, 1002001012, '访问令牌已过期', '2019-07-30 22:31:25');
INSERT INTO `access_log` VALUES (61011, '65.54.15644970879386039', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:28', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 22:31:28');
INSERT INTO `access_log` VALUES (61012, '65.52.15644970925066165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:33', 142, 0, '', '2019-07-30 22:31:33');
INSERT INTO `access_log` VALUES (61013, '65.49.15644970930666105', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:33', 11, 0, '', '2019-07-30 22:31:33');
INSERT INTO `access_log` VALUES (61014, '65.46.15644970930666185', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:33', 12, 0, '', '2019-07-30 22:31:33');
INSERT INTO `access_log` VALUES (61015, '65.53.15644970930676121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:33', 10, 2001001000, '服务端发生异常', '2019-07-30 22:31:33');
INSERT INTO `access_log` VALUES (61016, '65.3607.15644971115747921', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:52', 17, 0, '', '2019-07-30 22:31:52');
INSERT INTO `access_log` VALUES (61017, '65.45.15644971115746129', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:52', 19, 2001001000, '服务端发生异常', '2019-07-30 22:31:52');
INSERT INTO `access_log` VALUES (61018, '65.47.15644971115956111', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:52', 9, 0, '', '2019-07-30 22:31:52');
INSERT INTO `access_log` VALUES (61019, '65.54.15644971157766041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:56', 9, 0, '', '2019-07-30 22:31:56');
INSERT INTO `access_log` VALUES (61020, '65.46.15644971157776187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:56', 10, 0, '', '2019-07-30 22:31:56');
INSERT INTO `access_log` VALUES (61021, '65.52.15644971157766167', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.89.195.68', '2019-07-30 22:31:56', 10, 2001001000, '服务端发生异常', '2019-07-30 22:31:56');
INSERT INTO `access_log` VALUES (61022, '65.54.15644985937356061', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.87.80.188', '2019-07-30 22:56:34', 0, 1002001015, '账号未登陆', '2019-07-30 22:56:34');
INSERT INTO `access_log` VALUES (61023, '65.52.15644985937356187', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.87.80.188', '2019-07-30 22:56:34', 0, 1002001015, '账号未登陆', '2019-07-30 22:56:34');
INSERT INTO `access_log` VALUES (61024, '65.49.15644985937366127', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.87.80.188', '2019-07-30 22:56:34', 1, 1002001015, '账号未登陆', '2019-07-30 22:56:34');
INSERT INTO `access_log` VALUES (61025, '65.53.15644985957026143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.87.80.188', '2019-07-30 22:56:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-30 22:56:36');
INSERT INTO `access_log` VALUES (61026, '59.72.15645203456843963', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.238.229.52', '2019-07-31 04:59:06', 11, 0, '', '2019-07-31 04:59:06');
INSERT INTO `access_log` VALUES (61027, '59.77.15645203456853957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.238.229.52', '2019-07-31 04:59:06', 18, 2001001000, '服务端发生异常', '2019-07-31 04:59:06');
INSERT INTO `access_log` VALUES (61028, '65.54.15645203595526353', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.238.229.52', '2019-07-31 04:59:20', 0, 1002001015, '账号未登陆', '2019-07-31 04:59:20');
INSERT INTO `access_log` VALUES (61029, '65.46.15645203595526497', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.238.229.52', '2019-07-31 04:59:20', 0, 1002001015, '账号未登陆', '2019-07-31 04:59:20');
INSERT INTO `access_log` VALUES (61030, '65.49.15645203595526415', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '115.238.229.52', '2019-07-31 04:59:20', 0, 1002001015, '账号未登陆', '2019-07-31 04:59:20');
INSERT INTO `access_log` VALUES (61031, '65.45.15645241175946491', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.250', '2019-07-31 06:01:58', 0, 1002001015, '账号未登陆', '2019-07-31 06:01:58');
INSERT INTO `access_log` VALUES (61032, '65.53.15645241175956491', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.250', '2019-07-31 06:01:58', 1, 1002001015, '账号未登陆', '2019-07-31 06:01:58');
INSERT INTO `access_log` VALUES (61033, '65.50.15645241176136489', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.250', '2019-07-31 06:01:58', 0, 1002001015, '账号未登陆', '2019-07-31 06:01:58');
INSERT INTO `access_log` VALUES (61034, '65.51.15645241193876561', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.250', '2019-07-31 06:01:59', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 06:01:59');
INSERT INTO `access_log` VALUES (61035, '65.52.15645241215846533', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.250', '2019-07-31 06:02:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 06:02:02');
INSERT INTO `access_log` VALUES (61036, '65.3607.15645241218428285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.250', '2019-07-31 06:02:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 06:02:02');
INSERT INTO `access_log` VALUES (61037, '65.54.15645241222086405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.87.129.250', '2019-07-31 06:02:02', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 06:02:02');
INSERT INTO `access_log` VALUES (61038, '59.74.15645355998204185', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Mobile/15E148 Safari/604.1', '219.136.74.130', '2019-07-31 09:13:20', 11, 0, '', '2019-07-31 09:13:20');
INSERT INTO `access_log` VALUES (61039, '59.77.15645355998214161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Mobile/15E148 Safari/604.1', '219.136.74.130', '2019-07-31 09:13:20', 30, 2001001000, '服务端发生异常', '2019-07-31 09:13:20');
INSERT INTO `access_log` VALUES (61040, '64.84.15645356058754449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Mobile/15E148 Safari/604.1', '219.136.74.130', '2019-07-31 09:13:26', 12, 0, '', '2019-07-31 09:13:26');
INSERT INTO `access_log` VALUES (61041, '64.80.15645356059834463', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Mobile/15E148 Safari/604.1', '219.136.74.130', '2019-07-31 09:13:26', 3, 0, '', '2019-07-31 09:13:26');
INSERT INTO `access_log` VALUES (61042, '59.72.15645356074854167', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Mobile/15E148 Safari/604.1', '219.136.74.130', '2019-07-31 09:13:27', 3, 0, '', '2019-07-31 09:13:27');
INSERT INTO `access_log` VALUES (61043, '59.71.15645356074864169', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Mobile/15E148 Safari/604.1', '219.136.74.130', '2019-07-31 09:13:27', 18, 2001001000, '服务端发生异常', '2019-07-31 09:13:28');
INSERT INTO `access_log` VALUES (61044, '59.80.15645356129394145', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Mobile/15E148 Safari/604.1', '219.136.74.130', '2019-07-31 09:13:33', 3, 0, '', '2019-07-31 09:13:33');
INSERT INTO `access_log` VALUES (61045, '59.76.15645356129394159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Mobile/15E148 Safari/604.1', '219.136.74.130', '2019-07-31 09:13:33', 16, 2001001000, '服务端发生异常', '2019-07-31 09:13:33');
INSERT INTO `access_log` VALUES (61046, '64.77.15645356136644449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Mobile/15E148 Safari/604.1', '219.136.74.130', '2019-07-31 09:13:34', 2, 0, '', '2019-07-31 09:13:34');
INSERT INTO `access_log` VALUES (61047, '64.83.15645356137554447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Mobile/15E148 Safari/604.1', '219.136.74.130', '2019-07-31 09:13:34', 2, 0, '', '2019-07-31 09:13:34');
INSERT INTO `access_log` VALUES (61048, '59.75.15645356145204183', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Mobile/15E148 Safari/604.1', '219.136.74.130', '2019-07-31 09:13:35', 8, 0, '', '2019-07-31 09:13:35');
INSERT INTO `access_log` VALUES (61049, '59.73.15645356145204175', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Mobile/15E148 Safari/604.1', '219.136.74.130', '2019-07-31 09:13:35', 18, 2001001000, '服务端发生异常', '2019-07-31 09:13:35');
INSERT INTO `access_log` VALUES (61050, '59.80.15645368855764163', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.1.5.205', '2019-07-31 09:34:46', 23, 0, '', '2019-07-31 09:34:46');
INSERT INTO `access_log` VALUES (61051, '59.78.15645368855764195', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.1.5.205', '2019-07-31 09:34:46', 33, 2001001000, '服务端发生异常', '2019-07-31 09:34:46');
INSERT INTO `access_log` VALUES (61052, '65.46.15645375918236729', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.183.64.12', '2019-07-31 09:46:32', 5, 1002001015, '账号未登陆', '2019-07-31 09:46:32');
INSERT INTO `access_log` VALUES (61053, '65.3607.15645375918228465', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.183.64.12', '2019-07-31 09:46:32', 1, 1002001015, '账号未登陆', '2019-07-31 09:46:32');
INSERT INTO `access_log` VALUES (61054, '65.54.15645375918226585', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.183.64.12', '2019-07-31 09:46:32', 5, 1002001015, '账号未登陆', '2019-07-31 09:46:32');
INSERT INTO `access_log` VALUES (61055, '65.49.15645375967436647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.183.64.12', '2019-07-31 09:46:37', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 09:46:37');
INSERT INTO `access_log` VALUES (61056, '65.45.15645376103376673', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudanyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.183.64.12', '2019-07-31 09:46:50', 343, 0, '', '2019-07-31 09:46:51');
INSERT INTO `access_log` VALUES (61057, '65.53.15645376110386673', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.183.64.12', '2019-07-31 09:46:51', 16, 0, '', '2019-07-31 09:46:51');
INSERT INTO `access_log` VALUES (61058, '65.50.15645376110476671', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.183.64.12', '2019-07-31 09:46:51', 14, 2001001000, '服务端发生异常', '2019-07-31 09:46:51');
INSERT INTO `access_log` VALUES (61059, '65.51.15645376110526743', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.183.64.12', '2019-07-31 09:46:51', 12, 0, '', '2019-07-31 09:46:51');
INSERT INTO `access_log` VALUES (61060, '64.84.15645378236974479', 0, 2, 'product-application', '/product-api/admins/spu/update_sort', 'id=1&sort=0', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '116.1.5.205', '2019-07-31 09:50:24', 0, 1002001015, '账号未登陆', '2019-07-31 09:50:24');
INSERT INTO `access_log` VALUES (61061, '65.51.15645385965796757', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.119.69', '2019-07-31 10:03:17', 0, 1002001015, '账号未登陆', '2019-07-31 10:03:17');
INSERT INTO `access_log` VALUES (61062, '65.45.15645385965796687', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.119.69', '2019-07-31 10:03:17', 0, 1002001015, '账号未登陆', '2019-07-31 10:03:17');
INSERT INTO `access_log` VALUES (61063, '65.53.15645385965806687', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.119.69', '2019-07-31 10:03:17', 0, 1002001015, '账号未登陆', '2019-07-31 10:03:17');
INSERT INTO `access_log` VALUES (61064, '65.52.15645386097826729', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.119.69', '2019-07-31 10:03:30', 626, 0, '', '2019-07-31 10:03:30');
INSERT INTO `access_log` VALUES (61065, '65.46.15645386108666745', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.119.69', '2019-07-31 10:03:31', 326, 0, '', '2019-07-31 10:03:31');
INSERT INTO `access_log` VALUES (61066, '65.54.15645386108396601', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.119.69', '2019-07-31 10:03:31', 636, 0, '', '2019-07-31 10:03:31');
INSERT INTO `access_log` VALUES (61067, '65.3607.15645386108398481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.119.69', '2019-07-31 10:03:31', 640, 2001001000, '服务端发生异常', '2019-07-31 10:03:31');
INSERT INTO `access_log` VALUES (61068, '59.76.15645396782904215', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:21:18', 10, 0, '', '2019-07-31 10:21:18');
INSERT INTO `access_log` VALUES (61069, '59.71.15645396782894225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:21:18', 23, 2001001000, '服务端发生异常', '2019-07-31 10:21:18');
INSERT INTO `access_log` VALUES (61070, '59.80.15645396832874201', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:21:23', 3, 0, '', '2019-07-31 10:21:23');
INSERT INTO `access_log` VALUES (61071, '59.75.15645396832924239', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:21:23', 15, 2001001000, '服务端发生异常', '2019-07-31 10:21:23');
INSERT INTO `access_log` VALUES (61072, '64.80.15645396912954519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:21:31', 11, 0, '', '2019-07-31 10:21:31');
INSERT INTO `access_log` VALUES (61073, '64.84.15645396914494505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:21:31', 4, 0, '', '2019-07-31 10:21:31');
INSERT INTO `access_log` VALUES (61074, '64.85.15645396933724545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:21:33', 2, 0, '', '2019-07-31 10:21:33');
INSERT INTO `access_log` VALUES (61075, '64.77.15645396939294505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:21:34', 2, 0, '', '2019-07-31 10:21:34');
INSERT INTO `access_log` VALUES (61076, '65.52.15645397447006745', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:22:25', 1, 1002001015, '账号未登陆', '2019-07-31 10:22:25');
INSERT INTO `access_log` VALUES (61077, '65.46.15645397447006761', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:22:25', 0, 1002001015, '账号未登陆', '2019-07-31 10:22:25');
INSERT INTO `access_log` VALUES (61078, '65.54.15645397447126617', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:22:25', 0, 1002001015, '账号未登陆', '2019-07-31 10:22:25');
INSERT INTO `access_log` VALUES (61079, '65.3607.15645397492858497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:22:29', 98, 0, '', '2019-07-31 10:22:29');
INSERT INTO `access_log` VALUES (61080, '65.49.15645397497076679', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:22:30', 9, 0, '', '2019-07-31 10:22:30');
INSERT INTO `access_log` VALUES (61081, '65.47.15645397497326689', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:22:30', 10, 2001001000, '服务端发生异常', '2019-07-31 10:22:30');
INSERT INTO `access_log` VALUES (61082, '65.53.15645397497346705', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.4.97', '2019-07-31 10:22:30', 9, 0, '', '2019-07-31 10:22:30');
INSERT INTO `access_log` VALUES (61083, '65.47.15645401942556695', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 10:29:54', 1, 1002001015, '账号未登陆', '2019-07-31 10:29:54');
INSERT INTO `access_log` VALUES (61084, '65.53.15645401942566711', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 10:29:54', 0, 1002001015, '账号未登陆', '2019-07-31 10:29:54');
INSERT INTO `access_log` VALUES (61085, '65.51.15645401942596783', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 10:29:54', 0, 1002001015, '账号未登陆', '2019-07-31 10:29:54');
INSERT INTO `access_log` VALUES (61086, '65.50.15645401985216711', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 10:29:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 10:29:59');
INSERT INTO `access_log` VALUES (61087, '65.45.15645402075156713', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 10:30:08', 290, 0, '', '2019-07-31 10:30:08');
INSERT INTO `access_log` VALUES (61088, '65.52.15645402080586753', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 10:30:08', 9, 0, '', '2019-07-31 10:30:08');
INSERT INTO `access_log` VALUES (61089, '65.46.15645402080596769', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 10:30:08', 12, 2001001000, '服务端发生异常', '2019-07-31 10:30:08');
INSERT INTO `access_log` VALUES (61090, '65.54.15645402080656627', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 10:30:08', 10, 0, '', '2019-07-31 10:30:08');
INSERT INTO `access_log` VALUES (61091, '65.3607.15645402096848507', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:10', 0, 1002001015, '账号未登陆', '2019-07-31 10:30:10');
INSERT INTO `access_log` VALUES (61092, '65.51.15645402096946785', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:10', 1, 1002001015, '账号未登陆', '2019-07-31 10:30:10');
INSERT INTO `access_log` VALUES (61093, '65.47.15645402096976697', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:10', 0, 1002001015, '账号未登陆', '2019-07-31 10:30:10');
INSERT INTO `access_log` VALUES (61094, '65.53.15645402129866713', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 10:30:13');
INSERT INTO `access_log` VALUES (61095, '65.45.15645402287936715', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:29', 54, 0, '', '2019-07-31 10:30:29');
INSERT INTO `access_log` VALUES (61096, '65.54.15645402291166629', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:29', 8, 0, '', '2019-07-31 10:30:29');
INSERT INTO `access_log` VALUES (61097, '65.52.15645402291166755', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:29', 10, 0, '', '2019-07-31 10:30:29');
INSERT INTO `access_log` VALUES (61098, '65.46.15645402291186771', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:29', 9, 2001001000, '服务端发生异常', '2019-07-31 10:30:29');
INSERT INTO `access_log` VALUES (61099, '65.3607.15645402420068509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:42', 58, 0, '', '2019-07-31 10:30:42');
INSERT INTO `access_log` VALUES (61100, '65.53.15645402422746715', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:42', 10, 0, '', '2019-07-31 10:30:42');
INSERT INTO `access_log` VALUES (61101, '65.51.15645402422736787', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:42', 10, 2001001000, '服务端发生异常', '2019-07-31 10:30:42');
INSERT INTO `access_log` VALUES (61102, '65.47.15645402422736699', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:42', 9, 0, '', '2019-07-31 10:30:42');
INSERT INTO `access_log` VALUES (61103, '65.50.15645402537596715', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:54', 8, 0, '', '2019-07-31 10:30:54');
INSERT INTO `access_log` VALUES (61104, '65.45.15645402537596717', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:54', 9, 2001001000, '服务端发生异常', '2019-07-31 10:30:54');
INSERT INTO `access_log` VALUES (61105, '65.52.15645402537626757', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '171.221.41.158', '2019-07-31 10:30:54', 8, 0, '', '2019-07-31 10:30:54');
INSERT INTO `access_log` VALUES (61106, '65.54.15645402578036631', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 10:30:58', 9, 0, '', '2019-07-31 10:30:58');
INSERT INTO `access_log` VALUES (61107, '65.49.15645402578256691', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 10:30:58', 10, 2001001000, '服务端发生异常', '2019-07-31 10:30:58');
INSERT INTO `access_log` VALUES (61108, '65.3607.15645402578278511', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 10:30:58', 9, 0, '', '2019-07-31 10:30:58');
INSERT INTO `access_log` VALUES (61109, '65.53.15645402625446717', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 10:31:03', 8, 0, '', '2019-07-31 10:31:03');
INSERT INTO `access_log` VALUES (61110, '65.51.15645402625456789', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 10:31:03', 9, 0, '', '2019-07-31 10:31:03');
INSERT INTO `access_log` VALUES (61111, '65.47.15645402625456701', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 10:31:03', 9, 2001001000, '服务端发生异常', '2019-07-31 10:31:03');
INSERT INTO `access_log` VALUES (61112, '59.78.15645408367264249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:40:37', 3, 0, '', '2019-07-31 10:40:37');
INSERT INTO `access_log` VALUES (61113, '59.80.15645408367284217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:40:37', 28, 2001001000, '服务端发生异常', '2019-07-31 10:40:37');
INSERT INTO `access_log` VALUES (61114, '64.84.15645408423324521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:40:42', 3, 0, '', '2019-07-31 10:40:42');
INSERT INTO `access_log` VALUES (61115, '64.85.15645408423984561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:40:42', 2, 0, '', '2019-07-31 10:40:42');
INSERT INTO `access_log` VALUES (61116, '66.52.15645408582731977', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15666618888', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:40:58', 77, 0, '', '2019-07-31 10:40:58');
INSERT INTO `access_log` VALUES (61117, '66.48.15645408604341997', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15666618888&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:41:00', 470, 0, '', '2019-07-31 10:41:01');
INSERT INTO `access_log` VALUES (61118, '64.76.15645408678064527', 185, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:08', 7, 0, '', '2019-07-31 10:41:08');
INSERT INTO `access_log` VALUES (61119, '64.82.15645408679044547', 185, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:08', 8, 0, '', '2019-07-31 10:41:08');
INSERT INTO `access_log` VALUES (61120, '64.79.15645408703474523', 185, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:10', 5, 0, '', '2019-07-31 10:41:10');
INSERT INTO `access_log` VALUES (61121, 'N/A', 185, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:10', 12, 0, '', '2019-07-31 10:41:10');
INSERT INTO `access_log` VALUES (61122, '64.84.15645408714444523', 185, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:11', 14, 0, '', '2019-07-31 10:41:11');
INSERT INTO `access_log` VALUES (61123, '64.85.15645408735554563', 185, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:14', 5, 0, '', '2019-07-31 10:41:14');
INSERT INTO `access_log` VALUES (61124, 'N/A', 185, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:14', 12, 0, '', '2019-07-31 10:41:14');
INSERT INTO `access_log` VALUES (61125, '64.77.15645408743904523', 185, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:14', 6, 0, '', '2019-07-31 10:41:14');
INSERT INTO `access_log` VALUES (61126, '64.83.15645408744734523', 185, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:14', 4, 0, '', '2019-07-31 10:41:14');
INSERT INTO `access_log` VALUES (61127, '59.74.15645408762444259', 185, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:16', 6, 0, '', '2019-07-31 10:41:16');
INSERT INTO `access_log` VALUES (61128, '59.72.15645408762444241', 185, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:16', 18, 2001001000, '服务端发生异常', '2019-07-31 10:41:16');
INSERT INTO `access_log` VALUES (61129, '64.81.15645408800024531', 185, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:20', 7, 0, '', '2019-07-31 10:41:20');
INSERT INTO `access_log` VALUES (61130, '64.76.15645408800954529', 185, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:20', 6, 0, '', '2019-07-31 10:41:20');
INSERT INTO `access_log` VALUES (61131, '64.82.15645408839824549', 185, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:24', 5, 0, '', '2019-07-31 10:41:24');
INSERT INTO `access_log` VALUES (61132, '64.79.15645408840594525', 185, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:24', 5, 0, '', '2019-07-31 10:41:24');
INSERT INTO `access_log` VALUES (61133, '64.80.15645408852424539', 185, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:25', 5, 0, '', '2019-07-31 10:41:25');
INSERT INTO `access_log` VALUES (61134, 'N/A', 185, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:25', 10, 0, '', '2019-07-31 10:41:25');
INSERT INTO `access_log` VALUES (61135, '64.84.15645408877254525', 185, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:28', 10, 0, '', '2019-07-31 10:41:28');
INSERT INTO `access_log` VALUES (61136, '66.51.15645408922242009', 185, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:32', 6, 0, '', '2019-07-31 10:41:32');
INSERT INTO `access_log` VALUES (61137, '64.77.15645408978874525', 185, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Mobile Safari/537.36', '116.226.45.158', '2019-07-31 10:41:38', 12, 0, '', '2019-07-31 10:41:38');
INSERT INTO `access_log` VALUES (61138, '65.54.15645409187236641', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:41:59', 0, 1002001015, '账号未登陆', '2019-07-31 10:41:59');
INSERT INTO `access_log` VALUES (61139, '65.49.15645409187246701', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:41:59', 0, 1002001015, '账号未登陆', '2019-07-31 10:41:59');
INSERT INTO `access_log` VALUES (61140, '65.3607.15645409187328521', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:41:59', 1, 1002001015, '账号未登陆', '2019-07-31 10:41:59');
INSERT INTO `access_log` VALUES (61141, '65.53.15645409254956727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:42:05', 82, 0, '', '2019-07-31 10:42:06');
INSERT INTO `access_log` VALUES (61142, '65.47.15645409257736711', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:42:06', 9, 0, '', '2019-07-31 10:42:06');
INSERT INTO `access_log` VALUES (61143, '65.50.15645409257766727', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:42:06', 10, 0, '', '2019-07-31 10:42:06');
INSERT INTO `access_log` VALUES (61144, '65.51.15645409257766799', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:42:06', 10, 2001001000, '服务端发生异常', '2019-07-31 10:42:06');
INSERT INTO `access_log` VALUES (61145, '65.52.15645409322406769', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:42:12', 8, 0, '', '2019-07-31 10:42:12');
INSERT INTO `access_log` VALUES (61146, '65.46.15645409322426785', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:42:12', 9, 2001001000, '服务端发生异常', '2019-07-31 10:42:12');
INSERT INTO `access_log` VALUES (61147, '65.54.15645409322436643', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '116.226.45.158', '2019-07-31 10:42:12', 9, 0, '', '2019-07-31 10:42:12');
INSERT INTO `access_log` VALUES (61148, '65.53.15645411233306731', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.5.3.170', '2019-07-31 10:45:23', 1, 1002001015, '账号未登陆', '2019-07-31 10:45:23');
INSERT INTO `access_log` VALUES (61149, '65.50.15645411233326731', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.5.3.170', '2019-07-31 10:45:23', 0, 1002001015, '账号未登陆', '2019-07-31 10:45:23');
INSERT INTO `access_log` VALUES (61150, '65.51.15645411233476803', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.5.3.170', '2019-07-31 10:45:23', 0, 1002001015, '账号未登陆', '2019-07-31 10:45:23');
INSERT INTO `access_log` VALUES (61151, '65.45.15645411253736733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.5.3.170', '2019-07-31 10:45:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 10:45:25');
INSERT INTO `access_log` VALUES (61152, '65.46.15645411362456789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.5.3.170', '2019-07-31 10:45:36', 64, 0, '', '2019-07-31 10:45:36');
INSERT INTO `access_log` VALUES (61153, '65.54.15645411366946647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.5.3.170', '2019-07-31 10:45:37', 10, 0, '', '2019-07-31 10:45:37');
INSERT INTO `access_log` VALUES (61154, '65.52.15645411366986773', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.5.3.170', '2019-07-31 10:45:37', 10, 2001001000, '服务端发生异常', '2019-07-31 10:45:37');
INSERT INTO `access_log` VALUES (61155, '65.49.15645411367036707', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.5.3.170', '2019-07-31 10:45:37', 9, 0, '', '2019-07-31 10:45:37');
INSERT INTO `access_log` VALUES (61156, '65.50.15645411544896733', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.5.3.170', '2019-07-31 10:45:54', 9, 0, '', '2019-07-31 10:45:54');
INSERT INTO `access_log` VALUES (61157, '65.51.15645411544936805', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.5.3.170', '2019-07-31 10:45:54', 10, 2001001000, '服务端发生异常', '2019-07-31 10:45:55');
INSERT INTO `access_log` VALUES (61158, '65.47.15645411545026717', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.5.3.170', '2019-07-31 10:45:55', 8, 0, '', '2019-07-31 10:45:55');
INSERT INTO `access_log` VALUES (61159, '64.78.15645415525314543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '58.247.206.151', '2019-07-31 10:52:33', 3, 0, '', '2019-07-31 10:52:33');
INSERT INTO `access_log` VALUES (61160, '64.79.15645415564314535', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.178.166', '2019-07-31 10:52:36', 2, 0, '', '2019-07-31 10:52:36');
INSERT INTO `access_log` VALUES (61161, '59.79.15645415653764259', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.178.236', '2019-07-31 10:52:45', 19, 2001001000, '服务端发生异常', '2019-07-31 10:52:45');
INSERT INTO `access_log` VALUES (61162, '59.74.15645415757784269', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.151.207.186', '2019-07-31 10:52:56', 4, 0, '', '2019-07-31 10:52:56');
INSERT INTO `access_log` VALUES (61163, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.227.139.161', '2019-07-31 10:53:16', 6, 0, '', '2019-07-31 10:53:16');
INSERT INTO `access_log` VALUES (61164, '64.77.15645416030664535', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.129.6.227', '2019-07-31 10:53:23', 7, 0, '', '2019-07-31 10:53:23');
INSERT INTO `access_log` VALUES (61165, '66.50.15645416072411995', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '180.97.118.219', '2019-07-31 10:53:27', 4, 0, '', '2019-07-31 10:53:27');
INSERT INTO `access_log` VALUES (61166, '65.49.15645416452076715', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.178.197', '2019-07-31 10:54:05', 1, 1002001015, '账号未登陆', '2019-07-31 10:54:05');
INSERT INTO `access_log` VALUES (61167, '65.52.15645416491696781', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.89.19.149', '2019-07-31 10:54:09', 1, 1002001015, '账号未登陆', '2019-07-31 10:54:09');
INSERT INTO `access_log` VALUES (61168, '65.54.15645429739226673', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.249.228.130', '2019-07-31 11:16:14', 0, 1002001015, '账号未登陆', '2019-07-31 11:16:14');
INSERT INTO `access_log` VALUES (61169, '65.46.15645429739226815', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.249.228.130', '2019-07-31 11:16:14', 1, 1002001015, '账号未登陆', '2019-07-31 11:16:14');
INSERT INTO `access_log` VALUES (61170, '65.49.15645429739226733', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.249.228.130', '2019-07-31 11:16:14', 0, 1002001015, '账号未登陆', '2019-07-31 11:16:14');
INSERT INTO `access_log` VALUES (61171, '65.52.15645429797996803', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.249.228.130', '2019-07-31 11:16:20', 105, 0, '', '2019-07-31 11:16:20');
INSERT INTO `access_log` VALUES (61172, '65.3607.15645429801778553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.249.228.130', '2019-07-31 11:16:20', 10, 0, '', '2019-07-31 11:16:20');
INSERT INTO `access_log` VALUES (61173, '65.45.15645429801876761', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.249.228.130', '2019-07-31 11:16:20', 9, 0, '', '2019-07-31 11:16:20');
INSERT INTO `access_log` VALUES (61174, '65.53.15645429801866761', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.249.228.130', '2019-07-31 11:16:20', 9, 2001001000, '服务端发生异常', '2019-07-31 11:16:20');
INSERT INTO `access_log` VALUES (61175, '65.47.15645429895296745', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.249.228.130', '2019-07-31 11:16:30', 17, 0, '', '2019-07-31 11:16:30');
INSERT INTO `access_log` VALUES (61176, '65.50.15645429895326761', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.249.228.130', '2019-07-31 11:16:30', 17, 2001001000, '服务端发生异常', '2019-07-31 11:16:30');
INSERT INTO `access_log` VALUES (61177, '65.54.15645429895336675', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.249.228.130', '2019-07-31 11:16:30', 17, 0, '', '2019-07-31 11:16:30');
INSERT INTO `access_log` VALUES (61178, '59.79.15645482866204349', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:44:47', 16, 0, '', '2019-07-31 12:44:47');
INSERT INTO `access_log` VALUES (61179, '59.77.15645482866224335', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:44:47', 21, 2001001000, '服务端发生异常', '2019-07-31 12:44:47');
INSERT INTO `access_log` VALUES (61180, '64.79.15645482899014625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:44:50', 544, 0, '', '2019-07-31 12:44:50');
INSERT INTO `access_log` VALUES (61181, '64.82.15645482908494649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:44:51', 5, 0, '', '2019-07-31 12:44:51');
INSERT INTO `access_log` VALUES (61182, '64.81.15645482922774631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:44:52', 2, 0, '', '2019-07-31 12:44:52');
INSERT INTO `access_log` VALUES (61183, '64.83.15645482929254627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:44:53', 2, 0, '', '2019-07-31 12:44:53');
INSERT INTO `access_log` VALUES (61184, '59.72.15645482950404341', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:44:55', 3, 0, '', '2019-07-31 12:44:55');
INSERT INTO `access_log` VALUES (61185, '59.76.15645482950424333', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:44:55', 13, 2001001000, '服务端发生异常', '2019-07-31 12:44:55');
INSERT INTO `access_log` VALUES (61186, '64.85.15645482971184667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:44:57', 2, 0, '', '2019-07-31 12:44:57');
INSERT INTO `access_log` VALUES (61187, '64.84.15645482972414627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:44:57', 3, 0, '', '2019-07-31 12:44:57');
INSERT INTO `access_log` VALUES (61188, '59.71.15645482989104343', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:44:59', 2, 0, '', '2019-07-31 12:44:59');
INSERT INTO `access_log` VALUES (61189, '59.78.15645482989164351', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:44:59', 12, 2001001000, '服务端发生异常', '2019-07-31 12:44:59');
INSERT INTO `access_log` VALUES (61190, '65.45.15645483062486833', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:45:06', 0, 1002001015, '账号未登陆', '2019-07-31 12:45:06');
INSERT INTO `access_log` VALUES (61191, '65.53.15645483062486833', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:45:06', 0, 1002001015, '账号未登陆', '2019-07-31 12:45:06');
INSERT INTO `access_log` VALUES (61192, '65.51.15645483062496903', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:45:06', 0, 1002001015, '账号未登陆', '2019-07-31 12:45:06');
INSERT INTO `access_log` VALUES (61193, '65.54.15645483278186747', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:45:28', 92, 0, '', '2019-07-31 12:45:28');
INSERT INTO `access_log` VALUES (61194, '65.46.15645483283136889', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:45:28', 171, 0, '', '2019-07-31 12:45:28');
INSERT INTO `access_log` VALUES (61195, '65.52.15645483283236877', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:45:28', 163, 0, '', '2019-07-31 12:45:28');
INSERT INTO `access_log` VALUES (61196, '65.49.15645483283086807', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.175.169.59', '2019-07-31 12:45:28', 177, 2001001000, '服务端发生异常', '2019-07-31 12:45:28');
INSERT INTO `access_log` VALUES (61197, '59.72.15645514792034385', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-31 13:37:59', 11, 0, '', '2019-07-31 13:37:59');
INSERT INTO `access_log` VALUES (61198, '59.74.15645514792044403', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-31 13:37:59', 24, 2001001000, '服务端发生异常', '2019-07-31 13:37:59');
INSERT INTO `access_log` VALUES (61199, '65.51.15645515010716947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-31 13:38:21', 98, 0, '', '2019-07-31 13:38:21');
INSERT INTO `access_log` VALUES (61200, '65.53.15645515014016877', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-31 13:38:21', 175, 0, '', '2019-07-31 13:38:22');
INSERT INTO `access_log` VALUES (61201, '65.47.15645515014086861', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-31 13:38:21', 174, 0, '', '2019-07-31 13:38:22');
INSERT INTO `access_log` VALUES (61202, '65.45.15645515014056877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-31 13:38:21', 177, 2001001000, '服务端发生异常', '2019-07-31 13:38:22');
INSERT INTO `access_log` VALUES (61203, '65.54.15645515118136791', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-31 13:38:32', 11, 0, '', '2019-07-31 13:38:32');
INSERT INTO `access_log` VALUES (61204, '65.49.15645515118186851', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-31 13:38:32', 17, 2001001000, '服务端发生异常', '2019-07-31 13:38:32');
INSERT INTO `access_log` VALUES (61205, '65.52.15645515118236921', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.232.196.218', '2019-07-31 13:38:32', 16, 0, '', '2019-07-31 13:38:32');
INSERT INTO `access_log` VALUES (61206, '59.80.15645522610784373', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-07-31 13:51:01', 3, 0, '', '2019-07-31 13:51:01');
INSERT INTO `access_log` VALUES (61207, '59.78.15645522610754405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-07-31 13:51:01', 12, 2001001000, '服务端发生异常', '2019-07-31 13:51:01');
INSERT INTO `access_log` VALUES (61208, '65.50.15645524959126891', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-07-31 13:54:56', 1, 1002001015, '账号未登陆', '2019-07-31 13:54:56');
INSERT INTO `access_log` VALUES (61209, '65.49.15645524959156865', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-07-31 13:54:56', 8, 1002001015, '账号未登陆', '2019-07-31 13:54:56');
INSERT INTO `access_log` VALUES (61210, '65.54.15645524959246805', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-07-31 13:54:56', 0, 1002001015, '账号未登陆', '2019-07-31 13:54:56');
INSERT INTO `access_log` VALUES (61211, '59.71.15645525034654401', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-07-31 13:55:03', 3, 0, '', '2019-07-31 13:55:03');
INSERT INTO `access_log` VALUES (61212, '59.76.15645525034644391', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-07-31 13:55:03', 41, 2001001000, '服务端发生异常', '2019-07-31 13:55:04');
INSERT INTO `access_log` VALUES (61213, '64.76.15645525102114687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-07-31 13:55:10', 11, 0, '', '2019-07-31 13:55:10');
INSERT INTO `access_log` VALUES (61214, '64.78.15645525103324691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-07-31 13:55:10', 3, 0, '', '2019-07-31 13:55:10');
INSERT INTO `access_log` VALUES (61215, '64.80.15645525155224697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-07-31 13:55:16', 2, 0, '', '2019-07-31 13:55:16');
INSERT INTO `access_log` VALUES (61216, '64.79.15645525156044683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '36.7.87.91', '2019-07-31 13:55:16', 2, 0, '', '2019-07-31 13:55:16');
INSERT INTO `access_log` VALUES (61217, '65.46.15645537156126963', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.246.26.50', '2019-07-31 14:15:16', 0, 1002001015, '账号未登陆', '2019-07-31 14:15:16');
INSERT INTO `access_log` VALUES (61218, '65.3607.15645537156148701', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.246.26.50', '2019-07-31 14:15:16', 8, 1002001015, '账号未登陆', '2019-07-31 14:15:16');
INSERT INTO `access_log` VALUES (61219, '65.51.15645537156146979', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.246.26.50', '2019-07-31 14:15:16', 9, 1002001015, '账号未登陆', '2019-07-31 14:15:16');
INSERT INTO `access_log` VALUES (61220, '65.54.15645537751946823', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.246.26.50', '2019-07-31 14:16:15', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 14:16:15');
INSERT INTO `access_log` VALUES (61221, '65.46.15645538093016965', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.246.26.50', '2019-07-31 14:16:49', 94, 0, '', '2019-07-31 14:16:49');
INSERT INTO `access_log` VALUES (61222, '65.51.15645538101206981', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.246.26.50', '2019-07-31 14:16:50', 9, 0, '', '2019-07-31 14:16:50');
INSERT INTO `access_log` VALUES (61223, '65.45.15645538101266911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.246.26.50', '2019-07-31 14:16:50', 15, 0, '', '2019-07-31 14:16:50');
INSERT INTO `access_log` VALUES (61224, '65.3607.15645538101258703', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.246.26.50', '2019-07-31 14:16:50', 17, 2001001000, '服务端发生异常', '2019-07-31 14:16:50');
INSERT INTO `access_log` VALUES (61225, '65.47.15645538190036895', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.246.26.50', '2019-07-31 14:16:59', 10, 0, '', '2019-07-31 14:16:59');
INSERT INTO `access_log` VALUES (61226, '65.49.15645538190086885', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.246.26.50', '2019-07-31 14:16:59', 10, 2001001000, '服务端发生异常', '2019-07-31 14:16:59');
INSERT INTO `access_log` VALUES (61227, '65.54.15645538190096825', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.246.26.50', '2019-07-31 14:16:59', 9, 0, '', '2019-07-31 14:16:59');
INSERT INTO `access_log` VALUES (61228, '65.54.15645557472516851', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-31 14:49:07', 16, 1002001012, '访问令牌已过期', '2019-07-31 14:49:07');
INSERT INTO `access_log` VALUES (61229, '65.49.15645557472506911', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-31 14:49:07', 13, 1002001012, '访问令牌已过期', '2019-07-31 14:49:07');
INSERT INTO `access_log` VALUES (61230, '65.50.15645557472666937', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-31 14:49:07', 2, 1002001012, '访问令牌已过期', '2019-07-31 14:49:07');
INSERT INTO `access_log` VALUES (61231, '65.46.15645557558306993', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-31 14:49:16', 1333, 0, '', '2019-07-31 14:49:17');
INSERT INTO `access_log` VALUES (61232, '65.3607.15645557577748731', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-31 14:49:18', 15, 2001001000, '服务端发生异常', '2019-07-31 14:49:18');
INSERT INTO `access_log` VALUES (61233, '65.45.15645557577756939', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-31 14:49:18', 14, 0, '', '2019-07-31 14:49:18');
INSERT INTO `access_log` VALUES (61234, '65.51.15645557577847009', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-31 14:49:18', 9, 0, '', '2019-07-31 14:49:18');
INSERT INTO `access_log` VALUES (61235, '65.54.15645557680996853', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-31 14:49:28', 9, 0, '', '2019-07-31 14:49:28');
INSERT INTO `access_log` VALUES (61236, '65.50.15645557680996939', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-31 14:49:28', 8, 0, '', '2019-07-31 14:49:28');
INSERT INTO `access_log` VALUES (61237, '65.47.15645557680996923', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.56.160.126', '2019-07-31 14:49:28', 9, 2001001000, '服务端发生异常', '2019-07-31 14:49:28');
INSERT INTO `access_log` VALUES (61238, '65.53.15645558666646941', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.129.146.18', '2019-07-31 14:51:07', 0, 1002001015, '账号未登陆', '2019-07-31 14:51:07');
INSERT INTO `access_log` VALUES (61239, '65.50.15645558666646941', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.129.146.18', '2019-07-31 14:51:07', 0, 1002001015, '账号未登陆', '2019-07-31 14:51:07');
INSERT INTO `access_log` VALUES (61240, '65.54.15645558666656855', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.129.146.18', '2019-07-31 14:51:07', 0, 1002001015, '账号未登陆', '2019-07-31 14:51:07');
INSERT INTO `access_log` VALUES (61241, '65.49.15645558691006915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.129.146.18', '2019-07-31 14:51:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 14:51:09');
INSERT INTO `access_log` VALUES (61242, '65.52.15645558797046985', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.129.146.18', '2019-07-31 14:51:20', 89, 0, '', '2019-07-31 14:51:20');
INSERT INTO `access_log` VALUES (61243, '65.46.15645558801196997', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.129.146.18', '2019-07-31 14:51:20', 18, 0, '', '2019-07-31 14:51:20');
INSERT INTO `access_log` VALUES (61244, '65.45.15645558801226943', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.129.146.18', '2019-07-31 14:51:20', 17, 0, '', '2019-07-31 14:51:20');
INSERT INTO `access_log` VALUES (61245, '65.3607.15645558801218735', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.129.146.18', '2019-07-31 14:51:20', 18, 2001001000, '服务端发生异常', '2019-07-31 14:51:20');
INSERT INTO `access_log` VALUES (61246, '65.53.15645558854166943', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.129.146.18', '2019-07-31 14:51:25', 9, 0, '', '2019-07-31 14:51:25');
INSERT INTO `access_log` VALUES (61247, '65.50.15645558854226943', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.129.146.18', '2019-07-31 14:51:25', 9, 0, '', '2019-07-31 14:51:25');
INSERT INTO `access_log` VALUES (61248, '65.54.15645558854216857', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.129.146.18', '2019-07-31 14:51:25', 9, 2001001000, '服务端发生异常', '2019-07-31 14:51:25');
INSERT INTO `access_log` VALUES (61249, '65.52.15645559155196987', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.129.146.18', '2019-07-31 14:51:56', 9, 0, '', '2019-07-31 14:51:56');
INSERT INTO `access_log` VALUES (61250, '65.45.15645559155206945', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.129.146.18', '2019-07-31 14:51:56', 10, 2001001000, '服务端发生异常', '2019-07-31 14:51:56');
INSERT INTO `access_log` VALUES (61251, '65.3607.15645559155218737', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.129.146.18', '2019-07-31 14:51:56', 9, 0, '', '2019-07-31 14:51:56');
INSERT INTO `access_log` VALUES (61252, '65.47.15645567410766939', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '171.8.148.122', '2019-07-31 15:05:41', 1, 1002001015, '账号未登陆', '2019-07-31 15:05:41');
INSERT INTO `access_log` VALUES (61253, '65.49.15645567410776929', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '171.8.148.122', '2019-07-31 15:05:41', 0, 1002001015, '账号未登陆', '2019-07-31 15:05:41');
INSERT INTO `access_log` VALUES (61254, '65.3607.15645567410878749', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '171.8.148.122', '2019-07-31 15:05:41', 0, 1002001015, '账号未登陆', '2019-07-31 15:05:41');
INSERT INTO `access_log` VALUES (61255, '65.52.15645567429636999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '171.8.148.122', '2019-07-31 15:05:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 15:05:43');
INSERT INTO `access_log` VALUES (61256, '65.46.15645567597527011', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '171.8.148.122', '2019-07-31 15:06:00', 74, 0, '', '2019-07-31 15:06:00');
INSERT INTO `access_log` VALUES (61257, '65.51.15645567601317027', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '171.8.148.122', '2019-07-31 15:06:00', 9, 0, '', '2019-07-31 15:06:00');
INSERT INTO `access_log` VALUES (61258, '65.54.15645567601376871', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '171.8.148.122', '2019-07-31 15:06:00', 9, 2001001000, '服务端发生异常', '2019-07-31 15:06:00');
INSERT INTO `access_log` VALUES (61259, '65.53.15645567601416957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '171.8.148.122', '2019-07-31 15:06:00', 9, 0, '', '2019-07-31 15:06:00');
INSERT INTO `access_log` VALUES (61260, '59.73.15645577971524475', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:17', 10, 0, '', '2019-07-31 15:23:17');
INSERT INTO `access_log` VALUES (61261, '59.79.15645577971534479', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:17', 17, 2001001000, '服务端发生异常', '2019-07-31 15:23:17');
INSERT INTO `access_log` VALUES (61262, '64.79.15645577990154755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:19', 11, 0, '', '2019-07-31 15:23:19');
INSERT INTO `access_log` VALUES (61263, '64.83.15645577991404755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:19', 3, 0, '', '2019-07-31 15:23:19');
INSERT INTO `access_log` VALUES (61264, '64.85.15645577999614795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:20', 2, 0, '', '2019-07-31 15:23:20');
INSERT INTO `access_log` VALUES (61265, '64.81.15645578004484763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:20', 1, 0, '', '2019-07-31 15:23:20');
INSERT INTO `access_log` VALUES (61266, '64.77.15645578008314755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:21', 2, 0, '', '2019-07-31 15:23:21');
INSERT INTO `access_log` VALUES (61267, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:22', 8, 0, '', '2019-07-31 15:23:22');
INSERT INTO `access_log` VALUES (61268, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:22', 13, 0, '', '2019-07-31 15:23:22');
INSERT INTO `access_log` VALUES (61269, '64.80.15645578030704769', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:23', 8, 0, '', '2019-07-31 15:23:23');
INSERT INTO `access_log` VALUES (61270, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:24', 7, 0, '', '2019-07-31 15:23:24');
INSERT INTO `access_log` VALUES (61271, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:25', 8, 0, '', '2019-07-31 15:23:25');
INSERT INTO `access_log` VALUES (61272, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:25', 5, 0, '', '2019-07-31 15:23:25');
INSERT INTO `access_log` VALUES (61273, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:25', 10, 0, '', '2019-07-31 15:23:25');
INSERT INTO `access_log` VALUES (61274, '64.78.15645578070864763', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:27', 5, 0, '', '2019-07-31 15:23:27');
INSERT INTO `access_log` VALUES (61275, '65.50.15645578158486971', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:36', 4, 1002001012, '访问令牌已过期', '2019-07-31 15:23:36');
INSERT INTO `access_log` VALUES (61276, '65.49.15645578158526945', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:36', 3, 1002001012, '访问令牌已过期', '2019-07-31 15:23:36');
INSERT INTO `access_log` VALUES (61277, '65.47.15645578158576955', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:36', 3, 1002001012, '访问令牌已过期', '2019-07-31 15:23:36');
INSERT INTO `access_log` VALUES (61278, '65.3607.15645578177368765', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:23:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 15:23:38');
INSERT INTO `access_log` VALUES (61279, '65.52.15645579569737017', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:25:57', 84, 0, '', '2019-07-31 15:25:57');
INSERT INTO `access_log` VALUES (61280, '65.45.15645579573256975', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:25:57', 10, 0, '', '2019-07-31 15:25:57');
INSERT INTO `access_log` VALUES (61281, '65.46.15645579573277029', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:25:57', 10, 2001001000, '服务端发生异常', '2019-07-31 15:25:57');
INSERT INTO `access_log` VALUES (61282, '65.51.15645579573317045', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.76.177.35', '2019-07-31 15:25:57', 9, 0, '', '2019-07-31 15:25:57');
INSERT INTO `access_log` VALUES (61283, '59.72.15645584133014479', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 15:33:33', 4, 0, '', '2019-07-31 15:33:33');
INSERT INTO `access_log` VALUES (61284, '59.74.15645584133054497', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.41.117.49', '2019-07-31 15:33:33', 10, 2001001000, '服务端发生异常', '2019-07-31 15:33:33');
INSERT INTO `access_log` VALUES (61285, '59.75.15645589128604499', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.0.28', '2019-07-31 15:41:53', 3, 0, '', '2019-07-31 15:41:53');
INSERT INTO `access_log` VALUES (61286, '59.73.15645589128614491', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.0.28', '2019-07-31 15:41:53', 15, 2001001000, '服务端发生异常', '2019-07-31 15:41:53');
INSERT INTO `access_log` VALUES (61287, '64.85.15645589185174811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.0.28', '2019-07-31 15:41:59', 3, 0, '', '2019-07-31 15:41:59');
INSERT INTO `access_log` VALUES (61288, '64.81.15645589186434779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.0.28', '2019-07-31 15:41:59', 2, 0, '', '2019-07-31 15:41:59');
INSERT INTO `access_log` VALUES (61289, '64.84.15645589236374773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.0.28', '2019-07-31 15:42:04', 2, 0, '', '2019-07-31 15:42:04');
INSERT INTO `access_log` VALUES (61290, '64.77.15645589237564771', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.0.28', '2019-07-31 15:42:04', 2, 0, '', '2019-07-31 15:42:04');
INSERT INTO `access_log` VALUES (61291, '64.78.15645589306784779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.0.28', '2019-07-31 15:42:11', 2, 0, '', '2019-07-31 15:42:11');
INSERT INTO `access_log` VALUES (61292, '64.76.15645589307984777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.0.28', '2019-07-31 15:42:11', 2, 0, '', '2019-07-31 15:42:11');
INSERT INTO `access_log` VALUES (61293, '59.77.15645589314354481', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.0.28', '2019-07-31 15:42:11', 2, 0, '', '2019-07-31 15:42:11');
INSERT INTO `access_log` VALUES (61294, '59.74.15645589314684505', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.137.0.28', '2019-07-31 15:42:11', 9, 2001001000, '服务端发生异常', '2019-07-31 15:42:11');
INSERT INTO `access_log` VALUES (61295, '59.73.15645611179294521', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:38', 10, 0, '', '2019-07-31 16:18:38');
INSERT INTO `access_log` VALUES (61296, '59.79.15645611179304525', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:38', 16, 2001001000, '服务端发生异常', '2019-07-31 16:18:38');
INSERT INTO `access_log` VALUES (61297, '64.77.15645611209784801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:41', 12, 0, '', '2019-07-31 16:18:41');
INSERT INTO `access_log` VALUES (61298, '64.80.15645611211084815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:41', 3, 0, '', '2019-07-31 16:18:41');
INSERT INTO `access_log` VALUES (61299, '64.78.15645611224264809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:42', 1, 0, '', '2019-07-31 16:18:42');
INSERT INTO `access_log` VALUES (61300, '64.76.15645611231464807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:43', 2, 0, '', '2019-07-31 16:18:43');
INSERT INTO `access_log` VALUES (61301, '64.82.15645611238664825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:44', 2, 0, '', '2019-07-31 16:18:44');
INSERT INTO `access_log` VALUES (61302, '64.79.15645611272444803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:47', 2, 0, '', '2019-07-31 16:18:47');
INSERT INTO `access_log` VALUES (61303, '64.83.15645611273564803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:47', 2, 0, '', '2019-07-31 16:18:47');
INSERT INTO `access_log` VALUES (61304, '59.77.15645611285284511', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:49', 3, 0, '', '2019-07-31 16:18:49');
INSERT INTO `access_log` VALUES (61305, '59.74.15645611285294535', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:49', 13, 2001001000, '服务端发生异常', '2019-07-31 16:18:49');
INSERT INTO `access_log` VALUES (61306, '64.81.15645611328674811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:53', 1, 0, '', '2019-07-31 16:18:53');
INSERT INTO `access_log` VALUES (61307, '64.84.15645611330054805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:53', 2, 0, '', '2019-07-31 16:18:53');
INSERT INTO `access_log` VALUES (61308, '59.71.15645611339244519', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:54', 3, 0, '', '2019-07-31 16:18:54');
INSERT INTO `access_log` VALUES (61309, '59.76.15645611339264509', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:54', 12, 2001001000, '服务端发生异常', '2019-07-31 16:18:54');
INSERT INTO `access_log` VALUES (61310, '65.49.15645611394396991', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:59', 1, 1002001015, '账号未登陆', '2019-07-31 16:18:59');
INSERT INTO `access_log` VALUES (61311, '65.47.15645611394417001', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:59', 1, 1002001015, '账号未登陆', '2019-07-31 16:18:59');
INSERT INTO `access_log` VALUES (61312, '65.50.15645611394437017', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:18:59', 0, 1002001015, '账号未登陆', '2019-07-31 16:18:59');
INSERT INTO `access_log` VALUES (61313, '65.3607.15645611417798811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:19:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 16:19:02');
INSERT INTO `access_log` VALUES (61314, '65.52.15645611447857061', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:19:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 16:19:05');
INSERT INTO `access_log` VALUES (61315, '65.51.15645611501057089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:19:10', 4, 1002002001, '密码不正确', '2019-07-31 16:19:10');
INSERT INTO `access_log` VALUES (61316, '65.46.15645611636277073', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:19:24', 68, 0, '', '2019-07-31 16:19:24');
INSERT INTO `access_log` VALUES (61317, '65.53.15645611640007019', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:19:24', 43, 0, '', '2019-07-31 16:19:24');
INSERT INTO `access_log` VALUES (61318, '65.50.15645611640037019', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:19:24', 30, 2001001000, '服务端发生异常', '2019-07-31 16:19:24');
INSERT INTO `access_log` VALUES (61319, '65.47.15645611640317003', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.13.204.53', '2019-07-31 16:19:24', 19, 0, '', '2019-07-31 16:19:24');
INSERT INTO `access_log` VALUES (61320, '65.47.15645615928627009', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '113.116.29.134', '2019-07-31 16:26:33', 0, 1002001015, '账号未登陆', '2019-07-31 16:26:33');
INSERT INTO `access_log` VALUES (61321, '65.50.15645615928637025', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '113.116.29.134', '2019-07-31 16:26:33', 0, 1002001015, '账号未登陆', '2019-07-31 16:26:33');
INSERT INTO `access_log` VALUES (61322, '65.49.15645615928686999', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '113.116.29.134', '2019-07-31 16:26:33', 1, 1002001015, '账号未登陆', '2019-07-31 16:26:33');
INSERT INTO `access_log` VALUES (61323, '65.3607.15645615972528819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '113.116.29.134', '2019-07-31 16:26:37', 75, 0, '', '2019-07-31 16:26:37');
INSERT INTO `access_log` VALUES (61324, '65.52.15645615975577069', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '113.116.29.134', '2019-07-31 16:26:38', 9, 0, '', '2019-07-31 16:26:38');
INSERT INTO `access_log` VALUES (61325, '65.45.15645615975617027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '113.116.29.134', '2019-07-31 16:26:38', 10, 2001001000, '服务端发生异常', '2019-07-31 16:26:38');
INSERT INTO `access_log` VALUES (61326, '65.51.15645615975647097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '113.116.29.134', '2019-07-31 16:26:38', 16, 0, '', '2019-07-31 16:26:38');
INSERT INTO `access_log` VALUES (61327, '65.45.15645623198917037', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:38:40', 0, 1002001015, '账号未登陆', '2019-07-31 16:38:40');
INSERT INTO `access_log` VALUES (61328, '65.52.15645623199037081', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:38:40', 0, 1002001015, '账号未登陆', '2019-07-31 16:38:40');
INSERT INTO `access_log` VALUES (61329, '65.51.15645623199097107', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:38:40', 0, 1002001015, '账号未登陆', '2019-07-31 16:38:40');
INSERT INTO `access_log` VALUES (61330, '65.46.15645623273597093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:38:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 16:38:47');
INSERT INTO `access_log` VALUES (61331, '65.49.15645623312277013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:38:51', 841, 0, '', '2019-07-31 16:38:52');
INSERT INTO `access_log` VALUES (61332, '65.54.15645623323456953', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:38:52', 17, 0, '', '2019-07-31 16:38:52');
INSERT INTO `access_log` VALUES (61333, '65.53.15645623323587037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:38:52', 10, 0, '', '2019-07-31 16:38:52');
INSERT INTO `access_log` VALUES (61334, '65.47.15645623323587021', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:38:52', 10, 2001001000, '服务端发生异常', '2019-07-31 16:38:52');
INSERT INTO `access_log` VALUES (61335, '65.3607.15645623467218833', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:39:07', 9, 0, '', '2019-07-31 16:39:07');
INSERT INTO `access_log` VALUES (61336, '65.45.15645623467247039', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:39:07', 10, 2001001000, '服务端发生异常', '2019-07-31 16:39:07');
INSERT INTO `access_log` VALUES (61337, '65.51.15645623467267109', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:39:07', 9, 0, '', '2019-07-31 16:39:07');
INSERT INTO `access_log` VALUES (61338, '65.46.15645623520677095', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:39:12', 10, 0, '', '2019-07-31 16:39:12');
INSERT INTO `access_log` VALUES (61339, '65.49.15645623520727015', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:39:12', 10, 2001001000, '服务端发生异常', '2019-07-31 16:39:12');
INSERT INTO `access_log` VALUES (61340, '65.54.15645623520786955', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:39:12', 9, 0, '', '2019-07-31 16:39:12');
INSERT INTO `access_log` VALUES (61341, '59.74.15645623903414553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:39:50', 4, 0, '', '2019-07-31 16:39:50');
INSERT INTO `access_log` VALUES (61342, '59.73.15645623903414539', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:39:50', 16, 2001001000, '服务端发生异常', '2019-07-31 16:39:50');
INSERT INTO `access_log` VALUES (61343, '64.82.15645623938904843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:39:54', 4, 0, '', '2019-07-31 16:39:54');
INSERT INTO `access_log` VALUES (61344, '64.79.15645623940064821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:39:54', 2, 0, '', '2019-07-31 16:39:54');
INSERT INTO `access_log` VALUES (61345, '59.77.15645623983854529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:39:58', 2, 0, '', '2019-07-31 16:39:58');
INSERT INTO `access_log` VALUES (61346, '59.72.15645623983854535', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:39:58', 14, 2001001000, '服务端发生异常', '2019-07-31 16:39:58');
INSERT INTO `access_log` VALUES (61347, '66.56.15645624166462289', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=16666666666&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:17', 17, 1001003000, '验证码不存在', '2019-07-31 16:40:17');
INSERT INTO `access_log` VALUES (61348, '66.57.15645624187722281', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=16666666666', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:19', 80, 0, '', '2019-07-31 16:40:19');
INSERT INTO `access_log` VALUES (61349, '66.51.15645624207302297', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=16666666666&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:21', 176, 0, '', '2019-07-31 16:40:21');
INSERT INTO `access_log` VALUES (61350, '59.75.15645624250004549', 186, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:25', 12, 0, '', '2019-07-31 16:40:25');
INSERT INTO `access_log` VALUES (61351, '59.79.15645624250004545', 186, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:25', 20, 2001001000, '服务端发生异常', '2019-07-31 16:40:25');
INSERT INTO `access_log` VALUES (61352, '64.84.15645624267964823', 186, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:27', 6, 0, '', '2019-07-31 16:40:27');
INSERT INTO `access_log` VALUES (61353, '64.80.15645624269614835', 186, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:27', 8, 0, '', '2019-07-31 16:40:27');
INSERT INTO `access_log` VALUES (61354, '64.76.15645624279354827', 186, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:28', 6, 0, '', '2019-07-31 16:40:28');
INSERT INTO `access_log` VALUES (61355, '64.79.15645624284274823', 186, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:28', 7, 0, '', '2019-07-31 16:40:28');
INSERT INTO `access_log` VALUES (61356, '64.83.15645624287654823', 186, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:29', 6, 0, '', '2019-07-31 16:40:29');
INSERT INTO `access_log` VALUES (61357, '59.73.15645624297974541', 186, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:30', 22, 0, '', '2019-07-31 16:40:30');
INSERT INTO `access_log` VALUES (61358, '59.74.15645624297974555', 186, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:30', 23, 2001001000, '服务端发生异常', '2019-07-31 16:40:30');
INSERT INTO `access_log` VALUES (61359, '64.85.15645624330004863', 186, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:33', 6, 0, '', '2019-07-31 16:40:33');
INSERT INTO `access_log` VALUES (61360, '64.81.15645624331554831', 186, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:33', 6, 0, '', '2019-07-31 16:40:33');
INSERT INTO `access_log` VALUES (61361, '59.77.15645624339484531', 186, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:34', 7, 0, '', '2019-07-31 16:40:34');
INSERT INTO `access_log` VALUES (61362, '59.72.15645624339484537', 186, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.203.200', '2019-07-31 16:40:34', 17, 2001001000, '服务端发生异常', '2019-07-31 16:40:34');
INSERT INTO `access_log` VALUES (61363, '59.79.15645624840684547', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:41:24', 2, 0, '', '2019-07-31 16:41:24');
INSERT INTO `access_log` VALUES (61364, '59.75.15645624840684551', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:41:24', 13, 2001001000, '服务端发生异常', '2019-07-31 16:41:24');
INSERT INTO `access_log` VALUES (61365, '64.76.15645624895484829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:41:30', 2, 0, '', '2019-07-31 16:41:30');
INSERT INTO `access_log` VALUES (61366, '64.82.15645624898484847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:41:30', 2, 0, '', '2019-07-31 16:41:30');
INSERT INTO `access_log` VALUES (61367, '65.53.15645624968697041', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.228.3.1', '2019-07-31 16:41:37', 1, 1002001015, '账号未登陆', '2019-07-31 16:41:37');
INSERT INTO `access_log` VALUES (61368, '65.46.15645624968687097', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.228.3.1', '2019-07-31 16:41:37', 0, 1002001015, '账号未登陆', '2019-07-31 16:41:37');
INSERT INTO `access_log` VALUES (61369, '65.47.15645624970817025', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.228.3.1', '2019-07-31 16:41:37', 0, 1002001015, '账号未登陆', '2019-07-31 16:41:37');
INSERT INTO `access_log` VALUES (61370, '65.3607.15645625073108837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.228.3.1', '2019-07-31 16:41:47', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 16:41:47');
INSERT INTO `access_log` VALUES (61371, '65.45.15645625218407043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.228.3.1', '2019-07-31 16:42:02', 70, 0, '', '2019-07-31 16:42:02');
INSERT INTO `access_log` VALUES (61372, '65.52.15645625224457087', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.228.3.1', '2019-07-31 16:42:02', 7, 0, '', '2019-07-31 16:42:02');
INSERT INTO `access_log` VALUES (61373, '65.49.15645625293887019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.228.3.1', '2019-07-31 16:42:09', 106, 0, '', '2019-07-31 16:42:09');
INSERT INTO `access_log` VALUES (61374, '65.53.15645625298727043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.228.3.1', '2019-07-31 16:42:10', 10, 0, '', '2019-07-31 16:42:10');
INSERT INTO `access_log` VALUES (61375, '65.46.15645625378327099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.228.3.1', '2019-07-31 16:42:18', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 16:42:18');
INSERT INTO `access_log` VALUES (61376, '65.47.15645625419007027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.228.3.1', '2019-07-31 16:42:22', 93, 0, '', '2019-07-31 16:42:22');
INSERT INTO `access_log` VALUES (61377, '65.50.15645625425837043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.228.3.1', '2019-07-31 16:42:23', 17, 0, '', '2019-07-31 16:42:23');
INSERT INTO `access_log` VALUES (61378, '65.51.15645625528787115', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.228.3.1', '2019-07-31 16:42:33', 313, 0, '', '2019-07-31 16:42:33');
INSERT INTO `access_log` VALUES (61379, '65.45.15645625535847045', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.228.3.1', '2019-07-31 16:42:34', 10, 0, '', '2019-07-31 16:42:34');
INSERT INTO `access_log` VALUES (61380, '65.54.15645625636696961', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:42:44', 95, 0, '', '2019-07-31 16:42:44');
INSERT INTO `access_log` VALUES (61381, '65.49.15645625641307021', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:42:44', 8, 0, '', '2019-07-31 16:42:44');
INSERT INTO `access_log` VALUES (61382, '65.53.15645625641357045', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:42:44', 8, 2001001000, '服务端发生异常', '2019-07-31 16:42:44');
INSERT INTO `access_log` VALUES (61383, '65.46.15645625641407101', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:42:44', 8, 0, '', '2019-07-31 16:42:44');
INSERT INTO `access_log` VALUES (61384, '64.80.15645625790434839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:42:59', 2, 0, '', '2019-07-31 16:42:59');
INSERT INTO `access_log` VALUES (61385, '64.78.15645625791394833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:42:59', 2, 0, '', '2019-07-31 16:42:59');
INSERT INTO `access_log` VALUES (61386, '59.80.15645625806894517', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:43:01', 3, 0, '', '2019-07-31 16:43:01');
INSERT INTO `access_log` VALUES (61387, '59.78.15645625809194549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:43:01', 13, 2001001000, '服务端发生异常', '2019-07-31 16:43:01');
INSERT INTO `access_log` VALUES (61388, '64.76.15645625829394831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:43:03', 2, 0, '', '2019-07-31 16:43:03');
INSERT INTO `access_log` VALUES (61389, '64.82.15645625832494849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:43:03', 2, 0, '', '2019-07-31 16:43:03');
INSERT INTO `access_log` VALUES (61390, '64.79.15645625841994827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:43:04', 2, 0, '', '2019-07-31 16:43:04');
INSERT INTO `access_log` VALUES (61391, '64.83.15645625851794827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:43:05', 1, 0, '', '2019-07-31 16:43:05');
INSERT INTO `access_log` VALUES (61392, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:43:06', 7, 0, '', '2019-07-31 16:43:06');
INSERT INTO `access_log` VALUES (61393, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:43:07', 4, 0, '', '2019-07-31 16:43:07');
INSERT INTO `access_log` VALUES (61394, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:43:07', 10, 0, '', '2019-07-31 16:43:07');
INSERT INTO `access_log` VALUES (61395, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:43:07', 11, 0, '', '2019-07-31 16:43:07');
INSERT INTO `access_log` VALUES (61396, '64.81.15645625886104835', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:43:09', 7, 0, '', '2019-07-31 16:43:09');
INSERT INTO `access_log` VALUES (61397, '66.55.15645630393432265', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.3.1', '2019-07-31 16:50:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空', '2019-07-31 16:50:39');
INSERT INTO `access_log` VALUES (61398, '59.74.15645702594464661', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.235.245', '2019-07-31 18:50:59', 13, 0, '', '2019-07-31 18:50:59');
INSERT INTO `access_log` VALUES (61399, '59.73.15645702594464647', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.88.235.245', '2019-07-31 18:50:59', 16, 2001001000, '服务端发生异常', '2019-07-31 18:50:59');
INSERT INTO `access_log` VALUES (61400, '65.49.15645719591247147', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.174.92.34', '2019-07-31 19:19:19', 5, 1002001015, '账号未登陆', '2019-07-31 19:19:19');
INSERT INTO `access_log` VALUES (61401, '65.54.15645719591247087', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.174.92.35', '2019-07-31 19:19:19', 1, 1002001015, '账号未登陆', '2019-07-31 19:19:19');
INSERT INTO `access_log` VALUES (61402, '65.53.15645719591297171', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.174.92.35', '2019-07-31 19:19:19', 1, 1002001015, '账号未登陆', '2019-07-31 19:19:19');
INSERT INTO `access_log` VALUES (61403, '65.46.15645719618717227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.174.92.35', '2019-07-31 19:19:22', 19, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 19:19:22');
INSERT INTO `access_log` VALUES (61404, '65.50.15645719716277171', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.174.92.35', '2019-07-31 19:19:32', 79, 0, '', '2019-07-31 19:19:32');
INSERT INTO `access_log` VALUES (61405, '65.3607.15645719721888967', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.174.92.34', '2019-07-31 19:19:32', 14, 2001001000, '服务端发生异常', '2019-07-31 19:19:32');
INSERT INTO `access_log` VALUES (61406, '65.52.15645751410757259', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.74', '2019-07-31 20:12:21', 0, 1002001015, '账号未登陆', '2019-07-31 20:12:21');
INSERT INTO `access_log` VALUES (61407, '65.45.15645751410757215', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.74', '2019-07-31 20:12:21', 0, 1002001015, '账号未登陆', '2019-07-31 20:12:21');
INSERT INTO `access_log` VALUES (61408, '65.53.15645751410767215', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.74', '2019-07-31 20:12:21', 0, 1002001015, '账号未登陆', '2019-07-31 20:12:21');
INSERT INTO `access_log` VALUES (61409, '65.49.15645751496917191', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.74', '2019-07-31 20:12:30', 73, 0, '', '2019-07-31 20:12:30');
INSERT INTO `access_log` VALUES (61410, '65.46.15645751500577271', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.74', '2019-07-31 20:12:30', 13, 0, '', '2019-07-31 20:12:30');
INSERT INTO `access_log` VALUES (61411, '65.47.15645751500657199', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.74', '2019-07-31 20:12:30', 9, 0, '', '2019-07-31 20:12:30');
INSERT INTO `access_log` VALUES (61412, '65.50.15645751500657215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.204.74', '2019-07-31 20:12:30', 12, 2001001000, '服务端发生异常', '2019-07-31 20:12:30');
INSERT INTO `access_log` VALUES (61413, '65.46.15645785529987317', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '139.202.57.62', '2019-07-31 21:09:13', 1, 1002001015, '账号未登陆', '2019-07-31 21:09:13');
INSERT INTO `access_log` VALUES (61414, '65.47.15645785529987245', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '139.202.57.62', '2019-07-31 21:09:13', 1, 1002001015, '账号未登陆', '2019-07-31 21:09:13');
INSERT INTO `access_log` VALUES (61415, '65.50.15645785529987261', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '139.202.57.62', '2019-07-31 21:09:13', 0, 1002001015, '账号未登陆', '2019-07-31 21:09:13');
INSERT INTO `access_log` VALUES (61416, '65.3607.15645785607939057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '139.202.57.62', '2019-07-31 21:09:21', 67, 0, '', '2019-07-31 21:09:21');
INSERT INTO `access_log` VALUES (61417, '65.52.15645785646607307', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '139.202.57.62', '2019-07-31 21:09:25', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 21:09:25');
INSERT INTO `access_log` VALUES (61418, '65.45.15645785719947263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '139.202.57.62', '2019-07-31 21:09:32', 97, 0, '', '2019-07-31 21:09:32');
INSERT INTO `access_log` VALUES (61419, '65.54.15645785880647179', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '139.202.57.62', '2019-07-31 21:09:48', 53, 0, '', '2019-07-31 21:09:48');
INSERT INTO `access_log` VALUES (61420, '65.49.15645785887337239', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '139.202.57.62', '2019-07-31 21:09:49', 44, 0, '', '2019-07-31 21:09:49');
INSERT INTO `access_log` VALUES (61421, '65.50.15645785887427263', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '139.202.57.62', '2019-07-31 21:09:49', 38, 0, '', '2019-07-31 21:09:49');
INSERT INTO `access_log` VALUES (61422, '65.46.15645785887357319', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '139.202.57.62', '2019-07-31 21:09:49', 46, 2001001000, '服务端发生异常', '2019-07-31 21:09:49');
INSERT INTO `access_log` VALUES (61423, '59.74.15645799528064789', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:32:33', 10, 0, '', '2019-07-31 21:32:33');
INSERT INTO `access_log` VALUES (61424, '59.76.15645799528074765', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:32:33', 26, 2001001000, '服务端发生异常', '2019-07-31 21:32:33');
INSERT INTO `access_log` VALUES (61425, '64.83.15645799554815059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:32:35', 12, 0, '', '2019-07-31 21:32:35');
INSERT INTO `access_log` VALUES (61426, '64.81.15645799556485067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:32:36', 3, 0, '', '2019-07-31 21:32:36');
INSERT INTO `access_log` VALUES (61427, '64.84.15645799570085061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:32:37', 2, 0, '', '2019-07-31 21:32:37');
INSERT INTO `access_log` VALUES (61428, '64.77.15645799575905059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:32:38', 1, 0, '', '2019-07-31 21:32:38');
INSERT INTO `access_log` VALUES (61429, '59.80.15645799582934751', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:32:38', 3, 0, '', '2019-07-31 21:32:38');
INSERT INTO `access_log` VALUES (61430, '59.78.15645799582974783', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:32:38', 17, 2001001000, '服务端发生异常', '2019-07-31 21:32:38');
INSERT INTO `access_log` VALUES (61431, '65.52.15645799650497327', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:32:45', 0, 1002001015, '账号未登陆', '2019-07-31 21:32:45');
INSERT INTO `access_log` VALUES (61432, '65.51.15645799650487353', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:32:45', 0, 1002001015, '账号未登陆', '2019-07-31 21:32:45');
INSERT INTO `access_log` VALUES (61433, '65.45.15645799650527283', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:32:45', 1, 1002001015, '账号未登陆', '2019-07-31 21:32:45');
INSERT INTO `access_log` VALUES (61434, '65.53.15645799671237283', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:32:47', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 21:32:47');
INSERT INTO `access_log` VALUES (61435, '65.54.15645799715897199', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:32:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-07-31 21:32:52');
INSERT INTO `access_log` VALUES (61436, '65.46.15645799798757339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:33:00', 87, 0, '', '2019-07-31 21:33:00');
INSERT INTO `access_log` VALUES (61437, '65.49.15645799803907259', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:33:00', 8, 0, '', '2019-07-31 21:33:00');
INSERT INTO `access_log` VALUES (61438, '65.47.15645799804007267', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:33:00', 8, 2001001000, '服务端发生异常', '2019-07-31 21:33:00');
INSERT INTO `access_log` VALUES (61439, '65.3607.15645799804069079', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:33:00', 9, 0, '', '2019-07-31 21:33:00');
INSERT INTO `access_log` VALUES (61440, '65.51.15645799851287355', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:33:05', 33, 0, '', '2019-07-31 21:33:05');
INSERT INTO `access_log` VALUES (61441, '65.52.15645799851457329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:33:05', 15, 0, '', '2019-07-31 21:33:05');
INSERT INTO `access_log` VALUES (61442, '65.45.15645799851387285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.209.70.138', '2019-07-31 21:33:05', 24, 2001001000, '服务端发生异常', '2019-07-31 21:33:05');
INSERT INTO `access_log` VALUES (61443, '59.72.15645815029414793', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:23', 3, 0, '', '2019-07-31 21:58:23');
INSERT INTO `access_log` VALUES (61444, '59.77.15645815029424787', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:23', 23, 2001001000, '服务端发生异常', '2019-07-31 21:58:23');
INSERT INTO `access_log` VALUES (61445, '64.82.15645815056565103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:26', 2, 0, '', '2019-07-31 21:58:26');
INSERT INTO `access_log` VALUES (61446, '64.79.15645815057915081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:26', 2, 0, '', '2019-07-31 21:58:26');
INSERT INTO `access_log` VALUES (61447, '64.85.15645815071725121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:27', 1, 0, '', '2019-07-31 21:58:27');
INSERT INTO `access_log` VALUES (61448, '64.83.15645815078405081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:28', 2, 0, '', '2019-07-31 21:58:28');
INSERT INTO `access_log` VALUES (61449, '66.52.15645815260502521', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18998949646&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:46', 18, 1001003000, '验证码不存在', '2019-07-31 21:58:46');
INSERT INTO `access_log` VALUES (61450, '64.84.15645815297575083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:50', 2, 0, '', '2019-07-31 21:58:50');
INSERT INTO `access_log` VALUES (61451, '64.77.15645815298905081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:50', 2, 0, '', '2019-07-31 21:58:50');
INSERT INTO `access_log` VALUES (61452, '64.78.15645815308245089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:51', 2, 0, '', '2019-07-31 21:58:51');
INSERT INTO `access_log` VALUES (61453, '64.76.15645815312815087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:51', 2, 0, '', '2019-07-31 21:58:51');
INSERT INTO `access_log` VALUES (61454, '64.82.15645815364885105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:56', 2, 0, '', '2019-07-31 21:58:56');
INSERT INTO `access_log` VALUES (61455, '64.79.15645815366385083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:57', 2, 0, '', '2019-07-31 21:58:57');
INSERT INTO `access_log` VALUES (61456, '59.78.15645815367644805', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:57', 2, 0, '', '2019-07-31 21:58:57');
INSERT INTO `access_log` VALUES (61457, '59.71.15645815367644795', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:58:57', 22, 2001001000, '服务端发生异常', '2019-07-31 21:58:57');
INSERT INTO `access_log` VALUES (61458, '64.85.15645815400515123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:59:00', 2, 0, '', '2019-07-31 21:59:00');
INSERT INTO `access_log` VALUES (61459, '64.83.15645815401685083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:59:00', 3, 0, '', '2019-07-31 21:59:00');
INSERT INTO `access_log` VALUES (61460, '59.79.15645815421484805', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:59:02', 2, 0, '', '2019-07-31 21:59:02');
INSERT INTO `access_log` VALUES (61461, '59.80.15645815421484773', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.123.74.77', '2019-07-31 21:59:02', 13, 2001001000, '服务端发生异常', '2019-07-31 21:59:02');
INSERT INTO `access_log` VALUES (61462, '59.79.15645867564204875', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.38.56.99', '2019-07-31 23:25:56', 10, 0, '', '2019-07-31 23:25:56');
INSERT INTO `access_log` VALUES (61463, '59.80.15645867564204843', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.38.56.99', '2019-07-31 23:25:56', 20, 2001001000, '服务端发生异常', '2019-07-31 23:25:56');
INSERT INTO `access_log` VALUES (61464, '59.75.15645869084154881', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '1.180.238.65', '2019-07-31 23:28:28', 4, 0, '', '2019-07-31 23:28:28');
INSERT INTO `access_log` VALUES (61465, '59.73.15645869084384871', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '1.180.238.65', '2019-07-31 23:28:28', 19, 2001001000, '服务端发生异常', '2019-07-31 23:28:28');
INSERT INTO `access_log` VALUES (61466, '64.85.15645869125525195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '1.180.238.65', '2019-07-31 23:28:33', 13, 0, '', '2019-07-31 23:28:33');
INSERT INTO `access_log` VALUES (61467, '64.83.15645869126985155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '1.180.238.65', '2019-07-31 23:28:33', 3, 0, '', '2019-07-31 23:28:33');
INSERT INTO `access_log` VALUES (61468, '64.84.15645869202245157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '1.180.238.65', '2019-07-31 23:28:40', 2, 0, '', '2019-07-31 23:28:40');
INSERT INTO `access_log` VALUES (61469, '64.77.15645869203805155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '1.180.238.65', '2019-07-31 23:28:40', 2, 0, '', '2019-07-31 23:28:40');
INSERT INTO `access_log` VALUES (61470, '59.76.15645869282194861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '1.180.238.65', '2019-07-31 23:28:48', 2, 0, '', '2019-07-31 23:28:48');
INSERT INTO `access_log` VALUES (61471, '59.77.15645869282094861', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '1.180.238.65', '2019-07-31 23:28:48', 32, 2001001000, '服务端发生异常', '2019-07-31 23:28:48');
INSERT INTO `access_log` VALUES (61472, '64.78.15645869336145163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '1.180.238.65', '2019-07-31 23:28:54', 2, 0, '', '2019-07-31 23:28:54');
INSERT INTO `access_log` VALUES (61473, '64.76.15645869337565161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '1.180.238.65', '2019-07-31 23:28:54', 2, 0, '', '2019-07-31 23:28:54');
INSERT INTO `access_log` VALUES (61474, '59.71.15645869353954869', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '1.180.238.65', '2019-07-31 23:28:55', 3, 0, '', '2019-07-31 23:28:55');
INSERT INTO `access_log` VALUES (61475, '59.78.15645869354064879', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '1.180.238.65', '2019-07-31 23:28:55', 13, 2001001000, '服务端发生异常', '2019-07-31 23:28:55');
INSERT INTO `access_log` VALUES (61476, '59.75.15646079719235163', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '42.236.10.78', '2019-08-01 05:19:32', 11, 0, '', '2019-08-01 05:19:32');
INSERT INTO `access_log` VALUES (61477, '59.73.15646079719285153', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '42.236.10.75', '2019-08-01 05:19:32', 26, 2001001000, '服务端发生异常', '2019-08-01 05:19:32');
INSERT INTO `access_log` VALUES (61478, '65.54.15646236166717783', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.164.47.199', '2019-08-01 09:40:17', 0, 1002001015, '账号未登陆', '2019-08-01 09:40:17');
INSERT INTO `access_log` VALUES (61479, '65.53.15646236166717867', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.164.47.199', '2019-08-01 09:40:17', 0, 1002001015, '账号未登陆', '2019-08-01 09:40:17');
INSERT INTO `access_log` VALUES (61480, '65.45.15646236166687867', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.164.47.199', '2019-08-01 09:40:17', 1, 1002001015, '账号未登陆', '2019-08-01 09:40:17');
INSERT INTO `access_log` VALUES (61481, '65.46.15646236250177923', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.164.47.199', '2019-08-01 09:40:25', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 09:40:25');
INSERT INTO `access_log` VALUES (61482, '65.47.15646236687227851', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.164.47.199', '2019-08-01 09:41:09', 119, 0, '', '2019-08-01 09:41:09');
INSERT INTO `access_log` VALUES (61483, '65.52.15646236692027913', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.164.47.199', '2019-08-01 09:41:09', 16, 0, '', '2019-08-01 09:41:09');
INSERT INTO `access_log` VALUES (61484, '65.45.15646236692057869', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.164.47.199', '2019-08-01 09:41:09', 13, 2001001000, '服务端发生异常', '2019-08-01 09:41:09');
INSERT INTO `access_log` VALUES (61485, '65.53.15646236692097869', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.164.47.199', '2019-08-01 09:41:09', 13, 0, '', '2019-08-01 09:41:09');
INSERT INTO `access_log` VALUES (61486, '65.54.15646236745817785', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.164.47.199', '2019-08-01 09:41:15', 9, 0, '', '2019-08-01 09:41:15');
INSERT INTO `access_log` VALUES (61487, '65.50.15646236745847869', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.164.47.199', '2019-08-01 09:41:15', 10, 2001001000, '服务端发生异常', '2019-08-01 09:41:15');
INSERT INTO `access_log` VALUES (61488, '65.46.15646236745887925', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.164.47.199', '2019-08-01 09:41:15', 8, 0, '', '2019-08-01 09:41:15');
INSERT INTO `access_log` VALUES (61489, '65.46.15646242656197933', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.14.99.28', '2019-08-01 09:51:06', 12, 1002001012, '访问令牌已过期', '2019-08-01 09:51:06');
INSERT INTO `access_log` VALUES (61490, '65.49.15646242656207853', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.14.99.28', '2019-08-01 09:51:06', 4, 1002001012, '访问令牌已过期', '2019-08-01 09:51:06');
INSERT INTO `access_log` VALUES (61491, '65.3607.15646242656289673', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.14.99.28', '2019-08-01 09:51:06', 3, 1002001012, '访问令牌已过期', '2019-08-01 09:51:06');
INSERT INTO `access_log` VALUES (61492, '65.50.15646243384747879', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.14.99.28', '2019-08-01 09:52:18', 62, 0, '', '2019-08-01 09:52:19');
INSERT INTO `access_log` VALUES (61493, '65.54.15646243388437795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.14.99.28', '2019-08-01 09:52:19', 10, 0, '', '2019-08-01 09:52:19');
INSERT INTO `access_log` VALUES (61494, '65.46.15646243388477935', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.14.99.28', '2019-08-01 09:52:19', 11, 2001001000, '服务端发生异常', '2019-08-01 09:52:19');
INSERT INTO `access_log` VALUES (61495, '65.49.15646243388927855', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.14.99.28', '2019-08-01 09:52:19', 10, 0, '', '2019-08-01 09:52:19');
INSERT INTO `access_log` VALUES (61496, '65.3607.15646243432399675', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.14.99.28', '2019-08-01 09:52:23', 9, 0, '', '2019-08-01 09:52:23');
INSERT INTO `access_log` VALUES (61497, '65.47.15646243432457863', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.14.99.28', '2019-08-01 09:52:23', 11, 2001001000, '服务端发生异常', '2019-08-01 09:52:23');
INSERT INTO `access_log` VALUES (61498, '65.51.15646243432537951', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '123.14.99.28', '2019-08-01 09:52:23', 9, 0, '', '2019-08-01 09:52:23');
INSERT INTO `access_log` VALUES (61499, '65.51.15646249224117959', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.87.21', '2019-08-01 10:02:02', 5, 1002001012, '访问令牌已过期', '2019-08-01 10:02:02');
INSERT INTO `access_log` VALUES (61500, '65.52.15646249224117933', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.87.21', '2019-08-01 10:02:02', 4, 1002001012, '访问令牌已过期', '2019-08-01 10:02:02');
INSERT INTO `access_log` VALUES (61501, '65.45.15646249224117889', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.87.21', '2019-08-01 10:02:02', 4, 1002001012, '访问令牌已过期', '2019-08-01 10:02:02');
INSERT INTO `access_log` VALUES (61502, '65.53.15646249256487889', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.87.21', '2019-08-01 10:02:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 10:02:06');
INSERT INTO `access_log` VALUES (61503, '65.46.15646249325467945', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.87.21', '2019-08-01 10:02:13', 72, 0, '', '2019-08-01 10:02:13');
INSERT INTO `access_log` VALUES (61504, '65.54.15646249329537805', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.87.21', '2019-08-01 10:02:13', 11, 0, '', '2019-08-01 10:02:13');
INSERT INTO `access_log` VALUES (61505, '65.49.15646249329557865', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.87.21', '2019-08-01 10:02:13', 10, 2001001000, '服务端发生异常', '2019-08-01 10:02:13');
INSERT INTO `access_log` VALUES (61506, '65.3607.15646249329709685', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.87.21', '2019-08-01 10:02:13', 9, 0, '', '2019-08-01 10:02:13');
INSERT INTO `access_log` VALUES (61507, '65.45.15646249380607891', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.87.21', '2019-08-01 10:02:18', 9, 0, '', '2019-08-01 10:02:18');
INSERT INTO `access_log` VALUES (61508, '65.47.15646249380587873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.87.21', '2019-08-01 10:02:18', 11, 2001001000, '服务端发生异常', '2019-08-01 10:02:18');
INSERT INTO `access_log` VALUES (61509, '65.51.15646249381687961', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.87.21', '2019-08-01 10:02:18', 9, 0, '', '2019-08-01 10:02:18');
INSERT INTO `access_log` VALUES (61510, '65.50.15646249621177891', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.87.21', '2019-08-01 10:02:42', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 10:02:42');
INSERT INTO `access_log` VALUES (61511, '65.45.15646262281337909', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:23:48', 4, 1002001012, '访问令牌已过期', '2019-08-01 10:23:48');
INSERT INTO `access_log` VALUES (61512, '65.47.15646262281337891', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:23:48', 4, 1002001012, '访问令牌已过期', '2019-08-01 10:23:48');
INSERT INTO `access_log` VALUES (61513, '65.51.15646262281337979', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:23:48', 4, 1002001012, '访问令牌已过期', '2019-08-01 10:23:48');
INSERT INTO `access_log` VALUES (61514, '65.52.15646262318787953', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:23:52', 76, 0, '', '2019-08-01 10:23:52');
INSERT INTO `access_log` VALUES (61515, '65.53.15646262321667909', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:23:52', 9, 0, '', '2019-08-01 10:23:52');
INSERT INTO `access_log` VALUES (61516, '65.50.15646262321697909', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:23:52', 8, 2001001000, '服务端发生异常', '2019-08-01 10:23:52');
INSERT INTO `access_log` VALUES (61517, '65.46.15646262321707965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:23:52', 8, 0, '', '2019-08-01 10:23:52');
INSERT INTO `access_log` VALUES (61518, '65.54.15646262527317825', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:24:13', 9, 0, '', '2019-08-01 10:24:13');
INSERT INTO `access_log` VALUES (61519, '65.51.15646262527337981', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:24:13', 10, 2001001000, '服务端发生异常', '2019-08-01 10:24:13');
INSERT INTO `access_log` VALUES (61520, '65.45.15646262527347911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:24:13', 9, 0, '', '2019-08-01 10:24:13');
INSERT INTO `access_log` VALUES (61521, '65.47.15646262600817893', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:24:20', 8, 0, '', '2019-08-01 10:24:20');
INSERT INTO `access_log` VALUES (61522, '65.52.15646262600837955', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:24:20', 8, 2001001000, '服务端发生异常', '2019-08-01 10:24:20');
INSERT INTO `access_log` VALUES (61523, '65.50.15646262600857911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:24:20', 7, 0, '', '2019-08-01 10:24:20');
INSERT INTO `access_log` VALUES (61524, '65.54.15646263294567827', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:25:29', 10, 0, '', '2019-08-01 10:25:29');
INSERT INTO `access_log` VALUES (61525, '65.51.15646263294597983', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:25:29', 10, 2001001000, '服务端发生异常', '2019-08-01 10:25:29');
INSERT INTO `access_log` VALUES (61526, '65.52.15646263294607957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.89.187', '2019-08-01 10:25:29', 9, 0, '', '2019-08-01 10:25:29');
INSERT INTO `access_log` VALUES (61527, '59.72.15646269598055403', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.87.21', '2019-08-01 10:36:00', 10, 0, '', '2019-08-01 10:36:00');
INSERT INTO `access_log` VALUES (61528, '59.76.15646269598095397', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.87.21', '2019-08-01 10:36:00', 21, 2001001000, '服务端发生异常', '2019-08-01 10:36:00');
INSERT INTO `access_log` VALUES (61529, '59.71.15646293831515435', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:23', 10, 0, '', '2019-08-01 11:16:23');
INSERT INTO `access_log` VALUES (61530, '59.74.15646293831515453', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:23', 23, 2001001000, '服务端发生异常', '2019-08-01 11:16:23');
INSERT INTO `access_log` VALUES (61531, '64.76.15646293897745729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:30', 13, 0, '', '2019-08-01 11:16:30');
INSERT INTO `access_log` VALUES (61532, '64.82.15646293899295745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:30', 3, 0, '', '2019-08-01 11:16:30');
INSERT INTO `access_log` VALUES (61533, '64.79.15646293917955725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:32', 2, 0, '', '2019-08-01 11:16:32');
INSERT INTO `access_log` VALUES (61534, '64.85.15646293924405763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:32', 2, 0, '', '2019-08-01 11:16:32');
INSERT INTO `access_log` VALUES (61535, '59.78.15646293936225447', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:34', 3, 0, '', '2019-08-01 11:16:34');
INSERT INTO `access_log` VALUES (61536, '59.80.15646293936235413', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:34', 14, 2001001000, '服务端发生异常', '2019-08-01 11:16:34');
INSERT INTO `access_log` VALUES (61537, '65.45.15646294041317953', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:44', 0, 1002001015, '账号未登陆', '2019-08-01 11:16:44');
INSERT INTO `access_log` VALUES (61538, '65.3607.15646294041319749', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:44', 0, 1002001015, '账号未登陆', '2019-08-01 11:16:44');
INSERT INTO `access_log` VALUES (61539, '65.52.15646294041338003', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:44', 0, 1002001015, '账号未登陆', '2019-08-01 11:16:44');
INSERT INTO `access_log` VALUES (61540, '65.47.15646294060567937', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 11:16:46');
INSERT INTO `access_log` VALUES (61541, '65.51.15646294181318027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:58', 88, 0, '', '2019-08-01 11:16:58');
INSERT INTO `access_log` VALUES (61542, '65.53.15646294188037955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:59', 238, 0, '', '2019-08-01 11:16:59');
INSERT INTO `access_log` VALUES (61543, '65.46.15646294188058009', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:59', 239, 0, '', '2019-08-01 11:16:59');
INSERT INTO `access_log` VALUES (61544, '65.50.15646294188057955', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '183.134.103.169', '2019-08-01 11:16:59', 240, 2001001000, '服务端发生异常', '2019-08-01 11:16:59');
INSERT INTO `access_log` VALUES (61545, '65.49.15646328651447983', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:14:25', 0, 1002001015, '账号未登陆', '2019-08-01 12:14:25');
INSERT INTO `access_log` VALUES (61546, '65.45.15646328651458001', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:14:25', 0, 1002001015, '账号未登陆', '2019-08-01 12:14:25');
INSERT INTO `access_log` VALUES (61547, '65.3607.15646328651469797', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:14:25', 0, 1002001015, '账号未登陆', '2019-08-01 12:14:25');
INSERT INTO `access_log` VALUES (61548, '65.52.15646328699708051', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:14:30', 84, 0, '', '2019-08-01 12:14:30');
INSERT INTO `access_log` VALUES (61549, '65.47.15646328702587985', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:14:30', 41, 0, '', '2019-08-01 12:14:30');
INSERT INTO `access_log` VALUES (61550, '65.51.15646328702718075', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:14:30', 29, 0, '', '2019-08-01 12:14:30');
INSERT INTO `access_log` VALUES (61551, '65.54.15646328702677919', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:14:30', 34, 2001001000, '服务端发生异常', '2019-08-01 12:14:30');
INSERT INTO `access_log` VALUES (61552, '65.46.15646328846798057', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:14:45', 10, 0, '', '2019-08-01 12:14:45');
INSERT INTO `access_log` VALUES (61553, '65.53.15646328846838003', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:14:45', 10, 2001001000, '服务端发生异常', '2019-08-01 12:14:45');
INSERT INTO `access_log` VALUES (61554, '65.45.15646328846878003', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:14:45', 10, 0, '', '2019-08-01 12:14:45');
INSERT INTO `access_log` VALUES (61555, '65.3607.15646328955319799', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:14:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 12:14:56');
INSERT INTO `access_log` VALUES (61556, '65.52.15646328998578053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:15:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 12:15:00');
INSERT INTO `access_log` VALUES (61557, '65.51.15646329030298077', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:15:03', 4, 1002002001, '密码不正确', '2019-08-01 12:15:03');
INSERT INTO `access_log` VALUES (61558, '65.47.15646329064007987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:15:06', 119, 0, '', '2019-08-01 12:15:07');
INSERT INTO `access_log` VALUES (61559, '65.54.15646329066847921', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:15:07', 10, 0, '', '2019-08-01 12:15:07');
INSERT INTO `access_log` VALUES (61560, '65.45.15646329066878005', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:15:07', 8, 0, '', '2019-08-01 12:15:07');
INSERT INTO `access_log` VALUES (61561, '65.50.15646329066858005', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:15:07', 13, 0, '', '2019-08-01 12:15:07');
INSERT INTO `access_log` VALUES (61562, '62.84.15646329111444433', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:15:11', 32, 0, '', '2019-08-01 12:15:11');
INSERT INTO `access_log` VALUES (61563, '65.49.15646329278807987', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:15:28', 10, 0, '', '2019-08-01 12:15:28');
INSERT INTO `access_log` VALUES (61564, '65.3607.15646329278829801', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:15:28', 9, 0, '', '2019-08-01 12:15:28');
INSERT INTO `access_log` VALUES (61565, '65.52.15646329278848055', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:15:28', 9, 0, '', '2019-08-01 12:15:28');
INSERT INTO `access_log` VALUES (61566, '62.89.15646329280184449', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:15:28', 46, 0, '', '2019-08-01 12:15:28');
INSERT INTO `access_log` VALUES (61567, '65.50.15646329711268007', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:16:11', 9, 0, '', '2019-08-01 12:16:11');
INSERT INTO `access_log` VALUES (61568, '65.54.15646329711287923', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:16:11', 8, 0, '', '2019-08-01 12:16:11');
INSERT INTO `access_log` VALUES (61569, '65.46.15646329711338061', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:16:11', 7, 0, '', '2019-08-01 12:16:11');
INSERT INTO `access_log` VALUES (61570, '59.73.15646330535495489', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:17:34', 11, 0, '', '2019-08-01 12:17:34');
INSERT INTO `access_log` VALUES (61571, '59.77.15646330535515479', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:17:34', 27, 2001001000, '服务端发生异常', '2019-08-01 12:17:34');
INSERT INTO `access_log` VALUES (61572, '64.78.15646330616715781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:17:42', 9, 0, '', '2019-08-01 12:17:42');
INSERT INTO `access_log` VALUES (61573, '64.76.15646330618305779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:17:42', 4, 0, '', '2019-08-01 12:17:42');
INSERT INTO `access_log` VALUES (61574, '64.82.15646330674965795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:17:47', 2, 0, '', '2019-08-01 12:17:48');
INSERT INTO `access_log` VALUES (61575, '64.79.15646330675965775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:17:48', 2, 0, '', '2019-08-01 12:17:48');
INSERT INTO `access_log` VALUES (61576, '59.78.15646330682475497', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:17:48', 3, 0, '', '2019-08-01 12:17:48');
INSERT INTO `access_log` VALUES (61577, '59.74.15646330682475503', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:17:48', 14, 2001001000, '服务端发生异常', '2019-08-01 12:17:48');
INSERT INTO `access_log` VALUES (61578, '65.46.15646330872618063', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:18:07', 0, 1002001015, '账号未登陆', '2019-08-01 12:18:07');
INSERT INTO `access_log` VALUES (61579, '65.50.15646330872618009', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:18:07', 0, 1002001015, '账号未登陆', '2019-08-01 12:18:07');
INSERT INTO `access_log` VALUES (61580, '65.54.15646330872937925', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:18:07', 0, 1002001015, '账号未登陆', '2019-08-01 12:18:07');
INSERT INTO `access_log` VALUES (61581, '65.52.15646330949128059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:18:15', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 12:18:15');
INSERT INTO `access_log` VALUES (61582, '65.3607.15646331037819805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:18:24', 79, 0, '', '2019-08-01 12:18:24');
INSERT INTO `access_log` VALUES (61583, '65.51.15646331040798083', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:18:24', 8, 0, '', '2019-08-01 12:18:24');
INSERT INTO `access_log` VALUES (61584, '65.47.15646331040807993', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:18:24', 9, 2001001000, '服务端发生异常', '2019-08-01 12:18:24');
INSERT INTO `access_log` VALUES (61585, '65.45.15646331040838011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.92 Safari/537.36', '116.6.135.19', '2019-08-01 12:18:24', 7, 0, '', '2019-08-01 12:18:24');
INSERT INTO `access_log` VALUES (61586, '62.87.15646331425454441', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:03', 15, 0, '', '2019-08-01 12:19:03');
INSERT INTO `access_log` VALUES (61587, '62.85.15646331582254467', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:18', 13, 0, '', '2019-08-01 12:19:18');
INSERT INTO `access_log` VALUES (61588, '62.80.15646331612234453', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:21', 12, 0, '', '2019-08-01 12:19:21');
INSERT INTO `access_log` VALUES (61589, '62.89.15646331636294453', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:24', 14, 0, '', '2019-08-01 12:19:24');
INSERT INTO `access_log` VALUES (61590, '64.79.15646331821425777', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:42', 9, 0, '', '2019-08-01 12:19:42');
INSERT INTO `access_log` VALUES (61591, '64.82.15646331821385797', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:42', 16, 0, '', '2019-08-01 12:19:42');
INSERT INTO `access_log` VALUES (61592, '64.81.15646331880835781', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:48', 11, 0, '', '2019-08-01 12:19:48');
INSERT INTO `access_log` VALUES (61593, '64.85.15646331880825815', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:48', 26, 0, '', '2019-08-01 12:19:48');
INSERT INTO `access_log` VALUES (61594, '64.83.15646331899795777', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:50', 11, 0, '', '2019-08-01 12:19:50');
INSERT INTO `access_log` VALUES (61595, '64.77.15646331899795775', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:50', 10, 0, '', '2019-08-01 12:19:50');
INSERT INTO `access_log` VALUES (61596, '64.78.15646331926765785', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:53', 9, 0, '', '2019-08-01 12:19:53');
INSERT INTO `access_log` VALUES (61597, '64.80.15646331926735789', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:53', 14, 0, '', '2019-08-01 12:19:53');
INSERT INTO `access_log` VALUES (61598, '64.79.15646331969895779', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:57', 9, 0, '', '2019-08-01 12:19:57');
INSERT INTO `access_log` VALUES (61599, '64.82.15646331969885799', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:57', 10, 0, '', '2019-08-01 12:19:57');
INSERT INTO `access_log` VALUES (61600, '64.76.15646331969855783', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:19:57', 18, 0, '', '2019-08-01 12:19:57');
INSERT INTO `access_log` VALUES (61601, '62.86.15646332053914437', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:20:05', 12, 0, '', '2019-08-01 12:20:05');
INSERT INTO `access_log` VALUES (61602, '66.50.15646332168953219', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:20:17', 19, 0, '', '2019-08-01 12:20:17');
INSERT INTO `access_log` VALUES (61603, '59.79.15646332263885499', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:20:26', 15, 0, '', '2019-08-01 12:20:26');
INSERT INTO `access_log` VALUES (61604, '65.46.15646332584248067', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:20:58', 25, 0, '', '2019-08-01 12:20:58');
INSERT INTO `access_log` VALUES (61605, '65.50.15646332638418013', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:21:04', 17, 0, '', '2019-08-01 12:21:04');
INSERT INTO `access_log` VALUES (61606, '65.54.15646332658027929', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:21:06', 25, 0, '', '2019-08-01 12:21:06');
INSERT INTO `access_log` VALUES (61607, '65.53.15646332684728013', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:21:08', 9, 0, '', '2019-08-01 12:21:08');
INSERT INTO `access_log` VALUES (61608, '65.3607.15646332694069809', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:21:09', 18, 0, '', '2019-08-01 12:21:09');
INSERT INTO `access_log` VALUES (61609, '65.53.15646333851608015', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:23:05', 10, 0, '', '2019-08-01 12:23:05');
INSERT INTO `access_log` VALUES (61610, '64.78.15646334142075789', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:23:34', 14, 0, '', '2019-08-01 12:23:34');
INSERT INTO `access_log` VALUES (61611, '64.84.15646334142065783', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:23:34', 15, 0, '', '2019-08-01 12:23:34');
INSERT INTO `access_log` VALUES (61612, '64.79.15646334228355783', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:23:43', 9, 0, '', '2019-08-01 12:23:43');
INSERT INTO `access_log` VALUES (61613, '64.82.15646334228355803', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:23:43', 19, 0, '', '2019-08-01 12:23:43');
INSERT INTO `access_log` VALUES (61614, '64.76.15646334228345787', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 12:23:43', 22, 0, '', '2019-08-01 12:23:43');
INSERT INTO `access_log` VALUES (61615, '59.74.15646354204615535', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.168.41.154', '2019-08-01 12:57:00', 9, 0, '', '2019-08-01 12:57:00');
INSERT INTO `access_log` VALUES (61616, '59.78.15646354204745529', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.168.41.154', '2019-08-01 12:57:00', 13, 2001001000, '服务端发生异常', '2019-08-01 12:57:00');
INSERT INTO `access_log` VALUES (61617, '64.77.15646364649825821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.168.41.154', '2019-08-01 13:14:25', 55, 0, '', '2019-08-01 13:14:25');
INSERT INTO `access_log` VALUES (61618, '64.78.15646364651385831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.168.41.154', '2019-08-01 13:14:25', 4, 0, '', '2019-08-01 13:14:25');
INSERT INTO `access_log` VALUES (61619, '59.78.15646389760535577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:16', 19, 2001001000, '服务端发生异常', '2019-08-01 13:56:16');
INSERT INTO `access_log` VALUES (61620, '59.71.15646389760525565', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:16', 146, 0, '', '2019-08-01 13:56:16');
INSERT INTO `access_log` VALUES (61621, '59.80.15646389834815543', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:23', 3, 0, '', '2019-08-01 13:56:23');
INSERT INTO `access_log` VALUES (61622, '59.79.15646389834825577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:23', 11, 2001001000, '服务端发生异常', '2019-08-01 13:56:23');
INSERT INTO `access_log` VALUES (61623, '64.77.15646389855465855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:26', 15, 0, '', '2019-08-01 13:56:26');
INSERT INTO `access_log` VALUES (61624, '64.78.15646389856965865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:26', 3, 0, '', '2019-08-01 13:56:26');
INSERT INTO `access_log` VALUES (61625, '66.55.15646389883483281', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机号不能为空\n手机验证码长度为 4-6 位', '2019-08-01 13:56:28');
INSERT INTO `access_log` VALUES (61626, '64.84.15646389915475859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:32', 2, 0, '', '2019-08-01 13:56:32');
INSERT INTO `access_log` VALUES (61627, '64.80.15646389916495869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:32', 2, 0, '', '2019-08-01 13:56:32');
INSERT INTO `access_log` VALUES (61628, '65.47.15646389996158073', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:40', 1, 1002001015, '账号未登陆', '2019-08-01 13:56:40');
INSERT INTO `access_log` VALUES (61629, '65.46.15646389996168145', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:40', 1, 1002001015, '账号未登陆', '2019-08-01 13:56:40');
INSERT INTO `access_log` VALUES (61630, '65.50.15646389996168091', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:40', 0, 1002001015, '账号未登陆', '2019-08-01 13:56:40');
INSERT INTO `access_log` VALUES (61631, '65.54.15646390063108007', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:46', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 13:56:46');
INSERT INTO `access_log` VALUES (61632, '65.53.15646390109828091', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:51', 75, 0, '', '2019-08-01 13:56:51');
INSERT INTO `access_log` VALUES (61633, '65.52.15646390112898141', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:51', 16, 0, '', '2019-08-01 13:56:51');
INSERT INTO `access_log` VALUES (61634, '65.3607.15646390112909887', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:51', 17, 2001001000, '服务端发生异常', '2019-08-01 13:56:51');
INSERT INTO `access_log` VALUES (61635, '65.49.15646390112918073', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.68.66.250', '2019-08-01 13:56:51', 14, 0, '', '2019-08-01 13:56:51');
INSERT INTO `access_log` VALUES (61636, '65.49.15646396544678083', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 14:07:34', 4, 1002001012, '访问令牌已过期', '2019-08-01 14:07:34');
INSERT INTO `access_log` VALUES (61637, '65.53.15646396544678101', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 14:07:34', 4, 1002001012, '访问令牌已过期', '2019-08-01 14:07:34');
INSERT INTO `access_log` VALUES (61638, '65.3607.15646396544719897', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 14:07:34', 3, 1002001012, '访问令牌已过期', '2019-08-01 14:07:34');
INSERT INTO `access_log` VALUES (61639, '65.51.15646396712638175', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 14:07:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 14:07:51');
INSERT INTO `access_log` VALUES (61640, '65.50.15646396756538103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 14:07:56', 60, 0, '', '2019-08-01 14:07:56');
INSERT INTO `access_log` VALUES (61641, '65.47.15646396759238083', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 14:07:56', 11, 0, '', '2019-08-01 14:07:56');
INSERT INTO `access_log` VALUES (61642, '65.54.15646396759318017', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 14:07:56', 17, 0, '', '2019-08-01 14:07:56');
INSERT INTO `access_log` VALUES (61643, '65.52.15646396759348153', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.152.68.46', '2019-08-01 14:07:56', 17, 0, '', '2019-08-01 14:07:56');
INSERT INTO `access_log` VALUES (61644, '65.50.15646423199718139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.57', '2019-08-01 14:52:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 14:52:00');
INSERT INTO `access_log` VALUES (61645, '65.52.15646423234768189', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.57', '2019-08-01 14:52:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 14:52:03');
INSERT INTO `access_log` VALUES (61646, '65.47.15646423257048119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai12312312&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.57', '2019-08-01 14:52:06', 105, 0, '', '2019-08-01 14:52:06');
INSERT INTO `access_log` VALUES (61647, '65.49.15646423260908121', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.57', '2019-08-01 14:52:06', 16, 0, '', '2019-08-01 14:52:06');
INSERT INTO `access_log` VALUES (61648, '65.54.15646423260868053', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.57', '2019-08-01 14:52:06', 21, 0, '', '2019-08-01 14:52:06');
INSERT INTO `access_log` VALUES (61649, '65.53.15646423260938139', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.57', '2019-08-01 14:52:06', 24, 0, '', '2019-08-01 14:52:06');
INSERT INTO `access_log` VALUES (61650, '62.81.15646423430694541', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.57', '2019-08-01 14:52:23', 31, 0, '', '2019-08-01 14:52:23');
INSERT INTO `access_log` VALUES (61651, '62.84.15646423601274561', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.57', '2019-08-01 14:52:40', 16, 0, '', '2019-08-01 14:52:40');
INSERT INTO `access_log` VALUES (61652, '64.83.15646423650245903', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.57', '2019-08-01 14:52:45', 108, 0, '', '2019-08-01 14:52:45');
INSERT INTO `access_log` VALUES (61653, '64.77.15646423650275901', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.57', '2019-08-01 14:52:45', 112, 0, '', '2019-08-01 14:52:45');
INSERT INTO `access_log` VALUES (61654, '65.50.15646423808018141', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.57', '2019-08-01 14:53:01', 24, 0, '', '2019-08-01 14:53:01');
INSERT INTO `access_log` VALUES (61655, '65.52.15646423880568191', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.57', '2019-08-01 14:53:08', 9, 0, '', '2019-08-01 14:53:08');
INSERT INTO `access_log` VALUES (61656, '65.54.15646423904358055', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.57', '2019-08-01 14:53:10', 14, 0, '', '2019-08-01 14:53:10');
INSERT INTO `access_log` VALUES (61657, '62.86.15646424067364561', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.19.94.57', '2019-08-01 14:53:27', 9, 0, '', '2019-08-01 14:53:27');
INSERT INTO `access_log` VALUES (61658, '59.75.15646437933805645', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.245.229', '2019-08-01 15:16:33', 10, 0, '', '2019-08-01 15:16:33');
INSERT INTO `access_log` VALUES (61659, '59.72.15646437933815631', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.245.229', '2019-08-01 15:16:33', 20, 2001001000, '服务端发生异常', '2019-08-01 15:16:33');
INSERT INTO `access_log` VALUES (61660, '64.81.15646437987705927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.245.229', '2019-08-01 15:16:39', 2, 0, '', '2019-08-01 15:16:39');
INSERT INTO `access_log` VALUES (61661, '64.85.15646437988595961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.245.229', '2019-08-01 15:16:39', 1, 0, '', '2019-08-01 15:16:39');
INSERT INTO `access_log` VALUES (61662, '64.83.15646438005035923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.245.229', '2019-08-01 15:16:41', 2, 0, '', '2019-08-01 15:16:41');
INSERT INTO `access_log` VALUES (61663, '64.77.15646438012565921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.245.229', '2019-08-01 15:16:41', 1, 0, '', '2019-08-01 15:16:41');
INSERT INTO `access_log` VALUES (61664, '64.78.15646438018715931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.245.229', '2019-08-01 15:16:42', 2, 0, '', '2019-08-01 15:16:42');
INSERT INTO `access_log` VALUES (61665, '59.73.15646438037255635', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.245.229', '2019-08-01 15:16:44', 2, 0, '', '2019-08-01 15:16:44');
INSERT INTO `access_log` VALUES (61666, '59.77.15646438037265625', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.245.229', '2019-08-01 15:16:44', 17, 2001001000, '服务端发生异常', '2019-08-01 15:16:44');
INSERT INTO `access_log` VALUES (61667, '64.84.15646438103485925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.245.229', '2019-08-01 15:16:50', 2, 0, '', '2019-08-01 15:16:50');
INSERT INTO `access_log` VALUES (61668, '64.80.15646438104565935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.245.229', '2019-08-01 15:16:50', 2, 0, '', '2019-08-01 15:16:50');
INSERT INTO `access_log` VALUES (61669, '64.79.15646438117915925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.245.229', '2019-08-01 15:16:52', 2, 0, '', '2019-08-01 15:16:52');
INSERT INTO `access_log` VALUES (61670, '64.82.15646438125515945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.245.229', '2019-08-01 15:16:53', 2, 0, '', '2019-08-01 15:16:53');
INSERT INTO `access_log` VALUES (61671, '64.81.15646438130705929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.245.229', '2019-08-01 15:16:53', 2, 0, '', '2019-08-01 15:16:53');
INSERT INTO `access_log` VALUES (61672, '65.50.15646438402138161', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-08-01 15:17:20', 0, 1002001015, '账号未登陆', '2019-08-01 15:17:20');
INSERT INTO `access_log` VALUES (61673, '65.47.15646438402148141', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-08-01 15:17:20', 0, 1002001015, '账号未登陆', '2019-08-01 15:17:20');
INSERT INTO `access_log` VALUES (61674, '65.52.15646438402138211', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-08-01 15:17:20', 0, 1002001015, '账号未登陆', '2019-08-01 15:17:20');
INSERT INTO `access_log` VALUES (61675, '65.53.15646438460278161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-08-01 15:17:26', 76, 0, '', '2019-08-01 15:17:26');
INSERT INTO `access_log` VALUES (61676, '65.49.15646438463198143', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-08-01 15:17:26', 12, 0, '', '2019-08-01 15:17:26');
INSERT INTO `access_log` VALUES (61677, '65.3607.15646438463219957', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-08-01 15:17:26', 12, 2001001000, '服务端发生异常', '2019-08-01 15:17:26');
INSERT INTO `access_log` VALUES (61678, '65.45.15646438463258163', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-08-01 15:17:26', 9, 0, '', '2019-08-01 15:17:26');
INSERT INTO `access_log` VALUES (61679, '65.50.15646438893048163', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.63.224.117', '2019-08-01 15:18:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 15:18:09');
INSERT INTO `access_log` VALUES (61680, '65.45.15646450761568181', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.3', '2019-08-01 15:37:56', 10, 1002001012, '访问令牌已过期', '2019-08-01 15:37:56');
INSERT INTO `access_log` VALUES (61681, '65.52.15646450761568229', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.3', '2019-08-01 15:37:56', 9, 1002001012, '访问令牌已过期', '2019-08-01 15:37:56');
INSERT INTO `access_log` VALUES (61682, '65.3607.15646450761679975', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.3', '2019-08-01 15:37:56', 3, 1002001012, '访问令牌已过期', '2019-08-01 15:37:56');
INSERT INTO `access_log` VALUES (61683, '65.3607.15646452037559977', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.231.133.232', '2019-08-01 15:40:04', 1, 1002001015, '账号未登陆', '2019-08-01 15:40:04');
INSERT INTO `access_log` VALUES (61684, '65.45.15646452037548183', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.231.133.232', '2019-08-01 15:40:04', 0, 1002001015, '账号未登陆', '2019-08-01 15:40:04');
INSERT INTO `access_log` VALUES (61685, '65.47.15646452037688163', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.231.133.232', '2019-08-01 15:40:04', 1, 1002001015, '账号未登陆', '2019-08-01 15:40:04');
INSERT INTO `access_log` VALUES (61686, '65.49.15646452058298163', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.231.133.232', '2019-08-01 15:40:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 15:40:06');
INSERT INTO `access_log` VALUES (61687, '65.46.15646452121148237', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.231.133.232', '2019-08-01 15:40:12', 94, 0, '', '2019-08-01 15:40:12');
INSERT INTO `access_log` VALUES (61688, '65.53.15646452125578183', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.231.133.232', '2019-08-01 15:40:13', 10, 0, '', '2019-08-01 15:40:13');
INSERT INTO `access_log` VALUES (61689, '65.54.15646452125868097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.231.133.232', '2019-08-01 15:40:13', 10, 0, '', '2019-08-01 15:40:13');
INSERT INTO `access_log` VALUES (61690, '65.50.15646452135398183', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.231.133.232', '2019-08-01 15:40:14', 9, 2001001000, '服务端发生异常', '2019-08-01 15:40:14');
INSERT INTO `access_log` VALUES (61691, '59.75.15646452280985665', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:40:28', 6, 0, '', '2019-08-01 15:40:28');
INSERT INTO `access_log` VALUES (61692, '59.72.15646452280985651', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:40:28', 31, 2001001000, '服务端发生异常', '2019-08-01 15:40:28');
INSERT INTO `access_log` VALUES (61693, '64.84.15646452324985945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:40:32', 3, 0, '', '2019-08-01 15:40:33');
INSERT INTO `access_log` VALUES (61694, '64.76.15646452326945949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:40:33', 2, 0, '', '2019-08-01 15:40:33');
INSERT INTO `access_log` VALUES (61695, '64.80.15646452340395955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:40:34', 2, 0, '', '2019-08-01 15:40:34');
INSERT INTO `access_log` VALUES (61696, '64.79.15646452346925945', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:40:35', 1, 0, '', '2019-08-01 15:40:35');
INSERT INTO `access_log` VALUES (61697, '64.82.15646452353085965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:40:35', 2, 0, '', '2019-08-01 15:40:35');
INSERT INTO `access_log` VALUES (61698, '59.77.15646452364015645', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:40:36', 2, 0, '', '2019-08-01 15:40:36');
INSERT INTO `access_log` VALUES (61699, '59.73.15646452364015655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:40:36', 14, 2001001000, '服务端发生异常', '2019-08-01 15:40:36');
INSERT INTO `access_log` VALUES (61700, '66.48.15646452511143393', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=123123123&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:40:51', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-08-01 15:40:51');
INSERT INTO `access_log` VALUES (61701, '66.55.15646452596343365', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17136373243&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:00', 19, 1001003000, '验证码不存在', '2019-08-01 15:41:00');
INSERT INTO `access_log` VALUES (61702, '66.53.15646452656183379', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17136373243&code=999966', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:06', 7, 1001003000, '验证码不存在', '2019-08-01 15:41:06');
INSERT INTO `access_log` VALUES (61703, '66.56.15646452706583397', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17136373243&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:11', 7, 1001003000, '验证码不存在', '2019-08-01 15:41:11');
INSERT INTO `access_log` VALUES (61704, '66.50.15646452723573381', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17136373243', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:12', 501, 0, '', '2019-08-01 15:41:13');
INSERT INTO `access_log` VALUES (61705, '66.49.15646452749693383', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17136373243&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:15', 224, 0, '', '2019-08-01 15:41:15');
INSERT INTO `access_log` VALUES (61706, '59.72.15646452842945653', 187, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:24', 5, 0, '', '2019-08-01 15:41:24');
INSERT INTO `access_log` VALUES (61707, '59.75.15646452842905667', 187, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:24', 25, 2001001000, '服务端发生异常', '2019-08-01 15:41:24');
INSERT INTO `access_log` VALUES (61708, '64.84.15646452863515947', 187, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:26', 6, 0, '', '2019-08-01 15:41:26');
INSERT INTO `access_log` VALUES (61709, '64.80.15646452868975957', 187, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:27', 8, 0, '', '2019-08-01 15:41:27');
INSERT INTO `access_log` VALUES (61710, '66.52.15646452882443375', 187, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:28', 7, 0, '', '2019-08-01 15:41:28');
INSERT INTO `access_log` VALUES (61711, '66.48.15646452941173395', 187, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:34', 5, 0, '', '2019-08-01 15:41:34');
INSERT INTO `access_log` VALUES (61712, '66.51.15646452963593407', 187, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:36', 5, 0, '', '2019-08-01 15:41:36');
INSERT INTO `access_log` VALUES (61713, '59.73.15646452973605657', 187, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:37', 8, 0, '', '2019-08-01 15:41:37');
INSERT INTO `access_log` VALUES (61714, '66.53.15646452983983381', 187, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:38', 5, 0, '', '2019-08-01 15:41:38');
INSERT INTO `access_log` VALUES (61715, '66.56.15646453100173399', 187, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:50', 6, 0, '', '2019-08-01 15:41:50');
INSERT INTO `access_log` VALUES (61716, '66.54.15646453116253391', 187, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:41:52', 25, 0, '', '2019-08-01 15:41:52');
INSERT INTO `access_log` VALUES (61717, '66.57.15646453253253391', 187, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:42:05', 4, 0, '', '2019-08-01 15:42:05');
INSERT INTO `access_log` VALUES (61718, '66.48.15646453257173397', 187, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '110.184.153.111', '2019-08-01 15:42:06', 11, 0, '', '2019-08-01 15:42:06');
INSERT INTO `access_log` VALUES (61719, '59.80.15646453526185631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.202.147.132', '2019-08-01 15:42:33', 3, 0, '', '2019-08-01 15:42:33');
INSERT INTO `access_log` VALUES (61720, '59.79.15646453526185665', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.202.147.132', '2019-08-01 15:42:33', 18, 2001001000, '服务端发生异常', '2019-08-01 15:42:33');
INSERT INTO `access_log` VALUES (61721, '59.72.15646453581885655', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '1.202.147.132', '2019-08-01 15:42:38', 3, 0, '', '2019-08-01 15:42:38');
INSERT INTO `access_log` VALUES (61722, '59.76.15646453581895649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '1.202.147.132', '2019-08-01 15:42:38', 12, 2001001000, '服务端发生异常', '2019-08-01 15:42:38');
INSERT INTO `access_log` VALUES (61723, '65.45.15646453953898187', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.202.147.132', '2019-08-01 15:43:15', 1, 1002001015, '账号未登陆', '2019-08-01 15:43:15');
INSERT INTO `access_log` VALUES (61724, '65.47.15646453953908167', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.202.147.132', '2019-08-01 15:43:15', 0, 1002001015, '账号未登陆', '2019-08-01 15:43:15');
INSERT INTO `access_log` VALUES (61725, '65.49.15646453953958167', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.202.147.132', '2019-08-01 15:43:15', 0, 1002001015, '账号未登陆', '2019-08-01 15:43:15');
INSERT INTO `access_log` VALUES (61726, '65.51.15646454007618259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.202.147.132', '2019-08-01 15:43:21', 280, 0, '', '2019-08-01 15:43:21');
INSERT INTO `access_log` VALUES (61727, '65.46.15646454012638241', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.202.147.132', '2019-08-01 15:43:21', 10, 0, '', '2019-08-01 15:43:21');
INSERT INTO `access_log` VALUES (61728, '65.54.15646454012668101', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.202.147.132', '2019-08-01 15:43:21', 8, 0, '', '2019-08-01 15:43:21');
INSERT INTO `access_log` VALUES (61729, '65.53.15646454012658187', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.202.147.132', '2019-08-01 15:43:21', 10, 2001001000, '服务端发生异常', '2019-08-01 15:43:21');
INSERT INTO `access_log` VALUES (61730, '65.3607.15646454249939983', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.202.147.132', '2019-08-01 15:43:45', 9, 0, '', '2019-08-01 15:43:45');
INSERT INTO `access_log` VALUES (61731, '65.45.15646454249958189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.202.147.132', '2019-08-01 15:43:45', 10, 2001001000, '服务端发生异常', '2019-08-01 15:43:45');
INSERT INTO `access_log` VALUES (61732, '65.47.15646454250008169', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.202.147.132', '2019-08-01 15:43:45', 9, 0, '', '2019-08-01 15:43:45');
INSERT INTO `access_log` VALUES (61733, '65.3607.15646460163579991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.3', '2019-08-01 15:53:36', 71, 0, '', '2019-08-01 15:53:36');
INSERT INTO `access_log` VALUES (61734, '65.49.15646460167828177', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.3', '2019-08-01 15:53:37', 117, 0, '', '2019-08-01 15:53:37');
INSERT INTO `access_log` VALUES (61735, '65.53.15646460167948197', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.3', '2019-08-01 15:53:37', 109, 0, '', '2019-08-01 15:53:37');
INSERT INTO `access_log` VALUES (61736, '65.51.15646460167948269', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.3', '2019-08-01 15:53:37', 109, 2001001000, '服务端发生异常', '2019-08-01 15:53:37');
INSERT INTO `access_log` VALUES (61737, '65.46.15646460241538251', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.3', '2019-08-01 15:53:44', 8, 0, '', '2019-08-01 15:53:44');
INSERT INTO `access_log` VALUES (61738, '65.50.15646460241558197', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.3', '2019-08-01 15:53:44', 10, 2001001000, '服务端发生异常', '2019-08-01 15:53:44');
INSERT INTO `access_log` VALUES (61739, '65.52.15646460241578247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.3', '2019-08-01 15:53:44', 8, 0, '', '2019-08-01 15:53:44');
INSERT INTO `access_log` VALUES (61740, '59.72.15646468264015675', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-01 16:07:06', 3, 0, '', '2019-08-01 16:07:06');
INSERT INTO `access_log` VALUES (61741, '59.76.15646468264015669', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-01 16:07:06', 13, 2001001000, '服务端发生异常', '2019-08-01 16:07:06');
INSERT INTO `access_log` VALUES (61742, '65.49.15646468343818189', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-01 16:07:14', 0, 1002001015, '账号未登陆', '2019-08-01 16:07:14');
INSERT INTO `access_log` VALUES (61743, '65.51.15646468343838281', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-01 16:07:14', 0, 1002001015, '账号未登陆', '2019-08-01 16:07:14');
INSERT INTO `access_log` VALUES (61744, '65.54.15646468343848123', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-01 16:07:14', 0, 1002001015, '账号未登陆', '2019-08-01 16:07:14');
INSERT INTO `access_log` VALUES (61745, '65.52.15646468364678259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-01 16:07:16', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 16:07:16');
INSERT INTO `access_log` VALUES (61746, '65.46.15646468387388263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-01 16:07:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 16:07:19');
INSERT INTO `access_log` VALUES (61747, '65.45.15646468470178211', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-01 16:07:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 16:07:27');
INSERT INTO `access_log` VALUES (61748, 'a4d55e18-7644-4df8-8ab9-e04184b0cfdb', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'deptmentId=1&nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '0:0:0:0:0:0:0:1', '2019-08-01 16:33:33', 20, 1002001015, '账号未登陆', '2019-08-01 16:33:33');
INSERT INTO `access_log` VALUES (61749, '65.51.15646495365268319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.200.96', '2019-08-01 16:52:17', 106, 0, '', '2019-08-01 16:52:17');
INSERT INTO `access_log` VALUES (61750, '65.50.15646495375248245', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.200.96', '2019-08-01 16:52:18', 14, 0, '', '2019-08-01 16:52:18');
INSERT INTO `access_log` VALUES (61751, '65.49.15646495375248227', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.200.96', '2019-08-01 16:52:18', 18, 2001001000, '服务端发生异常', '2019-08-01 16:52:18');
INSERT INTO `access_log` VALUES (61752, '65.52.15646495375588297', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.200.96', '2019-08-01 16:52:18', 17, 0, '', '2019-08-01 16:52:18');
INSERT INTO `access_log` VALUES (61753, '65.3607.15646517019260071', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3860.5 Safari/537.36', '113.200.213.41', '2019-08-01 17:28:22', 0, 1002001015, '账号未登陆', '2019-08-01 17:28:22');
INSERT INTO `access_log` VALUES (61754, '65.53.15646517019288275', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3860.5 Safari/537.36', '113.200.213.41', '2019-08-01 17:28:22', 1, 1002001015, '账号未登陆', '2019-08-01 17:28:22');
INSERT INTO `access_log` VALUES (61755, '65.51.15646517019538349', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3860.5 Safari/537.36', '113.200.213.41', '2019-08-01 17:28:22', 0, 1002001015, '账号未登陆', '2019-08-01 17:28:22');
INSERT INTO `access_log` VALUES (61756, '65.49.15646517068698257', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3860.5 Safari/537.36', '113.200.213.41', '2019-08-01 17:28:27', 143, 0, '', '2019-08-01 17:28:27');
INSERT INTO `access_log` VALUES (61757, '65.54.15646517075158191', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3860.5 Safari/537.36', '113.200.213.41', '2019-08-01 17:28:28', 15, 0, '', '2019-08-01 17:28:28');
INSERT INTO `access_log` VALUES (61758, '65.46.15646517075158331', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3860.5 Safari/537.36', '113.200.213.41', '2019-08-01 17:28:28', 16, 0, '', '2019-08-01 17:28:28');
INSERT INTO `access_log` VALUES (61759, '65.52.15646517075158327', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3860.5 Safari/537.36', '113.200.213.41', '2019-08-01 17:28:28', 18, 2001001000, '服务端发生异常', '2019-08-01 17:28:28');
INSERT INTO `access_log` VALUES (61760, '65.47.15646517193358259', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3860.5 Safari/537.36', '113.200.213.41', '2019-08-01 17:28:39', 9, 0, '', '2019-08-01 17:28:39');
INSERT INTO `access_log` VALUES (61761, '65.51.15646517193388351', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3860.5 Safari/537.36', '113.200.213.41', '2019-08-01 17:28:39', 10, 2001001000, '服务端发生异常', '2019-08-01 17:28:39');
INSERT INTO `access_log` VALUES (61762, '65.3607.15646517193420073', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3860.5 Safari/537.36', '113.200.213.41', '2019-08-01 17:28:39', 9, 0, '', '2019-08-01 17:28:39');
INSERT INTO `access_log` VALUES (61763, '59.76.15646529686735751', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.89.210', '2019-08-01 17:49:29', 10, 0, '', '2019-08-01 17:49:29');
INSERT INTO `access_log` VALUES (61764, '59.77.15646529686735751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.89.210', '2019-08-01 17:49:29', 15, 2001001000, '服务端发生异常', '2019-08-01 17:49:29');
INSERT INTO `access_log` VALUES (61765, '64.81.15646529712946053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.89.210', '2019-08-01 17:49:31', 14, 0, '', '2019-08-01 17:49:31');
INSERT INTO `access_log` VALUES (61766, '64.85.15646529713936087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.89.210', '2019-08-01 17:49:31', 4, 0, '', '2019-08-01 17:49:31');
INSERT INTO `access_log` VALUES (61767, '64.83.15646529724386049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.89.210', '2019-08-01 17:49:32', 2, 0, '', '2019-08-01 17:49:32');
INSERT INTO `access_log` VALUES (61768, '64.77.15646529730866047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.89.210', '2019-08-01 17:49:33', 2, 0, '', '2019-08-01 17:49:33');
INSERT INTO `access_log` VALUES (61769, '65.54.15646530086838209', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.102.122', '2019-08-01 17:50:09', 1, 1002001015, '账号未登陆', '2019-08-01 17:50:09');
INSERT INTO `access_log` VALUES (61770, '65.45.15646530086838297', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.102.122', '2019-08-01 17:50:09', 0, 1002001015, '账号未登陆', '2019-08-01 17:50:09');
INSERT INTO `access_log` VALUES (61771, '65.47.15646530086858277', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.102.122', '2019-08-01 17:50:09', 0, 1002001015, '账号未登陆', '2019-08-01 17:50:09');
INSERT INTO `access_log` VALUES (61772, '65.3607.15646530106820091', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.102.122', '2019-08-01 17:50:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 17:50:11');
INSERT INTO `access_log` VALUES (61773, '65.53.15646530174398295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.102.122', '2019-08-01 17:50:17', 81, 0, '', '2019-08-01 17:50:18');
INSERT INTO `access_log` VALUES (61774, '65.50.15646530177758295', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.102.122', '2019-08-01 17:50:18', 18, 0, '', '2019-08-01 17:50:18');
INSERT INTO `access_log` VALUES (61775, '65.49.15646530177808277', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.102.122', '2019-08-01 17:50:18', 19, 2001001000, '服务端发生异常', '2019-08-01 17:50:18');
INSERT INTO `access_log` VALUES (61776, '65.52.15646530177838347', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '121.35.102.122', '2019-08-01 17:50:18', 17, 0, '', '2019-08-01 17:50:18');
INSERT INTO `access_log` VALUES (61777, '59.74.15646546652605797', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.230.158', '2019-08-01 18:17:45', 4, 0, '', '2019-08-01 18:17:45');
INSERT INTO `access_log` VALUES (61778, '59.80.15646546652615757', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.230.239', '2019-08-01 18:17:45', 13, 2001001000, '服务端发生异常', '2019-08-01 18:17:45');
INSERT INTO `access_log` VALUES (61779, '64.82.15646546861766093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.230.239', '2019-08-01 18:18:06', 3, 0, '', '2019-08-01 18:18:06');
INSERT INTO `access_log` VALUES (61780, '64.81.15646546862866077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.230.239', '2019-08-01 18:18:06', 2, 0, '', '2019-08-01 18:18:06');
INSERT INTO `access_log` VALUES (61781, '64.85.15646546877726111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.230.239', '2019-08-01 18:18:08', 2, 0, '', '2019-08-01 18:18:08');
INSERT INTO `access_log` VALUES (61782, '64.83.15646546885396073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.230.239', '2019-08-01 18:18:09', 3, 0, '', '2019-08-01 18:18:09');
INSERT INTO `access_log` VALUES (61783, '64.77.15646546950016071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.230.239', '2019-08-01 18:18:15', 2, 0, '', '2019-08-01 18:18:15');
INSERT INTO `access_log` VALUES (61784, '64.78.15646546951286081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.230.239', '2019-08-01 18:18:15', 2, 0, '', '2019-08-01 18:18:15');
INSERT INTO `access_log` VALUES (61785, '59.72.15646546962645781', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.230.239', '2019-08-01 18:18:16', 2, 0, '', '2019-08-01 18:18:16');
INSERT INTO `access_log` VALUES (61786, '59.77.15646546962645775', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.230.158', '2019-08-01 18:18:16', 39, 2001001000, '服务端发生异常', '2019-08-01 18:18:16');
INSERT INTO `access_log` VALUES (61787, '64.84.15646546985486075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.230.239', '2019-08-01 18:18:19', 2, 0, '', '2019-08-01 18:18:19');
INSERT INTO `access_log` VALUES (61788, '64.76.15646546986836079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.230.239', '2019-08-01 18:18:19', 2, 0, '', '2019-08-01 18:18:19');
INSERT INTO `access_log` VALUES (61789, '65.47.15646554185948311', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.253.2', '2019-08-01 18:30:19', 0, 1002001015, '账号未登陆', '2019-08-01 18:30:19');
INSERT INTO `access_log` VALUES (61790, '65.46.15646554185948383', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.253.2', '2019-08-01 18:30:19', 0, 1002001015, '账号未登陆', '2019-08-01 18:30:19');
INSERT INTO `access_log` VALUES (61791, '65.45.15646554186018331', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.253.2', '2019-08-01 18:30:19', 0, 1002001015, '账号未登陆', '2019-08-01 18:30:19');
INSERT INTO `access_log` VALUES (61792, '65.54.15646554222658243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.253.2', '2019-08-01 18:30:22', 167, 0, '', '2019-08-01 18:30:22');
INSERT INTO `access_log` VALUES (61793, '65.51.15646554226858403', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.253.2', '2019-08-01 18:30:23', 10, 0, '', '2019-08-01 18:30:23');
INSERT INTO `access_log` VALUES (61794, '65.3607.15646554226890125', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.253.2', '2019-08-01 18:30:23', 9, 2001001000, '服务端发生异常', '2019-08-01 18:30:23');
INSERT INTO `access_log` VALUES (61795, '65.53.15646554226908329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.253.2', '2019-08-01 18:30:23', 9, 0, '', '2019-08-01 18:30:23');
INSERT INTO `access_log` VALUES (61796, '65.50.15646554286998329', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.253.2', '2019-08-01 18:30:29', 17, 0, '', '2019-08-01 18:30:29');
INSERT INTO `access_log` VALUES (61797, '65.52.15646554287028381', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.253.2', '2019-08-01 18:30:29', 17, 2001001000, '服务端发生异常', '2019-08-01 18:30:29');
INSERT INTO `access_log` VALUES (61798, '65.46.15646554287068385', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.253.2', '2019-08-01 18:30:29', 9, 0, '', '2019-08-01 18:30:29');
INSERT INTO `access_log` VALUES (61799, '65.45.15646554300468333', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.253.2', '2019-08-01 18:30:30', 9, 0, '', '2019-08-01 18:30:30');
INSERT INTO `access_log` VALUES (61800, '65.47.15646554300488313', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.253.2', '2019-08-01 18:30:30', 10, 2001001000, '服务端发生异常', '2019-08-01 18:30:30');
INSERT INTO `access_log` VALUES (61801, '65.54.15646554300508245', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.253.2', '2019-08-01 18:30:30', 8, 0, '', '2019-08-01 18:30:30');
INSERT INTO `access_log` VALUES (61802, '59.72.15646599083565851', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.231.156', '2019-08-01 19:45:08', 18, 0, '', '2019-08-01 19:45:08');
INSERT INTO `access_log` VALUES (61803, '59.77.15646599083575845', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.230.239', '2019-08-01 19:45:08', 33, 2001001000, '服务端发生异常', '2019-08-01 19:45:08');
INSERT INTO `access_log` VALUES (61804, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=Java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.231.156', '2019-08-01 19:45:27', 14, 0, '', '2019-08-01 19:45:27');
INSERT INTO `access_log` VALUES (61805, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=Java', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.85.231.156', '2019-08-01 19:45:27', 54, 0, '', '2019-08-01 19:45:27');
INSERT INTO `access_log` VALUES (61806, '59.74.15646632657225913', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.243.215.212', '2019-08-01 20:41:06', 10, 0, '', '2019-08-01 20:41:06');
INSERT INTO `access_log` VALUES (61807, '59.80.15646632657235873', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.243.215.212', '2019-08-01 20:41:06', 27, 2001001000, '服务端发生异常', '2019-08-01 20:41:06');
INSERT INTO `access_log` VALUES (61808, '59.77.15646681037405955', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:01:44', 8, 0, '', '2019-08-01 22:01:44');
INSERT INTO `access_log` VALUES (61809, '59.72.15646681037405961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:01:44', 14, 2001001000, '服务端发生异常', '2019-08-01 22:01:44');
INSERT INTO `access_log` VALUES (61810, '64.83.15646681107656253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:01:51', 9, 0, '', '2019-08-01 22:01:51');
INSERT INTO `access_log` VALUES (61811, '64.77.15646681110066251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:01:51', 3, 0, '', '2019-08-01 22:01:51');
INSERT INTO `access_log` VALUES (61812, '59.71.15646681363035961', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.180.101', '2019-08-01 22:02:16', 3, 0, '', '2019-08-01 22:02:16');
INSERT INTO `access_log` VALUES (61813, '59.78.15646681363035973', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.180.101', '2019-08-01 22:02:16', 14, 2001001000, '服务端发生异常', '2019-08-01 22:02:16');
INSERT INTO `access_log` VALUES (61814, '59.80.15646681390645939', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:02:19', 3, 0, '', '2019-08-01 22:02:19');
INSERT INTO `access_log` VALUES (61815, '59.79.15646681391755973', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:02:19', 16, 2001001000, '服务端发生异常', '2019-08-01 22:02:19');
INSERT INTO `access_log` VALUES (61816, '64.76.15646681439136259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:02:24', 2, 0, '', '2019-08-01 22:02:24');
INSERT INTO `access_log` VALUES (61817, '64.80.15646681441366265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:02:24', 2, 0, '', '2019-08-01 22:02:24');
INSERT INTO `access_log` VALUES (61818, '64.79.15646681490596255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:02:29', 2, 0, '', '2019-08-01 22:02:29');
INSERT INTO `access_log` VALUES (61819, '64.82.15646681491606275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:02:29', 2, 0, '', '2019-08-01 22:02:29');
INSERT INTO `access_log` VALUES (61820, '59.75.15646681508635977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.180.101', '2019-08-01 22:02:31', 3, 0, '', '2019-08-01 22:02:31');
INSERT INTO `access_log` VALUES (61821, '59.77.15646681508785957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.180.101', '2019-08-01 22:02:31', 17, 2001001000, '服务端发生异常', '2019-08-01 22:02:31');
INSERT INTO `access_log` VALUES (61822, '59.72.15646681513675963', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:02:31', 2, 0, '', '2019-08-01 22:02:31');
INSERT INTO `access_log` VALUES (61823, '59.76.15646681514055957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:02:31', 15, 2001001000, '服务端发生异常', '2019-08-01 22:02:31');
INSERT INTO `access_log` VALUES (61824, '64.85.15646681584266293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.180.101', '2019-08-01 22:02:38', 1, 0, '', '2019-08-01 22:02:38');
INSERT INTO `access_log` VALUES (61825, '64.83.15646681585916255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.140.180.101', '2019-08-01 22:02:39', 2, 0, '', '2019-08-01 22:02:39');
INSERT INTO `access_log` VALUES (61826, '64.77.15646681598236253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:02:40', 2, 0, '', '2019-08-01 22:02:40');
INSERT INTO `access_log` VALUES (61827, '64.78.15646681599516263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:02:40', 2, 0, '', '2019-08-01 22:02:40');
INSERT INTO `access_log` VALUES (61828, '59.78.15646681607845975', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:02:41', 2, 0, '', '2019-08-01 22:02:41');
INSERT INTO `access_log` VALUES (61829, '59.71.15646681607855963', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:02:41', 30, 2001001000, '服务端发生异常', '2019-08-01 22:02:41');
INSERT INTO `access_log` VALUES (61830, '65.3607.15646681861180297', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:06', 1, 1002001015, '账号未登陆', '2019-08-01 22:03:06');
INSERT INTO `access_log` VALUES (61831, '65.53.15646681861198501', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:06', 1, 1002001015, '账号未登陆', '2019-08-01 22:03:06');
INSERT INTO `access_log` VALUES (61832, '65.51.15646681861348575', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:06', 0, 1002001015, '账号未登陆', '2019-08-01 22:03:06');
INSERT INTO `access_log` VALUES (61833, '65.52.15646681897508553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:10', 82, 0, '', '2019-08-01 22:03:10');
INSERT INTO `access_log` VALUES (61834, '65.50.15646681901518501', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:10', 9, 0, '', '2019-08-01 22:03:10');
INSERT INTO `access_log` VALUES (61835, '65.46.15646681901638557', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:10', 8, 2001001000, '服务端发生异常', '2019-08-01 22:03:10');
INSERT INTO `access_log` VALUES (61836, '65.54.15646681901828417', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:10', 8, 0, '', '2019-08-01 22:03:10');
INSERT INTO `access_log` VALUES (61837, '65.47.15646681957658485', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:16', 9, 0, '', '2019-08-01 22:03:16');
INSERT INTO `access_log` VALUES (61838, '65.3607.15646681957670299', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:16', 8, 0, '', '2019-08-01 22:03:16');
INSERT INTO `access_log` VALUES (61839, '65.45.15646681957648505', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:16', 14, 2001001000, '服务端发生异常', '2019-08-01 22:03:16');
INSERT INTO `access_log` VALUES (61840, '65.51.15646681968218577', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:17', 7, 0, '', '2019-08-01 22:03:17');
INSERT INTO `access_log` VALUES (61841, '65.49.15646681968308485', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:17', 9, 0, '', '2019-08-01 22:03:17');
INSERT INTO `access_log` VALUES (61842, '65.53.15646681968208503', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:17', 18, 2001001000, '服务端发生异常', '2019-08-01 22:03:17');
INSERT INTO `access_log` VALUES (61843, '65.52.15646682038908555', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:24', 9, 0, '', '2019-08-01 22:03:24');
INSERT INTO `access_log` VALUES (61844, '65.46.15646682039038559', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:24', 9, 2001001000, '服务端发生异常', '2019-08-01 22:03:24');
INSERT INTO `access_log` VALUES (61845, '65.50.15646682039058503', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:03:24', 9, 0, '', '2019-08-01 22:03:24');
INSERT INTO `access_log` VALUES (61846, '59.73.15646684203615971', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:07:00', 3, 0, '', '2019-08-01 22:07:00');
INSERT INTO `access_log` VALUES (61847, '59.78.15646684203635979', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:07:00', 14, 2001001000, '服务端发生异常', '2019-08-01 22:07:00');
INSERT INTO `access_log` VALUES (61848, '59.76.15646688260635967', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:13:46', 3, 0, '', '2019-08-01 22:13:46');
INSERT INTO `access_log` VALUES (61849, '59.78.15646688261855985', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.254.69.121', '2019-08-01 22:13:46', 16, 2001001000, '服务端发生异常', '2019-08-01 22:13:46');
INSERT INTO `access_log` VALUES (61850, '59.79.15646688833275985', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:14:43', 3, 0, '', '2019-08-01 22:14:43');
INSERT INTO `access_log` VALUES (61851, '59.75.15646688833275989', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:14:43', 13, 2001001000, '服务端发生异常', '2019-08-01 22:14:43');
INSERT INTO `access_log` VALUES (61852, '64.77.15646688885206263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:14:49', 2, 0, '', '2019-08-01 22:14:49');
INSERT INTO `access_log` VALUES (61853, '64.78.15646688886896273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:14:49', 1, 0, '', '2019-08-01 22:14:49');
INSERT INTO `access_log` VALUES (61854, '64.76.15646689007436271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:01', 2, 0, '', '2019-08-01 22:15:01');
INSERT INTO `access_log` VALUES (61855, '64.80.15646689008946277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:01', 2, 0, '', '2019-08-01 22:15:01');
INSERT INTO `access_log` VALUES (61856, '59.78.15646689122785987', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:12', 2, 0, '', '2019-08-01 22:15:12');
INSERT INTO `access_log` VALUES (61857, '59.76.15646689122785969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:12', 12, 2001001000, '服务端发生异常', '2019-08-01 22:15:12');
INSERT INTO `access_log` VALUES (61858, '64.81.15646689253206271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:25', 2, 0, '', '2019-08-01 22:15:25');
INSERT INTO `access_log` VALUES (61859, '64.85.15646689254576305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:25', 2, 0, '', '2019-08-01 22:15:25');
INSERT INTO `access_log` VALUES (61860, '64.83.15646689270596267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:27', 1, 0, '', '2019-08-01 22:15:27');
INSERT INTO `access_log` VALUES (61861, '64.77.15646689278696265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:28', 2, 0, '', '2019-08-01 22:15:28');
INSERT INTO `access_log` VALUES (61862, '64.78.15646689296646275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:30', 2, 0, '', '2019-08-01 22:15:30');
INSERT INTO `access_log` VALUES (61863, '59.71.15646689310655975', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:31', 2, 0, '', '2019-08-01 22:15:31');
INSERT INTO `access_log` VALUES (61864, '59.74.15646689310655993', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:31', 20, 2001001000, '服务端发生异常', '2019-08-01 22:15:31');
INSERT INTO `access_log` VALUES (61865, '64.84.15646689327936269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:33', 2, 0, '', '2019-08-01 22:15:33');
INSERT INTO `access_log` VALUES (61866, '64.76.15646689330986273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:33', 2, 0, '', '2019-08-01 22:15:33');
INSERT INTO `access_log` VALUES (61867, '64.82.15646689517456289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:52', 2, 0, '', '2019-08-01 22:15:52');
INSERT INTO `access_log` VALUES (61868, '64.81.15646689561206273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:56', 1, 0, '', '2019-08-01 22:15:56');
INSERT INTO `access_log` VALUES (61869, '64.85.15646689570016307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:57', 2, 0, '', '2019-08-01 22:15:57');
INSERT INTO `access_log` VALUES (61870, '64.83.15646689578176269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:58', 2, 0, '', '2019-08-01 22:15:58');
INSERT INTO `access_log` VALUES (61871, '64.77.15646689589246267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:59', 2, 0, '', '2019-08-01 22:15:59');
INSERT INTO `access_log` VALUES (61872, '64.78.15646689593746277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:15:59', 2, 0, '', '2019-08-01 22:15:59');
INSERT INTO `access_log` VALUES (61873, '64.84.15646689599226271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:00', 2, 0, '', '2019-08-01 22:16:00');
INSERT INTO `access_log` VALUES (61874, '64.76.15646689603876275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:00', 2, 0, '', '2019-08-01 22:16:00');
INSERT INTO `access_log` VALUES (61875, '64.80.15646689644406281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:04', 2, 0, '', '2019-08-01 22:16:04');
INSERT INTO `access_log` VALUES (61876, '64.79.15646689645786271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:05', 1, 0, '', '2019-08-01 22:16:05');
INSERT INTO `access_log` VALUES (61877, '59.77.15646689738835971', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:14', 2, 0, '', '2019-08-01 22:16:14');
INSERT INTO `access_log` VALUES (61878, '59.72.15646689738845977', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:14', 13, 2001001000, '服务端发生异常', '2019-08-01 22:16:14');
INSERT INTO `access_log` VALUES (61879, '64.85.15646689846566309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:25', 2, 0, '', '2019-08-01 22:16:25');
INSERT INTO `access_log` VALUES (61880, '64.83.15646689850096271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:25', 2, 0, '', '2019-08-01 22:16:25');
INSERT INTO `access_log` VALUES (61881, '64.77.15646689860256269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:26', 2, 0, '', '2019-08-01 22:16:26');
INSERT INTO `access_log` VALUES (61882, '64.78.15646689866996279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:27', 2, 0, '', '2019-08-01 22:16:27');
INSERT INTO `access_log` VALUES (61883, '64.84.15646689873606273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:27', 2, 0, '', '2019-08-01 22:16:27');
INSERT INTO `access_log` VALUES (61884, '64.76.15646689877946277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:28', 2, 0, '', '2019-08-01 22:16:28');
INSERT INTO `access_log` VALUES (61885, '59.76.15646689890635971', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:29', 2, 0, '', '2019-08-01 22:16:29');
INSERT INTO `access_log` VALUES (61886, '59.73.15646689890695981', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:29', 13, 2001001000, '服务端发生异常', '2019-08-01 22:16:29');
INSERT INTO `access_log` VALUES (61887, '64.79.15646689989246273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:39', 2, 0, '', '2019-08-01 22:16:39');
INSERT INTO `access_log` VALUES (61888, '64.82.15646689990486293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:39', 2, 0, '', '2019-08-01 22:16:39');
INSERT INTO `access_log` VALUES (61889, '64.81.15646690026006277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:43', 2, 0, '', '2019-08-01 22:16:43');
INSERT INTO `access_log` VALUES (61890, '64.85.15646690038916311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:44', 2, 0, '', '2019-08-01 22:16:44');
INSERT INTO `access_log` VALUES (61891, '64.83.15646690053446273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:45', 2, 0, '', '2019-08-01 22:16:45');
INSERT INTO `access_log` VALUES (61892, '64.77.15646690064896271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:46', 1, 0, '', '2019-08-01 22:16:46');
INSERT INTO `access_log` VALUES (61893, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:47', 7, 0, '', '2019-08-01 22:16:47');
INSERT INTO `access_log` VALUES (61894, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:51', 7, 0, '', '2019-08-01 22:16:51');
INSERT INTO `access_log` VALUES (61895, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:53', 6, 0, '', '2019-08-01 22:16:53');
INSERT INTO `access_log` VALUES (61896, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:54', 6, 0, '', '2019-08-01 22:16:54');
INSERT INTO `access_log` VALUES (61897, '64.84.15646690157086275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:56', 2, 0, '', '2019-08-01 22:16:56');
INSERT INTO `access_log` VALUES (61898, '64.76.15646690158426279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:56', 1, 0, '', '2019-08-01 22:16:56');
INSERT INTO `access_log` VALUES (61899, '64.80.15646690174536285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:57', 2, 0, '', '2019-08-01 22:16:57');
INSERT INTO `access_log` VALUES (61900, '64.79.15646690184826275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:58', 1, 0, '', '2019-08-01 22:16:58');
INSERT INTO `access_log` VALUES (61901, '64.82.15646690192266295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:59', 2, 0, '', '2019-08-01 22:16:59');
INSERT INTO `access_log` VALUES (61902, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:16:59', 7, 0, '', '2019-08-01 22:16:59');
INSERT INTO `access_log` VALUES (61903, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:01', 4, 0, '', '2019-08-01 22:17:01');
INSERT INTO `access_log` VALUES (61904, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:02', 5, 0, '', '2019-08-01 22:17:02');
INSERT INTO `access_log` VALUES (61905, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:04', 6, 0, '', '2019-08-01 22:17:04');
INSERT INTO `access_log` VALUES (61906, '64.81.15646690246516279', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:05', 8, 0, '', '2019-08-01 22:17:05');
INSERT INTO `access_log` VALUES (61907, '64.83.15646690323536275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:12', 2, 0, '', '2019-08-01 22:17:12');
INSERT INTO `access_log` VALUES (61908, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:13', 6, 0, '', '2019-08-01 22:17:13');
INSERT INTO `access_log` VALUES (61909, '64.77.15646690332926273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:13', 2, 0, '', '2019-08-01 22:17:13');
INSERT INTO `access_log` VALUES (61910, '64.78.15646690335796283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:14', 2, 0, '', '2019-08-01 22:17:14');
INSERT INTO `access_log` VALUES (61911, '66.49.15646690521263701', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18373353229&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:32', 16, 1001003000, '验证码不存在', '2019-08-01 22:17:32');
INSERT INTO `access_log` VALUES (61912, '66.54.15646690557703709', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18373353229', 'POST', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:36', 47, 0, '', '2019-08-01 22:17:36');
INSERT INTO `access_log` VALUES (61913, '66.48.15646690618233715', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18373353229&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:42', 171, 0, '', '2019-08-01 22:17:42');
INSERT INTO `access_log` VALUES (61914, '64.79.15646690677306277', 188, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:48', 7, 0, '', '2019-08-01 22:17:48');
INSERT INTO `access_log` VALUES (61915, '64.81.15646690682026281', 188, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:48', 5, 0, '', '2019-08-01 22:17:48');
INSERT INTO `access_log` VALUES (61916, '66.51.15646690685353727', 188, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:49', 66, 0, '', '2019-08-01 22:17:49');
INSERT INTO `access_log` VALUES (61917, '66.53.15646690706843701', 188, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:51', 7, 0, '', '2019-08-01 22:17:51');
INSERT INTO `access_log` VALUES (61918, '66.56.15646690729343719', 188, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:17:53', 6, 0, '', '2019-08-01 22:17:53');
INSERT INTO `access_log` VALUES (61919, '66.50.15646690815413703', 188, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:18:02', 5, 0, '', '2019-08-01 22:18:02');
INSERT INTO `access_log` VALUES (61920, '66.49.15646690844753703', 188, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:18:04', 5, 0, '', '2019-08-01 22:18:04');
INSERT INTO `access_log` VALUES (61921, '66.54.15646690863013711', 188, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:18:06', 5, 0, '', '2019-08-01 22:18:06');
INSERT INTO `access_log` VALUES (61922, '66.48.15646690912293717', 188, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:18:11', 5, 0, '', '2019-08-01 22:18:11');
INSERT INTO `access_log` VALUES (61923, '66.55.15646691292403689', 188, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:18:49', 6, 0, '', '2019-08-01 22:18:49');
INSERT INTO `access_log` VALUES (61924, '59.80.15646691302565957', 188, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:18:50', 8, 0, '', '2019-08-01 22:18:50');
INSERT INTO `access_log` VALUES (61925, '59.75.15646691303665995', 188, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:18:50', 45, 2001001000, '服务端发生异常', '2019-08-01 22:18:50');
INSERT INTO `access_log` VALUES (61926, '64.76.15646691399206283', 188, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:00', 7, 0, '', '2019-08-01 22:19:00');
INSERT INTO `access_log` VALUES (61927, '64.80.15646691401436289', 188, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:00', 4, 0, '', '2019-08-01 22:19:00');
INSERT INTO `access_log` VALUES (61928, '64.82.15646691420396299', 188, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:02', 5, 0, '', '2019-08-01 22:19:02');
INSERT INTO `access_log` VALUES (61929, '64.81.15646691430426283', 188, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:03', 6, 0, '', '2019-08-01 22:19:03');
INSERT INTO `access_log` VALUES (61930, 'N/A', 188, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:03', 10, 0, '', '2019-08-01 22:19:03');
INSERT INTO `access_log` VALUES (61931, '64.85.15646691450556317', 188, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:05', 6, 0, '', '2019-08-01 22:19:05');
INSERT INTO `access_log` VALUES (61932, '64.83.15646691452056279', 188, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:05', 7, 0, '', '2019-08-01 22:19:05');
INSERT INTO `access_log` VALUES (61933, '64.78.15646691460386287', 188, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:06', 4, 0, '', '2019-08-01 22:19:06');
INSERT INTO `access_log` VALUES (61934, '64.84.15646691464086281', 188, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:06', 4, 0, '', '2019-08-01 22:19:06');
INSERT INTO `access_log` VALUES (61935, 'N/A', 188, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:06', 10, 0, '', '2019-08-01 22:19:06');
INSERT INTO `access_log` VALUES (61936, '64.80.15646691485646291', 188, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:09', 11, 0, '', '2019-08-01 22:19:09');
INSERT INTO `access_log` VALUES (61937, '66.57.15646691728443711', 188, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:33', 6, 0, '', '2019-08-01 22:19:33');
INSERT INTO `access_log` VALUES (61938, '64.81.15646691770186285', 188, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:37', 9, 0, '', '2019-08-01 22:19:37');
INSERT INTO `access_log` VALUES (61939, '64.85.15646691823456319', 188, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:42', 9, 0, '', '2019-08-01 22:19:42');
INSERT INTO `access_log` VALUES (61940, '66.48.15646691903713719', 188, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:50', 6, 0, '', '2019-08-01 22:19:50');
INSERT INTO `access_log` VALUES (61941, '66.55.15646691951753691', 188, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:19:55', 5, 0, '', '2019-08-01 22:19:55');
INSERT INTO `access_log` VALUES (61942, '66.53.15646692001993705', 188, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:20:00', 5, 0, '', '2019-08-01 22:20:00');
INSERT INTO `access_log` VALUES (61943, '66.56.15646692010183723', 188, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:20:01', 6, 0, '', '2019-08-01 22:20:01');
INSERT INTO `access_log` VALUES (61944, '64.77.15646692047216279', 188, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:20:05', 9, 0, '', '2019-08-01 22:20:05');
INSERT INTO `access_log` VALUES (61945, '66.49.15646692102793707', 188, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:20:10', 5, 0, '', '2019-08-01 22:20:10');
INSERT INTO `access_log` VALUES (61946, '66.57.15646692139653713', 188, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:20:14', 6, 0, '', '2019-08-01 22:20:14');
INSERT INTO `access_log` VALUES (61947, '66.54.15646692158843715', 188, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:20:16', 5, 0, '', '2019-08-01 22:20:16');
INSERT INTO `access_log` VALUES (61948, '64.76.15646692260056287', 188, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:20:26', 9, 0, '', '2019-08-01 22:20:26');
INSERT INTO `access_log` VALUES (61949, '64.82.15646692630656303', 188, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:21:03', 5, 0, '', '2019-08-01 22:21:03');
INSERT INTO `access_log` VALUES (61950, 'N/A', 188, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:21:03', 9, 0, '', '2019-08-01 22:21:03');
INSERT INTO `access_log` VALUES (61951, '64.85.15646692653096321', 188, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:21:05', 7, 0, '', '2019-08-01 22:21:05');
INSERT INTO `access_log` VALUES (61952, '66.53.15646692746073707', 188, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:21:15', 6, 0, '', '2019-08-01 22:21:15');
INSERT INTO `access_log` VALUES (61953, '66.56.15646692790653725', 188, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:21:19', 5, 0, '', '2019-08-01 22:21:19');
INSERT INTO `access_log` VALUES (61954, '66.54.15646693024503717', 188, 1, 'user-application', '/user-api/users/address/add', 'name=看看&tel=18373353229&country=&province=河北省&city=石家庄市&county=桥西区&areaCode=130104&postalCode=&addressDetail=明年&isDefault=true&address=明年&areaNo=130104&mobile=18373353229&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:21:42', 521, 2001001000, '服务端发生异常', '2019-08-01 22:21:43');
INSERT INTO `access_log` VALUES (61955, '66.48.15646693044103723', 188, 1, 'user-application', '/user-api/users/address/add', 'name=看看&tel=18373353229&country=&province=河北省&city=石家庄市&county=桥西区&areaCode=130104&postalCode=&addressDetail=明年&isDefault=true&address=明年&areaNo=130104&mobile=18373353229&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:21:44', 80, 2001001000, '服务端发生异常', '2019-08-01 22:21:44');
INSERT INTO `access_log` VALUES (61956, '66.52.15646693064743703', 188, 1, 'user-application', '/user-api/users/address/add', 'name=看看&tel=18373353229&country=&province=河北省&city=石家庄市&county=桥西区&areaCode=130104&postalCode=&addressDetail=明年&isDefault=true&address=明年&areaNo=130104&mobile=18373353229&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:21:46', 119, 2001001000, '服务端发生异常', '2019-08-01 22:21:47');
INSERT INTO `access_log` VALUES (61957, '65.52.15646696771318575', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:27:57', 16, 0, '', '2019-08-01 22:27:57');
INSERT INTO `access_log` VALUES (61958, '65.3607.15646696771320321', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:27:57', 15, 2001001000, '服务端发生异常', '2019-08-01 22:27:57');
INSERT INTO `access_log` VALUES (61959, '65.46.15646696771318579', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:27:57', 16, 0, '', '2019-08-01 22:27:57');
INSERT INTO `access_log` VALUES (61960, '65.47.15646696835578507', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:28:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 22:28:04');
INSERT INTO `access_log` VALUES (61961, '65.45.15646696886408527', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:28:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 22:28:09');
INSERT INTO `access_log` VALUES (61962, '65.49.15646696948268507', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:28:15', 83, 0, '', '2019-08-01 22:28:15');
INSERT INTO `access_log` VALUES (61963, '65.53.15646696952328525', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:28:15', 8, 0, '', '2019-08-01 22:28:15');
INSERT INTO `access_log` VALUES (61964, '65.54.15646696952348441', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:28:15', 9, 0, '', '2019-08-01 22:28:15');
INSERT INTO `access_log` VALUES (61965, '65.50.15646696952348525', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:28:15', 9, 2001001000, '服务端发生异常', '2019-08-01 22:28:15');
INSERT INTO `access_log` VALUES (61966, '65.47.15646697406778509', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:29:01', 135, 0, '', '2019-08-01 22:29:01');
INSERT INTO `access_log` VALUES (61967, '65.45.15646697406808529', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:29:01', 134, 2001001000, '服务端发生异常', '2019-08-01 22:29:01');
INSERT INTO `access_log` VALUES (61968, '65.51.15646697406828601', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:29:01', 131, 0, '', '2019-08-01 22:29:01');
INSERT INTO `access_log` VALUES (61969, '65.54.15646697524238443', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:29:12', 10, 0, '', '2019-08-01 22:29:12');
INSERT INTO `access_log` VALUES (61970, '65.50.15646697524278527', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:29:12', 8, 0, '', '2019-08-01 22:29:12');
INSERT INTO `access_log` VALUES (61971, '65.53.15646697524278527', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.140.180.101', '2019-08-01 22:29:12', 10, 2001001000, '服务端发生异常', '2019-08-01 22:29:12');
INSERT INTO `access_log` VALUES (61972, '65.3607.15646715645740349', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.89.112', '2019-08-01 22:59:25', 1, 1002001015, '账号未登陆', '2019-08-01 22:59:25');
INSERT INTO `access_log` VALUES (61973, '65.46.15646715645748607', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.89.112', '2019-08-01 22:59:25', 1, 1002001015, '账号未登陆', '2019-08-01 22:59:25');
INSERT INTO `access_log` VALUES (61974, '65.47.15646715645788535', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.89.112', '2019-08-01 22:59:25', 0, 1002001015, '账号未登陆', '2019-08-01 22:59:25');
INSERT INTO `access_log` VALUES (61975, '59.77.15646715657766007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.89.112', '2019-08-01 22:59:26', 14, 2001001000, '服务端发生异常', '2019-08-01 22:59:26');
INSERT INTO `access_log` VALUES (61976, '59.78.15646715659556025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.89.112', '2019-08-01 22:59:26', 10, 0, '', '2019-08-01 22:59:26');
INSERT INTO `access_log` VALUES (61977, '65.51.15646715677788627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.89.112', '2019-08-01 22:59:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 22:59:28');
INSERT INTO `access_log` VALUES (61978, '65.49.15646715803778535', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.89.112', '2019-08-01 22:59:40', 70, 0, '', '2019-08-01 22:59:40');
INSERT INTO `access_log` VALUES (61979, '65.54.15646715810998469', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.89.112', '2019-08-01 22:59:41', 9, 0, '', '2019-08-01 22:59:41');
INSERT INTO `access_log` VALUES (61980, '65.50.15646715810988553', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.89.112', '2019-08-01 22:59:41', 10, 0, '', '2019-08-01 22:59:41');
INSERT INTO `access_log` VALUES (61981, '65.53.15646715810978553', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.89.112', '2019-08-01 22:59:41', 11, 2001001000, '服务端发生异常', '2019-08-01 22:59:41');
INSERT INTO `access_log` VALUES (61982, '65.52.15646715857388605', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.89.112', '2019-08-01 22:59:46', 38, 0, '', '2019-08-01 22:59:46');
INSERT INTO `access_log` VALUES (61983, '65.46.15646715857468609', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.89.112', '2019-08-01 22:59:46', 31, 0, '', '2019-08-01 22:59:46');
INSERT INTO `access_log` VALUES (61984, '65.47.15646715857388537', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.89.112', '2019-08-01 22:59:46', 39, 2001001000, '服务端发生异常', '2019-08-01 22:59:46');
INSERT INTO `access_log` VALUES (61985, '65.45.15646716018628557', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.136.89.112', '2019-08-01 23:00:02', 10, 0, '', '2019-08-01 23:00:02');
INSERT INTO `access_log` VALUES (61986, '65.51.15646716018628629', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.136.89.112', '2019-08-01 23:00:02', 11, 0, '', '2019-08-01 23:00:02');
INSERT INTO `access_log` VALUES (61987, '65.49.15646716018638537', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.136.89.112', '2019-08-01 23:00:02', 9, 2001001000, '服务端发生异常', '2019-08-01 23:00:02');
INSERT INTO `access_log` VALUES (61988, '59.78.15646748532896069', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:13', 10, 0, '', '2019-08-01 23:54:13');
INSERT INTO `access_log` VALUES (61989, '59.76.15646748532926051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:13', 15, 2001001000, '服务端发生异常', '2019-08-01 23:54:13');
INSERT INTO `access_log` VALUES (61990, '64.84.15646748589386359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:19', 13, 0, '', '2019-08-01 23:54:19');
INSERT INTO `access_log` VALUES (61991, '64.76.15646748591656363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:19', 3, 0, '', '2019-08-01 23:54:19');
INSERT INTO `access_log` VALUES (61992, '64.80.15646748604236369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:20', 2, 0, '', '2019-08-01 23:54:20');
INSERT INTO `access_log` VALUES (61993, '64.82.15646748611836379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:21', 2, 0, '', '2019-08-01 23:54:21');
INSERT INTO `access_log` VALUES (61994, '64.81.15646748620566363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:22', 2, 0, '', '2019-08-01 23:54:22');
INSERT INTO `access_log` VALUES (61995, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=kkk&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:24', 6, 0, '', '2019-08-01 23:54:24');
INSERT INTO `access_log` VALUES (61996, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kkk', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:24', 6, 0, '', '2019-08-01 23:54:24');
INSERT INTO `access_log` VALUES (61997, '65.53.15646748824868599', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:42', 0, 1002001015, '账号未登陆', '2019-08-01 23:54:42');
INSERT INTO `access_log` VALUES (61998, '65.51.15646748824868673', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:42', 1, 1002001015, '账号未登陆', '2019-08-01 23:54:42');
INSERT INTO `access_log` VALUES (61999, '65.50.15646748825058599', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:43', 1, 1002001015, '账号未登陆', '2019-08-01 23:54:43');
INSERT INTO `access_log` VALUES (62000, '65.54.15646748905168515', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-01 23:54:51');
INSERT INTO `access_log` VALUES (62001, '65.47.15646748973888583', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:57', 97, 0, '', '2019-08-01 23:54:57');
INSERT INTO `access_log` VALUES (62002, '65.52.15646748977958651', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:58', 14, 0, '', '2019-08-01 23:54:58');
INSERT INTO `access_log` VALUES (62003, '65.45.15646748978008603', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:58', 10, 0, '', '2019-08-01 23:54:58');
INSERT INTO `access_log` VALUES (62004, '65.3607.15646748977960397', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:54:58', 12, 0, '', '2019-08-01 23:54:58');
INSERT INTO `access_log` VALUES (62005, '62.88.15646749072775005', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:55:07', 24, 0, '', '2019-08-01 23:55:07');
INSERT INTO `access_log` VALUES (62006, '66.50.15646749120883785', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:55:12', 21, 0, '', '2019-08-01 23:55:12');
INSERT INTO `access_log` VALUES (62007, '59.79.15646749209626069', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.92.226.180', '2019-08-01 23:55:21', 16, 0, '', '2019-08-01 23:55:21');
INSERT INTO `access_log` VALUES (62008, '59.71.15646789012446111', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI PAD 4 Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Safari/537.36 MMWEBID/7299 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '175.167.154.185', '2019-08-02 01:01:41', 10, 0, '', '2019-08-02 01:01:41');
INSERT INTO `access_log` VALUES (62009, '59.74.15646789012446129', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI PAD 4 Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Safari/537.36 MMWEBID/7299 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '175.167.154.185', '2019-08-02 01:01:41', 19, 2001001000, '服务端发生异常', '2019-08-02 01:01:41');
INSERT INTO `access_log` VALUES (62010, '64.81.15646789072576417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI PAD 4 Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Safari/537.36 MMWEBID/7299 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '175.167.154.185', '2019-08-02 01:01:47', 11, 0, '', '2019-08-02 01:01:47');
INSERT INTO `access_log` VALUES (62011, '64.85.15646789075276451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI PAD 4 Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Safari/537.36 MMWEBID/7299 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '175.167.154.185', '2019-08-02 01:01:48', 3, 0, '', '2019-08-02 01:01:48');
INSERT INTO `access_log` VALUES (62012, '59.75.15646789098376127', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI PAD 4 Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Safari/537.36 MMWEBID/7299 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '175.167.154.185', '2019-08-02 01:01:50', 9, 0, '', '2019-08-02 01:01:50');
INSERT INTO `access_log` VALUES (62013, '59.79.15646789098506123', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI PAD 4 Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Safari/537.36 MMWEBID/7299 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '175.167.154.185', '2019-08-02 01:01:50', 12, 2001001000, '服务端发生异常', '2019-08-02 01:01:50');
INSERT INTO `access_log` VALUES (62014, '64.77.15646789117886411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI PAD 4 Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Safari/537.36 MMWEBID/7299 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '175.167.154.185', '2019-08-02 01:01:52', 2, 0, '', '2019-08-02 01:01:52');
INSERT INTO `access_log` VALUES (62015, '64.78.15646789120216421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI PAD 4 Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Safari/537.36 MMWEBID/7299 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '175.167.154.185', '2019-08-02 01:01:52', 2, 0, '', '2019-08-02 01:01:52');
INSERT INTO `access_log` VALUES (62016, '59.72.15646789135786113', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI PAD 4 Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Safari/537.36 MMWEBID/7299 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '175.167.154.185', '2019-08-02 01:01:54', 2, 0, '', '2019-08-02 01:01:54');
INSERT INTO `access_log` VALUES (62017, '59.77.15646789135946107', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; MI PAD 4 Build/OPM1.171019.019; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Safari/537.36 MMWEBID/7299 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '175.167.154.185', '2019-08-02 01:01:54', 12, 2001001000, '服务端发生异常', '2019-08-02 01:01:54');
INSERT INTO `access_log` VALUES (62018, '65.52.15646927034138889', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.88.243', '2019-08-02 04:51:43', 96, 1002001012, '访问令牌已过期', '2019-08-02 04:51:44');
INSERT INTO `access_log` VALUES (62019, '65.3607.15646927034330635', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.88.243', '2019-08-02 04:51:43', 75, 1002001012, '访问令牌已过期', '2019-08-02 04:51:44');
INSERT INTO `access_log` VALUES (62020, '65.45.15646927034138841', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.88.243', '2019-08-02 04:51:43', 94, 1002001012, '访问令牌已过期', '2019-08-02 04:51:44');
INSERT INTO `access_log` VALUES (62021, '65.49.15646927050818821', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.88.243', '2019-08-02 04:51:45', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 04:51:45');
INSERT INTO `access_log` VALUES (62022, '65.51.15646927162668913', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.88.243', '2019-08-02 04:51:56', 112, 0, '', '2019-08-02 04:51:56');
INSERT INTO `access_log` VALUES (62023, '65.50.15646927166368839', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.88.243', '2019-08-02 04:51:57', 21, 0, '', '2019-08-02 04:51:57');
INSERT INTO `access_log` VALUES (62024, '65.46.15646927166418895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.88.243', '2019-08-02 04:51:57', 20, 2001001000, '服务端发生异常', '2019-08-02 04:51:57');
INSERT INTO `access_log` VALUES (62025, '65.54.15646927166408755', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.88.243', '2019-08-02 04:51:57', 22, 0, '', '2019-08-02 04:51:57');
INSERT INTO `access_log` VALUES (62026, '65.52.15646927253938891', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.88.243', '2019-08-02 04:52:05', 9, 0, '', '2019-08-02 04:52:05');
INSERT INTO `access_log` VALUES (62027, '65.47.15646927253938823', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.88.243', '2019-08-02 04:52:05', 9, 0, '', '2019-08-02 04:52:05');
INSERT INTO `access_log` VALUES (62028, '65.45.15646927253938843', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.88.243', '2019-08-02 04:52:05', 10, 2001001000, '服务端发生异常', '2019-08-02 04:52:05');
INSERT INTO `access_log` VALUES (62029, '65.45.15647087393999057', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.122', '2019-08-02 09:18:59', 21, 1002001012, '访问令牌已过期', '2019-08-02 09:18:59');
INSERT INTO `access_log` VALUES (62030, '65.3607.15647087393990851', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.122', '2019-08-02 09:18:59', 22, 1002001012, '访问令牌已过期', '2019-08-02 09:18:59');
INSERT INTO `access_log` VALUES (62031, '65.47.15647087393989037', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.122', '2019-08-02 09:18:59', 20, 1002001012, '访问令牌已过期', '2019-08-02 09:18:59');
INSERT INTO `access_log` VALUES (62032, '65.53.15647087502929055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.122', '2019-08-02 09:19:10', 102, 0, '', '2019-08-02 09:19:10');
INSERT INTO `access_log` VALUES (62033, '65.51.15647087507049129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.122', '2019-08-02 09:19:11', 11, 0, '', '2019-08-02 09:19:11');
INSERT INTO `access_log` VALUES (62034, '65.50.15647087507259055', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.122', '2019-08-02 09:19:11', 13, 2001001000, '服务端发生异常', '2019-08-02 09:19:11');
INSERT INTO `access_log` VALUES (62035, '65.46.15647087507259111', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.22.45.122', '2019-08-02 09:19:11', 17, 0, '', '2019-08-02 09:19:11');
INSERT INTO `access_log` VALUES (62036, '65.47.15647093665819047', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.1 Safari/605.1.15', '120.33.203.186', '2019-08-02 09:29:27', 0, 1002001015, '账号未登陆', '2019-08-02 09:29:27');
INSERT INTO `access_log` VALUES (62037, '65.52.15647093665819115', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.1 Safari/605.1.15', '120.33.203.186', '2019-08-02 09:29:27', 1, 1002001015, '账号未登陆', '2019-08-02 09:29:27');
INSERT INTO `access_log` VALUES (62038, '65.45.15647093665879067', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.1 Safari/605.1.15', '120.33.203.186', '2019-08-02 09:29:27', 0, 1002001015, '账号未登陆', '2019-08-02 09:29:27');
INSERT INTO `access_log` VALUES (62039, '65.3607.15647093682750861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.1 Safari/605.1.15', '120.33.203.186', '2019-08-02 09:29:28', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 09:29:28');
INSERT INTO `access_log` VALUES (62040, '65.49.15647093782779047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.1 Safari/605.1.15', '120.33.203.186', '2019-08-02 09:29:38', 62, 0, '', '2019-08-02 09:29:38');
INSERT INTO `access_log` VALUES (62041, '65.53.15647093788919065', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.1 Safari/605.1.15', '120.33.203.186', '2019-08-02 09:29:39', 10, 0, '', '2019-08-02 09:29:39');
INSERT INTO `access_log` VALUES (62042, '65.50.15647093788949065', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.1 Safari/605.1.15', '120.33.203.186', '2019-08-02 09:29:39', 10, 2001001000, '服务端发生异常', '2019-08-02 09:29:39');
INSERT INTO `access_log` VALUES (62043, '65.46.15647093788969121', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.1 Safari/605.1.15', '120.33.203.186', '2019-08-02 09:29:39', 9, 0, '', '2019-08-02 09:29:39');
INSERT INTO `access_log` VALUES (62044, '59.76.15647105778786529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.169.201.214', '2019-08-02 09:49:38', 12, 0, '', '2019-08-02 09:49:38');
INSERT INTO `access_log` VALUES (62045, '59.73.15647105778786539', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.169.201.214', '2019-08-02 09:49:38', 25, 2001001000, '服务端发生异常', '2019-08-02 09:49:38');
INSERT INTO `access_log` VALUES (62046, '64.76.15647105856276841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.169.201.214', '2019-08-02 09:49:46', 11, 0, '', '2019-08-02 09:49:46');
INSERT INTO `access_log` VALUES (62047, '64.79.15647105859696837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.169.201.214', '2019-08-02 09:49:46', 4, 0, '', '2019-08-02 09:49:46');
INSERT INTO `access_log` VALUES (62048, '64.80.15647105872446847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.169.201.214', '2019-08-02 09:49:47', 2, 0, '', '2019-08-02 09:49:47');
INSERT INTO `access_log` VALUES (62049, '64.82.15647105880406857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.169.201.214', '2019-08-02 09:49:48', 2, 0, '', '2019-08-02 09:49:48');
INSERT INTO `access_log` VALUES (62050, '64.81.15647105884926841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.169.201.214', '2019-08-02 09:49:48', 2, 0, '', '2019-08-02 09:49:48');
INSERT INTO `access_log` VALUES (62051, '65.51.15647120156189175', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:13:36', 0, 1002001015, '账号未登陆', '2019-08-02 10:13:36');
INSERT INTO `access_log` VALUES (62052, '65.49.15647120156189083', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '116.3.9.101', '2019-08-02 10:13:36', 0, 1002001015, '账号未登陆', '2019-08-02 10:13:36');
INSERT INTO `access_log` VALUES (62053, '65.50.15647120156209101', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '116.3.9.101', '2019-08-02 10:13:36', 0, 1002001015, '账号未登陆', '2019-08-02 10:13:36');
INSERT INTO `access_log` VALUES (62054, '65.53.15647120181599101', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:13:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 10:13:38');
INSERT INTO `access_log` VALUES (62055, '65.54.15647120277229017', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyunmao&password=yudaoyunmao&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:13:48', 5, 1002002000, '账号不存在', '2019-08-02 10:13:48');
INSERT INTO `access_log` VALUES (62056, '65.45.15647120342119105', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:13:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 10:13:54');
INSERT INTO `access_log` VALUES (62057, '65.47.15647120395389085', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yidaoyunma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:14:00', 70, 0, '', '2019-08-02 10:14:00');
INSERT INTO `access_log` VALUES (62058, '65.3607.15647120402940899', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:14:00', 11, 0, '', '2019-08-02 10:14:00');
INSERT INTO `access_log` VALUES (62059, '65.50.15647120403019103', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '61.189.111.235', '2019-08-02 10:14:00', 16, 0, '', '2019-08-02 10:14:00');
INSERT INTO `access_log` VALUES (62060, '65.49.15647120403029085', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:14:00', 16, 0, '', '2019-08-02 10:14:00');
INSERT INTO `access_log` VALUES (62061, '62.84.15647120471345491', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:14:07', 51, 0, '', '2019-08-02 10:14:07');
INSERT INTO `access_log` VALUES (62062, '66.53.15647120603124279', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:14:20', 22, 0, '', '2019-08-02 10:14:20');
INSERT INTO `access_log` VALUES (62063, '59.73.15647120685886559', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:14:29', 19, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-02 10:14:29');
INSERT INTO `access_log` VALUES (62064, '59.80.15647120976886533', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=WAIT&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:14:58', 12, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-02 10:14:58');
INSERT INTO `access_log` VALUES (62065, '59.75.15647120984166571', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=RUN&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:14:58', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-02 10:14:58');
INSERT INTO `access_log` VALUES (62066, '59.79.15647120997836567', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=END&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:15:00', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-02 10:15:00');
INSERT INTO `access_log` VALUES (62067, '59.72.15647121006316557', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'status=INVALID&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:15:01', 16, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-02 10:15:01');
INSERT INTO `access_log` VALUES (62068, '65.45.15647121225989107', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:15:23', 10, 0, '', '2019-08-02 10:15:23');
INSERT INTO `access_log` VALUES (62069, '59.76.15647121336256551', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:15:34', 20, 2001001000, '服务端发生异常', '2019-08-02 10:15:34');
INSERT INTO `access_log` VALUES (62070, '59.73.15647121336286561', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:15:34', 133, 0, '', '2019-08-02 10:15:34');
INSERT INTO `access_log` VALUES (62071, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:15:41', 6, 0, '', '2019-08-02 10:15:41');
INSERT INTO `access_log` VALUES (62072, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:15:41', 4, 0, '', '2019-08-02 10:15:41');
INSERT INTO `access_log` VALUES (62073, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:15:41', 12, 0, '', '2019-08-02 10:15:41');
INSERT INTO `access_log` VALUES (62074, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:15:41', 9, 0, '', '2019-08-02 10:15:41');
INSERT INTO `access_log` VALUES (62075, '62.81.15647121419265473', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:15:42', 17, 0, '', '2019-08-02 10:15:42');
INSERT INTO `access_log` VALUES (62076, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:15:47', 6, 0, '', '2019-08-02 10:15:47');
INSERT INTO `access_log` VALUES (62077, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=java', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:15:48', 8, 0, '', '2019-08-02 10:15:48');
INSERT INTO `access_log` VALUES (62078, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=kaka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:15:53', 5, 0, '', '2019-08-02 10:15:53');
INSERT INTO `access_log` VALUES (62079, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=kaka', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:15:53', 5, 0, '', '2019-08-02 10:15:53');
INSERT INTO `access_log` VALUES (62080, '64.79.15647121573246859', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '61.189.111.235', '2019-08-02 10:15:57', 14, 0, '', '2019-08-02 10:15:57');
INSERT INTO `access_log` VALUES (62081, '64.76.15647121573216863', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '59.46.231.250', '2019-08-02 10:15:57', 15, 0, '', '2019-08-02 10:15:57');
INSERT INTO `access_log` VALUES (62082, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=ka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:15:58', 5, 0, '', '2019-08-02 10:15:58');
INSERT INTO `access_log` VALUES (62083, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=ka', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:15:58', 5, 0, '', '2019-08-02 10:15:58');
INSERT INTO `access_log` VALUES (62084, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=ka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:16:00', 13, 0, '', '2019-08-02 10:16:00');
INSERT INTO `access_log` VALUES (62085, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=ka', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:16:00', 5, 0, '', '2019-08-02 10:16:00');
INSERT INTO `access_log` VALUES (62086, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:16:03', 7, 0, '', '2019-08-02 10:16:03');
INSERT INTO `access_log` VALUES (62087, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.201.214', '2019-08-02 10:16:03', 15, 0, '', '2019-08-02 10:16:03');
INSERT INTO `access_log` VALUES (62088, '59.75.15647121686336573', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '61.189.111.235', '2019-08-02 10:16:09', 19, 2001001000, '服务端发生异常', '2019-08-02 10:16:09');
INSERT INTO `access_log` VALUES (62089, '65.45.15647161576209161', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.134.212.146', '2019-08-02 11:22:38', 0, 1002001015, '账号未登陆', '2019-08-02 11:22:38');
INSERT INTO `access_log` VALUES (62090, '65.47.15647161576209141', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.134.212.146', '2019-08-02 11:22:38', 0, 1002001015, '账号未登陆', '2019-08-02 11:22:38');
INSERT INTO `access_log` VALUES (62091, '65.49.15647161576489141', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.134.212.146', '2019-08-02 11:22:38', 1, 1002001015, '账号未登陆', '2019-08-02 11:22:38');
INSERT INTO `access_log` VALUES (62092, '65.50.15647161660309159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.134.212.146', '2019-08-02 11:22:46', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 11:22:46');
INSERT INTO `access_log` VALUES (62093, '65.53.15647161754169159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.134.212.146', '2019-08-02 11:22:55', 65, 0, '', '2019-08-02 11:22:55');
INSERT INTO `access_log` VALUES (62094, '65.46.15647161756899215', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.134.212.146', '2019-08-02 11:22:56', 14, 0, '', '2019-08-02 11:22:56');
INSERT INTO `access_log` VALUES (62095, '65.54.15647161756919075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.134.212.146', '2019-08-02 11:22:56', 12, 2001001000, '服务端发生异常', '2019-08-02 11:22:56');
INSERT INTO `access_log` VALUES (62096, '65.52.15647161756969211', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.134.212.146', '2019-08-02 11:22:56', 18, 0, '', '2019-08-02 11:22:56');
INSERT INTO `access_log` VALUES (62097, '59.73.15647177755526637', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.1.43', '2019-08-02 11:49:36', 12, 2001001000, '服务端发生异常', '2019-08-02 11:49:36');
INSERT INTO `access_log` VALUES (62098, '59.76.15647177755526627', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.1.43', '2019-08-02 11:49:36', 109, 0, '', '2019-08-02 11:49:36');
INSERT INTO `access_log` VALUES (62099, '64.77.15647177788246931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.1.43', '2019-08-02 11:49:39', 11, 0, '', '2019-08-02 11:49:39');
INSERT INTO `access_log` VALUES (62100, '64.78.15647177790106941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.1.43', '2019-08-02 11:49:39', 3, 0, '', '2019-08-02 11:49:39');
INSERT INTO `access_log` VALUES (62101, '59.74.15647177797206651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.1.43', '2019-08-02 11:49:40', 3, 0, '', '2019-08-02 11:49:40');
INSERT INTO `access_log` VALUES (62102, '59.71.15647177797206633', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.1.43', '2019-08-02 11:49:40', 16, 2001001000, '服务端发生异常', '2019-08-02 11:49:40');
INSERT INTO `access_log` VALUES (62103, '59.80.15647177836346611', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.1.43', '2019-08-02 11:49:44', 2, 0, '', '2019-08-02 11:49:44');
INSERT INTO `access_log` VALUES (62104, '59.75.15647177836346649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.1.43', '2019-08-02 11:49:44', 16, 2001001000, '服务端发生异常', '2019-08-02 11:49:44');
INSERT INTO `access_log` VALUES (62105, '59.77.15647236566926707', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.13.14.221', '2019-08-02 13:27:37', 10, 0, '', '2019-08-02 13:27:37');
INSERT INTO `access_log` VALUES (62106, '59.78.15647236566936725', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '218.13.14.221', '2019-08-02 13:27:37', 19, 2001001000, '服务端发生异常', '2019-08-02 13:27:37');
INSERT INTO `access_log` VALUES (62107, '64.76.15647236674127017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:27:47', 14, 0, '', '2019-08-02 13:27:47');
INSERT INTO `access_log` VALUES (62108, '64.80.15647236675917023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:27:48', 3, 0, '', '2019-08-02 13:27:48');
INSERT INTO `access_log` VALUES (62109, '64.82.15647236700987033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:27:50', 1, 0, '', '2019-08-02 13:27:50');
INSERT INTO `access_log` VALUES (62110, '64.81.15647236703517017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:27:50', 2, 0, '', '2019-08-02 13:27:50');
INSERT INTO `access_log` VALUES (62111, '64.83.15647236716997013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:27:52', 2, 0, '', '2019-08-02 13:27:52');
INSERT INTO `access_log` VALUES (62112, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:27:52', 6, 0, '', '2019-08-02 13:27:52');
INSERT INTO `access_log` VALUES (62113, '64.77.15647236733147011', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:27:53', 17, 0, '', '2019-08-02 13:27:53');
INSERT INTO `access_log` VALUES (62114, '64.78.15647236794647021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:27:59', 2, 0, '', '2019-08-02 13:27:59');
INSERT INTO `access_log` VALUES (62115, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:27:59', 13, 0, '', '2019-08-02 13:27:59');
INSERT INTO `access_log` VALUES (62116, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:28:01', 5, 0, '', '2019-08-02 13:28:01');
INSERT INTO `access_log` VALUES (62117, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:28:01', 5, 0, '', '2019-08-02 13:28:01');
INSERT INTO `access_log` VALUES (62118, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:28:02', 5, 0, '', '2019-08-02 13:28:02');
INSERT INTO `access_log` VALUES (62119, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:28:03', 7, 0, '', '2019-08-02 13:28:03');
INSERT INTO `access_log` VALUES (62120, '64.84.15647236831147015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:28:03', 2, 0, '', '2019-08-02 13:28:03');
INSERT INTO `access_log` VALUES (62121, '64.79.15647236832497015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:28:03', 2, 0, '', '2019-08-02 13:28:03');
INSERT INTO `access_log` VALUES (62122, '59.71.15647236981856713', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:28:18', 2, 0, '', '2019-08-02 13:28:18');
INSERT INTO `access_log` VALUES (62123, '59.74.15647236981856731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:28:18', 31, 2001001000, '服务端发生异常', '2019-08-02 13:28:18');
INSERT INTO `access_log` VALUES (62124, '64.80.15647237001217025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:28:20', 2, 0, '', '2019-08-02 13:28:20');
INSERT INTO `access_log` VALUES (62125, '64.82.15647237002767035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:28:20', 2, 0, '', '2019-08-02 13:28:20');
INSERT INTO `access_log` VALUES (62126, '64.85.15647237017957053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:28:22', 3, 0, '', '2019-08-02 13:28:22');
INSERT INTO `access_log` VALUES (62127, '64.83.15647237036117015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:28:24', 3, 0, '', '2019-08-02 13:28:24');
INSERT INTO `access_log` VALUES (62128, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:28:24', 5, 0, '', '2019-08-02 13:28:24');
INSERT INTO `access_log` VALUES (62129, '64.77.15647237047457013', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '218.13.14.221', '2019-08-02 13:28:25', 6, 0, '', '2019-08-02 13:28:25');
INSERT INTO `access_log` VALUES (62130, '59.72.15647237416166715', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.207.141', '2019-08-02 13:29:02', 2, 0, '', '2019-08-02 13:29:02');
INSERT INTO `access_log` VALUES (62131, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.207.141', '2019-08-02 13:29:07', 5, 0, '', '2019-08-02 13:29:07');
INSERT INTO `access_log` VALUES (62132, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.89.29.86', '2019-08-02 13:29:33', 6, 0, '', '2019-08-02 13:29:33');
INSERT INTO `access_log` VALUES (62133, '64.81.15647238047677021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.8.179', '2019-08-02 13:30:05', 2, 0, '', '2019-08-02 13:30:05');
INSERT INTO `access_log` VALUES (62134, '64.76.15647238855107023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.207.141', '2019-08-02 13:31:26', 2, 0, '', '2019-08-02 13:31:26');
INSERT INTO `access_log` VALUES (62135, '64.81.15647239233787023', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.129.6.159', '2019-08-02 13:32:03', 8, 0, '', '2019-08-02 13:32:03');
INSERT INTO `access_log` VALUES (62136, '59.71.15647239470006717', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '58.247.206.151', '2019-08-02 13:32:27', 14, 2001001000, '服务端发生异常', '2019-08-02 13:32:27');
INSERT INTO `access_log` VALUES (62137, '64.79.15647239919017021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.91.60.11', '2019-08-02 13:33:12', 4, 0, '', '2019-08-02 13:33:12');
INSERT INTO `access_log` VALUES (62138, '65.50.15647266863579301', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.249.3.229', '2019-08-02 14:18:06', 0, 1002001015, '账号未登陆', '2019-08-02 14:18:06');
INSERT INTO `access_log` VALUES (62139, '65.51.15647266863599375', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.249.3.229', '2019-08-02 14:18:06', 0, 1002001015, '账号未登陆', '2019-08-02 14:18:06');
INSERT INTO `access_log` VALUES (62140, '65.49.15647266863569283', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.249.3.229', '2019-08-02 14:18:06', 0, 1002001015, '账号未登陆', '2019-08-02 14:18:06');
INSERT INTO `access_log` VALUES (62141, '65.45.15647266894379305', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.249.3.229', '2019-08-02 14:18:09', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 14:18:09');
INSERT INTO `access_log` VALUES (62142, '65.54.15647267304119217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.249.3.229', '2019-08-02 14:18:50', 104, 0, '', '2019-08-02 14:18:51');
INSERT INTO `access_log` VALUES (62143, '65.46.15647267308089357', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.249.3.229', '2019-08-02 14:18:51', 14, 0, '', '2019-08-02 14:18:51');
INSERT INTO `access_log` VALUES (62144, '65.3607.15647267308111099', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.249.3.229', '2019-08-02 14:18:51', 13, 2001001000, '服务端发生异常', '2019-08-02 14:18:51');
INSERT INTO `access_log` VALUES (62145, '65.51.15647267308139377', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.249.3.229', '2019-08-02 14:18:51', 14, 0, '', '2019-08-02 14:18:51');
INSERT INTO `access_log` VALUES (62146, '59.72.15647273060196763', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.240.69', '2019-08-02 14:28:26', 16, 0, '', '2019-08-02 14:28:26');
INSERT INTO `access_log` VALUES (62147, '59.78.15647273060206775', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.207.82.170', '2019-08-02 14:28:26', 22, 2001001000, '服务端发生异常', '2019-08-02 14:28:26');
INSERT INTO `access_log` VALUES (62148, '64.80.15647273082857075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.207.82.170', '2019-08-02 14:28:28', 11, 0, '', '2019-08-02 14:28:28');
INSERT INTO `access_log` VALUES (62149, '64.82.15647273084007085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.207.82.170', '2019-08-02 14:28:28', 5, 0, '', '2019-08-02 14:28:28');
INSERT INTO `access_log` VALUES (62150, '64.81.15647273098297069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.207.82.170', '2019-08-02 14:28:30', 4, 0, '', '2019-08-02 14:28:30');
INSERT INTO `access_log` VALUES (62151, '64.85.15647273103317103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.207.82.170', '2019-08-02 14:28:30', 2, 0, '', '2019-08-02 14:28:30');
INSERT INTO `access_log` VALUES (62152, '59.76.15647273111996757', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.207.82.170', '2019-08-02 14:28:31', 3, 0, '', '2019-08-02 14:28:31');
INSERT INTO `access_log` VALUES (62153, '59.77.15647273111996757', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.240.69', '2019-08-02 14:28:31', 17, 2001001000, '服务端发生异常', '2019-08-02 14:28:31');
INSERT INTO `access_log` VALUES (62154, '65.51.15647273202349387', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.169.240.69', '2019-08-02 14:28:40', 1, 1002001015, '账号未登陆', '2019-08-02 14:28:40');
INSERT INTO `access_log` VALUES (62155, '65.3607.15647273202331107', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.206.181.53', '2019-08-02 14:28:40', 1, 1002001015, '账号未登陆', '2019-08-02 14:28:40');
INSERT INTO `access_log` VALUES (62156, '65.50.15647273202379311', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.207.82.170', '2019-08-02 14:28:40', 0, 1002001015, '账号未登陆', '2019-08-02 14:28:40');
INSERT INTO `access_log` VALUES (62157, '65.53.15647273215909311', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.207.82.170', '2019-08-02 14:28:42', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 14:28:42');
INSERT INTO `access_log` VALUES (62158, '65.52.15647273233619363', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.207.82.170', '2019-08-02 14:28:43', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 14:28:43');
INSERT INTO `access_log` VALUES (62159, '65.45.15647273284539315', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=756765765&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.207.82.170', '2019-08-02 14:28:48', 103, 0, '', '2019-08-02 14:28:49');
INSERT INTO `access_log` VALUES (62160, '65.47.15647273287259297', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.207.82.170', '2019-08-02 14:28:49', 15, 0, '', '2019-08-02 14:28:49');
INSERT INTO `access_log` VALUES (62161, '65.49.15647273287279297', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.206.181.53', '2019-08-02 14:28:49', 13, 0, '', '2019-08-02 14:28:49');
INSERT INTO `access_log` VALUES (62162, '65.54.15647273287349227', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.206.181.53', '2019-08-02 14:28:49', 9, 0, '', '2019-08-02 14:28:49');
INSERT INTO `access_log` VALUES (62163, '62.82.15647273330175705', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.206.181.53', '2019-08-02 14:28:53', 379, 0, '', '2019-08-02 14:28:53');
INSERT INTO `access_log` VALUES (62164, '66.53.15647273421104483', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.206.181.53', '2019-08-02 14:29:02', 21, 0, '', '2019-08-02 14:29:02');
INSERT INTO `access_log` VALUES (62165, '59.74.15647273438866781', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.206.181.53', '2019-08-02 14:29:04', 21, 2001001000, '服务端发生异常', '2019-08-02 14:29:04');
INSERT INTO `access_log` VALUES (62166, '64.79.15647273463917067', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.207.82.170', '2019-08-02 14:29:06', 13, 0, '', '2019-08-02 14:29:06');
INSERT INTO `access_log` VALUES (62167, '64.84.15647273463907067', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.206.181.53', '2019-08-02 14:29:06', 17, 0, '', '2019-08-02 14:29:06');
INSERT INTO `access_log` VALUES (62168, '64.76.15647273522147071', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.206.181.53', '2019-08-02 14:29:12', 14, 0, '', '2019-08-02 14:29:12');
INSERT INTO `access_log` VALUES (62169, '65.52.15647274056789365', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.206.181.53', '2019-08-02 14:30:06', 8, 0, '', '2019-08-02 14:30:06');
INSERT INTO `access_log` VALUES (62170, '65.45.15647274056799317', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.206.181.53', '2019-08-02 14:30:06', 10, 0, '', '2019-08-02 14:30:06');
INSERT INTO `access_log` VALUES (62171, '65.49.15647274056819299', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.206.181.53', '2019-08-02 14:30:06', 9, 0, '', '2019-08-02 14:30:06');
INSERT INTO `access_log` VALUES (62172, '64.83.15647274057647067', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '140.206.181.53', '2019-08-02 14:30:06', 12, 0, '', '2019-08-02 14:30:06');
INSERT INTO `access_log` VALUES (62173, '59.79.15647303677036815', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.42.123.49', '2019-08-02 15:19:28', 18, 0, '', '2019-08-02 15:19:28');
INSERT INTO `access_log` VALUES (62174, '59.72.15647303677036805', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.42.123.49', '2019-08-02 15:19:28', 23, 2001001000, '服务端发生异常', '2019-08-02 15:19:28');
INSERT INTO `access_log` VALUES (62175, '64.80.15647303724127117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.42.123.49', '2019-08-02 15:19:32', 12, 0, '', '2019-08-02 15:19:32');
INSERT INTO `access_log` VALUES (62176, '64.85.15647303725457147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.42.123.49', '2019-08-02 15:19:33', 3, 0, '', '2019-08-02 15:19:33');
INSERT INTO `access_log` VALUES (62177, '64.82.15647303738187127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.42.123.49', '2019-08-02 15:19:34', 2, 0, '', '2019-08-02 15:19:34');
INSERT INTO `access_log` VALUES (62178, '64.81.15647303744537113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.42.123.49', '2019-08-02 15:19:34', 2, 0, '', '2019-08-02 15:19:34');
INSERT INTO `access_log` VALUES (62179, '64.78.15647303749547115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '59.42.123.49', '2019-08-02 15:19:35', 2, 0, '', '2019-08-02 15:19:35');
INSERT INTO `access_log` VALUES (62180, '65.51.15647312825919441', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.191.47.53', '2019-08-02 15:34:43', 11, 1002001012, '访问令牌已过期', '2019-08-02 15:34:43');
INSERT INTO `access_log` VALUES (62181, '65.3607.15647312825911163', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.191.47.53', '2019-08-02 15:34:43', 13, 1002001012, '访问令牌已过期', '2019-08-02 15:34:43');
INSERT INTO `access_log` VALUES (62182, '65.50.15647312825919365', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.191.47.53', '2019-08-02 15:34:43', 14, 1002001012, '访问令牌已过期', '2019-08-02 15:34:43');
INSERT INTO `access_log` VALUES (62183, '65.53.15647312842199371', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.191.47.53', '2019-08-02 15:34:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 15:34:44');
INSERT INTO `access_log` VALUES (62184, '65.45.15647313065309369', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.191.47.53', '2019-08-02 15:35:07', 87, 0, '', '2019-08-02 15:35:07');
INSERT INTO `access_log` VALUES (62185, '65.49.15647313068579355', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.191.47.53', '2019-08-02 15:35:07', 12, 0, '', '2019-08-02 15:35:07');
INSERT INTO `access_log` VALUES (62186, '65.54.15647313068579283', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.191.47.53', '2019-08-02 15:35:07', 12, 0, '', '2019-08-02 15:35:07');
INSERT INTO `access_log` VALUES (62187, '65.47.15647313068559351', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.191.47.53', '2019-08-02 15:35:07', 15, 2001001000, '服务端发生异常', '2019-08-02 15:35:07');
INSERT INTO `access_log` VALUES (62188, '65.3607.15647313210931165', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.191.47.53', '2019-08-02 15:35:21', 7, 0, '', '2019-08-02 15:35:21');
INSERT INTO `access_log` VALUES (62189, '65.51.15647313210919443', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.191.47.53', '2019-08-02 15:35:21', 9, 2001001000, '服务端发生异常', '2019-08-02 15:35:21');
INSERT INTO `access_log` VALUES (62190, '65.50.15647313210959367', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.191.47.53', '2019-08-02 15:35:21', 8, 0, '', '2019-08-02 15:35:21');
INSERT INTO `access_log` VALUES (62191, '59.72.15647315303386821', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.21.33.153', '2019-08-02 15:38:50', 4, 0, '', '2019-08-02 15:38:50');
INSERT INTO `access_log` VALUES (62192, '59.79.15647315303366831', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.21.33.153', '2019-08-02 15:38:50', 20, 2001001000, '服务端发生异常', '2019-08-02 15:38:50');
INSERT INTO `access_log` VALUES (62193, '59.78.15647315342106833', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.19.93', '2019-08-02 15:38:54', 14, 2001001000, '服务端发生异常', '2019-08-02 15:38:54');
INSERT INTO `access_log` VALUES (62194, '59.76.15647315345546815', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.19.93', '2019-08-02 15:38:55', 41, 2001001000, '服务端发生异常', '2019-08-02 15:38:55');
INSERT INTO `access_log` VALUES (62195, '59.77.15647315350466815', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.19.93', '2019-08-02 15:38:55', 14, 2001001000, '服务端发生异常', '2019-08-02 15:38:55');
INSERT INTO `access_log` VALUES (62196, '59.73.15647315352796825', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.19.93', '2019-08-02 15:38:55', 19, 2001001000, '服务端发生异常', '2019-08-02 15:38:55');
INSERT INTO `access_log` VALUES (62197, '59.71.15647315354036821', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.19.93', '2019-08-02 15:38:55', 13, 2001001000, '服务端发生异常', '2019-08-02 15:38:55');
INSERT INTO `access_log` VALUES (62198, '59.74.15647315355386839', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Java/1.8.0_222', '117.50.19.93', '2019-08-02 15:38:56', 12, 2001001000, '服务端发生异常', '2019-08-02 15:38:56');
INSERT INTO `access_log` VALUES (62199, '65.46.15647315446709425', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.21.33.153', '2019-08-02 15:39:05', 0, 1002001015, '账号未登陆', '2019-08-02 15:39:05');
INSERT INTO `access_log` VALUES (62200, '65.54.15647315446709287', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.21.33.153', '2019-08-02 15:39:05', 1, 1002001015, '账号未登陆', '2019-08-02 15:39:05');
INSERT INTO `access_log` VALUES (62201, '65.50.15647315447119371', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.21.33.153', '2019-08-02 15:39:05', 0, 1002001015, '账号未登陆', '2019-08-02 15:39:05');
INSERT INTO `access_log` VALUES (62202, '65.3607.15647315471861169', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-08-02 15:39:07', 0, 1002001015, '账号未登陆', '2019-08-02 15:39:07');
INSERT INTO `access_log` VALUES (62203, '65.51.15647315473119447', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.21.33.153', '2019-08-02 15:39:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 15:39:07');
INSERT INTO `access_log` VALUES (62204, '65.53.15647315473279377', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-08-02 15:39:07', 1, 1002001015, '账号未登陆', '2019-08-02 15:39:07');
INSERT INTO `access_log` VALUES (62205, '65.52.15647315474529425', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-08-02 15:39:07', 1, 1002001015, '账号未登陆', '2019-08-02 15:39:07');
INSERT INTO `access_log` VALUES (62206, '65.47.15647315476369357', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.40', '2019-08-02 15:39:08', 0, 1002001015, '账号未登陆', '2019-08-02 15:39:08');
INSERT INTO `access_log` VALUES (62207, '65.45.15647315475789375', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-08-02 15:39:08', 1, 1002001015, '账号未登陆', '2019-08-02 15:39:08');
INSERT INTO `access_log` VALUES (62208, '65.49.15647315477789361', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.40', '2019-08-02 15:39:08', 0, 1002001015, '账号未登陆', '2019-08-02 15:39:08');
INSERT INTO `access_log` VALUES (62209, '65.46.15647315478489427', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-08-02 15:39:08', 1, 1002001015, '账号未登陆', '2019-08-02 15:39:08');
INSERT INTO `access_log` VALUES (62210, '65.54.15647315478779289', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.40', '2019-08-02 15:39:08', 0, 1002001015, '账号未登陆', '2019-08-02 15:39:08');
INSERT INTO `access_log` VALUES (62211, '65.50.15647315479819373', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Java/1.8.0_151', '120.132.59.70', '2019-08-02 15:39:08', 1, 1002001015, '账号未登陆', '2019-08-02 15:39:08');
INSERT INTO `access_log` VALUES (62212, '65.3607.15647315480051171', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.40', '2019-08-02 15:39:08', 1, 1002001015, '账号未登陆', '2019-08-02 15:39:08');
INSERT INTO `access_log` VALUES (62213, '65.53.15647315481029379', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.40', '2019-08-02 15:39:08', 1, 1002001015, '账号未登陆', '2019-08-02 15:39:08');
INSERT INTO `access_log` VALUES (62214, '65.51.15647315482289449', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Java/1.8.0_171', '120.132.59.40', '2019-08-02 15:39:08', 0, 1002001015, '账号未登陆', '2019-08-02 15:39:08');
INSERT INTO `access_log` VALUES (62215, '59.80.15647315531216799', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-08-02 15:39:13', 2, 0, '', '2019-08-02 15:39:13');
INSERT INTO `access_log` VALUES (62216, '59.72.15647315535016823', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-08-02 15:39:14', 2, 0, '', '2019-08-02 15:39:14');
INSERT INTO `access_log` VALUES (62217, '59.79.15647315538256833', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-08-02 15:39:14', 2, 0, '', '2019-08-02 15:39:14');
INSERT INTO `access_log` VALUES (62218, '65.47.15647315538889359', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.21.33.153', '2019-08-02 15:39:14', 80, 0, '', '2019-08-02 15:39:14');
INSERT INTO `access_log` VALUES (62219, '59.78.15647315539786835', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-08-02 15:39:14', 2, 0, '', '2019-08-02 15:39:14');
INSERT INTO `access_log` VALUES (62220, '59.76.15647315540996817', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '117.50.16.248', '2019-08-02 15:39:14', 2, 0, '', '2019-08-02 15:39:14');
INSERT INTO `access_log` VALUES (62221, '59.77.15647315542006817', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Java/1.8.0_181', '117.50.16.248', '2019-08-02 15:39:14', 2, 0, '', '2019-08-02 15:39:14');
INSERT INTO `access_log` VALUES (62222, '65.45.15647315542059377', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.21.33.153', '2019-08-02 15:39:14', 9, 0, '', '2019-08-02 15:39:14');
INSERT INTO `access_log` VALUES (62223, '65.46.15647315542169429', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.21.33.153', '2019-08-02 15:39:14', 15, 0, '', '2019-08-02 15:39:14');
INSERT INTO `access_log` VALUES (62224, '65.49.15647315542149363', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.21.33.153', '2019-08-02 15:39:14', 17, 2001001000, '服务端发生异常', '2019-08-02 15:39:14');
INSERT INTO `access_log` VALUES (62225, '65.54.15647315572319291', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-08-02 15:39:17', 1, 1002001015, '账号未登陆', '2019-08-02 15:39:17');
INSERT INTO `access_log` VALUES (62226, '65.50.15647315573939375', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-08-02 15:39:17', 1, 1002001015, '账号未登陆', '2019-08-02 15:39:17');
INSERT INTO `access_log` VALUES (62227, '65.3607.15647315575461173', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-08-02 15:39:18', 0, 1002001015, '账号未登陆', '2019-08-02 15:39:18');
INSERT INTO `access_log` VALUES (62228, '65.53.15647315577239381', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'HEAD', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-08-02 15:39:18', 1, 1002001015, '账号未登陆', '2019-08-02 15:39:18');
INSERT INTO `access_log` VALUES (62229, '65.51.15647315578739451', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)', '120.132.59.70', '2019-08-02 15:39:18', 1, 1002001015, '账号未登陆', '2019-08-02 15:39:18');
INSERT INTO `access_log` VALUES (62230, '65.52.15647315580189429', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Java/1.8.0_151', '120.132.59.70', '2019-08-02 15:39:18', 0, 1002001015, '账号未登陆', '2019-08-02 15:39:18');
INSERT INTO `access_log` VALUES (62231, '59.80.15647332598046823', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:07:40', 3, 0, '', '2019-08-02 16:07:40');
INSERT INTO `access_log` VALUES (62232, '59.72.15647332598056847', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:07:40', 12, 2001001000, '服务端发生异常', '2019-08-02 16:07:40');
INSERT INTO `access_log` VALUES (62233, '64.83.15647332660027149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:07:46', 15, 0, '', '2019-08-02 16:07:46');
INSERT INTO `access_log` VALUES (62234, '64.76.15647332661387151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:07:46', 3, 0, '', '2019-08-02 16:07:46');
INSERT INTO `access_log` VALUES (62235, '64.80.15647332691567157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:07:49', 2, 0, '', '2019-08-02 16:07:49');
INSERT INTO `access_log` VALUES (62236, '64.82.15647332706617167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:07:51', 2, 0, '', '2019-08-02 16:07:51');
INSERT INTO `access_log` VALUES (62237, '64.81.15647332724817153', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:07:52', 2, 0, '', '2019-08-02 16:07:52');
INSERT INTO `access_log` VALUES (62238, '59.78.15647332739956859', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:07:54', 2, 0, '', '2019-08-02 16:07:54');
INSERT INTO `access_log` VALUES (62239, '59.76.15647332739966841', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:07:54', 12, 2001001000, '服务端发生异常', '2019-08-02 16:07:54');
INSERT INTO `access_log` VALUES (62240, '59.77.15647332795196841', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:00', 18, 0, '', '2019-08-02 16:08:00');
INSERT INTO `access_log` VALUES (62241, '59.73.15647332795206851', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:00', 18, 2001001000, '服务端发生异常', '2019-08-02 16:08:00');
INSERT INTO `access_log` VALUES (62242, '66.49.15647332948834563', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15600391790', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:15', 89, 0, '', '2019-08-02 16:08:15');
INSERT INTO `access_log` VALUES (62243, '66.56.15647333038344583', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15600391790&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:24', 150, 0, '', '2019-08-02 16:08:24');
INSERT INTO `access_log` VALUES (62244, '65.53.15647333091789405', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.86.59.214', '2019-08-02 16:08:29', 1, 1002001015, '账号未登陆', '2019-08-02 16:08:29');
INSERT INTO `access_log` VALUES (62245, '65.51.15647333091819475', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.86.59.214', '2019-08-02 16:08:29', 1, 1002001015, '账号未登陆', '2019-08-02 16:08:29');
INSERT INTO `access_log` VALUES (62246, '65.52.15647333091819453', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.86.59.214', '2019-08-02 16:08:29', 1, 1002001015, '账号未登陆', '2019-08-02 16:08:29');
INSERT INTO `access_log` VALUES (62247, '66.50.15647333143894567', 189, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:34', 6, 0, '', '2019-08-02 16:08:34');
INSERT INTO `access_log` VALUES (62248, '66.54.15647333156374575', 189, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:36', 4, 0, '', '2019-08-02 16:08:36');
INSERT INTO `access_log` VALUES (62249, '66.55.15647333190534549', 189, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:39', 6, 0, '', '2019-08-02 16:08:39');
INSERT INTO `access_log` VALUES (62250, '65.49.15647333212519389', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.86.59.214', '2019-08-02 16:08:41', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 16:08:41');
INSERT INTO `access_log` VALUES (62251, '64.83.15647333233657151', 189, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:43', 6, 0, '', '2019-08-02 16:08:43');
INSERT INTO `access_log` VALUES (62252, '64.80.15647333235387159', 189, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:44', 6, 0, '', '2019-08-02 16:08:44');
INSERT INTO `access_log` VALUES (62253, '64.82.15647333250957169', 189, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:45', 6, 0, '', '2019-08-02 16:08:45');
INSERT INTO `access_log` VALUES (62254, '64.78.15647333257607157', 189, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:46', 5, 0, '', '2019-08-02 16:08:46');
INSERT INTO `access_log` VALUES (62255, '66.53.15647333267964565', 189, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:47', 8, 0, '', '2019-08-02 16:08:47');
INSERT INTO `access_log` VALUES (62256, '65.45.15647333269579403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.86.59.214', '2019-08-02 16:08:47', 89, 0, '', '2019-08-02 16:08:47');
INSERT INTO `access_log` VALUES (62257, '65.46.15647333276199455', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.86.59.214', '2019-08-02 16:08:48', 11, 0, '', '2019-08-02 16:08:48');
INSERT INTO `access_log` VALUES (62258, '65.54.15647333276199317', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.86.59.214', '2019-08-02 16:08:48', 11, 2001001000, '服务端发生异常', '2019-08-02 16:08:48');
INSERT INTO `access_log` VALUES (62259, '59.79.15647333276286859', 189, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:48', 5, 0, '', '2019-08-02 16:08:48');
INSERT INTO `access_log` VALUES (62260, '65.50.15647333276339401', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '125.86.59.214', '2019-08-02 16:08:48', 10, 0, '', '2019-08-02 16:08:48');
INSERT INTO `access_log` VALUES (62261, '59.76.15647333276336843', 189, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:48', 16, 2001001000, '服务端发生异常', '2019-08-02 16:08:48');
INSERT INTO `access_log` VALUES (62262, '64.77.15647333350057147', 189, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:55', 8, 0, '', '2019-08-02 16:08:55');
INSERT INTO `access_log` VALUES (62263, '64.84.15647333351337153', 189, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:08:55', 5, 0, '', '2019-08-02 16:08:55');
INSERT INTO `access_log` VALUES (62264, '59.73.15647333403316853', 189, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:09:00', 11, 0, '', '2019-08-02 16:09:00');
INSERT INTO `access_log` VALUES (62265, '59.77.15647333403286843', 189, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:09:00', 22, 2001001000, '服务端发生异常', '2019-08-02 16:09:00');
INSERT INTO `access_log` VALUES (62266, '65.51.15647333602369477', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:09:20', 0, 1002001015, '账号未登陆', '2019-08-02 16:09:20');
INSERT INTO `access_log` VALUES (62267, '65.53.15647333602549407', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:09:20', 0, 1002001015, '账号未登陆', '2019-08-02 16:09:20');
INSERT INTO `access_log` VALUES (62268, '65.47.15647333602709387', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:09:20', 0, 1002001015, '账号未登陆', '2019-08-02 16:09:20');
INSERT INTO `access_log` VALUES (62269, '65.45.15647333657049405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:09:26', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 16:09:26');
INSERT INTO `access_log` VALUES (62270, '65.54.15647333707369319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:09:31', 216, 0, '', '2019-08-02 16:09:31');
INSERT INTO `access_log` VALUES (62271, '65.50.15647333712539403', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:09:31', 15, 0, '', '2019-08-02 16:09:31');
INSERT INTO `access_log` VALUES (62272, '65.46.15647333712609457', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:09:31', 10, 2001001000, '服务端发生异常', '2019-08-02 16:09:31');
INSERT INTO `access_log` VALUES (62273, '65.3607.15647333712671201', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:09:31', 7, 0, '', '2019-08-02 16:09:31');
INSERT INTO `access_log` VALUES (62274, '59.77.15647334454476845', 189, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:10:45', 6, 0, '', '2019-08-02 16:10:45');
INSERT INTO `access_log` VALUES (62275, '59.71.15647334454486851', 189, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:10:45', 22, 2001001000, '服务端发生异常', '2019-08-02 16:10:45');
INSERT INTO `access_log` VALUES (62276, '65.54.15647334630259321', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:11:03', 9, 0, '', '2019-08-02 16:11:03');
INSERT INTO `access_log` VALUES (62277, '65.50.15647334630339405', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:11:03', 18, 2001001000, '服务端发生异常', '2019-08-02 16:11:03');
INSERT INTO `access_log` VALUES (62278, '65.3607.15647334630471203', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:11:03', 8, 0, '', '2019-08-02 16:11:03');
INSERT INTO `access_log` VALUES (62279, '65.52.15647334755319459', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:11:16', 261, 0, '', '2019-08-02 16:11:16');
INSERT INTO `access_log` VALUES (62280, '65.51.15647334760239481', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:11:16', 8, 0, '', '2019-08-02 16:11:16');
INSERT INTO `access_log` VALUES (62281, '65.53.15647334760319411', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:11:16', 9, 2001001000, '服务端发生异常', '2019-08-02 16:11:16');
INSERT INTO `access_log` VALUES (62282, '65.47.15647334760339391', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '101.254.234.184', '2019-08-02 16:11:16', 10, 0, '', '2019-08-02 16:11:16');
INSERT INTO `access_log` VALUES (62283, '59.79.15647339583886869', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:18', 3, 0, '', '2019-08-02 16:19:18');
INSERT INTO `access_log` VALUES (62284, '59.76.15647339583926853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:18', 13, 2001001000, '服务端发生异常', '2019-08-02 16:19:18');
INSERT INTO `access_log` VALUES (62285, '64.80.15647339642007169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:24', 4, 0, '', '2019-08-02 16:19:24');
INSERT INTO `access_log` VALUES (62286, '64.85.15647339643017199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:24', 2, 0, '', '2019-08-02 16:19:24');
INSERT INTO `access_log` VALUES (62287, '64.82.15647339654907179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:25', 2, 0, '', '2019-08-02 16:19:25');
INSERT INTO `access_log` VALUES (62288, '64.81.15647339661147165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:26', 1, 0, '', '2019-08-02 16:19:26');
INSERT INTO `access_log` VALUES (62289, '64.78.15647339673867167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:27', 2, 0, '', '2019-08-02 16:19:27');
INSERT INTO `access_log` VALUES (62290, '59.73.15647339694686863', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:29', 2, 0, '', '2019-08-02 16:19:29');
INSERT INTO `access_log` VALUES (62291, '59.71.15647339694696859', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:29', 12, 2001001000, '服务端发生异常', '2019-08-02 16:19:29');
INSERT INTO `access_log` VALUES (62292, '66.57.15647339834284581', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13138570323', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:43', 79, 0, '', '2019-08-02 16:19:44');
INSERT INTO `access_log` VALUES (62293, '66.50.15647339855084577', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13138570323&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:46', 220, 0, '', '2019-08-02 16:19:46');
INSERT INTO `access_log` VALUES (62294, '59.80.15647339965186837', 190, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:57', 5, 0, '', '2019-08-02 16:19:57');
INSERT INTO `access_log` VALUES (62295, '59.79.15647339965216871', 190, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:57', 18, 2001001000, '服务端发生异常', '2019-08-02 16:19:57');
INSERT INTO `access_log` VALUES (62296, '64.83.15647339974807163', 190, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:57', 5, 0, '', '2019-08-02 16:19:57');
INSERT INTO `access_log` VALUES (62297, '64.80.15647339976577171', 190, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:58', 5, 0, '', '2019-08-02 16:19:58');
INSERT INTO `access_log` VALUES (62298, '59.76.15647339981706855', 190, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:58', 6, 0, '', '2019-08-02 16:19:58');
INSERT INTO `access_log` VALUES (62299, '59.78.15647339981706873', 190, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:19:58', 15, 2001001000, '服务端发生异常', '2019-08-02 16:19:58');
INSERT INTO `access_log` VALUES (62300, '65.46.15647340063209467', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:20:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 16:20:06');
INSERT INTO `access_log` VALUES (62301, '65.47.15647340199649399', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:20:20', 83, 0, '', '2019-08-02 16:20:20');
INSERT INTO `access_log` VALUES (62302, '65.51.15647340203589489', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:20:20', 17, 0, '', '2019-08-02 16:20:20');
INSERT INTO `access_log` VALUES (62303, '65.53.15647340203589419', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:20:20', 19, 2001001000, '服务端发生异常', '2019-08-02 16:20:20');
INSERT INTO `access_log` VALUES (62304, '65.49.15647340203909403', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.175', '2019-08-02 16:20:20', 10, 0, '', '2019-08-02 16:20:20');
INSERT INTO `access_log` VALUES (62305, '65.50.15647365943039449', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.33.248.251', '2019-08-02 17:03:14', 0, 1002001015, '账号未登陆', '2019-08-02 17:03:14');
INSERT INTO `access_log` VALUES (62306, '65.3607.15647365943031247', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.33.248.251', '2019-08-02 17:03:14', 0, 1002001015, '账号未登陆', '2019-08-02 17:03:14');
INSERT INTO `access_log` VALUES (62307, '65.46.15647365943049503', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.33.248.251', '2019-08-02 17:03:14', 0, 1002001015, '账号未登陆', '2019-08-02 17:03:14');
INSERT INTO `access_log` VALUES (62308, '65.47.15647366065289435', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.33.248.251', '2019-08-02 17:03:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 17:03:27');
INSERT INTO `access_log` VALUES (62309, '65.3607.15647367012601249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.33.248.251', '2019-08-02 17:05:01', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 17:05:01');
INSERT INTO `access_log` VALUES (62310, '65.50.15647367074259451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.33.248.251', '2019-08-02 17:05:07', 77, 0, '', '2019-08-02 17:05:08');
INSERT INTO `access_log` VALUES (62311, '65.52.15647367080229505', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.33.248.251', '2019-08-02 17:05:08', 12, 0, '', '2019-08-02 17:05:08');
INSERT INTO `access_log` VALUES (62312, '65.47.15647367080229437', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.33.248.251', '2019-08-02 17:05:08', 13, 2001001000, '服务端发生异常', '2019-08-02 17:05:08');
INSERT INTO `access_log` VALUES (62313, '65.53.15647367080299457', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.33.248.251', '2019-08-02 17:05:08', 10, 0, '', '2019-08-02 17:05:08');
INSERT INTO `access_log` VALUES (62314, '65.53.15647393617169493', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:49:22', 0, 1002001015, '账号未登陆', '2019-08-02 17:49:22');
INSERT INTO `access_log` VALUES (62315, '65.52.15647393617199541', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:49:22', 0, 1002001015, '账号未登陆', '2019-08-02 17:49:22');
INSERT INTO `access_log` VALUES (62316, '65.47.15647393618329473', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:49:22', 1, 1002001015, '账号未登陆', '2019-08-02 17:49:22');
INSERT INTO `access_log` VALUES (62317, '65.51.15647393641139563', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:49:24', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 17:49:24');
INSERT INTO `access_log` VALUES (62318, '65.45.15647393736789491', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:49:34', 60, 0, '', '2019-08-02 17:49:34');
INSERT INTO `access_log` VALUES (62319, '65.54.15647393742149405', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:49:34', 169, 0, '', '2019-08-02 17:49:34');
INSERT INTO `access_log` VALUES (62320, '65.3607.15647393742631287', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:49:34', 121, 0, '', '2019-08-02 17:49:34');
INSERT INTO `access_log` VALUES (62321, '65.46.15647393742589543', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:49:34', 127, 2001001000, '服务端发生异常', '2019-08-02 17:49:34');
INSERT INTO `access_log` VALUES (62322, '59.78.15647393852286945', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:49:45', 10, 0, '', '2019-08-02 17:49:45');
INSERT INTO `access_log` VALUES (62323, '59.73.15647393852286937', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:49:45', 15, 2001001000, '服务端发生异常', '2019-08-02 17:49:45');
INSERT INTO `access_log` VALUES (62324, '64.85.15647393882237273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:49:48', 10, 0, '', '2019-08-02 17:49:48');
INSERT INTO `access_log` VALUES (62325, '64.80.15647393883327243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:49:48', 2, 0, '', '2019-08-02 17:49:48');
INSERT INTO `access_log` VALUES (62326, '64.78.15647393913987241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:49:51', 1, 0, '', '2019-08-02 17:49:51');
INSERT INTO `access_log` VALUES (62327, '64.81.15647393915377239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:49:52', 1, 0, '', '2019-08-02 17:49:52');
INSERT INTO `access_log` VALUES (62328, '59.76.15647394938016929', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:51:34', 4, 0, '', '2019-08-02 17:51:34');
INSERT INTO `access_log` VALUES (62329, '59.73.15647394938016939', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:51:34', 14, 2001001000, '服务端发生异常', '2019-08-02 17:51:34');
INSERT INTO `access_log` VALUES (62330, '65.51.15647395860919567', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:53:06', 11, 0, '', '2019-08-02 17:53:06');
INSERT INTO `access_log` VALUES (62331, '65.45.15647395860919495', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:53:06', 11, 0, '', '2019-08-02 17:53:06');
INSERT INTO `access_log` VALUES (62332, '65.49.15647395860919481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '60.173.236.5', '2019-08-02 17:53:06', 13, 2001001000, '服务端发生异常', '2019-08-02 17:53:06');
INSERT INTO `access_log` VALUES (62333, '65.49.15647396963639483', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:54:56', 0, 1002001015, '账号未登陆', '2019-08-02 17:54:56');
INSERT INTO `access_log` VALUES (62334, '65.45.15647396963679497', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:54:56', 1, 1002001015, '账号未登陆', '2019-08-02 17:54:56');
INSERT INTO `access_log` VALUES (62335, '65.54.15647396963679411', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:54:56', 0, 1002001015, '账号未登陆', '2019-08-02 17:54:56');
INSERT INTO `access_log` VALUES (62336, '65.3607.15647397000341293', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:00', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 17:55:00');
INSERT INTO `access_log` VALUES (62337, '65.46.15647397040149549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 17:55:04');
INSERT INTO `access_log` VALUES (62338, '65.52.15647397186789549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:19', 63, 0, '', '2019-08-02 17:55:19');
INSERT INTO `access_log` VALUES (62339, '65.53.15647397190239501', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:19', 9, 0, '', '2019-08-02 17:55:19');
INSERT INTO `access_log` VALUES (62340, '65.51.15647397190289571', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:19', 9, 0, '', '2019-08-02 17:55:19');
INSERT INTO `access_log` VALUES (62341, '65.47.15647397190279481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:19', 10, 2001001000, '服务端发生异常', '2019-08-02 17:55:19');
INSERT INTO `access_log` VALUES (62342, '65.49.15647397274389485', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:27', 8, 0, '', '2019-08-02 17:55:27');
INSERT INTO `access_log` VALUES (62343, '65.54.15647397274389413', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:27', 8, 0, '', '2019-08-02 17:55:27');
INSERT INTO `access_log` VALUES (62344, '65.3607.15647397274381295', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:27', 8, 2001001000, '服务端发生异常', '2019-08-02 17:55:27');
INSERT INTO `access_log` VALUES (62345, '65.50.15647397459849497', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:46', 9, 0, '', '2019-08-02 17:55:46');
INSERT INTO `access_log` VALUES (62346, '65.47.15647397460409483', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:46', 9, 0, '', '2019-08-02 17:55:46');
INSERT INTO `access_log` VALUES (62347, '65.52.15647397460399551', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:46', 11, 2001001000, '服务端发生异常', '2019-08-02 17:55:46');
INSERT INTO `access_log` VALUES (62348, '65.53.15647397508139503', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:51', 9, 0, '', '2019-08-02 17:55:51');
INSERT INTO `access_log` VALUES (62349, '65.45.15647397508139501', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:51', 10, 0, '', '2019-08-02 17:55:51');
INSERT INTO `access_log` VALUES (62350, '65.51.15647397508139573', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.63.203.35', '2019-08-02 17:55:51', 10, 2001001000, '服务端发生异常', '2019-08-02 17:55:51');
INSERT INTO `access_log` VALUES (62351, '65.47.15647435620859537', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.115.76.206', '2019-08-02 18:59:22', 5, 1002001015, '账号未登陆', '2019-08-02 18:59:22');
INSERT INTO `access_log` VALUES (62352, '65.46.15647435620859603', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.115.76.206', '2019-08-02 18:59:22', 1, 1002001015, '账号未登陆', '2019-08-02 18:59:22');
INSERT INTO `access_log` VALUES (62353, '65.50.15647435620859551', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.115.76.206', '2019-08-02 18:59:22', 1, 1002001015, '账号未登陆', '2019-08-02 18:59:22');
INSERT INTO `access_log` VALUES (62354, '65.45.15647435661489553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.115.76.206', '2019-08-02 18:59:26', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 18:59:26');
INSERT INTO `access_log` VALUES (62355, '65.53.15647435699549553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.115.76.206', '2019-08-02 18:59:30', 94, 0, '', '2019-08-02 18:59:30');
INSERT INTO `access_log` VALUES (62356, '65.54.15647435702299469', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.115.76.206', '2019-08-02 18:59:30', 11, 0, '', '2019-08-02 18:59:30');
INSERT INTO `access_log` VALUES (62357, '65.49.15647435702259541', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.115.76.206', '2019-08-02 18:59:30', 16, 2001001000, '服务端发生异常', '2019-08-02 18:59:30');
INSERT INTO `access_log` VALUES (62358, '65.51.15647435702249625', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.115.76.206', '2019-08-02 18:59:30', 18, 0, '', '2019-08-02 18:59:30');
INSERT INTO `access_log` VALUES (62359, '65.50.15647435879469553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.115.76.206', '2019-08-02 18:59:48', 11, 0, '', '2019-08-02 18:59:48');
INSERT INTO `access_log` VALUES (62360, '65.47.15647435879479539', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.115.76.206', '2019-08-02 18:59:48', 13, 2001001000, '服务端发生异常', '2019-08-02 18:59:48');
INSERT INTO `access_log` VALUES (62361, '65.46.15647435879529605', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.115.76.206', '2019-08-02 18:59:48', 9, 0, '', '2019-08-02 18:59:48');
INSERT INTO `access_log` VALUES (62362, '59.77.15647452141317005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '139.227.85.82', '2019-08-02 19:26:54', 13, 0, '', '2019-08-02 19:26:54');
INSERT INTO `access_log` VALUES (62363, '59.74.15647452141317029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '139.227.85.82', '2019-08-02 19:26:54', 26, 2001001000, '服务端发生异常', '2019-08-02 19:26:54');
INSERT INTO `access_log` VALUES (62364, '59.80.15647452501646989', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '139.227.85.82', '2019-08-02 19:27:30', 3, 0, '', '2019-08-02 19:27:30');
INSERT INTO `access_log` VALUES (62365, '59.79.15647452501647023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '139.227.85.82', '2019-08-02 19:27:30', 15, 2001001000, '服务端发生异常', '2019-08-02 19:27:30');
INSERT INTO `access_log` VALUES (62366, '59.78.15647452717157025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:27:52', 2, 0, '', '2019-08-02 19:27:52');
INSERT INTO `access_log` VALUES (62367, '59.71.15647452717187013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:27:52', 10, 2001001000, '服务端发生异常', '2019-08-02 19:27:52');
INSERT INTO `access_log` VALUES (62368, '64.79.15647452767557313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:27:57', 47, 0, '', '2019-08-02 19:27:57');
INSERT INTO `access_log` VALUES (62369, '64.84.15647452769467315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:27:57', 3, 0, '', '2019-08-02 19:27:57');
INSERT INTO `access_log` VALUES (62370, '64.76.15647452781697317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:27:58', 1, 0, '', '2019-08-02 19:27:58');
INSERT INTO `access_log` VALUES (62371, '64.85.15647452790367353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:27:59', 1, 0, '', '2019-08-02 19:27:59');
INSERT INTO `access_log` VALUES (62372, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:00', 6, 0, '', '2019-08-02 19:28:00');
INSERT INTO `access_log` VALUES (62373, '64.80.15647452796617323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:00', 2, 0, '', '2019-08-02 19:28:00');
INSERT INTO `access_log` VALUES (62374, '64.82.15647452807797333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:01', 2, 0, '', '2019-08-02 19:28:01');
INSERT INTO `access_log` VALUES (62375, '64.78.15647452809067321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:01', 3, 0, '', '2019-08-02 19:28:01');
INSERT INTO `access_log` VALUES (62376, '64.81.15647452813197319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:01', 2, 0, '', '2019-08-02 19:28:01');
INSERT INTO `access_log` VALUES (62377, '64.83.15647452817577317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:02', 2, 0, '', '2019-08-02 19:28:02');
INSERT INTO `access_log` VALUES (62378, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:02', 5, 0, '', '2019-08-02 19:28:02');
INSERT INTO `access_log` VALUES (62379, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:03', 5, 0, '', '2019-08-02 19:28:03');
INSERT INTO `access_log` VALUES (62380, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:03', 5, 0, '', '2019-08-02 19:28:03');
INSERT INTO `access_log` VALUES (62381, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:03', 5, 0, '', '2019-08-02 19:28:03');
INSERT INTO `access_log` VALUES (62382, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:04', 6, 0, '', '2019-08-02 19:28:04');
INSERT INTO `access_log` VALUES (62383, '64.77.15647452840327311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:04', 2, 0, '', '2019-08-02 19:28:04');
INSERT INTO `access_log` VALUES (62384, '64.79.15647452841297315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:04', 2, 0, '', '2019-08-02 19:28:04');
INSERT INTO `access_log` VALUES (62385, '64.84.15647452845537317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:05', 10, 0, '', '2019-08-02 19:28:05');
INSERT INTO `access_log` VALUES (62386, '64.76.15647452848917319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:05', 2, 0, '', '2019-08-02 19:28:05');
INSERT INTO `access_log` VALUES (62387, '66.52.15647452935394721', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17521698619', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:14', 91, 0, '', '2019-08-02 19:28:14');
INSERT INTO `access_log` VALUES (62388, '66.51.15647453010634751', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17521698619&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:21', 202, 0, '', '2019-08-02 19:28:21');
INSERT INTO `access_log` VALUES (62389, '64.78.15647453054857323', 191, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:25', 7, 0, '', '2019-08-02 19:28:25');
INSERT INTO `access_log` VALUES (62390, '64.83.15647453056507319', 191, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:26', 8, 0, '', '2019-08-02 19:28:26');
INSERT INTO `access_log` VALUES (62391, '66.57.15647453064404733', 191, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:26', 6, 0, '', '2019-08-02 19:28:26');
INSERT INTO `access_log` VALUES (62392, '66.48.15647453072724741', 191, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:27', 6, 0, '', '2019-08-02 19:28:27');
INSERT INTO `access_log` VALUES (62393, '66.55.15647453086964711', 191, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:29', 6, 0, '', '2019-08-02 19:28:29');
INSERT INTO `access_log` VALUES (62394, '59.72.15647453107437015', 191, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:31', 10, 0, '', '2019-08-02 19:28:31');
INSERT INTO `access_log` VALUES (62395, '66.52.15647453116124723', 191, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:32', 6, 0, '', '2019-08-02 19:28:32');
INSERT INTO `access_log` VALUES (62396, '66.51.15647453144664753', 191, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:34', 6, 0, '', '2019-08-02 19:28:34');
INSERT INTO `access_log` VALUES (62397, '59.78.15647453155167027', 191, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:36', 8, 0, '', '2019-08-02 19:28:36');
INSERT INTO `access_log` VALUES (62398, '59.73.15647453155137019', 191, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:36', 20, 2001001000, '服务端发生异常', '2019-08-02 19:28:36');
INSERT INTO `access_log` VALUES (62399, '64.84.15647453168597319', 191, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:37', 6, 0, '', '2019-08-02 19:28:37');
INSERT INTO `access_log` VALUES (62400, '64.85.15647453169867357', 191, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:37', 5, 0, '', '2019-08-02 19:28:37');
INSERT INTO `access_log` VALUES (62401, '64.82.15647453176337337', 191, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:38', 6, 0, '', '2019-08-02 19:28:38');
INSERT INTO `access_log` VALUES (62402, '64.81.15647453183187323', 191, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:38', 6, 0, '', '2019-08-02 19:28:38');
INSERT INTO `access_log` VALUES (62403, 'N/A', 191, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:38', 10, 0, '', '2019-08-02 19:28:38');
INSERT INTO `access_log` VALUES (62404, '64.77.15647453191517315', 191, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:39', 12, 0, '', '2019-08-02 19:28:39');
INSERT INTO `access_log` VALUES (62405, '66.50.15647453236314731', 191, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '139.227.85.82', '2019-08-02 19:28:44', 6, 0, '', '2019-08-02 19:28:44');
INSERT INTO `access_log` VALUES (62406, '59.78.15647522017427119', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.121.218.66', '2019-08-02 21:23:22', 14, 0, '', '2019-08-02 21:23:22');
INSERT INTO `access_log` VALUES (62407, '59.71.15647522017467107', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.121.218.66', '2019-08-02 21:23:22', 14, 2001001000, '服务端发生异常', '2019-08-02 21:23:22');
INSERT INTO `access_log` VALUES (62408, '59.75.15647522358657123', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.121.218.66', '2019-08-02 21:23:56', 3, 0, '', '2019-08-02 21:23:56');
INSERT INTO `access_log` VALUES (62409, '59.72.15647522358697109', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.121.218.66', '2019-08-02 21:23:56', 16, 2001001000, '服务端发生异常', '2019-08-02 21:23:56');
INSERT INTO `access_log` VALUES (62410, '64.84.15647522397627413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.121.218.66', '2019-08-02 21:24:00', 195, 0, '', '2019-08-02 21:24:00');
INSERT INTO `access_log` VALUES (62411, '64.76.15647522401077415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.121.218.66', '2019-08-02 21:24:00', 3, 0, '', '2019-08-02 21:24:00');
INSERT INTO `access_log` VALUES (62412, '66.54.15647522446714831', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.121.218.66', '2019-08-02 21:24:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-08-02 21:24:05');
INSERT INTO `access_log` VALUES (62413, '59.75.15647525230627127', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.211.183', '2019-08-02 21:28:43', 3, 0, '', '2019-08-02 21:28:43');
INSERT INTO `access_log` VALUES (62414, '59.80.15647525230637089', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.211.183', '2019-08-02 21:28:43', 21, 2001001000, '服务端发生异常', '2019-08-02 21:28:43');
INSERT INTO `access_log` VALUES (62415, '65.50.15647525290079673', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.211.183', '2019-08-02 21:28:49', 1, 1002001015, '账号未登陆', '2019-08-02 21:28:49');
INSERT INTO `access_log` VALUES (62416, '65.46.15647525290079725', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.211.183', '2019-08-02 21:28:49', 0, 1002001015, '账号未登陆', '2019-08-02 21:28:49');
INSERT INTO `access_log` VALUES (62417, '65.3607.15647525290071471', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.211.183', '2019-08-02 21:28:49', 1, 1002001015, '账号未登陆', '2019-08-02 21:28:49');
INSERT INTO `access_log` VALUES (62418, '65.52.15647525366179725', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.211.183', '2019-08-02 21:28:57', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 21:28:57');
INSERT INTO `access_log` VALUES (62419, '65.45.15647525389349675', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.211.183', '2019-08-02 21:28:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 21:28:59');
INSERT INTO `access_log` VALUES (62420, '65.49.15647525585529663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.211.183', '2019-08-02 21:29:19', 792, 0, '', '2019-08-02 21:29:19');
INSERT INTO `access_log` VALUES (62421, '65.54.15647525596269591', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.211.183', '2019-08-02 21:29:20', 12, 0, '', '2019-08-02 21:29:20');
INSERT INTO `access_log` VALUES (62422, '65.51.15647525596319747', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.211.183', '2019-08-02 21:29:20', 11, 2001001000, '服务端发生异常', '2019-08-02 21:29:20');
INSERT INTO `access_log` VALUES (62423, '65.3607.15647525596341473', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.211.183', '2019-08-02 21:29:20', 11, 0, '', '2019-08-02 21:29:20');
INSERT INTO `access_log` VALUES (62424, '65.46.15647525714199727', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.211.183', '2019-08-02 21:29:31', 11, 0, '', '2019-08-02 21:29:31');
INSERT INTO `access_log` VALUES (62425, '65.47.15647525714219661', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.211.183', '2019-08-02 21:29:31', 12, 2001001000, '服务端发生异常', '2019-08-02 21:29:31');
INSERT INTO `access_log` VALUES (62426, '65.52.15647525714249727', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '221.221.211.183', '2019-08-02 21:29:31', 16, 0, '', '2019-08-02 21:29:31');
INSERT INTO `access_log` VALUES (62427, '59.74.15647527495887133', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.174.28', '2019-08-02 21:32:30', 3, 0, '', '2019-08-02 21:32:30');
INSERT INTO `access_log` VALUES (62428, '59.77.15647527495887109', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.174.28', '2019-08-02 21:32:30', 33, 2001001000, '服务端发生异常', '2019-08-02 21:32:30');
INSERT INTO `access_log` VALUES (62429, '65.53.15647540654499697', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.174.28', '2019-08-02 21:54:25', 1, 1002001015, '账号未登陆', '2019-08-02 21:54:25');
INSERT INTO `access_log` VALUES (62430, '65.45.15647540654489697', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.174.28', '2019-08-02 21:54:25', 1, 1002001015, '账号未登陆', '2019-08-02 21:54:25');
INSERT INTO `access_log` VALUES (62431, '65.49.15647540654499685', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.174.28', '2019-08-02 21:54:25', 0, 1002001015, '账号未登陆', '2019-08-02 21:54:25');
INSERT INTO `access_log` VALUES (62432, '65.3607.15647540708961495', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.174.28', '2019-08-02 21:54:31', 214, 0, '', '2019-08-02 21:54:31');
INSERT INTO `access_log` VALUES (62433, '65.51.15647540713129769', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.174.28', '2019-08-02 21:54:31', 11, 0, '', '2019-08-02 21:54:31');
INSERT INTO `access_log` VALUES (62434, '65.54.15647540713169613', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.174.28', '2019-08-02 21:54:31', 10, 2001001000, '服务端发生异常', '2019-08-02 21:54:31');
INSERT INTO `access_log` VALUES (62435, '65.50.15647540713219697', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.193.174.28', '2019-08-02 21:54:31', 9, 0, '', '2019-08-02 21:54:31');
INSERT INTO `access_log` VALUES (62436, '65.54.15647583737619671', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.234.223.38', '2019-08-02 23:06:14', 0, 1002001015, '账号未登陆', '2019-08-02 23:06:14');
INSERT INTO `access_log` VALUES (62437, '65.50.15647583737619755', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.234.223.38', '2019-08-02 23:06:14', 0, 1002001015, '账号未登陆', '2019-08-02 23:06:14');
INSERT INTO `access_log` VALUES (62438, '65.51.15647583737639827', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.234.223.38', '2019-08-02 23:06:14', 0, 1002001015, '账号未登陆', '2019-08-02 23:06:14');
INSERT INTO `access_log` VALUES (62439, '65.47.15647583825969741', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.234.223.38', '2019-08-02 23:06:23', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 23:06:23');
INSERT INTO `access_log` VALUES (62440, '65.52.15647583916649807', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.234.223.38', '2019-08-02 23:06:32', 92, 0, '', '2019-08-02 23:06:32');
INSERT INTO `access_log` VALUES (62441, '65.53.15647583929319757', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.234.223.38', '2019-08-02 23:06:33', 14, 0, '', '2019-08-02 23:06:33');
INSERT INTO `access_log` VALUES (62442, '65.49.15647583929359745', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.234.223.38', '2019-08-02 23:06:33', 12, 0, '', '2019-08-02 23:06:33');
INSERT INTO `access_log` VALUES (62443, '65.45.15647583929379757', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.234.223.38', '2019-08-02 23:06:33', 11, 2001001000, '服务端发生异常', '2019-08-02 23:06:33');
INSERT INTO `access_log` VALUES (62444, '65.53.15647585107489759', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.89.49.217', '2019-08-02 23:08:31', 1, 1002001015, '账号未登陆', '2019-08-02 23:08:31');
INSERT INTO `access_log` VALUES (62445, '65.45.15647585107509759', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.89.49.217', '2019-08-02 23:08:31', 0, 1002001015, '账号未登陆', '2019-08-02 23:08:31');
INSERT INTO `access_log` VALUES (62446, '65.3607.15647585107581557', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.89.49.217', '2019-08-02 23:08:31', 1, 1002001015, '账号未登陆', '2019-08-02 23:08:31');
INSERT INTO `access_log` VALUES (62447, '65.51.15647585139659831', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.89.49.217', '2019-08-02 23:08:34', 68, 0, '', '2019-08-02 23:08:34');
INSERT INTO `access_log` VALUES (62448, '65.54.15647585142289675', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.89.49.217', '2019-08-02 23:08:34', 7, 0, '', '2019-08-02 23:08:34');
INSERT INTO `access_log` VALUES (62449, '65.50.15647585142359759', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.89.49.217', '2019-08-02 23:08:34', 9, 2001001000, '服务端发生异常', '2019-08-02 23:08:34');
INSERT INTO `access_log` VALUES (62450, '65.47.15647585142399745', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.89.49.217', '2019-08-02 23:08:34', 7, 0, '', '2019-08-02 23:08:34');
INSERT INTO `access_log` VALUES (62451, '65.46.15647585182299811', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.89.49.217', '2019-08-02 23:08:38', 13, 0, '', '2019-08-02 23:08:38');
INSERT INTO `access_log` VALUES (62452, '65.52.15647585182349811', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.89.49.217', '2019-08-02 23:08:38', 11, 2001001000, '服务端发生异常', '2019-08-02 23:08:38');
INSERT INTO `access_log` VALUES (62453, '65.49.15647585182389749', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.89.49.217', '2019-08-02 23:08:38', 12, 0, '', '2019-08-02 23:08:38');
INSERT INTO `access_log` VALUES (62454, '65.3607.15647585191561559', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.89.49.217', '2019-08-02 23:08:39', 17, 0, '', '2019-08-02 23:08:39');
INSERT INTO `access_log` VALUES (62455, '65.51.15647585191669833', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.89.49.217', '2019-08-02 23:08:39', 8, 0, '', '2019-08-02 23:08:39');
INSERT INTO `access_log` VALUES (62456, '65.53.15647585191669761', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.89.49.217', '2019-08-02 23:08:39', 9, 2001001000, '服务端发生异常', '2019-08-02 23:08:39');
INSERT INTO `access_log` VALUES (62457, '59.75.15647589282927213', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.234.223.38', '2019-08-02 23:15:28', 9, 0, '', '2019-08-02 23:15:28');
INSERT INTO `access_log` VALUES (62458, '59.76.15647589283047193', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.234.223.38', '2019-08-02 23:15:28', 13, 2001001000, '服务端发生异常', '2019-08-02 23:15:28');
INSERT INTO `access_log` VALUES (62459, '59.79.15647590806507211', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '3.84.220.238', '2019-08-02 23:18:01', 13, 2001001000, '服务端发生异常', '2019-08-02 23:18:01');
INSERT INTO `access_log` VALUES (62460, '59.72.15647591455957203', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '3.84.220.238', '2019-08-02 23:19:06', 3, 0, '', '2019-08-02 23:19:06');
INSERT INTO `access_log` VALUES (62461, '65.54.15647605681909703', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:42:48', 0, 1002001015, '账号未登陆', '2019-08-02 23:42:48');
INSERT INTO `access_log` VALUES (62462, '65.46.15647605681909841', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:42:48', 0, 1002001015, '账号未登陆', '2019-08-02 23:42:48');
INSERT INTO `access_log` VALUES (62463, '65.53.15647605681919787', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:42:48', 0, 1002001015, '账号未登陆', '2019-08-02 23:42:48');
INSERT INTO `access_log` VALUES (62464, '65.51.15647605751159863', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:42:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-02 23:42:55');
INSERT INTO `access_log` VALUES (62465, '65.45.15647605800939791', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:43:00', 84, 0, '', '2019-08-02 23:43:00');
INSERT INTO `access_log` VALUES (62466, '65.50.15647605808739791', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:43:01', 16, 2001001000, '服务端发生异常', '2019-08-02 23:43:01');
INSERT INTO `access_log` VALUES (62467, '65.47.15647605808739775', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:43:01', 15, 0, '', '2019-08-02 23:43:01');
INSERT INTO `access_log` VALUES (62468, '65.49.15647605808909781', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:43:01', 8, 0, '', '2019-08-02 23:43:01');
INSERT INTO `access_log` VALUES (62469, '65.54.15647606003169705', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:43:20', 10, 0, '', '2019-08-02 23:43:20');
INSERT INTO `access_log` VALUES (62470, '65.46.15647606003169843', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:43:20', 10, 2001001000, '服务端发生异常', '2019-08-02 23:43:20');
INSERT INTO `access_log` VALUES (62471, '65.53.15647606004629789', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:43:20', 8, 0, '', '2019-08-02 23:43:20');
INSERT INTO `access_log` VALUES (62472, '65.51.15647606047519865', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:43:25', 9, 0, '', '2019-08-02 23:43:25');
INSERT INTO `access_log` VALUES (62473, '65.49.15647606047539783', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:43:25', 9, 0, '', '2019-08-02 23:43:25');
INSERT INTO `access_log` VALUES (62474, '65.45.15647606047519793', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:43:25', 10, 2001001000, '服务端发生异常', '2019-08-02 23:43:25');
INSERT INTO `access_log` VALUES (62475, '65.46.15647606723529845', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:44:32', 9, 0, '', '2019-08-02 23:44:32');
INSERT INTO `access_log` VALUES (62476, '65.53.15647606723999791', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:44:32', 10, 2001001000, '服务端发生异常', '2019-08-02 23:44:32');
INSERT INTO `access_log` VALUES (62477, '65.52.15647606724289845', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:44:32', 10, 0, '', '2019-08-02 23:44:32');
INSERT INTO `access_log` VALUES (62478, '65.46.15647613819749855', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:56:22', 11, 0, '', '2019-08-02 23:56:22');
INSERT INTO `access_log` VALUES (62479, '65.53.15647613819819801', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:56:22', 11, 2001001000, '服务端发生异常', '2019-08-02 23:56:22');
INSERT INTO `access_log` VALUES (62480, '65.52.15647613819839855', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-02 23:56:22', 9, 0, '', '2019-08-02 23:56:22');
INSERT INTO `access_log` VALUES (62481, '65.45.15647616994909809', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-03 00:01:39', 11, 0, '', '2019-08-03 00:01:40');
INSERT INTO `access_log` VALUES (62482, '65.47.15647616995079793', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-03 00:01:40', 10, 2001001000, '服务端发生异常', '2019-08-03 00:01:40');
INSERT INTO `access_log` VALUES (62483, '65.50.15647616995089809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-03 00:01:40', 10, 0, '', '2019-08-03 00:01:40');
INSERT INTO `access_log` VALUES (62484, '65.54.15647617177209723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-03 00:01:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-03 00:01:58');
INSERT INTO `access_log` VALUES (62485, '65.52.15647617301689861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-03 00:02:10', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-03 00:02:10');
INSERT INTO `access_log` VALUES (62486, '65.49.15647617496159801', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-03 00:02:30', 123, 0, '', '2019-08-03 00:02:30');
INSERT INTO `access_log` VALUES (62487, '65.51.15647617504179883', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-03 00:02:30', 9, 0, '', '2019-08-03 00:02:30');
INSERT INTO `access_log` VALUES (62488, '65.50.15647617504189811', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-03 00:02:30', 9, 0, '', '2019-08-03 00:02:30');
INSERT INTO `access_log` VALUES (62489, '65.45.15647617504179811', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '61.171.252.215', '2019-08-03 00:02:30', 12, 2001001000, '服务端发生异常', '2019-08-03 00:02:30');
INSERT INTO `access_log` VALUES (62490, '59.76.15647969800627701', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.123.100.185', '2019-08-03 09:49:40', 17, 0, '', '2019-08-03 09:49:40');
INSERT INTO `access_log` VALUES (62491, '59.79.15647969800637717', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.123.100.185', '2019-08-03 09:49:40', 37, 2001001000, '服务端发生异常', '2019-08-03 09:49:40');
INSERT INTO `access_log` VALUES (62492, '64.84.15647969888118011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.123.100.185', '2019-08-03 09:49:49', 12, 0, '', '2019-08-03 09:49:49');
INSERT INTO `access_log` VALUES (62493, '64.81.15647969890018015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.123.100.185', '2019-08-03 09:49:49', 2, 0, '', '2019-08-03 09:49:49');
INSERT INTO `access_log` VALUES (62494, '64.76.15647969907878013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.123.100.185', '2019-08-03 09:49:51', 2, 0, '', '2019-08-03 09:49:51');
INSERT INTO `access_log` VALUES (62495, '64.83.15647969912128011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '119.123.100.185', '2019-08-03 09:49:51', 2, 0, '', '2019-08-03 09:49:51');
INSERT INTO `access_log` VALUES (62496, '59.73.15648043385957809', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '97.107.142.183', '2019-08-03 11:52:19', 23, 2001001000, '服务端发生异常', '2019-08-03 11:52:19');
INSERT INTO `access_log` VALUES (62497, '59.78.15648043386397817', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '97.107.142.183', '2019-08-03 11:52:19', 9, 0, '', '2019-08-03 11:52:19');
INSERT INTO `access_log` VALUES (62498, '65.3607.15648097857522253', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.171.21', '2019-08-03 13:23:06', 1, 1002001015, '账号未登陆', '2019-08-03 13:23:06');
INSERT INTO `access_log` VALUES (62499, '65.54.15648097857520365', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.171.21', '2019-08-03 13:23:06', 1, 1002001015, '账号未登陆', '2019-08-03 13:23:06');
INSERT INTO `access_log` VALUES (62500, '65.50.15648097857530453', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.171.21', '2019-08-03 13:23:06', 0, 1002001015, '账号未登陆', '2019-08-03 13:23:06');
INSERT INTO `access_log` VALUES (62501, '65.49.15648097995790443', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.171.21', '2019-08-03 13:23:20', 131, 0, '', '2019-08-03 13:23:20');
INSERT INTO `access_log` VALUES (62502, '65.46.15648097999370505', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.171.21', '2019-08-03 13:23:20', 18, 0, '', '2019-08-03 13:23:20');
INSERT INTO `access_log` VALUES (62503, '65.52.15648097999410503', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.171.21', '2019-08-03 13:23:20', 16, 2001001000, '服务端发生异常', '2019-08-03 13:23:20');
INSERT INTO `access_log` VALUES (62504, '65.53.15648097999440449', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.171.21', '2019-08-03 13:23:20', 14, 0, '', '2019-08-03 13:23:20');
INSERT INTO `access_log` VALUES (62505, '65.45.15648098083580453', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.171.21', '2019-08-03 13:23:28', 17, 0, '', '2019-08-03 13:23:28');
INSERT INTO `access_log` VALUES (62506, '65.54.15648098083690367', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.171.21', '2019-08-03 13:23:28', 10, 0, '', '2019-08-03 13:23:28');
INSERT INTO `access_log` VALUES (62507, '65.50.15648098083690455', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.171.171.21', '2019-08-03 13:23:28', 11, 2001001000, '服务端发生异常', '2019-08-03 13:23:28');
INSERT INTO `access_log` VALUES (62508, '65.47.15648101290900445', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.191.115', '2019-08-03 13:28:49', 0, 1002001015, '账号未登陆', '2019-08-03 13:28:49');
INSERT INTO `access_log` VALUES (62509, '65.49.15648101290920451', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.191.115', '2019-08-03 13:28:49', 0, 1002001015, '账号未登陆', '2019-08-03 13:28:49');
INSERT INTO `access_log` VALUES (62510, '65.50.15648101291000459', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.191.115', '2019-08-03 13:28:49', 0, 1002001015, '账号未登陆', '2019-08-03 13:28:49');
INSERT INTO `access_log` VALUES (62511, '65.53.15648101346970457', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.191.115', '2019-08-03 13:28:55', 100, 0, '', '2019-08-03 13:28:55');
INSERT INTO `access_log` VALUES (62512, '65.46.15648101350900511', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.191.115', '2019-08-03 13:28:55', 78, 0, '', '2019-08-03 13:28:55');
INSERT INTO `access_log` VALUES (62513, '65.51.15648101350950533', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.191.115', '2019-08-03 13:28:55', 76, 0, '', '2019-08-03 13:28:55');
INSERT INTO `access_log` VALUES (62514, '65.52.15648101350900509', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '202.101.191.115', '2019-08-03 13:28:55', 81, 2001001000, '服务端发生异常', '2019-08-03 13:28:55');
INSERT INTO `access_log` VALUES (62515, '59.75.15648119084577921', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.22.250.160', '2019-08-03 13:58:28', 10, 0, '', '2019-08-03 13:58:28');
INSERT INTO `access_log` VALUES (62516, '59.79.15648119084587917', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.22.250.160', '2019-08-03 13:58:28', 19, 2001001000, '服务端发生异常', '2019-08-03 13:58:28');
INSERT INTO `access_log` VALUES (62517, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.22.250.160', '2019-08-03 13:58:33', 7, 0, '', '2019-08-03 13:58:33');
INSERT INTO `access_log` VALUES (62518, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.22.250.160', '2019-08-03 13:58:34', 4, 0, '', '2019-08-03 13:58:34');
INSERT INTO `access_log` VALUES (62519, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.22.250.160', '2019-08-03 13:58:34', 19, 0, '', '2019-08-03 13:58:34');
INSERT INTO `access_log` VALUES (62520, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.22.250.160', '2019-08-03 13:58:34', 10, 0, '', '2019-08-03 13:58:34');
INSERT INTO `access_log` VALUES (62521, '65.53.15648119238800481', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.22.250.160', '2019-08-03 13:58:44', 0, 1002001015, '账号未登陆', '2019-08-03 13:58:44');
INSERT INTO `access_log` VALUES (62522, '65.46.15648119238800537', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.22.250.160', '2019-08-03 13:58:44', 0, 1002001015, '账号未登陆', '2019-08-03 13:58:44');
INSERT INTO `access_log` VALUES (62523, '65.52.15648119238820533', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.22.250.160', '2019-08-03 13:58:44', 0, 1002001015, '账号未登陆', '2019-08-03 13:58:44');
INSERT INTO `access_log` VALUES (62524, '65.51.15648119388050559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.22.250.160', '2019-08-03 13:58:59', 120, 0, '', '2019-08-03 13:58:59');
INSERT INTO `access_log` VALUES (62525, '65.50.15648119391540487', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.22.250.160', '2019-08-03 13:58:59', 9, 0, '', '2019-08-03 13:58:59');
INSERT INTO `access_log` VALUES (62526, '65.49.15648119391590479', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.22.250.160', '2019-08-03 13:58:59', 10, 2001001000, '服务端发生异常', '2019-08-03 13:58:59');
INSERT INTO `access_log` VALUES (62527, '65.3607.15648119391602287', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.22.250.160', '2019-08-03 13:58:59', 8, 0, '', '2019-08-03 13:58:59');
INSERT INTO `access_log` VALUES (62528, '59.74.15648161722357981', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.137.190.233', '2019-08-03 15:09:32', 11, 0, '', '2019-08-03 15:09:32');
INSERT INTO `access_log` VALUES (62529, '59.77.15648161722597957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.137.190.233', '2019-08-03 15:09:32', 19, 2001001000, '服务端发生异常', '2019-08-03 15:09:32');
INSERT INTO `access_log` VALUES (62530, '64.83.15648161868298267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.137.190.233', '2019-08-03 15:09:47', 14, 0, '', '2019-08-03 15:09:47');
INSERT INTO `access_log` VALUES (62531, '64.78.15648161871408273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.137.190.233', '2019-08-03 15:09:47', 4, 0, '', '2019-08-03 15:09:47');
INSERT INTO `access_log` VALUES (62532, '64.85.15648161888298303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.137.190.233', '2019-08-03 15:09:49', 2, 0, '', '2019-08-03 15:09:49');
INSERT INTO `access_log` VALUES (62533, '64.82.15648161895108283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.137.190.233', '2019-08-03 15:09:50', 2, 0, '', '2019-08-03 15:09:50');
INSERT INTO `access_log` VALUES (62534, '64.79.15648161934728269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.137.190.233', '2019-08-03 15:09:53', 2, 0, '', '2019-08-03 15:09:53');
INSERT INTO `access_log` VALUES (62535, '64.84.15648161935888269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.137.190.233', '2019-08-03 15:09:54', 2, 0, '', '2019-08-03 15:09:54');
INSERT INTO `access_log` VALUES (62536, '65.47.15648162931690531', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.137.190.233', '2019-08-03 15:11:33', 0, 1002001015, '账号未登陆', '2019-08-03 15:11:33');
INSERT INTO `access_log` VALUES (62537, '65.45.15648162931790543', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.137.190.233', '2019-08-03 15:11:33', 1, 1002001015, '账号未登陆', '2019-08-03 15:11:33');
INSERT INTO `access_log` VALUES (62538, '65.46.15648162931860597', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.137.190.233', '2019-08-03 15:11:33', 1, 1002001015, '账号未登陆', '2019-08-03 15:11:33');
INSERT INTO `access_log` VALUES (62539, '65.53.15648162957840541', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.137.190.233', '2019-08-03 15:11:36', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-03 15:11:36');
INSERT INTO `access_log` VALUES (62540, '65.54.15648162997440459', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.137.190.233', '2019-08-03 15:11:40', 107, 0, '', '2019-08-03 15:11:40');
INSERT INTO `access_log` VALUES (62541, '65.51.15648163002660619', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.137.190.233', '2019-08-03 15:11:40', 11, 0, '', '2019-08-03 15:11:40');
INSERT INTO `access_log` VALUES (62542, '65.50.15648163002710547', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.137.190.233', '2019-08-03 15:11:40', 10, 2001001000, '服务端发生异常', '2019-08-03 15:11:40');
INSERT INTO `access_log` VALUES (62543, '65.3607.15648163002752347', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.137.190.233', '2019-08-03 15:11:40', 8, 0, '', '2019-08-03 15:11:40');
INSERT INTO `access_log` VALUES (62544, '65.54.15648191017240497', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.227.148.118', '2019-08-03 15:58:22', 1, 1002001015, '账号未登陆', '2019-08-03 15:58:22');
INSERT INTO `access_log` VALUES (62545, '65.3607.15648191017562385', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.227.148.118', '2019-08-03 15:58:22', 0, 1002001015, '账号未登陆', '2019-08-03 15:58:22');
INSERT INTO `access_log` VALUES (62546, '65.51.15648191017690657', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.227.148.118', '2019-08-03 15:58:22', 0, 1002001015, '账号未登陆', '2019-08-03 15:58:22');
INSERT INTO `access_log` VALUES (62547, '65.49.15648191055990577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.227.148.118', '2019-08-03 15:58:26', 74, 0, '', '2019-08-03 15:58:26');
INSERT INTO `access_log` VALUES (62548, '65.47.15648191059620571', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.227.148.118', '2019-08-03 15:58:26', 11, 0, '', '2019-08-03 15:58:26');
INSERT INTO `access_log` VALUES (62549, '65.45.15648191059790583', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.227.148.118', '2019-08-03 15:58:26', 10, 2001001000, '服务端发生异常', '2019-08-03 15:58:26');
INSERT INTO `access_log` VALUES (62550, '65.46.15648191059870637', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.227.148.118', '2019-08-03 15:58:26', 11, 0, '', '2019-08-03 15:58:26');
INSERT INTO `access_log` VALUES (62551, '66.57.15648214419175751', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.65.102.92', '2019-08-03 16:37:22', 27, 0, '', '2019-08-03 16:37:22');
INSERT INTO `access_log` VALUES (62552, '59.73.15648274751448119', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.25.42.50', '2019-08-03 18:17:55', 20, 2001001000, '服务端发生异常', '2019-08-03 18:17:55');
INSERT INTO `access_log` VALUES (62553, '59.76.15648274751448109', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.25.42.50', '2019-08-03 18:17:55', 46, 0, '', '2019-08-03 18:17:55');
INSERT INTO `access_log` VALUES (62554, '64.76.15648274783118421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.25.42.50', '2019-08-03 18:17:58', 12, 0, '', '2019-08-03 18:17:58');
INSERT INTO `access_log` VALUES (62555, '64.83.15648274784698419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.25.42.50', '2019-08-03 18:17:58', 3, 0, '', '2019-08-03 18:17:58');
INSERT INTO `access_log` VALUES (62556, '59.78.15648276232448129', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.255.127.93', '2019-08-03 18:20:23', 5, 0, '', '2019-08-03 18:20:23');
INSERT INTO `access_log` VALUES (62557, '59.71.15648276232468117', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.255.127.93', '2019-08-03 18:20:23', 16, 2001001000, '服务端发生异常', '2019-08-03 18:20:23');
INSERT INTO `access_log` VALUES (62558, '64.82.15648276522058437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.255.127.93', '2019-08-03 18:20:52', 3, 0, '', '2019-08-03 18:20:52');
INSERT INTO `access_log` VALUES (62559, '64.77.15648276523558417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.255.127.93', '2019-08-03 18:20:52', 1, 0, '', '2019-08-03 18:20:52');
INSERT INTO `access_log` VALUES (62560, '64.79.15648276538578423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.255.127.93', '2019-08-03 18:20:54', 2, 0, '', '2019-08-03 18:20:54');
INSERT INTO `access_log` VALUES (62561, '64.84.15648276545898423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.255.127.93', '2019-08-03 18:20:55', 2, 0, '', '2019-08-03 18:20:55');
INSERT INTO `access_log` VALUES (62562, '59.75.15648332419188207', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:02', 9, 0, '', '2019-08-03 19:54:02');
INSERT INTO `access_log` VALUES (62563, '59.79.15648332419198203', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:02', 18, 2001001000, '服务端发生异常', '2019-08-03 19:54:02');
INSERT INTO `access_log` VALUES (62564, '64.83.15648332486188497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:09', 13, 0, '', '2019-08-03 19:54:09');
INSERT INTO `access_log` VALUES (62565, '64.78.15648332487578503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:09', 4, 0, '', '2019-08-03 19:54:09');
INSERT INTO `access_log` VALUES (62566, '64.85.15648332501578533', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:10', 2, 0, '', '2019-08-03 19:54:10');
INSERT INTO `access_log` VALUES (62567, '64.82.15648332508668513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:11', 2, 0, '', '2019-08-03 19:54:11');
INSERT INTO `access_log` VALUES (62568, '64.77.15648332513028493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:11', 2, 0, '', '2019-08-03 19:54:11');
INSERT INTO `access_log` VALUES (62569, '64.79.15648332590588499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:19', 1, 0, '', '2019-08-03 19:54:19');
INSERT INTO `access_log` VALUES (62570, '64.84.15648332591768499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:19', 2, 0, '', '2019-08-03 19:54:19');
INSERT INTO `access_log` VALUES (62571, '59.78.15648332603398205', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:20', 3, 0, '', '2019-08-03 19:54:20');
INSERT INTO `access_log` VALUES (62572, '59.71.15648332603398193', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:20', 18, 2001001000, '服务端发生异常', '2019-08-03 19:54:20');
INSERT INTO `access_log` VALUES (62573, '65.50.15648332805020775', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:41', 1, 1002001015, '账号未登陆', '2019-08-03 19:54:41');
INSERT INTO `access_log` VALUES (62574, '65.49.15648332805030767', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:41', 1, 1002001015, '账号未登陆', '2019-08-03 19:54:41');
INSERT INTO `access_log` VALUES (62575, '65.46.15648332805030827', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:41', 1, 1002001015, '账号未登陆', '2019-08-03 19:54:41');
INSERT INTO `access_log` VALUES (62576, '65.47.15648332922450761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:52', 228, 0, '', '2019-08-03 19:54:52');
INSERT INTO `access_log` VALUES (62577, '65.45.15648332927290773', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:53', 180, 0, '', '2019-08-03 19:54:53');
INSERT INTO `access_log` VALUES (62578, '65.52.15648332927320823', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:53', 178, 0, '', '2019-08-03 19:54:53');
INSERT INTO `access_log` VALUES (62579, '65.53.15648332927290771', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.90.128.90', '2019-08-03 19:54:53', 182, 2001001000, '服务端发生异常', '2019-08-03 19:54:53');
INSERT INTO `access_log` VALUES (62580, '65.53.15648354608510801', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.146.207', '2019-08-03 20:31:01', 12, 1002001012, '访问令牌已过期', '2019-08-03 20:31:01');
INSERT INTO `access_log` VALUES (62581, '65.3607.15648354608522607', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.146.207', '2019-08-03 20:31:01', 14, 1002001012, '访问令牌已过期', '2019-08-03 20:31:01');
INSERT INTO `access_log` VALUES (62582, '65.54.15648354608530719', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.146.207', '2019-08-03 20:31:01', 18, 1002001012, '访问令牌已过期', '2019-08-03 20:31:01');
INSERT INTO `access_log` VALUES (62583, '65.50.15648354708860807', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.146.207', '2019-08-03 20:31:11', 55, 0, '', '2019-08-03 20:31:11');
INSERT INTO `access_log` VALUES (62584, '65.49.15648354713910799', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.146.207', '2019-08-03 20:31:11', 139, 0, '', '2019-08-03 20:31:12');
INSERT INTO `access_log` VALUES (62585, '65.47.15648354713910791', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.146.207', '2019-08-03 20:31:11', 140, 2001001000, '服务端发生异常', '2019-08-03 20:31:12');
INSERT INTO `access_log` VALUES (62586, '65.46.15648354713870859', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.146.207', '2019-08-03 20:31:11', 143, 0, '', '2019-08-03 20:31:12');
INSERT INTO `access_log` VALUES (62587, '65.51.15648362970030891', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.102.184.126', '2019-08-03 20:44:57', 0, 1002001015, '账号未登陆', '2019-08-03 20:44:57');
INSERT INTO `access_log` VALUES (62588, '65.50.15648362970060819', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.102.184.126', '2019-08-03 20:44:57', 0, 1002001015, '账号未登陆', '2019-08-03 20:44:57');
INSERT INTO `access_log` VALUES (62589, '65.46.15648362970160871', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.102.184.126', '2019-08-03 20:44:57', 0, 1002001015, '账号未登陆', '2019-08-03 20:44:57');
INSERT INTO `access_log` VALUES (62590, '65.49.15648362991410811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.102.184.126', '2019-08-03 20:44:59', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-03 20:44:59');
INSERT INTO `access_log` VALUES (62591, '65.45.15648363179070815', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.102.184.126', '2019-08-03 20:45:18', 92, 0, '', '2019-08-03 20:45:18');
INSERT INTO `access_log` VALUES (62592, '65.52.15648363184370867', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.102.184.126', '2019-08-03 20:45:18', 10, 0, '', '2019-08-03 20:45:18');
INSERT INTO `access_log` VALUES (62593, '65.53.15648363184440815', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.102.184.126', '2019-08-03 20:45:18', 10, 2001001000, '服务端发生异常', '2019-08-03 20:45:18');
INSERT INTO `access_log` VALUES (62594, '65.3607.15648363184542621', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.102.184.126', '2019-08-03 20:45:18', 9, 0, '', '2019-08-03 20:45:18');
INSERT INTO `access_log` VALUES (62595, '59.79.15648370694408255', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:57:49', 9, 0, '', '2019-08-03 20:57:49');
INSERT INTO `access_log` VALUES (62596, '59.75.15648370694418259', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:57:49', 20, 2001001000, '服务端发生异常', '2019-08-03 20:57:49');
INSERT INTO `access_log` VALUES (62597, '64.85.15648370726768585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:57:53', 10, 0, '', '2019-08-03 20:57:53');
INSERT INTO `access_log` VALUES (62598, '64.82.15648370727838565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:57:53', 3, 0, '', '2019-08-03 20:57:53');
INSERT INTO `access_log` VALUES (62599, '64.77.15648370746788545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:57:55', 3, 0, '', '2019-08-03 20:57:55');
INSERT INTO `access_log` VALUES (62600, '64.79.15648370755828551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:57:56', 2, 0, '', '2019-08-03 20:57:56');
INSERT INTO `access_log` VALUES (62601, '64.84.15648370764038551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:57:56', 1, 0, '', '2019-08-03 20:57:56');
INSERT INTO `access_log` VALUES (62602, '64.81.15648370773248555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:57:57', 2, 0, '', '2019-08-03 20:57:57');
INSERT INTO `access_log` VALUES (62603, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:57:57', 6, 0, '', '2019-08-03 20:57:57');
INSERT INTO `access_log` VALUES (62604, '64.80.15648370804138559', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:58:00', 8, 0, '', '2019-08-03 20:58:00');
INSERT INTO `access_log` VALUES (62605, '66.54.15648371041975963', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=1111111111&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:58:24', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-08-03 20:58:24');
INSERT INTO `access_log` VALUES (62606, '66.52.15648371078155951', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=111111111&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:58:28', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-08-03 20:58:28');
INSERT INTO `access_log` VALUES (62607, '66.55.15648371160525937', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:58:36', 16, 1001003001, '验证码已过期', '2019-08-03 20:58:36');
INSERT INTO `access_log` VALUES (62608, '66.51.15648371191915979', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=11111111111', 'POST', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:58:39', 106, 0, '', '2019-08-03 20:58:39');
INSERT INTO `access_log` VALUES (62609, '66.56.15648371211495975', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:58:41', 169, 0, '', '2019-08-03 20:58:41');
INSERT INTO `access_log` VALUES (62610, '66.53.15648371228315955', 128, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MIX 2 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/5167 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '120.204.191.136', '2019-08-03 20:58:43', 7, 0, '', '2019-08-03 20:58:43');
INSERT INTO `access_log` VALUES (62611, '65.45.15648380576160839', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.135.54', '2019-08-03 21:14:18', 0, 1002001015, '账号未登陆', '2019-08-03 21:14:18');
INSERT INTO `access_log` VALUES (62612, '65.3607.15648380576202645', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.135.54', '2019-08-03 21:14:18', 1, 1002001015, '账号未登陆', '2019-08-03 21:14:18');
INSERT INTO `access_log` VALUES (62613, '65.53.15648380576250839', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.135.54', '2019-08-03 21:14:18', 0, 1002001015, '账号未登陆', '2019-08-03 21:14:18');
INSERT INTO `access_log` VALUES (62614, '65.52.15648380616990891', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.135.54', '2019-08-03 21:14:22', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-03 21:14:22');
INSERT INTO `access_log` VALUES (62615, '65.50.15648380665950845', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.135.54', '2019-08-03 21:14:27', 58, 0, '', '2019-08-03 21:14:27');
INSERT INTO `access_log` VALUES (62616, '65.46.15648380668640897', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.135.54', '2019-08-03 21:14:27', 9, 0, '', '2019-08-03 21:14:27');
INSERT INTO `access_log` VALUES (62617, '65.51.15648380668700917', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.135.54', '2019-08-03 21:14:27', 10, 2001001000, '服务端发生异常', '2019-08-03 21:14:27');
INSERT INTO `access_log` VALUES (62618, '65.49.15648380668730837', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.135.54', '2019-08-03 21:14:27', 9, 0, '', '2019-08-03 21:14:27');
INSERT INTO `access_log` VALUES (62619, '59.74.15648382020398277', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.174.207.83', '2019-08-03 21:16:42', 4, 0, '', '2019-08-03 21:16:42');
INSERT INTO `access_log` VALUES (62620, '59.72.15648382020398261', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.174.207.83', '2019-08-03 21:16:42', 20, 2001001000, '服务端发生异常', '2019-08-03 21:16:42');
INSERT INTO `access_log` VALUES (62621, '65.3607.15648382395382649', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.174.207.83', '2019-08-03 21:17:20', 1, 1002001015, '账号未登陆', '2019-08-03 21:17:20');
INSERT INTO `access_log` VALUES (62622, '65.53.15648382395460843', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.174.207.83', '2019-08-03 21:17:20', 1, 1002001015, '账号未登陆', '2019-08-03 21:17:20');
INSERT INTO `access_log` VALUES (62623, '65.45.15648382395610843', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.174.207.83', '2019-08-03 21:17:20', 0, 1002001015, '账号未登陆', '2019-08-03 21:17:20');
INSERT INTO `access_log` VALUES (62624, '65.52.15648382417200895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.174.207.83', '2019-08-03 21:17:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-03 21:17:22');
INSERT INTO `access_log` VALUES (62625, '65.49.15648382614730841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.174.207.83', '2019-08-03 21:17:41', 974, 0, '', '2019-08-03 21:17:42');
INSERT INTO `access_log` VALUES (62626, '65.46.15648382627110901', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.174.207.83', '2019-08-03 21:17:43', 99, 0, '', '2019-08-03 21:17:43');
INSERT INTO `access_log` VALUES (62627, '65.47.15648382627160833', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.174.207.83', '2019-08-03 21:17:43', 98, 0, '', '2019-08-03 21:17:43');
INSERT INTO `access_log` VALUES (62628, '65.51.15648382627150921', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.174.207.83', '2019-08-03 21:17:43', 98, 2001001000, '服务端发生异常', '2019-08-03 21:17:43');
INSERT INTO `access_log` VALUES (62629, '65.45.15648415063240891', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.77.11', '2019-08-03 22:11:46', 16, 1002001012, '访问令牌已过期', '2019-08-03 22:11:46');
INSERT INTO `access_log` VALUES (62630, '65.54.15648415063240807', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.77.11', '2019-08-03 22:11:46', 18, 1002001012, '访问令牌已过期', '2019-08-03 22:11:46');
INSERT INTO `access_log` VALUES (62631, '65.52.15648415063440939', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.77.11', '2019-08-03 22:11:46', 14, 1002001012, '访问令牌已过期', '2019-08-03 22:11:46');
INSERT INTO `access_log` VALUES (62632, '65.50.15648415088460897', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.77.11', '2019-08-03 22:11:49', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-03 22:11:49');
INSERT INTO `access_log` VALUES (62633, '65.47.15648415189440879', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.77.11', '2019-08-03 22:11:59', 101, 0, '', '2019-08-03 22:11:59');
INSERT INTO `access_log` VALUES (62634, '65.3607.15648415194182699', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.77.11', '2019-08-03 22:11:59', 10, 0, '', '2019-08-03 22:11:59');
INSERT INTO `access_log` VALUES (62635, '65.51.15648415194240969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.77.11', '2019-08-03 22:11:59', 10, 2001001000, '服务端发生异常', '2019-08-03 22:11:59');
INSERT INTO `access_log` VALUES (62636, '65.53.15648415194330889', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.77.11', '2019-08-03 22:11:59', 16, 0, '', '2019-08-03 22:11:59');
INSERT INTO `access_log` VALUES (62637, '59.79.15648436173178343', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.109.50.187', '2019-08-03 22:46:57', 11, 0, '', '2019-08-03 22:46:57');
INSERT INTO `access_log` VALUES (62638, '59.75.15648436173188347', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.109.50.187', '2019-08-03 22:46:57', 19, 2001001000, '服务端发生异常', '2019-08-03 22:46:57');
INSERT INTO `access_log` VALUES (62639, '64.84.15648436266568639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.109.50.187', '2019-08-03 22:47:07', 12, 0, '', '2019-08-03 22:47:07');
INSERT INTO `access_log` VALUES (62640, '64.81.15648436268018643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.109.50.187', '2019-08-03 22:47:07', 3, 0, '', '2019-08-03 22:47:07');
INSERT INTO `access_log` VALUES (62641, '64.80.15648436288178647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.109.50.187', '2019-08-03 22:47:09', 2, 0, '', '2019-08-03 22:47:09');
INSERT INTO `access_log` VALUES (62642, '64.76.15648436297778641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.109.50.187', '2019-08-03 22:47:10', 1, 0, '', '2019-08-03 22:47:10');
INSERT INTO `access_log` VALUES (62643, '65.54.15648436406920837', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.109.50.187', '2019-08-03 22:47:21', 0, 1002001015, '账号未登陆', '2019-08-03 22:47:21');
INSERT INTO `access_log` VALUES (62644, '65.52.15648436406950969', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.109.50.187', '2019-08-03 22:47:21', 0, 1002001015, '账号未登陆', '2019-08-03 22:47:21');
INSERT INTO `access_log` VALUES (62645, '65.45.15648436406950921', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.109.50.187', '2019-08-03 22:47:21', 0, 1002001015, '账号未登陆', '2019-08-03 22:47:21');
INSERT INTO `access_log` VALUES (62646, '65.46.15648436440590975', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.109.50.187', '2019-08-03 22:47:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-03 22:47:24');
INSERT INTO `access_log` VALUES (62647, '65.47.15648436487800909', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.109.50.187', '2019-08-03 22:47:29', 50, 0, '', '2019-08-03 22:47:29');
INSERT INTO `access_log` VALUES (62648, '65.3607.15648436490992729', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.109.50.187', '2019-08-03 22:47:29', 12, 0, '', '2019-08-03 22:47:29');
INSERT INTO `access_log` VALUES (62649, '65.53.15648436491040919', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.109.50.187', '2019-08-03 22:47:29', 10, 2001001000, '服务端发生异常', '2019-08-03 22:47:29');
INSERT INTO `access_log` VALUES (62650, '65.51.15648436491070999', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.109.50.187', '2019-08-03 22:47:29', 10, 0, '', '2019-08-03 22:47:29');
INSERT INTO `access_log` VALUES (62651, '64.81.15648479604558703', 0, 2, 'product-application', '/product-api/admins/attr/page', 'name=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.31.11', '2019-08-03 23:59:20', 1, 1002001015, '账号未登陆', '2019-08-03 23:59:20');
INSERT INTO `access_log` VALUES (62652, '59.79.15648488398438413', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-04 00:14:00', 10, 0, '', '2019-08-04 00:14:00');
INSERT INTO `access_log` VALUES (62653, '59.75.15648488398438417', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-04 00:14:00', 31, 2001001000, '服务端发生异常', '2019-08-04 00:14:00');
INSERT INTO `access_log` VALUES (62654, '64.83.15648488477218709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-04 00:14:08', 14, 0, '', '2019-08-04 00:14:08');
INSERT INTO `access_log` VALUES (62655, '64.77.15648488478248707', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-04 00:14:08', 3, 0, '', '2019-08-04 00:14:08');
INSERT INTO `access_log` VALUES (62656, '64.80.15648488497008717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-04 00:14:10', 3, 0, '', '2019-08-04 00:14:10');
INSERT INTO `access_log` VALUES (62657, '64.78.15648488502608715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-04 00:14:10', 1, 0, '', '2019-08-04 00:14:10');
INSERT INTO `access_log` VALUES (62658, '66.54.15648488545196123', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-04 00:14:15', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-08-04 00:14:15');
INSERT INTO `access_log` VALUES (62659, '64.85.15648488607008747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-04 00:14:21', 2, 0, '', '2019-08-04 00:14:21');
INSERT INTO `access_log` VALUES (62660, '64.79.15648488607928711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-04 00:14:21', 2, 0, '', '2019-08-04 00:14:21');
INSERT INTO `access_log` VALUES (62661, '59.74.15648492281928425', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.64.111.52', '2019-08-04 00:20:28', 3, 0, '', '2019-08-04 00:20:28');
INSERT INTO `access_log` VALUES (62662, '59.80.15648492282018385', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.64.111.52', '2019-08-04 00:20:28', 13, 2001001000, '服务端发生异常', '2019-08-04 00:20:28');
INSERT INTO `access_log` VALUES (62663, '64.77.15648492305398713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.64.111.52', '2019-08-04 00:20:31', 2, 0, '', '2019-08-04 00:20:31');
INSERT INTO `access_log` VALUES (62664, '64.80.15648492307138723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.64.111.52', '2019-08-04 00:20:31', 2, 0, '', '2019-08-04 00:20:31');
INSERT INTO `access_log` VALUES (62665, '64.78.15648492317958721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.64.111.52', '2019-08-04 00:20:32', 2, 0, '', '2019-08-04 00:20:32');
INSERT INTO `access_log` VALUES (62666, '64.82.15648492324458731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.64.111.52', '2019-08-04 00:20:32', 2, 0, '', '2019-08-04 00:20:32');
INSERT INTO `access_log` VALUES (62667, '64.85.15648492329438753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.64.111.52', '2019-08-04 00:20:33', 2, 0, '', '2019-08-04 00:20:33');
INSERT INTO `access_log` VALUES (62668, '64.79.15648492334118717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.64.111.52', '2019-08-04 00:20:33', 2, 0, '', '2019-08-04 00:20:33');
INSERT INTO `access_log` VALUES (62669, '64.84.15648492339658717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.64.111.52', '2019-08-04 00:20:34', 2, 0, '', '2019-08-04 00:20:34');
INSERT INTO `access_log` VALUES (62670, '59.74.15648760633708783', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:47:43', 15, 0, '', '2019-08-04 07:47:43');
INSERT INTO `access_log` VALUES (62671, '59.79.15648760633718777', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:47:43', 29, 2001001000, '服务端发生异常', '2019-08-04 07:47:43');
INSERT INTO `access_log` VALUES (62672, '64.84.15648760673849075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:47:47', 12, 0, '', '2019-08-04 07:47:47');
INSERT INTO `access_log` VALUES (62673, '64.76.15648760676129077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:47:48', 2, 0, '', '2019-08-04 07:47:48');
INSERT INTO `access_log` VALUES (62674, '64.81.15648760694379081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:47:49', 2, 0, '', '2019-08-04 07:47:49');
INSERT INTO `access_log` VALUES (62675, '64.83.15648760702659075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:47:50', 2, 0, '', '2019-08-04 07:47:50');
INSERT INTO `access_log` VALUES (62676, '64.80.15648760717159083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:47:52', 2, 0, '', '2019-08-04 07:47:52');
INSERT INTO `access_log` VALUES (62677, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:47:52', 5, 0, '', '2019-08-04 07:47:52');
INSERT INTO `access_log` VALUES (62678, '64.78.15648760738239081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:47:54', 2, 0, '', '2019-08-04 07:47:54');
INSERT INTO `access_log` VALUES (62679, '64.82.15648760740309091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:47:54', 2, 0, '', '2019-08-04 07:47:54');
INSERT INTO `access_log` VALUES (62680, '64.85.15648760758159113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:47:56', 2, 0, '', '2019-08-04 07:47:56');
INSERT INTO `access_log` VALUES (62681, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:47:56', 6, 0, '', '2019-08-04 07:47:56');
INSERT INTO `access_log` VALUES (62682, '64.79.15648760782039077', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:47:58', 8, 0, '', '2019-08-04 07:47:58');
INSERT INTO `access_log` VALUES (62683, '64.76.15648760909859079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:48:11', 2, 0, '', '2019-08-04 07:48:11');
INSERT INTO `access_log` VALUES (62684, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:48:11', 6, 0, '', '2019-08-04 07:48:11');
INSERT INTO `access_log` VALUES (62685, '64.81.15648760920789083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:48:12', 2, 0, '', '2019-08-04 07:48:12');
INSERT INTO `access_log` VALUES (62686, '64.83.15648760924749077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:48:12', 2, 0, '', '2019-08-04 07:48:12');
INSERT INTO `access_log` VALUES (62687, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=小米&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:48:21', 6, 0, '', '2019-08-04 07:48:21');
INSERT INTO `access_log` VALUES (62688, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=小米', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:48:21', 9, 0, '', '2019-08-04 07:48:21');
INSERT INTO `access_log` VALUES (62689, '65.53.15648761240721353', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:48:44', 1, 1002001015, '账号未登陆', '2019-08-04 07:48:44');
INSERT INTO `access_log` VALUES (62690, '65.45.15648761240731355', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:48:44', 0, 1002001015, '账号未登陆', '2019-08-04 07:48:44');
INSERT INTO `access_log` VALUES (62691, '65.49.15648761240731349', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:48:44', 1, 1002001015, '账号未登陆', '2019-08-04 07:48:44');
INSERT INTO `access_log` VALUES (62692, '65.52.15648761279421403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:48:48', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 07:48:48');
INSERT INTO `access_log` VALUES (62693, '65.46.15648761569011411', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:49:17', 150, 0, '', '2019-08-04 07:49:17');
INSERT INTO `access_log` VALUES (62694, '65.47.15648761576141345', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:49:18', 19, 0, '', '2019-08-04 07:49:18');
INSERT INTO `access_log` VALUES (62695, '65.51.15648761576221435', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:49:18', 17, 2001001000, '服务端发生异常', '2019-08-04 07:49:18');
INSERT INTO `access_log` VALUES (62696, '65.3607.15648761576413165', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '14.27.56.104', '2019-08-04 07:49:18', 10, 0, '', '2019-08-04 07:49:18');
INSERT INTO `access_log` VALUES (62697, '65.45.15648878349431513', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.248.65.195', '2019-08-04 11:03:55', 0, 1002001015, '账号未登陆', '2019-08-04 11:03:55');
INSERT INTO `access_log` VALUES (62698, '65.47.15648878349431501', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.248.65.195', '2019-08-04 11:03:55', 0, 1002001015, '账号未登陆', '2019-08-04 11:03:55');
INSERT INTO `access_log` VALUES (62699, '65.53.15648878349701511', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.248.65.195', '2019-08-04 11:03:55', 0, 1002001015, '账号未登陆', '2019-08-04 11:03:55');
INSERT INTO `access_log` VALUES (62700, '65.52.15648878581511561', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.248.65.195', '2019-08-04 11:04:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 11:04:18');
INSERT INTO `access_log` VALUES (62701, '65.54.15648878621941431', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.248.65.195', '2019-08-04 11:04:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 11:04:22');
INSERT INTO `access_log` VALUES (62702, '65.46.15648878703331569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.248.65.195', '2019-08-04 11:04:30', 81, 0, '', '2019-08-04 11:04:30');
INSERT INTO `access_log` VALUES (62703, '65.3607.15648878707803323', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.248.65.195', '2019-08-04 11:04:31', 14, 0, '', '2019-08-04 11:04:31');
INSERT INTO `access_log` VALUES (62704, '65.51.15648878707821593', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.248.65.195', '2019-08-04 11:04:31', 14, 2001001000, '服务端发生异常', '2019-08-04 11:04:31');
INSERT INTO `access_log` VALUES (62705, '65.47.15648878708181503', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.248.65.195', '2019-08-04 11:04:31', 9, 0, '', '2019-08-04 11:04:31');
INSERT INTO `access_log` VALUES (62706, '65.45.15648878897961515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.248.65.195', '2019-08-04 11:04:50', 9, 0, '', '2019-08-04 11:04:50');
INSERT INTO `access_log` VALUES (62707, '65.49.15648878898041509', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.248.65.195', '2019-08-04 11:04:50', 9, 2001001000, '服务端发生异常', '2019-08-04 11:04:50');
INSERT INTO `access_log` VALUES (62708, '65.52.15648878898711563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.248.65.195', '2019-08-04 11:04:50', 11, 0, '', '2019-08-04 11:04:50');
INSERT INTO `access_log` VALUES (62709, '65.46.15648879090981571', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.248.65.195', '2019-08-04 11:05:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 11:05:09');
INSERT INTO `access_log` VALUES (62710, '65.3607.15648879171063325', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.248.65.195', '2019-08-04 11:05:17', 3, 1002002001, '密码不正确', '2019-08-04 11:05:17');
INSERT INTO `access_log` VALUES (62711, '59.76.15648880857448921', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:06', 11, 0, '', '2019-08-04 11:08:06');
INSERT INTO `access_log` VALUES (62712, '59.78.15648880857458939', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:06', 27, 2001001000, '服务端发生异常', '2019-08-04 11:08:06');
INSERT INTO `access_log` VALUES (62713, '64.77.15648880929269235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:13', 11, 0, '', '2019-08-04 11:08:13');
INSERT INTO `access_log` VALUES (62714, '64.80.15648880930499245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:13', 3, 0, '', '2019-08-04 11:08:13');
INSERT INTO `access_log` VALUES (62715, '64.78.15648880950159243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:15', 2, 0, '', '2019-08-04 11:08:15');
INSERT INTO `access_log` VALUES (62716, '64.82.15648880956729253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:16', 3, 0, '', '2019-08-04 11:08:16');
INSERT INTO `access_log` VALUES (62717, '59.77.15648881067578921', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:27', 3, 0, '', '2019-08-04 11:08:27');
INSERT INTO `access_log` VALUES (62718, '59.72.15648881067588929', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:27', 14, 2001001000, '服务端发生异常', '2019-08-04 11:08:27');
INSERT INTO `access_log` VALUES (62719, '59.74.15648881210548945', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:41', 2, 0, '', '2019-08-04 11:08:41');
INSERT INTO `access_log` VALUES (62720, '59.79.15648881210558939', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:41', 13, 2001001000, '服务端发生异常', '2019-08-04 11:08:41');
INSERT INTO `access_log` VALUES (62721, '64.84.15648881254369239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:45', 3, 0, '', '2019-08-04 11:08:45');
INSERT INTO `access_log` VALUES (62722, '64.76.15648881255969241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:46', 1, 0, '', '2019-08-04 11:08:46');
INSERT INTO `access_log` VALUES (62723, '64.81.15648881270459245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:47', 2, 0, '', '2019-08-04 11:08:47');
INSERT INTO `access_log` VALUES (62724, '64.83.15648881280669239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:48', 1, 0, '', '2019-08-04 11:08:48');
INSERT INTO `access_log` VALUES (62725, '64.77.15648881286919237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:49', 2, 0, '', '2019-08-04 11:08:49');
INSERT INTO `access_log` VALUES (62726, '64.80.15648881292199247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:49', 2, 0, '', '2019-08-04 11:08:49');
INSERT INTO `access_log` VALUES (62727, '64.78.15648881297439245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:50', 1, 0, '', '2019-08-04 11:08:50');
INSERT INTO `access_log` VALUES (62728, '59.76.15648881323498923', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:52', 3, 0, '', '2019-08-04 11:08:52');
INSERT INTO `access_log` VALUES (62729, '59.73.15648881323498933', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.63.224.117', '2019-08-04 11:08:52', 19, 2001001000, '服务端发生异常', '2019-08-04 11:08:52');
INSERT INTO `access_log` VALUES (62730, '65.49.15648899304601537', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '125.71.72.225', '2019-08-04 11:38:50', 0, 1002001015, '账号未登陆', '2019-08-04 11:38:50');
INSERT INTO `access_log` VALUES (62731, '65.52.15648899304601591', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '125.71.72.225', '2019-08-04 11:38:50', 0, 1002001015, '账号未登陆', '2019-08-04 11:38:50');
INSERT INTO `access_log` VALUES (62732, '65.54.15648899304621461', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '125.71.72.225', '2019-08-04 11:38:50', 1, 1002001015, '账号未登陆', '2019-08-04 11:38:50');
INSERT INTO `access_log` VALUES (62733, '65.50.15648899330561549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '125.71.72.225', '2019-08-04 11:38:53', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 11:38:53');
INSERT INTO `access_log` VALUES (62734, '65.3607.15648899467133353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '125.71.72.225', '2019-08-04 11:39:07', 110, 0, '', '2019-08-04 11:39:07');
INSERT INTO `access_log` VALUES (62735, '65.51.15648899472201623', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '125.71.72.225', '2019-08-04 11:39:07', 10, 0, '', '2019-08-04 11:39:07');
INSERT INTO `access_log` VALUES (62736, '65.47.15648899472211533', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '125.71.72.225', '2019-08-04 11:39:07', 10, 2001001000, '服务端发生异常', '2019-08-04 11:39:07');
INSERT INTO `access_log` VALUES (62737, '65.53.15648899472291543', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '125.71.72.225', '2019-08-04 11:39:07', 9, 0, '', '2019-08-04 11:39:07');
INSERT INTO `access_log` VALUES (62738, '65.51.15648909566781637', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.155.119.14', '2019-08-04 11:55:57', 0, 1002001015, '账号未登陆', '2019-08-04 11:55:57');
INSERT INTO `access_log` VALUES (62739, '65.53.15648909566881557', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.155.119.14', '2019-08-04 11:55:57', 1, 1002001015, '账号未登陆', '2019-08-04 11:55:57');
INSERT INTO `access_log` VALUES (62740, '65.45.15648909566881559', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.155.119.14', '2019-08-04 11:55:57', 1, 1002001015, '账号未登陆', '2019-08-04 11:55:57');
INSERT INTO `access_log` VALUES (62741, '65.49.15648909599451553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.155.119.14', '2019-08-04 11:56:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 11:56:00');
INSERT INTO `access_log` VALUES (62742, '65.54.15648909642341477', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '180.155.119.14', '2019-08-04 11:56:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 11:56:04');
INSERT INTO `access_log` VALUES (62743, '65.45.15648912094851563', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '183.192.12.197', '2019-08-04 12:00:09', 0, 1002001015, '账号未登陆', '2019-08-04 12:00:09');
INSERT INTO `access_log` VALUES (62744, '65.49.15648912094861557', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '183.192.12.197', '2019-08-04 12:00:09', 0, 1002001015, '账号未登陆', '2019-08-04 12:00:09');
INSERT INTO `access_log` VALUES (62745, '65.54.15648912094931481', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '183.192.12.197', '2019-08-04 12:00:09', 1, 1002001015, '账号未登陆', '2019-08-04 12:00:09');
INSERT INTO `access_log` VALUES (62746, '65.52.15648912142661611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '183.192.12.197', '2019-08-04 12:00:14', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 12:00:14');
INSERT INTO `access_log` VALUES (62747, '65.46.15648912246931619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '183.192.12.197', '2019-08-04 12:00:25', 221, 0, '', '2019-08-04 12:00:25');
INSERT INTO `access_log` VALUES (62748, '65.3607.15648912253233373', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '183.192.12.197', '2019-08-04 12:00:25', 10, 0, '', '2019-08-04 12:00:25');
INSERT INTO `access_log` VALUES (62749, '65.47.15648912253411553', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '183.192.12.197', '2019-08-04 12:00:25', 10, 2001001000, '服务端发生异常', '2019-08-04 12:00:25');
INSERT INTO `access_log` VALUES (62750, '65.53.15648912253441563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '183.192.12.197', '2019-08-04 12:00:25', 8, 0, '', '2019-08-04 12:00:25');
INSERT INTO `access_log` VALUES (62751, '59.72.15648922360448985', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3588.400', '120.229.170.180', '2019-08-04 12:17:16', 9, 0, '', '2019-08-04 12:17:16');
INSERT INTO `access_log` VALUES (62752, '59.80.15648922360458961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3588.400', '120.229.170.180', '2019-08-04 12:17:16', 21, 2001001000, '服务端发生异常', '2019-08-04 12:17:16');
INSERT INTO `access_log` VALUES (62753, '59.79.15649000526709099', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.210.207.203', '2019-08-04 14:27:33', 10, 0, '', '2019-08-04 14:27:33');
INSERT INTO `access_log` VALUES (62754, '59.76.15649000526709085', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '27.210.207.203', '2019-08-04 14:27:33', 19, 2001001000, '服务端发生异常', '2019-08-04 14:27:33');
INSERT INTO `access_log` VALUES (62755, '9af2d307-f08f-40b1-8000-e7e912921432', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '0:0:0:0:0:0:0:1', '2019-08-04 15:09:47', 23, 1002001015, '账号未登陆', '2019-08-04 15:09:48');
INSERT INTO `access_log` VALUES (62756, '59.78.15649134035599281', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.193.70.82', '2019-08-04 18:10:04', 12, 0, '', '2019-08-04 18:10:04');
INSERT INTO `access_log` VALUES (62757, '59.73.15649134035599273', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.193.70.82', '2019-08-04 18:10:04', 26, 2001001000, '服务端发生异常', '2019-08-04 18:10:04');
INSERT INTO `access_log` VALUES (62758, '59.71.15649134154859269', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '1.193.70.82', '2019-08-04 18:10:15', 3, 0, '', '2019-08-04 18:10:15');
INSERT INTO `access_log` VALUES (62759, '59.77.15649134154899261', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '1.193.70.82', '2019-08-04 18:10:15', 22, 2001001000, '服务端发生异常', '2019-08-04 18:10:16');
INSERT INTO `access_log` VALUES (62760, '64.83.15649134192379577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '1.193.70.82', '2019-08-04 18:10:19', 13, 0, '', '2019-08-04 18:10:19');
INSERT INTO `access_log` VALUES (62761, '64.77.15649134194869575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '1.193.70.82', '2019-08-04 18:10:19', 3, 0, '', '2019-08-04 18:10:20');
INSERT INTO `access_log` VALUES (62762, '65.45.15649148410721881', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.247.143.26', '2019-08-04 18:34:01', 1, 1002001015, '账号未登陆', '2019-08-04 18:34:01');
INSERT INTO `access_log` VALUES (62763, '65.54.15649148410711797', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.247.143.26', '2019-08-04 18:34:01', 1, 1002001015, '账号未登陆', '2019-08-04 18:34:01');
INSERT INTO `access_log` VALUES (62764, '65.51.15649148410711957', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.247.143.26', '2019-08-04 18:34:01', 1, 1002001015, '账号未登陆', '2019-08-04 18:34:01');
INSERT INTO `access_log` VALUES (62765, '65.49.15649148460111875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.247.143.26', '2019-08-04 18:34:06', 87, 0, '', '2019-08-04 18:34:06');
INSERT INTO `access_log` VALUES (62766, '65.50.15649148463241889', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.247.143.26', '2019-08-04 18:34:06', 16, 0, '', '2019-08-04 18:34:06');
INSERT INTO `access_log` VALUES (62767, '65.52.15649148463291929', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.247.143.26', '2019-08-04 18:34:06', 14, 2001001000, '服务端发生异常', '2019-08-04 18:34:06');
INSERT INTO `access_log` VALUES (62768, '65.46.15649148463341937', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '222.247.143.26', '2019-08-04 18:34:06', 10, 0, '', '2019-08-04 18:34:06');
INSERT INTO `access_log` VALUES (62769, '50043d64-69c9-456e-95b9-b317e59a1c7a', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '0:0:0:0:0:0:0:1', '2019-08-04 20:02:42', 15, 1002001015, '账号未登陆', '2019-08-04 20:02:42');
INSERT INTO `access_log` VALUES (62770, '65.46.15649239438552059', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.47.41.157', '2019-08-04 21:05:44', 0, 1002001015, '账号未登陆', '2019-08-04 21:05:44');
INSERT INTO `access_log` VALUES (62771, '65.52.15649239438602051', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.47.41.157', '2019-08-04 21:05:44', 1, 1002001015, '账号未登陆', '2019-08-04 21:05:44');
INSERT INTO `access_log` VALUES (62772, '65.50.15649239438552011', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.47.41.157', '2019-08-04 21:05:44', 1, 1002001015, '账号未登陆', '2019-08-04 21:05:44');
INSERT INTO `access_log` VALUES (62773, '65.3607.15649239535533813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.47.41.157', '2019-08-04 21:05:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 21:05:54');
INSERT INTO `access_log` VALUES (62774, '65.53.15649239601422001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.47.41.157', '2019-08-04 21:06:00', 113, 0, '', '2019-08-04 21:06:00');
INSERT INTO `access_log` VALUES (62775, '65.51.15649239618102081', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.47.41.157', '2019-08-04 21:06:02', 15, 0, '', '2019-08-04 21:06:02');
INSERT INTO `access_log` VALUES (62776, '65.54.15649239618081921', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.47.41.157', '2019-08-04 21:06:02', 21, 0, '', '2019-08-04 21:06:02');
INSERT INTO `access_log` VALUES (62777, '65.45.15649239618092005', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.47.41.157', '2019-08-04 21:06:02', 19, 2001001000, '服务端发生异常', '2019-08-04 21:06:02');
INSERT INTO `access_log` VALUES (62778, '65.3607.15649240203223815', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.47.41.157', '2019-08-04 21:07:00', 11, 0, '', '2019-08-04 21:07:00');
INSERT INTO `access_log` VALUES (62779, '65.47.15649240203311995', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.47.41.157', '2019-08-04 21:07:00', 9, 2001001000, '服务端发生异常', '2019-08-04 21:07:00');
INSERT INTO `access_log` VALUES (62780, '65.53.15649240204562003', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.47.41.157', '2019-08-04 21:07:00', 9, 0, '', '2019-08-04 21:07:00');
INSERT INTO `access_log` VALUES (62781, '59.71.15649244871149417', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.250.18.215', '2019-08-04 21:14:47', 15, 0, '', '2019-08-04 21:14:47');
INSERT INTO `access_log` VALUES (62782, '59.77.15649244871149409', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '220.250.18.215', '2019-08-04 21:14:47', 19, 2001001000, '服务端发生异常', '2019-08-04 21:14:47');
INSERT INTO `access_log` VALUES (62783, '65.49.15649247030712011', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.10.251.173', '2019-08-04 21:18:23', 0, 1002001015, '账号未登陆', '2019-08-04 21:18:23');
INSERT INTO `access_log` VALUES (62784, '65.50.15649252768842033', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:27:57', 1, 1002001015, '账号未登陆', '2019-08-04 21:27:57');
INSERT INTO `access_log` VALUES (62785, '65.49.15649252768832019', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:27:57', 0, 1002001015, '账号未登陆', '2019-08-04 21:27:57');
INSERT INTO `access_log` VALUES (62786, '65.52.15649252768842073', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:27:57', 1, 1002001015, '账号未登陆', '2019-08-04 21:27:57');
INSERT INTO `access_log` VALUES (62787, '65.47.15649252791772013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:27:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 21:27:59');
INSERT INTO `access_log` VALUES (62788, '65.3607.15649252830233835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:03', 104, 0, '', '2019-08-04 21:28:03');
INSERT INTO `access_log` VALUES (62789, '65.51.15649252834432101', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:03', 15, 0, '', '2019-08-04 21:28:03');
INSERT INTO `access_log` VALUES (62790, '65.53.15649252834452021', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:03', 15, 0, '', '2019-08-04 21:28:03');
INSERT INTO `access_log` VALUES (62791, '65.45.15649252834452025', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:03', 15, 2001001000, '服务端发生异常', '2019-08-04 21:28:03');
INSERT INTO `access_log` VALUES (62792, '65.46.15649252939732079', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:14', 9, 0, '', '2019-08-04 21:28:14');
INSERT INTO `access_log` VALUES (62793, '65.52.15649252939732075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:14', 11, 2001001000, '服务端发生异常', '2019-08-04 21:28:14');
INSERT INTO `access_log` VALUES (62794, '65.50.15649252939762035', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:14', 9, 0, '', '2019-08-04 21:28:14');
INSERT INTO `access_log` VALUES (62795, '65.47.15649253139612015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 21:28:34');
INSERT INTO `access_log` VALUES (62796, '65.3607.15649253184843837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:38', 4, 1002002001, '密码不正确', '2019-08-04 21:28:38');
INSERT INTO `access_log` VALUES (62797, '65.51.15649253237742103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 21:28:44');
INSERT INTO `access_log` VALUES (62798, '65.53.15649253263822023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:46', 57, 0, '', '2019-08-04 21:28:46');
INSERT INTO `access_log` VALUES (62799, '65.52.15649253267112077', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:47', 9, 0, '', '2019-08-04 21:28:47');
INSERT INTO `access_log` VALUES (62800, '65.54.15649253267111945', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:47', 9, 0, '', '2019-08-04 21:28:47');
INSERT INTO `access_log` VALUES (62801, '65.46.15649253267112081', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:47', 9, 0, '', '2019-08-04 21:28:47');
INSERT INTO `access_log` VALUES (62802, '62.80.15649253314648351', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:28:51', 32, 0, '', '2019-08-04 21:28:52');
INSERT INTO `access_log` VALUES (62803, '65.49.15649253403172023', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:29:00', 18, 0, '', '2019-08-04 21:29:00');
INSERT INTO `access_log` VALUES (62804, '65.47.15649253455052017', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:29:06', 13, 0, '', '2019-08-04 21:29:06');
INSERT INTO `access_log` VALUES (62805, '65.45.15649253523602029', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.67.57', '2019-08-04 21:29:12', 9, 0, '', '2019-08-04 21:29:12');
INSERT INTO `access_log` VALUES (62806, '59.79.15649275447409467', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:05:45', 9, 0, '', '2019-08-04 22:05:45');
INSERT INTO `access_log` VALUES (62807, '59.73.15649275447449463', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:05:45', 14, 2001001000, '服务端发生异常', '2019-08-04 22:05:45');
INSERT INTO `access_log` VALUES (62808, '65.47.15649275486012047', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:05:49', 1, 1002001015, '账号未登陆', '2019-08-04 22:05:49');
INSERT INTO `access_log` VALUES (62809, '65.49.15649275486012053', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:05:49', 1, 1002001015, '账号未登陆', '2019-08-04 22:05:49');
INSERT INTO `access_log` VALUES (62810, '65.3607.15649275486023869', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:05:49', 0, 1002001015, '账号未登陆', '2019-08-04 22:05:49');
INSERT INTO `access_log` VALUES (62811, '64.85.15649275536939803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:05:54', 11, 0, '', '2019-08-04 22:05:54');
INSERT INTO `access_log` VALUES (62812, '64.79.15649275538019767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:05:54', 3, 0, '', '2019-08-04 22:05:54');
INSERT INTO `access_log` VALUES (62813, '64.84.15649275551759767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:05:55', 2, 0, '', '2019-08-04 22:05:55');
INSERT INTO `access_log` VALUES (62814, '64.76.15649275559349769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:05:56', 2, 0, '', '2019-08-04 22:05:56');
INSERT INTO `access_log` VALUES (62815, '65.51.15649275592462135', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:05:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 22:05:59');
INSERT INTO `access_log` VALUES (62816, '65.3607.15649279833323875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:13:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 22:13:03');
INSERT INTO `access_log` VALUES (62817, '65.49.15649280257342063', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:13:46', 100, 0, '', '2019-08-04 22:13:46');
INSERT INTO `access_log` VALUES (62818, '65.50.15649280261422077', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:13:46', 19, 0, '', '2019-08-04 22:13:46');
INSERT INTO `access_log` VALUES (62819, '65.47.15649280261592055', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:13:46', 11, 0, '', '2019-08-04 22:13:46');
INSERT INTO `access_log` VALUES (62820, '65.51.15649280261512143', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:13:46', 11, 2001001000, '服务端发生异常', '2019-08-04 22:13:46');
INSERT INTO `access_log` VALUES (62821, '64.80.15649280467229781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.80.75.225', '2019-08-04 22:14:07', 3, 0, '', '2019-08-04 22:14:07');
INSERT INTO `access_log` VALUES (62822, '59.77.15649295108289477', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.39.248.35', '2019-08-04 22:38:31', 23, 0, '', '2019-08-04 22:38:31');
INSERT INTO `access_log` VALUES (62823, '59.75.15649295108289497', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.39.248.35', '2019-08-04 22:38:31', 15, 2001001000, '服务端发生异常', '2019-08-04 22:38:31');
INSERT INTO `access_log` VALUES (62824, '59.76.15649295448699481', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.39.248.35', '2019-08-04 22:39:05', 3, 0, '', '2019-08-04 22:39:05');
INSERT INTO `access_log` VALUES (62825, '59.74.15649295448699501', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.39.248.35', '2019-08-04 22:39:05', 22, 2001001000, '服务端发生异常', '2019-08-04 22:39:05');
INSERT INTO `access_log` VALUES (62826, '64.78.15649295469679799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.39.248.35', '2019-08-04 22:39:07', 3, 0, '', '2019-08-04 22:39:07');
INSERT INTO `access_log` VALUES (62827, '64.82.15649295471069809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.39.248.35', '2019-08-04 22:39:07', 2, 0, '', '2019-08-04 22:39:07');
INSERT INTO `access_log` VALUES (62828, '64.85.15649295486639831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.39.248.35', '2019-08-04 22:39:09', 2, 0, '', '2019-08-04 22:39:09');
INSERT INTO `access_log` VALUES (62829, '64.79.15649295493699795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.39.248.35', '2019-08-04 22:39:09', 2, 0, '', '2019-08-04 22:39:09');
INSERT INTO `access_log` VALUES (62830, '59.79.15649295507469495', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.39.248.35', '2019-08-04 22:39:11', 2, 0, '', '2019-08-04 22:39:11');
INSERT INTO `access_log` VALUES (62831, '59.73.15649295507469491', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.39.248.35', '2019-08-04 22:39:11', 15, 2001001000, '服务端发生异常', '2019-08-04 22:39:11');
INSERT INTO `access_log` VALUES (62832, '59.77.15649295540499479', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.39.248.35', '2019-08-04 22:39:14', 3, 0, '', '2019-08-04 22:39:14');
INSERT INTO `access_log` VALUES (62833, '59.78.15649295540499499', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.39.248.35', '2019-08-04 22:39:14', 30, 2001001000, '服务端发生异常', '2019-08-04 22:39:14');
INSERT INTO `access_log` VALUES (62834, '65.52.15649322078972171', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.102.237.128', '2019-08-04 23:23:28', 0, 1002001015, '账号未登陆', '2019-08-04 23:23:28');
INSERT INTO `access_log` VALUES (62835, '65.47.15649322078972111', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.102.237.128', '2019-08-04 23:23:28', 0, 1002001015, '账号未登陆', '2019-08-04 23:23:28');
INSERT INTO `access_log` VALUES (62836, '65.46.15649322079142175', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.102.237.128', '2019-08-04 23:23:28', 0, 1002001015, '账号未登陆', '2019-08-04 23:23:28');
INSERT INTO `access_log` VALUES (62837, '65.3607.15649322178693933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.102.237.128', '2019-08-04 23:23:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 23:23:38');
INSERT INTO `access_log` VALUES (62838, '65.45.15649322198942123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.102.237.128', '2019-08-04 23:23:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-04 23:23:40');
INSERT INTO `access_log` VALUES (62839, '65.54.15649322284022043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.102.237.128', '2019-08-04 23:23:48', 74, 0, '', '2019-08-04 23:23:48');
INSERT INTO `access_log` VALUES (62840, '65.49.15649322295732121', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.102.237.128', '2019-08-04 23:23:50', 12, 0, '', '2019-08-04 23:23:50');
INSERT INTO `access_log` VALUES (62841, '65.50.15649322295742135', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.102.237.128', '2019-08-04 23:23:50', 11, 0, '', '2019-08-04 23:23:50');
INSERT INTO `access_log` VALUES (62842, '65.51.15649322295832201', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.102.237.128', '2019-08-04 23:23:50', 9, 2001001000, '服务端发生异常', '2019-08-04 23:23:50');
INSERT INTO `access_log` VALUES (62843, '65.47.15649322522042113', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.102.237.128', '2019-08-04 23:24:12', 10, 0, '', '2019-08-04 23:24:12');
INSERT INTO `access_log` VALUES (62844, '65.53.15649322522082121', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.102.237.128', '2019-08-04 23:24:12', 9, 0, '', '2019-08-04 23:24:12');
INSERT INTO `access_log` VALUES (62845, '65.3607.15649322522083935', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.102.237.128', '2019-08-04 23:24:12', 9, 2001001000, '服务端发生异常', '2019-08-04 23:24:12');
INSERT INTO `access_log` VALUES (62846, '59.80.15649327452119505', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.180', '2019-08-04 23:32:25', 8, 0, '', '2019-08-04 23:32:25');
INSERT INTO `access_log` VALUES (62847, '59.76.15649327452139525', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.180', '2019-08-04 23:32:25', 15, 2001001000, '服务端发生异常', '2019-08-04 23:32:25');
INSERT INTO `access_log` VALUES (62848, '65.50.15649327582552143', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.180', '2019-08-04 23:32:38', 1, 1002001015, '账号未登陆', '2019-08-04 23:32:38');
INSERT INTO `access_log` VALUES (62849, '65.49.15649327582642129', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.180', '2019-08-04 23:32:38', 0, 1002001015, '账号未登陆', '2019-08-04 23:32:38');
INSERT INTO `access_log` VALUES (62850, '65.46.15649327582802185', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.180', '2019-08-04 23:32:38', 0, 1002001015, '账号未登陆', '2019-08-04 23:32:38');
INSERT INTO `access_log` VALUES (62851, '65.3607.15649327680583943', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.180', '2019-08-04 23:32:48', 63, 0, '', '2019-08-04 23:32:48');
INSERT INTO `access_log` VALUES (62852, '65.53.15649327684652129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.180', '2019-08-04 23:32:48', 197, 0, '', '2019-08-04 23:32:49');
INSERT INTO `access_log` VALUES (62853, '65.47.15649327684682121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.180', '2019-08-04 23:32:48', 200, 2001001000, '服务端发生异常', '2019-08-04 23:32:49');
INSERT INTO `access_log` VALUES (62854, '65.45.15649327684742133', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.180', '2019-08-04 23:32:48', 195, 0, '', '2019-08-04 23:32:49');
INSERT INTO `access_log` VALUES (62855, '65.51.15649327744162211', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.180', '2019-08-04 23:32:54', 10, 0, '', '2019-08-04 23:32:54');
INSERT INTO `access_log` VALUES (62856, '65.50.15649327744222145', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.180', '2019-08-04 23:32:54', 10, 2001001000, '服务端发生异常', '2019-08-04 23:32:54');
INSERT INTO `access_log` VALUES (62857, '65.46.15649327744272187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.180', '2019-08-04 23:32:54', 8, 0, '', '2019-08-04 23:32:54');
INSERT INTO `access_log` VALUES (62858, '65.50.15649359443692189', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '157.255.17.17', '2019-08-05 00:25:44', 0, 1002001015, '账号未登陆', '2019-08-05 00:25:44');
INSERT INTO `access_log` VALUES (62859, '65.50.15649671364712605', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.142.231', '2019-08-05 09:05:36', 1, 1002001015, '账号未登陆', '2019-08-05 09:05:36');
INSERT INTO `access_log` VALUES (62860, '65.49.15649671365022589', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.142.231', '2019-08-05 09:05:37', 1, 1002001015, '账号未登陆', '2019-08-05 09:05:37');
INSERT INTO `access_log` VALUES (62861, '65.52.15649671365072641', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.142.231', '2019-08-05 09:05:37', 0, 1002001015, '账号未登陆', '2019-08-05 09:05:37');
INSERT INTO `access_log` VALUES (62862, '65.47.15649685325962601', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '42.120.75.142', '2019-08-05 09:28:53', 0, 1002001015, '账号未登陆', '2019-08-05 09:28:53');
INSERT INTO `access_log` VALUES (62863, '65.54.15649685325972533', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '42.120.75.142', '2019-08-05 09:28:53', 1, 1002001015, '账号未登陆', '2019-08-05 09:28:53');
INSERT INTO `access_log` VALUES (62864, '65.51.15649685325972691', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '42.120.75.142', '2019-08-05 09:28:53', 0, 1002001015, '账号未登陆', '2019-08-05 09:28:53');
INSERT INTO `access_log` VALUES (62865, '65.50.15649685400112625', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '42.120.75.142', '2019-08-05 09:29:00', 86, 0, '', '2019-08-05 09:29:00');
INSERT INTO `access_log` VALUES (62866, '65.49.15649685404062609', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '42.120.75.142', '2019-08-05 09:29:00', 20, 0, '', '2019-08-05 09:29:00');
INSERT INTO `access_log` VALUES (62867, '65.52.15649685404072661', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '42.120.75.142', '2019-08-05 09:29:00', 22, 2001001000, '服务端发生异常', '2019-08-05 09:29:00');
INSERT INTO `access_log` VALUES (62868, '65.3607.15649685404174425', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '42.120.75.142', '2019-08-05 09:29:00', 13, 0, '', '2019-08-05 09:29:00');
INSERT INTO `access_log` VALUES (62869, '65.45.15649685473202611', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '42.120.75.142', '2019-08-05 09:29:07', 75, 0, '', '2019-08-05 09:29:07');
INSERT INTO `access_log` VALUES (62870, '65.54.15649685473262535', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '42.120.75.142', '2019-08-05 09:29:07', 71, 0, '', '2019-08-05 09:29:07');
INSERT INTO `access_log` VALUES (62871, '65.53.15649685473222609', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '42.120.75.142', '2019-08-05 09:29:07', 74, 2001001000, '服务端发生异常', '2019-08-05 09:29:07');
INSERT INTO `access_log` VALUES (62872, '65.3607.15649696674104441', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.16.225.121', '2019-08-05 09:47:47', 0, 1002001015, '账号未登陆', '2019-08-05 09:47:47');
INSERT INTO `access_log` VALUES (62873, '65.53.15649696674102625', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.16.226.158', '2019-08-05 09:47:47', 1, 1002001015, '账号未登陆', '2019-08-05 09:47:47');
INSERT INTO `access_log` VALUES (62874, '65.52.15649696674092677', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.16.244.92', '2019-08-05 09:47:47', 0, 1002001015, '账号未登陆', '2019-08-05 09:47:47');
INSERT INTO `access_log` VALUES (62875, '65.54.15649696694532551', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.16.250.227', '2019-08-05 09:47:49', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 09:47:49');
INSERT INTO `access_log` VALUES (62876, '65.51.15649696823182709', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.232.156.224', '2019-08-05 09:48:02', 101, 0, '', '2019-08-05 09:48:02');
INSERT INTO `access_log` VALUES (62877, '65.47.15649696827382619', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.232.156.224', '2019-08-05 09:48:03', 78, 0, '', '2019-08-05 09:48:03');
INSERT INTO `access_log` VALUES (62878, '65.50.15649696827382643', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.16.250.227', '2019-08-05 09:48:03', 80, 0, '', '2019-08-05 09:48:03');
INSERT INTO `access_log` VALUES (62879, '65.46.15649696827382685', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.16.226.244', '2019-08-05 09:48:03', 80, 2001001000, '服务端发生异常', '2019-08-05 09:48:03');
INSERT INTO `access_log` VALUES (62880, '65.3607.15649696903154443', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.16.226.244', '2019-08-05 09:48:10', 9, 0, '', '2019-08-05 09:48:10');
INSERT INTO `access_log` VALUES (62881, '65.53.15649696903202627', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.16.250.227', '2019-08-05 09:48:10', 11, 2001001000, '服务端发生异常', '2019-08-05 09:48:10');
INSERT INTO `access_log` VALUES (62882, '65.52.15649696903222679', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.16.226.158', '2019-08-05 09:48:10', 9, 0, '', '2019-08-05 09:48:10');
INSERT INTO `access_log` VALUES (62883, '65.53.15649712954292649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.142.231', '2019-08-05 10:14:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 10:14:55');
INSERT INTO `access_log` VALUES (62884, '65.52.15649712984172701', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.142.231', '2019-08-05 10:14:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 10:14:58');
INSERT INTO `access_log` VALUES (62885, '65.3607.15649712993544465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.142.231', '2019-08-05 10:14:59', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 10:14:59');
INSERT INTO `access_log` VALUES (62886, '65.54.15649713035812575', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.142.231', '2019-08-05 10:15:04', 5, 1002002001, '密码不正确', '2019-08-05 10:15:04');
INSERT INTO `access_log` VALUES (62887, '65.51.15649713094382733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.142.231', '2019-08-05 10:15:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 10:15:09');
INSERT INTO `access_log` VALUES (62888, '65.52.15649713898012703', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.142.231', '2019-08-05 10:16:30', 92, 0, '', '2019-08-05 10:16:30');
INSERT INTO `access_log` VALUES (62889, '65.3607.15649713902554467', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.142.231', '2019-08-05 10:16:30', 10, 0, '', '2019-08-05 10:16:30');
INSERT INTO `access_log` VALUES (62890, '65.54.15649713902562577', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.142.231', '2019-08-05 10:16:30', 10, 0, '', '2019-08-05 10:16:30');
INSERT INTO `access_log` VALUES (62891, '65.45.15649713902972653', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.142.231', '2019-08-05 10:16:30', 9, 0, '', '2019-08-05 10:16:30');
INSERT INTO `access_log` VALUES (62892, '62.83.15649713950358983', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.142.231', '2019-08-05 10:16:35', 28, 0, '', '2019-08-05 10:16:35');
INSERT INTO `access_log` VALUES (62893, '65.53.15649729423622671', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-08-05 10:42:22', 4, 1002001012, '访问令牌已过期', '2019-08-05 10:42:22');
INSERT INTO `access_log` VALUES (62894, '65.50.15649729423622691', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-08-05 10:42:22', 4, 1002001012, '访问令牌已过期', '2019-08-05 10:42:22');
INSERT INTO `access_log` VALUES (62895, '65.46.15649729423622731', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-08-05 10:42:22', 4, 1002001012, '访问令牌已过期', '2019-08-05 10:42:22');
INSERT INTO `access_log` VALUES (62896, '65.3607.15649729461764489', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-08-05 10:42:26', 80, 0, '', '2019-08-05 10:42:26');
INSERT INTO `access_log` VALUES (62897, '65.51.15649729464122759', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-08-05 10:42:26', 8, 0, '', '2019-08-05 10:42:26');
INSERT INTO `access_log` VALUES (62898, '65.47.15649729464162669', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-08-05 10:42:26', 7, 0, '', '2019-08-05 10:42:26');
INSERT INTO `access_log` VALUES (62899, '65.45.15649729464162677', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-08-05 10:42:26', 8, 2001001000, '服务端发生异常', '2019-08-05 10:42:26');
INSERT INTO `access_log` VALUES (62900, '65.54.15649729531522601', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-08-05 10:42:33', 10, 0, '', '2019-08-05 10:42:33');
INSERT INTO `access_log` VALUES (62901, '65.49.15649729531532675', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-08-05 10:42:33', 17, 2001001000, '服务端发生异常', '2019-08-05 10:42:33');
INSERT INTO `access_log` VALUES (62902, '65.53.15649729531582673', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '180.168.134.212', '2019-08-05 10:42:33', 15, 0, '', '2019-08-05 10:42:33');
INSERT INTO `access_log` VALUES (62903, '59.71.15649730355590067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.235.29.230', '2019-08-05 10:43:56', 11, 0, '', '2019-08-05 10:43:56');
INSERT INTO `access_log` VALUES (62904, '59.72.15649730355640067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.235.29.230', '2019-08-05 10:43:56', 25, 2001001000, '服务端发生异常', '2019-08-05 10:43:56');
INSERT INTO `access_log` VALUES (62905, '64.79.15649730382940375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.235.29.230', '2019-08-05 10:43:58', 12, 0, '', '2019-08-05 10:43:58');
INSERT INTO `access_log` VALUES (62906, '64.84.15649730384070375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.235.29.230', '2019-08-05 10:43:58', 3, 0, '', '2019-08-05 10:43:58');
INSERT INTO `access_log` VALUES (62907, '64.76.15649730394440377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.235.29.230', '2019-08-05 10:43:59', 2, 0, '', '2019-08-05 10:43:59');
INSERT INTO `access_log` VALUES (62908, '64.81.15649730398900381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.235.29.230', '2019-08-05 10:44:00', 2, 0, '', '2019-08-05 10:44:00');
INSERT INTO `access_log` VALUES (62909, '64.83.15649730402200375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.235.29.230', '2019-08-05 10:44:00', 2, 0, '', '2019-08-05 10:44:00');
INSERT INTO `access_log` VALUES (62910, '59.80.15649730426570043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.235.29.230', '2019-08-05 10:44:03', 2, 0, '', '2019-08-05 10:44:03');
INSERT INTO `access_log` VALUES (62911, '59.76.15649730426570063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.235.29.230', '2019-08-05 10:44:03', 18, 2001001000, '服务端发生异常', '2019-08-05 10:44:03');
INSERT INTO `access_log` VALUES (62912, '59.75.15649738099630091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:56:50', 10, 0, '', '2019-08-05 10:56:50');
INSERT INTO `access_log` VALUES (62913, '59.78.15649738099610091', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:56:50', 28, 2001001000, '服务端发生异常', '2019-08-05 10:56:50');
INSERT INTO `access_log` VALUES (62914, '64.82.15649738214340401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:01', 9, 0, '', '2019-08-05 10:57:01');
INSERT INTO `access_log` VALUES (62915, '64.79.15649738216070387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:02', 9, 0, '', '2019-08-05 10:57:02');
INSERT INTO `access_log` VALUES (62916, '64.76.15649738229500389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:03', 11, 0, '', '2019-08-05 10:57:03');
INSERT INTO `access_log` VALUES (62917, '64.83.15649738236290387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:04', 8, 0, '', '2019-08-05 10:57:04');
INSERT INTO `access_log` VALUES (62918, '64.80.15649738300070395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:10', 9, 0, '', '2019-08-05 10:57:10');
INSERT INTO `access_log` VALUES (62919, '64.78.15649738301720393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:10', 8, 0, '', '2019-08-05 10:57:10');
INSERT INTO `access_log` VALUES (62920, '59.72.15649738309570079', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:11', 10, 0, '', '2019-08-05 10:57:11');
INSERT INTO `access_log` VALUES (62921, '59.80.15649738309580055', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:11', 20, 2001001000, '服务端发生异常', '2019-08-05 10:57:11');
INSERT INTO `access_log` VALUES (62922, '64.82.15649738334860403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:13', 9, 0, '', '2019-08-05 10:57:13');
INSERT INTO `access_log` VALUES (62923, '64.85.15649738336180425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:14', 7, 0, '', '2019-08-05 10:57:14');
INSERT INTO `access_log` VALUES (62924, '59.74.15649738351200095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:15', 18, 0, '', '2019-08-05 10:57:15');
INSERT INTO `access_log` VALUES (62925, '59.76.15649738351200075', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:15', 22, 2001001000, '服务端发生异常', '2019-08-05 10:57:15');
INSERT INTO `access_log` VALUES (62926, '65.50.15649738523872705', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:32', 4, 1002001012, '访问令牌已过期', '2019-08-05 10:57:32');
INSERT INTO `access_log` VALUES (62927, '65.46.15649738523942745', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:32', 3, 1002001012, '访问令牌已过期', '2019-08-05 10:57:32');
INSERT INTO `access_log` VALUES (62928, '65.52.15649738523942737', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:32', 3, 1002001012, '访问令牌已过期', '2019-08-05 10:57:32');
INSERT INTO `access_log` VALUES (62929, '65.51.15649738620422773', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=test&password=test&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:57:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位\n账号长度为 5-16 位', '2019-08-05 10:57:42');
INSERT INTO `access_log` VALUES (62930, '65.47.15649738797012683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:58:00', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 10:58:00');
INSERT INTO `access_log` VALUES (62931, '65.53.15649738843122687', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:58:04', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 10:58:04');
INSERT INTO `access_log` VALUES (62932, '65.49.15649738986202689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:58:19', 78, 0, '', '2019-08-05 10:58:19');
INSERT INTO `access_log` VALUES (62933, '65.52.15649738989472739', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:58:19', 17, 0, '', '2019-08-05 10:58:19');
INSERT INTO `access_log` VALUES (62934, '65.50.15649738989572707', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:58:19', 10, 2001001000, '服务端发生异常', '2019-08-05 10:58:19');
INSERT INTO `access_log` VALUES (62935, '65.46.15649738989592747', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.8 Safari/537.36', '121.35.101.254', '2019-08-05 10:58:19', 9, 0, '', '2019-08-05 10:58:19');
INSERT INTO `access_log` VALUES (62936, '65.54.15649748668362629', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:14:27', 0, 1002001015, '账号未登陆', '2019-08-05 11:14:27');
INSERT INTO `access_log` VALUES (62937, '65.49.15649748668372703', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:14:27', 0, 1002001015, '账号未登陆', '2019-08-05 11:14:27');
INSERT INTO `access_log` VALUES (62938, '65.46.15649748668402761', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:14:27', 0, 1002001015, '账号未登陆', '2019-08-05 11:14:27');
INSERT INTO `access_log` VALUES (62939, '65.52.15649748690452753', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:14:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 11:14:29');
INSERT INTO `access_log` VALUES (62940, '65.50.15649748722012721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:14:32', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 11:14:32');
INSERT INTO `access_log` VALUES (62941, '65.51.15649748846492789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:14:45', 121, 0, '', '2019-08-05 11:14:45');
INSERT INTO `access_log` VALUES (62942, '65.45.15649748852752707', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:14:45', 8, 0, '', '2019-08-05 11:14:45');
INSERT INTO `access_log` VALUES (62943, '65.47.15649748852872699', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:14:45', 8, 2001001000, '服务端发生异常', '2019-08-05 11:14:45');
INSERT INTO `access_log` VALUES (62944, '65.53.15649748852972703', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:14:45', 8, 0, '', '2019-08-05 11:14:45');
INSERT INTO `access_log` VALUES (62945, '65.49.15649749008822705', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:15:01', 9, 0, '', '2019-08-05 11:15:01');
INSERT INTO `access_log` VALUES (62946, '65.54.15649749008932631', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:15:01', 13, 2001001000, '服务端发生异常', '2019-08-05 11:15:01');
INSERT INTO `access_log` VALUES (62947, '65.52.15649749009022755', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:15:01', 9, 0, '', '2019-08-05 11:15:01');
INSERT INTO `access_log` VALUES (62948, '65.50.15649749082262723', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:15:08', 8, 0, '', '2019-08-05 11:15:08');
INSERT INTO `access_log` VALUES (62949, '65.3607.15649749082284521', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:15:08', 10, 2001001000, '服务端发生异常', '2019-08-05 11:15:08');
INSERT INTO `access_log` VALUES (62950, '65.51.15649749082372791', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.187.64.210', '2019-08-05 11:15:08', 9, 0, '', '2019-08-05 11:15:08');
INSERT INTO `access_log` VALUES (62951, '59.79.15649754820480111', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '117.136.2.176', '2019-08-05 11:24:42', 3, 0, '', '2019-08-05 11:24:42');
INSERT INTO `access_log` VALUES (62952, '59.73.15649754820540107', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '117.136.2.176', '2019-08-05 11:24:42', 24, 2001001000, '服务端发生异常', '2019-08-05 11:24:42');
INSERT INTO `access_log` VALUES (62953, '65.50.15649754890172731', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '117.136.2.176', '2019-08-05 11:24:49', 4, 1002001012, '访问令牌已过期', '2019-08-05 11:24:49');
INSERT INTO `access_log` VALUES (62954, '65.53.15649754890172713', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '117.136.2.176', '2019-08-05 11:24:49', 3, 1002001012, '访问令牌已过期', '2019-08-05 11:24:49');
INSERT INTO `access_log` VALUES (62955, '65.45.15649754890182717', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '117.136.2.176', '2019-08-05 11:24:49', 3, 1002001012, '访问令牌已过期', '2019-08-05 11:24:49');
INSERT INTO `access_log` VALUES (62956, '65.46.15649754991032773', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '117.136.2.176', '2019-08-05 11:24:59', 214, 0, '', '2019-08-05 11:24:59');
INSERT INTO `access_log` VALUES (62957, '65.54.15649754997062641', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '117.136.2.176', '2019-08-05 11:25:00', 17, 0, '', '2019-08-05 11:25:00');
INSERT INTO `access_log` VALUES (62958, '65.52.15649754997122765', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '117.136.2.176', '2019-08-05 11:25:00', 16, 2001001000, '服务端发生异常', '2019-08-05 11:25:00');
INSERT INTO `access_log` VALUES (62959, '65.49.15649754997132715', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '117.136.2.176', '2019-08-05 11:25:00', 16, 0, '', '2019-08-05 11:25:00');
INSERT INTO `access_log` VALUES (62960, '65.49.15649772798792739', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.107.21.200', '2019-08-05 11:54:40', 1, 1002001015, '账号未登陆', '2019-08-05 11:54:40');
INSERT INTO `access_log` VALUES (62961, '65.3607.15649772798804555', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.107.21.200', '2019-08-05 11:54:40', 0, 1002001015, '账号未登陆', '2019-08-05 11:54:40');
INSERT INTO `access_log` VALUES (62962, '65.51.15649772798802825', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.107.21.200', '2019-08-05 11:54:40', 1, 1002001015, '账号未登陆', '2019-08-05 11:54:40');
INSERT INTO `access_log` VALUES (62963, '65.53.15649772839022739', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.107.21.200', '2019-08-05 11:54:44', 397, 0, '', '2019-08-05 11:54:44');
INSERT INTO `access_log` VALUES (62964, '65.45.15649772845092743', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.107.21.200', '2019-08-05 11:54:45', 16, 0, '', '2019-08-05 11:54:45');
INSERT INTO `access_log` VALUES (62965, '65.50.15649772845132757', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.107.21.200', '2019-08-05 11:54:45', 17, 2001001000, '服务端发生异常', '2019-08-05 11:54:45');
INSERT INTO `access_log` VALUES (62966, '65.47.15649772845232735', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.107.21.200', '2019-08-05 11:54:45', 9, 0, '', '2019-08-05 11:54:45');
INSERT INTO `access_log` VALUES (62967, '59.71.15649777831340133', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.253', '2019-08-05 12:03:03', 13, 0, '', '2019-08-05 12:03:03');
INSERT INTO `access_log` VALUES (62968, '59.72.15649777831360133', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.253', '2019-08-05 12:03:03', 14, 2001001000, '服务端发生异常', '2019-08-05 12:03:03');
INSERT INTO `access_log` VALUES (62969, '65.51.15649778003312833', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.253', '2019-08-05 12:03:20', 3, 1002001012, '访问令牌已过期', '2019-08-05 12:03:20');
INSERT INTO `access_log` VALUES (62970, '65.49.15649778003322747', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.253', '2019-08-05 12:03:20', 3, 1002001012, '访问令牌已过期', '2019-08-05 12:03:20');
INSERT INTO `access_log` VALUES (62971, '65.53.15649778003332747', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.253', '2019-08-05 12:03:20', 3, 1002001012, '访问令牌已过期', '2019-08-05 12:03:20');
INSERT INTO `access_log` VALUES (62972, '65.45.15649778022522751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.253', '2019-08-05 12:03:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 12:03:22');
INSERT INTO `access_log` VALUES (62973, '65.46.15649778232802807', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.253', '2019-08-05 12:03:43', 69, 0, '', '2019-08-05 12:03:43');
INSERT INTO `access_log` VALUES (62974, '65.52.15649778235942799', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.253', '2019-08-05 12:03:44', 17, 0, '', '2019-08-05 12:03:44');
INSERT INTO `access_log` VALUES (62975, '65.54.15649778235942675', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.253', '2019-08-05 12:03:44', 17, 0, '', '2019-08-05 12:03:44');
INSERT INTO `access_log` VALUES (62976, '65.3607.15649778235954565', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.88.162.253', '2019-08-05 12:03:44', 16, 2001001000, '服务端发生异常', '2019-08-05 12:03:44');
INSERT INTO `access_log` VALUES (62977, '59.73.15649778436650139', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.140.248.98', '2019-08-05 12:04:04', 3, 0, '', '2019-08-05 12:04:04');
INSERT INTO `access_log` VALUES (62978, '59.77.15649778436650127', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.140.248.98', '2019-08-05 12:04:04', 34, 2001001000, '服务端发生异常', '2019-08-05 12:04:04');
INSERT INTO `access_log` VALUES (62979, '59.78.15649778513340147', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.140.248.98', '2019-08-05 12:04:11', 2, 0, '', '2019-08-05 12:04:11');
INSERT INTO `access_log` VALUES (62980, '59.72.15649778513340135', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '113.140.248.98', '2019-08-05 12:04:11', 19, 2001001000, '服务端发生异常', '2019-08-05 12:04:11');
INSERT INTO `access_log` VALUES (62981, '59.75.15649822993810207', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.109.78.253', '2019-08-05 13:18:19', 10, 0, '', '2019-08-05 13:18:19');
INSERT INTO `access_log` VALUES (62982, '59.72.15649822993810195', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.109.78.253', '2019-08-05 13:18:19', 18, 2001001000, '服务端发生异常', '2019-08-05 13:18:19');
INSERT INTO `access_log` VALUES (62983, '64.80.15649823285620509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.109.78.253', '2019-08-05 13:18:49', 11, 0, '', '2019-08-05 13:18:49');
INSERT INTO `access_log` VALUES (62984, '64.78.15649823287860507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.109.78.253', '2019-08-05 13:18:49', 3, 0, '', '2019-08-05 13:18:49');
INSERT INTO `access_log` VALUES (62985, '64.82.15649823302920517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.109.78.253', '2019-08-05 13:18:50', 2, 0, '', '2019-08-05 13:18:50');
INSERT INTO `access_log` VALUES (62986, '64.79.15649823307570503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.109.78.253', '2019-08-05 13:18:51', 2, 0, '', '2019-08-05 13:18:51');
INSERT INTO `access_log` VALUES (62987, '59.78.15649827549970213', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:25:55', 3, 0, '', '2019-08-05 13:25:55');
INSERT INTO `access_log` VALUES (62988, '59.71.15649827550780201', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:25:55', 13, 2001001000, '服务端发生异常', '2019-08-05 13:25:55');
INSERT INTO `access_log` VALUES (62989, '64.85.15649827598820545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:26:00', 2, 0, '', '2019-08-05 13:26:00');
INSERT INTO `access_log` VALUES (62990, '64.79.15649827600250509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:26:00', 2, 0, '', '2019-08-05 13:26:00');
INSERT INTO `access_log` VALUES (62991, '64.84.15649827615190509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:26:02', 2, 0, '', '2019-08-05 13:26:02');
INSERT INTO `access_log` VALUES (62992, '64.76.15649827619470511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:26:02', 2, 0, '', '2019-08-05 13:26:02');
INSERT INTO `access_log` VALUES (62993, '59.74.15649827761380217', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:26:16', 6, 0, '', '2019-08-05 13:26:16');
INSERT INTO `access_log` VALUES (62994, '59.76.15649827761400197', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:26:16', 21, 2001001000, '服务端发生异常', '2019-08-05 13:26:16');
INSERT INTO `access_log` VALUES (62995, '64.80.15649829558130519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:16', 2, 0, '', '2019-08-05 13:29:16');
INSERT INTO `access_log` VALUES (62996, '64.78.15649829559400517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:16', 2, 0, '', '2019-08-05 13:29:16');
INSERT INTO `access_log` VALUES (62997, '64.82.15649829569340527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:17', 2, 0, '', '2019-08-05 13:29:17');
INSERT INTO `access_log` VALUES (62998, '64.85.15649829573950549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:17', 3, 0, '', '2019-08-05 13:29:17');
INSERT INTO `access_log` VALUES (62999, '59.77.15649829582750197', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:18', 3, 0, '', '2019-08-05 13:29:18');
INSERT INTO `access_log` VALUES (63000, '59.75.15649829583130217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:18', 13, 2001001000, '服务端发生异常', '2019-08-05 13:29:18');
INSERT INTO `access_log` VALUES (63001, '64.79.15649829600630513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:20', 2, 0, '', '2019-08-05 13:29:20');
INSERT INTO `access_log` VALUES (63002, '64.84.15649829601740513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:20', 2, 0, '', '2019-08-05 13:29:20');
INSERT INTO `access_log` VALUES (63003, '64.81.15649829610450519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:21', 2, 0, '', '2019-08-05 13:29:21');
INSERT INTO `access_log` VALUES (63004, '64.83.15649829613950513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:21', 2, 0, '', '2019-08-05 13:29:21');
INSERT INTO `access_log` VALUES (63005, '59.71.15649829618550205', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:22', 2, 0, '', '2019-08-05 13:29:22');
INSERT INTO `access_log` VALUES (63006, '59.78.15649829618540217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:22', 22, 2001001000, '服务端发生异常', '2019-08-05 13:29:22');
INSERT INTO `access_log` VALUES (63007, '64.77.15649829645980511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:25', 2, 0, '', '2019-08-05 13:29:25');
INSERT INTO `access_log` VALUES (63008, '64.80.15649829647100521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:25', 1, 0, '', '2019-08-05 13:29:25');
INSERT INTO `access_log` VALUES (63009, '66.57.15649829757897909', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13225080352', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:36', 99, 0, '', '2019-08-05 13:29:36');
INSERT INTO `access_log` VALUES (63010, '66.52.15649829829407899', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13225080352&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:43', 201, 0, '', '2019-08-05 13:29:43');
INSERT INTO `access_log` VALUES (63011, '64.79.15649829916480515', 192, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:52', 12, 0, '', '2019-08-05 13:29:52');
INSERT INTO `access_log` VALUES (63012, '64.76.15649829918020517', 192, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:52', 5, 0, '', '2019-08-05 13:29:52');
INSERT INTO `access_log` VALUES (63013, '59.77.15649829929100199', 192, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:53', 5, 0, '', '2019-08-05 13:29:53');
INSERT INTO `access_log` VALUES (63014, '59.73.15649829929090211', 192, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:53', 25, 2001001000, '服务端发生异常', '2019-08-05 13:29:53');
INSERT INTO `access_log` VALUES (63015, '66.51.15649829949997927', 192, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:55', 6, 0, '', '2019-08-05 13:29:55');
INSERT INTO `access_log` VALUES (63016, '66.56.15649829958957927', 192, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:56', 5, 0, '', '2019-08-05 13:29:56');
INSERT INTO `access_log` VALUES (63017, '66.48.15649829988787915', 192, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:29:59', 5, 0, '', '2019-08-05 13:29:59');
INSERT INTO `access_log` VALUES (63018, '66.50.15649830046997903', 192, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.23.15.115', '2019-08-05 13:30:05', 6, 0, '', '2019-08-05 13:30:05');
INSERT INTO `access_log` VALUES (63019, '59.76.15649830810360203', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.241.176.178', '2019-08-05 13:31:21', 3, 0, '', '2019-08-05 13:31:21');
INSERT INTO `access_log` VALUES (63020, '59.79.15649830810380217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.241.176.178', '2019-08-05 13:31:21', 38, 2001001000, '服务端发生异常', '2019-08-05 13:31:21');
INSERT INTO `access_log` VALUES (63021, '64.85.15649830849490553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.241.176.178', '2019-08-05 13:31:25', 2, 0, '', '2019-08-05 13:31:25');
INSERT INTO `access_log` VALUES (63022, '64.79.15649830850710517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.241.176.178', '2019-08-05 13:31:25', 2, 0, '', '2019-08-05 13:31:25');
INSERT INTO `access_log` VALUES (63023, '64.84.15649830879410517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.241.176.178', '2019-08-05 13:31:28', 2, 0, '', '2019-08-05 13:31:28');
INSERT INTO `access_log` VALUES (63024, '64.76.15649830880410519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Opera/9.80 (Windows NT 6.0) Presto/2.12.388 Version/12.14', '218.241.176.178', '2019-08-05 13:31:28', 2, 0, '', '2019-08-05 13:31:28');
INSERT INTO `access_log` VALUES (63025, '65.51.15649834224362909', 0, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.12.130.199', '2019-08-05 13:37:02', 0, 1002001015, '账号未登陆', '2019-08-05 13:37:02');
INSERT INTO `access_log` VALUES (63026, '65.45.15649839717922837', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '113.87.225.28', '2019-08-05 13:46:12', 12, 1002001012, '访问令牌已过期', '2019-08-05 13:46:12');
INSERT INTO `access_log` VALUES (63027, '65.53.15649839717922831', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '113.87.225.28', '2019-08-05 13:46:12', 11, 1002001012, '访问令牌已过期', '2019-08-05 13:46:12');
INSERT INTO `access_log` VALUES (63028, '65.51.15649839718142917', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '113.87.225.28', '2019-08-05 13:46:12', 13, 1002001012, '访问令牌已过期', '2019-08-05 13:46:12');
INSERT INTO `access_log` VALUES (63029, '65.50.15649839759032851', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '113.87.225.28', '2019-08-05 13:46:16', 77, 0, '', '2019-08-05 13:46:16');
INSERT INTO `access_log` VALUES (63030, '65.47.15649839762122827', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '113.87.225.28', '2019-08-05 13:46:16', 11, 0, '', '2019-08-05 13:46:16');
INSERT INTO `access_log` VALUES (63031, '65.46.15649839762152891', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '113.87.225.28', '2019-08-05 13:46:16', 11, 2001001000, '服务端发生异常', '2019-08-05 13:46:16');
INSERT INTO `access_log` VALUES (63032, '65.3607.15649839762204649', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '113.87.225.28', '2019-08-05 13:46:16', 9, 0, '', '2019-08-05 13:46:16');
INSERT INTO `access_log` VALUES (63033, '59.80.15649860074390223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '218.93.160.56', '2019-08-05 14:20:07', 10, 0, '', '2019-08-05 14:20:07');
INSERT INTO `access_log` VALUES (63034, '59.78.15649860074380259', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '218.93.160.56', '2019-08-05 14:20:07', 17, 2001001000, '服务端发生异常', '2019-08-05 14:20:07');
INSERT INTO `access_log` VALUES (63035, '64.82.15649860170230571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.93.160.56', '2019-08-05 14:20:17', 18, 0, '', '2019-08-05 14:20:17');
INSERT INTO `access_log` VALUES (63036, '64.85.15649860171640593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.93.160.56', '2019-08-05 14:20:17', 4, 0, '', '2019-08-05 14:20:17');
INSERT INTO `access_log` VALUES (63037, '64.79.15649860189750557', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.93.160.56', '2019-08-05 14:20:19', 3, 0, '', '2019-08-05 14:20:19');
INSERT INTO `access_log` VALUES (63038, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.93.160.56', '2019-08-05 14:20:19', 14, 0, '', '2019-08-05 14:20:19');
INSERT INTO `access_log` VALUES (63039, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.93.160.56', '2019-08-05 14:20:20', 6, 0, '', '2019-08-05 14:20:20');
INSERT INTO `access_log` VALUES (63040, '64.76.15649860216880559', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.93.160.56', '2019-08-05 14:20:22', 9, 0, '', '2019-08-05 14:20:22');
INSERT INTO `access_log` VALUES (63041, '64.81.15649860291200563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.93.160.56', '2019-08-05 14:20:29', 2, 0, '', '2019-08-05 14:20:29');
INSERT INTO `access_log` VALUES (63042, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.93.160.56', '2019-08-05 14:20:29', 7, 0, '', '2019-08-05 14:20:29');
INSERT INTO `access_log` VALUES (63043, '64.83.15649860302060557', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.93.160.56', '2019-08-05 14:20:30', 2, 0, '', '2019-08-05 14:20:30');
INSERT INTO `access_log` VALUES (63044, '64.77.15649860303410555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.93.160.56', '2019-08-05 14:20:30', 1, 0, '', '2019-08-05 14:20:30');
INSERT INTO `access_log` VALUES (63045, '59.76.15649860322860243', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.93.160.56', '2019-08-05 14:20:32', 3, 0, '', '2019-08-05 14:20:32');
INSERT INTO `access_log` VALUES (63046, '59.79.15649860322860257', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.93.160.56', '2019-08-05 14:20:32', 14, 2001001000, '服务端发生异常', '2019-08-05 14:20:32');
INSERT INTO `access_log` VALUES (63047, '65.47.15649860466092855', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '218.93.160.56', '2019-08-05 14:20:47', 1, 1002001015, '账号未登陆', '2019-08-05 14:20:47');
INSERT INTO `access_log` VALUES (63048, '65.3607.15649860466194677', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '218.93.160.56', '2019-08-05 14:20:47', 0, 1002001015, '账号未登陆', '2019-08-05 14:20:47');
INSERT INTO `access_log` VALUES (63049, '65.54.15649860466412785', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '218.93.160.56', '2019-08-05 14:20:47', 1, 1002001015, '账号未登陆', '2019-08-05 14:20:47');
INSERT INTO `access_log` VALUES (63050, '65.52.15649860488352913', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '218.93.160.56', '2019-08-05 14:20:49', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 14:20:49');
INSERT INTO `access_log` VALUES (63051, '65.53.15649860682302861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '218.93.160.56', '2019-08-05 14:21:08', 106, 0, '', '2019-08-05 14:21:08');
INSERT INTO `access_log` VALUES (63052, '65.51.15649860688352947', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '218.93.160.56', '2019-08-05 14:21:09', 24, 0, '', '2019-08-05 14:21:09');
INSERT INTO `access_log` VALUES (63053, '65.45.15649860688352867', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '218.93.160.56', '2019-08-05 14:21:09', 27, 0, '', '2019-08-05 14:21:09');
INSERT INTO `access_log` VALUES (63054, '65.50.15649860688732881', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '218.93.160.56', '2019-08-05 14:21:09', 10, 2001001000, '服务端发生异常', '2019-08-05 14:21:09');
INSERT INTO `access_log` VALUES (63055, '65.3607.15649860834634679', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '47.240.29.70', '2019-08-05 14:21:23', 1, 1002001015, '账号未登陆', '2019-08-05 14:21:23');
INSERT INTO `access_log` VALUES (63056, '65.52.15649860990002915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '47.240.29.70', '2019-08-05 14:21:39', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 14:21:39');
INSERT INTO `access_log` VALUES (63057, '65.49.15649861089042865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '47.240.29.70', '2019-08-05 14:21:49', 231, 0, '', '2019-08-05 14:21:49');
INSERT INTO `access_log` VALUES (63058, '65.46.15649861112542923', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '47.240.29.70', '2019-08-05 14:21:51', 12, 0, '', '2019-08-05 14:21:51');
INSERT INTO `access_log` VALUES (63059, '65.53.15649861112532863', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '47.240.29.70', '2019-08-05 14:21:51', 12, 2001001000, '服务端发生异常', '2019-08-05 14:21:51');
INSERT INTO `access_log` VALUES (63060, '65.45.15649861112652869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '47.240.29.70', '2019-08-05 14:21:51', 7, 0, '', '2019-08-05 14:21:51');
INSERT INTO `access_log` VALUES (63061, '65.54.15649864638832793', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.176.128.6', '2019-08-05 14:27:44', 0, 1002001015, '账号未登陆', '2019-08-05 14:27:44');
INSERT INTO `access_log` VALUES (63062, '65.52.15649864639182921', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.176.128.6', '2019-08-05 14:27:44', 1, 1002001015, '账号未登陆', '2019-08-05 14:27:44');
INSERT INTO `access_log` VALUES (63063, '65.49.15649864639772871', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.176.128.6', '2019-08-05 14:27:44', 1, 1002001015, '账号未登陆', '2019-08-05 14:27:44');
INSERT INTO `access_log` VALUES (63064, '65.53.15649864668822869', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.176.128.6', '2019-08-05 14:27:47', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 14:27:47');
INSERT INTO `access_log` VALUES (63065, '65.45.15649864702022875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.176.128.6', '2019-08-05 14:27:50', 113, 0, '', '2019-08-05 14:27:50');
INSERT INTO `access_log` VALUES (63066, '65.51.15649864749312955', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '60.176.128.6', '2019-08-05 14:27:55', 114, 0, '', '2019-08-05 14:27:55');
INSERT INTO `access_log` VALUES (63067, '65.51.15649866227472957', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '47.240.29.70', '2019-08-05 14:30:23', 19, 0, '', '2019-08-05 14:30:23');
INSERT INTO `access_log` VALUES (63068, '65.50.15649866237692891', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '47.240.29.70', '2019-08-05 14:30:24', 10, 0, '', '2019-08-05 14:30:24');
INSERT INTO `access_log` VALUES (63069, '65.47.15649866257382867', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '47.240.29.70', '2019-08-05 14:30:26', 11, 2001001000, '服务端发生异常', '2019-08-05 14:30:26');
INSERT INTO `access_log` VALUES (63070, '65.51.15649881745962979', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.97.178.167', '2019-08-05 14:56:15', 0, 1002001015, '账号未登陆', '2019-08-05 14:56:15');
INSERT INTO `access_log` VALUES (63071, '65.46.15649881745962955', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.97.178.167', '2019-08-05 14:56:15', 0, 1002001015, '账号未登陆', '2019-08-05 14:56:15');
INSERT INTO `access_log` VALUES (63072, '65.50.15649881745982915', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.97.178.167', '2019-08-05 14:56:15', 1, 1002001015, '账号未登陆', '2019-08-05 14:56:15');
INSERT INTO `access_log` VALUES (63073, '65.47.15649881918742889', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.97.178.167', '2019-08-05 14:56:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 14:56:32');
INSERT INTO `access_log` VALUES (63074, '65.52.15649882008652945', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.97.178.167', '2019-08-05 14:56:41', 241, 0, '', '2019-08-05 14:56:41');
INSERT INTO `access_log` VALUES (63075, '65.49.15649882015242899', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.97.178.167', '2019-08-05 14:56:42', 194, 2001001000, '服务端发生异常', '2019-08-05 14:56:42');
INSERT INTO `access_log` VALUES (63076, '65.53.15649882015242893', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.97.178.167', '2019-08-05 14:56:42', 194, 0, '', '2019-08-05 14:56:42');
INSERT INTO `access_log` VALUES (63077, '65.45.15649882015332901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.97.178.167', '2019-08-05 14:56:42', 186, 0, '', '2019-08-05 14:56:42');
INSERT INTO `access_log` VALUES (63078, '65.50.15649882157162917', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.97.178.167', '2019-08-05 14:56:56', 8, 0, '', '2019-08-05 14:56:56');
INSERT INTO `access_log` VALUES (63079, '65.3607.15649882157234713', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.97.178.167', '2019-08-05 14:56:56', 252, 0, '', '2019-08-05 14:56:56');
INSERT INTO `access_log` VALUES (63080, '65.51.15649882157142981', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.97.178.167', '2019-08-05 14:56:56', 263, 2001001000, '服务端发生异常', '2019-08-05 14:56:56');
INSERT INTO `access_log` VALUES (63081, '59.71.15649889287100287', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.91.116.166', '2019-08-05 15:08:49', 10, 0, '', '2019-08-05 15:08:49');
INSERT INTO `access_log` VALUES (63082, '59.72.15649889287100287', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '114.91.116.166', '2019-08-05 15:08:49', 16, 2001001000, '服务端发生异常', '2019-08-05 15:08:49');
INSERT INTO `access_log` VALUES (63083, '59.71.15649890369360289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.7.0) com.laiwang.DingTalk/11728877 Channel/201200 language/zh-Hans-CN', '119.190.112.113', '2019-08-05 15:10:37', 2, 0, '', '2019-08-05 15:10:37');
INSERT INTO `access_log` VALUES (63084, '59.72.15649890369380289', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 AliApp(DingTalk/4.7.0) com.laiwang.DingTalk/11728877 Channel/201200 language/zh-Hans-CN', '119.190.112.113', '2019-08-05 15:10:37', 18, 2001001000, '服务端发生异常', '2019-08-05 15:10:37');
INSERT INTO `access_log` VALUES (63085, '65.52.15649893063362961', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.149.10.46', '2019-08-05 15:15:06', 0, 1002001015, '账号未登陆', '2019-08-05 15:15:06');
INSERT INTO `access_log` VALUES (63086, '65.49.15649893063402915', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.149.10.46', '2019-08-05 15:15:06', 0, 1002001015, '账号未登陆', '2019-08-05 15:15:06');
INSERT INTO `access_log` VALUES (63087, '65.45.15649893063632917', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.149.10.46', '2019-08-05 15:15:06', 1, 1002001015, '账号未登陆', '2019-08-05 15:15:06');
INSERT INTO `access_log` VALUES (63088, '65.46.15649893099912973', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.149.10.46', '2019-08-05 15:15:10', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 15:15:10');
INSERT INTO `access_log` VALUES (63089, '65.50.15649893227742933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.149.10.46', '2019-08-05 15:15:23', 61, 0, '', '2019-08-05 15:15:23');
INSERT INTO `access_log` VALUES (63090, '65.3607.15649893230604729', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.149.10.46', '2019-08-05 15:15:23', 10, 0, '', '2019-08-05 15:15:23');
INSERT INTO `access_log` VALUES (63091, '65.51.15649893230652997', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.149.10.46', '2019-08-05 15:15:23', 9, 0, '', '2019-08-05 15:15:23');
INSERT INTO `access_log` VALUES (63092, '65.47.15649893230732907', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.149.10.46', '2019-08-05 15:15:23', 10, 2001001000, '服务端发生异常', '2019-08-05 15:15:23');
INSERT INTO `access_log` VALUES (63093, '65.45.15649898046862925', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.118.64', '2019-08-05 15:23:25', 1, 1002001015, '账号未登陆', '2019-08-05 15:23:25');
INSERT INTO `access_log` VALUES (63094, '65.53.15649898047002917', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.118.64', '2019-08-05 15:23:25', 1, 1002001015, '账号未登陆', '2019-08-05 15:23:25');
INSERT INTO `access_log` VALUES (63095, '65.46.15649898047012981', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.118.64', '2019-08-05 15:23:25', 0, 1002001015, '账号未登陆', '2019-08-05 15:23:25');
INSERT INTO `access_log` VALUES (63096, '65.50.15649898093382941', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.118.64', '2019-08-05 15:23:29', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 15:23:29');
INSERT INTO `access_log` VALUES (63097, '65.3607.15649898173234737', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.118.64', '2019-08-05 15:23:37', 62, 0, '', '2019-08-05 15:23:37');
INSERT INTO `access_log` VALUES (63098, '65.51.15649898180953005', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.118.64', '2019-08-05 15:23:38', 14, 0, '', '2019-08-05 15:23:38');
INSERT INTO `access_log` VALUES (63099, '65.47.15649898180992915', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.118.64', '2019-08-05 15:23:38', 25, 2001001000, '服务端发生异常', '2019-08-05 15:23:38');
INSERT INTO `access_log` VALUES (63100, '65.54.15649898181012843', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.118.64', '2019-08-05 15:23:38', 23, 0, '', '2019-08-05 15:23:38');
INSERT INTO `access_log` VALUES (63101, '65.52.15649898228332971', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.118.64', '2019-08-05 15:23:43', 9, 0, '', '2019-08-05 15:23:43');
INSERT INTO `access_log` VALUES (63102, '65.45.15649898228382927', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.118.64', '2019-08-05 15:23:43', 9, 2001001000, '服务端发生异常', '2019-08-05 15:23:43');
INSERT INTO `access_log` VALUES (63103, '65.53.15649898228422919', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.118.64', '2019-08-05 15:23:43', 9, 0, '', '2019-08-05 15:23:43');
INSERT INTO `access_log` VALUES (63104, '65.3607.15649913608784759', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:49:21', 1, 1002001015, '账号未登陆', '2019-08-05 15:49:21');
INSERT INTO `access_log` VALUES (63105, '65.47.15649913608782937', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:49:21', 0, 1002001015, '账号未登陆', '2019-08-05 15:49:21');
INSERT INTO `access_log` VALUES (63106, '65.51.15649913608833027', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:49:21', 0, 1002001015, '账号未登陆', '2019-08-05 15:49:21');
INSERT INTO `access_log` VALUES (63107, '65.49.15649913646342947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:49:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 15:49:25');
INSERT INTO `access_log` VALUES (63108, '65.52.15649913799402993', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:49:40', 84, 0, '', '2019-08-05 15:49:40');
INSERT INTO `access_log` VALUES (63109, '65.53.15649913803742941', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:49:40', 9, 0, '', '2019-08-05 15:49:40');
INSERT INTO `access_log` VALUES (63110, '65.46.15649913803763005', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:49:40', 10, 2001001000, '服务端发生异常', '2019-08-05 15:49:40');
INSERT INTO `access_log` VALUES (63111, '65.50.15649913803802965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:49:40', 8, 0, '', '2019-08-05 15:49:40');
INSERT INTO `access_log` VALUES (63112, '65.51.15649913915273029', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:49:52', 8, 0, '', '2019-08-05 15:49:52');
INSERT INTO `access_log` VALUES (63113, '65.3607.15649913915284761', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:49:52', 9, 2001001000, '服务端发生异常', '2019-08-05 15:49:52');
INSERT INTO `access_log` VALUES (63114, '65.47.15649913915312939', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:49:52', 7, 0, '', '2019-08-05 15:49:52');
INSERT INTO `access_log` VALUES (63115, '59.76.15649915068910317', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.85.208.10', '2019-08-05 15:51:47', 17, 0, '', '2019-08-05 15:51:47');
INSERT INTO `access_log` VALUES (63116, '59.77.15649915068920315', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.85.208.10', '2019-08-05 15:51:47', 21, 2001001000, '服务端发生异常', '2019-08-05 15:51:47');
INSERT INTO `access_log` VALUES (63117, '65.45.15649917118932955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:55:12', 10, 0, '', '2019-08-05 15:55:12');
INSERT INTO `access_log` VALUES (63118, '65.52.15649917118952999', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:55:12', 11, 2001001000, '服务端发生异常', '2019-08-05 15:55:12');
INSERT INTO `access_log` VALUES (63119, '65.53.15649917122612947', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:55:12', 10, 0, '', '2019-08-05 15:55:12');
INSERT INTO `access_log` VALUES (63120, '65.46.15649917384103011', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:55:38', 9, 0, '', '2019-08-05 15:55:38');
INSERT INTO `access_log` VALUES (63121, '65.3607.15649917384134767', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:55:38', 10, 2001001000, '服务端发生异常', '2019-08-05 15:55:38');
INSERT INTO `access_log` VALUES (63122, '65.51.15649917384163035', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '36.110.58.27', '2019-08-05 15:55:38', 9, 0, '', '2019-08-05 15:55:38');
INSERT INTO `access_log` VALUES (63123, '59.77.15649917651840319', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.85.208.10', '2019-08-05 15:56:05', 3, 0, '', '2019-08-05 15:56:05');
INSERT INTO `access_log` VALUES (63124, '59.76.15649917651850321', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '202.85.208.10', '2019-08-05 15:56:05', 14, 2001001000, '服务端发生异常', '2019-08-05 15:56:05');
INSERT INTO `access_log` VALUES (63125, '59.75.15649919291360341', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.175.66', '2019-08-05 15:58:49', 2, 0, '', '2019-08-05 15:58:49');
INSERT INTO `access_log` VALUES (63126, '59.71.15649919291360329', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.175.66', '2019-08-05 15:58:49', 18, 2001001000, '服务端发生异常', '2019-08-05 15:58:49');
INSERT INTO `access_log` VALUES (63127, '65.50.15649919344962975', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.175.66', '2019-08-05 15:58:54', 3, 1002001012, '访问令牌已过期', '2019-08-05 15:58:55');
INSERT INTO `access_log` VALUES (63128, '65.51.15649919344983039', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.175.66', '2019-08-05 15:58:54', 3, 1002001012, '访问令牌已过期', '2019-08-05 15:58:55');
INSERT INTO `access_log` VALUES (63129, '65.3607.15649919345034771', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.175.66', '2019-08-05 15:58:55', 3, 1002001012, '访问令牌已过期', '2019-08-05 15:58:55');
INSERT INTO `access_log` VALUES (63130, '65.46.15649919360033015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.123.175.66', '2019-08-05 15:58:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 15:58:56');
INSERT INTO `access_log` VALUES (63131, '65.45.15649925941752969', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.20.60.185', '2019-08-05 16:09:54', 1, 1002001015, '账号未登陆', '2019-08-05 16:09:54');
INSERT INTO `access_log` VALUES (63132, '65.50.15649925941902985', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.20.60.185', '2019-08-05 16:09:54', 1, 1002001015, '账号未登陆', '2019-08-05 16:09:54');
INSERT INTO `access_log` VALUES (63133, '65.53.15649925941902961', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.20.60.185', '2019-08-05 16:09:54', 0, 1002001015, '账号未登陆', '2019-08-05 16:09:54');
INSERT INTO `access_log` VALUES (63134, '65.51.15649926131673049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.20.60.185', '2019-08-05 16:10:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 16:10:13');
INSERT INTO `access_log` VALUES (63135, '65.47.15649926345852959', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.20.60.185', '2019-08-05 16:10:35', 82, 0, '', '2019-08-05 16:10:35');
INSERT INTO `access_log` VALUES (63136, '65.54.15649926352372887', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.20.60.185', '2019-08-05 16:10:35', 9, 0, '', '2019-08-05 16:10:35');
INSERT INTO `access_log` VALUES (63137, '65.49.15649926352502969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.20.60.185', '2019-08-05 16:10:35', 9, 2001001000, '服务端发生异常', '2019-08-05 16:10:35');
INSERT INTO `access_log` VALUES (63138, '65.52.15649926353403015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.20.60.185', '2019-08-05 16:10:35', 10, 0, '', '2019-08-05 16:10:35');
INSERT INTO `access_log` VALUES (63139, '65.53.15649926490522963', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.20.60.185', '2019-08-05 16:10:49', 8, 0, '', '2019-08-05 16:10:49');
INSERT INTO `access_log` VALUES (63140, '65.3607.15649926490754783', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.20.60.185', '2019-08-05 16:10:49', 10, 0, '', '2019-08-05 16:10:49');
INSERT INTO `access_log` VALUES (63141, '65.50.15649926490752987', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.20.60.185', '2019-08-05 16:10:49', 11, 2001001000, '服务端发生异常', '2019-08-05 16:10:49');
INSERT INTO `access_log` VALUES (63142, '65.46.15649944479183051', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.171.63.214', '2019-08-05 16:40:48', 0, 1002001015, '账号未登陆', '2019-08-05 16:40:48');
INSERT INTO `access_log` VALUES (63143, '65.51.15649944479183075', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.171.63.214', '2019-08-05 16:40:48', 0, 1002001015, '账号未登陆', '2019-08-05 16:40:48');
INSERT INTO `access_log` VALUES (63144, '65.47.15649944479202985', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.171.63.214', '2019-08-05 16:40:48', 1, 1002001015, '账号未登陆', '2019-08-05 16:40:48');
INSERT INTO `access_log` VALUES (63145, '65.49.15649944631592995', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.171.63.214', '2019-08-05 16:41:03', 88, 0, '', '2019-08-05 16:41:03');
INSERT INTO `access_log` VALUES (63146, '65.52.15649944635963041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.171.63.214', '2019-08-05 16:41:04', 174, 0, '', '2019-08-05 16:41:04');
INSERT INTO `access_log` VALUES (63147, '65.45.15649944636022997', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.171.63.214', '2019-08-05 16:41:04', 170, 2001001000, '服务端发生异常', '2019-08-05 16:41:04');
INSERT INTO `access_log` VALUES (63148, '65.50.15649944698913013', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.171.63.214', '2019-08-05 16:41:10', 10, 0, '', '2019-08-05 16:41:10');
INSERT INTO `access_log` VALUES (63149, '65.3607.15649944698944809', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.171.63.214', '2019-08-05 16:41:10', 9, 2001001000, '服务端发生异常', '2019-08-05 16:41:10');
INSERT INTO `access_log` VALUES (63150, '65.47.15649944699012987', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.171.63.214', '2019-08-05 16:41:10', 9, 0, '', '2019-08-05 16:41:10');
INSERT INTO `access_log` VALUES (63151, '59.75.15649954620180389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.36.252.131', '2019-08-05 16:57:42', 11, 0, '', '2019-08-05 16:57:42');
INSERT INTO `access_log` VALUES (63152, '59.71.15649954620180377', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.36.252.131', '2019-08-05 16:57:42', 22, 2001001000, '服务端发生异常', '2019-08-05 16:57:42');
INSERT INTO `access_log` VALUES (63153, '64.79.15649954651880685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.36.252.131', '2019-08-05 16:57:45', 10, 0, '', '2019-08-05 16:57:45');
INSERT INTO `access_log` VALUES (63154, '64.82.15649954653330699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.36.252.131', '2019-08-05 16:57:45', 2, 0, '', '2019-08-05 16:57:45');
INSERT INTO `access_log` VALUES (63155, '64.76.15649954665910685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.36.252.131', '2019-08-05 16:57:47', 2, 0, '', '2019-08-05 16:57:47');
INSERT INTO `access_log` VALUES (63156, '59.72.15649954673860377', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.36.252.131', '2019-08-05 16:57:47', 3, 0, '', '2019-08-05 16:57:47');
INSERT INTO `access_log` VALUES (63157, '59.80.15649954673890353', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.36.252.131', '2019-08-05 16:57:47', 20, 2001001000, '服务端发生异常', '2019-08-05 16:57:47');
INSERT INTO `access_log` VALUES (63158, '64.85.15649954760780723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.36.252.131', '2019-08-05 16:57:56', 2, 0, '', '2019-08-05 16:57:56');
INSERT INTO `access_log` VALUES (63159, '64.81.15649954761930693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.36.252.131', '2019-08-05 16:57:56', 2, 0, '', '2019-08-05 16:57:56');
INSERT INTO `access_log` VALUES (63160, '64.84.15649954798230687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.36.252.131', '2019-08-05 16:58:00', 3, 0, '', '2019-08-05 16:58:00');
INSERT INTO `access_log` VALUES (63161, '64.77.15649954799320681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '120.36.252.131', '2019-08-05 16:58:00', 2, 0, '', '2019-08-05 16:58:00');
INSERT INTO `access_log` VALUES (63162, '65.53.15649967567123021', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:19:17', 0, 1002001015, '账号未登陆', '2019-08-05 17:19:17');
INSERT INTO `access_log` VALUES (63163, '65.50.15649967567133043', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:19:17', 0, 1002001015, '账号未登陆', '2019-08-05 17:19:17');
INSERT INTO `access_log` VALUES (63164, '65.47.15649967567143017', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:19:17', 0, 1002001015, '账号未登陆', '2019-08-05 17:19:17');
INSERT INTO `access_log` VALUES (63165, '65.3607.15649967591524841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:19:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 17:19:19');
INSERT INTO `access_log` VALUES (63166, '65.46.15649967648823085', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:19:25', 52, 0, '', '2019-08-05 17:19:25');
INSERT INTO `access_log` VALUES (63167, '65.54.15649967651922947', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:19:25', 11, 0, '', '2019-08-05 17:19:25');
INSERT INTO `access_log` VALUES (63168, '65.49.15649967651983029', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:19:25', 10, 2001001000, '服务端发生异常', '2019-08-05 17:19:25');
INSERT INTO `access_log` VALUES (63169, '65.52.15649967652003075', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:19:25', 9, 0, '', '2019-08-05 17:19:25');
INSERT INTO `access_log` VALUES (63170, '59.74.15649968100190411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:20:10', 4, 0, '', '2019-08-05 17:20:10');
INSERT INTO `access_log` VALUES (63171, '59.78.15649968100190407', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:20:10', 16, 2001001000, '服务端发生异常', '2019-08-05 17:20:10');
INSERT INTO `access_log` VALUES (63172, '65.47.15649968218453019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:20:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 17:20:22');
INSERT INTO `access_log` VALUES (63173, '65.51.15649968279123111', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:20:28', 85, 0, '', '2019-08-05 17:20:28');
INSERT INTO `access_log` VALUES (63174, '65.46.15649968282313087', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:20:28', 8, 0, '', '2019-08-05 17:20:28');
INSERT INTO `access_log` VALUES (63175, '65.49.15649968282353031', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:20:28', 9, 2001001000, '服务端发生异常', '2019-08-05 17:20:28');
INSERT INTO `access_log` VALUES (63176, '65.54.15649968282412949', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/17.17134', '122.224.159.130', '2019-08-05 17:20:28', 9, 0, '', '2019-08-05 17:20:28');
INSERT INTO `access_log` VALUES (63177, '59.77.15649971203310391', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '42.3.72.154', '2019-08-05 17:25:20', 3, 0, '', '2019-08-05 17:25:20');
INSERT INTO `access_log` VALUES (63178, '59.76.15649971203280395', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '42.3.72.154', '2019-08-05 17:25:20', 12, 2001001000, '服务端发生异常', '2019-08-05 17:25:20');
INSERT INTO `access_log` VALUES (63179, '64.78.15649971379460715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.28.25.114', '2019-08-05 17:25:38', 3, 0, '', '2019-08-05 17:25:38');
INSERT INTO `access_log` VALUES (63180, '64.79.15649971382110709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.28.25.114', '2019-08-05 17:25:38', 2, 0, '', '2019-08-05 17:25:38');
INSERT INTO `access_log` VALUES (63181, '64.82.15649971391790723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.28.25.114', '2019-08-05 17:25:39', 2, 0, '', '2019-08-05 17:25:39');
INSERT INTO `access_log` VALUES (63182, '64.76.15649971400690709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.28.25.114', '2019-08-05 17:25:40', 1, 0, '', '2019-08-05 17:25:40');
INSERT INTO `access_log` VALUES (63183, '64.83.15649971401080709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.28.25.114', '2019-08-05 17:25:40', 2, 0, '', '2019-08-05 17:25:40');
INSERT INTO `access_log` VALUES (63184, '64.85.15649971403900747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '121.28.25.114', '2019-08-05 17:25:40', 2, 0, '', '2019-08-05 17:25:40');
INSERT INTO `access_log` VALUES (63185, '59.76.15649978569820405', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.132.165', '2019-08-05 17:37:37', 3, 0, '', '2019-08-05 17:37:37');
INSERT INTO `access_log` VALUES (63186, '59.73.15649978569820413', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.132.165', '2019-08-05 17:37:37', 18, 2001001000, '服务端发生异常', '2019-08-05 17:37:37');
INSERT INTO `access_log` VALUES (63187, '64.83.15649978614090719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.132.165', '2019-08-05 17:37:41', 3, 0, '', '2019-08-05 17:37:41');
INSERT INTO `access_log` VALUES (63188, '64.85.15649978618310757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.132.165', '2019-08-05 17:37:42', 2, 0, '', '2019-08-05 17:37:42');
INSERT INTO `access_log` VALUES (63189, '64.81.15649978641060727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.132.165', '2019-08-05 17:37:44', 2, 0, '', '2019-08-05 17:37:44');
INSERT INTO `access_log` VALUES (63190, '64.84.15649978646140721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.132.165', '2019-08-05 17:37:45', 2, 0, '', '2019-08-05 17:37:45');
INSERT INTO `access_log` VALUES (63191, '59.79.15650075362510549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:18:56', 16, 2001001000, '服务端发生异常', '2019-08-05 20:18:56');
INSERT INTO `access_log` VALUES (63192, '59.74.15650075362510555', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:18:56', 56, 0, '', '2019-08-05 20:18:56');
INSERT INTO `access_log` VALUES (63193, '64.76.15650075430210849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:03', 12, 0, '', '2019-08-05 20:19:03');
INSERT INTO `access_log` VALUES (63194, '64.83.15650075431050849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:03', 3, 0, '', '2019-08-05 20:19:03');
INSERT INTO `access_log` VALUES (63195, '59.76.15650075439540535', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:04', 3, 0, '', '2019-08-05 20:19:04');
INSERT INTO `access_log` VALUES (63196, '59.77.15650075439540531', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:04', 13, 2001001000, '服务端发生异常', '2019-08-05 20:19:04');
INSERT INTO `access_log` VALUES (63197, '59.71.15650075449060541', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:05', 2, 0, '', '2019-08-05 20:19:05');
INSERT INTO `access_log` VALUES (63198, '59.75.15650075449060553', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:05', 15, 2001001000, '服务端发生异常', '2019-08-05 20:19:05');
INSERT INTO `access_log` VALUES (63199, '64.81.15650075471900857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:07', 1, 0, '', '2019-08-05 20:19:07');
INSERT INTO `access_log` VALUES (63200, '64.84.15650075473420851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:07', 2, 0, '', '2019-08-05 20:19:07');
INSERT INTO `access_log` VALUES (63201, '59.72.15650075485940541', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:09', 2, 0, '', '2019-08-05 20:19:09');
INSERT INTO `access_log` VALUES (63202, '59.80.15650075485940517', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:09', 12, 2001001000, '服务端发生异常', '2019-08-05 20:19:09');
INSERT INTO `access_log` VALUES (63203, '64.77.15650075497700845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:10', 2, 0, '', '2019-08-05 20:19:10');
INSERT INTO `access_log` VALUES (63204, '64.80.15650075498600857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:10', 2, 0, '', '2019-08-05 20:19:10');
INSERT INTO `access_log` VALUES (63205, '64.78.15650075511070857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:11', 2, 0, '', '2019-08-05 20:19:11');
INSERT INTO `access_log` VALUES (63206, '64.79.15650075513070851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:11', 2, 0, '', '2019-08-05 20:19:11');
INSERT INTO `access_log` VALUES (63207, '64.82.15650075514730865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:11', 2, 0, '', '2019-08-05 20:19:11');
INSERT INTO `access_log` VALUES (63208, '64.76.15650075520170851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:12', 2, 0, '', '2019-08-05 20:19:12');
INSERT INTO `access_log` VALUES (63209, '59.78.15650075528650553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:13', 2, 0, '', '2019-08-05 20:19:13');
INSERT INTO `access_log` VALUES (63210, '59.79.15650075528650551', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:13', 15, 2001001000, '服务端发生异常', '2019-08-05 20:19:13');
INSERT INTO `access_log` VALUES (63211, '59.76.15650075703360537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:30', 2, 0, '', '2019-08-05 20:19:30');
INSERT INTO `access_log` VALUES (63212, '59.77.15650075703370533', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:30', 13, 2001001000, '服务端发生异常', '2019-08-05 20:19:30');
INSERT INTO `access_log` VALUES (63213, '65.45.15650075710193177', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:31', 1, 1002001015, '账号未登陆', '2019-08-05 20:19:31');
INSERT INTO `access_log` VALUES (63214, '65.50.15650075710183191', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:31', 2, 1002001015, '账号未登陆', '2019-08-05 20:19:31');
INSERT INTO `access_log` VALUES (63215, '65.52.15650075710193221', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:31', 1, 1002001015, '账号未登陆', '2019-08-05 20:19:31');
INSERT INTO `access_log` VALUES (63216, '65.53.15650075731723169', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:33', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 20:19:33');
INSERT INTO `access_log` VALUES (63217, '64.85.15650075752250889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:35', 1, 0, '', '2019-08-05 20:19:35');
INSERT INTO `access_log` VALUES (63218, '64.81.15650075754070859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:35', 2, 0, '', '2019-08-05 20:19:35');
INSERT INTO `access_log` VALUES (63219, '59.71.15650075772150543', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:37', 2, 0, '', '2019-08-05 20:19:37');
INSERT INTO `access_log` VALUES (63220, '59.75.15650075772160555', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:37', 12, 2001001000, '服务端发生异常', '2019-08-05 20:19:37');
INSERT INTO `access_log` VALUES (63221, '64.77.15650075795110847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:40', 1, 0, '', '2019-08-05 20:19:40');
INSERT INTO `access_log` VALUES (63222, '64.80.15650075796260859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:40', 2, 0, '', '2019-08-05 20:19:40');
INSERT INTO `access_log` VALUES (63223, '64.78.15650075825350859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:43', 2, 0, '', '2019-08-05 20:19:43');
INSERT INTO `access_log` VALUES (63224, '64.79.15650075829650853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:43', 2, 0, '', '2019-08-05 20:19:43');
INSERT INTO `access_log` VALUES (63225, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=dfs&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:46', 6, 0, '', '2019-08-05 20:19:46');
INSERT INTO `access_log` VALUES (63226, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=dfs', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:46', 6, 0, '', '2019-08-05 20:19:46');
INSERT INTO `access_log` VALUES (63227, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=dfs&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=desc', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:19:56', 5, 0, '', '2019-08-05 20:19:56');
INSERT INTO `access_log` VALUES (63228, '65.51.15650075981553257', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuama&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:58', 81, 0, '', '2019-08-05 20:19:58');
INSERT INTO `access_log` VALUES (63229, '65.49.15650075987933177', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:59', 15, 0, '', '2019-08-05 20:19:59');
INSERT INTO `access_log` VALUES (63230, '65.46.15650075987943231', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:59', 17, 2001001000, '服务端发生异常', '2019-08-05 20:19:59');
INSERT INTO `access_log` VALUES (63231, '65.54.15650075988013093', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-05 20:19:59', 10, 0, '', '2019-08-05 20:19:59');
INSERT INTO `access_log` VALUES (63232, '65.53.15650076251033171', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:20:25', 0, 1002001015, '账号未登陆', '2019-08-05 20:20:25');
INSERT INTO `access_log` VALUES (63233, '65.52.15650076251033223', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:20:25', 1, 1002001015, '账号未登陆', '2019-08-05 20:20:25');
INSERT INTO `access_log` VALUES (63234, '65.47.15650076251193167', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:20:25', 0, 1002001015, '账号未登陆', '2019-08-05 20:20:25');
INSERT INTO `access_log` VALUES (63235, '65.3607.15650076278464991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:20:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 20:20:28');
INSERT INTO `access_log` VALUES (63236, '65.46.15650076401963233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:20:40', 92, 0, '', '2019-08-05 20:20:40');
INSERT INTO `access_log` VALUES (63237, '65.49.15650076405393179', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:20:41', 10, 0, '', '2019-08-05 20:20:41');
INSERT INTO `access_log` VALUES (63238, '65.54.15650076405403095', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:20:41', 12, 2001001000, '服务端发生异常', '2019-08-05 20:20:41');
INSERT INTO `access_log` VALUES (63239, '65.45.15650076405473181', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:20:41', 8, 0, '', '2019-08-05 20:20:41');
INSERT INTO `access_log` VALUES (63240, '65.45.15650077252723185', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:22:05', 10, 0, '', '2019-08-05 20:22:05');
INSERT INTO `access_log` VALUES (63241, '65.51.15650077252743261', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:22:05', 12, 2001001000, '服务端发生异常', '2019-08-05 20:22:05');
INSERT INTO `access_log` VALUES (63242, '65.3607.15650077252814993', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:22:05', 9, 0, '', '2019-08-05 20:22:05');
INSERT INTO `access_log` VALUES (63243, '65.49.15650077429873181', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:22:23', 9, 0, '', '2019-08-05 20:22:23');
INSERT INTO `access_log` VALUES (63244, '65.54.15650077429883099', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:22:23', 10, 0, '', '2019-08-05 20:22:23');
INSERT INTO `access_log` VALUES (63245, '65.50.15650077429873197', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.172.46', '2019-08-05 20:22:23', 11, 2001001000, '服务端发生异常', '2019-08-05 20:22:23');
INSERT INTO `access_log` VALUES (63246, '59.76.15650103579900575', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.37.140.25', '2019-08-05 21:05:58', 10, 0, '', '2019-08-05 21:05:58');
INSERT INTO `access_log` VALUES (63247, '59.77.15650103579900571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.37.140.25', '2019-08-05 21:05:58', 14, 2001001000, '服务端发生异常', '2019-08-05 21:05:58');
INSERT INTO `access_log` VALUES (63248, '65.46.15650103639483271', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.37.140.25', '2019-08-05 21:06:04', 0, 1002001015, '账号未登陆', '2019-08-05 21:06:04');
INSERT INTO `access_log` VALUES (63249, '65.3607.15650103639485029', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.37.140.25', '2019-08-05 21:06:04', 1, 1002001015, '账号未登陆', '2019-08-05 21:06:04');
INSERT INTO `access_log` VALUES (63250, '65.50.15650103639543233', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.37.140.25', '2019-08-05 21:06:04', 0, 1002001015, '账号未登陆', '2019-08-05 21:06:04');
INSERT INTO `access_log` VALUES (63251, '65.54.15650103658653135', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.37.140.25', '2019-08-05 21:06:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 21:06:06');
INSERT INTO `access_log` VALUES (63252, '65.49.15650103686223217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.37.140.25', '2019-08-05 21:06:09', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 21:06:09');
INSERT INTO `access_log` VALUES (63253, '65.53.15650103692963211', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.37.140.25', '2019-08-05 21:06:09', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 21:06:09');
INSERT INTO `access_log` VALUES (63254, '65.47.15650103697423209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.37.140.25', '2019-08-05 21:06:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 21:06:10');
INSERT INTO `access_log` VALUES (63255, '65.51.15650103701353299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.37.140.25', '2019-08-05 21:06:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-05 21:06:10');
INSERT INTO `access_log` VALUES (63256, '59.72.15650109870120589', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.37.140.25', '2019-08-05 21:16:27', 4, 0, '', '2019-08-05 21:16:27');
INSERT INTO `access_log` VALUES (63257, '59.71.15650109870120589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.37.140.25', '2019-08-05 21:16:27', 13, 2001001000, '服务端发生异常', '2019-08-05 21:16:27');
INSERT INTO `access_log` VALUES (63258, '59.75.15650113866780607', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.125.42', '2019-08-05 21:23:07', 3, 0, '', '2019-08-05 21:23:07');
INSERT INTO `access_log` VALUES (63259, '59.71.15650113866790595', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.125.42', '2019-08-05 21:23:07', 13, 2001001000, '服务端发生异常', '2019-08-05 21:23:07');
INSERT INTO `access_log` VALUES (63260, '59.78.15650147212460651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.34.32.2', '2019-08-05 22:18:41', 14, 0, '', '2019-08-05 22:18:41');
INSERT INTO `access_log` VALUES (63261, '59.79.15650147212470649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '121.34.32.2', '2019-08-05 22:18:41', 21, 2001001000, '服务端发生异常', '2019-08-05 22:18:41');
INSERT INTO `access_log` VALUES (63262, '59.76.15650178883960677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.238.194.179', '2019-08-05 23:11:28', 15, 0, '', '2019-08-05 23:11:28');
INSERT INTO `access_log` VALUES (63263, '59.77.15650178883970673', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.238.194.176', '2019-08-05 23:11:28', 17, 2001001000, '服务端发生异常', '2019-08-05 23:11:28');
INSERT INTO `access_log` VALUES (63264, '59.80.15650179497120659', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:12:30', 2, 0, '', '2019-08-05 23:12:30');
INSERT INTO `access_log` VALUES (63265, '59.79.15650179497130693', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:12:30', 10, 2001001000, '服务端发生异常', '2019-08-05 23:12:30');
INSERT INTO `access_log` VALUES (63266, '62.82.15650191362309589', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'createBeginTime=&createEndTime=&finishBeginTime=&finishEndTime=&pageNo=1&pageSize=10&payChannel=&status=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:32:16', 1, 1002001015, '账号未登陆', '2019-08-05 23:32:16');
INSERT INTO `access_log` VALUES (63267, '62.81.15650191414859573', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'createBeginTime=&createEndTime=&finishBeginTime=&finishEndTime=&pageNo=1&pageSize=10&payChannel=&status=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:32:21', 1, 1002001015, '账号未登陆', '2019-08-05 23:32:21');
INSERT INTO `access_log` VALUES (63268, '62.87.15650191431439603', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'createBeginTime=&createEndTime=&finishBeginTime=&finishEndTime=&pageNo=1&pageSize=10&payChannel=&status=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:32:23', 1, 1002001015, '账号未登陆', '2019-08-05 23:32:23');
INSERT INTO `access_log` VALUES (63269, '65.50.15650198237233361', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:43:44', 1, 1002001015, '账号未登陆', '2019-08-05 23:43:44');
INSERT INTO `access_log` VALUES (63270, '65.45.15650198237233349', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:43:44', 1, 1002001015, '账号未登陆', '2019-08-05 23:43:44');
INSERT INTO `access_log` VALUES (63271, '65.3607.15650198237255157', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:43:44', 0, 1002001015, '账号未登陆', '2019-08-05 23:43:44');
INSERT INTO `access_log` VALUES (63272, '65.46.15650198326073399', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:43:53', 71, 0, '', '2019-08-05 23:43:53');
INSERT INTO `access_log` VALUES (63273, '65.54.15650198329063263', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:43:53', 15, 0, '', '2019-08-05 23:43:53');
INSERT INTO `access_log` VALUES (63274, '65.49.15650198329093345', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:43:53', 12, 2001001000, '服务端发生异常', '2019-08-05 23:43:53');
INSERT INTO `access_log` VALUES (63275, '65.52.15650198329123393', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:43:53', 13, 0, '', '2019-08-05 23:43:53');
INSERT INTO `access_log` VALUES (63276, '65.50.15650198648563363', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:44:25', 18, 0, '', '2019-08-05 23:44:25');
INSERT INTO `access_log` VALUES (63277, '65.3607.15650198648615159', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:44:25', 17, 0, '', '2019-08-05 23:44:25');
INSERT INTO `access_log` VALUES (63278, '65.45.15650198648613351', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:44:25', 22, 2001001000, '服务端发生异常', '2019-08-05 23:44:25');
INSERT INTO `access_log` VALUES (63279, '65.46.15650198674833401', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:44:27', 7, 0, '', '2019-08-05 23:44:27');
INSERT INTO `access_log` VALUES (63280, '65.54.15650198674903265', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:44:27', 8, 2001001000, '服务端发生异常', '2019-08-05 23:44:27');
INSERT INTO `access_log` VALUES (63281, '65.49.15650198674933347', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:44:27', 8, 0, '', '2019-08-05 23:44:28');
INSERT INTO `access_log` VALUES (63282, '65.52.15650198713713395', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:44:31', 9, 0, '', '2019-08-05 23:44:31');
INSERT INTO `access_log` VALUES (63283, '65.47.15650198713753339', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:44:31', 8, 0, '', '2019-08-05 23:44:31');
INSERT INTO `access_log` VALUES (63284, '65.53.15650198713743341', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:44:31', 9, 2001001000, '服务端发生异常', '2019-08-05 23:44:31');
INSERT INTO `access_log` VALUES (63285, '65.51.15650198740513429', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:44:34', 16, 0, '', '2019-08-05 23:44:34');
INSERT INTO `access_log` VALUES (63286, '65.50.15650198740523365', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:44:34', 19, 2001001000, '服务端发生异常', '2019-08-05 23:44:34');
INSERT INTO `access_log` VALUES (63287, '65.45.15650198740573353', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.72.31.138', '2019-08-05 23:44:34', 18, 0, '', '2019-08-05 23:44:34');
INSERT INTO `access_log` VALUES (63288, '65.3607.15650519838185589', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 08:39:44', 0, 1002001015, '账号未登陆', '2019-08-06 08:39:44');
INSERT INTO `access_log` VALUES (63289, '65.45.15650519838173781', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 08:39:44', 1, 1002001015, '账号未登陆', '2019-08-06 08:39:44');
INSERT INTO `access_log` VALUES (63290, '65.50.15650519838163793', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 08:39:44', 1, 1002001015, '账号未登陆', '2019-08-06 08:39:44');
INSERT INTO `access_log` VALUES (63291, '65.54.15650519860303695', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 08:39:46', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-06 08:39:46');
INSERT INTO `access_log` VALUES (63292, '65.49.15650519989633777', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 08:39:59', 111, 0, '', '2019-08-06 08:39:59');
INSERT INTO `access_log` VALUES (63293, '65.53.15650519994863771', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 08:39:59', 14, 0, '', '2019-08-06 08:40:00');
INSERT INTO `access_log` VALUES (63294, '65.47.15650519995113771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 08:40:00', 13, 0, '', '2019-08-06 08:40:00');
INSERT INTO `access_log` VALUES (63295, '65.52.15650519995103825', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 08:40:00', 14, 2001001000, '服务端发生异常', '2019-08-06 08:40:00');
INSERT INTO `access_log` VALUES (63296, '65.3607.15650520436915591', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '116.128.128.79', '2019-08-06 08:40:44', 1, 1002001015, '账号未登陆', '2019-08-06 08:40:44');
INSERT INTO `access_log` VALUES (63297, '65.54.15650520451073697', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '116.128.128.79', '2019-08-06 08:40:45', 0, 1002001015, '账号未登陆', '2019-08-06 08:40:45');
INSERT INTO `access_log` VALUES (63298, '65.52.15650546116643861', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:23:32', 0, 1002001015, '账号未登陆', '2019-08-06 09:23:32');
INSERT INTO `access_log` VALUES (63299, '65.49.15650546116643813', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:23:32', 0, 1002001015, '账号未登陆', '2019-08-06 09:23:32');
INSERT INTO `access_log` VALUES (63300, '65.53.15650546116643807', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:23:32', 0, 1002001015, '账号未登陆', '2019-08-06 09:23:32');
INSERT INTO `access_log` VALUES (63301, '65.51.15650546244523897', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:23:44', 1, 1002001015, '账号未登陆', '2019-08-06 09:23:44');
INSERT INTO `access_log` VALUES (63302, '65.45.15650546244683819', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:23:44', 0, 1002001015, '账号未登陆', '2019-08-06 09:23:44');
INSERT INTO `access_log` VALUES (63303, '65.50.15650546244693831', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:23:44', 0, 1002001015, '账号未登陆', '2019-08-06 09:23:44');
INSERT INTO `access_log` VALUES (63304, '65.3607.15650546277435627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:23:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-06 09:23:48');
INSERT INTO `access_log` VALUES (63305, '65.46.15650546361013871', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:23:56', 253, 0, '', '2019-08-06 09:23:56');
INSERT INTO `access_log` VALUES (63306, '65.49.15650546365813815', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:23:57', 15, 0, '', '2019-08-06 09:23:57');
INSERT INTO `access_log` VALUES (63307, '65.52.15650546365833863', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:23:57', 17, 2001001000, '服务端发生异常', '2019-08-06 09:23:57');
INSERT INTO `access_log` VALUES (63308, '65.53.15650546365943809', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:23:57', 10, 0, '', '2019-08-06 09:23:57');
INSERT INTO `access_log` VALUES (63309, '65.51.15650546501123899', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.219.185.244', '2019-08-06 09:24:10', 1, 1002001015, '账号未登陆', '2019-08-06 09:24:10');
INSERT INTO `access_log` VALUES (63310, '65.45.15650546501133821', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.219.185.244', '2019-08-06 09:24:10', 0, 1002001015, '账号未登陆', '2019-08-06 09:24:10');
INSERT INTO `access_log` VALUES (63311, '65.50.15650546501203833', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.219.185.244', '2019-08-06 09:24:10', 0, 1002001015, '账号未登陆', '2019-08-06 09:24:10');
INSERT INTO `access_log` VALUES (63312, '65.3607.15650546599395629', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.219.185.244', '2019-08-06 09:24:20', 1002, 0, '', '2019-08-06 09:24:21');
INSERT INTO `access_log` VALUES (63313, '65.54.15650546612423735', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.219.185.244', '2019-08-06 09:24:21', 9, 0, '', '2019-08-06 09:24:21');
INSERT INTO `access_log` VALUES (63314, '65.52.15650546612453865', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.219.185.244', '2019-08-06 09:24:21', 8, 0, '', '2019-08-06 09:24:21');
INSERT INTO `access_log` VALUES (63315, '65.46.15650546612433873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.219.185.244', '2019-08-06 09:24:21', 10, 2001001000, '服务端发生异常', '2019-08-06 09:24:21');
INSERT INTO `access_log` VALUES (63316, '65.47.15650546792043811', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.219.185.244', '2019-08-06 09:24:39', 9, 0, '', '2019-08-06 09:24:39');
INSERT INTO `access_log` VALUES (63317, '65.51.15650546792063901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.219.185.244', '2019-08-06 09:24:39', 9, 0, '', '2019-08-06 09:24:39');
INSERT INTO `access_log` VALUES (63318, '65.50.15650546792063835', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.219.185.244', '2019-08-06 09:24:39', 9, 2001001000, '服务端发生异常', '2019-08-06 09:24:39');
INSERT INTO `access_log` VALUES (63319, '59.78.15650546994961185', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.219.185.244', '2019-08-06 09:24:59', 10, 0, '', '2019-08-06 09:25:00');
INSERT INTO `access_log` VALUES (63320, '59.74.15650546994961189', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.219.185.244', '2019-08-06 09:24:59', 20, 2001001000, '服务端发生异常', '2019-08-06 09:25:00');
INSERT INTO `access_log` VALUES (63321, '64.76.15650547024671481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.219.185.244', '2019-08-06 09:25:02', 12, 0, '', '2019-08-06 09:25:02');
INSERT INTO `access_log` VALUES (63322, '64.83.15650547027641481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '103.219.185.244', '2019-08-06 09:25:03', 3, 0, '', '2019-08-06 09:25:03');
INSERT INTO `access_log` VALUES (63323, '65.51.15650547769943903', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:26:17', 10, 0, '', '2019-08-06 09:26:17');
INSERT INTO `access_log` VALUES (63324, '65.47.15650547769933813', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:26:17', 11, 2001001000, '服务端发生异常', '2019-08-06 09:26:17');
INSERT INTO `access_log` VALUES (63325, '65.53.15650547769903813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:26:17', 11, 0, '', '2019-08-06 09:26:17');
INSERT INTO `access_log` VALUES (63326, '65.50.15650547817403837', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:26:22', 10, 0, '', '2019-08-06 09:26:22');
INSERT INTO `access_log` VALUES (63327, '65.3607.15650547817425633', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:26:22', 9, 0, '', '2019-08-06 09:26:22');
INSERT INTO `access_log` VALUES (63328, '65.45.15650547817403825', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:26:22', 10, 2001001000, '服务端发生异常', '2019-08-06 09:26:22');
INSERT INTO `access_log` VALUES (63329, '65.54.15650547822383739', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:26:22', 14, 2001001000, '服务端发生异常', '2019-08-06 09:26:22');
INSERT INTO `access_log` VALUES (63330, '65.46.15650547822393877', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:26:22', 15, 0, '', '2019-08-06 09:26:22');
INSERT INTO `access_log` VALUES (63331, '65.52.15650547822363869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:26:22', 79, 0, '', '2019-08-06 09:26:22');
INSERT INTO `access_log` VALUES (63332, '65.49.15650547825323821', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:26:23', 10, 0, '', '2019-08-06 09:26:23');
INSERT INTO `access_log` VALUES (63333, '65.47.15650547825363815', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:26:23', 8, 0, '', '2019-08-06 09:26:23');
INSERT INTO `access_log` VALUES (63334, '65.51.15650547825353905', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:26:23', 9, 2001001000, '服务端发生异常', '2019-08-06 09:26:23');
INSERT INTO `access_log` VALUES (63335, '65.49.15650548743843823', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:27:54', 8, 0, '', '2019-08-06 09:27:54');
INSERT INTO `access_log` VALUES (63336, '65.47.15650548743933817', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:27:54', 9, 2001001000, '服务端发生异常', '2019-08-06 09:27:54');
INSERT INTO `access_log` VALUES (63337, '65.51.15650548743983907', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:27:54', 8, 0, '', '2019-08-06 09:27:54');
INSERT INTO `access_log` VALUES (63338, '59.80.15650549416111153', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:29:02', 3, 0, '', '2019-08-06 09:29:02');
INSERT INTO `access_log` VALUES (63339, '59.79.15650549416141187', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:29:02', 22, 2001001000, '服务端发生异常', '2019-08-06 09:29:02');
INSERT INTO `access_log` VALUES (63340, '64.82.15650549456841499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:29:06', 3, 0, '', '2019-08-06 09:29:06');
INSERT INTO `access_log` VALUES (63341, '64.76.15650549457541485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:29:06', 2, 0, '', '2019-08-06 09:29:06');
INSERT INTO `access_log` VALUES (63342, '64.83.15650549467881485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:29:07', 2, 0, '', '2019-08-06 09:29:07');
INSERT INTO `access_log` VALUES (63343, '64.85.15650549472441523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-06 09:29:07', 3, 0, '', '2019-08-06 09:29:07');
INSERT INTO `access_log` VALUES (63344, '59.74.15650561511561209', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:11', 3, 0, '', '2019-08-06 09:49:11');
INSERT INTO `access_log` VALUES (63345, '59.76.15650561511571189', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:11', 16, 2001001000, '服务端发生异常', '2019-08-06 09:49:11');
INSERT INTO `access_log` VALUES (63346, '64.81.15650561552341509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:15', 2, 0, '', '2019-08-06 09:49:15');
INSERT INTO `access_log` VALUES (63347, '64.84.15650561554521503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:15', 2, 0, '', '2019-08-06 09:49:15');
INSERT INTO `access_log` VALUES (63348, '64.80.15650561620371509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:22', 2, 0, '', '2019-08-06 09:49:22');
INSERT INTO `access_log` VALUES (63349, '64.78.15650561621821509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:22', 1, 0, '', '2019-08-06 09:49:22');
INSERT INTO `access_log` VALUES (63350, '59.71.15650561790681195', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.168.36.86', '2019-08-06 09:49:39', 2, 0, '', '2019-08-06 09:49:39');
INSERT INTO `access_log` VALUES (63351, '59.75.15650561790671207', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.168.36.86', '2019-08-06 09:49:39', 17, 2001001000, '服务端发生异常', '2019-08-06 09:49:39');
INSERT INTO `access_log` VALUES (63352, '59.72.15650561839861195', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:44', 2, 0, '', '2019-08-06 09:49:44');
INSERT INTO `access_log` VALUES (63353, '59.80.15650561839891171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:44', 16, 2001001000, '服务端发生异常', '2019-08-06 09:49:44');
INSERT INTO `access_log` VALUES (63354, '64.82.15650561879721517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:48', 1, 0, '', '2019-08-06 09:49:48');
INSERT INTO `access_log` VALUES (63355, '64.76.15650561882371503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:48', 1, 0, '', '2019-08-06 09:49:48');
INSERT INTO `access_log` VALUES (63356, '64.83.15650561896031503', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:50', 2, 0, '', '2019-08-06 09:49:50');
INSERT INTO `access_log` VALUES (63357, '64.85.15650561898521541', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.168.36.86', '2019-08-06 09:49:50', 2, 0, '', '2019-08-06 09:49:50');
INSERT INTO `access_log` VALUES (63358, '64.81.15650561899641511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.168.36.86', '2019-08-06 09:49:50', 2, 0, '', '2019-08-06 09:49:50');
INSERT INTO `access_log` VALUES (63359, '64.84.15650561900841505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:50', 2, 0, '', '2019-08-06 09:49:50');
INSERT INTO `access_log` VALUES (63360, '64.80.15650561912701511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.168.36.86', '2019-08-06 09:49:51', 2, 0, '', '2019-08-06 09:49:51');
INSERT INTO `access_log` VALUES (63361, '59.78.15650561913051207', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:51', 2, 0, '', '2019-08-06 09:49:51');
INSERT INTO `access_log` VALUES (63362, '59.74.15650561913101211', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:51', 17, 2001001000, '服务端发生异常', '2019-08-06 09:49:51');
INSERT INTO `access_log` VALUES (63363, '64.78.15650561919241511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.168.36.86', '2019-08-06 09:49:52', 2, 0, '', '2019-08-06 09:49:52');
INSERT INTO `access_log` VALUES (63364, '64.79.15650561925871505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.168.36.86', '2019-08-06 09:49:53', 2, 0, '', '2019-08-06 09:49:53');
INSERT INTO `access_log` VALUES (63365, '64.82.15650561941311519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:54', 2, 0, '', '2019-08-06 09:49:54');
INSERT INTO `access_log` VALUES (63366, '64.76.15650561942891505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:49:54', 2, 0, '', '2019-08-06 09:49:54');
INSERT INTO `access_log` VALUES (63367, '59.77.15650561943801187', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.168.36.86', '2019-08-06 09:49:54', 2, 0, '', '2019-08-06 09:49:54');
INSERT INTO `access_log` VALUES (63368, '59.76.15650561943801191', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.168.36.86', '2019-08-06 09:49:54', 18, 2001001000, '服务端发生异常', '2019-08-06 09:49:54');
INSERT INTO `access_log` VALUES (63369, '64.81.15650562272781513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:50:27', 2, 0, '', '2019-08-06 09:50:27');
INSERT INTO `access_log` VALUES (63370, '64.84.15650562280381507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:50:28', 1, 0, '', '2019-08-06 09:50:28');
INSERT INTO `access_log` VALUES (63371, '59.72.15650562450971197', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:50:45', 2, 0, '', '2019-08-06 09:50:45');
INSERT INTO `access_log` VALUES (63372, '59.80.15650562450971173', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:50:45', 30, 2001001000, '服务端发生异常', '2019-08-06 09:50:45');
INSERT INTO `access_log` VALUES (63373, '59.78.15650562592731209', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:50:59', 2, 0, '', '2019-08-06 09:50:59');
INSERT INTO `access_log` VALUES (63374, '59.74.15650562592781213', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:50:59', 14, 2001001000, '服务端发生异常', '2019-08-06 09:50:59');
INSERT INTO `access_log` VALUES (63375, '64.78.15650562610531513', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:51:01', 2, 0, '', '2019-08-06 09:51:01');
INSERT INTO `access_log` VALUES (63376, '64.79.15650562611891507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:51:01', 1, 0, '', '2019-08-06 09:51:01');
INSERT INTO `access_log` VALUES (63377, '64.82.15650562621251521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:51:02', 2, 0, '', '2019-08-06 09:51:02');
INSERT INTO `access_log` VALUES (63378, '64.76.15650562626301507', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:51:03', 1, 0, '', '2019-08-06 09:51:03');
INSERT INTO `access_log` VALUES (63379, '59.73.15650562813661201', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:51:21', 2, 0, '', '2019-08-06 09:51:21');
INSERT INTO `access_log` VALUES (63380, '59.71.15650562813691199', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '58.48.122.46', '2019-08-06 09:51:21', 18, 2001001000, '服务端发生异常', '2019-08-06 09:51:21');
INSERT INTO `access_log` VALUES (63381, '64.81.15650564334851517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '223.167.152.70', '2019-08-06 09:53:53', 10, 0, '', '2019-08-06 09:53:53');
INSERT INTO `access_log` VALUES (63382, '59.75.15650564346411213', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '223.167.152.53', '2019-08-06 09:53:55', 19, 2001001000, '服务端发生异常', '2019-08-06 09:53:55');
INSERT INTO `access_log` VALUES (63383, '64.80.15650564663001517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '58.246.221.163', '2019-08-06 09:54:26', 1, 0, '', '2019-08-06 09:54:26');
INSERT INTO `access_log` VALUES (63384, '64.76.15650565135981511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '58.247.204.63', '2019-08-06 09:55:14', 2, 0, '', '2019-08-06 09:55:14');
INSERT INTO `access_log` VALUES (63385, '59.80.15650565972801179', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '58.247.204.63', '2019-08-06 09:56:37', 3, 0, '', '2019-08-06 09:56:37');
INSERT INTO `access_log` VALUES (63386, '64.81.15650566907921521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '58.246.221.163', '2019-08-06 09:58:11', 3, 0, '', '2019-08-06 09:58:11');
INSERT INTO `access_log` VALUES (63387, '59.73.15650571279921213', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '14.155.89.200', '2019-08-06 10:05:28', 3, 0, '', '2019-08-06 10:05:28');
INSERT INTO `access_log` VALUES (63388, '59.71.15650571279921211', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '14.155.89.200', '2019-08-06 10:05:28', 21, 2001001000, '服务端发生异常', '2019-08-06 10:05:28');
INSERT INTO `access_log` VALUES (63389, '65.3607.15650571510725667', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '14.155.89.200', '2019-08-06 10:05:51', 0, 1002001015, '账号未登陆', '2019-08-06 10:05:51');
INSERT INTO `access_log` VALUES (63390, '65.54.15650571510733775', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '14.155.89.200', '2019-08-06 10:05:51', 0, 1002001015, '账号未登陆', '2019-08-06 10:05:51');
INSERT INTO `access_log` VALUES (63391, '65.46.15650571510753913', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '14.155.89.200', '2019-08-06 10:05:51', 0, 1002001015, '账号未登陆', '2019-08-06 10:05:51');
INSERT INTO `access_log` VALUES (63392, '65.52.15650571534553903', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '14.155.89.200', '2019-08-06 10:05:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-06 10:05:53');
INSERT INTO `access_log` VALUES (63393, '65.49.15650571676853857', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '14.155.89.200', '2019-08-06 10:06:08', 87, 0, '', '2019-08-06 10:06:08');
INSERT INTO `access_log` VALUES (63394, '65.51.15650571679793937', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '14.155.89.200', '2019-08-06 10:06:08', 10, 0, '', '2019-08-06 10:06:08');
INSERT INTO `access_log` VALUES (63395, '65.45.15650571679843863', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '14.155.89.200', '2019-08-06 10:06:08', 16, 0, '', '2019-08-06 10:06:08');
INSERT INTO `access_log` VALUES (63396, '65.53.15650571679833849', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '14.155.89.200', '2019-08-06 10:06:08', 19, 2001001000, '服务端发生异常', '2019-08-06 10:06:08');
INSERT INTO `access_log` VALUES (63397, '65.3607.15650571753805669', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '14.155.89.200', '2019-08-06 10:06:15', 10, 0, '', '2019-08-06 10:06:15');
INSERT INTO `access_log` VALUES (63398, '65.54.15650571753823777', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '14.155.89.200', '2019-08-06 10:06:15', 10, 2001001000, '服务端发生异常', '2019-08-06 10:06:15');
INSERT INTO `access_log` VALUES (63399, '65.46.15650571753833915', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '14.155.89.200', '2019-08-06 10:06:15', 9, 0, '', '2019-08-06 10:06:15');
INSERT INTO `access_log` VALUES (63400, '65.54.15650572836633779', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.17.231.113', '2019-08-06 10:08:04', 0, 1002001015, '账号未登陆', '2019-08-06 10:08:04');
INSERT INTO `access_log` VALUES (63401, '65.46.15650572836633917', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.17.231.113', '2019-08-06 10:08:04', 0, 1002001015, '账号未登陆', '2019-08-06 10:08:04');
INSERT INTO `access_log` VALUES (63402, '65.3607.15650572836655671', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.17.231.113', '2019-08-06 10:08:04', 0, 1002001015, '账号未登陆', '2019-08-06 10:08:04');
INSERT INTO `access_log` VALUES (63403, '65.52.15650572860543907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.17.231.113', '2019-08-06 10:08:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-06 10:08:06');
INSERT INTO `access_log` VALUES (63404, '65.49.15650572913513861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.17.231.113', '2019-08-06 10:08:11', 60, 0, '', '2019-08-06 10:08:11');
INSERT INTO `access_log` VALUES (63405, '65.53.15650572916733853', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.17.231.113', '2019-08-06 10:08:12', 9, 0, '', '2019-08-06 10:08:12');
INSERT INTO `access_log` VALUES (63406, '65.51.15650572916743941', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.17.231.113', '2019-08-06 10:08:12', 11, 2001001000, '服务端发生异常', '2019-08-06 10:08:12');
INSERT INTO `access_log` VALUES (63407, '65.45.15650572916773867', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.17.231.113', '2019-08-06 10:08:12', 14, 0, '', '2019-08-06 10:08:12');
INSERT INTO `access_log` VALUES (63408, '65.50.15650572986553879', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.17.231.113', '2019-08-06 10:08:19', 17, 0, '', '2019-08-06 10:08:19');
INSERT INTO `access_log` VALUES (63409, '65.54.15650572986583781', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.17.231.113', '2019-08-06 10:08:19', 9, 0, '', '2019-08-06 10:08:19');
INSERT INTO `access_log` VALUES (63410, '65.3607.15650572986585673', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.17.231.113', '2019-08-06 10:08:19', 10, 2001001000, '服务端发生异常', '2019-08-06 10:08:19');
INSERT INTO `access_log` VALUES (63411, '65.46.15650573019993919', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.17.231.113', '2019-08-06 10:08:22', 9, 0, '', '2019-08-06 10:08:22');
INSERT INTO `access_log` VALUES (63412, '65.52.15650573020013909', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.17.231.113', '2019-08-06 10:08:22', 10, 2001001000, '服务端发生异常', '2019-08-06 10:08:22');
INSERT INTO `access_log` VALUES (63413, '65.47.15650573020033853', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.17.231.113', '2019-08-06 10:08:22', 9, 0, '', '2019-08-06 10:08:22');
INSERT INTO `access_log` VALUES (63414, '65.3607.15650603848475715', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.85.230.239', '2019-08-06 10:59:45', 0, 1002001015, '账号未登陆', '2019-08-06 10:59:45');
INSERT INTO `access_log` VALUES (63415, '65.52.15650603848483951', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.85.230.239', '2019-08-06 10:59:45', 1, 1002001015, '账号未登陆', '2019-08-06 10:59:45');
INSERT INTO `access_log` VALUES (63416, '65.47.15650603848733895', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.85.231.187', '2019-08-06 10:59:45', 0, 1002001015, '账号未登陆', '2019-08-06 10:59:45');
INSERT INTO `access_log` VALUES (63417, '65.46.15650603873163961', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.85.230.239', '2019-08-06 10:59:47', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-06 10:59:47');
INSERT INTO `access_log` VALUES (63418, '65.53.15650604159553897', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.85.230.239', '2019-08-06 11:00:16', 73, 0, '', '2019-08-06 11:00:16');
INSERT INTO `access_log` VALUES (63419, '65.51.15650604162063985', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.85.231.187', '2019-08-06 11:00:16', 14, 0, '', '2019-08-06 11:00:16');
INSERT INTO `access_log` VALUES (63420, '65.50.15650604162103923', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.85.230.239', '2019-08-06 11:00:16', 12, 0, '', '2019-08-06 11:00:16');
INSERT INTO `access_log` VALUES (63421, '65.54.15650604162103825', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.85.230.239', '2019-08-06 11:00:16', 14, 2001001000, '服务端发生异常', '2019-08-06 11:00:16');
INSERT INTO `access_log` VALUES (63422, '65.52.15650604245433953', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.85.231.187', '2019-08-06 11:00:25', 10, 0, '', '2019-08-06 11:00:25');
INSERT INTO `access_log` VALUES (63423, '65.46.15650604245453963', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.85.230.239', '2019-08-06 11:00:25', 17, 0, '', '2019-08-06 11:00:25');
INSERT INTO `access_log` VALUES (63424, '65.3607.15650604245445717', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.85.230.239', '2019-08-06 11:00:25', 9, 2001001000, '服务端发生异常', '2019-08-06 11:00:25');
INSERT INTO `access_log` VALUES (63425, '59.80.15650613504291243', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.13.72.106', '2019-08-06 11:15:50', 11, 0, '', '2019-08-06 11:15:50');
INSERT INTO `access_log` VALUES (63426, '59.79.15650613504321277', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.13.72.106', '2019-08-06 11:15:50', 17, 2001001000, '服务端发生异常', '2019-08-06 11:15:50');
INSERT INTO `access_log` VALUES (63427, '64.77.15650613585951571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:15:59', 11, 0, '', '2019-08-06 11:15:59');
INSERT INTO `access_log` VALUES (63428, '64.80.15650613586951583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:15:59', 3, 0, '', '2019-08-06 11:15:59');
INSERT INTO `access_log` VALUES (63429, '59.78.15650613605441279', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:01', 4, 0, '', '2019-08-06 11:16:01');
INSERT INTO `access_log` VALUES (63430, '59.74.15650613605461283', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:01', 20, 2001001000, '服务端发生异常', '2019-08-06 11:16:01');
INSERT INTO `access_log` VALUES (63431, '64.78.15650613628921583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:03', 2, 0, '', '2019-08-06 11:16:03');
INSERT INTO `access_log` VALUES (63432, '64.79.15650613629971577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:03', 2, 0, '', '2019-08-06 11:16:03');
INSERT INTO `access_log` VALUES (63433, '64.82.15650613641741591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:04', 2, 0, '', '2019-08-06 11:16:04');
INSERT INTO `access_log` VALUES (63434, '64.76.15650613649821577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:05', 2, 0, '', '2019-08-06 11:16:05');
INSERT INTO `access_log` VALUES (63435, '64.85.15650613669381615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:07', 2, 0, '', '2019-08-06 11:16:07');
INSERT INTO `access_log` VALUES (63436, '64.81.15650613680181585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:08', 2, 0, '', '2019-08-06 11:16:08');
INSERT INTO `access_log` VALUES (63437, '64.84.15650613696481579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:10', 2, 0, '', '2019-08-06 11:16:10');
INSERT INTO `access_log` VALUES (63438, '64.77.15650613703461573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:10', 2, 0, '', '2019-08-06 11:16:10');
INSERT INTO `access_log` VALUES (63439, '64.80.15650613724521585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:12', 2, 0, '', '2019-08-06 11:16:12');
INSERT INTO `access_log` VALUES (63440, '64.78.15650613730911585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:13', 1, 0, '', '2019-08-06 11:16:13');
INSERT INTO `access_log` VALUES (63441, '64.79.15650613737591579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:14', 2, 0, '', '2019-08-06 11:16:14');
INSERT INTO `access_log` VALUES (63442, '64.82.15650613754791593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:15', 2, 0, '', '2019-08-06 11:16:15');
INSERT INTO `access_log` VALUES (63443, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:15', 6, 0, '', '2019-08-06 11:16:15');
INSERT INTO `access_log` VALUES (63444, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:17', 5, 0, '', '2019-08-06 11:16:17');
INSERT INTO `access_log` VALUES (63445, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:19', 5, 0, '', '2019-08-06 11:16:19');
INSERT INTO `access_log` VALUES (63446, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:20', 6, 0, '', '2019-08-06 11:16:20');
INSERT INTO `access_log` VALUES (63447, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:21', 5, 0, '', '2019-08-06 11:16:21');
INSERT INTO `access_log` VALUES (63448, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:22', 5, 0, '', '2019-08-06 11:16:22');
INSERT INTO `access_log` VALUES (63449, '64.83.15650613826681579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:23', 2, 0, '', '2019-08-06 11:16:23');
INSERT INTO `access_log` VALUES (63450, '64.85.15650613827661617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:23', 2, 0, '', '2019-08-06 11:16:23');
INSERT INTO `access_log` VALUES (63451, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:24', 6, 0, '', '2019-08-06 11:16:24');
INSERT INTO `access_log` VALUES (63452, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:24', 11, 0, '', '2019-08-06 11:16:24');
INSERT INTO `access_log` VALUES (63453, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=desc', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:34', 7, 0, '', '2019-08-06 11:16:34');
INSERT INTO `access_log` VALUES (63454, '64.84.15650613963451581', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:36', 8, 0, '', '2019-08-06 11:16:36');
INSERT INTO `access_log` VALUES (63455, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:45', 6, 0, '', '2019-08-06 11:16:45');
INSERT INTO `access_log` VALUES (63456, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:45', 8, 0, '', '2019-08-06 11:16:45');
INSERT INTO `access_log` VALUES (63457, '64.77.15650614068051575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:47', 2, 0, '', '2019-08-06 11:16:47');
INSERT INTO `access_log` VALUES (63458, '64.80.15650614069271587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:47', 2, 0, '', '2019-08-06 11:16:47');
INSERT INTO `access_log` VALUES (63459, '66.54.15650614121888969', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:52', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-08-06 11:16:52');
INSERT INTO `access_log` VALUES (63460, '64.79.15650614156821581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:56', 2, 0, '', '2019-08-06 11:16:56');
INSERT INTO `access_log` VALUES (63461, '64.82.15650614157681595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.13.72.106', '2019-08-06 11:16:56', 2, 0, '', '2019-08-06 11:16:56');
INSERT INTO `access_log` VALUES (63462, '59.80.15650614456261245', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.190.108', '2019-08-06 11:17:26', 3, 0, '', '2019-08-06 11:17:26');
INSERT INTO `access_log` VALUES (63463, '59.79.15650614456261279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.190.108', '2019-08-06 11:17:26', 12, 2001001000, '服务端发生异常', '2019-08-06 11:17:26');
INSERT INTO `access_log` VALUES (63464, '64.85.15650614477861619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.190.108', '2019-08-06 11:17:28', 2, 0, '', '2019-08-06 11:17:28');
INSERT INTO `access_log` VALUES (63465, '64.81.15650614479921589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.190.108', '2019-08-06 11:17:28', 2, 0, '', '2019-08-06 11:17:28');
INSERT INTO `access_log` VALUES (63466, '64.84.15650614543881583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.190.108', '2019-08-06 11:17:34', 2, 0, '', '2019-08-06 11:17:34');
INSERT INTO `access_log` VALUES (63467, '64.77.15650614544931577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.190.108', '2019-08-06 11:17:34', 1, 0, '', '2019-08-06 11:17:34');
INSERT INTO `access_log` VALUES (63468, '59.77.15650614550881261', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.190.108', '2019-08-06 11:17:35', 2, 0, '', '2019-08-06 11:17:35');
INSERT INTO `access_log` VALUES (63469, '59.74.15650614550881285', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.193.190.108', '2019-08-06 11:17:35', 32, 2001001000, '服务端发生异常', '2019-08-06 11:17:35');
INSERT INTO `access_log` VALUES (63470, '59.77.15650638416561293', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.17.99.62', '2019-08-06 11:57:22', 27, 0, '', '2019-08-06 11:57:22');
INSERT INTO `access_log` VALUES (63471, '59.76.15650638416561297', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.17.99.62', '2019-08-06 11:57:22', 31, 2001001000, '服务端发生异常', '2019-08-06 11:57:22');
INSERT INTO `access_log` VALUES (63472, '64.80.15650638485171621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.17.99.62', '2019-08-06 11:57:29', 9, 0, '', '2019-08-06 11:57:29');
INSERT INTO `access_log` VALUES (63473, '64.78.15650638486221621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.17.99.62', '2019-08-06 11:57:29', 2, 0, '', '2019-08-06 11:57:29');
INSERT INTO `access_log` VALUES (63474, '59.73.15650653489081325', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '119.137.52.251', '2019-08-06 12:22:29', 4, 0, '', '2019-08-06 12:22:29');
INSERT INTO `access_log` VALUES (63475, '59.71.15650653489081323', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '119.137.52.251', '2019-08-06 12:22:29', 14, 2001001000, '服务端发生异常', '2019-08-06 12:22:29');
INSERT INTO `access_log` VALUES (63476, '59.79.15650664303681347', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '106.17.207.99', '2019-08-06 12:40:30', 3, 0, '', '2019-08-06 12:40:30');
INSERT INTO `access_log` VALUES (63477, '59.80.15650664303751313', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '106.17.207.99', '2019-08-06 12:40:30', 21, 2001001000, '服务端发生异常', '2019-08-06 12:40:30');
INSERT INTO `access_log` VALUES (63478, '59.75.15650683229331375', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.216.191.67', '2019-08-06 13:12:03', 10, 0, '', '2019-08-06 13:12:03');
INSERT INTO `access_log` VALUES (63479, '59.72.15650683229341363', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '114.216.191.67', '2019-08-06 13:12:03', 17, 2001001000, '服务端发生异常', '2019-08-06 13:12:03');
INSERT INTO `access_log` VALUES (63480, '59.73.15650705088071395', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '124.251.33.21', '2019-08-06 13:48:29', 10, 0, '', '2019-08-06 13:48:29');
INSERT INTO `access_log` VALUES (63481, '59.71.15650705088071393', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '124.251.33.21', '2019-08-06 13:48:29', 21, 2001001000, '服务端发生异常', '2019-08-06 13:48:29');
INSERT INTO `access_log` VALUES (63482, '64.85.15650705125771741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '124.251.33.21', '2019-08-06 13:48:33', 10, 0, '', '2019-08-06 13:48:33');
INSERT INTO `access_log` VALUES (63483, '64.81.15650705127211711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '124.251.33.21', '2019-08-06 13:48:33', 2, 0, '', '2019-08-06 13:48:33');
INSERT INTO `access_log` VALUES (63484, '59.80.15650705145241369', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '124.251.33.21', '2019-08-06 13:48:35', 3, 0, '', '2019-08-06 13:48:35');
INSERT INTO `access_log` VALUES (63485, '59.75.15650705145241405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '124.251.33.21', '2019-08-06 13:48:35', 13, 2001001000, '服务端发生异常', '2019-08-06 13:48:35');
INSERT INTO `access_log` VALUES (63486, '59.75.15650706634391407', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.119.226', '2019-08-06 13:51:03', 2, 0, '', '2019-08-06 13:51:03');
INSERT INTO `access_log` VALUES (63487, '59.79.15650706634391405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.119.226', '2019-08-06 13:51:03', 13, 2001001000, '服务端发生异常', '2019-08-06 13:51:03');
INSERT INTO `access_log` VALUES (63488, '64.77.15650706694021701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.119.226', '2019-08-06 13:51:09', 2, 0, '', '2019-08-06 13:51:09');
INSERT INTO `access_log` VALUES (63489, '64.80.15650706695141713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.119.226', '2019-08-06 13:51:10', 2, 0, '', '2019-08-06 13:51:10');
INSERT INTO `access_log` VALUES (63490, '64.78.15650706708021713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.119.226', '2019-08-06 13:51:11', 2, 0, '', '2019-08-06 13:51:11');
INSERT INTO `access_log` VALUES (63491, '64.79.15650706713641707', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.119.226', '2019-08-06 13:51:11', 2, 0, '', '2019-08-06 13:51:11');
INSERT INTO `access_log` VALUES (63492, '64.82.15650706717781721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.119.226', '2019-08-06 13:51:12', 2, 0, '', '2019-08-06 13:51:12');
INSERT INTO `access_log` VALUES (63493, '59.74.15650706730361411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.119.226', '2019-08-06 13:51:13', 2, 0, '', '2019-08-06 13:51:13');
INSERT INTO `access_log` VALUES (63494, '59.76.15650706730401391', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.119.226', '2019-08-06 13:51:13', 12, 2001001000, '服务端发生异常', '2019-08-06 13:51:13');
INSERT INTO `access_log` VALUES (63495, '59.73.15650706791471399', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.119.226', '2019-08-06 13:51:19', 2, 0, '', '2019-08-06 13:51:19');
INSERT INTO `access_log` VALUES (63496, '59.71.15650706791501397', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.183.119.226', '2019-08-06 13:51:19', 18, 2001001000, '服务端发生异常', '2019-08-06 13:51:19');
INSERT INTO `access_log` VALUES (63497, '59.80.15650726502901399', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:10', 11, 0, '', '2019-08-06 14:24:10');
INSERT INTO `access_log` VALUES (63498, '59.75.15650726502901435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:10', 17, 2001001000, '服务端发生异常', '2019-08-06 14:24:10');
INSERT INTO `access_log` VALUES (63499, '64.81.15650726613391741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:21', 15, 0, '', '2019-08-06 14:24:21');
INSERT INTO `access_log` VALUES (63500, '64.84.15650726614811735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:21', 3, 0, '', '2019-08-06 14:24:21');
INSERT INTO `access_log` VALUES (63501, '64.77.15650726663781729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:26', 2, 0, '', '2019-08-06 14:24:26');
INSERT INTO `access_log` VALUES (63502, '64.80.15650726665281741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:27', 2, 0, '', '2019-08-06 14:24:27');
INSERT INTO `access_log` VALUES (63503, '64.78.15650726676441741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:28', 2, 0, '', '2019-08-06 14:24:28');
INSERT INTO `access_log` VALUES (63504, '64.79.15650726677831735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:28', 1, 0, '', '2019-08-06 14:24:28');
INSERT INTO `access_log` VALUES (63505, '64.82.15650726691551749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:29', 2, 0, '', '2019-08-06 14:24:29');
INSERT INTO `access_log` VALUES (63506, '64.76.15650726702811735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:30', 2, 0, '', '2019-08-06 14:24:30');
INSERT INTO `access_log` VALUES (63507, '59.78.15650726730801435', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:33', 5, 0, '', '2019-08-06 14:24:33');
INSERT INTO `access_log` VALUES (63508, '59.74.15650726730851439', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:33', 12, 2001001000, '服务端发生异常', '2019-08-06 14:24:33');
INSERT INTO `access_log` VALUES (63509, '65.3607.15650726949095881', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:55', 1, 1002001015, '账号未登陆', '2019-08-06 14:24:55');
INSERT INTO `access_log` VALUES (63510, '65.52.15650726949094119', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:55', 0, 1002001015, '账号未登陆', '2019-08-06 14:24:55');
INSERT INTO `access_log` VALUES (63511, '65.49.15650726949344071', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:55', 1, 1002001015, '账号未登陆', '2019-08-06 14:24:55');
INSERT INTO `access_log` VALUES (63512, '65.50.15650726977614089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:24:58', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-06 14:24:58');
INSERT INTO `access_log` VALUES (63513, '65.51.15650727368904153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:25:37', 108, 0, '', '2019-08-06 14:25:37');
INSERT INTO `access_log` VALUES (63514, '65.54.15650727373273991', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:25:37', 21, 0, '', '2019-08-06 14:25:37');
INSERT INTO `access_log` VALUES (63515, '65.46.15650727373364129', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:25:37', 17, 2001001000, '服务端发生异常', '2019-08-06 14:25:37');
INSERT INTO `access_log` VALUES (63516, '65.45.15650727373444079', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:25:37', 10, 0, '', '2019-08-06 14:25:37');
INSERT INTO `access_log` VALUES (63517, '65.52.15650727624204121', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:26:02', 11, 0, '', '2019-08-06 14:26:02');
INSERT INTO `access_log` VALUES (63518, '65.50.15650727624254091', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:26:02', 14, 2001001000, '服务端发生异常', '2019-08-06 14:26:02');
INSERT INTO `access_log` VALUES (63519, '65.47.15650727624324067', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.209.34.134', '2019-08-06 14:26:02', 13, 0, '', '2019-08-06 14:26:02');
INSERT INTO `access_log` VALUES (63520, '59.76.15650735597001431', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:39:20', 4, 0, '', '2019-08-06 14:39:20');
INSERT INTO `access_log` VALUES (63521, '59.77.15650735597061427', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:39:20', 14, 2001001000, '服务端发生异常', '2019-08-06 14:39:20');
INSERT INTO `access_log` VALUES (63522, '59.71.15650735632411437', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:39:23', 3, 0, '', '2019-08-06 14:39:23');
INSERT INTO `access_log` VALUES (63523, '59.73.15650735632411439', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:39:23', 18, 2001001000, '服务端发生异常', '2019-08-06 14:39:23');
INSERT INTO `access_log` VALUES (63524, '64.83.15650735716561747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:39:32', 3, 0, '', '2019-08-06 14:39:32');
INSERT INTO `access_log` VALUES (63525, '64.85.15650735719261785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:39:32', 2, 0, '', '2019-08-06 14:39:32');
INSERT INTO `access_log` VALUES (63526, '64.81.15650735734161755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:39:33', 2, 0, '', '2019-08-06 14:39:33');
INSERT INTO `access_log` VALUES (63527, '64.77.15650735779671743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:39:38', 2, 0, '', '2019-08-06 14:39:38');
INSERT INTO `access_log` VALUES (63528, '64.80.15650735782481755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:39:38', 1, 0, '', '2019-08-06 14:39:38');
INSERT INTO `access_log` VALUES (63529, '65.50.15650735984684103', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:39:58', 1, 1002001015, '账号未登陆', '2019-08-06 14:39:58');
INSERT INTO `access_log` VALUES (63530, '65.52.15650735984684133', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:39:58', 1, 1002001015, '账号未登陆', '2019-08-06 14:39:58');
INSERT INTO `access_log` VALUES (63531, '65.49.15650735984684085', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:39:58', 1, 1002001015, '账号未登陆', '2019-08-06 14:39:58');
INSERT INTO `access_log` VALUES (63532, '65.47.15650736003494079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:40:00', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-06 14:40:00');
INSERT INTO `access_log` VALUES (63533, '65.53.15650736085964079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:40:09', 84, 0, '', '2019-08-06 14:40:09');
INSERT INTO `access_log` VALUES (63534, '65.54.15650736089404005', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:40:09', 8, 0, '', '2019-08-06 14:40:09');
INSERT INTO `access_log` VALUES (63535, '65.45.15650736089424093', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:40:09', 9, 0, '', '2019-08-06 14:40:09');
INSERT INTO `access_log` VALUES (63536, '65.46.15650736089404143', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '221.222.200.126', '2019-08-06 14:40:09', 11, 2001001000, '服务端发生异常', '2019-08-06 14:40:09');
INSERT INTO `access_log` VALUES (63537, '59.80.15650762742061449', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.97.179.148', '2019-08-06 15:24:34', 10, 0, '', '2019-08-06 15:24:34');
INSERT INTO `access_log` VALUES (63538, '59.75.15650762742061485', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.97.179.148', '2019-08-06 15:24:34', 30, 2001001000, '服务端发生异常', '2019-08-06 15:24:34');
INSERT INTO `access_log` VALUES (63539, '65.45.15650762893954129', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.97.179.148', '2019-08-06 15:24:49', 1, 1002001015, '账号未登陆', '2019-08-06 15:24:49');
INSERT INTO `access_log` VALUES (63540, '65.46.15650762893954179', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.97.179.148', '2019-08-06 15:24:49', 0, 1002001015, '账号未登陆', '2019-08-06 15:24:49');
INSERT INTO `access_log` VALUES (63541, '65.3607.15650762894265933', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.97.179.148', '2019-08-06 15:24:49', 1, 1002001015, '账号未登陆', '2019-08-06 15:24:49');
INSERT INTO `access_log` VALUES (63542, '65.52.15650762917214171', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.97.179.148', '2019-08-06 15:24:52', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-06 15:24:52');
INSERT INTO `access_log` VALUES (63543, '65.49.15650763060814123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.97.179.148', '2019-08-06 15:25:06', 60, 0, '', '2019-08-06 15:25:06');
INSERT INTO `access_log` VALUES (63544, '65.53.15650763064544117', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.97.179.148', '2019-08-06 15:25:06', 15, 2001001000, '服务端发生异常', '2019-08-06 15:25:06');
INSERT INTO `access_log` VALUES (63545, '65.47.15650763064544117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.97.179.148', '2019-08-06 15:25:06', 15, 0, '', '2019-08-06 15:25:06');
INSERT INTO `access_log` VALUES (63546, '65.51.15650763064624205', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.97.179.148', '2019-08-06 15:25:06', 10, 0, '', '2019-08-06 15:25:06');
INSERT INTO `access_log` VALUES (63547, '65.46.15650763195294181', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.97.179.148', '2019-08-06 15:25:20', 179, 0, '', '2019-08-06 15:25:20');
INSERT INTO `access_log` VALUES (63548, '65.3607.15650763195265935', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.97.179.148', '2019-08-06 15:25:20', 181, 0, '', '2019-08-06 15:25:20');
INSERT INTO `access_log` VALUES (63549, '65.45.15650763195264131', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.97.179.148', '2019-08-06 15:25:20', 182, 2001001000, '服务端发生异常', '2019-08-06 15:25:20');
INSERT INTO `access_log` VALUES (63550, '59.79.15650807720041543', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '58.247.119.33', '2019-08-06 16:39:32', 15, 0, '', '2019-08-06 16:39:32');
INSERT INTO `access_log` VALUES (63551, '59.75.15650807719941545', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '58.247.119.33', '2019-08-06 16:39:32', 25, 2001001000, '服务端发生异常', '2019-08-06 16:39:32');
INSERT INTO `access_log` VALUES (63552, '59.76.15650877115891621', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.108 Safari/537.36', '183.3.148.34', '2019-08-06 18:35:12', 9, 0, '', '2019-08-06 18:35:12');
INSERT INTO `access_log` VALUES (63553, '59.73.15650877115911629', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.108 Safari/537.36', '183.3.148.34', '2019-08-06 18:35:12', 12, 2001001000, '服务端发生异常', '2019-08-06 18:35:12');
INSERT INTO `access_log` VALUES (63554, '64.82.15650877176191951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.108 Safari/537.36', '183.3.148.34', '2019-08-06 18:35:18', 14, 0, '', '2019-08-06 18:35:18');
INSERT INTO `access_log` VALUES (63555, '64.76.15650877177661937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.108 Safari/537.36', '183.3.148.34', '2019-08-06 18:35:18', 3, 0, '', '2019-08-06 18:35:18');
INSERT INTO `access_log` VALUES (63556, '64.83.15650877194531937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.108 Safari/537.36', '183.3.148.34', '2019-08-06 18:35:19', 2, 0, '', '2019-08-06 18:35:19');
INSERT INTO `access_log` VALUES (63557, '64.85.15650877203301975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.108 Safari/537.36', '183.3.148.34', '2019-08-06 18:35:20', 2, 0, '', '2019-08-06 18:35:20');
INSERT INTO `access_log` VALUES (63558, '64.84.15650877250601939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.108 Safari/537.36', '183.3.148.34', '2019-08-06 18:35:25', 2, 0, '', '2019-08-06 18:35:25');
INSERT INTO `access_log` VALUES (63559, '64.77.15650877251821933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.108 Safari/537.36', '183.3.148.34', '2019-08-06 18:35:25', 2, 0, '', '2019-08-06 18:35:25');
INSERT INTO `access_log` VALUES (63560, '65.47.15650877440374271', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.108 Safari/537.36', '183.3.148.34', '2019-08-06 18:35:44', 0, 1002001015, '账号未登陆', '2019-08-06 18:35:44');
INSERT INTO `access_log` VALUES (63561, '65.46.15650877440404333', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.108 Safari/537.36', '183.3.148.34', '2019-08-06 18:35:44', 1, 1002001015, '账号未登陆', '2019-08-06 18:35:44');
INSERT INTO `access_log` VALUES (63562, '65.54.15650877440404197', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.108 Safari/537.36', '183.3.148.34', '2019-08-06 18:35:44', 0, 1002001015, '账号未登陆', '2019-08-06 18:35:44');
INSERT INTO `access_log` VALUES (63563, '59.74.15650949866521739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:36:27', 20, 2001001000, '服务端发生异常', '2019-08-06 20:36:27');
INSERT INTO `access_log` VALUES (63564, '59.78.15650949866501735', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:36:27', 250, 0, '', '2019-08-06 20:36:27');
INSERT INTO `access_log` VALUES (63565, '64.76.15650949933432035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:36:33', 11, 0, '', '2019-08-06 20:36:33');
INSERT INTO `access_log` VALUES (63566, '64.83.15650949934882035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:36:33', 3, 0, '', '2019-08-06 20:36:34');
INSERT INTO `access_log` VALUES (63567, '59.76.15650949965221719', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:36:37', 3, 0, '', '2019-08-06 20:36:37');
INSERT INTO `access_log` VALUES (63568, '59.73.15650949965261727', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:36:37', 22, 2001001000, '服务端发生异常', '2019-08-06 20:36:37');
INSERT INTO `access_log` VALUES (63569, '65.47.15650950054204367', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:36:45', 1, 1002001015, '账号未登陆', '2019-08-06 20:36:45');
INSERT INTO `access_log` VALUES (63570, '65.45.15650950054164385', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:36:45', 1, 1002001015, '账号未登陆', '2019-08-06 20:36:45');
INSERT INTO `access_log` VALUES (63571, '65.46.15650950054164431', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:36:45', 0, 1002001015, '账号未登陆', '2019-08-06 20:36:45');
INSERT INTO `access_log` VALUES (63572, '65.52.15650950074024425', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:36:47', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-06 20:36:47');
INSERT INTO `access_log` VALUES (63573, '65.50.15650950097594399', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:36:50', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-06 20:36:50');
INSERT INTO `access_log` VALUES (63574, '65.3607.15650950106036189', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:36:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-06 20:36:51');
INSERT INTO `access_log` VALUES (63575, '65.51.15650950108484463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:36:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-06 20:36:51');
INSERT INTO `access_log` VALUES (63576, '65.53.15650950268974373', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:37:07', 88, 0, '', '2019-08-06 20:37:07');
INSERT INTO `access_log` VALUES (63577, '65.54.15650950272984299', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:37:07', 19, 0, '', '2019-08-06 20:37:07');
INSERT INTO `access_log` VALUES (63578, '65.45.15650950273024387', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:37:07', 16, 0, '', '2019-08-06 20:37:07');
INSERT INTO `access_log` VALUES (63579, '65.47.15650950272984369', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '125.35.5.253', '2019-08-06 20:37:07', 20, 2001001000, '服务端发生异常', '2019-08-06 20:37:07');
INSERT INTO `access_log` VALUES (63580, '59.73.15650952703761731', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.207.124', '2019-08-06 20:41:10', 3, 0, '', '2019-08-06 20:41:10');
INSERT INTO `access_log` VALUES (63581, '59.76.15650952703751723', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.207.124', '2019-08-06 20:41:10', 25, 2001001000, '服务端发生异常', '2019-08-06 20:41:10');
INSERT INTO `access_log` VALUES (63582, '65.45.15650952826954391', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.207.124', '2019-08-06 20:41:23', 4, 1002001012, '访问令牌已过期', '2019-08-06 20:41:23');
INSERT INTO `access_log` VALUES (63583, '65.54.15650952826984303', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.207.124', '2019-08-06 20:41:23', 3, 1002001012, '访问令牌已过期', '2019-08-06 20:41:23');
INSERT INTO `access_log` VALUES (63584, '65.47.15650952827074373', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.207.124', '2019-08-06 20:41:23', 4, 1002001012, '访问令牌已过期', '2019-08-06 20:41:23');
INSERT INTO `access_log` VALUES (63585, '65.52.15650952899754431', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.207.124', '2019-08-06 20:41:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-06 20:41:30');
INSERT INTO `access_log` VALUES (63586, '65.50.15650952926714405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.207.124', '2019-08-06 20:41:33', 221, 0, '', '2019-08-06 20:41:33');
INSERT INTO `access_log` VALUES (63587, '65.3607.15650952931536195', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.207.124', '2019-08-06 20:41:33', 162, 0, '', '2019-08-06 20:41:33');
INSERT INTO `access_log` VALUES (63588, '65.51.15650952931554469', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.207.124', '2019-08-06 20:41:33', 160, 2001001000, '服务端发生异常', '2019-08-06 20:41:33');
INSERT INTO `access_log` VALUES (63589, '65.49.15650952931614387', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '59.42.207.124', '2019-08-06 20:41:33', 156, 0, '', '2019-08-06 20:41:33');
INSERT INTO `access_log` VALUES (63590, '65.51.15650987035504515', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.44.115.30', '2019-08-06 21:38:24', 1, 1002001015, '账号未登陆', '2019-08-06 21:38:24');
INSERT INTO `access_log` VALUES (63591, '65.3607.15650987035506241', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.44.115.30', '2019-08-06 21:38:24', 1, 1002001015, '账号未登陆', '2019-08-06 21:38:24');
INSERT INTO `access_log` VALUES (63592, '65.49.15650987035504433', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.44.115.30', '2019-08-06 21:38:24', 0, 1002001015, '账号未登陆', '2019-08-06 21:38:24');
INSERT INTO `access_log` VALUES (63593, '65.45.15650987115954439', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.44.115.30', '2019-08-06 21:38:32', 81, 0, '', '2019-08-06 21:38:32');
INSERT INTO `access_log` VALUES (63594, '65.54.15650987119274351', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.44.115.30', '2019-08-06 21:38:32', 12, 0, '', '2019-08-06 21:38:32');
INSERT INTO `access_log` VALUES (63595, '65.47.15650987119294421', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.44.115.30', '2019-08-06 21:38:32', 13, 2001001000, '服务端发生异常', '2019-08-06 21:38:32');
INSERT INTO `access_log` VALUES (63596, '65.46.15650987119314485', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.44.115.30', '2019-08-06 21:38:32', 11, 0, '', '2019-08-06 21:38:32');
INSERT INTO `access_log` VALUES (63597, '59.77.15651010738171797', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.40.195', '2019-08-06 22:17:54', 10, 0, '', '2019-08-06 22:17:54');
INSERT INTO `access_log` VALUES (63598, '59.73.15651010738541809', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.40.195', '2019-08-06 22:17:54', 13, 2001001000, '服务端发生异常', '2019-08-06 22:17:54');
INSERT INTO `access_log` VALUES (63599, '64.79.15651010783332117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.40.195', '2019-08-06 22:17:58', 13, 0, '', '2019-08-06 22:17:58');
INSERT INTO `access_log` VALUES (63600, '64.82.15651010785182131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.40.195', '2019-08-06 22:17:59', 4, 0, '', '2019-08-06 22:17:59');
INSERT INTO `access_log` VALUES (63601, '65.45.15651030001624497', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.70.129', '2019-08-06 22:50:00', 12, 1002001012, '访问令牌已过期', '2019-08-06 22:50:00');
INSERT INTO `access_log` VALUES (63602, '65.46.15651030001624543', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.70.129', '2019-08-06 22:50:00', 14, 1002001012, '访问令牌已过期', '2019-08-06 22:50:00');
INSERT INTO `access_log` VALUES (63603, '65.47.15651030001744479', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.70.129', '2019-08-06 22:50:00', 5, 1002001012, '访问令牌已过期', '2019-08-06 22:50:00');
INSERT INTO `access_log` VALUES (63604, '65.46.15651031210694545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '119.123.70.129', '2019-08-06 22:52:01', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-06 22:52:01');
INSERT INTO `access_log` VALUES (63605, '59.73.15651046279211857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.123.163', '2019-08-06 23:17:08', 10, 0, '', '2019-08-06 23:17:08');
INSERT INTO `access_log` VALUES (63606, '59.78.15651046279211865', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.123.163', '2019-08-06 23:17:08', 30, 2001001000, '服务端发生异常', '2019-08-06 23:17:08');
INSERT INTO `access_log` VALUES (63607, '59.77.15651046329081845', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.123.163', '2019-08-06 23:17:13', 3, 0, '', '2019-08-06 23:17:13');
INSERT INTO `access_log` VALUES (63608, '59.76.15651046329081849', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.123.123.163', '2019-08-06 23:17:13', 19, 2001001000, '服务端发生异常', '2019-08-06 23:17:13');
INSERT INTO `access_log` VALUES (63609, '59.71.15651046381961855', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.123.163', '2019-08-06 23:17:18', 2, 0, '', '2019-08-06 23:17:18');
INSERT INTO `access_log` VALUES (63610, '59.72.15651046381961855', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.123.163', '2019-08-06 23:17:18', 13, 2001001000, '服务端发生异常', '2019-08-06 23:17:18');
INSERT INTO `access_log` VALUES (63611, '64.79.15651046412802165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.123.163', '2019-08-06 23:17:21', 11, 0, '', '2019-08-06 23:17:21');
INSERT INTO `access_log` VALUES (63612, '64.82.15651046414332179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.123.163', '2019-08-06 23:17:21', 3, 0, '', '2019-08-06 23:17:21');
INSERT INTO `access_log` VALUES (63613, '64.76.15651046427932165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.123.163', '2019-08-06 23:17:23', 2, 0, '', '2019-08-06 23:17:23');
INSERT INTO `access_log` VALUES (63614, '64.83.15651046484502165', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.123.163', '2019-08-06 23:17:28', 2, 0, '', '2019-08-06 23:17:28');
INSERT INTO `access_log` VALUES (63615, '64.81.15651046581992173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.123.163', '2019-08-06 23:17:38', 2, 0, '', '2019-08-06 23:17:38');
INSERT INTO `access_log` VALUES (63616, '64.84.15651046657862167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.123.163', '2019-08-06 23:17:46', 3, 0, '', '2019-08-06 23:17:46');
INSERT INTO `access_log` VALUES (63617, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.123.163', '2019-08-06 23:17:46', 6, 0, '', '2019-08-06 23:17:46');
INSERT INTO `access_log` VALUES (63618, '64.80.15651046768142173', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '119.123.123.163', '2019-08-06 23:17:57', 8, 0, '', '2019-08-06 23:17:57');
INSERT INTO `access_log` VALUES (63619, '65.53.15651062552474527', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '37.9.113.171', '2019-08-06 23:44:15', 1, 1002001015, '账号未登陆', '2019-08-06 23:44:15');
INSERT INTO `access_log` VALUES (63620, '65.47.15651062570704523', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '178.154.200.13', '2019-08-06 23:44:17', 0, 1002001015, '账号未登陆', '2019-08-06 23:44:17');
INSERT INTO `access_log` VALUES (63621, '65.46.15651062579184589', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '37.9.113.171', '2019-08-06 23:44:18', 0, 1002001015, '账号未登陆', '2019-08-06 23:44:18');
INSERT INTO `access_log` VALUES (63622, '59.78.15651408570462349', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 09:20:57', 11, 0, '', '2019-08-07 09:20:57');
INSERT INTO `access_log` VALUES (63623, '59.77.15651408570472329', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 09:20:57', 26, 2001001000, '服务端发生异常', '2019-08-07 09:20:57');
INSERT INTO `access_log` VALUES (63624, '64.81.15651408677452657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 09:21:08', 11, 0, '', '2019-08-07 09:21:08');
INSERT INTO `access_log` VALUES (63625, '64.77.15651408678932645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 09:21:08', 3, 0, '', '2019-08-07 09:21:08');
INSERT INTO `access_log` VALUES (63626, '64.80.15651408709092657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 09:21:11', 2, 0, '', '2019-08-07 09:21:11');
INSERT INTO `access_log` VALUES (63627, '64.78.15651408710602657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 09:21:11', 2, 0, '', '2019-08-07 09:21:11');
INSERT INTO `access_log` VALUES (63628, '59.72.15651408721262339', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 09:21:12', 3, 0, '', '2019-08-07 09:21:12');
INSERT INTO `access_log` VALUES (63629, '59.71.15651408721262339', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 09:21:12', 21, 2001001000, '服务端发生异常', '2019-08-07 09:21:12');
INSERT INTO `access_log` VALUES (63630, '59.77.15651410897542333', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:24:50', 3, 0, '', '2019-08-07 09:24:50');
INSERT INTO `access_log` VALUES (63631, '59.78.15651410897572353', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:24:50', 16, 2001001000, '服务端发生异常', '2019-08-07 09:24:50');
INSERT INTO `access_log` VALUES (63632, '64.84.15651410963282653', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:24:56', 3, 0, '', '2019-08-07 09:24:56');
INSERT INTO `access_log` VALUES (63633, '64.81.15651410964972661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:24:56', 2, 0, '', '2019-08-07 09:24:57');
INSERT INTO `access_log` VALUES (63634, '64.77.15651411028392649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:25:03', 2, 0, '', '2019-08-07 09:25:03');
INSERT INTO `access_log` VALUES (63635, '64.78.15651411064492661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:25:06', 1, 0, '', '2019-08-07 09:25:06');
INSERT INTO `access_log` VALUES (63636, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:25:06', 6, 0, '', '2019-08-07 09:25:06');
INSERT INTO `access_log` VALUES (63637, '64.82.15651411093542669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:25:09', 2, 0, '', '2019-08-07 09:25:09');
INSERT INTO `access_log` VALUES (63638, '64.79.15651411095182655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:25:10', 1, 0, '', '2019-08-07 09:25:10');
INSERT INTO `access_log` VALUES (63639, '64.76.15651411113862655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:25:11', 2, 0, '', '2019-08-07 09:25:11');
INSERT INTO `access_log` VALUES (63640, '64.83.15651411118982655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:25:12', 2, 0, '', '2019-08-07 09:25:12');
INSERT INTO `access_log` VALUES (63641, '64.85.15651411133052691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:25:13', 1, 0, '', '2019-08-07 09:25:13');
INSERT INTO `access_log` VALUES (63642, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:25:13', 6, 0, '', '2019-08-07 09:25:13');
INSERT INTO `access_log` VALUES (63643, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:25:18', 5, 0, '', '2019-08-07 09:25:18');
INSERT INTO `access_log` VALUES (63644, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:25:20', 5, 0, '', '2019-08-07 09:25:20');
INSERT INTO `access_log` VALUES (63645, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:25:21', 6, 0, '', '2019-08-07 09:25:21');
INSERT INTO `access_log` VALUES (63646, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:25:22', 6, 0, '', '2019-08-07 09:25:22');
INSERT INTO `access_log` VALUES (63647, '64.81.15651411231642663', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:25:23', 9, 0, '', '2019-08-07 09:25:23');
INSERT INTO `access_log` VALUES (63648, '65.49.15651411810385005', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:26:21', 1, 1002001015, '账号未登陆', '2019-08-07 09:26:21');
INSERT INTO `access_log` VALUES (63649, '65.54.15651411810374919', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:26:21', 1, 1002001015, '账号未登陆', '2019-08-07 09:26:21');
INSERT INTO `access_log` VALUES (63650, '65.53.15651411810554993', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:26:21', 0, 1002001015, '账号未登陆', '2019-08-07 09:26:21');
INSERT INTO `access_log` VALUES (63651, '65.47.15651411836044991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:26:24', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 09:26:24');
INSERT INTO `access_log` VALUES (63652, '65.50.15651412112445025', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:26:51', 85, 0, '', '2019-08-07 09:26:51');
INSERT INTO `access_log` VALUES (63653, '65.3607.15651412116496815', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:26:52', 18, 0, '', '2019-08-07 09:26:52');
INSERT INTO `access_log` VALUES (63654, '65.51.15651412116555087', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:26:52', 13, 0, '', '2019-08-07 09:26:52');
INSERT INTO `access_log` VALUES (63655, '65.52.15651412116505049', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:26:52', 21, 2001001000, '服务端发生异常', '2019-08-07 09:26:52');
INSERT INTO `access_log` VALUES (63656, '65.45.15651412594065011', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:27:39', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 09:27:39');
INSERT INTO `access_log` VALUES (63657, '65.46.15651412724885057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.220.81.55', '2019-08-07 09:27:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 09:27:52');
INSERT INTO `access_log` VALUES (63658, '59.79.15651435661832385', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.159.26.88', '2019-08-07 10:06:06', 10, 0, '', '2019-08-07 10:06:06');
INSERT INTO `access_log` VALUES (63659, '59.74.15651435661882391', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '117.159.26.88', '2019-08-07 10:06:06', 15, 2001001000, '服务端发生异常', '2019-08-07 10:06:06');
INSERT INTO `access_log` VALUES (63660, '64.82.15651435777992703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:06:18', 13, 0, '', '2019-08-07 10:06:18');
INSERT INTO `access_log` VALUES (63661, '64.79.15651435779392689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:06:18', 4, 0, '', '2019-08-07 10:06:18');
INSERT INTO `access_log` VALUES (63662, '64.76.15651435794182689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:06:19', 2, 0, '', '2019-08-07 10:06:19');
INSERT INTO `access_log` VALUES (63663, '64.83.15651435798202689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:06:20', 2, 0, '', '2019-08-07 10:06:20');
INSERT INTO `access_log` VALUES (63664, '64.84.15651435806922689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:06:21', 2, 0, '', '2019-08-07 10:06:21');
INSERT INTO `access_log` VALUES (63665, '64.81.15651435813572697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:06:21', 1, 0, '', '2019-08-07 10:06:21');
INSERT INTO `access_log` VALUES (63666, '66.54.15651436003110065', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18217890692&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:06:40', 17, 1001003000, '验证码不存在', '2019-08-07 10:06:40');
INSERT INTO `access_log` VALUES (63667, '64.80.15651436052852697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:06:45', 3, 0, '', '2019-08-07 10:06:45');
INSERT INTO `access_log` VALUES (63668, '64.78.15651436054132697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:06:45', 2, 0, '', '2019-08-07 10:06:45');
INSERT INTO `access_log` VALUES (63669, '59.78.15651436064732387', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:06:46', 2, 0, '', '2019-08-07 10:06:46');
INSERT INTO `access_log` VALUES (63670, '59.76.15651436064822371', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:06:46', 9, 2001001000, '服务端发生异常', '2019-08-07 10:06:46');
INSERT INTO `access_log` VALUES (63671, '64.79.15651436250862691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:05', 3, 0, '', '2019-08-07 10:07:05');
INSERT INTO `access_log` VALUES (63672, '64.76.15651436253552691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:05', 2, 0, '', '2019-08-07 10:07:05');
INSERT INTO `access_log` VALUES (63673, '64.85.15651436264622727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:06', 2, 0, '', '2019-08-07 10:07:06');
INSERT INTO `access_log` VALUES (63674, '64.84.15651436268162691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:07', 2, 0, '', '2019-08-07 10:07:07');
INSERT INTO `access_log` VALUES (63675, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:09', 6, 0, '', '2019-08-07 10:07:09');
INSERT INTO `access_log` VALUES (63676, '64.81.15651436292162699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:09', 2, 0, '', '2019-08-07 10:07:09');
INSERT INTO `access_log` VALUES (63677, '64.77.15651436321312687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:12', 2, 0, '', '2019-08-07 10:07:12');
INSERT INTO `access_log` VALUES (63678, '64.80.15651436322792699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:12', 1, 0, '', '2019-08-07 10:07:12');
INSERT INTO `access_log` VALUES (63679, '59.80.15651436335702353', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:14', 2, 0, '', '2019-08-07 10:07:14');
INSERT INTO `access_log` VALUES (63680, '59.75.15651436335722389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:14', 18, 2001001000, '服务端发生异常', '2019-08-07 10:07:14');
INSERT INTO `access_log` VALUES (63681, '64.78.15651436359162699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:16', 2, 0, '', '2019-08-07 10:07:16');
INSERT INTO `access_log` VALUES (63682, '64.82.15651436360692707', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:16', 2, 0, '', '2019-08-07 10:07:16');
INSERT INTO `access_log` VALUES (63683, '59.74.15651436394542393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:19', 2, 0, '', '2019-08-07 10:07:19');
INSERT INTO `access_log` VALUES (63684, '59.73.15651436394552381', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:19', 20, 2001001000, '服务端发生异常', '2019-08-07 10:07:19');
INSERT INTO `access_log` VALUES (63685, '64.79.15651436402262693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:20', 2, 0, '', '2019-08-07 10:07:20');
INSERT INTO `access_log` VALUES (63686, '64.76.15651436403802693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:20', 2, 0, '', '2019-08-07 10:07:20');
INSERT INTO `access_log` VALUES (63687, '59.77.15651436410522369', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:21', 2, 0, '', '2019-08-07 10:07:21');
INSERT INTO `access_log` VALUES (63688, '59.78.15651436410542389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.159.26.88', '2019-08-07 10:07:21', 47, 2001001000, '服务端发生异常', '2019-08-07 10:07:21');
INSERT INTO `access_log` VALUES (63689, '64.83.15651440825882699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '120.204.17.73', '2019-08-07 10:14:43', 2, 0, '', '2019-08-07 10:14:43');
INSERT INTO `access_log` VALUES (63690, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '183.192.164.85', '2019-08-07 10:20:55', 5, 0, '', '2019-08-07 10:20:55');
INSERT INTO `access_log` VALUES (63691, '64.80.15651446097472715', 0, 2, 'product-application', '/product-api/admins/attr/add', 'name=颜色', 'POST', 'Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '124.227.192.81', '2019-08-07 10:23:30', 0, 1002001015, '账号未登陆', '2019-08-07 10:23:30');
INSERT INTO `access_log` VALUES (63692, '65.54.15651455547034979', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 10:39:15', 0, 1002001015, '账号未登陆', '2019-08-07 10:39:15');
INSERT INTO `access_log` VALUES (63693, '65.47.15651455547055051', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 10:39:15', 0, 1002001015, '账号未登陆', '2019-08-07 10:39:15');
INSERT INTO `access_log` VALUES (63694, '65.45.15651455547055069', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 10:39:15', 1, 1002001015, '账号未登陆', '2019-08-07 10:39:15');
INSERT INTO `access_log` VALUES (63695, '65.46.15651455625295115', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 10:39:23', 122, 0, '', '2019-08-07 10:39:23');
INSERT INTO `access_log` VALUES (63696, '65.50.15651455629225085', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 10:39:23', 12, 0, '', '2019-08-07 10:39:23');
INSERT INTO `access_log` VALUES (63697, '65.52.15651455629265109', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 10:39:23', 13, 2001001000, '服务端发生异常', '2019-08-07 10:39:23');
INSERT INTO `access_log` VALUES (63698, '65.3607.15651455629286875', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-07 10:39:23', 11, 0, '', '2019-08-07 10:39:23');
INSERT INTO `access_log` VALUES (63699, '65.47.15651456071585053', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.141.24', '2019-08-07 10:40:07', 3, 1002001012, '访问令牌已过期', '2019-08-07 10:40:07');
INSERT INTO `access_log` VALUES (63700, '65.54.15651456071974981', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.141.24', '2019-08-07 10:40:07', 3, 1002001012, '访问令牌已过期', '2019-08-07 10:40:07');
INSERT INTO `access_log` VALUES (63701, '65.45.15651456071985071', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.141.24', '2019-08-07 10:40:07', 3, 1002001012, '访问令牌已过期', '2019-08-07 10:40:07');
INSERT INTO `access_log` VALUES (63702, '62.84.15651456082651283', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.116.141.24', '2019-08-07 10:40:08', 9, 1002001012, '访问令牌已过期', '2019-08-07 10:40:08');
INSERT INTO `access_log` VALUES (63703, '65.50.15651481135625119', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.24.64.114', '2019-08-07 11:21:54', 1, 1002001015, '账号未登陆', '2019-08-07 11:21:54');
INSERT INTO `access_log` VALUES (63704, '65.52.15651481135625143', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.24.64.114', '2019-08-07 11:21:54', 1, 1002001015, '账号未登陆', '2019-08-07 11:21:54');
INSERT INTO `access_log` VALUES (63705, '65.49.15651481135625103', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.24.64.114', '2019-08-07 11:21:54', 0, 1002001015, '账号未登陆', '2019-08-07 11:21:54');
INSERT INTO `access_log` VALUES (63706, '65.45.15651481170845107', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.24.64.114', '2019-08-07 11:21:57', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 11:21:57');
INSERT INTO `access_log` VALUES (63707, '65.51.15651481205545183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.24.64.114', '2019-08-07 11:22:01', 67, 0, '', '2019-08-07 11:22:01');
INSERT INTO `access_log` VALUES (63708, '65.47.15651481209665089', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.24.64.114', '2019-08-07 11:22:01', 20, 0, '', '2019-08-07 11:22:01');
INSERT INTO `access_log` VALUES (63709, '65.53.15651481209705091', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.24.64.114', '2019-08-07 11:22:01', 21, 2001001000, '服务端发生异常', '2019-08-07 11:22:01');
INSERT INTO `access_log` VALUES (63710, '65.46.15651481209765151', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.24.64.114', '2019-08-07 11:22:01', 9, 0, '', '2019-08-07 11:22:01');
INSERT INTO `access_log` VALUES (63711, '59.72.15651562625192547', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:37:43', 9, 0, '', '2019-08-07 13:37:43');
INSERT INTO `access_log` VALUES (63712, '59.71.15651562625212547', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:37:43', 13, 2001001000, '服务端发生异常', '2019-08-07 13:37:43');
INSERT INTO `access_log` VALUES (63713, '64.83.15651562686472863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:37:49', 11, 0, '', '2019-08-07 13:37:49');
INSERT INTO `access_log` VALUES (63714, '64.81.15651562687402871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:37:49', 3, 0, '', '2019-08-07 13:37:49');
INSERT INTO `access_log` VALUES (63715, '64.84.15651562699202865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:37:50', 2, 0, '', '2019-08-07 13:37:50');
INSERT INTO `access_log` VALUES (63716, '64.80.15651562705662871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:37:51', 2, 0, '', '2019-08-07 13:37:51');
INSERT INTO `access_log` VALUES (63717, '64.79.15651562709592865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:37:51', 2, 0, '', '2019-08-07 13:37:51');
INSERT INTO `access_log` VALUES (63718, '64.76.15651562733582867', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:37:53', 1, 0, '', '2019-08-07 13:37:53');
INSERT INTO `access_log` VALUES (63719, '64.78.15651562735532871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:37:54', 2, 0, '', '2019-08-07 13:37:54');
INSERT INTO `access_log` VALUES (63720, '66.55.15651563940010197', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18622636558&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:39:54', 15, 1001003000, '验证码不存在', '2019-08-07 13:39:54');
INSERT INTO `access_log` VALUES (63721, '66.54.15651563955800235', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18622636558', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:39:56', 76, 0, '', '2019-08-07 13:39:56');
INSERT INTO `access_log` VALUES (63722, '66.57.15651564194130225', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18622636558&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:40:19', 414, 0, '', '2019-08-07 13:40:20');
INSERT INTO `access_log` VALUES (63723, '66.50.15651564280190223', 193, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:40:28', 8, 0, '', '2019-08-07 13:40:28');
INSERT INTO `access_log` VALUES (63724, '65.53.15651564363765203', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:40:36', 0, 1002001015, '账号未登陆', '2019-08-07 13:40:36');
INSERT INTO `access_log` VALUES (63725, '65.47.15651564363765199', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:40:36', 0, 1002001015, '账号未登陆', '2019-08-07 13:40:36');
INSERT INTO `access_log` VALUES (63726, '65.46.15651564363915263', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:40:36', 1, 1002001015, '账号未登陆', '2019-08-07 13:40:36');
INSERT INTO `access_log` VALUES (63727, '65.52.15651564491365257', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:40:49', 67, 0, '', '2019-08-07 13:40:49');
INSERT INTO `access_log` VALUES (63728, '65.50.15651564494305233', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:40:49', 13, 0, '', '2019-08-07 13:40:49');
INSERT INTO `access_log` VALUES (63729, '65.49.15651564494315217', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:40:49', 14, 2001001000, '服务端发生异常', '2019-08-07 13:40:49');
INSERT INTO `access_log` VALUES (63730, '65.54.15651564494375131', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:40:49', 10, 0, '', '2019-08-07 13:40:49');
INSERT INTO `access_log` VALUES (63731, '65.51.15651564597115297', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:41:00', 20, 0, '', '2019-08-07 13:41:00');
INSERT INTO `access_log` VALUES (63732, '65.53.15651564597135205', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:41:00', 18, 2001001000, '服务端发生异常', '2019-08-07 13:41:00');
INSERT INTO `access_log` VALUES (63733, '65.47.15651564597185201', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:41:00', 17, 0, '', '2019-08-07 13:41:00');
INSERT INTO `access_log` VALUES (63734, '65.46.15651564633715265', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:41:03', 10, 0, '', '2019-08-07 13:41:03');
INSERT INTO `access_log` VALUES (63735, '65.3607.15651564633767027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:41:03', 9, 2001001000, '服务端发生异常', '2019-08-07 13:41:03');
INSERT INTO `access_log` VALUES (63736, '65.52.15651564633805259', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:41:03', 9, 0, '', '2019-08-07 13:41:03');
INSERT INTO `access_log` VALUES (63737, '65.50.15651564785015235', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:41:19', 10, 0, '', '2019-08-07 13:41:19');
INSERT INTO `access_log` VALUES (63738, '65.49.15651564785045219', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:41:19', 10, 2001001000, '服务端发生异常', '2019-08-07 13:41:19');
INSERT INTO `access_log` VALUES (63739, '65.45.15651564785085223', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.141.222.124', '2019-08-07 13:41:19', 8, 0, '', '2019-08-07 13:41:19');
INSERT INTO `access_log` VALUES (63740, '59.78.15651566309582563', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '117.74.130.138', '2019-08-07 13:43:51', 4, 0, '', '2019-08-07 13:43:51');
INSERT INTO `access_log` VALUES (63741, '59.77.15651566309582543', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '117.74.130.138', '2019-08-07 13:43:51', 18, 2001001000, '服务端发生异常', '2019-08-07 13:43:51');
INSERT INTO `access_log` VALUES (63742, '64.84.15651566357542871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '117.74.130.138', '2019-08-07 13:43:56', 2, 0, '', '2019-08-07 13:43:56');
INSERT INTO `access_log` VALUES (63743, '64.77.15651566358382863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '117.74.130.138', '2019-08-07 13:43:56', 2, 0, '', '2019-08-07 13:43:56');
INSERT INTO `access_log` VALUES (63744, '64.80.15651566372552877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '117.74.130.138', '2019-08-07 13:43:57', 2, 0, '', '2019-08-07 13:43:57');
INSERT INTO `access_log` VALUES (63745, '59.71.15651566393252553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '117.74.130.138', '2019-08-07 13:43:59', 2, 0, '', '2019-08-07 13:43:59');
INSERT INTO `access_log` VALUES (63746, '59.76.15651566393252547', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '117.74.130.138', '2019-08-07 13:43:59', 12, 2001001000, '服务端发生异常', '2019-08-07 13:43:59');
INSERT INTO `access_log` VALUES (63747, '65.50.15651572125105245', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:53:33', 1, 1002001015, '账号未登陆', '2019-08-07 13:53:33');
INSERT INTO `access_log` VALUES (63748, '65.53.15651572125175217', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:53:33', 0, 1002001015, '账号未登陆', '2019-08-07 13:53:33');
INSERT INTO `access_log` VALUES (63749, '65.51.15651572125265309', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:53:33', 0, 1002001015, '账号未登陆', '2019-08-07 13:53:33');
INSERT INTO `access_log` VALUES (63750, '65.47.15651572152465213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:53:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 13:53:35');
INSERT INTO `access_log` VALUES (63751, '65.52.15651572195905271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:53:40', 88, 0, '', '2019-08-07 13:53:40');
INSERT INTO `access_log` VALUES (63752, '65.3607.15651572199867039', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:53:40', 10, 0, '', '2019-08-07 13:53:40');
INSERT INTO `access_log` VALUES (63753, '65.54.15651572199965145', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:53:40', 9, 2001001000, '服务端发生异常', '2019-08-07 13:53:40');
INSERT INTO `access_log` VALUES (63754, '65.45.15651572200035235', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:53:40', 10, 0, '', '2019-08-07 13:53:40');
INSERT INTO `access_log` VALUES (63755, '65.53.15651572526315219', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:54:13', 8, 0, '', '2019-08-07 13:54:13');
INSERT INTO `access_log` VALUES (63756, '65.50.15651572526385247', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:54:13', 9, 2001001000, '服务端发生异常', '2019-08-07 13:54:13');
INSERT INTO `access_log` VALUES (63757, '65.47.15651572526455215', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:54:13', 8, 0, '', '2019-08-07 13:54:13');
INSERT INTO `access_log` VALUES (63758, '65.46.15651572565245279', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:54:17', 16, 0, '', '2019-08-07 13:54:17');
INSERT INTO `access_log` VALUES (63759, '65.52.15651572565265273', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:54:17', 16, 2001001000, '服务端发生异常', '2019-08-07 13:54:17');
INSERT INTO `access_log` VALUES (63760, '65.45.15651572565385237', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:54:17', 8, 0, '', '2019-08-07 13:54:17');
INSERT INTO `access_log` VALUES (63761, '65.54.15651572596265147', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:54:20', 8, 0, '', '2019-08-07 13:54:20');
INSERT INTO `access_log` VALUES (63762, '65.3607.15651572596327041', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:54:20', 9, 2001001000, '服务端发生异常', '2019-08-07 13:54:20');
INSERT INTO `access_log` VALUES (63763, '65.49.15651572596405233', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:54:20', 9, 0, '', '2019-08-07 13:54:20');
INSERT INTO `access_log` VALUES (63764, '65.50.15651572801205249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.67 Safari/537.36', '180.168.158.242', '2019-08-07 13:54:40', 4, 1002002001, '密码不正确', '2019-08-07 13:54:40');
INSERT INTO `access_log` VALUES (63765, '65.51.15651606813105359', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.247.118', '2019-08-07 14:51:21', 0, 1002001015, '账号未登陆', '2019-08-07 14:51:21');
INSERT INTO `access_log` VALUES (63766, '65.49.15651606813105279', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.247.118', '2019-08-07 14:51:21', 0, 1002001015, '账号未登陆', '2019-08-07 14:51:21');
INSERT INTO `access_log` VALUES (63767, '65.53.15651606813125267', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.247.118', '2019-08-07 14:51:21', 0, 1002001015, '账号未登陆', '2019-08-07 14:51:21');
INSERT INTO `access_log` VALUES (63768, '65.47.15651606898025263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.247.118', '2019-08-07 14:51:30', 66, 0, '', '2019-08-07 14:51:30');
INSERT INTO `access_log` VALUES (63769, '65.52.15651606902205321', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.247.118', '2019-08-07 14:51:30', 137, 0, '', '2019-08-07 14:51:30');
INSERT INTO `access_log` VALUES (63770, '65.46.15651606902415327', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.247.118', '2019-08-07 14:51:30', 120, 0, '', '2019-08-07 14:51:30');
INSERT INTO `access_log` VALUES (63771, '65.45.15651606902445285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.247.118', '2019-08-07 14:51:30', 116, 2001001000, '服务端发生异常', '2019-08-07 14:51:30');
INSERT INTO `access_log` VALUES (63772, '65.52.15651627723955349', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-07 15:26:12', 1, 1002001015, '账号未登陆', '2019-08-07 15:26:12');
INSERT INTO `access_log` VALUES (63773, '65.3607.15651627723957117', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-07 15:26:12', 0, 1002001015, '账号未登陆', '2019-08-07 15:26:12');
INSERT INTO `access_log` VALUES (63774, '65.54.15651627723955223', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-07 15:26:12', 1, 1002001015, '账号未登陆', '2019-08-07 15:26:12');
INSERT INTO `access_log` VALUES (63775, '65.51.15651627782405389', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-07 15:26:18', 69, 0, '', '2019-08-07 15:26:18');
INSERT INTO `access_log` VALUES (63776, '65.49.15651627788965309', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-07 15:26:19', 11, 0, '', '2019-08-07 15:26:19');
INSERT INTO `access_log` VALUES (63777, '65.53.15651627788995297', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-07 15:26:19', 10, 2001001000, '服务端发生异常', '2019-08-07 15:26:19');
INSERT INTO `access_log` VALUES (63778, '65.50.15651627789065325', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-07 15:26:19', 9, 0, '', '2019-08-07 15:26:19');
INSERT INTO `access_log` VALUES (63779, '65.53.15651628881585299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-07 15:28:08', 88, 0, '', '2019-08-07 15:28:08');
INSERT INTO `access_log` VALUES (63780, '65.49.15651628887225311', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-07 15:28:09', 9, 0, '', '2019-08-07 15:28:09');
INSERT INTO `access_log` VALUES (63781, '65.50.15651628887255327', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-07 15:28:09', 10, 2001001000, '服务端发生异常', '2019-08-07 15:28:09');
INSERT INTO `access_log` VALUES (63782, '65.47.15651628887305295', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-07 15:28:09', 11, 0, '', '2019-08-07 15:28:09');
INSERT INTO `access_log` VALUES (63783, '59.77.15651643961812647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.119.160.38', '2019-08-07 15:53:16', 17, 0, '', '2019-08-07 15:53:16');
INSERT INTO `access_log` VALUES (63784, '59.71.15651643961842657', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.119.160.38', '2019-08-07 15:53:16', 23, 2001001000, '服务端发生异常', '2019-08-07 15:53:16');
INSERT INTO `access_log` VALUES (63785, '64.80.15651644008182981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.119.160.38', '2019-08-07 15:53:21', 13, 0, '', '2019-08-07 15:53:21');
INSERT INTO `access_log` VALUES (63786, '64.77.15651644009792967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.119.160.38', '2019-08-07 15:53:21', 3, 0, '', '2019-08-07 15:53:21');
INSERT INTO `access_log` VALUES (63787, '64.84.15651644047932975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.119.160.38', '2019-08-07 15:53:25', 2, 0, '', '2019-08-07 15:53:25');
INSERT INTO `access_log` VALUES (63788, '64.78.15651644049132981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.119.160.38', '2019-08-07 15:53:25', 2, 0, '', '2019-08-07 15:53:25');
INSERT INTO `access_log` VALUES (63789, '59.72.15651644128722657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.119.160.38', '2019-08-07 15:53:33', 3, 0, '', '2019-08-07 15:53:33');
INSERT INTO `access_log` VALUES (63790, '59.80.15651644128722633', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.119.160.38', '2019-08-07 15:53:33', 16, 2001001000, '服务端发生异常', '2019-08-07 15:53:33');
INSERT INTO `access_log` VALUES (63791, '64.76.15651644206792977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:53:41', 2, 0, '', '2019-08-07 15:53:41');
INSERT INTO `access_log` VALUES (63792, '64.83.15651644208062977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:53:41', 9, 0, '', '2019-08-07 15:53:41');
INSERT INTO `access_log` VALUES (63793, '64.85.15651644221953011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:53:42', 2, 0, '', '2019-08-07 15:53:42');
INSERT INTO `access_log` VALUES (63794, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:53:42', 8, 0, '', '2019-08-07 15:53:42');
INSERT INTO `access_log` VALUES (63795, '64.82.15651644236902987', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:53:44', 9, 0, '', '2019-08-07 15:53:44');
INSERT INTO `access_log` VALUES (63796, '64.77.15651644487522969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:54:09', 2, 0, '', '2019-08-07 15:54:09');
INSERT INTO `access_log` VALUES (63797, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:54:09', 6, 0, '', '2019-08-07 15:54:09');
INSERT INTO `access_log` VALUES (63798, '64.84.15651644494592977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:54:09', 2, 0, '', '2019-08-07 15:54:09');
INSERT INTO `access_log` VALUES (63799, '64.78.15651644495702983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:54:10', 2, 0, '', '2019-08-07 15:54:10');
INSERT INTO `access_log` VALUES (63800, '59.73.15651644501572661', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:54:10', 8, 0, '', '2019-08-07 15:54:10');
INSERT INTO `access_log` VALUES (63801, '59.78.15651644501572669', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:54:10', 22, 2001001000, '服务端发生异常', '2019-08-07 15:54:10');
INSERT INTO `access_log` VALUES (63802, '64.79.15651644514192979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:54:11', 2, 0, '', '2019-08-07 15:54:11');
INSERT INTO `access_log` VALUES (63803, '64.76.15651644515402979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:54:12', 1, 0, '', '2019-08-07 15:54:12');
INSERT INTO `access_log` VALUES (63804, '59.77.15651644521512649', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:54:12', 3, 0, '', '2019-08-07 15:54:12');
INSERT INTO `access_log` VALUES (63805, '59.71.15651644521522659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '1.119.160.38', '2019-08-07 15:54:12', 12, 2001001000, '服务端发生异常', '2019-08-07 15:54:12');
INSERT INTO `access_log` VALUES (63806, '65.53.15651662764225345', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.57.156.180', '2019-08-07 16:24:36', 1, 1002001015, '账号未登陆', '2019-08-07 16:24:36');
INSERT INTO `access_log` VALUES (63807, '65.50.15651662764245373', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.57.156.180', '2019-08-07 16:24:36', 0, 1002001015, '账号未登陆', '2019-08-07 16:24:36');
INSERT INTO `access_log` VALUES (63808, '65.47.15651662764255341', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.57.156.180', '2019-08-07 16:24:36', 0, 1002001015, '账号未登陆', '2019-08-07 16:24:36');
INSERT INTO `access_log` VALUES (63809, '65.46.15651662816555405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.57.156.180', '2019-08-07 16:24:42', 63, 0, '', '2019-08-07 16:24:42');
INSERT INTO `access_log` VALUES (63810, '65.45.15651662819825363', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.57.156.180', '2019-08-07 16:24:42', 13, 0, '', '2019-08-07 16:24:42');
INSERT INTO `access_log` VALUES (63811, '65.52.15651662819875399', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.57.156.180', '2019-08-07 16:24:42', 12, 2001001000, '服务端发生异常', '2019-08-07 16:24:42');
INSERT INTO `access_log` VALUES (63812, '65.3607.15651662819917167', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.57.156.180', '2019-08-07 16:24:42', 10, 0, '', '2019-08-07 16:24:42');
INSERT INTO `access_log` VALUES (63813, '65.51.15651662903275439', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.57.156.180', '2019-08-07 16:24:50', 1030, 0, '', '2019-08-07 16:24:51');
INSERT INTO `access_log` VALUES (63814, '65.47.15651662903285343', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.57.156.180', '2019-08-07 16:24:50', 1030, 0, '', '2019-08-07 16:24:51');
INSERT INTO `access_log` VALUES (63815, '65.54.15651662903275273', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.57.156.180', '2019-08-07 16:24:50', 1031, 2001001000, '服务端发生异常', '2019-08-07 16:24:51');
INSERT INTO `access_log` VALUES (63816, '59.75.15651677934982715', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.140.250', '2019-08-07 16:49:53', 10, 0, '', '2019-08-07 16:49:54');
INSERT INTO `access_log` VALUES (63817, '59.79.15651677935012713', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.140.250', '2019-08-07 16:49:54', 27, 2001001000, '服务端发生异常', '2019-08-07 16:49:54');
INSERT INTO `access_log` VALUES (63818, '64.81.15651677985383031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.140.250', '2019-08-07 16:49:59', 11, 0, '', '2019-08-07 16:49:59');
INSERT INTO `access_log` VALUES (63819, '64.80.15651677989843029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.140.250', '2019-08-07 16:49:59', 3, 0, '', '2019-08-07 16:49:59');
INSERT INTO `access_log` VALUES (63820, '64.77.15651678006333015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.140.250', '2019-08-07 16:50:01', 2, 0, '', '2019-08-07 16:50:01');
INSERT INTO `access_log` VALUES (63821, '64.84.15651678009983023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.140.250', '2019-08-07 16:50:01', 2, 0, '', '2019-08-07 16:50:01');
INSERT INTO `access_log` VALUES (63822, '64.78.15651678013853029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.140.250', '2019-08-07 16:50:01', 2, 0, '', '2019-08-07 16:50:01');
INSERT INTO `access_log` VALUES (63823, '59.74.15651678023492719', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.140.250', '2019-08-07 16:50:02', 3, 0, '', '2019-08-07 16:50:02');
INSERT INTO `access_log` VALUES (63824, '59.78.15651678023492715', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.140.250', '2019-08-07 16:50:02', 17, 2001001000, '服务端发生异常', '2019-08-07 16:50:02');
INSERT INTO `access_log` VALUES (63825, '59.73.15651681040222711', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.249', '2019-08-07 16:55:04', 2, 0, '', '2019-08-07 16:55:04');
INSERT INTO `access_log` VALUES (63826, '59.77.15651681040262699', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.198.75', '2019-08-07 16:55:04', 19, 2001001000, '服务端发生异常', '2019-08-07 16:55:04');
INSERT INTO `access_log` VALUES (63827, '64.76.15651681065533029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.249', '2019-08-07 16:55:07', 2, 0, '', '2019-08-07 16:55:07');
INSERT INTO `access_log` VALUES (63828, '64.83.15651681066783029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.249', '2019-08-07 16:55:07', 2, 0, '', '2019-08-07 16:55:07');
INSERT INTO `access_log` VALUES (63829, '64.85.15651681078433063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.249', '2019-08-07 16:55:08', 2, 0, '', '2019-08-07 16:55:08');
INSERT INTO `access_log` VALUES (63830, '64.82.15651681082753039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.249', '2019-08-07 16:55:08', 2, 0, '', '2019-08-07 16:55:08');
INSERT INTO `access_log` VALUES (63831, '64.81.15651681087773037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.249', '2019-08-07 16:55:09', 2, 0, '', '2019-08-07 16:55:09');
INSERT INTO `access_log` VALUES (63832, '59.76.15651681102672703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.249', '2019-08-07 16:55:10', 3, 0, '', '2019-08-07 16:55:10');
INSERT INTO `access_log` VALUES (63833, '59.72.15651681102672709', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.198.75', '2019-08-07 16:55:10', 30, 2001001000, '服务端发生异常', '2019-08-07 16:55:10');
INSERT INTO `access_log` VALUES (63834, '64.80.15651681172183035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.198.75', '2019-08-07 16:55:17', 2, 0, '', '2019-08-07 16:55:17');
INSERT INTO `access_log` VALUES (63835, '64.77.15651681173153021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.198.75', '2019-08-07 16:55:17', 2, 0, '', '2019-08-07 16:55:17');
INSERT INTO `access_log` VALUES (63836, '59.75.15651681181942721', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.198.75', '2019-08-07 16:55:18', 2, 0, '', '2019-08-07 16:55:18');
INSERT INTO `access_log` VALUES (63837, '59.80.15651681181912685', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.249', '2019-08-07 16:55:18', 24, 2001001000, '服务端发生异常', '2019-08-07 16:55:18');
INSERT INTO `access_log` VALUES (63838, '65.49.15651681342765383', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.196.117', '2019-08-07 16:55:34', 1, 1002001015, '账号未登陆', '2019-08-07 16:55:34');
INSERT INTO `access_log` VALUES (63839, '65.46.15651681342785431', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.198.75', '2019-08-07 16:55:34', 0, 1002001015, '账号未登陆', '2019-08-07 16:55:34');
INSERT INTO `access_log` VALUES (63840, '65.47.15651681342815369', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.196.117', '2019-08-07 16:55:34', 0, 1002001015, '账号未登陆', '2019-08-07 16:55:34');
INSERT INTO `access_log` VALUES (63841, '65.51.15651681400865465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.249', '2019-08-07 16:55:40', 58, 0, '', '2019-08-07 16:55:40');
INSERT INTO `access_log` VALUES (63842, '59.76.15651681999982705', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:56:40', 4, 0, '', '2019-08-07 16:56:40');
INSERT INTO `access_log` VALUES (63843, '59.72.15651681999982711', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:56:40', 16, 2001001000, '服务端发生异常', '2019-08-07 16:56:40');
INSERT INTO `access_log` VALUES (63844, '64.81.15651682204363039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:00', 3, 0, '', '2019-08-07 16:57:00');
INSERT INTO `access_log` VALUES (63845, '64.80.15651682205853037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:01', 2, 0, '', '2019-08-07 16:57:01');
INSERT INTO `access_log` VALUES (63846, '64.77.15651682242933023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:04', 2, 0, '', '2019-08-07 16:57:04');
INSERT INTO `access_log` VALUES (63847, '64.84.15651682244003031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:04', 2, 0, '', '2019-08-07 16:57:04');
INSERT INTO `access_log` VALUES (63848, '64.79.15651682272233033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:07', 2, 0, '', '2019-08-07 16:57:07');
INSERT INTO `access_log` VALUES (63849, '64.76.15651682273113033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:07', 2, 0, '', '2019-08-07 16:57:07');
INSERT INTO `access_log` VALUES (63850, '59.79.15651682308202721', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:11', 3, 0, '', '2019-08-07 16:57:11');
INSERT INTO `access_log` VALUES (63851, '59.74.15651682308232727', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:11', 13, 2001001000, '服务端发生异常', '2019-08-07 16:57:11');
INSERT INTO `access_log` VALUES (63852, '65.47.15651682420795371', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:22', 0, 1002001015, '账号未登陆', '2019-08-07 16:57:22');
INSERT INTO `access_log` VALUES (63853, '65.46.15651682420845433', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:22', 1, 1002001015, '账号未登陆', '2019-08-07 16:57:22');
INSERT INTO `access_log` VALUES (63854, '65.3607.15651682420877195', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:22', 0, 1002001015, '账号未登陆', '2019-08-07 16:57:22');
INSERT INTO `access_log` VALUES (63855, '65.54.15651682539115301', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 16:57:34');
INSERT INTO `access_log` VALUES (63856, '65.50.15651682770855405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:57', 87, 0, '', '2019-08-07 16:57:57');
INSERT INTO `access_log` VALUES (63857, '65.49.15651682777665387', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:58', 11, 0, '', '2019-08-07 16:57:58');
INSERT INTO `access_log` VALUES (63858, '65.53.15651682777665377', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:58', 11, 0, '', '2019-08-07 16:57:58');
INSERT INTO `access_log` VALUES (63859, '65.47.15651682777675373', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.13; rv:68.0) Gecko/20100101 Firefox/68.0', '36.110.61.105', '2019-08-07 16:57:58', 12, 2001001000, '服务端发生异常', '2019-08-07 16:57:58');
INSERT INTO `access_log` VALUES (63860, '65.54.15651683319335303', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.196.117', '2019-08-07 16:58:52', 82, 0, '', '2019-08-07 16:58:52');
INSERT INTO `access_log` VALUES (63861, '65.45.15651683324105393', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.249', '2019-08-07 16:58:52', 9, 0, '', '2019-08-07 16:58:52');
INSERT INTO `access_log` VALUES (63862, '65.52.15651683324165431', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.196.117', '2019-08-07 16:58:52', 9, 2001001000, '服务端发生异常', '2019-08-07 16:58:52');
INSERT INTO `access_log` VALUES (63863, '65.50.15651683324205407', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.196.117', '2019-08-07 16:58:52', 9, 0, '', '2019-08-07 16:58:52');
INSERT INTO `access_log` VALUES (63864, '65.53.15651683521075379', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.249', '2019-08-07 16:59:12', 8, 0, '', '2019-08-07 16:59:12');
INSERT INTO `access_log` VALUES (63865, '65.46.15651683521105437', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.196.117', '2019-08-07 16:59:12', 8, 2001001000, '服务端发生异常', '2019-08-07 16:59:12');
INSERT INTO `access_log` VALUES (63866, '65.3607.15651683521147199', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.196.117', '2019-08-07 16:59:12', 8, 0, '', '2019-08-07 16:59:12');
INSERT INTO `access_log` VALUES (63867, '65.51.15651683551005471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.196.117', '2019-08-07 16:59:15', 16, 0, '', '2019-08-07 16:59:15');
INSERT INTO `access_log` VALUES (63868, '65.54.15651683551095305', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '119.139.196.117', '2019-08-07 16:59:15', 9, 2001001000, '服务端发生异常', '2019-08-07 16:59:15');
INSERT INTO `access_log` VALUES (63869, '65.52.15651683551245433', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.141.65.249', '2019-08-07 16:59:15', 8, 0, '', '2019-08-07 16:59:15');
INSERT INTO `access_log` VALUES (63870, '59.79.15651685062232725', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.14.134.204', '2019-08-07 17:01:46', 3, 0, '', '2019-08-07 17:01:46');
INSERT INTO `access_log` VALUES (63871, '59.74.15651685062262731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.14.134.204', '2019-08-07 17:01:46', 12, 2001001000, '服务端发生异常', '2019-08-07 17:01:46');
INSERT INTO `access_log` VALUES (63872, '59.75.15651685887402729', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:03:09', 3, 0, '', '2019-08-07 17:03:09');
INSERT INTO `access_log` VALUES (63873, '59.80.15651685887402693', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:03:09', 12, 2001001000, '服务端发生异常', '2019-08-07 17:03:09');
INSERT INTO `access_log` VALUES (63874, '64.80.15651685944353043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:03:14', 2, 0, '', '2019-08-07 17:03:14');
INSERT INTO `access_log` VALUES (63875, '64.77.15651685944973029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:03:14', 2, 0, '', '2019-08-07 17:03:15');
INSERT INTO `access_log` VALUES (63876, '64.84.15651685966593037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:03:17', 1, 0, '', '2019-08-07 17:03:17');
INSERT INTO `access_log` VALUES (63877, '64.78.15651685972843043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:03:17', 2, 0, '', '2019-08-07 17:03:17');
INSERT INTO `access_log` VALUES (63878, '64.76.15651686026163039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:03:23', 2, 0, '', '2019-08-07 17:03:23');
INSERT INTO `access_log` VALUES (63879, '64.83.15651686027083039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:03:23', 1, 0, '', '2019-08-07 17:03:23');
INSERT INTO `access_log` VALUES (63880, '64.85.15651686111833073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:03:31', 1, 0, '', '2019-08-07 17:03:31');
INSERT INTO `access_log` VALUES (63881, '64.82.15651686112513049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:03:31', 2, 0, '', '2019-08-07 17:03:31');
INSERT INTO `access_log` VALUES (63882, '65.51.15651686278495475', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:03:48', 1, 1002001015, '账号未登陆', '2019-08-07 17:03:48');
INSERT INTO `access_log` VALUES (63883, '65.52.15651686278585437', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:03:48', 0, 1002001015, '账号未登陆', '2019-08-07 17:03:48');
INSERT INTO `access_log` VALUES (63884, '65.45.15651686278585399', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:03:48', 0, 1002001015, '账号未登陆', '2019-08-07 17:03:48');
INSERT INTO `access_log` VALUES (63885, '65.50.15651686305515413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:03:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 17:03:51');
INSERT INTO `access_log` VALUES (63886, '65.47.15651686461835381', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaouanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:04:06', 86, 0, '', '2019-08-07 17:04:06');
INSERT INTO `access_log` VALUES (63887, '65.3607.15651686465647205', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:04:07', 10, 0, '', '2019-08-07 17:04:07');
INSERT INTO `access_log` VALUES (63888, '65.53.15651686465665385', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:04:07', 10, 2001001000, '服务端发生异常', '2019-08-07 17:04:07');
INSERT INTO `access_log` VALUES (63889, '65.46.15651686465695443', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.173.83.165', '2019-08-07 17:04:07', 8, 0, '', '2019-08-07 17:04:07');
INSERT INTO `access_log` VALUES (63890, '65.46.15651695077585455', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.180.156.109', '2019-08-07 17:18:28', 1, 1002001015, '账号未登陆', '2019-08-07 17:18:28');
INSERT INTO `access_log` VALUES (63891, '65.53.15651695077665397', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.180.156.109', '2019-08-07 17:18:28', 0, 1002001015, '账号未登陆', '2019-08-07 17:18:28');
INSERT INTO `access_log` VALUES (63892, '65.54.15651695077675323', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.180.156.109', '2019-08-07 17:18:28', 0, 1002001015, '账号未登陆', '2019-08-07 17:18:28');
INSERT INTO `access_log` VALUES (63893, '65.52.15651695375315451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.180.156.109', '2019-08-07 17:18:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 17:18:58');
INSERT INTO `access_log` VALUES (63894, '65.50.15651695465065427', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.180.156.109', '2019-08-07 17:19:07', 78, 0, '', '2019-08-07 17:19:07');
INSERT INTO `access_log` VALUES (63895, '65.47.15651695470745395', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.180.156.109', '2019-08-07 17:19:07', 10, 0, '', '2019-08-07 17:19:07');
INSERT INTO `access_log` VALUES (63896, '65.49.15651695470745409', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.180.156.109', '2019-08-07 17:19:07', 12, 2001001000, '服务端发生异常', '2019-08-07 17:19:07');
INSERT INTO `access_log` VALUES (63897, '65.3607.15651695470837219', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.180.156.109', '2019-08-07 17:19:07', 8, 0, '', '2019-08-07 17:19:07');
INSERT INTO `access_log` VALUES (63898, '65.50.15651697777165431', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-07 17:22:58', 0, 1002001015, '账号未登陆', '2019-08-07 17:22:58');
INSERT INTO `access_log` VALUES (63899, '65.47.15651697777165399', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-07 17:22:58', 0, 1002001015, '账号未登陆', '2019-08-07 17:22:58');
INSERT INTO `access_log` VALUES (63900, '65.3607.15651697777207223', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-07 17:22:58', 0, 1002001015, '账号未登陆', '2019-08-07 17:22:58');
INSERT INTO `access_log` VALUES (63901, '65.49.15651697815905413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-07 17:23:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 17:23:02');
INSERT INTO `access_log` VALUES (63902, '65.54.15651697857895329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-07 17:23:06', 65, 0, '', '2019-08-07 17:23:06');
INSERT INTO `access_log` VALUES (63903, '65.53.15651697860725403', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-07 17:23:06', 8, 0, '', '2019-08-07 17:23:06');
INSERT INTO `access_log` VALUES (63904, '65.46.15651697860795461', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-07 17:23:06', 8, 2001001000, '服务端发生异常', '2019-08-07 17:23:06');
INSERT INTO `access_log` VALUES (63905, '65.51.15651697860805495', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-07 17:23:06', 8, 0, '', '2019-08-07 17:23:06');
INSERT INTO `access_log` VALUES (63906, '65.52.15651697899895457', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-07 17:23:10', 18, 0, '', '2019-08-07 17:23:10');
INSERT INTO `access_log` VALUES (63907, '65.47.15651697899895401', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-07 17:23:10', 18, 0, '', '2019-08-07 17:23:10');
INSERT INTO `access_log` VALUES (63908, '65.3607.15651697899907225', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-07 17:23:10', 18, 2001001000, '服务端发生异常', '2019-08-07 17:23:10');
INSERT INTO `access_log` VALUES (63909, '59.74.15651707075102761', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.82.188.134', '2019-08-07 17:38:28', 10, 0, '', '2019-08-07 17:38:28');
INSERT INTO `access_log` VALUES (63910, '59.78.15651707075132757', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.82.190.197', '2019-08-07 17:38:28', 21, 2001001000, '服务端发生异常', '2019-08-07 17:38:28');
INSERT INTO `access_log` VALUES (63911, '65.45.15651710703855437', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.82.189.25', '2019-08-07 17:44:30', 0, 1002001015, '账号未登陆', '2019-08-07 17:44:30');
INSERT INTO `access_log` VALUES (63912, '65.53.15651710703855421', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.82.188.83', '2019-08-07 17:44:30', 0, 1002001015, '账号未登陆', '2019-08-07 17:44:30');
INSERT INTO `access_log` VALUES (63913, '65.3607.15651710703937243', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.82.190.159', '2019-08-07 17:44:30', 1, 1002001015, '账号未登陆', '2019-08-07 17:44:30');
INSERT INTO `access_log` VALUES (63914, '65.47.15651710721935419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.82.190.159', '2019-08-07 17:44:32', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 17:44:32');
INSERT INTO `access_log` VALUES (63915, '65.52.15651710753075475', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.82.190.159', '2019-08-07 17:44:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 17:44:35');
INSERT INTO `access_log` VALUES (63916, '65.49.15651710896145433', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.82.190.159', '2019-08-07 17:44:50', 77, 0, '', '2019-08-07 17:44:50');
INSERT INTO `access_log` VALUES (63917, '65.51.15651710906155515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.82.190.159', '2019-08-07 17:44:51', 9, 0, '', '2019-08-07 17:44:51');
INSERT INTO `access_log` VALUES (63918, '65.54.15651710906145349', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.82.189.25', '2019-08-07 17:44:51', 11, 2001001000, '服务端发生异常', '2019-08-07 17:44:51');
INSERT INTO `access_log` VALUES (63919, '65.46.15651710906195481', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.82.189.25', '2019-08-07 17:44:51', 8, 0, '', '2019-08-07 17:44:51');
INSERT INTO `access_log` VALUES (63920, '2765000c-626e-41a8-a421-37d7b601d750', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '127.0.0.1', '2019-08-07 18:13:02', 262, 0, '', '2019-08-07 18:13:02');
INSERT INTO `access_log` VALUES (63921, 'dd282fd0-9613-4c3e-86ee-e035c573610c', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '127.0.0.1', '2019-08-07 18:13:02', 436, 0, '', '2019-08-07 18:13:03');
INSERT INTO `access_log` VALUES (63922, 'dd282fd0-9613-4c3e-86ee-e035c573610c', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '127.0.0.1', '2019-08-07 18:13:02', 436, 0, '', '2019-08-07 18:13:02');
INSERT INTO `access_log` VALUES (63923, '2bb2c3d2-f257-43ff-96f0-af626efe7653', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '127.0.0.1', '2019-08-07 18:13:15', 13, 0, '', '2019-08-07 18:13:15');
INSERT INTO `access_log` VALUES (63924, 'a9142c81-086c-4e66-b5e7-80a265ab2f5c', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '127.0.0.1', '2019-08-07 18:13:15', 37, 0, '', '2019-08-07 18:13:15');
INSERT INTO `access_log` VALUES (63925, '1f1bb40c-95f3-4f9f-b527-c9a95c6d8fc4', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPad; CPU OS 11_0 like Mac OS X) AppleWebKit/604.1.34 (KHTML, like Gecko) Version/11.0 Mobile/15A5341f Safari/604.1', '127.0.0.1', '2019-08-07 18:13:39', 114, 0, '', '2019-08-07 18:13:40');
INSERT INTO `access_log` VALUES (63926, '7499c880-cccb-4f54-9f12-04fe2bc734e4', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPad; CPU OS 11_0 like Mac OS X) AppleWebKit/604.1.34 (KHTML, like Gecko) Version/11.0 Mobile/15A5341f Safari/604.1', '127.0.0.1', '2019-08-07 18:13:40', 22, 0, '', '2019-08-07 18:13:40');
INSERT INTO `access_log` VALUES (63927, 'aa85d7c9-9fb1-4670-a151-d63fe601fbfc', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-07 18:14:09', 13, 0, '', '2019-08-07 18:14:09');
INSERT INTO `access_log` VALUES (63928, '65cdc73e-b764-4f01-ac63-07cda8d1ceac', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:14:34', 14, 0, '', '2019-08-07 18:14:34');
INSERT INTO `access_log` VALUES (63929, '763f906e-9bbb-4e1e-9794-262c38cb1dcb', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:14:34', 11, 0, '', '2019-08-07 18:14:34');
INSERT INTO `access_log` VALUES (63930, 'e9bb80e7-1195-4cc4-b6a3-ace7940489dc', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:14:35', 15, 0, '', '2019-08-07 18:14:35');
INSERT INTO `access_log` VALUES (63931, 'bf2e7bb7-1ee4-45fb-9351-9ec53505e858', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:14:35', 11, 0, '', '2019-08-07 18:14:35');
INSERT INTO `access_log` VALUES (63932, 'febf33b9-17ca-41e2-aea2-5cd8824b526c', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:14:45', 18, 0, '', '2019-08-07 18:14:45');
INSERT INTO `access_log` VALUES (63933, '1bae9fe9-92e3-4ed5-9843-aad4a065bfc5', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:14:45', 131, 0, '', '2019-08-07 18:14:45');
INSERT INTO `access_log` VALUES (63934, 'c5f6fd24-b823-4079-98ca-7ae501d480a7', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=41', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:14:49', 144, 0, '', '2019-08-07 18:14:49');
INSERT INTO `access_log` VALUES (63935, '35511063-5e1a-4e88-adcc-e0bb8c969e2c', 0, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=50', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:14:50', 442, 0, '', '2019-08-07 18:14:50');
INSERT INTO `access_log` VALUES (63936, '7fe33e44-0bcc-4b88-96ae-70a492cf65ea', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=16620864004', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:02', 1447, 0, '', '2019-08-07 18:15:03');
INSERT INTO `access_log` VALUES (63937, '615ba27a-e877-4a9d-b6ea-dad3e1ffdc20', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=41', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:12', 53, 0, '', '2019-08-07 18:15:12');
INSERT INTO `access_log` VALUES (63938, 'fc8a7f29-2290-4474-8949-b0872d97adbf', 0, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=50', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:12', 34, 0, '', '2019-08-07 18:15:12');
INSERT INTO `access_log` VALUES (63939, '603e71de-477b-4cf5-b252-ad3d704c9c79', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:14', 18, 0, '', '2019-08-07 18:15:14');
INSERT INTO `access_log` VALUES (63940, 'cfb0b463-961b-481d-ad22-e335fb35f77e', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:14', 32, 0, '', '2019-08-07 18:15:14');
INSERT INTO `access_log` VALUES (63941, '94cf926c-641f-4945-af83-f41e4f3292ea', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:17', 13, 0, '', '2019-08-07 18:15:17');
INSERT INTO `access_log` VALUES (63942, '3c760df8-42bd-48ee-80c8-6e82e9449673', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:17', 11, 0, '', '2019-08-07 18:15:17');
INSERT INTO `access_log` VALUES (63943, '2a6b31f5-00e6-4caf-bf53-a8e320591614', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:20', 13, 0, '', '2019-08-07 18:15:20');
INSERT INTO `access_log` VALUES (63944, 'f0b815ad-5b27-4009-ae3d-e88d2f0d137c', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:20', 12, 0, '', '2019-08-07 18:15:20');
INSERT INTO `access_log` VALUES (63945, '6592f8e6-d1ea-4886-ab70-d1232460ef85', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:22', 11, 0, '', '2019-08-07 18:15:22');
INSERT INTO `access_log` VALUES (63946, 'b8829ea4-9501-43d7-8ee4-0ab9120e8321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:25', 9, 0, '', '2019-08-07 18:15:25');
INSERT INTO `access_log` VALUES (63947, 'eee6b567-0940-4263-a97c-18ad3fce1245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:25', 10, 0, '', '2019-08-07 18:15:25');
INSERT INTO `access_log` VALUES (63948, 'a82f9f7a-23fd-4f5f-a58f-71c977457e33', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:30', 10, 0, '', '2019-08-07 18:15:30');
INSERT INTO `access_log` VALUES (63949, '748829ef-72aa-44c1-bb74-f3e540af56aa', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:30', 28, 0, '', '2019-08-07 18:15:30');
INSERT INTO `access_log` VALUES (63950, '50ece6c7-05d1-4d73-95ba-87f78506b4e2', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:58', 15, 0, '', '2019-08-07 18:15:58');
INSERT INTO `access_log` VALUES (63951, '252981e2-fe2d-4d0d-bb34-6b2ec5326f03', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '127.0.0.1', '2019-08-07 18:15:58', 13, 0, '', '2019-08-07 18:15:58');
INSERT INTO `access_log` VALUES (63952, '65.53.15651751668265477', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.84.242', '2019-08-07 18:52:47', 0, 1002001015, '账号未登陆', '2019-08-07 18:52:47');
INSERT INTO `access_log` VALUES (63953, '65.45.15651751668265493', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.84.242', '2019-08-07 18:52:47', 0, 1002001015, '账号未登陆', '2019-08-07 18:52:47');
INSERT INTO `access_log` VALUES (63954, '65.3607.15651751668297301', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.84.242', '2019-08-07 18:52:47', 0, 1002001015, '账号未登陆', '2019-08-07 18:52:47');
INSERT INTO `access_log` VALUES (63955, '65.50.15651751706255509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.84.242', '2019-08-07 18:52:51', 57, 0, '', '2019-08-07 18:52:51');
INSERT INTO `access_log` VALUES (63956, '65.46.15651751709625537', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.84.242', '2019-08-07 18:52:51', 28, 0, '', '2019-08-07 18:52:51');
INSERT INTO `access_log` VALUES (63957, '65.47.15651751709545477', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.84.242', '2019-08-07 18:52:51', 35, 0, '', '2019-08-07 18:52:51');
INSERT INTO `access_log` VALUES (63958, '65.54.15651751709565407', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.84.242', '2019-08-07 18:52:51', 34, 2001001000, '服务端发生异常', '2019-08-07 18:52:51');
INSERT INTO `access_log` VALUES (63959, '59.75.15651773775052847', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '178.154.200.13', '2019-08-07 19:29:38', 12, 2001001000, '服务端发生异常', '2019-08-07 19:29:38');
INSERT INTO `access_log` VALUES (63960, '59.80.15651773787232811', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '37.9.113.171', '2019-08-07 19:29:39', 12, 0, '', '2019-08-07 19:29:39');
INSERT INTO `access_log` VALUES (63961, '65.52.15651786409635579', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '219.152.26.167', '2019-08-07 19:50:41', 1, 1002001015, '账号未登陆', '2019-08-07 19:50:41');
INSERT INTO `access_log` VALUES (63962, '65.47.15651786409645523', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '219.152.26.167', '2019-08-07 19:50:41', 1, 1002001015, '账号未登陆', '2019-08-07 19:50:41');
INSERT INTO `access_log` VALUES (63963, '65.51.15651786466505619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '219.152.26.167', '2019-08-07 19:50:47', 78, 0, '', '2019-08-07 19:50:47');
INSERT INTO `access_log` VALUES (63964, '65.53.15651786475235525', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '219.152.26.167', '2019-08-07 19:50:48', 20, 0, '', '2019-08-07 19:50:48');
INSERT INTO `access_log` VALUES (63965, '65.3607.15651786475287349', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '219.152.26.167', '2019-08-07 19:50:48', 18, 0, '', '2019-08-07 19:50:48');
INSERT INTO `access_log` VALUES (63966, '65.45.15651786475285545', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '219.152.26.167', '2019-08-07 19:50:48', 22, 2001001000, '服务端发生异常', '2019-08-07 19:50:48');
INSERT INTO `access_log` VALUES (63967, '65.54.15651786865205455', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '219.152.26.167', '2019-08-07 19:51:27', 10, 0, '', '2019-08-07 19:51:27');
INSERT INTO `access_log` VALUES (63968, '65.47.15651786865205525', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '219.152.26.167', '2019-08-07 19:51:27', 11, 2001001000, '服务端发生异常', '2019-08-07 19:51:27');
INSERT INTO `access_log` VALUES (63969, '65.52.15651786865225581', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '219.152.26.167', '2019-08-07 19:51:27', 10, 0, '', '2019-08-07 19:51:27');
INSERT INTO `access_log` VALUES (63970, '65.47.15651787915175527', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '219.152.26.167', '2019-08-07 19:53:12', 10, 0, '', '2019-08-07 19:53:12');
INSERT INTO `access_log` VALUES (63971, '65.52.15651787915175583', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '219.152.26.167', '2019-08-07 19:53:12', 10, 2001001000, '服务端发生异常', '2019-08-07 19:53:12');
INSERT INTO `access_log` VALUES (63972, '65.54.15651787915235457', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '219.152.26.167', '2019-08-07 19:53:12', 9, 0, '', '2019-08-07 19:53:12');
INSERT INTO `access_log` VALUES (63973, '65.51.15651788039045623', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '219.152.26.167', '2019-08-07 19:53:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 19:53:24');
INSERT INTO `access_log` VALUES (63974, '65.45.15651788071555549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '219.152.26.167', '2019-08-07 19:53:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 19:53:27');
INSERT INTO `access_log` VALUES (63975, '65.46.15651816792815629', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:41:19', 0, 1002001015, '账号未登陆', '2019-08-07 20:41:19');
INSERT INTO `access_log` VALUES (63976, '65.50.15651816792815599', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:41:19', 0, 1002001015, '账号未登陆', '2019-08-07 20:41:19');
INSERT INTO `access_log` VALUES (63977, '65.49.15651816793025581', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:41:19', 0, 1002001015, '账号未登陆', '2019-08-07 20:41:19');
INSERT INTO `access_log` VALUES (63978, '65.47.15651816815775567', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:41:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 20:41:22');
INSERT INTO `access_log` VALUES (63979, '65.53.15651817001785569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:41:40', 91, 0, '', '2019-08-07 20:41:40');
INSERT INTO `access_log` VALUES (63980, '65.51.15651817005515663', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:41:41', 15, 0, '', '2019-08-07 20:41:41');
INSERT INTO `access_log` VALUES (63981, '65.3607.15651817005557393', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:41:41', 8, 0, '', '2019-08-07 20:41:41');
INSERT INTO `access_log` VALUES (63982, '65.45.15651817005525589', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:41:41', 14, 2001001000, '服务端发生异常', '2019-08-07 20:41:41');
INSERT INTO `access_log` VALUES (63983, '65.46.15651817044235631', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:41:44', 18, 0, '', '2019-08-07 20:41:44');
INSERT INTO `access_log` VALUES (63984, '65.49.15651817044275583', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:41:44', 17, 0, '', '2019-08-07 20:41:44');
INSERT INTO `access_log` VALUES (63985, '65.50.15651817044255601', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:41:44', 19, 2001001000, '服务端发生异常', '2019-08-07 20:41:44');
INSERT INTO `access_log` VALUES (63986, '65.54.15651817377505499', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:42:18', 9, 0, '', '2019-08-07 20:42:18');
INSERT INTO `access_log` VALUES (63987, '65.53.15651817377505571', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:42:18', 11, 2001001000, '服务端发生异常', '2019-08-07 20:42:18');
INSERT INTO `access_log` VALUES (63988, '65.3607.15651817377527395', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:42:18', 9, 0, '', '2019-08-07 20:42:18');
INSERT INTO `access_log` VALUES (63989, '59.78.15651817503292905', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:42:30', 11, 0, '', '2019-08-07 20:42:30');
INSERT INTO `access_log` VALUES (63990, '59.74.15651817503312909', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:42:30', 39, 2001001000, '服务端发生异常', '2019-08-07 20:42:30');
INSERT INTO `access_log` VALUES (63991, '64.83.15651817553553215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:42:35', 10, 0, '', '2019-08-07 20:42:35');
INSERT INTO `access_log` VALUES (63992, '64.85.15651817554613247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:42:35', 3, 0, '', '2019-08-07 20:42:35');
INSERT INTO `access_log` VALUES (63993, '64.82.15651817564743223', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:42:36', 2, 0, '', '2019-08-07 20:42:36');
INSERT INTO `access_log` VALUES (63994, '64.80.15651817571993221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.131.3.111', '2019-08-07 20:42:37', 2, 0, '', '2019-08-07 20:42:37');
INSERT INTO `access_log` VALUES (63995, '59.76.15651817897422889', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.131.3.111', '2019-08-07 20:43:10', 3, 0, '', '2019-08-07 20:43:10');
INSERT INTO `access_log` VALUES (63996, '59.72.15651817897422895', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.4(0x17000428) NetType/WIFI Language/zh_CN', '222.131.3.111', '2019-08-07 20:43:10', 15, 2001001000, '服务端发生异常', '2019-08-07 20:43:10');
INSERT INTO `access_log` VALUES (63997, '59.77.15651826336082897', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:14', 3, 0, '', '2019-08-07 20:57:14');
INSERT INTO `access_log` VALUES (63998, '59.73.15651826336092909', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:14', 12, 2001001000, '服务端发生异常', '2019-08-07 20:57:14');
INSERT INTO `access_log` VALUES (63999, '59.76.15651826388652901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:19', 2, 0, '', '2019-08-07 20:57:19');
INSERT INTO `access_log` VALUES (64000, '59.72.15651826388662907', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:19', 13, 2001001000, '服务端发生异常', '2019-08-07 20:57:19');
INSERT INTO `access_log` VALUES (64001, '64.80.15651826424893233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:22', 3, 0, '', '2019-08-07 20:57:22');
INSERT INTO `access_log` VALUES (64002, '64.84.15651826426003227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:23', 1, 0, '', '2019-08-07 20:57:23');
INSERT INTO `access_log` VALUES (64003, '64.78.15651826439383233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:24', 2, 0, '', '2019-08-07 20:57:24');
INSERT INTO `access_log` VALUES (64004, '64.81.15651826445543235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:25', 2, 0, '', '2019-08-07 20:57:25');
INSERT INTO `access_log` VALUES (64005, '65.50.15651826511515615', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:31', 1, 1002001015, '账号未登陆', '2019-08-07 20:57:31');
INSERT INTO `access_log` VALUES (64006, '65.45.15651826511515603', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:31', 1, 1002001015, '账号未登陆', '2019-08-07 20:57:31');
INSERT INTO `access_log` VALUES (64007, '65.46.15651826511605645', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:31', 1, 1002001015, '账号未登陆', '2019-08-07 20:57:31');
INSERT INTO `access_log` VALUES (64008, '65.49.15651826578895597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:38', 93, 0, '', '2019-08-07 20:57:38');
INSERT INTO `access_log` VALUES (64009, '65.47.15651826581585583', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:38', 9, 0, '', '2019-08-07 20:57:38');
INSERT INTO `access_log` VALUES (64010, '65.52.15651826581605639', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:38', 9, 2001001000, '服务端发生异常', '2019-08-07 20:57:38');
INSERT INTO `access_log` VALUES (64011, '65.53.15651826581625585', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.66.117.22', '2019-08-07 20:57:38', 8, 0, '', '2019-08-07 20:57:38');
INSERT INTO `access_log` VALUES (64012, '65.47.15651853202495619', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.91.17', '2019-08-07 21:42:00', 0, 1002001015, '账号未登陆', '2019-08-07 21:42:00');
INSERT INTO `access_log` VALUES (64013, '65.52.15651853203015675', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.91.17', '2019-08-07 21:42:00', 0, 1002001015, '账号未登陆', '2019-08-07 21:42:00');
INSERT INTO `access_log` VALUES (64014, '65.3607.15651853203167445', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.91.17', '2019-08-07 21:42:00', 1, 1002001015, '账号未登陆', '2019-08-07 21:42:00');
INSERT INTO `access_log` VALUES (64015, '65.54.15651853265455549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.91.17', '2019-08-07 21:42:07', 337, 0, '', '2019-08-07 21:42:07');
INSERT INTO `access_log` VALUES (64016, '65.51.15651853272465715', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.91.17', '2019-08-07 21:42:07', 67, 0, '', '2019-08-07 21:42:07');
INSERT INTO `access_log` VALUES (64017, '65.45.15651853272485641', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.91.17', '2019-08-07 21:42:07', 68, 0, '', '2019-08-07 21:42:07');
INSERT INTO `access_log` VALUES (64018, '65.46.15651853275435683', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.10.91.17', '2019-08-07 21:42:08', 10, 2001001000, '服务端发生异常', '2019-08-07 21:42:08');
INSERT INTO `access_log` VALUES (64019, '59.75.15651883247322995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.35.186.238', '2019-08-07 22:32:05', 16, 0, '', '2019-08-07 22:32:05');
INSERT INTO `access_log` VALUES (64020, '59.80.15651883247352959', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.35.186.238', '2019-08-07 22:32:05', 30, 2001001000, '服务端发生异常', '2019-08-07 22:32:05');
INSERT INTO `access_log` VALUES (64021, '59.79.15651883318242993', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.35.186.238', '2019-08-07 22:32:12', 3, 0, '', '2019-08-07 22:32:12');
INSERT INTO `access_log` VALUES (64022, '59.74.15651883318242999', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.35.186.238', '2019-08-07 22:32:12', 18, 2001001000, '服务端发生异常', '2019-08-07 22:32:12');
INSERT INTO `access_log` VALUES (64023, '65.49.15651883418735675', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.35.186.238', '2019-08-07 22:32:22', 0, 1002001015, '账号未登陆', '2019-08-07 22:32:22');
INSERT INTO `access_log` VALUES (64024, '65.47.15651883418765661', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.35.186.238', '2019-08-07 22:32:22', 1, 1002001015, '账号未登陆', '2019-08-07 22:32:22');
INSERT INTO `access_log` VALUES (64025, '65.53.15651883418765663', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.35.186.238', '2019-08-07 22:32:22', 1, 1002001015, '账号未登陆', '2019-08-07 22:32:22');
INSERT INTO `access_log` VALUES (64026, '65.52.15651883440085717', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.35.186.238', '2019-08-07 22:32:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-07 22:32:24');
INSERT INTO `access_log` VALUES (64027, '65.54.15651883555595591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.35.186.238', '2019-08-07 22:32:36', 271, 0, '', '2019-08-07 22:32:36');
INSERT INTO `access_log` VALUES (64028, '65.51.15651883560845757', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.35.186.238', '2019-08-07 22:32:36', 16, 0, '', '2019-08-07 22:32:36');
INSERT INTO `access_log` VALUES (64029, '65.45.15651883560915683', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.35.186.238', '2019-08-07 22:32:36', 13, 2001001000, '服务端发生异常', '2019-08-07 22:32:36');
INSERT INTO `access_log` VALUES (64030, '65.46.15651883560915725', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '121.35.186.238', '2019-08-07 22:32:36', 13, 0, '', '2019-08-07 22:32:36');
INSERT INTO `access_log` VALUES (64031, '59.73.15651888297522993', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.10.241.147', '2019-08-07 22:40:30', 3, 0, '', '2019-08-07 22:40:30');
INSERT INTO `access_log` VALUES (64032, '59.72.15651888297522991', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '175.10.241.147', '2019-08-07 22:40:30', 13, 2001001000, '服务端发生异常', '2019-08-07 22:40:30');
INSERT INTO `access_log` VALUES (64033, '59.78.15651903960543023', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.44.174.135', '2019-08-07 23:06:36', 4, 0, '', '2019-08-07 23:06:36');
INSERT INTO `access_log` VALUES (64034, '59.71.15651903960543013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.44.174.135', '2019-08-07 23:06:36', 13, 2001001000, '服务端发生异常', '2019-08-07 23:06:36');
INSERT INTO `access_log` VALUES (64035, '59.77.15651904065153003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.44.174.135', '2019-08-07 23:06:47', 2, 0, '', '2019-08-07 23:06:47');
INSERT INTO `access_log` VALUES (64036, '59.72.15651904065183013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.44.174.135', '2019-08-07 23:06:47', 14, 2001001000, '服务端发生异常', '2019-08-07 23:06:47');
INSERT INTO `access_log` VALUES (64037, '59.78.15651955847483093', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.159.154.19', '2019-08-08 00:33:05', 18, 2001001000, '服务端发生异常', '2019-08-08 00:33:05');
INSERT INTO `access_log` VALUES (64038, '59.71.15651955847703083', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.159.154.19', '2019-08-08 00:33:05', 11, 0, '', '2019-08-08 00:33:05');
INSERT INTO `access_log` VALUES (64039, '65.54.15651956045105691', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.159.154.19', '2019-08-08 00:33:25', 1, 1002001015, '账号未登陆', '2019-08-08 00:33:25');
INSERT INTO `access_log` VALUES (64040, '65.46.15651956045105821', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.159.154.19', '2019-08-08 00:33:25', 0, 1002001015, '账号未登陆', '2019-08-08 00:33:25');
INSERT INTO `access_log` VALUES (64041, '65.52.15651956045105819', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.159.154.19', '2019-08-08 00:33:25', 0, 1002001015, '账号未登陆', '2019-08-08 00:33:25');
INSERT INTO `access_log` VALUES (64042, '65.45.15651956066455779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.159.154.19', '2019-08-08 00:33:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 00:33:27');
INSERT INTO `access_log` VALUES (64043, '65.50.15651956237485793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.159.154.19', '2019-08-08 00:33:44', 72, 0, '', '2019-08-08 00:33:44');
INSERT INTO `access_log` VALUES (64044, '65.53.15651956246265763', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.159.154.19', '2019-08-08 00:33:45', 19, 0, '', '2019-08-08 00:33:45');
INSERT INTO `access_log` VALUES (64045, '65.49.15651956246265777', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.159.154.19', '2019-08-08 00:33:45', 19, 0, '', '2019-08-08 00:33:45');
INSERT INTO `access_log` VALUES (64046, '65.47.15651956246265761', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.159.154.19', '2019-08-08 00:33:45', 20, 2001001000, '服务端发生异常', '2019-08-08 00:33:45');
INSERT INTO `access_log` VALUES (64047, '65.47.15652225911026121', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; PCAT10 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '117.136.30.109', '2019-08-08 08:03:11', 1, 1002001015, '账号未登陆', '2019-08-08 08:03:11');
INSERT INTO `access_log` VALUES (64048, '65.53.15652225911286123', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; PCAT10 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '117.136.30.109', '2019-08-08 08:03:11', 1, 1002001015, '账号未登陆', '2019-08-08 08:03:11');
INSERT INTO `access_log` VALUES (64049, '65.3607.15652225911287949', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; PCAT10 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '117.136.30.109', '2019-08-08 08:03:11', 0, 1002001015, '账号未登陆', '2019-08-08 08:03:11');
INSERT INTO `access_log` VALUES (64050, '65.54.15652226211496053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; PCAT10 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '117.136.30.109', '2019-08-08 08:03:41', 89, 0, '', '2019-08-08 08:03:41');
INSERT INTO `access_log` VALUES (64051, '65.45.15652226220606141', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; PCAT10 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '117.136.30.109', '2019-08-08 08:03:42', 13, 0, '', '2019-08-08 08:03:42');
INSERT INTO `access_log` VALUES (64052, '65.51.15652226220796219', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; PCAT10 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '117.136.30.109', '2019-08-08 08:03:42', 11, 2001001000, '服务端发生异常', '2019-08-08 08:03:42');
INSERT INTO `access_log` VALUES (64053, '65.50.15652226220916155', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; PCAT10 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '117.136.30.109', '2019-08-08 08:03:42', 11, 0, '', '2019-08-08 08:03:42');
INSERT INTO `access_log` VALUES (64054, '65.47.15652226383836123', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; PCAT10 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '117.136.30.109', '2019-08-08 08:03:58', 17, 0, '', '2019-08-08 08:03:58');
INSERT INTO `access_log` VALUES (64055, '65.53.15652226383816125', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; PCAT10 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '117.136.30.109', '2019-08-08 08:03:58', 20, 0, '', '2019-08-08 08:03:58');
INSERT INTO `access_log` VALUES (64056, '65.3607.15652226383837951', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; PCAT10 Build/PPR1.180610.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.9.1039 Mobile Safari/537.36', '117.136.30.109', '2019-08-08 08:03:58', 18, 2001001000, '服务端发生异常', '2019-08-08 08:03:58');
INSERT INTO `access_log` VALUES (64057, '59.74.15652254032503495', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:50:03', 11, 0, '', '2019-08-08 08:50:03');
INSERT INTO `access_log` VALUES (64058, '59.78.15652254032533491', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:50:03', 26, 2001001000, '服务端发生异常', '2019-08-08 08:50:03');
INSERT INTO `access_log` VALUES (64059, '64.76.15652254081703799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:50:08', 10, 0, '', '2019-08-08 08:50:08');
INSERT INTO `access_log` VALUES (64060, '64.83.15652254083073799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:50:08', 3, 0, '', '2019-08-08 08:50:08');
INSERT INTO `access_log` VALUES (64061, '64.77.15652254094783791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:50:09', 2, 0, '', '2019-08-08 08:50:09');
INSERT INTO `access_log` VALUES (64062, '64.85.15652254104153831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:50:10', 2, 0, '', '2019-08-08 08:50:10');
INSERT INTO `access_log` VALUES (64063, '64.82.15652254136903807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:50:14', 2, 0, '', '2019-08-08 08:50:14');
INSERT INTO `access_log` VALUES (64064, '64.80.15652254137933805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:50:14', 2, 0, '', '2019-08-08 08:50:14');
INSERT INTO `access_log` VALUES (64065, '59.77.15652254185123471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:50:19', 3, 0, '', '2019-08-08 08:50:19');
INSERT INTO `access_log` VALUES (64066, '59.72.15652254185123481', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:50:19', 23, 2001001000, '服务端发生异常', '2019-08-08 08:50:19');
INSERT INTO `access_log` VALUES (64067, '64.78.15652254213393805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:50:21', 2, 0, '', '2019-08-08 08:50:21');
INSERT INTO `access_log` VALUES (64068, '64.81.15652254214483807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:50:21', 1, 0, '', '2019-08-08 08:50:21');
INSERT INTO `access_log` VALUES (64069, '65.52.15652255043956221', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:51:44', 5, 1002001012, '访问令牌已过期', '2019-08-08 08:51:44');
INSERT INTO `access_log` VALUES (64070, '65.54.15652255043956093', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:51:44', 5, 1002001012, '访问令牌已过期', '2019-08-08 08:51:44');
INSERT INTO `access_log` VALUES (64071, '65.45.15652255043966181', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:51:44', 7, 1002001012, '访问令牌已过期', '2019-08-08 08:51:44');
INSERT INTO `access_log` VALUES (64072, '65.50.15652255180466195', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:51:58', 72, 0, '', '2019-08-08 08:51:58');
INSERT INTO `access_log` VALUES (64073, '65.49.15652255183546179', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:51:58', 10, 0, '', '2019-08-08 08:51:58');
INSERT INTO `access_log` VALUES (64074, '65.47.15652255183586163', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:51:58', 11, 2001001000, '服务端发生异常', '2019-08-08 08:51:58');
INSERT INTO `access_log` VALUES (64075, '65.3607.15652255183597991', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.170', '2019-08-08 08:51:58', 9, 0, '', '2019-08-08 08:51:58');
INSERT INTO `access_log` VALUES (64076, '65.46.15652267479886243', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.0.19', '2019-08-08 09:12:28', 1, 1002001015, '账号未登陆', '2019-08-08 09:12:28');
INSERT INTO `access_log` VALUES (64077, '65.53.15652267479876183', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.0.19', '2019-08-08 09:12:28', 0, 1002001015, '账号未登陆', '2019-08-08 09:12:28');
INSERT INTO `access_log` VALUES (64078, '65.52.15652267479886239', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.0.19', '2019-08-08 09:12:28', 0, 1002001015, '账号未登陆', '2019-08-08 09:12:28');
INSERT INTO `access_log` VALUES (64079, '65.54.15652267565006111', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.0.19', '2019-08-08 09:12:37', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 09:12:37');
INSERT INTO `access_log` VALUES (64080, '65.51.15652267642376279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.0.19', '2019-08-08 09:12:44', 150, 0, '', '2019-08-08 09:12:44');
INSERT INTO `access_log` VALUES (64081, '65.49.15652267647666197', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.0.19', '2019-08-08 09:12:45', 18, 0, '', '2019-08-08 09:12:45');
INSERT INTO `access_log` VALUES (64082, '65.50.15652267647696213', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.0.19', '2019-08-08 09:12:45', 18, 2001001000, '服务端发生异常', '2019-08-08 09:12:45');
INSERT INTO `access_log` VALUES (64083, '65.3607.15652267647788011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.0.19', '2019-08-08 09:12:45', 11, 0, '', '2019-08-08 09:12:45');
INSERT INTO `access_log` VALUES (64084, '65.50.15652285172956237', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-08 09:41:57', 5, 1002001012, '访问令牌已过期', '2019-08-08 09:41:57');
INSERT INTO `access_log` VALUES (64085, '65.49.15652285172966221', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-08 09:41:57', 4, 1002001012, '访问令牌已过期', '2019-08-08 09:41:57');
INSERT INTO `access_log` VALUES (64086, '65.3607.15652285173028035', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-08 09:41:57', 3, 1002001012, '访问令牌已过期', '2019-08-08 09:41:57');
INSERT INTO `access_log` VALUES (64087, '65.47.15652285191936205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-08 09:41:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 09:41:59');
INSERT INTO `access_log` VALUES (64088, '65.46.15652285344466269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-08 09:42:14', 72, 0, '', '2019-08-08 09:42:15');
INSERT INTO `access_log` VALUES (64089, '65.52.15652285347276265', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-08 09:42:15', 11, 0, '', '2019-08-08 09:42:15');
INSERT INTO `access_log` VALUES (64090, '65.54.15652285347296137', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-08 09:42:15', 11, 2001001000, '服务端发生异常', '2019-08-08 09:42:15');
INSERT INTO `access_log` VALUES (64091, '65.45.15652285347336227', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-08 09:42:15', 8, 0, '', '2019-08-08 09:42:15');
INSERT INTO `access_log` VALUES (64092, '65.3607.15652302199968059', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.67.31', '2019-08-08 10:10:20', 4, 1002001012, '访问令牌已过期', '2019-08-08 10:10:20');
INSERT INTO `access_log` VALUES (64093, '65.50.15652302199966261', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.67.31', '2019-08-08 10:10:20', 4, 1002001012, '访问令牌已过期', '2019-08-08 10:10:20');
INSERT INTO `access_log` VALUES (64094, '65.47.15652302199996229', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.67.31', '2019-08-08 10:10:20', 2, 1002001012, '访问令牌已过期', '2019-08-08 10:10:20');
INSERT INTO `access_log` VALUES (64095, '65.46.15652302282026293', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.67.31', '2019-08-08 10:10:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 10:10:28');
INSERT INTO `access_log` VALUES (64096, '65.45.15652302422116251', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.67.31', '2019-08-08 10:10:42', 76, 0, '', '2019-08-08 10:10:42');
INSERT INTO `access_log` VALUES (64097, '65.52.15652302425976289', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.67.31', '2019-08-08 10:10:43', 11, 0, '', '2019-08-08 10:10:43');
INSERT INTO `access_log` VALUES (64098, '65.51.15652302426006329', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.67.31', '2019-08-08 10:10:43', 18, 2001001000, '服务端发生异常', '2019-08-08 10:10:43');
INSERT INTO `access_log` VALUES (64099, '65.49.15652302426056247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.67.31', '2019-08-08 10:10:43', 17, 0, '', '2019-08-08 10:10:43');
INSERT INTO `access_log` VALUES (64100, '65.3607.15652302560648061', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.67.31', '2019-08-08 10:10:56', 9, 0, '', '2019-08-08 10:10:56');
INSERT INTO `access_log` VALUES (64101, '65.50.15652302560736263', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.67.31', '2019-08-08 10:10:56', 9, 2001001000, '服务端发生异常', '2019-08-08 10:10:56');
INSERT INTO `access_log` VALUES (64102, '65.53.15652302560776235', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.67.31', '2019-08-08 10:10:56', 8, 0, '', '2019-08-08 10:10:56');
INSERT INTO `access_log` VALUES (64103, '59.72.15652319914663569', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:39:51', 10, 0, '', '2019-08-08 10:39:51');
INSERT INTO `access_log` VALUES (64104, '59.73.15652319914663571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:39:51', 20, 2001001000, '服务端发生异常', '2019-08-08 10:39:51');
INSERT INTO `access_log` VALUES (64105, '65.47.15652320033456255', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:40:03', 1, 1002001015, '账号未登陆', '2019-08-08 10:40:03');
INSERT INTO `access_log` VALUES (64106, '65.50.15652320033486287', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:40:03', 0, 1002001015, '账号未登陆', '2019-08-08 10:40:03');
INSERT INTO `access_log` VALUES (64107, '65.3607.15652320033538085', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:40:03', 0, 1002001015, '账号未登陆', '2019-08-08 10:40:03');
INSERT INTO `access_log` VALUES (64108, '65.53.15652320054526259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:40:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 10:40:05');
INSERT INTO `access_log` VALUES (64109, '65.54.15652320116346187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:40:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 10:40:12');
INSERT INTO `access_log` VALUES (64110, '65.45.15652320231196277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:40:23', 4, 1002002001, '密码不正确', '2019-08-08 10:40:23');
INSERT INTO `access_log` VALUES (64111, '65.51.15652320257386355', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:40:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 10:40:26');
INSERT INTO `access_log` VALUES (64112, '65.49.15652320359966273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:40:36', 76, 0, '', '2019-08-08 10:40:36');
INSERT INTO `access_log` VALUES (64113, '65.47.15652320363676257', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:40:36', 77, 0, '', '2019-08-08 10:40:36');
INSERT INTO `access_log` VALUES (64114, '65.3607.15652320363748087', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:40:36', 73, 0, '', '2019-08-08 10:40:36');
INSERT INTO `access_log` VALUES (64115, '65.50.15652320363706289', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:40:36', 76, 2001001000, '服务端发生异常', '2019-08-08 10:40:36');
INSERT INTO `access_log` VALUES (64116, '65.46.15652320503096321', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:40:50', 9, 0, '', '2019-08-08 10:40:50');
INSERT INTO `access_log` VALUES (64117, '65.54.15652320503146189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:40:50', 9, 2001001000, '服务端发生异常', '2019-08-08 10:40:50');
INSERT INTO `access_log` VALUES (64118, '65.45.15652320503216279', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:40:50', 9, 0, '', '2019-08-08 10:40:50');
INSERT INTO `access_log` VALUES (64119, '64.77.15652320704923881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:41:10', 11, 0, '', '2019-08-08 10:41:11');
INSERT INTO `access_log` VALUES (64120, '64.85.15652320706333921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:41:11', 3, 0, '', '2019-08-08 10:41:11');
INSERT INTO `access_log` VALUES (64121, '64.82.15652320721143897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:41:12', 2, 0, '', '2019-08-08 10:41:12');
INSERT INTO `access_log` VALUES (64122, '64.80.15652320729223895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:41:13', 2, 0, '', '2019-08-08 10:41:13');
INSERT INTO `access_log` VALUES (64123, '64.84.15652320733013889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:41:13', 2, 0, '', '2019-08-08 10:41:13');
INSERT INTO `access_log` VALUES (64124, '64.78.15652320736223895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '218.241.189.29', '2019-08-08 10:41:14', 2, 0, '', '2019-08-08 10:41:14');
INSERT INTO `access_log` VALUES (64125, '65.53.15652339335186287', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.4.110', '2019-08-08 11:12:14', 1, 1002001015, '账号未登陆', '2019-08-08 11:12:14');
INSERT INTO `access_log` VALUES (64126, '65.54.15652339335186215', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.4.110', '2019-08-08 11:12:14', 1, 1002001015, '账号未登陆', '2019-08-08 11:12:14');
INSERT INTO `access_log` VALUES (64127, '65.46.15652339335186347', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.110.4.110', '2019-08-08 11:12:14', 0, 1002001015, '账号未登陆', '2019-08-08 11:12:14');
INSERT INTO `access_log` VALUES (64128, '59.72.15652347585133609', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.210.253', '2019-08-08 11:25:59', 10, 0, '', '2019-08-08 11:25:59');
INSERT INTO `access_log` VALUES (64129, '59.77.15652347585123597', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.210.253', '2019-08-08 11:25:59', 18, 2001001000, '服务端发生异常', '2019-08-08 11:25:59');
INSERT INTO `access_log` VALUES (64130, '64.81.15652347716993933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.210.253', '2019-08-08 11:26:12', 11, 0, '', '2019-08-08 11:26:12');
INSERT INTO `access_log` VALUES (64131, '64.79.15652347720543929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.210.253', '2019-08-08 11:26:12', 5, 0, '', '2019-08-08 11:26:12');
INSERT INTO `access_log` VALUES (64132, '64.76.15652347735483927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.210.253', '2019-08-08 11:26:14', 4, 0, '', '2019-08-08 11:26:14');
INSERT INTO `access_log` VALUES (64133, '64.83.15652347742153927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.210.253', '2019-08-08 11:26:14', 1, 0, '', '2019-08-08 11:26:14');
INSERT INTO `access_log` VALUES (64134, '59.80.15652419891863677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-08-08 13:26:29', 12, 0, '', '2019-08-08 13:26:29');
INSERT INTO `access_log` VALUES (64135, '59.75.15652419891863715', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-08-08 13:26:29', 21, 2001001000, '服务端发生异常', '2019-08-08 13:26:29');
INSERT INTO `access_log` VALUES (64136, '65.52.15652432823836471', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '113.81.154.63', '2019-08-08 13:48:02', 0, 1002001015, '账号未登陆', '2019-08-08 13:48:02');
INSERT INTO `access_log` VALUES (64137, '65.50.15652432823836443', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '113.81.154.63', '2019-08-08 13:48:02', 0, 1002001015, '账号未登陆', '2019-08-08 13:48:02');
INSERT INTO `access_log` VALUES (64138, '65.53.15652432823846413', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '113.81.154.63', '2019-08-08 13:48:02', 1, 1002001015, '账号未登陆', '2019-08-08 13:48:02');
INSERT INTO `access_log` VALUES (64139, '65.45.15652443972336447', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-08-08 14:06:37', 7, 1002001012, '访问令牌已过期', '2019-08-08 14:06:37');
INSERT INTO `access_log` VALUES (64140, '65.46.15652443972336489', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-08-08 14:06:37', 7, 1002001012, '访问令牌已过期', '2019-08-08 14:06:37');
INSERT INTO `access_log` VALUES (64141, '65.3607.15652443972308253', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-08-08 14:06:37', 10, 1002001012, '访问令牌已过期', '2019-08-08 14:06:37');
INSERT INTO `access_log` VALUES (64142, '65.52.15652443989626487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-08-08 14:06:39', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 14:06:39');
INSERT INTO `access_log` VALUES (64143, '65.47.15652444153066427', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-08-08 14:06:55', 147, 0, '', '2019-08-08 14:06:55');
INSERT INTO `access_log` VALUES (64144, '65.49.15652444157216445', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-08-08 14:06:56', 12, 0, '', '2019-08-08 14:06:56');
INSERT INTO `access_log` VALUES (64145, '65.51.15652444157276525', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-08-08 14:06:56', 13, 2001001000, '服务端发生异常', '2019-08-08 14:06:56');
INSERT INTO `access_log` VALUES (64146, '65.54.15652444157316355', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.212.80.251', '2019-08-08 14:06:56', 12, 0, '', '2019-08-08 14:06:56');
INSERT INTO `access_log` VALUES (64147, '59.71.15652445693093737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.22', '2019-08-08 14:09:29', 11, 0, '', '2019-08-08 14:09:29');
INSERT INTO `access_log` VALUES (64148, '59.78.15652445693083747', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.22', '2019-08-08 14:09:29', 22, 2001001000, '服务端发生异常', '2019-08-08 14:09:29');
INSERT INTO `access_log` VALUES (64149, '64.83.15652445764584057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.22', '2019-08-08 14:09:36', 12, 0, '', '2019-08-08 14:09:36');
INSERT INTO `access_log` VALUES (64150, '64.77.15652445766204051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.22', '2019-08-08 14:09:37', 3, 0, '', '2019-08-08 14:09:37');
INSERT INTO `access_log` VALUES (64151, '64.85.15652445782584091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.22', '2019-08-08 14:09:38', 2, 0, '', '2019-08-08 14:09:38');
INSERT INTO `access_log` VALUES (64152, '64.80.15652445792184065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.22', '2019-08-08 14:09:39', 2, 0, '', '2019-08-08 14:09:39');
INSERT INTO `access_log` VALUES (64153, '59.72.15652445827853741', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.22', '2019-08-08 14:09:43', 3, 0, '', '2019-08-08 14:09:43');
INSERT INTO `access_log` VALUES (64154, '59.73.15652445827853743', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.22', '2019-08-08 14:09:43', 17, 2001001000, '服务端发生异常', '2019-08-08 14:09:43');
INSERT INTO `access_log` VALUES (64155, '64.84.15652445867674061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.22', '2019-08-08 14:09:47', 2, 0, '', '2019-08-08 14:09:47');
INSERT INTO `access_log` VALUES (64156, '64.82.15652445868564069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.22', '2019-08-08 14:09:47', 2, 0, '', '2019-08-08 14:09:47');
INSERT INTO `access_log` VALUES (64157, '59.76.15652445874403733', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.22', '2019-08-08 14:09:47', 3, 0, '', '2019-08-08 14:09:47');
INSERT INTO `access_log` VALUES (64158, '59.75.15652445874403751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '106.38.115.22', '2019-08-08 14:09:47', 33, 2001001000, '服务端发生异常', '2019-08-08 14:09:47');
INSERT INTO `access_log` VALUES (64159, '65.52.15652446296426491', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.149.209.78', '2019-08-08 14:10:30', 0, 1002001015, '账号未登陆', '2019-08-08 14:10:30');
INSERT INTO `access_log` VALUES (64160, '65.53.15652446296536433', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.149.209.78', '2019-08-08 14:10:30', 0, 1002001015, '账号未登陆', '2019-08-08 14:10:30');
INSERT INTO `access_log` VALUES (64161, '65.47.15652446296596431', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.149.209.78', '2019-08-08 14:10:30', 0, 1002001015, '账号未登陆', '2019-08-08 14:10:30');
INSERT INTO `access_log` VALUES (64162, '65.49.15652446320646449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.149.209.78', '2019-08-08 14:10:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 14:10:32');
INSERT INTO `access_log` VALUES (64163, '59.71.15652446324463739', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.80.1.52', '2019-08-08 14:10:32', 3, 0, '', '2019-08-08 14:10:32');
INSERT INTO `access_log` VALUES (64164, '59.78.15652446324463749', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.80.1.52', '2019-08-08 14:10:32', 23, 2001001000, '服务端发生异常', '2019-08-08 14:10:32');
INSERT INTO `access_log` VALUES (64165, '65.54.15652446374536359', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.149.209.78', '2019-08-08 14:10:37', 86, 0, '', '2019-08-08 14:10:38');
INSERT INTO `access_log` VALUES (64166, '65.45.15652446379036453', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.149.209.78', '2019-08-08 14:10:38', 10, 0, '', '2019-08-08 14:10:38');
INSERT INTO `access_log` VALUES (64167, '65.51.15652446379036529', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.149.209.78', '2019-08-08 14:10:38', 9, 0, '', '2019-08-08 14:10:38');
INSERT INTO `access_log` VALUES (64168, '65.46.15652446379046495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.149.209.78', '2019-08-08 14:10:38', 10, 2001001000, '服务端发生异常', '2019-08-08 14:10:38');
INSERT INTO `access_log` VALUES (64169, '65.54.15652456270796373', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.19.37.217', '2019-08-08 14:27:07', 1, 1002001015, '账号未登陆', '2019-08-08 14:27:07');
INSERT INTO `access_log` VALUES (64170, '65.45.15652456270806467', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.19.37.217', '2019-08-08 14:27:07', 0, 1002001015, '账号未登陆', '2019-08-08 14:27:07');
INSERT INTO `access_log` VALUES (64171, '65.51.15652456270876543', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.19.37.217', '2019-08-08 14:27:07', 0, 1002001015, '账号未登陆', '2019-08-08 14:27:07');
INSERT INTO `access_log` VALUES (64172, '65.3607.15652456296848273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.19.37.217', '2019-08-08 14:27:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 14:27:10');
INSERT INTO `access_log` VALUES (64173, '65.52.15652456573436507', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.19.37.217', '2019-08-08 14:27:37', 130, 0, '', '2019-08-08 14:27:37');
INSERT INTO `access_log` VALUES (64174, '65.53.15652456577866449', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.19.37.217', '2019-08-08 14:27:38', 10, 0, '', '2019-08-08 14:27:38');
INSERT INTO `access_log` VALUES (64175, '65.47.15652456577906447', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.19.37.217', '2019-08-08 14:27:38', 11, 2001001000, '服务端发生异常', '2019-08-08 14:27:38');
INSERT INTO `access_log` VALUES (64176, '65.49.15652456577936465', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.19.37.217', '2019-08-08 14:27:38', 9, 0, '', '2019-08-08 14:27:38');
INSERT INTO `access_log` VALUES (64177, '59.80.15652457465443729', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.7.66.45', '2019-08-08 14:29:07', 3, 0, '', '2019-08-08 14:29:07');
INSERT INTO `access_log` VALUES (64178, '59.74.15652457465453771', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.7.67.42', '2019-08-08 14:29:07', 16, 2001001000, '服务端发生异常', '2019-08-08 14:29:07');
INSERT INTO `access_log` VALUES (64179, '64.84.15652457540244077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.67.42', '2019-08-08 14:29:14', 3, 0, '', '2019-08-08 14:29:14');
INSERT INTO `access_log` VALUES (64180, '64.82.15652457541644085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.67.42', '2019-08-08 14:29:14', 2, 0, '', '2019-08-08 14:29:14');
INSERT INTO `access_log` VALUES (64181, '59.71.15652457672303755', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.67.42', '2019-08-08 14:29:27', 2, 0, '', '2019-08-08 14:29:27');
INSERT INTO `access_log` VALUES (64182, '59.78.15652457672313765', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.66.45', '2019-08-08 14:29:27', 15, 2001001000, '服务端发生异常', '2019-08-08 14:29:27');
INSERT INTO `access_log` VALUES (64183, '64.81.15652457700724081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.67.42', '2019-08-08 14:29:30', 2, 0, '', '2019-08-08 14:29:30');
INSERT INTO `access_log` VALUES (64184, '64.79.15652457701754081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.67.42', '2019-08-08 14:29:30', 2, 0, '', '2019-08-08 14:29:30');
INSERT INTO `access_log` VALUES (64185, '64.83.15652457757594075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.67.42', '2019-08-08 14:29:36', 2, 0, '', '2019-08-08 14:29:36');
INSERT INTO `access_log` VALUES (64186, '64.77.15652457759004069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.67.42', '2019-08-08 14:29:36', 1, 0, '', '2019-08-08 14:29:36');
INSERT INTO `access_log` VALUES (64187, '64.84.15652458184984079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.67.42', '2019-08-08 14:30:18', 2, 0, '', '2019-08-08 14:30:19');
INSERT INTO `access_log` VALUES (64188, '64.82.15652458186194087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '116.7.67.42', '2019-08-08 14:30:19', 1, 0, '', '2019-08-08 14:30:19');
INSERT INTO `access_log` VALUES (64189, '59.75.15652459799433771', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.150.28.35', '2019-08-08 14:33:00', 2, 0, '', '2019-08-08 14:33:00');
INSERT INTO `access_log` VALUES (64190, '59.74.15652459799443775', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.150.28.35', '2019-08-08 14:33:00', 23, 2001001000, '服务端发生异常', '2019-08-08 14:33:00');
INSERT INTO `access_log` VALUES (64191, '59.79.15652459927613767', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '119.137.53.185', '2019-08-08 14:33:13', 2, 0, '', '2019-08-08 14:33:13');
INSERT INTO `access_log` VALUES (64192, '59.71.15652459927613759', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '119.137.53.185', '2019-08-08 14:33:13', 12, 2001001000, '服务端发生异常', '2019-08-08 14:33:13');
INSERT INTO `access_log` VALUES (64193, '65.46.15652459959306515', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.150.28.35', '2019-08-08 14:33:16', 1, 1002001015, '账号未登陆', '2019-08-08 14:33:16');
INSERT INTO `access_log` VALUES (64194, '65.3607.15652459959338279', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.150.28.35', '2019-08-08 14:33:16', 0, 1002001015, '账号未登陆', '2019-08-08 14:33:16');
INSERT INTO `access_log` VALUES (64195, '65.50.15652459959356485', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.150.28.35', '2019-08-08 14:33:16', 0, 1002001015, '账号未登陆', '2019-08-08 14:33:16');
INSERT INTO `access_log` VALUES (64196, '65.52.15652459977856513', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.150.28.35', '2019-08-08 14:33:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 14:33:18');
INSERT INTO `access_log` VALUES (64197, '65.47.15652460154156453', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.150.28.35', '2019-08-08 14:33:35', 83, 0, '', '2019-08-08 14:33:35');
INSERT INTO `access_log` VALUES (64198, '65.49.15652460157496471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.150.28.35', '2019-08-08 14:33:36', 9, 0, '', '2019-08-08 14:33:36');
INSERT INTO `access_log` VALUES (64199, '65.45.15652460157536475', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.150.28.35', '2019-08-08 14:33:36', 10, 2001001000, '服务端发生异常', '2019-08-08 14:33:36');
INSERT INTO `access_log` VALUES (64200, '65.51.15652460157556551', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.150.28.35', '2019-08-08 14:33:36', 9, 0, '', '2019-08-08 14:33:36');
INSERT INTO `access_log` VALUES (64201, '64.77.15652460399434073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '119.137.53.185', '2019-08-08 14:34:00', 3, 0, '', '2019-08-08 14:34:00');
INSERT INTO `access_log` VALUES (64202, '64.85.15652460402714113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '119.137.53.185', '2019-08-08 14:34:00', 2, 0, '', '2019-08-08 14:34:00');
INSERT INTO `access_log` VALUES (64203, '64.80.15652460448984087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '119.137.53.185', '2019-08-08 14:34:05', 3, 0, '', '2019-08-08 14:34:05');
INSERT INTO `access_log` VALUES (64204, '64.84.15652460450094083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '119.137.53.185', '2019-08-08 14:34:05', 2, 0, '', '2019-08-08 14:34:05');
INSERT INTO `access_log` VALUES (64205, '59.76.15652460472073755', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '119.137.53.185', '2019-08-08 14:34:07', 2, 0, '', '2019-08-08 14:34:07');
INSERT INTO `access_log` VALUES (64206, '59.75.15652460472073773', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '119.137.53.185', '2019-08-08 14:34:07', 14, 2001001000, '服务端发生异常', '2019-08-08 14:34:07');
INSERT INTO `access_log` VALUES (64207, '64.76.15652460943044083', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '119.137.53.185', '2019-08-08 14:34:54', 2, 0, '', '2019-08-08 14:34:54');
INSERT INTO `access_log` VALUES (64208, '64.83.15652460946264081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '119.137.53.185', '2019-08-08 14:34:55', 2, 0, '', '2019-08-08 14:34:55');
INSERT INTO `access_log` VALUES (64209, '59.71.15652460969883761', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '119.137.53.185', '2019-08-08 14:34:57', 2, 0, '', '2019-08-08 14:34:57');
INSERT INTO `access_log` VALUES (64210, '59.78.15652460969883771', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Mobile Safari/537.36', '119.137.53.185', '2019-08-08 14:34:57', 12, 2001001000, '服务端发生异常', '2019-08-08 14:34:57');
INSERT INTO `access_log` VALUES (64211, '65.52.15652467909496525', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.38.128.89', '2019-08-08 14:46:31', 0, 1002001015, '账号未登陆', '2019-08-08 14:46:31');
INSERT INTO `access_log` VALUES (64212, '65.50.15652467909426497', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.38.128.89', '2019-08-08 14:46:31', 0, 1002001015, '账号未登陆', '2019-08-08 14:46:31');
INSERT INTO `access_log` VALUES (64213, '65.46.15652467909426527', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.38.128.89', '2019-08-08 14:46:31', 0, 1002001015, '账号未登陆', '2019-08-08 14:46:31');
INSERT INTO `access_log` VALUES (64214, '65.53.15652467927226467', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.38.128.89', '2019-08-08 14:46:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 14:46:33');
INSERT INTO `access_log` VALUES (64215, '65.45.15652468206516487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.38.128.89', '2019-08-08 14:47:01', 66, 0, '', '2019-08-08 14:47:01');
INSERT INTO `access_log` VALUES (64216, '65.3607.15652468209338293', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.38.128.89', '2019-08-08 14:47:01', 9, 0, '', '2019-08-08 14:47:01');
INSERT INTO `access_log` VALUES (64217, '65.51.15652468209316563', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.38.128.89', '2019-08-08 14:47:01', 11, 0, '', '2019-08-08 14:47:01');
INSERT INTO `access_log` VALUES (64218, '65.54.15652468209326393', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.38.128.89', '2019-08-08 14:47:01', 11, 2001001000, '服务端发生异常', '2019-08-08 14:47:01');
INSERT INTO `access_log` VALUES (64219, '65.52.15652468418176527', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.149.209.78', '2019-08-08 14:47:22', 82, 0, '', '2019-08-08 14:47:22');
INSERT INTO `access_log` VALUES (64220, '65.53.15652468418276469', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.149.209.78', '2019-08-08 14:47:22', 184, 0, '', '2019-08-08 14:47:22');
INSERT INTO `access_log` VALUES (64221, '65.50.15652468418206499', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '123.149.209.78', '2019-08-08 14:47:22', 197, 2001001000, '服务端发生异常', '2019-08-08 14:47:22');
INSERT INTO `access_log` VALUES (64222, '59.79.15652474035613787', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:56:44', 26, 0, '', '2019-08-08 14:56:44');
INSERT INTO `access_log` VALUES (64223, '59.71.15652474035743779', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:56:44', 45, 2001001000, '服务端发生异常', '2019-08-08 14:56:44');
INSERT INTO `access_log` VALUES (64224, '59.77.15652474152573771', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:56:55', 3, 0, '', '2019-08-08 14:56:55');
INSERT INTO `access_log` VALUES (64225, '59.73.15652474152593785', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:56:55', 14, 2001001000, '服务端发生异常', '2019-08-08 14:56:55');
INSERT INTO `access_log` VALUES (64226, '59.76.15652474305903775', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:57:11', 2, 0, '', '2019-08-08 14:57:11');
INSERT INTO `access_log` VALUES (64227, '59.75.15652474305913793', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:57:11', 9, 2001001000, '服务端发生异常', '2019-08-08 14:57:11');
INSERT INTO `access_log` VALUES (64228, '64.83.15652474341744099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:57:14', 5, 0, '', '2019-08-08 14:57:14');
INSERT INTO `access_log` VALUES (64229, '64.77.15652474342974093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:57:14', 2, 0, '', '2019-08-08 14:57:14');
INSERT INTO `access_log` VALUES (64230, '64.85.15652474360314133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:57:16', 2, 0, '', '2019-08-08 14:57:16');
INSERT INTO `access_log` VALUES (64231, '64.80.15652474371284107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:57:17', 2, 0, '', '2019-08-08 14:57:17');
INSERT INTO `access_log` VALUES (64232, '64.84.15652474378154103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:57:18', 2, 0, '', '2019-08-08 14:57:18');
INSERT INTO `access_log` VALUES (64233, '65.46.15652475311256539', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:58:51', 1, 1002001015, '账号未登陆', '2019-08-08 14:58:51');
INSERT INTO `access_log` VALUES (64234, '65.52.15652475311306537', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:58:51', 0, 1002001015, '账号未登陆', '2019-08-08 14:58:51');
INSERT INTO `access_log` VALUES (64235, '65.50.15652475311456509', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:58:51', 0, 1002001015, '账号未登陆', '2019-08-08 14:58:51');
INSERT INTO `access_log` VALUES (64236, '65.47.15652475341296477', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:58:54', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 14:58:54');
INSERT INTO `access_log` VALUES (64237, '65.49.15652475410466495', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:59:01', 86, 0, '', '2019-08-08 14:59:01');
INSERT INTO `access_log` VALUES (64238, '65.45.15652475416496499', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:59:02', 9, 0, '', '2019-08-08 14:59:02');
INSERT INTO `access_log` VALUES (64239, '65.3607.15652475416518305', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:59:02', 9, 2001001000, '服务端发生异常', '2019-08-08 14:59:02');
INSERT INTO `access_log` VALUES (64240, '65.54.15652475416656405', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '113.98.246.239', '2019-08-08 14:59:02', 8, 0, '', '2019-08-08 14:59:02');
INSERT INTO `access_log` VALUES (64241, '65.46.15652475599226541', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.210.253', '2019-08-08 14:59:20', 0, 1002001015, '账号未登陆', '2019-08-08 14:59:20');
INSERT INTO `access_log` VALUES (64242, '65.52.15652475599316539', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.210.253', '2019-08-08 14:59:20', 0, 1002001015, '账号未登陆', '2019-08-08 14:59:20');
INSERT INTO `access_log` VALUES (64243, '65.50.15652475599376511', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.210.253', '2019-08-08 14:59:20', 1, 1002001015, '账号未登陆', '2019-08-08 14:59:20');
INSERT INTO `access_log` VALUES (64244, '65.45.15652476122326501', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.210.253', '2019-08-08 15:00:12', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 15:00:12');
INSERT INTO `access_log` VALUES (64245, '65.51.15652476297226577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.210.253', '2019-08-08 15:00:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 15:00:30');
INSERT INTO `access_log` VALUES (64246, '59.73.15652476517523789', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:00:52', 3, 0, '', '2019-08-08 15:00:52');
INSERT INTO `access_log` VALUES (64247, '59.77.15652476517503775', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:00:52', 19, 2001001000, '服务端发生异常', '2019-08-08 15:00:52');
INSERT INTO `access_log` VALUES (64248, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=电脑 &pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:01:05', 7, 0, '', '2019-08-08 15:01:05');
INSERT INTO `access_log` VALUES (64249, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=电脑 ', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:01:05', 9, 0, '', '2019-08-08 15:01:05');
INSERT INTO `access_log` VALUES (64250, '64.77.15652476676144097', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:01:08', 36, 0, '', '2019-08-08 15:01:08');
INSERT INTO `access_log` VALUES (64251, '66.55.15652476972631415', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=213&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:01:37', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-08-08 15:01:37');
INSERT INTO `access_log` VALUES (64252, '66.56.15652477062971457', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:01:46', 17, 1001003001, '验证码已过期', '2019-08-08 15:01:46');
INSERT INTO `access_log` VALUES (64253, '65.54.15652477239756409', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:02:04', 0, 1002001015, '账号未登陆', '2019-08-08 15:02:04');
INSERT INTO `access_log` VALUES (64254, '65.45.15652477239816503', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:02:04', 0, 1002001015, '账号未登陆', '2019-08-08 15:02:04');
INSERT INTO `access_log` VALUES (64255, '65.3607.15652477239828309', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:02:04', 1, 1002001015, '账号未登陆', '2019-08-08 15:02:04');
INSERT INTO `access_log` VALUES (64256, '65.46.15652477312366545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:02:11', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 15:02:11');
INSERT INTO `access_log` VALUES (64257, '65.52.15652477439046543', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:02:24', 84, 0, '', '2019-08-08 15:02:24');
INSERT INTO `access_log` VALUES (64258, '65.53.15652477441976485', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:02:24', 10, 0, '', '2019-08-08 15:02:24');
INSERT INTO `access_log` VALUES (64259, '65.47.15652477441986483', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:02:24', 11, 2001001000, '服务端发生异常', '2019-08-08 15:02:24');
INSERT INTO `access_log` VALUES (64260, '65.49.15652477442006501', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:02:24', 10, 0, '', '2019-08-08 15:02:24');
INSERT INTO `access_log` VALUES (64261, '65.45.15652477718836505', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:02:52', 9, 0, '', '2019-08-08 15:02:52');
INSERT INTO `access_log` VALUES (64262, '65.51.15652477718856581', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:02:52', 9, 0, '', '2019-08-08 15:02:52');
INSERT INTO `access_log` VALUES (64263, '65.54.15652477718856411', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:02:52', 9, 2001001000, '服务端发生异常', '2019-08-08 15:02:52');
INSERT INTO `access_log` VALUES (64264, '65.52.15652477748966545', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:02:55', 10, 2001001000, '服务端发生异常', '2019-08-08 15:02:55');
INSERT INTO `access_log` VALUES (64265, '65.50.15652477748956517', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:02:55', 165, 0, '', '2019-08-08 15:02:55');
INSERT INTO `access_log` VALUES (64266, '65.49.15652477749016503', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '60.176.107.122', '2019-08-08 15:02:55', 159, 0, '', '2019-08-08 15:02:55');
INSERT INTO `access_log` VALUES (64267, '65.45.15652478611656507', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.19.37.217', '2019-08-08 15:04:21', 10, 0, '', '2019-08-08 15:04:21');
INSERT INTO `access_log` VALUES (64268, '65.46.15652478611726549', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.19.37.217', '2019-08-08 15:04:21', 9, 2001001000, '服务端发生异常', '2019-08-08 15:04:21');
INSERT INTO `access_log` VALUES (64269, '65.52.15652478611776547', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.19.37.217', '2019-08-08 15:04:21', 9, 0, '', '2019-08-08 15:04:21');
INSERT INTO `access_log` VALUES (64270, '65.3607.15652480653878317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.158.210.253', '2019-08-08 15:07:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 15:07:45');
INSERT INTO `access_log` VALUES (64271, '65.45.15652494761796529', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.238.177.46', '2019-08-08 15:31:16', 1, 1002001015, '账号未登陆', '2019-08-08 15:31:16');
INSERT INTO `access_log` VALUES (64272, '65.50.15652494761816541', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.238.177.46', '2019-08-08 15:31:16', 1, 1002001015, '账号未登陆', '2019-08-08 15:31:16');
INSERT INTO `access_log` VALUES (64273, '65.49.15652494761956527', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.238.177.46', '2019-08-08 15:31:16', 0, 1002001015, '账号未登陆', '2019-08-08 15:31:16');
INSERT INTO `access_log` VALUES (64274, '65.53.15652494789326511', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.238.177.46', '2019-08-08 15:31:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 15:31:19');
INSERT INTO `access_log` VALUES (64275, '65.3607.15652494954188337', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.238.177.46', '2019-08-08 15:31:35', 94, 0, '', '2019-08-08 15:31:36');
INSERT INTO `access_log` VALUES (64276, '65.51.15652494959216607', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.238.177.46', '2019-08-08 15:31:36', 10, 0, '', '2019-08-08 15:31:36');
INSERT INTO `access_log` VALUES (64277, '65.54.15652494959236437', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.238.177.46', '2019-08-08 15:31:36', 10, 2001001000, '服务端发生异常', '2019-08-08 15:31:36');
INSERT INTO `access_log` VALUES (64278, '65.46.15652494959356573', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.238.177.46', '2019-08-08 15:31:36', 9, 0, '', '2019-08-08 15:31:36');
INSERT INTO `access_log` VALUES (64279, '65.47.15652495663826511', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.238.177.46', '2019-08-08 15:32:46', 123, 0, '', '2019-08-08 15:32:47');
INSERT INTO `access_log` VALUES (64280, '65.54.15652495663946439', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.238.177.46', '2019-08-08 15:32:46', 111, 0, '', '2019-08-08 15:32:47');
INSERT INTO `access_log` VALUES (64281, '65.3607.15652495663828339', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.238.177.46', '2019-08-08 15:32:46', 123, 2001001000, '服务端发生异常', '2019-08-08 15:32:47');
INSERT INTO `access_log` VALUES (64282, '65.51.15652495736566609', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.238.177.46', '2019-08-08 15:32:54', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 15:32:54');
INSERT INTO `access_log` VALUES (64283, '65.50.15652505004006557', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.96.57', '2019-08-08 15:48:20', 1, 1002001015, '账号未登陆', '2019-08-08 15:48:20');
INSERT INTO `access_log` VALUES (64284, '65.45.15652505004006545', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.96.57', '2019-08-08 15:48:20', 0, 1002001015, '账号未登陆', '2019-08-08 15:48:20');
INSERT INTO `access_log` VALUES (64285, '65.49.15652505004156543', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.96.57', '2019-08-08 15:48:20', 0, 1002001015, '账号未登陆', '2019-08-08 15:48:20');
INSERT INTO `access_log` VALUES (64286, '65.53.15652505035326527', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.96.57', '2019-08-08 15:48:24', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 15:48:24');
INSERT INTO `access_log` VALUES (64287, '65.3607.15652505156998353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.96.57', '2019-08-08 15:48:36', 86, 0, '', '2019-08-08 15:48:36');
INSERT INTO `access_log` VALUES (64288, '65.54.15652505160166453', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.96.57', '2019-08-08 15:48:36', 9, 0, '', '2019-08-08 15:48:36');
INSERT INTO `access_log` VALUES (64289, '65.51.15652505160216623', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.96.57', '2019-08-08 15:48:36', 10, 2001001000, '服务端发生异常', '2019-08-08 15:48:36');
INSERT INTO `access_log` VALUES (64290, '65.46.15652505160266589', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.96.57', '2019-08-08 15:48:36', 9, 0, '', '2019-08-08 15:48:36');
INSERT INTO `access_log` VALUES (64291, '65.3607.15652511109228363', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:58:31', 0, 1002001015, '账号未登陆', '2019-08-08 15:58:31');
INSERT INTO `access_log` VALUES (64292, '65.46.15652511109246599', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:58:31', 1, 1002001015, '账号未登陆', '2019-08-08 15:58:31');
INSERT INTO `access_log` VALUES (64293, '65.51.15652511109306633', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:58:31', 1, 1002001015, '账号未登陆', '2019-08-08 15:58:31');
INSERT INTO `access_log` VALUES (64294, '65.54.15652511179156463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:58:38', 5, 1002002000, '账号不存在', '2019-08-08 15:58:38');
INSERT INTO `access_log` VALUES (64295, '65.45.15652511235986555', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:58:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 15:58:44');
INSERT INTO `access_log` VALUES (64296, '65.50.15652511330936567', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:58:53', 67, 0, '', '2019-08-08 15:58:53');
INSERT INTO `access_log` VALUES (64297, '65.49.15652511333896553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:58:53', 8, 0, '', '2019-08-08 15:58:53');
INSERT INTO `access_log` VALUES (64298, '65.53.15652511333926539', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:58:53', 8, 2001001000, '服务端发生异常', '2019-08-08 15:58:53');
INSERT INTO `access_log` VALUES (64299, '65.47.15652511334006537', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:58:53', 8, 0, '', '2019-08-08 15:58:53');
INSERT INTO `access_log` VALUES (64300, '65.51.15652511526626635', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:59:13', 8, 0, '', '2019-08-08 15:59:13');
INSERT INTO `access_log` VALUES (64301, '65.54.15652511526636465', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:59:13', 10, 2001001000, '服务端发生异常', '2019-08-08 15:59:13');
INSERT INTO `access_log` VALUES (64302, '65.52.15652511526816597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:59:13', 16, 0, '', '2019-08-08 15:59:13');
INSERT INTO `access_log` VALUES (64303, '65.50.15652511625266569', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:59:23', 9, 2001001000, '服务端发生异常', '2019-08-08 15:59:23');
INSERT INTO `access_log` VALUES (64304, '65.45.15652511625206557', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:59:23', 135, 0, '', '2019-08-08 15:59:23');
INSERT INTO `access_log` VALUES (64305, '65.49.15652511625276555', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 15:59:23', 129, 0, '', '2019-08-08 15:59:23');
INSERT INTO `access_log` VALUES (64306, '59.76.15652512603103827', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 16:01:00', 10, 0, '', '2019-08-08 16:01:00');
INSERT INTO `access_log` VALUES (64307, '59.72.15652512603103835', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '111.198.124.10', '2019-08-08 16:01:00', 23, 2001001000, '服务端发生异常', '2019-08-08 16:01:00');
INSERT INTO `access_log` VALUES (64308, '59.78.15652529847293865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.175.2.49', '2019-08-08 16:29:45', 4, 0, '', '2019-08-08 16:29:45');
INSERT INTO `access_log` VALUES (64309, '59.77.15652529847293847', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.175.2.49', '2019-08-08 16:29:45', 14, 2001001000, '服务端发生异常', '2019-08-08 16:29:45');
INSERT INTO `access_log` VALUES (64310, '59.77.15652536955623857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:41:36', 3, 0, '', '2019-08-08 16:41:36');
INSERT INTO `access_log` VALUES (64311, '59.78.15652536955663875', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:41:36', 9, 2001001000, '服务端发生异常', '2019-08-08 16:41:36');
INSERT INTO `access_log` VALUES (64312, '64.79.15652536980344191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:41:38', 12, 0, '', '2019-08-08 16:41:38');
INSERT INTO `access_log` VALUES (64313, '64.76.15652536982514187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:41:38', 4, 0, '', '2019-08-08 16:41:38');
INSERT INTO `access_log` VALUES (64314, '64.83.15652536990604185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:41:39', 2, 0, '', '2019-08-08 16:41:39');
INSERT INTO `access_log` VALUES (64315, '64.77.15652536994364179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:41:39', 2, 0, '', '2019-08-08 16:41:39');
INSERT INTO `access_log` VALUES (64316, '59.73.15652537003073871', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:41:40', 2, 0, '', '2019-08-08 16:41:40');
INSERT INTO `access_log` VALUES (64317, '59.76.15652537003073861', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:41:40', 13, 2001001000, '服务端发生异常', '2019-08-08 16:41:40');
INSERT INTO `access_log` VALUES (64318, '64.85.15652537053964219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:41:45', 2, 0, '', '2019-08-08 16:41:45');
INSERT INTO `access_log` VALUES (64319, '64.80.15652537055554193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:41:46', 2, 0, '', '2019-08-08 16:41:46');
INSERT INTO `access_log` VALUES (64320, '64.84.15652537070964189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:41:47', 3, 0, '', '2019-08-08 16:41:47');
INSERT INTO `access_log` VALUES (64321, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:41:47', 6, 0, '', '2019-08-08 16:41:47');
INSERT INTO `access_log` VALUES (64322, '64.82.15652537081324197', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:41:48', 7, 0, '', '2019-08-08 16:41:48');
INSERT INTO `access_log` VALUES (64323, '66.51.15652537177061545', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:41:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-08-08 16:41:58');
INSERT INTO `access_log` VALUES (64324, '64.81.15652537220054191', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:42:02', 6, 0, '', '2019-08-08 16:42:02');
INSERT INTO `access_log` VALUES (64325, '64.79.15652537226184193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:42:03', 2, 0, '', '2019-08-08 16:42:03');
INSERT INTO `access_log` VALUES (64326, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:42:03', 5, 0, '', '2019-08-08 16:42:03');
INSERT INTO `access_log` VALUES (64327, '64.76.15652537234434189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:42:03', 2, 0, '', '2019-08-08 16:42:03');
INSERT INTO `access_log` VALUES (64328, '64.83.15652537236144187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:42:04', 2, 0, '', '2019-08-08 16:42:04');
INSERT INTO `access_log` VALUES (64329, '64.77.15652537246324181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:42:05', 2, 0, '', '2019-08-08 16:42:05');
INSERT INTO `access_log` VALUES (64330, '59.74.15652537253403883', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:42:05', 3, 0, '', '2019-08-08 16:42:05');
INSERT INTO `access_log` VALUES (64331, '59.80.15652537253403841', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:42:05', 14, 2001001000, '服务端发生异常', '2019-08-08 16:42:05');
INSERT INTO `access_log` VALUES (64332, '59.71.15652537286273867', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:42:09', 2, 0, '', '2019-08-08 16:42:09');
INSERT INTO `access_log` VALUES (64333, '59.79.15652537286273875', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:42:09', 20, 2001001000, '服务端发生异常', '2019-08-08 16:42:09');
INSERT INTO `access_log` VALUES (64334, '65.46.15652537417676637', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:22', 1, 1002001015, '账号未登陆', '2019-08-08 16:42:22');
INSERT INTO `access_log` VALUES (64335, '65.3607.15652537417688401', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:22', 0, 1002001015, '账号未登陆', '2019-08-08 16:42:22');
INSERT INTO `access_log` VALUES (64336, '65.52.15652537417926633', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:22', 0, 1002001015, '账号未登陆', '2019-08-08 16:42:22');
INSERT INTO `access_log` VALUES (64337, '65.51.15652537439476671', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 16:42:24');
INSERT INTO `access_log` VALUES (64338, '65.50.15652537463236605', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 16:42:26');
INSERT INTO `access_log` VALUES (64339, '65.45.15652537471746593', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 16:42:27');
INSERT INTO `access_log` VALUES (64340, '65.49.15652537478906591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:28', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 16:42:28');
INSERT INTO `access_log` VALUES (64341, '65.53.15652537485406577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:29', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 16:42:29');
INSERT INTO `access_log` VALUES (64342, '65.47.15652537513866575', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:31', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 16:42:31');
INSERT INTO `access_log` VALUES (64343, '65.3607.15652537646008403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:45', 161, 0, '', '2019-08-08 16:42:45');
INSERT INTO `access_log` VALUES (64344, '65.52.15652537650156635', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:45', 11, 2001001000, '服务端发生异常', '2019-08-08 16:42:45');
INSERT INTO `access_log` VALUES (64345, '65.54.15652537650196503', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:45', 8, 0, '', '2019-08-08 16:42:45');
INSERT INTO `access_log` VALUES (64346, '65.51.15652537650246673', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:45', 8, 0, '', '2019-08-08 16:42:45');
INSERT INTO `access_log` VALUES (64347, '65.45.15652537748406595', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:55', 9, 0, '', '2019-08-08 16:42:55');
INSERT INTO `access_log` VALUES (64348, '65.49.15652537748426593', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:55', 10, 2001001000, '服务端发生异常', '2019-08-08 16:42:55');
INSERT INTO `access_log` VALUES (64349, '65.53.15652537748456579', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:55', 9, 0, '', '2019-08-08 16:42:55');
INSERT INTO `access_log` VALUES (64350, '65.47.15652537781586577', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:58', 9, 0, '', '2019-08-08 16:42:58');
INSERT INTO `access_log` VALUES (64351, '65.46.15652537781616641', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:58', 10, 2001001000, '服务端发生异常', '2019-08-08 16:42:58');
INSERT INTO `access_log` VALUES (64352, '65.3607.15652537781658405', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:42:58', 9, 0, '', '2019-08-08 16:42:58');
INSERT INTO `access_log` VALUES (64353, '59.72.15652542478863877', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.1.52', '2019-08-08 16:50:48', 3, 0, '', '2019-08-08 16:50:48');
INSERT INTO `access_log` VALUES (64354, '59.75.15652542478863887', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.1.52', '2019-08-08 16:50:48', 19, 2001001000, '服务端发生异常', '2019-08-08 16:50:48');
INSERT INTO `access_log` VALUES (64355, '64.79.15652542513224201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.1.52', '2019-08-08 16:50:51', 3, 0, '', '2019-08-08 16:50:51');
INSERT INTO `access_log` VALUES (64356, '64.76.15652542514574197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.1.52', '2019-08-08 16:50:51', 1, 0, '', '2019-08-08 16:50:51');
INSERT INTO `access_log` VALUES (64357, '64.83.15652542525204195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.1.52', '2019-08-08 16:50:53', 2, 0, '', '2019-08-08 16:50:53');
INSERT INTO `access_log` VALUES (64358, '64.77.15652542533844189', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.1.52', '2019-08-08 16:50:53', 1, 0, '', '2019-08-08 16:50:53');
INSERT INTO `access_log` VALUES (64359, '59.74.15652542547463891', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.1.52', '2019-08-08 16:50:55', 2, 0, '', '2019-08-08 16:50:55');
INSERT INTO `access_log` VALUES (64360, '59.79.15652542547473883', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.1.52', '2019-08-08 16:50:55', 12, 2001001000, '服务端发生异常', '2019-08-08 16:50:55');
INSERT INTO `access_log` VALUES (64361, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.62.99', '2019-08-08 16:53:12', 5, 0, '', '2019-08-08 16:53:12');
INSERT INTO `access_log` VALUES (64362, '59.78.15652544172843887', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.91.60.104', '2019-08-08 16:53:37', 114, 0, '', '2019-08-08 16:53:37');
INSERT INTO `access_log` VALUES (64363, '59.77.15652544176373869', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.91.60.107', '2019-08-08 16:53:38', 13, 2001001000, '服务端发生异常', '2019-08-08 16:53:38');
INSERT INTO `access_log` VALUES (64364, '64.80.15652544180084205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.91.60.104', '2019-08-08 16:53:38', 48, 0, '', '2019-08-08 16:53:38');
INSERT INTO `access_log` VALUES (64365, '64.84.15652544206094201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.151.207.205', '2019-08-08 16:53:41', 2, 0, '', '2019-08-08 16:53:41');
INSERT INTO `access_log` VALUES (64366, '64.78.15652544355694201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.89.29.94', '2019-08-08 16:53:56', 2, 0, '', '2019-08-08 16:53:56');
INSERT INTO `access_log` VALUES (64367, '65.45.15652544419486605', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.29.86', '2019-08-08 16:54:02', 0, 1002001015, '账号未登陆', '2019-08-08 16:54:02');
INSERT INTO `access_log` VALUES (64368, '65.3607.15652544749018415', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.91.62.99', '2019-08-08 16:54:35', 1, 1002001015, '账号未登陆', '2019-08-08 16:54:35');
INSERT INTO `access_log` VALUES (64369, '59.78.15652545472073889', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:55:47', 3, 0, '', '2019-08-08 16:55:47');
INSERT INTO `access_log` VALUES (64370, '59.77.15652545472093871', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:55:47', 19, 2001001000, '服务端发生异常', '2019-08-08 16:55:47');
INSERT INTO `access_log` VALUES (64371, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=123123&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:55:54', 6, 0, '', '2019-08-08 16:55:54');
INSERT INTO `access_log` VALUES (64372, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=123123', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:55:54', 5, 0, '', '2019-08-08 16:55:54');
INSERT INTO `access_log` VALUES (64373, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:55:57', 6, 0, '', '2019-08-08 16:55:57');
INSERT INTO `access_log` VALUES (64374, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:55:58', 11, 0, '', '2019-08-08 16:55:58');
INSERT INTO `access_log` VALUES (64375, '64.82.15652545585504211', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:55:59', 7, 0, '', '2019-08-08 16:55:59');
INSERT INTO `access_log` VALUES (64376, '64.81.15652545690124205', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:56:09', 6, 0, '', '2019-08-08 16:56:09');
INSERT INTO `access_log` VALUES (64377, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:56:12', 7, 0, '', '2019-08-08 16:56:12');
INSERT INTO `access_log` VALUES (64378, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:56:12', 12, 0, '', '2019-08-08 16:56:12');
INSERT INTO `access_log` VALUES (64379, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:56:13', 5, 0, '', '2019-08-08 16:56:13');
INSERT INTO `access_log` VALUES (64380, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:56:13', 10, 0, '', '2019-08-08 16:56:13');
INSERT INTO `access_log` VALUES (64381, '59.72.15652545751923883', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:56:15', 2, 0, '', '2019-08-08 16:56:15');
INSERT INTO `access_log` VALUES (64382, '59.75.15652545751923893', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '112.115.220.39', '2019-08-08 16:56:15', 18, 2001001000, '服务端发生异常', '2019-08-08 16:56:15');
INSERT INTO `access_log` VALUES (64383, '59.74.15652545910063897', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16A366 QQ/8.0.0.472 V1_IPH_SQ_8.0.0_1_APP_A Pixel/1242 Core/WKWebView Device/Apple(iPhone XS Max) NetType/WIFI QBWebViewType/1 WKType/1', '112.115.220.39', '2019-08-08 16:56:31', 4, 0, '', '2019-08-08 16:56:31');
INSERT INTO `access_log` VALUES (64384, '59.79.15652545910123889', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/16A366 QQ/8.0.0.472 V1_IPH_SQ_8.0.0_1_APP_A Pixel/1242 Core/WKWebView Device/Apple(iPhone XS Max) NetType/WIFI QBWebViewType/1 WKType/1', '112.115.220.39', '2019-08-08 16:56:31', 22, 2001001000, '服务端发生异常', '2019-08-08 16:56:31');
INSERT INTO `access_log` VALUES (64385, '59.77.15652545952163873', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:35', 2, 0, '', '2019-08-08 16:56:35');
INSERT INTO `access_log` VALUES (64386, '59.78.15652545952173891', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:35', 13, 2001001000, '服务端发生异常', '2019-08-08 16:56:35');
INSERT INTO `access_log` VALUES (64387, '64.83.15652545970384201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:37', 1, 0, '', '2019-08-08 16:56:37');
INSERT INTO `access_log` VALUES (64388, '64.77.15652545972274195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:37', 2, 0, '', '2019-08-08 16:56:37');
INSERT INTO `access_log` VALUES (64389, '64.85.15652546000664235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:40', 2, 0, '', '2019-08-08 16:56:40');
INSERT INTO `access_log` VALUES (64390, '64.80.15652546002504209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:40', 2, 0, '', '2019-08-08 16:56:40');
INSERT INTO `access_log` VALUES (64391, '59.73.15652546021623887', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:42', 2, 0, '', '2019-08-08 16:56:42');
INSERT INTO `access_log` VALUES (64392, '59.76.15652546021623877', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:42', 11, 2001001000, '服务端发生异常', '2019-08-08 16:56:42');
INSERT INTO `access_log` VALUES (64393, '59.72.15652546051843885', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:45', 2, 0, '', '2019-08-08 16:56:45');
INSERT INTO `access_log` VALUES (64394, '59.75.15652546051843895', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:45', 10, 2001001000, '服务端发生异常', '2019-08-08 16:56:45');
INSERT INTO `access_log` VALUES (64395, '64.84.15652546070414205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:47', 2, 0, '', '2019-08-08 16:56:47');
INSERT INTO `access_log` VALUES (64396, '64.82.15652546072844213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:47', 2, 0, '', '2019-08-08 16:56:47');
INSERT INTO `access_log` VALUES (64397, '64.78.15652546081774205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:48', 2, 0, '', '2019-08-08 16:56:48');
INSERT INTO `access_log` VALUES (64398, '64.81.15652546086924207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:49', 2, 0, '', '2019-08-08 16:56:49');
INSERT INTO `access_log` VALUES (64399, '64.79.15652546100274209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:50', 2, 0, '', '2019-08-08 16:56:50');
INSERT INTO `access_log` VALUES (64400, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:50', 5, 0, '', '2019-08-08 16:56:50');
INSERT INTO `access_log` VALUES (64401, '64.83.15652546121364203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:52', 2, 0, '', '2019-08-08 16:56:52');
INSERT INTO `access_log` VALUES (64402, '64.77.15652546125614197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:53', 2, 0, '', '2019-08-08 16:56:53');
INSERT INTO `access_log` VALUES (64403, '59.79.15652546141443891', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:54', 2, 0, '', '2019-08-08 16:56:54');
INSERT INTO `access_log` VALUES (64404, '59.74.15652546141443899', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 16:56:54', 20, 2001001000, '服务端发生异常', '2019-08-08 16:56:54');
INSERT INTO `access_log` VALUES (64405, '65.47.15652546228206589', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:57:03', 10, 0, '', '2019-08-08 16:57:03');
INSERT INTO `access_log` VALUES (64406, '65.46.15652546228206653', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:57:03', 12, 2001001000, '服务端发生异常', '2019-08-08 16:57:03');
INSERT INTO `access_log` VALUES (64407, '65.54.15652546228316517', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:57:03', 9, 0, '', '2019-08-08 16:57:03');
INSERT INTO `access_log` VALUES (64408, '65.51.15652546358116687', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:57:16', 9, 0, '', '2019-08-08 16:57:16');
INSERT INTO `access_log` VALUES (64409, '65.50.15652546358186621', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:57:16', 9, 2001001000, '服务端发生异常', '2019-08-08 16:57:16');
INSERT INTO `access_log` VALUES (64410, '65.45.15652546358226609', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 16:57:16', 9, 0, '', '2019-08-08 16:57:16');
INSERT INTO `access_log` VALUES (64411, '59.80.15652548691343861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 17:01:09', 3, 0, '', '2019-08-08 17:01:09');
INSERT INTO `access_log` VALUES (64412, '59.74.15652548691693903', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 17:01:09', 12, 2001001000, '服务端发生异常', '2019-08-08 17:01:09');
INSERT INTO `access_log` VALUES (64413, '64.76.15652548710744209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 17:01:11', 2, 0, '', '2019-08-08 17:01:11');
INSERT INTO `access_log` VALUES (64414, '64.83.15652548712534207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 17:01:11', 2, 0, '', '2019-08-08 17:01:11');
INSERT INTO `access_log` VALUES (64415, '59.79.15652548730483895', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 17:01:13', 3, 0, '', '2019-08-08 17:01:13');
INSERT INTO `access_log` VALUES (64416, '59.71.15652548730533887', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 17:01:13', 13, 2001001000, '服务端发生异常', '2019-08-08 17:01:13');
INSERT INTO `access_log` VALUES (64417, '64.77.15652548744644201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 17:01:14', 2, 0, '', '2019-08-08 17:01:14');
INSERT INTO `access_log` VALUES (64418, '64.85.15652548746174241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 17:01:15', 2, 0, '', '2019-08-08 17:01:15');
INSERT INTO `access_log` VALUES (64419, '59.77.15652548758603879', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 17:01:16', 2, 0, '', '2019-08-08 17:01:16');
INSERT INTO `access_log` VALUES (64420, '59.78.15652548758643897', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 17:01:16', 18, 2001001000, '服务端发生异常', '2019-08-08 17:01:16');
INSERT INTO `access_log` VALUES (64421, '64.80.15652548772174215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 17:01:17', 2, 0, '', '2019-08-08 17:01:17');
INSERT INTO `access_log` VALUES (64422, '64.84.15652548773954211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 17:01:17', 2, 0, '', '2019-08-08 17:01:17');
INSERT INTO `access_log` VALUES (64423, '59.73.15652548783603893', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 17:01:18', 2, 0, '', '2019-08-08 17:01:18');
INSERT INTO `access_log` VALUES (64424, '59.76.15652548783643883', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '112.115.220.39', '2019-08-08 17:01:18', 9, 2001001000, '服务端发生异常', '2019-08-08 17:01:18');
INSERT INTO `access_log` VALUES (64425, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.151.207.141', '2019-08-08 17:07:51', 13, 0, '', '2019-08-08 17:07:51');
INSERT INTO `access_log` VALUES (64426, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=123123', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.227', '2019-08-08 17:07:53', 6, 0, '', '2019-08-08 17:07:53');
INSERT INTO `access_log` VALUES (64427, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=123123&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.207.141', '2019-08-08 17:07:57', 6, 0, '', '2019-08-08 17:07:57');
INSERT INTO `access_log` VALUES (64428, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.62.99', '2019-08-08 17:08:13', 7, 0, '', '2019-08-08 17:08:13');
INSERT INTO `access_log` VALUES (64429, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.89.29.94', '2019-08-08 17:08:14', 17, 0, '', '2019-08-08 17:08:14');
INSERT INTO `access_log` VALUES (64430, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.236', '2019-08-08 17:08:32', 5, 0, '', '2019-08-08 17:08:32');
INSERT INTO `access_log` VALUES (64431, '65.3607.15652553356338429', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.254.2', '2019-08-08 17:08:56', 0, 1002001015, '账号未登陆', '2019-08-08 17:08:56');
INSERT INTO `access_log` VALUES (64432, '65.53.15652553356336605', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.254.2', '2019-08-08 17:08:56', 1, 1002001015, '账号未登陆', '2019-08-08 17:08:56');
INSERT INTO `access_log` VALUES (64433, '65.54.15652553356416527', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.254.2', '2019-08-08 17:08:56', 0, 1002001015, '账号未登陆', '2019-08-08 17:08:56');
INSERT INTO `access_log` VALUES (64434, '65.46.15652553374266665', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.254.2', '2019-08-08 17:08:57', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 17:08:57');
INSERT INTO `access_log` VALUES (64435, '65.47.15652553462376597', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.89.29.94', '2019-08-08 17:09:06', 0, 1002001015, '账号未登陆', '2019-08-08 17:09:06');
INSERT INTO `access_log` VALUES (64436, '65.50.15652553550406633', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.254.2', '2019-08-08 17:09:15', 122, 0, '', '2019-08-08 17:09:15');
INSERT INTO `access_log` VALUES (64437, '65.51.15652553554476699', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.254.2', '2019-08-08 17:09:15', 9, 0, '', '2019-08-08 17:09:15');
INSERT INTO `access_log` VALUES (64438, '65.45.15652553554486621', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.254.2', '2019-08-08 17:09:15', 11, 2001001000, '服务端发生异常', '2019-08-08 17:09:15');
INSERT INTO `access_log` VALUES (64439, '65.49.15652553554516619', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.254.2', '2019-08-08 17:09:15', 16, 0, '', '2019-08-08 17:09:15');
INSERT INTO `access_log` VALUES (64440, '65.3607.15652553685948431', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.254.2', '2019-08-08 17:09:29', 8, 0, '', '2019-08-08 17:09:29');
INSERT INTO `access_log` VALUES (64441, '65.54.15652553685986529', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.254.2', '2019-08-08 17:09:29', 8, 2001001000, '服务端发生异常', '2019-08-08 17:09:29');
INSERT INTO `access_log` VALUES (64442, '65.46.15652553685996667', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.254.2', '2019-08-08 17:09:29', 7, 0, '', '2019-08-08 17:09:29');
INSERT INTO `access_log` VALUES (64443, '64.83.15652553928914215', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.89.19.149', '2019-08-08 17:09:53', 7, 0, '', '2019-08-08 17:09:53');
INSERT INTO `access_log` VALUES (64444, '59.75.15652562358133919', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:23:56', 3, 0, '', '2019-08-08 17:23:56');
INSERT INTO `access_log` VALUES (64445, '59.80.15652562358133881', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:23:56', 19, 2001001000, '服务端发生异常', '2019-08-08 17:23:56');
INSERT INTO `access_log` VALUES (64446, '59.74.15652562402603923', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:24:00', 2, 0, '', '2019-08-08 17:24:00');
INSERT INTO `access_log` VALUES (64447, '59.71.15652562402623907', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:24:00', 12, 2001001000, '服务端发生异常', '2019-08-08 17:24:00');
INSERT INTO `access_log` VALUES (64448, '64.81.15652562436884231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:24:04', 2, 0, '', '2019-08-08 17:24:04');
INSERT INTO `access_log` VALUES (64449, '64.79.15652562438054233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:24:04', 2, 0, '', '2019-08-08 17:24:04');
INSERT INTO `access_log` VALUES (64450, '64.83.15652562470844227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:24:07', 2, 0, '', '2019-08-08 17:24:07');
INSERT INTO `access_log` VALUES (64451, '64.77.15652562474824221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:24:07', 2, 0, '', '2019-08-08 17:24:07');
INSERT INTO `access_log` VALUES (64452, '64.85.15652562479064261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:24:08', 2, 0, '', '2019-08-08 17:24:08');
INSERT INTO `access_log` VALUES (64453, '65.53.15652563572536621', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 17:25:57', 10, 0, '', '2019-08-08 17:25:57');
INSERT INTO `access_log` VALUES (64454, '65.46.15652563572566681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 17:25:57', 10, 2001001000, '服务端发生异常', '2019-08-08 17:25:57');
INSERT INTO `access_log` VALUES (64455, '65.54.15652563572636543', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 17:25:57', 8, 0, '', '2019-08-08 17:25:57');
INSERT INTO `access_log` VALUES (64456, '65.47.15652563690876613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 17:26:09', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 17:26:09');
INSERT INTO `access_log` VALUES (64457, '65.52.15652563713096677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 17:26:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 17:26:11');
INSERT INTO `access_log` VALUES (64458, '65.51.15652563852296715', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:26:25', 0, 1002001015, '账号未登陆', '2019-08-08 17:26:25');
INSERT INTO `access_log` VALUES (64459, '65.45.15652563852616637', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:26:25', 0, 1002001015, '账号未登陆', '2019-08-08 17:26:25');
INSERT INTO `access_log` VALUES (64460, '65.49.15652563852616635', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:26:25', 0, 1002001015, '账号未登陆', '2019-08-08 17:26:25');
INSERT INTO `access_log` VALUES (64461, '65.53.15652563876026623', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:26:28', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 17:26:28');
INSERT INTO `access_log` VALUES (64462, '65.54.15652563909036545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:26:31', 89, 0, '', '2019-08-08 17:26:31');
INSERT INTO `access_log` VALUES (64463, '65.46.15652563912656683', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:26:31', 9, 0, '', '2019-08-08 17:26:31');
INSERT INTO `access_log` VALUES (64464, '65.3607.15652563912708447', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:26:31', 9, 2001001000, '服务端发生异常', '2019-08-08 17:26:31');
INSERT INTO `access_log` VALUES (64465, '65.47.15652563912736615', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:26:31', 8, 0, '', '2019-08-08 17:26:31');
INSERT INTO `access_log` VALUES (64466, '65.54.15652566242476549', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:30:24', 11, 0, '', '2019-08-08 17:30:24');
INSERT INTO `access_log` VALUES (64467, '65.3607.15652566242528451', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:30:24', 10, 2001001000, '服务端发生异常', '2019-08-08 17:30:24');
INSERT INTO `access_log` VALUES (64468, '65.47.15652566242586619', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:30:24', 8, 0, '', '2019-08-08 17:30:24');
INSERT INTO `access_log` VALUES (64469, '65.46.15652566331596687', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:30:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 17:30:33');
INSERT INTO `access_log` VALUES (64470, '65.50.15652566438636655', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:30:44', 75, 0, '', '2019-08-08 17:30:44');
INSERT INTO `access_log` VALUES (64471, '65.45.15652566441246643', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:30:44', 9, 0, '', '2019-08-08 17:30:44');
INSERT INTO `access_log` VALUES (64472, '65.51.15652566441286721', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:30:44', 17, 2001001000, '服务端发生异常', '2019-08-08 17:30:44');
INSERT INTO `access_log` VALUES (64473, '65.49.15652566441326641', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.37.207.126', '2019-08-08 17:30:44', 16, 0, '', '2019-08-08 17:30:44');
INSERT INTO `access_log` VALUES (64474, '59.76.15652567289953911', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.172.123.131', '2019-08-08 17:32:09', 2, 0, '', '2019-08-08 17:32:09');
INSERT INTO `access_log` VALUES (64475, '59.77.15652567289953907', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.172.123.131', '2019-08-08 17:32:09', 12, 2001001000, '服务端发生异常', '2019-08-08 17:32:09');
INSERT INTO `access_log` VALUES (64476, '59.79.15652568249523925', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-08 17:33:45', 2, 0, '', '2019-08-08 17:33:45');
INSERT INTO `access_log` VALUES (64477, '59.74.15652568249523931', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-08 17:33:45', 13, 2001001000, '服务端发生异常', '2019-08-08 17:33:45');
INSERT INTO `access_log` VALUES (64478, '65.54.15652568414976553', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.115.220.39', '2019-08-08 17:34:01', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 17:34:02');
INSERT INTO `access_log` VALUES (64479, '66.51.15652568485811587', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18826277525', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-08 17:34:09', 115, 0, '', '2019-08-08 17:34:09');
INSERT INTO `access_log` VALUES (64480, '66.48.15652568654171579', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18826277525&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-08 17:34:25', 217, 0, '', '2019-08-08 17:34:26');
INSERT INTO `access_log` VALUES (64481, '59.78.15652568672363927', 194, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-08 17:34:27', 12, 0, '', '2019-08-08 17:34:27');
INSERT INTO `access_log` VALUES (64482, '59.80.15652568703803891', 194, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-08 17:34:30', 7, 0, '', '2019-08-08 17:34:30');
INSERT INTO `access_log` VALUES (64483, '59.74.15652568734133933', 194, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3854.3 Safari/537.36', '183.62.168.218', '2019-08-08 17:34:33', 7, 0, '', '2019-08-08 17:34:33');
INSERT INTO `access_log` VALUES (64484, '65.45.15652570326216649', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.178.174', '2019-08-08 17:37:13', 0, 1002001015, '账号未登陆', '2019-08-08 17:37:13');
INSERT INTO `access_log` VALUES (64485, '59.80.15652571260523895', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:38:46', 3, 0, '', '2019-08-08 17:38:46');
INSERT INTO `access_log` VALUES (64486, '59.71.15652571260523923', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:38:46', 9, 2001001000, '服务端发生异常', '2019-08-08 17:38:46');
INSERT INTO `access_log` VALUES (64487, '59.79.15652571309833931', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.206.178.77', '2019-08-08 17:38:51', 3, 0, '', '2019-08-08 17:38:51');
INSERT INTO `access_log` VALUES (64488, '59.76.15652571309833919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.206.178.77', '2019-08-08 17:38:51', 13, 2001001000, '服务端发生异常', '2019-08-08 17:38:51');
INSERT INTO `access_log` VALUES (64489, '64.85.15652571316344273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:38:52', 3, 0, '', '2019-08-08 17:38:52');
INSERT INTO `access_log` VALUES (64490, '64.80.15652571317184247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:38:52', 2, 0, '', '2019-08-08 17:38:52');
INSERT INTO `access_log` VALUES (64491, '64.84.15652571335324243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:38:54', 2, 0, '', '2019-08-08 17:38:54');
INSERT INTO `access_log` VALUES (64492, '64.82.15652571342544251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:38:54', 2, 0, '', '2019-08-08 17:38:54');
INSERT INTO `access_log` VALUES (64493, '64.78.15652571366354243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:38:57', 2, 0, '', '2019-08-08 17:38:57');
INSERT INTO `access_log` VALUES (64494, '64.81.15652571367684245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:38:57', 1, 0, '', '2019-08-08 17:38:57');
INSERT INTO `access_log` VALUES (64495, '59.77.15652571412533915', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.206.178.77', '2019-08-08 17:39:01', 3, 0, '', '2019-08-08 17:39:01');
INSERT INTO `access_log` VALUES (64496, '59.73.15652571412543929', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.206.178.77', '2019-08-08 17:39:01', 18, 2001001000, '服务端发生异常', '2019-08-08 17:39:01');
INSERT INTO `access_log` VALUES (64497, '64.76.15652571469374243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:07', 1, 0, '', '2019-08-08 17:39:07');
INSERT INTO `access_log` VALUES (64498, '64.83.15652571470564241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:07', 2, 0, '', '2019-08-08 17:39:07');
INSERT INTO `access_log` VALUES (64499, '64.77.15652571488494235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:09', 2, 0, '', '2019-08-08 17:39:09');
INSERT INTO `access_log` VALUES (64500, '64.85.15652571496154275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:10', 2, 0, '', '2019-08-08 17:39:10');
INSERT INTO `access_log` VALUES (64501, '64.80.15652571502984249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:10', 2, 0, '', '2019-08-08 17:39:10');
INSERT INTO `access_log` VALUES (64502, '64.84.15652571507544245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:11', 2, 0, '', '2019-08-08 17:39:11');
INSERT INTO `access_log` VALUES (64503, '59.78.15652571517463933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:12', 2, 0, '', '2019-08-08 17:39:12');
INSERT INTO `access_log` VALUES (64504, '59.75.15652571517463935', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:12', 12, 2001001000, '服务端发生异常', '2019-08-08 17:39:12');
INSERT INTO `access_log` VALUES (64505, '65.50.15652571589446663', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.206.178.77', '2019-08-08 17:39:19', 0, 1002001015, '账号未登陆', '2019-08-08 17:39:19');
INSERT INTO `access_log` VALUES (64506, '65.45.15652571589476651', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.206.178.77', '2019-08-08 17:39:19', 1, 1002001015, '账号未登陆', '2019-08-08 17:39:19');
INSERT INTO `access_log` VALUES (64507, '65.49.15652571589486649', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.206.178.77', '2019-08-08 17:39:19', 0, 1002001015, '账号未登陆', '2019-08-08 17:39:19');
INSERT INTO `access_log` VALUES (64508, '64.82.15652571590504253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:19', 2, 0, '', '2019-08-08 17:39:19');
INSERT INTO `access_log` VALUES (64509, '64.78.15652571591464245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:19', 2, 0, '', '2019-08-08 17:39:19');
INSERT INTO `access_log` VALUES (64510, '64.79.15652571625564249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:23', 2, 0, '', '2019-08-08 17:39:23');
INSERT INTO `access_log` VALUES (64511, '64.76.15652571626864245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:23', 2, 0, '', '2019-08-08 17:39:23');
INSERT INTO `access_log` VALUES (64512, '65.53.15652571640826637', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.206.178.77', '2019-08-08 17:39:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 17:39:24');
INSERT INTO `access_log` VALUES (64513, '64.83.15652571656404243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:26', 2, 0, '', '2019-08-08 17:39:26');
INSERT INTO `access_log` VALUES (64514, '64.77.15652571657694237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:26', 2, 0, '', '2019-08-08 17:39:26');
INSERT INTO `access_log` VALUES (64515, '64.85.15652571677024277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:28', 2, 0, '', '2019-08-08 17:39:28');
INSERT INTO `access_log` VALUES (64516, '64.80.15652571678614251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '183.131.110.63', '2019-08-08 17:39:28', 2, 0, '', '2019-08-08 17:39:28');
INSERT INTO `access_log` VALUES (64517, '65.3607.15652571808728461', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.206.178.77', '2019-08-08 17:39:41', 80, 0, '', '2019-08-08 17:39:41');
INSERT INTO `access_log` VALUES (64518, '65.54.15652571812106559', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.206.178.77', '2019-08-08 17:39:41', 9, 0, '', '2019-08-08 17:39:41');
INSERT INTO `access_log` VALUES (64519, '65.46.15652571812136697', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.206.178.77', '2019-08-08 17:39:41', 9, 2001001000, '服务端发生异常', '2019-08-08 17:39:41');
INSERT INTO `access_log` VALUES (64520, '65.52.15652571812176693', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '115.206.178.77', '2019-08-08 17:39:41', 7, 0, '', '2019-08-08 17:39:41');
INSERT INTO `access_log` VALUES (64521, '59.75.15652578841733945', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.230.34', '2019-08-08 17:51:24', 3, 0, '', '2019-08-08 17:51:24');
INSERT INTO `access_log` VALUES (64522, '59.80.15652578841743907', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.230.34', '2019-08-08 17:51:24', 11, 2001001000, '服务端发生异常', '2019-08-08 17:51:24');
INSERT INTO `access_log` VALUES (64523, '64.85.15652578887464287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.230.34', '2019-08-08 17:51:29', 3, 0, '', '2019-08-08 17:51:29');
INSERT INTO `access_log` VALUES (64524, '64.80.15652578888894261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.230.34', '2019-08-08 17:51:29', 2, 0, '', '2019-08-08 17:51:29');
INSERT INTO `access_log` VALUES (64525, '64.84.15652578898444257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.230.34', '2019-08-08 17:51:30', 2, 0, '', '2019-08-08 17:51:30');
INSERT INTO `access_log` VALUES (64526, '64.82.15652578903774265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.230.34', '2019-08-08 17:51:30', 2, 0, '', '2019-08-08 17:51:30');
INSERT INTO `access_log` VALUES (64527, '59.71.15652578913143935', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.230.34', '2019-08-08 17:51:31', 9, 0, '', '2019-08-08 17:51:31');
INSERT INTO `access_log` VALUES (64528, '59.74.15652578913143949', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '113.110.230.34', '2019-08-08 17:51:31', 12, 2001001000, '服务端发生异常', '2019-08-08 17:51:31');
INSERT INTO `access_log` VALUES (64529, '59.76.15652579018463931', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.202.111', '2019-08-08 17:51:42', 3, 0, '', '2019-08-08 17:51:42');
INSERT INTO `access_log` VALUES (64530, '59.77.15652579018473927', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.202.111', '2019-08-08 17:51:42', 12, 2001001000, '服务端发生异常', '2019-08-08 17:51:42');
INSERT INTO `access_log` VALUES (64531, '65.46.15652579125466707', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.202.111', '2019-08-08 17:51:53', 1, 1002001015, '账号未登陆', '2019-08-08 17:51:53');
INSERT INTO `access_log` VALUES (64532, '65.54.15652579125456569', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.202.111', '2019-08-08 17:51:53', 1, 1002001015, '账号未登陆', '2019-08-08 17:51:53');
INSERT INTO `access_log` VALUES (64533, '65.45.15652579125506663', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.202.111', '2019-08-08 17:51:53', 1, 1002001015, '账号未登陆', '2019-08-08 17:51:53');
INSERT INTO `access_log` VALUES (64534, '65.49.15652579141686661', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.202.111', '2019-08-08 17:51:54', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 17:51:54');
INSERT INTO `access_log` VALUES (64535, '65.51.15652579178406741', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '113.104.202.111', '2019-08-08 17:51:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 17:51:58');
INSERT INTO `access_log` VALUES (64536, '65.46.15652593338896727', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.108.74.26', '2019-08-08 18:15:34', 1, 1002001015, '账号未登陆', '2019-08-08 18:15:34');
INSERT INTO `access_log` VALUES (64537, '65.45.15652593338886683', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.108.74.26', '2019-08-08 18:15:34', 1, 1002001015, '账号未登陆', '2019-08-08 18:15:34');
INSERT INTO `access_log` VALUES (64538, '65.54.15652593338916589', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.108.74.26', '2019-08-08 18:15:34', 0, 1002001015, '账号未登陆', '2019-08-08 18:15:34');
INSERT INTO `access_log` VALUES (64539, '65.50.15652593368196695', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.108.74.26', '2019-08-08 18:15:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 18:15:37');
INSERT INTO `access_log` VALUES (64540, '65.3607.15652599909358501', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:26:31', 1, 1002001015, '账号未登陆', '2019-08-08 18:26:31');
INSERT INTO `access_log` VALUES (64541, '65.52.15652599909376733', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:26:31', 0, 1002001015, '账号未登陆', '2019-08-08 18:26:31');
INSERT INTO `access_log` VALUES (64542, '65.45.15652599909386693', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:26:31', 0, 1002001015, '账号未登陆', '2019-08-08 18:26:31');
INSERT INTO `access_log` VALUES (64543, '65.46.15652599936236737', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:26:34', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 18:26:34');
INSERT INTO `access_log` VALUES (64544, '65.50.15652600000036705', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:26:40', 178, 0, '', '2019-08-08 18:26:40');
INSERT INTO `access_log` VALUES (64545, '65.49.15652600004536691', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:26:40', 10, 0, '', '2019-08-08 18:26:40');
INSERT INTO `access_log` VALUES (64546, '65.51.15652600004566771', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:26:40', 10, 2001001000, '服务端发生异常', '2019-08-08 18:26:40');
INSERT INTO `access_log` VALUES (64547, '65.53.15652600004606679', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:26:40', 9, 0, '', '2019-08-08 18:26:40');
INSERT INTO `access_log` VALUES (64548, '59.78.15652600373373973', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:27:17', 10, 0, '', '2019-08-08 18:27:17');
INSERT INTO `access_log` VALUES (64549, '59.75.15652600373403975', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:27:17', 12, 2001001000, '服务端发生异常', '2019-08-08 18:27:17');
INSERT INTO `access_log` VALUES (64550, '64.83.15652600434904283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:27:23', 11, 0, '', '2019-08-08 18:27:24');
INSERT INTO `access_log` VALUES (64551, '64.77.15652600436404277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:27:24', 2, 0, '', '2019-08-08 18:27:24');
INSERT INTO `access_log` VALUES (64552, '64.85.15652600452944317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:27:25', 3, 0, '', '2019-08-08 18:27:25');
INSERT INTO `access_log` VALUES (64553, '64.80.15652600462464291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:27:26', 3, 0, '', '2019-08-08 18:27:26');
INSERT INTO `access_log` VALUES (64554, '64.84.15652600468224287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '112.31.210.251', '2019-08-08 18:27:27', 2, 0, '', '2019-08-08 18:27:27');
INSERT INTO `access_log` VALUES (64555, '59.77.15652602573773959', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.24', '2019-08-08 18:30:57', 4, 0, '', '2019-08-08 18:30:57');
INSERT INTO `access_log` VALUES (64556, '59.73.15652602573773973', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.25', '2019-08-08 18:30:57', 19, 2001001000, '服务端发生异常', '2019-08-08 18:30:57');
INSERT INTO `access_log` VALUES (64557, '64.76.15652602645114289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.24', '2019-08-08 18:31:05', 3, 0, '', '2019-08-08 18:31:05');
INSERT INTO `access_log` VALUES (64558, '64.83.15652602646664287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.24', '2019-08-08 18:31:05', 2, 0, '', '2019-08-08 18:31:05');
INSERT INTO `access_log` VALUES (64559, '64.85.15652602664284321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.24', '2019-08-08 18:31:06', 2, 0, '', '2019-08-08 18:31:06');
INSERT INTO `access_log` VALUES (64560, '64.80.15652602671364295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.24', '2019-08-08 18:31:07', 2, 0, '', '2019-08-08 18:31:07');
INSERT INTO `access_log` VALUES (64561, '64.84.15652602673774291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.24', '2019-08-08 18:31:07', 2, 0, '', '2019-08-08 18:31:07');
INSERT INTO `access_log` VALUES (64562, '64.82.15652602675784299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.24', '2019-08-08 18:31:08', 2, 0, '', '2019-08-08 18:31:08');
INSERT INTO `access_log` VALUES (64563, '64.78.15652602679194291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.24', '2019-08-08 18:31:08', 2, 0, '', '2019-08-08 18:31:08');
INSERT INTO `access_log` VALUES (64564, '64.81.15652602683324293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.24', '2019-08-08 18:31:08', 1, 0, '', '2019-08-08 18:31:08');
INSERT INTO `access_log` VALUES (64565, '59.75.15652602692843979', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.24', '2019-08-08 18:31:09', 2, 0, '', '2019-08-08 18:31:09');
INSERT INTO `access_log` VALUES (64566, '59.78.15652602692853977', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.25', '2019-08-08 18:31:09', 12, 2001001000, '服务端发生异常', '2019-08-08 18:31:09');
INSERT INTO `access_log` VALUES (64567, '64.79.15652602719584295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.24', '2019-08-08 18:31:12', 2, 0, '', '2019-08-08 18:31:12');
INSERT INTO `access_log` VALUES (64568, '64.76.15652602721174291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.24', '2019-08-08 18:31:12', 1, 0, '', '2019-08-08 18:31:12');
INSERT INTO `access_log` VALUES (64569, '59.80.15652602727543941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.24', '2019-08-08 18:31:13', 2, 0, '', '2019-08-08 18:31:13');
INSERT INTO `access_log` VALUES (64570, '59.74.15652602727553983', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.131.110.25', '2019-08-08 18:31:13', 12, 2001001000, '服务端发生异常', '2019-08-08 18:31:13');
INSERT INTO `access_log` VALUES (64571, '59.77.15652628681633995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.147.197', '2019-08-08 19:14:28', 11, 0, '', '2019-08-08 19:14:28');
INSERT INTO `access_log` VALUES (64572, '59.73.15652628681724009', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.147.197', '2019-08-08 19:14:28', 17, 2001001000, '服务端发生异常', '2019-08-08 19:14:28');
INSERT INTO `access_log` VALUES (64573, '64.84.15652628787224327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.147.197', '2019-08-08 19:14:39', 133, 0, '', '2019-08-08 19:14:39');
INSERT INTO `access_log` VALUES (64574, '64.82.15652628797124335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.147.197', '2019-08-08 19:14:40', 3, 0, '', '2019-08-08 19:14:40');
INSERT INTO `access_log` VALUES (64575, '64.78.15652628815124327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.147.197', '2019-08-08 19:14:42', 2, 0, '', '2019-08-08 19:14:42');
INSERT INTO `access_log` VALUES (64576, '59.75.15652628840634015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.147.197', '2019-08-08 19:14:44', 3, 0, '', '2019-08-08 19:14:44');
INSERT INTO `access_log` VALUES (64577, '65.45.15652673727226793', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '119.123.133.93', '2019-08-08 20:29:33', 1, 1002001015, '账号未登陆', '2019-08-08 20:29:33');
INSERT INTO `access_log` VALUES (64578, '65.52.15652673727226833', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '119.123.133.93', '2019-08-08 20:29:33', 1, 1002001015, '账号未登陆', '2019-08-08 20:29:33');
INSERT INTO `access_log` VALUES (64579, '65.3607.15652673730148601', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '119.123.133.93', '2019-08-08 20:29:33', 0, 1002001015, '账号未登陆', '2019-08-08 20:29:33');
INSERT INTO `access_log` VALUES (64580, '65.51.15652674342876871', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '119.123.133.93', '2019-08-08 20:30:34', 75, 0, '', '2019-08-08 20:30:34');
INSERT INTO `access_log` VALUES (64581, '65.53.15652674346306779', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '119.123.133.93', '2019-08-08 20:30:35', 27, 0, '', '2019-08-08 20:30:35');
INSERT INTO `access_log` VALUES (64582, '65.45.15652674346366795', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '119.123.133.93', '2019-08-08 20:30:35', 27, 0, '', '2019-08-08 20:30:35');
INSERT INTO `access_log` VALUES (64583, '65.47.15652674346326771', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '119.123.133.93', '2019-08-08 20:30:35', 31, 2001001000, '服务端发生异常', '2019-08-08 20:30:35');
INSERT INTO `access_log` VALUES (64584, '59.80.15652693626824063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '113.128.96.177', '2019-08-08 21:02:43', 12, 0, '', '2019-08-08 21:02:43');
INSERT INTO `access_log` VALUES (64585, '59.71.15652693626834091', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.75 Safari/537.36', '113.128.96.177', '2019-08-08 21:02:43', 27, 2001001000, '服务端发生异常', '2019-08-08 21:02:43');
INSERT INTO `access_log` VALUES (64586, '59.73.15652699916924105', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.244.121.150', '2019-08-08 21:13:12', 3, 0, '', '2019-08-08 21:13:12');
INSERT INTO `access_log` VALUES (64587, '59.77.15652699916944091', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.244.121.150', '2019-08-08 21:13:12', 19, 2001001000, '服务端发生异常', '2019-08-08 21:13:12');
INSERT INTO `access_log` VALUES (64588, '65.45.15652747393696893', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.131.242.122', '2019-08-08 22:32:19', 0, 1002001015, '账号未登陆', '2019-08-08 22:32:19');
INSERT INTO `access_log` VALUES (64589, '65.53.15652747393696877', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.131.242.122', '2019-08-08 22:32:19', 0, 1002001015, '账号未登陆', '2019-08-08 22:32:19');
INSERT INTO `access_log` VALUES (64590, '65.47.15652747393716869', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.131.242.122', '2019-08-08 22:32:19', 1, 1002001015, '账号未登陆', '2019-08-08 22:32:19');
INSERT INTO `access_log` VALUES (64591, '65.52.15652747410536933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.131.242.122', '2019-08-08 22:32:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-08 22:32:21');
INSERT INTO `access_log` VALUES (64592, '65.46.15652747482976937', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.131.242.122', '2019-08-08 22:32:28', 78, 0, '', '2019-08-08 22:32:28');
INSERT INTO `access_log` VALUES (64593, '65.54.15652747485876799', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.131.242.122', '2019-08-08 22:32:29', 12, 0, '', '2019-08-08 22:32:29');
INSERT INTO `access_log` VALUES (64594, '65.50.15652747485916905', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.131.242.122', '2019-08-08 22:32:29', 10, 0, '', '2019-08-08 22:32:29');
INSERT INTO `access_log` VALUES (64595, '65.49.15652747485926891', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.131.242.122', '2019-08-08 22:32:29', 11, 2001001000, '服务端发生异常', '2019-08-08 22:32:29');
INSERT INTO `access_log` VALUES (64596, '65.53.15652747860996879', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.131.242.122', '2019-08-08 22:33:06', 8, 0, '', '2019-08-08 22:33:06');
INSERT INTO `access_log` VALUES (64597, '65.47.15652747861006871', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.131.242.122', '2019-08-08 22:33:06', 8, 0, '', '2019-08-08 22:33:06');
INSERT INTO `access_log` VALUES (64598, '65.52.15652747861026935', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.131.242.122', '2019-08-08 22:33:06', 8, 2001001000, '服务端发生异常', '2019-08-08 22:33:06');
INSERT INTO `access_log` VALUES (64599, '59.77.15652770217444185', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.131.242.122', '2019-08-08 23:10:22', 10, 0, '', '2019-08-08 23:10:22');
INSERT INTO `access_log` VALUES (64600, '59.72.15652770217454195', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.131.242.122', '2019-08-08 23:10:22', 19, 2001001000, '服务端发生异常', '2019-08-08 23:10:22');
INSERT INTO `access_log` VALUES (64601, '59.78.15652770331034203', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.131.242.122', '2019-08-08 23:10:33', 2, 0, '', '2019-08-08 23:10:33');
INSERT INTO `access_log` VALUES (64602, '59.75.15652770331034205', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.131.242.122', '2019-08-08 23:10:33', 17, 2001001000, '服务端发生异常', '2019-08-08 23:10:33');
INSERT INTO `access_log` VALUES (64603, '64.84.15652770664124515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.131.242.122', '2019-08-08 23:11:06', 69, 0, '', '2019-08-08 23:11:06');
INSERT INTO `access_log` VALUES (64604, '64.82.15652770665814525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.131.242.122', '2019-08-08 23:11:07', 2, 0, '', '2019-08-08 23:11:07');
INSERT INTO `access_log` VALUES (64605, '64.81.15652770870074519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:11:27', 2, 0, '', '2019-08-08 23:11:27');
INSERT INTO `access_log` VALUES (64606, '64.79.15652770875284521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:11:28', 2, 0, '', '2019-08-08 23:11:28');
INSERT INTO `access_log` VALUES (64607, '64.76.15652770878454517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:11:28', 2, 0, '', '2019-08-08 23:11:28');
INSERT INTO `access_log` VALUES (64608, '64.83.15652770889954515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:11:29', 3, 0, '', '2019-08-08 23:11:29');
INSERT INTO `access_log` VALUES (64609, '59.76.15652770903174191', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:11:30', 2, 0, '', '2019-08-08 23:11:30');
INSERT INTO `access_log` VALUES (64610, '59.73.15652770903184201', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:11:30', 14, 2001001000, '服务端发生异常', '2019-08-08 23:11:30');
INSERT INTO `access_log` VALUES (64611, '59.72.15652771017794197', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:11:42', 2, 0, '', '2019-08-08 23:11:42');
INSERT INTO `access_log` VALUES (64612, '59.75.15652771017804207', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:11:42', 19, 2001001000, '服务端发生异常', '2019-08-08 23:11:42');
INSERT INTO `access_log` VALUES (64613, '59.74.15652771097554211', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:11:50', 2, 0, '', '2019-08-08 23:11:50');
INSERT INTO `access_log` VALUES (64614, '59.80.15652771097554169', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:11:50', 12, 2001001000, '服务端发生异常', '2019-08-08 23:11:50');
INSERT INTO `access_log` VALUES (64615, '64.80.15652771227834523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:03', 2, 0, '', '2019-08-08 23:12:03');
INSERT INTO `access_log` VALUES (64616, '64.84.15652771229224517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:03', 2, 0, '', '2019-08-08 23:12:03');
INSERT INTO `access_log` VALUES (64617, '64.82.15652771248104527', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:05', 2, 0, '', '2019-08-08 23:12:05');
INSERT INTO `access_log` VALUES (64618, '64.81.15652771258074521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:06', 2, 0, '', '2019-08-08 23:12:06');
INSERT INTO `access_log` VALUES (64619, '64.79.15652771269014523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:07', 2, 0, '', '2019-08-08 23:12:07');
INSERT INTO `access_log` VALUES (64620, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:08', 6, 0, '', '2019-08-08 23:12:08');
INSERT INTO `access_log` VALUES (64621, '64.76.15652771278104519', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:08', 2, 0, '', '2019-08-08 23:12:08');
INSERT INTO `access_log` VALUES (64622, '64.83.15652771299344517', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:10', 2, 0, '', '2019-08-08 23:12:10');
INSERT INTO `access_log` VALUES (64623, '64.77.15652771300594511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:10', 2, 0, '', '2019-08-08 23:12:10');
INSERT INTO `access_log` VALUES (64624, '64.85.15652771312774551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:11', 2, 0, '', '2019-08-08 23:12:11');
INSERT INTO `access_log` VALUES (64625, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:11', 5, 0, '', '2019-08-08 23:12:11');
INSERT INTO `access_log` VALUES (64626, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:14', 5, 0, '', '2019-08-08 23:12:14');
INSERT INTO `access_log` VALUES (64627, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:15', 12, 0, '', '2019-08-08 23:12:15');
INSERT INTO `access_log` VALUES (64628, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:16', 5, 0, '', '2019-08-08 23:12:16');
INSERT INTO `access_log` VALUES (64629, '64.80.15652771372784525', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:17', 9, 0, '', '2019-08-08 23:12:17');
INSERT INTO `access_log` VALUES (64630, '64.81.15652771767034523', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '222.131.242.122', '2019-08-08 23:12:57', 6, 0, '', '2019-08-08 23:12:57');
INSERT INTO `access_log` VALUES (64631, '65.50.15652800912426977', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '112.96.179.46', '2019-08-09 00:01:31', 0, 1002001015, '账号未登陆', '2019-08-09 00:01:31');
INSERT INTO `access_log` VALUES (64632, '65.51.15652800912427043', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '112.96.179.46', '2019-08-09 00:01:31', 0, 1002001015, '账号未登陆', '2019-08-09 00:01:31');
INSERT INTO `access_log` VALUES (64633, '65.45.15652800912426967', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '112.96.179.46', '2019-08-09 00:01:31', 0, 1002001015, '账号未登陆', '2019-08-09 00:01:31');
INSERT INTO `access_log` VALUES (64634, '65.52.15652800962207007', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '112.96.179.46', '2019-08-09 00:01:36', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 00:01:36');
INSERT INTO `access_log` VALUES (64635, '65.53.15652801033596951', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '112.96.179.46', '2019-08-09 00:01:43', 54, 0, '', '2019-08-09 00:01:43');
INSERT INTO `access_log` VALUES (64636, '65.46.15652801052627011', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '112.96.179.46', '2019-08-09 00:01:45', 16, 0, '', '2019-08-09 00:01:45');
INSERT INTO `access_log` VALUES (64637, '65.3607.15652801052628775', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '112.96.179.46', '2019-08-09 00:01:45', 16, 0, '', '2019-08-09 00:01:45');
INSERT INTO `access_log` VALUES (64638, '65.49.15652801052646965', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '112.96.179.46', '2019-08-09 00:01:45', 16, 2001001000, '服务端发生异常', '2019-08-09 00:01:45');
INSERT INTO `access_log` VALUES (64639, '65.53.15652806440516959', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '112.96.179.46', '2019-08-09 00:10:44', 12, 0, '', '2019-08-09 00:10:44');
INSERT INTO `access_log` VALUES (64640, '65.49.15652806440526973', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '112.96.179.46', '2019-08-09 00:10:44', 14, 2001001000, '服务端发生异常', '2019-08-09 00:10:44');
INSERT INTO `access_log` VALUES (64641, '65.3607.15652806440608783', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '112.96.179.46', '2019-08-09 00:10:44', 10, 0, '', '2019-08-09 00:10:44');
INSERT INTO `access_log` VALUES (64642, '59.74.15652908743694395', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '106.57.78.218', '2019-08-09 03:01:14', 10, 0, '', '2019-08-09 03:01:14');
INSERT INTO `access_log` VALUES (64643, '59.78.15652908743684389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Mobile/15E148 Safari/604.1', '106.57.78.218', '2019-08-09 03:01:14', 34, 2001001000, '服务端发生异常', '2019-08-09 03:01:14');
INSERT INTO `access_log` VALUES (64644, '65.46.15653139844907465', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '223.104.210.213', '2019-08-09 09:26:24', 1, 0, '', '2019-08-09 09:26:25');
INSERT INTO `access_log` VALUES (64645, '65.52.15653140540257465', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.50.109.250', '2019-08-09 09:27:34', 0, 1002001015, '账号未登陆', '2019-08-09 09:27:34');
INSERT INTO `access_log` VALUES (64646, '65.49.15653140540257421', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.50.109.250', '2019-08-09 09:27:34', 0, 1002001015, '账号未登陆', '2019-08-09 09:27:34');
INSERT INTO `access_log` VALUES (64647, '65.54.15653140540257331', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.50.109.250', '2019-08-09 09:27:34', 0, 1002001015, '账号未登陆', '2019-08-09 09:27:34');
INSERT INTO `access_log` VALUES (64648, '65.3607.15653140664739229', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.50.109.250', '2019-08-09 09:27:46', 64, 0, '', '2019-08-09 09:27:47');
INSERT INTO `access_log` VALUES (64649, '65.51.15653140668117503', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.50.109.250', '2019-08-09 09:27:47', 15, 0, '', '2019-08-09 09:27:47');
INSERT INTO `access_log` VALUES (64650, '65.46.15653140668007467', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.50.109.250', '2019-08-09 09:27:47', 26, 0, '', '2019-08-09 09:27:47');
INSERT INTO `access_log` VALUES (64651, '65.53.15653140668147405', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '61.50.109.250', '2019-08-09 09:27:47', 13, 2001001000, '服务端发生异常', '2019-08-09 09:27:47');
INSERT INTO `access_log` VALUES (64652, '65.54.15653141107707333', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '23.91.96.2', '2019-08-09 09:28:31', 1, 1002001015, '账号未登陆', '2019-08-09 09:28:31');
INSERT INTO `access_log` VALUES (64653, '65.52.15653141107697467', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '23.91.96.2', '2019-08-09 09:28:31', 1, 1002001015, '账号未登陆', '2019-08-09 09:28:31');
INSERT INTO `access_log` VALUES (64654, '65.50.15653141107807435', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '23.91.96.2', '2019-08-09 09:28:31', 1, 1002001015, '账号未登陆', '2019-08-09 09:28:31');
INSERT INTO `access_log` VALUES (64655, '65.47.15653141930877405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '23.91.96.2', '2019-08-09 09:29:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 09:29:53');
INSERT INTO `access_log` VALUES (64656, '65.50.15653142144447437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '23.91.96.2', '2019-08-09 09:30:14', 102, 0, '', '2019-08-09 09:30:15');
INSERT INTO `access_log` VALUES (64657, '65.3607.15653142160879233', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '23.91.96.2', '2019-08-09 09:30:16', 69, 0, '', '2019-08-09 09:30:16');
INSERT INTO `access_log` VALUES (64658, '65.51.15653142160907507', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '23.91.96.2', '2019-08-09 09:30:16', 66, 0, '', '2019-08-09 09:30:16');
INSERT INTO `access_log` VALUES (64659, '65.52.15653142160827469', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '23.91.96.2', '2019-08-09 09:30:16', 75, 2001001000, '服务端发生异常', '2019-08-09 09:30:16');
INSERT INTO `access_log` VALUES (64660, '59.76.15653144511164691', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.37.134.136', '2019-08-09 09:34:11', 10, 0, '', '2019-08-09 09:34:11');
INSERT INTO `access_log` VALUES (64661, '59.79.15653144511164703', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.37.134.136', '2019-08-09 09:34:11', 27, 2001001000, '服务端发生异常', '2019-08-09 09:34:11');
INSERT INTO `access_log` VALUES (64662, '64.80.15653144537975023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.37.134.136', '2019-08-09 09:34:14', 13, 0, '', '2019-08-09 09:34:14');
INSERT INTO `access_log` VALUES (64663, '64.84.15653144544705017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.37.134.136', '2019-08-09 09:34:14', 4, 0, '', '2019-08-09 09:34:14');
INSERT INTO `access_log` VALUES (64664, '64.82.15653144556265027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.37.134.136', '2019-08-09 09:34:16', 2, 0, '', '2019-08-09 09:34:16');
INSERT INTO `access_log` VALUES (64665, '64.78.15653144563025019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.37.134.136', '2019-08-09 09:34:16', 2, 0, '', '2019-08-09 09:34:16');
INSERT INTO `access_log` VALUES (64666, '59.73.15653144569164701', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.37.134.136', '2019-08-09 09:34:17', 3, 0, '', '2019-08-09 09:34:17');
INSERT INTO `access_log` VALUES (64667, '59.77.15653144569164687', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '120.37.134.136', '2019-08-09 09:34:17', 18, 2001001000, '服务端发生异常', '2019-08-09 09:34:17');
INSERT INTO `access_log` VALUES (64668, '59.73.15653148662904707', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:06', 3, 0, '', '2019-08-09 09:41:06');
INSERT INTO `access_log` VALUES (64669, '59.77.15653148662904693', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:06', 13, 2001001000, '服务端发生异常', '2019-08-09 09:41:06');
INSERT INTO `access_log` VALUES (64670, '64.82.15653148687115033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:09', 2, 0, '', '2019-08-09 09:41:09');
INSERT INTO `access_log` VALUES (64671, '64.78.15653148688285025', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:09', 3, 0, '', '2019-08-09 09:41:09');
INSERT INTO `access_log` VALUES (64672, '64.81.15653148697165027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:10', 2, 0, '', '2019-08-09 09:41:10');
INSERT INTO `access_log` VALUES (64673, '65.54.15653148890487345', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:29', 0, 1002001015, '账号未登陆', '2019-08-09 09:41:29');
INSERT INTO `access_log` VALUES (64674, '65.50.15653148890807447', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:29', 0, 1002001015, '账号未登陆', '2019-08-09 09:41:29');
INSERT INTO `access_log` VALUES (64675, '65.51.15653148890807517', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:29', 0, 1002001015, '账号未登陆', '2019-08-09 09:41:29');
INSERT INTO `access_log` VALUES (64676, '65.52.15653148913027479', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 09:41:31');
INSERT INTO `access_log` VALUES (64677, '65.46.15653149018927481', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yundaoyuanma&password=yundaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:42', 5, 1002002000, '账号不存在', '2019-08-09 09:41:42');
INSERT INTO `access_log` VALUES (64678, '65.53.15653149047347419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 09:41:45');
INSERT INTO `access_log` VALUES (64679, '65.45.15653149058377437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 09:41:46');
INSERT INTO `access_log` VALUES (64680, '65.47.15653149062607417', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 09:41:46');
INSERT INTO `access_log` VALUES (64681, '65.49.15653149068877437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:47', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 09:41:47');
INSERT INTO `access_log` VALUES (64682, '65.50.15653149182587449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:58', 85, 0, '', '2019-08-09 09:41:58');
INSERT INTO `access_log` VALUES (64683, '65.52.15653149187157481', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:59', 9, 0, '', '2019-08-09 09:41:59');
INSERT INTO `access_log` VALUES (64684, '65.51.15653149187157519', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:59', 12, 2001001000, '服务端发生异常', '2019-08-09 09:41:59');
INSERT INTO `access_log` VALUES (64685, '65.3607.15653149187269245', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.169.57.154', '2019-08-09 09:41:59', 10, 0, '', '2019-08-09 09:41:59');
INSERT INTO `access_log` VALUES (64686, '65.47.15653163739547437', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.205.248', '2019-08-09 10:06:14', 1, 1002001015, '账号未登陆', '2019-08-09 10:06:14');
INSERT INTO `access_log` VALUES (64687, '65.54.15653163739547367', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.205.248', '2019-08-09 10:06:14', 1, 1002001015, '账号未登陆', '2019-08-09 10:06:14');
INSERT INTO `access_log` VALUES (64688, '65.51.15653163739657541', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.118.205.248', '2019-08-09 10:06:14', 0, 1002001015, '账号未登陆', '2019-08-09 10:06:14');
INSERT INTO `access_log` VALUES (64689, '65.50.15653168562837477', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.101.138', '2019-08-09 10:14:16', 0, 1002001015, '账号未登陆', '2019-08-09 10:14:16');
INSERT INTO `access_log` VALUES (64690, '65.45.15653168562847467', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.101.170', '2019-08-09 10:14:16', 0, 1002001015, '账号未登陆', '2019-08-09 10:14:16');
INSERT INTO `access_log` VALUES (64691, '65.49.15653168562887465', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.101.170', '2019-08-09 10:14:16', 0, 1002001015, '账号未登陆', '2019-08-09 10:14:16');
INSERT INTO `access_log` VALUES (64692, '65.53.15653170903387453', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.101.138', '2019-08-09 10:18:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 10:18:10');
INSERT INTO `access_log` VALUES (64693, '65.49.15653171093487469', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.101.138', '2019-08-09 10:18:29', 854, 0, '', '2019-08-09 10:18:30');
INSERT INTO `access_log` VALUES (64694, '65.45.15653171104897471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.101.138', '2019-08-09 10:18:30', 9, 0, '', '2019-08-09 10:18:30');
INSERT INTO `access_log` VALUES (64695, '65.51.15653171104917553', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.101.138', '2019-08-09 10:18:30', 11, 2001001000, '服务端发生异常', '2019-08-09 10:18:31');
INSERT INTO `access_log` VALUES (64696, '65.47.15653171104937449', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.101.138', '2019-08-09 10:18:30', 10, 0, '', '2019-08-09 10:18:31');
INSERT INTO `access_log` VALUES (64697, '65.45.15653175257777477', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.101.170', '2019-08-09 10:25:26', 10, 0, '', '2019-08-09 10:25:26');
INSERT INTO `access_log` VALUES (64698, '65.54.15653175257807385', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.101.170', '2019-08-09 10:25:26', 9, 0, '', '2019-08-09 10:25:26');
INSERT INTO `access_log` VALUES (64699, '65.47.15653175257807455', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.101.170', '2019-08-09 10:25:26', 10, 2001001000, '服务端发生异常', '2019-08-09 10:25:26');
INSERT INTO `access_log` VALUES (64700, '65.52.15653175354047519', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.101.170', '2019-08-09 10:25:35', 9, 0, '', '2019-08-09 10:25:35');
INSERT INTO `access_log` VALUES (64701, '65.46.15653175354127523', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.101.170', '2019-08-09 10:25:35', 8, 0, '', '2019-08-09 10:25:35');
INSERT INTO `access_log` VALUES (64702, '65.3607.15653175354129285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.35.101.170', '2019-08-09 10:25:35', 8, 2001001000, '服务端发生异常', '2019-08-09 10:25:35');
INSERT INTO `access_log` VALUES (64703, '65.47.15653186326957471', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '182.150.24.10', '2019-08-09 10:43:53', 1, 1002001015, '账号未登陆', '2019-08-09 10:43:53');
INSERT INTO `access_log` VALUES (64704, '65.51.15653186326947575', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '182.150.24.10', '2019-08-09 10:43:53', 0, 1002001015, '账号未登陆', '2019-08-09 10:43:53');
INSERT INTO `access_log` VALUES (64705, '65.54.15653186326957401', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '182.150.24.10', '2019-08-09 10:43:53', 0, 1002001015, '账号未登陆', '2019-08-09 10:43:53');
INSERT INTO `access_log` VALUES (64706, '65.3607.15653186424689301', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '182.150.24.10', '2019-08-09 10:44:02', 82, 0, '', '2019-08-09 10:44:03');
INSERT INTO `access_log` VALUES (64707, '65.53.15653186432087477', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '182.150.24.10', '2019-08-09 10:44:03', 9, 0, '', '2019-08-09 10:44:03');
INSERT INTO `access_log` VALUES (64708, '65.52.15653186432087535', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '182.150.24.10', '2019-08-09 10:44:03', 11, 0, '', '2019-08-09 10:44:03');
INSERT INTO `access_log` VALUES (64709, '65.46.15653186432087539', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '182.150.24.10', '2019-08-09 10:44:03', 11, 2001001000, '服务端发生异常', '2019-08-09 10:44:03');
INSERT INTO `access_log` VALUES (64710, '65.54.15653188142577405', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.193.68.239', '2019-08-09 10:46:54', 1, 1002001015, '账号未登陆', '2019-08-09 10:46:54');
INSERT INTO `access_log` VALUES (64711, '65.51.15653188142597579', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.193.68.239', '2019-08-09 10:46:54', 0, 1002001015, '账号未登陆', '2019-08-09 10:46:54');
INSERT INTO `access_log` VALUES (64712, '65.47.15653188142657475', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.193.68.239', '2019-08-09 10:46:54', 0, 1002001015, '账号未登陆', '2019-08-09 10:46:54');
INSERT INTO `access_log` VALUES (64713, '65.45.15653188167637497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.193.68.239', '2019-08-09 10:46:57', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 10:46:57');
INSERT INTO `access_log` VALUES (64714, '65.3607.15653188202249305', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.193.68.239', '2019-08-09 10:47:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 10:47:00');
INSERT INTO `access_log` VALUES (64715, '65.46.15653188526117543', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.193.68.239', '2019-08-09 10:47:33', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 10:47:33');
INSERT INTO `access_log` VALUES (64716, '65.53.15653189401167483', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.174.187.130', '2019-08-09 10:49:00', 1, 1002001015, '账号未登陆', '2019-08-09 10:49:00');
INSERT INTO `access_log` VALUES (64717, '65.3607.15653189401159307', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.57.34.6', '2019-08-09 10:49:00', 0, 1002001015, '账号未登陆', '2019-08-09 10:49:00');
INSERT INTO `access_log` VALUES (64718, '65.52.15653189401167541', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.57.34.6', '2019-08-09 10:49:00', 0, 1002001015, '账号未登陆', '2019-08-09 10:49:00');
INSERT INTO `access_log` VALUES (64719, '65.46.15653189437947545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.57.34.6', '2019-08-09 10:49:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 10:49:04');
INSERT INTO `access_log` VALUES (64720, '65.50.15653189488977511', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.57.34.6', '2019-08-09 10:49:09', 178, 0, '', '2019-08-09 10:49:09');
INSERT INTO `access_log` VALUES (64721, '65.47.15653189499567479', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.174.187.130', '2019-08-09 10:49:10', 8, 0, '', '2019-08-09 10:49:10');
INSERT INTO `access_log` VALUES (64722, '65.54.15653189499547409', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.174.187.130', '2019-08-09 10:49:10', 10, 0, '', '2019-08-09 10:49:10');
INSERT INTO `access_log` VALUES (64723, '65.51.15653189499557583', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.57.34.6', '2019-08-09 10:49:10', 10, 2001001000, '服务端发生异常', '2019-08-09 10:49:10');
INSERT INTO `access_log` VALUES (64724, '65.52.15653189585397543', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.57.34.6', '2019-08-09 10:49:19', 8, 0, '', '2019-08-09 10:49:19');
INSERT INTO `access_log` VALUES (64725, '65.45.15653189585397501', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.174.187.130', '2019-08-09 10:49:19', 10, 0, '', '2019-08-09 10:49:19');
INSERT INTO `access_log` VALUES (64726, '65.53.15653189585397485', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '58.57.34.6', '2019-08-09 10:49:19', 11, 2001001000, '服务端发生异常', '2019-08-09 10:49:19');
INSERT INTO `access_log` VALUES (64727, '65.52.15653207276717567', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.227.192.84', '2019-08-09 11:18:48', 0, 1002001015, '账号未登陆', '2019-08-09 11:18:48');
INSERT INTO `access_log` VALUES (64728, '65.54.15653207276717435', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.227.192.84', '2019-08-09 11:18:48', 1, 1002001015, '账号未登陆', '2019-08-09 11:18:48');
INSERT INTO `access_log` VALUES (64729, '65.53.15653207276757509', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.227.192.84', '2019-08-09 11:18:48', 0, 1002001015, '账号未登陆', '2019-08-09 11:18:48');
INSERT INTO `access_log` VALUES (64730, '65.3607.15653207350089335', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.227.192.84', '2019-08-09 11:18:55', 103, 0, '', '2019-08-09 11:18:55');
INSERT INTO `access_log` VALUES (64731, '65.46.15653207353727571', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.227.192.84', '2019-08-09 11:18:55', 10, 0, '', '2019-08-09 11:18:55');
INSERT INTO `access_log` VALUES (64732, '65.49.15653207353747527', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.227.192.84', '2019-08-09 11:18:55', 10, 2001001000, '服务端发生异常', '2019-08-09 11:18:55');
INSERT INTO `access_log` VALUES (64733, '65.50.15653207353767537', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.227.192.84', '2019-08-09 11:18:55', 9, 0, '', '2019-08-09 11:18:55');
INSERT INTO `access_log` VALUES (64734, '59.74.15653207540174795', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.227.192.84', '2019-08-09 11:19:14', 10, 0, '', '2019-08-09 11:19:14');
INSERT INTO `access_log` VALUES (64735, '59.78.15653207540174789', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.227.192.84', '2019-08-09 11:19:14', 19, 2001001000, '服务端发生异常', '2019-08-09 11:19:14');
INSERT INTO `access_log` VALUES (64736, '65.54.15653211340257443', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.49.107.82', '2019-08-09 11:25:34', 0, 1002001015, '账号未登陆', '2019-08-09 11:25:34');
INSERT INTO `access_log` VALUES (64737, '65.53.15653211340287515', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.49.107.82', '2019-08-09 11:25:34', 1, 1002001015, '账号未登陆', '2019-08-09 11:25:34');
INSERT INTO `access_log` VALUES (64738, '65.45.15653211340297533', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.49.107.82', '2019-08-09 11:25:34', 0, 1002001015, '账号未登陆', '2019-08-09 11:25:34');
INSERT INTO `access_log` VALUES (64739, '65.3607.15653211385759341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.49.107.82', '2019-08-09 11:25:39', 100, 0, '', '2019-08-09 11:25:39');
INSERT INTO `access_log` VALUES (64740, '65.50.15653211389647543', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.49.107.82', '2019-08-09 11:25:39', 16, 0, '', '2019-08-09 11:25:39');
INSERT INTO `access_log` VALUES (64741, '65.51.15653211389667619', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.49.107.82', '2019-08-09 11:25:39', 15, 0, '', '2019-08-09 11:25:39');
INSERT INTO `access_log` VALUES (64742, '65.46.15653211389657577', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.49.107.82', '2019-08-09 11:25:39', 17, 2001001000, '服务端发生异常', '2019-08-09 11:25:39');
INSERT INTO `access_log` VALUES (64743, '65.52.15653297018807691', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.201.228', '2019-08-09 13:48:22', 0, 1002001015, '账号未登陆', '2019-08-09 13:48:22');
INSERT INTO `access_log` VALUES (64744, '65.45.15653297018817651', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.201.228', '2019-08-09 13:48:22', 0, 1002001015, '账号未登陆', '2019-08-09 13:48:22');
INSERT INTO `access_log` VALUES (64745, '65.54.15653297019277559', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.201.228', '2019-08-09 13:48:22', 0, 1002001015, '账号未登陆', '2019-08-09 13:48:22');
INSERT INTO `access_log` VALUES (64746, '65.47.15653297809167625', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.201.228', '2019-08-09 13:49:41', 117, 0, '', '2019-08-09 13:49:41');
INSERT INTO `access_log` VALUES (64747, '65.45.15653297813237653', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.201.228', '2019-08-09 13:49:41', 11, 0, '', '2019-08-09 13:49:41');
INSERT INTO `access_log` VALUES (64748, '65.52.15653297813237693', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.201.228', '2019-08-09 13:49:41', 12, 2001001000, '服务端发生异常', '2019-08-09 13:49:41');
INSERT INTO `access_log` VALUES (64749, '65.54.15653297813707561', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.201.228', '2019-08-09 13:49:41', 10, 0, '', '2019-08-09 13:49:41');
INSERT INTO `access_log` VALUES (64750, '65.3607.15653308584259469', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '210.76.108.39', '2019-08-09 14:07:38', 1, 1002001015, '账号未登陆', '2019-08-09 14:07:38');
INSERT INTO `access_log` VALUES (64751, '65.51.15653308584257753', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '210.76.108.39', '2019-08-09 14:07:38', 0, 1002001015, '账号未登陆', '2019-08-09 14:07:38');
INSERT INTO `access_log` VALUES (64752, '65.49.15653308584257665', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '210.76.108.39', '2019-08-09 14:07:38', 1, 1002001015, '账号未登陆', '2019-08-09 14:07:38');
INSERT INTO `access_log` VALUES (64753, '65.46.15653308674207711', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '210.76.108.39', '2019-08-09 14:07:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 14:07:47');
INSERT INTO `access_log` VALUES (64754, '65.54.15653308750317577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '210.76.108.39', '2019-08-09 14:07:55', 106, 0, '', '2019-08-09 14:07:55');
INSERT INTO `access_log` VALUES (64755, '65.52.15653308753987709', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '210.76.108.39', '2019-08-09 14:07:55', 19, 0, '', '2019-08-09 14:07:55');
INSERT INTO `access_log` VALUES (64756, '65.45.15653308753997669', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '210.76.108.39', '2019-08-09 14:07:55', 20, 2001001000, '服务端发生异常', '2019-08-09 14:07:55');
INSERT INTO `access_log` VALUES (64757, '65.53.15653308754037649', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '210.76.108.39', '2019-08-09 14:07:55', 18, 0, '', '2019-08-09 14:07:55');
INSERT INTO `access_log` VALUES (64758, '65.49.15653334410557701', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.7.140.167', '2019-08-09 14:50:41', 0, 1002001015, '账号未登陆', '2019-08-09 14:50:41');
INSERT INTO `access_log` VALUES (64759, '65.3607.15653334410559505', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.7.140.167', '2019-08-09 14:50:41', 0, 1002001015, '账号未登陆', '2019-08-09 14:50:41');
INSERT INTO `access_log` VALUES (64760, '65.50.15653334410717709', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.7.140.167', '2019-08-09 14:50:41', 0, 1002001015, '账号未登陆', '2019-08-09 14:50:41');
INSERT INTO `access_log` VALUES (64761, '65.46.15653334465317747', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.7.140.167', '2019-08-09 14:50:47', 82, 0, '', '2019-08-09 14:50:47');
INSERT INTO `access_log` VALUES (64762, '65.47.15653334467917677', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.7.140.167', '2019-08-09 14:50:47', 11, 0, '', '2019-08-09 14:50:47');
INSERT INTO `access_log` VALUES (64763, '65.54.15653334467927613', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.7.140.167', '2019-08-09 14:50:47', 12, 2001001000, '服务端发生异常', '2019-08-09 14:50:47');
INSERT INTO `access_log` VALUES (64764, '65.52.15653334467957745', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.7.140.167', '2019-08-09 14:50:47', 9, 0, '', '2019-08-09 14:50:47');
INSERT INTO `access_log` VALUES (64765, '65.45.15653334585617705', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.7.140.167', '2019-08-09 14:50:59', 11, 0, '', '2019-08-09 14:50:59');
INSERT INTO `access_log` VALUES (64766, '65.51.15653334585637791', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.7.140.167', '2019-08-09 14:50:59', 10, 2001001000, '服务端发生异常', '2019-08-09 14:50:59');
INSERT INTO `access_log` VALUES (64767, '65.3607.15653334585659507', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '36.7.140.167', '2019-08-09 14:50:59', 9, 0, '', '2019-08-09 14:50:59');
INSERT INTO `access_log` VALUES (64768, '65.46.15653334982547749', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.82.154.152', '2019-08-09 14:51:38', 0, 1002001015, '账号未登陆', '2019-08-09 14:51:38');
INSERT INTO `access_log` VALUES (64769, '65.52.15653334982617747', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.82.154.152', '2019-08-09 14:51:38', 1, 1002001015, '账号未登陆', '2019-08-09 14:51:38');
INSERT INTO `access_log` VALUES (64770, '65.54.15653334982617615', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.82.154.152', '2019-08-09 14:51:38', 0, 1002001015, '账号未登陆', '2019-08-09 14:51:38');
INSERT INTO `access_log` VALUES (64771, '65.52.15653335922707749', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.82.154.152', '2019-08-09 14:53:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 14:53:12');
INSERT INTO `access_log` VALUES (64772, '65.50.15653337103477715', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.82.154.152', '2019-08-09 14:55:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 14:55:10');
INSERT INTO `access_log` VALUES (64773, '65.52.15653337197777751', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.210.251', '2019-08-09 14:55:20', 0, 1002001015, '账号未登陆', '2019-08-09 14:55:20');
INSERT INTO `access_log` VALUES (64774, '65.46.15653337197827753', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.210.251', '2019-08-09 14:55:20', 0, 1002001015, '账号未登陆', '2019-08-09 14:55:20');
INSERT INTO `access_log` VALUES (64775, '65.54.15653337197927619', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.210.251', '2019-08-09 14:55:20', 0, 1002001015, '账号未登陆', '2019-08-09 14:55:20');
INSERT INTO `access_log` VALUES (64776, '65.47.15653337227987683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.210.251', '2019-08-09 14:55:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 14:55:23');
INSERT INTO `access_log` VALUES (64777, '65.3607.15653337529709513', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.210.251', '2019-08-09 14:55:53', 80, 0, '', '2019-08-09 14:55:53');
INSERT INTO `access_log` VALUES (64778, '65.45.15653337533507711', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.210.251', '2019-08-09 14:55:53', 9, 0, '', '2019-08-09 14:55:53');
INSERT INTO `access_log` VALUES (64779, '65.50.15653337533597717', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.210.251', '2019-08-09 14:55:53', 9, 0, '', '2019-08-09 14:55:53');
INSERT INTO `access_log` VALUES (64780, '65.49.15653337533587709', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.210.251', '2019-08-09 14:55:53', 10, 2001001000, '服务端发生异常', '2019-08-09 14:55:53');
INSERT INTO `access_log` VALUES (64781, '65.47.15653337864707685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.82.154.152', '2019-08-09 14:56:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 14:56:26');
INSERT INTO `access_log` VALUES (64782, '65.53.15653337929707693', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.82.154.152', '2019-08-09 14:56:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 14:56:33');
INSERT INTO `access_log` VALUES (64783, '65.45.15653355002287735', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.44.174.133', '2019-08-09 15:25:00', 0, 1002001015, '账号未登陆', '2019-08-09 15:25:00');
INSERT INTO `access_log` VALUES (64784, '65.52.15653355002297777', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.44.174.133', '2019-08-09 15:25:00', 0, 1002001015, '账号未登陆', '2019-08-09 15:25:00');
INSERT INTO `access_log` VALUES (64785, '65.46.15653355002337779', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.44.174.133', '2019-08-09 15:25:00', 1, 1002001015, '账号未登陆', '2019-08-09 15:25:00');
INSERT INTO `access_log` VALUES (64786, '65.47.15653355095737709', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.44.174.133', '2019-08-09 15:25:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 15:25:10');
INSERT INTO `access_log` VALUES (64787, '65.53.15653355239157717', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.44.174.133', '2019-08-09 15:25:24', 65, 0, '', '2019-08-09 15:25:24');
INSERT INTO `access_log` VALUES (64788, '65.3607.15653355243259539', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.44.174.133', '2019-08-09 15:25:24', 9, 0, '', '2019-08-09 15:25:24');
INSERT INTO `access_log` VALUES (64789, '65.49.15653355244327735', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.44.174.133', '2019-08-09 15:25:24', 10, 0, '', '2019-08-09 15:25:24');
INSERT INTO `access_log` VALUES (64790, '65.50.15653355246287743', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.44.174.133', '2019-08-09 15:25:25', 9, 2001001000, '服务端发生异常', '2019-08-09 15:25:25');
INSERT INTO `access_log` VALUES (64791, '65.52.15653358546867783', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '183.192.164.71', '2019-08-09 15:30:55', 1, 1002001015, '账号未登陆', '2019-08-09 15:30:55');
INSERT INTO `access_log` VALUES (64792, '59.75.15653358615554993', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:31:02', 11, 0, '', '2019-08-09 15:31:02');
INSERT INTO `access_log` VALUES (64793, '59.74.15653358615554997', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:31:02', 19, 2001001000, '服务端发生异常', '2019-08-09 15:31:02');
INSERT INTO `access_log` VALUES (64794, '59.71.15653358928214983', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:33', 3, 0, '', '2019-08-09 15:31:33');
INSERT INTO `access_log` VALUES (64795, '59.79.15653358928214991', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:33', 21, 2001001000, '服务端发生异常', '2019-08-09 15:31:33');
INSERT INTO `access_log` VALUES (64796, '64.76.15653358959015305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:36', 12, 0, '', '2019-08-09 15:31:36');
INSERT INTO `access_log` VALUES (64797, '64.83.15653358960445303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:36', 3, 0, '', '2019-08-09 15:31:36');
INSERT INTO `access_log` VALUES (64798, '64.77.15653358976185299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:38', 2, 0, '', '2019-08-09 15:31:38');
INSERT INTO `access_log` VALUES (64799, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:38', 14, 0, '', '2019-08-09 15:31:38');
INSERT INTO `access_log` VALUES (64800, '64.85.15653358988725337', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:39', 8, 0, '', '2019-08-09 15:31:39');
INSERT INTO `access_log` VALUES (64801, '64.80.15653359000195311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:40', 2, 0, '', '2019-08-09 15:31:40');
INSERT INTO `access_log` VALUES (64802, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:40', 6, 0, '', '2019-08-09 15:31:40');
INSERT INTO `access_log` VALUES (64803, '64.84.15653359010635305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:41', 2, 0, '', '2019-08-09 15:31:41');
INSERT INTO `access_log` VALUES (64804, '64.82.15653359012035317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:41', 2, 0, '', '2019-08-09 15:31:41');
INSERT INTO `access_log` VALUES (64805, '64.78.15653359020885307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:42', 2, 0, '', '2019-08-09 15:31:42');
INSERT INTO `access_log` VALUES (64806, '64.81.15653359028175311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:43', 2, 0, '', '2019-08-09 15:31:43');
INSERT INTO `access_log` VALUES (64807, '59.73.15653359041234989', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:44', 2, 0, '', '2019-08-09 15:31:44');
INSERT INTO `access_log` VALUES (64808, '59.77.15653359041324975', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:44', 13, 2001001000, '服务端发生异常', '2019-08-09 15:31:44');
INSERT INTO `access_log` VALUES (64809, '64.79.15653359058425313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:46', 2, 0, '', '2019-08-09 15:31:46');
INSERT INTO `access_log` VALUES (64810, '64.76.15653359061845307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:46', 3, 0, '', '2019-08-09 15:31:46');
INSERT INTO `access_log` VALUES (64811, '65.53.15653359118917727', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '120.204.17.71', '2019-08-09 15:31:52', 0, 1002001015, '账号未登陆', '2019-08-09 15:31:52');
INSERT INTO `access_log` VALUES (64812, '64.77.15653359161085301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:56', 3, 0, '', '2019-08-09 15:31:56');
INSERT INTO `access_log` VALUES (64813, '64.85.15653359161975339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:31:56', 2, 0, '', '2019-08-09 15:31:56');
INSERT INTO `access_log` VALUES (64814, '59.75.15653359276554995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:32:08', 3, 0, '', '2019-08-09 15:32:08');
INSERT INTO `access_log` VALUES (64815, '59.78.15653359276604993', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; YAL-AL00 Build/HUAWEIYAL-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/1198 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '220.191.39.220', '2019-08-09 15:32:08', 12, 2001001000, '服务端发生异常', '2019-08-09 15:32:08');
INSERT INTO `access_log` VALUES (64816, '65.45.15653359445597743', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:32:25', 48, 1002001012, '访问令牌已过期', '2019-08-09 15:32:25');
INSERT INTO `access_log` VALUES (64817, '65.52.15653359445657787', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:32:25', 42, 1002001012, '访问令牌已过期', '2019-08-09 15:32:25');
INSERT INTO `access_log` VALUES (64818, '65.46.15653359445667787', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:32:25', 43, 1002001012, '访问令牌已过期', '2019-08-09 15:32:25');
INSERT INTO `access_log` VALUES (64819, '65.54.15653359521977653', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:32:32', 67, 0, '', '2019-08-09 15:32:32');
INSERT INTO `access_log` VALUES (64820, '65.47.15653359525857715', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:32:33', 9, 0, '', '2019-08-09 15:32:33');
INSERT INTO `access_log` VALUES (64821, '65.53.15653359525897729', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:32:33', 8, 0, '', '2019-08-09 15:32:33');
INSERT INTO `access_log` VALUES (64822, '65.51.15653359525897829', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:32:33', 8, 2001001000, '服务端发生异常', '2019-08-09 15:32:33');
INSERT INTO `access_log` VALUES (64823, '65.50.15653359781917751', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:32:58', 9, 0, '', '2019-08-09 15:32:58');
INSERT INTO `access_log` VALUES (64824, '65.45.15653359781957745', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:32:58', 10, 2001001000, '服务端发生异常', '2019-08-09 15:32:58');
INSERT INTO `access_log` VALUES (64825, '65.52.15653359782007789', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:32:58', 8, 0, '', '2019-08-09 15:32:58');
INSERT INTO `access_log` VALUES (64826, '65.46.15653359818257789', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:33:02', 8, 0, '', '2019-08-09 15:33:02');
INSERT INTO `access_log` VALUES (64827, '65.47.15653359818277717', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:33:02', 8, 0, '', '2019-08-09 15:33:02');
INSERT INTO `access_log` VALUES (64828, '65.54.15653359818277655', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.191.39.220', '2019-08-09 15:33:02', 10, 2001001000, '服务端发生异常', '2019-08-09 15:33:02');
INSERT INTO `access_log` VALUES (64829, '59.72.15653373775685005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:56:18', 3, 0, '', '2019-08-09 15:56:18');
INSERT INTO `access_log` VALUES (64830, '59.74.15653373775695019', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:56:18', 22, 2001001000, '服务端发生异常', '2019-08-09 15:56:18');
INSERT INTO `access_log` VALUES (64831, '64.77.15653373861515321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:56:26', 3, 0, '', '2019-08-09 15:56:26');
INSERT INTO `access_log` VALUES (64832, '64.85.15653373862425359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:56:26', 2, 0, '', '2019-08-09 15:56:26');
INSERT INTO `access_log` VALUES (64833, '64.80.15653373874415333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:56:27', 2, 0, '', '2019-08-09 15:56:27');
INSERT INTO `access_log` VALUES (64834, '64.84.15653373881285327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:56:28', 2, 0, '', '2019-08-09 15:56:28');
INSERT INTO `access_log` VALUES (64835, '64.82.15653373919245339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:56:32', 2, 0, '', '2019-08-09 15:56:32');
INSERT INTO `access_log` VALUES (64836, '64.78.15653373920325329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:56:32', 2, 0, '', '2019-08-09 15:56:32');
INSERT INTO `access_log` VALUES (64837, '66.52.15653374102082637', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:56:50', 17, 1001003001, '验证码已过期', '2019-08-09 15:56:50');
INSERT INTO `access_log` VALUES (64838, '66.56.15653374138712653', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=11111111111', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:56:54', 122, 0, '', '2019-08-09 15:56:54');
INSERT INTO `access_log` VALUES (64839, '66.48.15653374166562653', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:56:57', 191, 0, '', '2019-08-09 15:56:57');
INSERT INTO `access_log` VALUES (64840, '66.57.15653374246392641', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:57:05', 63, 0, '', '2019-08-09 15:57:05');
INSERT INTO `access_log` VALUES (64841, '66.54.15653374272912653', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:57:07', 5, 0, '', '2019-08-09 15:57:07');
INSERT INTO `access_log` VALUES (64842, '66.50.15653374307732643', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:57:11', 5, 0, '', '2019-08-09 15:57:11');
INSERT INTO `access_log` VALUES (64843, '66.53.15653374346062637', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '219.143.150.77', '2019-08-09 15:57:15', 6, 0, '', '2019-08-09 15:57:15');
INSERT INTO `access_log` VALUES (64844, '65.49.15653377393037771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.44.174.133', '2019-08-09 16:02:19', 157, 0, '', '2019-08-09 16:02:19');
INSERT INTO `access_log` VALUES (64845, '65.51.15653377392907855', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.44.174.133', '2019-08-09 16:02:19', 170, 0, '', '2019-08-09 16:02:19');
INSERT INTO `access_log` VALUES (64846, '65.3607.15653377392929573', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '222.44.174.133', '2019-08-09 16:02:19', 170, 2001001000, '服务端发生异常', '2019-08-09 16:02:19');
INSERT INTO `access_log` VALUES (64847, '65.47.15653392908357763', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.17.51.26', '2019-08-09 16:28:11', 1, 1002001015, '账号未登陆', '2019-08-09 16:28:11');
INSERT INTO `access_log` VALUES (64848, '65.53.15653392908407775', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.17.51.26', '2019-08-09 16:28:11', 0, 1002001015, '账号未登陆', '2019-08-09 16:28:11');
INSERT INTO `access_log` VALUES (64849, '65.54.15653392908477701', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.17.51.26', '2019-08-09 16:28:11', 0, 1002001015, '账号未登陆', '2019-08-09 16:28:11');
INSERT INTO `access_log` VALUES (64850, '65.3607.15653392966439595', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.17.51.26', '2019-08-09 16:28:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 16:28:17');
INSERT INTO `access_log` VALUES (64851, '65.46.15653393431097837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.17.51.26', '2019-08-09 16:29:03', 105, 0, '', '2019-08-09 16:29:03');
INSERT INTO `access_log` VALUES (64852, '65.45.15653393437017793', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.17.51.26', '2019-08-09 16:29:04', 9, 0, '', '2019-08-09 16:29:04');
INSERT INTO `access_log` VALUES (64853, '65.50.15653393437147799', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.17.51.26', '2019-08-09 16:29:04', 10, 2001001000, '服务端发生异常', '2019-08-09 16:29:04');
INSERT INTO `access_log` VALUES (64854, '65.47.15653393437227765', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.17.51.26', '2019-08-09 16:29:04', 8, 0, '', '2019-08-09 16:29:04');
INSERT INTO `access_log` VALUES (64855, '59.75.15653399149505049', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.215', '2019-08-09 16:38:35', 10, 0, '', '2019-08-09 16:38:35');
INSERT INTO `access_log` VALUES (64856, '59.80.15653399149545011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.215', '2019-08-09 16:38:35', 27, 2001001000, '服务端发生异常', '2019-08-09 16:38:35');
INSERT INTO `access_log` VALUES (64857, '64.78.15653399211725363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.215', '2019-08-09 16:38:41', 12, 0, '', '2019-08-09 16:38:41');
INSERT INTO `access_log` VALUES (64858, '64.81.15653399212925367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.215', '2019-08-09 16:38:41', 3, 0, '', '2019-08-09 16:38:41');
INSERT INTO `access_log` VALUES (64859, '64.79.15653399228835369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.215', '2019-08-09 16:38:43', 2, 0, '', '2019-08-09 16:38:43');
INSERT INTO `access_log` VALUES (64860, '64.76.15653399236845363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.215', '2019-08-09 16:38:44', 2, 0, '', '2019-08-09 16:38:44');
INSERT INTO `access_log` VALUES (64861, '59.71.15653399263285037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.215', '2019-08-09 16:38:46', 3, 0, '', '2019-08-09 16:38:46');
INSERT INTO `access_log` VALUES (64862, '59.79.15653399263295047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.215', '2019-08-09 16:38:46', 17, 2001001000, '服务端发生异常', '2019-08-09 16:38:46');
INSERT INTO `access_log` VALUES (64863, '59.76.15653400789235037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.215', '2019-08-09 16:41:19', 3, 0, '', '2019-08-09 16:41:19');
INSERT INTO `access_log` VALUES (64864, '59.77.15653400789245033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.215', '2019-08-09 16:41:19', 30, 2001001000, '服务端发生异常', '2019-08-09 16:41:19');
INSERT INTO `access_log` VALUES (64865, '64.77.15653400805605359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.215', '2019-08-09 16:41:21', 2, 0, '', '2019-08-09 16:41:21');
INSERT INTO `access_log` VALUES (64866, '64.85.15653400807075397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.215', '2019-08-09 16:41:21', 2, 0, '', '2019-08-09 16:41:21');
INSERT INTO `access_log` VALUES (64867, '59.72.15653400807555043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.215', '2019-08-09 16:41:21', 2, 0, '', '2019-08-09 16:41:21');
INSERT INTO `access_log` VALUES (64868, '59.74.15653400807925057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.13.14.215', '2019-08-09 16:41:21', 13, 2001001000, '服务端发生异常', '2019-08-09 16:41:21');
INSERT INTO `access_log` VALUES (64869, '65.46.15653404884787853', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:08', 0, 1002001015, '账号未登陆', '2019-08-09 16:48:08');
INSERT INTO `access_log` VALUES (64870, '65.50.15653404884787815', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:08', 0, 1002001015, '账号未登陆', '2019-08-09 16:48:08');
INSERT INTO `access_log` VALUES (64871, '65.45.15653404884787809', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:08', 0, 1002001015, '账号未登陆', '2019-08-09 16:48:08');
INSERT INTO `access_log` VALUES (64872, '65.53.15653404923347793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 16:48:12');
INSERT INTO `access_log` VALUES (64873, '65.54.15653404970197719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:17', 65, 0, '', '2019-08-09 16:48:17');
INSERT INTO `access_log` VALUES (64874, '65.3607.15653404974729613', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:17', 102, 0, '', '2019-08-09 16:48:18');
INSERT INTO `access_log` VALUES (64875, '65.49.15653404974897811', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:17', 96, 0, '', '2019-08-09 16:48:18');
INSERT INTO `access_log` VALUES (64876, '65.51.15653404974807895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:17', 104, 2001001000, '服务端发生异常', '2019-08-09 16:48:18');
INSERT INTO `access_log` VALUES (64877, '65.46.15653405066507855', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:27', 9, 0, '', '2019-08-09 16:48:27');
INSERT INTO `access_log` VALUES (64878, '65.50.15653405066597817', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:27', 10, 2001001000, '服务端发生异常', '2019-08-09 16:48:27');
INSERT INTO `access_log` VALUES (64879, '65.45.15653405066777811', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:27', 8, 0, '', '2019-08-09 16:48:27');
INSERT INTO `access_log` VALUES (64880, '65.47.15653405182757783', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 16:48:38');
INSERT INTO `access_log` VALUES (64881, '65.54.15653405239717721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:44', 90, 0, '', '2019-08-09 16:48:44');
INSERT INTO `access_log` VALUES (64882, '65.49.15653405243807813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:44', 9, 0, '', '2019-08-09 16:48:44');
INSERT INTO `access_log` VALUES (64883, '65.3607.15653405243859615', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:44', 9, 2001001000, '服务端发生异常', '2019-08-09 16:48:44');
INSERT INTO `access_log` VALUES (64884, '65.51.15653405243877897', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '114.242.105.130', '2019-08-09 16:48:44', 8, 0, '', '2019-08-09 16:48:44');
INSERT INTO `access_log` VALUES (64885, '65.3607.15653413893859627', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:03:09', 1, 1002001015, '账号未登陆', '2019-08-09 17:03:09');
INSERT INTO `access_log` VALUES (64886, '65.51.15653413893907909', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:03:09', 1, 1002001015, '账号未登陆', '2019-08-09 17:03:09');
INSERT INTO `access_log` VALUES (64887, '65.52.15653413893917869', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:03:09', 0, 1002001015, '账号未登陆', '2019-08-09 17:03:09');
INSERT INTO `access_log` VALUES (64888, '65.51.15653415043147911', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:05:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 17:05:04');
INSERT INTO `access_log` VALUES (64889, '65.45.15653421318157835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:15:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 17:15:32');
INSERT INTO `access_log` VALUES (64890, '65.47.15653421544707807', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:15:54', 106, 0, '', '2019-08-09 17:15:55');
INSERT INTO `access_log` VALUES (64891, '65.53.15653421549577819', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:15:55', 66, 0, '', '2019-08-09 17:15:55');
INSERT INTO `access_log` VALUES (64892, '65.54.15653421549657745', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:15:55', 68, 2001001000, '服务端发生异常', '2019-08-09 17:15:55');
INSERT INTO `access_log` VALUES (64893, '65.49.15653421551867837', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:15:55', 10, 0, '', '2019-08-09 17:15:55');
INSERT INTO `access_log` VALUES (64894, '65.51.15653421671407921', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:16:07', 8, 0, '', '2019-08-09 17:16:07');
INSERT INTO `access_log` VALUES (64895, '65.3607.15653421671419639', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:16:07', 9, 2001001000, '服务端发生异常', '2019-08-09 17:16:07');
INSERT INTO `access_log` VALUES (64896, '65.52.15653421671907881', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:16:07', 10, 0, '', '2019-08-09 17:16:07');
INSERT INTO `access_log` VALUES (64897, '65.53.15653422301837821', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.70.253', '2019-08-09 17:17:10', 4, 1002001012, '访问令牌已过期', '2019-08-09 17:17:10');
INSERT INTO `access_log` VALUES (64898, '65.51.15653422301837923', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.70.253', '2019-08-09 17:17:10', 4, 1002001012, '访问令牌已过期', '2019-08-09 17:17:10');
INSERT INTO `access_log` VALUES (64899, '65.49.15653422301837839', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.70.253', '2019-08-09 17:17:10', 4, 1002001012, '访问令牌已过期', '2019-08-09 17:17:10');
INSERT INTO `access_log` VALUES (64900, '65.3607.15653422329949641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.70.253', '2019-08-09 17:17:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 17:17:13');
INSERT INTO `access_log` VALUES (64901, '65.45.15653422478307839', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.70.253', '2019-08-09 17:17:28', 71, 0, '', '2019-08-09 17:17:28');
INSERT INTO `access_log` VALUES (64902, '65.50.15653422481967845', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.70.253', '2019-08-09 17:17:28', 10, 0, '', '2019-08-09 17:17:28');
INSERT INTO `access_log` VALUES (64903, '65.46.15653422481997883', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.70.253', '2019-08-09 17:17:28', 9, 0, '', '2019-08-09 17:17:28');
INSERT INTO `access_log` VALUES (64904, '65.47.15653422482007811', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.70.253', '2019-08-09 17:17:28', 9, 2001001000, '服务端发生异常', '2019-08-09 17:17:28');
INSERT INTO `access_log` VALUES (64905, '65.54.15653422519157749', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.70.253', '2019-08-09 17:17:32', 9, 0, '', '2019-08-09 17:17:32');
INSERT INTO `access_log` VALUES (64906, '65.51.15653422519177925', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.70.253', '2019-08-09 17:17:32', 8, 0, '', '2019-08-09 17:17:32');
INSERT INTO `access_log` VALUES (64907, '65.49.15653422519197841', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.11.70.253', '2019-08-09 17:17:32', 9, 2001001000, '服务端发生异常', '2019-08-09 17:17:32');
INSERT INTO `access_log` VALUES (64908, '65.53.15653422547287823', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:17:35', 9, 0, '', '2019-08-09 17:17:35');
INSERT INTO `access_log` VALUES (64909, '65.3607.15653422547319643', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:17:35', 10, 2001001000, '服务端发生异常', '2019-08-09 17:17:35');
INSERT INTO `access_log` VALUES (64910, '65.52.15653422548437885', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:17:35', 9, 0, '', '2019-08-09 17:17:35');
INSERT INTO `access_log` VALUES (64911, '65.51.15653423417417927', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:19:02', 8, 0, '', '2019-08-09 17:19:02');
INSERT INTO `access_log` VALUES (64912, '65.53.15653423417417825', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:19:02', 10, 2001001000, '服务端发生异常', '2019-08-09 17:19:02');
INSERT INTO `access_log` VALUES (64913, '65.3607.15653423419079645', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '112.224.65.99', '2019-08-09 17:19:02', 9, 0, '', '2019-08-09 17:19:02');
INSERT INTO `access_log` VALUES (64914, '59.73.15653440945885101', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '180.169.242.126', '2019-08-09 17:48:15', 9, 0, '', '2019-08-09 17:48:15');
INSERT INTO `access_log` VALUES (64915, '59.76.15653440945885091', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2864.400', '180.169.242.126', '2019-08-09 17:48:15', 14, 2001001000, '服务端发生异常', '2019-08-09 17:48:15');
INSERT INTO `access_log` VALUES (64916, '59.72.15653441006515097', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:21', 2, 0, '', '2019-08-09 17:48:21');
INSERT INTO `access_log` VALUES (64917, '59.78.15653441006525105', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:21', 18, 2001001000, '服务端发生异常', '2019-08-09 17:48:21');
INSERT INTO `access_log` VALUES (64918, '64.80.15653441026085423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:23', 12, 0, '', '2019-08-09 17:48:23');
INSERT INTO `access_log` VALUES (64919, '64.84.15653441027145417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:23', 3, 0, '', '2019-08-09 17:48:23');
INSERT INTO `access_log` VALUES (64920, '64.85.15653441047095453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:25', 2, 0, '', '2019-08-09 17:48:25');
INSERT INTO `access_log` VALUES (64921, '64.77.15653441054075413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:25', 2, 0, '', '2019-08-09 17:48:25');
INSERT INTO `access_log` VALUES (64922, '64.82.15653441061065433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:26', 2, 0, '', '2019-08-09 17:48:26');
INSERT INTO `access_log` VALUES (64923, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:26', 7, 0, '', '2019-08-09 17:48:26');
INSERT INTO `access_log` VALUES (64924, '64.78.15653441073515423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:27', 2, 0, '', '2019-08-09 17:48:27');
INSERT INTO `access_log` VALUES (64925, '64.83.15653441077515419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:28', 2, 0, '', '2019-08-09 17:48:28');
INSERT INTO `access_log` VALUES (64926, '64.76.15653441101485423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:30', 1, 0, '', '2019-08-09 17:48:30');
INSERT INTO `access_log` VALUES (64927, '64.81.15653441102445427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:30', 1, 0, '', '2019-08-09 17:48:30');
INSERT INTO `access_log` VALUES (64928, '66.57.15653441148232733', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空', '2019-08-09 17:48:35');
INSERT INTO `access_log` VALUES (64929, '59.75.15653441191645107', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:39', 2, 0, '', '2019-08-09 17:48:39');
INSERT INTO `access_log` VALUES (64930, '59.79.15653441191645105', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:39', 12, 2001001000, '服务端发生异常', '2019-08-09 17:48:39');
INSERT INTO `access_log` VALUES (64931, '64.80.15653441211805425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:41', 1, 0, '', '2019-08-09 17:48:41');
INSERT INTO `access_log` VALUES (64932, '64.84.15653441215535419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:42', 1, 0, '', '2019-08-09 17:48:42');
INSERT INTO `access_log` VALUES (64933, '59.77.15653441229515089', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:43', 2, 0, '', '2019-08-09 17:48:43');
INSERT INTO `access_log` VALUES (64934, '59.71.15653441229515097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:43', 19, 2001001000, '服务端发生异常', '2019-08-09 17:48:43');
INSERT INTO `access_log` VALUES (64935, '64.85.15653441244895455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:44', 2, 0, '', '2019-08-09 17:48:44');
INSERT INTO `access_log` VALUES (64936, '64.77.15653441245805415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:45', 2, 0, '', '2019-08-09 17:48:45');
INSERT INTO `access_log` VALUES (64937, '59.76.15653441258265093', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:46', 3, 0, '', '2019-08-09 17:48:46');
INSERT INTO `access_log` VALUES (64938, '59.73.15653441258265103', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Mobile Safari/537.36', '180.169.242.126', '2019-08-09 17:48:46', 13, 2001001000, '服务端发生异常', '2019-08-09 17:48:46');
INSERT INTO `access_log` VALUES (64939, '65.50.15653446422207879', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '183.63.125.165', '2019-08-09 17:57:22', 0, 1002001015, '账号未登陆', '2019-08-09 17:57:22');
INSERT INTO `access_log` VALUES (64940, '65.47.15653446422227845', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '183.63.125.165', '2019-08-09 17:57:22', 0, 1002001015, '账号未登陆', '2019-08-09 17:57:22');
INSERT INTO `access_log` VALUES (64941, '65.46.15653446422377919', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '183.63.125.165', '2019-08-09 17:57:22', 0, 1002001015, '账号未登陆', '2019-08-09 17:57:22');
INSERT INTO `access_log` VALUES (64942, '65.54.15653446475487783', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '183.63.125.165', '2019-08-09 17:57:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 17:57:28');
INSERT INTO `access_log` VALUES (64943, '65.3607.15653446630899677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '183.63.125.165', '2019-08-09 17:57:43', 60, 0, '', '2019-08-09 17:57:43');
INSERT INTO `access_log` VALUES (64944, '65.51.15653446639427959', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '183.63.125.165', '2019-08-09 17:57:44', 12, 0, '', '2019-08-09 17:57:44');
INSERT INTO `access_log` VALUES (64945, '65.45.15653446639427877', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '183.63.125.165', '2019-08-09 17:57:44', 11, 0, '', '2019-08-09 17:57:44');
INSERT INTO `access_log` VALUES (64946, '65.52.15653446639427921', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101 Firefox/60.0', '183.63.125.165', '2019-08-09 17:57:44', 13, 2001001000, '服务端发生异常', '2019-08-09 17:57:44');
INSERT INTO `access_log` VALUES (64947, '59.76.15653452955755109', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.131.242.122', '2019-08-09 18:08:16', 4, 0, '', '2019-08-09 18:08:16');
INSERT INTO `access_log` VALUES (64948, '59.73.15653452955755119', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '222.131.242.122', '2019-08-09 18:08:16', 14, 2001001000, '服务端发生异常', '2019-08-09 18:08:16');
INSERT INTO `access_log` VALUES (64949, '59.72.15653452959715115', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:16', 3, 0, '', '2019-08-09 18:08:16');
INSERT INTO `access_log` VALUES (64950, '59.74.15653452959715129', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:16', 38, 2001001000, '服务端发生异常', '2019-08-09 18:08:16');
INSERT INTO `access_log` VALUES (64951, '65.49.15653453079827887', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.131.242.122', '2019-08-09 18:08:28', 0, 1002001015, '账号未登陆', '2019-08-09 18:08:28');
INSERT INTO `access_log` VALUES (64952, '65.54.15653453079837793', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.131.242.122', '2019-08-09 18:08:28', 1, 1002001015, '账号未登陆', '2019-08-09 18:08:28');
INSERT INTO `access_log` VALUES (64953, '65.53.15653453079867867', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.131.242.122', '2019-08-09 18:08:28', 0, 1002001015, '账号未登陆', '2019-08-09 18:08:28');
INSERT INTO `access_log` VALUES (64954, '64.77.15653453110415431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:31', 3, 0, '', '2019-08-09 18:08:31');
INSERT INTO `access_log` VALUES (64955, '64.82.15653453113085451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:31', 2, 0, '', '2019-08-09 18:08:31');
INSERT INTO `access_log` VALUES (64956, '65.3607.15653453113239687', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.131.242.122', '2019-08-09 18:08:31', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 18:08:31');
INSERT INTO `access_log` VALUES (64957, '65.45.15653453150237887', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.131.242.122', '2019-08-09 18:08:35', 4, 1002002001, '密码不正确', '2019-08-09 18:08:35');
INSERT INTO `access_log` VALUES (64958, '64.83.15653453158765437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:36', 2, 0, '', '2019-08-09 18:08:36');
INSERT INTO `access_log` VALUES (64959, '64.76.15653453160095441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:36', 2, 0, '', '2019-08-09 18:08:36');
INSERT INTO `access_log` VALUES (64960, '59.79.15653453185535123', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:39', 2, 0, '', '2019-08-09 18:08:39');
INSERT INTO `access_log` VALUES (64961, '59.75.15653453185885125', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:39', 11, 2001001000, '服务端发生异常', '2019-08-09 18:08:39');
INSERT INTO `access_log` VALUES (64962, '65.51.15653453228137969', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.131.242.122', '2019-08-09 18:08:43', 89, 0, '', '2019-08-09 18:08:43');
INSERT INTO `access_log` VALUES (64963, '64.81.15653453231725445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:43', 2, 0, '', '2019-08-09 18:08:43');
INSERT INTO `access_log` VALUES (64964, '64.79.15653453234965445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:43', 2, 0, '', '2019-08-09 18:08:43');
INSERT INTO `access_log` VALUES (64965, '59.71.15653453241495115', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:44', 2, 0, '', '2019-08-09 18:08:44');
INSERT INTO `access_log` VALUES (64966, '59.77.15653453241505107', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:44', 12, 2001001000, '服务端发生异常', '2019-08-09 18:08:44');
INSERT INTO `access_log` VALUES (64967, '64.80.15653453268625443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:47', 2, 0, '', '2019-08-09 18:08:47');
INSERT INTO `access_log` VALUES (64968, '64.84.15653453270135437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:47', 1, 0, '', '2019-08-09 18:08:47');
INSERT INTO `access_log` VALUES (64969, '64.77.15653453309485433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:51', 1, 0, '', '2019-08-09 18:08:51');
INSERT INTO `access_log` VALUES (64970, '64.82.15653453311275453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.254.248.168', '2019-08-09 18:08:51', 2, 0, '', '2019-08-09 18:08:51');
INSERT INTO `access_log` VALUES (64971, '65.50.15653453351357891', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '222.131.242.122', '2019-08-09 18:08:55', 75, 0, '', '2019-08-09 18:08:55');
INSERT INTO `access_log` VALUES (64972, '65.54.15653552464817927', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.238.216.70', '2019-08-09 20:54:06', 1, 1002001015, '账号未登陆', '2019-08-09 20:54:06');
INSERT INTO `access_log` VALUES (64973, '65.46.15653552464808063', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.238.216.70', '2019-08-09 20:54:06', 1, 1002001015, '账号未登陆', '2019-08-09 20:54:06');
INSERT INTO `access_log` VALUES (64974, '65.53.15653552464958001', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.238.216.70', '2019-08-09 20:54:06', 1, 1002001015, '账号未登陆', '2019-08-09 20:54:06');
INSERT INTO `access_log` VALUES (64975, '65.3607.15653552494069821', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.238.216.70', '2019-08-09 20:54:09', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 20:54:09');
INSERT INTO `access_log` VALUES (64976, '65.45.15653552522458021', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.238.216.70', '2019-08-09 20:54:12', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 20:54:12');
INSERT INTO `access_log` VALUES (64977, '65.52.15653552564228065', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.238.216.70', '2019-08-09 20:54:16', 87, 0, '', '2019-08-09 20:54:17');
INSERT INTO `access_log` VALUES (64978, '65.51.15653552568578103', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.238.216.70', '2019-08-09 20:54:17', 19, 0, '', '2019-08-09 20:54:17');
INSERT INTO `access_log` VALUES (64979, '65.47.15653552568627991', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.238.216.70', '2019-08-09 20:54:17', 16, 2001001000, '服务端发生异常', '2019-08-09 20:54:17');
INSERT INTO `access_log` VALUES (64980, '65.50.15653552568648025', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '221.238.216.70', '2019-08-09 20:54:17', 16, 0, '', '2019-08-09 20:54:17');
INSERT INTO `access_log` VALUES (64981, '59.72.15653572063225275', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '49.66.19.206', '2019-08-09 21:26:46', 11, 0, '', '2019-08-09 21:26:46');
INSERT INTO `access_log` VALUES (64982, '59.74.15653572063225289', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '49.66.19.206', '2019-08-09 21:26:46', 25, 2001001000, '服务端发生异常', '2019-08-09 21:26:46');
INSERT INTO `access_log` VALUES (64983, '64.76.15653572109895601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '49.66.19.206', '2019-08-09 21:26:51', 13, 0, '', '2019-08-09 21:26:51');
INSERT INTO `access_log` VALUES (64984, '64.81.15653572111795605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '49.66.19.206', '2019-08-09 21:26:51', 3, 0, '', '2019-08-09 21:26:51');
INSERT INTO `access_log` VALUES (64985, '64.79.15653572121265605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '49.66.19.206', '2019-08-09 21:26:52', 2, 0, '', '2019-08-09 21:26:52');
INSERT INTO `access_log` VALUES (64986, '64.80.15653572125905603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '49.66.19.206', '2019-08-09 21:26:53', 2, 0, '', '2019-08-09 21:26:53');
INSERT INTO `access_log` VALUES (64987, '65.50.15653642700758147', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 9 Build/PKQ1.181121.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.6.1036 Mobile Safari/537.36', '223.72.91.189', '2019-08-09 23:24:30', 0, 1002001015, '账号未登陆', '2019-08-09 23:24:30');
INSERT INTO `access_log` VALUES (64988, '65.53.15653642700768127', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 9 Build/PKQ1.181121.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.6.1036 Mobile Safari/537.36', '223.72.91.189', '2019-08-09 23:24:30', 0, 1002001015, '账号未登陆', '2019-08-09 23:24:30');
INSERT INTO `access_log` VALUES (64989, '65.46.15653642700838183', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 9 Build/PKQ1.181121.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.6.1036 Mobile Safari/537.36', '223.72.91.189', '2019-08-09 23:24:30', 2, 1002001015, '账号未登陆', '2019-08-09 23:24:30');
INSERT INTO `access_log` VALUES (64990, '65.54.15653642737438047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 9 Build/PKQ1.181121.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.6.1036 Mobile Safari/537.36', '1.180.239.193', '2019-08-09 23:24:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-09 23:24:34');
INSERT INTO `access_log` VALUES (64991, '65.49.15653642924238147', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 9 Build/PKQ1.181121.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.6.1036 Mobile Safari/537.36', '1.180.239.193', '2019-08-09 23:24:52', 199, 0, '', '2019-08-09 23:24:53');
INSERT INTO `access_log` VALUES (64992, '65.52.15653642930258189', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 9 Build/PKQ1.181121.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.6.1036 Mobile Safari/537.36', '1.180.239.193', '2019-08-09 23:24:53', 12, 0, '', '2019-08-09 23:24:53');
INSERT INTO `access_log` VALUES (64993, '65.45.15653642930318147', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 9 Build/PKQ1.181121.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.6.1036 Mobile Safari/537.36', '1.180.239.193', '2019-08-09 23:24:53', 9, 0, '', '2019-08-09 23:24:53');
INSERT INTO `access_log` VALUES (64994, '65.51.15653642932748227', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 9 Build/PKQ1.181121.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.6.1036 Mobile Safari/537.36', '1.180.239.193', '2019-08-09 23:24:53', 11, 2001001000, '服务端发生异常', '2019-08-09 23:24:53');
INSERT INTO `access_log` VALUES (64995, '65.50.15653643048788149', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 9 Build/PKQ1.181121.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.6.1036 Mobile Safari/537.36', '1.180.239.193', '2019-08-09 23:25:05', 10, 0, '', '2019-08-09 23:25:05');
INSERT INTO `access_log` VALUES (64996, '65.46.15653643048848185', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 9 Build/PKQ1.181121.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.6.1036 Mobile Safari/537.36', '1.180.239.193', '2019-08-09 23:25:05', 14, 2001001000, '服务端发生异常', '2019-08-09 23:25:05');
INSERT INTO `access_log` VALUES (64997, '65.53.15653643048958129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MI 9 Build/PKQ1.181121.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.5.6.1036 Mobile Safari/537.36', '1.180.239.193', '2019-08-09 23:25:05', 8, 0, '', '2019-08-09 23:25:05');
INSERT INTO `access_log` VALUES (64998, '59.80.15653957674435761', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.62', '2019-08-10 08:09:27', 10, 0, '', '2019-08-10 08:09:27');
INSERT INTO `access_log` VALUES (64999, '59.79.15653957674455797', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.62', '2019-08-10 08:09:27', 22, 2001001000, '服务端发生异常', '2019-08-10 08:09:27');
INSERT INTO `access_log` VALUES (65000, '64.83.15653957782966111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.62', '2019-08-10 08:09:38', 11, 0, '', '2019-08-10 08:09:38');
INSERT INTO `access_log` VALUES (65001, '64.76.15653957784866115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.62', '2019-08-10 08:09:38', 3, 0, '', '2019-08-10 08:09:38');
INSERT INTO `access_log` VALUES (65002, '64.85.15653957803226149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.62', '2019-08-10 08:09:40', 2, 0, '', '2019-08-10 08:09:40');
INSERT INTO `access_log` VALUES (65003, '64.84.15653957812426113', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.62', '2019-08-10 08:09:41', 2, 0, '', '2019-08-10 08:09:41');
INSERT INTO `access_log` VALUES (65004, '64.77.15653957820656109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.62', '2019-08-10 08:09:42', 2, 0, '', '2019-08-10 08:09:42');
INSERT INTO `access_log` VALUES (65005, '64.80.15653957962996119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.62', '2019-08-10 08:09:56', 3, 0, '', '2019-08-10 08:09:56');
INSERT INTO `access_log` VALUES (65006, '64.81.15653957964746121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.62', '2019-08-10 08:09:56', 2, 0, '', '2019-08-10 08:09:56');
INSERT INTO `access_log` VALUES (65007, '59.71.15654004377105851', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '171.92.120.201', '2019-08-10 09:27:18', 19, 2001001000, '服务端发生异常', '2019-08-10 09:27:18');
INSERT INTO `access_log` VALUES (65008, '59.77.15654004377025843', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Mobile/15E148 Safari/604.1', '171.92.120.201', '2019-08-10 09:27:18', 193, 0, '', '2019-08-10 09:27:18');
INSERT INTO `access_log` VALUES (65009, '65.51.15654057987328783', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '59.63.206.70', '2019-08-10 10:56:39', 1, 1002001015, '账号未登陆', '2019-08-10 10:56:39');
INSERT INTO `access_log` VALUES (65010, '65.47.15654057987328667', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '59.63.206.70', '2019-08-10 10:56:39', 0, 1002001015, '账号未登陆', '2019-08-10 10:56:39');
INSERT INTO `access_log` VALUES (65011, '65.52.15654057987318745', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '59.63.206.70', '2019-08-10 10:56:39', 0, 1002001015, '账号未登陆', '2019-08-10 10:56:39');
INSERT INTO `access_log` VALUES (65012, '65.53.15654058138368683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '59.63.206.70', '2019-08-10 10:56:54', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-10 10:56:54');
INSERT INTO `access_log` VALUES (65013, '65.46.15654058219558741', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '59.63.206.70', '2019-08-10 10:57:02', 92, 0, '', '2019-08-10 10:57:02');
INSERT INTO `access_log` VALUES (65014, '65.54.15654058224848603', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '59.63.206.70', '2019-08-10 10:57:02', 14, 0, '', '2019-08-10 10:57:02');
INSERT INTO `access_log` VALUES (65015, '65.45.15654058225008705', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '59.63.206.70', '2019-08-10 10:57:03', 13, 2001001000, '服务端发生异常', '2019-08-10 10:57:03');
INSERT INTO `access_log` VALUES (65016, '65.49.15654058225008703', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '59.63.206.70', '2019-08-10 10:57:03', 13, 0, '', '2019-08-10 10:57:03');
INSERT INTO `access_log` VALUES (65017, '65.51.15654058418178785', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '59.63.206.70', '2019-08-10 10:57:22', 10, 0, '', '2019-08-10 10:57:22');
INSERT INTO `access_log` VALUES (65018, '65.50.15654058418308707', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '59.63.206.70', '2019-08-10 10:57:22', 109, 2001001000, '服务端发生异常', '2019-08-10 10:57:22');
INSERT INTO `access_log` VALUES (65019, '65.47.15654058418298669', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '59.63.206.70', '2019-08-10 10:57:22', 109, 0, '', '2019-08-10 10:57:22');
INSERT INTO `access_log` VALUES (65020, '59.72.15654073206095943', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.155.1.225', '2019-08-10 11:22:01', 9, 0, '', '2019-08-10 11:22:01');
INSERT INTO `access_log` VALUES (65021, '59.78.15654073206145951', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.155.1.225', '2019-08-10 11:22:01', 18, 2001001000, '服务端发生异常', '2019-08-10 11:22:01');
INSERT INTO `access_log` VALUES (65022, '64.84.15654155487076379', 0, 2, 'product-application', '/product-api/admins/attr/add', 'name=颜色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.213.93.7', '2019-08-10 13:39:09', 1, 1002001015, '账号未登陆', '2019-08-10 13:39:09');
INSERT INTO `access_log` VALUES (65023, '64.81.15654155987386385', 0, 2, 'product-application', '/product-api/admins/spu/info', 'id=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.213.93.7', '2019-08-10 13:39:59', 0, 1002001015, '账号未登陆', '2019-08-10 13:39:59');
INSERT INTO `access_log` VALUES (65024, '59.75.15654176856956097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.65.231.8', '2019-08-10 14:14:46', 19, 2001001000, '服务端发生异常', '2019-08-10 14:14:46');
INSERT INTO `access_log` VALUES (65025, '59.79.15654176856946091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.23.154.214', '2019-08-10 14:14:46', 87, 0, '', '2019-08-10 14:14:46');
INSERT INTO `access_log` VALUES (65026, '65.3607.15654177000760663', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.65.231.8', '2019-08-10 14:15:00', 4, 1002001012, '访问令牌已过期', '2019-08-10 14:15:00');
INSERT INTO `access_log` VALUES (65027, '65.52.15654177000768905', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.65.231.8', '2019-08-10 14:15:00', 4, 1002001012, '访问令牌已过期', '2019-08-10 14:15:00');
INSERT INTO `access_log` VALUES (65028, '65.53.15654177000798843', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.23.154.214', '2019-08-10 14:15:00', 4, 1002001012, '访问令牌已过期', '2019-08-10 14:15:00');
INSERT INTO `access_log` VALUES (65029, '65.46.15654177030698903', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.23.154.214', '2019-08-10 14:15:03', 66, 0, '', '2019-08-10 14:15:03');
INSERT INTO `access_log` VALUES (65030, '65.45.15654177034518867', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.23.154.214', '2019-08-10 14:15:03', 14, 0, '', '2019-08-10 14:15:03');
INSERT INTO `access_log` VALUES (65031, '65.54.15654177034518763', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.23.154.214', '2019-08-10 14:15:03', 15, 2001001000, '服务端发生异常', '2019-08-10 14:15:03');
INSERT INTO `access_log` VALUES (65032, '65.49.15654177034578865', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.23.154.214', '2019-08-10 14:15:03', 10, 0, '', '2019-08-10 14:15:03');
INSERT INTO `access_log` VALUES (65033, '65.50.15654177141278867', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.23.154.214', '2019-08-10 14:15:14', 18, 0, '', '2019-08-10 14:15:14');
INSERT INTO `access_log` VALUES (65034, '65.3607.15654177141270665', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.23.154.214', '2019-08-10 14:15:14', 17, 0, '', '2019-08-10 14:15:14');
INSERT INTO `access_log` VALUES (65035, '65.51.15654177141278947', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.23.154.214', '2019-08-10 14:15:14', 18, 2001001000, '服务端发生异常', '2019-08-10 14:15:14');
INSERT INTO `access_log` VALUES (65036, '59.76.15654186264406089', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '115.231.19.42', '2019-08-10 14:30:26', 4, 0, '', '2019-08-10 14:30:26');
INSERT INTO `access_log` VALUES (65037, '59.74.15654186264576115', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '115.231.19.40', '2019-08-10 14:30:26', 15, 2001001000, '服务端发生异常', '2019-08-10 14:30:26');
INSERT INTO `access_log` VALUES (65038, '64.76.15654186307186423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '115.231.19.40', '2019-08-10 14:30:31', 10, 0, '', '2019-08-10 14:30:31');
INSERT INTO `access_log` VALUES (65039, '64.85.15654186309506455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '115.231.19.40', '2019-08-10 14:30:31', 2, 0, '', '2019-08-10 14:30:31');
INSERT INTO `access_log` VALUES (65040, '64.79.15654186347726427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '115.231.19.40', '2019-08-10 14:30:35', 2, 0, '', '2019-08-10 14:30:35');
INSERT INTO `access_log` VALUES (65041, '64.84.15654186349186421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '115.231.19.40', '2019-08-10 14:30:35', 2, 0, '', '2019-08-10 14:30:35');
INSERT INTO `access_log` VALUES (65042, '59.80.15654186363156067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '115.231.19.40', '2019-08-10 14:30:36', 2, 0, '', '2019-08-10 14:30:36');
INSERT INTO `access_log` VALUES (65043, '59.78.15654186363076103', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '115.231.19.42', '2019-08-10 14:30:36', 20, 2001001000, '服务端发生异常', '2019-08-10 14:30:36');
INSERT INTO `access_log` VALUES (65044, '65.54.15654186446328777', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.231.19.40', '2019-08-10 14:30:45', 0, 1002001015, '账号未登陆', '2019-08-10 14:30:45');
INSERT INTO `access_log` VALUES (65045, '65.46.15654186446318917', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.231.19.42', '2019-08-10 14:30:45', 0, 1002001015, '账号未登陆', '2019-08-10 14:30:45');
INSERT INTO `access_log` VALUES (65046, '65.45.15654186446338881', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.231.19.42', '2019-08-10 14:30:45', 0, 1002001015, '账号未登陆', '2019-08-10 14:30:45');
INSERT INTO `access_log` VALUES (65047, '65.49.15654186499178879', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.231.19.40', '2019-08-10 14:30:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-10 14:30:50');
INSERT INTO `access_log` VALUES (65048, '65.50.15654186634888881', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.231.19.40', '2019-08-10 14:31:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-10 14:31:03');
INSERT INTO `access_log` VALUES (65049, '65.3607.15654186734130679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.231.19.40', '2019-08-10 14:31:13', 88, 0, '', '2019-08-10 14:31:14');
INSERT INTO `access_log` VALUES (65050, '65.53.15654186738258859', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.231.19.40', '2019-08-10 14:31:14', 15, 2001001000, '服务端发生异常', '2019-08-10 14:31:14');
INSERT INTO `access_log` VALUES (65051, '65.52.15654186738258921', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.231.19.42', '2019-08-10 14:31:14', 17, 0, '', '2019-08-10 14:31:14');
INSERT INTO `access_log` VALUES (65052, '65.46.15654186789878919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.231.19.42', '2019-08-10 14:31:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-10 14:31:19');
INSERT INTO `access_log` VALUES (65053, '65.54.15654186889338779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.231.19.42', '2019-08-10 14:31:29', 229, 0, '', '2019-08-10 14:31:29');
INSERT INTO `access_log` VALUES (65054, '65.49.15654186895278881', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.231.19.42', '2019-08-10 14:31:30', 10, 0, '', '2019-08-10 14:31:30');
INSERT INTO `access_log` VALUES (65055, '65.47.15654186895308845', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '115.231.19.42', '2019-08-10 14:31:30', 11, 2001001000, '服务端发生异常', '2019-08-10 14:31:30');
INSERT INTO `access_log` VALUES (65056, 'b3e47d59-b2c1-454d-af65-a6b816c70bcc', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:35:41', 131, 0, '', '2019-08-10 15:35:41');
INSERT INTO `access_log` VALUES (65057, 'f4462a6a-e766-4421-941c-f53dc6294097', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:35:41', 228, 0, '', '2019-08-10 15:35:41');
INSERT INTO `access_log` VALUES (65058, 'f842caf0-4d12-4da6-bfb4-c1ca253a3922', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:35:48', 53, 0, '', '2019-08-10 15:35:48');
INSERT INTO `access_log` VALUES (65059, 'd5a84dcd-f688-4128-a157-f20ca0936a79', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:35:48', 15, 0, '', '2019-08-10 15:35:48');
INSERT INTO `access_log` VALUES (65060, '8769fee5-012f-4080-a218-31665a4b42ef', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15858248641&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:07', 235, 1001003000, '验证码不存在', '2019-08-10 15:36:08');
INSERT INTO `access_log` VALUES (65061, '6d9b03ff-a579-498c-a20a-0b3c12ca9822', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15858248641', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:12', 111, 0, '', '2019-08-10 15:36:12');
INSERT INTO `access_log` VALUES (65062, '83d066af-01c8-4a8c-8e97-0c0348f53a7a', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15858248641&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:16', 383, 0, '', '2019-08-10 15:36:17');
INSERT INTO `access_log` VALUES (65063, 'e3d82981-dd66-4d2c-a211-20f698b64e64', 195, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:19', 217, 0, '', '2019-08-10 15:36:19');
INSERT INTO `access_log` VALUES (65064, '9e7fa748-337e-4d3f-b19d-37bbc618b969', 195, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:26', 44, 0, '', '2019-08-10 15:36:26');
INSERT INTO `access_log` VALUES (65065, 'fb6b2288-e3d1-4efd-98b5-68c1c808b3d5', 195, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:26', 39, 0, '', '2019-08-10 15:36:26');
INSERT INTO `access_log` VALUES (65066, 'b08aceca-721c-4e5c-a80d-e65acac7e784', 195, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:27', 31, 0, '', '2019-08-10 15:36:27');
INSERT INTO `access_log` VALUES (65067, '1187a1c8-96c8-4359-aadf-f248f21fee53', 195, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:28', 39, 0, '', '2019-08-10 15:36:28');
INSERT INTO `access_log` VALUES (65068, 'c32f7049-288f-4b15-8b0a-0d59038d1617', 195, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:29', 47, 0, '', '2019-08-10 15:36:29');
INSERT INTO `access_log` VALUES (65069, 'a0d273be-bd8b-4167-ac1b-3ed613728962', 195, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:29', 67, 0, '', '2019-08-10 15:36:29');
INSERT INTO `access_log` VALUES (65070, 'f1b97955-2fd9-4804-a4c1-22f0d9dd309a', 195, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:32', 32, 0, '', '2019-08-10 15:36:32');
INSERT INTO `access_log` VALUES (65071, 'bcfb48c2-c966-4cbf-920f-291cb61ea8e7', 195, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:32', 32, 0, '', '2019-08-10 15:36:32');
INSERT INTO `access_log` VALUES (65072, '0f1ea406-6f04-43f9-b453-2922d9ba3c85', 195, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:33', 39, 0, '', '2019-08-10 15:36:33');
INSERT INTO `access_log` VALUES (65073, 'd7e2bad4-d913-4935-a203-b53d9bacea6e', 195, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:33', 36, 0, '', '2019-08-10 15:36:33');
INSERT INTO `access_log` VALUES (65074, '597be201-9cbf-4d4e-a15f-e0cf9a42d35f', 195, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:34', 39, 0, '', '2019-08-10 15:36:34');
INSERT INTO `access_log` VALUES (65075, '49c333e3-c592-4722-b41a-0a60d005edcf', 195, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-10 15:36:34', 51, 0, '', '2019-08-10 15:36:34');
INSERT INTO `access_log` VALUES (65076, '6233c7e2-606f-4f7f-96ba-2b1f9e51488a', 195, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '127.0.0.1', '2019-08-10 15:37:05', 44, 0, '', '2019-08-10 15:37:05');
INSERT INTO `access_log` VALUES (65077, '95699c13-ac1f-42a0-9554-e62e1033f53d', 195, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '127.0.0.1', '2019-08-10 15:37:05', 118, 0, '', '2019-08-10 15:37:05');
INSERT INTO `access_log` VALUES (65078, '832fb49a-2d2b-4a4a-8263-240eeba00eb9', 195, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '127.0.0.1', '2019-08-10 15:37:05', 142, 0, '', '2019-08-10 15:37:05');
INSERT INTO `access_log` VALUES (65079, '256897ec-6374-476b-bec0-1b9d932ce789', 195, 1, 'order-impl', '/order-api/users/cart/add', 'skuId=38&quantity=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '127.0.0.1', '2019-08-10 15:37:16', 154, 0, '', '2019-08-10 15:37:17');
INSERT INTO `access_log` VALUES (65080, 'a0a47be3-77b3-4ebd-a5f1-da8e1fc9db6b', 195, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '127.0.0.1', '2019-08-10 15:37:20', 72, 0, '', '2019-08-10 15:37:20');
INSERT INTO `access_log` VALUES (65081, '797d3d66-5c9a-4476-848d-e0759756a46d', 195, 1, 'order-impl', '/order-api/users/order/confirm_create_order', 'skuId=38&quantity=1', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '127.0.0.1', '2019-08-10 15:37:20', 149, 0, '', '2019-08-10 15:37:20');
INSERT INTO `access_log` VALUES (65082, 'ed5f90d3-4d3c-49e3-8ba6-e7b8aa0ade6c', 195, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '127.0.0.1', '2019-08-10 15:37:24', 40, 0, '', '2019-08-10 15:37:24');
INSERT INTO `access_log` VALUES (65083, '65.53.15654232419808921', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.12.236.16', '2019-08-10 15:47:22', 1, 1002001015, '账号未登陆', '2019-08-10 15:47:22');
INSERT INTO `access_log` VALUES (65084, '65.52.15654232419818983', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.12.236.16', '2019-08-10 15:47:22', 1, 1002001015, '账号未登陆', '2019-08-10 15:47:22');
INSERT INTO `access_log` VALUES (65085, '65.46.15654232420098981', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.12.236.16', '2019-08-10 15:47:22', 0, 1002001015, '账号未登陆', '2019-08-10 15:47:22');
INSERT INTO `access_log` VALUES (65086, '65.54.15654232447848841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.12.236.16', '2019-08-10 15:47:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-10 15:47:25');
INSERT INTO `access_log` VALUES (65087, '65.47.15654232540828907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.12.236.16', '2019-08-10 15:47:34', 61, 0, '', '2019-08-10 15:47:34');
INSERT INTO `access_log` VALUES (65088, '65.49.15654232544008943', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.12.236.16', '2019-08-10 15:47:34', 11, 0, '', '2019-08-10 15:47:34');
INSERT INTO `access_log` VALUES (65089, '65.50.15654232544098945', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.12.236.16', '2019-08-10 15:47:34', 18, 2001001000, '服务端发生异常', '2019-08-10 15:47:34');
INSERT INTO `access_log` VALUES (65090, '65.51.15654232544109025', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.12.236.16', '2019-08-10 15:47:34', 17, 0, '', '2019-08-10 15:47:34');
INSERT INTO `access_log` VALUES (65091, '59.77.15654233279356149', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.12.236.16', '2019-08-10 15:48:48', 10, 0, '', '2019-08-10 15:48:48');
INSERT INTO `access_log` VALUES (65092, '59.71.15654233279356159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.12.236.16', '2019-08-10 15:48:48', 19, 2001001000, '服务端发生异常', '2019-08-10 15:48:48');
INSERT INTO `access_log` VALUES (65093, '64.78.15654233344706489', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.12.236.16', '2019-08-10 15:48:54', 13, 0, '', '2019-08-10 15:48:54');
INSERT INTO `access_log` VALUES (65094, '64.83.15654233345906481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.12.236.16', '2019-08-10 15:48:55', 4, 0, '', '2019-08-10 15:48:55');
INSERT INTO `access_log` VALUES (65095, '59.76.15654233426006153', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:49:03', 3, 0, '', '2019-08-10 15:49:03');
INSERT INTO `access_log` VALUES (65096, '59.74.15654233426016179', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:49:03', 30, 2001001000, '服务端发生异常', '2019-08-10 15:49:03');
INSERT INTO `access_log` VALUES (65097, '64.76.15654233454196487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:49:05', 2, 0, '', '2019-08-10 15:49:05');
INSERT INTO `access_log` VALUES (65098, '64.79.15654233455386491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:49:06', 1, 0, '', '2019-08-10 15:49:06');
INSERT INTO `access_log` VALUES (65099, '64.84.15654233475216485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:49:08', 2, 0, '', '2019-08-10 15:49:08');
INSERT INTO `access_log` VALUES (65100, '64.77.15654233490566479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:49:09', 2, 0, '', '2019-08-10 15:49:09');
INSERT INTO `access_log` VALUES (65101, '64.80.15654233498246491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:49:10', 2, 0, '', '2019-08-10 15:49:10');
INSERT INTO `access_log` VALUES (65102, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:49:10', 6, 0, '', '2019-08-10 15:49:10');
INSERT INTO `access_log` VALUES (65103, '64.82.15654233516696499', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:49:12', 8, 0, '', '2019-08-10 15:49:12');
INSERT INTO `access_log` VALUES (65104, '64.81.15654233583126491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:49:18', 2, 0, '', '2019-08-10 15:49:18');
INSERT INTO `access_log` VALUES (65105, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:49:18', 6, 0, '', '2019-08-10 15:49:18');
INSERT INTO `access_log` VALUES (65106, '64.78.15654233593296491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:49:19', 2, 0, '', '2019-08-10 15:49:19');
INSERT INTO `access_log` VALUES (65107, '64.83.15654233594676483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:49:19', 2, 0, '', '2019-08-10 15:49:19');
INSERT INTO `access_log` VALUES (65108, '64.85.15654235236066523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:52:04', 2, 0, '', '2019-08-10 15:52:04');
INSERT INTO `access_log` VALUES (65109, '64.79.15654235240246495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:52:04', 2, 0, '', '2019-08-10 15:52:04');
INSERT INTO `access_log` VALUES (65110, '64.80.15654235551816495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:52:35', 2, 0, '', '2019-08-10 15:52:35');
INSERT INTO `access_log` VALUES (65111, '64.81.15654235562696495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.12.236.16', '2019-08-10 15:52:36', 3, 0, '', '2019-08-10 15:52:36');
INSERT INTO `access_log` VALUES (65112, '59.75.15654270934856223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 16:51:33', 11, 0, '', '2019-08-10 16:51:33');
INSERT INTO `access_log` VALUES (65113, '59.79.15654270934866217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 16:51:33', 17, 2001001000, '服务端发生异常', '2019-08-10 16:51:34');
INSERT INTO `access_log` VALUES (65114, '64.77.15654271003186531', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 16:51:40', 11, 0, '', '2019-08-10 16:51:40');
INSERT INTO `access_log` VALUES (65115, '64.80.15654271006806543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 16:51:41', 3, 0, '', '2019-08-10 16:51:41');
INSERT INTO `access_log` VALUES (65116, '64.82.15654271019156551', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 16:51:42', 2, 0, '', '2019-08-10 16:51:42');
INSERT INTO `access_log` VALUES (65117, '64.81.15654271022416543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 16:51:42', 2, 0, '', '2019-08-10 16:51:42');
INSERT INTO `access_log` VALUES (65118, '64.78.15654271029656543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 16:51:43', 2, 0, '', '2019-08-10 16:51:43');
INSERT INTO `access_log` VALUES (65119, '65.3607.15654271093770797', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 16:51:49', 1, 1002001015, '账号未登陆', '2019-08-10 16:51:49');
INSERT INTO `access_log` VALUES (65120, '65.53.15654271093778975', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 16:51:49', 0, 1002001015, '账号未登陆', '2019-08-10 16:51:49');
INSERT INTO `access_log` VALUES (65121, '65.54.15654271093978897', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 16:51:49', 1, 1002001015, '账号未登陆', '2019-08-10 16:51:49');
INSERT INTO `access_log` VALUES (65122, '65.47.15654271204238961', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 16:52:00', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-10 16:52:00');
INSERT INTO `access_log` VALUES (65123, '65.49.15654280189269011', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.101.149.230', '2019-08-10 17:06:59', 0, 1002001015, '账号未登陆', '2019-08-10 17:06:59');
INSERT INTO `access_log` VALUES (65124, '65.50.15654280189349009', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.101.149.230', '2019-08-10 17:06:59', 0, 1002001015, '账号未登陆', '2019-08-10 17:06:59');
INSERT INTO `access_log` VALUES (65125, '65.51.15654280189379091', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.101.149.230', '2019-08-10 17:06:59', 0, 1002001015, '账号未登陆', '2019-08-10 17:06:59');
INSERT INTO `access_log` VALUES (65126, '65.46.15654280213969051', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.101.149.230', '2019-08-10 17:07:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-10 17:07:01');
INSERT INTO `access_log` VALUES (65127, '65.54.15654280337488911', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.101.149.230', '2019-08-10 17:07:14', 106, 0, '', '2019-08-10 17:07:14');
INSERT INTO `access_log` VALUES (65128, '65.53.15654280341348989', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.101.149.230', '2019-08-10 17:07:14', 11, 0, '', '2019-08-10 17:07:14');
INSERT INTO `access_log` VALUES (65129, '65.3607.15654280341370811', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.101.149.230', '2019-08-10 17:07:14', 11, 2001001000, '服务端发生异常', '2019-08-10 17:07:14');
INSERT INTO `access_log` VALUES (65130, '65.45.15654280341449013', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '58.101.149.230', '2019-08-10 17:07:14', 8, 0, '', '2019-08-10 17:07:14');
INSERT INTO `access_log` VALUES (65131, '65.47.15654287812108985', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 17:19:41', 64, 0, '', '2019-08-10 17:19:41');
INSERT INTO `access_log` VALUES (65132, '65.50.15654287815809021', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 17:19:42', 10, 0, '', '2019-08-10 17:19:42');
INSERT INTO `access_log` VALUES (65133, '65.49.15654287815809023', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 17:19:42', 11, 0, '', '2019-08-10 17:19:42');
INSERT INTO `access_log` VALUES (65134, '65.51.15654287815809103', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/77.0.3865.10 Safari/537.36 Edg/77.0.235.5', '180.111.71.72', '2019-08-10 17:19:42', 11, 2001001000, '服务端发生异常', '2019-08-10 17:19:42');
INSERT INTO `access_log` VALUES (65135, '59.78.15654304692076263', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.54.29.219', '2019-08-10 17:47:49', 19, 0, '', '2019-08-10 17:47:49');
INSERT INTO `access_log` VALUES (65136, '59.80.15654304692086227', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.54.29.219', '2019-08-10 17:47:49', 22, 2001001000, '服务端发生异常', '2019-08-10 17:47:49');
INSERT INTO `access_log` VALUES (65137, '59.76.15654499385646509', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.10.65.130', '2019-08-10 23:12:19', 11, 0, '', '2019-08-10 23:12:19');
INSERT INTO `access_log` VALUES (65138, '59.74.15654499386036533', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.10.65.130', '2019-08-10 23:12:19', 21, 2001001000, '服务端发生异常', '2019-08-10 23:12:19');
INSERT INTO `access_log` VALUES (65139, '64.79.15654499449676849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.10.65.130', '2019-08-10 23:12:25', 12, 0, '', '2019-08-10 23:12:25');
INSERT INTO `access_log` VALUES (65140, '64.84.15654499451756843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.10.65.130', '2019-08-10 23:12:25', 3, 0, '', '2019-08-10 23:12:25');
INSERT INTO `access_log` VALUES (65141, '64.77.15654499495886837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.10.65.130', '2019-08-10 23:12:30', 2, 0, '', '2019-08-10 23:12:30');
INSERT INTO `access_log` VALUES (65142, '64.80.15654499497256849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.10.65.130', '2019-08-10 23:12:30', 2, 0, '', '2019-08-10 23:12:30');
INSERT INTO `access_log` VALUES (65143, '59.76.15654566576266599', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 01:04:18', 10, 0, '', '2019-08-11 01:04:18');
INSERT INTO `access_log` VALUES (65144, '59.74.15654566576566623', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 01:04:18', 13, 2001001000, '服务端发生异常', '2019-08-11 01:04:18');
INSERT INTO `access_log` VALUES (65145, '64.77.15654566638596927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 01:04:24', 11, 0, '', '2019-08-11 01:04:24');
INSERT INTO `access_log` VALUES (65146, '64.80.15654566641066939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 01:04:24', 3, 0, '', '2019-08-11 01:04:24');
INSERT INTO `access_log` VALUES (65147, '64.82.15654566654426947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 01:04:25', 2, 0, '', '2019-08-11 01:04:25');
INSERT INTO `access_log` VALUES (65148, '59.75.15654566670906619', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 01:04:27', 3, 0, '', '2019-08-11 01:04:27');
INSERT INTO `access_log` VALUES (65149, '59.71.15654566670756607', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 01:04:27', 21, 2001001000, '服务端发生异常', '2019-08-11 01:04:27');
INSERT INTO `access_log` VALUES (65150, '59.72.15654823018736949', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 08:11:42', 13, 0, '', '2019-08-11 08:11:42');
INSERT INTO `access_log` VALUES (65151, '59.75.15654823018736961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 08:11:42', 25, 2001001000, '服务端发生异常', '2019-08-11 08:11:42');
INSERT INTO `access_log` VALUES (65152, '64.82.15654823092467289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 08:11:49', 12, 0, '', '2019-08-11 08:11:49');
INSERT INTO `access_log` VALUES (65153, '64.81.15654823094077281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 08:11:49', 3, 0, '', '2019-08-11 08:11:49');
INSERT INTO `access_log` VALUES (65154, '65.52.15654823478569779', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 08:12:28', 1, 1002001015, '账号未登陆', '2019-08-11 08:12:28');
INSERT INTO `access_log` VALUES (65155, '65.54.15654823478579637', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 08:12:28', 0, 1002001015, '账号未登陆', '2019-08-11 08:12:28');
INSERT INTO `access_log` VALUES (65156, '65.46.15654823478709781', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 08:12:28', 0, 1002001015, '账号未登陆', '2019-08-11 08:12:28');
INSERT INTO `access_log` VALUES (65157, '65.3607.15654823559521537', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 08:12:36', 95, 0, '', '2019-08-11 08:12:36');
INSERT INTO `access_log` VALUES (65158, '65.45.15654823564799739', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 08:12:36', 76, 0, '', '2019-08-11 08:12:37');
INSERT INTO `access_log` VALUES (65159, '65.53.15654823564889715', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 08:12:36', 71, 2001001000, '服务端发生异常', '2019-08-11 08:12:37');
INSERT INTO `access_log` VALUES (65160, '65.47.15654823564879703', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 08:12:36', 71, 0, '', '2019-08-11 08:12:37');
INSERT INTO `access_log` VALUES (65161, '65.50.15654823653699737', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 08:12:45', 10, 0, '', '2019-08-11 08:12:45');
INSERT INTO `access_log` VALUES (65162, '65.51.15654823653799821', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 08:12:45', 10, 0, '', '2019-08-11 08:12:45');
INSERT INTO `access_log` VALUES (65163, '65.54.15654823653829639', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.102.228.120', '2019-08-11 08:12:45', 8, 2001001000, '服务端发生异常', '2019-08-11 08:12:45');
INSERT INTO `access_log` VALUES (65164, '65.47.15654827127309709', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.32.39', '2019-08-11 08:18:33', 0, 1002001015, '账号未登陆', '2019-08-11 08:18:33');
INSERT INTO `access_log` VALUES (65165, '65.53.15654827127359721', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.32.39', '2019-08-11 08:18:33', 1, 1002001015, '账号未登陆', '2019-08-11 08:18:33');
INSERT INTO `access_log` VALUES (65166, '65.45.15654827127409745', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.32.39', '2019-08-11 08:18:33', 0, 1002001015, '账号未登陆', '2019-08-11 08:18:33');
INSERT INTO `access_log` VALUES (65167, '65.49.15654827158709745', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.32.39', '2019-08-11 08:18:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 08:18:36');
INSERT INTO `access_log` VALUES (65168, '65.51.15654827214689827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.32.39', '2019-08-11 08:18:41', 63, 0, '', '2019-08-11 08:18:42');
INSERT INTO `access_log` VALUES (65169, '65.54.15654827217179645', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.32.39', '2019-08-11 08:18:42', 7, 0, '', '2019-08-11 08:18:42');
INSERT INTO `access_log` VALUES (65170, '65.46.15654827217189789', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.32.39', '2019-08-11 08:18:42', 8, 2001001000, '服务端发生异常', '2019-08-11 08:18:42');
INSERT INTO `access_log` VALUES (65171, '65.52.15654827217269787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.32.39', '2019-08-11 08:18:42', 8, 0, '', '2019-08-11 08:18:42');
INSERT INTO `access_log` VALUES (65172, '65.3607.15654827299601545', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.32.39', '2019-08-11 08:18:50', 9, 0, '', '2019-08-11 08:18:50');
INSERT INTO `access_log` VALUES (65173, '65.45.15654827299609747', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.32.39', '2019-08-11 08:18:50', 11, 2001001000, '服务端发生异常', '2019-08-11 08:18:50');
INSERT INTO `access_log` VALUES (65174, '65.53.15654827299639723', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.166.32.39', '2019-08-11 08:18:50', 9, 0, '', '2019-08-11 08:18:50');
INSERT INTO `access_log` VALUES (65175, '59.76.15654930067997085', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:07', 11, 0, '', '2019-08-11 11:10:07');
INSERT INTO `access_log` VALUES (65176, '59.74.15654930068027109', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:07', 25, 2001001000, '服务端发生异常', '2019-08-11 11:10:07');
INSERT INTO `access_log` VALUES (65177, '64.79.15654930102577425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:10', 11, 0, '', '2019-08-11 11:10:10');
INSERT INTO `access_log` VALUES (65178, '64.84.15654930104457419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:10', 3, 0, '', '2019-08-11 11:10:10');
INSERT INTO `access_log` VALUES (65179, '64.77.15654930115077413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:12', 1, 0, '', '2019-08-11 11:10:12');
INSERT INTO `access_log` VALUES (65180, '64.80.15654930119177425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:12', 3, 0, '', '2019-08-11 11:10:12');
INSERT INTO `access_log` VALUES (65181, '59.80.15654930133477065', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:13', 3, 0, '', '2019-08-11 11:10:13');
INSERT INTO `access_log` VALUES (65182, '59.71.15654930133487093', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:13', 18, 2001001000, '服务端发生异常', '2019-08-11 11:10:13');
INSERT INTO `access_log` VALUES (65183, '65.3607.15654930200481683', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:20', 1, 1002001015, '账号未登陆', '2019-08-11 11:10:20');
INSERT INTO `access_log` VALUES (65184, '65.45.15654930200489885', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:20', 1, 1002001015, '账号未登陆', '2019-08-11 11:10:20');
INSERT INTO `access_log` VALUES (65185, '65.46.15654930200479927', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:20', 1, 1002001015, '账号未登陆', '2019-08-11 11:10:20');
INSERT INTO `access_log` VALUES (65186, '65.53.15654930229589861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:23', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 11:10:23');
INSERT INTO `access_log` VALUES (65187, '65.49.15654930278569885', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:28', 125, 0, '', '2019-08-11 11:10:28');
INSERT INTO `access_log` VALUES (65188, '65.50.15654930283209883', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:28', 14, 0, '', '2019-08-11 11:10:28');
INSERT INTO `access_log` VALUES (65189, '65.51.15654930283309967', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:28', 11, 2001001000, '服务端发生异常', '2019-08-11 11:10:28');
INSERT INTO `access_log` VALUES (65190, '65.54.15654930283319785', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.203.12.98', '2019-08-11 11:10:28', 10, 0, '', '2019-08-11 11:10:28');
INSERT INTO `access_log` VALUES (65191, '59.76.15654980660557153', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.89.86.191', '2019-08-11 12:34:26', 11, 0, '', '2019-08-11 12:34:26');
INSERT INTO `access_log` VALUES (65192, '59.80.15654980660607133', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '124.89.86.191', '2019-08-11 12:34:26', 15, 2001001000, '服务端发生异常', '2019-08-11 12:34:26');
INSERT INTO `access_log` VALUES (65193, '59.71.15655091461487309', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:06', 9, 0, '', '2019-08-11 15:39:06');
INSERT INTO `access_log` VALUES (65194, '59.80.15655091461487281', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:06', 14, 2001001000, '服务端发生异常', '2019-08-11 15:39:06');
INSERT INTO `access_log` VALUES (65195, '64.84.15655091493457633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:09', 12, 0, '', '2019-08-11 15:39:09');
INSERT INTO `access_log` VALUES (65196, '64.77.15655091494577629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:09', 3, 0, '', '2019-08-11 15:39:09');
INSERT INTO `access_log` VALUES (65197, '59.72.15655091537207309', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:14', 2, 0, '', '2019-08-11 15:39:14');
INSERT INTO `access_log` VALUES (65198, '59.75.15655091537257321', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:14', 10, 2001001000, '服务端发生异常', '2019-08-11 15:39:14');
INSERT INTO `access_log` VALUES (65199, '64.80.15655091565047641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:17', 2, 0, '', '2019-08-11 15:39:17');
INSERT INTO `access_log` VALUES (65200, '64.82.15655091566187649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:17', 2, 0, '', '2019-08-11 15:39:17');
INSERT INTO `access_log` VALUES (65201, '66.48.15655091601074941', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:20', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-08-11 15:39:20');
INSERT INTO `access_log` VALUES (65202, '64.78.15655091714717641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:31', 2, 0, '', '2019-08-11 15:39:31');
INSERT INTO `access_log` VALUES (65203, '64.83.15655091715707633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:32', 2, 0, '', '2019-08-11 15:39:32');
INSERT INTO `access_log` VALUES (65204, '59.77.15655091884707299', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:48', 1, 0, '', '2019-08-11 15:39:48');
INSERT INTO `access_log` VALUES (65205, '59.73.15655091884767313', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:48', 21, 2001001000, '服务端发生异常', '2019-08-11 15:39:48');
INSERT INTO `access_log` VALUES (65206, '64.85.15655091902827671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:50', 47, 0, '', '2019-08-11 15:39:50');
INSERT INTO `access_log` VALUES (65207, '64.84.15655091907047635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:51', 2, 0, '', '2019-08-11 15:39:51');
INSERT INTO `access_log` VALUES (65208, '64.77.15655091919307631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:52', 2, 0, '', '2019-08-11 15:39:52');
INSERT INTO `access_log` VALUES (65209, '64.80.15655091923027643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:52', 2, 0, '', '2019-08-11 15:39:52');
INSERT INTO `access_log` VALUES (65210, '64.82.15655091928587651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.230.4', '2019-08-11 15:39:53', 2, 0, '', '2019-08-11 15:39:53');
INSERT INTO `access_log` VALUES (65211, '65.46.15655109024630167', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.10.253.57', '2019-08-11 16:08:22', 1, 1002001015, '账号未登陆', '2019-08-11 16:08:22');
INSERT INTO `access_log` VALUES (65212, '65.3607.15655109024641923', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.10.253.57', '2019-08-11 16:08:22', 0, 1002001015, '账号未登陆', '2019-08-11 16:08:22');
INSERT INTO `access_log` VALUES (65213, '65.45.15655109024630125', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.10.253.57', '2019-08-11 16:08:22', 1, 1002001015, '账号未登陆', '2019-08-11 16:08:22');
INSERT INTO `access_log` VALUES (65214, '65.47.15655109187650089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.10.253.57', '2019-08-11 16:08:39', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 16:08:39');
INSERT INTO `access_log` VALUES (65215, '65.50.15655109253700123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.10.253.57', '2019-08-11 16:08:45', 70, 0, '', '2019-08-11 16:08:45');
INSERT INTO `access_log` VALUES (65216, '65.54.15655109256200025', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.10.253.57', '2019-08-11 16:08:46', 20, 0, '', '2019-08-11 16:08:46');
INSERT INTO `access_log` VALUES (65217, '65.51.15655109256180207', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.10.253.57', '2019-08-11 16:08:46', 24, 2001001000, '服务端发生异常', '2019-08-11 16:08:46');
INSERT INTO `access_log` VALUES (65218, '65.52.15655109258480167', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.10.253.57', '2019-08-11 16:08:46', 12, 0, '', '2019-08-11 16:08:46');
INSERT INTO `access_log` VALUES (65219, '65.46.15655109529920169', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '112.10.253.57', '2019-08-11 16:09:13', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 16:09:13');
INSERT INTO `access_log` VALUES (65220, '59.71.15655111579717337', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.155.152', '2019-08-11 16:12:38', 10, 0, '', '2019-08-11 16:12:38');
INSERT INTO `access_log` VALUES (65221, '59.80.15655111579727309', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.155.152', '2019-08-11 16:12:38', 16, 2001001000, '服务端发生异常', '2019-08-11 16:12:38');
INSERT INTO `access_log` VALUES (65222, '64.83.15655111727437661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.155.152', '2019-08-11 16:12:53', 11, 0, '', '2019-08-11 16:12:53');
INSERT INTO `access_log` VALUES (65223, '64.76.15655111728627667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.155.152', '2019-08-11 16:12:53', 5, 0, '', '2019-08-11 16:12:53');
INSERT INTO `access_log` VALUES (65224, '64.79.15655111784757671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.155.152', '2019-08-11 16:12:58', 3, 0, '', '2019-08-11 16:12:58');
INSERT INTO `access_log` VALUES (65225, '64.85.15655111786087699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.155.152', '2019-08-11 16:12:59', 2, 0, '', '2019-08-11 16:12:59');
INSERT INTO `access_log` VALUES (65226, '65.3607.15655111935431929', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.155.152', '2019-08-11 16:13:14', 0, 1002001015, '账号未登陆', '2019-08-11 16:13:14');
INSERT INTO `access_log` VALUES (65227, '65.52.15655111935430171', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.155.152', '2019-08-11 16:13:14', 0, 1002001015, '账号未登陆', '2019-08-11 16:13:14');
INSERT INTO `access_log` VALUES (65228, '65.45.15655111935440131', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.155.152', '2019-08-11 16:13:14', 1, 1002001015, '账号未登陆', '2019-08-11 16:13:14');
INSERT INTO `access_log` VALUES (65229, '65.46.15655112011530173', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.155.152', '2019-08-11 16:13:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 16:13:21');
INSERT INTO `access_log` VALUES (65230, '65.47.15655112180580095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.155.152', '2019-08-11 16:13:38', 68, 0, '', '2019-08-11 16:13:38');
INSERT INTO `access_log` VALUES (65231, '65.49.15655112186630131', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.155.152', '2019-08-11 16:13:39', 10, 0, '', '2019-08-11 16:13:39');
INSERT INTO `access_log` VALUES (65232, '65.50.15655112186960129', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.155.152', '2019-08-11 16:13:39', 8, 2001001000, '服务端发生异常', '2019-08-11 16:13:39');
INSERT INTO `access_log` VALUES (65233, '65.51.15655112186980213', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.155.152', '2019-08-11 16:13:39', 7, 0, '', '2019-08-11 16:13:39');
INSERT INTO `access_log` VALUES (65234, '65.52.15655128992180195', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:41:39', 1, 1002001015, '账号未登陆', '2019-08-11 16:41:39');
INSERT INTO `access_log` VALUES (65235, '65.46.15655128992260197', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:41:39', 0, 1002001015, '账号未登陆', '2019-08-11 16:41:39');
INSERT INTO `access_log` VALUES (65236, '65.53.15655128992370131', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:41:39', 0, 1002001015, '账号未登陆', '2019-08-11 16:41:39');
INSERT INTO `access_log` VALUES (65237, '65.47.15655129088470119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:41:49', 84, 0, '', '2019-08-11 16:41:49');
INSERT INTO `access_log` VALUES (65238, '65.49.15655129092160155', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:41:49', 361, 0, '', '2019-08-11 16:41:50');
INSERT INTO `access_log` VALUES (65239, '65.50.15655129092470153', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:41:49', 333, 0, '', '2019-08-11 16:41:50');
INSERT INTO `access_log` VALUES (65240, '65.51.15655129092230237', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:41:49', 356, 2001001000, '服务端发生异常', '2019-08-11 16:41:50');
INSERT INTO `access_log` VALUES (65241, '65.3607.15655129355541955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:16', 10, 0, '', '2019-08-11 16:42:16');
INSERT INTO `access_log` VALUES (65242, '65.46.15655129355730199', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:16', 9, 0, '', '2019-08-11 16:42:16');
INSERT INTO `access_log` VALUES (65243, '65.52.15655129355730197', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:16', 9, 2001001000, '服务端发生异常', '2019-08-11 16:42:16');
INSERT INTO `access_log` VALUES (65244, '65.53.15655129389560133', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:19', 10, 0, '', '2019-08-11 16:42:19');
INSERT INTO `access_log` VALUES (65245, '65.50.15655129389630155', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:19', 9, 0, '', '2019-08-11 16:42:19');
INSERT INTO `access_log` VALUES (65246, '65.47.15655129389620121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:19', 10, 2001001000, '服务端发生异常', '2019-08-11 16:42:19');
INSERT INTO `access_log` VALUES (65247, '65.49.15655129479170157', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 16:42:28');
INSERT INTO `access_log` VALUES (65248, '65.54.15655129556750057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:36', 91, 0, '', '2019-08-11 16:42:36');
INSERT INTO `access_log` VALUES (65249, '65.45.15655129559770159', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:36', 10, 0, '', '2019-08-11 16:42:36');
INSERT INTO `access_log` VALUES (65250, '65.3607.15655129559771957', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:36', 10, 0, '', '2019-08-11 16:42:36');
INSERT INTO `access_log` VALUES (65251, '65.46.15655129559940201', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:36', 8, 0, '', '2019-08-11 16:42:36');
INSERT INTO `access_log` VALUES (65252, '64.85.15655129677557723', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:48', 19, 0, '', '2019-08-11 16:42:48');
INSERT INTO `access_log` VALUES (65253, '64.84.15655129677627687', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:48', 14, 0, '', '2019-08-11 16:42:48');
INSERT INTO `access_log` VALUES (65254, '64.80.15655129685497695', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:49', 8, 0, '', '2019-08-11 16:42:49');
INSERT INTO `access_log` VALUES (65255, '64.77.15655129685437683', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:49', 15, 0, '', '2019-08-11 16:42:49');
INSERT INTO `access_log` VALUES (65256, '66.51.15655129759845005', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.93.223.104', '2019-08-11 16:42:56', 27, 0, '', '2019-08-11 16:42:56');
INSERT INTO `access_log` VALUES (65257, '65.53.15655152215860165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '125.86.88.126', '2019-08-11 17:20:22', 163, 0, '', '2019-08-11 17:20:22');
INSERT INTO `access_log` VALUES (65258, '65.50.15655152222370187', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '125.86.88.126', '2019-08-11 17:20:22', 14, 2001001000, '服务端发生异常', '2019-08-11 17:20:22');
INSERT INTO `access_log` VALUES (65259, '65.47.15655152222410153', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '125.86.88.126', '2019-08-11 17:20:22', 12, 0, '', '2019-08-11 17:20:22');
INSERT INTO `access_log` VALUES (65260, '65.51.15655152224350271', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '125.86.88.126', '2019-08-11 17:20:22', 15, 0, '', '2019-08-11 17:20:22');
INSERT INTO `access_log` VALUES (65261, '59.77.15655158787357389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.87.21', '2019-08-11 17:31:19', 10, 0, '', '2019-08-11 17:31:19');
INSERT INTO `access_log` VALUES (65262, '59.73.15655158787357403', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.87.21', '2019-08-11 17:31:19', 32, 2001001000, '服务端发生异常', '2019-08-11 17:31:19');
INSERT INTO `access_log` VALUES (65263, '64.79.15655158944307735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.87.21', '2019-08-11 17:31:34', 12, 0, '', '2019-08-11 17:31:34');
INSERT INTO `access_log` VALUES (65264, '64.85.15655158945847763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.87.21', '2019-08-11 17:31:35', 3, 0, '', '2019-08-11 17:31:35');
INSERT INTO `access_log` VALUES (65265, '64.80.15655158978407735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.87.21', '2019-08-11 17:31:38', 2, 0, '', '2019-08-11 17:31:38');
INSERT INTO `access_log` VALUES (65266, '64.77.15655158989857723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.87.21', '2019-08-11 17:31:39', 2, 0, '', '2019-08-11 17:31:39');
INSERT INTO `access_log` VALUES (65267, '64.82.15655159043907743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.87.21', '2019-08-11 17:31:44', 2, 0, '', '2019-08-11 17:31:44');
INSERT INTO `access_log` VALUES (65268, '64.81.15655159045757735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.87.21', '2019-08-11 17:31:45', 2, 0, '', '2019-08-11 17:31:45');
INSERT INTO `access_log` VALUES (65269, '59.80.15655159142347373', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.87.21', '2019-08-11 17:31:54', 3, 0, '', '2019-08-11 17:31:54');
INSERT INTO `access_log` VALUES (65270, '59.72.15655159142347401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.87.21', '2019-08-11 17:31:54', 17, 2001001000, '服务端发生异常', '2019-08-11 17:31:54');
INSERT INTO `access_log` VALUES (65271, '65.54.15655161345400101', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.87.21', '2019-08-11 17:35:35', 1, 1002001015, '账号未登陆', '2019-08-11 17:35:35');
INSERT INTO `access_log` VALUES (65272, '65.46.15655161345560245', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.87.21', '2019-08-11 17:35:35', 0, 1002001015, '账号未登陆', '2019-08-11 17:35:35');
INSERT INTO `access_log` VALUES (65273, '65.3607.15655161345662001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.87.21', '2019-08-11 17:35:35', 0, 1002001015, '账号未登陆', '2019-08-11 17:35:35');
INSERT INTO `access_log` VALUES (65274, '65.45.15655161376680203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.87.21', '2019-08-11 17:35:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 17:35:38');
INSERT INTO `access_log` VALUES (65275, '65.47.15655166114650173', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.1.224.35', '2019-08-11 17:43:31', 1, 1002001015, '账号未登陆', '2019-08-11 17:43:31');
INSERT INTO `access_log` VALUES (65276, '65.50.15655166114650207', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.1.224.35', '2019-08-11 17:43:31', 1, 1002001015, '账号未登陆', '2019-08-11 17:43:31');
INSERT INTO `access_log` VALUES (65277, '65.51.15655166114710291', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.1.224.35', '2019-08-11 17:43:31', 0, 1002001015, '账号未登陆', '2019-08-11 17:43:31');
INSERT INTO `access_log` VALUES (65278, '65.49.15655166168790209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.1.224.247', '2019-08-11 17:43:37', 84, 0, '', '2019-08-11 17:43:37');
INSERT INTO `access_log` VALUES (65279, '65.54.15655166173510109', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.1.224.247', '2019-08-11 17:43:37', 9, 0, '', '2019-08-11 17:43:37');
INSERT INTO `access_log` VALUES (65280, '65.46.15655166173570253', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.1.224.35', '2019-08-11 17:43:37', 9, 2001001000, '服务端发生异常', '2019-08-11 17:43:37');
INSERT INTO `access_log` VALUES (65281, '65.3607.15655166173622009', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.1.224.35', '2019-08-11 17:43:37', 10, 0, '', '2019-08-11 17:43:37');
INSERT INTO `access_log` VALUES (65282, '65.50.15655166500550209', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.1.224.35', '2019-08-11 17:44:10', 8, 0, '', '2019-08-11 17:44:10');
INSERT INTO `access_log` VALUES (65283, '65.47.15655166500630175', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.1.224.247', '2019-08-11 17:44:10', 7, 0, '', '2019-08-11 17:44:10');
INSERT INTO `access_log` VALUES (65284, '65.51.15655166500620293', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.1.224.247', '2019-08-11 17:44:10', 8, 2001001000, '服务端发生异常', '2019-08-11 17:44:10');
INSERT INTO `access_log` VALUES (65285, '65.49.15655166549760211', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '218.1.224.35', '2019-08-11 17:44:15', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 17:44:15');
INSERT INTO `access_log` VALUES (65286, '59.79.15655208927607475', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.97.174.175', '2019-08-11 18:54:53', 11, 0, '', '2019-08-11 18:54:53');
INSERT INTO `access_log` VALUES (65287, '59.77.15655208927627457', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.97.174.175', '2019-08-11 18:54:53', 21, 2001001000, '服务端发生异常', '2019-08-11 18:54:53');
INSERT INTO `access_log` VALUES (65288, '65.52.15655209144530309', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.97.174.175', '2019-08-11 18:55:14', 0, 1002001015, '账号未登陆', '2019-08-11 18:55:14');
INSERT INTO `access_log` VALUES (65289, '65.53.15655209144570245', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.97.174.175', '2019-08-11 18:55:14', 1, 1002001015, '账号未登陆', '2019-08-11 18:55:14');
INSERT INTO `access_log` VALUES (65290, '65.51.15655209144570351', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.97.174.175', '2019-08-11 18:55:14', 1, 1002001015, '账号未登陆', '2019-08-11 18:55:14');
INSERT INTO `access_log` VALUES (65291, '65.47.15655209365050233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.97.174.175', '2019-08-11 18:55:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 18:55:37');
INSERT INTO `access_log` VALUES (65292, '65.52.15655210021530311', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.97.174.175', '2019-08-11 18:56:42', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 18:56:42');
INSERT INTO `access_log` VALUES (65293, '65.51.15655259693400419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.10.253.57', '2019-08-11 20:19:29', 14, 1002002001, '密码不正确', '2019-08-11 20:19:29');
INSERT INTO `access_log` VALUES (65294, '65.50.15655259763400335', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.10.253.57', '2019-08-11 20:19:36', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 20:19:36');
INSERT INTO `access_log` VALUES (65295, '65.49.15655259877850337', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.10.253.57', '2019-08-11 20:19:48', 60, 0, '', '2019-08-11 20:19:48');
INSERT INTO `access_log` VALUES (65296, '65.46.15655259880400381', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.10.253.57', '2019-08-11 20:19:48', 9, 0, '', '2019-08-11 20:19:48');
INSERT INTO `access_log` VALUES (65297, '65.3607.15655259880452137', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.10.253.57', '2019-08-11 20:19:48', 17, 0, '', '2019-08-11 20:19:48');
INSERT INTO `access_log` VALUES (65298, '65.54.15655259880420237', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.10.253.57', '2019-08-11 20:19:48', 26, 2001001000, '服务端发生异常', '2019-08-11 20:19:48');
INSERT INTO `access_log` VALUES (65299, '59.72.15655280271077563', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3768.400', '117.28.180.143', '2019-08-11 20:53:47', 10, 0, '', '2019-08-11 20:53:47');
INSERT INTO `access_log` VALUES (65300, '59.75.15655280271137575', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3768.400', '117.28.180.143', '2019-08-11 20:53:47', 18, 2001001000, '服务端发生异常', '2019-08-11 20:53:47');
INSERT INTO `access_log` VALUES (65301, '64.81.15655280362257897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '117.28.180.143', '2019-08-11 20:53:56', 13, 0, '', '2019-08-11 20:53:56');
INSERT INTO `access_log` VALUES (65302, '64.78.15655280363647897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '117.28.180.143', '2019-08-11 20:53:56', 3, 0, '', '2019-08-11 20:53:56');
INSERT INTO `access_log` VALUES (65303, '64.83.15655280378347889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '117.28.180.143', '2019-08-11 20:53:58', 1, 0, '', '2019-08-11 20:53:58');
INSERT INTO `access_log` VALUES (65304, '64.76.15655280384677895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '117.28.180.143', '2019-08-11 20:53:58', 2, 0, '', '2019-08-11 20:53:58');
INSERT INTO `access_log` VALUES (65305, '65.3607.15655310386132205', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.136.6.148', '2019-08-11 21:43:59', 0, 1002001015, '账号未登陆', '2019-08-11 21:43:59');
INSERT INTO `access_log` VALUES (65306, '65.46.15655310386120449', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.136.6.148', '2019-08-11 21:43:59', 0, 1002001015, '账号未登陆', '2019-08-11 21:43:59');
INSERT INTO `access_log` VALUES (65307, '65.54.15655310386130305', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.136.6.148', '2019-08-11 21:43:59', 1, 1002001015, '账号未登陆', '2019-08-11 21:43:59');
INSERT INTO `access_log` VALUES (65308, '65.45.15655310402410407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.136.6.148', '2019-08-11 21:44:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 21:44:00');
INSERT INTO `access_log` VALUES (65309, '65.53.15655310515450383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.136.6.148', '2019-08-11 21:44:12', 106, 0, '', '2019-08-11 21:44:12');
INSERT INTO `access_log` VALUES (65310, '65.51.15655310518850489', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.136.6.148', '2019-08-11 21:44:12', 21, 0, '', '2019-08-11 21:44:12');
INSERT INTO `access_log` VALUES (65311, '65.50.15655310518850405', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.136.6.148', '2019-08-11 21:44:12', 22, 2001001000, '服务端发生异常', '2019-08-11 21:44:12');
INSERT INTO `access_log` VALUES (65312, '65.47.15655310518890371', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.136.6.148', '2019-08-11 21:44:12', 19, 0, '', '2019-08-11 21:44:12');
INSERT INTO `access_log` VALUES (65313, '65.51.15655325353750509', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:55', 1, 1002001015, '账号未登陆', '2019-08-11 22:08:55');
INSERT INTO `access_log` VALUES (65314, '65.49.15655325353810427', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:55', 1, 1002001015, '账号未登陆', '2019-08-11 22:08:55');
INSERT INTO `access_log` VALUES (65315, '65.3607.15655325353812227', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:55', 0, 1002001015, '账号未登陆', '2019-08-11 22:08:55');
INSERT INTO `access_log` VALUES (65316, '65.54.15655325362860327', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:56', 0, 1002001015, '账号未登陆', '2019-08-11 22:08:56');
INSERT INTO `access_log` VALUES (65317, '65.46.15655325362870471', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:56', 0, 1002001015, '账号未登陆', '2019-08-11 22:08:56');
INSERT INTO `access_log` VALUES (65318, '65.45.15655325363010429', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:56', 1, 1002001015, '账号未登陆', '2019-08-11 22:08:56');
INSERT INTO `access_log` VALUES (65319, '65.52.15655325369560469', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:57', 0, 1002001015, '账号未登陆', '2019-08-11 22:08:57');
INSERT INTO `access_log` VALUES (65320, '65.53.15655325369610405', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:57', 1, 1002001015, '账号未登陆', '2019-08-11 22:08:57');
INSERT INTO `access_log` VALUES (65321, '65.47.15655325369650393', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:57', 1, 1002001015, '账号未登陆', '2019-08-11 22:08:57');
INSERT INTO `access_log` VALUES (65322, '65.50.15655325379970427', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:58', 0, 1002001015, '账号未登陆', '2019-08-11 22:08:58');
INSERT INTO `access_log` VALUES (65323, '65.51.15655325380000511', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:58', 0, 1002001015, '账号未登陆', '2019-08-11 22:08:58');
INSERT INTO `access_log` VALUES (65324, '65.49.15655325380160429', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:58', 0, 1002001015, '账号未登陆', '2019-08-11 22:08:58');
INSERT INTO `access_log` VALUES (65325, '65.3607.15655325391322229', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:59', 1, 1002001015, '账号未登陆', '2019-08-11 22:08:59');
INSERT INTO `access_log` VALUES (65326, '65.46.15655325391330473', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:59', 0, 1002001015, '账号未登陆', '2019-08-11 22:08:59');
INSERT INTO `access_log` VALUES (65327, '65.54.15655325391570329', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:08:59', 0, 1002001015, '账号未登陆', '2019-08-11 22:08:59');
INSERT INTO `access_log` VALUES (65328, '65.45.15655325401660431', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:00', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:00');
INSERT INTO `access_log` VALUES (65329, '65.52.15655325401770471', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:00', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:00');
INSERT INTO `access_log` VALUES (65330, '65.47.15655325401800395', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:00', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:00');
INSERT INTO `access_log` VALUES (65331, '65.53.15655325410560407', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:01', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:01');
INSERT INTO `access_log` VALUES (65332, '65.50.15655325410610429', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:01', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:01');
INSERT INTO `access_log` VALUES (65333, '65.51.15655325410760513', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:01', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:01');
INSERT INTO `access_log` VALUES (65334, '65.49.15655325418180431', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:02', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:02');
INSERT INTO `access_log` VALUES (65335, '65.46.15655325418260475', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:02', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:02');
INSERT INTO `access_log` VALUES (65336, '65.54.15655325418270331', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:02', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:02');
INSERT INTO `access_log` VALUES (65337, '65.52.15655325425170473', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:03', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:03');
INSERT INTO `access_log` VALUES (65338, '65.3607.15655325425162231', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:03', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:03');
INSERT INTO `access_log` VALUES (65339, '65.45.15655325425220433', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:03', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:03');
INSERT INTO `access_log` VALUES (65340, '65.47.15655325432370397', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:03', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:03');
INSERT INTO `access_log` VALUES (65341, '65.50.15655325432470431', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:03', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:03');
INSERT INTO `access_log` VALUES (65342, '65.53.15655325432500409', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:03', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:03');
INSERT INTO `access_log` VALUES (65343, '65.51.15655325441310515', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:04', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:04');
INSERT INTO `access_log` VALUES (65344, '65.54.15655325441360333', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:04', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:04');
INSERT INTO `access_log` VALUES (65345, '65.49.15655325441470433', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:04', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:04');
INSERT INTO `access_log` VALUES (65346, '65.46.15655325451310477', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:05', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:05');
INSERT INTO `access_log` VALUES (65347, '65.52.15655325451410475', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:05', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:05');
INSERT INTO `access_log` VALUES (65348, '65.45.15655325451560435', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:05', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:05');
INSERT INTO `access_log` VALUES (65349, '65.3607.15655325465262233', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:07', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:07');
INSERT INTO `access_log` VALUES (65350, '65.50.15655325465550433', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:07', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:07');
INSERT INTO `access_log` VALUES (65351, '65.53.15655325466230411', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:07', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:07');
INSERT INTO `access_log` VALUES (65352, '65.47.15655325473560399', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:07', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:07');
INSERT INTO `access_log` VALUES (65353, '65.54.15655325473640335', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:07', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:07');
INSERT INTO `access_log` VALUES (65354, '65.51.15655325473760517', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:07', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:07');
INSERT INTO `access_log` VALUES (65355, '65.49.15655325483700435', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:08', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:08');
INSERT INTO `access_log` VALUES (65356, '65.46.15655325483760479', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:08', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:08');
INSERT INTO `access_log` VALUES (65357, '65.52.15655325483810477', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:08', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:08');
INSERT INTO `access_log` VALUES (65358, '65.3607.15655325491002235', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:09', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:09');
INSERT INTO `access_log` VALUES (65359, '65.50.15655325491060435', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:09', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:09');
INSERT INTO `access_log` VALUES (65360, '65.53.15655325491110413', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:09', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:09');
INSERT INTO `access_log` VALUES (65361, '65.47.15655325499000401', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:10', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:10');
INSERT INTO `access_log` VALUES (65362, '65.51.15655325499100519', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:10', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:10');
INSERT INTO `access_log` VALUES (65363, '65.54.15655325499160337', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:10', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:10');
INSERT INTO `access_log` VALUES (65364, '65.52.15655325507360479', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:11', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:11');
INSERT INTO `access_log` VALUES (65365, '65.46.15655325507550481', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:11', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:11');
INSERT INTO `access_log` VALUES (65366, '65.49.15655325507760437', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:11', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:11');
INSERT INTO `access_log` VALUES (65367, '65.45.15655325515150439', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:12', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:12');
INSERT INTO `access_log` VALUES (65368, '65.3607.15655325515372237', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:12', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:12');
INSERT INTO `access_log` VALUES (65369, '65.50.15655325515420437', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:12', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:12');
INSERT INTO `access_log` VALUES (65370, '65.53.15655325522950415', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:12', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:12');
INSERT INTO `access_log` VALUES (65371, '65.47.15655325523000403', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:12', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:12');
INSERT INTO `access_log` VALUES (65372, '65.51.15655325523070521', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:12', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:12');
INSERT INTO `access_log` VALUES (65373, '65.54.15655325530970339', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:13', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:13');
INSERT INTO `access_log` VALUES (65374, '65.46.15655325531020483', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:13', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:13');
INSERT INTO `access_log` VALUES (65375, '65.52.15655325531030481', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:13', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:13');
INSERT INTO `access_log` VALUES (65376, '65.50.15655325538440439', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:14', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:14');
INSERT INTO `access_log` VALUES (65377, '65.49.15655325538430439', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:14', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:14');
INSERT INTO `access_log` VALUES (65378, '65.45.15655325538480441', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:14', 252, 1002001015, '账号未登陆', '2019-08-11 22:09:14');
INSERT INTO `access_log` VALUES (65379, '65.3607.15655325549362239', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:15', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:15');
INSERT INTO `access_log` VALUES (65380, '65.53.15655325549420417', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:15', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:15');
INSERT INTO `access_log` VALUES (65381, '65.47.15655325549460405', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:15', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:15');
INSERT INTO `access_log` VALUES (65382, '65.51.15655325558070523', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:16', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:16');
INSERT INTO `access_log` VALUES (65383, '65.54.15655325558160341', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:16', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:16');
INSERT INTO `access_log` VALUES (65384, '65.46.15655325558210485', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:16', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:16');
INSERT INTO `access_log` VALUES (65385, '65.52.15655325565580483', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:17', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:17');
INSERT INTO `access_log` VALUES (65386, '65.49.15655325565600441', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:17', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:17');
INSERT INTO `access_log` VALUES (65387, '65.50.15655325565960441', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:17', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:17');
INSERT INTO `access_log` VALUES (65388, '65.45.15655325574160443', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:17', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:17');
INSERT INTO `access_log` VALUES (65389, '65.3607.15655325574272241', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:17', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:17');
INSERT INTO `access_log` VALUES (65390, '65.53.15655325574290419', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:17', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:17');
INSERT INTO `access_log` VALUES (65391, '65.47.15655325584060407', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:18', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:18');
INSERT INTO `access_log` VALUES (65392, '65.46.15655325584120487', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:18', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:18');
INSERT INTO `access_log` VALUES (65393, '65.51.15655325584230525', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:18', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:18');
INSERT INTO `access_log` VALUES (65394, '65.54.15655325595050343', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:20', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:20');
INSERT INTO `access_log` VALUES (65395, '65.52.15655325595230485', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:20', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:20');
INSERT INTO `access_log` VALUES (65396, '65.49.15655325595320443', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:20', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:20');
INSERT INTO `access_log` VALUES (65397, '65.50.15655325603060443', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:20', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:20');
INSERT INTO `access_log` VALUES (65398, '65.45.15655325603150445', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:20', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:20');
INSERT INTO `access_log` VALUES (65399, '65.53.15655325603170421', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:20', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:20');
INSERT INTO `access_log` VALUES (65400, '65.3607.15655325613142243', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:21', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:21');
INSERT INTO `access_log` VALUES (65401, '65.51.15655325613260527', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:21', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:21');
INSERT INTO `access_log` VALUES (65402, '65.46.15655325613290489', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:21', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:21');
INSERT INTO `access_log` VALUES (65403, '65.47.15655325620560409', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:22', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:22');
INSERT INTO `access_log` VALUES (65404, '65.54.15655325620590345', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:22', 1, 1002001015, '账号未登陆', '2019-08-11 22:09:22');
INSERT INTO `access_log` VALUES (65405, '65.52.15655325620610487', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X; zh-CN) AppleWebKit/537.51.1 (KHTML, like Gecko) Mobile/16F203 UCBrowser/12.5.7.1203 Mobile  AliApp(TUnionSDK/0.1.20.3)', '117.136.47.102', '2019-08-11 22:09:22', 0, 1002001015, '账号未登陆', '2019-08-11 22:09:22');
INSERT INTO `access_log` VALUES (65406, '65.45.15655360311150495', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.56.190', '2019-08-11 23:07:11', 1, 1002001015, '账号未登陆', '2019-08-11 23:07:11');
INSERT INTO `access_log` VALUES (65407, '65.49.15655360311150491', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.56.190', '2019-08-11 23:07:11', 1, 1002001015, '账号未登陆', '2019-08-11 23:07:11');
INSERT INTO `access_log` VALUES (65408, '65.51.15655360311160577', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.56.190', '2019-08-11 23:07:11', 0, 1002001015, '账号未登陆', '2019-08-11 23:07:11');
INSERT INTO `access_log` VALUES (65409, '65.50.15655360331130493', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.56.190', '2019-08-11 23:07:13', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 23:07:13');
INSERT INTO `access_log` VALUES (65410, '65.3607.15655360522772291', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.56.190', '2019-08-11 23:07:32', 92, 0, '', '2019-08-11 23:07:32');
INSERT INTO `access_log` VALUES (65411, '65.47.15655360527530457', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.56.190', '2019-08-11 23:07:33', 10, 0, '', '2019-08-11 23:07:33');
INSERT INTO `access_log` VALUES (65412, '65.46.15655360527610537', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.56.190', '2019-08-11 23:07:33', 21, 2001001000, '服务端发生异常', '2019-08-11 23:07:33');
INSERT INTO `access_log` VALUES (65413, '65.52.15655360527780537', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.56.190', '2019-08-11 23:07:33', 10, 0, '', '2019-08-11 23:07:33');
INSERT INTO `access_log` VALUES (65414, '65.45.15655360590620497', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.56.190', '2019-08-11 23:07:39', 13, 0, '', '2019-08-11 23:07:39');
INSERT INTO `access_log` VALUES (65415, '65.49.15655360590680493', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.56.190', '2019-08-11 23:07:39', 16, 2001001000, '服务端发生异常', '2019-08-11 23:07:39');
INSERT INTO `access_log` VALUES (65416, '65.51.15655360590750579', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.56.190', '2019-08-11 23:07:39', 12, 0, '', '2019-08-11 23:07:39');
INSERT INTO `access_log` VALUES (65417, '65.53.15655360854130471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.56.190', '2019-08-11 23:08:05', 11, 0, '', '2019-08-11 23:08:05');
INSERT INTO `access_log` VALUES (65418, '65.3607.15655360854212293', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.56.190', '2019-08-11 23:08:05', 10, 2001001000, '服务端发生异常', '2019-08-11 23:08:05');
INSERT INTO `access_log` VALUES (65419, '65.47.15655360854220459', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.56.190', '2019-08-11 23:08:05', 8, 0, '', '2019-08-11 23:08:05');
INSERT INTO `access_log` VALUES (65420, '59.71.15655366639537679', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '139.227.74.143', '2019-08-11 23:17:44', 16, 0, '', '2019-08-11 23:17:44');
INSERT INTO `access_log` VALUES (65421, '59.80.15655366639537651', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '139.227.74.143', '2019-08-11 23:17:44', 23, 2001001000, '服务端发生异常', '2019-08-11 23:17:44');
INSERT INTO `access_log` VALUES (65422, '65.3607.15655366735582301', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '139.227.74.143', '2019-08-11 23:17:54', 0, 1002001015, '账号未登陆', '2019-08-11 23:17:54');
INSERT INTO `access_log` VALUES (65423, '65.46.15655366735690547', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '139.227.74.143', '2019-08-11 23:17:54', 1, 1002001015, '账号未登陆', '2019-08-11 23:17:54');
INSERT INTO `access_log` VALUES (65424, '65.52.15655366735690547', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '139.227.74.143', '2019-08-11 23:17:54', 0, 1002001015, '账号未登陆', '2019-08-11 23:17:54');
INSERT INTO `access_log` VALUES (65425, '65.45.15655366755690507', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '139.227.74.143', '2019-08-11 23:17:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 23:17:56');
INSERT INTO `access_log` VALUES (65426, '65.49.15655366769970503', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '139.227.74.143', '2019-08-11 23:17:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 23:17:57');
INSERT INTO `access_log` VALUES (65427, '65.51.15655366779980589', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '139.227.74.143', '2019-08-11 23:17:58', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-11 23:17:58');
INSERT INTO `access_log` VALUES (65428, '65.50.15655366839070505', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '139.227.74.143', '2019-08-11 23:18:04', 85, 0, '', '2019-08-11 23:18:04');
INSERT INTO `access_log` VALUES (65429, '65.53.15655366842030481', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '139.227.74.143', '2019-08-11 23:18:04', 8, 0, '', '2019-08-11 23:18:04');
INSERT INTO `access_log` VALUES (65430, '65.47.15655366842090469', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '139.227.74.143', '2019-08-11 23:18:04', 8, 2001001000, '服务端发生异常', '2019-08-11 23:18:04');
INSERT INTO `access_log` VALUES (65431, '65.3607.15655366842142303', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '139.227.74.143', '2019-08-11 23:18:04', 8, 0, '', '2019-08-11 23:18:04');
INSERT INTO `access_log` VALUES (65432, '59.78.15655395400647725', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/2173 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.128.48.132', '2019-08-12 00:05:40', 9, 0, '', '2019-08-12 00:05:40');
INSERT INTO `access_log` VALUES (65433, '59.77.15655395400657707', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/2173 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.128.48.132', '2019-08-12 00:05:40', 17, 2001001000, '服务端发生异常', '2019-08-12 00:05:40');
INSERT INTO `access_log` VALUES (65434, '59.73.15655395447447721', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/2173 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.128.48.132', '2019-08-12 00:05:45', 3, 0, '', '2019-08-12 00:05:45');
INSERT INTO `access_log` VALUES (65435, '59.79.15655395447447725', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; MI 6 Build/OPR1.170623.027; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/2173 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.128.48.132', '2019-08-12 00:05:45', 16, 2001001000, '服务端发生异常', '2019-08-12 00:05:45');
INSERT INTO `access_log` VALUES (65436, '59.78.15655411334247747', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.44.174.137', '2019-08-12 00:32:13', 2, 0, '', '2019-08-12 00:32:13');
INSERT INTO `access_log` VALUES (65437, '59.77.15655411336077729', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '222.44.174.137', '2019-08-12 00:32:14', 27, 2001001000, '服务端发生异常', '2019-08-12 00:32:14');
INSERT INTO `access_log` VALUES (65438, '65.54.15655703051760855', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.31.130', '2019-08-12 08:38:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 08:38:25');
INSERT INTO `access_log` VALUES (65439, '65.45.15655703103880957', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.31.130', '2019-08-12 08:38:30', 116, 0, '', '2019-08-12 08:38:31');
INSERT INTO `access_log` VALUES (65440, '65.49.15655703110320953', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.31.130', '2019-08-12 08:38:31', 18, 0, '', '2019-08-12 08:38:31');
INSERT INTO `access_log` VALUES (65441, '65.51.15655703110411039', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.31.130', '2019-08-12 08:38:31', 21, 2001001000, '服务端发生异常', '2019-08-12 08:38:31');
INSERT INTO `access_log` VALUES (65442, '65.50.15655703110500955', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '125.70.31.130', '2019-08-12 08:38:31', 20, 0, '', '2019-08-12 08:38:31');
INSERT INTO `access_log` VALUES (65443, '65.51.15655704365341041', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.207.204', '2019-08-12 08:40:37', 1, 1002001015, '账号未登陆', '2019-08-12 08:40:37');
INSERT INTO `access_log` VALUES (65444, '65.50.15655704365340957', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.207.204', '2019-08-12 08:40:37', 1, 1002001015, '账号未登陆', '2019-08-12 08:40:37');
INSERT INTO `access_log` VALUES (65445, '65.47.15655704365370921', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.207.204', '2019-08-12 08:40:37', 0, 1002001015, '账号未登陆', '2019-08-12 08:40:37');
INSERT INTO `access_log` VALUES (65446, '65.53.15655704426100933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.207.204', '2019-08-12 08:40:43', 101, 0, '', '2019-08-12 08:40:43');
INSERT INTO `access_log` VALUES (65447, '65.46.15655704428951001', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.207.204', '2019-08-12 08:40:43', 9, 0, '', '2019-08-12 08:40:43');
INSERT INTO `access_log` VALUES (65448, '65.54.15655704428980859', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.207.204', '2019-08-12 08:40:43', 10, 0, '', '2019-08-12 08:40:43');
INSERT INTO `access_log` VALUES (65449, '65.52.15655704428961001', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.207.204', '2019-08-12 08:40:43', 12, 2001001000, '服务端发生异常', '2019-08-12 08:40:43');
INSERT INTO `access_log` VALUES (65450, '65.3607.15655722841782781', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.249.156.63', '2019-08-12 09:11:24', 0, 1002001015, '账号未登陆', '2019-08-12 09:11:24');
INSERT INTO `access_log` VALUES (65451, '65.51.15655722841771067', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.249.156.63', '2019-08-12 09:11:24', 0, 1002001015, '账号未登陆', '2019-08-12 09:11:24');
INSERT INTO `access_log` VALUES (65452, '65.47.15655722841770947', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.249.156.63', '2019-08-12 09:11:24', 0, 1002001015, '账号未登陆', '2019-08-12 09:11:24');
INSERT INTO `access_log` VALUES (65453, '65.53.15655722866680959', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.249.156.63', '2019-08-12 09:11:27', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 09:11:27');
INSERT INTO `access_log` VALUES (65454, '65.52.15655723233141027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.249.156.63', '2019-08-12 09:12:03', 117, 0, '', '2019-08-12 09:12:03');
INSERT INTO `access_log` VALUES (65455, '65.49.15655723237590983', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.249.156.63', '2019-08-12 09:12:04', 10, 0, '', '2019-08-12 09:12:04');
INSERT INTO `access_log` VALUES (65456, '65.45.15655723237590987', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.249.156.63', '2019-08-12 09:12:04', 11, 2001001000, '服务端发生异常', '2019-08-12 09:12:04');
INSERT INTO `access_log` VALUES (65457, '65.50.15655723237650985', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.249.156.63', '2019-08-12 09:12:04', 9, 0, '', '2019-08-12 09:12:04');
INSERT INTO `access_log` VALUES (65458, '65.53.15655723634300961', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.249.156.63', '2019-08-12 09:12:43', 78, 0, '', '2019-08-12 09:12:44');
INSERT INTO `access_log` VALUES (65459, '65.45.15655728206920995', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.61.88.206', '2019-08-12 09:20:21', 1, 1002001015, '账号未登陆', '2019-08-12 09:20:21');
INSERT INTO `access_log` VALUES (65460, '65.49.15655728207010989', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.61.88.206', '2019-08-12 09:20:21', 1, 1002001015, '账号未登陆', '2019-08-12 09:20:21');
INSERT INTO `access_log` VALUES (65461, '65.51.15655728207131077', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.61.88.206', '2019-08-12 09:20:21', 0, 1002001015, '账号未登陆', '2019-08-12 09:20:21');
INSERT INTO `access_log` VALUES (65462, '65.3607.15655728254212789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.61.88.206', '2019-08-12 09:20:25', 96, 0, '', '2019-08-12 09:20:26');
INSERT INTO `access_log` VALUES (65463, '65.46.15655728259231037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.61.88.206', '2019-08-12 09:20:26', 115, 0, '', '2019-08-12 09:20:26');
INSERT INTO `access_log` VALUES (65464, '65.53.15655728259210969', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.61.88.206', '2019-08-12 09:20:26', 118, 0, '', '2019-08-12 09:20:26');
INSERT INTO `access_log` VALUES (65465, '65.54.15655728259210895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.61.88.206', '2019-08-12 09:20:26', 121, 2001001000, '服务端发生异常', '2019-08-12 09:20:26');
INSERT INTO `access_log` VALUES (65466, '65.50.15655728496390995', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.61.88.206', '2019-08-12 09:20:50', 9, 0, '', '2019-08-12 09:20:50');
INSERT INTO `access_log` VALUES (65467, '65.45.15655728496460997', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.61.88.206', '2019-08-12 09:20:50', 9, 2001001000, '服务端发生异常', '2019-08-12 09:20:50');
INSERT INTO `access_log` VALUES (65468, '65.49.15655728496540991', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.61.88.206', '2019-08-12 09:20:50', 8, 0, '', '2019-08-12 09:20:50');
INSERT INTO `access_log` VALUES (65469, '65.50.15655738471611009', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '106.117.17.12', '2019-08-12 09:37:27', 0, 1002001015, '账号未登陆', '2019-08-12 09:37:27');
INSERT INTO `access_log` VALUES (65470, '65.45.15655738471711011', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '106.117.17.12', '2019-08-12 09:37:27', 1, 1002001015, '账号未登陆', '2019-08-12 09:37:27');
INSERT INTO `access_log` VALUES (65471, '65.49.15655738471721005', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '106.117.17.12', '2019-08-12 09:37:27', 0, 1002001015, '账号未登陆', '2019-08-12 09:37:27');
INSERT INTO `access_log` VALUES (65472, '65.51.15655738531931093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '106.117.17.12', '2019-08-12 09:37:33', 74, 0, '', '2019-08-12 09:37:33');
INSERT INTO `access_log` VALUES (65473, '65.47.15655738536390973', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '106.117.17.12', '2019-08-12 09:37:34', 758, 0, '', '2019-08-12 09:37:34');
INSERT INTO `access_log` VALUES (65474, '65.3607.15655738536422805', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '106.117.17.12', '2019-08-12 09:37:34', 815, 2001001000, '服务端发生异常', '2019-08-12 09:37:34');
INSERT INTO `access_log` VALUES (65475, '65.46.15655738536611053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '106.117.17.12', '2019-08-12 09:37:34', 799, 0, '', '2019-08-12 09:37:34');
INSERT INTO `access_log` VALUES (65476, '65.54.15655738600520911', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '106.117.17.12', '2019-08-12 09:37:40', 9, 0, '', '2019-08-12 09:37:40');
INSERT INTO `access_log` VALUES (65477, '65.52.15655738600611053', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '106.117.17.12', '2019-08-12 09:37:40', 10, 2001001000, '服务端发生异常', '2019-08-12 09:37:40');
INSERT INTO `access_log` VALUES (65478, '65.49.15655738600691007', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:69.0) Gecko/20100101 Firefox/69.0', '106.117.17.12', '2019-08-12 09:37:40', 16, 0, '', '2019-08-12 09:37:40');
INSERT INTO `access_log` VALUES (65479, '59.77.15655745684628175', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.216.40.207', '2019-08-12 09:49:28', 9, 0, '', '2019-08-12 09:49:28');
INSERT INTO `access_log` VALUES (65480, '59.73.15655745684638189', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.216.40.207', '2019-08-12 09:49:28', 21, 2001001000, '服务端发生异常', '2019-08-12 09:49:28');
INSERT INTO `access_log` VALUES (65481, '65.54.15655745906640921', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.216.40.207', '2019-08-12 09:49:51', 0, 1002001015, '账号未登陆', '2019-08-12 09:49:51');
INSERT INTO `access_log` VALUES (65482, '65.52.15655745906741063', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.216.40.207', '2019-08-12 09:49:51', 1, 1002001015, '账号未登陆', '2019-08-12 09:49:51');
INSERT INTO `access_log` VALUES (65483, '65.50.15655745906741021', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.216.40.207', '2019-08-12 09:49:51', 0, 1002001015, '账号未登陆', '2019-08-12 09:49:51');
INSERT INTO `access_log` VALUES (65484, '65.45.15655745935091023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.216.40.207', '2019-08-12 09:49:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 09:49:54');
INSERT INTO `access_log` VALUES (65485, '65.3607.15655746097482817', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.216.40.207', '2019-08-12 09:50:10', 108, 0, '', '2019-08-12 09:50:10');
INSERT INTO `access_log` VALUES (65486, '65.46.15655746102601065', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.216.40.207', '2019-08-12 09:50:10', 9, 0, '', '2019-08-12 09:50:10');
INSERT INTO `access_log` VALUES (65487, '65.53.15655746102660997', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.216.40.207', '2019-08-12 09:50:10', 8, 2001001000, '服务端发生异常', '2019-08-12 09:50:10');
INSERT INTO `access_log` VALUES (65488, '65.49.15655746102701019', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.216.40.207', '2019-08-12 09:50:10', 8, 0, '', '2019-08-12 09:50:10');
INSERT INTO `access_log` VALUES (65489, '59.73.15655767854258219', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.1.17.162', '2019-08-12 10:26:25', 11, 0, '', '2019-08-12 10:26:25');
INSERT INTO `access_log` VALUES (65490, '59.77.15655767854258205', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.1.17.162', '2019-08-12 10:26:25', 22, 2001001000, '服务端发生异常', '2019-08-12 10:26:25');
INSERT INTO `access_log` VALUES (65491, '65.49.15655776065281059', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:07', 1, 1002001015, '账号未登陆', '2019-08-12 10:40:07');
INSERT INTO `access_log` VALUES (65492, '65.52.15655776065351105', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:07', 0, 1002001015, '账号未登陆', '2019-08-12 10:40:07');
INSERT INTO `access_log` VALUES (65493, '65.50.15655776065311063', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:07', 0, 1002001015, '账号未登陆', '2019-08-12 10:40:07');
INSERT INTO `access_log` VALUES (65494, '65.54.15655776088240963', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:09', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 10:40:09');
INSERT INTO `access_log` VALUES (65495, '65.51.15655776237241147', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:24', 73, 0, '', '2019-08-12 10:40:24');
INSERT INTO `access_log` VALUES (65496, '65.3607.15655776240872859', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:24', 17, 0, '', '2019-08-12 10:40:24');
INSERT INTO `access_log` VALUES (65497, '65.46.15655776240891107', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:24', 17, 0, '', '2019-08-12 10:40:24');
INSERT INTO `access_log` VALUES (65498, '65.53.15655776240911039', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:24', 17, 2001001000, '服务端发生异常', '2019-08-12 10:40:24');
INSERT INTO `access_log` VALUES (65499, '65.52.15655776397581107', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:40', 16, 0, '', '2019-08-12 10:40:40');
INSERT INTO `access_log` VALUES (65500, '65.49.15655776397611061', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:40', 17, 0, '', '2019-08-12 10:40:40');
INSERT INTO `access_log` VALUES (65501, '65.54.15655776397620965', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:40', 18, 2001001000, '服务端发生异常', '2019-08-12 10:40:40');
INSERT INTO `access_log` VALUES (65502, '65.45.15655776440471067', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:44', 8, 0, '', '2019-08-12 10:40:44');
INSERT INTO `access_log` VALUES (65503, '65.51.15655776440511149', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:44', 8, 2001001000, '服务端发生异常', '2019-08-12 10:40:44');
INSERT INTO `access_log` VALUES (65504, '65.47.15655776440541029', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:44', 7, 0, '', '2019-08-12 10:40:44');
INSERT INTO `access_log` VALUES (65505, '65.53.15655776472711041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:47', 9, 0, '', '2019-08-12 10:40:47');
INSERT INTO `access_log` VALUES (65506, '65.3607.15655776472702861', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:47', 9, 0, '', '2019-08-12 10:40:47');
INSERT INTO `access_log` VALUES (65507, '65.46.15655776472701109', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.232.172.141', '2019-08-12 10:40:47', 10, 2001001000, '服务端发生异常', '2019-08-12 10:40:47');
INSERT INTO `access_log` VALUES (65508, '59.80.15655780393668205', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.70.18', '2019-08-12 10:47:19', 4, 0, '', '2019-08-12 10:47:19');
INSERT INTO `access_log` VALUES (65509, '59.72.15655780393708233', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.70.18', '2019-08-12 10:47:19', 17, 2001001000, '服务端发生异常', '2019-08-12 10:47:19');
INSERT INTO `access_log` VALUES (65510, '65.46.15655780552251115', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.70.18', '2019-08-12 10:47:35', 1, 1002001015, '账号未登陆', '2019-08-12 10:47:35');
INSERT INTO `access_log` VALUES (65511, '65.53.15655780552261047', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.70.18', '2019-08-12 10:47:35', 8, 1002001015, '账号未登陆', '2019-08-12 10:47:35');
INSERT INTO `access_log` VALUES (65512, '65.3607.15655780552342867', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.70.18', '2019-08-12 10:47:35', 0, 1002001015, '账号未登陆', '2019-08-12 10:47:35');
INSERT INTO `access_log` VALUES (65513, '65.50.15655780578081073', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.70.18', '2019-08-12 10:47:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 10:47:38');
INSERT INTO `access_log` VALUES (65514, '65.54.15655780786150973', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.70.18', '2019-08-12 10:47:59', 72, 0, '', '2019-08-12 10:47:59');
INSERT INTO `access_log` VALUES (65515, '65.45.15655780790221075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.70.18', '2019-08-12 10:47:59', 79, 2001001000, '服务端发生异常', '2019-08-12 10:47:59');
INSERT INTO `access_log` VALUES (65516, '65.51.15655780790231157', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.70.18', '2019-08-12 10:47:59', 80, 0, '', '2019-08-12 10:47:59');
INSERT INTO `access_log` VALUES (65517, '65.47.15655780790251037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.70.18', '2019-08-12 10:47:59', 78, 0, '', '2019-08-12 10:47:59');
INSERT INTO `access_log` VALUES (65518, '65.52.15655811612361157', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.132.181', '2019-08-12 11:39:21', 1, 1002001015, '账号未登陆', '2019-08-12 11:39:21');
INSERT INTO `access_log` VALUES (65519, '65.54.15655811612361015', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.132.181', '2019-08-12 11:39:21', 1, 1002001015, '账号未登陆', '2019-08-12 11:39:21');
INSERT INTO `access_log` VALUES (65520, '65.51.15655811612541199', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.132.181', '2019-08-12 11:39:21', 1, 1002001015, '账号未登陆', '2019-08-12 11:39:21');
INSERT INTO `access_log` VALUES (65521, '65.3607.15655811803962911', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.132.181', '2019-08-12 11:39:40', 248, 0, '', '2019-08-12 11:39:41');
INSERT INTO `access_log` VALUES (65522, '65.53.15655812026261091', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.132.181', '2019-08-12 11:40:03', 96, 0, '', '2019-08-12 11:40:03');
INSERT INTO `access_log` VALUES (65523, '65.50.15655812049921117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.132.181', '2019-08-12 11:40:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 11:40:05');
INSERT INTO `access_log` VALUES (65524, '65.45.15655812587461119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.132.181', '2019-08-12 11:40:59', 67, 0, '', '2019-08-12 11:40:59');
INSERT INTO `access_log` VALUES (65525, '65.46.15655812877841161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.123.132.181', '2019-08-12 11:41:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 11:41:28');
INSERT INTO `access_log` VALUES (65526, '59.71.15655813064958277', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36', '222.209.18.70', '2019-08-12 11:41:46', 10, 0, '', '2019-08-12 11:41:47');
INSERT INTO `access_log` VALUES (65527, '59.80.15655813064968249', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36', '222.209.18.70', '2019-08-12 11:41:46', 18, 2001001000, '服务端发生异常', '2019-08-12 11:41:47');
INSERT INTO `access_log` VALUES (65528, '59.78.15655813144248285', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36', '222.209.18.70', '2019-08-12 11:41:54', 3, 0, '', '2019-08-12 11:41:54');
INSERT INTO `access_log` VALUES (65529, '59.75.15655813144248289', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36', '222.209.18.70', '2019-08-12 11:41:54', 13, 2001001000, '服务端发生异常', '2019-08-12 11:41:54');
INSERT INTO `access_log` VALUES (65530, '65.52.15655813251851161', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36', '222.209.18.70', '2019-08-12 11:42:05', 1, 1002001015, '账号未登陆', '2019-08-12 11:42:05');
INSERT INTO `access_log` VALUES (65531, '65.49.15655813251851115', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36', '222.209.18.70', '2019-08-12 11:42:05', 1, 1002001015, '账号未登陆', '2019-08-12 11:42:05');
INSERT INTO `access_log` VALUES (65532, '65.54.15655813251891019', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36', '222.209.18.70', '2019-08-12 11:42:05', 0, 1002001015, '账号未登陆', '2019-08-12 11:42:05');
INSERT INTO `access_log` VALUES (65533, '65.51.15655813274451203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36', '222.209.18.70', '2019-08-12 11:42:07', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 11:42:07');
INSERT INTO `access_log` VALUES (65534, '65.47.15655813302931083', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36', '222.209.18.70', '2019-08-12 11:42:10', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 11:42:10');
INSERT INTO `access_log` VALUES (65535, '65.46.15655813486761163', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36', '222.209.18.70', '2019-08-12 11:42:29', 80, 0, '', '2019-08-12 11:42:29');
INSERT INTO `access_log` VALUES (65536, '65.53.15655813490191095', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36', '222.209.18.70', '2019-08-12 11:42:29', 12, 0, '', '2019-08-12 11:42:29');
INSERT INTO `access_log` VALUES (65537, '65.54.15655813490231021', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36', '222.209.18.70', '2019-08-12 11:42:29', 10, 0, '', '2019-08-12 11:42:29');
INSERT INTO `access_log` VALUES (65538, '65.50.15655813490231121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36', '222.209.18.70', '2019-08-12 11:42:29', 11, 2001001000, '服务端发生异常', '2019-08-12 11:42:29');
INSERT INTO `access_log` VALUES (65539, '65.45.15655814000831123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.146 Safari/537.36', '222.209.18.70', '2019-08-12 11:43:20', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 11:43:20');
INSERT INTO `access_log` VALUES (65540, '65.45.15655827322131141', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:05:32', 1, 1002001015, '账号未登陆', '2019-08-12 12:05:32');
INSERT INTO `access_log` VALUES (65541, '65.47.15655827322151103', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:05:32', 0, 1002001015, '账号未登陆', '2019-08-12 12:05:32');
INSERT INTO `access_log` VALUES (65542, '65.3607.15655827322172935', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:05:32', 1, 1002001015, '账号未登陆', '2019-08-12 12:05:32');
INSERT INTO `access_log` VALUES (65543, '65.46.15655827339141183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:05:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 12:05:34');
INSERT INTO `access_log` VALUES (65544, '65.50.15655827405601141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:05:41', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 12:05:41');
INSERT INTO `access_log` VALUES (65545, '65.45.15655828089771143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:06:49', 89, 0, '', '2019-08-12 12:06:49');
INSERT INTO `access_log` VALUES (65546, '65.47.15655828092441105', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:06:49', 11, 2001001000, '服务端发生异常', '2019-08-12 12:06:49');
INSERT INTO `access_log` VALUES (65547, '65.3607.15655828092482937', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:06:49', 8, 0, '', '2019-08-12 12:06:49');
INSERT INTO `access_log` VALUES (65548, '65.46.15655828092481185', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:06:49', 9, 0, '', '2019-08-12 12:06:49');
INSERT INTO `access_log` VALUES (65549, '65.50.15655828184321143', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:06:58', 9, 0, '', '2019-08-12 12:06:58');
INSERT INTO `access_log` VALUES (65550, '65.53.15655828184381117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:06:58', 9, 0, '', '2019-08-12 12:06:58');
INSERT INTO `access_log` VALUES (65551, '65.49.15655828184391139', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:06:58', 10, 2001001000, '服务端发生异常', '2019-08-12 12:06:58');
INSERT INTO `access_log` VALUES (65552, '59.77.15655828223738287', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:07:02', 3, 0, '', '2019-08-12 12:07:02');
INSERT INTO `access_log` VALUES (65553, '59.73.15655828223738301', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:07:02', 26, 2001001000, '服务端发生异常', '2019-08-12 12:07:02');
INSERT INTO `access_log` VALUES (65554, '64.76.15655828324408629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:07:12', 24, 0, '', '2019-08-12 12:07:12');
INSERT INTO `access_log` VALUES (65555, '64.83.15655828325548619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:07:13', 3, 0, '', '2019-08-12 12:07:13');
INSERT INTO `access_log` VALUES (65556, '64.79.15655828342358631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:07:14', 2, 0, '', '2019-08-12 12:07:14');
INSERT INTO `access_log` VALUES (65557, '64.84.15655828344768621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '49.77.249.106', '2019-08-12 12:07:14', 1, 0, '', '2019-08-12 12:07:14');
INSERT INTO `access_log` VALUES (65558, '59.73.15655893997728389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.253.195.71', '2019-08-12 13:56:40', 10, 0, '', '2019-08-12 13:56:40');
INSERT INTO `access_log` VALUES (65559, '59.79.15655893997728393', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.253.195.71', '2019-08-12 13:56:40', 18, 2001001000, '服务端发生异常', '2019-08-12 13:56:40');
INSERT INTO `access_log` VALUES (65560, '64.79.15655894075898719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.253.195.71', '2019-08-12 13:56:48', 11, 0, '', '2019-08-12 13:56:48');
INSERT INTO `access_log` VALUES (65561, '64.84.15655894077708709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.253.195.71', '2019-08-12 13:56:48', 3, 0, '', '2019-08-12 13:56:48');
INSERT INTO `access_log` VALUES (65562, '59.71.15655894196058387', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '114.253.195.71', '2019-08-12 13:57:00', 3, 0, '', '2019-08-12 13:57:00');
INSERT INTO `access_log` VALUES (65563, '59.76.15655894196058379', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '114.253.195.71', '2019-08-12 13:57:00', 37, 2001001000, '服务端发生异常', '2019-08-12 13:57:00');
INSERT INTO `access_log` VALUES (65564, '64.77.15655894289488707', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '114.253.195.71', '2019-08-12 13:57:09', 2, 0, '', '2019-08-12 13:57:09');
INSERT INTO `access_log` VALUES (65565, '64.82.15655894291368729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '114.253.195.71', '2019-08-12 13:57:09', 2, 0, '', '2019-08-12 13:57:09');
INSERT INTO `access_log` VALUES (65566, '66.55.15655894428065981', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15810648088', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '114.253.195.71', '2019-08-12 13:57:23', 90, 0, '', '2019-08-12 13:57:23');
INSERT INTO `access_log` VALUES (65567, '64.77.15655895462038709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.253.195.71', '2019-08-12 13:59:06', 2, 0, '', '2019-08-12 13:59:06');
INSERT INTO `access_log` VALUES (65568, '64.82.15655895464008731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.253.195.71', '2019-08-12 13:59:06', 2, 0, '', '2019-08-12 13:59:06');
INSERT INTO `access_log` VALUES (65569, '59.76.15655895470098381', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.253.195.71', '2019-08-12 13:59:07', 4, 0, '', '2019-08-12 13:59:07');
INSERT INTO `access_log` VALUES (65570, '59.80.15655895470958361', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.253.195.71', '2019-08-12 13:59:07', 15, 2001001000, '服务端发生异常', '2019-08-12 13:59:07');
INSERT INTO `access_log` VALUES (65571, '64.81.15655895476138719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.253.195.71', '2019-08-12 13:59:08', 2, 0, '', '2019-08-12 13:59:08');
INSERT INTO `access_log` VALUES (65572, '64.85.15655895478358751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.253.195.71', '2019-08-12 13:59:08', 2, 0, '', '2019-08-12 13:59:08');
INSERT INTO `access_log` VALUES (65573, '59.78.15655895499938397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.253.195.71', '2019-08-12 13:59:10', 3, 0, '', '2019-08-12 13:59:10');
INSERT INTO `access_log` VALUES (65574, '59.72.15655895499938389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.253.195.71', '2019-08-12 13:59:10', 13, 2001001000, '服务端发生异常', '2019-08-12 13:59:10');
INSERT INTO `access_log` VALUES (65575, '65.50.15655903514681245', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '43.254.221.21', '2019-08-12 14:12:31', 0, 1002001015, '账号未登陆', '2019-08-12 14:12:31');
INSERT INTO `access_log` VALUES (65576, '65.54.15655903514681145', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '43.254.221.21', '2019-08-12 14:12:31', 0, 1002001015, '账号未登陆', '2019-08-12 14:12:31');
INSERT INTO `access_log` VALUES (65577, '65.49.15655903514701241', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '43.254.221.21', '2019-08-12 14:12:31', 0, 1002001015, '账号未登陆', '2019-08-12 14:12:31');
INSERT INTO `access_log` VALUES (65578, '65.53.15655903572221217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '43.254.221.21', '2019-08-12 14:12:37', 194, 0, '', '2019-08-12 14:12:37');
INSERT INTO `access_log` VALUES (65579, '65.52.15655903576681285', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '43.254.221.21', '2019-08-12 14:12:38', 13, 0, '', '2019-08-12 14:12:38');
INSERT INTO `access_log` VALUES (65580, '65.45.15655903576711247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '43.254.221.21', '2019-08-12 14:12:38', 13, 0, '', '2019-08-12 14:12:38');
INSERT INTO `access_log` VALUES (65581, '65.51.15655903576691329', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '43.254.221.21', '2019-08-12 14:12:38', 15, 2001001000, '服务端发生异常', '2019-08-12 14:12:38');
INSERT INTO `access_log` VALUES (65582, '65.46.15655906549181293', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.128', '2019-08-12 14:17:35', 0, 1002001015, '账号未登陆', '2019-08-12 14:17:35');
INSERT INTO `access_log` VALUES (65583, '65.47.15655906549551213', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:17:35', 1, 1002001015, '账号未登陆', '2019-08-12 14:17:35');
INSERT INTO `access_log` VALUES (65584, '65.3607.15655906549593045', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.33', '2019-08-12 14:17:35', 0, 1002001015, '账号未登陆', '2019-08-12 14:17:35');
INSERT INTO `access_log` VALUES (65585, '65.50.15655906621301251', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.128', '2019-08-12 14:17:42', 91, 0, '', '2019-08-12 14:17:42');
INSERT INTO `access_log` VALUES (65586, '65.54.15655906628431151', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.128', '2019-08-12 14:17:43', 9, 0, '', '2019-08-12 14:17:43');
INSERT INTO `access_log` VALUES (65587, '65.53.15655906628451223', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:17:43', 11, 0, '', '2019-08-12 14:17:43');
INSERT INTO `access_log` VALUES (65588, '65.45.15655906628501253', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.33', '2019-08-12 14:17:43', 9, 2001001000, '服务端发生异常', '2019-08-12 14:17:43');
INSERT INTO `access_log` VALUES (65589, '65.52.15655906695351291', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.33', '2019-08-12 14:17:50', 8, 0, '', '2019-08-12 14:17:50');
INSERT INTO `access_log` VALUES (65590, '65.51.15655906695351335', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:17:50', 10, 2001001000, '服务端发生异常', '2019-08-12 14:17:50');
INSERT INTO `access_log` VALUES (65591, '65.47.15655906695361215', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '222.173.116.82', '2019-08-12 14:17:50', 10, 0, '', '2019-08-12 14:17:50');
INSERT INTO `access_log` VALUES (65592, '65.47.15655907563591217', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:19:16', 9, 0, '', '2019-08-12 14:19:16');
INSERT INTO `access_log` VALUES (65593, '65.53.15655907563571225', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.54.120', '2019-08-12 14:19:16', 11, 2001001000, '服务端发生异常', '2019-08-12 14:19:16');
INSERT INTO `access_log` VALUES (65594, '65.51.15655907563631337', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:19:16', 9, 0, '', '2019-08-12 14:19:16');
INSERT INTO `access_log` VALUES (65595, '65.50.15655908020721255', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.54.120', '2019-08-12 14:20:02', 8, 0, '', '2019-08-12 14:20:02');
INSERT INTO `access_log` VALUES (65596, '65.49.15655908020721251', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.128', '2019-08-12 14:20:02', 9, 0, '', '2019-08-12 14:20:02');
INSERT INTO `access_log` VALUES (65597, '65.54.15655908020731155', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:20:02', 7, 2001001000, '服务端发生异常', '2019-08-12 14:20:02');
INSERT INTO `access_log` VALUES (65598, '65.47.15655908243731219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:20:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 14:20:24');
INSERT INTO `access_log` VALUES (65599, '65.53.15655908260451227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:20:26', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 14:20:26');
INSERT INTO `access_log` VALUES (65600, '65.52.15655908359981295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:20:36', 55, 0, '', '2019-08-12 14:20:36');
INSERT INTO `access_log` VALUES (65601, '65.3607.15655908362363051', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:20:36', 9, 0, '', '2019-08-12 14:20:36');
INSERT INTO `access_log` VALUES (65602, '65.50.15655908362381257', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.54.120', '2019-08-12 14:20:36', 8, 2001001000, '服务端发生异常', '2019-08-12 14:20:36');
INSERT INTO `access_log` VALUES (65603, '65.46.15655908362361299', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:20:36', 7, 0, '', '2019-08-12 14:20:36');
INSERT INTO `access_log` VALUES (65604, '59.77.15655909011118397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.128', '2019-08-12 14:21:41', 5, 0, '', '2019-08-12 14:21:41');
INSERT INTO `access_log` VALUES (65605, '59.75.15655909011088419', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:21:41', 14, 2001001000, '服务端发生异常', '2019-08-12 14:21:41');
INSERT INTO `access_log` VALUES (65606, '65.53.15655909073911229', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.166', '2019-08-12 14:21:47', 9, 0, '', '2019-08-12 14:21:47');
INSERT INTO `access_log` VALUES (65607, '65.50.15655909073961259', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.54.120', '2019-08-12 14:21:47', 10, 0, '', '2019-08-12 14:21:47');
INSERT INTO `access_log` VALUES (65608, '65.52.15655909073951297', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.54.120', '2019-08-12 14:21:47', 9, 2001001000, '服务端发生异常', '2019-08-12 14:21:47');
INSERT INTO `access_log` VALUES (65609, '59.79.15655909109098415', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:21:51', 2, 0, '', '2019-08-12 14:21:51');
INSERT INTO `access_log` VALUES (65610, '59.74.15655909109208425', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.128', '2019-08-12 14:21:51', 13, 2001001000, '服务端发生异常', '2019-08-12 14:21:51');
INSERT INTO `access_log` VALUES (65611, '64.83.15655909141318729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:21:54', 3, 0, '', '2019-08-12 14:21:54');
INSERT INTO `access_log` VALUES (65612, '64.79.15655909142618741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:21:54', 2, 0, '', '2019-08-12 14:21:54');
INSERT INTO `access_log` VALUES (65613, '64.84.15655909153598731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:21:55', 2, 0, '', '2019-08-12 14:21:55');
INSERT INTO `access_log` VALUES (65614, '65.52.15655910456111299', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.128', '2019-08-12 14:24:06', 10, 0, '', '2019-08-12 14:24:06');
INSERT INTO `access_log` VALUES (65615, '65.46.15655910456161303', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.182', '2019-08-12 14:24:06', 8, 0, '', '2019-08-12 14:24:06');
INSERT INTO `access_log` VALUES (65616, '65.3607.15655910456773055', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.182', '2019-08-12 14:24:06', 9, 2001001000, '服务端发生异常', '2019-08-12 14:24:06');
INSERT INTO `access_log` VALUES (65617, '65.49.15655910462071257', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:24:06', 9, 2001001000, '服务端发生异常', '2019-08-12 14:24:06');
INSERT INTO `access_log` VALUES (65618, '65.54.15655910462051161', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.128', '2019-08-12 14:24:06', 12, 0, '', '2019-08-12 14:24:06');
INSERT INTO `access_log` VALUES (65619, '65.45.15655910462081263', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '222.173.116.82', '2019-08-12 14:24:06', 10, 0, '', '2019-08-12 14:24:06');
INSERT INTO `access_log` VALUES (65620, '65.54.15655911718621163', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.182', '2019-08-12 14:26:12', 10, 0, '', '2019-08-12 14:26:12');
INSERT INTO `access_log` VALUES (65621, '65.51.15655911719111347', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.54.120', '2019-08-12 14:26:12', 10, 0, '', '2019-08-12 14:26:12');
INSERT INTO `access_log` VALUES (65622, '65.47.15655911719111227', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.33', '2019-08-12 14:26:12', 10, 2001001000, '服务端发生异常', '2019-08-12 14:26:12');
INSERT INTO `access_log` VALUES (65623, '65.53.15655911816951235', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.182', '2019-08-12 14:26:22', 9, 0, '', '2019-08-12 14:26:22');
INSERT INTO `access_log` VALUES (65624, '65.46.15655911816991307', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.33', '2019-08-12 14:26:22', 8, 0, '', '2019-08-12 14:26:22');
INSERT INTO `access_log` VALUES (65625, '65.50.15655911816991265', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.54.120', '2019-08-12 14:26:22', 9, 2001001000, '服务端发生异常', '2019-08-12 14:26:22');
INSERT INTO `access_log` VALUES (65626, '59.74.15655913360538431', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-08-12 14:28:56', 3, 0, '', '2019-08-12 14:28:56');
INSERT INTO `access_log` VALUES (65627, '59.79.15655913360558421', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:61.0) Gecko/20100101 Firefox/61.0', '202.105.136.106', '2019-08-12 14:28:56', 10, 2001001000, '服务端发生异常', '2019-08-12 14:28:56');
INSERT INTO `access_log` VALUES (65628, '65.45.15655913549241269', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:29:15', 10, 0, '', '2019-08-12 14:29:15');
INSERT INTO `access_log` VALUES (65629, '65.49.15655913549701263', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.128', '2019-08-12 14:29:15', 11, 2001001000, '服务端发生异常', '2019-08-12 14:29:15');
INSERT INTO `access_log` VALUES (65630, '65.54.15655913549731167', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.90', '2019-08-12 14:29:15', 9, 0, '', '2019-08-12 14:29:15');
INSERT INTO `access_log` VALUES (65631, '59.78.15655913841388423', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '210.12.2.58', '2019-08-12 14:29:44', 3, 0, '', '2019-08-12 14:29:44');
INSERT INTO `access_log` VALUES (65632, '59.72.15655913841398415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '210.12.2.58', '2019-08-12 14:29:44', 14, 2001001000, '服务端发生异常', '2019-08-12 14:29:44');
INSERT INTO `access_log` VALUES (65633, '65.49.15655914792441265', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.33', '2019-08-12 14:31:19', 10, 0, '', '2019-08-12 14:31:19');
INSERT INTO `access_log` VALUES (65634, '65.54.15655914792451169', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.128', '2019-08-12 14:31:19', 10, 2001001000, '服务端发生异常', '2019-08-12 14:31:19');
INSERT INTO `access_log` VALUES (65635, '65.47.15655914792511233', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '144.0.56.166', '2019-08-12 14:31:19', 10, 0, '', '2019-08-12 14:31:19');
INSERT INTO `access_log` VALUES (65636, '65.50.15655916453551273', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '222.173.116.82', '2019-08-12 14:34:05', 10, 0, '', '2019-08-12 14:34:05');
INSERT INTO `access_log` VALUES (65637, '65.46.15655916453551315', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.54.120', '2019-08-12 14:34:05', 12, 2001001000, '服务端发生异常', '2019-08-12 14:34:05');
INSERT INTO `access_log` VALUES (65638, '65.53.15655916453601243', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '113.124.55.128', '2019-08-12 14:34:05', 9, 0, '', '2019-08-12 14:34:05');
INSERT INTO `access_log` VALUES (65639, '59.71.15655946130878459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.190.191', '2019-08-12 15:23:33', 16, 2001001000, '服务端发生异常', '2019-08-12 15:23:33');
INSERT INTO `access_log` VALUES (65640, '59.80.15655946144108431', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.191.20', '2019-08-12 15:23:34', 9, 0, '', '2019-08-12 15:23:34');
INSERT INTO `access_log` VALUES (65641, '59.78.15655946146188467', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.190.199', '2019-08-12 15:23:35', 3, 0, '', '2019-08-12 15:23:35');
INSERT INTO `access_log` VALUES (65642, '59.72.15655946146798459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.190.199', '2019-08-12 15:23:35', 39, 2001001000, '服务端发生异常', '2019-08-12 15:23:35');
INSERT INTO `access_log` VALUES (65643, '65.50.15655951889811321', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:33:09', 0, 1002001015, '账号未登陆', '2019-08-12 15:33:09');
INSERT INTO `access_log` VALUES (65644, '65.53.15655951889821291', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:33:09', 1, 1002001015, '账号未登陆', '2019-08-12 15:33:09');
INSERT INTO `access_log` VALUES (65645, '65.46.15655951890091363', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:33:09', 0, 1002001015, '账号未登陆', '2019-08-12 15:33:09');
INSERT INTO `access_log` VALUES (65646, '65.52.15655951926281359', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:33:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 15:33:13');
INSERT INTO `access_log` VALUES (65647, '65.45.15655952050851323', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:33:25', 243, 0, '', '2019-08-12 15:33:25');
INSERT INTO `access_log` VALUES (65648, '65.47.15655952058541285', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:33:26', 18, 0, '', '2019-08-12 15:33:26');
INSERT INTO `access_log` VALUES (65649, '65.49.15655952058651317', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:33:26', 10, 2001001000, '服务端发生异常', '2019-08-12 15:33:26');
INSERT INTO `access_log` VALUES (65650, '65.54.15655952058741221', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:33:26', 8, 0, '', '2019-08-12 15:33:26');
INSERT INTO `access_log` VALUES (65651, '64.77.15655953031438787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:03', 13, 0, '', '2019-08-12 15:35:03');
INSERT INTO `access_log` VALUES (65652, '64.82.15655953032898809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:03', 3, 0, '', '2019-08-12 15:35:03');
INSERT INTO `access_log` VALUES (65653, '64.85.15655953097618829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:10', 1, 0, '', '2019-08-12 15:35:10');
INSERT INTO `access_log` VALUES (65654, '64.76.15655953131298799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:13', 1, 0, '', '2019-08-12 15:35:13');
INSERT INTO `access_log` VALUES (65655, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:13', 5, 0, '', '2019-08-12 15:35:13');
INSERT INTO `access_log` VALUES (65656, '64.83.15655953164568789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:16', 2, 0, '', '2019-08-12 15:35:16');
INSERT INTO `access_log` VALUES (65657, '64.79.15655953165718801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:17', 2, 0, '', '2019-08-12 15:35:17');
INSERT INTO `access_log` VALUES (65658, '64.84.15655953193148791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:19', 2, 0, '', '2019-08-12 15:35:19');
INSERT INTO `access_log` VALUES (65659, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:19', 5, 0, '', '2019-08-12 15:35:19');
INSERT INTO `access_log` VALUES (65660, '64.78.15655953237628803', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:24', 7, 0, '', '2019-08-12 15:35:24');
INSERT INTO `access_log` VALUES (65661, '66.56.15655953521926099', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18621592340', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:52', 20, 1001003005, '短信发送过于频率', '2019-08-12 15:35:52');
INSERT INTO `access_log` VALUES (65662, '66.51.15655953522176107', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18621592340', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:52', 5, 1001003005, '短信发送过于频率', '2019-08-12 15:35:52');
INSERT INTO `access_log` VALUES (65663, '66.54.15655953521876097', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18621592340', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:52', 95, 0, '', '2019-08-12 15:35:52');
INSERT INTO `access_log` VALUES (65664, '66.53.15655953521856081', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18621592340', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:52', 96, 0, '', '2019-08-12 15:35:52');
INSERT INTO `access_log` VALUES (65665, '66.52.15655953587926085', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18621592340&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:35:59', 248, 0, '', '2019-08-12 15:35:59');
INSERT INTO `access_log` VALUES (65666, '66.55.15655953613896063', 196, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:36:01', 8, 0, '', '2019-08-12 15:36:01');
INSERT INTO `access_log` VALUES (65667, '66.49.15655953688436085', 196, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:36:09', 10, 0, '', '2019-08-12 15:36:09');
INSERT INTO `access_log` VALUES (65668, '65.46.15655953759691367', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.11.255.97', '2019-08-12 15:36:16', 4, 1002001012, '访问令牌已过期', '2019-08-12 15:36:16');
INSERT INTO `access_log` VALUES (65669, '65.50.15655953759761325', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.11.255.97', '2019-08-12 15:36:16', 3, 1002001012, '访问令牌已过期', '2019-08-12 15:36:16');
INSERT INTO `access_log` VALUES (65670, '65.53.15655953759831295', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.11.255.97', '2019-08-12 15:36:16', 4, 1002001012, '访问令牌已过期', '2019-08-12 15:36:16');
INSERT INTO `access_log` VALUES (65671, '66.53.15655953877296083', 196, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:36:28', 5, 0, '', '2019-08-12 15:36:28');
INSERT INTO `access_log` VALUES (65672, '66.51.15655953877276109', 196, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:36:28', 316, 0, '', '2019-08-12 15:36:28');
INSERT INTO `access_log` VALUES (65673, '64.83.15655953888088791', 196, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:36:29', 49, 0, '', '2019-08-12 15:36:29');
INSERT INTO `access_log` VALUES (65674, '64.84.15655953893118793', 196, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:36:29', 8, 0, '', '2019-08-12 15:36:29');
INSERT INTO `access_log` VALUES (65675, 'N/A', 196, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:36:29', 21, 0, '', '2019-08-12 15:36:29');
INSERT INTO `access_log` VALUES (65676, '64.78.15655953898438805', 196, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:36:30', 6, 0, '', '2019-08-12 15:36:30');
INSERT INTO `access_log` VALUES (65677, '64.77.15655953899648791', 196, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:36:30', 6, 0, '', '2019-08-12 15:36:30');
INSERT INTO `access_log` VALUES (65678, '59.74.15655953902888487', 196, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:36:30', 9, 0, '', '2019-08-12 15:36:30');
INSERT INTO `access_log` VALUES (65679, '59.79.15655953902888477', 196, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '49.65.4.11', '2019-08-12 15:36:30', 20, 2001001000, '服务端发生异常', '2019-08-12 15:36:30');
INSERT INTO `access_log` VALUES (65680, '65.45.15655961505171337', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:49:11', 0, 1002001015, '账号未登陆', '2019-08-12 15:49:11');
INSERT INTO `access_log` VALUES (65681, '65.49.15655961505261331', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:49:11', 0, 1002001015, '账号未登陆', '2019-08-12 15:49:11');
INSERT INTO `access_log` VALUES (65682, '65.54.15655961505421235', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:49:11', 0, 1002001015, '账号未登陆', '2019-08-12 15:49:11');
INSERT INTO `access_log` VALUES (65683, '65.47.15655961526001299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:49:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 15:49:13');
INSERT INTO `access_log` VALUES (65684, '65.51.15655961565301419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:49:17', 60, 0, '', '2019-08-12 15:49:17');
INSERT INTO `access_log` VALUES (65685, '65.50.15655961568121337', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:49:17', 10, 0, '', '2019-08-12 15:49:17');
INSERT INTO `access_log` VALUES (65686, '65.46.15655961568221379', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:49:17', 10, 2001001000, '服务端发生异常', '2019-08-12 15:49:17');
INSERT INTO `access_log` VALUES (65687, '65.53.15655961568361307', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:49:17', 9, 0, '', '2019-08-12 15:49:17');
INSERT INTO `access_log` VALUES (65688, '59.77.15655962139408471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:50:14', 4, 0, '', '2019-08-12 15:50:14');
INSERT INTO `access_log` VALUES (65689, '59.73.15655962139418485', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:50:14', 12, 2001001000, '服务端发生异常', '2019-08-12 15:50:14');
INSERT INTO `access_log` VALUES (65690, '64.79.15655962194528815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:50:19', 2, 0, '', '2019-08-12 15:50:19');
INSERT INTO `access_log` VALUES (65691, '64.84.15655962195698805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:50:20', 2, 0, '', '2019-08-12 15:50:20');
INSERT INTO `access_log` VALUES (65692, '64.78.15655962210548817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:50:21', 2, 0, '', '2019-08-12 15:50:21');
INSERT INTO `access_log` VALUES (65693, '64.77.15655962213088803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:50:21', 3, 0, '', '2019-08-12 15:50:21');
INSERT INTO `access_log` VALUES (65694, '59.74.15655962230298499', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:50:23', 2, 0, '', '2019-08-12 15:50:23');
INSERT INTO `access_log` VALUES (65695, '59.79.15655962230358489', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:50:23', 11, 2001001000, '服务端发生异常', '2019-08-12 15:50:23');
INSERT INTO `access_log` VALUES (65696, '65.47.15655962309081301', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:50:31', 11, 0, '', '2019-08-12 15:50:31');
INSERT INTO `access_log` VALUES (65697, '65.51.15655962309081421', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:50:31', 11, 2001001000, '服务端发生异常', '2019-08-12 15:50:31');
INSERT INTO `access_log` VALUES (65698, '65.46.15655962309181381', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.91.116.166', '2019-08-12 15:50:31', 9, 0, '', '2019-08-12 15:50:31');
INSERT INTO `access_log` VALUES (65699, '59.73.15655967645798493', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 15:59:25', 3, 0, '', '2019-08-12 15:59:25');
INSERT INTO `access_log` VALUES (65700, '59.75.15655967645838501', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 15:59:25', 12, 2001001000, '服务端发生异常', '2019-08-12 15:59:25');
INSERT INTO `access_log` VALUES (65701, '64.84.15655967707978813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 15:59:31', 3, 0, '', '2019-08-12 15:59:31');
INSERT INTO `access_log` VALUES (65702, '64.80.15655967709288825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 15:59:31', 2, 0, '', '2019-08-12 15:59:31');
INSERT INTO `access_log` VALUES (65703, '64.77.15655967763408811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 15:59:36', 2, 0, '', '2019-08-12 15:59:36');
INSERT INTO `access_log` VALUES (65704, '64.82.15655967764478833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 15:59:36', 2, 0, '', '2019-08-12 15:59:36');
INSERT INTO `access_log` VALUES (65705, '59.71.15655967816178491', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 15:59:42', 2, 0, '', '2019-08-12 15:59:42');
INSERT INTO `access_log` VALUES (65706, '59.79.15655967816178497', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 15:59:42', 16, 2001001000, '服务端发生异常', '2019-08-12 15:59:42');
INSERT INTO `access_log` VALUES (65707, '64.81.15655967881618821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 15:59:48', 2, 0, '', '2019-08-12 15:59:48');
INSERT INTO `access_log` VALUES (65708, '64.85.15655967883128853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 15:59:48', 2, 0, '', '2019-08-12 15:59:48');
INSERT INTO `access_log` VALUES (65709, '65.46.15655968022901389', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 16:00:02', 8, 1002001015, '账号未登陆', '2019-08-12 16:00:02');
INSERT INTO `access_log` VALUES (65710, '65.51.15655968022901429', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 16:00:02', 0, 1002001015, '账号未登陆', '2019-08-12 16:00:02');
INSERT INTO `access_log` VALUES (65711, '65.53.15655968022991317', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 16:00:02', 0, 1002001015, '账号未登陆', '2019-08-12 16:00:02');
INSERT INTO `access_log` VALUES (65712, '65.52.15655968184811385', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 16:00:18', 61, 0, '', '2019-08-12 16:00:19');
INSERT INTO `access_log` VALUES (65713, '65.3607.15655968187733141', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 16:00:19', 112, 0, '', '2019-08-12 16:00:19');
INSERT INTO `access_log` VALUES (65714, '65.54.15655968187791247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 16:00:19', 109, 0, '', '2019-08-12 16:00:19');
INSERT INTO `access_log` VALUES (65715, '65.45.15655968187751349', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.131.28.146', '2019-08-12 16:00:19', 114, 2001001000, '服务端发生异常', '2019-08-12 16:00:19');
INSERT INTO `access_log` VALUES (65716, '65.47.15655972283461317', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.178.221.58', '2019-08-12 16:07:08', 0, 1002001015, '账号未登陆', '2019-08-12 16:07:08');
INSERT INTO `access_log` VALUES (65717, '65.46.15655972283481397', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.178.221.58', '2019-08-12 16:07:08', 0, 1002001015, '账号未登陆', '2019-08-12 16:07:08');
INSERT INTO `access_log` VALUES (65718, '65.53.15655972283571323', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.178.221.58', '2019-08-12 16:07:08', 0, 1002001015, '账号未登陆', '2019-08-12 16:07:08');
INSERT INTO `access_log` VALUES (65719, '65.52.15655972304431393', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.178.221.58', '2019-08-12 16:07:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 16:07:10');
INSERT INTO `access_log` VALUES (65720, '65.50.15655972394011355', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.178.221.58', '2019-08-12 16:07:19', 80, 0, '', '2019-08-12 16:07:19');
INSERT INTO `access_log` VALUES (65721, '65.54.15655972396851255', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.178.221.58', '2019-08-12 16:07:20', 10, 0, '', '2019-08-12 16:07:20');
INSERT INTO `access_log` VALUES (65722, '65.49.15655972396871351', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.178.221.58', '2019-08-12 16:07:20', 10, 0, '', '2019-08-12 16:07:20');
INSERT INTO `access_log` VALUES (65723, '65.3607.15655972396863149', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.178.221.58', '2019-08-12 16:07:20', 10, 2001001000, '服务端发生异常', '2019-08-12 16:07:20');
INSERT INTO `access_log` VALUES (65724, '59.72.15655977278898503', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '153.3.219.43', '2019-08-12 16:15:28', 3, 0, '', '2019-08-12 16:15:28');
INSERT INTO `access_log` VALUES (65725, '59.77.15655977278908493', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '153.3.219.43', '2019-08-12 16:15:28', 13, 2001001000, '服务端发生异常', '2019-08-12 16:15:28');
INSERT INTO `access_log` VALUES (65726, '64.80.15655977363318839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '153.3.219.43', '2019-08-12 16:15:36', 3, 0, '', '2019-08-12 16:15:36');
INSERT INTO `access_log` VALUES (65727, '64.78.15655977365958839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '153.3.219.43', '2019-08-12 16:15:37', 2, 0, '', '2019-08-12 16:15:37');
INSERT INTO `access_log` VALUES (65728, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=手机&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '153.3.219.43', '2019-08-12 16:15:42', 15, 0, '', '2019-08-12 16:15:42');
INSERT INTO `access_log` VALUES (65729, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=手机', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '153.3.219.43', '2019-08-12 16:15:42', 12, 0, '', '2019-08-12 16:15:42');
INSERT INTO `access_log` VALUES (65730, '65.46.15655979896051409', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:19:50', 0, 1002001015, '账号未登陆', '2019-08-12 16:19:50');
INSERT INTO `access_log` VALUES (65731, '65.45.15655979896051367', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:19:50', 1, 1002001015, '账号未登陆', '2019-08-12 16:19:50');
INSERT INTO `access_log` VALUES (65732, '65.47.15655979896101329', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:19:50', 0, 1002001015, '账号未登陆', '2019-08-12 16:19:50');
INSERT INTO `access_log` VALUES (65733, '65.51.15655979972611447', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:19:57', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 16:19:57');
INSERT INTO `access_log` VALUES (65734, '65.52.15655980004871405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:00', 59, 0, '', '2019-08-12 16:20:01');
INSERT INTO `access_log` VALUES (65735, '65.50.15655980008251367', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:01', 9, 0, '', '2019-08-12 16:20:01');
INSERT INTO `access_log` VALUES (65736, '65.49.15655980008261363', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:01', 11, 2001001000, '服务端发生异常', '2019-08-12 16:20:01');
INSERT INTO `access_log` VALUES (65737, '65.54.15655980008351267', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:01', 17, 0, '', '2019-08-12 16:20:01');
INSERT INTO `access_log` VALUES (65738, '65.45.15655980288901369', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:29', 9, 0, '', '2019-08-12 16:20:29');
INSERT INTO `access_log` VALUES (65739, '65.47.15655980288921331', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:29', 10, 2001001000, '服务端发生异常', '2019-08-12 16:20:29');
INSERT INTO `access_log` VALUES (65740, '65.53.15655980289221337', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:29', 9, 0, '', '2019-08-12 16:20:29');
INSERT INTO `access_log` VALUES (65741, '65.52.15655980343711407', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:34', 8, 0, '', '2019-08-12 16:20:34');
INSERT INTO `access_log` VALUES (65742, '65.51.15655980343711449', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:34', 11, 2001001000, '服务端发生异常', '2019-08-12 16:20:34');
INSERT INTO `access_log` VALUES (65743, '65.50.15655980343751369', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:34', 10, 0, '', '2019-08-12 16:20:34');
INSERT INTO `access_log` VALUES (65744, '59.75.15655980460608519', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:46', 2, 0, '', '2019-08-12 16:20:46');
INSERT INTO `access_log` VALUES (65745, '59.74.15655980460618525', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:46', 11, 2001001000, '服务端发生异常', '2019-08-12 16:20:46');
INSERT INTO `access_log` VALUES (65746, '64.82.15655980538048851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:54', 3, 0, '', '2019-08-12 16:20:54');
INSERT INTO `access_log` VALUES (65747, '64.81.15655980539088839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:54', 2, 0, '', '2019-08-12 16:20:54');
INSERT INTO `access_log` VALUES (65748, '64.85.15655980552708871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:55', 2, 0, '', '2019-08-12 16:20:55');
INSERT INTO `access_log` VALUES (65749, '64.76.15655980557838841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:56', 2, 0, '', '2019-08-12 16:20:56');
INSERT INTO `access_log` VALUES (65750, '59.79.15655980568998515', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:57', 2, 0, '', '2019-08-12 16:20:57');
INSERT INTO `access_log` VALUES (65751, '59.76.15655980568998501', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '182.149.196.172', '2019-08-12 16:20:57', 12, 2001001000, '服务端发生异常', '2019-08-12 16:20:57');
INSERT INTO `access_log` VALUES (65752, '62.80.15656006513247373', 0, 2, 'pay-application', '/pay-api/admins/refund/page', 'createBeginTime=&createEndTime=&finishBeginTime=&finishEndTime=&pageNo=1&pageSize=10&payChannel=&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.19.94.13', '2019-08-12 17:04:11', 1, 1002001015, '账号未登陆', '2019-08-12 17:04:11');
INSERT INTO `access_log` VALUES (65753, '65.3607.15656006830513197', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO R11s Build/NMF26X) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.80 Mobile Safari/537.36 OppoBrowser/10.5.1.2', '36.18.107.211', '2019-08-12 17:04:43', 0, 1002001015, '账号未登陆', '2019-08-12 17:04:43');
INSERT INTO `access_log` VALUES (65754, '65.49.15656006830511401', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO R11s Build/NMF26X) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.80 Mobile Safari/537.36 OppoBrowser/10.5.1.2', '36.18.107.211', '2019-08-12 17:04:43', 0, 1002001015, '账号未登陆', '2019-08-12 17:04:43');
INSERT INTO `access_log` VALUES (65755, '65.46.15656006830511449', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO R11s Build/NMF26X) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.80 Mobile Safari/537.36 OppoBrowser/10.5.1.2', '36.18.107.211', '2019-08-12 17:04:43', 0, 1002001015, '账号未登陆', '2019-08-12 17:04:43');
INSERT INTO `access_log` VALUES (65756, '65.45.15656006842581407', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.115.209.209', '2019-08-12 17:04:44', 0, 1002001015, '账号未登陆', '2019-08-12 17:04:44');
INSERT INTO `access_log` VALUES (65757, '65.47.15656006842611367', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.115.209.209', '2019-08-12 17:04:44', 1, 1002001015, '账号未登陆', '2019-08-12 17:04:44');
INSERT INTO `access_log` VALUES (65758, '65.50.15656006842641407', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.115.209.209', '2019-08-12 17:04:44', 1, 1002001015, '账号未登陆', '2019-08-12 17:04:44');
INSERT INTO `access_log` VALUES (65759, '65.53.15656006857381375', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO R11s Build/NMF26X) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.80 Mobile Safari/537.36 OppoBrowser/10.5.1.2', '36.18.107.211', '2019-08-12 17:04:46', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 17:04:46');
INSERT INTO `access_log` VALUES (65760, '65.51.15656006906281487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO R11s Build/NMF26X) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.80 Mobile Safari/537.36 OppoBrowser/10.5.1.2', '36.18.107.211', '2019-08-12 17:04:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 17:04:51');
INSERT INTO `access_log` VALUES (65761, '65.54.15656006944711307', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.115.209.209', '2019-08-12 17:04:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 17:04:54');
INSERT INTO `access_log` VALUES (65762, '65.49.15656007113661403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.115.209.209', '2019-08-12 17:05:11', 91, 0, '', '2019-08-12 17:05:11');
INSERT INTO `access_log` VALUES (65763, '65.46.15656007117591451', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.115.209.209', '2019-08-12 17:05:12', 13, 0, '', '2019-08-12 17:05:12');
INSERT INTO `access_log` VALUES (65764, '65.45.15656007117591409', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.115.209.209', '2019-08-12 17:05:12', 14, 2001001000, '服务端发生异常', '2019-08-12 17:05:12');
INSERT INTO `access_log` VALUES (65765, '65.47.15656007117641369', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.115.209.209', '2019-08-12 17:05:12', 10, 0, '', '2019-08-12 17:05:12');
INSERT INTO `access_log` VALUES (65766, '65.50.15656007154481409', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO R11s Build/NMF26X) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.80 Mobile Safari/537.36 OppoBrowser/10.5.1.2', '36.18.107.211', '2019-08-12 17:05:15', 107, 0, '', '2019-08-12 17:05:16');
INSERT INTO `access_log` VALUES (65767, '65.51.15656007160071489', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO R11s Build/NMF26X) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.80 Mobile Safari/537.36 OppoBrowser/10.5.1.2', '36.18.107.211', '2019-08-12 17:05:16', 9, 0, '', '2019-08-12 17:05:16');
INSERT INTO `access_log` VALUES (65768, '65.53.15656007160061377', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO R11s Build/NMF26X) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.80 Mobile Safari/537.36 OppoBrowser/10.5.1.2', '36.18.107.211', '2019-08-12 17:05:16', 10, 2001001000, '服务端发生异常', '2019-08-12 17:05:16');
INSERT INTO `access_log` VALUES (65769, '65.52.15656007160281447', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 7.1.1; zh-cn; OPPO R11s Build/NMF26X) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/70.0.3538.80 Mobile Safari/537.36 OppoBrowser/10.5.1.2', '36.18.107.211', '2019-08-12 17:05:16', 8, 0, '', '2019-08-12 17:05:16');
INSERT INTO `access_log` VALUES (65770, '65.54.15656007188771309', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.115.209.209', '2019-08-12 17:05:19', 9, 0, '', '2019-08-12 17:05:19');
INSERT INTO `access_log` VALUES (65771, '65.3607.15656007188783201', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.115.209.209', '2019-08-12 17:05:19', 9, 2001001000, '服务端发生异常', '2019-08-12 17:05:19');
INSERT INTO `access_log` VALUES (65772, '65.49.15656007188791405', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '112.115.209.209', '2019-08-12 17:05:19', 8, 0, '', '2019-08-12 17:05:19');
INSERT INTO `access_log` VALUES (65773, '59.71.15656018903248561', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:24:50', 16, 0, '', '2019-08-12 17:24:50');
INSERT INTO `access_log` VALUES (65774, '59.75.15656018903198571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:24:50', 21, 2001001000, '服务端发生异常', '2019-08-12 17:24:50');
INSERT INTO `access_log` VALUES (65775, '64.82.15656018948038903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:24:55', 11, 0, '', '2019-08-12 17:24:55');
INSERT INTO `access_log` VALUES (65776, '64.81.15656018949998891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:24:55', 3, 0, '', '2019-08-12 17:24:55');
INSERT INTO `access_log` VALUES (65777, '64.85.15656019047848923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:25:05', 2, 0, '', '2019-08-12 17:25:05');
INSERT INTO `access_log` VALUES (65778, '64.76.15656019049888893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:25:05', 2, 0, '', '2019-08-12 17:25:05');
INSERT INTO `access_log` VALUES (65779, '59.76.15656019063738553', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:25:06', 3, 0, '', '2019-08-12 17:25:06');
INSERT INTO `access_log` VALUES (65780, '59.80.15656019063738533', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:25:06', 13, 2001001000, '服务端发生异常', '2019-08-12 17:25:06');
INSERT INTO `access_log` VALUES (65781, '65.47.15656019257671387', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:25:26', 0, 1002001015, '账号未登陆', '2019-08-12 17:25:26');
INSERT INTO `access_log` VALUES (65782, '65.46.15656019257851469', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:25:26', 0, 1002001015, '账号未登陆', '2019-08-12 17:25:26');
INSERT INTO `access_log` VALUES (65783, '65.50.15656019258001427', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:25:26', 0, 1002001015, '账号未登陆', '2019-08-12 17:25:26');
INSERT INTO `access_log` VALUES (65784, '65.51.15656019476261507', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:25:48', 73, 0, '', '2019-08-12 17:25:48');
INSERT INTO `access_log` VALUES (65785, '65.52.15656019482681465', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:25:48', 34, 0, '', '2019-08-12 17:25:48');
INSERT INTO `access_log` VALUES (65786, '65.3607.15656019482823219', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:25:48', 38, 2001001000, '服务端发生异常', '2019-08-12 17:25:48');
INSERT INTO `access_log` VALUES (65787, '65.49.15656019483011423', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '117.136.38.150', '2019-08-12 17:25:48', 36, 0, '', '2019-08-12 17:25:48');
INSERT INTO `access_log` VALUES (65788, 'd2897293-4301-41f7-88e1-d0084c65251d', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '127.0.0.1', '2019-08-12 17:27:36', 304, 0, '', '2019-08-12 17:27:37');
INSERT INTO `access_log` VALUES (65789, 'e3d13326-070b-459c-9483-2b5fe4e8d895', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '127.0.0.1', '2019-08-12 17:27:36', 462, 0, '', '2019-08-12 17:27:37');
INSERT INTO `access_log` VALUES (65790, '94dc01c1-2fd7-4c55-97c1-6dc66fa21e01', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:27:37', 15, 0, '', '2019-08-12 17:27:37');
INSERT INTO `access_log` VALUES (65791, 'ba76ae2b-99d6-476f-8423-c85febeab8dd', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:27:37', 38, 0, '', '2019-08-12 17:27:37');
INSERT INTO `access_log` VALUES (65792, '9296a193-852a-40fe-9a53-e2f90190f3d1', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13621901111&code=21', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:27:54', 183, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码长度为 4-6 位', '2019-08-12 17:27:54');
INSERT INTO `access_log` VALUES (65793, '76b42c9e-d05f-4445-964c-0a60ec07a2e4', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13621901111&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:27:59', 166, 1001003000, '验证码不存在', '2019-08-12 17:27:59');
INSERT INTO `access_log` VALUES (65794, '08cd2a95-02ee-40d8-b09b-d945ee72546d', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18856655656', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:17', 165, 0, '', '2019-08-12 17:28:17');
INSERT INTO `access_log` VALUES (65795, '16c225e1-4dec-4d64-9c14-5f38f9245ef6', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18856655656&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:19', 424, 0, '', '2019-08-12 17:28:20');
INSERT INTO `access_log` VALUES (65796, 'db1cb72f-0403-40fa-98ca-51bc7fad0c1e', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:21', 256, 0, '', '2019-08-12 17:28:22');
INSERT INTO `access_log` VALUES (65797, '59.73.15656021031678567', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:28:23', 3, 0, '', '2019-08-12 17:28:23');
INSERT INTO `access_log` VALUES (65798, '59.74.15656021031678581', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:28:23', 13, 2001001000, '服务端发生异常', '2019-08-12 17:28:23');
INSERT INTO `access_log` VALUES (65799, '11fcb8f4-c341-45c1-adad-7f7eba383afb', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:24', 56, 0, '', '2019-08-12 17:28:24');
INSERT INTO `access_log` VALUES (65800, '8276911c-8253-4584-9e93-11ce92d64cb2', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:24', 76, 0, '', '2019-08-12 17:28:24');
INSERT INTO `access_log` VALUES (65801, 'c5af153c-a203-422e-b7ba-32dee828257f', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:26', 22, 0, '', '2019-08-12 17:28:26');
INSERT INTO `access_log` VALUES (65802, 'c55bfc9d-8cff-4550-a7b5-012a4b883d26', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:27', 23, 0, '', '2019-08-12 17:28:27');
INSERT INTO `access_log` VALUES (65803, '35338a22-3a43-49b6-9a80-e50baf90eba7', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:28', 33, 0, '', '2019-08-12 17:28:28');
INSERT INTO `access_log` VALUES (65804, '2c1a643e-d83d-4b7b-94c3-98fe23a8d990', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:28', 46, 0, '', '2019-08-12 17:28:28');
INSERT INTO `access_log` VALUES (65805, '808405d5-e9ee-4c6f-8312-1320f007c67e', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:29', 138, 0, '', '2019-08-12 17:28:29');
INSERT INTO `access_log` VALUES (65806, 'af4d438b-368d-4929-a6a9-b051adfc0516', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:29', 21, 0, '', '2019-08-12 17:28:29');
INSERT INTO `access_log` VALUES (65807, '59.75.15656021096598575', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:28:30', 2, 0, '', '2019-08-12 17:28:30');
INSERT INTO `access_log` VALUES (65808, '59.71.15656021096598565', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:28:30', 15, 2001001000, '服务端发生异常', '2019-08-12 17:28:30');
INSERT INTO `access_log` VALUES (65809, '81467ecd-f02f-42d6-9a12-df3aa60d3088', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:31', 20, 0, '', '2019-08-12 17:28:31');
INSERT INTO `access_log` VALUES (65810, '8d27a8ae-c696-42c0-9f45-61aee11c8ef0', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:31', 22, 0, '', '2019-08-12 17:28:31');
INSERT INTO `access_log` VALUES (65811, 'a3d097c8-cfb0-4c0c-9e6c-576424e3ff77', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:32', 23, 0, '', '2019-08-12 17:28:32');
INSERT INTO `access_log` VALUES (65812, 'c50c475f-7b4f-4cec-9395-de12bc5bf779', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:33', 27, 0, '', '2019-08-12 17:28:33');
INSERT INTO `access_log` VALUES (65813, '9a4f85e1-6cad-4828-9c50-6b52f08e3722', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:33', 40, 0, '', '2019-08-12 17:28:33');
INSERT INTO `access_log` VALUES (65814, '5d6dd087-7a1d-4b2c-a98e-01ab4884868f', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:35', 37, 0, '', '2019-08-12 17:28:35');
INSERT INTO `access_log` VALUES (65815, '1922b425-6c15-486f-bea5-716fa81190e3', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:35', 121, 0, '', '2019-08-12 17:28:35');
INSERT INTO `access_log` VALUES (65816, 'd81197bf-d1f8-47f5-82fe-60d7fa22d559', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:35', 198, 0, '', '2019-08-12 17:28:35');
INSERT INTO `access_log` VALUES (65817, '4d31b06a-8715-4414-a69d-2c6d297a7e36', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:35', 362, 2001001000, '服务端发生异常', '2019-08-12 17:28:35');
INSERT INTO `access_log` VALUES (65818, '64.77.15656021175758885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:28:38', 3, 0, '', '2019-08-12 17:28:38');
INSERT INTO `access_log` VALUES (65819, '64.82.15656021176798907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:28:38', 2, 0, '', '2019-08-12 17:28:38');
INSERT INTO `access_log` VALUES (65820, '1a41eb80-5708-4f26-b011-3360a799489f', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:39', 23, 0, '', '2019-08-12 17:28:39');
INSERT INTO `access_log` VALUES (65821, '217aa862-023e-4c4d-b20b-08cafdca4647', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:39', 37, 0, '', '2019-08-12 17:28:39');
INSERT INTO `access_log` VALUES (65822, '64.81.15656021192378895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:28:39', 2, 0, '', '2019-08-12 17:28:39');
INSERT INTO `access_log` VALUES (65823, '64.85.15656021198918927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:28:40', 2, 0, '', '2019-08-12 17:28:40');
INSERT INTO `access_log` VALUES (65824, '64b10bb4-3c40-497d-b0f2-0a95d34a27ad', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:40', 25, 0, '', '2019-08-12 17:28:40');
INSERT INTO `access_log` VALUES (65825, '9fb7d7b9-8d22-483b-b470-a748e1a9a42f', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:40', 53, 0, '', '2019-08-12 17:28:40');
INSERT INTO `access_log` VALUES (65826, '77027279-ad86-479c-b0d9-35aac7a1dbb0', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:40', 37, 0, '', '2019-08-12 17:28:40');
INSERT INTO `access_log` VALUES (65827, '42c31b86-ecea-4f5e-a175-fea5ba760000', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:40', 116, 2001001000, '服务端发生异常', '2019-08-12 17:28:41');
INSERT INTO `access_log` VALUES (65828, '64.76.15656021205978897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:28:41', 1, 0, '', '2019-08-12 17:28:41');
INSERT INTO `access_log` VALUES (65829, '65.47.15656021316641391', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:28:52', 1, 1002001015, '账号未登陆', '2019-08-12 17:28:52');
INSERT INTO `access_log` VALUES (65830, '65.46.15656021317371473', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:28:52', 1, 1002001015, '账号未登陆', '2019-08-12 17:28:52');
INSERT INTO `access_log` VALUES (65831, '65.50.15656021317371431', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:28:52', 0, 1002001015, '账号未登陆', '2019-08-12 17:28:52');
INSERT INTO `access_log` VALUES (65832, '65.51.15656021366561511', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:28:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 17:28:57');
INSERT INTO `access_log` VALUES (65833, '65.3607.15656021377093223', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:28:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 17:28:58');
INSERT INTO `access_log` VALUES (65834, '65.52.15656021436341469', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:29:04', 81, 0, '', '2019-08-12 17:29:04');
INSERT INTO `access_log` VALUES (65835, '65.49.15656021438761427', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:29:04', 8, 0, '', '2019-08-12 17:29:04');
INSERT INTO `access_log` VALUES (65836, '65.54.15656021438831331', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:29:04', 9, 2001001000, '服务端发生异常', '2019-08-12 17:29:04');
INSERT INTO `access_log` VALUES (65837, '65.45.15656021438831433', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '114.91.116.166', '2019-08-12 17:29:04', 8, 0, '', '2019-08-12 17:29:04');
INSERT INTO `access_log` VALUES (65838, '5e2838bc-01cf-4579-8713-b2bbdcaeda8e', 197, 1, 'order-impl', '/order-api/users/cart/add', 'skuId=36&quantity=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:04', 125, 0, '', '2019-08-12 17:29:04');
INSERT INTO `access_log` VALUES (65839, '4f785afd-04fa-4cd4-9137-e0adbba49bb1', 197, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:07', 68, 0, '', '2019-08-12 17:29:07');
INSERT INTO `access_log` VALUES (65840, '0629ab7e-411e-4c5b-8b6a-52bac78a0e4e', 197, 1, 'order-impl', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:07', 137, 0, '', '2019-08-12 17:29:07');
INSERT INTO `access_log` VALUES (65841, 'c0e3fca9-3ceb-43ad-bb68-3ac8eabc3f49', 197, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:09', 25, 0, '', '2019-08-12 17:29:09');
INSERT INTO `access_log` VALUES (65842, 'c2c9b44e-4290-420b-a210-f41bff56dac9', 197, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:11', 20, 0, '', '2019-08-12 17:29:11');
INSERT INTO `access_log` VALUES (65843, '73c17d70-bbb4-4e6b-9e84-0a333626d3db', 197, 1, 'order-impl', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:11', 65, 0, '', '2019-08-12 17:29:11');
INSERT INTO `access_log` VALUES (65844, '84e13967-45a5-4b2f-829e-797da2a32558', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:11', 22, 0, '', '2019-08-12 17:29:11');
INSERT INTO `access_log` VALUES (65845, 'af176e31-dc2d-443e-acc1-20489494de1b', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:11', 54, 0, '', '2019-08-12 17:29:11');
INSERT INTO `access_log` VALUES (65846, 'fefa0dd1-d087-44a0-9d1a-9675f087873c', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:11', 38, 0, '', '2019-08-12 17:29:11');
INSERT INTO `access_log` VALUES (65847, '973985e7-1450-42d5-b57d-407428c51187', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:11', 123, 2001001000, '服务端发生异常', '2019-08-12 17:29:11');
INSERT INTO `access_log` VALUES (65848, 'aa1235a5-0bf4-4445-ad69-8feb9c72bcf8', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:16', 23, 0, '', '2019-08-12 17:29:16');
INSERT INTO `access_log` VALUES (65849, 'bef41150-9a89-4007-b14d-68424d77ff2a', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:16', 52, 0, '', '2019-08-12 17:29:16');
INSERT INTO `access_log` VALUES (65850, '1f7236db-94af-49ae-b2bc-949f4620b384', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:16', 38, 0, '', '2019-08-12 17:29:16');
INSERT INTO `access_log` VALUES (65851, 'cb672ab1-ee52-4494-8e0a-175840d93f1d', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:16', 111, 2001001000, '服务端发生异常', '2019-08-12 17:29:16');
INSERT INTO `access_log` VALUES (65852, '6870640e-1c8f-4490-9684-3752a43619cc', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:29', 24, 0, '', '2019-08-12 17:29:29');
INSERT INTO `access_log` VALUES (65853, 'c3ace017-22a9-445e-b8dd-6da4610bec13', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:29', 53, 0, '', '2019-08-12 17:29:29');
INSERT INTO `access_log` VALUES (65854, '0e5bd34d-355f-4fc6-a596-c47cf1c69754', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:29', 40, 0, '', '2019-08-12 17:29:29');
INSERT INTO `access_log` VALUES (65855, '736e4fe8-cf38-4329-a559-e746390055e9', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:29', 158, 2001001000, '服务端发生异常', '2019-08-12 17:29:29');
INSERT INTO `access_log` VALUES (65856, '16046d11-6a65-4035-844a-bd275ab12786', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:30:56', 33, 0, '', '2019-08-12 17:30:56');
INSERT INTO `access_log` VALUES (65857, '403794c3-28e9-49a7-b96b-f6cec77add50', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:30:56', 65, 0, '', '2019-08-12 17:30:56');
INSERT INTO `access_log` VALUES (65858, 'd8084a56-b752-43bc-ab26-2e0b1ca674c3', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:30:56', 62, 0, '', '2019-08-12 17:30:56');
INSERT INTO `access_log` VALUES (65859, '17a91eb0-cf9c-4cd4-a08c-a0f95d79665b', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:30:56', 132, 2001001000, '服务端发生异常', '2019-08-12 17:30:56');
INSERT INTO `access_log` VALUES (65860, '75bcd955-896c-4aad-b203-a8ead97fa80f', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '127.0.0.1', '2019-08-12 17:31:36', 17, 0, '', '2019-08-12 17:31:36');
INSERT INTO `access_log` VALUES (65861, 'e750fc1b-176b-43fb-880f-c518f8ee07a0', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '127.0.0.1', '2019-08-12 17:31:36', 35, 0, '', '2019-08-12 17:31:36');
INSERT INTO `access_log` VALUES (65862, 'bd0f00be-33a8-423a-a1fe-1e21b2ed3af2', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '127.0.0.1', '2019-08-12 17:31:48', 12, 0, '', '2019-08-12 17:31:48');
INSERT INTO `access_log` VALUES (65863, '013e9099-8995-464a-94e6-ed8303fff96d', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '127.0.0.1', '2019-08-12 17:31:48', 27, 0, '', '2019-08-12 17:31:48');
INSERT INTO `access_log` VALUES (65864, 'e9b31a7d-c58d-407f-8ec5-170df5d9c39a', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '127.0.0.1', '2019-08-12 17:31:50', 42, 0, '', '2019-08-12 17:31:51');
INSERT INTO `access_log` VALUES (65865, 'c07b082d-d8da-4340-a7ee-5703f57b9daf', 0, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '127.0.0.1', '2019-08-12 17:31:51', 25, 0, '', '2019-08-12 17:31:51');
INSERT INTO `access_log` VALUES (65866, 'd20b9000-e60f-4a0c-89fb-6a15ed276726', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '127.0.0.1', '2019-08-12 17:31:53', 47, 0, '', '2019-08-12 17:31:53');
INSERT INTO `access_log` VALUES (65867, 'ec94bfc9-33b1-4b04-bc41-759dfa5ce5c3', 0, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '127.0.0.1', '2019-08-12 17:31:53', 25, 0, '', '2019-08-12 17:31:53');
INSERT INTO `access_log` VALUES (65868, 'e3488cff-fb72-4ec2-bc3e-df7e745bc9e8', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:32:04', 9, 0, '', '2019-08-12 17:32:04');
INSERT INTO `access_log` VALUES (65869, '53d79bd5-4487-4347-923d-63691c2726dd', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:32:04', 21, 0, '', '2019-08-12 17:32:04');
INSERT INTO `access_log` VALUES (65870, '640bfd58-ccbd-4ca6-8cb6-9f0cb2149639', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:08', 11, 0, '', '2019-08-12 17:32:08');
INSERT INTO `access_log` VALUES (65871, 'c36b3458-9186-41bf-965d-109d1634f568', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:08', 25, 0, '', '2019-08-12 17:32:08');
INSERT INTO `access_log` VALUES (65872, '98e76f51-5679-4c28-8ded-41240ee89801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:13', 13, 0, '', '2019-08-12 17:32:13');
INSERT INTO `access_log` VALUES (65873, 'f0ad6a87-a815-4998-aee4-c56c3e2e4f47', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:13', 10, 0, '', '2019-08-12 17:32:13');
INSERT INTO `access_log` VALUES (65874, '2b633957-45a5-4ae4-b089-07bb97ed0297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:15', 11, 0, '', '2019-08-12 17:32:15');
INSERT INTO `access_log` VALUES (65875, '0edccb6e-f257-4acd-ac86-2146d3e862f2', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:15', 8, 0, '', '2019-08-12 17:32:15');
INSERT INTO `access_log` VALUES (65876, 'aa2d80b6-61a9-4211-a173-7170cdba699b', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:17', 12, 0, '', '2019-08-12 17:32:17');
INSERT INTO `access_log` VALUES (65877, '4afb6dd7-6254-4fee-96de-574de6f7d59e', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:17', 26, 0, '', '2019-08-12 17:32:17');
INSERT INTO `access_log` VALUES (65878, 'c8cd44e4-64eb-49f2-bfc8-c064083396eb', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:18', 9, 0, '', '2019-08-12 17:32:18');
INSERT INTO `access_log` VALUES (65879, 'e7ba9cc8-476f-4ee5-86d1-5ca547a28d51', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:18', 9, 0, '', '2019-08-12 17:32:18');
INSERT INTO `access_log` VALUES (65880, '57ac7ddc-4b51-48ef-bd4d-61f009d4afe1', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:19', 10, 0, '', '2019-08-12 17:32:19');
INSERT INTO `access_log` VALUES (65881, '152c2f43-67be-494a-8bf8-e2719c38082b', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:20', 9, 0, '', '2019-08-12 17:32:20');
INSERT INTO `access_log` VALUES (65882, 'dd8c8d0d-703c-4a95-b8e1-f3303ea28a90', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:20', 20, 0, '', '2019-08-12 17:32:20');
INSERT INTO `access_log` VALUES (65883, '6902c978-ddeb-424d-9951-5f9a2a542230', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:21', 38, 0, '', '2019-08-12 17:32:21');
INSERT INTO `access_log` VALUES (65884, '3eb6a365-b4b7-4d7b-b757-109a00cdc490', 0, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:21', 21, 0, '', '2019-08-12 17:32:21');
INSERT INTO `access_log` VALUES (65885, '421a5c8f-a8c7-410a-a340-c1d859cdd808', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:27', 36, 0, '', '2019-08-12 17:32:27');
INSERT INTO `access_log` VALUES (65886, '8fef8e54-b1d4-4db7-969a-1612ef4b2c0f', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:27', 50, 0, '', '2019-08-12 17:32:27');
INSERT INTO `access_log` VALUES (65887, 'cb68fe4b-4f7f-473d-a8d2-dc8506d35caf', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18856655656', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:36', 156, 0, '', '2019-08-12 17:32:36');
INSERT INTO `access_log` VALUES (65888, 'b150eed7-731b-4e8f-93cc-df43db9077d5', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18856655656&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:38', 1705, 0, '', '2019-08-12 17:32:40');
INSERT INTO `access_log` VALUES (65889, '1d1003bd-cdb9-45b5-b52b-188aa8a560e7', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:41', 375, 0, '', '2019-08-12 17:32:41');
INSERT INTO `access_log` VALUES (65890, 'ddfce774-39e9-4e50-b6d1-7e91d98e5e3b', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:45', 113, 0, '', '2019-08-12 17:32:45');
INSERT INTO `access_log` VALUES (65891, 'aa3ff17b-661a-4737-8fad-e5696e02beea', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:45', 134, 0, '', '2019-08-12 17:32:45');
INSERT INTO `access_log` VALUES (65892, 'cc323b8d-0c19-4850-938e-74e69b8d90ef', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:46', 141, 0, '', '2019-08-12 17:32:46');
INSERT INTO `access_log` VALUES (65893, 'ebde970a-fc7a-4924-9687-fdc3938b8281', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:47', 230, 0, '', '2019-08-12 17:32:48');
INSERT INTO `access_log` VALUES (65894, '6f1d1c21-c317-4372-9faa-2e9a05dfabe3', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:49', 31, 0, '', '2019-08-12 17:32:49');
INSERT INTO `access_log` VALUES (65895, '9242a784-d778-4dfc-91f4-20043a38d000', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:50', 24, 0, '', '2019-08-12 17:32:50');
INSERT INTO `access_log` VALUES (65896, '1c3297ae-526d-4218-ace9-a3a08d3f24d3', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:51', 75, 0, '', '2019-08-12 17:32:51');
INSERT INTO `access_log` VALUES (65897, '166c175b-9624-4e80-a4ff-16dba33606bf', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:52', 24, 0, '', '2019-08-12 17:32:52');
INSERT INTO `access_log` VALUES (65898, 'c9df2bcf-c89a-46b1-9d8e-0744ab3005bd', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:53', 23, 0, '', '2019-08-12 17:32:53');
INSERT INTO `access_log` VALUES (65899, '3f2fe33b-7c8a-4a38-9c83-763b0268de71', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:54', 142, 0, '', '2019-08-12 17:32:54');
INSERT INTO `access_log` VALUES (65900, '03a2adca-8240-4a0c-a108-fc87594fd3ea', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:55', 123, 0, '', '2019-08-12 17:32:55');
INSERT INTO `access_log` VALUES (65901, 'e30b2c58-b415-495c-a57a-f3ec65331c59', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:56', 113, 0, '', '2019-08-12 17:32:56');
INSERT INTO `access_log` VALUES (65902, '2ce9c309-c45b-4632-8041-048071cdba58', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:57', 117, 0, '', '2019-08-12 17:32:57');
INSERT INTO `access_log` VALUES (65903, '2602e19b-db4b-4438-a32d-dbf18709bf25', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:58', 87, 0, '', '2019-08-12 17:32:58');
INSERT INTO `access_log` VALUES (65904, '3ade619e-9517-448c-9a77-3e567e561343', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:58', 42, 0, '', '2019-08-12 17:32:58');
INSERT INTO `access_log` VALUES (65905, 'cc5045c1-1798-49c5-a68a-a79d0d545377', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:32:59', 19, 0, '', '2019-08-12 17:32:59');
INSERT INTO `access_log` VALUES (65906, 'f4a92e33-d1d0-4b82-b469-8e120b58507d', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:00', 22, 0, '', '2019-08-12 17:33:00');
INSERT INTO `access_log` VALUES (65907, '4116e753-dde8-4126-9f33-930e0ff68408', 197, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:02', 187, 0, '', '2019-08-12 17:33:02');
INSERT INTO `access_log` VALUES (65908, '2203951b-2502-48b3-b38e-2b5c7fd5610e', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:03', 141, 0, '', '2019-08-12 17:33:03');
INSERT INTO `access_log` VALUES (65909, '63a70505-6881-4052-8393-fae12f12794b', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:04', 107, 0, '', '2019-08-12 17:33:04');
INSERT INTO `access_log` VALUES (65910, '3c035db7-031e-4ae8-bc3c-4a58f5b63f2e', 197, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:08', 120, 0, '', '2019-08-12 17:33:08');
INSERT INTO `access_log` VALUES (65911, '25f265c7-f26d-4aa9-8aa0-6f9171237cff', 197, 1, 'order-impl', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:08', 357, 0, '', '2019-08-12 17:33:08');
INSERT INTO `access_log` VALUES (65912, 'e62137de-2d08-4176-a6a5-277457ad5927', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:12', 118, 0, '', '2019-08-12 17:33:12');
INSERT INTO `access_log` VALUES (65913, 'da69684d-7297-48ce-a175-ac6bb30354ac', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:13', 37, 0, '', '2019-08-12 17:33:13');
INSERT INTO `access_log` VALUES (65914, 'c13425f7-3b40-4c61-b468-926eb31720a0', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:15', 36, 0, '', '2019-08-12 17:33:15');
INSERT INTO `access_log` VALUES (65915, '4336449c-70f6-4088-a0f1-06d64318fd62', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:15', 118, 0, '', '2019-08-12 17:33:15');
INSERT INTO `access_log` VALUES (65916, 'fc739f17-bf02-411e-add0-4afcc9a65c2b', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:17', 107, 0, '', '2019-08-12 17:33:17');
INSERT INTO `access_log` VALUES (65917, 'dade2844-9557-4037-8d17-b67900a9bdb9', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:17', 119, 0, '', '2019-08-12 17:33:18');
INSERT INTO `access_log` VALUES (65918, '7126927b-d964-44a2-ad33-f3481d0b32b4', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:18', 132, 0, '', '2019-08-12 17:33:18');
INSERT INTO `access_log` VALUES (65919, '713bd3ed-5464-43c1-a758-0c31281ea7ec', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:19', 34, 0, '', '2019-08-12 17:33:19');
INSERT INTO `access_log` VALUES (65920, '9d1c42c4-560b-46b0-8c8a-29c994b73bf7', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:20', 320, 0, '', '2019-08-12 17:33:21');
INSERT INTO `access_log` VALUES (65921, 'e3ba6cdd-a6f9-4ad4-97c0-cf4f9bb715d3', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:23', 246, 0, '', '2019-08-12 17:33:23');
INSERT INTO `access_log` VALUES (65922, '930d5483-bb97-4662-8a95-5ad77e342bd1', 197, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:24', 78, 0, '', '2019-08-12 17:33:25');
INSERT INTO `access_log` VALUES (65923, '16656ff1-9637-474e-9f29-eb176fd49834', 197, 1, 'order-impl', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:24', 172, 0, '', '2019-08-12 17:33:25');
INSERT INTO `access_log` VALUES (65924, 'e8326625-3dc4-4e50-8dfb-e2dc9a972127', 197, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:28', 110, 0, '', '2019-08-12 17:33:28');
INSERT INTO `access_log` VALUES (65925, 'fe57ba11-fbe5-45f6-ae9e-aedcb79eb96f', 197, 1, 'user-application', '/user-api/users/address/add', 'name=胡家明&tel=18856655656&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=1231231&isDefault=true&address=1231231&areaNo=110101&mobile=18856655656&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:42', 154, 2001001000, '服务端发生异常', '2019-08-12 17:33:42');
INSERT INTO `access_log` VALUES (65926, 'deee2140-7558-4c62-8236-bdcb55236dac', 197, 1, 'user-application', '/user-api/users/address/add', 'name=胡家明&tel=18856655656&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=44&isDefault=true&address=44&areaNo=110101&mobile=18856655656&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:50', 149, 2001001000, '服务端发生异常', '2019-08-12 17:33:50');
INSERT INTO `access_log` VALUES (65927, '973be54e-72d1-4b36-8e76-a7d75a1af36b', 197, 1, 'user-application', '/user-api/users/address/add', 'name=胡家明&tel=18856655656&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=44&isDefault=true&address=44&areaNo=110101&mobile=18856655656&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:34:18', 120, 2001001000, '服务端发生异常', '2019-08-12 17:34:19');
INSERT INTO `access_log` VALUES (65928, 'cfff9261-b1cd-4c55-a6a7-b079e68a3427', 197, 1, 'user-application', '/user-api/users/address/add', 'name=胡家明&tel=18856655656&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=44&isDefault=true&address=44&areaNo=110101&mobile=18856655656&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:34:46', 101, 2001001000, '服务端发生异常', '2019-08-12 17:34:46');
INSERT INTO `access_log` VALUES (65929, 'ec8fb78a-0c5c-47fc-a573-e1d612c96fb5', 197, 1, 'user-application', '/user-api/users/address/add', 'name=胡家明&tel=18856655656&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=44444444444&isDefault=true&address=44444444444&areaNo=110101&mobile=18856655656&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:00', 262, 0, '', '2019-08-12 17:35:00');
INSERT INTO `access_log` VALUES (65930, 'eb35c085-12c2-4afb-83ea-e33793d32929', 197, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:00', 29, 0, '', '2019-08-12 17:35:00');
INSERT INTO `access_log` VALUES (65931, 'b4f34652-81c9-4930-bc2a-b66387f3e04c', 197, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:03', 19, 0, '', '2019-08-12 17:35:03');
INSERT INTO `access_log` VALUES (65932, '44ae236b-f2b1-4794-9668-330e07e8fc1e', 197, 1, 'order-impl', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:03', 95, 0, '', '2019-08-12 17:35:03');
INSERT INTO `access_log` VALUES (65933, 'db865e8d-4172-4362-83ea-838893073cdc', 197, 1, 'order-impl', '/order-api/users/order/create_order_from_cart', 'userAddressId=18&remark=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:05', 2565, 0, '', '2019-08-12 17:35:08');
INSERT INTO `access_log` VALUES (65934, 'fbfa1b9a-8f24-4c66-b097-239ef689c526', 197, 1, 'order-impl', '/order-api/users/order/create_order_from_cart', 'userAddressId=18&remark=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:07', 799, 0, '', '2019-08-12 17:35:08');
INSERT INTO `access_log` VALUES (65935, '7248c884-f681-4d04-a395-12ee22907914', 197, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=224', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:09', 225, 0, '', '2019-08-12 17:35:09');
INSERT INTO `access_log` VALUES (65936, 'e484707e-1f9e-42ff-b84d-56d101a08dfe', 197, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=225', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:12', 26, 0, '', '2019-08-12 17:35:12');
INSERT INTO `access_log` VALUES (65937, '063f7126-f990-4c76-bbcf-6ed2c3cbb58b', 197, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:14', 22, 0, '', '2019-08-12 17:35:14');
INSERT INTO `access_log` VALUES (65938, 'a557274d-a00b-4b64-abfd-56823d93caab', 197, 1, 'order-impl', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:14', 22, 0, '', '2019-08-12 17:35:14');
INSERT INTO `access_log` VALUES (65939, '507438e1-5594-47e0-a1ca-b264a1e0d3d3', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:14', 22, 0, '', '2019-08-12 17:35:14');
INSERT INTO `access_log` VALUES (65940, 'ac4af0c2-9b6d-40c4-8b4e-d3b6cddc4118', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:15', 19, 0, '', '2019-08-12 17:35:15');
INSERT INTO `access_log` VALUES (65941, 'adf8602b-617c-4d21-a9e7-0b9f83e23a7a', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:17', 66, 0, '', '2019-08-12 17:35:17');
INSERT INTO `access_log` VALUES (65942, 'bccd10a6-f23c-49d2-9222-f2c5249b8d74', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:21', 49, 0, '', '2019-08-12 17:35:21');
INSERT INTO `access_log` VALUES (65943, '64ff7274-fe3e-441d-b89f-77828c00a482', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:23', 19, 0, '', '2019-08-12 17:35:23');
INSERT INTO `access_log` VALUES (65944, '1da7116f-74ba-46b9-857d-858fba0b2ad2', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:25', 40, 0, '', '2019-08-12 17:35:25');
INSERT INTO `access_log` VALUES (65945, 'bcdebccb-1edb-498b-94b4-42fa18a87ff5', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:25', 20, 0, '', '2019-08-12 17:35:25');
INSERT INTO `access_log` VALUES (65946, 'd59bc0bf-4e2c-4ab8-adca-a0013a72d29b', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:26', 49, 0, '', '2019-08-12 17:35:26');
INSERT INTO `access_log` VALUES (65947, '6fc257f7-f9a2-40f5-99ca-d1870c1a67df', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:27', 45, 0, '', '2019-08-12 17:35:27');
INSERT INTO `access_log` VALUES (65948, '48373e1c-52d8-4698-8211-f25d07a8e856', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:32', 22, 0, '', '2019-08-12 17:35:32');
INSERT INTO `access_log` VALUES (65949, '47658acf-3574-40ee-b361-cdf98f70fb8a', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:34', 28, 0, '', '2019-08-12 17:35:34');
INSERT INTO `access_log` VALUES (65950, '43a32a30-d147-4914-87c4-24664ded4ff3', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:34', 34, 0, '', '2019-08-12 17:35:34');
INSERT INTO `access_log` VALUES (65951, '45b822be-4521-48f0-9409-47054c6fd4b0', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:37', 19, 0, '', '2019-08-12 17:35:37');
INSERT INTO `access_log` VALUES (65952, '29996c3a-ca90-4b7e-ba6e-4c60e9eefbbb', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:37', 52, 0, '', '2019-08-12 17:35:37');
INSERT INTO `access_log` VALUES (65953, '17a2a53a-9de2-4ab5-90db-631dca62b284', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:37', 34, 0, '', '2019-08-12 17:35:37');
INSERT INTO `access_log` VALUES (65954, 'ec93e8ac-919b-4181-8618-6168a408fbc1', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:37', 143, 2001001000, '服务端发生异常', '2019-08-12 17:35:37');
INSERT INTO `access_log` VALUES (65955, '7f4cfe03-da41-45c6-a946-b2b877bf3482', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:51', 27, 0, '', '2019-08-12 17:35:51');
INSERT INTO `access_log` VALUES (65956, 'a2a16248-1f23-4829-9ae0-c736f56d4aaf', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:51', 39, 0, '', '2019-08-12 17:35:51');
INSERT INTO `access_log` VALUES (65957, '9b607544-f810-4144-867e-20c658b2f205', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:36:19', 19, 0, '', '2019-08-12 17:36:19');
INSERT INTO `access_log` VALUES (65958, '10ac7a95-e463-4650-8c3d-cd2ff25e738e', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:36:19', 59, 0, '', '2019-08-12 17:36:19');
INSERT INTO `access_log` VALUES (65959, '6913e93d-e97f-42ed-992f-c0316eadb21d', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:36:20', 37, 0, '', '2019-08-12 17:36:20');
INSERT INTO `access_log` VALUES (65960, '4590f93b-ee95-4666-9bea-60f592feb0fe', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:36:20', 128, 2001001000, '服务端发生异常', '2019-08-12 17:36:20');
INSERT INTO `access_log` VALUES (65961, '70eb9e06-aac1-4a3a-85df-b0feed7fbb8d', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:36:26', 18, 0, '', '2019-08-12 17:36:26');
INSERT INTO `access_log` VALUES (65962, 'f5f144e3-bc3c-46b4-a31d-8452d4fafd71', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:36:26', 48, 0, '', '2019-08-12 17:36:26');
INSERT INTO `access_log` VALUES (65963, 'c89a00b9-a464-4595-a857-b67a78ff1f99', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:36:26', 36, 0, '', '2019-08-12 17:36:26');
INSERT INTO `access_log` VALUES (65964, '64ea1ec1-12d1-4ae9-bebe-d4d5ff1ebf91', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:36:26', 206, 2001001000, '服务端发生异常', '2019-08-12 17:36:27');
INSERT INTO `access_log` VALUES (65965, '350a8aad-5539-497a-977c-8306893e16a4', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:36:51', 89, 0, '', '2019-08-12 17:36:51');
INSERT INTO `access_log` VALUES (65966, 'e8f0be0b-aad3-4cad-9cd6-ae7ef2a1a80e', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:36:51', 182, 0, '', '2019-08-12 17:36:51');
INSERT INTO `access_log` VALUES (65967, '3d4eda90-9563-468a-ad43-889b572f2cad', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:37:44', 118, 0, '', '2019-08-12 17:37:44');
INSERT INTO `access_log` VALUES (65968, '6efa712f-1b13-4af1-8a85-c98aee2b2854', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:37:44', 135, 0, '', '2019-08-12 17:37:44');
INSERT INTO `access_log` VALUES (65969, '9cda1aa6-e24d-45e7-8b22-6719f5a5e593', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:38:23', 27, 0, '', '2019-08-12 17:38:23');
INSERT INTO `access_log` VALUES (65970, '8bcee5a0-b816-45fe-b78a-9f7b4dfe90ed', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:38:23', 51, 0, '', '2019-08-12 17:38:23');
INSERT INTO `access_log` VALUES (65971, 'fcf914fc-f6d3-4dda-9360-7f6c1def95ae', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:38:23', 43, 0, '', '2019-08-12 17:38:23');
INSERT INTO `access_log` VALUES (65972, '13db133e-c135-4c20-9a1c-a71808a1e178', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:38:23', 125, 2001001000, '服务端发生异常', '2019-08-12 17:38:23');
INSERT INTO `access_log` VALUES (65973, 'd8cfc459-31e2-460e-a4e8-c89aec2c0257', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:38:32', 19, 0, '', '2019-08-12 17:38:32');
INSERT INTO `access_log` VALUES (65974, '7e95051a-d618-4590-a558-c750e5bf5644', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:38:32', 49, 0, '', '2019-08-12 17:38:32');
INSERT INTO `access_log` VALUES (65975, 'd5bc153e-4cc2-46e6-adcc-bc0884636724', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:38:32', 35, 0, '', '2019-08-12 17:38:32');
INSERT INTO `access_log` VALUES (65976, '3213620e-4374-4593-8cad-a865d823e290', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=35', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:38:32', 134, 2001001000, '服务端发生异常', '2019-08-12 17:38:33');
INSERT INTO `access_log` VALUES (65977, 'a4808c1f-113a-45b8-8221-bb3fe2515e4d', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:38:44', 22, 0, '', '2019-08-12 17:38:44');
INSERT INTO `access_log` VALUES (65978, '0db121f3-8458-4499-9cea-d82ccc579fef', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:38:44', 50, 0, '', '2019-08-12 17:38:44');
INSERT INTO `access_log` VALUES (65979, '1aec6d7e-2865-46f0-b03c-9000c86ec3f2', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:38:45', 36, 0, '', '2019-08-12 17:38:45');
INSERT INTO `access_log` VALUES (65980, '049c474d-420c-488e-9031-194f7217ed08', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:38:45', 901, 2001001000, '服务端发生异常', '2019-08-12 17:38:46');
INSERT INTO `access_log` VALUES (65981, 'd7ed97fa-4328-4868-845b-4c6cb9de812b', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:16', 26, 0, '', '2019-08-12 17:39:16');
INSERT INTO `access_log` VALUES (65982, 'ec5231eb-6756-49a9-b125-664c3854f93f', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:16', 34, 0, '', '2019-08-12 17:39:16');
INSERT INTO `access_log` VALUES (65983, 'd43d9e83-78dc-450e-bcef-029c07e27d74', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:18', 25, 0, '', '2019-08-12 17:39:18');
INSERT INTO `access_log` VALUES (65984, 'd52bd612-7099-45e1-af28-529e0e7222f2', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:18', 75, 0, '', '2019-08-12 17:39:18');
INSERT INTO `access_log` VALUES (65985, '6763138f-7e79-4e7d-bb32-5cd044b468f4', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:18', 50, 0, '', '2019-08-12 17:39:18');
INSERT INTO `access_log` VALUES (65986, 'cceec782-3e6d-4166-ac42-669f4b9ee847', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=34', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:18', 136, 2001001000, '服务端发生异常', '2019-08-12 17:39:18');
INSERT INTO `access_log` VALUES (65987, '776fda6e-129f-4a1b-9563-8b1e5d1d3d19', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:22', 19, 0, '', '2019-08-12 17:39:22');
INSERT INTO `access_log` VALUES (65988, '498def6b-c39f-44d8-a081-87c91e5b88e5', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:22', 32, 0, '', '2019-08-12 17:39:22');
INSERT INTO `access_log` VALUES (65989, 'fd7e596f-d57d-422c-b2ee-3a4f86f304b4', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:23', 20, 0, '', '2019-08-12 17:39:23');
INSERT INTO `access_log` VALUES (65990, '01c03db1-0dd8-499c-b0c8-4616c07a2b0b', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:24', 20, 0, '', '2019-08-12 17:39:24');
INSERT INTO `access_log` VALUES (65991, '243717fb-5397-4515-a082-2c9d50090adb', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:25', 21, 0, '', '2019-08-12 17:39:25');
INSERT INTO `access_log` VALUES (65992, '4b5d8b81-b70b-43d1-afe6-fb878ba4eb0c', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:25', 17, 0, '', '2019-08-12 17:39:25');
INSERT INTO `access_log` VALUES (65993, 'b3a8a844-aa54-42a6-be18-4e264acdda91', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:27', 26, 0, '', '2019-08-12 17:39:27');
INSERT INTO `access_log` VALUES (65994, '38979564-7aa2-4294-b862-4cd47a012ec2', 197, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:27', 497, 2001001000, '服务端发生异常', '2019-08-12 17:39:28');
INSERT INTO `access_log` VALUES (65995, '405cb432-546f-4ff3-9a96-9207093b6646', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:32', 20, 0, '', '2019-08-12 17:39:32');
INSERT INTO `access_log` VALUES (65996, '0840e18b-4b9b-4310-bcdb-37c30e835b15', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:32', 19, 0, '', '2019-08-12 17:39:32');
INSERT INTO `access_log` VALUES (65997, '42b8fe8b-5a54-454b-9a6a-a14b2736484f', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:33', 22, 0, '', '2019-08-12 17:39:33');
INSERT INTO `access_log` VALUES (65998, '512abc86-2fbb-466d-b3ff-070a34b5f3d8', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:35', 18, 0, '', '2019-08-12 17:39:35');
INSERT INTO `access_log` VALUES (65999, 'cc7a197e-8985-45f4-bd79-b8b71a9a48e6', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:35', 19, 0, '', '2019-08-12 17:39:35');
INSERT INTO `access_log` VALUES (66000, '4ade8b7c-f8c9-4395-91e8-8dc518d80f63', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:36', 20, 0, '', '2019-08-12 17:39:36');
INSERT INTO `access_log` VALUES (66001, '4f3cc8ed-65a4-411b-aa37-9e2d8c60ed54', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:38', 107, 0, '', '2019-08-12 17:39:38');
INSERT INTO `access_log` VALUES (66002, 'c4c77e1c-5660-45e1-ad1d-c1d15ec045d9', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:41', 46, 0, '', '2019-08-12 17:39:41');
INSERT INTO `access_log` VALUES (66003, '49ef8638-b91c-4baf-9f69-8edfbe379a5e', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:41', 18, 0, '', '2019-08-12 17:39:41');
INSERT INTO `access_log` VALUES (66004, 'c43377f9-1072-4bba-ac44-befba74ed5f9', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:42', 17, 0, '', '2019-08-12 17:39:42');
INSERT INTO `access_log` VALUES (66005, '65f01657-cf35-489a-b5d7-c52f969909bf', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:43', 22, 0, '', '2019-08-12 17:39:43');
INSERT INTO `access_log` VALUES (66006, 'e243d6e4-2cc7-4d85-ad73-1396735d6ad4', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:43', 19, 0, '', '2019-08-12 17:39:43');
INSERT INTO `access_log` VALUES (66007, 'ff8e83a6-ec1e-4f79-9e05-d6bca3c8580e', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:40:26', 20, 0, '', '2019-08-12 17:40:26');
INSERT INTO `access_log` VALUES (66008, '70401419-3180-407c-b489-4938f2129a2a', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:40:26', 19, 0, '', '2019-08-12 17:40:26');
INSERT INTO `access_log` VALUES (66009, 'e424a584-6047-4af6-831f-968c506bf5b2', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:40:28', 19, 0, '', '2019-08-12 17:40:28');
INSERT INTO `access_log` VALUES (66010, '2d0634a7-511e-41a6-a9f7-ec730baca694', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:40:29', 18, 0, '', '2019-08-12 17:40:29');
INSERT INTO `access_log` VALUES (66011, '7303fece-0449-4f8b-9323-6f12f31354eb', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:40:30', 19, 0, '', '2019-08-12 17:40:30');
INSERT INTO `access_log` VALUES (66012, '886fbd7e-fec6-43fb-aeb2-f25ebfbe38e3', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:40:31', 221, 0, '', '2019-08-12 17:40:31');
INSERT INTO `access_log` VALUES (66013, '034946bb-b60c-41fc-a3a1-4029bbb03673', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:40:31', 228, 0, '', '2019-08-12 17:40:31');
INSERT INTO `access_log` VALUES (66014, '5e8262d3-829c-4d70-a14b-cd2ec5578a7e', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:40:34', 20, 0, '', '2019-08-12 17:40:34');
INSERT INTO `access_log` VALUES (66015, 'ef9fd985-1074-461f-9b74-dbed72f64802', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:40:36', 20, 0, '', '2019-08-12 17:40:36');
INSERT INTO `access_log` VALUES (66016, '2489ede0-7ca4-4100-9d92-9cf934e064ef', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:40:36', 30, 0, '', '2019-08-12 17:40:36');
INSERT INTO `access_log` VALUES (66017, '7d5334d3-2577-4ab1-93a5-6b1dee00865c', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:55:44', 530, 0, '', '2019-08-12 17:55:45');
INSERT INTO `access_log` VALUES (66018, '52c43657-4a0d-4567-8a9c-c2b87d0c1f22', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:55:44', 678, 0, '', '2019-08-12 17:55:45');
INSERT INTO `access_log` VALUES (66019, '24012bcd-a4cf-49f0-991b-18152fc75192', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:55:48', 321, 0, '', '2019-08-12 17:55:48');
INSERT INTO `access_log` VALUES (66020, '4b321707-3bda-4a87-a067-bed9a5ccbe91', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:55:48', 324, 0, '', '2019-08-12 17:55:48');
INSERT INTO `access_log` VALUES (66021, '0dbd99c6-af05-4937-9628-86c19da6f4c1', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:55:48', 309, 0, '', '2019-08-12 17:55:48');
INSERT INTO `access_log` VALUES (66022, '9e721dd3-397c-4ad6-ba0e-7aaa514e971f', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:55:48', 720, 2001001000, '服务端发生异常', '2019-08-12 17:55:49');
INSERT INTO `access_log` VALUES (66023, '97fd3c53-5be8-4834-b9df-c78223c14bb8', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:56:08', 26, 0, '', '2019-08-12 17:56:08');
INSERT INTO `access_log` VALUES (66024, 'c60d967f-b619-4e5b-bf49-1cc67a08803d', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:56:08', 41, 0, '', '2019-08-12 17:56:08');
INSERT INTO `access_log` VALUES (66025, '4694caf4-2e10-46ef-acb4-185dafd3989c', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:56:12', 25, 0, '', '2019-08-12 17:56:12');
INSERT INTO `access_log` VALUES (66026, 'e4db5e0d-19ae-4aff-85af-4b8bd2a9778a', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:56:12', 58, 0, '', '2019-08-12 17:56:12');
INSERT INTO `access_log` VALUES (66027, '6224f9d2-42d8-4328-8390-8e0098b4d809', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:56:12', 38, 0, '', '2019-08-12 17:56:12');
INSERT INTO `access_log` VALUES (66028, '96253dbc-13d2-49db-aa06-2f66750a4d45', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:56:12', 131, 2001001000, '服务端发生异常', '2019-08-12 17:56:12');
INSERT INTO `access_log` VALUES (66029, '77c70c69-d771-46fb-9ac3-b2f12c0a9eb9', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:57:06', 24, 0, '', '2019-08-12 17:57:06');
INSERT INTO `access_log` VALUES (66030, '4e56bfb0-6a04-4a66-b55e-4a9abdf03093', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:57:06', 56, 0, '', '2019-08-12 17:57:06');
INSERT INTO `access_log` VALUES (66031, '270c310d-0019-4449-bca8-5efc242d4f8a', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:57:06', 42, 0, '', '2019-08-12 17:57:06');
INSERT INTO `access_log` VALUES (66032, 'fa81aea5-789e-445f-8057-269e3e40ce7b', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:57:06', 5730, 2001001000, '服务端发生异常', '2019-08-12 17:57:12');
INSERT INTO `access_log` VALUES (66033, '1020c0c8-b97e-4a74-855e-0b1be0bb556c', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:27', 35, 0, '', '2019-08-12 17:58:27');
INSERT INTO `access_log` VALUES (66034, '70f3e1a6-d0a1-4345-96d6-88cf59c4fa52', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:27', 75, 0, '', '2019-08-12 17:58:27');
INSERT INTO `access_log` VALUES (66035, 'eab7e2ed-1b01-48e1-bf06-81bebd4e3626', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:27', 47, 0, '', '2019-08-12 17:58:27');
INSERT INTO `access_log` VALUES (66036, '0455d1b7-a0a8-4a04-91b9-b88363553775', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:27', 3286, 0, '', '2019-08-12 17:58:30');
INSERT INTO `access_log` VALUES (66037, '37d02c6a-f52d-4e5e-ac43-5db7538b4742', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:35', 26, 0, '', '2019-08-12 17:58:35');
INSERT INTO `access_log` VALUES (66038, 'c68963ec-c5b4-40cb-97e3-accf79dc8e15', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:35', 57, 0, '', '2019-08-12 17:58:35');
INSERT INTO `access_log` VALUES (66039, '698b4d3d-4ec7-4d9b-bfea-d060e8fb9854', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:36', 27, 0, '', '2019-08-12 17:58:36');
INSERT INTO `access_log` VALUES (66040, 'e1beba98-acce-409c-8d3f-dbe74cffa6f7', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:36', 42, 0, '', '2019-08-12 17:58:36');
INSERT INTO `access_log` VALUES (66041, '9539b226-c6ee-4d32-8188-046a055da28c', 197, 1, 'order-impl', '/order-api/users/cart/add', 'skuId=36&quantity=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:38', 108, 0, '', '2019-08-12 17:58:38');
INSERT INTO `access_log` VALUES (66042, 'b915c953-a4bf-4142-a638-0258ac913bab', 197, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:41', 102, 0, '', '2019-08-12 17:58:41');
INSERT INTO `access_log` VALUES (66043, 'ca8245a3-0f7c-4dfb-b322-c1b889f8f03d', 197, 1, 'order-impl', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:41', 169, 0, '', '2019-08-12 17:58:41');
INSERT INTO `access_log` VALUES (66044, 'bd35ca60-6611-49cd-b73b-6d62ace7bc74', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:43', 24, 0, '', '2019-08-12 17:58:43');
INSERT INTO `access_log` VALUES (66045, '35b082cb-776d-4232-862a-d2fdfd7156ce', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:43', 56, 0, '', '2019-08-12 17:58:43');
INSERT INTO `access_log` VALUES (66046, 'd719ebc4-9f41-419b-91a1-ed44d4626497', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:43', 23, 0, '', '2019-08-12 17:58:44');
INSERT INTO `access_log` VALUES (66047, '8e340f5b-1518-41bf-89a0-27c2b0669776', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:43', 36, 0, '', '2019-08-12 17:58:44');
INSERT INTO `access_log` VALUES (66048, 'ca9230b1-4031-410a-9153-da508d60af0c', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:44', 31, 0, '', '2019-08-12 17:58:44');
INSERT INTO `access_log` VALUES (66049, '796ea2a2-eb29-4fdc-9058-0ac5bcbbfd30', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:44', 40, 0, '', '2019-08-12 17:58:44');
INSERT INTO `access_log` VALUES (66050, 'fc5f8273-e6b7-499b-a53a-62d7d1f8b618', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:47', 30, 0, '', '2019-08-12 17:58:48');
INSERT INTO `access_log` VALUES (66051, 'ddda561f-fbe5-4f70-a032-81bdf8d36f1b', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:48', 23, 0, '', '2019-08-12 17:58:48');
INSERT INTO `access_log` VALUES (66052, 'c3d75577-20c8-4eff-a640-3b4bf3a09913', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:58:48', 109, 0, '', '2019-08-12 17:58:49');
INSERT INTO `access_log` VALUES (66053, '943d8c22-9898-4173-9bc8-06bb0e8e1b06', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:03', 23, 0, '', '2019-08-12 17:59:03');
INSERT INTO `access_log` VALUES (66054, 'fcd60ec9-5373-4986-8ee6-73828b13d2aa', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:03', 21, 0, '', '2019-08-12 17:59:03');
INSERT INTO `access_log` VALUES (66055, '4e3503f6-a1b9-446b-b8e0-4d1948a74715', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:05', 68, 0, '', '2019-08-12 17:59:05');
INSERT INTO `access_log` VALUES (66056, 'b8dbb5f0-e36d-4731-b1d0-7d042c90538f', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:07', 22, 0, '', '2019-08-12 17:59:07');
INSERT INTO `access_log` VALUES (66057, 'a21b83d9-56d5-424c-af77-a88b658b1aa3', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:07', 22, 0, '', '2019-08-12 17:59:07');
INSERT INTO `access_log` VALUES (66058, '34b40932-6f0a-4e7e-b267-9071543c2688', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:08', 83, 0, '', '2019-08-12 17:59:08');
INSERT INTO `access_log` VALUES (66059, 'b17456e7-5ea0-4b18-940d-6afd340e0b34', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:14', 20, 0, '', '2019-08-12 17:59:14');
INSERT INTO `access_log` VALUES (66060, 'c22e0097-70bb-40fb-924d-19342ad845d6', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:15', 175, 0, '', '2019-08-12 17:59:15');
INSERT INTO `access_log` VALUES (66061, '0645818a-fe63-4ece-abb9-8533d3443a68', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:18', 23, 0, '', '2019-08-12 17:59:18');
INSERT INTO `access_log` VALUES (66062, '4961d4ba-bd99-450f-9693-534227150232', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:20', 57, 0, '', '2019-08-12 17:59:20');
INSERT INTO `access_log` VALUES (66063, 'cb6f7fd7-c9d1-4112-bd35-e732cb7c441f', 197, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=224', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:21', 320, 0, '', '2019-08-12 17:59:21');
INSERT INTO `access_log` VALUES (66064, 'fc52f557-00ad-4fde-9dd0-9570aa6d40e5', 197, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=224&payChannel=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:22', 565, 2001001000, '服务端发生异常', '2019-08-12 17:59:22');
INSERT INTO `access_log` VALUES (66065, '72957615-8f9c-48d7-9211-75a4303c3544', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:45', 53, 0, '', '2019-08-12 17:59:45');
INSERT INTO `access_log` VALUES (66066, '6f3859b9-550c-473e-bcc0-da410b5c7e3b', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:47', 50, 0, '', '2019-08-12 17:59:47');
INSERT INTO `access_log` VALUES (66067, 'a1740e65-f6f6-461e-8300-2d9b528b43e7', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:48', 19, 0, '', '2019-08-12 17:59:48');
INSERT INTO `access_log` VALUES (66068, '99d9b5a0-54c1-434b-b82b-1be0af6a4948', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:49', 23, 0, '', '2019-08-12 17:59:49');
INSERT INTO `access_log` VALUES (66069, 'c0849358-068c-4a71-8244-f207e4df6368', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:51', 47, 0, '', '2019-08-12 17:59:51');
INSERT INTO `access_log` VALUES (66070, '9526f4c8-1f0c-4e82-968d-53ad85a1ff75', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:56', 54, 0, '', '2019-08-12 17:59:56');
INSERT INTO `access_log` VALUES (66071, 'efdb9f9f-3726-4819-a6db-ba8d2a2640c5', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:57', 22, 0, '', '2019-08-12 17:59:57');
INSERT INTO `access_log` VALUES (66072, 'f7d596f4-34cf-469d-b3f5-f10449b1bc10', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:00', 38, 0, '', '2019-08-12 18:00:00');
INSERT INTO `access_log` VALUES (66073, 'ed3e71aa-44d2-4a73-b3c3-c953119df6ed', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:00', 38, 0, '', '2019-08-12 18:00:00');
INSERT INTO `access_log` VALUES (66074, '0517bafb-5fc2-4101-9e1d-ac01833ba766', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:02', 22, 0, '', '2019-08-12 18:00:02');
INSERT INTO `access_log` VALUES (66075, '4591b50c-446f-440d-86ba-ca1dae06d5f2', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:02', 24, 0, '', '2019-08-12 18:00:02');
INSERT INTO `access_log` VALUES (66076, '8881f9ff-f5ea-4e27-aed5-3e5061964d22', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:04', 21, 0, '', '2019-08-12 18:00:04');
INSERT INTO `access_log` VALUES (66077, 'a2f458cd-b86f-42c7-a138-ed11165d8bc8', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:04', 21, 0, '', '2019-08-12 18:00:04');
INSERT INTO `access_log` VALUES (66078, '53e624a5-c379-4795-bebd-eaec1f0a76d7', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:05', 75, 0, '', '2019-08-12 18:00:05');
INSERT INTO `access_log` VALUES (66079, '9caa2cb0-8caa-44c2-854a-489ffac0f20b', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:06', 22, 0, '', '2019-08-12 18:00:06');
INSERT INTO `access_log` VALUES (66080, '2c3cef82-c1ca-4325-b487-ba61da5ea449', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:06', 57, 0, '', '2019-08-12 18:00:06');
INSERT INTO `access_log` VALUES (66081, '473d97fc-4127-4260-9241-9d519b3d4809', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:07', 23, 0, '', '2019-08-12 18:00:07');
INSERT INTO `access_log` VALUES (66082, '54918f12-1b48-45ce-affc-422d64c68043', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:07', 35, 0, '', '2019-08-12 18:00:07');
INSERT INTO `access_log` VALUES (66083, 'bd5e2f9d-9e1c-4421-9517-a1a1dffa60bc', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:30', 63, 0, '', '2019-08-12 18:00:30');
INSERT INTO `access_log` VALUES (66084, '24b3a2ed-1a66-4aba-bb11-8dce11095582', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:30', 20, 0, '', '2019-08-12 18:00:30');
INSERT INTO `access_log` VALUES (66085, '0ac0124d-89db-4752-a9ef-3c9eca3da383', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:30', 21, 0, '', '2019-08-12 18:00:30');
INSERT INTO `access_log` VALUES (66086, 'ace6dd81-1fe2-4179-8b1b-a15046ab5c3e', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:32', 21, 0, '', '2019-08-12 18:00:32');
INSERT INTO `access_log` VALUES (66087, '3edb9f15-c7ff-402b-b75e-b7bd350d8a3b', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:32', 21, 0, '', '2019-08-12 18:00:32');
INSERT INTO `access_log` VALUES (66088, 'd7ba1eab-a8fa-476b-b94e-cf71e3f3ff4d', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:33', 21, 0, '', '2019-08-12 18:00:33');
INSERT INTO `access_log` VALUES (66089, '07461f83-bb9b-4043-904d-7b3768cfe0ce', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:33', 36, 0, '', '2019-08-12 18:00:33');
INSERT INTO `access_log` VALUES (66090, '2209aad7-27f8-4345-93b8-8f1bd78c7b13', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:33', 50, 0, '', '2019-08-12 18:00:34');
INSERT INTO `access_log` VALUES (66091, 'a33dd402-30ae-401c-a6ad-8efa1ad52380', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:33', 79, 0, '', '2019-08-12 18:00:34');
INSERT INTO `access_log` VALUES (66092, 'aefe9951-4a90-4d13-b9c9-f126c9fee5cb', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=34', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:34', 23, 0, '', '2019-08-12 18:00:34');
INSERT INTO `access_log` VALUES (66093, 'fbdab1e1-089f-4fef-8a40-5213b9124e34', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:34', 37, 0, '', '2019-08-12 18:00:34');
INSERT INTO `access_log` VALUES (66094, '1efab3cd-3006-4928-a059-190ec0eac1d6', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:37', 30, 0, '', '2019-08-12 18:00:37');
INSERT INTO `access_log` VALUES (66095, 'cceb4d91-9b86-40aa-828d-04976ff85af4', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:00:37', 42, 0, '', '2019-08-12 18:00:37');
INSERT INTO `access_log` VALUES (66096, '41d48e59-3a6d-4c50-b443-710c57ff26b2', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:25', 19, 0, '', '2019-08-12 18:01:25');
INSERT INTO `access_log` VALUES (66097, '632e95d3-43a8-4670-89df-5eac731eb972', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:25', 21, 0, '', '2019-08-12 18:01:25');
INSERT INTO `access_log` VALUES (66098, '8ccb9f89-fab0-4fed-b7c8-9aa891ec9305', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:27', 20, 0, '', '2019-08-12 18:01:27');
INSERT INTO `access_log` VALUES (66099, 'cedba19f-119a-48ec-bf30-f9397c74e683', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:28', 19, 0, '', '2019-08-12 18:01:28');
INSERT INTO `access_log` VALUES (66100, '8c8fda23-3b91-4c5f-b97f-4f3bbd2fc48e', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:29', 73, 0, '', '2019-08-12 18:01:29');
INSERT INTO `access_log` VALUES (66101, 'aad5abe5-903b-456a-a5e4-96426a5d5b8f', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:32', 20, 0, '', '2019-08-12 18:01:32');
INSERT INTO `access_log` VALUES (66102, '739b3d0c-6005-40f1-a72d-3cd098cf5b7e', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:32', 21, 0, '', '2019-08-12 18:01:32');
INSERT INTO `access_log` VALUES (66103, '42746033-49a0-4e4a-a0c5-6dd05a195937', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:33', 66, 0, '', '2019-08-12 18:01:33');
INSERT INTO `access_log` VALUES (66104, '6ae6d2ed-8efa-4ecc-8727-c549e175cca0', 197, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:35', 27, 0, '', '2019-08-12 18:01:35');
INSERT INTO `access_log` VALUES (66105, '55422115-9789-4fad-9225-2e3b0de6a9a4', 197, 1, 'order-impl', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:35', 83, 0, '', '2019-08-12 18:01:35');
INSERT INTO `access_log` VALUES (66106, '537b1c78-1555-4785-a021-bf1ec9f481a5', 197, 1, 'order-impl', '/order-api/users/order/create_order_from_cart', 'userAddressId=18&remark=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:37', 1801, 0, '', '2019-08-12 18:01:39');
INSERT INTO `access_log` VALUES (66107, 'c350b471-2d73-46c6-aea2-22d742e09c74', 197, 1, 'pay-application', '/pay-api/users/transaction/get', 'appId=POd4RC6a&orderId=226', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:39', 26, 0, '', '2019-08-12 18:01:39');
INSERT INTO `access_log` VALUES (66108, 'fb709a22-7719-4c3b-a07f-c5b671d58865', 197, 1, 'order-impl', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:42', 25, 0, '', '2019-08-12 18:01:42');
INSERT INTO `access_log` VALUES (66109, 'f86c9956-e814-4c80-8928-f95c9b5d0ecc', 197, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:42', 24, 0, '', '2019-08-12 18:01:42');
INSERT INTO `access_log` VALUES (66110, '2504a973-39aa-4c84-b9fa-f4e52b061d28', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:42', 23, 0, '', '2019-08-12 18:01:42');
INSERT INTO `access_log` VALUES (66111, 'c0d9fe3d-6551-4f2b-a2b9-12d7c0846fcc', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:43', 22, 0, '', '2019-08-12 18:01:43');
INSERT INTO `access_log` VALUES (66112, 'ee0311d0-698a-42d6-a86f-f20b139a4271', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:43', 22, 0, '', '2019-08-12 18:01:43');
INSERT INTO `access_log` VALUES (66113, 'e0e0aceb-fd59-4edd-acdb-99d429ea249d', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:45', 22, 0, '', '2019-08-12 18:01:45');
INSERT INTO `access_log` VALUES (66114, '7a2b1d11-c604-4e41-a81d-240c226c0dbd', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:47', 45, 0, '', '2019-08-12 18:01:47');
INSERT INTO `access_log` VALUES (66115, '6cb9b2aa-3c8c-4e49-8abd-209f97b5658b', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:51', 58, 0, '', '2019-08-12 18:01:51');
INSERT INTO `access_log` VALUES (66116, 'e3c476ed-1dd8-4e66-915c-599efdc7f36f', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:51', 18, 0, '', '2019-08-12 18:01:51');
INSERT INTO `access_log` VALUES (66117, '6ff092eb-53d4-43dd-985e-d9cb5eb9a9ca', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:52', 20, 0, '', '2019-08-12 18:01:52');
INSERT INTO `access_log` VALUES (66118, 'ef372ee2-915b-4c54-8a25-64feda3862d3', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:53', 20, 0, '', '2019-08-12 18:01:53');
INSERT INTO `access_log` VALUES (66119, '69f6513c-7a7b-442d-983a-d41e02379d3d', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:54', 24, 0, '', '2019-08-12 18:01:54');
INSERT INTO `access_log` VALUES (66120, 'ecc73f83-17ae-49d3-a4ec-ef4e32493d01', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:56', 21, 0, '', '2019-08-12 18:01:56');
INSERT INTO `access_log` VALUES (66121, 'd519d3e0-b479-42c4-9ce9-165a18e5d858', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:56', 18, 0, '', '2019-08-12 18:01:56');
INSERT INTO `access_log` VALUES (66122, '116e9f74-89b1-44d3-9095-4265b7e1a35b', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:01:58', 21, 0, '', '2019-08-12 18:01:58');
INSERT INTO `access_log` VALUES (66123, '7acf1b52-844c-449a-be9e-537a0f0eff4c', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:02:00', 21, 0, '', '2019-08-12 18:02:00');
INSERT INTO `access_log` VALUES (66124, '48d82ef6-f7d9-468b-942c-83fe096a4796', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:02:00', 18, 0, '', '2019-08-12 18:02:00');
INSERT INTO `access_log` VALUES (66125, '9b0b91d7-1710-4e5b-9fcc-faef918713ee', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:02:01', 19, 0, '', '2019-08-12 18:02:01');
INSERT INTO `access_log` VALUES (66126, '3ca0e109-4bae-40e7-82e1-e989bd95d06d', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:02:01', 39, 0, '', '2019-08-12 18:02:01');
INSERT INTO `access_log` VALUES (66127, '4d69a8d1-7d41-40e6-827c-0f1dce02a959', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:02:03', 19, 0, '', '2019-08-12 18:02:03');
INSERT INTO `access_log` VALUES (66128, '1133c0fa-6777-44d5-8831-36ebd2c31a3e', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:02:05', 23, 0, '', '2019-08-12 18:02:05');
INSERT INTO `access_log` VALUES (66129, '5c479d6c-bc76-44ca-8d62-8fd3447a68fe', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:02:05', 36, 0, '', '2019-08-12 18:02:05');
INSERT INTO `access_log` VALUES (66130, 'f84b940a-849c-4c03-bb3c-fc0930a5d40a', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:02:06', 19, 0, '', '2019-08-12 18:02:06');
INSERT INTO `access_log` VALUES (66131, '1be74a25-0652-4822-8251-3c414439f616', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:02:39', 22, 0, '', '2019-08-12 18:02:39');
INSERT INTO `access_log` VALUES (66132, 'a4a8d373-9d31-4e02-b570-54cc001514e4', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:02:39', 33, 0, '', '2019-08-12 18:02:39');
INSERT INTO `access_log` VALUES (66133, 'e0ed2829-183e-40d4-a894-c13b531e3a3e', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:03:09', 21, 0, '', '2019-08-12 18:03:09');
INSERT INTO `access_log` VALUES (66134, '3711e712-fcde-43df-b6b5-4323a62c37c2', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:03:09', 20, 0, '', '2019-08-12 18:03:09');
INSERT INTO `access_log` VALUES (66135, 'e9121715-0d1a-4c3b-86c1-959cfdb1d57b', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:03:10', 22, 0, '', '2019-08-12 18:03:10');
INSERT INTO `access_log` VALUES (66136, 'aec860b6-c348-4c25-b808-65a7f6d7a304', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:03:11', 18, 0, '', '2019-08-12 18:03:11');
INSERT INTO `access_log` VALUES (66137, '8b92cae4-db40-4401-9058-759cb83921ac', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:03:11', 17, 0, '', '2019-08-12 18:03:12');
INSERT INTO `access_log` VALUES (66138, '85783c30-e7df-4488-add3-1ab418d814f2', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:03:12', 22, 0, '', '2019-08-12 18:03:12');
INSERT INTO `access_log` VALUES (66139, '380d8fb6-edce-4501-b77f-e726c137c5cb', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:03:12', 35, 0, '', '2019-08-12 18:03:12');
INSERT INTO `access_log` VALUES (66140, '4d576299-873b-4637-9874-c219f8f2f3be', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:03:14', 22, 0, '', '2019-08-12 18:03:14');
INSERT INTO `access_log` VALUES (66141, 'bf7eeb36-4b8c-4c3b-b570-66d81535fad9', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:03:14', 29, 0, '', '2019-08-12 18:03:14');
INSERT INTO `access_log` VALUES (66142, '07b094b3-143f-4b6d-a221-2822de80075b', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:03:15', 20, 0, '', '2019-08-12 18:03:15');
INSERT INTO `access_log` VALUES (66143, '5a9a67e1-6659-4a28-86c6-848009a0b71b', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:03:35', 22, 0, '', '2019-08-12 18:03:35');
INSERT INTO `access_log` VALUES (66144, '4d2bf397-6edb-4073-a166-f294851120b5', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:03:51', 21, 0, '', '2019-08-12 18:03:51');
INSERT INTO `access_log` VALUES (66145, '87524cd5-73f0-4bcd-afa2-68a11bb24fc2', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:03:51', 19, 0, '', '2019-08-12 18:03:51');
INSERT INTO `access_log` VALUES (66146, 'acde7fa8-7ccf-4918-a85e-1b68e0293e50', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:04:32', 25, 0, '', '2019-08-12 18:04:32');
INSERT INTO `access_log` VALUES (66147, 'ec910ec5-1f9f-4bde-a000-365c1b36680c', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:04:34', 21, 0, '', '2019-08-12 18:04:34');
INSERT INTO `access_log` VALUES (66148, 'bf7fae82-b0ad-4089-a495-81022aac5d69', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:04:34', 20, 0, '', '2019-08-12 18:04:34');
INSERT INTO `access_log` VALUES (66149, 'a41d8994-6a1a-4ed9-8a52-964cb5a9cc5f', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:04:35', 26, 0, '', '2019-08-12 18:04:35');
INSERT INTO `access_log` VALUES (66150, '0748c7f4-f4fb-4db9-8761-51c98de54eea', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:04:36', 49, 0, '', '2019-08-12 18:04:36');
INSERT INTO `access_log` VALUES (66151, 'ef91a754-1357-4cc7-abad-186a58b660cb', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:04:39', 22, 0, '', '2019-08-12 18:04:39');
INSERT INTO `access_log` VALUES (66152, 'f9ed6563-ca21-465c-b681-8bbc218a2931', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:09:53', 90, 1002001015, '账号未登陆', '2019-08-12 18:09:53');
INSERT INTO `access_log` VALUES (66153, 'f47ba67e-9d0d-4a91-957e-016e2a0876fe', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:09:53', 90, 1002001015, '账号未登陆', '2019-08-12 18:09:53');
INSERT INTO `access_log` VALUES (66154, '0bb1ceab-76f8-4603-ac0d-d040539ca418', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:09:53', 90, 1002001015, '账号未登陆', '2019-08-12 18:09:53');
INSERT INTO `access_log` VALUES (66155, '04f6da1f-d9aa-4e0a-b4f7-f182df932316', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:09:55', 437, 2001001000, '服务端发生异常', '2019-08-12 18:09:55');
INSERT INTO `access_log` VALUES (66156, 'f030e57d-1b44-45a3-89ab-220891e55b48', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:10:08', 119, 2001001000, '服务端发生异常', '2019-08-12 18:10:08');
INSERT INTO `access_log` VALUES (66157, '019d1421-e482-4c22-976c-a705847f0b4a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:10:18', 116, 2001001000, '服务端发生异常', '2019-08-12 18:10:18');
INSERT INTO `access_log` VALUES (66158, '7679f76f-c570-4c29-ac6b-b0b5814ea30a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:11:17', 16, 1002002001, '密码不正确', '2019-08-12 18:11:17');
INSERT INTO `access_log` VALUES (66159, '7bde6d13-33c3-456c-82ac-8c0add358fab', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:11:24', 12, 1002002001, '密码不正确', '2019-08-12 18:11:24');
INSERT INTO `access_log` VALUES (66160, '7fefbf2a-0f12-458d-be99-401db12bdb86', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:11:42', 729, 0, '', '2019-08-12 18:11:43');
INSERT INTO `access_log` VALUES (66161, 'ed824575-6d11-495e-8063-719bc4af3833', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:11:43', 212, 0, '', '2019-08-12 18:11:44');
INSERT INTO `access_log` VALUES (66162, '992f62ca-7cf7-49ec-9501-b1839f9718b9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:11:43', 221, 0, '', '2019-08-12 18:11:44');
INSERT INTO `access_log` VALUES (66163, '38ff8133-3dce-4a27-9b27-3edcf3f827b5', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:11:43', 218, 0, '', '2019-08-12 18:11:44');
INSERT INTO `access_log` VALUES (66164, '8297e5b1-acd3-4fc5-bf58-b677e034ff1b', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:11:47', 184, 0, '', '2019-08-12 18:11:47');
INSERT INTO `access_log` VALUES (66165, 'e1a4cb63-7727-4015-b71a-113a7d36e30f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:11:49', 52, 0, '', '2019-08-12 18:11:50');
INSERT INTO `access_log` VALUES (66166, '96351594-0480-447d-962f-5086b181f8a2', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:11:49', 71, 0, '', '2019-08-12 18:11:50');
INSERT INTO `access_log` VALUES (66167, '86832fcd-46bc-4045-ad2a-29a2000f7929', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:11:52', 146, 0, '', '2019-08-12 18:11:53');
INSERT INTO `access_log` VALUES (66168, '2da44f70-6b0b-4ea8-b878-cd998128eacc', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:11:55', 168, 0, '', '2019-08-12 18:11:55');
INSERT INTO `access_log` VALUES (66169, '87d4f81c-ff63-4674-abb3-d88729935216', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:11:57', 165, 0, '', '2019-08-12 18:11:57');
INSERT INTO `access_log` VALUES (66170, '8e7ed2af-18ce-45a7-b6b9-bc265ca177cd', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:11:57', 175, 0, '', '2019-08-12 18:11:57');
INSERT INTO `access_log` VALUES (66171, '3b36f164-4bda-4fbb-bb4d-325e5b0a22b3', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:12:01', 45, 0, '', '2019-08-12 18:12:01');
INSERT INTO `access_log` VALUES (66172, 'fd9901da-fe37-4d2e-b51c-6d2f1d6a8d17', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:12:01', 82, 0, '', '2019-08-12 18:12:01');
INSERT INTO `access_log` VALUES (66173, 'a4bbeca9-2652-4587-803b-737c236cce3e', 1, 2, 'order-impl', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:12:06', 120, 0, '', '2019-08-12 18:12:06');
INSERT INTO `access_log` VALUES (66174, '31b3b999-79e0-4b53-9a99-308958823112', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:12:14', 149, 0, '', '2019-08-12 18:12:14');
INSERT INTO `access_log` VALUES (66175, 'b19279a7-e16f-4d4f-9f5d-4236955b4663', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:12:16', 147, 0, '', '2019-08-12 18:12:16');
INSERT INTO `access_log` VALUES (66176, '40ddd5bb-e583-44d3-b6a3-04fdeea2985b', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:12:18', 79, 0, '', '2019-08-12 18:12:18');
INSERT INTO `access_log` VALUES (66177, '624e1aa8-596d-4867-9c9c-99aa228a062c', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:12:20', 148, 0, '', '2019-08-12 18:12:20');
INSERT INTO `access_log` VALUES (66178, '6c7eed05-5e5d-4112-bcd3-b85c14a14dae', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:12:22', 124, 0, '', '2019-08-12 18:12:22');
INSERT INTO `access_log` VALUES (66179, '827b020a-e90d-4560-9c2c-81cf31d3a8a1', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:12:24', 52, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-12 18:12:25');
INSERT INTO `access_log` VALUES (66180, '80f2849c-db96-4c4a-8af9-87ab2296cf44', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:12:27', 141, 2001001000, '服务端发生异常', '2019-08-12 18:12:27');
INSERT INTO `access_log` VALUES (66181, 'f7e06dc6-3a8e-4c79-99cf-d4c11ea2edb8', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:12:27', 1272, 2001001000, '服务端发生异常', '2019-08-12 18:12:28');
INSERT INTO `access_log` VALUES (66182, '7930d7a8-af14-452e-a8ae-84c68b4dd660', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:13:06', 41, 0, '', '2019-08-12 18:13:06');
INSERT INTO `access_log` VALUES (66183, '837ffcd3-f327-423f-9d3f-894e4f79d469', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:13:06', 37, 0, '', '2019-08-12 18:13:06');
INSERT INTO `access_log` VALUES (66184, 'b50e9bc4-6daf-47da-9f7a-db6593cac46b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:13:06', 39, 0, '', '2019-08-12 18:13:06');
INSERT INTO `access_log` VALUES (66185, '8cabfbf3-9557-4195-9494-88c037bb3130', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:13:06', 196, 2001001000, '服务端发生异常', '2019-08-12 18:13:06');
INSERT INTO `access_log` VALUES (66186, '3da375fd-bf14-4a15-92f2-d1ab68c0bf1c', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:13:06', 288, 2001001000, '服务端发生异常', '2019-08-12 18:13:06');
INSERT INTO `access_log` VALUES (66187, '5f008b33-ccd7-466e-94d2-9ac9dbb0064f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:13:16', 36, 0, '', '2019-08-12 18:13:16');
INSERT INTO `access_log` VALUES (66188, '418ad5a5-d4a9-43fd-956d-e2e99e72eced', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:13:16', 37, 0, '', '2019-08-12 18:13:16');
INSERT INTO `access_log` VALUES (66189, 'd4e196fa-ebf7-4a1e-901c-af859ad650f0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:13:16', 38, 0, '', '2019-08-12 18:13:16');
INSERT INTO `access_log` VALUES (66190, '5f932ea5-d1bf-42f9-acdd-92bd8661d627', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:13:16', 161, 2001001000, '服务端发生异常', '2019-08-12 18:13:17');
INSERT INTO `access_log` VALUES (66191, 'b2f42b38-990f-448b-952f-ba4168abbee0', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:13:16', 213, 2001001000, '服务端发生异常', '2019-08-12 18:13:17');
INSERT INTO `access_log` VALUES (66192, '3eda2cf0-988b-4438-829a-b105bddf9729', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:00', 30, 0, '', '2019-08-12 18:14:00');
INSERT INTO `access_log` VALUES (66193, '3822945e-3a6e-4773-8fef-fbc631f19ee3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:00', 36, 0, '', '2019-08-12 18:14:00');
INSERT INTO `access_log` VALUES (66194, '1403db96-5966-4cde-8351-a64cb8b5abe2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:00', 34, 0, '', '2019-08-12 18:14:00');
INSERT INTO `access_log` VALUES (66195, 'b96c44e1-bff7-4947-a39f-dab62f694146', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:00', 43, 0, '', '2019-08-12 18:14:00');
INSERT INTO `access_log` VALUES (66196, '23b735f1-b383-4788-931d-826e33e9bec5', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:00', 99, 0, '', '2019-08-12 18:14:00');
INSERT INTO `access_log` VALUES (66197, '3defb4b8-a36c-4326-86ed-6619268fcc90', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:06', 110, 0, '', '2019-08-12 18:14:06');
INSERT INTO `access_log` VALUES (66198, '73289bf9-d53f-450d-99ee-28042cf9ec56', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:08', 49, 0, '', '2019-08-12 18:14:08');
INSERT INTO `access_log` VALUES (66199, 'fa2dfa46-2802-4178-ab02-6222ca8b3a99', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:10', 59, 0, '', '2019-08-12 18:14:10');
INSERT INTO `access_log` VALUES (66200, '59638f64-1cfa-4069-bb6f-c681382e871f', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:12', 32, 0, '', '2019-08-12 18:14:12');
INSERT INTO `access_log` VALUES (66201, '981315a6-5d44-4e25-a2e9-ee0a2256075e', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:12', 97, 0, '', '2019-08-12 18:14:12');
INSERT INTO `access_log` VALUES (66202, '71a07296-c103-4468-913a-1de07e86c404', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:17', 41, 0, '', '2019-08-12 18:14:17');
INSERT INTO `access_log` VALUES (66203, 'c1db7c12-9b14-46e2-b813-c331212a9eeb', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:20', 37, 0, '', '2019-08-12 18:14:20');
INSERT INTO `access_log` VALUES (66204, 'f1e161e8-7118-4d77-9c04-83862eef23b7', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:25', 53, 0, '', '2019-08-12 18:14:25');
INSERT INTO `access_log` VALUES (66205, '0142f30e-4a94-4807-a971-4cdfc4b1056c', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:30', 51, 0, '', '2019-08-12 18:14:30');
INSERT INTO `access_log` VALUES (66206, '50b0eb9d-e365-42e2-bf4a-c1d0d2d34538', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:33', 67, 0, '', '2019-08-12 18:14:33');
INSERT INTO `access_log` VALUES (66207, '933ff9d1-8e0a-4f39-b739-181a10a73a19', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:35', 47, 0, '', '2019-08-12 18:14:35');
INSERT INTO `access_log` VALUES (66208, '970b8277-ed39-4cff-8557-98d23adffefd', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:37', 50, 0, '', '2019-08-12 18:14:37');
INSERT INTO `access_log` VALUES (66209, '5324fdae-ba9e-4d18-aa09-f4bb078423e0', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:39', 32, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-12 18:14:39');
INSERT INTO `access_log` VALUES (66210, 'a491bd08-2df7-43f5-ba3f-5b3be3cc9087', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:48', 36, 0, '', '2019-08-12 18:14:48');
INSERT INTO `access_log` VALUES (66211, '18afe1a6-0e72-45c3-ac09-47adb9d5e7d5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:48', 38, 0, '', '2019-08-12 18:14:48');
INSERT INTO `access_log` VALUES (66212, '71f86e1a-1a15-4cba-a7c0-346386519c63', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:48', 37, 0, '', '2019-08-12 18:14:48');
INSERT INTO `access_log` VALUES (66213, '7a7195a5-1aab-4aed-a7a1-dcdc764db030', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:14:49', 32, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-12 18:14:49');
INSERT INTO `access_log` VALUES (66214, 'aa292eda-de36-46ee-99a3-79f4dc116563', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:15:03', 37, 0, '', '2019-08-12 18:15:03');
INSERT INTO `access_log` VALUES (66215, 'bb7e9687-90c6-4637-af8f-bd92a42b38e4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:15:03', 40, 0, '', '2019-08-12 18:15:03');
INSERT INTO `access_log` VALUES (66216, '41b81724-b8a0-4cdd-9d79-87cbfd62b041', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:15:03', 37, 0, '', '2019-08-12 18:15:03');
INSERT INTO `access_log` VALUES (66217, '69569550-57fe-4b44-81bd-94bae91d75c1', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:15:03', 122, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-12 18:15:03');
INSERT INTO `access_log` VALUES (66218, '60580d5b-8c0c-4527-bcf7-4cce6fc95ef0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:17:29', 42, 0, '', '2019-08-12 18:17:29');
INSERT INTO `access_log` VALUES (66219, '8d0f3f12-2397-4790-959e-dd763c648e59', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:17:29', 49, 0, '', '2019-08-12 18:17:29');
INSERT INTO `access_log` VALUES (66220, 'f0be4d5e-27b1-4189-8041-1b8880ad63f1', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:17:29', 43, 0, '', '2019-08-12 18:17:29');
INSERT INTO `access_log` VALUES (66221, 'cbbaa305-4c41-4635-971b-026ee0a0ac17', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:17:29', 36, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-12 18:17:29');
INSERT INTO `access_log` VALUES (66222, 'e9a8d2ac-5104-44d1-a66b-49c44ef04681', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:18:01', 113, 0, '', '2019-08-12 18:18:01');
INSERT INTO `access_log` VALUES (66223, 'c4e01bff-849c-4113-a39b-b0692344f76f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:18:01', 117, 0, '', '2019-08-12 18:18:01');
INSERT INTO `access_log` VALUES (66224, '066e7c06-d6b0-4acc-8ed9-36d97360a49d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:18:01', 107, 0, '', '2019-08-12 18:18:01');
INSERT INTO `access_log` VALUES (66225, '77215757-85c6-407c-8ab7-954bea2f2b53', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:18:01', 82, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-12 18:18:01');
INSERT INTO `access_log` VALUES (66226, '2e36c258-1dfd-4be0-8595-8e1d5806d7b7', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:19:39', 82, 0, '', '2019-08-12 18:19:39');
INSERT INTO `access_log` VALUES (66227, '6bcad188-df4f-445a-96e4-85cefbd25cc1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:19:39', 80, 0, '', '2019-08-12 18:19:39');
INSERT INTO `access_log` VALUES (66228, '3bd444f1-12f4-4c69-bdba-88a3c7327ed9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:19:39', 111, 0, '', '2019-08-12 18:19:39');
INSERT INTO `access_log` VALUES (66229, '5b160012-e87e-42c2-b57f-f61420ad2c7d', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:19:39', 201, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-12 18:19:39');
INSERT INTO `access_log` VALUES (66230, '87d7e907-ac1a-44d1-963c-3bfc0bafe49c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:21:59', 42, 0, '', '2019-08-12 18:21:59');
INSERT INTO `access_log` VALUES (66231, 'a81f5b3a-eb3e-4618-b75e-63c38904d631', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:21:59', 45, 0, '', '2019-08-12 18:21:59');
INSERT INTO `access_log` VALUES (66232, '15796648-5203-4e0c-aca0-88749c558fcd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:21:59', 40, 0, '', '2019-08-12 18:21:59');
INSERT INTO `access_log` VALUES (66233, '5ea8466f-d957-4895-90f0-bdaf5f227408', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:22:00', 36, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-12 18:22:00');
INSERT INTO `access_log` VALUES (66234, 'fa1db584-777f-4eeb-878c-0c87d83a24ef', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:28:23', 63, 0, '', '2019-08-12 18:28:24');
INSERT INTO `access_log` VALUES (66235, 'cfec7ab7-726b-43ee-b67a-38ef1a308a94', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:28:23', 85, 0, '', '2019-08-12 18:28:24');
INSERT INTO `access_log` VALUES (66236, '06bdc023-0973-4b4d-b8c0-1c5f9bd73e4b', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:28:27', 23, 0, '', '2019-08-12 18:28:27');
INSERT INTO `access_log` VALUES (66237, '71678103-118f-47f9-9a0b-aa72838f0cdf', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:28:27', 36, 0, '', '2019-08-12 18:28:27');
INSERT INTO `access_log` VALUES (66238, 'b090f0ec-ea2b-4cec-9151-91f23fbcb1b9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:28:37', 34, 0, '', '2019-08-12 18:28:37');
INSERT INTO `access_log` VALUES (66239, '04fcfc19-e032-4a2b-845d-6562c8f8ae68', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:28:37', 36, 0, '', '2019-08-12 18:28:37');
INSERT INTO `access_log` VALUES (66240, '0e977ffe-49e5-4f54-aa9f-1866ba85a37c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:28:37', 40, 0, '', '2019-08-12 18:28:37');
INSERT INTO `access_log` VALUES (66241, '17624b43-1bdf-4a20-acab-7ac44f4338c0', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:26', 3585, 0, '', '2019-08-12 18:29:29');
INSERT INTO `access_log` VALUES (66242, '23e3b678-b3ed-4c41-bb5b-cede587c5a4a', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:26', 5745, 0, '', '2019-08-12 18:29:31');
INSERT INTO `access_log` VALUES (66243, '1c975d30-678a-4c01-9759-9516cf12e2e2', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:37', 80, 0, '', '2019-08-12 18:29:37');
INSERT INTO `access_log` VALUES (66244, 'd29057e0-d62e-489e-a222-0b00d138378d', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:37', 49, 0, '', '2019-08-12 18:29:37');
INSERT INTO `access_log` VALUES (66245, 'ade1d8e3-431b-47ff-ae81-743992b05700', 0, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:38', 2051, 0, '', '2019-08-12 18:29:40');
INSERT INTO `access_log` VALUES (66246, '25ca9424-eac2-414d-afc0-39e1c2570959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:42', 31, 0, '', '2019-08-12 18:29:42');
INSERT INTO `access_log` VALUES (66247, 'bdbed25a-309c-48a8-9c23-9d08be201c1f', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:42', 48, 0, '', '2019-08-12 18:29:42');
INSERT INTO `access_log` VALUES (66248, '98734bc0-94c7-4870-a5aa-51f8d5d57477', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:43', 28, 0, '', '2019-08-12 18:29:44');
INSERT INTO `access_log` VALUES (66249, '189319d4-32ff-4110-a686-b32194c615c5', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:43', 47, 0, '', '2019-08-12 18:29:44');
INSERT INTO `access_log` VALUES (66250, '44c9ae54-1a25-41cb-9e17-c6facf384bdc', 0, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:55', 65, 0, '', '2019-08-12 18:29:55');
INSERT INTO `access_log` VALUES (66251, '30c8bd4f-6bbc-4cea-b317-4d6706ba8276', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:55', 118, 0, '', '2019-08-12 18:29:55');
INSERT INTO `access_log` VALUES (66252, 'ad161b97-045b-4ac5-8792-4f6cc519aa00', 0, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:55', 37, 1002001012, '访问令牌已过期', '2019-08-12 18:29:55');
INSERT INTO `access_log` VALUES (66253, '72387a96-8052-414b-bbf2-ddb7639171c5', 0, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:55', 77, 0, '', '2019-08-12 18:29:55');
INSERT INTO `access_log` VALUES (66254, 'bc3809b9-8143-494c-b457-84000a49825f', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=4b6f1b70e8684cabb90e1d3e229ea9de', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:55', 352, 0, '', '2019-08-12 18:29:56');
INSERT INTO `access_log` VALUES (66255, '72fef487-5d33-418d-a9b9-161c81287588', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:56', 1268, 0, '', '2019-08-12 18:29:57');
INSERT INTO `access_log` VALUES (66256, 'd742ece2-44db-4743-993c-6d1ac36fa865', 197, 1, 'order-impl', '/order-api/users/cart/add', 'skuId=36&quantity=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:29:59', 135, 0, '', '2019-08-12 18:29:59');
INSERT INTO `access_log` VALUES (66257, '0cc89e88-d9f3-43f7-abc7-a22a6a52d6d2', 197, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:30:01', 77, 0, '', '2019-08-12 18:30:01');
INSERT INTO `access_log` VALUES (66258, '8a44619c-d02f-4bc8-9900-26aa823d1e79', 197, 1, 'order-impl', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:30:01', 179, 0, '', '2019-08-12 18:30:01');
INSERT INTO `access_log` VALUES (66259, '21b2fc5d-3f2b-4f9a-a464-835debaae84c', 197, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:30:02', 44, 0, '', '2019-08-12 18:30:02');
INSERT INTO `access_log` VALUES (66260, 'd462a358-270c-4aa8-90eb-80c3fda21bf1', 197, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:30:05', 49, 0, '', '2019-08-12 18:30:05');
INSERT INTO `access_log` VALUES (66261, '689f322c-ce95-4061-989a-941cc164a49f', 197, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:30:06', 64, 0, '', '2019-08-12 18:30:06');
INSERT INTO `access_log` VALUES (66262, '2b54f91f-8674-4b9d-8bd7-40372839cd2b', 197, 1, 'order-impl', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:30:06', 130, 0, '', '2019-08-12 18:30:06');
INSERT INTO `access_log` VALUES (66263, '36272f47-72d7-4d45-b7d3-ca14404ac9c1', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:30:22', 2097, 0, '', '2019-08-12 18:30:24');
INSERT INTO `access_log` VALUES (66264, '5a7207cf-0e20-48ab-bf36-12444d546848', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:31:37', 132, 0, '', '2019-08-12 18:31:37');
INSERT INTO `access_log` VALUES (66265, '5d9c3b0f-60b8-4382-83d2-d5f3b2b1cc9e', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:31:37', 194, 0, '', '2019-08-12 18:31:37');
INSERT INTO `access_log` VALUES (66266, '52a6b471-c529-4d51-99a6-b3bba75442d1', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:31:37', 82, 0, '', '2019-08-12 18:31:38');
INSERT INTO `access_log` VALUES (66267, '67a0e0a3-09a6-4f57-bbbf-3a8a1a97b91a', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:31:37', 85, 0, '', '2019-08-12 18:31:38');
INSERT INTO `access_log` VALUES (66268, 'ff52c56d-a8e8-4a02-86f2-4531140ae916', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:31:41', 63, 0, '', '2019-08-12 18:31:41');
INSERT INTO `access_log` VALUES (66269, 'b677da98-3114-408d-99a6-015a323264b6', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:31:41', 94, 0, '', '2019-08-12 18:31:41');
INSERT INTO `access_log` VALUES (66270, '8ab7adc8-0bb0-43ef-80c9-6806666c594e', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:31:52', 37, 0, '', '2019-08-12 18:31:52');
INSERT INTO `access_log` VALUES (66271, '57cae304-e37a-4cc3-976c-4f0dcdd41e48', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:31:52', 36, 0, '', '2019-08-12 18:31:52');
INSERT INTO `access_log` VALUES (66272, 'c76ee082-369d-4669-9ad5-e1164bdea727', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:31:55', 58, 0, '', '2019-08-12 18:31:55');
INSERT INTO `access_log` VALUES (66273, '5a9cb8fc-a238-4197-97b1-43364a00e229', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:31:57', 32, 0, '', '2019-08-12 18:31:57');
INSERT INTO `access_log` VALUES (66274, '73c77fd4-fba3-4b49-b725-e4fc82a7d712', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:31:58', 22, 0, '', '2019-08-12 18:31:58');
INSERT INTO `access_log` VALUES (66275, '04ce866b-3e2e-4920-ba83-f55ca8867e25', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:32:22', 22, 0, '', '2019-08-12 18:32:22');
INSERT INTO `access_log` VALUES (66276, '35a252b1-3ecc-4f8a-aeaa-e36ec581584a', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:32:22', 23, 0, '', '2019-08-12 18:32:22');
INSERT INTO `access_log` VALUES (66277, 'bd8059fc-2ab1-40bf-bcf4-e609b238e28d', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:32:24', 29, 0, '', '2019-08-12 18:32:24');
INSERT INTO `access_log` VALUES (66278, '6dba054b-9b75-4c1f-88c7-dfd8a6d22c16', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:32:24', 42, 0, '', '2019-08-12 18:32:24');
INSERT INTO `access_log` VALUES (66279, '6b3bf520-7be0-4d38-9d0a-8b816a40e38d', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:32:32', 108, 0, '', '2019-08-12 18:32:32');
INSERT INTO `access_log` VALUES (66280, 'f90e1f36-2f60-49b7-bda1-7145f378019b', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:32:36', 133, 0, '', '2019-08-12 18:32:36');
INSERT INTO `access_log` VALUES (66281, 'c33bfc79-6df9-4955-8788-95e92a308381', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:32:39', 82, 0, '', '2019-08-12 18:32:40');
INSERT INTO `access_log` VALUES (66282, '241d6023-aad3-49f1-bf9d-12017fd9753e', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:32:41', 37, 0, '', '2019-08-12 18:32:41');
INSERT INTO `access_log` VALUES (66283, 'ca613e5c-cf29-44c2-a41f-a7a51c5c358d', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:32:43', 29, 0, '', '2019-08-12 18:32:43');
INSERT INTO `access_log` VALUES (66284, 'b6289fa5-f169-459a-8e74-417159c41313', 197, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:32:44', 30, 0, '', '2019-08-12 18:32:44');
INSERT INTO `access_log` VALUES (66285, 'ad3638aa-3c9d-42a3-8252-32e62e423c06', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:32:47', 36, 0, '', '2019-08-12 18:32:47');
INSERT INTO `access_log` VALUES (66286, '82559f80-8c9e-4c2e-b64f-ff9dcf223761', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:32:57', 72, 0, '', '2019-08-12 18:32:57');
INSERT INTO `access_log` VALUES (66287, '57907a6d-bf88-49ee-85ba-bf985c9f597d', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:32:57', 75, 0, '', '2019-08-12 18:32:57');
INSERT INTO `access_log` VALUES (66288, 'c36ca86f-1029-4666-b7b7-023df05da16f', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:34:02', 140, 0, '', '2019-08-12 18:34:02');
INSERT INTO `access_log` VALUES (66289, '58b6f64e-9d05-43dc-a429-b234b4070eb2', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:34:35', 224, 0, '', '2019-08-12 18:34:36');
INSERT INTO `access_log` VALUES (66290, '6b00888e-2f4d-4d2a-8a5b-e3e7bbb9d6e6', 1, 2, 'order-impl', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:34:40', 479, 0, '', '2019-08-12 18:34:40');
INSERT INTO `access_log` VALUES (66291, 'e2fe3062-7f14-4448-9fd0-e4dd92e65bb4', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:35:17', 342, 0, '', '2019-08-12 18:35:18');
INSERT INTO `access_log` VALUES (66292, 'fb01f3fa-3f1a-47e0-9ff3-31f717b79d6a', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:35:32', 84, 0, '', '2019-08-12 18:35:32');
INSERT INTO `access_log` VALUES (66293, '2ba3c8ea-241a-4839-91a4-05d08d71daab', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:35:46', 114, 0, '', '2019-08-12 18:35:46');
INSERT INTO `access_log` VALUES (66294, '1c59b4cc-f6da-4694-876a-f58fe7a61571', 1, 2, 'order-impl', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:36:06', 173, 0, '', '2019-08-12 18:36:06');
INSERT INTO `access_log` VALUES (66295, 'f15639b0-03e7-45eb-a6f5-ffadc0ee97b8', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:36:10', 121, 0, '', '2019-08-12 18:36:10');
INSERT INTO `access_log` VALUES (66296, '27efbf06-d2af-4569-9d3d-5cb56b75618b', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:36:14', 125, 0, '', '2019-08-12 18:36:14');
INSERT INTO `access_log` VALUES (66297, 'c1804e54-7d5f-4ac6-8076-015cbca1d5c7', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:36:14', 404, 0, '', '2019-08-12 18:36:15');
INSERT INTO `access_log` VALUES (66298, '80070eb5-7330-4472-8393-1f2ddd0a6116', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:36:23', 90, 0, '', '2019-08-12 18:36:23');
INSERT INTO `access_log` VALUES (66299, '7e25fe5a-92e2-41ba-8af1-24215813395f', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:36:28', 72, 0, '', '2019-08-12 18:36:28');
INSERT INTO `access_log` VALUES (66300, '7dbb6439-93b8-44b1-9d18-099360ecac3f', 1, 2, 'order-impl', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:36:32', 132, 0, '', '2019-08-12 18:36:32');
INSERT INTO `access_log` VALUES (66301, '9795846d-0d84-43b8-84ef-e1740d42e01c', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:36:45', 105, 0, '', '2019-08-12 18:36:45');
INSERT INTO `access_log` VALUES (66302, '6ec9f49c-290a-48df-aaf8-0b741d1e1169', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:36:51', 89, 0, '', '2019-08-12 18:36:51');
INSERT INTO `access_log` VALUES (66303, '2ddbe33e-3342-4c70-82a5-0d1e9806074f', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:36:55', 84, 0, '', '2019-08-12 18:36:56');
INSERT INTO `access_log` VALUES (66304, '826a0b2e-9717-4635-93c5-ddb6cea706ac', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:37:00', 122, 0, '', '2019-08-12 18:37:00');
INSERT INTO `access_log` VALUES (66305, '03c055cf-2097-4459-9abd-61a072848264', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:41:20', 145, 0, '', '2019-08-12 18:41:20');
INSERT INTO `access_log` VALUES (66306, 'fa108f81-6f8e-4b8a-a301-1f6b4ba0d04e', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:41:20', 162, 0, '', '2019-08-12 18:41:20');
INSERT INTO `access_log` VALUES (66307, '46ae1156-990c-463b-9346-409b8b01cbba', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:41:24', 172, 0, '', '2019-08-12 18:41:25');
INSERT INTO `access_log` VALUES (66308, '29a2ae17-f9f3-43d8-b8a8-a77848d51610', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:41:24', 197, 0, '', '2019-08-12 18:41:25');
INSERT INTO `access_log` VALUES (66309, 'f8008861-8b04-47c1-90a3-dfcda27da056', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:41:40', 59, 0, '', '2019-08-12 18:41:40');
INSERT INTO `access_log` VALUES (66310, '0338e87b-8284-4404-a527-a91e28359b61', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:41:40', 212, 0, '', '2019-08-12 18:41:40');
INSERT INTO `access_log` VALUES (66311, 'c3e4b082-059f-40d3-818a-dc377d9fa47e', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:42:06', 130, 0, '', '2019-08-12 18:42:06');
INSERT INTO `access_log` VALUES (66312, '719a4078-3407-4aba-b5de-3e6aebae64cd', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:42:10', 78, 0, '', '2019-08-12 18:42:10');
INSERT INTO `access_log` VALUES (66313, '4e72b963-bcca-4a04-82b6-9ef8e3d28522', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:43:09', 133, 0, '', '2019-08-12 18:43:09');
INSERT INTO `access_log` VALUES (66314, '76324273-e2a5-4e2e-a4c2-e1c515a82068', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:43:21', 309, 0, '', '2019-08-12 18:43:21');
INSERT INTO `access_log` VALUES (66315, '72a61835-212c-4b03-8c4b-7e6ad84ab3c0', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:43:22', 110, 0, '', '2019-08-12 18:43:22');
INSERT INTO `access_log` VALUES (66316, '7bd15c40-af2a-4f19-b1fa-a42c4b2718c9', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:43:24', 28, 0, '', '2019-08-12 18:43:24');
INSERT INTO `access_log` VALUES (66317, '8da60ad6-16f7-4fd4-879c-3a273438f539', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:43:26', 347, 0, '', '2019-08-12 18:43:26');
INSERT INTO `access_log` VALUES (66318, 'bd7d38d4-73b3-4cb9-b9a6-7816d5d59bcb', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:43:29', 277, 0, '', '2019-08-12 18:43:29');
INSERT INTO `access_log` VALUES (66319, '4113fc40-7135-4359-8017-60b9c6fac41b', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:43:39', 26, 0, '', '2019-08-12 18:43:39');
INSERT INTO `access_log` VALUES (66320, '4c8a52b6-b5da-421a-a146-72e3cd8b0f2c', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:43:39', 213, 0, '', '2019-08-12 18:43:39');
INSERT INTO `access_log` VALUES (66321, '84d444f6-b0e5-49f7-b7f4-1d43ed19d83a', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:43:50', 23, 0, '', '2019-08-12 18:43:50');
INSERT INTO `access_log` VALUES (66322, 'fa147855-d99b-4d01-8e55-5aafe91f01d4', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:43:51', 42, 0, '', '2019-08-12 18:43:51');
INSERT INTO `access_log` VALUES (66323, '3f9b840b-88bb-425b-9ef0-1e39299f7095', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:43:55', 352, 0, '', '2019-08-12 18:43:55');
INSERT INTO `access_log` VALUES (66324, '363792b2-e156-4e9e-8f59-245ca2601e37', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:43:55', 354, 0, '', '2019-08-12 18:43:55');
INSERT INTO `access_log` VALUES (66325, '4d40560f-e644-4f9c-8a1f-6143cdad39b4', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:44:14', 745, 0, '', '2019-08-12 18:44:15');
INSERT INTO `access_log` VALUES (66326, 'fdde0a78-0b97-4dd9-8ad0-be73f94ce46a', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:44:14', 794, 0, '', '2019-08-12 18:44:15');
INSERT INTO `access_log` VALUES (66327, 'b781b130-e57c-47f6-853e-dc0ff8aa0b95', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:44:15', 53, 0, '', '2019-08-12 18:44:15');
INSERT INTO `access_log` VALUES (66328, '06f5da16-0cb2-419c-9912-15950e2ab4ce', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:44:15', 65, 0, '', '2019-08-12 18:44:15');
INSERT INTO `access_log` VALUES (66329, '3ebc035f-3e0a-478c-a166-c75fe0013c60', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:44:18', 190, 0, '', '2019-08-12 18:44:18');
INSERT INTO `access_log` VALUES (66330, 'ce160ecf-37ac-495e-948b-dd61292ade7d', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:44:18', 205, 0, '', '2019-08-12 18:44:18');
INSERT INTO `access_log` VALUES (66331, 'defe380a-3700-4352-99dd-9ab0dddefe05', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:44:21', 554, 0, '', '2019-08-12 18:44:22');
INSERT INTO `access_log` VALUES (66332, '84b2f5e1-8048-4d6b-99c5-c3120474d885', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:44:22', 42, 0, '', '2019-08-12 18:44:22');
INSERT INTO `access_log` VALUES (66333, 'f4fefa13-f96f-4e3a-8d3f-5e8588e4ec37', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:44:24', 205, 0, '', '2019-08-12 18:44:24');
INSERT INTO `access_log` VALUES (66334, '5871ff14-3bca-450e-bad7-f8133eab1ef6', 197, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:44:27', 41, 0, '', '2019-08-12 18:44:27');
INSERT INTO `access_log` VALUES (66335, '9b1ad2b0-3e68-415c-8d51-2e30a0354eed', 197, 1, 'order-impl', '/order-api/users/cart/confirm_create_order', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:44:27', 1179, 0, '', '2019-08-12 18:44:28');
INSERT INTO `access_log` VALUES (66336, 'f26e3eff-7210-4f91-978d-2ea201fb07ab', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:45:52', 230, 0, '', '2019-08-12 18:45:52');
INSERT INTO `access_log` VALUES (66337, 'e6c56b22-5214-4184-834e-0ab8dbb5b51e', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:45:52', 30, 0, '', '2019-08-12 18:45:52');
INSERT INTO `access_log` VALUES (66338, 'b4bae17d-1a73-4af2-94bd-c6ee2833a499', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:45:52', 34, 0, '', '2019-08-12 18:45:53');
INSERT INTO `access_log` VALUES (66339, '61fcbfd8-59b6-43ab-bd58-74cf11de531a', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 18:45:54', 34, 0, '', '2019-08-12 18:45:54');
INSERT INTO `access_log` VALUES (66340, '98f6d072-d7e7-4290-a488-95c0e9624927', 0, 2, 'admin-application', '/admin-api/admins/data_dict/delete', 'id=100', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '0:0:0:0:0:0:0:1', '2019-08-12 18:46:15', 1, 1002001015, '账号未登陆', '2019-08-12 18:46:15');
INSERT INTO `access_log` VALUES (66341, 'd3000f70-1c44-45a2-9ba8-b41fbac1f934', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:47:20', 139, 0, '', '2019-08-12 18:47:20');
INSERT INTO `access_log` VALUES (66342, '2f2aeb53-9da8-48c3-80fc-5d708bb3994a', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:47:20', 164, 0, '', '2019-08-12 18:47:20');
INSERT INTO `access_log` VALUES (66343, 'c55a0e24-917c-4803-b18f-ef93ba665646', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:48:21', 302, 0, '', '2019-08-12 18:48:21');
INSERT INTO `access_log` VALUES (66344, '72fb54ac-35ce-4b2f-ab6a-f9dccf1f989a', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:48:35', 54, 0, '', '2019-08-12 18:48:35');
INSERT INTO `access_log` VALUES (66345, '6bed9ead-5852-4325-a1ca-e9ba86cf6817', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=12312', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:48:47', 935, 0, '', '2019-08-12 18:48:48');
INSERT INTO `access_log` VALUES (66346, 'f2d6e715-dfb7-41c6-aa0b-8bcce3704f09', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:48:48', 229, 0, '', '2019-08-12 18:48:48');
INSERT INTO `access_log` VALUES (66347, '56587226-578c-4492-be5f-14ae4f41e495', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=3&name=222', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:48:53', 642, 0, '', '2019-08-12 18:48:54');
INSERT INTO `access_log` VALUES (66348, '69671e8a-9459-4c78-9357-385e6cdbc723', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:48:54', 64, 0, '', '2019-08-12 18:48:54');
INSERT INTO `access_log` VALUES (66349, '216d559d-828c-4952-9396-06f0f154375f', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=<script>alert(1111)</script>&sellPoint=123&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/a7c70291-3d6e-46c2-90b8-f2b43f134b2b&skuStr=[{\"attrs\":[47,48],\"price\":1200,\"quantity\":2}]&description=<p>123123321</p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/45bae085-0f13-42c8-a048-296ecc2dba2c\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:48:58', 3832, 2001001000, '服务端发生异常', '2019-08-12 18:49:02');
INSERT INTO `access_log` VALUES (66350, '5a2ebe94-e722-4926-a176-ff5eaf627cd8', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=<script>alert(1111)</script>&sellPoint=123&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/a7c70291-3d6e-46c2-90b8-f2b43f134b2b&skuStr=[{\"attrs\":[47,48],\"price\":1200,\"quantity\":2}]&description=<p>123123321</p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/45bae085-0f13-42c8-a048-296ecc2dba2c\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:49:03', 3702, 2001001000, '服务端发生异常', '2019-08-12 18:49:06');
INSERT INTO `access_log` VALUES (66351, '23aa4fba-8217-44d0-82a8-e1a80de58572', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=<script>alert(1111)</script>&sellPoint=123&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/a7c70291-3d6e-46c2-90b8-f2b43f134b2b&skuStr=[{\"attrs\":[47,48],\"price\":1200,\"quantity\":2}]&description=<p>123123321</p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/45bae085-0f13-42c8-a048-296ecc2dba2c\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:49:18', 4548, 2001001000, '服务端发生异常', '2019-08-12 18:49:23');
INSERT INTO `access_log` VALUES (66352, '9d181f32-72b2-4a33-8b67-e984397764ec', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=<script>alert(1111)</script>&sellPoint=123&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/a7c70291-3d6e-46c2-90b8-f2b43f134b2b&skuStr=[{\"attrs\":[47,48],\"price\":1200,\"quantity\":2}]&description=<p>123123321</p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/45bae085-0f13-42c8-a048-296ecc2dba2c\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:50:48', 3541, 2001001000, '服务端发生异常', '2019-08-12 18:50:52');
INSERT INTO `access_log` VALUES (66353, '59.74.15656088184728671', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.182.78', '2019-08-12 19:20:18', 11, 0, '', '2019-08-12 19:20:18');
INSERT INTO `access_log` VALUES (66354, '59.75.15656088184738665', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.182.78', '2019-08-12 19:20:18', 22, 2001001000, '服务端发生异常', '2019-08-12 19:20:18');
INSERT INTO `access_log` VALUES (66355, '64.81.15656088214168985', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.182.78', '2019-08-12 19:20:21', 14, 0, '', '2019-08-12 19:20:21');
INSERT INTO `access_log` VALUES (66356, '64.85.15656088215349017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.182.78', '2019-08-12 19:20:22', 4, 0, '', '2019-08-12 19:20:22');
INSERT INTO `access_log` VALUES (66357, '64.76.15656088271228987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.182.78', '2019-08-12 19:20:27', 2, 0, '', '2019-08-12 19:20:27');
INSERT INTO `access_log` VALUES (66358, '64.83.15656088272428977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.182.78', '2019-08-12 19:20:27', 2, 0, '', '2019-08-12 19:20:27');
INSERT INTO `access_log` VALUES (66359, '59.79.15656088284018661', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.182.78', '2019-08-12 19:20:28', 3, 0, '', '2019-08-12 19:20:28');
INSERT INTO `access_log` VALUES (66360, '59.80.15656088284018627', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '182.139.182.78', '2019-08-12 19:20:28', 20, 2001001000, '服务端发生异常', '2019-08-12 19:20:28');
INSERT INTO `access_log` VALUES (66361, '59.74.15656094964378681', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.116.11.31', '2019-08-12 19:31:36', 3, 0, '', '2019-08-12 19:31:36');
INSERT INTO `access_log` VALUES (66362, '59.75.15656094964388675', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.116.11.31', '2019-08-12 19:31:36', 13, 2001001000, '服务端发生异常', '2019-08-12 19:31:36');
INSERT INTO `access_log` VALUES (66363, '64.82.15656094986359007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.116.11.31', '2019-08-12 19:31:39', 3, 0, '', '2019-08-12 19:31:39');
INSERT INTO `access_log` VALUES (66364, '64.81.15656094987668995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.116.11.31', '2019-08-12 19:31:39', 2, 0, '', '2019-08-12 19:31:39');
INSERT INTO `access_log` VALUES (66365, '59.71.15656095002648665', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.116.11.31', '2019-08-12 19:31:40', 2, 0, '', '2019-08-12 19:31:40');
INSERT INTO `access_log` VALUES (66366, '59.79.15656095002658671', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.116.11.31', '2019-08-12 19:31:40', 23, 2001001000, '服务端发生异常', '2019-08-12 19:31:40');
INSERT INTO `access_log` VALUES (66367, '65.53.15656101029871505', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.144.96.100', '2019-08-12 19:41:43', 0, 1002001015, '账号未登陆', '2019-08-12 19:41:43');
INSERT INTO `access_log` VALUES (66368, '65.49.15656101029861535', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.144.96.100', '2019-08-12 19:41:43', 0, 1002001015, '账号未登陆', '2019-08-12 19:41:43');
INSERT INTO `access_log` VALUES (66369, '65.47.15656101029871501', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.144.96.100', '2019-08-12 19:41:43', 0, 1002001015, '账号未登陆', '2019-08-12 19:41:43');
INSERT INTO `access_log` VALUES (66370, '65.46.15656101056831581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.144.96.100', '2019-08-12 19:41:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 19:41:46');
INSERT INTO `access_log` VALUES (66371, '65.50.15656101121571541', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '61.144.96.100', '2019-08-12 19:41:52', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 19:41:52');
INSERT INTO `access_log` VALUES (66372, '59.77.15656132985408705', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-12 20:34:59', 12, 0, '', '2019-08-12 20:34:59');
INSERT INTO `access_log` VALUES (66373, '59.72.15656132985358715', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.106.169.144', '2019-08-12 20:34:59', 21, 2001001000, '服务端发生异常', '2019-08-12 20:34:59');
INSERT INTO `access_log` VALUES (66374, '59.74.15656133062798733', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.34.152.61', '2019-08-12 20:35:06', 4, 0, '', '2019-08-12 20:35:06');
INSERT INTO `access_log` VALUES (66375, '59.75.15656133062798727', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.34.152.61', '2019-08-12 20:35:06', 14, 2001001000, '服务端发生异常', '2019-08-12 20:35:06');
INSERT INTO `access_log` VALUES (66376, '65.45.15656133129431583', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.34.152.61', '2019-08-12 20:35:13', 0, 1002001015, '账号未登陆', '2019-08-12 20:35:13');
INSERT INTO `access_log` VALUES (66377, '65.47.15656133129431545', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.34.152.61', '2019-08-12 20:35:13', 0, 1002001015, '账号未登陆', '2019-08-12 20:35:13');
INSERT INTO `access_log` VALUES (66378, '65.53.15656133129441549', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.34.152.61', '2019-08-12 20:35:13', 0, 1002001015, '账号未登陆', '2019-08-12 20:35:13');
INSERT INTO `access_log` VALUES (66379, '65.49.15656133216171579', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.34.152.61', '2019-08-12 20:35:22', 87, 0, '', '2019-08-12 20:35:22');
INSERT INTO `access_log` VALUES (66380, '65.46.15656133219631625', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.34.152.61', '2019-08-12 20:35:22', 13, 0, '', '2019-08-12 20:35:22');
INSERT INTO `access_log` VALUES (66381, '65.50.15656133219711585', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.34.152.61', '2019-08-12 20:35:22', 12, 2001001000, '服务端发生异常', '2019-08-12 20:35:22');
INSERT INTO `access_log` VALUES (66382, '65.52.15656133219731623', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.34.152.61', '2019-08-12 20:35:22', 12, 0, '', '2019-08-12 20:35:22');
INSERT INTO `access_log` VALUES (66383, '65.54.15656133382911485', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.34.152.61', '2019-08-12 20:35:38', 9, 0, '', '2019-08-12 20:35:38');
INSERT INTO `access_log` VALUES (66384, '65.3607.15656133382943375', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.34.152.61', '2019-08-12 20:35:38', 10, 2001001000, '服务端发生异常', '2019-08-12 20:35:38');
INSERT INTO `access_log` VALUES (66385, '65.45.15656133383001585', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.34.152.61', '2019-08-12 20:35:38', 9, 0, '', '2019-08-12 20:35:38');
INSERT INTO `access_log` VALUES (66386, '59.77.15656143062428719', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.85.8.251', '2019-08-12 20:51:46', 3, 0, '', '2019-08-12 20:51:46');
INSERT INTO `access_log` VALUES (66387, '59.73.15656143062438733', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.85.8.251', '2019-08-12 20:51:46', 19, 2001001000, '服务端发生异常', '2019-08-12 20:51:46');
INSERT INTO `access_log` VALUES (66388, '65.51.15656143180571679', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.85.8.251', '2019-08-12 20:51:58', 0, 1002001015, '账号未登陆', '2019-08-12 20:51:58');
INSERT INTO `access_log` VALUES (66389, '65.54.15656143180631499', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.85.8.251', '2019-08-12 20:51:58', 1, 1002001015, '账号未登陆', '2019-08-12 20:51:58');
INSERT INTO `access_log` VALUES (66390, '65.3607.15656143180643389', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '222.85.8.251', '2019-08-12 20:51:58', 0, 1002001015, '账号未登陆', '2019-08-12 20:51:58');
INSERT INTO `access_log` VALUES (66391, '59.71.15656231591408849', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.60.143', '2019-08-12 23:19:19', 31, 2001001000, '服务端发生异常', '2019-08-12 23:19:19');
INSERT INTO `access_log` VALUES (66392, '59.71.15656231591408849', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.60.143', '2019-08-12 23:19:19', 31, 2001001000, '服务端发生异常', '2019-08-12 23:19:20');
INSERT INTO `access_log` VALUES (66393, '59.75.15656231591408859', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.60.143', '2019-08-12 23:19:19', 1809, 0, '', '2019-08-12 23:19:21');
INSERT INTO `access_log` VALUES (66394, '64.76.15656231740499179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.60.143', '2019-08-12 23:19:34', 12, 0, '', '2019-08-12 23:19:34');
INSERT INTO `access_log` VALUES (66395, '64.83.15656231742419169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.60.143', '2019-08-12 23:19:34', 3, 0, '', '2019-08-12 23:19:34');
INSERT INTO `access_log` VALUES (66396, '59.76.15656231908438841', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Mobile Safari/537.36', '115.171.60.143', '2019-08-12 23:19:51', 2, 0, '', '2019-08-12 23:19:51');
INSERT INTO `access_log` VALUES (66397, '59.78.15656231908448857', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Mobile Safari/537.36', '115.171.60.143', '2019-08-12 23:19:51', 16, 2001001000, '服务端发生异常', '2019-08-12 23:19:51');
INSERT INTO `access_log` VALUES (66398, '64.80.15656231938759183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Mobile Safari/537.36', '115.171.60.143', '2019-08-12 23:19:54', 2, 0, '', '2019-08-12 23:19:54');
INSERT INTO `access_log` VALUES (66399, '64.78.15656231940089183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Mobile Safari/537.36', '115.171.60.143', '2019-08-12 23:19:54', 2, 0, '', '2019-08-12 23:19:54');
INSERT INTO `access_log` VALUES (66400, '64.77.15656231987309169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Mobile Safari/537.36', '115.171.60.143', '2019-08-12 23:19:59', 2, 0, '', '2019-08-12 23:19:59');
INSERT INTO `access_log` VALUES (66401, '64.82.15656232002099191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Mobile Safari/537.36', '115.171.60.143', '2019-08-12 23:20:00', 3, 0, '', '2019-08-12 23:20:00');
INSERT INTO `access_log` VALUES (66402, '64.81.15656232019619179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Mobile Safari/537.36', '115.171.60.143', '2019-08-12 23:20:02', 2, 0, '', '2019-08-12 23:20:02');
INSERT INTO `access_log` VALUES (66403, '64.85.15656232026959211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Mobile Safari/537.36', '115.171.60.143', '2019-08-12 23:20:03', 2, 0, '', '2019-08-12 23:20:03');
INSERT INTO `access_log` VALUES (66404, '64.83.15656232112689171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Mobile Safari/537.36', '115.171.60.143', '2019-08-12 23:20:11', 2, 0, '', '2019-08-12 23:20:11');
INSERT INTO `access_log` VALUES (66405, '64.79.15656232113759183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Mobile Safari/537.36', '115.171.60.143', '2019-08-12 23:20:11', 2, 0, '', '2019-08-12 23:20:11');
INSERT INTO `access_log` VALUES (66406, '66.56.15656232443206473', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18511265421&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Mobile Safari/537.36', '115.171.60.143', '2019-08-12 23:20:44', 17, 1001003000, '验证码不存在', '2019-08-12 23:20:44');
INSERT INTO `access_log` VALUES (66407, '66.53.15656232489846455', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18511265421', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Mobile Safari/537.36', '115.171.60.143', '2019-08-12 23:20:49', 114, 0, '', '2019-08-12 23:20:49');
INSERT INTO `access_log` VALUES (66408, '66.54.15656232614496471', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18511286241', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Mobile Safari/537.36', '115.171.60.143', '2019-08-12 23:21:01', 64, 0, '', '2019-08-12 23:21:02');
INSERT INTO `access_log` VALUES (66409, '65.54.15656233280481619', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.60.143', '2019-08-12 23:22:08', 0, 1002001015, '账号未登陆', '2019-08-12 23:22:08');
INSERT INTO `access_log` VALUES (66410, '65.51.15656233280481799', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.60.143', '2019-08-12 23:22:08', 0, 1002001015, '账号未登陆', '2019-08-12 23:22:08');
INSERT INTO `access_log` VALUES (66411, '65.45.15656233280691719', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.60.143', '2019-08-12 23:22:08', 0, 1002001015, '账号未登陆', '2019-08-12 23:22:08');
INSERT INTO `access_log` VALUES (66412, '65.47.15656233302171681', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.60.143', '2019-08-12 23:22:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 23:22:10');
INSERT INTO `access_log` VALUES (66413, '65.50.15656233450291721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.60.143', '2019-08-12 23:22:25', 89, 0, '', '2019-08-12 23:22:25');
INSERT INTO `access_log` VALUES (66414, '65.3607.15656233453593511', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.60.143', '2019-08-12 23:22:25', 16, 0, '', '2019-08-12 23:22:25');
INSERT INTO `access_log` VALUES (66415, '65.52.15656233453661759', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.60.143', '2019-08-12 23:22:25', 12, 0, '', '2019-08-12 23:22:25');
INSERT INTO `access_log` VALUES (66416, '65.46.15656233453661761', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '115.171.60.143', '2019-08-12 23:22:25', 11, 2001001000, '服务端发生异常', '2019-08-12 23:22:25');
INSERT INTO `access_log` VALUES (66417, '6b3c2c65-ac8c-4b26-b9eb-568c83ade4b9', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:24:48', 653, 0, '', '2019-08-12 23:24:48');
INSERT INTO `access_log` VALUES (66418, '64f90408-581d-4441-9053-d6413fab651f', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:24:48', 794, 0, '', '2019-08-12 23:24:48');
INSERT INTO `access_log` VALUES (66419, '0b7f2d90-12a8-403d-85d1-8a7016e7e920', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:02', 42, 0, '', '2019-08-12 23:25:02');
INSERT INTO `access_log` VALUES (66420, 'ecaa7406-c444-403e-8a2a-451d819c0470', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:02', 71, 0, '', '2019-08-12 23:25:02');
INSERT INTO `access_log` VALUES (66421, 'c80976f7-93a9-446c-9682-c58915213954', 0, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:07', 248, 0, '', '2019-08-12 23:25:07');
INSERT INTO `access_log` VALUES (66422, '88ab3228-f8f0-4b3d-8940-ee33abd59436', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:07', 291, 0, '', '2019-08-12 23:25:07');
INSERT INTO `access_log` VALUES (66423, 'c459a978-c614-4444-ac22-060f25a961c7', 0, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:08', 232, 0, '', '2019-08-12 23:25:08');
INSERT INTO `access_log` VALUES (66424, '39588844-8af2-4222-a4e7-b9bd1e6a08c9', 0, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:08', 219, 1002001012, '访问令牌已过期', '2019-08-12 23:25:08');
INSERT INTO `access_log` VALUES (66425, 'd9ea9d59-7239-4f63-977a-acf4c98ddc7f', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=4b6f1b70e8684cabb90e1d3e229ea9de', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:08', 306, 0, '', '2019-08-12 23:25:08');
INSERT INTO `access_log` VALUES (66426, '6ae2d44e-3fbc-401c-a26c-37174fa86974', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:09', 220, 0, '', '2019-08-12 23:25:09');
INSERT INTO `access_log` VALUES (66427, '1bdf3626-e693-4b14-ab78-9cea5da8e6a5', 197, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:15', 108, 0, '', '2019-08-12 23:25:15');
INSERT INTO `access_log` VALUES (66428, 'dad83e27-5da8-4b2e-b013-2ca3e92e5e8d', 197, 1, 'order-impl', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:15', 219, 0, '', '2019-08-12 23:25:15');
INSERT INTO `access_log` VALUES (66429, '1d77b3eb-efa3-455b-90c7-a3a3624ef47e', 197, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:16', 34, 0, '', '2019-08-12 23:25:16');
INSERT INTO `access_log` VALUES (66430, 'f9b84949-32c1-441e-a2aa-2c24642fc09a', 197, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:18', 32, 0, '', '2019-08-12 23:25:18');
INSERT INTO `access_log` VALUES (66431, 'a77e887f-ba27-4215-80a5-dbf016ed323e', 197, 1, 'order-impl', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:18', 93, 0, '', '2019-08-12 23:25:18');
INSERT INTO `access_log` VALUES (66432, '25626ba7-c687-4542-a3d3-90fd50e6b8ad', 197, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:19', 33, 0, '', '2019-08-12 23:25:19');
INSERT INTO `access_log` VALUES (66433, '3f5d7891-4c69-4e6f-b7fd-0eaa6519ce8e', 197, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:19', 87, 0, '', '2019-08-12 23:25:19');
INSERT INTO `access_log` VALUES (66434, '51e459f7-6a6d-4304-9335-57a12bb1a3c5', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:19', 30, 0, '', '2019-08-12 23:25:19');
INSERT INTO `access_log` VALUES (66435, '95e17ef8-6a95-4c7b-92db-b176b5a07977', 197, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:19', 47, 0, '', '2019-08-12 23:25:19');
INSERT INTO `access_log` VALUES (66436, 'a8b1091e-c0f5-4e95-b681-ac1a7ac68eb8', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:19', 32, 0, '', '2019-08-12 23:25:19');
INSERT INTO `access_log` VALUES (66437, '9336b71d-14e0-4c80-9027-d4f68baefe33', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:19', 53, 0, '', '2019-08-12 23:25:19');
INSERT INTO `access_log` VALUES (66438, 'c0883c92-d70c-43c5-8e5d-bf4ccbee2402', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:21', 36, 0, '', '2019-08-12 23:25:21');
INSERT INTO `access_log` VALUES (66439, 'd9f6d62c-314b-4dec-a91a-eeb98fbe2672', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:21', 28, 0, '', '2019-08-12 23:25:21');
INSERT INTO `access_log` VALUES (66440, '18920424-57c4-4c55-893e-029af20b3d86', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:22', 133, 0, '', '2019-08-12 23:25:22');
INSERT INTO `access_log` VALUES (66441, '844bff0c-bbdc-4b9c-90cd-dcdb3238e4cb', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:24', 38, 0, '', '2019-08-12 23:25:24');
INSERT INTO `access_log` VALUES (66442, '3d740701-a073-4640-9c57-03032eabcb8e', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:24', 31, 0, '', '2019-08-12 23:25:24');
INSERT INTO `access_log` VALUES (66443, '1f0ae002-fb27-48d0-a76c-414440521578', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:25:25', 84, 0, '', '2019-08-12 23:25:25');
INSERT INTO `access_log` VALUES (66444, '31713606-0ba7-417e-b04b-458a79dbe96d', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:20', 126, 1002001012, '访问令牌已过期', '2019-08-12 23:26:20');
INSERT INTO `access_log` VALUES (66445, 'bb37b48d-66b6-483e-9805-eb1910b8ea66', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:20', 126, 1002001012, '访问令牌已过期', '2019-08-12 23:26:20');
INSERT INTO `access_log` VALUES (66446, 'c17fda6b-a182-471c-a7bf-533270ceef0f', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:20', 126, 1002001012, '访问令牌已过期', '2019-08-12 23:26:20');
INSERT INTO `access_log` VALUES (66447, 'a9f365ac-c7cb-4a88-8733-fc3657c32b93', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:26', 264, 0, '', '2019-08-12 23:26:27');
INSERT INTO `access_log` VALUES (66448, 'bbde7807-f42b-49d1-a3a9-fef9a38750af', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:27', 135, 0, '', '2019-08-12 23:26:27');
INSERT INTO `access_log` VALUES (66449, '8fedfacd-d45d-405d-8d6f-326932dff54a', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:27', 142, 0, '', '2019-08-12 23:26:27');
INSERT INTO `access_log` VALUES (66450, 'b54591bd-6e22-4f2c-8e98-bf3f3f2eaa19', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:27', 163, 0, '', '2019-08-12 23:26:27');
INSERT INTO `access_log` VALUES (66451, 'd096826f-2ee4-4257-8d87-6a677158721a', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:31', 410, 0, '', '2019-08-12 23:26:31');
INSERT INTO `access_log` VALUES (66452, '9bcc92f2-8d2a-4b37-97f6-dbe7d14f64db', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:33', 185, 0, '', '2019-08-12 23:26:33');
INSERT INTO `access_log` VALUES (66453, 'e0cda413-a0f7-4814-961e-5dc15dc8b844', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:37', 131, 0, '', '2019-08-12 23:26:37');
INSERT INTO `access_log` VALUES (66454, 'ebeabfa5-03f9-4346-9bf6-a7300008ffe6', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:37', 167, 0, '', '2019-08-12 23:26:37');
INSERT INTO `access_log` VALUES (66455, '45f23ad0-befe-4c6d-90e3-f2792bb1172f', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:40', 63, 0, '', '2019-08-12 23:26:40');
INSERT INTO `access_log` VALUES (66456, '7504db83-7756-499e-824c-35dd0cdfb290', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:40', 111, 0, '', '2019-08-12 23:26:40');
INSERT INTO `access_log` VALUES (66457, 'aaf65f5c-3f0b-41a0-b35a-d51395bb4936', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:42', 62, 0, '', '2019-08-12 23:26:42');
INSERT INTO `access_log` VALUES (66458, '305b63a0-a50c-4924-9f5d-969f728f8045', 1, 2, 'product-application', '/product-api/admins/brand/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:26:46', 1181, 0, '', '2019-08-12 23:26:47');
INSERT INTO `access_log` VALUES (66459, '82d92b71-bab1-4206-8a8c-22c7391c64dc', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:28:05', 148, 0, '', '2019-08-12 23:28:06');
INSERT INTO `access_log` VALUES (66460, '6b11db16-3866-4eba-9a18-a8436aa85782', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:28:08', 84, 0, '', '2019-08-12 23:28:08');
INSERT INTO `access_log` VALUES (66461, '97b6db7b-ad7b-46b3-b74a-371ea352392d', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:28:08', 281, 0, '', '2019-08-12 23:28:08');
INSERT INTO `access_log` VALUES (66462, '255d3a76-2cf4-4fa3-a893-b88d90a5b13c', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:28:09', 134, 0, '', '2019-08-12 23:28:09');
INSERT INTO `access_log` VALUES (66463, '27c1a175-aa89-4eee-87b5-d06fe36954de', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:28:10', 66, 0, '', '2019-08-12 23:28:10');
INSERT INTO `access_log` VALUES (66464, '2310df1d-af44-45d0-b6b5-bab578d2be4c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:28:11', 94, 0, '', '2019-08-12 23:28:11');
INSERT INTO `access_log` VALUES (66465, '09c68b6f-73aa-4f93-89ed-194e1b866db5', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:28:13', 142, 0, '', '2019-08-12 23:28:13');
INSERT INTO `access_log` VALUES (66466, '6120b54b-b53c-4fef-b335-1561061b62ff', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:28:16', 42, 0, '', '2019-08-12 23:28:16');
INSERT INTO `access_log` VALUES (66467, 'cc13ebcb-199c-4939-9e81-01dfc895562e', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:28:16', 123, 0, '', '2019-08-12 23:28:16');
INSERT INTO `access_log` VALUES (66468, '59.74.15656238044148875', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.89.236.239', '2019-08-12 23:30:04', 4, 0, '', '2019-08-12 23:30:04');
INSERT INTO `access_log` VALUES (66469, '59.71.15656238044138857', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.89.236.239', '2019-08-12 23:30:04', 13, 2001001000, '服务端发生异常', '2019-08-12 23:30:04');
INSERT INTO `access_log` VALUES (66470, '12567364-3eac-4415-8aa6-3d97868766e3', 1, 2, 'order-impl', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:36:18', 359, 0, '', '2019-08-12 23:36:18');
INSERT INTO `access_log` VALUES (66471, '8e5dafcb-1e5d-440e-bddf-8a7af42d14ac', 1, 2, 'order-impl', '/order-api/admins/order_return/list', 'index=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:36:31', 191, 0, '', '2019-08-12 23:36:31');
INSERT INTO `access_log` VALUES (66472, 'b66898b5-0d67-47db-9c06-532093a3b9cc', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:36:39', 99, 0, '', '2019-08-12 23:36:39');
INSERT INTO `access_log` VALUES (66473, '6cd37fe1-0cf1-4c3d-874f-5c9196fb929d', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:36:43', 132, 0, '', '2019-08-12 23:36:44');
INSERT INTO `access_log` VALUES (66474, 'f5acfb29-7e2c-4ed2-b02a-7290a4e2b4b8', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:36:46', 203, 0, '', '2019-08-12 23:36:47');
INSERT INTO `access_log` VALUES (66475, 'e484c2b8-6a47-4c57-9b0b-5b7974694e1a', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:36:50', 306, 0, '', '2019-08-12 23:36:50');
INSERT INTO `access_log` VALUES (66476, 'ee645800-7ddc-4d0d-a9e3-feca58329a24', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:36:52', 72, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-12 23:36:52');
INSERT INTO `access_log` VALUES (66477, 'e4e1c3be-bbab-489b-8cf8-8ec828a981c1', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:37:00', 70, 0, '', '2019-08-12 23:37:00');
INSERT INTO `access_log` VALUES (66478, '4d523412-90f3-46e6-a3b9-34f7f14d5486', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:37:00', 167, 0, '', '2019-08-12 23:37:00');
INSERT INTO `access_log` VALUES (66479, '984fc005-be57-4252-a379-339146dfc393', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:37:02', 123, 0, '', '2019-08-12 23:37:02');
INSERT INTO `access_log` VALUES (66480, 'e6632980-50c9-45aa-b15c-43368f28c34a', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:37:02', 176, 0, '', '2019-08-12 23:37:02');
INSERT INTO `access_log` VALUES (66481, '45b318e0-e488-4a7a-a65c-1afd998f5086', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:37:22', 100, 0, '', '2019-08-12 23:37:22');
INSERT INTO `access_log` VALUES (66482, '59.71.15656242457178863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:37:26', 13, 2001001000, '服务端发生异常', '2019-08-12 23:37:26');
INSERT INTO `access_log` VALUES (66483, '59.75.15656242457178873', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:37:26', 278, 0, '', '2019-08-12 23:37:26');
INSERT INTO `access_log` VALUES (66484, '5efb16d1-d764-4058-aead-9409387fa71e', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:37:27', 464, 0, '', '2019-08-12 23:37:27');
INSERT INTO `access_log` VALUES (66485, '65.45.15656242592541733', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:37:39', 0, 1002001015, '账号未登陆', '2019-08-12 23:37:39');
INSERT INTO `access_log` VALUES (66486, '65.51.15656242592721813', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:37:39', 1, 1002001015, '账号未登陆', '2019-08-12 23:37:39');
INSERT INTO `access_log` VALUES (66487, '65.53.15656242592721701', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:37:39', 1, 1002001015, '账号未登陆', '2019-08-12 23:37:39');
INSERT INTO `access_log` VALUES (66488, '65.47.15656242625491695', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:37:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-12 23:37:43');
INSERT INTO `access_log` VALUES (66489, '65.49.15656242735351731', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=1234567890&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:37:54', 84, 0, '', '2019-08-12 23:37:54');
INSERT INTO `access_log` VALUES (66490, '65.52.15656242739851773', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:37:54', 10, 0, '', '2019-08-12 23:37:54');
INSERT INTO `access_log` VALUES (66491, '65.46.15656242739881775', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:37:54', 9, 0, '', '2019-08-12 23:37:54');
INSERT INTO `access_log` VALUES (66492, '65.3607.15656242739933525', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:37:54', 8, 0, '', '2019-08-12 23:37:54');
INSERT INTO `access_log` VALUES (66493, '62.81.15656242879457651', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:38:08', 43, 0, '', '2019-08-12 23:38:08');
INSERT INTO `access_log` VALUES (66494, '64.78.15656242935829199', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:38:14', 15, 0, '', '2019-08-12 23:38:14');
INSERT INTO `access_log` VALUES (66495, '64.77.15656242935869185', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:38:14', 52, 0, '', '2019-08-12 23:38:14');
INSERT INTO `access_log` VALUES (66496, '64.81.15656243034459195', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:38:23', 13, 0, '', '2019-08-12 23:38:23');
INSERT INTO `access_log` VALUES (66497, '64.85.15656243034529227', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:38:23', 9, 0, '', '2019-08-12 23:38:23');
INSERT INTO `access_log` VALUES (66498, '64.79.15656243089239199', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:38:29', 10, 0, '', '2019-08-12 23:38:29');
INSERT INTO `access_log` VALUES (66499, '64.83.15656243089209187', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:38:29', 15, 0, '', '2019-08-12 23:38:29');
INSERT INTO `access_log` VALUES (66500, '64.76.15656243089199197', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:38:29', 20, 0, '', '2019-08-12 23:38:29');
INSERT INTO `access_log` VALUES (66501, '64.84.15656243125659189', 1, 2, 'product-application', '/product-api/admins/spu/update', 'name=Oracle&sellPoint=数据库服务器&cid=639&visible=true&id=35&picUrls=https://static.oschina.net/img/logo/oracle.gif&skuStr=[{\"attrs\":[3],\"price\":500000,\"quantity\":11},{\"attrs\":[4],\"price\":200000,\"quantity\":22}]&description=<p>Oracle是一个面向Internet计算环境的数据库。它是在数据库领域一直处于领先地位的Oracle（即甲骨文公司）的产品。可以说Oracle 关系数据库系统是目前世界上流行的关系数据库管理系统，系统可移植性好、使用方便、功能强，适用于各类大、中、小、微机环境。它是一种高效率、可靠性好的 适应高吞吐量的数据库解决方案。</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:38:33', 659, 2001001000, '服务端发生异常', '2019-08-12 23:38:33');
INSERT INTO `access_log` VALUES (66502, '64.77.15656243174159187', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:38:37', 11, 0, '', '2019-08-12 23:38:37');
INSERT INTO `access_log` VALUES (66503, '64.78.15656243174159201', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:38:37', 16, 0, '', '2019-08-12 23:38:37');
INSERT INTO `access_log` VALUES (66504, '64.85.15656243342749229', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:38:54', 10, 0, '', '2019-08-12 23:38:54');
INSERT INTO `access_log` VALUES (66505, '64.81.15656243342719197', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:38:54', 74, 0, '', '2019-08-12 23:38:54');
INSERT INTO `access_log` VALUES (66506, '65.47.15656243488531697', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:39:09', 10, 0, '', '2019-08-12 23:39:09');
INSERT INTO `access_log` VALUES (66507, '65.49.15656243488611733', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:39:09', 9, 0, '', '2019-08-12 23:39:09');
INSERT INTO `access_log` VALUES (66508, '65.50.15656243489321737', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:39:09', 18, 0, '', '2019-08-12 23:39:09');
INSERT INTO `access_log` VALUES (66509, '64.79.15656243491219201', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:39:09', 11, 0, '', '2019-08-12 23:39:09');
INSERT INTO `access_log` VALUES (66510, '64.76.15656243491299199', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:39:09', 13, 0, '', '2019-08-12 23:39:09');
INSERT INTO `access_log` VALUES (66511, '64.82.15656245678919213', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:42:48', 12, 0, '', '2019-08-12 23:42:48');
INSERT INTO `access_log` VALUES (66512, '64.85.15656245692209233', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:42:49', 8, 0, '', '2019-08-12 23:42:49');
INSERT INTO `access_log` VALUES (66513, '64.83.15656245717329193', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:42:52', 11, 0, '', '2019-08-12 23:42:52');
INSERT INTO `access_log` VALUES (66514, '64.76.15656245754979203', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:42:55', 12, 0, '', '2019-08-12 23:42:56');
INSERT INTO `access_log` VALUES (66515, '64.79.15656245755019205', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:42:56', 8, 0, '', '2019-08-12 23:42:56');
INSERT INTO `access_log` VALUES (66516, '65.52.15656246708091779', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:44:31', 4, 0, '', '2019-08-12 23:44:31');
INSERT INTO `access_log` VALUES (66517, '65.45.15656247021331741', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:45:02', 2, 0, '', '2019-08-12 23:45:02');
INSERT INTO `access_log` VALUES (66518, '65.50.15656247624851743', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:46:02', 4, 0, '', '2019-08-12 23:46:02');
INSERT INTO `access_log` VALUES (66519, '64.77.15656247717099195', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=Hadoop&sellPoint=有点小贵&cid=794&visible=true&picUrls=http://static.shop.iocoder.cn/4870d103-1c00-42e1-8eb7-177e227d5e03&skuStr=[{\"attrs\":[1],\"price\":10000,\"quantity\":100}]&description=<p>好看的不得了</p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/d5dccd13-1f82-483e-bb87-fc47e14cb19f\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:46:12', 452, 2001001000, '服务端发生异常', '2019-08-12 23:46:12');
INSERT INTO `access_log` VALUES (66520, '62.88.15656253314067693', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:55:31', 19, 0, '', '2019-08-12 23:55:31');
INSERT INTO `access_log` VALUES (66521, 'fc1aea10-7841-4f65-a644-fe8b5b00c48b', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:48', 6148, 2001001000, '服务端发生异常', '2019-08-12 23:58:54');
INSERT INTO `access_log` VALUES (66522, 'fbc98934-636a-466a-8915-e51bb103d0e3', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:48', 6148, 2001001000, '服务端发生异常', '2019-08-12 23:58:54');
INSERT INTO `access_log` VALUES (66523, 'fbc98934-636a-466a-8915-e51bb103d0e3', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:48', 6148, 2001001000, '服务端发生异常', '2019-08-12 23:58:55');
INSERT INTO `access_log` VALUES (66524, 'fc1aea10-7841-4f65-a644-fe8b5b00c48b', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:48', 6148, 2001001000, '服务端发生异常', '2019-08-12 23:58:55');
INSERT INTO `access_log` VALUES (66525, 'fbc98934-636a-466a-8915-e51bb103d0e3', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:48', 6148, 2001001000, '服务端发生异常', '2019-08-12 23:58:56');
INSERT INTO `access_log` VALUES (66526, 'fc1aea10-7841-4f65-a644-fe8b5b00c48b', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:48', 6148, 2001001000, '服务端发生异常', '2019-08-12 23:58:56');
INSERT INTO `access_log` VALUES (66527, '07ea2ae5-6027-4213-b503-1ad8626eaf53', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:52', 6041, 2001001000, '服务端发生异常', '2019-08-12 23:58:58');
INSERT INTO `access_log` VALUES (66528, '7faa0386-e5e2-4daa-8059-1b844bda6ccd', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:52', 6043, 2001001000, '服务端发生异常', '2019-08-12 23:58:58');
INSERT INTO `access_log` VALUES (66529, '07ea2ae5-6027-4213-b503-1ad8626eaf53', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:52', 6041, 2001001000, '服务端发生异常', '2019-08-12 23:58:59');
INSERT INTO `access_log` VALUES (66530, '7faa0386-e5e2-4daa-8059-1b844bda6ccd', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:52', 6043, 2001001000, '服务端发生异常', '2019-08-12 23:58:59');
INSERT INTO `access_log` VALUES (66531, '07ea2ae5-6027-4213-b503-1ad8626eaf53', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:52', 6041, 2001001000, '服务端发生异常', '2019-08-12 23:59:00');
INSERT INTO `access_log` VALUES (66532, '7faa0386-e5e2-4daa-8059-1b844bda6ccd', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:52', 6043, 2001001000, '服务端发生异常', '2019-08-12 23:59:00');
INSERT INTO `access_log` VALUES (66533, '97e7ebb5-16b3-40b4-8655-4256f4be44f1', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:59:14', 3732, 0, '', '2019-08-12 23:59:18');
INSERT INTO `access_log` VALUES (66534, '97e7ebb5-16b3-40b4-8655-4256f4be44f1', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:59:14', 3732, 0, '', '2019-08-12 23:59:19');
INSERT INTO `access_log` VALUES (66535, '97e7ebb5-16b3-40b4-8655-4256f4be44f1', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:59:14', 3732, 0, '', '2019-08-12 23:59:20');
INSERT INTO `access_log` VALUES (66536, '93d139f2-c9a7-40e9-8a44-5c6fa8605d8b', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:59:14', 10709, 2001001000, '服务端发生异常', '2019-08-12 23:59:25');
INSERT INTO `access_log` VALUES (66537, '93d139f2-c9a7-40e9-8a44-5c6fa8605d8b', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:59:14', 10709, 2001001000, '服务端发生异常', '2019-08-12 23:59:26');
INSERT INTO `access_log` VALUES (66538, '93d139f2-c9a7-40e9-8a44-5c6fa8605d8b', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:59:14', 10709, 2001001000, '服务端发生异常', '2019-08-12 23:59:27');
INSERT INTO `access_log` VALUES (66539, 'a4b69aaa-d080-41d2-a9a1-d11932f8886e', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:59:41', 1123, 0, '', '2019-08-12 23:59:43');
INSERT INTO `access_log` VALUES (66540, '507be1d7-e6df-4fca-bff9-4c7989b5ffef', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 23:59:41', 1135, 0, '', '2019-08-12 23:59:43');
INSERT INTO `access_log` VALUES (66541, '34fb01cb-4f07-4e91-9a18-614dbd0bd9fb', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:17', 6201, 2001001000, '服务端发生异常', '2019-08-13 00:01:23');
INSERT INTO `access_log` VALUES (66542, '7f18098f-ec91-47f6-8bac-6f5fd1cacdd5', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:21', 2487, 0, '', '2019-08-13 00:01:23');
INSERT INTO `access_log` VALUES (66543, '34fb01cb-4f07-4e91-9a18-614dbd0bd9fb', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:17', 6201, 2001001000, '服务端发生异常', '2019-08-13 00:01:24');
INSERT INTO `access_log` VALUES (66544, '7f18098f-ec91-47f6-8bac-6f5fd1cacdd5', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:21', 2487, 0, '', '2019-08-13 00:01:24');
INSERT INTO `access_log` VALUES (66545, '34fb01cb-4f07-4e91-9a18-614dbd0bd9fb', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:17', 6201, 2001001000, '服务端发生异常', '2019-08-13 00:01:25');
INSERT INTO `access_log` VALUES (66546, '7f18098f-ec91-47f6-8bac-6f5fd1cacdd5', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:21', 2487, 0, '', '2019-08-13 00:01:25');
INSERT INTO `access_log` VALUES (66547, '7c6c84bd-52d2-46ed-a383-6e366a587f48', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:26', 1802, 0, '', '2019-08-13 00:01:28');
INSERT INTO `access_log` VALUES (66548, 'd730da14-42a3-48b4-bbe1-35c3c8c14829', 197, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:19', 9609, 0, '', '2019-08-13 00:01:29');
INSERT INTO `access_log` VALUES (66549, '7c6c84bd-52d2-46ed-a383-6e366a587f48', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:26', 1802, 0, '', '2019-08-13 00:01:29');
INSERT INTO `access_log` VALUES (66550, '7c6c84bd-52d2-46ed-a383-6e366a587f48', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:26', 1802, 0, '', '2019-08-13 00:01:30');
INSERT INTO `access_log` VALUES (66551, '4ae12e7c-f01f-42e9-9750-944ed9b73b2f', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:22', 10370, 0, '', '2019-08-13 00:01:32');
INSERT INTO `access_log` VALUES (66552, '4ae12e7c-f01f-42e9-9750-944ed9b73b2f', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:22', 10370, 0, '', '2019-08-13 00:01:33');
INSERT INTO `access_log` VALUES (66553, '4ae12e7c-f01f-42e9-9750-944ed9b73b2f', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:22', 10370, 0, '', '2019-08-13 00:01:34');
INSERT INTO `access_log` VALUES (66554, '65.3607.15656279980753577', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:39:58', 0, 1002001015, '账号未登陆', '2019-08-13 00:39:58');
INSERT INTO `access_log` VALUES (66555, '65.49.15656279980751783', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:39:58', 0, 1002001015, '账号未登陆', '2019-08-13 00:39:58');
INSERT INTO `access_log` VALUES (66556, '65.47.15656279980761747', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:39:58', 1, 1002001015, '账号未登陆', '2019-08-13 00:39:58');
INSERT INTO `access_log` VALUES (66557, '65.50.15656280015181787', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:40:02', 69, 0, '', '2019-08-13 00:40:02');
INSERT INTO `access_log` VALUES (66558, '65.46.15656280017811827', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:40:02', 12, 0, '', '2019-08-13 00:40:02');
INSERT INTO `access_log` VALUES (66559, '65.54.15656280017861687', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:40:02', 12, 0, '', '2019-08-13 00:40:02');
INSERT INTO `access_log` VALUES (66560, '65.52.15656280017831825', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:40:02', 24, 2001001000, '服务端发生异常', '2019-08-13 00:40:02');
INSERT INTO `access_log` VALUES (66561, '65.53.15656280037431755', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:40:04', 10, 0, '', '2019-08-13 00:40:04');
INSERT INTO `access_log` VALUES (66562, '65.45.15656280037431787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:40:04', 9, 0, '', '2019-08-13 00:40:04');
INSERT INTO `access_log` VALUES (66563, '65.51.15656280037431867', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:40:04', 10, 2001001000, '服务端发生异常', '2019-08-13 00:40:04');
INSERT INTO `access_log` VALUES (66564, '65.47.15656280052541749', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:40:05', 9, 0, '', '2019-08-13 00:40:05');
INSERT INTO `access_log` VALUES (66565, '65.49.15656280052571785', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:40:05', 9, 0, '', '2019-08-13 00:40:05');
INSERT INTO `access_log` VALUES (66566, '65.3607.15656280052563579', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:40:05', 13, 2001001000, '服务端发生异常', '2019-08-13 00:40:05');
INSERT INTO `access_log` VALUES (66567, '65.46.15656280064361829', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:40:06', 9, 2001001000, '服务端发生异常', '2019-08-13 00:40:06');
INSERT INTO `access_log` VALUES (66568, '65.54.15656280064371689', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:40:06', 8, 0, '', '2019-08-13 00:40:06');
INSERT INTO `access_log` VALUES (66569, '65.50.15656280064361789', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.69.26.53', '2019-08-13 00:40:06', 11, 0, '', '2019-08-13 00:40:06');
INSERT INTO `access_log` VALUES (66570, '65.52.15656407442861997', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '143.107.167.182', '2019-08-13 04:12:24', 0, 1002001015, '账号未登陆', '2019-08-13 04:12:24');
INSERT INTO `access_log` VALUES (66571, '65.51.15656407442872039', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '143.107.167.182', '2019-08-13 04:12:24', 0, 1002001015, '账号未登陆', '2019-08-13 04:12:24');
INSERT INTO `access_log` VALUES (66572, '65.45.15656407442901959', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '143.107.167.182', '2019-08-13 04:12:24', 0, 1002001015, '账号未登陆', '2019-08-13 04:12:24');
INSERT INTO `access_log` VALUES (66573, '65.49.15656407812931957', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '143.107.167.182', '2019-08-13 04:13:01', 82, 0, '', '2019-08-13 04:13:01');
INSERT INTO `access_log` VALUES (66574, '65.3607.15656407822333751', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '143.107.167.182', '2019-08-13 04:13:02', 13, 0, '', '2019-08-13 04:13:02');
INSERT INTO `access_log` VALUES (66575, '65.50.15656407822371961', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '143.107.167.182', '2019-08-13 04:13:02', 10, 0, '', '2019-08-13 04:13:02');
INSERT INTO `access_log` VALUES (66576, '65.46.15656407822402001', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '143.107.167.182', '2019-08-13 04:13:02', 9, 2001001000, '服务端发生异常', '2019-08-13 04:13:02');
INSERT INTO `access_log` VALUES (66577, '59.76.15656577640209303', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:04', 11, 0, '', '2019-08-13 08:56:04');
INSERT INTO `access_log` VALUES (66578, '59.77.15656577640229301', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:04', 25, 2001001000, '服务端发生异常', '2019-08-13 08:56:04');
INSERT INTO `access_log` VALUES (66579, '64.82.15656577674819657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:07', 101, 0, '', '2019-08-13 08:56:08');
INSERT INTO `access_log` VALUES (66580, '64.85.15656577677409677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:08', 3, 0, '', '2019-08-13 08:56:08');
INSERT INTO `access_log` VALUES (66581, '64.81.15656577687759645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:09', 2, 0, '', '2019-08-13 08:56:09');
INSERT INTO `access_log` VALUES (66582, '64.83.15656577692769637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:09', 2, 0, '', '2019-08-13 08:56:09');
INSERT INTO `access_log` VALUES (66583, '64.76.15656577696379647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:10', 2, 0, '', '2019-08-13 08:56:10');
INSERT INTO `access_log` VALUES (66584, '65.45.15656577763332187', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:16', 1, 1002001015, '账号未登陆', '2019-08-13 08:56:16');
INSERT INTO `access_log` VALUES (66585, '65.53.15656577763332155', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:16', 1, 1002001015, '账号未登陆', '2019-08-13 08:56:16');
INSERT INTO `access_log` VALUES (66586, '65.47.15656577763532149', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:16', 0, 1002001015, '账号未登陆', '2019-08-13 08:56:16');
INSERT INTO `access_log` VALUES (66587, '65.49.15656577824112185', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:22', 73, 0, '', '2019-08-13 08:56:22');
INSERT INTO `access_log` VALUES (66588, '65.50.15656577827422189', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:23', 11, 0, '', '2019-08-13 08:56:23');
INSERT INTO `access_log` VALUES (66589, '65.3607.15656577827443979', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:23', 12, 2001001000, '服务端发生异常', '2019-08-13 08:56:23');
INSERT INTO `access_log` VALUES (66590, '65.46.15656577827482229', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:23', 10, 0, '', '2019-08-13 08:56:23');
INSERT INTO `access_log` VALUES (66591, '65.51.15656578051422269', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:45', 11, 0, '', '2019-08-13 08:56:45');
INSERT INTO `access_log` VALUES (66592, '65.45.15656578051482189', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:45', 11, 2001001000, '服务端发生异常', '2019-08-13 08:56:45');
INSERT INTO `access_log` VALUES (66593, '65.53.15656578051482157', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:45', 12, 0, '', '2019-08-13 08:56:45');
INSERT INTO `access_log` VALUES (66594, '65.47.15656578106712151', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 08:56:51');
INSERT INTO `access_log` VALUES (66595, '65.49.15656578118252187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:52', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 08:56:52');
INSERT INTO `access_log` VALUES (66596, '65.46.15656578123792231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:52', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 08:56:52');
INSERT INTO `access_log` VALUES (66597, '65.3607.15656578127353981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:53', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 08:56:53');
INSERT INTO `access_log` VALUES (66598, '65.50.15656578130972191', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:53', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 08:56:53');
INSERT INTO `access_log` VALUES (66599, '65.54.15656578134352091', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 08:56:53');
INSERT INTO `access_log` VALUES (66600, '65.52.15656578137842229', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 08:56:54');
INSERT INTO `access_log` VALUES (66601, '65.53.15656578141232159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 08:56:54');
INSERT INTO `access_log` VALUES (66602, '65.45.15656578144642191', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.140.201.18', '2019-08-13 08:56:54', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 08:56:54');
INSERT INTO `access_log` VALUES (66603, '65.54.15656588230862107', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.166', '2019-08-13 09:13:43', 3, 1002001012, '访问令牌已过期', '2019-08-13 09:13:43');
INSERT INTO `access_log` VALUES (66604, '65.51.15656588230882287', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.166', '2019-08-13 09:13:43', 2, 1002001012, '访问令牌已过期', '2019-08-13 09:13:43');
INSERT INTO `access_log` VALUES (66605, '65.52.15656588230882245', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.166', '2019-08-13 09:13:43', 2, 1002001012, '访问令牌已过期', '2019-08-13 09:13:43');
INSERT INTO `access_log` VALUES (66606, '65.53.15656588295202173', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.166', '2019-08-13 09:13:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 09:13:50');
INSERT INTO `access_log` VALUES (66607, '65.47.15656588341612169', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.166', '2019-08-13 09:13:54', 81, 0, '', '2019-08-13 09:13:54');
INSERT INTO `access_log` VALUES (66608, '65.49.15656588345112205', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.166', '2019-08-13 09:13:55', 8, 0, '', '2019-08-13 09:13:55');
INSERT INTO `access_log` VALUES (66609, '65.3607.15656588345143997', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.166', '2019-08-13 09:13:55', 7, 0, '', '2019-08-13 09:13:55');
INSERT INTO `access_log` VALUES (66610, '65.46.15656588345132247', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '110.53.253.166', '2019-08-13 09:13:55', 9, 2001001000, '服务端发生异常', '2019-08-13 09:13:55');
INSERT INTO `access_log` VALUES (66611, '65.3607.15656606441204023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.96.34', '2019-08-13 09:44:04', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 09:44:04');
INSERT INTO `access_log` VALUES (66612, '65.53.15656609963572203', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.98.116.217', '2019-08-13 09:49:56', 0, 1002001015, '账号未登陆', '2019-08-13 09:49:56');
INSERT INTO `access_log` VALUES (66613, '65.47.15656609963582199', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.98.116.217', '2019-08-13 09:49:56', 0, 1002001015, '账号未登陆', '2019-08-13 09:49:56');
INSERT INTO `access_log` VALUES (66614, '65.51.15656609963582317', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.98.116.217', '2019-08-13 09:49:56', 1, 1002001015, '账号未登陆', '2019-08-13 09:49:56');
INSERT INTO `access_log` VALUES (66615, '65.49.15656609990702235', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.98.116.217', '2019-08-13 09:49:59', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 09:49:59');
INSERT INTO `access_log` VALUES (66616, '65.46.15656610035672277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.98.116.217', '2019-08-13 09:50:04', 82, 0, '', '2019-08-13 09:50:04');
INSERT INTO `access_log` VALUES (66617, '65.3607.15656610038464029', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.98.116.217', '2019-08-13 09:50:04', 10, 0, '', '2019-08-13 09:50:04');
INSERT INTO `access_log` VALUES (66618, '65.50.15656610038492241', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.98.116.217', '2019-08-13 09:50:04', 11, 2001001000, '服务端发生异常', '2019-08-13 09:50:04');
INSERT INTO `access_log` VALUES (66619, '65.54.15656610038542141', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.98.116.217', '2019-08-13 09:50:04', 12, 0, '', '2019-08-13 09:50:04');
INSERT INTO `access_log` VALUES (66620, '65.45.15656610112182241', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.98.116.217', '2019-08-13 09:50:11', 7, 0, '', '2019-08-13 09:50:11');
INSERT INTO `access_log` VALUES (66621, '65.53.15656610112232205', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.98.116.217', '2019-08-13 09:50:11', 8, 2001001000, '服务端发生异常', '2019-08-13 09:50:11');
INSERT INTO `access_log` VALUES (66622, '65.47.15656610112252201', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.98.116.217', '2019-08-13 09:50:11', 7, 0, '', '2019-08-13 09:50:11');
INSERT INTO `access_log` VALUES (66623, '59.78.15656632685859393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.142.30.78', '2019-08-13 10:27:49', 11, 0, '', '2019-08-13 10:27:49');
INSERT INTO `access_log` VALUES (66624, '59.73.15656632685869389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.142.30.78', '2019-08-13 10:27:49', 24, 2001001000, '服务端发生异常', '2019-08-13 10:27:49');
INSERT INTO `access_log` VALUES (66625, '64.81.15656632721769719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.142.30.78', '2019-08-13 10:27:52', 10, 0, '', '2019-08-13 10:27:52');
INSERT INTO `access_log` VALUES (66626, '64.83.15656632723149711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.142.30.78', '2019-08-13 10:27:52', 3, 0, '', '2019-08-13 10:27:52');
INSERT INTO `access_log` VALUES (66627, '65.52.15656641085442321', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.181.38.124', '2019-08-13 10:41:49', 0, 1002001015, '账号未登陆', '2019-08-13 10:41:49');
INSERT INTO `access_log` VALUES (66628, '65.50.15656641085392285', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.181.38.124', '2019-08-13 10:41:49', 1, 1002001015, '账号未登陆', '2019-08-13 10:41:49');
INSERT INTO `access_log` VALUES (66629, '65.3607.15656641085404071', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.181.38.124', '2019-08-13 10:41:49', 2, 1002001015, '账号未登陆', '2019-08-13 10:41:49');
INSERT INTO `access_log` VALUES (66630, '65.47.15656641134742245', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.181.38.124', '2019-08-13 10:41:53', 94, 0, '', '2019-08-13 10:41:54');
INSERT INTO `access_log` VALUES (66631, '65.53.15656641138212247', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.181.38.124', '2019-08-13 10:41:54', 16, 0, '', '2019-08-13 10:41:54');
INSERT INTO `access_log` VALUES (66632, '65.49.15656641138242281', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.181.38.124', '2019-08-13 10:41:54', 14, 2001001000, '服务端发生异常', '2019-08-13 10:41:54');
INSERT INTO `access_log` VALUES (66633, '65.51.15656641138292363', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.181.38.124', '2019-08-13 10:41:54', 13, 0, '', '2019-08-13 10:41:54');
INSERT INTO `access_log` VALUES (66634, '65.46.15656641223042323', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.181.38.124', '2019-08-13 10:42:02', 17, 0, '', '2019-08-13 10:42:02');
INSERT INTO `access_log` VALUES (66635, '65.50.15656641223142287', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.181.38.124', '2019-08-13 10:42:02', 9, 0, '', '2019-08-13 10:42:02');
INSERT INTO `access_log` VALUES (66636, '65.54.15656641223062185', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.181.38.124', '2019-08-13 10:42:02', 10, 2001001000, '服务端发生异常', '2019-08-13 10:42:02');
INSERT INTO `access_log` VALUES (66637, '59.80.15656667935339405', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.64.119.135', '2019-08-13 11:26:34', 9, 0, '', '2019-08-13 11:26:34');
INSERT INTO `access_log` VALUES (66638, '59.79.15656667935349439', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.64.119.135', '2019-08-13 11:26:34', 16, 2001001000, '服务端发生异常', '2019-08-13 11:26:34');
INSERT INTO `access_log` VALUES (66639, '59.77.15656680222399439', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-13 11:47:02', 3, 0, '', '2019-08-13 11:47:02');
INSERT INTO `access_log` VALUES (66640, '59.73.15656680222399453', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-13 11:47:02', 17, 2001001000, '服务端发生异常', '2019-08-13 11:47:02');
INSERT INTO `access_log` VALUES (66641, '59.71.15656680247969449', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-13 11:47:05', 3, 0, '', '2019-08-13 11:47:05');
INSERT INTO `access_log` VALUES (66642, '59.74.15656680247969467', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-13 11:47:05', 17, 2001001000, '服务端发生异常', '2019-08-13 11:47:05');
INSERT INTO `access_log` VALUES (66643, '59.77.15656681105909441', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-13 11:48:31', 2, 0, '', '2019-08-13 11:48:31');
INSERT INTO `access_log` VALUES (66644, '59.73.15656681105909455', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-13 11:48:31', 13, 2001001000, '服务端发生异常', '2019-08-13 11:48:31');
INSERT INTO `access_log` VALUES (66645, '59.71.15656681159649451', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-13 11:48:36', 2, 0, '', '2019-08-13 11:48:36');
INSERT INTO `access_log` VALUES (66646, '59.74.15656681159659469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-13 11:48:36', 25, 2001001000, '服务端发生异常', '2019-08-13 11:48:36');
INSERT INTO `access_log` VALUES (66647, '59.75.15656681201499461', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-13 11:48:40', 2, 0, '', '2019-08-13 11:48:40');
INSERT INTO `access_log` VALUES (66648, '59.80.15656681201499425', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-13 11:48:40', 12, 2001001000, '服务端发生异常', '2019-08-13 11:48:40');
INSERT INTO `access_log` VALUES (66649, '59.79.15656681253249459', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-13 11:48:45', 2, 0, '', '2019-08-13 11:48:45');
INSERT INTO `access_log` VALUES (66650, '59.72.15656681253249453', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-13 11:48:45', 29, 2001001000, '服务端发生异常', '2019-08-13 11:48:45');
INSERT INTO `access_log` VALUES (66651, '59.76.15656681693409445', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:49:29', 2, 0, '', '2019-08-13 11:49:29');
INSERT INTO `access_log` VALUES (66652, '59.71.15656681693419453', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:49:29', 21, 2001001000, '服务端发生异常', '2019-08-13 11:49:29');
INSERT INTO `access_log` VALUES (66653, '59.72.15656682186049455', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:50:19', 2, 0, '', '2019-08-13 11:50:19');
INSERT INTO `access_log` VALUES (66654, '59.79.15656682186049461', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:50:19', 15, 2001001000, '服务端发生异常', '2019-08-13 11:50:19');
INSERT INTO `access_log` VALUES (66655, '59.71.15656682737659455', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:51:14', 8, 0, '', '2019-08-13 11:51:14');
INSERT INTO `access_log` VALUES (66656, '59.74.15656682737659473', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:51:14', 18, 2001001000, '服务端发生异常', '2019-08-13 11:51:14');
INSERT INTO `access_log` VALUES (66657, '59.73.15656683455809461', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:52:26', 9, 0, '', '2019-08-13 11:52:26');
INSERT INTO `access_log` VALUES (66658, '59.77.15656683455819447', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:52:26', 20, 2001001000, '服务端发生异常', '2019-08-13 11:52:26');
INSERT INTO `access_log` VALUES (66659, '64.80.15656684160569793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:53:36', 13, 0, '', '2019-08-13 11:53:36');
INSERT INTO `access_log` VALUES (66660, '64.78.15656684161639793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:53:36', 4, 0, '', '2019-08-13 11:53:36');
INSERT INTO `access_log` VALUES (66661, '66.50.15656684237937063', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18856655656', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:53:44', 78, 0, '', '2019-08-13 11:53:44');
INSERT INTO `access_log` VALUES (66662, '66.55.15656684273767039', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18856655656&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:53:47', 169, 0, '', '2019-08-13 11:53:48');
INSERT INTO `access_log` VALUES (66663, '64.85.15656684307689821', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:53:51', 10, 0, '', '2019-08-13 11:53:51');
INSERT INTO `access_log` VALUES (66664, '64.83.15656684308789781', 197, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:53:51', 8, 0, '', '2019-08-13 11:53:51');
INSERT INTO `access_log` VALUES (66665, '66.49.15656684318837061', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:53:52', 6, 0, '', '2019-08-13 11:53:52');
INSERT INTO `access_log` VALUES (66666, '66.53.15656684375197059', 197, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:53:58', 5, 0, '', '2019-08-13 11:53:58');
INSERT INTO `access_log` VALUES (66667, '59.73.15656684384979463', 197, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:53:58', 7, 0, '', '2019-08-13 11:53:59');
INSERT INTO `access_log` VALUES (66668, '59.77.15656684385049449', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 11:53:59', 11, 2001001000, '服务端发生异常', '2019-08-13 11:53:59');
INSERT INTO `access_log` VALUES (66669, '65.51.15656688333822427', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.60.188.221', '2019-08-13 12:00:33', 1, 1002001015, '账号未登陆', '2019-08-13 12:00:33');
INSERT INTO `access_log` VALUES (66670, '65.53.15656688333832311', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.60.188.221', '2019-08-13 12:00:33', 1, 1002001015, '账号未登陆', '2019-08-13 12:00:33');
INSERT INTO `access_log` VALUES (66671, '65.45.15656688333912349', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.60.188.221', '2019-08-13 12:00:33', 1, 1002001015, '账号未登陆', '2019-08-13 12:00:33');
INSERT INTO `access_log` VALUES (66672, '65.46.15656688443552387', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.60.188.221', '2019-08-13 12:00:44', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 12:00:44');
INSERT INTO `access_log` VALUES (66673, '65.52.15656688689502387', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.60.188.221', '2019-08-13 12:01:09', 100, 0, '', '2019-08-13 12:01:09');
INSERT INTO `access_log` VALUES (66674, '65.47.15656688693882311', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.60.188.221', '2019-08-13 12:01:09', 12, 0, '', '2019-08-13 12:01:09');
INSERT INTO `access_log` VALUES (66675, '65.49.15656688694062347', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.60.188.221', '2019-08-13 12:01:09', 12, 2001001000, '服务端发生异常', '2019-08-13 12:01:09');
INSERT INTO `access_log` VALUES (66676, '65.45.15656688694102351', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.60.188.221', '2019-08-13 12:01:09', 10, 0, '', '2019-08-13 12:01:09');
INSERT INTO `access_log` VALUES (66677, '59.72.15656689784179467', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '211.138.116.141', '2019-08-13 12:02:58', 2, 0, '', '2019-08-13 12:02:58');
INSERT INTO `access_log` VALUES (66678, '59.78.15656689784319475', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '211.138.116.141', '2019-08-13 12:02:58', 15, 2001001000, '服务端发生异常', '2019-08-13 12:02:58');
INSERT INTO `access_log` VALUES (66679, '59.79.15656690743529475', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '211.138.116.141', '2019-08-13 12:04:34', 2, 0, '', '2019-08-13 12:04:34');
INSERT INTO `access_log` VALUES (66680, '59.72.15656690743539469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '211.138.116.141', '2019-08-13 12:04:34', 16, 2001001000, '服务端发生异常', '2019-08-13 12:04:34');
INSERT INTO `access_log` VALUES (66681, '65.53.15656703890662333', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.82.98', '2019-08-13 12:26:29', 1, 1002001015, '账号未登陆', '2019-08-13 12:26:29');
INSERT INTO `access_log` VALUES (66682, '65.50.15656703890662373', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.82.98', '2019-08-13 12:26:29', 1, 1002001015, '账号未登陆', '2019-08-13 12:26:29');
INSERT INTO `access_log` VALUES (66683, '65.46.15656703890672409', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.82.98', '2019-08-13 12:26:29', 0, 1002001015, '账号未登陆', '2019-08-13 12:26:29');
INSERT INTO `access_log` VALUES (66684, '65.3607.15656704004294159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.82.98', '2019-08-13 12:26:40', 137, 0, '', '2019-08-13 12:26:41');
INSERT INTO `access_log` VALUES (66685, '65.52.15656704008462409', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.82.98', '2019-08-13 12:26:41', 10, 0, '', '2019-08-13 12:26:41');
INSERT INTO `access_log` VALUES (66686, '65.47.15656704008472333', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.82.98', '2019-08-13 12:26:41', 12, 2001001000, '服务端发生异常', '2019-08-13 12:26:41');
INSERT INTO `access_log` VALUES (66687, '65.45.15656704008512373', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.82.98', '2019-08-13 12:26:41', 9, 0, '', '2019-08-13 12:26:41');
INSERT INTO `access_log` VALUES (66688, '65.52.15656705190332411', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.82.98', '2019-08-13 12:28:39', 88, 0, '', '2019-08-13 12:28:39');
INSERT INTO `access_log` VALUES (66689, '65.45.15656705192732375', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.82.98', '2019-08-13 12:28:39', 10, 0, '', '2019-08-13 12:28:39');
INSERT INTO `access_log` VALUES (66690, '65.49.15656705192782371', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.82.98', '2019-08-13 12:28:39', 10, 2001001000, '服务端发生异常', '2019-08-13 12:28:39');
INSERT INTO `access_log` VALUES (66691, '65.51.15656705192792453', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.82.98', '2019-08-13 12:28:39', 9, 0, '', '2019-08-13 12:28:39');
INSERT INTO `access_log` VALUES (66692, '59.80.15656725925099489', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 13:03:13', 27, 0, '', '2019-08-13 13:03:13');
INSERT INTO `access_log` VALUES (66693, '59.75.15656725925099525', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.175.27.178', '2019-08-13 13:03:13', 59, 2001001000, '服务端发生异常', '2019-08-13 13:03:13');
INSERT INTO `access_log` VALUES (66694, '65.50.15656747582362433', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '222.209.83.2', '2019-08-13 13:39:18', 1, 1002001015, '账号未登陆', '2019-08-13 13:39:18');
INSERT INTO `access_log` VALUES (66695, '65.54.15656747582362331', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '222.209.83.2', '2019-08-13 13:39:18', 0, 1002001015, '账号未登陆', '2019-08-13 13:39:18');
INSERT INTO `access_log` VALUES (66696, '65.3607.15656747582594219', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '222.209.83.2', '2019-08-13 13:39:18', 0, 1002001015, '账号未登陆', '2019-08-13 13:39:18');
INSERT INTO `access_log` VALUES (66697, '65.47.15656747598882393', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '222.209.83.2', '2019-08-13 13:39:20', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 13:39:20');
INSERT INTO `access_log` VALUES (66698, '59.74.15656750798949567', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:44:40', 9, 0, '', '2019-08-13 13:44:40');
INSERT INTO `access_log` VALUES (66699, '59.71.15656750798949549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:44:40', 15, 2001001000, '服务端发生异常', '2019-08-13 13:44:40');
INSERT INTO `access_log` VALUES (66700, '64.80.15656750856019883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:44:46', 10, 0, '', '2019-08-13 13:44:46');
INSERT INTO `access_log` VALUES (66701, '64.78.15656750857599883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:44:46', 3, 0, '', '2019-08-13 13:44:46');
INSERT INTO `access_log` VALUES (66702, '65.50.15656751407672439', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:45:41', 1, 1002001015, '账号未登陆', '2019-08-13 13:45:41');
INSERT INTO `access_log` VALUES (66703, '65.3607.15656751407674225', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:45:41', 0, 1002001015, '账号未登陆', '2019-08-13 13:45:41');
INSERT INTO `access_log` VALUES (66704, '65.54.15656751407742337', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:45:41', 0, 1002001015, '账号未登陆', '2019-08-13 13:45:41');
INSERT INTO `access_log` VALUES (66705, '65.52.15656751548632475', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:45:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 13:45:55');
INSERT INTO `access_log` VALUES (66706, '65.45.15656751648672439', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:46:05', 304, 0, '', '2019-08-13 13:46:05');
INSERT INTO `access_log` VALUES (66707, '65.51.15656751654302517', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:46:05', 19, 0, '', '2019-08-13 13:46:05');
INSERT INTO `access_log` VALUES (66708, '65.49.15656751654412435', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:46:05', 9, 2001001000, '服务端发生异常', '2019-08-13 13:46:05');
INSERT INTO `access_log` VALUES (66709, '65.46.15656751654432477', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:46:05', 9, 0, '', '2019-08-13 13:46:05');
INSERT INTO `access_log` VALUES (66710, '65.47.15656752091552401', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:46:49', 18, 2001001000, '服务端发生异常', '2019-08-13 13:46:49');
INSERT INTO `access_log` VALUES (66711, '65.50.15656752091512441', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:46:49', 25, 0, '', '2019-08-13 13:46:49');
INSERT INTO `access_log` VALUES (66712, '65.52.15656752091972477', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.143.82', '2019-08-13 13:46:49', 9, 0, '', '2019-08-13 13:46:49');
INSERT INTO `access_log` VALUES (66713, '65.47.15656765082962419', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-13 14:08:28', 4, 1002001012, '访问令牌已过期', '2019-08-13 14:08:28');
INSERT INTO `access_log` VALUES (66714, '65.52.15656765082972495', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-13 14:08:28', 4, 1002001012, '访问令牌已过期', '2019-08-13 14:08:28');
INSERT INTO `access_log` VALUES (66715, '65.50.15656765083032459', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-13 14:08:28', 3, 1002001012, '访问令牌已过期', '2019-08-13 14:08:28');
INSERT INTO `access_log` VALUES (66716, '65.45.15656765135542459', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-13 14:08:34', 74, 0, '', '2019-08-13 14:08:34');
INSERT INTO `access_log` VALUES (66717, '65.51.15656765139712537', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-13 14:08:34', 238, 0, '', '2019-08-13 14:08:34');
INSERT INTO `access_log` VALUES (66718, '65.46.15656765139822497', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-13 14:08:34', 227, 0, '', '2019-08-13 14:08:34');
INSERT INTO `access_log` VALUES (66719, '65.49.15656765139762455', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-13 14:08:34', 234, 2001001000, '服务端发生异常', '2019-08-13 14:08:34');
INSERT INTO `access_log` VALUES (66720, '59.73.15656775570399587', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.236.143.47', '2019-08-13 14:25:57', 9, 0, '', '2019-08-13 14:25:57');
INSERT INTO `access_log` VALUES (66721, '59.77.15656775570409573', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.236.143.47', '2019-08-13 14:25:57', 15, 2001001000, '服务端发生异常', '2019-08-13 14:25:57');
INSERT INTO `access_log` VALUES (66722, '59.72.15656818522919641', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-13 15:37:32', 9, 0, '', '2019-08-13 15:37:32');
INSERT INTO `access_log` VALUES (66723, '59.78.15656818522939649', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-13 15:37:32', 16, 2001001000, '服务端发生异常', '2019-08-13 15:37:32');
INSERT INTO `access_log` VALUES (66724, '64.85.15656818565600001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-13 15:37:37', 430, 0, '', '2019-08-13 15:37:37');
INSERT INTO `access_log` VALUES (66725, '64.81.15656818571849969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-13 15:37:37', 3, 0, '', '2019-08-13 15:37:37');
INSERT INTO `access_log` VALUES (66726, '64.83.15656818613539961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-13 15:37:41', 2, 0, '', '2019-08-13 15:37:41');
INSERT INTO `access_log` VALUES (66727, '64.76.15656818614739971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-13 15:37:41', 1, 0, '', '2019-08-13 15:37:41');
INSERT INTO `access_log` VALUES (66728, '64.79.15656818655279973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-13 15:37:46', 1, 0, '', '2019-08-13 15:37:46');
INSERT INTO `access_log` VALUES (66729, '64.84.15656818656279963', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-13 15:37:46', 2, 0, '', '2019-08-13 15:37:46');
INSERT INTO `access_log` VALUES (66730, '59.73.15656818662819645', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-13 15:37:46', 5, 0, '', '2019-08-13 15:37:46');
INSERT INTO `access_log` VALUES (66731, '59.76.15656818662839633', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-13 15:37:46', 19, 2001001000, '服务端发生异常', '2019-08-13 15:37:46');
INSERT INTO `access_log` VALUES (66732, '59.75.15656818933879651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:13', 2, 0, '', '2019-08-13 15:38:13');
INSERT INTO `access_log` VALUES (66733, '59.80.15656818933869615', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:13', 13, 2001001000, '服务端发生异常', '2019-08-13 15:38:13');
INSERT INTO `access_log` VALUES (66734, '64.77.15656818963969961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:16', 2, 0, '', '2019-08-13 15:38:16');
INSERT INTO `access_log` VALUES (66735, '64.82.15656818968679983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:17', 2, 0, '', '2019-08-13 15:38:17');
INSERT INTO `access_log` VALUES (66736, '64.85.15656818995720003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:20', 2, 0, '', '2019-08-13 15:38:20');
INSERT INTO `access_log` VALUES (66737, '64.81.15656818997019971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:20', 2, 0, '', '2019-08-13 15:38:20');
INSERT INTO `access_log` VALUES (66738, '64.76.15656819029659973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:23', 2, 0, '', '2019-08-13 15:38:23');
INSERT INTO `access_log` VALUES (66739, '64.79.15656819031519975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:23', 2, 0, '', '2019-08-13 15:38:23');
INSERT INTO `access_log` VALUES (66740, '59.78.15656819039559651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:24', 2, 0, '', '2019-08-13 15:38:24');
INSERT INTO `access_log` VALUES (66741, '59.72.15656819039569643', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:24', 12, 2001001000, '服务端发生异常', '2019-08-13 15:38:24');
INSERT INTO `access_log` VALUES (66742, '64.84.15656819056029965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:26', 2, 0, '', '2019-08-13 15:38:26');
INSERT INTO `access_log` VALUES (66743, '64.80.15656819057379977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:26', 1, 0, '', '2019-08-13 15:38:26');
INSERT INTO `access_log` VALUES (66744, '64.78.15656819067449977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:27', 1, 0, '', '2019-08-13 15:38:27');
INSERT INTO `access_log` VALUES (66745, '64.77.15656819074319963', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:27', 2, 0, '', '2019-08-13 15:38:27');
INSERT INTO `access_log` VALUES (66746, '64.82.15656819082759985', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:28', 2, 0, '', '2019-08-13 15:38:28');
INSERT INTO `access_log` VALUES (66747, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:28', 12, 0, '', '2019-08-13 15:38:28');
INSERT INTO `access_log` VALUES (66748, '64.85.15656819099940005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:30', 1, 0, '', '2019-08-13 15:38:30');
INSERT INTO `access_log` VALUES (66749, '64.81.15656819101169973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:30', 2, 0, '', '2019-08-13 15:38:30');
INSERT INTO `access_log` VALUES (66750, '64.83.15656819110829965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:31', 2, 0, '', '2019-08-13 15:38:31');
INSERT INTO `access_log` VALUES (66751, '64.76.15656819118449975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:32', 1, 0, '', '2019-08-13 15:38:32');
INSERT INTO `access_log` VALUES (66752, '64.79.15656819126099977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:33', 2, 0, '', '2019-08-13 15:38:33');
INSERT INTO `access_log` VALUES (66753, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:33', 6, 0, '', '2019-08-13 15:38:33');
INSERT INTO `access_log` VALUES (66754, '64.84.15656819137249967', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:34', 7, 0, '', '2019-08-13 15:38:34');
INSERT INTO `access_log` VALUES (66755, '66.53.15656819260427239', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13693100472', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:46', 94, 0, '', '2019-08-13 15:38:46');
INSERT INTO `access_log` VALUES (66756, '66.54.15656819350117255', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13693100472&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:55', 221, 0, '', '2019-08-13 15:38:55');
INSERT INTO `access_log` VALUES (66757, '66.50.15656819365177245', 198, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:38:57', 5, 0, '', '2019-08-13 15:38:57');
INSERT INTO `access_log` VALUES (66758, '64.82.15656819400169987', 198, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:39:00', 10, 0, '', '2019-08-13 15:39:00');
INSERT INTO `access_log` VALUES (66759, '66.55.15656819422807221', 198, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:39:02', 5, 0, '', '2019-08-13 15:39:02');
INSERT INTO `access_log` VALUES (66760, '66.48.15656819437797253', 198, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:39:04', 5, 0, '', '2019-08-13 15:39:04');
INSERT INTO `access_log` VALUES (66761, '66.53.15656819591367241', 198, 1, 'user-application', '/user-api/users/address/add', 'name=哈哈&tel=13693100472&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=哈哈&isDefault=false&address=哈哈&areaNo=110101&mobile=13693100472&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:39:19', 121, 2001001000, '服务端发生异常', '2019-08-13 15:39:19');
INSERT INTO `access_log` VALUES (66762, '66.54.15656819609987257', 198, 1, 'user-application', '/user-api/users/address/add', 'name=哈哈&tel=13693100472&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=哈哈&isDefault=false&address=哈哈&areaNo=110101&mobile=13693100472&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:39:21', 70, 2001001000, '服务端发生异常', '2019-08-13 15:39:21');
INSERT INTO `access_log` VALUES (66763, '66.50.15656819632327247', 198, 1, 'user-application', '/user-api/users/address/add', 'name=哈哈&tel=13693100472&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=哈哈&isDefault=true&address=哈哈&areaNo=110101&mobile=13693100472&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:39:23', 138, 2001001000, '服务端发生异常', '2019-08-13 15:39:23');
INSERT INTO `access_log` VALUES (66764, '64.83.15656819742029967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-13 15:39:34', 2, 0, '', '2019-08-13 15:39:34');
INSERT INTO `access_log` VALUES (66765, '64.76.15656819743099977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-13 15:39:34', 2, 0, '', '2019-08-13 15:39:34');
INSERT INTO `access_log` VALUES (66766, '65.54.15656820040952431', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:04', 1, 1002001015, '账号未登陆', '2019-08-13 15:40:04');
INSERT INTO `access_log` VALUES (66767, '65.49.15656820040952529', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:04', 0, 1002001015, '账号未登陆', '2019-08-13 15:40:04');
INSERT INTO `access_log` VALUES (66768, '65.3607.15656820040984321', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:04', 0, 1002001015, '账号未登陆', '2019-08-13 15:40:04');
INSERT INTO `access_log` VALUES (66769, '65.50.15656820060542535', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 15:40:06');
INSERT INTO `access_log` VALUES (66770, '65.47.15656820211232495', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:21', 325, 0, '', '2019-08-13 15:40:21');
INSERT INTO `access_log` VALUES (66771, '65.51.15656820216222613', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:22', 11, 2001001000, '服务端发生异常', '2019-08-13 15:40:22');
INSERT INTO `access_log` VALUES (66772, '65.45.15656820216212535', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:22', 15, 0, '', '2019-08-13 15:40:22');
INSERT INTO `access_log` VALUES (66773, '65.46.15656820216252573', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:22', 12, 0, '', '2019-08-13 15:40:22');
INSERT INTO `access_log` VALUES (66774, '65.49.15656820296052531', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:30', 9, 0, '', '2019-08-13 15:40:30');
INSERT INTO `access_log` VALUES (66775, '65.54.15656820296082433', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:30', 9, 2001001000, '服务端发生异常', '2019-08-13 15:40:30');
INSERT INTO `access_log` VALUES (66776, '65.3607.15656820296104323', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:30', 9, 0, '', '2019-08-13 15:40:30');
INSERT INTO `access_log` VALUES (66777, '65.50.15656820304022537', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:30', 9, 0, '', '2019-08-13 15:40:30');
INSERT INTO `access_log` VALUES (66778, '65.52.15656820304032573', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:30', 10, 2001001000, '服务端发生异常', '2019-08-13 15:40:30');
INSERT INTO `access_log` VALUES (66779, '65.47.15656820304032497', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:30', 12, 0, '', '2019-08-13 15:40:30');
INSERT INTO `access_log` VALUES (66780, '65.46.15656820321532575', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:32', 8, 0, '', '2019-08-13 15:40:32');
INSERT INTO `access_log` VALUES (66781, '65.45.15656820321512537', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:32', 11, 0, '', '2019-08-13 15:40:32');
INSERT INTO `access_log` VALUES (66782, '65.51.15656820321512615', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:32', 13, 2001001000, '服务端发生异常', '2019-08-13 15:40:32');
INSERT INTO `access_log` VALUES (66783, '65.53.15656820324002497', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:32', 14, 0, '', '2019-08-13 15:40:32');
INSERT INTO `access_log` VALUES (66784, '65.49.15656820324012533', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:32', 15, 2001001000, '服务端发生异常', '2019-08-13 15:40:32');
INSERT INTO `access_log` VALUES (66785, '65.3607.15656820324034325', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:32', 14, 0, '', '2019-08-13 15:40:32');
INSERT INTO `access_log` VALUES (66786, '65.54.15656820327022435', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:33', 8, 0, '', '2019-08-13 15:40:33');
INSERT INTO `access_log` VALUES (66787, '65.50.15656820327042539', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:33', 8, 2001001000, '服务端发生异常', '2019-08-13 15:40:33');
INSERT INTO `access_log` VALUES (66788, '65.47.15656820327082499', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:33', 8, 0, '', '2019-08-13 15:40:33');
INSERT INTO `access_log` VALUES (66789, '65.52.15656820330592575', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:33', 9, 0, '', '2019-08-13 15:40:33');
INSERT INTO `access_log` VALUES (66790, '65.46.15656820330632577', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:33', 9, 2001001000, '服务端发生异常', '2019-08-13 15:40:33');
INSERT INTO `access_log` VALUES (66791, '65.45.15656820330652539', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:33', 9, 0, '', '2019-08-13 15:40:33');
INSERT INTO `access_log` VALUES (66792, '65.51.15656820370282617', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:37', 9, 0, '', '2019-08-13 15:40:37');
INSERT INTO `access_log` VALUES (66793, '65.3607.15656820370294327', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:37', 10, 2001001000, '服务端发生异常', '2019-08-13 15:40:37');
INSERT INTO `access_log` VALUES (66794, '65.49.15656820370302535', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.195.88.97', '2019-08-13 15:40:37', 9, 0, '', '2019-08-13 15:40:37');
INSERT INTO `access_log` VALUES (66795, '59.72.15656833490409663', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '218.17.161.141', '2019-08-13 16:02:29', 3, 0, '', '2019-08-13 16:02:29');
INSERT INTO `access_log` VALUES (66796, '59.79.15656833490419669', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1159.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '218.17.161.141', '2019-08-13 16:02:29', 10, 2001001000, '服务端发生异常', '2019-08-13 16:02:29');
INSERT INTO `access_log` VALUES (66797, '59.74.15656833926479681', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '218.17.161.141', '2019-08-13 16:03:13', 2, 0, '', '2019-08-13 16:03:13');
INSERT INTO `access_log` VALUES (66798, '59.77.15656833926489653', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '218.17.161.141', '2019-08-13 16:03:13', 12, 2001001000, '服务端发生异常', '2019-08-13 16:03:13');
INSERT INTO `access_log` VALUES (66799, '64.82.15656834000920007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Mobile Safari/537.36', '218.17.161.141', '2019-08-13 16:03:20', 2, 0, '', '2019-08-13 16:03:20');
INSERT INTO `access_log` VALUES (66800, '64.85.15656834002040027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Mobile Safari/537.36', '218.17.161.141', '2019-08-13 16:03:20', 2, 0, '', '2019-08-13 16:03:20');
INSERT INTO `access_log` VALUES (66801, '64.83.15656834053569987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Mobile Safari/537.36', '218.17.161.141', '2019-08-13 16:03:25', 2, 0, '', '2019-08-13 16:03:25');
INSERT INTO `access_log` VALUES (66802, '64.76.15656834054779997', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Mobile Safari/537.36', '218.17.161.141', '2019-08-13 16:03:25', 2, 0, '', '2019-08-13 16:03:25');
INSERT INTO `access_log` VALUES (66803, '64.79.15656834085009999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Mobile Safari/537.36', '218.17.161.141', '2019-08-13 16:03:29', 3, 0, '', '2019-08-13 16:03:29');
INSERT INTO `access_log` VALUES (66804, '64.84.15656834086489989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Mobile Safari/537.36', '218.17.161.141', '2019-08-13 16:03:29', 2, 0, '', '2019-08-13 16:03:29');
INSERT INTO `access_log` VALUES (66805, '59.71.15656834132699665', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Mobile Safari/537.36', '218.17.161.141', '2019-08-13 16:03:33', 2, 0, '', '2019-08-13 16:03:33');
INSERT INTO `access_log` VALUES (66806, '59.75.15656834132699673', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Mobile Safari/537.36', '218.17.161.141', '2019-08-13 16:03:33', 13, 2001001000, '服务端发生异常', '2019-08-13 16:03:33');
INSERT INTO `access_log` VALUES (66807, '64.78.15656834196840001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Mobile Safari/537.36', '218.17.161.141', '2019-08-13 16:03:40', 2, 0, '', '2019-08-13 16:03:40');
INSERT INTO `access_log` VALUES (66808, '64.77.15656834198329987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Mobile Safari/537.36', '218.17.161.141', '2019-08-13 16:03:40', 2, 0, '', '2019-08-13 16:03:40');
INSERT INTO `access_log` VALUES (66809, '59.71.15656854541769693', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.166.10', '2019-08-13 16:37:34', 16, 2001001000, '服务端发生异常', '2019-08-13 16:37:34');
INSERT INTO `access_log` VALUES (66810, '59.78.15656854541769701', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.166.10', '2019-08-13 16:37:34', 10, 0, '', '2019-08-13 16:37:34');
INSERT INTO `access_log` VALUES (66811, '64.84.15656854589040017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.166.10', '2019-08-13 16:37:39', 11, 0, '', '2019-08-13 16:37:39');
INSERT INTO `access_log` VALUES (66812, '64.80.15656854590360029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.166.10', '2019-08-13 16:37:39', 3, 0, '', '2019-08-13 16:37:39');
INSERT INTO `access_log` VALUES (66813, '59.75.15656854609799701', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.166.10', '2019-08-13 16:37:41', 4, 0, '', '2019-08-13 16:37:41');
INSERT INTO `access_log` VALUES (66814, '59.72.15656854609799693', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.166.10', '2019-08-13 16:37:41', 14, 2001001000, '服务端发生异常', '2019-08-13 16:37:41');
INSERT INTO `access_log` VALUES (66815, '65.50.15656854689522589', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.166.10', '2019-08-13 16:37:49', 1, 1002001015, '账号未登陆', '2019-08-13 16:37:49');
INSERT INTO `access_log` VALUES (66816, '65.54.15656854689532485', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.166.10', '2019-08-13 16:37:49', 1, 1002001015, '账号未登陆', '2019-08-13 16:37:49');
INSERT INTO `access_log` VALUES (66817, '65.46.15656854689552623', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.166.10', '2019-08-13 16:37:49', 0, 1002001015, '账号未登陆', '2019-08-13 16:37:49');
INSERT INTO `access_log` VALUES (66818, '65.3607.15656854707834377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.166.10', '2019-08-13 16:37:51', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 16:37:51');
INSERT INTO `access_log` VALUES (66819, '59.74.15656864244899723', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:53:44', 3, 0, '', '2019-08-13 16:53:44');
INSERT INTO `access_log` VALUES (66820, '59.77.15656864244939695', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:53:44', 12, 2001001000, '服务端发生异常', '2019-08-13 16:53:45');
INSERT INTO `access_log` VALUES (66821, '66.49.15656864416917305', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=11111111111', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:54:02', 101, 0, '', '2019-08-13 16:54:02');
INSERT INTO `access_log` VALUES (66822, '66.56.15656864435127321', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:54:04', 225, 0, '', '2019-08-13 16:54:04');
INSERT INTO `access_log` VALUES (66823, '66.51.15656864511407329', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:54:11', 8, 0, '', '2019-08-13 16:54:11');
INSERT INTO `access_log` VALUES (66824, '66.54.15656864527057319', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:54:13', 6, 0, '', '2019-08-13 16:54:13');
INSERT INTO `access_log` VALUES (66825, '66.52.15656864549767305', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:54:15', 5, 0, '', '2019-08-13 16:54:15');
INSERT INTO `access_log` VALUES (66826, '59.79.15656864567699713', 128, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:54:17', 5, 0, '', '2019-08-13 16:54:17');
INSERT INTO `access_log` VALUES (66827, '59.80.15656864567759679', 128, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:54:17', 13, 2001001000, '服务端发生异常', '2019-08-13 16:54:17');
INSERT INTO `access_log` VALUES (66828, '64.79.15656864597810041', 128, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:54:20', 7, 0, '', '2019-08-13 16:54:20');
INSERT INTO `access_log` VALUES (66829, '64.80.15656864598810043', 128, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:54:20', 5, 0, '', '2019-08-13 16:54:20');
INSERT INTO `access_log` VALUES (66830, '64.82.15656864609600051', 128, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:54:21', 6, 0, '', '2019-08-13 16:54:21');
INSERT INTO `access_log` VALUES (66831, '64.81.15656864618780039', 128, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:54:22', 5, 0, '', '2019-08-13 16:54:22');
INSERT INTO `access_log` VALUES (66832, '64.83.15656864624200031', 128, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:54:22', 6, 0, '', '2019-08-13 16:54:22');
INSERT INTO `access_log` VALUES (66833, '64.76.15656864627630041', 128, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:54:23', 4, 0, '', '2019-08-13 16:54:23');
INSERT INTO `access_log` VALUES (66834, '64.79.15656864631630043', 128, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.235.147.110', '2019-08-13 16:54:23', 5, 0, '', '2019-08-13 16:54:23');
INSERT INTO `access_log` VALUES (66835, '65.52.15656868881512641', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.166.10', '2019-08-13 17:01:28', 96, 0, '', '2019-08-13 17:01:28');
INSERT INTO `access_log` VALUES (66836, '65.46.15656868884782643', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.166.10', '2019-08-13 17:01:28', 15, 0, '', '2019-08-13 17:01:28');
INSERT INTO `access_log` VALUES (66837, '65.54.15656868884822505', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.166.10', '2019-08-13 17:01:28', 14, 2001001000, '服务端发生异常', '2019-08-13 17:01:28');
INSERT INTO `access_log` VALUES (66838, '65.50.15656868884892609', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.166.10', '2019-08-13 17:01:28', 11, 0, '', '2019-08-13 17:01:29');
INSERT INTO `access_log` VALUES (66839, '59.74.15656908479849783', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.127.244.10', '2019-08-13 18:07:28', 12, 0, '', '2019-08-13 18:07:28');
INSERT INTO `access_log` VALUES (66840, '59.78.15656908479849775', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.127.244.10', '2019-08-13 18:07:28', 26, 2001001000, '服务端发生异常', '2019-08-13 18:07:28');
INSERT INTO `access_log` VALUES (66841, '59.75.15656908578829775', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:38', 3, 0, '', '2019-08-13 18:07:38');
INSERT INTO `access_log` VALUES (66842, '59.72.15656908578849767', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:38', 18, 2001001000, '服务端发生异常', '2019-08-13 18:07:38');
INSERT INTO `access_log` VALUES (66843, '64.77.15656908624340089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:42', 12, 0, '', '2019-08-13 18:07:42');
INSERT INTO `access_log` VALUES (66844, '64.82.15656908625860111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:43', 3, 0, '', '2019-08-13 18:07:43');
INSERT INTO `access_log` VALUES (66845, '64.85.15656908644770131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:44', 2, 0, '', '2019-08-13 18:07:44');
INSERT INTO `access_log` VALUES (66846, '64.81.15656908664760099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:46', 2, 0, '', '2019-08-13 18:07:46');
INSERT INTO `access_log` VALUES (66847, '64.83.15656908673260091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:47', 2, 0, '', '2019-08-13 18:07:47');
INSERT INTO `access_log` VALUES (66848, '64.76.15656908688100101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:49', 2, 0, '', '2019-08-13 18:07:49');
INSERT INTO `access_log` VALUES (66849, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:49', 7, 0, '', '2019-08-13 18:07:49');
INSERT INTO `access_log` VALUES (66850, '64.84.15656908705800093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:51', 2, 0, '', '2019-08-13 18:07:51');
INSERT INTO `access_log` VALUES (66851, '64.80.15656908706940105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:51', 2, 0, '', '2019-08-13 18:07:51');
INSERT INTO `access_log` VALUES (66852, '64.78.15656908716290105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:52', 2, 0, '', '2019-08-13 18:07:52');
INSERT INTO `access_log` VALUES (66853, '64.77.15656908724030091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:52', 10, 0, '', '2019-08-13 18:07:52');
INSERT INTO `access_log` VALUES (66854, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:52', 11, 0, '', '2019-08-13 18:07:52');
INSERT INTO `access_log` VALUES (66855, '64.82.15656908749600113', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:07:55', 8, 0, '', '2019-08-13 18:07:55');
INSERT INTO `access_log` VALUES (66856, '66.51.15656909084787389', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18538373863&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:08:28', 13, 1001003000, '验证码不存在', '2019-08-13 18:08:28');
INSERT INTO `access_log` VALUES (66857, '66.54.15656909127487379', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18538373863', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:08:33', 95, 0, '', '2019-08-13 18:08:33');
INSERT INTO `access_log` VALUES (66858, '66.52.15656909149847365', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18538373863&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:08:35', 246, 0, '', '2019-08-13 18:08:35');
INSERT INTO `access_log` VALUES (66859, '64.84.15656909349780095', 199, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:08:55', 12, 0, '', '2019-08-13 18:08:55');
INSERT INTO `access_log` VALUES (66860, '66.49.15656909425447367', 199, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:03', 5, 0, '', '2019-08-13 18:09:03');
INSERT INTO `access_log` VALUES (66861, '64.80.15656909447520107', 199, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:05', 9, 0, '', '2019-08-13 18:09:05');
INSERT INTO `access_log` VALUES (66862, '64.82.15656909527230115', 199, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:13', 7, 0, '', '2019-08-13 18:09:13');
INSERT INTO `access_log` VALUES (66863, 'N/A', 199, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:13', 11, 0, '', '2019-08-13 18:09:13');
INSERT INTO `access_log` VALUES (66864, '64.81.15656909549980103', 199, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:15', 4, 0, '', '2019-08-13 18:09:15');
INSERT INTO `access_log` VALUES (66865, '64.76.15656909551790105', 199, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:15', 4, 0, '', '2019-08-13 18:09:15');
INSERT INTO `access_log` VALUES (66866, '66.53.15656909578067365', 199, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:18', 8, 0, '', '2019-08-13 18:09:18');
INSERT INTO `access_log` VALUES (66867, '66.54.15656909688827381', 199, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:29', 6, 0, '', '2019-08-13 18:09:29');
INSERT INTO `access_log` VALUES (66868, '66.52.15656909744387367', 199, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:34', 6, 0, '', '2019-08-13 18:09:34');
INSERT INTO `access_log` VALUES (66869, '66.55.15656909796467347', 199, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:40', 6, 0, '', '2019-08-13 18:09:40');
INSERT INTO `access_log` VALUES (66870, '59.80.15656909810539741', 199, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:41', 5, 0, '', '2019-08-13 18:09:41');
INSERT INTO `access_log` VALUES (66871, '59.79.15656909810539775', 199, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:41', 13, 2001001000, '服务端发生异常', '2019-08-13 18:09:41');
INSERT INTO `access_log` VALUES (66872, '64.80.15656909828090109', 199, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:43', 5, 0, '', '2019-08-13 18:09:43');
INSERT INTO `access_log` VALUES (66873, '64.78.15656909829220109', 199, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:43', 4, 0, '', '2019-08-13 18:09:43');
INSERT INTO `access_log` VALUES (66874, '59.76.15656909853229761', 199, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:45', 5, 0, '', '2019-08-13 18:09:45');
INSERT INTO `access_log` VALUES (66875, '59.73.15656909853279773', 199, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:09:45', 12, 2001001000, '服务端发生异常', '2019-08-13 18:09:45');
INSERT INTO `access_log` VALUES (66876, '59.74.15656910092889787', 199, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:10:09', 7, 0, '', '2019-08-13 18:10:09');
INSERT INTO `access_log` VALUES (66877, '59.71.15656910092949771', 199, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '124.127.244.10', '2019-08-13 18:10:09', 22, 2001001000, '服务端发生异常', '2019-08-13 18:10:09');
INSERT INTO `access_log` VALUES (66878, '65.52.15656926819352719', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.153.76.218', '2019-08-13 18:38:02', 0, 1002001015, '账号未登陆', '2019-08-13 18:38:02');
INSERT INTO `access_log` VALUES (66879, '65.46.15656926819652721', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.153.76.218', '2019-08-13 18:38:02', 0, 1002001015, '账号未登陆', '2019-08-13 18:38:02');
INSERT INTO `access_log` VALUES (66880, '65.54.15656926819682583', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.153.76.218', '2019-08-13 18:38:02', 0, 1002001015, '账号未登陆', '2019-08-13 18:38:02');
INSERT INTO `access_log` VALUES (66881, '65.50.15656926859192687', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.153.76.218', '2019-08-13 18:38:06', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 18:38:06');
INSERT INTO `access_log` VALUES (66882, '65.3607.15656926884464475', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.153.76.218', '2019-08-13 18:38:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 18:38:08');
INSERT INTO `access_log` VALUES (66883, '59.80.15657021368719891', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-13 21:15:37', 9, 0, '', '2019-08-13 21:15:37');
INSERT INTO `access_log` VALUES (66884, '59.79.15657021368729925', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-13 21:15:37', 15, 2001001000, '服务端发生异常', '2019-08-13 21:15:37');
INSERT INTO `access_log` VALUES (66885, '64.83.15657021455130245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-13 21:15:46', 11, 0, '', '2019-08-13 21:15:46');
INSERT INTO `access_log` VALUES (66886, '64.76.15657021456860255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-13 21:15:46', 3, 0, '', '2019-08-13 21:15:46');
INSERT INTO `access_log` VALUES (66887, '64.79.15657021485850257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-13 21:15:49', 2, 0, '', '2019-08-13 21:15:49');
INSERT INTO `access_log` VALUES (66888, '66.54.15657021525937533', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-13 21:15:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-08-13 21:15:53');
INSERT INTO `access_log` VALUES (66889, '64.80.15657021564540259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-13 21:15:56', 2, 0, '', '2019-08-13 21:15:56');
INSERT INTO `access_log` VALUES (66890, '64.78.15657021565640259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-13 21:15:57', 2, 0, '', '2019-08-13 21:15:57');
INSERT INTO `access_log` VALUES (66891, '64.77.15657021648800245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-13 21:16:05', 3, 0, '', '2019-08-13 21:16:05');
INSERT INTO `access_log` VALUES (66892, '64.82.15657021650040267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-13 21:16:05', 2, 0, '', '2019-08-13 21:16:05');
INSERT INTO `access_log` VALUES (66893, '64.81.15657021664880255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-13 21:16:06', 2, 0, '', '2019-08-13 21:16:06');
INSERT INTO `access_log` VALUES (66894, '64.83.15657021673750247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-13 21:16:07', 2, 0, '', '2019-08-13 21:16:07');
INSERT INTO `access_log` VALUES (66895, '59.77.15657021686589909', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-13 21:16:09', 3, 0, '', '2019-08-13 21:16:09');
INSERT INTO `access_log` VALUES (66896, '59.78.15657021686589929', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-13 21:16:09', 15, 2001001000, '服务端发生异常', '2019-08-13 21:16:09');
INSERT INTO `access_log` VALUES (66897, '65.53.15657064012802831', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '183.156.79.114', '2019-08-13 22:26:41', 1, 1002001015, '账号未登陆', '2019-08-13 22:26:41');
INSERT INTO `access_log` VALUES (66898, '65.49.15657064012802867', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '183.156.79.114', '2019-08-13 22:26:41', 0, 1002001015, '账号未登陆', '2019-08-13 22:26:41');
INSERT INTO `access_log` VALUES (66899, '65.3607.15657064012804661', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '183.156.79.114', '2019-08-13 22:26:41', 1, 1002001015, '账号未登陆', '2019-08-13 22:26:41');
INSERT INTO `access_log` VALUES (66900, '65.50.15657064190502873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '183.156.79.114', '2019-08-13 22:26:59', 109, 0, '', '2019-08-13 22:26:59');
INSERT INTO `access_log` VALUES (66901, '65.52.15657064200062903', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '183.156.79.114', '2019-08-13 22:27:00', 23, 0, '', '2019-08-13 22:27:00');
INSERT INTO `access_log` VALUES (66902, '65.47.15657064200002827', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '183.156.79.114', '2019-08-13 22:27:00', 24, 2001001000, '服务端发生异常', '2019-08-13 22:27:00');
INSERT INTO `access_log` VALUES (66903, '65.46.15657064199972905', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '183.156.79.114', '2019-08-13 22:27:00', 35, 0, '', '2019-08-13 22:27:00');
INSERT INTO `access_log` VALUES (66904, '59.76.15657084131839995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.38.22.201', '2019-08-13 23:00:13', 9, 0, '', '2019-08-13 23:00:13');
INSERT INTO `access_log` VALUES (66905, '59.73.15657084131840007', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.38.22.201', '2019-08-13 23:00:13', 15, 2001001000, '服务端发生异常', '2019-08-13 23:00:13');
INSERT INTO `access_log` VALUES (66906, '65.3607.15657090152394697', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-13 23:10:15', 5, 1002001012, '访问令牌已过期', '2019-08-13 23:10:15');
INSERT INTO `access_log` VALUES (66907, '65.54.15657090152402805', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-13 23:10:15', 4, 1002001012, '访问令牌已过期', '2019-08-13 23:10:15');
INSERT INTO `access_log` VALUES (66908, '65.53.15657090152402867', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-13 23:10:15', 7, 1002001012, '访问令牌已过期', '2019-08-13 23:10:15');
INSERT INTO `access_log` VALUES (66909, '65.50.15657090178232909', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-13 23:10:18', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-13 23:10:18');
INSERT INTO `access_log` VALUES (66910, '65.47.15657090287722863', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-13 23:10:29', 90, 0, '', '2019-08-13 23:10:29');
INSERT INTO `access_log` VALUES (66911, '65.46.15657090291352941', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-13 23:10:29', 10, 0, '', '2019-08-13 23:10:29');
INSERT INTO `access_log` VALUES (66912, '65.45.15657090291392911', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-13 23:10:29', 10, 2001001000, '服务端发生异常', '2019-08-13 23:10:29');
INSERT INTO `access_log` VALUES (66913, '65.51.15657090291412989', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-13 23:10:29', 9, 0, '', '2019-08-13 23:10:29');
INSERT INTO `access_log` VALUES (66914, '59.71.15657399583710425', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.1.2.133', '2019-08-14 07:45:58', 13, 0, '', '2019-08-14 07:45:58');
INSERT INTO `access_log` VALUES (66915, '59.72.15657399583740425', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.1.2.133', '2019-08-14 07:45:58', 32, 2001001000, '服务端发生异常', '2019-08-14 07:45:58');
INSERT INTO `access_log` VALUES (66916, '65.46.15657404790833361', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:54:39', 1, 1002001015, '账号未登陆', '2019-08-14 07:54:39');
INSERT INTO `access_log` VALUES (66917, '65.51.15657404790833409', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:54:39', 0, 1002001015, '账号未登陆', '2019-08-14 07:54:39');
INSERT INTO `access_log` VALUES (66918, '65.45.15657404790833331', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:54:39', 0, 1002001015, '账号未登陆', '2019-08-14 07:54:39');
INSERT INTO `access_log` VALUES (66919, '65.49.15657404835843325', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:54:44', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 07:54:44');
INSERT INTO `access_log` VALUES (66920, '65.53.15657404980223289', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:54:58', 73, 0, '', '2019-08-14 07:54:58');
INSERT INTO `access_log` VALUES (66921, '65.54.15657404990243227', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:54:59', 15, 0, '', '2019-08-14 07:54:59');
INSERT INTO `access_log` VALUES (66922, '65.50.15657404990263331', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:54:59', 12, 0, '', '2019-08-14 07:54:59');
INSERT INTO `access_log` VALUES (66923, '65.52.15657404990333361', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:54:59', 11, 0, '', '2019-08-14 07:54:59');
INSERT INTO `access_log` VALUES (66924, '65.51.15657405162223411', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:55:16', 282, 0, '', '2019-08-14 07:55:17');
INSERT INTO `access_log` VALUES (66925, '65.46.15657405162243363', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:55:16', 280, 0, '', '2019-08-14 07:55:17');
INSERT INTO `access_log` VALUES (66926, '65.45.15657405168273333', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:55:17', 9, 0, '', '2019-08-14 07:55:17');
INSERT INTO `access_log` VALUES (66927, '64.82.15657405169220779', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:55:17', 25, 0, '', '2019-08-14 07:55:17');
INSERT INTO `access_log` VALUES (66928, '64.85.15657405169220799', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:55:17', 36, 0, '', '2019-08-14 07:55:17');
INSERT INTO `access_log` VALUES (66929, '65.49.15657405231193327', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36', '203.208.60.113', '2019-08-14 07:55:23', 1, 1002001015, '账号未登陆', '2019-08-14 07:55:23');
INSERT INTO `access_log` VALUES (66930, '65.53.15657405240293291', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36', '203.208.60.113', '2019-08-14 07:55:24', 0, 1002001015, '账号未登陆', '2019-08-14 07:55:24');
INSERT INTO `access_log` VALUES (66931, '65.52.15657405247613363', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36', '203.208.60.115', '2019-08-14 07:55:25', 0, 1002001015, '账号未登陆', '2019-08-14 07:55:25');
INSERT INTO `access_log` VALUES (66932, '65.45.15657406023023335', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:42', 10, 0, '', '2019-08-14 07:56:42');
INSERT INTO `access_log` VALUES (66933, '65.49.15657406023033329', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:42', 10, 0, '', '2019-08-14 07:56:42');
INSERT INTO `access_log` VALUES (66934, '65.3607.15657406023045123', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:42', 10, 0, '', '2019-08-14 07:56:42');
INSERT INTO `access_log` VALUES (66935, '64.77.15657406028570759', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:43', 15, 0, '', '2019-08-14 07:56:43');
INSERT INTO `access_log` VALUES (66936, '64.78.15657406028520773', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:43', 22, 0, '', '2019-08-14 07:56:43');
INSERT INTO `access_log` VALUES (66937, '65.53.15657406085333293', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:49', 8, 0, '', '2019-08-14 07:56:49');
INSERT INTO `access_log` VALUES (66938, '65.52.15657406085403365', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:49', 8, 0, '', '2019-08-14 07:56:49');
INSERT INTO `access_log` VALUES (66939, '65.54.15657406085403231', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:49', 9, 0, '', '2019-08-14 07:56:49');
INSERT INTO `access_log` VALUES (66940, '64.82.15657406091000781', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:49', 11, 0, '', '2019-08-14 07:56:49');
INSERT INTO `access_log` VALUES (66941, '64.85.15657406091000801', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:49', 9, 0, '', '2019-08-14 07:56:49');
INSERT INTO `access_log` VALUES (66942, '65.47.15657406142943289', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:54', 9, 0, '', '2019-08-14 07:56:54');
INSERT INTO `access_log` VALUES (66943, '65.51.15657406142963415', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:54', 9, 0, '', '2019-08-14 07:56:54');
INSERT INTO `access_log` VALUES (66944, '65.46.15657406142943367', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:54', 11, 0, '', '2019-08-14 07:56:54');
INSERT INTO `access_log` VALUES (66945, '64.83.15657406148530761', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:55', 12, 0, '', '2019-08-14 07:56:55');
INSERT INTO `access_log` VALUES (66946, '64.76.15657406148570771', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:56:55', 8, 0, '', '2019-08-14 07:56:55');
INSERT INTO `access_log` VALUES (66947, '65.49.15657406391673331', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:57:19', 8, 0, '', '2019-08-14 07:57:19');
INSERT INTO `access_log` VALUES (66948, '65.45.15657406391653337', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:57:19', 9, 0, '', '2019-08-14 07:57:19');
INSERT INTO `access_log` VALUES (66949, '65.53.15657406391863295', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:57:19', 8, 0, '', '2019-08-14 07:57:19');
INSERT INTO `access_log` VALUES (66950, '65.50.15657406664753337', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:57:46', 8, 0, '', '2019-08-14 07:57:46');
INSERT INTO `access_log` VALUES (66951, '65.47.15657406664793291', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:57:46', 9, 0, '', '2019-08-14 07:57:46');
INSERT INTO `access_log` VALUES (66952, '65.46.15657406664783369', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:57:46', 169, 0, '', '2019-08-14 07:57:47');
INSERT INTO `access_log` VALUES (66953, '59.74.15657406668760451', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:57:47', 18, 0, '', '2019-08-14 07:57:47');
INSERT INTO `access_log` VALUES (66954, '65.3607.15657406760405127', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:57:56', 10, 0, '', '2019-08-14 07:57:56');
INSERT INTO `access_log` VALUES (66955, '65.53.15657406760583297', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:57:56', 9, 0, '', '2019-08-14 07:57:56');
INSERT INTO `access_log` VALUES (66956, '65.45.15657406760603339', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:57:56', 8, 0, '', '2019-08-14 07:57:56');
INSERT INTO `access_log` VALUES (66957, '59.71.15657406763420435', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:57:56', 16, 0, '', '2019-08-14 07:57:56');
INSERT INTO `access_log` VALUES (66958, '65.49.15657406833643333', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:58:03', 11, 0, '', '2019-08-14 07:58:03');
INSERT INTO `access_log` VALUES (66959, '65.54.15657406833653235', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:58:03', 9, 0, '', '2019-08-14 07:58:03');
INSERT INTO `access_log` VALUES (66960, '65.52.15657406833663369', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:58:03', 9, 0, '', '2019-08-14 07:58:03');
INSERT INTO `access_log` VALUES (66961, '59.75.15657406836210443', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:58:04', 16, 0, '', '2019-08-14 07:58:04');
INSERT INTO `access_log` VALUES (66962, '65.50.15657406914003339', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:58:11', 8, 0, '', '2019-08-14 07:58:11');
INSERT INTO `access_log` VALUES (66963, '65.46.15657406914223371', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:58:11', 9, 0, '', '2019-08-14 07:58:11');
INSERT INTO `access_log` VALUES (66964, '65.51.15657406914233419', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:58:11', 9, 0, '', '2019-08-14 07:58:11');
INSERT INTO `access_log` VALUES (66965, '59.80.15657406917080407', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:58:12', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-14 07:58:12');
INSERT INTO `access_log` VALUES (66966, '65.3607.15657407020515129', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:58:22', 9, 0, '', '2019-08-14 07:58:22');
INSERT INTO `access_log` VALUES (66967, '65.53.15657407020543299', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:58:22', 8, 0, '', '2019-08-14 07:58:22');
INSERT INTO `access_log` VALUES (66968, '65.45.15657407020573341', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:58:22', 7, 0, '', '2019-08-14 07:58:22');
INSERT INTO `access_log` VALUES (66969, '65.54.15657407022853237', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:58:22', 53, 0, '', '2019-08-14 07:58:22');
INSERT INTO `access_log` VALUES (66970, '65.45.15657407808993343', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 07:59:41', 73, 0, '', '2019-08-14 07:59:41');
INSERT INTO `access_log` VALUES (66971, '65.53.15657408042053301', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:00:04', 8, 0, '', '2019-08-14 08:00:04');
INSERT INTO `access_log` VALUES (66972, '65.54.15657408042103239', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:00:04', 8, 0, '', '2019-08-14 08:00:04');
INSERT INTO `access_log` VALUES (66973, '65.52.15657408042483373', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:00:04', 8, 0, '', '2019-08-14 08:00:04');
INSERT INTO `access_log` VALUES (66974, '65.49.15657408044953337', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:00:04', 14, 0, '', '2019-08-14 08:00:05');
INSERT INTO `access_log` VALUES (66975, '65.50.15657408167613343', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:00:17', 9, 0, '', '2019-08-14 08:00:17');
INSERT INTO `access_log` VALUES (66976, '65.46.15657408167793375', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:00:17', 9, 0, '', '2019-08-14 08:00:17');
INSERT INTO `access_log` VALUES (66977, '65.51.15657408167953423', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:00:17', 8, 0, '', '2019-08-14 08:00:17');
INSERT INTO `access_log` VALUES (66978, '65.45.15657408169963345', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:00:17', 14, 0, '', '2019-08-14 08:00:17');
INSERT INTO `access_log` VALUES (66979, '65.52.15657408420413375', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:00:42', 8, 0, '', '2019-08-14 08:00:42');
INSERT INTO `access_log` VALUES (66980, '65.54.15657408420913241', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:00:42', 9, 0, '', '2019-08-14 08:00:42');
INSERT INTO `access_log` VALUES (66981, '65.49.15657408421153339', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:00:42', 7, 0, '', '2019-08-14 08:00:42');
INSERT INTO `access_log` VALUES (66982, '62.87.15657408423799229', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:00:42', 28, 0, '', '2019-08-14 08:00:42');
INSERT INTO `access_log` VALUES (66983, '65.50.15657408607203345', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:01:01', 14, 0, '', '2019-08-14 08:01:01');
INSERT INTO `access_log` VALUES (66984, '65.46.15657408607203377', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:01:01', 15, 0, '', '2019-08-14 08:01:01');
INSERT INTO `access_log` VALUES (66985, '65.51.15657408607193425', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:01:01', 15, 0, '', '2019-08-14 08:01:01');
INSERT INTO `access_log` VALUES (66986, '65.3607.15657408743985135', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:01:14', 8, 0, '', '2019-08-14 08:01:14');
INSERT INTO `access_log` VALUES (66987, '65.53.15657408744393305', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:01:14', 9, 0, '', '2019-08-14 08:01:14');
INSERT INTO `access_log` VALUES (66988, '65.52.15657408744433377', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:01:14', 7, 0, '', '2019-08-14 08:01:14');
INSERT INTO `access_log` VALUES (66989, '66.57.15657408746958037', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; ALP-TL00 Build/HUAWEIALP-TL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.136.0.237', '2019-08-14 08:01:15', 18, 0, '', '2019-08-14 08:01:15');
INSERT INTO `access_log` VALUES (66990, '59.72.15657418118650451', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.62.130', '2019-08-14 08:16:52', 3, 0, '', '2019-08-14 08:16:52');
INSERT INTO `access_log` VALUES (66991, '59.71.15657418118650451', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.62.130', '2019-08-14 08:16:52', 17, 2001001000, '服务端发生异常', '2019-08-14 08:16:52');
INSERT INTO `access_log` VALUES (66992, '64.79.15657418140100789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.62.130', '2019-08-14 08:16:54', 3, 0, '', '2019-08-14 08:16:54');
INSERT INTO `access_log` VALUES (66993, '64.84.15657418141190779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.62.130', '2019-08-14 08:16:54', 1, 0, '', '2019-08-14 08:16:54');
INSERT INTO `access_log` VALUES (66994, '64.80.15657418150560791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.62.130', '2019-08-14 08:16:55', 2, 0, '', '2019-08-14 08:16:55');
INSERT INTO `access_log` VALUES (66995, '65.45.15657424599703369', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.152.139.154', '2019-08-14 08:27:40', 1, 1002001015, '账号未登陆', '2019-08-14 08:27:40');
INSERT INTO `access_log` VALUES (66996, '65.3607.15657424599765157', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.152.139.154', '2019-08-14 08:27:40', 0, 1002001015, '账号未登陆', '2019-08-14 08:27:40');
INSERT INTO `access_log` VALUES (66997, '65.53.15657424599763327', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.152.139.154', '2019-08-14 08:27:40', 0, 1002001015, '账号未登陆', '2019-08-14 08:27:40');
INSERT INTO `access_log` VALUES (66998, '65.52.15657424655803399', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.152.139.154', '2019-08-14 08:27:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 08:27:46');
INSERT INTO `access_log` VALUES (66999, '65.54.15657424687353265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.152.139.154', '2019-08-14 08:27:49', 80, 0, '', '2019-08-14 08:27:49');
INSERT INTO `access_log` VALUES (67000, '65.49.15657424692383363', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.152.139.154', '2019-08-14 08:27:49', 10, 0, '', '2019-08-14 08:27:49');
INSERT INTO `access_log` VALUES (67001, '65.47.15657424692493323', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.152.139.154', '2019-08-14 08:27:49', 10, 2001001000, '服务端发生异常', '2019-08-14 08:27:49');
INSERT INTO `access_log` VALUES (67002, '65.46.15657424692533401', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.152.139.154', '2019-08-14 08:27:49', 8, 0, '', '2019-08-14 08:27:49');
INSERT INTO `access_log` VALUES (67003, '65.54.15657425538333267', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.152.139.154', '2019-08-14 08:29:14', 11, 0, '', '2019-08-14 08:29:14');
INSERT INTO `access_log` VALUES (67004, '65.46.15657425538383403', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.152.139.154', '2019-08-14 08:29:14', 10, 2001001000, '服务端发生异常', '2019-08-14 08:29:14');
INSERT INTO `access_log` VALUES (67005, '65.49.15657425538423365', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.152.139.154', '2019-08-14 08:29:14', 9, 0, '', '2019-08-14 08:29:14');
INSERT INTO `access_log` VALUES (67006, '65.52.15657427951113405', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.129.193.10', '2019-08-14 08:33:15', 0, 1002001015, '账号未登陆', '2019-08-14 08:33:15');
INSERT INTO `access_log` VALUES (67007, '65.49.15657427951133369', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.129.193.10', '2019-08-14 08:33:15', 0, 1002001015, '账号未登陆', '2019-08-14 08:33:15');
INSERT INTO `access_log` VALUES (67008, '65.46.15657427951193407', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.129.193.10', '2019-08-14 08:33:15', 0, 1002001015, '账号未登陆', '2019-08-14 08:33:15');
INSERT INTO `access_log` VALUES (67009, '65.51.15657428318973455', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=youdaoyuanma&password=http://admin.shop.iocoder.cn:18099/user/login&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.129.193.10', '2019-08-14 08:33:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 08:33:52');
INSERT INTO `access_log` VALUES (67010, '65.53.15657428489843335', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.129.193.10', '2019-08-14 08:34:09', 69, 0, '', '2019-08-14 08:34:09');
INSERT INTO `access_log` VALUES (67011, '65.45.15657428495833377', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.129.193.10', '2019-08-14 08:34:10', 10, 0, '', '2019-08-14 08:34:10');
INSERT INTO `access_log` VALUES (67012, '65.46.15657428495933409', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.129.193.10', '2019-08-14 08:34:10', 10, 2001001000, '服务端发生异常', '2019-08-14 08:34:10');
INSERT INTO `access_log` VALUES (67013, '65.52.15657428496003407', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.129.193.10', '2019-08-14 08:34:10', 9, 0, '', '2019-08-14 08:34:10');
INSERT INTO `access_log` VALUES (67014, '65.3607.15657430754445169', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.28.132.247', '2019-08-14 08:37:55', 0, 1002001015, '账号未登陆', '2019-08-14 08:37:55');
INSERT INTO `access_log` VALUES (67015, '65.53.15657430754483339', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.28.132.247', '2019-08-14 08:37:55', 0, 1002001015, '账号未登陆', '2019-08-14 08:37:55');
INSERT INTO `access_log` VALUES (67016, '65.52.15657430754523411', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.28.132.247', '2019-08-14 08:37:55', 0, 1002001015, '账号未登陆', '2019-08-14 08:37:55');
INSERT INTO `access_log` VALUES (67017, '65.45.15657430798933381', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.28.132.247', '2019-08-14 08:38:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 08:38:00');
INSERT INTO `access_log` VALUES (67018, '65.46.15657430853013413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.28.132.247', '2019-08-14 08:38:05', 62, 0, '', '2019-08-14 08:38:05');
INSERT INTO `access_log` VALUES (67019, '65.47.15657431163303335', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.28.132.247', '2019-08-14 08:38:36', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 08:38:36');
INSERT INTO `access_log` VALUES (67020, '65.51.15657431167423461', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.28.132.247', '2019-08-14 08:38:37', 0, 1002001015, '账号未登陆', '2019-08-14 08:38:37');
INSERT INTO `access_log` VALUES (67021, '65.50.15657431167483381', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.28.132.247', '2019-08-14 08:38:37', 0, 1002001015, '账号未登陆', '2019-08-14 08:38:37');
INSERT INTO `access_log` VALUES (67022, '65.53.15657431167513341', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.28.132.247', '2019-08-14 08:38:37', 1, 1002001015, '账号未登陆', '2019-08-14 08:38:37');
INSERT INTO `access_log` VALUES (67023, '65.52.15657431184333413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.28.132.247', '2019-08-14 08:38:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 08:38:38');
INSERT INTO `access_log` VALUES (67024, '65.46.15657431384213415', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.28.132.247', '2019-08-14 08:38:58', 80, 0, '', '2019-08-14 08:38:59');
INSERT INTO `access_log` VALUES (67025, '65.49.15657431387513377', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.28.132.247', '2019-08-14 08:38:59', 9, 0, '', '2019-08-14 08:38:59');
INSERT INTO `access_log` VALUES (67026, '65.47.15657431387613337', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.28.132.247', '2019-08-14 08:38:59', 9, 0, '', '2019-08-14 08:38:59');
INSERT INTO `access_log` VALUES (67027, '65.54.15657431387613279', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.28.132.247', '2019-08-14 08:38:59', 9, 2001001000, '服务端发生异常', '2019-08-14 08:38:59');
INSERT INTO `access_log` VALUES (67028, '65.49.15657441536483391', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/4.0.1219.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '117.136.61.124', '2019-08-14 08:55:54', 1, 1002001015, '账号未登陆', '2019-08-14 08:55:54');
INSERT INTO `access_log` VALUES (67029, '65.54.15657441536553293', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/4.0.1219.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '117.136.61.124', '2019-08-14 08:55:54', 0, 1002001015, '账号未登陆', '2019-08-14 08:55:54');
INSERT INTO `access_log` VALUES (67030, '65.47.15657441536563351', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/4.0.1219.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '117.136.61.124', '2019-08-14 08:55:54', 1, 1002001015, '账号未登陆', '2019-08-14 08:55:54');
INSERT INTO `access_log` VALUES (67031, '65.53.15657441595013357', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/4.0.1219.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '117.136.61.124', '2019-08-14 08:56:00', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 08:56:00');
INSERT INTO `access_log` VALUES (67032, '65.3607.15657441840215187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/4.0.1219.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '117.136.61.124', '2019-08-14 08:56:24', 51, 0, '', '2019-08-14 08:56:24');
INSERT INTO `access_log` VALUES (67033, '65.45.15657441846163399', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/4.0.1219.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '117.136.61.124', '2019-08-14 08:56:25', 10, 0, '', '2019-08-14 08:56:25');
INSERT INTO `access_log` VALUES (67034, '65.46.15657441846263431', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/4.0.1219.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '117.136.61.124', '2019-08-14 08:56:25', 11, 2001001000, '服务端发生异常', '2019-08-14 08:56:25');
INSERT INTO `access_log` VALUES (67035, '65.47.15657441846373353', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/4.0.1219.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '117.136.61.124', '2019-08-14 08:56:25', 10, 0, '', '2019-08-14 08:56:25');
INSERT INTO `access_log` VALUES (67036, '65.51.15657448213683487', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '120.229.32.109', '2019-08-14 09:07:01', 0, 1002001015, '账号未登陆', '2019-08-14 09:07:01');
INSERT INTO `access_log` VALUES (67037, '65.53.15657448213713367', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '120.229.32.109', '2019-08-14 09:07:01', 1, 1002001015, '账号未登陆', '2019-08-14 09:07:01');
INSERT INTO `access_log` VALUES (67038, '65.50.15657448213713407', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '120.229.32.109', '2019-08-14 09:07:01', 0, 1002001015, '账号未登陆', '2019-08-14 09:07:01');
INSERT INTO `access_log` VALUES (67039, '65.52.15657448236063439', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '120.229.32.109', '2019-08-14 09:07:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 09:07:04');
INSERT INTO `access_log` VALUES (67040, '65.3607.15657448286685197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '120.229.32.109', '2019-08-14 09:07:09', 96, 0, '', '2019-08-14 09:07:09');
INSERT INTO `access_log` VALUES (67041, '65.46.15657448289793441', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '120.229.32.109', '2019-08-14 09:07:09', 9, 0, '', '2019-08-14 09:07:09');
INSERT INTO `access_log` VALUES (67042, '65.47.15657448289833363', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '120.229.32.109', '2019-08-14 09:07:09', 9, 0, '', '2019-08-14 09:07:09');
INSERT INTO `access_log` VALUES (67043, '65.54.15657448289833305', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '120.229.32.109', '2019-08-14 09:07:09', 8, 2001001000, '服务端发生异常', '2019-08-14 09:07:09');
INSERT INTO `access_log` VALUES (67044, '65.52.15657469886703469', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:09', 0, 1002001015, '账号未登陆', '2019-08-14 09:43:09');
INSERT INTO `access_log` VALUES (67045, '65.50.15657469886703437', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:09', 0, 1002001015, '账号未登陆', '2019-08-14 09:43:09');
INSERT INTO `access_log` VALUES (67046, '65.3607.15657469886725227', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:09', 1, 1002001015, '账号未登陆', '2019-08-14 09:43:09');
INSERT INTO `access_log` VALUES (67047, '59.78.15657469914700529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:11', 17, 0, '', '2019-08-14 09:43:11');
INSERT INTO `access_log` VALUES (67048, '59.77.15657469914730509', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:11', 30, 2001001000, '服务端发生异常', '2019-08-14 09:43:12');
INSERT INTO `access_log` VALUES (67049, '65.47.15657469930823393', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:13', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 09:43:13');
INSERT INTO `access_log` VALUES (67050, '64.83.15657469988680847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:19', 12, 0, '', '2019-08-14 09:43:19');
INSERT INTO `access_log` VALUES (67051, '64.76.15657469989920857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:19', 5, 0, '', '2019-08-14 09:43:19');
INSERT INTO `access_log` VALUES (67052, '64.84.15657470020690849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:22', 2, 0, '', '2019-08-14 09:43:22');
INSERT INTO `access_log` VALUES (67053, '64.80.15657470030520861', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:23', 2, 0, '', '2019-08-14 09:43:23');
INSERT INTO `access_log` VALUES (67054, '59.71.15657470041490521', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:24', 3, 0, '', '2019-08-14 09:43:24');
INSERT INTO `access_log` VALUES (67055, '59.72.15657470041510521', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:24', 19, 2001001000, '服务端发生异常', '2019-08-14 09:43:24');
INSERT INTO `access_log` VALUES (67056, '59.80.15657470154050493', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:35', 2, 0, '', '2019-08-14 09:43:35');
INSERT INTO `access_log` VALUES (67057, '59.79.15657470154050527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:35', 16, 2001001000, '服务端发生异常', '2019-08-14 09:43:35');
INSERT INTO `access_log` VALUES (67058, '66.53.15657470264198115', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:43:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空', '2019-08-14 09:43:46');
INSERT INTO `access_log` VALUES (67059, '66.52.15657470533048119', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18578638326', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:44:13', 89, 0, '', '2019-08-14 09:44:13');
INSERT INTO `access_log` VALUES (67060, '66.48.15657470656848125', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18578638326&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:44:26', 187, 0, '', '2019-08-14 09:44:26');
INSERT INTO `access_log` VALUES (67061, '66.55.15657470715158097', 200, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:44:32', 6, 0, '', '2019-08-14 09:44:32');
INSERT INTO `access_log` VALUES (67062, '66.56.15657470751838135', 200, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:44:35', 6, 0, '', '2019-08-14 09:44:35');
INSERT INTO `access_log` VALUES (67063, '64.76.15657470799590859', 200, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:44:40', 10, 1003002003, 'Spu 只能添加在二级分类下', '2019-08-14 09:44:40');
INSERT INTO `access_log` VALUES (67064, '66.51.15657470969848145', 200, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:44:57', 6, 0, '', '2019-08-14 09:44:57');
INSERT INTO `access_log` VALUES (67065, '59.75.15657470986750531', 200, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:44:59', 8, 0, '', '2019-08-14 09:44:59');
INSERT INTO `access_log` VALUES (67066, '59.80.15657470987030495', 200, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:44:59', 20, 2001001000, '服务端发生异常', '2019-08-14 09:44:59');
INSERT INTO `access_log` VALUES (67067, '64.80.15657471010960863', 200, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:01', 9, 0, '', '2019-08-14 09:45:01');
INSERT INTO `access_log` VALUES (67068, '64.78.15657471012890863', 200, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:01', 7, 0, '', '2019-08-14 09:45:01');
INSERT INTO `access_log` VALUES (67069, '64.82.15657471025930871', 200, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:03', 7, 0, '', '2019-08-14 09:45:03');
INSERT INTO `access_log` VALUES (67070, '64.83.15657471037000851', 200, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:04', 6, 0, '', '2019-08-14 09:45:04');
INSERT INTO `access_log` VALUES (67071, 'N/A', 200, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:05', 11, 0, '', '2019-08-14 09:45:05');
INSERT INTO `access_log` VALUES (67072, 'N/A', 200, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:06', 15, 0, '', '2019-08-14 09:45:06');
INSERT INTO `access_log` VALUES (67073, 'N/A', 200, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:07', 11, 0, '', '2019-08-14 09:45:07');
INSERT INTO `access_log` VALUES (67074, 'N/A', 200, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:07', 14, 0, '', '2019-08-14 09:45:07');
INSERT INTO `access_log` VALUES (67075, '64.84.15657471110450853', 200, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:11', 10, 0, '', '2019-08-14 09:45:11');
INSERT INTO `access_log` VALUES (67076, '59.76.15657471165500515', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.107.99.189', '2019-08-14 09:45:17', 2, 0, '', '2019-08-14 09:45:17');
INSERT INTO `access_log` VALUES (67077, '59.73.15657471165510527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.107.99.189', '2019-08-14 09:45:17', 16, 2001001000, '服务端发生异常', '2019-08-14 09:45:17');
INSERT INTO `access_log` VALUES (67078, '66.50.15657471189368121', 200, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:19', 6, 0, '', '2019-08-14 09:45:19');
INSERT INTO `access_log` VALUES (67079, '66.55.15657471234748099', 200, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:23', 5, 0, '', '2019-08-14 09:45:23');
INSERT INTO `access_log` VALUES (67080, '65.47.15657471290623395', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.107.99.189', '2019-08-14 09:45:29', 0, 1002001015, '账号未登陆', '2019-08-14 09:45:29');
INSERT INTO `access_log` VALUES (67081, '65.54.15657471290673337', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.107.99.189', '2019-08-14 09:45:29', 1, 1002001015, '账号未登陆', '2019-08-14 09:45:29');
INSERT INTO `access_log` VALUES (67082, '65.46.15657471290693473', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.107.99.189', '2019-08-14 09:45:29', 0, 1002001015, '账号未登陆', '2019-08-14 09:45:29');
INSERT INTO `access_log` VALUES (67083, '65.49.15657471307373435', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.107.99.189', '2019-08-14 09:45:31', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 09:45:31');
INSERT INTO `access_log` VALUES (67084, '65.51.15657471347883521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.107.99.189', '2019-08-14 09:45:35', 6, 1002002001, '密码不正确', '2019-08-14 09:45:35');
INSERT INTO `access_log` VALUES (67085, '66.53.15657471495708119', 200, 1, 'user-application', '/user-api/users/address/add', 'name=4&tel=18825146607&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=44&isDefault=true&address=44&areaNo=110101&mobile=18825146607&hasDefault=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:50', 86, 2001001000, '服务端发生异常', '2019-08-14 09:45:50');
INSERT INTO `access_log` VALUES (67086, '66.52.15657471561878123', 200, 1, 'user-application', '/user-api/users/address/add', 'name=东方故事代发工资&tel=18825146607&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=44&isDefault=true&address=44&areaNo=110101&mobile=18825146607&hasDefault=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:56', 76, 2001001000, '服务端发生异常', '2019-08-14 09:45:56');
INSERT INTO `access_log` VALUES (67087, '66.50.15657471586378123', 200, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:59', 6, 0, '', '2019-08-14 09:45:59');
INSERT INTO `access_log` VALUES (67088, '59.77.15657481712510527', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.190.217.109', '2019-08-14 10:02:51', 3, 0, '', '2019-08-14 10:02:51');
INSERT INTO `access_log` VALUES (67089, '59.74.15657481713820555', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.190.217.109', '2019-08-14 10:02:51', 19, 2001001000, '服务端发生异常', '2019-08-14 10:02:51');
INSERT INTO `access_log` VALUES (67090, '64.85.15657482047860907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.190.217.109', '2019-08-14 10:03:25', 2, 0, '', '2019-08-14 10:03:25');
INSERT INTO `access_log` VALUES (67091, '64.82.15657482048950887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.190.217.109', '2019-08-14 10:03:25', 2, 0, '', '2019-08-14 10:03:25');
INSERT INTO `access_log` VALUES (67092, '64.81.15657482058300875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.190.217.109', '2019-08-14 10:03:26', 3, 0, '', '2019-08-14 10:03:26');
INSERT INTO `access_log` VALUES (67093, '64.83.15657482064370867', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.190.217.109', '2019-08-14 10:03:26', 2, 0, '', '2019-08-14 10:03:26');
INSERT INTO `access_log` VALUES (67094, '64.76.15657482067960877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.190.217.109', '2019-08-14 10:03:27', 1, 0, '', '2019-08-14 10:03:27');
INSERT INTO `access_log` VALUES (67095, '65.47.15657489791253421', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '61.140.70.216', '2019-08-14 10:16:19', 1, 1002001015, '账号未登陆', '2019-08-14 10:16:19');
INSERT INTO `access_log` VALUES (67096, '65.51.15657489791243545', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '61.140.70.216', '2019-08-14 10:16:19', 1, 1002001015, '账号未登陆', '2019-08-14 10:16:19');
INSERT INTO `access_log` VALUES (67097, '65.53.15657489791293427', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '61.140.70.216', '2019-08-14 10:16:19', 0, 1002001015, '账号未登陆', '2019-08-14 10:16:19');
INSERT INTO `access_log` VALUES (67098, '65.52.15657489830233499', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '61.140.70.216', '2019-08-14 10:16:23', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 10:16:23');
INSERT INTO `access_log` VALUES (67099, '65.50.15657489907723467', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '61.140.70.216', '2019-08-14 10:16:31', 63, 0, '', '2019-08-14 10:16:31');
INSERT INTO `access_log` VALUES (67100, '65.46.15657489910723503', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '61.140.70.216', '2019-08-14 10:16:31', 14, 0, '', '2019-08-14 10:16:31');
INSERT INTO `access_log` VALUES (67101, '65.45.15657489910803471', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '61.140.70.216', '2019-08-14 10:16:31', 10, 2001001000, '服务端发生异常', '2019-08-14 10:16:31');
INSERT INTO `access_log` VALUES (67102, '65.54.15657489910843365', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '61.140.70.216', '2019-08-14 10:16:31', 11, 0, '', '2019-08-14 10:16:31');
INSERT INTO `access_log` VALUES (67103, '59.74.15657490676390567', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:17:48', 3, 0, '', '2019-08-14 10:17:48');
INSERT INTO `access_log` VALUES (67104, '59.71.15657490676420551', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:17:48', 19, 2001001000, '服务端发生异常', '2019-08-14 10:17:48');
INSERT INTO `access_log` VALUES (67105, '64.76.15657490855280889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:06', 2, 0, '', '2019-08-14 10:18:06');
INSERT INTO `access_log` VALUES (67106, '64.79.15657490856150891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:06', 2, 0, '', '2019-08-14 10:18:06');
INSERT INTO `access_log` VALUES (67107, '59.79.15657490875250557', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:08', 32, 2001001000, '服务端发生异常', '2019-08-14 10:18:08');
INSERT INTO `access_log` VALUES (67108, '59.80.15657490875250523', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:08', 280, 0, '', '2019-08-14 10:18:08');
INSERT INTO `access_log` VALUES (67109, '64.84.15657490914600881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:11', 2, 0, '', '2019-08-14 10:18:11');
INSERT INTO `access_log` VALUES (67110, '64.80.15657490915870893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:12', 2, 0, '', '2019-08-14 10:18:12');
INSERT INTO `access_log` VALUES (67111, '64.77.15657490926940879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:13', 24, 0, '', '2019-08-14 10:18:13');
INSERT INTO `access_log` VALUES (67112, '64.78.15657490933480893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:13', 94, 0, '', '2019-08-14 10:18:13');
INSERT INTO `access_log` VALUES (67113, '64.85.15657490940620921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:14', 2, 0, '', '2019-08-14 10:18:14');
INSERT INTO `access_log` VALUES (67114, '59.76.15657490979660543', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:18', 2, 0, '', '2019-08-14 10:18:18');
INSERT INTO `access_log` VALUES (67115, '59.73.15657490979660555', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:18', 13, 2001001000, '服务端发生异常', '2019-08-14 10:18:18');
INSERT INTO `access_log` VALUES (67116, '64.82.15657490989350901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:19', 2, 0, '', '2019-08-14 10:18:19');
INSERT INTO `access_log` VALUES (67117, '64.81.15657490990240889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:19', 2, 0, '', '2019-08-14 10:18:19');
INSERT INTO `access_log` VALUES (67118, '59.77.15657491002830541', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:20', 3, 0, '', '2019-08-14 10:18:20');
INSERT INTO `access_log` VALUES (67119, '59.74.15657491002860569', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:20', 11, 2001001000, '服务端发生异常', '2019-08-14 10:18:20');
INSERT INTO `access_log` VALUES (67120, '65.46.15657491300203505', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:50', 0, 1002001015, '账号未登陆', '2019-08-14 10:18:50');
INSERT INTO `access_log` VALUES (67121, '65.49.15657491300313465', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:50', 0, 1002001015, '账号未登陆', '2019-08-14 10:18:50');
INSERT INTO `access_log` VALUES (67122, '65.47.15657491300313425', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:50', 0, 1002001015, '账号未登陆', '2019-08-14 10:18:50');
INSERT INTO `access_log` VALUES (67123, '65.53.15657491372473431', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:57', 82, 0, '', '2019-08-14 10:18:57');
INSERT INTO `access_log` VALUES (67124, '65.50.15657491376253471', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:58', 9, 0, '', '2019-08-14 10:18:58');
INSERT INTO `access_log` VALUES (67125, '65.52.15657491376153503', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:58', 135, 0, '', '2019-08-14 10:18:58');
INSERT INTO `access_log` VALUES (67126, '65.3607.15657491376255257', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:18:58', 128, 2001001000, '服务端发生异常', '2019-08-14 10:18:58');
INSERT INTO `access_log` VALUES (67127, '59.75.15657491393830561', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.120.49.20', '2019-08-14 10:18:59', 2, 0, '', '2019-08-14 10:18:59');
INSERT INTO `access_log` VALUES (67128, '59.80.15657491393880525', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '113.120.49.20', '2019-08-14 10:18:59', 12, 2001001000, '服务端发生异常', '2019-08-14 10:18:59');
INSERT INTO `access_log` VALUES (67129, '65.49.15657491644523467', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:19:24', 9, 0, '', '2019-08-14 10:19:24');
INSERT INTO `access_log` VALUES (67130, '65.46.15657491644573507', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:19:24', 10, 2001001000, '服务端发生异常', '2019-08-14 10:19:24');
INSERT INTO `access_log` VALUES (67131, '65.47.15657491644623427', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:19:24', 9, 0, '', '2019-08-14 10:19:24');
INSERT INTO `access_log` VALUES (67132, '65.51.15657491667893551', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:19:27', 9, 0, '', '2019-08-14 10:19:27');
INSERT INTO `access_log` VALUES (67133, '65.53.15657491667933433', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:19:27', 10, 2001001000, '服务端发生异常', '2019-08-14 10:19:27');
INSERT INTO `access_log` VALUES (67134, '65.50.15657491667973473', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '112.65.12.42', '2019-08-14 10:19:27', 9, 0, '', '2019-08-14 10:19:27');
INSERT INTO `access_log` VALUES (67135, '59.78.15657491844520563', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.154.31.201', '2019-08-14 10:19:44', 3, 0, '', '2019-08-14 10:19:44');
INSERT INTO `access_log` VALUES (67136, '59.74.15657491844540571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.154.31.201', '2019-08-14 10:19:44', 19, 2001001000, '服务端发生异常', '2019-08-14 10:19:44');
INSERT INTO `access_log` VALUES (67137, '64.78.15657491869270895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.154.31.201', '2019-08-14 10:19:47', 2, 0, '', '2019-08-14 10:19:47');
INSERT INTO `access_log` VALUES (67138, '64.85.15657491871650923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.154.31.201', '2019-08-14 10:19:47', 2, 0, '', '2019-08-14 10:19:47');
INSERT INTO `access_log` VALUES (67139, '64.82.15657491880890903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.154.31.201', '2019-08-14 10:19:48', 2, 0, '', '2019-08-14 10:19:48');
INSERT INTO `access_log` VALUES (67140, '64.81.15657491885430891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.154.31.201', '2019-08-14 10:19:49', 1, 0, '', '2019-08-14 10:19:49');
INSERT INTO `access_log` VALUES (67141, '59.71.15657491896880555', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.154.31.201', '2019-08-14 10:19:50', 3, 0, '', '2019-08-14 10:19:50');
INSERT INTO `access_log` VALUES (67142, '59.72.15657491896880555', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.154.31.201', '2019-08-14 10:19:50', 15, 2001001000, '服务端发生异常', '2019-08-14 10:19:50');
INSERT INTO `access_log` VALUES (67143, '65.49.15657505296663485', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.42.26.104', '2019-08-14 10:42:10', 0, 1002001015, '账号未登陆', '2019-08-14 10:42:10');
INSERT INTO `access_log` VALUES (67144, '65.51.15657505296663571', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.42.26.104', '2019-08-14 10:42:10', 0, 1002001015, '账号未登陆', '2019-08-14 10:42:10');
INSERT INTO `access_log` VALUES (67145, '65.53.15657505297023453', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.42.26.104', '2019-08-14 10:42:10', 0, 1002001015, '账号未登陆', '2019-08-14 10:42:10');
INSERT INTO `access_log` VALUES (67146, '65.47.15657505359523445', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.42.26.104', '2019-08-14 10:42:16', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 10:42:16');
INSERT INTO `access_log` VALUES (67147, '65.3607.15657505536765279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yidaoyuanma&password=yidaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.42.26.104', '2019-08-14 10:42:34', 6, 1002002000, '账号不存在', '2019-08-14 10:42:34');
INSERT INTO `access_log` VALUES (67148, '65.50.15657505571283493', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.42.26.104', '2019-08-14 10:42:37', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 10:42:37');
INSERT INTO `access_log` VALUES (67149, '65.54.15657505685603391', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.42.26.104', '2019-08-14 10:42:49', 89, 0, '', '2019-08-14 10:42:49');
INSERT INTO `access_log` VALUES (67150, '65.46.15657505689603529', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.42.26.104', '2019-08-14 10:42:49', 75, 0, '', '2019-08-14 10:42:49');
INSERT INTO `access_log` VALUES (67151, '65.49.15657505689693487', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.42.26.104', '2019-08-14 10:42:49', 69, 0, '', '2019-08-14 10:42:49');
INSERT INTO `access_log` VALUES (67152, '65.51.15657505689613573', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.42.26.104', '2019-08-14 10:42:49', 77, 2001001000, '服务端发生异常', '2019-08-14 10:42:49');
INSERT INTO `access_log` VALUES (67153, '65.50.15657515876853509', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.79.158', '2019-08-14 10:59:48', 0, 1002001015, '账号未登陆', '2019-08-14 10:59:48');
INSERT INTO `access_log` VALUES (67154, '65.52.15657515876843541', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.79.158', '2019-08-14 10:59:48', 0, 1002001015, '账号未登陆', '2019-08-14 10:59:48');
INSERT INTO `access_log` VALUES (67155, '65.54.15657515876983405', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.79.158', '2019-08-14 10:59:48', 0, 1002001015, '账号未登陆', '2019-08-14 10:59:48');
INSERT INTO `access_log` VALUES (67156, '65.45.15657515894303513', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.79.158', '2019-08-14 10:59:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 10:59:49');
INSERT INTO `access_log` VALUES (67157, '65.51.15657515949683589', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.79.158', '2019-08-14 10:59:55', 90, 0, '', '2019-08-14 10:59:55');
INSERT INTO `access_log` VALUES (67158, '65.46.15657515952633545', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.79.158', '2019-08-14 10:59:55', 11, 0, '', '2019-08-14 10:59:55');
INSERT INTO `access_log` VALUES (67159, '65.49.15657515952633503', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.79.158', '2019-08-14 10:59:55', 11, 2001001000, '服务端发生异常', '2019-08-14 10:59:55');
INSERT INTO `access_log` VALUES (67160, '65.47.15657515952943461', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.79.158', '2019-08-14 10:59:55', 8, 0, '', '2019-08-14 10:59:55');
INSERT INTO `access_log` VALUES (67161, '65.54.15657516143643407', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.79.158', '2019-08-14 11:00:14', 8, 0, '', '2019-08-14 11:00:14');
INSERT INTO `access_log` VALUES (67162, '65.52.15657516143623543', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.79.158', '2019-08-14 11:00:14', 10, 0, '', '2019-08-14 11:00:14');
INSERT INTO `access_log` VALUES (67163, '65.50.15657516143623511', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.79.158', '2019-08-14 11:00:14', 10, 2001001000, '服务端发生异常', '2019-08-14 11:00:14');
INSERT INTO `access_log` VALUES (67164, '59.71.15657518512810591', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.79.158', '2019-08-14 11:04:11', 10, 0, '', '2019-08-14 11:04:11');
INSERT INTO `access_log` VALUES (67165, '59.77.15657518512800579', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.17.79.158', '2019-08-14 11:04:11', 17, 2001001000, '服务端发生异常', '2019-08-14 11:04:11');
INSERT INTO `access_log` VALUES (67166, '65.51.15657537611333621', 0, 2, 'admin-application', '/admin-api/admins/admin/delete', 'id=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.248.13.142', '2019-08-14 11:36:01', 1, 1002001015, '账号未登陆', '2019-08-14 11:36:01');
INSERT INTO `access_log` VALUES (67167, '59.72.15657542537220623', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:14', 10, 0, '', '2019-08-14 11:44:14');
INSERT INTO `access_log` VALUES (67168, '59.75.15657542537340631', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:14', 12, 2001001000, '服务端发生异常', '2019-08-14 11:44:14');
INSERT INTO `access_log` VALUES (67169, '64.82.15657542588510971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:19', 13, 0, '', '2019-08-14 11:44:19');
INSERT INTO `access_log` VALUES (67170, '64.81.15657542589810959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:19', 3, 0, '', '2019-08-14 11:44:19');
INSERT INTO `access_log` VALUES (67171, '64.76.15657542608100961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:21', 1, 0, '', '2019-08-14 11:44:21');
INSERT INTO `access_log` VALUES (67172, '64.79.15657542615190963', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:22', 1, 0, '', '2019-08-14 11:44:22');
INSERT INTO `access_log` VALUES (67173, '66.53.15657542793948215', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13569516290&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:39', 15, 1001003000, '验证码不存在', '2019-08-14 11:44:39');
INSERT INTO `access_log` VALUES (67174, '66.51.15657542814968243', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13569516290', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:41', 406, 0, '', '2019-08-14 11:44:42');
INSERT INTO `access_log` VALUES (67175, '66.54.15657542836588233', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13569516290&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:44', 197, 0, '', '2019-08-14 11:44:44');
INSERT INTO `access_log` VALUES (67176, '64.78.15657542928170965', 201, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:53', 6, 0, '', '2019-08-14 11:44:53');
INSERT INTO `access_log` VALUES (67177, '64.82.15657542930060973', 201, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:53', 9, 0, '', '2019-08-14 11:44:53');
INSERT INTO `access_log` VALUES (67178, '64.81.15657542938150961', 201, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:54', 6, 0, '', '2019-08-14 11:44:54');
INSERT INTO `access_log` VALUES (67179, '64.76.15657542941920963', 201, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:54', 6, 0, '', '2019-08-14 11:44:54');
INSERT INTO `access_log` VALUES (67180, '64.84.15657542946180955', 201, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:55', 4, 0, '', '2019-08-14 11:44:55');
INSERT INTO `access_log` VALUES (67181, '59.71.15657542954180625', 201, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:55', 7, 0, '', '2019-08-14 11:44:55');
INSERT INTO `access_log` VALUES (67182, '59.74.15657542954050641', 201, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:55', 50, 2001001000, '服务端发生异常', '2019-08-14 11:44:55');
INSERT INTO `access_log` VALUES (67183, '64.80.15657542982630967', 201, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:58', 5, 0, '', '2019-08-14 11:44:58');
INSERT INTO `access_log` VALUES (67184, '64.77.15657542983980953', 201, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:44:58', 5, 0, '', '2019-08-14 11:44:58');
INSERT INTO `access_log` VALUES (67185, '59.72.15657542998570625', 201, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:45:00', 6, 0, '', '2019-08-14 11:45:00');
INSERT INTO `access_log` VALUES (67186, '59.77.15657542998570613', 201, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.158.151.10', '2019-08-14 11:45:00', 19, 2001001000, '服务端发生异常', '2019-08-14 11:45:00');
INSERT INTO `access_log` VALUES (67187, '65.51.15657605822143713', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '183.246.16.29', '2019-08-14 13:29:42', 1, 1002001015, '账号未登陆', '2019-08-14 13:29:42');
INSERT INTO `access_log` VALUES (67188, '65.54.15657605822153527', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '183.246.16.29', '2019-08-14 13:29:42', 1, 1002001015, '账号未登陆', '2019-08-14 13:29:42');
INSERT INTO `access_log` VALUES (67189, '65.45.15657605822363637', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '183.246.16.29', '2019-08-14 13:29:42', 0, 1002001015, '账号未登陆', '2019-08-14 13:29:42');
INSERT INTO `access_log` VALUES (67190, '59.77.15657619207650715', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.94.135.106', '2019-08-14 13:52:01', 9, 0, '', '2019-08-14 13:52:01');
INSERT INTO `access_log` VALUES (67191, '59.72.15657619207640727', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.94.135.106', '2019-08-14 13:52:01', 15, 2001001000, '服务端发生异常', '2019-08-14 13:52:01');
INSERT INTO `access_log` VALUES (67192, '65.51.15657623827763739', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.87.98.122', '2019-08-14 13:59:43', 0, 1002001015, '账号未登陆', '2019-08-14 13:59:43');
INSERT INTO `access_log` VALUES (67193, '65.51.15657625214803741', 0, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'roleIds=&id=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.87.98.122', '2019-08-14 14:02:01', 1, 1002001015, '账号未登陆', '2019-08-14 14:02:01');
INSERT INTO `access_log` VALUES (67194, '65.3607.15657625672225449', 0, 2, 'admin-application', '/admin-api/admins/data_dict/add', 'displayName=男&enumValue=gender&sort=123&value=1&memo=你猜我猜不猜', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.87.98.122', '2019-08-14 14:02:47', 0, 1002001015, '账号未登陆', '2019-08-14 14:02:47');
INSERT INTO `access_log` VALUES (67195, '65.49.15657638913143673', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:24:51', 0, 1002001015, '账号未登陆', '2019-08-14 14:24:51');
INSERT INTO `access_log` VALUES (67196, '65.3607.15657638913155467', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:24:51', 1, 1002001015, '账号未登陆', '2019-08-14 14:24:51');
INSERT INTO `access_log` VALUES (67197, '65.50.15657638913353677', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:24:51', 0, 1002001015, '账号未登陆', '2019-08-14 14:24:51');
INSERT INTO `access_log` VALUES (67198, '65.54.15657653896143597', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:49:50', 1, 1002001015, '账号未登陆', '2019-08-14 14:49:50');
INSERT INTO `access_log` VALUES (67199, '65.45.15657653896143703', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:49:50', 0, 1002001015, '账号未登陆', '2019-08-14 14:49:50');
INSERT INTO `access_log` VALUES (67200, '65.51.15657653896153783', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:49:50', 0, 1002001015, '账号未登陆', '2019-08-14 14:49:50');
INSERT INTO `access_log` VALUES (67201, '65.52.15657653931293733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:49:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 14:49:53');
INSERT INTO `access_log` VALUES (67202, '65.50.15657653964193699', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:49:56', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 14:49:56');
INSERT INTO `access_log` VALUES (67203, '65.46.15657654347973735', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:50:35', 64, 0, '', '2019-08-14 14:50:35');
INSERT INTO `access_log` VALUES (67204, '65.53.15657654351493661', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:50:35', 13, 0, '', '2019-08-14 14:50:35');
INSERT INTO `access_log` VALUES (67205, '65.51.15657654351523785', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:50:35', 14, 2001001000, '服务端发生异常', '2019-08-14 14:50:35');
INSERT INTO `access_log` VALUES (67206, '65.45.15657654351583705', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:50:35', 9, 0, '', '2019-08-14 14:50:35');
INSERT INTO `access_log` VALUES (67207, '65.47.15657654580903655', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:50:58', 9, 0, '', '2019-08-14 14:50:58');
INSERT INTO `access_log` VALUES (67208, '65.50.15657654580953701', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:50:58', 9, 2001001000, '服务端发生异常', '2019-08-14 14:50:58');
INSERT INTO `access_log` VALUES (67209, '65.49.15657654580983699', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:50:58', 21, 0, '', '2019-08-14 14:50:58');
INSERT INTO `access_log` VALUES (67210, '65.46.15657654816923737', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:51:22', 17, 0, '', '2019-08-14 14:51:22');
INSERT INTO `access_log` VALUES (67211, '65.53.15657654816963663', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:51:22', 18, 2001001000, '服务端发生异常', '2019-08-14 14:51:22');
INSERT INTO `access_log` VALUES (67212, '65.45.15657654817093707', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:51:22', 10, 0, '', '2019-08-14 14:51:22');
INSERT INTO `access_log` VALUES (67213, '65.3607.15657655660655493', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:52:46', 8, 0, '', '2019-08-14 14:52:46');
INSERT INTO `access_log` VALUES (67214, '65.45.15657655660693709', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:52:46', 10, 2001001000, '服务端发生异常', '2019-08-14 14:52:46');
INSERT INTO `access_log` VALUES (67215, '65.46.15657655660693739', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:52:46', 11, 0, '', '2019-08-14 14:52:46');
INSERT INTO `access_log` VALUES (67216, '65.54.15657655975673603', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:53:18', 16, 0, '', '2019-08-14 14:53:18');
INSERT INTO `access_log` VALUES (67217, '65.47.15657655975803659', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:53:18', 9, 0, '', '2019-08-14 14:53:18');
INSERT INTO `access_log` VALUES (67218, '65.52.15657655975703739', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:53:18', 9, 2001001000, '服务端发生异常', '2019-08-14 14:53:18');
INSERT INTO `access_log` VALUES (67219, '65.50.15657655984383705', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:53:18', 7, 0, '', '2019-08-14 14:53:18');
INSERT INTO `access_log` VALUES (67220, '65.49.15657655984393703', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:53:18', 8, 2001001000, '服务端发生异常', '2019-08-14 14:53:18');
INSERT INTO `access_log` VALUES (67221, '65.46.15657655984433741', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:53:18', 7, 0, '', '2019-08-14 14:53:18');
INSERT INTO `access_log` VALUES (67222, '65.3607.15657655987785495', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:53:19', 7, 0, '', '2019-08-14 14:53:19');
INSERT INTO `access_log` VALUES (67223, '65.45.15657655987793711', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:53:19', 8, 2001001000, '服务端发生异常', '2019-08-14 14:53:19');
INSERT INTO `access_log` VALUES (67224, '65.53.15657655987823667', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.49.46.29', '2019-08-14 14:53:19', 8, 0, '', '2019-08-14 14:53:19');
INSERT INTO `access_log` VALUES (67225, '65.49.15657656803693705', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:54:40', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 14:54:40');
INSERT INTO `access_log` VALUES (67226, '59.79.15657656973410783', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:54:57', 10, 0, '', '2019-08-14 14:54:57');
INSERT INTO `access_log` VALUES (67227, '59.73.15657656973430781', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:54:57', 15, 2001001000, '服务端发生异常', '2019-08-14 14:54:57');
INSERT INTO `access_log` VALUES (67228, '59.78.15657657016850787', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:55:02', 3, 0, '', '2019-08-14 14:55:02');
INSERT INTO `access_log` VALUES (67229, '59.76.15657657016870769', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:55:02', 11, 2001001000, '服务端发生异常', '2019-08-14 14:55:02');
INSERT INTO `access_log` VALUES (67230, '64.85.15657657175641147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:55:18', 10, 0, '', '2019-08-14 14:55:18');
INSERT INTO `access_log` VALUES (67231, '64.82.15657657176781127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:55:18', 3, 0, '', '2019-08-14 14:55:18');
INSERT INTO `access_log` VALUES (67232, '64.81.15657657186741115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:55:19', 2, 0, '', '2019-08-14 14:55:19');
INSERT INTO `access_log` VALUES (67233, '64.83.15657657190091107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:55:19', 1, 0, '', '2019-08-14 14:55:19');
INSERT INTO `access_log` VALUES (67234, '59.77.15657657197960767', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:55:20', 2, 0, '', '2019-08-14 14:55:20');
INSERT INTO `access_log` VALUES (67235, '59.72.15657657197970779', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:55:20', 13, 2001001000, '服务端发生异常', '2019-08-14 14:55:20');
INSERT INTO `access_log` VALUES (67236, '65.54.15657657421873607', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:55:42', 59, 0, '', '2019-08-14 14:55:42');
INSERT INTO `access_log` VALUES (67237, '65.47.15657657424753663', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:55:42', 9, 0, '', '2019-08-14 14:55:42');
INSERT INTO `access_log` VALUES (67238, '65.52.15657657424773743', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:55:42', 9, 2001001000, '服务端发生异常', '2019-08-14 14:55:42');
INSERT INTO `access_log` VALUES (67239, '65.46.15657657424783745', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.240.229.2', '2019-08-14 14:55:42', 9, 0, '', '2019-08-14 14:55:42');
INSERT INTO `access_log` VALUES (67240, '59.73.15657657457010783', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:55:46', 2, 0, '', '2019-08-14 14:55:46');
INSERT INTO `access_log` VALUES (67241, '59.80.15657657457010751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:55:46', 9, 2001001000, '服务端发生异常', '2019-08-14 14:55:46');
INSERT INTO `access_log` VALUES (67242, '64.80.15657657516321121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:55:52', 3, 0, '', '2019-08-14 14:55:52');
INSERT INTO `access_log` VALUES (67243, '64.77.15657657517311107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:55:52', 2, 0, '', '2019-08-14 14:55:52');
INSERT INTO `access_log` VALUES (67244, '64.78.15657657562741121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:55:56', 2, 0, '', '2019-08-14 14:55:56');
INSERT INTO `access_log` VALUES (67245, '64.85.15657657563951149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:55:56', 2, 0, '', '2019-08-14 14:55:56');
INSERT INTO `access_log` VALUES (67246, '64.82.15657657595851129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:56:00', 2, 0, '', '2019-08-14 14:56:00');
INSERT INTO `access_log` VALUES (67247, '64.81.15657657597071117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:56:00', 1, 0, '', '2019-08-14 14:56:00');
INSERT INTO `access_log` VALUES (67248, '65.45.15657657734953715', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:56:13', 0, 1002001015, '账号未登陆', '2019-08-14 14:56:13');
INSERT INTO `access_log` VALUES (67249, '65.3607.15657657735005499', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:56:14', 1, 1002001015, '账号未登陆', '2019-08-14 14:56:14');
INSERT INTO `access_log` VALUES (67250, '65.53.15657657735083671', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:56:14', 0, 1002001015, '账号未登陆', '2019-08-14 14:56:14');
INSERT INTO `access_log` VALUES (67251, '65.51.15657657754873795', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:56:15', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 14:56:15');
INSERT INTO `access_log` VALUES (67252, '65.54.15657657795953609', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:56:20', 89, 0, '', '2019-08-14 14:56:20');
INSERT INTO `access_log` VALUES (67253, '65.46.15657657799243747', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:56:20', 9, 0, '', '2019-08-14 14:56:20');
INSERT INTO `access_log` VALUES (67254, '65.52.15657657799243745', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:56:20', 10, 0, '', '2019-08-14 14:56:20');
INSERT INTO `access_log` VALUES (67255, '65.47.15657657799243665', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 14:56:20', 11, 2001001000, '服务端发生异常', '2019-08-14 14:56:20');
INSERT INTO `access_log` VALUES (67256, '65.54.15657661666763615', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 15:02:47', 52, 0, '', '2019-08-14 15:02:47');
INSERT INTO `access_log` VALUES (67257, '65.46.15657661666843753', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 15:02:47', 44, 0, '', '2019-08-14 15:02:47');
INSERT INTO `access_log` VALUES (67258, '65.47.15657661666783671', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '123.116.248.194', '2019-08-14 15:02:47', 50, 2001001000, '服务端发生异常', '2019-08-14 15:02:47');
INSERT INTO `access_log` VALUES (67259, '65.49.15657669419153725', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.115.25', '2019-08-14 15:15:42', 0, 1002001015, '账号未登陆', '2019-08-14 15:15:42');
INSERT INTO `access_log` VALUES (67260, '65.45.15657669419163733', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.115.25', '2019-08-14 15:15:42', 1, 1002001015, '账号未登陆', '2019-08-14 15:15:42');
INSERT INTO `access_log` VALUES (67261, '65.3607.15657669419255517', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.115.25', '2019-08-14 15:15:42', 0, 1002001015, '账号未登陆', '2019-08-14 15:15:42');
INSERT INTO `access_log` VALUES (67262, '65.53.15657669464303689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.115.25', '2019-08-14 15:15:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 15:15:46');
INSERT INTO `access_log` VALUES (67263, '65.51.15657669510033813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.115.25', '2019-08-14 15:15:51', 72, 0, '', '2019-08-14 15:15:51');
INSERT INTO `access_log` VALUES (67264, '65.46.15657669516563765', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.115.25', '2019-08-14 15:15:52', 17, 0, '', '2019-08-14 15:15:52');
INSERT INTO `access_log` VALUES (67265, '65.54.15657669516593627', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.115.25', '2019-08-14 15:15:52', 17, 2001001000, '服务端发生异常', '2019-08-14 15:15:52');
INSERT INTO `access_log` VALUES (67266, '65.47.15657669516703683', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.115.25', '2019-08-14 15:15:52', 10, 0, '', '2019-08-14 15:15:52');
INSERT INTO `access_log` VALUES (67267, '65.50.15657669572773729', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.115.25', '2019-08-14 15:15:57', 9, 0, '', '2019-08-14 15:15:57');
INSERT INTO `access_log` VALUES (67268, '65.45.15657669572793735', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.115.25', '2019-08-14 15:15:57', 10, 2001001000, '服务端发生异常', '2019-08-14 15:15:57');
INSERT INTO `access_log` VALUES (67269, '65.49.15657669572823727', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.115.25', '2019-08-14 15:15:57', 8, 0, '', '2019-08-14 15:15:57');
INSERT INTO `access_log` VALUES (67270, '65.3607.15657686719875543', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:44:32', 5, 1002001012, '访问令牌已过期', '2019-08-14 15:44:32');
INSERT INTO `access_log` VALUES (67271, '65.53.15657686719883715', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:44:32', 5, 1002001012, '访问令牌已过期', '2019-08-14 15:44:32');
INSERT INTO `access_log` VALUES (67272, '65.51.15657686719883839', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:44:32', 5, 1002001012, '访问令牌已过期', '2019-08-14 15:44:32');
INSERT INTO `access_log` VALUES (67273, '65.46.15657686738663791', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:44:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 15:44:34');
INSERT INTO `access_log` VALUES (67274, '65.54.15657686785883651', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:44:39', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 15:44:39');
INSERT INTO `access_log` VALUES (67275, '65.52.15657686838523789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:44:44', 5, 1002002001, '密码不正确', '2019-08-14 15:44:44');
INSERT INTO `access_log` VALUES (67276, '65.45.15657686933283761', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:44:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 15:44:53');
INSERT INTO `access_log` VALUES (67277, '65.49.15657687079673755', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:45:08', 82, 0, '', '2019-08-14 15:45:08');
INSERT INTO `access_log` VALUES (67278, '65.53.15657687083213717', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:45:08', 10, 0, '', '2019-08-14 15:45:08');
INSERT INTO `access_log` VALUES (67279, '65.51.15657687083233841', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:45:08', 9, 0, '', '2019-08-14 15:45:08');
INSERT INTO `access_log` VALUES (67280, '65.3607.15657687083225545', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:45:08', 11, 2001001000, '服务端发生异常', '2019-08-14 15:45:08');
INSERT INTO `access_log` VALUES (67281, '59.71.15657687862880821', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:46:26', 10, 0, '', '2019-08-14 15:46:26');
INSERT INTO `access_log` VALUES (67282, '59.74.15657687862920837', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:46:26', 14, 2001001000, '服务端发生异常', '2019-08-14 15:46:26');
INSERT INTO `access_log` VALUES (67283, '64.79.15657687919041161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:46:32', 11, 0, '', '2019-08-14 15:46:32');
INSERT INTO `access_log` VALUES (67284, '64.84.15657687921131151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:46:32', 3, 0, '', '2019-08-14 15:46:32');
INSERT INTO `access_log` VALUES (67285, '64.80.15657687931571163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:46:33', 2, 0, '', '2019-08-14 15:46:33');
INSERT INTO `access_log` VALUES (67286, '64.77.15657687936491149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:46:34', 1, 0, '', '2019-08-14 15:46:34');
INSERT INTO `access_log` VALUES (67287, '64.85.15657688015641191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:46:42', 2, 0, '', '2019-08-14 15:46:42');
INSERT INTO `access_log` VALUES (67288, '64.82.15657688016561171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:46:42', 1, 0, '', '2019-08-14 15:46:42');
INSERT INTO `access_log` VALUES (67289, '59.72.15657688040550821', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:46:44', 3, 0, '', '2019-08-14 15:46:44');
INSERT INTO `access_log` VALUES (67290, '59.75.15657688040560829', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:46:44', 18, 2001001000, '服务端发生异常', '2019-08-14 15:46:44');
INSERT INTO `access_log` VALUES (67291, '64.81.15657688083961159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:46:48', 2, 0, '', '2019-08-14 15:46:48');
INSERT INTO `access_log` VALUES (67292, '64.83.15657688085061151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:46:49', 2, 0, '', '2019-08-14 15:46:49');
INSERT INTO `access_log` VALUES (67293, '64.76.15657688097431161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:46:50', 2, 0, '', '2019-08-14 15:46:50');
INSERT INTO `access_log` VALUES (67294, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:46:50', 6, 0, '', '2019-08-14 15:46:50');
INSERT INTO `access_log` VALUES (67295, '64.84.15657688116361153', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:46:52', 7, 0, '', '2019-08-14 15:46:52');
INSERT INTO `access_log` VALUES (67296, '66.50.15657688444458413', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18350220746&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:47:24', 16, 1001003001, '验证码已过期', '2019-08-14 15:47:24');
INSERT INTO `access_log` VALUES (67297, '66.48.15657688552648419', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18350220746&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:47:35', 8, 1001003001, '验证码已过期', '2019-08-14 15:47:35');
INSERT INTO `access_log` VALUES (67298, '66.55.15657688572358391', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18350220746', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:47:37', 56, 0, '', '2019-08-14 15:47:37');
INSERT INTO `access_log` VALUES (67299, '59.77.15657689108800811', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:48:31', 3, 0, '', '2019-08-14 15:48:31');
INSERT INTO `access_log` VALUES (67300, '59.75.15657689109030831', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '117.30.209.148', '2019-08-14 15:48:31', 12, 2001001000, '服务端发生异常', '2019-08-14 15:48:31');
INSERT INTO `access_log` VALUES (67301, '66.54.15657689249788429', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18467546854', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:48:45', 80, 0, '', '2019-08-14 15:48:45');
INSERT INTO `access_log` VALUES (67302, '66.52.15657689269608415', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18467546854&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:48:47', 201, 0, '', '2019-08-14 15:48:47');
INSERT INTO `access_log` VALUES (67303, '66.48.15657689285418421', 202, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:48:49', 7, 0, '', '2019-08-14 15:48:49');
INSERT INTO `access_log` VALUES (67304, '66.56.15657689462568431', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18350220746', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:06', 78, 0, '', '2019-08-14 15:49:06');
INSERT INTO `access_log` VALUES (67305, '66.57.15657689481588417', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18350220746&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:08', 198, 0, '', '2019-08-14 15:49:08');
INSERT INTO `access_log` VALUES (67306, '66.53.15657689494548413', 38, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:09', 6, 0, '', '2019-08-14 15:49:09');
INSERT INTO `access_log` VALUES (67307, '66.54.15657689687428431', 38, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:29', 5, 0, '', '2019-08-14 15:49:29');
INSERT INTO `access_log` VALUES (67308, '66.52.15657689693768417', 38, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:29', 6, 0, '', '2019-08-14 15:49:29');
INSERT INTO `access_log` VALUES (67309, '66.50.15657689733918417', 38, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:33', 6, 0, '', '2019-08-14 15:49:33');
INSERT INTO `access_log` VALUES (67310, '66.48.15657689751988423', 38, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:35', 6, 0, '', '2019-08-14 15:49:35');
INSERT INTO `access_log` VALUES (67311, '66.55.15657689772538395', 38, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:37', 5, 0, '', '2019-08-14 15:49:37');
INSERT INTO `access_log` VALUES (67312, '66.56.15657689780308433', 38, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:38', 5, 0, '', '2019-08-14 15:49:38');
INSERT INTO `access_log` VALUES (67313, '59.74.15657689830950841', 38, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:43', 7, 0, '', '2019-08-14 15:49:43');
INSERT INTO `access_log` VALUES (67314, '59.77.15657689831180813', 38, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:43', 22, 2001001000, '服务端发生异常', '2019-08-14 15:49:43');
INSERT INTO `access_log` VALUES (67315, '64.78.15657689847871167', 38, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:45', 6, 0, '', '2019-08-14 15:49:45');
INSERT INTO `access_log` VALUES (67316, '64.82.15657689849371175', 38, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:45', 5, 0, '', '2019-08-14 15:49:45');
INSERT INTO `access_log` VALUES (67317, '64.81.15657689864541163', 38, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:46', 4, 0, '', '2019-08-14 15:49:46');
INSERT INTO `access_log` VALUES (67318, 'N/A', 38, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:46', 7, 0, '', '2019-08-14 15:49:46');
INSERT INTO `access_log` VALUES (67319, '64.76.15657689875881165', 38, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:48', 160, 0, '', '2019-08-14 15:49:48');
INSERT INTO `access_log` VALUES (67320, '66.53.15657689893708415', 38, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:49', 6, 0, '', '2019-08-14 15:49:49');
INSERT INTO `access_log` VALUES (67321, '66.52.15657689943418419', 38, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '117.30.209.148', '2019-08-14 15:49:54', 13, 0, '', '2019-08-14 15:49:54');
INSERT INTO `access_log` VALUES (67322, '59.75.15657691351260835', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.35.234.63', '2019-08-14 15:52:15', 4, 0, '', '2019-08-14 15:52:15');
INSERT INTO `access_log` VALUES (67323, '59.72.15657691351260827', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.35.234.63', '2019-08-14 15:52:15', 13, 2001001000, '服务端发生异常', '2019-08-14 15:52:15');
INSERT INTO `access_log` VALUES (67324, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.35.234.63', '2019-08-14 15:52:26', 7, 0, '', '2019-08-14 15:52:26');
INSERT INTO `access_log` VALUES (67325, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.35.234.63', '2019-08-14 15:52:26', 4, 0, '', '2019-08-14 15:52:26');
INSERT INTO `access_log` VALUES (67326, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.35.234.63', '2019-08-14 15:52:26', 10, 0, '', '2019-08-14 15:52:26');
INSERT INTO `access_log` VALUES (67327, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.35.234.63', '2019-08-14 15:52:26', 10, 0, '', '2019-08-14 15:52:26');
INSERT INTO `access_log` VALUES (67328, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.35.234.63', '2019-08-14 15:52:40', 5, 0, '', '2019-08-14 15:52:40');
INSERT INTO `access_log` VALUES (67329, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.35.234.63', '2019-08-14 15:52:45', 5, 0, '', '2019-08-14 15:52:45');
INSERT INTO `access_log` VALUES (67330, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.35.234.63', '2019-08-14 15:52:48', 5, 0, '', '2019-08-14 15:52:48');
INSERT INTO `access_log` VALUES (67331, '59.71.15657722010140869', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:21', 12, 0, '', '2019-08-14 16:43:21');
INSERT INTO `access_log` VALUES (67332, '59.77.15657722010210857', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:21', 21, 2001001000, '服务端发生异常', '2019-08-14 16:43:21');
INSERT INTO `access_log` VALUES (67333, '59.74.15657722089910885', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:29', 4, 0, '', '2019-08-14 16:43:29');
INSERT INTO `access_log` VALUES (67334, '59.75.15657722089950877', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:29', 19, 2001001000, '服务端发生异常', '2019-08-14 16:43:29');
INSERT INTO `access_log` VALUES (67335, '64.85.15657722107921239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:31', 11, 0, '', '2019-08-14 16:43:31');
INSERT INTO `access_log` VALUES (67336, '64.82.15657722110611219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:31', 3, 0, '', '2019-08-14 16:43:31');
INSERT INTO `access_log` VALUES (67337, '64.81.15657722133281207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:33', 2, 0, '', '2019-08-14 16:43:33');
INSERT INTO `access_log` VALUES (67338, '64.83.15657722134221199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:33', 1, 0, '', '2019-08-14 16:43:33');
INSERT INTO `access_log` VALUES (67339, '59.73.15657722142270873', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:34', 2, 0, '', '2019-08-14 16:43:34');
INSERT INTO `access_log` VALUES (67340, '59.80.15657722142310841', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:34', 16, 2001001000, '服务端发生异常', '2019-08-14 16:43:34');
INSERT INTO `access_log` VALUES (67341, '65.54.15657722229123701', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:43', 0, 1002001015, '账号未登陆', '2019-08-14 16:43:43');
INSERT INTO `access_log` VALUES (67342, '65.46.15657722229123841', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:43', 0, 1002001015, '账号未登陆', '2019-08-14 16:43:43');
INSERT INTO `access_log` VALUES (67343, '65.51.15657722229133889', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:43', 0, 1002001015, '账号未登陆', '2019-08-14 16:43:43');
INSERT INTO `access_log` VALUES (67344, '65.52.15657722246433839', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:45', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 16:43:45');
INSERT INTO `access_log` VALUES (67345, '65.47.15657722311983759', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:43:51', 5, 1002002001, '密码不正确', '2019-08-14 16:43:51');
INSERT INTO `access_log` VALUES (67346, '65.49.15657725146763809', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '49.74.235.87', '2019-08-14 16:48:35', 3, 1002001012, '访问令牌已过期', '2019-08-14 16:48:35');
INSERT INTO `access_log` VALUES (67347, '65.47.15657725146763763', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '49.74.235.87', '2019-08-14 16:48:35', 4, 1002001012, '访问令牌已过期', '2019-08-14 16:48:35');
INSERT INTO `access_log` VALUES (67348, '65.45.15657725146763815', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '49.74.235.87', '2019-08-14 16:48:35', 9, 1002001012, '访问令牌已过期', '2019-08-14 16:48:35');
INSERT INTO `access_log` VALUES (67349, '65.50.15657725183793809', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '49.74.235.87', '2019-08-14 16:48:38', 69, 0, '', '2019-08-14 16:48:38');
INSERT INTO `access_log` VALUES (67350, '65.3607.15657725186405597', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '49.74.235.87', '2019-08-14 16:48:39', 10, 0, '', '2019-08-14 16:48:39');
INSERT INTO `access_log` VALUES (67351, '65.53.15657725186423769', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '49.74.235.87', '2019-08-14 16:48:39', 10, 2001001000, '服务端发生异常', '2019-08-14 16:48:39');
INSERT INTO `access_log` VALUES (67352, '65.54.15657725186423707', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '49.74.235.87', '2019-08-14 16:48:39', 10, 0, '', '2019-08-14 16:48:39');
INSERT INTO `access_log` VALUES (67353, '65.45.15657727097573819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:51:50', 71, 0, '', '2019-08-14 16:51:50');
INSERT INTO `access_log` VALUES (67354, '65.47.15657727101093767', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:51:50', 11, 0, '', '2019-08-14 16:51:50');
INSERT INTO `access_log` VALUES (67355, '65.50.15657727101103813', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:51:50', 13, 0, '', '2019-08-14 16:51:50');
INSERT INTO `access_log` VALUES (67356, '65.49.15657727101083813', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:51:50', 16, 2001001000, '服务端发生异常', '2019-08-14 16:51:50');
INSERT INTO `access_log` VALUES (67357, '65.3607.15657727200175601', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:00', 8, 0, '', '2019-08-14 16:52:00');
INSERT INTO `access_log` VALUES (67358, '65.53.15657727200183773', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:00', 9, 2001001000, '服务端发生异常', '2019-08-14 16:52:00');
INSERT INTO `access_log` VALUES (67359, '65.51.15657727200193899', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:00', 8, 0, '', '2019-08-14 16:52:00');
INSERT INTO `access_log` VALUES (67360, '65.46.15657727206863851', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:01', 8, 0, '', '2019-08-14 16:52:01');
INSERT INTO `access_log` VALUES (67361, '65.52.15657727206863849', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:01', 9, 2001001000, '服务端发生异常', '2019-08-14 16:52:01');
INSERT INTO `access_log` VALUES (67362, '65.45.15657727206873821', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:01', 8, 0, '', '2019-08-14 16:52:01');
INSERT INTO `access_log` VALUES (67363, '59.77.15657727289480865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:09', 3, 0, '', '2019-08-14 16:52:09');
INSERT INTO `access_log` VALUES (67364, '59.74.15657727289610893', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:09', 13, 2001001000, '服务端发生异常', '2019-08-14 16:52:09');
INSERT INTO `access_log` VALUES (67365, '64.85.15657727476361247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:28', 3, 0, '', '2019-08-14 16:52:28');
INSERT INTO `access_log` VALUES (67366, '64.82.15657727477541227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:28', 2, 0, '', '2019-08-14 16:52:28');
INSERT INTO `access_log` VALUES (67367, '64.81.15657727530511215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:33', 2, 0, '', '2019-08-14 16:52:33');
INSERT INTO `access_log` VALUES (67368, '64.83.15657727531801207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:33', 2, 0, '', '2019-08-14 16:52:33');
INSERT INTO `access_log` VALUES (67369, '64.76.15657727538771217', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:34', 2, 0, '', '2019-08-14 16:52:34');
INSERT INTO `access_log` VALUES (67370, '64.79.15657727548681219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:35', 2, 0, '', '2019-08-14 16:52:35');
INSERT INTO `access_log` VALUES (67371, '64.84.15657727553001209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:35', 2, 0, '', '2019-08-14 16:52:35');
INSERT INTO `access_log` VALUES (67372, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=adsad&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:37', 6, 0, '', '2019-08-14 16:52:37');
INSERT INTO `access_log` VALUES (67373, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=adsad', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.99.246', '2019-08-14 16:52:38', 5, 0, '', '2019-08-14 16:52:38');
INSERT INTO `access_log` VALUES (67374, '65.53.15657735179993785', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.68.65.77', '2019-08-14 17:05:18', 0, 1002001015, '账号未登陆', '2019-08-14 17:05:18');
INSERT INTO `access_log` VALUES (67375, '65.49.15657735180083827', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.68.65.77', '2019-08-14 17:05:18', 1, 1002001015, '账号未登陆', '2019-08-14 17:05:18');
INSERT INTO `access_log` VALUES (67376, '65.45.15657735180213833', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.68.65.77', '2019-08-14 17:05:18', 0, 1002001015, '账号未登陆', '2019-08-14 17:05:18');
INSERT INTO `access_log` VALUES (67377, '59.73.15657735295570891', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.153.59.249', '2019-08-14 17:05:30', 3, 0, '', '2019-08-14 17:05:30');
INSERT INTO `access_log` VALUES (67378, '59.79.15657735295630893', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.153.59.249', '2019-08-14 17:05:30', 12, 2001001000, '服务端发生异常', '2019-08-14 17:05:30');
INSERT INTO `access_log` VALUES (67379, '64.85.15657735371921259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.153.59.249', '2019-08-14 17:05:37', 3, 0, '', '2019-08-14 17:05:37');
INSERT INTO `access_log` VALUES (67380, '64.82.15657735378011239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.153.59.249', '2019-08-14 17:05:38', 2, 0, '', '2019-08-14 17:05:38');
INSERT INTO `access_log` VALUES (67381, '64.81.15657735427391227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.153.59.249', '2019-08-14 17:05:43', 2, 0, '', '2019-08-14 17:05:43');
INSERT INTO `access_log` VALUES (67382, '64.83.15657735434591219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.153.59.249', '2019-08-14 17:05:43', 2, 0, '', '2019-08-14 17:05:43');
INSERT INTO `access_log` VALUES (67383, '65.50.15657735439183827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.68.65.77', '2019-08-14 17:05:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 17:05:44');
INSERT INTO `access_log` VALUES (67384, '65.3607.15657735552385613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.68.65.77', '2019-08-14 17:05:55', 88, 0, '', '2019-08-14 17:05:55');
INSERT INTO `access_log` VALUES (67385, '65.52.15657735558833863', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.68.65.77', '2019-08-14 17:05:56', 9, 0, '', '2019-08-14 17:05:56');
INSERT INTO `access_log` VALUES (67386, '65.46.15657735558913865', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.68.65.77', '2019-08-14 17:05:56', 10, 2001001000, '服务端发生异常', '2019-08-14 17:05:56');
INSERT INTO `access_log` VALUES (67387, '65.53.15657735559303787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.68.65.77', '2019-08-14 17:05:56', 9, 0, '', '2019-08-14 17:05:56');
INSERT INTO `access_log` VALUES (67388, '64.79.15657735594791231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.153.59.249', '2019-08-14 17:05:59', 2, 0, '', '2019-08-14 17:05:59');
INSERT INTO `access_log` VALUES (67389, '64.84.15657735604061221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.153.59.249', '2019-08-14 17:06:00', 2, 0, '', '2019-08-14 17:06:00');
INSERT INTO `access_log` VALUES (67390, '59.74.15657737166330907', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.153.59.249', '2019-08-14 17:08:37', 3, 0, '', '2019-08-14 17:08:37');
INSERT INTO `access_log` VALUES (67391, '59.77.15657737166330879', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.153.59.249', '2019-08-14 17:08:37', 17, 2001001000, '服务端发生异常', '2019-08-14 17:08:37');
INSERT INTO `access_log` VALUES (67392, '59.80.15657737522950863', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '103.218.216.101', '2019-08-14 17:09:12', 3, 0, '', '2019-08-14 17:09:12');
INSERT INTO `access_log` VALUES (67393, '59.73.15657737522990895', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '103.218.216.101', '2019-08-14 17:09:12', 14, 2001001000, '服务端发生异常', '2019-08-14 17:09:12');
INSERT INTO `access_log` VALUES (67394, '64.85.15657737560341263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '103.218.216.101', '2019-08-14 17:09:16', 3, 0, '', '2019-08-14 17:09:16');
INSERT INTO `access_log` VALUES (67395, '64.82.15657737561741243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '103.218.216.101', '2019-08-14 17:09:16', 2, 0, '', '2019-08-14 17:09:16');
INSERT INTO `access_log` VALUES (67396, '64.81.15657737588191231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '103.218.216.101', '2019-08-14 17:09:19', 2, 0, '', '2019-08-14 17:09:19');
INSERT INTO `access_log` VALUES (67397, '64.83.15657737592611223', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '103.218.216.101', '2019-08-14 17:09:19', 2, 0, '', '2019-08-14 17:09:19');
INSERT INTO `access_log` VALUES (67398, '64.76.15657737596661233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '103.218.216.101', '2019-08-14 17:09:20', 2, 0, '', '2019-08-14 17:09:20');
INSERT INTO `access_log` VALUES (67399, '65.53.15657742983513797', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.186.227.106', '2019-08-14 17:18:18', 1, 1002001015, '账号未登陆', '2019-08-14 17:18:18');
INSERT INTO `access_log` VALUES (67400, '65.45.15657742983523845', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.186.227.106', '2019-08-14 17:18:18', 1, 1002001015, '账号未登陆', '2019-08-14 17:18:18');
INSERT INTO `access_log` VALUES (67401, '65.49.15657742983623839', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.186.227.106', '2019-08-14 17:18:18', 1, 1002001015, '账号未登陆', '2019-08-14 17:18:18');
INSERT INTO `access_log` VALUES (67402, '65.45.15657753202563859', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-14 17:35:20', 1, 1002001015, '账号未登陆', '2019-08-14 17:35:20');
INSERT INTO `access_log` VALUES (67403, '65.49.15657753202563853', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-14 17:35:20', 0, 1002001015, '账号未登陆', '2019-08-14 17:35:20');
INSERT INTO `access_log` VALUES (67404, '65.51.15657753202633937', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-14 17:35:20', 0, 1002001015, '账号未登陆', '2019-08-14 17:35:20');
INSERT INTO `access_log` VALUES (67405, '65.50.15657753241293853', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-14 17:35:24', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 17:35:24');
INSERT INTO `access_log` VALUES (67406, '65.54.15657753266163749', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-14 17:35:27', 79, 0, '', '2019-08-14 17:35:27');
INSERT INTO `access_log` VALUES (67407, '65.3607.15657753269335639', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-14 17:35:27', 17, 0, '', '2019-08-14 17:35:27');
INSERT INTO `access_log` VALUES (67408, '65.46.15657753269393891', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-14 17:35:27', 9, 0, '', '2019-08-14 17:35:27');
INSERT INTO `access_log` VALUES (67409, '65.52.15657753269383889', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-14 17:35:27', 17, 2001001000, '服务端发生异常', '2019-08-14 17:35:27');
INSERT INTO `access_log` VALUES (67410, '59.77.15657781791350939', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:22:59', 10, 0, '', '2019-08-14 18:22:59');
INSERT INTO `access_log` VALUES (67411, '59.75.15657781791360959', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:22:59', 15, 2001001000, '服务端发生异常', '2019-08-14 18:22:59');
INSERT INTO `access_log` VALUES (67412, '64.85.15657781851111323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:05', 10, 0, '', '2019-08-14 18:23:05');
INSERT INTO `access_log` VALUES (67413, '64.82.15657781854861303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:05', 3, 0, '', '2019-08-14 18:23:05');
INSERT INTO `access_log` VALUES (67414, '64.83.15657781874421283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:07', 2, 0, '', '2019-08-14 18:23:07');
INSERT INTO `access_log` VALUES (67415, '64.76.15657781879911293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:08', 1, 0, '', '2019-08-14 18:23:08');
INSERT INTO `access_log` VALUES (67416, '64.79.15657781927551295', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:13', 2, 0, '', '2019-08-14 18:23:13');
INSERT INTO `access_log` VALUES (67417, '64.84.15657781929201285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:13', 1, 0, '', '2019-08-14 18:23:13');
INSERT INTO `access_log` VALUES (67418, '59.80.15657781975580923', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:18', 3, 0, '', '2019-08-14 18:23:18');
INSERT INTO `access_log` VALUES (67419, '59.73.15657781975580955', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:18', 13, 2001001000, '服务端发生异常', '2019-08-14 18:23:18');
INSERT INTO `access_log` VALUES (67420, '64.77.15657782019061283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:22', 1, 0, '', '2019-08-14 18:23:22');
INSERT INTO `access_log` VALUES (67421, '64.78.15657782020111297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:22', 2, 0, '', '2019-08-14 18:23:22');
INSERT INTO `access_log` VALUES (67422, '59.76.15657782040330943', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:24', 2, 0, '', '2019-08-14 18:23:24');
INSERT INTO `access_log` VALUES (67423, '59.78.15657782040340961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:24', 13, 2001001000, '服务端发生异常', '2019-08-14 18:23:24');
INSERT INTO `access_log` VALUES (67424, '64.85.15657782071011325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:27', 2, 0, '', '2019-08-14 18:23:27');
INSERT INTO `access_log` VALUES (67425, '64.81.15657782071991293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:27', 2, 0, '', '2019-08-14 18:23:27');
INSERT INTO `access_log` VALUES (67426, '65.51.15657782152813977', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:35', 4, 1002001012, '访问令牌已过期', '2019-08-14 18:23:35');
INSERT INTO `access_log` VALUES (67427, '65.45.15657782152813899', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:35', 4, 1002001012, '访问令牌已过期', '2019-08-14 18:23:35');
INSERT INTO `access_log` VALUES (67428, '65.47.15657782152833847', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:35', 5, 1002001012, '访问令牌已过期', '2019-08-14 18:23:35');
INSERT INTO `access_log` VALUES (67429, '65.50.15657782182073893', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:38', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 18:23:38');
INSERT INTO `access_log` VALUES (67430, '65.46.15657782271773931', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:47', 108, 0, '', '2019-08-14 18:23:47');
INSERT INTO `access_log` VALUES (67431, '65.52.15657782276063929', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:48', 10, 0, '', '2019-08-14 18:23:48');
INSERT INTO `access_log` VALUES (67432, '65.3607.15657782276125679', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:48', 10, 2001001000, '服务端发生异常', '2019-08-14 18:23:48');
INSERT INTO `access_log` VALUES (67433, '65.53.15657782276333853', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:23:48', 191, 0, '', '2019-08-14 18:23:48');
INSERT INTO `access_log` VALUES (67434, '65.47.15657782502553849', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:24:10', 10, 0, '', '2019-08-14 18:24:10');
INSERT INTO `access_log` VALUES (67435, '65.51.15657782502813979', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:24:10', 10, 2001001000, '服务端发生异常', '2019-08-14 18:24:10');
INSERT INTO `access_log` VALUES (67436, '65.50.15657782503013895', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.6.135.142', '2019-08-14 18:24:10', 9, 0, '', '2019-08-14 18:24:10');
INSERT INTO `access_log` VALUES (67437, '65.52.15657877402334057', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.5.29.220', '2019-08-14 21:02:20', 1, 1002001015, '账号未登陆', '2019-08-14 21:02:20');
INSERT INTO `access_log` VALUES (67438, '65.3607.15657877402335807', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.5.29.220', '2019-08-14 21:02:20', 0, 1002001015, '账号未登陆', '2019-08-14 21:02:20');
INSERT INTO `access_log` VALUES (67439, '65.53.15657877402333981', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.5.29.220', '2019-08-14 21:02:20', 0, 1002001015, '账号未登陆', '2019-08-14 21:02:20');
INSERT INTO `access_log` VALUES (67440, '65.45.15657877574754029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.5.29.220', '2019-08-14 21:02:37', 124, 0, '', '2019-08-14 21:02:38');
INSERT INTO `access_log` VALUES (67441, '65.47.15657877579073977', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.5.29.220', '2019-08-14 21:02:38', 108, 0, '', '2019-08-14 21:02:38');
INSERT INTO `access_log` VALUES (67442, '65.50.15657877579194023', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.5.29.220', '2019-08-14 21:02:38', 97, 0, '', '2019-08-14 21:02:38');
INSERT INTO `access_log` VALUES (67443, '65.51.15657877579144107', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.5.29.220', '2019-08-14 21:02:38', 103, 2001001000, '服务端发生异常', '2019-08-14 21:02:38');
INSERT INTO `access_log` VALUES (67444, '59.80.15657886327451063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.31.210.251', '2019-08-14 21:17:13', 10, 0, '', '2019-08-14 21:17:13');
INSERT INTO `access_log` VALUES (67445, '59.73.15657886327541095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.31.210.251', '2019-08-14 21:17:13', 18, 2001001000, '服务端发生异常', '2019-08-14 21:17:13');
INSERT INTO `access_log` VALUES (67446, '64.80.15657886389811437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.31.210.251', '2019-08-14 21:17:19', 11, 0, '', '2019-08-14 21:17:19');
INSERT INTO `access_log` VALUES (67447, '64.77.15657886391361423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.31.210.251', '2019-08-14 21:17:19', 3, 0, '', '2019-08-14 21:17:19');
INSERT INTO `access_log` VALUES (67448, '64.85.15657886429191465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.31.210.251', '2019-08-14 21:17:23', 2, 0, '', '2019-08-14 21:17:23');
INSERT INTO `access_log` VALUES (67449, '64.81.15657886430531433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.31.210.251', '2019-08-14 21:17:23', 1, 0, '', '2019-08-14 21:17:23');
INSERT INTO `access_log` VALUES (67450, '59.78.15657886442381101', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.31.210.251', '2019-08-14 21:17:24', 3, 0, '', '2019-08-14 21:17:24');
INSERT INTO `access_log` VALUES (67451, '59.76.15657886442431083', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '112.31.210.251', '2019-08-14 21:17:24', 15, 2001001000, '服务端发生异常', '2019-08-14 21:17:24');
INSERT INTO `access_log` VALUES (67452, '59.72.15657894613061103', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.212.50', '2019-08-14 21:31:01', 2, 0, '', '2019-08-14 21:31:01');
INSERT INTO `access_log` VALUES (67453, '59.73.15657894613071107', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.212.50', '2019-08-14 21:31:01', 10, 2001001000, '服务端发生异常', '2019-08-14 21:31:01');
INSERT INTO `access_log` VALUES (67454, '64.83.15657895666621437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.212.50', '2019-08-14 21:32:47', 2, 0, '', '2019-08-14 21:32:47');
INSERT INTO `access_log` VALUES (67455, '64.76.15657895668051447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.212.50', '2019-08-14 21:32:47', 2, 0, '', '2019-08-14 21:32:47');
INSERT INTO `access_log` VALUES (67456, '64.79.15657895681151449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.212.50', '2019-08-14 21:32:48', 1, 0, '', '2019-08-14 21:32:48');
INSERT INTO `access_log` VALUES (67457, '64.84.15657895687041439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.212.50', '2019-08-14 21:32:49', 1, 0, '', '2019-08-14 21:32:49');
INSERT INTO `access_log` VALUES (67458, '59.72.15657895694221105', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.212.50', '2019-08-14 21:32:49', 3, 0, '', '2019-08-14 21:32:49');
INSERT INTO `access_log` VALUES (67459, '59.73.15657895694671109', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.212.50', '2019-08-14 21:32:49', 12, 2001001000, '服务端发生异常', '2019-08-14 21:32:49');
INSERT INTO `access_log` VALUES (67460, '59.73.15657924144731147', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '171.40.219.104', '2019-08-14 22:20:14', 10, 0, '', '2019-08-14 22:20:14');
INSERT INTO `access_log` VALUES (67461, '59.80.15657924144731115', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '171.40.219.104', '2019-08-14 22:20:14', 21, 2001001000, '服务端发生异常', '2019-08-14 22:20:14');
INSERT INTO `access_log` VALUES (67462, '65.53.15657924314424045', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '171.40.219.104', '2019-08-14 22:20:31', 1, 1002001015, '账号未登陆', '2019-08-14 22:20:31');
INSERT INTO `access_log` VALUES (67463, '65.3607.15657924314415871', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '171.40.219.104', '2019-08-14 22:20:31', 1, 1002001015, '账号未登陆', '2019-08-14 22:20:31');
INSERT INTO `access_log` VALUES (67464, '65.52.15657924314624121', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '171.40.219.104', '2019-08-14 22:20:31', 0, 1002001015, '账号未登陆', '2019-08-14 22:20:31');
INSERT INTO `access_log` VALUES (67465, '65.49.15657924339784087', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '171.40.219.104', '2019-08-14 22:20:34', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 22:20:34');
INSERT INTO `access_log` VALUES (67466, '65.49.15657926826794091', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:24:43', 1398, 1002001012, '访问令牌已过期', '2019-08-14 22:24:44');
INSERT INTO `access_log` VALUES (67467, '65.52.15657926826714125', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:24:43', 1407, 1002001012, '访问令牌已过期', '2019-08-14 22:24:44');
INSERT INTO `access_log` VALUES (67468, '65.53.15657926826734049', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:24:43', 1405, 1002001012, '访问令牌已过期', '2019-08-14 22:24:44');
INSERT INTO `access_log` VALUES (67469, '65.45.15657926860314097', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:24:46', 200, 0, '', '2019-08-14 22:24:46');
INSERT INTO `access_log` VALUES (67470, '65.51.15657926864484175', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:24:46', 415, 0, '', '2019-08-14 22:24:47');
INSERT INTO `access_log` VALUES (67471, '65.50.15657926864484091', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:24:46', 415, 0, '', '2019-08-14 22:24:47');
INSERT INTO `access_log` VALUES (67472, '65.47.15657926864554045', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:24:46', 409, 0, '', '2019-08-14 22:24:47');
INSERT INTO `access_log` VALUES (67473, '64.84.15657926906611481', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:24:51', 113, 0, '', '2019-08-14 22:24:51');
INSERT INTO `access_log` VALUES (67474, '64.80.15657926922961493', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:24:52', 13, 0, '', '2019-08-14 22:24:52');
INSERT INTO `access_log` VALUES (67475, '64.77.15657926922971479', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:24:52', 16, 0, '', '2019-08-14 22:24:52');
INSERT INTO `access_log` VALUES (67476, '64.85.15657927023041521', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:25:02', 13, 0, '', '2019-08-14 22:25:02');
INSERT INTO `access_log` VALUES (67477, '64.78.15657927023041493', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:25:02', 15, 0, '', '2019-08-14 22:25:02');
INSERT INTO `access_log` VALUES (67478, '64.83.15657927049021481', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:25:05', 1756, 0, '', '2019-08-14 22:25:07');
INSERT INTO `access_log` VALUES (67479, '64.81.15657927049001489', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:25:05', 1762, 0, '', '2019-08-14 22:25:07');
INSERT INTO `access_log` VALUES (67480, '64.82.15657927049021501', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:25:05', 1777, 0, '', '2019-08-14 22:25:07');
INSERT INTO `access_log` VALUES (67481, '65.53.15657927518224051', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:25:52', 11, 0, '', '2019-08-14 22:25:52');
INSERT INTO `access_log` VALUES (67482, '65.52.15657927518234127', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:25:52', 11, 0, '', '2019-08-14 22:25:52');
INSERT INTO `access_log` VALUES (67483, '65.45.15657927518264099', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:25:52', 10, 0, '', '2019-08-14 22:25:52');
INSERT INTO `access_log` VALUES (67484, '64.85.15657927520001523', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:25:52', 17, 0, '', '2019-08-14 22:25:52');
INSERT INTO `access_log` VALUES (67485, '64.78.15657927520021495', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:25:52', 18, 0, '', '2019-08-14 22:25:52');
INSERT INTO `access_log` VALUES (67486, '64.80.15657927519971495', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:25:52', 23, 0, '', '2019-08-14 22:25:52');
INSERT INTO `access_log` VALUES (67487, '65.47.15657927819704047', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-14 22:26:22', 1, 1002001015, '账号未登陆', '2019-08-14 22:26:22');
INSERT INTO `access_log` VALUES (67488, '65.54.15657927819753989', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-14 22:26:22', 0, 1002001015, '账号未登陆', '2019-08-14 22:26:22');
INSERT INTO `access_log` VALUES (67489, '65.46.15657927819754131', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-14 22:26:22', 0, 1002001015, '账号未登陆', '2019-08-14 22:26:22');
INSERT INTO `access_log` VALUES (67490, '65.49.15657927841514095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-14 22:26:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 22:26:24');
INSERT INTO `access_log` VALUES (67491, '65.45.15657927926884101', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-14 22:26:33', 4, 1002002001, '密码不正确', '2019-08-14 22:26:33');
INSERT INTO `access_log` VALUES (67492, '59.72.15657928167461149', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:26:57', 10, 0, '', '2019-08-14 22:26:57');
INSERT INTO `access_log` VALUES (67493, '59.80.15657928167471121', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:26:57', 19, 2001001000, '服务端发生异常', '2019-08-14 22:26:57');
INSERT INTO `access_log` VALUES (67494, '64.79.15657928223411495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:27:02', 3, 0, '', '2019-08-14 22:27:02');
INSERT INTO `access_log` VALUES (67495, '64.84.15657928224421485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:27:02', 2, 0, '', '2019-08-14 22:27:02');
INSERT INTO `access_log` VALUES (67496, '64.77.15657928235451483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:27:04', 2, 0, '', '2019-08-14 22:27:04');
INSERT INTO `access_log` VALUES (67497, '64.80.15657928240971497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:27:04', 2, 0, '', '2019-08-14 22:27:04');
INSERT INTO `access_log` VALUES (67498, '59.79.15657928255791155', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:27:06', 2, 0, '', '2019-08-14 22:27:06');
INSERT INTO `access_log` VALUES (67499, '59.76.15657928255801141', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:27:06', 14, 2001001000, '服务端发生异常', '2019-08-14 22:27:06');
INSERT INTO `access_log` VALUES (67500, '59.71.15657928274061151', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:27:07', 3, 0, '', '2019-08-14 22:27:07');
INSERT INTO `access_log` VALUES (67501, '59.78.15657928274061159', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:27:07', 12, 2001001000, '服务端发生异常', '2019-08-14 22:27:07');
INSERT INTO `access_log` VALUES (67502, '64.85.15657928305721525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:27:11', 2, 0, '', '2019-08-14 22:27:11');
INSERT INTO `access_log` VALUES (67503, '64.76.15657928309171495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:27:11', 2, 0, '', '2019-08-14 22:27:11');
INSERT INTO `access_log` VALUES (67504, '65.47.15657928549604049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-14 22:27:35', 72, 0, '', '2019-08-14 22:27:35');
INSERT INTO `access_log` VALUES (67505, '65.54.15657928555493991', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-14 22:27:36', 9, 0, '', '2019-08-14 22:27:36');
INSERT INTO `access_log` VALUES (67506, '65.46.15657928556014133', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-14 22:27:36', 9, 0, '', '2019-08-14 22:27:36');
INSERT INTO `access_log` VALUES (67507, '65.3607.15657928556745881', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '101.83.173.42', '2019-08-14 22:27:36', 10, 2001001000, '服务端发生异常', '2019-08-14 22:27:36');
INSERT INTO `access_log` VALUES (67508, '66.57.15657938480288753', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.121.54', '2019-08-14 22:44:08', 1, 1002001015, '账号未登陆', '2019-08-14 22:44:08');
INSERT INTO `access_log` VALUES (67509, '66.49.15657938823878751', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.121.54', '2019-08-14 22:44:42', 1, 1002001015, '账号未登陆', '2019-08-14 22:44:42');
INSERT INTO `access_log` VALUES (67510, '66.48.15657938960458757', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.121.54', '2019-08-14 22:44:56', 0, 1002001015, '账号未登陆', '2019-08-14 22:44:56');
INSERT INTO `access_log` VALUES (67511, '66.56.15657938970148769', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.121.54', '2019-08-14 22:44:57', 1, 1002001015, '账号未登陆', '2019-08-14 22:44:57');
INSERT INTO `access_log` VALUES (67512, '59.77.15657944965161161', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.63.206.114', '2019-08-14 22:54:57', 3, 0, '', '2019-08-14 22:54:57');
INSERT INTO `access_log` VALUES (67513, '59.75.15657944965261181', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.63.206.114', '2019-08-14 22:54:57', 18, 2001001000, '服务端发生异常', '2019-08-14 22:54:57');
INSERT INTO `access_log` VALUES (67514, '59.76.15657945583901165', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.227.139.178', '2019-08-14 22:55:58', 12, 2001001000, '服务端发生异常', '2019-08-14 22:55:58');
INSERT INTO `access_log` VALUES (67515, '59.78.15657945683761183', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '61.151.178.175', '2019-08-14 22:56:08', 3, 0, '', '2019-08-14 22:56:08');
INSERT INTO `access_log` VALUES (67516, '59.73.15657947905191181', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:59:51', 2, 0, '', '2019-08-14 22:59:51');
INSERT INTO `access_log` VALUES (67517, '59.79.15657947905211183', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 22:59:51', 12, 2001001000, '服务端发生异常', '2019-08-14 22:59:51');
INSERT INTO `access_log` VALUES (67518, '59.75.15657948574911187', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:00:57', 3, 0, '', '2019-08-14 23:00:57');
INSERT INTO `access_log` VALUES (67519, '59.77.15657948574931167', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:00:57', 12, 2001001000, '服务端发生异常', '2019-08-14 23:00:58');
INSERT INTO `access_log` VALUES (67520, '64.77.15657948605531511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:01', 13, 0, '', '2019-08-14 23:01:01');
INSERT INTO `access_log` VALUES (67521, '64.80.15657948606981525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:01', 3, 0, '', '2019-08-14 23:01:01');
INSERT INTO `access_log` VALUES (67522, '64.78.15657948622711525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:02', 2, 0, '', '2019-08-14 23:01:02');
INSERT INTO `access_log` VALUES (67523, '64.85.15657948627691553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:03', 2, 0, '', '2019-08-14 23:01:03');
INSERT INTO `access_log` VALUES (67524, '64.76.15657948650621523', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:05', 1, 0, '', '2019-08-14 23:01:05');
INSERT INTO `access_log` VALUES (67525, '66.55.15657948821258743', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18566763798', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:22', 258, 0, '', '2019-08-14 23:01:22');
INSERT INTO `access_log` VALUES (67526, '66.50.15657948926698767', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18566763798&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:33', 187, 0, '', '2019-08-14 23:01:33');
INSERT INTO `access_log` VALUES (67527, '66.53.15657948977888761', 203, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:38', 6, 0, '', '2019-08-14 23:01:38');
INSERT INTO `access_log` VALUES (67528, '66.57.15657948993328769', 203, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:39', 6, 0, '', '2019-08-14 23:01:39');
INSERT INTO `access_log` VALUES (67529, '64.84.15657949024021515', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:42', 6, 0, '', '2019-08-14 23:01:42');
INSERT INTO `access_log` VALUES (67530, '64.80.15657949025511527', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:43', 5, 0, '', '2019-08-14 23:01:43');
INSERT INTO `access_log` VALUES (67531, '59.71.15657949040121181', 203, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:44', 7, 0, '', '2019-08-14 23:01:44');
INSERT INTO `access_log` VALUES (67532, '59.78.15657949040131189', 203, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:44', 22, 2001001000, '服务端发生异常', '2019-08-14 23:01:44');
INSERT INTO `access_log` VALUES (67533, '64.78.15657949063391527', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:46', 5, 0, '', '2019-08-14 23:01:46');
INSERT INTO `access_log` VALUES (67534, '64.85.15657949064471555', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:46', 4, 0, '', '2019-08-14 23:01:46');
INSERT INTO `access_log` VALUES (67535, '59.74.15657949088771197', 203, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:49', 5, 0, '', '2019-08-14 23:01:49');
INSERT INTO `access_log` VALUES (67536, '59.77.15657949088791169', 203, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:01:49', 16, 2001001000, '服务端发生异常', '2019-08-14 23:01:49');
INSERT INTO `access_log` VALUES (67537, '59.74.15657949292371199', 203, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:02:09', 9, 0, '', '2019-08-14 23:02:09');
INSERT INTO `access_log` VALUES (67538, '59.77.15657949292361171', 203, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '113.87.130.137', '2019-08-14 23:02:09', 20, 2001001000, '服务端发生异常', '2019-08-14 23:02:09');
INSERT INTO `access_log` VALUES (67539, '59.79.15657949455981189', 203, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:26', 4, 0, '', '2019-08-14 23:02:26');
INSERT INTO `access_log` VALUES (67540, '59.73.15657949456031187', 203, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:26', 14, 2001001000, '服务端发生异常', '2019-08-14 23:02:26');
INSERT INTO `access_log` VALUES (67541, '64.79.15657949476181527', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:28', 7, 0, '', '2019-08-14 23:02:28');
INSERT INTO `access_log` VALUES (67542, '64.77.15657949477841515', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:28', 5, 0, '', '2019-08-14 23:02:28');
INSERT INTO `access_log` VALUES (67543, '64.78.15657949493621529', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:29', 4, 0, '', '2019-08-14 23:02:29');
INSERT INTO `access_log` VALUES (67544, 'N/A', 203, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:29', 9, 0, '', '2019-08-14 23:02:29');
INSERT INTO `access_log` VALUES (67545, '64.76.15657949522661527', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:32', 6, 0, '', '2019-08-14 23:02:32');
INSERT INTO `access_log` VALUES (67546, '64.82.15657949524131537', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:32', 6, 0, '', '2019-08-14 23:02:32');
INSERT INTO `access_log` VALUES (67547, '64.79.15657949538021529', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:34', 6, 0, '', '2019-08-14 23:02:34');
INSERT INTO `access_log` VALUES (67548, 'N/A', 203, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:34', 9, 0, '', '2019-08-14 23:02:34');
INSERT INTO `access_log` VALUES (67549, '64.77.15657949552891517', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:35', 5, 0, '', '2019-08-14 23:02:35');
INSERT INTO `access_log` VALUES (67550, '64.78.15657949554421531', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:35', 4, 0, '', '2019-08-14 23:02:35');
INSERT INTO `access_log` VALUES (67551, '64.83.15657949585611519', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:39', 6, 0, '', '2019-08-14 23:02:39');
INSERT INTO `access_log` VALUES (67552, 'N/A', 203, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:39', 8, 0, '', '2019-08-14 23:02:39');
INSERT INTO `access_log` VALUES (67553, 'N/A', 203, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:41', 11, 0, '', '2019-08-14 23:02:41');
INSERT INTO `access_log` VALUES (67554, '64.81.15657949623161527', 203, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:42', 11, 0, '', '2019-08-14 23:02:42');
INSERT INTO `access_log` VALUES (67555, '64.77.15657949715711519', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:52', 5, 0, '', '2019-08-14 23:02:52');
INSERT INTO `access_log` VALUES (67556, 'N/A', 203, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:52', 10, 0, '', '2019-08-14 23:02:52');
INSERT INTO `access_log` VALUES (67557, 'N/A', 203, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:53', 7, 0, '', '2019-08-14 23:02:53');
INSERT INTO `access_log` VALUES (67558, 'N/A', 203, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:54', 8, 0, '', '2019-08-14 23:02:54');
INSERT INTO `access_log` VALUES (67559, 'N/A', 203, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:54', 10, 0, '', '2019-08-14 23:02:54');
INSERT INTO `access_log` VALUES (67560, '64.85.15657949748351561', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:55', 5, 0, '', '2019-08-14 23:02:55');
INSERT INTO `access_log` VALUES (67561, '64.76.15657949750191531', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:55', 4, 0, '', '2019-08-14 23:02:55');
INSERT INTO `access_log` VALUES (67562, '64.82.15657949767671541', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:57', 6, 0, '', '2019-08-14 23:02:57');
INSERT INTO `access_log` VALUES (67563, '64.79.15657949780041533', 203, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:58', 5, 0, '', '2019-08-14 23:02:58');
INSERT INTO `access_log` VALUES (67564, 'N/A', 203, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:02:58', 19, 0, '', '2019-08-14 23:02:58');
INSERT INTO `access_log` VALUES (67565, '64.77.15657949795441521', 203, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '113.87.130.137', '2019-08-14 23:03:00', 9, 0, '', '2019-08-14 23:03:00');
INSERT INTO `access_log` VALUES (67566, '65.49.15657972197964155', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.114.159.238', '2019-08-14 23:40:20', 1, 1002001015, '账号未登陆', '2019-08-14 23:40:20');
INSERT INTO `access_log` VALUES (67567, '65.45.15657972197964161', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.114.159.238', '2019-08-14 23:40:20', 0, 1002001015, '账号未登陆', '2019-08-14 23:40:20');
INSERT INTO `access_log` VALUES (67568, '65.52.15657972198064189', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.114.159.238', '2019-08-14 23:40:20', 0, 1002001015, '账号未登陆', '2019-08-14 23:40:20');
INSERT INTO `access_log` VALUES (67569, '65.53.15657972225464115', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.114.159.238', '2019-08-14 23:40:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 23:40:23');
INSERT INTO `access_log` VALUES (67570, '65.51.15657972283234241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.114.159.238', '2019-08-14 23:40:28', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 23:40:28');
INSERT INTO `access_log` VALUES (67571, '65.54.15657976945464057', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.196.73.251', '2019-08-14 23:48:15', 0, 1002001015, '账号未登陆', '2019-08-14 23:48:15');
INSERT INTO `access_log` VALUES (67572, '65.46.15657976945474201', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.196.73.251', '2019-08-14 23:48:15', 0, 1002001015, '账号未登陆', '2019-08-14 23:48:15');
INSERT INTO `access_log` VALUES (67573, '65.3607.15657976945525949', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.196.73.251', '2019-08-14 23:48:15', 0, 1002001015, '账号未登陆', '2019-08-14 23:48:15');
INSERT INTO `access_log` VALUES (67574, '65.45.15657976999544169', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.196.73.251', '2019-08-14 23:48:20', 108, 0, '', '2019-08-14 23:48:20');
INSERT INTO `access_log` VALUES (67575, '65.52.15657977002784197', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.196.73.251', '2019-08-14 23:48:20', 10, 0, '', '2019-08-14 23:48:20');
INSERT INTO `access_log` VALUES (67576, '65.53.15657977002824123', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.196.73.251', '2019-08-14 23:48:20', 9, 0, '', '2019-08-14 23:48:20');
INSERT INTO `access_log` VALUES (67577, '65.49.15657977002824163', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.196.73.251', '2019-08-14 23:48:20', 10, 2001001000, '服务端发生异常', '2019-08-14 23:48:20');
INSERT INTO `access_log` VALUES (67578, '65.51.15657977125004249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.196.73.251', '2019-08-14 23:48:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-14 23:48:33');
INSERT INTO `access_log` VALUES (67579, '59.74.15658299155691667', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.206.152.206', '2019-08-15 08:45:16', 11, 0, '', '2019-08-15 08:45:16');
INSERT INTO `access_log` VALUES (67580, '59.71.15658299155681651', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.206.152.206', '2019-08-15 08:45:16', 41, 2001001000, '服务端发生异常', '2019-08-15 08:45:16');
INSERT INTO `access_log` VALUES (67581, '65.52.15658301395314629', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.206.152.206', '2019-08-15 08:49:00', 1, 1002001015, '账号未登陆', '2019-08-15 08:49:00');
INSERT INTO `access_log` VALUES (67582, '65.45.15658301395304603', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.206.152.206', '2019-08-15 08:49:00', 1, 1002001015, '账号未登陆', '2019-08-15 08:49:00');
INSERT INTO `access_log` VALUES (67583, '65.53.15658301395764557', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.206.152.206', '2019-08-15 08:49:00', 1, 1002001015, '账号未登陆', '2019-08-15 08:49:00');
INSERT INTO `access_log` VALUES (67584, '65.49.15658301425884597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.206.152.206', '2019-08-15 08:49:03', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 08:49:03');
INSERT INTO `access_log` VALUES (67585, '65.51.15658301493464681', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.206.152.206', '2019-08-15 08:49:09', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 08:49:09');
INSERT INTO `access_log` VALUES (67586, '65.3607.15658301704186385', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.206.152.206', '2019-08-15 08:49:30', 81, 0, '', '2019-08-15 08:49:31');
INSERT INTO `access_log` VALUES (67587, '65.46.15658301710724637', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.206.152.206', '2019-08-15 08:49:31', 18, 0, '', '2019-08-15 08:49:31');
INSERT INTO `access_log` VALUES (67588, '65.54.15658301710754493', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.206.152.206', '2019-08-15 08:49:31', 18, 0, '', '2019-08-15 08:49:31');
INSERT INTO `access_log` VALUES (67589, '65.52.15658301710754631', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.206.152.206', '2019-08-15 08:49:31', 17, 2001001000, '服务端发生异常', '2019-08-15 08:49:31');
INSERT INTO `access_log` VALUES (67590, '65.49.15658302017564599', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '121.206.152.206', '2019-08-15 08:50:02', 0, 1002001015, '账号未登陆', '2019-08-15 08:50:02');
INSERT INTO `access_log` VALUES (67591, '65.51.15658302017784683', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '121.206.152.206', '2019-08-15 08:50:02', 0, 1002001015, '账号未登陆', '2019-08-15 08:50:02');
INSERT INTO `access_log` VALUES (67592, '65.50.15658302017784599', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '121.206.152.206', '2019-08-15 08:50:02', 0, 1002001015, '账号未登陆', '2019-08-15 08:50:02');
INSERT INTO `access_log` VALUES (67593, '65.52.15658302342584633', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '121.206.152.206', '2019-08-15 08:50:34', 56, 0, '', '2019-08-15 08:50:34');
INSERT INTO `access_log` VALUES (67594, '65.46.15658302351474639', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '121.206.152.206', '2019-08-15 08:50:35', 10, 0, '', '2019-08-15 08:50:35');
INSERT INTO `access_log` VALUES (67595, '65.54.15658302351884495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '121.206.152.206', '2019-08-15 08:50:35', 10, 2001001000, '服务端发生异常', '2019-08-15 08:50:35');
INSERT INTO `access_log` VALUES (67596, '65.45.15658302352414607', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:67.0) Gecko/20100101 Firefox/67.0', '121.206.152.206', '2019-08-15 08:50:35', 9, 0, '', '2019-08-15 08:50:35');
INSERT INTO `access_log` VALUES (67597, '65.50.15658308631634609', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.204.228.187', '2019-08-15 09:01:03', 0, 1002001015, '账号未登陆', '2019-08-15 09:01:03');
INSERT INTO `access_log` VALUES (67598, '65.49.15658308631634609', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.204.228.187', '2019-08-15 09:01:03', 0, 1002001015, '账号未登陆', '2019-08-15 09:01:03');
INSERT INTO `access_log` VALUES (67599, '65.47.15658308631684563', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.204.228.187', '2019-08-15 09:01:03', 0, 1002001015, '账号未登陆', '2019-08-15 09:01:03');
INSERT INTO `access_log` VALUES (67600, '65.54.15658309100584505', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.204.228.187', '2019-08-15 09:01:50', 78, 0, '', '2019-08-15 09:01:50');
INSERT INTO `access_log` VALUES (67601, '65.45.15658309106384617', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.204.228.187', '2019-08-15 09:01:51', 8, 0, '', '2019-08-15 09:01:51');
INSERT INTO `access_log` VALUES (67602, '65.53.15658309106434571', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.204.228.187', '2019-08-15 09:01:51', 9, 2001001000, '服务端发生异常', '2019-08-15 09:01:51');
INSERT INTO `access_log` VALUES (67603, '65.51.15658309106504695', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.204.228.187', '2019-08-15 09:01:51', 8, 0, '', '2019-08-15 09:01:51');
INSERT INTO `access_log` VALUES (67604, '65.50.15658309297764611', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.204.228.187', '2019-08-15 09:02:10', 8, 0, '', '2019-08-15 09:02:10');
INSERT INTO `access_log` VALUES (67605, '65.3607.15658309297806399', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.204.228.187', '2019-08-15 09:02:10', 8, 2001001000, '服务端发生异常', '2019-08-15 09:02:10');
INSERT INTO `access_log` VALUES (67606, '65.52.15658309297824645', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.204.228.187', '2019-08-15 09:02:10', 7, 0, '', '2019-08-15 09:02:10');
INSERT INTO `access_log` VALUES (67607, '59.78.15658331626461703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.202.223.225', '2019-08-15 09:39:23', 32, 0, '', '2019-08-15 09:39:23');
INSERT INTO `access_log` VALUES (67608, '59.74.15658331628061711', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.202.223.225', '2019-08-15 09:39:23', 18, 2001001000, '服务端发生异常', '2019-08-15 09:39:23');
INSERT INTO `access_log` VALUES (67609, '65.54.15658336558024543', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.107.27', '2019-08-15 09:47:36', 67, 0, '', '2019-08-15 09:47:36');
INSERT INTO `access_log` VALUES (67610, '65.51.15658336561254733', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.107.27', '2019-08-15 09:47:36', 20, 0, '', '2019-08-15 09:47:36');
INSERT INTO `access_log` VALUES (67611, '65.45.15658336561214655', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.107.27', '2019-08-15 09:47:36', 24, 0, '', '2019-08-15 09:47:36');
INSERT INTO `access_log` VALUES (67612, '65.53.15658336561234609', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.107.27', '2019-08-15 09:47:36', 23, 2001001000, '服务端发生异常', '2019-08-15 09:47:36');
INSERT INTO `access_log` VALUES (67613, '65.47.15658336702114603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.107.27', '2019-08-15 09:47:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 09:47:50');
INSERT INTO `access_log` VALUES (67614, '65.52.15658336727604683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.107.27', '2019-08-15 09:47:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 09:47:53');
INSERT INTO `access_log` VALUES (67615, '65.50.15658336736614649', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.107.27', '2019-08-15 09:47:54', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 09:47:54');
INSERT INTO `access_log` VALUES (67616, '65.3607.15658336738726437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.107.27', '2019-08-15 09:47:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 09:47:54');
INSERT INTO `access_log` VALUES (67617, '65.54.15658336782324545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '218.68.107.27', '2019-08-15 09:47:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 09:47:58');
INSERT INTO `access_log` VALUES (67618, '65.45.15658353599764681', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.231.0.96', '2019-08-15 10:16:00', 1, 1002001015, '账号未登陆', '2019-08-15 10:16:00');
INSERT INTO `access_log` VALUES (67619, '65.49.15658353599764673', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.231.0.96', '2019-08-15 10:16:00', 1, 1002001015, '账号未登陆', '2019-08-15 10:16:00');
INSERT INTO `access_log` VALUES (67620, '65.53.15658353599774635', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.231.0.96', '2019-08-15 10:16:00', 0, 1002001015, '账号未登陆', '2019-08-15 10:16:00');
INSERT INTO `access_log` VALUES (67621, '65.51.15658353619594759', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.231.0.96', '2019-08-15 10:16:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 10:16:02');
INSERT INTO `access_log` VALUES (67622, '59.74.15658358447351747', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.231.0.96', '2019-08-15 10:24:05', 10, 0, '', '2019-08-15 10:24:05');
INSERT INTO `access_log` VALUES (67623, '59.71.15658358447371731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.231.0.96', '2019-08-15 10:24:05', 19, 2001001000, '服务端发生异常', '2019-08-15 10:24:05');
INSERT INTO `access_log` VALUES (67624, '64.82.15658358477992087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.231.0.96', '2019-08-15 10:24:08', 12, 0, '', '2019-08-15 10:24:08');
INSERT INTO `access_log` VALUES (67625, '64.81.15658358479412075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.231.0.96', '2019-08-15 10:24:08', 3, 0, '', '2019-08-15 10:24:08');
INSERT INTO `access_log` VALUES (67626, '64.79.15658358491682079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.231.0.96', '2019-08-15 10:24:09', 2, 0, '', '2019-08-15 10:24:09');
INSERT INTO `access_log` VALUES (67627, '64.84.15658358499012069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.231.0.96', '2019-08-15 10:24:10', 1, 0, '', '2019-08-15 10:24:10');
INSERT INTO `access_log` VALUES (67628, '59.79.15658371076841753', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:08', 4, 0, '', '2019-08-15 10:45:08');
INSERT INTO `access_log` VALUES (67629, '59.73.15658371076881751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:08', 22, 2001001000, '服务端发生异常', '2019-08-15 10:45:08');
INSERT INTO `access_log` VALUES (67630, '64.83.15658371215102085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:22', 3, 0, '', '2019-08-15 10:45:22');
INSERT INTO `access_log` VALUES (67631, '64.82.15658371216642105', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:22', 2, 0, '', '2019-08-15 10:45:22');
INSERT INTO `access_log` VALUES (67632, '64.81.15658371236532093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:24', 2, 0, '', '2019-08-15 10:45:24');
INSERT INTO `access_log` VALUES (67633, '64.79.15658371244942097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:24', 2, 0, '', '2019-08-15 10:45:24');
INSERT INTO `access_log` VALUES (67634, '59.78.15658371253011757', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:25', 2, 0, '', '2019-08-15 10:45:25');
INSERT INTO `access_log` VALUES (67635, '59.74.15658371253011765', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:25', 15, 2001001000, '服务端发生异常', '2019-08-15 10:45:25');
INSERT INTO `access_log` VALUES (67636, '64.84.15658371303532087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:30', 1, 0, '', '2019-08-15 10:45:30');
INSERT INTO `access_log` VALUES (67637, '64.77.15658371304902085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:30', 2, 0, '', '2019-08-15 10:45:30');
INSERT INTO `access_log` VALUES (67638, '66.53.15658371524829325', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13566667777&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:52', 15, 1001003000, '验证码不存在', '2019-08-15 10:45:52');
INSERT INTO `access_log` VALUES (67639, '64.78.15658371549692099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:55', 2, 0, '', '2019-08-15 10:45:55');
INSERT INTO `access_log` VALUES (67640, '64.76.15658371550962097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:55', 1, 0, '', '2019-08-15 10:45:55');
INSERT INTO `access_log` VALUES (67641, '64.83.15658371571122087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:57', 2, 0, '', '2019-08-15 10:45:57');
INSERT INTO `access_log` VALUES (67642, '64.82.15658371576292107', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:58', 2, 0, '', '2019-08-15 10:45:58');
INSERT INTO `access_log` VALUES (67643, '59.75.15658371582781757', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:58', 3, 0, '', '2019-08-15 10:45:58');
INSERT INTO `access_log` VALUES (67644, '59.80.15658371582891721', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:45:58', 16, 2001001000, '服务端发生异常', '2019-08-15 10:45:58');
INSERT INTO `access_log` VALUES (67645, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:01', 7, 0, '', '2019-08-15 10:46:01');
INSERT INTO `access_log` VALUES (67646, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:01', 10, 0, '', '2019-08-15 10:46:01');
INSERT INTO `access_log` VALUES (67647, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:02', 4, 0, '', '2019-08-15 10:46:02');
INSERT INTO `access_log` VALUES (67648, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:02', 10, 0, '', '2019-08-15 10:46:02');
INSERT INTO `access_log` VALUES (67649, '64.81.15658371643242095', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:04', 7, 0, '', '2019-08-15 10:46:04');
INSERT INTO `access_log` VALUES (67650, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:05', 7, 0, '', '2019-08-15 10:46:05');
INSERT INTO `access_log` VALUES (67651, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:05', 9, 0, '', '2019-08-15 10:46:05');
INSERT INTO `access_log` VALUES (67652, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:06', 4, 0, '', '2019-08-15 10:46:06');
INSERT INTO `access_log` VALUES (67653, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:06', 9, 0, '', '2019-08-15 10:46:06');
INSERT INTO `access_log` VALUES (67654, '64.84.15658371687322089', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:09', 6, 0, '', '2019-08-15 10:46:09');
INSERT INTO `access_log` VALUES (67655, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:10', 7, 0, '', '2019-08-15 10:46:10');
INSERT INTO `access_log` VALUES (67656, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:10', 9, 0, '', '2019-08-15 10:46:10');
INSERT INTO `access_log` VALUES (67657, '64.77.15658371738262087', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:14', 6, 0, '', '2019-08-15 10:46:14');
INSERT INTO `access_log` VALUES (67658, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:15', 6, 0, '', '2019-08-15 10:46:15');
INSERT INTO `access_log` VALUES (67659, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:15', 9, 0, '', '2019-08-15 10:46:15');
INSERT INTO `access_log` VALUES (67660, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:15', 5, 0, '', '2019-08-15 10:46:15');
INSERT INTO `access_log` VALUES (67661, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:16', 9, 0, '', '2019-08-15 10:46:16');
INSERT INTO `access_log` VALUES (67662, '64.80.15658371790752101', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:19', 6, 0, '', '2019-08-15 10:46:19');
INSERT INTO `access_log` VALUES (67663, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:20', 7, 0, '', '2019-08-15 10:46:20');
INSERT INTO `access_log` VALUES (67664, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:20', 10, 0, '', '2019-08-15 10:46:20');
INSERT INTO `access_log` VALUES (67665, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:21', 4, 0, '', '2019-08-15 10:46:21');
INSERT INTO `access_log` VALUES (67666, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:21', 8, 0, '', '2019-08-15 10:46:21');
INSERT INTO `access_log` VALUES (67667, '64.78.15658371817782101', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:22', 6, 0, '', '2019-08-15 10:46:22');
INSERT INTO `access_log` VALUES (67668, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:22', 6, 0, '', '2019-08-15 10:46:22');
INSERT INTO `access_log` VALUES (67669, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:23', 11, 0, '', '2019-08-15 10:46:23');
INSERT INTO `access_log` VALUES (67670, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:23', 4, 0, '', '2019-08-15 10:46:23');
INSERT INTO `access_log` VALUES (67671, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:23', 8, 0, '', '2019-08-15 10:46:23');
INSERT INTO `access_log` VALUES (67672, '64.76.15658371866112099', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:27', 3, 1003002003, 'Spu 只能添加在二级分类下', '2019-08-15 10:46:27');
INSERT INTO `access_log` VALUES (67673, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:29', 6, 0, '', '2019-08-15 10:46:29');
INSERT INTO `access_log` VALUES (67674, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:29', 17, 0, '', '2019-08-15 10:46:29');
INSERT INTO `access_log` VALUES (67675, '64.83.15658371909662089', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:31', 7, 0, '', '2019-08-15 10:46:31');
INSERT INTO `access_log` VALUES (67676, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:32', 7, 0, '', '2019-08-15 10:46:32');
INSERT INTO `access_log` VALUES (67677, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:32', 10, 0, '', '2019-08-15 10:46:32');
INSERT INTO `access_log` VALUES (67678, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:34', 5, 0, '', '2019-08-15 10:46:34');
INSERT INTO `access_log` VALUES (67679, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.189.210.170', '2019-08-15 10:46:34', 9, 0, '', '2019-08-15 10:46:34');
INSERT INTO `access_log` VALUES (67680, '65.45.15658392055384733', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:06', 1, 1002001015, '账号未登陆', '2019-08-15 11:20:06');
INSERT INTO `access_log` VALUES (67681, '65.53.15658392055384687', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:06', 1, 1002001015, '账号未登陆', '2019-08-15 11:20:06');
INSERT INTO `access_log` VALUES (67682, '65.50.15658392055544729', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:06', 0, 1002001015, '账号未登陆', '2019-08-15 11:20:06');
INSERT INTO `access_log` VALUES (67683, '65.46.15658392103604765', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:10', 90, 0, '', '2019-08-15 11:20:10');
INSERT INTO `access_log` VALUES (67684, '65.52.15658392106534765', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:11', 11, 0, '', '2019-08-15 11:20:11');
INSERT INTO `access_log` VALUES (67685, '65.47.15658392106544679', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:11', 13, 0, '', '2019-08-15 11:20:11');
INSERT INTO `access_log` VALUES (67686, '65.3607.15658392106536515', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:11', 15, 2001001000, '服务端发生异常', '2019-08-15 11:20:11');
INSERT INTO `access_log` VALUES (67687, '65.49.15658392247344729', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:25', 8, 0, '', '2019-08-15 11:20:25');
INSERT INTO `access_log` VALUES (67688, '65.45.15658392247384735', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:25', 8, 2001001000, '服务端发生异常', '2019-08-15 11:20:25');
INSERT INTO `access_log` VALUES (67689, '65.53.15658392247374689', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:25', 8, 0, '', '2019-08-15 11:20:25');
INSERT INTO `access_log` VALUES (67690, '65.46.15658392266704767', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:27', 9, 0, '', '2019-08-15 11:20:27');
INSERT INTO `access_log` VALUES (67691, '65.50.15658392266694731', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:27', 9, 0, '', '2019-08-15 11:20:27');
INSERT INTO `access_log` VALUES (67692, '65.51.15658392266694811', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:27', 10, 2001001000, '服务端发生异常', '2019-08-15 11:20:27');
INSERT INTO `access_log` VALUES (67693, '65.3607.15658392275486517', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:28', 8, 0, '', '2019-08-15 11:20:28');
INSERT INTO `access_log` VALUES (67694, '65.52.15658392275474767', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:28', 8, 0, '', '2019-08-15 11:20:28');
INSERT INTO `access_log` VALUES (67695, '65.47.15658392275484681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:28', 10, 2001001000, '服务端发生异常', '2019-08-15 11:20:28');
INSERT INTO `access_log` VALUES (67696, '65.49.15658392280714731', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:28', 17, 2001001000, '服务端发生异常', '2019-08-15 11:20:28');
INSERT INTO `access_log` VALUES (67697, '65.54.15658392280704625', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:28', 10, 0, '', '2019-08-15 11:20:28');
INSERT INTO `access_log` VALUES (67698, '65.45.15658392280704737', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:28', 19, 0, '', '2019-08-15 11:20:28');
INSERT INTO `access_log` VALUES (67699, '65.53.15658392340094691', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:34', 10, 0, '', '2019-08-15 11:20:34');
INSERT INTO `access_log` VALUES (67700, '65.46.15658392340114769', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:34', 10, 2001001000, '服务端发生异常', '2019-08-15 11:20:34');
INSERT INTO `access_log` VALUES (67701, '65.51.15658392340114813', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '14.153.185.64', '2019-08-15 11:20:34', 13, 0, '', '2019-08-15 11:20:34');
INSERT INTO `access_log` VALUES (67702, '59.78.15658396251881791', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '199.181.130.25', '2019-08-15 11:27:05', 10, 0, '', '2019-08-15 11:27:05');
INSERT INTO `access_log` VALUES (67703, '59.71.15658396251911783', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '199.181.130.25', '2019-08-15 11:27:05', 15, 2001001000, '服务端发生异常', '2019-08-15 11:27:05');
INSERT INTO `access_log` VALUES (67704, '64.84.15658396281772123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '199.181.130.25', '2019-08-15 11:27:08', 10, 0, '', '2019-08-15 11:27:08');
INSERT INTO `access_log` VALUES (67705, '64.77.15658396284112121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '199.181.130.25', '2019-08-15 11:27:08', 3, 0, '', '2019-08-15 11:27:08');
INSERT INTO `access_log` VALUES (67706, '64.80.15658396293802135', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '199.181.130.25', '2019-08-15 11:27:09', 43, 0, '', '2019-08-15 11:27:09');
INSERT INTO `access_log` VALUES (67707, '64.85.15658396298112163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '199.181.130.25', '2019-08-15 11:27:10', 1, 0, '', '2019-08-15 11:27:10');
INSERT INTO `access_log` VALUES (67708, '66.50.15658396321969367', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '199.181.130.25', '2019-08-15 11:27:12', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-08-15 11:27:12');
INSERT INTO `access_log` VALUES (67709, '66.48.15658396349249369', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '199.181.130.25', '2019-08-15 11:27:15', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空', '2019-08-15 11:27:15');
INSERT INTO `access_log` VALUES (67710, '64.78.15658396395322135', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '199.181.130.25', '2019-08-15 11:27:20', 2, 0, '', '2019-08-15 11:27:20');
INSERT INTO `access_log` VALUES (67711, '64.76.15658396397322133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '199.181.130.25', '2019-08-15 11:27:20', 2, 0, '', '2019-08-15 11:27:20');
INSERT INTO `access_log` VALUES (67712, '59.75.15658396399001791', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '199.181.130.25', '2019-08-15 11:27:20', 3, 0, '', '2019-08-15 11:27:20');
INSERT INTO `access_log` VALUES (67713, '59.80.15658396399921755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '199.181.130.25', '2019-08-15 11:27:20', 30, 2001001000, '服务端发生异常', '2019-08-15 11:27:20');
INSERT INTO `access_log` VALUES (67714, '59.72.15658403982141793', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.231.115.28', '2019-08-15 11:39:58', 5, 0, '', '2019-08-15 11:39:58');
INSERT INTO `access_log` VALUES (67715, '59.79.15658403982141799', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.231.115.28', '2019-08-15 11:39:58', 16, 2001001000, '服务端发生异常', '2019-08-15 11:39:58');
INSERT INTO `access_log` VALUES (67716, '65.50.15658464444424829', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.215.160', '2019-08-15 13:20:44', 1, 1002001015, '账号未登陆', '2019-08-15 13:20:44');
INSERT INTO `access_log` VALUES (67717, '65.3607.15658464444426615', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.215.160', '2019-08-15 13:20:44', 1, 1002001015, '账号未登陆', '2019-08-15 13:20:44');
INSERT INTO `access_log` VALUES (67718, '65.53.15658464444584791', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.215.160', '2019-08-15 13:20:44', 0, 1002001015, '账号未登陆', '2019-08-15 13:20:44');
INSERT INTO `access_log` VALUES (67719, '59.78.15658464461231883', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.215.160', '2019-08-15 13:20:46', 10, 0, '', '2019-08-15 13:20:46');
INSERT INTO `access_log` VALUES (67720, '59.71.15658464461231875', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.215.160', '2019-08-15 13:20:46', 18, 2001001000, '服务端发生异常', '2019-08-15 13:20:46');
INSERT INTO `access_log` VALUES (67721, '64.85.15658464910262255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '58.59.215.160', '2019-08-15 13:21:31', 13, 0, '', '2019-08-15 13:21:31');
INSERT INTO `access_log` VALUES (67722, '64.78.15658464911782227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '58.59.215.160', '2019-08-15 13:21:31', 4, 0, '', '2019-08-15 13:21:31');
INSERT INTO `access_log` VALUES (67723, '59.72.15658464935891875', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '58.59.215.160', '2019-08-15 13:21:34', 4, 0, '', '2019-08-15 13:21:34');
INSERT INTO `access_log` VALUES (67724, '59.79.15658464935901881', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '58.59.215.160', '2019-08-15 13:21:34', 16, 2001001000, '服务端发生异常', '2019-08-15 13:21:34');
INSERT INTO `access_log` VALUES (67725, '64.83.15658464980162215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '58.59.215.160', '2019-08-15 13:21:38', 2, 0, '', '2019-08-15 13:21:38');
INSERT INTO `access_log` VALUES (67726, '64.82.15658464982282235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '58.59.215.160', '2019-08-15 13:21:38', 1, 0, '', '2019-08-15 13:21:38');
INSERT INTO `access_log` VALUES (67727, '59.76.15658465004141865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '58.59.215.160', '2019-08-15 13:21:40', 3, 0, '', '2019-08-15 13:21:40');
INSERT INTO `access_log` VALUES (67728, '59.74.15658465004161893', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Mobile Safari/537.36', '58.59.215.160', '2019-08-15 13:21:40', 12, 2001001000, '服务端发生异常', '2019-08-15 13:21:40');
INSERT INTO `access_log` VALUES (67729, '65.54.15658465046194723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.215.160', '2019-08-15 13:21:45', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 13:21:45');
INSERT INTO `access_log` VALUES (67730, '65.46.15658465235374871', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.215.160', '2019-08-15 13:22:04', 77, 0, '', '2019-08-15 13:22:04');
INSERT INTO `access_log` VALUES (67731, '65.3607.15658465240576617', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.215.160', '2019-08-15 13:22:04', 10, 0, '', '2019-08-15 13:22:04');
INSERT INTO `access_log` VALUES (67732, '65.50.15658465240764831', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.215.160', '2019-08-15 13:22:04', 18, 2001001000, '服务端发生异常', '2019-08-15 13:22:04');
INSERT INTO `access_log` VALUES (67733, '65.53.15658465241254793', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.215.160', '2019-08-15 13:22:04', 9, 0, '', '2019-08-15 13:22:04');
INSERT INTO `access_log` VALUES (67734, '59.75.15658492288881921', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:09', 10, 0, '', '2019-08-15 14:07:09');
INSERT INTO `access_log` VALUES (67735, '59.77.15658492288881901', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:09', 16, 2001001000, '服务端发生异常', '2019-08-15 14:07:09');
INSERT INTO `access_log` VALUES (67736, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:17', 6, 0, '', '2019-08-15 14:07:17');
INSERT INTO `access_log` VALUES (67737, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:17', 3, 0, '', '2019-08-15 14:07:17');
INSERT INTO `access_log` VALUES (67738, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:17', 18, 0, '', '2019-08-15 14:07:17');
INSERT INTO `access_log` VALUES (67739, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:17', 9, 0, '', '2019-08-15 14:07:17');
INSERT INTO `access_log` VALUES (67740, '64.84.15658492387482253', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:19', 9, 0, '', '2019-08-15 14:07:19');
INSERT INTO `access_log` VALUES (67741, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:27', 6, 0, '', '2019-08-15 14:07:27');
INSERT INTO `access_log` VALUES (67742, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:27', 4, 0, '', '2019-08-15 14:07:27');
INSERT INTO `access_log` VALUES (67743, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:27', 9, 0, '', '2019-08-15 14:07:27');
INSERT INTO `access_log` VALUES (67744, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:27', 8, 0, '', '2019-08-15 14:07:27');
INSERT INTO `access_log` VALUES (67745, '64.80.15658492482712265', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:28', 6, 0, '', '2019-08-15 14:07:28');
INSERT INTO `access_log` VALUES (67746, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:31', 6, 0, '', '2019-08-15 14:07:31');
INSERT INTO `access_log` VALUES (67747, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:31', 13, 0, '', '2019-08-15 14:07:31');
INSERT INTO `access_log` VALUES (67748, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:31', 17, 0, '', '2019-08-15 14:07:31');
INSERT INTO `access_log` VALUES (67749, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:31', 9, 0, '', '2019-08-15 14:07:31');
INSERT INTO `access_log` VALUES (67750, '59.72.15658492517521913', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:32', 3, 0, '', '2019-08-15 14:07:32');
INSERT INTO `access_log` VALUES (67751, '59.79.15658492517521919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '58.247.17.210', '2019-08-15 14:07:32', 14, 2001001000, '服务端发生异常', '2019-08-15 14:07:32');
INSERT INTO `access_log` VALUES (67752, '65.54.15658497263054767', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.205.209.238', '2019-08-15 14:15:26', 0, 1002001015, '账号未登陆', '2019-08-15 14:15:26');
INSERT INTO `access_log` VALUES (67753, '65.51.15658497263064955', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.205.209.238', '2019-08-15 14:15:26', 0, 1002001015, '账号未登陆', '2019-08-15 14:15:26');
INSERT INTO `access_log` VALUES (67754, '65.46.15658497263114915', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.205.209.238', '2019-08-15 14:15:26', 1, 1002001015, '账号未登陆', '2019-08-15 14:15:26');
INSERT INTO `access_log` VALUES (67755, '65.50.15658497389724875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuma&password=yudaoyuanam&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.205.209.238', '2019-08-15 14:15:39', 4, 1002002000, '账号不存在', '2019-08-15 14:15:39');
INSERT INTO `access_log` VALUES (67756, '65.53.15658497429314837', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.205.209.238', '2019-08-15 14:15:43', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 14:15:43');
INSERT INTO `access_log` VALUES (67757, '65.45.15658502100864895', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-08-15 14:23:30', 3, 1002001012, '访问令牌已过期', '2019-08-15 14:23:30');
INSERT INTO `access_log` VALUES (67758, '65.49.15658502100854879', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-08-15 14:23:30', 3, 1002001012, '访问令牌已过期', '2019-08-15 14:23:30');
INSERT INTO `access_log` VALUES (67759, '65.52.15658502100854919', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-08-15 14:23:30', 3, 1002001012, '访问令牌已过期', '2019-08-15 14:23:30');
INSERT INTO `access_log` VALUES (67760, '65.46.15658502179254923', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-08-15 14:23:38', 142, 0, '', '2019-08-15 14:23:38');
INSERT INTO `access_log` VALUES (67761, '65.51.15658502183554963', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-08-15 14:23:38', 11, 0, '', '2019-08-15 14:23:38');
INSERT INTO `access_log` VALUES (67762, '65.54.15658502183564775', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-08-15 14:23:38', 11, 0, '', '2019-08-15 14:23:38');
INSERT INTO `access_log` VALUES (67763, '65.3607.15658502183596669', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '58.246.125.226', '2019-08-15 14:23:38', 9, 2001001000, '服务端发生异常', '2019-08-15 14:23:38');
INSERT INTO `access_log` VALUES (67764, '65.49.15658502684044881', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.120.75.87', '2019-08-15 14:24:28', 1, 1002001015, '账号未登陆', '2019-08-15 14:24:28');
INSERT INTO `access_log` VALUES (67765, '65.52.15658502684054921', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.120.75.87', '2019-08-15 14:24:28', 1, 1002001015, '账号未登陆', '2019-08-15 14:24:28');
INSERT INTO `access_log` VALUES (67766, '65.46.15658502684064925', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.120.75.87', '2019-08-15 14:24:28', 0, 1002001015, '账号未登陆', '2019-08-15 14:24:28');
INSERT INTO `access_log` VALUES (67767, '65.3607.15658502713336671', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.120.75.87', '2019-08-15 14:24:31', 70, 0, '', '2019-08-15 14:24:31');
INSERT INTO `access_log` VALUES (67768, '65.50.15658502716754885', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.120.75.87', '2019-08-15 14:24:32', 50, 0, '', '2019-08-15 14:24:32');
INSERT INTO `access_log` VALUES (67769, '65.51.15658502716704965', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.120.75.87', '2019-08-15 14:24:32', 54, 0, '', '2019-08-15 14:24:32');
INSERT INTO `access_log` VALUES (67770, '65.54.15658502716744777', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.120.75.87', '2019-08-15 14:24:32', 52, 2001001000, '服务端发生异常', '2019-08-15 14:24:32');
INSERT INTO `access_log` VALUES (67771, '65.53.15658502770214847', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.120.75.87', '2019-08-15 14:24:37', 8, 0, '', '2019-08-15 14:24:37');
INSERT INTO `access_log` VALUES (67772, '65.45.15658502770234899', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.120.75.87', '2019-08-15 14:24:37', 9, 0, '', '2019-08-15 14:24:37');
INSERT INTO `access_log` VALUES (67773, '65.47.15658502770234835', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.120.75.87', '2019-08-15 14:24:37', 11, 2001001000, '服务端发生异常', '2019-08-15 14:24:37');
INSERT INTO `access_log` VALUES (67774, '59.80.15658520528171923', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.218', '2019-08-15 14:54:13', 10, 0, '', '2019-08-15 14:54:13');
INSERT INTO `access_log` VALUES (67775, '59.72.15658520528181951', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.218', '2019-08-15 14:54:13', 15, 2001001000, '服务端发生异常', '2019-08-15 14:54:13');
INSERT INTO `access_log` VALUES (67776, '59.76.15658520775341941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.218', '2019-08-15 14:54:38', 4, 0, '', '2019-08-15 14:54:38');
INSERT INTO `access_log` VALUES (67777, '59.74.15658520775341969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.218', '2019-08-15 14:54:38', 40, 2001001000, '服务端发生异常', '2019-08-15 14:54:38');
INSERT INTO `access_log` VALUES (67778, '64.80.15658520798592303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.218', '2019-08-15 14:54:40', 11, 0, '', '2019-08-15 14:54:40');
INSERT INTO `access_log` VALUES (67779, '64.85.15658520799832331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.218', '2019-08-15 14:54:40', 3, 0, '', '2019-08-15 14:54:40');
INSERT INTO `access_log` VALUES (67780, '64.78.15658520821942303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.218', '2019-08-15 14:54:42', 2, 0, '', '2019-08-15 14:54:42');
INSERT INTO `access_log` VALUES (67781, '64.76.15658520827572301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.218', '2019-08-15 14:54:43', 2, 0, '', '2019-08-15 14:54:43');
INSERT INTO `access_log` VALUES (67782, '64.83.15658520858272291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.218', '2019-08-15 14:54:46', 2, 0, '', '2019-08-15 14:54:46');
INSERT INTO `access_log` VALUES (67783, '64.82.15658520859692311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.218', '2019-08-15 14:54:46', 1, 0, '', '2019-08-15 14:54:46');
INSERT INTO `access_log` VALUES (67784, '59.75.15658521099851961', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.11.251', '2019-08-15 14:55:10', 3, 0, '', '2019-08-15 14:55:10');
INSERT INTO `access_log` VALUES (67785, '59.77.15658521099871941', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.11.251', '2019-08-15 14:55:10', 15, 2001001000, '服务端发生异常', '2019-08-15 14:55:10');
INSERT INTO `access_log` VALUES (67786, '64.80.15658521377972305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.11.251', '2019-08-15 14:55:38', 3, 0, '', '2019-08-15 14:55:38');
INSERT INTO `access_log` VALUES (67787, '64.85.15658521380472333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.11.251', '2019-08-15 14:55:38', 2, 0, '', '2019-08-15 14:55:38');
INSERT INTO `access_log` VALUES (67788, '64.78.15658521397062305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.11.251', '2019-08-15 14:55:40', 1, 0, '', '2019-08-15 14:55:40');
INSERT INTO `access_log` VALUES (67789, '64.76.15658521402612303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.11.251', '2019-08-15 14:55:40', 2, 0, '', '2019-08-15 14:55:40');
INSERT INTO `access_log` VALUES (67790, '59.79.15658521417721959', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.11.251', '2019-08-15 14:55:42', 3, 0, '', '2019-08-15 14:55:42');
INSERT INTO `access_log` VALUES (67791, '59.73.15658521417741957', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.11.251', '2019-08-15 14:55:42', 12, 2001001000, '服务端发生异常', '2019-08-15 14:55:42');
INSERT INTO `access_log` VALUES (67792, '65.46.15658525358864957', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.19.204.204', '2019-08-15 15:02:16', 0, 1002001015, '账号未登陆', '2019-08-15 15:02:16');
INSERT INTO `access_log` VALUES (67793, '65.49.15658525358864913', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.19.204.204', '2019-08-15 15:02:16', 0, 1002001015, '账号未登陆', '2019-08-15 15:02:16');
INSERT INTO `access_log` VALUES (67794, '65.3607.15658525358916703', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.19.204.204', '2019-08-15 15:02:16', 0, 1002001015, '账号未登陆', '2019-08-15 15:02:16');
INSERT INTO `access_log` VALUES (67795, '65.51.15658525515104997', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.19.204.204', '2019-08-15 15:02:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 15:02:32');
INSERT INTO `access_log` VALUES (67796, '65.53.15658525604704879', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.19.204.204', '2019-08-15 15:02:40', 87, 0, '', '2019-08-15 15:02:41');
INSERT INTO `access_log` VALUES (67797, '65.45.15658525607794931', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.19.204.204', '2019-08-15 15:02:41', 11, 0, '', '2019-08-15 15:02:41');
INSERT INTO `access_log` VALUES (67798, '65.52.15658525607814955', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.19.204.204', '2019-08-15 15:02:41', 10, 0, '', '2019-08-15 15:02:41');
INSERT INTO `access_log` VALUES (67799, '65.47.15658525607804867', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.19.204.204', '2019-08-15 15:02:41', 11, 2001001000, '服务端发生异常', '2019-08-15 15:02:41');
INSERT INTO `access_log` VALUES (67800, '59.79.15658552742882001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.145.72.174', '2019-08-15 15:47:54', 16, 0, '', '2019-08-15 15:47:54');
INSERT INTO `access_log` VALUES (67801, '59.74.15658552742882013', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.145.72.174', '2019-08-15 15:47:54', 16, 2001001000, '服务端发生异常', '2019-08-15 15:47:54');
INSERT INTO `access_log` VALUES (67802, '64.76.15658552801082345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.145.72.174', '2019-08-15 15:48:00', 10, 0, '', '2019-08-15 15:48:00');
INSERT INTO `access_log` VALUES (67803, '64.83.15658552802592335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.145.72.174', '2019-08-15 15:48:00', 3, 0, '', '2019-08-15 15:48:00');
INSERT INTO `access_log` VALUES (67804, '65.51.15658553062245035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.145.72.174', '2019-08-15 15:48:26', 10, 1002001012, '访问令牌已过期', '2019-08-15 15:48:26');
INSERT INTO `access_log` VALUES (67805, '65.54.15658553062264847', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.145.72.174', '2019-08-15 15:48:26', 8, 1002001012, '访问令牌已过期', '2019-08-15 15:48:26');
INSERT INTO `access_log` VALUES (67806, '65.50.15658553062244955', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.145.72.174', '2019-08-15 15:48:26', 11, 1002001012, '访问令牌已过期', '2019-08-15 15:48:26');
INSERT INTO `access_log` VALUES (67807, '65.47.15658553436624905', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.145.72.174', '2019-08-15 15:49:04', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 15:49:04');
INSERT INTO `access_log` VALUES (67808, '65.49.15658553727934953', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.145.72.174', '2019-08-15 15:49:33', 135, 0, '', '2019-08-15 15:49:33');
INSERT INTO `access_log` VALUES (67809, '65.3607.15658553734616743', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.145.72.174', '2019-08-15 15:49:33', 10, 0, '', '2019-08-15 15:49:33');
INSERT INTO `access_log` VALUES (67810, '65.50.15658553734634957', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.145.72.174', '2019-08-15 15:49:33', 11, 2001001000, '服务端发生异常', '2019-08-15 15:49:33');
INSERT INTO `access_log` VALUES (67811, '65.51.15658553734665037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '219.145.72.174', '2019-08-15 15:49:33', 11, 0, '', '2019-08-15 15:49:33');
INSERT INTO `access_log` VALUES (67812, '59.76.15658572269732011', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.198.133', '2019-08-15 16:20:27', 13, 0, '', '2019-08-15 16:20:27');
INSERT INTO `access_log` VALUES (67813, '59.71.15658572269742023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.198.133', '2019-08-15 16:20:27', 21, 2001001000, '服务端发生异常', '2019-08-15 16:20:27');
INSERT INTO `access_log` VALUES (67814, '64.82.15658572309472381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.198.133', '2019-08-15 16:20:31', 11, 0, '', '2019-08-15 16:20:31');
INSERT INTO `access_log` VALUES (67815, '64.81.15658572310642369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.198.133', '2019-08-15 16:20:31', 2, 0, '', '2019-08-15 16:20:31');
INSERT INTO `access_log` VALUES (67816, '64.79.15658572322472373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.198.133', '2019-08-15 16:20:32', 2, 0, '', '2019-08-15 16:20:32');
INSERT INTO `access_log` VALUES (67817, '64.84.15658572328552363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.198.133', '2019-08-15 16:20:33', 2, 0, '', '2019-08-15 16:20:33');
INSERT INTO `access_log` VALUES (67818, '59.72.15658577211242029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.194.2.66', '2019-08-15 16:28:41', 14, 2001001000, '服务端发生异常', '2019-08-15 16:28:41');
INSERT INTO `access_log` VALUES (67819, '59.80.15658577211242001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.194.2.66', '2019-08-15 16:28:41', 424, 0, '', '2019-08-15 16:28:42');
INSERT INTO `access_log` VALUES (67820, '65.54.15658577548184881', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 16:29:15', 1, 1002001015, '账号未登陆', '2019-08-15 16:29:15');
INSERT INTO `access_log` VALUES (67821, '65.51.15658577548185069', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 16:29:15', 1, 1002001015, '账号未登陆', '2019-08-15 16:29:15');
INSERT INTO `access_log` VALUES (67822, '65.53.15658577548194951', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 16:29:15', 1, 1002001015, '账号未登陆', '2019-08-15 16:29:15');
INSERT INTO `access_log` VALUES (67823, '65.45.15658577574105003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 16:29:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 16:29:17');
INSERT INTO `access_log` VALUES (67824, '65.52.15658577653495027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 16:29:25', 95, 0, '', '2019-08-15 16:29:25');
INSERT INTO `access_log` VALUES (67825, '65.46.15658577761995031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 16:29:36', 201, 0, '', '2019-08-15 16:29:36');
INSERT INTO `access_log` VALUES (67826, '65.54.15658578095064883', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.28.195.162', '2019-08-15 16:30:10', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 16:30:10');
INSERT INTO `access_log` VALUES (67827, '59.71.15658583741262039', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '60.191.54.27', '2019-08-15 16:39:34', 3, 0, '', '2019-08-15 16:39:34');
INSERT INTO `access_log` VALUES (67828, '59.78.15658583741262047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '60.191.54.27', '2019-08-15 16:39:34', 22, 2001001000, '服务端发生异常', '2019-08-15 16:39:34');
INSERT INTO `access_log` VALUES (67829, '64.81.15658583777772385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '60.191.54.27', '2019-08-15 16:39:38', 3, 0, '', '2019-08-15 16:39:38');
INSERT INTO `access_log` VALUES (67830, '64.79.15658583779482389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '60.191.54.27', '2019-08-15 16:39:38', 2, 0, '', '2019-08-15 16:39:38');
INSERT INTO `access_log` VALUES (67831, '59.77.15658583799682027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '60.191.54.27', '2019-08-15 16:39:40', 3, 0, '', '2019-08-15 16:39:40');
INSERT INTO `access_log` VALUES (67832, '59.75.15658583799682047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '60.191.54.27', '2019-08-15 16:39:40', 15, 2001001000, '服务端发生异常', '2019-08-15 16:39:40');
INSERT INTO `access_log` VALUES (67833, '59.72.15658583856212039', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '60.191.54.27', '2019-08-15 16:39:46', 2, 0, '', '2019-08-15 16:39:46');
INSERT INTO `access_log` VALUES (67834, '59.80.15658583856212011', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '60.191.54.27', '2019-08-15 16:39:46', 19, 2001001000, '服务端发生异常', '2019-08-15 16:39:46');
INSERT INTO `access_log` VALUES (67835, '64.84.15658583885752379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '60.191.54.27', '2019-08-15 16:39:49', 1, 0, '', '2019-08-15 16:39:49');
INSERT INTO `access_log` VALUES (67836, '64.77.15658583886872377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '60.191.54.27', '2019-08-15 16:39:49', 2, 0, '', '2019-08-15 16:39:49');
INSERT INTO `access_log` VALUES (67837, '65.3607.15658584971566787', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.75.51.17', '2019-08-15 16:41:37', 0, 1002001015, '账号未登陆', '2019-08-15 16:41:37');
INSERT INTO `access_log` VALUES (67838, '65.49.15658584971534997', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.75.51.17', '2019-08-15 16:41:37', 0, 1002001015, '账号未登陆', '2019-08-15 16:41:37');
INSERT INTO `access_log` VALUES (67839, '65.46.15658584971535041', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.75.51.17', '2019-08-15 16:41:37', 0, 1002001015, '账号未登陆', '2019-08-15 16:41:37');
INSERT INTO `access_log` VALUES (67840, '65.54.15658585042764893', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.75.51.17', '2019-08-15 16:41:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 16:41:44');
INSERT INTO `access_log` VALUES (67841, '65.51.15658585114325081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.75.51.17', '2019-08-15 16:41:51', 65, 0, '', '2019-08-15 16:41:51');
INSERT INTO `access_log` VALUES (67842, '65.53.15658585117044963', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.75.51.17', '2019-08-15 16:41:52', 11, 0, '', '2019-08-15 16:41:52');
INSERT INTO `access_log` VALUES (67843, '65.45.15658585117095015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.75.51.17', '2019-08-15 16:41:52', 9, 0, '', '2019-08-15 16:41:52');
INSERT INTO `access_log` VALUES (67844, '65.47.15658585117094951', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.75.51.17', '2019-08-15 16:41:52', 9, 2001001000, '服务端发生异常', '2019-08-15 16:41:52');
INSERT INTO `access_log` VALUES (67845, '59.80.15658586671692015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:44:27', 3, 0, '', '2019-08-15 16:44:27');
INSERT INTO `access_log` VALUES (67846, '59.73.15658586671712047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:44:27', 18, 2001001000, '服务端发生异常', '2019-08-15 16:44:27');
INSERT INTO `access_log` VALUES (67847, '64.77.15658586748912381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:44:35', 3, 0, '', '2019-08-15 16:44:35');
INSERT INTO `access_log` VALUES (67848, '64.80.15658586749842395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:44:35', 2, 0, '', '2019-08-15 16:44:35');
INSERT INTO `access_log` VALUES (67849, '64.78.15658586763862395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:44:36', 2, 0, '', '2019-08-15 16:44:36');
INSERT INTO `access_log` VALUES (67850, '64.76.15658586770842393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:44:37', 2, 0, '', '2019-08-15 16:44:37');
INSERT INTO `access_log` VALUES (67851, '64.83.15658586776932383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:44:38', 1, 0, '', '2019-08-15 16:44:38');
INSERT INTO `access_log` VALUES (67852, '64.82.15658586781752403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:44:38', 1, 0, '', '2019-08-15 16:44:38');
INSERT INTO `access_log` VALUES (67853, '59.74.15658586791622061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:44:39', 2, 0, '', '2019-08-15 16:44:39');
INSERT INTO `access_log` VALUES (67854, '59.76.15658586791632033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:44:39', 12, 2001001000, '服务端发生异常', '2019-08-15 16:44:39');
INSERT INTO `access_log` VALUES (67855, '64.81.15658586822692391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:44:42', 2, 0, '', '2019-08-15 16:44:42');
INSERT INTO `access_log` VALUES (67856, '64.79.15658586824012395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:44:42', 2, 0, '', '2019-08-15 16:44:42');
INSERT INTO `access_log` VALUES (67857, '59.78.15658586837472053', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:44:44', 2, 0, '', '2019-08-15 16:44:44');
INSERT INTO `access_log` VALUES (67858, '59.71.15658586837462045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:44:44', 12, 2001001000, '服务端发生异常', '2019-08-15 16:44:44');
INSERT INTO `access_log` VALUES (67859, '65.46.15658586936675045', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.75.51.17', '2019-08-15 16:44:54', 11, 0, '', '2019-08-15 16:44:54');
INSERT INTO `access_log` VALUES (67860, '65.3607.15658586936676791', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.75.51.17', '2019-08-15 16:44:54', 12, 2001001000, '服务端发生异常', '2019-08-15 16:44:54');
INSERT INTO `access_log` VALUES (67861, '65.50.15658586936755005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.75.51.17', '2019-08-15 16:44:54', 18, 0, '', '2019-08-15 16:44:54');
INSERT INTO `access_log` VALUES (67862, '65.51.15658586997205085', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:45:00', 1, 1002001015, '账号未登陆', '2019-08-15 16:45:00');
INSERT INTO `access_log` VALUES (67863, '65.45.15658586997245019', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:45:00', 0, 1002001015, '账号未登陆', '2019-08-15 16:45:00');
INSERT INTO `access_log` VALUES (67864, '65.53.15658586997284967', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:45:00', 0, 1002001015, '账号未登陆', '2019-08-15 16:45:00');
INSERT INTO `access_log` VALUES (67865, '65.47.15658587014934955', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:45:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 16:45:02');
INSERT INTO `access_log` VALUES (67866, '65.52.15658587067915043', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:45:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 16:45:07');
INSERT INTO `access_log` VALUES (67867, '65.3607.15658587171376793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:45:17', 99, 0, '', '2019-08-15 16:45:17');
INSERT INTO `access_log` VALUES (67868, '65.46.15658587174825047', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:45:17', 9, 0, '', '2019-08-15 16:45:17');
INSERT INTO `access_log` VALUES (67869, '65.50.15658587174845007', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:45:17', 10, 2001001000, '服务端发生异常', '2019-08-15 16:45:17');
INSERT INTO `access_log` VALUES (67870, '65.54.15658587174864899', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '58.63.60.83', '2019-08-15 16:45:17', 9, 0, '', '2019-08-15 16:45:17');
INSERT INTO `access_log` VALUES (67871, '65.54.15658600468004919', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-08-15 17:07:27', 4, 1002001012, '访问令牌已过期', '2019-08-15 17:07:27');
INSERT INTO `access_log` VALUES (67872, '65.46.15658600467985067', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-08-15 17:07:27', 5, 1002001012, '访问令牌已过期', '2019-08-15 17:07:27');
INSERT INTO `access_log` VALUES (67873, '65.50.15658600467995027', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-08-15 17:07:27', 4, 1002001012, '访问令牌已过期', '2019-08-15 17:07:27');
INSERT INTO `access_log` VALUES (67874, '65.45.15658600488135039', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-08-15 17:07:29', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 17:07:29');
INSERT INTO `access_log` VALUES (67875, '65.53.15658600696064989', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-08-15 17:07:50', 301, 0, '', '2019-08-15 17:07:50');
INSERT INTO `access_log` VALUES (67876, '65.49.15658600701415023', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-08-15 17:07:50', 21, 0, '', '2019-08-15 17:07:50');
INSERT INTO `access_log` VALUES (67877, '65.47.15658600701344975', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-08-15 17:07:50', 28, 0, '', '2019-08-15 17:07:50');
INSERT INTO `access_log` VALUES (67878, '65.52.15658600701405065', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '183.134.103.169', '2019-08-15 17:07:50', 23, 2001001000, '服务端发生异常', '2019-08-15 17:07:50');
INSERT INTO `access_log` VALUES (67879, '59.79.15658608516322079', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:20:52', 10, 0, '', '2019-08-15 17:20:52');
INSERT INTO `access_log` VALUES (67880, '59.76.15658608516322063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:20:52', 15, 2001001000, '服务端发生异常', '2019-08-15 17:20:52');
INSERT INTO `access_log` VALUES (67881, '64.76.15658608579572423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:20:58', 11, 0, '', '2019-08-15 17:20:58');
INSERT INTO `access_log` VALUES (67882, '64.83.15658608580742413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:20:58', 3, 0, '', '2019-08-15 17:20:58');
INSERT INTO `access_log` VALUES (67883, '64.82.15658608594542433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:20:59', 2, 0, '', '2019-08-15 17:20:59');
INSERT INTO `access_log` VALUES (67884, '64.81.15658608599992421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:00', 2, 0, '', '2019-08-15 17:21:00');
INSERT INTO `access_log` VALUES (67885, '59.74.15658608614912091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:01', 2, 0, '', '2019-08-15 17:21:01');
INSERT INTO `access_log` VALUES (67886, '59.78.15658608614912083', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:01', 16, 2001001000, '服务端发生异常', '2019-08-15 17:21:02');
INSERT INTO `access_log` VALUES (67887, '59.77.15658608675662063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:08', 3, 0, '', '2019-08-15 17:21:08');
INSERT INTO `access_log` VALUES (67888, '59.75.15658608675662083', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:08', 14, 2001001000, '服务端发生异常', '2019-08-15 17:21:08');
INSERT INTO `access_log` VALUES (67889, '64.84.15658608746392415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:15', 2, 0, '', '2019-08-15 17:21:15');
INSERT INTO `access_log` VALUES (67890, '64.77.15658608747532413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:15', 2, 0, '', '2019-08-15 17:21:15');
INSERT INTO `access_log` VALUES (67891, '59.80.15658608851862047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:25', 2, 0, '', '2019-08-15 17:21:25');
INSERT INTO `access_log` VALUES (67892, '59.73.15658608851862079', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:25', 21, 2001001000, '服务端发生异常', '2019-08-15 17:21:25');
INSERT INTO `access_log` VALUES (67893, '65.50.15658608939555041', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:34', 0, 1002001015, '账号未登陆', '2019-08-15 17:21:34');
INSERT INTO `access_log` VALUES (67894, '65.54.15658608939574933', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:34', 1, 1002001015, '账号未登陆', '2019-08-15 17:21:34');
INSERT INTO `access_log` VALUES (67895, '65.46.15658608939635079', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:34', 1, 1002001015, '账号未登陆', '2019-08-15 17:21:34');
INSERT INTO `access_log` VALUES (67896, '65.45.15658608956645053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:36', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 17:21:36');
INSERT INTO `access_log` VALUES (67897, '65.53.15658609013435003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:41', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 17:21:41');
INSERT INTO `access_log` VALUES (67898, '65.47.15658609138814987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:54', 79, 0, '', '2019-08-15 17:21:54');
INSERT INTO `access_log` VALUES (67899, '65.52.15658609142335079', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:54', 9, 0, '', '2019-08-15 17:21:54');
INSERT INTO `access_log` VALUES (67900, '65.3607.15658609142396827', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:54', 10, 2001001000, '服务端发生异常', '2019-08-15 17:21:54');
INSERT INTO `access_log` VALUES (67901, '65.54.15658609142454935', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.166.84.130', '2019-08-15 17:21:54', 9, 0, '', '2019-08-15 17:21:54');
INSERT INTO `access_log` VALUES (67902, '65.45.15658609562055055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 17:22:36', 105, 0, '', '2019-08-15 17:22:36');
INSERT INTO `access_log` VALUES (67903, '65.51.15658609566245121', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 17:22:37', 9, 0, '', '2019-08-15 17:22:37');
INSERT INTO `access_log` VALUES (67904, '65.53.15658609566245005', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 17:22:37', 9, 2001001000, '服务端发生异常', '2019-08-15 17:22:37');
INSERT INTO `access_log` VALUES (67905, '65.49.15658609566285037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 17:22:37', 9, 0, '', '2019-08-15 17:22:37');
INSERT INTO `access_log` VALUES (67906, '65.54.15658609752524937', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.28.195.162', '2019-08-15 17:22:55', 113, 0, '', '2019-08-15 17:22:55');
INSERT INTO `access_log` VALUES (67907, '65.50.15658609752615045', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 17:22:55', 105, 0, '', '2019-08-15 17:22:55');
INSERT INTO `access_log` VALUES (67908, '65.52.15658609752575081', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 17:22:55', 109, 2001001000, '服务端发生异常', '2019-08-15 17:22:55');
INSERT INTO `access_log` VALUES (67909, '65.46.15658609849645083', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 17:23:05', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 17:23:05');
INSERT INTO `access_log` VALUES (67910, '65.45.15658609880105057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 17:23:08', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 17:23:08');
INSERT INTO `access_log` VALUES (67911, '65.49.15658610181575039', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.194.2.66', '2019-08-15 17:23:38', 197, 0, '', '2019-08-15 17:23:38');
INSERT INTO `access_log` VALUES (67912, '59.71.15658619809052091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.54.229', '2019-08-15 17:39:41', 3, 0, '', '2019-08-15 17:39:41');
INSERT INTO `access_log` VALUES (67913, '59.78.15658619809052099', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_4 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/WIFI Language/zh_CN', '119.137.54.229', '2019-08-15 17:39:41', 12, 2001001000, '服务端发生异常', '2019-08-15 17:39:41');
INSERT INTO `access_log` VALUES (67914, '65.3607.15658673362096917', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.100.23.110', '2019-08-15 19:08:56', 0, 1002001015, '账号未登陆', '2019-08-15 19:08:56');
INSERT INTO `access_log` VALUES (67915, '65.52.15658673362285169', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.100.23.110', '2019-08-15 19:08:56', 0, 1002001015, '账号未登陆', '2019-08-15 19:08:56');
INSERT INTO `access_log` VALUES (67916, '65.54.15658673367255025', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.100.23.110', '2019-08-15 19:08:57', 0, 1002001015, '账号未登陆', '2019-08-15 19:08:57');
INSERT INTO `access_log` VALUES (67917, '65.50.15658673397205131', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.100.23.110', '2019-08-15 19:09:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 19:09:00');
INSERT INTO `access_log` VALUES (67918, '65.46.15658673435285167', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.100.23.110', '2019-08-15 19:09:04', 177, 0, '', '2019-08-15 19:09:04');
INSERT INTO `access_log` VALUES (67919, '65.51.15658673440985207', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.100.23.110', '2019-08-15 19:09:04', 67, 0, '', '2019-08-15 19:09:04');
INSERT INTO `access_log` VALUES (67920, '65.45.15658673441125145', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.100.23.110', '2019-08-15 19:09:04', 53, 0, '', '2019-08-15 19:09:04');
INSERT INTO `access_log` VALUES (67921, '65.53.15658673441135095', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.100.23.110', '2019-08-15 19:09:04', 54, 2001001000, '服务端发生异常', '2019-08-15 19:09:04');
INSERT INTO `access_log` VALUES (67922, '65.47.15658673591215079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.100.23.110', '2019-08-15 19:09:19', 129, 0, '', '2019-08-15 19:09:19');
INSERT INTO `access_log` VALUES (67923, '65.3607.15658673594646919', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.100.23.110', '2019-08-15 19:09:19', 18, 0, '', '2019-08-15 19:09:19');
INSERT INTO `access_log` VALUES (67924, '65.54.15658673594655027', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.100.23.110', '2019-08-15 19:09:19', 11, 2001001000, '服务端发生异常', '2019-08-15 19:09:19');
INSERT INTO `access_log` VALUES (67925, '65.52.15658673594645171', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.100.23.110', '2019-08-15 19:09:19', 20, 0, '', '2019-08-15 19:09:19');
INSERT INTO `access_log` VALUES (67926, '65.53.15658683171675109', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.10', '2019-08-15 19:25:17', 1, 1002001015, '账号未登陆', '2019-08-15 19:25:17');
INSERT INTO `access_log` VALUES (67927, '65.49.15658683171685139', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.10', '2019-08-15 19:25:17', 0, 1002001015, '账号未登陆', '2019-08-15 19:25:17');
INSERT INTO `access_log` VALUES (67928, '65.47.15658683171735093', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.10', '2019-08-15 19:25:17', 0, 1002001015, '账号未登陆', '2019-08-15 19:25:17');
INSERT INTO `access_log` VALUES (67929, '65.52.15658683201165185', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.10', '2019-08-15 19:25:20', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 19:25:20');
INSERT INTO `access_log` VALUES (67930, '65.54.15658683259265041', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.10', '2019-08-15 19:25:26', 79, 0, '', '2019-08-15 19:25:26');
INSERT INTO `access_log` VALUES (67931, '65.50.15658683262425147', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.10', '2019-08-15 19:25:26', 10, 0, '', '2019-08-15 19:25:26');
INSERT INTO `access_log` VALUES (67932, '65.46.15658683262455183', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.10', '2019-08-15 19:25:26', 18, 2001001000, '服务端发生异常', '2019-08-15 19:25:26');
INSERT INTO `access_log` VALUES (67933, '65.51.15658683262505223', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.10', '2019-08-15 19:25:26', 17, 0, '', '2019-08-15 19:25:26');
INSERT INTO `access_log` VALUES (67934, '59.76.15658687862372171', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.139.121.226', '2019-08-15 19:33:06', 10, 0, '', '2019-08-15 19:33:06');
INSERT INTO `access_log` VALUES (67935, '59.73.15658687862372185', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.139.121.226', '2019-08-15 19:33:06', 21, 2001001000, '服务端发生异常', '2019-08-15 19:33:06');
INSERT INTO `access_log` VALUES (67936, '59.79.15658687970832187', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.139.121.226', '2019-08-15 19:33:17', 4, 0, '', '2019-08-15 19:33:17');
INSERT INTO `access_log` VALUES (67937, '59.74.15658687970912199', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.139.121.226', '2019-08-15 19:33:17', 15, 2001001000, '服务端发生异常', '2019-08-15 19:33:17');
INSERT INTO `access_log` VALUES (67938, '65.47.15658691157775105', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-15 19:38:36', 4, 1002001012, '访问令牌已过期', '2019-08-15 19:38:36');
INSERT INTO `access_log` VALUES (67939, '65.53.15658691157775121', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-15 19:38:36', 4, 1002001012, '访问令牌已过期', '2019-08-15 19:38:36');
INSERT INTO `access_log` VALUES (67940, '65.52.15658691158135197', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-15 19:38:36', 3, 1002001012, '访问令牌已过期', '2019-08-15 19:38:36');
INSERT INTO `access_log` VALUES (67941, '65.54.15658691222785053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-15 19:38:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 19:38:42');
INSERT INTO `access_log` VALUES (67942, '65.50.15658691458055159', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-15 19:39:06', 68, 0, '', '2019-08-15 19:39:06');
INSERT INTO `access_log` VALUES (67943, '65.51.15658691462515235', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-15 19:39:06', 11, 0, '', '2019-08-15 19:39:06');
INSERT INTO `access_log` VALUES (67944, '65.45.15658691462575173', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-15 19:39:06', 18, 2001001000, '服务端发生异常', '2019-08-15 19:39:06');
INSERT INTO `access_log` VALUES (67945, '65.49.15658691462595153', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '115.198.222.251', '2019-08-15 19:39:06', 17, 0, '', '2019-08-15 19:39:06');
INSERT INTO `access_log` VALUES (67946, '65.3607.15658709674906971', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.69.43.252', '2019-08-15 20:09:27', 0, 1002001015, '账号未登陆', '2019-08-15 20:09:27');
INSERT INTO `access_log` VALUES (67947, '65.52.15658709674905223', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.69.43.252', '2019-08-15 20:09:27', 1, 1002001015, '账号未登陆', '2019-08-15 20:09:27');
INSERT INTO `access_log` VALUES (67948, '65.54.15658709674985079', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.69.43.252', '2019-08-15 20:09:27', 0, 1002001015, '账号未登陆', '2019-08-15 20:09:27');
INSERT INTO `access_log` VALUES (67949, '65.46.15658709702055221', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.69.43.252', '2019-08-15 20:09:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 20:09:30');
INSERT INTO `access_log` VALUES (67950, '59.72.15658734944202245', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.87.95.18', '2019-08-15 20:51:34', 9, 0, '', '2019-08-15 20:51:34');
INSERT INTO `access_log` VALUES (67951, '59.80.15658734944202217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.87.95.18', '2019-08-15 20:51:34', 15, 2001001000, '服务端发生异常', '2019-08-15 20:51:34');
INSERT INTO `access_log` VALUES (67952, '64.78.15658734994042595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.87.95.18', '2019-08-15 20:51:39', 12, 0, '', '2019-08-15 20:51:39');
INSERT INTO `access_log` VALUES (67953, '64.76.15658734995222593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.87.95.18', '2019-08-15 20:51:40', 3, 0, '', '2019-08-15 20:51:40');
INSERT INTO `access_log` VALUES (67954, '64.83.15658735007512583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.87.95.18', '2019-08-15 20:51:41', 50, 0, '', '2019-08-15 20:51:41');
INSERT INTO `access_log` VALUES (67955, '64.82.15658735049562603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.87.95.18', '2019-08-15 20:51:45', 1, 0, '', '2019-08-15 20:51:45');
INSERT INTO `access_log` VALUES (67956, '64.81.15658735050872591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.87.95.18', '2019-08-15 20:51:45', 1, 0, '', '2019-08-15 20:51:45');
INSERT INTO `access_log` VALUES (67957, '64.79.15658735064232595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.87.95.18', '2019-08-15 20:51:46', 3, 0, '', '2019-08-15 20:51:46');
INSERT INTO `access_log` VALUES (67958, '65.53.15658735956265183', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '183.156.79.114', '2019-08-15 20:53:16', 29, 1002001012, '访问令牌已过期', '2019-08-15 20:53:16');
INSERT INTO `access_log` VALUES (67959, '65.52.15658735956265259', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '183.156.79.114', '2019-08-15 20:53:16', 29, 1002001012, '访问令牌已过期', '2019-08-15 20:53:16');
INSERT INTO `access_log` VALUES (67960, '65.3607.15658735956277007', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '183.156.79.114', '2019-08-15 20:53:16', 29, 1002001012, '访问令牌已过期', '2019-08-15 20:53:16');
INSERT INTO `access_log` VALUES (67961, '59.72.15658751141992267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:18:34', 3, 0, '', '2019-08-15 21:18:34');
INSERT INTO `access_log` VALUES (67962, '59.80.15658751142002239', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:18:34', 13, 2001001000, '服务端发生异常', '2019-08-15 21:18:34');
INSERT INTO `access_log` VALUES (67963, '64.81.15658751185782613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:18:39', 3, 0, '', '2019-08-15 21:18:39');
INSERT INTO `access_log` VALUES (67964, '64.79.15658751187252617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:18:39', 2, 0, '', '2019-08-15 21:18:39');
INSERT INTO `access_log` VALUES (67965, '64.84.15658751200282607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:18:40', 1, 0, '', '2019-08-15 21:18:40');
INSERT INTO `access_log` VALUES (67966, '64.77.15658751210262605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:18:41', 2, 0, '', '2019-08-15 21:18:41');
INSERT INTO `access_log` VALUES (67967, '65.45.15658751350365255', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:18:55', 1, 1002001015, '账号未登陆', '2019-08-15 21:18:55');
INSERT INTO `access_log` VALUES (67968, '65.49.15658751350365235', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:18:55', 0, 1002001015, '账号未登陆', '2019-08-15 21:18:55');
INSERT INTO `access_log` VALUES (67969, '65.51.15658751350415317', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:18:55', 1, 1002001015, '账号未登陆', '2019-08-15 21:18:55');
INSERT INTO `access_log` VALUES (67970, '65.47.15658751370005189', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:18:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 21:18:57');
INSERT INTO `access_log` VALUES (67971, '65.53.15658751412445205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:19:01', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 21:19:01');
INSERT INTO `access_log` VALUES (67972, '65.3607.15658751514667029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:19:11', 369, 0, '', '2019-08-15 21:19:12');
INSERT INTO `access_log` VALUES (67973, '65.54.15658751520395137', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:19:12', 13, 0, '', '2019-08-15 21:19:12');
INSERT INTO `access_log` VALUES (67974, '65.46.15658751520445279', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:19:12', 11, 2001001000, '服务端发生异常', '2019-08-15 21:19:12');
INSERT INTO `access_log` VALUES (67975, '65.50.15658751520455243', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.78.53.82', '2019-08-15 21:19:12', 10, 0, '', '2019-08-15 21:19:12');
INSERT INTO `access_log` VALUES (67976, '59.76.15658823257892353', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '59.63.204.192', '2019-08-15 23:18:46', 9, 0, '', '2019-08-15 23:18:46');
INSERT INTO `access_log` VALUES (67977, '59.73.15658823257902367', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '59.63.204.192', '2019-08-15 23:18:46', 15, 2001001000, '服务端发生异常', '2019-08-15 23:18:46');
INSERT INTO `access_log` VALUES (67978, '64.85.15658823359242743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '59.63.204.192', '2019-08-15 23:18:56', 18, 0, '', '2019-08-15 23:18:56');
INSERT INTO `access_log` VALUES (67979, '64.78.15658823360672715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '59.63.204.192', '2019-08-15 23:18:56', 3, 0, '', '2019-08-15 23:18:56');
INSERT INTO `access_log` VALUES (67980, '64.76.15658823379512713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '59.63.204.192', '2019-08-15 23:18:58', 2, 0, '', '2019-08-15 23:18:58');
INSERT INTO `access_log` VALUES (67981, '64.83.15658823385892703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '59.63.204.192', '2019-08-15 23:18:59', 2, 0, '', '2019-08-15 23:18:59');
INSERT INTO `access_log` VALUES (67982, '64.82.15658823427482723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '59.63.204.192', '2019-08-15 23:19:03', 1, 0, '', '2019-08-15 23:19:03');
INSERT INTO `access_log` VALUES (67983, '64.81.15658823428832711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '59.63.204.192', '2019-08-15 23:19:03', 2, 0, '', '2019-08-15 23:19:03');
INSERT INTO `access_log` VALUES (67984, '64.84.15658823471762705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '59.63.204.192', '2019-08-15 23:19:07', 2, 0, '', '2019-08-15 23:19:07');
INSERT INTO `access_log` VALUES (67985, '64.77.15658823472932703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '59.63.204.192', '2019-08-15 23:19:07', 2, 0, '', '2019-08-15 23:19:07');
INSERT INTO `access_log` VALUES (67986, '59.71.15658823479252365', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '59.63.204.192', '2019-08-15 23:19:08', 3, 0, '', '2019-08-15 23:19:08');
INSERT INTO `access_log` VALUES (67987, '59.78.15658823479252373', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '59.63.204.192', '2019-08-15 23:19:08', 19, 2001001000, '服务端发生异常', '2019-08-15 23:19:08');
INSERT INTO `access_log` VALUES (67988, '65.47.15658836080175303', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.74.154.56', '2019-08-15 23:40:08', 1, 1002001015, '账号未登陆', '2019-08-15 23:40:08');
INSERT INTO `access_log` VALUES (67989, '65.53.15658836080235319', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.74.154.56', '2019-08-15 23:40:08', 1, 1002001015, '账号未登陆', '2019-08-15 23:40:08');
INSERT INTO `access_log` VALUES (67990, '65.52.15658836080665395', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.74.154.56', '2019-08-15 23:40:08', 0, 1002001015, '账号未登陆', '2019-08-15 23:40:08');
INSERT INTO `access_log` VALUES (67991, '65.54.15658836177725251', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.74.154.56', '2019-08-15 23:40:18', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-15 23:40:18');
INSERT INTO `access_log` VALUES (67992, '65.47.15659162895295739', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:44:50', 1, 1002001015, '账号未登陆', '2019-08-16 08:44:50');
INSERT INTO `access_log` VALUES (67993, '65.52.15659162895305835', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:44:50', 1, 1002001015, '账号未登陆', '2019-08-16 08:44:50');
INSERT INTO `access_log` VALUES (67994, '65.51.15659162895655867', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:44:50', 1, 1002001015, '账号未登陆', '2019-08-16 08:44:50');
INSERT INTO `access_log` VALUES (67995, '65.53.15659162924325755', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:44:52', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 08:44:52');
INSERT INTO `access_log` VALUES (67996, '65.3607.15659163072357579', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma &password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:45:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号格式为数字以及字母', '2019-08-16 08:45:07');
INSERT INTO `access_log` VALUES (67997, '65.53.15659164049785757', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma &password=yudaoyuanma &type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:46:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号格式为数字以及字母', '2019-08-16 08:46:45');
INSERT INTO `access_log` VALUES (67998, '65.3607.15659164254347581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:47:05', 133, 0, '', '2019-08-16 08:47:06');
INSERT INTO `access_log` VALUES (67999, '65.54.15659164258945691', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:47:06', 17, 0, '', '2019-08-16 08:47:06');
INSERT INTO `access_log` VALUES (68000, '65.50.15659164258965797', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:47:06', 17, 2001001000, '服务端发生异常', '2019-08-16 08:47:06');
INSERT INTO `access_log` VALUES (68001, '65.46.15659164259495833', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:47:06', 12, 0, '', '2019-08-16 08:47:06');
INSERT INTO `access_log` VALUES (68002, '59.80.15659165933562793', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:49:53', 11, 0, '', '2019-08-16 08:49:53');
INSERT INTO `access_log` VALUES (68003, '59.73.15659165933572825', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:49:53', 26, 2001001000, '服务端发生异常', '2019-08-16 08:49:53');
INSERT INTO `access_log` VALUES (68004, '64.76.15659166003603171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:50:00', 13, 0, '', '2019-08-16 08:50:00');
INSERT INTO `access_log` VALUES (68005, '64.83.15659166004753161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:50:00', 5, 0, '', '2019-08-16 08:50:00');
INSERT INTO `access_log` VALUES (68006, '64.82.15659166016483181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:50:02', 3, 0, '', '2019-08-16 08:50:02');
INSERT INTO `access_log` VALUES (68007, '64.81.15659166025113169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:50:03', 2, 0, '', '2019-08-16 08:50:03');
INSERT INTO `access_log` VALUES (68008, '65.53.15659167775815763', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:52:58', 13, 0, '', '2019-08-16 08:52:58');
INSERT INTO `access_log` VALUES (68009, '65.3607.15659167775927587', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:52:58', 9, 0, '', '2019-08-16 08:52:58');
INSERT INTO `access_log` VALUES (68010, '65.49.15659167775915795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.254', '2019-08-16 08:52:58', 10, 2001001000, '服务端发生异常', '2019-08-16 08:52:58');
INSERT INTO `access_log` VALUES (68011, '65.3607.15659211401197647', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-16 10:05:40', 13, 1002001012, '访问令牌已过期', '2019-08-16 10:05:40');
INSERT INTO `access_log` VALUES (68012, '65.54.15659211401195757', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-16 10:05:40', 26, 1002001012, '访问令牌已过期', '2019-08-16 10:05:40');
INSERT INTO `access_log` VALUES (68013, '65.46.15659211401205897', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-16 10:05:40', 27, 1002001012, '访问令牌已过期', '2019-08-16 10:05:40');
INSERT INTO `access_log` VALUES (68014, '65.50.15659211477545861', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-16 10:05:48', 77, 0, '', '2019-08-16 10:05:48');
INSERT INTO `access_log` VALUES (68015, '65.45.15659211480135875', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-16 10:05:48', 12, 0, '', '2019-08-16 10:05:48');
INSERT INTO `access_log` VALUES (68016, '65.47.15659211480155809', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-16 10:05:48', 11, 2001001000, '服务端发生异常', '2019-08-16 10:05:48');
INSERT INTO `access_log` VALUES (68017, '65.52.15659211480185903', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '222.73.203.10', '2019-08-16 10:05:48', 9, 0, '', '2019-08-16 10:05:48');
INSERT INTO `access_log` VALUES (68018, '65.46.15659221579375913', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.119.247.37', '2019-08-16 10:22:38', 1, 1002001015, '账号未登陆', '2019-08-16 10:22:38');
INSERT INTO `access_log` VALUES (68019, '65.50.15659221579545875', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.119.247.37', '2019-08-16 10:22:38', 1, 1002001015, '账号未登陆', '2019-08-16 10:22:38');
INSERT INTO `access_log` VALUES (68020, '65.52.15659221579645919', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.119.247.37', '2019-08-16 10:22:38', 0, 1002001015, '账号未登陆', '2019-08-16 10:22:38');
INSERT INTO `access_log` VALUES (68021, '65.3607.15659222139947661', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.119.247.37', '2019-08-16 10:23:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 10:23:34');
INSERT INTO `access_log` VALUES (68022, '65.54.15659222216065775', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.119.247.37', '2019-08-16 10:23:42', 66, 0, '', '2019-08-16 10:23:42');
INSERT INTO `access_log` VALUES (68023, '65.46.15659222221615915', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.119.247.37', '2019-08-16 10:23:42', 11, 0, '', '2019-08-16 10:23:42');
INSERT INTO `access_log` VALUES (68024, '65.50.15659222221615877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.119.247.37', '2019-08-16 10:23:42', 12, 2001001000, '服务端发生异常', '2019-08-16 10:23:42');
INSERT INTO `access_log` VALUES (68025, '65.52.15659222221965921', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.119.247.37', '2019-08-16 10:23:42', 106, 0, '', '2019-08-16 10:23:42');
INSERT INTO `access_log` VALUES (68026, '65.46.15659224636265919', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '58.23.3.42', '2019-08-16 10:27:44', 0, 1002001015, '账号未登陆', '2019-08-16 10:27:44');
INSERT INTO `access_log` VALUES (68027, '65.50.15659224636265881', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '58.23.3.42', '2019-08-16 10:27:44', 0, 1002001015, '账号未登陆', '2019-08-16 10:27:44');
INSERT INTO `access_log` VALUES (68028, '65.54.15659224636265779', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '58.23.3.42', '2019-08-16 10:27:44', 0, 1002001015, '账号未登陆', '2019-08-16 10:27:44');
INSERT INTO `access_log` VALUES (68029, '65.52.15659224693215925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '58.23.3.42', '2019-08-16 10:27:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 10:27:49');
INSERT INTO `access_log` VALUES (68030, '65.51.15659224775295957', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '58.23.3.42', '2019-08-16 10:27:58', 85, 0, '', '2019-08-16 10:27:58');
INSERT INTO `access_log` VALUES (68031, '65.53.15659224779305847', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '58.23.3.42', '2019-08-16 10:27:58', 11, 0, '', '2019-08-16 10:27:58');
INSERT INTO `access_log` VALUES (68032, '65.45.15659224779385895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '58.23.3.42', '2019-08-16 10:27:58', 16, 2001001000, '服务端发生异常', '2019-08-16 10:27:58');
INSERT INTO `access_log` VALUES (68033, '65.3607.15659224779397667', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '58.23.3.42', '2019-08-16 10:27:58', 17, 0, '', '2019-08-16 10:27:58');
INSERT INTO `access_log` VALUES (68034, '59.71.15659253462942939', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.233.142.90', '2019-08-16 11:15:46', 10, 0, '', '2019-08-16 11:15:46');
INSERT INTO `access_log` VALUES (68035, '59.78.15659253462972947', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.233.142.90', '2019-08-16 11:15:46', 20, 2001001000, '服务端发生异常', '2019-08-16 11:15:46');
INSERT INTO `access_log` VALUES (68036, '64.76.15659253516413289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.233.142.90', '2019-08-16 11:15:52', 14, 0, '', '2019-08-16 11:15:52');
INSERT INTO `access_log` VALUES (68037, '64.83.15659253517813281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.233.142.90', '2019-08-16 11:15:52', 3, 0, '', '2019-08-16 11:15:52');
INSERT INTO `access_log` VALUES (68038, '64.85.15659253581023319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '113.233.142.90', '2019-08-16 11:15:58', 2, 0, '', '2019-08-16 11:15:58');
INSERT INTO `access_log` VALUES (68039, '64.82.15659253582223299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '113.233.142.90', '2019-08-16 11:15:58', 1, 0, '', '2019-08-16 11:15:58');
INSERT INTO `access_log` VALUES (68040, '64.84.15659253614363287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '113.233.142.90', '2019-08-16 11:16:01', 2, 0, '', '2019-08-16 11:16:01');
INSERT INTO `access_log` VALUES (68041, '64.77.15659253615883277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '113.233.142.90', '2019-08-16 11:16:02', 2, 0, '', '2019-08-16 11:16:02');
INSERT INTO `access_log` VALUES (68042, '59.74.15659255844372959', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.53.174.242', '2019-08-16 11:19:44', 4, 0, '', '2019-08-16 11:19:44');
INSERT INTO `access_log` VALUES (68043, '59.79.15659255844372947', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.53.174.242', '2019-08-16 11:19:44', 16, 2001001000, '服务端发生异常', '2019-08-16 11:19:44');
INSERT INTO `access_log` VALUES (68044, '64.82.15659256190643303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.53.174.242', '2019-08-16 11:20:19', 3, 0, '', '2019-08-16 11:20:19');
INSERT INTO `access_log` VALUES (68045, '64.84.15659256191953291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.53.174.242', '2019-08-16 11:20:19', 2, 0, '', '2019-08-16 11:20:19');
INSERT INTO `access_log` VALUES (68046, '64.81.15659256217233293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.53.174.242', '2019-08-16 11:20:22', 2, 0, '', '2019-08-16 11:20:22');
INSERT INTO `access_log` VALUES (68047, '64.80.15659256218333297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.53.174.242', '2019-08-16 11:20:22', 2, 0, '', '2019-08-16 11:20:22');
INSERT INTO `access_log` VALUES (68048, '65.49.15659264506245931', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:34:11', 1, 1002001015, '账号未登陆', '2019-08-16 11:34:11');
INSERT INTO `access_log` VALUES (68049, '65.54.15659264506495835', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:34:11', 1, 1002001015, '账号未登陆', '2019-08-16 11:34:11');
INSERT INTO `access_log` VALUES (68050, '65.46.15659264506795973', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:34:11', 0, 1002001015, '账号未登陆', '2019-08-16 11:34:11');
INSERT INTO `access_log` VALUES (68051, '65.3607.15659264528647723', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:34:13', 0, 1002001015, '账号未登陆', '2019-08-16 11:34:13');
INSERT INTO `access_log` VALUES (68052, '65.47.15659264528925887', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:34:13', 0, 1002001015, '账号未登陆', '2019-08-16 11:34:13');
INSERT INTO `access_log` VALUES (68053, '65.51.15659264529436011', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:34:13', 0, 1002001015, '账号未登陆', '2019-08-16 11:34:13');
INSERT INTO `access_log` VALUES (68054, '66.50.15659264558550527', 0, 2, 'user-application', '/user-api/admins/user/update_status', 'id=1&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.208.70', '2019-08-16 11:34:16', 1, 1002001015, '账号未登陆', '2019-08-16 11:34:16');
INSERT INTO `access_log` VALUES (68055, '65.53.15659264987535903', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:34:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 11:34:59');
INSERT INTO `access_log` VALUES (68056, '65.50.15659265149375941', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:35:15', 100, 0, '', '2019-08-16 11:35:15');
INSERT INTO `access_log` VALUES (68057, '65.49.15659265154115935', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:35:15', 11, 0, '', '2019-08-16 11:35:15');
INSERT INTO `access_log` VALUES (68058, '65.46.15659265154195977', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:35:15', 9, 2001001000, '服务端发生异常', '2019-08-16 11:35:15');
INSERT INTO `access_log` VALUES (68059, '65.3607.15659265154297725', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:35:15', 8, 0, '', '2019-08-16 11:35:15');
INSERT INTO `access_log` VALUES (68060, '65.54.15659265215655837', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:35:22', 8, 0, '', '2019-08-16 11:35:22');
INSERT INTO `access_log` VALUES (68061, '65.47.15659265215725891', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:35:22', 15, 2001001000, '服务端发生异常', '2019-08-16 11:35:22');
INSERT INTO `access_log` VALUES (68062, '65.51.15659265215766013', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:35:22', 14, 0, '', '2019-08-16 11:35:22');
INSERT INTO `access_log` VALUES (68063, '65.53.15659265294065905', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:35:29', 8, 0, '', '2019-08-16 11:35:29');
INSERT INTO `access_log` VALUES (68064, '65.45.15659265294135953', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:35:29', 10, 2001001000, '服务端发生异常', '2019-08-16 11:35:29');
INSERT INTO `access_log` VALUES (68065, '65.50.15659265294295943', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '60.190.230.35', '2019-08-16 11:35:29', 9, 0, '', '2019-08-16 11:35:29');
INSERT INTO `access_log` VALUES (68066, '65.46.15659368863006117', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.108.85.58', '2019-08-16 14:28:06', 1, 1002001015, '账号未登陆', '2019-08-16 14:28:06');
INSERT INTO `access_log` VALUES (68067, '65.49.15659368863006075', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.108.85.58', '2019-08-16 14:28:06', 1, 1002001015, '账号未登陆', '2019-08-16 14:28:06');
INSERT INTO `access_log` VALUES (68068, '65.3607.15659368863027865', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.108.85.58', '2019-08-16 14:28:06', 0, 1002001015, '账号未登陆', '2019-08-16 14:28:06');
INSERT INTO `access_log` VALUES (68069, '65.51.15659368894386153', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:28:09', 1, 1002001015, '账号未登陆', '2019-08-16 14:28:09');
INSERT INTO `access_log` VALUES (68070, '65.47.15659368894406031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:28:09', 0, 1002001015, '账号未登陆', '2019-08-16 14:28:09');
INSERT INTO `access_log` VALUES (68071, '65.52.15659368894466123', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:28:09', 1, 1002001015, '账号未登陆', '2019-08-16 14:28:09');
INSERT INTO `access_log` VALUES (68072, '65.45.15659368935156093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.108.85.58', '2019-08-16 14:28:14', 157, 0, '', '2019-08-16 14:28:14');
INSERT INTO `access_log` VALUES (68073, '65.53.15659368939336045', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.108.85.58', '2019-08-16 14:28:14', 10, 0, '', '2019-08-16 14:28:14');
INSERT INTO `access_log` VALUES (68074, '65.50.15659368939356083', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.108.85.58', '2019-08-16 14:28:14', 11, 2001001000, '服务端发生异常', '2019-08-16 14:28:14');
INSERT INTO `access_log` VALUES (68075, '65.46.15659368939536119', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.108.85.58', '2019-08-16 14:28:14', 9, 0, '', '2019-08-16 14:28:14');
INSERT INTO `access_log` VALUES (68076, '65.49.15659368973456077', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:28:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 14:28:17');
INSERT INTO `access_log` VALUES (68077, '65.54.15659369077575979', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:28:28', 165, 0, '', '2019-08-16 14:28:28');
INSERT INTO `access_log` VALUES (68078, '65.51.15659369081806155', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:28:28', 10, 0, '', '2019-08-16 14:28:28');
INSERT INTO `access_log` VALUES (68079, '65.52.15659369081846125', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:28:28', 11, 2001001000, '服务端发生异常', '2019-08-16 14:28:28');
INSERT INTO `access_log` VALUES (68080, '65.47.15659369081866033', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:28:28', 10, 0, '', '2019-08-16 14:28:28');
INSERT INTO `access_log` VALUES (68081, '65.50.15659369156046085', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:28:36', 28, 0, '', '2019-08-16 14:28:36');
INSERT INTO `access_log` VALUES (68082, '65.45.15659369155986095', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:28:36', 32, 0, '', '2019-08-16 14:28:36');
INSERT INTO `access_log` VALUES (68083, '65.46.15659369156016121', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:28:36', 31, 2001001000, '服务端发生异常', '2019-08-16 14:28:36');
INSERT INTO `access_log` VALUES (68084, '65.49.15659369260046079', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:28:46', 9, 0, '', '2019-08-16 14:28:46');
INSERT INTO `access_log` VALUES (68085, '65.3607.15659369260097869', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:28:46', 10, 2001001000, '服务端发生异常', '2019-08-16 14:28:46');
INSERT INTO `access_log` VALUES (68086, '65.54.15659369260145981', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:28:46', 8, 0, '', '2019-08-16 14:28:46');
INSERT INTO `access_log` VALUES (68087, '65.47.15659377948346047', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:43:15', 10, 0, '', '2019-08-16 14:43:15');
INSERT INTO `access_log` VALUES (68088, '65.51.15659377948416167', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:43:15', 10, 2001001000, '服务端发生异常', '2019-08-16 14:43:15');
INSERT INTO `access_log` VALUES (68089, '65.49.15659377948516093', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.183.158.214', '2019-08-16 14:43:15', 9, 0, '', '2019-08-16 14:43:15');
INSERT INTO `access_log` VALUES (68090, '65.51.15659386827416179', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:62.0) Gecko/20100101 Firefox/62.0', '122.224.203.210', '2019-08-16 14:58:03', 0, 1002001015, '账号未登陆', '2019-08-16 14:58:03');
INSERT INTO `access_log` VALUES (68091, '65.52.15659386827516151', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:62.0) Gecko/20100101 Firefox/62.0', '122.224.203.210', '2019-08-16 14:58:03', 0, 1002001015, '账号未登陆', '2019-08-16 14:58:03');
INSERT INTO `access_log` VALUES (68092, '65.3607.15659386827737895', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:62.0) Gecko/20100101 Firefox/62.0', '122.224.203.210', '2019-08-16 14:58:03', 1, 1002001015, '账号未登陆', '2019-08-16 14:58:03');
INSERT INTO `access_log` VALUES (68093, '65.45.15659386862176121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:62.0) Gecko/20100101 Firefox/62.0', '122.224.203.210', '2019-08-16 14:58:06', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 14:58:06');
INSERT INTO `access_log` VALUES (68094, '65.50.15659387024146111', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:62.0) Gecko/20100101 Firefox/62.0', '122.224.203.210', '2019-08-16 14:58:22', 66, 0, '', '2019-08-16 14:58:22');
INSERT INTO `access_log` VALUES (68095, '65.46.15659387031386149', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:62.0) Gecko/20100101 Firefox/62.0', '122.224.203.210', '2019-08-16 14:58:23', 11, 0, '', '2019-08-16 14:58:23');
INSERT INTO `access_log` VALUES (68096, '65.54.15659387031486007', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:62.0) Gecko/20100101 Firefox/62.0', '122.224.203.210', '2019-08-16 14:58:23', 10, 2001001000, '服务端发生异常', '2019-08-16 14:58:23');
INSERT INTO `access_log` VALUES (68097, '65.47.15659387031626061', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:62.0) Gecko/20100101 Firefox/62.0', '122.224.203.210', '2019-08-16 14:58:23', 9, 0, '', '2019-08-16 14:58:23');
INSERT INTO `access_log` VALUES (68098, '65.51.15659387109466181', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:62.0) Gecko/20100101 Firefox/62.0', '122.224.203.210', '2019-08-16 14:58:31', 9, 0, '', '2019-08-16 14:58:31');
INSERT INTO `access_log` VALUES (68099, '65.52.15659387109556153', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:62.0) Gecko/20100101 Firefox/62.0', '122.224.203.210', '2019-08-16 14:58:31', 10, 2001001000, '服务端发生异常', '2019-08-16 14:58:31');
INSERT INTO `access_log` VALUES (68100, '65.3607.15659387109637897', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:62.0) Gecko/20100101 Firefox/62.0', '122.224.203.210', '2019-08-16 14:58:31', 9, 0, '', '2019-08-16 14:58:31');
INSERT INTO `access_log` VALUES (68101, '59.76.15659396156893119', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:13:36', 11, 0, '', '2019-08-16 15:13:36');
INSERT INTO `access_log` VALUES (68102, '59.73.15659396156893133', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:13:36', 21, 2001001000, '服务端发生异常', '2019-08-16 15:13:36');
INSERT INTO `access_log` VALUES (68103, '64.79.15659396274183479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:13:47', 11, 0, '', '2019-08-16 15:13:47');
INSERT INTO `access_log` VALUES (68104, '64.83.15659396275273475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:13:48', 3, 0, '', '2019-08-16 15:13:48');
INSERT INTO `access_log` VALUES (68105, '64.84.15659396287323479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:13:49', 2, 0, '', '2019-08-16 15:13:49');
INSERT INTO `access_log` VALUES (68106, '64.82.15659396294483493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:13:49', 2, 0, '', '2019-08-16 15:13:49');
INSERT INTO `access_log` VALUES (68107, '64.81.15659396300443481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:13:50', 2, 0, '', '2019-08-16 15:13:50');
INSERT INTO `access_log` VALUES (68108, '64.78.15659396306873491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:13:51', 3, 0, '', '2019-08-16 15:13:51');
INSERT INTO `access_log` VALUES (68109, '64.80.15659396312723485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:13:51', 2, 0, '', '2019-08-16 15:13:51');
INSERT INTO `access_log` VALUES (68110, '64.76.15659396318333485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:13:52', 2, 0, '', '2019-08-16 15:13:52');
INSERT INTO `access_log` VALUES (68111, '59.79.15659396347253135', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:13:55', 3, 0, '', '2019-08-16 15:13:55');
INSERT INTO `access_log` VALUES (68112, '59.71.15659396347263131', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:13:55', 19, 2001001000, '服务端发生异常', '2019-08-16 15:13:55');
INSERT INTO `access_log` VALUES (68113, '64.79.15659396466133481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:14:07', 2, 0, '', '2019-08-16 15:14:07');
INSERT INTO `access_log` VALUES (68114, '64.83.15659396467163477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:14:07', 1, 0, '', '2019-08-16 15:14:07');
INSERT INTO `access_log` VALUES (68115, '64.84.15659396489543481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:14:09', 2, 0, '', '2019-08-16 15:14:09');
INSERT INTO `access_log` VALUES (68116, '64.82.15659396497553495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:14:10', 2, 0, '', '2019-08-16 15:14:10');
INSERT INTO `access_log` VALUES (68117, '64.81.15659396503253483', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:14:10', 2, 0, '', '2019-08-16 15:14:10');
INSERT INTO `access_log` VALUES (68118, '59.75.15659396535163139', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:14:14', 2, 0, '', '2019-08-16 15:14:14');
INSERT INTO `access_log` VALUES (68119, '59.77.15659396535163119', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:14:14', 13, 2001001000, '服务端发生异常', '2019-08-16 15:14:14');
INSERT INTO `access_log` VALUES (68120, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:16:41', 6, 0, '', '2019-08-16 15:16:41');
INSERT INTO `access_log` VALUES (68121, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=java', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:16:41', 11, 0, '', '2019-08-16 15:16:41');
INSERT INTO `access_log` VALUES (68122, '64.77.15659398020803475', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:16:42', 264, 0, '', '2019-08-16 15:16:42');
INSERT INTO `access_log` VALUES (68123, '64.76.15659398400483489', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=36', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:17:20', 7, 0, '', '2019-08-16 15:17:20');
INSERT INTO `access_log` VALUES (68124, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:17:29', 7, 0, '', '2019-08-16 15:17:29');
INSERT INTO `access_log` VALUES (68125, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:17:29', 9, 0, '', '2019-08-16 15:17:29');
INSERT INTO `access_log` VALUES (68126, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:17:29', 5, 0, '', '2019-08-16 15:17:29');
INSERT INTO `access_log` VALUES (68127, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:17:29', 9, 0, '', '2019-08-16 15:17:29');
INSERT INTO `access_log` VALUES (68128, '64.83.15659398564133481', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=42', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:17:36', 5, 0, '', '2019-08-16 15:17:36');
INSERT INTO `access_log` VALUES (68129, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:17:44', 6, 0, '', '2019-08-16 15:17:44');
INSERT INTO `access_log` VALUES (68130, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:17:44', 4, 0, '', '2019-08-16 15:17:44');
INSERT INTO `access_log` VALUES (68131, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:17:44', 10, 0, '', '2019-08-16 15:17:44');
INSERT INTO `access_log` VALUES (68132, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.35.94.249', '2019-08-16 15:17:44', 10, 0, '', '2019-08-16 15:17:44');
INSERT INTO `access_log` VALUES (68133, '59.80.15659416182833129', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:46:58', 13, 0, '', '2019-08-16 15:46:58');
INSERT INTO `access_log` VALUES (68134, '59.73.15659416182843161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:46:58', 27, 2001001000, '服务端发生异常', '2019-08-16 15:46:58');
INSERT INTO `access_log` VALUES (68135, '64.85.15659416234953541', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:03', 3, 0, '', '2019-08-16 15:47:03');
INSERT INTO `access_log` VALUES (68136, '64.79.15659416235943509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:04', 2, 0, '', '2019-08-16 15:47:04');
INSERT INTO `access_log` VALUES (68137, '64.83.15659416248563505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:05', 2, 0, '', '2019-08-16 15:47:05');
INSERT INTO `access_log` VALUES (68138, '64.84.15659416254253509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:05', 2, 0, '', '2019-08-16 15:47:05');
INSERT INTO `access_log` VALUES (68139, '64.81.15659416261513511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:06', 2, 0, '', '2019-08-16 15:47:06');
INSERT INTO `access_log` VALUES (68140, '64.77.15659416272393501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:07', 2, 0, '', '2019-08-16 15:47:07');
INSERT INTO `access_log` VALUES (68141, '59.74.15659416300253175', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:10', 3, 0, '', '2019-08-16 15:47:10');
INSERT INTO `access_log` VALUES (68142, '59.79.15659416300283163', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:10', 28, 2001001000, '服务端发生异常', '2019-08-16 15:47:10');
INSERT INTO `access_log` VALUES (68143, '64.78.15659416322963521', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:12', 3, 0, '', '2019-08-16 15:47:12');
INSERT INTO `access_log` VALUES (68144, '64.80.15659416324543515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:12', 2, 0, '', '2019-08-16 15:47:12');
INSERT INTO `access_log` VALUES (68145, '64.76.15659416334883515', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:13', 2, 0, '', '2019-08-16 15:47:13');
INSERT INTO `access_log` VALUES (68146, '64.85.15659416337713543', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:14', 2, 0, '', '2019-08-16 15:47:14');
INSERT INTO `access_log` VALUES (68147, '59.71.15659416346943159', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:15', 2, 0, '', '2019-08-16 15:47:15');
INSERT INTO `access_log` VALUES (68148, '59.78.15659416346943167', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:15', 15, 2001001000, '服务端发生异常', '2019-08-16 15:47:15');
INSERT INTO `access_log` VALUES (68149, '65.52.15659416494096193', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:29', 3, 1002001012, '访问令牌已过期', '2019-08-16 15:47:29');
INSERT INTO `access_log` VALUES (68150, '65.49.15659416494096147', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:29', 4, 1002001012, '访问令牌已过期', '2019-08-16 15:47:29');
INSERT INTO `access_log` VALUES (68151, '65.51.15659416494106221', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:29', 4, 1002001012, '访问令牌已过期', '2019-08-16 15:47:29');
INSERT INTO `access_log` VALUES (68152, '65.45.15659416594106163', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:39', 93, 0, '', '2019-08-16 15:47:40');
INSERT INTO `access_log` VALUES (68153, '65.50.15659416598576153', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:40', 366, 2001001000, '服务端发生异常', '2019-08-16 15:47:40');
INSERT INTO `access_log` VALUES (68154, '65.53.15659416598436115', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:40', 381, 0, '', '2019-08-16 15:47:40');
INSERT INTO `access_log` VALUES (68155, '65.47.15659416598666103', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.88.161.47', '2019-08-16 15:47:40', 358, 0, '', '2019-08-16 15:47:40');
INSERT INTO `access_log` VALUES (68156, '65.52.15659429057296211', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.216.116', '2019-08-16 16:08:26', 5, 1002001012, '访问令牌已过期', '2019-08-16 16:08:26');
INSERT INTO `access_log` VALUES (68157, '65.3607.15659429057307955', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.216.116', '2019-08-16 16:08:26', 5, 1002001012, '访问令牌已过期', '2019-08-16 16:08:26');
INSERT INTO `access_log` VALUES (68158, '65.51.15659429057296239', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.216.116', '2019-08-16 16:08:26', 5, 1002001012, '访问令牌已过期', '2019-08-16 16:08:26');
INSERT INTO `access_log` VALUES (68159, '65.45.15659429095436181', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.216.116', '2019-08-16 16:08:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 16:08:30');
INSERT INTO `access_log` VALUES (68160, '65.47.15659429259366121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.216.116', '2019-08-16 16:08:46', 205, 0, '', '2019-08-16 16:08:46');
INSERT INTO `access_log` VALUES (68161, '65.53.15659429263926133', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.216.116', '2019-08-16 16:08:46', 12, 0, '', '2019-08-16 16:08:46');
INSERT INTO `access_log` VALUES (68162, '65.46.15659429263956209', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.216.116', '2019-08-16 16:08:46', 9, 0, '', '2019-08-16 16:08:46');
INSERT INTO `access_log` VALUES (68163, '65.54.15659429263956067', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.216.116', '2019-08-16 16:08:46', 10, 2001001000, '服务端发生异常', '2019-08-16 16:08:46');
INSERT INTO `access_log` VALUES (68164, '65.51.15659434046976247', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.17.26.186', '2019-08-16 16:16:45', 0, 1002001015, '账号未登陆', '2019-08-16 16:16:45');
INSERT INTO `access_log` VALUES (68165, '65.3607.15659434046977963', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.17.26.186', '2019-08-16 16:16:45', 1, 1002001015, '账号未登陆', '2019-08-16 16:16:45');
INSERT INTO `access_log` VALUES (68166, '65.45.15659434046996189', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.17.26.186', '2019-08-16 16:16:45', 1, 1002001015, '账号未登陆', '2019-08-16 16:16:45');
INSERT INTO `access_log` VALUES (68167, '65.47.15659434144666129', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.17.26.186', '2019-08-16 16:16:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 16:16:54');
INSERT INTO `access_log` VALUES (68168, '65.54.15659434240946075', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.17.26.186', '2019-08-16 16:17:04', 90, 0, '', '2019-08-16 16:17:04');
INSERT INTO `access_log` VALUES (68169, '65.53.15659434245316141', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.17.26.186', '2019-08-16 16:17:05', 11, 0, '', '2019-08-16 16:17:05');
INSERT INTO `access_log` VALUES (68170, '65.46.15659434245356217', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.17.26.186', '2019-08-16 16:17:05', 10, 2001001000, '服务端发生异常', '2019-08-16 16:17:05');
INSERT INTO `access_log` VALUES (68171, '65.49.15659434245426175', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.17.26.186', '2019-08-16 16:17:05', 9, 0, '', '2019-08-16 16:17:05');
INSERT INTO `access_log` VALUES (68172, '65.51.15659436269946251', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '218.17.26.186', '2019-08-16 16:20:27', 0, 1002001015, '账号未登陆', '2019-08-16 16:20:27');
INSERT INTO `access_log` VALUES (68173, '65.3607.15659436269957967', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '218.17.26.186', '2019-08-16 16:20:27', 0, 1002001015, '账号未登陆', '2019-08-16 16:20:27');
INSERT INTO `access_log` VALUES (68174, '65.50.15659436269996183', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '218.17.26.186', '2019-08-16 16:20:27', 0, 1002001015, '账号未登陆', '2019-08-16 16:20:27');
INSERT INTO `access_log` VALUES (68175, '65.54.15659436468196079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '218.17.26.186', '2019-08-16 16:20:47', 55, 0, '', '2019-08-16 16:20:47');
INSERT INTO `access_log` VALUES (68176, '65.53.15659436471686145', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '218.17.26.186', '2019-08-16 16:20:47', 9, 0, '', '2019-08-16 16:20:47');
INSERT INTO `access_log` VALUES (68177, '65.49.15659436471696181', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '218.17.26.186', '2019-08-16 16:20:47', 11, 2001001000, '服务端发生异常', '2019-08-16 16:20:47');
INSERT INTO `access_log` VALUES (68178, '65.46.15659436471716223', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '218.17.26.186', '2019-08-16 16:20:47', 9, 0, '', '2019-08-16 16:20:47');
INSERT INTO `access_log` VALUES (68179, '65.45.15659437716906199', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.0.64', '2019-08-16 16:22:52', 0, 1002001015, '账号未登陆', '2019-08-16 16:22:52');
INSERT INTO `access_log` VALUES (68180, '65.49.15659437716896183', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.0.64', '2019-08-16 16:22:52', 0, 1002001015, '账号未登陆', '2019-08-16 16:22:52');
INSERT INTO `access_log` VALUES (68181, '65.46.15659437716896225', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.0.64', '2019-08-16 16:22:52', 0, 1002001015, '账号未登陆', '2019-08-16 16:22:52');
INSERT INTO `access_log` VALUES (68182, '65.50.15659437776346187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.0.64', '2019-08-16 16:22:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 16:22:58');
INSERT INTO `access_log` VALUES (68183, '65.51.15659437798356255', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.228.0.64', '2019-08-16 16:23:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 16:23:00');
INSERT INTO `access_log` VALUES (68184, '59.80.15659438863903161', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.17.26.186', '2019-08-16 16:24:46', 9, 0, '', '2019-08-16 16:24:46');
INSERT INTO `access_log` VALUES (68185, '59.72.15659438863913189', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.17.26.186', '2019-08-16 16:24:46', 18, 2001001000, '服务端发生异常', '2019-08-16 16:24:46');
INSERT INTO `access_log` VALUES (68186, '65.3607.15659439263397973', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-16 16:25:26', 0, 1002001015, '账号未登陆', '2019-08-16 16:25:26');
INSERT INTO `access_log` VALUES (68187, '65.47.15659439263426141', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-16 16:25:26', 1, 1002001015, '账号未登陆', '2019-08-16 16:25:26');
INSERT INTO `access_log` VALUES (68188, '65.54.15659439263466085', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-16 16:25:26', 0, 1002001015, '账号未登陆', '2019-08-16 16:25:26');
INSERT INTO `access_log` VALUES (68189, '65.53.15659439346046151', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-16 16:25:35', 54, 0, '', '2019-08-16 16:25:35');
INSERT INTO `access_log` VALUES (68190, '65.45.15659439348736203', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-16 16:25:35', 10, 0, '', '2019-08-16 16:25:35');
INSERT INTO `access_log` VALUES (68191, '65.46.15659439348786229', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-16 16:25:35', 17, 0, '', '2019-08-16 16:25:35');
INSERT INTO `access_log` VALUES (68192, '65.49.15659439348776187', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.175.27.178', '2019-08-16 16:25:35', 17, 2001001000, '服务端发生异常', '2019-08-16 16:25:35');
INSERT INTO `access_log` VALUES (68193, '59.80.15659440017003163', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.171.98', '2019-08-16 16:26:42', 3, 0, '', '2019-08-16 16:26:42');
INSERT INTO `access_log` VALUES (68194, '59.72.15659440017003191', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.171.98', '2019-08-16 16:26:42', 12, 2001001000, '服务端发生异常', '2019-08-16 16:26:42');
INSERT INTO `access_log` VALUES (68195, '59.77.15659445424443187', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.129.232.234', '2019-08-16 16:35:42', 3, 0, '', '2019-08-16 16:35:42');
INSERT INTO `access_log` VALUES (68196, '59.75.15659445424453207', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.129.232.234', '2019-08-16 16:35:42', 13, 2001001000, '服务端发生异常', '2019-08-16 16:35:42');
INSERT INTO `access_log` VALUES (68197, '65.50.15659445538606199', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.129.232.234', '2019-08-16 16:35:54', 0, 1002001015, '账号未登陆', '2019-08-16 16:35:54');
INSERT INTO `access_log` VALUES (68198, '65.51.15659445538616267', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.129.232.234', '2019-08-16 16:35:54', 1, 1002001015, '账号未登陆', '2019-08-16 16:35:54');
INSERT INTO `access_log` VALUES (68199, '65.47.15659445538716151', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.129.232.234', '2019-08-16 16:35:54', 0, 1002001015, '账号未登陆', '2019-08-16 16:35:54');
INSERT INTO `access_log` VALUES (68200, '65.54.15659445564516095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.129.232.234', '2019-08-16 16:35:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 16:35:56');
INSERT INTO `access_log` VALUES (68201, '65.53.15659445583506161', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.129.232.234', '2019-08-16 16:35:58', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 16:35:58');
INSERT INTO `access_log` VALUES (68202, '65.49.15659445685066197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.129.232.234', '2019-08-16 16:36:09', 133, 0, '', '2019-08-16 16:36:09');
INSERT INTO `access_log` VALUES (68203, '65.46.15659445690156239', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.129.232.234', '2019-08-16 16:36:09', 20, 0, '', '2019-08-16 16:36:09');
INSERT INTO `access_log` VALUES (68204, '65.52.15659445690256243', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.129.232.234', '2019-08-16 16:36:09', 13, 2001001000, '服务端发生异常', '2019-08-16 16:36:09');
INSERT INTO `access_log` VALUES (68205, '65.50.15659445690356201', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.129.232.234', '2019-08-16 16:36:09', 9, 0, '', '2019-08-16 16:36:09');
INSERT INTO `access_log` VALUES (68206, '65.3607.15659445881047985', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.153.122', '2019-08-16 16:36:28', 8, 0, '', '2019-08-16 16:36:28');
INSERT INTO `access_log` VALUES (68207, '65.47.15659445881146153', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.129.232.234', '2019-08-16 16:36:28', 9, 2001001000, '服务端发生异常', '2019-08-16 16:36:28');
INSERT INTO `access_log` VALUES (68208, '65.54.15659445881196097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.129.232.234', '2019-08-16 16:36:28', 7, 0, '', '2019-08-16 16:36:28');
INSERT INTO `access_log` VALUES (68209, '59.75.15659454188433219', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 16:50:19', 3, 0, '', '2019-08-16 16:50:19');
INSERT INTO `access_log` VALUES (68210, '59.77.15659454188423199', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 16:50:19', 13, 2001001000, '服务端发生异常', '2019-08-16 16:50:19');
INSERT INTO `access_log` VALUES (68211, '65.51.15659454362626281', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 16:50:36', 1, 1002001015, '账号未登陆', '2019-08-16 16:50:36');
INSERT INTO `access_log` VALUES (68212, '65.3607.15659454362667997', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 16:50:36', 0, 1002001015, '账号未登陆', '2019-08-16 16:50:36');
INSERT INTO `access_log` VALUES (68213, '65.54.15659454365666109', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 16:50:37', 1, 1002001015, '账号未登陆', '2019-08-16 16:50:37');
INSERT INTO `access_log` VALUES (68214, '65.47.15659454386846165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 16:50:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 16:50:39');
INSERT INTO `access_log` VALUES (68215, '65.53.15659464923046189', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:08:12', 0, 1002001015, '账号未登陆', '2019-08-16 17:08:12');
INSERT INTO `access_log` VALUES (68216, '65.47.15659464923126179', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:08:12', 0, 1002001015, '账号未登陆', '2019-08-16 17:08:12');
INSERT INTO `access_log` VALUES (68217, '65.45.15659464923116241', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:08:12', 0, 1002001015, '账号未登陆', '2019-08-16 17:08:12');
INSERT INTO `access_log` VALUES (68218, '65.49.15659464965236227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:08:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 17:08:17');
INSERT INTO `access_log` VALUES (68219, '65.46.15659465011746269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:08:21', 53, 0, '', '2019-08-16 17:08:21');
INSERT INTO `access_log` VALUES (68220, '65.50.15659465015096229', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:08:22', 12, 2001001000, '服务端发生异常', '2019-08-16 17:08:22');
INSERT INTO `access_log` VALUES (68221, '65.52.15659465015146273', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:08:22', 9, 0, '', '2019-08-16 17:08:22');
INSERT INTO `access_log` VALUES (68222, '65.3607.15659465015158015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:08:22', 8, 0, '', '2019-08-16 17:08:22');
INSERT INTO `access_log` VALUES (68223, '65.47.15659465231776181', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:08:43', 9, 0, '', '2019-08-16 17:08:43');
INSERT INTO `access_log` VALUES (68224, '65.53.15659465231806191', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:08:43', 10, 2001001000, '服务端发生异常', '2019-08-16 17:08:43');
INSERT INTO `access_log` VALUES (68225, '65.45.15659465231846243', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:08:43', 8, 0, '', '2019-08-16 17:08:43');
INSERT INTO `access_log` VALUES (68226, '65.46.15659465392216271', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:08:59', 9, 0, '', '2019-08-16 17:08:59');
INSERT INTO `access_log` VALUES (68227, '65.52.15659465392246275', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:08:59', 9, 2001001000, '服务端发生异常', '2019-08-16 17:08:59');
INSERT INTO `access_log` VALUES (68228, '65.50.15659465392266231', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:08:59', 9, 0, '', '2019-08-16 17:08:59');
INSERT INTO `access_log` VALUES (68229, '65.3607.15659465436378017', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:09:04', 16, 0, '', '2019-08-16 17:09:04');
INSERT INTO `access_log` VALUES (68230, '65.51.15659465436396299', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:09:04', 16, 2001001000, '服务端发生异常', '2019-08-16 17:09:04');
INSERT INTO `access_log` VALUES (68231, '65.54.15659465436506129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '111.121.69.56', '2019-08-16 17:09:04', 8, 0, '', '2019-08-16 17:09:04');
INSERT INTO `access_log` VALUES (68232, '59.79.15659466413843233', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3759.400', '222.240.161.74', '2019-08-16 17:10:41', 2, 0, '', '2019-08-16 17:10:41');
INSERT INTO `access_log` VALUES (68233, '59.76.15659466413843217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3759.400', '222.240.161.74', '2019-08-16 17:10:41', 12, 2001001000, '服务端发生异常', '2019-08-16 17:10:41');
INSERT INTO `access_log` VALUES (68234, '65.51.15659466491816301', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 17:10:49', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 17:10:49');
INSERT INTO `access_log` VALUES (68235, '65.3607.15659466569758019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 17:10:57', 74, 0, '', '2019-08-16 17:10:57');
INSERT INTO `access_log` VALUES (68236, '65.47.15659466572976185', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 17:10:57', 9, 0, '', '2019-08-16 17:10:57');
INSERT INTO `access_log` VALUES (68237, '65.53.15659466573076195', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 17:10:57', 9, 0, '', '2019-08-16 17:10:57');
INSERT INTO `access_log` VALUES (68238, '65.45.15659466575996247', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 17:10:58', 11, 2001001000, '服务端发生异常', '2019-08-16 17:10:58');
INSERT INTO `access_log` VALUES (68239, '59.75.15659466816293237', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 17:11:22', 2, 0, '', '2019-08-16 17:11:22');
INSERT INTO `access_log` VALUES (68240, '59.78.15659466816283237', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 17:11:22', 10, 2001001000, '服务端发生异常', '2019-08-16 17:11:22');
INSERT INTO `access_log` VALUES (68241, '64.80.15659466876563583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 17:11:28', 12, 0, '', '2019-08-16 17:11:28');
INSERT INTO `access_log` VALUES (68242, '64.76.15659466878093583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 17:11:28', 3, 0, '', '2019-08-16 17:11:28');
INSERT INTO `access_log` VALUES (68243, '64.85.15659466916863611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 17:11:32', 2, 0, '', '2019-08-16 17:11:32');
INSERT INTO `access_log` VALUES (68244, '64.79.15659466919343579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 17:11:32', 2, 0, '', '2019-08-16 17:11:32');
INSERT INTO `access_log` VALUES (68245, '64.78.15659469063803593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 17:15:06', 3, 0, '', '2019-08-16 17:15:06');
INSERT INTO `access_log` VALUES (68246, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 17:15:06', 6, 0, '', '2019-08-16 17:15:06');
INSERT INTO `access_log` VALUES (68247, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 17:15:08', 5, 0, '', '2019-08-16 17:15:08');
INSERT INTO `access_log` VALUES (68248, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 17:15:09', 5, 0, '', '2019-08-16 17:15:09');
INSERT INTO `access_log` VALUES (68249, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 17:15:10', 6, 0, '', '2019-08-16 17:15:10');
INSERT INTO `access_log` VALUES (68250, '64.80.15659469100173587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 17:15:10', 2, 0, '', '2019-08-16 17:15:10');
INSERT INTO `access_log` VALUES (68251, '64.76.15659469101203587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 17:15:10', 2, 0, '', '2019-08-16 17:15:10');
INSERT INTO `access_log` VALUES (68252, '64.85.15659469111253615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 17:15:11', 2, 0, '', '2019-08-16 17:15:11');
INSERT INTO `access_log` VALUES (68253, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 17:15:11', 5, 0, '', '2019-08-16 17:15:11');
INSERT INTO `access_log` VALUES (68254, '64.79.15659469125173583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 17:15:13', 2, 0, '', '2019-08-16 17:15:13');
INSERT INTO `access_log` VALUES (68255, '64.83.15659469126733579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 17:15:13', 2, 0, '', '2019-08-16 17:15:13');
INSERT INTO `access_log` VALUES (68256, '64.84.15659469139913583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 17:15:14', 2, 0, '', '2019-08-16 17:15:14');
INSERT INTO `access_log` VALUES (68257, '64.82.15659469145063597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.50.25', '2019-08-16 17:15:15', 2, 0, '', '2019-08-16 17:15:15');
INSERT INTO `access_log` VALUES (68258, '65.47.15659481335166205', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:35:34', 0, 1002001015, '账号未登陆', '2019-08-16 17:35:34');
INSERT INTO `access_log` VALUES (68259, '65.45.15659481335176267', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:35:34', 1, 1002001015, '账号未登陆', '2019-08-16 17:35:34');
INSERT INTO `access_log` VALUES (68260, '65.49.15659481335186253', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:35:34', 1, 1002001015, '账号未登陆', '2019-08-16 17:35:34');
INSERT INTO `access_log` VALUES (68261, '65.50.15659481357146255', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:35:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 17:35:36');
INSERT INTO `access_log` VALUES (68262, '65.46.15659481397756295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:35:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 17:35:40');
INSERT INTO `access_log` VALUES (68263, '65.53.15659481912956217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:36:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-16 17:36:31');
INSERT INTO `access_log` VALUES (68264, '65.45.15659481959536269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai1&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:36:36', 78, 0, '', '2019-08-16 17:36:36');
INSERT INTO `access_log` VALUES (68265, '65.49.15659481962816255', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:36:36', 18, 0, '', '2019-08-16 17:36:36');
INSERT INTO `access_log` VALUES (68266, '65.47.15659481962816207', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:36:36', 18, 0, '', '2019-08-16 17:36:36');
INSERT INTO `access_log` VALUES (68267, '65.50.15659481962856257', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:36:36', 16, 0, '', '2019-08-16 17:36:36');
INSERT INTO `access_log` VALUES (68268, '62.81.15659482010251969', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:36:41', 30, 0, '', '2019-08-16 17:36:41');
INSERT INTO `access_log` VALUES (68269, '59.80.15659482092453221', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:36:49', 16, 0, '', '2019-08-16 17:36:49');
INSERT INTO `access_log` VALUES (68270, '59.76.15659482132983239', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:36:53', 49, 2001001000, '服务端发生异常', '2019-08-16 17:36:53');
INSERT INTO `access_log` VALUES (68271, '59.79.15659482166953255', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:36:57', 15, 0, '', '2019-08-16 17:36:57');
INSERT INTO `access_log` VALUES (68272, '59.74.15659482226593267', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:37:03', 15, 0, '', '2019-08-16 17:37:03');
INSERT INTO `access_log` VALUES (68273, '59.73.15659482247623253', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:37:05', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-16 17:37:05');
INSERT INTO `access_log` VALUES (68274, '65.51.15659482275656325', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:37:08', 27, 0, '', '2019-08-16 17:37:08');
INSERT INTO `access_log` VALUES (68275, '65.3607.15659482293348043', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:37:09', 19, 0, '', '2019-08-16 17:37:09');
INSERT INTO `access_log` VALUES (68276, '65.53.15659482433756219', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:37:23', 9, 0, '', '2019-08-16 17:37:23');
INSERT INTO `access_log` VALUES (68277, '65.50.15659482471546259', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:37:27', 13, 0, '', '2019-08-16 17:37:27');
INSERT INTO `access_log` VALUES (68278, '62.85.15659482565162017', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:37:37', 14, 0, '', '2019-08-16 17:37:37');
INSERT INTO `access_log` VALUES (68279, '64.77.15659482589943593', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:37:39', 12, 0, '', '2019-08-16 17:37:39');
INSERT INTO `access_log` VALUES (68280, '64.81.15659482589943603', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:37:39', 15, 0, '', '2019-08-16 17:37:39');
INSERT INTO `access_log` VALUES (68281, '64.80.15659482671563607', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:37:47', 15, 0, '', '2019-08-16 17:37:47');
INSERT INTO `access_log` VALUES (68282, '64.78.15659482671553613', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:37:47', 23, 0, '', '2019-08-16 17:37:47');
INSERT INTO `access_log` VALUES (68283, '64.79.15659482932243603', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:38:13', 12, 0, '', '2019-08-16 17:38:13');
INSERT INTO `access_log` VALUES (68284, '64.83.15659482962663599', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=3&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:38:16', 11, 0, '', '2019-08-16 17:38:16');
INSERT INTO `access_log` VALUES (68285, '66.49.15659483054170817', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:38:25', 19, 0, '', '2019-08-16 17:38:25');
INSERT INTO `access_log` VALUES (68286, '59.79.15659483184243257', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:38:38', 12, 0, '', '2019-08-16 17:38:38');
INSERT INTO `access_log` VALUES (68287, '59.74.15659483222933269', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:38:42', 23, 2001001000, '服务端发生异常', '2019-08-16 17:38:42');
INSERT INTO `access_log` VALUES (68288, '65.47.15659484037516211', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:40:04', 9, 0, '', '2019-08-16 17:40:04');
INSERT INTO `access_log` VALUES (68289, '65.49.15659484058016259', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:40:06', 14, 0, '', '2019-08-16 17:40:06');
INSERT INTO `access_log` VALUES (68290, '65.51.15659492381846339', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:53:58', 18, 0, '', '2019-08-16 17:53:58');
INSERT INTO `access_log` VALUES (68291, '59.73.15659492394783267', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:53:59', 19, 2001001000, '服务端发生异常', '2019-08-16 17:53:59');
INSERT INTO `access_log` VALUES (68292, '59.75.15659492402323273', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:54:00', 10, 0, '', '2019-08-16 17:54:00');
INSERT INTO `access_log` VALUES (68293, '66.53.15659492413880827', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:54:01', 13, 0, '', '2019-08-16 17:54:01');
INSERT INTO `access_log` VALUES (68294, '65.50.15659493353496275', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:55:35', 11, 0, '', '2019-08-16 17:55:35');
INSERT INTO `access_log` VALUES (68295, '65.47.15659493353576225', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:55:35', 12, 0, '', '2019-08-16 17:55:35');
INSERT INTO `access_log` VALUES (68296, '65.49.15659493353576273', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:55:35', 12, 0, '', '2019-08-16 17:55:35');
INSERT INTO `access_log` VALUES (68297, '59.71.15659493357573265', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:55:36', 231, 0, '', '2019-08-16 17:55:36');
INSERT INTO `access_log` VALUES (68298, '62.82.15659495257222027', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:58:46', 412, 0, '', '2019-08-16 17:58:46');
INSERT INTO `access_log` VALUES (68299, '62.84.15659495320912015', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:58:52', 13, 0, '', '2019-08-16 17:58:52');
INSERT INTO `access_log` VALUES (68300, '64.78.15659495354663631', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:58:55', 10, 0, '', '2019-08-16 17:58:55');
INSERT INTO `access_log` VALUES (68301, '64.81.15659495354653621', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:58:55', 13, 0, '', '2019-08-16 17:58:55');
INSERT INTO `access_log` VALUES (68302, '64.76.15659495386713625', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:58:59', 11, 0, '', '2019-08-16 17:58:59');
INSERT INTO `access_log` VALUES (68303, '64.80.15659495386713625', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.48.105.51', '2019-08-16 17:58:59', 12, 0, '', '2019-08-16 17:58:59');
INSERT INTO `access_log` VALUES (68304, '59.78.15659502043233287', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:04', 9, 0, '', '2019-08-16 18:10:04');
INSERT INTO `access_log` VALUES (68305, '59.75.15659502043183287', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:04', 19, 2001001000, '服务端发生异常', '2019-08-16 18:10:04');
INSERT INTO `access_log` VALUES (68306, '64.77.15659502155423621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:16', 3, 0, '', '2019-08-16 18:10:16');
INSERT INTO `access_log` VALUES (68307, '64.78.15659502157303641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:16', 2, 0, '', '2019-08-16 18:10:16');
INSERT INTO `access_log` VALUES (68308, '64.81.15659502192953631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:19', 2, 0, '', '2019-08-16 18:10:19');
INSERT INTO `access_log` VALUES (68309, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:19', 5, 0, '', '2019-08-16 18:10:19');
INSERT INTO `access_log` VALUES (68310, '64.80.15659502209323635', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:21', 60, 0, '', '2019-08-16 18:10:21');
INSERT INTO `access_log` VALUES (68311, '64.85.15659502257353663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:26', 1, 0, '', '2019-08-16 18:10:26');
INSERT INTO `access_log` VALUES (68312, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:26', 6, 0, '', '2019-08-16 18:10:26');
INSERT INTO `access_log` VALUES (68313, '64.79.15659502264523631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:26', 2, 0, '', '2019-08-16 18:10:26');
INSERT INTO `access_log` VALUES (68314, '64.83.15659502266413627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:27', 2, 0, '', '2019-08-16 18:10:27');
INSERT INTO `access_log` VALUES (68315, '59.80.15659502275173251', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:28', 2, 0, '', '2019-08-16 18:10:28');
INSERT INTO `access_log` VALUES (68316, '59.72.15659502275143279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:28', 12, 2001001000, '服务端发生异常', '2019-08-16 18:10:28');
INSERT INTO `access_log` VALUES (68317, '59.74.15659502318503295', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:32', 2, 0, '', '2019-08-16 18:10:32');
INSERT INTO `access_log` VALUES (68318, '59.76.15659502318493269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:32', 12, 2001001000, '服务端发生异常', '2019-08-16 18:10:32');
INSERT INTO `access_log` VALUES (68319, '64.82.15659502358253645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:36', 2, 0, '', '2019-08-16 18:10:36');
INSERT INTO `access_log` VALUES (68320, '64.77.15659502364043623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:36', 2, 0, '', '2019-08-16 18:10:36');
INSERT INTO `access_log` VALUES (68321, '59.71.15659502382433279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:38', 12, 2001001000, '服务端发生异常', '2019-08-16 18:10:38');
INSERT INTO `access_log` VALUES (68322, '59.73.15659502382583283', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:38', 2, 0, '', '2019-08-16 18:10:38');
INSERT INTO `access_log` VALUES (68323, '64.78.15659502426963643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:43', 2, 0, '', '2019-08-16 18:10:43');
INSERT INTO `access_log` VALUES (68324, '64.81.15659502428503633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:43', 1, 0, '', '2019-08-16 18:10:43');
INSERT INTO `access_log` VALUES (68325, '64.76.15659502471693637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:47', 2, 0, '', '2019-08-16 18:10:47');
INSERT INTO `access_log` VALUES (68326, '64.80.15659502476073637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:10:48', 2, 0, '', '2019-08-16 18:10:48');
INSERT INTO `access_log` VALUES (68327, '64.79.15659502609103633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:11:01', 2, 0, '', '2019-08-16 18:11:01');
INSERT INTO `access_log` VALUES (68328, '64.83.15659502612043629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:11:01', 2, 0, '', '2019-08-16 18:11:01');
INSERT INTO `access_log` VALUES (68329, '59.78.15659502617193289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:11:02', 2, 0, '', '2019-08-16 18:11:02');
INSERT INTO `access_log` VALUES (68330, '59.77.15659502617233269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.166.44', '2019-08-16 18:11:02', 14, 2001001000, '服务端发生异常', '2019-08-16 18:11:02');
INSERT INTO `access_log` VALUES (68331, '59.78.15659506592233295', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.158', '2019-08-16 18:17:39', 2, 0, '', '2019-08-16 18:17:39');
INSERT INTO `access_log` VALUES (68332, '59.75.15659506592233295', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '119.137.52.158', '2019-08-16 18:17:39', 13, 2001001000, '服务端发生异常', '2019-08-16 18:17:39');
INSERT INTO `access_log` VALUES (68333, '64.85.15659506698693671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '119.137.52.158', '2019-08-16 18:17:50', 2, 0, '', '2019-08-16 18:17:50');
INSERT INTO `access_log` VALUES (68334, '64.79.15659506700663639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '119.137.52.158', '2019-08-16 18:17:50', 2, 0, '', '2019-08-16 18:17:50');
INSERT INTO `access_log` VALUES (68335, '64.84.15659506749943639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '119.137.52.158', '2019-08-16 18:17:55', 2, 0, '', '2019-08-16 18:17:55');
INSERT INTO `access_log` VALUES (68336, '64.82.15659506751743653', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '119.137.52.158', '2019-08-16 18:17:55', 2, 0, '', '2019-08-16 18:17:55');
INSERT INTO `access_log` VALUES (68337, '64.77.15659506785243631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '119.137.52.158', '2019-08-16 18:17:59', 1, 0, '', '2019-08-16 18:17:59');
INSERT INTO `access_log` VALUES (68338, '64.78.15659506786383651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '119.137.52.158', '2019-08-16 18:17:59', 1, 0, '', '2019-08-16 18:17:59');
INSERT INTO `access_log` VALUES (68339, '59.80.15659506800503259', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '119.137.52.158', '2019-08-16 18:18:00', 2, 0, '', '2019-08-16 18:18:00');
INSERT INTO `access_log` VALUES (68340, '59.72.15659506800513287', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '119.137.52.158', '2019-08-16 18:18:00', 19, 2001001000, '服务端发生异常', '2019-08-16 18:18:00');
INSERT INTO `access_log` VALUES (68341, '64.76.15659506909633645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '119.137.52.158', '2019-08-16 18:18:11', 2, 0, '', '2019-08-16 18:18:11');
INSERT INTO `access_log` VALUES (68342, '64.80.15659506910753645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '119.137.52.158', '2019-08-16 18:18:11', 2, 0, '', '2019-08-16 18:18:11');
INSERT INTO `access_log` VALUES (68343, '59.76.15659506923443277', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '119.137.52.158', '2019-08-16 18:18:12', 2, 0, '', '2019-08-16 18:18:12');
INSERT INTO `access_log` VALUES (68344, '59.79.15659506923443291', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '119.137.52.158', '2019-08-16 18:18:12', 9, 2001001000, '服务端发生异常', '2019-08-16 18:18:12');
INSERT INTO `access_log` VALUES (68345, '59.76.15659529152993307', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:15', 10, 0, '', '2019-08-16 18:55:15');
INSERT INTO `access_log` VALUES (68346, '59.79.15659529153033321', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:15', 15, 2001001000, '服务端发生异常', '2019-08-16 18:55:15');
INSERT INTO `access_log` VALUES (68347, '64.76.15659529185713675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:19', 10, 0, '', '2019-08-16 18:55:19');
INSERT INTO `access_log` VALUES (68348, '64.80.15659529186963675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:19', 3, 0, '', '2019-08-16 18:55:19');
INSERT INTO `access_log` VALUES (68349, '64.79.15659529207153671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:21', 2, 0, '', '2019-08-16 18:55:21');
INSERT INTO `access_log` VALUES (68350, '64.83.15659529210103667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:21', 2, 0, '', '2019-08-16 18:55:21');
INSERT INTO `access_log` VALUES (68351, '64.84.15659529210823671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:21', 2, 0, '', '2019-08-16 18:55:21');
INSERT INTO `access_log` VALUES (68352, '64.82.15659529242473685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:24', 2, 0, '', '2019-08-16 18:55:24');
INSERT INTO `access_log` VALUES (68353, '64.77.15659529243883663', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:24', 1, 0, '', '2019-08-16 18:55:24');
INSERT INTO `access_log` VALUES (68354, '59.73.15659529277683321', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:28', 3, 0, '', '2019-08-16 18:55:28');
INSERT INTO `access_log` VALUES (68355, '59.78.15659529277693327', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:28', 19, 2001001000, '服务端发生异常', '2019-08-16 18:55:28');
INSERT INTO `access_log` VALUES (68356, '64.81.15659529478313673', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:48', 2, 0, '', '2019-08-16 18:55:48');
INSERT INTO `access_log` VALUES (68357, '64.76.15659529489323677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:49', 2, 0, '', '2019-08-16 18:55:49');
INSERT INTO `access_log` VALUES (68358, '59.80.15659529493633291', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:49', 2, 0, '', '2019-08-16 18:55:49');
INSERT INTO `access_log` VALUES (68359, '59.72.15659529493623319', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.236.199.195', '2019-08-16 18:55:49', 13, 2001001000, '服务端发生异常', '2019-08-16 18:55:49');
INSERT INTO `access_log` VALUES (68360, '59.73.15659638285513467', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.52.107.91', '2019-08-16 21:57:09', 10, 0, '', '2019-08-16 21:57:09');
INSERT INTO `access_log` VALUES (68361, '59.75.15659638285523473', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.52.107.91', '2019-08-16 21:57:09', 18, 2001001000, '服务端发生异常', '2019-08-16 21:57:09');
INSERT INTO `access_log` VALUES (68362, '64.77.15659638324003809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.52.107.91', '2019-08-16 21:57:12', 11, 0, '', '2019-08-16 21:57:12');
INSERT INTO `access_log` VALUES (68363, '64.78.15659638325173829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.52.107.91', '2019-08-16 21:57:13', 2, 0, '', '2019-08-16 21:57:13');
INSERT INTO `access_log` VALUES (68364, '64.81.15659638339733819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.52.107.91', '2019-08-16 21:57:14', 2, 0, '', '2019-08-16 21:57:14');
INSERT INTO `access_log` VALUES (68365, '64.76.15659638354933823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.52.107.91', '2019-08-16 21:57:15', 2, 0, '', '2019-08-16 21:57:15');
INSERT INTO `access_log` VALUES (68366, '59.80.15659638399613437', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.52.107.91', '2019-08-16 21:57:20', 3, 0, '', '2019-08-16 21:57:20');
INSERT INTO `access_log` VALUES (68367, '59.72.15659638399623465', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.52.107.91', '2019-08-16 21:57:20', 13, 2001001000, '服务端发生异常', '2019-08-16 21:57:20');
INSERT INTO `access_log` VALUES (68368, '65.45.15659683031206541', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '39.130.83.146', '2019-08-16 23:11:43', 1, 1002001015, '账号未登陆', '2019-08-16 23:11:43');
INSERT INTO `access_log` VALUES (68369, '65.50.15659683031216533', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '39.130.83.146', '2019-08-16 23:11:43', 1, 1002001015, '账号未登陆', '2019-08-16 23:11:43');
INSERT INTO `access_log` VALUES (68370, '65.49.15659683031216529', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '39.130.83.146', '2019-08-16 23:11:43', 0, 1002001015, '账号未登陆', '2019-08-16 23:11:43');
INSERT INTO `access_log` VALUES (68371, '59.71.15660058440874025', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:24', 11, 0, '', '2019-08-17 09:37:24');
INSERT INTO `access_log` VALUES (68372, '59.80.15660058440873999', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:24', 26, 2001001000, '服务端发生异常', '2019-08-17 09:37:24');
INSERT INTO `access_log` VALUES (68373, '64.85.15660058493864411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:29', 12, 0, '', '2019-08-17 09:37:29');
INSERT INTO `access_log` VALUES (68374, '64.79.15660058495504379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:30', 3, 0, '', '2019-08-17 09:37:30');
INSERT INTO `access_log` VALUES (68375, '64.83.15660058535224375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:34', 2, 0, '', '2019-08-17 09:37:34');
INSERT INTO `access_log` VALUES (68376, '64.84.15660058536794379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:34', 2, 0, '', '2019-08-17 09:37:34');
INSERT INTO `access_log` VALUES (68377, '64.77.15660058571724371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:37', 2, 0, '', '2019-08-17 09:37:37');
INSERT INTO `access_log` VALUES (68378, '64.78.15660058573684391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:37', 2, 0, '', '2019-08-17 09:37:37');
INSERT INTO `access_log` VALUES (68379, '59.79.15660058589484029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:39', 3, 0, '', '2019-08-17 09:37:39');
INSERT INTO `access_log` VALUES (68380, '59.78.15660058589484035', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:39', 17, 2001001000, '服务端发生异常', '2019-08-17 09:37:39');
INSERT INTO `access_log` VALUES (68381, '64.81.15660058610004381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:41', 2, 0, '', '2019-08-17 09:37:41');
INSERT INTO `access_log` VALUES (68382, '64.76.15660058611724385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:41', 2, 0, '', '2019-08-17 09:37:41');
INSERT INTO `access_log` VALUES (68383, '59.74.15660058619634043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:42', 2, 0, '', '2019-08-17 09:37:42');
INSERT INTO `access_log` VALUES (68384, '59.76.15660058619644015', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:42', 17, 2001001000, '服务端发生异常', '2019-08-17 09:37:42');
INSERT INTO `access_log` VALUES (68385, '64.80.15660058636344385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:44', 3, 0, '', '2019-08-17 09:37:44');
INSERT INTO `access_log` VALUES (68386, '64.85.15660058638264413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '171.11.0.251', '2019-08-17 09:37:44', 2, 0, '', '2019-08-17 09:37:44');
INSERT INTO `access_log` VALUES (68387, '59.71.15660069392944041', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '115.192.222.95', '2019-08-17 09:55:39', 3, 0, '', '2019-08-17 09:55:39');
INSERT INTO `access_log` VALUES (68388, '59.72.15660069392944041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '115.192.222.95', '2019-08-17 09:55:39', 17, 2001001000, '服务端发生异常', '2019-08-17 09:55:39');
INSERT INTO `access_log` VALUES (68389, '64.82.15660069519124409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '115.192.222.95', '2019-08-17 09:55:52', 3, 0, '', '2019-08-17 09:55:52');
INSERT INTO `access_log` VALUES (68390, '64.77.15660069521904387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '115.192.222.95', '2019-08-17 09:55:52', 2, 0, '', '2019-08-17 09:55:52');
INSERT INTO `access_log` VALUES (68391, '64.78.15660069531914407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '115.192.222.95', '2019-08-17 09:55:53', 2, 0, '', '2019-08-17 09:55:53');
INSERT INTO `access_log` VALUES (68392, '64.81.15660069536634397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.36 Safari/537.36', '115.192.222.95', '2019-08-17 09:55:54', 2, 0, '', '2019-08-17 09:55:54');
INSERT INTO `access_log` VALUES (68393, '59.79.15660089289944071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.35.58', '2019-08-17 10:28:49', 10, 0, '', '2019-08-17 10:28:49');
INSERT INTO `access_log` VALUES (68394, '59.78.15660089289944077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.35.58', '2019-08-17 10:28:49', 18, 2001001000, '服务端发生异常', '2019-08-17 10:28:49');
INSERT INTO `access_log` VALUES (68395, '64.85.15660089352164455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.35.58', '2019-08-17 10:28:55', 13, 0, '', '2019-08-17 10:28:55');
INSERT INTO `access_log` VALUES (68396, '64.79.15660089354104423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.35.58', '2019-08-17 10:28:55', 4, 0, '', '2019-08-17 10:28:55');
INSERT INTO `access_log` VALUES (68397, '64.83.15660089369084419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.35.58', '2019-08-17 10:28:57', 2, 0, '', '2019-08-17 10:28:57');
INSERT INTO `access_log` VALUES (68398, '64.84.15660089375734423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.35.58', '2019-08-17 10:28:58', 2, 0, '', '2019-08-17 10:28:58');
INSERT INTO `access_log` VALUES (68399, '64.77.15660089527304415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.35.58', '2019-08-17 10:29:13', 2, 0, '', '2019-08-17 10:29:13');
INSERT INTO `access_log` VALUES (68400, '64.78.15660089528574435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.35.58', '2019-08-17 10:29:13', 2, 0, '', '2019-08-17 10:29:13');
INSERT INTO `access_log` VALUES (68401, '59.75.15660089541444077', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.35.58', '2019-08-17 10:29:14', 3, 0, '', '2019-08-17 10:29:14');
INSERT INTO `access_log` VALUES (68402, '59.77.15660089541444057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '120.229.35.58', '2019-08-17 10:29:14', 13, 2001001000, '服务端发生异常', '2019-08-17 10:29:14');
INSERT INTO `access_log` VALUES (68403, '59.73.15660095893044081', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.226.249.52', '2019-08-17 10:39:49', 4, 0, '', '2019-08-17 10:39:49');
INSERT INTO `access_log` VALUES (68404, '59.79.15660095893054081', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.226.249.52', '2019-08-17 10:39:49', 14, 2001001000, '服务端发生异常', '2019-08-17 10:39:49');
INSERT INTO `access_log` VALUES (68405, '59.78.15660095977904087', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.226.249.52', '2019-08-17 10:39:58', 2, 0, '', '2019-08-17 10:39:58');
INSERT INTO `access_log` VALUES (68406, '59.74.15660095977904095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.226.249.52', '2019-08-17 10:39:58', 24, 2001001000, '服务端发生异常', '2019-08-17 10:39:58');
INSERT INTO `access_log` VALUES (68407, '64.85.15660096002974465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.226.249.52', '2019-08-17 10:40:00', 3, 0, '', '2019-08-17 10:40:00');
INSERT INTO `access_log` VALUES (68408, '64.79.15660096003964433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.226.249.52', '2019-08-17 10:40:00', 1, 0, '', '2019-08-17 10:40:00');
INSERT INTO `access_log` VALUES (68409, '66.50.15660096144761635', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15158059581', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.226.249.52', '2019-08-17 10:40:14', 155, 0, '', '2019-08-17 10:40:15');
INSERT INTO `access_log` VALUES (68410, '66.53.15660096188861631', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15158059581&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.226.249.52', '2019-08-17 10:40:19', 175, 0, '', '2019-08-17 10:40:19');
INSERT INTO `access_log` VALUES (68411, '64.77.15660096323144425', 204, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '116.226.249.52', '2019-08-17 10:40:32', 7, 0, '', '2019-08-17 10:40:32');
INSERT INTO `access_log` VALUES (68412, '64.81.15660096323954435', 204, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '116.226.249.52', '2019-08-17 10:40:32', 4, 0, '', '2019-08-17 10:40:32');
INSERT INTO `access_log` VALUES (68413, '66.57.15660096336561637', 204, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '116.226.249.52', '2019-08-17 10:40:34', 6, 0, '', '2019-08-17 10:40:34');
INSERT INTO `access_log` VALUES (68414, '66.55.15660096389271619', 204, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '116.226.249.52', '2019-08-17 10:40:39', 7, 0, '', '2019-08-17 10:40:39');
INSERT INTO `access_log` VALUES (68415, '64.85.15660096400704467', 204, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '116.226.249.52', '2019-08-17 10:40:40', 7, 0, '', '2019-08-17 10:40:40');
INSERT INTO `access_log` VALUES (68416, '64.83.15660096401864431', 204, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '116.226.249.52', '2019-08-17 10:40:40', 5, 0, '', '2019-08-17 10:40:40');
INSERT INTO `access_log` VALUES (68417, '59.80.15660096409884053', 204, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '116.226.249.52', '2019-08-17 10:40:41', 8, 0, '', '2019-08-17 10:40:41');
INSERT INTO `access_log` VALUES (68418, '59.73.15660096409894083', 204, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '116.226.249.52', '2019-08-17 10:40:41', 20, 2001001000, '服务端发生异常', '2019-08-17 10:40:41');
INSERT INTO `access_log` VALUES (68419, '64.82.15660096428904449', 204, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '116.226.249.52', '2019-08-17 10:40:43', 6, 0, '', '2019-08-17 10:40:43');
INSERT INTO `access_log` VALUES (68420, '64.78.15660096429724447', 204, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '116.226.249.52', '2019-08-17 10:40:43', 5, 0, '', '2019-08-17 10:40:43');
INSERT INTO `access_log` VALUES (68421, '64.76.15660096442154441', 204, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '116.226.249.52', '2019-08-17 10:40:44', 6, 0, '', '2019-08-17 10:40:44');
INSERT INTO `access_log` VALUES (68422, 'N/A', 204, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '116.226.249.52', '2019-08-17 10:40:44', 29, 0, '', '2019-08-17 10:40:44');
INSERT INTO `access_log` VALUES (68423, '64.85.15660096451594469', 204, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '116.226.249.52', '2019-08-17 10:40:45', 14, 0, '', '2019-08-17 10:40:45');
INSERT INTO `access_log` VALUES (68424, '66.50.15660096575871637', 204, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '116.226.249.52', '2019-08-17 10:40:58', 8, 0, '', '2019-08-17 10:40:58');
INSERT INTO `access_log` VALUES (68425, '65.54.15660112885277001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-17 11:08:09', 0, 1002001015, '账号未登陆', '2019-08-17 11:08:09');
INSERT INTO `access_log` VALUES (68426, '65.45.15660112885337115', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-17 11:08:09', 1, 1002001015, '账号未登陆', '2019-08-17 11:08:09');
INSERT INTO `access_log` VALUES (68427, '65.46.15660112885277143', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-17 11:08:09', 1, 1002001015, '账号未登陆', '2019-08-17 11:08:09');
INSERT INTO `access_log` VALUES (68428, '65.49.15660112932797103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-17 11:08:13', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 11:08:13');
INSERT INTO `access_log` VALUES (68429, '65.3607.15660113107048885', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-17 11:08:31', 10, 1002002000, '账号不存在', '2019-08-17 11:08:31');
INSERT INTO `access_log` VALUES (68430, '65.47.15660113173917057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-17 11:08:37', 81, 0, '', '2019-08-17 11:08:37');
INSERT INTO `access_log` VALUES (68431, '65.51.15660113178487171', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-17 11:08:38', 16, 0, '', '2019-08-17 11:08:38');
INSERT INTO `access_log` VALUES (68432, '65.52.15660113178577149', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-17 11:08:38', 11, 2001001000, '服务端发生异常', '2019-08-17 11:08:38');
INSERT INTO `access_log` VALUES (68433, '65.45.15660113178687117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-17 11:08:38', 16, 0, '', '2019-08-17 11:08:38');
INSERT INTO `access_log` VALUES (68434, '65.46.15660113225017145', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-17 11:08:43', 9, 0, '', '2019-08-17 11:08:43');
INSERT INTO `access_log` VALUES (68435, '65.49.15660113225167105', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-17 11:08:43', 10, 0, '', '2019-08-17 11:08:43');
INSERT INTO `access_log` VALUES (68436, '65.50.15660113225157109', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-17 11:08:43', 10, 2001001000, '服务端发生异常', '2019-08-17 11:08:43');
INSERT INTO `access_log` VALUES (68437, '59.80.15660129072554097', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.66.217.213', '2019-08-17 11:35:07', 10, 0, '', '2019-08-17 11:35:07');
INSERT INTO `access_log` VALUES (68438, '59.73.15660129072554127', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.66.217.213', '2019-08-17 11:35:07', 21, 2001001000, '服务端发生异常', '2019-08-17 11:35:07');
INSERT INTO `access_log` VALUES (68439, '65.46.15660129185087167', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.66.217.213', '2019-08-17 11:35:19', 0, 1002001015, '账号未登陆', '2019-08-17 11:35:19');
INSERT INTO `access_log` VALUES (68440, '65.54.15660129185087025', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.66.217.213', '2019-08-17 11:35:19', 0, 1002001015, '账号未登陆', '2019-08-17 11:35:19');
INSERT INTO `access_log` VALUES (68441, '65.49.15660129185097127', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.66.217.213', '2019-08-17 11:35:19', 0, 1002001015, '账号未登陆', '2019-08-17 11:35:19');
INSERT INTO `access_log` VALUES (68442, '65.50.15660129204527131', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.66.217.213', '2019-08-17 11:35:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 11:35:20');
INSERT INTO `access_log` VALUES (68443, '65.3607.15660129362738909', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.66.217.213', '2019-08-17 11:35:36', 91, 0, '', '2019-08-17 11:35:36');
INSERT INTO `access_log` VALUES (68444, '65.47.15660129367047081', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.66.217.213', '2019-08-17 11:35:37', 8, 0, '', '2019-08-17 11:35:37');
INSERT INTO `access_log` VALUES (68445, '65.45.15660129367117141', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.66.217.213', '2019-08-17 11:35:37', 8, 2001001000, '服务端发生异常', '2019-08-17 11:35:37');
INSERT INTO `access_log` VALUES (68446, '65.51.15660129367507195', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '113.66.217.213', '2019-08-17 11:35:37', 8, 0, '', '2019-08-17 11:35:37');
INSERT INTO `access_log` VALUES (68447, '65.51.15660186095987271', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.154.54.142', '2019-08-17 13:10:10', 116, 1002001012, '访问令牌已过期', '2019-08-17 13:10:10');
INSERT INTO `access_log` VALUES (68448, '65.52.15660186095987249', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.154.54.142', '2019-08-17 13:10:10', 116, 1002001012, '访问令牌已过期', '2019-08-17 13:10:10');
INSERT INTO `access_log` VALUES (68449, '65.49.15660186095997205', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.154.54.142', '2019-08-17 13:10:10', 116, 1002001012, '访问令牌已过期', '2019-08-17 13:10:10');
INSERT INTO `access_log` VALUES (68450, '65.46.15660186180757245', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.154.54.142', '2019-08-17 13:10:18', 125, 0, '', '2019-08-17 13:10:18');
INSERT INTO `access_log` VALUES (68451, '65.54.15660186184657103', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.154.54.142', '2019-08-17 13:10:18', 9, 0, '', '2019-08-17 13:10:18');
INSERT INTO `access_log` VALUES (68452, '65.50.15660186184787209', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.154.54.142', '2019-08-17 13:10:18', 15, 2001001000, '服务端发生异常', '2019-08-17 13:10:18');
INSERT INTO `access_log` VALUES (68453, '65.53.15660186184827165', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.154.54.142', '2019-08-17 13:10:18', 13, 0, '', '2019-08-17 13:10:18');
INSERT INTO `access_log` VALUES (68454, '65.49.15660189541727211', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.154.54.142', '2019-08-17 13:15:54', 10, 0, '', '2019-08-17 13:15:54');
INSERT INTO `access_log` VALUES (68455, '65.51.15660189541727277', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.154.54.142', '2019-08-17 13:15:54', 12, 2001001000, '服务端发生异常', '2019-08-17 13:15:54');
INSERT INTO `access_log` VALUES (68456, '65.52.15660189541817255', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.154.54.142', '2019-08-17 13:15:54', 9, 0, '', '2019-08-17 13:15:54');
INSERT INTO `access_log` VALUES (68457, '65.3607.15660190051498993', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.154.54.142', '2019-08-17 13:16:45', 23, 0, '', '2019-08-17 13:16:45');
INSERT INTO `access_log` VALUES (68458, '65.47.15660190051507165', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.154.54.142', '2019-08-17 13:16:45', 22, 0, '', '2019-08-17 13:16:45');
INSERT INTO `access_log` VALUES (68459, '65.50.15660190051487215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.154.54.142', '2019-08-17 13:16:45', 26, 2001001000, '服务端发生异常', '2019-08-17 13:16:45');
INSERT INTO `access_log` VALUES (68460, '65.49.15660193389437217', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '51.68.205.164', '2019-08-17 13:22:19', 11, 0, '', '2019-08-17 13:22:19');
INSERT INTO `access_log` VALUES (68461, '65.51.15660193389807283', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '51.68.205.164', '2019-08-17 13:22:19', 8, 0, '', '2019-08-17 13:22:19');
INSERT INTO `access_log` VALUES (68462, '65.46.15660193390197257', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '51.68.205.164', '2019-08-17 13:22:19', 11, 2001001000, '服务端发生异常', '2019-08-17 13:22:19');
INSERT INTO `access_log` VALUES (68463, '65.53.15660193484727177', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '51.68.205.164', '2019-08-17 13:22:28', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 13:22:28');
INSERT INTO `access_log` VALUES (68464, '65.47.15660193514657171', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '51.68.205.164', '2019-08-17 13:22:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 13:22:31');
INSERT INTO `access_log` VALUES (68465, '65.3607.15660193575408999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '51.68.205.164', '2019-08-17 13:22:38', 4, 1002002001, '密码不正确', '2019-08-17 13:22:38');
INSERT INTO `access_log` VALUES (68466, '65.45.15660193685677231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma &type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '51.68.205.164', '2019-08-17 13:22:49', 86, 0, '', '2019-08-17 13:22:49');
INSERT INTO `access_log` VALUES (68467, '65.52.15660193692717263', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '51.68.205.164', '2019-08-17 13:22:49', 9, 0, '', '2019-08-17 13:22:49');
INSERT INTO `access_log` VALUES (68468, '65.49.15660193693047219', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '51.68.205.164', '2019-08-17 13:22:49', 7, 0, '', '2019-08-17 13:22:49');
INSERT INTO `access_log` VALUES (68469, '65.51.15660193693397285', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '51.68.205.164', '2019-08-17 13:22:49', 9, 2001001000, '服务端发生异常', '2019-08-17 13:22:49');
INSERT INTO `access_log` VALUES (68470, '65.53.15660193793377179', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '51.68.205.164', '2019-08-17 13:22:59', 9, 0, '', '2019-08-17 13:22:59');
INSERT INTO `access_log` VALUES (68471, '65.54.15660193793357117', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '51.68.205.164', '2019-08-17 13:22:59', 11, 2001001000, '服务端发生异常', '2019-08-17 13:22:59');
INSERT INTO `access_log` VALUES (68472, '65.47.15660193793737173', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '51.68.205.164', '2019-08-17 13:22:59', 16, 0, '', '2019-08-17 13:22:59');
INSERT INTO `access_log` VALUES (68473, '59.76.15660200133164207', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:33:33', 9, 0, '', '2019-08-17 13:33:33');
INSERT INTO `access_log` VALUES (68474, '59.75.15660200133214227', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:33:33', 14, 2001001000, '服务端发生异常', '2019-08-17 13:33:33');
INSERT INTO `access_log` VALUES (68475, '64.84.15660200196004575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:33:40', 22, 0, '', '2019-08-17 13:33:40');
INSERT INTO `access_log` VALUES (68476, '64.82.15660200197674589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:33:40', 4, 0, '', '2019-08-17 13:33:40');
INSERT INTO `access_log` VALUES (68477, '65.49.15660200306587229', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:33:51', 1, 1002001015, '账号未登陆', '2019-08-17 13:33:51');
INSERT INTO `access_log` VALUES (68478, '65.52.15660200306647273', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:33:51', 0, 1002001015, '账号未登陆', '2019-08-17 13:33:51');
INSERT INTO `access_log` VALUES (68479, '65.51.15660200306807295', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:33:51', 0, 1002001015, '账号未登陆', '2019-08-17 13:33:51');
INSERT INTO `access_log` VALUES (68480, '65.46.15660200338907269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:33:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 13:33:54');
INSERT INTO `access_log` VALUES (68481, '65.54.15660200469507127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:34:07', 125, 0, '', '2019-08-17 13:34:07');
INSERT INTO `access_log` VALUES (68482, '65.47.15660200477177183', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:34:08', 10, 0, '', '2019-08-17 13:34:08');
INSERT INTO `access_log` VALUES (68483, '65.3607.15660200477239011', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:34:08', 10, 2001001000, '服务端发生异常', '2019-08-17 13:34:08');
INSERT INTO `access_log` VALUES (68484, '65.50.15660200477307233', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:34:08', 15, 0, '', '2019-08-17 13:34:08');
INSERT INTO `access_log` VALUES (68485, '65.49.15660200588137231', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:34:19', 9, 0, '', '2019-08-17 13:34:19');
INSERT INTO `access_log` VALUES (68486, '65.52.15660200588197275', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:34:19', 9, 2001001000, '服务端发生异常', '2019-08-17 13:34:19');
INSERT INTO `access_log` VALUES (68487, '65.51.15660200588517297', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:34:19', 9, 0, '', '2019-08-17 13:34:19');
INSERT INTO `access_log` VALUES (68488, '65.53.15660200618077191', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:34:22', 9, 0, '', '2019-08-17 13:34:22');
INSERT INTO `access_log` VALUES (68489, '65.46.15660200618127271', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:34:22', 9, 2001001000, '服务端发生异常', '2019-08-17 13:34:22');
INSERT INTO `access_log` VALUES (68490, '65.54.15660200618207129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '123.233.218.34', '2019-08-17 13:34:22', 15, 0, '', '2019-08-17 13:34:22');
INSERT INTO `access_log` VALUES (68491, '59.79.15660223271234253', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.5006.400 QQBrowser/9.7.13114.400', '113.65.33.112', '2019-08-17 14:12:07', 10, 0, '', '2019-08-17 14:12:07');
INSERT INTO `access_log` VALUES (68492, '59.78.15660223271244259', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.5006.400 QQBrowser/9.7.13114.400', '113.65.33.112', '2019-08-17 14:12:07', 16, 2001001000, '服务端发生异常', '2019-08-17 14:12:07');
INSERT INTO `access_log` VALUES (68493, '64.80.15660223331804611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.5006.400 QQBrowser/9.7.13114.400', '113.65.33.112', '2019-08-17 14:12:13', 11, 0, '', '2019-08-17 14:12:13');
INSERT INTO `access_log` VALUES (68494, '64.85.15660223333264639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.5006.400 QQBrowser/9.7.13114.400', '113.65.33.112', '2019-08-17 14:12:13', 3, 0, '', '2019-08-17 14:12:13');
INSERT INTO `access_log` VALUES (68495, '64.79.15660223347964607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.5006.400 QQBrowser/9.7.13114.400', '113.65.33.112', '2019-08-17 14:12:15', 2, 0, '', '2019-08-17 14:12:15');
INSERT INTO `access_log` VALUES (68496, '64.83.15660223351784603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.5006.400 QQBrowser/9.7.13114.400', '113.65.33.112', '2019-08-17 14:12:15', 3, 0, '', '2019-08-17 14:12:15');
INSERT INTO `access_log` VALUES (68497, '64.84.15660223354564607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.5006.400 QQBrowser/9.7.13114.400', '113.65.33.112', '2019-08-17 14:12:15', 2, 0, '', '2019-08-17 14:12:15');
INSERT INTO `access_log` VALUES (68498, '65.52.15660234044607321', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.205', '2019-08-17 14:30:04', 4, 1002001012, '访问令牌已过期', '2019-08-17 14:30:04');
INSERT INTO `access_log` VALUES (68499, '65.45.15660234044607289', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.205', '2019-08-17 14:30:04', 4, 1002001012, '访问令牌已过期', '2019-08-17 14:30:04');
INSERT INTO `access_log` VALUES (68500, '65.49.15660234044727277', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.205', '2019-08-17 14:30:04', 11, 1002001012, '访问令牌已过期', '2019-08-17 14:30:04');
INSERT INTO `access_log` VALUES (68501, '65.51.15660234066157343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.205', '2019-08-17 14:30:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 14:30:07');
INSERT INTO `access_log` VALUES (68502, '65.53.15660234164847237', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.205', '2019-08-17 14:30:16', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 14:30:16');
INSERT INTO `access_log` VALUES (68503, '65.47.15660234321087231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.205', '2019-08-17 14:30:32', 97, 0, '', '2019-08-17 14:30:32');
INSERT INTO `access_log` VALUES (68504, '65.3607.15660234325479059', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.205', '2019-08-17 14:30:33', 10, 0, '', '2019-08-17 14:30:33');
INSERT INTO `access_log` VALUES (68505, '65.50.15660234325537281', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.205', '2019-08-17 14:30:33', 12, 2001001000, '服务端发生异常', '2019-08-17 14:30:33');
INSERT INTO `access_log` VALUES (68506, '65.52.15660234325567323', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '175.8.48.205', '2019-08-17 14:30:33', 9, 0, '', '2019-08-17 14:30:33');
INSERT INTO `access_log` VALUES (68507, '59.73.15660249878174289', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.146.7.112', '2019-08-17 14:56:28', 11, 0, '', '2019-08-17 14:56:28');
INSERT INTO `access_log` VALUES (68508, '59.79.15660249878274289', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.146.7.112', '2019-08-17 14:56:28', 29, 2001001000, '服务端发生异常', '2019-08-17 14:56:28');
INSERT INTO `access_log` VALUES (68509, '59.76.15660252993204279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.5006.400 QQBrowser/9.7.13114.400', '113.65.33.112', '2019-08-17 15:01:39', 25, 2001001000, '服务端发生异常', '2019-08-17 15:01:39');
INSERT INTO `access_log` VALUES (68510, '59.74.15660252993174307', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.5006.400 QQBrowser/9.7.13114.400', '113.65.33.112', '2019-08-17 15:01:39', 138, 0, '', '2019-08-17 15:01:39');
INSERT INTO `access_log` VALUES (68511, '64.83.15660253020564643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.5006.400 QQBrowser/9.7.13114.400', '113.65.33.112', '2019-08-17 15:01:42', 11, 0, '', '2019-08-17 15:01:42');
INSERT INTO `access_log` VALUES (68512, '64.84.15660253021634647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.5006.400 QQBrowser/9.7.13114.400', '113.65.33.112', '2019-08-17 15:01:42', 3, 0, '', '2019-08-17 15:01:42');
INSERT INTO `access_log` VALUES (68513, '64.82.15660253030974661', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.5006.400 QQBrowser/9.7.13114.400', '113.65.33.112', '2019-08-17 15:01:43', 2, 0, '', '2019-08-17 15:01:43');
INSERT INTO `access_log` VALUES (68514, '66.56.15660253103821863', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13786160975', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.5006.400 QQBrowser/9.7.13114.400', '113.65.33.112', '2019-08-17 15:01:50', 103, 0, '', '2019-08-17 15:01:50');
INSERT INTO `access_log` VALUES (68515, '66.48.15660253208701849', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13786160975&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.5006.400 QQBrowser/9.7.13114.400', '113.65.33.112', '2019-08-17 15:02:01', 187, 0, '', '2019-08-17 15:02:01');
INSERT INTO `access_log` VALUES (68516, '65.50.15660276525327339', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.8.148.66', '2019-08-17 15:40:53', 1, 1002001015, '账号未登陆', '2019-08-17 15:40:53');
INSERT INTO `access_log` VALUES (68517, '65.52.15660276525327379', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.8.148.66', '2019-08-17 15:40:53', 0, 1002001015, '账号未登陆', '2019-08-17 15:40:53');
INSERT INTO `access_log` VALUES (68518, '65.49.15660276525447337', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.8.148.66', '2019-08-17 15:40:53', 0, 1002001015, '账号未登陆', '2019-08-17 15:40:53');
INSERT INTO `access_log` VALUES (68519, '65.51.15660276753087401', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.8.148.66', '2019-08-17 15:41:15', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 15:41:15');
INSERT INTO `access_log` VALUES (68520, '65.46.15660276823617377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.8.148.66', '2019-08-17 15:41:22', 74, 0, '', '2019-08-17 15:41:22');
INSERT INTO `access_log` VALUES (68521, '65.53.15660276830267297', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.8.148.66', '2019-08-17 15:41:23', 18, 2001001000, '服务端发生异常', '2019-08-17 15:41:23');
INSERT INTO `access_log` VALUES (68522, '65.54.15660276830257235', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.8.148.66', '2019-08-17 15:41:23', 20, 0, '', '2019-08-17 15:41:23');
INSERT INTO `access_log` VALUES (68523, '65.47.15660276830297291', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.8.148.66', '2019-08-17 15:41:23', 17, 0, '', '2019-08-17 15:41:23');
INSERT INTO `access_log` VALUES (68524, '65.51.15660277563467403', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.8.148.66', '2019-08-17 15:42:36', 10, 0, '', '2019-08-17 15:42:36');
INSERT INTO `access_log` VALUES (68525, '65.46.15660277563467379', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.8.148.66', '2019-08-17 15:42:36', 11, 2001001000, '服务端发生异常', '2019-08-17 15:42:36');
INSERT INTO `access_log` VALUES (68526, '65.53.15660277563467299', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '121.8.148.66', '2019-08-17 15:42:36', 133, 0, '', '2019-08-17 15:42:36');
INSERT INTO `access_log` VALUES (68527, '65.50.15660286824477355', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.13.55.147', '2019-08-17 15:58:02', 0, 1002001015, '账号未登陆', '2019-08-17 15:58:02');
INSERT INTO `access_log` VALUES (68528, '65.52.15660286824487395', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.13.55.147', '2019-08-17 15:58:02', 1, 1002001015, '账号未登陆', '2019-08-17 15:58:02');
INSERT INTO `access_log` VALUES (68529, '65.49.15660286824517353', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.13.55.147', '2019-08-17 15:58:02', 0, 1002001015, '账号未登陆', '2019-08-17 15:58:02');
INSERT INTO `access_log` VALUES (68530, '65.3607.15660286847579133', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.13.55.147', '2019-08-17 15:58:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 15:58:05');
INSERT INTO `access_log` VALUES (68531, '65.45.15660286881747363', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.13.55.147', '2019-08-17 15:58:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 15:58:08');
INSERT INTO `access_log` VALUES (68532, '65.51.15660286956837417', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.13.55.147', '2019-08-17 15:58:16', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 15:58:16');
INSERT INTO `access_log` VALUES (68533, '65.54.15660287138377251', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.13.55.147', '2019-08-17 15:58:34', 160, 0, '', '2019-08-17 15:58:34');
INSERT INTO `access_log` VALUES (68534, '65.47.15660287145647307', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.13.55.147', '2019-08-17 15:58:35', 8, 0, '', '2019-08-17 15:58:35');
INSERT INTO `access_log` VALUES (68535, '65.52.15660287145727397', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.13.55.147', '2019-08-17 15:58:35', 15, 2001001000, '服务端发生异常', '2019-08-17 15:58:35');
INSERT INTO `access_log` VALUES (68536, '65.50.15660287145757357', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.13.55.147', '2019-08-17 15:58:35', 14, 0, '', '2019-08-17 15:58:35');
INSERT INTO `access_log` VALUES (68537, '65.3607.15660287312569135', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.13.55.147', '2019-08-17 15:58:51', 8, 0, '', '2019-08-17 15:58:51');
INSERT INTO `access_log` VALUES (68538, '65.46.15660287312657395', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.13.55.147', '2019-08-17 15:58:51', 31, 0, '', '2019-08-17 15:58:51');
INSERT INTO `access_log` VALUES (68539, '65.45.15660287312637365', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.13.55.147', '2019-08-17 15:58:51', 38, 2001001000, '服务端发生异常', '2019-08-17 15:58:51');
INSERT INTO `access_log` VALUES (68540, '59.74.15660288605874355', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:01', 10, 0, '', '2019-08-17 16:01:01');
INSERT INTO `access_log` VALUES (68541, '59.75.15660288605964347', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:01', 23, 2001001000, '服务端发生异常', '2019-08-17 16:01:01');
INSERT INTO `access_log` VALUES (68542, '64.82.15660288662384709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:06', 12, 0, '', '2019-08-17 16:01:06');
INSERT INTO `access_log` VALUES (68543, '64.77.15660288663694687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:06', 3, 0, '', '2019-08-17 16:01:06');
INSERT INTO `access_log` VALUES (68544, '64.78.15660288714604707', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:11', 2, 0, '', '2019-08-17 16:01:11');
INSERT INTO `access_log` VALUES (68545, '64.81.15660288715654697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:12', 1, 0, '', '2019-08-17 16:01:12');
INSERT INTO `access_log` VALUES (68546, '64.76.15660288731804701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:13', 2, 0, '', '2019-08-17 16:01:13');
INSERT INTO `access_log` VALUES (68547, '64.85.15660288834564729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:23', 3, 0, '', '2019-08-17 16:01:23');
INSERT INTO `access_log` VALUES (68548, '64.79.15660288835894697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:24', 2, 0, '', '2019-08-17 16:01:24');
INSERT INTO `access_log` VALUES (68549, '64.83.15660288847974693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:25', 2, 0, '', '2019-08-17 16:01:25');
INSERT INTO `access_log` VALUES (68550, '64.84.15660288853084697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:25', 2, 0, '', '2019-08-17 16:01:25');
INSERT INTO `access_log` VALUES (68551, '59.72.15660288875444339', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:28', 4, 0, '', '2019-08-17 16:01:28');
INSERT INTO `access_log` VALUES (68552, '59.80.15660288875464313', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:28', 18, 2001001000, '服务端发生异常', '2019-08-17 16:01:28');
INSERT INTO `access_log` VALUES (68553, '64.82.15660288893314711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:29', 2, 0, '', '2019-08-17 16:01:29');
INSERT INTO `access_log` VALUES (68554, '64.77.15660288894334689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:29', 1, 0, '', '2019-08-17 16:01:29');
INSERT INTO `access_log` VALUES (68555, '64.78.15660288903184709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:30', 2, 0, '', '2019-08-17 16:01:30');
INSERT INTO `access_log` VALUES (68556, '59.73.15660288923904343', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:32', 3, 0, '', '2019-08-17 16:01:32');
INSERT INTO `access_log` VALUES (68557, '59.79.15660288923904343', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:32', 17, 2001001000, '服务端发生异常', '2019-08-17 16:01:32');
INSERT INTO `access_log` VALUES (68558, '64.81.15660288926164699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:33', 2, 0, '', '2019-08-17 16:01:33');
INSERT INTO `access_log` VALUES (68559, '64.76.15660288927484703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:33', 2, 0, '', '2019-08-17 16:01:33');
INSERT INTO `access_log` VALUES (68560, '64.85.15660289001974731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:40', 2, 0, '', '2019-08-17 16:01:40');
INSERT INTO `access_log` VALUES (68561, '64.79.15660289002904699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:40', 2, 0, '', '2019-08-17 16:01:40');
INSERT INTO `access_log` VALUES (68562, '59.76.15660289009184329', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:41', 2, 0, '', '2019-08-17 16:01:41');
INSERT INTO `access_log` VALUES (68563, '59.74.15660289009314357', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.93.161.98', '2019-08-17 16:01:41', 19, 2001001000, '服务端发生异常', '2019-08-17 16:01:41');
INSERT INTO `access_log` VALUES (68564, '65.51.15660323124927467', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.246.7', '2019-08-17 16:58:32', 0, 1002001015, '账号未登陆', '2019-08-17 16:58:33');
INSERT INTO `access_log` VALUES (68565, '65.46.15660323124927443', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.246.7', '2019-08-17 16:58:32', 0, 1002001015, '账号未登陆', '2019-08-17 16:58:33');
INSERT INTO `access_log` VALUES (68566, '65.53.15660323124997363', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.246.7', '2019-08-17 16:58:32', 1, 1002001015, '账号未登陆', '2019-08-17 16:58:33');
INSERT INTO `access_log` VALUES (68567, '65.54.15660324587017303', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.94.25.93', '2019-08-17 17:00:59', 1, 1002001015, '账号未登陆', '2019-08-17 17:00:59');
INSERT INTO `access_log` VALUES (68568, '65.50.15660324587067409', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.94.25.93', '2019-08-17 17:00:59', 0, 1002001015, '账号未登陆', '2019-08-17 17:00:59');
INSERT INTO `access_log` VALUES (68569, '65.52.15660324587127449', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.94.25.93', '2019-08-17 17:00:59', 0, 1002001015, '账号未登陆', '2019-08-17 17:00:59');
INSERT INTO `access_log` VALUES (68570, '65.49.15660324699477407', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.94.25.93', '2019-08-17 17:01:10', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 17:01:10');
INSERT INTO `access_log` VALUES (68571, '65.3607.15660324754679187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.94.25.93', '2019-08-17 17:01:15', 75, 0, '', '2019-08-17 17:01:16');
INSERT INTO `access_log` VALUES (68572, '65.45.15660324758247417', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.94.25.93', '2019-08-17 17:01:16', 16, 0, '', '2019-08-17 17:01:16');
INSERT INTO `access_log` VALUES (68573, '65.46.15660324758277447', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.94.25.93', '2019-08-17 17:01:16', 14, 2001001000, '服务端发生异常', '2019-08-17 17:01:16');
INSERT INTO `access_log` VALUES (68574, '65.51.15660324758317471', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.94.25.93', '2019-08-17 17:01:16', 13, 0, '', '2019-08-17 17:01:16');
INSERT INTO `access_log` VALUES (68575, '59.77.15660341551874399', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.31.195', '2019-08-17 17:29:15', 17, 2001001000, '服务端发生异常', '2019-08-17 17:29:15');
INSERT INTO `access_log` VALUES (68576, '59.75.15660341551864419', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.31.195', '2019-08-17 17:29:15', 240, 0, '', '2019-08-17 17:29:15');
INSERT INTO `access_log` VALUES (68577, '64.84.15660341673054769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '119.123.31.195', '2019-08-17 17:29:27', 135, 0, '', '2019-08-17 17:29:27');
INSERT INTO `access_log` VALUES (68578, '64.82.15660341675854783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '119.123.31.195', '2019-08-17 17:29:28', 2, 0, '', '2019-08-17 17:29:28');
INSERT INTO `access_log` VALUES (68579, '64.77.15660341689674761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '119.123.31.195', '2019-08-17 17:29:29', 2, 0, '', '2019-08-17 17:29:29');
INSERT INTO `access_log` VALUES (68580, '64.78.15660341696194781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '119.123.31.195', '2019-08-17 17:29:30', 2, 0, '', '2019-08-17 17:29:30');
INSERT INTO `access_log` VALUES (68581, '64.76.15660341795434775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '119.123.31.195', '2019-08-17 17:29:40', 1, 0, '', '2019-08-17 17:29:40');
INSERT INTO `access_log` VALUES (68582, '64.80.15660341796834775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '119.123.31.195', '2019-08-17 17:29:40', 2, 0, '', '2019-08-17 17:29:40');
INSERT INTO `access_log` VALUES (68583, '59.72.15660341871054411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '119.123.31.195', '2019-08-17 17:29:47', 4, 0, '', '2019-08-17 17:29:47');
INSERT INTO `access_log` VALUES (68584, '59.73.15660341871094415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '119.123.31.195', '2019-08-17 17:29:47', 30, 2001001000, '服务端发生异常', '2019-08-17 17:29:47');
INSERT INTO `access_log` VALUES (68585, '64.85.15660341895524803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '119.123.31.195', '2019-08-17 17:29:50', 2, 0, '', '2019-08-17 17:29:50');
INSERT INTO `access_log` VALUES (68586, '64.79.15660341897924771', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '119.123.31.195', '2019-08-17 17:29:50', 2, 0, '', '2019-08-17 17:29:50');
INSERT INTO `access_log` VALUES (68587, '65.3607.15660342052449211', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.31.195', '2019-08-17 17:30:05', 0, 1002001015, '账号未登陆', '2019-08-17 17:30:05');
INSERT INTO `access_log` VALUES (68588, '65.49.15660342052447431', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.31.195', '2019-08-17 17:30:05', 1, 1002001015, '账号未登陆', '2019-08-17 17:30:05');
INSERT INTO `access_log` VALUES (68589, '65.46.15660342052717471', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.31.195', '2019-08-17 17:30:05', 0, 1002001015, '账号未登陆', '2019-08-17 17:30:05');
INSERT INTO `access_log` VALUES (68590, '65.51.15660342070377495', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.31.195', '2019-08-17 17:30:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 17:30:07');
INSERT INTO `access_log` VALUES (68591, '65.53.15660342095967391', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.31.195', '2019-08-17 17:30:10', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 17:30:10');
INSERT INTO `access_log` VALUES (68592, '65.52.15660342171977475', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.31.195', '2019-08-17 17:30:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 17:30:17');
INSERT INTO `access_log` VALUES (68593, '65.54.15660342309737329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.31.195', '2019-08-17 17:30:31', 53, 0, '', '2019-08-17 17:30:31');
INSERT INTO `access_log` VALUES (68594, '65.47.15660342312897385', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.31.195', '2019-08-17 17:30:31', 11, 0, '', '2019-08-17 17:30:31');
INSERT INTO `access_log` VALUES (68595, '65.3607.15660342312939213', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.31.195', '2019-08-17 17:30:31', 10, 2001001000, '服务端发生异常', '2019-08-17 17:30:31');
INSERT INTO `access_log` VALUES (68596, '65.49.15660342312977433', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.31.195', '2019-08-17 17:30:31', 9, 0, '', '2019-08-17 17:30:31');
INSERT INTO `access_log` VALUES (68597, '65.51.15660375460267541', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:25:46', 1, 1002001015, '账号未登陆', '2019-08-17 18:25:46');
INSERT INTO `access_log` VALUES (68598, '65.45.15660375460267487', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:25:46', 1, 1002001015, '账号未登陆', '2019-08-17 18:25:46');
INSERT INTO `access_log` VALUES (68599, '65.53.15660375460297437', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:25:46', 0, 1002001015, '账号未登陆', '2019-08-17 18:25:46');
INSERT INTO `access_log` VALUES (68600, '65.52.15660375474407521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:25:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 18:25:47');
INSERT INTO `access_log` VALUES (68601, '65.54.15660375577987375', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:25:58', 109, 0, '', '2019-08-17 18:25:58');
INSERT INTO `access_log` VALUES (68602, '65.49.15660375581677479', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:25:58', 156, 0, '', '2019-08-17 18:25:58');
INSERT INTO `access_log` VALUES (68603, '65.3607.15660375581729259', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:25:58', 153, 0, '', '2019-08-17 18:25:58');
INSERT INTO `access_log` VALUES (68604, '65.47.15660375581697431', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:25:58', 157, 2001001000, '服务端发生异常', '2019-08-17 18:25:58');
INSERT INTO `access_log` VALUES (68605, '65.45.15660375776277489', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:26:18', 9, 0, '', '2019-08-17 18:26:18');
INSERT INTO `access_log` VALUES (68606, '65.53.15660375776517439', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:26:18', 15, 0, '', '2019-08-17 18:26:18');
INSERT INTO `access_log` VALUES (68607, '65.51.15660375776517543', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:26:18', 17, 2001001000, '服务端发生异常', '2019-08-17 18:26:18');
INSERT INTO `access_log` VALUES (68608, '65.52.15660375821677523', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:26:22', 10, 0, '', '2019-08-17 18:26:22');
INSERT INTO `access_log` VALUES (68609, '65.50.15660375821687483', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:26:22', 10, 0, '', '2019-08-17 18:26:22');
INSERT INTO `access_log` VALUES (68610, '65.54.15660375821697377', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:26:22', 10, 2001001000, '服务端发生异常', '2019-08-17 18:26:22');
INSERT INTO `access_log` VALUES (68611, '65.47.15660375871887433', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:26:27', 9, 0, '', '2019-08-17 18:26:27');
INSERT INTO `access_log` VALUES (68612, '65.49.15660375871887481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:26:27', 12, 2001001000, '服务端发生异常', '2019-08-17 18:26:27');
INSERT INTO `access_log` VALUES (68613, '65.46.15660375871927521', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:26:27', 9, 0, '', '2019-08-17 18:26:27');
INSERT INTO `access_log` VALUES (68614, '65.53.15660375910757441', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:26:31', 7, 0, '', '2019-08-17 18:26:31');
INSERT INTO `access_log` VALUES (68615, '65.45.15660375910747491', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:26:31', 9, 2001001000, '服务端发生异常', '2019-08-17 18:26:31');
INSERT INTO `access_log` VALUES (68616, '65.51.15660375910787545', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '14.20.90.91', '2019-08-17 18:26:31', 8, 0, '', '2019-08-17 18:26:31');
INSERT INTO `access_log` VALUES (68617, '65.45.15660395326247517', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '114.92.173.93', '2019-08-17 18:58:53', 1, 1002001015, '账号未登陆', '2019-08-17 18:58:53');
INSERT INTO `access_log` VALUES (68618, '65.52.15660395326257551', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '114.92.173.93', '2019-08-17 18:58:53', 0, 1002001015, '账号未登陆', '2019-08-17 18:58:53');
INSERT INTO `access_log` VALUES (68619, '65.50.15660395326257511', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '114.92.173.93', '2019-08-17 18:58:53', 0, 1002001015, '账号未登陆', '2019-08-17 18:58:53');
INSERT INTO `access_log` VALUES (68620, '65.47.15660395630857461', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '114.92.173.93', '2019-08-17 18:59:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 18:59:23');
INSERT INTO `access_log` VALUES (68621, '65.46.15660395675907549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '114.92.173.93', '2019-08-17 18:59:28', 59, 0, '', '2019-08-17 18:59:28');
INSERT INTO `access_log` VALUES (68622, '65.53.15660395678197469', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '114.92.173.93', '2019-08-17 18:59:28', 19, 0, '', '2019-08-17 18:59:28');
INSERT INTO `access_log` VALUES (68623, '65.45.15660395678207519', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '114.92.173.93', '2019-08-17 18:59:28', 20, 0, '', '2019-08-17 18:59:28');
INSERT INTO `access_log` VALUES (68624, '65.51.15660395678197573', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '114.92.173.93', '2019-08-17 18:59:28', 21, 2001001000, '服务端发生异常', '2019-08-17 18:59:28');
INSERT INTO `access_log` VALUES (68625, '65.50.15660395776507513', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '114.92.173.93', '2019-08-17 18:59:38', 1142, 2001001000, '服务端发生异常', '2019-08-17 18:59:39');
INSERT INTO `access_log` VALUES (68626, '65.52.15660395776507553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '114.92.173.93', '2019-08-17 18:59:38', 1394, 0, '', '2019-08-17 18:59:39');
INSERT INTO `access_log` VALUES (68627, '65.54.15660395776527407', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '114.92.173.93', '2019-08-17 18:59:38', 1393, 0, '', '2019-08-17 18:59:39');
INSERT INTO `access_log` VALUES (68628, '59.76.15660514597864631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.192.11.174', '2019-08-17 22:17:40', 11, 0, '', '2019-08-17 22:17:40');
INSERT INTO `access_log` VALUES (68629, '59.74.15660514597864659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.192.11.174', '2019-08-17 22:17:40', 25, 2001001000, '服务端发生异常', '2019-08-17 22:17:40');
INSERT INTO `access_log` VALUES (68630, '65.51.15660521135557741', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.8.143', '2019-08-17 22:28:34', 0, 1002001015, '账号未登陆', '2019-08-17 22:28:34');
INSERT INTO `access_log` VALUES (68631, '65.50.15660521135597681', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.8.143', '2019-08-17 22:28:34', 1, 1002001015, '账号未登陆', '2019-08-17 22:28:34');
INSERT INTO `access_log` VALUES (68632, '65.3607.15660521135619459', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.8.143', '2019-08-17 22:28:34', 0, 1002001015, '账号未登陆', '2019-08-17 22:28:34');
INSERT INTO `access_log` VALUES (68633, '65.54.15660521155427575', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.8.143', '2019-08-17 22:28:36', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 22:28:36');
INSERT INTO `access_log` VALUES (68634, '65.47.15660521227477631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.8.143', '2019-08-17 22:28:43', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 22:28:43');
INSERT INTO `access_log` VALUES (68635, '65.49.15660521274177679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.8.143', '2019-08-17 22:28:47', 5, 1002002001, '密码不正确', '2019-08-17 22:28:47');
INSERT INTO `access_log` VALUES (68636, '65.45.15660521406337689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.8.143', '2019-08-17 22:29:01', 304, 0, '', '2019-08-17 22:29:01');
INSERT INTO `access_log` VALUES (68637, '65.50.15660521413397683', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.8.143', '2019-08-17 22:29:01', 161, 0, '', '2019-08-17 22:29:02');
INSERT INTO `access_log` VALUES (68638, '65.3607.15660521413399461', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.8.143', '2019-08-17 22:29:01', 164, 0, '', '2019-08-17 22:29:02');
INSERT INTO `access_log` VALUES (68639, '65.53.15660521413397639', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.8.143', '2019-08-17 22:29:01', 164, 2001001000, '服务端发生异常', '2019-08-17 22:29:02');
INSERT INTO `access_log` VALUES (68640, '65.47.15660521502647633', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.8.143', '2019-08-17 22:29:10', 13, 0, '', '2019-08-17 22:29:10');
INSERT INTO `access_log` VALUES (68641, '65.54.15660521502637577', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.8.143', '2019-08-17 22:29:10', 14, 0, '', '2019-08-17 22:29:10');
INSERT INTO `access_log` VALUES (68642, '65.52.15660521502647723', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.8.143', '2019-08-17 22:29:10', 14, 2001001000, '服务端发生异常', '2019-08-17 22:29:10');
INSERT INTO `access_log` VALUES (68643, '59.75.15660531088944673', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.159.238.102', '2019-08-17 22:45:09', 4, 0, '', '2019-08-17 22:45:09');
INSERT INTO `access_log` VALUES (68644, '59.77.15660531089094653', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.159.238.102', '2019-08-17 22:45:09', 23, 2001001000, '服务端发生异常', '2019-08-17 22:45:09');
INSERT INTO `access_log` VALUES (68645, '65.51.15660531288517757', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.159.238.102', '2019-08-17 22:45:29', 1, 1002001015, '账号未登陆', '2019-08-17 22:45:29');
INSERT INTO `access_log` VALUES (68646, '65.53.15660531288507653', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.159.238.102', '2019-08-17 22:45:29', 1, 1002001015, '账号未登陆', '2019-08-17 22:45:29');
INSERT INTO `access_log` VALUES (68647, '65.54.15660531288607591', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.159.238.102', '2019-08-17 22:45:29', 1, 1002001015, '账号未登陆', '2019-08-17 22:45:29');
INSERT INTO `access_log` VALUES (68648, '65.52.15660531320907737', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.159.238.102', '2019-08-17 22:45:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-17 22:45:32');
INSERT INTO `access_log` VALUES (68649, '65.47.15660531374687647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.159.238.102', '2019-08-17 22:45:37', 62, 0, '', '2019-08-17 22:45:38');
INSERT INTO `access_log` VALUES (68650, '65.49.15660531378657695', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.159.238.102', '2019-08-17 22:45:38', 10, 0, '', '2019-08-17 22:45:38');
INSERT INTO `access_log` VALUES (68651, '65.46.15660531378657735', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.159.238.102', '2019-08-17 22:45:38', 11, 2001001000, '服务端发生异常', '2019-08-17 22:45:38');
INSERT INTO `access_log` VALUES (68652, '65.45.15660531378697705', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.159.238.102', '2019-08-17 22:45:38', 9, 0, '', '2019-08-17 22:45:38');
INSERT INTO `access_log` VALUES (68653, '65.51.15660531651727759', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.159.238.102', '2019-08-17 22:46:05', 8, 0, '', '2019-08-17 22:46:05');
INSERT INTO `access_log` VALUES (68654, '65.54.15660531651787593', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.159.238.102', '2019-08-17 22:46:05', 8, 2001001000, '服务端发生异常', '2019-08-17 22:46:05');
INSERT INTO `access_log` VALUES (68655, '65.53.15660531651827655', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.159.238.102', '2019-08-17 22:46:05', 7, 0, '', '2019-08-17 22:46:05');
INSERT INTO `access_log` VALUES (68656, '59.71.15660539978154677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.83.243.2', '2019-08-17 22:59:58', 3, 0, '', '2019-08-17 22:59:58');
INSERT INTO `access_log` VALUES (68657, '59.77.15660539978154665', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.83.243.2', '2019-08-17 22:59:58', 18, 2001001000, '服务端发生异常', '2019-08-17 22:59:58');
INSERT INTO `access_log` VALUES (68658, '64.84.15660539999065035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.83.243.2', '2019-08-17 23:00:00', 12, 0, '', '2019-08-17 23:00:00');
INSERT INTO `access_log` VALUES (68659, '64.82.15660540000635049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.83.243.2', '2019-08-17 23:00:00', 3, 0, '', '2019-08-17 23:00:00');
INSERT INTO `access_log` VALUES (68660, '59.72.15660540010004677', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.83.243.2', '2019-08-17 23:00:01', 13, 2001001000, '服务端发生异常', '2019-08-17 23:00:01');
INSERT INTO `access_log` VALUES (68661, '59.80.15660540010004651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.83.243.2', '2019-08-17 23:00:01', 274, 0, '', '2019-08-17 23:00:01');
INSERT INTO `access_log` VALUES (68662, '65.51.15660540104207771', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.83.243.2', '2019-08-17 23:00:10', 4, 1002001012, '访问令牌已过期', '2019-08-17 23:00:10');
INSERT INTO `access_log` VALUES (68663, '65.53.15660540104207667', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.83.243.2', '2019-08-17 23:00:10', 4, 1002001012, '访问令牌已过期', '2019-08-17 23:00:10');
INSERT INTO `access_log` VALUES (68664, '65.54.15660540104257605', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '110.83.243.2', '2019-08-17 23:00:10', 4, 1002001012, '访问令牌已过期', '2019-08-17 23:00:10');
INSERT INTO `access_log` VALUES (68665, '59.77.15660615884524767', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.223.93.10', '2019-08-18 01:06:28', 11, 0, '', '2019-08-18 01:06:28');
INSERT INTO `access_log` VALUES (68666, '59.71.15660615884524779', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.223.93.10', '2019-08-18 01:06:28', 16, 2001001000, '服务端发生异常', '2019-08-18 01:06:28');
INSERT INTO `access_log` VALUES (68667, '64.83.15660615981775133', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:06:38', 11, 0, '', '2019-08-18 01:06:38');
INSERT INTO `access_log` VALUES (68668, '64.84.15660615983575137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:06:38', 3, 0, '', '2019-08-18 01:06:38');
INSERT INTO `access_log` VALUES (68669, '64.82.15660616016575151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:06:42', 2, 0, '', '2019-08-18 01:06:42');
INSERT INTO `access_log` VALUES (68670, '64.77.15660616017905129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:06:42', 2, 0, '', '2019-08-18 01:06:42');
INSERT INTO `access_log` VALUES (68671, '66.57.15660616149932333', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17358671342', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:06:55', 117, 0, '', '2019-08-18 01:06:55');
INSERT INTO `access_log` VALUES (68672, '66.51.15660616205132357', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17358671342&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:01', 213, 0, '', '2019-08-18 01:07:01');
INSERT INTO `access_log` VALUES (68673, '66.55.15660616219892315', 206, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:02', 8, 0, '', '2019-08-18 01:07:02');
INSERT INTO `access_log` VALUES (68674, '66.50.15660616261402333', 206, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:06', 6, 0, '', '2019-08-18 01:07:06');
INSERT INTO `access_log` VALUES (68675, '66.52.15660616268272335', 206, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:07', 6, 0, '', '2019-08-18 01:07:07');
INSERT INTO `access_log` VALUES (68676, '66.56.15660616280722349', 206, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:08', 4, 0, '', '2019-08-18 01:07:08');
INSERT INTO `access_log` VALUES (68677, '66.54.15660616294852349', 206, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:09', 5, 0, '', '2019-08-18 01:07:09');
INSERT INTO `access_log` VALUES (68678, '66.48.15660616341012335', 206, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:14', 6, 0, '', '2019-08-18 01:07:14');
INSERT INTO `access_log` VALUES (68679, '66.57.15660616373162335', 206, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:17', 6, 0, '', '2019-08-18 01:07:17');
INSERT INTO `access_log` VALUES (68680, '64.80.15660616383005143', 206, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:18', 6, 0, '', '2019-08-18 01:07:18');
INSERT INTO `access_log` VALUES (68681, '64.79.15660616385815139', 206, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:19', 9, 0, '', '2019-08-18 01:07:19');
INSERT INTO `access_log` VALUES (68682, '64.83.15660616397545135', 206, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:20', 6, 0, '', '2019-08-18 01:07:20');
INSERT INTO `access_log` VALUES (68683, 'N/A', 206, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:20', 12, 0, '', '2019-08-18 01:07:20');
INSERT INTO `access_log` VALUES (68684, '64.77.15660616411595131', 206, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:21', 12, 0, '', '2019-08-18 01:07:21');
INSERT INTO `access_log` VALUES (68685, '66.55.15660616485682317', 206, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:29', 6, 0, '', '2019-08-18 01:07:29');
INSERT INTO `access_log` VALUES (68686, '64.81.15660616558735141', 206, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:36', 10, 0, '', '2019-08-18 01:07:36');
INSERT INTO `access_log` VALUES (68687, '64.76.15660616566175145', 206, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:37', 5, 0, '', '2019-08-18 01:07:37');
INSERT INTO `access_log` VALUES (68688, 'N/A', 206, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:37', 10, 0, '', '2019-08-18 01:07:37');
INSERT INTO `access_log` VALUES (68689, '64.80.15660616572505145', 206, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:37', 7, 0, '', '2019-08-18 01:07:37');
INSERT INTO `access_log` VALUES (68690, '64.85.15660616574105173', 206, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:37', 6, 0, '', '2019-08-18 01:07:37');
INSERT INTO `access_log` VALUES (68691, '64.79.15660616606785141', 206, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:41', 6, 0, '', '2019-08-18 01:07:41');
INSERT INTO `access_log` VALUES (68692, '64.83.15660616610025137', 206, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:41', 6, 0, '', '2019-08-18 01:07:41');
INSERT INTO `access_log` VALUES (68693, '59.71.15660616617304781', 206, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:42', 9, 0, '', '2019-08-18 01:07:42');
INSERT INTO `access_log` VALUES (68694, '59.75.15660616617304789', 206, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:07:42', 22, 2001001000, '服务端发生异常', '2019-08-18 01:07:42');
INSERT INTO `access_log` VALUES (68695, '66.49.15660617942162335', 206, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:09:54', 7, 0, '', '2019-08-18 01:09:54');
INSERT INTO `access_log` VALUES (68696, '66.50.15660617960082337', 206, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:09:56', 5, 0, '', '2019-08-18 01:09:56');
INSERT INTO `access_log` VALUES (68697, '66.52.15660617976642339', 206, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '171.223.93.10', '2019-08-18 01:09:58', 5, 0, '', '2019-08-18 01:09:58');
INSERT INTO `access_log` VALUES (68698, '59.72.15660618053384783', 206, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.223.93.10', '2019-08-18 01:10:05', 20, 2001001000, '服务端发生异常', '2019-08-18 01:10:05');
INSERT INTO `access_log` VALUES (68699, '59.77.15660618052914771', 206, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.223.93.10', '2019-08-18 01:10:05', 146, 0, '', '2019-08-18 01:10:05');
INSERT INTO `access_log` VALUES (68700, '66.54.15660618087032353', 206, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.223.93.10', '2019-08-18 01:10:09', 6, 0, '', '2019-08-18 01:10:09');
INSERT INTO `access_log` VALUES (68701, '66.48.15660618100312339', 206, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.223.93.10', '2019-08-18 01:10:10', 5, 0, '', '2019-08-18 01:10:10');
INSERT INTO `access_log` VALUES (68702, '66.57.15660618130532339', 206, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.223.93.10', '2019-08-18 01:10:13', 5, 0, '', '2019-08-18 01:10:13');
INSERT INTO `access_log` VALUES (68703, '65.51.15660901256118253', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.172.46', '2019-08-18 09:02:06', 1, 1002001015, '账号未登陆', '2019-08-18 09:02:06');
INSERT INTO `access_log` VALUES (68704, '65.53.15660901256118149', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.172.46', '2019-08-18 09:02:06', 0, 1002001015, '账号未登陆', '2019-08-18 09:02:06');
INSERT INTO `access_log` VALUES (68705, '65.54.15660901256348087', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.172.46', '2019-08-18 09:02:06', 1, 1002001015, '账号未登陆', '2019-08-18 09:02:06');
INSERT INTO `access_log` VALUES (68706, '65.47.15660901395518143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.172.46', '2019-08-18 09:02:20', 76, 0, '', '2019-08-18 09:02:20');
INSERT INTO `access_log` VALUES (68707, '65.49.15660901398638191', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.172.46', '2019-08-18 09:02:20', 20, 0, '', '2019-08-18 09:02:20');
INSERT INTO `access_log` VALUES (68708, '65.45.15660901398668201', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.172.46', '2019-08-18 09:02:20', 19, 2001001000, '服务端发生异常', '2019-08-18 09:02:20');
INSERT INTO `access_log` VALUES (68709, '65.46.15660901398708231', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.183.172.46', '2019-08-18 09:02:20', 16, 0, '', '2019-08-18 09:02:20');
INSERT INTO `access_log` VALUES (68710, '65.50.15660929916868233', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.201.48', '2019-08-18 09:49:52', 0, 1002001015, '账号未登陆', '2019-08-18 09:49:52');
INSERT INTO `access_log` VALUES (68711, '65.3607.15660929916860011', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.201.48', '2019-08-18 09:49:52', 0, 1002001015, '账号未登陆', '2019-08-18 09:49:52');
INSERT INTO `access_log` VALUES (68712, '65.53.15660929917138189', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.201.48', '2019-08-18 09:49:52', 0, 1002001015, '账号未登陆', '2019-08-18 09:49:52');
INSERT INTO `access_log` VALUES (68713, '65.45.15660958893528279', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.56.8', '2019-08-18 10:38:09', 0, 1002001015, '账号未登陆', '2019-08-18 10:38:09');
INSERT INTO `access_log` VALUES (68714, '65.49.15660958893648269', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.56.0', '2019-08-18 10:38:09', 0, 1002001015, '账号未登陆', '2019-08-18 10:38:09');
INSERT INTO `access_log` VALUES (68715, '65.46.15660958893728309', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.56.0', '2019-08-18 10:38:09', 1, 1002001015, '账号未登陆', '2019-08-18 10:38:09');
INSERT INTO `access_log` VALUES (68716, '65.50.15660959142958273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.56.0', '2019-08-18 10:38:34', 87, 0, '', '2019-08-18 10:38:34');
INSERT INTO `access_log` VALUES (68717, '65.53.15660959149118229', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.56.0', '2019-08-18 10:38:35', 113, 0, '', '2019-08-18 10:38:35');
INSERT INTO `access_log` VALUES (68718, '65.51.15660959149138333', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.56.0', '2019-08-18 10:38:35', 113, 2001001000, '服务端发生异常', '2019-08-18 10:38:35');
INSERT INTO `access_log` VALUES (68719, '65.54.15660959149258167', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.56.8', '2019-08-18 10:38:35', 99, 0, '', '2019-08-18 10:38:35');
INSERT INTO `access_log` VALUES (68720, '65.46.15660965504248319', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-18 10:49:10', 0, 1002001015, '账号未登陆', '2019-08-18 10:49:10');
INSERT INTO `access_log` VALUES (68721, '65.45.15660965504288289', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-18 10:49:10', 0, 1002001015, '账号未登陆', '2019-08-18 10:49:10');
INSERT INTO `access_log` VALUES (68722, '65.3607.15660965504330061', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-18 10:49:10', 0, 1002001015, '账号未登陆', '2019-08-18 10:49:10');
INSERT INTO `access_log` VALUES (68723, '65.50.15660965527748283', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-18 10:49:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-18 10:49:13');
INSERT INTO `access_log` VALUES (68724, '65.51.15660965693758343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-18 10:49:29', 63, 0, '', '2019-08-18 10:49:29');
INSERT INTO `access_log` VALUES (68725, '65.53.15660965697548239', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-18 10:49:30', 9, 0, '', '2019-08-18 10:49:30');
INSERT INTO `access_log` VALUES (68726, '65.47.15660965697758233', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-18 10:49:30', 10, 0, '', '2019-08-18 10:49:30');
INSERT INTO `access_log` VALUES (68727, '65.52.15660965697758323', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-18 10:49:30', 10, 2001001000, '服务端发生异常', '2019-08-18 10:49:30');
INSERT INTO `access_log` VALUES (68728, '59.78.15660978520235273', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:10:52', 10, 0, '', '2019-08-18 11:10:52');
INSERT INTO `access_log` VALUES (68729, '59.76.15660978520235253', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:10:52', 25, 2001001000, '服务端发生异常', '2019-08-18 11:10:52');
INSERT INTO `access_log` VALUES (68730, '64.78.15660978562625635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:10:56', 12, 0, '', '2019-08-18 11:10:56');
INSERT INTO `access_log` VALUES (68731, '64.81.15660978564105625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:10:56', 3, 0, '', '2019-08-18 11:10:56');
INSERT INTO `access_log` VALUES (68732, '64.76.15660978574965629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:10:57', 2, 0, '', '2019-08-18 11:10:58');
INSERT INTO `access_log` VALUES (68733, '64.80.15660978584655629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:10:58', 2, 0, '', '2019-08-18 11:10:58');
INSERT INTO `access_log` VALUES (68734, '64.85.15660978652005657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:11:05', 2, 0, '', '2019-08-18 11:11:05');
INSERT INTO `access_log` VALUES (68735, '64.79.15660978653295625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:11:05', 2, 0, '', '2019-08-18 11:11:05');
INSERT INTO `access_log` VALUES (68736, '59.75.15660978658855273', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:11:06', 3, 0, '', '2019-08-18 11:11:06');
INSERT INTO `access_log` VALUES (68737, '59.71.15660978658865265', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:11:06', 23, 2001001000, '服务端发生异常', '2019-08-18 11:11:06');
INSERT INTO `access_log` VALUES (68738, '65.53.15660978872128257', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:11:27', 1, 1002001015, '账号未登陆', '2019-08-18 11:11:27');
INSERT INTO `access_log` VALUES (68739, '65.47.15660978872148251', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:11:27', 0, 1002001015, '账号未登陆', '2019-08-18 11:11:27');
INSERT INTO `access_log` VALUES (68740, '65.49.15660978872218299', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:11:27', 1, 1002001015, '账号未登陆', '2019-08-18 11:11:27');
INSERT INTO `access_log` VALUES (68741, '65.46.15660978910008339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:11:31', 116, 0, '', '2019-08-18 11:11:31');
INSERT INTO `access_log` VALUES (68742, '65.45.15660978914508309', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:11:31', 9, 0, '', '2019-08-18 11:11:31');
INSERT INTO `access_log` VALUES (68743, '65.3607.15660978914500081', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:11:31', 11, 2001001000, '服务端发生异常', '2019-08-18 11:11:31');
INSERT INTO `access_log` VALUES (68744, '65.50.15660978914568303', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.20.192.215', '2019-08-18 11:11:31', 14, 0, '', '2019-08-18 11:11:31');
INSERT INTO `access_log` VALUES (68745, '65.46.15660988859588353', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:28:06', 1, 1002001015, '账号未登陆', '2019-08-18 11:28:06');
INSERT INTO `access_log` VALUES (68746, '65.45.15660988859588323', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:28:06', 0, 1002001015, '账号未登陆', '2019-08-18 11:28:06');
INSERT INTO `access_log` VALUES (68747, '65.3607.15660988859600095', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:28:06', 0, 1002001015, '账号未登陆', '2019-08-18 11:28:06');
INSERT INTO `access_log` VALUES (68748, '65.50.15660988884638317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:28:08', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-18 11:28:08');
INSERT INTO `access_log` VALUES (68749, '65.51.15660988954938377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:28:15', 108, 0, '', '2019-08-18 11:28:16');
INSERT INTO `access_log` VALUES (68750, '65.52.15660988959508357', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:28:16', 11, 0, '', '2019-08-18 11:28:16');
INSERT INTO `access_log` VALUES (68751, '65.49.15660988959538315', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:28:16', 11, 2001001000, '服务端发生异常', '2019-08-18 11:28:16');
INSERT INTO `access_log` VALUES (68752, '65.53.15660988959608273', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:28:16', 9, 0, '', '2019-08-18 11:28:16');
INSERT INTO `access_log` VALUES (68753, '65.46.15660989088938355', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:28:29', 10, 0, '', '2019-08-18 11:28:29');
INSERT INTO `access_log` VALUES (68754, '65.45.15660989088968325', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:28:29', 10, 2001001000, '服务端发生异常', '2019-08-18 11:28:29');
INSERT INTO `access_log` VALUES (68755, '65.3607.15660989089030097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:28:29', 8, 0, '', '2019-08-18 11:28:29');
INSERT INTO `access_log` VALUES (68756, '59.73.15660989726355283', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:29:33', 3, 0, '', '2019-08-18 11:29:33');
INSERT INTO `access_log` VALUES (68757, '59.79.15660989726665283', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:29:33', 16, 2001001000, '服务端发生异常', '2019-08-18 11:29:33');
INSERT INTO `access_log` VALUES (68758, '64.81.15660989788785641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:29:39', 2, 0, '', '2019-08-18 11:29:39');
INSERT INTO `access_log` VALUES (68759, '64.76.15660989789995645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:29:39', 1, 0, '', '2019-08-18 11:29:39');
INSERT INTO `access_log` VALUES (68760, '64.80.15660989804105645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:29:40', 2, 0, '', '2019-08-18 11:29:40');
INSERT INTO `access_log` VALUES (68761, '64.85.15660989809255673', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:29:41', 2, 0, '', '2019-08-18 11:29:41');
INSERT INTO `access_log` VALUES (68762, '64.79.15660989816995641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '14.20.89.46', '2019-08-18 11:29:42', 2, 0, '', '2019-08-18 11:29:42');
INSERT INTO `access_log` VALUES (68763, '59.71.15660997815595291', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.6.162.84', '2019-08-18 11:43:02', 3, 0, '', '2019-08-18 11:43:02');
INSERT INTO `access_log` VALUES (68764, '59.72.15660997815605291', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.6.162.84', '2019-08-18 11:43:02', 16, 2001001000, '服务端发生异常', '2019-08-18 11:43:02');
INSERT INTO `access_log` VALUES (68765, '59.73.15660997994545295', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '106.6.162.84', '2019-08-18 11:43:19', 2, 0, '', '2019-08-18 11:43:19');
INSERT INTO `access_log` VALUES (68766, '59.79.15660997994545295', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '106.6.162.84', '2019-08-18 11:43:19', 13, 2001001000, '服务端发生异常', '2019-08-18 11:43:19');
INSERT INTO `access_log` VALUES (68767, '65.54.15661080702168335', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:10', 0, 1002001015, '账号未登陆', '2019-08-18 14:01:10');
INSERT INTO `access_log` VALUES (68768, '65.51.15661080702168501', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:10', 0, 1002001015, '账号未登陆', '2019-08-18 14:01:10');
INSERT INTO `access_log` VALUES (68769, '65.49.15661080702168439', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:10', 0, 1002001015, '账号未登陆', '2019-08-18 14:01:10');
INSERT INTO `access_log` VALUES (68770, '65.52.15661080771658481', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-18 14:01:17');
INSERT INTO `access_log` VALUES (68771, '65.53.15661080810208397', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:21', 75, 0, '', '2019-08-18 14:01:21');
INSERT INTO `access_log` VALUES (68772, '65.46.15661080815238479', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:22', 46, 0, '', '2019-08-18 14:01:22');
INSERT INTO `access_log` VALUES (68773, '65.47.15661080815048391', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:22', 66, 0, '', '2019-08-18 14:01:22');
INSERT INTO `access_log` VALUES (68774, '65.3607.15661080815150221', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:22', 57, 2001001000, '服务端发生异常', '2019-08-18 14:01:22');
INSERT INTO `access_log` VALUES (68775, '65.50.15661080884698443', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:28', 8, 0, '', '2019-08-18 14:01:28');
INSERT INTO `access_log` VALUES (68776, '65.51.15661080884748503', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:28', 9, 2001001000, '服务端发生异常', '2019-08-18 14:01:28');
INSERT INTO `access_log` VALUES (68777, '65.54.15661080884798337', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:28', 8, 0, '', '2019-08-18 14:01:28');
INSERT INTO `access_log` VALUES (68778, '65.49.15661080913908441', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:31', 8, 0, '', '2019-08-18 14:01:31');
INSERT INTO `access_log` VALUES (68779, '65.52.15661080913948483', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:31', 10, 2001001000, '服务端发生异常', '2019-08-18 14:01:31');
INSERT INTO `access_log` VALUES (68780, '65.53.15661080913988399', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:31', 8, 0, '', '2019-08-18 14:01:31');
INSERT INTO `access_log` VALUES (68781, '65.3607.15661080943530223', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:34', 7, 0, '', '2019-08-18 14:01:34');
INSERT INTO `access_log` VALUES (68782, '65.46.15661080943578481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:34', 8, 2001001000, '服务端发生异常', '2019-08-18 14:01:34');
INSERT INTO `access_log` VALUES (68783, '65.47.15661080943618393', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.72.94.210', '2019-08-18 14:01:34', 7, 0, '', '2019-08-18 14:01:34');
INSERT INTO `access_log` VALUES (68784, '65.50.15661174244718569', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.230.100.84', '2019-08-18 16:37:04', 1, 1002001015, '账号未登陆', '2019-08-18 16:37:04');
INSERT INTO `access_log` VALUES (68785, '65.54.15661174244718463', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.230.100.84', '2019-08-18 16:37:04', 1, 1002001015, '账号未登陆', '2019-08-18 16:37:04');
INSERT INTO `access_log` VALUES (68786, '65.49.15661174244718567', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.230.100.84', '2019-08-18 16:37:04', 0, 1002001015, '账号未登陆', '2019-08-18 16:37:04');
INSERT INTO `access_log` VALUES (68787, '65.52.15661174272418609', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.230.100.84', '2019-08-18 16:37:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-18 16:37:07');
INSERT INTO `access_log` VALUES (68788, '65.3607.15661174320160349', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.230.100.84', '2019-08-18 16:37:12', 148, 0, '', '2019-08-18 16:37:12');
INSERT INTO `access_log` VALUES (68789, '65.46.15661174327038607', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.230.100.84', '2019-08-18 16:37:13', 9, 0, '', '2019-08-18 16:37:13');
INSERT INTO `access_log` VALUES (68790, '65.47.15661174327098519', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.230.100.84', '2019-08-18 16:37:13', 8, 2001001000, '服务端发生异常', '2019-08-18 16:37:13');
INSERT INTO `access_log` VALUES (68791, '65.45.15661174327158577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.230.100.84', '2019-08-18 16:37:13', 15, 0, '', '2019-08-18 16:37:13');
INSERT INTO `access_log` VALUES (68792, '59.75.15661181570225545', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '183.149.45.98', '2019-08-18 16:49:17', 11, 0, '', '2019-08-18 16:49:17');
INSERT INTO `access_log` VALUES (68793, '59.72.15661181570285537', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '183.149.45.98', '2019-08-18 16:49:17', 26, 2001001000, '服务端发生异常', '2019-08-18 16:49:17');
INSERT INTO `access_log` VALUES (68794, '59.76.15661182210405527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '180.97.118.223', '2019-08-18 16:50:21', 18, 2001001000, '服务端发生异常', '2019-08-18 16:50:21');
INSERT INTO `access_log` VALUES (68795, '59.78.15661182210895547', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.129.7.235', '2019-08-18 16:50:21', 8, 0, '', '2019-08-18 16:50:21');
INSERT INTO `access_log` VALUES (68796, '59.75.15661191391885559', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-18 17:05:39', 16, 2001001000, '服务端发生异常', '2019-08-18 17:05:39');
INSERT INTO `access_log` VALUES (68797, '59.72.15661191391875551', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-18 17:05:39', 191, 0, '', '2019-08-18 17:05:39');
INSERT INTO `access_log` VALUES (68798, '59.80.15661191579045525', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '59.174.89.101', '2019-08-18 17:05:58', 3, 0, '', '2019-08-18 17:05:58');
INSERT INTO `access_log` VALUES (68799, '59.77.15661191579025539', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '59.174.89.101', '2019-08-18 17:05:58', 13, 2001001000, '服务端发生异常', '2019-08-18 17:05:58');
INSERT INTO `access_log` VALUES (68800, '64.81.15661191611155911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '59.174.89.101', '2019-08-18 17:06:01', 11, 0, '', '2019-08-18 17:06:01');
INSERT INTO `access_log` VALUES (68801, '64.76.15661191612625915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '59.174.89.101', '2019-08-18 17:06:01', 2, 0, '', '2019-08-18 17:06:01');
INSERT INTO `access_log` VALUES (68802, '64.80.15661191629075915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '59.174.89.101', '2019-08-18 17:06:03', 2, 0, '', '2019-08-18 17:06:03');
INSERT INTO `access_log` VALUES (68803, '64.85.15661191634725943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '59.174.89.101', '2019-08-18 17:06:03', 2, 0, '', '2019-08-18 17:06:03');
INSERT INTO `access_log` VALUES (68804, '64.79.15661191645655911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '59.174.89.101', '2019-08-18 17:06:05', 2, 0, '', '2019-08-18 17:06:05');
INSERT INTO `access_log` VALUES (68805, '64.84.15661191686685911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '59.174.89.101', '2019-08-18 17:06:09', 3, 0, '', '2019-08-18 17:06:09');
INSERT INTO `access_log` VALUES (68806, '64.82.15661191687745925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '59.174.89.101', '2019-08-18 17:06:09', 2, 0, '', '2019-08-18 17:06:09');
INSERT INTO `access_log` VALUES (68807, '64.78.15661191816285923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '59.174.89.101', '2019-08-18 17:06:22', 2, 0, '', '2019-08-18 17:06:22');
INSERT INTO `access_log` VALUES (68808, '64.81.15661191817165913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '59.174.89.101', '2019-08-18 17:06:22', 2, 0, '', '2019-08-18 17:06:22');
INSERT INTO `access_log` VALUES (68809, '59.76.15661191821795541', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '59.174.89.101', '2019-08-18 17:06:22', 2, 0, '', '2019-08-18 17:06:22');
INSERT INTO `access_log` VALUES (68810, '59.78.15661191821835561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Mobile Safari/537.36', '59.174.89.101', '2019-08-18 17:06:22', 9, 2001001000, '服务端发生异常', '2019-08-18 17:06:22');
INSERT INTO `access_log` VALUES (68811, '65.52.15661192938218635', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-18 17:08:14', 0, 1002001015, '账号未登陆', '2019-08-18 17:08:14');
INSERT INTO `access_log` VALUES (68812, '65.53.15661192938218551', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-18 17:08:14', 0, 1002001015, '账号未登陆', '2019-08-18 17:08:14');
INSERT INTO `access_log` VALUES (68813, '65.3607.15661192938250375', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-18 17:08:14', 0, 1002001015, '账号未登陆', '2019-08-18 17:08:14');
INSERT INTO `access_log` VALUES (68814, '65.45.15661192958448603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-18 17:08:16', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-18 17:08:16');
INSERT INTO `access_log` VALUES (68815, '65.47.15661192987198545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-18 17:08:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-18 17:08:19');
INSERT INTO `access_log` VALUES (68816, '65.51.15661193121708657', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-18 17:08:32', 157, 0, '', '2019-08-18 17:08:32');
INSERT INTO `access_log` VALUES (68817, '65.49.15661193125538595', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-18 17:08:33', 17, 0, '', '2019-08-18 17:08:33');
INSERT INTO `access_log` VALUES (68818, '65.50.15661193125558597', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-18 17:08:33', 16, 2001001000, '服务端发生异常', '2019-08-18 17:08:33');
INSERT INTO `access_log` VALUES (68819, '65.54.15661193125568491', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-18 17:08:33', 18, 0, '', '2019-08-18 17:08:33');
INSERT INTO `access_log` VALUES (68820, '65.52.15661193200388637', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-18 17:08:40', 10, 0, '', '2019-08-18 17:08:40');
INSERT INTO `access_log` VALUES (68821, '65.45.15661193200428605', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-18 17:08:40', 9, 0, '', '2019-08-18 17:08:40');
INSERT INTO `access_log` VALUES (68822, '65.53.15661193200408553', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-18 17:08:40', 11, 2001001000, '服务端发生异常', '2019-08-18 17:08:40');
INSERT INTO `access_log` VALUES (68823, '59.73.15661218116505591', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.9134.1502 Mobile Safari/537.36; Bytespider', '110.249.201.25', '2019-08-18 17:50:12', 9, 0, '', '2019-08-18 17:50:12');
INSERT INTO `access_log` VALUES (68824, '59.77.15661218116425575', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0; Pixel 2 Build/OPD3.170816.012) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.9134.1502 Mobile Safari/537.36; Bytespider', '110.249.201.25', '2019-08-18 17:50:12', 20, 2001001000, '服务端发生异常', '2019-08-18 17:50:12');
INSERT INTO `access_log` VALUES (68825, '59.75.15661298069565703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.201.48', '2019-08-18 20:03:27', 11, 0, '', '2019-08-18 20:03:27');
INSERT INTO `access_log` VALUES (68826, '59.74.15661298069565711', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.201.48', '2019-08-18 20:03:27', 19, 2001001000, '服务端发生异常', '2019-08-18 20:03:27');
INSERT INTO `access_log` VALUES (68827, '64.81.15661298205436055', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.201.48', '2019-08-18 20:03:41', 11, 0, '', '2019-08-18 20:03:41');
INSERT INTO `access_log` VALUES (68828, '64.76.15661298206726059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.201.48', '2019-08-18 20:03:41', 3, 0, '', '2019-08-18 20:03:41');
INSERT INTO `access_log` VALUES (68829, '59.75.15661324957385739', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '223.72.81.105', '2019-08-18 20:48:16', 9, 0, '', '2019-08-18 20:48:16');
INSERT INTO `access_log` VALUES (68830, '59.72.15661324957385731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Safari/537.36', '223.72.81.105', '2019-08-18 20:48:16', 33, 2001001000, '服务端发生异常', '2019-08-18 20:48:16');
INSERT INTO `access_log` VALUES (68831, '59.75.15661344159795765', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.223.98.207', '2019-08-18 21:20:16', 10, 0, '', '2019-08-18 21:20:16');
INSERT INTO `access_log` VALUES (68832, '59.72.15661344159795757', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.223.98.207', '2019-08-18 21:20:16', 16, 2001001000, '服务端发生异常', '2019-08-18 21:20:16');
INSERT INTO `access_log` VALUES (68833, '64.81.15661344469356117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:20:47', 12, 0, '', '2019-08-18 21:20:47');
INSERT INTO `access_log` VALUES (68834, '64.76.15661344470766121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:20:47', 3, 0, '', '2019-08-18 21:20:47');
INSERT INTO `access_log` VALUES (68835, '64.80.15661344501086121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:20:50', 1, 0, '', '2019-08-18 21:20:50');
INSERT INTO `access_log` VALUES (68836, '64.79.15661344513036117', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:20:51', 2, 0, '', '2019-08-18 21:20:51');
INSERT INTO `access_log` VALUES (68837, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:20:51', 7, 0, '', '2019-08-18 21:20:51');
INSERT INTO `access_log` VALUES (68838, '64.83.15661344550216113', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:20:55', 9, 0, '', '2019-08-18 21:20:55');
INSERT INTO `access_log` VALUES (68839, '64.82.15661344743836131', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:21:14', 2, 0, '', '2019-08-18 21:21:14');
INSERT INTO `access_log` VALUES (68840, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:21:14', 6, 0, '', '2019-08-18 21:21:14');
INSERT INTO `access_log` VALUES (68841, '64.77.15661344755716109', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:21:16', 2, 0, '', '2019-08-18 21:21:16');
INSERT INTO `access_log` VALUES (68842, '64.78.15661344759336129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:21:16', 2, 0, '', '2019-08-18 21:21:16');
INSERT INTO `access_log` VALUES (68843, '59.76.15661344830715747', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:21:23', 4, 0, '', '2019-08-18 21:21:23');
INSERT INTO `access_log` VALUES (68844, '59.78.15661344830725767', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:21:23', 15, 2001001000, '服务端发生异常', '2019-08-18 21:21:23');
INSERT INTO `access_log` VALUES (68845, '64.76.15661344901836123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:21:30', 2, 0, '', '2019-08-18 21:21:30');
INSERT INTO `access_log` VALUES (68846, '64.80.15661344902946123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:21:30', 2, 0, '', '2019-08-18 21:21:30');
INSERT INTO `access_log` VALUES (68847, '64.85.15661344944036151', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:21:34', 2, 0, '', '2019-08-18 21:21:34');
INSERT INTO `access_log` VALUES (68848, '64.79.15661344945226119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '171.223.98.207', '2019-08-18 21:21:35', 3, 0, '', '2019-08-18 21:21:35');
INSERT INTO `access_log` VALUES (68849, '65.54.15661357497428711', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.219.101.203', '2019-08-18 21:42:30', 1, 1002001015, '账号未登陆', '2019-08-18 21:42:30');
INSERT INTO `access_log` VALUES (68850, '65.3607.15661357497420597', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.219.101.203', '2019-08-18 21:42:30', 1, 1002001015, '账号未登陆', '2019-08-18 21:42:30');
INSERT INTO `access_log` VALUES (68851, '65.53.15661357497668773', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.219.101.203', '2019-08-18 21:42:30', 0, 1002001015, '账号未登陆', '2019-08-18 21:42:30');
INSERT INTO `access_log` VALUES (68852, '65.45.15661357548088825', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.127.35.42', '2019-08-18 21:42:35', 19, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-18 21:42:35');
INSERT INTO `access_log` VALUES (68853, '65.46.15661357881228855', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.219.101.203', '2019-08-18 21:43:08', 61, 0, '', '2019-08-18 21:43:08');
INSERT INTO `access_log` VALUES (68854, '65.50.15661357890128819', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.219.101.203', '2019-08-18 21:43:09', 16, 0, '', '2019-08-18 21:43:09');
INSERT INTO `access_log` VALUES (68855, '65.49.15661357890148817', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.219.101.203', '2019-08-18 21:43:09', 16, 2001001000, '服务端发生异常', '2019-08-18 21:43:09');
INSERT INTO `access_log` VALUES (68856, '65.3607.15661357890210599', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.127.35.42', '2019-08-18 21:43:09', 11, 0, '', '2019-08-18 21:43:09');
INSERT INTO `access_log` VALUES (68857, '59.74.15661371930745811', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.63.203.251', '2019-08-18 22:06:33', 21, 0, '', '2019-08-18 22:06:33');
INSERT INTO `access_log` VALUES (68858, '59.72.15661371930755795', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.63.203.251', '2019-08-18 22:06:33', 30, 2001001000, '服务端发生异常', '2019-08-18 22:06:33');
INSERT INTO `access_log` VALUES (68859, '64.84.15661372003616155', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.63.203.251', '2019-08-18 22:06:40', 9, 0, '', '2019-08-18 22:06:40');
INSERT INTO `access_log` VALUES (68860, '64.82.15661372005356169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.63.203.251', '2019-08-18 22:06:41', 4, 0, '', '2019-08-18 22:06:41');
INSERT INTO `access_log` VALUES (68861, '65.45.15661372695928847', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.63.203.251', '2019-08-18 22:07:50', 0, 1002001015, '账号未登陆', '2019-08-18 22:07:50');
INSERT INTO `access_log` VALUES (68862, '65.52.15661372695958879', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.170.50.59', '2019-08-18 22:07:50', 0, 1002001015, '账号未登陆', '2019-08-18 22:07:50');
INSERT INTO `access_log` VALUES (68863, '65.47.15661372695988787', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.136.21.155', '2019-08-18 22:07:50', 1, 1002001015, '账号未登陆', '2019-08-18 22:07:50');
INSERT INTO `access_log` VALUES (68864, '65.51.15661372867968899', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.136.21.155', '2019-08-18 22:08:07', 603, 0, '', '2019-08-18 22:08:07');
INSERT INTO `access_log` VALUES (68865, '65.3607.15661372880190621', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.194.162', '2019-08-18 22:08:08', 12, 0, '', '2019-08-18 22:08:08');
INSERT INTO `access_log` VALUES (68866, '65.49.15661372880238839', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.170.50.59', '2019-08-18 22:08:08', 9, 0, '', '2019-08-18 22:08:08');
INSERT INTO `access_log` VALUES (68867, '65.50.15661372880288841', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.136.21.155', '2019-08-18 22:08:08', 11, 2001001000, '服务端发生异常', '2019-08-18 22:08:08');
INSERT INTO `access_log` VALUES (68868, '65.45.15661373003508849', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.90.92.19', '2019-08-18 22:08:20', 10, 0, '', '2019-08-18 22:08:20');
INSERT INTO `access_log` VALUES (68869, '65.53.15661373003488797', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.63.203.251', '2019-08-18 22:08:20', 12, 2001001000, '服务端发生异常', '2019-08-18 22:08:20');
INSERT INTO `access_log` VALUES (68870, '65.52.15661373003638881', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.136.21.155', '2019-08-18 22:08:20', 7, 0, '', '2019-08-18 22:08:20');
INSERT INTO `access_log` VALUES (68871, '65.51.15661398740628935', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:14', 0, 1002001015, '账号未登陆', '2019-08-18 22:51:14');
INSERT INTO `access_log` VALUES (68872, '65.50.15661398740638877', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:14', 0, 1002001015, '账号未登陆', '2019-08-18 22:51:14');
INSERT INTO `access_log` VALUES (68873, '65.3607.15661398740650657', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:14', 0, 1002001015, '账号未登陆', '2019-08-18 22:51:14');
INSERT INTO `access_log` VALUES (68874, '65.49.15661398794168875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:19', 89, 0, '', '2019-08-18 22:51:20');
INSERT INTO `access_log` VALUES (68875, '65.54.15661398796968771', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:20', 13, 0, '', '2019-08-18 22:51:20');
INSERT INTO `access_log` VALUES (68876, '65.45.15661398796968885', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:20', 22, 2001001000, '服务端发生异常', '2019-08-18 22:51:20');
INSERT INTO `access_log` VALUES (68877, '65.53.15661398797098833', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:20', 9, 0, '', '2019-08-18 22:51:20');
INSERT INTO `access_log` VALUES (68878, '65.52.15661398838828917', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:24', 10, 0, '', '2019-08-18 22:51:24');
INSERT INTO `access_log` VALUES (68879, '65.47.15661398838828825', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:24', 11, 2001001000, '服务端发生异常', '2019-08-18 22:51:24');
INSERT INTO `access_log` VALUES (68880, '65.46.15661398838888915', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:24', 9, 0, '', '2019-08-18 22:51:24');
INSERT INTO `access_log` VALUES (68881, '59.71.15661398991055831', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:39', 17, 0, '', '2019-08-18 22:51:39');
INSERT INTO `access_log` VALUES (68882, '59.80.15661398991055805', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:39', 24, 2001001000, '服务端发生异常', '2019-08-18 22:51:39');
INSERT INTO `access_log` VALUES (68883, '64.77.15661399027146183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:43', 11, 0, '', '2019-08-18 22:51:43');
INSERT INTO `access_log` VALUES (68884, '64.78.15661399028326203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:43', 4, 0, '', '2019-08-18 22:51:43');
INSERT INTO `access_log` VALUES (68885, '64.81.15661399041086193', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:44', 2, 0, '', '2019-08-18 22:51:44');
INSERT INTO `access_log` VALUES (68886, '64.76.15661399045786197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:45', 2, 0, '', '2019-08-18 22:51:45');
INSERT INTO `access_log` VALUES (68887, '64.80.15661399048596197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.143.126.211', '2019-08-18 22:51:45', 2, 0, '', '2019-08-18 22:51:45');
INSERT INTO `access_log` VALUES (68888, '59.73.15661427480265873', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.37.150.185', '2019-08-18 23:39:08', 18, 2001001000, '服务端发生异常', '2019-08-18 23:39:08');
INSERT INTO `access_log` VALUES (68889, '59.77.15661427480265857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.37.150.185', '2019-08-18 23:39:08', 100, 0, '', '2019-08-18 23:39:08');
INSERT INTO `access_log` VALUES (68890, '59.77.15661518803575979', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 02:11:20', 10, 0, '', '2019-08-19 02:11:20');
INSERT INTO `access_log` VALUES (68891, '59.79.15661518803585995', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 02:11:20', 15, 2001001000, '服务端发生异常', '2019-08-19 02:11:20');
INSERT INTO `access_log` VALUES (68892, '64.80.15661518832236357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 02:11:23', 12, 0, '', '2019-08-19 02:11:23');
INSERT INTO `access_log` VALUES (68893, '64.85.15661518834396385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 02:11:23', 3, 0, '', '2019-08-19 02:11:23');
INSERT INTO `access_log` VALUES (68894, '65.3607.15661518894820819', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 02:11:29', 1, 1002001015, '账号未登陆', '2019-08-19 02:11:29');
INSERT INTO `access_log` VALUES (68895, '65.51.15661518894819097', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 02:11:29', 1, 1002001015, '账号未登陆', '2019-08-19 02:11:29');
INSERT INTO `access_log` VALUES (68896, '65.49.15661518895129037', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 02:11:30', 1, 1002001015, '账号未登陆', '2019-08-19 02:11:30');
INSERT INTO `access_log` VALUES (68897, '65.54.15661518947158933', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 02:11:35', 1, 1002001015, '账号未登陆', '2019-08-19 02:11:35');
INSERT INTO `access_log` VALUES (68898, '65.53.15661518947188995', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 02:11:35', 0, 1002001015, '账号未登陆', '2019-08-19 02:11:35');
INSERT INTO `access_log` VALUES (68899, '65.45.15661518947189047', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 02:11:35', 1, 1002001015, '账号未登陆', '2019-08-19 02:11:35');
INSERT INTO `access_log` VALUES (68900, '65.50.15661518982859041', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 02:11:38', 77, 0, '', '2019-08-19 02:11:38');
INSERT INTO `access_log` VALUES (68901, '65.47.15661518986018987', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 02:11:39', 14, 0, '', '2019-08-19 02:11:39');
INSERT INTO `access_log` VALUES (68902, '65.46.15661518986079077', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 02:11:39', 12, 2001001000, '服务端发生异常', '2019-08-19 02:11:39');
INSERT INTO `access_log` VALUES (68903, '65.52.15661518986119079', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 02:11:39', 13, 0, '', '2019-08-19 02:11:39');
INSERT INTO `access_log` VALUES (68904, '65.49.15661737910949331', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 08:16:31', 22, 1002001012, '访问令牌已过期', '2019-08-19 08:16:31');
INSERT INTO `access_log` VALUES (68905, '65.3607.15661737910941113', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 08:16:31', 26, 1002001012, '访问令牌已过期', '2019-08-19 08:16:31');
INSERT INTO `access_log` VALUES (68906, '65.51.15661737911069391', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 08:16:31', 18, 1002001012, '访问令牌已过期', '2019-08-19 08:16:31');
INSERT INTO `access_log` VALUES (68907, '65.45.15661737928209341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 08:16:33', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 08:16:33');
INSERT INTO `access_log` VALUES (68908, '65.53.15661737988629289', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 08:16:39', 96, 0, '', '2019-08-19 08:16:39');
INSERT INTO `access_log` VALUES (68909, '65.52.15661737992189373', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 08:16:39', 57, 2001001000, '服务端发生异常', '2019-08-19 08:16:39');
INSERT INTO `access_log` VALUES (68910, '65.47.15661737992249281', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 08:16:39', 52, 0, '', '2019-08-19 08:16:39');
INSERT INTO `access_log` VALUES (68911, '65.50.15661737992129335', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.200.126.207', '2019-08-19 08:16:39', 69, 0, '', '2019-08-19 08:16:39');
INSERT INTO `access_log` VALUES (68912, '59.75.15661766926796331', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.17.229.193', '2019-08-19 09:04:53', 11, 0, '', '2019-08-19 09:04:53');
INSERT INTO `access_log` VALUES (68913, '59.80.15661766926796297', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '183.17.229.193', '2019-08-19 09:04:53', 26, 2001001000, '服务端发生异常', '2019-08-19 09:04:53');
INSERT INTO `access_log` VALUES (68914, '65.45.15661766969099381', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:04:57', 0, 1002001015, '账号未登陆', '2019-08-19 09:04:57');
INSERT INTO `access_log` VALUES (68915, '65.51.15661766969099431', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:04:57', 1, 1002001015, '账号未登陆', '2019-08-19 09:04:57');
INSERT INTO `access_log` VALUES (68916, '65.54.15661766969119267', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:04:57', 0, 1002001015, '账号未登陆', '2019-08-19 09:04:57');
INSERT INTO `access_log` VALUES (68917, '65.53.15661767011569329', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:05:01', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 09:05:01');
INSERT INTO `access_log` VALUES (68918, '65.52.15661767122999413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:05:12', 110, 0, '', '2019-08-19 09:05:12');
INSERT INTO `access_log` VALUES (68919, '65.50.15661767127249375', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:05:13', 10, 0, '', '2019-08-19 09:05:13');
INSERT INTO `access_log` VALUES (68920, '65.46.15661767127329411', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:05:13', 9, 0, '', '2019-08-19 09:05:13');
INSERT INTO `access_log` VALUES (68921, '65.3607.15661767353331155', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:05:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 09:05:35');
INSERT INTO `access_log` VALUES (68922, '65.45.15661767446909383', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:05:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 09:05:45');
INSERT INTO `access_log` VALUES (68923, '65.53.15661767605919331', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:06:01', 80, 0, '', '2019-08-19 09:06:01');
INSERT INTO `access_log` VALUES (68924, '65.47.15661767612259323', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:06:01', 9, 0, '', '2019-08-19 09:06:01');
INSERT INTO `access_log` VALUES (68925, '65.52.15661767612349415', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:06:01', 8, 0, '', '2019-08-19 09:06:01');
INSERT INTO `access_log` VALUES (68926, '65.46.15661767673919413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:06:07', 19, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 09:06:07');
INSERT INTO `access_log` VALUES (68927, '65.49.15661767723419375', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:06:12', 118, 0, '', '2019-08-19 09:06:12');
INSERT INTO `access_log` VALUES (68928, '65.3607.15661767727401157', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:06:13', 9, 0, '', '2019-08-19 09:06:13');
INSERT INTO `access_log` VALUES (68929, '65.54.15661767727479271', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 09:06:13', 9, 0, '', '2019-08-19 09:06:13');
INSERT INTO `access_log` VALUES (68930, '59.72.15661772325546331', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.94.232.240', '2019-08-19 09:13:53', 4, 0, '', '2019-08-19 09:13:53');
INSERT INTO `access_log` VALUES (68931, '59.74.15661772325546347', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.94.232.240', '2019-08-19 09:13:53', 15, 2001001000, '服务端发生异常', '2019-08-19 09:13:53');
INSERT INTO `access_log` VALUES (68932, '64.79.15661772374146691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.94.232.240', '2019-08-19 09:13:57', 79, 0, '', '2019-08-19 09:13:57');
INSERT INTO `access_log` VALUES (68933, '64.83.15661772376286687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.94.232.240', '2019-08-19 09:13:58', 3, 0, '', '2019-08-19 09:13:58');
INSERT INTO `access_log` VALUES (68934, '64.84.15661772391146691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.94.232.240', '2019-08-19 09:13:59', 2, 0, '', '2019-08-19 09:13:59');
INSERT INTO `access_log` VALUES (68935, '64.82.15661772397666705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.94.232.240', '2019-08-19 09:14:00', 2, 0, '', '2019-08-19 09:14:00');
INSERT INTO `access_log` VALUES (68936, '64.77.15661772433186683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.94.232.240', '2019-08-19 09:14:03', 2, 0, '', '2019-08-19 09:14:03');
INSERT INTO `access_log` VALUES (68937, '64.78.15661772435686703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '211.94.232.240', '2019-08-19 09:14:04', 3, 0, '', '2019-08-19 09:14:04');
INSERT INTO `access_log` VALUES (68938, '65.46.15661795473649453', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.79.40', '2019-08-19 09:52:27', 0, 1002001015, '账号未登陆', '2019-08-19 09:52:27');
INSERT INTO `access_log` VALUES (68939, '65.51.15661795473649473', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.79.40', '2019-08-19 09:52:27', 0, 1002001015, '账号未登陆', '2019-08-19 09:52:27');
INSERT INTO `access_log` VALUES (68940, '65.50.15661795474079415', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.79.40', '2019-08-19 09:52:27', 0, 1002001015, '账号未登陆', '2019-08-19 09:52:27');
INSERT INTO `access_log` VALUES (68941, '65.47.15661795511049361', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.79.40', '2019-08-19 09:52:31', 90, 0, '', '2019-08-19 09:52:31');
INSERT INTO `access_log` VALUES (68942, '65.49.15661795513779415', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.79.40', '2019-08-19 09:52:31', 12, 0, '', '2019-08-19 09:52:31');
INSERT INTO `access_log` VALUES (68943, '65.45.15661795513829421', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.79.40', '2019-08-19 09:52:31', 12, 2001001000, '服务端发生异常', '2019-08-19 09:52:31');
INSERT INTO `access_log` VALUES (68944, '65.3607.15661795513851197', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '220.184.79.40', '2019-08-19 09:52:31', 9, 0, '', '2019-08-19 09:52:31');
INSERT INTO `access_log` VALUES (68945, '59.80.15661797827016339', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.184.71.250', '2019-08-19 09:56:23', 10, 0, '', '2019-08-19 09:56:23');
INSERT INTO `access_log` VALUES (68946, '59.75.15661797827026373', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.184.71.250', '2019-08-19 09:56:23', 18, 2001001000, '服务端发生异常', '2019-08-19 09:56:23');
INSERT INTO `access_log` VALUES (68947, '64.81.15661797870566727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.184.71.250', '2019-08-19 09:56:27', 11, 0, '', '2019-08-19 09:56:27');
INSERT INTO `access_log` VALUES (68948, '64.76.15661797871666731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.184.71.250', '2019-08-19 09:56:27', 2, 0, '', '2019-08-19 09:56:27');
INSERT INTO `access_log` VALUES (68949, '64.80.15661797883876731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.184.71.250', '2019-08-19 09:56:28', 9, 0, '', '2019-08-19 09:56:28');
INSERT INTO `access_log` VALUES (68950, '64.85.15661797888656759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.184.71.250', '2019-08-19 09:56:29', 1, 0, '', '2019-08-19 09:56:29');
INSERT INTO `access_log` VALUES (68951, '64.79.15661797892246727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.184.71.250', '2019-08-19 09:56:29', 2, 0, '', '2019-08-19 09:56:29');
INSERT INTO `access_log` VALUES (68952, '64.83.15661797895306723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.184.71.250', '2019-08-19 09:56:30', 1, 0, '', '2019-08-19 09:56:30');
INSERT INTO `access_log` VALUES (68953, '59.76.15661805984396365', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.56.16', '2019-08-19 10:09:58', 4, 0, '', '2019-08-19 10:09:58');
INSERT INTO `access_log` VALUES (68954, '59.78.15661805984406385', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.56.16', '2019-08-19 10:09:58', 13, 2001001000, '服务端发生异常', '2019-08-19 10:09:58');
INSERT INTO `access_log` VALUES (68955, '65.49.15661813253819439', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:05', 0, 1002001015, '账号未登陆', '2019-08-19 10:22:05');
INSERT INTO `access_log` VALUES (68956, '65.3607.15661813253801221', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:05', 0, 1002001015, '账号未登陆', '2019-08-19 10:22:05');
INSERT INTO `access_log` VALUES (68957, '65.54.15661813254029335', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:05', 0, 1002001015, '账号未登陆', '2019-08-19 10:22:05');
INSERT INTO `access_log` VALUES (68958, '65.53.15661813386609397', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:19', 145, 0, '', '2019-08-19 10:22:19');
INSERT INTO `access_log` VALUES (68959, '65.46.15661813390499479', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:19', 10, 0, '', '2019-08-19 10:22:19');
INSERT INTO `access_log` VALUES (68960, '65.51.15661813390809499', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:19', 13, 0, '', '2019-08-19 10:22:19');
INSERT INTO `access_log` VALUES (68961, '65.50.15661813390809441', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:19', 15, 2001001000, '服务端发生异常', '2019-08-19 10:22:19');
INSERT INTO `access_log` VALUES (68962, '65.45.15661813451149447', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:25', 8, 0, '', '2019-08-19 10:22:25');
INSERT INTO `access_log` VALUES (68963, '65.54.15661813451289337', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:25', 8, 0, '', '2019-08-19 10:22:25');
INSERT INTO `access_log` VALUES (68964, '65.49.15661813451289441', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:25', 8, 2001001000, '服务端发生异常', '2019-08-19 10:22:25');
INSERT INTO `access_log` VALUES (68965, '65.3607.15661813554861223', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:35', 9, 0, '', '2019-08-19 10:22:35');
INSERT INTO `access_log` VALUES (68966, '65.52.15661813554919481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:35', 10, 2001001000, '服务端发生异常', '2019-08-19 10:22:36');
INSERT INTO `access_log` VALUES (68967, '65.53.15661813554929399', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:35', 8, 0, '', '2019-08-19 10:22:36');
INSERT INTO `access_log` VALUES (68968, '65.47.15661813626319389', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:43', 9, 0, '', '2019-08-19 10:22:43');
INSERT INTO `access_log` VALUES (68969, '65.46.15661813626319481', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:43', 10, 0, '', '2019-08-19 10:22:43');
INSERT INTO `access_log` VALUES (68970, '65.50.15661813626319443', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:22:43', 11, 2001001000, '服务端发生异常', '2019-08-19 10:22:43');
INSERT INTO `access_log` VALUES (68971, '65.50.15661814905859445', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:24:51', 10, 0, '', '2019-08-19 10:24:51');
INSERT INTO `access_log` VALUES (68972, '65.47.15661814905679391', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:24:51', 360, 0, '', '2019-08-19 10:24:51');
INSERT INTO `access_log` VALUES (68973, '65.54.15661814905859341', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.77.216.173', '2019-08-19 10:24:51', 342, 2001001000, '服务端发生异常', '2019-08-19 10:24:51');
INSERT INTO `access_log` VALUES (68974, '59.72.15661817955696393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.3.148', '2019-08-19 10:29:56', 3, 0, '', '2019-08-19 10:29:56');
INSERT INTO `access_log` VALUES (68975, '59.74.15661817955846409', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.3.148', '2019-08-19 10:29:56', 21, 2001001000, '服务端发生异常', '2019-08-19 10:29:56');
INSERT INTO `access_log` VALUES (68976, '65.49.15661818045289449', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.53.174.242', '2019-08-19 10:30:05', 0, 1002001015, '账号未登陆', '2019-08-19 10:30:05');
INSERT INTO `access_log` VALUES (68977, '65.3607.15661818045331231', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.53.174.242', '2019-08-19 10:30:05', 0, 1002001015, '账号未登陆', '2019-08-19 10:30:05');
INSERT INTO `access_log` VALUES (68978, '65.53.15661818045429407', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.53.174.242', '2019-08-19 10:30:05', 0, 1002001015, '账号未登陆', '2019-08-19 10:30:05');
INSERT INTO `access_log` VALUES (68979, '65.52.15661818053589489', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.3.148', '2019-08-19 10:30:05', 1, 1002001015, '账号未登陆', '2019-08-19 10:30:05');
INSERT INTO `access_log` VALUES (68980, '65.51.15661818055439509', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.3.148', '2019-08-19 10:30:06', 0, 1002001015, '账号未登陆', '2019-08-19 10:30:06');
INSERT INTO `access_log` VALUES (68981, '65.46.15661818061899489', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.3.148', '2019-08-19 10:30:06', 1, 1002001015, '账号未登陆', '2019-08-19 10:30:06');
INSERT INTO `access_log` VALUES (68982, '65.54.15661818175399347', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.53.174.242', '2019-08-19 10:30:18', 75, 0, '', '2019-08-19 10:30:18');
INSERT INTO `access_log` VALUES (68983, '65.47.15661818184729397', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.53.174.242', '2019-08-19 10:30:18', 8, 0, '', '2019-08-19 10:30:18');
INSERT INTO `access_log` VALUES (68984, '65.45.15661818184779457', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.53.174.242', '2019-08-19 10:30:18', 9, 2001001000, '服务端发生异常', '2019-08-19 10:30:18');
INSERT INTO `access_log` VALUES (68985, '65.3607.15661818184821233', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '59.53.174.242', '2019-08-19 10:30:18', 14, 0, '', '2019-08-19 10:30:18');
INSERT INTO `access_log` VALUES (68986, '65.52.15661818399199491', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.3.148', '2019-08-19 10:30:40', 83, 0, '', '2019-08-19 10:30:40');
INSERT INTO `access_log` VALUES (68987, '65.51.15661818404989511', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.3.148', '2019-08-19 10:30:40', 9, 0, '', '2019-08-19 10:30:41');
INSERT INTO `access_log` VALUES (68988, '65.46.15661818405019491', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.3.148', '2019-08-19 10:30:41', 10, 2001001000, '服务端发生异常', '2019-08-19 10:30:41');
INSERT INTO `access_log` VALUES (68989, '65.50.15661818405039453', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '223.104.3.148', '2019-08-19 10:30:41', 9, 0, '', '2019-08-19 10:30:41');
INSERT INTO `access_log` VALUES (68990, '59.77.15661824549436389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.57.110.210', '2019-08-19 10:40:55', 4, 0, '', '2019-08-19 10:40:55');
INSERT INTO `access_log` VALUES (68991, '59.79.15661824549466405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.57.110.210', '2019-08-19 10:40:55', 23, 2001001000, '服务端发生异常', '2019-08-19 10:40:55');
INSERT INTO `access_log` VALUES (68992, '64.79.15661824649476763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.57.110.210', '2019-08-19 10:41:05', 12, 0, '', '2019-08-19 10:41:05');
INSERT INTO `access_log` VALUES (68993, '64.83.15661824650546759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.57.110.210', '2019-08-19 10:41:05', 3, 0, '', '2019-08-19 10:41:05');
INSERT INTO `access_log` VALUES (68994, '64.82.15661824730996777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.57.110.210', '2019-08-19 10:41:13', 2, 0, '', '2019-08-19 10:41:13');
INSERT INTO `access_log` VALUES (68995, '64.77.15661824732186755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.57.110.210', '2019-08-19 10:41:13', 3, 0, '', '2019-08-19 10:41:13');
INSERT INTO `access_log` VALUES (68996, '59.74.15661824823986419', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.57.110.210', '2019-08-19 10:41:22', 2, 0, '', '2019-08-19 10:41:22');
INSERT INTO `access_log` VALUES (68997, '59.72.15661824823986403', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.57.110.210', '2019-08-19 10:41:22', 12, 2001001000, '服务端发生异常', '2019-08-19 10:41:22');
INSERT INTO `access_log` VALUES (68998, '65.53.15661835680589433', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 10:59:28', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 10:59:28');
INSERT INTO `access_log` VALUES (68999, '65.52.15661835780799515', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 10:59:38', 77, 0, '', '2019-08-19 10:59:38');
INSERT INTO `access_log` VALUES (69000, '65.46.15661835784469515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 10:59:38', 10, 0, '', '2019-08-19 10:59:38');
INSERT INTO `access_log` VALUES (69001, '65.51.15661835784499535', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 10:59:38', 10, 2001001000, '服务端发生异常', '2019-08-19 10:59:38');
INSERT INTO `access_log` VALUES (69002, '65.50.15661835784549477', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.17.229.193', '2019-08-19 10:59:38', 10, 0, '', '2019-08-19 10:59:38');
INSERT INTO `access_log` VALUES (69003, '59.80.15661836885686393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:01:29', 3, 0, '', '2019-08-19 11:01:29');
INSERT INTO `access_log` VALUES (69004, '59.75.15661836885686427', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:01:29', 31, 2001001000, '服务端发生异常', '2019-08-19 11:01:29');
INSERT INTO `access_log` VALUES (69005, '64.81.15661836913406781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:01:31', 3, 0, '', '2019-08-19 11:01:31');
INSERT INTO `access_log` VALUES (69006, '64.76.15661836914496785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:01:31', 2, 0, '', '2019-08-19 11:01:31');
INSERT INTO `access_log` VALUES (69007, '64.80.15661836924446785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:01:32', 2, 0, '', '2019-08-19 11:01:32');
INSERT INTO `access_log` VALUES (69008, '64.85.15661836929966813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:01:33', 2, 0, '', '2019-08-19 11:01:33');
INSERT INTO `access_log` VALUES (69009, '64.79.15661836937566781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:01:34', 2, 0, '', '2019-08-19 11:01:34');
INSERT INTO `access_log` VALUES (69010, '59.73.15661836951956423', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:01:35', 3, 0, '', '2019-08-19 11:01:35');
INSERT INTO `access_log` VALUES (69011, '59.77.15661836951996407', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:01:35', 16, 2001001000, '服务端发生异常', '2019-08-19 11:01:35');
INSERT INTO `access_log` VALUES (69012, '65.47.15661837310279425', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:02:11', 1, 1002001015, '账号未登陆', '2019-08-19 11:02:11');
INSERT INTO `access_log` VALUES (69013, '65.45.15661837310279485', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:02:11', 1, 1002001015, '账号未登陆', '2019-08-19 11:02:11');
INSERT INTO `access_log` VALUES (69014, '65.3607.15661837310281261', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:02:11', 0, 1002001015, '账号未登陆', '2019-08-19 11:02:11');
INSERT INTO `access_log` VALUES (69015, '65.53.15661837473809437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:02:27', 96, 0, '', '2019-08-19 11:02:27');
INSERT INTO `access_log` VALUES (69016, '65.51.15661837476939539', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:02:28', 10, 0, '', '2019-08-19 11:02:28');
INSERT INTO `access_log` VALUES (69017, '65.50.15661837476929481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:02:28', 11, 2001001000, '服务端发生异常', '2019-08-19 11:02:28');
INSERT INTO `access_log` VALUES (69018, '65.52.15661837476929519', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-19 11:02:28', 13, 0, '', '2019-08-19 11:02:28');
INSERT INTO `access_log` VALUES (69019, '59.79.15661867024826463', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3739.400', '117.30.118.67', '2019-08-19 11:51:42', 10, 0, '', '2019-08-19 11:51:42');
INSERT INTO `access_log` VALUES (69020, '59.76.15661867024846449', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3739.400', '117.30.118.67', '2019-08-19 11:51:42', 21, 2001001000, '服务端发生异常', '2019-08-19 11:51:43');
INSERT INTO `access_log` VALUES (69021, '64.84.15661867049406821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3739.400', '117.30.118.67', '2019-08-19 11:51:45', 11, 0, '', '2019-08-19 11:51:45');
INSERT INTO `access_log` VALUES (69022, '64.82.15661867050396835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3739.400', '117.30.118.67', '2019-08-19 11:51:45', 3, 0, '', '2019-08-19 11:51:45');
INSERT INTO `access_log` VALUES (69023, '65.51.15661948276339689', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '49.69.202.131', '2019-08-19 14:07:08', 0, 1002001015, '账号未登陆', '2019-08-19 14:07:08');
INSERT INTO `access_log` VALUES (69024, '65.52.15661948276369669', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '49.69.202.131', '2019-08-19 14:07:08', 1, 1002001015, '账号未登陆', '2019-08-19 14:07:08');
INSERT INTO `access_log` VALUES (69025, '65.53.15661948276339587', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '49.69.202.131', '2019-08-19 14:07:08', 0, 1002001015, '账号未登陆', '2019-08-19 14:07:08');
INSERT INTO `access_log` VALUES (69026, '65.50.15661948338439629', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '49.69.202.131', '2019-08-19 14:07:14', 19, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 14:07:14');
INSERT INTO `access_log` VALUES (69027, '65.54.15661948371499525', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '49.69.202.131', '2019-08-19 14:07:17', 97, 0, '', '2019-08-19 14:07:17');
INSERT INTO `access_log` VALUES (69028, '65.3607.15661948374191413', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '49.69.202.131', '2019-08-19 14:07:17', 16, 0, '', '2019-08-19 14:07:17');
INSERT INTO `access_log` VALUES (69029, '65.47.15661948374249575', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '49.69.202.131', '2019-08-19 14:07:17', 14, 2001001000, '服务端发生异常', '2019-08-19 14:07:17');
INSERT INTO `access_log` VALUES (69030, '65.45.15661948374279635', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '49.69.202.131', '2019-08-19 14:07:17', 11, 0, '', '2019-08-19 14:07:17');
INSERT INTO `access_log` VALUES (69031, '65.49.15661948432949631', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '49.69.202.131', '2019-08-19 14:07:23', 11, 0, '', '2019-08-19 14:07:23');
INSERT INTO `access_log` VALUES (69032, '65.53.15661948432979589', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '49.69.202.131', '2019-08-19 14:07:23', 10, 2001001000, '服务端发生异常', '2019-08-19 14:07:23');
INSERT INTO `access_log` VALUES (69033, '65.51.15661948432989691', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '49.69.202.131', '2019-08-19 14:07:23', 10, 0, '', '2019-08-19 14:07:23');
INSERT INTO `access_log` VALUES (69034, '65.49.15661984042969679', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.81.122.16', '2019-08-19 15:06:44', 1, 1002001015, '账号未登陆', '2019-08-19 15:06:44');
INSERT INTO `access_log` VALUES (69035, '65.51.15661984042969739', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.81.122.16', '2019-08-19 15:06:44', 0, 1002001015, '账号未登陆', '2019-08-19 15:06:44');
INSERT INTO `access_log` VALUES (69036, '65.52.15661984042989719', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.81.122.16', '2019-08-19 15:06:44', 0, 1002001015, '账号未登陆', '2019-08-19 15:06:44');
INSERT INTO `access_log` VALUES (69037, '65.46.15661984073169717', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.81.122.16', '2019-08-19 15:06:47', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 15:06:47');
INSERT INTO `access_log` VALUES (69038, '65.47.15661984545169625', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.81.122.16', '2019-08-19 15:07:35', 84, 0, '', '2019-08-19 15:07:35');
INSERT INTO `access_log` VALUES (69039, '65.49.15661984549809681', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.81.122.16', '2019-08-19 15:07:35', 10, 0, '', '2019-08-19 15:07:35');
INSERT INTO `access_log` VALUES (69040, '65.53.15661984549799639', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.81.122.16', '2019-08-19 15:07:35', 11, 0, '', '2019-08-19 15:07:35');
INSERT INTO `access_log` VALUES (69041, '65.3607.15661984549781463', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '42.81.122.16', '2019-08-19 15:07:35', 13, 2001001000, '服务端发生异常', '2019-08-19 15:07:35');
INSERT INTO `access_log` VALUES (69042, '59.73.15661996898846637', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.104.31', '2019-08-19 15:28:10', 11, 0, '', '2019-08-19 15:28:10');
INSERT INTO `access_log` VALUES (69043, '59.77.15661996899056621', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.104.31', '2019-08-19 15:28:10', 27, 2001001000, '服务端发生异常', '2019-08-19 15:28:10');
INSERT INTO `access_log` VALUES (69044, '64.79.15661996926706995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.104.31', '2019-08-19 15:28:13', 13, 0, '', '2019-08-19 15:28:13');
INSERT INTO `access_log` VALUES (69045, '64.83.15661996928506991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.104.31', '2019-08-19 15:28:13', 3, 0, '', '2019-08-19 15:28:13');
INSERT INTO `access_log` VALUES (69046, '64.84.15661996937506995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.104.31', '2019-08-19 15:28:14', 2, 0, '', '2019-08-19 15:28:14');
INSERT INTO `access_log` VALUES (69047, '64.82.15661996943307009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.104.31', '2019-08-19 15:28:14', 2, 0, '', '2019-08-19 15:28:14');
INSERT INTO `access_log` VALUES (69048, '59.79.15661996951496637', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.104.31', '2019-08-19 15:28:15', 4, 0, '', '2019-08-19 15:28:15');
INSERT INTO `access_log` VALUES (69049, '59.76.15661996951536623', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '117.136.104.31', '2019-08-19 15:28:15', 18, 2001001000, '服务端发生异常', '2019-08-19 15:28:15');
INSERT INTO `access_log` VALUES (69050, '59.72.15662013582186657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/54.0.2200.1839 Mobile Safari/537.36; Bytespider', '111.225.148.28', '2019-08-19 15:55:58', 4, 0, '', '2019-08-19 15:55:58');
INSERT INTO `access_log` VALUES (69051, '59.74.15662013582206673', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/54.0.2200.1839 Mobile Safari/537.36; Bytespider', '111.225.148.28', '2019-08-19 15:55:58', 16, 2001001000, '服务端发生异常', '2019-08-19 15:55:58');
INSERT INTO `access_log` VALUES (69052, '65.54.15662036043999645', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:33:24', 0, 1002001015, '账号未登陆', '2019-08-19 16:33:24');
INSERT INTO `access_log` VALUES (69053, '65.45.15662036044009755', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:33:24', 1, 1002001015, '账号未登陆', '2019-08-19 16:33:24');
INSERT INTO `access_log` VALUES (69054, '65.47.15662036044159695', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:33:24', 0, 1002001015, '账号未登陆', '2019-08-19 16:33:24');
INSERT INTO `access_log` VALUES (69055, '65.3607.15662036072881533', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:33:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 16:33:27');
INSERT INTO `access_log` VALUES (69056, '65.53.15662036107199709', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:33:31', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 16:33:31');
INSERT INTO `access_log` VALUES (69057, '65.49.15662036113109751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:33:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 16:33:31');
INSERT INTO `access_log` VALUES (69058, '65.51.15662036116749811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:33:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 16:33:32');
INSERT INTO `access_log` VALUES (69059, '65.52.15662036119799791', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:33:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 16:33:32');
INSERT INTO `access_log` VALUES (69060, '65.50.15662036264899751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:33:46', 61, 0, '', '2019-08-19 16:33:47');
INSERT INTO `access_log` VALUES (69061, '65.45.15662036269499757', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:33:47', 12, 0, '', '2019-08-19 16:33:47');
INSERT INTO `access_log` VALUES (69062, '65.47.15662036269559697', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:33:47', 10, 2001001000, '服务端发生异常', '2019-08-19 16:33:47');
INSERT INTO `access_log` VALUES (69063, '65.54.15662036269639647', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:33:47', 9, 0, '', '2019-08-19 16:33:47');
INSERT INTO `access_log` VALUES (69064, '65.51.15662036663559813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:34:26', 11, 0, '', '2019-08-19 16:34:26');
INSERT INTO `access_log` VALUES (69065, '65.52.15662036663679793', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:34:26', 11, 2001001000, '服务端发生异常', '2019-08-19 16:34:26');
INSERT INTO `access_log` VALUES (69066, '65.46.15662036663729791', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:34:26', 8, 0, '', '2019-08-19 16:34:26');
INSERT INTO `access_log` VALUES (69067, '65.50.15662036719119753', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:34:32', 10, 0, '', '2019-08-19 16:34:32');
INSERT INTO `access_log` VALUES (69068, '65.45.15662036719219759', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:34:32', 9, 2001001000, '服务端发生异常', '2019-08-19 16:34:32');
INSERT INTO `access_log` VALUES (69069, '65.47.15662036719279699', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:34:32', 8, 0, '', '2019-08-19 16:34:32');
INSERT INTO `access_log` VALUES (69070, '59.79.15662036798996691', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.144.90', '2019-08-19 16:34:40', 10, 0, '', '2019-08-19 16:34:40');
INSERT INTO `access_log` VALUES (69071, '59.76.15662036799096677', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.144.90', '2019-08-19 16:34:40', 12, 2001001000, '服务端发生异常', '2019-08-19 16:34:40');
INSERT INTO `access_log` VALUES (69072, '59.78.15662036801066697', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.144.90', '2019-08-19 16:34:40', 3, 0, '', '2019-08-19 16:34:40');
INSERT INTO `access_log` VALUES (69073, '59.72.15662036801136689', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.135.144.90', '2019-08-19 16:34:40', 12, 2001001000, '服务端发生异常', '2019-08-19 16:34:40');
INSERT INTO `access_log` VALUES (69074, '65.3607.15662036838691537', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:34:44', 10, 0, '', '2019-08-19 16:34:44');
INSERT INTO `access_log` VALUES (69075, '65.53.15662036838739713', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:34:44', 9, 2001001000, '服务端发生异常', '2019-08-19 16:34:44');
INSERT INTO `access_log` VALUES (69076, '65.49.15662036838809755', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:34:44', 8, 0, '', '2019-08-19 16:34:44');
INSERT INTO `access_log` VALUES (69077, '65.52.15662036877239795', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:34:48', 8, 0, '', '2019-08-19 16:34:48');
INSERT INTO `access_log` VALUES (69078, '65.51.15662036877389815', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:34:48', 10, 2001001000, '服务端发生异常', '2019-08-19 16:34:48');
INSERT INTO `access_log` VALUES (69079, '65.46.15662036877419793', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3679.0 Safari/537.36', '123.118.230.165', '2019-08-19 16:34:48', 9, 0, '', '2019-08-19 16:34:48');
INSERT INTO `access_log` VALUES (69080, '65.51.15662072910439863', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.89.64.240', '2019-08-19 17:34:51', 0, 1002001015, '账号未登陆', '2019-08-19 17:34:51');
INSERT INTO `access_log` VALUES (69081, '65.52.15662072910429845', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.89.64.240', '2019-08-19 17:34:51', 0, 1002001015, '账号未登陆', '2019-08-19 17:34:51');
INSERT INTO `access_log` VALUES (69082, '65.50.15662072910449803', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.89.64.240', '2019-08-19 17:34:51', 0, 1002001015, '账号未登陆', '2019-08-19 17:34:51');
INSERT INTO `access_log` VALUES (69083, '65.45.15662072969889811', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.89.64.240', '2019-08-19 17:34:57', 99, 0, '', '2019-08-19 17:34:57');
INSERT INTO `access_log` VALUES (69084, '65.3607.15662072976301587', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.89.64.240', '2019-08-19 17:34:58', 15, 0, '', '2019-08-19 17:34:58');
INSERT INTO `access_log` VALUES (69085, '65.54.15662072975909699', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.89.64.240', '2019-08-19 17:34:58', 56, 0, '', '2019-08-19 17:34:58');
INSERT INTO `access_log` VALUES (69086, '65.49.15662072976419807', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.89.64.240', '2019-08-19 17:34:58', 12, 2001001000, '服务端发生异常', '2019-08-19 17:34:58');
INSERT INTO `access_log` VALUES (69087, '65.49.15662073885249809', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.89.64.240', '2019-08-19 17:36:29', 17, 2001001000, '服务端发生异常', '2019-08-19 17:36:29');
INSERT INTO `access_log` VALUES (69088, '65.54.15662073885109701', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.89.64.240', '2019-08-19 17:36:29', 203, 0, '', '2019-08-19 17:36:29');
INSERT INTO `access_log` VALUES (69089, '65.45.15662073884849813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.89.64.240', '2019-08-19 17:36:28', 231, 0, '', '2019-08-19 17:36:29');
INSERT INTO `access_log` VALUES (69090, '65.3607.15662073934781589', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.89.64.240', '2019-08-19 17:36:33', 9, 0, '', '2019-08-19 17:36:33');
INSERT INTO `access_log` VALUES (69091, '65.53.15662073935029765', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.89.64.240', '2019-08-19 17:36:34', 10, 2001001000, '服务端发生异常', '2019-08-19 17:36:34');
INSERT INTO `access_log` VALUES (69092, '65.46.15662073935229847', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.89.64.240', '2019-08-19 17:36:34', 9, 0, '', '2019-08-19 17:36:34');
INSERT INTO `access_log` VALUES (69093, '65.49.15662078964479817', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:44:56', 1, 1002001015, '账号未登陆', '2019-08-19 17:44:56');
INSERT INTO `access_log` VALUES (69094, '65.54.15662078964509709', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:44:56', 0, 1002001015, '账号未登陆', '2019-08-19 17:44:56');
INSERT INTO `access_log` VALUES (69095, '65.45.15662078964509821', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:44:56', 0, 1002001015, '账号未登陆', '2019-08-19 17:44:56');
INSERT INTO `access_log` VALUES (69096, '65.46.15662078966489855', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:44:57', 0, 1002001015, '账号未登陆', '2019-08-19 17:44:57');
INSERT INTO `access_log` VALUES (69097, '65.3607.15662078966511597', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:44:57', 0, 1002001015, '账号未登陆', '2019-08-19 17:44:57');
INSERT INTO `access_log` VALUES (69098, '65.53.15662078966519773', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:44:57', 0, 1002001015, '账号未登陆', '2019-08-19 17:44:57');
INSERT INTO `access_log` VALUES (69099, '65.52.15662079017339857', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:45:02', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 17:45:02');
INSERT INTO `access_log` VALUES (69100, '65.50.15662079072799815', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:45:07', 112, 0, '', '2019-08-19 17:45:07');
INSERT INTO `access_log` VALUES (69101, '65.47.15662079076809763', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:45:08', 9, 0, '', '2019-08-19 17:45:08');
INSERT INTO `access_log` VALUES (69102, '65.45.15662079076819823', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:45:08', 7, 0, '', '2019-08-19 17:45:08');
INSERT INTO `access_log` VALUES (69103, '65.51.15662079076799875', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:45:08', 9, 2001001000, '服务端发生异常', '2019-08-19 17:45:08');
INSERT INTO `access_log` VALUES (69104, '65.54.15662079077259711', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:45:08', 1, 1002001015, '账号未登陆', '2019-08-19 17:45:08');
INSERT INTO `access_log` VALUES (69105, '65.49.15662079078029819', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:45:08', 0, 1002001015, '账号未登陆', '2019-08-19 17:45:08');
INSERT INTO `access_log` VALUES (69106, '65.3607.15662079078031599', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:45:08', 0, 1002001015, '账号未登陆', '2019-08-19 17:45:08');
INSERT INTO `access_log` VALUES (69107, '59.73.15662079445526749', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:45:45', 10, 0, '', '2019-08-19 17:45:45');
INSERT INTO `access_log` VALUES (69108, '59.77.15662079445536733', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:45:45', 23, 2001001000, '服务端发生异常', '2019-08-19 17:45:45');
INSERT INTO `access_log` VALUES (69109, '59.76.15662079447006735', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:45:45', 3, 0, '', '2019-08-19 17:45:45');
INSERT INTO `access_log` VALUES (69110, '59.79.15662079447436749', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.21.48.194', '2019-08-19 17:45:45', 19, 2001001000, '服务端发生异常', '2019-08-19 17:45:45');
INSERT INTO `access_log` VALUES (69111, '65.46.15662086394629867', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.24.26', '2019-08-19 17:57:19', 0, 1002001015, '账号未登陆', '2019-08-19 17:57:19');
INSERT INTO `access_log` VALUES (69112, '65.49.15662086394629829', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.24.26', '2019-08-19 17:57:19', 0, 1002001015, '账号未登陆', '2019-08-19 17:57:19');
INSERT INTO `access_log` VALUES (69113, '65.53.15662086394819785', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.24.26', '2019-08-19 17:57:19', 0, 1002001015, '账号未登陆', '2019-08-19 17:57:19');
INSERT INTO `access_log` VALUES (69114, '65.50.15662086458589827', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.24.26', '2019-08-19 17:57:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 17:57:26');
INSERT INTO `access_log` VALUES (69115, '65.47.15662086558539775', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.24.26', '2019-08-19 17:57:36', 74, 0, '', '2019-08-19 17:57:36');
INSERT INTO `access_log` VALUES (69116, '65.45.15662086561169835', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.24.26', '2019-08-19 17:57:36', 8, 0, '', '2019-08-19 17:57:36');
INSERT INTO `access_log` VALUES (69117, '65.51.15662086561189887', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.24.26', '2019-08-19 17:57:36', 9, 2001001000, '服务端发生异常', '2019-08-19 17:57:36');
INSERT INTO `access_log` VALUES (69118, '65.54.15662086561219723', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.24.26', '2019-08-19 17:57:36', 9, 0, '', '2019-08-19 17:57:36');
INSERT INTO `access_log` VALUES (69119, '65.46.15662086838339869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.24.26', '2019-08-19 17:58:04', 17, 0, '', '2019-08-19 17:58:04');
INSERT INTO `access_log` VALUES (69120, '65.52.15662086838359871', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.24.26', '2019-08-19 17:58:04', 8, 0, '', '2019-08-19 17:58:04');
INSERT INTO `access_log` VALUES (69121, '65.53.15662086838349787', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.24.26', '2019-08-19 17:58:04', 17, 2001001000, '服务端发生异常', '2019-08-19 17:58:04');
INSERT INTO `access_log` VALUES (69122, '65.54.15662091917449731', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.68.108.146', '2019-08-19 18:06:32', 0, 1002001015, '账号未登陆', '2019-08-19 18:06:32');
INSERT INTO `access_log` VALUES (69123, '65.3607.15662091917451619', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.68.108.146', '2019-08-19 18:06:32', 0, 1002001015, '账号未登陆', '2019-08-19 18:06:32');
INSERT INTO `access_log` VALUES (69124, '65.49.15662091917509839', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.68.108.146', '2019-08-19 18:06:32', 0, 1002001015, '账号未登陆', '2019-08-19 18:06:32');
INSERT INTO `access_log` VALUES (69125, '65.52.15662091974219879', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.68.108.146', '2019-08-19 18:06:37', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 18:06:37');
INSERT INTO `access_log` VALUES (69126, '65.53.15662092062479795', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.68.108.146', '2019-08-19 18:06:46', 90, 0, '', '2019-08-19 18:06:46');
INSERT INTO `access_log` VALUES (69127, '65.50.15662092065959837', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.68.108.146', '2019-08-19 18:06:47', 9, 0, '', '2019-08-19 18:06:47');
INSERT INTO `access_log` VALUES (69128, '65.47.15662092066019785', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.68.108.146', '2019-08-19 18:06:47', 10, 2001001000, '服务端发生异常', '2019-08-19 18:06:47');
INSERT INTO `access_log` VALUES (69129, '65.45.15662092066069845', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.68.108.146', '2019-08-19 18:06:47', 9, 0, '', '2019-08-19 18:06:47');
INSERT INTO `access_log` VALUES (69130, '59.80.15662157783426825', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '112.10.65.206', '2019-08-19 19:56:18', 18, 0, '', '2019-08-19 19:56:18');
INSERT INTO `access_log` VALUES (69131, '59.75.15662157783426857', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '112.10.65.206', '2019-08-19 19:56:18', 42, 2001001000, '服务端发生异常', '2019-08-19 19:56:18');
INSERT INTO `access_log` VALUES (69132, '65.52.15662185673560007', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:42:47', 0, 1002001015, '账号未登陆', '2019-08-19 20:42:47');
INSERT INTO `access_log` VALUES (69133, '65.46.15662185673570003', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:42:47', 0, 1002001015, '账号未登陆', '2019-08-19 20:42:47');
INSERT INTO `access_log` VALUES (69134, '65.50.15662185673609965', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:42:47', 0, 1002001015, '账号未登陆', '2019-08-19 20:42:47');
INSERT INTO `access_log` VALUES (69135, '65.47.15662185727069913', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:42:53', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 20:42:53');
INSERT INTO `access_log` VALUES (69136, '65.49.15662186040689969', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:43:24', 83, 0, '', '2019-08-19 20:43:24');
INSERT INTO `access_log` VALUES (69137, '65.54.15662186044249861', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:43:24', 11, 0, '', '2019-08-19 20:43:24');
INSERT INTO `access_log` VALUES (69138, '65.3607.15662186044281749', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:43:24', 10, 2001001000, '服务端发生异常', '2019-08-19 20:43:24');
INSERT INTO `access_log` VALUES (69139, '65.52.15662186044300009', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:43:24', 9, 0, '', '2019-08-19 20:43:24');
INSERT INTO `access_log` VALUES (69140, '65.50.15662186120919967', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:43:32', 14, 0, '', '2019-08-19 20:43:32');
INSERT INTO `access_log` VALUES (69141, '65.46.15662186120940005', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:43:32', 12, 2001001000, '服务端发生异常', '2019-08-19 20:43:32');
INSERT INTO `access_log` VALUES (69142, '65.47.15662186120979915', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:43:32', 13, 0, '', '2019-08-19 20:43:32');
INSERT INTO `access_log` VALUES (69143, '65.51.15662186234120023', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:43:43', 9, 0, '', '2019-08-19 20:43:43');
INSERT INTO `access_log` VALUES (69144, '65.45.15662186234199971', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:43:43', 9, 0, '', '2019-08-19 20:43:43');
INSERT INTO `access_log` VALUES (69145, '65.49.15662186234199971', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:43:43', 9, 2001001000, '服务端发生异常', '2019-08-19 20:43:43');
INSERT INTO `access_log` VALUES (69146, '65.54.15662186291719863', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:43:49', 8, 0, '', '2019-08-19 20:43:49');
INSERT INTO `access_log` VALUES (69147, '65.3607.15662186291751751', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:43:49', 9, 2001001000, '服务端发生异常', '2019-08-19 20:43:49');
INSERT INTO `access_log` VALUES (69148, '65.52.15662186291820011', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:43:49', 8, 0, '', '2019-08-19 20:43:49');
INSERT INTO `access_log` VALUES (69149, '65.47.15662186403999917', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:44:00', 9, 0, '', '2019-08-19 20:44:00');
INSERT INTO `access_log` VALUES (69150, '65.50.15662186404049969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:44:00', 10, 2001001000, '服务端发生异常', '2019-08-19 20:44:00');
INSERT INTO `access_log` VALUES (69151, '65.53.15662186404079925', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '115.238.239.183', '2019-08-19 20:44:00', 15, 0, '', '2019-08-19 20:44:00');
INSERT INTO `access_log` VALUES (69152, '59.72.15662226170196943', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.92.226.194', '2019-08-19 21:50:17', 11, 0, '', '2019-08-19 21:50:17');
INSERT INTO `access_log` VALUES (69153, '59.74.15662226170566959', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.241.251.135', '2019-08-19 21:50:17', 23, 2001001000, '服务端发生异常', '2019-08-19 21:50:17');
INSERT INTO `access_log` VALUES (69154, '64.78.15662226229927313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.92.226.194', '2019-08-19 21:50:23', 15, 0, '', '2019-08-19 21:50:23');
INSERT INTO `access_log` VALUES (69155, '64.81.15662226232177303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.92.226.194', '2019-08-19 21:50:23', 4, 0, '', '2019-08-19 21:50:23');
INSERT INTO `access_log` VALUES (69156, '64.76.15662226324317307', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.92.226.194', '2019-08-19 21:50:32', 2, 0, '', '2019-08-19 21:50:32');
INSERT INTO `access_log` VALUES (69157, '64.80.15662226325667305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.92.226.194', '2019-08-19 21:50:33', 2, 0, '', '2019-08-19 21:50:33');
INSERT INTO `access_log` VALUES (69158, '64.79.15662226380327303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.92.226.194', '2019-08-19 21:50:38', 2, 0, '', '2019-08-19 21:50:38');
INSERT INTO `access_log` VALUES (69159, '64.83.15662226382697299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.92.226.194', '2019-08-19 21:50:38', 3, 0, '', '2019-08-19 21:50:38');
INSERT INTO `access_log` VALUES (69160, '59.73.15662226400526947', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.92.226.194', '2019-08-19 21:50:40', 3, 0, '', '2019-08-19 21:50:40');
INSERT INTO `access_log` VALUES (69161, '59.71.15662226400506943', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '218.241.251.135', '2019-08-19 21:50:40', 15, 2001001000, '服务端发生异常', '2019-08-19 21:50:40');
INSERT INTO `access_log` VALUES (69162, '59.76.15662255114206971', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '101.224.180.47', '2019-08-19 22:38:31', 11, 0, '', '2019-08-19 22:38:31');
INSERT INTO `access_log` VALUES (69163, '59.79.15662255114216985', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_1) AppleWebKit/604.3.5 (KHTML, like Gecko) Version/11.0.1 Safari/604.3.5', '101.224.180.47', '2019-08-19 22:38:31', 21, 2001001000, '服务端发生异常', '2019-08-19 22:38:31');
INSERT INTO `access_log` VALUES (69164, '59.73.15662258859366991', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '115.238.239.190', '2019-08-19 22:44:46', 5, 0, '', '2019-08-19 22:44:46');
INSERT INTO `access_log` VALUES (69165, '59.71.15662258859406987', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '115.238.239.190', '2019-08-19 22:44:46', 15, 2001001000, '服务端发生异常', '2019-08-19 22:44:46');
INSERT INTO `access_log` VALUES (69166, '64.85.15662258937597379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '115.238.239.190', '2019-08-19 22:44:54', 13, 0, '', '2019-08-19 22:44:54');
INSERT INTO `access_log` VALUES (69167, '64.79.15662258940827347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '115.238.239.190', '2019-08-19 22:44:54', 3, 0, '', '2019-08-19 22:44:54');
INSERT INTO `access_log` VALUES (69168, '65.49.15662279233370097', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:18:43', 1, 1002001015, '账号未登陆', '2019-08-19 23:18:43');
INSERT INTO `access_log` VALUES (69169, '65.47.15662279233370043', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:18:43', 1, 1002001015, '账号未登陆', '2019-08-19 23:18:43');
INSERT INTO `access_log` VALUES (69170, '65.46.15662279233600133', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:18:43', 0, 1002001015, '账号未登陆', '2019-08-19 23:18:43');
INSERT INTO `access_log` VALUES (69171, '65.45.15662279260540097', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:18:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 23:18:46');
INSERT INTO `access_log` VALUES (69172, '65.3607.15662279510281879', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:19:11', 95, 0, '', '2019-08-19 23:19:11');
INSERT INTO `access_log` VALUES (69173, '65.50.15662279514760095', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:19:11', 14, 0, '', '2019-08-19 23:19:11');
INSERT INTO `access_log` VALUES (69174, '65.53.15662279514770051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:19:11', 14, 0, '', '2019-08-19 23:19:11');
INSERT INTO `access_log` VALUES (69175, '65.52.15662279514760135', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:19:11', 15, 2001001000, '服务端发生异常', '2019-08-19 23:19:11');
INSERT INTO `access_log` VALUES (69176, '65.45.15662279912860099', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:19:51', 8, 0, '', '2019-08-19 23:19:51');
INSERT INTO `access_log` VALUES (69177, '65.47.15662279912860045', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:19:51', 10, 2001001000, '服务端发生异常', '2019-08-19 23:19:51');
INSERT INTO `access_log` VALUES (69178, '65.51.15662279913060153', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:19:51', 9, 0, '', '2019-08-19 23:19:51');
INSERT INTO `access_log` VALUES (69179, '65.3607.15662280085101881', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:20:09', 94, 0, '', '2019-08-19 23:20:09');
INSERT INTO `access_log` VALUES (69180, '65.50.15662280087880097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:20:09', 8, 0, '', '2019-08-19 23:20:09');
INSERT INTO `access_log` VALUES (69181, '65.53.15662280087880053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:20:09', 9, 0, '', '2019-08-19 23:20:09');
INSERT INTO `access_log` VALUES (69182, '65.52.15662280087880137', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '221.225.59.180', '2019-08-19 23:20:09', 10, 2001001000, '服务端发生异常', '2019-08-19 23:20:09');
INSERT INTO `access_log` VALUES (69183, '65.49.15662281535730103', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.5.152.105', '2019-08-19 23:22:34', 0, 1002001015, '账号未登陆', '2019-08-19 23:22:34');
INSERT INTO `access_log` VALUES (69184, '65.46.15662281535780139', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.5.152.105', '2019-08-19 23:22:34', 0, 1002001015, '账号未登陆', '2019-08-19 23:22:34');
INSERT INTO `access_log` VALUES (69185, '65.45.15662281535940103', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.5.152.105', '2019-08-19 23:22:34', 0, 1002001015, '账号未登陆', '2019-08-19 23:22:34');
INSERT INTO `access_log` VALUES (69186, '65.52.15662282180820141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.5.152.105', '2019-08-19 23:23:38', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-19 23:23:38');
INSERT INTO `access_log` VALUES (69187, '65.45.15662282496030105', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.5.152.105', '2019-08-19 23:24:10', 83, 0, '', '2019-08-19 23:24:10');
INSERT INTO `access_log` VALUES (69188, '65.46.15662282500900141', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.5.152.105', '2019-08-19 23:24:10', 8, 0, '', '2019-08-19 23:24:10');
INSERT INTO `access_log` VALUES (69189, '65.47.15662282500940051', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.5.152.105', '2019-08-19 23:24:10', 9, 2001001000, '服务端发生异常', '2019-08-19 23:24:10');
INSERT INTO `access_log` VALUES (69190, '65.51.15662282501170159', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.5.152.105', '2019-08-19 23:24:10', 9, 0, '', '2019-08-19 23:24:10');
INSERT INTO `access_log` VALUES (69191, '59.80.15662294198157009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.196.244.153', '2019-08-19 23:43:40', 10, 0, '', '2019-08-19 23:43:40');
INSERT INTO `access_log` VALUES (69192, '59.75.15662294198357041', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.196.244.153', '2019-08-19 23:43:40', 13, 2001001000, '服务端发生异常', '2019-08-19 23:43:40');
INSERT INTO `access_log` VALUES (69193, '66.52.15662296485624581', 0, 2, 'user-application', '/user-api/admins/user/page', 'pageSize=10&nickname=小王&pageNo=1&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '59.174.89.101', '2019-08-19 23:47:29', 0, 1002001015, '账号未登陆', '2019-08-19 23:47:29');
INSERT INTO `access_log` VALUES (69194, '59.77.15662312533677047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '42.236.10.75', '2019-08-20 00:14:13', 10, 0, '', '2019-08-20 00:14:13');
INSERT INTO `access_log` VALUES (69195, '59.76.15662312533687049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '42.236.10.84', '2019-08-20 00:14:13', 22, 2001001000, '服务端发生异常', '2019-08-20 00:14:13');
INSERT INTO `access_log` VALUES (69196, '65.50.15662646951410589', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.22.20.72', '2019-08-20 09:31:35', 1, 1002001015, '账号未登陆', '2019-08-20 09:31:35');
INSERT INTO `access_log` VALUES (69197, '65.3607.15662646951422381', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.22.20.72', '2019-08-20 09:31:35', 0, 1002001015, '账号未登陆', '2019-08-20 09:31:35');
INSERT INTO `access_log` VALUES (69198, '65.47.15662646951680541', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.22.20.72', '2019-08-20 09:31:35', 1, 1002001015, '账号未登陆', '2019-08-20 09:31:35');
INSERT INTO `access_log` VALUES (69199, '65.51.15662647075110651', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.22.20.72', '2019-08-20 09:31:48', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 09:31:48');
INSERT INTO `access_log` VALUES (69200, '65.52.15662647249960635', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.22.20.72', '2019-08-20 09:32:05', 77, 0, '', '2019-08-20 09:32:05');
INSERT INTO `access_log` VALUES (69201, '65.49.15662647253890597', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.22.20.72', '2019-08-20 09:32:05', 17, 0, '', '2019-08-20 09:32:05');
INSERT INTO `access_log` VALUES (69202, '65.54.15662647253900489', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.22.20.72', '2019-08-20 09:32:05', 19, 2001001000, '服务端发生异常', '2019-08-20 09:32:05');
INSERT INTO `access_log` VALUES (69203, '65.45.15662647253930599', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.22.20.72', '2019-08-20 09:32:05', 17, 0, '', '2019-08-20 09:32:05');
INSERT INTO `access_log` VALUES (69204, '59.71.15662665924577531', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.154.199.114', '2019-08-20 10:03:12', 11, 0, '', '2019-08-20 10:03:12');
INSERT INTO `access_log` VALUES (69205, '59.77.15662665924577519', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.154.199.114', '2019-08-20 10:03:12', 26, 2001001000, '服务端发生异常', '2019-08-20 10:03:12');
INSERT INTO `access_log` VALUES (69206, '59.79.15662666057567533', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.154.199.114', '2019-08-20 10:03:26', 3, 0, '', '2019-08-20 10:03:26');
INSERT INTO `access_log` VALUES (69207, '59.78.15662666060587541', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.154.199.114', '2019-08-20 10:03:26', 15, 2001001000, '服务端发生异常', '2019-08-20 10:03:26');
INSERT INTO `access_log` VALUES (69208, '59.72.15662666165027533', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:37', 3, 0, '', '2019-08-20 10:03:37');
INSERT INTO `access_log` VALUES (69209, '59.75.15662666178617539', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:38', 17, 2001001000, '服务端发生异常', '2019-08-20 10:03:38');
INSERT INTO `access_log` VALUES (69210, '64.79.15662666204147889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:40', 12, 0, '', '2019-08-20 10:03:40');
INSERT INTO `access_log` VALUES (69211, '64.80.15662666206027891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:41', 3, 0, '', '2019-08-20 10:03:41');
INSERT INTO `access_log` VALUES (69212, '64.84.15662666233637891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:43', 2, 0, '', '2019-08-20 10:03:43');
INSERT INTO `access_log` VALUES (69213, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:43', 5, 0, '', '2019-08-20 10:03:43');
INSERT INTO `access_log` VALUES (69214, '64.85.15662666257327925', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:46', 7, 0, '', '2019-08-20 10:03:46');
INSERT INTO `access_log` VALUES (69215, '64.78.15662666272307905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:47', 2, 0, '', '2019-08-20 10:03:47');
INSERT INTO `access_log` VALUES (69216, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:47', 6, 0, '', '2019-08-20 10:03:47');
INSERT INTO `access_log` VALUES (69217, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:50', 5, 0, '', '2019-08-20 10:03:50');
INSERT INTO `access_log` VALUES (69218, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:50', 4, 0, '', '2019-08-20 10:03:50');
INSERT INTO `access_log` VALUES (69219, '64.81.15662666310237891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:51', 2, 0, '', '2019-08-20 10:03:51');
INSERT INTO `access_log` VALUES (69220, '64.82.15662666313337905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:51', 2, 0, '', '2019-08-20 10:03:51');
INSERT INTO `access_log` VALUES (69221, '64.76.15662666329147899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:53', 2, 0, '', '2019-08-20 10:03:53');
INSERT INTO `access_log` VALUES (69222, '64.83.15662666349537891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:55', 2, 0, '', '2019-08-20 10:03:55');
INSERT INTO `access_log` VALUES (69223, '59.73.15662666358007537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:56', 3, 0, '', '2019-08-20 10:03:56');
INSERT INTO `access_log` VALUES (69224, '59.77.15662666358007521', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:56', 16, 2001001000, '服务端发生异常', '2019-08-20 10:03:56');
INSERT INTO `access_log` VALUES (69225, '64.79.15662666389827891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:59', 2, 0, '', '2019-08-20 10:03:59');
INSERT INTO `access_log` VALUES (69226, '64.80.15662666391467893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:03:59', 3, 0, '', '2019-08-20 10:03:59');
INSERT INTO `access_log` VALUES (69227, '59.71.15662666413257533', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:04:01', 2, 0, '', '2019-08-20 10:04:01');
INSERT INTO `access_log` VALUES (69228, '59.76.15662666413257523', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:04:01', 14, 2001001000, '服务端发生异常', '2019-08-20 10:04:01');
INSERT INTO `access_log` VALUES (69229, '64.84.15662666430627893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:04:03', 3, 0, '', '2019-08-20 10:04:03');
INSERT INTO `access_log` VALUES (69230, '64.85.15662666431727927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:04:03', 2, 0, '', '2019-08-20 10:04:03');
INSERT INTO `access_log` VALUES (69231, '64.78.15662666442797907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:04:04', 1, 0, '', '2019-08-20 10:04:04');
INSERT INTO `access_log` VALUES (69232, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:04:04', 4, 0, '', '2019-08-20 10:04:04');
INSERT INTO `access_log` VALUES (69233, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:04:05', 5, 0, '', '2019-08-20 10:04:05');
INSERT INTO `access_log` VALUES (69234, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:04:06', 5, 0, '', '2019-08-20 10:04:06');
INSERT INTO `access_log` VALUES (69235, '64.81.15662666520577893', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:04:12', 5, 0, '', '2019-08-20 10:04:12');
INSERT INTO `access_log` VALUES (69236, '64.82.15662666533897907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:04:13', 2, 0, '', '2019-08-20 10:04:13');
INSERT INTO `access_log` VALUES (69237, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:04:13', 6, 0, '', '2019-08-20 10:04:13');
INSERT INTO `access_log` VALUES (69238, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.154.199.114', '2019-08-20 10:04:16', 6, 0, '', '2019-08-20 10:04:16');
INSERT INTO `access_log` VALUES (69239, '59.72.15662668266577537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.154.199.114', '2019-08-20 10:07:07', 2, 0, '', '2019-08-20 10:07:07');
INSERT INTO `access_log` VALUES (69240, '59.75.15662668266637543', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.154.199.114', '2019-08-20 10:07:07', 13, 2001001000, '服务端发生异常', '2019-08-20 10:07:07');
INSERT INTO `access_log` VALUES (69241, '65.50.15662671735980623', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.22.20.72', '2019-08-20 10:12:54', 18, 0, '', '2019-08-20 10:12:54');
INSERT INTO `access_log` VALUES (69242, '65.53.15662671735980577', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.22.20.72', '2019-08-20 10:12:54', 19, 0, '', '2019-08-20 10:12:54');
INSERT INTO `access_log` VALUES (69243, '65.3607.15662671735982417', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '117.22.20.72', '2019-08-20 10:12:54', 20, 2001001000, '服务端发生异常', '2019-08-20 10:12:54');
INSERT INTO `access_log` VALUES (69244, '59.79.15662716856097603', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.207.25.99', '2019-08-20 11:28:06', 23, 2001001000, '服务端发生异常', '2019-08-20 11:28:06');
INSERT INTO `access_log` VALUES (69245, '59.71.15662716856087601', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.207.25.99', '2019-08-20 11:28:06', 152, 0, '', '2019-08-20 11:28:06');
INSERT INTO `access_log` VALUES (69246, '59.79.15662731628127623', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 11:52:43', 3, 0, '', '2019-08-20 11:52:43');
INSERT INTO `access_log` VALUES (69247, '59.71.15662731628217621', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 11:52:43', 37, 2001001000, '服务端发生异常', '2019-08-20 11:52:43');
INSERT INTO `access_log` VALUES (69248, '65.51.15662731684560765', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 11:52:48', 0, 1002001015, '账号未登陆', '2019-08-20 11:52:48');
INSERT INTO `access_log` VALUES (69249, '65.45.15662731684560715', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 11:52:48', 0, 1002001015, '账号未登陆', '2019-08-20 11:52:48');
INSERT INTO `access_log` VALUES (69250, '65.54.15662731684570601', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 11:52:48', 0, 1002001015, '账号未登陆', '2019-08-20 11:52:48');
INSERT INTO `access_log` VALUES (69251, '65.49.15662731746740713', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 11:52:55', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 11:52:55');
INSERT INTO `access_log` VALUES (69252, '65.47.15662731795430657', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 11:53:00', 107, 0, '', '2019-08-20 11:53:00');
INSERT INTO `access_log` VALUES (69253, '65.3607.15662731799322499', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 11:53:00', 12, 0, '', '2019-08-20 11:53:00');
INSERT INTO `access_log` VALUES (69254, '65.53.15662731799350659', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 11:53:00', 9, 2001001000, '服务端发生异常', '2019-08-20 11:53:00');
INSERT INTO `access_log` VALUES (69255, '65.50.15662731799380705', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 11:53:00', 9, 0, '', '2019-08-20 11:53:00');
INSERT INTO `access_log` VALUES (69256, '65.45.15662731943970717', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 11:53:14', 13, 0, '', '2019-08-20 11:53:14');
INSERT INTO `access_log` VALUES (69257, '65.54.15662731943990603', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 11:53:14', 13, 2001001000, '服务端发生异常', '2019-08-20 11:53:14');
INSERT INTO `access_log` VALUES (69258, '65.51.15662731944040767', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 11:53:14', 180, 0, '', '2019-08-20 11:53:15');
INSERT INTO `access_log` VALUES (69259, '65.50.15662741654010719', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 12:09:25', 11, 0, '', '2019-08-20 12:09:25');
INSERT INTO `access_log` VALUES (69260, '65.46.15662741654020763', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 12:09:25', 12, 2001001000, '服务端发生异常', '2019-08-20 12:09:25');
INSERT INTO `access_log` VALUES (69261, '65.45.15662741654050731', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-20 12:09:25', 18, 0, '', '2019-08-20 12:09:25');
INSERT INTO `access_log` VALUES (69262, '65.54.15662756364180637', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.230.11.12', '2019-08-20 12:33:56', 0, 1002001015, '账号未登陆', '2019-08-20 12:33:56');
INSERT INTO `access_log` VALUES (69263, '65.50.15662756364170739', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.230.11.12', '2019-08-20 12:33:56', 0, 1002001015, '账号未登陆', '2019-08-20 12:33:56');
INSERT INTO `access_log` VALUES (69264, '65.45.15662756364170751', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.230.11.12', '2019-08-20 12:33:56', 0, 1002001015, '账号未登陆', '2019-08-20 12:33:56');
INSERT INTO `access_log` VALUES (69265, '65.51.15662756382980801', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.230.11.12', '2019-08-20 12:33:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 12:33:58');
INSERT INTO `access_log` VALUES (69266, '65.52.15662756423430785', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.230.11.12', '2019-08-20 12:34:02', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 12:34:02');
INSERT INTO `access_log` VALUES (69267, '65.47.15662756550070693', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.230.11.12', '2019-08-20 12:34:15', 321, 0, '', '2019-08-20 12:34:15');
INSERT INTO `access_log` VALUES (69268, '65.3607.15662756556782535', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.230.11.12', '2019-08-20 12:34:16', 10, 0, '', '2019-08-20 12:34:16');
INSERT INTO `access_log` VALUES (69269, '65.46.15662756556850785', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.230.11.12', '2019-08-20 12:34:16', 8, 0, '', '2019-08-20 12:34:16');
INSERT INTO `access_log` VALUES (69270, '65.53.15662756556840695', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '183.230.11.12', '2019-08-20 12:34:16', 9, 2001001000, '服务端发生异常', '2019-08-20 12:34:16');
INSERT INTO `access_log` VALUES (69271, '59.72.15662767902227671', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.144.40.142', '2019-08-20 12:53:10', 10, 0, '', '2019-08-20 12:53:10');
INSERT INTO `access_log` VALUES (69272, '59.75.15662767902397677', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.144.40.142', '2019-08-20 12:53:10', 13, 2001001000, '服务端发生异常', '2019-08-20 12:53:10');
INSERT INTO `access_log` VALUES (69273, '59.73.15662767976117675', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:53:18', 3, 0, '', '2019-08-20 12:53:18');
INSERT INTO `access_log` VALUES (69274, '59.80.15662767976097645', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:53:18', 14, 2001001000, '服务端发生异常', '2019-08-20 12:53:18');
INSERT INTO `access_log` VALUES (69275, '64.81.15662768169418029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:53:37', 11, 0, '', '2019-08-20 12:53:37');
INSERT INTO `access_log` VALUES (69276, '64.82.15662768171868043', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:53:37', 3, 0, '', '2019-08-20 12:53:37');
INSERT INTO `access_log` VALUES (69277, '64.76.15662768187428037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:53:39', 2, 0, '', '2019-08-20 12:53:39');
INSERT INTO `access_log` VALUES (69278, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:53:39', 14, 0, '', '2019-08-20 12:53:39');
INSERT INTO `access_log` VALUES (69279, '64.83.15662768201638029', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:53:40', 15, 0, '', '2019-08-20 12:53:40');
INSERT INTO `access_log` VALUES (69280, '66.55.15662768343285193', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18555556666&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:53:54', 15, 1001003000, '验证码不存在', '2019-08-20 12:53:54');
INSERT INTO `access_log` VALUES (69281, '66.51.15662768365595235', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18555556666', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:53:57', 85, 0, '', '2019-08-20 12:53:57');
INSERT INTO `access_log` VALUES (69282, '66.52.15662768386405211', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18555556666&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:53:59', 381, 0, '', '2019-08-20 12:53:59');
INSERT INTO `access_log` VALUES (69283, '66.56.15662768402075225', 207, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:54:00', 7, 0, '', '2019-08-20 12:54:00');
INSERT INTO `access_log` VALUES (69284, '64.85.15662768463918065', 207, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:54:06', 10, 0, '', '2019-08-20 12:54:06');
INSERT INTO `access_log` VALUES (69285, '64.77.15662768465178019', 207, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:54:07', 16, 0, '', '2019-08-20 12:54:07');
INSERT INTO `access_log` VALUES (69286, 'N/A', 207, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:54:07', 11, 0, '', '2019-08-20 12:54:07');
INSERT INTO `access_log` VALUES (69287, '64.81.15662768477418031', 207, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:54:08', 10, 0, '', '2019-08-20 12:54:08');
INSERT INTO `access_log` VALUES (69288, '66.57.15662768496345213', 207, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:54:10', 6, 0, '', '2019-08-20 12:54:10');
INSERT INTO `access_log` VALUES (69289, '66.50.15662768657795213', 207, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '123.144.40.142', '2019-08-20 12:54:26', 5, 0, '', '2019-08-20 12:54:26');
INSERT INTO `access_log` VALUES (69290, '59.79.15662790645537703', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.236.113', '2019-08-20 13:31:05', 12, 0, '', '2019-08-20 13:31:05');
INSERT INTO `access_log` VALUES (69291, '59.71.15662790648237701', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.236.113', '2019-08-20 13:31:05', 30, 2001001000, '服务端发生异常', '2019-08-20 13:31:05');
INSERT INTO `access_log` VALUES (69292, '64.77.15662790693368049', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.236.113', '2019-08-20 13:31:09', 12, 0, '', '2019-08-20 13:31:09');
INSERT INTO `access_log` VALUES (69293, '64.81.15662790694958061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.236.113', '2019-08-20 13:31:09', 3, 0, '', '2019-08-20 13:31:09');
INSERT INTO `access_log` VALUES (69294, '0411b0f3-1867-4833-ae4c-efea0be06d4e', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '127.0.0.1', '2019-08-20 13:31:36', 139, 1002001015, '账号未登陆', '2019-08-20 13:31:36');
INSERT INTO `access_log` VALUES (69295, '4b774213-83c6-4c5b-b165-cc7d24392f83', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '127.0.0.1', '2019-08-20 13:31:36', 139, 1002001015, '账号未登陆', '2019-08-20 13:31:36');
INSERT INTO `access_log` VALUES (69296, 'a18119d4-9499-479c-bb92-436be849abff', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '127.0.0.1', '2019-08-20 13:31:36', 139, 1002001015, '账号未登陆', '2019-08-20 13:31:36');
INSERT INTO `access_log` VALUES (69297, 'f154c024-0806-4757-809d-6a7fea3f9521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '127.0.0.1', '2019-08-20 13:31:45', 221, 1002002001, '密码不正确', '2019-08-20 13:31:45');
INSERT INTO `access_log` VALUES (69298, '65.3607.15662791266182583', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.236.113', '2019-08-20 13:32:07', 0, 1002001015, '账号未登陆', '2019-08-20 13:32:07');
INSERT INTO `access_log` VALUES (69299, '65.46.15662791266190833', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.236.113', '2019-08-20 13:32:07', 1, 1002001015, '账号未登陆', '2019-08-20 13:32:07');
INSERT INTO `access_log` VALUES (69300, '65.53.15662791266240743', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.236.113', '2019-08-20 13:32:07', 0, 1002001015, '账号未登陆', '2019-08-20 13:32:07');
INSERT INTO `access_log` VALUES (69301, '65.45.15662791317720801', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.236.113', '2019-08-20 13:32:12', 86, 0, '', '2019-08-20 13:32:12');
INSERT INTO `access_log` VALUES (69302, '65.50.15662791368280789', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.236.113', '2019-08-20 13:32:17', 10, 0, '', '2019-08-20 13:32:17');
INSERT INTO `access_log` VALUES (69303, '65.51.15662791368630849', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.236.113', '2019-08-20 13:32:17', 11, 0, '', '2019-08-20 13:32:17');
INSERT INTO `access_log` VALUES (69304, '65.52.15662791368620835', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '122.234.236.113', '2019-08-20 13:32:17', 12, 2001001000, '服务端发生异常', '2019-08-20 13:32:17');
INSERT INTO `access_log` VALUES (69305, '78357161-9b62-495d-82c4-6c4769f5b798', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=ant.design&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:32:25', 20, 1002002001, '密码不正确', '2019-08-20 13:32:25');
INSERT INTO `access_log` VALUES (69306, '85edd225-1303-425a-925b-884ddc229fbc', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=ant.design&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:32:43', 17, 1002002001, '密码不正确', '2019-08-20 13:32:43');
INSERT INTO `access_log` VALUES (69307, '1d3dd9c4-6e97-41a6-b450-89f7ff1922ea', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:32:57', 167, 1002002001, '密码不正确', '2019-08-20 13:32:57');
INSERT INTO `access_log` VALUES (69308, '65.52.15662797215510843', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '60.28.45.82', '2019-08-20 13:42:02', 0, 1002001015, '账号未登陆', '2019-08-20 13:42:02');
INSERT INTO `access_log` VALUES (69309, '65.49.15662797215530809', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '60.28.45.82', '2019-08-20 13:42:02', 0, 1002001015, '账号未登陆', '2019-08-20 13:42:02');
INSERT INTO `access_log` VALUES (69310, '65.47.15662797215530751', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/57.0.2987.98 Safari/537.36 LBBROWSER', '60.28.45.82', '2019-08-20 13:42:02', 0, 1002001015, '账号未登陆', '2019-08-20 13:42:02');
INSERT INTO `access_log` VALUES (69311, 'd309ca81-669d-4cac-b721-52b59c20227b', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=ant.design&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:43:16', 72074, 1002002001, '密码不正确', '2019-08-20 13:44:28');
INSERT INTO `access_log` VALUES (69312, '34429c7f-435d-421e-919e-5b468bcad094', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:44:38', 632, 0, '', '2019-08-20 13:44:38');
INSERT INTO `access_log` VALUES (69313, 'fe139a38-ff40-46be-90bd-0cfdec8ff975', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:44:39', 334, 0, '', '2019-08-20 13:44:39');
INSERT INTO `access_log` VALUES (69314, '5b9fd04a-8b1b-458d-b0d5-3a89c56f13db', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:44:39', 157, 0, '', '2019-08-20 13:44:39');
INSERT INTO `access_log` VALUES (69315, 'da0edc55-5d80-4e1e-9723-877b8064d703', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:44:39', 555, 0, '', '2019-08-20 13:44:39');
INSERT INTO `access_log` VALUES (69316, '4468086b-21f2-448d-b7dd-0acbbeb82aa6', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:50:30', 1637, 0, '', '2019-08-20 13:50:32');
INSERT INTO `access_log` VALUES (69317, '012b6dcf-af6f-4e6e-a1c2-52a293030c74', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:50:41', 736, 0, '', '2019-08-20 13:50:42');
INSERT INTO `access_log` VALUES (69318, '0af2c2c7-5347-48cb-aade-8694fefdf057', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:50:41', 736, 0, '', '2019-08-20 13:50:42');
INSERT INTO `access_log` VALUES (69319, '743abcc1-5e88-4f3e-b662-c9703aa80904', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:50:57', 212, 0, '', '2019-08-20 13:50:57');
INSERT INTO `access_log` VALUES (69320, '43b0ae61-5b47-4074-bcf0-b91fc926c5e6', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:50:57', 262, 0, '', '2019-08-20 13:50:57');
INSERT INTO `access_log` VALUES (69321, '8248ff17-a746-480a-9f87-cee3968c33aa', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:51:15', 91, 0, '', '2019-08-20 13:51:15');
INSERT INTO `access_log` VALUES (69322, 'b671af74-d4c6-4236-b969-b3e9326fb5af', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:51:15', 88, 0, '', '2019-08-20 13:51:15');
INSERT INTO `access_log` VALUES (69323, '270039e0-9a2a-4a05-b2d9-1bcf814fc008', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:51:15', 131, 0, '', '2019-08-20 13:51:15');
INSERT INTO `access_log` VALUES (69324, '41b4d13c-32dc-4d80-a838-7e5424888af2', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:51:20', 68, 0, '', '2019-08-20 13:51:20');
INSERT INTO `access_log` VALUES (69325, '1bf6f0c9-553d-40fc-ae06-f39ff0c8d3c7', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:51:20', 1662, 0, '', '2019-08-20 13:51:21');
INSERT INTO `access_log` VALUES (69326, '6f8d81d1-c210-484c-b5bf-278cbe8232a4', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 13:51:22', 117, 0, '', '2019-08-20 13:51:22');
INSERT INTO `access_log` VALUES (69327, '65.51.15662805273920869', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.0.240', '2019-08-20 13:55:27', 0, 1002001015, '账号未登陆', '2019-08-20 13:55:27');
INSERT INTO `access_log` VALUES (69328, '65.50.15662805273920809', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.0.240', '2019-08-20 13:55:27', 1, 1002001015, '账号未登陆', '2019-08-20 13:55:27');
INSERT INTO `access_log` VALUES (69329, '65.45.15662805273910821', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.0.240', '2019-08-20 13:55:27', 1, 1002001015, '账号未登陆', '2019-08-20 13:55:27');
INSERT INTO `access_log` VALUES (69330, '65.47.15662805315110763', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.0.240', '2019-08-20 13:55:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 13:55:32');
INSERT INTO `access_log` VALUES (69331, '65.49.15662805340670821', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.0.240', '2019-08-20 13:55:34', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 13:55:34');
INSERT INTO `access_log` VALUES (69332, '65.3607.15662805526122605', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.0.240', '2019-08-20 13:55:53', 84, 0, '', '2019-08-20 13:55:53');
INSERT INTO `access_log` VALUES (69333, '65.54.15662805530070709', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.0.240', '2019-08-20 13:55:53', 13, 0, '', '2019-08-20 13:55:53');
INSERT INTO `access_log` VALUES (69334, '65.53.15662805529930765', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.0.240', '2019-08-20 13:55:53', 27, 2001001000, '服务端发生异常', '2019-08-20 13:55:53');
INSERT INTO `access_log` VALUES (69335, '65.46.15662805529890855', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.0.240', '2019-08-20 13:55:53', 26, 0, '', '2019-08-20 13:55:53');
INSERT INTO `access_log` VALUES (69336, '59.71.15662820616357741', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:02', 15, 0, '', '2019-08-20 14:21:02');
INSERT INTO `access_log` VALUES (69337, '59.78.15662820616357751', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:02', 29, 2001001000, '服务端发生异常', '2019-08-20 14:21:02');
INSERT INTO `access_log` VALUES (69338, '64.81.15662820649008101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:05', 11, 0, '', '2019-08-20 14:21:05');
INSERT INTO `access_log` VALUES (69339, '64.82.15662820650188115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:05', 3, 0, '', '2019-08-20 14:21:05');
INSERT INTO `access_log` VALUES (69340, '64.83.15662820663878101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:06', 2, 0, '', '2019-08-20 14:21:06');
INSERT INTO `access_log` VALUES (69341, '64.79.15662820669128101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:07', 2, 0, '', '2019-08-20 14:21:07');
INSERT INTO `access_log` VALUES (69342, '66.53.15662820692385267', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:09', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-08-20 14:21:09');
INSERT INTO `access_log` VALUES (69343, '64.80.15662820747918103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:15', 2, 0, '', '2019-08-20 14:21:15');
INSERT INTO `access_log` VALUES (69344, '64.84.15662820749078103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:15', 1, 0, '', '2019-08-20 14:21:15');
INSERT INTO `access_log` VALUES (69345, '66.48.15662820787175277', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-08-20 14:21:19');
INSERT INTO `access_log` VALUES (69346, '66.55.15662820855035265', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位', '2019-08-20 14:21:26');
INSERT INTO `access_log` VALUES (69347, '64.85.15662820926878137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:33', 2, 0, '', '2019-08-20 14:21:33');
INSERT INTO `access_log` VALUES (69348, '64.77.15662820928518091', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:33', 2, 0, '', '2019-08-20 14:21:33');
INSERT INTO `access_log` VALUES (69349, '59.75.15662820932747749', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:33', 6, 0, '', '2019-08-20 14:21:33');
INSERT INTO `access_log` VALUES (69350, '59.73.15662820932747747', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '1.80.217.217', '2019-08-20 14:21:33', 15, 2001001000, '服务端发生异常', '2019-08-20 14:21:33');
INSERT INTO `access_log` VALUES (69351, 'f8cf5889-73cb-40a2-99f1-cf5fb13e88a4', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 15:05:37', 251, 1002001012, '访问令牌已过期', '2019-08-20 15:05:38');
INSERT INTO `access_log` VALUES (69352, '7bd13bad-e87b-4cb1-b4bf-f649266cf46c', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 15:05:41', 140, 0, '', '2019-08-20 15:05:41');
INSERT INTO `access_log` VALUES (69353, '05195b10-9d85-45b4-a687-0e2beaa023e4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 15:05:42', 91, 0, '', '2019-08-20 15:05:42');
INSERT INTO `access_log` VALUES (69354, 'e90897ab-7fea-4e5a-ae71-d41a708b8e26', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 15:05:42', 110, 0, '', '2019-08-20 15:05:42');
INSERT INTO `access_log` VALUES (69355, 'f3f21826-329d-40f5-b5da-03b3ab9d54cf', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 15:05:42', 201, 0, '', '2019-08-20 15:05:42');
INSERT INTO `access_log` VALUES (69356, '5dda6312-e38a-4608-9765-d8db7d69d33f', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 15:05:50', 214, 0, '', '2019-08-20 15:05:51');
INSERT INTO `access_log` VALUES (69357, 'c25c5fc8-66e1-452a-97b8-b3a0b1f6c195', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 15:05:50', 233, 0, '', '2019-08-20 15:05:51');
INSERT INTO `access_log` VALUES (69358, '7e4204d3-3802-4b4b-9a9d-8a3223e812b1', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 15:06:16', 64, 0, '', '2019-08-20 15:06:16');
INSERT INTO `access_log` VALUES (69359, '65.45.15662868751870907', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:15', 1, 1002001015, '账号未登陆', '2019-08-20 15:41:15');
INSERT INTO `access_log` VALUES (69360, '65.47.15662868751870849', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:15', 0, 1002001015, '账号未登陆', '2019-08-20 15:41:15');
INSERT INTO `access_log` VALUES (69361, '65.49.15662868751880907', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:15', 0, 1002001015, '账号未登陆', '2019-08-20 15:41:15');
INSERT INTO `access_log` VALUES (69362, '65.52.15662868807950941', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:21', 71, 0, '', '2019-08-20 15:41:21');
INSERT INTO `access_log` VALUES (69363, '65.3607.15662868815142691', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:22', 435, 0, '', '2019-08-20 15:41:22');
INSERT INTO `access_log` VALUES (69364, '65.53.15662868815180851', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:22', 433, 0, '', '2019-08-20 15:41:22');
INSERT INTO `access_log` VALUES (69365, '65.54.15662868815160795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:22', 436, 2001001000, '服务端发生异常', '2019-08-20 15:41:22');
INSERT INTO `access_log` VALUES (69366, '65.50.15662869013670897', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:41', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 15:41:41');
INSERT INTO `access_log` VALUES (69367, '65.49.15662869046970909', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:45', 89, 0, '', '2019-08-20 15:41:45');
INSERT INTO `access_log` VALUES (69368, '65.47.15662869053230851', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:45', 16, 0, '', '2019-08-20 15:41:45');
INSERT INTO `access_log` VALUES (69369, '65.45.15662869053230909', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:45', 16, 0, '', '2019-08-20 15:41:45');
INSERT INTO `access_log` VALUES (69370, '65.52.15662869053240943', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:45', 18, 0, '', '2019-08-20 15:41:45');
INSERT INTO `access_log` VALUES (69371, '62.81.15662869100146499', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:50', 27, 0, '', '2019-08-20 15:41:50');
INSERT INTO `access_log` VALUES (69372, '64.83.15662869125708167', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:53', 18, 0, '', '2019-08-20 15:41:53');
INSERT INTO `access_log` VALUES (69373, '64.76.15662869125668175', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:53', 34, 0, '', '2019-08-20 15:41:53');
INSERT INTO `access_log` VALUES (69374, '59.76.15662869191737797', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:41:59', 23, 0, '', '2019-08-20 15:41:59');
INSERT INTO `access_log` VALUES (69375, '59.79.15662869233037809', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:42:03', 22, 0, '', '2019-08-20 15:42:03');
INSERT INTO `access_log` VALUES (69376, '65.53.15662869294780853', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:42:09', 25, 0, '', '2019-08-20 15:42:10');
INSERT INTO `access_log` VALUES (69377, '65.46.15662869306050943', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:42:11', 15, 0, '', '2019-08-20 15:42:11');
INSERT INTO `access_log` VALUES (69378, '65.51.15662869324160959', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:42:12', 18, 0, '', '2019-08-20 15:42:12');
INSERT INTO `access_log` VALUES (69379, '65.50.15662869376090899', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:42:18', 10, 0, '', '2019-08-20 15:42:18');
INSERT INTO `access_log` VALUES (69380, '65.45.15662869460500911', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:42:26', 9, 0, '', '2019-08-20 15:42:26');
INSERT INTO `access_log` VALUES (69381, '59.72.15662869563567809', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:42:36', 2, 0, '', '2019-08-20 15:42:36');
INSERT INTO `access_log` VALUES (69382, '59.75.15662869563577815', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:42:36', 16, 2001001000, '服务端发生异常', '2019-08-20 15:42:36');
INSERT INTO `access_log` VALUES (69383, '64.78.15662869597048183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:42:40', 2, 0, '', '2019-08-20 15:42:40');
INSERT INTO `access_log` VALUES (69384, '64.85.15662869599988203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:42:40', 2, 0, '', '2019-08-20 15:42:40');
INSERT INTO `access_log` VALUES (69385, '64.77.15662869611438157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:42:41', 2, 0, '', '2019-08-20 15:42:41');
INSERT INTO `access_log` VALUES (69386, '64.81.15662869619528169', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0.2 Safari/605.1.15', '106.38.115.24', '2019-08-20 15:42:42', 2, 0, '', '2019-08-20 15:42:42');
INSERT INTO `access_log` VALUES (69387, '59.71.15662879422337821', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:02', 2, 0, '', '2019-08-20 15:59:02');
INSERT INTO `access_log` VALUES (69388, '59.78.15662879422637831', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:02', 15, 2001001000, '服务端发生异常', '2019-08-20 15:59:02');
INSERT INTO `access_log` VALUES (69389, '64.78.15662879469238197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:07', 3, 0, '', '2019-08-20 15:59:07');
INSERT INTO `access_log` VALUES (69390, '64.85.15662879470238217', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:07', 1, 0, '', '2019-08-20 15:59:07');
INSERT INTO `access_log` VALUES (69391, '64.77.15662879482828171', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:08', 1, 0, '', '2019-08-20 15:59:08');
INSERT INTO `access_log` VALUES (69392, '64.81.15662879488368183', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:09', 2, 0, '', '2019-08-20 15:59:09');
INSERT INTO `access_log` VALUES (69393, '64.82.15662879493628197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:09', 1, 0, '', '2019-08-20 15:59:09');
INSERT INTO `access_log` VALUES (69394, '64.76.15662879496838191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:10', 2, 0, '', '2019-08-20 15:59:10');
INSERT INTO `access_log` VALUES (69395, '59.72.15662879507157823', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:11', 2, 0, '', '2019-08-20 15:59:11');
INSERT INTO `access_log` VALUES (69396, '59.75.15662879507147829', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:11', 17, 2001001000, '服务端发生异常', '2019-08-20 15:59:11');
INSERT INTO `access_log` VALUES (69397, '65.50.15662879595120913', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:20', 0, 1002001015, '账号未登陆', '2019-08-20 15:59:20');
INSERT INTO `access_log` VALUES (69398, '65.49.15662879595150925', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:20', 0, 1002001015, '账号未登陆', '2019-08-20 15:59:20');
INSERT INTO `access_log` VALUES (69399, '65.45.15662879595170925', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:20', 0, 1002001015, '账号未登陆', '2019-08-20 15:59:20');
INSERT INTO `access_log` VALUES (69400, '65.52.15662879617590959', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 15:59:22');
INSERT INTO `access_log` VALUES (69401, '65.54.15662879644030813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:24', 71, 0, '', '2019-08-20 15:59:24');
INSERT INTO `access_log` VALUES (69402, '65.3607.15662879646862709', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:25', 9, 0, '', '2019-08-20 15:59:25');
INSERT INTO `access_log` VALUES (69403, '65.53.15662879646860869', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:25', 11, 2001001000, '服务端发生异常', '2019-08-20 15:59:25');
INSERT INTO `access_log` VALUES (69404, '65.46.15662879646910959', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:25', 9, 0, '', '2019-08-20 15:59:25');
INSERT INTO `access_log` VALUES (69405, '65.51.15662879725430975', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:33', 16, 0, '', '2019-08-20 15:59:33');
INSERT INTO `access_log` VALUES (69406, '65.50.15662879725450915', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:33', 17, 2001001000, '服务端发生异常', '2019-08-20 15:59:33');
INSERT INTO `access_log` VALUES (69407, '65.45.15662879725600927', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:33', 8, 0, '', '2019-08-20 15:59:33');
INSERT INTO `access_log` VALUES (69408, '65.52.15662879809080961', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:41', 11, 0, '', '2019-08-20 15:59:41');
INSERT INTO `access_log` VALUES (69409, '65.47.15662879809130869', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:41', 10, 2001001000, '服务端发生异常', '2019-08-20 15:59:41');
INSERT INTO `access_log` VALUES (69410, '65.54.15662879809140815', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.227.163.78', '2019-08-20 15:59:41', 9, 0, '', '2019-08-20 15:59:41');
INSERT INTO `access_log` VALUES (69411, '65.3607.15662893323422729', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '61.141.64.85', '2019-08-20 16:22:12', 1, 1002001015, '账号未登陆', '2019-08-20 16:22:12');
INSERT INTO `access_log` VALUES (69412, '65.46.15662893323410979', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '61.141.64.85', '2019-08-20 16:22:12', 0, 1002001015, '账号未登陆', '2019-08-20 16:22:12');
INSERT INTO `access_log` VALUES (69413, '65.53.15662893323420889', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '61.141.64.85', '2019-08-20 16:22:12', 0, 1002001015, '账号未登陆', '2019-08-20 16:22:12');
INSERT INTO `access_log` VALUES (69414, '65.50.15662893344230935', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '61.141.64.85', '2019-08-20 16:22:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 16:22:14');
INSERT INTO `access_log` VALUES (69415, '65.45.15662893452160947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '61.141.64.85', '2019-08-20 16:22:25', 105, 0, '', '2019-08-20 16:22:25');
INSERT INTO `access_log` VALUES (69416, '65.54.15662893455830835', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '61.141.64.85', '2019-08-20 16:22:26', 499, 0, '', '2019-08-20 16:22:26');
INSERT INTO `access_log` VALUES (69417, '65.49.15662893455740947', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '61.141.64.85', '2019-08-20 16:22:26', 508, 0, '', '2019-08-20 16:22:26');
INSERT INTO `access_log` VALUES (69418, '65.52.15662893455790981', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '61.141.64.85', '2019-08-20 16:22:26', 507, 2001001000, '服务端发生异常', '2019-08-20 16:22:26');
INSERT INTO `access_log` VALUES (69419, '59.71.15662905704217857', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.8.255.49', '2019-08-20 16:42:50', 9, 0, '', '2019-08-20 16:42:50');
INSERT INTO `access_log` VALUES (69420, '59.78.15662905704227867', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.8.255.49', '2019-08-20 16:42:50', 19, 2001001000, '服务端发生异常', '2019-08-20 16:42:50');
INSERT INTO `access_log` VALUES (69421, '59.72.15662905903497859', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.8.255.49', '2019-08-20 16:43:10', 3, 0, '', '2019-08-20 16:43:10');
INSERT INTO `access_log` VALUES (69422, '59.75.15662905903537865', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.8.255.49', '2019-08-20 16:43:10', 29, 2001001000, '服务端发生异常', '2019-08-20 16:43:10');
INSERT INTO `access_log` VALUES (69423, '59.77.15662906250017847', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.8.255.49', '2019-08-20 16:43:45', 2, 0, '', '2019-08-20 16:43:45');
INSERT INTO `access_log` VALUES (69424, '59.76.15662906250067849', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.8.255.49', '2019-08-20 16:43:45', 14, 2001001000, '服务端发生异常', '2019-08-20 16:43:45');
INSERT INTO `access_log` VALUES (69425, '64.82.15662906288338233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.8.255.49', '2019-08-20 16:43:49', 11, 0, '', '2019-08-20 16:43:49');
INSERT INTO `access_log` VALUES (69426, '64.76.15662906289548227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '121.8.255.49', '2019-08-20 16:43:49', 3, 0, '', '2019-08-20 16:43:49');
INSERT INTO `access_log` VALUES (69427, '59.77.15662909096457851', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '124.127.202.102', '2019-08-20 16:48:30', 3, 0, '', '2019-08-20 16:48:30');
INSERT INTO `access_log` VALUES (69428, '59.79.15662909096467865', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:48:30', 21, 2001001000, '服务端发生异常', '2019-08-20 16:48:30');
INSERT INTO `access_log` VALUES (69429, '64.83.15662909183818223', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:48:38', 3, 0, '', '2019-08-20 16:48:38');
INSERT INTO `access_log` VALUES (69430, '64.79.15662909184998223', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:48:39', 2, 0, '', '2019-08-20 16:48:39');
INSERT INTO `access_log` VALUES (69431, '64.80.15662909204378225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:48:40', 2, 0, '', '2019-08-20 16:48:40');
INSERT INTO `access_log` VALUES (69432, '64.84.15662909214328225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:48:41', 2, 0, '', '2019-08-20 16:48:41');
INSERT INTO `access_log` VALUES (69433, '64.78.15662909246738239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:48:45', 1, 0, '', '2019-08-20 16:48:45');
INSERT INTO `access_log` VALUES (69434, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '124.127.202.102', '2019-08-20 16:48:45', 6, 0, '', '2019-08-20 16:48:45');
INSERT INTO `access_log` VALUES (69435, '64.85.15662909276378259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '124.127.202.102', '2019-08-20 16:48:48', 2, 0, '', '2019-08-20 16:48:48');
INSERT INTO `access_log` VALUES (69436, '64.77.15662909277588213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '124.127.202.102', '2019-08-20 16:48:48', 2, 0, '', '2019-08-20 16:48:48');
INSERT INTO `access_log` VALUES (69437, '64.81.15662909303618225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '124.127.202.102', '2019-08-20 16:48:50', 2, 0, '', '2019-08-20 16:48:50');
INSERT INTO `access_log` VALUES (69438, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:48:50', 6, 0, '', '2019-08-20 16:48:50');
INSERT INTO `access_log` VALUES (69439, '64.76.15662909322238233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:48:52', 2, 0, '', '2019-08-20 16:48:52');
INSERT INTO `access_log` VALUES (69440, '64.83.15662909323408225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:48:52', 2, 0, '', '2019-08-20 16:48:52');
INSERT INTO `access_log` VALUES (69441, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:48:59', 6, 0, '', '2019-08-20 16:48:59');
INSERT INTO `access_log` VALUES (69442, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=java', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:48:59', 10, 0, '', '2019-08-20 16:48:59');
INSERT INTO `access_log` VALUES (69443, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=java&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:49:01', 5, 0, '', '2019-08-20 16:49:01');
INSERT INTO `access_log` VALUES (69444, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=java', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:49:02', 7, 0, '', '2019-08-20 16:49:02');
INSERT INTO `access_log` VALUES (69445, '64.80.15662909484978227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:49:08', 2, 0, '', '2019-08-20 16:49:09');
INSERT INTO `access_log` VALUES (69446, '64.84.15662909486228227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:49:09', 2, 0, '', '2019-08-20 16:49:09');
INSERT INTO `access_log` VALUES (69447, '65.54.15662909606510857', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '124.127.178.154', '2019-08-20 16:49:21', 0, 1002001015, '账号未登陆', '2019-08-20 16:49:21');
INSERT INTO `access_log` VALUES (69448, '65.52.15662909606511003', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '1.202.183.178', '2019-08-20 16:49:21', 1, 1002001015, '账号未登陆', '2019-08-20 16:49:21');
INSERT INTO `access_log` VALUES (69449, '65.49.15662909606850969', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '124.127.202.110', '2019-08-20 16:49:21', 0, 1002001015, '账号未登陆', '2019-08-20 16:49:21');
INSERT INTO `access_log` VALUES (69450, '65.49.15662910884580971', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.108.25.90', '2019-08-20 16:51:28', 1, 1002001015, '账号未登陆', '2019-08-20 16:51:28');
INSERT INTO `access_log` VALUES (69451, '65.47.15662910884620913', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.108.25.90', '2019-08-20 16:51:28', 0, 1002001015, '账号未登陆', '2019-08-20 16:51:28');
INSERT INTO `access_log` VALUES (69452, '65.3607.15662910884722755', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.108.25.90', '2019-08-20 16:51:28', 1, 1002001015, '账号未登陆', '2019-08-20 16:51:28');
INSERT INTO `access_log` VALUES (69453, '65.53.15662911063440915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.108.25.90', '2019-08-20 16:51:46', 102, 0, '', '2019-08-20 16:51:46');
INSERT INTO `access_log` VALUES (69454, '65.50.15662911067990961', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.108.25.90', '2019-08-20 16:51:47', 10, 0, '', '2019-08-20 16:51:47');
INSERT INTO `access_log` VALUES (69455, '65.51.15662911068041021', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.108.25.90', '2019-08-20 16:51:47', 10, 2001001000, '服务端发生异常', '2019-08-20 16:51:47');
INSERT INTO `access_log` VALUES (69456, '65.45.15662911068090973', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.108.25.90', '2019-08-20 16:51:47', 10, 0, '', '2019-08-20 16:51:47');
INSERT INTO `access_log` VALUES (69457, '65.46.15662916135791013', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-20 17:00:14', 3, 1002001012, '访问令牌已过期', '2019-08-20 17:00:14');
INSERT INTO `access_log` VALUES (69458, '65.3607.15662916135782763', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-20 17:00:14', 3, 1002001012, '访问令牌已过期', '2019-08-20 17:00:14');
INSERT INTO `access_log` VALUES (69459, '65.53.15662916135820923', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-20 17:00:14', 2, 1002001012, '访问令牌已过期', '2019-08-20 17:00:14');
INSERT INTO `access_log` VALUES (69460, '65.47.15662916447800923', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-20 17:00:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 17:00:45');
INSERT INTO `access_log` VALUES (69461, '65.51.15662916713991029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-20 17:01:11', 70, 0, '', '2019-08-20 17:01:11');
INSERT INTO `access_log` VALUES (69462, '65.50.15662916718540971', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-20 17:01:12', 18, 0, '', '2019-08-20 17:01:12');
INSERT INTO `access_log` VALUES (69463, '65.49.15662916718540981', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-20 17:01:12', 18, 0, '', '2019-08-20 17:01:12');
INSERT INTO `access_log` VALUES (69464, '65.52.15662916718541017', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-20 17:01:12', 19, 2001001000, '服务端发生异常', '2019-08-20 17:01:12');
INSERT INTO `access_log` VALUES (69465, '65.50.15662931849300993', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.117 Safari/537.36', '120.37.177.34', '2019-08-20 17:26:25', 0, 1002001015, '账号未登陆', '2019-08-20 17:26:25');
INSERT INTO `access_log` VALUES (69466, '65.49.15662931849291003', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.117 Safari/537.36', '120.37.177.34', '2019-08-20 17:26:25', 0, 1002001015, '账号未登陆', '2019-08-20 17:26:25');
INSERT INTO `access_log` VALUES (69467, '65.54.15662931849510891', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.117 Safari/537.36', '120.37.177.34', '2019-08-20 17:26:25', 0, 1002001015, '账号未登陆', '2019-08-20 17:26:25');
INSERT INTO `access_log` VALUES (69468, '65.47.15662931865670945', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.117 Safari/537.36', '120.37.177.34', '2019-08-20 17:26:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 17:26:27');
INSERT INTO `access_log` VALUES (69469, '65.53.15662931985480947', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.117 Safari/537.36', '120.37.177.34', '2019-08-20 17:26:39', 87, 0, '', '2019-08-20 17:26:39');
INSERT INTO `access_log` VALUES (69470, '65.3607.15662931988752789', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.117 Safari/537.36', '120.37.177.34', '2019-08-20 17:26:39', 10, 0, '', '2019-08-20 17:26:39');
INSERT INTO `access_log` VALUES (69471, '65.46.15662931988771037', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.117 Safari/537.36', '120.37.177.34', '2019-08-20 17:26:39', 10, 2001001000, '服务端发生异常', '2019-08-20 17:26:39');
INSERT INTO `access_log` VALUES (69472, '65.45.15662931989001007', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.117 Safari/537.36', '120.37.177.34', '2019-08-20 17:26:39', 9, 0, '', '2019-08-20 17:26:39');
INSERT INTO `access_log` VALUES (69473, '65.52.15662932068411041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.117 Safari/537.36', '120.37.177.34', '2019-08-20 17:26:47', 10, 0, '', '2019-08-20 17:26:47');
INSERT INTO `access_log` VALUES (69474, '65.50.15662932068440995', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.117 Safari/537.36', '120.37.177.34', '2019-08-20 17:26:47', 10, 2001001000, '服务端发生异常', '2019-08-20 17:26:47');
INSERT INTO `access_log` VALUES (69475, '65.49.15662932068471005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.117 Safari/537.36', '120.37.177.34', '2019-08-20 17:26:47', 9, 0, '', '2019-08-20 17:26:47');
INSERT INTO `access_log` VALUES (69476, '64.83.15662934641308259', 0, 2, 'product-application', '/product-api/admins/attr/add', 'name=颜色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 17:31:04', 0, 1002001015, '账号未登陆', '2019-08-20 17:31:04');
INSERT INTO `access_log` VALUES (69477, '64.85.15662935119578295', 0, 2, 'product-application', '/product-api/admins/spu/list', 'ids=1,2,3', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 17:31:52', 1, 1002001015, '账号未登陆', '2019-08-20 17:31:52');
INSERT INTO `access_log` VALUES (69478, '59.75.15662936542627907', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.117 Safari/537.36', '120.37.177.34', '2019-08-20 17:34:14', 14, 2001001000, '服务端发生异常', '2019-08-20 17:34:14');
INSERT INTO `access_log` VALUES (69479, '59.72.15662936542617901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.117 Safari/537.36', '120.37.177.34', '2019-08-20 17:34:14', 344, 0, '', '2019-08-20 17:34:15');
INSERT INTO `access_log` VALUES (69480, '59.80.15662936624767875', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:22', 4, 0, '', '2019-08-20 17:34:22');
INSERT INTO `access_log` VALUES (69481, '59.76.15662936624777891', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:22', 16, 2001001000, '服务端发生异常', '2019-08-20 17:34:22');
INSERT INTO `access_log` VALUES (69482, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:26', 7, 0, '', '2019-08-20 17:34:26');
INSERT INTO `access_log` VALUES (69483, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:26', 21, 0, '', '2019-08-20 17:34:26');
INSERT INTO `access_log` VALUES (69484, '59.79.15662936672607903', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:27', 2, 0, '', '2019-08-20 17:34:27');
INSERT INTO `access_log` VALUES (69485, '59.77.15662936672607889', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:27', 14, 2001001000, '服务端发生异常', '2019-08-20 17:34:27');
INSERT INTO `access_log` VALUES (69486, '64.77.15662936694538251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:29', 3, 0, '', '2019-08-20 17:34:29');
INSERT INTO `access_log` VALUES (69487, '64.82.15662936695858277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:30', 2, 0, '', '2019-08-20 17:34:30');
INSERT INTO `access_log` VALUES (69488, '64.81.15662936713218265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:31', 1, 0, '', '2019-08-20 17:34:31');
INSERT INTO `access_log` VALUES (69489, '64.76.15662936720138271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:32', 2, 0, '', '2019-08-20 17:34:32');
INSERT INTO `access_log` VALUES (69490, '64.83.15662936728428263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:33', 2, 0, '', '2019-08-20 17:34:33');
INSERT INTO `access_log` VALUES (69491, '64.79.15662936732498263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:33', 2, 0, '', '2019-08-20 17:34:33');
INSERT INTO `access_log` VALUES (69492, '64.80.15662936740728267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:34', 2, 0, '', '2019-08-20 17:34:34');
INSERT INTO `access_log` VALUES (69493, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:34', 5, 0, '', '2019-08-20 17:34:34');
INSERT INTO `access_log` VALUES (69494, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:36', 5, 0, '', '2019-08-20 17:34:36');
INSERT INTO `access_log` VALUES (69495, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:37', 5, 0, '', '2019-08-20 17:34:37');
INSERT INTO `access_log` VALUES (69496, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:37', 6, 0, '', '2019-08-20 17:34:37');
INSERT INTO `access_log` VALUES (69497, '64.84.15662936792448267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:39', 2, 0, '', '2019-08-20 17:34:39');
INSERT INTO `access_log` VALUES (69498, '64.85.15662936793308299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:39', 1, 0, '', '2019-08-20 17:34:39');
INSERT INTO `access_log` VALUES (69499, '64.77.15662936827318253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:43', 3, 0, '', '2019-08-20 17:34:43');
INSERT INTO `access_log` VALUES (69500, '64.82.15662936828338279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:43', 2, 0, '', '2019-08-20 17:34:43');
INSERT INTO `access_log` VALUES (69501, '59.74.15662936904387919', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:50', 3, 0, '', '2019-08-20 17:34:50');
INSERT INTO `access_log` VALUES (69502, '59.75.15662936904397909', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:50', 12, 2001001000, '服务端发生异常', '2019-08-20 17:34:50');
INSERT INTO `access_log` VALUES (69503, '64.76.15662936928098273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:53', 1, 0, '', '2019-08-20 17:34:53');
INSERT INTO `access_log` VALUES (69504, '64.83.15662936928998265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:53', 2, 0, '', '2019-08-20 17:34:53');
INSERT INTO `access_log` VALUES (69505, '59.72.15662936946127903', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:55', 2, 0, '', '2019-08-20 17:34:55');
INSERT INTO `access_log` VALUES (69506, '59.73.15662936946137907', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:55', 13, 2001001000, '服务端发生异常', '2019-08-20 17:34:55');
INSERT INTO `access_log` VALUES (69507, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:58', 7, 0, '', '2019-08-20 17:34:58');
INSERT INTO `access_log` VALUES (69508, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:58', 10, 0, '', '2019-08-20 17:34:58');
INSERT INTO `access_log` VALUES (69509, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:34:59', 4, 0, '', '2019-08-20 17:34:59');
INSERT INTO `access_log` VALUES (69510, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:00', 8, 0, '', '2019-08-20 17:35:00');
INSERT INTO `access_log` VALUES (69511, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:02', 6, 0, '', '2019-08-20 17:35:02');
INSERT INTO `access_log` VALUES (69512, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:02', 12, 0, '', '2019-08-20 17:35:02');
INSERT INTO `access_log` VALUES (69513, '64.79.15662937045718265', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:05', 9, 0, '', '2019-08-20 17:35:05');
INSERT INTO `access_log` VALUES (69514, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:06', 6, 0, '', '2019-08-20 17:35:06');
INSERT INTO `access_log` VALUES (69515, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:06', 10, 0, '', '2019-08-20 17:35:06');
INSERT INTO `access_log` VALUES (69516, '64.78.15662937106908283', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:11', 6, 0, '', '2019-08-20 17:35:11');
INSERT INTO `access_log` VALUES (69517, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:23', 7, 0, '', '2019-08-20 17:35:23');
INSERT INTO `access_log` VALUES (69518, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:24', 10, 0, '', '2019-08-20 17:35:24');
INSERT INTO `access_log` VALUES (69519, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:24', 5, 0, '', '2019-08-20 17:35:24');
INSERT INTO `access_log` VALUES (69520, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:24', 11, 0, '', '2019-08-20 17:35:24');
INSERT INTO `access_log` VALUES (69521, '64.85.15662937254658301', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:25', 6, 0, '', '2019-08-20 17:35:25');
INSERT INTO `access_log` VALUES (69522, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:40', 6, 0, '', '2019-08-20 17:35:40');
INSERT INTO `access_log` VALUES (69523, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:40', 8, 0, '', '2019-08-20 17:35:40');
INSERT INTO `access_log` VALUES (69524, '64.82.15662937416448281', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:42', 6, 0, '', '2019-08-20 17:35:42');
INSERT INTO `access_log` VALUES (69525, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:45', 7, 0, '', '2019-08-20 17:35:45');
INSERT INTO `access_log` VALUES (69526, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:45', 9, 0, '', '2019-08-20 17:35:45');
INSERT INTO `access_log` VALUES (69527, '64.81.15662937456168269', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:46', 5, 0, '', '2019-08-20 17:35:46');
INSERT INTO `access_log` VALUES (69528, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:49', 6, 0, '', '2019-08-20 17:35:49');
INSERT INTO `access_log` VALUES (69529, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.37.177.34', '2019-08-20 17:35:49', 7, 0, '', '2019-08-20 17:35:49');
INSERT INTO `access_log` VALUES (69530, '65.46.15662941858011051', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 17:43:06', 1, 1002001015, '账号未登陆', '2019-08-20 17:43:06');
INSERT INTO `access_log` VALUES (69531, '65.45.15662941858011021', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 17:43:06', 1, 1002001015, '账号未登陆', '2019-08-20 17:43:06');
INSERT INTO `access_log` VALUES (69532, '65.52.15662941858031055', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 17:43:06', 0, 1002001015, '账号未登陆', '2019-08-20 17:43:06');
INSERT INTO `access_log` VALUES (69533, '65.50.15662941881461009', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 17:43:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 17:43:08');
INSERT INTO `access_log` VALUES (69534, '65.54.15662941975980907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 17:43:18', 55, 0, '', '2019-08-20 17:43:18');
INSERT INTO `access_log` VALUES (69535, '65.47.15662941981060961', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 17:43:18', 10, 0, '', '2019-08-20 17:43:18');
INSERT INTO `access_log` VALUES (69536, '65.53.15662941981130963', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 17:43:18', 10, 2001001000, '服务端发生异常', '2019-08-20 17:43:18');
INSERT INTO `access_log` VALUES (69537, '65.51.15662941981201069', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 17:43:18', 9, 0, '', '2019-08-20 17:43:18');
INSERT INTO `access_log` VALUES (69538, '65.52.15662942059991057', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 17:43:26', 16, 0, '', '2019-08-20 17:43:26');
INSERT INTO `access_log` VALUES (69539, '65.45.15662942059991023', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 17:43:26', 17, 2001001000, '服务端发生异常', '2019-08-20 17:43:26');
INSERT INTO `access_log` VALUES (69540, '65.46.15662942060181053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 17:43:26', 9, 0, '', '2019-08-20 17:43:26');
INSERT INTO `access_log` VALUES (69541, '59.72.15662944169637913', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.2.115.179', '2019-08-20 17:46:57', 3, 0, '', '2019-08-20 17:46:57');
INSERT INTO `access_log` VALUES (69542, '59.73.15662944169637917', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.2.115.179', '2019-08-20 17:46:57', 39, 2001001000, '服务端发生异常', '2019-08-20 17:46:57');
INSERT INTO `access_log` VALUES (69543, '59.76.15662944227947903', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.2.115.179', '2019-08-20 17:47:03', 3, 0, '', '2019-08-20 17:47:03');
INSERT INTO `access_log` VALUES (69544, '59.80.15662944227997887', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.2.115.179', '2019-08-20 17:47:03', 14, 2001001000, '服务端发生异常', '2019-08-20 17:47:03');
INSERT INTO `access_log` VALUES (69545, '64.84.15662944254628279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.2.115.179', '2019-08-20 17:47:05', 4, 0, '', '2019-08-20 17:47:05');
INSERT INTO `access_log` VALUES (69546, '64.77.15662944255808265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.2.115.179', '2019-08-20 17:47:06', 2, 0, '', '2019-08-20 17:47:06');
INSERT INTO `access_log` VALUES (69547, '64.82.15662944270558291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.2.115.179', '2019-08-20 17:47:07', 2, 0, '', '2019-08-20 17:47:07');
INSERT INTO `access_log` VALUES (69548, '64.81.15662944276798279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.2.115.179', '2019-08-20 17:47:08', 2, 0, '', '2019-08-20 17:47:08');
INSERT INTO `access_log` VALUES (69549, '738e8af9-81c0-4f5e-a451-72de4488fce2', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 17:49:09', 767, 0, '', '2019-08-20 17:49:10');
INSERT INTO `access_log` VALUES (69550, '7d11d0ce-2186-4c00-84a6-5f75405aa7d7', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 17:49:09', 1141, 2001001000, '服务端发生异常', '2019-08-20 17:49:10');
INSERT INTO `access_log` VALUES (69551, 'c7ab7a67-7904-4872-9fcf-a2ff7a4d3a48', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '127.0.0.1', '2019-08-20 17:50:57', 845, 0, '', '2019-08-20 17:50:58');
INSERT INTO `access_log` VALUES (69552, '8ea9ab23-4977-4b95-9f52-adf62f10ad7f', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '127.0.0.1', '2019-08-20 17:50:58', 943, 0, '', '2019-08-20 17:50:59');
INSERT INTO `access_log` VALUES (69553, '75cb0cb6-46ff-4afa-a978-8cb66b2014b9', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17621638086', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '127.0.0.1', '2019-08-20 17:51:16', 734, 0, '', '2019-08-20 17:51:17');
INSERT INTO `access_log` VALUES (69554, '820dd9e1-750f-4f83-9782-9f068f870f85', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17621638086&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '127.0.0.1', '2019-08-20 17:51:36', 572, 0, '', '2019-08-20 17:51:36');
INSERT INTO `access_log` VALUES (69555, '2cd08164-f668-4ff7-b252-b64ce8fadcb9', 208, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '127.0.0.1', '2019-08-20 17:51:40', 1204, 0, '', '2019-08-20 17:51:41');
INSERT INTO `access_log` VALUES (69556, 'c5469ab4-9220-4ff7-8dfb-148fbd071075', 208, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '127.0.0.1', '2019-08-20 17:51:52', 32, 0, '', '2019-08-20 17:51:52');
INSERT INTO `access_log` VALUES (69557, 'fe4181f9-17d7-4597-a78d-a23f0bba3ae6', 208, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '127.0.0.1', '2019-08-20 17:51:52', 41, 0, '', '2019-08-20 17:51:52');
INSERT INTO `access_log` VALUES (69558, '621ff00f-fccf-44e8-bc31-ce07d207a17c', 208, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '127.0.0.1', '2019-08-20 17:51:54', 87, 0, '', '2019-08-20 17:51:54');
INSERT INTO `access_log` VALUES (69559, '2c64f747-66ab-4bd2-a6a6-bf11e3fb7055', 208, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '127.0.0.1', '2019-08-20 17:51:56', 234, 0, '', '2019-08-20 17:51:57');
INSERT INTO `access_log` VALUES (69560, '271e6471-dd00-4b0b-96f7-e593b211f698', 208, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '127.0.0.1', '2019-08-20 17:51:58', 45, 0, '', '2019-08-20 17:51:58');
INSERT INTO `access_log` VALUES (69561, 'd35046d6-529a-47f8-880a-e6b71a6dbb6c', 208, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '127.0.0.1', '2019-08-20 17:56:46', 86, 0, '', '2019-08-20 17:56:46');
INSERT INTO `access_log` VALUES (69562, 'e0f2cf4a-23dc-44c7-ae1f-8c7de5559ee4', 208, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '127.0.0.1', '2019-08-20 17:56:46', 43, 0, '', '2019-08-20 17:56:46');
INSERT INTO `access_log` VALUES (69563, '33ed3099-3014-4b0a-aad1-3759c6aaecb6', 208, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '127.0.0.1', '2019-08-20 17:56:47', 38, 0, '', '2019-08-20 17:56:48');
INSERT INTO `access_log` VALUES (69564, '59.73.15662954027257931', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 18:03:23', 2, 0, '', '2019-08-20 18:03:23');
INSERT INTO `access_log` VALUES (69565, '59.72.15662954027257927', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 18:03:23', 13, 2001001000, '服务端发生异常', '2019-08-20 18:03:23');
INSERT INTO `access_log` VALUES (69566, '59.80.15662954087307901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 18:03:29', 5, 0, '', '2019-08-20 18:03:29');
INSERT INTO `access_log` VALUES (69567, '59.76.15662954087317917', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '59.42.25.65', '2019-08-20 18:03:29', 19, 2001001000, '服务端发生异常', '2019-08-20 18:03:29');
INSERT INTO `access_log` VALUES (69568, '65.53.15662956118050983', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-20 18:06:52', 1, 1002001015, '账号未登陆', '2019-08-20 18:06:52');
INSERT INTO `access_log` VALUES (69569, '65.46.15662956494591073', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-20 18:07:29', 78, 0, '', '2019-08-20 18:07:30');
INSERT INTO `access_log` VALUES (69570, '65.51.15662956851091091', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-20 18:08:05', 79, 0, '', '2019-08-20 18:08:05');
INSERT INTO `access_log` VALUES (69571, '65.46.15662959003841079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-20 18:11:40', 70, 0, '', '2019-08-20 18:11:40');
INSERT INTO `access_log` VALUES (69572, '65.45.15662966523951059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-20 18:24:12', 185, 0, '', '2019-08-20 18:24:13');
INSERT INTO `access_log` VALUES (69573, '65.50.15662966560921045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-20 18:24:16', 68, 0, '', '2019-08-20 18:24:16');
INSERT INTO `access_log` VALUES (69574, '65.50.15662970755731051', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:16', 0, 1002001015, '账号未登陆', '2019-08-20 18:31:16');
INSERT INTO `access_log` VALUES (69575, '65.45.15662970755731065', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:16', 0, 1002001015, '账号未登陆', '2019-08-20 18:31:16');
INSERT INTO `access_log` VALUES (69576, '65.49.15662970755921063', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:16', 0, 1002001015, '账号未登陆', '2019-08-20 18:31:16');
INSERT INTO `access_log` VALUES (69577, '65.54.15662970794610951', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 18:31:19');
INSERT INTO `access_log` VALUES (69578, '65.47.15662970826251003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 18:31:23');
INSERT INTO `access_log` VALUES (69579, '65.51.15662970846791113', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:25', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 18:31:25');
INSERT INTO `access_log` VALUES (69580, '65.3607.15662970872972849', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:27', 4, 1002002001, '密码不正确', '2019-08-20 18:31:27');
INSERT INTO `access_log` VALUES (69581, '65.52.15662970923631101', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 18:31:32');
INSERT INTO `access_log` VALUES (69582, '65.45.15662971084241067', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:48', 97, 0, '', '2019-08-20 18:31:49');
INSERT INTO `access_log` VALUES (69583, '65.50.15662971090071053', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:49', 11, 0, '', '2019-08-20 18:31:49');
INSERT INTO `access_log` VALUES (69584, '65.49.15662971090111065', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:49', 9, 0, '', '2019-08-20 18:31:49');
INSERT INTO `access_log` VALUES (69585, '65.54.15662971090120953', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:49', 10, 2001001000, '服务端发生异常', '2019-08-20 18:31:49');
INSERT INTO `access_log` VALUES (69586, '65.47.15662971136741005', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:54', 9, 0, '', '2019-08-20 18:31:54');
INSERT INTO `access_log` VALUES (69587, '65.53.15662971136791009', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:54', 10, 2001001000, '服务端发生异常', '2019-08-20 18:31:54');
INSERT INTO `access_log` VALUES (69588, '65.51.15662971136871115', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.207.175.100', '2019-08-20 18:31:54', 8, 0, '', '2019-08-20 18:31:54');
INSERT INTO `access_log` VALUES (69589, '59.76.15662973278357943', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:35:28', 10, 0, '', '2019-08-20 18:35:28');
INSERT INTO `access_log` VALUES (69590, '59.80.15662973278367927', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:35:28', 15, 2001001000, '服务端发生异常', '2019-08-20 18:35:28');
INSERT INTO `access_log` VALUES (69591, '64.80.15662973306708319', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:35:31', 12, 0, '', '2019-08-20 18:35:31');
INSERT INTO `access_log` VALUES (69592, '64.78.15662973307918333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:35:31', 3, 0, '', '2019-08-20 18:35:31');
INSERT INTO `access_log` VALUES (69593, '66.51.15662973336345511', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:35:34', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位', '2019-08-20 18:35:34');
INSERT INTO `access_log` VALUES (69594, '66.52.15662973408075485', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15701358931', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:35:41', 95, 0, '', '2019-08-20 18:35:41');
INSERT INTO `access_log` VALUES (69595, '65.54.15662973530020957', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:35:53', 1, 1002001015, '账号未登陆', '2019-08-20 18:35:53');
INSERT INTO `access_log` VALUES (69596, '65.53.15662973530041013', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:35:53', 0, 1002001015, '账号未登陆', '2019-08-20 18:35:53');
INSERT INTO `access_log` VALUES (69597, '65.47.15662973530091009', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:35:53', 0, 1002001015, '账号未登陆', '2019-08-20 18:35:53');
INSERT INTO `access_log` VALUES (69598, '65.3607.15662973629722855', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 18:36:03');
INSERT INTO `access_log` VALUES (69599, '65.46.15662973782531103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:18', 84, 0, '', '2019-08-20 18:36:18');
INSERT INTO `access_log` VALUES (69600, '65.45.15662973785901073', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:19', 17, 0, '', '2019-08-20 18:36:19');
INSERT INTO `access_log` VALUES (69601, '65.49.15662973785911071', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:19', 18, 2001001000, '服务端发生异常', '2019-08-20 18:36:19');
INSERT INTO `access_log` VALUES (69602, '65.50.15662973785971059', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:19', 16, 0, '', '2019-08-20 18:36:19');
INSERT INTO `access_log` VALUES (69603, '66.48.15662973992035483', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15701358931&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:39', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空', '2019-08-20 18:36:39');
INSERT INTO `access_log` VALUES (69604, '66.50.15662974041115489', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15701358931&code=8888', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:44', 9, 1001003003, '验证码不正确', '2019-08-20 18:36:44');
INSERT INTO `access_log` VALUES (69605, '64.76.15662974070528325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:47', 2, 0, '', '2019-08-20 18:36:47');
INSERT INTO `access_log` VALUES (69606, '64.83.15662974073058317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:47', 2, 0, '', '2019-08-20 18:36:47');
INSERT INTO `access_log` VALUES (69607, '59.73.15662974091337959', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:49', 3, 0, '', '2019-08-20 18:36:49');
INSERT INTO `access_log` VALUES (69608, '59.72.15662974091647955', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:49', 10, 2001001000, '服务端发生异常', '2019-08-20 18:36:49');
INSERT INTO `access_log` VALUES (69609, '64.80.15662974112858321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:51', 2, 0, '', '2019-08-20 18:36:51');
INSERT INTO `access_log` VALUES (69610, '64.78.15662974114258335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:51', 2, 0, '', '2019-08-20 18:36:51');
INSERT INTO `access_log` VALUES (69611, '64.85.15662974123428353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:52', 2, 0, '', '2019-08-20 18:36:52');
INSERT INTO `access_log` VALUES (69612, '64.84.15662974129198321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:53', 2, 0, '', '2019-08-20 18:36:53');
INSERT INTO `access_log` VALUES (69613, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=掘金&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:56', 5, 0, '', '2019-08-20 18:36:56');
INSERT INTO `access_log` VALUES (69614, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=掘金', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '119.57.66.106', '2019-08-20 18:36:56', 5, 0, '', '2019-08-20 18:36:56');
INSERT INTO `access_log` VALUES (69615, '59.74.15662976556957975', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:40:56', 3, 0, '', '2019-08-20 18:40:56');
INSERT INTO `access_log` VALUES (69616, '59.75.15662976557007965', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:40:56', 21, 2001001000, '服务端发生异常', '2019-08-20 18:40:56');
INSERT INTO `access_log` VALUES (69617, '64.78.15662976686778339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:09', 2, 0, '', '2019-08-20 18:41:09');
INSERT INTO `access_log` VALUES (69618, '64.85.15662976691218357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:09', 2, 0, '', '2019-08-20 18:41:09');
INSERT INTO `access_log` VALUES (69619, '64.84.15662976717038325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:12', 1, 0, '', '2019-08-20 18:41:12');
INSERT INTO `access_log` VALUES (69620, '64.77.15662976722268311', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:12', 2, 0, '', '2019-08-20 18:41:12');
INSERT INTO `access_log` VALUES (69621, '64.82.15662976739858337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:14', 2, 0, '', '2019-08-20 18:41:14');
INSERT INTO `access_log` VALUES (69622, '64.81.15662976748868325', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:15', 1, 0, '', '2019-08-20 18:41:15');
INSERT INTO `access_log` VALUES (69623, '64.76.15662976754918331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:15', 2, 0, '', '2019-08-20 18:41:15');
INSERT INTO `access_log` VALUES (69624, '64.83.15662976759018323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:16', 2, 0, '', '2019-08-20 18:41:16');
INSERT INTO `access_log` VALUES (69625, '64.79.15662976769618323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:17', 2, 0, '', '2019-08-20 18:41:17');
INSERT INTO `access_log` VALUES (69626, '64.78.15662976809728341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:21', 2, 0, '', '2019-08-20 18:41:21');
INSERT INTO `access_log` VALUES (69627, '64.85.15662976811278359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:21', 1, 0, '', '2019-08-20 18:41:21');
INSERT INTO `access_log` VALUES (69628, '59.76.15662976819827949', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:22', 2, 0, '', '2019-08-20 18:41:22');
INSERT INTO `access_log` VALUES (69629, '59.80.15662976820507933', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:22', 10, 2001001000, '服务端发生异常', '2019-08-20 18:41:22');
INSERT INTO `access_log` VALUES (69630, '59.79.15662976877007961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:28', 13, 2001001000, '服务端发生异常', '2019-08-20 18:41:28');
INSERT INTO `access_log` VALUES (69631, '59.77.15662976885457947', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:29', 2, 0, '', '2019-08-20 18:41:29');
INSERT INTO `access_log` VALUES (69632, '59.78.15662976913807969', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:31', 2, 0, '', '2019-08-20 18:41:31');
INSERT INTO `access_log` VALUES (69633, '59.71.15662976913707959', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:31', 12, 2001001000, '服务端发生异常', '2019-08-20 18:41:31');
INSERT INTO `access_log` VALUES (69634, '64.84.15662976929158327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:33', 2, 0, '', '2019-08-20 18:41:33');
INSERT INTO `access_log` VALUES (69635, '64.77.15662976930958313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:33', 2, 0, '', '2019-08-20 18:41:33');
INSERT INTO `access_log` VALUES (69636, '59.74.15662976943057977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_3_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '117.136.38.140', '2019-08-20 18:41:34', 2, 0, '', '2019-08-20 18:41:34');
INSERT INTO `access_log` VALUES (69637, '59.74.15662988890177993', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.78.106', '2019-08-20 19:01:29', 3, 0, '', '2019-08-20 19:01:29');
INSERT INTO `access_log` VALUES (69638, '59.73.15662988890187981', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.78.106', '2019-08-20 19:01:29', 12, 2001001000, '服务端发生异常', '2019-08-20 19:01:29');
INSERT INTO `access_log` VALUES (69639, '64.81.15662988917328343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.78.106', '2019-08-20 19:01:32', 3, 0, '', '2019-08-20 19:01:32');
INSERT INTO `access_log` VALUES (69640, '64.76.15662988918558349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.78.106', '2019-08-20 19:01:32', 2, 0, '', '2019-08-20 19:01:32');
INSERT INTO `access_log` VALUES (69641, '59.72.15662988934927977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.78.106', '2019-08-20 19:01:33', 2, 0, '', '2019-08-20 19:01:33');
INSERT INTO `access_log` VALUES (69642, '59.76.15662988934927967', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.78.106', '2019-08-20 19:01:33', 9, 2001001000, '服务端发生异常', '2019-08-20 19:01:34');
INSERT INTO `access_log` VALUES (69643, '59.79.15662989083127979', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.206.108.42', '2019-08-20 19:01:48', 2, 0, '', '2019-08-20 19:01:48');
INSERT INTO `access_log` VALUES (69644, '59.77.15662989083137965', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.206.108.42', '2019-08-20 19:01:48', 13, 2001001000, '服务端发生异常', '2019-08-20 19:01:48');
INSERT INTO `access_log` VALUES (69645, '59.75.15662989288107985', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.206.108.42', '2019-08-20 19:02:09', 2, 0, '', '2019-08-20 19:02:09');
INSERT INTO `access_log` VALUES (69646, '59.74.15662989288107995', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.206.108.42', '2019-08-20 19:02:09', 12, 2001001000, '服务端发生异常', '2019-08-20 19:02:09');
INSERT INTO `access_log` VALUES (69647, '65.52.15662989571741129', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.206.108.42', '2019-08-20 19:02:37', 0, 1002001015, '账号未登陆', '2019-08-20 19:02:37');
INSERT INTO `access_log` VALUES (69648, '65.46.15662989571801125', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.206.108.42', '2019-08-20 19:02:37', 0, 1002001015, '账号未登陆', '2019-08-20 19:02:37');
INSERT INTO `access_log` VALUES (69649, '65.49.15662989571881093', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.206.108.42', '2019-08-20 19:02:37', 0, 1002001015, '账号未登陆', '2019-08-20 19:02:37');
INSERT INTO `access_log` VALUES (69650, '65.50.15662989649141081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.206.108.42', '2019-08-20 19:02:45', 111, 0, '', '2019-08-20 19:02:45');
INSERT INTO `access_log` VALUES (69651, '65.54.15662989653030981', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.206.108.42', '2019-08-20 19:02:45', 119, 0, '', '2019-08-20 19:02:45');
INSERT INTO `access_log` VALUES (69652, '65.53.15662989653201037', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.206.108.42', '2019-08-20 19:02:45', 105, 0, '', '2019-08-20 19:02:45');
INSERT INTO `access_log` VALUES (69653, '65.47.15662989653181033', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.206.108.42', '2019-08-20 19:02:45', 106, 2001001000, '服务端发生异常', '2019-08-20 19:02:45');
INSERT INTO `access_log` VALUES (69654, '59.73.15662996773227993', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:14:37', 3, 0, '', '2019-08-20 19:14:37');
INSERT INTO `access_log` VALUES (69655, '59.76.15662996773237979', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:14:37', 10, 2001001000, '服务端发生异常', '2019-08-20 19:14:37');
INSERT INTO `access_log` VALUES (69656, '59.77.15662997081467977', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:08', 2, 0, '', '2019-08-20 19:15:08');
INSERT INTO `access_log` VALUES (69657, '59.79.15662997081437991', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:08', 10, 2001001000, '服务端发生异常', '2019-08-20 19:15:08');
INSERT INTO `access_log` VALUES (69658, '64.84.15662997117358355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:12', 2, 0, '', '2019-08-20 19:15:12');
INSERT INTO `access_log` VALUES (69659, '64.77.15662997118308341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:12', 2, 0, '', '2019-08-20 19:15:12');
INSERT INTO `access_log` VALUES (69660, '64.82.15662997146998367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:15', 2, 0, '', '2019-08-20 19:15:15');
INSERT INTO `access_log` VALUES (69661, '64.81.15662997156848355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:16', 1, 0, '', '2019-08-20 19:15:16');
INSERT INTO `access_log` VALUES (69662, '64.76.15662997172728361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:17', 2, 0, '', '2019-08-20 19:15:17');
INSERT INTO `access_log` VALUES (69663, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:17', 5, 0, '', '2019-08-20 19:15:17');
INSERT INTO `access_log` VALUES (69664, '64.83.15662997186308353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:19', 1, 0, '', '2019-08-20 19:15:19');
INSERT INTO `access_log` VALUES (69665, '64.79.15662997187628353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:19', 2, 0, '', '2019-08-20 19:15:19');
INSERT INTO `access_log` VALUES (69666, '66.56.15662997286405533', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15579872216', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:29', 54, 0, '', '2019-08-20 19:15:29');
INSERT INTO `access_log` VALUES (69667, '59.75.15662997390427997', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.129.6.251', '2019-08-20 19:15:39', 13, 2001001000, '服务端发生异常', '2019-08-20 19:15:39');
INSERT INTO `access_log` VALUES (69668, '59.74.15662997422118007', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.91.60.104', '2019-08-20 19:15:42', 3, 0, '', '2019-08-20 19:15:42');
INSERT INTO `access_log` VALUES (69669, '66.53.15662997430565505', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15579872216&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:43', 465, 0, '', '2019-08-20 19:15:44');
INSERT INTO `access_log` VALUES (69670, '66.50.15662997449285521', 209, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:45', 9, 0, '', '2019-08-20 19:15:45');
INSERT INTO `access_log` VALUES (69671, '66.51.15662997507245545', 209, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:51', 7, 0, '', '2019-08-20 19:15:51');
INSERT INTO `access_log` VALUES (69672, '66.49.15662997511575521', 209, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:51', 5, 0, '', '2019-08-20 19:15:51');
INSERT INTO `access_log` VALUES (69673, '59.80.15662997526097965', 209, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:53', 15, 0, '', '2019-08-20 19:15:53');
INSERT INTO `access_log` VALUES (69674, '59.79.15662997526097993', 209, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:15:53', 24, 2001001000, '服务端发生异常', '2019-08-20 19:15:53');
INSERT INTO `access_log` VALUES (69675, '64.77.15662997739388343', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '58.247.206.141', '2019-08-20 19:16:14', 2, 0, '', '2019-08-20 19:16:14');
INSERT INTO `access_log` VALUES (69676, '64.82.15662997744328369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.151.178.174', '2019-08-20 19:16:14', 2, 0, '', '2019-08-20 19:16:14');
INSERT INTO `access_log` VALUES (69677, '64.81.15662997790948357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.151.207.205', '2019-08-20 19:16:19', 1, 0, '', '2019-08-20 19:16:19');
INSERT INTO `access_log` VALUES (69678, '64.76.15662997799028363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '61.151.178.197', '2019-08-20 19:16:20', 2, 0, '', '2019-08-20 19:16:20');
INSERT INTO `access_log` VALUES (69679, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.89.239.232', '2019-08-20 19:16:21', 5, 0, '', '2019-08-20 19:16:21');
INSERT INTO `access_log` VALUES (69680, '64.78.15662997986418373', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:16:39', 6, 0, '', '2019-08-20 19:16:39');
INSERT INTO `access_log` VALUES (69681, '64.84.15662997987998359', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:16:39', 9, 0, '', '2019-08-20 19:16:39');
INSERT INTO `access_log` VALUES (69682, '64.77.15662998002068345', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:16:40', 6, 0, '', '2019-08-20 19:16:40');
INSERT INTO `access_log` VALUES (69683, 'N/A', 209, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:16:40', 12, 0, '', '2019-08-20 19:16:40');
INSERT INTO `access_log` VALUES (69684, '64.81.15662998018058359', 209, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:16:42', 11, 0, '', '2019-08-20 19:16:42');
INSERT INTO `access_log` VALUES (69685, '66.57.15662998060535523', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.129.6.159', '2019-08-20 19:16:46', 1, 1002001015, '账号未登陆', '2019-08-20 19:16:46');
INSERT INTO `access_log` VALUES (69686, '64.76.15662998066518365', 209, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:16:47', 11, 0, '', '2019-08-20 19:16:47');
INSERT INTO `access_log` VALUES (69687, '66.50.15662998152245523', 209, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:16:55', 7, 0, '', '2019-08-20 19:16:55');
INSERT INTO `access_log` VALUES (69688, '66.51.15662998199515547', 209, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:17:00', 5, 0, '', '2019-08-20 19:17:00');
INSERT INTO `access_log` VALUES (69689, '66.54.15662998490095541', 209, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:17:29', 6, 0, '', '2019-08-20 19:17:29');
INSERT INTO `access_log` VALUES (69690, '66.56.15662998497945537', 209, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '101.231.252.114', '2019-08-20 19:17:30', 6, 0, '', '2019-08-20 19:17:30');
INSERT INTO `access_log` VALUES (69691, '64.85.15662998569848393', 209, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:37', 11, 0, '', '2019-08-20 19:17:37');
INSERT INTO `access_log` VALUES (69692, '64.84.15662998621558361', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:42', 4, 0, '', '2019-08-20 19:17:42');
INSERT INTO `access_log` VALUES (69693, 'N/A', 209, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:42', 15, 0, '', '2019-08-20 19:17:42');
INSERT INTO `access_log` VALUES (69694, '64.77.15662998644448347', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '58.247.206.146', '2019-08-20 19:17:44', 8, 0, '', '2019-08-20 19:17:44');
INSERT INTO `access_log` VALUES (69695, '64.82.15662998650408373', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:45', 7, 0, '', '2019-08-20 19:17:45');
INSERT INTO `access_log` VALUES (69696, '64.81.15662998651398361', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:45', 5, 0, '', '2019-08-20 19:17:45');
INSERT INTO `access_log` VALUES (69697, '64.76.15662998676658367', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:48', 8, 0, '', '2019-08-20 19:17:48');
INSERT INTO `access_log` VALUES (69698, '64.79.15662998682008359', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:48', 5, 0, '', '2019-08-20 19:17:48');
INSERT INTO `access_log` VALUES (69699, '64.80.15662998690328361', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:49', 4, 0, '', '2019-08-20 19:17:49');
INSERT INTO `access_log` VALUES (69700, '64.78.15662998692078377', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:49', 5, 0, '', '2019-08-20 19:17:49');
INSERT INTO `access_log` VALUES (69701, '64.85.15662998695868395', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:50', 5, 0, '', '2019-08-20 19:17:50');
INSERT INTO `access_log` VALUES (69702, '64.84.15662998698238363', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:50', 5, 0, '', '2019-08-20 19:17:50');
INSERT INTO `access_log` VALUES (69703, '64.77.15662998701438349', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:50', 6, 0, '', '2019-08-20 19:17:50');
INSERT INTO `access_log` VALUES (69704, '59.80.15662998739777967', 209, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:54', 22, 0, '', '2019-08-20 19:17:54');
INSERT INTO `access_log` VALUES (69705, '59.79.15662998739807995', 209, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:54', 22, 2001001000, '服务端发生异常', '2019-08-20 19:17:54');
INSERT INTO `access_log` VALUES (69706, '66.48.15662998747615519', 209, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:55', 69, 0, '', '2019-08-20 19:17:55');
INSERT INTO `access_log` VALUES (69707, '66.50.15662998752555525', 0, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.89.239.238', '2019-08-20 19:17:55', 2, 0, '', '2019-08-20 19:17:55');
INSERT INTO `access_log` VALUES (69708, '64.81.15662998769598363', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:57', 5, 0, '', '2019-08-20 19:17:57');
INSERT INTO `access_log` VALUES (69709, '64.76.15662998770538369', 209, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:57', 5, 0, '', '2019-08-20 19:17:57');
INSERT INTO `access_log` VALUES (69710, '59.78.15662998776298003', 209, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:58', 5, 0, '', '2019-08-20 19:17:58');
INSERT INTO `access_log` VALUES (69711, '59.77.15662998776297981', 209, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.231.252.114', '2019-08-20 19:17:58', 14, 2001001000, '服务端发生异常', '2019-08-20 19:17:58');
INSERT INTO `access_log` VALUES (69712, '66.55.15662998807795505', 0, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.89.19.197', '2019-08-20 19:18:01', 2, 0, '', '2019-08-20 19:18:01');
INSERT INTO `access_log` VALUES (69713, '65.3607.15663022798042923', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.205.209.238', '2019-08-20 19:58:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 19:58:00');
INSERT INTO `access_log` VALUES (69714, '65.49.15663022939331139', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.205.209.238', '2019-08-20 19:58:14', 57, 0, '', '2019-08-20 19:58:14');
INSERT INTO `access_log` VALUES (69715, '65.52.15663022943761175', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.205.209.238', '2019-08-20 19:58:14', 104, 0, '', '2019-08-20 19:58:14');
INSERT INTO `access_log` VALUES (69716, '65.50.15663022943851127', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.205.209.238', '2019-08-20 19:58:14', 98, 0, '', '2019-08-20 19:58:14');
INSERT INTO `access_log` VALUES (69717, '65.45.15663022943811141', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.205.209.238', '2019-08-20 19:58:14', 102, 2001001000, '服务端发生异常', '2019-08-20 19:58:14');
INSERT INTO `access_log` VALUES (69718, '59.74.15663031918758055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.107.216.233', '2019-08-20 20:13:12', 15, 0, '', '2019-08-20 20:13:12');
INSERT INTO `access_log` VALUES (69719, '59.75.15663031918748045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.107.216.233', '2019-08-20 20:13:12', 15, 2001001000, '服务端发生异常', '2019-08-20 20:13:12');
INSERT INTO `access_log` VALUES (69720, '64.79.15663031975798405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.107.216.233', '2019-08-20 20:13:18', 11, 0, '', '2019-08-20 20:13:18');
INSERT INTO `access_log` VALUES (69721, '64.80.15663031977098407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.107.216.233', '2019-08-20 20:13:18', 3, 0, '', '2019-08-20 20:13:18');
INSERT INTO `access_log` VALUES (69722, '64.85.15663032018138441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.107.216.233', '2019-08-20 20:13:22', 2, 0, '', '2019-08-20 20:13:22');
INSERT INTO `access_log` VALUES (69723, '64.84.15663032019288409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.107.216.233', '2019-08-20 20:13:22', 1, 0, '', '2019-08-20 20:13:22');
INSERT INTO `access_log` VALUES (69724, '59.72.15663032057408039', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.107.216.233', '2019-08-20 20:13:26', 3, 0, '', '2019-08-20 20:13:26');
INSERT INTO `access_log` VALUES (69725, '59.73.15663032057398043', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.107.216.233', '2019-08-20 20:13:26', 15, 2001001000, '服务端发生异常', '2019-08-20 20:13:26');
INSERT INTO `access_log` VALUES (69726, '64.77.15663035037528399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.107.216.233', '2019-08-20 20:18:24', 3, 0, '', '2019-08-20 20:18:24');
INSERT INTO `access_log` VALUES (69727, '64.82.15663035038568425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.107.216.233', '2019-08-20 20:18:24', 2, 0, '', '2019-08-20 20:18:24');
INSERT INTO `access_log` VALUES (69728, '66.52.15663035153975571', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13422220000&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.107.216.233', '2019-08-20 20:18:35', 16, 1001003000, '验证码不存在', '2019-08-20 20:18:35');
INSERT INTO `access_log` VALUES (69729, '66.56.15663035208345587', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13422220000&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.107.216.233', '2019-08-20 20:18:41', 7, 1001003000, '验证码不存在', '2019-08-20 20:18:41');
INSERT INTO `access_log` VALUES (69730, '66.57.15663035232195575', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13422220000', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.107.216.233', '2019-08-20 20:18:43', 93, 0, '', '2019-08-20 20:18:43');
INSERT INTO `access_log` VALUES (69731, '66.53.15663035293975559', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13426469491', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.107.216.233', '2019-08-20 20:18:49', 90, 0, '', '2019-08-20 20:18:49');
INSERT INTO `access_log` VALUES (69732, '65.3607.15663065619552981', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '183.17.56.242', '2019-08-20 21:09:22', 1, 1002001015, '账号未登陆', '2019-08-20 21:09:22');
INSERT INTO `access_log` VALUES (69733, '65.46.15663065619561229', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.116.72.3', '2019-08-20 21:09:22', 1, 1002001015, '账号未登陆', '2019-08-20 21:09:22');
INSERT INTO `access_log` VALUES (69734, '65.49.15663065619821197', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.116.72.3', '2019-08-20 21:09:22', 1, 1002001015, '账号未登陆', '2019-08-20 21:09:22');
INSERT INTO `access_log` VALUES (69735, '65.54.15663065989111085', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.116.72.3', '2019-08-20 21:09:59', 90, 0, '', '2019-08-20 21:09:59');
INSERT INTO `access_log` VALUES (69736, '65.47.15663065992201137', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.116.72.3', '2019-08-20 21:09:59', 21, 0, '', '2019-08-20 21:09:59');
INSERT INTO `access_log` VALUES (69737, '65.51.15663065992201247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '183.17.56.242', '2019-08-20 21:09:59', 20, 0, '', '2019-08-20 21:09:59');
INSERT INTO `access_log` VALUES (69738, '65.53.15663065992201141', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.116.72.3', '2019-08-20 21:09:59', 22, 2001001000, '服务端发生异常', '2019-08-20 21:09:59');
INSERT INTO `access_log` VALUES (69739, '65.46.15663066123311231', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.116.72.3', '2019-08-20 21:10:12', 9, 0, '', '2019-08-20 21:10:12');
INSERT INTO `access_log` VALUES (69740, '65.3607.15663066123322983', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '183.17.56.242', '2019-08-20 21:10:12', 10, 2001001000, '服务端发生异常', '2019-08-20 21:10:12');
INSERT INTO `access_log` VALUES (69741, '65.45.15663066123361201', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '183.17.56.242', '2019-08-20 21:10:12', 8, 0, '', '2019-08-20 21:10:12');
INSERT INTO `access_log` VALUES (69742, '65.52.15663066278171235', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.129.7.235', '2019-08-20 21:10:28', 0, 1002001015, '账号未登陆', '2019-08-20 21:10:28');
INSERT INTO `access_log` VALUES (69743, '65.54.15663066307721087', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.151.207.205', '2019-08-20 21:10:31', 1, 1002001015, '账号未登陆', '2019-08-20 21:10:31');
INSERT INTO `access_log` VALUES (69744, '65.53.15663066401651143', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.6.151', '2019-08-20 21:10:40', 0, 1002001015, '账号未登陆', '2019-08-20 21:10:40');
INSERT INTO `access_log` VALUES (69745, '59.77.15663078696748089', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:10', 18, 0, '', '2019-08-20 21:31:10');
INSERT INTO `access_log` VALUES (69746, '59.79.15663078696748103', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:10', 26, 2001001000, '服务端发生异常', '2019-08-20 21:31:10');
INSERT INTO `access_log` VALUES (69747, '64.76.15663078739248477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:14', 130, 0, '', '2019-08-20 21:31:14');
INSERT INTO `access_log` VALUES (69748, '64.83.15663078741958469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:14', 3, 0, '', '2019-08-20 21:31:14');
INSERT INTO `access_log` VALUES (69749, '64.79.15663078754688469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:15', 2, 0, '', '2019-08-20 21:31:15');
INSERT INTO `access_log` VALUES (69750, '64.80.15663078760908471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:16', 2, 0, '', '2019-08-20 21:31:16');
INSERT INTO `access_log` VALUES (69751, '59.78.15663078775798111', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:18', 3, 0, '', '2019-08-20 21:31:18');
INSERT INTO `access_log` VALUES (69752, '59.71.15663078775808101', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:18', 17, 2001001000, '服务端发生异常', '2019-08-20 21:31:18');
INSERT INTO `access_log` VALUES (69753, '59.74.15663078879798119', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:28', 8, 0, '', '2019-08-20 21:31:28');
INSERT INTO `access_log` VALUES (69754, '59.76.15663078879798093', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:28', 21, 2001001000, '服务端发生异常', '2019-08-20 21:31:28');
INSERT INTO `access_log` VALUES (69755, '65.45.15663078948771219', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:35', 0, 1002001015, '账号未登陆', '2019-08-20 21:31:35');
INSERT INTO `access_log` VALUES (69756, '65.46.15663078948781249', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:35', 0, 1002001015, '账号未登陆', '2019-08-20 21:31:35');
INSERT INTO `access_log` VALUES (69757, '65.50.15663078948801205', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:35', 0, 1002001015, '账号未登陆', '2019-08-20 21:31:35');
INSERT INTO `access_log` VALUES (69758, '65.54.15663079005911105', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 21:31:41');
INSERT INTO `access_log` VALUES (69759, '65.47.15663079085811157', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:49', 82, 0, '', '2019-08-20 21:31:49');
INSERT INTO `access_log` VALUES (69760, '65.53.15663079089691161', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:49', 9, 0, '', '2019-08-20 21:31:49');
INSERT INTO `access_log` VALUES (69761, '65.51.15663079089721267', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:49', 10, 2001001000, '服务端发生异常', '2019-08-20 21:31:49');
INSERT INTO `access_log` VALUES (69762, '65.49.15663079089811219', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '120.85.78.204', '2019-08-20 21:31:49', 9, 0, '', '2019-08-20 21:31:49');
INSERT INTO `access_log` VALUES (69763, '86fe828d-f96c-4de0-a4a5-e07ef3064bab', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-20 21:32:11', 3606, 0, '', '2019-08-20 21:32:16');
INSERT INTO `access_log` VALUES (69764, '86fe828d-f96c-4de0-a4a5-e07ef3064bab', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-20 21:32:11', 3606, 0, '', '2019-08-20 21:32:15');
INSERT INTO `access_log` VALUES (69765, 'c6ce79a6-24f8-440b-9644-d3f4136c1c53', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-20 21:32:11', 5086, 0, '', '2019-08-20 21:32:16');
INSERT INTO `access_log` VALUES (69766, '5d102904-8b20-45b0-a5d8-c0e1db33e55d', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:10', 644, 0, '', '2019-08-20 21:33:10');
INSERT INTO `access_log` VALUES (69767, '6dfb9796-275f-4912-8688-2e0d8b149eec', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:10', 21, 0, '', '2019-08-20 21:33:10');
INSERT INTO `access_log` VALUES (69768, 'b5e60612-01a8-417a-ad34-f14abad9d9a3', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:12', 26, 0, '', '2019-08-20 21:33:12');
INSERT INTO `access_log` VALUES (69769, '310eec8c-3435-459f-913f-a783fa98b99f', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:12', 410, 0, '', '2019-08-20 21:33:13');
INSERT INTO `access_log` VALUES (69770, 'cc42b676-3e4e-4ad4-99b7-dc0f710af334', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:16', 445, 0, '', '2019-08-20 21:33:16');
INSERT INTO `access_log` VALUES (69771, 'a635065c-5668-416b-ac5e-fd4e64997747', 0, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:17', 297, 0, '', '2019-08-20 21:33:17');
INSERT INTO `access_log` VALUES (69772, 'bcf1ef81-bf31-46f2-b335-0391d91bd0df', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:24', 91, 0, '', '2019-08-20 21:33:24');
INSERT INTO `access_log` VALUES (69773, '08109de8-9905-45d6-8291-d5827695f573', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:24', 33, 0, '', '2019-08-20 21:33:24');
INSERT INTO `access_log` VALUES (69774, 'eba61b56-a4ae-430a-9ffa-4830ca9dd0d9', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:26', 130, 0, '', '2019-08-20 21:33:26');
INSERT INTO `access_log` VALUES (69775, 'a0132410-8c0a-451c-aeb3-4c3f0b2bce2a', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:27', 21, 0, '', '2019-08-20 21:33:27');
INSERT INTO `access_log` VALUES (69776, '72096aa6-01e5-4f89-b80c-68a3d78eeb44', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:28', 22, 0, '', '2019-08-20 21:33:28');
INSERT INTO `access_log` VALUES (69777, 'c6921fd9-3ca5-489e-91e6-a6480dca72a4', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:29', 30, 0, '', '2019-08-20 21:33:29');
INSERT INTO `access_log` VALUES (69778, 'bcebbd3c-4add-478c-a0cf-0dd7935801f5', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:30', 90, 0, '', '2019-08-20 21:33:30');
INSERT INTO `access_log` VALUES (69779, '20d510bc-c8ab-45ec-b132-715b62da59bc', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:30', 23, 0, '', '2019-08-20 21:33:30');
INSERT INTO `access_log` VALUES (69780, 'fb86b2b3-9000-4f7c-9159-a1dd4abb09bb', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:31', 22, 0, '', '2019-08-20 21:33:31');
INSERT INTO `access_log` VALUES (69781, 'd946bdf6-48b0-4040-9da0-bebe693c285b', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:31', 30, 0, '', '2019-08-20 21:33:31');
INSERT INTO `access_log` VALUES (69782, 'ed8774f7-a842-40e5-b497-2271886fd2d4', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:34', 33, 0, '', '2019-08-20 21:33:34');
INSERT INTO `access_log` VALUES (69783, '2408861f-0407-4d2d-94a8-198a04863312', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:34', 21, 0, '', '2019-08-20 21:33:34');
INSERT INTO `access_log` VALUES (69784, '0d1dd8ad-c030-4d7c-8d35-c69b6260b030', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:35', 110, 0, '', '2019-08-20 21:33:35');
INSERT INTO `access_log` VALUES (69785, 'b5bed093-9978-4eb6-9838-af45c2b4ed1f', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:36', 341, 0, '', '2019-08-20 21:33:36');
INSERT INTO `access_log` VALUES (69786, '03db95d8-ba37-477e-b6c3-9160f537e528', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:37', 58, 0, '', '2019-08-20 21:33:37');
INSERT INTO `access_log` VALUES (69787, '58a0b85d-0b46-4fbe-bc72-2987df1a91e7', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:37', 90, 0, '', '2019-08-20 21:33:37');
INSERT INTO `access_log` VALUES (69788, '8ab2cfc7-ee6a-4dae-9d4e-a9217d08de44', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:39', 22, 0, '', '2019-08-20 21:33:39');
INSERT INTO `access_log` VALUES (69789, '6058ff9c-5bb7-47da-83e5-68a992f5c1fe', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-20 21:33:39', 23, 0, '', '2019-08-20 21:33:39');
INSERT INTO `access_log` VALUES (69790, '4803f40e-1335-46ae-9e70-3be45164bdf4', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-20 21:33:54', 22, 0, '', '2019-08-20 21:33:54');
INSERT INTO `access_log` VALUES (69791, 'a1d60776-ff88-442b-aced-3866bf5058a7', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-20 21:34:56', 111, 0, '', '2019-08-20 21:34:56');
INSERT INTO `access_log` VALUES (69792, 'a4dfb451-2fbd-42bb-97d5-6be0e7d3fdc9', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-20 21:34:56', 136, 0, '', '2019-08-20 21:34:56');
INSERT INTO `access_log` VALUES (69793, '5b36cc0d-d2df-4254-b4c7-d5c7600f7629', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-20 23:01:01', 560, 0, '', '2019-08-20 23:01:02');
INSERT INTO `access_log` VALUES (69794, '5a0bb4c6-0b7c-47a9-9579-82459272b127', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-20 23:01:02', 296, 0, '', '2019-08-20 23:01:03');
INSERT INTO `access_log` VALUES (69795, '5016628d-3094-4b35-9dac-bba07d512995', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-20 23:01:02', 355, 0, '', '2019-08-20 23:01:03');
INSERT INTO `access_log` VALUES (69796, '454be33c-b071-4161-bba7-5309b6744770', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-20 23:01:02', 326, 0, '', '2019-08-20 23:01:03');
INSERT INTO `access_log` VALUES (69797, 'b330caa6-2ddf-453d-a487-de5291455ab5', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-20 23:01:12', 782, 0, '', '2019-08-20 23:01:12');
INSERT INTO `access_log` VALUES (69798, '34ea43e3-cad9-4e07-92a0-2d0f0990b554', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-20 23:01:28', 200, 0, '', '2019-08-20 23:01:28');
INSERT INTO `access_log` VALUES (69799, '65.54.15663148909951199', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.120.163.102', '2019-08-20 23:28:11', 0, 1002001015, '账号未登陆', '2019-08-20 23:28:11');
INSERT INTO `access_log` VALUES (69800, '65.49.15663148909951313', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.120.163.102', '2019-08-20 23:28:11', 0, 1002001015, '账号未登陆', '2019-08-20 23:28:11');
INSERT INTO `access_log` VALUES (69801, '65.50.15663148909961301', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.120.163.102', '2019-08-20 23:28:11', 0, 1002001015, '账号未登陆', '2019-08-20 23:28:11');
INSERT INTO `access_log` VALUES (69802, '65.52.15663148926471347', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.120.163.102', '2019-08-20 23:28:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-20 23:28:13');
INSERT INTO `access_log` VALUES (69803, '65.51.15663149048911363', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.120.163.102', '2019-08-20 23:28:25', 123, 0, '', '2019-08-20 23:28:25');
INSERT INTO `access_log` VALUES (69804, '65.53.15663149053071257', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.120.163.102', '2019-08-20 23:28:25', 11, 0, '', '2019-08-20 23:28:25');
INSERT INTO `access_log` VALUES (69805, '65.46.15663149053111347', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.120.163.102', '2019-08-20 23:28:25', 11, 2001001000, '服务端发生异常', '2019-08-20 23:28:25');
INSERT INTO `access_log` VALUES (69806, '65.45.15663149053131317', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.120.163.102', '2019-08-20 23:28:25', 10, 0, '', '2019-08-20 23:28:25');
INSERT INTO `access_log` VALUES (69807, '65.47.15663149104051253', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.120.163.102', '2019-08-20 23:28:30', 9, 0, '', '2019-08-20 23:28:30');
INSERT INTO `access_log` VALUES (69808, '65.50.15663149104061303', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.120.163.102', '2019-08-20 23:28:30', 12, 2001001000, '服务端发生异常', '2019-08-20 23:28:30');
INSERT INTO `access_log` VALUES (69809, '65.49.15663149104131315', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.120.163.102', '2019-08-20 23:28:30', 10, 0, '', '2019-08-20 23:28:30');
INSERT INTO `access_log` VALUES (69810, '65.54.15663149123341201', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.120.163.102', '2019-08-20 23:28:32', 9, 0, '', '2019-08-20 23:28:32');
INSERT INTO `access_log` VALUES (69811, '65.52.15663149123341349', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.120.163.102', '2019-08-20 23:28:32', 11, 2001001000, '服务端发生异常', '2019-08-20 23:28:32');
INSERT INTO `access_log` VALUES (69812, '65.3607.15663149123373101', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.120.163.102', '2019-08-20 23:28:32', 9, 0, '', '2019-08-20 23:28:32');
INSERT INTO `access_log` VALUES (69813, '65.3607.15663492603083559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:01:00', 171, 0, '', '2019-08-21 09:01:00');
INSERT INTO `access_log` VALUES (69814, '65.50.15663493048721765', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:01:45', 70, 0, '', '2019-08-21 09:01:45');
INSERT INTO `access_log` VALUES (69815, '65.51.15663496102551831', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:06:50', 8, 1002001012, '访问令牌已过期', '2019-08-21 09:06:50');
INSERT INTO `access_log` VALUES (69816, '65.46.15663496102561811', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:06:50', 9, 1002001012, '访问令牌已过期', '2019-08-21 09:06:50');
INSERT INTO `access_log` VALUES (69817, '65.53.15663496102561725', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:06:50', 9, 1002001012, '访问令牌已过期', '2019-08-21 09:06:50');
INSERT INTO `access_log` VALUES (69818, '65.52.15663496185181815', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:06:59', 111, 0, '', '2019-08-21 09:06:59');
INSERT INTO `access_log` VALUES (69819, '65.3607.15663496190263565', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:06:59', 25, 0, '', '2019-08-21 09:06:59');
INSERT INTO `access_log` VALUES (69820, '65.54.15663496190321667', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:06:59', 23, 2001001000, '服务端发生异常', '2019-08-21 09:06:59');
INSERT INTO `access_log` VALUES (69821, '65.45.15663496190371787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:06:59', 22, 0, '', '2019-08-21 09:06:59');
INSERT INTO `access_log` VALUES (69822, '65.50.15663496304531771', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:07:10', 98, 0, '', '2019-08-21 09:07:11');
INSERT INTO `access_log` VALUES (69823, '65.51.15663496308371833', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:07:11', 9, 0, '', '2019-08-21 09:07:11');
INSERT INTO `access_log` VALUES (69824, '65.46.15663496308411813', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:07:11', 10, 2001001000, '服务端发生异常', '2019-08-21 09:07:11');
INSERT INTO `access_log` VALUES (69825, '65.53.15663496308451727', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:07:11', 9, 0, '', '2019-08-21 09:07:11');
INSERT INTO `access_log` VALUES (69826, '65.49.15663496384611785', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:07:18', 84, 0, '', '2019-08-21 09:07:19');
INSERT INTO `access_log` VALUES (69827, '65.52.15663496388371817', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:07:19', 9, 0, '', '2019-08-21 09:07:19');
INSERT INTO `access_log` VALUES (69828, '65.3607.15663496388433567', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:07:19', 10, 2001001000, '服务端发生异常', '2019-08-21 09:07:19');
INSERT INTO `access_log` VALUES (69829, '65.54.15663496388471669', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 09:07:19', 10, 0, '', '2019-08-21 09:07:19');
INSERT INTO `access_log` VALUES (69830, '65.49.15663507528581801', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.5', '2019-08-21 09:25:53', 1, 1002001015, '账号未登陆', '2019-08-21 09:25:53');
INSERT INTO `access_log` VALUES (69831, '65.52.15663507528601833', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.5', '2019-08-21 09:25:53', 0, 1002001015, '账号未登陆', '2019-08-21 09:25:53');
INSERT INTO `access_log` VALUES (69832, '65.54.15663507528621685', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.5', '2019-08-21 09:25:53', 0, 1002001015, '账号未登陆', '2019-08-21 09:25:53');
INSERT INTO `access_log` VALUES (69833, '65.45.15663507609591805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.5', '2019-08-21 09:26:01', 74, 0, '', '2019-08-21 09:26:01');
INSERT INTO `access_log` VALUES (69834, '65.47.15663507612351739', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.5', '2019-08-21 09:26:01', 10, 0, '', '2019-08-21 09:26:01');
INSERT INTO `access_log` VALUES (69835, '65.50.15663507612351789', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.5', '2019-08-21 09:26:01', 11, 2001001000, '服务端发生异常', '2019-08-21 09:26:01');
INSERT INTO `access_log` VALUES (69836, '65.51.15663507612391851', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.5', '2019-08-21 09:26:01', 9, 0, '', '2019-08-21 09:26:01');
INSERT INTO `access_log` VALUES (69837, '65.46.15663507743271831', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.5', '2019-08-21 09:26:14', 10, 0, '', '2019-08-21 09:26:14');
INSERT INTO `access_log` VALUES (69838, '65.54.15663507743291687', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.5', '2019-08-21 09:26:14', 9, 0, '', '2019-08-21 09:26:14');
INSERT INTO `access_log` VALUES (69839, '65.52.15663507743271835', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.5', '2019-08-21 09:26:14', 12, 2001001000, '服务端发生异常', '2019-08-21 09:26:14');
INSERT INTO `access_log` VALUES (69840, '65.49.15663507839051803', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.5', '2019-08-21 09:26:24', 10, 0, '', '2019-08-21 09:26:24');
INSERT INTO `access_log` VALUES (69841, '65.3607.15663507839063585', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.5', '2019-08-21 09:26:24', 10, 2001001000, '服务端发生异常', '2019-08-21 09:26:24');
INSERT INTO `access_log` VALUES (69842, '65.45.15663507839091807', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '116.22.197.5', '2019-08-21 09:26:24', 9, 0, '', '2019-08-21 09:26:24');
INSERT INTO `access_log` VALUES (69843, '65.54.15663518688101703', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '59.41.160.28', '2019-08-21 09:44:29', 0, 1002001015, '账号未登陆', '2019-08-21 09:44:29');
INSERT INTO `access_log` VALUES (69844, '65.53.15663518688101761', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '59.41.160.28', '2019-08-21 09:44:29', 0, 1002001015, '账号未登陆', '2019-08-21 09:44:29');
INSERT INTO `access_log` VALUES (69845, '65.52.15663518688201851', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '59.41.160.28', '2019-08-21 09:44:29', 0, 1002001015, '账号未登陆', '2019-08-21 09:44:29');
INSERT INTO `access_log` VALUES (69846, '65.47.15663518852221757', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '59.41.160.28', '2019-08-21 09:44:45', 99, 0, '', '2019-08-21 09:44:45');
INSERT INTO `access_log` VALUES (69847, '65.3607.15663519124793601', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '59.41.160.28', '2019-08-21 09:45:12', 90, 0, '', '2019-08-21 09:45:13');
INSERT INTO `access_log` VALUES (69848, '65.50.15663519128991807', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '59.41.160.28', '2019-08-21 09:45:13', 10, 0, '', '2019-08-21 09:45:13');
INSERT INTO `access_log` VALUES (69849, '65.51.15663519129001869', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '59.41.160.28', '2019-08-21 09:45:13', 10, 2001001000, '服务端发生异常', '2019-08-21 09:45:13');
INSERT INTO `access_log` VALUES (69850, '65.52.15663519129041853', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '59.41.160.28', '2019-08-21 09:45:13', 9, 0, '', '2019-08-21 09:45:13');
INSERT INTO `access_log` VALUES (69851, '59.77.15663521849868681', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:49:45', 16, 0, '', '2019-08-21 09:49:45');
INSERT INTO `access_log` VALUES (69852, '59.79.15663521849868695', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:49:45', 32, 2001001000, '服务端发生异常', '2019-08-21 09:49:45');
INSERT INTO `access_log` VALUES (69853, '64.76.15663521953259069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:49:55', 12, 0, '', '2019-08-21 09:49:55');
INSERT INTO `access_log` VALUES (69854, '64.83.15663521954539061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:49:55', 6, 0, '', '2019-08-21 09:49:55');
INSERT INTO `access_log` VALUES (69855, '65.51.15663521964561873', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:49:56', 1, 1002001015, '账号未登陆', '2019-08-21 09:49:56');
INSERT INTO `access_log` VALUES (69856, '65.54.15663521964561709', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:49:56', 8, 1002001015, '账号未登陆', '2019-08-21 09:49:56');
INSERT INTO `access_log` VALUES (69857, '65.53.15663521964561767', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:49:56', 8, 1002001015, '账号未登陆', '2019-08-21 09:49:56');
INSERT INTO `access_log` VALUES (69858, '64.79.15663521965239061', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:49:57', 3, 0, '', '2019-08-21 09:49:57');
INSERT INTO `access_log` VALUES (69859, '64.80.15663521971789063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:49:57', 2, 0, '', '2019-08-21 09:49:57');
INSERT INTO `access_log` VALUES (69860, '64.78.15663521976429079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:49:58', 2, 0, '', '2019-08-21 09:49:58');
INSERT INTO `access_log` VALUES (69861, '65.46.15663522001381853', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:50:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 09:50:00');
INSERT INTO `access_log` VALUES (69862, '65.49.15663522185561825', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:50:19', 113, 0, '', '2019-08-21 09:50:19');
INSERT INTO `access_log` VALUES (69863, '65.45.15663522189641829', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:50:19', 10, 0, '', '2019-08-21 09:50:19');
INSERT INTO `access_log` VALUES (69864, '65.3607.15663522189683607', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:50:19', 9, 2001001000, '服务端发生异常', '2019-08-21 09:50:19');
INSERT INTO `access_log` VALUES (69865, '65.52.15663522189721859', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '192.168.20.211', '2019-08-21 09:50:19', 9, 0, '', '2019-08-21 09:50:19');
INSERT INTO `access_log` VALUES (69866, '59.76.15663525484718689', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '218.88.22.49', '2019-08-21 09:55:48', 3, 0, '', '2019-08-21 09:55:48');
INSERT INTO `access_log` VALUES (69867, '59.72.15663525484728699', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '218.88.22.49', '2019-08-21 09:55:48', 15, 2001001000, '服务端发生异常', '2019-08-21 09:55:48');
INSERT INTO `access_log` VALUES (69868, '59.74.15663532532658725', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.61.126', '2019-08-21 10:07:33', 5, 0, '', '2019-08-21 10:07:33');
INSERT INTO `access_log` VALUES (69869, '59.76.15663532532658699', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.61.126', '2019-08-21 10:07:33', 24, 2001001000, '服务端发生异常', '2019-08-21 10:07:33');
INSERT INTO `access_log` VALUES (69870, '64.84.15663532627459079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.61.126', '2019-08-21 10:07:43', 3, 0, '', '2019-08-21 10:07:43');
INSERT INTO `access_log` VALUES (69871, '64.77.15663532628329065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.61.126', '2019-08-21 10:07:43', 2, 0, '', '2019-08-21 10:07:43');
INSERT INTO `access_log` VALUES (69872, '65.50.15663555052911855', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:45:05', 0, 1002001015, '账号未登陆', '2019-08-21 10:45:05');
INSERT INTO `access_log` VALUES (69873, '65.46.15663555052921897', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:45:05', 0, 1002001015, '账号未登陆', '2019-08-21 10:45:05');
INSERT INTO `access_log` VALUES (69874, '65.51.15663555053111921', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:45:05', 0, 1002001015, '账号未登陆', '2019-08-21 10:45:05');
INSERT INTO `access_log` VALUES (69875, '65.47.15663555296621809', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:45:30', 83, 0, '', '2019-08-21 10:45:30');
INSERT INTO `access_log` VALUES (69876, '65.49.15663555299821873', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:45:30', 11, 0, '', '2019-08-21 10:45:30');
INSERT INTO `access_log` VALUES (69877, '65.53.15663555299841815', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:45:30', 11, 0, '', '2019-08-21 10:45:30');
INSERT INTO `access_log` VALUES (69878, '65.3607.15663555299843655', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:45:30', 13, 2001001000, '服务端发生异常', '2019-08-21 10:45:30');
INSERT INTO `access_log` VALUES (69879, '65.46.15663555481441899', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:45:48', 10, 0, '', '2019-08-21 10:45:48');
INSERT INTO `access_log` VALUES (69880, '65.50.15663555481491857', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:45:48', 10, 2001001000, '服务端发生异常', '2019-08-21 10:45:48');
INSERT INTO `access_log` VALUES (69881, '65.51.15663555481521923', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:45:48', 9, 0, '', '2019-08-21 10:45:48');
INSERT INTO `access_log` VALUES (69882, '65.52.15663555550651909', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:45:55', 9, 0, '', '2019-08-21 10:45:55');
INSERT INTO `access_log` VALUES (69883, '65.47.15663555550671811', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:45:55', 9, 2001001000, '服务端发生异常', '2019-08-21 10:45:55');
INSERT INTO `access_log` VALUES (69884, '65.49.15663555550701875', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:45:55', 8, 0, '', '2019-08-21 10:45:55');
INSERT INTO `access_log` VALUES (69885, '65.53.15663555596311817', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:46:00', 9, 0, '', '2019-08-21 10:46:00');
INSERT INTO `access_log` VALUES (69886, '65.45.15663555596371879', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:46:00', 9, 0, '', '2019-08-21 10:46:00');
INSERT INTO `access_log` VALUES (69887, '65.3607.15663555596363657', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:46:00', 11, 2001001000, '服务端发生异常', '2019-08-21 10:46:00');
INSERT INTO `access_log` VALUES (69888, '65.51.15663555656431925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:46:06', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 10:46:06');
INSERT INTO `access_log` VALUES (69889, '65.54.15663555911431759', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:46:31', 70, 0, '', '2019-08-21 10:46:31');
INSERT INTO `access_log` VALUES (69890, '65.52.15663555913961911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:46:31', 9, 0, '', '2019-08-21 10:46:31');
INSERT INTO `access_log` VALUES (69891, '65.49.15663555913951877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:46:31', 10, 2001001000, '服务端发生异常', '2019-08-21 10:46:31');
INSERT INTO `access_log` VALUES (69892, '65.47.15663555913951813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:46:31', 9, 0, '', '2019-08-21 10:46:31');
INSERT INTO `access_log` VALUES (69893, '65.51.15663556353221927', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:47:15', 8, 0, '', '2019-08-21 10:47:15');
INSERT INTO `access_log` VALUES (69894, '65.46.15663556353251903', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:47:15', 8, 2001001000, '服务端发生异常', '2019-08-21 10:47:15');
INSERT INTO `access_log` VALUES (69895, '65.50.15663556353321861', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.124.16.83', '2019-08-21 10:47:15', 7, 0, '', '2019-08-21 10:47:15');
INSERT INTO `access_log` VALUES (69896, '59.77.15663565987408741', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.110.202', '2019-08-21 11:03:19', 12, 0, '', '2019-08-21 11:03:19');
INSERT INTO `access_log` VALUES (69897, '59.79.15663565987418755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.110.202', '2019-08-21 11:03:19', 17, 2001001000, '服务端发生异常', '2019-08-21 11:03:19');
INSERT INTO `access_log` VALUES (69898, '64.83.15663566070519121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.110.202', '2019-08-21 11:03:27', 13, 0, '', '2019-08-21 11:03:27');
INSERT INTO `access_log` VALUES (69899, '64.79.15663566072099121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.110.202', '2019-08-21 11:03:27', 4, 0, '', '2019-08-21 11:03:27');
INSERT INTO `access_log` VALUES (69900, '64.80.15663566085679123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.38.110.202', '2019-08-21 11:03:29', 2, 0, '', '2019-08-21 11:03:29');
INSERT INTO `access_log` VALUES (69901, '65.54.15663574195851785', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:00', 1, 1002001015, '账号未登陆', '2019-08-21 11:17:00');
INSERT INTO `access_log` VALUES (69902, '65.51.15663574195851951', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:00', 1, 1002001015, '账号未登陆', '2019-08-21 11:17:00');
INSERT INTO `access_log` VALUES (69903, '65.49.15663574195871903', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:00', 0, 1002001015, '账号未登陆', '2019-08-21 11:17:00');
INSERT INTO `access_log` VALUES (69904, '65.47.15663574219801839', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:02', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 11:17:02');
INSERT INTO `access_log` VALUES (69905, '65.3607.15663574298353685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:10', 70, 0, '', '2019-08-21 11:17:10');
INSERT INTO `access_log` VALUES (69906, '65.53.15663574303081845', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:10', 10, 0, '', '2019-08-21 11:17:10');
INSERT INTO `access_log` VALUES (69907, '65.45.15663574303081907', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:10', 10, 0, '', '2019-08-21 11:17:10');
INSERT INTO `access_log` VALUES (69908, '65.46.15663574303171929', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:10', 9, 0, '', '2019-08-21 11:17:10');
INSERT INTO `access_log` VALUES (69909, '64.76.15663574513989141', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:31', 21, 0, '', '2019-08-21 11:17:31');
INSERT INTO `access_log` VALUES (69910, '64.83.15663574514039133', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:31', 17, 0, '', '2019-08-21 11:17:31');
INSERT INTO `access_log` VALUES (69911, '64.78.15663574556649151', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:36', 11, 0, '', '2019-08-21 11:17:36');
INSERT INTO `access_log` VALUES (69912, '64.80.15663574556599135', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:36', 20, 0, '', '2019-08-21 11:17:36');
INSERT INTO `access_log` VALUES (69913, '64.84.15663574704509137', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:50', 10, 0, '', '2019-08-21 11:17:50');
INSERT INTO `access_log` VALUES (69914, '64.85.15663574704489169', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:50', 12, 0, '', '2019-08-21 11:17:50');
INSERT INTO `access_log` VALUES (69915, '64.82.15663574733139149', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:17:53', 10, 0, '', '2019-08-21 11:17:53');
INSERT INTO `access_log` VALUES (69916, '64.81.15663574848889135', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:18:05', 9, 0, '', '2019-08-21 11:18:05');
INSERT INTO `access_log` VALUES (69917, '64.78.15663575018829153', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:18:22', 16, 0, '', '2019-08-21 11:18:22');
INSERT INTO `access_log` VALUES (69918, '64.79.15663575018799135', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:18:22', 21, 0, '', '2019-08-21 11:18:22');
INSERT INTO `access_log` VALUES (69919, '62.80.15663575420557489', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:19:02', 81, 0, '', '2019-08-21 11:19:02');
INSERT INTO `access_log` VALUES (69920, '66.51.15663575623936319', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:19:22', 21, 0, '', '2019-08-21 11:19:22');
INSERT INTO `access_log` VALUES (69921, '59.72.15663575689598767', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:19:29', 16, 0, '', '2019-08-21 11:19:29');
INSERT INTO `access_log` VALUES (69922, '59.73.15663575725488771', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:19:33', 30, 2001001000, '服务端发生异常', '2019-08-21 11:19:33');
INSERT INTO `access_log` VALUES (69923, '59.77.15663575766238755', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:19:37', 16, 0, '', '2019-08-21 11:19:37');
INSERT INTO `access_log` VALUES (69924, '64.81.15663575838249137', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:19:44', 11, 0, '', '2019-08-21 11:19:44');
INSERT INTO `access_log` VALUES (69925, '65.54.15663576097331789', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:20:10', 8, 0, '', '2019-08-21 11:20:10');
INSERT INTO `access_log` VALUES (69926, '65.51.15663576097471955', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:20:10', 9, 0, '', '2019-08-21 11:20:10');
INSERT INTO `access_log` VALUES (69927, '65.47.15663576097471843', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:20:10', 8, 0, '', '2019-08-21 11:20:10');
INSERT INTO `access_log` VALUES (69928, '66.56.15663576098566309', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:20:10', 13, 0, '', '2019-08-21 11:20:10');
INSERT INTO `access_log` VALUES (69929, '65.3607.15663576309423689', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:20:31', 24, 0, '', '2019-08-21 11:20:31');
INSERT INTO `access_log` VALUES (69930, '65.53.15663576363771849', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:20:36', 20, 0, '', '2019-08-21 11:20:36');
INSERT INTO `access_log` VALUES (69931, '65.46.15663576423071933', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:20:42', 10, 0, '', '2019-08-21 11:20:42');
INSERT INTO `access_log` VALUES (69932, '65.49.15663576591441909', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:20:59', 16, 0, '', '2019-08-21 11:20:59');
INSERT INTO `access_log` VALUES (69933, '65.47.15663576613281845', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:21:01', 11, 0, '', '2019-08-21 11:21:01');
INSERT INTO `access_log` VALUES (69934, '65.51.15663576636121957', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:21:04', 11, 0, '', '2019-08-21 11:21:04');
INSERT INTO `access_log` VALUES (69935, '65.54.15663576662481791', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:21:06', 13, 0, '', '2019-08-21 11:21:06');
INSERT INTO `access_log` VALUES (69936, '59.73.15663576812238773', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:21:21', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-21 11:21:21');
INSERT INTO `access_log` VALUES (69937, '59.80.15663576844918743', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:21:24', 16, 0, '', '2019-08-21 11:21:25');
INSERT INTO `access_log` VALUES (69938, '59.79.15663576947408771', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-21 11:21:35', 27, 2001001000, '服务端发生异常', '2019-08-21 11:21:35');
INSERT INTO `access_log` VALUES (69939, '59.73.15663580881288779', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.78.106', '2019-08-21 11:28:08', 9, 2001001000, '服务端发生异常', '2019-08-21 11:28:08');
INSERT INTO `access_log` VALUES (69940, '59.80.15663580881628749', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.78.106', '2019-08-21 11:28:08', 3, 0, '', '2019-08-21 11:28:08');
INSERT INTO `access_log` VALUES (69941, '65.47.15663587190491861', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 11:38:39', 4, 1002001012, '访问令牌已过期', '2019-08-21 11:38:39');
INSERT INTO `access_log` VALUES (69942, '65.54.15663587190491805', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 11:38:39', 4, 1002001012, '访问令牌已过期', '2019-08-21 11:38:39');
INSERT INTO `access_log` VALUES (69943, '65.3607.15663587190503707', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 11:38:39', 4, 1002001012, '访问令牌已过期', '2019-08-21 11:38:39');
INSERT INTO `access_log` VALUES (69944, '65.45.15663587412491927', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.28.107', '2019-08-21 11:39:01', 4, 1002001012, '访问令牌已过期', '2019-08-21 11:39:01');
INSERT INTO `access_log` VALUES (69945, '65.46.15663587412541951', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.28.107', '2019-08-21 11:39:01', 3, 1002001012, '访问令牌已过期', '2019-08-21 11:39:01');
INSERT INTO `access_log` VALUES (69946, '65.50.15663587412571909', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.28.107', '2019-08-21 11:39:01', 3, 1002001012, '访问令牌已过期', '2019-08-21 11:39:01');
INSERT INTO `access_log` VALUES (69947, '65.51.15663587451721975', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.28.107', '2019-08-21 11:39:05', 161, 0, '', '2019-08-21 11:39:05');
INSERT INTO `access_log` VALUES (69948, '65.49.15663587455791925', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.28.107', '2019-08-21 11:39:06', 10, 0, '', '2019-08-21 11:39:06');
INSERT INTO `access_log` VALUES (69949, '65.52.15663587455821959', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.28.107', '2019-08-21 11:39:06', 9, 2001001000, '服务端发生异常', '2019-08-21 11:39:06');
INSERT INTO `access_log` VALUES (69950, '65.3607.15663587455833709', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.28.107', '2019-08-21 11:39:06', 8, 0, '', '2019-08-21 11:39:06');
INSERT INTO `access_log` VALUES (69951, '65.53.15663587661741867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.28.107', '2019-08-21 11:39:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 11:39:26');
INSERT INTO `access_log` VALUES (69952, '65.45.15663587762131929', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.28.107', '2019-08-21 11:39:36', 150, 0, '', '2019-08-21 11:39:36');
INSERT INTO `access_log` VALUES (69953, '65.46.15663587765711953', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.28.107', '2019-08-21 11:39:37', 9, 0, '', '2019-08-21 11:39:37');
INSERT INTO `access_log` VALUES (69954, '65.50.15663587765741911', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.28.107', '2019-08-21 11:39:37', 9, 2001001000, '服务端发生异常', '2019-08-21 11:39:37');
INSERT INTO `access_log` VALUES (69955, '65.51.15663587765761977', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.28.107', '2019-08-21 11:39:37', 8, 0, '', '2019-08-21 11:39:37');
INSERT INTO `access_log` VALUES (69956, '65.54.15663593581821817', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 11:49:18', 144, 0, '', '2019-08-21 11:49:18');
INSERT INTO `access_log` VALUES (69957, '65.45.15663593589471939', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 11:49:19', 73, 0, '', '2019-08-21 11:49:19');
INSERT INTO `access_log` VALUES (69958, '65.47.15663593589321873', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 11:49:19', 86, 0, '', '2019-08-21 11:49:19');
INSERT INTO `access_log` VALUES (69959, '65.53.15663593589431877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 11:49:19', 79, 2001001000, '服务端发生异常', '2019-08-21 11:49:19');
INSERT INTO `access_log` VALUES (69960, '65.50.15663595052031923', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 11:51:45', 1, 1002001015, '账号未登陆', '2019-08-21 11:51:45');
INSERT INTO `access_log` VALUES (69961, '65.3607.15663595265633723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 11:52:07', 62, 0, '', '2019-08-21 11:52:07');
INSERT INTO `access_log` VALUES (69962, '65.49.15663595315451937', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 11:52:12', 0, 1002001015, '账号未登陆', '2019-08-21 11:52:12');
INSERT INTO `access_log` VALUES (69963, '65.54.15663595330831821', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 11:52:13', 1, 1002001015, '账号未登陆', '2019-08-21 11:52:13');
INSERT INTO `access_log` VALUES (69964, '65.47.15663595337631877', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 11:52:14', 0, 1002001015, '账号未登陆', '2019-08-21 11:52:14');
INSERT INTO `access_log` VALUES (69965, '65.45.15663595340851943', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 11:52:14', 0, 1002001015, '账号未登陆', '2019-08-21 11:52:14');
INSERT INTO `access_log` VALUES (69966, '65.53.15663595348681881', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 11:52:15', 0, 1002001015, '账号未登陆', '2019-08-21 11:52:15');
INSERT INTO `access_log` VALUES (69967, '62.81.15663616384637495', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'createBeginTime=&createEndTime=&hasRefund=&orderSubject=&pageNo=1&pageSize=10&payChannel=&paymentBeginTime=&paymentEndTime=&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '203.18.50.4', '2019-08-21 12:27:18', 1, 1002001015, '账号未登陆', '2019-08-21 12:27:18');
INSERT INTO `access_log` VALUES (69968, '65.49.15663677437442047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 14:09:04', 85, 0, '', '2019-08-21 14:09:04');
INSERT INTO `access_log` VALUES (69969, '65.54.15663677442181933', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 14:09:04', 133, 0, '', '2019-08-21 14:09:04');
INSERT INTO `access_log` VALUES (69970, '65.47.15663677442231985', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 14:09:04', 132, 2001001000, '服务端发生异常', '2019-08-21 14:09:04');
INSERT INTO `access_log` VALUES (69971, '65.45.15663677442312055', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 14:09:04', 123, 0, '', '2019-08-21 14:09:04');
INSERT INTO `access_log` VALUES (69972, '65.50.15663677719072037', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 14:09:32', 5, 1002002001, '密码不正确', '2019-08-21 14:09:32');
INSERT INTO `access_log` VALUES (69973, '59.73.15663678169108909', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 14:10:17', 11, 0, '', '2019-08-21 14:10:17');
INSERT INTO `access_log` VALUES (69974, '59.80.15663678169118879', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 14:10:17', 25, 2001001000, '服务端发生异常', '2019-08-21 14:10:17');
INSERT INTO `access_log` VALUES (69975, '59.71.15663678251718905', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 14:10:25', 17, 2001001000, '服务端发生异常', '2019-08-21 14:10:25');
INSERT INTO `access_log` VALUES (69976, '59.79.15663678251708907', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 14:10:25', 31, 0, '', '2019-08-21 14:10:25');
INSERT INTO `access_log` VALUES (69977, '64.79.15663678297439273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 14:10:30', 10, 0, '', '2019-08-21 14:10:30');
INSERT INTO `access_log` VALUES (69978, '64.80.15663678298589275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Safari/537.36', '39.71.148.205', '2019-08-21 14:10:30', 3, 0, '', '2019-08-21 14:10:30');
INSERT INTO `access_log` VALUES (69979, '65.49.15663679726462051', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:12:53', 1, 1002001015, '账号未登陆', '2019-08-21 14:12:53');
INSERT INTO `access_log` VALUES (69980, '65.54.15663679726561937', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:12:53', 0, 1002001015, '账号未登陆', '2019-08-21 14:12:53');
INSERT INTO `access_log` VALUES (69981, '65.45.15663679726652059', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:12:53', 0, 1002001015, '账号未登陆', '2019-08-21 14:12:53');
INSERT INTO `access_log` VALUES (69982, '65.53.15663679760731993', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:12:56', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 14:12:56');
INSERT INTO `access_log` VALUES (69983, '65.51.15663679834552103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:13:03', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 14:13:03');
INSERT INTO `access_log` VALUES (69984, '65.46.15663679905862081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:13:11', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 14:13:11');
INSERT INTO `access_log` VALUES (69985, '65.3607.15663679922113841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:13:12', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 14:13:12');
INSERT INTO `access_log` VALUES (69986, '65.49.15663680076302053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:13:28', 74, 0, '', '2019-08-21 14:13:28');
INSERT INTO `access_log` VALUES (69987, '65.54.15663680081691939', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:13:28', 9, 0, '', '2019-08-21 14:13:28');
INSERT INTO `access_log` VALUES (69988, '65.45.15663680081802061', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:13:28', 9, 2001001000, '服务端发生异常', '2019-08-21 14:13:28');
INSERT INTO `access_log` VALUES (69989, '65.47.15663680081901991', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:13:28', 10, 0, '', '2019-08-21 14:13:28');
INSERT INTO `access_log` VALUES (69990, '65.3607.15663680652873843', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:14:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 14:14:25');
INSERT INTO `access_log` VALUES (69991, '65.52.15663680774372089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:14:37', 109, 0, '', '2019-08-21 14:14:38');
INSERT INTO `access_log` VALUES (69992, '65.49.15663680778682055', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:14:38', 9, 0, '', '2019-08-21 14:14:38');
INSERT INTO `access_log` VALUES (69993, '65.54.15663680778771941', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:14:38', 16, 0, '', '2019-08-21 14:14:38');
INSERT INTO `access_log` VALUES (69994, '65.45.15663680778782063', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:14:38', 16, 0, '', '2019-08-21 14:14:38');
INSERT INTO `access_log` VALUES (69995, '62.86.15663680822597609', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:14:42', 33, 0, '', '2019-08-21 14:14:42');
INSERT INTO `access_log` VALUES (69996, '62.89.15663680938487625', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:14:54', 22, 0, '', '2019-08-21 14:14:54');
INSERT INTO `access_log` VALUES (69997, '62.80.15663681003107631', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:15:00', 16, 0, '', '2019-08-21 14:15:00');
INSERT INTO `access_log` VALUES (69998, '64.79.15663681039469277', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:15:04', 16, 0, '', '2019-08-21 14:15:04');
INSERT INTO `access_log` VALUES (69999, '64.80.15663681039519279', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:15:04', 12, 0, '', '2019-08-21 14:15:04');
INSERT INTO `access_log` VALUES (70000, '64.84.15663681121539281', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:15:12', 9, 0, '', '2019-08-21 14:15:12');
INSERT INTO `access_log` VALUES (70001, '64.85.15663681121539313', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:15:12', 12, 0, '', '2019-08-21 14:15:12');
INSERT INTO `access_log` VALUES (70002, '59.78.15663681259768919', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3676.400 QQBrowser/10.4.3505.400', '113.235.116.42', '2019-08-21 14:15:26', 14, 0, '', '2019-08-21 14:15:26');
INSERT INTO `access_log` VALUES (70003, '65.45.15663695243512083', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:38:44', 0, 1002001015, '账号未登陆', '2019-08-21 14:38:44');
INSERT INTO `access_log` VALUES (70004, '65.49.15663695243502075', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:38:44', 0, 1002001015, '账号未登陆', '2019-08-21 14:38:44');
INSERT INTO `access_log` VALUES (70005, '65.54.15663695243501961', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:38:44', 0, 1002001015, '账号未登陆', '2019-08-21 14:38:44');
INSERT INTO `access_log` VALUES (70006, '65.47.15663695279812013', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:38:48', 310, 0, '', '2019-08-21 14:38:48');
INSERT INTO `access_log` VALUES (70007, '65.53.15663695285332017', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:38:49', 10, 0, '', '2019-08-21 14:38:49');
INSERT INTO `access_log` VALUES (70008, '65.51.15663695285352127', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:38:49', 10, 2001001000, '服务端发生异常', '2019-08-21 14:38:49');
INSERT INTO `access_log` VALUES (70009, '65.50.15663695285392065', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:38:49', 8, 0, '', '2019-08-21 14:38:49');
INSERT INTO `access_log` VALUES (70010, '65.3607.15663695410213865', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:39:01', 10, 0, '', '2019-08-21 14:39:01');
INSERT INTO `access_log` VALUES (70011, '65.52.15663695410242111', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:39:01', 10, 2001001000, '服务端发生异常', '2019-08-21 14:39:01');
INSERT INTO `access_log` VALUES (70012, '65.45.15663695410282085', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:39:01', 9, 0, '', '2019-08-21 14:39:01');
INSERT INTO `access_log` VALUES (70013, '65.54.15663695499631963', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:39:10', 9, 0, '', '2019-08-21 14:39:10');
INSERT INTO `access_log` VALUES (70014, '65.47.15663695499652015', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:39:10', 11, 2001001000, '服务端发生异常', '2019-08-21 14:39:10');
INSERT INTO `access_log` VALUES (70015, '65.51.15663695499672129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:39:10', 16, 0, '', '2019-08-21 14:39:10');
INSERT INTO `access_log` VALUES (70016, '65.50.15663695539982067', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:39:14', 9, 0, '', '2019-08-21 14:39:14');
INSERT INTO `access_log` VALUES (70017, '65.53.15663695540002019', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:39:14', 10, 2001001000, '服务端发生异常', '2019-08-21 14:39:14');
INSERT INTO `access_log` VALUES (70018, '65.46.15663695540032107', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.126.141.238', '2019-08-21 14:39:14', 9, 0, '', '2019-08-21 14:39:14');
INSERT INTO `access_log` VALUES (70019, '59.72.15663696646768931', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.160.17.218', '2019-08-21 14:41:05', 4, 0, '', '2019-08-21 14:41:05');
INSERT INTO `access_log` VALUES (70020, '59.80.15663696646778905', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.160.17.218', '2019-08-21 14:41:05', 13, 2001001000, '服务端发生异常', '2019-08-21 14:41:05');
INSERT INTO `access_log` VALUES (70021, '65.46.15663696782432109', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.160.17.218', '2019-08-21 14:41:18', 1, 1002001015, '账号未登陆', '2019-08-21 14:41:18');
INSERT INTO `access_log` VALUES (70022, '65.53.15663696782422021', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.160.17.218', '2019-08-21 14:41:18', 1, 1002001015, '账号未登陆', '2019-08-21 14:41:18');
INSERT INTO `access_log` VALUES (70023, '65.45.15663696782442089', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.160.17.218', '2019-08-21 14:41:18', 0, 1002001015, '账号未登陆', '2019-08-21 14:41:18');
INSERT INTO `access_log` VALUES (70024, '65.3607.15663696808453869', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.160.17.218', '2019-08-21 14:41:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 14:41:21');
INSERT INTO `access_log` VALUES (70025, '65.49.15663696882082081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.160.17.218', '2019-08-21 14:41:28', 64, 0, '', '2019-08-21 14:41:28');
INSERT INTO `access_log` VALUES (70026, '65.51.15663696885972133', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.160.17.218', '2019-08-21 14:41:29', 9, 0, '', '2019-08-21 14:41:29');
INSERT INTO `access_log` VALUES (70027, '65.47.15663696885972019', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.160.17.218', '2019-08-21 14:41:29', 10, 2001001000, '服务端发生异常', '2019-08-21 14:41:29');
INSERT INTO `access_log` VALUES (70028, '65.54.15663696886021967', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '124.160.17.218', '2019-08-21 14:41:29', 9, 0, '', '2019-08-21 14:41:29');
INSERT INTO `access_log` VALUES (70029, '65.50.15663720986572103', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:21:39', 0, 1002001015, '账号未登陆', '2019-08-21 15:21:39');
INSERT INTO `access_log` VALUES (70030, '65.46.15663720986582143', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:21:39', 1, 1002001015, '账号未登陆', '2019-08-21 15:21:39');
INSERT INTO `access_log` VALUES (70031, '65.45.15663720986732123', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:21:39', 3, 1002001015, '账号未登陆', '2019-08-21 15:21:39');
INSERT INTO `access_log` VALUES (70032, '65.3607.15663721007923903', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:21:41', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 15:21:41');
INSERT INTO `access_log` VALUES (70033, '65.52.15663721078542149', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:21:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 15:21:48');
INSERT INTO `access_log` VALUES (70034, '65.49.15663721137572115', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:21:54', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 15:21:54');
INSERT INTO `access_log` VALUES (70035, '65.47.15663721147402053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:21:55', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 15:21:55');
INSERT INTO `access_log` VALUES (70036, '65.51.15663721155272167', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:21:56', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 15:21:56');
INSERT INTO `access_log` VALUES (70037, '65.53.15663721158212057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:21:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 15:21:56');
INSERT INTO `access_log` VALUES (70038, '65.45.15663721160752125', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:21:56', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 15:21:56');
INSERT INTO `access_log` VALUES (70039, '65.50.15663721163552105', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:21:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 15:21:56');
INSERT INTO `access_log` VALUES (70040, '59.74.15663721571318981', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:22:37', 12, 0, '', '2019-08-21 15:22:37');
INSERT INTO `access_log` VALUES (70041, '59.76.15663721571318955', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:22:37', 24, 2001001000, '服务端发生异常', '2019-08-21 15:22:37');
INSERT INTO `access_log` VALUES (70042, '64.82.15663721642439347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:22:44', 10, 0, '', '2019-08-21 15:22:44');
INSERT INTO `access_log` VALUES (70043, '64.81.15663721643349333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:22:44', 3, 0, '', '2019-08-21 15:22:44');
INSERT INTO `access_log` VALUES (70044, '64.83.15663721668789333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:22:47', 2, 0, '', '2019-08-21 15:22:47');
INSERT INTO `access_log` VALUES (70045, '64.76.15663721675559341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:22:48', 2, 0, '', '2019-08-21 15:22:48');
INSERT INTO `access_log` VALUES (70046, '64.78.15663721685539351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:22:49', 2, 0, '', '2019-08-21 15:22:49');
INSERT INTO `access_log` VALUES (70047, '59.80.15663721714638939', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:22:51', 4, 0, '', '2019-08-21 15:22:51');
INSERT INTO `access_log` VALUES (70048, '59.73.15663721714638969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:22:51', 18, 2001001000, '服务端发生异常', '2019-08-21 15:22:51');
INSERT INTO `access_log` VALUES (70049, '64.80.15663721739319335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:22:54', 2, 0, '', '2019-08-21 15:22:54');
INSERT INTO `access_log` VALUES (70050, '64.77.15663721740209323', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:22:54', 3, 0, '', '2019-08-21 15:22:54');
INSERT INTO `access_log` VALUES (70051, '66.49.15663721768706491', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:22:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空', '2019-08-21 15:22:57');
INSERT INTO `access_log` VALUES (70052, '64.84.15663721845279337', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:23:05', 2, 0, '', '2019-08-21 15:23:05');
INSERT INTO `access_log` VALUES (70053, '64.85.15663721846289369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:23:05', 2, 0, '', '2019-08-21 15:23:05');
INSERT INTO `access_log` VALUES (70054, '64.81.15663721860599335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:23:06', 1, 0, '', '2019-08-21 15:23:06');
INSERT INTO `access_log` VALUES (70055, '64.83.15663721867229335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.239.103.77', '2019-08-21 15:23:07', 2, 0, '', '2019-08-21 15:23:07');
INSERT INTO `access_log` VALUES (70056, '65.46.15663753303452189', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:15:30', 14, 1002002001, '密码不正确', '2019-08-21 16:15:30');
INSERT INTO `access_log` VALUES (70057, '65.45.15663753530362169', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=yudaoyuanma&username=yudaoyuanma', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:15:53', 83, 0, '', '2019-08-21 16:15:53');
INSERT INTO `access_log` VALUES (70058, '65.51.15663754612612215', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:17:41', 3, 1002001012, '访问令牌已过期', '2019-08-21 16:17:41');
INSERT INTO `access_log` VALUES (70059, '65.45.15663754612612171', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:17:41', 5, 1002001012, '访问令牌已过期', '2019-08-21 16:17:41');
INSERT INTO `access_log` VALUES (70060, '65.52.15663754612852199', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:17:41', 11, 1002001012, '访问令牌已过期', '2019-08-21 16:17:41');
INSERT INTO `access_log` VALUES (70061, '65.49.15663754673412163', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:17:47', 100, 0, '', '2019-08-21 16:17:47');
INSERT INTO `access_log` VALUES (70062, '65.54.15663754676882049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:17:48', 11, 0, '', '2019-08-21 16:17:48');
INSERT INTO `access_log` VALUES (70063, '65.3607.15663754676883951', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:17:48', 11, 0, '', '2019-08-21 16:17:48');
INSERT INTO `access_log` VALUES (70064, '65.47.15663754676872099', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:17:48', 12, 2001001000, '服务端发生异常', '2019-08-21 16:17:48');
INSERT INTO `access_log` VALUES (70065, '65.46.15663754951202193', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:18:15', 7, 0, '', '2019-08-21 16:18:15');
INSERT INTO `access_log` VALUES (70066, '65.45.15663754951432173', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:18:15', 8, 0, '', '2019-08-21 16:18:15');
INSERT INTO `access_log` VALUES (70067, '65.51.15663754951422217', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:18:15', 8, 2001001000, '服务端发生异常', '2019-08-21 16:18:15');
INSERT INTO `access_log` VALUES (70068, '65.52.15663754997322201', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:18:20', 9, 0, '', '2019-08-21 16:18:20');
INSERT INTO `access_log` VALUES (70069, '65.49.15663754997352165', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:18:20', 9, 2001001000, '服务端发生异常', '2019-08-21 16:18:20');
INSERT INTO `access_log` VALUES (70070, '65.3607.15663754997383953', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.148.13.144', '2019-08-21 16:18:20', 8, 0, '', '2019-08-21 16:18:20');
INSERT INTO `access_log` VALUES (70071, '59.71.15663768453149027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:40:45', 11, 0, '', '2019-08-21 16:40:45');
INSERT INTO `access_log` VALUES (70072, '59.79.15663768453149029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:40:45', 24, 2001001000, '服务端发生异常', '2019-08-21 16:40:45');
INSERT INTO `access_log` VALUES (70073, '64.82.15663768577719411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:40:58', 11, 0, '', '2019-08-21 16:40:58');
INSERT INTO `access_log` VALUES (70074, '64.81.15663768579489399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:40:58', 3, 0, '', '2019-08-21 16:40:58');
INSERT INTO `access_log` VALUES (70075, '59.75.15663768593729035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:40:59', 3, 0, '', '2019-08-21 16:40:59');
INSERT INTO `access_log` VALUES (70076, '59.74.15663768593729045', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:40:59', 13, 2001001000, '服务端发生异常', '2019-08-21 16:40:59');
INSERT INTO `access_log` VALUES (70077, '64.76.15663768750669407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:15', 2, 0, '', '2019-08-21 16:41:15');
INSERT INTO `access_log` VALUES (70078, '64.80.15663768752459401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:15', 1, 0, '', '2019-08-21 16:41:15');
INSERT INTO `access_log` VALUES (70079, '64.79.15663768768859399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:17', 1, 0, '', '2019-08-21 16:41:17');
INSERT INTO `access_log` VALUES (70080, '64.77.15663768773969387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:17', 11, 0, '', '2019-08-21 16:41:17');
INSERT INTO `access_log` VALUES (70081, '59.72.15663768783219029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:18', 2, 0, '', '2019-08-21 16:41:18');
INSERT INTO `access_log` VALUES (70082, '59.80.15663768783429003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:18', 35, 2001001000, '服务端发生异常', '2019-08-21 16:41:18');
INSERT INTO `access_log` VALUES (70083, '64.84.15663768809329403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:21', 2, 0, '', '2019-08-21 16:41:21');
INSERT INTO `access_log` VALUES (70084, '64.85.15663768810999435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:21', 2, 0, '', '2019-08-21 16:41:21');
INSERT INTO `access_log` VALUES (70085, '64.82.15663768850189413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:25', 2, 0, '', '2019-08-21 16:41:25');
INSERT INTO `access_log` VALUES (70086, '64.81.15663768851759401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:25', 2, 0, '', '2019-08-21 16:41:25');
INSERT INTO `access_log` VALUES (70087, '59.77.15663768861189017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:26', 3, 0, '', '2019-08-21 16:41:26');
INSERT INTO `access_log` VALUES (70088, '59.79.15663768861199031', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:26', 13, 2001001000, '服务端发生异常', '2019-08-21 16:41:26');
INSERT INTO `access_log` VALUES (70089, '64.83.15663768867619401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:27', 2, 0, '', '2019-08-21 16:41:27');
INSERT INTO `access_log` VALUES (70090, '64.76.15663768869539409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:27', 2, 0, '', '2019-08-21 16:41:27');
INSERT INTO `access_log` VALUES (70091, '59.71.15663768887279029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:29', 2, 0, '', '2019-08-21 16:41:29');
INSERT INTO `access_log` VALUES (70092, '59.78.15663768888719039', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:29', 21, 2001001000, '服务端发生异常', '2019-08-21 16:41:29');
INSERT INTO `access_log` VALUES (70093, '64.80.15663768893919403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:29', 2, 0, '', '2019-08-21 16:41:29');
INSERT INTO `access_log` VALUES (70094, '64.79.15663768895199401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:30', 2, 0, '', '2019-08-21 16:41:30');
INSERT INTO `access_log` VALUES (70095, '59.75.15663768898569037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:30', 2, 0, '', '2019-08-21 16:41:30');
INSERT INTO `access_log` VALUES (70096, '59.74.15663768898569047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:41:30', 12, 2001001000, '服务端发生异常', '2019-08-21 16:41:30');
INSERT INTO `access_log` VALUES (70097, '65.52.15663769587612221', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:42:39', 0, 1002001015, '账号未登陆', '2019-08-21 16:42:39');
INSERT INTO `access_log` VALUES (70098, '65.49.15663769587642185', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:42:39', 1, 1002001015, '账号未登陆', '2019-08-21 16:42:39');
INSERT INTO `access_log` VALUES (70099, '65.3607.15663769587663973', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:42:39', 0, 1002001015, '账号未登陆', '2019-08-21 16:42:39');
INSERT INTO `access_log` VALUES (70100, '65.47.15663769673552121', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:42:47', 84, 0, '', '2019-08-21 16:42:47');
INSERT INTO `access_log` VALUES (70101, '65.53.15663769676632127', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:42:48', 172, 0, '', '2019-08-21 16:42:48');
INSERT INTO `access_log` VALUES (70102, '65.51.15663769676822239', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:42:48', 156, 0, '', '2019-08-21 16:42:48');
INSERT INTO `access_log` VALUES (70103, '65.50.15663769676722175', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:42:48', 166, 2001001000, '服务端发生异常', '2019-08-21 16:42:48');
INSERT INTO `access_log` VALUES (70104, '59.78.15663769923889041', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:43:12', 2, 0, '', '2019-08-21 16:43:12');
INSERT INTO `access_log` VALUES (70105, '59.74.15663769923889049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:43:12', 9, 2001001000, '服务端发生异常', '2019-08-21 16:43:12');
INSERT INTO `access_log` VALUES (70106, '64.76.15663769993849411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:43:19', 3, 0, '', '2019-08-21 16:43:19');
INSERT INTO `access_log` VALUES (70107, '64.80.15663769995069405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:43:20', 1, 0, '', '2019-08-21 16:43:20');
INSERT INTO `access_log` VALUES (70108, '64.79.15663770004209403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:43:20', 2, 0, '', '2019-08-21 16:43:20');
INSERT INTO `access_log` VALUES (70109, '64.78.15663770010129421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:43:21', 2, 0, '', '2019-08-21 16:43:21');
INSERT INTO `access_log` VALUES (70110, '64.84.15663770014669407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:43:21', 2, 0, '', '2019-08-21 16:43:21');
INSERT INTO `access_log` VALUES (70111, '64.85.15663770017649439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '58.211.111.18', '2019-08-21 16:43:22', 2, 0, '', '2019-08-21 16:43:22');
INSERT INTO `access_log` VALUES (70112, '65.53.15663776825952137', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:54:43', 0, 1002001015, '账号未登陆', '2019-08-21 16:54:43');
INSERT INTO `access_log` VALUES (70113, '65.51.15663776826052249', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:54:43', 0, 1002001015, '账号未登陆', '2019-08-21 16:54:43');
INSERT INTO `access_log` VALUES (70114, '65.45.15663776826212205', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:54:43', 0, 1002001015, '账号未登陆', '2019-08-21 16:54:43');
INSERT INTO `access_log` VALUES (70115, '65.46.15663776859732225', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:54:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 16:54:46');
INSERT INTO `access_log` VALUES (70116, '65.52.15663776950572233', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:54:55', 76, 0, '', '2019-08-21 16:54:55');
INSERT INTO `access_log` VALUES (70117, '65.3607.15663776955773985', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:54:56', 10, 0, '', '2019-08-21 16:54:56');
INSERT INTO `access_log` VALUES (70118, '65.54.15663776955892083', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:54:56', 10, 2001001000, '服务端发生异常', '2019-08-21 16:54:56');
INSERT INTO `access_log` VALUES (70119, '65.47.15663776956222133', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 16:54:56', 10, 0, '', '2019-08-21 16:54:56');
INSERT INTO `access_log` VALUES (70120, '65.46.15663780539592231', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.160.72.30', '2019-08-21 17:00:54', 0, 1002001015, '账号未登陆', '2019-08-21 17:00:54');
INSERT INTO `access_log` VALUES (70121, '65.49.15663780539622203', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.160.72.30', '2019-08-21 17:00:54', 0, 1002001015, '账号未登陆', '2019-08-21 17:00:54');
INSERT INTO `access_log` VALUES (70122, '65.52.15663780539732239', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.160.72.30', '2019-08-21 17:00:54', 0, 1002001015, '账号未登陆', '2019-08-21 17:00:54');
INSERT INTO `access_log` VALUES (70123, '65.54.15663780569042089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.160.72.30', '2019-08-21 17:00:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 17:00:57');
INSERT INTO `access_log` VALUES (70124, '65.3607.15663780623303991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.160.72.30', '2019-08-21 17:01:02', 57, 0, '', '2019-08-21 17:01:02');
INSERT INTO `access_log` VALUES (70125, '65.50.15663780748102193', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '183.160.72.30', '2019-08-21 17:01:15', 65, 0, '', '2019-08-21 17:01:15');
INSERT INTO `access_log` VALUES (70126, '65.45.15663781084752213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.160.72.30', '2019-08-21 17:01:48', 75, 0, '', '2019-08-21 17:01:49');
INSERT INTO `access_log` VALUES (70127, '65.52.15663781092572241', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.160.72.30', '2019-08-21 17:01:49', 130, 0, '', '2019-08-21 17:01:49');
INSERT INTO `access_log` VALUES (70128, '65.46.15663781092532233', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.160.72.30', '2019-08-21 17:01:49', 133, 0, '', '2019-08-21 17:01:49');
INSERT INTO `access_log` VALUES (70129, '65.49.15663781092572205', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '183.160.72.30', '2019-08-21 17:01:49', 133, 2001001000, '服务端发生异常', '2019-08-21 17:01:49');
INSERT INTO `access_log` VALUES (70130, '65.3607.15663781284803993', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.184.0', '2019-08-21 17:02:08', 1, 1002001015, '账号未登陆', '2019-08-21 17:02:08');
INSERT INTO `access_log` VALUES (70131, '65.47.15663781284962141', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.184.0', '2019-08-21 17:02:08', 1, 1002001015, '账号未登陆', '2019-08-21 17:02:08');
INSERT INTO `access_log` VALUES (70132, '65.50.15663781285032195', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.184.0', '2019-08-21 17:02:09', 0, 1002001015, '账号未登陆', '2019-08-21 17:02:09');
INSERT INTO `access_log` VALUES (70133, '65.51.15663781309112259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.184.0', '2019-08-21 17:02:11', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 17:02:11');
INSERT INTO `access_log` VALUES (70134, '65.45.15663781420692215', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.184.0', '2019-08-21 17:02:22', 75, 0, '', '2019-08-21 17:02:22');
INSERT INTO `access_log` VALUES (70135, '65.52.15663781424552243', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.184.0', '2019-08-21 17:02:22', 10, 0, '', '2019-08-21 17:02:22');
INSERT INTO `access_log` VALUES (70136, '65.49.15663781424552207', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.184.0', '2019-08-21 17:02:22', 10, 2001001000, '服务端发生异常', '2019-08-21 17:02:22');
INSERT INTO `access_log` VALUES (70137, '65.46.15663781424612235', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.184.0', '2019-08-21 17:02:22', 8, 0, '', '2019-08-21 17:02:22');
INSERT INTO `access_log` VALUES (70138, '65.3607.15663781488253995', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.184.0', '2019-08-21 17:02:29', 33, 0, '', '2019-08-21 17:02:29');
INSERT INTO `access_log` VALUES (70139, '65.47.15663781488562143', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.184.0', '2019-08-21 17:02:29', 9, 0, '', '2019-08-21 17:02:29');
INSERT INTO `access_log` VALUES (70140, '65.50.15663781488592197', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.230.184.0', '2019-08-21 17:02:29', 10, 2001001000, '服务端发生异常', '2019-08-21 17:02:29');
INSERT INTO `access_log` VALUES (70141, '65.3607.15663793267994011', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 17:22:07', 11, 0, '', '2019-08-21 17:22:07');
INSERT INTO `access_log` VALUES (70142, '65.50.15663793268032213', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 17:22:07', 10, 2001001000, '服务端发生异常', '2019-08-21 17:22:07');
INSERT INTO `access_log` VALUES (70143, '65.53.15663793268312165', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.5.241.6', '2019-08-21 17:22:07', 10, 0, '', '2019-08-21 17:22:07');
INSERT INTO `access_log` VALUES (70144, '59.71.15663793491259063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/4.0.1219.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '218.5.241.6', '2019-08-21 17:22:29', 10, 0, '', '2019-08-21 17:22:29');
INSERT INTO `access_log` VALUES (70145, '59.74.15663793491279081', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/4.0.1219.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '218.5.241.6', '2019-08-21 17:22:29', 18, 2001001000, '服务端发生异常', '2019-08-21 17:22:29');
INSERT INTO `access_log` VALUES (70146, '64.79.15663793524929435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/4.0.1219.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '218.5.241.6', '2019-08-21 17:22:32', 11, 0, '', '2019-08-21 17:22:33');
INSERT INTO `access_log` VALUES (70147, '64.78.15663793526039453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/4.0.1219.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '218.5.241.6', '2019-08-21 17:22:33', 3, 0, '', '2019-08-21 17:22:33');
INSERT INTO `access_log` VALUES (70148, '59.75.15663793555199071', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/4.0.1219.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '218.5.241.6', '2019-08-21 17:22:36', 3, 0, '', '2019-08-21 17:22:36');
INSERT INTO `access_log` VALUES (70149, '59.76.15663793555239055', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/4.0.1219.400 QQBrowser/9.0.2524.400 Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.95 Safari/537.36 MicroMessenger/6.5.2.501 NetType/WIFI WindowsWechat', '218.5.241.6', '2019-08-21 17:22:36', 11, 2001001000, '服务端发生异常', '2019-08-21 17:22:36');
INSERT INTO `access_log` VALUES (70150, '65.49.15663795451882229', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:25:45', 1, 0, '', '2019-08-21 17:25:45');
INSERT INTO `access_log` VALUES (70151, '65.54.15663795463122113', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:25:46', 1, 0, '', '2019-08-21 17:25:46');
INSERT INTO `access_log` VALUES (70152, '65.47.15663795472562165', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:25:47', 1, 0, '', '2019-08-21 17:25:47');
INSERT INTO `access_log` VALUES (70153, '65.51.15663795479602283', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:25:48', 1, 0, '', '2019-08-21 17:25:48');
INSERT INTO `access_log` VALUES (70154, '65.50.15663795486422217', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:25:49', 1, 0, '', '2019-08-21 17:25:49');
INSERT INTO `access_log` VALUES (70155, '65.53.15663795491762171', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:25:49', 1, 0, '', '2019-08-21 17:25:49');
INSERT INTO `access_log` VALUES (70156, '65.52.15663795537582265', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:25:54', 1, 0, '', '2019-08-21 17:25:54');
INSERT INTO `access_log` VALUES (70157, '65.3607.15663795542614017', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:25:54', 1, 0, '', '2019-08-21 17:25:54');
INSERT INTO `access_log` VALUES (70158, '65.46.15663795550162255', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:25:55', 1, 0, '', '2019-08-21 17:25:55');
INSERT INTO `access_log` VALUES (70159, '65.49.15663795556802231', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:25:56', 1, 0, '', '2019-08-21 17:25:56');
INSERT INTO `access_log` VALUES (70160, '65.54.15663795568562115', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:25:57', 1, 0, '', '2019-08-21 17:25:57');
INSERT INTO `access_log` VALUES (70161, '65.47.15663795613762167', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:26:01', 0, 1002001015, '账号未登陆', '2019-08-21 17:26:01');
INSERT INTO `access_log` VALUES (70162, '65.51.15663795622642285', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:26:02', 0, 1002001015, '账号未登陆', '2019-08-21 17:26:02');
INSERT INTO `access_log` VALUES (70163, '65.50.15663795630032219', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:26:03', 0, 1002001015, '账号未登陆', '2019-08-21 17:26:03');
INSERT INTO `access_log` VALUES (70164, '65.53.15663795656872173', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:26:06', 0, 1002001015, '账号未登陆', '2019-08-21 17:26:06');
INSERT INTO `access_log` VALUES (70165, '65.52.15663795663372267', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:26:06', 0, 1002001015, '账号未登陆', '2019-08-21 17:26:06');
INSERT INTO `access_log` VALUES (70166, '65.3607.15663795711854019', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:26:11', 1, 1002001015, '账号未登陆', '2019-08-21 17:26:11');
INSERT INTO `access_log` VALUES (70167, '65.46.15663795719992257', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:26:12', 1, 1002001015, '账号未登陆', '2019-08-21 17:26:12');
INSERT INTO `access_log` VALUES (70168, '65.49.15663795771682233', 0, 2, 'admin-application', '/admin-api/admins/admin/delete', 'id=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:26:17', 0, 1002001015, '账号未登陆', '2019-08-21 17:26:17');
INSERT INTO `access_log` VALUES (70169, '65.54.15663795785382117', 0, 2, 'admin-application', '/admin-api/admins/admin/delete', 'id=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:26:19', 1, 1002001015, '账号未登陆', '2019-08-21 17:26:19');
INSERT INTO `access_log` VALUES (70170, '65.47.15663795792872169', 0, 2, 'admin-application', '/admin-api/admins/admin/delete', 'id=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:26:19', 0, 1002001015, '账号未登陆', '2019-08-21 17:26:19');
INSERT INTO `access_log` VALUES (70171, '66.51.15663801383276625', 0, 2, 'user-application', '/user-api/admins/user/page', 'pageSize=10&nickname=小王&pageNo=1&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:35:38', 0, 1002001015, '账号未登陆', '2019-08-21 17:35:38');
INSERT INTO `access_log` VALUES (70172, '66.50.15663801397266601', 0, 2, 'user-application', '/user-api/admins/user/page', 'pageSize=10&nickname=小王&pageNo=1&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:35:40', 1, 1002001015, '账号未登陆', '2019-08-21 17:35:40');
INSERT INTO `access_log` VALUES (70173, '66.49.15663801406016601', 0, 2, 'user-application', '/user-api/admins/user/page', 'pageSize=10&nickname=小王&pageNo=1&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:35:41', 0, 1002001015, '账号未登陆', '2019-08-21 17:35:41');
INSERT INTO `access_log` VALUES (70174, '66.50.15663802702896603', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'code=1024&mobile=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:37:50', 17, 1001003000, '验证码不存在', '2019-08-21 17:37:50');
INSERT INTO `access_log` VALUES (70175, '66.54.15663802717346619', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'code=1024&mobile=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:37:52', 7, 1001003000, '验证码不存在', '2019-08-21 17:37:52');
INSERT INTO `access_log` VALUES (70176, '66.55.15663802776256581', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'code=1024&mobile=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:37:58', 8, 1001003000, '验证码不存在', '2019-08-21 17:37:58');
INSERT INTO `access_log` VALUES (70177, '66.53.15663802778646583', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'code=1024&mobile=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:37:58', 7, 1001003000, '验证码不存在', '2019-08-21 17:37:58');
INSERT INTO `access_log` VALUES (70178, '66.52.15663802804816601', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', '1=1024&mobile=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:38:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空', '2019-08-21 17:38:00');
INSERT INTO `access_log` VALUES (70179, '66.48.15663802855306593', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'code=1024&mobile=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:38:06', 14, 1001003000, '验证码不存在', '2019-08-21 17:38:06');
INSERT INTO `access_log` VALUES (70180, '66.57.15663802863936599', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'code=1024&mobile=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:38:06', 7, 1001003000, '验证码不存在', '2019-08-21 17:38:06');
INSERT INTO `access_log` VALUES (70181, '66.51.15663802940056629', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:38:14', 65, 0, '', '2019-08-21 17:38:14');
INSERT INTO `access_log` VALUES (70182, '66.49.15663803014726605', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17350332369', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:38:21', 282, 0, '', '2019-08-21 17:38:22');
INSERT INTO `access_log` VALUES (70183, '65.52.15663803865912281', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.19.197', '2019-08-21 17:39:47', 1, 0, '', '2019-08-21 17:39:47');
INSERT INTO `access_log` VALUES (70184, '66.54.15663806423906627', 0, 2, 'user-application', '/user-api/admins/user/page', 'pageSize=10&nickname=小王&pageNo=1&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:44:02', 1, 1002001015, '账号未登陆', '2019-08-21 17:44:02');
INSERT INTO `access_log` VALUES (70185, '66.49.15663806434386611', 0, 2, 'user-application', '/user-api/admins/user/page', 'pageSize=10&nickname=小王&pageNo=1&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:44:03', 1, 1002001015, '账号未登陆', '2019-08-21 17:44:03');
INSERT INTO `access_log` VALUES (70186, '59.71.15663807825079083', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.188.94.64', '2019-08-21 17:46:23', 4, 0, '', '2019-08-21 17:46:23');
INSERT INTO `access_log` VALUES (70187, '59.74.15663807825159101', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.188.94.64', '2019-08-21 17:46:23', 12, 2001001000, '服务端发生异常', '2019-08-21 17:46:23');
INSERT INTO `access_log` VALUES (70188, '59.76.15663807832499075', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.26.4.17', '2019-08-21 17:46:23', 3, 0, '', '2019-08-21 17:46:23');
INSERT INTO `access_log` VALUES (70189, '59.78.15663807832489093', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.26.4.17', '2019-08-21 17:46:23', 39, 2001001000, '服务端发生异常', '2019-08-21 17:46:23');
INSERT INTO `access_log` VALUES (70190, '64.80.15663807871619457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.26.4.17', '2019-08-21 17:46:27', 15, 0, '', '2019-08-21 17:46:27');
INSERT INTO `access_log` VALUES (70191, '64.77.15663807872939443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.26.4.17', '2019-08-21 17:46:27', 2, 0, '', '2019-08-21 17:46:27');
INSERT INTO `access_log` VALUES (70192, '64.79.15663807875159455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.188.94.64', '2019-08-21 17:46:28', 2, 0, '', '2019-08-21 17:46:28');
INSERT INTO `access_log` VALUES (70193, '64.78.15663807876339473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.188.94.64', '2019-08-21 17:46:28', 2, 0, '', '2019-08-21 17:46:28');
INSERT INTO `access_log` VALUES (70194, '64.84.15663807883549459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.188.94.64', '2019-08-21 17:46:28', 2, 0, '', '2019-08-21 17:46:28');
INSERT INTO `access_log` VALUES (70195, '64.85.15663807887769491', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '39.188.94.64', '2019-08-21 17:46:29', 2, 0, '', '2019-08-21 17:46:29');
INSERT INTO `access_log` VALUES (70196, '64.82.15663807888619469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.26.4.17', '2019-08-21 17:46:29', 1, 0, '', '2019-08-21 17:46:29');
INSERT INTO `access_log` VALUES (70197, '64.81.15663807894559457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.26.4.17', '2019-08-21 17:46:29', 2, 0, '', '2019-08-21 17:46:29');
INSERT INTO `access_log` VALUES (70198, '64.83.15663807921859457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.26.4.17', '2019-08-21 17:46:32', 2, 0, '', '2019-08-21 17:46:32');
INSERT INTO `access_log` VALUES (70199, '64.76.15663807925189465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.26.4.17', '2019-08-21 17:46:33', 5, 0, '', '2019-08-21 17:46:33');
INSERT INTO `access_log` VALUES (70200, '66.57.15663807978576607', 0, 2, 'user-application', '/user-api/admins/user/page', 'pageSize=10&nickname=小王&pageNo=1&status=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:46:38', 1, 1002001015, '账号未登陆', '2019-08-21 17:46:38');
INSERT INTO `access_log` VALUES (70201, '66.53.15663808120776593', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678901&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '115.26.4.17', '2019-08-21 17:46:52', 8, 1001003001, '验证码已过期', '2019-08-21 17:46:52');
INSERT INTO `access_log` VALUES (70202, '64.85.15663813342669499', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:55:34', 4, 1003002003, 'Spu 只能添加在二级分类下', '2019-08-21 17:55:34');
INSERT INTO `access_log` VALUES (70203, '64.81.15663813359269467', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:55:36', 3, 1003002003, 'Spu 只能添加在二级分类下', '2019-08-21 17:55:36');
INSERT INTO `access_log` VALUES (70204, '64.76.15663813371129473', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:55:37', 3, 1003002003, 'Spu 只能添加在二级分类下', '2019-08-21 17:55:37');
INSERT INTO `access_log` VALUES (70205, '64.83.15663813376269467', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:55:38', 3, 1003002003, 'Spu 只能添加在二级分类下', '2019-08-21 17:55:38');
INSERT INTO `access_log` VALUES (70206, '64.80.15663813383319467', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:55:38', 3, 1003002003, 'Spu 只能添加在二级分类下', '2019-08-21 17:55:38');
INSERT INTO `access_log` VALUES (70207, '64.77.15663813387159453', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:55:39', 2, 1003002003, 'Spu 只能添加在二级分类下', '2019-08-21 17:55:39');
INSERT INTO `access_log` VALUES (70208, '64.79.15663813389889467', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:55:39', 3, 1003002003, 'Spu 只能添加在二级分类下', '2019-08-21 17:55:39');
INSERT INTO `access_log` VALUES (70209, '64.78.15663813392849483', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:55:39', 3, 1003002003, 'Spu 只能添加在二级分类下', '2019-08-21 17:55:39');
INSERT INTO `access_log` VALUES (70210, '64.84.15663813396379469', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:55:40', 2, 1003002003, 'Spu 只能添加在二级分类下', '2019-08-21 17:55:40');
INSERT INTO `access_log` VALUES (70211, '64.85.15663813436369501', 0, 1, 'product-application', '/product-api/users/spu/page', 'pageSize=10&cid=1&pageNo=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:55:44', 3, 0, '', '2019-08-21 17:55:44');
INSERT INTO `access_log` VALUES (70212, '64.82.15663813448009481', 0, 1, 'product-application', '/product-api/users/spu/page', 'pageSize=10&cid=1&pageNo=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:55:45', 3, 0, '', '2019-08-21 17:55:45');
INSERT INTO `access_log` VALUES (70213, '64.81.15663813464929469', 0, 1, 'product-application', '/product-api/users/spu/page', 'pageSize=10&cid=1&pageNo=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:55:46', 3, 0, '', '2019-08-21 17:55:46');
INSERT INTO `access_log` VALUES (70214, '64.83.15663813577719469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:55:58', 2, 0, '', '2019-08-21 17:55:58');
INSERT INTO `access_log` VALUES (70215, '64.80.15663813616769469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:56:02', 2, 0, '', '2019-08-21 17:56:02');
INSERT INTO `access_log` VALUES (70216, '64.79.15663813689669469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:56:09', 1, 0, '', '2019-08-21 17:56:09');
INSERT INTO `access_log` VALUES (70217, '64.78.15663813713679485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=2', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:56:11', 2, 0, '', '2019-08-21 17:56:11');
INSERT INTO `access_log` VALUES (70218, '64.84.15663813750919471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:56:15', 1, 0, '', '2019-08-21 17:56:15');
INSERT INTO `access_log` VALUES (70219, '64.81.15663813996849471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:56:40', 2, 0, '', '2019-08-21 17:56:40');
INSERT INTO `access_log` VALUES (70220, '64.83.15663814127279471', 0, 2, 'product-application', '/product-api/admins/spu/add', 'cid=反正我是信了&description=你就说强不强 MQ 骚操作&name=厮大牛逼&picUrls=http://www.iocoder.cn&sellPoint=各种 MQ 骚操作&skuStr=[{\"attrs\": [1,3 ], \"price\": 1, \"quantity\": 100, \"picUrl\": \"http://www.iocoder.cn\"}]&visible=true', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:56:53', 1, 1002001015, '账号未登陆', '2019-08-21 17:56:53');
INSERT INTO `access_log` VALUES (70221, '64.80.15663814142219471', 0, 2, 'product-application', '/product-api/admins/spu/add', 'cid=反正我是信了&description=你就说强不强 MQ 骚操作&name=厮大牛逼&picUrls=http://www.iocoder.cn&sellPoint=各种 MQ 骚操作&skuStr=[{\"attrs\": [1,3 ], \"price\": 1, \"quantity\": 100, \"picUrl\": \"http://www.iocoder.cn\"}]&visible=true', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:56:54', 1, 1002001015, '账号未登陆', '2019-08-21 17:56:54');
INSERT INTO `access_log` VALUES (70222, '64.77.15663814148749457', 0, 2, 'product-application', '/product-api/admins/spu/add', 'cid=反正我是信了&description=你就说强不强 MQ 骚操作&name=厮大牛逼&picUrls=http://www.iocoder.cn&sellPoint=各种 MQ 骚操作&skuStr=[{\"attrs\": [1,3 ], \"price\": 1, \"quantity\": 100, \"picUrl\": \"http://www.iocoder.cn\"}]&visible=true', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:56:55', 1, 1002001015, '账号未登陆', '2019-08-21 17:56:55');
INSERT INTO `access_log` VALUES (70223, '64.79.15663814154299471', 0, 2, 'product-application', '/product-api/admins/spu/add', 'cid=反正我是信了&description=你就说强不强 MQ 骚操作&name=厮大牛逼&picUrls=http://www.iocoder.cn&sellPoint=各种 MQ 骚操作&skuStr=[{\"attrs\": [1,3 ], \"price\": 1, \"quantity\": 100, \"picUrl\": \"http://www.iocoder.cn\"}]&visible=true', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:56:55', 0, 1002001015, '账号未登陆', '2019-08-21 17:56:55');
INSERT INTO `access_log` VALUES (70224, '64.81.15663814787069473', 0, 2, 'product-application', '/product-api/admins/attr/add', 'name=颜色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:57:59', 0, 1002001015, '账号未登陆', '2019-08-21 17:57:59');
INSERT INTO `access_log` VALUES (70225, '64.78.15663814902879489', 0, 2, 'product-application', '/product-api/admins/attr/update', 'id=1&name=颜色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:58:10', 1, 1002001015, '账号未登陆', '2019-08-21 17:58:10');
INSERT INTO `access_log` VALUES (70226, '64.84.15663814914059475', 0, 2, 'product-application', '/product-api/admins/attr/update', 'id=1&name=颜色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:58:11', 1, 1002001015, '账号未登陆', '2019-08-21 17:58:11');
INSERT INTO `access_log` VALUES (70227, '65.54.15663815821122145', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:59:42', 0, 1002001015, '账号未登陆', '2019-08-21 17:59:42');
INSERT INTO `access_log` VALUES (70228, '65.3607.15663815833314049', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:59:43', 1, 1002001015, '账号未登陆', '2019-08-21 17:59:43');
INSERT INTO `access_log` VALUES (70229, '65.49.15663815937212261', 0, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 17:59:54', 1, 0, '', '2019-08-21 17:59:54');
INSERT INTO `access_log` VALUES (70230, '65.47.15663816062552199', 0, 2, 'admin-application', '/admin-api/admins/role/add', 'name=系统管理员', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:00:06', 1, 1002001015, '账号未登陆', '2019-08-21 18:00:06');
INSERT INTO `access_log` VALUES (70231, '65.53.15663816193952203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:00:19', 4, 1002002001, '密码不正确', '2019-08-21 18:00:19');
INSERT INTO `access_log` VALUES (70232, '65.52.15663816238852299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=YldfyUC7OewoWM63TPYTairqnq8GMJvNek9EGoID:T879v0WOEp3vyseLZbzQK_53vVs=:eyJzY29wZSI6Im9uZW1hbGwiLCJkZWFkbGluZSI6MTU2NjM4NTE5M30=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:00:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号格式为数字以及字母\n账号长度为 5-16 位', '2019-08-21 18:00:24');
INSERT INTO `access_log` VALUES (70233, '65.51.15663816291562317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:00:29', 4, 1002002001, '密码不正确', '2019-08-21 18:00:29');
INSERT INTO `access_log` VALUES (70234, '65.54.15663816299622147', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:00:30', 4, 1002002001, '密码不正确', '2019-08-21 18:00:30');
INSERT INTO `access_log` VALUES (70235, '65.3607.15663816388184051', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:00:39', 0, 1002001015, '账号未登陆', '2019-08-21 18:00:39');
INSERT INTO `access_log` VALUES (70236, '65.46.15663816396982289', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:00:40', 0, 1002001015, '账号未登陆', '2019-08-21 18:00:40');
INSERT INTO `access_log` VALUES (70237, '65.45.15663816608812273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:01', 4, 1002002001, '密码不正确', '2019-08-21 18:01:01');
INSERT INTO `access_log` VALUES (70238, '65.53.15663816685282205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:09', 3, 1002002001, '密码不正确', '2019-08-21 18:01:09');
INSERT INTO `access_log` VALUES (70239, '65.52.15663816691532301', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:09', 3, 1002002001, '密码不正确', '2019-08-21 18:01:09');
INSERT INTO `access_log` VALUES (70240, '65.51.15663816694452319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:09', 3, 1002002001, '密码不正确', '2019-08-21 18:01:09');
INSERT INTO `access_log` VALUES (70241, '65.54.15663816697722149', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:10', 4, 1002002001, '密码不正确', '2019-08-21 18:01:10');
INSERT INTO `access_log` VALUES (70242, '65.3607.15663816699754053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:10', 3, 1002002001, '密码不正确', '2019-08-21 18:01:10');
INSERT INTO `access_log` VALUES (70243, '65.49.15663816703862265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:10', 3, 1002002001, '密码不正确', '2019-08-21 18:01:10');
INSERT INTO `access_log` VALUES (70244, '65.46.15663816741532291', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:14', 4, 1002002001, '密码不正确', '2019-08-21 18:01:14');
INSERT INTO `access_log` VALUES (70245, '65.45.15663816842102275', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=123456&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:24', 12, 1002002001, '密码不正确', '2019-08-21 18:01:24');
INSERT INTO `access_log` VALUES (70246, '65.53.15663816970072207', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=123456&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:37', 4, 1002002001, '密码不正确', '2019-08-21 18:01:37');
INSERT INTO `access_log` VALUES (70247, '65.50.15663816975862255', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=123456&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:38', 4, 1002002001, '密码不正确', '2019-08-21 18:01:38');
INSERT INTO `access_log` VALUES (70248, '65.51.15663816990422321', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=12345611&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:39', 217, 0, '', '2019-08-21 18:01:39');
INSERT INTO `access_log` VALUES (70249, '65.54.15663817054872151', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=123456&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:45', 4, 1002002001, '密码不正确', '2019-08-21 18:01:45');
INSERT INTO `access_log` VALUES (70250, '65.3607.15663817074904055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=12345611&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:47', 89, 0, '', '2019-08-21 18:01:48');
INSERT INTO `access_log` VALUES (70251, '65.49.15663817092342267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=12345611111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:49', 95, 0, '', '2019-08-21 18:01:49');
INSERT INTO `access_log` VALUES (70252, '65.46.15663817101382293', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=12345611111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:50', 151, 0, '', '2019-08-21 18:01:50');
INSERT INTO `access_log` VALUES (70253, '65.47.15663817109142205', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=12345611111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:51', 85, 0, '', '2019-08-21 18:01:51');
INSERT INTO `access_log` VALUES (70254, '65.45.15663817117022277', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=12345611111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:52', 170, 0, '', '2019-08-21 18:01:52');
INSERT INTO `access_log` VALUES (70255, '65.53.15663817124102209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=12345611111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:52', 82, 0, '', '2019-08-21 18:01:52');
INSERT INTO `access_log` VALUES (70256, '65.50.15663817131232257', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=12345611111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:53', 70, 0, '', '2019-08-21 18:01:53');
INSERT INTO `access_log` VALUES (70257, '65.52.15663817138422305', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=12345611111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:54', 92, 0, '', '2019-08-21 18:01:54');
INSERT INTO `access_log` VALUES (70258, '65.54.15663817144822153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=12345611111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:54', 64, 0, '', '2019-08-21 18:01:55');
INSERT INTO `access_log` VALUES (70259, '65.3607.15663817184094057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:01:58', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 18:01:58');
INSERT INTO `access_log` VALUES (70260, '65.49.15663817216582269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=111111111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:02:02', 79, 0, '', '2019-08-21 18:02:02');
INSERT INTO `access_log` VALUES (70261, '65.46.15663817225692295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=111111111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:02:03', 103, 0, '', '2019-08-21 18:02:03');
INSERT INTO `access_log` VALUES (70262, '65.47.15663817234072207', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=111111111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:02:03', 84, 0, '', '2019-08-21 18:02:03');
INSERT INTO `access_log` VALUES (70263, '65.45.15663817241562279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=111111111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:02:04', 85, 0, '', '2019-08-21 18:02:04');
INSERT INTO `access_log` VALUES (70264, '65.50.15663817436212259', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.132.195.172', '2019-08-21 18:02:24', 1, 1002001015, '账号未登陆', '2019-08-21 18:02:24');
INSERT INTO `access_log` VALUES (70265, '65.51.15663817436212325', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.132.195.172', '2019-08-21 18:02:24', 1, 1002001015, '账号未登陆', '2019-08-21 18:02:24');
INSERT INTO `access_log` VALUES (70266, '65.52.15663817436372307', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.132.195.172', '2019-08-21 18:02:24', 1, 1002001015, '账号未登陆', '2019-08-21 18:02:24');
INSERT INTO `access_log` VALUES (70267, '65.49.15663817639172271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.132.195.172', '2019-08-21 18:02:44', 139, 0, '', '2019-08-21 18:02:44');
INSERT INTO `access_log` VALUES (70268, '65.46.15663817646022297', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.132.195.172', '2019-08-21 18:02:45', 13, 0, '', '2019-08-21 18:02:45');
INSERT INTO `access_log` VALUES (70269, '65.45.15663817646182281', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.132.195.172', '2019-08-21 18:02:45', 7, 0, '', '2019-08-21 18:02:45');
INSERT INTO `access_log` VALUES (70270, '65.47.15663817646162209', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.132.195.172', '2019-08-21 18:02:45', 10, 2001001000, '服务端发生异常', '2019-08-21 18:02:45');
INSERT INTO `access_log` VALUES (70271, '65.53.15663817691372213', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=111111111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:02:49', 67, 0, '', '2019-08-21 18:02:49');
INSERT INTO `access_log` VALUES (70272, '65.50.15663817825682261', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=111111111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:03:03', 103, 0, '', '2019-08-21 18:03:03');
INSERT INTO `access_log` VALUES (70273, '65.52.15663817835872309', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=111111111&username=admin', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:03:04', 53, 0, '', '2019-08-21 18:03:04');
INSERT INTO `access_log` VALUES (70274, '65.3607.15663817841784061', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.132.195.172', '2019-08-21 18:03:04', 10, 0, '', '2019-08-21 18:03:04');
INSERT INTO `access_log` VALUES (70275, '65.54.15663817841782157', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.132.195.172', '2019-08-21 18:03:04', 11, 2001001000, '服务端发生异常', '2019-08-21 18:03:04');
INSERT INTO `access_log` VALUES (70276, '65.49.15663817841922273', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.132.195.172', '2019-08-21 18:03:04', 8, 0, '', '2019-08-21 18:03:04');
INSERT INTO `access_log` VALUES (70277, '65.47.15663817953462211', 0, 2, 'admin-application', '/admin-api/admins/role/add', 'name=系统管理员', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:03:15', 1, 1002001015, '账号未登陆', '2019-08-21 18:03:15');
INSERT INTO `access_log` VALUES (70278, '65.45.15663817961292283', 0, 2, 'admin-application', '/admin-api/admins/role/add', 'name=系统管理员', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-21 18:03:16', 1, 1002001015, '账号未登陆', '2019-08-21 18:03:16');
INSERT INTO `access_log` VALUES (70279, '59.76.15663818068589089', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.132.195.172', '2019-08-21 18:03:27', 3, 0, '', '2019-08-21 18:03:27');
INSERT INTO `access_log` VALUES (70280, '59.78.15663818068699107', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '117.132.195.172', '2019-08-21 18:03:27', 14, 2001001000, '服务端发生异常', '2019-08-21 18:03:27');
INSERT INTO `access_log` VALUES (70281, '65.51.15663887138282421', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.121.206.217', '2019-08-21 19:58:34', 13, 1002001012, '访问令牌已过期', '2019-08-21 19:58:34');
INSERT INTO `access_log` VALUES (70282, '65.50.15663887138282355', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.121.206.217', '2019-08-21 19:58:34', 16, 1002001012, '访问令牌已过期', '2019-08-21 19:58:34');
INSERT INTO `access_log` VALUES (70283, '65.52.15663887138292403', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.121.206.217', '2019-08-21 19:58:34', 19, 1002001012, '访问令牌已过期', '2019-08-21 19:58:34');
INSERT INTO `access_log` VALUES (70284, '65.3607.15663887170784155', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.121.206.217', '2019-08-21 19:58:37', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 19:58:37');
INSERT INTO `access_log` VALUES (70285, '65.54.15663887331892251', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.121.206.217', '2019-08-21 19:58:53', 85, 0, '', '2019-08-21 19:58:53');
INSERT INTO `access_log` VALUES (70286, '65.46.15663887335032393', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.121.206.217', '2019-08-21 19:58:54', 12, 0, '', '2019-08-21 19:58:54');
INSERT INTO `access_log` VALUES (70287, '65.47.15663887335072305', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.121.206.217', '2019-08-21 19:58:54', 11, 2001001000, '服务端发生异常', '2019-08-21 19:58:54');
INSERT INTO `access_log` VALUES (70288, '65.45.15663887335122377', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.121.206.217', '2019-08-21 19:58:54', 10, 0, '', '2019-08-21 19:58:54');
INSERT INTO `access_log` VALUES (70289, '65.51.15663887379882423', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.121.206.217', '2019-08-21 19:58:58', 8, 0, '', '2019-08-21 19:58:58');
INSERT INTO `access_log` VALUES (70290, '65.50.15663887379962357', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.121.206.217', '2019-08-21 19:58:58', 18, 0, '', '2019-08-21 19:58:58');
INSERT INTO `access_log` VALUES (70291, '65.52.15663887379922405', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.121.206.217', '2019-08-21 19:58:58', 189, 2001001000, '服务端发生异常', '2019-08-21 19:58:58');
INSERT INTO `access_log` VALUES (70292, '65.53.15663900069982327', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.49.23.162', '2019-08-21 20:20:07', 1, 1002001015, '账号未登陆', '2019-08-21 20:20:07');
INSERT INTO `access_log` VALUES (70293, '65.46.15663900069972411', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.49.23.162', '2019-08-21 20:20:07', 1, 1002001015, '账号未登陆', '2019-08-21 20:20:07');
INSERT INTO `access_log` VALUES (70294, '65.45.15663900069982395', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.49.23.162', '2019-08-21 20:20:07', 1, 1002001015, '账号未登陆', '2019-08-21 20:20:07');
INSERT INTO `access_log` VALUES (70295, '65.51.15663900084522441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.49.23.162', '2019-08-21 20:20:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 20:20:08');
INSERT INTO `access_log` VALUES (70296, '65.52.15663900142882423', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.49.23.162', '2019-08-21 20:20:14', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 20:20:14');
INSERT INTO `access_log` VALUES (70297, '59.78.15663900294989217', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.49.23.162', '2019-08-21 20:20:29', 12, 0, '', '2019-08-21 20:20:30');
INSERT INTO `access_log` VALUES (70298, '59.76.15663900295019199', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.49.23.162', '2019-08-21 20:20:30', 26, 2001001000, '服务端发生异常', '2019-08-21 20:20:30');
INSERT INTO `access_log` VALUES (70299, '65.54.15663900401522271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.49.23.162', '2019-08-21 20:20:40', 70, 0, '', '2019-08-21 20:20:40');
INSERT INTO `access_log` VALUES (70300, '65.47.15663900404472325', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.49.23.162', '2019-08-21 20:20:40', 8, 0, '', '2019-08-21 20:20:40');
INSERT INTO `access_log` VALUES (70301, '65.53.15663900404482329', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.49.23.162', '2019-08-21 20:20:40', 9, 2001001000, '服务端发生异常', '2019-08-21 20:20:40');
INSERT INTO `access_log` VALUES (70302, '65.46.15663900404522413', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '58.49.23.162', '2019-08-21 20:20:40', 8, 0, '', '2019-08-21 20:20:40');
INSERT INTO `access_log` VALUES (70303, '65.51.15663930631552483', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '115.238.239.190', '2019-08-21 21:11:03', 0, 1002001015, '账号未登陆', '2019-08-21 21:11:03');
INSERT INTO `access_log` VALUES (70304, '65.50.15663930631552417', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '115.238.239.190', '2019-08-21 21:11:03', 0, 1002001015, '账号未登陆', '2019-08-21 21:11:03');
INSERT INTO `access_log` VALUES (70305, '65.52.15663930631572465', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '115.238.239.190', '2019-08-21 21:11:03', 0, 1002001015, '账号未登陆', '2019-08-21 21:11:03');
INSERT INTO `access_log` VALUES (70306, '65.47.15663931328982367', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.129.6.151', '2019-08-21 21:12:13', 1, 1002001015, '账号未登陆', '2019-08-21 21:12:13');
INSERT INTO `access_log` VALUES (70307, '59.72.15663933376979253', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '106.37.187.140', '2019-08-21 21:15:38', 32, 0, '', '2019-08-21 21:15:38');
INSERT INTO `access_log` VALUES (70308, '59.80.15663933377189227', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '106.37.187.140', '2019-08-21 21:15:38', 17, 2001001000, '服务端发生异常', '2019-08-21 21:15:38');
INSERT INTO `access_log` VALUES (70309, '65.45.15663972587122495', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:20:59', 1, 1002001015, '账号未登陆', '2019-08-21 22:20:59');
INSERT INTO `access_log` VALUES (70310, '65.52.15663972587122523', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:20:59', 1, 1002001015, '账号未登陆', '2019-08-21 22:20:59');
INSERT INTO `access_log` VALUES (70311, '65.53.15663972587332427', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:20:59', 0, 1002001015, '账号未登陆', '2019-08-21 22:20:59');
INSERT INTO `access_log` VALUES (70312, '65.3607.15663972889014275', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:21:29', 676, 0, '', '2019-08-21 22:21:30');
INSERT INTO `access_log` VALUES (70313, '65.49.15663972902392487', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:21:30', 21, 0, '', '2019-08-21 22:21:30');
INSERT INTO `access_log` VALUES (70314, '65.47.15663972902422423', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:21:30', 18, 0, '', '2019-08-21 22:21:30');
INSERT INTO `access_log` VALUES (70315, '65.54.15663972902422371', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:21:30', 21, 2001001000, '服务端发生异常', '2019-08-21 22:21:30');
INSERT INTO `access_log` VALUES (70316, '65.46.15663972958852511', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:21:36', 9, 0, '', '2019-08-21 22:21:36');
INSERT INTO `access_log` VALUES (70317, '65.52.15663972958852525', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:21:36', 9, 0, '', '2019-08-21 22:21:36');
INSERT INTO `access_log` VALUES (70318, '65.45.15663972958852497', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:21:36', 10, 2001001000, '服务端发生异常', '2019-08-21 22:21:36');
INSERT INTO `access_log` VALUES (70319, '59.80.15663973763269281', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:22:56', 10, 0, '', '2019-08-21 22:22:56');
INSERT INTO `access_log` VALUES (70320, '59.73.15663973763269311', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:22:56', 15, 2001001000, '服务端发生异常', '2019-08-21 22:22:56');
INSERT INTO `access_log` VALUES (70321, '65.46.15663974230862513', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:23:43', 8, 0, '', '2019-08-21 22:23:43');
INSERT INTO `access_log` VALUES (70322, '65.53.15663974230862431', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:23:43', 10, 2001001000, '服务端发生异常', '2019-08-21 22:23:43');
INSERT INTO `access_log` VALUES (70323, '65.50.15663974230882479', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:23:43', 10, 0, '', '2019-08-21 22:23:43');
INSERT INTO `access_log` VALUES (70324, '65.3607.15663974384144279', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:23:58', 9, 0, '', '2019-08-21 22:23:58');
INSERT INTO `access_log` VALUES (70325, '65.47.15663974384182427', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:23:58', 9, 0, '', '2019-08-21 22:23:58');
INSERT INTO `access_log` VALUES (70326, '65.49.15663974384172491', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.175.71.178', '2019-08-21 22:23:58', 9, 2001001000, '服务端发生异常', '2019-08-21 22:23:58');
INSERT INTO `access_log` VALUES (70327, '65.51.15664030859882621', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:58:06', 7, 1002001015, '账号未登陆', '2019-08-21 23:58:06');
INSERT INTO `access_log` VALUES (70328, '65.3607.15664030859894355', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:58:06', 8, 1002001015, '账号未登陆', '2019-08-21 23:58:06');
INSERT INTO `access_log` VALUES (70329, '65.49.15664030859882567', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:58:06', 7, 1002001015, '账号未登陆', '2019-08-21 23:58:06');
INSERT INTO `access_log` VALUES (70330, '65.54.15664030893532451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:58:09', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-21 23:58:09');
INSERT INTO `access_log` VALUES (70331, '65.45.15664030951842577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:58:15', 197, 0, '', '2019-08-21 23:58:15');
INSERT INTO `access_log` VALUES (70332, '65.52.15664030960212605', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:58:16', 23, 0, '', '2019-08-21 23:58:16');
INSERT INTO `access_log` VALUES (70333, '65.46.15664030960292591', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:58:16', 18, 0, '', '2019-08-21 23:58:16');
INSERT INTO `access_log` VALUES (70334, '65.53.15664030960292509', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:58:16', 19, 0, '', '2019-08-21 23:58:16');
INSERT INTO `access_log` VALUES (70335, '62.81.15664031116268049', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:58:32', 34, 0, '', '2019-08-21 23:58:32');
INSERT INTO `access_log` VALUES (70336, '64.76.15664031176489769', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:58:38', 19, 0, '', '2019-08-21 23:58:38');
INSERT INTO `access_log` VALUES (70337, '64.80.15664031176369765', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:58:38', 32, 0, '', '2019-08-21 23:58:38');
INSERT INTO `access_log` VALUES (70338, '64.82.15664031273899777', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:58:47', 16, 0, '', '2019-08-21 23:58:47');
INSERT INTO `access_log` VALUES (70339, '64.85.15664031274289797', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:58:47', 10, 0, '', '2019-08-21 23:58:47');
INSERT INTO `access_log` VALUES (70340, '64.77.15664031379439751', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:58:58', 10, 0, '', '2019-08-21 23:58:58');
INSERT INTO `access_log` VALUES (70341, '64.79.15664031442229761', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:59:04', 13, 0, '', '2019-08-21 23:59:04');
INSERT INTO `access_log` VALUES (70342, '64.84.15664031442199769', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:59:04', 18, 0, '', '2019-08-21 23:59:04');
INSERT INTO `access_log` VALUES (70343, '66.49.15664031653426911', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:59:25', 17, 0, '', '2019-08-21 23:59:25');
INSERT INTO `access_log` VALUES (70344, '59.73.15664031727129387', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:59:33', 24, 0, '', '2019-08-21 23:59:33');
INSERT INTO `access_log` VALUES (70345, '59.79.15664031768229387', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:59:37', 26, 2001001000, '服务端发生异常', '2019-08-21 23:59:37');
INSERT INTO `access_log` VALUES (70346, '59.71.15664031830199385', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:59:43', 17, 0, '', '2019-08-21 23:59:43');
INSERT INTO `access_log` VALUES (70347, '59.78.15664031902889395', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:59:50', 16, 0, '', '2019-08-21 23:59:50');
INSERT INTO `access_log` VALUES (70348, '59.74.15664031945119403', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-21 23:59:55', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-08-21 23:59:55');
INSERT INTO `access_log` VALUES (70349, '65.52.15664031997222607', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-22 00:00:00', 25, 0, '', '2019-08-22 00:00:00');
INSERT INTO `access_log` VALUES (70350, '65.46.15664032014902593', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-22 00:00:01', 20, 0, '', '2019-08-22 00:00:02');
INSERT INTO `access_log` VALUES (70351, '65.53.15664032037992511', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-22 00:00:04', 10, 0, '', '2019-08-22 00:00:04');
INSERT INTO `access_log` VALUES (70352, '65.50.15664032083662559', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-22 00:00:08', 13, 0, '', '2019-08-22 00:00:08');
INSERT INTO `access_log` VALUES (70353, '65.3607.15664032154084359', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-22 00:00:15', 9, 0, '', '2019-08-22 00:00:15');
INSERT INTO `access_log` VALUES (70354, '65.49.15664032164152571', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '223.73.131.214', '2019-08-22 00:00:16', 10, 0, '', '2019-08-22 00:00:16');
INSERT INTO `access_log` VALUES (70355, '65.3607.15664049696594383', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.85.182.131', '2019-08-22 00:29:30', 1, 1002001015, '账号未登陆', '2019-08-22 00:29:30');
INSERT INTO `access_log` VALUES (70356, '65.51.15664049696592649', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.85.182.131', '2019-08-22 00:29:30', 1, 1002001015, '账号未登陆', '2019-08-22 00:29:30');
INSERT INTO `access_log` VALUES (70357, '65.49.15664049696592595', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.85.182.131', '2019-08-22 00:29:30', 1, 1002001015, '账号未登陆', '2019-08-22 00:29:30');
INSERT INTO `access_log` VALUES (70358, '65.47.15664049778142531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.85.182.131', '2019-08-22 00:29:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-22 00:29:38');
INSERT INTO `access_log` VALUES (70359, '65.45.15664049842012605', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.85.182.131', '2019-08-22 00:29:44', 57, 0, '', '2019-08-22 00:29:44');
INSERT INTO `access_log` VALUES (70360, '65.52.15664049845352633', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.85.182.131', '2019-08-22 00:29:45', 102, 0, '', '2019-08-22 00:29:45');
INSERT INTO `access_log` VALUES (70361, '65.46.15664049845362619', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.85.182.131', '2019-08-22 00:29:45', 105, 0, '', '2019-08-22 00:29:45');
INSERT INTO `access_log` VALUES (70362, '65.53.15664049845392537', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.85.182.131', '2019-08-22 00:29:45', 102, 2001001000, '服务端发生异常', '2019-08-22 00:29:45');
INSERT INTO `access_log` VALUES (70363, '65.3607.15664049968284385', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.85.182.131', '2019-08-22 00:29:57', 15, 0, '', '2019-08-22 00:29:57');
INSERT INTO `access_log` VALUES (70364, '65.51.15664049968262651', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.85.182.131', '2019-08-22 00:29:57', 18, 2001001000, '服务端发生异常', '2019-08-22 00:29:57');
INSERT INTO `access_log` VALUES (70365, '65.49.15664049968292597', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.85.182.131', '2019-08-22 00:29:57', 16, 0, '', '2019-08-22 00:29:57');
INSERT INTO `access_log` VALUES (70366, '65.46.15664309890732969', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.23.67', '2019-08-22 07:43:09', 1, 1002001015, '账号未登陆', '2019-08-22 07:43:09');
INSERT INTO `access_log` VALUES (70367, '65.45.15664312775032957', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.23.67', '2019-08-22 07:47:58', 1, 1002001015, '账号未登陆', '2019-08-22 07:47:58');
INSERT INTO `access_log` VALUES (70368, '65.52.15664312775242985', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.23.67', '2019-08-22 07:47:58', 1, 1002001015, '账号未登陆', '2019-08-22 07:47:58');
INSERT INTO `access_log` VALUES (70369, '65.53.15664312775032889', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.23.67', '2019-08-22 07:47:58', 0, 1002001015, '账号未登陆', '2019-08-22 07:47:58');
INSERT INTO `access_log` VALUES (70370, '65.50.15664312873832937', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.23.67', '2019-08-22 07:48:07', 282, 0, '', '2019-08-22 07:48:08');
INSERT INTO `access_log` VALUES (70371, '65.51.15664312879703003', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.23.67', '2019-08-22 07:48:08', 18, 0, '', '2019-08-22 07:48:08');
INSERT INTO `access_log` VALUES (70372, '65.47.15664312879702885', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.23.67', '2019-08-22 07:48:08', 20, 2001001000, '服务端发生异常', '2019-08-22 07:48:08');
INSERT INTO `access_log` VALUES (70373, '65.3607.15664312879824739', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.23.67', '2019-08-22 07:48:08', 12, 0, '', '2019-08-22 07:48:08');
INSERT INTO `access_log` VALUES (70374, '65.45.15664313262262959', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.23.67', '2019-08-22 07:48:46', 8, 0, '', '2019-08-22 07:48:46');
INSERT INTO `access_log` VALUES (70375, '65.53.15664313262262891', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.23.67', '2019-08-22 07:48:46', 11, 0, '', '2019-08-22 07:48:46');
INSERT INTO `access_log` VALUES (70376, '65.52.15664313262242987', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.23.67', '2019-08-22 07:48:46', 11, 2001001000, '服务端发生异常', '2019-08-22 07:48:46');
INSERT INTO `access_log` VALUES (70377, '65.50.15664313313812939', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.23.67', '2019-08-22 07:48:51', 16, 0, '', '2019-08-22 07:48:51');
INSERT INTO `access_log` VALUES (70378, '65.3607.15664313313814741', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.23.67', '2019-08-22 07:48:51', 18, 2001001000, '服务端发生异常', '2019-08-22 07:48:51');
INSERT INTO `access_log` VALUES (70379, '65.51.15664313314043005', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.23.67', '2019-08-22 07:48:51', 8, 0, '', '2019-08-22 07:48:51');
INSERT INTO `access_log` VALUES (70380, '65.51.15664379797453097', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-22 09:39:40', 0, 1002001015, '账号未登陆', '2019-08-22 09:39:40');
INSERT INTO `access_log` VALUES (70381, '65.3607.15664379812274831', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-22 09:39:41', 1, 1002001015, '账号未登陆', '2019-08-22 09:39:41');
INSERT INTO `access_log` VALUES (70382, '65.50.15664379835923029', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao11&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-22 09:39:44', 0, 1002001015, '账号未登陆', '2019-08-22 09:39:44');
INSERT INTO `access_log` VALUES (70383, '59.77.15664380515399837', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:40:52', 11, 0, '', '2019-08-22 09:40:52');
INSERT INTO `access_log` VALUES (70384, '59.79.15664380515409853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:40:52', 25, 2001001000, '服务端发生异常', '2019-08-22 09:40:52');
INSERT INTO `access_log` VALUES (70385, '64.84.15664380622840235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:02', 54, 0, '', '2019-08-22 09:41:02');
INSERT INTO `access_log` VALUES (70386, '64.79.15664380624400227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:02', 3, 0, '', '2019-08-22 09:41:02');
INSERT INTO `access_log` VALUES (70387, '64.81.15664380651720233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:05', 2, 0, '', '2019-08-22 09:41:05');
INSERT INTO `access_log` VALUES (70388, '64.76.15664380660220237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:06', 2, 0, '', '2019-08-22 09:41:06');
INSERT INTO `access_log` VALUES (70389, '64.80.15664380667980233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:07', 3, 0, '', '2019-08-22 09:41:07');
INSERT INTO `access_log` VALUES (70390, '59.78.15664380695999861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:10', 3, 0, '', '2019-08-22 09:41:10');
INSERT INTO `access_log` VALUES (70391, '59.76.15664380695999843', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:10', 20, 2001001000, '服务端发生异常', '2019-08-22 09:41:10');
INSERT INTO `access_log` VALUES (70392, '59.72.15664380797409853', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:20', 3, 0, '', '2019-08-22 09:41:20');
INSERT INTO `access_log` VALUES (70393, '59.75.15664380797409859', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:20', 15, 2001001000, '服务端发生异常', '2019-08-22 09:41:20');
INSERT INTO `access_log` VALUES (70394, '59.80.15664380892479827', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:29', 3, 0, '', '2019-08-22 09:41:29');
INSERT INTO `access_log` VALUES (70395, '59.73.15664380892489855', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:29', 16, 2001001000, '服务端发生异常', '2019-08-22 09:41:29');
INSERT INTO `access_log` VALUES (70396, '59.79.15664380947589855', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:35', 2, 0, '', '2019-08-22 09:41:35');
INSERT INTO `access_log` VALUES (70397, '59.71.15664380947589853', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:35', 13, 2001001000, '服务端发生异常', '2019-08-22 09:41:35');
INSERT INTO `access_log` VALUES (70398, '64.83.15664380958340229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:36', 3, 0, '', '2019-08-22 09:41:36');
INSERT INTO `access_log` VALUES (70399, '64.77.15664380959610219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:36', 2, 0, '', '2019-08-22 09:41:36');
INSERT INTO `access_log` VALUES (70400, '59.78.15664380980969863', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:38', 2, 0, '', '2019-08-22 09:41:38');
INSERT INTO `access_log` VALUES (70401, '59.76.15664380980979845', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:38', 18, 2001001000, '服务端发生异常', '2019-08-22 09:41:38');
INSERT INTO `access_log` VALUES (70402, '65.47.15664381153502979', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:55', 1, 1002001015, '账号未登陆', '2019-08-22 09:41:55');
INSERT INTO `access_log` VALUES (70403, '65.50.15664381153503031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:55', 1, 1002001015, '账号未登陆', '2019-08-22 09:41:55');
INSERT INTO `access_log` VALUES (70404, '65.49.15664381153503045', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:55', 0, 1002001015, '账号未登陆', '2019-08-22 09:41:55');
INSERT INTO `access_log` VALUES (70405, '65.54.15664381174752927', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:41:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-22 09:41:57');
INSERT INTO `access_log` VALUES (70406, '65.46.15664381278793069', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.213.108.76', '2019-08-22 09:42:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-22 09:42:08');
INSERT INTO `access_log` VALUES (70407, '59.75.15664411212159901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.192.178.185', '2019-08-22 10:32:01', 10, 0, '', '2019-08-22 10:32:01');
INSERT INTO `access_log` VALUES (70408, '59.72.15664411212159895', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.192.178.185', '2019-08-22 10:32:01', 18, 2001001000, '服务端发生异常', '2019-08-22 10:32:01');
INSERT INTO `access_log` VALUES (70409, '64.79.15664411237560269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.192.178.185', '2019-08-22 10:32:04', 13, 0, '', '2019-08-22 10:32:04');
INSERT INTO `access_log` VALUES (70410, '64.81.15664411238960275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.192.178.185', '2019-08-22 10:32:04', 3, 0, '', '2019-08-22 10:32:04');
INSERT INTO `access_log` VALUES (70411, '64.78.15664411249080291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.192.178.185', '2019-08-22 10:32:05', 2, 0, '', '2019-08-22 10:32:05');
INSERT INTO `access_log` VALUES (70412, '64.76.15664411253590279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '221.192.178.185', '2019-08-22 10:32:05', 2, 0, '', '2019-08-22 10:32:05');
INSERT INTO `access_log` VALUES (70413, '59.77.15664428001169903', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '219.147.2.35', '2019-08-22 11:00:00', 3, 0, '', '2019-08-22 11:00:00');
INSERT INTO `access_log` VALUES (70414, '59.79.15664428003699919', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '219.147.2.35', '2019-08-22 11:00:00', 30, 2001001000, '服务端发生异常', '2019-08-22 11:00:00');
INSERT INTO `access_log` VALUES (70415, '65.51.15664429413913167', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '219.147.2.35', '2019-08-22 11:02:21', 1, 1002001015, '账号未登陆', '2019-08-22 11:02:21');
INSERT INTO `access_log` VALUES (70416, '65.3607.15664429413924901', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '219.147.2.35', '2019-08-22 11:02:21', 0, 1002001015, '账号未登陆', '2019-08-22 11:02:21');
INSERT INTO `access_log` VALUES (70417, '65.47.15664429414153043', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '219.147.2.35', '2019-08-22 11:02:21', 0, 1002001015, '账号未登陆', '2019-08-22 11:02:21');
INSERT INTO `access_log` VALUES (70418, '65.50.15664429435063095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '219.147.2.35', '2019-08-22 11:02:24', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-22 11:02:24');
INSERT INTO `access_log` VALUES (70419, '65.46.15664429479053133', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '219.147.2.35', '2019-08-22 11:02:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-22 11:02:28');
INSERT INTO `access_log` VALUES (70420, '65.54.15664429558472995', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '219.147.2.35', '2019-08-22 11:02:36', 84, 0, '', '2019-08-22 11:02:36');
INSERT INTO `access_log` VALUES (70421, '65.52.15664429562763149', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '219.147.2.35', '2019-08-22 11:02:36', 223, 0, '', '2019-08-22 11:02:36');
INSERT INTO `access_log` VALUES (70422, '65.45.15664429562873119', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '219.147.2.35', '2019-08-22 11:02:36', 221, 0, '', '2019-08-22 11:02:37');
INSERT INTO `access_log` VALUES (70423, '65.53.15664429562853051', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '219.147.2.35', '2019-08-22 11:02:36', 223, 2001001000, '服务端发生异常', '2019-08-22 11:02:37');
INSERT INTO `access_log` VALUES (70424, '65.50.15664429839533097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '219.147.2.35', '2019-08-22 11:03:04', 10, 0, '', '2019-08-22 11:03:04');
INSERT INTO `access_log` VALUES (70425, '65.47.15664429839523045', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '219.147.2.35', '2019-08-22 11:03:04', 11, 2001001000, '服务端发生异常', '2019-08-22 11:03:04');
INSERT INTO `access_log` VALUES (70426, '65.49.15664429839583111', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '219.147.2.35', '2019-08-22 11:03:04', 17, 0, '', '2019-08-22 11:03:04');
INSERT INTO `access_log` VALUES (70427, '59.74.15664447901589961', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.107.59', '2019-08-22 11:33:10', 9, 0, '', '2019-08-22 11:33:10');
INSERT INTO `access_log` VALUES (70428, '59.72.15664447901629945', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.107.59', '2019-08-22 11:33:10', 14, 2001001000, '服务端发生异常', '2019-08-22 11:33:10');
INSERT INTO `access_log` VALUES (70429, '65.47.15664447965283069', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.107.59', '2019-08-22 11:33:17', 5, 1002001012, '访问令牌已过期', '2019-08-22 11:33:17');
INSERT INTO `access_log` VALUES (70430, '65.51.15664447965283193', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.107.59', '2019-08-22 11:33:17', 6, 1002001012, '访问令牌已过期', '2019-08-22 11:33:17');
INSERT INTO `access_log` VALUES (70431, '65.50.15664447965523123', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.107.59', '2019-08-22 11:33:17', 3, 1002001012, '访问令牌已过期', '2019-08-22 11:33:17');
INSERT INTO `access_log` VALUES (70432, '65.49.15664447983933137', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.107.59', '2019-08-22 11:33:18', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-22 11:33:18');
INSERT INTO `access_log` VALUES (70433, '65.54.15664448117023023', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.107.59', '2019-08-22 11:33:32', 128, 0, '', '2019-08-22 11:33:32');
INSERT INTO `access_log` VALUES (70434, '65.45.15664448121893145', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.107.59', '2019-08-22 11:33:32', 11, 0, '', '2019-08-22 11:33:32');
INSERT INTO `access_log` VALUES (70435, '65.53.15664448121943079', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.107.59', '2019-08-22 11:33:32', 10, 2001001000, '服务端发生异常', '2019-08-22 11:33:32');
INSERT INTO `access_log` VALUES (70436, '65.52.15664448121963177', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.107.59', '2019-08-22 11:33:32', 9, 0, '', '2019-08-22 11:33:32');
INSERT INTO `access_log` VALUES (70437, '65.3607.15664448180014931', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.107.59', '2019-08-22 11:33:38', 9, 0, '', '2019-08-22 11:33:38');
INSERT INTO `access_log` VALUES (70438, '65.47.15664448180063071', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.107.59', '2019-08-22 11:33:38', 10, 2001001000, '服务端发生异常', '2019-08-22 11:33:38');
INSERT INTO `access_log` VALUES (70439, '65.51.15664448180133195', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.246.107.59', '2019-08-22 11:33:38', 9, 0, '', '2019-08-22 11:33:38');
INSERT INTO `access_log` VALUES (70440, '65.54.15664453113053031', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.142.132.142', '2019-08-22 11:41:51', 0, 1002001015, '账号未登陆', '2019-08-22 11:41:51');
INSERT INTO `access_log` VALUES (70441, '65.52.15664453113093185', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.142.132.142', '2019-08-22 11:41:51', 0, 1002001015, '账号未登陆', '2019-08-22 11:41:51');
INSERT INTO `access_log` VALUES (70442, '65.45.15664453113163153', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.142.132.142', '2019-08-22 11:41:51', 1, 1002001015, '账号未登陆', '2019-08-22 11:41:51');
INSERT INTO `access_log` VALUES (70443, '65.53.15664453138453087', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.142.132.142', '2019-08-22 11:41:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-22 11:41:54');
INSERT INTO `access_log` VALUES (70444, '65.51.15664453223113203', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.142.132.142', '2019-08-22 11:42:02', 93, 0, '', '2019-08-22 11:42:02');
INSERT INTO `access_log` VALUES (70445, '65.47.15664453227073079', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.142.132.142', '2019-08-22 11:42:03', 10, 0, '', '2019-08-22 11:42:03');
INSERT INTO `access_log` VALUES (70446, '65.50.15664453227163133', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.142.132.142', '2019-08-22 11:42:03', 10, 2001001000, '服务端发生异常', '2019-08-22 11:42:03');
INSERT INTO `access_log` VALUES (70447, '65.49.15664453227223147', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.142.132.142', '2019-08-22 11:42:03', 9, 0, '', '2019-08-22 11:42:03');
INSERT INTO `access_log` VALUES (70448, '65.52.15664453527733187', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.142.132.142', '2019-08-22 11:42:33', 9, 0, '', '2019-08-22 11:42:33');
INSERT INTO `access_log` VALUES (70449, '65.45.15664453527793155', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.142.132.142', '2019-08-22 11:42:33', 10, 2001001000, '服务端发生异常', '2019-08-22 11:42:33');
INSERT INTO `access_log` VALUES (70450, '65.53.15664453527833089', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.142.132.142', '2019-08-22 11:42:33', 9, 0, '', '2019-08-22 11:42:33');
INSERT INTO `access_log` VALUES (70451, '65.51.15664453575413205', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.142.132.142', '2019-08-22 11:42:38', 16, 0, '', '2019-08-22 11:42:38');
INSERT INTO `access_log` VALUES (70452, '65.3607.15664453575404941', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.142.132.142', '2019-08-22 11:42:38', 18, 2001001000, '服务端发生异常', '2019-08-22 11:42:38');
INSERT INTO `access_log` VALUES (70453, '65.50.15664453575423135', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '219.142.132.142', '2019-08-22 11:42:38', 19, 0, '', '2019-08-22 11:42:38');
INSERT INTO `access_log` VALUES (70454, '5ad53820-6040-426f-bcbe-90350f524a7b', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:03:47', 111, 0, '', '2019-08-22 12:03:47');
INSERT INTO `access_log` VALUES (70455, '3998564a-e780-4581-9e72-0e88834d610e', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:03:47', 14, 0, '', '2019-08-22 12:03:48');
INSERT INTO `access_log` VALUES (70456, 'ebd3ef2e-1b18-45f4-b9a2-b5528d29c3e0', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:03:50', 12, 0, '', '2019-08-22 12:03:50');
INSERT INTO `access_log` VALUES (70457, '7ac9dd4e-871c-4f95-ba39-262f6e7fdd82', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:03:51', 15, 0, '', '2019-08-22 12:03:51');
INSERT INTO `access_log` VALUES (70458, 'ca5a7ee9-c320-4916-937e-1d6e215a70a5', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:03:51', 821, 2001001000, '服务端发生异常', '2019-08-22 12:03:52');
INSERT INTO `access_log` VALUES (70459, '0a372ee7-8f4e-4849-9268-efd228db4157', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:03:55', 305, 2001001000, '服务端发生异常', '2019-08-22 12:03:56');
INSERT INTO `access_log` VALUES (70460, '585381f1-03d8-4c30-ad5b-afcaa4e48c8e', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:03:58', 11, 0, '', '2019-08-22 12:03:58');
INSERT INTO `access_log` VALUES (70461, '1111fe7f-79c8-489c-8f4e-dc18b08a0898', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:03:58', 12, 0, '', '2019-08-22 12:03:58');
INSERT INTO `access_log` VALUES (70462, 'b4c1b9fa-d73e-4a5b-83bd-7083e07dd87e', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:04:01', 11, 0, '', '2019-08-22 12:04:01');
INSERT INTO `access_log` VALUES (70463, '8cc6ffb7-3be2-433c-9e48-d460091d9f70', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:04:01', 184, 2001001000, '服务端发生异常', '2019-08-22 12:04:01');
INSERT INTO `access_log` VALUES (70464, '59e7a5a7-807d-4820-8319-cc0a7ac57bf7', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:04:04', 9, 0, '', '2019-08-22 12:04:04');
INSERT INTO `access_log` VALUES (70465, '91a726dc-cec1-48bd-bf7b-5b0457447cd0', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:04:04', 11, 0, '', '2019-08-22 12:04:04');
INSERT INTO `access_log` VALUES (70466, 'ac6eda41-d34b-41b1-9265-3379c9d82472', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=1223489646&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:04:20', 168, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-08-22 12:04:20');
INSERT INTO `access_log` VALUES (70467, '246edee3-f681-46b7-8ca2-091bb6d07a3a', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17602176892&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:04:33', 207, 2001001000, '服务端发生异常', '2019-08-22 12:04:33');
INSERT INTO `access_log` VALUES (70468, '19a26f80-83be-495f-953d-eb1a1459948a', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17602176892&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:04:38', 141, 2001001000, '服务端发生异常', '2019-08-22 12:04:38');
INSERT INTO `access_log` VALUES (70469, '6e6a0a57-075b-481b-821e-662a0e2c76c7', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:04:42', 10, 0, '', '2019-08-22 12:04:42');
INSERT INTO `access_log` VALUES (70470, '61645dde-ae6b-4881-92e3-42668cf88f14', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:04:42', 12, 0, '', '2019-08-22 12:04:42');
INSERT INTO `access_log` VALUES (70471, '3a30240c-e154-49d2-bc75-0289af0f6ea4', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:04:45', 12, 0, '', '2019-08-22 12:04:45');
INSERT INTO `access_log` VALUES (70472, 'bdd07a90-57e0-4e06-8542-237c10e8746b', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:04:45', 12, 0, '', '2019-08-22 12:04:45');
INSERT INTO `access_log` VALUES (70473, 'd7597cef-93bc-492d-84cf-4a775afe55c3', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18777777777&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:05:31', 108, 2001001000, '服务端发生异常', '2019-08-22 12:05:31');
INSERT INTO `access_log` VALUES (70474, 'f532e6bd-1bf5-406b-97bf-0f689a3ebeec', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:05:38', 1537, 0, '', '2019-08-22 12:05:40');
INSERT INTO `access_log` VALUES (70475, 'f6b5fee4-ba12-4089-86d1-36e2b63864bd', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:05:38', 1538, 0, '', '2019-08-22 12:05:40');
INSERT INTO `access_log` VALUES (70476, '1e1a7c77-59c1-4400-946a-14835ffca698', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:05:38', 1541, 0, '', '2019-08-22 12:05:40');
INSERT INTO `access_log` VALUES (70477, '0de4904a-66a6-4e40-9017-3a06007363ed', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:03:42', 117814, 0, '', '2019-08-22 12:05:40');
INSERT INTO `access_log` VALUES (70478, '099bc0d3-5253-4ec2-b8b9-5191cec73c7e', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:05:38', 5011, 2001001000, '服务端发生异常', '2019-08-22 12:05:43');
INSERT INTO `access_log` VALUES (70479, '66ee9af9-9cf2-419d-bbe9-42c06e061502', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:03:42', 121435, 2001001000, '服务端发生异常', '2019-08-22 12:05:43');
INSERT INTO `access_log` VALUES (70480, '7af0ba11-bc3d-4cd1-baf4-cd20557b1a25', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:05:38', 5156, 2001001000, '服务端发生异常', '2019-08-22 12:05:43');
INSERT INTO `access_log` VALUES (70481, '7668eb8d-17ec-4f66-b7aa-94f9e6244b58', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:05:38', 5190, 2001001000, '服务端发生异常', '2019-08-22 12:05:43');
INSERT INTO `access_log` VALUES (70482, '380c51c4-7ddc-4a77-963b-2629512b88cf', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:06:32', 11, 0, '', '2019-08-22 12:06:32');
INSERT INTO `access_log` VALUES (70483, '8824cca7-0147-4480-bea0-aa3bb5f65340', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:06:32', 134, 0, '', '2019-08-22 12:06:32');
INSERT INTO `access_log` VALUES (70484, '700fa63e-a13a-4cf5-8bb7-dac1847cbbf8', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:06:42', 10, 0, '', '2019-08-22 12:06:42');
INSERT INTO `access_log` VALUES (70485, '16124843-494c-4760-b1f0-23891d318406', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:06:42', 9, 0, '', '2019-08-22 12:06:42');
INSERT INTO `access_log` VALUES (70486, 'edf24cd2-4716-4244-a4fc-eba9073aa11e', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:06:44', 10, 0, '', '2019-08-22 12:06:44');
INSERT INTO `access_log` VALUES (70487, 'fc5cbeec-c3ac-4a9b-b555-0e41ee1631ce', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:06:44', 23, 0, '', '2019-08-22 12:06:44');
INSERT INTO `access_log` VALUES (70488, 'b8224198-7807-47cf-89a9-67d072aff932', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:06:46', 10, 0, '', '2019-08-22 12:06:46');
INSERT INTO `access_log` VALUES (70489, '7573d9df-845e-4acc-8467-9d9ef031408a', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:06:46', 10, 0, '', '2019-08-22 12:06:46');
INSERT INTO `access_log` VALUES (70490, '15a7d40d-f8d0-433b-b5ed-d810871dcdc4', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:06:48', 10, 0, '', '2019-08-22 12:06:48');
INSERT INTO `access_log` VALUES (70491, 'f573bd88-1dc7-4b52-aa1a-5ad3104e0106', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:06:48', 24, 0, '', '2019-08-22 12:06:48');
INSERT INTO `access_log` VALUES (70492, '74888b06-029e-492f-8f7f-99a3ec052510', 0, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:06:59', 36, 1002001015, '账号未登陆', '2019-08-22 12:06:59');
INSERT INTO `access_log` VALUES (70493, '54098eab-0436-42d9-9caa-a7efe1e6bd4f', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15579872216&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:07:23', 100, 2001001000, '服务端发生异常', '2019-08-22 12:07:23');
INSERT INTO `access_log` VALUES (70494, 'fca7547d-8a86-477a-8343-a7b02b0c5724', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:09:25', 17, 0, '', '2019-08-22 12:09:26');
INSERT INTO `access_log` VALUES (70495, '6b389049-3ef0-4ed1-a20c-20404c7a19fd', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:09:26', 36, 0, '', '2019-08-22 12:09:26');
INSERT INTO `access_log` VALUES (70496, '38098464-11e1-43a0-85a5-21e2aeb47e21', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18777777777&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:20:33', 157, 2001001000, '服务端发生异常', '2019-08-22 12:20:33');
INSERT INTO `access_log` VALUES (70497, 'c5a865df-a5d2-4b1b-9de3-aaf461078a5b', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18777777777&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:20:45', 117, 2001001000, '服务端发生异常', '2019-08-22 12:20:45');
INSERT INTO `access_log` VALUES (70498, 'f6cc26d1-fad6-4f22-819c-b5b8368972d4', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18777777777&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:22:04', 112, 2001001000, '服务端发生异常', '2019-08-22 12:22:04');
INSERT INTO `access_log` VALUES (70499, '25b5d3d8-fa30-4512-99fa-248386c3029e', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18777777777&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:22:34', 12568, 2001001000, '服务端发生异常', '2019-08-22 12:22:46');
INSERT INTO `access_log` VALUES (70500, 'f0b96422-cdb7-4551-8cca-2b1580911ff3', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18777777777&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:23:11', 11015, 2001001000, '服务端发生异常', '2019-08-22 12:23:22');
INSERT INTO `access_log` VALUES (70501, '65.53.15664479657893125', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '123.58.107.138', '2019-08-22 12:26:06', 0, 1002001015, '账号未登陆', '2019-08-22 12:26:06');
INSERT INTO `access_log` VALUES (70502, '65.52.15664479657883223', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '123.58.107.138', '2019-08-22 12:26:06', 0, 1002001015, '账号未登陆', '2019-08-22 12:26:06');
INSERT INTO `access_log` VALUES (70503, '65.45.15664479657893191', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '123.58.107.138', '2019-08-22 12:26:06', 0, 1002001015, '账号未登陆', '2019-08-22 12:26:06');
INSERT INTO `access_log` VALUES (70504, '65.50.15664479769063171', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '123.58.107.138', '2019-08-22 12:26:17', 68, 0, '', '2019-08-22 12:26:17');
INSERT INTO `access_log` VALUES (70505, '65.51.15664479778043241', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '123.58.107.138', '2019-08-22 12:26:18', 11, 0, '', '2019-08-22 12:26:18');
INSERT INTO `access_log` VALUES (70506, '65.49.15664479778143185', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '123.58.107.138', '2019-08-22 12:26:18', 11, 2001001000, '服务端发生异常', '2019-08-22 12:26:18');
INSERT INTO `access_log` VALUES (70507, '65.47.15664479778433117', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '123.58.107.138', '2019-08-22 12:26:18', 9, 0, '', '2019-08-22 12:26:18');
INSERT INTO `access_log` VALUES (70508, '65.53.15664526566533189', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '144.48.5.31', '2019-08-22 13:44:17', 0, 1002001015, '账号未登陆', '2019-08-22 13:44:17');
INSERT INTO `access_log` VALUES (70509, '65.45.15664526566543255', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '144.48.5.31', '2019-08-22 13:44:17', 1, 1002001015, '账号未登陆', '2019-08-22 13:44:17');
INSERT INTO `access_log` VALUES (70510, '65.52.15664526566603287', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '144.48.5.31', '2019-08-22 13:44:17', 0, 1002001015, '账号未登陆', '2019-08-22 13:44:17');
INSERT INTO `access_log` VALUES (70511, '65.54.15664533488753143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '144.48.5.31', '2019-08-22 13:55:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-22 13:55:49');
INSERT INTO `access_log` VALUES (70512, '65.3607.15664538285575057', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.35.92', '2019-08-22 14:03:49', 0, 1002001015, '账号未登陆', '2019-08-22 14:03:49');
INSERT INTO `access_log` VALUES (70513, '65.45.15664538285563271', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.35.92', '2019-08-22 14:03:49', 0, 1002001015, '账号未登陆', '2019-08-22 14:03:49');
INSERT INTO `access_log` VALUES (70514, '65.50.15664538285573251', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.35.92', '2019-08-22 14:03:49', 0, 1002001015, '账号未登陆', '2019-08-22 14:03:49');
INSERT INTO `access_log` VALUES (70515, '65.49.15664538305573265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.35.92', '2019-08-22 14:03:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-22 14:03:51');
INSERT INTO `access_log` VALUES (70516, '65.47.15664538403863197', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.35.92', '2019-08-22 14:04:00', 85, 0, '', '2019-08-22 14:04:00');
INSERT INTO `access_log` VALUES (70517, '65.53.15664538407963207', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.35.92', '2019-08-22 14:04:01', 12, 0, '', '2019-08-22 14:04:01');
INSERT INTO `access_log` VALUES (70518, '65.54.15664538407963151', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.35.92', '2019-08-22 14:04:01', 13, 2001001000, '服务端发生异常', '2019-08-22 14:04:01');
INSERT INTO `access_log` VALUES (70519, '65.46.15664538407963289', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.136.35.92', '2019-08-22 14:04:01', 13, 0, '', '2019-08-22 14:04:01');
INSERT INTO `access_log` VALUES (70520, '1d185148-57a7-46a7-baa7-8011511ae607', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '127.0.0.1', '2019-08-22 14:07:51', 46, 1002001015, '账号未登陆', '2019-08-22 14:07:51');
INSERT INTO `access_log` VALUES (70521, 'ec9d0c76-9ff1-410d-914a-b4c186c38981', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '127.0.0.1', '2019-08-22 14:07:51', 46, 1002001015, '账号未登陆', '2019-08-22 14:07:51');
INSERT INTO `access_log` VALUES (70522, '16d3e732-4c8d-43a5-a436-9cead3ea1c70', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '127.0.0.1', '2019-08-22 14:07:51', 48, 1002001015, '账号未登陆', '2019-08-22 14:07:51');
INSERT INTO `access_log` VALUES (70523, '05dd0412-83cd-41ad-934a-f6bcf03e7f7a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '127.0.0.1', '2019-08-22 14:07:57', 228, 1002002001, '密码不正确', '2019-08-22 14:07:58');
INSERT INTO `access_log` VALUES (70524, 'c31ed60d-4254-4db9-8357-65bc62417341', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:08:21', 1, 1002001015, '账号未登陆', '2019-08-22 14:08:21');
INSERT INTO `access_log` VALUES (70525, 'c1bc74af-abfc-4bf4-a7f6-e894204c5367', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:08:21', 1, 1002001015, '账号未登陆', '2019-08-22 14:08:21');
INSERT INTO `access_log` VALUES (70526, 'fe450bd8-5c1a-460c-9fe9-76498ffc217d', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:08:21', 2, 1002001015, '账号未登陆', '2019-08-22 14:08:21');
INSERT INTO `access_log` VALUES (70527, '1efef8c6-3ff3-410b-a54e-0748bbd0e6e5', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:08:54', 13, 1002002001, '密码不正确', '2019-08-22 14:08:54');
INSERT INTO `access_log` VALUES (70528, 'b7460ebb-469b-405a-ae74-9da507ca57e7', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:14:01', 58, 1002002001, '密码不正确', '2019-08-22 14:14:01');
INSERT INTO `access_log` VALUES (70529, '5567eb9e-fb14-49d5-bd29-5d17f1095df8', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:14:08', 31, 1002002001, '密码不正确', '2019-08-22 14:14:08');
INSERT INTO `access_log` VALUES (70530, 'd890cfb2-4af8-4109-92f3-fb38d30651b3', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=123456&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:16:06', 51, 1002002001, '密码不正确', '2019-08-22 14:16:06');
INSERT INTO `access_log` VALUES (70531, 'e74fcab3-a5d7-47a7-a1d4-01915880fae3', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:20:41', 111, 1002002001, '密码不正确', '2019-08-22 14:20:41');
INSERT INTO `access_log` VALUES (70532, 'dd56e4cb-c050-4d08-b320-c8421d1ccd36', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:24:18', 40, 1002002001, '密码不正确', '2019-08-22 14:24:18');
INSERT INTO `access_log` VALUES (70533, '758e5bbd-6318-4a12-b037-ae17b76ad046', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 14:24:52', 21, 1002002001, '密码不正确', '2019-08-22 14:24:52');
INSERT INTO `access_log` VALUES (70534, 'ca918a5c-4df6-495c-8d1e-5e6a6d8ad322', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=e10adc3949ba59abbe56e057f20f883e&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:25:16', 19, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 4-16 位', '2019-08-22 14:25:16');
INSERT INTO `access_log` VALUES (70535, 'd04cb945-e3ba-4f59-825e-2fea60caf913', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:25:35', 20142, 1002002001, '密码不正确', '2019-08-22 14:25:55');
INSERT INTO `access_log` VALUES (70536, 'f592bac7-fcbd-4037-8dc2-d751b6bbc951', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:26:07', 20160, 1002002001, '密码不正确', '2019-08-22 14:26:27');
INSERT INTO `access_log` VALUES (70537, '8c09dc87-20e6-4efc-a7b6-2fd84644ab13', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:29:57', 47049, 2001001000, '服务端发生异常', '2019-08-22 14:30:44');
INSERT INTO `access_log` VALUES (70538, 'bbdbab16-63b2-4c4f-b661-3053e291761b', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:32:07', 18, 1002002001, '密码不正确', '2019-08-22 14:32:07');
INSERT INTO `access_log` VALUES (70539, 'cd1c2916-354d-422e-ad0b-5af27ac5b9dd', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:32:11', 69545, 2001001000, '服务端发生异常', '2019-08-22 14:33:21');
INSERT INTO `access_log` VALUES (70540, '05898764-48b6-436c-b553-f18c6bac868c', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:33:49', 183, 2001001000, '服务端发生异常', '2019-08-22 14:33:49');
INSERT INTO `access_log` VALUES (70541, '65.50.15664565494373289', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:49:09', 0, 1002001015, '账号未登陆', '2019-08-22 14:49:09');
INSERT INTO `access_log` VALUES (70542, '65.3607.15664565494395095', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:49:09', 0, 1002001015, '账号未登陆', '2019-08-22 14:49:09');
INSERT INTO `access_log` VALUES (70543, '65.45.15664565494393309', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:49:09', 0, 1002001015, '账号未登陆', '2019-08-22 14:49:09');
INSERT INTO `access_log` VALUES (70544, '65.46.15664565948583327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:49:55', 79, 0, '', '2019-08-22 14:49:55');
INSERT INTO `access_log` VALUES (70545, '65.52.15664565952323343', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:49:55', 14, 0, '', '2019-08-22 14:49:55');
INSERT INTO `access_log` VALUES (70546, '65.3607.15664565952385097', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:49:55', 11, 0, '', '2019-08-22 14:49:55');
INSERT INTO `access_log` VALUES (70547, '65.45.15664565952383311', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:49:55', 12, 2001001000, '服务端发生异常', '2019-08-22 14:49:55');
INSERT INTO `access_log` VALUES (70548, '65.50.15664566081963291', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:50:08', 10, 0, '', '2019-08-22 14:50:08');
INSERT INTO `access_log` VALUES (70549, '65.49.15664566081963305', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:50:08', 11, 0, '', '2019-08-22 14:50:08');
INSERT INTO `access_log` VALUES (70550, '65.51.15664566081973361', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:50:08', 10, 2001001000, '服务端发生异常', '2019-08-22 14:50:08');
INSERT INTO `access_log` VALUES (70551, '65.46.15664566408943329', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:50:41', 17, 0, '', '2019-08-22 14:50:41');
INSERT INTO `access_log` VALUES (70552, '65.45.15664566409063313', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:50:41', 8, 0, '', '2019-08-22 14:50:41');
INSERT INTO `access_log` VALUES (70553, '65.3607.15664566408985099', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:50:41', 9, 2001001000, '服务端发生异常', '2019-08-22 14:50:41');
INSERT INTO `access_log` VALUES (70554, '65.52.15664566447183345', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:50:45', 9, 0, '', '2019-08-22 14:50:45');
INSERT INTO `access_log` VALUES (70555, '65.50.15664566447193293', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:50:45', 8, 0, '', '2019-08-22 14:50:45');
INSERT INTO `access_log` VALUES (70556, '65.51.15664566447203363', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '123.138.78.129', '2019-08-22 14:50:45', 9, 2001001000, '服务端发生异常', '2019-08-22 14:50:45');
INSERT INTO `access_log` VALUES (70557, '65.49.15664587001073337', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.216.34', '2019-08-22 15:25:00', 4, 1002001012, '访问令牌已过期', '2019-08-22 15:25:00');
INSERT INTO `access_log` VALUES (70558, '65.51.15664587000963391', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.216.34', '2019-08-22 15:25:00', 13, 1002001012, '访问令牌已过期', '2019-08-22 15:25:00');
INSERT INTO `access_log` VALUES (70559, '65.47.15664587001313269', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.216.34', '2019-08-22 15:25:00', 10, 1002001012, '访问令牌已过期', '2019-08-22 15:25:00');
INSERT INTO `access_log` VALUES (70560, '65.54.15664589981213225', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.216.34', '2019-08-22 15:29:58', 87, 0, '', '2019-08-22 15:29:58');
INSERT INTO `access_log` VALUES (70561, '65.53.15664589988893285', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.216.34', '2019-08-22 15:29:59', 11, 0, '', '2019-08-22 15:29:59');
INSERT INTO `access_log` VALUES (70562, '65.45.15664589988973351', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.216.34', '2019-08-22 15:29:59', 11, 2001001000, '服务端发生异常', '2019-08-22 15:29:59');
INSERT INTO `access_log` VALUES (70563, '65.3607.15664589989545131', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.216.34', '2019-08-22 15:29:59', 10, 0, '', '2019-08-22 15:29:59');
INSERT INTO `access_log` VALUES (70564, '65.49.15664590524903343', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.216.34', '2019-08-22 15:30:52', 10, 0, '', '2019-08-22 15:30:53');
INSERT INTO `access_log` VALUES (70565, '65.47.15664590524983275', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.216.34', '2019-08-22 15:30:52', 11, 2001001000, '服务端发生异常', '2019-08-22 15:30:53');
INSERT INTO `access_log` VALUES (70566, '65.51.15664590525023397', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '58.59.216.34', '2019-08-22 15:30:53', 9, 0, '', '2019-08-22 15:30:53');
INSERT INTO `access_log` VALUES (70567, 'c33b918d-d3d2-47a4-a785-fdebb96d6f7a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 15:42:53', 459, 2001001000, '服务端发生异常', '2019-08-22 15:42:54');
INSERT INTO `access_log` VALUES (70568, 'd74a21ba-eb76-4001-91b5-ba6e1f4d6112', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 15:47:14', 164, 2001001000, '服务端发生异常', '2019-08-22 15:47:14');
INSERT INTO `access_log` VALUES (70569, '5d846f6c-1929-4481-99f0-8b2336a7147e', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 15:53:35', 460, 2001001000, '服务端发生异常', '2019-08-22 15:53:35');
INSERT INTO `access_log` VALUES (70570, 'a715cf50-86c3-47fc-9c59-13f3bc8bd831', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 15:54:15', 12, 1002002001, '密码不正确', '2019-08-22 15:54:15');
INSERT INTO `access_log` VALUES (70571, '7234b3c9-8b9b-40f1-a100-bc67eb17bb9c', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 15:54:33', 29096, 2001001000, '服务端发生异常', '2019-08-22 15:55:02');
INSERT INTO `access_log` VALUES (70572, '6abc7824-37e3-44ae-ad7d-e129fefbdc73', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 16:00:05', 17, 1002002001, '密码不正确', '2019-08-22 16:00:05');
INSERT INTO `access_log` VALUES (70573, '0ad02e5d-930d-4da1-ae1e-7bc4b5960354', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 16:02:55', 47, 1002002001, '密码不正确', '2019-08-22 16:02:55');
INSERT INTO `access_log` VALUES (70574, '65eb7852-3573-4d81-9756-839c48d5b8b4', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 16:03:01', 51637, 2001001000, '服务端发生异常', '2019-08-22 16:03:53');
INSERT INTO `access_log` VALUES (70575, '65.46.15664631726883419', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.236.186.77', '2019-08-22 16:39:33', 0, 1002001015, '账号未登陆', '2019-08-22 16:39:33');
INSERT INTO `access_log` VALUES (70576, '65.45.15664631726903407', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.236.186.77', '2019-08-22 16:39:33', 0, 1002001015, '账号未登陆', '2019-08-22 16:39:33');
INSERT INTO `access_log` VALUES (70577, '65.50.15664631727123385', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.236.186.77', '2019-08-22 16:39:33', 0, 1002001015, '账号未登陆', '2019-08-22 16:39:33');
INSERT INTO `access_log` VALUES (70578, '65.53.15664631754993343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.236.186.77', '2019-08-22 16:39:35', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-22 16:39:36');
INSERT INTO `access_log` VALUES (70579, '65.51.15664631822783455', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.236.186.77', '2019-08-22 16:39:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-22 16:39:42');
INSERT INTO `access_log` VALUES (70580, '59.74.15664635059800211', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '120.236.186.77', '2019-08-22 16:45:06', 10, 0, '', '2019-08-22 16:45:06');
INSERT INTO `access_log` VALUES (70581, '59.72.15664635059820195', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '120.236.186.77', '2019-08-22 16:45:06', 22, 2001001000, '服务端发生异常', '2019-08-22 16:45:06');
INSERT INTO `access_log` VALUES (70582, '64.81.15664635173570575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '120.236.186.77', '2019-08-22 16:45:17', 12, 0, '', '2019-08-22 16:45:17');
INSERT INTO `access_log` VALUES (70583, '64.78.15664635175200591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '120.236.186.77', '2019-08-22 16:45:18', 3, 0, '', '2019-08-22 16:45:18');
INSERT INTO `access_log` VALUES (70584, '64.76.15664635201600579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '120.236.186.77', '2019-08-22 16:45:20', 2, 0, '', '2019-08-22 16:45:20');
INSERT INTO `access_log` VALUES (70585, '64.85.15664635248230607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '120.236.186.77', '2019-08-22 16:45:25', 2, 0, '', '2019-08-22 16:45:25');
INSERT INTO `access_log` VALUES (70586, '64.82.15664635249370587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '120.236.186.77', '2019-08-22 16:45:25', 1, 0, '', '2019-08-22 16:45:25');
INSERT INTO `access_log` VALUES (70587, '65.52.15664636091133439', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.236.186.77', '2019-08-22 16:46:49', 71, 0, '', '2019-08-22 16:46:49');
INSERT INTO `access_log` VALUES (70588, '65.51.15664636095673461', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.236.186.77', '2019-08-22 16:46:50', 10, 0, '', '2019-08-22 16:46:50');
INSERT INTO `access_log` VALUES (70589, '65.3607.15664636095735195', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.236.186.77', '2019-08-22 16:46:50', 10, 2001001000, '服务端发生异常', '2019-08-22 16:46:50');
INSERT INTO `access_log` VALUES (70590, '65.47.15664636096183339', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.236.186.77', '2019-08-22 16:46:50', 10, 0, '', '2019-08-22 16:46:50');
INSERT INTO `access_log` VALUES (70591, '65.52.15664662771243479', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.152.99.34', '2019-08-22 17:31:17', 0, 1002001015, '账号未登陆', '2019-08-22 17:31:17');
INSERT INTO `access_log` VALUES (70592, '65.3607.15664662771255231', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.152.99.34', '2019-08-22 17:31:17', 0, 1002001015, '账号未登陆', '2019-08-22 17:31:17');
INSERT INTO `access_log` VALUES (70593, '65.51.15664662771293499', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.152.99.34', '2019-08-22 17:31:17', 1, 1002001015, '账号未登陆', '2019-08-22 17:31:17');
INSERT INTO `access_log` VALUES (70594, '65.49.15664662843293445', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.152.99.34', '2019-08-22 17:31:24', 86, 0, '', '2019-08-22 17:31:24');
INSERT INTO `access_log` VALUES (70595, '65.54.15664662848513329', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.152.99.34', '2019-08-22 17:31:25', 18, 0, '', '2019-08-22 17:31:25');
INSERT INTO `access_log` VALUES (70596, '65.46.15664662848533463', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.152.99.34', '2019-08-22 17:31:25', 18, 2001001000, '服务端发生异常', '2019-08-22 17:31:25');
INSERT INTO `access_log` VALUES (70597, '65.50.15664662848703431', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.152.99.34', '2019-08-22 17:31:25', 10, 0, '', '2019-08-22 17:31:25');
INSERT INTO `access_log` VALUES (70598, '59.78.15664672087420253', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '116.21.137.234', '2019-08-22 17:46:49', 10, 0, '', '2019-08-22 17:46:49');
INSERT INTO `access_log` VALUES (70599, '59.76.15664672087430235', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '116.21.137.234', '2019-08-22 17:46:49', 18, 2001001000, '服务端发生异常', '2019-08-22 17:46:49');
INSERT INTO `access_log` VALUES (70600, '64.76.15664672161780629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '116.21.137.234', '2019-08-22 17:46:56', 13, 0, '', '2019-08-22 17:46:56');
INSERT INTO `access_log` VALUES (70601, '64.80.15664672163090625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '116.21.137.234', '2019-08-22 17:46:56', 2, 0, '', '2019-08-22 17:46:56');
INSERT INTO `access_log` VALUES (70602, '64.85.15664672211770657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '116.21.137.234', '2019-08-22 17:47:01', 2, 0, '', '2019-08-22 17:47:01');
INSERT INTO `access_log` VALUES (70603, '64.82.15664672212850637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '116.21.137.234', '2019-08-22 17:47:01', 2, 0, '', '2019-08-22 17:47:01');
INSERT INTO `access_log` VALUES (70604, '59.75.15664672250980251', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '116.21.137.234', '2019-08-22 17:47:05', 3, 0, '', '2019-08-22 17:47:05');
INSERT INTO `access_log` VALUES (70605, '59.80.15664672250990219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 Mobile Safari/537.36', '116.21.137.234', '2019-08-22 17:47:05', 11, 2001001000, '服务端发生异常', '2019-08-22 17:47:05');
INSERT INTO `access_log` VALUES (70606, 'd5ed33e8-c4cf-4087-af28-f7e4e569a4c2', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '127.0.0.1', '2019-08-22 18:00:04', 9119, 2001001000, '服务端发生异常', '2019-08-22 18:00:14');
INSERT INTO `access_log` VALUES (70607, '393d4cb9-f1eb-4047-85dc-612f9565d05c', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 18:10:12', 5459, 2001001000, '服务端发生异常', '2019-08-22 18:10:17');
INSERT INTO `access_log` VALUES (70608, '65.54.15664792216533503', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.112.114.69', '2019-08-22 21:07:02', 0, 1002001015, '账号未登陆', '2019-08-22 21:07:02');
INSERT INTO `access_log` VALUES (70609, '65.49.15664792216533619', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.112.114.69', '2019-08-22 21:07:02', 0, 1002001015, '账号未登陆', '2019-08-22 21:07:02');
INSERT INTO `access_log` VALUES (70610, '65.50.15664792216543605', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.112.114.69', '2019-08-22 21:07:02', 0, 1002001015, '账号未登陆', '2019-08-22 21:07:02');
INSERT INTO `access_log` VALUES (70611, '65.46.15664792256323635', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.112.114.69', '2019-08-22 21:07:06', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-22 21:07:06');
INSERT INTO `access_log` VALUES (70612, '65.45.15664792364553627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.112.114.69', '2019-08-22 21:07:16', 289, 0, '', '2019-08-22 21:07:17');
INSERT INTO `access_log` VALUES (70613, '65.51.15664792370813673', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.112.114.69', '2019-08-22 21:07:17', 9, 0, '', '2019-08-22 21:07:17');
INSERT INTO `access_log` VALUES (70614, '65.52.15664792370973655', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.112.114.69', '2019-08-22 21:07:17', 9, 0, '', '2019-08-22 21:07:17');
INSERT INTO `access_log` VALUES (70615, '65.3607.15664792370985407', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.112.114.69', '2019-08-22 21:07:17', 10, 2001001000, '服务端发生异常', '2019-08-22 21:07:17');
INSERT INTO `access_log` VALUES (70616, '59.74.15664839703460485', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.182.196.234', '2019-08-22 22:26:10', 11, 0, '', '2019-08-22 22:26:10');
INSERT INTO `access_log` VALUES (70617, '59.72.15664839703530469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.182.196.234', '2019-08-22 22:26:10', 25, 2001001000, '服务端发生异常', '2019-08-22 22:26:10');
INSERT INTO `access_log` VALUES (70618, '64.80.15664839751560849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.182.196.234', '2019-08-22 22:26:15', 10, 0, '', '2019-08-22 22:26:15');
INSERT INTO `access_log` VALUES (70619, '64.85.15664839753040881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.182.196.234', '2019-08-22 22:26:15', 3, 0, '', '2019-08-22 22:26:15');
INSERT INTO `access_log` VALUES (70620, '64.82.15664839768190861', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.182.196.234', '2019-08-22 22:26:17', 2, 0, '', '2019-08-22 22:26:17');
INSERT INTO `access_log` VALUES (70621, '64.83.15664839776740845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.182.196.234', '2019-08-22 22:26:18', 2, 0, '', '2019-08-22 22:26:18');
INSERT INTO `access_log` VALUES (70622, '59.73.15664839791930471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.182.196.234', '2019-08-22 22:26:19', 3, 0, '', '2019-08-22 22:26:19');
INSERT INTO `access_log` VALUES (70623, '59.80.15664839791930443', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.182.196.234', '2019-08-22 22:26:19', 18, 2001001000, '服务端发生异常', '2019-08-22 22:26:19');
INSERT INTO `access_log` VALUES (70624, '64.84.15664839884730853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.182.196.234', '2019-08-22 22:26:28', 2, 0, '', '2019-08-22 22:26:28');
INSERT INTO `access_log` VALUES (70625, '64.79.15664839886610845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.182.196.234', '2019-08-22 22:26:29', 2, 0, '', '2019-08-22 22:26:29');
INSERT INTO `access_log` VALUES (70626, '59.79.15664839969030471', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.182.196.234', '2019-08-22 22:26:37', 2, 0, '', '2019-08-22 22:26:37');
INSERT INTO `access_log` VALUES (70627, '59.71.15664839969040469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.182.196.234', '2019-08-22 22:26:37', 17, 2001001000, '服务端发生异常', '2019-08-22 22:26:37');
INSERT INTO `access_log` VALUES (70628, '64.78.15664840000240867', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.182.196.234', '2019-08-22 22:26:40', 2, 0, '', '2019-08-22 22:26:40');
INSERT INTO `access_log` VALUES (70629, '64.76.15664840001580855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.182.196.234', '2019-08-22 22:26:40', 2, 0, '', '2019-08-22 22:26:40');
INSERT INTO `access_log` VALUES (70630, '59.80.15664854446360463', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.249.183.152', '2019-08-22 22:50:45', 10, 0, '', '2019-08-22 22:50:45');
INSERT INTO `access_log` VALUES (70631, '59.77.15664854446380475', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.249.183.152', '2019-08-22 22:50:45', 16, 2001001000, '服务端发生异常', '2019-08-22 22:50:45');
INSERT INTO `access_log` VALUES (70632, '65.50.15664857064173693', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/76.0.3809.87 Chrome/76.0.3809.87 Safari/537.36', '144.48.5.31', '2019-08-22 22:55:06', 1, 1002001015, '账号未登陆', '2019-08-22 22:55:06');
INSERT INTO `access_log` VALUES (70633, '65.54.15664857064163591', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/76.0.3809.87 Chrome/76.0.3809.87 Safari/537.36', '144.48.5.31', '2019-08-22 22:55:06', 0, 1002001015, '账号未登陆', '2019-08-22 22:55:06');
INSERT INTO `access_log` VALUES (70634, '65.49.15664857064203707', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/76.0.3809.87 Chrome/76.0.3809.87 Safari/537.36', '144.48.5.31', '2019-08-22 22:55:06', 0, 1002001015, '账号未登陆', '2019-08-22 22:55:06');
INSERT INTO `access_log` VALUES (70635, '65.53.15664857205093647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/76.0.3809.87 Chrome/76.0.3809.87 Safari/537.36', '144.48.5.31', '2019-08-22 22:55:21', 430, 0, '', '2019-08-22 22:55:21');
INSERT INTO `access_log` VALUES (70636, '65.45.15664857213083715', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/76.0.3809.87 Chrome/76.0.3809.87 Safari/537.36', '144.48.5.31', '2019-08-22 22:55:21', 13, 0, '', '2019-08-22 22:55:21');
INSERT INTO `access_log` VALUES (70637, '65.51.15664857213123761', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/76.0.3809.87 Chrome/76.0.3809.87 Safari/537.36', '144.48.5.31', '2019-08-22 22:55:21', 12, 2001001000, '服务端发生异常', '2019-08-22 22:55:21');
INSERT INTO `access_log` VALUES (70638, '65.3607.15664857213145495', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/76.0.3809.87 Chrome/76.0.3809.87 Safari/537.36', '144.48.5.31', '2019-08-22 22:55:21', 10, 0, '', '2019-08-22 22:55:21');
INSERT INTO `access_log` VALUES (70639, '65.46.15664857862343725', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/76.0.3809.87 Chrome/76.0.3809.87 Safari/537.36', '219.134.114.119', '2019-08-22 22:56:26', 16, 0, '', '2019-08-22 22:56:26');
INSERT INTO `access_log` VALUES (70640, '65.53.15664857862373649', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/76.0.3809.87 Chrome/76.0.3809.87 Safari/537.36', '219.134.114.119', '2019-08-22 22:56:26', 16, 2001001000, '服务端发生异常', '2019-08-22 22:56:26');
INSERT INTO `access_log` VALUES (70641, '65.51.15664857862393763', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Ubuntu Chromium/76.0.3809.87 Chrome/76.0.3809.87 Safari/537.36', '219.134.114.119', '2019-08-22 22:56:26', 15, 0, '', '2019-08-22 22:56:26');
INSERT INTO `access_log` VALUES (70642, '65.50.15665240370234207', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:33:57', 0, 1002001015, '账号未登陆', '2019-08-23 09:33:57');
INSERT INTO `access_log` VALUES (70643, '65.54.15665240370214103', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:33:57', 1, 1002001015, '账号未登陆', '2019-08-23 09:33:57');
INSERT INTO `access_log` VALUES (70644, '65.47.15665240370214149', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:33:57', 1, 1002001015, '账号未登陆', '2019-08-23 09:33:57');
INSERT INTO `access_log` VALUES (70645, '65.49.15665240403654219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:34:00', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 09:34:00');
INSERT INTO `access_log` VALUES (70646, '65.51.15665240457014275', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai11&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:34:06', 172, 0, '', '2019-08-23 09:34:06');
INSERT INTO `access_log` VALUES (70647, '65.46.15665240461374237', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:34:06', 14, 0, '', '2019-08-23 09:34:06');
INSERT INTO `access_log` VALUES (70648, '65.53.15665240461464161', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:34:06', 12, 0, '', '2019-08-23 09:34:06');
INSERT INTO `access_log` VALUES (70649, '65.45.15665240461464229', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:34:06', 13, 0, '', '2019-08-23 09:34:06');
INSERT INTO `access_log` VALUES (70650, '62.84.15665240516509675', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:34:12', 33, 0, '', '2019-08-23 09:34:12');
INSERT INTO `access_log` VALUES (70651, '65.47.15665240692224151', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:34:29', 21, 0, '', '2019-08-23 09:34:29');
INSERT INTO `access_log` VALUES (70652, '65.54.15665240710764105', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:34:31', 11, 0, '', '2019-08-23 09:34:31');
INSERT INTO `access_log` VALUES (70653, '65.49.15665240800814221', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:34:40', 18, 0, '', '2019-08-23 09:34:40');
INSERT INTO `access_log` VALUES (70654, '65.51.15665240824764277', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:34:42', 9, 0, '', '2019-08-23 09:34:42');
INSERT INTO `access_log` VALUES (70655, '59.73.15665240970611007', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:34:57', 27, 0, '', '2019-08-23 09:34:57');
INSERT INTO `access_log` VALUES (70656, '66.50.15665241021848523', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:35:02', 21, 0, '', '2019-08-23 09:35:02');
INSERT INTO `access_log` VALUES (70657, '64.84.15665241092781389', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:35:09', 23, 0, '', '2019-08-23 09:35:09');
INSERT INTO `access_log` VALUES (70658, '64.77.15665241092751371', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:35:09', 28, 0, '', '2019-08-23 09:35:09');
INSERT INTO `access_log` VALUES (70659, '59.79.15665241222541007', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:35:22', 36, 2001001000, '服务端发生异常', '2019-08-23 09:35:22');
INSERT INTO `access_log` VALUES (70660, '59.71.15665241260291005', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:35:26', 14, 0, '', '2019-08-23 09:35:26');
INSERT INTO `access_log` VALUES (70661, '64.81.15665241280471387', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:35:28', 9, 0, '', '2019-08-23 09:35:28');
INSERT INTO `access_log` VALUES (70662, '59.76.15665241280820997', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '36.24.171.109', '2019-08-23 09:35:28', 2, 0, '', '2019-08-23 09:35:28');
INSERT INTO `access_log` VALUES (70663, '59.78.15665241280841015', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '36.24.171.109', '2019-08-23 09:35:28', 13, 2001001000, '服务端发生异常', '2019-08-23 09:35:28');
INSERT INTO `access_log` VALUES (70664, '64.78.15665241324731403', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36 chrome-extension', '61.190.4.66', '2019-08-23 09:35:32', 9, 0, '', '2019-08-23 09:35:32');
INSERT INTO `access_log` VALUES (70665, '65.3607.15665241356256013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '36.24.171.109', '2019-08-23 09:35:36', 1, 1002001015, '账号未登陆', '2019-08-23 09:35:36');
INSERT INTO `access_log` VALUES (70666, '65.52.15665241356324259', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '36.24.171.109', '2019-08-23 09:35:36', 0, 1002001015, '账号未登陆', '2019-08-23 09:35:36');
INSERT INTO `access_log` VALUES (70667, '65.47.15665241356454153', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '36.24.171.109', '2019-08-23 09:35:36', 0, 1002001015, '账号未登陆', '2019-08-23 09:35:36');
INSERT INTO `access_log` VALUES (70668, '65.54.15665241382134107', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '36.24.171.109', '2019-08-23 09:35:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 09:35:38');
INSERT INTO `access_log` VALUES (70669, '65.49.15665241484694223', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '36.24.171.109', '2019-08-23 09:35:48', 90, 0, '', '2019-08-23 09:35:49');
INSERT INTO `access_log` VALUES (70670, '65.51.15665241488514279', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '36.24.171.109', '2019-08-23 09:35:49', 9, 0, '', '2019-08-23 09:35:49');
INSERT INTO `access_log` VALUES (70671, '65.45.15665241488544233', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '36.24.171.109', '2019-08-23 09:35:49', 10, 2001001000, '服务端发生异常', '2019-08-23 09:35:49');
INSERT INTO `access_log` VALUES (70672, '65.46.15665241488624241', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '36.24.171.109', '2019-08-23 09:35:49', 9, 0, '', '2019-08-23 09:35:49');
INSERT INTO `access_log` VALUES (70673, '65.51.15665244244524285', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '101.89.239.230', '2019-08-23 09:40:24', 1, 1002001015, '账号未登陆', '2019-08-23 09:40:24');
INSERT INTO `access_log` VALUES (70674, '59.80.15665244918770985', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.89.239.230', '2019-08-23 09:41:32', 16, 2001001000, '服务端发生异常', '2019-08-23 09:41:32');
INSERT INTO `access_log` VALUES (70675, '59.71.15665245169501011', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.19.197', '2019-08-23 09:41:57', 3, 0, '', '2019-08-23 09:41:57');
INSERT INTO `access_log` VALUES (70676, '65.47.15665245169654161', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.197', '2019-08-23 09:41:57', 0, 1002001015, '账号未登陆', '2019-08-23 09:41:57');
INSERT INTO `access_log` VALUES (70677, '65.3607.15665248830246025', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '101.89.239.230', '2019-08-23 09:48:03', 0, 1002001015, '账号未登陆', '2019-08-23 09:48:03');
INSERT INTO `access_log` VALUES (70678, '59.78.15665251386261029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:52:19', 4, 0, '', '2019-08-23 09:52:19');
INSERT INTO `access_log` VALUES (70679, '59.74.15665251386331037', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:52:19', 22, 2001001000, '服务端发生异常', '2019-08-23 09:52:19');
INSERT INTO `access_log` VALUES (70680, '64.81.15665251433061401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:52:23', 3, 0, '', '2019-08-23 09:52:23');
INSERT INTO `access_log` VALUES (70681, '64.78.15665251434361417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:52:23', 2, 0, '', '2019-08-23 09:52:23');
INSERT INTO `access_log` VALUES (70682, '64.76.15665251445061405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:52:25', 2, 0, '', '2019-08-23 09:52:25');
INSERT INTO `access_log` VALUES (70683, '64.80.15665251450811401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:52:25', 2, 0, '', '2019-08-23 09:52:25');
INSERT INTO `access_log` VALUES (70684, '64.85.15665251454481433', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:52:25', 2, 0, '', '2019-08-23 09:52:25');
INSERT INTO `access_log` VALUES (70685, '59.75.15665251482331027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:52:28', 3, 0, '', '2019-08-23 09:52:28');
INSERT INTO `access_log` VALUES (70686, '59.73.15665251482331023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:52:28', 16, 2001001000, '服务端发生异常', '2019-08-23 09:52:28');
INSERT INTO `access_log` VALUES (70687, '65.52.15665251961584277', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:53:16', 0, 1002001015, '账号未登陆', '2019-08-23 09:53:16');
INSERT INTO `access_log` VALUES (70688, '65.54.15665251961584121', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:53:16', 0, 1002001015, '账号未登陆', '2019-08-23 09:53:16');
INSERT INTO `access_log` VALUES (70689, '65.47.15665251961634171', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:53:16', 0, 1002001015, '账号未登陆', '2019-08-23 09:53:16');
INSERT INTO `access_log` VALUES (70690, '65.49.15665252131104241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:53:33', 57, 0, '', '2019-08-23 09:53:33');
INSERT INTO `access_log` VALUES (70691, '65.51.15665252134414297', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:53:33', 66, 0, '', '2019-08-23 09:53:34');
INSERT INTO `access_log` VALUES (70692, '65.45.15665252134474251', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:53:33', 63, 0, '', '2019-08-23 09:53:34');
INSERT INTO `access_log` VALUES (70693, '65.46.15665252134504259', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:53:33', 60, 2001001000, '服务端发生异常', '2019-08-23 09:53:34');
INSERT INTO `access_log` VALUES (70694, '65.47.15665252368674173', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:53:57', 10, 0, '', '2019-08-23 09:53:57');
INSERT INTO `access_log` VALUES (70695, '65.54.15665252368684123', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:53:57', 9, 0, '', '2019-08-23 09:53:57');
INSERT INTO `access_log` VALUES (70696, '65.52.15665252368714279', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:53:57', 10, 2001001000, '服务端发生异常', '2019-08-23 09:53:57');
INSERT INTO `access_log` VALUES (70697, '65.49.15665252400364243', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:54:00', 10, 2001001000, '服务端发生异常', '2019-08-23 09:54:00');
INSERT INTO `access_log` VALUES (70698, '65.51.15665252400414299', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:54:00', 9, 0, '', '2019-08-23 09:54:00');
INSERT INTO `access_log` VALUES (70699, '65.50.15665252400354229', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:54:00', 110, 0, '', '2019-08-23 09:54:00');
INSERT INTO `access_log` VALUES (70700, '65.45.15665252441504253', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:54:04', 9, 0, '', '2019-08-23 09:54:04');
INSERT INTO `access_log` VALUES (70701, '65.46.15665252441494261', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:54:04', 10, 0, '', '2019-08-23 09:54:04');
INSERT INTO `access_log` VALUES (70702, '65.3607.15665252441516033', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:54:04', 9, 2001001000, '服务端发生异常', '2019-08-23 09:54:04');
INSERT INTO `access_log` VALUES (70703, '65.47.15665252516444175', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:54:12', 10, 0, '', '2019-08-23 09:54:12');
INSERT INTO `access_log` VALUES (70704, '65.54.15665252516514125', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:54:12', 9, 2001001000, '服务端发生异常', '2019-08-23 09:54:12');
INSERT INTO `access_log` VALUES (70705, '65.52.15665252516534281', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.218.91', '2019-08-23 09:54:12', 9, 0, '', '2019-08-23 09:54:12');
INSERT INTO `access_log` VALUES (70706, '59.72.15665255538961027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:14', 3, 0, '', '2019-08-23 09:59:14');
INSERT INTO `access_log` VALUES (70707, '59.75.15665255538971033', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:14', 18, 2001001000, '服务端发生异常', '2019-08-23 09:59:14');
INSERT INTO `access_log` VALUES (70708, '64.76.15665255556891411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:16', 32, 0, '', '2019-08-23 09:59:16');
INSERT INTO `access_log` VALUES (70709, '64.80.15665255558511407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:16', 2, 0, '', '2019-08-23 09:59:16');
INSERT INTO `access_log` VALUES (70710, '64.85.15665255566571439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:17', 2, 0, '', '2019-08-23 09:59:17');
INSERT INTO `access_log` VALUES (70711, '64.82.15665255570491419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:17', 2, 0, '', '2019-08-23 09:59:17');
INSERT INTO `access_log` VALUES (70712, '64.83.15665255574071403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:17', 2, 0, '', '2019-08-23 09:59:17');
INSERT INTO `access_log` VALUES (70713, '59.80.15665255577241001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:18', 2, 0, '', '2019-08-23 09:59:18');
INSERT INTO `access_log` VALUES (70714, '59.73.15665255577241029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:18', 19, 2001001000, '服务端发生异常', '2019-08-23 09:59:18');
INSERT INTO `access_log` VALUES (70715, '64.77.15665255603911393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:20', 2, 0, '', '2019-08-23 09:59:20');
INSERT INTO `access_log` VALUES (70716, '64.79.15665255605091403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:21', 2, 0, '', '2019-08-23 09:59:21');
INSERT INTO `access_log` VALUES (70717, '66.56.15665255705268555', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17350332369', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:31', 120, 0, '', '2019-08-23 09:59:31');
INSERT INTO `access_log` VALUES (70718, '66.50.15665255736238543', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17350332369&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:34', 280, 0, '', '2019-08-23 09:59:34');
INSERT INTO `access_log` VALUES (70719, '64.76.15665255785521413', 210, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:39', 6, 0, '', '2019-08-23 09:59:39');
INSERT INTO `access_log` VALUES (70720, '64.85.15665255787581441', 210, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:39', 6, 0, '', '2019-08-23 09:59:39');
INSERT INTO `access_log` VALUES (70721, '59.74.15665255800281045', 210, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:40', 6, 0, '', '2019-08-23 09:59:40');
INSERT INTO `access_log` VALUES (70722, '59.78.15665255800341037', 210, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 09:59:40', 39, 2001001000, '服务端发生异常', '2019-08-23 09:59:40');
INSERT INTO `access_log` VALUES (70723, '65.45.15665270021274279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 10:23:22', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 10:23:22');
INSERT INTO `access_log` VALUES (70724, '65.3607.15665270131946059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 10:23:33', 80, 0, '', '2019-08-23 10:23:33');
INSERT INTO `access_log` VALUES (70725, '65.53.15665270136244209', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 10:23:34', 15, 0, '', '2019-08-23 10:23:34');
INSERT INTO `access_log` VALUES (70726, '65.47.15665270136274201', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 10:23:34', 16, 2001001000, '服务端发生异常', '2019-08-23 10:23:34');
INSERT INTO `access_log` VALUES (70727, '65.52.15665270136274305', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 10:23:34', 16, 0, '', '2019-08-23 10:23:34');
INSERT INTO `access_log` VALUES (70728, '65.50.15665276534284265', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:34:13', 0, 1002001015, '账号未登陆', '2019-08-23 10:34:13');
INSERT INTO `access_log` VALUES (70729, '65.45.15665276534294289', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:34:13', 0, 1002001015, '账号未登陆', '2019-08-23 10:34:13');
INSERT INTO `access_log` VALUES (70730, '65.46.15665276534344295', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:34:13', 0, 1002001015, '账号未登陆', '2019-08-23 10:34:13');
INSERT INTO `access_log` VALUES (70731, '65.3607.15665276591816069', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:34:19', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 10:34:19');
INSERT INTO `access_log` VALUES (70732, '65.46.15665277608784297', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:01', 95, 0, '', '2019-08-23 10:36:01');
INSERT INTO `access_log` VALUES (70733, '65.50.15665277613494267', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:01', 79, 0, '', '2019-08-23 10:36:01');
INSERT INTO `access_log` VALUES (70734, '65.53.15665277613944221', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:01', 36, 0, '', '2019-08-23 10:36:01');
INSERT INTO `access_log` VALUES (70735, '65.3607.15665277613506071', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:01', 87, 2001001000, '服务端发生异常', '2019-08-23 10:36:01');
INSERT INTO `access_log` VALUES (70736, '65.52.15665277672024317', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:07', 10, 0, '', '2019-08-23 10:36:07');
INSERT INTO `access_log` VALUES (70737, '65.47.15665277672064213', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:07', 9, 2001001000, '服务端发生异常', '2019-08-23 10:36:07');
INSERT INTO `access_log` VALUES (70738, '65.51.15665277672104337', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:07', 9, 0, '', '2019-08-23 10:36:07');
INSERT INTO `access_log` VALUES (70739, '65.3607.15665277816856073', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:22', 8, 0, '', '2019-08-23 10:36:22');
INSERT INTO `access_log` VALUES (70740, '65.47.15665277816884215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:22', 9, 2001001000, '服务端发生异常', '2019-08-23 10:36:22');
INSERT INTO `access_log` VALUES (70741, '65.50.15665277816924269', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:22', 9, 0, '', '2019-08-23 10:36:22');
INSERT INTO `access_log` VALUES (70742, '65.45.15665277850674293', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:25', 9, 0, '', '2019-08-23 10:36:25');
INSERT INTO `access_log` VALUES (70743, '65.49.15665277850724281', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:25', 9, 2001001000, '服务端发生异常', '2019-08-23 10:36:25');
INSERT INTO `access_log` VALUES (70744, '65.51.15665277850764339', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:25', 9, 0, '', '2019-08-23 10:36:25');
INSERT INTO `access_log` VALUES (70745, '65.54.15665277872164165', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:27', 9, 0, '', '2019-08-23 10:36:27');
INSERT INTO `access_log` VALUES (70746, '65.53.15665277872224225', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:27', 9, 2001001000, '服务端发生异常', '2019-08-23 10:36:27');
INSERT INTO `access_log` VALUES (70747, '65.46.15665277872264301', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:36:27', 8, 0, '', '2019-08-23 10:36:27');
INSERT INTO `access_log` VALUES (70748, '65.53.15665279058974227', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:38:26', 10, 0, '', '2019-08-23 10:38:26');
INSERT INTO `access_log` VALUES (70749, '65.46.15665279059004303', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:38:26', 10, 2001001000, '服务端发生异常', '2019-08-23 10:38:26');
INSERT INTO `access_log` VALUES (70750, '65.50.15665279059024273', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:38:26', 9, 0, '', '2019-08-23 10:38:26');
INSERT INTO `access_log` VALUES (70751, '59.71.15665279271391059', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:38:47', 9, 0, '', '2019-08-23 10:38:47');
INSERT INTO `access_log` VALUES (70752, '59.76.15665279271391051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.62.135.162', '2019-08-23 10:38:47', 13, 2001001000, '服务端发生异常', '2019-08-23 10:38:47');
INSERT INTO `access_log` VALUES (70753, '65.45.15665286675854305', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 10:51:08', 1, 1002001015, '账号未登陆', '2019-08-23 10:51:08');
INSERT INTO `access_log` VALUES (70754, '65.53.15665288165924239', 0, 2, 'admin-application', '/admin-api/admins/admin/update', 'id=1&nickname=小王&username=15601691300&password=buzhidao', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 10:53:37', 0, 1002001015, '账号未登陆', '2019-08-23 10:53:37');
INSERT INTO `access_log` VALUES (70755, '65.3607.15665288176686093', 0, 2, 'admin-application', '/admin-api/admins/admin/update', 'id=1&nickname=小王&username=15601691300&password=buzhidao', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 10:53:38', 1, 1002001015, '账号未登陆', '2019-08-23 10:53:38');
INSERT INTO `access_log` VALUES (70756, '65.50.15665289330224285', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 10:55:33', 1, 1002001015, '账号未登陆', '2019-08-23 10:55:33');
INSERT INTO `access_log` VALUES (70757, '65.52.15665289341244339', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 10:55:34', 1, 1002001015, '账号未登陆', '2019-08-23 10:55:34');
INSERT INTO `access_log` VALUES (70758, '64.80.15665302316791473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 11:17:12', 11, 0, '', '2019-08-23 11:17:12');
INSERT INTO `access_log` VALUES (70759, '64.82.15665302319711487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 11:17:12', 3, 0, '', '2019-08-23 11:17:12');
INSERT INTO `access_log` VALUES (70760, '64.77.15665302329561459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 11:17:13', 2, 0, '', '2019-08-23 11:17:13');
INSERT INTO `access_log` VALUES (70761, '64.78.15665302338421487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 11:17:14', 2, 0, '', '2019-08-23 11:17:14');
INSERT INTO `access_log` VALUES (70762, '64.83.15665302344421469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 11:17:14', 2, 0, '', '2019-08-23 11:17:14');
INSERT INTO `access_log` VALUES (70763, '64.80.15665302350341475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 11:17:15', 2, 0, '', '2019-08-23 11:17:15');
INSERT INTO `access_log` VALUES (70764, '64.85.15665302412401501', 0, 2, 'product-application', '/product-api/admins/spu/add', 'cid=反正我是信了&description=你就说强不强 MQ 骚操作&name=厮大牛逼&picUrls=http://www.iocoder.cn&sellPoint=各种 MQ 骚操作&skuStr=[{\"attrs\": [1,3 ], \"price\": 1, \"quantity\": 100, \"picUrl\": \"http://www.iocoder.cn\"}]&visible=true', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 11:17:21', 1, 1002001015, '账号未登陆', '2019-08-23 11:17:21');
INSERT INTO `access_log` VALUES (70765, '64.81.15665302422991477', 0, 2, 'product-application', '/product-api/admins/spu/add', 'cid=反正我是信了&description=你就说强不强 MQ 骚操作&name=厮大牛逼&picUrls=http://www.iocoder.cn&sellPoint=各种 MQ 骚操作&skuStr=[{\"attrs\": [1,3 ], \"price\": 1, \"quantity\": 100, \"picUrl\": \"http://www.iocoder.cn\"}]&visible=true', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.5.241.6', '2019-08-23 11:17:22', 0, 1002001015, '账号未登陆', '2019-08-23 11:17:22');
INSERT INTO `access_log` VALUES (70766, '59.74.15665319686141131', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.87.113', '2019-08-23 11:46:09', 10, 0, '', '2019-08-23 11:46:09');
INSERT INTO `access_log` VALUES (70767, '59.78.15665319687361123', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.87.113', '2019-08-23 11:46:09', 17, 2001001000, '服务端发生异常', '2019-08-23 11:46:09');
INSERT INTO `access_log` VALUES (70768, '65.50.15665319803534327', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.87.113', '2019-08-23 11:46:20', 0, 1002001015, '账号未登陆', '2019-08-23 11:46:20');
INSERT INTO `access_log` VALUES (70769, '65.3607.15665319803536137', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.87.113', '2019-08-23 11:46:20', 1, 1002001015, '账号未登陆', '2019-08-23 11:46:20');
INSERT INTO `access_log` VALUES (70770, '65.45.15665319803584351', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.87.113', '2019-08-23 11:46:20', 0, 1002001015, '账号未登陆', '2019-08-23 11:46:20');
INSERT INTO `access_log` VALUES (70771, '65.52.15665319820444381', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.87.113', '2019-08-23 11:46:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 11:46:22');
INSERT INTO `access_log` VALUES (70772, '65.49.15665319912734345', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.87.113', '2019-08-23 11:46:31', 67, 0, '', '2019-08-23 11:46:31');
INSERT INTO `access_log` VALUES (70773, '65.54.15665319915574225', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.87.113', '2019-08-23 11:46:32', 14, 0, '', '2019-08-23 11:46:32');
INSERT INTO `access_log` VALUES (70774, '65.46.15665319915644359', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.87.113', '2019-08-23 11:46:32', 11, 2001001000, '服务端发生异常', '2019-08-23 11:46:32');
INSERT INTO `access_log` VALUES (70775, '65.53.15665319915664285', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.87.113', '2019-08-23 11:46:32', 11, 0, '', '2019-08-23 11:46:32');
INSERT INTO `access_log` VALUES (70776, '65.51.15665319983474395', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.87.113', '2019-08-23 11:46:38', 16, 0, '', '2019-08-23 11:46:38');
INSERT INTO `access_log` VALUES (70777, '65.45.15665319983494353', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.87.113', '2019-08-23 11:46:38', 18, 2001001000, '服务端发生异常', '2019-08-23 11:46:38');
INSERT INTO `access_log` VALUES (70778, '65.50.15665319983604329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.87.113', '2019-08-23 11:46:38', 9, 0, '', '2019-08-23 11:46:38');
INSERT INTO `access_log` VALUES (70779, '59.71.15665383692071199', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.189.204.163', '2019-08-23 13:32:49', 10, 0, '', '2019-08-23 13:32:49');
INSERT INTO `access_log` VALUES (70780, '59.74.15665383692451217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.189.204.163', '2019-08-23 13:32:49', 15, 2001001000, '服务端发生异常', '2019-08-23 13:32:49');
INSERT INTO `access_log` VALUES (70781, '65.51.15665383921504481', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.189.204.163', '2019-08-23 13:33:12', 0, 1002001015, '账号未登陆', '2019-08-23 13:33:12');
INSERT INTO `access_log` VALUES (70782, '65.45.15665383921504439', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.189.204.163', '2019-08-23 13:33:12', 0, 1002001015, '账号未登陆', '2019-08-23 13:33:12');
INSERT INTO `access_log` VALUES (70783, '65.50.15665383921764415', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.189.204.163', '2019-08-23 13:33:12', 0, 1002001015, '账号未登陆', '2019-08-23 13:33:12');
INSERT INTO `access_log` VALUES (70784, '65.3607.15665383939926225', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.189.204.163', '2019-08-23 13:33:14', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 13:33:14');
INSERT INTO `access_log` VALUES (70785, '65.47.15665384101994363', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.189.204.163', '2019-08-23 13:33:30', 110, 0, '', '2019-08-23 13:33:30');
INSERT INTO `access_log` VALUES (70786, '65.49.15665384105774433', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.189.204.163', '2019-08-23 13:33:31', 11, 0, '', '2019-08-23 13:33:31');
INSERT INTO `access_log` VALUES (70787, '65.46.15665384105814447', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.189.204.163', '2019-08-23 13:33:31', 14, 2001001000, '服务端发生异常', '2019-08-23 13:33:31');
INSERT INTO `access_log` VALUES (70788, '65.53.15665384105844373', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.189.204.163', '2019-08-23 13:33:31', 13, 0, '', '2019-08-23 13:33:31');
INSERT INTO `access_log` VALUES (70789, '59.74.15665407402861249', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:12:20', 16, 2001001000, '服务端发生异常', '2019-08-23 14:12:20');
INSERT INTO `access_log` VALUES (70790, '59.71.15665407402861231', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:12:20', 107, 0, '', '2019-08-23 14:12:20');
INSERT INTO `access_log` VALUES (70791, '64.83.15665407425901611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:12:23', 12, 0, '', '2019-08-23 14:12:23');
INSERT INTO `access_log` VALUES (70792, '64.84.15665407427201617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:12:23', 3, 0, '', '2019-08-23 14:12:23');
INSERT INTO `access_log` VALUES (70793, '64.80.15665407437411617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:12:24', 2, 0, '', '2019-08-23 14:12:24');
INSERT INTO `access_log` VALUES (70794, '64.79.15665407440081611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:12:24', 2, 0, '', '2019-08-23 14:12:24');
INSERT INTO `access_log` VALUES (70795, '64.82.15665407443891631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:12:24', 2, 0, '', '2019-08-23 14:12:24');
INSERT INTO `access_log` VALUES (70796, '65.54.15665408067754345', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:13:27', 0, 1002001015, '账号未登陆', '2019-08-23 14:13:27');
INSERT INTO `access_log` VALUES (70797, '65.45.15665408067764473', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:13:27', 0, 1002001015, '账号未登陆', '2019-08-23 14:13:27');
INSERT INTO `access_log` VALUES (70798, '65.51.15665408067914515', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:13:27', 1, 1002001015, '账号未登陆', '2019-08-23 14:13:27');
INSERT INTO `access_log` VALUES (70799, '65.50.15665408085844449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:13:29', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 14:13:29');
INSERT INTO `access_log` VALUES (70800, '65.3607.15665408182666259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:13:38', 109, 0, '', '2019-08-23 14:13:38');
INSERT INTO `access_log` VALUES (70801, '65.49.15665408186044467', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:13:39', 19, 0, '', '2019-08-23 14:13:39');
INSERT INTO `access_log` VALUES (70802, '65.47.15665408186034397', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:13:39', 21, 0, '', '2019-08-23 14:13:39');
INSERT INTO `access_log` VALUES (70803, '65.52.15665408186024503', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.30.193.210', '2019-08-23 14:13:39', 24, 2001001000, '服务端发生异常', '2019-08-23 14:13:39');
INSERT INTO `access_log` VALUES (70804, '65.51.15665438569574557', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '110.184.49.241', '2019-08-23 15:04:17', 1, 1002001015, '账号未登陆', '2019-08-23 15:04:17');
INSERT INTO `access_log` VALUES (70805, '65.45.15665438569574515', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '110.184.49.241', '2019-08-23 15:04:17', 1, 1002001015, '账号未登陆', '2019-08-23 15:04:17');
INSERT INTO `access_log` VALUES (70806, '65.50.15665438569574491', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '110.184.49.241', '2019-08-23 15:04:17', 1, 1002001015, '账号未登陆', '2019-08-23 15:04:17');
INSERT INTO `access_log` VALUES (70807, '65.49.15665438707264509', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '110.184.49.241', '2019-08-23 15:04:31', 69, 0, '', '2019-08-23 15:04:31');
INSERT INTO `access_log` VALUES (70808, '65.47.15665438711104439', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '110.184.49.241', '2019-08-23 15:04:31', 226, 0, '', '2019-08-23 15:04:31');
INSERT INTO `access_log` VALUES (70809, '65.46.15665438711204523', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '110.184.49.241', '2019-08-23 15:04:31', 219, 0, '', '2019-08-23 15:04:31');
INSERT INTO `access_log` VALUES (70810, '65.52.15665438711154545', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '110.184.49.241', '2019-08-23 15:04:31', 223, 2001001000, '服务端发生异常', '2019-08-23 15:04:31');
INSERT INTO `access_log` VALUES (70811, '65.45.15665438949474517', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '110.184.49.241', '2019-08-23 15:04:55', 11, 0, '', '2019-08-23 15:04:55');
INSERT INTO `access_log` VALUES (70812, '65.50.15665438949524493', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '110.184.49.241', '2019-08-23 15:04:55', 9, 2001001000, '服务端发生异常', '2019-08-23 15:04:55');
INSERT INTO `access_log` VALUES (70813, '65.51.15665438949564559', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '110.184.49.241', '2019-08-23 15:04:55', 8, 0, '', '2019-08-23 15:04:55');
INSERT INTO `access_log` VALUES (70814, '65.3607.15665439036406303', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '110.184.49.241', '2019-08-23 15:05:04', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 15:05:04');
INSERT INTO `access_log` VALUES (70815, '65.47.15665439135834441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 10.0; WOW64; Trident/7.0; .NET4.0C; .NET4.0E; .NET CLR 2.0.50727; .NET CLR 3.0.30729; .NET CLR 3.5.30729)', '110.184.49.241', '2019-08-23 15:05:14', 74, 0, '', '2019-08-23 15:05:14');
INSERT INTO `access_log` VALUES (70816, '59.76.15665450517971281', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.230.38.192', '2019-08-23 15:24:12', 11, 0, '', '2019-08-23 15:24:12');
INSERT INTO `access_log` VALUES (70817, '59.74.15665450519341307', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.230.38.192', '2019-08-23 15:24:12', 13, 2001001000, '服务端发生异常', '2019-08-23 15:24:12');
INSERT INTO `access_log` VALUES (70818, '59.78.15665450672211299', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:27', 3, 0, '', '2019-08-23 15:24:27');
INSERT INTO `access_log` VALUES (70819, '59.72.15665450672851291', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:27', 14, 2001001000, '服务端发生异常', '2019-08-23 15:24:27');
INSERT INTO `access_log` VALUES (70820, '64.82.15665450812271689', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:41', 11, 0, '', '2019-08-23 15:24:41');
INSERT INTO `access_log` VALUES (70821, '64.85.15665450814181701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:41', 3, 0, '', '2019-08-23 15:24:41');
INSERT INTO `access_log` VALUES (70822, '64.77.15665450859451659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:46', 2, 0, '', '2019-08-23 15:24:46');
INSERT INTO `access_log` VALUES (70823, '64.81.15665450870481677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:47', 2, 0, '', '2019-08-23 15:24:47');
INSERT INTO `access_log` VALUES (70824, '64.78.15665450881661687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:48', 2, 0, '', '2019-08-23 15:24:48');
INSERT INTO `access_log` VALUES (70825, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:48', 6, 0, '', '2019-08-23 15:24:48');
INSERT INTO `access_log` VALUES (70826, '64.76.15665450902041675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:50', 2, 0, '', '2019-08-23 15:24:50');
INSERT INTO `access_log` VALUES (70827, '64.83.15665450903751671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:50', 1, 0, '', '2019-08-23 15:24:50');
INSERT INTO `access_log` VALUES (70828, '64.80.15665450912881677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:51', 2, 0, '', '2019-08-23 15:24:51');
INSERT INTO `access_log` VALUES (70829, '64.79.15665450920951671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:52', 2, 0, '', '2019-08-23 15:24:52');
INSERT INTO `access_log` VALUES (70830, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:52', 14, 0, '', '2019-08-23 15:24:52');
INSERT INTO `access_log` VALUES (70831, '64.82.15665450955461691', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:56', 114, 0, '', '2019-08-23 15:24:56');
INSERT INTO `access_log` VALUES (70832, '64.85.15665450991461703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:59', 2, 0, '', '2019-08-23 15:24:59');
INSERT INTO `access_log` VALUES (70833, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:24:59', 5, 0, '', '2019-08-23 15:24:59');
INSERT INTO `access_log` VALUES (70834, '64.77.15665451007171661', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '183.230.38.192', '2019-08-23 15:25:01', 6, 0, '', '2019-08-23 15:25:01');
INSERT INTO `access_log` VALUES (70835, '59.72.15665463757121309', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.216.40.207', '2019-08-23 15:46:16', 3, 0, '', '2019-08-23 15:46:16');
INSERT INTO `access_log` VALUES (70836, '59.71.15665463757121307', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.216.40.207', '2019-08-23 15:46:16', 14, 2001001000, '服务端发生异常', '2019-08-23 15:46:16');
INSERT INTO `access_log` VALUES (70837, '65.45.15665464002714555', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.216.40.207', '2019-08-23 15:46:40', 0, 1002001015, '账号未登陆', '2019-08-23 15:46:40');
INSERT INTO `access_log` VALUES (70838, '65.47.15665464002714477', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.216.40.207', '2019-08-23 15:46:40', 0, 1002001015, '账号未登陆', '2019-08-23 15:46:40');
INSERT INTO `access_log` VALUES (70839, '65.53.15665464002734487', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.216.40.207', '2019-08-23 15:46:40', 0, 1002001015, '账号未登陆', '2019-08-23 15:46:40');
INSERT INTO `access_log` VALUES (70840, '65.50.15665464024834529', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.216.40.207', '2019-08-23 15:46:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 15:46:42');
INSERT INTO `access_log` VALUES (70841, '65.46.15665464049124559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.216.40.207', '2019-08-23 15:46:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 15:46:45');
INSERT INTO `access_log` VALUES (70842, '65.3607.15665464053716343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.216.40.207', '2019-08-23 15:46:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 15:46:45');
INSERT INTO `access_log` VALUES (70843, '65.54.15665464201344423', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.216.40.207', '2019-08-23 15:47:00', 145, 0, '', '2019-08-23 15:47:00');
INSERT INTO `access_log` VALUES (70844, '65.52.15665464206684587', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.216.40.207', '2019-08-23 15:47:01', 7, 0, '', '2019-08-23 15:47:01');
INSERT INTO `access_log` VALUES (70845, '65.49.15665464206854545', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.216.40.207', '2019-08-23 15:47:01', 8, 2001001000, '服务端发生异常', '2019-08-23 15:47:01');
INSERT INTO `access_log` VALUES (70846, '65.53.15665464206894489', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.216.40.207', '2019-08-23 15:47:01', 8, 0, '', '2019-08-23 15:47:01');
INSERT INTO `access_log` VALUES (70847, '65.49.15665475449154563', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.126.226', '2019-08-23 16:05:45', 0, 1002001015, '账号未登陆', '2019-08-23 16:05:45');
INSERT INTO `access_log` VALUES (70848, '65.47.15665475449154493', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.126.226', '2019-08-23 16:05:45', 0, 1002001015, '账号未登陆', '2019-08-23 16:05:45');
INSERT INTO `access_log` VALUES (70849, '65.52.15665475449194605', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.126.226', '2019-08-23 16:05:45', 1, 1002001015, '账号未登陆', '2019-08-23 16:05:45');
INSERT INTO `access_log` VALUES (70850, '65.53.15665475791164507', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.126.226', '2019-08-23 16:06:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 16:06:19');
INSERT INTO `access_log` VALUES (70851, '65.46.15665475822154579', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.126.226', '2019-08-23 16:06:22', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 16:06:22');
INSERT INTO `access_log` VALUES (70852, '65.45.15665476022734577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.126.226', '2019-08-23 16:06:42', 68, 0, '', '2019-08-23 16:06:42');
INSERT INTO `access_log` VALUES (70853, '65.3607.15665476025806363', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.126.226', '2019-08-23 16:06:43', 9, 0, '', '2019-08-23 16:06:43');
INSERT INTO `access_log` VALUES (70854, '65.53.15665476025874509', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.126.226', '2019-08-23 16:06:43', 9, 2001001000, '服务端发生异常', '2019-08-23 16:06:43');
INSERT INTO `access_log` VALUES (70855, '65.46.15665476026634581', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '210.22.126.226', '2019-08-23 16:06:43', 10, 0, '', '2019-08-23 16:06:43');
INSERT INTO `access_log` VALUES (70856, '65.50.15665479346464557', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-23 16:12:15', 4, 1002001012, '访问令牌已过期', '2019-08-23 16:12:15');
INSERT INTO `access_log` VALUES (70857, '65.53.15665479346464515', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-23 16:12:15', 4, 1002001012, '访问令牌已过期', '2019-08-23 16:12:15');
INSERT INTO `access_log` VALUES (70858, '65.49.15665479346534573', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-23 16:12:15', 3, 1002001012, '访问令牌已过期', '2019-08-23 16:12:15');
INSERT INTO `access_log` VALUES (70859, '65.46.15665479467984587', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-23 16:12:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 16:12:27');
INSERT INTO `access_log` VALUES (70860, '65.45.15665479500864585', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-23 16:12:30', 99, 0, '', '2019-08-23 16:12:30');
INSERT INTO `access_log` VALUES (70861, '65.52.15665479504574611', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-23 16:12:30', 10, 0, '', '2019-08-23 16:12:30');
INSERT INTO `access_log` VALUES (70862, '65.51.15665479504604621', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-23 16:12:30', 9, 2001001000, '服务端发生异常', '2019-08-23 16:12:30');
INSERT INTO `access_log` VALUES (70863, '65.54.15665479504644449', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.68.30.202', '2019-08-23 16:12:30', 9, 0, '', '2019-08-23 16:12:30');
INSERT INTO `access_log` VALUES (70864, '59.75.15665496728571359', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.83.243.2', '2019-08-23 16:41:13', 10, 0, '', '2019-08-23 16:41:13');
INSERT INTO `access_log` VALUES (70865, '59.78.15665496728571361', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.83.243.2', '2019-08-23 16:41:13', 43, 2001001000, '服务端发生异常', '2019-08-23 16:41:13');
INSERT INTO `access_log` VALUES (70866, '64.83.15665496764591733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.83.243.2', '2019-08-23 16:41:16', 11, 0, '', '2019-08-23 16:41:16');
INSERT INTO `access_log` VALUES (70867, '64.84.15665496765631737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.83.243.2', '2019-08-23 16:41:17', 3, 0, '', '2019-08-23 16:41:17');
INSERT INTO `access_log` VALUES (70868, '64.80.15665496799081741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.83.243.2', '2019-08-23 16:41:20', 2, 0, '', '2019-08-23 16:41:20');
INSERT INTO `access_log` VALUES (70869, '64.79.15665496801031733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.83.243.2', '2019-08-23 16:41:20', 2, 0, '', '2019-08-23 16:41:20');
INSERT INTO `access_log` VALUES (70870, '59.77.15665496842261339', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.83.243.2', '2019-08-23 16:41:24', 3, 0, '', '2019-08-23 16:41:24');
INSERT INTO `access_log` VALUES (70871, '59.80.15665496842261327', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.83.243.2', '2019-08-23 16:41:24', 17, 2001001000, '服务端发生异常', '2019-08-23 16:41:24');
INSERT INTO `access_log` VALUES (70872, '64.85.15665496863841765', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.83.243.2', '2019-08-23 16:41:26', 2, 0, '', '2019-08-23 16:41:26');
INSERT INTO `access_log` VALUES (70873, '64.77.15665496865251721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.83.243.2', '2019-08-23 16:41:27', 2, 0, '', '2019-08-23 16:41:27');
INSERT INTO `access_log` VALUES (70874, '59.76.15665496876541345', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.83.243.2', '2019-08-23 16:41:28', 3, 0, '', '2019-08-23 16:41:28');
INSERT INTO `access_log` VALUES (70875, '59.79.15665496876541355', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '110.83.243.2', '2019-08-23 16:41:28', 19, 2001001000, '服务端发生异常', '2019-08-23 16:41:28');
INSERT INTO `access_log` VALUES (70876, '59.77.15665506756021353', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:57:56', 3, 0, '', '2019-08-23 16:57:56');
INSERT INTO `access_log` VALUES (70877, '59.80.15665506756051341', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:57:56', 13, 2001001000, '服务端发生异常', '2019-08-23 16:57:56');
INSERT INTO `access_log` VALUES (70878, '64.79.15665506812761747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:01', 3, 0, '', '2019-08-23 16:58:01');
INSERT INTO `access_log` VALUES (70879, '64.82.15665506813821769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:01', 2, 0, '', '2019-08-23 16:58:01');
INSERT INTO `access_log` VALUES (70880, '64.85.15665506842391779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:04', 9, 0, '', '2019-08-23 16:58:04');
INSERT INTO `access_log` VALUES (70881, '64.77.15665506843361735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:04', 2, 0, '', '2019-08-23 16:58:04');
INSERT INTO `access_log` VALUES (70882, '64.78.15665506912401767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:11', 2, 0, '', '2019-08-23 16:58:11');
INSERT INTO `access_log` VALUES (70883, '64.76.15665506915331755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:12', 1, 0, '', '2019-08-23 16:58:12');
INSERT INTO `access_log` VALUES (70884, '59.79.15665506922601369', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:12', 2, 0, '', '2019-08-23 16:58:12');
INSERT INTO `access_log` VALUES (70885, '59.74.15665506922601385', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:12', 15, 2001001000, '服务端发生异常', '2019-08-23 16:58:12');
INSERT INTO `access_log` VALUES (70886, '65.46.15665507128384627', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:33', 1, 1002001015, '账号未登陆', '2019-08-23 16:58:33');
INSERT INTO `access_log` VALUES (70887, '65.45.15665507128394627', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:33', 1, 1002001015, '账号未登陆', '2019-08-23 16:58:33');
INSERT INTO `access_log` VALUES (70888, '65.52.15665507128594649', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:33', 1, 1002001015, '账号未登陆', '2019-08-23 16:58:33');
INSERT INTO `access_log` VALUES (70889, '65.54.15665507144424491', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 16:58:34');
INSERT INTO `access_log` VALUES (70890, '65.47.15665507231324545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 16:58:43');
INSERT INTO `access_log` VALUES (70891, '65.50.15665507260884599', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:46', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 16:58:46');
INSERT INTO `access_log` VALUES (70892, '65.49.15665507312264613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:58:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 16:58:51');
INSERT INTO `access_log` VALUES (70893, '65.45.15665507552804629', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:59:15', 88, 0, '', '2019-08-23 16:59:15');
INSERT INTO `access_log` VALUES (70894, '65.46.15665507557264629', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:59:16', 18, 0, '', '2019-08-23 16:59:16');
INSERT INTO `access_log` VALUES (70895, '65.52.15665507557274651', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:59:16', 18, 2001001000, '服务端发生异常', '2019-08-23 16:59:16');
INSERT INTO `access_log` VALUES (70896, '65.54.15665507557394493', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.115.71.180', '2019-08-23 16:59:16', 10, 0, '', '2019-08-23 16:59:16');
INSERT INTO `access_log` VALUES (70897, '59.78.15665511579741383', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:05:58', 19, 2001001000, '服务端发生异常', '2019-08-23 17:05:58');
INSERT INTO `access_log` VALUES (70898, '59.71.15665511579731373', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:05:58', 980, 0, '', '2019-08-23 17:05:59');
INSERT INTO `access_log` VALUES (70899, '59.78.15665511579741383', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:05:58', 19, 2001001000, '服务端发生异常', '2019-08-23 17:05:59');
INSERT INTO `access_log` VALUES (70900, '64.84.15665511639351759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:06:04', 194, 0, '', '2019-08-23 17:06:04');
INSERT INTO `access_log` VALUES (70901, '64.80.15665511644341763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:06:04', 2, 0, '', '2019-08-23 17:06:04');
INSERT INTO `access_log` VALUES (70902, '64.80.15665511644341763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:06:04', 2, 0, '', '2019-08-23 17:06:05');
INSERT INTO `access_log` VALUES (70903, '64.82.15665511684661777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:06:08', 24, 0, '', '2019-08-23 17:06:08');
INSERT INTO `access_log` VALUES (70904, '64.85.15665511687171787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:06:09', 2, 0, '', '2019-08-23 17:06:09');
INSERT INTO `access_log` VALUES (70905, '59.73.15665511777401377', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:06:18', 2, 0, '', '2019-08-23 17:06:18');
INSERT INTO `access_log` VALUES (70906, '59.77.15665511777441361', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:06:18', 12, 2001001000, '服务端发生异常', '2019-08-23 17:06:18');
INSERT INTO `access_log` VALUES (70907, '64.77.15665511803631743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:06:20', 2, 0, '', '2019-08-23 17:06:20');
INSERT INTO `access_log` VALUES (70908, '64.81.15665511804881763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:06:20', 1, 0, '', '2019-08-23 17:06:20');
INSERT INTO `access_log` VALUES (70909, '64.76.15665511821181763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:06:22', 2, 0, '', '2019-08-23 17:06:22');
INSERT INTO `access_log` VALUES (70910, '64.83.15665511827901757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:06:23', 2, 0, '', '2019-08-23 17:06:23');
INSERT INTO `access_log` VALUES (70911, '66.52.15665511852108883', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.60.210', '2019-08-23 17:06:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空\n账号长度为 11 位', '2019-08-23 17:06:25');
INSERT INTO `access_log` VALUES (70912, '65.49.15665527578904641', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:32:38', 1, 1002001015, '账号未登陆', '2019-08-23 17:32:38');
INSERT INTO `access_log` VALUES (70913, '65.53.15665527578964587', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:32:38', 1, 1002001015, '账号未登陆', '2019-08-23 17:32:38');
INSERT INTO `access_log` VALUES (70914, '65.3607.15665527579186437', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:32:38', 1, 1002001015, '账号未登陆', '2019-08-23 17:32:38');
INSERT INTO `access_log` VALUES (70915, '65.46.15665527732104657', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:32:53', 71, 0, '', '2019-08-23 17:32:53');
INSERT INTO `access_log` VALUES (70916, '65.52.15665527735074679', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:32:54', 18, 0, '', '2019-08-23 17:32:54');
INSERT INTO `access_log` VALUES (70917, '65.54.15665527735074521', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:32:54', 17, 2001001000, '服务端发生异常', '2019-08-23 17:32:54');
INSERT INTO `access_log` VALUES (70918, '65.51.15665527735154693', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:32:54', 16, 0, '', '2019-08-23 17:32:54');
INSERT INTO `access_log` VALUES (70919, '65.53.15665527895144589', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:33:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 17:33:10');
INSERT INTO `access_log` VALUES (70920, '65.49.15665528093784643', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:33:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 17:33:29');
INSERT INTO `access_log` VALUES (70921, '65.46.15665528229284659', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:33:43', 56, 0, '', '2019-08-23 17:33:43');
INSERT INTO `access_log` VALUES (70922, '65.52.15665528232774681', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:33:43', 9, 0, '', '2019-08-23 17:33:43');
INSERT INTO `access_log` VALUES (70923, '65.54.15665528232784523', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:33:43', 9, 0, '', '2019-08-23 17:33:43');
INSERT INTO `access_log` VALUES (70924, '65.51.15665528232784695', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:33:43', 11, 2001001000, '服务端发生异常', '2019-08-23 17:33:43');
INSERT INTO `access_log` VALUES (70925, '59.72.15665528757571399', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:34:36', 2, 0, '', '2019-08-23 17:34:36');
INSERT INTO `access_log` VALUES (70926, '59.78.15665528757571407', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.168.50.10', '2019-08-23 17:34:36', 13, 2001001000, '服务端发生异常', '2019-08-23 17:34:36');
INSERT INTO `access_log` VALUES (70927, '59.73.15665536538951411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:47:34', 3, 0, '', '2019-08-23 17:47:34');
INSERT INTO `access_log` VALUES (70928, '59.75.15665536538941415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:47:34', 12, 2001001000, '服务端发生异常', '2019-08-23 17:47:34');
INSERT INTO `access_log` VALUES (70929, '64.77.15665536609401777', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:47:41', 11, 0, '', '2019-08-23 17:47:41');
INSERT INTO `access_log` VALUES (70930, '64.78.15665536610901809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:47:41', 3, 0, '', '2019-08-23 17:47:41');
INSERT INTO `access_log` VALUES (70931, '64.81.15665536642451797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:47:44', 2, 0, '', '2019-08-23 17:47:44');
INSERT INTO `access_log` VALUES (70932, '64.76.15665536645361797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:47:45', 2, 0, '', '2019-08-23 17:47:45');
INSERT INTO `access_log` VALUES (70933, '65.3607.15665536701206453', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:47:50', 0, 1002001015, '账号未登陆', '2019-08-23 17:47:50');
INSERT INTO `access_log` VALUES (70934, '65.50.15665536701194643', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:47:50', 0, 1002001015, '账号未登陆', '2019-08-23 17:47:50');
INSERT INTO `access_log` VALUES (70935, '65.53.15665536701204601', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:47:50', 0, 1002001015, '账号未登陆', '2019-08-23 17:47:50');
INSERT INTO `access_log` VALUES (70936, '65.45.15665536752484673', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:47:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-23 17:47:55');
INSERT INTO `access_log` VALUES (70937, '65.46.15665536803734673', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:48:00', 80, 0, '', '2019-08-23 17:48:00');
INSERT INTO `access_log` VALUES (70938, '65.51.15665536807344709', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:48:01', 8, 0, '', '2019-08-23 17:48:01');
INSERT INTO `access_log` VALUES (70939, '65.52.15665536807364693', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:48:01', 8, 2001001000, '服务端发生异常', '2019-08-23 17:48:01');
INSERT INTO `access_log` VALUES (70940, '65.54.15665536807754535', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:48:01', 9, 0, '', '2019-08-23 17:48:01');
INSERT INTO `access_log` VALUES (70941, '65.3607.15665536898616455', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:48:10', 9, 0, '', '2019-08-23 17:48:10');
INSERT INTO `access_log` VALUES (70942, '65.53.15665536898654603', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:48:10', 10, 2001001000, '服务端发生异常', '2019-08-23 17:48:10');
INSERT INTO `access_log` VALUES (70943, '65.50.15665536898684645', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:48:10', 9, 0, '', '2019-08-23 17:48:10');
INSERT INTO `access_log` VALUES (70944, '65.49.15665536919294659', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:48:12', 9, 0, '', '2019-08-23 17:48:12');
INSERT INTO `access_log` VALUES (70945, '65.45.15665536919324675', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:48:12', 10, 2001001000, '服务端发生异常', '2019-08-23 17:48:12');
INSERT INTO `access_log` VALUES (70946, '65.46.15665536919344675', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '116.30.223.34', '2019-08-23 17:48:12', 9, 0, '', '2019-08-23 17:48:12');
INSERT INTO `access_log` VALUES (70947, '59.74.15666007853822055', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:05', 13, 0, '', '2019-08-24 06:53:05');
INSERT INTO `access_log` VALUES (70948, '59.78.15666007853862047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:05', 26, 2001001000, '服务端发生异常', '2019-08-24 06:53:05');
INSERT INTO `access_log` VALUES (70949, '64.77.15666007879772405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:08', 12, 0, '', '2019-08-24 06:53:08');
INSERT INTO `access_log` VALUES (70950, '64.78.15666007881512439', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:08', 3, 0, '', '2019-08-24 06:53:08');
INSERT INTO `access_log` VALUES (70951, '64.81.15666007901962427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:10', 2, 0, '', '2019-08-24 06:53:10');
INSERT INTO `access_log` VALUES (70952, '64.76.15666007912422427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:11', 2, 0, '', '2019-08-24 06:53:11');
INSERT INTO `access_log` VALUES (70953, '64.83.15666007922672421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:12', 2, 0, '', '2019-08-24 06:53:12');
INSERT INTO `access_log` VALUES (70954, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:12', 12, 0, '', '2019-08-24 06:53:12');
INSERT INTO `access_log` VALUES (70955, '64.84.15666007940132425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:14', 2, 0, '', '2019-08-24 06:53:14');
INSERT INTO `access_log` VALUES (70956, '64.79.15666007941612421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:14', 3, 0, '', '2019-08-24 06:53:14');
INSERT INTO `access_log` VALUES (70957, '64.80.15666007955412427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:16', 2, 0, '', '2019-08-24 06:53:16');
INSERT INTO `access_log` VALUES (70958, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:16', 5, 0, '', '2019-08-24 06:53:16');
INSERT INTO `access_log` VALUES (70959, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:17', 6, 0, '', '2019-08-24 06:53:17');
INSERT INTO `access_log` VALUES (70960, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:18', 5, 0, '', '2019-08-24 06:53:18');
INSERT INTO `access_log` VALUES (70961, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:19', 6, 0, '', '2019-08-24 06:53:19');
INSERT INTO `access_log` VALUES (70962, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:20', 5, 0, '', '2019-08-24 06:53:20');
INSERT INTO `access_log` VALUES (70963, '64.85.15666008016462451', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:22', 8, 0, '', '2019-08-24 06:53:22');
INSERT INTO `access_log` VALUES (70964, '64.77.15666008100612407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:30', 2, 0, '', '2019-08-24 06:53:30');
INSERT INTO `access_log` VALUES (70965, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:30', 5, 0, '', '2019-08-24 06:53:30');
INSERT INTO `access_log` VALUES (70966, '64.78.15666008127412441', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:33', 2, 0, '', '2019-08-24 06:53:33');
INSERT INTO `access_log` VALUES (70967, '64.81.15666008130062429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:33', 3, 0, '', '2019-08-24 06:53:33');
INSERT INTO `access_log` VALUES (70968, '64.83.15666008165642423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:37', 2, 0, '', '2019-08-24 06:53:37');
INSERT INTO `access_log` VALUES (70969, '64.84.15666008168052427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:37', 2, 0, '', '2019-08-24 06:53:37');
INSERT INTO `access_log` VALUES (70970, '66.56.15666008343039561', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=1688266288276&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:53:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-08-24 06:53:54');
INSERT INTO `access_log` VALUES (70971, '66.50.15666008395549549', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=1688266288&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:54:00', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位', '2019-08-24 06:54:00');
INSERT INTO `access_log` VALUES (70972, '66.51.15666008492439573', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=16882662887&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:54:09', 20, 1001003000, '验证码不存在', '2019-08-24 06:54:09');
INSERT INTO `access_log` VALUES (70973, '66.53.15666008554929533', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=16882662887', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:54:15', 92, 0, '', '2019-08-24 06:54:16');
INSERT INTO `access_log` VALUES (70974, '66.49.15666008582059551', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=16882662887&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_2 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Mobile/15E148 Safari/604.1', '123.119.141.32', '2019-08-24 06:54:18', 200, 0, '', '2019-08-24 06:54:18');
INSERT INTO `access_log` VALUES (70975, '65.45.15666080496605401', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.196.192.182', '2019-08-24 08:54:10', 1, 1002001015, '账号未登陆', '2019-08-24 08:54:10');
INSERT INTO `access_log` VALUES (70976, '65.51.15666080496605435', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.196.192.182', '2019-08-24 08:54:10', 1, 1002001015, '账号未登陆', '2019-08-24 08:54:10');
INSERT INTO `access_log` VALUES (70977, '65.49.15666080496595385', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.196.192.182', '2019-08-24 08:54:10', 1, 1002001015, '账号未登陆', '2019-08-24 08:54:10');
INSERT INTO `access_log` VALUES (70978, '65.52.15666080554355421', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.196.192.182', '2019-08-24 08:54:15', 91, 0, '', '2019-08-24 08:54:16');
INSERT INTO `access_log` VALUES (70979, '65.3607.15666080556957183', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.196.192.182', '2019-08-24 08:54:16', 20, 0, '', '2019-08-24 08:54:16');
INSERT INTO `access_log` VALUES (70980, '65.54.15666080556905263', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.196.192.182', '2019-08-24 08:54:16', 12, 0, '', '2019-08-24 08:54:16');
INSERT INTO `access_log` VALUES (70981, '65.47.15666080556955319', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '115.196.192.182', '2019-08-24 08:54:16', 28, 2001001000, '服务端发生异常', '2019-08-24 08:54:16');
INSERT INTO `access_log` VALUES (70982, '59.73.15666093472772155', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.102.121.252', '2019-08-24 09:15:47', 21, 2001001000, '服务端发生异常', '2019-08-24 09:15:47');
INSERT INTO `access_log` VALUES (70983, '59.77.15666093472772141', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.102.121.252', '2019-08-24 09:15:47', 305, 0, '', '2019-08-24 09:15:48');
INSERT INTO `access_log` VALUES (70984, '64.78.15666093550002557', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.102.121.252', '2019-08-24 09:15:55', 14, 0, '', '2019-08-24 09:15:55');
INSERT INTO `access_log` VALUES (70985, '64.81.15666093551992545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.102.121.252', '2019-08-24 09:15:55', 7, 0, '', '2019-08-24 09:15:55');
INSERT INTO `access_log` VALUES (70986, '64.76.15666093627482545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.102.121.252', '2019-08-24 09:16:03', 4, 0, '', '2019-08-24 09:16:03');
INSERT INTO `access_log` VALUES (70987, '64.83.15666093628902539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.102.121.252', '2019-08-24 09:16:03', 2, 0, '', '2019-08-24 09:16:03');
INSERT INTO `access_log` VALUES (70988, '64.79.15666093705802539', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.102.121.252', '2019-08-24 09:16:11', 2, 0, '', '2019-08-24 09:16:11');
INSERT INTO `access_log` VALUES (70989, '64.80.15666093707382545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.102.121.252', '2019-08-24 09:16:11', 2, 0, '', '2019-08-24 09:16:11');
INSERT INTO `access_log` VALUES (70990, '59.74.15666093712982171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.102.121.252', '2019-08-24 09:16:11', 13, 2001001000, '服务端发生异常', '2019-08-24 09:16:11');
INSERT INTO `access_log` VALUES (70991, '59.79.15666093712982157', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.102.121.252', '2019-08-24 09:16:11', 64, 0, '', '2019-08-24 09:16:11');
INSERT INTO `access_log` VALUES (70992, '59.74.15666123342302211', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.65.189.9', '2019-08-24 10:05:34', 10, 0, '', '2019-08-24 10:05:34');
INSERT INTO `access_log` VALUES (70993, '59.79.15666123342312197', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.65.189.9', '2019-08-24 10:05:34', 24, 2001001000, '服务端发生异常', '2019-08-24 10:05:34');
INSERT INTO `access_log` VALUES (70994, '59.78.15666123407292207', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.65.189.9', '2019-08-24 10:05:41', 3, 0, '', '2019-08-24 10:05:41');
INSERT INTO `access_log` VALUES (70995, '59.72.15666123407302197', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.65.189.9', '2019-08-24 10:05:41', 14, 2001001000, '服务端发生异常', '2019-08-24 10:05:41');
INSERT INTO `access_log` VALUES (70996, '64.82.15666123735332599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:14', 12, 0, '', '2019-08-24 10:06:14');
INSERT INTO `access_log` VALUES (70997, '64.85.15666123738062609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:14', 3, 0, '', '2019-08-24 10:06:14');
INSERT INTO `access_log` VALUES (70998, '64.77.15666123756602565', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:16', 1, 0, '', '2019-08-24 10:06:16');
INSERT INTO `access_log` VALUES (70999, '64.78.15666123764172599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:16', 2, 0, '', '2019-08-24 10:06:16');
INSERT INTO `access_log` VALUES (71000, '64.81.15666123774272587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:17', 1, 0, '', '2019-08-24 10:06:17');
INSERT INTO `access_log` VALUES (71001, '64.76.15666123783722587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:18', 2, 0, '', '2019-08-24 10:06:18');
INSERT INTO `access_log` VALUES (71002, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:18', 6, 0, '', '2019-08-24 10:06:18');
INSERT INTO `access_log` VALUES (71003, '64.83.15666123800512581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:20', 2, 0, '', '2019-08-24 10:06:20');
INSERT INTO `access_log` VALUES (71004, '64.79.15666123805472581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:21', 2, 0, '', '2019-08-24 10:06:21');
INSERT INTO `access_log` VALUES (71005, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=u&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:23', 6, 0, '', '2019-08-24 10:06:23');
INSERT INTO `access_log` VALUES (71006, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=u', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:23', 6, 0, '', '2019-08-24 10:06:23');
INSERT INTO `access_log` VALUES (71007, '64.80.15666123849722587', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:25', 1, 0, '', '2019-08-24 10:06:25');
INSERT INTO `access_log` VALUES (71008, '64.82.15666123851032601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:25', 1, 0, '', '2019-08-24 10:06:25');
INSERT INTO `access_log` VALUES (71009, '59.77.15666123900342183', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:30', 3, 0, '', '2019-08-24 10:06:30');
INSERT INTO `access_log` VALUES (71010, '59.80.15666123900352171', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '222.65.189.9', '2019-08-24 10:06:30', 17, 2001001000, '服务端发生异常', '2019-08-24 10:06:30');
INSERT INTO `access_log` VALUES (71011, '65.53.15666124068365389', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.65.189.9', '2019-08-24 10:06:47', 0, 1002001015, '账号未登陆', '2019-08-24 10:06:47');
INSERT INTO `access_log` VALUES (71012, '65.50.15666124068375431', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.65.189.9', '2019-08-24 10:06:47', 0, 1002001015, '账号未登陆', '2019-08-24 10:06:47');
INSERT INTO `access_log` VALUES (71013, '65.46.15666124068495459', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.65.189.9', '2019-08-24 10:06:47', 1, 1002001015, '账号未登陆', '2019-08-24 10:06:47');
INSERT INTO `access_log` VALUES (71014, '65.45.15666124129345461', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.65.189.9', '2019-08-24 10:06:53', 1, 1002001015, '账号未登陆', '2019-08-24 10:06:53');
INSERT INTO `access_log` VALUES (71015, '65.51.15666124129335495', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.65.189.9', '2019-08-24 10:06:53', 1, 1002001015, '账号未登陆', '2019-08-24 10:06:53');
INSERT INTO `access_log` VALUES (71016, '65.49.15666124129355445', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.65.189.9', '2019-08-24 10:06:53', 0, 1002001015, '账号未登陆', '2019-08-24 10:06:53');
INSERT INTO `access_log` VALUES (71017, '65.3607.15666124186537243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.65.189.9', '2019-08-24 10:06:59', 69, 0, '', '2019-08-24 10:06:59');
INSERT INTO `access_log` VALUES (71018, '65.47.15666124190705379', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.65.189.9', '2019-08-24 10:06:59', 11, 2001001000, '服务端发生异常', '2019-08-24 10:06:59');
INSERT INTO `access_log` VALUES (71019, '65.54.15666124190705323', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.65.189.9', '2019-08-24 10:06:59', 12, 0, '', '2019-08-24 10:06:59');
INSERT INTO `access_log` VALUES (71020, '65.53.15666124190715391', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.65.189.9', '2019-08-24 10:06:59', 12, 0, '', '2019-08-24 10:06:59');
INSERT INTO `access_log` VALUES (71021, '59.80.15666159713882219', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.164.107.116', '2019-08-24 11:06:11', 11, 0, '', '2019-08-24 11:06:11');
INSERT INTO `access_log` VALUES (71022, '59.76.15666159713972237', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.164.107.116', '2019-08-24 11:06:11', 22, 2001001000, '服务端发生异常', '2019-08-24 11:06:11');
INSERT INTO `access_log` VALUES (71023, '65.52.15666160783265531', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.164.107.116', '2019-08-24 11:07:58', 0, 1002001015, '账号未登陆', '2019-08-24 11:07:58');
INSERT INTO `access_log` VALUES (71024, '65.45.15666160783265511', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.164.107.116', '2019-08-24 11:07:58', 0, 1002001015, '账号未登陆', '2019-08-24 11:07:58');
INSERT INTO `access_log` VALUES (71025, '65.3607.15666160783267293', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.164.107.116', '2019-08-24 11:07:58', 0, 1002001015, '账号未登陆', '2019-08-24 11:07:58');
INSERT INTO `access_log` VALUES (71026, '65.47.15666160805865429', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.164.107.116', '2019-08-24 11:08:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-24 11:08:01');
INSERT INTO `access_log` VALUES (71027, '65.54.15666160853325373', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.164.107.116', '2019-08-24 11:08:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-24 11:08:05');
INSERT INTO `access_log` VALUES (71028, '65.45.15666161657965513', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '180.164.107.116', '2019-08-24 11:09:26', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-24 11:09:26');
INSERT INTO `access_log` VALUES (71029, '59.79.15666185351152281', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:48:55', 15, 0, '', '2019-08-24 11:48:55');
INSERT INTO `access_log` VALUES (71030, '59.78.15666185351182291', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:48:55', 19, 2001001000, '服务端发生异常', '2019-08-24 11:48:55');
INSERT INTO `access_log` VALUES (71031, '59.72.15666185390042281', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:48:59', 3, 0, '', '2019-08-24 11:48:59');
INSERT INTO `access_log` VALUES (71032, '59.71.15666185392582279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:48:59', 16, 2001001000, '服务端发生异常', '2019-08-24 11:48:59');
INSERT INTO `access_log` VALUES (71033, '64.77.15666185492972649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:09', 10, 0, '', '2019-08-24 11:49:09');
INSERT INTO `access_log` VALUES (71034, '64.78.15666185494172683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:09', 3, 0, '', '2019-08-24 11:49:09');
INSERT INTO `access_log` VALUES (71035, '64.81.15666185510242671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:11', 2, 0, '', '2019-08-24 11:49:11');
INSERT INTO `access_log` VALUES (71036, '64.76.15666185517072671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:12', 2, 0, '', '2019-08-24 11:49:12');
INSERT INTO `access_log` VALUES (71037, '64.83.15666185525672665', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:13', 2, 0, '', '2019-08-24 11:49:13');
INSERT INTO `access_log` VALUES (71038, '59.73.15666185544212281', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:14', 2, 0, '', '2019-08-24 11:49:14');
INSERT INTO `access_log` VALUES (71039, '59.77.15666185544252267', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:14', 17, 2001001000, '服务端发生异常', '2019-08-24 11:49:14');
INSERT INTO `access_log` VALUES (71040, '59.80.15666185688692255', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:29', 2, 0, '', '2019-08-24 11:49:29');
INSERT INTO `access_log` VALUES (71041, '59.74.15666185691312297', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:29', 11, 2001001000, '服务端发生异常', '2019-08-24 11:49:29');
INSERT INTO `access_log` VALUES (71042, '65.53.15666185791485475', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:39', 0, 1002001015, '账号未登陆', '2019-08-24 11:49:39');
INSERT INTO `access_log` VALUES (71043, '65.54.15666185791485407', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:39', 1, 1002001015, '账号未登陆', '2019-08-24 11:49:39');
INSERT INTO `access_log` VALUES (71044, '65.47.15666185791485463', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:39', 1, 1002001015, '账号未登陆', '2019-08-24 11:49:39');
INSERT INTO `access_log` VALUES (71045, '65.46.15666185848515545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:45', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-24 11:49:45');
INSERT INTO `access_log` VALUES (71046, '65.51.15666185967395581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:57', 106, 0, '', '2019-08-24 11:49:57');
INSERT INTO `access_log` VALUES (71047, '65.49.15666185975755531', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:58', 13, 0, '', '2019-08-24 11:49:58');
INSERT INTO `access_log` VALUES (71048, '65.52.15666185975755567', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:58', 15, 2001001000, '服务端发生异常', '2019-08-24 11:49:58');
INSERT INTO `access_log` VALUES (71049, '65.45.15666185976055547', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.20.192.216', '2019-08-24 11:49:58', 9, 0, '', '2019-08-24 11:49:58');
INSERT INTO `access_log` VALUES (71050, '59.75.15666331592652483', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:52:39', 9, 0, '', '2019-08-24 15:52:39');
INSERT INTO `access_log` VALUES (71051, '59.73.15666331592662477', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:52:39', 30, 2001001000, '服务端发生异常', '2019-08-24 15:52:39');
INSERT INTO `access_log` VALUES (71052, '64.85.15666331627732889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:52:43', 12, 0, '', '2019-08-24 15:52:43');
INSERT INTO `access_log` VALUES (71053, '64.77.15666331628872845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:52:43', 3, 0, '', '2019-08-24 15:52:43');
INSERT INTO `access_log` VALUES (71054, '64.78.15666331637622879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:52:44', 1, 0, '', '2019-08-24 15:52:44');
INSERT INTO `access_log` VALUES (71055, '64.81.15666331642892867', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:52:44', 2, 0, '', '2019-08-24 15:52:44');
INSERT INTO `access_log` VALUES (71056, '59.76.15666331657262469', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:52:46', 3, 0, '', '2019-08-24 15:52:46');
INSERT INTO `access_log` VALUES (71057, '59.77.15666331657262463', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:52:46', 13, 2001001000, '服务端发生异常', '2019-08-24 15:52:46');
INSERT INTO `access_log` VALUES (71058, '65.50.15666332007975717', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:53:21', 0, 1002001015, '账号未登陆', '2019-08-24 15:53:21');
INSERT INTO `access_log` VALUES (71059, '65.45.15666332007985743', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:53:21', 0, 1002001015, '账号未登陆', '2019-08-24 15:53:21');
INSERT INTO `access_log` VALUES (71060, '65.52.15666332008175765', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:53:21', 0, 1002001015, '账号未登陆', '2019-08-24 15:53:21');
INSERT INTO `access_log` VALUES (71061, '65.49.15666332032855727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:53:23', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-24 15:53:23');
INSERT INTO `access_log` VALUES (71062, '65.47.15666332209085661', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:53:41', 54, 0, '', '2019-08-24 15:53:41');
INSERT INTO `access_log` VALUES (71063, '65.54.15666332211915607', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:53:41', 12, 0, '', '2019-08-24 15:53:41');
INSERT INTO `access_log` VALUES (71064, '65.46.15666332211955743', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:53:41', 12, 2001001000, '服务端发生异常', '2019-08-24 15:53:41');
INSERT INTO `access_log` VALUES (71065, '65.51.15666332211975783', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '180.111.218.152', '2019-08-24 15:53:41', 10, 0, '', '2019-08-24 15:53:41');
INSERT INTO `access_log` VALUES (71066, '59.74.15666351213472519', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:21', 13, 0, '', '2019-08-24 16:25:21');
INSERT INTO `access_log` VALUES (71067, '59.79.15666351213482505', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:21', 40, 2001001000, '服务端发生异常', '2019-08-24 16:25:21');
INSERT INTO `access_log` VALUES (71068, '64.82.15666351239942907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:24', 21, 0, '', '2019-08-24 16:25:24');
INSERT INTO `access_log` VALUES (71069, '64.85.15666351242002917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:24', 3, 0, '', '2019-08-24 16:25:24');
INSERT INTO `access_log` VALUES (71070, '64.77.15666351252932873', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:25', 1, 0, '', '2019-08-24 16:25:25');
INSERT INTO `access_log` VALUES (71071, '64.78.15666351258832905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:26', 2, 0, '', '2019-08-24 16:25:26');
INSERT INTO `access_log` VALUES (71072, '66.54.15666351330340025', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号必须都是数字\n手机验证码不能为空\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-08-24 16:25:33');
INSERT INTO `access_log` VALUES (71073, '59.72.15666351460632505', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:46', 3, 0, '', '2019-08-24 16:25:46');
INSERT INTO `access_log` VALUES (71074, '59.71.15666351460652503', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:46', 11, 2001001000, '服务端发生异常', '2019-08-24 16:25:46');
INSERT INTO `access_log` VALUES (71075, '64.76.15666351484442893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:48', 2, 0, '', '2019-08-24 16:25:48');
INSERT INTO `access_log` VALUES (71076, '64.84.15666351486342893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:49', 2, 0, '', '2019-08-24 16:25:49');
INSERT INTO `access_log` VALUES (71077, '64.83.15666351497242889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:50', 2, 0, '', '2019-08-24 16:25:50');
INSERT INTO `access_log` VALUES (71078, '64.79.15666351503232889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:50', 2, 0, '', '2019-08-24 16:25:50');
INSERT INTO `access_log` VALUES (71079, '64.82.15666351524042909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:52', 2, 0, '', '2019-08-24 16:25:52');
INSERT INTO `access_log` VALUES (71080, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:52', 4, 0, '', '2019-08-24 16:25:52');
INSERT INTO `access_log` VALUES (71081, '64.85.15666351563322919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:56', 2, 0, '', '2019-08-24 16:25:56');
INSERT INTO `access_log` VALUES (71082, '64.77.15666351566242875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:25:57', 2, 0, '', '2019-08-24 16:25:57');
INSERT INTO `access_log` VALUES (71083, '64.78.15666351604352907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:26:00', 2, 0, '', '2019-08-24 16:26:00');
INSERT INTO `access_log` VALUES (71084, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:26:00', 6, 0, '', '2019-08-24 16:26:00');
INSERT INTO `access_log` VALUES (71085, '64.81.15666351620042895', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.97.56.156', '2019-08-24 16:26:02', 8, 0, '', '2019-08-24 16:26:02');
INSERT INTO `access_log` VALUES (71086, '65.54.15666456321495773', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.114.103.167', '2019-08-24 19:20:32', 6, 1002001015, '账号未登陆', '2019-08-24 19:20:32');
INSERT INTO `access_log` VALUES (71087, '65.51.15666456321495949', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.114.103.167', '2019-08-24 19:20:32', 6, 1002001015, '账号未登陆', '2019-08-24 19:20:32');
INSERT INTO `access_log` VALUES (71088, '65.46.15666456321495909', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.114.103.167', '2019-08-24 19:20:32', 6, 1002001015, '账号未登陆', '2019-08-24 19:20:32');
INSERT INTO `access_log` VALUES (71089, '65.45.15666456341785911', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.114.103.167', '2019-08-24 19:20:34', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-24 19:20:34');
INSERT INTO `access_log` VALUES (71090, '65.50.15666456389175885', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.114.103.167', '2019-08-24 19:20:39', 118, 0, '', '2019-08-24 19:20:39');
INSERT INTO `access_log` VALUES (71091, '65.3607.15666456393737693', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.114.103.167', '2019-08-24 19:20:39', 23, 0, '', '2019-08-24 19:20:39');
INSERT INTO `access_log` VALUES (71092, '65.49.15666456393685895', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.114.103.167', '2019-08-24 19:20:39', 20, 0, '', '2019-08-24 19:20:39');
INSERT INTO `access_log` VALUES (71093, '65.53.15666456393725841', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.114.103.167', '2019-08-24 19:20:39', 25, 2001001000, '服务端发生异常', '2019-08-24 19:20:39');
INSERT INTO `access_log` VALUES (71094, '65.54.15666456609225775', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.114.103.167', '2019-08-24 19:21:01', 18, 0, '', '2019-08-24 19:21:01');
INSERT INTO `access_log` VALUES (71095, '65.51.15666456609225951', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.114.103.167', '2019-08-24 19:21:01', 19, 2001001000, '服务端发生异常', '2019-08-24 19:21:01');
INSERT INTO `access_log` VALUES (71096, '65.46.15666456609255911', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.114.103.167', '2019-08-24 19:21:01', 18, 0, '', '2019-08-24 19:21:01');
INSERT INTO `access_log` VALUES (71097, '59.80.15666539465242727', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.226.184.5', '2019-08-24 21:39:07', 11, 0, '', '2019-08-24 21:39:07');
INSERT INTO `access_log` VALUES (71098, '59.74.15666539465342771', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.226.184.5', '2019-08-24 21:39:07', 30, 2001001000, '服务端发生异常', '2019-08-24 21:39:07');
INSERT INTO `access_log` VALUES (71099, '59.79.15666539543642757', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.226.184.5', '2019-08-24 21:39:14', 3, 0, '', '2019-08-24 21:39:14');
INSERT INTO `access_log` VALUES (71100, '59.78.15666539543662767', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.226.184.5', '2019-08-24 21:39:14', 13, 2001001000, '服务端发生异常', '2019-08-24 21:39:14');
INSERT INTO `access_log` VALUES (71101, '64.79.15666539563713141', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.226.184.5', '2019-08-24 21:39:16', 14, 0, '', '2019-08-24 21:39:16');
INSERT INTO `access_log` VALUES (71102, '64.80.15666539567133149', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.226.184.5', '2019-08-24 21:39:17', 4, 0, '', '2019-08-24 21:39:17');
INSERT INTO `access_log` VALUES (71103, '64.82.15666539585223161', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.226.184.5', '2019-08-24 21:39:19', 2, 0, '', '2019-08-24 21:39:19');
INSERT INTO `access_log` VALUES (71104, '64.77.15666539686783127', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.226.184.5', '2019-08-24 21:39:29', 2, 0, '', '2019-08-24 21:39:29');
INSERT INTO `access_log` VALUES (71105, '64.78.15666539688843159', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.226.184.5', '2019-08-24 21:39:29', 2, 0, '', '2019-08-24 21:39:29');
INSERT INTO `access_log` VALUES (71106, '59.71.15666539738072755', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.226.184.5', '2019-08-24 21:39:34', 16, 2001001000, '服务端发生异常', '2019-08-24 21:39:34');
INSERT INTO `access_log` VALUES (71107, '59.73.15666539738092757', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.226.184.5', '2019-08-24 21:39:34', 128, 0, '', '2019-08-24 21:39:34');
INSERT INTO `access_log` VALUES (71108, '64.76.15666539765153147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.226.184.5', '2019-08-24 21:39:37', 2, 0, '', '2019-08-24 21:39:37');
INSERT INTO `access_log` VALUES (71109, '64.84.15666539766853147', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.226.184.5', '2019-08-24 21:39:37', 3, 0, '', '2019-08-24 21:39:37');
INSERT INTO `access_log` VALUES (71110, '64.83.15666539776693143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.226.184.5', '2019-08-24 21:39:38', 2, 0, '', '2019-08-24 21:39:38');
INSERT INTO `access_log` VALUES (71111, '64.79.15666539782943143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.226.184.5', '2019-08-24 21:39:38', 2, 0, '', '2019-08-24 21:39:38');
INSERT INTO `access_log` VALUES (71112, '59.77.15666539807172743', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.226.184.5', '2019-08-24 21:39:41', 3, 0, '', '2019-08-24 21:39:41');
INSERT INTO `access_log` VALUES (71113, '59.76.15666539807162749', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.226.184.5', '2019-08-24 21:39:41', 17, 2001001000, '服务端发生异常', '2019-08-24 21:39:41');
INSERT INTO `access_log` VALUES (71114, '65.54.15666573267565931', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:35:27', 1, 1002001015, '账号未登陆', '2019-08-24 22:35:27');
INSERT INTO `access_log` VALUES (71115, '65.46.15666573267566067', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:35:27', 0, 1002001015, '账号未登陆', '2019-08-24 22:35:27');
INSERT INTO `access_log` VALUES (71116, '65.45.15666573267596069', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:35:27', 0, 1002001015, '账号未登陆', '2019-08-24 22:35:27');
INSERT INTO `access_log` VALUES (71117, '65.53.15666573850375999', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:36:25', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-24 22:36:25');
INSERT INTO `access_log` VALUES (71118, '65.47.15666573973655987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:36:37', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-24 22:36:37');
INSERT INTO `access_log` VALUES (71119, '65.54.15666574041255933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:36:44', 51, 1002002001, '密码不正确', '2019-08-24 22:36:44');
INSERT INTO `access_log` VALUES (71120, '65.52.15666574306476093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:37:11', 70, 0, '', '2019-08-24 22:37:11');
INSERT INTO `access_log` VALUES (71121, '65.49.15666574311306055', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:37:11', 231, 2001001000, '服务端发生异常', '2019-08-24 22:37:11');
INSERT INTO `access_log` VALUES (71122, '65.50.15666574311266045', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:37:11', 236, 0, '', '2019-08-24 22:37:11');
INSERT INTO `access_log` VALUES (71123, '65.3607.15666574312027853', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:37:11', 172, 0, '', '2019-08-24 22:37:11');
INSERT INTO `access_log` VALUES (71124, '65.47.15666574417815989', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:37:22', 12, 0, '', '2019-08-24 22:37:22');
INSERT INTO `access_log` VALUES (71125, '65.51.15666574417816111', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:37:22', 11, 0, '', '2019-08-24 22:37:22');
INSERT INTO `access_log` VALUES (71126, '65.53.15666574417816001', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:37:22', 14, 2001001000, '服务端发生异常', '2019-08-24 22:37:22');
INSERT INTO `access_log` VALUES (71127, '65.46.15666574588126071', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:37:39', 10, 0, '', '2019-08-24 22:37:39');
INSERT INTO `access_log` VALUES (71128, '65.45.15666574588146073', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:37:39', 10, 2001001000, '服务端发生异常', '2019-08-24 22:37:39');
INSERT INTO `access_log` VALUES (71129, '65.52.15666574588176095', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-24 22:37:39', 9, 0, '', '2019-08-24 22:37:39');
INSERT INTO `access_log` VALUES (71130, '65.50.15666583697526059', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '116.77.131.104', '2019-08-24 22:52:50', 1, 1002001015, '账号未登陆', '2019-08-24 22:52:50');
INSERT INTO `access_log` VALUES (71131, '65.49.15666583697636069', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '116.77.131.104', '2019-08-24 22:52:50', 0, 1002001015, '账号未登陆', '2019-08-24 22:52:50');
INSERT INTO `access_log` VALUES (71132, '65.47.15666583697646003', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '116.77.131.104', '2019-08-24 22:52:50', 1, 1002001015, '账号未登陆', '2019-08-24 22:52:50');
INSERT INTO `access_log` VALUES (71133, '65.53.15666583721316015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '116.77.131.104', '2019-08-24 22:52:52', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-24 22:52:52');
INSERT INTO `access_log` VALUES (71134, '65.54.15666583787495949', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '116.77.131.104', '2019-08-24 22:52:59', 69, 0, '', '2019-08-24 22:52:59');
INSERT INTO `access_log` VALUES (71135, '65.45.15666583794136087', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '116.77.131.104', '2019-08-24 22:52:59', 10, 0, '', '2019-08-24 22:52:59');
INSERT INTO `access_log` VALUES (71136, '65.46.15666583794166085', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '116.77.131.104', '2019-08-24 22:52:59', 10, 0, '', '2019-08-24 22:52:59');
INSERT INTO `access_log` VALUES (71137, '65.52.15666583794136109', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '116.77.131.104', '2019-08-24 22:52:59', 11, 2001001000, '服务端发生异常', '2019-08-24 22:52:59');
INSERT INTO `access_log` VALUES (71138, '65.49.15666584112656071', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '116.77.131.104', '2019-08-24 22:53:31', 8, 0, '', '2019-08-24 22:53:31');
INSERT INTO `access_log` VALUES (71139, '65.47.15666584112766005', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '116.77.131.104', '2019-08-24 22:53:31', 9, 2001001000, '服务端发生异常', '2019-08-24 22:53:31');
INSERT INTO `access_log` VALUES (71140, '65.53.15666584112966017', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '116.77.131.104', '2019-08-24 22:53:31', 8, 0, '', '2019-08-24 22:53:31');
INSERT INTO `access_log` VALUES (71141, '59.77.15666993893363349', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.30.137.223', '2019-08-25 10:16:29', 32, 2001001000, '服务端发生异常', '2019-08-25 10:16:29');
INSERT INTO `access_log` VALUES (71142, '59.75.15666993893353369', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.30.137.223', '2019-08-25 10:16:29', 94, 0, '', '2019-08-25 10:16:29');
INSERT INTO `access_log` VALUES (71143, '64.83.15666993957103749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.30.137.223', '2019-08-25 10:16:36', 12, 0, '', '2019-08-25 10:16:36');
INSERT INTO `access_log` VALUES (71144, '64.79.15666993959033749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.30.137.223', '2019-08-25 10:16:36', 3, 0, '', '2019-08-25 10:16:36');
INSERT INTO `access_log` VALUES (71145, '64.80.15666994010453757', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.30.137.223', '2019-08-25 10:16:41', 1, 0, '', '2019-08-25 10:16:41');
INSERT INTO `access_log` VALUES (71146, '64.82.15666994011993769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.30.137.223', '2019-08-25 10:16:41', 2, 0, '', '2019-08-25 10:16:41');
INSERT INTO `access_log` VALUES (71147, '64.85.15666994065773779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.30.137.223', '2019-08-25 10:16:47', 2, 0, '', '2019-08-25 10:16:47');
INSERT INTO `access_log` VALUES (71148, '64.77.15666994067543735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.30.137.223', '2019-08-25 10:16:47', 2, 0, '', '2019-08-25 10:16:47');
INSERT INTO `access_log` VALUES (71149, '59.74.15666994078033379', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.30.137.223', '2019-08-25 10:16:48', 3, 0, '', '2019-08-25 10:16:48');
INSERT INTO `access_log` VALUES (71150, '59.80.15666994078043335', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.30.137.223', '2019-08-25 10:16:48', 18, 2001001000, '服务端发生异常', '2019-08-25 10:16:48');
INSERT INTO `access_log` VALUES (71151, '59.73.15667018673433397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; PBEM00 Build/OPM1.171019.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.12 baiduboxapp/11.12.0.10 (Baidu; P1 8.1.0)', '101.84.16.82', '2019-08-25 10:57:47', 11, 0, '', '2019-08-25 10:57:47');
INSERT INTO `access_log` VALUES (71152, '59.75.15667018673443403', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; PBEM00 Build/OPM1.171019.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.12 baiduboxapp/11.12.0.10 (Baidu; P1 8.1.0)', '101.84.16.82', '2019-08-25 10:57:47', 19, 2001001000, '服务端发生异常', '2019-08-25 10:57:47');
INSERT INTO `access_log` VALUES (71153, '64.79.15667018705013783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; PBEM00 Build/OPM1.171019.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.12 baiduboxapp/11.12.0.10 (Baidu; P1 8.1.0)', '101.84.16.82', '2019-08-25 10:57:51', 16, 0, '', '2019-08-25 10:57:51');
INSERT INTO `access_log` VALUES (71154, '64.80.15667018707003791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; PBEM00 Build/OPM1.171019.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.12 baiduboxapp/11.12.0.10 (Baidu; P1 8.1.0)', '101.84.16.82', '2019-08-25 10:57:51', 4, 0, '', '2019-08-25 10:57:51');
INSERT INTO `access_log` VALUES (71155, '64.82.15667018724113803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; PBEM00 Build/OPM1.171019.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.12 baiduboxapp/11.12.0.10 (Baidu; P1 8.1.0)', '101.84.16.82', '2019-08-25 10:57:52', 2, 0, '', '2019-08-25 10:57:52');
INSERT INTO `access_log` VALUES (71156, '65.49.15667018830686653', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; PBEM00 Build/OPM1.171019.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.12 baiduboxapp/11.12.0.10 (Baidu; P1 8.1.0)', '101.84.16.82', '2019-08-25 10:58:03', 0, 1002001015, '账号未登陆', '2019-08-25 10:58:03');
INSERT INTO `access_log` VALUES (71157, '65.47.15667018831116587', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; PBEM00 Build/OPM1.171019.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.12 baiduboxapp/11.12.0.10 (Baidu; P1 8.1.0)', '101.84.16.82', '2019-08-25 10:58:03', 0, 1002001015, '账号未登陆', '2019-08-25 10:58:03');
INSERT INTO `access_log` VALUES (71158, '65.51.15667018831286707', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.1.0; PBEM00 Build/OPM1.171019.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.12 baiduboxapp/11.12.0.10 (Baidu; P1 8.1.0)', '101.84.16.82', '2019-08-25 10:58:03', 0, 1002001015, '账号未登陆', '2019-08-25 10:58:03');
INSERT INTO `access_log` VALUES (71159, '65.52.15667018865806691', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1.0; PBEM00 Build/OPM1.171019.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.12 baiduboxapp/11.12.0.10 (Baidu; P1 8.1.0)', '101.84.16.82', '2019-08-25 10:58:07', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-25 10:58:07');
INSERT INTO `access_log` VALUES (71160, '65.53.15667018894366597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1.0; PBEM00 Build/OPM1.171019.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.12 baiduboxapp/11.12.0.10 (Baidu; P1 8.1.0)', '101.84.16.82', '2019-08-25 10:58:09', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-25 10:58:09');
INSERT INTO `access_log` VALUES (71161, '65.46.15667018925196669', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 8.1.0; PBEM00 Build/OPM1.171019.026; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/63.0.3239.83 Mobile Safari/537.36 T7/11.12 baiduboxapp/11.12.0.10 (Baidu; P1 8.1.0)', '101.84.16.82', '2019-08-25 10:58:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-25 10:58:13');
INSERT INTO `access_log` VALUES (71162, '59.74.15667018926193413', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '118.249.49.154', '2019-08-25 10:58:13', 3, 0, '', '2019-08-25 10:58:13');
INSERT INTO `access_log` VALUES (71163, '59.80.15667018926203369', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '118.249.49.154', '2019-08-25 10:58:13', 18, 2001001000, '服务端发生异常', '2019-08-25 10:58:13');
INSERT INTO `access_log` VALUES (71164, '59.72.15667022232103403', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:03:43', 3, 0, '', '2019-08-25 11:03:43');
INSERT INTO `access_log` VALUES (71165, '59.71.15667022232113401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:03:43', 19, 2001001000, '服务端发生异常', '2019-08-25 11:03:43');
INSERT INTO `access_log` VALUES (71166, '64.76.15667022356513793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:03:56', 2, 0, '', '2019-08-25 11:03:56');
INSERT INTO `access_log` VALUES (71167, '64.84.15667022358633793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:03:56', 2, 0, '', '2019-08-25 11:03:56');
INSERT INTO `access_log` VALUES (71168, '64.83.15667022397713789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:04:00', 2, 0, '', '2019-08-25 11:04:00');
INSERT INTO `access_log` VALUES (71169, '64.79.15667022430633789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:04:03', 2, 0, '', '2019-08-25 11:04:03');
INSERT INTO `access_log` VALUES (71170, '59.76.15667022454113395', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:04:05', 3, 0, '', '2019-08-25 11:04:05');
INSERT INTO `access_log` VALUES (71171, '59.77.15667022454113389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:04:05', 54, 2001001000, '服务端发生异常', '2019-08-25 11:04:05');
INSERT INTO `access_log` VALUES (71172, '59.80.15667022498913375', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:04:10', 2, 0, '', '2019-08-25 11:04:10');
INSERT INTO `access_log` VALUES (71173, '59.74.15667022498913419', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:04:10', 12, 2001001000, '服务端发生异常', '2019-08-25 11:04:10');
INSERT INTO `access_log` VALUES (71174, '59.79.15667022546713405', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:04:15', 2, 0, '', '2019-08-25 11:04:15');
INSERT INTO `access_log` VALUES (71175, '59.78.15667022546713415', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:04:15', 24, 2001001000, '服务端发生异常', '2019-08-25 11:04:15');
INSERT INTO `access_log` VALUES (71176, '64.82.15667022553723809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:04:15', 1, 0, '', '2019-08-25 11:04:15');
INSERT INTO `access_log` VALUES (71177, '64.85.15667022556313819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:04:16', 1, 0, '', '2019-08-25 11:04:16');
INSERT INTO `access_log` VALUES (71178, '59.71.15667022562313403', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:04:16', 3, 0, '', '2019-08-25 11:04:16');
INSERT INTO `access_log` VALUES (71179, '59.72.15667022562313405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:04:16', 15, 2001001000, '服务端发生异常', '2019-08-25 11:04:16');
INSERT INTO `access_log` VALUES (71180, '65.47.15667023603876595', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:06:00', 0, 1002001015, '账号未登陆', '2019-08-25 11:06:00');
INSERT INTO `access_log` VALUES (71181, '65.3607.15667023603848457', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:06:00', 0, 1002001015, '账号未登陆', '2019-08-25 11:06:00');
INSERT INTO `access_log` VALUES (71182, '65.50.15667023603846649', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:06:00', 0, 1002001015, '账号未登陆', '2019-08-25 11:06:00');
INSERT INTO `access_log` VALUES (71183, '65.52.15667023882816699', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:06:28', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-25 11:06:28');
INSERT INTO `access_log` VALUES (71184, '65.53.15667024117006605', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=youdaoyuanma&password=youdaoyuanma&type=account', 'POST', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:06:52', 10, 1002002000, '账号不存在', '2019-08-25 11:06:52');
INSERT INTO `access_log` VALUES (71185, '65.45.15667024166006679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:06:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-25 11:06:57');
INSERT INTO `access_log` VALUES (71186, '59.76.15667024468623399', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '61.145.209.127', '2019-08-25 11:07:27', 2, 0, '', '2019-08-25 11:07:27');
INSERT INTO `access_log` VALUES (71187, '59.80.15667024468633379', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '61.145.209.127', '2019-08-25 11:07:27', 12, 2001001000, '服务端发生异常', '2019-08-25 11:07:27');
INSERT INTO `access_log` VALUES (71188, '65.3607.15667024506788459', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:07:31', 104, 0, '', '2019-08-25 11:07:31');
INSERT INTO `access_log` VALUES (71189, '65.49.15667024515576663', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:07:32', 13, 0, '', '2019-08-25 11:07:32');
INSERT INTO `access_log` VALUES (71190, '65.51.15667024515696717', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:07:32', 18, 2001001000, '服务端发生异常', '2019-08-25 11:07:32');
INSERT INTO `access_log` VALUES (71191, '65.52.15667024515866701', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'xiaomiquan/4.3.1 Android/Phone/7.1.2 vivo_vivo_X9Plus', '220.195.67.7', '2019-08-25 11:07:32', 10, 0, '', '2019-08-25 11:07:32');
INSERT INTO `access_log` VALUES (71192, '59.79.15667032042103419', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.94.30.0', '2019-08-25 11:20:04', 3, 0, '', '2019-08-25 11:20:04');
INSERT INTO `access_log` VALUES (71193, '59.78.15667032042143429', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.94.30.0', '2019-08-25 11:20:04', 14, 2001001000, '服务端发生异常', '2019-08-25 11:20:04');
INSERT INTO `access_log` VALUES (71194, '65.53.15667032137876617', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.94.30.6', '2019-08-25 11:20:14', 0, 1002001015, '账号未登陆', '2019-08-25 11:20:14');
INSERT INTO `access_log` VALUES (71195, '65.46.15667032137876689', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.94.30.6', '2019-08-25 11:20:14', 0, 1002001015, '账号未登陆', '2019-08-25 11:20:14');
INSERT INTO `access_log` VALUES (71196, '65.45.15667032137886691', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.94.30.6', '2019-08-25 11:20:14', 0, 1002001015, '账号未登陆', '2019-08-25 11:20:14');
INSERT INTO `access_log` VALUES (71197, '65.50.15667032271176663', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.94.30.6', '2019-08-25 11:20:27', 73, 0, '', '2019-08-25 11:20:27');
INSERT INTO `access_log` VALUES (71198, '65.3607.15667032275338471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.94.30.6', '2019-08-25 11:20:28', 9, 0, '', '2019-08-25 11:20:28');
INSERT INTO `access_log` VALUES (71199, '65.51.15667032275376729', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.94.30.6', '2019-08-25 11:20:28', 10, 2001001000, '服务端发生异常', '2019-08-25 11:20:28');
INSERT INTO `access_log` VALUES (71200, '65.52.15667032275416713', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '125.94.30.6', '2019-08-25 11:20:28', 8, 0, '', '2019-08-25 11:20:28');
INSERT INTO `access_log` VALUES (71201, '65.52.15667038087306721', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '220.189.247.173', '2019-08-25 11:30:09', 0, 1002001015, '账号未登陆', '2019-08-25 11:30:09');
INSERT INTO `access_log` VALUES (71202, '65.3607.15667038087468479', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '220.189.247.173', '2019-08-25 11:30:09', 1, 1002001015, '账号未登陆', '2019-08-25 11:30:09');
INSERT INTO `access_log` VALUES (71203, '65.49.15667038087466683', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '220.189.247.173', '2019-08-25 11:30:09', 1, 1002001015, '账号未登陆', '2019-08-25 11:30:09');
INSERT INTO `access_log` VALUES (71204, '65.46.15667038108596699', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '220.189.247.173', '2019-08-25 11:30:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-25 11:30:11');
INSERT INTO `access_log` VALUES (71205, '65.53.15667038292386627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '220.189.247.173', '2019-08-25 11:30:29', 52, 0, '', '2019-08-25 11:30:29');
INSERT INTO `access_log` VALUES (71206, '65.47.15667038296936619', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '220.189.247.173', '2019-08-25 11:30:30', 8, 0, '', '2019-08-25 11:30:30');
INSERT INTO `access_log` VALUES (71207, '65.51.15667038296976739', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '220.189.247.173', '2019-08-25 11:30:30', 8, 0, '', '2019-08-25 11:30:30');
INSERT INTO `access_log` VALUES (71208, '65.50.15667038296976673', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '220.189.247.173', '2019-08-25 11:30:30', 8, 2001001000, '服务端发生异常', '2019-08-25 11:30:30');
INSERT INTO `access_log` VALUES (71209, '65.52.15667038434136723', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '220.189.247.173', '2019-08-25 11:30:43', 7, 0, '', '2019-08-25 11:30:43');
INSERT INTO `access_log` VALUES (71210, '65.49.15667038434226685', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '220.189.247.173', '2019-08-25 11:30:43', 9, 2001001000, '服务端发生异常', '2019-08-25 11:30:43');
INSERT INTO `access_log` VALUES (71211, '65.54.15667038434256563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '220.189.247.173', '2019-08-25 11:30:43', 8, 0, '', '2019-08-25 11:30:43');
INSERT INTO `access_log` VALUES (71212, '65.47.15667042649156625', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.67.159.201', '2019-08-25 11:37:45', 1, 1002001015, '账号未登陆', '2019-08-25 11:37:45');
INSERT INTO `access_log` VALUES (71213, '65.49.15667042649156693', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.67.159.201', '2019-08-25 11:37:45', 1, 1002001015, '账号未登陆', '2019-08-25 11:37:45');
INSERT INTO `access_log` VALUES (71214, '65.3607.15667042649368487', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.67.159.201', '2019-08-25 11:37:45', 1, 1002001015, '账号未登陆', '2019-08-25 11:37:45');
INSERT INTO `access_log` VALUES (71215, '65.46.15667042669536707', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.67.159.201', '2019-08-25 11:37:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-25 11:37:47');
INSERT INTO `access_log` VALUES (71216, '59.75.15667063872493467', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 12:13:07', 9, 0, '', '2019-08-25 12:13:07');
INSERT INTO `access_log` VALUES (71217, '59.73.15667063872493461', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 12:13:07', 16, 2001001000, '服务端发生异常', '2019-08-25 12:13:07');
INSERT INTO `access_log` VALUES (71218, '64.79.15667063918513845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 12:13:12', 14, 0, '', '2019-08-25 12:13:12');
INSERT INTO `access_log` VALUES (71219, '64.83.15667063920253845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 12:13:12', 6, 0, '', '2019-08-25 12:13:12');
INSERT INTO `access_log` VALUES (71220, '64.81.15667063939213851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 12:13:14', 2, 0, '', '2019-08-25 12:13:14');
INSERT INTO `access_log` VALUES (71221, '64.80.15667063942873853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 12:13:14', 2, 0, '', '2019-08-25 12:13:14');
INSERT INTO `access_log` VALUES (71222, '65.52.15667064047596761', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 12:13:25', 1, 1002001015, '账号未登陆', '2019-08-25 12:13:25');
INSERT INTO `access_log` VALUES (71223, '65.50.15667064047586711', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 12:13:25', 1, 1002001015, '账号未登陆', '2019-08-25 12:13:25');
INSERT INTO `access_log` VALUES (71224, '65.54.15667064047596601', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 12:13:25', 1, 1002001015, '账号未登陆', '2019-08-25 12:13:25');
INSERT INTO `access_log` VALUES (71225, '65.47.15667064086106655', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 12:13:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-25 12:13:29');
INSERT INTO `access_log` VALUES (71226, '65.49.15667064138176723', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 12:13:34', 239, 0, '', '2019-08-25 12:13:34');
INSERT INTO `access_log` VALUES (71227, '65.3607.15667064143508517', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 12:13:34', 108, 0, '', '2019-08-25 12:13:34');
INSERT INTO `access_log` VALUES (71228, '65.46.15667064143576737', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 12:13:34', 102, 0, '', '2019-08-25 12:13:34');
INSERT INTO `access_log` VALUES (71229, '65.45.15667064143596741', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 12:13:34', 101, 2001001000, '服务端发生异常', '2019-08-25 12:13:34');
INSERT INTO `access_log` VALUES (71230, '65.51.15667079216206797', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-25 12:38:42', 6, 1002001012, '访问令牌已过期', '2019-08-25 12:38:42');
INSERT INTO `access_log` VALUES (71231, '65.54.15667079216206623', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-25 12:38:42', 6, 1002001012, '访问令牌已过期', '2019-08-25 12:38:42');
INSERT INTO `access_log` VALUES (71232, '65.50.15667079216206733', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-25 12:38:42', 6, 1002001012, '访问令牌已过期', '2019-08-25 12:38:42');
INSERT INTO `access_log` VALUES (71233, '65.52.15667079337676783', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-25 12:38:54', 97, 0, '', '2019-08-25 12:38:54');
INSERT INTO `access_log` VALUES (71234, '65.49.15667079342006745', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-25 12:38:54', 70, 0, '', '2019-08-25 12:38:54');
INSERT INTO `access_log` VALUES (71235, '65.3607.15667079342028539', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-25 12:38:54', 68, 2001001000, '服务端发生异常', '2019-08-25 12:38:54');
INSERT INTO `access_log` VALUES (71236, '65.46.15667079342036759', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.241.251.135', '2019-08-25 12:38:54', 67, 0, '', '2019-08-25 12:38:54');
INSERT INTO `access_log` VALUES (71237, '65.3607.15667135364398617', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 14:12:16', 12, 1002001012, '访问令牌已过期', '2019-08-25 14:12:16');
INSERT INTO `access_log` VALUES (71238, '65.49.15667135364756821', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 14:12:16', 171, 1002001012, '访问令牌已过期', '2019-08-25 14:12:17');
INSERT INTO `access_log` VALUES (71239, '65.46.15667135367166833', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 14:12:17', 5, 1002001012, '访问令牌已过期', '2019-08-25 14:12:17');
INSERT INTO `access_log` VALUES (71240, '65.54.15667135413006701', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 14:12:21', 5, 1002002000, '账号不存在', '2019-08-25 14:12:21');
INSERT INTO `access_log` VALUES (71241, '65.51.15667135508936873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 14:12:31', 61, 0, '', '2019-08-25 14:12:31');
INSERT INTO `access_log` VALUES (71242, '65.50.15667135514386811', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 14:12:31', 9, 0, '', '2019-08-25 14:12:31');
INSERT INTO `access_log` VALUES (71243, '65.53.15667135514496759', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 14:12:31', 193, 2001001000, '服务端发生异常', '2019-08-25 14:12:32');
INSERT INTO `access_log` VALUES (71244, '65.47.15667135514566757', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.176.216.64', '2019-08-25 14:12:31', 191, 0, '', '2019-08-25 14:12:32');
INSERT INTO `access_log` VALUES (71245, '65.52.15667190701616933', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '117.136.124.195', '2019-08-25 15:44:30', 0, 1002001015, '账号未登陆', '2019-08-25 15:44:30');
INSERT INTO `access_log` VALUES (71246, '65.53.15667190701616833', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '117.136.124.195', '2019-08-25 15:44:30', 0, 1002001015, '账号未登陆', '2019-08-25 15:44:30');
INSERT INTO `access_log` VALUES (71247, '65.3607.15667190701628693', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '117.136.124.195', '2019-08-25 15:44:30', 0, 1002001015, '账号未登陆', '2019-08-25 15:44:30');
INSERT INTO `access_log` VALUES (71248, '65.54.15667191049586777', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '117.136.124.195', '2019-08-25 15:45:05', 75, 0, '', '2019-08-25 15:45:05');
INSERT INTO `access_log` VALUES (71249, '65.45.15667191055736915', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '117.136.124.195', '2019-08-25 15:45:06', 76, 0, '', '2019-08-25 15:45:06');
INSERT INTO `access_log` VALUES (71250, '65.51.15667191055856949', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '117.136.124.195', '2019-08-25 15:45:06', 66, 0, '', '2019-08-25 15:45:06');
INSERT INTO `access_log` VALUES (71251, '65.50.15667191055896887', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '117.136.124.195', '2019-08-25 15:45:06', 62, 2001001000, '服务端发生异常', '2019-08-25 15:45:06');
INSERT INTO `access_log` VALUES (71252, '65.3607.15667191177268695', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '117.136.124.195', '2019-08-25 15:45:18', 8, 0, '', '2019-08-25 15:45:18');
INSERT INTO `access_log` VALUES (71253, '65.52.15667191177286935', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '117.136.124.195', '2019-08-25 15:45:18', 8, 0, '', '2019-08-25 15:45:18');
INSERT INTO `access_log` VALUES (71254, '65.53.15667191177296835', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.84 Safari/537.36', '117.136.124.195', '2019-08-25 15:45:18', 8, 2001001000, '服务端发生异常', '2019-08-25 15:45:18');
INSERT INTO `access_log` VALUES (71255, '65.46.15667191304636911', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '183.192.164.85', '2019-08-25 15:45:30', 1, 1002001015, '账号未登陆', '2019-08-25 15:45:30');
INSERT INTO `access_log` VALUES (71256, '65.54.15667191322856779', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '120.204.17.73', '2019-08-25 15:45:32', 0, 1002001015, '账号未登陆', '2019-08-25 15:45:32');
INSERT INTO `access_log` VALUES (71257, '65.51.15667191396436951', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '183.192.164.85', '2019-08-25 15:45:40', 0, 1002001015, '账号未登陆', '2019-08-25 15:45:40');
INSERT INTO `access_log` VALUES (71258, '59.71.15667220784523669', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 16:34:38', 9, 0, '', '2019-08-25 16:34:38');
INSERT INTO `access_log` VALUES (71259, '59.72.15667220784523671', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 16:34:38', 13, 2001001000, '服务端发生异常', '2019-08-25 16:34:38');
INSERT INTO `access_log` VALUES (71260, '59.75.15667220843153677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 16:34:44', 4, 0, '', '2019-08-25 16:34:44');
INSERT INTO `access_log` VALUES (71261, '59.73.15667220843163671', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 16:34:44', 15, 2001001000, '服务端发生异常', '2019-08-25 16:34:44');
INSERT INTO `access_log` VALUES (71262, '65.51.15667221243226991', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 16:35:24', 0, 1002001015, '账号未登陆', '2019-08-25 16:35:24');
INSERT INTO `access_log` VALUES (71263, '65.50.15667221243236929', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 16:35:24', 1, 1002001015, '账号未登陆', '2019-08-25 16:35:24');
INSERT INTO `access_log` VALUES (71264, '65.47.15667221243316875', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 16:35:24', 0, 1002001015, '账号未登陆', '2019-08-25 16:35:24');
INSERT INTO `access_log` VALUES (71265, '59.79.15667290632223765', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 18:31:03', 11, 0, '', '2019-08-25 18:31:03');
INSERT INTO `access_log` VALUES (71266, '59.71.15667290633053763', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 18:31:03', 21, 2001001000, '服务端发生异常', '2019-08-25 18:31:03');
INSERT INTO `access_log` VALUES (71267, '59.74.15667294421923785', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.6 Mobile Safari/537.36', '112.27.120.67', '2019-08-25 18:37:22', 2, 0, '', '2019-08-25 18:37:22');
INSERT INTO `access_log` VALUES (71268, '59.78.15667294421933781', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; COR-AL00 Build/HUAWEICOR-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/9.6 Mobile Safari/537.36', '112.27.120.67', '2019-08-25 18:37:22', 14, 2001001000, '服务端发生异常', '2019-08-25 18:37:22');
INSERT INTO `access_log` VALUES (71269, '65.52.15667312807227099', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.70.176.244', '2019-08-25 19:08:01', 28, 1002001012, '访问令牌已过期', '2019-08-25 19:08:01');
INSERT INTO `access_log` VALUES (71270, '65.3607.15667312807228859', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.70.176.244', '2019-08-25 19:08:01', 24, 1002001012, '访问令牌已过期', '2019-08-25 19:08:01');
INSERT INTO `access_log` VALUES (71271, '65.53.15667312807226999', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.70.176.244', '2019-08-25 19:08:01', 29, 1002001012, '访问令牌已过期', '2019-08-25 19:08:01');
INSERT INTO `access_log` VALUES (71272, '65.46.15667312996237075', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.70.176.244', '2019-08-25 19:08:20', 118, 0, '', '2019-08-25 19:08:20');
INSERT INTO `access_log` VALUES (71273, '65.54.15667313032036943', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.70.176.244', '2019-08-25 19:08:23', 11, 0, '', '2019-08-25 19:08:23');
INSERT INTO `access_log` VALUES (71274, '65.45.15667313032177081', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.70.176.244', '2019-08-25 19:08:23', 12, 0, '', '2019-08-25 19:08:23');
INSERT INTO `access_log` VALUES (71275, '65.51.15667313062187115', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.70.176.244', '2019-08-25 19:08:26', 12, 2001001000, '服务端发生异常', '2019-08-25 19:08:26');
INSERT INTO `access_log` VALUES (71276, '59.75.15667359543043863', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:25:54', 10, 0, '', '2019-08-25 20:25:54');
INSERT INTO `access_log` VALUES (71277, '59.77.15667359543053843', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:25:54', 16, 2001001000, '服务端发生异常', '2019-08-25 20:25:54');
INSERT INTO `access_log` VALUES (71278, '64.85.15667359629804273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:03', 12, 0, '', '2019-08-25 20:26:03');
INSERT INTO `access_log` VALUES (71279, '64.76.15667359631544251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:03', 3, 0, '', '2019-08-25 20:26:03');
INSERT INTO `access_log` VALUES (71280, '64.80.15667359645684247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:05', 2, 0, '', '2019-08-25 20:26:05');
INSERT INTO `access_log` VALUES (71281, '64.77.15667359651514229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:05', 2, 0, '', '2019-08-25 20:26:05');
INSERT INTO `access_log` VALUES (71282, '64.84.15667359686944243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:09', 2, 0, '', '2019-08-25 20:26:09');
INSERT INTO `access_log` VALUES (71283, '64.79.15667359690534243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:09', 2, 0, '', '2019-08-25 20:26:09');
INSERT INTO `access_log` VALUES (71284, '59.76.15667359698003849', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:10', 10, 0, '', '2019-08-25 20:26:10');
INSERT INTO `access_log` VALUES (71285, '59.74.15667359698043873', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:10', 16, 2001001000, '服务端发生异常', '2019-08-25 20:26:10');
INSERT INTO `access_log` VALUES (71286, '64.78.15667359714844263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:11', 2, 0, '', '2019-08-25 20:26:11');
INSERT INTO `access_log` VALUES (71287, '64.83.15667359716434245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:12', 2, 0, '', '2019-08-25 20:26:12');
INSERT INTO `access_log` VALUES (71288, '64.82.15667359724934261', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:12', 2, 0, '', '2019-08-25 20:26:12');
INSERT INTO `access_log` VALUES (71289, '64.85.15667359730114275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:13', 1, 0, '', '2019-08-25 20:26:13');
INSERT INTO `access_log` VALUES (71290, '64.80.15667359830474249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:23', 2, 0, '', '2019-08-25 20:26:23');
INSERT INTO `access_log` VALUES (71291, '64.77.15667359832234231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:23', 2, 0, '', '2019-08-25 20:26:23');
INSERT INTO `access_log` VALUES (71292, '64.81.15667359846284251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:25', 2, 0, '', '2019-08-25 20:26:25');
INSERT INTO `access_log` VALUES (71293, '64.84.15667359851484245', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:25', 2, 0, '', '2019-08-25 20:26:25');
INSERT INTO `access_log` VALUES (71294, '59.79.15667359860043859', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:26', 3, 0, '', '2019-08-25 20:26:26');
INSERT INTO `access_log` VALUES (71295, '59.71.15667359860053857', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3620.400', '113.12.24.74', '2019-08-25 20:26:26', 16, 2001001000, '服务端发生异常', '2019-08-25 20:26:26');
INSERT INTO `access_log` VALUES (71296, '59.77.15667360094493845', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:26:49', 2, 0, '', '2019-08-25 20:26:49');
INSERT INTO `access_log` VALUES (71297, '59.75.15667360094513865', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:26:49', 20, 2001001000, '服务端发生异常', '2019-08-25 20:26:49');
INSERT INTO `access_log` VALUES (71298, '64.83.15667360125994247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:26:53', 2, 0, '', '2019-08-25 20:26:53');
INSERT INTO `access_log` VALUES (71299, '64.82.15667360127294263', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:26:53', 3, 0, '', '2019-08-25 20:26:53');
INSERT INTO `access_log` VALUES (71300, '64.85.15667360145734277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:26:55', 2, 0, '', '2019-08-25 20:26:55');
INSERT INTO `access_log` VALUES (71301, '64.76.15667360153204255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:26:55', 2, 0, '', '2019-08-25 20:26:55');
INSERT INTO `access_log` VALUES (71302, '64.80.15667360199454251', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:27:00', 2, 0, '', '2019-08-25 20:27:00');
INSERT INTO `access_log` VALUES (71303, '64.77.15667360200594233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:27:00', 2, 0, '', '2019-08-25 20:27:00');
INSERT INTO `access_log` VALUES (71304, '65.47.15667360462947063', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:27:26', 69, 0, '', '2019-08-25 20:27:26');
INSERT INTO `access_log` VALUES (71305, '65.54.15667360468187009', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:27:27', 11, 0, '', '2019-08-25 20:27:27');
INSERT INTO `access_log` VALUES (71306, '65.3607.15667360468468927', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:27:27', 10, 0, '', '2019-08-25 20:27:27');
INSERT INTO `access_log` VALUES (71307, '65.53.15667360468737067', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:27:27', 20, 0, '', '2019-08-25 20:27:27');
INSERT INTO `access_log` VALUES (71308, '62.86.15667360493572521', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:27:29', 31, 0, '', '2019-08-25 20:27:29');
INSERT INTO `access_log` VALUES (71309, '66.57.15667360519151349', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:27:32', 34, 0, '', '2019-08-25 20:27:32');
INSERT INTO `access_log` VALUES (71310, '59.74.15667360540053875', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:27:34', 14, 0, '', '2019-08-25 20:27:34');
INSERT INTO `access_log` VALUES (71311, '62.80.15667360691952541', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:27:49', 16, 0, '', '2019-08-25 20:27:49');
INSERT INTO `access_log` VALUES (71312, '64.83.15667360720424249', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:27:52', 13, 0, '', '2019-08-25 20:27:52');
INSERT INTO `access_log` VALUES (71313, '64.82.15667360720474265', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:27:52', 19, 0, '', '2019-08-25 20:27:52');
INSERT INTO `access_log` VALUES (71314, '64.76.15667360773354257', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:27:57', 11, 0, '', '2019-08-25 20:27:57');
INSERT INTO `access_log` VALUES (71315, '64.85.15667360773324279', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:27:57', 16, 0, '', '2019-08-25 20:27:57');
INSERT INTO `access_log` VALUES (71316, '64.80.15667360826134253', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:28:03', 13, 0, '', '2019-08-25 20:28:03');
INSERT INTO `access_log` VALUES (71317, '59.72.15667360923533861', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-25 20:28:12', 25, 2001001000, '服务端发生异常', '2019-08-25 20:28:12');
INSERT INTO `access_log` VALUES (71318, '59.80.15667385298163865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:08:50', 10, 0, '', '2019-08-25 21:08:50');
INSERT INTO `access_log` VALUES (71319, '59.76.15667385298193885', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:08:50', 33, 2001001000, '服务端发生异常', '2019-08-25 21:08:50');
INSERT INTO `access_log` VALUES (71320, '64.78.15667385325954301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:08:53', 12, 0, '', '2019-08-25 21:08:53');
INSERT INTO `access_log` VALUES (71321, '64.82.15667385328194299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:08:53', 3, 0, '', '2019-08-25 21:08:53');
INSERT INTO `access_log` VALUES (71322, '64.83.15667385342644283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:08:54', 2, 0, '', '2019-08-25 21:08:54');
INSERT INTO `access_log` VALUES (71323, '64.76.15667385349974291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:08:55', 2, 0, '', '2019-08-25 21:08:55');
INSERT INTO `access_log` VALUES (71324, '59.78.15667385359393905', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:08:56', 3, 0, '', '2019-08-25 21:08:56');
INSERT INTO `access_log` VALUES (71325, '59.74.15667385359423909', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:08:56', 14, 2001001000, '服务端发生异常', '2019-08-25 21:08:56');
INSERT INTO `access_log` VALUES (71326, '64.85.15667385376994313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:08:58', 2, 0, '', '2019-08-25 21:08:58');
INSERT INTO `access_log` VALUES (71327, '64.80.15667385378944287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:08:58', 2, 0, '', '2019-08-25 21:08:58');
INSERT INTO `access_log` VALUES (71328, '64.77.15667385390664269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:08:59', 3, 0, '', '2019-08-25 21:08:59');
INSERT INTO `access_log` VALUES (71329, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:08:59', 6, 0, '', '2019-08-25 21:08:59');
INSERT INTO `access_log` VALUES (71330, '64.81.15667385411914289', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:09:01', 8, 0, '', '2019-08-25 21:09:01');
INSERT INTO `access_log` VALUES (71331, '64.79.15667385471294283', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:09:07', 6, 0, '', '2019-08-25 21:09:07');
INSERT INTO `access_log` VALUES (71332, '64.78.15667385478354303', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:09:08', 2, 0, '', '2019-08-25 21:09:08');
INSERT INTO `access_log` VALUES (71333, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:09:08', 6, 0, '', '2019-08-25 21:09:08');
INSERT INTO `access_log` VALUES (71334, '64.82.15667385484564301', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:09:08', 2, 0, '', '2019-08-25 21:09:08');
INSERT INTO `access_log` VALUES (71335, '64.83.15667385486954285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:09:09', 1, 0, '', '2019-08-25 21:09:09');
INSERT INTO `access_log` VALUES (71336, '59.79.15667385493013895', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:09:09', 2, 0, '', '2019-08-25 21:09:09');
INSERT INTO `access_log` VALUES (71337, '59.72.15667385493043895', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'xiaomiquan/4.5.1 Android/Phone/8.1.0 OPPO_PAAM00', '36.102.228.100', '2019-08-25 21:09:09', 10, 2001001000, '服务端发生异常', '2019-08-25 21:09:09');
INSERT INTO `access_log` VALUES (71338, '65.47.15667462334407199', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.157.187.80', '2019-08-25 23:17:13', 1, 1002001015, '账号未登陆', '2019-08-25 23:17:13');
INSERT INTO `access_log` VALUES (71339, '59.72.15667484323224027', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:53:52', 10, 0, '', '2019-08-25 23:53:52');
INSERT INTO `access_log` VALUES (71340, '59.73.15667484324734027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:53:52', 15, 2001001000, '服务端发生异常', '2019-08-25 23:53:52');
INSERT INTO `access_log` VALUES (71341, '64.83.15667484402114417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:00', 9, 0, '', '2019-08-25 23:54:00');
INSERT INTO `access_log` VALUES (71342, '64.76.15667484404984425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:00', 2, 0, '', '2019-08-25 23:54:01');
INSERT INTO `access_log` VALUES (71343, '64.80.15667484478974421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:08', 2, 0, '', '2019-08-25 23:54:08');
INSERT INTO `access_log` VALUES (71344, '64.77.15667484480844403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:08', 2, 0, '', '2019-08-25 23:54:08');
INSERT INTO `access_log` VALUES (71345, '59.75.15667484556174033', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:16', 2, 0, '', '2019-08-25 23:54:16');
INSERT INTO `access_log` VALUES (71346, '59.80.15667484556733999', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:16', 12, 2001001000, '服务端发生异常', '2019-08-25 23:54:16');
INSERT INTO `access_log` VALUES (71347, '64.81.15667484577394423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:18', 2, 0, '', '2019-08-25 23:54:18');
INSERT INTO `access_log` VALUES (71348, '64.84.15667484579744417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:18', 2, 0, '', '2019-08-25 23:54:18');
INSERT INTO `access_log` VALUES (71349, '64.79.15667484592814417', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:19', 2, 0, '', '2019-08-25 23:54:19');
INSERT INTO `access_log` VALUES (71350, '64.78.15667484601124437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:20', 2, 0, '', '2019-08-25 23:54:20');
INSERT INTO `access_log` VALUES (71351, '59.74.15667484622814043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:22', 2, 0, '', '2019-08-25 23:54:22');
INSERT INTO `access_log` VALUES (71352, '59.78.15667484622974039', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:22', 20, 2001001000, '服务端发生异常', '2019-08-25 23:54:22');
INSERT INTO `access_log` VALUES (71353, '64.83.15667484654964419', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:25', 2, 0, '', '2019-08-25 23:54:25');
INSERT INTO `access_log` VALUES (71354, '64.76.15667484657274427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:26', 2, 0, '', '2019-08-25 23:54:26');
INSERT INTO `access_log` VALUES (71355, '59.79.15667484666644029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:27', 2, 0, '', '2019-08-25 23:54:27');
INSERT INTO `access_log` VALUES (71356, '59.71.15667484666614027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:27', 13, 2001001000, '服务端发生异常', '2019-08-25 23:54:27');
INSERT INTO `access_log` VALUES (71357, '64.85.15667484671174449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:27', 2, 0, '', '2019-08-25 23:54:27');
INSERT INTO `access_log` VALUES (71358, '64.80.15667484673544423', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:27', 2, 0, '', '2019-08-25 23:54:27');
INSERT INTO `access_log` VALUES (71359, '59.73.15667484678894029', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:28', 3, 0, '', '2019-08-25 23:54:28');
INSERT INTO `access_log` VALUES (71360, '59.72.15667484678864029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:28', 12, 2001001000, '服务端发生异常', '2019-08-25 23:54:28');
INSERT INTO `access_log` VALUES (71361, '65.53.15667484751517235', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:35', 0, 1002001015, '账号未登陆', '2019-08-25 23:54:35');
INSERT INTO `access_log` VALUES (71362, '65.3607.15667484751519093', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:35', 1, 1002001015, '账号未登陆', '2019-08-25 23:54:35');
INSERT INTO `access_log` VALUES (71363, '65.54.15667484751517179', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:35', 1, 1002001015, '账号未登陆', '2019-08-25 23:54:35');
INSERT INTO `access_log` VALUES (71364, '65.46.15667484777757309', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-25 23:54:38');
INSERT INTO `access_log` VALUES (71365, '65.50.15667484963917285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:56', 72, 0, '', '2019-08-25 23:54:56');
INSERT INTO `access_log` VALUES (71366, '65.51.15667484968327347', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:57', 11, 0, '', '2019-08-25 23:54:57');
INSERT INTO `access_log` VALUES (71367, '65.49.15667484968397297', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:57', 10, 2001001000, '服务端发生异常', '2019-08-25 23:54:57');
INSERT INTO `access_log` VALUES (71368, '65.47.15667484968427231', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0.0; zh-CN; MIX 2 Build/OPR1.170623.027) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '106.122.211.237', '2019-08-25 23:54:57', 9, 0, '', '2019-08-25 23:54:57');
INSERT INTO `access_log` VALUES (71369, '65.53.15667753396767595', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.202.232.205', '2019-08-26 07:22:20', 25, 1002001012, '访问令牌已过期', '2019-08-26 07:22:20');
INSERT INTO `access_log` VALUES (71370, '65.3607.15667753396759451', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.202.232.205', '2019-08-26 07:22:20', 27, 1002001012, '访问令牌已过期', '2019-08-26 07:22:20');
INSERT INTO `access_log` VALUES (71371, '65.54.15667753396757539', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.202.232.205', '2019-08-26 07:22:20', 22, 1002001012, '访问令牌已过期', '2019-08-26 07:22:20');
INSERT INTO `access_log` VALUES (71372, '65.46.15667753429007669', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.202.232.205', '2019-08-26 07:22:23', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 07:22:23');
INSERT INTO `access_log` VALUES (71373, '65.45.15667753537597675', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.202.232.205', '2019-08-26 07:22:34', 143, 0, '', '2019-08-26 07:22:34');
INSERT INTO `access_log` VALUES (71374, '65.50.15667753541987645', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.202.232.205', '2019-08-26 07:22:34', 14, 0, '', '2019-08-26 07:22:34');
INSERT INTO `access_log` VALUES (71375, '65.51.15667753542047707', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.202.232.205', '2019-08-26 07:22:34', 11, 2001001000, '服务端发生异常', '2019-08-26 07:22:34');
INSERT INTO `access_log` VALUES (71376, '65.47.15667753542097591', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.202.232.205', '2019-08-26 07:22:34', 12, 0, '', '2019-08-26 07:22:34');
INSERT INTO `access_log` VALUES (71377, '65.54.15667776441197571', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-26 08:00:44', 0, 1002001015, '账号未登陆', '2019-08-26 08:00:44');
INSERT INTO `access_log` VALUES (71378, '65.52.15667776441217723', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-26 08:00:44', 0, 1002001015, '账号未登陆', '2019-08-26 08:00:44');
INSERT INTO `access_log` VALUES (71379, '65.46.15667776441217701', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-26 08:00:44', 0, 1002001015, '账号未登陆', '2019-08-26 08:00:44');
INSERT INTO `access_log` VALUES (71380, '65.47.15667776609547623', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-26 08:01:01', 77, 0, '', '2019-08-26 08:01:01');
INSERT INTO `access_log` VALUES (71381, '65.51.15667776613247739', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-26 08:01:01', 15, 0, '', '2019-08-26 08:01:01');
INSERT INTO `access_log` VALUES (71382, '65.50.15667776613277677', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-26 08:01:01', 12, 2001001000, '服务端发生异常', '2019-08-26 08:01:01');
INSERT INTO `access_log` VALUES (71383, '65.49.15667776613317689', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-26 08:01:01', 10, 0, '', '2019-08-26 08:01:01');
INSERT INTO `access_log` VALUES (71384, '65.54.15667776711197573', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-26 08:01:11', 10, 0, '', '2019-08-26 08:01:11');
INSERT INTO `access_log` VALUES (71385, '65.3607.15667776711199485', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-26 08:01:11', 11, 2001001000, '服务端发生异常', '2019-08-26 08:01:11');
INSERT INTO `access_log` VALUES (71386, '65.46.15667776711217703', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-26 08:01:11', 10, 0, '', '2019-08-26 08:01:11');
INSERT INTO `access_log` VALUES (71387, '65.45.15667776861527709', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-26 08:01:26', 8, 0, '', '2019-08-26 08:01:26');
INSERT INTO `access_log` VALUES (71388, '65.50.15667776861547679', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-26 08:01:26', 8, 0, '', '2019-08-26 08:01:26');
INSERT INTO `access_log` VALUES (71389, '65.47.15667776861527625', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-26 08:01:26', 11, 2001001000, '服务端发生异常', '2019-08-26 08:01:26');
INSERT INTO `access_log` VALUES (71390, '9e4f1de6-e23c-4838-9f18-1345debbc052', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 09:39:35', 414, 0, '', '2019-08-26 09:39:35');
INSERT INTO `access_log` VALUES (71391, '51778b38-3b67-468b-abbd-e3b5905c1ce0', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 09:39:36', 162, 0, '', '2019-08-26 09:39:36');
INSERT INTO `access_log` VALUES (71392, 'b15a6324-ddb2-448a-849b-d145f43051eb', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 09:39:36', 158, 0, '', '2019-08-26 09:39:36');
INSERT INTO `access_log` VALUES (71393, '1c2f4252-505f-4785-8de3-44792facb73a', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 09:39:36', 95, 0, '', '2019-08-26 09:39:36');
INSERT INTO `access_log` VALUES (71394, 'f590c546-5845-4a4c-b2eb-40f9a60dafb0', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 09:58:43', 93, 0, '', '2019-08-26 09:58:44');
INSERT INTO `access_log` VALUES (71395, 'd1cbdd1b-da81-43c5-aa05-405e407aec70', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 09:58:51', 56, 0, '', '2019-08-26 09:58:51');
INSERT INTO `access_log` VALUES (71396, 'aa9be22b-4719-4ce5-9fd8-280f4ba32d7f', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=1&total=0&size=100', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 09:58:52', 40, 0, '', '2019-08-26 09:58:52');
INSERT INTO `access_log` VALUES (71397, 'b2373b9f-4e34-43c5-96ab-2cc1e133109b', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 09:59:20', 46, 0, '', '2019-08-26 09:59:20');
INSERT INTO `access_log` VALUES (71398, '24f35770-0545-4745-9596-7e5c5f7f2839', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 09:59:20', 128, 0, '', '2019-08-26 09:59:20');
INSERT INTO `access_log` VALUES (71399, 'e0373ac8-608b-4a9c-b2d4-d7820d6d7b4a', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 09:59:26', 80, 0, '', '2019-08-26 09:59:26');
INSERT INTO `access_log` VALUES (71400, '619a5c40-4237-4b9a-b956-c80337dfce47', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 09:59:28', 43, 0, '', '2019-08-26 09:59:28');
INSERT INTO `access_log` VALUES (71401, 'd4b063ea-14c4-4e35-9792-6709d29f693d', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 09:59:43', 55, 0, '', '2019-08-26 09:59:43');
INSERT INTO `access_log` VALUES (71402, '59.78.15667848351394525', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; BLA-AL00 Build/HUAWEIBLA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/1201 MicroMessenger/7.0.6.1460(0x2700066A) Process/tools NetType/4G Language/zh_CN', '223.104.3.61', '2019-08-26 10:00:35', 11, 0, '', '2019-08-26 10:00:35');
INSERT INTO `access_log` VALUES (71403, '59.79.15667848351464515', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; BLA-AL00 Build/HUAWEIBLA-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/1201 MicroMessenger/7.0.6.1460(0x2700066A) Process/tools NetType/4G Language/zh_CN', '223.104.3.61', '2019-08-26 10:00:35', 31, 2001001000, '服务端发生异常', '2019-08-26 10:00:35');
INSERT INTO `access_log` VALUES (71404, '59.75.15667849022744521', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:01:42', 4, 0, '', '2019-08-26 10:01:42');
INSERT INTO `access_log` VALUES (71405, '59.80.15667849022784487', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:01:42', 23, 2001001000, '服务端发生异常', '2019-08-26 10:01:42');
INSERT INTO `access_log` VALUES (71406, '65.49.15667849126727787', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:01:53', 0, 1002001015, '账号未登陆', '2019-08-26 10:01:53');
INSERT INTO `access_log` VALUES (71407, '65.53.15667849127157727', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:01:53', 0, 1002001015, '账号未登陆', '2019-08-26 10:01:53');
INSERT INTO `access_log` VALUES (71408, '65.3607.15667849127459583', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:01:53', 0, 1002001015, '账号未登陆', '2019-08-26 10:01:53');
INSERT INTO `access_log` VALUES (71409, '65.46.15667849158287801', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:01:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 10:01:56');
INSERT INTO `access_log` VALUES (71410, '65.52.15667849270507823', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:02:07', 94, 0, '', '2019-08-26 10:02:07');
INSERT INTO `access_log` VALUES (71411, '65.45.15667849276217807', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:02:08', 13, 0, '', '2019-08-26 10:02:08');
INSERT INTO `access_log` VALUES (71412, '65.47.15667849276187723', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:02:08', 16, 0, '', '2019-08-26 10:02:08');
INSERT INTO `access_log` VALUES (71413, '65.50.15667849276207777', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:02:08', 17, 2001001000, '服务端发生异常', '2019-08-26 10:02:08');
INSERT INTO `access_log` VALUES (71414, '59.72.15667849712944517', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.66.224.50', '2019-08-26 10:02:51', 3, 0, '', '2019-08-26 10:02:51');
INSERT INTO `access_log` VALUES (71415, '59.73.15667849712954519', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.66.224.50', '2019-08-26 10:02:51', 25, 2001001000, '服务端发生异常', '2019-08-26 10:02:51');
INSERT INTO `access_log` VALUES (71416, '65.46.15667849980007803', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.66.224.50', '2019-08-26 10:03:18', 1, 1002001015, '账号未登陆', '2019-08-26 10:03:18');
INSERT INTO `access_log` VALUES (71417, '65.52.15667849980057825', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.66.224.50', '2019-08-26 10:03:18', 1, 1002001015, '账号未登陆', '2019-08-26 10:03:18');
INSERT INTO `access_log` VALUES (71418, '65.47.15667849980077725', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.66.224.50', '2019-08-26 10:03:18', 0, 1002001015, '账号未登陆', '2019-08-26 10:03:18');
INSERT INTO `access_log` VALUES (71419, '65.50.15667850017717779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.66.224.50', '2019-08-26 10:03:22', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 10:03:22');
INSERT INTO `access_log` VALUES (71420, '65.46.15667850888117805', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:04:49', 4, 1002001012, '访问令牌已过期', '2019-08-26 10:04:49');
INSERT INTO `access_log` VALUES (71421, '65.47.15667850888197727', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:04:49', 4, 1002001012, '访问令牌已过期', '2019-08-26 10:04:49');
INSERT INTO `access_log` VALUES (71422, '65.52.15667850888257827', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:04:49', 3, 1002001012, '访问令牌已过期', '2019-08-26 10:04:49');
INSERT INTO `access_log` VALUES (71423, '65.50.15667850908477781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:04:51', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 10:04:51');
INSERT INTO `access_log` VALUES (71424, '65.51.15667850946867843', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:04:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 10:04:55');
INSERT INTO `access_log` VALUES (71425, '65.49.15667851074887793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:05:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 10:05:07');
INSERT INTO `access_log` VALUES (71426, '65.3607.15667851185269589', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:05:19', 77, 0, '', '2019-08-26 10:05:19');
INSERT INTO `access_log` VALUES (71427, '65.54.15667851189047677', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:05:19', 19, 0, '', '2019-08-26 10:05:19');
INSERT INTO `access_log` VALUES (71428, '65.46.15667851189057807', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:05:19', 17, 0, '', '2019-08-26 10:05:19');
INSERT INTO `access_log` VALUES (71429, '65.52.15667851189067829', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:05:19', 18, 2001001000, '服务端发生异常', '2019-08-26 10:05:19');
INSERT INTO `access_log` VALUES (71430, '65.45.15667851356437813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:05:36', 9, 0, '', '2019-08-26 10:05:36');
INSERT INTO `access_log` VALUES (71431, '65.50.15667851356427783', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:05:36', 10, 2001001000, '服务端发生异常', '2019-08-26 10:05:36');
INSERT INTO `access_log` VALUES (71432, '65.51.15667851356497845', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:05:36', 8, 0, '', '2019-08-26 10:05:36');
INSERT INTO `access_log` VALUES (71433, '65.51.15667852353807847', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.184.235.219', '2019-08-26 10:07:15', 1, 1002001015, '账号未登陆', '2019-08-26 10:07:15');
INSERT INTO `access_log` VALUES (71434, '65.50.15667852353837785', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.184.235.219', '2019-08-26 10:07:15', 0, 1002001015, '账号未登陆', '2019-08-26 10:07:15');
INSERT INTO `access_log` VALUES (71435, '65.45.15667852353927815', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.184.235.219', '2019-08-26 10:07:15', 0, 1002001015, '账号未登陆', '2019-08-26 10:07:15');
INSERT INTO `access_log` VALUES (71436, '65.49.15667852384957797', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.184.235.219', '2019-08-26 10:07:18', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 10:07:19');
INSERT INTO `access_log` VALUES (71437, '65.3607.15667852569119593', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.184.235.219', '2019-08-26 10:07:37', 100, 0, '', '2019-08-26 10:07:37');
INSERT INTO `access_log` VALUES (71438, '65.52.15667852574047833', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.184.235.219', '2019-08-26 10:07:37', 9, 0, '', '2019-08-26 10:07:37');
INSERT INTO `access_log` VALUES (71439, '65.54.15667852574157681', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.184.235.219', '2019-08-26 10:07:37', 8, 0, '', '2019-08-26 10:07:37');
INSERT INTO `access_log` VALUES (71440, '65.46.15667852574157811', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '220.184.235.219', '2019-08-26 10:07:37', 10, 2001001000, '服务端发生异常', '2019-08-26 10:07:37');
INSERT INTO `access_log` VALUES (71441, '59.77.15667852723074509', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-26 10:07:52', 4, 0, '', '2019-08-26 10:07:52');
INSERT INTO `access_log` VALUES (71442, '59.75.15667852723134527', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-26 10:07:52', 16, 2001001000, '服务端发生异常', '2019-08-26 10:07:52');
INSERT INTO `access_log` VALUES (71443, '59.80.15667852773134493', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-26 10:07:57', 2, 0, '', '2019-08-26 10:07:57');
INSERT INTO `access_log` VALUES (71444, '59.76.15667852773144511', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.5.241.6', '2019-08-26 10:07:57', 12, 2001001000, '服务端发生异常', '2019-08-26 10:07:57');
INSERT INTO `access_log` VALUES (71445, '59.79.15667857432664529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:15:43', 3, 0, '', '2019-08-26 10:15:43');
INSERT INTO `access_log` VALUES (71446, '59.78.15667857432694539', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:15:43', 15, 2001001000, '服务端发生异常', '2019-08-26 10:15:43');
INSERT INTO `access_log` VALUES (71447, '64.82.15667857491244933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:15:49', 12, 0, '', '2019-08-26 10:15:49');
INSERT INTO `access_log` VALUES (71448, '64.83.15667857493194917', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:15:49', 3, 0, '', '2019-08-26 10:15:49');
INSERT INTO `access_log` VALUES (71449, '59.72.15667857510494529', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:15:51', 2, 0, '', '2019-08-26 10:15:51');
INSERT INTO `access_log` VALUES (71450, '59.73.15667857511074531', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:15:51', 12, 2001001000, '服务端发生异常', '2019-08-26 10:15:51');
INSERT INTO `access_log` VALUES (71451, '64.85.15667857538074947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:15:54', 2, 0, '', '2019-08-26 10:15:54');
INSERT INTO `access_log` VALUES (71452, '64.80.15667857539764921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:15:54', 2, 0, '', '2019-08-26 10:15:54');
INSERT INTO `access_log` VALUES (71453, '64.77.15667857555474903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:15:56', 2, 0, '', '2019-08-26 10:15:56');
INSERT INTO `access_log` VALUES (71454, '64.81.15667857559684923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:15:56', 3, 0, '', '2019-08-26 10:15:56');
INSERT INTO `access_log` VALUES (71455, '59.75.15667857573244535', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:15:57', 2, 0, '', '2019-08-26 10:15:57');
INSERT INTO `access_log` VALUES (71456, '59.77.15667857573204517', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.61', '2019-08-26 10:15:57', 24, 2001001000, '服务端发生异常', '2019-08-26 10:15:57');
INSERT INTO `access_log` VALUES (71457, '65.50.15667860289717799', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-26 10:20:29', 0, 1002001015, '账号未登陆', '2019-08-26 10:20:29');
INSERT INTO `access_log` VALUES (71458, '65.51.15667860289767859', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-26 10:20:29', 1, 1002001015, '账号未登陆', '2019-08-26 10:20:29');
INSERT INTO `access_log` VALUES (71459, '65.49.15667860289807809', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-26 10:20:29', 0, 1002001015, '账号未登陆', '2019-08-26 10:20:29');
INSERT INTO `access_log` VALUES (71460, '65.53.15667860352577749', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-26 10:20:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 10:20:35');
INSERT INTO `access_log` VALUES (71461, '59.77.15667860374274521', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.87.208.185', '2019-08-26 10:20:37', 3, 0, '', '2019-08-26 10:20:37');
INSERT INTO `access_log` VALUES (71462, '59.76.15667860375174523', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.87.208.185', '2019-08-26 10:20:38', 11, 2001001000, '服务端发生异常', '2019-08-26 10:20:38');
INSERT INTO `access_log` VALUES (71463, '65.3607.15667860375699607', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-26 10:20:38', 94, 0, '', '2019-08-26 10:20:38');
INSERT INTO `access_log` VALUES (71464, '65.54.15667860380087695', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-26 10:20:38', 10, 0, '', '2019-08-26 10:20:38');
INSERT INTO `access_log` VALUES (71465, '65.46.15667860380117825', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-26 10:20:38', 8, 0, '', '2019-08-26 10:20:38');
INSERT INTO `access_log` VALUES (71466, '65.47.15667860380437745', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-26 10:20:38', 8, 0, '', '2019-08-26 10:20:38');
INSERT INTO `access_log` VALUES (71467, '64.81.15667860450324927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.87.208.185', '2019-08-26 10:20:45', 2, 0, '', '2019-08-26 10:20:45');
INSERT INTO `access_log` VALUES (71468, '64.84.15667860451574921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.87.208.185', '2019-08-26 10:20:45', 2, 0, '', '2019-08-26 10:20:45');
INSERT INTO `access_log` VALUES (71469, '62.84.15667860467693173', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-26 10:20:47', 33, 0, '', '2019-08-26 10:20:47');
INSERT INTO `access_log` VALUES (71470, '64.79.15667860475674921', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.87.208.185', '2019-08-26 10:20:48', 1, 0, '', '2019-08-26 10:20:48');
INSERT INTO `access_log` VALUES (71471, '64.78.15667860483114941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.87.208.185', '2019-08-26 10:20:48', 1, 0, '', '2019-08-26 10:20:48');
INSERT INTO `access_log` VALUES (71472, '64.83.15667860525064923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.87.208.185', '2019-08-26 10:20:53', 2, 0, '', '2019-08-26 10:20:53');
INSERT INTO `access_log` VALUES (71473, '64.76.15667860528354931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.87.208.185', '2019-08-26 10:20:53', 2, 0, '', '2019-08-26 10:20:53');
INSERT INTO `access_log` VALUES (71474, '62.87.15667860531453185', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-26 10:20:53', 24, 0, '', '2019-08-26 10:20:53');
INSERT INTO `access_log` VALUES (71475, '59.79.15667860597604535', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.87.208.185', '2019-08-26 10:21:00', 2, 0, '', '2019-08-26 10:21:00');
INSERT INTO `access_log` VALUES (71476, '59.74.15667860597574547', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.87.208.185', '2019-08-26 10:21:00', 14, 2001001000, '服务端发生异常', '2019-08-26 10:21:00');
INSERT INTO `access_log` VALUES (71477, '62.81.15667860621483161', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-26 10:21:02', 15, 0, '', '2019-08-26 10:21:02');
INSERT INTO `access_log` VALUES (71478, '59.71.15667860689434533', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-26 10:21:09', 2, 0, '', '2019-08-26 10:21:09');
INSERT INTO `access_log` VALUES (71479, '59.72.15667860689464535', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '36.110.58.27', '2019-08-26 10:21:09', 17, 2001001000, '服务端发生异常', '2019-08-26 10:21:09');
INSERT INTO `access_log` VALUES (71480, '64.80.15667860734484927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.87.208.185', '2019-08-26 10:21:13', 2, 0, '', '2019-08-26 10:21:13');
INSERT INTO `access_log` VALUES (71481, '64.77.15667860735524909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.87.208.185', '2019-08-26 10:21:14', 2, 0, '', '2019-08-26 10:21:14');
INSERT INTO `access_log` VALUES (71482, '59.73.15667860743024537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.87.208.185', '2019-08-26 10:21:14', 2, 0, '', '2019-08-26 10:21:14');
INSERT INTO `access_log` VALUES (71483, '59.75.15667860743064541', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.87.208.185', '2019-08-26 10:21:14', 12, 2001001000, '服务端发生异常', '2019-08-26 10:21:14');
INSERT INTO `access_log` VALUES (71484, '4e2ebb09-8b02-480a-8b04-5050f098eea9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 10:22:57', 44, 0, '', '2019-08-26 10:22:57');
INSERT INTO `access_log` VALUES (71485, 'c38c7cde-64be-4f16-8867-d4538c1551e9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 10:22:57', 50, 0, '', '2019-08-26 10:22:57');
INSERT INTO `access_log` VALUES (71486, 'c4518ca8-fbb7-4f78-95ed-c735131732dd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 10:22:57', 49, 0, '', '2019-08-26 10:22:57');
INSERT INTO `access_log` VALUES (71487, 'abed8ff3-5fbc-445f-a65e-8d6a894d10bf', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 10:23:15', 179, 0, '', '2019-08-26 10:23:15');
INSERT INTO `access_log` VALUES (71488, 'a9c2c94a-9df9-4114-a89e-baa125518044', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-26 10:23:15', 304, 0, '', '2019-08-26 10:23:15');
INSERT INTO `access_log` VALUES (71489, '72e2159d-2e89-4a3c-a30d-406d1893283b', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:23:41', 67, 0, '', '2019-08-26 10:23:42');
INSERT INTO `access_log` VALUES (71490, '06043d7e-4276-4dd4-92fe-351d64247b74', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:23:42', 13, 0, '', '2019-08-26 10:23:42');
INSERT INTO `access_log` VALUES (71491, '745acdaf-2ec1-4de0-8e01-24175001e355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:23:44', 15, 0, '', '2019-08-26 10:23:44');
INSERT INTO `access_log` VALUES (71492, '18adb410-3c93-4cb5-8cec-8f0bcbe49820', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:23:45', 17, 0, '', '2019-08-26 10:23:45');
INSERT INTO `access_log` VALUES (71493, '53d6a2da-d397-46bb-9f35-0e0cd064fe97', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:23:46', 14, 0, '', '2019-08-26 10:23:46');
INSERT INTO `access_log` VALUES (71494, 'd2d46d92-5a28-43e4-ba63-4dbe5ee35d2d', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:23:47', 16, 0, '', '2019-08-26 10:23:47');
INSERT INTO `access_log` VALUES (71495, 'c6e4c127-4f80-4077-833c-490d14a6978b', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:23:47', 595, 2001001000, '服务端发生异常', '2019-08-26 10:23:48');
INSERT INTO `access_log` VALUES (71496, '2b8ed877-4f34-4ae3-b9bb-6a2d56d58d83', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:23:50', 14, 0, '', '2019-08-26 10:23:50');
INSERT INTO `access_log` VALUES (71497, '4a0f03d4-0a5b-4425-aa59-0cf779f70620', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:23:51', 17, 0, '', '2019-08-26 10:23:51');
INSERT INTO `access_log` VALUES (71498, '6d94dc79-07de-47e6-9c16-b3e662825ffb', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17602176290&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:03', 7354, 1001003000, '验证码不存在', '2019-08-26 10:24:10');
INSERT INTO `access_log` VALUES (71499, '75da44bc-b09e-4926-abac-09f2203e9fca', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17602176290&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:22', 34, 1001003000, '验证码不存在', '2019-08-26 10:24:22');
INSERT INTO `access_log` VALUES (71500, '933fcb57-9037-4fff-aad5-889be2cae44a', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17602176290', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:25', 165, 0, '', '2019-08-26 10:24:25');
INSERT INTO `access_log` VALUES (71501, '9d1fcd00-1914-4b67-8445-9263fa0c05e0', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17602176290&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:28', 408, 0, '', '2019-08-26 10:24:28');
INSERT INTO `access_log` VALUES (71502, '566a710b-f1cc-4979-bea5-dafa4391332a', 212, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:30', 240, 0, '', '2019-08-26 10:24:30');
INSERT INTO `access_log` VALUES (71503, '2c836ec6-53d2-4741-bffb-2e60d0978157', 212, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:33', 47, 0, '', '2019-08-26 10:24:33');
INSERT INTO `access_log` VALUES (71504, '324356b1-2fa5-4902-9f40-ce29b6c94c5b', 212, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:34', 40, 0, '', '2019-08-26 10:24:34');
INSERT INTO `access_log` VALUES (71505, '811c654a-6dea-4ec8-8acb-220afde7a13a', 212, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:35', 36, 0, '', '2019-08-26 10:24:35');
INSERT INTO `access_log` VALUES (71506, 'f2088663-729b-438d-a283-ed3b8d680aec', 212, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:37', 151, 0, '', '2019-08-26 10:24:37');
INSERT INTO `access_log` VALUES (71507, '3bab1086-2652-44aa-8ebd-39f3867ff459', 212, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:38', 22, 0, '', '2019-08-26 10:24:38');
INSERT INTO `access_log` VALUES (71508, '52bbe3ef-6a94-4283-b3b4-bfada22175aa', 212, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:40', 32, 0, '', '2019-08-26 10:24:40');
INSERT INTO `access_log` VALUES (71509, '0a47b2a1-c0f0-4267-a1b6-bada0b3d631d', 212, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:41', 24, 0, '', '2019-08-26 10:24:41');
INSERT INTO `access_log` VALUES (71510, 'f4a67b40-1740-454b-a3f1-51e021569f18', 212, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:41', 42, 0, '', '2019-08-26 10:24:41');
INSERT INTO `access_log` VALUES (71511, 'ac90e38a-d194-4220-8d40-24d601434dac', 212, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:42', 26, 0, '', '2019-08-26 10:24:42');
INSERT INTO `access_log` VALUES (71512, 'fb6369ee-0e28-4e69-a33e-aff6579e8724', 212, 1, 'order-impl', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:44', 41, 0, '', '2019-08-26 10:24:44');
INSERT INTO `access_log` VALUES (71513, 'fe53905c-c648-431f-b249-2f9fdc95eaaf', 212, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:45', 39, 0, '', '2019-08-26 10:24:45');
INSERT INTO `access_log` VALUES (71514, 'c427140e-0167-4c0d-ad53-8c332cb79e1d', 212, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:48', 109, 0, '', '2019-08-26 10:24:48');
INSERT INTO `access_log` VALUES (71515, '09129efd-2004-4e4e-91e6-fb2e49939269', 212, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:52', 39, 0, '', '2019-08-26 10:24:52');
INSERT INTO `access_log` VALUES (71516, 'ea8495c1-ef17-4ebd-9b1a-6a1bbff435f1', 212, 1, 'order-impl', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:24:56', 45, 0, '', '2019-08-26 10:24:56');
INSERT INTO `access_log` VALUES (71517, '88ac07bc-aa23-4f6e-bc8d-f0dfb1c3ad15', 212, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:00', 40, 0, '', '2019-08-26 10:25:00');
INSERT INTO `access_log` VALUES (71518, '9dc36d11-18f2-48f7-a20f-16252f84b2ad', 212, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:04', 61, 0, '', '2019-08-26 10:25:04');
INSERT INTO `access_log` VALUES (71519, '9eb75c87-366a-4e52-b8a8-472f2a3e4219', 212, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:04', 45, 0, '', '2019-08-26 10:25:04');
INSERT INTO `access_log` VALUES (71520, 'bb05edfe-ab74-48e4-b1c6-3d18fb71b4e4', 212, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:06', 49, 0, '', '2019-08-26 10:25:06');
INSERT INTO `access_log` VALUES (71521, '8c969f2b-b57f-4d73-8e16-f91bfba17e66', 212, 1, 'product-application', '/product-api/users/spu/info', 'id=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:06', 122, 0, '', '2019-08-26 10:25:06');
INSERT INTO `access_log` VALUES (71522, 'c682bdee-d2e3-4fc4-af44-2268838914b6', 212, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:06', 54, 0, '', '2019-08-26 10:25:06');
INSERT INTO `access_log` VALUES (71523, '134ad21e-0261-44b1-a787-a6e7dd76cefc', 212, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=40', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:06', 160, 0, '', '2019-08-26 10:25:06');
INSERT INTO `access_log` VALUES (71524, 'dc546da1-6f68-407c-a478-35676c9ff649', 212, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:14', 42, 0, '', '2019-08-26 10:25:14');
INSERT INTO `access_log` VALUES (71525, 'ed249ec1-b036-44f4-ba43-37b78654bb46', 212, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:14', 75, 0, '', '2019-08-26 10:25:14');
INSERT INTO `access_log` VALUES (71526, 'd8141092-cc34-4f92-b4cf-371b30753d78', 212, 1, 'order-impl', '/order-api/users/cart/count', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:18', 21, 0, '', '2019-08-26 10:25:18');
INSERT INTO `access_log` VALUES (71527, 'adda5dc0-3f32-4e57-b26c-53d80654c4e1', 212, 1, 'product-application', '/product-api/users/spu/info', 'id=41', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:18', 65, 0, '', '2019-08-26 10:25:18');
INSERT INTO `access_log` VALUES (71528, 'aedda3e0-667c-494d-a0b7-f1547c03e8e2', 212, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=41', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:18', 34, 0, '', '2019-08-26 10:25:18');
INSERT INTO `access_log` VALUES (71529, '82fef29d-8b34-4530-9730-03f2ba5f858d', 212, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=50', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:18', 59, 0, '', '2019-08-26 10:25:18');
INSERT INTO `access_log` VALUES (71530, '80cac446-704d-4bbd-be54-e0d500c37db3', 212, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:25', 76, 0, '', '2019-08-26 10:25:25');
INSERT INTO `access_log` VALUES (71531, '9e2cc8a3-24e5-4533-b689-850f36acac99', 212, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:25:25', 41, 0, '', '2019-08-26 10:25:25');
INSERT INTO `access_log` VALUES (71532, '3d7e00b4-2f54-4902-bab2-d8213b9aa2fb', 0, 1, 'promotion-application', '/promotion-api/users/coupon/template/get', 'id=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:26:05', 16, 0, '', '2019-08-26 10:26:05');
INSERT INTO `access_log` VALUES (71533, '1a713a18-e0a5-4b3d-99b2-f34646f33562', 0, 1, 'promotion-application', '/promotion-api/users/coupon/card/add', 'templateId=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:26:08', 480, 2001001000, '服务端发生异常', '2019-08-26 10:26:08');
INSERT INTO `access_log` VALUES (71534, '59.73.15667866425444545', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:30:43', 3, 0, '', '2019-08-26 10:30:43');
INSERT INTO `access_log` VALUES (71535, '59.75.15667866425484549', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:30:43', 13, 2001001000, '服务端发生异常', '2019-08-26 10:30:43');
INSERT INTO `access_log` VALUES (71536, '59.76.15667866484114533', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:30:48', 2, 0, '', '2019-08-26 10:30:48');
INSERT INTO `access_log` VALUES (71537, '59.77.15667866484104531', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:30:48', 21, 2001001000, '服务端发生异常', '2019-08-26 10:30:48');
INSERT INTO `access_log` VALUES (71538, '59.78.15667866861874555', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.76.251.164', '2019-08-26 10:31:26', 2, 0, '', '2019-08-26 10:31:26');
INSERT INTO `access_log` VALUES (71539, '59.71.15667866862754543', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.76.251.164', '2019-08-26 10:31:26', 13, 2001001000, '服务端发生异常', '2019-08-26 10:31:26');
INSERT INTO `access_log` VALUES (71540, '64.84.15667866912074931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.76.251.164', '2019-08-26 10:31:31', 8, 0, '', '2019-08-26 10:31:31');
INSERT INTO `access_log` VALUES (71541, '64.79.15667866913574931', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.76.251.164', '2019-08-26 10:31:31', 3, 0, '', '2019-08-26 10:31:31');
INSERT INTO `access_log` VALUES (71542, '64.78.15667866923144951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.76.251.164', '2019-08-26 10:31:32', 2, 0, '', '2019-08-26 10:31:32');
INSERT INTO `access_log` VALUES (71543, '64.82.15667866926964949', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.76.251.164', '2019-08-26 10:31:33', 2, 0, '', '2019-08-26 10:31:33');
INSERT INTO `access_log` VALUES (71544, '65.46.15667867053377835', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.76.251.164', '2019-08-26 10:31:45', 0, 1002001015, '账号未登陆', '2019-08-26 10:31:45');
INSERT INTO `access_log` VALUES (71545, '65.3607.15667867053379617', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.76.251.164', '2019-08-26 10:31:45', 0, 1002001015, '账号未登陆', '2019-08-26 10:31:45');
INSERT INTO `access_log` VALUES (71546, '65.53.15667867053377759', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.76.251.164', '2019-08-26 10:31:45', 0, 1002001015, '账号未登陆', '2019-08-26 10:31:45');
INSERT INTO `access_log` VALUES (71547, '65.54.15667867081597705', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.76.251.164', '2019-08-26 10:31:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 10:31:48');
INSERT INTO `access_log` VALUES (71548, '59.77.15667867114074533', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-08-26 10:31:51', 72, 0, '', '2019-08-26 10:31:51');
INSERT INTO `access_log` VALUES (71549, '59.80.15667867114154517', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '192.144.189.163', '2019-08-26 10:31:51', 106, 2001001000, '服务端发生异常', '2019-08-26 10:31:52');
INSERT INTO `access_log` VALUES (71550, '65.52.15667867168977857', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.76.251.164', '2019-08-26 10:31:57', 84, 0, '', '2019-08-26 10:31:57');
INSERT INTO `access_log` VALUES (71551, '65.45.15667867172237839', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.76.251.164', '2019-08-26 10:31:57', 9, 0, '', '2019-08-26 10:31:57');
INSERT INTO `access_log` VALUES (71552, '65.51.15667867172327871', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.76.251.164', '2019-08-26 10:31:57', 9, 0, '', '2019-08-26 10:31:57');
INSERT INTO `access_log` VALUES (71553, '65.49.15667867172317821', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '222.76.251.164', '2019-08-26 10:31:57', 9, 2001001000, '服务端发生异常', '2019-08-26 10:31:57');
INSERT INTO `access_log` VALUES (71554, '65.45.15667871570857847', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.236.217.161', '2019-08-26 10:39:17', 1, 1002001015, '账号未登陆', '2019-08-26 10:39:17');
INSERT INTO `access_log` VALUES (71555, '65.47.15667871570857763', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.236.217.161', '2019-08-26 10:39:17', 0, 1002001015, '账号未登陆', '2019-08-26 10:39:17');
INSERT INTO `access_log` VALUES (71556, '65.52.15667871570867865', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.236.217.161', '2019-08-26 10:39:17', 1, 1002001015, '账号未登陆', '2019-08-26 10:39:17');
INSERT INTO `access_log` VALUES (71557, '65.51.15667871723777879', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.236.217.161', '2019-08-26 10:39:32', 112, 0, '', '2019-08-26 10:39:32');
INSERT INTO `access_log` VALUES (71558, '65.46.15667871731597843', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.236.217.161', '2019-08-26 10:39:33', 10, 0, '', '2019-08-26 10:39:33');
INSERT INTO `access_log` VALUES (71559, '65.50.15667871731637819', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.236.217.161', '2019-08-26 10:39:33', 8, 0, '', '2019-08-26 10:39:33');
INSERT INTO `access_log` VALUES (71560, '65.3607.15667871731639627', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '116.236.217.161', '2019-08-26 10:39:33', 10, 2001001000, '服务端发生异常', '2019-08-26 10:39:33');
INSERT INTO `access_log` VALUES (71561, '64.83.15667881843264953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:56:24', 3, 0, '', '2019-08-26 10:56:24');
INSERT INTO `access_log` VALUES (71562, '64.76.15667881844864961', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:56:24', 2, 0, '', '2019-08-26 10:56:24');
INSERT INTO `access_log` VALUES (71563, '64.85.15667881907954983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:56:31', 2, 0, '', '2019-08-26 10:56:31');
INSERT INTO `access_log` VALUES (71564, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:56:31', 6, 0, '', '2019-08-26 10:56:31');
INSERT INTO `access_log` VALUES (71565, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:57:34', 5, 0, '', '2019-08-26 10:57:34');
INSERT INTO `access_log` VALUES (71566, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:57:35', 6, 0, '', '2019-08-26 10:57:35');
INSERT INTO `access_log` VALUES (71567, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '14.23.152.242', '2019-08-26 10:57:39', 5, 0, '', '2019-08-26 10:57:39');
INSERT INTO `access_log` VALUES (71568, '65.3607.15667889222759651', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.141.139.183', '2019-08-26 11:08:42', 0, 1002001015, '账号未登陆', '2019-08-26 11:08:42');
INSERT INTO `access_log` VALUES (71569, '65.46.15667889222757867', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.141.139.183', '2019-08-26 11:08:42', 0, 1002001015, '账号未登陆', '2019-08-26 11:08:42');
INSERT INTO `access_log` VALUES (71570, '65.50.15667889222787843', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.141.139.183', '2019-08-26 11:08:42', 1, 1002001015, '账号未登陆', '2019-08-26 11:08:42');
INSERT INTO `access_log` VALUES (71571, '65.54.15667889292067739', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.141.139.183', '2019-08-26 11:08:49', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 11:08:49');
INSERT INTO `access_log` VALUES (71572, '65.52.15667889392467891', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanman&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.141.139.183', '2019-08-26 11:08:59', 140, 0, '', '2019-08-26 11:08:59');
INSERT INTO `access_log` VALUES (71573, '65.45.15667889397417873', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.141.139.183', '2019-08-26 11:09:00', 10, 0, '', '2019-08-26 11:09:00');
INSERT INTO `access_log` VALUES (71574, '65.47.15667889397687789', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.141.139.183', '2019-08-26 11:09:00', 10, 2001001000, '服务端发生异常', '2019-08-26 11:09:00');
INSERT INTO `access_log` VALUES (71575, '65.49.15667889397697855', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.141.139.183', '2019-08-26 11:09:00', 9, 0, '', '2019-08-26 11:09:00');
INSERT INTO `access_log` VALUES (71576, '59.72.15667890327574577', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.141.139.183', '2019-08-26 11:10:33', 10, 0, '', '2019-08-26 11:10:33');
INSERT INTO `access_log` VALUES (71577, '59.73.15667890327574579', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.141.139.183', '2019-08-26 11:10:33', 17, 2001001000, '服务端发生异常', '2019-08-26 11:10:33');
INSERT INTO `access_log` VALUES (71578, '59.76.15667897879754577', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.12.118', '2019-08-26 11:23:08', 3, 0, '', '2019-08-26 11:23:08');
INSERT INTO `access_log` VALUES (71579, '59.77.15667897879754575', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '218.13.12.118', '2019-08-26 11:23:08', 13, 2001001000, '服务端发生异常', '2019-08-26 11:23:08');
INSERT INTO `access_log` VALUES (71580, '65.54.15668008664747899', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.123.105.12', '2019-08-26 14:27:46', 30, 1002001012, '访问令牌已过期', '2019-08-26 14:27:47');
INSERT INTO `access_log` VALUES (71581, '65.53.15668008664757953', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.123.105.12', '2019-08-26 14:27:46', 32, 1002001012, '访问令牌已过期', '2019-08-26 14:27:47');
INSERT INTO `access_log` VALUES (71582, '65.52.15668008664858053', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.123.105.12', '2019-08-26 14:27:46', 23, 1002001012, '访问令牌已过期', '2019-08-26 14:27:47');
INSERT INTO `access_log` VALUES (71583, '65.47.15668008685677949', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.123.105.12', '2019-08-26 14:27:49', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 14:27:49');
INSERT INTO `access_log` VALUES (71584, '65.46.15668008835218031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.123.105.12', '2019-08-26 14:28:04', 108, 0, '', '2019-08-26 14:28:04');
INSERT INTO `access_log` VALUES (71585, '65.51.15668008838458067', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.123.105.12', '2019-08-26 14:28:04', 14, 0, '', '2019-08-26 14:28:04');
INSERT INTO `access_log` VALUES (71586, '65.50.15668008838478003', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.123.105.12', '2019-08-26 14:28:04', 12, 2001001000, '服务端发生异常', '2019-08-26 14:28:04');
INSERT INTO `access_log` VALUES (71587, '65.49.15668008838478015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.123.105.12', '2019-08-26 14:28:04', 15, 0, '', '2019-08-26 14:28:04');
INSERT INTO `access_log` VALUES (71588, '65.46.15668009783648033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.31.206', '2019-08-26 14:29:38', 4, 1002001012, '访问令牌已过期', '2019-08-26 14:29:38');
INSERT INTO `access_log` VALUES (71589, '65.50.15668009783698005', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.31.206', '2019-08-26 14:29:38', 3, 1002001012, '访问令牌已过期', '2019-08-26 14:29:38');
INSERT INTO `access_log` VALUES (71590, '65.51.15668009783698069', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.31.206', '2019-08-26 14:29:38', 3, 1002001012, '访问令牌已过期', '2019-08-26 14:29:38');
INSERT INTO `access_log` VALUES (71591, '65.3607.15668009863249817', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.31.206', '2019-08-26 14:29:46', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 14:29:46');
INSERT INTO `access_log` VALUES (71592, '65.52.15668009905178057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.31.206', '2019-08-26 14:29:51', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 14:29:51');
INSERT INTO `access_log` VALUES (71593, '65.47.15668010098257953', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.31.206', '2019-08-26 14:30:10', 58, 0, '', '2019-08-26 14:30:10');
INSERT INTO `access_log` VALUES (71594, '65.45.15668010101948037', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.31.206', '2019-08-26 14:30:10', 9, 0, '', '2019-08-26 14:30:10');
INSERT INTO `access_log` VALUES (71595, '65.46.15668010102238035', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.31.206', '2019-08-26 14:30:10', 8, 2001001000, '服务端发生异常', '2019-08-26 14:30:10');
INSERT INTO `access_log` VALUES (71596, '65.51.15668010102248071', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.88.31.206', '2019-08-26 14:30:10', 8, 0, '', '2019-08-26 14:30:10');
INSERT INTO `access_log` VALUES (71597, '65.49.15668019220578031', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.78.106', '2019-08-26 14:45:22', 0, 1002001015, '账号未登陆', '2019-08-26 14:45:22');
INSERT INTO `access_log` VALUES (71598, '65.50.15668019220578019', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.78.106', '2019-08-26 14:45:22', 0, 1002001015, '账号未登陆', '2019-08-26 14:45:22');
INSERT INTO `access_log` VALUES (71599, '65.3607.15668019220649831', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.78.106', '2019-08-26 14:45:22', 0, 1002001015, '账号未登陆', '2019-08-26 14:45:22');
INSERT INTO `access_log` VALUES (71600, '65.53.15668019337007971', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.78.106', '2019-08-26 14:45:34', 82, 0, '', '2019-08-26 14:45:34');
INSERT INTO `access_log` VALUES (71601, '65.54.15668019343847917', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.78.106', '2019-08-26 14:45:34', 11, 2001001000, '服务端发生异常', '2019-08-26 14:45:34');
INSERT INTO `access_log` VALUES (71602, '65.47.15668019343877967', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.78.106', '2019-08-26 14:45:34', 8, 0, '', '2019-08-26 14:45:34');
INSERT INTO `access_log` VALUES (71603, '65.45.15668019343928051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.78.106', '2019-08-26 14:45:34', 7, 0, '', '2019-08-26 14:45:34');
INSERT INTO `access_log` VALUES (71604, '65.52.15668020080258073', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.78.106', '2019-08-26 14:46:48', 13, 2001001000, '服务端发生异常', '2019-08-26 14:46:48');
INSERT INTO `access_log` VALUES (71605, '65.53.15668020080307973', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.78.106', '2019-08-26 14:46:48', 9, 0, '', '2019-08-26 14:46:48');
INSERT INTO `access_log` VALUES (71606, '65.47.15668020080327969', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:68.0) Gecko/20100101 Firefox/68.0', '112.17.78.106', '2019-08-26 14:46:48', 8, 0, '', '2019-08-26 14:46:48');
INSERT INTO `access_log` VALUES (71607, '65.46.15668034056678071', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:06', 0, 1002001015, '账号未登陆', '2019-08-26 15:10:06');
INSERT INTO `access_log` VALUES (71608, '65.52.15668034056698093', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:06', 0, 1002001015, '账号未登陆', '2019-08-26 15:10:06');
INSERT INTO `access_log` VALUES (71609, '65.51.15668034056808107', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:06', 0, 1002001015, '账号未登陆', '2019-08-26 15:10:06');
INSERT INTO `access_log` VALUES (71610, '65.49.15668034084488055', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 15:10:08');
INSERT INTO `access_log` VALUES (71611, '65.45.15668034218638073', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:22', 101, 0, '', '2019-08-26 15:10:22');
INSERT INTO `access_log` VALUES (71612, '65.47.15668034222637987', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:22', 12, 2001001000, '服务端发生异常', '2019-08-26 15:10:22');
INSERT INTO `access_log` VALUES (71613, '65.50.15668034222688041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:22', 9, 0, '', '2019-08-26 15:10:22');
INSERT INTO `access_log` VALUES (71614, '65.54.15668034222687941', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:22', 9, 0, '', '2019-08-26 15:10:22');
INSERT INTO `access_log` VALUES (71615, '65.52.15668034343818095', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:34', 10, 0, '', '2019-08-26 15:10:34');
INSERT INTO `access_log` VALUES (71616, '65.51.15668034343878109', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:34', 9, 0, '', '2019-08-26 15:10:34');
INSERT INTO `access_log` VALUES (71617, '65.46.15668034343868073', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:34', 10, 2001001000, '服务端发生异常', '2019-08-26 15:10:34');
INSERT INTO `access_log` VALUES (71618, '65.53.15668034422657995', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:42', 17, 0, '', '2019-08-26 15:10:42');
INSERT INTO `access_log` VALUES (71619, '65.45.15668034422698075', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:42', 16, 0, '', '2019-08-26 15:10:42');
INSERT INTO `access_log` VALUES (71620, '65.54.15668034422727943', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:42', 17, 2001001000, '服务端发生异常', '2019-08-26 15:10:42');
INSERT INTO `access_log` VALUES (71621, '65.47.15668034506227989', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:51', 10, 0, '', '2019-08-26 15:10:51');
INSERT INTO `access_log` VALUES (71622, '65.50.15668034506328043', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:51', 9, 2001001000, '服务端发生异常', '2019-08-26 15:10:51');
INSERT INTO `access_log` VALUES (71623, '65.3607.15668034506369859', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:10:51', 9, 0, '', '2019-08-26 15:10:51');
INSERT INTO `access_log` VALUES (71624, '59.78.15668034772244781', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:11:17', 10, 0, '', '2019-08-26 15:11:17');
INSERT INTO `access_log` VALUES (71625, '59.74.15668034772244783', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:11:17', 18, 2001001000, '服务端发生异常', '2019-08-26 15:11:17');
INSERT INTO `access_log` VALUES (71626, '64.76.15668034879675167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:11:28', 11, 0, '', '2019-08-26 15:11:28');
INSERT INTO `access_log` VALUES (71627, '64.85.15668034880885185', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:11:28', 2, 0, '', '2019-08-26 15:11:28');
INSERT INTO `access_log` VALUES (71628, '64.79.15668034894715157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:11:29', 2, 0, '', '2019-08-26 15:11:29');
INSERT INTO `access_log` VALUES (71629, '64.81.15668034902125163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:11:30', 1, 0, '', '2019-08-26 15:11:30');
INSERT INTO `access_log` VALUES (71630, '64.80.15668034907565163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-26 15:11:31', 2, 0, '', '2019-08-26 15:11:31');
INSERT INTO `access_log` VALUES (71631, '59.75.15668047182224793', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.69.249.90', '2019-08-26 15:31:58', 4, 0, '', '2019-08-26 15:31:58');
INSERT INTO `access_log` VALUES (71632, '59.77.15668047182274775', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.69.249.90', '2019-08-26 15:31:58', 12, 2001001000, '服务端发生异常', '2019-08-26 15:31:58');
INSERT INTO `access_log` VALUES (71633, '59.77.15668072496544809', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.154.103.16', '2019-08-26 16:14:10', 11, 0, '', '2019-08-26 16:14:10');
INSERT INTO `access_log` VALUES (71634, '59.76.15668072496554811', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.154.103.16', '2019-08-26 16:14:10', 37, 2001001000, '服务端发生异常', '2019-08-26 16:14:10');
INSERT INTO `access_log` VALUES (71635, '59.80.15668072579004793', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:18', 4, 0, '', '2019-08-26 16:14:18');
INSERT INTO `access_log` VALUES (71636, '59.79.15668072579004823', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:18', 14, 2001001000, '服务端发生异常', '2019-08-26 16:14:18');
INSERT INTO `access_log` VALUES (71637, '64.78.15668072627765231', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:23', 13, 0, '', '2019-08-26 16:14:23');
INSERT INTO `access_log` VALUES (71638, '64.83.15668072630285209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:23', 3, 0, '', '2019-08-26 16:14:23');
INSERT INTO `access_log` VALUES (71639, '64.82.15668072646435225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:25', 79, 0, '', '2019-08-26 16:14:25');
INSERT INTO `access_log` VALUES (71640, '64.76.15668072654045219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:25', 2, 0, '', '2019-08-26 16:14:25');
INSERT INTO `access_log` VALUES (71641, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:27', 5, 0, '', '2019-08-26 16:14:27');
INSERT INTO `access_log` VALUES (71642, '64.85.15668072665045237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:27', 2, 0, '', '2019-08-26 16:14:27');
INSERT INTO `access_log` VALUES (71643, '64.79.15668072681205209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:28', 1, 0, '', '2019-08-26 16:14:28');
INSERT INTO `access_log` VALUES (71644, '64.81.15668072682005215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:28', 2, 0, '', '2019-08-26 16:14:28');
INSERT INTO `access_log` VALUES (71645, '64.80.15668072692415215', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:29', 2, 0, '', '2019-08-26 16:14:29');
INSERT INTO `access_log` VALUES (71646, '64.84.15668072698955211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:30', 2, 0, '', '2019-08-26 16:14:30');
INSERT INTO `access_log` VALUES (71647, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:30', 5, 0, '', '2019-08-26 16:14:30');
INSERT INTO `access_log` VALUES (71648, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:34', 5, 0, '', '2019-08-26 16:14:34');
INSERT INTO `access_log` VALUES (71649, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:35', 5, 0, '', '2019-08-26 16:14:35');
INSERT INTO `access_log` VALUES (71650, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:36', 5, 0, '', '2019-08-26 16:14:36');
INSERT INTO `access_log` VALUES (71651, '64.78.15668072762935233', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:36', 2, 0, '', '2019-08-26 16:14:36');
INSERT INTO `access_log` VALUES (71652, '64.83.15668072763935211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:36', 2, 0, '', '2019-08-26 16:14:36');
INSERT INTO `access_log` VALUES (71653, '64.82.15668072774435227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:37', 2, 0, '', '2019-08-26 16:14:37');
INSERT INTO `access_log` VALUES (71654, '64.76.15668072782745221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:38', 2, 0, '', '2019-08-26 16:14:38');
INSERT INTO `access_log` VALUES (71655, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:38', 6, 0, '', '2019-08-26 16:14:38');
INSERT INTO `access_log` VALUES (71656, '64.85.15668072796445239', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:14:40', 15, 0, '', '2019-08-26 16:14:40');
INSERT INTO `access_log` VALUES (71657, '64.81.15668073002145217', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:15:00', 6, 0, '', '2019-08-26 16:15:00');
INSERT INTO `access_log` VALUES (71658, '64.80.15668073008935217', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:15:01', 1, 0, '', '2019-08-26 16:15:01');
INSERT INTO `access_log` VALUES (71659, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.154.103.16', '2019-08-26 16:15:01', 6, 0, '', '2019-08-26 16:15:01');
INSERT INTO `access_log` VALUES (71660, '65.53.15668112622298101', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.102.184.188', '2019-08-26 17:21:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 17:21:02');
INSERT INTO `access_log` VALUES (71661, '65.51.15668112625498215', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.102.184.188', '2019-08-26 17:21:03', 4, 1002001012, '访问令牌已过期', '2019-08-26 17:21:03');
INSERT INTO `access_log` VALUES (71662, '65.46.15668112625638181', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.102.184.188', '2019-08-26 17:21:03', 11, 1002001012, '访问令牌已过期', '2019-08-26 17:21:03');
INSERT INTO `access_log` VALUES (71663, '65.52.15668112625708201', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.102.184.188', '2019-08-26 17:21:03', 5, 1002001012, '访问令牌已过期', '2019-08-26 17:21:03');
INSERT INTO `access_log` VALUES (71664, '65.49.15668112682868165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.102.184.188', '2019-08-26 17:21:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 17:21:08');
INSERT INTO `access_log` VALUES (71665, '59.74.15668114607374891', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.204.12.34', '2019-08-26 17:24:21', 11, 0, '', '2019-08-26 17:24:21');
INSERT INTO `access_log` VALUES (71666, '59.71.15668114607444877', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.204.12.34', '2019-08-26 17:24:21', 24, 2001001000, '服务端发生异常', '2019-08-26 17:24:21');
INSERT INTO `access_log` VALUES (71667, '59.72.15668114671794879', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '121.204.12.34', '2019-08-26 17:24:27', 3, 0, '', '2019-08-26 17:24:27');
INSERT INTO `access_log` VALUES (71668, '59.73.15668114671794881', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '121.204.12.34', '2019-08-26 17:24:27', 19, 2001001000, '服务端发生异常', '2019-08-26 17:24:27');
INSERT INTO `access_log` VALUES (71669, '64.81.15668114706635273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:31', 11, 0, '', '2019-08-26 17:24:31');
INSERT INTO `access_log` VALUES (71670, '64.80.15668114707895273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:31', 3, 0, '', '2019-08-26 17:24:31');
INSERT INTO `access_log` VALUES (71671, '64.84.15668114720095269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:32', 108, 0, '', '2019-08-26 17:24:32');
INSERT INTO `access_log` VALUES (71672, '64.77.15668114724995255', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:33', 2, 0, '', '2019-08-26 17:24:33');
INSERT INTO `access_log` VALUES (71673, '64.78.15668114742415291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:34', 2, 0, '', '2019-08-26 17:24:34');
INSERT INTO `access_log` VALUES (71674, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:34', 6, 0, '', '2019-08-26 17:24:34');
INSERT INTO `access_log` VALUES (71675, '64.82.15668114755425285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:36', 2, 0, '', '2019-08-26 17:24:36');
INSERT INTO `access_log` VALUES (71676, '64.76.15668114756865279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:36', 1, 0, '', '2019-08-26 17:24:36');
INSERT INTO `access_log` VALUES (71677, '64.85.15668114761825297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:36', 2, 0, '', '2019-08-26 17:24:36');
INSERT INTO `access_log` VALUES (71678, '64.79.15668114766005269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:37', 2, 0, '', '2019-08-26 17:24:37');
INSERT INTO `access_log` VALUES (71679, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:37', 7, 0, '', '2019-08-26 17:24:37');
INSERT INTO `access_log` VALUES (71680, '64.81.15668114775005275', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:38', 8, 0, '', '2019-08-26 17:24:38');
INSERT INTO `access_log` VALUES (71681, '64.84.15668114923675271', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:52', 7, 0, '', '2019-08-26 17:24:52');
INSERT INTO `access_log` VALUES (71682, '64.77.15668114937525257', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:54', 2, 0, '', '2019-08-26 17:24:54');
INSERT INTO `access_log` VALUES (71683, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:54', 5, 0, '', '2019-08-26 17:24:54');
INSERT INTO `access_log` VALUES (71684, '64.78.15668114953365293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:55', 2, 0, '', '2019-08-26 17:24:55');
INSERT INTO `access_log` VALUES (71685, '64.83.15668114954165271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:24:55', 2, 0, '', '2019-08-26 17:24:55');
INSERT INTO `access_log` VALUES (71686, '64.82.15668115015535287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:25:02', 2, 0, '', '2019-08-26 17:25:02');
INSERT INTO `access_log` VALUES (71687, '64.76.15668115016405281', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:25:02', 10, 0, '', '2019-08-26 17:25:02');
INSERT INTO `access_log` VALUES (71688, '59.77.15668115023374867', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:25:02', 3, 0, '', '2019-08-26 17:25:02');
INSERT INTO `access_log` VALUES (71689, '59.80.15668115023394851', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:25:02', 16, 2001001000, '服务端发生异常', '2019-08-26 17:25:02');
INSERT INTO `access_log` VALUES (71690, '64.85.15668115036135299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:25:04', 1, 0, '', '2019-08-26 17:25:04');
INSERT INTO `access_log` VALUES (71691, '64.79.15668115037265271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:25:04', 2, 0, '', '2019-08-26 17:25:04');
INSERT INTO `access_log` VALUES (71692, '59.78.15668115054054891', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:25:05', 3, 0, '', '2019-08-26 17:25:05');
INSERT INTO `access_log` VALUES (71693, '59.71.15668115054084879', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '121.204.12.34', '2019-08-26 17:25:05', 16, 2001001000, '服务端发生异常', '2019-08-26 17:25:05');
INSERT INTO `access_log` VALUES (71694, '65.46.15668119668918191', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '111.85.152.35', '2019-08-26 17:32:47', 1, 1002001015, '账号未登陆', '2019-08-26 17:32:47');
INSERT INTO `access_log` VALUES (71695, '65.52.15668119668928211', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '111.85.152.35', '2019-08-26 17:32:47', 0, 1002001015, '账号未登陆', '2019-08-26 17:32:47');
INSERT INTO `access_log` VALUES (71696, '65.49.15668119668958175', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '111.85.152.35', '2019-08-26 17:32:47', 1, 1002001015, '账号未登陆', '2019-08-26 17:32:47');
INSERT INTO `access_log` VALUES (71697, '65.45.15668119690868193', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '111.85.152.35', '2019-08-26 17:32:49', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 17:32:49');
INSERT INTO `access_log` VALUES (71698, '65.54.15668119709418059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '111.85.152.35', '2019-08-26 17:32:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 17:32:51');
INSERT INTO `access_log` VALUES (71699, '65.50.15668124257698167', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:40:26', 0, 1002001015, '账号未登陆', '2019-08-26 17:40:26');
INSERT INTO `access_log` VALUES (71700, '65.3607.15668124257699981', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:40:26', 0, 1002001015, '账号未登陆', '2019-08-26 17:40:26');
INSERT INTO `access_log` VALUES (71701, '65.53.15668124257748119', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:40:26', 0, 1002001015, '账号未登陆', '2019-08-26 17:40:26');
INSERT INTO `access_log` VALUES (71702, '65.51.15668124258458233', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:40:26', 0, 1002001015, '账号未登陆', '2019-08-26 17:40:26');
INSERT INTO `access_log` VALUES (71703, '65.49.15668124258488183', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:40:26', 0, 1002001015, '账号未登陆', '2019-08-26 17:40:26');
INSERT INTO `access_log` VALUES (71704, '65.46.15668124258848199', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:40:26', 0, 1002001015, '账号未登陆', '2019-08-26 17:40:26');
INSERT INTO `access_log` VALUES (71705, '65.52.15668124273348219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:40:27', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 17:40:27');
INSERT INTO `access_log` VALUES (71706, '65.45.15668124382828201', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:40:38', 91, 0, '', '2019-08-26 17:40:38');
INSERT INTO `access_log` VALUES (71707, '65.54.15668124386748067', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:40:39', 92, 0, '', '2019-08-26 17:40:39');
INSERT INTO `access_log` VALUES (71708, '65.50.15668124386858169', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:40:39', 82, 0, '', '2019-08-26 17:40:39');
INSERT INTO `access_log` VALUES (71709, '65.47.15668124386778113', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:40:39', 91, 2001001000, '服务端发生异常', '2019-08-26 17:40:39');
INSERT INTO `access_log` VALUES (71710, '65.3607.15668124387919983', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:40:39', 0, 1002001015, '账号未登陆', '2019-08-26 17:40:39');
INSERT INTO `access_log` VALUES (71711, '65.53.15668124388958121', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:40:39', 0, 1002001015, '账号未登陆', '2019-08-26 17:40:39');
INSERT INTO `access_log` VALUES (71712, '65.49.15668124388968185', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:40:39', 1, 1002001015, '账号未登陆', '2019-08-26 17:40:39');
INSERT INTO `access_log` VALUES (71713, '65.52.15668124639348221', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:41:04', 12, 0, '', '2019-08-26 17:41:04');
INSERT INTO `access_log` VALUES (71714, '65.45.15668124639398203', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:41:04', 12, 2001001000, '服务端发生异常', '2019-08-26 17:41:04');
INSERT INTO `access_log` VALUES (71715, '65.54.15668124639408069', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:41:04', 12, 0, '', '2019-08-26 17:41:04');
INSERT INTO `access_log` VALUES (71716, '65.3607.15668124639789985', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:41:04', 1, 1002001015, '账号未登陆', '2019-08-26 17:41:04');
INSERT INTO `access_log` VALUES (71717, '65.47.15668124640658115', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:41:04', 1, 1002001015, '账号未登陆', '2019-08-26 17:41:04');
INSERT INTO `access_log` VALUES (71718, '65.50.15668124640678171', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '122.224.223.239', '2019-08-26 17:41:04', 0, 1002001015, '账号未登陆', '2019-08-26 17:41:04');
INSERT INTO `access_log` VALUES (71719, '59.80.15668129281644871', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.32.216.13', '2019-08-26 17:48:48', 13, 2001001000, '服务端发生异常', '2019-08-26 17:48:48');
INSERT INTO `access_log` VALUES (71720, '59.76.15668129281634889', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.32.216.13', '2019-08-26 17:48:48', 145, 0, '', '2019-08-26 17:48:48');
INSERT INTO `access_log` VALUES (71721, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=ka&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.32.216.13', '2019-08-26 17:48:52', 4, 0, '', '2019-08-26 17:48:52');
INSERT INTO `access_log` VALUES (71722, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=ka', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.32.216.13', '2019-08-26 17:48:52', 5, 0, '', '2019-08-26 17:48:52');
INSERT INTO `access_log` VALUES (71723, '59.78.15668129339454911', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.32.216.13', '2019-08-26 17:48:54', 2, 0, '', '2019-08-26 17:48:54');
INSERT INTO `access_log` VALUES (71724, '59.79.15668129339454901', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.32.216.13', '2019-08-26 17:48:54', 26, 2001001000, '服务端发生异常', '2019-08-26 17:48:54');
INSERT INTO `access_log` VALUES (71725, '65.49.15668129453488193', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.32.216.13', '2019-08-26 17:49:05', 0, 1002001015, '账号未登陆', '2019-08-26 17:49:05');
INSERT INTO `access_log` VALUES (71726, '65.46.15668129453788209', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.32.216.13', '2019-08-26 17:49:05', 1, 1002001015, '账号未登陆', '2019-08-26 17:49:05');
INSERT INTO `access_log` VALUES (71727, '65.3607.15668129453929993', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.32.216.13', '2019-08-26 17:49:05', 1, 1002001015, '账号未登陆', '2019-08-26 17:49:05');
INSERT INTO `access_log` VALUES (71728, '65.52.15668129470748229', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.32.216.13', '2019-08-26 17:49:07', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 17:49:07');
INSERT INTO `access_log` VALUES (71729, '65.51.15668191915708327', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:33:12', 1, 1002001015, '账号未登陆', '2019-08-26 19:33:12');
INSERT INTO `access_log` VALUES (71730, '65.50.15668191915718263', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:33:12', 0, 1002001015, '账号未登陆', '2019-08-26 19:33:12');
INSERT INTO `access_log` VALUES (71731, '65.53.15668191915948215', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:33:12', 0, 1002001015, '账号未登陆', '2019-08-26 19:33:12');
INSERT INTO `access_log` VALUES (71732, '65.3607.15668191946260079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:33:15', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 19:33:15');
INSERT INTO `access_log` VALUES (71733, '65.49.15668192029608279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:33:23', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 19:33:23');
INSERT INTO `access_log` VALUES (71734, '59.71.15668192412974983', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:34:01', 10, 0, '', '2019-08-26 19:34:01');
INSERT INTO `access_log` VALUES (71735, '59.74.15668192413244997', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:34:01', 13, 2001001000, '服务端发生异常', '2019-08-26 19:34:01');
INSERT INTO `access_log` VALUES (71736, '64.76.15668192465755385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:34:07', 12, 0, '', '2019-08-26 19:34:07');
INSERT INTO `access_log` VALUES (71737, '64.85.15668192469235403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:34:07', 3, 0, '', '2019-08-26 19:34:07');
INSERT INTO `access_log` VALUES (71738, '64.79.15668192479785375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:34:08', 2, 0, '', '2019-08-26 19:34:08');
INSERT INTO `access_log` VALUES (71739, '64.81.15668192487215381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:34:09', 2, 0, '', '2019-08-26 19:34:09');
INSERT INTO `access_log` VALUES (71740, '64.80.15668192491935381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:34:09', 2, 0, '', '2019-08-26 19:34:09');
INSERT INTO `access_log` VALUES (71741, '64.82.15668193075785393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:35:08', 2, 0, '', '2019-08-26 19:35:08');
INSERT INTO `access_log` VALUES (71742, '64.76.15668193084495387', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:35:08', 2, 0, '', '2019-08-26 19:35:08');
INSERT INTO `access_log` VALUES (71743, '64.85.15668193092965405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:35:09', 2, 0, '', '2019-08-26 19:35:09');
INSERT INTO `access_log` VALUES (71744, '64.79.15668193102895377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-26 19:35:10', 2, 0, '', '2019-08-26 19:35:10');
INSERT INTO `access_log` VALUES (71745, '65.49.15668311536918441', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.10.17.90', '2019-08-26 22:52:34', 1, 1002001015, '账号未登陆', '2019-08-26 22:52:34');
INSERT INTO `access_log` VALUES (71746, '65.46.15668311536918453', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.10.17.90', '2019-08-26 22:52:34', 0, 1002001015, '账号未登陆', '2019-08-26 22:52:34');
INSERT INTO `access_log` VALUES (71747, '65.54.15668311536948323', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.10.17.90', '2019-08-26 22:52:34', 0, 1002001015, '账号未登陆', '2019-08-26 22:52:34');
INSERT INTO `access_log` VALUES (71748, '65.47.15668311716658369', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.10.17.90', '2019-08-26 22:52:52', 96, 0, '', '2019-08-26 22:52:52');
INSERT INTO `access_log` VALUES (71749, '65.51.15668311722658491', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.238.194.207', '2019-08-26 22:52:52', 16, 0, '', '2019-08-26 22:52:52');
INSERT INTO `access_log` VALUES (71750, '65.53.15668311722768375', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.10.17.90', '2019-08-26 22:52:52', 10, 0, '', '2019-08-26 22:52:52');
INSERT INTO `access_log` VALUES (71751, '65.3607.15668311722750241', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '60.10.17.90', '2019-08-26 22:52:52', 13, 2001001000, '服务端发生异常', '2019-08-26 22:52:52');
INSERT INTO `access_log` VALUES (71752, '65.51.15668325034678509', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '175.43.94.95', '2019-08-26 23:15:03', 0, 1002001015, '账号未登陆', '2019-08-26 23:15:03');
INSERT INTO `access_log` VALUES (71753, '65.45.15668325034698479', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '175.43.94.95', '2019-08-26 23:15:03', 0, 1002001015, '账号未登陆', '2019-08-26 23:15:03');
INSERT INTO `access_log` VALUES (71754, '65.52.15668325034698493', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '175.43.94.95', '2019-08-26 23:15:03', 0, 1002001015, '账号未登陆', '2019-08-26 23:15:03');
INSERT INTO `access_log` VALUES (71755, '65.49.15668325060568461', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '175.43.94.95', '2019-08-26 23:15:06', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 23:15:06');
INSERT INTO `access_log` VALUES (71756, '65.54.15668325189848343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '175.43.94.95', '2019-08-26 23:15:19', 80, 0, '', '2019-08-26 23:15:19');
INSERT INTO `access_log` VALUES (71757, '65.50.15668325194028445', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '175.43.94.95', '2019-08-26 23:15:19', 18, 0, '', '2019-08-26 23:15:19');
INSERT INTO `access_log` VALUES (71758, '65.53.15668325194078395', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '175.43.94.95', '2019-08-26 23:15:19', 17, 0, '', '2019-08-26 23:15:19');
INSERT INTO `access_log` VALUES (71759, '65.47.15668325194068389', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '175.43.94.95', '2019-08-26 23:15:19', 18, 2001001000, '服务端发生异常', '2019-08-26 23:15:19');
INSERT INTO `access_log` VALUES (71760, '65.52.15668325290198495', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '175.43.94.95', '2019-08-26 23:15:29', 9, 0, '', '2019-08-26 23:15:29');
INSERT INTO `access_log` VALUES (71761, '65.51.15668325290228511', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '175.43.94.95', '2019-08-26 23:15:29', 9, 0, '', '2019-08-26 23:15:29');
INSERT INTO `access_log` VALUES (71762, '65.45.15668325290228481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '175.43.94.95', '2019-08-26 23:15:29', 10, 2001001000, '服务端发生异常', '2019-08-26 23:15:29');
INSERT INTO `access_log` VALUES (71763, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '175.43.94.95', '2019-08-26 23:18:16', 6, 0, '', '2019-08-26 23:18:16');
INSERT INTO `access_log` VALUES (71764, '64.85.15668326955505581', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '175.43.94.95', '2019-08-26 23:18:16', 11, 0, '', '2019-08-26 23:18:16');
INSERT INTO `access_log` VALUES (71765, '64.76.15668326981745567', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '175.43.94.95', '2019-08-26 23:18:18', 63, 0, '', '2019-08-26 23:18:18');
INSERT INTO `access_log` VALUES (71766, '65.45.15668331102408489', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.158.86.32', '2019-08-26 23:25:10', 5, 1002002001, '密码不正确', '2019-08-26 23:25:10');
INSERT INTO `access_log` VALUES (71767, '65.52.15668331271308505', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'password=admin&username=admin', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.158.86.32', '2019-08-26 23:25:27', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-26 23:25:27');
INSERT INTO `access_log` VALUES (71768, '65.49.15668331350918473', 0, 2, 'admin-application', '/admin-api/admins/passport/login', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.158.86.32', '2019-08-26 23:25:35', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码不能为空\n登陆账号不能为空', '2019-08-26 23:25:35');
INSERT INTO `access_log` VALUES (71769, '65.49.15668368587818523', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '113.104.200.194', '2019-08-27 00:27:39', 0, 1002001015, '账号未登陆', '2019-08-27 00:27:39');
INSERT INTO `access_log` VALUES (71770, '65.52.15668368587818555', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '113.104.200.194', '2019-08-27 00:27:39', 0, 1002001015, '账号未登陆', '2019-08-27 00:27:39');
INSERT INTO `access_log` VALUES (71771, '65.46.15668368587818535', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '113.104.200.194', '2019-08-27 00:27:39', 0, 1002001015, '账号未登陆', '2019-08-27 00:27:39');
INSERT INTO `access_log` VALUES (71772, '65.53.15668368641838457', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '113.104.200.194', '2019-08-27 00:27:44', 77, 0, '', '2019-08-27 00:27:44');
INSERT INTO `access_log` VALUES (71773, '65.50.15668368645938507', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '113.104.200.194', '2019-08-27 00:27:45', 12, 0, '', '2019-08-27 00:27:45');
INSERT INTO `access_log` VALUES (71774, '65.47.15668368645988449', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '113.104.200.194', '2019-08-27 00:27:45', 11, 2001001000, '服务端发生异常', '2019-08-27 00:27:45');
INSERT INTO `access_log` VALUES (71775, '65.3607.15668368646050319', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '113.104.200.194', '2019-08-27 00:27:45', 8, 0, '', '2019-08-27 00:27:45');
INSERT INTO `access_log` VALUES (71776, '65.51.15668368770018571', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '113.104.200.194', '2019-08-27 00:27:57', 11, 0, '', '2019-08-27 00:27:57');
INSERT INTO `access_log` VALUES (71777, '65.49.15668368770038525', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '113.104.200.194', '2019-08-27 00:27:57', 11, 2001001000, '服务端发生异常', '2019-08-27 00:27:57');
INSERT INTO `access_log` VALUES (71778, '65.46.15668368770098537', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '113.104.200.194', '2019-08-27 00:27:57', 10, 0, '', '2019-08-27 00:27:57');
INSERT INTO `access_log` VALUES (71779, '65.52.15668368809118557', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '113.104.200.194', '2019-08-27 00:28:01', 10, 0, '', '2019-08-27 00:28:01');
INSERT INTO `access_log` VALUES (71780, '65.54.15668368809228407', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '113.104.200.194', '2019-08-27 00:28:01', 9, 0, '', '2019-08-27 00:28:01');
INSERT INTO `access_log` VALUES (71781, '65.53.15668368809248459', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3719.400 QQBrowser/10.5.3715.400', '113.104.200.194', '2019-08-27 00:28:01', 9, 2001001000, '服务端发生异常', '2019-08-27 00:28:01');
INSERT INTO `access_log` VALUES (71782, '65.52.15668590477238853', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.154.213.250', '2019-08-27 06:37:28', 1, 1002001015, '账号未登陆', '2019-08-27 06:37:28');
INSERT INTO `access_log` VALUES (71783, '65.54.15668590477238703', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.154.213.250', '2019-08-27 06:37:28', 1, 1002001015, '账号未登陆', '2019-08-27 06:37:28');
INSERT INTO `access_log` VALUES (71784, '65.50.15668590477278805', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.154.213.250', '2019-08-27 06:37:28', 0, 1002001015, '账号未登陆', '2019-08-27 06:37:28');
INSERT INTO `access_log` VALUES (71785, '65.47.15668590504398747', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.154.213.250', '2019-08-27 06:37:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 06:37:30');
INSERT INTO `access_log` VALUES (71786, '65.3607.15668590533270617', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.154.213.250', '2019-08-27 06:37:33', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 06:37:33');
INSERT INTO `access_log` VALUES (71787, '65.51.15668590652378869', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.154.213.250', '2019-08-27 06:37:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 06:37:45');
INSERT INTO `access_log` VALUES (71788, '65.49.15668590785908823', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.154.213.250', '2019-08-27 06:37:59', 281, 0, '', '2019-08-27 06:37:59');
INSERT INTO `access_log` VALUES (71789, '65.53.15668590791948757', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.154.213.250', '2019-08-27 06:37:59', 15, 0, '', '2019-08-27 06:37:59');
INSERT INTO `access_log` VALUES (71790, '65.52.15668590792028855', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.154.213.250', '2019-08-27 06:37:59', 13, 2001001000, '服务端发生异常', '2019-08-27 06:37:59');
INSERT INTO `access_log` VALUES (71791, '65.50.15668590792378807', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.154.213.250', '2019-08-27 06:37:59', 9, 0, '', '2019-08-27 06:37:59');
INSERT INTO `access_log` VALUES (71792, '65.47.15668591004158749', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.154.213.250', '2019-08-27 06:38:20', 10, 0, '', '2019-08-27 06:38:20');
INSERT INTO `access_log` VALUES (71793, '65.3607.15668591004510619', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.154.213.250', '2019-08-27 06:38:20', 10, 2001001000, '服务端发生异常', '2019-08-27 06:38:20');
INSERT INTO `access_log` VALUES (71794, '65.45.15668591004568841', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.154.213.250', '2019-08-27 06:38:20', 9, 0, '', '2019-08-27 06:38:20');
INSERT INTO `access_log` VALUES (71795, '65.51.15668650277148949', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.203.175.184', '2019-08-27 08:17:08', 1, 1002001015, '账号未登陆', '2019-08-27 08:17:08');
INSERT INTO `access_log` VALUES (71796, '65.3607.15668650277140701', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.203.175.184', '2019-08-27 08:17:08', 1, 1002001015, '账号未登陆', '2019-08-27 08:17:08');
INSERT INTO `access_log` VALUES (71797, '65.45.15668650277168923', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.203.175.184', '2019-08-27 08:17:08', 1, 1002001015, '账号未登陆', '2019-08-27 08:17:08');
INSERT INTO `access_log` VALUES (71798, '65.46.15668650299608919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.203.175.184', '2019-08-27 08:17:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 08:17:10');
INSERT INTO `access_log` VALUES (71799, '65.52.15668650567208935', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.203.175.184', '2019-08-27 08:17:37', 91, 0, '', '2019-08-27 08:17:37');
INSERT INTO `access_log` VALUES (71800, '65.54.15668650570748787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.203.175.184', '2019-08-27 08:17:37', 13, 0, '', '2019-08-27 08:17:37');
INSERT INTO `access_log` VALUES (71801, '65.47.15668650570748833', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.203.175.184', '2019-08-27 08:17:37', 12, 0, '', '2019-08-27 08:17:37');
INSERT INTO `access_log` VALUES (71802, '65.50.15668650570738893', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.203.175.184', '2019-08-27 08:17:37', 15, 2001001000, '服务端发生异常', '2019-08-27 08:17:37');
INSERT INTO `access_log` VALUES (71803, '65.3607.15668650788440703', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.203.175.184', '2019-08-27 08:17:59', 8, 0, '', '2019-08-27 08:17:59');
INSERT INTO `access_log` VALUES (71804, '65.49.15668650788448907', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.203.175.184', '2019-08-27 08:17:59', 10, 2001001000, '服务端发生异常', '2019-08-27 08:17:59');
INSERT INTO `access_log` VALUES (71805, '65.46.15668650788778921', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.203.175.184', '2019-08-27 08:17:59', 9, 0, '', '2019-08-27 08:17:59');
INSERT INTO `access_log` VALUES (71806, '65.52.15668650971348937', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.203.175.184', '2019-08-27 08:18:17', 9, 0, '', '2019-08-27 08:18:17');
INSERT INTO `access_log` VALUES (71807, '65.50.15668650971378895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.203.175.184', '2019-08-27 08:18:17', 10, 2001001000, '服务端发生异常', '2019-08-27 08:18:17');
INSERT INTO `access_log` VALUES (71808, '65.54.15668650971408789', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.203.175.184', '2019-08-27 08:18:17', 41, 0, '', '2019-08-27 08:18:17');
INSERT INTO `access_log` VALUES (71809, '59.76.15668666838055607', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:44:44', 11, 0, '', '2019-08-27 08:44:44');
INSERT INTO `access_log` VALUES (71810, '59.80.15668666838095589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:44:44', 32, 2001001000, '服务端发生异常', '2019-08-27 08:44:44');
INSERT INTO `access_log` VALUES (71811, '64.78.15668666873196035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:44:47', 12, 0, '', '2019-08-27 08:44:47');
INSERT INTO `access_log` VALUES (71812, '64.83.15668666875576011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:44:48', 3, 0, '', '2019-08-27 08:44:48');
INSERT INTO `access_log` VALUES (71813, '59.77.15668666887435605', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:44:49', 17, 2001001000, '服务端发生异常', '2019-08-27 08:44:49');
INSERT INTO `access_log` VALUES (71814, '59.78.15668666887505629', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:44:49', 643, 0, '', '2019-08-27 08:44:49');
INSERT INTO `access_log` VALUES (71815, '59.74.15668666941385631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:44:54', 2, 0, '', '2019-08-27 08:44:54');
INSERT INTO `access_log` VALUES (71816, '59.71.15668666941355617', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:44:54', 14, 2001001000, '服务端发生异常', '2019-08-27 08:44:54');
INSERT INTO `access_log` VALUES (71817, '59.73.15668666985195621', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:44:59', 2, 0, '', '2019-08-27 08:44:59');
INSERT INTO `access_log` VALUES (71818, '59.72.15668666985195619', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:44:59', 12, 2001001000, '服务端发生异常', '2019-08-27 08:44:59');
INSERT INTO `access_log` VALUES (71819, '64.76.15668667026146021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:03', 2, 0, '', '2019-08-27 08:45:03');
INSERT INTO `access_log` VALUES (71820, '64.81.15668667028306017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:03', 2, 0, '', '2019-08-27 08:45:03');
INSERT INTO `access_log` VALUES (71821, '64.82.15668667042356029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:04', 2, 0, '', '2019-08-27 08:45:04');
INSERT INTO `access_log` VALUES (71822, '64.80.15668667049736015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:05', 3, 0, '', '2019-08-27 08:45:05');
INSERT INTO `access_log` VALUES (71823, '64.84.15668667055026013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:06', 2, 0, '', '2019-08-27 08:45:06');
INSERT INTO `access_log` VALUES (71824, '64.77.15668667058835999', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:06', 3, 0, '', '2019-08-27 08:45:06');
INSERT INTO `access_log` VALUES (71825, '64.78.15668667061226037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:06', 2, 0, '', '2019-08-27 08:45:06');
INSERT INTO `access_log` VALUES (71826, '64.83.15668667063876013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:06', 2, 0, '', '2019-08-27 08:45:06');
INSERT INTO `access_log` VALUES (71827, '64.85.15668667066026037', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:07', 2, 0, '', '2019-08-27 08:45:07');
INSERT INTO `access_log` VALUES (71828, '64.76.15668667070016023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:07', 2, 0, '', '2019-08-27 08:45:07');
INSERT INTO `access_log` VALUES (71829, '64.81.15668667072076019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:07', 2, 0, '', '2019-08-27 08:45:07');
INSERT INTO `access_log` VALUES (71830, '59.76.15668667081745609', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:08', 2, 0, '', '2019-08-27 08:45:08');
INSERT INTO `access_log` VALUES (71831, '59.80.15668667081755591', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:08', 14, 2001001000, '服务端发生异常', '2019-08-27 08:45:08');
INSERT INTO `access_log` VALUES (71832, '64.82.15668667151046031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:15', 1, 0, '', '2019-08-27 08:45:15');
INSERT INTO `access_log` VALUES (71833, '64.80.15668667153576017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:15', 2, 0, '', '2019-08-27 08:45:15');
INSERT INTO `access_log` VALUES (71834, '59.79.15668667165055621', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:17', 2, 0, '', '2019-08-27 08:45:17');
INSERT INTO `access_log` VALUES (71835, '59.77.15668667165035607', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:17', 17, 2001001000, '服务端发生异常', '2019-08-27 08:45:17');
INSERT INTO `access_log` VALUES (71836, '59.74.15668667192975633', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:19', 3, 0, '', '2019-08-27 08:45:19');
INSERT INTO `access_log` VALUES (71837, '59.71.15668667192985619', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:19', 10, 2001001000, '服务端发生异常', '2019-08-27 08:45:19');
INSERT INTO `access_log` VALUES (71838, '64.84.15668667214796015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:21', 2, 0, '', '2019-08-27 08:45:21');
INSERT INTO `access_log` VALUES (71839, '64.77.15668667217896001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:22', 2, 0, '', '2019-08-27 08:45:22');
INSERT INTO `access_log` VALUES (71840, '59.73.15668667231745623', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:23', 2, 0, '', '2019-08-27 08:45:23');
INSERT INTO `access_log` VALUES (71841, '59.72.15668667231755621', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.0zh-cn; ONEPLUS A6000 Build/PKQ1.180716.001) AppleWebKit/537.36 (KHTML, like Gecko)Version/4.0 Chrome/57.0.2987.132 MQQBrowser/8.1 Mobile Safari/537.36', '117.136.79.141', '2019-08-27 08:45:23', 28, 2001001000, '服务端发生异常', '2019-08-27 08:45:23');
INSERT INTO `access_log` VALUES (71842, '65.51.15668667547478975', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '39.176.195.5', '2019-08-27 08:45:55', 0, 1002001015, '账号未登陆', '2019-08-27 08:45:55');
INSERT INTO `access_log` VALUES (71843, '65.45.15668667547478949', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '39.176.195.5', '2019-08-27 08:45:55', 0, 1002001015, '账号未登陆', '2019-08-27 08:45:55');
INSERT INTO `access_log` VALUES (71844, '65.3607.15668667647380727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '39.176.195.5', '2019-08-27 08:46:05', 103, 0, '', '2019-08-27 08:46:05');
INSERT INTO `access_log` VALUES (71845, '65.46.15668667654728945', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '39.176.195.5', '2019-08-27 08:46:05', 11, 0, '', '2019-08-27 08:46:05');
INSERT INTO `access_log` VALUES (71846, '65.53.15668667654828865', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '39.176.195.5', '2019-08-27 08:46:05', 9, 0, '', '2019-08-27 08:46:05');
INSERT INTO `access_log` VALUES (71847, '65.49.15668667654828931', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '39.176.195.5', '2019-08-27 08:46:05', 10, 2001001000, '服务端发生异常', '2019-08-27 08:46:05');
INSERT INTO `access_log` VALUES (71848, '65.50.15668667742208919', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '39.176.195.5', '2019-08-27 08:46:14', 9, 0, '', '2019-08-27 08:46:14');
INSERT INTO `access_log` VALUES (71849, '65.47.15668667742528859', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '39.176.195.5', '2019-08-27 08:46:14', 10, 0, '', '2019-08-27 08:46:14');
INSERT INTO `access_log` VALUES (71850, '65.54.15668667742518813', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '39.176.195.5', '2019-08-27 08:46:14', 10, 2001001000, '服务端发生异常', '2019-08-27 08:46:14');
INSERT INTO `access_log` VALUES (71851, '65.45.15668667922908951', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '39.176.195.5', '2019-08-27 08:46:32', 8, 0, '', '2019-08-27 08:46:32');
INSERT INTO `access_log` VALUES (71852, '65.3607.15668667922920729', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '39.176.195.5', '2019-08-27 08:46:32', 10, 2001001000, '服务端发生异常', '2019-08-27 08:46:32');
INSERT INTO `access_log` VALUES (71853, '65.46.15668667926008947', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:66.0) Gecko/20100101 Firefox/66.0', '39.176.195.5', '2019-08-27 08:46:33', 10, 0, '', '2019-08-27 08:46:33');
INSERT INTO `access_log` VALUES (71854, '59.71.15668690887955651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.244.81.195', '2019-08-27 09:24:49', 11, 0, '', '2019-08-27 09:24:49');
INSERT INTO `access_log` VALUES (71855, '59.73.15668690888005655', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.244.81.195', '2019-08-27 09:24:49', 16, 2001001000, '服务端发生异常', '2019-08-27 09:24:49');
INSERT INTO `access_log` VALUES (71856, '64.84.15668690973646047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.244.81.195', '2019-08-27 09:24:57', 13, 0, '', '2019-08-27 09:24:57');
INSERT INTO `access_log` VALUES (71857, '64.77.15668690974916033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.244.81.195', '2019-08-27 09:24:57', 4, 0, '', '2019-08-27 09:24:57');
INSERT INTO `access_log` VALUES (71858, '64.78.15668690987986071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.244.81.195', '2019-08-27 09:24:59', 2, 0, '', '2019-08-27 09:24:59');
INSERT INTO `access_log` VALUES (71859, '64.83.15668690993816047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.244.81.195', '2019-08-27 09:24:59', 1, 0, '', '2019-08-27 09:24:59');
INSERT INTO `access_log` VALUES (71860, '64.85.15668690998946071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.244.81.195', '2019-08-27 09:25:00', 2, 0, '', '2019-08-27 09:25:00');
INSERT INTO `access_log` VALUES (71861, '65.51.15668692848649011', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '182.40.205.9', '2019-08-27 09:28:05', 6, 1002001012, '访问令牌已过期', '2019-08-27 09:28:05');
INSERT INTO `access_log` VALUES (71862, '65.45.15668692848648985', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '182.40.205.9', '2019-08-27 09:28:05', 5, 1002001012, '访问令牌已过期', '2019-08-27 09:28:05');
INSERT INTO `access_log` VALUES (71863, '65.3607.15668692848660763', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '182.40.200.124', '2019-08-27 09:28:05', 5, 1002001012, '访问令牌已过期', '2019-08-27 09:28:05');
INSERT INTO `access_log` VALUES (71864, '65.46.15668692866928981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '182.40.205.9', '2019-08-27 09:28:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 09:28:07');
INSERT INTO `access_log` VALUES (71865, '65.52.15668693047858997', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '182.40.205.9', '2019-08-27 09:28:25', 89, 0, '', '2019-08-27 09:28:25');
INSERT INTO `access_log` VALUES (71866, '65.50.15668693051308955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '182.40.205.9', '2019-08-27 09:28:25', 194, 0, '', '2019-08-27 09:28:25');
INSERT INTO `access_log` VALUES (71867, '65.54.15668693051628849', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '182.40.200.124', '2019-08-27 09:28:25', 163, 0, '', '2019-08-27 09:28:25');
INSERT INTO `access_log` VALUES (71868, '65.47.15668693051308895', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '182.40.205.9', '2019-08-27 09:28:25', 195, 2001001000, '服务端发生异常', '2019-08-27 09:28:25');
INSERT INTO `access_log` VALUES (71869, '59.73.15668698231865665', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.192.217.48', '2019-08-27 09:37:03', 4, 0, '', '2019-08-27 09:37:03');
INSERT INTO `access_log` VALUES (71870, '59.72.15668698231935663', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.192.217.48', '2019-08-27 09:37:03', 15, 2001001000, '服务端发生异常', '2019-08-27 09:37:03');
INSERT INTO `access_log` VALUES (71871, '64.85.15668698262786081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.192.217.48', '2019-08-27 09:37:06', 3, 0, '', '2019-08-27 09:37:06');
INSERT INTO `access_log` VALUES (71872, '64.76.15668698264276067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.192.217.48', '2019-08-27 09:37:06', 2, 0, '', '2019-08-27 09:37:06');
INSERT INTO `access_log` VALUES (71873, '64.81.15668698292526063', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.192.217.48', '2019-08-27 09:37:09', 2, 0, '', '2019-08-27 09:37:09');
INSERT INTO `access_log` VALUES (71874, '64.82.15668698294246075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '1.192.217.48', '2019-08-27 09:37:09', 2, 0, '', '2019-08-27 09:37:09');
INSERT INTO `access_log` VALUES (71875, '65.53.15668701410228913', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:42:21', 1, 1002001015, '账号未登陆', '2019-08-27 09:42:21');
INSERT INTO `access_log` VALUES (71876, '65.51.15668701410299025', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:42:21', 0, 1002001015, '账号未登陆', '2019-08-27 09:42:21');
INSERT INTO `access_log` VALUES (71877, '65.45.15668701410298999', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:42:21', 0, 1002001015, '账号未登陆', '2019-08-27 09:42:21');
INSERT INTO `access_log` VALUES (71878, '65.52.15668701518189011', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:42:32', 60, 0, '', '2019-08-27 09:42:32');
INSERT INTO `access_log` VALUES (71879, '65.54.15668701521328863', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:42:32', 15, 0, '', '2019-08-27 09:42:32');
INSERT INTO `access_log` VALUES (71880, '65.47.15668701521348909', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:42:32', 13, 2001001000, '服务端发生异常', '2019-08-27 09:42:32');
INSERT INTO `access_log` VALUES (71881, '65.50.15668701521388967', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:42:32', 15, 0, '', '2019-08-27 09:42:32');
INSERT INTO `access_log` VALUES (71882, '65.46.15668701666988997', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:42:47', 9, 0, '', '2019-08-27 09:42:47');
INSERT INTO `access_log` VALUES (71883, '65.53.15668701667058915', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:42:47', 10, 2001001000, '服务端发生异常', '2019-08-27 09:42:47');
INSERT INTO `access_log` VALUES (71884, '65.45.15668701667089001', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:42:47', 10, 0, '', '2019-08-27 09:42:47');
INSERT INTO `access_log` VALUES (71885, '65.51.15668701733069027', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:42:53', 9, 0, '', '2019-08-27 09:42:53');
INSERT INTO `access_log` VALUES (71886, '65.49.15668701733108983', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:42:53', 9, 2001001000, '服务端发生异常', '2019-08-27 09:42:53');
INSERT INTO `access_log` VALUES (71887, '65.52.15668701733179013', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:42:53', 9, 0, '', '2019-08-27 09:42:53');
INSERT INTO `access_log` VALUES (71888, '65.45.15668702193299003', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:43:39', 1, 1002001015, '账号未登陆', '2019-08-27 09:43:39');
INSERT INTO `access_log` VALUES (71889, '65.46.15668702254498999', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:43:45', 0, 1002001015, '账号未登陆', '2019-08-27 09:43:45');
INSERT INTO `access_log` VALUES (71890, '65.49.15668702364888985', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:43:56', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 09:43:57');
INSERT INTO `access_log` VALUES (71891, '59.72.15668702425285669', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.248.34', '2019-08-27 09:44:03', 3, 0, '', '2019-08-27 09:44:03');
INSERT INTO `access_log` VALUES (71892, '59.73.15668702425285671', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.248.34', '2019-08-27 09:44:03', 11, 2001001000, '服务端发生异常', '2019-08-27 09:44:03');
INSERT INTO `access_log` VALUES (71893, '65.51.15668702485549029', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=youdaoyuanma&password=youdaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:44:09', 4, 1002002000, '账号不存在', '2019-08-27 09:44:09');
INSERT INTO `access_log` VALUES (71894, '59.76.15668702524235659', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.85.248.34', '2019-08-27 09:44:12', 3, 0, '', '2019-08-27 09:44:12');
INSERT INTO `access_log` VALUES (71895, '59.80.15668702524335641', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.85.248.34', '2019-08-27 09:44:12', 13, 2001001000, '服务端发生异常', '2019-08-27 09:44:12');
INSERT INTO `access_log` VALUES (71896, '64.81.15668702566436069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.85.248.34', '2019-08-27 09:44:17', 2, 0, '', '2019-08-27 09:44:17');
INSERT INTO `access_log` VALUES (71897, '64.82.15668702571306081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.85.248.34', '2019-08-27 09:44:17', 1, 0, '', '2019-08-27 09:44:17');
INSERT INTO `access_log` VALUES (71898, '65.54.15668702582038867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:44:18', 76, 0, '', '2019-08-27 09:44:18');
INSERT INTO `access_log` VALUES (71899, '65.50.15668702584778971', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:44:18', 10, 0, '', '2019-08-27 09:44:18');
INSERT INTO `access_log` VALUES (71900, '65.47.15668702584798913', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:44:18', 9, 2001001000, '服务端发生异常', '2019-08-27 09:44:18');
INSERT INTO `access_log` VALUES (71901, '65.3607.15668702584820779', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:44:18', 8, 0, '', '2019-08-27 09:44:18');
INSERT INTO `access_log` VALUES (71902, '64.79.15668702609966067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.85.248.34', '2019-08-27 09:44:21', 2, 0, '', '2019-08-27 09:44:21');
INSERT INTO `access_log` VALUES (71903, '64.84.15668702613646065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.85.248.34', '2019-08-27 09:44:21', 1, 0, '', '2019-08-27 09:44:21');
INSERT INTO `access_log` VALUES (71904, '59.77.15668702708475657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.85.248.34', '2019-08-27 09:44:31', 2, 0, '', '2019-08-27 09:44:31');
INSERT INTO `access_log` VALUES (71905, '59.78.15668702708475681', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '120.85.248.34', '2019-08-27 09:44:31', 13, 2001001000, '服务端发生异常', '2019-08-27 09:44:31');
INSERT INTO `access_log` VALUES (71906, '59.71.15668702747365669', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:44:35', 2, 0, '', '2019-08-27 09:44:35');
INSERT INTO `access_log` VALUES (71907, '59.72.15668702747485671', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:44:35', 13, 2001001000, '服务端发生异常', '2019-08-27 09:44:35');
INSERT INTO `access_log` VALUES (71908, '59.75.15668702823945677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:44:42', 2, 0, '', '2019-08-27 09:44:42');
INSERT INTO `access_log` VALUES (71909, '59.73.15668702823905673', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:44:42', 27, 2001001000, '服务端发生异常', '2019-08-27 09:44:42');
INSERT INTO `access_log` VALUES (71910, '59.80.15668702892695643', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:44:49', 2, 0, '', '2019-08-27 09:44:49');
INSERT INTO `access_log` VALUES (71911, '59.79.15668702892735673', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-08-27 09:44:49', 31, 2001001000, '服务端发生异常', '2019-08-27 09:44:49');
INSERT INTO `access_log` VALUES (71912, '59.78.15668702926455683', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.248.34', '2019-08-27 09:44:53', 2, 0, '', '2019-08-27 09:44:53');
INSERT INTO `access_log` VALUES (71913, '59.77.15668702926555659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.248.34', '2019-08-27 09:44:53', 13, 2001001000, '服务端发生异常', '2019-08-27 09:44:53');
INSERT INTO `access_log` VALUES (71914, '65.49.15668703020028987', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.248.34', '2019-08-27 09:45:02', 1, 1002001015, '账号未登陆', '2019-08-27 09:45:02');
INSERT INTO `access_log` VALUES (71915, '65.51.15668703020079031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.248.34', '2019-08-27 09:45:02', 0, 1002001015, '账号未登陆', '2019-08-27 09:45:02');
INSERT INTO `access_log` VALUES (71916, '65.52.15668703020099017', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.85.248.34', '2019-08-27 09:45:02', 0, 1002001015, '账号未登陆', '2019-08-27 09:45:02');
INSERT INTO `access_log` VALUES (71917, '65.53.15668713462158933', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-27 10:02:26', 3, 1002001012, '访问令牌已过期', '2019-08-27 10:02:26');
INSERT INTO `access_log` VALUES (71918, '65.51.15668713462159047', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-27 10:02:26', 3, 1002001012, '访问令牌已过期', '2019-08-27 10:02:26');
INSERT INTO `access_log` VALUES (71919, '65.49.15668713462169001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-27 10:02:26', 3, 1002001012, '访问令牌已过期', '2019-08-27 10:02:26');
INSERT INTO `access_log` VALUES (71920, '65.52.15668713501659031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-27 10:02:30', 86, 0, '', '2019-08-27 10:02:30');
INSERT INTO `access_log` VALUES (71921, '65.54.15668713506278885', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-27 10:02:31', 9, 0, '', '2019-08-27 10:02:31');
INSERT INTO `access_log` VALUES (71922, '65.47.15668713506328931', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-27 10:02:31', 16, 2001001000, '服务端发生异常', '2019-08-27 10:02:31');
INSERT INTO `access_log` VALUES (71923, '65.3607.15668713506820797', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-08-27 10:02:31', 9, 0, '', '2019-08-27 10:02:31');
INSERT INTO `access_log` VALUES (71924, '65.3607.15668749995870845', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.74.147.82', '2019-08-27 11:03:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 11:03:20');
INSERT INTO `access_log` VALUES (71925, '65.47.15668750010198981', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.74.147.82', '2019-08-27 11:03:21', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 11:03:21');
INSERT INTO `access_log` VALUES (71926, '65.46.15668753134599073', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.167.18', '2019-08-27 11:08:33', 0, 1002001015, '账号未登陆', '2019-08-27 11:08:33');
INSERT INTO `access_log` VALUES (71927, '65.45.15668753134599077', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.167.18', '2019-08-27 11:08:33', 0, 1002001015, '账号未登陆', '2019-08-27 11:08:33');
INSERT INTO `access_log` VALUES (71928, '65.51.15668753134609103', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.167.18', '2019-08-27 11:08:33', 0, 1002001015, '账号未登陆', '2019-08-27 11:08:33');
INSERT INTO `access_log` VALUES (71929, '65.49.15668753163719057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.167.18', '2019-08-27 11:08:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 11:08:36');
INSERT INTO `access_log` VALUES (71930, '59.71.15668755592775741', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.167.18', '2019-08-27 11:12:39', 10, 0, '', '2019-08-27 11:12:39');
INSERT INTO `access_log` VALUES (71931, '59.72.15668755592785743', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.167.18', '2019-08-27 11:12:39', 15, 2001001000, '服务端发生异常', '2019-08-27 11:12:39');
INSERT INTO `access_log` VALUES (71932, '59.75.15668755637095749', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.167.18', '2019-08-27 11:12:44', 2, 0, '', '2019-08-27 11:12:44');
INSERT INTO `access_log` VALUES (71933, '59.73.15668755637105745', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.167.18', '2019-08-27 11:12:44', 21, 2001001000, '服务端发生异常', '2019-08-27 11:12:44');
INSERT INTO `access_log` VALUES (71934, '59.80.15668755639905715', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.74.147.82', '2019-08-27 11:12:44', 2, 0, '', '2019-08-27 11:12:44');
INSERT INTO `access_log` VALUES (71935, '59.76.15668755639895733', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.74.147.82', '2019-08-27 11:12:44', 12, 2001001000, '服务端发生异常', '2019-08-27 11:12:44');
INSERT INTO `access_log` VALUES (71936, '65.53.15668758502958997', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '221.216.205.78', '2019-08-27 11:17:30', 0, 1002001015, '账号未登陆', '2019-08-27 11:17:30');
INSERT INTO `access_log` VALUES (71937, '65.54.15668758503008949', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '221.216.205.78', '2019-08-27 11:17:30', 0, 1002001015, '账号未登陆', '2019-08-27 11:17:30');
INSERT INTO `access_log` VALUES (71938, '65.47.15668758503098995', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '221.216.205.78', '2019-08-27 11:17:30', 1, 1002001015, '账号未登陆', '2019-08-27 11:17:30');
INSERT INTO `access_log` VALUES (71939, '65.52.15668758525759095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '221.216.205.78', '2019-08-27 11:17:33', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 11:17:33');
INSERT INTO `access_log` VALUES (71940, '65.50.15668758616079053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '221.216.205.78', '2019-08-27 11:17:42', 62, 0, '', '2019-08-27 11:17:42');
INSERT INTO `access_log` VALUES (71941, '65.45.15668758619999087', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '221.216.205.78', '2019-08-27 11:17:42', 12, 0, '', '2019-08-27 11:17:42');
INSERT INTO `access_log` VALUES (71942, '65.46.15668758620019083', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '221.216.205.78', '2019-08-27 11:17:42', 15, 2001001000, '服务端发生异常', '2019-08-27 11:17:42');
INSERT INTO `access_log` VALUES (71943, '65.49.15668758620019065', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '221.216.205.78', '2019-08-27 11:17:42', 12, 0, '', '2019-08-27 11:17:42');
INSERT INTO `access_log` VALUES (71944, '59.73.15668759674315751', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '221.216.205.78', '2019-08-27 11:19:27', 3, 0, '', '2019-08-27 11:19:27');
INSERT INTO `access_log` VALUES (71945, '59.76.15668759676085739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '221.216.205.78', '2019-08-27 11:19:28', 13, 2001001000, '服务端发生异常', '2019-08-27 11:19:28');
INSERT INTO `access_log` VALUES (71946, '65.53.15668761790729003', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.179.228', '2019-08-27 11:22:59', 1, 1002001015, '账号未登陆', '2019-08-27 11:22:59');
INSERT INTO `access_log` VALUES (71947, '65.54.15668761790808955', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.179.228', '2019-08-27 11:22:59', 0, 1002001015, '账号未登陆', '2019-08-27 11:22:59');
INSERT INTO `access_log` VALUES (71948, '65.47.15668761790849001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.179.228', '2019-08-27 11:22:59', 0, 1002001015, '账号未登陆', '2019-08-27 11:22:59');
INSERT INTO `access_log` VALUES (71949, '65.50.15668762161839059', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.179.228', '2019-08-27 11:23:36', 80, 0, '', '2019-08-27 11:23:36');
INSERT INTO `access_log` VALUES (71950, '65.49.15668762165519071', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.179.228', '2019-08-27 11:23:37', 20, 0, '', '2019-08-27 11:23:37');
INSERT INTO `access_log` VALUES (71951, '65.46.15668762165629089', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.179.228', '2019-08-27 11:23:37', 10, 0, '', '2019-08-27 11:23:37');
INSERT INTO `access_log` VALUES (71952, '65.45.15668762165629093', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.179.228', '2019-08-27 11:23:37', 13, 2001001000, '服务端发生异常', '2019-08-27 11:23:37');
INSERT INTO `access_log` VALUES (71953, '65.53.15668762427959005', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.179.228', '2019-08-27 11:24:03', 10, 0, '', '2019-08-27 11:24:03');
INSERT INTO `access_log` VALUES (71954, '65.47.15668762428019003', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.179.228', '2019-08-27 11:24:03', 9, 2001001000, '服务端发生异常', '2019-08-27 11:24:03');
INSERT INTO `access_log` VALUES (71955, '65.52.15668762428059103', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.179.228', '2019-08-27 11:24:03', 8, 0, '', '2019-08-27 11:24:03');
INSERT INTO `access_log` VALUES (71956, '65.3607.15668762460890867', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.179.228', '2019-08-27 11:24:06', 7, 0, '', '2019-08-27 11:24:06');
INSERT INTO `access_log` VALUES (71957, '65.45.15668762460989095', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.179.228', '2019-08-27 11:24:06', 8, 0, '', '2019-08-27 11:24:06');
INSERT INTO `access_log` VALUES (71958, '65.50.15668762460989061', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '27.18.179.228', '2019-08-27 11:24:06', 9, 2001001000, '服务端发生异常', '2019-08-27 11:24:06');
INSERT INTO `access_log` VALUES (71959, '65.52.15668767618829111', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.171.181.239', '2019-08-27 11:32:42', 1, 1002001015, '账号未登陆', '2019-08-27 11:32:42');
INSERT INTO `access_log` VALUES (71960, '65.47.15668767618829011', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.171.181.239', '2019-08-27 11:32:42', 0, 1002001015, '账号未登陆', '2019-08-27 11:32:42');
INSERT INTO `access_log` VALUES (71961, '65.45.15668767619609103', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.171.181.239', '2019-08-27 11:32:42', 0, 1002001015, '账号未登陆', '2019-08-27 11:32:42');
INSERT INTO `access_log` VALUES (71962, '65.46.15668767975949099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.171.181.239', '2019-08-27 11:33:18', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 11:33:18');
INSERT INTO `access_log` VALUES (71963, '65.51.15668768116229127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.171.181.239', '2019-08-27 11:33:32', 77, 0, '', '2019-08-27 11:33:32');
INSERT INTO `access_log` VALUES (71964, '65.54.15668768123848967', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.171.181.239', '2019-08-27 11:33:32', 101, 0, '', '2019-08-27 11:33:32');
INSERT INTO `access_log` VALUES (71965, '65.52.15668768123939113', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.171.181.239', '2019-08-27 11:33:32', 95, 0, '', '2019-08-27 11:33:32');
INSERT INTO `access_log` VALUES (71966, '65.53.15668768123889015', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.171.181.239', '2019-08-27 11:33:32', 101, 2001001000, '服务端发生异常', '2019-08-27 11:33:32');
INSERT INTO `access_log` VALUES (71967, 'f97c3f55-85f6-4abe-81d8-74fdcb0d6925', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:12:28', 3829, 0, '', '2019-08-27 12:12:32');
INSERT INTO `access_log` VALUES (71968, '365054f3-0acf-408f-8b04-7cc62a4ba398', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:12:28', 3760, 2001001000, '服务端发生异常', '2019-08-27 12:12:32');
INSERT INTO `access_log` VALUES (71969, 'd7032474-9d4a-4aea-ad1d-c69e9250e623', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:13:39', 281, 0, '', '2019-08-27 12:13:39');
INSERT INTO `access_log` VALUES (71970, '33294d2c-9f63-4dd5-aebc-6b5392ec57cb', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:13:39', 354, 2001001000, '服务端发生异常', '2019-08-27 12:13:39');
INSERT INTO `access_log` VALUES (71971, '502ae46c-00a9-433f-bb7b-d67b58b69b61', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:13:39', 745, 0, '', '2019-08-27 12:13:40');
INSERT INTO `access_log` VALUES (71972, 'c3b6cd90-df7f-4daa-bd32-bd6debcfb779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:13:40', 38, 0, '', '2019-08-27 12:13:40');
INSERT INTO `access_log` VALUES (71973, '7c888278-7d90-45c9-b625-b76e033f63d2', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:14:30', 667, 0, '', '2019-08-27 12:14:31');
INSERT INTO `access_log` VALUES (71974, 'd7b0f3d4-2c40-47a8-8692-47a9c6bb3c89', 0, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=31', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:14:33', 1446, 0, '', '2019-08-27 12:14:35');
INSERT INTO `access_log` VALUES (71975, '279ef7b9-2b65-4005-b678-801b817e62da', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:14:39', 131, 0, '', '2019-08-27 12:14:39');
INSERT INTO `access_log` VALUES (71976, '6bd1aced-f94d-4810-8574-3b7f9a1b54aa', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:14:39', 173, 2001001000, '服务端发生异常', '2019-08-27 12:14:39');
INSERT INTO `access_log` VALUES (71977, '4bd8dc61-f10d-44f7-aab6-c97c54898d4f', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:15:02', 192, 0, '', '2019-08-27 12:15:02');
INSERT INTO `access_log` VALUES (71978, 'f16c1a37-fe26-4387-a98c-b738596aba09', 0, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=36', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:15:02', 76, 0, '', '2019-08-27 12:15:02');
INSERT INTO `access_log` VALUES (71979, '4d0313dd-fdb7-47a2-9a60-2ed6ce71a89f', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:15:12', 83, 0, '', '2019-08-27 12:15:12');
INSERT INTO `access_log` VALUES (71980, 'fb310e22-9fba-4eb7-a4fe-9ff83ca2e6f2', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:15:12', 968, 2001001000, '服务端发生异常', '2019-08-27 12:15:13');
INSERT INTO `access_log` VALUES (71981, '65.50.15668822998379147', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '118.186.226.226', '2019-08-27 13:05:00', 24, 1002001012, '访问令牌已过期', '2019-08-27 13:05:00');
INSERT INTO `access_log` VALUES (71982, '65.54.15668822998369041', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '118.186.226.226', '2019-08-27 13:05:00', 19, 1002001012, '访问令牌已过期', '2019-08-27 13:05:00');
INSERT INTO `access_log` VALUES (71983, '65.46.15668822998549177', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '118.186.226.226', '2019-08-27 13:05:00', 3, 1002001012, '访问令牌已过期', '2019-08-27 13:05:00');
INSERT INTO `access_log` VALUES (71984, '65.3607.15668823021870949', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '118.186.226.226', '2019-08-27 13:05:02', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 13:05:02');
INSERT INTO `access_log` VALUES (71985, '65.49.15668823053219157', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '118.186.226.226', '2019-08-27 13:05:05', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 13:05:05');
INSERT INTO `access_log` VALUES (71986, '59.72.15668853407015875', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:41', 10, 0, '', '2019-08-27 13:55:41');
INSERT INTO `access_log` VALUES (71987, '59.71.15668853407015873', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:41', 16, 2001001000, '服务端发生异常', '2019-08-27 13:55:41');
INSERT INTO `access_log` VALUES (71988, '59.75.15668853408465881', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:41', 3, 0, '', '2019-08-27 13:55:41');
INSERT INTO `access_log` VALUES (71989, '59.73.15668853408465877', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:41', 13, 2001001000, '服务端发生异常', '2019-08-27 13:55:41');
INSERT INTO `access_log` VALUES (71990, '64.82.15668853442696283', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:44', 12, 0, '', '2019-08-27 13:55:44');
INSERT INTO `access_log` VALUES (71991, '64.84.15668853444926265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:44', 5, 0, '', '2019-08-27 13:55:45');
INSERT INTO `access_log` VALUES (71992, '64.83.15668853445016269', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:45', 5, 0, '', '2019-08-27 13:55:45');
INSERT INTO `access_log` VALUES (71993, '64.78.15668853446716293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:45', 2, 0, '', '2019-08-27 13:55:45');
INSERT INTO `access_log` VALUES (71994, '64.77.15668853458346253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:46', 1, 0, '', '2019-08-27 13:55:46');
INSERT INTO `access_log` VALUES (71995, '64.85.15668853459456291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:46', 3, 0, '', '2019-08-27 13:55:46');
INSERT INTO `access_log` VALUES (71996, '64.76.15668853463016277', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:46', 2, 0, '', '2019-08-27 13:55:46');
INSERT INTO `access_log` VALUES (71997, '64.80.15668853466016273', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:47', 2, 0, '', '2019-08-27 13:55:47');
INSERT INTO `access_log` VALUES (71998, '64.81.15668853506916275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:51', 2, 0, '', '2019-08-27 13:55:51');
INSERT INTO `access_log` VALUES (71999, '64.82.15668853507546285', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:51', 2, 0, '', '2019-08-27 13:55:51');
INSERT INTO `access_log` VALUES (72000, '64.84.15668853507606267', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:51', 2, 0, '', '2019-08-27 13:55:51');
INSERT INTO `access_log` VALUES (72001, '64.83.15668853508396271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:55:51', 2, 0, '', '2019-08-27 13:55:51');
INSERT INTO `access_log` VALUES (72002, '64.85.15668853848656293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.156.7.144', '2019-08-27 13:56:25', 2, 0, '', '2019-08-27 13:56:25');
INSERT INTO `access_log` VALUES (72003, '64.76.15668853850186279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:56:25', 2, 0, '', '2019-08-27 13:56:25');
INSERT INTO `access_log` VALUES (72004, '64.80.15668853850256275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.156.7.144', '2019-08-27 13:56:25', 1, 0, '', '2019-08-27 13:56:25');
INSERT INTO `access_log` VALUES (72005, '64.79.15668853851576275', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:56:25', 2, 0, '', '2019-08-27 13:56:25');
INSERT INTO `access_log` VALUES (72006, '59.78.15668853875575887', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.156.7.144', '2019-08-27 13:56:28', 2, 0, '', '2019-08-27 13:56:28');
INSERT INTO `access_log` VALUES (72007, '59.77.15668853875575863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.156.7.144', '2019-08-27 13:56:28', 18, 2001001000, '服务端发生异常', '2019-08-27 13:56:28');
INSERT INTO `access_log` VALUES (72008, '59.72.15668853876545877', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:56:28', 2, 0, '', '2019-08-27 13:56:28');
INSERT INTO `access_log` VALUES (72009, '59.74.15668853876545889', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:56:28', 12, 2001001000, '服务端发生异常', '2019-08-27 13:56:28');
INSERT INTO `access_log` VALUES (72010, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.156.7.144', '2019-08-27 13:56:39', 14, 0, '', '2019-08-27 13:56:39');
INSERT INTO `access_log` VALUES (72011, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:56:39', 5, 0, '', '2019-08-27 13:56:39');
INSERT INTO `access_log` VALUES (72012, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.156.7.144', '2019-08-27 13:56:39', 4, 0, '', '2019-08-27 13:56:39');
INSERT INTO `access_log` VALUES (72013, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.156.7.144', '2019-08-27 13:56:39', 15, 0, '', '2019-08-27 13:56:39');
INSERT INTO `access_log` VALUES (72014, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:56:39', 4, 0, '', '2019-08-27 13:56:39');
INSERT INTO `access_log` VALUES (72015, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.156.7.144', '2019-08-27 13:56:39', 11, 0, '', '2019-08-27 13:56:39');
INSERT INTO `access_log` VALUES (72016, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:56:39', 9, 0, '', '2019-08-27 13:56:39');
INSERT INTO `access_log` VALUES (72017, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.156.7.144', '2019-08-27 13:56:40', 10, 0, '', '2019-08-27 13:56:40');
INSERT INTO `access_log` VALUES (72018, '65.45.15668862499219231', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.175.73.95', '2019-08-27 14:10:50', 0, 1002001015, '账号未登陆', '2019-08-27 14:10:50');
INSERT INTO `access_log` VALUES (72019, '65.50.15668862499239201', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.175.73.95', '2019-08-27 14:10:50', 0, 1002001015, '账号未登陆', '2019-08-27 14:10:50');
INSERT INTO `access_log` VALUES (72020, '65.52.15668862499239245', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.175.73.95', '2019-08-27 14:10:50', 0, 1002001015, '账号未登陆', '2019-08-27 14:10:50');
INSERT INTO `access_log` VALUES (72021, '65.46.15668862517799231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.175.73.95', '2019-08-27 14:10:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 14:10:52');
INSERT INTO `access_log` VALUES (72022, '65.3607.15668862539941003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.175.73.95', '2019-08-27 14:10:54', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 14:10:54');
INSERT INTO `access_log` VALUES (72023, '59.74.15668862594575901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.175.73.95', '2019-08-27 14:10:59', 5, 0, '', '2019-08-27 14:10:59');
INSERT INTO `access_log` VALUES (72024, '59.72.15668862594575889', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '180.175.73.95', '2019-08-27 14:10:59', 12, 2001001000, '服务端发生异常', '2019-08-27 14:10:59');
INSERT INTO `access_log` VALUES (72025, '59.73.15668862705045891', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '180.175.73.95', '2019-08-27 14:11:11', 10, 2001001000, '服务端发生异常', '2019-08-27 14:11:11');
INSERT INTO `access_log` VALUES (72026, '59.75.15668862705045895', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '180.175.73.95', '2019-08-27 14:11:11', 28, 0, '', '2019-08-27 14:11:11');
INSERT INTO `access_log` VALUES (72027, '59.79.15668872038055903', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.48', '2019-08-27 14:26:44', 3, 0, '', '2019-08-27 14:26:44');
INSERT INTO `access_log` VALUES (72028, '59.77.15668872038055889', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3738.400', '223.104.3.48', '2019-08-27 14:26:44', 13, 2001001000, '服务端发生异常', '2019-08-27 14:26:44');
INSERT INTO `access_log` VALUES (72029, '59.76.15668872965065893', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.212.186.221', '2019-08-27 14:28:17', 2, 0, '', '2019-08-27 14:28:17');
INSERT INTO `access_log` VALUES (72030, '59.80.15668872965115875', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.212.186.221', '2019-08-27 14:28:17', 19, 2001001000, '服务端发生异常', '2019-08-27 14:28:17');
INSERT INTO `access_log` VALUES (72031, '65.49.15668873030409225', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.212.186.221', '2019-08-27 14:28:23', 0, 1002001015, '账号未登陆', '2019-08-27 14:28:23');
INSERT INTO `access_log` VALUES (72032, '65.3607.15668873030401017', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.212.186.221', '2019-08-27 14:28:23', 0, 1002001015, '账号未登陆', '2019-08-27 14:28:23');
INSERT INTO `access_log` VALUES (72033, '65.51.15668873030419271', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.212.186.221', '2019-08-27 14:28:23', 1, 1002001015, '账号未登陆', '2019-08-27 14:28:23');
INSERT INTO `access_log` VALUES (72034, '65.47.15668873047719155', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.212.186.221', '2019-08-27 14:28:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 14:28:25');
INSERT INTO `access_log` VALUES (72035, '65.50.15668873130149217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.212.186.221', '2019-08-27 14:28:33', 66, 0, '', '2019-08-27 14:28:33');
INSERT INTO `access_log` VALUES (72036, '65.45.15668873133499247', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.212.186.221', '2019-08-27 14:28:33', 23, 0, '', '2019-08-27 14:28:33');
INSERT INTO `access_log` VALUES (72037, '65.52.15668873133569261', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.212.186.221', '2019-08-27 14:28:33', 28, 2001001000, '服务端发生异常', '2019-08-27 14:28:33');
INSERT INTO `access_log` VALUES (72038, '65.46.15668873133739247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.212.186.221', '2019-08-27 14:28:33', 13, 0, '', '2019-08-27 14:28:33');
INSERT INTO `access_log` VALUES (72039, '59.79.15668878751905913', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.61.156', '2019-08-27 14:37:55', 13, 2001001000, '服务端发生异常', '2019-08-27 14:37:55');
INSERT INTO `access_log` VALUES (72040, '59.76.15668878751895901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.61.156', '2019-08-27 14:37:55', 193, 0, '', '2019-08-27 14:37:55');
INSERT INTO `access_log` VALUES (72041, '64.78.15668878776196331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.61.156', '2019-08-27 14:37:58', 11, 0, '', '2019-08-27 14:37:58');
INSERT INTO `access_log` VALUES (72042, '64.77.15668878777996289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.61.156', '2019-08-27 14:37:58', 3, 0, '', '2019-08-27 14:37:58');
INSERT INTO `access_log` VALUES (72043, '59.77.15668878793795899', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.61.156', '2019-08-27 14:37:59', 2, 0, '', '2019-08-27 14:37:59');
INSERT INTO `access_log` VALUES (72044, '59.78.15668878793805923', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.65.61.156', '2019-08-27 14:37:59', 12, 2001001000, '服务端发生异常', '2019-08-27 14:37:59');
INSERT INTO `access_log` VALUES (72045, '59.77.15668885995175909', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '115.236.71.65', '2019-08-27 14:50:00', 3, 0, '', '2019-08-27 14:50:00');
INSERT INTO `access_log` VALUES (72046, '59.78.15668885995185933', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '115.236.71.65', '2019-08-27 14:50:00', 13, 2001001000, '服务端发生异常', '2019-08-27 14:50:00');
INSERT INTO `access_log` VALUES (72047, '64.78.15668886050936341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '115.236.71.65', '2019-08-27 14:50:05', 3, 0, '', '2019-08-27 14:50:05');
INSERT INTO `access_log` VALUES (72048, '64.77.15668886051676299', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '115.236.71.65', '2019-08-27 14:50:05', 2, 0, '', '2019-08-27 14:50:05');
INSERT INTO `access_log` VALUES (72049, '64.85.15668886072256339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '115.236.71.65', '2019-08-27 14:50:07', 2, 0, '', '2019-08-27 14:50:07');
INSERT INTO `access_log` VALUES (72050, '64.79.15668886080976321', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '115.236.71.65', '2019-08-27 14:50:08', 1, 0, '', '2019-08-27 14:50:08');
INSERT INTO `access_log` VALUES (72051, '59.71.15668886199745921', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '115.236.71.65', '2019-08-27 14:50:20', 2, 0, '', '2019-08-27 14:50:20');
INSERT INTO `access_log` VALUES (72052, '59.75.15668886199855929', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '115.236.71.65', '2019-08-27 14:50:20', 12, 2001001000, '服务端发生异常', '2019-08-27 14:50:20');
INSERT INTO `access_log` VALUES (72053, '59.74.15668896355205949', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:16', 3, 0, '', '2019-08-27 15:07:16');
INSERT INTO `access_log` VALUES (72054, '59.71.15668896355205935', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:16', 12, 2001001000, '服务端发生异常', '2019-08-27 15:07:16');
INSERT INTO `access_log` VALUES (72055, '64.85.15668896399996353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:20', 3, 0, '', '2019-08-27 15:07:20');
INSERT INTO `access_log` VALUES (72056, '64.79.15668896401716335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:20', 1, 0, '', '2019-08-27 15:07:20');
INSERT INTO `access_log` VALUES (72057, '64.80.15668896410266335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:21', 2, 0, '', '2019-08-27 15:07:21');
INSERT INTO `access_log` VALUES (72058, '59.80.15668896418095909', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:22', 3, 0, '', '2019-08-27 15:07:22');
INSERT INTO `access_log` VALUES (72059, '59.73.15668896418095939', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:22', 13, 2001001000, '服务端发生异常', '2019-08-27 15:07:22');
INSERT INTO `access_log` VALUES (72060, '66.56.15668896554003421', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15521277446&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:35', 84, 1001003000, '验证码不存在', '2019-08-27 15:07:35');
INSERT INTO `access_log` VALUES (72061, '66.53.15668896574903393', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15521277446', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:37', 94, 0, '', '2019-08-27 15:07:38');
INSERT INTO `access_log` VALUES (72062, '66.57.15668896593303397', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15521277446&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:39', 223, 0, '', '2019-08-27 15:07:40');
INSERT INTO `access_log` VALUES (72063, '66.48.15668896607673395', 213, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:41', 7, 0, '', '2019-08-27 15:07:41');
INSERT INTO `access_log` VALUES (72064, '66.50.15668896644833405', 213, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:44', 6, 0, '', '2019-08-27 15:07:44');
INSERT INTO `access_log` VALUES (72065, '66.55.15668896650753383', 213, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:45', 5, 0, '', '2019-08-27 15:07:45');
INSERT INTO `access_log` VALUES (72066, '66.54.15668896680063425', 213, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:48', 5, 0, '', '2019-08-27 15:07:48');
INSERT INTO `access_log` VALUES (72067, '65.52.15668896699479293', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '115.174.70.25', '2019-08-27 15:07:50', 1, 1002001015, '账号未登陆', '2019-08-27 15:07:50');
INSERT INTO `access_log` VALUES (72068, '65.46.15668896699479279', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '115.174.70.25', '2019-08-27 15:07:50', 0, 1002001015, '账号未登陆', '2019-08-27 15:07:50');
INSERT INTO `access_log` VALUES (72069, '65.45.15668896699519279', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '115.174.70.25', '2019-08-27 15:07:50', 1, 1002001015, '账号未登陆', '2019-08-27 15:07:50');
INSERT INTO `access_log` VALUES (72070, '66.49.15668896708063409', 213, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:51', 6, 0, '', '2019-08-27 15:07:51');
INSERT INTO `access_log` VALUES (72071, '59.72.15668896719305939', 213, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:52', 7, 0, '', '2019-08-27 15:07:52');
INSERT INTO `access_log` VALUES (72072, '59.74.15668896719395951', 213, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:52', 16, 2001001000, '服务端发生异常', '2019-08-27 15:07:52');
INSERT INTO `access_log` VALUES (72073, '64.78.15668896747406357', 213, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:55', 6, 0, '', '2019-08-27 15:07:55');
INSERT INTO `access_log` VALUES (72074, '64.81.15668896749236337', 213, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:55', 9, 0, '', '2019-08-27 15:07:55');
INSERT INTO `access_log` VALUES (72075, '64.79.15668896758586337', 213, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:56', 7, 0, '', '2019-08-27 15:07:56');
INSERT INTO `access_log` VALUES (72076, '64.80.15668896762586337', 213, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:56', 5, 0, '', '2019-08-27 15:07:56');
INSERT INTO `access_log` VALUES (72077, '64.84.15668896764746329', 213, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:56', 6, 0, '', '2019-08-27 15:07:56');
INSERT INTO `access_log` VALUES (72078, '59.80.15668896771595911', 213, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:57', 7, 0, '', '2019-08-27 15:07:57');
INSERT INTO `access_log` VALUES (72079, '59.73.15668896771815941', 213, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:57', 16, 2001001000, '服务端发生异常', '2019-08-27 15:07:57');
INSERT INTO `access_log` VALUES (72080, '65.51.15668896781139305', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '115.174.70.25', '2019-08-27 15:07:58', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 15:07:58');
INSERT INTO `access_log` VALUES (72081, '64.78.15668896790876359', 213, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:59', 4, 0, '', '2019-08-27 15:07:59');
INSERT INTO `access_log` VALUES (72082, '64.81.15668896792386339', 213, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:07:59', 5, 0, '', '2019-08-27 15:07:59');
INSERT INTO `access_log` VALUES (72083, '64.79.15668896801896339', 213, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:08:00', 4, 0, '', '2019-08-27 15:08:00');
INSERT INTO `access_log` VALUES (72084, '64.80.15668896806126339', 213, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:08:01', 4, 0, '', '2019-08-27 15:08:01');
INSERT INTO `access_log` VALUES (72085, '65.49.15668896810879259', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '115.174.70.25', '2019-08-27 15:08:01', 68, 0, '', '2019-08-27 15:08:01');
INSERT INTO `access_log` VALUES (72086, '59.77.15668896815515927', 213, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:08:02', 6, 0, '', '2019-08-27 15:08:02');
INSERT INTO `access_log` VALUES (72087, '59.78.15668896815515951', 213, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:08:02', 15, 2001001000, '服务端发生异常', '2019-08-27 15:08:02');
INSERT INTO `access_log` VALUES (72088, '65.3607.15668896816041051', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '115.174.70.25', '2019-08-27 15:08:02', 12, 2001001000, '服务端发生异常', '2019-08-27 15:08:02');
INSERT INTO `access_log` VALUES (72089, '65.53.15668896816419193', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '115.174.70.25', '2019-08-27 15:08:02', 10, 0, '', '2019-08-27 15:08:02');
INSERT INTO `access_log` VALUES (72090, '65.47.15668896816809189', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '115.174.70.25', '2019-08-27 15:08:02', 8, 0, '', '2019-08-27 15:08:02');
INSERT INTO `access_log` VALUES (72091, '65.52.15668897010999295', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:08:21', 0, 1002001015, '账号未登陆', '2019-08-27 15:08:21');
INSERT INTO `access_log` VALUES (72092, '65.45.15668897011139281', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:08:21', 0, 1002001015, '账号未登陆', '2019-08-27 15:08:21');
INSERT INTO `access_log` VALUES (72093, '65.46.15668897011429281', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:08:21', 1, 1002001015, '账号未登陆', '2019-08-27 15:08:21');
INSERT INTO `access_log` VALUES (72094, '65.51.15668897065979307', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:08:27', 82, 0, '', '2019-08-27 15:08:27');
INSERT INTO `access_log` VALUES (72095, '65.49.15668897071559261', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:08:27', 9, 0, '', '2019-08-27 15:08:27');
INSERT INTO `access_log` VALUES (72096, '65.3607.15668897071631053', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:08:27', 7, 2001001000, '服务端发生异常', '2019-08-27 15:08:27');
INSERT INTO `access_log` VALUES (72097, '65.53.15668897071789195', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '113.111.7.51', '2019-08-27 15:08:27', 8, 0, '', '2019-08-27 15:08:27');
INSERT INTO `access_log` VALUES (72098, '65.50.15668897246029253', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '115.174.70.25', '2019-08-27 15:08:45', 10, 0, '', '2019-08-27 15:08:45');
INSERT INTO `access_log` VALUES (72099, '65.52.15668897246079297', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '115.174.70.25', '2019-08-27 15:08:45', 10, 2001001000, '服务端发生异常', '2019-08-27 15:08:45');
INSERT INTO `access_log` VALUES (72100, '65.45.15668897246119283', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '115.174.70.25', '2019-08-27 15:08:45', 9, 0, '', '2019-08-27 15:08:45');
INSERT INTO `access_log` VALUES (72101, '65.53.15668909643789213', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:24', 1, 1002001015, '账号未登陆', '2019-08-27 15:29:24');
INSERT INTO `access_log` VALUES (72102, '65.49.15668909643809279', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:24', 0, 1002001015, '账号未登陆', '2019-08-27 15:29:24');
INSERT INTO `access_log` VALUES (72103, '65.3607.15668909644011071', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:24', 0, 1002001015, '账号未登陆', '2019-08-27 15:29:24');
INSERT INTO `access_log` VALUES (72104, '65.47.15668909669479209', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 15:29:27');
INSERT INTO `access_log` VALUES (72105, '65.45.15668909697359301', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:30', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 15:29:30');
INSERT INTO `access_log` VALUES (72106, '65.50.15668909821499271', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:42', 116, 0, '', '2019-08-27 15:29:42');
INSERT INTO `access_log` VALUES (72107, '65.46.15668909825369301', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:43', 17, 0, '', '2019-08-27 15:29:43');
INSERT INTO `access_log` VALUES (72108, '65.54.15668909825399165', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:43', 16, 2001001000, '服务端发生异常', '2019-08-27 15:29:43');
INSERT INTO `access_log` VALUES (72109, '65.51.15668909825559327', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:43', 9, 0, '', '2019-08-27 15:29:43');
INSERT INTO `access_log` VALUES (72110, '65.49.15668909901649281', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:50', 739, 0, '', '2019-08-27 15:29:51');
INSERT INTO `access_log` VALUES (72111, '65.53.15668909901689215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:50', 735, 2001001000, '服务端发生异常', '2019-08-27 15:29:51');
INSERT INTO `access_log` VALUES (72112, '65.3607.15668909901751073', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:50', 729, 0, '', '2019-08-27 15:29:51');
INSERT INTO `access_log` VALUES (72113, '65.47.15668909912299211', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:51', 9, 0, '', '2019-08-27 15:29:51');
INSERT INTO `access_log` VALUES (72114, '65.45.15668909912349303', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:51', 16, 2001001000, '服务端发生异常', '2019-08-27 15:29:51');
INSERT INTO `access_log` VALUES (72115, '65.52.15668909912389317', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '182.106.212.149', '2019-08-27 15:29:51', 8, 0, '', '2019-08-27 15:29:51');
INSERT INTO `access_log` VALUES (72116, '59.74.15668922462105987', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-27 15:50:46', 9, 0, '', '2019-08-27 15:50:46');
INSERT INTO `access_log` VALUES (72117, '59.71.15668922462145973', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-27 15:50:46', 15, 2001001000, '服务端发生异常', '2019-08-27 15:50:46');
INSERT INTO `access_log` VALUES (72118, '59.80.15668922569055947', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:50:57', 3, 0, '', '2019-08-27 15:50:57');
INSERT INTO `access_log` VALUES (72119, '59.73.15668922569075977', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:50:57', 12, 2001001000, '服务端发生异常', '2019-08-27 15:50:57');
INSERT INTO `access_log` VALUES (72120, '59.76.15668922656455965', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:06', 3, 0, '', '2019-08-27 15:51:06');
INSERT INTO `access_log` VALUES (72121, '59.77.15668922656495963', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:06', 12, 2001001000, '服务端发生异常', '2019-08-27 15:51:06');
INSERT INTO `access_log` VALUES (72122, '64.78.15668922680806395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:08', 10, 0, '', '2019-08-27 15:51:08');
INSERT INTO `access_log` VALUES (72123, '64.77.15668922681926353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:08', 3, 0, '', '2019-08-27 15:51:08');
INSERT INTO `access_log` VALUES (72124, '64.81.15668922694006375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:09', 1, 0, '', '2019-08-27 15:51:09');
INSERT INTO `access_log` VALUES (72125, '64.85.15668922699056393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:10', 2, 0, '', '2019-08-27 15:51:10');
INSERT INTO `access_log` VALUES (72126, '64.79.15668922704966375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:10', 2, 0, '', '2019-08-27 15:51:10');
INSERT INTO `access_log` VALUES (72127, '64.76.15668922709346379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:11', 2, 0, '', '2019-08-27 15:51:11');
INSERT INTO `access_log` VALUES (72128, '59.78.15668922717925987', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:12', 2, 0, '', '2019-08-27 15:51:12');
INSERT INTO `access_log` VALUES (72129, '59.72.15668922717945977', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:12', 13, 2001001000, '服务端发生异常', '2019-08-27 15:51:12');
INSERT INTO `access_log` VALUES (72130, '59.74.15668922841265989', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:24', 2, 0, '', '2019-08-27 15:51:24');
INSERT INTO `access_log` VALUES (72131, '59.75.15668922841285983', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:24', 16, 2001001000, '服务端发生异常', '2019-08-27 15:51:24');
INSERT INTO `access_log` VALUES (72132, '59.73.15668922933095979', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:33', 2, 0, '', '2019-08-27 15:51:33');
INSERT INTO `access_log` VALUES (72133, '59.80.15668922933095949', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:33', 12, 2001001000, '服务端发生异常', '2019-08-27 15:51:33');
INSERT INTO `access_log` VALUES (72134, '64.82.15668922953666385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:35', 2, 0, '', '2019-08-27 15:51:35');
INSERT INTO `access_log` VALUES (72135, '64.83.15668922955716371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:36', 2, 0, '', '2019-08-27 15:51:36');
INSERT INTO `access_log` VALUES (72136, '64.78.15668922988466397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:39', 2, 0, '', '2019-08-27 15:51:39');
INSERT INTO `access_log` VALUES (72137, '64.77.15668922990586355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:51:39', 2, 0, '', '2019-08-27 15:51:39');
INSERT INTO `access_log` VALUES (72138, '66.54.15668923199833461', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13693100472', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:00', 77, 0, '', '2019-08-27 15:52:00');
INSERT INTO `access_log` VALUES (72139, '66.56.15668923243453461', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13693100472&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:04', 181, 0, '', '2019-08-27 15:52:05');
INSERT INTO `access_log` VALUES (72140, '66.57.15668923288193435', 198, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:09', 5, 0, '', '2019-08-27 15:52:09');
INSERT INTO `access_log` VALUES (72141, '66.55.15668923324053421', 198, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:12', 5, 0, '', '2019-08-27 15:52:12');
INSERT INTO `access_log` VALUES (72142, '64.76.15668923335896381', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:14', 5, 0, '', '2019-08-27 15:52:14');
INSERT INTO `access_log` VALUES (72143, '64.82.15668923337476387', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:14', 6, 0, '', '2019-08-27 15:52:14');
INSERT INTO `access_log` VALUES (72144, '64.83.15668923352956373', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:15', 5, 0, '', '2019-08-27 15:52:15');
INSERT INTO `access_log` VALUES (72145, '64.77.15668923358316357', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:16', 5, 0, '', '2019-08-27 15:52:16');
INSERT INTO `access_log` VALUES (72146, '64.81.15668923362636379', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:16', 4, 0, '', '2019-08-27 15:52:16');
INSERT INTO `access_log` VALUES (72147, '64.85.15668923366876397', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:17', 5, 0, '', '2019-08-27 15:52:17');
INSERT INTO `access_log` VALUES (72148, '64.79.15668923371446379', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:17', 6, 0, '', '2019-08-27 15:52:17');
INSERT INTO `access_log` VALUES (72149, '64.76.15668923375626383', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:18', 5, 0, '', '2019-08-27 15:52:18');
INSERT INTO `access_log` VALUES (72150, '59.75.15668923384385985', 198, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:18', 6, 0, '', '2019-08-27 15:52:18');
INSERT INTO `access_log` VALUES (72151, '59.71.15668923384375977', 198, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:18', 16, 2001001000, '服务端发生异常', '2019-08-27 15:52:18');
INSERT INTO `access_log` VALUES (72152, '64.82.15668923430476389', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:23', 5, 0, '', '2019-08-27 15:52:23');
INSERT INTO `access_log` VALUES (72153, '64.84.15668923431706371', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:23', 7, 0, '', '2019-08-27 15:52:23');
INSERT INTO `access_log` VALUES (72154, '64.83.15668923443116375', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:24', 5, 0, '', '2019-08-27 15:52:24');
INSERT INTO `access_log` VALUES (72155, '64.78.15668923447596401', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:25', 6, 0, '', '2019-08-27 15:52:25');
INSERT INTO `access_log` VALUES (72156, '64.81.15668923589866381', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:39', 12, 0, '', '2019-08-27 15:52:39');
INSERT INTO `access_log` VALUES (72157, '64.85.15668923594906399', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:39', 7, 0, '', '2019-08-27 15:52:39');
INSERT INTO `access_log` VALUES (72158, '64.76.15668923731416385', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:53', 5, 0, '', '2019-08-27 15:52:53');
INSERT INTO `access_log` VALUES (72159, '64.80.15668923747406381', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:55', 4, 0, '', '2019-08-27 15:52:55');
INSERT INTO `access_log` VALUES (72160, '64.82.15668923756446391', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:56', 5, 0, '', '2019-08-27 15:52:56');
INSERT INTO `access_log` VALUES (72161, '64.84.15668923761706373', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:56', 5, 0, '', '2019-08-27 15:52:56');
INSERT INTO `access_log` VALUES (72162, '64.83.15668923771646377', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:57', 5, 0, '', '2019-08-27 15:52:57');
INSERT INTO `access_log` VALUES (72163, '64.78.15668923776316403', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:58', 5, 0, '', '2019-08-27 15:52:58');
INSERT INTO `access_log` VALUES (72164, '64.77.15668923780646361', 198, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:52:58', 6, 0, '', '2019-08-27 15:52:58');
INSERT INTO `access_log` VALUES (72165, '59.76.15668923852685969', 198, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-27 15:53:05', 6, 0, '', '2019-08-27 15:53:05');
INSERT INTO `access_log` VALUES (72166, '59.77.15668923852685967', 198, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-27 15:53:05', 16, 2001001000, '服务端发生异常', '2019-08-27 15:53:05');
INSERT INTO `access_log` VALUES (72167, 'N/A', 198, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:53:15', 18, 0, '', '2019-08-27 15:53:15');
INSERT INTO `access_log` VALUES (72168, 'N/A', 198, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:53:15', 7, 0, '', '2019-08-27 15:53:15');
INSERT INTO `access_log` VALUES (72169, 'N/A', 198, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:53:15', 18, 0, '', '2019-08-27 15:53:15');
INSERT INTO `access_log` VALUES (72170, 'N/A', 198, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:53:15', 15, 0, '', '2019-08-27 15:53:15');
INSERT INTO `access_log` VALUES (72171, '64.79.15668923982126383', 198, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:53:18', 10, 0, '', '2019-08-27 15:53:18');
INSERT INTO `access_log` VALUES (72172, 'N/A', 198, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:53:21', 18, 0, '', '2019-08-27 15:53:21');
INSERT INTO `access_log` VALUES (72173, 'N/A', 198, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:53:21', 7, 0, '', '2019-08-27 15:53:21');
INSERT INTO `access_log` VALUES (72174, 'N/A', 198, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:53:21', 15, 0, '', '2019-08-27 15:53:21');
INSERT INTO `access_log` VALUES (72175, 'N/A', 198, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:53:21', 16, 0, '', '2019-08-27 15:53:21');
INSERT INTO `access_log` VALUES (72176, '64.82.15668924018406393', 198, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '219.143.154.194', '2019-08-27 15:53:22', 9, 0, '', '2019-08-27 15:53:22');
INSERT INTO `access_log` VALUES (72177, 'N/A', 198, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-27 15:53:36', 17, 0, '', '2019-08-27 15:53:36');
INSERT INTO `access_log` VALUES (72178, 'N/A', 198, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.143.154.194', '2019-08-27 15:53:36', 14, 0, '', '2019-08-27 15:53:36');
INSERT INTO `access_log` VALUES (72179, '59.78.15668926552075995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 15:57:35', 10, 0, '', '2019-08-27 15:57:35');
INSERT INTO `access_log` VALUES (72180, '59.72.15668926552075985', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 15:57:35', 20, 2001001000, '服务端发生异常', '2019-08-27 15:57:35');
INSERT INTO `access_log` VALUES (72181, '66.52.15668926653473445', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 15:57:45', 7, 1002001012, '访问令牌已过期', '2019-08-27 15:57:45');
INSERT INTO `access_log` VALUES (72182, '66.54.15668926654343467', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=98d30edbd4584062b384f45497e82e44', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 15:57:45', 14, 1002001018, '访问令牌已过期', '2019-08-27 15:57:45');
INSERT INTO `access_log` VALUES (72183, '66.53.15668926766313437', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15668618898&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 15:57:57', 9, 1001003000, '验证码不存在', '2019-08-27 15:57:57');
INSERT INTO `access_log` VALUES (72184, '66.48.15668926791123439', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15668618898', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 15:57:59', 93, 0, '', '2019-08-27 15:57:59');
INSERT INTO `access_log` VALUES (72185, '66.57.15668926815263441', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15668618898&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 15:58:02', 444, 0, '', '2019-08-27 15:58:02');
INSERT INTO `access_log` VALUES (72186, '66.55.15668926832613427', 214, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 15:58:03', 6, 0, '', '2019-08-27 15:58:03');
INSERT INTO `access_log` VALUES (72187, '66.50.15668926876193449', 214, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 15:58:08', 5, 0, '', '2019-08-27 15:58:08');
INSERT INTO `access_log` VALUES (72188, '66.51.15668926918283467', 214, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 15:58:12', 6, 0, '', '2019-08-27 15:58:12');
INSERT INTO `access_log` VALUES (72189, '59.74.15668926962165997', 214, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 15:58:16', 13, 0, '', '2019-08-27 15:58:16');
INSERT INTO `access_log` VALUES (72190, '59.73.15668926962165987', 214, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 15:58:16', 21, 2001001000, '服务端发生异常', '2019-08-27 15:58:16');
INSERT INTO `access_log` VALUES (72191, 'N/A', 214, 1, 'search-application', '/search-api/users/product/page', 'keyword=你好&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 15:58:30', 9, 0, '', '2019-08-27 15:58:30');
INSERT INTO `access_log` VALUES (72192, 'N/A', 214, 1, 'search-application', '/search-api/users/product/condition', 'keyword=你好', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 15:58:30', 8, 0, '', '2019-08-27 15:58:30');
INSERT INTO `access_log` VALUES (72193, '65.49.15668930275769309', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:03:48', 0, 1002001015, '账号未登陆', '2019-08-27 16:03:48');
INSERT INTO `access_log` VALUES (72194, '65.53.15668930275769245', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:03:48', 0, 1002001015, '账号未登陆', '2019-08-27 16:03:48');
INSERT INTO `access_log` VALUES (72195, '65.3607.15668930275771103', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:03:48', 1, 1002001015, '账号未登陆', '2019-08-27 16:03:48');
INSERT INTO `access_log` VALUES (72196, '65.47.15668930310119241', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:03:51', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 16:03:51');
INSERT INTO `access_log` VALUES (72197, '65.45.15668930343209331', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.231.31.68', '2019-08-27 16:03:54', 0, 1002001015, '账号未登陆', '2019-08-27 16:03:54');
INSERT INTO `access_log` VALUES (72198, '65.50.15668930343289303', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.231.31.68', '2019-08-27 16:03:54', 0, 1002001015, '账号未登陆', '2019-08-27 16:03:54');
INSERT INTO `access_log` VALUES (72199, '65.54.15668930343299195', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.231.31.68', '2019-08-27 16:03:54', 0, 1002001015, '账号未登陆', '2019-08-27 16:03:54');
INSERT INTO `access_log` VALUES (72200, '65.46.15668930368409333', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.231.31.68', '2019-08-27 16:03:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 16:03:57');
INSERT INTO `access_log` VALUES (72201, '65.51.15668930378469357', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:03:58', 154, 0, '', '2019-08-27 16:03:58');
INSERT INTO `access_log` VALUES (72202, '65.3607.15668930382181105', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:03:58', 11, 0, '', '2019-08-27 16:03:58');
INSERT INTO `access_log` VALUES (72203, '65.49.15668930382209311', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:03:58', 11, 0, '', '2019-08-27 16:03:58');
INSERT INTO `access_log` VALUES (72204, '65.53.15668930382189247', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:03:58', 13, 2001001000, '服务端发生异常', '2019-08-27 16:03:58');
INSERT INTO `access_log` VALUES (72205, '65.47.15668930410099243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.231.31.68', '2019-08-27 16:04:01', 87, 0, '', '2019-08-27 16:04:01');
INSERT INTO `access_log` VALUES (72206, '65.54.15668930413599197', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.231.31.68', '2019-08-27 16:04:01', 16, 0, '', '2019-08-27 16:04:01');
INSERT INTO `access_log` VALUES (72207, '65.52.15668930413599347', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.231.31.68', '2019-08-27 16:04:01', 18, 2001001000, '服务端发生异常', '2019-08-27 16:04:01');
INSERT INTO `access_log` VALUES (72208, '65.50.15668930413619305', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.231.31.68', '2019-08-27 16:04:01', 16, 0, '', '2019-08-27 16:04:01');
INSERT INTO `access_log` VALUES (72209, '65.45.15668930467919333', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:04:07', 8, 0, '', '2019-08-27 16:04:07');
INSERT INTO `access_log` VALUES (72210, '65.46.15668930467939335', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:04:07', 8, 2001001000, '服务端发生异常', '2019-08-27 16:04:07');
INSERT INTO `access_log` VALUES (72211, '65.51.15668930467959359', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:04:07', 8, 0, '', '2019-08-27 16:04:07');
INSERT INTO `access_log` VALUES (72212, '65.49.15668930725719313', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:04:33', 9, 0, '', '2019-08-27 16:04:33');
INSERT INTO `access_log` VALUES (72213, '65.47.15668930725729245', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:04:33', 10, 2001001000, '服务端发生异常', '2019-08-27 16:04:33');
INSERT INTO `access_log` VALUES (72214, '65.50.15668930725749307', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:04:33', 8, 0, '', '2019-08-27 16:04:33');
INSERT INTO `access_log` VALUES (72215, '65.52.15668930754339349', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:04:35', 17, 0, '', '2019-08-27 16:04:35');
INSERT INTO `access_log` VALUES (72216, '65.54.15668930754399199', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:04:35', 16, 2001001000, '服务端发生异常', '2019-08-27 16:04:35');
INSERT INTO `access_log` VALUES (72217, '65.46.15668930754409337', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:04:35', 16, 0, '', '2019-08-27 16:04:35');
INSERT INTO `access_log` VALUES (72218, '65.45.15668930809499335', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:04:41', 10, 0, '', '2019-08-27 16:04:41');
INSERT INTO `access_log` VALUES (72219, '65.53.15668930809529251', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:04:41', 10, 2001001000, '服务端发生异常', '2019-08-27 16:04:41');
INSERT INTO `access_log` VALUES (72220, '65.3607.15668930809561109', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:04:41', 9, 0, '', '2019-08-27 16:04:41');
INSERT INTO `access_log` VALUES (72221, '65.51.15668931784929363', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:06:18', 9, 0, '', '2019-08-27 16:06:19');
INSERT INTO `access_log` VALUES (72222, '65.45.15668931784949337', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:06:18', 9, 0, '', '2019-08-27 16:06:19');
INSERT INTO `access_log` VALUES (72223, '65.3607.15668931784941111', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:06:18', 10, 2001001000, '服务端发生异常', '2019-08-27 16:06:19');
INSERT INTO `access_log` VALUES (72224, '65.53.15668931788279253', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:06:19', 9, 0, '', '2019-08-27 16:06:19');
INSERT INTO `access_log` VALUES (72225, '65.49.15668931788289317', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:06:19', 10, 2001001000, '服务端发生异常', '2019-08-27 16:06:19');
INSERT INTO `access_log` VALUES (72226, '65.50.15668931788329311', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-27 16:06:19', 9, 0, '', '2019-08-27 16:06:19');
INSERT INTO `access_log` VALUES (72227, '59.74.15668934190676007', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '101.91.60.11', '2019-08-27 16:10:19', 3, 0, '', '2019-08-27 16:10:19');
INSERT INTO `access_log` VALUES (72228, '66.50.15668934196693459', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.178.197', '2019-08-27 16:10:20', 1, 1002001015, '账号未登陆', '2019-08-27 16:10:20');
INSERT INTO `access_log` VALUES (72229, '59.80.15668934249035967', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.129.7.235', '2019-08-27 16:10:25', 14, 2001001000, '服务端发生异常', '2019-08-27 16:10:25');
INSERT INTO `access_log` VALUES (72230, '59.79.15668934335355997', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-27 16:10:34', 2, 0, '', '2019-08-27 16:10:34');
INSERT INTO `access_log` VALUES (72231, '59.76.15668934335635985', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.17.169.238', '2019-08-27 16:10:34', 17, 2001001000, '服务端发生异常', '2019-08-27 16:10:34');
INSERT INTO `access_log` VALUES (72232, '65.53.15668953661589281', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:42:46', 0, 1002001015, '账号未登陆', '2019-08-27 16:42:46');
INSERT INTO `access_log` VALUES (72233, '65.47.15668953661599277', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:42:46', 0, 1002001015, '账号未登陆', '2019-08-27 16:42:46');
INSERT INTO `access_log` VALUES (72234, '65.54.15668953661729235', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:42:46', 1, 1002001015, '账号未登陆', '2019-08-27 16:42:46');
INSERT INTO `access_log` VALUES (72235, '65.52.15668953683039385', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:42:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 16:42:48');
INSERT INTO `access_log` VALUES (72236, '65.46.15668953853069371', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:43:05', 295, 0, '', '2019-08-27 16:43:06');
INSERT INTO `access_log` VALUES (72237, '65.51.15668953859269395', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:43:06', 11, 0, '', '2019-08-27 16:43:06');
INSERT INTO `access_log` VALUES (72238, '65.45.15668953859399369', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:43:06', 12, 0, '', '2019-08-27 16:43:06');
INSERT INTO `access_log` VALUES (72239, '65.50.15668953859409343', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:43:06', 12, 2001001000, '服务端发生异常', '2019-08-27 16:43:06');
INSERT INTO `access_log` VALUES (72240, '65.50.15668955142039345', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:45:14', 21, 0, '', '2019-08-27 16:45:14');
INSERT INTO `access_log` VALUES (72241, '65.49.15668955142069353', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:45:14', 21, 2001001000, '服务端发生异常', '2019-08-27 16:45:14');
INSERT INTO `access_log` VALUES (72242, '65.47.15668955142219281', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:45:14', 8, 0, '', '2019-08-27 16:45:14');
INSERT INTO `access_log` VALUES (72243, '65.53.15668955188129285', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:45:19', 9, 0, '', '2019-08-27 16:45:19');
INSERT INTO `access_log` VALUES (72244, '65.52.15668955188229389', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:45:19', 8, 0, '', '2019-08-27 16:45:19');
INSERT INTO `access_log` VALUES (72245, '65.54.15668955188209239', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:45:19', 9, 2001001000, '服务端发生异常', '2019-08-27 16:45:19');
INSERT INTO `access_log` VALUES (72246, '65.46.15668955241659375', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:45:24', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 16:45:24');
INSERT INTO `access_log` VALUES (72247, '65.45.15668955274159373', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '121.33.231.52', '2019-08-27 16:45:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 16:45:27');
INSERT INTO `access_log` VALUES (72248, '59.73.15668960052286031', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.190.172', '2019-08-27 16:53:25', 10, 0, '', '2019-08-27 16:53:25');
INSERT INTO `access_log` VALUES (72249, '59.74.15668960055986043', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) BingPreview/1.0b', '40.77.190.172', '2019-08-27 16:53:26', 12, 2001001000, '服务端发生异常', '2019-08-27 16:53:26');
INSERT INTO `access_log` VALUES (72250, '65.46.15668970079719397', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.54.192.52', '2019-08-27 17:10:08', 0, 1002001015, '账号未登陆', '2019-08-27 17:10:08');
INSERT INTO `access_log` VALUES (72251, '65.3607.15668970079711171', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.54.192.52', '2019-08-27 17:10:08', 1, 1002001015, '账号未登陆', '2019-08-27 17:10:08');
INSERT INTO `access_log` VALUES (72252, '65.54.15668970079719261', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.54.192.52', '2019-08-27 17:10:08', 1, 1002001015, '账号未登陆', '2019-08-27 17:10:08');
INSERT INTO `access_log` VALUES (72253, '65.51.15668970116419419', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.54.192.52', '2019-08-27 17:10:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 17:10:12');
INSERT INTO `access_log` VALUES (72254, '65.49.15668970291089377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.54.192.52', '2019-08-27 17:10:29', 69, 0, '', '2019-08-27 17:10:29');
INSERT INTO `access_log` VALUES (72255, '65.47.15668970297039305', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.54.192.52', '2019-08-27 17:10:30', 9, 0, '', '2019-08-27 17:10:30');
INSERT INTO `access_log` VALUES (72256, '65.53.15668970297189307', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.54.192.52', '2019-08-27 17:10:30', 9, 2001001000, '服务端发生异常', '2019-08-27 17:10:30');
INSERT INTO `access_log` VALUES (72257, '65.52.15668970297299411', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.54.192.52', '2019-08-27 17:10:30', 8, 0, '', '2019-08-27 17:10:30');
INSERT INTO `access_log` VALUES (72258, '65.46.15668970421409399', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.54.192.52', '2019-08-27 17:10:42', 10, 0, '', '2019-08-27 17:10:42');
INSERT INTO `access_log` VALUES (72259, '65.54.15668970421439263', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.54.192.52', '2019-08-27 17:10:42', 10, 2001001000, '服务端发生异常', '2019-08-27 17:10:42');
INSERT INTO `access_log` VALUES (72260, '65.45.15668970421509395', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '183.54.192.52', '2019-08-27 17:10:42', 8, 0, '', '2019-08-27 17:10:42');
INSERT INTO `access_log` VALUES (72261, '59.77.15668996241246067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.154.37.42', '2019-08-27 17:53:44', 9, 0, '', '2019-08-27 17:53:44');
INSERT INTO `access_log` VALUES (72262, '59.76.15668996241306069', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.154.37.42', '2019-08-27 17:53:44', 15, 2001001000, '服务端发生异常', '2019-08-27 17:53:44');
INSERT INTO `access_log` VALUES (72263, '64.78.15668996315666501', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.154.37.42', '2019-08-27 17:53:52', 11, 0, '', '2019-08-27 17:53:52');
INSERT INTO `access_log` VALUES (72264, '64.77.15668996317066459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.154.37.42', '2019-08-27 17:53:52', 3, 0, '', '2019-08-27 17:53:52');
INSERT INTO `access_log` VALUES (72265, '64.81.15668996359696481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.154.37.42', '2019-08-27 17:53:56', 2, 0, '', '2019-08-27 17:53:56');
INSERT INTO `access_log` VALUES (72266, '64.85.15668996360966499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.154.37.42', '2019-08-27 17:53:56', 2, 0, '', '2019-08-27 17:53:56');
INSERT INTO `access_log` VALUES (72267, '59.80.15668996411236051', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.154.37.42', '2019-08-27 17:54:01', 2, 0, '', '2019-08-27 17:54:01');
INSERT INTO `access_log` VALUES (72268, '59.72.15668996411256081', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.154.37.42', '2019-08-27 17:54:01', 10, 2001001000, '服务端发生异常', '2019-08-27 17:54:01');
INSERT INTO `access_log` VALUES (72269, '59.72.15669004685286091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.191.0.175', '2019-08-27 18:07:49', 3, 0, '', '2019-08-27 18:07:49');
INSERT INTO `access_log` VALUES (72270, '59.80.15669004685286063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.191.0.175', '2019-08-27 18:07:49', 17, 2001001000, '服务端发生异常', '2019-08-27 18:07:49');
INSERT INTO `access_log` VALUES (72271, '65.51.15669004946749467', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.191.0.175', '2019-08-27 18:08:15', 0, 1002001015, '账号未登陆', '2019-08-27 18:08:15');
INSERT INTO `access_log` VALUES (72272, '65.49.15669004946769425', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.191.0.175', '2019-08-27 18:08:15', 0, 1002001015, '账号未登陆', '2019-08-27 18:08:15');
INSERT INTO `access_log` VALUES (72273, '65.50.15669004946759415', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.191.0.175', '2019-08-27 18:08:15', 0, 1002001015, '账号未登陆', '2019-08-27 18:08:15');
INSERT INTO `access_log` VALUES (72274, '65.47.15669004964589353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.191.0.175', '2019-08-27 18:08:16', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 18:08:16');
INSERT INTO `access_log` VALUES (72275, '65.53.15669005083559355', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.191.0.175', '2019-08-27 18:08:28', 84, 0, '', '2019-08-27 18:08:28');
INSERT INTO `access_log` VALUES (72276, '65.3607.15669005086731221', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.191.0.175', '2019-08-27 18:08:29', 12, 0, '', '2019-08-27 18:08:29');
INSERT INTO `access_log` VALUES (72277, '65.45.15669005086809443', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.191.0.175', '2019-08-27 18:08:29', 9, 0, '', '2019-08-27 18:08:29');
INSERT INTO `access_log` VALUES (72278, '65.46.15669005086829447', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.191.0.175', '2019-08-27 18:08:29', 8, 2001001000, '服务端发生异常', '2019-08-27 18:08:29');
INSERT INTO `access_log` VALUES (72279, '65.54.15669005186039311', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.191.0.175', '2019-08-27 18:08:39', 15, 0, '', '2019-08-27 18:08:39');
INSERT INTO `access_log` VALUES (72280, '65.49.15669005186049427', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.191.0.175', '2019-08-27 18:08:39', 14, 2001001000, '服务端发生异常', '2019-08-27 18:08:39');
INSERT INTO `access_log` VALUES (72281, '65.51.15669005186099469', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '60.191.0.175', '2019-08-27 18:08:39', 12, 0, '', '2019-08-27 18:08:39');
INSERT INTO `access_log` VALUES (72282, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 18:21:04', 16, 0, '', '2019-08-27 18:21:04');
INSERT INTO `access_log` VALUES (72283, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 18:21:05', 14, 0, '', '2019-08-27 18:21:05');
INSERT INTO `access_log` VALUES (72284, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 18:21:05', 9, 0, '', '2019-08-27 18:21:05');
INSERT INTO `access_log` VALUES (72285, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '101.81.124.18', '2019-08-27 18:21:05', 13, 0, '', '2019-08-27 18:21:05');
INSERT INTO `access_log` VALUES (72286, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '61.151.178.197', '2019-08-27 18:24:40', 5, 0, '', '2019-08-27 18:24:40');
INSERT INTO `access_log` VALUES (72287, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:50.0) Gecko/20100101 Firefox/50.0', '101.89.29.97', '2019-08-27 18:24:42', 6, 0, '', '2019-08-27 18:24:42');
INSERT INTO `access_log` VALUES (72288, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.129.6.251', '2019-08-27 18:25:23', 11, 0, '', '2019-08-27 18:25:23');
INSERT INTO `access_log` VALUES (72289, '65.47.15669042772889405', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.218.40', '2019-08-27 19:11:17', 0, 1002001015, '账号未登陆', '2019-08-27 19:11:17');
INSERT INTO `access_log` VALUES (72290, '65.52.15669042772889511', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.218.40', '2019-08-27 19:11:17', 0, 1002001015, '账号未登陆', '2019-08-27 19:11:17');
INSERT INTO `access_log` VALUES (72291, '65.53.15669042773039407', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.218.40', '2019-08-27 19:11:17', 0, 1002001015, '账号未登陆', '2019-08-27 19:11:17');
INSERT INTO `access_log` VALUES (72292, '65.45.15669042846739495', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.218.40', '2019-08-27 19:11:25', 86, 0, '', '2019-08-27 19:11:25');
INSERT INTO `access_log` VALUES (72293, '65.46.15669042849949499', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.218.40', '2019-08-27 19:11:25', 178, 0, '', '2019-08-27 19:11:25');
INSERT INTO `access_log` VALUES (72294, '65.54.15669042849989363', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.218.40', '2019-08-27 19:11:25', 178, 0, '', '2019-08-27 19:11:25');
INSERT INTO `access_log` VALUES (72295, '65.49.15669042849959479', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.218.40', '2019-08-27 19:11:25', 182, 2001001000, '服务端发生异常', '2019-08-27 19:11:25');
INSERT INTO `access_log` VALUES (72296, '65.51.15669042915999521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.218.40', '2019-08-27 19:11:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 19:11:32');
INSERT INTO `access_log` VALUES (72297, '65.50.15669042960899469', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.218.40', '2019-08-27 19:11:36', 101, 0, '', '2019-08-27 19:11:36');
INSERT INTO `access_log` VALUES (72298, '65.47.15669042963529407', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.218.40', '2019-08-27 19:11:36', 17, 0, '', '2019-08-27 19:11:36');
INSERT INTO `access_log` VALUES (72299, '65.52.15669042963569513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.218.40', '2019-08-27 19:11:36', 16, 0, '', '2019-08-27 19:11:36');
INSERT INTO `access_log` VALUES (72300, '65.53.15669042963569409', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.218.40', '2019-08-27 19:11:36', 18, 2001001000, '服务端发生异常', '2019-08-27 19:11:36');
INSERT INTO `access_log` VALUES (72301, '59.71.15669066205246171', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.41.74.117', '2019-08-27 19:50:21', 9, 0, '', '2019-08-27 19:50:21');
INSERT INTO `access_log` VALUES (72302, '59.73.15669066205256175', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.41.74.117', '2019-08-27 19:50:21', 14, 2001001000, '服务端发生异常', '2019-08-27 19:50:21');
INSERT INTO `access_log` VALUES (72303, '64.78.15669066243516597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.41.74.117', '2019-08-27 19:50:24', 13, 0, '', '2019-08-27 19:50:24');
INSERT INTO `access_log` VALUES (72304, '64.77.15669066244946555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.41.74.117', '2019-08-27 19:50:24', 3, 0, '', '2019-08-27 19:50:24');
INSERT INTO `access_log` VALUES (72305, '64.81.15669066261196575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.41.74.117', '2019-08-27 19:50:26', 3, 0, '', '2019-08-27 19:50:26');
INSERT INTO `access_log` VALUES (72306, '64.85.15669066268396595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.41.74.117', '2019-08-27 19:50:27', 2, 0, '', '2019-08-27 19:50:27');
INSERT INTO `access_log` VALUES (72307, '64.80.15669066275496575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.41.74.117', '2019-08-27 19:50:28', 2, 0, '', '2019-08-27 19:50:28');
INSERT INTO `access_log` VALUES (72308, '64.76.15669066317086579', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.41.74.117', '2019-08-27 19:50:32', 2, 0, '', '2019-08-27 19:50:32');
INSERT INTO `access_log` VALUES (72309, '64.79.15669066318576575', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '59.41.74.117', '2019-08-27 19:50:32', 2, 0, '', '2019-08-27 19:50:32');
INSERT INTO `access_log` VALUES (72310, '59.71.15669091481136205', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '124.126.2.114', '2019-08-27 20:32:28', 10, 0, '', '2019-08-27 20:32:28');
INSERT INTO `access_log` VALUES (72311, '59.73.15669091481166209', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '124.126.2.114', '2019-08-27 20:32:28', 15, 2001001000, '服务端发生异常', '2019-08-27 20:32:28');
INSERT INTO `access_log` VALUES (72312, '59.77.15669101049036209', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.55.186.18', '2019-08-27 20:48:25', 4, 0, '', '2019-08-27 20:48:25');
INSERT INTO `access_log` VALUES (72313, '59.80.15669101049106193', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.55.186.18', '2019-08-27 20:48:25', 12, 2001001000, '服务端发生异常', '2019-08-27 20:48:25');
INSERT INTO `access_log` VALUES (72314, '64.78.15669101175036645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.55.186.18', '2019-08-27 20:48:38', 26, 0, '', '2019-08-27 20:48:38');
INSERT INTO `access_log` VALUES (72315, '64.77.15669101177926603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.55.186.18', '2019-08-27 20:48:38', 3, 0, '', '2019-08-27 20:48:38');
INSERT INTO `access_log` VALUES (72316, '64.81.15669101187226623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.55.186.18', '2019-08-27 20:48:39', 2, 0, '', '2019-08-27 20:48:39');
INSERT INTO `access_log` VALUES (72317, '64.85.15669101190716643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.55.186.18', '2019-08-27 20:48:39', 1, 0, '', '2019-08-27 20:48:39');
INSERT INTO `access_log` VALUES (72318, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.55.186.18', '2019-08-27 20:48:40', 6, 0, '', '2019-08-27 20:48:40');
INSERT INTO `access_log` VALUES (72319, '64.80.15669101200656623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.55.186.18', '2019-08-27 20:48:40', 2, 0, '', '2019-08-27 20:48:40');
INSERT INTO `access_log` VALUES (72320, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.55.186.18', '2019-08-27 20:48:41', 14, 0, '', '2019-08-27 20:48:41');
INSERT INTO `access_log` VALUES (72321, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.55.186.18', '2019-08-27 20:48:42', 6, 0, '', '2019-08-27 20:48:42');
INSERT INTO `access_log` VALUES (72322, '65.45.15669101347989575', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.55.186.18', '2019-08-27 20:48:55', 1, 1002001015, '账号未登陆', '2019-08-27 20:48:55');
INSERT INTO `access_log` VALUES (72323, '65.3607.15669101347981353', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.55.186.18', '2019-08-27 20:48:55', 1, 1002001015, '账号未登陆', '2019-08-27 20:48:55');
INSERT INTO `access_log` VALUES (72324, '65.49.15669101347989559', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.55.186.18', '2019-08-27 20:48:55', 0, 1002001015, '账号未登陆', '2019-08-27 20:48:55');
INSERT INTO `access_log` VALUES (72325, '65.54.15669101382339443', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.55.186.18', '2019-08-27 20:48:58', 142, 0, '', '2019-08-27 20:48:58');
INSERT INTO `access_log` VALUES (72326, '65.46.15669101387999579', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.55.186.18', '2019-08-27 20:48:59', 149, 0, '', '2019-08-27 20:48:59');
INSERT INTO `access_log` VALUES (72327, '65.50.15669101388079549', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.55.186.18', '2019-08-27 20:48:59', 143, 0, '', '2019-08-27 20:48:59');
INSERT INTO `access_log` VALUES (72328, '65.51.15669101388009601', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.55.186.18', '2019-08-27 20:48:59', 151, 2001001000, '服务端发生异常', '2019-08-27 20:48:59');
INSERT INTO `access_log` VALUES (72329, '59.76.15669102010016213', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.55.186.18', '2019-08-27 20:50:01', 10, 0, '', '2019-08-27 20:50:01');
INSERT INTO `access_log` VALUES (72330, '59.78.15669102010036235', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '122.55.186.18', '2019-08-27 20:50:01', 14, 2001001000, '服务端发生异常', '2019-08-27 20:50:01');
INSERT INTO `access_log` VALUES (72331, '65.53.15669106218529495', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.96.204', '2019-08-27 20:57:02', 1, 1002001015, '账号未登陆', '2019-08-27 20:57:02');
INSERT INTO `access_log` VALUES (72332, '65.45.15669106218539583', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.96.204', '2019-08-27 20:57:02', 1, 1002001015, '账号未登陆', '2019-08-27 20:57:02');
INSERT INTO `access_log` VALUES (72333, '65.49.15669106218539567', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.96.204', '2019-08-27 20:57:02', 0, 1002001015, '账号未登陆', '2019-08-27 20:57:02');
INSERT INTO `access_log` VALUES (72334, '65.3607.15669106236571361', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.96.204', '2019-08-27 20:57:04', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 20:57:04');
INSERT INTO `access_log` VALUES (72335, '65.51.15669106397479609', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.96.204', '2019-08-27 20:57:20', 66, 0, '', '2019-08-27 20:57:20');
INSERT INTO `access_log` VALUES (72336, '65.50.15669106405529557', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.96.204', '2019-08-27 20:57:21', 10, 0, '', '2019-08-27 20:57:21');
INSERT INTO `access_log` VALUES (72337, '65.46.15669106405529587', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.96.204', '2019-08-27 20:57:21', 11, 2001001000, '服务端发生异常', '2019-08-27 20:57:21');
INSERT INTO `access_log` VALUES (72338, '65.47.15669106405559495', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '112.31.96.204', '2019-08-27 20:57:21', 9, 0, '', '2019-08-27 20:57:21');
INSERT INTO `access_log` VALUES (72339, '65.53.15669106812139497', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '183.192.164.85', '2019-08-27 20:58:01', 0, 1002001015, '账号未登陆', '2019-08-27 20:58:01');
INSERT INTO `access_log` VALUES (72340, '65.3607.15669106831641363', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '183.192.164.56', '2019-08-27 20:58:03', 0, 1002001015, '账号未登陆', '2019-08-27 20:58:03');
INSERT INTO `access_log` VALUES (72341, '65.53.15669172442619585', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.87.206.125', '2019-08-27 22:47:24', 1, 1002001015, '账号未登陆', '2019-08-27 22:47:24');
INSERT INTO `access_log` VALUES (72342, '65.3607.15669172442611451', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.87.206.125', '2019-08-27 22:47:24', 1, 1002001015, '账号未登陆', '2019-08-27 22:47:24');
INSERT INTO `access_log` VALUES (72343, '65.54.15669172442739541', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.87.206.125', '2019-08-27 22:47:24', 0, 1002001015, '账号未登陆', '2019-08-27 22:47:24');
INSERT INTO `access_log` VALUES (72344, '65.51.15669172468679699', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.87.206.125', '2019-08-27 22:47:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 22:47:27');
INSERT INTO `access_log` VALUES (72345, '65.47.15669172512789585', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.87.206.125', '2019-08-27 22:47:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 22:47:31');
INSERT INTO `access_log` VALUES (72346, '65.49.15669173043789659', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '183.192.164.85', '2019-08-27 22:48:24', 1, 1002001015, '账号未登陆', '2019-08-27 22:48:24');
INSERT INTO `access_log` VALUES (72347, '65.53.15669173045979587', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '183.192.164.71', '2019-08-27 22:48:25', 0, 1002001015, '账号未登陆', '2019-08-27 22:48:25');
INSERT INTO `access_log` VALUES (72348, '65.3607.15669173153891453', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.87.206.125', '2019-08-27 22:48:35', 69, 0, '', '2019-08-27 22:48:35');
INSERT INTO `access_log` VALUES (72349, '65.51.15669173220779701', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.87.206.125', '2019-08-27 22:48:42', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 22:48:42');
INSERT INTO `access_log` VALUES (72350, '65.47.15669173281809587', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.87.206.125', '2019-08-27 22:48:48', 62, 0, '', '2019-08-27 22:48:48');
INSERT INTO `access_log` VALUES (72351, '59.78.15669181354536341', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.87.206.125', '2019-08-27 23:02:15', 11, 0, '', '2019-08-27 23:02:15');
INSERT INTO `access_log` VALUES (72352, '59.77.15669181354596317', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.87.206.125', '2019-08-27 23:02:15', 17, 2001001000, '服务端发生异常', '2019-08-27 23:02:15');
INSERT INTO `access_log` VALUES (72353, '64.76.15669181420366735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.87.206.125', '2019-08-27 23:02:22', 14, 0, '', '2019-08-27 23:02:22');
INSERT INTO `access_log` VALUES (72354, '64.83.15669181421706727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.87.206.125', '2019-08-27 23:02:22', 3, 0, '', '2019-08-27 23:02:22');
INSERT INTO `access_log` VALUES (72355, '64.78.15669181433636753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.87.206.125', '2019-08-27 23:02:23', 4, 0, '', '2019-08-27 23:02:23');
INSERT INTO `access_log` VALUES (72356, '64.77.15669181441146711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.87.206.125', '2019-08-27 23:02:24', 1, 0, '', '2019-08-27 23:02:24');
INSERT INTO `access_log` VALUES (72357, '64.81.15669181446036735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.87.206.125', '2019-08-27 23:02:25', 2, 0, '', '2019-08-27 23:02:25');
INSERT INTO `access_log` VALUES (72358, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=fdf &pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.87.206.125', '2019-08-27 23:02:30', 5, 0, '', '2019-08-27 23:02:30');
INSERT INTO `access_log` VALUES (72359, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=fdf ', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.87.206.125', '2019-08-27 23:02:30', 5, 0, '', '2019-08-27 23:02:30');
INSERT INTO `access_log` VALUES (72360, '64.76.15669182057566737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.104 Safari/537.36 Core/1.53.2141.400 QQBrowser/9.5.10219.400', '183.192.164.56', '2019-08-27 23:03:26', 4, 0, '', '2019-08-27 23:03:26');
INSERT INTO `access_log` VALUES (72361, '64.84.15669182057566727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '183.192.164.56', '2019-08-27 23:03:26', 3, 0, '', '2019-08-27 23:03:26');
INSERT INTO `access_log` VALUES (72362, '64.83.15669182091206729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '183.192.164.85', '2019-08-27 23:03:29', 8, 0, '', '2019-08-27 23:03:29');
INSERT INTO `access_log` VALUES (72363, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=fdf ', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '183.192.164.85', '2019-08-27 23:03:33', 7, 0, '', '2019-08-27 23:03:33');
INSERT INTO `access_log` VALUES (72364, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=fdf &pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '121.51.32.144', '2019-08-27 23:03:44', 5, 0, '', '2019-08-27 23:03:44');
INSERT INTO `access_log` VALUES (72365, '59.76.15669189842846331', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:24', 5, 0, '', '2019-08-27 23:16:24');
INSERT INTO `access_log` VALUES (72366, '59.78.15669189842856353', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:24', 14, 2001001000, '服务端发生异常', '2019-08-27 23:16:24');
INSERT INTO `access_log` VALUES (72367, '64.81.15669189871766747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:27', 8, 0, '', '2019-08-27 23:16:27');
INSERT INTO `access_log` VALUES (72368, '64.85.15669189875516761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:28', 1, 0, '', '2019-08-27 23:16:28');
INSERT INTO `access_log` VALUES (72369, '64.80.15669189886046745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:29', 2, 0, '', '2019-08-27 23:16:29');
INSERT INTO `access_log` VALUES (72370, '64.79.15669189891646743', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:29', 2, 0, '', '2019-08-27 23:16:29');
INSERT INTO `access_log` VALUES (72371, '64.82.15669189896626755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:30', 2, 0, '', '2019-08-27 23:16:30');
INSERT INTO `access_log` VALUES (72372, '59.77.15669189915306329', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:32', 3, 0, '', '2019-08-27 23:16:32');
INSERT INTO `access_log` VALUES (72373, '59.80.15669189915306313', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:32', 12, 2001001000, '服务端发生异常', '2019-08-27 23:16:32');
INSERT INTO `access_log` VALUES (72374, '64.84.15669189943616739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:34', 3, 0, '', '2019-08-27 23:16:34');
INSERT INTO `access_log` VALUES (72375, '64.76.15669189945266749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:35', 2, 0, '', '2019-08-27 23:16:35');
INSERT INTO `access_log` VALUES (72376, '59.74.15669189951146353', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:35', 2, 0, '', '2019-08-27 23:16:35');
INSERT INTO `access_log` VALUES (72377, '59.73.15669189951146343', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:35', 11, 2001001000, '服务端发生异常', '2019-08-27 23:16:35');
INSERT INTO `access_log` VALUES (72378, '64.78.15669189969506767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:37', 2, 0, '', '2019-08-27 23:16:37');
INSERT INTO `access_log` VALUES (72379, '64.77.15669189970386725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:37', 2, 0, '', '2019-08-27 23:16:37');
INSERT INTO `access_log` VALUES (72380, '59.71.15669189975626339', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:38', 5, 0, '', '2019-08-27 23:16:38');
INSERT INTO `access_log` VALUES (72381, '59.79.15669189975646345', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:38', 13, 2001001000, '服务端发生异常', '2019-08-27 23:16:38');
INSERT INTO `access_log` VALUES (72382, '65.52.15669190033099715', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:43', 1, 1002001015, '账号未登陆', '2019-08-27 23:16:43');
INSERT INTO `access_log` VALUES (72383, '65.45.15669190033109699', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:43', 1, 1002001015, '账号未登陆', '2019-08-27 23:16:43');
INSERT INTO `access_log` VALUES (72384, '65.49.15669190033109683', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:43', 0, 1002001015, '账号未登陆', '2019-08-27 23:16:43');
INSERT INTO `access_log` VALUES (72385, '65.53.15669190057839611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:16:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 23:16:46');
INSERT INTO `access_log` VALUES (72386, '65.54.15669190206329567', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:17:01', 95, 0, '', '2019-08-27 23:17:01');
INSERT INTO `access_log` VALUES (72387, '65.51.15669190209539725', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:17:01', 11, 0, '', '2019-08-27 23:17:01');
INSERT INTO `access_log` VALUES (72388, '65.50.15669190209549673', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:17:01', 11, 0, '', '2019-08-27 23:17:01');
INSERT INTO `access_log` VALUES (72389, '65.47.15669190209549611', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.80 Safari/537.36', '180.158.40.23', '2019-08-27 23:17:01', 11, 2001001000, '服务端发生异常', '2019-08-27 23:17:01');
INSERT INTO `access_log` VALUES (72390, '59.73.15669204409236363', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X; zh-cn) AppleWebKit/601.1.46 (KHTML, like Gecko) Mobile/16D57 Quark/3.4.2.966 Mobile', '61.140.235.138', '2019-08-27 23:40:41', 2, 0, '', '2019-08-27 23:40:41');
INSERT INTO `access_log` VALUES (72391, '59.74.15669204409216373', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X; zh-cn) AppleWebKit/601.1.46 (KHTML, like Gecko) Mobile/16D57 Quark/3.4.2.966 Mobile', '61.140.235.138', '2019-08-27 23:40:41', 12, 2001001000, '服务端发生异常', '2019-08-27 23:40:41');
INSERT INTO `access_log` VALUES (72392, '64.76.15669204458806769', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X; zh-cn) AppleWebKit/601.1.46 (KHTML, like Gecko) Mobile/16D57 Quark/3.4.2.966 Mobile', '61.140.235.138', '2019-08-27 23:40:46', 3, 0, '', '2019-08-27 23:40:46');
INSERT INTO `access_log` VALUES (72393, '64.83.15669204460466761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X; zh-cn) AppleWebKit/601.1.46 (KHTML, like Gecko) Mobile/16D57 Quark/3.4.2.966 Mobile', '61.140.235.138', '2019-08-27 23:40:46', 2, 0, '', '2019-08-27 23:40:46');
INSERT INTO `access_log` VALUES (72394, '65.47.15669204622149631', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X; zh-cn) AppleWebKit/601.1.46 (KHTML, like Gecko) Mobile/16D57 Quark/3.4.2.966 Mobile', '61.140.235.138', '2019-08-27 23:41:02', 0, 1002001015, '账号未登陆', '2019-08-27 23:41:02');
INSERT INTO `access_log` VALUES (72395, '65.54.15669204622139587', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X; zh-cn) AppleWebKit/601.1.46 (KHTML, like Gecko) Mobile/16D57 Quark/3.4.2.966 Mobile', '61.140.235.138', '2019-08-27 23:41:02', 0, 1002001015, '账号未登陆', '2019-08-27 23:41:02');
INSERT INTO `access_log` VALUES (72396, '65.51.15669204622139745', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X; zh-cn) AppleWebKit/601.1.46 (KHTML, like Gecko) Mobile/16D57 Quark/3.4.2.966 Mobile', '61.140.235.138', '2019-08-27 23:41:02', 0, 1002001015, '账号未登陆', '2019-08-27 23:41:02');
INSERT INTO `access_log` VALUES (72397, '65.50.15669204643439693', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 12_1_4 like Mac OS X; zh-cn) AppleWebKit/601.1.46 (KHTML, like Gecko) Mobile/16D57 Quark/3.4.2.966 Mobile', '113.67.72.164', '2019-08-27 23:41:04', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-27 23:41:04');
INSERT INTO `access_log` VALUES (72398, '65.52.15669233387819775', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:28:59', 0, 1002001015, '账号未登陆', '2019-08-28 00:28:59');
INSERT INTO `access_log` VALUES (72399, '65.49.15669233387819743', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:28:59', 0, 1002001015, '账号未登陆', '2019-08-28 00:28:59');
INSERT INTO `access_log` VALUES (72400, '65.53.15669233387829671', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:28:59', 0, 1002001015, '账号未登陆', '2019-08-28 00:28:59');
INSERT INTO `access_log` VALUES (72401, '65.3607.15669233418901537', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:29:02', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 00:29:02');
INSERT INTO `access_log` VALUES (72402, '65.51.15669233747839785', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:29:35', 97, 0, '', '2019-08-28 00:29:35');
INSERT INTO `access_log` VALUES (72403, '65.50.15669233752019733', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:29:35', 14, 0, '', '2019-08-28 00:29:35');
INSERT INTO `access_log` VALUES (72404, '65.46.15669233752069763', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:29:35', 12, 2001001000, '服务端发生异常', '2019-08-28 00:29:35');
INSERT INTO `access_log` VALUES (72405, '65.45.15669233752189761', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:29:35', 11, 0, '', '2019-08-28 00:29:35');
INSERT INTO `access_log` VALUES (72406, '65.51.15669234259869787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:30:26', 64, 0, '', '2019-08-28 00:30:26');
INSERT INTO `access_log` VALUES (72407, '65.47.15669234259839673', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:30:26', 68, 2001001000, '服务端发生异常', '2019-08-28 00:30:26');
INSERT INTO `access_log` VALUES (72408, '65.54.15669234259809629', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:30:26', 72, 0, '', '2019-08-28 00:30:26');
INSERT INTO `access_log` VALUES (72409, '65.45.15669234457329763', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:30:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 00:30:46');
INSERT INTO `access_log` VALUES (72410, '65.53.15669234590609675', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=user&password=admin&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:30:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 5-16 位\n密码长度为 6-16 位', '2019-08-28 00:30:59');
INSERT INTO `access_log` VALUES (72411, '65.3607.15669234862011541', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:31:26', 73, 0, '', '2019-08-28 00:31:26');
INSERT INTO `access_log` VALUES (72412, '65.51.15669234869879789', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:31:27', 18, 0, '', '2019-08-28 00:31:27');
INSERT INTO `access_log` VALUES (72413, '65.47.15669234869909675', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:31:27', 18, 0, '', '2019-08-28 00:31:27');
INSERT INTO `access_log` VALUES (72414, '65.54.15669234869889631', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:31:27', 19, 0, '', '2019-08-28 00:31:27');
INSERT INTO `access_log` VALUES (72415, '65.46.15669234952159767', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:31:35', 8, 0, '', '2019-08-28 00:31:35');
INSERT INTO `access_log` VALUES (72416, '65.45.15669234952249765', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:31:35', 9, 0, '', '2019-08-28 00:31:35');
INSERT INTO `access_log` VALUES (72417, '65.50.15669234952389737', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:31:35', 9, 0, '', '2019-08-28 00:31:35');
INSERT INTO `access_log` VALUES (72418, '65.49.15669235064369749', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:31:46', 9, 0, '', '2019-08-28 00:31:46');
INSERT INTO `access_log` VALUES (72419, '65.52.15669235064409781', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:31:46', 9, 0, '', '2019-08-28 00:31:46');
INSERT INTO `access_log` VALUES (72420, '65.3607.15669235064471543', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:31:46', 9, 0, '', '2019-08-28 00:31:46');
INSERT INTO `access_log` VALUES (72421, '65.47.15669235066389677', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:31:47', 26, 0, '', '2019-08-28 00:31:47');
INSERT INTO `access_log` VALUES (72422, '65.51.15669235185789791', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:31:59', 12, 0, '', '2019-08-28 00:31:59');
INSERT INTO `access_log` VALUES (72423, '65.50.15669235316739739', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:32:12', 16, 0, '', '2019-08-28 00:32:12');
INSERT INTO `access_log` VALUES (72424, '65.45.15669235405789767', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:32:21', 12, 0, '', '2019-08-28 00:32:21');
INSERT INTO `access_log` VALUES (72425, '65.49.15669235517859751', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:32:32', 9, 0, '', '2019-08-28 00:32:32');
INSERT INTO `access_log` VALUES (72426, '65.54.15669235940489635', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:33:14', 8, 0, '', '2019-08-28 00:33:14');
INSERT INTO `access_log` VALUES (72427, '65.51.15669235940559793', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:33:14', 8, 0, '', '2019-08-28 00:33:14');
INSERT INTO `access_log` VALUES (72428, '65.46.15669235940569771', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:33:14', 9, 0, '', '2019-08-28 00:33:14');
INSERT INTO `access_log` VALUES (72429, '59.79.15669235942776407', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:33:14', 23, 0, '', '2019-08-28 00:33:14');
INSERT INTO `access_log` VALUES (72430, '65.50.15669236028119741', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:33:23', 17, 0, '', '2019-08-28 00:33:23');
INSERT INTO `access_log` VALUES (72431, '65.45.15669236028159769', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:33:23', 16, 0, '', '2019-08-28 00:33:23');
INSERT INTO `access_log` VALUES (72432, '65.53.15669236028259681', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:33:23', 8, 0, '', '2019-08-28 00:33:23');
INSERT INTO `access_log` VALUES (72433, '65.52.15669236081819785', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:33:28', 8, 0, '', '2019-08-28 00:33:28');
INSERT INTO `access_log` VALUES (72434, '65.3607.15669236081851547', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:33:28', 7, 0, '', '2019-08-28 00:33:28');
INSERT INTO `access_log` VALUES (72435, '65.47.15669236081909681', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:33:28', 7, 0, '', '2019-08-28 00:33:28');
INSERT INTO `access_log` VALUES (72436, '65.51.15669236158509795', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:33:36', 19, 0, '', '2019-08-28 00:33:36');
INSERT INTO `access_log` VALUES (72437, '65.46.15669236158569773', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:33:36', 17, 0, '', '2019-08-28 00:33:36');
INSERT INTO `access_log` VALUES (72438, '65.54.15669236158679637', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:33:36', 9, 0, '', '2019-08-28 00:33:36');
INSERT INTO `access_log` VALUES (72439, '62.87.15669236160315021', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:33:36', 41, 0, '', '2019-08-28 00:33:36');
INSERT INTO `access_log` VALUES (72440, '65.53.15669236400319683', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:34:00', 9, 0, '', '2019-08-28 00:34:00');
INSERT INTO `access_log` VALUES (72441, '65.49.15669236400369755', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:34:00', 9, 0, '', '2019-08-28 00:34:00');
INSERT INTO `access_log` VALUES (72442, '65.52.15669236400409787', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:34:00', 8, 0, '', '2019-08-28 00:34:00');
INSERT INTO `access_log` VALUES (72443, '65.47.15669236402029683', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-CN; MIX 2 Build/PKQ1.190118.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '123.158.86.32', '2019-08-28 00:34:00', 13, 0, '', '2019-08-28 00:34:00');
INSERT INTO `access_log` VALUES (72444, '65.52.15669260110749819', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.136.0.233', '2019-08-28 01:13:31', 0, 1002001015, '账号未登陆', '2019-08-28 01:13:31');
INSERT INTO `access_log` VALUES (72445, '65.47.15669260110759715', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.136.0.233', '2019-08-28 01:13:31', 0, 1002001015, '账号未登陆', '2019-08-28 01:13:31');
INSERT INTO `access_log` VALUES (72446, '65.3607.15669260110751581', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.136.0.233', '2019-08-28 01:13:31', 0, 1002001015, '账号未登陆', '2019-08-28 01:13:31');
INSERT INTO `access_log` VALUES (72447, '65.54.15669260141349671', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.136.0.233', '2019-08-28 01:13:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 01:13:34');
INSERT INTO `access_log` VALUES (72448, '65.50.15669260351339777', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.136.0.233', '2019-08-28 01:13:55', 172, 0, '', '2019-08-28 01:13:55');
INSERT INTO `access_log` VALUES (72449, '65.45.15669260414139805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '117.136.0.233', '2019-08-28 01:14:01', 98, 0, '', '2019-08-28 01:14:02');
INSERT INTO `access_log` VALUES (72450, '65.46.15669489384510113', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '178.154.200.13', '2019-08-28 07:35:38', 0, 1002001015, '账号未登陆', '2019-08-28 07:35:38');
INSERT INTO `access_log` VALUES (72451, '65.50.15669489393040083', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '37.9.113.171', '2019-08-28 07:35:39', 0, 1002001015, '账号未登陆', '2019-08-28 07:35:39');
INSERT INTO `access_log` VALUES (72452, '65.45.15669489401980111', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '178.154.200.13', '2019-08-28 07:35:40', 0, 1002001015, '账号未登陆', '2019-08-28 07:35:40');
INSERT INTO `access_log` VALUES (72453, '65.54.15669533703370037', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:49:30', 1, 1002001015, '账号未登陆', '2019-08-28 08:49:30');
INSERT INTO `access_log` VALUES (72454, '65.46.15669533703370173', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:49:30', 0, 1002001015, '账号未登陆', '2019-08-28 08:49:30');
INSERT INTO `access_log` VALUES (72455, '65.51.15669533703460195', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:49:30', 1, 1002001015, '账号未登陆', '2019-08-28 08:49:30');
INSERT INTO `access_log` VALUES (72456, '65.50.15669533720030143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:49:32', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 08:49:32');
INSERT INTO `access_log` VALUES (72457, '65.49.15669533835480155', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:49:44', 73, 0, '', '2019-08-28 08:49:44');
INSERT INTO `access_log` VALUES (72458, '65.53.15669533838260083', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:49:44', 15, 0, '', '2019-08-28 08:49:44');
INSERT INTO `access_log` VALUES (72459, '65.52.15669533838300187', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:49:44', 13, 0, '', '2019-08-28 08:49:44');
INSERT INTO `access_log` VALUES (72460, '65.3607.15669533838291949', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:49:44', 14, 2001001000, '服务端发生异常', '2019-08-28 08:49:44');
INSERT INTO `access_log` VALUES (72461, '65.54.15669533951310039', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:49:55', 11, 0, '', '2019-08-28 08:49:55');
INSERT INTO `access_log` VALUES (72462, '65.46.15669533951320175', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:49:55', 11, 2001001000, '服务端发生异常', '2019-08-28 08:49:55');
INSERT INTO `access_log` VALUES (72463, '65.51.15669533951340197', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:49:55', 12, 0, '', '2019-08-28 08:49:55');
INSERT INTO `access_log` VALUES (72464, '59.72.15669535352666803', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:52:15', 13, 0, '', '2019-08-28 08:52:15');
INSERT INTO `access_log` VALUES (72465, '59.74.15669535352676815', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:52:15', 27, 2001001000, '服务端发生异常', '2019-08-28 08:52:15');
INSERT INTO `access_log` VALUES (72466, '64.83.15669535385857203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:52:19', 12, 0, '', '2019-08-28 08:52:19');
INSERT INTO `access_log` VALUES (72467, '64.84.15669535387257201', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:52:19', 3, 0, '', '2019-08-28 08:52:19');
INSERT INTO `access_log` VALUES (72468, '64.78.15669535399217229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:52:20', 2, 0, '', '2019-08-28 08:52:20');
INSERT INTO `access_log` VALUES (72469, '64.81.15669535405777211', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:52:21', 2, 0, '', '2019-08-28 08:52:21');
INSERT INTO `access_log` VALUES (72470, '64.80.15669535410807209', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:52:21', 2, 0, '', '2019-08-28 08:52:21');
INSERT INTO `access_log` VALUES (72471, '64.85.15669535442967225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:52:24', 2, 0, '', '2019-08-28 08:52:24');
INSERT INTO `access_log` VALUES (72472, '64.79.15669535444437205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:52:24', 2, 0, '', '2019-08-28 08:52:24');
INSERT INTO `access_log` VALUES (72473, '59.79.15669535456056807', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:52:26', 3, 0, '', '2019-08-28 08:52:26');
INSERT INTO `access_log` VALUES (72474, '59.71.15669535456056801', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:52:26', 22, 2001001000, '服务端发生异常', '2019-08-28 08:52:26');
INSERT INTO `access_log` VALUES (72475, '65.49.15669535807750159', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:53:01', 9, 0, '', '2019-08-28 08:53:01');
INSERT INTO `access_log` VALUES (72476, '65.3607.15669535807871953', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:53:01', 9, 2001001000, '服务端发生异常', '2019-08-28 08:53:01');
INSERT INTO `access_log` VALUES (72477, '65.52.15669535807870191', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:53:01', 10, 0, '', '2019-08-28 08:53:01');
INSERT INTO `access_log` VALUES (72478, '65.53.15669535848220087', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:53:05', 9, 0, '', '2019-08-28 08:53:05');
INSERT INTO `access_log` VALUES (72479, '65.47.15669535848230087', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:53:05', 9, 2001001000, '服务端发生异常', '2019-08-28 08:53:05');
INSERT INTO `access_log` VALUES (72480, '65.54.15669535848250043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:53:05', 10, 0, '', '2019-08-28 08:53:05');
INSERT INTO `access_log` VALUES (72481, '65.51.15669535873950201', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:53:07', 9, 0, '', '2019-08-28 08:53:07');
INSERT INTO `access_log` VALUES (72482, '65.46.15669535873980179', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:53:07', 9, 2001001000, '服务端发生异常', '2019-08-28 08:53:07');
INSERT INTO `access_log` VALUES (72483, '65.50.15669535873990149', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:53:07', 10, 0, '', '2019-08-28 08:53:07');
INSERT INTO `access_log` VALUES (72484, '65.52.15669535908930193', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:53:11', 10, 0, '', '2019-08-28 08:53:11');
INSERT INTO `access_log` VALUES (72485, '65.3607.15669535908951955', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:53:11', 9, 0, '', '2019-08-28 08:53:11');
INSERT INTO `access_log` VALUES (72486, '65.49.15669535908950161', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:53:11', 10, 2001001000, '服务端发生异常', '2019-08-28 08:53:11');
INSERT INTO `access_log` VALUES (72487, '65.53.15669536171420089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:53:37', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 08:53:37');
INSERT INTO `access_log` VALUES (72488, '65.50.15669536225910151', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '59.172.37.250', '2019-08-28 08:53:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 08:53:43');
INSERT INTO `access_log` VALUES (72489, '59.72.15669545381776817', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3887.7 Safari/537.36', '58.32.5.50', '2019-08-28 09:08:58', 3, 0, '', '2019-08-28 09:08:58');
INSERT INTO `access_log` VALUES (72490, '59.73.15669545381776819', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3887.7 Safari/537.36', '58.32.5.50', '2019-08-28 09:08:58', 22, 2001001000, '服务端发生异常', '2019-08-28 09:08:58');
INSERT INTO `access_log` VALUES (72491, '64.81.15669545412637225', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3887.7 Safari/537.36', '58.32.5.50', '2019-08-28 09:09:01', 2, 0, '', '2019-08-28 09:09:01');
INSERT INTO `access_log` VALUES (72492, '64.80.15669545413587223', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3887.7 Safari/537.36', '58.32.5.50', '2019-08-28 09:09:01', 1, 0, '', '2019-08-28 09:09:01');
INSERT INTO `access_log` VALUES (72493, '64.85.15669545423197239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3887.7 Safari/537.36', '58.32.5.50', '2019-08-28 09:09:02', 2, 0, '', '2019-08-28 09:09:02');
INSERT INTO `access_log` VALUES (72494, '64.79.15669545426907219', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3887.7 Safari/537.36', '58.32.5.50', '2019-08-28 09:09:03', 2, 0, '', '2019-08-28 09:09:03');
INSERT INTO `access_log` VALUES (72495, '65.53.15669550460140109', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-28 09:17:26', 4, 1002001012, '访问令牌已过期', '2019-08-28 09:17:26');
INSERT INTO `access_log` VALUES (72496, '65.47.15669550460140109', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-28 09:17:26', 6, 1002001012, '访问令牌已过期', '2019-08-28 09:17:26');
INSERT INTO `access_log` VALUES (72497, '65.52.15669550460130213', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.240.18', '2019-08-28 09:17:26', 9, 1002001012, '访问令牌已过期', '2019-08-28 09:17:26');
INSERT INTO `access_log` VALUES (72498, '59.75.15669575601726865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1031.400 QQBrowser/9.0.2524.400', '218.5.241.6', '2019-08-28 09:59:20', 11, 0, '', '2019-08-28 09:59:20');
INSERT INTO `access_log` VALUES (72499, '59.76.15669575601966849', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/53.0.2785.116 Safari/537.36 QBCore/3.53.1031.400 QQBrowser/9.0.2524.400', '218.5.241.6', '2019-08-28 09:59:20', 16, 2001001000, '服务端发生异常', '2019-08-28 09:59:20');
INSERT INTO `access_log` VALUES (72500, '65.54.15669628750620169', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.67.2', '2019-08-28 11:27:55', 12, 1002001012, '访问令牌已过期', '2019-08-28 11:27:55');
INSERT INTO `access_log` VALUES (72501, '65.50.15669628750630275', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.67.2', '2019-08-28 11:27:55', 14, 1002001012, '访问令牌已过期', '2019-08-28 11:27:55');
INSERT INTO `access_log` VALUES (72502, '65.46.15669628750650307', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.67.2', '2019-08-28 11:27:55', 14, 1002001012, '访问令牌已过期', '2019-08-28 11:27:55');
INSERT INTO `access_log` VALUES (72503, '65.51.15669628767580327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.67.2', '2019-08-28 11:27:57', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 11:27:57');
INSERT INTO `access_log` VALUES (72504, '65.3607.15669628830692081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.67.2', '2019-08-28 11:28:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 11:28:03');
INSERT INTO `access_log` VALUES (72505, '65.53.15669628895400219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai5&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.67.2', '2019-08-28 11:28:10', 126, 0, '', '2019-08-28 11:28:10');
INSERT INTO `access_log` VALUES (72506, '65.49.15669628898820291', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.67.2', '2019-08-28 11:28:10', 12, 0, '', '2019-08-28 11:28:10');
INSERT INTO `access_log` VALUES (72507, '65.52.15669628898880323', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.67.2', '2019-08-28 11:28:10', 12, 0, '', '2019-08-28 11:28:10');
INSERT INTO `access_log` VALUES (72508, '65.47.15669628898880217', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '116.24.67.2', '2019-08-28 11:28:10', 12, 0, '', '2019-08-28 11:28:10');
INSERT INTO `access_log` VALUES (72509, '59.73.15669631935666935', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.221.9.229', '2019-08-28 11:33:14', 8, 0, '', '2019-08-28 11:33:14');
INSERT INTO `access_log` VALUES (72510, '59.71.15669631935676931', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.221.9.229', '2019-08-28 11:33:14', 14, 2001001000, '服务端发生异常', '2019-08-28 11:33:14');
INSERT INTO `access_log` VALUES (72511, '64.85.15669632039867355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.221.9.229', '2019-08-28 11:33:24', 86, 0, '', '2019-08-28 11:33:24');
INSERT INTO `access_log` VALUES (72512, '64.79.15669632041917335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.221.9.229', '2019-08-28 11:33:24', 3, 0, '', '2019-08-28 11:33:24');
INSERT INTO `access_log` VALUES (72513, '64.76.15669632050307341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.221.9.229', '2019-08-28 11:33:25', 2, 0, '', '2019-08-28 11:33:25');
INSERT INTO `access_log` VALUES (72514, '64.82.15669632056517349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.221.9.229', '2019-08-28 11:33:26', 2, 0, '', '2019-08-28 11:33:26');
INSERT INTO `access_log` VALUES (72515, '59.76.15669632072936925', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.221.9.229', '2019-08-28 11:33:27', 2, 0, '', '2019-08-28 11:33:27');
INSERT INTO `access_log` VALUES (72516, '59.75.15669632072936941', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.221.9.229', '2019-08-28 11:33:27', 16, 2001001000, '服务端发生异常', '2019-08-28 11:33:27');
INSERT INTO `access_log` VALUES (72517, '65.51.15669636844340339', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.87.117.45', '2019-08-28 11:41:24', 1, 1002001015, '账号未登陆', '2019-08-28 11:41:24');
INSERT INTO `access_log` VALUES (72518, '65.3607.15669636844362093', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.87.117.45', '2019-08-28 11:41:24', 0, 1002001015, '账号未登陆', '2019-08-28 11:41:24');
INSERT INTO `access_log` VALUES (72519, '65.45.15669636844480315', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.87.117.45', '2019-08-28 11:41:24', 0, 1002001015, '账号未登陆', '2019-08-28 11:41:24');
INSERT INTO `access_log` VALUES (72520, '65.53.15669636875180231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.87.117.45', '2019-08-28 11:41:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 11:41:28');
INSERT INTO `access_log` VALUES (72521, '65.47.15669636954680229', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.87.117.45', '2019-08-28 11:41:35', 71, 0, '', '2019-08-28 11:41:36');
INSERT INTO `access_log` VALUES (72522, '65.49.15669636962200303', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.87.117.45', '2019-08-28 11:41:36', 9, 0, '', '2019-08-28 11:41:36');
INSERT INTO `access_log` VALUES (72523, '65.52.15669636962230335', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.87.117.45', '2019-08-28 11:41:36', 9, 2001001000, '服务端发生异常', '2019-08-28 11:41:36');
INSERT INTO `access_log` VALUES (72524, '65.46.15669636962230321', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.87.117.45', '2019-08-28 11:41:36', 9, 0, '', '2019-08-28 11:41:36');
INSERT INTO `access_log` VALUES (72525, '65.52.15669637934140337', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.87.117.45', '2019-08-28 11:43:13', 10, 0, '', '2019-08-28 11:43:13');
INSERT INTO `access_log` VALUES (72526, '65.49.15669637934260305', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.87.117.45', '2019-08-28 11:43:13', 10, 0, '', '2019-08-28 11:43:13');
INSERT INTO `access_log` VALUES (72527, '65.46.15669637934250323', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.87.117.45', '2019-08-28 11:43:13', 11, 2001001000, '服务端发生异常', '2019-08-28 11:43:13');
INSERT INTO `access_log` VALUES (72528, '65.49.15669645239410315', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '118.250.48.54', '2019-08-28 11:55:24', 0, 1002001015, '账号未登陆', '2019-08-28 11:55:24');
INSERT INTO `access_log` VALUES (72529, '65.50.15669645239450301', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '118.250.48.54', '2019-08-28 11:55:24', 0, 1002001015, '账号未登陆', '2019-08-28 11:55:24');
INSERT INTO `access_log` VALUES (72530, '65.54.15669645239540195', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '118.250.48.54', '2019-08-28 11:55:24', 0, 1002001015, '账号未登陆', '2019-08-28 11:55:24');
INSERT INTO `access_log` VALUES (72531, '65.51.15669645434910353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '118.250.48.54', '2019-08-28 11:55:43', 92, 0, '', '2019-08-28 11:55:44');
INSERT INTO `access_log` VALUES (72532, '65.45.15669645438860329', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '118.250.48.54', '2019-08-28 11:55:44', 111, 0, '', '2019-08-28 11:55:44');
INSERT INTO `access_log` VALUES (72533, '65.53.15669645438920245', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '118.250.48.54', '2019-08-28 11:55:44', 110, 2001001000, '服务端发生异常', '2019-08-28 11:55:44');
INSERT INTO `access_log` VALUES (72534, '65.47.15669645439000243', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '118.250.48.54', '2019-08-28 11:55:44', 100, 0, '', '2019-08-28 11:55:44');
INSERT INTO `access_log` VALUES (72535, '59.80.15669645898796925', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '118.250.48.54', '2019-08-28 11:56:30', 4, 0, '', '2019-08-28 11:56:30');
INSERT INTO `access_log` VALUES (72536, '59.74.15669645898806965', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '118.250.48.54', '2019-08-28 11:56:30', 14, 2001001000, '服务端发生异常', '2019-08-28 11:56:30');
INSERT INTO `access_log` VALUES (72537, '65.49.15669707186150399', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '1.119.129.18', '2019-08-28 13:38:39', 0, 1002001015, '账号未登陆', '2019-08-28 13:38:39');
INSERT INTO `access_log` VALUES (72538, '65.46.15669707186140417', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '1.119.129.18', '2019-08-28 13:38:39', 0, 1002001015, '账号未登陆', '2019-08-28 13:38:39');
INSERT INTO `access_log` VALUES (72539, '65.54.15669707186350279', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '1.119.129.18', '2019-08-28 13:38:39', 1, 1002001015, '账号未登陆', '2019-08-28 13:38:39');
INSERT INTO `access_log` VALUES (72540, '65.3607.15669707224162191', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '1.119.129.18', '2019-08-28 13:38:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 13:38:42');
INSERT INTO `access_log` VALUES (72541, '65.51.15669707321450437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '1.119.129.18', '2019-08-28 13:38:52', 163, 0, '', '2019-08-28 13:38:52');
INSERT INTO `access_log` VALUES (72542, '65.45.15669707402240413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '1.119.129.18', '2019-08-28 13:39:00', 118, 0, '', '2019-08-28 13:39:00');
INSERT INTO `access_log` VALUES (72543, '65.45.15669717798470427', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '1.119.129.18', '2019-08-28 13:56:20', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 13:56:20');
INSERT INTO `access_log` VALUES (72544, '65.47.15669717825700341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '1.119.129.18', '2019-08-28 13:56:23', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 13:56:23');
INSERT INTO `access_log` VALUES (72545, '65.49.15669717860860415', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '1.119.129.18', '2019-08-28 13:56:26', 127, 0, '', '2019-08-28 13:56:26');
INSERT INTO `access_log` VALUES (72546, '65.45.15669724810860437', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.87.206.125', '2019-08-28 14:08:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 14:08:01');
INSERT INTO `access_log` VALUES (72547, '65.49.15669725148960425', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.87.206.125', '2019-08-28 14:08:35', 79, 0, '', '2019-08-28 14:08:35');
INSERT INTO `access_log` VALUES (72548, '65.54.15669725155210305', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.87.206.125', '2019-08-28 14:08:36', 230, 0, '', '2019-08-28 14:08:36');
INSERT INTO `access_log` VALUES (72549, '65.46.15669725155170443', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.87.206.125', '2019-08-28 14:08:36', 234, 0, '', '2019-08-28 14:08:36');
INSERT INTO `access_log` VALUES (72550, '65.50.15669725155210411', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '223.87.206.125', '2019-08-28 14:08:36', 232, 2001001000, '服务端发生异常', '2019-08-28 14:08:36');
INSERT INTO `access_log` VALUES (72551, '65.53.15669726039550357', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '118.186.226.226', '2019-08-28 14:10:04', 91, 0, '', '2019-08-28 14:10:04');
INSERT INTO `access_log` VALUES (72552, '65.45.15669726043370441', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '118.186.226.226', '2019-08-28 14:10:04', 9, 0, '', '2019-08-28 14:10:04');
INSERT INTO `access_log` VALUES (72553, '65.52.15669726043430459', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '118.186.226.226', '2019-08-28 14:10:04', 9, 0, '', '2019-08-28 14:10:04');
INSERT INTO `access_log` VALUES (72554, '65.47.15669726043430353', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '118.186.226.226', '2019-08-28 14:10:04', 9, 2001001000, '服务端发生异常', '2019-08-28 14:10:04');
INSERT INTO `access_log` VALUES (72555, '59.71.15669758356117101', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.223.198.90', '2019-08-28 15:03:56', 27, 2001001000, '服务端发生异常', '2019-08-28 15:03:56');
INSERT INTO `access_log` VALUES (72556, '59.72.15669758356117103', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.223.198.90', '2019-08-28 15:03:56', 35, 0, '', '2019-08-28 15:03:56');
INSERT INTO `access_log` VALUES (72557, '64.78.15669758385327529', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.223.198.90', '2019-08-28 15:03:59', 11, 0, '', '2019-08-28 15:03:59');
INSERT INTO `access_log` VALUES (72558, '64.77.15669758386927487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.223.198.90', '2019-08-28 15:03:59', 3, 0, '', '2019-08-28 15:03:59');
INSERT INTO `access_log` VALUES (72559, '64.81.15669758429037511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.223.198.90', '2019-08-28 15:04:03', 2, 0, '', '2019-08-28 15:04:03');
INSERT INTO `access_log` VALUES (72560, '64.80.15669758434407509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.223.198.90', '2019-08-28 15:04:03', 2, 0, '', '2019-08-28 15:04:03');
INSERT INTO `access_log` VALUES (72561, '59.79.15669758443657107', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.223.198.90', '2019-08-28 15:04:04', 3, 0, '', '2019-08-28 15:04:04');
INSERT INTO `access_log` VALUES (72562, '59.76.15669758443687095', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.223.198.90', '2019-08-28 15:04:04', 17, 2001001000, '服务端发生异常', '2019-08-28 15:04:04');
INSERT INTO `access_log` VALUES (72563, '64.79.15669758467077505', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.223.198.90', '2019-08-28 15:04:07', 2, 0, '', '2019-08-28 15:04:07');
INSERT INTO `access_log` VALUES (72564, '64.76.15669758468717511', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.223.198.90', '2019-08-28 15:04:07', 2, 0, '', '2019-08-28 15:04:07');
INSERT INTO `access_log` VALUES (72565, '59.75.15669758473837111', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.223.198.90', '2019-08-28 15:04:07', 2, 0, '', '2019-08-28 15:04:07');
INSERT INTO `access_log` VALUES (72566, '59.78.15669758473837117', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.223.198.90', '2019-08-28 15:04:07', 15, 2001001000, '服务端发生异常', '2019-08-28 15:04:07');
INSERT INTO `access_log` VALUES (72567, '65.49.15669788704440513', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.152.68.46', '2019-08-28 15:54:30', 13, 1002001012, '访问令牌已过期', '2019-08-28 15:54:30');
INSERT INTO `access_log` VALUES (72568, '65.50.15669788704450501', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.152.68.46', '2019-08-28 15:54:30', 15, 1002001012, '访问令牌已过期', '2019-08-28 15:54:30');
INSERT INTO `access_log` VALUES (72569, '65.54.15669788704650389', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.152.68.46', '2019-08-28 15:54:30', 18, 1002001012, '访问令牌已过期', '2019-08-28 15:54:30');
INSERT INTO `access_log` VALUES (72570, '65.47.15669788724380439', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.152.68.46', '2019-08-28 15:54:32', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 15:54:32');
INSERT INTO `access_log` VALUES (72571, '65.45.15669788764530529', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.152.68.46', '2019-08-28 15:54:36', 204, 0, '', '2019-08-28 15:54:37');
INSERT INTO `access_log` VALUES (72572, '65.53.15669788770110443', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.152.68.46', '2019-08-28 15:54:37', 20, 0, '', '2019-08-28 15:54:37');
INSERT INTO `access_log` VALUES (72573, '65.3607.15669788770152303', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.152.68.46', '2019-08-28 15:54:37', 19, 0, '', '2019-08-28 15:54:37');
INSERT INTO `access_log` VALUES (72574, '65.46.15669788770270533', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.152.68.46', '2019-08-28 15:54:37', 8, 0, '', '2019-08-28 15:54:37');
INSERT INTO `access_log` VALUES (72575, '62.80.15669788818355783', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.152.68.46', '2019-08-28 15:54:42', 31, 0, '', '2019-08-28 15:54:42');
INSERT INTO `access_log` VALUES (72576, '62.89.15669788836965773', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.152.68.46', '2019-08-28 15:54:44', 21, 0, '', '2019-08-28 15:54:44');
INSERT INTO `access_log` VALUES (72577, '66.52.15669788935714599', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.152.68.46', '2019-08-28 15:54:54', 20, 0, '', '2019-08-28 15:54:54');
INSERT INTO `access_log` VALUES (72578, '59.78.15669810933347187', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-28 16:31:33', 11, 0, '', '2019-08-28 16:31:33');
INSERT INTO `access_log` VALUES (72579, '59.77.15669810933357163', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-28 16:31:33', 30, 2001001000, '服务端发生异常', '2019-08-28 16:31:33');
INSERT INTO `access_log` VALUES (72580, '59.74.15669811080037187', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-28 16:31:48', 3, 0, '', '2019-08-28 16:31:48');
INSERT INTO `access_log` VALUES (72581, '59.71.15669811080047173', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-28 16:31:48', 18, 2001001000, '服务端发生异常', '2019-08-28 16:31:48');
INSERT INTO `access_log` VALUES (72582, '65.49.15669811167670545', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-28 16:31:57', 4, 1002001012, '访问令牌已过期', '2019-08-28 16:31:57');
INSERT INTO `access_log` VALUES (72583, '65.50.15669811167690533', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-28 16:31:57', 3, 1002001012, '访问令牌已过期', '2019-08-28 16:31:57');
INSERT INTO `access_log` VALUES (72584, '65.54.15669811167900421', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-28 16:31:57', 11, 1002001012, '访问令牌已过期', '2019-08-28 16:31:57');
INSERT INTO `access_log` VALUES (72585, '65.47.15669811189180471', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-28 16:31:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 16:31:59');
INSERT INTO `access_log` VALUES (72586, '65.45.15669811349610561', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-28 16:32:15', 184, 0, '', '2019-08-28 16:32:15');
INSERT INTO `access_log` VALUES (72587, '65.53.15669811355740477', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-28 16:32:16', 9, 0, '', '2019-08-28 16:32:16');
INSERT INTO `access_log` VALUES (72588, '65.52.15669811355950581', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-28 16:32:16', 11, 0, '', '2019-08-28 16:32:16');
INSERT INTO `access_log` VALUES (72589, '65.46.15669811355940565', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-28 16:32:16', 11, 2001001000, '服务端发生异常', '2019-08-28 16:32:16');
INSERT INTO `access_log` VALUES (72590, '59.75.15669829647617207', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:02:45', 9, 0, '', '2019-08-28 17:02:45');
INSERT INTO `access_log` VALUES (72591, '59.78.15669829647627213', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:02:45', 17, 2001001000, '服务端发生异常', '2019-08-28 17:02:45');
INSERT INTO `access_log` VALUES (72592, '59.71.15669830118787199', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.48.202', '2019-08-28 17:03:32', 24, 2001001000, '服务端发生异常', '2019-08-28 17:03:32');
INSERT INTO `access_log` VALUES (72593, '64.79.15669833374147605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:08:57', 12, 0, '', '2019-08-28 17:08:57');
INSERT INTO `access_log` VALUES (72594, '64.81.15669833375407611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:08:58', 3, 0, '', '2019-08-28 17:08:58');
INSERT INTO `access_log` VALUES (72595, '64.82.15669833489797619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:09:09', 2, 0, '', '2019-08-28 17:09:09');
INSERT INTO `access_log` VALUES (72596, '64.83.15669833491417607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:09:09', 1, 0, '', '2019-08-28 17:09:09');
INSERT INTO `access_log` VALUES (72597, '59.76.15669833517307197', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:09:12', 5, 0, '', '2019-08-28 17:09:12');
INSERT INTO `access_log` VALUES (72598, '59.78.15669833517427219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:09:12', 15, 2001001000, '服务端发生异常', '2019-08-28 17:09:12');
INSERT INTO `access_log` VALUES (72599, '64.77.15669833636017589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:09:24', 2, 0, '', '2019-08-28 17:09:24');
INSERT INTO `access_log` VALUES (72600, '64.80.15669833636917613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:09:24', 3, 0, '', '2019-08-28 17:09:24');
INSERT INTO `access_log` VALUES (72601, '64.78.15669833649117633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:09:25', 2, 0, '', '2019-08-28 17:09:25');
INSERT INTO `access_log` VALUES (72602, '64.85.15669833657647629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:09:26', 2, 0, '', '2019-08-28 17:09:26');
INSERT INTO `access_log` VALUES (72603, '64.79.15669833671087607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:09:27', 2, 0, '', '2019-08-28 17:09:27');
INSERT INTO `access_log` VALUES (72604, '59.77.15669833686987195', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:09:29', 3, 0, '', '2019-08-28 17:09:29');
INSERT INTO `access_log` VALUES (72605, '59.80.15669833686987179', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.236.48.202', '2019-08-28 17:09:29', 18, 2001001000, '服务端发生异常', '2019-08-28 17:09:29');
INSERT INTO `access_log` VALUES (72606, '59.71.15669836776957209', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:38', 2, 0, '', '2019-08-28 17:14:38');
INSERT INTO `access_log` VALUES (72607, '59.72.15669836776957211', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:38', 15, 2001001000, '服务端发生异常', '2019-08-28 17:14:38');
INSERT INTO `access_log` VALUES (72608, '64.76.15669836803857619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:40', 3, 0, '', '2019-08-28 17:14:40');
INSERT INTO `access_log` VALUES (72609, '64.82.15669836805067625', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:41', 2, 0, '', '2019-08-28 17:14:41');
INSERT INTO `access_log` VALUES (72610, '64.83.15669836817037613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:42', 2, 0, '', '2019-08-28 17:14:42');
INSERT INTO `access_log` VALUES (72611, '64.84.15669836821007609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:42', 2, 0, '', '2019-08-28 17:14:42');
INSERT INTO `access_log` VALUES (72612, '64.77.15669836823587595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:42', 2, 0, '', '2019-08-28 17:14:42');
INSERT INTO `access_log` VALUES (72613, '64.80.15669836825887619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:43', 2, 0, '', '2019-08-28 17:14:43');
INSERT INTO `access_log` VALUES (72614, '64.78.15669836834037639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:43', 3, 0, '', '2019-08-28 17:14:43');
INSERT INTO `access_log` VALUES (72615, '59.73.15669836838117213', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:44', 2, 0, '', '2019-08-28 17:14:44');
INSERT INTO `access_log` VALUES (72616, '59.79.15669836838137215', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:44', 31, 2001001000, '服务端发生异常', '2019-08-28 17:14:44');
INSERT INTO `access_log` VALUES (72617, '64.85.15669836882797635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:48', 2, 0, '', '2019-08-28 17:14:48');
INSERT INTO `access_log` VALUES (72618, '64.79.15669836885077613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:49', 1, 0, '', '2019-08-28 17:14:49');
INSERT INTO `access_log` VALUES (72619, '59.78.15669836897927225', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:50', 84, 0, '', '2019-08-28 17:14:50');
INSERT INTO `access_log` VALUES (72620, '59.75.15669836900937219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:14:50', 10, 2001001000, '服务端发生异常', '2019-08-28 17:14:50');
INSERT INTO `access_log` VALUES (72621, '59.77.15669837000507201', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:15:00', 2, 0, '', '2019-08-28 17:15:00');
INSERT INTO `access_log` VALUES (72622, '59.80.15669837000577185', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:15:00', 12, 2001001000, '服务端发生异常', '2019-08-28 17:15:00');
INSERT INTO `access_log` VALUES (72623, '59.71.15669837093617211', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:15:09', 9, 0, '', '2019-08-28 17:15:09');
INSERT INTO `access_log` VALUES (72624, '59.72.15669837093617213', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:15:09', 18, 2001001000, '服务端发生异常', '2019-08-28 17:15:09');
INSERT INTO `access_log` VALUES (72625, '64.82.15669837115807627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:15:12', 2, 0, '', '2019-08-28 17:15:12');
INSERT INTO `access_log` VALUES (72626, '64.83.15669837118057615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:15:12', 2, 0, '', '2019-08-28 17:15:12');
INSERT INTO `access_log` VALUES (72627, '64.84.15669837135687611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:15:14', 2, 0, '', '2019-08-28 17:15:14');
INSERT INTO `access_log` VALUES (72628, '65.50.15669837227560569', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.48.202', '2019-08-28 17:15:23', 0, 1002001015, '账号未登陆', '2019-08-28 17:15:23');
INSERT INTO `access_log` VALUES (72629, '65.54.15669837227560457', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.48.202', '2019-08-28 17:15:23', 0, 1002001015, '账号未登陆', '2019-08-28 17:15:23');
INSERT INTO `access_log` VALUES (72630, '65.47.15669837227570507', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.48.202', '2019-08-28 17:15:23', 0, 1002001015, '账号未登陆', '2019-08-28 17:15:23');
INSERT INTO `access_log` VALUES (72631, '65.45.15669837248450597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.48.202', '2019-08-28 17:15:25', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 17:15:25');
INSERT INTO `access_log` VALUES (72632, '64.80.15669837299677621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:15:30', 2, 0, '', '2019-08-28 17:15:30');
INSERT INTO `access_log` VALUES (72633, '64.78.15669837310637641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:15:31', 2, 0, '', '2019-08-28 17:15:31');
INSERT INTO `access_log` VALUES (72634, '64.85.15669837316787637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:15:32', 2, 0, '', '2019-08-28 17:15:32');
INSERT INTO `access_log` VALUES (72635, '64.79.15669837322957615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:15:32', 1, 0, '', '2019-08-28 17:15:32');
INSERT INTO `access_log` VALUES (72636, '64.81.15669837331747621', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:15:33', 2, 0, '', '2019-08-28 17:15:33');
INSERT INTO `access_log` VALUES (72637, '64.76.15669837338307623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:15:34', 2, 0, '', '2019-08-28 17:15:34');
INSERT INTO `access_log` VALUES (72638, '64.82.15669837342817629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:15:34', 2, 0, '', '2019-08-28 17:15:34');
INSERT INTO `access_log` VALUES (72639, '65.53.15669837380650513', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.48.202', '2019-08-28 17:15:38', 154, 0, '', '2019-08-28 17:15:38');
INSERT INTO `access_log` VALUES (72640, '65.52.15669837384560617', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.48.202', '2019-08-28 17:15:38', 11, 0, '', '2019-08-28 17:15:38');
INSERT INTO `access_log` VALUES (72641, '65.46.15669837384600601', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.48.202', '2019-08-28 17:15:38', 10, 2001001000, '服务端发生异常', '2019-08-28 17:15:38');
INSERT INTO `access_log` VALUES (72642, '65.51.15669837384630623', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.48.202', '2019-08-28 17:15:38', 9, 0, '', '2019-08-28 17:15:38');
INSERT INTO `access_log` VALUES (72643, '59.80.15669837806167187', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:16:21', 3, 0, '', '2019-08-28 17:16:21');
INSERT INTO `access_log` VALUES (72644, '59.77.15669837806247203', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:16:21', 14, 2001001000, '服务端发生异常', '2019-08-28 17:16:21');
INSERT INTO `access_log` VALUES (72645, '59.74.15669837820197227', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:16:22', 2, 0, '', '2019-08-28 17:16:22');
INSERT INTO `access_log` VALUES (72646, '59.71.15669837823207213', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '221.181.101.37', '2019-08-28 17:16:22', 13, 2001001000, '服务端发生异常', '2019-08-28 17:16:22');
INSERT INTO `access_log` VALUES (72647, '59.71.15669839242287215', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.172.187.254', '2019-08-28 17:18:44', 3, 0, '', '2019-08-28 17:18:44');
INSERT INTO `access_log` VALUES (72648, '59.72.15669839242287217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.172.187.254', '2019-08-28 17:18:44', 18, 2001001000, '服务端发生异常', '2019-08-28 17:18:44');
INSERT INTO `access_log` VALUES (72649, '65.3607.15669839465802375', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.172.187.254', '2019-08-28 17:19:07', 1, 1002001015, '账号未登陆', '2019-08-28 17:19:07');
INSERT INTO `access_log` VALUES (72650, '65.45.15669839465820601', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.172.187.254', '2019-08-28 17:19:07', 0, 1002001015, '账号未登陆', '2019-08-28 17:19:07');
INSERT INTO `access_log` VALUES (72651, '65.53.15669839465840517', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.172.187.254', '2019-08-28 17:19:07', 0, 1002001015, '账号未登陆', '2019-08-28 17:19:07');
INSERT INTO `access_log` VALUES (72652, '65.51.15669839528210627', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.172.187.254', '2019-08-28 17:19:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 17:19:13');
INSERT INTO `access_log` VALUES (72653, '65.49.15669839647420587', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.172.187.254', '2019-08-28 17:19:25', 68, 0, '', '2019-08-28 17:19:25');
INSERT INTO `access_log` VALUES (72654, '65.54.15669839650500463', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.172.187.254', '2019-08-28 17:19:25', 8, 0, '', '2019-08-28 17:19:25');
INSERT INTO `access_log` VALUES (72655, '65.50.15669839650520575', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.172.187.254', '2019-08-28 17:19:25', 8, 2001001000, '服务端发生异常', '2019-08-28 17:19:25');
INSERT INTO `access_log` VALUES (72656, '65.47.15669839650540513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.172.187.254', '2019-08-28 17:19:25', 7, 0, '', '2019-08-28 17:19:25');
INSERT INTO `access_log` VALUES (72657, '65.52.15669844725790629', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.198.178.189', '2019-08-28 17:27:53', 263, 1002001012, '访问令牌已过期', '2019-08-28 17:27:53');
INSERT INTO `access_log` VALUES (72658, '65.46.15669844725800615', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.198.178.189', '2019-08-28 17:27:53', 263, 1002001012, '访问令牌已过期', '2019-08-28 17:27:53');
INSERT INTO `access_log` VALUES (72659, '65.45.15669844725710609', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.198.178.189', '2019-08-28 17:27:53', 271, 1002001012, '访问令牌已过期', '2019-08-28 17:27:53');
INSERT INTO `access_log` VALUES (72660, '65.50.15669844762780581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.198.178.189', '2019-08-28 17:27:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 17:27:56');
INSERT INTO `access_log` VALUES (72661, '65.47.15669844954610525', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.198.178.189', '2019-08-28 17:28:15', 88, 0, '', '2019-08-28 17:28:16');
INSERT INTO `access_log` VALUES (72662, '65.54.15669844958090471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.198.178.189', '2019-08-28 17:28:16', 9, 0, '', '2019-08-28 17:28:16');
INSERT INTO `access_log` VALUES (72663, '65.3607.15669844958212385', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.198.178.189', '2019-08-28 17:28:16', 9, 2001001000, '服务端发生异常', '2019-08-28 17:28:16');
INSERT INTO `access_log` VALUES (72664, '65.51.15669844958220637', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.198.178.189', '2019-08-28 17:28:16', 9, 0, '', '2019-08-28 17:28:16');
INSERT INTO `access_log` VALUES (72665, '65.53.15669854987930543', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.116.170.180', '2019-08-28 17:44:59', 0, 1002001015, '账号未登陆', '2019-08-28 17:44:59');
INSERT INTO `access_log` VALUES (72666, '65.47.15669854987950539', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.116.170.180', '2019-08-28 17:44:59', 0, 1002001015, '账号未登陆', '2019-08-28 17:44:59');
INSERT INTO `access_log` VALUES (72667, '65.3607.15669854987952399', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.116.170.180', '2019-08-28 17:44:59', 0, 1002001015, '账号未登陆', '2019-08-28 17:44:59');
INSERT INTO `access_log` VALUES (72668, '65.54.15669855008230487', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.116.170.180', '2019-08-28 17:45:01', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 17:45:01');
INSERT INTO `access_log` VALUES (72669, '65.52.15669855104590647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.116.170.180', '2019-08-28 17:45:10', 66, 0, '', '2019-08-28 17:45:11');
INSERT INTO `access_log` VALUES (72670, '65.46.15669855107930631', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.116.170.180', '2019-08-28 17:45:11', 9, 0, '', '2019-08-28 17:45:11');
INSERT INTO `access_log` VALUES (72671, '65.49.15669855107950613', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.116.170.180', '2019-08-28 17:45:11', 10, 0, '', '2019-08-28 17:45:11');
INSERT INTO `access_log` VALUES (72672, '65.45.15669855107930627', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.116.170.180', '2019-08-28 17:45:11', 11, 2001001000, '服务端发生异常', '2019-08-28 17:45:11');
INSERT INTO `access_log` VALUES (72673, '59.80.15669858032567215', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.10.209.124', '2019-08-28 17:50:03', 11, 0, '', '2019-08-28 17:50:03');
INSERT INTO `access_log` VALUES (72674, '59.77.15669858032567231', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.10.209.124', '2019-08-28 17:50:03', 13, 2001001000, '服务端发生异常', '2019-08-28 17:50:03');
INSERT INTO `access_log` VALUES (72675, '64.83.15669858120967645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.10.209.124', '2019-08-28 17:50:12', 10, 0, '', '2019-08-28 17:50:12');
INSERT INTO `access_log` VALUES (72676, '64.82.15669858121947657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.10.209.124', '2019-08-28 17:50:12', 3, 0, '', '2019-08-28 17:50:12');
INSERT INTO `access_log` VALUES (72677, '64.77.15669858134177629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.10.209.124', '2019-08-28 17:50:13', 2, 0, '', '2019-08-28 17:50:13');
INSERT INTO `access_log` VALUES (72678, '64.84.15669858148357641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.10.209.124', '2019-08-28 17:50:15', 2, 0, '', '2019-08-28 17:50:15');
INSERT INTO `access_log` VALUES (72679, '64.80.15669858156467653', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.10.209.124', '2019-08-28 17:50:16', 2, 0, '', '2019-08-28 17:50:16');
INSERT INTO `access_log` VALUES (72680, '65.47.15669947008300663', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '183.134.205.58', '2019-08-28 20:18:21', 0, 1002001015, '账号未登陆', '2019-08-28 20:18:21');
INSERT INTO `access_log` VALUES (72681, '65.3607.15669947008312523', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '183.134.205.58', '2019-08-28 20:18:21', 1, 1002001015, '账号未登陆', '2019-08-28 20:18:21');
INSERT INTO `access_log` VALUES (72682, '65.54.15669947008540611', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '183.134.205.58', '2019-08-28 20:18:21', 1, 1002001015, '账号未登陆', '2019-08-28 20:18:21');
INSERT INTO `access_log` VALUES (72683, '65.52.15669947086990771', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '183.134.205.58', '2019-08-28 20:18:29', 88, 0, '', '2019-08-28 20:18:29');
INSERT INTO `access_log` VALUES (72684, '65.45.15669947089820751', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '183.134.205.58', '2019-08-28 20:18:29', 14, 0, '', '2019-08-28 20:18:29');
INSERT INTO `access_log` VALUES (72685, '65.46.15669947089860755', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '183.134.205.58', '2019-08-28 20:18:29', 10, 0, '', '2019-08-28 20:18:29');
INSERT INTO `access_log` VALUES (72686, '65.49.15669947089830737', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.139 Safari/537.36', '183.134.205.58', '2019-08-28 20:18:29', 15, 2001001000, '服务端发生异常', '2019-08-28 20:18:29');
INSERT INTO `access_log` VALUES (72687, '59.73.15669964718917387', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:47:52', 10, 0, '', '2019-08-28 20:47:52');
INSERT INTO `access_log` VALUES (72688, '59.72.15669964718907385', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:47:52', 44, 2001001000, '服务端发生异常', '2019-08-28 20:47:52');
INSERT INTO `access_log` VALUES (72689, '64.76.15669964784907797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:47:58', 9, 0, '', '2019-08-28 20:47:59');
INSERT INTO `access_log` VALUES (72690, '64.85.15669964786137811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:47:59', 2, 0, '', '2019-08-28 20:47:59');
INSERT INTO `access_log` VALUES (72691, '64.81.15669964797457793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:00', 2, 0, '', '2019-08-28 20:48:00');
INSERT INTO `access_log` VALUES (72692, '64.79.15669964805117789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:01', 2, 0, '', '2019-08-28 20:48:01');
INSERT INTO `access_log` VALUES (72693, '64.83.15669964810067789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:01', 2, 0, '', '2019-08-28 20:48:01');
INSERT INTO `access_log` VALUES (72694, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=？？？&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:06', 5, 0, '', '2019-08-28 20:48:06');
INSERT INTO `access_log` VALUES (72695, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=？？？', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:06', 4, 0, '', '2019-08-28 20:48:06');
INSERT INTO `access_log` VALUES (72696, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=？？？&pageNo=1&pageSize=10&sortField=buyPrice&sortOrder=desc', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:17', 6, 0, '', '2019-08-28 20:48:17');
INSERT INTO `access_log` VALUES (72697, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=？？？&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:18', 6, 0, '', '2019-08-28 20:48:18');
INSERT INTO `access_log` VALUES (72698, '65.50.15669965103450745', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:30', 1, 1002001015, '账号未登陆', '2019-08-28 20:48:30');
INSERT INTO `access_log` VALUES (72699, '65.53.15669965103640693', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:30', 1, 1002001015, '账号未登陆', '2019-08-28 20:48:30');
INSERT INTO `access_log` VALUES (72700, '65.3607.15669965103672549', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:30', 0, 1002001015, '账号未登陆', '2019-08-28 20:48:30');
INSERT INTO `access_log` VALUES (72701, '65.54.15669965122310637', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:32', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 20:48:32');
INSERT INTO `access_log` VALUES (72702, '65.51.15669965241330801', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:44', 84, 0, '', '2019-08-28 20:48:44');
INSERT INTO `access_log` VALUES (72703, '65.45.15669965244560777', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:44', 17, 0, '', '2019-08-28 20:48:44');
INSERT INTO `access_log` VALUES (72704, '65.52.15669965244550797', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:44', 10, 0, '', '2019-08-28 20:48:44');
INSERT INTO `access_log` VALUES (72705, '65.46.15669965244550781', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:48:44', 18, 2001001000, '服务端发生异常', '2019-08-28 20:48:44');
INSERT INTO `access_log` VALUES (72706, '65.3607.15669965659902551', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:49:26', 9, 0, '', '2019-08-28 20:49:26');
INSERT INTO `access_log` VALUES (72707, '65.54.15669965659920639', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:49:26', 10, 2001001000, '服务端发生异常', '2019-08-28 20:49:26');
INSERT INTO `access_log` VALUES (72708, '65.47.15669965659960691', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.92.155.97', '2019-08-28 20:49:26', 9, 0, '', '2019-08-28 20:49:26');
INSERT INTO `access_log` VALUES (72709, '65.46.15669987234820811', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.198.104.162', '2019-08-28 21:25:23', 0, 1002001015, '账号未登陆', '2019-08-28 21:25:23');
INSERT INTO `access_log` VALUES (72710, '65.49.15669987234830793', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.198.104.162', '2019-08-28 21:25:23', 1, 1002001015, '账号未登陆', '2019-08-28 21:25:23');
INSERT INTO `access_log` VALUES (72711, '65.53.15669987235080725', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.198.104.162', '2019-08-28 21:25:24', 0, 1002001015, '账号未登陆', '2019-08-28 21:25:24');
INSERT INTO `access_log` VALUES (72712, '65.47.15669987273190721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.198.104.162', '2019-08-28 21:25:27', 83, 0, '', '2019-08-28 21:25:27');
INSERT INTO `access_log` VALUES (72713, '65.3607.15669987276982581', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.198.104.162', '2019-08-28 21:25:28', 11, 0, '', '2019-08-28 21:25:28');
INSERT INTO `access_log` VALUES (72714, '65.54.15669987277050669', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.198.104.162', '2019-08-28 21:25:28', 9, 2001001000, '服务端发生异常', '2019-08-28 21:25:28');
INSERT INTO `access_log` VALUES (72715, '65.51.15669987277110833', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.198.104.162', '2019-08-28 21:25:28', 9, 0, '', '2019-08-28 21:25:28');
INSERT INTO `access_log` VALUES (72716, '65.52.15669987345410829', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.198.104.162', '2019-08-28 21:25:35', 10, 0, '', '2019-08-28 21:25:35');
INSERT INTO `access_log` VALUES (72717, '65.45.15669987345460809', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.198.104.162', '2019-08-28 21:25:35', 11, 2001001000, '服务端发生异常', '2019-08-28 21:25:35');
INSERT INTO `access_log` VALUES (72718, '65.49.15669987345500795', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.198.104.162', '2019-08-28 21:25:35', 16, 0, '', '2019-08-28 21:25:35');
INSERT INTO `access_log` VALUES (72719, '59.75.15669987695707423', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.198.104.162', '2019-08-28 21:26:10', 10, 0, '', '2019-08-28 21:26:10');
INSERT INTO `access_log` VALUES (72720, '59.77.15669987695707405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '111.198.104.162', '2019-08-28 21:26:10', 17, 2001001000, '服务端发生异常', '2019-08-28 21:26:10');
INSERT INTO `access_log` VALUES (72721, '59.77.15669992108777411', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '106.85.76.215', '2019-08-28 21:33:31', 3, 0, '', '2019-08-28 21:33:31');
INSERT INTO `access_log` VALUES (72722, '59.80.15669992108817395', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '106.85.76.215', '2019-08-28 21:33:31', 13, 2001001000, '服务端发生异常', '2019-08-28 21:33:31');
INSERT INTO `access_log` VALUES (72723, '65.46.15670014034590849', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.82.172.244', '2019-08-28 22:10:03', 1, 1002001015, '账号未登陆', '2019-08-28 22:10:03');
INSERT INTO `access_log` VALUES (72724, '65.49.15670014034590831', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.82.172.244', '2019-08-28 22:10:03', 1, 1002001015, '账号未登陆', '2019-08-28 22:10:03');
INSERT INTO `access_log` VALUES (72725, '65.52.15670014034580865', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.82.172.244', '2019-08-28 22:10:03', 1, 1002001015, '账号未登陆', '2019-08-28 22:10:03');
INSERT INTO `access_log` VALUES (72726, '65.53.15670014078520763', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.82.172.244', '2019-08-28 22:10:08', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 22:10:08');
INSERT INTO `access_log` VALUES (72727, '65.47.15670014108440759', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.82.172.244', '2019-08-28 22:10:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 22:10:11');
INSERT INTO `access_log` VALUES (72728, '65.3607.15670014302762619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.82.172.244', '2019-08-28 22:10:30', 90, 0, '', '2019-08-28 22:10:30');
INSERT INTO `access_log` VALUES (72729, '65.45.15670014411760847', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.82.172.244', '2019-08-28 22:10:41', 104, 0, '', '2019-08-28 22:10:41');
INSERT INTO `access_log` VALUES (72730, '65.52.15670014440480867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.82.172.244', '2019-08-28 22:10:44', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 22:10:44');
INSERT INTO `access_log` VALUES (72731, '65.49.15670014491390833', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.82.172.244', '2019-08-28 22:10:49', 108, 0, '', '2019-08-28 22:10:49');
INSERT INTO `access_log` VALUES (72732, '65.53.15670014547330765', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.82.172.244', '2019-08-28 22:10:55', 80, 0, '', '2019-08-28 22:10:55');
INSERT INTO `access_log` VALUES (72733, '65.49.15670015610600835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.82.172.244', '2019-08-28 22:12:41', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 22:12:41');
INSERT INTO `access_log` VALUES (72734, '65.46.15670015675140853', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '218.82.172.244', '2019-08-28 22:12:48', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 22:12:48');
INSERT INTO `access_log` VALUES (72735, '65.51.15670016389780875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:13:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 22:13:59');
INSERT INTO `access_log` VALUES (72736, '65.45.15670016392420851', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:13:59', 1, 1002001015, '账号未登陆', '2019-08-28 22:13:59');
INSERT INTO `access_log` VALUES (72737, '65.52.15670016392480871', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:13:59', 1, 1002001015, '账号未登陆', '2019-08-28 22:13:59');
INSERT INTO `access_log` VALUES (72738, '65.49.15670016392500837', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:13:59', 0, 1002001015, '账号未登陆', '2019-08-28 22:13:59');
INSERT INTO `access_log` VALUES (72739, '65.46.15670016461370855', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:14:06', 113, 0, '', '2019-08-28 22:14:06');
INSERT INTO `access_log` VALUES (72740, '65.50.15670016465470821', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:14:07', 14, 0, '', '2019-08-28 22:14:07');
INSERT INTO `access_log` VALUES (72741, '65.47.15670016465470765', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:14:07', 14, 0, '', '2019-08-28 22:14:07');
INSERT INTO `access_log` VALUES (72742, '65.53.15670016465470769', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:14:07', 17, 2001001000, '服务端发生异常', '2019-08-28 22:14:07');
INSERT INTO `access_log` VALUES (72743, '65.45.15670016809530853', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:14:41', 9, 0, '', '2019-08-28 22:14:41');
INSERT INTO `access_log` VALUES (72744, '65.52.15670016809540873', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:14:41', 10, 2001001000, '服务端发生异常', '2019-08-28 22:14:41');
INSERT INTO `access_log` VALUES (72745, '65.49.15670016809540839', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:14:41', 10, 0, '', '2019-08-28 22:14:41');
INSERT INTO `access_log` VALUES (72746, '65.46.15670016856260857', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:14:46', 9, 0, '', '2019-08-28 22:14:46');
INSERT INTO `access_log` VALUES (72747, '65.47.15670016856280767', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:14:46', 10, 2001001000, '服务端发生异常', '2019-08-28 22:14:46');
INSERT INTO `access_log` VALUES (72748, '65.53.15670016856330771', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:14:46', 9, 0, '', '2019-08-28 22:14:46');
INSERT INTO `access_log` VALUES (72749, '65.54.15670017026230715', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-28 22:15:03');
INSERT INTO `access_log` VALUES (72750, '65.51.15670017141190879', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:14', 123, 0, '', '2019-08-28 22:15:14');
INSERT INTO `access_log` VALUES (72751, '65.52.15670017144350875', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:14', 9, 0, '', '2019-08-28 22:15:14');
INSERT INTO `access_log` VALUES (72752, '65.49.15670017144380841', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:14', 8, 2001001000, '服务端发生异常', '2019-08-28 22:15:14');
INSERT INTO `access_log` VALUES (72753, '65.45.15670017144410855', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:14', 8, 0, '', '2019-08-28 22:15:14');
INSERT INTO `access_log` VALUES (72754, '59.80.15670017377737429', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:38', 10, 0, '', '2019-08-28 22:15:38');
INSERT INTO `access_log` VALUES (72755, '59.74.15670017377747469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:38', 14, 2001001000, '服务端发生异常', '2019-08-28 22:15:38');
INSERT INTO `access_log` VALUES (72756, '59.73.15670017430857459', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:43', 2, 0, '', '2019-08-28 22:15:43');
INSERT INTO `access_log` VALUES (72757, '59.71.15670017430857455', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:43', 10, 2001001000, '服务端发生异常', '2019-08-28 22:15:43');
INSERT INTO `access_log` VALUES (72758, '59.79.15670017483337461', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:48', 2, 0, '', '2019-08-28 22:15:48');
INSERT INTO `access_log` VALUES (72759, '59.72.15670017483337457', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:48', 16, 2001001000, '服务端发生异常', '2019-08-28 22:15:48');
INSERT INTO `access_log` VALUES (72760, '64.84.15670017510787855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:51', 11, 0, '', '2019-08-28 22:15:51');
INSERT INTO `access_log` VALUES (72761, '64.80.15670017512427867', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:51', 3, 0, '', '2019-08-28 22:15:51');
INSERT INTO `access_log` VALUES (72762, '64.78.15670017522427885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:52', 2, 0, '', '2019-08-28 22:15:52');
INSERT INTO `access_log` VALUES (72763, '64.76.15670017529037869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.82.172.244', '2019-08-28 22:15:53', 2, 0, '', '2019-08-28 22:15:53');
INSERT INTO `access_log` VALUES (72764, '65.51.15670088650770977', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.158.86.32', '2019-08-29 00:14:25', 1, 1002001015, '账号未登陆', '2019-08-29 00:14:25');
INSERT INTO `access_log` VALUES (72765, '65.54.15670088650840811', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.158.86.32', '2019-08-29 00:14:25', 0, 1002001015, '账号未登陆', '2019-08-29 00:14:25');
INSERT INTO `access_log` VALUES (72766, '65.50.15670088650780919', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.158.86.32', '2019-08-29 00:14:25', 1, 1002001015, '账号未登陆', '2019-08-29 00:14:25');
INSERT INTO `access_log` VALUES (72767, '65.49.15670088683080937', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.158.86.32', '2019-08-29 00:14:28', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 00:14:28');
INSERT INTO `access_log` VALUES (72768, '65.47.15670088854300865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.158.86.32', '2019-08-29 00:14:45', 83, 0, '', '2019-08-29 00:14:46');
INSERT INTO `access_log` VALUES (72769, '65.53.15670088857700869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.158.86.32', '2019-08-29 00:14:46', 13, 0, '', '2019-08-29 00:14:46');
INSERT INTO `access_log` VALUES (72770, '65.3607.15670088857842727', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.158.86.32', '2019-08-29 00:14:46', 12, 2001001000, '服务端发生异常', '2019-08-29 00:14:46');
INSERT INTO `access_log` VALUES (72771, '65.52.15670088857860975', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.158.86.32', '2019-08-29 00:14:46', 13, 0, '', '2019-08-29 00:14:46');
INSERT INTO `access_log` VALUES (72772, '65.54.15670089214210813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.158.86.32', '2019-08-29 00:15:21', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 00:15:21');
INSERT INTO `access_log` VALUES (72773, '65.53.15670093069230875', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:21:47', 0, 1002001015, '账号未登陆', '2019-08-29 00:21:47');
INSERT INTO `access_log` VALUES (72774, '65.46.15670093069320963', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:21:47', 0, 1002001015, '账号未登陆', '2019-08-29 00:21:47');
INSERT INTO `access_log` VALUES (72775, '65.51.15670093069430985', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:21:47', 1, 1002001015, '账号未登陆', '2019-08-29 00:21:47');
INSERT INTO `access_log` VALUES (72776, '65.54.15670093135030819', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:21:54', 79, 0, '', '2019-08-29 00:21:54');
INSERT INTO `access_log` VALUES (72777, '65.49.15670093139790945', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:21:54', 100, 0, '', '2019-08-29 00:21:54');
INSERT INTO `access_log` VALUES (72778, '65.47.15670093139890873', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:21:54', 92, 0, '', '2019-08-29 00:21:54');
INSERT INTO `access_log` VALUES (72779, '65.45.15670093139850961', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:21:54', 96, 2001001000, '服务端发生异常', '2019-08-29 00:21:54');
INSERT INTO `access_log` VALUES (72780, '65.46.15670093513240965', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:22:31', 7, 0, '', '2019-08-29 00:22:31');
INSERT INTO `access_log` VALUES (72781, '65.53.15670093513300877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:22:31', 9, 2001001000, '服务端发生异常', '2019-08-29 00:22:31');
INSERT INTO `access_log` VALUES (72782, '65.51.15670093513350987', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:22:31', 7, 0, '', '2019-08-29 00:22:31');
INSERT INTO `access_log` VALUES (72783, '59.79.15670095144627565', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:14', 11, 0, '', '2019-08-29 00:25:14');
INSERT INTO `access_log` VALUES (72784, '59.72.15670095144627561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:14', 33, 2001001000, '服务端发生异常', '2019-08-29 00:25:14');
INSERT INTO `access_log` VALUES (72785, '64.78.15670095206377989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:21', 12, 0, '', '2019-08-29 00:25:21');
INSERT INTO `access_log` VALUES (72786, '64.76.15670095208177973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:21', 3, 0, '', '2019-08-29 00:25:21');
INSERT INTO `access_log` VALUES (72787, '64.85.15670095221537987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:22', 2, 0, '', '2019-08-29 00:25:22');
INSERT INTO `access_log` VALUES (72788, '64.81.15670095227547969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:23', 2, 0, '', '2019-08-29 00:25:23');
INSERT INTO `access_log` VALUES (72789, '64.79.15670095233127965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:23', 2, 0, '', '2019-08-29 00:25:23');
INSERT INTO `access_log` VALUES (72790, '59.78.15670095252797575', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:25', 3, 0, '', '2019-08-29 00:25:25');
INSERT INTO `access_log` VALUES (72791, '59.75.15670095252827569', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:25', 18, 2001001000, '服务端发生异常', '2019-08-29 00:25:25');
INSERT INTO `access_log` VALUES (72792, '64.83.15670095297767965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:30', 3, 0, '', '2019-08-29 00:25:30');
INSERT INTO `access_log` VALUES (72793, '64.82.15670095298927977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:30', 2, 0, '', '2019-08-29 00:25:30');
INSERT INTO `access_log` VALUES (72794, '59.77.15670095304037551', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:30', 3, 0, '', '2019-08-29 00:25:30');
INSERT INTO `access_log` VALUES (72795, '59.80.15670095304037535', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:30', 24, 2001001000, '服务端发生异常', '2019-08-29 00:25:30');
INSERT INTO `access_log` VALUES (72796, '65.45.15670095441380965', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 00:25:44');
INSERT INTO `access_log` VALUES (72797, '65.50.15670095484160933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.92.226.194', '2019-08-29 00:25:48', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 00:25:48');
INSERT INTO `access_log` VALUES (72798, '59.80.15670098018327539', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:02', 3, 0, '', '2019-08-29 00:30:02');
INSERT INTO `access_log` VALUES (72799, '59.77.15670098018327555', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:02', 22, 2001001000, '服务端发生异常', '2019-08-29 00:30:02');
INSERT INTO `access_log` VALUES (72800, '64.77.15670098211317953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:21', 2, 0, '', '2019-08-29 00:30:21');
INSERT INTO `access_log` VALUES (72801, '64.84.15670098212407965', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:21', 2, 0, '', '2019-08-29 00:30:21');
INSERT INTO `access_log` VALUES (72802, '64.80.15670098320527977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:32', 2, 0, '', '2019-08-29 00:30:32');
INSERT INTO `access_log` VALUES (72803, '64.78.15670098321857995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:32', 2, 0, '', '2019-08-29 00:30:32');
INSERT INTO `access_log` VALUES (72804, '59.72.15670098382617567', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:38', 2, 0, '', '2019-08-29 00:30:38');
INSERT INTO `access_log` VALUES (72805, '59.79.15670098382617571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:38', 15, 2001001000, '服务端发生异常', '2019-08-29 00:30:38');
INSERT INTO `access_log` VALUES (72806, '64.85.15670098423417993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:42', 2, 0, '', '2019-08-29 00:30:42');
INSERT INTO `access_log` VALUES (72807, '64.81.15670098425027975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:43', 1, 0, '', '2019-08-29 00:30:43');
INSERT INTO `access_log` VALUES (72808, '64.79.15670098446937971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:45', 2, 0, '', '2019-08-29 00:30:45');
INSERT INTO `access_log` VALUES (72809, '64.83.15670098453457971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:45', 2, 0, '', '2019-08-29 00:30:45');
INSERT INTO `access_log` VALUES (72810, '64.82.15670098457667983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:46', 3, 0, '', '2019-08-29 00:30:46');
INSERT INTO `access_log` VALUES (72811, '59.76.15670098468437559', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:47', 2, 0, '', '2019-08-29 00:30:47');
INSERT INTO `access_log` VALUES (72812, '59.78.15670098468477581', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.196.117', '2019-08-29 00:30:47', 17, 2001001000, '服务端发生异常', '2019-08-29 00:30:47');
INSERT INTO `access_log` VALUES (72813, '59.72.15670106645117579', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Lite Build/PKQ1.181007.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.2', '116.232.242.181', '2019-08-29 00:44:25', 3, 0, '', '2019-08-29 00:44:25');
INSERT INTO `access_log` VALUES (72814, '59.71.15670106645117577', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Lite Build/PKQ1.181007.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.2', '116.232.242.181', '2019-08-29 00:44:25', 18, 2001001000, '服务端发生异常', '2019-08-29 00:44:25');
INSERT INTO `access_log` VALUES (72815, '64.85.15670106697618005', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Lite Build/PKQ1.181007.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.2', '116.232.242.181', '2019-08-29 00:44:30', 2, 0, '', '2019-08-29 00:44:30');
INSERT INTO `access_log` VALUES (72816, '64.81.15670106698867987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Lite Build/PKQ1.181007.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.2', '116.232.242.181', '2019-08-29 00:44:30', 1, 0, '', '2019-08-29 00:44:30');
INSERT INTO `access_log` VALUES (72817, '64.79.15670106730927983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Lite Build/PKQ1.181007.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.2', '116.232.242.181', '2019-08-29 00:44:33', 2, 0, '', '2019-08-29 00:44:33');
INSERT INTO `access_log` VALUES (72818, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Lite Build/PKQ1.181007.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.2', '116.232.242.181', '2019-08-29 00:44:33', 5, 0, '', '2019-08-29 00:44:33');
INSERT INTO `access_log` VALUES (72819, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Lite Build/PKQ1.181007.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.2', '116.232.242.181', '2019-08-29 00:44:35', 5, 0, '', '2019-08-29 00:44:35');
INSERT INTO `access_log` VALUES (72820, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Lite Build/PKQ1.181007.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.2', '116.232.242.181', '2019-08-29 00:44:36', 5, 0, '', '2019-08-29 00:44:36');
INSERT INTO `access_log` VALUES (72821, '64.82.15670106765587995', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Lite Build/PKQ1.181007.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.2', '116.232.242.181', '2019-08-29 00:44:37', 2, 0, '', '2019-08-29 00:44:37');
INSERT INTO `access_log` VALUES (72822, '64.77.15670106767147967', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Lite Build/PKQ1.181007.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.2', '116.232.242.181', '2019-08-29 00:44:37', 2, 0, '', '2019-08-29 00:44:37');
INSERT INTO `access_log` VALUES (72823, '66.54.15670106999325043', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13888888888&code=9999', 'POST', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Lite Build/PKQ1.181007.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.2', '116.232.242.181', '2019-08-29 00:45:00', 16, 1001003001, '验证码已过期', '2019-08-29 00:45:00');
INSERT INTO `access_log` VALUES (72824, '59.75.15670107110127587', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Lite Build/PKQ1.181007.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.2', '116.232.242.181', '2019-08-29 00:45:11', 17, 0, '', '2019-08-29 00:45:11');
INSERT INTO `access_log` VALUES (72825, '59.80.15670107110127553', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 9; zh-cn; MI 8 Lite Build/PKQ1.181007.001) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/71.0.3578.141 Mobile Safari/537.36 XiaoMi/MiuiBrowser/10.9.2', '116.232.242.181', '2019-08-29 00:45:11', 62, 2001001000, '服务端发生异常', '2019-08-29 00:45:11');
INSERT INTO `access_log` VALUES (72826, '65.50.15670149161501003', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3708.400 QQBrowser/10.4.3699.400', '61.144.96.62', '2019-08-29 01:55:16', 0, 1002001015, '账号未登陆', '2019-08-29 01:55:16');
INSERT INTO `access_log` VALUES (72827, '65.51.15670149161511063', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3708.400 QQBrowser/10.4.3699.400', '61.144.96.62', '2019-08-29 01:55:16', 0, 1002001015, '账号未登陆', '2019-08-29 01:55:16');
INSERT INTO `access_log` VALUES (72828, '65.45.15670149161531037', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3708.400 QQBrowser/10.4.3699.400', '61.144.96.62', '2019-08-29 01:55:16', 0, 1002001015, '账号未登陆', '2019-08-29 01:55:16');
INSERT INTO `access_log` VALUES (72829, '65.47.15670149214440951', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3708.400 QQBrowser/10.4.3699.400', '61.144.96.62', '2019-08-29 01:55:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 01:55:21');
INSERT INTO `access_log` VALUES (72830, '65.52.15670149359131061', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3708.400 QQBrowser/10.4.3699.400', '61.144.96.62', '2019-08-29 01:55:36', 108, 1002002000, '账号不存在', '2019-08-29 01:55:36');
INSERT INTO `access_log` VALUES (72831, '65.46.15670149440651041', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3708.400 QQBrowser/10.4.3699.400', '61.144.96.62', '2019-08-29 01:55:44', 62, 0, '', '2019-08-29 01:55:44');
INSERT INTO `access_log` VALUES (72832, '65.3607.15670149444022813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3708.400 QQBrowser/10.4.3699.400', '61.144.96.62', '2019-08-29 01:55:44', 9, 0, '', '2019-08-29 01:55:44');
INSERT INTO `access_log` VALUES (72833, '65.45.15670149444331039', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3708.400 QQBrowser/10.4.3699.400', '61.144.96.62', '2019-08-29 01:55:44', 12, 0, '', '2019-08-29 01:55:44');
INSERT INTO `access_log` VALUES (72834, '65.54.15670149444330899', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3708.400 QQBrowser/10.4.3699.400', '61.144.96.62', '2019-08-29 01:55:44', 13, 2001001000, '服务端发生异常', '2019-08-29 01:55:44');
INSERT INTO `access_log` VALUES (72835, '65.54.15670395349641227', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.239.8.14', '2019-08-29 08:45:35', 0, 1002001015, '账号未登陆', '2019-08-29 08:45:35');
INSERT INTO `access_log` VALUES (72836, '65.50.15670395349641333', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.239.8.14', '2019-08-29 08:45:35', 1, 1002001015, '账号未登陆', '2019-08-29 08:45:35');
INSERT INTO `access_log` VALUES (72837, '65.51.15670395349641393', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.239.8.14', '2019-08-29 08:45:35', 0, 1002001015, '账号未登陆', '2019-08-29 08:45:35');
INSERT INTO `access_log` VALUES (72838, '65.52.15670395559001391', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.239.8.14', '2019-08-29 08:45:56', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 08:45:56');
INSERT INTO `access_log` VALUES (72839, '65.53.15670395675861287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.239.8.14', '2019-08-29 08:46:08', 90, 0, '', '2019-08-29 08:46:08');
INSERT INTO `access_log` VALUES (72840, '65.46.15670395680101371', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.239.8.14', '2019-08-29 08:46:08', 17, 0, '', '2019-08-29 08:46:08');
INSERT INTO `access_log` VALUES (72841, '65.3607.15670395680113143', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.239.8.14', '2019-08-29 08:46:08', 18, 2001001000, '服务端发生异常', '2019-08-29 08:46:08');
INSERT INTO `access_log` VALUES (72842, '65.45.15670395680171369', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.239.8.14', '2019-08-29 08:46:08', 13, 0, '', '2019-08-29 08:46:08');
INSERT INTO `access_log` VALUES (72843, '65.50.15670395758411335', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.239.8.14', '2019-08-29 08:46:16', 20, 0, '', '2019-08-29 08:46:16');
INSERT INTO `access_log` VALUES (72844, '65.47.15670395758561283', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.239.8.14', '2019-08-29 08:46:16', 10, 0, '', '2019-08-29 08:46:16');
INSERT INTO `access_log` VALUES (72845, '65.54.15670395758561229', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.239.8.14', '2019-08-29 08:46:16', 12, 2001001000, '服务端发生异常', '2019-08-29 08:46:16');
INSERT INTO `access_log` VALUES (72846, '65.54.15670396869471231', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.239.8.14', '2019-08-29 08:48:07', 9, 2001001000, '服务端发生异常', '2019-08-29 08:48:07');
INSERT INTO `access_log` VALUES (72847, '65.50.15670396869391337', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.239.8.14', '2019-08-29 08:48:07', 229, 0, '', '2019-08-29 08:48:07');
INSERT INTO `access_log` VALUES (72848, '65.47.15670396869531285', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '219.239.8.14', '2019-08-29 08:48:07', 217, 0, '', '2019-08-29 08:48:07');
INSERT INTO `access_log` VALUES (72849, '65.3607.15670422853823181', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:31:25', 0, 1002001015, '账号未登陆', '2019-08-29 09:31:25');
INSERT INTO `access_log` VALUES (72850, '65.51.15670422853821433', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:31:25', 0, 1002001015, '账号未登陆', '2019-08-29 09:31:25');
INSERT INTO `access_log` VALUES (72851, '65.46.15670422853821409', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:31:25', 0, 1002001015, '账号未登陆', '2019-08-29 09:31:25');
INSERT INTO `access_log` VALUES (72852, '65.54.15670422877731267', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:31:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 09:31:28');
INSERT INTO `access_log` VALUES (72853, '65.47.15670423028291321', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:31:43', 78, 0, '', '2019-08-29 09:31:43');
INSERT INTO `access_log` VALUES (72854, '65.49.15670423032451395', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:31:43', 13, 0, '', '2019-08-29 09:31:43');
INSERT INTO `access_log` VALUES (72855, '65.53.15670423032491327', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:31:43', 10, 0, '', '2019-08-29 09:31:43');
INSERT INTO `access_log` VALUES (72856, '65.52.15670423032461431', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:31:43', 13, 2001001000, '服务端发生异常', '2019-08-29 09:31:43');
INSERT INTO `access_log` VALUES (72857, '59.75.15670423315548009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:32:12', 10, 0, '', '2019-08-29 09:32:12');
INSERT INTO `access_log` VALUES (72858, '59.80.15670423315577975', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:32:12', 26, 2001001000, '服务端发生异常', '2019-08-29 09:32:12');
INSERT INTO `access_log` VALUES (72859, '64.80.15670423340068411', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:32:14', 56, 0, '', '2019-08-29 09:32:14');
INSERT INTO `access_log` VALUES (72860, '64.78.15670423342148431', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:32:14', 3, 0, '', '2019-08-29 09:32:14');
INSERT INTO `access_log` VALUES (72861, '64.76.15670423351858415', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:32:15', 2, 0, '', '2019-08-29 09:32:15');
INSERT INTO `access_log` VALUES (72862, '64.85.15670423356818429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:32:16', 2, 0, '', '2019-08-29 09:32:16');
INSERT INTO `access_log` VALUES (72863, '59.79.15670424106468007', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:33:31', 3, 0, '', '2019-08-29 09:33:31');
INSERT INTO `access_log` VALUES (72864, '59.76.15670424106497995', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:33:31', 12, 2001001000, '服务端发生异常', '2019-08-29 09:33:31');
INSERT INTO `access_log` VALUES (72865, '64.84.15670424129828403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:33:33', 3, 0, '', '2019-08-29 09:33:33');
INSERT INTO `access_log` VALUES (72866, '64.80.15670424131318413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:33:33', 2, 0, '', '2019-08-29 09:33:33');
INSERT INTO `access_log` VALUES (72867, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=电脑&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:33:37', 12, 0, '', '2019-08-29 09:33:37');
INSERT INTO `access_log` VALUES (72868, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=电脑', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:33:37', 11, 0, '', '2019-08-29 09:33:37');
INSERT INTO `access_log` VALUES (72869, '64.76.15670424186918417', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=34', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:33:39', 8, 0, '', '2019-08-29 09:33:39');
INSERT INTO `access_log` VALUES (72870, '66.57.15670424261125439', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:33:46', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-08-29 09:33:46');
INSERT INTO `access_log` VALUES (72871, '64.81.15670424317988413', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:33:52', 180, 0, '', '2019-08-29 09:33:52');
INSERT INTO `access_log` VALUES (72872, '64.79.15670424321448409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:33:52', 2, 0, '', '2019-08-29 09:33:52');
INSERT INTO `access_log` VALUES (72873, '59.80.15670424328087977', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:33:53', 16, 2001001000, '服务端发生异常', '2019-08-29 09:33:53');
INSERT INTO `access_log` VALUES (72874, '59.77.15670424328087993', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.216.40.207', '2019-08-29 09:33:53', 81, 0, '', '2019-08-29 09:33:53');
INSERT INTO `access_log` VALUES (72875, '59.71.15670460855958051', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.138.191.83', '2019-08-29 10:34:46', 10, 0, '', '2019-08-29 10:34:46');
INSERT INTO `access_log` VALUES (72876, '59.79.15670460855968057', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.138.191.83', '2019-08-29 10:34:46', 16, 2001001000, '服务端发生异常', '2019-08-29 10:34:46');
INSERT INTO `access_log` VALUES (72877, '59.73.15670464789258061', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '171.11.245.70', '2019-08-29 10:41:19', 3, 0, '', '2019-08-29 10:41:19');
INSERT INTO `access_log` VALUES (72878, '59.72.15670464789298059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '171.11.245.70', '2019-08-29 10:41:19', 17, 2001001000, '服务端发生异常', '2019-08-29 10:41:19');
INSERT INTO `access_log` VALUES (72879, '59.71.15670466138678059', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:43:34', 3, 0, '', '2019-08-29 10:43:34');
INSERT INTO `access_log` VALUES (72880, '59.72.15670466138668061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:43:34', 23, 2001001000, '服务端发生异常', '2019-08-29 10:43:34');
INSERT INTO `access_log` VALUES (72881, '64.79.15670466220728465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:43:42', 61, 0, '', '2019-08-29 10:43:42');
INSERT INTO `access_log` VALUES (72882, '64.83.15670466222668465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:43:42', 3, 0, '', '2019-08-29 10:43:42');
INSERT INTO `access_log` VALUES (72883, '64.82.15670466233918477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:43:43', 2, 0, '', '2019-08-29 10:43:43');
INSERT INTO `access_log` VALUES (72884, '64.77.15670466241038449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:43:44', 2, 0, '', '2019-08-29 10:43:44');
INSERT INTO `access_log` VALUES (72885, '64.84.15670466246348461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:43:45', 3, 0, '', '2019-08-29 10:43:45');
INSERT INTO `access_log` VALUES (72886, '64.80.15670466249688471', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:43:45', 2, 0, '', '2019-08-29 10:43:45');
INSERT INTO `access_log` VALUES (72887, '59.78.15670466261788075', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:43:46', 2, 0, '', '2019-08-29 10:43:46');
INSERT INTO `access_log` VALUES (72888, '59.76.15670466261788053', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:43:46', 12, 2001001000, '服务端发生异常', '2019-08-29 10:43:46');
INSERT INTO `access_log` VALUES (72889, '65.53.15670466388981385', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:43:59', 1, 1002001015, '账号未登陆', '2019-08-29 10:43:59');
INSERT INTO `access_log` VALUES (72890, '65.45.15670466388981467', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:43:59', 0, 1002001015, '账号未登陆', '2019-08-29 10:43:59');
INSERT INTO `access_log` VALUES (72891, '65.3607.15670466389013241', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:43:59', 1, 1002001015, '账号未登陆', '2019-08-29 10:43:59');
INSERT INTO `access_log` VALUES (72892, '65.51.15670466488701493', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:44:09', 90, 0, '', '2019-08-29 10:44:09');
INSERT INTO `access_log` VALUES (72893, '65.50.15670466493241433', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:44:09', 68, 0, '', '2019-08-29 10:44:09');
INSERT INTO `access_log` VALUES (72894, '65.54.15670466493241327', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:44:09', 69, 2001001000, '服务端发生异常', '2019-08-29 10:44:09');
INSERT INTO `access_log` VALUES (72895, '65.47.15670466493301381', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:44:09', 63, 0, '', '2019-08-29 10:44:09');
INSERT INTO `access_log` VALUES (72896, '65.52.15670466573611491', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:44:17', 10, 0, '', '2019-08-29 10:44:17');
INSERT INTO `access_log` VALUES (72897, '65.49.15670466573731455', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:44:17', 9, 0, '', '2019-08-29 10:44:17');
INSERT INTO `access_log` VALUES (72898, '65.45.15670466573731469', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '140.206.46.74', '2019-08-29 10:44:17', 10, 2001001000, '服务端发生异常', '2019-08-29 10:44:17');
INSERT INTO `access_log` VALUES (72899, '59.74.15670466620348075', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '18.206.159.236', '2019-08-29 10:44:22', 3, 0, '', '2019-08-29 10:44:22');
INSERT INTO `access_log` VALUES (72900, '59.73.15670466658558065', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '35.173.212.247', '2019-08-29 10:44:26', 34, 2001001000, '服务端发生异常', '2019-08-29 10:44:26');
INSERT INTO `access_log` VALUES (72901, '65.50.15670468677091437', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '171.11.245.70', '2019-08-29 10:47:48', 1, 1002001015, '账号未登陆', '2019-08-29 10:47:48');
INSERT INTO `access_log` VALUES (72902, '65.47.15670468677111385', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '171.11.245.70', '2019-08-29 10:47:48', 0, 1002001015, '账号未登陆', '2019-08-29 10:47:48');
INSERT INTO `access_log` VALUES (72903, '65.54.15670468677111331', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '171.11.245.70', '2019-08-29 10:47:48', 0, 1002001015, '账号未登陆', '2019-08-29 10:47:48');
INSERT INTO `access_log` VALUES (72904, '65.49.15670468697841459', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '171.11.245.70', '2019-08-29 10:47:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 10:47:50');
INSERT INTO `access_log` VALUES (72905, '65.52.15670468746151495', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '171.11.245.70', '2019-08-29 10:47:55', 83, 0, '', '2019-08-29 10:47:55');
INSERT INTO `access_log` VALUES (72906, '65.3607.15670468749203247', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '171.11.245.70', '2019-08-29 10:47:55', 10, 0, '', '2019-08-29 10:47:55');
INSERT INTO `access_log` VALUES (72907, '65.53.15670468749221391', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '171.11.245.70', '2019-08-29 10:47:55', 11, 2001001000, '服务端发生异常', '2019-08-29 10:47:55');
INSERT INTO `access_log` VALUES (72908, '65.46.15670468749231475', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '171.11.245.70', '2019-08-29 10:47:55', 9, 0, '', '2019-08-29 10:47:55');
INSERT INTO `access_log` VALUES (72909, '59.78.15670470136928081', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.205.6.129', '2019-08-29 10:50:14', 3, 0, '', '2019-08-29 10:50:14');
INSERT INTO `access_log` VALUES (72910, '59.76.15670470136958059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.205.6.129', '2019-08-29 10:50:14', 17, 2001001000, '服务端发生异常', '2019-08-29 10:50:14');
INSERT INTO `access_log` VALUES (72911, '64.77.15670470314068455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.205.6.129', '2019-08-29 10:50:31', 3, 0, '', '2019-08-29 10:50:31');
INSERT INTO `access_log` VALUES (72912, '64.84.15670470315288467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.205.6.129', '2019-08-29 10:50:32', 2, 0, '', '2019-08-29 10:50:32');
INSERT INTO `access_log` VALUES (72913, '64.80.15670470331648477', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.205.6.129', '2019-08-29 10:50:33', 2, 0, '', '2019-08-29 10:50:33');
INSERT INTO `access_log` VALUES (72914, '64.78.15670470339798497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.205.6.129', '2019-08-29 10:50:34', 2, 0, '', '2019-08-29 10:50:34');
INSERT INTO `access_log` VALUES (72915, '59.77.15670470348998057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.205.6.129', '2019-08-29 10:50:35', 3, 0, '', '2019-08-29 10:50:35');
INSERT INTO `access_log` VALUES (72916, '59.74.15670470348998081', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '111.205.6.129', '2019-08-29 10:50:35', 13, 2001001000, '服务端发生异常', '2019-08-29 10:50:35');
INSERT INTO `access_log` VALUES (72917, '65.53.15670472932961397', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.41.167.245', '2019-08-29 10:54:53', 1, 1002001015, '账号未登陆', '2019-08-29 10:54:53');
INSERT INTO `access_log` VALUES (72918, '65.3607.15670472932983253', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.41.167.245', '2019-08-29 10:54:53', 0, 1002001015, '账号未登陆', '2019-08-29 10:54:53');
INSERT INTO `access_log` VALUES (72919, '65.46.15670472933011481', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.41.167.245', '2019-08-29 10:54:53', 0, 1002001015, '账号未登陆', '2019-08-29 10:54:53');
INSERT INTO `access_log` VALUES (72920, '65.54.15670472953751339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.41.167.245', '2019-08-29 10:54:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 10:54:55');
INSERT INTO `access_log` VALUES (72921, '65.50.15670473010861445', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.41.167.245', '2019-08-29 10:55:01', 79, 0, '', '2019-08-29 10:55:01');
INSERT INTO `access_log` VALUES (72922, '65.45.15670473014031481', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.41.167.245', '2019-08-29 10:55:01', 8, 0, '', '2019-08-29 10:55:01');
INSERT INTO `access_log` VALUES (72923, '65.47.15670473014011393', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.41.167.245', '2019-08-29 10:55:01', 10, 0, '', '2019-08-29 10:55:01');
INSERT INTO `access_log` VALUES (72924, '65.49.15670473014031467', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.41.167.245', '2019-08-29 10:55:01', 11, 2001001000, '服务端发生异常', '2019-08-29 10:55:01');
INSERT INTO `access_log` VALUES (72925, '65.52.15670474375971505', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.48.47.239', '2019-08-29 10:57:18', 1, 1002001015, '账号未登陆', '2019-08-29 10:57:18');
INSERT INTO `access_log` VALUES (72926, '65.49.15670474375961469', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.48.47.239', '2019-08-29 10:57:18', 1, 1002001015, '账号未登陆', '2019-08-29 10:57:18');
INSERT INTO `access_log` VALUES (72927, '65.46.15670474376061485', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.48.47.239', '2019-08-29 10:57:18', 0, 1002001015, '账号未登陆', '2019-08-29 10:57:18');
INSERT INTO `access_log` VALUES (72928, '65.3607.15670474564093257', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.48.47.239', '2019-08-29 10:57:36', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 10:57:36');
INSERT INTO `access_log` VALUES (72929, '65.54.15670474595181343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.48.47.239', '2019-08-29 10:57:40', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 10:57:40');
INSERT INTO `access_log` VALUES (72930, '65.47.15670474769731397', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.48.47.239', '2019-08-29 10:57:57', 79, 0, '', '2019-08-29 10:57:57');
INSERT INTO `access_log` VALUES (72931, '65.45.15670474774931485', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.48.47.239', '2019-08-29 10:57:57', 10, 0, '', '2019-08-29 10:57:58');
INSERT INTO `access_log` VALUES (72932, '65.46.15670474775021487', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.48.47.239', '2019-08-29 10:57:58', 10, 2001001000, '服务端发生异常', '2019-08-29 10:57:58');
INSERT INTO `access_log` VALUES (72933, '65.49.15670474775061471', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.48.47.239', '2019-08-29 10:57:58', 16, 0, '', '2019-08-29 10:57:58');
INSERT INTO `access_log` VALUES (72934, '65.52.15670474880551507', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.48.47.239', '2019-08-29 10:58:08', 9, 0, '', '2019-08-29 10:58:08');
INSERT INTO `access_log` VALUES (72935, '65.53.15670474880581403', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.48.47.239', '2019-08-29 10:58:08', 9, 2001001000, '服务端发生异常', '2019-08-29 10:58:08');
INSERT INTO `access_log` VALUES (72936, '65.3607.15670474880633259', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.48.47.239', '2019-08-29 10:58:08', 10, 0, '', '2019-08-29 10:58:08');
INSERT INTO `access_log` VALUES (72937, '65.52.15670485129701521', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.87.45', '2019-08-29 11:15:13', 1, 1002001015, '账号未登陆', '2019-08-29 11:15:13');
INSERT INTO `access_log` VALUES (72938, '65.51.15670485129701525', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.87.45', '2019-08-29 11:15:13', 1, 1002001015, '账号未登陆', '2019-08-29 11:15:13');
INSERT INTO `access_log` VALUES (72939, '65.54.15670485129721359', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.87.45', '2019-08-29 11:15:13', 0, 1002001015, '账号未登陆', '2019-08-29 11:15:13');
INSERT INTO `access_log` VALUES (72940, '65.47.15670485254531413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.87.45', '2019-08-29 11:15:25', 87, 0, '', '2019-08-29 11:15:26');
INSERT INTO `access_log` VALUES (72941, '65.45.15670485257551501', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.87.45', '2019-08-29 11:15:26', 9, 0, '', '2019-08-29 11:15:26');
INSERT INTO `access_log` VALUES (72942, '65.49.15670485257571487', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.87.45', '2019-08-29 11:15:26', 10, 2001001000, '服务端发生异常', '2019-08-29 11:15:26');
INSERT INTO `access_log` VALUES (72943, '65.46.15670485257611503', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.236.87.45', '2019-08-29 11:15:26', 8, 0, '', '2019-08-29 11:15:26');
INSERT INTO `access_log` VALUES (72944, '65.53.15670488271511423', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '171.11.245.70', '2019-08-29 11:20:27', 9, 2001001000, '服务端发生异常', '2019-08-29 11:20:27');
INSERT INTO `access_log` VALUES (72945, '65.51.15670488271511531', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '171.11.245.70', '2019-08-29 11:20:27', 10, 0, '', '2019-08-29 11:20:27');
INSERT INTO `access_log` VALUES (72946, '65.3607.15670488271503279', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '171.11.245.70', '2019-08-29 11:20:27', 15, 0, '', '2019-08-29 11:20:27');
INSERT INTO `access_log` VALUES (72947, '65.3607.15670526782673331', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.167.101.22', '2019-08-29 12:24:38', 1, 1002001015, '账号未登陆', '2019-08-29 12:24:38');
INSERT INTO `access_log` VALUES (72948, '65.46.15670526782671559', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.167.101.22', '2019-08-29 12:24:38', 1, 1002001015, '账号未登陆', '2019-08-29 12:24:38');
INSERT INTO `access_log` VALUES (72949, '65.51.15670526782691583', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.167.101.22', '2019-08-29 12:24:38', 1, 1002001015, '账号未登陆', '2019-08-29 12:24:38');
INSERT INTO `access_log` VALUES (72950, '65.52.15670526802791579', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.167.101.22', '2019-08-29 12:24:40', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 12:24:40');
INSERT INTO `access_log` VALUES (72951, '65.54.15670526829561417', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.167.101.22', '2019-08-29 12:24:43', 102, 0, '', '2019-08-29 12:24:43');
INSERT INTO `access_log` VALUES (72952, '65.50.15670526833511523', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.167.101.22', '2019-08-29 12:24:43', 20, 0, '', '2019-08-29 12:24:43');
INSERT INTO `access_log` VALUES (72953, '65.45.15670526833551559', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.167.101.22', '2019-08-29 12:24:43', 17, 0, '', '2019-08-29 12:24:43');
INSERT INTO `access_log` VALUES (72954, '65.47.15670526833511471', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.167.101.22', '2019-08-29 12:24:43', 21, 2001001000, '服务端发生异常', '2019-08-29 12:24:43');
INSERT INTO `access_log` VALUES (72955, '65.52.15670544075381603', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '37.9.113.171', '2019-08-29 12:53:28', 1, 1002001015, '账号未登陆', '2019-08-29 12:53:28');
INSERT INTO `access_log` VALUES (72956, '65.54.15670544084611441', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '37.9.113.171', '2019-08-29 12:53:28', 0, 1002001015, '账号未登陆', '2019-08-29 12:53:28');
INSERT INTO `access_log` VALUES (72957, '65.50.15670544101941547', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '37.9.113.171', '2019-08-29 12:53:30', 1, 1002001015, '账号未登陆', '2019-08-29 12:53:30');
INSERT INTO `access_log` VALUES (72958, '65.52.15670573616241643', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.194.126.225', '2019-08-29 13:42:42', 0, 1002001015, '账号未登陆', '2019-08-29 13:42:42');
INSERT INTO `access_log` VALUES (72959, '65.54.15670573616241481', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.194.126.225', '2019-08-29 13:42:42', 0, 1002001015, '账号未登陆', '2019-08-29 13:42:42');
INSERT INTO `access_log` VALUES (72960, '65.50.15670573616251587', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '111.194.126.225', '2019-08-29 13:42:42', 1, 1002001015, '账号未登陆', '2019-08-29 13:42:42');
INSERT INTO `access_log` VALUES (72961, '65.49.15670575398891611', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '119.139.197.119', '2019-08-29 13:45:40', 0, 1002001015, '账号未登陆', '2019-08-29 13:45:40');
INSERT INTO `access_log` VALUES (72962, '65.46.15670575398891627', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '119.139.197.119', '2019-08-29 13:45:40', 0, 1002001015, '账号未登陆', '2019-08-29 13:45:40');
INSERT INTO `access_log` VALUES (72963, '65.3607.15670575403523399', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '119.139.197.119', '2019-08-29 13:45:40', 0, 1002001015, '账号未登陆', '2019-08-29 13:45:40');
INSERT INTO `access_log` VALUES (72964, '65.51.15670575496311651', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '119.139.197.119', '2019-08-29 13:45:50', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 13:45:50');
INSERT INTO `access_log` VALUES (72965, '59.78.15670578895928227', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '58.213.156.170', '2019-08-29 13:51:30', 9, 2001001000, '服务端发生异常', '2019-08-29 13:51:30');
INSERT INTO `access_log` VALUES (72966, '59.72.15670578895928213', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '58.213.156.170', '2019-08-29 13:51:30', 624, 0, '', '2019-08-29 13:51:30');
INSERT INTO `access_log` VALUES (72967, '64.83.15670578936938617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '58.213.156.170', '2019-08-29 13:51:34', 10, 0, '', '2019-08-29 13:51:34');
INSERT INTO `access_log` VALUES (72968, '64.82.15670578938878629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '58.213.156.170', '2019-08-29 13:51:34', 3, 0, '', '2019-08-29 13:51:34');
INSERT INTO `access_log` VALUES (72969, '64.77.15670578954728601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '58.213.156.170', '2019-08-29 13:51:35', 77, 0, '', '2019-08-29 13:51:36');
INSERT INTO `access_log` VALUES (72970, '64.80.15670578961348623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '58.213.156.170', '2019-08-29 13:51:36', 1, 0, '', '2019-08-29 13:51:36');
INSERT INTO `access_log` VALUES (72971, '65.47.15670579008471543', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '119.139.197.119', '2019-08-29 13:51:41', 92, 0, '', '2019-08-29 13:51:41');
INSERT INTO `access_log` VALUES (72972, '65.45.15670579012101631', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '119.139.197.119', '2019-08-29 13:51:41', 14, 0, '', '2019-08-29 13:51:41');
INSERT INTO `access_log` VALUES (72973, '65.49.15670579012111617', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '119.139.197.119', '2019-08-29 13:51:41', 15, 2001001000, '服务端发生异常', '2019-08-29 13:51:41');
INSERT INTO `access_log` VALUES (72974, '65.46.15670579012531633', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '119.139.197.119', '2019-08-29 13:51:41', 11, 0, '', '2019-08-29 13:51:41');
INSERT INTO `access_log` VALUES (72975, '65.51.15670579063031657', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '119.139.197.119', '2019-08-29 13:51:46', 11, 0, '', '2019-08-29 13:51:46');
INSERT INTO `access_log` VALUES (72976, '65.3607.15670579063033405', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '119.139.197.119', '2019-08-29 13:51:46', 10, 0, '', '2019-08-29 13:51:46');
INSERT INTO `access_log` VALUES (72977, '65.53.15670579063041549', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '119.139.197.119', '2019-08-29 13:51:46', 11, 2001001000, '服务端发生异常', '2019-08-29 13:51:46');
INSERT INTO `access_log` VALUES (72978, '65.50.15670580901191599', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.109.34.115', '2019-08-29 13:54:50', 0, 1002001015, '账号未登陆', '2019-08-29 13:54:50');
INSERT INTO `access_log` VALUES (72979, '65.47.15670580901221547', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.109.34.115', '2019-08-29 13:54:50', 0, 1002001015, '账号未登陆', '2019-08-29 13:54:50');
INSERT INTO `access_log` VALUES (72980, '65.49.15670580901311621', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.109.34.115', '2019-08-29 13:54:50', 1, 1002001015, '账号未登陆', '2019-08-29 13:54:50');
INSERT INTO `access_log` VALUES (72981, '65.46.15670581060551637', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.109.34.115', '2019-08-29 13:55:06', 13, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 13:55:06');
INSERT INTO `access_log` VALUES (72982, '65.3607.15670581093623409', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.109.34.115', '2019-08-29 13:55:09', 92, 0, '', '2019-08-29 13:55:09');
INSERT INTO `access_log` VALUES (72983, '65.53.15670581096821553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.109.34.115', '2019-08-29 13:55:10', 10, 0, '', '2019-08-29 13:55:10');
INSERT INTO `access_log` VALUES (72984, '65.54.15670581096831495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.109.34.115', '2019-08-29 13:55:10', 10, 2001001000, '服务端发生异常', '2019-08-29 13:55:10');
INSERT INTO `access_log` VALUES (72985, '65.52.15670581096881657', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.109.34.115', '2019-08-29 13:55:10', 9, 0, '', '2019-08-29 13:55:10');
INSERT INTO `access_log` VALUES (72986, '65.47.15670581334301549', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '119.139.197.119', '2019-08-29 13:55:33', 11, 0, '', '2019-08-29 13:55:33');
INSERT INTO `access_log` VALUES (72987, '65.49.15670581334321623', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '119.139.197.119', '2019-08-29 13:55:33', 10, 2001001000, '服务端发生异常', '2019-08-29 13:55:33');
INSERT INTO `access_log` VALUES (72988, '65.45.15670581334351637', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '119.139.197.119', '2019-08-29 13:55:33', 9, 0, '', '2019-08-29 13:55:33');
INSERT INTO `access_log` VALUES (72989, '59.74.15670586811108237', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:04:41', 3, 0, '', '2019-08-29 14:04:41');
INSERT INTO `access_log` VALUES (72990, '59.77.15670586811108213', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:04:41', 10, 2001001000, '服务端发生异常', '2019-08-29 14:04:41');
INSERT INTO `access_log` VALUES (72991, '64.85.15670586848568651', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:04:45', 5, 0, '', '2019-08-29 14:04:45');
INSERT INTO `access_log` VALUES (72992, '64.81.15670586849938633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:04:45', 2, 0, '', '2019-08-29 14:04:45');
INSERT INTO `access_log` VALUES (72993, '64.79.15670586860538629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:04:46', 2, 0, '', '2019-08-29 14:04:46');
INSERT INTO `access_log` VALUES (72994, '64.83.15670586866678629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:04:47', 2, 0, '', '2019-08-29 14:04:47');
INSERT INTO `access_log` VALUES (72995, '64.82.15670586872348641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:04:47', 2, 0, '', '2019-08-29 14:04:47');
INSERT INTO `access_log` VALUES (72996, '65.47.15670586981861557', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:04:58', 0, 1002001015, '账号未登陆', '2019-08-29 14:04:58');
INSERT INTO `access_log` VALUES (72997, '65.45.15670586981931645', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:04:58', 0, 1002001015, '账号未登陆', '2019-08-29 14:04:58');
INSERT INTO `access_log` VALUES (72998, '65.46.15670586982081647', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:04:58', 1, 1002001015, '账号未登陆', '2019-08-29 14:04:58');
INSERT INTO `access_log` VALUES (72999, '65.51.15670587003351671', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:05:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:05:00');
INSERT INTO `access_log` VALUES (73000, '65.54.15670587103281505', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:05:10', 73, 0, '', '2019-08-29 14:05:10');
INSERT INTO `access_log` VALUES (73001, '65.52.15670587106391667', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:05:11', 9, 0, '', '2019-08-29 14:05:11');
INSERT INTO `access_log` VALUES (73002, '65.53.15670587106461563', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:05:11', 9, 2001001000, '服务端发生异常', '2019-08-29 14:05:11');
INSERT INTO `access_log` VALUES (73003, '65.50.15670587106521611', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.57.136.234', '2019-08-29 14:05:11', 9, 0, '', '2019-08-29 14:05:11');
INSERT INTO `access_log` VALUES (73004, '65.45.15670600739711665', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.208.98', '2019-08-29 14:27:54', 0, 1002001015, '账号未登陆', '2019-08-29 14:27:54');
INSERT INTO `access_log` VALUES (73005, '65.46.15670600739711665', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.208.98', '2019-08-29 14:27:54', 0, 1002001015, '账号未登陆', '2019-08-29 14:27:54');
INSERT INTO `access_log` VALUES (73006, '65.51.15670600739721691', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.208.98', '2019-08-29 14:27:54', 0, 1002001015, '账号未登陆', '2019-08-29 14:27:54');
INSERT INTO `access_log` VALUES (73007, '65.3607.15670600758683441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.208.98', '2019-08-29 14:27:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:27:56');
INSERT INTO `access_log` VALUES (73008, '65.54.15670600787781525', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.208.98', '2019-08-29 14:27:59', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:27:59');
INSERT INTO `access_log` VALUES (73009, '65.50.15670600817571631', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.208.98', '2019-08-29 14:28:02', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:28:02');
INSERT INTO `access_log` VALUES (73010, '65.52.15670600874761687', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.208.98', '2019-08-29 14:28:07', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:28:07');
INSERT INTO `access_log` VALUES (73011, '65.49.15670600916211653', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.208.98', '2019-08-29 14:28:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:28:12');
INSERT INTO `access_log` VALUES (73012, '65.47.15670601013751577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.208.98', '2019-08-29 14:28:21', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:28:21');
INSERT INTO `access_log` VALUES (73013, '65.51.15670601066071693', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '123.157.208.98', '2019-08-29 14:28:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:28:27');
INSERT INTO `access_log` VALUES (73014, '65.3607.15670617729783465', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:56:13', 0, 1002001015, '账号未登陆', '2019-08-29 14:56:13');
INSERT INTO `access_log` VALUES (73015, '65.54.15670617730011549', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:56:13', 0, 1002001015, '账号未登陆', '2019-08-29 14:56:13');
INSERT INTO `access_log` VALUES (73016, '65.50.15670617730021655', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:56:13', 0, 1002001015, '账号未登陆', '2019-08-29 14:56:13');
INSERT INTO `access_log` VALUES (73017, '65.52.15670617747021711', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:56:15', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:56:15');
INSERT INTO `access_log` VALUES (73018, '65.53.15670617770631607', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:56:17', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:56:17');
INSERT INTO `access_log` VALUES (73019, '65.49.15670617794131677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:56:19', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:56:19');
INSERT INTO `access_log` VALUES (73020, '65.45.15670617921071691', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:56:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:56:32');
INSERT INTO `access_log` VALUES (73021, '65.46.15670618032821691', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:56:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:56:43');
INSERT INTO `access_log` VALUES (73022, '65.3607.15670618039723467', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:56:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:56:44');
INSERT INTO `access_log` VALUES (73023, '65.54.15670618043441551', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:56:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:56:44');
INSERT INTO `access_log` VALUES (73024, '65.50.15670618047191657', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:56:45', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:56:45');
INSERT INTO `access_log` VALUES (73025, '59.71.15670618272208265', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:57:07', 11, 0, '', '2019-08-29 14:57:07');
INSERT INTO `access_log` VALUES (73026, '59.73.15670618272208269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:57:07', 26, 2001001000, '服务端发生异常', '2019-08-29 14:57:07');
INSERT INTO `access_log` VALUES (73027, '65.49.15670618392761679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:57:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:57:19');
INSERT INTO `access_log` VALUES (73028, '65.47.15670618407951603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:57:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:57:21');
INSERT INTO `access_log` VALUES (73029, '65.45.15670618411991693', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:57:21', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:57:21');
INSERT INTO `access_log` VALUES (73030, '65.51.15670618415411719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3889.0 Safari/537.36 Edg/78.0.259.0', '114.252.58.109', '2019-08-29 14:57:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 14:57:22');
INSERT INTO `access_log` VALUES (73031, '65.52.15670625551591725', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.109.34.115', '2019-08-29 15:09:15', 4, 1002001012, '访问令牌已过期', '2019-08-29 15:09:15');
INSERT INTO `access_log` VALUES (73032, '65.54.15670625551581561', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.109.34.115', '2019-08-29 15:09:15', 4, 1002001012, '访问令牌已过期', '2019-08-29 15:09:15');
INSERT INTO `access_log` VALUES (73033, '65.49.15670625551591691', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.109.34.115', '2019-08-29 15:09:15', 3, 1002001012, '访问令牌已过期', '2019-08-29 15:09:15');
INSERT INTO `access_log` VALUES (73034, '65.3607.15670645758673505', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '202.105.139.120', '2019-08-29 15:42:56', 0, 1002001015, '账号未登陆', '2019-08-29 15:42:56');
INSERT INTO `access_log` VALUES (73035, '65.46.15670645758671729', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '202.105.139.120', '2019-08-29 15:42:56', 1, 1002001015, '账号未登陆', '2019-08-29 15:42:56');
INSERT INTO `access_log` VALUES (73036, '65.52.15670645758691753', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '202.105.139.120', '2019-08-29 15:42:56', 1, 1002001015, '账号未登陆', '2019-08-29 15:42:56');
INSERT INTO `access_log` VALUES (73037, '65.49.15670645819131719', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '202.105.139.120', '2019-08-29 15:43:02', 292, 0, '', '2019-08-29 15:43:02');
INSERT INTO `access_log` VALUES (73038, '65.54.15670645824391589', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '202.105.139.120', '2019-08-29 15:43:02', 12, 0, '', '2019-08-29 15:43:02');
INSERT INTO `access_log` VALUES (73039, '65.50.15670645824391699', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '202.105.139.120', '2019-08-29 15:43:02', 12, 2001001000, '服务端发生异常', '2019-08-29 15:43:02');
INSERT INTO `access_log` VALUES (73040, '65.53.15670645824461649', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '202.105.139.120', '2019-08-29 15:43:02', 11, 0, '', '2019-08-29 15:43:02');
INSERT INTO `access_log` VALUES (73041, '59.80.15670646030968277', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '202.105.139.120', '2019-08-29 15:43:23', 9, 0, '', '2019-08-29 15:43:23');
INSERT INTO `access_log` VALUES (73042, '59.74.15670646030998317', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '202.105.139.120', '2019-08-29 15:43:23', 23, 2001001000, '服务端发生异常', '2019-08-29 15:43:23');
INSERT INTO `access_log` VALUES (73043, '65.3607.15670647344613507', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:45:34', 0, 1002001015, '账号未登陆', '2019-08-29 15:45:34');
INSERT INTO `access_log` VALUES (73044, '65.52.15670647344661757', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:45:34', 0, 1002001015, '账号未登陆', '2019-08-29 15:45:34');
INSERT INTO `access_log` VALUES (73045, '65.49.15670647344701723', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:45:34', 0, 1002001015, '账号未登陆', '2019-08-29 15:45:34');
INSERT INTO `access_log` VALUES (73046, '65.53.15670647381441651', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:45:38', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 15:45:38');
INSERT INTO `access_log` VALUES (73047, '65.54.15670647430241593', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:45:43', 93, 0, '', '2019-08-29 15:45:43');
INSERT INTO `access_log` VALUES (73048, '65.51.15670647433211763', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:45:43', 19, 0, '', '2019-08-29 15:45:43');
INSERT INTO `access_log` VALUES (73049, '65.45.15670647433261737', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:45:43', 19, 0, '', '2019-08-29 15:45:43');
INSERT INTO `access_log` VALUES (73050, '65.47.15670647433251647', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:45:43', 20, 2001001000, '服务端发生异常', '2019-08-29 15:45:43');
INSERT INTO `access_log` VALUES (73051, '65.54.15670648357351595', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:47:16', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 15:47:16');
INSERT INTO `access_log` VALUES (73052, '65.45.15670648401681739', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:47:20', 76, 0, '', '2019-08-29 15:47:20');
INSERT INTO `access_log` VALUES (73053, '65.47.15670648403951649', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:47:20', 7, 0, '', '2019-08-29 15:47:20');
INSERT INTO `access_log` VALUES (73054, '65.51.15670648404201765', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:47:20', 8, 0, '', '2019-08-29 15:47:20');
INSERT INTO `access_log` VALUES (73055, '65.46.15670648404221737', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:47:20', 7, 0, '', '2019-08-29 15:47:20');
INSERT INTO `access_log` VALUES (73056, '65.49.15670648494371727', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:47:29', 26, 0, '', '2019-08-29 15:47:29');
INSERT INTO `access_log` VALUES (73057, '65.52.15670648520391761', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:47:32', 18, 0, '', '2019-08-29 15:47:32');
INSERT INTO `access_log` VALUES (73058, '65.53.15670648563221655', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:47:36', 9, 0, '', '2019-08-29 15:47:36');
INSERT INTO `access_log` VALUES (73059, '65.45.15670648868141741', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:48:07', 14, 0, '', '2019-08-29 15:48:07');
INSERT INTO `access_log` VALUES (73060, '65.51.15670648901201767', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:48:10', 8, 0, '', '2019-08-29 15:48:10');
INSERT INTO `access_log` VALUES (73061, '65.47.15670648921011651', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:48:12', 8, 0, '', '2019-08-29 15:48:12');
INSERT INTO `access_log` VALUES (73062, '65.3607.15670648987353513', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:48:19', 10, 0, '', '2019-08-29 15:48:19');
INSERT INTO `access_log` VALUES (73063, '65.49.15670649012121729', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.204.27.103', '2019-08-29 15:48:21', 12, 0, '', '2019-08-29 15:48:21');
INSERT INTO `access_log` VALUES (73064, '65.50.15670649265641709', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.229.162', '2019-08-29 15:48:47', 0, 1002001015, '账号未登陆', '2019-08-29 15:48:47');
INSERT INTO `access_log` VALUES (73065, '65.54.15670649265691599', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.229.162', '2019-08-29 15:48:47', 0, 1002001015, '账号未登陆', '2019-08-29 15:48:47');
INSERT INTO `access_log` VALUES (73066, '65.45.15670649265791743', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.229.162', '2019-08-29 15:48:47', 0, 1002001015, '账号未登陆', '2019-08-29 15:48:47');
INSERT INTO `access_log` VALUES (73067, '65.51.15670649342011769', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.229.162', '2019-08-29 15:48:54', 78, 0, '', '2019-08-29 15:48:54');
INSERT INTO `access_log` VALUES (73068, '65.47.15670649346951653', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.229.162', '2019-08-29 15:48:55', 9, 0, '', '2019-08-29 15:48:55');
INSERT INTO `access_log` VALUES (73069, '65.3607.15670649348123515', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.229.162', '2019-08-29 15:48:55', 9, 2001001000, '服务端发生异常', '2019-08-29 15:48:55');
INSERT INTO `access_log` VALUES (73070, '65.49.15670649348121731', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.229.162', '2019-08-29 15:48:55', 9, 0, '', '2019-08-29 15:48:55');
INSERT INTO `access_log` VALUES (73071, '65.3607.15670658087403527', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:03:29', 0, 1002001015, '账号未登陆', '2019-08-29 16:03:29');
INSERT INTO `access_log` VALUES (73072, '65.49.15670658087551743', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:03:29', 1, 1002001015, '账号未登陆', '2019-08-29 16:03:29');
INSERT INTO `access_log` VALUES (73073, '65.52.15670658087621777', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:03:29', 1, 1002001015, '账号未登陆', '2019-08-29 16:03:29');
INSERT INTO `access_log` VALUES (73074, '65.53.15670658119191671', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:03:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 16:03:32');
INSERT INTO `access_log` VALUES (73075, '65.54.15670658368821613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:03:57', 316, 0, '', '2019-08-29 16:03:57');
INSERT INTO `access_log` VALUES (73076, '65.46.15670658375771755', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:03:58', 9, 0, '', '2019-08-29 16:03:58');
INSERT INTO `access_log` VALUES (73077, '65.51.15670658375801783', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:03:58', 9, 2001001000, '服务端发生异常', '2019-08-29 16:03:58');
INSERT INTO `access_log` VALUES (73078, '65.47.15670658376121667', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:03:58', 10, 0, '', '2019-08-29 16:03:58');
INSERT INTO `access_log` VALUES (73079, '59.78.15670661711298339', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:09:31', 3, 0, '', '2019-08-29 16:09:31');
INSERT INTO `access_log` VALUES (73080, '59.72.15670661711368325', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:09:31', 19, 2001001000, '服务端发生异常', '2019-08-29 16:09:31');
INSERT INTO `access_log` VALUES (73081, '64.84.15670661796328725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:09:40', 14, 0, '', '2019-08-29 16:09:40');
INSERT INTO `access_log` VALUES (73082, '64.77.15670661799098713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:09:40', 4, 0, '', '2019-08-29 16:09:40');
INSERT INTO `access_log` VALUES (73083, '64.80.15670661830178735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:09:43', 23, 0, '', '2019-08-29 16:09:43');
INSERT INTO `access_log` VALUES (73084, '64.78.15670661836958755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:09:44', 2, 0, '', '2019-08-29 16:09:44');
INSERT INTO `access_log` VALUES (73085, '64.76.15670661841268739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:09:44', 1, 0, '', '2019-08-29 16:09:44');
INSERT INTO `access_log` VALUES (73086, '64.85.15670661850638753', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:09:45', 2, 0, '', '2019-08-29 16:09:45');
INSERT INTO `access_log` VALUES (73087, '64.81.15670661853668735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:09:45', 2, 0, '', '2019-08-29 16:09:45');
INSERT INTO `access_log` VALUES (73088, '64.79.15670661889038731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:09:49', 2, 0, '', '2019-08-29 16:09:49');
INSERT INTO `access_log` VALUES (73089, '64.83.15670661890738731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:09:49', 2, 0, '', '2019-08-29 16:09:49');
INSERT INTO `access_log` VALUES (73090, '64.77.15670662099208715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:10', 2, 0, '', '2019-08-29 16:10:10');
INSERT INTO `access_log` VALUES (73091, '64.80.15670662100468737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:10', 2, 0, '', '2019-08-29 16:10:10');
INSERT INTO `access_log` VALUES (73092, '59.77.15670662115028315', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:12', 3, 0, '', '2019-08-29 16:10:12');
INSERT INTO `access_log` VALUES (73093, '59.80.15670662114998299', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:12', 17, 2001001000, '服务端发生异常', '2019-08-29 16:10:12');
INSERT INTO `access_log` VALUES (73094, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:14', 7, 0, '', '2019-08-29 16:10:14');
INSERT INTO `access_log` VALUES (73095, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:14', 10, 0, '', '2019-08-29 16:10:15');
INSERT INTO `access_log` VALUES (73096, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:15', 7, 0, '', '2019-08-29 16:10:15');
INSERT INTO `access_log` VALUES (73097, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:15', 9, 0, '', '2019-08-29 16:10:16');
INSERT INTO `access_log` VALUES (73098, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:16', 13, 0, '', '2019-08-29 16:10:16');
INSERT INTO `access_log` VALUES (73099, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:16', 9, 0, '', '2019-08-29 16:10:16');
INSERT INTO `access_log` VALUES (73100, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:16', 6, 0, '', '2019-08-29 16:10:16');
INSERT INTO `access_log` VALUES (73101, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:16', 9, 0, '', '2019-08-29 16:10:16');
INSERT INTO `access_log` VALUES (73102, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:16', 6, 0, '', '2019-08-29 16:10:16');
INSERT INTO `access_log` VALUES (73103, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:16', 9, 0, '', '2019-08-29 16:10:16');
INSERT INTO `access_log` VALUES (73104, '64.78.15670662163318757', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-08-29 16:10:16', 8, 0, '', '2019-08-29 16:10:16');
INSERT INTO `access_log` VALUES (73105, '59.79.15670665159388335', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.28.113.167', '2019-08-29 16:15:16', 13, 0, '', '2019-08-29 16:15:16');
INSERT INTO `access_log` VALUES (73106, '59.78.15670665159498345', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '117.28.113.167', '2019-08-29 16:15:16', 27, 2001001000, '服务端发生异常', '2019-08-29 16:15:16');
INSERT INTO `access_log` VALUES (73107, '65.45.15670675555881781', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-29 16:32:36', 4, 1002001012, '访问令牌已过期', '2019-08-29 16:32:36');
INSERT INTO `access_log` VALUES (73108, '65.54.15670675555901637', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-29 16:32:36', 3, 1002001012, '访问令牌已过期', '2019-08-29 16:32:36');
INSERT INTO `access_log` VALUES (73109, '65.50.15670675555901747', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '124.160.30.69', '2019-08-29 16:32:36', 3, 1002001012, '访问令牌已过期', '2019-08-29 16:32:36');
INSERT INTO `access_log` VALUES (73110, '59.74.15670695560198385', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.88.162.39', '2019-08-29 17:05:56', 9, 0, '', '2019-08-29 17:05:56');
INSERT INTO `access_log` VALUES (73111, '59.77.15670695560208361', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.88.162.39', '2019-08-29 17:05:56', 19, 2001001000, '服务端发生异常', '2019-08-29 17:05:56');
INSERT INTO `access_log` VALUES (73112, '64.85.15670695623458799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.88.162.39', '2019-08-29 17:06:02', 11, 0, '', '2019-08-29 17:06:02');
INSERT INTO `access_log` VALUES (73113, '64.81.15670695626318783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.88.162.39', '2019-08-29 17:06:03', 5, 0, '', '2019-08-29 17:06:03');
INSERT INTO `access_log` VALUES (73114, '64.79.15670695663208779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.88.162.39', '2019-08-29 17:06:06', 3, 0, '', '2019-08-29 17:06:06');
INSERT INTO `access_log` VALUES (73115, '64.82.15670695664598791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.88.162.39', '2019-08-29 17:06:06', 1, 0, '', '2019-08-29 17:06:06');
INSERT INTO `access_log` VALUES (73116, '59.71.15670695691188371', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.88.162.39', '2019-08-29 17:06:09', 3, 0, '', '2019-08-29 17:06:09');
INSERT INTO `access_log` VALUES (73117, '59.73.15670695691188375', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '171.88.162.39', '2019-08-29 17:06:09', 14, 2001001000, '服务端发生异常', '2019-08-29 17:06:09');
INSERT INTO `access_log` VALUES (73118, '59.79.15670709159518395', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3773.400', '183.63.119.6', '2019-08-29 17:28:36', 3, 0, '', '2019-08-29 17:28:36');
INSERT INTO `access_log` VALUES (73119, '59.78.15670709159518405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3773.400', '183.63.119.6', '2019-08-29 17:28:36', 37, 2001001000, '服务端发生异常', '2019-08-29 17:28:36');
INSERT INTO `access_log` VALUES (73120, '64.84.15670709210318793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3773.400', '183.63.119.6', '2019-08-29 17:28:41', 5, 0, '', '2019-08-29 17:28:41');
INSERT INTO `access_log` VALUES (73121, '64.78.15670709211608821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3773.400', '183.63.119.6', '2019-08-29 17:28:41', 2, 0, '', '2019-08-29 17:28:41');
INSERT INTO `access_log` VALUES (73122, '64.77.15670709241758781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3773.400', '183.63.119.6', '2019-08-29 17:28:44', 2, 0, '', '2019-08-29 17:28:44');
INSERT INTO `access_log` VALUES (73123, '64.76.15670709248548807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3773.400', '183.63.119.6', '2019-08-29 17:28:45', 2, 0, '', '2019-08-29 17:28:45');
INSERT INTO `access_log` VALUES (73124, '59.76.15670709301838383', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3773.400', '183.63.119.6', '2019-08-29 17:28:50', 2, 0, '', '2019-08-29 17:28:50');
INSERT INTO `access_log` VALUES (73125, '59.75.15670709301838399', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3722.400 QQBrowser/10.5.3773.400', '183.63.119.6', '2019-08-29 17:28:50', 10, 2001001000, '服务端发生异常', '2019-08-29 17:28:50');
INSERT INTO `access_log` VALUES (73126, '59.73.15670716027958403', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.138.191.83', '2019-08-29 17:40:03', 4, 0, '', '2019-08-29 17:40:03');
INSERT INTO `access_log` VALUES (73127, '59.79.15670716027958405', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.138.191.83', '2019-08-29 17:40:03', 12, 2001001000, '服务端发生异常', '2019-08-29 17:40:03');
INSERT INTO `access_log` VALUES (73128, '65.45.15670716222401835', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.138.191.83', '2019-08-29 17:40:22', 0, 1002001015, '账号未登陆', '2019-08-29 17:40:22');
INSERT INTO `access_log` VALUES (73129, '65.50.15670716222411805', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.138.191.83', '2019-08-29 17:40:22', 1, 1002001015, '账号未登陆', '2019-08-29 17:40:22');
INSERT INTO `access_log` VALUES (73130, '65.54.15670716222411693', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.138.191.83', '2019-08-29 17:40:22', 0, 1002001015, '账号未登陆', '2019-08-29 17:40:22');
INSERT INTO `access_log` VALUES (73131, '65.51.15670716341721863', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.138.191.83', '2019-08-29 17:40:34', 112, 0, '', '2019-08-29 17:40:34');
INSERT INTO `access_log` VALUES (73132, '65.52.15670716347551861', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.138.191.83', '2019-08-29 17:40:35', 11, 0, '', '2019-08-29 17:40:35');
INSERT INTO `access_log` VALUES (73133, '65.49.15670716348061827', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.138.191.83', '2019-08-29 17:40:35', 12, 0, '', '2019-08-29 17:40:35');
INSERT INTO `access_log` VALUES (73134, '65.47.15670716349831747', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '211.138.191.83', '2019-08-29 17:40:35', 11, 2001001000, '服务端发生异常', '2019-08-29 17:40:35');
INSERT INTO `access_log` VALUES (73135, '59.76.15670723735058403', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.234.14', '2019-08-29 17:52:54', 3, 0, '', '2019-08-29 17:52:54');
INSERT INTO `access_log` VALUES (73136, '59.75.15670723735068419', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.234.14', '2019-08-29 17:52:54', 15, 2001001000, '服务端发生异常', '2019-08-29 17:52:54');
INSERT INTO `access_log` VALUES (73137, '65.53.15670723821011765', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.234.14', '2019-08-29 17:53:02', 0, 1002001015, '账号未登陆', '2019-08-29 17:53:02');
INSERT INTO `access_log` VALUES (73138, '65.3607.15670723821033619', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.234.14', '2019-08-29 17:53:02', 1, 1002001015, '账号未登陆', '2019-08-29 17:53:02');
INSERT INTO `access_log` VALUES (73139, '65.54.15670723821081705', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.234.14', '2019-08-29 17:53:02', 0, 1002001015, '账号未登陆', '2019-08-29 17:53:02');
INSERT INTO `access_log` VALUES (73140, '65.45.15670723905241847', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.234.14', '2019-08-29 17:53:11', 70, 0, '', '2019-08-29 17:53:11');
INSERT INTO `access_log` VALUES (73141, '65.46.15670723909051847', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.234.14', '2019-08-29 17:53:11', 11, 0, '', '2019-08-29 17:53:11');
INSERT INTO `access_log` VALUES (73142, '65.51.15670723909091875', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.234.14', '2019-08-29 17:53:11', 11, 2001001000, '服务端发生异常', '2019-08-29 17:53:11');
INSERT INTO `access_log` VALUES (73143, '65.49.15670723909121839', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.234.14', '2019-08-29 17:53:11', 11, 0, '', '2019-08-29 17:53:11');
INSERT INTO `access_log` VALUES (73144, '65.47.15670724067961759', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.234.14', '2019-08-29 17:53:27', 9, 0, '', '2019-08-29 17:53:27');
INSERT INTO `access_log` VALUES (73145, '65.54.15670724068091707', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.234.14', '2019-08-29 17:53:27', 9, 0, '', '2019-08-29 17:53:27');
INSERT INTO `access_log` VALUES (73146, '65.3607.15670724068093621', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.224.234.14', '2019-08-29 17:53:27', 10, 2001001000, '服务端发生异常', '2019-08-29 17:53:27');
INSERT INTO `access_log` VALUES (73147, '59.80.15670773469108451', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '210.74.157.182', '2019-08-29 19:15:47', 11, 0, '', '2019-08-29 19:15:47');
INSERT INTO `access_log` VALUES (73148, '59.74.15670773469108491', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '210.74.157.182', '2019-08-29 19:15:47', 18, 2001001000, '服务端发生异常', '2019-08-29 19:15:47');
INSERT INTO `access_log` VALUES (73149, '65.49.15670800466661943', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.120.15.178', '2019-08-29 20:00:47', 12, 1002001012, '访问令牌已过期', '2019-08-29 20:00:47');
INSERT INTO `access_log` VALUES (73150, '65.46.15670800466671951', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.120.15.178', '2019-08-29 20:00:47', 14, 1002001012, '访问令牌已过期', '2019-08-29 20:00:47');
INSERT INTO `access_log` VALUES (73151, '65.51.15670800466671979', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.120.15.178', '2019-08-29 20:00:47', 16, 1002001012, '访问令牌已过期', '2019-08-29 20:00:47');
INSERT INTO `access_log` VALUES (73152, '65.53.15670800561181873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.120.15.178', '2019-08-29 20:00:56', 80, 0, '', '2019-08-29 20:00:56');
INSERT INTO `access_log` VALUES (73153, '65.3607.15670800564693725', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.120.15.178', '2019-08-29 20:00:56', 14, 0, '', '2019-08-29 20:00:56');
INSERT INTO `access_log` VALUES (73154, '65.54.15670800564691813', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.120.15.178', '2019-08-29 20:00:56', 15, 2001001000, '服务端发生异常', '2019-08-29 20:00:56');
INSERT INTO `access_log` VALUES (73155, '65.50.15670800564791923', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '106.120.15.178', '2019-08-29 20:00:56', 9, 0, '', '2019-08-29 20:00:56');
INSERT INTO `access_log` VALUES (73156, '65.47.15670806657641873', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-29 20:11:06', 165, 1002001012, '访问令牌已过期', '2019-08-29 20:11:06');
INSERT INTO `access_log` VALUES (73157, '65.49.15670806657731953', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-29 20:11:06', 156, 1002001012, '访问令牌已过期', '2019-08-29 20:11:06');
INSERT INTO `access_log` VALUES (73158, '65.45.15670806657671963', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-29 20:11:06', 162, 1002001012, '访问令牌已过期', '2019-08-29 20:11:06');
INSERT INTO `access_log` VALUES (73159, '59.73.15670806660778525', 0, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.238.229.52', '2019-08-29 20:11:06', 9, 1002001012, '访问令牌已过期', '2019-08-29 20:11:06');
INSERT INTO `access_log` VALUES (73160, '65.52.15670850127902047', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.157.43.97', '2019-08-29 21:23:33', 0, 1002001015, '账号未登陆', '2019-08-29 21:23:33');
INSERT INTO `access_log` VALUES (73161, '65.51.15670850127902047', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.157.43.97', '2019-08-29 21:23:33', 1, 1002001015, '账号未登陆', '2019-08-29 21:23:33');
INSERT INTO `access_log` VALUES (73162, '65.46.15670850127902019', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.157.43.97', '2019-08-29 21:23:33', 1, 1002001015, '账号未登陆', '2019-08-29 21:23:33');
INSERT INTO `access_log` VALUES (73163, '65.53.15670850148461941', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.157.43.97', '2019-08-29 21:23:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-29 21:23:35');
INSERT INTO `access_log` VALUES (73164, '65.54.15670850318891881', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.157.43.97', '2019-08-29 21:23:52', 198, 0, '', '2019-08-29 21:23:52');
INSERT INTO `access_log` VALUES (73165, '65.3607.15670850324203793', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.157.43.97', '2019-08-29 21:23:52', 12, 0, '', '2019-08-29 21:23:52');
INSERT INTO `access_log` VALUES (73166, '65.45.15670850324252023', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.157.43.97', '2019-08-29 21:23:52', 10, 2001001000, '服务端发生异常', '2019-08-29 21:23:52');
INSERT INTO `access_log` VALUES (73167, '65.49.15670850324352013', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.157.43.97', '2019-08-29 21:23:52', 10, 0, '', '2019-08-29 21:23:52');
INSERT INTO `access_log` VALUES (73168, '65.52.15670850733592049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.157.43.97', '2019-08-29 21:24:33', 11, 0, '', '2019-08-29 21:24:33');
INSERT INTO `access_log` VALUES (73169, '65.53.15670850733691943', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.157.43.97', '2019-08-29 21:24:33', 9, 2001001000, '服务端发生异常', '2019-08-29 21:24:33');
INSERT INTO `access_log` VALUES (73170, '65.50.15670850733721993', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.157.43.97', '2019-08-29 21:24:33', 9, 0, '', '2019-08-29 21:24:33');
INSERT INTO `access_log` VALUES (73171, '65.54.15670850766081883', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.157.43.97', '2019-08-29 21:24:37', 11, 0, '', '2019-08-29 21:24:37');
INSERT INTO `access_log` VALUES (73172, '65.3607.15670850766193795', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.157.43.97', '2019-08-29 21:24:37', 10, 2001001000, '服务端发生异常', '2019-08-29 21:24:37');
INSERT INTO `access_log` VALUES (73173, '65.49.15670850766332015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.157.43.97', '2019-08-29 21:24:37', 9, 0, '', '2019-08-29 21:24:37');
INSERT INTO `access_log` VALUES (73174, '65.50.15670877715132031', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.167.65.60', '2019-08-29 22:09:32', 0, 1002001015, '账号未登陆', '2019-08-29 22:09:32');
INSERT INTO `access_log` VALUES (73175, '65.51.15670877715132089', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.167.65.60', '2019-08-29 22:09:32', 0, 1002001015, '账号未登陆', '2019-08-29 22:09:32');
INSERT INTO `access_log` VALUES (73176, '65.52.15670877715142089', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.167.65.60', '2019-08-29 22:09:32', 0, 1002001015, '账号未登陆', '2019-08-29 22:09:32');
INSERT INTO `access_log` VALUES (73177, '65.54.15670877774581923', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.167.65.60', '2019-08-29 22:09:37', 118, 0, '', '2019-08-29 22:09:38');
INSERT INTO `access_log` VALUES (73178, '65.53.15670877779031983', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.167.65.60', '2019-08-29 22:09:38', 11, 0, '', '2019-08-29 22:09:38');
INSERT INTO `access_log` VALUES (73179, '65.3607.15670877779073831', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.167.65.60', '2019-08-29 22:09:38', 10, 2001001000, '服务端发生异常', '2019-08-29 22:09:38');
INSERT INTO `access_log` VALUES (73180, '65.49.15670877779132053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.167.65.60', '2019-08-29 22:09:38', 9, 0, '', '2019-08-29 22:09:38');
INSERT INTO `access_log` VALUES (73181, '65.51.15671041211092309', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0', '117.136.38.150', '2019-08-30 02:42:01', 0, 1002001015, '账号未登陆', '2019-08-30 02:42:01');
INSERT INTO `access_log` VALUES (73182, '65.54.15671041211702143', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0', '117.136.38.150', '2019-08-30 02:42:01', 0, 1002001015, '账号未登陆', '2019-08-30 02:42:01');
INSERT INTO `access_log` VALUES (73183, '65.49.15671041211712273', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0', '117.136.38.150', '2019-08-30 02:42:01', 0, 1002001015, '账号未登陆', '2019-08-30 02:42:01');
INSERT INTO `access_log` VALUES (73184, '65.3607.15671041258994051', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0', '117.136.38.150', '2019-08-30 02:42:06', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 02:42:06');
INSERT INTO `access_log` VALUES (73185, '65.45.15671041329292285', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0', '117.136.38.150', '2019-08-30 02:42:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 02:42:13');
INSERT INTO `access_log` VALUES (73186, '65.46.15671041361982279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai213123&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0', '117.136.38.150', '2019-08-30 02:42:16', 69, 0, '', '2019-08-30 02:42:16');
INSERT INTO `access_log` VALUES (73187, '65.47.15671041374282195', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0', '117.136.38.150', '2019-08-30 02:42:17', 68, 0, '', '2019-08-30 02:42:17');
INSERT INTO `access_log` VALUES (73188, '65.50.15671041374322253', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0', '117.136.38.150', '2019-08-30 02:42:17', 66, 0, '', '2019-08-30 02:42:17');
INSERT INTO `access_log` VALUES (73189, '65.52.15671041374322311', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0', '117.136.38.150', '2019-08-30 02:42:17', 66, 0, '', '2019-08-30 02:42:17');
INSERT INTO `access_log` VALUES (73190, '59.74.15671041506608849', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0', '117.136.38.150', '2019-08-30 02:42:31', 27, 0, '', '2019-08-30 02:42:31');
INSERT INTO `access_log` VALUES (73191, '65.53.15671241965952471', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-30 08:16:37', 25, 1002001012, '访问令牌已过期', '2019-08-30 08:16:37');
INSERT INTO `access_log` VALUES (73192, '65.51.15671241965952577', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-30 08:16:37', 27, 1002001012, '访问令牌已过期', '2019-08-30 08:16:37');
INSERT INTO `access_log` VALUES (73193, '65.45.15671241966382555', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-30 08:16:37', 10, 1002001012, '访问令牌已过期', '2019-08-30 08:16:37');
INSERT INTO `access_log` VALUES (73194, '65.52.15671241985332581', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-30 08:16:39', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 08:16:39');
INSERT INTO `access_log` VALUES (73195, '65.46.15671242338112549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-30 08:17:14', 186, 0, '', '2019-08-30 08:17:14');
INSERT INTO `access_log` VALUES (73196, '65.47.15671242342862465', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-30 08:17:14', 11, 0, '', '2019-08-30 08:17:14');
INSERT INTO `access_log` VALUES (73197, '65.50.15671242342862523', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-30 08:17:14', 13, 2001001000, '服务端发生异常', '2019-08-30 08:17:14');
INSERT INTO `access_log` VALUES (73198, '65.51.15671242342902579', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '222.240.44.78', '2019-08-30 08:17:14', 13, 0, '', '2019-08-30 08:17:14');
INSERT INTO `access_log` VALUES (73199, '65.3607.15671257742364341', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.60.146', '2019-08-30 08:42:54', 0, 1002001015, '账号未登陆', '2019-08-30 08:42:54');
INSERT INTO `access_log` VALUES (73200, '65.50.15671257742362543', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.60.146', '2019-08-30 08:42:54', 1, 1002001015, '账号未登陆', '2019-08-30 08:42:54');
INSERT INTO `access_log` VALUES (73201, '65.52.15671257742362603', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.60.146', '2019-08-30 08:42:54', 1, 1002001015, '账号未登陆', '2019-08-30 08:42:54');
INSERT INTO `access_log` VALUES (73202, '65.49.15671257787392569', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.60.146', '2019-08-30 08:42:59', 62, 0, '', '2019-08-30 08:42:59');
INSERT INTO `access_log` VALUES (73203, '65.54.15671257792022437', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.60.146', '2019-08-30 08:42:59', 9, 0, '', '2019-08-30 08:42:59');
INSERT INTO `access_log` VALUES (73204, '65.46.15671257792102573', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.60.146', '2019-08-30 08:42:59', 9, 2001001000, '服务端发生异常', '2019-08-30 08:42:59');
INSERT INTO `access_log` VALUES (73205, '65.51.15671257792272603', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '115.171.60.146', '2019-08-30 08:42:59', 10, 0, '', '2019-08-30 08:42:59');
INSERT INTO `access_log` VALUES (73206, '59.78.15671274559139161', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:10:56', 11, 0, '', '2019-08-30 09:10:56');
INSERT INTO `access_log` VALUES (73207, '59.72.15671274559149147', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:10:56', 25, 2001001000, '服务端发生异常', '2019-08-30 09:10:56');
INSERT INTO `access_log` VALUES (73208, '59.80.15671275183939121', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.158.210.253', '2019-08-30 09:11:58', 3, 0, '', '2019-08-30 09:11:58');
INSERT INTO `access_log` VALUES (73209, '59.71.15671275184019147', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.158.210.253', '2019-08-30 09:11:58', 13, 2001001000, '服务端发生异常', '2019-08-30 09:11:58');
INSERT INTO `access_log` VALUES (73210, '64.82.15671275250309567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.158.210.253', '2019-08-30 09:12:05', 11, 0, '', '2019-08-30 09:12:05');
INSERT INTO `access_log` VALUES (73211, '64.84.15671275252339549', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.158.210.253', '2019-08-30 09:12:05', 2, 0, '', '2019-08-30 09:12:05');
INSERT INTO `access_log` VALUES (73212, '66.51.15671275594266603', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18703813750&code=9999', 'POST', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.158.210.253', '2019-08-30 09:12:39', 16, 1001003000, '验证码不存在', '2019-08-30 09:12:39');
INSERT INTO `access_log` VALUES (73213, '66.53.15671275625636575', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18703813750', 'POST', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.158.210.253', '2019-08-30 09:12:43', 76, 0, '', '2019-08-30 09:12:43');
INSERT INTO `access_log` VALUES (73214, '66.57.15671275814186579', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18703813750', 'POST', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.158.210.253', '2019-08-30 09:13:01', 3, 1001003005, '短信发送过于频率', '2019-08-30 09:13:01');
INSERT INTO `access_log` VALUES (73215, '66.49.15671275895026591', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18703813750', 'POST', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.158.210.253', '2019-08-30 09:13:10', 6, 1001003005, '短信发送过于频率', '2019-08-30 09:13:10');
INSERT INTO `access_log` VALUES (73216, '66.54.15671275919436603', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18703813750&code=9999', 'POST', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Redmi Note 5 Build/OPM1.171019.011) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.0.1040 Mobile Safari/537.36', '117.158.210.253', '2019-08-30 09:13:12', 227, 0, '', '2019-08-30 09:13:12');
INSERT INTO `access_log` VALUES (73217, '59.74.15671277402839167', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.183.98', '2019-08-30 09:15:40', 3, 0, '', '2019-08-30 09:15:40');
INSERT INTO `access_log` VALUES (73218, '59.80.15671277402849127', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.183.98', '2019-08-30 09:15:40', 14, 2001001000, '服务端发生异常', '2019-08-30 09:15:40');
INSERT INTO `access_log` VALUES (73219, '64.76.15671277784159567', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.183.98', '2019-08-30 09:16:18', 2, 0, '', '2019-08-30 09:16:18');
INSERT INTO `access_log` VALUES (73220, '64.80.15671277787349559', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.183.98', '2019-08-30 09:16:19', 1, 0, '', '2019-08-30 09:16:19');
INSERT INTO `access_log` VALUES (73221, '64.81.15671277810309563', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.183.98', '2019-08-30 09:16:21', 2, 0, '', '2019-08-30 09:16:21');
INSERT INTO `access_log` VALUES (73222, '64.83.15671277818939555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.183.98', '2019-08-30 09:16:22', 2, 0, '', '2019-08-30 09:16:22');
INSERT INTO `access_log` VALUES (73223, '59.78.15671277833199169', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.183.98', '2019-08-30 09:16:23', 3, 0, '', '2019-08-30 09:16:23');
INSERT INTO `access_log` VALUES (73224, '59.72.15671277833219155', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.183.98', '2019-08-30 09:16:23', 13, 2001001000, '服务端发生异常', '2019-08-30 09:16:23');
INSERT INTO `access_log` VALUES (73225, '64.79.15671277858259561', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.183.98', '2019-08-30 09:16:26', 2, 0, '', '2019-08-30 09:16:26');
INSERT INTO `access_log` VALUES (73226, '64.82.15671277861879573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.183.98', '2019-08-30 09:16:26', 2, 0, '', '2019-08-30 09:16:26');
INSERT INTO `access_log` VALUES (73227, '64.84.15671277871439555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.183.98', '2019-08-30 09:16:27', 2, 0, '', '2019-08-30 09:16:27');
INSERT INTO `access_log` VALUES (73228, '64.78.15671277876759583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '113.104.183.98', '2019-08-30 09:16:28', 2, 0, '', '2019-08-30 09:16:28');
INSERT INTO `access_log` VALUES (73229, '65.53.15671279082562523', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:18:28', 0, 1002001015, '账号未登陆', '2019-08-30 09:18:28');
INSERT INTO `access_log` VALUES (73230, '65.51.15671279082562631', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:18:28', 0, 1002001015, '账号未登陆', '2019-08-30 09:18:28');
INSERT INTO `access_log` VALUES (73231, '65.45.15671279082572609', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:18:28', 0, 1002001015, '账号未登陆', '2019-08-30 09:18:28');
INSERT INTO `access_log` VALUES (73232, '65.50.15671279153292573', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:18:35', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 09:18:35');
INSERT INTO `access_log` VALUES (73233, '65.52.15671279269962635', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:18:47', 128, 0, '', '2019-08-30 09:18:47');
INSERT INTO `access_log` VALUES (73234, '65.47.15671279273882519', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:18:47', 13, 0, '', '2019-08-30 09:18:47');
INSERT INTO `access_log` VALUES (73235, '65.49.15671279273942599', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:18:47', 16, 0, '', '2019-08-30 09:18:47');
INSERT INTO `access_log` VALUES (73236, '65.46.15671279273942605', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:18:47', 17, 2001001000, '服务端发生异常', '2019-08-30 09:18:47');
INSERT INTO `access_log` VALUES (73237, '65.51.15671279583642633', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:19:18', 11, 0, '', '2019-08-30 09:19:18');
INSERT INTO `access_log` VALUES (73238, '65.53.15671279583642525', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:19:18', 13, 2001001000, '服务端发生异常', '2019-08-30 09:19:18');
INSERT INTO `access_log` VALUES (73239, '65.50.15671279583682575', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:19:18', 9, 0, '', '2019-08-30 09:19:18');
INSERT INTO `access_log` VALUES (73240, '65.3607.15671279623354375', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:19:22', 11, 0, '', '2019-08-30 09:19:22');
INSERT INTO `access_log` VALUES (73241, '65.47.15671279623372521', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:19:22', 10, 0, '', '2019-08-30 09:19:22');
INSERT INTO `access_log` VALUES (73242, '65.52.15671279623362637', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.158.210.253', '2019-08-30 09:19:22', 11, 2001001000, '服务端发生异常', '2019-08-30 09:19:22');
INSERT INTO `access_log` VALUES (73243, '59.80.15671303811969163', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 09:59:41', 10, 0, '', '2019-08-30 09:59:41');
INSERT INTO `access_log` VALUES (73244, '59.74.15671303811999203', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 09:59:41', 12, 2001001000, '服务端发生异常', '2019-08-30 09:59:41');
INSERT INTO `access_log` VALUES (73245, '64.85.15671303875009613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 09:59:48', 10, 0, '', '2019-08-30 09:59:48');
INSERT INTO `access_log` VALUES (73246, '64.81.15671303878309599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 09:59:48', 3, 0, '', '2019-08-30 09:59:48');
INSERT INTO `access_log` VALUES (73247, '64.83.15671303896319591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 09:59:50', 2, 0, '', '2019-08-30 09:59:50');
INSERT INTO `access_log` VALUES (73248, '64.79.15671303901089597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 09:59:50', 1, 0, '', '2019-08-30 09:59:50');
INSERT INTO `access_log` VALUES (73249, '59.73.15671303927689193', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 09:59:53', 3, 0, '', '2019-08-30 09:59:53');
INSERT INTO `access_log` VALUES (73250, '59.79.15671303927689195', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 09:59:53', 21, 2001001000, '服务端发生异常', '2019-08-30 09:59:53');
INSERT INTO `access_log` VALUES (73251, '65.54.15671304059752505', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 10:00:06', 0, 1002001015, '账号未登陆', '2019-08-30 10:00:06');
INSERT INTO `access_log` VALUES (73252, '65.46.15671304059752639', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 10:00:06', 0, 1002001015, '账号未登陆', '2019-08-30 10:00:06');
INSERT INTO `access_log` VALUES (73253, '65.45.15671304059762645', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 10:00:06', 0, 1002001015, '账号未登陆', '2019-08-30 10:00:06');
INSERT INTO `access_log` VALUES (73254, '65.50.15671304106232611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 10:00:11', 88, 0, '', '2019-08-30 10:00:11');
INSERT INTO `access_log` VALUES (73255, '65.3607.15671304109084409', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 10:00:11', 14, 0, '', '2019-08-30 10:00:11');
INSERT INTO `access_log` VALUES (73256, '65.52.15671304109082671', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 10:00:11', 13, 2001001000, '服务端发生异常', '2019-08-30 10:00:11');
INSERT INTO `access_log` VALUES (73257, '65.51.15671304109122669', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '114.252.161.49', '2019-08-30 10:00:11', 10, 0, '', '2019-08-30 10:00:11');
INSERT INTO `access_log` VALUES (73258, '65.51.15671312976942681', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:14:58', 0, 1002001015, '账号未登陆', '2019-08-30 10:14:58');
INSERT INTO `access_log` VALUES (73259, '65.47.15671312977292569', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:14:58', 0, 1002001015, '账号未登陆', '2019-08-30 10:14:58');
INSERT INTO `access_log` VALUES (73260, '65.49.15671312977302649', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:14:58', 0, 1002001015, '账号未登陆', '2019-08-30 10:14:58');
INSERT INTO `access_log` VALUES (73261, '65.54.15671313073692519', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:15:07', 51, 0, '', '2019-08-30 10:15:07');
INSERT INTO `access_log` VALUES (73262, '65.45.15671313077002659', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:15:08', 9, 0, '', '2019-08-30 10:15:08');
INSERT INTO `access_log` VALUES (73263, '65.53.15671313077082573', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:15:08', 9, 0, '', '2019-08-30 10:15:08');
INSERT INTO `access_log` VALUES (73264, '65.46.15671313077072653', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:15:08', 9, 2001001000, '服务端发生异常', '2019-08-30 10:15:08');
INSERT INTO `access_log` VALUES (73265, '65.52.15671313131402685', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:15:13', 7, 0, '', '2019-08-30 10:15:13');
INSERT INTO `access_log` VALUES (73266, '65.3607.15671313131504423', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:15:13', 8, 2001001000, '服务端发生异常', '2019-08-30 10:15:13');
INSERT INTO `access_log` VALUES (73267, '65.51.15671313131522683', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:15:13', 8, 0, '', '2019-08-30 10:15:13');
INSERT INTO `access_log` VALUES (73268, '65.54.15671313449012521', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:15:45', 9, 0, '', '2019-08-30 10:15:45');
INSERT INTO `access_log` VALUES (73269, '65.46.15671313449052655', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:15:45', 10, 2001001000, '服务端发生异常', '2019-08-30 10:15:45');
INSERT INTO `access_log` VALUES (73270, '65.45.15671313449092661', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:15:45', 8, 0, '', '2019-08-30 10:15:45');
INSERT INTO `access_log` VALUES (73271, '65.53.15671313503352575', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:15:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 10:15:50');
INSERT INTO `access_log` VALUES (73272, '65.51.15671313550002685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '114.252.161.49', '2019-08-30 10:15:55', 4, 1002002001, '密码不正确', '2019-08-30 10:15:55');
INSERT INTO `access_log` VALUES (73273, '65.52.15671313673292687', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.252.161.49', '2019-08-30 10:16:07', 0, 1002001015, '账号未登陆', '2019-08-30 10:16:07');
INSERT INTO `access_log` VALUES (73274, '65.3607.15671313673374425', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.252.161.49', '2019-08-30 10:16:07', 0, 1002001015, '账号未登陆', '2019-08-30 10:16:07');
INSERT INTO `access_log` VALUES (73275, '65.47.15671313673412573', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.252.161.49', '2019-08-30 10:16:07', 0, 1002001015, '账号未登陆', '2019-08-30 10:16:07');
INSERT INTO `access_log` VALUES (73276, '65.53.15671322745182587', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:15', 0, 1002001015, '账号未登陆', '2019-08-30 10:31:15');
INSERT INTO `access_log` VALUES (73277, '65.54.15671322745182537', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:15', 1, 1002001015, '账号未登陆', '2019-08-30 10:31:15');
INSERT INTO `access_log` VALUES (73278, '65.52.15671322745222701', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:15', 0, 1002001015, '账号未登陆', '2019-08-30 10:31:15');
INSERT INTO `access_log` VALUES (73279, '59.71.15671322809999215', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:21', 25, 2001001000, '服务端发生异常', '2019-08-30 10:31:21');
INSERT INTO `access_log` VALUES (73280, '59.74.15671322809999229', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:21', 25, 0, '', '2019-08-30 10:31:21');
INSERT INTO `access_log` VALUES (73281, '65.50.15671322837552643', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:24', 58, 0, '', '2019-08-30 10:31:24');
INSERT INTO `access_log` VALUES (73282, '65.51.15671322841332699', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:24', 10, 0, '', '2019-08-30 10:31:24');
INSERT INTO `access_log` VALUES (73283, '65.49.15671322841382667', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:24', 9, 0, '', '2019-08-30 10:31:24');
INSERT INTO `access_log` VALUES (73284, '65.47.15671322841372589', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:24', 10, 2001001000, '服务端发生异常', '2019-08-30 10:31:24');
INSERT INTO `access_log` VALUES (73285, '65.46.15671322972142671', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:37', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 10:31:37');
INSERT INTO `access_log` VALUES (73286, '65.52.15671323041442703', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:44', 103, 0, '', '2019-08-30 10:31:44');
INSERT INTO `access_log` VALUES (73287, '65.53.15671323044222589', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:44', 8, 0, '', '2019-08-30 10:31:44');
INSERT INTO `access_log` VALUES (73288, '65.54.15671323044222539', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:44', 179, 2001001000, '服务端发生异常', '2019-08-30 10:31:45');
INSERT INTO `access_log` VALUES (73289, '65.50.15671323044252645', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:44', 186, 0, '', '2019-08-30 10:31:45');
INSERT INTO `access_log` VALUES (73290, '64.83.15671323093759617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:49', 11, 0, '', '2019-08-30 10:31:49');
INSERT INTO `access_log` VALUES (73291, '64.79.15671323095279623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:50', 4, 0, '', '2019-08-30 10:31:50');
INSERT INTO `access_log` VALUES (73292, '64.84.15671323105499617', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:51', 2, 0, '', '2019-08-30 10:31:51');
INSERT INTO `access_log` VALUES (73293, '64.78.15671323110779645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '182.50.118.228', '2019-08-30 10:31:51', 2, 0, '', '2019-08-30 10:31:51');
INSERT INTO `access_log` VALUES (73294, '65.51.15671327518152707', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:39:12', 0, 1002001015, '账号未登陆', '2019-08-30 10:39:12');
INSERT INTO `access_log` VALUES (73295, '65.3607.15671327518144449', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:39:12', 1, 1002001015, '账号未登陆', '2019-08-30 10:39:12');
INSERT INTO `access_log` VALUES (73296, '65.49.15671327518222675', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:39:12', 0, 1002001015, '账号未登陆', '2019-08-30 10:39:12');
INSERT INTO `access_log` VALUES (73297, '65.47.15671327571882597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:39:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 10:39:17');
INSERT INTO `access_log` VALUES (73298, '65.45.15671327757982687', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:39:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 10:39:36');
INSERT INTO `access_log` VALUES (73299, '65.50.15671327968172653', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:39:57', 71, 0, '', '2019-08-30 10:39:57');
INSERT INTO `access_log` VALUES (73300, '65.54.15671327972042547', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:39:57', 188, 0, '', '2019-08-30 10:39:57');
INSERT INTO `access_log` VALUES (73301, '65.49.15671327972122677', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:39:57', 184, 0, '', '2019-08-30 10:39:57');
INSERT INTO `access_log` VALUES (73302, '65.3607.15671327972084451', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:39:57', 187, 2001001000, '服务端发生异常', '2019-08-30 10:39:57');
INSERT INTO `access_log` VALUES (73303, '59.78.15671329094479239', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:41:49', 5, 0, '', '2019-08-30 10:41:49');
INSERT INTO `access_log` VALUES (73304, '59.72.15671329094479225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:41:49', 34, 2001001000, '服务端发生异常', '2019-08-30 10:41:49');
INSERT INTO `access_log` VALUES (73305, '64.79.15671330015259633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:43:22', 3, 0, '', '2019-08-30 10:43:22');
INSERT INTO `access_log` VALUES (73306, '64.82.15671330016539645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:43:22', 2, 0, '', '2019-08-30 10:43:22');
INSERT INTO `access_log` VALUES (73307, '64.84.15671330065779627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:43:27', 1, 0, '', '2019-08-30 10:43:27');
INSERT INTO `access_log` VALUES (73308, '59.73.15671330095329229', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:43:30', 3, 0, '', '2019-08-30 10:43:30');
INSERT INTO `access_log` VALUES (73309, '59.79.15671330095529231', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:43:30', 13, 2001001000, '服务端发生异常', '2019-08-30 10:43:30');
INSERT INTO `access_log` VALUES (73310, '64.77.15671330157709615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:43:36', 2, 0, '', '2019-08-30 10:43:36');
INSERT INTO `access_log` VALUES (73311, '64.76.15671330158869641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:43:36', 2, 0, '', '2019-08-30 10:43:36');
INSERT INTO `access_log` VALUES (73312, '64.80.15671330243979633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:43:44', 2, 0, '', '2019-08-30 10:43:44');
INSERT INTO `access_log` VALUES (73313, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:43:44', 6, 0, '', '2019-08-30 10:43:44');
INSERT INTO `access_log` VALUES (73314, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:44:17', 6, 0, '', '2019-08-30 10:44:17');
INSERT INTO `access_log` VALUES (73315, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:44:18', 4, 0, '', '2019-08-30 10:44:18');
INSERT INTO `access_log` VALUES (73316, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:44:20', 5, 0, '', '2019-08-30 10:44:20');
INSERT INTO `access_log` VALUES (73317, '64.79.15671330612519635', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.207.215.101', '2019-08-30 10:44:21', 9, 0, '', '2019-08-30 10:44:21');
INSERT INTO `access_log` VALUES (73318, '59.74.15671334070669245', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.232.106.14', '2019-08-30 10:50:07', 3, 0, '', '2019-08-30 10:50:07');
INSERT INTO `access_log` VALUES (73319, '59.73.15671334070689235', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.232.106.14', '2019-08-30 10:50:07', 16, 2001001000, '服务端发生异常', '2019-08-30 10:50:07');
INSERT INTO `access_log` VALUES (73320, '65.47.15671335736202609', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '73.211.227.144', '2019-08-30 10:52:54', 4, 1002001012, '访问令牌已过期', '2019-08-30 10:52:54');
INSERT INTO `access_log` VALUES (73321, '65.46.15671335736262691', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '73.211.227.144', '2019-08-30 10:52:54', 3, 1002001012, '访问令牌已过期', '2019-08-30 10:52:54');
INSERT INTO `access_log` VALUES (73322, '65.52.15671335739952723', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '73.211.227.144', '2019-08-30 10:52:54', 4, 1002001012, '访问令牌已过期', '2019-08-30 10:52:54');
INSERT INTO `access_log` VALUES (73323, '65.53.15671335770492609', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '73.211.227.144', '2019-08-30 10:52:57', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 10:52:57');
INSERT INTO `access_log` VALUES (73324, '59.76.15671343785659237', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.88.34', '2019-08-30 11:06:19', 2, 0, '', '2019-08-30 11:06:19');
INSERT INTO `access_log` VALUES (73325, '59.77.15671343785709235', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.88.34', '2019-08-30 11:06:19', 10, 2001001000, '服务端发生异常', '2019-08-30 11:06:19');
INSERT INTO `access_log` VALUES (73326, '64.85.15671343843879671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.88.34', '2019-08-30 11:06:24', 2, 0, '', '2019-08-30 11:06:24');
INSERT INTO `access_log` VALUES (73327, '64.81.15671343845119657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.88.34', '2019-08-30 11:06:25', 2, 0, '', '2019-08-30 11:06:25');
INSERT INTO `access_log` VALUES (73328, '64.79.15671343898399655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.88.34', '2019-08-30 11:06:30', 2, 0, '', '2019-08-30 11:06:30');
INSERT INTO `access_log` VALUES (73329, '64.83.15671343899869649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.88.34', '2019-08-30 11:06:30', 2, 0, '', '2019-08-30 11:06:30');
INSERT INTO `access_log` VALUES (73330, '64.82.15671343914439667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.88.34', '2019-08-30 11:06:31', 1, 0, '', '2019-08-30 11:06:31');
INSERT INTO `access_log` VALUES (73331, '64.84.15671343921249649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.88.34', '2019-08-30 11:06:32', 2, 0, '', '2019-08-30 11:06:32');
INSERT INTO `access_log` VALUES (73332, '64.78.15671343928359677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.88.34', '2019-08-30 11:06:33', 3, 0, '', '2019-08-30 11:06:33');
INSERT INTO `access_log` VALUES (73333, '64.77.15671343936719633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.88.34', '2019-08-30 11:06:34', 2, 0, '', '2019-08-30 11:06:34');
INSERT INTO `access_log` VALUES (73334, '64.80.15671343986829655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.88.34', '2019-08-30 11:06:39', 2, 0, '', '2019-08-30 11:06:39');
INSERT INTO `access_log` VALUES (73335, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.88.34', '2019-08-30 11:06:39', 8, 0, '', '2019-08-30 11:06:39');
INSERT INTO `access_log` VALUES (73336, '64.85.15671344043649673', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.205.88.34', '2019-08-30 11:06:44', 7, 0, '', '2019-08-30 11:06:44');
INSERT INTO `access_log` VALUES (73337, '65.46.15671345646192705', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '203.177.9.75', '2019-08-30 11:09:25', 0, 1002001015, '账号未登陆', '2019-08-30 11:09:25');
INSERT INTO `access_log` VALUES (73338, '65.45.15671345646192713', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '203.177.9.75', '2019-08-30 11:09:25', 0, 1002001015, '账号未登陆', '2019-08-30 11:09:25');
INSERT INTO `access_log` VALUES (73339, '65.52.15671345646212737', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '203.177.9.75', '2019-08-30 11:09:25', 1, 1002001015, '账号未登陆', '2019-08-30 11:09:25');
INSERT INTO `access_log` VALUES (73340, '65.53.15671345758032623', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '203.177.9.75', '2019-08-30 11:09:36', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 11:09:36');
INSERT INTO `access_log` VALUES (73341, '65.3607.15671345892294477', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '203.177.9.75', '2019-08-30 11:09:49', 78, 0, '', '2019-08-30 11:09:49');
INSERT INTO `access_log` VALUES (73342, '65.54.15671345896272573', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '203.177.9.75', '2019-08-30 11:09:50', 12, 2001001000, '服务端发生异常', '2019-08-30 11:09:50');
INSERT INTO `access_log` VALUES (73343, '65.49.15671345896302703', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '203.177.9.75', '2019-08-30 11:09:50', 10, 0, '', '2019-08-30 11:09:50');
INSERT INTO `access_log` VALUES (73344, '65.51.15671345896362735', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '203.177.9.75', '2019-08-30 11:09:50', 8, 0, '', '2019-08-30 11:09:50');
INSERT INTO `access_log` VALUES (73345, '59.73.15671360622649271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '115.231.148.11', '2019-08-30 11:34:22', 3, 0, '', '2019-08-30 11:34:22');
INSERT INTO `access_log` VALUES (73346, '59.79.15671360624329273', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '115.231.148.11', '2019-08-30 11:34:22', 13, 2001001000, '服务端发生异常', '2019-08-30 11:34:22');
INSERT INTO `access_log` VALUES (73347, '59.78.15671360631919283', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.130.10.147', '2019-08-30 11:34:23', 2, 0, '', '2019-08-30 11:34:23');
INSERT INTO `access_log` VALUES (73348, '59.72.15671360631919269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '61.130.10.147', '2019-08-30 11:34:23', 13, 2001001000, '服务端发生异常', '2019-08-30 11:34:23');
INSERT INTO `access_log` VALUES (73349, '64.79.15671360697819679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '115.231.148.11', '2019-08-30 11:34:30', 2, 0, '', '2019-08-30 11:34:30');
INSERT INTO `access_log` VALUES (73350, '64.83.15671360698999673', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '115.231.148.11', '2019-08-30 11:34:30', 2, 0, '', '2019-08-30 11:34:30');
INSERT INTO `access_log` VALUES (73351, '64.82.15671360727529691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '115.231.148.11', '2019-08-30 11:34:33', 2, 0, '', '2019-08-30 11:34:33');
INSERT INTO `access_log` VALUES (73352, '64.84.15671360734189673', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '115.231.148.11', '2019-08-30 11:34:33', 2, 0, '', '2019-08-30 11:34:33');
INSERT INTO `access_log` VALUES (73353, '64.78.15671360745359701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '115.231.148.11', '2019-08-30 11:34:35', 2, 0, '', '2019-08-30 11:34:35');
INSERT INTO `access_log` VALUES (73354, '59.76.15671360752249261', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:34:35', 2, 0, '', '2019-08-30 11:34:35');
INSERT INTO `access_log` VALUES (73355, '59.77.15671360752269259', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:34:35', 13, 2001001000, '服务端发生异常', '2019-08-30 11:34:35');
INSERT INTO `access_log` VALUES (73356, '64.80.15671360952219679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:34:55', 2, 0, '', '2019-08-30 11:34:55');
INSERT INTO `access_log` VALUES (73357, '64.85.15671360955829697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:34:56', 2, 0, '', '2019-08-30 11:34:56');
INSERT INTO `access_log` VALUES (73358, '64.81.15671360976679683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:34:58', 2, 0, '', '2019-08-30 11:34:58');
INSERT INTO `access_log` VALUES (73359, '64.79.15671360990189681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:34:59', 2, 0, '', '2019-08-30 11:34:59');
INSERT INTO `access_log` VALUES (73360, '64.83.15671361005869675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:35:01', 1, 0, '', '2019-08-30 11:35:01');
INSERT INTO `access_log` VALUES (73361, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:35:01', 5, 0, '', '2019-08-30 11:35:01');
INSERT INTO `access_log` VALUES (73362, '64.82.15671361025049693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:35:03', 2, 0, '', '2019-08-30 11:35:03');
INSERT INTO `access_log` VALUES (73363, '64.84.15671361028419675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:35:03', 1, 0, '', '2019-08-30 11:35:03');
INSERT INTO `access_log` VALUES (73364, '64.78.15671361039839703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:35:04', 2, 0, '', '2019-08-30 11:35:04');
INSERT INTO `access_log` VALUES (73365, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:35:04', 5, 0, '', '2019-08-30 11:35:04');
INSERT INTO `access_log` VALUES (73366, '64.76.15671361074499687', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:35:07', 8, 0, '', '2019-08-30 11:35:07');
INSERT INTO `access_log` VALUES (73367, '66.51.15671361453906719', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15279514680&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:35:45', 22, 1001003000, '验证码不存在', '2019-08-30 11:35:45');
INSERT INTO `access_log` VALUES (73368, '66.53.15671361491286689', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15279514680', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:35:49', 124, 0, '', '2019-08-30 11:35:49');
INSERT INTO `access_log` VALUES (73369, '66.48.15671361593356687', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15279514680&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:35:59', 203, 0, '', '2019-08-30 11:36:00');
INSERT INTO `access_log` VALUES (73370, '66.54.15671361614226719', 216, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:01', 7, 0, '', '2019-08-30 11:36:01');
INSERT INTO `access_log` VALUES (73371, '64.82.15671361665449695', 216, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:07', 11, 0, '', '2019-08-30 11:36:07');
INSERT INTO `access_log` VALUES (73372, '64.78.15671361905249705', 216, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:31', 12, 0, '', '2019-08-30 11:36:31');
INSERT INTO `access_log` VALUES (73373, '64.76.15671361915999689', 216, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:32', 5, 0, '', '2019-08-30 11:36:32');
INSERT INTO `access_log` VALUES (73374, 'N/A', 216, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:32', 9, 0, '', '2019-08-30 11:36:32');
INSERT INTO `access_log` VALUES (73375, '64.85.15671361925539701', 216, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:33', 6, 0, '', '2019-08-30 11:36:33');
INSERT INTO `access_log` VALUES (73376, '64.81.15671361926739687', 216, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:33', 5, 0, '', '2019-08-30 11:36:33');
INSERT INTO `access_log` VALUES (73377, '64.79.15671361940999685', 216, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:34', 5, 0, '', '2019-08-30 11:36:34');
INSERT INTO `access_log` VALUES (73378, 'N/A', 216, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:34', 9, 0, '', '2019-08-30 11:36:34');
INSERT INTO `access_log` VALUES (73379, '64.82.15671361968399697', 216, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:37', 6, 0, '', '2019-08-30 11:36:37');
INSERT INTO `access_log` VALUES (73380, '64.84.15671361974449679', 216, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:37', 6, 0, '', '2019-08-30 11:36:37');
INSERT INTO `access_log` VALUES (73381, '64.78.15671361999779707', 216, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:40', 7, 0, '', '2019-08-30 11:36:40');
INSERT INTO `access_log` VALUES (73382, 'N/A', 216, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:40', 10, 0, '', '2019-08-30 11:36:40');
INSERT INTO `access_log` VALUES (73383, '64.77.15671362020989663', 216, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:42', 6, 0, '', '2019-08-30 11:36:42');
INSERT INTO `access_log` VALUES (73384, '64.76.15671362021909691', 216, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:42', 6, 0, '', '2019-08-30 11:36:42');
INSERT INTO `access_log` VALUES (73385, '64.85.15671362034299703', 216, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:36:43', 4, 0, '', '2019-08-30 11:36:43');
INSERT INTO `access_log` VALUES (73386, '64.83.15671362386679681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.130.10.147', '2019-08-30 11:37:19', 2, 0, '', '2019-08-30 11:37:19');
INSERT INTO `access_log` VALUES (73387, '64.82.15671362389469699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.130.10.147', '2019-08-30 11:37:19', 2, 0, '', '2019-08-30 11:37:19');
INSERT INTO `access_log` VALUES (73388, '64.78.15671362467669709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:37:27', 2, 0, '', '2019-08-30 11:37:27');
INSERT INTO `access_log` VALUES (73389, '64.77.15671362468649665', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:37:27', 2, 0, '', '2019-08-30 11:37:27');
INSERT INTO `access_log` VALUES (73390, '66.48.15671362579256689', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15279514680', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:37:38', 67, 0, '', '2019-08-30 11:37:38');
INSERT INTO `access_log` VALUES (73391, '66.50.15671362661976709', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15279514680&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:37:46', 193, 0, '', '2019-08-30 11:37:46');
INSERT INTO `access_log` VALUES (73392, '66.57.15671364310556701', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15279514680', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:40:31', 209, 0, '', '2019-08-30 11:40:31');
INSERT INTO `access_log` VALUES (73393, '66.50.15671364420056713', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15279514680&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '61.130.10.147', '2019-08-30 11:40:42', 257, 0, '', '2019-08-30 11:40:42');
INSERT INTO `access_log` VALUES (73394, '59.74.15671400172569335', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:40:17', 10, 0, '', '2019-08-30 12:40:17');
INSERT INTO `access_log` VALUES (73395, '59.73.15671400172569325', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:40:17', 17, 2001001000, '服务端发生异常', '2019-08-30 12:40:17');
INSERT INTO `access_log` VALUES (73396, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:40:23', 7, 0, '', '2019-08-30 12:40:23');
INSERT INTO `access_log` VALUES (73397, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:40:23', 20, 0, '', '2019-08-30 12:40:23');
INSERT INTO `access_log` VALUES (73398, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:40:23', 4, 0, '', '2019-08-30 12:40:23');
INSERT INTO `access_log` VALUES (73399, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:40:23', 17, 0, '', '2019-08-30 12:40:23');
INSERT INTO `access_log` VALUES (73400, '59.78.15671400249579337', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:40:25', 4, 0, '', '2019-08-30 12:40:25');
INSERT INTO `access_log` VALUES (73401, '59.72.15671400250089323', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:40:25', 97, 2001001000, '服务端发生异常', '2019-08-30 12:40:25');
INSERT INTO `access_log` VALUES (73402, '64.85.15671400290459755', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:40:29', 4, 0, '', '2019-08-30 12:40:29');
INSERT INTO `access_log` VALUES (73403, '64.81.15671400291799741', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:40:29', 1, 0, '', '2019-08-30 12:40:29');
INSERT INTO `access_log` VALUES (73404, '64.83.15671400402329733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:40:40', 2, 0, '', '2019-08-30 12:40:40');
INSERT INTO `access_log` VALUES (73405, '64.82.15671400403829751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:40:40', 1, 0, '', '2019-08-30 12:40:40');
INSERT INTO `access_log` VALUES (73406, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=wenhua\'&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:40:47', 6, 0, '', '2019-08-30 12:40:47');
INSERT INTO `access_log` VALUES (73407, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=wenhua\'', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:40:47', 5, 0, '', '2019-08-30 12:40:47');
INSERT INTO `access_log` VALUES (73408, '65.50.15671400666772753', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:41:07', 0, 1002001015, '账号未登陆', '2019-08-30 12:41:07');
INSERT INTO `access_log` VALUES (73409, '65.3607.15671400666804551', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:41:07', 1, 1002001015, '账号未登陆', '2019-08-30 12:41:07');
INSERT INTO `access_log` VALUES (73410, '65.49.15671400666802777', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:41:07', 1, 1002001015, '账号未登陆', '2019-08-30 12:41:07');
INSERT INTO `access_log` VALUES (73411, '65.54.15671400734002647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:41:13', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 12:41:13');
INSERT INTO `access_log` VALUES (73412, '65.52.15671400839642813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:41:24', 59, 0, '', '2019-08-30 12:41:24');
INSERT INTO `access_log` VALUES (73413, '65.46.15671400844252781', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:41:24', 10, 0, '', '2019-08-30 12:41:24');
INSERT INTO `access_log` VALUES (73414, '65.45.15671400844302789', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:41:24', 9, 2001001000, '服务端发生异常', '2019-08-30 12:41:24');
INSERT INTO `access_log` VALUES (73415, '65.53.15671400844372699', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '114.249.114.43', '2019-08-30 12:41:24', 201, 0, '', '2019-08-30 12:41:25');
INSERT INTO `access_log` VALUES (73416, '59.75.15671415269199351', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.207.214.253', '2019-08-30 13:05:27', 3, 0, '', '2019-08-30 13:05:27');
INSERT INTO `access_log` VALUES (73417, '59.77.15671415269199333', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.207.214.253', '2019-08-30 13:05:27', 17, 2001001000, '服务端发生异常', '2019-08-30 13:05:27');
INSERT INTO `access_log` VALUES (73418, '65.52.15671415373702833', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.207.214.253', '2019-08-30 13:05:37', 1, 1002001015, '账号未登陆', '2019-08-30 13:05:37');
INSERT INTO `access_log` VALUES (73419, '65.46.15671415373702801', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.207.214.253', '2019-08-30 13:05:37', 0, 1002001015, '账号未登陆', '2019-08-30 13:05:37');
INSERT INTO `access_log` VALUES (73420, '65.45.15671415373712809', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.207.214.253', '2019-08-30 13:05:37', 0, 1002001015, '账号未登陆', '2019-08-30 13:05:37');
INSERT INTO `access_log` VALUES (73421, '65.50.15671415389702775', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.207.214.253', '2019-08-30 13:05:39', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 13:05:39');
INSERT INTO `access_log` VALUES (73422, '65.3607.15671415516224573', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.207.214.253', '2019-08-30 13:05:52', 78, 0, '', '2019-08-30 13:05:52');
INSERT INTO `access_log` VALUES (73423, '65.54.15671415520622669', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.207.214.253', '2019-08-30 13:05:52', 10, 0, '', '2019-08-30 13:05:52');
INSERT INTO `access_log` VALUES (73424, '65.49.15671415520602799', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.207.214.253', '2019-08-30 13:05:52', 11, 0, '', '2019-08-30 13:05:52');
INSERT INTO `access_log` VALUES (73425, '65.51.15671415520612831', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.207.214.253', '2019-08-30 13:05:52', 11, 2001001000, '服务端发生异常', '2019-08-30 13:05:52');
INSERT INTO `access_log` VALUES (73426, '65.46.15671415656622803', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.207.214.253', '2019-08-30 13:06:06', 9, 0, '', '2019-08-30 13:06:06');
INSERT INTO `access_log` VALUES (73427, '65.52.15671415656632835', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.207.214.253', '2019-08-30 13:06:06', 10, 2001001000, '服务端发生异常', '2019-08-30 13:06:06');
INSERT INTO `access_log` VALUES (73428, '65.45.15671415656662811', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.207.214.253', '2019-08-30 13:06:06', 8, 0, '', '2019-08-30 13:06:06');
INSERT INTO `access_log` VALUES (73429, '59.75.15671418075739355', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '117.132.191.39', '2019-08-30 13:10:08', 3, 0, '', '2019-08-30 13:10:08');
INSERT INTO `access_log` VALUES (73430, '59.76.15671418079339339', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '117.132.192.57', '2019-08-30 13:10:08', 16, 2001001000, '服务端发生异常', '2019-08-30 13:10:08');
INSERT INTO `access_log` VALUES (73431, '59.71.15671425779169357', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.41.193.198', '2019-08-30 13:22:58', 3, 0, '', '2019-08-30 13:22:58');
INSERT INTO `access_log` VALUES (73432, '59.74.15671425779179371', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.41.193.198', '2019-08-30 13:22:58', 12, 2001001000, '服务端发生异常', '2019-08-30 13:22:58');
INSERT INTO `access_log` VALUES (73433, '64.84.15671425870649767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.41.193.198', '2019-08-30 13:23:07', 11, 0, '', '2019-08-30 13:23:07');
INSERT INTO `access_log` VALUES (73434, '64.78.15671425872189795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.41.193.198', '2019-08-30 13:23:07', 3, 0, '', '2019-08-30 13:23:07');
INSERT INTO `access_log` VALUES (73435, '64.77.15671425891609751', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.41.193.198', '2019-08-30 13:23:09', 2, 0, '', '2019-08-30 13:23:09');
INSERT INTO `access_log` VALUES (73436, '64.76.15671425898399779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.41.193.198', '2019-08-30 13:23:10', 1, 0, '', '2019-08-30 13:23:10');
INSERT INTO `access_log` VALUES (73437, '64.80.15671425910009773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '222.41.193.198', '2019-08-30 13:23:11', 2, 0, '', '2019-08-30 13:23:11');
INSERT INTO `access_log` VALUES (73438, '65.45.15671439150732843', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.81 Safari/537.36', '59.63.224.117', '2019-08-30 13:45:15', 1, 1002001015, '账号未登陆', '2019-08-30 13:45:15');
INSERT INTO `access_log` VALUES (73439, '65.46.15671439150732835', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.81 Safari/537.36', '59.63.224.117', '2019-08-30 13:45:15', 1, 1002001015, '账号未登陆', '2019-08-30 13:45:15');
INSERT INTO `access_log` VALUES (73440, '65.52.15671439150822867', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.81 Safari/537.36', '59.63.224.117', '2019-08-30 13:45:15', 0, 1002001015, '账号未登陆', '2019-08-30 13:45:15');
INSERT INTO `access_log` VALUES (73441, '65.52.15671446554942877', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.173.212.73', '2019-08-30 13:57:35', 1, 1002001015, '账号未登陆', '2019-08-30 13:57:35');
INSERT INTO `access_log` VALUES (73442, '65.53.15671446555212763', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.173.212.73', '2019-08-30 13:57:36', 1, 1002001015, '账号未登陆', '2019-08-30 13:57:36');
INSERT INTO `access_log` VALUES (73443, '65.50.15671446555542819', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.173.212.73', '2019-08-30 13:57:36', 0, 1002001015, '账号未登陆', '2019-08-30 13:57:36');
INSERT INTO `access_log` VALUES (73444, '65.51.15671446623412875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.173.212.73', '2019-08-30 13:57:42', 69, 0, '', '2019-08-30 13:57:42');
INSERT INTO `access_log` VALUES (73445, '65.49.15671446628732843', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.173.212.73', '2019-08-30 13:57:43', 9, 0, '', '2019-08-30 13:57:43');
INSERT INTO `access_log` VALUES (73446, '65.54.15671446628732713', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.173.212.73', '2019-08-30 13:57:43', 11, 2001001000, '服务端发生异常', '2019-08-30 13:57:43');
INSERT INTO `access_log` VALUES (73447, '65.47.15671446628762765', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.173.212.73', '2019-08-30 13:57:43', 9, 0, '', '2019-08-30 13:57:43');
INSERT INTO `access_log` VALUES (73448, '59.78.15671470868039433', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.30.220.42', '2019-08-30 14:38:07', 11, 0, '', '2019-08-30 14:38:07');
INSERT INTO `access_log` VALUES (73449, '59.79.15671470868029423', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '116.30.220.42', '2019-08-30 14:38:07', 31, 2001001000, '服务端发生异常', '2019-08-30 14:38:07');
INSERT INTO `access_log` VALUES (73450, '59.75.15671474097309431', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '113.105.13.131', '2019-08-30 14:43:30', 21, 2001001000, '服务端发生异常', '2019-08-30 14:43:30');
INSERT INTO `access_log` VALUES (73451, '59.77.15671474097299413', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '113.105.13.131', '2019-08-30 14:43:30', 249, 0, '', '2019-08-30 14:43:30');
INSERT INTO `access_log` VALUES (73452, '59.80.15671474253879397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.207.141', '2019-08-30 14:43:45', 2, 0, '', '2019-08-30 14:43:45');
INSERT INTO `access_log` VALUES (73453, '64.79.15671474258969839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '113.105.13.131', '2019-08-30 14:43:46', 111, 0, '', '2019-08-30 14:43:46');
INSERT INTO `access_log` VALUES (73454, '64.83.15671474261549833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '113.105.13.131', '2019-08-30 14:43:46', 4, 0, '', '2019-08-30 14:43:46');
INSERT INTO `access_log` VALUES (73455, '59.74.15671474292349437', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.91.60.110', '2019-08-30 14:43:49', 22, 2001001000, '服务端发生异常', '2019-08-30 14:43:49');
INSERT INTO `access_log` VALUES (73456, '59.71.15671489125969443', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:08:33', 3, 0, '', '2019-08-30 15:08:33');
INSERT INTO `access_log` VALUES (73457, '59.74.15671489125969457', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:08:33', 16, 2001001000, '服务端发生异常', '2019-08-30 15:08:33');
INSERT INTO `access_log` VALUES (73458, '64.82.15671489195609871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:08:40', 3, 0, '', '2019-08-30 15:08:40');
INSERT INTO `access_log` VALUES (73459, '64.84.15671489196759853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:08:40', 2, 0, '', '2019-08-30 15:08:40');
INSERT INTO `access_log` VALUES (73460, '66.51.15671489369956893', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13567871123', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:08:57', 182, 0, '', '2019-08-30 15:08:57');
INSERT INTO `access_log` VALUES (73461, '66.53.15671489407796863', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13567871123&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:09:01', 146, 0, '', '2019-08-30 15:09:01');
INSERT INTO `access_log` VALUES (73462, '64.80.15671489474209859', 217, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:09:07', 6, 0, '', '2019-08-30 15:09:07');
INSERT INTO `access_log` VALUES (73463, '64.81.15671489475829863', 217, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:09:08', 5, 0, '', '2019-08-30 15:09:08');
INSERT INTO `access_log` VALUES (73464, '59.76.15671489491039437', 217, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:09:09', 8, 0, '', '2019-08-30 15:09:09');
INSERT INTO `access_log` VALUES (73465, '59.77.15671489491039435', 217, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:09:09', 24, 2001001000, '服务端发生异常', '2019-08-30 15:09:09');
INSERT INTO `access_log` VALUES (73466, '66.50.15671489510736881', 217, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:09:11', 6, 0, '', '2019-08-30 15:09:11');
INSERT INTO `access_log` VALUES (73467, '66.54.15671489586236893', 217, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:09:19', 6, 0, '', '2019-08-30 15:09:19');
INSERT INTO `access_log` VALUES (73468, '59.74.15671489602549459', 217, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:09:20', 11, 0, '', '2019-08-30 15:09:20');
INSERT INTO `access_log` VALUES (73469, '59.78.15671489612499461', 217, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:09:21', 8, 0, '', '2019-08-30 15:09:21');
INSERT INTO `access_log` VALUES (73470, '59.72.15671489618299447', 217, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:09:22', 8, 0, '', '2019-08-30 15:09:22');
INSERT INTO `access_log` VALUES (73471, '66.49.15671489672476881', 217, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:09:27', 7, 0, '', '2019-08-30 15:09:27');
INSERT INTO `access_log` VALUES (73472, '59.75.15671489687999455', 217, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:09:29', 6, 0, '', '2019-08-30 15:09:29');
INSERT INTO `access_log` VALUES (73473, '59.76.15671489688019439', 217, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.13.14.210', '2019-08-30 15:09:29', 23, 2001001000, '服务端发生异常', '2019-08-30 15:09:29');
INSERT INTO `access_log` VALUES (73474, '65.54.15671493054162777', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.77.180.14', '2019-08-30 15:15:05', 1, 1002001015, '账号未登陆', '2019-08-30 15:15:05');
INSERT INTO `access_log` VALUES (73475, '65.49.15671493054162907', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.77.180.14', '2019-08-30 15:15:05', 1, 1002001015, '账号未登陆', '2019-08-30 15:15:05');
INSERT INTO `access_log` VALUES (73476, '65.46.15671493054282909', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.77.180.14', '2019-08-30 15:15:05', 0, 1002001015, '账号未登陆', '2019-08-30 15:15:05');
INSERT INTO `access_log` VALUES (73477, '65.45.15671493073972915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.77.180.14', '2019-08-30 15:15:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 15:15:07');
INSERT INTO `access_log` VALUES (73478, '65.50.15671493246972885', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.77.180.14', '2019-08-30 15:15:25', 88, 0, '', '2019-08-30 15:15:25');
INSERT INTO `access_log` VALUES (73479, '65.51.15671493249722941', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.77.180.14', '2019-08-30 15:15:25', 18, 0, '', '2019-08-30 15:15:25');
INSERT INTO `access_log` VALUES (73480, '65.47.15671493249742831', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.77.180.14', '2019-08-30 15:15:25', 18, 0, '', '2019-08-30 15:15:25');
INSERT INTO `access_log` VALUES (73481, '65.53.15671493249732827', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '49.77.180.14', '2019-08-30 15:15:25', 20, 2001001000, '服务端发生异常', '2019-08-30 15:15:25');
INSERT INTO `access_log` VALUES (73482, '65.46.15671494781092913', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:17:58', 1, 1002001015, '账号未登陆', '2019-08-30 15:17:58');
INSERT INTO `access_log` VALUES (73483, '65.49.15671494781102911', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:17:58', 0, 1002001015, '账号未登陆', '2019-08-30 15:17:58');
INSERT INTO `access_log` VALUES (73484, '65.54.15671494781162781', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:17:58', 0, 1002001015, '账号未登陆', '2019-08-30 15:17:58');
INSERT INTO `access_log` VALUES (73485, '65.45.15671494800982919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:18:00', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 15:18:00');
INSERT INTO `access_log` VALUES (73486, '65.52.15671494836502943', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:18:04', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 15:18:04');
INSERT INTO `access_log` VALUES (73487, '65.53.15671495129712831', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:18:33', 85, 0, '', '2019-08-30 15:18:33');
INSERT INTO `access_log` VALUES (73488, '65.51.15671495138852945', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:18:34', 10, 0, '', '2019-08-30 15:18:34');
INSERT INTO `access_log` VALUES (73489, '65.47.15671495138922835', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:18:34', 10, 2001001000, '服务端发生异常', '2019-08-30 15:18:34');
INSERT INTO `access_log` VALUES (73490, '65.49.15671495138962913', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:18:34', 9, 0, '', '2019-08-30 15:18:34');
INSERT INTO `access_log` VALUES (73491, '65.54.15671495322822783', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:18:52', 16, 0, '', '2019-08-30 15:18:52');
INSERT INTO `access_log` VALUES (73492, '65.52.15671495322912945', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:18:52', 32, 0, '', '2019-08-30 15:18:52');
INSERT INTO `access_log` VALUES (73493, '65.45.15671495322912921', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:18:52', 36, 2001001000, '服务端发生异常', '2019-08-30 15:18:52');
INSERT INTO `access_log` VALUES (73494, '65.51.15671495924032947', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:19:52', 9, 0, '', '2019-08-30 15:19:52');
INSERT INTO `access_log` VALUES (73495, '65.49.15671495924052915', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:19:52', 9, 2001001000, '服务端发生异常', '2019-08-30 15:19:52');
INSERT INTO `access_log` VALUES (73496, '65.46.15671495924112917', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:19:52', 9, 0, '', '2019-08-30 15:19:52');
INSERT INTO `access_log` VALUES (73497, '59.78.15671499379509475', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:25:38', 4, 0, '', '2019-08-30 15:25:38');
INSERT INTO `access_log` VALUES (73498, '59.79.15671499379539465', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:25:38', 22, 2001001000, '服务端发生异常', '2019-08-30 15:25:38');
INSERT INTO `access_log` VALUES (73499, '64.76.15671499418719879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:25:42', 2, 0, '', '2019-08-30 15:25:42');
INSERT INTO `access_log` VALUES (73500, '64.80.15671499419629873', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:25:42', 1, 0, '', '2019-08-30 15:25:42');
INSERT INTO `access_log` VALUES (73501, '64.85.15671499432459891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:25:43', 2, 0, '', '2019-08-30 15:25:43');
INSERT INTO `access_log` VALUES (73502, '64.81.15671499440349877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:25:44', 2, 0, '', '2019-08-30 15:25:44');
INSERT INTO `access_log` VALUES (73503, '59.72.15671499456599461', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:25:46', 1, 0, '', '2019-08-30 15:25:46');
INSERT INTO `access_log` VALUES (73504, '59.75.15671499456599469', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.213.193', '2019-08-30 15:25:46', 28, 2001001000, '服务端发生异常', '2019-08-30 15:25:46');
INSERT INTO `access_log` VALUES (73505, '65.49.15671507735972931', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:39:34', 1, 1002001015, '账号未登陆', '2019-08-30 15:39:34');
INSERT INTO `access_log` VALUES (73506, '65.53.15671507735962849', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:39:34', 1, 1002001015, '账号未登陆', '2019-08-30 15:39:34');
INSERT INTO `access_log` VALUES (73507, '65.47.15671507736182855', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:39:34', 1, 1002001015, '账号未登陆', '2019-08-30 15:39:34');
INSERT INTO `access_log` VALUES (73508, '65.46.15671507817612933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:39:42', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 15:39:42');
INSERT INTO `access_log` VALUES (73509, '65.54.15671507848702801', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:39:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 15:39:45');
INSERT INTO `access_log` VALUES (73510, '65.52.15671507966322965', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:39:57', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 15:39:57');
INSERT INTO `access_log` VALUES (73511, '65.3607.15671508018844709', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:40:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 15:40:02');
INSERT INTO `access_log` VALUES (73512, '65.47.15671508152122857', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:40:15', 97, 0, '', '2019-08-30 15:40:15');
INSERT INTO `access_log` VALUES (73513, '65.49.15671508160202933', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:40:16', 11, 2001001000, '服务端发生异常', '2019-08-30 15:40:16');
INSERT INTO `access_log` VALUES (73514, '65.53.15671508160252851', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:40:16', 10, 0, '', '2019-08-30 15:40:16');
INSERT INTO `access_log` VALUES (73515, '65.51.15671508160402967', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:40:16', 8, 0, '', '2019-08-30 15:40:16');
INSERT INTO `access_log` VALUES (73516, '65.45.15671508430352943', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:40:43', 8, 0, '', '2019-08-30 15:40:43');
INSERT INTO `access_log` VALUES (73517, '65.52.15671508430352967', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:40:43', 10, 0, '', '2019-08-30 15:40:43');
INSERT INTO `access_log` VALUES (73518, '65.3607.15671508430364711', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:40:43', 10, 2001001000, '服务端发生异常', '2019-08-30 15:40:43');
INSERT INTO `access_log` VALUES (73519, '65.53.15671508677532853', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:41:08', 9, 0, '', '2019-08-30 15:41:08');
INSERT INTO `access_log` VALUES (73520, '65.47.15671508677512859', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:41:08', 10, 2001001000, '服务端发生异常', '2019-08-30 15:41:08');
INSERT INTO `access_log` VALUES (73521, '65.49.15671508686502935', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:41:09', 9, 0, '', '2019-08-30 15:41:09');
INSERT INTO `access_log` VALUES (73522, '65.46.15671508732822937', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:41:13', 8, 0, '', '2019-08-30 15:41:13');
INSERT INTO `access_log` VALUES (73523, '65.54.15671508732822805', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:41:13', 10, 2001001000, '服务端发生异常', '2019-08-30 15:41:13');
INSERT INTO `access_log` VALUES (73524, '65.45.15671508732862945', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '67.230.185.83', '2019-08-30 15:41:13', 9, 0, '', '2019-08-30 15:41:13');
INSERT INTO `access_log` VALUES (73525, '65.50.15671510491912919', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.240.18', '2019-08-30 15:44:09', 0, 1002001015, '账号未登陆', '2019-08-30 15:44:09');
INSERT INTO `access_log` VALUES (73526, '65.47.15671510491942863', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.240.18', '2019-08-30 15:44:09', 1, 1002001015, '账号未登陆', '2019-08-30 15:44:09');
INSERT INTO `access_log` VALUES (73527, '65.53.15671510491952857', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.240.18', '2019-08-30 15:44:09', 0, 1002001015, '账号未登陆', '2019-08-30 15:44:09');
INSERT INTO `access_log` VALUES (73528, '65.49.15671510533012939', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.240.18', '2019-08-30 15:44:13', 103, 0, '', '2019-08-30 15:44:13');
INSERT INTO `access_log` VALUES (73529, '65.51.15671510536312973', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.240.18', '2019-08-30 15:44:14', 17, 0, '', '2019-08-30 15:44:14');
INSERT INTO `access_log` VALUES (73530, '65.46.15671510536332941', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.240.18', '2019-08-30 15:44:14', 19, 2001001000, '服务端发生异常', '2019-08-30 15:44:14');
INSERT INTO `access_log` VALUES (73531, '65.45.15671510536332949', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.240.18', '2019-08-30 15:44:14', 18, 0, '', '2019-08-30 15:44:14');
INSERT INTO `access_log` VALUES (73532, '65.54.15671510595022809', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.240.18', '2019-08-30 15:44:20', 8, 0, '', '2019-08-30 15:44:20');
INSERT INTO `access_log` VALUES (73533, '65.3607.15671510595064717', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.240.18', '2019-08-30 15:44:20', 9, 2001001000, '服务端发生异常', '2019-08-30 15:44:20');
INSERT INTO `access_log` VALUES (73534, '65.52.15671510595102973', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.240.18', '2019-08-30 15:44:20', 8, 0, '', '2019-08-30 15:44:20');
INSERT INTO `access_log` VALUES (73535, '65.47.15671510726732865', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.240.18', '2019-08-30 15:44:33', 9, 0, '', '2019-08-30 15:44:33');
INSERT INTO `access_log` VALUES (73536, '65.50.15671510726762921', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.240.18', '2019-08-30 15:44:33', 10, 2001001000, '服务端发生异常', '2019-08-30 15:44:33');
INSERT INTO `access_log` VALUES (73537, '65.49.15671510726772941', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.240.18', '2019-08-30 15:44:33', 9, 0, '', '2019-08-30 15:44:33');
INSERT INTO `access_log` VALUES (73538, '59.78.15671516427829499', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.250.23.120', '2019-08-30 15:54:03', 2, 0, '', '2019-08-30 15:54:03');
INSERT INTO `access_log` VALUES (73539, '59.72.15671516427829485', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.250.23.120', '2019-08-30 15:54:03', 16, 2001001000, '服务端发生异常', '2019-08-30 15:54:03');
INSERT INTO `access_log` VALUES (73540, '64.84.15671516451349891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.250.23.120', '2019-08-30 15:54:05', 3, 0, '', '2019-08-30 15:54:05');
INSERT INTO `access_log` VALUES (73541, '64.78.15671516452539919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.250.23.120', '2019-08-30 15:54:05', 1, 0, '', '2019-08-30 15:54:05');
INSERT INTO `access_log` VALUES (73542, '59.79.15671516467169489', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.250.23.120', '2019-08-30 15:54:07', 2, 0, '', '2019-08-30 15:54:07');
INSERT INTO `access_log` VALUES (73543, '59.76.15671516467169477', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.250.23.120', '2019-08-30 15:54:07', 12, 2001001000, '服务端发生异常', '2019-08-30 15:54:07');
INSERT INTO `access_log` VALUES (73544, '65.49.15671516539592949', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.250.23.120', '2019-08-30 15:54:14', 0, 1002001015, '账号未登陆', '2019-08-30 15:54:14');
INSERT INTO `access_log` VALUES (73545, '65.45.15671516539602959', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.250.23.120', '2019-08-30 15:54:14', 0, 1002001015, '账号未登陆', '2019-08-30 15:54:14');
INSERT INTO `access_log` VALUES (73546, '65.46.15671516539602951', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.250.23.120', '2019-08-30 15:54:14', 1, 1002001015, '账号未登陆', '2019-08-30 15:54:14');
INSERT INTO `access_log` VALUES (73547, '65.51.15671516553812983', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.250.23.120', '2019-08-30 15:54:15', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 15:54:15');
INSERT INTO `access_log` VALUES (73548, '65.52.15671516594222983', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.250.23.120', '2019-08-30 15:54:19', 63, 0, '', '2019-08-30 15:54:19');
INSERT INTO `access_log` VALUES (73549, '65.3607.15671516597044727', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.250.23.120', '2019-08-30 15:54:20', 10, 0, '', '2019-08-30 15:54:20');
INSERT INTO `access_log` VALUES (73550, '65.53.15671516597062869', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.250.23.120', '2019-08-30 15:54:20', 9, 0, '', '2019-08-30 15:54:20');
INSERT INTO `access_log` VALUES (73551, '65.54.15671516597062819', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '114.250.23.120', '2019-08-30 15:54:20', 10, 2001001000, '服务端发生异常', '2019-08-30 15:54:20');
INSERT INTO `access_log` VALUES (73552, '65.54.15671520816772825', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-08-30 16:01:22', 0, 1002001015, '账号未登陆', '2019-08-30 16:01:22');
INSERT INTO `access_log` VALUES (73553, '65.3607.15671520816774733', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-08-30 16:01:22', 0, 1002001015, '账号未登陆', '2019-08-30 16:01:22');
INSERT INTO `access_log` VALUES (73554, '65.47.15671520816792881', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-08-30 16:01:22', 0, 1002001015, '账号未登陆', '2019-08-30 16:01:22');
INSERT INTO `access_log` VALUES (73555, '65.45.15671520893092967', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-08-30 16:01:29', 96, 0, '', '2019-08-30 16:01:29');
INSERT INTO `access_log` VALUES (73556, '65.49.15671520896352957', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-08-30 16:01:30', 16, 0, '', '2019-08-30 16:01:30');
INSERT INTO `access_log` VALUES (73557, '65.46.15671520896362959', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-08-30 16:01:30', 18, 2001001000, '服务端发生异常', '2019-08-30 16:01:30');
INSERT INTO `access_log` VALUES (73558, '65.51.15671520896382991', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-08-30 16:01:30', 16, 0, '', '2019-08-30 16:01:30');
INSERT INTO `access_log` VALUES (73559, '65.52.15671520961712991', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-08-30 16:01:36', 9, 0, '', '2019-08-30 16:01:36');
INSERT INTO `access_log` VALUES (73560, '65.53.15671520961722877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-08-30 16:01:36', 9, 2001001000, '服务端发生异常', '2019-08-30 16:01:36');
INSERT INTO `access_log` VALUES (73561, '65.54.15671520961732827', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-08-30 16:01:36', 9, 0, '', '2019-08-30 16:01:36');
INSERT INTO `access_log` VALUES (73562, '65.50.15671521028262939', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-08-30 16:01:43', 18, 2001001000, '服务端发生异常', '2019-08-30 16:01:43');
INSERT INTO `access_log` VALUES (73563, '65.45.15671521028282969', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-08-30 16:01:43', 20, 0, '', '2019-08-30 16:01:43');
INSERT INTO `access_log` VALUES (73564, '65.3607.15671521028264735', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '222.173.11.26', '2019-08-30 16:01:43', 249, 0, '', '2019-08-30 16:01:43');
INSERT INTO `access_log` VALUES (73565, '65.51.15671533258543009', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.88.31.206', '2019-08-30 16:22:06', 5, 1002001012, '访问令牌已过期', '2019-08-30 16:22:06');
INSERT INTO `access_log` VALUES (73566, '65.53.15671533258542895', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.88.31.206', '2019-08-30 16:22:06', 5, 1002001012, '访问令牌已过期', '2019-08-30 16:22:06');
INSERT INTO `access_log` VALUES (73567, '65.46.15671533258542977', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.88.31.206', '2019-08-30 16:22:06', 5, 1002001012, '访问令牌已过期', '2019-08-30 16:22:06');
INSERT INTO `access_log` VALUES (73568, '65.52.15671533291513009', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.88.31.206', '2019-08-30 16:22:09', 85, 0, '', '2019-08-30 16:22:09');
INSERT INTO `access_log` VALUES (73569, '65.47.15671533294712901', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.88.31.206', '2019-08-30 16:22:09', 10, 0, '', '2019-08-30 16:22:09');
INSERT INTO `access_log` VALUES (73570, '65.50.15671533294722957', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.88.31.206', '2019-08-30 16:22:09', 10, 2001001000, '服务端发生异常', '2019-08-30 16:22:09');
INSERT INTO `access_log` VALUES (73571, '65.45.15671533294772987', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.88.31.206', '2019-08-30 16:22:09', 9, 0, '', '2019-08-30 16:22:09');
INSERT INTO `access_log` VALUES (73572, '65.51.15671554678603039', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:57:48', 0, 1002001015, '账号未登陆', '2019-08-30 16:57:48');
INSERT INTO `access_log` VALUES (73573, '65.46.15671554678603007', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:57:48', 0, 1002001015, '账号未登陆', '2019-08-30 16:57:48');
INSERT INTO `access_log` VALUES (73574, '65.53.15671554678612925', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:57:48', 0, 1002001015, '账号未登陆', '2019-08-30 16:57:48');
INSERT INTO `access_log` VALUES (73575, '65.54.15671554704552875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:57:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 16:57:50');
INSERT INTO `access_log` VALUES (73576, '65.50.15671554818062987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:58:02', 80, 0, '', '2019-08-30 16:58:02');
INSERT INTO `access_log` VALUES (73577, '65.47.15671554821352931', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:58:02', 13, 0, '', '2019-08-30 16:58:02');
INSERT INTO `access_log` VALUES (73578, '65.45.15671554821373017', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:58:02', 11, 2001001000, '服务端发生异常', '2019-08-30 16:58:02');
INSERT INTO `access_log` VALUES (73579, '65.3607.15671554821424783', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:58:02', 11, 0, '', '2019-08-30 16:58:02');
INSERT INTO `access_log` VALUES (73580, '65.54.15671555428972877', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:59:03', 71, 0, '', '2019-08-30 16:59:03');
INSERT INTO `access_log` VALUES (73581, '65.52.15671555431133041', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:59:03', 9, 0, '', '2019-08-30 16:59:03');
INSERT INTO `access_log` VALUES (73582, '65.50.15671555431162989', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:59:03', 10, 2001001000, '服务端发生异常', '2019-08-30 16:59:03');
INSERT INTO `access_log` VALUES (73583, '65.45.15671555431193019', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:59:03', 9, 0, '', '2019-08-30 16:59:03');
INSERT INTO `access_log` VALUES (73584, '65.49.15671555672613009', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:59:27', 8, 0, '', '2019-08-30 16:59:27');
INSERT INTO `access_log` VALUES (73585, '65.46.15671555672663011', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:59:27', 9, 2001001000, '服务端发生异常', '2019-08-30 16:59:27');
INSERT INTO `access_log` VALUES (73586, '65.51.15671555672713043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:59:27', 7, 0, '', '2019-08-30 16:59:27');
INSERT INTO `access_log` VALUES (73587, '65.53.15671555775642929', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:59:38', 139, 0, '', '2019-08-30 16:59:38');
INSERT INTO `access_log` VALUES (73588, '65.54.15671555778482879', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:59:38', 9, 0, '', '2019-08-30 16:59:38');
INSERT INTO `access_log` VALUES (73589, '65.52.15671555778563043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:59:38', 8, 0, '', '2019-08-30 16:59:38');
INSERT INTO `access_log` VALUES (73590, '65.45.15671555778563021', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 16:59:38', 9, 2001001000, '服务端发生异常', '2019-08-30 16:59:38');
INSERT INTO `access_log` VALUES (73591, '65.45.15671565439003035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:15:44', 0, 1002001015, '账号未登陆', '2019-08-30 17:15:44');
INSERT INTO `access_log` VALUES (73592, '65.51.15671565439003057', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:15:44', 1, 1002001015, '账号未登陆', '2019-08-30 17:15:44');
INSERT INTO `access_log` VALUES (73593, '65.53.15671565439002943', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:15:44', 1, 1002001015, '账号未登陆', '2019-08-30 17:15:44');
INSERT INTO `access_log` VALUES (73594, '65.54.15671565501692893', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:15:50', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 17:15:50');
INSERT INTO `access_log` VALUES (73595, '65.50.15671565560053005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:15:56', 111, 0, '', '2019-08-30 17:15:56');
INSERT INTO `access_log` VALUES (73596, '65.3607.15671565564484801', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:15:56', 9, 0, '', '2019-08-30 17:15:56');
INSERT INTO `access_log` VALUES (73597, '65.47.15671565564582949', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:15:56', 10, 2001001000, '服务端发生异常', '2019-08-30 17:15:56');
INSERT INTO `access_log` VALUES (73598, '65.49.15671565564633025', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:15:56', 8, 0, '', '2019-08-30 17:15:56');
INSERT INTO `access_log` VALUES (73599, '65.45.15671565702523037', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:16:10', 9, 0, '', '2019-08-30 17:16:10');
INSERT INTO `access_log` VALUES (73600, '65.53.15671565702602945', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:16:10', 9, 2001001000, '服务端发生异常', '2019-08-30 17:16:10');
INSERT INTO `access_log` VALUES (73601, '65.51.15671565702693059', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:16:10', 16, 0, '', '2019-08-30 17:16:10');
INSERT INTO `access_log` VALUES (73602, '65.54.15671565831042895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:16:23', 89, 0, '', '2019-08-30 17:16:23');
INSERT INTO `access_log` VALUES (73603, '65.52.15671565835023059', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:16:24', 9, 0, '', '2019-08-30 17:16:24');
INSERT INTO `access_log` VALUES (73604, '65.50.15671565835113007', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:16:24', 10, 2001001000, '服务端发生异常', '2019-08-30 17:16:24');
INSERT INTO `access_log` VALUES (73605, '65.3607.15671565835204803', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-08-30 17:16:24', 9, 0, '', '2019-08-30 17:16:24');
INSERT INTO `access_log` VALUES (73606, '59.80.15671573455109535', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:29:06', 16, 0, '', '2019-08-30 17:29:06');
INSERT INTO `access_log` VALUES (73607, '59.77.15671573455109551', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:29:06', 17, 2001001000, '服务端发生异常', '2019-08-30 17:29:06');
INSERT INTO `access_log` VALUES (73608, '64.76.15671573543149979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:29:14', 11, 0, '', '2019-08-30 17:29:14');
INSERT INTO `access_log` VALUES (73609, '64.80.15671573544409973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:29:14', 3, 0, '', '2019-08-30 17:29:14');
INSERT INTO `access_log` VALUES (73610, '64.85.15671573560369991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:29:16', 2, 0, '', '2019-08-30 17:29:16');
INSERT INTO `access_log` VALUES (73611, '64.81.15671573568569977', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:29:17', 2, 0, '', '2019-08-30 17:29:17');
INSERT INTO `access_log` VALUES (73612, '64.79.15671573575859975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:29:18', 2, 0, '', '2019-08-30 17:29:18');
INSERT INTO `access_log` VALUES (73613, '64.82.15671573614759987', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:29:21', 2, 0, '', '2019-08-30 17:29:21');
INSERT INTO `access_log` VALUES (73614, '64.84.15671573617259969', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:29:22', 2, 0, '', '2019-08-30 17:29:22');
INSERT INTO `access_log` VALUES (73615, '59.78.15671573966839577', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:29:57', 4, 0, '', '2019-08-30 17:29:57');
INSERT INTO `access_log` VALUES (73616, '59.72.15671573966839563', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:29:57', 18, 2001001000, '服务端发生异常', '2019-08-30 17:29:57');
INSERT INTO `access_log` VALUES (73617, '64.76.15671573994619981', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:29:59', 2, 0, '', '2019-08-30 17:29:59');
INSERT INTO `access_log` VALUES (73618, '64.80.15671573995849975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:30:00', 2, 0, '', '2019-08-30 17:30:00');
INSERT INTO `access_log` VALUES (73619, '59.79.15671574012679567', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:30:01', 2, 0, '', '2019-08-30 17:30:01');
INSERT INTO `access_log` VALUES (73620, '59.75.15671574012679571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:30:01', 10, 2001001000, '服务端发生异常', '2019-08-30 17:30:01');
INSERT INTO `access_log` VALUES (73621, '64.85.15671574038159993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:30:04', 2, 0, '', '2019-08-30 17:30:04');
INSERT INTO `access_log` VALUES (73622, '64.81.15671574039139979', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:30:04', 2, 0, '', '2019-08-30 17:30:04');
INSERT INTO `access_log` VALUES (73623, '59.80.15671574049369537', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:30:05', 2, 0, '', '2019-08-30 17:30:05');
INSERT INTO `access_log` VALUES (73624, '59.77.15671574049379553', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:30:05', 13, 2001001000, '服务端发生异常', '2019-08-30 17:30:05');
INSERT INTO `access_log` VALUES (73625, '64.83.15671574071979971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:30:07', 2, 0, '', '2019-08-30 17:30:07');
INSERT INTO `access_log` VALUES (73626, '64.82.15671574073319989', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:30:07', 2, 0, '', '2019-08-30 17:30:07');
INSERT INTO `access_log` VALUES (73627, '59.74.15671574087689577', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:30:09', 2, 0, '', '2019-08-30 17:30:09');
INSERT INTO `access_log` VALUES (73628, '59.71.15671574087689561', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '115.204.92.171', '2019-08-30 17:30:09', 9, 2001001000, '服务端发生异常', '2019-08-30 17:30:09');
INSERT INTO `access_log` VALUES (73629, 'e6e03259-bf29-42eb-b2ab-54725eaf0c38', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:52:32', 2092, 0, '', '2019-08-30 17:52:35');
INSERT INTO `access_log` VALUES (73630, '0358633e-47b3-4d62-b256-27ead5804ff8', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:52:32', 2706, 2001001000, '服务端发生异常', '2019-08-30 17:52:35');
INSERT INTO `access_log` VALUES (73631, '27c9ec30-b4dd-4adf-82cc-99b378bdb328', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:52:36', 236, 0, '', '2019-08-30 17:52:36');
INSERT INTO `access_log` VALUES (73632, '047acfd6-7b3c-403a-97a0-03e3838018aa', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:52:37', 45, 0, '', '2019-08-30 17:52:37');
INSERT INTO `access_log` VALUES (73633, '43e87c44-c462-4e75-ac7e-21f6866316ee', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:52:43', 44, 0, '', '2019-08-30 17:52:44');
INSERT INTO `access_log` VALUES (73634, '85464bf1-c557-4ed0-b4ec-b7386831faf1', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:52:44', 298, 0, '', '2019-08-30 17:52:44');
INSERT INTO `access_log` VALUES (73635, '685934b4-2160-4f95-b836-424e6b99e7a0', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:52:52', 94, 0, '', '2019-08-30 17:52:52');
INSERT INTO `access_log` VALUES (73636, 'f390417a-7491-4703-8fec-566914792fc3', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:52:52', 224, 2001001000, '服务端发生异常', '2019-08-30 17:52:52');
INSERT INTO `access_log` VALUES (73637, 'bd5e92ed-0e57-47b8-8ab8-a8cc1282c939', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=41', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:52:57', 567, 0, '', '2019-08-30 17:52:57');
INSERT INTO `access_log` VALUES (73638, '5c906d62-d01a-49a0-a4c4-a95de71f24ba', 0, 1, 'order-impl', '/order-api/users/cart/calc_sku_price', 'skuId=50', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:52:58', 776, 0, '', '2019-08-30 17:52:59');
INSERT INTO `access_log` VALUES (73639, '9af25b12-c7dc-41c6-9497-218659b08b23', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:53:04', 133, 0, '', '2019-08-30 17:53:04');
INSERT INTO `access_log` VALUES (73640, '70350157-dfb1-46df-b9c1-19c82b31779b', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:53:04', 255, 2001001000, '服务端发生异常', '2019-08-30 17:53:04');
INSERT INTO `access_log` VALUES (73641, 'f7840f55-4c41-47e0-a75a-fef2714bc7f9', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 18:01:07', 1058, 1002001015, '账号未登陆', '2019-08-30 18:01:09');
INSERT INTO `access_log` VALUES (73642, '777c8aae-d4bf-44c8-8f1c-becf22ef5b2f', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 18:01:07', 1058, 1002001015, '账号未登陆', '2019-08-30 18:01:09');
INSERT INTO `access_log` VALUES (73643, '4a18a9ab-d10e-4a2c-9da7-b57e6e460637', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 18:01:07', 1057, 1002001015, '账号未登陆', '2019-08-30 18:01:09');
INSERT INTO `access_log` VALUES (73644, '2f6aa62c-3196-48e6-9ac8-afd23fbff5a8', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 18:01:13', 469, 1002002001, '密码不正确', '2019-08-30 18:01:13');
INSERT INTO `access_log` VALUES (73645, 'f7dcfc60-5238-45c4-a509-461301abef47', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 18:01:19', 117, 1002002001, '密码不正确', '2019-08-30 18:01:19');
INSERT INTO `access_log` VALUES (73646, '3ed61cfd-90de-4bf9-99ec-914440858774', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 18:01:47', 146, 1002002001, '密码不正确', '2019-08-30 18:01:47');
INSERT INTO `access_log` VALUES (73647, 'ce9e24bd-89bf-4135-8e53-e9db684b4e37', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 18:03:11', 300, 1002002001, '密码不正确', '2019-08-30 18:03:11');
INSERT INTO `access_log` VALUES (73648, '65.3607.15671594115344843', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '119.139.197.112', '2019-08-30 18:03:32', 13, 1002001012, '访问令牌已过期', '2019-08-30 18:03:32');
INSERT INTO `access_log` VALUES (73649, '65.52.15671594116753099', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '119.139.197.112', '2019-08-30 18:03:32', 5, 1002001012, '访问令牌已过期', '2019-08-30 18:03:32');
INSERT INTO `access_log` VALUES (73650, '65.49.15671594116753065', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '119.139.197.112', '2019-08-30 18:03:32', 5, 1002001012, '访问令牌已过期', '2019-08-30 18:03:32');
INSERT INTO `access_log` VALUES (73651, '65.47.15671594142332989', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '119.139.197.112', '2019-08-30 18:03:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 18:03:34');
INSERT INTO `access_log` VALUES (73652, '65.45.15671594191483077', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '119.139.197.112', '2019-08-30 18:03:39', 106, 0, '', '2019-08-30 18:03:39');
INSERT INTO `access_log` VALUES (73653, '65.51.15671594198663097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '119.139.197.112', '2019-08-30 18:03:40', 11, 0, '', '2019-08-30 18:03:40');
INSERT INTO `access_log` VALUES (73654, '65.54.15671594198662937', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '119.139.197.112', '2019-08-30 18:03:40', 11, 2001001000, '服务端发生异常', '2019-08-30 18:03:40');
INSERT INTO `access_log` VALUES (73655, '65.50.15671594199713049', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '119.139.197.112', '2019-08-30 18:03:40', 10, 0, '', '2019-08-30 18:03:40');
INSERT INTO `access_log` VALUES (73656, '2ff19836-21ab-483b-9c6d-ce76a9b71256', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 18:03:56', 181, 1002002001, '密码不正确', '2019-08-30 18:03:57');
INSERT INTO `access_log` VALUES (73657, '65.47.15671594748032991', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:04:35', 0, 1002001015, '账号未登陆', '2019-08-30 18:04:35');
INSERT INTO `access_log` VALUES (73658, '65.49.15671594748023067', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:04:35', 0, 1002001015, '账号未登陆', '2019-08-30 18:04:35');
INSERT INTO `access_log` VALUES (73659, '65.46.15671594748033069', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:04:35', 0, 1002001015, '账号未登陆', '2019-08-30 18:04:35');
INSERT INTO `access_log` VALUES (73660, '59.74.15671594788129605', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:04:39', 12, 0, '', '2019-08-30 18:04:39');
INSERT INTO `access_log` VALUES (73661, '59.71.15671594788129589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:04:39', 46, 2001001000, '服务端发生异常', '2019-08-30 18:04:39');
INSERT INTO `access_log` VALUES (73662, '65.54.15671594824832939', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:04:42', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-30 18:04:42');
INSERT INTO `access_log` VALUES (73663, '65.50.15671594997543051', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:05:00', 84, 0, '', '2019-08-30 18:05:00');
INSERT INTO `access_log` VALUES (73664, '65.53.15671595003162989', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:05:00', 17, 0, '', '2019-08-30 18:05:00');
INSERT INTO `access_log` VALUES (73665, '65.3607.15671595003184847', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:05:00', 18, 0, '', '2019-08-30 18:05:00');
INSERT INTO `access_log` VALUES (73666, '65.52.15671595003183103', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:05:00', 18, 2001001000, '服务端发生异常', '2019-08-30 18:05:00');
INSERT INTO `access_log` VALUES (73667, 'd6457390-2e0b-4bd0-bce4-27704ae17081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 18:05:04', 201, 1002002001, '密码不正确', '2019-08-30 18:05:04');
INSERT INTO `access_log` VALUES (73668, '65.49.15671595069553069', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:05:07', 9, 0, '', '2019-08-30 18:05:07');
INSERT INTO `access_log` VALUES (73669, '65.47.15671595069592993', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:05:07', 9, 2001001000, '服务端发生异常', '2019-08-30 18:05:07');
INSERT INTO `access_log` VALUES (73670, '65.46.15671595069643071', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:05:07', 9, 0, '', '2019-08-30 18:05:07');
INSERT INTO `access_log` VALUES (73671, '59.72.15671595101599593', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:05:10', 3, 0, '', '2019-08-30 18:05:10');
INSERT INTO `access_log` VALUES (73672, '59.79.15671595101869597', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:05:10', 21, 2001001000, '服务端发生异常', '2019-08-30 18:05:10');
INSERT INTO `access_log` VALUES (73673, '65.54.15671595152742941', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:05:15', 8, 0, '', '2019-08-30 18:05:15');
INSERT INTO `access_log` VALUES (73674, '65.50.15671595152813053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:05:15', 8, 0, '', '2019-08-30 18:05:15');
INSERT INTO `access_log` VALUES (73675, '65.51.15671595152813101', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '183.250.69.180', '2019-08-30 18:05:15', 9, 2001001000, '服务端发生异常', '2019-08-30 18:05:15');
INSERT INTO `access_log` VALUES (73676, '874fcf37-ea95-45d3-b1b2-64e5c68270e5', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 18:06:37', 201, 1002002001, '密码不正确', '2019-08-30 18:06:37');
INSERT INTO `access_log` VALUES (73677, '4137e882-ec2c-4466-9c3d-a16c688ebef2', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 18:07:44', 233, 1002002001, '密码不正确', '2019-08-30 18:07:44');
INSERT INTO `access_log` VALUES (73678, '59.72.15671639814829653', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '119.139.199.138', '2019-08-30 19:19:41', 14, 0, '', '2019-08-30 19:19:41');
INSERT INTO `access_log` VALUES (73679, '59.79.15671639814829657', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '119.139.199.138', '2019-08-30 19:19:41', 17, 2001001000, '服务端发生异常', '2019-08-30 19:19:42');
INSERT INTO `access_log` VALUES (73680, '59.80.15672088608050225', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.17.234.240', '2019-08-31 07:47:41', 11, 0, '', '2019-08-31 07:47:41');
INSERT INTO `access_log` VALUES (73681, '59.77.15672088608070241', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.17.234.240', '2019-08-31 07:47:41', 25, 2001001000, '服务端发生异常', '2019-08-31 07:47:41');
INSERT INTO `access_log` VALUES (73682, '64.84.15672088648210657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.17.234.240', '2019-08-31 07:47:45', 11, 0, '', '2019-08-31 07:47:45');
INSERT INTO `access_log` VALUES (73683, '64.78.15672088649500685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.17.234.240', '2019-08-31 07:47:45', 3, 0, '', '2019-08-31 07:47:45');
INSERT INTO `access_log` VALUES (73684, '64.77.15672088669390641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.17.234.240', '2019-08-31 07:47:47', 2, 0, '', '2019-08-31 07:47:47');
INSERT INTO `access_log` VALUES (73685, '64.76.15672088682670669', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.17.234.240', '2019-08-31 07:47:48', 2, 0, '', '2019-08-31 07:47:48');
INSERT INTO `access_log` VALUES (73686, '59.71.15672088710150249', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.17.234.240', '2019-08-31 07:47:51', 3, 0, '', '2019-08-31 07:47:51');
INSERT INTO `access_log` VALUES (73687, '59.73.15672088710160253', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.17.234.240', '2019-08-31 07:47:51', 18, 2001001000, '服务端发生异常', '2019-08-31 07:47:51');
INSERT INTO `access_log` VALUES (73688, '59.72.15672088965540253', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.17.234.240', '2019-08-31 07:48:17', 2, 0, '', '2019-08-31 07:48:17');
INSERT INTO `access_log` VALUES (73689, '59.79.15672088965560257', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.17.234.240', '2019-08-31 07:48:17', 14, 2001001000, '服务端发生异常', '2019-08-31 07:48:17');
INSERT INTO `access_log` VALUES (73690, '64.81.15672088975400667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.17.234.240', '2019-08-31 07:48:18', 1, 0, '', '2019-08-31 07:48:18');
INSERT INTO `access_log` VALUES (73691, '64.79.15672088976690665', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.17.234.240', '2019-08-31 07:48:18', 2, 0, '', '2019-08-31 07:48:18');
INSERT INTO `access_log` VALUES (73692, '59.75.15672088980570261', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.17.234.240', '2019-08-31 07:48:18', 3, 0, '', '2019-08-31 07:48:18');
INSERT INTO `access_log` VALUES (73693, '59.76.15672088980580245', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '27.17.234.240', '2019-08-31 07:48:18', 16, 2001001000, '服务端发生异常', '2019-08-31 07:48:18');
INSERT INTO `access_log` VALUES (73694, '59.73.15672140504310323', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.128.96.184', '2019-08-31 09:14:10', 10, 0, '', '2019-08-31 09:14:10');
INSERT INTO `access_log` VALUES (73695, '59.78.15672140504320337', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.128.96.184', '2019-08-31 09:14:10', 16, 2001001000, '服务端发生异常', '2019-08-31 09:14:10');
INSERT INTO `access_log` VALUES (73696, '65.51.15672156247003849', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 09:40:25', 0, 1002001015, '账号未登陆', '2019-08-31 09:40:25');
INSERT INTO `access_log` VALUES (73697, '65.3607.15672156248875599', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 09:40:25', 0, 1002001015, '账号未登陆', '2019-08-31 09:40:25');
INSERT INTO `access_log` VALUES (73698, '65.54.15672156251793689', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 09:40:25', 0, 1002001015, '账号未登陆', '2019-08-31 09:40:25');
INSERT INTO `access_log` VALUES (73699, '65.50.15672156273403801', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 09:40:27', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-31 09:40:27');
INSERT INTO `access_log` VALUES (73700, '65.49.15672156401503825', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 09:40:40', 74, 0, '', '2019-08-31 09:40:40');
INSERT INTO `access_log` VALUES (73701, '65.47.15672156410433747', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 09:40:41', 20, 2001001000, '服务端发生异常', '2019-08-31 09:40:41');
INSERT INTO `access_log` VALUES (73702, '65.46.15672156410423825', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 09:40:41', 23, 0, '', '2019-08-31 09:40:41');
INSERT INTO `access_log` VALUES (73703, '65.52.15672156410463857', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 09:40:41', 25, 0, '', '2019-08-31 09:40:41');
INSERT INTO `access_log` VALUES (73704, '65.45.15672156491303831', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 09:40:49', 9, 0, '', '2019-08-31 09:40:49');
INSERT INTO `access_log` VALUES (73705, '65.51.15672156493973851', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 09:40:49', 9, 2001001000, '服务端发生异常', '2019-08-31 09:40:49');
INSERT INTO `access_log` VALUES (73706, '65.3607.15672156493975601', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 09:40:49', 72, 0, '', '2019-08-31 09:40:49');
INSERT INTO `access_log` VALUES (73707, '65.46.15672231215083929', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:22', 17, 1002001012, '访问令牌已过期', '2019-08-31 11:45:22');
INSERT INTO `access_log` VALUES (73708, '65.45.15672231215033933', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:22', 17, 1002001012, '访问令牌已过期', '2019-08-31 11:45:22');
INSERT INTO `access_log` VALUES (73709, '59.77.15672231215320433', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:22', 14, 2001001000, '服务端发生异常', '2019-08-31 11:45:22');
INSERT INTO `access_log` VALUES (73710, '59.74.15672231220770457', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:22', 59, 0, '', '2019-08-31 11:45:22');
INSERT INTO `access_log` VALUES (73711, '64.79.15672231242220855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:24', 9, 0, '', '2019-08-31 11:45:24');
INSERT INTO `access_log` VALUES (73712, '64.83.15672231243650849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:24', 3, 0, '', '2019-08-31 11:45:24');
INSERT INTO `access_log` VALUES (73713, '64.82.15672231253230867', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:25', 2, 0, '', '2019-08-31 11:45:25');
INSERT INTO `access_log` VALUES (73714, '64.84.15672231261360849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:26', 2, 0, '', '2019-08-31 11:45:26');
INSERT INTO `access_log` VALUES (73715, '59.71.15672231274290441', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:27', 12, 2001001000, '服务端发生异常', '2019-08-31 11:45:27');
INSERT INTO `access_log` VALUES (73716, '59.73.15672231276750445', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:28', 3, 0, '', '2019-08-31 11:45:28');
INSERT INTO `access_log` VALUES (73717, '64.78.15672231292060877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:29', 2, 0, '', '2019-08-31 11:45:29');
INSERT INTO `access_log` VALUES (73718, '64.77.15672231295730833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:30', 2, 0, '', '2019-08-31 11:45:30');
INSERT INTO `access_log` VALUES (73719, '64.76.15672231302280861', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:30', 2, 0, '', '2019-08-31 11:45:30');
INSERT INTO `access_log` VALUES (73720, '64.80.15672231306430855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:31', 1, 0, '', '2019-08-31 11:45:31');
INSERT INTO `access_log` VALUES (73721, '59.72.15672231323860445', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:32', 3, 0, '', '2019-08-31 11:45:32');
INSERT INTO `access_log` VALUES (73722, '59.78.15672231323860459', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:32', 38, 2001001000, '服务端发生异常', '2019-08-31 11:45:32');
INSERT INTO `access_log` VALUES (73723, '65.49.15672231355163927', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:36', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-31 11:45:36');
INSERT INTO `access_log` VALUES (73724, '65.3607.15672231453915703', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:45', 64, 0, '', '2019-08-31 11:45:45');
INSERT INTO `access_log` VALUES (73725, '65.52.15672231462463959', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:46', 13, 0, '', '2019-08-31 11:45:46');
INSERT INTO `access_log` VALUES (73726, '65.50.15672231462513907', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:46', 13, 2001001000, '服务端发生异常', '2019-08-31 11:45:46');
INSERT INTO `access_log` VALUES (73727, '65.53.15672231462513851', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '119.139.199.109', '2019-08-31 11:45:46', 14, 0, '', '2019-08-31 11:45:46');
INSERT INTO `access_log` VALUES (73728, '65.47.15672337912293993', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.92.226.226', '2019-08-31 14:43:11', 1, 1002001015, '账号未登陆', '2019-08-31 14:43:11');
INSERT INTO `access_log` VALUES (73729, '65.46.15672337912304073', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.92.226.226', '2019-08-31 14:43:11', 0, 1002001015, '账号未登陆', '2019-08-31 14:43:11');
INSERT INTO `access_log` VALUES (73730, '65.45.15672337912314077', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.92.226.226', '2019-08-31 14:43:11', 0, 1002001015, '账号未登陆', '2019-08-31 14:43:11');
INSERT INTO `access_log` VALUES (73731, '65.51.15672338005264093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.92.226.226', '2019-08-31 14:43:21', 71, 0, '', '2019-08-31 14:43:21');
INSERT INTO `access_log` VALUES (73732, '65.49.15672338010944071', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.92.226.226', '2019-08-31 14:43:21', 13, 0, '', '2019-08-31 14:43:21');
INSERT INTO `access_log` VALUES (73733, '65.3607.15672338010955847', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.92.226.226', '2019-08-31 14:43:21', 14, 0, '', '2019-08-31 14:43:21');
INSERT INTO `access_log` VALUES (73734, '65.54.15672338010953935', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.92.226.226', '2019-08-31 14:43:21', 15, 2001001000, '服务端发生异常', '2019-08-31 14:43:21');
INSERT INTO `access_log` VALUES (73735, '65.47.15672338366683995', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.92.226.226', '2019-08-31 14:43:57', 9, 0, '', '2019-08-31 14:43:57');
INSERT INTO `access_log` VALUES (73736, '65.45.15672338366754079', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.92.226.226', '2019-08-31 14:43:57', 8, 0, '', '2019-08-31 14:43:57');
INSERT INTO `access_log` VALUES (73737, '65.46.15672338366754075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.92.226.226', '2019-08-31 14:43:57', 10, 2001001000, '服务端发生异常', '2019-08-31 14:43:57');
INSERT INTO `access_log` VALUES (73738, '65.51.15672338416974095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '218.92.226.226', '2019-08-31 14:44:02', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-31 14:44:02');
INSERT INTO `access_log` VALUES (73739, '59.79.15672399299560673', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '163.125.212.190', '2019-08-31 16:25:30', 10, 0, '', '2019-08-31 16:25:30');
INSERT INTO `access_log` VALUES (73740, '59.75.15672399299560677', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '163.125.212.190', '2019-08-31 16:25:30', 25, 2001001000, '服务端发生异常', '2019-08-31 16:25:30');
INSERT INTO `access_log` VALUES (73741, '59.76.15672399301020661', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '163.125.212.190', '2019-08-31 16:25:30', 3, 0, '', '2019-08-31 16:25:30');
INSERT INTO `access_log` VALUES (73742, '59.80.15672399301020643', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '163.125.212.190', '2019-08-31 16:25:30', 18, 2001001000, '服务端发生异常', '2019-08-31 16:25:30');
INSERT INTO `access_log` VALUES (73743, '64.82.15672399599211093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '163.125.212.190', '2019-08-31 16:26:00', 263, 0, '', '2019-08-31 16:26:00');
INSERT INTO `access_log` VALUES (73744, '64.84.15672399603281075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '163.125.212.190', '2019-08-31 16:26:00', 3, 0, '', '2019-08-31 16:26:00');
INSERT INTO `access_log` VALUES (73745, '64.78.15672399623631103', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '163.125.212.190', '2019-08-31 16:26:02', 2, 0, '', '2019-08-31 16:26:02');
INSERT INTO `access_log` VALUES (73746, '64.76.15672399699491087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '163.125.212.190', '2019-08-31 16:26:10', 2, 0, '', '2019-08-31 16:26:10');
INSERT INTO `access_log` VALUES (73747, '64.80.15672399700901081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '163.125.212.190', '2019-08-31 16:26:10', 2, 0, '', '2019-08-31 16:26:10');
INSERT INTO `access_log` VALUES (73748, '64.85.15672399716671099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '163.125.212.190', '2019-08-31 16:26:12', 3, 0, '', '2019-08-31 16:26:12');
INSERT INTO `access_log` VALUES (73749, '64.81.15672399722301085', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '163.125.212.190', '2019-08-31 16:26:12', 2, 0, '', '2019-08-31 16:26:12');
INSERT INTO `access_log` VALUES (73750, '59.80.15672420170350671', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.32.153.133', '2019-08-31 17:00:17', 12, 0, '', '2019-08-31 17:00:17');
INSERT INTO `access_log` VALUES (73751, '59.77.15672420170410687', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.32.153.133', '2019-08-31 17:00:17', 22, 2001001000, '服务端发生异常', '2019-08-31 17:00:17');
INSERT INTO `access_log` VALUES (73752, '59.73.15672450473150739', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.103.136.242', '2019-08-31 17:50:47', 11, 0, '', '2019-08-31 17:50:47');
INSERT INTO `access_log` VALUES (73753, '59.72.15672450473180739', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.103.136.242', '2019-08-31 17:50:47', 21, 2001001000, '服务端发生异常', '2019-08-31 17:50:47');
INSERT INTO `access_log` VALUES (73754, '65.50.15672450869474203', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.103.136.242', '2019-08-31 17:51:27', 0, 1002001015, '账号未登陆', '2019-08-31 17:51:27');
INSERT INTO `access_log` VALUES (73755, '65.49.15672450869474223', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.103.136.242', '2019-08-31 17:51:27', 0, 1002001015, '账号未登陆', '2019-08-31 17:51:27');
INSERT INTO `access_log` VALUES (73756, '65.3607.15672450869475999', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.103.136.242', '2019-08-31 17:51:27', 0, 1002001015, '账号未登陆', '2019-08-31 17:51:27');
INSERT INTO `access_log` VALUES (73757, '65.53.15672451088744145', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.103.136.242', '2019-08-31 17:51:49', 100, 0, '', '2019-08-31 17:51:49');
INSERT INTO `access_log` VALUES (73758, '65.45.15672451092204231', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.103.136.242', '2019-08-31 17:51:49', 15, 0, '', '2019-08-31 17:51:49');
INSERT INTO `access_log` VALUES (73759, '65.47.15672451092234147', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.103.136.242', '2019-08-31 17:51:49', 15, 0, '', '2019-08-31 17:51:49');
INSERT INTO `access_log` VALUES (73760, '65.46.15672451092234227', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.103.136.242', '2019-08-31 17:51:49', 15, 2001001000, '服务端发生异常', '2019-08-31 17:51:49');
INSERT INTO `access_log` VALUES (73761, '65.51.15672451136834247', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.103.136.242', '2019-08-31 17:51:54', 11, 0, '', '2019-08-31 17:51:54');
INSERT INTO `access_log` VALUES (73762, '65.50.15672451136884205', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.103.136.242', '2019-08-31 17:51:54', 9, 0, '', '2019-08-31 17:51:54');
INSERT INTO `access_log` VALUES (73763, '65.54.15672451136874089', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.103.136.242', '2019-08-31 17:51:54', 10, 2001001000, '服务端发生异常', '2019-08-31 17:51:54');
INSERT INTO `access_log` VALUES (73764, '59.78.15672451970580755', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.103.136.242', '2019-08-31 17:53:17', 5, 0, '', '2019-08-31 17:53:17');
INSERT INTO `access_log` VALUES (73765, '59.75.15672451970600749', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.103.136.242', '2019-08-31 17:53:17', 16, 2001001000, '服务端发生异常', '2019-08-31 17:53:17');
INSERT INTO `access_log` VALUES (73766, '59.71.15672553176040873', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.106.243', '2019-08-31 20:41:58', 17, 0, '', '2019-08-31 20:41:58');
INSERT INTO `access_log` VALUES (73767, '59.73.15672553176040877', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.106.243', '2019-08-31 20:41:58', 18, 2001001000, '服务端发生异常', '2019-08-31 20:41:58');
INSERT INTO `access_log` VALUES (73768, '59.72.15672553232760877', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.106.243', '2019-08-31 20:42:03', 3, 0, '', '2019-08-31 20:42:03');
INSERT INTO `access_log` VALUES (73769, '59.75.15672553232770885', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.106.243', '2019-08-31 20:42:03', 14, 2001001000, '服务端发生异常', '2019-08-31 20:42:03');
INSERT INTO `access_log` VALUES (73770, '64.78.15672553285781309', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.106.243', '2019-08-31 20:42:09', 12, 0, '', '2019-08-31 20:42:09');
INSERT INTO `access_log` VALUES (73771, '64.77.15672553287001265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.106.243', '2019-08-31 20:42:09', 3, 0, '', '2019-08-31 20:42:09');
INSERT INTO `access_log` VALUES (73772, '64.76.15672553299611293', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.106.243', '2019-08-31 20:42:10', 2, 0, '', '2019-08-31 20:42:10');
INSERT INTO `access_log` VALUES (73773, '64.80.15672553305371287', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.106.243', '2019-08-31 20:42:11', 2, 0, '', '2019-08-31 20:42:11');
INSERT INTO `access_log` VALUES (73774, '64.85.15672553310881305', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.106.243', '2019-08-31 20:42:11', 2, 0, '', '2019-08-31 20:42:11');
INSERT INTO `access_log` VALUES (73775, '64.81.15672553332701291', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.106.243', '2019-08-31 20:42:13', 2, 0, '', '2019-08-31 20:42:13');
INSERT INTO `access_log` VALUES (73776, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.106.243', '2019-08-31 20:42:13', 14, 0, '', '2019-08-31 20:42:13');
INSERT INTO `access_log` VALUES (73777, '64.79.15672553361701289', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.66.106.243', '2019-08-31 20:42:16', 9, 0, '', '2019-08-31 20:42:16');
INSERT INTO `access_log` VALUES (73778, '59.73.15672557279210883', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.143.114.38', '2019-08-31 20:48:48', 4, 0, '', '2019-08-31 20:48:48');
INSERT INTO `access_log` VALUES (73779, '59.72.15672557279230883', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.143.114.38', '2019-08-31 20:48:48', 34, 2001001000, '服务端发生异常', '2019-08-31 20:48:48');
INSERT INTO `access_log` VALUES (73780, '59.78.15672608329610965', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:13:53', 11, 0, '', '2019-08-31 22:13:53');
INSERT INTO `access_log` VALUES (73781, '59.79.15672608329610955', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:13:53', 26, 2001001000, '服务端发生异常', '2019-08-31 22:13:53');
INSERT INTO `access_log` VALUES (73782, '64.85.15672608389611379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:13:59', 12, 0, '', '2019-08-31 22:13:59');
INSERT INTO `access_log` VALUES (73783, '64.81.15672608390961365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:13:59', 3, 0, '', '2019-08-31 22:13:59');
INSERT INTO `access_log` VALUES (73784, '64.79.15672608403201363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:00', 2, 0, '', '2019-08-31 22:14:00');
INSERT INTO `access_log` VALUES (73785, '64.83.15672608407761357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:01', 1, 0, '', '2019-08-31 22:14:01');
INSERT INTO `access_log` VALUES (73786, '59.76.15672608414780943', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:01', 3, 0, '', '2019-08-31 22:14:01');
INSERT INTO `access_log` VALUES (73787, '59.77.15672608414780941', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:01', 18, 2001001000, '服务端发生异常', '2019-08-31 22:14:02');
INSERT INTO `access_log` VALUES (73788, '64.84.15672608455781357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:06', 2, 0, '', '2019-08-31 22:14:06');
INSERT INTO `access_log` VALUES (73789, '64.78.15672608456521385', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:06', 3, 0, '', '2019-08-31 22:14:06');
INSERT INTO `access_log` VALUES (73790, '64.77.15672608466691341', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:07', 3, 0, '', '2019-08-31 22:14:07');
INSERT INTO `access_log` VALUES (73791, '64.76.15672608469471369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:07', 2, 0, '', '2019-08-31 22:14:07');
INSERT INTO `access_log` VALUES (73792, '65.3607.15672608527856211', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:13', 1, 1002001015, '账号未登陆', '2019-08-31 22:14:13');
INSERT INTO `access_log` VALUES (73793, '65.49.15672608527854435', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:13', 0, 1002001015, '账号未登陆', '2019-08-31 22:14:13');
INSERT INTO `access_log` VALUES (73794, '65.52.15672608527934467', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:13', 1, 1002001015, '账号未登陆', '2019-08-31 22:14:13');
INSERT INTO `access_log` VALUES (73795, '65.53.15672608586824357', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-31 22:14:19');
INSERT INTO `access_log` VALUES (73796, '65.45.15672608630334443', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:23', 161, 0, '', '2019-08-31 22:14:23');
INSERT INTO `access_log` VALUES (73797, '65.47.15672608635154359', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:24', 20, 0, '', '2019-08-31 22:14:24');
INSERT INTO `access_log` VALUES (73798, '65.46.15672608635194439', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:24', 17, 2001001000, '服务端发生异常', '2019-08-31 22:14:24');
INSERT INTO `access_log` VALUES (73799, '65.50.15672608635224417', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '49.66.145.213', '2019-08-31 22:14:24', 18, 0, '', '2019-08-31 22:14:24');
INSERT INTO `access_log` VALUES (73800, '65.45.15672609504194445', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.13', '2019-08-31 22:15:50', 96, 0, '', '2019-08-31 22:15:51');
INSERT INTO `access_log` VALUES (73801, '65.50.15672609508224419', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.13', '2019-08-31 22:15:51', 17, 0, '', '2019-08-31 22:15:51');
INSERT INTO `access_log` VALUES (73802, '65.47.15672609508224361', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.13', '2019-08-31 22:15:51', 18, 2001001000, '服务端发生异常', '2019-08-31 22:15:51');
INSERT INTO `access_log` VALUES (73803, '65.46.15672609508284441', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.13', '2019-08-31 22:15:51', 15, 0, '', '2019-08-31 22:15:51');
INSERT INTO `access_log` VALUES (73804, '65.3607.15672611230056217', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.13', '2019-08-31 22:18:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-31 22:18:43');
INSERT INTO `access_log` VALUES (73805, '65.52.15672611370504473', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.13', '2019-08-31 22:18:57', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-08-31 22:18:57');
INSERT INTO `access_log` VALUES (73806, '65.45.15672611514934449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.13', '2019-08-31 22:19:11', 86, 0, '', '2019-08-31 22:19:12');
INSERT INTO `access_log` VALUES (73807, '65.46.15672611517604445', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.13', '2019-08-31 22:19:12', 124, 0, '', '2019-08-31 22:19:12');
INSERT INTO `access_log` VALUES (73808, '65.47.15672611517874365', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.13', '2019-08-31 22:19:12', 98, 0, '', '2019-08-31 22:19:12');
INSERT INTO `access_log` VALUES (73809, '65.50.15672611517854423', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.13', '2019-08-31 22:19:12', 101, 0, '', '2019-08-31 22:19:12');
INSERT INTO `access_log` VALUES (73810, '64.85.15672611705481385', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.13', '2019-08-31 22:19:31', 16, 0, '', '2019-08-31 22:19:31');
INSERT INTO `access_log` VALUES (73811, '64.81.15672611705481371', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.13', '2019-08-31 22:19:31', 19, 0, '', '2019-08-31 22:19:31');
INSERT INTO `access_log` VALUES (73812, '65.53.15672615331044369', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.115.228.195', '2019-08-31 22:25:33', 0, 1002001015, '账号未登陆', '2019-08-31 22:25:33');
INSERT INTO `access_log` VALUES (73813, '65.45.15672615331064455', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.115.228.195', '2019-08-31 22:25:33', 0, 1002001015, '账号未登陆', '2019-08-31 22:25:33');
INSERT INTO `access_log` VALUES (73814, '65.50.15672615331104429', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.115.228.195', '2019-08-31 22:25:33', 0, 1002001015, '账号未登陆', '2019-08-31 22:25:33');
INSERT INTO `access_log` VALUES (73815, '65.46.15672615364324451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.115.228.195', '2019-08-31 22:25:36', 77, 0, '', '2019-08-31 22:25:37');
INSERT INTO `access_log` VALUES (73816, '65.47.15672615367574371', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.115.228.195', '2019-08-31 22:25:37', 10, 0, '', '2019-08-31 22:25:37');
INSERT INTO `access_log` VALUES (73817, '65.54.15672615367624313', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.115.228.195', '2019-08-31 22:25:37', 10, 2001001000, '服务端发生异常', '2019-08-31 22:25:37');
INSERT INTO `access_log` VALUES (73818, '65.51.15672615367654471', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.115.228.195', '2019-08-31 22:25:37', 9, 0, '', '2019-08-31 22:25:37');
INSERT INTO `access_log` VALUES (73819, '65.49.15672615408574449', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.4', '2019-08-31 22:25:41', 0, 1002001015, '账号未登陆', '2019-08-31 22:25:41');
INSERT INTO `access_log` VALUES (73820, '65.52.15672615408744481', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.4', '2019-08-31 22:25:41', 1, 1002001015, '账号未登陆', '2019-08-31 22:25:41');
INSERT INTO `access_log` VALUES (73821, '65.50.15672615408944431', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.67', '2019-08-31 22:25:41', 0, 1002001015, '账号未登陆', '2019-08-31 22:25:41');
INSERT INTO `access_log` VALUES (73822, '65.53.15672615432594371', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.115.228.195', '2019-08-31 22:25:43', 9, 0, '', '2019-08-31 22:25:43');
INSERT INTO `access_log` VALUES (73823, '65.45.15672615432644457', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.115.228.195', '2019-08-31 22:25:43', 17, 2001001000, '服务端发生异常', '2019-08-31 22:25:43');
INSERT INTO `access_log` VALUES (73824, '65.46.15672615432664453', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.115.228.195', '2019-08-31 22:25:43', 15, 0, '', '2019-08-31 22:25:43');
INSERT INTO `access_log` VALUES (73825, '59.71.15672949195621403', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '178.154.200.13', '2019-09-01 07:42:00', 23, 2001001000, '服务端发生异常', '2019-09-01 07:42:00');
INSERT INTO `access_log` VALUES (73826, '59.73.15672949207871407', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '37.9.113.171', '2019-09-01 07:42:01', 10, 0, '', '2019-09-01 07:42:01');
INSERT INTO `access_log` VALUES (73827, '59.74.15673028261741525', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.162.130.149', '2019-09-01 09:53:46', 12, 0, '', '2019-09-01 09:53:46');
INSERT INTO `access_log` VALUES (73828, '59.71.15673028261761509', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.162.130.149', '2019-09-01 09:53:46', 15, 2001001000, '服务端发生异常', '2019-09-01 09:53:46');
INSERT INTO `access_log` VALUES (73829, '64.81.15673028357271927', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.162.130.149', '2019-09-01 09:53:56', 13, 0, '', '2019-09-01 09:53:56');
INSERT INTO `access_log` VALUES (73830, '64.85.15673028358161941', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.162.130.149', '2019-09-01 09:53:56', 3, 0, '', '2019-09-01 09:53:56');
INSERT INTO `access_log` VALUES (73831, '64.79.15673028387651925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.162.130.149', '2019-09-01 09:53:59', 2, 0, '', '2019-09-01 09:53:59');
INSERT INTO `access_log` VALUES (73832, '64.83.15673028403131919', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.162.130.149', '2019-09-01 09:54:00', 2, 0, '', '2019-09-01 09:54:00');
INSERT INTO `access_log` VALUES (73833, '59.72.15673028430761513', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.162.130.149', '2019-09-01 09:54:03', 3, 0, '', '2019-09-01 09:54:03');
INSERT INTO `access_log` VALUES (73834, '59.75.15673028430761521', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.162.130.149', '2019-09-01 09:54:03', 14, 2001001000, '服务端发生异常', '2019-09-01 09:54:03');
INSERT INTO `access_log` VALUES (73835, '59.72.15673117920501633', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '60.216.208.46', '2019-09-01 12:23:12', 13, 0, '', '2019-09-01 12:23:12');
INSERT INTO `access_log` VALUES (73836, '59.73.15673117920451633', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '60.216.208.46', '2019-09-01 12:23:12', 22, 2001001000, '服务端发生异常', '2019-09-01 12:23:12');
INSERT INTO `access_log` VALUES (73837, '65.51.15673134216195167', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.19.38.164', '2019-09-01 12:50:22', 0, 1002001015, '账号未登陆', '2019-09-01 12:50:22');
INSERT INTO `access_log` VALUES (73838, '65.54.15673134217425007', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.19.38.164', '2019-09-01 12:50:22', 0, 1002001015, '账号未登陆', '2019-09-01 12:50:22');
INSERT INTO `access_log` VALUES (73839, '65.3607.15673134217426919', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.19.38.164', '2019-09-01 12:50:22', 0, 1002001015, '账号未登陆', '2019-09-01 12:50:22');
INSERT INTO `access_log` VALUES (73840, '59.73.15673134269531655', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.19.38.164', '2019-09-01 12:50:27', 5, 0, '', '2019-09-01 12:50:27');
INSERT INTO `access_log` VALUES (73841, '59.75.15673134270181663', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.19.38.164', '2019-09-01 12:50:27', 14, 2001001000, '服务端发生异常', '2019-09-01 12:50:27');
INSERT INTO `access_log` VALUES (73842, '65.50.15673134274265123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.19.38.164', '2019-09-01 12:50:27', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-01 12:50:27');
INSERT INTO `access_log` VALUES (73843, '65.46.15673134338435147', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.19.38.164', '2019-09-01 12:50:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-01 12:50:34');
INSERT INTO `access_log` VALUES (73844, '59.78.15673239400341809', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.49.232.157', '2019-09-01 15:45:40', 11, 0, '', '2019-09-01 15:45:40');
INSERT INTO `access_log` VALUES (73845, '59.76.15673239400351787', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.49.232.157', '2019-09-01 15:45:40', 23, 2001001000, '服务端发生异常', '2019-09-01 15:45:40');
INSERT INTO `access_log` VALUES (73846, '65.54.15673245260145157', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.107.119.24', '2019-09-01 15:55:26', 0, 1002001015, '账号未登陆', '2019-09-01 15:55:26');
INSERT INTO `access_log` VALUES (73847, '65.51.15673245260135315', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.107.119.24', '2019-09-01 15:55:26', 0, 1002001015, '账号未登陆', '2019-09-01 15:55:26');
INSERT INTO `access_log` VALUES (73848, '65.3607.15673245260137069', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.107.119.24', '2019-09-01 15:55:26', 0, 1002001015, '账号未登陆', '2019-09-01 15:55:26');
INSERT INTO `access_log` VALUES (73849, '65.52.15673245348235325', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.107.119.24', '2019-09-01 15:55:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-01 15:55:35');
INSERT INTO `access_log` VALUES (73850, '65.50.15673245385985273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.107.119.24', '2019-09-01 15:55:39', 85, 0, '', '2019-09-01 15:55:39');
INSERT INTO `access_log` VALUES (73851, '65.49.15673245389235295', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.107.119.24', '2019-09-01 15:55:39', 20, 2001001000, '服务端发生异常', '2019-09-01 15:55:39');
INSERT INTO `access_log` VALUES (73852, '65.53.15673245389345215', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.107.119.24', '2019-09-01 15:55:39', 12, 0, '', '2019-09-01 15:55:39');
INSERT INTO `access_log` VALUES (73853, '65.46.15673245389235297', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.107.119.24', '2019-09-01 15:55:39', 31, 0, '', '2019-09-01 15:55:39');
INSERT INTO `access_log` VALUES (73854, '65.47.15673245486745217', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.107.119.24', '2019-09-01 15:55:49', 10, 0, '', '2019-09-01 15:55:49');
INSERT INTO `access_log` VALUES (73855, '65.54.15673245486805159', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.107.119.24', '2019-09-01 15:55:49', 17, 2001001000, '服务端发生异常', '2019-09-01 15:55:49');
INSERT INTO `access_log` VALUES (73856, '65.51.15673245486855317', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.107.119.24', '2019-09-01 15:55:49', 16, 0, '', '2019-09-01 15:55:49');
INSERT INTO `access_log` VALUES (73857, '59.74.15673278836261861', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.26.54.100', '2019-09-01 16:51:24', 10, 0, '', '2019-09-01 16:51:24');
INSERT INTO `access_log` VALUES (73858, '59.72.15673278836321849', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.26.54.100', '2019-09-01 16:51:24', 19, 2001001000, '服务端发生异常', '2019-09-01 16:51:24');
INSERT INTO `access_log` VALUES (73859, '65.45.15673335415335425', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.52 Safari/537.36', '117.136.75.195', '2019-09-01 18:25:42', 0, 1002001015, '账号未登陆', '2019-09-01 18:25:42');
INSERT INTO `access_log` VALUES (73860, '65.47.15673335415315339', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.52 Safari/537.36', '117.136.75.195', '2019-09-01 18:25:42', 1, 1002001015, '账号未登陆', '2019-09-01 18:25:42');
INSERT INTO `access_log` VALUES (73861, '65.53.15673335415485337', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.52 Safari/537.36', '117.136.75.195', '2019-09-01 18:25:42', 0, 1002001015, '账号未登陆', '2019-09-01 18:25:42');
INSERT INTO `access_log` VALUES (73862, '65.54.15673335451985279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.52 Safari/537.36', '117.136.75.195', '2019-09-01 18:25:45', 18, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-01 18:25:45');
INSERT INTO `access_log` VALUES (73863, '65.49.15673335528235417', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.52 Safari/537.36', '117.136.75.195', '2019-09-01 18:25:53', 112, 0, '', '2019-09-01 18:25:53');
INSERT INTO `access_log` VALUES (73864, '65.3607.15673335536117191', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.52 Safari/537.36', '117.136.75.195', '2019-09-01 18:25:54', 15, 0, '', '2019-09-01 18:25:54');
INSERT INTO `access_log` VALUES (73865, '65.46.15673335536115421', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.52 Safari/537.36', '117.136.75.195', '2019-09-01 18:25:54', 16, 2001001000, '服务端发生异常', '2019-09-01 18:25:54');
INSERT INTO `access_log` VALUES (73866, '65.51.15673335536445441', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.52 Safari/537.36', '117.136.75.195', '2019-09-01 18:25:54', 12, 0, '', '2019-09-01 18:25:54');
INSERT INTO `access_log` VALUES (73867, '59.74.15673443638772081', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.79.160', '2019-09-01 21:26:04', 12, 0, '', '2019-09-01 21:26:04');
INSERT INTO `access_log` VALUES (73868, '59.72.15673443638832069', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.79.160', '2019-09-01 21:26:04', 31, 2001001000, '服务端发生异常', '2019-09-01 21:26:04');
INSERT INTO `access_log` VALUES (73869, '59.78.15673443820972083', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.79.160', '2019-09-01 21:26:22', 2, 0, '', '2019-09-01 21:26:22');
INSERT INTO `access_log` VALUES (73870, '59.79.15673443820922073', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.79.160', '2019-09-01 21:26:22', 18, 2001001000, '服务端发生异常', '2019-09-01 21:26:22');
INSERT INTO `access_log` VALUES (73871, '59.77.15673443962482059', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.136.79.160', '2019-09-01 21:26:36', 2, 0, '', '2019-09-01 21:26:36');
INSERT INTO `access_log` VALUES (73872, '59.80.15673443962572043', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.136.79.160', '2019-09-01 21:26:36', 16, 2001001000, '服务端发生异常', '2019-09-01 21:26:36');
INSERT INTO `access_log` VALUES (73873, '64.77.15673444274172457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.136.79.160', '2019-09-01 21:27:07', 10, 0, '', '2019-09-01 21:27:07');
INSERT INTO `access_log` VALUES (73874, '64.76.15673444276272485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.136.79.160', '2019-09-01 21:27:08', 3, 0, '', '2019-09-01 21:27:08');
INSERT INTO `access_log` VALUES (73875, '64.80.15673444394892479', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.136.79.160', '2019-09-01 21:27:19', 2, 0, '', '2019-09-01 21:27:20');
INSERT INTO `access_log` VALUES (73876, '64.85.15673444415522497', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '117.136.79.160', '2019-09-01 21:27:22', 1, 0, '', '2019-09-01 21:27:22');
INSERT INTO `access_log` VALUES (73877, '65.46.15673445677315567', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.79.160', '2019-09-01 21:29:28', 0, 1002001015, '账号未登陆', '2019-09-01 21:29:28');
INSERT INTO `access_log` VALUES (73878, '65.49.15673445677315565', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.79.160', '2019-09-01 21:29:28', 0, 1002001015, '账号未登陆', '2019-09-01 21:29:28');
INSERT INTO `access_log` VALUES (73879, '65.54.15673445677315431', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.79.160', '2019-09-01 21:29:28', 0, 1002001015, '账号未登陆', '2019-09-01 21:29:28');
INSERT INTO `access_log` VALUES (73880, '65.51.15673467911425621', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.79.160', '2019-09-01 22:06:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-01 22:06:31');
INSERT INTO `access_log` VALUES (73881, '65.47.15673468098745521', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.79.160', '2019-09-01 22:06:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-01 22:06:50');
INSERT INTO `access_log` VALUES (73882, '65.54.15673468300325463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.79.160', '2019-09-01 22:07:10', 98, 0, '', '2019-09-01 22:07:10');
INSERT INTO `access_log` VALUES (73883, '65.46.15673468306935599', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.79.160', '2019-09-01 22:07:11', 15, 0, '', '2019-09-01 22:07:11');
INSERT INTO `access_log` VALUES (73884, '65.49.15673468306935597', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.79.160', '2019-09-01 22:07:11', 18, 2001001000, '服务端发生异常', '2019-09-01 22:07:11');
INSERT INTO `access_log` VALUES (73885, '65.3607.15673468307067371', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.79.160', '2019-09-01 22:07:11', 15, 0, '', '2019-09-01 22:07:11');
INSERT INTO `access_log` VALUES (73886, '65.49.15673504029765645', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:06:43', 1, 1002001015, '账号未登陆', '2019-09-01 23:06:43');
INSERT INTO `access_log` VALUES (73887, '65.52.15673504029785679', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:06:43', 0, 1002001015, '账号未登陆', '2019-09-01 23:06:43');
INSERT INTO `access_log` VALUES (73888, '65.51.15673504029785671', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:06:43', 1, 1002001015, '账号未登陆', '2019-09-01 23:06:43');
INSERT INTO `access_log` VALUES (73889, '65.45.15673504056855655', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:06:46', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-01 23:06:46');
INSERT INTO `access_log` VALUES (73890, '65.47.15673504104985571', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:06:50', 96, 0, '', '2019-09-01 23:06:51');
INSERT INTO `access_log` VALUES (73891, '65.53.15673504107745571', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:06:51', 14, 0, '', '2019-09-01 23:06:51');
INSERT INTO `access_log` VALUES (73892, '65.54.15673504107785511', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:06:51', 13, 0, '', '2019-09-01 23:06:51');
INSERT INTO `access_log` VALUES (73893, '65.50.15673504107775627', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:06:51', 13, 0, '', '2019-09-01 23:06:51');
INSERT INTO `access_log` VALUES (73894, '64.81.15673504141052563', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:06:54', 31, 0, '', '2019-09-01 23:06:54');
INSERT INTO `access_log` VALUES (73895, '64.85.15673504141052577', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:06:54', 25, 0, '', '2019-09-01 23:06:54');
INSERT INTO `access_log` VALUES (73896, '64.83.15673504159002555', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:06:56', 16, 0, '', '2019-09-01 23:06:56');
INSERT INTO `access_log` VALUES (73897, '64.79.15673504158992561', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:06:56', 17, 0, '', '2019-09-01 23:06:56');
INSERT INTO `access_log` VALUES (73898, '64.84.15673504320732555', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:07:12', 13, 0, '', '2019-09-01 23:07:12');
INSERT INTO `access_log` VALUES (73899, '64.77.15673504320732539', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:07:12', 13, 0, '', '2019-09-01 23:07:12');
INSERT INTO `access_log` VALUES (73900, '64.78.15673504320732583', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:07:12', 17, 0, '', '2019-09-01 23:07:12');
INSERT INTO `access_log` VALUES (73901, '64.80.15673504346092561', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:07:15', 12, 0, '', '2019-09-01 23:07:15');
INSERT INTO `access_log` VALUES (73902, '64.76.15673504346072567', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:07:15', 15, 0, '', '2019-09-01 23:07:15');
INSERT INTO `access_log` VALUES (73903, '64.81.15673504381452565', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:07:18', 11, 0, '', '2019-09-01 23:07:18');
INSERT INTO `access_log` VALUES (73904, '64.85.15673504381452579', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:07:18', 15, 0, '', '2019-09-01 23:07:18');
INSERT INTO `access_log` VALUES (73905, '66.53.15673504686219555', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:07:49', 17, 0, '', '2019-09-01 23:07:49');
INSERT INTO `access_log` VALUES (73906, '64.81.15673505364762567', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:08:56', 17, 0, '', '2019-09-01 23:08:56');
INSERT INTO `access_log` VALUES (73907, '64.80.15673505364762563', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:08:56', 18, 0, '', '2019-09-01 23:08:56');
INSERT INTO `access_log` VALUES (73908, '64.84.15673505637042559', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:09:24', 10, 0, '', '2019-09-01 23:09:24');
INSERT INTO `access_log` VALUES (73909, '64.82.15673505637032577', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:09:24', 10, 0, '', '2019-09-01 23:09:24');
INSERT INTO `access_log` VALUES (73910, '64.83.15673505637032559', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-01 23:09:24', 14, 0, '', '2019-09-01 23:09:24');
INSERT INTO `access_log` VALUES (73911, '59.72.15673573355712243', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '178.154.200.13', '2019-09-02 01:02:16', 17, 2001001000, '服务端发生异常', '2019-09-02 01:02:16');
INSERT INTO `access_log` VALUES (73912, '59.73.15673573367922243', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 8_1 like Mac OS X) AppleWebKit/600.1.4 (KHTML, like Gecko) Version/8.0 Mobile/12B411 Safari/600.1.4 (compatible; YandexMobileBot/3.0; +http://yandex.com/bots)', '37.9.113.171', '2019-09-02 01:02:17', 11, 0, '', '2019-09-02 01:02:17');
INSERT INTO `access_log` VALUES (73913, '65.47.15673818437945991', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.35.75.30', '2019-09-02 07:50:44', 1, 1002001015, '账号未登陆', '2019-09-02 07:50:44');
INSERT INTO `access_log` VALUES (73914, '65.53.15673818440265991', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.35.75.30', '2019-09-02 07:50:44', 0, 1002001015, '账号未登陆', '2019-09-02 07:50:44');
INSERT INTO `access_log` VALUES (73915, '65.54.15673818442265931', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.35.75.30', '2019-09-02 07:50:44', 0, 1002001015, '账号未登陆', '2019-09-02 07:50:44');
INSERT INTO `access_log` VALUES (73916, '65.46.15673818553256069', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.35.75.30', '2019-09-02 07:50:55', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 07:50:55');
INSERT INTO `access_log` VALUES (73917, '65.51.15673818742316093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.35.75.30', '2019-09-02 07:51:14', 68, 0, '', '2019-09-02 07:51:14');
INSERT INTO `access_log` VALUES (73918, '65.49.15673818763486067', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.35.75.30', '2019-09-02 07:51:16', 16, 0, '', '2019-09-02 07:51:16');
INSERT INTO `access_log` VALUES (73919, '65.52.15673818767046101', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.35.75.30', '2019-09-02 07:51:17', 13, 2001001000, '服务端发生异常', '2019-09-02 07:51:17');
INSERT INTO `access_log` VALUES (73920, '65.45.15673818769766077', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.35.75.30', '2019-09-02 07:51:17', 12, 0, '', '2019-09-02 07:51:17');
INSERT INTO `access_log` VALUES (73921, '65.53.15673818881765993', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.35.75.30', '2019-09-02 07:51:28', 10, 0, '', '2019-09-02 07:51:28');
INSERT INTO `access_log` VALUES (73922, '65.54.15673818884815933', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.35.75.30', '2019-09-02 07:51:28', 10, 2001001000, '服务端发生异常', '2019-09-02 07:51:28');
INSERT INTO `access_log` VALUES (73923, '65.50.15673818887936049', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.35.75.30', '2019-09-02 07:51:29', 10, 0, '', '2019-09-02 07:51:29');
INSERT INTO `access_log` VALUES (73924, '59.74.15673914597472711', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.240.44.78', '2019-09-02 10:31:00', 27, 2001001000, '服务端发生异常', '2019-09-02 10:31:00');
INSERT INTO `access_log` VALUES (73925, '59.71.15673914597452695', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.240.44.78', '2019-09-02 10:31:00', 38, 0, '', '2019-09-02 10:31:00');
INSERT INTO `access_log` VALUES (73926, '64.81.15673914647713115', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.240.44.78', '2019-09-02 10:31:05', 11, 0, '', '2019-09-02 10:31:05');
INSERT INTO `access_log` VALUES (73927, '64.85.15673914648863129', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.240.44.78', '2019-09-02 10:31:05', 3, 0, '', '2019-09-02 10:31:05');
INSERT INTO `access_log` VALUES (73928, '64.82.15673914664543123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.240.44.78', '2019-09-02 10:31:06', 2, 0, '', '2019-09-02 10:31:06');
INSERT INTO `access_log` VALUES (73929, '64.79.15673914669263111', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '222.240.44.78', '2019-09-02 10:31:07', 2, 0, '', '2019-09-02 10:31:07');
INSERT INTO `access_log` VALUES (73930, '59.80.15673924296182685', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '61.141.72.172', '2019-09-02 10:47:10', 5, 0, '', '2019-09-02 10:47:10');
INSERT INTO `access_log` VALUES (73931, '59.76.15673924296102703', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.88.134.202', '2019-09-02 10:47:10', 23, 2001001000, '服务端发生异常', '2019-09-02 10:47:10');
INSERT INTO `access_log` VALUES (73932, '65.53.15673924332816135', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.88.134.202', '2019-09-02 10:47:13', 1, 1002001015, '账号未登陆', '2019-09-02 10:47:13');
INSERT INTO `access_log` VALUES (73933, '65.46.15673924332816213', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '61.141.72.172', '2019-09-02 10:47:13', 0, 1002001015, '账号未登陆', '2019-09-02 10:47:13');
INSERT INTO `access_log` VALUES (73934, '65.54.15673924332816075', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '61.141.72.172', '2019-09-02 10:47:13', 1, 1002001015, '账号未登陆', '2019-09-02 10:47:13');
INSERT INTO `access_log` VALUES (73935, '64.80.15673924404943123', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.88.134.202', '2019-09-02 10:47:20', 3, 0, '', '2019-09-02 10:47:20');
INSERT INTO `access_log` VALUES (73936, '64.85.15673924405933143', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.88.134.202', '2019-09-02 10:47:21', 2, 0, '', '2019-09-02 10:47:21');
INSERT INTO `access_log` VALUES (73937, '64.83.15673924429253119', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.88.134.202', '2019-09-02 10:47:23', 2, 0, '', '2019-09-02 10:47:23');
INSERT INTO `access_log` VALUES (73938, '64.82.15673924435063137', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.88.134.202', '2019-09-02 10:47:24', 2, 0, '', '2019-09-02 10:47:24');
INSERT INTO `access_log` VALUES (73939, '64.79.15673924488513125', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.88.134.202', '2019-09-02 10:47:29', 2, 0, '', '2019-09-02 10:47:29');
INSERT INTO `access_log` VALUES (73940, '64.84.15673924489943121', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.88.134.202', '2019-09-02 10:47:29', 1, 0, '', '2019-09-02 10:47:29');
INSERT INTO `access_log` VALUES (73941, '59.71.15673924500662709', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.88.134.202', '2019-09-02 10:47:30', 2, 0, '', '2019-09-02 10:47:30');
INSERT INTO `access_log` VALUES (73942, '59.74.15673924500632725', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '61.141.72.172', '2019-09-02 10:47:30', 13, 2001001000, '服务端发生异常', '2019-09-02 10:47:30');
INSERT INTO `access_log` VALUES (73943, '65.3607.15673924538327985', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '61.141.72.172', '2019-09-02 10:47:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 10:47:34');
INSERT INTO `access_log` VALUES (73944, '65.51.15673924575106237', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '61.141.72.172', '2019-09-02 10:47:38', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 10:47:38');
INSERT INTO `access_log` VALUES (73945, '65.45.15673924617016219', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '61.141.72.172', '2019-09-02 10:47:42', 119, 0, '', '2019-09-02 10:47:42');
INSERT INTO `access_log` VALUES (73946, '65.49.15673924624026211', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '113.88.134.202', '2019-09-02 10:47:42', 14, 0, '', '2019-09-02 10:47:42');
INSERT INTO `access_log` VALUES (73947, '65.47.15673924624096137', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '61.141.72.172', '2019-09-02 10:47:42', 11, 2001001000, '服务端发生异常', '2019-09-02 10:47:42');
INSERT INTO `access_log` VALUES (73948, '65.46.15673924624116215', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '61.141.72.172', '2019-09-02 10:47:42', 10, 0, '', '2019-09-02 10:47:42');
INSERT INTO `access_log` VALUES (73949, '65.54.15673924863236077', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '61.141.72.172', '2019-09-02 10:48:06', 9, 0, '', '2019-09-02 10:48:06');
INSERT INTO `access_log` VALUES (73950, '65.3607.15673924863497987', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '61.141.72.172', '2019-09-02 10:48:06', 10, 0, '', '2019-09-02 10:48:06');
INSERT INTO `access_log` VALUES (73951, '65.50.15673924863476193', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '61.141.72.172', '2019-09-02 10:48:06', 12, 2001001000, '服务端发生异常', '2019-09-02 10:48:06');
INSERT INTO `access_log` VALUES (73952, '65.52.15673935424786259', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '103.208.12.101', '2019-09-02 11:05:42', 0, 1002001015, '账号未登陆', '2019-09-02 11:05:42');
INSERT INTO `access_log` VALUES (73953, '65.45.15673935424796235', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '103.208.12.101', '2019-09-02 11:05:42', 0, 1002001015, '账号未登陆', '2019-09-02 11:05:42');
INSERT INTO `access_log` VALUES (73954, '65.47.15673935424816153', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '103.208.12.101', '2019-09-02 11:05:42', 0, 1002001015, '账号未登陆', '2019-09-02 11:05:42');
INSERT INTO `access_log` VALUES (73955, '65.49.15673935447156227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '103.208.12.101', '2019-09-02 11:05:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 11:05:45');
INSERT INTO `access_log` VALUES (73956, '65.46.15673935495066231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '103.208.12.101', '2019-09-02 11:05:50', 108, 0, '', '2019-09-02 11:05:50');
INSERT INTO `access_log` VALUES (73957, '65.53.15673935498656153', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '103.208.12.101', '2019-09-02 11:05:50', 10, 0, '', '2019-09-02 11:05:50');
INSERT INTO `access_log` VALUES (73958, '65.50.15673935498686209', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '103.208.12.101', '2019-09-02 11:05:50', 10, 2001001000, '服务端发生异常', '2019-09-02 11:05:50');
INSERT INTO `access_log` VALUES (73959, '65.54.15673935498716093', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '103.208.12.101', '2019-09-02 11:05:50', 9, 0, '', '2019-09-02 11:05:50');
INSERT INTO `access_log` VALUES (73960, '65.51.15673935674196255', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '103.208.12.101', '2019-09-02 11:06:07', 8, 0, '', '2019-09-02 11:06:07');
INSERT INTO `access_log` VALUES (73961, '65.45.15673935674196237', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '103.208.12.101', '2019-09-02 11:06:07', 9, 2001001000, '服务端发生异常', '2019-09-02 11:06:07');
INSERT INTO `access_log` VALUES (73962, '65.47.15673935674226155', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '103.208.12.101', '2019-09-02 11:06:07', 8, 0, '', '2019-09-02 11:06:07');
INSERT INTO `access_log` VALUES (73963, '65.54.15673955777936121', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.95.45.117', '2019-09-02 11:39:38', 0, 1002001015, '账号未登陆', '2019-09-02 11:39:38');
INSERT INTO `access_log` VALUES (73964, '65.53.15673955777936181', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.169.28.165', '2019-09-02 11:39:38', 0, 1002001015, '账号未登陆', '2019-09-02 11:39:38');
INSERT INTO `access_log` VALUES (73965, '65.3607.15673955777948031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.95.45.117', '2019-09-02 11:39:38', 1, 1002001015, '账号未登陆', '2019-09-02 11:39:38');
INSERT INTO `access_log` VALUES (73966, '65.45.15673955802706265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.95.45.117', '2019-09-02 11:39:40', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 11:39:40');
INSERT INTO `access_log` VALUES (73967, '65.47.15673955897966183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.95.45.117', '2019-09-02 11:39:50', 76, 0, '', '2019-09-02 11:39:50');
INSERT INTO `access_log` VALUES (73968, '65.52.15673955904676289', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.95.45.117', '2019-09-02 11:39:50', 12, 2001001000, '服务端发生异常', '2019-09-02 11:39:50');
INSERT INTO `access_log` VALUES (73969, '65.46.15673955904696261', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.95.45.117', '2019-09-02 11:39:50', 10, 0, '', '2019-09-02 11:39:50');
INSERT INTO `access_log` VALUES (73970, '65.49.15673955904686257', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.95.45.117', '2019-09-02 11:39:50', 13, 0, '', '2019-09-02 11:39:50');
INSERT INTO `access_log` VALUES (73971, '65.54.15673955979456123', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.95.45.117', '2019-09-02 11:39:58', 8, 0, '', '2019-09-02 11:39:58');
INSERT INTO `access_log` VALUES (73972, '65.53.15673955979456183', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.95.45.117', '2019-09-02 11:39:58', 10, 2001001000, '服务端发生异常', '2019-09-02 11:39:58');
INSERT INTO `access_log` VALUES (73973, '65.3607.15673955979468033', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.95.45.117', '2019-09-02 11:39:58', 10, 0, '', '2019-09-02 11:39:58');
INSERT INTO `access_log` VALUES (73974, '59.78.15673956340772769', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.95.45.117', '2019-09-02 11:40:34', 12, 0, '', '2019-09-02 11:40:34');
INSERT INTO `access_log` VALUES (73975, '59.79.15673956340782759', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.95.45.117', '2019-09-02 11:40:34', 18, 2001001000, '服务端发生异常', '2019-09-02 11:40:34');
INSERT INTO `access_log` VALUES (73976, '64.81.15673956428023173', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.169.28.165', '2019-09-02 11:40:43', 13, 0, '', '2019-09-02 11:40:43');
INSERT INTO `access_log` VALUES (73977, '64.80.15673956429403167', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.169.28.165', '2019-09-02 11:40:43', 4, 0, '', '2019-09-02 11:40:43');
INSERT INTO `access_log` VALUES (73978, '64.85.15673956440803187', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.169.28.165', '2019-09-02 11:40:44', 2, 0, '', '2019-09-02 11:40:44');
INSERT INTO `access_log` VALUES (73979, '64.83.15673956445653163', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.169.28.165', '2019-09-02 11:40:45', 2, 0, '', '2019-09-02 11:40:45');
INSERT INTO `access_log` VALUES (73980, '64.82.15673956449963181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.169.28.165', '2019-09-02 11:40:45', 2, 0, '', '2019-09-02 11:40:45');
INSERT INTO `access_log` VALUES (73981, '65.52.15673958192446293', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.91.83.238', '2019-09-02 11:43:39', 1, 1002001015, '账号未登陆', '2019-09-02 11:43:39');
INSERT INTO `access_log` VALUES (73982, '65.50.15673958192466243', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.91.83.238', '2019-09-02 11:43:39', 1, 1002001015, '账号未登陆', '2019-09-02 11:43:39');
INSERT INTO `access_log` VALUES (73983, '65.3607.15673958192468037', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.91.83.238', '2019-09-02 11:43:39', 1, 1002001015, '账号未登陆', '2019-09-02 11:43:39');
INSERT INTO `access_log` VALUES (73984, '65.54.15673958258936127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.91.83.238', '2019-09-02 11:43:46', 127, 0, '', '2019-09-02 11:43:46');
INSERT INTO `access_log` VALUES (73985, '65.45.15673958262266271', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.91.83.238', '2019-09-02 11:43:46', 9, 0, '', '2019-09-02 11:43:46');
INSERT INTO `access_log` VALUES (73986, '65.53.15673958262266187', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.91.83.238', '2019-09-02 11:43:46', 9, 0, '', '2019-09-02 11:43:46');
INSERT INTO `access_log` VALUES (73987, '65.51.15673958262266289', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.91.83.238', '2019-09-02 11:43:46', 10, 2001001000, '服务端发生异常', '2019-09-02 11:43:46');
INSERT INTO `access_log` VALUES (73988, '59.75.15674005489572827', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:02:29', 12, 0, '', '2019-09-02 13:02:29');
INSERT INTO `access_log` VALUES (73989, '59.78.15674005489572835', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:02:29', 27, 2001001000, '服务端发生异常', '2019-09-02 13:02:29');
INSERT INTO `access_log` VALUES (73990, '64.85.15674005544373253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:02:34', 11, 0, '', '2019-09-02 13:02:34');
INSERT INTO `access_log` VALUES (73991, '64.83.15674005546373229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:02:35', 5, 0, '', '2019-09-02 13:02:35');
INSERT INTO `access_log` VALUES (73992, '65.53.15674005782536251', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:02:58', 1, 1002001015, '账号未登陆', '2019-09-02 13:02:58');
INSERT INTO `access_log` VALUES (73993, '65.45.15674005782546335', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:02:58', 1, 1002001015, '账号未登陆', '2019-09-02 13:02:58');
INSERT INTO `access_log` VALUES (73994, '65.51.15674005782566353', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:02:58', 0, 1002001015, '账号未登陆', '2019-09-02 13:02:58');
INSERT INTO `access_log` VALUES (73995, '65.47.15674005814946253', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:03:01', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 13:03:02');
INSERT INTO `access_log` VALUES (73996, '65.50.15674006077446309', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:03:28', 193, 0, '', '2019-09-02 13:03:28');
INSERT INTO `access_log` VALUES (73997, '65.3607.15674006083318103', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:03:28', 12, 0, '', '2019-09-02 13:03:28');
INSERT INTO `access_log` VALUES (73998, '65.54.15674006083326193', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:03:28', 13, 2001001000, '服务端发生异常', '2019-09-02 13:03:28');
INSERT INTO `access_log` VALUES (73999, '65.52.15674006083316359', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:03:28', 14, 0, '', '2019-09-02 13:03:28');
INSERT INTO `access_log` VALUES (74000, '65.51.15674006411376355', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:04:01', 9, 0, '', '2019-09-02 13:04:01');
INSERT INTO `access_log` VALUES (74001, '65.47.15674006411376255', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:04:01', 10, 2001001000, '服务端发生异常', '2019-09-02 13:04:01');
INSERT INTO `access_log` VALUES (74002, '65.49.15674006411956329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:04:01', 19, 0, '', '2019-09-02 13:04:01');
INSERT INTO `access_log` VALUES (74003, '65.50.15674006462326311', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:04:06', 9, 0, '', '2019-09-02 13:04:06');
INSERT INTO `access_log` VALUES (74004, '65.46.15674006462326333', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:04:06', 10, 2001001000, '服务端发生异常', '2019-09-02 13:04:06');
INSERT INTO `access_log` VALUES (74005, '65.3607.15674006462448105', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:04:06', 9, 0, '', '2019-09-02 13:04:06');
INSERT INTO `access_log` VALUES (74006, '65.45.15674006486466339', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:04:09', 9, 0, '', '2019-09-02 13:04:09');
INSERT INTO `access_log` VALUES (74007, '65.52.15674006486466361', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:04:09', 9, 0, '', '2019-09-02 13:04:09');
INSERT INTO `access_log` VALUES (74008, '65.54.15674006486466195', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.136.75.239', '2019-09-02 13:04:09', 10, 2001001000, '服务端发生异常', '2019-09-02 13:04:09');
INSERT INTO `access_log` VALUES (74009, '59.76.15674071683542901', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Mi Note 3 Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '117.139.221.34', '2019-09-02 14:52:48', 9, 0, '', '2019-09-02 14:52:48');
INSERT INTO `access_log` VALUES (74010, '59.80.15674071683542883', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Mi Note 3 Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '117.139.221.34', '2019-09-02 14:52:48', 25, 2001001000, '服务端发生异常', '2019-09-02 14:52:48');
INSERT INTO `access_log` VALUES (74011, '65.3607.15674071765168193', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Mi Note 3 Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '117.139.221.34', '2019-09-02 14:52:57', 1, 1002001015, '账号未登陆', '2019-09-02 14:52:57');
INSERT INTO `access_log` VALUES (74012, '65.52.15674071765176449', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Mi Note 3 Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '117.139.221.34', '2019-09-02 14:52:57', 0, 1002001015, '账号未登陆', '2019-09-02 14:52:57');
INSERT INTO `access_log` VALUES (74013, '65.54.15674071765306283', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Mi Note 3 Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '117.139.221.34', '2019-09-02 14:52:57', 0, 1002001015, '账号未登陆', '2019-09-02 14:52:57');
INSERT INTO `access_log` VALUES (74014, '65.45.15674071800236427', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Mi Note 3 Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '117.139.221.34', '2019-09-02 14:53:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 14:53:00');
INSERT INTO `access_log` VALUES (74015, '65.47.15674072062576345', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Mi Note 3 Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '117.139.221.34', '2019-09-02 14:53:26', 69, 0, '', '2019-09-02 14:53:26');
INSERT INTO `access_log` VALUES (74016, '65.49.15674072070946419', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Mi Note 3 Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '117.139.221.34', '2019-09-02 14:53:27', 12, 2001001000, '服务端发生异常', '2019-09-02 14:53:27');
INSERT INTO `access_log` VALUES (74017, '65.46.15674072070996423', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Mi Note 3 Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '117.139.221.34', '2019-09-02 14:53:27', 9, 0, '', '2019-09-02 14:53:27');
INSERT INTO `access_log` VALUES (74018, '65.50.15674072071156401', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; Mi Note 3 Build/OPM1.171019.019) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/12.6.1.1041 Mobile Safari/537.36', '117.139.221.34', '2019-09-02 14:53:27', 7, 0, '', '2019-09-02 14:53:27');
INSERT INTO `access_log` VALUES (74019, '59.74.15674076488322929', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '39.155.215.146', '2019-09-02 15:00:49', 4, 0, '', '2019-09-02 15:00:49');
INSERT INTO `access_log` VALUES (74020, '59.72.15674076488362917', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '39.155.215.146', '2019-09-02 15:00:49', 23, 2001001000, '服务端发生异常', '2019-09-02 15:00:49');
INSERT INTO `access_log` VALUES (74021, '65.47.15674079013916355', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '39.155.215.146', '2019-09-02 15:05:01', 1, 1002001015, '账号未登陆', '2019-09-02 15:05:01');
INSERT INTO `access_log` VALUES (74022, '65.49.15674079013956429', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '39.155.215.146', '2019-09-02 15:05:01', 0, 1002001015, '账号未登陆', '2019-09-02 15:05:01');
INSERT INTO `access_log` VALUES (74023, '65.50.15674079014006411', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '39.155.215.146', '2019-09-02 15:05:01', 0, 1002001015, '账号未登陆', '2019-09-02 15:05:01');
INSERT INTO `access_log` VALUES (74024, '65.52.15674079190226461', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '39.155.215.146', '2019-09-02 15:05:19', 54, 0, '', '2019-09-02 15:05:19');
INSERT INTO `access_log` VALUES (74025, '65.3607.15674079193438205', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '39.155.215.146', '2019-09-02 15:05:19', 11, 0, '', '2019-09-02 15:05:19');
INSERT INTO `access_log` VALUES (74026, '65.45.15674079193466439', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '39.155.215.146', '2019-09-02 15:05:19', 10, 0, '', '2019-09-02 15:05:19');
INSERT INTO `access_log` VALUES (74027, '65.54.15674079193466295', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '39.155.215.146', '2019-09-02 15:05:19', 11, 2001001000, '服务端发生异常', '2019-09-02 15:05:19');
INSERT INTO `access_log` VALUES (74028, '65.51.15674079272196457', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '39.155.215.146', '2019-09-02 15:05:27', 9, 0, '', '2019-09-02 15:05:27');
INSERT INTO `access_log` VALUES (74029, '65.49.15674079272216431', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '39.155.215.146', '2019-09-02 15:05:27', 10, 2001001000, '服务端发生异常', '2019-09-02 15:05:27');
INSERT INTO `access_log` VALUES (74030, '65.47.15674079272256357', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '39.155.215.146', '2019-09-02 15:05:27', 8, 0, '', '2019-09-02 15:05:27');
INSERT INTO `access_log` VALUES (74031, '65.51.15674080614656459', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:07:41', 1, 1002001015, '账号未登陆', '2019-09-02 15:07:41');
INSERT INTO `access_log` VALUES (74032, '65.50.15674080615016415', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:07:42', 0, 1002001015, '账号未登陆', '2019-09-02 15:07:42');
INSERT INTO `access_log` VALUES (74033, '65.46.15674080615016437', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:07:42', 0, 1002001015, '账号未登陆', '2019-09-02 15:07:42');
INSERT INTO `access_log` VALUES (74034, '65.52.15674080676376465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:07:48', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 15:07:48');
INSERT INTO `access_log` VALUES (74035, '65.54.15674080744456299', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:07:54', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 15:07:54');
INSERT INTO `access_log` VALUES (74036, '65.53.15674080903276359', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:08:10', 101, 0, '', '2019-09-02 15:08:10');
INSERT INTO `access_log` VALUES (74037, '65.49.15674080906206435', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:08:11', 10, 0, '', '2019-09-02 15:08:11');
INSERT INTO `access_log` VALUES (74038, '65.47.15674080906236361', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:08:11', 10, 2001001000, '服务端发生异常', '2019-09-02 15:08:11');
INSERT INTO `access_log` VALUES (74039, '65.51.15674080906256461', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:08:11', 8, 0, '', '2019-09-02 15:08:11');
INSERT INTO `access_log` VALUES (74040, '65.45.15674082982256447', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.45.9', '2019-09-02 15:11:38', 0, 1002001015, '账号未登陆', '2019-09-02 15:11:38');
INSERT INTO `access_log` VALUES (74041, '65.54.15674082982286303', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.45.9', '2019-09-02 15:11:38', 0, 1002001015, '账号未登陆', '2019-09-02 15:11:38');
INSERT INTO `access_log` VALUES (74042, '65.3607.15674082982348213', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.45.9', '2019-09-02 15:11:38', 0, 1002001015, '账号未登陆', '2019-09-02 15:11:38');
INSERT INTO `access_log` VALUES (74043, '65.47.15674082999186365', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.45.9', '2019-09-02 15:11:40', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 15:11:40');
INSERT INTO `access_log` VALUES (74044, '65.49.15674083029756439', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.45.9', '2019-09-02 15:11:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 15:11:43');
INSERT INTO `access_log` VALUES (74045, '65.51.15674083035956465', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.45.9', '2019-09-02 15:11:44', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 15:11:44');
INSERT INTO `access_log` VALUES (74046, '59.77.15674083184302915', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:11:58', 4, 0, '', '2019-09-02 15:11:58');
INSERT INTO `access_log` VALUES (74047, '59.76.15674083184292917', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:11:58', 16, 2001001000, '服务端发生异常', '2019-09-02 15:11:58');
INSERT INTO `access_log` VALUES (74048, '65.46.15674083207186443', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.45.9', '2019-09-02 15:12:01', 88, 0, '', '2019-09-02 15:12:01');
INSERT INTO `access_log` VALUES (74049, '65.52.15674083211656471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.45.9', '2019-09-02 15:12:01', 10, 0, '', '2019-09-02 15:12:01');
INSERT INTO `access_log` VALUES (74050, '65.3607.15674083211668215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.45.9', '2019-09-02 15:12:01', 11, 2001001000, '服务端发生异常', '2019-09-02 15:12:01');
INSERT INTO `access_log` VALUES (74051, '65.45.15674083211706449', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.45.9', '2019-09-02 15:12:01', 9, 0, '', '2019-09-02 15:12:01');
INSERT INTO `access_log` VALUES (74052, '64.85.15674083234963357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:03', 10, 0, '', '2019-09-02 15:12:04');
INSERT INTO `access_log` VALUES (74053, '64.83.15674083236093333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:04', 3, 0, '', '2019-09-02 15:12:04');
INSERT INTO `access_log` VALUES (74054, '64.79.15674083280323339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:08', 2, 0, '', '2019-09-02 15:12:08');
INSERT INTO `access_log` VALUES (74055, '64.84.15674083281563335', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:08', 2, 0, '', '2019-09-02 15:12:08');
INSERT INTO `access_log` VALUES (74056, '64.77.15674083297653317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:10', 2, 0, '', '2019-09-02 15:12:10');
INSERT INTO `access_log` VALUES (74057, '64.78.15674083305043363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:11', 2, 0, '', '2019-09-02 15:12:11');
INSERT INTO `access_log` VALUES (74058, '59.74.15674083318072939', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:12', 2, 0, '', '2019-09-02 15:12:12');
INSERT INTO `access_log` VALUES (74059, '59.72.15674083318082927', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:12', 17, 2001001000, '服务端发生异常', '2019-09-02 15:12:12');
INSERT INTO `access_log` VALUES (74060, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:17', 15, 0, '', '2019-09-02 15:12:17');
INSERT INTO `access_log` VALUES (74061, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:17', 4, 0, '', '2019-09-02 15:12:17');
INSERT INTO `access_log` VALUES (74062, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:17', 19, 0, '', '2019-09-02 15:12:17');
INSERT INTO `access_log` VALUES (74063, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:17', 8, 0, '', '2019-09-02 15:12:17');
INSERT INTO `access_log` VALUES (74064, '64.76.15674083385423347', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:19', 7, 0, '', '2019-09-02 15:12:19');
INSERT INTO `access_log` VALUES (74065, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:26', 6, 0, '', '2019-09-02 15:12:26');
INSERT INTO `access_log` VALUES (74066, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:26', 4, 0, '', '2019-09-02 15:12:26');
INSERT INTO `access_log` VALUES (74067, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:26', 20, 0, '', '2019-09-02 15:12:26');
INSERT INTO `access_log` VALUES (74068, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:26', 14, 0, '', '2019-09-02 15:12:26');
INSERT INTO `access_log` VALUES (74069, '59.75.15674083471862933', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:27', 2, 0, '', '2019-09-02 15:12:27');
INSERT INTO `access_log` VALUES (74070, '59.78.15674083471862941', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:27', 42, 2001001000, '服务端发生异常', '2019-09-02 15:12:27');
INSERT INTO `access_log` VALUES (74071, '64.80.15674083481863339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:28', 2, 0, '', '2019-09-02 15:12:28');
INSERT INTO `access_log` VALUES (74072, '64.85.15674083484753359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:28', 1, 0, '', '2019-09-02 15:12:28');
INSERT INTO `access_log` VALUES (74073, '59.79.15674083492822931', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:29', 2, 0, '', '2019-09-02 15:12:29');
INSERT INTO `access_log` VALUES (74074, '59.80.15674083492822901', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '106.38.110.73', '2019-09-02 15:12:29', 13, 2001001000, '服务端发生异常', '2019-09-02 15:12:29');
INSERT INTO `access_log` VALUES (74075, '59.74.15674091450392951', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.45.9', '2019-09-02 15:25:45', 3, 0, '', '2019-09-02 15:25:45');
INSERT INTO `access_log` VALUES (74076, '59.72.15674091450392939', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.157.45.9', '2019-09-02 15:25:45', 24, 2001001000, '服务端发生异常', '2019-09-02 15:25:45');
INSERT INTO `access_log` VALUES (74077, '64.77.15674091626593329', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:03', 4, 0, '', '2019-09-02 15:26:03');
INSERT INTO `access_log` VALUES (74078, '64.78.15674091627753375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:03', 2, 0, '', '2019-09-02 15:26:03');
INSERT INTO `access_log` VALUES (74079, '64.76.15674091639963359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:04', 2, 0, '', '2019-09-02 15:26:04');
INSERT INTO `access_log` VALUES (74080, '64.81.15674091648103357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:05', 2, 0, '', '2019-09-02 15:26:05');
INSERT INTO `access_log` VALUES (74081, '64.80.15674091653533351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:05', 3, 0, '', '2019-09-02 15:26:05');
INSERT INTO `access_log` VALUES (74082, '64.83.15674091663073347', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:06', 2, 0, '', '2019-09-02 15:26:06');
INSERT INTO `access_log` VALUES (74083, '64.82.15674091667583365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:07', 2, 0, '', '2019-09-02 15:26:07');
INSERT INTO `access_log` VALUES (74084, '64.79.15674091671003353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:07', 2, 0, '', '2019-09-02 15:26:07');
INSERT INTO `access_log` VALUES (74085, '64.84.15674091713383349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:11', 2, 0, '', '2019-09-02 15:26:11');
INSERT INTO `access_log` VALUES (74086, '64.77.15674091714523331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:11', 1, 0, '', '2019-09-02 15:26:11');
INSERT INTO `access_log` VALUES (74087, '59.78.15674091770372953', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:17', 3, 0, '', '2019-09-02 15:26:17');
INSERT INTO `access_log` VALUES (74088, '59.80.15674091770382913', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:17', 14, 2001001000, '服务端发生异常', '2019-09-02 15:26:17');
INSERT INTO `access_log` VALUES (74089, '64.78.15674091794663377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:19', 2, 0, '', '2019-09-02 15:26:19');
INSERT INTO `access_log` VALUES (74090, '64.76.15674091795743361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:20', 2, 0, '', '2019-09-02 15:26:20');
INSERT INTO `access_log` VALUES (74091, '64.80.15674091808053353', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:21', 2, 0, '', '2019-09-02 15:26:21');
INSERT INTO `access_log` VALUES (74092, '64.85.15674091814113373', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:21', 2, 0, '', '2019-09-02 15:26:21');
INSERT INTO `access_log` VALUES (74093, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:21', 8, 0, '', '2019-09-02 15:26:21');
INSERT INTO `access_log` VALUES (74094, '64.83.15674091825993349', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:23', 7, 0, '', '2019-09-02 15:26:23');
INSERT INTO `access_log` VALUES (74095, '66.51.15674091909340365', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=2121&code=212', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码长度为 4-6 位\n账号长度为 11 位', '2019-09-02 15:26:31');
INSERT INTO `access_log` VALUES (74096, '64.82.15674091930673367', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:33', 6, 0, '', '2019-09-02 15:26:33');
INSERT INTO `access_log` VALUES (74097, '64.79.15674091935523355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:34', 2, 0, '', '2019-09-02 15:26:34');
INSERT INTO `access_log` VALUES (74098, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:34', 5, 0, '', '2019-09-02 15:26:34');
INSERT INTO `access_log` VALUES (74099, '64.84.15674091943143351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:34', 2, 0, '', '2019-09-02 15:26:34');
INSERT INTO `access_log` VALUES (74100, '64.77.15674091943843333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:34', 2, 0, '', '2019-09-02 15:26:34');
INSERT INTO `access_log` VALUES (74101, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=小米&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:41', 5, 0, '', '2019-09-02 15:26:41');
INSERT INTO `access_log` VALUES (74102, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=小米', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '180.157.45.9', '2019-09-02 15:26:41', 11, 0, '', '2019-09-02 15:26:41');
INSERT INTO `access_log` VALUES (74103, '65.46.15674094653676461', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:31:05', 11, 0, '', '2019-09-02 15:31:05');
INSERT INTO `access_log` VALUES (74104, '65.50.15674094653676439', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:31:05', 12, 2001001000, '服务端发生异常', '2019-09-02 15:31:05');
INSERT INTO `access_log` VALUES (74105, '65.3607.15674094653718231', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:31:05', 11, 0, '', '2019-09-02 15:31:05');
INSERT INTO `access_log` VALUES (74106, '65.53.15674094878496381', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:31:28', 10, 0, '', '2019-09-02 15:31:28');
INSERT INTO `access_log` VALUES (74107, '65.49.15674094878556457', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:31:28', 9, 0, '', '2019-09-02 15:31:28');
INSERT INTO `access_log` VALUES (74108, '65.54.15674094878546321', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.87 Safari/537.36', '180.169.59.217', '2019-09-02 15:31:28', 10, 2001001000, '服务端发生异常', '2019-09-02 15:31:28');
INSERT INTO `access_log` VALUES (74109, '59.73.15674101575382953', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:42:38', 2, 0, '', '2019-09-02 15:42:38');
INSERT INTO `access_log` VALUES (74110, '59.75.15674101575402959', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:42:38', 12, 2001001000, '服务端发生异常', '2019-09-02 15:42:38');
INSERT INTO `access_log` VALUES (74111, '59.78.15674107594552975', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:52:39', 3, 0, '', '2019-09-02 15:52:39');
INSERT INTO `access_log` VALUES (74112, '59.80.15674107594562935', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:52:39', 12, 2001001000, '服务端发生异常', '2019-09-02 15:52:39');
INSERT INTO `access_log` VALUES (74113, '64.81.15674107635303381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:52:44', 3, 0, '', '2019-09-02 15:52:44');
INSERT INTO `access_log` VALUES (74114, '64.85.15674107637153397', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:52:44', 2, 0, '', '2019-09-02 15:52:44');
INSERT INTO `access_log` VALUES (74115, '64.83.15674107647153371', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:52:45', 9, 0, '', '2019-09-02 15:52:45');
INSERT INTO `access_log` VALUES (74116, '64.82.15674107652753391', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:52:45', 2, 0, '', '2019-09-02 15:52:45');
INSERT INTO `access_log` VALUES (74117, '64.79.15674107658353379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:52:46', 2, 0, '', '2019-09-02 15:52:46');
INSERT INTO `access_log` VALUES (74118, '64.77.15674107665563357', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:52:47', 1, 0, '', '2019-09-02 15:52:47');
INSERT INTO `access_log` VALUES (74119, '64.84.15674107673853375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:52:47', 2, 0, '', '2019-09-02 15:52:47');
INSERT INTO `access_log` VALUES (74120, '64.78.15674107678353403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:52:48', 2, 0, '', '2019-09-02 15:52:48');
INSERT INTO `access_log` VALUES (74121, '65.51.15674107955486499', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:53:16', 1, 1002001015, '账号未登陆', '2019-09-02 15:53:16');
INSERT INTO `access_log` VALUES (74122, '65.47.15674107955496401', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:53:16', 1, 1002001015, '账号未登陆', '2019-09-02 15:53:16');
INSERT INTO `access_log` VALUES (74123, '65.45.15674107955496487', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:53:16', 0, 1002001015, '账号未登陆', '2019-09-02 15:53:16');
INSERT INTO `access_log` VALUES (74124, '65.53.15674108033776399', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:53:23', 104, 0, '', '2019-09-02 15:53:23');
INSERT INTO `access_log` VALUES (74125, '65.54.15674108038696339', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:53:24', 92, 0, '', '2019-09-02 15:53:24');
INSERT INTO `access_log` VALUES (74126, '65.52.15674108038776511', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:53:24', 86, 0, '', '2019-09-02 15:53:24');
INSERT INTO `access_log` VALUES (74127, '65.3607.15674108038698251', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:53:24', 95, 2001001000, '服务端发生异常', '2019-09-02 15:53:24');
INSERT INTO `access_log` VALUES (74128, '65.49.15674108107116477', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:53:31', 9, 0, '', '2019-09-02 15:53:31');
INSERT INTO `access_log` VALUES (74129, '65.46.15674108107786483', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:53:31', 10, 2001001000, '服务端发生异常', '2019-09-02 15:53:31');
INSERT INTO `access_log` VALUES (74130, '65.51.15674108107816501', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:53:31', 9, 0, '', '2019-09-02 15:53:31');
INSERT INTO `access_log` VALUES (74131, '65.45.15674108243296489', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:53:44', 9, 0, '', '2019-09-02 15:53:44');
INSERT INTO `access_log` VALUES (74132, '65.53.15674108243336401', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:53:44', 10, 2001001000, '服务端发生异常', '2019-09-02 15:53:44');
INSERT INTO `access_log` VALUES (74133, '65.50.15674108243376461', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:53:44', 9, 0, '', '2019-09-02 15:53:44');
INSERT INTO `access_log` VALUES (74134, '64.82.15674108338993393', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:53:54', 4, 0, '', '2019-09-02 15:53:54');
INSERT INTO `access_log` VALUES (74135, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=k&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:53:59', 5, 0, '', '2019-09-02 15:53:59');
INSERT INTO `access_log` VALUES (74136, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=k', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:53:59', 5, 0, '', '2019-09-02 15:53:59');
INSERT INTO `access_log` VALUES (74137, '65.3607.15674108443198253', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:54:04', 1, 1002001015, '账号未登陆', '2019-09-02 15:54:04');
INSERT INTO `access_log` VALUES (74138, '65.54.15674108443276341', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:54:04', 0, 1002001015, '账号未登陆', '2019-09-02 15:54:04');
INSERT INTO `access_log` VALUES (74139, '65.49.15674108443386479', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:54:04', 0, 1002001015, '账号未登陆', '2019-09-02 15:54:04');
INSERT INTO `access_log` VALUES (74140, '65.46.15674108473456485', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:54:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 15:54:07');
INSERT INTO `access_log` VALUES (74141, '65.47.15674108586946405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:54:19', 69, 0, '', '2019-09-02 15:54:19');
INSERT INTO `access_log` VALUES (74142, '65.50.15674108589966463', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:54:19', 9, 0, '', '2019-09-02 15:54:19');
INSERT INTO `access_log` VALUES (74143, '65.53.15674108589966403', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:54:19', 10, 2001001000, '服务端发生异常', '2019-09-02 15:54:19');
INSERT INTO `access_log` VALUES (74144, '65.45.15674108589976491', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:54:19', 10, 0, '', '2019-09-02 15:54:19');
INSERT INTO `access_log` VALUES (74145, '65.49.15674108686316481', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:54:29', 10, 0, '', '2019-09-02 15:54:29');
INSERT INTO `access_log` VALUES (74146, '65.3607.15674108686338255', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:54:29', 10, 2001001000, '服务端发生异常', '2019-09-02 15:54:29');
INSERT INTO `access_log` VALUES (74147, '65.54.15674108686376343', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:54:29', 9, 0, '', '2019-09-02 15:54:29');
INSERT INTO `access_log` VALUES (74148, '59.76.15674109447382955', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:55:45', 2, 0, '', '2019-09-02 15:55:45');
INSERT INTO `access_log` VALUES (74149, '59.71.15674109447392961', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:55:45', 14, 2001001000, '服务端发生异常', '2019-09-02 15:55:45');
INSERT INTO `access_log` VALUES (74150, '59.73.15674109512942965', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:55:51', 2, 0, '', '2019-09-02 15:55:51');
INSERT INTO `access_log` VALUES (74151, '59.72.15674109512942965', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:55:51', 18, 2001001000, '服务端发生异常', '2019-09-02 15:55:51');
INSERT INTO `access_log` VALUES (74152, '64.83.15674109558943375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:55:56', 2, 0, '', '2019-09-02 15:55:56');
INSERT INTO `access_log` VALUES (74153, '64.82.15674109560253395', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:55:56', 2, 0, '', '2019-09-02 15:55:56');
INSERT INTO `access_log` VALUES (74154, '64.79.15674109577413383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:55:58', 2, 0, '', '2019-09-02 15:55:58');
INSERT INTO `access_log` VALUES (74155, '64.77.15674109583643361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '59.173.241.166', '2019-09-02 15:55:58', 2, 0, '', '2019-09-02 15:55:58');
INSERT INTO `access_log` VALUES (74156, '64.78.15674109723463407', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:56:12', 2, 0, '', '2019-09-02 15:56:12');
INSERT INTO `access_log` VALUES (74157, '64.76.15674109725763389', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:56:13', 1, 0, '', '2019-09-02 15:56:13');
INSERT INTO `access_log` VALUES (74158, '59.79.15674109992262969', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:56:39', 3, 0, '', '2019-09-02 15:56:39');
INSERT INTO `access_log` VALUES (74159, '59.77.15674109993022955', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.0.222', '2019-09-02 15:56:39', 13, 2001001000, '服务端发生异常', '2019-09-02 15:56:39');
INSERT INTO `access_log` VALUES (74160, '65.3607.15674111329948259', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:58:53', 10, 0, '', '2019-09-02 15:58:53');
INSERT INTO `access_log` VALUES (74161, '65.54.15674111333946347', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:58:53', 11, 2001001000, '服务端发生异常', '2019-09-02 15:58:53');
INSERT INTO `access_log` VALUES (74162, '65.49.15674111334086485', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.119.175.23', '2019-09-02 15:58:53', 10, 0, '', '2019-09-02 15:58:53');
INSERT INTO `access_log` VALUES (74163, '65.53.15674132712366437', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.198.101.133', '2019-09-02 16:34:31', 1, 1002001015, '账号未登陆', '2019-09-02 16:34:31');
INSERT INTO `access_log` VALUES (74164, '65.45.15674132712366525', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.198.101.133', '2019-09-02 16:34:31', 0, 1002001015, '账号未登陆', '2019-09-02 16:34:31');
INSERT INTO `access_log` VALUES (74165, '65.50.15674132712446497', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.198.101.133', '2019-09-02 16:34:31', 2, 1002001015, '账号未登陆', '2019-09-02 16:34:31');
INSERT INTO `access_log` VALUES (74166, '65.52.15674132789346549', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.198.101.133', '2019-09-02 16:34:39', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 16:34:39');
INSERT INTO `access_log` VALUES (74167, '65.54.15674132877856377', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.198.101.133', '2019-09-02 16:34:48', 89, 0, '', '2019-09-02 16:34:48');
INSERT INTO `access_log` VALUES (74168, '65.51.15674132884356539', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.198.101.133', '2019-09-02 16:34:48', 13, 0, '', '2019-09-02 16:34:48');
INSERT INTO `access_log` VALUES (74169, '65.49.15674132884346515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.198.101.133', '2019-09-02 16:34:48', 12, 0, '', '2019-09-02 16:34:48');
INSERT INTO `access_log` VALUES (74170, '65.46.15674132884356521', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '111.198.101.133', '2019-09-02 16:34:48', 14, 2001001000, '服务端发生异常', '2019-09-02 16:34:48');
INSERT INTO `access_log` VALUES (74171, '59.80.15674135129552973', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.136.38.137', '2019-09-02 16:38:33', 13, 0, '', '2019-09-02 16:38:33');
INSERT INTO `access_log` VALUES (74172, '59.79.15674135129603003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.136.38.137', '2019-09-02 16:38:33', 15, 2001001000, '服务端发生异常', '2019-09-02 16:38:33');
INSERT INTO `access_log` VALUES (74173, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=1111&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.136.38.137', '2019-09-02 16:38:41', 6, 0, '', '2019-09-02 16:38:41');
INSERT INTO `access_log` VALUES (74174, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=1111', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.136.38.137', '2019-09-02 16:38:41', 5, 0, '', '2019-09-02 16:38:41');
INSERT INTO `access_log` VALUES (74175, '59.71.15674147295153013', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.77.45.139', '2019-09-02 16:58:50', 5, 0, '', '2019-09-02 16:58:50');
INSERT INTO `access_log` VALUES (74176, '59.74.15674147295153029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.77.45.139', '2019-09-02 16:58:50', 40, 2001001000, '服务端发生异常', '2019-09-02 16:58:50');
INSERT INTO `access_log` VALUES (74177, '64.81.15674147409093437', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.77.45.139', '2019-09-02 16:59:01', 12, 0, '', '2019-09-02 16:59:01');
INSERT INTO `access_log` VALUES (74178, '64.85.15674147410183453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.77.45.139', '2019-09-02 16:59:01', 3, 0, '', '2019-09-02 16:59:01');
INSERT INTO `access_log` VALUES (74179, '64.82.15674147458093447', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.77.45.139', '2019-09-02 16:59:06', 2, 0, '', '2019-09-02 16:59:06');
INSERT INTO `access_log` VALUES (74180, '64.79.15674147459053435', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.77.45.139', '2019-09-02 16:59:06', 2, 0, '', '2019-09-02 16:59:06');
INSERT INTO `access_log` VALUES (74181, '59.73.15674147575363017', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.77.45.139', '2019-09-02 16:59:18', 2, 0, '', '2019-09-02 16:59:18');
INSERT INTO `access_log` VALUES (74182, '59.75.15674147575403023', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.77.45.139', '2019-09-02 16:59:18', 14, 2001001000, '服务端发生异常', '2019-09-02 16:59:18');
INSERT INTO `access_log` VALUES (74183, '59.72.15674178501473059', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.80.141.54', '2019-09-02 17:50:50', 13, 0, '', '2019-09-02 17:50:50');
INSERT INTO `access_log` VALUES (74184, '59.73.15674178501493059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '125.80.141.54', '2019-09-02 17:50:50', 15, 2001001000, '服务端发生异常', '2019-09-02 17:50:50');
INSERT INTO `access_log` VALUES (74185, '59.76.15674185099153059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.64.103', '2019-09-02 18:01:50', 15, 2001001000, '服务端发生异常', '2019-09-02 18:01:50');
INSERT INTO `access_log` VALUES (74186, '59.77.15674185099013057', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.64.103', '2019-09-02 18:01:50', 161, 0, '', '2019-09-02 18:01:50');
INSERT INTO `access_log` VALUES (74187, '64.84.15674185159653481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.64.103', '2019-09-02 18:01:56', 13, 0, '', '2019-09-02 18:01:56');
INSERT INTO `access_log` VALUES (74188, '64.78.15674185160683509', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '116.24.64.103', '2019-09-02 18:01:56', 3, 0, '', '2019-09-02 18:01:56');
INSERT INTO `access_log` VALUES (74189, '65.50.15674196790086587', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.203.79.200', '2019-09-02 18:21:19', 1, 1002001015, '账号未登陆', '2019-09-02 18:21:19');
INSERT INTO `access_log` VALUES (74190, '65.53.15674196790076527', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.203.79.200', '2019-09-02 18:21:19', 1, 1002001015, '账号未登陆', '2019-09-02 18:21:19');
INSERT INTO `access_log` VALUES (74191, '65.3607.15674196790268379', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.203.79.200', '2019-09-02 18:21:19', 0, 1002001015, '账号未登陆', '2019-09-02 18:21:19');
INSERT INTO `access_log` VALUES (74192, '65.52.15674196812096637', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.203.79.200', '2019-09-02 18:21:21', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 18:21:21');
INSERT INTO `access_log` VALUES (74193, '59.76.15674197031253075', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.203.79.200', '2019-09-02 18:21:43', 3, 0, '', '2019-09-02 18:21:43');
INSERT INTO `access_log` VALUES (74194, '59.71.15674197031273081', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.203.79.200', '2019-09-02 18:21:43', 18, 2001001000, '服务端发生异常', '2019-09-02 18:21:43');
INSERT INTO `access_log` VALUES (74195, '65.46.15674197198126611', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.203.79.200', '2019-09-02 18:22:00', 162, 0, '', '2019-09-02 18:22:00');
INSERT INTO `access_log` VALUES (74196, '65.45.15674197203276613', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.203.79.200', '2019-09-02 18:22:00', 14, 0, '', '2019-09-02 18:22:00');
INSERT INTO `access_log` VALUES (74197, '65.47.15674197203316529', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.203.79.200', '2019-09-02 18:22:00', 12, 2001001000, '服务端发生异常', '2019-09-02 18:22:00');
INSERT INTO `access_log` VALUES (74198, '65.3607.15674197203368381', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '111.203.79.200', '2019-09-02 18:22:00', 11, 0, '', '2019-09-02 18:22:00');
INSERT INTO `access_log` VALUES (74199, '59.78.15674200622353103', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.35.101.10', '2019-09-02 18:27:42', 2, 0, '', '2019-09-02 18:27:42');
INSERT INTO `access_log` VALUES (74200, '59.79.15674200622393093', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.35.101.10', '2019-09-02 18:27:42', 15, 2001001000, '服务端发生异常', '2019-09-02 18:27:42');
INSERT INTO `access_log` VALUES (74201, '64.85.15674200650863525', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.35.101.10', '2019-09-02 18:27:45', 3, 0, '', '2019-09-02 18:27:45');
INSERT INTO `access_log` VALUES (74202, '64.83.15674200652273499', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.35.101.10', '2019-09-02 18:27:45', 2, 0, '', '2019-09-02 18:27:45');
INSERT INTO `access_log` VALUES (74203, '59.77.15674200667093079', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.35.101.10', '2019-09-02 18:27:47', 2, 0, '', '2019-09-02 18:27:47');
INSERT INTO `access_log` VALUES (74204, '59.80.15674200667093063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.35.101.10', '2019-09-02 18:27:47', 12, 2001001000, '服务端发生异常', '2019-09-02 18:27:47');
INSERT INTO `access_log` VALUES (74205, '65.54.15674200725006471', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.35.101.10', '2019-09-02 18:27:53', 1, 1002001015, '账号未登陆', '2019-09-02 18:27:53');
INSERT INTO `access_log` VALUES (74206, '65.51.15674200725016631', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.35.101.10', '2019-09-02 18:27:53', 1, 1002001015, '账号未登陆', '2019-09-02 18:27:53');
INSERT INTO `access_log` VALUES (74207, '65.49.15674200725026605', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.35.101.10', '2019-09-02 18:27:53', 0, 1002001015, '账号未登陆', '2019-09-02 18:27:53');
INSERT INTO `access_log` VALUES (74208, '65.45.15674200783006619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.35.101.10', '2019-09-02 18:27:58', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 18:27:58');
INSERT INTO `access_log` VALUES (74209, '65.47.15674200808556535', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.35.101.10', '2019-09-02 18:28:01', 112, 0, '', '2019-09-02 18:28:01');
INSERT INTO `access_log` VALUES (74210, '65.3607.15674200812198387', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.35.101.10', '2019-09-02 18:28:01', 9, 0, '', '2019-09-02 18:28:01');
INSERT INTO `access_log` VALUES (74211, '65.53.15674200812196535', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.35.101.10', '2019-09-02 18:28:01', 11, 2001001000, '服务端发生异常', '2019-09-02 18:28:01');
INSERT INTO `access_log` VALUES (74212, '65.50.15674200812246595', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '121.35.101.10', '2019-09-02 18:28:01', 10, 0, '', '2019-09-02 18:28:01');
INSERT INTO `access_log` VALUES (74213, '59.76.15674221590023109', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.116.56.89', '2019-09-02 19:02:39', 15, 0, '', '2019-09-02 19:02:39');
INSERT INTO `access_log` VALUES (74214, '59.71.15674221590033115', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '113.116.56.89', '2019-09-02 19:02:39', 15, 2001001000, '服务端发生异常', '2019-09-02 19:02:39');
INSERT INTO `access_log` VALUES (74215, '59.71.15674252799123157', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.236.75.206', '2019-09-02 19:54:40', 10, 0, '', '2019-09-02 19:54:40');
INSERT INTO `access_log` VALUES (74216, '59.76.15674252799123151', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.236.75.206', '2019-09-02 19:54:40', 15, 2001001000, '服务端发生异常', '2019-09-02 19:54:40');
INSERT INTO `access_log` VALUES (74217, '64.85.15674252875483595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.236.75.206', '2019-09-02 19:54:48', 22, 0, '', '2019-09-02 19:54:48');
INSERT INTO `access_log` VALUES (74218, '64.83.15674252878513569', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.236.75.206', '2019-09-02 19:54:48', 3, 0, '', '2019-09-02 19:54:48');
INSERT INTO `access_log` VALUES (74219, '64.79.15674252953283577', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.236.75.206', '2019-09-02 19:54:55', 2, 0, '', '2019-09-02 19:54:55');
INSERT INTO `access_log` VALUES (74220, '64.77.15674252954583555', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.236.75.206', '2019-09-02 19:54:55', 2, 0, '', '2019-09-02 19:54:55');
INSERT INTO `access_log` VALUES (74221, '64.84.15674252968663573', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.236.75.206', '2019-09-02 19:54:57', 2, 0, '', '2019-09-02 19:54:57');
INSERT INTO `access_log` VALUES (74222, '59.72.15674252983033161', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.236.75.206', '2019-09-02 19:54:58', 3, 0, '', '2019-09-02 19:54:58');
INSERT INTO `access_log` VALUES (74223, '59.73.15674252983033161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.236.75.206', '2019-09-02 19:54:58', 10, 2001001000, '服务端发生异常', '2019-09-02 19:54:58');
INSERT INTO `access_log` VALUES (74224, '64.78.15674253043523601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.236.75.206', '2019-09-02 19:55:04', 2, 0, '', '2019-09-02 19:55:04');
INSERT INTO `access_log` VALUES (74225, '64.76.15674253044383583', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.236.75.206', '2019-09-02 19:55:04', 2, 0, '', '2019-09-02 19:55:04');
INSERT INTO `access_log` VALUES (74226, '59.78.15674253055323175', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.236.75.206', '2019-09-02 19:55:06', 2, 0, '', '2019-09-02 19:55:06');
INSERT INTO `access_log` VALUES (74227, '59.79.15674253055333165', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '116.236.75.206', '2019-09-02 19:55:06', 9, 2001001000, '服务端发生异常', '2019-09-02 19:55:06');
INSERT INTO `access_log` VALUES (74228, '65.54.15674253417116543', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.75.206', '2019-09-02 19:55:42', 0, 1002001015, '账号未登陆', '2019-09-02 19:55:42');
INSERT INTO `access_log` VALUES (74229, '65.51.15674253417146703', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.75.206', '2019-09-02 19:55:42', 0, 1002001015, '账号未登陆', '2019-09-02 19:55:42');
INSERT INTO `access_log` VALUES (74230, '65.49.15674253417146677', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.75.206', '2019-09-02 19:55:42', 0, 1002001015, '账号未登陆', '2019-09-02 19:55:42');
INSERT INTO `access_log` VALUES (74231, '65.46.15674253484946689', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.75.206', '2019-09-02 19:55:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 19:55:49');
INSERT INTO `access_log` VALUES (74232, '65.3607.15674253872268459', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.75.206', '2019-09-02 19:56:27', 108, 0, '', '2019-09-02 19:56:27');
INSERT INTO `access_log` VALUES (74233, '65.50.15674253877556667', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.75.206', '2019-09-02 19:56:28', 10, 0, '', '2019-09-02 19:56:28');
INSERT INTO `access_log` VALUES (74234, '65.52.15674253877636717', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.75.206', '2019-09-02 19:56:28', 9, 2001001000, '服务端发生异常', '2019-09-02 19:56:28');
INSERT INTO `access_log` VALUES (74235, '65.51.15674253877726705', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.236.75.206', '2019-09-02 19:56:28', 9, 0, '', '2019-09-02 19:56:28');
INSERT INTO `access_log` VALUES (74236, '62.84.15674261930071723', 0, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:09:53', 13, 1002001012, '访问令牌已过期', '2019-09-02 20:09:53');
INSERT INTO `access_log` VALUES (74237, '65.47.15674261950936619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:09:55', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 20:09:55');
INSERT INTO `access_log` VALUES (74238, '65.53.15674262056556619', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:10:06', 240, 0, '', '2019-09-02 20:10:06');
INSERT INTO `access_log` VALUES (74239, '65.3607.15674262061688471', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:10:06', 15, 0, '', '2019-09-02 20:10:06');
INSERT INTO `access_log` VALUES (74240, '65.50.15674262061726679', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:10:06', 14, 0, '', '2019-09-02 20:10:06');
INSERT INTO `access_log` VALUES (74241, '65.51.15674262061736717', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:10:06', 13, 0, '', '2019-09-02 20:10:06');
INSERT INTO `access_log` VALUES (74242, '65.49.15674262143296691', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:10:14', 24, 0, '', '2019-09-02 20:10:14');
INSERT INTO `access_log` VALUES (74243, '65.46.15674262339856703', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:10:34', 26, 0, '', '2019-09-02 20:10:34');
INSERT INTO `access_log` VALUES (74244, '65.47.15674262439326621', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:10:44', 14, 0, '', '2019-09-02 20:10:44');
INSERT INTO `access_log` VALUES (74245, '65.53.15674262511256621', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:10:51', 7, 0, '', '2019-09-02 20:10:51');
INSERT INTO `access_log` VALUES (74246, '65.3607.15674262590868473', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:10:59', 13, 0, '', '2019-09-02 20:10:59');
INSERT INTO `access_log` VALUES (74247, '65.52.15674262771066731', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:11:17', 19, 0, '', '2019-09-02 20:11:17');
INSERT INTO `access_log` VALUES (74248, '65.49.15674262781876693', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:11:18', 8, 0, '', '2019-09-02 20:11:18');
INSERT INTO `access_log` VALUES (74249, '65.54.15674262795046559', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:11:20', 10, 0, '', '2019-09-02 20:11:20');
INSERT INTO `access_log` VALUES (74250, '59.72.15674262828423175', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:11:23', 16, 0, '', '2019-09-02 20:11:23');
INSERT INTO `access_log` VALUES (74251, '59.73.15674262893893175', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:11:29', 23, 2001001000, '服务端发生异常', '2019-09-02 20:11:29');
INSERT INTO `access_log` VALUES (74252, '66.57.15674262968390573', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:11:37', 482, 0, '', '2019-09-02 20:11:37');
INSERT INTO `access_log` VALUES (74253, '65.53.15674263256666623', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:12:06', 18, 0, '', '2019-09-02 20:12:06');
INSERT INTO `access_log` VALUES (74254, '65.50.15674263475906683', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:12:28', 19, 0, '', '2019-09-02 20:12:28');
INSERT INTO `access_log` VALUES (74255, '65.52.15674263555096733', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:12:36', 17, 0, '', '2019-09-02 20:12:36');
INSERT INTO `access_log` VALUES (74256, '65.54.15674263682426561', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:12:48', 18, 0, '', '2019-09-02 20:12:48');
INSERT INTO `access_log` VALUES (74257, '65.50.15674264492616685', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:14:09', 19, 0, '', '2019-09-02 20:14:09');
INSERT INTO `access_log` VALUES (74258, '65.52.15674264630546735', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:14:23', 8, 0, '', '2019-09-02 20:14:23');
INSERT INTO `access_log` VALUES (74259, '65.45.15674265048966711', 1, 2, 'admin-application', '/admin-api/admins/role/add', 'name=测试', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:15:05', 60, 0, '', '2019-09-02 20:15:05');
INSERT INTO `access_log` VALUES (74260, '65.47.15674265052136627', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:15:05', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-09-02 20:15:05');
INSERT INTO `access_log` VALUES (74261, '65.51.15674265140946725', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:15:14', 9, 0, '', '2019-09-02 20:15:14');
INSERT INTO `access_log` VALUES (74262, '65.52.15674277631166755', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:36:03', 18, 0, '', '2019-09-02 20:36:03');
INSERT INTO `access_log` VALUES (74263, '65.54.15674277736526581', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:36:14', 10, 0, '', '2019-09-02 20:36:14');
INSERT INTO `access_log` VALUES (74264, '65.3607.15674277753468497', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:36:15', 10, 0, '', '2019-09-02 20:36:15');
INSERT INTO `access_log` VALUES (74265, '65.49.15674280261226719', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:40:26', 21, 0, '', '2019-09-02 20:40:26');
INSERT INTO `access_log` VALUES (74266, '65.54.15674280283106585', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=9', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:40:28', 8, 0, '', '2019-09-02 20:40:28');
INSERT INTO `access_log` VALUES (74267, '65.3607.15674280318948501', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:40:32', 10, 0, '', '2019-09-02 20:40:32');
INSERT INTO `access_log` VALUES (74268, '65.46.15674280347626731', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=9', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:40:35', 12, 0, '', '2019-09-02 20:40:35');
INSERT INTO `access_log` VALUES (74269, '65.53.15674280466236649', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.84.138', '2019-09-02 20:40:47', 9, 0, '', '2019-09-02 20:40:47');
INSERT INTO `access_log` VALUES (74270, '59.80.15674342742973255', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '117.136.45.142', '2019-09-02 22:24:34', 10, 0, '', '2019-09-02 22:24:34');
INSERT INTO `access_log` VALUES (74271, '59.77.15674342743183271', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '117.136.45.142', '2019-09-02 22:24:34', 12, 2001001000, '服务端发生异常', '2019-09-02 22:24:34');
INSERT INTO `access_log` VALUES (74272, '65.50.15674347686246799', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:32:49', 5, 1002001012, '访问令牌已过期', '2019-09-02 22:32:49');
INSERT INTO `access_log` VALUES (74273, '65.47.15674347686246739', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:32:49', 4, 1002001012, '访问令牌已过期', '2019-09-02 22:32:49');
INSERT INTO `access_log` VALUES (74274, '65.46.15674347686256823', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:32:49', 7, 1002001012, '访问令牌已过期', '2019-09-02 22:32:49');
INSERT INTO `access_log` VALUES (74275, '65.49.15674347724026809', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:32:52', 108, 0, '', '2019-09-02 22:32:53');
INSERT INTO `access_log` VALUES (74276, '65.52.15674347731096853', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:32:53', 19, 0, '', '2019-09-02 22:32:53');
INSERT INTO `access_log` VALUES (74277, '65.54.15674347731096677', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:32:53', 20, 0, '', '2019-09-02 22:32:53');
INSERT INTO `access_log` VALUES (74278, '65.45.15674347731096827', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:32:53', 20, 0, '', '2019-09-02 22:32:53');
INSERT INTO `access_log` VALUES (74279, '64.85.15674347836783723', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:33:04', 19, 0, '', '2019-09-02 22:33:04');
INSERT INTO `access_log` VALUES (74280, '64.79.15674347892423705', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:33:09', 15, 0, '', '2019-09-02 22:33:09');
INSERT INTO `access_log` VALUES (74281, '64.82.15674347892423717', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:33:09', 20, 0, '', '2019-09-02 22:33:09');
INSERT INTO `access_log` VALUES (74282, '65.53.15674349165386741', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:35:17', 9, 0, '', '2019-09-02 22:35:17');
INSERT INTO `access_log` VALUES (74283, '65.3607.15674349180998595', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:35:18', 19, 0, '', '2019-09-02 22:35:18');
INSERT INTO `access_log` VALUES (74284, '65.51.15674349201076845', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:35:20', 9, 0, '', '2019-09-02 22:35:20');
INSERT INTO `access_log` VALUES (74285, '65.47.15674349209406743', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:35:21', 14, 0, '', '2019-09-02 22:35:21');
INSERT INTO `access_log` VALUES (74286, '59.75.15674349346703297', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:35:35', 4, 0, '', '2019-09-02 22:35:35');
INSERT INTO `access_log` VALUES (74287, '59.73.15674349346703291', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:35:35', 17, 2001001000, '服务端发生异常', '2019-09-02 22:35:35');
INSERT INTO `access_log` VALUES (74288, '59.78.15674349415493305', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:35:42', 2, 0, '', '2019-09-02 22:35:42');
INSERT INTO `access_log` VALUES (74289, '59.79.15674349415503295', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:35:42', 11, 2001001000, '服务端发生异常', '2019-09-02 22:35:42');
INSERT INTO `access_log` VALUES (74290, '62.85.15674349459491877', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:35:46', 51, 0, '', '2019-09-02 22:35:46');
INSERT INTO `access_log` VALUES (74291, '65.49.15674349496516813', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:35:50', 0, 1002001015, '账号未登陆', '2019-09-02 22:35:50');
INSERT INTO `access_log` VALUES (74292, '65.54.15674349496566681', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:35:50', 0, 1002001015, '账号未登陆', '2019-09-02 22:35:50');
INSERT INTO `access_log` VALUES (74293, '65.45.15674349496616831', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:35:50', 0, 1002001015, '账号未登陆', '2019-09-02 22:35:50');
INSERT INTO `access_log` VALUES (74294, '65.3607.15674349716438597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:36:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 22:36:12');
INSERT INTO `access_log` VALUES (74295, '65.51.15674349825296847', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:36:23', 82, 0, '', '2019-09-02 22:36:23');
INSERT INTO `access_log` VALUES (74296, '65.46.15674349829676829', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:36:23', 8, 0, '', '2019-09-02 22:36:23');
INSERT INTO `access_log` VALUES (74297, '65.47.15674349829506745', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:36:23', 123, 0, '', '2019-09-02 22:36:23');
INSERT INTO `access_log` VALUES (74298, '65.50.15674349829666805', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:36:23', 111, 2001001000, '服务端发生异常', '2019-09-02 22:36:23');
INSERT INTO `access_log` VALUES (74299, '65.54.15674349957686683', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:36:36', 10, 0, '', '2019-09-02 22:36:36');
INSERT INTO `access_log` VALUES (74300, '65.45.15674349957736833', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:36:36', 8, 0, '', '2019-09-02 22:36:36');
INSERT INTO `access_log` VALUES (74301, '65.52.15674349957756859', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:36:36', 9, 2001001000, '服务端发生异常', '2019-09-02 22:36:36');
INSERT INTO `access_log` VALUES (74302, '59.72.15674350182173293', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:36:58', 3, 0, '', '2019-09-02 22:36:58');
INSERT INTO `access_log` VALUES (74303, '59.75.15674350182193299', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '211.137.127.218', '2019-09-02 22:36:58', 13, 2001001000, '服务端发生异常', '2019-09-02 22:36:58');
INSERT INTO `access_log` VALUES (74304, '65.53.15674354380846751', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.46.128.8', '2019-09-02 22:43:58', 0, 1002001015, '账号未登陆', '2019-09-02 22:43:58');
INSERT INTO `access_log` VALUES (74305, '65.3607.15674354381018605', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.46.128.8', '2019-09-02 22:43:58', 1, 1002001015, '账号未登陆', '2019-09-02 22:43:58');
INSERT INTO `access_log` VALUES (74306, '65.51.15674354381216855', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.46.128.8', '2019-09-02 22:43:58', 1, 1002001015, '账号未登陆', '2019-09-02 22:43:58');
INSERT INTO `access_log` VALUES (74307, '64.81.15674354513763717', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:44:11', 12, 0, '', '2019-09-02 22:44:11');
INSERT INTO `access_log` VALUES (74308, '64.80.15674354513743709', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:44:11', 17, 0, '', '2019-09-02 22:44:11');
INSERT INTO `access_log` VALUES (74309, '65.50.15674354539736813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.46.128.8', '2019-09-02 22:44:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 22:44:14');
INSERT INTO `access_log` VALUES (74310, '64.83.15674354544093707', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:44:14', 17, 0, '', '2019-09-02 22:44:14');
INSERT INTO `access_log` VALUES (74311, '64.85.15674354544093733', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:44:14', 19, 0, '', '2019-09-02 22:44:14');
INSERT INTO `access_log` VALUES (74312, '64.79.15674354575393715', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:44:18', 11, 0, '', '2019-09-02 22:44:18');
INSERT INTO `access_log` VALUES (74313, '64.82.15674354582323727', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-02 22:44:18', 11, 0, '', '2019-09-02 22:44:18');
INSERT INTO `access_log` VALUES (74314, '65.49.15674354682836823', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.46.128.8', '2019-09-02 22:44:28', 260, 0, '', '2019-09-02 22:44:29');
INSERT INTO `access_log` VALUES (74315, '65.45.15674354691116841', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.46.128.8', '2019-09-02 22:44:29', 84, 0, '', '2019-09-02 22:44:29');
INSERT INTO `access_log` VALUES (74316, '65.52.15674354691356867', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.46.128.8', '2019-09-02 22:44:29', 61, 0, '', '2019-09-02 22:44:29');
INSERT INTO `access_log` VALUES (74317, '65.54.15674354691236691', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.46.128.8', '2019-09-02 22:44:29', 73, 2001001000, '服务端发生异常', '2019-09-02 22:44:29');
INSERT INTO `access_log` VALUES (74318, '65.54.15674357325816695', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.206.13.112', '2019-09-02 22:48:53', 1, 1002001015, '账号未登陆', '2019-09-02 22:48:53');
INSERT INTO `access_log` VALUES (74319, '65.52.15674357325816871', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.206.13.112', '2019-09-02 22:48:53', 0, 1002001015, '账号未登陆', '2019-09-02 22:48:53');
INSERT INTO `access_log` VALUES (74320, '65.45.15674357325816845', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.206.13.112', '2019-09-02 22:48:53', 0, 1002001015, '账号未登陆', '2019-09-02 22:48:53');
INSERT INTO `access_log` VALUES (74321, '65.53.15674357467806757', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.206.13.112', '2019-09-02 22:49:07', 76, 0, '', '2019-09-02 22:49:07');
INSERT INTO `access_log` VALUES (74322, '65.51.15674357472836861', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.206.13.112', '2019-09-02 22:49:07', 10, 0, '', '2019-09-02 22:49:07');
INSERT INTO `access_log` VALUES (74323, '65.46.15674357472906843', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.206.13.112', '2019-09-02 22:49:07', 10, 2001001000, '服务端发生异常', '2019-09-02 22:49:07');
INSERT INTO `access_log` VALUES (74324, '65.50.15674357472986819', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '101.206.13.112', '2019-09-02 22:49:07', 8, 0, '', '2019-09-02 22:49:07');
INSERT INTO `access_log` VALUES (74325, '65.3607.15674365739008623', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.46.128.8', '2019-09-02 23:02:54', 10, 0, '', '2019-09-02 23:02:54');
INSERT INTO `access_log` VALUES (74326, '65.53.15674365739156769', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.46.128.8', '2019-09-02 23:02:54', 17, 2001001000, '服务端发生异常', '2019-09-02 23:02:54');
INSERT INTO `access_log` VALUES (74327, '65.46.15674365739276855', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.46.128.8', '2019-09-02 23:02:54', 9, 0, '', '2019-09-02 23:02:54');
INSERT INTO `access_log` VALUES (74328, '65.50.15674365779056831', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.46.128.8', '2019-09-02 23:02:58', 9, 0, '', '2019-09-02 23:02:58');
INSERT INTO `access_log` VALUES (74329, '65.47.15674365779126771', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.46.128.8', '2019-09-02 23:02:58', 9, 2001001000, '服务端发生异常', '2019-09-02 23:02:58');
INSERT INTO `access_log` VALUES (74330, '65.49.15674365779216841', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '27.46.128.8', '2019-09-02 23:02:58', 8, 0, '', '2019-09-02 23:02:58');
INSERT INTO `access_log` VALUES (74331, '65.47.15674391046866805', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:45:05', 13, 1002001012, '访问令牌已过期', '2019-09-02 23:45:05');
INSERT INTO `access_log` VALUES (74332, '65.49.15674391071636875', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:45:07', 89, 0, '', '2019-09-02 23:45:07');
INSERT INTO `access_log` VALUES (74333, '65.45.15674391077376893', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:45:08', 88, 0, '', '2019-09-02 23:45:08');
INSERT INTO `access_log` VALUES (74334, '65.52.15674391077436919', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:45:08', 84, 0, '', '2019-09-02 23:45:08');
INSERT INTO `access_log` VALUES (74335, '65.54.15674391077426743', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:45:08', 86, 0, '', '2019-09-02 23:45:08');
INSERT INTO `access_log` VALUES (74336, '65.3607.15674391157638659', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:45:16', 18, 0, '', '2019-09-02 23:45:16');
INSERT INTO `access_log` VALUES (74337, '65.53.15674391300536805', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:45:30', 9, 0, '', '2019-09-02 23:45:30');
INSERT INTO `access_log` VALUES (74338, '65.50.15674391354366867', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:45:35', 11, 0, '', '2019-09-02 23:45:35');
INSERT INTO `access_log` VALUES (74339, '65.47.15674391379786807', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:45:38', 13, 0, '', '2019-09-02 23:45:38');
INSERT INTO `access_log` VALUES (74340, '65.54.15674391527226745', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:45:53', 9, 0, '', '2019-09-02 23:45:53');
INSERT INTO `access_log` VALUES (74341, '65.46.15674391990856893', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:46:39', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-02 23:46:39');
INSERT INTO `access_log` VALUES (74342, '65.50.15674392198396869', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:47:00', 107, 0, '', '2019-09-02 23:47:00');
INSERT INTO `access_log` VALUES (74343, '65.47.15674392201826809', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:47:00', 8, 0, '', '2019-09-02 23:47:00');
INSERT INTO `access_log` VALUES (74344, '65.49.15674392202056879', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:47:00', 9, 0, '', '2019-09-02 23:47:00');
INSERT INTO `access_log` VALUES (74345, '65.54.15674392202066747', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-02 23:47:00', 8, 0, '', '2019-09-02 23:47:00');
INSERT INTO `access_log` VALUES (74346, '59.71.15674392983603347', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '1.180.239.132', '2019-09-02 23:48:18', 10, 0, '', '2019-09-02 23:48:18');
INSERT INTO `access_log` VALUES (74347, '59.76.15674392983673341', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '1.180.239.132', '2019-09-02 23:48:18', 10, 2001001000, '服务端发生异常', '2019-09-02 23:48:18');
INSERT INTO `access_log` VALUES (74348, '64.85.15674393034313785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '1.180.239.132', '2019-09-02 23:48:23', 20, 0, '', '2019-09-02 23:48:23');
INSERT INTO `access_log` VALUES (74349, '64.79.15674393036013767', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '1.180.239.132', '2019-09-02 23:48:24', 3, 0, '', '2019-09-02 23:48:24');
INSERT INTO `access_log` VALUES (74350, '65.50.15674447070686943', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.67', '2019-09-03 01:18:27', 1, 1002001015, '账号未登陆', '2019-09-03 01:18:27');
INSERT INTO `access_log` VALUES (74351, '65.47.15674447070886883', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.5', '2019-09-03 01:18:27', 0, 1002001015, '账号未登陆', '2019-09-03 01:18:27');
INSERT INTO `access_log` VALUES (74352, '65.54.15674447071096821', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.68', '2019-09-03 01:18:27', 1, 1002001015, '账号未登陆', '2019-09-03 01:18:27');
INSERT INTO `access_log` VALUES (74353, '65.45.15674447375346971', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.68', '2019-09-03 01:18:58', 0, 1002001015, '账号未登陆', '2019-09-03 01:18:58');
INSERT INTO `access_log` VALUES (74354, '65.51.15674447376186987', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.3', '2019-09-03 01:18:58', 0, 1002001015, '账号未登陆', '2019-09-03 01:18:58');
INSERT INTO `access_log` VALUES (74355, '65.3607.15674447376398737', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.68', '2019-09-03 01:18:58', 0, 1002001015, '账号未登陆', '2019-09-03 01:18:58');
INSERT INTO `access_log` VALUES (74356, '59.79.15674447707373427', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.68', '2019-09-03 01:19:31', 11, 0, '', '2019-09-03 01:19:31');
INSERT INTO `access_log` VALUES (74357, '59.80.15674447707393397', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.5', '2019-09-03 01:19:31', 20, 2001001000, '服务端发生异常', '2019-09-03 01:19:31');
INSERT INTO `access_log` VALUES (74358, '59.72.15674701819903763', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.66.74.174', '2019-09-03 08:23:02', 11, 0, '', '2019-09-03 08:23:02');
INSERT INTO `access_log` VALUES (74359, '59.75.15674701819913769', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.66.74.174', '2019-09-03 08:23:02', 58, 2001001000, '服务端发生异常', '2019-09-03 08:23:02');
INSERT INTO `access_log` VALUES (74360, '64.79.15674701878784179', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.66.74.174', '2019-09-03 08:23:08', 13, 0, '', '2019-09-03 08:23:08');
INSERT INTO `access_log` VALUES (74361, '64.82.15674701880374191', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.66.74.174', '2019-09-03 08:23:08', 3, 0, '', '2019-09-03 08:23:08');
INSERT INTO `access_log` VALUES (74362, '64.77.15674701896374157', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.66.74.174', '2019-09-03 08:23:10', 2, 0, '', '2019-09-03 08:23:10');
INSERT INTO `access_log` VALUES (74363, '64.84.15674701902874175', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.66.74.174', '2019-09-03 08:23:10', 2, 0, '', '2019-09-03 08:23:10');
INSERT INTO `access_log` VALUES (74364, '65.54.15674705937827167', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-03 08:29:54', 15, 1002001012, '访问令牌已过期', '2019-09-03 08:29:54');
INSERT INTO `access_log` VALUES (74365, '65.49.15674705937837299', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-03 08:29:54', 14, 1002001012, '访问令牌已过期', '2019-09-03 08:29:54');
INSERT INTO `access_log` VALUES (74366, '65.47.15674705937827229', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-03 08:29:54', 15, 1002001012, '访问令牌已过期', '2019-09-03 08:29:54');
INSERT INTO `access_log` VALUES (74367, '65.45.15674705956217317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-03 08:29:56', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 08:29:56');
INSERT INTO `access_log` VALUES (74368, '65.3607.15674706180079083', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-03 08:30:18', 131, 0, '', '2019-09-03 08:30:18');
INSERT INTO `access_log` VALUES (74369, '65.46.15674706183797315', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-03 08:30:18', 11, 0, '', '2019-09-03 08:30:18');
INSERT INTO `access_log` VALUES (74370, '65.53.15674706183807229', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-03 08:30:18', 13, 2001001000, '服务端发生异常', '2019-09-03 08:30:18');
INSERT INTO `access_log` VALUES (74371, '65.50.15674706183847291', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-03 08:30:18', 13, 0, '', '2019-09-03 08:30:18');
INSERT INTO `access_log` VALUES (74372, '65.54.15674713922947179', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.197.24.59', '2019-09-03 08:43:12', 1, 1002001015, '账号未登陆', '2019-09-03 08:43:12');
INSERT INTO `access_log` VALUES (74373, '65.52.15674713923147355', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.197.24.59', '2019-09-03 08:43:12', 1, 1002001015, '账号未登陆', '2019-09-03 08:43:12');
INSERT INTO `access_log` VALUES (74374, '65.45.15674713923447329', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.197.24.59', '2019-09-03 08:43:12', 1, 1002001015, '账号未登陆', '2019-09-03 08:43:12');
INSERT INTO `access_log` VALUES (74375, '65.51.15674714016197345', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.197.24.59', '2019-09-03 08:43:22', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 08:43:22');
INSERT INTO `access_log` VALUES (74376, '65.46.15674714090307327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.197.24.59', '2019-09-03 08:43:29', 105, 0, '', '2019-09-03 08:43:29');
INSERT INTO `access_log` VALUES (74377, '65.53.15674714095567241', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.197.24.59', '2019-09-03 08:43:30', 10, 0, '', '2019-09-03 08:43:30');
INSERT INTO `access_log` VALUES (74378, '65.50.15674714095707303', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.197.24.59', '2019-09-03 08:43:30', 11, 2001001000, '服务端发生异常', '2019-09-03 08:43:30');
INSERT INTO `access_log` VALUES (74379, '65.47.15674714095787243', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.197.24.59', '2019-09-03 08:43:30', 10, 0, '', '2019-09-03 08:43:30');
INSERT INTO `access_log` VALUES (74380, '65.54.15674714192927181', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.197.24.59', '2019-09-03 08:43:39', 10, 0, '', '2019-09-03 08:43:39');
INSERT INTO `access_log` VALUES (74381, '65.52.15674714192997357', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.197.24.59', '2019-09-03 08:43:39', 9, 2001001000, '服务端发生异常', '2019-09-03 08:43:39');
INSERT INTO `access_log` VALUES (74382, '65.45.15674714193107331', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.197.24.59', '2019-09-03 08:43:39', 9, 0, '', '2019-09-03 08:43:39');
INSERT INTO `access_log` VALUES (74383, '59.80.15674718456463759', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.36.143', '2019-09-03 08:50:46', 3, 0, '', '2019-09-03 08:50:46');
INSERT INTO `access_log` VALUES (74384, '59.78.15674718456453799', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.36.143', '2019-09-03 08:50:46', 19, 2001001000, '服务端发生异常', '2019-09-03 08:50:46');
INSERT INTO `access_log` VALUES (74385, '59.71.15674718736203783', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.36.143', '2019-09-03 08:51:14', 3, 0, '', '2019-09-03 08:51:14');
INSERT INTO `access_log` VALUES (74386, '59.76.15674718736203777', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.36.143', '2019-09-03 08:51:14', 17, 2001001000, '服务端发生异常', '2019-09-03 08:51:14');
INSERT INTO `access_log` VALUES (74387, '64.80.15674718771954197', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.36.143', '2019-09-03 08:51:17', 3, 0, '', '2019-09-03 08:51:17');
INSERT INTO `access_log` VALUES (74388, '64.81.15674718773554205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.36.143', '2019-09-03 08:51:17', 3, 0, '', '2019-09-03 08:51:17');
INSERT INTO `access_log` VALUES (74389, '64.83.15674718786504195', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.36.143', '2019-09-03 08:51:19', 2, 0, '', '2019-09-03 08:51:19');
INSERT INTO `access_log` VALUES (74390, '64.85.15674718793704221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.36.143', '2019-09-03 08:51:19', 2, 0, '', '2019-09-03 08:51:19');
INSERT INTO `access_log` VALUES (74391, '64.79.15674718799304203', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.36.143', '2019-09-03 08:51:20', 2, 0, '', '2019-09-03 08:51:20');
INSERT INTO `access_log` VALUES (74392, '64.77.15674718805104181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.36.143', '2019-09-03 08:51:21', 2, 0, '', '2019-09-03 08:51:21');
INSERT INTO `access_log` VALUES (74393, '59.72.15674718829703787', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.36.143', '2019-09-03 08:51:23', 3, 0, '', '2019-09-03 08:51:23');
INSERT INTO `access_log` VALUES (74394, '59.75.15674718829803793', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.36.143', '2019-09-03 08:51:23', 13, 2001001000, '服务端发生异常', '2019-09-03 08:51:23');
INSERT INTO `access_log` VALUES (74395, '59.80.15674718864853761', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.36.143', '2019-09-03 08:51:26', 3, 0, '', '2019-09-03 08:51:26');
INSERT INTO `access_log` VALUES (74396, '59.73.15674718864853787', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '223.104.36.143', '2019-09-03 08:51:26', 13, 2001001000, '服务端发生异常', '2019-09-03 08:51:26');
INSERT INTO `access_log` VALUES (74397, '59.73.15674738079323813', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.6.106.210', '2019-09-03 09:23:28', 11, 0, '', '2019-09-03 09:23:28');
INSERT INTO `access_log` VALUES (74398, '59.80.15674738079333787', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '183.6.106.210', '2019-09-03 09:23:28', 22, 2001001000, '服务端发生异常', '2019-09-03 09:23:28');
INSERT INTO `access_log` VALUES (74399, '59.74.15674746338273837', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:14', 3, 0, '', '2019-09-03 09:37:14');
INSERT INTO `access_log` VALUES (74400, '59.72.15674746338323825', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:14', 16, 2001001000, '服务端发生异常', '2019-09-03 09:37:14');
INSERT INTO `access_log` VALUES (74401, '64.80.15674746384424235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:18', 10, 0, '', '2019-09-03 09:37:18');
INSERT INTO `access_log` VALUES (74402, '64.81.15674746385704243', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:19', 3, 0, '', '2019-09-03 09:37:19');
INSERT INTO `access_log` VALUES (74403, '64.85.15674746406644259', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:21', 2, 0, '', '2019-09-03 09:37:21');
INSERT INTO `access_log` VALUES (74404, '59.73.15674746418783825', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:22', 2, 0, '', '2019-09-03 09:37:22');
INSERT INTO `access_log` VALUES (74405, '59.80.15674746418833799', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:22', 30, 2001001000, '服务端发生异常', '2019-09-03 09:37:22');
INSERT INTO `access_log` VALUES (74406, '64.79.15674746542604241', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:34', 2, 0, '', '2019-09-03 09:37:34');
INSERT INTO `access_log` VALUES (74407, '64.82.15674746543814253', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:34', 1, 0, '', '2019-09-03 09:37:34');
INSERT INTO `access_log` VALUES (74408, '64.84.15674746555724237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:36', 2, 0, '', '2019-09-03 09:37:36');
INSERT INTO `access_log` VALUES (74409, '64.78.15674746563804265', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:36', 2, 0, '', '2019-09-03 09:37:36');
INSERT INTO `access_log` VALUES (74410, '64.76.15674746575644247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:38', 2, 0, '', '2019-09-03 09:37:38');
INSERT INTO `access_log` VALUES (74411, '59.77.15674746592853815', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:39', 2, 0, '', '2019-09-03 09:37:39');
INSERT INTO `access_log` VALUES (74412, '59.79.15674746592853829', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:39', 13, 2001001000, '服务端发生异常', '2019-09-03 09:37:39');
INSERT INTO `access_log` VALUES (74413, '65.49.15674746705727357', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:51', 1, 1002001015, '账号未登陆', '2019-09-03 09:37:51');
INSERT INTO `access_log` VALUES (74414, '65.52.15674746705727401', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:51', 1, 1002001015, '账号未登陆', '2019-09-03 09:37:51');
INSERT INTO `access_log` VALUES (74415, '65.45.15674746705747375', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:51', 1, 1002001015, '账号未登陆', '2019-09-03 09:37:51');
INSERT INTO `access_log` VALUES (74416, '65.54.15674746730757225', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:37:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 09:37:53');
INSERT INTO `access_log` VALUES (74417, '65.3607.15674746844269141', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:38:04', 205, 0, '', '2019-09-03 09:38:05');
INSERT INTO `access_log` VALUES (74418, '65.46.15674746849897373', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:38:05', 14, 0, '', '2019-09-03 09:38:05');
INSERT INTO `access_log` VALUES (74419, '65.50.15674746849937349', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:38:05', 13, 2001001000, '服务端发生异常', '2019-09-03 09:38:05');
INSERT INTO `access_log` VALUES (74420, '65.53.15674746849947287', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '119.123.204.158', '2019-09-03 09:38:05', 9, 0, '', '2019-09-03 09:38:05');
INSERT INTO `access_log` VALUES (74421, '59.73.15674747426583827', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.125.8.98', '2019-09-03 09:39:03', 2, 0, '', '2019-09-03 09:39:03');
INSERT INTO `access_log` VALUES (74422, '59.80.15674747426603801', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.125.8.98', '2019-09-03 09:39:03', 13, 2001001000, '服务端发生异常', '2019-09-03 09:39:03');
INSERT INTO `access_log` VALUES (74423, '64.77.15674747479154221', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.125.8.98', '2019-09-03 09:39:08', 2, 0, '', '2019-09-03 09:39:08');
INSERT INTO `access_log` VALUES (74424, '64.84.15674747480564239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.125.8.98', '2019-09-03 09:39:08', 2, 0, '', '2019-09-03 09:39:08');
INSERT INTO `access_log` VALUES (74425, '59.79.15674747595213831', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '123.125.8.98', '2019-09-03 09:39:20', 3, 0, '', '2019-09-03 09:39:20');
INSERT INTO `access_log` VALUES (74426, '59.76.15674747595213819', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '123.125.8.98', '2019-09-03 09:39:20', 16, 2001001000, '服务端发生异常', '2019-09-03 09:39:20');
INSERT INTO `access_log` VALUES (74427, '64.76.15674747641904249', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '123.125.8.98', '2019-09-03 09:39:24', 9, 0, '', '2019-09-03 09:39:24');
INSERT INTO `access_log` VALUES (74428, '64.80.15674747643334239', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '123.125.8.98', '2019-09-03 09:39:24', 2, 0, '', '2019-09-03 09:39:24');
INSERT INTO `access_log` VALUES (74429, '64.81.15674747686924247', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '123.125.8.98', '2019-09-03 09:39:29', 2, 0, '', '2019-09-03 09:39:29');
INSERT INTO `access_log` VALUES (74430, '64.83.15674747688314237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '123.125.8.98', '2019-09-03 09:39:29', 2, 0, '', '2019-09-03 09:39:29');
INSERT INTO `access_log` VALUES (74431, '65.54.15674748659307229', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-09-03 09:41:06', 93, 1002001012, '访问令牌已过期', '2019-09-03 09:41:06');
INSERT INTO `access_log` VALUES (74432, '65.52.15674748659227405', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-09-03 09:41:06', 106, 1002001012, '访问令牌已过期', '2019-09-03 09:41:06');
INSERT INTO `access_log` VALUES (74433, '65.49.15674748659257361', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-09-03 09:41:06', 103, 1002001012, '访问令牌已过期', '2019-09-03 09:41:06');
INSERT INTO `access_log` VALUES (74434, '65.3607.15674748745069145', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-09-03 09:41:15', 77, 0, '', '2019-09-03 09:41:15');
INSERT INTO `access_log` VALUES (74435, '65.46.15674748749507377', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-09-03 09:41:15', 9, 0, '', '2019-09-03 09:41:15');
INSERT INTO `access_log` VALUES (74436, '65.53.15674748749397291', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-09-03 09:41:15', 156, 0, '', '2019-09-03 09:41:15');
INSERT INTO `access_log` VALUES (74437, '65.50.15674748749457353', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '61.183.116.198', '2019-09-03 09:41:15', 151, 2001001000, '服务端发生异常', '2019-09-03 09:41:15');
INSERT INTO `access_log` VALUES (74438, '65.54.15674755716867239', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.239', '2019-09-03 09:52:52', 1, 1002001015, '账号未登陆', '2019-09-03 09:52:52');
INSERT INTO `access_log` VALUES (74439, '65.51.15674755716867405', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.239', '2019-09-03 09:52:52', 0, 1002001015, '账号未登陆', '2019-09-03 09:52:52');
INSERT INTO `access_log` VALUES (74440, '65.3607.15674755716879155', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.239', '2019-09-03 09:52:52', 0, 1002001015, '账号未登陆', '2019-09-03 09:52:52');
INSERT INTO `access_log` VALUES (74441, '65.53.15674755732287303', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.239', '2019-09-03 09:52:53', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 09:52:53');
INSERT INTO `access_log` VALUES (74442, '65.50.15674755854317365', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.239', '2019-09-03 09:53:05', 79, 0, '', '2019-09-03 09:53:06');
INSERT INTO `access_log` VALUES (74443, '65.49.15674755857407373', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.239', '2019-09-03 09:53:06', 9, 0, '', '2019-09-03 09:53:06');
INSERT INTO `access_log` VALUES (74444, '65.45.15674755857427391', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.239', '2019-09-03 09:53:06', 10, 2001001000, '服务端发生异常', '2019-09-03 09:53:06');
INSERT INTO `access_log` VALUES (74445, '65.52.15674755857467419', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.239', '2019-09-03 09:53:06', 9, 0, '', '2019-09-03 09:53:06');
INSERT INTO `access_log` VALUES (74446, '65.51.15674755911417407', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.239', '2019-09-03 09:53:11', 9, 0, '', '2019-09-03 09:53:11');
INSERT INTO `access_log` VALUES (74447, '65.54.15674755911487241', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.239', '2019-09-03 09:53:11', 9, 2001001000, '服务端发生异常', '2019-09-03 09:53:11');
INSERT INTO `access_log` VALUES (74448, '65.3607.15674755911539157', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '125.122.222.239', '2019-09-03 09:53:11', 9, 0, '', '2019-09-03 09:53:11');
INSERT INTO `access_log` VALUES (74449, '59.75.15674806449553913', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3730.400 QQBrowser/10.5.3805.400', '117.136.0.239', '2019-09-03 11:17:25', 11, 0, '', '2019-09-03 11:17:25');
INSERT INTO `access_log` VALUES (74450, '59.72.15674806449553907', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3730.400 QQBrowser/10.5.3805.400', '117.136.0.239', '2019-09-03 11:17:25', 16, 2001001000, '服务端发生异常', '2019-09-03 11:17:25');
INSERT INTO `access_log` VALUES (74451, '59.78.15674821748823941', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.30.174', '2019-09-03 11:42:55', 4, 0, '', '2019-09-03 11:42:55');
INSERT INTO `access_log` VALUES (74452, '59.77.15674821748833917', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36', '211.97.30.174', '2019-09-03 11:42:55', 19, 2001001000, '服务端发生异常', '2019-09-03 11:42:55');
INSERT INTO `access_log` VALUES (74453, '59.79.15674842746833959', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'ZhihuHybrid DefaultBrowser com.zhihu.android/Futureve/6.11.0 Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36', '223.104.147.48', '2019-09-03 12:17:55', 12, 0, '', '2019-09-03 12:17:55');
INSERT INTO `access_log` VALUES (74454, '59.76.15674842746943947', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'ZhihuHybrid DefaultBrowser com.zhihu.android/Futureve/6.11.0 Mozilla/5.0 (Linux; Android 9; MI 8 Build/PKQ1.180729.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36', '223.104.147.48', '2019-09-03 12:17:55', 17, 2001001000, '服务端发生异常', '2019-09-03 12:17:55');
INSERT INTO `access_log` VALUES (74455, '59.75.15674868708793997', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:11', 9, 0, '', '2019-09-03 13:01:11');
INSERT INTO `access_log` VALUES (74456, '59.73.15674868708793991', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:11', 19, 2001001000, '服务端发生异常', '2019-09-03 13:01:11');
INSERT INTO `access_log` VALUES (74457, '64.80.15674868773274401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:17', 10, 0, '', '2019-09-03 13:01:17');
INSERT INTO `access_log` VALUES (74458, '64.81.15674868774444409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:17', 3, 0, '', '2019-09-03 13:01:17');
INSERT INTO `access_log` VALUES (74459, '64.83.15674868786794399', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:19', 2, 0, '', '2019-09-03 13:01:19');
INSERT INTO `access_log` VALUES (74460, '64.85.15674868791424425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:19', 2, 0, '', '2019-09-03 13:01:19');
INSERT INTO `access_log` VALUES (74461, '59.77.15674868806523981', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:21', 3, 0, '', '2019-09-03 13:01:21');
INSERT INTO `access_log` VALUES (74462, '59.78.15674868806524005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:21', 39, 2001001000, '服务端发生异常', '2019-09-03 13:01:21');
INSERT INTO `access_log` VALUES (74463, '65.50.15674868852757519', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:25', 1, 1002001015, '账号未登陆', '2019-09-03 13:01:25');
INSERT INTO `access_log` VALUES (74464, '65.53.15674868852767457', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:25', 1, 1002001015, '账号未登陆', '2019-09-03 13:01:25');
INSERT INTO `access_log` VALUES (74465, '65.52.15674868852767573', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:25', 1, 1002001015, '账号未登陆', '2019-09-03 13:01:25');
INSERT INTO `access_log` VALUES (74466, '65.45.15674868866757545', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:27', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 13:01:27');
INSERT INTO `access_log` VALUES (74467, '65.3607.15674869012489311', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:41', 59, 0, '', '2019-09-03 13:01:41');
INSERT INTO `access_log` VALUES (74468, '65.47.15674869015507461', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:42', 16, 0, '', '2019-09-03 13:01:42');
INSERT INTO `access_log` VALUES (74469, '65.51.15674869015557557', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:42', 12, 0, '', '2019-09-03 13:01:42');
INSERT INTO `access_log` VALUES (74470, '65.54.15674869015537393', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.170.174.147', '2019-09-03 13:01:42', 16, 2001001000, '服务端发生异常', '2019-09-03 13:01:42');
INSERT INTO `access_log` VALUES (74471, '65.45.15674892051677577', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.97.175.85', '2019-09-03 13:40:05', 16, 1002001012, '访问令牌已过期', '2019-09-03 13:40:05');
INSERT INTO `access_log` VALUES (74472, '65.52.15674892051677605', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.97.175.85', '2019-09-03 13:40:05', 29, 1002001012, '访问令牌已过期', '2019-09-03 13:40:05');
INSERT INTO `access_log` VALUES (74473, '65.49.15674892051687559', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.97.175.85', '2019-09-03 13:40:05', 29, 1002001012, '访问令牌已过期', '2019-09-03 13:40:05');
INSERT INTO `access_log` VALUES (74474, '65.3607.15674892089149343', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.97.175.85', '2019-09-03 13:40:09', 89, 0, '', '2019-09-03 13:40:09');
INSERT INTO `access_log` VALUES (74475, '65.54.15674892093047425', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.97.175.85', '2019-09-03 13:40:09', 11, 0, '', '2019-09-03 13:40:09');
INSERT INTO `access_log` VALUES (74476, '65.46.15674892093157573', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.97.175.85', '2019-09-03 13:40:09', 149, 0, '', '2019-09-03 13:40:09');
INSERT INTO `access_log` VALUES (74477, '65.47.15674892093147493', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '122.97.175.85', '2019-09-03 13:40:09', 151, 2001001000, '服务端发生异常', '2019-09-03 13:40:09');
INSERT INTO `access_log` VALUES (74478, '65.46.15674899477007583', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '221.232.115.14', '2019-09-03 13:52:28', 0, 1002001015, '账号未登陆', '2019-09-03 13:52:28');
INSERT INTO `access_log` VALUES (74479, '65.50.15674899477007563', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '221.232.115.14', '2019-09-03 13:52:28', 0, 1002001015, '账号未登陆', '2019-09-03 13:52:28');
INSERT INTO `access_log` VALUES (74480, '65.53.15674899477047501', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '221.232.115.14', '2019-09-03 13:52:28', 0, 1002001015, '账号未登陆', '2019-09-03 13:52:28');
INSERT INTO `access_log` VALUES (74481, '65.49.15674899503107571', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '221.232.115.14', '2019-09-03 13:52:30', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 13:52:30');
INSERT INTO `access_log` VALUES (74482, '65.52.15674899711647617', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '221.232.115.14', '2019-09-03 13:52:51', 63, 0, '', '2019-09-03 13:52:51');
INSERT INTO `access_log` VALUES (74483, '65.51.15674899714747601', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '221.232.115.14', '2019-09-03 13:52:51', 9, 0, '', '2019-09-03 13:52:51');
INSERT INTO `access_log` VALUES (74484, '65.3607.15674899714779355', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '221.232.115.14', '2019-09-03 13:52:51', 8, 2001001000, '服务端发生异常', '2019-09-03 13:52:51');
INSERT INTO `access_log` VALUES (74485, '65.54.15674899714827437', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '221.232.115.14', '2019-09-03 13:52:51', 8, 0, '', '2019-09-03 13:52:51');
INSERT INTO `access_log` VALUES (74486, '59.77.15674909108994035', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:08:31', 10, 0, '', '2019-09-03 14:08:31');
INSERT INTO `access_log` VALUES (74487, '59.78.15674909109044059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:08:31', 17, 2001001000, '服务端发生异常', '2019-09-03 14:08:31');
INSERT INTO `access_log` VALUES (74488, '59.71.15674909428354043', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:03', 3, 0, '', '2019-09-03 14:09:03');
INSERT INTO `access_log` VALUES (74489, '59.74.15674909428394059', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:03', 13, 2001001000, '服务端发生异常', '2019-09-03 14:09:03');
INSERT INTO `access_log` VALUES (74490, '64.82.15674909454754473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:05', 11, 0, '', '2019-09-03 14:09:05');
INSERT INTO `access_log` VALUES (74491, '64.84.15674909457144457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:06', 4, 0, '', '2019-09-03 14:09:06');
INSERT INTO `access_log` VALUES (74492, '64.78.15674909470344485', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:07', 2, 0, '', '2019-09-03 14:09:07');
INSERT INTO `access_log` VALUES (74493, '64.76.15674909476154467', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:08', 2, 0, '', '2019-09-03 14:09:08');
INSERT INTO `access_log` VALUES (74494, '64.80.15674909479464457', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:08', 2, 0, '', '2019-09-03 14:09:08');
INSERT INTO `access_log` VALUES (74495, '64.81.15674909483564465', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:08', 2, 0, '', '2019-09-03 14:09:08');
INSERT INTO `access_log` VALUES (74496, '64.83.15674909506244455', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:11', 2, 0, '', '2019-09-03 14:09:11');
INSERT INTO `access_log` VALUES (74497, '64.85.15674909511344481', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:11', 2, 0, '', '2019-09-03 14:09:11');
INSERT INTO `access_log` VALUES (74498, '64.79.15674909515144463', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:12', 2, 0, '', '2019-09-03 14:09:12');
INSERT INTO `access_log` VALUES (74499, '59.75.15674909526244053', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:13', 3, 0, '', '2019-09-03 14:09:13');
INSERT INTO `access_log` VALUES (74500, '59.73.15674909526284047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:13', 12, 2001001000, '服务端发生异常', '2019-09-03 14:09:13');
INSERT INTO `access_log` VALUES (74501, '64.82.15674909701554475', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:30', 2, 0, '', '2019-09-03 14:09:30');
INSERT INTO `access_log` VALUES (74502, '64.84.15674909703834459', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:30', 2, 0, '', '2019-09-03 14:09:30');
INSERT INTO `access_log` VALUES (74503, '64.78.15674909715054487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:32', 3, 0, '', '2019-09-03 14:09:32');
INSERT INTO `access_log` VALUES (74504, '64.76.15674909718754469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.136.41.71', '2019-09-03 14:09:32', 2, 0, '', '2019-09-03 14:09:32');
INSERT INTO `access_log` VALUES (74505, '65.51.15674935921667651', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:53:12', 17, 1002001012, '访问令牌已过期', '2019-09-03 14:53:12');
INSERT INTO `access_log` VALUES (74506, '65.54.15674935921657487', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:53:12', 17, 1002001012, '访问令牌已过期', '2019-09-03 14:53:12');
INSERT INTO `access_log` VALUES (74507, '65.46.15674935922277633', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:53:12', 11, 1002001012, '访问令牌已过期', '2019-09-03 14:53:12');
INSERT INTO `access_log` VALUES (74508, '65.47.15674936010047559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:53:21', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 14:53:21');
INSERT INTO `access_log` VALUES (74509, '65.49.15674936142457621', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:53:34', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 14:53:34');
INSERT INTO `access_log` VALUES (74510, '65.52.15674936226227669', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:53:43', 106, 0, '', '2019-09-03 14:53:43');
INSERT INTO `access_log` VALUES (74511, '65.53.15674936230727551', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:53:43', 15, 0, '', '2019-09-03 14:53:43');
INSERT INTO `access_log` VALUES (74512, '65.3607.15674936230719405', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:53:43', 17, 2001001000, '服务端发生异常', '2019-09-03 14:53:43');
INSERT INTO `access_log` VALUES (74513, '65.51.15674936231277653', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:53:43', 68, 0, '', '2019-09-03 14:53:43');
INSERT INTO `access_log` VALUES (74514, '65.46.15674936466177635', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:54:07', 8, 0, '', '2019-09-03 14:54:07');
INSERT INTO `access_log` VALUES (74515, '65.47.15674936466227561', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:54:07', 8, 2001001000, '服务端发生异常', '2019-09-03 14:54:07');
INSERT INTO `access_log` VALUES (74516, '65.50.15674936466547619', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:54:07', 8, 0, '', '2019-09-03 14:54:07');
INSERT INTO `access_log` VALUES (74517, '65.45.15674936549717643', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:54:15', 9, 0, '', '2019-09-03 14:54:15');
INSERT INTO `access_log` VALUES (74518, '65.52.15674936549897671', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:54:15', 10, 2001001000, '服务端发生异常', '2019-09-03 14:54:15');
INSERT INTO `access_log` VALUES (74519, '65.3607.15674936553509407', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.82.186.177', '2019-09-03 14:54:15', 10, 0, '', '2019-09-03 14:54:15');
INSERT INTO `access_log` VALUES (74520, '65.47.15674945954037575', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '218.2.219.66', '2019-09-03 15:09:55', 1, 1002001015, '账号未登陆', '2019-09-03 15:09:55');
INSERT INTO `access_log` VALUES (74521, '65.50.15674945954037633', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '218.2.219.66', '2019-09-03 15:09:55', 0, 1002001015, '账号未登陆', '2019-09-03 15:09:55');
INSERT INTO `access_log` VALUES (74522, '65.46.15674945954037649', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '218.2.219.66', '2019-09-03 15:09:55', 0, 1002001015, '账号未登陆', '2019-09-03 15:09:55');
INSERT INTO `access_log` VALUES (74523, '65.49.15674946013547637', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '218.2.219.66', '2019-09-03 15:10:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 15:10:01');
INSERT INTO `access_log` VALUES (74524, '65.47.15674947132307577', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '218.2.219.66', '2019-09-03 15:11:53', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 15:11:53');
INSERT INTO `access_log` VALUES (74525, '65.45.15674947297967659', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '218.2.219.66', '2019-09-03 15:12:10', 204, 0, '', '2019-09-03 15:12:10');
INSERT INTO `access_log` VALUES (74526, '65.52.15674947307967687', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '218.2.219.66', '2019-09-03 15:12:11', 9, 0, '', '2019-09-03 15:12:11');
INSERT INTO `access_log` VALUES (74527, '65.3607.15674947307969423', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '218.2.219.66', '2019-09-03 15:12:11', 11, 2001001000, '服务端发生异常', '2019-09-03 15:12:11');
INSERT INTO `access_log` VALUES (74528, '65.53.15674947308127569', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '218.2.219.66', '2019-09-03 15:12:11', 17, 0, '', '2019-09-03 15:12:11');
INSERT INTO `access_log` VALUES (74529, '65.46.15674957117687665', 0, 2, 'admin-application', '/admin-api/admins/admin/add', 'nickname=小王&password=buzhidao&username=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.6.19.132', '2019-09-03 15:28:32', 0, 1002001015, '账号未登陆', '2019-09-03 15:28:32');
INSERT INTO `access_log` VALUES (74530, '65.45.15674964780747685', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:41:18', 0, 1002001015, '账号未登陆', '2019-09-03 15:41:18');
INSERT INTO `access_log` VALUES (74531, '65.52.15674964780757711', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:41:18', 0, 1002001015, '账号未登陆', '2019-09-03 15:41:18');
INSERT INTO `access_log` VALUES (74532, '65.3607.15674964780749449', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:41:18', 0, 1002001015, '账号未登陆', '2019-09-03 15:41:18');
INSERT INTO `access_log` VALUES (74533, '65.53.15674964799417593', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:41:20', 17, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 15:41:20');
INSERT INTO `access_log` VALUES (74534, '59.80.15674964950464095', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:41:35', 8, 0, '', '2019-09-03 15:41:35');
INSERT INTO `access_log` VALUES (74535, '59.77.15674964950474111', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:41:35', 18, 2001001000, '服务端发生异常', '2019-09-03 15:41:35');
INSERT INTO `access_log` VALUES (74536, '66.50.15674965128331517', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13774153793&code=9999', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:41:53', 16, 1001003000, '验证码不存在', '2019-09-03 15:41:53');
INSERT INTO `access_log` VALUES (74537, '66.55.15674965146821493', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=13774153793', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:41:55', 89, 0, '', '2019-09-03 15:41:55');
INSERT INTO `access_log` VALUES (74538, '66.54.15674965164891529', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13774153793&code=9999', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:41:56', 160, 0, '', '2019-09-03 15:41:57');
INSERT INTO `access_log` VALUES (74539, '66.52.15674965239561513', 218, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:04', 9, 0, '', '2019-09-03 15:42:04');
INSERT INTO `access_log` VALUES (74540, '64.81.15674965252744541', 218, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:05', 262, 0, '', '2019-09-03 15:42:06');
INSERT INTO `access_log` VALUES (74541, '64.79.15674965256934539', 218, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:06', 8, 0, '', '2019-09-03 15:42:06');
INSERT INTO `access_log` VALUES (74542, '59.71.15674965269624119', 218, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:07', 14, 0, '', '2019-09-03 15:42:07');
INSERT INTO `access_log` VALUES (74543, '59.72.15674965269624123', 218, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:07', 31, 2001001000, '服务端发生异常', '2019-09-03 15:42:07');
INSERT INTO `access_log` VALUES (74544, '64.77.15674965312414517', 218, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:11', 5, 0, '', '2019-09-03 15:42:11');
INSERT INTO `access_log` VALUES (74545, '64.82.15674965313534551', 218, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:11', 5, 0, '', '2019-09-03 15:42:11');
INSERT INTO `access_log` VALUES (74546, '59.73.15674965332454123', 218, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:13', 6, 0, '', '2019-09-03 15:42:13');
INSERT INTO `access_log` VALUES (74547, '59.75.15674965332454129', 218, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:13', 16, 2001001000, '服务端发生异常', '2019-09-03 15:42:13');
INSERT INTO `access_log` VALUES (74548, '64.84.15674965347124535', 218, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:15', 6, 0, '', '2019-09-03 15:42:15');
INSERT INTO `access_log` VALUES (74549, '64.78.15674965348134563', 218, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:15', 6, 0, '', '2019-09-03 15:42:15');
INSERT INTO `access_log` VALUES (74550, '59.80.15674965364254097', 218, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:16', 6, 0, '', '2019-09-03 15:42:16');
INSERT INTO `access_log` VALUES (74551, '59.77.15674965364254113', 218, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:16', 17, 2001001000, '服务端发生异常', '2019-09-03 15:42:16');
INSERT INTO `access_log` VALUES (74552, '64.76.15674965386124545', 218, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:19', 5, 0, '', '2019-09-03 15:42:19');
INSERT INTO `access_log` VALUES (74553, '64.80.15674965386984535', 218, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:19', 6, 0, '', '2019-09-03 15:42:19');
INSERT INTO `access_log` VALUES (74554, '59.76.15674965415634115', 218, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:22', 6, 0, '', '2019-09-03 15:42:22');
INSERT INTO `access_log` VALUES (74555, '59.79.15674965415644127', 218, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:22', 26, 2001001000, '服务端发生异常', '2019-09-03 15:42:22');
INSERT INTO `access_log` VALUES (74556, '64.81.15674965422534543', 218, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:22', 6, 0, '', '2019-09-03 15:42:22');
INSERT INTO `access_log` VALUES (74557, '64.85.15674965423724559', 218, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:22', 5, 0, '', '2019-09-03 15:42:22');
INSERT INTO `access_log` VALUES (74558, '59.71.15674965426004121', 218, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:23', 5, 0, '', '2019-09-03 15:42:23');
INSERT INTO `access_log` VALUES (74559, '59.74.15674965426004137', 218, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:23', 17, 2001001000, '服务端发生异常', '2019-09-03 15:42:23');
INSERT INTO `access_log` VALUES (74560, '64.79.15674965430654541', 218, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:23', 13, 0, '', '2019-09-03 15:42:23');
INSERT INTO `access_log` VALUES (74561, '64.77.15674965431584519', 218, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:23', 4, 0, '', '2019-09-03 15:42:23');
INSERT INTO `access_log` VALUES (74562, '59.75.15674965435144131', 218, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:24', 4, 0, '', '2019-09-03 15:42:24');
INSERT INTO `access_log` VALUES (74563, '59.72.15674965435144125', 218, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:24', 15, 2001001000, '服务端发生异常', '2019-09-03 15:42:24');
INSERT INTO `access_log` VALUES (74564, '64.82.15674965439214553', 218, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:24', 7, 0, '', '2019-09-03 15:42:24');
INSERT INTO `access_log` VALUES (74565, '64.84.15674965440204537', 218, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:24', 5, 0, '', '2019-09-03 15:42:24');
INSERT INTO `access_log` VALUES (74566, '66.48.15674965445631501', 218, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:25', 5, 0, '', '2019-09-03 15:42:25');
INSERT INTO `access_log` VALUES (74567, '59.77.15674965452444115', 218, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:25', 5, 0, '', '2019-09-03 15:42:25');
INSERT INTO `access_log` VALUES (74568, '59.73.15674965452434125', 218, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '119.98.1.96', '2019-09-03 15:42:25', 17, 2001001000, '服务端发生异常', '2019-09-03 15:42:25');
INSERT INTO `access_log` VALUES (74569, '65.53.15674994504647633', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:30:50', 30, 1002001012, '访问令牌已过期', '2019-09-03 16:30:51');
INSERT INTO `access_log` VALUES (74570, '65.45.15674994504647725', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:30:50', 31, 1002001012, '访问令牌已过期', '2019-09-03 16:30:51');
INSERT INTO `access_log` VALUES (74571, '65.51.15674994504667737', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:30:50', 27, 1002001012, '访问令牌已过期', '2019-09-03 16:30:51');
INSERT INTO `access_log` VALUES (74572, '65.50.15674994545767703', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:30:55', 104, 0, '', '2019-09-03 16:30:55');
INSERT INTO `access_log` VALUES (74573, '65.47.15674994558207641', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:30:56', 13, 0, '', '2019-09-03 16:30:56');
INSERT INTO `access_log` VALUES (74574, '65.46.15674994558207717', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:30:56', 15, 0, '', '2019-09-03 16:30:56');
INSERT INTO `access_log` VALUES (74575, '65.49.15674994558227707', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:30:56', 15, 2001001000, '服务端发生异常', '2019-09-03 16:30:56');
INSERT INTO `access_log` VALUES (74576, '65.52.15674994806907753', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:31:21', 11, 2001001000, '服务端发生异常', '2019-09-03 16:31:21');
INSERT INTO `access_log` VALUES (74577, '65.51.15674994807177739', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:31:21', 8, 0, '', '2019-09-03 16:31:21');
INSERT INTO `access_log` VALUES (74578, '65.45.15674994807167727', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:31:21', 9, 0, '', '2019-09-03 16:31:21');
INSERT INTO `access_log` VALUES (74579, '65.54.15674994974077573', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:31:37', 9, 0, '', '2019-09-03 16:31:37');
INSERT INTO `access_log` VALUES (74580, '65.49.15674994974377709', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:31:37', 9, 0, '', '2019-09-03 16:31:37');
INSERT INTO `access_log` VALUES (74581, '65.50.15674994974377705', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:31:37', 10, 2001001000, '服务端发生异常', '2019-09-03 16:31:37');
INSERT INTO `access_log` VALUES (74582, '65.46.15674995028287719', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:31:43', 10, 2001001000, '服务端发生异常', '2019-09-03 16:31:43');
INSERT INTO `access_log` VALUES (74583, '65.3607.15674995028309493', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:31:43', 8, 0, '', '2019-09-03 16:31:43');
INSERT INTO `access_log` VALUES (74584, '65.51.15674995028567741', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:31:43', 9, 0, '', '2019-09-03 16:31:43');
INSERT INTO `access_log` VALUES (74585, '65.45.15674995097067729', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:31:50', 10, 0, '', '2019-09-03 16:31:50');
INSERT INTO `access_log` VALUES (74586, '65.53.15674995097077637', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:31:50', 9, 0, '', '2019-09-03 16:31:50');
INSERT INTO `access_log` VALUES (74587, '65.52.15674995097067755', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.96.248.178', '2019-09-03 16:31:50', 12, 2001001000, '服务端发生异常', '2019-09-03 16:31:50');
INSERT INTO `access_log` VALUES (74588, '65.46.15675007755527737', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:52:56', 1, 1002001015, '账号未登陆', '2019-09-03 16:52:56');
INSERT INTO `access_log` VALUES (74589, '65.51.15675007755547759', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:52:56', 0, 1002001015, '账号未登陆', '2019-09-03 16:52:56');
INSERT INTO `access_log` VALUES (74590, '65.53.15675007755547655', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:52:56', 0, 1002001015, '账号未登陆', '2019-09-03 16:52:56');
INSERT INTO `access_log` VALUES (74591, '65.52.15675007795357773', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:53:00', 77, 0, '', '2019-09-03 16:53:00');
INSERT INTO `access_log` VALUES (74592, '65.45.15675007800867747', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:53:00', 332, 0, '', '2019-09-03 16:53:00');
INSERT INTO `access_log` VALUES (74593, '65.50.15675007800977725', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:53:00', 323, 2001001000, '服务端发生异常', '2019-09-03 16:53:00');
INSERT INTO `access_log` VALUES (74594, '65.54.15675007800937593', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:53:00', 329, 0, '', '2019-09-03 16:53:00');
INSERT INTO `access_log` VALUES (74595, '65.53.15675008478477657', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:08', 10, 0, '', '2019-09-03 16:54:08');
INSERT INTO `access_log` VALUES (74596, '65.52.15675008478827775', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:08', 18, 0, '', '2019-09-03 16:54:08');
INSERT INTO `access_log` VALUES (74597, '65.46.15675008478827739', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:08', 20, 2001001000, '服务端发生异常', '2019-09-03 16:54:08');
INSERT INTO `access_log` VALUES (74598, '65.45.15675008525277749', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:13', 9, 0, '', '2019-09-03 16:54:13');
INSERT INTO `access_log` VALUES (74599, '65.50.15675008525277727', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:13', 11, 2001001000, '服务端发生异常', '2019-09-03 16:54:13');
INSERT INTO `access_log` VALUES (74600, '65.49.15675008525477731', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:13', 9, 0, '', '2019-09-03 16:54:13');
INSERT INTO `access_log` VALUES (74601, '59.71.15675008705444181', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:31', 9, 0, '', '2019-09-03 16:54:31');
INSERT INTO `access_log` VALUES (74602, '59.74.15675008705444197', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:31', 11, 2001001000, '服务端发生异常', '2019-09-03 16:54:31');
INSERT INTO `access_log` VALUES (74603, '64.84.15675008767694595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:37', 10, 0, '', '2019-09-03 16:54:37');
INSERT INTO `access_log` VALUES (74604, '64.78.15675008769584623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:37', 3, 0, '', '2019-09-03 16:54:37');
INSERT INTO `access_log` VALUES (74605, '64.76.15675008791134605', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:39', 2, 0, '', '2019-09-03 16:54:39');
INSERT INTO `access_log` VALUES (74606, '64.80.15675008802024595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:40', 2, 0, '', '2019-09-03 16:54:40');
INSERT INTO `access_log` VALUES (74607, '64.83.15675008807374593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:41', 2, 0, '', '2019-09-03 16:54:41');
INSERT INTO `access_log` VALUES (74608, '64.81.15675008811174603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:41', 2, 0, '', '2019-09-03 16:54:41');
INSERT INTO `access_log` VALUES (74609, '64.85.15675008815184619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:42', 1, 0, '', '2019-09-03 16:54:42');
INSERT INTO `access_log` VALUES (74610, '64.79.15675008818324601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:42', 1, 0, '', '2019-09-03 16:54:42');
INSERT INTO `access_log` VALUES (74611, '64.82.15675008944754613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:54', 2, 0, '', '2019-09-03 16:54:54');
INSERT INTO `access_log` VALUES (74612, '64.84.15675008945714597', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.127.99.32', '2019-09-03 16:54:55', 2, 0, '', '2019-09-03 16:54:55');
INSERT INTO `access_log` VALUES (74613, '59.71.15675012851544187', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 17:01:25', 3, 0, '', '2019-09-03 17:01:25');
INSERT INTO `access_log` VALUES (74614, '59.74.15675012851564203', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 17:01:25', 19, 2001001000, '服务端发生异常', '2019-09-03 17:01:25');
INSERT INTO `access_log` VALUES (74615, '64.79.15675012912524607', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 17:01:31', 3, 0, '', '2019-09-03 17:01:31');
INSERT INTO `access_log` VALUES (74616, '64.77.15675012914304585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 17:01:31', 1, 0, '', '2019-09-03 17:01:31');
INSERT INTO `access_log` VALUES (74617, '64.82.15675012927424619', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 17:01:33', 2, 0, '', '2019-09-03 17:01:33');
INSERT INTO `access_log` VALUES (74618, '64.84.15675012933944603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 17:01:33', 2, 0, '', '2019-09-03 17:01:33');
INSERT INTO `access_log` VALUES (74619, '65.47.15675012989447671', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 17:01:39', 1, 1002001015, '账号未登陆', '2019-09-03 17:01:39');
INSERT INTO `access_log` VALUES (74620, '65.3607.15675012989459521', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 17:01:39', 1, 1002001015, '账号未登陆', '2019-09-03 17:01:39');
INSERT INTO `access_log` VALUES (74621, '65.51.15675012989467769', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 17:01:39', 0, 1002001015, '账号未登陆', '2019-09-03 17:01:39');
INSERT INTO `access_log` VALUES (74622, '65.52.15675013321237783', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 17:02:12', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 17:02:12');
INSERT INTO `access_log` VALUES (74623, '65.54.15675013383127603', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 17:02:18', 61, 0, '', '2019-09-03 17:02:18');
INSERT INTO `access_log` VALUES (74624, '65.50.15675013386677735', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 17:02:19', 10, 0, '', '2019-09-03 17:02:19');
INSERT INTO `access_log` VALUES (74625, '65.45.15675013386697757', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 17:02:19', 9, 2001001000, '服务端发生异常', '2019-09-03 17:02:19');
INSERT INTO `access_log` VALUES (74626, '65.49.15675013386747739', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 17:02:19', 9, 0, '', '2019-09-03 17:02:19');
INSERT INTO `access_log` VALUES (74627, '65.52.15675015684347787', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.212.80.251', '2019-09-03 17:06:08', 4, 1002001012, '访问令牌已过期', '2019-09-03 17:06:08');
INSERT INTO `access_log` VALUES (74628, '65.54.15675015684367607', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.212.80.251', '2019-09-03 17:06:08', 4, 1002001012, '访问令牌已过期', '2019-09-03 17:06:08');
INSERT INTO `access_log` VALUES (74629, '65.50.15675015684417739', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.212.80.251', '2019-09-03 17:06:08', 3, 1002001012, '访问令牌已过期', '2019-09-03 17:06:08');
INSERT INTO `access_log` VALUES (74630, '65.49.15675015712877743', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.212.80.251', '2019-09-03 17:06:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 17:06:11');
INSERT INTO `access_log` VALUES (74631, '65.3607.15675015788469527', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.212.80.251', '2019-09-03 17:06:19', 85, 0, '', '2019-09-03 17:06:19');
INSERT INTO `access_log` VALUES (74632, '65.51.15675015791727775', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.212.80.251', '2019-09-03 17:06:19', 9, 0, '', '2019-09-03 17:06:19');
INSERT INTO `access_log` VALUES (74633, '65.47.15675015791767677', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.212.80.251', '2019-09-03 17:06:19', 17, 2001001000, '服务端发生异常', '2019-09-03 17:06:19');
INSERT INTO `access_log` VALUES (74634, '65.53.15675015791797671', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.212.80.251', '2019-09-03 17:06:19', 17, 0, '', '2019-09-03 17:06:19');
INSERT INTO `access_log` VALUES (74635, '65.50.15675016171807741', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.212.80.251', '2019-09-03 17:06:57', 8, 0, '', '2019-09-03 17:06:57');
INSERT INTO `access_log` VALUES (74636, '65.45.15675016172077763', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.212.80.251', '2019-09-03 17:06:57', 9, 2001001000, '服务端发生异常', '2019-09-03 17:06:57');
INSERT INTO `access_log` VALUES (74637, '65.49.15675016172087745', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.212.80.251', '2019-09-03 17:06:57', 9, 0, '', '2019-09-03 17:06:57');
INSERT INTO `access_log` VALUES (74638, '59.79.15675032804304219', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.180.239.193', '2019-09-03 17:34:40', 11, 0, '', '2019-09-03 17:34:40');
INSERT INTO `access_log` VALUES (74639, '59.73.15675032804304215', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.180.239.193', '2019-09-03 17:34:40', 16, 2001001000, '服务端发生异常', '2019-09-03 17:34:40');
INSERT INTO `access_log` VALUES (74640, '64.83.15675032871024627', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:34:47', 12, 0, '', '2019-09-03 17:34:47');
INSERT INTO `access_log` VALUES (74641, '64.81.15675032872554637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:34:47', 3, 0, '', '2019-09-03 17:34:47');
INSERT INTO `access_log` VALUES (74642, '64.85.15675032885124653', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:34:49', 2, 0, '', '2019-09-03 17:34:49');
INSERT INTO `access_log` VALUES (74643, '64.79.15675032891034635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:34:49', 1, 0, '', '2019-09-03 17:34:49');
INSERT INTO `access_log` VALUES (74644, '64.82.15675032910564647', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:34:51', 2, 0, '', '2019-09-03 17:34:51');
INSERT INTO `access_log` VALUES (74645, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:34:51', 5, 0, '', '2019-09-03 17:34:51');
INSERT INTO `access_log` VALUES (74646, '64.84.15675032927344631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:34:53', 1, 0, '', '2019-09-03 17:34:53');
INSERT INTO `access_log` VALUES (74647, '64.78.15675032928554659', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:34:53', 1, 0, '', '2019-09-03 17:34:53');
INSERT INTO `access_log` VALUES (74648, '66.49.15675033090061609', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18810092585&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:09', 16, 1001003000, '验证码不存在', '2019-09-03 17:35:09');
INSERT INTO `access_log` VALUES (74649, '66.50.15675033117411609', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18810092585', 'POST', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:12', 68, 0, '', '2019-09-03 17:35:12');
INSERT INTO `access_log` VALUES (74650, '64.81.15675033409614639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:41', 2, 0, '', '2019-09-03 17:35:41');
INSERT INTO `access_log` VALUES (74651, '64.85.15675033411564655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:41', 2, 0, '', '2019-09-03 17:35:41');
INSERT INTO `access_log` VALUES (74652, '59.71.15675033415104215', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:42', 3, 0, '', '2019-09-03 17:35:42');
INSERT INTO `access_log` VALUES (74653, '59.75.15675033415774225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:42', 10, 2001001000, '服务端发生异常', '2019-09-03 17:35:42');
INSERT INTO `access_log` VALUES (74654, '64.79.15675033438674637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:44', 2, 0, '', '2019-09-03 17:35:44');
INSERT INTO `access_log` VALUES (74655, '64.77.15675033440274615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:44', 2, 0, '', '2019-09-03 17:35:44');
INSERT INTO `access_log` VALUES (74656, '59.77.15675033452364209', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:45', 2, 0, '', '2019-09-03 17:35:45');
INSERT INTO `access_log` VALUES (74657, '59.72.15675033452264217', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:45', 12, 2001001000, '服务端发生异常', '2019-09-03 17:35:45');
INSERT INTO `access_log` VALUES (74658, '64.82.15675033468554649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:47', 2, 0, '', '2019-09-03 17:35:47');
INSERT INTO `access_log` VALUES (74659, '64.84.15675033470084633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:47', 2, 0, '', '2019-09-03 17:35:47');
INSERT INTO `access_log` VALUES (74660, '59.73.15675033485234217', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:49', 2, 0, '', '2019-09-03 17:35:49');
INSERT INTO `access_log` VALUES (74661, '59.79.15675033485334221', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:49', 9, 2001001000, '服务端发生异常', '2019-09-03 17:35:49');
INSERT INTO `access_log` VALUES (74662, '64.76.15675033587744643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:59', 2, 0, '', '2019-09-03 17:35:59');
INSERT INTO `access_log` VALUES (74663, '64.80.15675033589124633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:35:59', 1, 0, '', '2019-09-03 17:35:59');
INSERT INTO `access_log` VALUES (74664, '64.83.15675033600794631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:36:00', 2, 0, '', '2019-09-03 17:36:00');
INSERT INTO `access_log` VALUES (74665, '64.81.15675033602524641', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:36:00', 2, 0, '', '2019-09-03 17:36:00');
INSERT INTO `access_log` VALUES (74666, '59.76.15675033606474211', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:36:01', 4, 0, '', '2019-09-03 17:36:01');
INSERT INTO `access_log` VALUES (74667, '59.80.15675033606384191', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 8.0.0; Pixel 2 XL Build/OPD1.170816.004) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '1.180.239.193', '2019-09-03 17:36:01', 13, 2001001000, '服务端发生异常', '2019-09-03 17:36:01');
INSERT INTO `access_log` VALUES (74668, '65.51.15675033788997799', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.180.239.193', '2019-09-03 17:36:19', 0, 1002001015, '账号未登陆', '2019-09-03 17:36:19');
INSERT INTO `access_log` VALUES (74669, '65.53.15675033788997695', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.180.239.193', '2019-09-03 17:36:19', 0, 1002001015, '账号未登陆', '2019-09-03 17:36:19');
INSERT INTO `access_log` VALUES (74670, '65.54.15675033788997635', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.180.239.193', '2019-09-03 17:36:19', 0, 1002001015, '账号未登陆', '2019-09-03 17:36:19');
INSERT INTO `access_log` VALUES (74671, '65.47.15675033829867703', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.180.239.193', '2019-09-03 17:36:23', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 17:36:23');
INSERT INTO `access_log` VALUES (74672, '65.45.15675033991687789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.180.239.193', '2019-09-03 17:36:39', 71, 0, '', '2019-09-03 17:36:39');
INSERT INTO `access_log` VALUES (74673, '65.50.15675033995347767', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.180.239.193', '2019-09-03 17:36:40', 11, 2001001000, '服务端发生异常', '2019-09-03 17:36:40');
INSERT INTO `access_log` VALUES (74674, '65.3607.15675033995369555', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.180.239.193', '2019-09-03 17:36:40', 11, 0, '', '2019-09-03 17:36:40');
INSERT INTO `access_log` VALUES (74675, '65.46.15675033995427779', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.180.239.193', '2019-09-03 17:36:40', 8, 0, '', '2019-09-03 17:36:40');
INSERT INTO `access_log` VALUES (74676, '65.52.15675034650287817', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '1.180.239.193', '2019-09-03 17:37:45', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 17:37:45');
INSERT INTO `access_log` VALUES (74677, '65.50.15675044562077783', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.27.46.67', '2019-09-03 17:54:16', 0, 1002001015, '账号未登陆', '2019-09-03 17:54:16');
INSERT INTO `access_log` VALUES (74678, '65.51.15675044562087817', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.27.46.67', '2019-09-03 17:54:16', 0, 1002001015, '账号未登陆', '2019-09-03 17:54:16');
INSERT INTO `access_log` VALUES (74679, '65.54.15675044562127651', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.27.46.67', '2019-09-03 17:54:16', 0, 1002001015, '账号未登陆', '2019-09-03 17:54:16');
INSERT INTO `access_log` VALUES (74680, '65.53.15675044583027713', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.27.46.67', '2019-09-03 17:54:18', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 17:54:18');
INSERT INTO `access_log` VALUES (74681, '65.52.15675044648697831', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.27.46.67', '2019-09-03 17:54:25', 70, 0, '', '2019-09-03 17:54:25');
INSERT INTO `access_log` VALUES (74682, '65.49.15675044651717789', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.27.46.67', '2019-09-03 17:54:25', 10, 0, '', '2019-09-03 17:54:25');
INSERT INTO `access_log` VALUES (74683, '65.46.15675044651747797', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.27.46.67', '2019-09-03 17:54:25', 9, 0, '', '2019-09-03 17:54:25');
INSERT INTO `access_log` VALUES (74684, '65.45.15675044651737805', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.27.46.67', '2019-09-03 17:54:25', 10, 2001001000, '服务端发生异常', '2019-09-03 17:54:25');
INSERT INTO `access_log` VALUES (74685, '65.51.15675044952777819', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.27.46.67', '2019-09-03 17:54:55', 16, 0, '', '2019-09-03 17:54:55');
INSERT INTO `access_log` VALUES (74686, '65.54.15675044952777653', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.27.46.67', '2019-09-03 17:54:55', 18, 2001001000, '服务端发生异常', '2019-09-03 17:54:55');
INSERT INTO `access_log` VALUES (74687, '65.53.15675044952987715', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '112.27.46.67', '2019-09-03 17:54:55', 8, 0, '', '2019-09-03 17:54:55');
INSERT INTO `access_log` VALUES (74688, '59.80.15675057305544223', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 18:15:31', 10, 0, '', '2019-09-03 18:15:31');
INSERT INTO `access_log` VALUES (74689, '59.76.15675057305554243', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 18:15:31', 20, 2001001000, '服务端发生异常', '2019-09-03 18:15:31');
INSERT INTO `access_log` VALUES (74690, '59.77.15675060578294247', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.172.61.18', '2019-09-03 18:20:58', 3, 0, '', '2019-09-03 18:20:58');
INSERT INTO `access_log` VALUES (74691, '59.75.15675060578294263', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.172.61.18', '2019-09-03 18:20:58', 14, 2001001000, '服务端发生异常', '2019-09-03 18:20:58');
INSERT INTO `access_log` VALUES (74692, '64.85.15675060620194693', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.172.61.18', '2019-09-03 18:21:02', 11, 0, '', '2019-09-03 18:21:02');
INSERT INTO `access_log` VALUES (74693, '64.79.15675060621964675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.172.61.18', '2019-09-03 18:21:02', 3, 0, '', '2019-09-03 18:21:02');
INSERT INTO `access_log` VALUES (74694, '64.82.15675060658374687', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.172.61.18', '2019-09-03 18:21:06', 2, 0, '', '2019-09-03 18:21:06');
INSERT INTO `access_log` VALUES (74695, '64.84.15675060659624671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.172.61.18', '2019-09-03 18:21:06', 2, 0, '', '2019-09-03 18:21:06');
INSERT INTO `access_log` VALUES (74696, '64.78.15675060686144699', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.172.61.18', '2019-09-03 18:21:09', 2, 0, '', '2019-09-03 18:21:09');
INSERT INTO `access_log` VALUES (74697, '64.76.15675060688354681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.172.61.18', '2019-09-03 18:21:09', 2, 0, '', '2019-09-03 18:21:09');
INSERT INTO `access_log` VALUES (74698, '59.79.15675060692184259', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.172.61.18', '2019-09-03 18:21:09', 2, 0, '', '2019-09-03 18:21:09');
INSERT INTO `access_log` VALUES (74699, '59.73.15675060692184255', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.172.61.18', '2019-09-03 18:21:09', 13, 2001001000, '服务端发生异常', '2019-09-03 18:21:09');
INSERT INTO `access_log` VALUES (74700, '65.54.15675060916337675', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 18:21:32', 3, 1002001012, '访问令牌已过期', '2019-09-03 18:21:32');
INSERT INTO `access_log` VALUES (74701, '65.50.15675060916327807', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 18:21:32', 4, 1002001012, '访问令牌已过期', '2019-09-03 18:21:32');
INSERT INTO `access_log` VALUES (74702, '65.51.15675060916347841', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 18:21:32', 3, 1002001012, '访问令牌已过期', '2019-09-03 18:21:32');
INSERT INTO `access_log` VALUES (74703, '65.53.15675060933317737', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '220.181.38.105', '2019-09-03 18:21:33', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 18:21:33');
INSERT INTO `access_log` VALUES (74704, '64.85.15675061197884695', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:00', 2, 0, '', '2019-09-03 18:22:00');
INSERT INTO `access_log` VALUES (74705, '64.79.15675061199104677', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:00', 2, 0, '', '2019-09-03 18:22:00');
INSERT INTO `access_log` VALUES (74706, '64.77.15675061211164655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:01', 2, 0, '', '2019-09-03 18:22:01');
INSERT INTO `access_log` VALUES (74707, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:01', 5, 0, '', '2019-09-03 18:22:01');
INSERT INTO `access_log` VALUES (74708, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:07', 5, 0, '', '2019-09-03 18:22:07');
INSERT INTO `access_log` VALUES (74709, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:18', 5, 0, '', '2019-09-03 18:22:18');
INSERT INTO `access_log` VALUES (74710, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:19', 5, 0, '', '2019-09-03 18:22:19');
INSERT INTO `access_log` VALUES (74711, '64.84.15675061403624673', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:20', 130, 0, '', '2019-09-03 18:22:20');
INSERT INTO `access_log` VALUES (74712, '64.80.15675061583754673', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:38', 6, 0, '', '2019-09-03 18:22:38');
INSERT INTO `access_log` VALUES (74713, '64.83.15675061648464671', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:45', 2, 0, '', '2019-09-03 18:22:45');
INSERT INTO `access_log` VALUES (74714, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:45', 6, 0, '', '2019-09-03 18:22:45');
INSERT INTO `access_log` VALUES (74715, '64.81.15675061656724681', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:46', 2, 0, '', '2019-09-03 18:22:46');
INSERT INTO `access_log` VALUES (74716, '64.85.15675061657834697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:46', 2, 0, '', '2019-09-03 18:22:46');
INSERT INTO `access_log` VALUES (74717, '64.79.15675061688504679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:49', 2, 0, '', '2019-09-03 18:22:49');
INSERT INTO `access_log` VALUES (74718, '64.77.15675061694534657', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:49', 2, 0, '', '2019-09-03 18:22:49');
INSERT INTO `access_log` VALUES (74719, '64.82.15675061703764691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:50', 2, 0, '', '2019-09-03 18:22:50');
INSERT INTO `access_log` VALUES (74720, '64.84.15675061712714675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:51', 3, 0, '', '2019-09-03 18:22:51');
INSERT INTO `access_log` VALUES (74721, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:51', 6, 0, '', '2019-09-03 18:22:51');
INSERT INTO `access_log` VALUES (74722, '64.76.15675061728934685', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '220.181.38.105', '2019-09-03 18:22:53', 6, 0, '', '2019-09-03 18:22:53');
INSERT INTO `access_log` VALUES (74723, '59.80.15675062540594231', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.64.230.186', '2019-09-03 18:24:14', 3, 0, '', '2019-09-03 18:24:14');
INSERT INTO `access_log` VALUES (74724, '59.74.15675062540604273', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.64.230.186', '2019-09-03 18:24:14', 10, 2001001000, '服务端发生异常', '2019-09-03 18:24:14');
INSERT INTO `access_log` VALUES (74725, '64.77.15675068596424667', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.64.230.186', '2019-09-03 18:34:20', 3, 0, '', '2019-09-03 18:34:20');
INSERT INTO `access_log` VALUES (74726, '64.82.15675068597934701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.64.230.186', '2019-09-03 18:34:20', 2, 0, '', '2019-09-03 18:34:20');
INSERT INTO `access_log` VALUES (74727, '64.84.15675068606714685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.64.230.186', '2019-09-03 18:34:21', 2, 0, '', '2019-09-03 18:34:21');
INSERT INTO `access_log` VALUES (74728, '64.76.15675068613864695', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.64.230.186', '2019-09-03 18:34:21', 2, 0, '', '2019-09-03 18:34:21');
INSERT INTO `access_log` VALUES (74729, '59.75.15675068620284275', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.64.230.186', '2019-09-03 18:34:22', 3, 0, '', '2019-09-03 18:34:22');
INSERT INTO `access_log` VALUES (74730, '59.77.15675068620594259', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.64.230.186', '2019-09-03 18:34:22', 16, 2001001000, '服务端发生异常', '2019-09-03 18:34:22');
INSERT INTO `access_log` VALUES (74731, '64.80.15675068644844685', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.64.230.186', '2019-09-03 18:34:24', 1, 0, '', '2019-09-03 18:34:24');
INSERT INTO `access_log` VALUES (74732, '64.83.15675068646064683', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '124.64.230.186', '2019-09-03 18:34:25', 2, 0, '', '2019-09-03 18:34:25');
INSERT INTO `access_log` VALUES (74733, '65.53.15675099379187789', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.250.173.135', '2019-09-03 19:25:38', 1, 1002001015, '账号未登陆', '2019-09-03 19:25:38');
INSERT INTO `access_log` VALUES (74734, '65.45.15675099379207881', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.250.173.135', '2019-09-03 19:25:38', 0, 1002001015, '账号未登陆', '2019-09-03 19:25:38');
INSERT INTO `access_log` VALUES (74735, '65.47.15675099379207795', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.250.173.135', '2019-09-03 19:25:38', 0, 1002001015, '账号未登陆', '2019-09-03 19:25:38');
INSERT INTO `access_log` VALUES (74736, '65.46.15675099432327873', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.250.173.135', '2019-09-03 19:25:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 19:25:43');
INSERT INTO `access_log` VALUES (74737, '65.54.15675099481087727', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.250.173.135', '2019-09-03 19:25:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 19:25:48');
INSERT INTO `access_log` VALUES (74738, '65.3607.15675099611119647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.250.173.135', '2019-09-03 19:26:01', 85, 0, '', '2019-09-03 19:26:01');
INSERT INTO `access_log` VALUES (74739, '65.50.15675099616347859', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.250.173.135', '2019-09-03 19:26:02', 11, 0, '', '2019-09-03 19:26:02');
INSERT INTO `access_log` VALUES (74740, '65.52.15675099616397909', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.250.173.135', '2019-09-03 19:26:02', 10, 2001001000, '服务端发生异常', '2019-09-03 19:26:02');
INSERT INTO `access_log` VALUES (74741, '65.45.15675099616457883', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '118.250.173.135', '2019-09-03 19:26:02', 9, 0, '', '2019-09-03 19:26:02');
INSERT INTO `access_log` VALUES (74742, '65.53.15675104160987797', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.109.188.117', '2019-09-03 19:33:36', 4, 1002001012, '访问令牌已过期', '2019-09-03 19:33:36');
INSERT INTO `access_log` VALUES (74743, '65.47.15675104160997803', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.109.188.117', '2019-09-03 19:33:36', 3, 1002001012, '访问令牌已过期', '2019-09-03 19:33:36');
INSERT INTO `access_log` VALUES (74744, '65.49.15675104161007873', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '180.109.188.117', '2019-09-03 19:33:36', 3, 1002001012, '访问令牌已过期', '2019-09-03 19:33:36');
INSERT INTO `access_log` VALUES (74745, '59.77.15675131567284343', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.63.85', '2019-09-03 20:19:17', 12, 0, '', '2019-09-03 20:19:17');
INSERT INTO `access_log` VALUES (74746, '59.72.15675131567584351', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.63.85', '2019-09-03 20:19:17', 20, 2001001000, '服务端发生异常', '2019-09-03 20:19:17');
INSERT INTO `access_log` VALUES (74747, '65.52.15675131653277953', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.63.85', '2019-09-03 20:19:25', 1, 1002001015, '账号未登陆', '2019-09-03 20:19:25');
INSERT INTO `access_log` VALUES (74748, '65.50.15675131653387903', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.63.85', '2019-09-03 20:19:25', 0, 1002001015, '账号未登陆', '2019-09-03 20:19:25');
INSERT INTO `access_log` VALUES (74749, '65.45.15675131653387927', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.63.85', '2019-09-03 20:19:25', 0, 1002001015, '账号未登陆', '2019-09-03 20:19:25');
INSERT INTO `access_log` VALUES (74750, '65.47.15675131676407841', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.104.63.85', '2019-09-03 20:19:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 20:19:28');
INSERT INTO `access_log` VALUES (74751, '65.50.15675185451407975', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.118.234.127', '2019-09-03 21:49:05', 0, 1002001015, '账号未登陆', '2019-09-03 21:49:05');
INSERT INTO `access_log` VALUES (74752, '65.45.15675185451407999', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.118.234.127', '2019-09-03 21:49:05', 1, 1002001015, '账号未登陆', '2019-09-03 21:49:05');
INSERT INTO `access_log` VALUES (74753, '65.52.15675185451408027', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.118.234.127', '2019-09-03 21:49:05', 0, 1002001015, '账号未登陆', '2019-09-03 21:49:05');
INSERT INTO `access_log` VALUES (74754, '65.47.15675185469007915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.118.234.127', '2019-09-03 21:49:07', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 21:49:07');
INSERT INTO `access_log` VALUES (74755, '65.53.15675185603317907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.118.234.127', '2019-09-03 21:49:20', 93, 0, '', '2019-09-03 21:49:20');
INSERT INTO `access_log` VALUES (74756, '65.46.15675185606557995', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.118.234.127', '2019-09-03 21:49:21', 14, 0, '', '2019-09-03 21:49:21');
INSERT INTO `access_log` VALUES (74757, '65.51.15675185606618015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.118.234.127', '2019-09-03 21:49:21', 11, 0, '', '2019-09-03 21:49:21');
INSERT INTO `access_log` VALUES (74758, '65.54.15675185606597845', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.118.234.127', '2019-09-03 21:49:21', 20, 2001001000, '服务端发生异常', '2019-09-03 21:49:21');
INSERT INTO `access_log` VALUES (74759, '65.45.15675185734798001', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.118.234.127', '2019-09-03 21:49:33', 8, 0, '', '2019-09-03 21:49:33');
INSERT INTO `access_log` VALUES (74760, '65.50.15675185734827977', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.118.234.127', '2019-09-03 21:49:33', 8, 2001001000, '服务端发生异常', '2019-09-03 21:49:33');
INSERT INTO `access_log` VALUES (74761, '65.52.15675185734848029', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.118.234.127', '2019-09-03 21:49:33', 8, 0, '', '2019-09-03 21:49:33');
INSERT INTO `access_log` VALUES (74762, '65.3607.15675188015789769', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:53:22', 12, 1002001012, '访问令牌已过期', '2019-09-03 21:53:22');
INSERT INTO `access_log` VALUES (74763, '65.50.15675188015797981', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:53:22', 11, 1002001012, '访问令牌已过期', '2019-09-03 21:53:22');
INSERT INTO `access_log` VALUES (74764, '65.54.15675188015787849', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:53:22', 13, 1002001012, '访问令牌已过期', '2019-09-03 21:53:22');
INSERT INTO `access_log` VALUES (74765, '65.45.15675188054088005', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:53:25', 102, 0, '', '2019-09-03 21:53:26');
INSERT INTO `access_log` VALUES (74766, '65.47.15675188058187921', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:53:26', 131, 0, '', '2019-09-03 21:53:26');
INSERT INTO `access_log` VALUES (74767, '65.53.15675188058207913', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:53:26', 129, 0, '', '2019-09-03 21:53:26');
INSERT INTO `access_log` VALUES (74768, '65.49.15675188058197989', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:53:26', 132, 0, '', '2019-09-03 21:53:26');
INSERT INTO `access_log` VALUES (74769, '64.76.15675188100984855', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:53:30', 26, 0, '', '2019-09-03 21:53:30');
INSERT INTO `access_log` VALUES (74770, '64.84.15675188100984845', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:53:30', 30, 0, '', '2019-09-03 21:53:30');
INSERT INTO `access_log` VALUES (74771, '64.83.15675188113184843', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:53:31', 11, 0, '', '2019-09-03 21:53:31');
INSERT INTO `access_log` VALUES (74772, '64.80.15675188113184845', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:53:31', 15, 0, '', '2019-09-03 21:53:31');
INSERT INTO `access_log` VALUES (74773, '65.46.15675189794758003', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:56:19', 9, 0, '', '2019-09-03 21:56:19');
INSERT INTO `access_log` VALUES (74774, '65.3607.15675189794789773', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:56:19', 8, 0, '', '2019-09-03 21:56:19');
INSERT INTO `access_log` VALUES (74775, '65.54.15675189794807853', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:56:19', 8, 0, '', '2019-09-03 21:56:19');
INSERT INTO `access_log` VALUES (74776, '64.79.15675189795664853', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:56:20', 18, 0, '', '2019-09-03 21:56:20');
INSERT INTO `access_log` VALUES (74777, '64.85.15675189795654871', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 21:56:20', 20, 0, '', '2019-09-03 21:56:20');
INSERT INTO `access_log` VALUES (74778, '65.47.15675197709397935', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:31', 11, 0, '', '2019-09-03 22:09:31');
INSERT INTO `access_log` VALUES (74779, '65.49.15675197709428003', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:31', 16, 0, '', '2019-09-03 22:09:31');
INSERT INTO `access_log` VALUES (74780, '65.53.15675197709387927', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:31', 21, 0, '', '2019-09-03 22:09:31');
INSERT INTO `access_log` VALUES (74781, '64.76.15675197724744869', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:32', 11, 0, '', '2019-09-03 22:09:32');
INSERT INTO `access_log` VALUES (74782, '64.84.15675197724734859', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:32', 243, 0, '', '2019-09-03 22:09:33');
INSERT INTO `access_log` VALUES (74783, '59.78.15675197813554455', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:41', 25, 0, '', '2019-09-03 22:09:41');
INSERT INTO `access_log` VALUES (74784, '59.76.15675197844484433', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:44', 17, 2001001000, '服务端发生异常', '2019-09-03 22:09:44');
INSERT INTO `access_log` VALUES (74785, '59.80.15675197865984413', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:47', 18, 0, '', '2019-09-03 22:09:47');
INSERT INTO `access_log` VALUES (74786, '59.74.15675197883984455', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:48', 198, 0, '', '2019-09-03 22:09:49');
INSERT INTO `access_log` VALUES (74787, '59.75.15675197892314449', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '221.238.245.47', '2019-09-03 22:09:49', 2, 0, '', '2019-09-03 22:09:49');
INSERT INTO `access_log` VALUES (74788, '59.77.15675197892384433', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '221.238.245.47', '2019-09-03 22:09:49', 22, 2001001000, '服务端发生异常', '2019-09-03 22:09:49');
INSERT INTO `access_log` VALUES (74789, '59.72.15675197913994441', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:51', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-09-03 22:09:51');
INSERT INTO `access_log` VALUES (74790, '65.46.15675197932338015', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:53', 26, 0, '', '2019-09-03 22:09:53');
INSERT INTO `access_log` VALUES (74791, '65.54.15675197942767865', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:54', 18, 0, '', '2019-09-03 22:09:54');
INSERT INTO `access_log` VALUES (74792, '65.50.15675197952187997', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:55', 10, 0, '', '2019-09-03 22:09:55');
INSERT INTO `access_log` VALUES (74793, '65.52.15675197958908049', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:56', 14, 0, '', '2019-09-03 22:09:56');
INSERT INTO `access_log` VALUES (74794, '62.87.15675197985732983', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:09:59', 30, 0, '', '2019-09-03 22:09:59');
INSERT INTO `access_log` VALUES (74795, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=123&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '221.238.245.47', '2019-09-03 22:10:02', 5, 0, '', '2019-09-03 22:10:02');
INSERT INTO `access_log` VALUES (74796, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=123', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '221.238.245.47', '2019-09-03 22:10:02', 7, 0, '', '2019-09-03 22:10:02');
INSERT INTO `access_log` VALUES (74797, '59.79.15675198046654445', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '221.238.245.47', '2019-09-03 22:10:05', 2, 0, '', '2019-09-03 22:10:05');
INSERT INTO `access_log` VALUES (74798, '59.78.15675198046654457', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '221.238.245.47', '2019-09-03 22:10:05', 15, 2001001000, '服务端发生异常', '2019-09-03 22:10:05');
INSERT INTO `access_log` VALUES (74799, '64.85.15675198074134883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '221.238.245.47', '2019-09-03 22:10:07', 3, 0, '', '2019-09-03 22:10:07');
INSERT INTO `access_log` VALUES (74800, '64.79.15675198075144865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '221.238.245.47', '2019-09-03 22:10:08', 1, 0, '', '2019-09-03 22:10:08');
INSERT INTO `access_log` VALUES (74801, '64.77.15675198091604843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '221.238.245.47', '2019-09-03 22:10:09', 2, 0, '', '2019-09-03 22:10:09');
INSERT INTO `access_log` VALUES (74802, '64.82.15675198100734877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '221.238.245.47', '2019-09-03 22:10:10', 3, 0, '', '2019-09-03 22:10:10');
INSERT INTO `access_log` VALUES (74803, '64.78.15675198108344889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '221.238.245.47', '2019-09-03 22:10:11', 2, 0, '', '2019-09-03 22:10:11');
INSERT INTO `access_log` VALUES (74804, '64.76.15675198113214871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '221.238.245.47', '2019-09-03 22:10:11', 2, 0, '', '2019-09-03 22:10:11');
INSERT INTO `access_log` VALUES (74805, '59.80.15675198145874415', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '221.238.245.47', '2019-09-03 22:10:15', 2, 0, '', '2019-09-03 22:10:15');
INSERT INTO `access_log` VALUES (74806, '59.76.15675198145874435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '221.238.245.47', '2019-09-03 22:10:15', 18, 2001001000, '服务端发生异常', '2019-09-03 22:10:15');
INSERT INTO `access_log` VALUES (74807, '59.77.15675200002784437', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:20', 3, 0, '', '2019-09-03 22:13:20');
INSERT INTO `access_log` VALUES (74808, '59.72.15675200002784445', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:20', 13, 2001001000, '服务端发生异常', '2019-09-03 22:13:20');
INSERT INTO `access_log` VALUES (74809, '64.85.15675200161674887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:36', 2, 0, '', '2019-09-03 22:13:36');
INSERT INTO `access_log` VALUES (74810, '64.79.15675200162644869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:36', 1, 0, '', '2019-09-03 22:13:36');
INSERT INTO `access_log` VALUES (74811, '64.77.15675200173154847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:37', 2, 0, '', '2019-09-03 22:13:37');
INSERT INTO `access_log` VALUES (74812, '64.82.15675200177654881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:38', 2, 0, '', '2019-09-03 22:13:38');
INSERT INTO `access_log` VALUES (74813, '64.78.15675200181904893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:38', 2, 0, '', '2019-09-03 22:13:38');
INSERT INTO `access_log` VALUES (74814, '65.46.15675200253538019', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:45', 1, 1002001015, '账号未登陆', '2019-09-03 22:13:45');
INSERT INTO `access_log` VALUES (74815, '65.3607.15675200253549789', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:45', 0, 1002001015, '账号未登陆', '2019-09-03 22:13:45');
INSERT INTO `access_log` VALUES (74816, '65.54.15675200253587869', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:45', 1, 1002001015, '账号未登陆', '2019-09-03 22:13:45');
INSERT INTO `access_log` VALUES (74817, '65.50.15675200276248001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:48', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-03 22:13:48');
INSERT INTO `access_log` VALUES (74818, '65.52.15675200331888053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:53', 65, 0, '', '2019-09-03 22:13:53');
INSERT INTO `access_log` VALUES (74819, '65.53.15675200334477933', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:53', 16, 0, '', '2019-09-03 22:13:53');
INSERT INTO `access_log` VALUES (74820, '65.45.15675200334468025', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:53', 17, 2001001000, '服务端发生异常', '2019-09-03 22:13:53');
INSERT INTO `access_log` VALUES (74821, '65.47.15675200334577941', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.70.63.248', '2019-09-03 22:13:53', 9, 0, '', '2019-09-03 22:13:53');
INSERT INTO `access_log` VALUES (74822, '64.83.15675209335104875', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:28:54', 11, 0, '', '2019-09-03 22:28:54');
INSERT INTO `access_log` VALUES (74823, '64.84.15675209335094877', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:28:54', 13, 0, '', '2019-09-03 22:28:54');
INSERT INTO `access_log` VALUES (74824, '64.81.15675209354864885', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:28:55', 11, 0, '', '2019-09-03 22:28:55');
INSERT INTO `access_log` VALUES (74825, '64.80.15675209354864877', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:28:55', 14, 0, '', '2019-09-03 22:28:56');
INSERT INTO `access_log` VALUES (74826, '62.88.15675213716582999', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:36:12', 24, 0, '', '2019-09-03 22:36:12');
INSERT INTO `access_log` VALUES (74827, '62.85.15675213772063035', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-03 22:36:17', 14, 0, '', '2019-09-03 22:36:17');
INSERT INTO `access_log` VALUES (74828, '65.49.15675257223548085', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0', '117.136.0.211', '2019-09-03 23:48:42', 13, 1002001012, '访问令牌已过期', '2019-09-03 23:48:42');
INSERT INTO `access_log` VALUES (74829, '65.51.15675257223558117', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0', '117.136.0.211', '2019-09-03 23:48:42', 19, 1002001012, '访问令牌已过期', '2019-09-03 23:48:42');
INSERT INTO `access_log` VALUES (74830, '65.46.15675257223558097', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0', '117.136.0.211', '2019-09-03 23:48:42', 19, 1002001012, '访问令牌已过期', '2019-09-03 23:48:42');
INSERT INTO `access_log` VALUES (74831, '59.80.15675263347384503', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-03 23:58:55', 17, 2001001000, '服务端发生异常', '2019-09-03 23:58:55');
INSERT INTO `access_log` VALUES (74832, '59.78.15675263347294545', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-03 23:58:55', 93, 0, '', '2019-09-03 23:58:55');
INSERT INTO `access_log` VALUES (74833, '64.79.15675263463414955', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-03 23:59:06', 11, 0, '', '2019-09-03 23:59:06');
INSERT INTO `access_log` VALUES (74834, '64.77.15675263468644933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-03 23:59:07', 3, 0, '', '2019-09-03 23:59:07');
INSERT INTO `access_log` VALUES (74835, '65.53.15675268718978025', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-04 00:07:52', 1, 1002001015, '账号未登陆', '2019-09-04 00:07:52');
INSERT INTO `access_log` VALUES (74836, '65.45.15675268718968119', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-04 00:07:52', 1, 1002001015, '账号未登陆', '2019-09-04 00:07:52');
INSERT INTO `access_log` VALUES (74837, '65.47.15675268729078035', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-04 00:07:53', 1, 1002001015, '账号未登陆', '2019-09-04 00:07:53');
INSERT INTO `access_log` VALUES (74838, '65.49.15675268780638101', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-04 00:07:58', 0, 1002001015, '账号未登陆', '2019-09-04 00:07:58');
INSERT INTO `access_log` VALUES (74839, '65.54.15675268832727963', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '183.131.116.97', '2019-09-04 00:08:03', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 00:08:03');
INSERT INTO `access_log` VALUES (74840, '65.51.15675269091288133', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoadmin&password=yudaonicai&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '183.131.116.97', '2019-09-04 00:08:29', 4, 1002002000, '账号不存在', '2019-09-04 00:08:29');
INSERT INTO `access_log` VALUES (74841, '65.53.15675269410058027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '183.131.116.97', '2019-09-04 00:09:01', 91, 0, '', '2019-09-04 00:09:01');
INSERT INTO `access_log` VALUES (74842, '65.47.15675269437168037', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-04 00:09:04', 12, 2001001000, '服务端发生异常', '2019-09-04 00:09:04');
INSERT INTO `access_log` VALUES (74843, '65.46.15675269437428117', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-04 00:09:04', 9, 0, '', '2019-09-04 00:09:04');
INSERT INTO `access_log` VALUES (74844, '65.49.15675269437628103', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-04 00:09:04', 9, 0, '', '2019-09-04 00:09:04');
INSERT INTO `access_log` VALUES (74845, '65.50.15675269642298099', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-04 00:09:24', 8, 0, '', '2019-09-04 00:09:24');
INSERT INTO `access_log` VALUES (74846, '65.51.15675269642618135', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-04 00:09:24', 9, 0, '', '2019-09-04 00:09:24');
INSERT INTO `access_log` VALUES (74847, '65.52.15675269654278151', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-04 00:09:25', 11, 2001001000, '服务端发生异常', '2019-09-04 00:09:25');
INSERT INTO `access_log` VALUES (74848, '65.45.15675269664338123', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; Android 7.0; EVA-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.143 Mobile Safari/537.36', '112.48.22.73', '2019-09-04 00:09:26', 9, 2001001000, '服务端发生异常', '2019-09-04 00:09:26');
INSERT INTO `access_log` VALUES (74849, '59.76.15675272211014535', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.229.45.201', '2019-09-04 00:13:41', 7, 0, '', '2019-09-04 00:13:41');
INSERT INTO `access_log` VALUES (74850, '59.78.15675272211014557', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.229.45.201', '2019-09-04 00:13:41', 12, 2001001000, '服务端发生异常', '2019-09-04 00:13:41');
INSERT INTO `access_log` VALUES (74851, '65.52.15675272361638155', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.229.45.201', '2019-09-04 00:13:56', 1, 1002001015, '账号未登陆', '2019-09-04 00:13:56');
INSERT INTO `access_log` VALUES (74852, '65.45.15675272361658127', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.229.45.201', '2019-09-04 00:13:56', 1, 1002001015, '账号未登陆', '2019-09-04 00:13:56');
INSERT INTO `access_log` VALUES (74853, '65.53.15675272361688033', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.229.45.201', '2019-09-04 00:13:56', 0, 1002001015, '账号未登陆', '2019-09-04 00:13:56');
INSERT INTO `access_log` VALUES (74854, '65.46.15675272391368123', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.229.45.201', '2019-09-04 00:13:59', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 00:13:59');
INSERT INTO `access_log` VALUES (74855, '65.3607.15675280397519901', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '42.236.10.75', '2019-09-04 00:27:20', 1, 1002001015, '账号未登陆', '2019-09-04 00:27:20');
INSERT INTO `access_log` VALUES (74856, '65.50.15675280397528115', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '42.236.10.78', '2019-09-04 00:27:20', 0, 1002001015, '账号未登陆', '2019-09-04 00:27:20');
INSERT INTO `access_log` VALUES (74857, '65.51.15675280397638151', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '42.236.10.78', '2019-09-04 00:27:20', 0, 1002001015, '账号未登陆', '2019-09-04 00:27:20');
INSERT INTO `access_log` VALUES (74858, '65.54.15675281261627983', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '36.110.118.131', '2019-09-04 00:28:46', 0, 1002001015, '账号未登陆', '2019-09-04 00:28:46');
INSERT INTO `access_log` VALUES (74859, '65.50.15675281261678117', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '36.110.118.131', '2019-09-04 00:28:46', 1, 1002001015, '账号未登陆', '2019-09-04 00:28:46');
INSERT INTO `access_log` VALUES (74860, '65.3607.15675281261709903', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '36.110.118.131', '2019-09-04 00:28:46', 1, 1002001015, '账号未登陆', '2019-09-04 00:28:46');
INSERT INTO `access_log` VALUES (74861, '59.73.15675281987194555', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '36.110.118.131', '2019-09-04 00:29:59', 2, 0, '', '2019-09-04 00:29:59');
INSERT INTO `access_log` VALUES (74862, '59.79.15675281987214559', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '36.110.118.131', '2019-09-04 00:29:59', 12, 2001001000, '服务端发生异常', '2019-09-04 00:29:59');
INSERT INTO `access_log` VALUES (74863, '64.83.15675282019414973', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '36.110.118.131', '2019-09-04 00:30:02', 13, 0, '', '2019-09-04 00:30:02');
INSERT INTO `access_log` VALUES (74864, '64.84.15675282021154975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '36.110.118.131', '2019-09-04 00:30:02', 4, 0, '', '2019-09-04 00:30:02');
INSERT INTO `access_log` VALUES (74865, '64.81.15675282047774983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '36.110.118.131', '2019-09-04 00:30:05', 2, 0, '', '2019-09-04 00:30:05');
INSERT INTO `access_log` VALUES (74866, '64.80.15675282049244975', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '36.110.118.131', '2019-09-04 00:30:05', 2, 0, '', '2019-09-04 00:30:05');
INSERT INTO `access_log` VALUES (74867, '59.76.15675282053874549', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '36.110.118.131', '2019-09-04 00:30:05', 2, 0, '', '2019-09-04 00:30:05');
INSERT INTO `access_log` VALUES (74868, '59.78.15675282053864571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '36.110.118.131', '2019-09-04 00:30:05', 9, 2001001000, '服务端发生异常', '2019-09-04 00:30:05');
INSERT INTO `access_log` VALUES (74869, '65.49.15675311284948163', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.68', '2019-09-04 01:18:48', 0, 1002001015, '账号未登陆', '2019-09-04 01:18:48');
INSERT INTO `access_log` VALUES (74870, '65.45.15675311284948181', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.3', '2019-09-04 01:18:48', 1, 1002001015, '账号未登陆', '2019-09-04 01:18:48');
INSERT INTO `access_log` VALUES (74871, '65.50.15675311284958157', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.5', '2019-09-04 01:18:48', 0, 1002001015, '账号未登陆', '2019-09-04 01:18:48');
INSERT INTO `access_log` VALUES (74872, '59.80.15675338473614605', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.167.101.22', '2019-09-04 02:04:07', 20, 2001001000, '服务端发生异常', '2019-09-04 02:04:07');
INSERT INTO `access_log` VALUES (74873, '59.79.15675338473614635', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.167.101.22', '2019-09-04 02:04:07', 15, 0, '', '2019-09-04 02:04:07');
INSERT INTO `access_log` VALUES (74874, '59.78.15675338597694647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-09-04 02:04:20', 3, 0, '', '2019-09-04 02:04:20');
INSERT INTO `access_log` VALUES (74875, '59.74.15675338597694647', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-09-04 02:04:20', 13, 2001001000, '服务端发生异常', '2019-09-04 02:04:20');
INSERT INTO `access_log` VALUES (74876, '64.81.15675338625825059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-09-04 02:04:23', 11, 0, '', '2019-09-04 02:04:23');
INSERT INTO `access_log` VALUES (74877, '64.80.15675338626675051', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-09-04 02:04:23', 3, 0, '', '2019-09-04 02:04:23');
INSERT INTO `access_log` VALUES (74878, '64.85.15675338639905075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-09-04 02:04:24', 2, 0, '', '2019-09-04 02:04:24');
INSERT INTO `access_log` VALUES (74879, '64.79.15675338644525057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-09-04 02:04:24', 2, 0, '', '2019-09-04 02:04:24');
INSERT INTO `access_log` VALUES (74880, '59.71.15675338655574631', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-09-04 02:04:26', 3, 0, '', '2019-09-04 02:04:26');
INSERT INTO `access_log` VALUES (74881, '59.75.15675338655574641', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-09-04 02:04:26', 21, 2001001000, '服务端发生异常', '2019-09-04 02:04:26');
INSERT INTO `access_log` VALUES (74882, '59.74.15675449046604795', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.67', '2019-09-04 05:08:25', 13, 0, '', '2019-09-04 05:08:25');
INSERT INTO `access_log` VALUES (74883, '59.78.15675449046604795', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.5', '2019-09-04 05:08:25', 31, 2001001000, '服务端发生异常', '2019-09-04 05:08:25');
INSERT INTO `access_log` VALUES (74884, '59.73.15675560673284929', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.174.206.134', '2019-09-04 08:14:27', 10, 0, '', '2019-09-04 08:14:27');
INSERT INTO `access_log` VALUES (74885, '59.80.15675560673384903', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.174.206.134', '2019-09-04 08:14:27', 17, 2001001000, '服务端发生异常', '2019-09-04 08:14:27');
INSERT INTO `access_log` VALUES (74886, '64.82.15675560771575365', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.174.206.134', '2019-09-04 08:14:37', 12, 0, '', '2019-09-04 08:14:37');
INSERT INTO `access_log` VALUES (74887, '64.78.15675560772665377', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.174.206.134', '2019-09-04 08:14:37', 5, 0, '', '2019-09-04 08:14:37');
INSERT INTO `access_log` VALUES (74888, '65.45.15675561185558515', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.174.206.134', '2019-09-04 08:15:19', 0, 1002001015, '账号未登陆', '2019-09-04 08:15:19');
INSERT INTO `access_log` VALUES (74889, '65.47.15675561185558431', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.174.206.134', '2019-09-04 08:15:19', 1, 1002001015, '账号未登陆', '2019-09-04 08:15:19');
INSERT INTO `access_log` VALUES (74890, '65.49.15675561185588497', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.174.206.134', '2019-09-04 08:15:19', 0, 1002001015, '账号未登陆', '2019-09-04 08:15:19');
INSERT INTO `access_log` VALUES (74891, '65.50.15675561210268491', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.174.206.134', '2019-09-04 08:15:21', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 08:15:21');
INSERT INTO `access_log` VALUES (74892, '65.51.15675561408788527', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.174.206.134', '2019-09-04 08:15:41', 84, 0, '', '2019-09-04 08:15:41');
INSERT INTO `access_log` VALUES (74893, '65.53.15675561412158421', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.174.206.134', '2019-09-04 08:15:41', 16, 0, '', '2019-09-04 08:15:41');
INSERT INTO `access_log` VALUES (74894, '65.52.15675561412188543', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.174.206.134', '2019-09-04 08:15:41', 15, 2001001000, '服务端发生异常', '2019-09-04 08:15:41');
INSERT INTO `access_log` VALUES (74895, '65.46.15675561412268513', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '60.174.206.134', '2019-09-04 08:15:41', 13, 0, '', '2019-09-04 08:15:41');
INSERT INTO `access_log` VALUES (74896, '64.77.15675561886355333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:16:29', 4, 0, '', '2019-09-04 08:16:29');
INSERT INTO `access_log` VALUES (74897, '64.82.15675561887435367', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:16:29', 1, 0, '', '2019-09-04 08:16:29');
INSERT INTO `access_log` VALUES (74898, '64.78.15675561904365379', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:16:30', 2, 0, '', '2019-09-04 08:16:30');
INSERT INTO `access_log` VALUES (74899, '64.76.15675561912835361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:16:31', 2, 0, '', '2019-09-04 08:16:31');
INSERT INTO `access_log` VALUES (74900, '64.83.15675561934325349', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:16:33', 2, 0, '', '2019-09-04 08:16:33');
INSERT INTO `access_log` VALUES (74901, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:16:33', 5, 0, '', '2019-09-04 08:16:33');
INSERT INTO `access_log` VALUES (74902, '64.81.15675561958955359', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:16:36', 2, 0, '', '2019-09-04 08:16:36');
INSERT INTO `access_log` VALUES (74903, '64.80.15675561960045351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:16:36', 1, 0, '', '2019-09-04 08:16:36');
INSERT INTO `access_log` VALUES (74904, '64.85.15675561974545375', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:16:37', 2, 0, '', '2019-09-04 08:16:37');
INSERT INTO `access_log` VALUES (74905, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:16:37', 6, 0, '', '2019-09-04 08:16:37');
INSERT INTO `access_log` VALUES (74906, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:16:39', 7, 0, '', '2019-09-04 08:16:39');
INSERT INTO `access_log` VALUES (74907, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:16:40', 6, 0, '', '2019-09-04 08:16:40');
INSERT INTO `access_log` VALUES (74908, '64.79.15675562052475357', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=38', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:16:45', 7, 0, '', '2019-09-04 08:16:45');
INSERT INTO `access_log` VALUES (74909, '64.82.15675562233155369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:17:03', 3, 0, '', '2019-09-04 08:17:03');
INSERT INTO `access_log` VALUES (74910, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:17:03', 5, 0, '', '2019-09-04 08:17:03');
INSERT INTO `access_log` VALUES (74911, '64.78.15675562239875381', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:17:04', 2, 0, '', '2019-09-04 08:17:04');
INSERT INTO `access_log` VALUES (74912, '64.76.15675562240735363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:17:04', 2, 0, '', '2019-09-04 08:17:04');
INSERT INTO `access_log` VALUES (74913, '59.76.15675562254214925', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:17:05', 3, 0, '', '2019-09-04 08:17:05');
INSERT INTO `access_log` VALUES (74914, '59.78.15675562254224947', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '60.174.206.134', '2019-09-04 08:17:05', 18, 2001001000, '服务端发生异常', '2019-09-04 08:17:05');
INSERT INTO `access_log` VALUES (74915, '59.79.15675594821854979', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.104.225.140', '2019-09-04 09:11:22', 11, 0, '', '2019-09-04 09:11:22');
INSERT INTO `access_log` VALUES (74916, '59.76.15675594821884969', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.104.225.140', '2019-09-04 09:11:22', 25, 2001001000, '服务端发生异常', '2019-09-04 09:11:22');
INSERT INTO `access_log` VALUES (74917, '64.85.15675595748145421', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 4.0; en-us; GT-I9300 Build/IMM76D) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30', '218.104.225.140', '2019-09-04 09:12:55', 11, 0, '', '2019-09-04 09:12:55');
INSERT INTO `access_log` VALUES (74918, '64.79.15675595749345403', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 4.0; en-us; GT-I9300 Build/IMM76D) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30', '218.104.225.140', '2019-09-04 09:12:55', 3, 0, '', '2019-09-04 09:12:55');
INSERT INTO `access_log` VALUES (74919, '64.78.15675596095495427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; U; Android 4.0; en-us; GT-I9300 Build/IMM76D) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30', '218.104.225.140', '2019-09-04 09:13:30', 2, 0, '', '2019-09-04 09:13:30');
INSERT INTO `access_log` VALUES (74920, '64.76.15675596096875409', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; U; Android 4.0; en-us; GT-I9300 Build/IMM76D) AppleWebKit/534.30 (KHTML, like Gecko) Version/4.0 Mobile Safari/534.30', '218.104.225.140', '2019-09-04 09:13:30', 3, 0, '', '2019-09-04 09:13:30');
INSERT INTO `access_log` VALUES (74921, '59.78.15675596316474993', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:13:52', 4, 0, '', '2019-09-04 09:13:52');
INSERT INTO `access_log` VALUES (74922, '59.74.15675596317114993', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:13:52', 36, 2001001000, '服务端发生异常', '2019-09-04 09:13:52');
INSERT INTO `access_log` VALUES (74923, '59.75.15675596572994987', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:14:17', 2, 0, '', '2019-09-04 09:14:17');
INSERT INTO `access_log` VALUES (74924, '59.77.15675596573004971', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:14:17', 20, 2001001000, '服务端发生异常', '2019-09-04 09:14:17');
INSERT INTO `access_log` VALUES (74925, '64.79.15675596900735405', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:14:50', 3, 0, '', '2019-09-04 09:14:50');
INSERT INTO `access_log` VALUES (74926, '64.77.15675596903065383', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:14:50', 2, 0, '', '2019-09-04 09:14:50');
INSERT INTO `access_log` VALUES (74927, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:14:52', 6, 0, '', '2019-09-04 09:14:52');
INSERT INTO `access_log` VALUES (74928, '64.78.15675596915625429', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:14:52', 2, 0, '', '2019-09-04 09:14:52');
INSERT INTO `access_log` VALUES (74929, '64.76.15675596937035411', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:14:54', 8, 0, '', '2019-09-04 09:14:54');
INSERT INTO `access_log` VALUES (74930, '64.84.15675597181975401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:15:18', 2, 0, '', '2019-09-04 09:15:18');
INSERT INTO `access_log` VALUES (74931, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:15:18', 6, 0, '', '2019-09-04 09:15:18');
INSERT INTO `access_log` VALUES (74932, '64.80.15675597209755401', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:15:21', 2, 0, '', '2019-09-04 09:15:21');
INSERT INTO `access_log` VALUES (74933, '64.85.15675597211435425', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:15:21', 2, 0, '', '2019-09-04 09:15:21');
INSERT INTO `access_log` VALUES (74934, '59.74.15675597425004995', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:15:43', 9, 0, '', '2019-09-04 09:15:43');
INSERT INTO `access_log` VALUES (74935, '59.71.15675597425014979', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '218.104.225.140', '2019-09-04 09:15:43', 22, 2001001000, '服务端发生异常', '2019-09-04 09:15:43');
INSERT INTO `access_log` VALUES (74936, '65.45.15675612805258585', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '180.154.199.114', '2019-09-04 09:41:21', 4, 1002001012, '访问令牌已过期', '2019-09-04 09:41:21');
INSERT INTO `access_log` VALUES (74937, '65.54.15675612805288429', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '180.154.199.114', '2019-09-04 09:41:21', 4, 1002001012, '访问令牌已过期', '2019-09-04 09:41:21');
INSERT INTO `access_log` VALUES (74938, '65.50.15675612805288561', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '180.154.199.114', '2019-09-04 09:41:21', 3, 1002001012, '访问令牌已过期', '2019-09-04 09:41:21');
INSERT INTO `access_log` VALUES (74939, '65.51.15675612929878597', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '180.154.199.114', '2019-09-04 09:41:33', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 09:41:33');
INSERT INTO `access_log` VALUES (74940, '65.52.15675612970248613', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '180.154.199.114', '2019-09-04 09:41:37', 93, 0, '', '2019-09-04 09:41:37');
INSERT INTO `access_log` VALUES (74941, '65.53.15675612978058491', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '180.154.199.114', '2019-09-04 09:41:38', 18, 0, '', '2019-09-04 09:41:38');
INSERT INTO `access_log` VALUES (74942, '65.46.15675612978068583', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '180.154.199.114', '2019-09-04 09:41:38', 19, 2001001000, '服务端发生异常', '2019-09-04 09:41:38');
INSERT INTO `access_log` VALUES (74943, '65.49.15675612978248569', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '180.154.199.114', '2019-09-04 09:41:38', 8, 0, '', '2019-09-04 09:41:38');
INSERT INTO `access_log` VALUES (74944, '65.50.15675613021338563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '180.154.199.114', '2019-09-04 09:41:42', 10, 0, '', '2019-09-04 09:41:42');
INSERT INTO `access_log` VALUES (74945, '65.54.15675613021318431', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '180.154.199.114', '2019-09-04 09:41:42', 16, 0, '', '2019-09-04 09:41:42');
INSERT INTO `access_log` VALUES (74946, '65.45.15675613021318587', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.0 Safari/605.1.15', '180.154.199.114', '2019-09-04 09:41:42', 16, 2001001000, '服务端发生异常', '2019-09-04 09:41:42');
INSERT INTO `access_log` VALUES (74947, '59.75.15675616984195015', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.173.247.22', '2019-09-04 09:48:18', 10, 0, '', '2019-09-04 09:48:18');
INSERT INTO `access_log` VALUES (74948, '59.77.15675616984204999', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '60.173.247.22', '2019-09-04 09:48:18', 32, 2001001000, '服务端发生异常', '2019-09-04 09:48:18');
INSERT INTO `access_log` VALUES (74949, '65.3607.15675619129620357', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.56.90.69', '2019-09-04 09:51:53', 0, 1002001015, '账号未登陆', '2019-09-04 09:51:53');
INSERT INTO `access_log` VALUES (74950, '65.51.15675619129668607', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.56.90.69', '2019-09-04 09:51:53', 0, 1002001015, '账号未登陆', '2019-09-04 09:51:53');
INSERT INTO `access_log` VALUES (74951, '65.52.15675619129728623', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.56.90.69', '2019-09-04 09:51:53', 0, 1002001015, '账号未登陆', '2019-09-04 09:51:53');
INSERT INTO `access_log` VALUES (74952, '65.53.15675619345148501', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.56.90.69', '2019-09-04 09:52:15', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 09:52:15');
INSERT INTO `access_log` VALUES (74953, '65.50.15675619449828573', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.56.90.69', '2019-09-04 09:52:25', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 09:52:25');
INSERT INTO `access_log` VALUES (74954, '59.71.15675619527245009', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '101.89.239.230', '2019-09-04 09:52:33', 3, 0, '', '2019-09-04 09:52:33');
INSERT INTO `access_log` VALUES (74955, '65.54.15675619533388441', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.56.90.69', '2019-09-04 09:52:33', 235, 0, '', '2019-09-04 09:52:34');
INSERT INTO `access_log` VALUES (74956, '65.45.15675619538398597', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.56.90.69', '2019-09-04 09:52:34', 11, 0, '', '2019-09-04 09:52:34');
INSERT INTO `access_log` VALUES (74957, '65.52.15675619538438625', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.56.90.69', '2019-09-04 09:52:34', 11, 2001001000, '服务端发生异常', '2019-09-04 09:52:34');
INSERT INTO `access_log` VALUES (74958, '65.51.15675619538468609', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.56.90.69', '2019-09-04 09:52:34', 9, 0, '', '2019-09-04 09:52:34');
INSERT INTO `access_log` VALUES (74959, '59.76.15675620421595005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.129.6.251', '2019-09-04 09:54:02', 16, 2001001000, '服务端发生异常', '2019-09-04 09:54:02');
INSERT INTO `access_log` VALUES (74960, '65.53.15675628745268515', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.221.4.22', '2019-09-04 10:07:55', 1, 1002001015, '账号未登陆', '2019-09-04 10:07:55');
INSERT INTO `access_log` VALUES (74961, '65.47.15675628745268527', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.221.4.22', '2019-09-04 10:07:55', 1, 1002001015, '账号未登陆', '2019-09-04 10:07:55');
INSERT INTO `access_log` VALUES (74962, '65.46.15675628745258607', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.221.4.22', '2019-09-04 10:07:55', 1, 1002001015, '账号未登陆', '2019-09-04 10:07:55');
INSERT INTO `access_log` VALUES (74963, '65.50.15675628773128587', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.221.4.22', '2019-09-04 10:07:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 10:07:57');
INSERT INTO `access_log` VALUES (74964, '65.54.15675628856848455', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.221.4.22', '2019-09-04 10:08:06', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 10:08:06');
INSERT INTO `access_log` VALUES (74965, '59.80.15675628906054997', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-09-04 10:08:11', 2, 0, '', '2019-09-04 10:08:11');
INSERT INTO `access_log` VALUES (74966, '59.79.15675628906115027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-09-04 10:08:11', 9, 2001001000, '服务端发生异常', '2019-09-04 10:08:11');
INSERT INTO `access_log` VALUES (74967, '65.52.15675628924608639', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin1&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.221.4.22', '2019-09-04 10:08:12', 75, 0, '', '2019-09-04 10:08:13');
INSERT INTO `access_log` VALUES (74968, '64.77.15675628984475427', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-09-04 10:08:18', 14, 0, '', '2019-09-04 10:08:18');
INSERT INTO `access_log` VALUES (74969, '64.82.15675628986075461', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-09-04 10:08:19', 4, 0, '', '2019-09-04 10:08:19');
INSERT INTO `access_log` VALUES (74970, '64.78.15675628999165473', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-09-04 10:08:20', 2, 0, '', '2019-09-04 10:08:20');
INSERT INTO `access_log` VALUES (74971, '64.83.15675629007665443', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-09-04 10:08:21', 2, 0, '', '2019-09-04 10:08:21');
INSERT INTO `access_log` VALUES (74972, '64.84.15675629028835445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-09-04 10:08:23', 2, 0, '', '2019-09-04 10:08:23');
INSERT INTO `access_log` VALUES (74973, '64.81.15675629032215453', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-09-04 10:08:23', 2, 0, '', '2019-09-04 10:08:23');
INSERT INTO `access_log` VALUES (74974, '64.80.15675629043635445', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-09-04 10:08:24', 2, 0, '', '2019-09-04 10:08:24');
INSERT INTO `access_log` VALUES (74975, '64.85.15675629051055469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-09-04 10:08:25', 1, 0, '', '2019-09-04 10:08:25');
INSERT INTO `access_log` VALUES (74976, '64.79.15675629087685451', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '210.83.240.178', '2019-09-04 10:08:29', 2, 0, '', '2019-09-04 10:08:29');
INSERT INTO `access_log` VALUES (74977, '65.49.15675629221988595', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '58.221.4.22', '2019-09-04 10:08:42', 80, 0, '', '2019-09-04 10:08:42');
INSERT INTO `access_log` VALUES (74978, '65.53.15675633936108523', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 10:16:34', 4, 1002001012, '访问令牌已过期', '2019-09-04 10:16:34');
INSERT INTO `access_log` VALUES (74979, '65.50.15675633936128595', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 10:16:34', 3, 1002001012, '访问令牌已过期', '2019-09-04 10:16:34');
INSERT INTO `access_log` VALUES (74980, '65.46.15675633936108615', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 10:16:34', 5, 1002001012, '访问令牌已过期', '2019-09-04 10:16:34');
INSERT INTO `access_log` VALUES (74981, '65.54.15675633950938463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 10:16:35', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 10:16:35');
INSERT INTO `access_log` VALUES (74982, '65.52.15675633989968647', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 10:16:39', 90, 0, '', '2019-09-04 10:16:39');
INSERT INTO `access_log` VALUES (74983, '65.45.15675633993218619', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 10:16:39', 11, 0, '', '2019-09-04 10:16:39');
INSERT INTO `access_log` VALUES (74984, '65.3607.15675633993240381', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 10:16:39', 9, 0, '', '2019-09-04 10:16:39');
INSERT INTO `access_log` VALUES (74985, '65.49.15675633993288603', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 10:16:39', 9, 0, '', '2019-09-04 10:16:39');
INSERT INTO `access_log` VALUES (74986, '62.88.15675634020153561', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 10:16:42', 31, 0, '', '2019-09-04 10:16:42');
INSERT INTO `access_log` VALUES (74987, '65.47.15675634088088537', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 10:16:49', 9, 0, '', '2019-09-04 10:16:49');
INSERT INTO `access_log` VALUES (74988, '65.50.15675634088088597', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 10:16:49', 9, 0, '', '2019-09-04 10:16:49');
INSERT INTO `access_log` VALUES (74989, '65.53.15675634088118525', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 10:16:49', 9, 0, '', '2019-09-04 10:16:49');
INSERT INTO `access_log` VALUES (74990, '59.79.15675663085465073', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.254.234.184', '2019-09-04 11:05:09', 10, 0, '', '2019-09-04 11:05:09');
INSERT INTO `access_log` VALUES (74991, '59.80.15675663085465043', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.254.234.184', '2019-09-04 11:05:09', 22, 2001001000, '服务端发生异常', '2019-09-04 11:05:09');
INSERT INTO `access_log` VALUES (74992, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.254.234.184', '2019-09-04 11:05:16', 7, 0, '', '2019-09-04 11:05:16');
INSERT INTO `access_log` VALUES (74993, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.254.234.184', '2019-09-04 11:05:16', 4, 0, '', '2019-09-04 11:05:16');
INSERT INTO `access_log` VALUES (74994, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.254.234.184', '2019-09-04 11:05:16', 18, 0, '', '2019-09-04 11:05:16');
INSERT INTO `access_log` VALUES (74995, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.254.234.184', '2019-09-04 11:05:16', 11, 0, '', '2019-09-04 11:05:16');
INSERT INTO `access_log` VALUES (74996, '64.80.15675663201405491', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.254.234.184', '2019-09-04 11:05:20', 7, 0, '', '2019-09-04 11:05:20');
INSERT INTO `access_log` VALUES (74997, '65.54.15675668836158511', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.97.212.244', '2019-09-04 11:14:44', 4, 1002001012, '访问令牌已过期', '2019-09-04 11:14:44');
INSERT INTO `access_log` VALUES (74998, '65.46.15675668836158665', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.97.212.244', '2019-09-04 11:14:44', 5, 1002001012, '访问令牌已过期', '2019-09-04 11:14:44');
INSERT INTO `access_log` VALUES (74999, '65.52.15675668836158695', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.97.212.244', '2019-09-04 11:14:44', 6, 1002001012, '访问令牌已过期', '2019-09-04 11:14:44');
INSERT INTO `access_log` VALUES (75000, '65.3607.15675668875250431', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.97.212.244', '2019-09-04 11:14:48', 61, 0, '', '2019-09-04 11:14:48');
INSERT INTO `access_log` VALUES (75001, '65.51.15675668879788679', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.97.212.244', '2019-09-04 11:14:48', 12, 0, '', '2019-09-04 11:14:48');
INSERT INTO `access_log` VALUES (75002, '65.49.15675668879798653', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.97.212.244', '2019-09-04 11:14:48', 14, 2001001000, '服务端发生异常', '2019-09-04 11:14:48');
INSERT INTO `access_log` VALUES (75003, '65.45.15675668879858669', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.97.212.244', '2019-09-04 11:14:48', 11, 0, '', '2019-09-04 11:14:48');
INSERT INTO `access_log` VALUES (75004, '65.47.15675690218498615', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.13.93.243', '2019-09-04 11:50:22', 0, 1002001015, '账号未登陆', '2019-09-04 11:50:22');
INSERT INTO `access_log` VALUES (75005, '65.50.15675690218498675', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.13.93.243', '2019-09-04 11:50:22', 0, 1002001015, '账号未登陆', '2019-09-04 11:50:22');
INSERT INTO `access_log` VALUES (75006, '65.53.15675690218688605', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.13.93.243', '2019-09-04 11:50:22', 0, 1002001015, '账号未登陆', '2019-09-04 11:50:22');
INSERT INTO `access_log` VALUES (75007, '65.54.15675690242218541', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.13.93.243', '2019-09-04 11:50:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 11:50:24');
INSERT INTO `access_log` VALUES (75008, '65.46.15675690267988697', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.13.93.243', '2019-09-04 11:50:27', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 11:50:27');
INSERT INTO `access_log` VALUES (75009, '65.45.15675690441398701', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.13.93.243', '2019-09-04 11:50:44', 108, 0, '', '2019-09-04 11:50:44');
INSERT INTO `access_log` VALUES (75010, '65.49.15675690449348683', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.13.93.243', '2019-09-04 11:50:45', 205, 0, '', '2019-09-04 11:50:45');
INSERT INTO `access_log` VALUES (75011, '65.51.15675690449348709', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.13.93.243', '2019-09-04 11:50:45', 205, 2001001000, '服务端发生异常', '2019-09-04 11:50:45');
INSERT INTO `access_log` VALUES (75012, '65.53.15675690449418607', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.13.93.243', '2019-09-04 11:50:45', 199, 0, '', '2019-09-04 11:50:45');
INSERT INTO `access_log` VALUES (75013, '65.52.15675767295228829', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-04 13:58:50', 0, 1002001015, '账号未登陆', '2019-09-04 13:58:50');
INSERT INTO `access_log` VALUES (75014, '65.54.15675767295238645', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-04 13:58:50', 0, 1002001015, '账号未登陆', '2019-09-04 13:58:50');
INSERT INTO `access_log` VALUES (75015, '65.46.15675767295438801', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-04 13:58:50', 0, 1002001015, '账号未登陆', '2019-09-04 13:58:50');
INSERT INTO `access_log` VALUES (75016, '65.45.15675767373308805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-04 13:58:57', 80, 0, '', '2019-09-04 13:58:57');
INSERT INTO `access_log` VALUES (75017, '65.51.15675767377978813', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-04 13:58:58', 11, 0, '', '2019-09-04 13:58:58');
INSERT INTO `access_log` VALUES (75018, '65.53.15675767378088711', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-04 13:58:58', 9, 2001001000, '服务端发生异常', '2019-09-04 13:58:58');
INSERT INTO `access_log` VALUES (75019, '65.49.15675767378468787', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-04 13:58:58', 9, 0, '', '2019-09-04 13:58:58');
INSERT INTO `access_log` VALUES (75020, '65.47.15675767602518721', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-04 13:59:20', 11, 0, '', '2019-09-04 13:59:20');
INSERT INTO `access_log` VALUES (75021, '65.52.15675767602568831', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-04 13:59:20', 10, 2001001000, '服务端发生异常', '2019-09-04 13:59:20');
INSERT INTO `access_log` VALUES (75022, '65.54.15675767602638647', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-04 13:59:20', 8, 0, '', '2019-09-04 13:59:20');
INSERT INTO `access_log` VALUES (75023, '65.3607.15675767690320567', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-04 13:59:29', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 13:59:29');
INSERT INTO `access_log` VALUES (75024, '65.45.15675767743658807', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-04 13:59:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 13:59:34');
INSERT INTO `access_log` VALUES (75025, '59.75.15675774891865227', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.191.24.162', '2019-09-04 14:11:29', 10, 0, '', '2019-09-04 14:11:29');
INSERT INTO `access_log` VALUES (75026, '59.72.15675774891875219', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '61.191.24.162', '2019-09-04 14:11:29', 19, 2001001000, '服务端发生异常', '2019-09-04 14:11:29');
INSERT INTO `access_log` VALUES (75027, '59.74.15675775626925235', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.89.29.86', '2019-09-04 14:12:43', 12, 2001001000, '服务端发生异常', '2019-09-04 14:12:43');
INSERT INTO `access_log` VALUES (75028, '59.73.15675776181875221', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.81.180.234', '2019-09-04 14:13:38', 5, 0, '', '2019-09-04 14:13:38');
INSERT INTO `access_log` VALUES (75029, '59.79.15675776181905225', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.81.180.234', '2019-09-04 14:13:38', 12, 2001001000, '服务端发生异常', '2019-09-04 14:13:38');
INSERT INTO `access_log` VALUES (75030, '59.71.15675776770145221', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.81.180.234', '2019-09-04 14:14:37', 2, 0, '', '2019-09-04 14:14:37');
INSERT INTO `access_log` VALUES (75031, '59.77.15675776770485215', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '183.81.180.234', '2019-09-04 14:14:37', 16, 2001001000, '服务端发生异常', '2019-09-04 14:14:37');
INSERT INTO `access_log` VALUES (75032, '59.73.15675799596785253', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '202.101.194.220', '2019-09-04 14:52:40', 10, 0, '', '2019-09-04 14:52:40');
INSERT INTO `access_log` VALUES (75033, '59.79.15675799596805257', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '202.101.194.220', '2019-09-04 14:52:40', 40, 2001001000, '服务端发生异常', '2019-09-04 14:52:40');
INSERT INTO `access_log` VALUES (75034, '64.85.15675799638405697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '202.101.194.220', '2019-09-04 14:52:44', 13, 0, '', '2019-09-04 14:52:44');
INSERT INTO `access_log` VALUES (75035, '64.79.15675799639735679', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '202.101.194.220', '2019-09-04 14:52:44', 4, 0, '', '2019-09-04 14:52:44');
INSERT INTO `access_log` VALUES (75036, '65.45.15675812579648867', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.32.125.33', '2019-09-04 15:14:18', 0, 1002001015, '账号未登陆', '2019-09-04 15:14:18');
INSERT INTO `access_log` VALUES (75037, '65.53.15675812579648773', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.32.125.33', '2019-09-04 15:14:18', 0, 1002001015, '账号未登陆', '2019-09-04 15:14:18');
INSERT INTO `access_log` VALUES (75038, '65.51.15675812579668875', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.32.125.33', '2019-09-04 15:14:18', 0, 1002001015, '账号未登陆', '2019-09-04 15:14:18');
INSERT INTO `access_log` VALUES (75039, '65.49.15675812603848849', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.32.125.33', '2019-09-04 15:14:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 15:14:20');
INSERT INTO `access_log` VALUES (75040, '65.54.15675812680438709', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.32.125.33', '2019-09-04 15:14:28', 59, 0, '', '2019-09-04 15:14:28');
INSERT INTO `access_log` VALUES (75041, '65.47.15675812683878783', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.32.125.33', '2019-09-04 15:14:28', 11, 0, '', '2019-09-04 15:14:28');
INSERT INTO `access_log` VALUES (75042, '65.52.15675812683918893', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.32.125.33', '2019-09-04 15:14:28', 9, 2001001000, '服务端发生异常', '2019-09-04 15:14:28');
INSERT INTO `access_log` VALUES (75043, '65.46.15675812683968865', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.32.125.33', '2019-09-04 15:14:28', 11, 0, '', '2019-09-04 15:14:28');
INSERT INTO `access_log` VALUES (75044, '65.45.15675812730408869', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.32.125.33', '2019-09-04 15:14:33', 11, 2001001000, '服务端发生异常', '2019-09-04 15:14:33');
INSERT INTO `access_log` VALUES (75045, '65.53.15675812730418775', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.32.125.33', '2019-09-04 15:14:33', 9, 0, '', '2019-09-04 15:14:33');
INSERT INTO `access_log` VALUES (75046, '65.3607.15675812730300629', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '120.32.125.33', '2019-09-04 15:14:33', 12, 0, '', '2019-09-04 15:14:33');
INSERT INTO `access_log` VALUES (75047, '59.73.15675812815745271', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.32.125.33', '2019-09-04 15:14:42', 4, 0, '', '2019-09-04 15:14:42');
INSERT INTO `access_log` VALUES (75048, '59.79.15675812815745275', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.32.125.33', '2019-09-04 15:14:42', 14, 2001001000, '服务端发生异常', '2019-09-04 15:14:42');
INSERT INTO `access_log` VALUES (75049, '64.85.15675812849015715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.32.125.33', '2019-09-04 15:14:45', 4, 0, '', '2019-09-04 15:14:45');
INSERT INTO `access_log` VALUES (75050, '64.79.15675812852045697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.32.125.33', '2019-09-04 15:14:45', 2, 0, '', '2019-09-04 15:14:45');
INSERT INTO `access_log` VALUES (75051, '64.77.15675812881025675', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.32.125.33', '2019-09-04 15:14:48', 2, 0, '', '2019-09-04 15:14:48');
INSERT INTO `access_log` VALUES (75052, '64.82.15675812882015709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '120.32.125.33', '2019-09-04 15:14:48', 1, 0, '', '2019-09-04 15:14:48');
INSERT INTO `access_log` VALUES (75053, '59.71.15675828446295291', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.6.120.221', '2019-09-04 15:40:45', 4, 0, '', '2019-09-04 15:40:45');
INSERT INTO `access_log` VALUES (75054, '59.77.15675828446295285', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.6.120.221', '2019-09-04 15:40:45', 19, 2001001000, '服务端发生异常', '2019-09-04 15:40:45');
INSERT INTO `access_log` VALUES (75055, '64.83.15675828500055711', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.6.120.221', '2019-09-04 15:40:50', 2, 0, '', '2019-09-04 15:40:50');
INSERT INTO `access_log` VALUES (75056, '64.84.15675828501315715', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.6.120.221', '2019-09-04 15:40:50', 1, 0, '', '2019-09-04 15:40:50');
INSERT INTO `access_log` VALUES (75057, '64.81.15675828515175721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.6.120.221', '2019-09-04 15:40:52', 2, 0, '', '2019-09-04 15:40:52');
INSERT INTO `access_log` VALUES (75058, '64.85.15675828519915739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/67.0.3396.99 Safari/537.36', '183.6.120.221', '2019-09-04 15:40:52', 2, 0, '', '2019-09-04 15:40:52');
INSERT INTO `access_log` VALUES (75059, '59.75.15675832887515307', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.84.154', '2019-09-04 15:48:09', 3, 0, '', '2019-09-04 15:48:09');
INSERT INTO `access_log` VALUES (75060, '59.72.15675832887565299', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.84.154', '2019-09-04 15:48:09', 10, 2001001000, '服务端发生异常', '2019-09-04 15:48:09');
INSERT INTO `access_log` VALUES (75061, '64.85.15675832912925745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.84.154', '2019-09-04 15:48:11', 3, 0, '', '2019-09-04 15:48:11');
INSERT INTO `access_log` VALUES (75062, '64.79.15675832913865725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.84.154', '2019-09-04 15:48:11', 2, 0, '', '2019-09-04 15:48:11');
INSERT INTO `access_log` VALUES (75063, '64.77.15675832925445703', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.84.154', '2019-09-04 15:48:13', 2, 0, '', '2019-09-04 15:48:13');
INSERT INTO `access_log` VALUES (75064, '64.82.15675832932495739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.84.154', '2019-09-04 15:48:13', 2, 0, '', '2019-09-04 15:48:13');
INSERT INTO `access_log` VALUES (75065, '59.73.15675832937965299', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.84.154', '2019-09-04 15:48:14', 2, 0, '', '2019-09-04 15:48:14');
INSERT INTO `access_log` VALUES (75066, '59.79.15675832938055303', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.84.154', '2019-09-04 15:48:14', 12, 2001001000, '服务端发生异常', '2019-09-04 15:48:14');
INSERT INTO `access_log` VALUES (75067, '59.78.15675845177485331', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:08:38', 2, 0, '', '2019-09-04 16:08:38');
INSERT INTO `access_log` VALUES (75068, '59.74.15675845177495331', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:08:38', 18, 2001001000, '服务端发生异常', '2019-09-04 16:08:38');
INSERT INTO `access_log` VALUES (75069, '64.83.15675845231365735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:08:43', 2, 0, '', '2019-09-04 16:08:43');
INSERT INTO `access_log` VALUES (75070, '64.84.15675845232445739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:08:43', 2, 0, '', '2019-09-04 16:08:43');
INSERT INTO `access_log` VALUES (75071, '64.80.15675845241855739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:08:44', 1, 0, '', '2019-09-04 16:08:44');
INSERT INTO `access_log` VALUES (75072, '64.81.15675845246345745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:08:45', 2, 0, '', '2019-09-04 16:08:45');
INSERT INTO `access_log` VALUES (75073, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:08:45', 7, 0, '', '2019-09-04 16:08:45');
INSERT INTO `access_log` VALUES (75074, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:08:46', 4, 0, '', '2019-09-04 16:08:46');
INSERT INTO `access_log` VALUES (75075, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:08:46', 10, 0, '', '2019-09-04 16:08:46');
INSERT INTO `access_log` VALUES (75076, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:08:46', 13, 0, '', '2019-09-04 16:08:46');
INSERT INTO `access_log` VALUES (75077, '65.45.15675845315318913', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:08:52', 1, 1002001015, '账号未登陆', '2019-09-04 16:08:52');
INSERT INTO `access_log` VALUES (75078, '65.3607.15675845315310673', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:08:52', 1, 1002001015, '账号未登陆', '2019-09-04 16:08:52');
INSERT INTO `access_log` VALUES (75079, '65.53.15675845315388819', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:08:52', 1, 1002001015, '账号未登陆', '2019-09-04 16:08:52');
INSERT INTO `access_log` VALUES (75080, '65.49.15675845372018895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:08:57', 20, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 16:08:57');
INSERT INTO `access_log` VALUES (75081, '65.50.15675845472408889', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:09:07', 77, 0, '', '2019-09-04 16:09:07');
INSERT INTO `access_log` VALUES (75082, '65.54.15675845475278755', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:09:08', 13, 0, '', '2019-09-04 16:09:08');
INSERT INTO `access_log` VALUES (75083, '65.47.15675845475328829', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:09:08', 11, 2001001000, '服务端发生异常', '2019-09-04 16:09:08');
INSERT INTO `access_log` VALUES (75084, '65.52.15675845475358939', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.229.60.152', '2019-09-04 16:09:08', 11, 0, '', '2019-09-04 16:09:08');
INSERT INTO `access_log` VALUES (75085, '65.54.15675861452418777', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.36.76.58', '2019-09-04 16:35:45', 0, 1002001015, '账号未登陆', '2019-09-04 16:35:45');
INSERT INTO `access_log` VALUES (75086, '65.47.15675861452428851', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.36.76.58', '2019-09-04 16:35:45', 1, 1002001015, '账号未登陆', '2019-09-04 16:35:45');
INSERT INTO `access_log` VALUES (75087, '65.52.15675861452428961', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.36.76.58', '2019-09-04 16:35:45', 1, 1002001015, '账号未登陆', '2019-09-04 16:35:45');
INSERT INTO `access_log` VALUES (75088, '65.46.15675861471728933', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.36.76.58', '2019-09-04 16:35:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 16:35:47');
INSERT INTO `access_log` VALUES (75089, '65.53.15675861554538843', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.36.76.58', '2019-09-04 16:35:55', 73, 0, '', '2019-09-04 16:35:56');
INSERT INTO `access_log` VALUES (75090, '65.3607.15675861557850697', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.36.76.58', '2019-09-04 16:35:56', 9, 0, '', '2019-09-04 16:35:56');
INSERT INTO `access_log` VALUES (75091, '65.49.15675861557868919', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.36.76.58', '2019-09-04 16:35:56', 9, 0, '', '2019-09-04 16:35:56');
INSERT INTO `access_log` VALUES (75092, '65.51.15675861557868945', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '117.36.76.58', '2019-09-04 16:35:56', 11, 2001001000, '服务端发生异常', '2019-09-04 16:35:56');
INSERT INTO `access_log` VALUES (75093, '65.45.15675867998068947', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.207.251.32', '2019-09-04 16:46:40', 0, 1002001015, '账号未登陆', '2019-09-04 16:46:40');
INSERT INTO `access_log` VALUES (75094, '65.54.15675867998068787', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.207.251.32', '2019-09-04 16:46:40', 1, 1002001015, '账号未登陆', '2019-09-04 16:46:40');
INSERT INTO `access_log` VALUES (75095, '65.46.15675867998068943', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.207.251.32', '2019-09-04 16:46:40', 1, 1002001015, '账号未登陆', '2019-09-04 16:46:40');
INSERT INTO `access_log` VALUES (75096, '65.53.15675868021438853', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.207.251.32', '2019-09-04 16:46:42', 24, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 16:46:42');
INSERT INTO `access_log` VALUES (75097, '65.51.15675868175048955', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.207.251.32', '2019-09-04 16:46:58', 65, 0, '', '2019-09-04 16:46:58');
INSERT INTO `access_log` VALUES (75098, '65.3607.15675868178040707', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.207.251.32', '2019-09-04 16:46:58', 10, 0, '', '2019-09-04 16:46:58');
INSERT INTO `access_log` VALUES (75099, '65.50.15675868178058923', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.207.251.32', '2019-09-04 16:46:58', 10, 2001001000, '服务端发生异常', '2019-09-04 16:46:58');
INSERT INTO `access_log` VALUES (75100, '65.52.15675868178078973', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '111.207.251.32', '2019-09-04 16:46:58', 17, 0, '', '2019-09-04 16:46:58');
INSERT INTO `access_log` VALUES (75101, '59.74.15675870608375365', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '192.168.86.175', '2019-09-04 16:51:01', 10, 0, '', '2019-09-04 16:51:01');
INSERT INTO `access_log` VALUES (75102, '59.71.15675870608375349', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '192.168.86.175', '2019-09-04 16:51:01', 17, 2001001000, '服务端发生异常', '2019-09-04 16:51:01');
INSERT INTO `access_log` VALUES (75103, '65.51.15675870687258959', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '192.168.86.175', '2019-09-04 16:51:09', 1, 1002001015, '账号未登陆', '2019-09-04 16:51:09');
INSERT INTO `access_log` VALUES (75104, '65.3607.15675870687250711', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '192.168.86.175', '2019-09-04 16:51:09', 0, 1002001015, '账号未登陆', '2019-09-04 16:51:09');
INSERT INTO `access_log` VALUES (75105, '65.50.15675870687388927', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '192.168.86.175', '2019-09-04 16:51:09', 0, 1002001015, '账号未登陆', '2019-09-04 16:51:09');
INSERT INTO `access_log` VALUES (75106, '65.47.15675870708128867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '192.168.86.175', '2019-09-04 16:51:11', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 16:51:11');
INSERT INTO `access_log` VALUES (75107, '65.46.15675870850088949', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '192.168.86.175', '2019-09-04 16:51:25', 146, 0, '', '2019-09-04 16:51:25');
INSERT INTO `access_log` VALUES (75108, '65.54.15675870855728793', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '192.168.86.175', '2019-09-04 16:51:26', 10, 0, '', '2019-09-04 16:51:26');
INSERT INTO `access_log` VALUES (75109, '65.49.15675870855748935', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '192.168.86.175', '2019-09-04 16:51:26', 9, 0, '', '2019-09-04 16:51:26');
INSERT INTO `access_log` VALUES (75110, '65.53.15675870855748859', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '192.168.86.175', '2019-09-04 16:51:26', 10, 2001001000, '服务端发生异常', '2019-09-04 16:51:26');
INSERT INTO `access_log` VALUES (75111, '65.3607.15675878461360723', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.233.44.173', '2019-09-04 17:04:06', 0, 1002001015, '账号未登陆', '2019-09-04 17:04:06');
INSERT INTO `access_log` VALUES (75112, '65.50.15675878461358939', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.233.44.173', '2019-09-04 17:04:06', 0, 1002001015, '账号未登陆', '2019-09-04 17:04:06');
INSERT INTO `access_log` VALUES (75113, '65.51.15675878461408971', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.233.44.173', '2019-09-04 17:04:06', 0, 1002001015, '账号未登陆', '2019-09-04 17:04:06');
INSERT INTO `access_log` VALUES (75114, '65.54.15675878502618805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.233.44.173', '2019-09-04 17:04:10', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 17:04:10');
INSERT INTO `access_log` VALUES (75115, '65.47.15675878644558879', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.233.44.173', '2019-09-04 17:04:24', 57, 0, '', '2019-09-04 17:04:25');
INSERT INTO `access_log` VALUES (75116, '65.46.15675878650728963', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.233.44.173', '2019-09-04 17:04:25', 9, 0, '', '2019-09-04 17:04:25');
INSERT INTO `access_log` VALUES (75117, '65.49.15675878650748947', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.233.44.173', '2019-09-04 17:04:25', 9, 0, '', '2019-09-04 17:04:25');
INSERT INTO `access_log` VALUES (75118, '65.45.15675878650738967', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '122.233.44.173', '2019-09-04 17:04:25', 11, 2001001000, '服务端发生异常', '2019-09-04 17:04:25');
INSERT INTO `access_log` VALUES (75119, '59.77.15675881056505357', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.109.39.95', '2019-09-04 17:08:26', 3, 0, '', '2019-09-04 17:08:26');
INSERT INTO `access_log` VALUES (75120, '59.72.15675881056515365', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '113.109.39.95', '2019-09-04 17:08:26', 13, 2001001000, '服务端发生异常', '2019-09-04 17:08:26');
INSERT INTO `access_log` VALUES (75121, '59.75.15675890035885385', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:23:24', 3, 0, '', '2019-09-04 17:23:24');
INSERT INTO `access_log` VALUES (75122, '59.73.15675890035925377', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:23:24', 17, 2001001000, '服务端发生异常', '2019-09-04 17:23:24');
INSERT INTO `access_log` VALUES (75123, '64.81.15675890092545805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:23:29', 15, 0, '', '2019-09-04 17:23:29');
INSERT INTO `access_log` VALUES (75124, '64.85.15675890093855823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:23:29', 4, 0, '', '2019-09-04 17:23:29');
INSERT INTO `access_log` VALUES (75125, '64.77.15675890198075781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:23:40', 2, 0, '', '2019-09-04 17:23:40');
INSERT INTO `access_log` VALUES (75126, '64.82.15675890199395817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:23:40', 2, 0, '', '2019-09-04 17:23:40');
INSERT INTO `access_log` VALUES (75127, '64.78.15675890208695827', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:23:41', 2, 0, '', '2019-09-04 17:23:41');
INSERT INTO `access_log` VALUES (75128, '64.76.15675890215335811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:23:42', 2, 0, '', '2019-09-04 17:23:42');
INSERT INTO `access_log` VALUES (75129, '64.83.15675890251855797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:23:45', 2, 0, '', '2019-09-04 17:23:45');
INSERT INTO `access_log` VALUES (75130, '64.84.15675890253125801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:23:45', 1, 0, '', '2019-09-04 17:23:45');
INSERT INTO `access_log` VALUES (75131, '59.78.15675890296095393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:23:50', 3, 0, '', '2019-09-04 17:23:50');
INSERT INTO `access_log` VALUES (75132, '59.76.15675890296095371', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:23:50', 22, 2001001000, '服务端发生异常', '2019-09-04 17:23:50');
INSERT INTO `access_log` VALUES (75133, '65.54.15675890750388823', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:24:35', 1, 1002001015, '账号未登陆', '2019-09-04 17:24:35');
INSERT INTO `access_log` VALUES (75134, '65.53.15675890750448887', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:24:35', 0, 1002001015, '账号未登陆', '2019-09-04 17:24:35');
INSERT INTO `access_log` VALUES (75135, '65.3607.15675890750450741', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:24:35', 0, 1002001015, '账号未登陆', '2019-09-04 17:24:35');
INSERT INTO `access_log` VALUES (75136, '65.51.15675890773658991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:24:37', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 17:24:37');
INSERT INTO `access_log` VALUES (75137, '65.52.15675890812769009', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:24:41', 94, 0, '', '2019-09-04 17:24:41');
INSERT INTO `access_log` VALUES (75138, '65.47.15675890816508897', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:24:42', 10, 0, '', '2019-09-04 17:24:42');
INSERT INTO `access_log` VALUES (75139, '65.45.15675890816608985', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:24:42', 10, 2001001000, '服务端发生异常', '2019-09-04 17:24:42');
INSERT INTO `access_log` VALUES (75140, '65.49.15675890816638965', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:24:42', 9, 0, '', '2019-09-04 17:24:42');
INSERT INTO `access_log` VALUES (75141, '65.53.15675890966278889', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '119.137.52.123', '2019-09-04 17:24:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 17:24:57');
INSERT INTO `access_log` VALUES (75142, '65.52.15675899154269021', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.53.52.220', '2019-09-04 17:38:35', 0, 1002001015, '账号未登陆', '2019-09-04 17:38:35');
INSERT INTO `access_log` VALUES (75143, '65.47.15675899154268909', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.53.52.220', '2019-09-04 17:38:35', 0, 1002001015, '账号未登陆', '2019-09-04 17:38:35');
INSERT INTO `access_log` VALUES (75144, '65.49.15675899154378977', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.53.52.220', '2019-09-04 17:38:35', 0, 1002001015, '账号未登陆', '2019-09-04 17:38:35');
INSERT INTO `access_log` VALUES (75145, '59.74.15675899346125405', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.53.52.220', '2019-09-04 17:38:55', 3, 0, '', '2019-09-04 17:38:55');
INSERT INTO `access_log` VALUES (75146, '59.71.15675899346105389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '111.53.52.220', '2019-09-04 17:38:55', 12, 2001001000, '服务端发生异常', '2019-09-04 17:38:55');
INSERT INTO `access_log` VALUES (75147, '59.71.15675903644765395', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.17.116.242', '2019-09-04 17:46:04', 3, 0, '', '2019-09-04 17:46:04');
INSERT INTO `access_log` VALUES (75148, '59.77.15675903644815389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.17.116.242', '2019-09-04 17:46:04', 12, 2001001000, '服务端发生异常', '2019-09-04 17:46:04');
INSERT INTO `access_log` VALUES (75149, '64.80.15675903707205819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.17.116.242', '2019-09-04 17:46:11', 2, 0, '', '2019-09-04 17:46:11');
INSERT INTO `access_log` VALUES (75150, '64.81.15675903708805825', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.17.116.242', '2019-09-04 17:46:11', 2, 0, '', '2019-09-04 17:46:11');
INSERT INTO `access_log` VALUES (75151, '66.51.15675903769272785', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.17.116.242', '2019-09-04 17:46:17', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位', '2019-09-04 17:46:17');
INSERT INTO `access_log` VALUES (75152, '66.55.15675903899682747', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18319431325', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.17.116.242', '2019-09-04 17:46:30', 100, 0, '', '2019-09-04 17:46:30');
INSERT INTO `access_log` VALUES (75153, '66.50.15675903993752773', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18319431325&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.17.116.242', '2019-09-04 17:46:39', 184, 0, '', '2019-09-04 17:46:40');
INSERT INTO `access_log` VALUES (75154, '64.82.15675904071195837', 219, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.17.116.242', '2019-09-04 17:46:47', 16, 0, '', '2019-09-04 17:46:47');
INSERT INTO `access_log` VALUES (75155, '64.76.15675904072895831', 219, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.17.116.242', '2019-09-04 17:46:47', 7, 0, '', '2019-09-04 17:46:47');
INSERT INTO `access_log` VALUES (75156, '64.84.15675904084345821', 219, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.17.116.242', '2019-09-04 17:46:48', 6, 0, '', '2019-09-04 17:46:48');
INSERT INTO `access_log` VALUES (75157, '66.53.15675904105072757', 219, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.17.116.242', '2019-09-04 17:46:51', 8, 0, '', '2019-09-04 17:46:51');
INSERT INTO `access_log` VALUES (75158, '66.48.15675904153082757', 219, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.17.116.242', '2019-09-04 17:46:55', 6, 0, '', '2019-09-04 17:46:55');
INSERT INTO `access_log` VALUES (75159, '66.49.15675904273012773', 219, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '218.17.116.242', '2019-09-04 17:47:07', 5, 0, '', '2019-09-04 17:47:07');
INSERT INTO `access_log` VALUES (75160, '66.55.15675904294642749', 219, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '218.17.116.242', '2019-09-04 17:47:09', 5, 0, '', '2019-09-04 17:47:09');
INSERT INTO `access_log` VALUES (75161, '66.50.15675904351032775', 219, 1, 'user-application', '/user-api/users/user/update_nickname', 'nickname=123', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '218.17.116.242', '2019-09-04 17:47:15', 89, 0, '', '2019-09-04 17:47:15');
INSERT INTO `access_log` VALUES (75162, '66.53.15675904650612759', 219, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '218.17.116.242', '2019-09-04 17:47:45', 5, 0, '', '2019-09-04 17:47:45');
INSERT INTO `access_log` VALUES (75163, '66.48.15675904715122759', 219, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '218.17.116.242', '2019-09-04 17:47:52', 6, 0, '', '2019-09-04 17:47:52');
INSERT INTO `access_log` VALUES (75164, '64.82.15675904733855839', 219, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '218.17.116.242', '2019-09-04 17:47:53', 9, 0, '', '2019-09-04 17:47:53');
INSERT INTO `access_log` VALUES (75165, '64.78.15675904734905849', 219, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '218.17.116.242', '2019-09-04 17:47:53', 5, 0, '', '2019-09-04 17:47:53');
INSERT INTO `access_log` VALUES (75166, '64.76.15675904761195833', 219, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '218.17.116.242', '2019-09-04 17:47:56', 6, 0, '', '2019-09-04 17:47:56');
INSERT INTO `access_log` VALUES (75167, 'N/A', 219, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '218.17.116.242', '2019-09-04 17:47:56', 11, 0, '', '2019-09-04 17:47:56');
INSERT INTO `access_log` VALUES (75168, '64.84.15675904779775823', 219, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '218.17.116.242', '2019-09-04 17:47:58', 13, 0, '', '2019-09-04 17:47:58');
INSERT INTO `access_log` VALUES (75169, '66.49.15675904814832775', 219, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Mobile Safari/537.36', '218.17.116.242', '2019-09-04 17:48:01', 6, 0, '', '2019-09-04 17:48:01');
INSERT INTO `access_log` VALUES (75170, '65.49.15675906296148987', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 17:50:30', 5, 1002001012, '访问令牌已过期', '2019-09-04 17:50:30');
INSERT INTO `access_log` VALUES (75171, '65.52.15675906296159031', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 17:50:30', 4, 1002001012, '访问令牌已过期', '2019-09-04 17:50:30');
INSERT INTO `access_log` VALUES (75172, '65.45.15675906296169007', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 17:50:30', 3, 1002001012, '访问令牌已过期', '2019-09-04 17:50:30');
INSERT INTO `access_log` VALUES (75173, '65.46.15675906309349003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 17:50:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 17:50:31');
INSERT INTO `access_log` VALUES (75174, '65.53.15675906344908911', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 17:50:34', 62, 0, '', '2019-09-04 17:50:35');
INSERT INTO `access_log` VALUES (75175, '65.54.15675906348308847', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 17:50:35', 18, 0, '', '2019-09-04 17:50:35');
INSERT INTO `access_log` VALUES (75176, '65.3607.15675906348330765', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 17:50:35', 18, 0, '', '2019-09-04 17:50:35');
INSERT INTO `access_log` VALUES (75177, '65.51.15675906348389015', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 17:50:35', 18, 0, '', '2019-09-04 17:50:35');
INSERT INTO `access_log` VALUES (75178, '64.85.15675906368865849', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 17:50:37', 11, 0, '', '2019-09-04 17:50:37');
INSERT INTO `access_log` VALUES (75179, '64.81.15675906368835831', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 17:50:37', 15, 0, '', '2019-09-04 17:50:37');
INSERT INTO `access_log` VALUES (75180, '64.77.15675906385475807', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 17:50:39', 12, 0, '', '2019-09-04 17:50:39');
INSERT INTO `access_log` VALUES (75181, '64.79.15675906385465829', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 17:50:39', 16, 0, '', '2019-09-04 17:50:39');
INSERT INTO `access_log` VALUES (75182, '65.3607.15675919418420783', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 18:12:22', 11, 0, '', '2019-09-04 18:12:22');
INSERT INTO `access_log` VALUES (75183, '65.51.15675919418429033', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 18:12:22', 12, 0, '', '2019-09-04 18:12:22');
INSERT INTO `access_log` VALUES (75184, '65.54.15675919418458865', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-04 18:12:22', 10, 0, '', '2019-09-04 18:12:22');
INSERT INTO `access_log` VALUES (75185, '59.76.15675925601995419', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.89.21.204', '2019-09-04 18:22:40', 11, 0, '', '2019-09-04 18:22:40');
INSERT INTO `access_log` VALUES (75186, '59.74.15675925601995441', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.89.21.204', '2019-09-04 18:22:40', 20, 2001001000, '服务端发生异常', '2019-09-04 18:22:40');
INSERT INTO `access_log` VALUES (75187, '59.71.15675925705565425', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.89.21.204', '2019-09-04 18:22:51', 2, 0, '', '2019-09-04 18:22:51');
INSERT INTO `access_log` VALUES (75188, '59.72.15675925705565427', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.89.21.204', '2019-09-04 18:22:51', 14, 2001001000, '服务端发生异常', '2019-09-04 18:22:51');
INSERT INTO `access_log` VALUES (75189, '64.77.15675925757525833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.89.21.204', '2019-09-04 18:22:56', 77, 0, '', '2019-09-04 18:22:56');
INSERT INTO `access_log` VALUES (75190, '64.82.15675925759625869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.89.21.204', '2019-09-04 18:22:56', 2, 0, '', '2019-09-04 18:22:56');
INSERT INTO `access_log` VALUES (75191, '64.78.15675925782125879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.89.21.204', '2019-09-04 18:22:58', 3, 0, '', '2019-09-04 18:22:58');
INSERT INTO `access_log` VALUES (75192, '64.76.15675925789255863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.89.21.204', '2019-09-04 18:22:59', 2, 0, '', '2019-09-04 18:22:59');
INSERT INTO `access_log` VALUES (75193, '64.83.15675925797255849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.89.21.204', '2019-09-04 18:23:00', 2, 0, '', '2019-09-04 18:23:00');
INSERT INTO `access_log` VALUES (75194, '64.80.15675925878525853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:08', 2, 0, '', '2019-09-04 18:23:08');
INSERT INTO `access_log` VALUES (75195, '64.81.15675925884605859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:08', 2, 0, '', '2019-09-04 18:23:08');
INSERT INTO `access_log` VALUES (75196, '64.85.15675925921665877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:12', 2, 0, '', '2019-09-04 18:23:12');
INSERT INTO `access_log` VALUES (75197, '64.79.15675925925185857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:13', 2, 0, '', '2019-09-04 18:23:13');
INSERT INTO `access_log` VALUES (75198, '59.79.15675926022265431', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:22', 2, 0, '', '2019-09-04 18:23:22');
INSERT INTO `access_log` VALUES (75199, '59.80.15675926022265401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:22', 15, 2001001000, '服务端发生异常', '2019-09-04 18:23:22');
INSERT INTO `access_log` VALUES (75200, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:26', 8, 0, '', '2019-09-04 18:23:26');
INSERT INTO `access_log` VALUES (75201, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:26', 10, 0, '', '2019-09-04 18:23:26');
INSERT INTO `access_log` VALUES (75202, '59.74.15675926096265443', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:30', 2, 0, '', '2019-09-04 18:23:30');
INSERT INTO `access_log` VALUES (75203, '59.78.15675926096265443', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:30', 13, 2001001000, '服务端发生异常', '2019-09-04 18:23:30');
INSERT INTO `access_log` VALUES (75204, '64.82.15675926117245871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:32', 2, 0, '', '2019-09-04 18:23:32');
INSERT INTO `access_log` VALUES (75205, '64.78.15675926118415881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:32', 1, 0, '', '2019-09-04 18:23:32');
INSERT INTO `access_log` VALUES (75206, '64.76.15675926138785865', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:34', 2, 0, '', '2019-09-04 18:23:34');
INSERT INTO `access_log` VALUES (75207, '64.83.15675926146305851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:35', 2, 0, '', '2019-09-04 18:23:35');
INSERT INTO `access_log` VALUES (75208, '64.80.15675926156015855', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:36', 2, 0, '', '2019-09-04 18:23:36');
INSERT INTO `access_log` VALUES (75209, '64.81.15675926161945861', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:36', 2, 0, '', '2019-09-04 18:23:36');
INSERT INTO `access_log` VALUES (75210, '64.85.15675926195605879', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:40', 2, 0, '', '2019-09-04 18:23:40');
INSERT INTO `access_log` VALUES (75211, '64.79.15675926196635859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:40', 2, 0, '', '2019-09-04 18:23:40');
INSERT INTO `access_log` VALUES (75212, '66.57.15675926367032797', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=999999', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:23:57', 14, 1001003001, '验证码已过期', '2019-09-04 18:23:57');
INSERT INTO `access_log` VALUES (75213, '66.53.15675926418732789', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:24:02', 7, 1001003001, '验证码已过期', '2019-09-04 18:24:02');
INSERT INTO `access_log` VALUES (75214, '66.56.15675926447232815', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=11111111111', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:24:05', 48, 0, '', '2019-09-04 18:24:05');
INSERT INTO `access_log` VALUES (75215, '66.51.15675926465082819', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:24:07', 177, 0, '', '2019-09-04 18:24:07');
INSERT INTO `access_log` VALUES (75216, '59.75.15675926479625437', 128, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:24:08', 132, 0, '', '2019-09-04 18:24:08');
INSERT INTO `access_log` VALUES (75217, '59.79.15675926496475433', 128, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:24:10', 15, 0, '', '2019-09-04 18:24:10');
INSERT INTO `access_log` VALUES (75218, '59.74.15675926503295445', 128, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:24:10', 8, 0, '', '2019-09-04 18:24:10');
INSERT INTO `access_log` VALUES (75219, '66.55.15675926533642781', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:24:13', 5, 0, '', '2019-09-04 18:24:13');
INSERT INTO `access_log` VALUES (75220, '66.50.15675926556912807', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:24:16', 5, 0, '', '2019-09-04 18:24:16');
INSERT INTO `access_log` VALUES (75221, '66.57.15675926585582799', 128, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.89.21.204', '2019-09-04 18:24:19', 6, 0, '', '2019-09-04 18:24:19');
INSERT INTO `access_log` VALUES (75222, '65.47.15675927214448953', 0, 2, 'admin-application', '/admin-api/admins/admin/add', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.89.21.204', '2019-09-04 18:25:21', 0, 1002001015, '账号未登陆', '2019-09-04 18:25:21');
INSERT INTO `access_log` VALUES (75223, '65.52.15675927217349061', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '218.2.219.66', '2019-09-04 18:25:22', 4, 1002001012, '访问令牌已过期', '2019-09-04 18:25:22');
INSERT INTO `access_log` VALUES (75224, '65.49.15675927217349019', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '218.2.219.66', '2019-09-04 18:25:22', 4, 1002001012, '访问令牌已过期', '2019-09-04 18:25:22');
INSERT INTO `access_log` VALUES (75225, '65.46.15675927217359033', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '218.2.219.66', '2019-09-04 18:25:22', 3, 1002001012, '访问令牌已过期', '2019-09-04 18:25:22');
INSERT INTO `access_log` VALUES (75226, '65.53.15675952756898977', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.17.169.238', '2019-09-04 19:07:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 19:07:56');
INSERT INTO `access_log` VALUES (75227, '65.3607.15675952802870829', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.17.169.238', '2019-09-04 19:08:00', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 19:08:00');
INSERT INTO `access_log` VALUES (75228, '65.51.15675952996199079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.17.169.238', '2019-09-04 19:08:20', 95, 0, '', '2019-09-04 19:08:20');
INSERT INTO `access_log` VALUES (75229, '65.50.15675953000189043', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.17.169.238', '2019-09-04 19:08:20', 276, 0, '', '2019-09-04 19:08:20');
INSERT INTO `access_log` VALUES (75230, '65.46.15675953000249069', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.17.169.238', '2019-09-04 19:08:20', 270, 0, '', '2019-09-04 19:08:20');
INSERT INTO `access_log` VALUES (75231, '65.47.15675953000238989', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '112.17.169.238', '2019-09-04 19:08:20', 274, 2001001000, '服务端发生异常', '2019-09-04 19:08:20');
INSERT INTO `access_log` VALUES (75232, '64.82.15676007399005981', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 20:39:00', 17, 1002001012, '访问令牌已过期', '2019-09-04 20:39:00');
INSERT INTO `access_log` VALUES (75233, '64.78.15676007399005991', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 20:39:00', 17, 1002001012, '访问令牌已过期', '2019-09-04 20:39:00');
INSERT INTO `access_log` VALUES (75234, '65.54.15676007751868987', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.26.79.29', '2019-09-04 20:39:35', 1, 1002001015, '账号未登陆', '2019-09-04 20:39:35');
INSERT INTO `access_log` VALUES (75235, '65.51.15676007751869153', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.26.79.29', '2019-09-04 20:39:35', 0, 1002001015, '账号未登陆', '2019-09-04 20:39:35');
INSERT INTO `access_log` VALUES (75236, '65.46.15676007751979143', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.26.79.29', '2019-09-04 20:39:35', 0, 1002001015, '账号未登陆', '2019-09-04 20:39:35');
INSERT INTO `access_log` VALUES (75237, '65.47.15676007788299063', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.26.79.29', '2019-09-04 20:39:39', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 20:39:39');
INSERT INTO `access_log` VALUES (75238, '65.52.15676007826429171', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.26.79.29', '2019-09-04 20:39:43', 257, 0, '', '2019-09-04 20:39:43');
INSERT INTO `access_log` VALUES (75239, '65.49.15676007831979129', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.26.79.29', '2019-09-04 20:39:43', 11, 0, '', '2019-09-04 20:39:43');
INSERT INTO `access_log` VALUES (75240, '65.45.15676007831989147', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.26.79.29', '2019-09-04 20:39:43', 13, 2001001000, '服务端发生异常', '2019-09-04 20:39:43');
INSERT INTO `access_log` VALUES (75241, '65.53.15676007832029053', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.26.79.29', '2019-09-04 20:39:43', 10, 0, '', '2019-09-04 20:39:43');
INSERT INTO `access_log` VALUES (75242, '65.3607.15676007867040905', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 20:39:47', 299, 0, '', '2019-09-04 20:39:47');
INSERT INTO `access_log` VALUES (75243, '65.46.15676007873929145', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 20:39:47', 164, 0, '', '2019-09-04 20:39:48');
INSERT INTO `access_log` VALUES (75244, '65.54.15676007873918989', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 20:39:47', 164, 0, '', '2019-09-04 20:39:48');
INSERT INTO `access_log` VALUES (75245, '65.51.15676007873869155', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 20:39:47', 172, 0, '', '2019-09-04 20:39:48');
INSERT INTO `access_log` VALUES (75246, '65.47.15676007917309065', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 20:39:52', 23, 0, '', '2019-09-04 20:39:52');
INSERT INTO `access_log` VALUES (75247, '65.52.15676007974579173', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 20:39:57', 11, 0, '', '2019-09-04 20:39:57');
INSERT INTO `access_log` VALUES (75248, '65.49.15676008047719131', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.26.79.29', '2019-09-04 20:40:05', 9, 0, '', '2019-09-04 20:40:05');
INSERT INTO `access_log` VALUES (75249, '65.45.15676008047729149', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.26.79.29', '2019-09-04 20:40:05', 10, 2001001000, '服务端发生异常', '2019-09-04 20:40:05');
INSERT INTO `access_log` VALUES (75250, '65.53.15676008047739055', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '117.26.79.29', '2019-09-04 20:40:05', 10, 0, '', '2019-09-04 20:40:05');
INSERT INTO `access_log` VALUES (75251, '65.51.15676008243629157', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 20:40:24', 18, 0, '', '2019-09-04 20:40:24');
INSERT INTO `access_log` VALUES (75252, '65.46.15676008366459147', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 20:40:37', 12, 0, '', '2019-09-04 20:40:37');
INSERT INTO `access_log` VALUES (75253, '65.50.15676008418359121', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 20:40:42', 17, 0, '', '2019-09-04 20:40:42');
INSERT INTO `access_log` VALUES (75254, '65.49.15676013118659139', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.231.190.125', '2019-09-04 20:48:32', 1, 1002001015, '账号未登陆', '2019-09-04 20:48:32');
INSERT INTO `access_log` VALUES (75255, '65.45.15676013118649157', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.231.190.125', '2019-09-04 20:48:32', 0, 1002001015, '账号未登陆', '2019-09-04 20:48:32');
INSERT INTO `access_log` VALUES (75256, '65.53.15676013118659063', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.231.190.125', '2019-09-04 20:48:32', 1, 1002001015, '账号未登陆', '2019-09-04 20:48:32');
INSERT INTO `access_log` VALUES (75257, '65.3607.15676013148900915', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.231.190.125', '2019-09-04 20:48:35', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 20:48:35');
INSERT INTO `access_log` VALUES (75258, '65.51.15676013257509165', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.231.190.125', '2019-09-04 20:48:46', 96, 0, '', '2019-09-04 20:48:46');
INSERT INTO `access_log` VALUES (75259, '65.46.15676013260529155', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.231.190.125', '2019-09-04 20:48:46', 10, 0, '', '2019-09-04 20:48:46');
INSERT INTO `access_log` VALUES (75260, '65.50.15676013260559129', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.231.190.125', '2019-09-04 20:48:46', 8, 0, '', '2019-09-04 20:48:46');
INSERT INTO `access_log` VALUES (75261, '65.47.15676013260549075', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.231.190.125', '2019-09-04 20:48:46', 11, 2001001000, '服务端发生异常', '2019-09-04 20:48:46');
INSERT INTO `access_log` VALUES (75262, '65.46.15676080376389245', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-04 22:40:38', 20, 1002001012, '访问令牌已过期', '2019-09-04 22:40:38');
INSERT INTO `access_log` VALUES (75263, '65.50.15676080376369219', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-04 22:40:38', 20, 1002001012, '访问令牌已过期', '2019-09-04 22:40:38');
INSERT INTO `access_log` VALUES (75264, '65.47.15676080376359165', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-04 22:40:38', 23, 1002001012, '访问令牌已过期', '2019-09-04 22:40:38');
INSERT INTO `access_log` VALUES (75265, '65.52.15676080388669273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-04 22:40:39', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-04 22:40:39');
INSERT INTO `access_log` VALUES (75266, '65.45.15676080412239249', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-04 22:40:41', 72, 0, '', '2019-09-04 22:40:41');
INSERT INTO `access_log` VALUES (75267, '65.49.15676080417729231', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-04 22:40:42', 14, 0, '', '2019-09-04 22:40:42');
INSERT INTO `access_log` VALUES (75268, '65.3607.15676080417731007', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-04 22:40:42', 16, 0, '', '2019-09-04 22:40:42');
INSERT INTO `access_log` VALUES (75269, '65.54.15676080417739091', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-04 22:40:42', 17, 0, '', '2019-09-04 22:40:42');
INSERT INTO `access_log` VALUES (75270, '64.78.15676080435256089', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-04 22:40:44', 20, 0, '', '2019-09-04 22:40:44');
INSERT INTO `access_log` VALUES (75271, '64.77.15676080435246043', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-04 22:40:44', 25, 0, '', '2019-09-04 22:40:44');
INSERT INTO `access_log` VALUES (75272, '64.76.15676080452446073', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-04 22:40:45', 12, 0, '', '2019-09-04 22:40:45');
INSERT INTO `access_log` VALUES (75273, '64.82.15676080452436079', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-04 22:40:45', 15, 0, '', '2019-09-04 22:40:45');
INSERT INTO `access_log` VALUES (75274, '59.80.15676085097825615', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:48:30', 10, 2001001000, '服务端发生异常', '2019-09-04 22:48:30');
INSERT INTO `access_log` VALUES (75275, '59.79.15676085097595645', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:48:30', 77, 0, '', '2019-09-04 22:48:30');
INSERT INTO `access_log` VALUES (75276, '59.78.15676085261055657', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:48:46', 3, 0, '', '2019-09-04 22:48:46');
INSERT INTO `access_log` VALUES (75277, '59.76.15676085261175635', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:48:46', 12, 2001001000, '服务端发生异常', '2019-09-04 22:48:46');
INSERT INTO `access_log` VALUES (75278, '64.81.15676085395886075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:00', 4, 0, '', '2019-09-04 22:49:00');
INSERT INTO `access_log` VALUES (75279, '64.85.15676085396826093', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:00', 2, 0, '', '2019-09-04 22:49:00');
INSERT INTO `access_log` VALUES (75280, '64.79.15676085422646073', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:02', 2, 0, '', '2019-09-04 22:49:02');
INSERT INTO `access_log` VALUES (75281, '64.78.15676085430436097', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:03', 1, 0, '', '2019-09-04 22:49:03');
INSERT INTO `access_log` VALUES (75282, '64.82.15676085458716087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:06', 2, 0, '', '2019-09-04 22:49:06');
INSERT INTO `access_log` VALUES (75283, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:06', 5, 0, '', '2019-09-04 22:49:06');
INSERT INTO `access_log` VALUES (75284, '64.76.15676085480726081', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:08', 2, 0, '', '2019-09-04 22:49:08');
INSERT INTO `access_log` VALUES (75285, '64.83.15676085482226067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:08', 2, 0, '', '2019-09-04 22:49:08');
INSERT INTO `access_log` VALUES (75286, '59.71.15676085520245641', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:12', 13, 2001001000, '服务端发生异常', '2019-09-04 22:49:12');
INSERT INTO `access_log` VALUES (75287, '59.75.15676085520365651', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:12', 2, 0, '', '2019-09-04 22:49:12');
INSERT INTO `access_log` VALUES (75288, '64.81.15676085761346077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:36', 2, 0, '', '2019-09-04 22:49:36');
INSERT INTO `access_log` VALUES (75289, '64.85.15676085762666095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:36', 2, 0, '', '2019-09-04 22:49:36');
INSERT INTO `access_log` VALUES (75290, '59.80.15676085782845617', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:38', 3, 0, '', '2019-09-04 22:49:38');
INSERT INTO `access_log` VALUES (75291, '59.74.15676085782965659', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:38', 19, 2001001000, '服务端发生异常', '2019-09-04 22:49:38');
INSERT INTO `access_log` VALUES (75292, '64.79.15676085817936075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:42', 2, 0, '', '2019-09-04 22:49:42');
INSERT INTO `access_log` VALUES (75293, '64.78.15676085819536099', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:42', 2, 0, '', '2019-09-04 22:49:42');
INSERT INTO `access_log` VALUES (75294, '59.78.15676085829425659', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:43', 2, 0, '', '2019-09-04 22:49:43');
INSERT INTO `access_log` VALUES (75295, '59.76.15676085829325637', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:43', 12, 2001001000, '服务端发生异常', '2019-09-04 22:49:43');
INSERT INTO `access_log` VALUES (75296, '64.77.15676085834886053', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:43', 2, 0, '', '2019-09-04 22:49:43');
INSERT INTO `access_log` VALUES (75297, '64.82.15676085835996089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Safari/537.36 Edge/18.18362', '111.20.226.6', '2019-09-04 22:49:44', 2, 0, '', '2019-09-04 22:49:44');
INSERT INTO `access_log` VALUES (75298, '59.74.15676086729765661', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '110.184.242.253', '2019-09-04 22:51:13', 3, 0, '', '2019-09-04 22:51:13');
INSERT INTO `access_log` VALUES (75299, '59.80.15676086729765619', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '110.184.242.253', '2019-09-04 22:51:13', 13, 2001001000, '服务端发生异常', '2019-09-04 22:51:13');
INSERT INTO `access_log` VALUES (75300, '66.50.15676088028753023', 0, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:53:23', 8, 1002001012, '访问令牌已过期', '2019-09-04 22:53:23');
INSERT INTO `access_log` VALUES (75301, '65.50.15676088046329231', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:53:25', 177, 0, '', '2019-09-04 22:53:25');
INSERT INTO `access_log` VALUES (75302, '65.46.15676088052399257', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:53:25', 10, 0, '', '2019-09-04 22:53:25');
INSERT INTO `access_log` VALUES (75303, '65.47.15676088052399177', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:53:25', 9, 0, '', '2019-09-04 22:53:25');
INSERT INTO `access_log` VALUES (75304, '65.53.15676088052419167', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:53:25', 10, 0, '', '2019-09-04 22:53:25');
INSERT INTO `access_log` VALUES (75305, '64.79.15676088076086079', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:53:28', 10, 0, '', '2019-09-04 22:53:28');
INSERT INTO `access_log` VALUES (75306, '64.85.15676088076066099', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:53:28', 13, 0, '', '2019-09-04 22:53:28');
INSERT INTO `access_log` VALUES (75307, '66.54.15676088100453035', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:53:30', 34, 0, '', '2019-09-04 22:53:30');
INSERT INTO `access_log` VALUES (75308, '64.77.15676088271896057', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:53:47', 20, 0, '', '2019-09-04 22:53:47');
INSERT INTO `access_log` VALUES (75309, '64.82.15676088273636093', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:53:47', 12, 0, '', '2019-09-04 22:53:47');
INSERT INTO `access_log` VALUES (75310, '64.84.15676088329686077', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:53:53', 9, 0, '', '2019-09-04 22:53:53');
INSERT INTO `access_log` VALUES (75311, '64.83.15676088329656073', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:53:53', 12, 0, '', '2019-09-04 22:53:53');
INSERT INTO `access_log` VALUES (75312, '64.85.15676088701986101', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:54:30', 10, 0, '', '2019-09-04 22:54:30');
INSERT INTO `access_log` VALUES (75313, '64.78.15676088702046105', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:54:30', 18, 0, '', '2019-09-04 22:54:30');
INSERT INTO `access_log` VALUES (75314, '64.79.15676088702036081', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:54:30', 22, 0, '', '2019-09-04 22:54:30');
INSERT INTO `access_log` VALUES (75315, '64.76.15676088885706089', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:54:49', 9, 0, '', '2019-09-04 22:54:49');
INSERT INTO `access_log` VALUES (75316, '64.82.15676088885706095', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:54:49', 10, 0, '', '2019-09-04 22:54:49');
INSERT INTO `access_log` VALUES (75317, '65.51.15676088921609269', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:54:52', 30, 0, '', '2019-09-04 22:54:52');
INSERT INTO `access_log` VALUES (75318, '65.47.15676089082809179', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:55:08', 14, 0, '', '2019-09-04 22:55:08');
INSERT INTO `access_log` VALUES (75319, '65.53.15676089132889169', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:55:13', 12, 0, '', '2019-09-04 22:55:13');
INSERT INTO `access_log` VALUES (75320, '65.45.15676089240449263', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:55:24', 17, 0, '', '2019-09-04 22:55:24');
INSERT INTO `access_log` VALUES (75321, '65.49.15676089640139245', 1, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=zhangxinzhe&nickname=张信哲&password=123456', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:56:04', 144, 0, '', '2019-09-04 22:56:04');
INSERT INTO `access_log` VALUES (75322, '65.51.15676089643499271', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:56:04', 15, 0, '', '2019-09-04 22:56:04');
INSERT INTO `access_log` VALUES (75323, '65.47.15676089722649181', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=张', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:56:12', 17, 0, '', '2019-09-04 22:56:12');
INSERT INTO `access_log` VALUES (75324, '65.46.15676089750029261', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:56:15', 10, 0, '', '2019-09-04 22:56:15');
INSERT INTO `access_log` VALUES (75325, '65.52.15676089862059289', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:56:26', 10, 0, '', '2019-09-04 22:56:26');
INSERT INTO `access_log` VALUES (75326, '65.45.15676089930309265', 1, 2, 'admin-application', '/admin-api/admins/role/add', 'name=老张', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:56:33', 71, 0, '', '2019-09-04 22:56:33');
INSERT INTO `access_log` VALUES (75327, '65.54.15676089932539107', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:56:33', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-09-04 22:56:33');
INSERT INTO `access_log` VALUES (75328, '65.49.15676089997219247', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:56:40', 10, 0, '', '2019-09-04 22:56:40');
INSERT INTO `access_log` VALUES (75329, '65.51.15676090077619273', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:56:48', 19, 0, '', '2019-09-04 22:56:48');
INSERT INTO `access_log` VALUES (75330, '65.50.15676090122249237', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=张', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:56:52', 15, 0, '', '2019-09-04 22:56:52');
INSERT INTO `access_log` VALUES (75331, '65.47.15676090139039183', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:56:54', 9, 0, '', '2019-09-04 22:56:54');
INSERT INTO `access_log` VALUES (75332, '65.53.15676090192039173', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:56:59', 9, 0, '', '2019-09-04 22:56:59');
INSERT INTO `access_log` VALUES (75333, '65.52.15676090200409291', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:00', 9, 0, '', '2019-09-04 22:57:00');
INSERT INTO `access_log` VALUES (75334, '65.45.15676090254529267', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=11', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:05', 11, 0, '', '2019-09-04 22:57:05');
INSERT INTO `access_log` VALUES (75335, '65.3607.15676090347361025', 1, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=11&resourceIds=32,34,43', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:15', 100, 0, '', '2019-09-04 22:57:15');
INSERT INTO `access_log` VALUES (75336, '65.49.15676090368019249', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:17', 18, 0, '', '2019-09-04 22:57:17');
INSERT INTO `access_log` VALUES (75337, '65.51.15676090400029275', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=张', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:20', 17, 0, '', '2019-09-04 22:57:20');
INSERT INTO `access_log` VALUES (75338, '65.50.15676090415699239', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:22', 8, 0, '', '2019-09-04 22:57:22');
INSERT INTO `access_log` VALUES (75339, '65.46.15676090434169265', 1, 2, 'admin-application', '/admin-api/admins/admin/assign_role', 'id=28&roleIds=11', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:23', 65, 0, '', '2019-09-04 22:57:23');
INSERT INTO `access_log` VALUES (75340, '65.53.15676090459679175', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:26', 9, 0, '', '2019-09-04 22:57:26');
INSERT INTO `access_log` VALUES (75341, '65.52.15676090481599293', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:28', 13, 0, '', '2019-09-04 22:57:28');
INSERT INTO `access_log` VALUES (75342, '65.45.15676090573499269', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=zhangxinzhe&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:37', 5, 1002002001, '密码不正确', '2019-09-04 22:57:37');
INSERT INTO `access_log` VALUES (75343, '65.3607.15676090695921027', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=zhangxinzhe&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:50', 3, 1002002001, '密码不正确', '2019-09-04 22:57:50');
INSERT INTO `access_log` VALUES (75344, '65.49.15676090721989251', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:52', 86, 0, '', '2019-09-04 22:57:52');
INSERT INTO `access_log` VALUES (75345, '65.51.15676090724739277', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:52', 10, 0, '', '2019-09-04 22:57:52');
INSERT INTO `access_log` VALUES (75346, '65.50.15676090724759241', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:52', 9, 0, '', '2019-09-04 22:57:52');
INSERT INTO `access_log` VALUES (75347, '65.46.15676090725189267', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:53', 9, 0, '', '2019-09-04 22:57:53');
INSERT INTO `access_log` VALUES (75348, '65.53.15676090755599177', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:57:56', 19, 0, '', '2019-09-04 22:57:56');
INSERT INTO `access_log` VALUES (75349, '65.52.15676090801459295', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=张', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:58:00', 27, 0, '', '2019-09-04 22:58:00');
INSERT INTO `access_log` VALUES (75350, '65.45.15676090871579271', 1, 2, 'admin-application', '/admin-api/admins/admin/update', 'id=28&username=zhangxinzhe&nickname=张信哲&password=111111', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:58:07', 276, 0, '', '2019-09-04 22:58:07');
INSERT INTO `access_log` VALUES (75351, '65.54.15676090876229113', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:58:08', 17, 0, '', '2019-09-04 22:58:08');
INSERT INTO `access_log` VALUES (75352, '65.49.15676090901569253', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10&nickname=张', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:58:10', 17, 0, '', '2019-09-04 22:58:10');
INSERT INTO `access_log` VALUES (75353, '65.51.15676091027319279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=zhangxinzhe&password=111111&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:58:23', 90, 0, '', '2019-09-04 22:58:23');
INSERT INTO `access_log` VALUES (75354, '65.50.15676091030199243', 28, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:58:23', 8, 0, '', '2019-09-04 22:58:23');
INSERT INTO `access_log` VALUES (75355, '65.46.15676091030249269', 28, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:58:23', 8, 0, '', '2019-09-04 22:58:23');
INSERT INTO `access_log` VALUES (75356, '65.47.15676091030289189', 28, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:58:23', 8, 0, '', '2019-09-04 22:58:23');
INSERT INTO `access_log` VALUES (75357, '66.57.15676091084653019', 28, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:58:28', 13, 0, '', '2019-09-04 22:58:28');
INSERT INTO `access_log` VALUES (75358, '66.53.15676091114223011', 28, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:58:31', 10, 0, '', '2019-09-04 22:58:31');
INSERT INTO `access_log` VALUES (75359, '66.56.15676091139573037', 28, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 22:58:34', 11, 0, '', '2019-09-04 22:58:34');
INSERT INTO `access_log` VALUES (75360, '65.45.15676096769799279', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 23:07:57', 53, 0, '', '2019-09-04 23:07:57');
INSERT INTO `access_log` VALUES (75361, '65.50.15676096772039251', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 23:07:57', 10, 0, '', '2019-09-04 23:07:57');
INSERT INTO `access_log` VALUES (75362, '65.51.15676096772519287', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 23:07:57', 11, 0, '', '2019-09-04 23:07:57');
INSERT INTO `access_log` VALUES (75363, '65.49.15676096772539263', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 23:07:57', 10, 0, '', '2019-09-04 23:07:57');
INSERT INTO `access_log` VALUES (75364, '62.87.15676096801404183', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 23:08:00', 30, 0, '', '2019-09-04 23:08:00');
INSERT INTO `access_log` VALUES (75365, '64.78.15676096919016117', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 23:08:12', 11, 0, '', '2019-09-04 23:08:12');
INSERT INTO `access_log` VALUES (75366, '65.45.15676102221359287', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.3', '2019-09-04 23:17:02', 0, 1002001015, '账号未登陆', '2019-09-04 23:17:02');
INSERT INTO `access_log` VALUES (75367, '65.50.15676102221579259', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.4', '2019-09-04 23:17:02', 0, 1002001015, '账号未登陆', '2019-09-04 23:17:02');
INSERT INTO `access_log` VALUES (75368, '65.49.15676102221819271', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.3', '2019-09-04 23:17:02', 0, 1002001015, '账号未登陆', '2019-09-04 23:17:02');
INSERT INTO `access_log` VALUES (75369, '65.3607.15676116410541065', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.24', '2019-09-04 23:40:41', 9, 0, '', '2019-09-04 23:40:41');
INSERT INTO `access_log` VALUES (75370, '65.52.15676130910489353', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '42.236.10.84', '2019-09-05 00:04:51', 0, 1002001015, '账号未登陆', '2019-09-05 00:04:51');
INSERT INTO `access_log` VALUES (75371, '65.53.15676130910819235', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '42.236.10.84', '2019-09-05 00:04:51', 0, 1002001015, '账号未登陆', '2019-09-05 00:04:51');
INSERT INTO `access_log` VALUES (75372, '65.54.15676130910939171', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '42.236.10.93', '2019-09-05 00:04:51', 0, 1002001015, '账号未登陆', '2019-09-05 00:04:51');
INSERT INTO `access_log` VALUES (75373, '65.45.15676171537939381', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.67', '2019-09-05 01:12:34', 0, 1002001015, '账号未登陆', '2019-09-05 01:12:34');
INSERT INTO `access_log` VALUES (75374, '65.47.15676171537939299', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.5', '2019-09-05 01:12:34', 1, 1002001015, '账号未登陆', '2019-09-05 01:12:34');
INSERT INTO `access_log` VALUES (75375, '65.49.15676171537949365', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.66', '2019-09-05 01:12:34', 0, 1002001015, '账号未登陆', '2019-09-05 01:12:34');
INSERT INTO `access_log` VALUES (75376, '65.51.15676171633869389', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '42.236.10.125', '2019-09-05 01:12:43', 0, 1002001015, '账号未登陆', '2019-09-05 01:12:43');
INSERT INTO `access_log` VALUES (75377, '65.46.15676171633989383', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '42.236.10.114', '2019-09-05 01:12:43', 0, 1002001015, '账号未登陆', '2019-09-05 01:12:43');
INSERT INTO `access_log` VALUES (75378, '65.52.15676171633999409', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '42.236.10.117', '2019-09-05 01:12:43', 0, 1002001015, '账号未登陆', '2019-09-05 01:12:43');
INSERT INTO `access_log` VALUES (75379, '59.78.15676410159466091', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.63.206.38', '2019-09-05 07:50:16', 12, 0, '', '2019-09-05 07:50:16');
INSERT INTO `access_log` VALUES (75380, '59.71.15676410159486077', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.63.206.38', '2019-09-05 07:50:16', 26, 2001001000, '服务端发生异常', '2019-09-05 07:50:16');
INSERT INTO `access_log` VALUES (75381, '59.74.15676424325086113', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.174.213.198', '2019-09-05 08:13:53', 4, 0, '', '2019-09-05 08:13:53');
INSERT INTO `access_log` VALUES (75382, '59.80.15676424325106069', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.2.4098.3 Safari/537.36', '222.174.213.198', '2019-09-05 08:13:53', 21, 2001001000, '服务端发生异常', '2019-09-05 08:13:53');
INSERT INTO `access_log` VALUES (75383, '59.76.15676424330766087', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '222.174.213.198', '2019-09-05 08:13:53', 17, 2001001000, '服务端发生异常', '2019-09-05 08:13:53');
INSERT INTO `access_log` VALUES (75384, '59.71.15676424333206097', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/55.0.2883.87 UBrowser/6.1.3228.1 Safari/537.36', '222.174.213.198', '2019-09-05 08:13:53', 2, 0, '', '2019-09-05 08:13:53');
INSERT INTO `access_log` VALUES (75385, '65.45.15676459937809769', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3730.400 QQBrowser/10.5.3805.400', '211.157.146.98', '2019-09-05 09:13:14', 1, 1002001015, '账号未登陆', '2019-09-05 09:13:14');
INSERT INTO `access_log` VALUES (75386, '65.49.15676459937819749', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3730.400 QQBrowser/10.5.3805.400', '211.157.146.98', '2019-09-05 09:13:14', 0, 1002001015, '账号未登陆', '2019-09-05 09:13:14');
INSERT INTO `access_log` VALUES (75387, '65.51.15676459938039777', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3730.400 QQBrowser/10.5.3805.400', '211.157.146.98', '2019-09-05 09:13:14', 1, 1002001015, '账号未登陆', '2019-09-05 09:13:14');
INSERT INTO `access_log` VALUES (75388, '65.50.15676459995889739', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3730.400 QQBrowser/10.5.3805.400', '211.157.146.98', '2019-09-05 09:13:20', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 09:13:20');
INSERT INTO `access_log` VALUES (75389, '65.54.15676460110069615', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3730.400 QQBrowser/10.5.3805.400', '211.157.146.98', '2019-09-05 09:13:31', 174, 0, '', '2019-09-05 09:13:31');
INSERT INTO `access_log` VALUES (75390, '65.47.15676460114719685', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3730.400 QQBrowser/10.5.3805.400', '211.157.146.98', '2019-09-05 09:13:31', 74, 0, '', '2019-09-05 09:13:32');
INSERT INTO `access_log` VALUES (75391, '65.3607.15676460114761523', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3730.400 QQBrowser/10.5.3805.400', '211.157.146.98', '2019-09-05 09:13:31', 72, 0, '', '2019-09-05 09:13:32');
INSERT INTO `access_log` VALUES (75392, '65.52.15676460114729799', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3730.400 QQBrowser/10.5.3805.400', '211.157.146.98', '2019-09-05 09:13:31', 75, 2001001000, '服务端发生异常', '2019-09-05 09:13:32');
INSERT INTO `access_log` VALUES (75393, '65.45.15676465001719777', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:21:40', 1, 1002001015, '账号未登陆', '2019-09-05 09:21:40');
INSERT INTO `access_log` VALUES (75394, '65.50.15676465001729747', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:21:40', 0, 1002001015, '账号未登陆', '2019-09-05 09:21:40');
INSERT INTO `access_log` VALUES (75395, '65.53.15676465001749685', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:21:40', 1, 1002001015, '账号未登陆', '2019-09-05 09:21:40');
INSERT INTO `access_log` VALUES (75396, '65.54.15676465018009623', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:21:42', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 09:21:42');
INSERT INTO `access_log` VALUES (75397, '65.3607.15676465115741531', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:21:52', 67, 0, '', '2019-09-05 09:21:52');
INSERT INTO `access_log` VALUES (75398, '65.47.15676465117999693', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:21:52', 12, 0, '', '2019-09-05 09:21:52');
INSERT INTO `access_log` VALUES (75399, '65.46.15676465118029781', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:21:52', 10, 0, '', '2019-09-05 09:21:52');
INSERT INTO `access_log` VALUES (75400, '65.52.15676465118029807', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:21:52', 11, 2001001000, '服务端发生异常', '2019-09-05 09:21:52');
INSERT INTO `access_log` VALUES (75401, '65.45.15676465720689779', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:22:52', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 09:22:52');
INSERT INTO `access_log` VALUES (75402, '65.3607.15676465758471533', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:22:56', 73, 0, '', '2019-09-05 09:22:56');
INSERT INTO `access_log` VALUES (75403, '65.52.15676465760449809', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:22:56', 8, 0, '', '2019-09-05 09:22:56');
INSERT INTO `access_log` VALUES (75404, '65.46.15676465760479783', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:22:56', 17, 0, '', '2019-09-05 09:22:56');
INSERT INTO `access_log` VALUES (75405, '65.47.15676465760509695', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:22:56', 17, 0, '', '2019-09-05 09:22:56');
INSERT INTO `access_log` VALUES (75406, '62.84.15676465851614671', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:23:05', 29, 0, '', '2019-09-05 09:23:05');
INSERT INTO `access_log` VALUES (75407, '62.85.15676465954094705', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:23:15', 22, 0, '', '2019-09-05 09:23:15');
INSERT INTO `access_log` VALUES (75408, '64.76.15676465990926593', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:23:19', 27, 0, '', '2019-09-05 09:23:19');
INSERT INTO `access_log` VALUES (75409, '64.77.15676465990916563', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:23:19', 31, 0, '', '2019-09-05 09:23:19');
INSERT INTO `access_log` VALUES (75410, '65.50.15676466104189751', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:23:30', 3, 0, '', '2019-09-05 09:23:30');
INSERT INTO `access_log` VALUES (75411, '65.45.15676466269499781', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:23:47', 4, 0, '', '2019-09-05 09:23:47');
INSERT INTO `access_log` VALUES (75412, '64.81.15676466333306589', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:23:53', 13, 0, '', '2019-09-05 09:23:53');
INSERT INTO `access_log` VALUES (75413, '64.80.15676466333266583', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:23:53', 26, 0, '', '2019-09-05 09:23:53');
INSERT INTO `access_log` VALUES (75414, '64.78.15676466428206609', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:24:03', 11, 0, '', '2019-09-05 09:24:03');
INSERT INTO `access_log` VALUES (75415, '66.54.15676466705633541', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:24:31', 43, 0, '', '2019-09-05 09:24:31');
INSERT INTO `access_log` VALUES (75416, '66.53.15676466761843511', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:24:36', 12, 0, '', '2019-09-05 09:24:36');
INSERT INTO `access_log` VALUES (75417, '66.56.15676466768343539', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=3&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:24:37', 12, 0, '', '2019-09-05 09:24:37');
INSERT INTO `access_log` VALUES (75418, '66.48.15676466772913513', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=4&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:24:37', 12, 0, '', '2019-09-05 09:24:37');
INSERT INTO `access_log` VALUES (75419, '66.51.15676466776513543', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=6&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:24:38', 12, 0, '', '2019-09-05 09:24:38');
INSERT INTO `access_log` VALUES (75420, '59.75.15676466806126161', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:24:41', 30, 0, '', '2019-09-05 09:24:41');
INSERT INTO `access_log` VALUES (75421, '59.73.15676466876586155', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:24:48', 20, 2001001000, '服务端发生异常', '2019-09-05 09:24:48');
INSERT INTO `access_log` VALUES (75422, '59.80.15676466901436127', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:24:50', 14, 0, '', '2019-09-05 09:24:50');
INSERT INTO `access_log` VALUES (75423, '64.82.15676466927806599', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:24:53', 10, 0, '', '2019-09-05 09:24:53');
INSERT INTO `access_log` VALUES (75424, '65.45.15676467430699783', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:25:43', 9, 0, '', '2019-09-05 09:25:43');
INSERT INTO `access_log` VALUES (75425, '65.53.15676467430679691', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:25:43', 10, 0, '', '2019-09-05 09:25:43');
INSERT INTO `access_log` VALUES (75426, '65.54.15676467430719629', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:25:43', 8, 0, '', '2019-09-05 09:25:43');
INSERT INTO `access_log` VALUES (75427, '65.3607.15676467451221537', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:25:45', 31, 0, '', '2019-09-05 09:25:45');
INSERT INTO `access_log` VALUES (75428, '65.52.15676467505779813', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:25:51', 15, 0, '', '2019-09-05 09:25:51');
INSERT INTO `access_log` VALUES (75429, '65.47.15676467547159699', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:25:55', 13, 0, '', '2019-09-05 09:25:55');
INSERT INTO `access_log` VALUES (75430, '65.49.15676467602919765', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:26:00', 9, 0, '', '2019-09-05 09:26:00');
INSERT INTO `access_log` VALUES (75431, '65.54.15676467891309631', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:26:29', 15, 0, '', '2019-09-05 09:26:29');
INSERT INTO `access_log` VALUES (75432, '59.76.15676468552216147', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:35', 9, 0, '', '2019-09-05 09:27:35');
INSERT INTO `access_log` VALUES (75433, '59.71.15676468569386157', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:37', 31, 2001001000, '服务端发生异常', '2019-09-05 09:27:37');
INSERT INTO `access_log` VALUES (75434, '59.78.15676468595816171', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:40', 16, 0, '', '2019-09-05 09:27:40');
INSERT INTO `access_log` VALUES (75435, '59.77.15676468622486151', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:42', 13, 0, '', '2019-09-05 09:27:42');
INSERT INTO `access_log` VALUES (75436, '59.72.15676468660866159', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10&status=ALL&activityType=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:46', 13, 0, '', '2019-09-05 09:27:46');
INSERT INTO `access_log` VALUES (75437, '59.75.15676468667806165', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10&status=ALL&activityType=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:47', 11, 0, '', '2019-09-05 09:27:47');
INSERT INTO `access_log` VALUES (75438, '59.73.15676468673226159', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10&status=ALL&activityType=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:47', 11, 0, '', '2019-09-05 09:27:47');
INSERT INTO `access_log` VALUES (75439, '59.79.15676468676836165', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10&status=ALL&activityType=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:48', 12, 0, '', '2019-09-05 09:27:48');
INSERT INTO `access_log` VALUES (75440, '59.80.15676468685656131', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10&status=ALL&activityType=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:49', 11, 0, '', '2019-09-05 09:27:49');
INSERT INTO `access_log` VALUES (75441, '59.74.15676468688596175', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10&status=ALL&activityType=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:49', 11, 0, '', '2019-09-05 09:27:49');
INSERT INTO `access_log` VALUES (75442, '59.71.15676468712526159', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:51', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-09-05 09:27:51');
INSERT INTO `access_log` VALUES (75443, '59.78.15676468724526173', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:52', 10, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-09-05 09:27:52');
INSERT INTO `access_log` VALUES (75444, '59.77.15676468727236153', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:53', 9, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-09-05 09:27:53');
INSERT INTO `access_log` VALUES (75445, '59.72.15676468729866161', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:53', 11, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-09-05 09:27:53');
INSERT INTO `access_log` VALUES (75446, '65.49.15676468751109767', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:55', 20, 0, '', '2019-09-05 09:27:55');
INSERT INTO `access_log` VALUES (75447, '65.51.15676468755789795', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:56', 11, 0, '', '2019-09-05 09:27:56');
INSERT INTO `access_log` VALUES (75448, '65.50.15676468760729757', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:56', 8, 0, '', '2019-09-05 09:27:56');
INSERT INTO `access_log` VALUES (75449, '65.54.15676468764559633', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:27:56', 11, 0, '', '2019-09-05 09:27:56');
INSERT INTO `access_log` VALUES (75450, '59.79.15676468887456167', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:09', 2, 0, '', '2019-09-05 09:28:09');
INSERT INTO `access_log` VALUES (75451, '59.73.15676468887456161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:09', 18, 2001001000, '服务端发生异常', '2019-09-05 09:28:09');
INSERT INTO `access_log` VALUES (75452, '59.74.15676468918836177', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:12', 3, 0, '', '2019-09-05 09:28:12');
INSERT INTO `access_log` VALUES (75453, '59.80.15676468918836133', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:12', 13, 2001001000, '服务端发生异常', '2019-09-05 09:28:12');
INSERT INTO `access_log` VALUES (75454, '64.81.15676468978856593', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:18', 3, 0, '', '2019-09-05 09:28:18');
INSERT INTO `access_log` VALUES (75455, '64.78.15676468979906613', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:18', 2, 0, '', '2019-09-05 09:28:18');
INSERT INTO `access_log` VALUES (75456, '64.85.15676468995516611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:20', 2, 0, '', '2019-09-05 09:28:20');
INSERT INTO `access_log` VALUES (75457, '64.79.15676469000646591', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:20', 1, 0, '', '2019-09-05 09:28:20');
INSERT INTO `access_log` VALUES (75458, '64.76.15676469004796599', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:20', 2, 0, '', '2019-09-05 09:28:20');
INSERT INTO `access_log` VALUES (75459, '64.82.15676469007846603', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:21', 2, 0, '', '2019-09-05 09:28:21');
INSERT INTO `access_log` VALUES (75460, '64.84.15676469066216589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:27', 2, 0, '', '2019-09-05 09:28:27');
INSERT INTO `access_log` VALUES (75461, '64.83.15676469067166585', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:27', 2, 0, '', '2019-09-05 09:28:27');
INSERT INTO `access_log` VALUES (75462, '64.80.15676469090126589', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:29', 3, 0, '', '2019-09-05 09:28:29');
INSERT INTO `access_log` VALUES (75463, '64.81.15676469091106595', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:29', 1, 0, '', '2019-09-05 09:28:29');
INSERT INTO `access_log` VALUES (75464, '64.85.15676469266396613', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:28:47', 4, 1003002003, 'Spu 只能添加在二级分类下', '2019-09-05 09:28:47');
INSERT INTO `access_log` VALUES (75465, '64.77.15676469416936571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:29:02', 2, 0, '', '2019-09-05 09:29:02');
INSERT INTO `access_log` VALUES (75466, '64.76.15676469417866601', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:29:02', 2, 0, '', '2019-09-05 09:29:02');
INSERT INTO `access_log` VALUES (75467, '59.72.15676469438846163', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:29:04', 2, 0, '', '2019-09-05 09:29:04');
INSERT INTO `access_log` VALUES (75468, '59.77.15676469438846155', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3724.8 Safari/537.36', '58.216.137.131', '2019-09-05 09:29:04', 31, 2001001000, '服务端发生异常', '2019-09-05 09:29:04');
INSERT INTO `access_log` VALUES (75469, '65.51.15676475858969805', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-05 09:39:46', 4, 1002001012, '访问令牌已过期', '2019-09-05 09:39:46');
INSERT INTO `access_log` VALUES (75470, '65.50.15676475858989767', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-05 09:39:46', 4, 1002001012, '访问令牌已过期', '2019-09-05 09:39:46');
INSERT INTO `access_log` VALUES (75471, '65.54.15676475858999643', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-05 09:39:46', 3, 1002001012, '访问令牌已过期', '2019-09-05 09:39:46');
INSERT INTO `access_log` VALUES (75472, '65.45.15676475888979797', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-05 09:39:49', 91, 0, '', '2019-09-05 09:39:49');
INSERT INTO `access_log` VALUES (75473, '65.53.15676475891779705', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-05 09:39:49', 10, 0, '', '2019-09-05 09:39:49');
INSERT INTO `access_log` VALUES (75474, '65.3607.15676475891771551', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-05 09:39:49', 10, 0, '', '2019-09-05 09:39:49');
INSERT INTO `access_log` VALUES (75475, '65.52.15676475891799827', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-05 09:39:49', 10, 0, '', '2019-09-05 09:39:49');
INSERT INTO `access_log` VALUES (75476, '64.78.15676475918896625', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-05 09:39:52', 11, 0, '', '2019-09-05 09:39:52');
INSERT INTO `access_log` VALUES (75477, '64.81.15676475918886605', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-05 09:39:52', 14, 0, '', '2019-09-05 09:39:52');
INSERT INTO `access_log` VALUES (75478, '64.79.15676475935176603', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-05 09:39:54', 9, 0, '', '2019-09-05 09:39:54');
INSERT INTO `access_log` VALUES (75479, '64.85.15676475935166623', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '61.152.68.46', '2019-09-05 09:39:54', 11, 0, '', '2019-09-05 09:39:54');
INSERT INTO `access_log` VALUES (75480, '65.51.15676480775279813', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:47:58', 4, 1002001012, '访问令牌已过期', '2019-09-05 09:47:58');
INSERT INTO `access_log` VALUES (75481, '65.50.15676480775329775', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:47:58', 3, 1002001012, '访问令牌已过期', '2019-09-05 09:47:58');
INSERT INTO `access_log` VALUES (75482, '65.54.15676480775339651', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:47:58', 3, 1002001012, '访问令牌已过期', '2019-09-05 09:47:58');
INSERT INTO `access_log` VALUES (75483, '65.45.15676480794679805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:47:59', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 09:47:59');
INSERT INTO `access_log` VALUES (75484, '65.3607.15676480899001559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:48:10', 85, 0, '', '2019-09-05 09:48:10');
INSERT INTO `access_log` VALUES (75485, '65.52.15676480902459835', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:48:10', 10, 0, '', '2019-09-05 09:48:10');
INSERT INTO `access_log` VALUES (75486, '65.46.15676480902499809', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:48:10', 8, 0, '', '2019-09-05 09:48:10');
INSERT INTO `access_log` VALUES (75487, '65.47.15676480902569721', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:48:10', 8, 0, '', '2019-09-05 09:48:10');
INSERT INTO `access_log` VALUES (75488, '62.80.15676481069274717', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:48:27', 15, 0, '', '2019-09-05 09:48:27');
INSERT INTO `access_log` VALUES (75489, '64.80.15676481109746607', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:48:31', 11, 0, '', '2019-09-05 09:48:31');
INSERT INTO `access_log` VALUES (75490, '64.83.15676481109726603', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:48:31', 15, 0, '', '2019-09-05 09:48:31');
INSERT INTO `access_log` VALUES (75491, '64.84.15676482041766609', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:50:04', 10, 0, '', '2019-09-05 09:50:04');
INSERT INTO `access_log` VALUES (75492, '64.82.15676482041756623', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:50:04', 20, 0, '', '2019-09-05 09:50:04');
INSERT INTO `access_log` VALUES (75493, '64.78.15676482121626635', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:50:12', 10, 0, '', '2019-09-05 09:50:12');
INSERT INTO `access_log` VALUES (75494, '64.81.15676482121626615', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:50:12', 12, 0, '', '2019-09-05 09:50:12');
INSERT INTO `access_log` VALUES (75495, '64.83.15676482121616605', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=32', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:50:12', 14, 0, '', '2019-09-05 09:50:12');
INSERT INTO `access_log` VALUES (75496, '66.57.15676482615733543', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:51:02', 14, 0, '', '2019-09-05 09:51:02');
INSERT INTO `access_log` VALUES (75497, '65.50.15676482755259779', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:51:16', 66, 0, '', '2019-09-05 09:51:16');
INSERT INTO `access_log` VALUES (75498, '65.54.15676482831609655', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:51:23', 9, 0, '', '2019-09-05 09:51:23');
INSERT INTO `access_log` VALUES (75499, '65.53.15676482862589717', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 09:51:26', 9, 0, '', '2019-09-05 09:51:26');
INSERT INTO `access_log` VALUES (75500, '65.51.15676491205339829', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:05:21', 1, 1002001015, '账号未登陆', '2019-09-05 10:05:21');
INSERT INTO `access_log` VALUES (75501, '65.50.15676491205339791', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:05:21', 0, 1002001015, '账号未登陆', '2019-09-05 10:05:21');
INSERT INTO `access_log` VALUES (75502, '65.54.15676491205439667', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:05:21', 1, 1002001015, '账号未登陆', '2019-09-05 10:05:21');
INSERT INTO `access_log` VALUES (75503, '59.73.15676493560186195', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.87.202.24', '2019-09-05 10:09:16', 11, 0, '', '2019-09-05 10:09:16');
INSERT INTO `access_log` VALUES (75504, '59.79.15676493560196201', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.87.202.24', '2019-09-05 10:09:16', 22, 2001001000, '服务端发生异常', '2019-09-05 10:09:16');
INSERT INTO `access_log` VALUES (75505, '65.49.15676493597279805', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:09:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 10:09:20');
INSERT INTO `access_log` VALUES (75506, '65.51.15676493669799833', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.87.202.24', '2019-09-05 10:09:27', 1, 1002001015, '账号未登陆', '2019-09-05 10:09:27');
INSERT INTO `access_log` VALUES (75507, '65.54.15676493669799671', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.87.202.24', '2019-09-05 10:09:27', 0, 1002001015, '账号未登陆', '2019-09-05 10:09:27');
INSERT INTO `access_log` VALUES (75508, '65.45.15676493669819825', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.87.202.24', '2019-09-05 10:09:27', 0, 1002001015, '账号未登陆', '2019-09-05 10:09:27');
INSERT INTO `access_log` VALUES (75509, '65.53.15676493686489733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.87.202.24', '2019-09-05 10:09:29', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 10:09:29');
INSERT INTO `access_log` VALUES (75510, '65.3607.15676493735481579', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:09:34', 168, 0, '', '2019-09-05 10:09:34');
INSERT INTO `access_log` VALUES (75511, '65.46.15676493741209829', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:09:34', 10, 0, '', '2019-09-05 10:09:34');
INSERT INTO `access_log` VALUES (75512, '65.52.15676493741219855', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:09:34', 12, 2001001000, '服务端发生异常', '2019-09-05 10:09:34');
INSERT INTO `access_log` VALUES (75513, '65.47.15676493741239741', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:09:34', 9, 0, '', '2019-09-05 10:09:34');
INSERT INTO `access_log` VALUES (75514, '65.51.15676493951579835', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:09:55', 10, 0, '', '2019-09-05 10:09:55');
INSERT INTO `access_log` VALUES (75515, '65.54.15676493951609673', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:09:55', 10, 2001001000, '服务端发生异常', '2019-09-05 10:09:55');
INSERT INTO `access_log` VALUES (75516, '65.45.15676493951629827', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:09:55', 9, 0, '', '2019-09-05 10:09:55');
INSERT INTO `access_log` VALUES (75517, '65.54.15676495363939675', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.33.27.166', '2019-09-05 10:12:16', 1, 1002001015, '账号未登陆', '2019-09-05 10:12:16');
INSERT INTO `access_log` VALUES (75518, '65.53.15676495363989737', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.33.27.166', '2019-09-05 10:12:16', 0, 1002001015, '账号未登陆', '2019-09-05 10:12:16');
INSERT INTO `access_log` VALUES (75519, '65.3607.15676495364021583', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.33.27.166', '2019-09-05 10:12:16', 0, 1002001015, '账号未登陆', '2019-09-05 10:12:16');
INSERT INTO `access_log` VALUES (75520, '65.47.15676495406279745', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.33.27.166', '2019-09-05 10:12:21', 70, 0, '', '2019-09-05 10:12:21');
INSERT INTO `access_log` VALUES (75521, '65.52.15676495411599859', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.33.27.166', '2019-09-05 10:12:21', 10, 0, '', '2019-09-05 10:12:21');
INSERT INTO `access_log` VALUES (75522, '65.46.15676495411619833', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.33.27.166', '2019-09-05 10:12:21', 17, 2001001000, '服务端发生异常', '2019-09-05 10:12:21');
INSERT INTO `access_log` VALUES (75523, '65.49.15676495411649811', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.33.27.166', '2019-09-05 10:12:21', 17, 0, '', '2019-09-05 10:12:21');
INSERT INTO `access_log` VALUES (75524, '65.51.15676495533929839', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.33.27.166', '2019-09-05 10:12:33', 9, 0, '', '2019-09-05 10:12:33');
INSERT INTO `access_log` VALUES (75525, '65.45.15676495533949831', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.33.27.166', '2019-09-05 10:12:33', 9, 2001001000, '服务端发生异常', '2019-09-05 10:12:33');
INSERT INTO `access_log` VALUES (75526, '65.54.15676495533989677', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/68.0.3440.106 Safari/537.36', '125.33.27.166', '2019-09-05 10:12:33', 8, 0, '', '2019-09-05 10:12:33');
INSERT INTO `access_log` VALUES (75527, '59.76.15676498349706191', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:17:15', 6, 0, '', '2019-09-05 10:17:15');
INSERT INTO `access_log` VALUES (75528, '59.71.15676498349716201', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:17:15', 14, 2001001000, '服务端发生异常', '2019-09-05 10:17:15');
INSERT INTO `access_log` VALUES (75529, '59.78.15676498382816215', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:17:18', 15, 2001001000, '服务端发生异常', '2019-09-05 10:17:18');
INSERT INTO `access_log` VALUES (75530, '59.75.15676498383226209', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.237.67.146', '2019-09-05 10:17:18', 2, 0, '', '2019-09-05 10:17:18');
INSERT INTO `access_log` VALUES (75531, '64.85.15676498555866655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:17:36', 6, 0, '', '2019-09-05 10:17:36');
INSERT INTO `access_log` VALUES (75532, '64.79.15676498558026635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:17:36', 3, 0, '', '2019-09-05 10:17:36');
INSERT INTO `access_log` VALUES (75533, '66.54.15676498844933585', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18812345678', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:18:04', 77, 0, '', '2019-09-05 10:18:05');
INSERT INTO `access_log` VALUES (75534, '66.53.15676498872483555', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18812345678&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:18:07', 219, 0, '', '2019-09-05 10:18:07');
INSERT INTO `access_log` VALUES (75535, '66.48.15676498890253557', 220, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:18:09', 5, 0, '', '2019-09-05 10:18:09');
INSERT INTO `access_log` VALUES (75536, '66.51.15676498924903587', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:18:12', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-09-05 10:18:12');
INSERT INTO `access_log` VALUES (75537, '66.55.15676498948033547', 220, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:18:15', 6, 0, '', '2019-09-05 10:18:15');
INSERT INTO `access_log` VALUES (75538, '66.50.15676498958103575', 220, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:18:16', 5, 0, '', '2019-09-05 10:18:16');
INSERT INTO `access_log` VALUES (75539, '66.57.15676498969143567', 220, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:18:17', 5, 0, '', '2019-09-05 10:18:17');
INSERT INTO `access_log` VALUES (75540, '66.48.15676499025673559', 220, 1, 'user-application', '/user-api/users/user/update_nickname', 'nickname=hai', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:18:23', 126, 0, '', '2019-09-05 10:18:23');
INSERT INTO `access_log` VALUES (75541, '66.49.15676499081173575', 220, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:18:28', 5, 0, '', '2019-09-05 10:18:28');
INSERT INTO `access_log` VALUES (75542, '66.54.15676499403753589', 220, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:19:00', 6, 0, '', '2019-09-05 10:19:00');
INSERT INTO `access_log` VALUES (75543, '64.83.15676499418736629', 220, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:19:02', 5, 0, '', '2019-09-05 10:19:02');
INSERT INTO `access_log` VALUES (75544, '64.85.15676499420586657', 220, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:19:02', 4, 0, '', '2019-09-05 10:19:02');
INSERT INTO `access_log` VALUES (75545, '64.77.15676499434526615', 220, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:19:03', 6, 0, '', '2019-09-05 10:19:03');
INSERT INTO `access_log` VALUES (75546, 'N/A', 220, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:19:03', 19, 0, '', '2019-09-05 10:19:04');
INSERT INTO `access_log` VALUES (75547, '64.84.15676499451186635', 220, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:19:05', 9, 0, '', '2019-09-05 10:19:05');
INSERT INTO `access_log` VALUES (75548, '66.56.15676499519813587', 220, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:19:12', 6, 0, '', '2019-09-05 10:19:12');
INSERT INTO `access_log` VALUES (75549, '66.51.15676499567793591', 220, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:19:17', 5, 0, '', '2019-09-05 10:19:17');
INSERT INTO `access_log` VALUES (75550, '66.50.15676499822353579', 220, 1, 'user-application', '/user-api/users/address/add', 'name=z&tel=18812345678&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=zz&isDefault=true&address=zz&areaNo=110101&mobile=18812345678&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:19:42', 101, 2001001000, '服务端发生异常', '2019-09-05 10:19:42');
INSERT INTO `access_log` VALUES (75551, '66.53.15676499989273561', 220, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:19:59', 7, 0, '', '2019-09-05 10:19:59');
INSERT INTO `access_log` VALUES (75552, '66.48.15676499997573563', 220, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:00', 7, 0, '', '2019-09-05 10:20:00');
INSERT INTO `access_log` VALUES (75553, '64.85.15676500005676659', 220, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:01', 10, 0, '', '2019-09-05 10:20:01');
INSERT INTO `access_log` VALUES (75554, '64.77.15676500020126617', 220, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:02', 4, 0, '', '2019-09-05 10:20:02');
INSERT INTO `access_log` VALUES (75555, 'N/A', 220, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:02', 10, 0, '', '2019-09-05 10:20:02');
INSERT INTO `access_log` VALUES (75556, '64.84.15676500028596637', 220, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:03', 5, 0, '', '2019-09-05 10:20:03');
INSERT INTO `access_log` VALUES (75557, '64.80.15676500030276637', 220, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:03', 5, 0, '', '2019-09-05 10:20:03');
INSERT INTO `access_log` VALUES (75558, '64.83.15676500043886633', 220, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:04', 4, 0, '', '2019-09-05 10:20:04');
INSERT INTO `access_log` VALUES (75559, '64.85.15676500052306661', 220, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:05', 4, 0, '', '2019-09-05 10:20:05');
INSERT INTO `access_log` VALUES (75560, '59.74.15676500072426221', 220, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:07', 6, 0, '', '2019-09-05 10:20:07');
INSERT INTO `access_log` VALUES (75561, '59.80.15676500072406177', 220, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:07', 17, 2001001000, '服务端发生异常', '2019-09-05 10:20:07');
INSERT INTO `access_log` VALUES (75562, '64.84.15676500246506639', 220, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:25', 5, 0, '', '2019-09-05 10:20:25');
INSERT INTO `access_log` VALUES (75563, '64.80.15676500248436639', 220, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:25', 5, 0, '', '2019-09-05 10:20:25');
INSERT INTO `access_log` VALUES (75564, 'N/A', 220, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:27', 11, 0, '', '2019-09-05 10:20:27');
INSERT INTO `access_log` VALUES (75565, 'N/A', 220, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:28', 10, 0, '', '2019-09-05 10:20:28');
INSERT INTO `access_log` VALUES (75566, 'N/A', 220, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:28', 13, 0, '', '2019-09-05 10:20:28');
INSERT INTO `access_log` VALUES (75567, 'N/A', 220, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:28', 14, 0, '', '2019-09-05 10:20:28');
INSERT INTO `access_log` VALUES (75568, 'N/A', 220, 1, 'search-application', '/search-api/users/product/page', 'cid=639&keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:35', 8, 0, '', '2019-09-05 10:20:35');
INSERT INTO `access_log` VALUES (75569, 'N/A', 220, 1, 'search-application', '/search-api/users/product/page', 'cid=579&keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:38', 9, 0, '', '2019-09-05 10:20:38');
INSERT INTO `access_log` VALUES (75570, '64.78.15676500404256665', 220, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:40', 4, 0, '', '2019-09-05 10:20:40');
INSERT INTO `access_log` VALUES (75571, '64.79.15676500406066643', 220, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:41', 4, 0, '', '2019-09-05 10:20:41');
INSERT INTO `access_log` VALUES (75572, '59.72.15676500430226207', 220, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:43', 14, 2001001000, '服务端发生异常', '2019-09-05 10:20:43');
INSERT INTO `access_log` VALUES (75573, '59.77.15676500432876199', 220, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:43', 6, 0, '', '2019-09-05 10:20:43');
INSERT INTO `access_log` VALUES (75574, '66.50.15676500473893581', 220, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:47', 5, 0, '', '2019-09-05 10:20:47');
INSERT INTO `access_log` VALUES (75575, '59.74.15676500520996223', 220, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:52', 9, 0, '', '2019-09-05 10:20:52');
INSERT INTO `access_log` VALUES (75576, '59.76.15676500533226197', 220, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=2&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:53', 5, 0, '', '2019-09-05 10:20:53');
INSERT INTO `access_log` VALUES (75577, '59.78.15676500539526221', 220, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=3&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:54', 7, 0, '', '2019-09-05 10:20:54');
INSERT INTO `access_log` VALUES (75578, '66.53.15676500563333563', 220, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:20:56', 5, 0, '', '2019-09-05 10:20:56');
INSERT INTO `access_log` VALUES (75579, '65.53.15676510782879761', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:37:58', 4, 1002001012, '访问令牌已过期', '2019-09-05 10:37:58');
INSERT INTO `access_log` VALUES (75580, '65.47.15676510782889767', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:37:58', 3, 1002001012, '访问令牌已过期', '2019-09-05 10:37:58');
INSERT INTO `access_log` VALUES (75581, '65.51.15676510782879859', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:37:58', 4, 1002001012, '访问令牌已过期', '2019-09-05 10:37:58');
INSERT INTO `access_log` VALUES (75582, '64.79.15676510785356657', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:37:59', 15, 1002001012, '访问令牌已过期', '2019-09-05 10:37:59');
INSERT INTO `access_log` VALUES (75583, '64.77.15676510785416635', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:37:59', 10, 1002001012, '访问令牌已过期', '2019-09-05 10:37:59');
INSERT INTO `access_log` VALUES (75584, '65.52.15676510851539881', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:38:05', 766, 0, '', '2019-09-05 10:38:06');
INSERT INTO `access_log` VALUES (75585, '65.46.15676510863379855', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:38:06', 10, 0, '', '2019-09-05 10:38:06');
INSERT INTO `access_log` VALUES (75586, '65.49.15676510863409835', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:38:06', 9, 0, '', '2019-09-05 10:38:06');
INSERT INTO `access_log` VALUES (75587, '65.50.15676510863449823', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:38:06', 9, 0, '', '2019-09-05 10:38:06');
INSERT INTO `access_log` VALUES (75588, '64.84.15676510929156655', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:38:13', 29, 0, '', '2019-09-05 10:38:13');
INSERT INTO `access_log` VALUES (75589, '64.82.15676510929376669', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:38:13', 10, 0, '', '2019-09-05 10:38:13');
INSERT INTO `access_log` VALUES (75590, '64.78.15676511353446681', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=1&name=金色', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:38:55', 95, 0, '', '2019-09-05 10:38:55');
INSERT INTO `access_log` VALUES (75591, '64.85.15676511355836679', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:38:56', 10, 0, '', '2019-09-05 10:38:56');
INSERT INTO `access_log` VALUES (75592, '65.51.15676511370759861', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 10:38:57', 0, 1002001015, '账号未登陆', '2019-09-05 10:38:57');
INSERT INTO `access_log` VALUES (75593, '65.47.15676511370789769', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 10:38:57', 1, 1002001015, '账号未登陆', '2019-09-05 10:38:57');
INSERT INTO `access_log` VALUES (75594, '65.52.15676511370829883', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 10:38:57', 1, 1002001015, '账号未登陆', '2019-09-05 10:38:57');
INSERT INTO `access_log` VALUES (75595, '65.46.15676511393079857', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 10:38:59', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 10:38:59');
INSERT INTO `access_log` VALUES (75596, '64.79.15676511448056659', 1, 2, 'product-application', '/product-api/admins/attr_value/add', 'attrId=2&name=一克拉', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:39:05', 337, 0, '', '2019-09-05 10:39:05');
INSERT INTO `access_log` VALUES (75597, '64.77.15676511453276637', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:39:05', 12, 0, '', '2019-09-05 10:39:05');
INSERT INTO `access_log` VALUES (75598, '65.50.15676511557039825', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 10:39:16', 62, 0, '', '2019-09-05 10:39:16');
INSERT INTO `access_log` VALUES (75599, '65.54.15676511560719703', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 10:39:16', 7, 0, '', '2019-09-05 10:39:16');
INSERT INTO `access_log` VALUES (75600, '65.45.15676511560739857', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 10:39:16', 8, 2001001000, '服务端发生异常', '2019-09-05 10:39:16');
INSERT INTO `access_log` VALUES (75601, '65.3607.15676511560751611', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 10:39:16', 7, 0, '', '2019-09-05 10:39:16');
INSERT INTO `access_log` VALUES (75602, '65.50.15676512419139827', 1, 2, 'admin-application', '/admin-api/admins/file/get_qiniu_token', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:40:42', 4, 0, '', '2019-09-05 10:40:42');
INSERT INTO `access_log` VALUES (75603, '64.76.15676512843166669', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=金坷垃&sellPoint=农民伯伯都爱它&cid=783&visible=true&picUrls=http://static.shop.iocoder.cn/8fb41fd6-2ace-4e66-870d-28cff91084ae&skuStr=[{\"attrs\":[49,50],\"price\":10000,\"quantity\":100}]&description=<p>金坷拉</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:41:24', 279, 2001001000, '服务端发生异常', '2019-09-05 10:41:25');
INSERT INTO `access_log` VALUES (75604, '65.3607.15676542451371653', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:30:45', 1, 1002001015, '账号未登陆', '2019-09-05 11:30:45');
INSERT INTO `access_log` VALUES (75605, '65.45.15676542451379899', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:30:45', 1, 1002001015, '账号未登陆', '2019-09-05 11:30:45');
INSERT INTO `access_log` VALUES (75606, '65.54.15676542451379745', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:30:45', 0, 1002001015, '账号未登陆', '2019-09-05 11:30:45');
INSERT INTO `access_log` VALUES (75607, '65.53.15676542473639807', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:30:47', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 11:30:47');
INSERT INTO `access_log` VALUES (75608, '65.47.15676542547259813', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:30:55', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 11:30:55');
INSERT INTO `access_log` VALUES (75609, '65.51.15676542664199905', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:31:06', 92, 0, '', '2019-09-05 11:31:07');
INSERT INTO `access_log` VALUES (75610, '65.49.15676542668449881', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:31:07', 22, 2001001000, '服务端发生异常', '2019-09-05 11:31:07');
INSERT INTO `access_log` VALUES (75611, '65.50.15676542668479869', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:31:07', 20, 0, '', '2019-09-05 11:31:07');
INSERT INTO `access_log` VALUES (75612, '65.46.15676542668449901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:31:07', 23, 0, '', '2019-09-05 11:31:07');
INSERT INTO `access_log` VALUES (75613, '65.45.15676542903109901', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:31:30', 11, 0, '', '2019-09-05 11:31:30');
INSERT INTO `access_log` VALUES (75614, '65.52.15676542903149929', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:31:30', 10, 0, '', '2019-09-05 11:31:30');
INSERT INTO `access_log` VALUES (75615, '65.53.15676542903149809', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:31:30', 12, 2001001000, '服务端发生异常', '2019-09-05 11:31:30');
INSERT INTO `access_log` VALUES (75616, '65.49.15676543285249883', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:32:09', 8, 0, '', '2019-09-05 11:32:09');
INSERT INTO `access_log` VALUES (75617, '65.50.15676543285249871', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:32:09', 10, 2001001000, '服务端发生异常', '2019-09-05 11:32:09');
INSERT INTO `access_log` VALUES (75618, '65.46.15676543285289903', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '1.202.147.132', '2019-09-05 11:32:09', 9, 0, '', '2019-09-05 11:32:09');
INSERT INTO `access_log` VALUES (75619, '59.76.15676546628466259', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:37:43', 10, 0, '', '2019-09-05 11:37:43');
INSERT INTO `access_log` VALUES (75620, '59.71.15676546628486269', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:37:43', 23, 2001001000, '服务端发生异常', '2019-09-05 11:37:43');
INSERT INTO `access_log` VALUES (75621, '64.82.15676546708156719', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:37:51', 11, 0, '', '2019-09-05 11:37:51');
INSERT INTO `access_log` VALUES (75622, '64.80.15676546709686705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:37:51', 3, 0, '', '2019-09-05 11:37:51');
INSERT INTO `access_log` VALUES (75623, '64.78.15676546723946731', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:37:52', 2, 0, '', '2019-09-05 11:37:52');
INSERT INTO `access_log` VALUES (75624, '64.83.15676546727876701', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:37:53', 2, 0, '', '2019-09-05 11:37:53');
INSERT INTO `access_log` VALUES (75625, '59.75.15676546733336277', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:37:53', 2, 0, '', '2019-09-05 11:37:53');
INSERT INTO `access_log` VALUES (75626, '59.72.15676546733346271', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:37:53', 13, 2001001000, '服务端发生异常', '2019-09-05 11:37:53');
INSERT INTO `access_log` VALUES (75627, '65.54.15676546876029755', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:38:08', 10, 1002001012, '访问令牌已过期', '2019-09-05 11:38:08');
INSERT INTO `access_log` VALUES (75628, '65.53.15676546876049817', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:38:08', 9, 1002001012, '访问令牌已过期', '2019-09-05 11:38:08');
INSERT INTO `access_log` VALUES (75629, '65.45.15676546876029909', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:38:08', 12, 1002001012, '访问令牌已过期', '2019-09-05 11:38:08');
INSERT INTO `access_log` VALUES (75630, '65.51.15676546914739913', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:38:11', 66, 0, '', '2019-09-05 11:38:12');
INSERT INTO `access_log` VALUES (75631, '65.46.15676546918409909', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:38:12', 53, 0, '', '2019-09-05 11:38:12');
INSERT INTO `access_log` VALUES (75632, '65.52.15676546918439937', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:38:12', 52, 0, '', '2019-09-05 11:38:12');
INSERT INTO `access_log` VALUES (75633, '65.50.15676546918419877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/58.0.3029.110 Safari/537.36 SE 2.X MetaSr 1.0', '117.107.132.42', '2019-09-05 11:38:12', 53, 2001001000, '服务端发生异常', '2019-09-05 11:38:12');
INSERT INTO `access_log` VALUES (75634, '59.71.15676549215716273', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.234.51.50', '2019-09-05 11:42:02', 2, 0, '', '2019-09-05 11:42:02');
INSERT INTO `access_log` VALUES (75635, '59.78.15676549215876287', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.234.51.50', '2019-09-05 11:42:02', 42, 2001001000, '服务端发生异常', '2019-09-05 11:42:02');
INSERT INTO `access_log` VALUES (75636, '64.82.15676549252316723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.234.51.50', '2019-09-05 11:42:05', 2, 0, '', '2019-09-05 11:42:05');
INSERT INTO `access_log` VALUES (75637, '64.80.15676549253916709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.234.51.50', '2019-09-05 11:42:05', 2, 0, '', '2019-09-05 11:42:05');
INSERT INTO `access_log` VALUES (75638, '59.77.15676549300846267', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.234.51.50', '2019-09-05 11:42:10', 2, 0, '', '2019-09-05 11:42:10');
INSERT INTO `access_log` VALUES (75639, '59.72.15676549300816275', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.234.51.50', '2019-09-05 11:42:10', 14, 2001001000, '服务端发生异常', '2019-09-05 11:42:10');
INSERT INTO `access_log` VALUES (75640, '59.79.15676549354426281', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.234.51.50', '2019-09-05 11:42:15', 2, 0, '', '2019-09-05 11:42:15');
INSERT INTO `access_log` VALUES (75641, '59.73.15676549354396275', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.234.51.50', '2019-09-05 11:42:15', 13, 2001001000, '服务端发生异常', '2019-09-05 11:42:15');
INSERT INTO `access_log` VALUES (75642, '64.83.15676549386036705', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.234.51.50', '2019-09-05 11:42:19', 2, 0, '', '2019-09-05 11:42:19');
INSERT INTO `access_log` VALUES (75643, '64.85.15676549387446733', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.234.51.50', '2019-09-05 11:42:19', 2, 0, '', '2019-09-05 11:42:19');
INSERT INTO `access_log` VALUES (75644, '66.50.15676549507623647', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.234.51.50', '2019-09-05 11:42:31', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机号不能为空', '2019-09-05 11:42:31');
INSERT INTO `access_log` VALUES (75645, '59.75.15676551517976285', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.87.162.85', '2019-09-05 11:45:52', 3, 0, '', '2019-09-05 11:45:52');
INSERT INTO `access_log` VALUES (75646, '59.72.15676551517976279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.87.162.85', '2019-09-05 11:45:52', 13, 2001001000, '服务端发生异常', '2019-09-05 11:45:52');
INSERT INTO `access_log` VALUES (75647, '64.82.15676551574176727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.87.162.85', '2019-09-05 11:45:57', 3, 0, '', '2019-09-05 11:45:57');
INSERT INTO `access_log` VALUES (75648, '64.80.15676551575376713', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.87.162.85', '2019-09-05 11:45:58', 1, 0, '', '2019-09-05 11:45:58');
INSERT INTO `access_log` VALUES (75649, '64.78.15676551584976739', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.87.162.85', '2019-09-05 11:45:58', 2, 0, '', '2019-09-05 11:45:59');
INSERT INTO `access_log` VALUES (75650, '64.83.15676551594976709', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.87.162.85', '2019-09-05 11:45:59', 2, 0, '', '2019-09-05 11:46:00');
INSERT INTO `access_log` VALUES (75651, '64.85.15676551604376737', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.87.162.85', '2019-09-05 11:46:00', 2, 0, '', '2019-09-05 11:46:00');
INSERT INTO `access_log` VALUES (75652, '64.79.15676551640576717', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.87.162.85', '2019-09-05 11:46:04', 1, 0, '', '2019-09-05 11:46:04');
INSERT INTO `access_log` VALUES (75653, '64.77.15676551641976691', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.87.162.85', '2019-09-05 11:46:04', 1, 0, '', '2019-09-05 11:46:04');
INSERT INTO `access_log` VALUES (75654, '59.73.15676551648736279', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.87.162.85', '2019-09-05 11:46:05', 2, 0, '', '2019-09-05 11:46:05');
INSERT INTO `access_log` VALUES (75655, '59.79.15676551648736285', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.87.162.85', '2019-09-05 11:46:05', 13, 2001001000, '服务端发生异常', '2019-09-05 11:46:05');
INSERT INTO `access_log` VALUES (75656, '59.77.15676554313546275', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.10', '2019-09-05 11:50:31', 3, 0, '', '2019-09-05 11:50:31');
INSERT INTO `access_log` VALUES (75657, '59.73.15676554313566283', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.10', '2019-09-05 11:50:31', 12, 2001001000, '服务端发生异常', '2019-09-05 11:50:31');
INSERT INTO `access_log` VALUES (75658, '65.49.15676554459169899', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.10', '2019-09-05 11:50:46', 0, 1002001015, '账号未登陆', '2019-09-05 11:50:46');
INSERT INTO `access_log` VALUES (75659, '65.47.15676554459249833', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.10', '2019-09-05 11:50:46', 0, 1002001015, '账号未登陆', '2019-09-05 11:50:46');
INSERT INTO `access_log` VALUES (75660, '65.53.15676554459319829', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.10', '2019-09-05 11:50:46', 0, 1002001015, '账号未登陆', '2019-09-05 11:50:46');
INSERT INTO `access_log` VALUES (75661, '65.54.15676554485079767', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.10', '2019-09-05 11:50:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 11:50:49');
INSERT INTO `access_log` VALUES (75662, '65.3607.15676554562471677', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.10', '2019-09-05 11:50:56', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 11:50:56');
INSERT INTO `access_log` VALUES (75663, '65.51.15676554654409925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=onemall&password=onemall&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.10', '2019-09-05 11:51:05', 4, 1002002000, '账号不存在', '2019-09-05 11:51:05');
INSERT INTO `access_log` VALUES (75664, '65.52.15676554756679949', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.10', '2019-09-05 11:51:16', 75, 0, '', '2019-09-05 11:51:16');
INSERT INTO `access_log` VALUES (75665, '65.50.15676554761349889', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.10', '2019-09-05 11:51:16', 9, 0, '', '2019-09-05 11:51:16');
INSERT INTO `access_log` VALUES (75666, '65.49.15676554761429901', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.10', '2019-09-05 11:51:16', 17, 2001001000, '服务端发生异常', '2019-09-05 11:51:16');
INSERT INTO `access_log` VALUES (75667, '65.53.15676554761789831', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.10', '2019-09-05 11:51:16', 9, 0, '', '2019-09-05 11:51:16');
INSERT INTO `access_log` VALUES (75668, '59.72.15676555312826285', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:52:11', 3, 0, '', '2019-09-05 11:52:11');
INSERT INTO `access_log` VALUES (75669, '59.77.15676555312846277', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:52:11', 13, 2001001000, '服务端发生异常', '2019-09-05 11:52:11');
INSERT INTO `access_log` VALUES (75670, '59.73.15676555377006285', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:52:18', 3, 0, '', '2019-09-05 11:52:18');
INSERT INTO `access_log` VALUES (75671, '59.79.15676555377036291', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:52:18', 10, 2001001000, '服务端发生异常', '2019-09-05 11:52:18');
INSERT INTO `access_log` VALUES (75672, '64.79.15676555707556723', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:52:51', 2, 0, '', '2019-09-05 11:52:51');
INSERT INTO `access_log` VALUES (75673, '64.77.15676555708606697', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:52:51', 2, 0, '', '2019-09-05 11:52:51');
INSERT INTO `access_log` VALUES (75674, '64.76.15676555727966729', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:52:53', 2, 0, '', '2019-09-05 11:52:53');
INSERT INTO `access_log` VALUES (75675, '64.84.15676555736786721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:52:54', 2, 0, '', '2019-09-05 11:52:54');
INSERT INTO `access_log` VALUES (75676, '64.81.15676555747646727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:52:55', 1, 0, '', '2019-09-05 11:52:55');
INSERT INTO `access_log` VALUES (75677, '64.82.15676555751726735', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:52:55', 2, 0, '', '2019-09-05 11:52:55');
INSERT INTO `access_log` VALUES (75678, '64.80.15676555848206721', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:53:05', 1, 0, '', '2019-09-05 11:53:05');
INSERT INTO `access_log` VALUES (75679, '64.78.15676555848976747', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:53:05', 2, 0, '', '2019-09-05 11:53:05');
INSERT INTO `access_log` VALUES (75680, '59.75.15676555914976293', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:53:11', 2, 0, '', '2019-09-05 11:53:12');
INSERT INTO `access_log` VALUES (75681, '59.78.15676555914976299', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:53:11', 15, 2001001000, '服务端发生异常', '2019-09-05 11:53:12');
INSERT INTO `access_log` VALUES (75682, '64.85.15676555980416745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:53:18', 2, 0, '', '2019-09-05 11:53:18');
INSERT INTO `access_log` VALUES (75683, '64.79.15676555981236725', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:53:18', 2, 0, '', '2019-09-05 11:53:18');
INSERT INTO `access_log` VALUES (75684, '59.77.15676555984776279', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:53:18', 2, 0, '', '2019-09-05 11:53:18');
INSERT INTO `access_log` VALUES (75685, '59.72.15676555984776287', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 11:53:18', 11, 2001001000, '服务端发生异常', '2019-09-05 11:53:18');
INSERT INTO `access_log` VALUES (75686, '65.3607.15676556510951681', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:54:11', 1, 1002001015, '账号未登陆', '2019-09-05 11:54:11');
INSERT INTO `access_log` VALUES (75687, '65.45.15676556510949925', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:54:11', 0, 1002001015, '账号未登陆', '2019-09-05 11:54:11');
INSERT INTO `access_log` VALUES (75688, '65.51.15676556510979929', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:54:11', 0, 1002001015, '账号未登陆', '2019-09-05 11:54:11');
INSERT INTO `access_log` VALUES (75689, '59.76.15676556525496277', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:54:13', 2, 0, '', '2019-09-05 11:54:13');
INSERT INTO `access_log` VALUES (75690, '59.71.15676556525496287', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:54:13', 19, 2001001000, '服务端发生异常', '2019-09-05 11:54:13');
INSERT INTO `access_log` VALUES (75691, '65.46.15676556583689925', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:54:18', 116, 0, '', '2019-09-05 11:54:18');
INSERT INTO `access_log` VALUES (75692, '65.49.15676556586879905', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:54:19', 17, 0, '', '2019-09-05 11:54:19');
INSERT INTO `access_log` VALUES (75693, '65.50.15676556586869893', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:54:19', 19, 0, '', '2019-09-05 11:54:19');
INSERT INTO `access_log` VALUES (75694, '65.52.15676556586869953', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:54:19', 19, 2001001000, '服务端发生异常', '2019-09-05 11:54:19');
INSERT INTO `access_log` VALUES (75695, '65.3607.15676556991361683', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:54:59', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 11:54:59');
INSERT INTO `access_log` VALUES (75696, '65.51.15676557055549931', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:55:06', 89, 0, '', '2019-09-05 11:55:06');
INSERT INTO `access_log` VALUES (75697, '65.45.15676557058139927', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:55:06', 9, 0, '', '2019-09-05 11:55:06');
INSERT INTO `access_log` VALUES (75698, '65.46.15676557058159927', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:55:06', 9, 0, '', '2019-09-05 11:55:06');
INSERT INTO `access_log` VALUES (75699, '65.50.15676557058189895', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:55:06', 8, 0, '', '2019-09-05 11:55:06');
INSERT INTO `access_log` VALUES (75700, '62.89.15676557147154809', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:55:15', 67, 0, '', '2019-09-05 11:55:15');
INSERT INTO `access_log` VALUES (75701, '62.84.15676557319624793', 1, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:55:32', 19, 0, '', '2019-09-05 11:55:32');
INSERT INTO `access_log` VALUES (75702, '64.76.15676557386556733', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:55:39', 9, 0, '', '2019-09-05 11:55:39');
INSERT INTO `access_log` VALUES (75703, '64.77.15676557386556701', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:55:39', 11, 0, '', '2019-09-05 11:55:39');
INSERT INTO `access_log` VALUES (75704, '64.81.15676557433876731', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:55:43', 12, 0, '', '2019-09-05 11:55:43');
INSERT INTO `access_log` VALUES (75705, '64.84.15676557433876725', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:55:43', 15, 0, '', '2019-09-05 11:55:43');
INSERT INTO `access_log` VALUES (75706, '64.80.15676557527886725', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:55:53', 8, 0, '', '2019-09-05 11:55:53');
INSERT INTO `access_log` VALUES (75707, '66.55.15676557966093631', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:56:37', 21, 0, '', '2019-09-05 11:56:37');
INSERT INTO `access_log` VALUES (75708, '66.52.15676558035883651', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=2&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:56:44', 14, 0, '', '2019-09-05 11:56:44');
INSERT INTO `access_log` VALUES (75709, '66.50.15676558047933659', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=3&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:56:45', 12, 0, '', '2019-09-05 11:56:45');
INSERT INTO `access_log` VALUES (75710, '66.54.15676558054863671', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=4&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:56:45', 11, 0, '', '2019-09-05 11:56:45');
INSERT INTO `access_log` VALUES (75711, '66.57.15676558068033651', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=6&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:56:47', 28, 0, '', '2019-09-05 11:56:47');
INSERT INTO `access_log` VALUES (75712, '66.53.15676558081003641', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=7&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:56:48', 9, 0, '', '2019-09-05 11:56:48');
INSERT INTO `access_log` VALUES (75713, '66.56.15676558092853669', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=8&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:56:49', 12, 0, '', '2019-09-05 11:56:49');
INSERT INTO `access_log` VALUES (75714, '66.48.15676558106083643', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=9&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:56:51', 13, 0, '', '2019-09-05 11:56:51');
INSERT INTO `access_log` VALUES (75715, '59.75.15676558141606297', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:56:54', 10, 0, '', '2019-09-05 11:56:54');
INSERT INTO `access_log` VALUES (75716, '59.72.15676558241466291', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:57:04', 18, 2001001000, '服务端发生异常', '2019-09-05 11:57:04');
INSERT INTO `access_log` VALUES (75717, '59.73.15676558274986291', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:57:07', 633, 0, '', '2019-09-05 11:57:08');
INSERT INTO `access_log` VALUES (75718, '59.79.15676558325976297', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:57:13', 13, 0, '', '2019-09-05 11:57:13');
INSERT INTO `access_log` VALUES (75719, '59.80.15676558431396263', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:57:23', 8, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-09-05 11:57:23');
INSERT INTO `access_log` VALUES (75720, '65.49.15676558453369909', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:57:25', 20, 0, '', '2019-09-05 11:57:25');
INSERT INTO `access_log` VALUES (75721, '65.52.15676558522479957', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:57:32', 10, 0, '', '2019-09-05 11:57:32');
INSERT INTO `access_log` VALUES (75722, '65.53.15676558583999839', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:57:38', 13, 0, '', '2019-09-05 11:57:38');
INSERT INTO `access_log` VALUES (75723, '65.54.15676558656079777', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:57:46', 9, 0, '', '2019-09-05 11:57:46');
INSERT INTO `access_log` VALUES (75724, '65.51.15676558746729935', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:57:55', 14, 0, '', '2019-09-05 11:57:55');
INSERT INTO `access_log` VALUES (75725, '65.45.15676558839389931', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 11:58:04', 18, 0, '', '2019-09-05 11:58:04');
INSERT INTO `access_log` VALUES (75726, '59.75.15676575366596321', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:37', 3, 0, '', '2019-09-05 12:25:37');
INSERT INTO `access_log` VALUES (75727, '59.77.15676575366646307', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:37', 19, 2001001000, '服务端发生异常', '2019-09-05 12:25:37');
INSERT INTO `access_log` VALUES (75728, '64.80.15676575426776749', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:43', 3, 0, '', '2019-09-05 12:25:43');
INSERT INTO `access_log` VALUES (75729, '64.78.15676575428306775', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:43', 2, 0, '', '2019-09-05 12:25:43');
INSERT INTO `access_log` VALUES (75730, '64.83.15676575457876745', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:46', 1, 0, '', '2019-09-05 12:25:46');
INSERT INTO `access_log` VALUES (75731, '64.85.15676575458956773', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:46', 2, 0, '', '2019-09-05 12:25:46');
INSERT INTO `access_log` VALUES (75732, '59.73.15676575482786315', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:48', 2, 0, '', '2019-09-05 12:25:48');
INSERT INTO `access_log` VALUES (75733, '59.72.15676575482756315', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:48', 13, 2001001000, '服务端发生异常', '2019-09-05 12:25:48');
INSERT INTO `access_log` VALUES (75734, '64.76.15676575522896759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:52', 2, 0, '', '2019-09-05 12:25:52');
INSERT INTO `access_log` VALUES (75735, '64.77.15676575524386727', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:52', 2, 0, '', '2019-09-05 12:25:52');
INSERT INTO `access_log` VALUES (75736, '59.80.15676575530216287', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:53', 2, 0, '', '2019-09-05 12:25:53');
INSERT INTO `access_log` VALUES (75737, '59.74.15676575530216331', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:53', 13, 2001001000, '服务端发生异常', '2019-09-05 12:25:53');
INSERT INTO `access_log` VALUES (75738, '65.49.15676575585919933', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:59', 1, 1002001015, '账号未登陆', '2019-09-05 12:25:59');
INSERT INTO `access_log` VALUES (75739, '65.52.15676575585919981', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:59', 0, 1002001015, '账号未登陆', '2019-09-05 12:25:59');
INSERT INTO `access_log` VALUES (75740, '65.53.15676575585969863', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:25:59', 0, 1002001015, '账号未登陆', '2019-09-05 12:25:59');
INSERT INTO `access_log` VALUES (75741, '65.47.15676575604549867', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:26:00', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 12:26:00');
INSERT INTO `access_log` VALUES (75742, '65.54.15676575619719801', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '222.76.251.164', '2019-09-05 12:26:02', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 12:26:02');
INSERT INTO `access_log` VALUES (75743, '65.49.15676589723519953', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.119.21', '2019-09-05 12:49:32', 1, 1002001015, '账号未登陆', '2019-09-05 12:49:32');
INSERT INTO `access_log` VALUES (75744, '65.46.15676589723519973', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.119.21', '2019-09-05 12:49:32', 1, 1002001015, '账号未登陆', '2019-09-05 12:49:32');
INSERT INTO `access_log` VALUES (75745, '65.52.15676589723540001', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.119.21', '2019-09-05 12:49:32', 0, 1002001015, '账号未登陆', '2019-09-05 12:49:32');
INSERT INTO `access_log` VALUES (75746, '65.53.15676589745229883', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.119.21', '2019-09-05 12:49:35', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 12:49:35');
INSERT INTO `access_log` VALUES (75747, '65.54.15676589876119821', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.119.21', '2019-09-05 12:49:48', 117, 0, '', '2019-09-05 12:49:48');
INSERT INTO `access_log` VALUES (75748, '65.3607.15676589879881731', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.119.21', '2019-09-05 12:49:48', 10, 0, '', '2019-09-05 12:49:48');
INSERT INTO `access_log` VALUES (75749, '65.51.15676589879899979', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.119.21', '2019-09-05 12:49:48', 11, 2001001000, '服务端发生异常', '2019-09-05 12:49:48');
INSERT INTO `access_log` VALUES (75750, '65.45.15676589879959975', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '124.236.119.21', '2019-09-05 12:49:48', 9, 0, '', '2019-09-05 12:49:48');
INSERT INTO `access_log` VALUES (75751, '59.78.15676598376156359', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:03:58', 10, 0, '', '2019-09-05 13:03:58');
INSERT INTO `access_log` VALUES (75752, '59.75.15676598376156353', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:03:58', 23, 2001001000, '服务端发生异常', '2019-09-05 13:03:58');
INSERT INTO `access_log` VALUES (75753, '64.82.15676598434656795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:03', 11, 0, '', '2019-09-05 13:04:03');
INSERT INTO `access_log` VALUES (75754, '64.80.15676598436256781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:04', 3, 0, '', '2019-09-05 13:04:04');
INSERT INTO `access_log` VALUES (75755, '64.78.15676598452156807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:05', 2, 0, '', '2019-09-05 13:04:05');
INSERT INTO `access_log` VALUES (75756, '64.85.15676598460956805', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:06', 2, 0, '', '2019-09-05 13:04:06');
INSERT INTO `access_log` VALUES (75757, '64.79.15676598460956785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:06', 3, 0, '', '2019-09-05 13:04:06');
INSERT INTO `access_log` VALUES (75758, '64.76.15676598470456791', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:07', 4, 0, '', '2019-09-05 13:04:07');
INSERT INTO `access_log` VALUES (75759, '64.77.15676598475256759', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:08', 3, 0, '', '2019-09-05 13:04:08');
INSERT INTO `access_log` VALUES (75760, '64.81.15676598487356789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:09', 2, 0, '', '2019-09-05 13:04:09');
INSERT INTO `access_log` VALUES (75761, '64.84.15676598492256783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:09', 2, 0, '', '2019-09-05 13:04:09');
INSERT INTO `access_log` VALUES (75762, '64.82.15676598497256797', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:10', 2, 0, '', '2019-09-05 13:04:10');
INSERT INTO `access_log` VALUES (75763, '59.72.15676598509056347', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:11', 3, 0, '', '2019-09-05 13:04:11');
INSERT INTO `access_log` VALUES (75764, '59.73.15676598509056347', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:11', 13, 2001001000, '服务端发生异常', '2019-09-05 13:04:11');
INSERT INTO `access_log` VALUES (75765, '64.80.15676598538656783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:14', 1, 0, '', '2019-09-05 13:04:14');
INSERT INTO `access_log` VALUES (75766, '64.78.15676598543656809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:14', 1, 0, '', '2019-09-05 13:04:14');
INSERT INTO `access_log` VALUES (75767, '64.83.15676598556556779', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:16', 2, 0, '', '2019-09-05 13:04:16');
INSERT INTO `access_log` VALUES (75768, '64.85.15676598562156807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:16', 2, 0, '', '2019-09-05 13:04:16');
INSERT INTO `access_log` VALUES (75769, '59.79.15676598583056353', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:18', 2, 0, '', '2019-09-05 13:04:18');
INSERT INTO `access_log` VALUES (75770, '59.80.15676598583056319', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:18', 13, 2001001000, '服务端发生异常', '2019-09-05 13:04:18');
INSERT INTO `access_log` VALUES (75771, '64.76.15676598720956793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:32', 2, 0, '', '2019-09-05 13:04:32');
INSERT INTO `access_log` VALUES (75772, '64.77.15676598722656761', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:32', 2, 0, '', '2019-09-05 13:04:32');
INSERT INTO `access_log` VALUES (75773, '64.82.15676598906956799', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:51', 2, 0, '', '2019-09-05 13:04:51');
INSERT INTO `access_log` VALUES (75774, '64.80.15676598908206785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:51', 2, 0, '', '2019-09-05 13:04:51');
INSERT INTO `access_log` VALUES (75775, '64.78.15676598922316811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:52', 2, 0, '', '2019-09-05 13:04:52');
INSERT INTO `access_log` VALUES (75776, '64.83.15676598932306781', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:53', 2, 0, '', '2019-09-05 13:04:53');
INSERT INTO `access_log` VALUES (75777, '64.85.15676598940306809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:54', 2, 0, '', '2019-09-05 13:04:54');
INSERT INTO `access_log` VALUES (75778, '64.79.15676598943106789', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:54', 2, 0, '', '2019-09-05 13:04:54');
INSERT INTO `access_log` VALUES (75779, '64.76.15676598947656795', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:55', 2, 0, '', '2019-09-05 13:04:55');
INSERT INTO `access_log` VALUES (75780, '64.77.15676598952216763', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:55', 2, 0, '', '2019-09-05 13:04:55');
INSERT INTO `access_log` VALUES (75781, '64.81.15676598963066793', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:04:56', 2, 0, '', '2019-09-05 13:04:56');
INSERT INTO `access_log` VALUES (75782, '59.75.15676599018556355', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:05:02', 2, 0, '', '2019-09-05 13:05:02');
INSERT INTO `access_log` VALUES (75783, '59.78.15676599018556361', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:05:02', 12, 2001001000, '服务端发生异常', '2019-09-05 13:05:02');
INSERT INTO `access_log` VALUES (75784, '59.72.15676599084656349', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:05:08', 2, 0, '', '2019-09-05 13:05:08');
INSERT INTO `access_log` VALUES (75785, '59.73.15676599084656349', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:05:08', 18, 2001001000, '服务端发生异常', '2019-09-05 13:05:08');
INSERT INTO `access_log` VALUES (75786, '64.82.15676599092256801', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:05:09', 2, 0, '', '2019-09-05 13:05:09');
INSERT INTO `access_log` VALUES (75787, '64.80.15676599096156787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:05:10', 2, 0, '', '2019-09-05 13:05:10');
INSERT INTO `access_log` VALUES (75788, '59.80.15676599096156321', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:05:10', 2, 0, '', '2019-09-05 13:05:10');
INSERT INTO `access_log` VALUES (75789, '59.79.15676599096156355', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:05:10', 12, 2001001000, '服务端发生异常', '2019-09-05 13:05:10');
INSERT INTO `access_log` VALUES (75790, '65.49.15676599237819967', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:05:24', 0, 1002001015, '账号未登陆', '2019-09-05 13:05:24');
INSERT INTO `access_log` VALUES (75791, '65.53.15676599237829897', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:05:24', 1, 1002001015, '账号未登陆', '2019-09-05 13:05:24');
INSERT INTO `access_log` VALUES (75792, '65.46.15676599237819987', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:05:24', 0, 1002001015, '账号未登陆', '2019-09-05 13:05:24');
INSERT INTO `access_log` VALUES (75793, '65.54.15676599271699835', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.104.212.251', '2019-09-05 13:05:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 13:05:27');
INSERT INTO `access_log` VALUES (75794, '59.77.15676613407376361', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:01', 3, 0, '', '2019-09-05 13:29:01');
INSERT INTO `access_log` VALUES (75795, '59.72.15676613407536369', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:01', 13, 2001001000, '服务端发生异常', '2019-09-05 13:29:01');
INSERT INTO `access_log` VALUES (75796, '64.77.15676613432756783', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:03', 3, 0, '', '2019-09-05 13:29:03');
INSERT INTO `access_log` VALUES (75797, '64.81.15676613434536813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:03', 1, 0, '', '2019-09-05 13:29:03');
INSERT INTO `access_log` VALUES (75798, '64.84.15676613446076807', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:05', 2, 0, '', '2019-09-05 13:29:05');
INSERT INTO `access_log` VALUES (75799, '64.82.15676613452196821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:05', 2, 0, '', '2019-09-05 13:29:05');
INSERT INTO `access_log` VALUES (75800, '64.78.15676613456516833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:06', 2, 0, '', '2019-09-05 13:29:06');
INSERT INTO `access_log` VALUES (75801, '64.83.15676613499416803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:10', 2, 0, '', '2019-09-05 13:29:10');
INSERT INTO `access_log` VALUES (75802, '64.85.15676613500786831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:10', 2, 0, '', '2019-09-05 13:29:10');
INSERT INTO `access_log` VALUES (75803, '59.80.15676613507796341', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:11', 2, 0, '', '2019-09-05 13:29:11');
INSERT INTO `access_log` VALUES (75804, '59.79.15676613507796375', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:11', 13, 2001001000, '服务端发生异常', '2019-09-05 13:29:11');
INSERT INTO `access_log` VALUES (75805, '64.79.15676613533116811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:13', 1, 0, '', '2019-09-05 13:29:13');
INSERT INTO `access_log` VALUES (75806, '64.76.15676613534766817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:13', 1, 0, '', '2019-09-05 13:29:13');
INSERT INTO `access_log` VALUES (75807, '64.77.15676613554916785', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:15', 2, 0, '', '2019-09-05 13:29:15');
INSERT INTO `access_log` VALUES (75808, '64.81.15676613556556815', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:16', 2, 0, '', '2019-09-05 13:29:16');
INSERT INTO `access_log` VALUES (75809, '64.82.15676613619996823', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:22', 2, 0, '', '2019-09-05 13:29:22');
INSERT INTO `access_log` VALUES (75810, '64.80.15676613621336809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:22', 2, 0, '', '2019-09-05 13:29:22');
INSERT INTO `access_log` VALUES (75811, '59.71.15676613634396369', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:23', 2, 0, '', '2019-09-05 13:29:23');
INSERT INTO `access_log` VALUES (75812, '59.76.15676613634316359', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:23', 12, 2001001000, '服务端发生异常', '2019-09-05 13:29:23');
INSERT INTO `access_log` VALUES (75813, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:27', 14, 0, '', '2019-09-05 13:29:27');
INSERT INTO `access_log` VALUES (75814, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:27', 10, 0, '', '2019-09-05 13:29:27');
INSERT INTO `access_log` VALUES (75815, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:28', 6, 0, '', '2019-09-05 13:29:28');
INSERT INTO `access_log` VALUES (75816, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:28', 9, 0, '', '2019-09-05 13:29:28');
INSERT INTO `access_log` VALUES (75817, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:28', 6, 0, '', '2019-09-05 13:29:28');
INSERT INTO `access_log` VALUES (75818, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:28', 9, 0, '', '2019-09-05 13:29:28');
INSERT INTO `access_log` VALUES (75819, '64.78.15676613696016835', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:30', 7, 0, '', '2019-09-05 13:29:30');
INSERT INTO `access_log` VALUES (75820, '64.83.15676613749756805', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:35', 6, 0, '', '2019-09-05 13:29:35');
INSERT INTO `access_log` VALUES (75821, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:37', 6, 0, '', '2019-09-05 13:29:37');
INSERT INTO `access_log` VALUES (75822, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:37', 9, 0, '', '2019-09-05 13:29:37');
INSERT INTO `access_log` VALUES (75823, '59.77.15676613776916363', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:38', 2, 0, '', '2019-09-05 13:29:38');
INSERT INTO `access_log` VALUES (75824, '59.78.15676613776916383', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:38', 12, 2001001000, '服务端发生异常', '2019-09-05 13:29:38');
INSERT INTO `access_log` VALUES (75825, '64.79.15676613783116813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:38', 2, 0, '', '2019-09-05 13:29:38');
INSERT INTO `access_log` VALUES (75826, '64.76.15676613784766819', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:38', 1, 0, '', '2019-09-05 13:29:38');
INSERT INTO `access_log` VALUES (75827, '59.72.15676613798316371', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:40', 3, 0, '', '2019-09-05 13:29:40');
INSERT INTO `access_log` VALUES (75828, '59.73.15676613798416371', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:40', 12, 2001001000, '服务端发生异常', '2019-09-05 13:29:40');
INSERT INTO `access_log` VALUES (75829, '64.77.15676613804796787', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:40', 2, 0, '', '2019-09-05 13:29:40');
INSERT INTO `access_log` VALUES (75830, '64.81.15676613806356817', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:41', 2, 0, '', '2019-09-05 13:29:41');
INSERT INTO `access_log` VALUES (75831, '59.80.15676613821116343', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:42', 2, 0, '', '2019-09-05 13:29:42');
INSERT INTO `access_log` VALUES (75832, '59.79.15676613821226377', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 9; ELE-AL00 Build/HUAWEIELE-AL00; wv) AppleWebKit/537.36 (KHTML, like Gecko) S3 Version/4.0 Chrome/72.0.3626.121 Mobile Safari/537.36 SGInfo/1080/2265/3.0 SogouSearch Android1.0 version3.0 AppVersion/7202 NoHead', '122.96.41.141', '2019-09-05 13:29:42', 12, 2001001000, '服务端发生异常', '2019-09-05 13:29:42');
INSERT INTO `access_log` VALUES (75833, '64.78.15676624790476851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 13:47:59', 2, 0, '', '2019-09-05 13:47:59');
INSERT INTO `access_log` VALUES (75834, '64.83.15676624791516821', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 13:47:59', 2, 0, '', '2019-09-05 13:47:59');
INSERT INTO `access_log` VALUES (75835, '64.85.15676624814406849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 13:48:01', 2, 0, '', '2019-09-05 13:48:01');
INSERT INTO `access_log` VALUES (75836, '64.79.15676624822246829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 13:48:02', 2, 0, '', '2019-09-05 13:48:02');
INSERT INTO `access_log` VALUES (75837, '64.76.15676624827366835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 13:48:03', 1, 0, '', '2019-09-05 13:48:03');
INSERT INTO `access_log` VALUES (75838, '64.77.15676624833936803', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 13:48:03', 1, 0, '', '2019-09-05 13:48:03');
INSERT INTO `access_log` VALUES (75839, '64.81.15676624837596833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 13:48:04', 2, 0, '', '2019-09-05 13:48:04');
INSERT INTO `access_log` VALUES (75840, '65.49.15676630310320009', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.35.5.254', '2019-09-05 13:57:11', 0, 1002001015, '账号未登陆', '2019-09-05 13:57:11');
INSERT INTO `access_log` VALUES (75841, '65.47.15676630310849943', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.35.5.254', '2019-09-05 13:57:11', 0, 1002001015, '账号未登陆', '2019-09-05 13:57:11');
INSERT INTO `access_log` VALUES (75842, '65.54.15676630310859877', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.35.5.254', '2019-09-05 13:57:11', 0, 1002001015, '账号未登陆', '2019-09-05 13:57:11');
INSERT INTO `access_log` VALUES (75843, '65.45.15676630355230031', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.35.5.254', '2019-09-05 13:57:16', 76, 0, '', '2019-09-05 13:57:16');
INSERT INTO `access_log` VALUES (75844, '65.51.15676630358040035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.35.5.254', '2019-09-05 13:57:16', 11, 0, '', '2019-09-05 13:57:16');
INSERT INTO `access_log` VALUES (75845, '65.3607.15676630358061787', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.35.5.254', '2019-09-05 13:57:16', 11, 2001001000, '服务端发生异常', '2019-09-05 13:57:16');
INSERT INTO `access_log` VALUES (75846, '65.50.15676630358099999', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.35.5.254', '2019-09-05 13:57:16', 9, 0, '', '2019-09-05 13:57:16');
INSERT INTO `access_log` VALUES (75847, '65.49.15676632257360013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '115.197.191.216', '2019-09-05 14:00:26', 0, 1002001015, '账号未登陆', '2019-09-05 14:00:26');
INSERT INTO `access_log` VALUES (75848, '65.47.15676632257379947', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '115.197.191.216', '2019-09-05 14:00:26', 0, 1002001015, '账号未登陆', '2019-09-05 14:00:26');
INSERT INTO `access_log` VALUES (75849, '65.54.15676632257419881', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '115.197.191.216', '2019-09-05 14:00:26', 0, 1002001015, '账号未登陆', '2019-09-05 14:00:26');
INSERT INTO `access_log` VALUES (75850, '65.45.15676632274560035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '115.197.191.216', '2019-09-05 14:00:27', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 14:00:27');
INSERT INTO `access_log` VALUES (75851, '65.3607.15676632302071791', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '115.197.191.216', '2019-09-05 14:00:30', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 14:00:30');
INSERT INTO `access_log` VALUES (75852, '65.49.15676633176740015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '115.197.191.216', '2019-09-05 14:01:58', 83, 0, '', '2019-09-05 14:01:58');
INSERT INTO `access_log` VALUES (75853, '65.54.15676633179849883', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '115.197.191.216', '2019-09-05 14:01:58', 68, 0, '', '2019-09-05 14:01:58');
INSERT INTO `access_log` VALUES (75854, '65.3607.15676633179921793', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '115.197.191.216', '2019-09-05 14:01:58', 62, 0, '', '2019-09-05 14:01:58');
INSERT INTO `access_log` VALUES (75855, '65.45.15676633179890037', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '115.197.191.216', '2019-09-05 14:01:58', 65, 2001001000, '服务端发生异常', '2019-09-05 14:01:58');
INSERT INTO `access_log` VALUES (75856, '65.46.15676644726110051', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.5.159.180', '2019-09-05 14:21:13', 0, 1002001015, '账号未登陆', '2019-09-05 14:21:13');
INSERT INTO `access_log` VALUES (75857, '65.53.15676644726129965', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.5.159.180', '2019-09-05 14:21:13', 0, 1002001015, '账号未登陆', '2019-09-05 14:21:13');
INSERT INTO `access_log` VALUES (75858, '65.49.15676644726120033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.5.159.180', '2019-09-05 14:21:13', 0, 1002001015, '账号未登陆', '2019-09-05 14:21:13');
INSERT INTO `access_log` VALUES (75859, '65.47.15676644770519967', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.5.159.180', '2019-09-05 14:21:17', 87, 0, '', '2019-09-05 14:21:17');
INSERT INTO `access_log` VALUES (75860, '65.45.15676644773230055', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.5.159.180', '2019-09-05 14:21:17', 10, 0, '', '2019-09-05 14:21:17');
INSERT INTO `access_log` VALUES (75861, '65.54.15676644773249901', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.5.159.180', '2019-09-05 14:21:17', 11, 2001001000, '服务端发生异常', '2019-09-05 14:21:17');
INSERT INTO `access_log` VALUES (75862, '65.3607.15676644773271813', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '36.5.159.180', '2019-09-05 14:21:17', 9, 0, '', '2019-09-05 14:21:17');
INSERT INTO `access_log` VALUES (75863, '59.71.15676655923876427', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:39:52', 11, 0, '', '2019-09-05 14:39:52');
INSERT INTO `access_log` VALUES (75864, '59.76.15676655923876417', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:39:52', 16, 2001001000, '服务端发生异常', '2019-09-05 14:39:52');
INSERT INTO `access_log` VALUES (75865, '64.77.15676655977276845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:39:58', 13, 0, '', '2019-09-05 14:39:58');
INSERT INTO `access_log` VALUES (75866, '64.81.15676655978866875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:39:58', 3, 0, '', '2019-09-05 14:39:58');
INSERT INTO `access_log` VALUES (75867, '64.84.15676655991536869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:39:59', 2, 0, '', '2019-09-05 14:39:59');
INSERT INTO `access_log` VALUES (75868, '64.82.15676655999856883', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:40:00', 2, 0, '', '2019-09-05 14:40:00');
INSERT INTO `access_log` VALUES (75869, '64.80.15676656004966869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:40:00', 1, 0, '', '2019-09-05 14:40:00');
INSERT INTO `access_log` VALUES (75870, '64.78.15676656007456895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:40:01', 2, 0, '', '2019-09-05 14:40:01');
INSERT INTO `access_log` VALUES (75871, '59.78.15676656016196441', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:40:02', 15, 2001001000, '服务端发生异常', '2019-09-05 14:40:02');
INSERT INTO `access_log` VALUES (75872, '59.75.15676656016196435', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:40:02', 16, 0, '', '2019-09-05 14:40:02');
INSERT INTO `access_log` VALUES (75873, '64.81.15676656675366877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.129.6.227', '2019-09-05 14:41:08', 3, 0, '', '2019-09-05 14:41:08');
INSERT INTO `access_log` VALUES (75874, '64.84.15676656715116871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '61.129.7.235', '2019-09-05 14:41:12', 2, 0, '', '2019-09-05 14:41:12');
INSERT INTO `access_log` VALUES (75875, '65.50.15676656784900037', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:41:18', 1, 1002001015, '账号未登陆', '2019-09-05 14:41:18');
INSERT INTO `access_log` VALUES (75876, '65.51.15676656784910073', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:41:18', 0, 1002001015, '账号未登陆', '2019-09-05 14:41:18');
INSERT INTO `access_log` VALUES (75877, '65.52.15676656784940101', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:41:18', 0, 1002001015, '账号未登陆', '2019-09-05 14:41:18');
INSERT INTO `access_log` VALUES (75878, '65.53.15676656802669983', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:41:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 14:41:20');
INSERT INTO `access_log` VALUES (75879, '64.80.15676656808176871', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '58.247.206.146', '2019-09-05 14:41:21', 2, 0, '', '2019-09-05 14:41:21');
INSERT INTO `access_log` VALUES (75880, '64.83.15676656956236867', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.151.207.186', '2019-09-05 14:41:36', 2, 0, '', '2019-09-05 14:41:36');
INSERT INTO `access_log` VALUES (75881, '65.46.15676656977960069', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:41:38', 91, 0, '', '2019-09-05 14:41:38');
INSERT INTO `access_log` VALUES (75882, '65.47.15676656981769985', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:41:38', 9, 0, '', '2019-09-05 14:41:38');
INSERT INTO `access_log` VALUES (75883, '65.54.15676656981799919', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:41:38', 10, 2001001000, '服务端发生异常', '2019-09-05 14:41:38');
INSERT INTO `access_log` VALUES (75884, '65.45.15676656981860073', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.36.228.6', '2019-09-05 14:41:38', 9, 0, '', '2019-09-05 14:41:38');
INSERT INTO `access_log` VALUES (75885, '65.52.15676657432350103', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.207.186', '2019-09-05 14:42:23', 0, 1002001015, '账号未登陆', '2019-09-05 14:42:23');
INSERT INTO `access_log` VALUES (75886, '65.45.15676657758770075', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/45.0.2454.101 Safari/537.36', '61.129.7.235', '2019-09-05 14:42:56', 1, 1002001015, '账号未登陆', '2019-09-05 14:42:56');
INSERT INTO `access_log` VALUES (75887, '65.47.15676657937669987', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '61.129.6.151', '2019-09-05 14:43:14', 1, 1002001015, '账号未登陆', '2019-09-05 14:43:14');
INSERT INTO `access_log` VALUES (75888, '65.47.15676663841659995', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-09-05 14:53:04', 5, 1002001012, '访问令牌已过期', '2019-09-05 14:53:04');
INSERT INTO `access_log` VALUES (75889, '65.3607.15676663842111841', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-09-05 14:53:04', 4, 1002001012, '访问令牌已过期', '2019-09-05 14:53:04');
INSERT INTO `access_log` VALUES (75890, '65.51.15676663842330085', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-09-05 14:53:04', 3, 1002001012, '访问令牌已过期', '2019-09-05 14:53:04');
INSERT INTO `access_log` VALUES (75891, '65.52.15676663897260113', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-09-05 14:53:10', 86, 0, '', '2019-09-05 14:53:10');
INSERT INTO `access_log` VALUES (75892, '65.53.15676663901159995', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-09-05 14:53:10', 16, 0, '', '2019-09-05 14:53:10');
INSERT INTO `access_log` VALUES (75893, '65.49.15676663901300063', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-09-05 14:53:10', 10, 2001001000, '服务端发生异常', '2019-09-05 14:53:10');
INSERT INTO `access_log` VALUES (75894, '65.46.15676663901340081', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '123.125.250.165', '2019-09-05 14:53:10', 9, 0, '', '2019-09-05 14:53:10');
INSERT INTO `access_log` VALUES (75895, '65.50.15676669234880057', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.74.142.38', '2019-09-05 15:02:03', 0, 1002001015, '账号未登陆', '2019-09-05 15:02:03');
INSERT INTO `access_log` VALUES (75896, '65.52.15676669234920121', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.74.142.38', '2019-09-05 15:02:03', 0, 1002001015, '账号未登陆', '2019-09-05 15:02:03');
INSERT INTO `access_log` VALUES (75897, '65.49.15676669235030071', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.74.142.38', '2019-09-05 15:02:04', 0, 1002001015, '账号未登陆', '2019-09-05 15:02:04');
INSERT INTO `access_log` VALUES (75898, '65.53.15676669265100003', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.74.142.38', '2019-09-05 15:02:07', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 15:02:07');
INSERT INTO `access_log` VALUES (75899, '59.75.15676674971956461', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:11:37', 22, 2001001000, '服务端发生异常', '2019-09-05 15:11:37');
INSERT INTO `access_log` VALUES (75900, '59.71.15676674971936453', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:11:37', 135, 0, '', '2019-09-05 15:11:37');
INSERT INTO `access_log` VALUES (75901, '59.72.15676675190226455', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:11:59', 2, 0, '', '2019-09-05 15:11:59');
INSERT INTO `access_log` VALUES (75902, '59.77.15676675190226447', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:11:59', 11, 2001001000, '服务端发生异常', '2019-09-05 15:11:59');
INSERT INTO `access_log` VALUES (75903, '66.55.15676675405223789', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=16596969632', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:12:21', 89, 0, '', '2019-09-05 15:12:21');
INSERT INTO `access_log` VALUES (75904, '66.50.15676675476163817', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=16596969632&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:12:28', 426, 0, '', '2019-09-05 15:12:28');
INSERT INTO `access_log` VALUES (75905, '59.71.15676675570906455', 221, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:12:37', 6, 0, '', '2019-09-05 15:12:37');
INSERT INTO `access_log` VALUES (75906, '59.75.15676675570916463', 221, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:12:37', 18, 2001001000, '服务端发生异常', '2019-09-05 15:12:37');
INSERT INTO `access_log` VALUES (75907, '66.53.15676675593793799', 221, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:12:39', 7, 0, '', '2019-09-05 15:12:39');
INSERT INTO `access_log` VALUES (75908, '66.51.15676675616733831', 221, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:12:42', 9, 0, '', '2019-09-05 15:12:42');
INSERT INTO `access_log` VALUES (75909, '66.52.15676675741333811', 221, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:12:54', 6, 0, '', '2019-09-05 15:12:54');
INSERT INTO `access_log` VALUES (75910, '66.50.15676675807533819', 221, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:01', 6, 0, '', '2019-09-05 15:13:01');
INSERT INTO `access_log` VALUES (75911, '66.57.15676675838803811', 221, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:04', 6, 0, '', '2019-09-05 15:13:04');
INSERT INTO `access_log` VALUES (75912, '59.77.15676675900986449', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:10', 2, 0, '', '2019-09-05 15:13:10');
INSERT INTO `access_log` VALUES (75913, '59.73.15676675901106457', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:10', 15, 2001001000, '服务端发生异常', '2019-09-05 15:13:10');
INSERT INTO `access_log` VALUES (75914, '64.82.15676675944056911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:14', 69, 0, '', '2019-09-05 15:13:14');
INSERT INTO `access_log` VALUES (75915, '64.80.15676675946006897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:15', 3, 0, '', '2019-09-05 15:13:15');
INSERT INTO `access_log` VALUES (75916, '64.78.15676675979516923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:18', 2, 0, '', '2019-09-05 15:13:18');
INSERT INTO `access_log` VALUES (75917, '64.83.15676675980846893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:18', 2, 0, '', '2019-09-05 15:13:18');
INSERT INTO `access_log` VALUES (75918, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=aaa&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:23', 7, 0, '', '2019-09-05 15:13:23');
INSERT INTO `access_log` VALUES (75919, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=aaa', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:23', 5, 0, '', '2019-09-05 15:13:23');
INSERT INTO `access_log` VALUES (75920, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=aaa&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:24', 6, 0, '', '2019-09-05 15:13:24');
INSERT INTO `access_log` VALUES (75921, 'N/A', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=aaa', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:24', 5, 0, '', '2019-09-05 15:13:24');
INSERT INTO `access_log` VALUES (75922, '64.79.15676676052736901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:25', 2, 0, '', '2019-09-05 15:13:25');
INSERT INTO `access_log` VALUES (75923, '64.76.15676676054856907', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:25', 2, 0, '', '2019-09-05 15:13:25');
INSERT INTO `access_log` VALUES (75924, '64.77.15676676069296875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:27', 2, 0, '', '2019-09-05 15:13:27');
INSERT INTO `access_log` VALUES (75925, '64.81.15676676073426905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:27', 2, 0, '', '2019-09-05 15:13:27');
INSERT INTO `access_log` VALUES (75926, '64.84.15676676078826899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:28', 2, 0, '', '2019-09-05 15:13:28');
INSERT INTO `access_log` VALUES (75927, '64.82.15676676082606913', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:28', 2, 0, '', '2019-09-05 15:13:28');
INSERT INTO `access_log` VALUES (75928, '64.80.15676676086586899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:29', 1, 0, '', '2019-09-05 15:13:29');
INSERT INTO `access_log` VALUES (75929, '64.78.15676676091386925', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:29', 2, 0, '', '2019-09-05 15:13:29');
INSERT INTO `access_log` VALUES (75930, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:29', 5, 0, '', '2019-09-05 15:13:29');
INSERT INTO `access_log` VALUES (75931, '64.83.15676676118386895', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:32', 2, 0, '', '2019-09-05 15:13:32');
INSERT INTO `access_log` VALUES (75932, '64.85.15676676119256923', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:32', 2, 0, '', '2019-09-05 15:13:32');
INSERT INTO `access_log` VALUES (75933, '64.79.15676676125776903', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:33', 2, 0, '', '2019-09-05 15:13:33');
INSERT INTO `access_log` VALUES (75934, '64.76.15676676130236909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:33', 2, 0, '', '2019-09-05 15:13:33');
INSERT INTO `access_log` VALUES (75935, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:33', 6, 0, '', '2019-09-05 15:13:33');
INSERT INTO `access_log` VALUES (75936, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:35', 5, 0, '', '2019-09-05 15:13:35');
INSERT INTO `access_log` VALUES (75937, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=639&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:35', 5, 0, '', '2019-09-05 15:13:35');
INSERT INTO `access_log` VALUES (75938, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:35', 5, 0, '', '2019-09-05 15:13:36');
INSERT INTO `access_log` VALUES (75939, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:36', 6, 0, '', '2019-09-05 15:13:36');
INSERT INTO `access_log` VALUES (75940, '64.81.15676676164286907', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:36', 7, 0, '', '2019-09-05 15:13:36');
INSERT INTO `access_log` VALUES (75941, '66.48.15676676290713803', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=16969693232', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:49', 70, 0, '', '2019-09-05 15:13:49');
INSERT INTO `access_log` VALUES (75942, '66.52.15676676335023813', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=16969693232&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:54', 195, 0, '', '2019-09-05 15:13:54');
INSERT INTO `access_log` VALUES (75943, '66.50.15676676348603821', 222, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:13:55', 156, 0, '', '2019-09-05 15:13:55');
INSERT INTO `access_log` VALUES (75944, '66.57.15676676395163813', 222, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:00', 6, 0, '', '2019-09-05 15:14:00');
INSERT INTO `access_log` VALUES (75945, '66.51.15676676581483835', 222, 1, 'user-application', '/user-api/users/address/add', 'name=a&tel=19898323232&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=aaa&isDefault=false&address=aaa&areaNo=110101&mobile=19898323232&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:18', 128, 2001001000, '服务端发生异常', '2019-09-05 15:14:18');
INSERT INTO `access_log` VALUES (75946, '66.49.15676676602823821', 222, 1, 'user-application', '/user-api/users/address/add', 'name=a&tel=19898323232&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=aaa&isDefault=false&address=aaa&areaNo=110101&mobile=19898323232&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:20', 114, 2001001000, '服务端发生异常', '2019-09-05 15:14:20');
INSERT INTO `access_log` VALUES (75947, '66.50.15676676635453823', 222, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:24', 5, 0, '', '2019-09-05 15:14:24');
INSERT INTO `access_log` VALUES (75948, '66.57.15676676645633815', 222, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:25', 5, 0, '', '2019-09-05 15:14:25');
INSERT INTO `access_log` VALUES (75949, '66.56.15676676677433833', 222, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:28', 5, 0, '', '2019-09-05 15:14:28');
INSERT INTO `access_log` VALUES (75950, '66.48.15676676686053807', 222, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:29', 6, 0, '', '2019-09-05 15:14:29');
INSERT INTO `access_log` VALUES (75951, '64.83.15676676698006897', 222, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:30', 12, 0, '', '2019-09-05 15:14:30');
INSERT INTO `access_log` VALUES (75952, '64.79.15676676705976905', 222, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:31', 8, 0, '', '2019-09-05 15:14:31');
INSERT INTO `access_log` VALUES (75953, 'N/A', 222, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:31', 10, 0, '', '2019-09-05 15:14:31');
INSERT INTO `access_log` VALUES (75954, '64.77.15676676721056879', 222, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:32', 6, 0, '', '2019-09-05 15:14:32');
INSERT INTO `access_log` VALUES (75955, '64.84.15676676725166903', 222, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:33', 6, 0, '', '2019-09-05 15:14:33');
INSERT INTO `access_log` VALUES (75956, '64.80.15676676736986903', 222, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:34', 4, 0, '', '2019-09-05 15:14:34');
INSERT INTO `access_log` VALUES (75957, '64.83.15676676741546899', 222, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:34', 5, 0, '', '2019-09-05 15:14:34');
INSERT INTO `access_log` VALUES (75958, '64.79.15676676747526907', 222, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:35', 13, 0, '', '2019-09-05 15:14:35');
INSERT INTO `access_log` VALUES (75959, '64.77.15676676752986881', 222, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:35', 6, 0, '', '2019-09-05 15:14:35');
INSERT INTO `access_log` VALUES (75960, 'N/A', 222, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:35', 12, 0, '', '2019-09-05 15:14:35');
INSERT INTO `access_log` VALUES (75961, '64.82.15676676763276919', 222, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:36', 6, 0, '', '2019-09-05 15:14:36');
INSERT INTO `access_log` VALUES (75962, '64.78.15676676764846931', 222, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:36', 4, 0, '', '2019-09-05 15:14:36');
INSERT INTO `access_log` VALUES (75963, '64.85.15676676810456929', 222, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:41', 4, 0, '', '2019-09-05 15:14:41');
INSERT INTO `access_log` VALUES (75964, '64.76.15676676811646915', 222, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:41', 7, 0, '', '2019-09-05 15:14:41');
INSERT INTO `access_log` VALUES (75965, '59.73.15676676820776459', 222, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:42', 5, 0, '', '2019-09-05 15:14:42');
INSERT INTO `access_log` VALUES (75966, '59.77.15676676820766451', 222, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:42', 16, 2001001000, '服务端发生异常', '2019-09-05 15:14:42');
INSERT INTO `access_log` VALUES (75967, '66.55.15676676843163797', 222, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:44', 6, 0, '', '2019-09-05 15:14:44');
INSERT INTO `access_log` VALUES (75968, '59.75.15676676900116467', 222, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:50', 13, 2001001000, '服务端发生异常', '2019-09-05 15:14:50');
INSERT INTO `access_log` VALUES (75969, '59.76.15676676900046449', 222, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:50', 120, 0, '', '2019-09-05 15:14:50');
INSERT INTO `access_log` VALUES (75970, '64.84.15676676913376907', 222, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:51', 6, 0, '', '2019-09-05 15:14:51');
INSERT INTO `access_log` VALUES (75971, '64.80.15676676914536907', 222, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:51', 6, 0, '', '2019-09-05 15:14:51');
INSERT INTO `access_log` VALUES (75972, '59.73.15676676919326461', 222, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:52', 5, 0, '', '2019-09-05 15:14:52');
INSERT INTO `access_log` VALUES (75973, '59.72.15676676919326461', 222, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:52', 16, 2001001000, '服务端发生异常', '2019-09-05 15:14:52');
INSERT INTO `access_log` VALUES (75974, '66.57.15676676923993817', 222, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:52', 6, 0, '', '2019-09-05 15:14:52');
INSERT INTO `access_log` VALUES (75975, '59.74.15676676925916477', 222, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:53', 5, 0, '', '2019-09-05 15:14:53');
INSERT INTO `access_log` VALUES (75976, '59.80.15676676925916433', 222, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:53', 15, 2001001000, '服务端发生异常', '2019-09-05 15:14:53');
INSERT INTO `access_log` VALUES (75977, '66.56.15676676927643835', 222, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:53', 5, 0, '', '2019-09-05 15:14:53');
INSERT INTO `access_log` VALUES (75978, '59.78.15676676929436475', 222, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:53', 5, 0, '', '2019-09-05 15:14:53');
INSERT INTO `access_log` VALUES (75979, '59.71.15676676929426461', 222, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:53', 16, 2001001000, '服务端发生异常', '2019-09-05 15:14:53');
INSERT INTO `access_log` VALUES (75980, '65.3607.15676677293791861', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:15:29', 0, 1002001015, '账号未登陆', '2019-09-05 15:15:29');
INSERT INTO `access_log` VALUES (75981, '65.51.15676677293890105', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:15:29', 1, 1002001015, '账号未登陆', '2019-09-05 15:15:29');
INSERT INTO `access_log` VALUES (75982, '65.50.15676677293960069', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:15:29', 1, 1002001015, '账号未登陆', '2019-09-05 15:15:29');
INSERT INTO `access_log` VALUES (75983, '65.52.15676677318160133', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:15:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 15:15:32');
INSERT INTO `access_log` VALUES (75984, '65.49.15676677337660083', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:15:34', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 15:15:34');
INSERT INTO `access_log` VALUES (75985, '65.53.15676677374260015', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:15:37', 110, 0, '', '2019-09-05 15:15:38');
INSERT INTO `access_log` VALUES (75986, '65.46.15676677377890101', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:15:38', 10, 0, '', '2019-09-05 15:15:38');
INSERT INTO `access_log` VALUES (75987, '65.45.15676677377940105', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:15:38', 10, 2001001000, '服务端发生异常', '2019-09-05 15:15:38');
INSERT INTO `access_log` VALUES (75988, '65.54.15676677377999951', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '49.74.106.33', '2019-09-05 15:15:38', 9, 0, '', '2019-09-05 15:15:38');
INSERT INTO `access_log` VALUES (75989, '59.75.15676686821006483', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.205.65.11', '2019-09-05 15:31:22', 2, 0, '', '2019-09-05 15:31:22');
INSERT INTO `access_log` VALUES (75990, '59.76.15676686821006465', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '115.205.65.11', '2019-09-05 15:31:22', 11, 2001001000, '服务端发生异常', '2019-09-05 15:31:22');
INSERT INTO `access_log` VALUES (75991, '59.71.15676686887496475', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.205.65.11', '2019-09-05 15:31:29', 2, 0, '', '2019-09-05 15:31:29');
INSERT INTO `access_log` VALUES (75992, '59.78.15676686887496489', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '115.205.65.11', '2019-09-05 15:31:29', 10, 2001001000, '服务端发生异常', '2019-09-05 15:31:29');
INSERT INTO `access_log` VALUES (75993, '59.78.15676695711516501', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.255.127.81', '2019-09-05 15:46:11', 3, 0, '', '2019-09-05 15:46:11');
INSERT INTO `access_log` VALUES (75994, '59.73.15676695711526489', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.255.127.81', '2019-09-05 15:46:11', 9, 2001001000, '服务端发生异常', '2019-09-05 15:46:11');
INSERT INTO `access_log` VALUES (75995, '64.77.15676695754116909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.255.127.81', '2019-09-05 15:46:15', 11, 0, '', '2019-09-05 15:46:15');
INSERT INTO `access_log` VALUES (75996, '64.81.15676695755876939', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.255.127.81', '2019-09-05 15:46:16', 5, 0, '', '2019-09-05 15:46:16');
INSERT INTO `access_log` VALUES (75997, '64.84.15676695771106933', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.255.127.81', '2019-09-05 15:46:17', 3, 0, '', '2019-09-05 15:46:17');
INSERT INTO `access_log` VALUES (75998, '64.82.15676695777336947', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.255.127.81', '2019-09-05 15:46:18', 1, 0, '', '2019-09-05 15:46:18');
INSERT INTO `access_log` VALUES (75999, '64.78.15676695828756959', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.255.127.81', '2019-09-05 15:46:23', 2, 0, '', '2019-09-05 15:46:23');
INSERT INTO `access_log` VALUES (76000, '64.83.15676695830016929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '223.255.127.81', '2019-09-05 15:46:23', 2, 0, '', '2019-09-05 15:46:23');
INSERT INTO `access_log` VALUES (76001, '64.81.15676697907306943', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/56.0.2924.87 Safari/537.36', '101.91.60.107', '2019-09-05 15:49:51', 2, 0, '', '2019-09-05 15:49:51');
INSERT INTO `access_log` VALUES (76002, '59.75.15676698139826499', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E; InfoPath.3; rv:11.0) like Gecko', '61.151.178.197', '2019-09-05 15:50:14', 3, 0, '', '2019-09-05 15:50:14');
INSERT INTO `access_log` VALUES (76003, '64.82.15676698159946951', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.124 Safari/537.36', '101.89.239.230', '2019-09-05 15:50:16', 2, 0, '', '2019-09-05 15:50:16');
INSERT INTO `access_log` VALUES (76004, '59.78.15676701255136509', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.235.245.129', '2019-09-05 15:55:26', 13, 2001001000, '服务端发生异常', '2019-09-05 15:55:26');
INSERT INTO `access_log` VALUES (76005, '59.73.15676701255126497', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.235.245.129', '2019-09-05 15:55:26', 254, 0, '', '2019-09-05 15:55:26');
INSERT INTO `access_log` VALUES (76006, '65.3607.15676701354631895', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.235.245.129', '2019-09-05 15:55:35', 1, 1002001015, '账号未登陆', '2019-09-05 15:55:35');
INSERT INTO `access_log` VALUES (76007, '65.47.15676701354620049', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.235.245.129', '2019-09-05 15:55:35', 0, 1002001015, '账号未登陆', '2019-09-05 15:55:35');
INSERT INTO `access_log` VALUES (76008, '65.51.15676701354850139', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.235.245.129', '2019-09-05 15:55:35', 0, 1002001015, '账号未登陆', '2019-09-05 15:55:35');
INSERT INTO `access_log` VALUES (76009, '65.50.15676701378890103', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.235.245.129', '2019-09-05 15:55:38', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 15:55:38');
INSERT INTO `access_log` VALUES (76010, '65.53.15676701628620049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.235.245.129', '2019-09-05 15:56:03', 260, 0, '', '2019-09-05 15:56:03');
INSERT INTO `access_log` VALUES (76011, '65.54.15676701635219985', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.235.245.129', '2019-09-05 15:56:04', 20, 0, '', '2019-09-05 15:56:04');
INSERT INTO `access_log` VALUES (76012, '65.46.15676701635230135', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.235.245.129', '2019-09-05 15:56:04', 20, 0, '', '2019-09-05 15:56:04');
INSERT INTO `access_log` VALUES (76013, '65.45.15676701635200139', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.235.245.129', '2019-09-05 15:56:04', 25, 2001001000, '服务端发生异常', '2019-09-05 15:56:04');
INSERT INTO `access_log` VALUES (76014, '59.78.15676702443126511', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.140.86.88', '2019-09-05 15:57:24', 3, 0, '', '2019-09-05 15:57:24');
INSERT INTO `access_log` VALUES (76015, '59.73.15676702443126499', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '61.140.86.88', '2019-09-05 15:57:24', 14, 2001001000, '服务端发生异常', '2019-09-05 15:57:24');
INSERT INTO `access_log` VALUES (76016, '59.77.15676735595956535', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 16:52:40', 16, 2001001000, '服务端发生异常', '2019-09-05 16:52:40');
INSERT INTO `access_log` VALUES (76017, '59.79.15676735595956549', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 16:52:40', 221, 0, '', '2019-09-05 16:52:40');
INSERT INTO `access_log` VALUES (76018, '59.76.15676735875876533', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 16:53:08', 3, 0, '', '2019-09-05 16:53:08');
INSERT INTO `access_log` VALUES (76019, '59.75.15676735875876551', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 16:53:08', 13, 2001001000, '服务端发生异常', '2019-09-05 16:53:08');
INSERT INTO `access_log` VALUES (76020, '64.83.15676735935336983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 16:53:14', 10, 0, '', '2019-09-05 16:53:14');
INSERT INTO `access_log` VALUES (76021, '64.85.15676735936367011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 16:53:14', 3, 0, '', '2019-09-05 16:53:14');
INSERT INTO `access_log` VALUES (76022, '64.79.15676735960646991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 16:53:16', 2, 0, '', '2019-09-05 16:53:16');
INSERT INTO `access_log` VALUES (76023, '64.76.15676735962886997', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 16:53:16', 2, 0, '', '2019-09-05 16:53:16');
INSERT INTO `access_log` VALUES (76024, '64.78.15676745634527027', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:09:23', 2, 0, '', '2019-09-05 17:09:23');
INSERT INTO `access_log` VALUES (76025, '64.83.15676745635286997', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:09:24', 1, 0, '', '2019-09-05 17:09:24');
INSERT INTO `access_log` VALUES (76026, '65.54.15676745685590045', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.236.4.47', '2019-09-05 17:09:29', 1, 1002001015, '账号未登陆', '2019-09-05 17:09:29');
INSERT INTO `access_log` VALUES (76027, '65.50.15676745685750163', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.236.4.47', '2019-09-05 17:09:29', 0, 1002001015, '账号未登陆', '2019-09-05 17:09:29');
INSERT INTO `access_log` VALUES (76028, '64.78.15676748428727031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:14:03', 3, 0, '', '2019-09-05 17:14:03');
INSERT INTO `access_log` VALUES (76029, '64.83.15676748429827001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:14:03', 2, 0, '', '2019-09-05 17:14:03');
INSERT INTO `access_log` VALUES (76030, '64.79.15676748484277009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:14:08', 2, 0, '', '2019-09-05 17:14:08');
INSERT INTO `access_log` VALUES (76031, '64.76.15676748485287015', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:14:09', 1, 0, '', '2019-09-05 17:14:09');
INSERT INTO `access_log` VALUES (76032, '64.77.15676748514196983', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:14:11', 2, 0, '', '2019-09-05 17:14:11');
INSERT INTO `access_log` VALUES (76033, '64.81.15676748520577013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:14:12', 2, 0, '', '2019-09-05 17:14:12');
INSERT INTO `access_log` VALUES (76034, '64.84.15676748530187007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:14:13', 2, 0, '', '2019-09-05 17:14:13');
INSERT INTO `access_log` VALUES (76035, '64.82.15676748536337021', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:14:14', 2, 0, '', '2019-09-05 17:14:14');
INSERT INTO `access_log` VALUES (76036, '64.80.15676748540747007', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:14:14', 2, 0, '', '2019-09-05 17:14:14');
INSERT INTO `access_log` VALUES (76037, '64.78.15676748545067033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:14:15', 2, 0, '', '2019-09-05 17:14:15');
INSERT INTO `access_log` VALUES (76038, '64.83.15676748548897003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:14:15', 2, 0, '', '2019-09-05 17:14:15');
INSERT INTO `access_log` VALUES (76039, '64.85.15676748553777031', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:14:15', 2, 0, '', '2019-09-05 17:14:15');
INSERT INTO `access_log` VALUES (76040, '64.82.15676749341497023', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:15:34', 3, 0, '', '2019-09-05 17:15:34');
INSERT INTO `access_log` VALUES (76041, '64.80.15676749342457009', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:15:34', 2, 0, '', '2019-09-05 17:15:34');
INSERT INTO `access_log` VALUES (76042, '64.78.15676749354447035', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:15:35', 2, 0, '', '2019-09-05 17:15:35');
INSERT INTO `access_log` VALUES (76043, '64.85.15676749355137033', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:15:36', 1, 0, '', '2019-09-05 17:15:36');
INSERT INTO `access_log` VALUES (76044, '59.71.15676749377506561', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:15:38', 3, 0, '', '2019-09-05 17:15:38');
INSERT INTO `access_log` VALUES (76045, '59.78.15676749377576575', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:15:38', 18, 2001001000, '服务端发生异常', '2019-09-05 17:15:38');
INSERT INTO `access_log` VALUES (76046, '59.73.15676749446866563', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:15:45', 2, 0, '', '2019-09-05 17:15:45');
INSERT INTO `access_log` VALUES (76047, '59.72.15676749446876563', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:15:45', 14, 2001001000, '服务端发生异常', '2019-09-05 17:15:45');
INSERT INTO `access_log` VALUES (76048, '64.79.15676749503097013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:15:50', 2, 0, '', '2019-09-05 17:15:50');
INSERT INTO `access_log` VALUES (76049, '64.76.15676749504067019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:15:50', 1, 0, '', '2019-09-05 17:15:50');
INSERT INTO `access_log` VALUES (76050, '64.81.15676749527397017', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:15:53', 2, 0, '', '2019-09-05 17:15:53');
INSERT INTO `access_log` VALUES (76051, '64.84.15676749528257011', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:15:53', 1, 0, '', '2019-09-05 17:15:53');
INSERT INTO `access_log` VALUES (76052, '66.55.15676749622303895', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15039141227&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:16:02', 16, 1001003000, '验证码不存在', '2019-09-05 17:16:02');
INSERT INTO `access_log` VALUES (76053, '66.54.15676749692863935', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15039141227', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:16:09', 73, 0, '', '2019-09-05 17:16:09');
INSERT INTO `access_log` VALUES (76054, '66.57.15676749710303915', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15039141227&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:16:11', 200, 0, '', '2019-09-05 17:16:11');
INSERT INTO `access_log` VALUES (76055, '66.56.15676749767323933', 223, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:16:17', 6, 0, '', '2019-09-05 17:16:17');
INSERT INTO `access_log` VALUES (76056, '66.48.15676749812933907', 223, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:16:21', 4, 0, '', '2019-09-05 17:16:21');
INSERT INTO `access_log` VALUES (76057, '64.83.15676749820197007', 223, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:16:22', 5, 0, '', '2019-09-05 17:16:22');
INSERT INTO `access_log` VALUES (76058, '64.79.15676749821527015', 223, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:16:22', 4, 0, '', '2019-09-05 17:16:22');
INSERT INTO `access_log` VALUES (76059, '59.75.15676749829356571', 223, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:16:23', 7, 0, '', '2019-09-05 17:16:23');
INSERT INTO `access_log` VALUES (76060, '59.71.15676749829356563', 223, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:16:23', 21, 2001001000, '服务端发生异常', '2019-09-05 17:16:23');
INSERT INTO `access_log` VALUES (76061, '66.52.15676749848173917', 223, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:16:25', 7, 0, '', '2019-09-05 17:16:25');
INSERT INTO `access_log` VALUES (76062, '66.55.15676749890133897', 223, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:16:29', 5, 0, '', '2019-09-05 17:16:29');
INSERT INTO `access_log` VALUES (76063, '66.57.15676750102653917', 223, 1, 'user-application', '/user-api/users/address/add', 'name=刘&tel=15039141227&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=110101&mobile=15039141227&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:16:50', 62, 2001001000, '服务端发生异常', '2019-09-05 17:16:50');
INSERT INTO `access_log` VALUES (76064, '59.72.15676750112586565', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 17:16:51', 2, 0, '', '2019-09-05 17:16:51');
INSERT INTO `access_log` VALUES (76065, '59.79.15676750112606571', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 17:16:51', 12, 2001001000, '服务端发生异常', '2019-09-05 17:16:51');
INSERT INTO `access_log` VALUES (76066, '64.81.15676750219767019', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 17:17:02', 1, 0, '', '2019-09-05 17:17:02');
INSERT INTO `access_log` VALUES (76067, '64.84.15676750220807013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 17:17:02', 1, 0, '', '2019-09-05 17:17:02');
INSERT INTO `access_log` VALUES (76068, '66.56.15676750239283935', 223, 1, 'user-application', '/user-api/users/address/add', 'name=刘&tel=15039141227&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=110101&mobile=15039141227&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:17:04', 116, 2001001000, '服务端发生异常', '2019-09-05 17:17:04');
INSERT INTO `access_log` VALUES (76069, '66.48.15676750266883909', 223, 1, 'user-application', '/user-api/users/address/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:17:07', 5, 0, '', '2019-09-05 17:17:07');
INSERT INTO `access_log` VALUES (76070, '64.80.15676750279117013', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 17:17:08', 2, 0, '', '2019-09-05 17:17:08');
INSERT INTO `access_log` VALUES (76071, '66.52.15676750280423919', 223, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:17:08', 5, 0, '', '2019-09-05 17:17:08');
INSERT INTO `access_log` VALUES (76072, '64.78.15676750280857039', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 17:17:08', 1, 0, '', '2019-09-05 17:17:08');
INSERT INTO `access_log` VALUES (76073, '59.74.15676750292386581', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 17:17:09', 2, 0, '', '2019-09-05 17:17:09');
INSERT INTO `access_log` VALUES (76074, '59.80.15676750292386537', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 17:17:09', 18, 2001001000, '服务端发生异常', '2019-09-05 17:17:09');
INSERT INTO `access_log` VALUES (76075, '59.71.15676750315556565', 223, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:17:12', 6, 0, '', '2019-09-05 17:17:12');
INSERT INTO `access_log` VALUES (76076, '59.76.15676750315556555', 223, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:17:12', 21, 2001001000, '服务端发生异常', '2019-09-05 17:17:12');
INSERT INTO `access_log` VALUES (76077, '64.85.15676750389797037', 223, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:17:19', 5, 0, '', '2019-09-05 17:17:19');
INSERT INTO `access_log` VALUES (76078, '64.76.15676750390877023', 223, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:17:19', 4, 0, '', '2019-09-05 17:17:19');
INSERT INTO `access_log` VALUES (76079, '64.77.15676750402866991', 223, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:17:20', 5, 0, '', '2019-09-05 17:17:20');
INSERT INTO `access_log` VALUES (76080, 'N/A', 223, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:17:20', 12, 0, '', '2019-09-05 17:17:20');
INSERT INTO `access_log` VALUES (76081, '64.82.15676750423687029', 223, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:17:22', 10, 0, '', '2019-09-05 17:17:22');
INSERT INTO `access_log` VALUES (76082, '64.80.15676750534577015', 223, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:17:33', 9, 0, '', '2019-09-05 17:17:33');
INSERT INTO `access_log` VALUES (76083, '65.52.15676750707470235', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 17:17:51', 0, 1002001015, '账号未登陆', '2019-09-05 17:17:51');
INSERT INTO `access_log` VALUES (76084, '65.46.15676750707480201', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 17:17:51', 1, 1002001015, '账号未登陆', '2019-09-05 17:17:51');
INSERT INTO `access_log` VALUES (76085, '65.49.15676750707480185', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 17:17:51', 0, 1002001015, '账号未登陆', '2019-09-05 17:17:51');
INSERT INTO `access_log` VALUES (76086, '65.45.15676750741550207', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 17:17:54', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 17:17:54');
INSERT INTO `access_log` VALUES (76087, '64.79.15676750925517019', 223, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:18:13', 5, 0, '', '2019-09-05 17:18:13');
INSERT INTO `access_log` VALUES (76088, 'N/A', 223, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:18:13', 11, 0, '', '2019-09-05 17:18:13');
INSERT INTO `access_log` VALUES (76089, 'N/A', 223, 1, 'search-application', '/search-api/users/product/page', 'cid=784&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:18:15', 8, 0, '', '2019-09-05 17:18:15');
INSERT INTO `access_log` VALUES (76090, 'N/A', 223, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:18:16', 9, 0, '', '2019-09-05 17:18:16');
INSERT INTO `access_log` VALUES (76091, 'N/A', 223, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:18:16', 10, 0, '', '2019-09-05 17:18:16');
INSERT INTO `access_log` VALUES (76092, '64.76.15676750968297025', 223, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:18:17', 11, 0, '', '2019-09-05 17:18:17');
INSERT INTO `access_log` VALUES (76093, '64.77.15676750969416993', 223, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:18:17', 4, 0, '', '2019-09-05 17:18:17');
INSERT INTO `access_log` VALUES (76094, '66.52.15676750980353921', 223, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:18:18', 6, 0, '', '2019-09-05 17:18:18');
INSERT INTO `access_log` VALUES (76095, '66.55.15676751090073901', 223, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:18:29', 6, 0, '', '2019-09-05 17:18:29');
INSERT INTO `access_log` VALUES (76096, '66.57.15676751182563921', 223, 1, 'user-application', '/user-api/users/user/update_nickname', 'nickname=nicheng', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:18:38', 76, 0, '', '2019-09-05 17:18:38');
INSERT INTO `access_log` VALUES (76097, '66.53.15676751250343911', 223, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:18:45', 6, 0, '', '2019-09-05 17:18:45');
INSERT INTO `access_log` VALUES (76098, '65.47.15676751269750119', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.62.79', '2019-09-05 17:18:47', 3, 1002001012, '访问令牌已过期', '2019-09-05 17:18:47');
INSERT INTO `access_log` VALUES (76099, '65.51.15676751269790209', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.62.79', '2019-09-05 17:18:47', 3, 1002001012, '访问令牌已过期', '2019-09-05 17:18:47');
INSERT INTO `access_log` VALUES (76100, '65.46.15676751269840203', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.62.79', '2019-09-05 17:18:47', 3, 1002001012, '访问令牌已过期', '2019-09-05 17:18:47');
INSERT INTO `access_log` VALUES (76101, '66.56.15676751281713939', 223, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:18:48', 5, 0, '', '2019-09-05 17:18:48');
INSERT INTO `access_log` VALUES (76102, '65.49.15676751367720187', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.62.79', '2019-09-05 17:18:57', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 17:18:57');
INSERT INTO `access_log` VALUES (76103, '65.53.15676751400750117', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.62.79', '2019-09-05 17:19:00', 118, 0, '', '2019-09-05 17:19:00');
INSERT INTO `access_log` VALUES (76104, '65.45.15676751406380209', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.62.79', '2019-09-05 17:19:01', 8, 0, '', '2019-09-05 17:19:01');
INSERT INTO `access_log` VALUES (76105, '65.50.15676751406430173', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.62.79', '2019-09-05 17:19:01', 9, 2001001000, '服务端发生异常', '2019-09-05 17:19:01');
INSERT INTO `access_log` VALUES (76106, '65.54.15676751406450055', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.62.79', '2019-09-05 17:19:01', 9, 0, '', '2019-09-05 17:19:01');
INSERT INTO `access_log` VALUES (76107, '65.51.15676751649600211', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.62.79', '2019-09-05 17:19:25', 9, 0, '', '2019-09-05 17:19:25');
INSERT INTO `access_log` VALUES (76108, '65.52.15676751649650239', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.62.79', '2019-09-05 17:19:25', 9, 0, '', '2019-09-05 17:19:25');
INSERT INTO `access_log` VALUES (76109, '65.46.15676751649640205', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '183.67.62.79', '2019-09-05 17:19:25', 10, 2001001000, '服务端发生异常', '2019-09-05 17:19:25');
INSERT INTO `access_log` VALUES (76110, '65.53.15676751857600119', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.236.4.47', '2019-09-05 17:19:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 17:19:46');
INSERT INTO `access_log` VALUES (76111, '65.45.15676751906490211', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.236.4.47', '2019-09-05 17:19:51', 99, 0, '', '2019-09-05 17:19:51');
INSERT INTO `access_log` VALUES (76112, '65.54.15676751915150057', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.236.4.47', '2019-09-05 17:19:52', 9, 2001001000, '服务端发生异常', '2019-09-05 17:19:52');
INSERT INTO `access_log` VALUES (76113, '65.50.15676751915180175', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.236.4.47', '2019-09-05 17:19:52', 8, 0, '', '2019-09-05 17:19:52');
INSERT INTO `access_log` VALUES (76114, '65.3607.15676751917161969', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.236.4.47', '2019-09-05 17:19:52', 292, 0, '', '2019-09-05 17:19:52');
INSERT INTO `access_log` VALUES (76115, '65.52.15676752044280241', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.236.4.47', '2019-09-05 17:20:04', 9, 0, '', '2019-09-05 17:20:04');
INSERT INTO `access_log` VALUES (76116, '65.51.15676752044380213', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.236.4.47', '2019-09-05 17:20:04', 10, 2001001000, '服务端发生异常', '2019-09-05 17:20:04');
INSERT INTO `access_log` VALUES (76117, '65.46.15676752044510207', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.236.4.47', '2019-09-05 17:20:04', 8, 0, '', '2019-09-05 17:20:04');
INSERT INTO `access_log` VALUES (76118, '59.77.15676752076826561', 223, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:20:08', 6, 0, '', '2019-09-05 17:20:08');
INSERT INTO `access_log` VALUES (76119, '59.79.15676752076826575', 223, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:20:08', 25, 2001001000, '服务端发生异常', '2019-09-05 17:20:08');
INSERT INTO `access_log` VALUES (76120, '59.74.15676752094546585', 223, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:20:09', 5, 0, '', '2019-09-05 17:20:09');
INSERT INTO `access_log` VALUES (76121, '59.80.15676752094556541', 223, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:20:09', 18, 2001001000, '服务端发生异常', '2019-09-05 17:20:09');
INSERT INTO `access_log` VALUES (76122, '66.54.15676752109333943', 223, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:20:11', 7, 0, '', '2019-09-05 17:20:11');
INSERT INTO `access_log` VALUES (76123, '66.50.15676753337733933', 223, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:22:14', 7, 0, '', '2019-09-05 17:22:14');
INSERT INTO `access_log` VALUES (76124, '59.79.15676754531196579', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.136.0.231', '2019-09-05 17:24:13', 3, 0, '', '2019-09-05 17:24:13');
INSERT INTO `access_log` VALUES (76125, '59.77.15676754531156565', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.136.0.231', '2019-09-05 17:24:13', 9, 2001001000, '服务端发生异常', '2019-09-05 17:24:13');
INSERT INTO `access_log` VALUES (76126, '65.46.15676754628250211', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.136.0.231', '2019-09-05 17:24:23', 4, 1002001012, '访问令牌已过期', '2019-09-05 17:24:23');
INSERT INTO `access_log` VALUES (76127, '65.51.15676754628260217', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.136.0.231', '2019-09-05 17:24:23', 2, 1002001012, '访问令牌已过期', '2019-09-05 17:24:23');
INSERT INTO `access_log` VALUES (76128, '65.52.15676754628270245', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.136.0.231', '2019-09-05 17:24:23', 3, 1002001012, '访问令牌已过期', '2019-09-05 17:24:23');
INSERT INTO `access_log` VALUES (76129, '65.53.15676754698470125', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.136.0.231', '2019-09-05 17:24:30', 80, 0, '', '2019-09-05 17:24:30');
INSERT INTO `access_log` VALUES (76130, '65.54.15676754703080063', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.136.0.231', '2019-09-05 17:24:30', 17, 0, '', '2019-09-05 17:24:30');
INSERT INTO `access_log` VALUES (76131, '65.45.15676754703080217', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.136.0.231', '2019-09-05 17:24:30', 18, 0, '', '2019-09-05 17:24:30');
INSERT INTO `access_log` VALUES (76132, '65.50.15676754703080181', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '117.136.0.231', '2019-09-05 17:24:30', 20, 2001001000, '服务端发生异常', '2019-09-05 17:24:30');
INSERT INTO `access_log` VALUES (76133, '59.80.15676759149556551', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.236.4.47', '2019-09-05 17:31:55', 2, 0, '', '2019-09-05 17:31:55');
INSERT INTO `access_log` VALUES (76134, '59.71.15676759149626579', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '116.236.4.47', '2019-09-05 17:31:55', 12, 2001001000, '服务端发生异常', '2019-09-05 17:31:55');
INSERT INTO `access_log` VALUES (76135, '59.72.15676771746546597', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.116.236.148', '2019-09-05 17:52:55', 3, 0, '', '2019-09-05 17:52:55');
INSERT INTO `access_log` VALUES (76136, '59.79.15676771746556603', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.116.236.148', '2019-09-05 17:52:55', 12, 2001001000, '服务端发生异常', '2019-09-05 17:52:55');
INSERT INTO `access_log` VALUES (76137, '59.74.15676771813236613', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Mobile Safari/537.36', '113.116.236.148', '2019-09-05 17:53:01', 3, 0, '', '2019-09-05 17:53:01');
INSERT INTO `access_log` VALUES (76138, '59.77.15676771813236589', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Mobile Safari/537.36', '113.116.236.148', '2019-09-05 17:53:01', 13, 2001001000, '服务端发生异常', '2019-09-05 17:53:01');
INSERT INTO `access_log` VALUES (76139, '66.51.15676771972263971', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Mobile Safari/537.36', '113.116.236.148', '2019-09-05 17:53:17', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机号不能为空\n手机号必须都是数字\n手机验证码不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-09-05 17:53:17');
INSERT INTO `access_log` VALUES (76140, '65.45.15676772249450241', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.116.236.148', '2019-09-05 17:53:45', 0, 1002001015, '账号未登陆', '2019-09-05 17:53:45');
INSERT INTO `access_log` VALUES (76141, '65.54.15676772249440087', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.116.236.148', '2019-09-05 17:53:45', 0, 1002001015, '账号未登陆', '2019-09-05 17:53:45');
INSERT INTO `access_log` VALUES (76142, '65.50.15676772249470205', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.116.236.148', '2019-09-05 17:53:45', 0, 1002001015, '账号未登陆', '2019-09-05 17:53:45');
INSERT INTO `access_log` VALUES (76143, '65.47.15676772353710153', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.116.236.148', '2019-09-05 17:53:55', 61, 0, '', '2019-09-05 17:53:55');
INSERT INTO `access_log` VALUES (76144, '65.52.15676772356930271', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.116.236.148', '2019-09-05 17:53:56', 160, 0, '', '2019-09-05 17:53:56');
INSERT INTO `access_log` VALUES (76145, '65.46.15676772357010237', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.116.236.148', '2019-09-05 17:53:56', 155, 0, '', '2019-09-05 17:53:56');
INSERT INTO `access_log` VALUES (76146, '65.51.15676772356960243', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.116.236.148', '2019-09-05 17:53:56', 161, 2001001000, '服务端发生异常', '2019-09-05 17:53:56');
INSERT INTO `access_log` VALUES (76147, '65.49.15676772402790221', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.116.236.148', '2019-09-05 17:54:00', 9, 0, '', '2019-09-05 17:54:00');
INSERT INTO `access_log` VALUES (76148, '65.53.15676772402820151', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.116.236.148', '2019-09-05 17:54:00', 10, 2001001000, '服务端发生异常', '2019-09-05 17:54:00');
INSERT INTO `access_log` VALUES (76149, '65.45.15676772402850243', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '113.116.236.148', '2019-09-05 17:54:00', 8, 0, '', '2019-09-05 17:54:00');
INSERT INTO `access_log` VALUES (76150, '64.77.15676777817607029', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 18:03:02', 10, 0, '', '2019-09-05 18:03:02');
INSERT INTO `access_log` VALUES (76151, '64.82.15676778019367067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-05 18:03:22', 4, 0, '', '2019-09-05 18:03:22');
INSERT INTO `access_log` VALUES (76152, '59.71.15676780902226609', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.236.4.47', '2019-09-05 18:08:10', 3, 0, '', '2019-09-05 18:08:10');
INSERT INTO `access_log` VALUES (76153, '59.76.15676780902236599', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.236.4.47', '2019-09-05 18:08:10', 12, 2001001000, '服务端发生异常', '2019-09-05 18:08:10');
INSERT INTO `access_log` VALUES (76154, '64.82.15676780949957071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.236.4.47', '2019-09-05 18:08:15', 2, 0, '', '2019-09-05 18:08:15');
INSERT INTO `access_log` VALUES (76155, '64.80.15676780950967057', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.236.4.47', '2019-09-05 18:08:15', 2, 0, '', '2019-09-05 18:08:15');
INSERT INTO `access_log` VALUES (76156, '59.78.15676780977756623', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.236.4.47', '2019-09-05 18:08:18', 3, 0, '', '2019-09-05 18:08:18');
INSERT INTO `access_log` VALUES (76157, '59.75.15676780977756617', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.236.4.47', '2019-09-05 18:08:18', 12, 2001001000, '服务端发生异常', '2019-09-05 18:08:18');
INSERT INTO `access_log` VALUES (76158, '66.50.15676784309173975', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 18:13:51', 9, 1002001012, '访问令牌已过期', '2019-09-05 18:13:51');
INSERT INTO `access_log` VALUES (76159, '66.54.15676784310063987', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=1705f3cc19c04570b480a16df5913a2b', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 18:13:51', 184, 0, '', '2019-09-05 18:13:51');
INSERT INTO `access_log` VALUES (76160, '66.57.15676784312973967', 223, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 18:13:51', 13, 0, '', '2019-09-05 18:13:51');
INSERT INTO `access_log` VALUES (76161, '66.53.15676784319393957', 223, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 18:13:52', 6, 0, '', '2019-09-05 18:13:52');
INSERT INTO `access_log` VALUES (76162, '59.71.15676808756206647', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '60.191.47.53', '2019-09-05 18:54:36', 13, 0, '', '2019-09-05 18:54:36');
INSERT INTO `access_log` VALUES (76163, '59.76.15676808756226637', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '60.191.47.53', '2019-09-05 18:54:36', 11, 2001001000, '服务端发生异常', '2019-09-05 18:54:36');
INSERT INTO `access_log` VALUES (76164, '64.81.15676808851597101', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '60.191.47.53', '2019-09-05 18:54:45', 10, 0, '', '2019-09-05 18:54:45');
INSERT INTO `access_log` VALUES (76165, '64.84.15676808853557095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '60.191.47.53', '2019-09-05 18:54:45', 2, 0, '', '2019-09-05 18:54:45');
INSERT INTO `access_log` VALUES (76166, '59.72.15676890114396757', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.35.6.82', '2019-09-05 21:10:11', 9, 0, '', '2019-09-05 21:10:11');
INSERT INTO `access_log` VALUES (76167, '59.73.15676890114396757', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.35.6.82', '2019-09-05 21:10:11', 18, 2001001000, '服务端发生异常', '2019-09-05 21:10:11');
INSERT INTO `access_log` VALUES (76168, '64.78.15676890141687229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.35.6.82', '2019-09-05 21:10:14', 14, 0, '', '2019-09-05 21:10:14');
INSERT INTO `access_log` VALUES (76169, '64.83.15676890142827199', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.35.6.82', '2019-09-05 21:10:14', 4, 0, '', '2019-09-05 21:10:14');
INSERT INTO `access_log` VALUES (76170, '64.85.15676890152667227', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.35.6.82', '2019-09-05 21:10:15', 2, 0, '', '2019-09-05 21:10:15');
INSERT INTO `access_log` VALUES (76171, '64.79.15676890157227207', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.35.6.82', '2019-09-05 21:10:16', 2, 0, '', '2019-09-05 21:10:16');
INSERT INTO `access_log` VALUES (76172, '64.76.15676890161407213', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.35.6.82', '2019-09-05 21:10:16', 1, 0, '', '2019-09-05 21:10:16');
INSERT INTO `access_log` VALUES (76173, '64.77.15676890164457181', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.35.6.82', '2019-09-05 21:10:16', 2, 0, '', '2019-09-05 21:10:16');
INSERT INTO `access_log` VALUES (76174, '65.47.15676890337010315', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.35.6.82', '2019-09-05 21:10:34', 0, 1002001015, '账号未登陆', '2019-09-05 21:10:34');
INSERT INTO `access_log` VALUES (76175, '65.3607.15676890336992161', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.35.6.82', '2019-09-05 21:10:34', 1, 1002001015, '账号未登陆', '2019-09-05 21:10:34');
INSERT INTO `access_log` VALUES (76176, '65.50.15676890336990365', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.35.6.82', '2019-09-05 21:10:34', 1, 1002001015, '账号未登陆', '2019-09-05 21:10:34');
INSERT INTO `access_log` VALUES (76177, '65.51.15676890355150405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.35.6.82', '2019-09-05 21:10:36', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 21:10:36');
INSERT INTO `access_log` VALUES (76178, '59.75.15676907681156787', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:39:28', 4, 0, '', '2019-09-05 21:39:28');
INSERT INTO `access_log` VALUES (76179, '59.72.15676907681166781', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:39:28', 13, 2001001000, '服务端发生异常', '2019-09-05 21:39:28');
INSERT INTO `access_log` VALUES (76180, '64.76.15676907762367237', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:39:36', 3, 0, '', '2019-09-05 21:39:36');
INSERT INTO `access_log` VALUES (76181, '64.77.15676907763387205', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:39:36', 2, 0, '', '2019-09-05 21:39:36');
INSERT INTO `access_log` VALUES (76182, '64.81.15676907775387235', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:39:38', 2, 0, '', '2019-09-05 21:39:38');
INSERT INTO `access_log` VALUES (76183, '64.84.15676907782187229', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:39:38', 2, 0, '', '2019-09-05 21:39:38');
INSERT INTO `access_log` VALUES (76184, '59.74.15676907797106797', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:39:40', 3, 0, '', '2019-09-05 21:39:40');
INSERT INTO `access_log` VALUES (76185, '59.79.15676907797106787', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:39:40', 13, 2001001000, '服务端发生异常', '2019-09-05 21:39:40');
INSERT INTO `access_log` VALUES (76186, '65.49.15676908058670407', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:40:06', 1, 1002001015, '账号未登陆', '2019-09-05 21:40:06');
INSERT INTO `access_log` VALUES (76187, '65.46.15676908058660425', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:40:06', 0, 1002001015, '账号未登陆', '2019-09-05 21:40:06');
INSERT INTO `access_log` VALUES (76188, '65.54.15676908058700271', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:40:06', 0, 1002001015, '账号未登陆', '2019-09-05 21:40:06');
INSERT INTO `access_log` VALUES (76189, '65.47.15676908088040339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:40:09', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 21:40:09');
INSERT INTO `access_log` VALUES (76190, '65.53.15676908154170337', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:40:15', 87, 0, '', '2019-09-05 21:40:16');
INSERT INTO `access_log` VALUES (76191, '65.51.15676908157070431', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:40:16', 13, 0, '', '2019-09-05 21:40:16');
INSERT INTO `access_log` VALUES (76192, '65.50.15676908157100391', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:40:16', 11, 2001001000, '服务端发生异常', '2019-09-05 21:40:16');
INSERT INTO `access_log` VALUES (76193, '65.52.15676908157120457', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.123.135.72', '2019-09-05 21:40:16', 9, 0, '', '2019-09-05 21:40:16');
INSERT INTO `access_log` VALUES (76194, '65.47.15676923833420363', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.230.77.5', '2019-09-05 22:06:23', 5, 1002001012, '访问令牌已过期', '2019-09-05 22:06:23');
INSERT INTO `access_log` VALUES (76195, '65.46.15676923833420447', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.230.77.5', '2019-09-05 22:06:23', 5, 1002001012, '访问令牌已过期', '2019-09-05 22:06:23');
INSERT INTO `access_log` VALUES (76196, '65.54.15676923833640293', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.230.77.5', '2019-09-05 22:06:23', 4, 1002001012, '访问令牌已过期', '2019-09-05 22:06:23');
INSERT INTO `access_log` VALUES (76197, '65.3607.15676923880312211', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.230.77.5', '2019-09-05 22:06:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-05 22:06:28');
INSERT INTO `access_log` VALUES (76198, '65.50.15676924020550413', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.230.77.5', '2019-09-05 22:06:42', 53, 0, '', '2019-09-05 22:06:42');
INSERT INTO `access_log` VALUES (76199, '65.45.15676924024100453', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.230.77.5', '2019-09-05 22:06:42', 10, 0, '', '2019-09-05 22:06:42');
INSERT INTO `access_log` VALUES (76200, '65.52.15676924024160481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.230.77.5', '2019-09-05 22:06:42', 9, 2001001000, '服务端发生异常', '2019-09-05 22:06:42');
INSERT INTO `access_log` VALUES (76201, '65.49.15676924024160431', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '120.230.77.5', '2019-09-05 22:06:42', 9, 0, '', '2019-09-05 22:06:42');
INSERT INTO `access_log` VALUES (76202, '59.72.15676934194406817', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.60.101', '2019-09-05 22:23:39', 9, 0, '', '2019-09-05 22:23:39');
INSERT INTO `access_log` VALUES (76203, '59.73.15676934194776817', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.60.101', '2019-09-05 22:23:39', 15, 2001001000, '服务端发生异常', '2019-09-05 22:23:39');
INSERT INTO `access_log` VALUES (76204, '64.81.15676934259367271', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.60.101', '2019-09-05 22:23:46', 15, 0, '', '2019-09-05 22:23:46');
INSERT INTO `access_log` VALUES (76205, '64.82.15676934261187279', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.60.101', '2019-09-05 22:23:46', 3, 0, '', '2019-09-05 22:23:46');
INSERT INTO `access_log` VALUES (76206, '64.78.15676934297477289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.60.101', '2019-09-05 22:23:50', 2, 0, '', '2019-09-05 22:23:50');
INSERT INTO `access_log` VALUES (76207, '64.85.15676934305577289', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '120.229.60.101', '2019-09-05 22:23:51', 1, 0, '', '2019-09-05 22:23:51');
INSERT INTO `access_log` VALUES (76208, '65.52.15676935428490497', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10&name=系统管理员&offset=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '112.96.179.147', '2019-09-05 22:25:43', 1, 1002001015, '账号未登陆', '2019-09-05 22:25:43');
INSERT INTO `access_log` VALUES (76209, '65.3607.15676935878902231', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.2 Safari/605.1.15', '112.96.179.147', '2019-09-05 22:26:28', 0, 1002001015, '账号未登陆', '2019-09-05 22:26:28');
INSERT INTO `access_log` VALUES (76210, '65.49.15676954760250473', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-05 22:57:56', 12, 1002001012, '访问令牌已过期', '2019-09-05 22:57:56');
INSERT INTO `access_log` VALUES (76211, '65.50.15676954808930453', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-05 22:58:01', 70, 0, '', '2019-09-05 22:58:01');
INSERT INTO `access_log` VALUES (76212, '65.3607.15676954818322257', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-05 22:58:02', 9, 0, '', '2019-09-05 22:58:02');
INSERT INTO `access_log` VALUES (76213, '65.54.15676954818390339', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-05 22:58:02', 22, 0, '', '2019-09-05 22:58:02');
INSERT INTO `access_log` VALUES (76214, '65.45.15676954818480499', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-05 22:58:02', 16, 0, '', '2019-09-05 22:58:02');
INSERT INTO `access_log` VALUES (76215, '65.51.15676954874420499', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-05 22:58:07', 26, 0, '', '2019-09-05 22:58:07');
INSERT INTO `access_log` VALUES (76216, '65.50.15676958577010459', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-05 23:04:18', 19, 0, '', '2019-09-05 23:04:18');
INSERT INTO `access_log` VALUES (76217, '65.54.15677000934750401', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.254.121', '2019-09-06 00:14:53', 14, 1002001012, '访问令牌已过期', '2019-09-06 00:14:53');
INSERT INTO `access_log` VALUES (76218, '65.51.15677000934750561', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.254.121', '2019-09-06 00:14:53', 16, 1002001012, '访问令牌已过期', '2019-09-06 00:14:53');
INSERT INTO `access_log` VALUES (76219, '65.47.15677000934790471', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.254.121', '2019-09-06 00:14:53', 15, 1002001012, '访问令牌已过期', '2019-09-06 00:14:53');
INSERT INTO `access_log` VALUES (76220, '65.52.15677001027330587', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.254.121', '2019-09-06 00:15:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 00:15:03');
INSERT INTO `access_log` VALUES (76221, '65.49.15677001101380537', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.254.121', '2019-09-06 00:15:10', 59, 0, '', '2019-09-06 00:15:10');
INSERT INTO `access_log` VALUES (76222, '65.50.15677001104440517', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.254.121', '2019-09-06 00:15:10', 10, 0, '', '2019-09-06 00:15:10');
INSERT INTO `access_log` VALUES (76223, '65.3607.15677001104492321', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.254.121', '2019-09-06 00:15:10', 12, 2001001000, '服务端发生异常', '2019-09-06 00:15:10');
INSERT INTO `access_log` VALUES (76224, '65.45.15677001104540563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.254.121', '2019-09-06 00:15:10', 11, 0, '', '2019-09-06 00:15:10');
INSERT INTO `access_log` VALUES (76225, '65.47.15677001169420473', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.254.121', '2019-09-06 00:15:17', 8, 0, '', '2019-09-06 00:15:17');
INSERT INTO `access_log` VALUES (76226, '65.51.15677001169450563', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.254.121', '2019-09-06 00:15:17', 9, 0, '', '2019-09-06 00:15:17');
INSERT INTO `access_log` VALUES (76227, '65.54.15677001169450403', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.249.254.121', '2019-09-06 00:15:17', 9, 2001001000, '服务端发生异常', '2019-09-06 00:15:17');
INSERT INTO `access_log` VALUES (76228, '59.79.15677165182067131', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.66', '2019-09-06 04:48:38', 11, 0, '', '2019-09-06 04:48:38');
INSERT INTO `access_log` VALUES (76229, '59.74.15677165182077141', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.5', '2019-09-06 04:48:38', 31, 2001001000, '服务端发生异常', '2019-09-06 04:48:38');
INSERT INTO `access_log` VALUES (76230, '65.50.15677288885200901', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.4', '2019-09-06 08:14:49', 1, 1002001015, '账号未登陆', '2019-09-06 08:14:49');
INSERT INTO `access_log` VALUES (76231, '65.3607.15677288885602705', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.5', '2019-09-06 08:14:49', 0, 1002001015, '账号未登陆', '2019-09-06 08:14:49');
INSERT INTO `access_log` VALUES (76232, '65.54.15677288886050787', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.68', '2019-09-06 08:14:49', 1, 1002001015, '账号未登陆', '2019-09-06 08:14:49');
INSERT INTO `access_log` VALUES (76233, '65.49.15677303005740943', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-06 08:38:21', 9, 1002001012, '访问令牌已过期', '2019-09-06 08:38:21');
INSERT INTO `access_log` VALUES (76234, '65.53.15677303005740871', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-06 08:38:21', 9, 1002001012, '访问令牌已过期', '2019-09-06 08:38:21');
INSERT INTO `access_log` VALUES (76235, '65.45.15677303005750969', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-06 08:38:21', 11, 1002001012, '访问令牌已过期', '2019-09-06 08:38:21');
INSERT INTO `access_log` VALUES (76236, '65.54.15677303106320807', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-06 08:38:31', 142, 0, '', '2019-09-06 08:38:31');
INSERT INTO `access_log` VALUES (76237, '65.3607.15677303111172725', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-06 08:38:31', 13, 0, '', '2019-09-06 08:38:31');
INSERT INTO `access_log` VALUES (76238, '65.51.15677303111180969', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-06 08:38:31', 15, 2001001000, '服务端发生异常', '2019-09-06 08:38:31');
INSERT INTO `access_log` VALUES (76239, '65.47.15677303111220877', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-06 08:38:31', 12, 0, '', '2019-09-06 08:38:31');
INSERT INTO `access_log` VALUES (76240, '59.78.15677305356307325', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-06 08:42:16', 9, 0, '', '2019-09-06 08:42:16');
INSERT INTO `access_log` VALUES (76241, '59.75.15677305356307319', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-06 08:42:16', 20, 2001001000, '服务端发生异常', '2019-09-06 08:42:16');
INSERT INTO `access_log` VALUES (76242, '65.54.15677305483280811', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-06 08:42:28', 11, 0, '', '2019-09-06 08:42:28');
INSERT INTO `access_log` VALUES (76243, '65.3607.15677305483352729', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-06 08:42:28', 9, 2001001000, '服务端发生异常', '2019-09-06 08:42:28');
INSERT INTO `access_log` VALUES (76244, '65.47.15677305483400881', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-06 08:42:28', 10, 0, '', '2019-09-06 08:42:28');
INSERT INTO `access_log` VALUES (76245, '65.51.15677305579920973', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.236.181.122', '2019-09-06 08:42:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 08:42:38');
INSERT INTO `access_log` VALUES (76246, '59.78.15677322953257349', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.104.155.137', '2019-09-06 09:11:35', 9, 0, '', '2019-09-06 09:11:35');
INSERT INTO `access_log` VALUES (76247, '59.75.15677322953257343', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '218.104.155.137', '2019-09-06 09:11:35', 23, 2001001000, '服务端发生异常', '2019-09-06 09:11:35');
INSERT INTO `access_log` VALUES (76248, '65.46.15677327185670991', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.244.82.180', '2019-09-06 09:18:39', 0, 1002001015, '账号未登陆', '2019-09-06 09:18:39');
INSERT INTO `access_log` VALUES (76249, '65.51.15677327185671001', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.244.82.180', '2019-09-06 09:18:39', 1, 1002001015, '账号未登陆', '2019-09-06 09:18:39');
INSERT INTO `access_log` VALUES (76250, '65.52.15677327185911027', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.244.82.180', '2019-09-06 09:18:39', 1, 1002001015, '账号未登陆', '2019-09-06 09:18:39');
INSERT INTO `access_log` VALUES (76251, '65.53.15677327247690907', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.244.82.180', '2019-09-06 09:18:45', 121, 0, '', '2019-09-06 09:18:45');
INSERT INTO `access_log` VALUES (76252, '65.50.15677327250840955', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.244.82.180', '2019-09-06 09:18:45', 10, 0, '', '2019-09-06 09:18:45');
INSERT INTO `access_log` VALUES (76253, '65.45.15677327250901005', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.244.82.180', '2019-09-06 09:18:45', 9, 2001001000, '服务端发生异常', '2019-09-06 09:18:45');
INSERT INTO `access_log` VALUES (76254, '65.3607.15677327250922761', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.244.82.180', '2019-09-06 09:18:45', 7, 0, '', '2019-09-06 09:18:45');
INSERT INTO `access_log` VALUES (76255, '65.54.15677327319290843', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.244.82.180', '2019-09-06 09:18:52', 9, 0, '', '2019-09-06 09:18:52');
INSERT INTO `access_log` VALUES (76256, '65.46.15677327319380993', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.244.82.180', '2019-09-06 09:18:52', 9, 0, '', '2019-09-06 09:18:52');
INSERT INTO `access_log` VALUES (76257, '65.47.15677327319380913', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.244.82.180', '2019-09-06 09:18:52', 10, 2001001000, '服务端发生异常', '2019-09-06 09:18:52');
INSERT INTO `access_log` VALUES (76258, '65.52.15677327439061029', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.244.82.180', '2019-09-06 09:19:04', 19, 0, '', '2019-09-06 09:19:04');
INSERT INTO `access_log` VALUES (76259, '65.49.15677327439060981', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.244.82.180', '2019-09-06 09:19:04', 19, 2001001000, '服务端发生异常', '2019-09-06 09:19:04');
INSERT INTO `access_log` VALUES (76260, '65.53.15677327439080909', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '223.244.82.180', '2019-09-06 09:19:04', 9, 0, '', '2019-09-06 09:19:04');
INSERT INTO `access_log` VALUES (76261, '59.76.15677331392427337', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.25.42.96', '2019-09-06 09:25:39', 5, 0, '', '2019-09-06 09:25:39');
INSERT INTO `access_log` VALUES (76262, '59.71.15677331392427347', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.25.42.96', '2019-09-06 09:25:39', 18, 2001001000, '服务端发生异常', '2019-09-06 09:25:39');
INSERT INTO `access_log` VALUES (76263, '59.77.15677357816267375', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:09:42', 10, 0, '', '2019-09-06 10:09:42');
INSERT INTO `access_log` VALUES (76264, '59.80.15677357816277355', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:09:42', 16, 2001001000, '服务端发生异常', '2019-09-06 10:09:42');
INSERT INTO `access_log` VALUES (76265, '59.75.15677359740577393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:12:54', 3, 0, '', '2019-09-06 10:12:54');
INSERT INTO `access_log` VALUES (76266, '59.72.15677359740587387', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:12:54', 16, 2001001000, '服务端发生异常', '2019-09-06 10:12:54');
INSERT INTO `access_log` VALUES (76267, '64.82.15677359795217847', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:00', 10, 0, '', '2019-09-06 10:13:00');
INSERT INTO `access_log` VALUES (76268, '64.78.15677359796527857', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:00', 2, 0, '', '2019-09-06 10:13:00');
INSERT INTO `access_log` VALUES (76269, '64.84.15677359810797835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:01', 2, 0, '', '2019-09-06 10:13:01');
INSERT INTO `access_log` VALUES (76270, '64.76.15677359880417841', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:08', 2, 0, '', '2019-09-06 10:13:08');
INSERT INTO `access_log` VALUES (76271, '64.83.15677359895787829', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:10', 2, 0, '', '2019-09-06 10:13:10');
INSERT INTO `access_log` VALUES (76272, '59.79.15677359905547393', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:11', 2, 0, '', '2019-09-06 10:13:11');
INSERT INTO `access_log` VALUES (76273, '59.74.15677359905607403', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:11', 14, 2001001000, '服务端发生异常', '2019-09-06 10:13:11');
INSERT INTO `access_log` VALUES (76274, '66.54.15677359942454755', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:14', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n账号长度为 11 位\n手机验证码不能为空', '2019-09-06 10:13:14');
INSERT INTO `access_log` VALUES (76275, '59.77.15677360026487379', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:23', 3, 0, '', '2019-09-06 10:13:23');
INSERT INTO `access_log` VALUES (76276, '59.71.15677360026487387', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:23', 32, 2001001000, '服务端发生异常', '2019-09-06 10:13:23');
INSERT INTO `access_log` VALUES (76277, '59.76.15677360116777377', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:32', 3, 0, '', '2019-09-06 10:13:32');
INSERT INTO `access_log` VALUES (76278, '59.78.15677360116777401', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:32', 14, 2001001000, '服务端发生异常', '2019-09-06 10:13:32');
INSERT INTO `access_log` VALUES (76279, '64.80.15677360151767835', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:35', 2, 0, '', '2019-09-06 10:13:35');
INSERT INTO `access_log` VALUES (76280, '64.77.15677360152977811', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:35', 2, 0, '', '2019-09-06 10:13:35');
INSERT INTO `access_log` VALUES (76281, '59.72.15677360161377389', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:36', 2, 0, '', '2019-09-06 10:13:36');
INSERT INTO `access_log` VALUES (76282, '59.73.15677360161377389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:36', 15, 2001001000, '服务端发生异常', '2019-09-06 10:13:36');
INSERT INTO `access_log` VALUES (76283, '65.53.15677360221680955', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:42', 1, 1002001015, '账号未登陆', '2019-09-06 10:13:42');
INSERT INTO `access_log` VALUES (76284, '65.52.15677360221681073', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:42', 1, 1002001015, '账号未登陆', '2019-09-06 10:13:42');
INSERT INTO `access_log` VALUES (76285, '65.49.15677360221681027', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:13:42', 0, 1002001015, '账号未登陆', '2019-09-06 10:13:42');
INSERT INTO `access_log` VALUES (76286, '59.74.15677360279707405', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:13:48', 2, 0, '', '2019-09-06 10:13:48');
INSERT INTO `access_log` VALUES (76287, '64.82.15677360297447849', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:13:50', 2, 0, '', '2019-09-06 10:13:50');
INSERT INTO `access_log` VALUES (76288, '64.78.15677360298917859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:13:50', 2, 0, '', '2019-09-06 10:13:50');
INSERT INTO `access_log` VALUES (76289, '64.85.15677360312177859', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:13:51', 2, 0, '', '2019-09-06 10:13:51');
INSERT INTO `access_log` VALUES (76290, '64.76.15677360318527843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:13:52', 1, 0, '', '2019-09-06 10:13:52');
INSERT INTO `access_log` VALUES (76291, '64.83.15677360324607831', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:13:52', 2, 0, '', '2019-09-06 10:13:52');
INSERT INTO `access_log` VALUES (76292, '64.79.15677360331927839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:13:53', 1, 0, '', '2019-09-06 10:13:53');
INSERT INTO `access_log` VALUES (76293, '59.80.15677360351777361', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:13:55', 2, 0, '', '2019-09-06 10:13:55');
INSERT INTO `access_log` VALUES (76294, '64.80.15677360370177837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:13:57', 1, 0, '', '2019-09-06 10:13:57');
INSERT INTO `access_log` VALUES (76295, '64.77.15677360371887813', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:13:57', 2, 0, '', '2019-09-06 10:13:57');
INSERT INTO `access_log` VALUES (76296, '64.81.15677360382947843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:13:58', 2, 0, '', '2019-09-06 10:13:58');
INSERT INTO `access_log` VALUES (76297, '64.82.15677360387587851', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:13:59', 2, 0, '', '2019-09-06 10:13:59');
INSERT INTO `access_log` VALUES (76298, '59.77.15677360400867381', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:14:00', 3, 0, '', '2019-09-06 10:14:00');
INSERT INTO `access_log` VALUES (76299, '65.50.15677360405171001', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:14:01', 60, 0, '', '2019-09-06 10:14:01');
INSERT INTO `access_log` VALUES (76300, '65.54.15677360408000891', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:14:01', 14, 0, '', '2019-09-06 10:14:01');
INSERT INTO `access_log` VALUES (76301, '65.46.15677360408041039', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:14:01', 14, 0, '', '2019-09-06 10:14:01');
INSERT INTO `access_log` VALUES (76302, '65.3607.15677360408042807', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:14:01', 14, 2001001000, '服务端发生异常', '2019-09-06 10:14:01');
INSERT INTO `access_log` VALUES (76303, '64.78.15677360419797861', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:14:02', 2, 0, '', '2019-09-06 10:14:02');
INSERT INTO `access_log` VALUES (76304, '64.84.15677360421457839', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:14:02', 2, 0, '', '2019-09-06 10:14:02');
INSERT INTO `access_log` VALUES (76305, '64.76.15677360460707845', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:14:06', 2, 0, '', '2019-09-06 10:14:06');
INSERT INTO `access_log` VALUES (76306, '64.83.15677360462257833', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:14:06', 2, 0, '', '2019-09-06 10:14:06');
INSERT INTO `access_log` VALUES (76307, '59.76.15677360471597379', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '220.170.50.137', '2019-09-06 10:14:07', 2, 0, '', '2019-09-06 10:14:07');
INSERT INTO `access_log` VALUES (76308, '65.53.15677360648720957', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:14:25', 10, 0, '', '2019-09-06 10:14:25');
INSERT INTO `access_log` VALUES (76309, '65.49.15677360648751029', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:14:25', 10, 2001001000, '服务端发生异常', '2019-09-06 10:14:25');
INSERT INTO `access_log` VALUES (76310, '65.52.15677360648761075', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:14:25', 9, 0, '', '2019-09-06 10:14:25');
INSERT INTO `access_log` VALUES (76311, '65.45.15677360685051055', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:14:29', 9, 0, '', '2019-09-06 10:14:29');
INSERT INTO `access_log` VALUES (76312, '65.54.15677360685070893', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:14:29', 9, 0, '', '2019-09-06 10:14:29');
INSERT INTO `access_log` VALUES (76313, '65.50.15677360685061003', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.205.61.219', '2019-09-06 10:14:29', 10, 2001001000, '服务端发生异常', '2019-09-06 10:14:29');
INSERT INTO `access_log` VALUES (76314, '65.49.15677364503621035', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:20:50', 0, 1002001015, '账号未登陆', '2019-09-06 10:20:50');
INSERT INTO `access_log` VALUES (76315, '65.52.15677364503641081', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:20:50', 0, 1002001015, '账号未登陆', '2019-09-06 10:20:50');
INSERT INTO `access_log` VALUES (76316, '65.50.15677364503651009', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:20:50', 1, 1002001015, '账号未登陆', '2019-09-06 10:20:50');
INSERT INTO `access_log` VALUES (76317, '65.54.15677364642170899', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:04', 81, 0, '', '2019-09-06 10:21:04');
INSERT INTO `access_log` VALUES (76318, '65.46.15677364645131047', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:05', 10, 0, '', '2019-09-06 10:21:05');
INSERT INTO `access_log` VALUES (76319, '65.3607.15677364645182815', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:05', 10, 2001001000, '服务端发生异常', '2019-09-06 10:21:05');
INSERT INTO `access_log` VALUES (76320, '65.47.15677364645230969', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:05', 9, 0, '', '2019-09-06 10:21:05');
INSERT INTO `access_log` VALUES (76321, '65.53.15677364725910965', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:13', 9, 0, '', '2019-09-06 10:21:13');
INSERT INTO `access_log` VALUES (76322, '65.50.15677364725911011', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:13', 10, 2001001000, '服务端发生异常', '2019-09-06 10:21:13');
INSERT INTO `access_log` VALUES (76323, '65.52.15677364726121083', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:13', 9, 0, '', '2019-09-06 10:21:13');
INSERT INTO `access_log` VALUES (76324, '65.49.15677364772271037', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:17', 10, 2001001000, '服务端发生异常', '2019-09-06 10:21:17');
INSERT INTO `access_log` VALUES (76325, '65.45.15677364772281063', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:17', 31, 0, '', '2019-09-06 10:21:17');
INSERT INTO `access_log` VALUES (76326, '65.54.15677364772280901', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:17', 32, 0, '', '2019-09-06 10:21:17');
INSERT INTO `access_log` VALUES (76327, '65.46.15677364791631049', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:19', 14, 0, '', '2019-09-06 10:21:19');
INSERT INTO `access_log` VALUES (76328, '65.3607.15677364791632817', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:19', 15, 0, '', '2019-09-06 10:21:19');
INSERT INTO `access_log` VALUES (76329, '65.47.15677364791630971', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:19', 15, 2001001000, '服务端发生异常', '2019-09-06 10:21:19');
INSERT INTO `access_log` VALUES (76330, '65.52.15677364941941085', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:34', 8, 0, '', '2019-09-06 10:21:34');
INSERT INTO `access_log` VALUES (76331, '65.53.15677364941930967', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:34', 9, 0, '', '2019-09-06 10:21:34');
INSERT INTO `access_log` VALUES (76332, '65.50.15677364941941013', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:21:34', 9, 2001001000, '服务端发生异常', '2019-09-06 10:21:34');
INSERT INTO `access_log` VALUES (76333, '65.47.15677365726600973', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:22:53', 9, 0, '', '2019-09-06 10:22:53');
INSERT INTO `access_log` VALUES (76334, '65.51.15677365726611061', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:22:53', 9, 2001001000, '服务端发生异常', '2019-09-06 10:22:53');
INSERT INTO `access_log` VALUES (76335, '65.50.15677365726661015', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:22:53', 10, 0, '', '2019-09-06 10:22:53');
INSERT INTO `access_log` VALUES (76336, '65.53.15677372794320979', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:34:39', 127, 0, '', '2019-09-06 10:34:40');
INSERT INTO `access_log` VALUES (76337, '65.50.15677372794311025', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:34:39', 127, 0, '', '2019-09-06 10:34:40');
INSERT INTO `access_log` VALUES (76338, '65.47.15677372794310983', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3704.400 QQBrowser/10.4.3587.400', '119.96.16.57', '2019-09-06 10:34:39', 127, 2001001000, '服务端发生异常', '2019-09-06 10:34:40');
INSERT INTO `access_log` VALUES (76339, '65.50.15677377933661033', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.42.91.71', '2019-09-06 10:43:13', 1, 1002001015, '账号未登陆', '2019-09-06 10:43:13');
INSERT INTO `access_log` VALUES (76340, '65.53.15677377933670987', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.42.91.71', '2019-09-06 10:43:13', 0, 1002001015, '账号未登陆', '2019-09-06 10:43:13');
INSERT INTO `access_log` VALUES (76341, '65.52.15677377933691105', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.42.91.71', '2019-09-06 10:43:13', 0, 1002001015, '账号未登陆', '2019-09-06 10:43:13');
INSERT INTO `access_log` VALUES (76342, '65.51.15677378024721079', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.42.91.71', '2019-09-06 10:43:22', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 10:43:22');
INSERT INTO `access_log` VALUES (76343, '65.47.15677378155610991', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.42.91.71', '2019-09-06 10:43:36', 92, 0, '', '2019-09-06 10:43:36');
INSERT INTO `access_log` VALUES (76344, '65.46.15677378159941071', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.42.91.71', '2019-09-06 10:43:36', 22, 0, '', '2019-09-06 10:43:36');
INSERT INTO `access_log` VALUES (76345, '65.49.15677378159951059', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.42.91.71', '2019-09-06 10:43:36', 23, 2001001000, '服务端发生异常', '2019-09-06 10:43:36');
INSERT INTO `access_log` VALUES (76346, '65.3607.15677378160332839', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.42.91.71', '2019-09-06 10:43:36', 8, 0, '', '2019-09-06 10:43:36');
INSERT INTO `access_log` VALUES (76347, '65.52.15677378210321107', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.42.91.71', '2019-09-06 10:43:41', 9, 2001001000, '服务端发生异常', '2019-09-06 10:43:41');
INSERT INTO `access_log` VALUES (76348, '65.50.15677378210281035', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.42.91.71', '2019-09-06 10:43:41', 9, 0, '', '2019-09-06 10:43:41');
INSERT INTO `access_log` VALUES (76349, '65.53.15677378210380989', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.42.91.71', '2019-09-06 10:43:41', 8, 0, '', '2019-09-06 10:43:41');
INSERT INTO `access_log` VALUES (76350, '65.49.15677384653581069', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:54:25', 0, 1002001015, '账号未登陆', '2019-09-06 10:54:25');
INSERT INTO `access_log` VALUES (76351, '65.46.15677384653581081', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:54:25', 0, 1002001015, '账号未登陆', '2019-09-06 10:54:25');
INSERT INTO `access_log` VALUES (76352, '65.3607.15677384653602849', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:54:25', 0, 1002001015, '账号未登陆', '2019-09-06 10:54:25');
INSERT INTO `access_log` VALUES (76353, '65.45.15677384764591095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:54:36', 105, 0, '', '2019-09-06 10:54:37');
INSERT INTO `access_log` VALUES (76354, '65.53.15677384767990999', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:54:37', 10, 0, '', '2019-09-06 10:54:37');
INSERT INTO `access_log` VALUES (76355, '65.52.15677384768011117', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:54:37', 11, 2001001000, '服务端发生异常', '2019-09-06 10:54:37');
INSERT INTO `access_log` VALUES (76356, '65.50.15677384768061045', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:54:37', 11, 0, '', '2019-09-06 10:54:37');
INSERT INTO `access_log` VALUES (76357, '65.54.15677384889170935', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:54:49', 9, 0, '', '2019-09-06 10:54:49');
INSERT INTO `access_log` VALUES (76358, '65.47.15677384889181003', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:54:49', 9, 2001001000, '服务端发生异常', '2019-09-06 10:54:49');
INSERT INTO `access_log` VALUES (76359, '65.3607.15677384889192851', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:54:49', 171, 0, '', '2019-09-06 10:54:49');
INSERT INTO `access_log` VALUES (76360, '65.46.15677384984241083', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:54:58', 9, 0, '', '2019-09-06 10:54:58');
INSERT INTO `access_log` VALUES (76361, '65.45.15677384984261097', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:54:58', 10, 2001001000, '服务端发生异常', '2019-09-06 10:54:58');
INSERT INTO `access_log` VALUES (76362, '65.53.15677384984281001', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:54:58', 9, 0, '', '2019-09-06 10:54:58');
INSERT INTO `access_log` VALUES (76363, '65.52.15677385015501119', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:55:02', 9, 0, '', '2019-09-06 10:55:02');
INSERT INTO `access_log` VALUES (76364, '65.51.15677385015531093', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:55:02', 8, 0, '', '2019-09-06 10:55:02');
INSERT INTO `access_log` VALUES (76365, '65.50.15677385015501047', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:55:02', 11, 2001001000, '服务端发生异常', '2019-09-06 10:55:02');
INSERT INTO `access_log` VALUES (76366, '65.3607.15677385366392853', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:55:37', 9, 0, '', '2019-09-06 10:55:37');
INSERT INTO `access_log` VALUES (76367, '65.49.15677385366421073', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:55:37', 10, 2001001000, '服务端发生异常', '2019-09-06 10:55:37');
INSERT INTO `access_log` VALUES (76368, '65.53.15677385366481003', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:55:37', 11, 0, '', '2019-09-06 10:55:37');
INSERT INTO `access_log` VALUES (76369, '65.45.15677385427561099', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:55:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 10:55:43');
INSERT INTO `access_log` VALUES (76370, '65.51.15677385499851095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:55:50', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 10:55:50');
INSERT INTO `access_log` VALUES (76371, '65.50.15677385554171049', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:55:55', 211, 0, '', '2019-09-06 10:55:56');
INSERT INTO `access_log` VALUES (76372, '65.47.15677385557931007', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:55:56', 7, 0, '', '2019-09-06 10:55:56');
INSERT INTO `access_log` VALUES (76373, '65.49.15677385557951075', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:55:56', 7, 0, '', '2019-09-06 10:55:56');
INSERT INTO `access_log` VALUES (76374, '65.54.15677385557950939', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:55:56', 8, 0, '', '2019-09-06 10:55:56');
INSERT INTO `access_log` VALUES (76375, '62.82.15677385654905903', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:56:05', 31, 0, '', '2019-09-06 10:56:06');
INSERT INTO `access_log` VALUES (76376, '64.83.15677385680947867', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:56:08', 23, 0, '', '2019-09-06 10:56:08');
INSERT INTO `access_log` VALUES (76377, '64.76.15677385680937879', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:56:08', 28, 0, '', '2019-09-06 10:56:08');
INSERT INTO `access_log` VALUES (76378, '59.80.15677386696177397', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.181.101.37', '2019-09-06 10:57:50', 9, 0, '', '2019-09-06 10:57:50');
INSERT INTO `access_log` VALUES (76379, '59.79.15677386696167431', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.181.101.37', '2019-09-06 10:57:50', 18, 2001001000, '服务端发生异常', '2019-09-06 10:57:50');
INSERT INTO `access_log` VALUES (76380, '64.85.15677386746867897', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.181.101.37', '2019-09-06 10:57:55', 3, 0, '', '2019-09-06 10:57:55');
INSERT INTO `access_log` VALUES (76381, '64.83.15677386747937869', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.181.101.37', '2019-09-06 10:57:55', 1, 0, '', '2019-09-06 10:57:55');
INSERT INTO `access_log` VALUES (76382, '64.76.15677386762837881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.181.101.37', '2019-09-06 10:57:56', 2, 0, '', '2019-09-06 10:57:56');
INSERT INTO `access_log` VALUES (76383, '64.79.15677386770837877', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.181.101.37', '2019-09-06 10:57:57', 1, 0, '', '2019-09-06 10:57:57');
INSERT INTO `access_log` VALUES (76384, '64.80.15677386777087875', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.181.101.37', '2019-09-06 10:57:58', 2, 0, '', '2019-09-06 10:57:58');
INSERT INTO `access_log` VALUES (76385, '59.77.15677386792937417', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.181.101.37', '2019-09-06 10:57:59', 15, 2001001000, '服务端发生异常', '2019-09-06 10:57:59');
INSERT INTO `access_log` VALUES (76386, '59.71.15677386792937425', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.181.101.37', '2019-09-06 10:57:59', 47, 0, '', '2019-09-06 10:57:59');
INSERT INTO `access_log` VALUES (76387, '59.78.15677386867247439', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.181.101.37', '2019-09-06 10:58:07', 3, 0, '', '2019-09-06 10:58:07');
INSERT INTO `access_log` VALUES (76388, '59.75.15677386867257433', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.181.101.37', '2019-09-06 10:58:07', 12, 2001001000, '服务端发生异常', '2019-09-06 10:58:07');
INSERT INTO `access_log` VALUES (76389, '66.57.15677386932314771', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.181.101.37', '2019-09-06 10:58:13', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字\n手机号不能为空\n手机验证码必须都是数字\n手机验证码长度为 4-6 位', '2019-09-06 10:58:13');
INSERT INTO `access_log` VALUES (76390, '59.74.15677387026927443', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.181.101.37', '2019-09-06 10:58:23', 2, 0, '', '2019-09-06 10:58:23');
INSERT INTO `access_log` VALUES (76391, '59.73.15677387026927427', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/64.0.3282.140 Safari/537.36 Edge/18.17763', '221.181.101.37', '2019-09-06 10:58:23', 9, 2001001000, '服务端发生异常', '2019-09-06 10:58:23');
INSERT INTO `access_log` VALUES (76392, '64.78.15677387068377899', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:58:27', 21, 0, '', '2019-09-06 10:58:27');
INSERT INTO `access_log` VALUES (76393, '64.82.15677387068367889', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:58:27', 25, 0, '', '2019-09-06 10:58:27');
INSERT INTO `access_log` VALUES (76394, '64.85.15677387163477899', 1, 2, 'product-application', '/product-api/admins/spu/update_sort', 'id=32&sort=1', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:58:36', 172, 2001001000, '服务端发生异常', '2019-09-06 10:58:37');
INSERT INTO `access_log` VALUES (76395, '59.77.15677387314637419', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:58:51', 14, 0, '', '2019-09-06 10:58:51');
INSERT INTO `access_log` VALUES (76396, '59.71.15677387337687427', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:58:54', 21, 2001001000, '服务端发生异常', '2019-09-06 10:58:54');
INSERT INTO `access_log` VALUES (76397, '59.76.15677387356607417', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:58:56', 16, 0, '', '2019-09-06 10:58:56');
INSERT INTO `access_log` VALUES (76398, '64.76.15677387370667883', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:58:57', 9, 0, '', '2019-09-06 10:58:57');
INSERT INTO `access_log` VALUES (76399, '64.80.15677387503877877', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:59:10', 10, 0, '', '2019-09-06 10:59:10');
INSERT INTO `access_log` VALUES (76400, '64.77.15677387544597853', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:59:14', 11, 0, '', '2019-09-06 10:59:14');
INSERT INTO `access_log` VALUES (76401, '64.78.15677387703157901', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:59:30', 11, 0, '', '2019-09-06 10:59:30');
INSERT INTO `access_log` VALUES (76402, '64.84.15677387765467879', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:59:37', 10, 0, '', '2019-09-06 10:59:37');
INSERT INTO `access_log` VALUES (76403, '64.85.15677387883627901', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:59:48', 365, 0, '', '2019-09-06 10:59:49');
INSERT INTO `access_log` VALUES (76404, '64.76.15677387941387885', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:59:54', 9, 0, '', '2019-09-06 10:59:54');
INSERT INTO `access_log` VALUES (76405, '64.79.15677388040697881', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:00:04', 10, 0, '', '2019-09-06 11:00:04');
INSERT INTO `access_log` VALUES (76406, '65.50.15677388069121053', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:00:07', 25, 0, '', '2019-09-06 11:00:07');
INSERT INTO `access_log` VALUES (76407, '65.54.15677388078820943', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:00:08', 18, 0, '', '2019-09-06 11:00:08');
INSERT INTO `access_log` VALUES (76408, '65.49.15677388087801079', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:00:09', 9, 0, '', '2019-09-06 11:00:09');
INSERT INTO `access_log` VALUES (76409, '65.3607.15677388296302859', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:00:30', 15, 0, '', '2019-09-06 11:00:30');
INSERT INTO `access_log` VALUES (76410, '65.45.15677388412101105', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:00:41', 9, 0, '', '2019-09-06 11:00:41');
INSERT INTO `access_log` VALUES (76411, '59.75.15677392065007441', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:06:47', 3, 0, '', '2019-09-06 11:06:47');
INSERT INTO `access_log` VALUES (76412, '59.72.15677392065017435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:06:47', 31, 2001001000, '服务端发生异常', '2019-09-06 11:06:47');
INSERT INTO `access_log` VALUES (76413, '64.76.15677392134017891', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:06:53', 3, 0, '', '2019-09-06 11:06:53');
INSERT INTO `access_log` VALUES (76414, '64.79.15677392135277887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:06:54', 1, 0, '', '2019-09-06 11:06:54');
INSERT INTO `access_log` VALUES (76415, '64.80.15677392192017885', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:06:59', 2, 0, '', '2019-09-06 11:06:59');
INSERT INTO `access_log` VALUES (76416, '64.77.15677392193507861', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:06:59', 1, 0, '', '2019-09-06 11:06:59');
INSERT INTO `access_log` VALUES (76417, '59.79.15677392223837441', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:02', 2, 0, '', '2019-09-06 11:07:02');
INSERT INTO `access_log` VALUES (76418, '59.73.15677392223837435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:02', 14, 2001001000, '服务端发生异常', '2019-09-06 11:07:02');
INSERT INTO `access_log` VALUES (76419, '64.78.15677392257147909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:06', 2, 0, '', '2019-09-06 11:07:06');
INSERT INTO `access_log` VALUES (76420, '64.82.15677392258607899', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:06', 2, 0, '', '2019-09-06 11:07:06');
INSERT INTO `access_log` VALUES (76421, '64.84.15677392269017887', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:07', 2, 0, '', '2019-09-06 11:07:07');
INSERT INTO `access_log` VALUES (76422, '64.85.15677392275907909', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:08', 1, 0, '', '2019-09-06 11:07:08');
INSERT INTO `access_log` VALUES (76423, '64.83.15677392282457881', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:08', 2, 0, '', '2019-09-06 11:07:08');
INSERT INTO `access_log` VALUES (76424, '64.76.15677392355657893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:16', 1, 0, '', '2019-09-06 11:07:16');
INSERT INTO `access_log` VALUES (76425, '64.79.15677392356877889', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:16', 1, 0, '', '2019-09-06 11:07:16');
INSERT INTO `access_log` VALUES (76426, '59.77.15677392372857427', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:17', 3, 0, '', '2019-09-06 11:07:17');
INSERT INTO `access_log` VALUES (76427, '59.71.15677392372857435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:17', 18, 2001001000, '服务端发生异常', '2019-09-06 11:07:17');
INSERT INTO `access_log` VALUES (76428, '64.77.15677392509267863', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:31', 2, 0, '', '2019-09-06 11:07:31');
INSERT INTO `access_log` VALUES (76429, '64.81.15677392510237893', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:31', 2, 0, '', '2019-09-06 11:07:31');
INSERT INTO `access_log` VALUES (76430, '64.78.15677392525677911', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:33', 2, 0, '', '2019-09-06 11:07:33');
INSERT INTO `access_log` VALUES (76431, '64.82.15677392530227901', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:33', 1, 0, '', '2019-09-06 11:07:33');
INSERT INTO `access_log` VALUES (76432, '59.72.15677392554737437', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:35', 2, 0, '', '2019-09-06 11:07:35');
INSERT INTO `access_log` VALUES (76433, '59.75.15677392554737443', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:35', 10, 2001001000, '服务端发生异常', '2019-09-06 11:07:35');
INSERT INTO `access_log` VALUES (76434, '66.54.15677392705154799', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=11111111111&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:51', 17, 1001003001, '验证码已过期', '2019-09-06 11:07:51');
INSERT INTO `access_log` VALUES (76435, '66.53.15677392742354769', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=11111111111', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:07:54', 110, 0, '', '2019-09-06 11:07:54');
INSERT INTO `access_log` VALUES (76436, '59.80.15677392972767409', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:08:17', 2, 0, '', '2019-09-06 11:08:17');
INSERT INTO `access_log` VALUES (76437, '59.79.15677392972767443', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 11:08:17', 9, 2001001000, '服务端发生异常', '2019-09-06 11:08:17');
INSERT INTO `access_log` VALUES (76438, '59.73.15677411921487463', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:39:52', 10, 0, '', '2019-09-06 11:39:52');
INSERT INTO `access_log` VALUES (76439, '59.80.15677411921517435', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:39:52', 15, 2001001000, '服务端发生异常', '2019-09-06 11:39:52');
INSERT INTO `access_log` VALUES (76440, '64.84.15677411989097915', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.22.27.195', '2019-09-06 11:39:59', 11, 0, '', '2019-09-06 11:39:59');
INSERT INTO `access_log` VALUES (76441, '64.85.15677411990587937', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.22.27.195', '2019-09-06 11:39:59', 2, 0, '', '2019-09-06 11:39:59');
INSERT INTO `access_log` VALUES (76442, '66.57.15677412021494805', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.22.27.195', '2019-09-06 11:40:02', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机验证码不能为空\n账号长度为 11 位\n手机号不能为空', '2019-09-06 11:40:02');
INSERT INTO `access_log` VALUES (76443, '66.56.15677412100554823', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=12345678911', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.22.27.195', '2019-09-06 11:40:10', 85, 0, '', '2019-09-06 11:40:10');
INSERT INTO `access_log` VALUES (76444, '66.51.15677412174864827', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678911&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.22.27.195', '2019-09-06 11:40:17', 1346, 0, '', '2019-09-06 11:40:19');
INSERT INTO `access_log` VALUES (76445, '64.80.15677412276297915', 153, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.22.27.195', '2019-09-06 11:40:28', 5, 0, '', '2019-09-06 11:40:28');
INSERT INTO `access_log` VALUES (76446, '64.81.15677412277817921', 153, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.22.27.195', '2019-09-06 11:40:28', 5, 0, '', '2019-09-06 11:40:28');
INSERT INTO `access_log` VALUES (76447, '64.78.15677412287967939', 153, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.22.27.195', '2019-09-06 11:40:29', 5, 0, '', '2019-09-06 11:40:29');
INSERT INTO `access_log` VALUES (76448, 'N/A', 153, 1, 'search-application', '/search-api/users/product/page', 'cid=783&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.22.27.195', '2019-09-06 11:40:29', 12, 0, '', '2019-09-06 11:40:29');
INSERT INTO `access_log` VALUES (76449, '64.84.15677412309677917', 153, 1, 'product-application', '/product-api/users/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.22.27.195', '2019-09-06 11:40:31', 12, 0, '', '2019-09-06 11:40:31');
INSERT INTO `access_log` VALUES (76450, '66.49.15677412340564813', 153, 1, 'user-application', '/user-api/users/address/default_address', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '210.22.27.195', '2019-09-06 11:40:34', 6, 0, '', '2019-09-06 11:40:34');
INSERT INTO `access_log` VALUES (76451, '65.47.15677412540621043', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:40:54', 0, 1002001015, '账号未登陆', '2019-09-06 11:40:54');
INSERT INTO `access_log` VALUES (76452, '65.51.15677412540631135', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:40:54', 0, 1002001015, '账号未登陆', '2019-09-06 11:40:54');
INSERT INTO `access_log` VALUES (76453, '65.53.15677412540631041', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:40:54', 0, 1002001015, '账号未登陆', '2019-09-06 11:40:54');
INSERT INTO `access_log` VALUES (76454, '65.46.15677412578791125', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:40:58', 15, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 11:40:58');
INSERT INTO `access_log` VALUES (76455, '65.50.15677412636691089', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:41:04', 60, 0, '', '2019-09-06 11:41:04');
INSERT INTO `access_log` VALUES (76456, '65.45.15677412639511139', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:41:04', 10, 0, '', '2019-09-06 11:41:04');
INSERT INTO `access_log` VALUES (76457, '65.3607.15677412639522893', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:41:04', 10, 0, '', '2019-09-06 11:41:04');
INSERT INTO `access_log` VALUES (76458, '65.52.15677412639511161', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:41:04', 12, 2001001000, '服务端发生异常', '2019-09-06 11:41:04');
INSERT INTO `access_log` VALUES (76459, '65.47.15677412905911045', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:41:31', 10, 0, '', '2019-09-06 11:41:31');
INSERT INTO `access_log` VALUES (76460, '65.51.15677412905941137', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:41:31', 11, 2001001000, '服务端发生异常', '2019-09-06 11:41:31');
INSERT INTO `access_log` VALUES (76461, '65.53.15677412906201043', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:41:31', 8, 0, '', '2019-09-06 11:41:31');
INSERT INTO `access_log` VALUES (76462, '65.46.15677412931411127', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:41:33', 15, 0, '', '2019-09-06 11:41:33');
INSERT INTO `access_log` VALUES (76463, '65.52.15677412931501163', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:41:33', 8, 0, '', '2019-09-06 11:41:33');
INSERT INTO `access_log` VALUES (76464, '65.50.15677412931501091', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '210.22.27.195', '2019-09-06 11:41:33', 8, 2001001000, '服务端发生异常', '2019-09-06 11:41:33');
INSERT INTO `access_log` VALUES (76465, '59.75.15677421738157483', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.144.222.3', '2019-09-06 11:56:14', 4, 0, '', '2019-09-06 11:56:14');
INSERT INTO `access_log` VALUES (76466, '59.72.15677421738167477', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.144.222.3', '2019-09-06 11:56:14', 13, 2001001000, '服务端发生异常', '2019-09-06 11:56:14');
INSERT INTO `access_log` VALUES (76467, '64.80.15677421887537929', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.144.222.3', '2019-09-06 11:56:29', 2, 0, '', '2019-09-06 11:56:29');
INSERT INTO `access_log` VALUES (76468, '64.77.15677421888847905', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.144.222.3', '2019-09-06 11:56:29', 2, 0, '', '2019-09-06 11:56:29');
INSERT INTO `access_log` VALUES (76469, '64.81.15677421902247935', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.144.222.3', '2019-09-06 11:56:30', 2, 0, '', '2019-09-06 11:56:30');
INSERT INTO `access_log` VALUES (76470, '64.78.15677421909257953', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.144.222.3', '2019-09-06 11:56:31', 2, 0, '', '2019-09-06 11:56:31');
INSERT INTO `access_log` VALUES (76471, '59.73.15677421939597477', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.144.222.3', '2019-09-06 11:56:34', 2, 0, '', '2019-09-06 11:56:34');
INSERT INTO `access_log` VALUES (76472, '59.80.15677421939627449', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '219.144.222.3', '2019-09-06 11:56:34', 20, 2001001000, '服务端发生异常', '2019-09-06 11:56:34');
INSERT INTO `access_log` VALUES (76473, '65.49.15677422292941129', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '219.144.222.3', '2019-09-06 11:57:09', 0, 1002001015, '账号未登陆', '2019-09-06 11:57:09');
INSERT INTO `access_log` VALUES (76474, '65.51.15677422292991151', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '219.144.222.3', '2019-09-06 11:57:09', 0, 1002001015, '账号未登陆', '2019-09-06 11:57:09');
INSERT INTO `access_log` VALUES (76475, '65.47.15677422293061059', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '219.144.222.3', '2019-09-06 11:57:09', 1, 1002001015, '账号未登陆', '2019-09-06 11:57:09');
INSERT INTO `access_log` VALUES (76476, '65.53.15677422357191057', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '219.144.222.3', '2019-09-06 11:57:16', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 11:57:16');
INSERT INTO `access_log` VALUES (76477, '65.50.15677422399431105', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '219.144.222.3', '2019-09-06 11:57:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 11:57:20');
INSERT INTO `access_log` VALUES (76478, '65.52.15677422415181177', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '219.144.222.3', '2019-09-06 11:57:22', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 11:57:22');
INSERT INTO `access_log` VALUES (76479, '65.3607.15677422441382909', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '219.144.222.3', '2019-09-06 11:57:24', 4, 1002002001, '密码不正确', '2019-09-06 11:57:24');
INSERT INTO `access_log` VALUES (76480, '65.54.15677422609930995', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '219.144.222.3', '2019-09-06 11:57:41', 168, 0, '', '2019-09-06 11:57:41');
INSERT INTO `access_log` VALUES (76481, '65.49.15677422615641131', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '219.144.222.3', '2019-09-06 11:57:42', 109, 0, '', '2019-09-06 11:57:42');
INSERT INTO `access_log` VALUES (76482, '65.47.15677422615741061', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '219.144.222.3', '2019-09-06 11:57:42', 102, 0, '', '2019-09-06 11:57:42');
INSERT INTO `access_log` VALUES (76483, '65.51.15677422615701153', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '219.144.222.3', '2019-09-06 11:57:42', 107, 2001001000, '服务端发生异常', '2019-09-06 11:57:42');
INSERT INTO `access_log` VALUES (76484, '65.45.15677472979791223', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.67', '2019-09-06 13:21:38', 1, 1002001015, '账号未登陆', '2019-09-06 13:21:38');
INSERT INTO `access_log` VALUES (76485, '65.54.15677472979801063', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.3', '2019-09-06 13:21:38', 1, 1002001015, '账号未登陆', '2019-09-06 13:21:38');
INSERT INTO `access_log` VALUES (76486, '65.51.15677472980381221', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.3', '2019-09-06 13:21:38', 1, 1002001015, '账号未登陆', '2019-09-06 13:21:38');
INSERT INTO `access_log` VALUES (76487, '65.45.15677514682491279', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.72.8.155', '2019-09-06 14:31:08', 1, 1002001015, '账号未登陆', '2019-09-06 14:31:08');
INSERT INTO `access_log` VALUES (76488, '65.54.15677514682511119', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.72.8.155', '2019-09-06 14:31:08', 1, 1002001015, '账号未登陆', '2019-09-06 14:31:08');
INSERT INTO `access_log` VALUES (76489, '65.49.15677514682521255', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.72.8.155', '2019-09-06 14:31:08', 0, 1002001015, '账号未登陆', '2019-09-06 14:31:08');
INSERT INTO `access_log` VALUES (76490, '65.53.15677514770721183', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.72.8.155', '2019-09-06 14:31:17', 109, 0, '', '2019-09-06 14:31:17');
INSERT INTO `access_log` VALUES (76491, '65.50.15677514773921231', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.72.8.155', '2019-09-06 14:31:17', 71, 0, '', '2019-09-06 14:31:17');
INSERT INTO `access_log` VALUES (76492, '65.46.15677514773921267', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.72.8.155', '2019-09-06 14:31:17', 71, 0, '', '2019-09-06 14:31:17');
INSERT INTO `access_log` VALUES (76493, '65.52.15677514773921303', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.72.8.155', '2019-09-06 14:31:17', 72, 2001001000, '服务端发生异常', '2019-09-06 14:31:17');
INSERT INTO `access_log` VALUES (76494, '65.51.15677514906951279', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.72.8.155', '2019-09-06 14:31:31', 10, 0, '', '2019-09-06 14:31:31');
INSERT INTO `access_log` VALUES (76495, '65.54.15677514907061121', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.72.8.155', '2019-09-06 14:31:31', 9, 0, '', '2019-09-06 14:31:31');
INSERT INTO `access_log` VALUES (76496, '65.49.15677514907061257', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '218.72.8.155', '2019-09-06 14:31:31', 8, 2001001000, '服务端发生异常', '2019-09-06 14:31:31');
INSERT INTO `access_log` VALUES (76497, '65.50.15677519022171237', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:38:22', 1, 1002001015, '账号未登陆', '2019-09-06 14:38:22');
INSERT INTO `access_log` VALUES (76498, '65.3607.15677519022183043', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:38:22', 0, 1002001015, '账号未登陆', '2019-09-06 14:38:22');
INSERT INTO `access_log` VALUES (76499, '65.49.15677519022261263', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:38:22', 1, 1002001015, '账号未登陆', '2019-09-06 14:38:22');
INSERT INTO `access_log` VALUES (76500, '65.54.15677519069251129', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:38:27', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 14:38:27');
INSERT INTO `access_log` VALUES (76501, '65.45.15677519087731287', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:38:29', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 14:38:29');
INSERT INTO `access_log` VALUES (76502, '65.47.15677519182121193', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:38:38', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 14:38:38');
INSERT INTO `access_log` VALUES (76503, '65.52.15677519282621313', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:38:48', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 14:38:48');
INSERT INTO `access_log` VALUES (76504, '65.46.15677519290401275', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:38:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 14:38:49');
INSERT INTO `access_log` VALUES (76505, '65.49.15677519294181265', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:38:49', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 14:38:49');
INSERT INTO `access_log` VALUES (76506, '65.3607.15677519297663045', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:38:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 14:38:50');
INSERT INTO `access_log` VALUES (76507, '65.50.15677519302861239', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:38:50', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 14:38:50');
INSERT INTO `access_log` VALUES (76508, '65.54.15677519460741131', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:39:06', 55, 0, '', '2019-09-06 14:39:06');
INSERT INTO `access_log` VALUES (76509, '65.45.15677519465321289', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:39:07', 9, 0, '', '2019-09-06 14:39:07');
INSERT INTO `access_log` VALUES (76510, '65.53.15677519465361195', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:39:07', 8, 0, '', '2019-09-06 14:39:07');
INSERT INTO `access_log` VALUES (76511, '65.47.15677519465351195', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:39:07', 8, 2001001000, '服务端发生异常', '2019-09-06 14:39:07');
INSERT INTO `access_log` VALUES (76512, '65.3607.15677519873653047', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:39:47', 42, 0, '', '2019-09-06 14:39:47');
INSERT INTO `access_log` VALUES (76513, '65.51.15677519873811291', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:39:47', 27, 0, '', '2019-09-06 14:39:47');
INSERT INTO `access_log` VALUES (76514, '65.50.15677519873771241', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:39:47', 32, 2001001000, '服务端发生异常', '2019-09-06 14:39:47');
INSERT INTO `access_log` VALUES (76515, '65.50.15677521060951243', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:41:46', 1, 1002001015, '账号未登陆', '2019-09-06 14:41:46');
INSERT INTO `access_log` VALUES (76516, '65.3607.15677521060963049', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:41:46', 0, 1002001015, '账号未登陆', '2019-09-06 14:41:46');
INSERT INTO `access_log` VALUES (76517, '65.54.15677521060971135', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:41:46', 0, 1002001015, '账号未登陆', '2019-09-06 14:41:46');
INSERT INTO `access_log` VALUES (76518, '65.53.15677521122251199', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:41:52', 89, 0, '', '2019-09-06 14:41:52');
INSERT INTO `access_log` VALUES (76519, '65.47.15677521125151199', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:41:53', 18, 0, '', '2019-09-06 14:41:53');
INSERT INTO `access_log` VALUES (76520, '65.45.15677521125171293', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:41:53', 17, 2001001000, '服务端发生异常', '2019-09-06 14:41:53');
INSERT INTO `access_log` VALUES (76521, '65.52.15677521125271319', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:41:53', 8, 0, '', '2019-09-06 14:41:53');
INSERT INTO `access_log` VALUES (76522, '65.49.15677521274331271', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:42:07', 9, 0, '', '2019-09-06 14:42:07');
INSERT INTO `access_log` VALUES (76523, '65.51.15677521274361295', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:42:07', 10, 2001001000, '服务端发生异常', '2019-09-06 14:42:07');
INSERT INTO `access_log` VALUES (76524, '65.50.15677521274391245', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:42:07', 9, 0, '', '2019-09-06 14:42:07');
INSERT INTO `access_log` VALUES (76525, '65.54.15677521357041137', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:42:16', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 14:42:16');
INSERT INTO `access_log` VALUES (76526, '65.53.15677521414731201', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:42:21', 86, 0, '', '2019-09-06 14:42:22');
INSERT INTO `access_log` VALUES (76527, '65.45.15677521417101295', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:42:22', 8, 0, '', '2019-09-06 14:42:22');
INSERT INTO `access_log` VALUES (76528, '65.52.15677521417131321', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:42:22', 9, 0, '', '2019-09-06 14:42:22');
INSERT INTO `access_log` VALUES (76529, '65.47.15677521417131201', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:42:22', 9, 0, '', '2019-09-06 14:42:22');
INSERT INTO `access_log` VALUES (76530, '62.87.15677521533616085', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:42:33', 26, 0, '', '2019-09-06 14:42:33');
INSERT INTO `access_log` VALUES (76531, '62.82.15677521670306085', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:42:47', 13, 0, '', '2019-09-06 14:42:47');
INSERT INTO `access_log` VALUES (76532, '59.72.15677521821957611', 1, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.242.237.192', '2019-09-06 14:43:02', 26, 2001001000, '服务端发生异常', '2019-09-06 14:43:02');
INSERT INTO `access_log` VALUES (76533, '59.79.15677521999057617', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:43:20', 11, 0, '', '2019-09-06 14:43:20');
INSERT INTO `access_log` VALUES (76534, '59.80.15677521999067583', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:43:20', 16, 2001001000, '服务端发生异常', '2019-09-06 14:43:20');
INSERT INTO `access_log` VALUES (76535, '59.71.15677522004387611', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.144.123.126', '2019-09-06 14:43:20', 2, 0, '', '2019-09-06 14:43:20');
INSERT INTO `access_log` VALUES (76536, '59.77.15677522004377603', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.144.123.126', '2019-09-06 14:43:20', 20, 2001001000, '服务端发生异常', '2019-09-06 14:43:20');
INSERT INTO `access_log` VALUES (76537, '64.81.15677522049518069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.144.123.126', '2019-09-06 14:43:25', 11, 0, '', '2019-09-06 14:43:25');
INSERT INTO `access_log` VALUES (76538, '64.78.15677522050618087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.144.123.126', '2019-09-06 14:43:25', 3, 0, '', '2019-09-06 14:43:25');
INSERT INTO `access_log` VALUES (76539, '64.84.15677522183708065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.144.123.126', '2019-09-06 14:43:38', 2, 0, '', '2019-09-06 14:43:38');
INSERT INTO `access_log` VALUES (76540, '64.85.15677522184818087', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.144.123.126', '2019-09-06 14:43:38', 2, 0, '', '2019-09-06 14:43:38');
INSERT INTO `access_log` VALUES (76541, '59.78.15677522197787625', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.144.123.126', '2019-09-06 14:43:40', 2, 0, '', '2019-09-06 14:43:40');
INSERT INTO `access_log` VALUES (76542, '59.75.15677522197847619', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.144.123.126', '2019-09-06 14:43:40', 10, 2001001000, '服务端发生异常', '2019-09-06 14:43:40');
INSERT INTO `access_log` VALUES (76543, '64.83.15677522224128059', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.144.123.126', '2019-09-06 14:43:42', 2, 0, '', '2019-09-06 14:43:42');
INSERT INTO `access_log` VALUES (76544, '64.76.15677522225298071', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.144.123.126', '2019-09-06 14:43:43', 2, 0, '', '2019-09-06 14:43:43');
INSERT INTO `access_log` VALUES (76545, '64.79.15677522240538067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.144.123.126', '2019-09-06 14:43:44', 2, 0, '', '2019-09-06 14:43:44');
INSERT INTO `access_log` VALUES (76546, '64.80.15677522246218065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.144.123.126', '2019-09-06 14:43:45', 2, 0, '', '2019-09-06 14:43:45');
INSERT INTO `access_log` VALUES (76547, '64.77.15677522250578041', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '117.144.123.126', '2019-09-06 14:43:45', 2, 0, '', '2019-09-06 14:43:45');
INSERT INTO `access_log` VALUES (76548, '64.78.15677522322538089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.144.123.126', '2019-09-06 14:43:52', 2, 0, '', '2019-09-06 14:43:52');
INSERT INTO `access_log` VALUES (76549, '64.82.15677522323638079', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.144.123.126', '2019-09-06 14:43:52', 2, 0, '', '2019-09-06 14:43:52');
INSERT INTO `access_log` VALUES (76550, '59.73.15677522336707613', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.144.123.126', '2019-09-06 14:43:54', 2, 0, '', '2019-09-06 14:43:54');
INSERT INTO `access_log` VALUES (76551, '59.74.15677522336697629', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.144.123.126', '2019-09-06 14:43:54', 9, 2001001000, '服务端发生异常', '2019-09-06 14:43:54');
INSERT INTO `access_log` VALUES (76552, '64.84.15677522346858067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.144.123.126', '2019-09-06 14:43:55', 1, 0, '', '2019-09-06 14:43:55');
INSERT INTO `access_log` VALUES (76553, '64.85.15677522347648089', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.144.123.126', '2019-09-06 14:43:55', 2, 0, '', '2019-09-06 14:43:55');
INSERT INTO `access_log` VALUES (76554, '59.79.15677522365457619', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.144.123.126', '2019-09-06 14:43:57', 2, 0, '', '2019-09-06 14:43:57');
INSERT INTO `access_log` VALUES (76555, '59.80.15677522365477585', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.144.123.126', '2019-09-06 14:43:57', 15, 2001001000, '服务端发生异常', '2019-09-06 14:43:57');
INSERT INTO `access_log` VALUES (76556, '64.81.15677524627388077', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:47:43', 3, 0, '', '2019-09-06 14:47:43');
INSERT INTO `access_log` VALUES (76557, '64.77.15677524629328047', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:47:43', 2, 0, '', '2019-09-06 14:47:43');
INSERT INTO `access_log` VALUES (76558, '64.78.15677524638228095', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:47:44', 2, 0, '', '2019-09-06 14:47:44');
INSERT INTO `access_log` VALUES (76559, '64.83.15677524641578065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '119.129.115.200', '2019-09-06 14:47:44', 2, 0, '', '2019-09-06 14:47:44');
INSERT INTO `access_log` VALUES (76560, '59.76.15677534719697619', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '58.248.229.145', '2019-09-06 15:04:32', 3, 0, '', '2019-09-06 15:04:32');
INSERT INTO `access_log` VALUES (76561, '59.78.15677534719697643', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36', '58.248.229.145', '2019-09-06 15:04:32', 13, 2001001000, '服务端发生异常', '2019-09-06 15:04:32');
INSERT INTO `access_log` VALUES (76562, '65.45.15677537236431317', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.168.186.65', '2019-09-06 15:08:44', 0, 1002001015, '账号未登陆', '2019-09-06 15:08:44');
INSERT INTO `access_log` VALUES (76563, '65.53.15677537236431223', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.168.186.65', '2019-09-06 15:08:44', 1, 1002001015, '账号未登陆', '2019-09-06 15:08:44');
INSERT INTO `access_log` VALUES (76564, '65.52.15677537236441343', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.168.186.65', '2019-09-06 15:08:44', 1, 1002001015, '账号未登陆', '2019-09-06 15:08:44');
INSERT INTO `access_log` VALUES (76565, '65.47.15677537261741223', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.168.186.65', '2019-09-06 15:08:46', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 15:08:46');
INSERT INTO `access_log` VALUES (76566, '65.51.15677537354531319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=adminyudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.168.186.65', '2019-09-06 15:08:55', 98, 1002002000, '账号不存在', '2019-09-06 15:08:56');
INSERT INTO `access_log` VALUES (76567, '65.49.15677537566041295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.168.186.65', '2019-09-06 15:09:17', 91, 0, '', '2019-09-06 15:09:17');
INSERT INTO `access_log` VALUES (76568, '65.3607.15677537569283075', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.168.186.65', '2019-09-06 15:09:17', 17, 0, '', '2019-09-06 15:09:17');
INSERT INTO `access_log` VALUES (76569, '65.54.15677537569281161', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.168.186.65', '2019-09-06 15:09:17', 18, 2001001000, '服务端发生异常', '2019-09-06 15:09:17');
INSERT INTO `access_log` VALUES (76570, '65.45.15677537569471319', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.168.186.65', '2019-09-06 15:09:17', 8, 0, '', '2019-09-06 15:09:17');
INSERT INTO `access_log` VALUES (76571, '65.52.15677537717851345', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.168.186.65', '2019-09-06 15:09:32', 34, 0, '', '2019-09-06 15:09:32');
INSERT INTO `access_log` VALUES (76572, '65.46.15677537717901307', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.168.186.65', '2019-09-06 15:09:32', 32, 0, '', '2019-09-06 15:09:32');
INSERT INTO `access_log` VALUES (76573, '65.47.15677537717861225', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.168.186.65', '2019-09-06 15:09:32', 36, 2001001000, '服务端发生异常', '2019-09-06 15:09:32');
INSERT INTO `access_log` VALUES (76574, '65.3607.15677548934043091', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.3', '2019-09-06 15:28:13', 0, 1002001015, '账号未登陆', '2019-09-06 15:28:13');
INSERT INTO `access_log` VALUES (76575, '65.53.15677548934231241', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.67', '2019-09-06 15:28:13', 0, 1002001015, '账号未登陆', '2019-09-06 15:28:13');
INSERT INTO `access_log` VALUES (76576, '65.52.15677548934331361', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.67', '2019-09-06 15:28:13', 1, 1002001015, '账号未登陆', '2019-09-06 15:28:13');
INSERT INTO `access_log` VALUES (76577, '65.46.15677552025691327', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-06 15:33:23', 0, 1002001015, '账号未登陆', '2019-09-06 15:33:23');
INSERT INTO `access_log` VALUES (76578, '65.47.15677552025721245', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-06 15:33:23', 0, 1002001015, '账号未登陆', '2019-09-06 15:33:23');
INSERT INTO `access_log` VALUES (76579, '65.51.15677552025731341', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-06 15:33:23', 1, 1002001015, '账号未登陆', '2019-09-06 15:33:23');
INSERT INTO `access_log` VALUES (76580, '65.49.15677552086901317', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-06 15:33:29', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 15:33:29');
INSERT INTO `access_log` VALUES (76581, '65.45.15677552251321341', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-06 15:33:45', 172, 0, '', '2019-09-06 15:33:45');
INSERT INTO `access_log` VALUES (76582, '65.3607.15677552256303097', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-06 15:33:46', 17, 0, '', '2019-09-06 15:33:46');
INSERT INTO `access_log` VALUES (76583, '65.53.15677552256401247', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-06 15:33:46', 8, 0, '', '2019-09-06 15:33:46');
INSERT INTO `access_log` VALUES (76584, '65.52.15677552256311367', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '106.11.34.18', '2019-09-06 15:33:46', 11, 2001001000, '服务端发生异常', '2019-09-06 15:33:46');
INSERT INTO `access_log` VALUES (76585, '65.54.15677563383221199', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-09-06 15:52:18', 0, 1002001015, '账号未登陆', '2019-09-06 15:52:18');
INSERT INTO `access_log` VALUES (76586, '65.45.15677563383231357', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-09-06 15:52:18', 1, 1002001015, '账号未登陆', '2019-09-06 15:52:18');
INSERT INTO `access_log` VALUES (76587, '65.49.15677563383221333', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-09-06 15:52:18', 0, 1002001015, '账号未登陆', '2019-09-06 15:52:18');
INSERT INTO `access_log` VALUES (76588, '65.53.15677563461851263', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-09-06 15:52:26', 136, 0, '', '2019-09-06 15:52:26');
INSERT INTO `access_log` VALUES (76589, '65.47.15677563465481263', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-09-06 15:52:27', 9, 0, '', '2019-09-06 15:52:27');
INSERT INTO `access_log` VALUES (76590, '65.46.15677563465491345', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-09-06 15:52:27', 10, 0, '', '2019-09-06 15:52:27');
INSERT INTO `access_log` VALUES (76591, '65.52.15677563465481383', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-09-06 15:52:27', 10, 2001001000, '服务端发生异常', '2019-09-06 15:52:27');
INSERT INTO `access_log` VALUES (76592, '65.51.15677563524161359', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-09-06 15:52:32', 8, 0, '', '2019-09-06 15:52:32');
INSERT INTO `access_log` VALUES (76593, '65.50.15677563524201309', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-09-06 15:52:32', 10, 2001001000, '服务端发生异常', '2019-09-06 15:52:32');
INSERT INTO `access_log` VALUES (76594, '65.45.15677563524221359', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '112.26.142.150', '2019-09-06 15:52:32', 16, 0, '', '2019-09-06 15:52:32');
INSERT INTO `access_log` VALUES (76595, '59.80.15677565246587643', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.167.101.22', '2019-09-06 15:55:25', 10, 2001001000, '服务端发生异常', '2019-09-06 15:55:25');
INSERT INTO `access_log` VALUES (76596, '59.79.15677565246587677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.167.101.22', '2019-09-06 15:55:25', 37, 0, '', '2019-09-06 15:55:25');
INSERT INTO `access_log` VALUES (76597, '65.49.15677569396171343', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.36.146.170', '2019-09-06 16:02:20', 0, 1002001015, '账号未登陆', '2019-09-06 16:02:20');
INSERT INTO `access_log` VALUES (76598, '65.45.15677569396161367', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.36.146.170', '2019-09-06 16:02:20', 0, 1002001015, '账号未登陆', '2019-09-06 16:02:20');
INSERT INTO `access_log` VALUES (76599, '65.54.15677569396241209', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.36.146.170', '2019-09-06 16:02:20', 0, 1002001015, '账号未登陆', '2019-09-06 16:02:20');
INSERT INTO `access_log` VALUES (76600, '65.53.15677569504451273', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.36.146.170', '2019-09-06 16:02:30', 63, 0, '', '2019-09-06 16:02:31');
INSERT INTO `access_log` VALUES (76601, '65.46.15677569508561355', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.36.146.170', '2019-09-06 16:02:31', 10, 0, '', '2019-09-06 16:02:31');
INSERT INTO `access_log` VALUES (76602, '65.47.15677569508651273', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.36.146.170', '2019-09-06 16:02:31', 9, 2001001000, '服务端发生异常', '2019-09-06 16:02:31');
INSERT INTO `access_log` VALUES (76603, '65.52.15677569508741393', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.36.146.170', '2019-09-06 16:02:31', 8, 0, '', '2019-09-06 16:02:31');
INSERT INTO `access_log` VALUES (76604, '65.50.15677569591631319', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.36.146.170', '2019-09-06 16:02:39', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 16:02:39');
INSERT INTO `access_log` VALUES (76605, '65.49.15677569695061345', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.36.146.170', '2019-09-06 16:02:50', 73, 0, '', '2019-09-06 16:02:50');
INSERT INTO `access_log` VALUES (76606, '65.45.15677569697961369', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.36.146.170', '2019-09-06 16:02:50', 9, 0, '', '2019-09-06 16:02:50');
INSERT INTO `access_log` VALUES (76607, '65.54.15677569698131211', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.36.146.170', '2019-09-06 16:02:50', 10, 2001001000, '服务端发生异常', '2019-09-06 16:02:50');
INSERT INTO `access_log` VALUES (76608, '65.3607.15677569698203125', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.36.146.170', '2019-09-06 16:02:50', 8, 0, '', '2019-09-06 16:02:50');
INSERT INTO `access_log` VALUES (76609, '59.71.15677569830537677', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.36.146.170', '2019-09-06 16:03:03', 4, 0, '', '2019-09-06 16:03:03');
INSERT INTO `access_log` VALUES (76610, '59.77.15677569830537669', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '120.36.146.170', '2019-09-06 16:03:03', 13, 2001001000, '服务端发生异常', '2019-09-06 16:03:03');
INSERT INTO `access_log` VALUES (76611, '65.45.15677582370301387', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.96.52.164', '2019-09-06 16:23:57', 0, 1002001015, '账号未登陆', '2019-09-06 16:23:57');
INSERT INTO `access_log` VALUES (76612, '65.50.15677582370291337', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.96.52.164', '2019-09-06 16:23:57', 0, 1002001015, '账号未登陆', '2019-09-06 16:23:57');
INSERT INTO `access_log` VALUES (76613, '65.49.15677582370291363', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.96.52.164', '2019-09-06 16:23:57', 0, 1002001015, '账号未登陆', '2019-09-06 16:23:57');
INSERT INTO `access_log` VALUES (76614, '65.54.15677582396311229', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.96.52.164', '2019-09-06 16:24:00', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 16:24:00');
INSERT INTO `access_log` VALUES (76615, '65.3607.15677582488873143', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.96.52.164', '2019-09-06 16:24:09', 60, 0, '', '2019-09-06 16:24:09');
INSERT INTO `access_log` VALUES (76616, '65.46.15677582495421375', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.96.52.164', '2019-09-06 16:24:10', 9, 0, '', '2019-09-06 16:24:10');
INSERT INTO `access_log` VALUES (76617, '65.47.15677582495431293', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.96.52.164', '2019-09-06 16:24:10', 10, 2001001000, '服务端发生异常', '2019-09-06 16:24:10');
INSERT INTO `access_log` VALUES (76618, '65.52.15677582495461413', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.96.52.164', '2019-09-06 16:24:10', 9, 0, '', '2019-09-06 16:24:10');
INSERT INTO `access_log` VALUES (76619, '65.50.15677582659741339', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.96.52.164', '2019-09-06 16:24:26', 10, 2001001000, '服务端发生异常', '2019-09-06 16:24:26');
INSERT INTO `access_log` VALUES (76620, '65.45.15677582659741389', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.96.52.164', '2019-09-06 16:24:26', 11, 0, '', '2019-09-06 16:24:26');
INSERT INTO `access_log` VALUES (76621, '65.49.15677582659741365', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '119.96.52.164', '2019-09-06 16:24:26', 11, 0, '', '2019-09-06 16:24:26');
INSERT INTO `access_log` VALUES (76622, '59.76.15677594931797701', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.69.205.192', '2019-09-06 16:44:53', 16, 2001001000, '服务端发生异常', '2019-09-06 16:44:53');
INSERT INTO `access_log` VALUES (76623, '59.75.15677594931787719', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.69.205.192', '2019-09-06 16:44:53', 16, 0, '', '2019-09-06 16:44:53');
INSERT INTO `access_log` VALUES (76624, '59.76.15677596116007703', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.14.83', '2019-09-06 16:46:52', 12, 2001001000, '服务端发生异常', '2019-09-06 16:46:52');
INSERT INTO `access_log` VALUES (76625, '59.75.15677596115867721', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36', '183.62.14.83', '2019-09-06 16:46:52', 56, 0, '', '2019-09-06 16:46:52');
INSERT INTO `access_log` VALUES (76626, '65.53.15677606647261327', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:04:25', 0, 1002001015, '账号未登陆', '2019-09-06 17:04:25');
INSERT INTO `access_log` VALUES (76627, '65.54.15677606647251263', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:04:25', 1, 1002001015, '账号未登陆', '2019-09-06 17:04:25');
INSERT INTO `access_log` VALUES (76628, '65.3607.15677606647263177', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:04:25', 0, 1002001015, '账号未登陆', '2019-09-06 17:04:25');
INSERT INTO `access_log` VALUES (76629, '65.46.15677606675231409', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:04:28', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 17:04:28');
INSERT INTO `access_log` VALUES (76630, '65.47.15677606833691327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyaunma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:04:43', 5, 1002002000, '账号不存在', '2019-09-06 17:04:43');
INSERT INTO `access_log` VALUES (76631, '65.45.15677607058211423', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:05:06', 91, 0, '', '2019-09-06 17:05:06');
INSERT INTO `access_log` VALUES (76632, '65.50.15677607062941373', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:05:06', 181, 0, '', '2019-09-06 17:05:06');
INSERT INTO `access_log` VALUES (76633, '65.53.15677607062961329', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:05:06', 182, 0, '', '2019-09-06 17:05:06');
INSERT INTO `access_log` VALUES (76634, '65.49.15677607062941399', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:05:06', 183, 2001001000, '服务端发生异常', '2019-09-06 17:05:06');
INSERT INTO `access_log` VALUES (76635, '65.54.15677607191461265', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:05:19', 9, 0, '', '2019-09-06 17:05:19');
INSERT INTO `access_log` VALUES (76636, '65.46.15677607191531411', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:05:19', 18, 2001001000, '服务端发生异常', '2019-09-06 17:05:19');
INSERT INTO `access_log` VALUES (76637, '65.52.15677607191681449', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:05:19', 9, 0, '', '2019-09-06 17:05:19');
INSERT INTO `access_log` VALUES (76638, '65.45.15677607472121425', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:05:47', 8, 0, '', '2019-09-06 17:05:47');
INSERT INTO `access_log` VALUES (76639, '65.49.15677607472171401', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:05:47', 11, 2001001000, '服务端发生异常', '2019-09-06 17:05:47');
INSERT INTO `access_log` VALUES (76640, '65.53.15677607472321331', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:05:47', 8, 0, '', '2019-09-06 17:05:47');
INSERT INTO `access_log` VALUES (76641, '65.54.15677607747091267', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:06:15', 9, 0, '', '2019-09-06 17:06:15');
INSERT INTO `access_log` VALUES (76642, '65.52.15677607747161451', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:06:15', 9, 2001001000, '服务端发生异常', '2019-09-06 17:06:15');
INSERT INTO `access_log` VALUES (76643, '65.46.15677607747341413', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:06:15', 9, 0, '', '2019-09-06 17:06:15');
INSERT INTO `access_log` VALUES (76644, '65.47.15677607806651331', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:06:21', 7, 0, '', '2019-09-06 17:06:21');
INSERT INTO `access_log` VALUES (76645, '65.51.15677607806701427', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:06:21', 8, 2001001000, '服务端发生异常', '2019-09-06 17:06:21');
INSERT INTO `access_log` VALUES (76646, '65.45.15677607806761427', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:06:21', 7, 0, '', '2019-09-06 17:06:21');
INSERT INTO `access_log` VALUES (76647, '65.53.15677607932831333', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:06:33', 9, 0, '', '2019-09-06 17:06:33');
INSERT INTO `access_log` VALUES (76648, '65.50.15677607932911377', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:06:33', 10, 2001001000, '服务端发生异常', '2019-09-06 17:06:33');
INSERT INTO `access_log` VALUES (76649, '65.3607.15677607932963183', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:68.0) Gecko/20100101 Firefox/68.0', '180.168.46.230', '2019-09-06 17:06:33', 8, 0, '', '2019-09-06 17:06:33');
INSERT INTO `access_log` VALUES (76650, '59.76.15677621474777737', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-06 17:29:07', 12, 0, '', '2019-09-06 17:29:07');
INSERT INTO `access_log` VALUES (76651, '59.73.15677621474787747', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.224.217.58', '2019-09-06 17:29:07', 17, 2001001000, '服务端发生异常', '2019-09-06 17:29:07');
INSERT INTO `access_log` VALUES (76652, '66.52.15677635963925109', 0, 2, 'user-application', '/user-api/admins/user/page', 'pageSize=10&nickname=小王&pageNo=1&status=', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.83.241.126', '2019-09-06 17:53:16', 0, 1002001015, '账号未登陆', '2019-09-06 17:53:16');
INSERT INTO `access_log` VALUES (76653, '65.49.15677664831621479', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.175.169.59', '2019-09-06 18:41:23', 0, 1002001015, '账号未登陆', '2019-09-06 18:41:23');
INSERT INTO `access_log` VALUES (76654, '65.45.15677664831611505', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.175.169.59', '2019-09-06 18:41:23', 0, 1002001015, '账号未登陆', '2019-09-06 18:41:23');
INSERT INTO `access_log` VALUES (76655, '65.51.15677664831611505', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.175.169.59', '2019-09-06 18:41:23', 0, 1002001015, '账号未登陆', '2019-09-06 18:41:23');
INSERT INTO `access_log` VALUES (76656, '65.54.15677668435021349', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.175.169.59', '2019-09-06 18:47:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 18:47:24');
INSERT INTO `access_log` VALUES (76657, '65.46.15677668438331497', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.175.169.59', '2019-09-06 18:47:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 18:47:24');
INSERT INTO `access_log` VALUES (76658, '65.45.15677668465071511', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.175.169.59', '2019-09-06 18:47:27', 52, 0, '', '2019-09-06 18:47:27');
INSERT INTO `access_log` VALUES (76659, '65.49.15677668468101485', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.175.169.59', '2019-09-06 18:47:27', 13, 0, '', '2019-09-06 18:47:27');
INSERT INTO `access_log` VALUES (76660, '65.51.15677668468101511', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.175.169.59', '2019-09-06 18:47:27', 14, 2001001000, '服务端发生异常', '2019-09-06 18:47:27');
INSERT INTO `access_log` VALUES (76661, '65.53.15677668468121417', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '117.175.169.59', '2019-09-06 18:47:27', 11, 0, '', '2019-09-06 18:47:27');
INSERT INTO `access_log` VALUES (76662, '65.3607.15677690798953297', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2843.400', '180.109.228.135', '2019-09-06 19:24:40', 0, 1002001015, '账号未登陆', '2019-09-06 19:24:40');
INSERT INTO `access_log` VALUES (76663, '65.51.15677690798951541', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2843.400', '180.109.228.135', '2019-09-06 19:24:40', 0, 1002001015, '账号未登陆', '2019-09-06 19:24:40');
INSERT INTO `access_log` VALUES (76664, '65.50.15677690799001491', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2843.400', '180.109.228.135', '2019-09-06 19:24:40', 1, 1002001015, '账号未登陆', '2019-09-06 19:24:40');
INSERT INTO `access_log` VALUES (76665, '65.45.15677691436421543', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2843.400', '180.109.228.135', '2019-09-06 19:25:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 19:25:44');
INSERT INTO `access_log` VALUES (76666, '65.49.15677691672511517', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2843.400', '180.109.228.135', '2019-09-06 19:26:07', 82, 0, '', '2019-09-06 19:26:07');
INSERT INTO `access_log` VALUES (76667, '65.51.15677691676461543', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2843.400', '180.109.228.135', '2019-09-06 19:26:08', 19, 0, '', '2019-09-06 19:26:08');
INSERT INTO `access_log` VALUES (76668, '65.50.15677691676501493', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2843.400', '180.109.228.135', '2019-09-06 19:26:08', 18, 2001001000, '服务端发生异常', '2019-09-06 19:26:08');
INSERT INTO `access_log` VALUES (76669, '65.3607.15677691676703299', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.26 Safari/537.36 Core/1.63.6788.400 QQBrowser/10.3.2843.400', '180.109.228.135', '2019-09-06 19:26:08', 8, 0, '', '2019-09-06 19:26:08');
INSERT INTO `access_log` VALUES (76670, '59.76.15677707416477853', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:22', 8, 0, '', '2019-09-06 19:52:22');
INSERT INTO `access_log` VALUES (76671, '59.73.15677707416487863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:22', 15, 2001001000, '服务端发生异常', '2019-09-06 19:52:22');
INSERT INTO `access_log` VALUES (76672, '64.82.15677707469618327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:27', 12, 0, '', '2019-09-06 19:52:27');
INSERT INTO `access_log` VALUES (76673, '64.85.15677707470558339', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:27', 3, 0, '', '2019-09-06 19:52:27');
INSERT INTO `access_log` VALUES (76674, '64.84.15677707484298313', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:28', 1, 0, '', '2019-09-06 19:52:28');
INSERT INTO `access_log` VALUES (76675, '64.79.15677707490118317', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:29', 2, 0, '', '2019-09-06 19:52:29');
INSERT INTO `access_log` VALUES (76676, '59.72.15677707524747865', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:32', 3, 0, '', '2019-09-06 19:52:32');
INSERT INTO `access_log` VALUES (76677, '59.74.15677707524747877', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:32', 16, 2001001000, '服务端发生异常', '2019-09-06 19:52:32');
INSERT INTO `access_log` VALUES (76678, '65.51.15677707592051565', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:39', 0, 1002001015, '账号未登陆', '2019-09-06 19:52:39');
INSERT INTO `access_log` VALUES (76679, '65.3607.15677707592063321', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:39', 0, 1002001015, '账号未登陆', '2019-09-06 19:52:39');
INSERT INTO `access_log` VALUES (76680, '65.50.15677707592151515', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:39', 0, 1002001015, '账号未登陆', '2019-09-06 19:52:39');
INSERT INTO `access_log` VALUES (76681, '65.52.15677707634021591', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:43', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-06 19:52:43');
INSERT INTO `access_log` VALUES (76682, '65.54.15677707666651405', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:47', 101, 0, '', '2019-09-06 19:52:47');
INSERT INTO `access_log` VALUES (76683, '65.46.15677707669621553', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:47', 9, 0, '', '2019-09-06 19:52:47');
INSERT INTO `access_log` VALUES (76684, '65.47.15677707669631469', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:47', 11, 2001001000, '服务端发生异常', '2019-09-06 19:52:47');
INSERT INTO `access_log` VALUES (76685, '65.45.15677707669681567', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '180.167.137.76', '2019-09-06 19:52:47', 18, 0, '', '2019-09-06 19:52:47');
INSERT INTO `access_log` VALUES (76686, '59.79.15677737422237911', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.44.79.233', '2019-09-06 20:42:22', 9, 0, '', '2019-09-06 20:42:22');
INSERT INTO `access_log` VALUES (76687, '59.71.15677737422257903', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.44.79.233', '2019-09-06 20:42:22', 15, 2001001000, '服务端发生异常', '2019-09-06 20:42:22');
INSERT INTO `access_log` VALUES (76688, '64.76.15677737505658361', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.44.79.233', '2019-09-06 20:42:31', 11, 0, '', '2019-09-06 20:42:31');
INSERT INTO `access_log` VALUES (76689, '64.80.15677737507078355', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.44.79.233', '2019-09-06 20:42:31', 4, 0, '', '2019-09-06 20:42:31');
INSERT INTO `access_log` VALUES (76690, '64.81.15677737523318363', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.44.79.233', '2019-09-06 20:42:32', 2, 0, '', '2019-09-06 20:42:32');
INSERT INTO `access_log` VALUES (76691, '64.77.15677737529158333', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.44.79.233', '2019-09-06 20:42:33', 2, 0, '', '2019-09-06 20:42:33');
INSERT INTO `access_log` VALUES (76692, '64.83.15677737626058351', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.44.79.233', '2019-09-06 20:42:43', 2, 0, '', '2019-09-06 20:42:43');
INSERT INTO `access_log` VALUES (76693, '64.82.15677737627178369', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.44.79.233', '2019-09-06 20:42:43', 2, 0, '', '2019-09-06 20:42:43');
INSERT INTO `access_log` VALUES (76694, '59.80.15677737665617877', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.44.79.233', '2019-09-06 20:42:47', 3, 0, '', '2019-09-06 20:42:47');
INSERT INTO `access_log` VALUES (76695, '59.75.15677737665677913', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '115.44.79.233', '2019-09-06 20:42:47', 12, 2001001000, '服务端发生异常', '2019-09-06 20:42:47');
INSERT INTO `access_log` VALUES (76696, '59.79.15677801485397997', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:69.0) Gecko/20100101 Firefox/69.0', '116.249.23.248', '2019-09-06 22:29:09', 9, 0, '', '2019-09-06 22:29:09');
INSERT INTO `access_log` VALUES (76697, '59.78.15677801485458005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:69.0) Gecko/20100101 Firefox/69.0', '116.249.23.248', '2019-09-06 22:29:09', 21, 2001001000, '服务端发生异常', '2019-09-06 22:29:09');
INSERT INTO `access_log` VALUES (76698, '65.50.15677801674741641', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:69.0) Gecko/20100101 Firefox/69.0', '116.249.23.248', '2019-09-06 22:29:27', 0, 1002001015, '账号未登陆', '2019-09-06 22:29:27');
INSERT INTO `access_log` VALUES (76699, '65.53.15677801674741599', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:69.0) Gecko/20100101 Firefox/69.0', '116.249.23.248', '2019-09-06 22:29:27', 0, 1002001015, '账号未登陆', '2019-09-06 22:29:27');
INSERT INTO `access_log` VALUES (76700, '65.51.15677801674741693', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:69.0) Gecko/20100101 Firefox/69.0', '116.249.23.248', '2019-09-06 22:29:27', 0, 1002001015, '账号未登陆', '2019-09-06 22:29:27');
INSERT INTO `access_log` VALUES (76701, '65.3607.15677801757313449', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:69.0) Gecko/20100101 Firefox/69.0', '116.249.23.248', '2019-09-06 22:29:36', 70, 0, '', '2019-09-06 22:29:36');
INSERT INTO `access_log` VALUES (76702, '65.54.15677801763131533', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:69.0) Gecko/20100101 Firefox/69.0', '116.249.23.248', '2019-09-06 22:29:36', 20, 0, '', '2019-09-06 22:29:36');
INSERT INTO `access_log` VALUES (76703, '65.52.15677801763111719', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:69.0) Gecko/20100101 Firefox/69.0', '116.249.23.248', '2019-09-06 22:29:36', 22, 0, '', '2019-09-06 22:29:36');
INSERT INTO `access_log` VALUES (76704, '65.47.15677801763131595', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:69.0) Gecko/20100101 Firefox/69.0', '116.249.23.248', '2019-09-06 22:29:36', 20, 2001001000, '服务端发生异常', '2019-09-06 22:29:36');
INSERT INTO `access_log` VALUES (76705, '59.74.15677808201568013', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '59.63.206.47', '2019-09-06 22:40:20', 7, 0, '', '2019-09-06 22:40:20');
INSERT INTO `access_log` VALUES (76706, '59.72.15677808201578001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '59.63.206.47', '2019-09-06 22:40:20', 13, 2001001000, '服务端发生异常', '2019-09-06 22:40:20');
INSERT INTO `access_log` VALUES (76707, '65.52.15677829976651757', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-06 23:16:38', 16, 1002001012, '访问令牌已过期', '2019-09-06 23:16:38');
INSERT INTO `access_log` VALUES (76708, '65.47.15677829976661633', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-06 23:16:38', 18, 1002001012, '访问令牌已过期', '2019-09-06 23:16:38');
INSERT INTO `access_log` VALUES (76709, '65.46.15677829976661719', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-06 23:16:38', 22, 1002001012, '访问令牌已过期', '2019-09-06 23:16:38');
INSERT INTO `access_log` VALUES (76710, '65.45.15677830009801733', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-06 23:16:41', 78, 0, '', '2019-09-06 23:16:41');
INSERT INTO `access_log` VALUES (76711, '65.50.15677830012181681', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-06 23:16:41', 17, 0, '', '2019-09-06 23:16:41');
INSERT INTO `access_log` VALUES (76712, '65.53.15677830012201639', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-06 23:16:41', 20, 0, '', '2019-09-06 23:16:41');
INSERT INTO `access_log` VALUES (76713, '65.51.15677830012201733', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-06 23:16:41', 18, 0, '', '2019-09-06 23:16:41');
INSERT INTO `access_log` VALUES (76714, '59.76.15677830119548019', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-06 23:16:52', 26, 0, '', '2019-09-06 23:16:52');
INSERT INTO `access_log` VALUES (76715, '59.73.15677830145688029', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-06 23:16:55', 17, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-09-06 23:16:55');
INSERT INTO `access_log` VALUES (76716, '65.54.15677830173271573', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-06 23:16:57', 33, 0, '', '2019-09-06 23:16:57');
INSERT INTO `access_log` VALUES (76717, '65.52.15677830205851759', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-06 23:17:01', 307, 0, '', '2019-09-06 23:17:01');
INSERT INTO `access_log` VALUES (76718, '62.86.15677830257016517', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-06 23:17:06', 28, 0, '', '2019-09-06 23:17:06');
INSERT INTO `access_log` VALUES (76719, '65.53.15677883364641711', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.232.240', '2019-09-07 00:45:36', 0, 1002001015, '账号未登陆', '2019-09-07 00:45:36');
INSERT INTO `access_log` VALUES (76720, '65.51.15677883364871805', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.232.240', '2019-09-07 00:45:36', 1, 1002001015, '账号未登陆', '2019-09-07 00:45:36');
INSERT INTO `access_log` VALUES (76721, '65.50.15677883365171753', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.232.240', '2019-09-07 00:45:37', 0, 1002001015, '账号未登陆', '2019-09-07 00:45:37');
INSERT INTO `access_log` VALUES (76722, '65.54.15677883402201645', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.232.240', '2019-09-07 00:45:40', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-07 00:45:40');
INSERT INTO `access_log` VALUES (76723, '65.46.15677883619361793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.232.240', '2019-09-07 00:46:02', 85, 0, '', '2019-09-07 00:46:02');
INSERT INTO `access_log` VALUES (76724, '65.47.15677883623901707', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.232.240', '2019-09-07 00:46:02', 12, 0, '', '2019-09-07 00:46:02');
INSERT INTO `access_log` VALUES (76725, '65.45.15677883623961807', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.232.240', '2019-09-07 00:46:02', 10, 0, '', '2019-09-07 00:46:02');
INSERT INTO `access_log` VALUES (76726, '65.49.15677883623961781', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '58.248.232.240', '2019-09-07 00:46:02', 11, 2001001000, '服务端发生异常', '2019-09-07 00:46:02');
INSERT INTO `access_log` VALUES (76727, '65.51.15677907454211839', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.32.35.109', '2019-09-07 01:25:45', 1, 1002001015, '账号未登陆', '2019-09-07 01:25:45');
INSERT INTO `access_log` VALUES (76728, '65.47.15677907454201739', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.32.35.109', '2019-09-07 01:25:45', 1, 1002001015, '账号未登陆', '2019-09-07 01:25:45');
INSERT INTO `access_log` VALUES (76729, '65.53.15677907454211745', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.32.35.109', '2019-09-07 01:25:45', 1, 1002001015, '账号未登陆', '2019-09-07 01:25:45');
INSERT INTO `access_log` VALUES (76730, '65.54.15677907765411679', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.32.35.109', '2019-09-07 01:26:17', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-07 01:26:17');
INSERT INTO `access_log` VALUES (76731, '65.52.15677907809261865', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.32.35.109', '2019-09-07 01:26:21', 72, 0, '', '2019-09-07 01:26:21');
INSERT INTO `access_log` VALUES (76732, '65.46.15677907814911827', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.32.35.109', '2019-09-07 01:26:21', 10, 0, '', '2019-09-07 01:26:22');
INSERT INTO `access_log` VALUES (76733, '65.45.15677907814961841', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.32.35.109', '2019-09-07 01:26:21', 11, 2001001000, '服务端发生异常', '2019-09-07 01:26:22');
INSERT INTO `access_log` VALUES (76734, '65.49.15677907815191815', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '121.32.35.109', '2019-09-07 01:26:22', 9, 0, '', '2019-09-07 01:26:22');
INSERT INTO `access_log` VALUES (76735, '59.76.15678132912508423', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.66', '2019-09-07 07:41:31', 12, 0, '', '2019-09-07 07:41:31');
INSERT INTO `access_log` VALUES (76736, '59.73.15678132912508433', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; U; Android 8.1.0; zh-CN; EML-AL00 Build/HUAWEIEML-AL00) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 baidu.sogo.uc.UCBrowser/11.9.4.974 UWS/2.13.1.48 Mobile Safari/537.36 AliApp(DingTalk/4.5.11) com.alibaba.android.rimet/10487439 Channel/227200 language/zh-CN', '180.163.220.67', '2019-09-07 07:41:31', 26, 2001001000, '服务端发生异常', '2019-09-07 07:41:31');
INSERT INTO `access_log` VALUES (76737, '59.79.15678214374688549', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '114.242.250.105', '2019-09-07 09:57:17', 12, 0, '', '2019-09-07 09:57:17');
INSERT INTO `access_log` VALUES (76738, '59.78.15678214374688557', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '114.242.250.105', '2019-09-07 09:57:17', 20, 2001001000, '服务端发生异常', '2019-09-07 09:57:17');
INSERT INTO `access_log` VALUES (76739, '64.84.15678214435168991', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '114.242.250.105', '2019-09-07 09:57:24', 12, 0, '', '2019-09-07 09:57:24');
INSERT INTO `access_log` VALUES (76740, '64.80.15678214438088993', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '114.242.250.105', '2019-09-07 09:57:24', 3, 0, '', '2019-09-07 09:57:24');
INSERT INTO `access_log` VALUES (76741, '64.81.15678214499769001', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '114.242.250.105', '2019-09-07 09:57:30', 2, 0, '', '2019-09-07 09:57:30');
INSERT INTO `access_log` VALUES (76742, '64.77.15678214501718971', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '114.242.250.105', '2019-09-07 09:57:30', 2, 0, '', '2019-09-07 09:57:30');
INSERT INTO `access_log` VALUES (76743, '59.75.15678214507368551', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '114.242.250.105', '2019-09-07 09:57:31', 4, 0, '', '2019-09-07 09:57:31');
INSERT INTO `access_log` VALUES (76744, '59.77.15678214507878535', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '114.242.250.105', '2019-09-07 09:57:31', 20, 2001001000, '服务端发生异常', '2019-09-07 09:57:31');
INSERT INTO `access_log` VALUES (76745, '65.54.15678215976792091', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '114.242.250.105', '2019-09-07 09:59:58', 1, 1002001015, '账号未登陆', '2019-09-07 09:59:58');
INSERT INTO `access_log` VALUES (76746, '65.52.15678215977322277', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '114.242.250.105', '2019-09-07 09:59:58', 0, 1002001015, '账号未登陆', '2019-09-07 09:59:58');
INSERT INTO `access_log` VALUES (76747, '65.46.15678215977452239', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '114.242.250.105', '2019-09-07 09:59:58', 0, 1002001015, '账号未登陆', '2019-09-07 09:59:58');
INSERT INTO `access_log` VALUES (76748, '65.45.15678216119652253', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 13_1 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148 MicroMessenger/7.0.5(0x17000523) NetType/4G Language/zh_CN', '114.242.250.105', '2019-09-07 10:00:12', 113, 0, '', '2019-09-07 10:00:12');
INSERT INTO `access_log` VALUES (76749, '65.45.15678243026682289', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:69.0) Gecko/20100101 Firefox/69.0', '116.249.23.248', '2019-09-07 10:45:03', 15, 1002001012, '访问令牌已过期', '2019-09-07 10:45:03');
INSERT INTO `access_log` VALUES (76750, '65.53.15678243026862195', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:69.0) Gecko/20100101 Firefox/69.0', '116.249.23.248', '2019-09-07 10:45:03', 11, 1002001012, '访问令牌已过期', '2019-09-07 10:45:03');
INSERT INTO `access_log` VALUES (76751, '65.51.15678243026882289', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:69.0) Gecko/20100101 Firefox/69.0', '116.249.23.248', '2019-09-07 10:45:03', 12, 1002001012, '访问令牌已过期', '2019-09-07 10:45:03');
INSERT INTO `access_log` VALUES (76752, '65.49.15678246855552269', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.128.200.220', '2019-09-07 10:51:26', 0, 1002001015, '账号未登陆', '2019-09-07 10:51:26');
INSERT INTO `access_log` VALUES (76753, '65.45.15678246855562295', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.128.200.220', '2019-09-07 10:51:26', 1, 1002001015, '账号未登陆', '2019-09-07 10:51:26');
INSERT INTO `access_log` VALUES (76754, '65.53.15678246855572201', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.128.200.220', '2019-09-07 10:51:26', 1, 1002001015, '账号未登陆', '2019-09-07 10:51:26');
INSERT INTO `access_log` VALUES (76755, '65.51.15678246923782295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.128.200.220', '2019-09-07 10:51:32', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-07 10:51:32');
INSERT INTO `access_log` VALUES (76756, '65.50.15678247007222243', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.128.200.220', '2019-09-07 10:51:41', 86, 0, '', '2019-09-07 10:51:41');
INSERT INTO `access_log` VALUES (76757, '65.3607.15678247010824051', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.128.200.220', '2019-09-07 10:51:41', 12, 0, '', '2019-09-07 10:51:41');
INSERT INTO `access_log` VALUES (76758, '65.46.15678247010882283', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.128.200.220', '2019-09-07 10:51:41', 12, 0, '', '2019-09-07 10:51:41');
INSERT INTO `access_log` VALUES (76759, '65.54.15678247010862135', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.128.200.220', '2019-09-07 10:51:41', 13, 2001001000, '服务端发生异常', '2019-09-07 10:51:41');
INSERT INTO `access_log` VALUES (76760, '65.49.15678247208282271', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.128.200.220', '2019-09-07 10:52:01', 9, 0, '', '2019-09-07 10:52:01');
INSERT INTO `access_log` VALUES (76761, '65.53.15678247208312203', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.128.200.220', '2019-09-07 10:52:01', 10, 2001001000, '服务端发生异常', '2019-09-07 10:52:01');
INSERT INTO `access_log` VALUES (76762, '65.45.15678247208372297', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '183.128.200.220', '2019-09-07 10:52:01', 8, 0, '', '2019-09-07 10:52:01');
INSERT INTO `access_log` VALUES (76763, '65.3607.15678264838824077', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.102.228.117', '2019-09-07 11:21:24', 0, 1002001015, '账号未登陆', '2019-09-07 11:21:24');
INSERT INTO `access_log` VALUES (76764, '65.49.15678264838832295', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.102.228.117', '2019-09-07 11:21:24', 0, 1002001015, '账号未登陆', '2019-09-07 11:21:24');
INSERT INTO `access_log` VALUES (76765, '65.52.15678264838832345', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.102.228.117', '2019-09-07 11:21:24', 0, 1002001015, '账号未登陆', '2019-09-07 11:21:24');
INSERT INTO `access_log` VALUES (76766, '65.53.15678264904742227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '36.102.228.117', '2019-09-07 11:21:30', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-07 11:21:30');
INSERT INTO `access_log` VALUES (76767, '65.50.15678266705602271', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.11.59.242', '2019-09-07 11:24:31', 1, 1002001015, '账号未登陆', '2019-09-07 11:24:31');
INSERT INTO `access_log` VALUES (76768, '65.54.15678266705672163', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.11.59.242', '2019-09-07 11:24:31', 1, 1002001015, '账号未登陆', '2019-09-07 11:24:31');
INSERT INTO `access_log` VALUES (76769, '65.46.15678266705742313', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.11.59.242', '2019-09-07 11:24:31', 1, 1002001015, '账号未登陆', '2019-09-07 11:24:31');
INSERT INTO `access_log` VALUES (76770, '65.45.15678266767952327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.11.59.242', '2019-09-07 11:24:37', 108, 0, '', '2019-09-07 11:24:37');
INSERT INTO `access_log` VALUES (76771, '65.3607.15678266771124081', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.11.59.242', '2019-09-07 11:24:37', 10, 0, '', '2019-09-07 11:24:37');
INSERT INTO `access_log` VALUES (76772, '65.52.15678266771122349', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.11.59.242', '2019-09-07 11:24:37', 11, 2001001000, '服务端发生异常', '2019-09-07 11:24:37');
INSERT INTO `access_log` VALUES (76773, '65.49.15678266771222299', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.11.59.242', '2019-09-07 11:24:37', 8, 0, '', '2019-09-07 11:24:37');
INSERT INTO `access_log` VALUES (76774, '65.47.15678267005252227', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.11.59.242', '2019-09-07 11:25:01', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-07 11:25:01');
INSERT INTO `access_log` VALUES (76775, '65.52.15678396912302523', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.71.166.87', '2019-09-07 15:01:31', 0, 1002001015, '账号未登陆', '2019-09-07 15:01:31');
INSERT INTO `access_log` VALUES (76776, '65.51.15678396912302501', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.71.166.87', '2019-09-07 15:01:31', 1, 1002001015, '账号未登陆', '2019-09-07 15:01:31');
INSERT INTO `access_log` VALUES (76777, '65.53.15678396912302405', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.71.166.87', '2019-09-07 15:01:31', 0, 1002001015, '账号未登陆', '2019-09-07 15:01:31');
INSERT INTO `access_log` VALUES (76778, '65.47.15678396940242401', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.71.166.87', '2019-09-07 15:01:34', 10, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-07 15:01:34');
INSERT INTO `access_log` VALUES (76779, '65.54.15678397055492339', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.71.166.87', '2019-09-07 15:01:46', 109, 0, '', '2019-09-07 15:01:46');
INSERT INTO `access_log` VALUES (76780, '65.50.15678397059222447', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.71.166.87', '2019-09-07 15:01:46', 15, 0, '', '2019-09-07 15:01:46');
INSERT INTO `access_log` VALUES (76781, '65.45.15678397059262503', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.71.166.87', '2019-09-07 15:01:46', 14, 2001001000, '服务端发生异常', '2019-09-07 15:01:46');
INSERT INTO `access_log` VALUES (76782, '65.49.15678397059282475', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.71.166.87', '2019-09-07 15:01:46', 14, 0, '', '2019-09-07 15:01:46');
INSERT INTO `access_log` VALUES (76783, '65.53.15678397178952407', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.71.166.87', '2019-09-07 15:01:58', 10, 0, '', '2019-09-07 15:01:58');
INSERT INTO `access_log` VALUES (76784, '65.51.15678397178962503', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.71.166.87', '2019-09-07 15:01:58', 11, 2001001000, '服务端发生异常', '2019-09-07 15:01:58');
INSERT INTO `access_log` VALUES (76785, '65.52.15678397178982525', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.71.166.87', '2019-09-07 15:01:58', 10, 0, '', '2019-09-07 15:01:58');
INSERT INTO `access_log` VALUES (76786, '59.80.15678415064688783', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.63.203.251', '2019-09-07 15:31:46', 10, 0, '', '2019-09-07 15:31:46');
INSERT INTO `access_log` VALUES (76787, '59.75.15678415064798819', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.63.203.251', '2019-09-07 15:31:46', 19, 2001001000, '服务端发生异常', '2019-09-07 15:31:47');
INSERT INTO `access_log` VALUES (76788, '65.47.15678415165742427', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.63.203.251', '2019-09-07 15:31:57', 1, 1002001015, '账号未登陆', '2019-09-07 15:31:57');
INSERT INTO `access_log` VALUES (76789, '65.46.15678415165742515', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.63.203.251', '2019-09-07 15:31:57', 0, 1002001015, '账号未登陆', '2019-09-07 15:31:57');
INSERT INTO `access_log` VALUES (76790, '65.54.15678415165802365', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.63.203.251', '2019-09-07 15:31:57', 1, 1002001015, '账号未登陆', '2019-09-07 15:31:57');
INSERT INTO `access_log` VALUES (76791, '65.45.15678415186462529', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.63.203.251', '2019-09-07 15:31:59', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-07 15:31:59');
INSERT INTO `access_log` VALUES (76792, '65.50.15678415283902473', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.63.203.251', '2019-09-07 15:32:08', 53, 0, '', '2019-09-07 15:32:08');
INSERT INTO `access_log` VALUES (76793, '65.49.15678415287082501', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.63.203.251', '2019-09-07 15:32:09', 10, 0, '', '2019-09-07 15:32:09');
INSERT INTO `access_log` VALUES (76794, '65.3607.15678415287104283', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.63.203.251', '2019-09-07 15:32:09', 10, 2001001000, '服务端发生异常', '2019-09-07 15:32:09');
INSERT INTO `access_log` VALUES (76795, '65.52.15678415287172551', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '59.63.203.251', '2019-09-07 15:32:09', 9, 0, '', '2019-09-07 15:32:09');
INSERT INTO `access_log` VALUES (76796, '59.75.15678429736048839', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '60.190.217.65', '2019-09-07 15:56:14', 4, 0, '', '2019-09-07 15:56:14');
INSERT INTO `access_log` VALUES (76797, '59.80.15678429736048803', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '60.190.217.65', '2019-09-07 15:56:14', 18, 2001001000, '服务端发生异常', '2019-09-07 15:56:14');
INSERT INTO `access_log` VALUES (76798, '59.78.15678430478258847', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '60.190.217.65', '2019-09-07 15:57:28', 3, 0, '', '2019-09-07 15:57:28');
INSERT INTO `access_log` VALUES (76799, '59.71.15678430478258831', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '60.190.217.65', '2019-09-07 15:57:28', 16, 2001001000, '服务端发生异常', '2019-09-07 15:57:28');
INSERT INTO `access_log` VALUES (76800, '59.78.15678458679318885', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.209.118.91', '2019-09-07 16:44:28', 11, 0, '', '2019-09-07 16:44:28');
INSERT INTO `access_log` VALUES (76801, '59.71.15678458679308869', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.209.118.91', '2019-09-07 16:44:28', 28, 2001001000, '服务端发生异常', '2019-09-07 16:44:28');
INSERT INTO `access_log` VALUES (76802, '64.81.15678458734599327', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.209.118.91', '2019-09-07 16:44:33', 12, 0, '', '2019-09-07 16:44:33');
INSERT INTO `access_log` VALUES (76803, '64.77.15678458736979297', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.209.118.91', '2019-09-07 16:44:34', 4, 0, '', '2019-09-07 16:44:34');
INSERT INTO `access_log` VALUES (76804, '64.82.15678458756049331', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.209.118.91', '2019-09-07 16:44:36', 2, 0, '', '2019-09-07 16:44:36');
INSERT INTO `access_log` VALUES (76805, '64.83.15678458762359315', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.209.118.91', '2019-09-07 16:44:36', 2, 0, '', '2019-09-07 16:44:36');
INSERT INTO `access_log` VALUES (76806, '64.85.15678458769459345', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '222.209.118.91', '2019-09-07 16:44:37', 2, 0, '', '2019-09-07 16:44:37');
INSERT INTO `access_log` VALUES (76807, '65.49.15678520293042643', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 18:27:09', 16, 1002001012, '访问令牌已过期', '2019-09-07 18:27:09');
INSERT INTO `access_log` VALUES (76808, '65.51.15678520293042671', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 18:27:09', 19, 1002001012, '访问令牌已过期', '2019-09-07 18:27:09');
INSERT INTO `access_log` VALUES (76809, '65.47.15678520293042569', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 18:27:09', 22, 1002001012, '访问令牌已过期', '2019-09-07 18:27:09');
INSERT INTO `access_log` VALUES (76810, '65.53.15678520342722573', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 18:27:14', 57, 0, '', '2019-09-07 18:27:14');
INSERT INTO `access_log` VALUES (76811, '65.54.15678520344902507', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 18:27:14', 13, 0, '', '2019-09-07 18:27:15');
INSERT INTO `access_log` VALUES (76812, '65.46.15678520344902659', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 18:27:14', 12, 0, '', '2019-09-07 18:27:15');
INSERT INTO `access_log` VALUES (76813, '65.45.15678520344902673', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 18:27:14', 13, 0, '', '2019-09-07 18:27:15');
INSERT INTO `access_log` VALUES (76814, '64.76.15678520392539409', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 18:27:19', 25, 0, '', '2019-09-07 18:27:19');
INSERT INTO `access_log` VALUES (76815, '64.79.15678520392539405', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 18:27:19', 29, 0, '', '2019-09-07 18:27:19');
INSERT INTO `access_log` VALUES (76816, '64.84.15678521621419403', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 18:29:22', 12, 0, '', '2019-09-07 18:29:22');
INSERT INTO `access_log` VALUES (76817, '64.79.15678521621419407', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 18:29:22', 17, 0, '', '2019-09-07 18:29:22');
INSERT INTO `access_log` VALUES (76818, '64.77.15678521636679383', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 18:29:24', 20, 0, '', '2019-09-07 18:29:24');
INSERT INTO `access_log` VALUES (76819, '64.81.15678521636679413', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 18:29:24', 25, 0, '', '2019-09-07 18:29:24');
INSERT INTO `access_log` VALUES (76820, '64.80.15678521636679405', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=33', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 18:29:24', 28, 0, '', '2019-09-07 18:29:24');
INSERT INTO `access_log` VALUES (76821, '59.73.15678583734839037', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.230.38.64', '2019-09-07 20:12:53', 10, 0, '', '2019-09-07 20:12:53');
INSERT INTO `access_log` VALUES (76822, '59.76.15678583734849027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.230.38.64', '2019-09-07 20:12:53', 36, 2001001000, '服务端发生异常', '2019-09-07 20:12:54');
INSERT INTO `access_log` VALUES (76823, '65.47.15678583985042655', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.230.38.64', '2019-09-07 20:13:19', 1, 1002001015, '账号未登陆', '2019-09-07 20:13:19');
INSERT INTO `access_log` VALUES (76824, '65.51.15678583985532757', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.230.38.64', '2019-09-07 20:13:19', 0, 1002001015, '账号未登陆', '2019-09-07 20:13:19');
INSERT INTO `access_log` VALUES (76825, '65.53.15678583985552659', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.230.38.64', '2019-09-07 20:13:19', 0, 1002001015, '账号未登陆', '2019-09-07 20:13:19');
INSERT INTO `access_log` VALUES (76826, '65.54.15678584016682593', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '116.230.38.64', '2019-09-07 20:13:22', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-07 20:13:22');
INSERT INTO `access_log` VALUES (76827, '65.47.15678587884372661', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.85.232.235', '2019-09-07 20:19:48', 1, 1002001015, '账号未登陆', '2019-09-07 20:19:48');
INSERT INTO `access_log` VALUES (76828, '65.53.15678587884412665', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.85.232.235', '2019-09-07 20:19:48', 0, 1002001015, '账号未登陆', '2019-09-07 20:19:48');
INSERT INTO `access_log` VALUES (76829, '65.51.15678587884482763', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.85.232.235', '2019-09-07 20:19:48', 1, 1002001015, '账号未登陆', '2019-09-07 20:19:48');
INSERT INTO `access_log` VALUES (76830, '65.45.15678587982292765', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.85.232.235', '2019-09-07 20:19:58', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-07 20:19:58');
INSERT INTO `access_log` VALUES (76831, '65.46.15678588013952751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.85.232.235', '2019-09-07 20:20:01', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-07 20:20:01');
INSERT INTO `access_log` VALUES (76832, '65.50.15678588029652707', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.85.232.235', '2019-09-07 20:20:03', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-07 20:20:03');
INSERT INTO `access_log` VALUES (76833, '65.52.15678588100882787', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.85.232.235', '2019-09-07 20:20:10', 85, 0, '', '2019-09-07 20:20:10');
INSERT INTO `access_log` VALUES (76834, '65.47.15678588104842663', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.85.232.235', '2019-09-07 20:20:10', 14, 0, '', '2019-09-07 20:20:10');
INSERT INTO `access_log` VALUES (76835, '65.51.15678588104852765', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.85.232.235', '2019-09-07 20:20:10', 16, 2001001000, '服务端发生异常', '2019-09-07 20:20:11');
INSERT INTO `access_log` VALUES (76836, '65.49.15678588104822737', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.85.232.235', '2019-09-07 20:20:10', 18, 0, '', '2019-09-07 20:20:11');
INSERT INTO `access_log` VALUES (76837, '65.53.15678588167732667', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.85.232.235', '2019-09-07 20:20:17', 8, 0, '', '2019-09-07 20:20:17');
INSERT INTO `access_log` VALUES (76838, '65.54.15678588167732601', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.85.232.235', '2019-09-07 20:20:17', 9, 2001001000, '服务端发生异常', '2019-09-07 20:20:17');
INSERT INTO `access_log` VALUES (76839, '65.45.15678588167742767', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '125.85.232.235', '2019-09-07 20:20:17', 10, 0, '', '2019-09-07 20:20:17');
INSERT INTO `access_log` VALUES (76840, '65.3607.15678625979204571', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:23:18', 1, 1002001015, '账号未登陆', '2019-09-07 21:23:18');
INSERT INTO `access_log` VALUES (76841, '65.46.15678625979202803', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:23:18', 1, 1002001015, '账号未登陆', '2019-09-07 21:23:18');
INSERT INTO `access_log` VALUES (76842, '65.52.15678625979222837', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:23:18', 0, 1002001015, '账号未登陆', '2019-09-07 21:23:18');
INSERT INTO `access_log` VALUES (76843, '65.49.15678626016582789', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:23:22', 109, 0, '', '2019-09-07 21:23:22');
INSERT INTO `access_log` VALUES (76844, '65.50.15678626021992763', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:23:22', 9, 0, '', '2019-09-07 21:23:22');
INSERT INTO `access_log` VALUES (76845, '65.51.15678626021982819', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:23:22', 9, 0, '', '2019-09-07 21:23:22');
INSERT INTO `access_log` VALUES (76846, '65.47.15678626021982717', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:23:22', 13, 2001001000, '服务端发生异常', '2019-09-07 21:23:22');
INSERT INTO `access_log` VALUES (76847, '65.45.15678626193582821', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:23:39', 11, 0, '', '2019-09-07 21:23:39');
INSERT INTO `access_log` VALUES (76848, '65.46.15678626193602805', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:23:39', 12, 2001001000, '服务端发生异常', '2019-09-07 21:23:39');
INSERT INTO `access_log` VALUES (76849, '65.3607.15678626193604573', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:23:39', 15, 0, '', '2019-09-07 21:23:39');
INSERT INTO `access_log` VALUES (76850, '65.52.15678626297962839', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:23:50', 9, 0, '', '2019-09-07 21:23:50');
INSERT INTO `access_log` VALUES (76851, '65.49.15678626298002791', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:23:50', 11, 2001001000, '服务端发生异常', '2019-09-07 21:23:50');
INSERT INTO `access_log` VALUES (76852, '65.50.15678626298032765', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:23:50', 9, 0, '', '2019-09-07 21:23:50');
INSERT INTO `access_log` VALUES (76853, '59.76.15678627073409085', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:07', 9, 0, '', '2019-09-07 21:25:07');
INSERT INTO `access_log` VALUES (76854, '59.74.15678627073449109', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:07', 14, 2001001000, '服务端发生异常', '2019-09-07 21:25:07');
INSERT INTO `access_log` VALUES (76855, '64.85.15678627134009571', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:13', 12, 0, '', '2019-09-07 21:25:13');
INSERT INTO `access_log` VALUES (76856, '64.76.15678627136549553', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:14', 3, 0, '', '2019-09-07 21:25:14');
INSERT INTO `access_log` VALUES (76857, '64.84.15678627146709545', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:15', 2, 0, '', '2019-09-07 21:25:15');
INSERT INTO `access_log` VALUES (76858, '59.72.15678627172149097', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:17', 3, 0, '', '2019-09-07 21:25:17');
INSERT INTO `access_log` VALUES (76859, '59.78.15678627172149111', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:17', 23, 2001001000, '服务端发生异常', '2019-09-07 21:25:17');
INSERT INTO `access_log` VALUES (76860, '65.50.15678627245142767', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:25', 10, 0, '', '2019-09-07 21:25:25');
INSERT INTO `access_log` VALUES (76861, '65.52.15678627245152841', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:25', 11, 2001001000, '服务端发生异常', '2019-09-07 21:25:25');
INSERT INTO `access_log` VALUES (76862, '65.49.15678627245192793', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:25', 10, 0, '', '2019-09-07 21:25:25');
INSERT INTO `access_log` VALUES (76863, '65.51.15678627466502823', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:47', 9, 0, '', '2019-09-07 21:25:47');
INSERT INTO `access_log` VALUES (76864, '65.53.15678627466522723', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:47', 9, 2001001000, '服务端发生异常', '2019-09-07 21:25:47');
INSERT INTO `access_log` VALUES (76865, '65.54.15678627466572657', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:47', 8, 0, '', '2019-09-07 21:25:47');
INSERT INTO `access_log` VALUES (76866, '65.3607.15678627518754577', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:52', 10, 0, '', '2019-09-07 21:25:52');
INSERT INTO `access_log` VALUES (76867, '65.45.15678627518792825', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:52', 9, 0, '', '2019-09-07 21:25:52');
INSERT INTO `access_log` VALUES (76868, '65.46.15678627518802809', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:52', 9, 2001001000, '服务端发生异常', '2019-09-07 21:25:52');
INSERT INTO `access_log` VALUES (76869, '65.52.15678627555252843', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:56', 9, 0, '', '2019-09-07 21:25:56');
INSERT INTO `access_log` VALUES (76870, '65.47.15678627555272723', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:56', 9, 0, '', '2019-09-07 21:25:56');
INSERT INTO `access_log` VALUES (76871, '65.50.15678627555252769', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/66.0.3359.181 Safari/537.36', '223.212.113.112', '2019-09-07 21:25:56', 11, 2001001000, '服务端发生异常', '2019-09-07 21:25:56');
INSERT INTO `access_log` VALUES (76872, '65.54.15678633644922667', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 21:36:04', 4, 1002001012, '访问令牌已过期', '2019-09-07 21:36:04');
INSERT INTO `access_log` VALUES (76873, '65.51.15678633644922833', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 21:36:04', 4, 1002001012, '访问令牌已过期', '2019-09-07 21:36:04');
INSERT INTO `access_log` VALUES (76874, '65.53.15678633644912733', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 21:36:04', 6, 1002001012, '访问令牌已过期', '2019-09-07 21:36:04');
INSERT INTO `access_log` VALUES (76875, '65.3607.15678633676364587', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 21:36:08', 229, 0, '', '2019-09-07 21:36:08');
INSERT INTO `access_log` VALUES (76876, '65.46.15678633680532819', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 21:36:08', 8, 0, '', '2019-09-07 21:36:08');
INSERT INTO `access_log` VALUES (76877, '65.49.15678633680542805', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 21:36:08', 8, 0, '', '2019-09-07 21:36:08');
INSERT INTO `access_log` VALUES (76878, '65.45.15678633680532835', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 21:36:08', 9, 0, '', '2019-09-07 21:36:08');
INSERT INTO `access_log` VALUES (76879, '62.86.15678633723957587', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 21:36:12', 25, 0, '', '2019-09-07 21:36:12');
INSERT INTO `access_log` VALUES (76880, '64.78.15678633762859579', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 21:36:16', 17, 0, '', '2019-09-07 21:36:16');
INSERT INTO `access_log` VALUES (76881, '64.82.15678633762859567', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 21:36:16', 14, 0, '', '2019-09-07 21:36:16');
INSERT INTO `access_log` VALUES (76882, '64.85.15678633787539581', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 21:36:19', 16, 0, '', '2019-09-07 21:36:19');
INSERT INTO `access_log` VALUES (76883, '64.83.15678633787489551', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-07 21:36:19', 105, 0, '', '2019-09-07 21:36:19');
INSERT INTO `access_log` VALUES (76884, '65.50.15678663765822819', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.65.0.32', '2019-09-07 22:26:17', 0, 1002001015, '账号未登陆', '2019-09-07 22:26:17');
INSERT INTO `access_log` VALUES (76885, '65.52.15678663765822893', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.65.0.32', '2019-09-07 22:26:17', 1, 1002001015, '账号未登陆', '2019-09-07 22:26:17');
INSERT INTO `access_log` VALUES (76886, '65.51.15678663765822875', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.65.0.32', '2019-09-07 22:26:17', 0, 1002001015, '账号未登陆', '2019-09-07 22:26:17');
INSERT INTO `access_log` VALUES (76887, '65.53.15678663792372775', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.65.0.32', '2019-09-07 22:26:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-07 22:26:19');
INSERT INTO `access_log` VALUES (76888, '65.3607.15678663884174629', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.65.0.32', '2019-09-07 22:26:28', 77, 0, '', '2019-09-07 22:26:28');
INSERT INTO `access_log` VALUES (76889, '65.46.15678663889072861', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.65.0.32', '2019-09-07 22:26:29', 15, 0, '', '2019-09-07 22:26:29');
INSERT INTO `access_log` VALUES (76890, '65.45.15678663889132877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.65.0.32', '2019-09-07 22:26:29', 12, 2001001000, '服务端发生异常', '2019-09-07 22:26:29');
INSERT INTO `access_log` VALUES (76891, '65.49.15678663889172847', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.65.0.32', '2019-09-07 22:26:29', 9, 0, '', '2019-09-07 22:26:29');
INSERT INTO `access_log` VALUES (76892, '65.50.15678664000512821', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.65.0.32', '2019-09-07 22:26:40', 9, 0, '', '2019-09-07 22:26:40');
INSERT INTO `access_log` VALUES (76893, '65.51.15678664000912877', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.65.0.32', '2019-09-07 22:26:40', 11, 2001001000, '服务端发生异常', '2019-09-07 22:26:40');
INSERT INTO `access_log` VALUES (76894, '65.52.15678664001052895', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '112.65.0.32', '2019-09-07 22:26:40', 10, 0, '', '2019-09-07 22:26:40');
INSERT INTO `access_log` VALUES (76895, '65.52.15678675803622911', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:46:20', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-07 22:46:20');
INSERT INTO `access_log` VALUES (76896, '65.53.15678675977122793', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:46:38', 96, 0, '', '2019-09-07 22:46:38');
INSERT INTO `access_log` VALUES (76897, '65.54.15678675980222727', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:46:38', 9, 0, '', '2019-09-07 22:46:38');
INSERT INTO `access_log` VALUES (76898, '65.45.15678675980662895', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:46:38', 412, 0, '', '2019-09-07 22:46:38');
INSERT INTO `access_log` VALUES (76899, '65.3607.15678675980554647', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:46:38', 424, 0, '', '2019-09-07 22:46:38');
INSERT INTO `access_log` VALUES (76900, '65.49.15678676065752865', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:46:47', 26, 0, '', '2019-09-07 22:46:47');
INSERT INTO `access_log` VALUES (76901, '65.50.15678676154822839', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:46:55', 18, 0, '', '2019-09-07 22:46:56');
INSERT INTO `access_log` VALUES (76902, '65.51.15678676343632895', 1, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=28&status=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:47:14', 196, 0, '', '2019-09-07 22:47:15');
INSERT INTO `access_log` VALUES (76903, '65.53.15678676348382795', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:47:15', 4, 1002001013, '访问令牌已失效', '2019-09-07 22:47:15');
INSERT INTO `access_log` VALUES (76904, '65.54.15678676420402729', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:47:22', 79, 0, '', '2019-09-07 22:47:22');
INSERT INTO `access_log` VALUES (76905, '65.3607.15678676423854649', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:47:22', 8, 0, '', '2019-09-07 22:47:22');
INSERT INTO `access_log` VALUES (76906, '65.46.15678676423862881', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:47:22', 8, 0, '', '2019-09-07 22:47:22');
INSERT INTO `access_log` VALUES (76907, '65.45.15678676423842897', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:47:22', 10, 0, '', '2019-09-07 22:47:22');
INSERT INTO `access_log` VALUES (76908, '65.47.15678676492472795', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:47:29', 16, 0, '', '2019-09-07 22:47:29');
INSERT INTO `access_log` VALUES (76909, '65.50.15678676520922841', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:47:32', 16, 0, '', '2019-09-07 22:47:32');
INSERT INTO `access_log` VALUES (76910, '65.51.15678676643262897', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:47:44', 20, 0, '', '2019-09-07 22:47:44');
INSERT INTO `access_log` VALUES (76911, '65.53.15678676688222797', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.134', '2019-09-07 22:47:49', 18, 0, '', '2019-09-07 22:47:49');
INSERT INTO `access_log` VALUES (76912, '64.76.15678855658099859', 0, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=3&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:06', 22, 1002001012, '访问令牌已过期', '2019-09-08 03:46:06');
INSERT INTO `access_log` VALUES (76913, '65.49.15678855700803107', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:10', 229, 0, '', '2019-09-08 03:46:10');
INSERT INTO `access_log` VALUES (76914, '65.47.15678855705023035', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:11', 30, 0, '', '2019-09-08 03:46:11');
INSERT INTO `access_log` VALUES (76915, '65.50.15678855705033081', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:11', 29, 0, '', '2019-09-08 03:46:11');
INSERT INTO `access_log` VALUES (76916, '65.52.15678855705053155', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:11', 33, 0, '', '2019-09-08 03:46:11');
INSERT INTO `access_log` VALUES (76917, '64.79.15678855730519855', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:13', 23, 0, '', '2019-09-08 03:46:13');
INSERT INTO `access_log` VALUES (76918, '64.84.15678855730509851', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:13', 32, 0, '', '2019-09-08 03:46:13');
INSERT INTO `access_log` VALUES (76919, '64.77.15678855747269831', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=3&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:15', 11, 0, '', '2019-09-08 03:46:15');
INSERT INTO `access_log` VALUES (76920, '64.81.15678855761289861', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:16', 25, 0, '', '2019-09-08 03:46:16');
INSERT INTO `access_log` VALUES (76921, '64.80.15678855761279853', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=29', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:16', 34, 0, '', '2019-09-08 03:46:16');
INSERT INTO `access_log` VALUES (76922, '64.78.15678855761299877', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:16', 35, 0, '', '2019-09-08 03:46:16');
INSERT INTO `access_log` VALUES (76923, '64.83.15678855808289849', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:21', 12, 0, '', '2019-09-08 03:46:21');
INSERT INTO `access_log` VALUES (76924, '64.85.15678855808289879', 1, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:21', 14, 0, '', '2019-09-08 03:46:21');
INSERT INTO `access_log` VALUES (76925, '64.76.15678855829679861', 1, 2, 'product-application', '/product-api/admins/spu/page', 'pageNo=3&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:23', 11, 0, '', '2019-09-08 03:46:23');
INSERT INTO `access_log` VALUES (76926, '64.77.15678855842439833', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:24', 9, 0, '', '2019-09-08 03:46:24');
INSERT INTO `access_log` VALUES (76927, '64.84.15678855842419853', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:24', 12, 0, '', '2019-09-08 03:46:24');
INSERT INTO `access_log` VALUES (76928, '64.79.15678855842419857', 1, 2, 'product-application', '/product-api/admins/spu/info', 'id=28', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:24', 122, 0, '', '2019-09-08 03:46:24');
INSERT INTO `access_log` VALUES (76929, '66.50.15678855936976747', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:34', 21, 0, '', '2019-09-08 03:46:34');
INSERT INTO `access_log` VALUES (76930, '66.54.15678855957856751', 1, 2, 'user-application', '/user-api/admins/user/page', 'pageNo=5&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:36', 12, 0, '', '2019-09-08 03:46:36');
INSERT INTO `access_log` VALUES (76931, '65.54.15678856003952971', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:40', 25, 0, '', '2019-09-08 03:46:40');
INSERT INTO `access_log` VALUES (76932, '65.45.15678856017113139', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:42', 18, 0, '', '2019-09-08 03:46:42');
INSERT INTO `access_log` VALUES (76933, '65.3607.15678856052824891', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:45', 18, 0, '', '2019-09-08 03:46:45');
INSERT INTO `access_log` VALUES (76934, '62.82.15678856097857871', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:50', 24, 0, '', '2019-09-08 03:46:50');
INSERT INTO `access_log` VALUES (76935, '62.89.15678856118127887', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=9&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:52', 20, 0, '', '2019-09-08 03:46:52');
INSERT INTO `access_log` VALUES (76936, '64.80.15678856194279855', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:46:59', 10, 0, '', '2019-09-08 03:46:59');
INSERT INTO `access_log` VALUES (76937, '59.72.15678856266269403', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:47:07', 23, 0, '', '2019-09-08 03:47:07');
INSERT INTO `access_log` VALUES (76938, '59.78.15678856339839417', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'activityType=1&status=ALL&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:47:14', 17, 0, '', '2019-09-08 03:47:14');
INSERT INTO `access_log` VALUES (76939, '59.71.15678856363559401', 1, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:47:16', 15, 0, '', '2019-09-08 03:47:16');
INSERT INTO `access_log` VALUES (76940, '59.75.15678856395169411', 1, 2, 'promotion-application', '/promotion-api/admins/promotion_activity/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:47:20', 8, 2001001001, '参数缺失:Required Integer parameter \'activityType\' is not present', '2019-09-08 03:47:20');
INSERT INTO `access_log` VALUES (76941, '62.80.15678856428377897', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '180.154.67.132', '2019-09-08 03:47:23', 12, 0, '', '2019-09-08 03:47:23');
INSERT INTO `access_log` VALUES (76942, '64.78.15679077448570179', 0, 2, 'product-application', '/product-api/admins/attr/update', 'id=1&name=颜色', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '182.119.70.169', '2019-09-08 09:55:45', 1, 1002001015, '账号未登陆', '2019-09-08 09:55:45');
INSERT INTO `access_log` VALUES (76943, '64.81.15679077663380159', 0, 2, 'product-application', '/product-api/admins/spu/info', 'id=100', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '182.119.70.169', '2019-09-08 09:56:06', 0, 1002001015, '账号未登陆', '2019-09-08 09:56:06');
INSERT INTO `access_log` VALUES (76944, '65.50.15679108452413419', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '223.79.35.120', '2019-09-08 10:47:25', 2, 1002001015, '账号未登陆', '2019-09-08 10:47:25');
INSERT INTO `access_log` VALUES (76945, '65.51.15679108452413475', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '223.79.35.120', '2019-09-08 10:47:25', 0, 1002001015, '账号未登陆', '2019-09-08 10:47:25');
INSERT INTO `access_log` VALUES (76946, '65.53.15679108452423375', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '223.79.35.120', '2019-09-08 10:47:25', 1, 1002001015, '账号未登陆', '2019-09-08 10:47:25');
INSERT INTO `access_log` VALUES (76947, '65.54.15679108479743309', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '223.79.35.120', '2019-09-08 10:47:28', 12, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-08 10:47:28');
INSERT INTO `access_log` VALUES (76948, '65.45.15679108506523477', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '223.79.35.120', '2019-09-08 10:47:31', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-08 10:47:31');
INSERT INTO `access_log` VALUES (76949, '65.46.15679108631283461', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '223.79.35.120', '2019-09-08 10:47:43', 77, 0, '', '2019-09-08 10:47:43');
INSERT INTO `access_log` VALUES (76950, '65.49.15679108635623445', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '223.79.35.120', '2019-09-08 10:47:44', 15, 0, '', '2019-09-08 10:47:44');
INSERT INTO `access_log` VALUES (76951, '65.52.15679108635723495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '223.79.35.120', '2019-09-08 10:47:44', 11, 2001001000, '服务端发生异常', '2019-09-08 10:47:44');
INSERT INTO `access_log` VALUES (76952, '65.47.15679108636363375', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3314.0 Safari/537.36 SE 2.X MetaSr 1.0', '223.79.35.120', '2019-09-08 10:47:44', 14, 0, '', '2019-09-08 10:47:44');
INSERT INTO `access_log` VALUES (76953, '65.51.15679109010313477', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.79.35.120', '2019-09-08 10:48:21', 1, 1002001015, '账号未登陆', '2019-09-08 10:48:21');
INSERT INTO `access_log` VALUES (76954, '65.54.15679109010423311', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.79.35.120', '2019-09-08 10:48:21', 0, 1002001015, '账号未登陆', '2019-09-08 10:48:21');
INSERT INTO `access_log` VALUES (76955, '65.45.15679109010453479', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.79.35.120', '2019-09-08 10:48:21', 0, 1002001015, '账号未登陆', '2019-09-08 10:48:21');
INSERT INTO `access_log` VALUES (76956, '65.46.15679109131043463', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.79.35.120', '2019-09-08 10:48:33', 265, 0, '', '2019-09-08 10:48:33');
INSERT INTO `access_log` VALUES (76957, '65.49.15679109136953447', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.79.35.120', '2019-09-08 10:48:34', 10, 0, '', '2019-09-08 10:48:34');
INSERT INTO `access_log` VALUES (76958, '65.52.15679109136963497', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.79.35.120', '2019-09-08 10:48:34', 390, 2001001000, '服务端发生异常', '2019-09-08 10:48:34');
INSERT INTO `access_log` VALUES (76959, '65.47.15679109139843377', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '223.79.35.120', '2019-09-08 10:48:34', 103, 0, '', '2019-09-08 10:48:34');
INSERT INTO `access_log` VALUES (76960, '65.53.15679139203363419', 0, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=28&status=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 11:38:40', 13, 1002001012, '访问令牌已过期', '2019-09-08 11:38:40');
INSERT INTO `access_log` VALUES (76961, '65.54.15679139221503353', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 11:38:42', 70, 0, '', '2019-09-08 11:38:42');
INSERT INTO `access_log` VALUES (76962, '65.45.15679139225123521', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 11:38:43', 24, 0, '', '2019-09-08 11:38:43');
INSERT INTO `access_log` VALUES (76963, '65.51.15679139225113519', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 11:38:43', 27, 0, '', '2019-09-08 11:38:43');
INSERT INTO `access_log` VALUES (76964, '65.3607.15679139225135273', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 11:38:43', 22, 0, '', '2019-09-08 11:38:43');
INSERT INTO `access_log` VALUES (76965, '65.46.15679139252443505', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 11:38:45', 26, 0, '', '2019-09-08 11:38:45');
INSERT INTO `access_log` VALUES (76966, '65.49.15679139283323489', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 11:38:48', 18, 0, '', '2019-09-08 11:38:48');
INSERT INTO `access_log` VALUES (76967, '65.52.15679139372683539', 1, 2, 'admin-application', '/admin-api/admins/admin/update_status', 'id=28&status=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 11:38:57', 81, 0, '', '2019-09-08 11:38:57');
INSERT INTO `access_log` VALUES (76968, '65.50.15679139375243465', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 11:38:58', 18, 0, '', '2019-09-08 11:38:58');
INSERT INTO `access_log` VALUES (76969, '65.50.15679151221943481', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 11:58:42', 25, 0, '', '2019-09-08 11:58:42');
INSERT INTO `access_log` VALUES (76970, '65.45.15679151722533539', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 11:59:32', 10, 0, '', '2019-09-08 11:59:32');
INSERT INTO `access_log` VALUES (76971, '65.54.15679212177293451', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 13:40:18', 90, 0, '', '2019-09-08 13:40:18');
INSERT INTO `access_log` VALUES (76972, '65.3607.15679212180425371', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 13:40:18', 15, 0, '', '2019-09-08 13:40:18');
INSERT INTO `access_log` VALUES (76973, '65.51.15679212181133619', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 13:40:18', 26, 0, '', '2019-09-08 13:40:18');
INSERT INTO `access_log` VALUES (76974, '65.45.15679212181123623', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 13:40:18', 28, 0, '', '2019-09-08 13:40:18');
INSERT INTO `access_log` VALUES (76975, '65.47.15679240870983557', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 14:28:07', 29, 0, '', '2019-09-08 14:28:07');
INSERT INTO `access_log` VALUES (76976, '65.52.15679272360573719', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.228.79.126', '2019-09-08 15:20:36', 0, 1002001015, '账号未登陆', '2019-09-08 15:20:36');
INSERT INTO `access_log` VALUES (76977, '65.49.15679272360573669', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.228.79.126', '2019-09-08 15:20:36', 1, 1002001015, '账号未登陆', '2019-09-08 15:20:36');
INSERT INTO `access_log` VALUES (76978, '65.50.15679272360633645', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.228.79.126', '2019-09-08 15:20:36', 0, 1002001015, '账号未登陆', '2019-09-08 15:20:36');
INSERT INTO `access_log` VALUES (76979, '65.45.15679272580433705', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.228.79.126', '2019-09-08 15:20:58', 81, 0, '', '2019-09-08 15:20:58');
INSERT INTO `access_log` VALUES (76980, '65.3607.15679272583535453', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.228.79.126', '2019-09-08 15:20:58', 21, 0, '', '2019-09-08 15:20:58');
INSERT INTO `access_log` VALUES (76981, '65.51.15679272583573701', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.228.79.126', '2019-09-08 15:20:58', 19, 0, '', '2019-09-08 15:20:58');
INSERT INTO `access_log` VALUES (76982, '65.46.15679272583573685', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.228.79.126', '2019-09-08 15:20:58', 20, 2001001000, '服务端发生异常', '2019-09-08 15:20:58');
INSERT INTO `access_log` VALUES (76983, '65.52.15679272706183721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.228.79.126', '2019-09-08 15:21:11', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-08 15:21:11');
INSERT INTO `access_log` VALUES (76984, '65.49.15679272769323671', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.228.79.126', '2019-09-08 15:21:17', 83, 0, '', '2019-09-08 15:21:17');
INSERT INTO `access_log` VALUES (76985, '65.53.15679272771973603', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.228.79.126', '2019-09-08 15:21:17', 11, 0, '', '2019-09-08 15:21:17');
INSERT INTO `access_log` VALUES (76986, '65.50.15679272771963647', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.228.79.126', '2019-09-08 15:21:17', 13, 0, '', '2019-09-08 15:21:17');
INSERT INTO `access_log` VALUES (76987, '65.54.15679272772003535', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.228.79.126', '2019-09-08 15:21:17', 11, 2001001000, '服务端发生异常', '2019-09-08 15:21:17');
INSERT INTO `access_log` VALUES (76988, '59.76.15679279183099955', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.139.16.98', '2019-09-08 15:31:58', 11, 0, '', '2019-09-08 15:31:58');
INSERT INTO `access_log` VALUES (76989, '59.74.15679279183219981', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.139.16.98', '2019-09-08 15:31:58', 27, 2001001000, '服务端发生异常', '2019-09-08 15:31:58');
INSERT INTO `access_log` VALUES (76990, '59.74.15679313345800027', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:28:55', 26, 2001001000, '服务端发生异常', '2019-09-08 16:28:55');
INSERT INTO `access_log` VALUES (76991, '59.76.15679313345790001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:28:55', 77, 0, '', '2019-09-08 16:28:55');
INSERT INTO `access_log` VALUES (76992, '65.3607.15679313398695509', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:00', 0, 1002001015, '账号未登陆', '2019-09-08 16:29:00');
INSERT INTO `access_log` VALUES (76993, '65.46.15679313398683741', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:00', 0, 1002001015, '账号未登陆', '2019-09-08 16:29:00');
INSERT INTO `access_log` VALUES (76994, '65.51.15679313398703757', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:00', 0, 1002001015, '账号未登陆', '2019-09-08 16:29:00');
INSERT INTO `access_log` VALUES (76995, '65.47.15679313441873657', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:04', 82, 0, '', '2019-09-08 16:29:04');
INSERT INTO `access_log` VALUES (76996, '65.49.15679313446183727', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:05', 12, 0, '', '2019-09-08 16:29:05');
INSERT INTO `access_log` VALUES (76997, '65.50.15679313446193703', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:05', 13, 0, '', '2019-09-08 16:29:05');
INSERT INTO `access_log` VALUES (76998, '65.52.15679313446173777', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:05', 14, 2001001000, '服务端发生异常', '2019-09-08 16:29:05');
INSERT INTO `access_log` VALUES (76999, '65.54.15679313517893591', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:12', 23, 0, '', '2019-09-08 16:29:12');
INSERT INTO `access_log` VALUES (77000, '65.45.15679313517903763', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:12', 22, 2001001000, '服务端发生异常', '2019-09-08 16:29:12');
INSERT INTO `access_log` VALUES (77001, '65.3607.15679313518045511', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:12', 10, 0, '', '2019-09-08 16:29:12');
INSERT INTO `access_log` VALUES (77002, '64.77.15679313571820449', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:17', 14, 0, '', '2019-09-08 16:29:17');
INSERT INTO `access_log` VALUES (77003, '64.80.15679313573860463', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:17', 4, 0, '', '2019-09-08 16:29:17');
INSERT INTO `access_log` VALUES (77004, '64.85.15679313586030493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:19', 2, 0, '', '2019-09-08 16:29:19');
INSERT INTO `access_log` VALUES (77005, '64.76.15679313594410469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:19', 2, 0, '', '2019-09-08 16:29:19');
INSERT INTO `access_log` VALUES (77006, '64.78.15679313600250495', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:20', 2, 0, '', '2019-09-08 16:29:20');
INSERT INTO `access_log` VALUES (77007, '64.79.15679313606490469', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3895.5 Safari/537.36', '113.92.32.118', '2019-09-08 16:29:21', 3, 0, '', '2019-09-08 16:29:21');
INSERT INTO `access_log` VALUES (77008, '64.79.15679326975250487', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.139.16.98', '2019-09-08 16:51:38', 3, 0, '', '2019-09-08 16:51:38');
INSERT INTO `access_log` VALUES (77009, '64.81.15679326976880493', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '103.139.16.98', '2019-09-08 16:51:38', 1, 0, '', '2019-09-08 16:51:38');
INSERT INTO `access_log` VALUES (77010, '65.45.15679329750063785', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:56:15', 0, 1002001015, '账号未登陆', '2019-09-08 16:56:15');
INSERT INTO `access_log` VALUES (77011, '65.3607.15679329750065533', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:56:15', 0, 1002001015, '账号未登陆', '2019-09-08 16:56:15');
INSERT INTO `access_log` VALUES (77012, '65.46.15679329750333765', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:56:15', 0, 1002001015, '账号未登陆', '2019-09-08 16:56:15');
INSERT INTO `access_log` VALUES (77013, '65.51.15679329786433781', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:56:19', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-08 16:56:19');
INSERT INTO `access_log` VALUES (77014, '65.49.15679329959333751', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:56:36', 52, 0, '', '2019-09-08 16:56:36');
INSERT INTO `access_log` VALUES (77015, '65.50.15679329961973727', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:56:36', 12, 0, '', '2019-09-08 16:56:36');
INSERT INTO `access_log` VALUES (77016, '65.52.15679329961993801', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:56:36', 12, 2001001000, '服务端发生异常', '2019-09-08 16:56:36');
INSERT INTO `access_log` VALUES (77017, '65.53.15679329962013683', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:56:36', 13, 0, '', '2019-09-08 16:56:36');
INSERT INTO `access_log` VALUES (77018, '65.53.15679331280053685', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:58:48', 11, 0, '', '2019-09-08 16:58:48');
INSERT INTO `access_log` VALUES (77019, '65.54.15679331280053617', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:58:48', 12, 2001001000, '服务端发生异常', '2019-09-08 16:58:48');
INSERT INTO `access_log` VALUES (77020, '65.3607.15679331280355537', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:58:48', 17, 0, '', '2019-09-08 16:58:48');
INSERT INTO `access_log` VALUES (77021, '65.46.15679331424523769', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:59:02', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-08 16:59:02');
INSERT INTO `access_log` VALUES (77022, '65.47.15679331491363685', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:59:09', 52, 0, '', '2019-09-08 16:59:09');
INSERT INTO `access_log` VALUES (77023, '65.49.15679331493373755', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:59:09', 9, 0, '', '2019-09-08 16:59:09');
INSERT INTO `access_log` VALUES (77024, '65.50.15679331493373731', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:59:09', 10, 2001001000, '服务端发生异常', '2019-09-08 16:59:09');
INSERT INTO `access_log` VALUES (77025, '65.52.15679331493413805', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.81 Safari/537.36', '27.47.192.242', '2019-09-08 16:59:09', 8, 0, '', '2019-09-08 16:59:09');
INSERT INTO `access_log` VALUES (77026, '65.54.15679357269293653', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 17:42:07', 14, 1002001012, '访问令牌已过期', '2019-09-08 17:42:07');
INSERT INTO `access_log` VALUES (77027, '65.3607.15679357269295573', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 17:42:07', 17, 1002001012, '访问令牌已过期', '2019-09-08 17:42:07');
INSERT INTO `access_log` VALUES (77028, '65.45.15679357269303825', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 17:42:07', 19, 1002001012, '访问令牌已过期', '2019-09-08 17:42:07');
INSERT INTO `access_log` VALUES (77029, '65.46.15679357270233805', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 17:42:07', 3, 1002001012, '访问令牌已过期', '2019-09-08 17:42:07');
INSERT INTO `access_log` VALUES (77030, '65.47.15679357292653721', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 17:42:09', 65, 0, '', '2019-09-08 17:42:09');
INSERT INTO `access_log` VALUES (77031, '65.52.15679357295553841', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 17:42:10', 13, 0, '', '2019-09-08 17:42:10');
INSERT INTO `access_log` VALUES (77032, '65.49.15679357295583791', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 17:42:10', 13, 0, '', '2019-09-08 17:42:10');
INSERT INTO `access_log` VALUES (77033, '65.50.15679357295643767', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 17:42:10', 9, 0, '', '2019-09-08 17:42:10');
INSERT INTO `access_log` VALUES (77034, '65.54.15679357475783655', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 17:42:28', 10, 0, '', '2019-09-08 17:42:28');
INSERT INTO `access_log` VALUES (77035, '65.47.15679429684393819', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 19:42:48', 17, 1002001012, '访问令牌已过期', '2019-09-08 19:42:48');
INSERT INTO `access_log` VALUES (77036, '65.53.15679429699793821', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 19:42:50', 87, 0, '', '2019-09-08 19:42:50');
INSERT INTO `access_log` VALUES (77037, '65.52.15679429703733939', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 19:42:50', 24, 0, '', '2019-09-08 19:42:50');
INSERT INTO `access_log` VALUES (77038, '65.46.15679429703763903', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 19:42:50', 24, 0, '', '2019-09-08 19:42:50');
INSERT INTO `access_log` VALUES (77039, '65.50.15679429703763865', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 19:42:50', 25, 0, '', '2019-09-08 19:42:50');
INSERT INTO `access_log` VALUES (77040, '65.54.15679429742453753', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 19:42:54', 25, 0, '', '2019-09-08 19:42:54');
INSERT INTO `access_log` VALUES (77041, '59.71.15679432095080171', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:46:50', 10, 0, '', '2019-09-08 19:46:50');
INSERT INTO `access_log` VALUES (77042, '59.75.15679432095080181', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:46:50', 24, 2001001000, '服务端发生异常', '2019-09-08 19:46:50');
INSERT INTO `access_log` VALUES (77043, '64.82.15679432123480643', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:46:52', 11, 0, '', '2019-09-08 19:46:52');
INSERT INTO `access_log` VALUES (77044, '64.77.15679432125680609', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:46:53', 5, 0, '', '2019-09-08 19:46:53');
INSERT INTO `access_log` VALUES (77045, '64.80.15679432135840623', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:46:54', 3, 0, '', '2019-09-08 19:46:54');
INSERT INTO `access_log` VALUES (77046, '64.85.15679432143680653', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:46:54', 2, 0, '', '2019-09-08 19:46:54');
INSERT INTO `access_log` VALUES (77047, '64.76.15679432170360629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:46:57', 2, 0, '', '2019-09-08 19:46:57');
INSERT INTO `access_log` VALUES (77048, '64.78.15679432173080655', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:46:57', 2, 0, '', '2019-09-08 19:46:57');
INSERT INTO `access_log` VALUES (77049, '66.57.15679432215367503', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:47:02', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空\n账号长度为 11 位\n手机验证码不能为空\n手机号必须都是数字', '2019-09-08 19:47:02');
INSERT INTO `access_log` VALUES (77050, '66.56.15679432287847517', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:09', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n手机验证码不能为空\n账号长度为 11 位\n手机号必须都是数字\n手机验证码必须都是数字\n手机验证码长度为 4-6 位\n手机号不能为空', '2019-09-08 19:47:09');
INSERT INTO `access_log` VALUES (77051, '64.79.15679432310680629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:11', 2, 0, '', '2019-09-08 19:47:11');
INSERT INTO `access_log` VALUES (77052, '64.81.15679432312360635', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:11', 2, 0, '', '2019-09-08 19:47:11');
INSERT INTO `access_log` VALUES (77053, '64.84.15679432329880629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:13', 2, 0, '', '2019-09-08 19:47:13');
INSERT INTO `access_log` VALUES (77054, '64.82.15679432337560645', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:14', 2, 0, '', '2019-09-08 19:47:14');
INSERT INTO `access_log` VALUES (77055, '64.77.15679432349320611', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:15', 2, 0, '', '2019-09-08 19:47:15');
INSERT INTO `access_log` VALUES (77056, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:15', 13, 0, '', '2019-09-08 19:47:15');
INSERT INTO `access_log` VALUES (77057, '64.80.15679432368840625', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:17', 8, 0, '', '2019-09-08 19:47:17');
INSERT INTO `access_log` VALUES (77058, '64.78.15679432558360657', 0, 1, 'product-application', '/product-api/users/spu/info', 'id=37', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:36', 6, 0, '', '2019-09-08 19:47:36');
INSERT INTO `access_log` VALUES (77059, '64.83.15679432568760629', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:37', 2, 0, '', '2019-09-08 19:47:37');
INSERT INTO `access_log` VALUES (77060, 'N/A', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:37', 6, 0, '', '2019-09-08 19:47:37');
INSERT INTO `access_log` VALUES (77061, '64.79.15679432578360631', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:38', 2, 0, '', '2019-09-08 19:47:38');
INSERT INTO `access_log` VALUES (77062, '64.81.15679432580040637', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:38', 599, 0, '', '2019-09-08 19:47:39');
INSERT INTO `access_log` VALUES (77063, '59.72.15679432586160173', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:39', 2, 0, '', '2019-09-08 19:47:39');
INSERT INTO `access_log` VALUES (77064, '59.76.15679432586880161', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '42.90.118.146', '2019-09-08 19:47:39', 17, 2001001000, '服务端发生异常', '2019-09-08 19:47:39');
INSERT INTO `access_log` VALUES (77065, '65.52.15679433246013945', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:48:45', 0, 1002001015, '账号未登陆', '2019-09-08 19:48:45');
INSERT INTO `access_log` VALUES (77066, '65.47.15679433246003825', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:48:45', 0, 1002001015, '账号未登陆', '2019-09-08 19:48:45');
INSERT INTO `access_log` VALUES (77067, '65.53.15679433246003827', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:48:45', 0, 1002001015, '账号未登陆', '2019-09-08 19:48:45');
INSERT INTO `access_log` VALUES (77068, '65.50.15679433272513871', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:48:47', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-08 19:48:47');
INSERT INTO `access_log` VALUES (77069, '65.49.15679433404073895', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:49:00', 63, 0, '', '2019-09-08 19:49:00');
INSERT INTO `access_log` VALUES (77070, '65.45.15679433412093933', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:49:01', 10, 0, '', '2019-09-08 19:49:01');
INSERT INTO `access_log` VALUES (77071, '65.54.15679433412083759', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:49:01', 12, 0, '', '2019-09-08 19:49:01');
INSERT INTO `access_log` VALUES (77072, '65.3607.15679433412085681', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '42.90.118.146', '2019-09-08 19:49:01', 12, 2001001000, '服务端发生异常', '2019-09-08 19:49:01');
INSERT INTO `access_log` VALUES (77073, '59.72.15679433848460175', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '122.224.161.136', '2019-09-08 19:49:45', 3, 0, '', '2019-09-08 19:49:45');
INSERT INTO `access_log` VALUES (77074, '59.76.15679433848460163', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '122.224.161.136', '2019-09-08 19:49:45', 16, 2001001000, '服务端发生异常', '2019-09-08 19:49:45');
INSERT INTO `access_log` VALUES (77075, '64.81.15679433948900639', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.161.136', '2019-09-08 19:49:55', 2, 0, '', '2019-09-08 19:49:55');
INSERT INTO `access_log` VALUES (77076, '64.84.15679433950070633', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.161.136', '2019-09-08 19:49:55', 2, 0, '', '2019-09-08 19:49:55');
INSERT INTO `access_log` VALUES (77077, '64.82.15679434006270649', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.161.136', '2019-09-08 19:50:01', 2, 0, '', '2019-09-08 19:50:01');
INSERT INTO `access_log` VALUES (77078, '64.77.15679434007120615', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.161.136', '2019-09-08 19:50:01', 3, 0, '', '2019-09-08 19:50:01');
INSERT INTO `access_log` VALUES (77079, '59.79.15679511137130285', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.240.210.34', '2019-09-08 21:58:34', 10, 0, '', '2019-09-08 21:58:34');
INSERT INTO `access_log` VALUES (77080, '59.71.15679511137130279', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '122.240.210.34', '2019-09-08 21:58:34', 15, 2001001000, '服务端发生异常', '2019-09-08 21:58:34');
INSERT INTO `access_log` VALUES (77081, '65.52.15679514862254055', 0, 2, 'admin-application', '/admin-api/admins/role/delete', 'id=11', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:04:46', 4, 1002001012, '访问令牌已过期', '2019-09-08 22:04:46');
INSERT INTO `access_log` VALUES (77082, '65.50.15679514863623981', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:04:46', 4, 1002001012, '访问令牌已过期', '2019-09-08 22:04:46');
INSERT INTO `access_log` VALUES (77083, '65.46.15679514881784019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:04:48', 226, 0, '', '2019-09-08 22:04:48');
INSERT INTO `access_log` VALUES (77084, '65.45.15679514886844043', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:04:49', 16, 0, '', '2019-09-08 22:04:49');
INSERT INTO `access_log` VALUES (77085, '65.3607.15679514886865791', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:04:49', 15, 0, '', '2019-09-08 22:04:49');
INSERT INTO `access_log` VALUES (77086, '65.49.15679514886844005', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:04:49', 19, 0, '', '2019-09-08 22:04:49');
INSERT INTO `access_log` VALUES (77087, '65.45.15679515873714045', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:06:27', 84, 0, '', '2019-09-08 22:06:27');
INSERT INTO `access_log` VALUES (77088, '65.3607.15679515882615793', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:06:28', 11, 0, '', '2019-09-08 22:06:28');
INSERT INTO `access_log` VALUES (77089, '65.49.15679515929164007', 1, 2, 'admin-application', '/admin-api/admins/role/add', 'name=aaa', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:06:33', 63, 0, '', '2019-09-08 22:06:33');
INSERT INTO `access_log` VALUES (77090, '65.54.15679515931363871', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:06:33', 11, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-09-08 22:06:33');
INSERT INTO `access_log` VALUES (77091, '65.51.15679515969924039', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:06:37', 27, 0, '', '2019-09-08 22:06:37');
INSERT INTO `access_log` VALUES (77092, '65.47.15679515976563939', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:06:38', 11, 0, '', '2019-09-08 22:06:38');
INSERT INTO `access_log` VALUES (77093, '65.52.15679516032844059', 1, 2, 'admin-application', '/admin-api/admins/role/delete', 'id=12', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:06:43', 98, 0, '', '2019-09-08 22:06:43');
INSERT INTO `access_log` VALUES (77094, '65.50.15679516035363985', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:06:44', 14, 2001001002, '参数校验不正确\n\n详细错误如下：\n页码最小值为 1', '2019-09-08 22:06:44');
INSERT INTO `access_log` VALUES (77095, '65.46.15679516076364023', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:06:48', 15, 0, '', '2019-09-08 22:06:48');
INSERT INTO `access_log` VALUES (77096, '65.45.15679516085564047', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:06:49', 10, 0, '', '2019-09-08 22:06:49');
INSERT INTO `access_log` VALUES (77097, '65.45.15679517419174049', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:09:02', 18, 0, '', '2019-09-08 22:09:02');
INSERT INTO `access_log` VALUES (77098, '65.3607.15679517439965797', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.86.111', '2019-09-08 22:09:04', 9, 0, '', '2019-09-08 22:09:04');
INSERT INTO `access_log` VALUES (77099, '65.53.15679531447333963', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:32:25', 11, 0, '', '2019-09-08 22:32:25');
INSERT INTO `access_log` VALUES (77100, '62.81.15679532960008761', 1, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:34:56', 31, 0, '', '2019-09-08 22:34:56');
INSERT INTO `access_log` VALUES (77101, '65.50.15679533123794009', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:35:12', 10, 0, '', '2019-09-08 22:35:12');
INSERT INTO `access_log` VALUES (77102, '65.45.15679533362304071', 1, 2, 'admin-application', '/admin-api/admins/data_dict/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:35:36', 12, 0, '', '2019-09-08 22:35:36');
INSERT INTO `access_log` VALUES (77103, '65.49.15679533423584033', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:35:42', 10, 0, '', '2019-09-08 22:35:42');
INSERT INTO `access_log` VALUES (77104, '59.75.15679539655250327', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.87.35.170', '2019-09-08 22:46:06', 13, 0, '', '2019-09-08 22:46:06');
INSERT INTO `access_log` VALUES (77105, '59.80.15679539656250289', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.87.35.170', '2019-09-08 22:46:06', 20, 2001001000, '服务端发生异常', '2019-09-08 22:46:06');
INSERT INTO `access_log` VALUES (77106, '65.47.15679539744753973', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.87.35.170', '2019-09-08 22:46:14', 1, 1002001015, '账号未登陆', '2019-09-08 22:46:14');
INSERT INTO `access_log` VALUES (77107, '65.53.15679539744823975', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.87.35.170', '2019-09-08 22:46:14', 0, 1002001015, '账号未登陆', '2019-09-08 22:46:14');
INSERT INTO `access_log` VALUES (77108, '65.52.15679539748314093', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.87.35.170', '2019-09-08 22:46:15', 0, 1002001015, '账号未登陆', '2019-09-08 22:46:15');
INSERT INTO `access_log` VALUES (77109, '65.50.15679539765164019', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.87.35.170', '2019-09-08 22:46:17', 16, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-08 22:46:17');
INSERT INTO `access_log` VALUES (77110, '65.45.15679539847894081', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.87.35.170', '2019-09-08 22:46:25', 112, 0, '', '2019-09-08 22:46:25');
INSERT INTO `access_log` VALUES (77111, '65.3607.15679539851975829', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.87.35.170', '2019-09-08 22:46:25', 21, 0, '', '2019-09-08 22:46:25');
INSERT INTO `access_log` VALUES (77112, '65.54.15679539852043907', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.87.35.170', '2019-09-08 22:46:25', 18, 0, '', '2019-09-08 22:46:25');
INSERT INTO `access_log` VALUES (77113, '65.49.15679539852014043', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '223.87.35.170', '2019-09-08 22:46:25', 20, 2001001000, '服务端发生异常', '2019-09-08 22:46:25');
INSERT INTO `access_log` VALUES (77114, '65.53.15679546040783985', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '202.119.46.57', '2019-09-08 22:56:44', 1, 1002001015, '账号未登陆', '2019-09-08 22:56:44');
INSERT INTO `access_log` VALUES (77115, '65.47.15679546040773983', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '202.119.46.57', '2019-09-08 22:56:44', 0, 1002001015, '账号未登陆', '2019-09-08 22:56:44');
INSERT INTO `access_log` VALUES (77116, '65.52.15679546040984103', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '202.119.46.57', '2019-09-08 22:56:44', 0, 1002001015, '账号未登陆', '2019-09-08 22:56:44');
INSERT INTO `access_log` VALUES (77117, '65.51.15679546934714085', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:58:13', 3, 1002001012, '访问令牌已过期', '2019-09-08 22:58:13');
INSERT INTO `access_log` VALUES (77118, '65.53.15679546957163987', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:58:16', 94, 0, '', '2019-09-08 22:58:16');
INSERT INTO `access_log` VALUES (77119, '65.52.15679546960944105', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:58:16', 10, 0, '', '2019-09-08 22:58:16');
INSERT INTO `access_log` VALUES (77120, '65.50.15679546960984031', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:58:16', 11, 0, '', '2019-09-08 22:58:16');
INSERT INTO `access_log` VALUES (77121, '65.47.15679546960943985', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:58:16', 17, 0, '', '2019-09-08 22:58:16');
INSERT INTO `access_log` VALUES (77122, '65.46.15679546991954069', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '202.119.46.57', '2019-09-08 22:58:19', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-08 22:58:19');
INSERT INTO `access_log` VALUES (77123, '65.45.15679547002654093', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:58:20', 18, 0, '', '2019-09-08 22:58:20');
INSERT INTO `access_log` VALUES (77124, '65.3607.15679547023115841', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=9', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:58:22', 12, 0, '', '2019-09-08 22:58:22');
INSERT INTO `access_log` VALUES (77125, '65.54.15679547039883919', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=admin&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '202.119.46.57', '2019-09-08 22:58:24', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-08 22:58:24');
INSERT INTO `access_log` VALUES (77126, '65.51.15679547135864087', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:58:34', 19, 0, '', '2019-09-08 22:58:34');
INSERT INTO `access_log` VALUES (77127, '65.53.15679547170453989', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:58:37', 18, 0, '', '2019-09-08 22:58:37');
INSERT INTO `access_log` VALUES (77128, '65.52.15679547265424107', 1, 2, 'admin-application', '/admin-api/admins/admin/update', 'id=28&username=zhangxinzhe&nickname=张信哲&password=123456', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:58:47', 161, 0, '', '2019-09-08 22:58:47');
INSERT INTO `access_log` VALUES (77129, '65.47.15679547269613987', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:58:47', 18, 0, '', '2019-09-08 22:58:47');
INSERT INTO `access_log` VALUES (77130, '65.45.15679547351114095', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=张信哲&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:58:55', 8, 2001001002, '参数校验不正确\n\n详细错误如下：\n账号长度为 5-16 位\n账号格式为数字以及字母', '2019-09-08 22:58:55');
INSERT INTO `access_log` VALUES (77131, '65.3607.15679547465175843', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=zhangxinzhe&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:59:07', 331, 0, '', '2019-09-08 22:59:07');
INSERT INTO `access_log` VALUES (77132, '65.49.15679547471314057', 28, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:59:07', 18, 0, '', '2019-09-08 22:59:07');
INSERT INTO `access_log` VALUES (77133, '65.54.15679547471313921', 28, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:59:07', 19, 0, '', '2019-09-08 22:59:07');
INSERT INTO `access_log` VALUES (77134, '65.51.15679547471314089', 28, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:59:07', 18, 0, '', '2019-09-08 22:59:07');
INSERT INTO `access_log` VALUES (77135, '65.50.15679547618604035', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:59:22', 282, 0, '', '2019-09-08 22:59:22');
INSERT INTO `access_log` VALUES (77136, '65.47.15679547623683989', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:59:22', 8, 0, '', '2019-09-08 22:59:22');
INSERT INTO `access_log` VALUES (77137, '65.52.15679547623684109', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:59:22', 10, 0, '', '2019-09-08 22:59:22');
INSERT INTO `access_log` VALUES (77138, '65.46.15679547623694073', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:59:22', 10, 0, '', '2019-09-08 22:59:22');
INSERT INTO `access_log` VALUES (77139, '65.3607.15679547653105845', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:59:25', 17, 0, '', '2019-09-08 22:59:25');
INSERT INTO `access_log` VALUES (77140, '65.51.15679547678724091', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:59:28', 23, 0, '', '2019-09-08 22:59:28');
INSERT INTO `access_log` VALUES (77141, '65.49.15679547700954059', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:59:30', 12, 0, '', '2019-09-08 22:59:30');
INSERT INTO `access_log` VALUES (77142, '65.53.15679547839903993', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=27', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:59:44', 11, 0, '', '2019-09-08 22:59:44');
INSERT INTO `access_log` VALUES (77143, '65.47.15679547954563991', 1, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:59:55', 11, 0, '', '2019-09-08 22:59:55');
INSERT INTO `access_log` VALUES (77144, '65.52.15679547986034111', 1, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 22:59:59', 10, 0, '', '2019-09-08 22:59:59');
INSERT INTO `access_log` VALUES (77145, '65.46.15679548008114075', 1, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=11', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:00:01', 12, 0, '', '2019-09-08 23:00:01');
INSERT INTO `access_log` VALUES (77146, '65.3607.15679548094785847', 1, 2, 'admin-application', '/admin-api/admins/role/assign_resource', 'id=11&resourceIds=13,14,15,16,19,32,34,43,47,48,49,50', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:00:09', 138, 0, '', '2019-09-08 23:00:10');
INSERT INTO `access_log` VALUES (77147, '65.51.15679548153724093', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=zhangxinzhe&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:00:15', 69, 0, '', '2019-09-08 23:00:15');
INSERT INTO `access_log` VALUES (77148, '65.49.15679548156474061', 28, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:00:16', 9, 0, '', '2019-09-08 23:00:16');
INSERT INTO `access_log` VALUES (77149, '65.54.15679548156483925', 28, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:00:16', 8, 0, '', '2019-09-08 23:00:16');
INSERT INTO `access_log` VALUES (77150, '65.53.15679548156493995', 28, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:00:16', 9, 0, '', '2019-09-08 23:00:16');
INSERT INTO `access_log` VALUES (77151, '65.50.15679548191564039', 28, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:00:19', 18, 0, '', '2019-09-08 23:00:19');
INSERT INTO `access_log` VALUES (77152, '65.47.15679548218123993', 28, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:00:22', 10, 0, '', '2019-09-08 23:00:22');
INSERT INTO `access_log` VALUES (77153, '65.46.15679548288374077', 28, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:00:29', 10, 0, '', '2019-09-08 23:00:29');
INSERT INTO `access_log` VALUES (77154, '65.45.15679548343294101', 28, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:00:34', 8, 0, '', '2019-09-08 23:00:34');
INSERT INTO `access_log` VALUES (77155, '65.3607.15679548373395849', 28, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=11', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:00:37', 12, 0, '', '2019-09-08 23:00:37');
INSERT INTO `access_log` VALUES (77156, '65.49.15679548476554063', 28, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:00:48', 165, 0, '', '2019-09-08 23:00:48');
INSERT INTO `access_log` VALUES (77157, '65.54.15679548503123927', 28, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=3&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:00:50', 17, 0, '', '2019-09-08 23:00:50');
INSERT INTO `access_log` VALUES (77158, '65.50.15679548565054041', 28, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=27', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:00:57', 11, 0, '', '2019-09-08 23:00:57');
INSERT INTO `access_log` VALUES (77159, '65.52.15679548717234115', 28, 2, 'admin-application', '/admin-api/admins/admin/role_list', 'id=28', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '123.158.85.114', '2019-09-08 23:01:12', 13, 0, '', '2019-09-08 23:01:12');
INSERT INTO `access_log` VALUES (77160, '65.47.15679557099164007', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.87.214.150', '2019-09-08 23:15:10', 5, 1002001012, '访问令牌已过期', '2019-09-08 23:15:10');
INSERT INTO `access_log` VALUES (77161, '65.53.15679557099164009', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.87.214.150', '2019-09-08 23:15:10', 5, 1002001012, '访问令牌已过期', '2019-09-08 23:15:10');
INSERT INTO `access_log` VALUES (77162, '65.50.15679557099164053', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.87.214.150', '2019-09-08 23:15:10', 5, 1002001012, '访问令牌已过期', '2019-09-08 23:15:10');
INSERT INTO `access_log` VALUES (77163, '65.52.15679557131034127', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=buzhidao&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.87.214.150', '2019-09-08 23:15:13', 76, 0, '', '2019-09-08 23:15:13');
INSERT INTO `access_log` VALUES (77164, '65.45.15679557133314115', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.87.214.150', '2019-09-08 23:15:13', 9, 0, '', '2019-09-08 23:15:13');
INSERT INTO `access_log` VALUES (77165, '65.46.15679557133304091', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.87.214.150', '2019-09-08 23:15:13', 9, 0, '', '2019-09-08 23:15:13');
INSERT INTO `access_log` VALUES (77166, '65.3607.15679557133345863', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.87.214.150', '2019-09-08 23:15:13', 10, 0, '', '2019-09-08 23:15:13');
INSERT INTO `access_log` VALUES (77167, '64.76.15679557167810799', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.87.214.150', '2019-09-08 23:15:17', 27, 0, '', '2019-09-08 23:15:17');
INSERT INTO `access_log` VALUES (77168, '64.85.15679557167800823', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '101.87.214.150', '2019-09-08 23:15:17', 33, 0, '', '2019-09-08 23:15:17');
INSERT INTO `access_log` VALUES (77169, '59.79.15679566021920359', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '1.86.10.134', '2019-09-08 23:30:02', 10, 0, '', '2019-09-08 23:30:02');
INSERT INTO `access_log` VALUES (77170, '59.71.15679566021960353', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '1.86.10.134', '2019-09-08 23:30:02', 15, 2001001000, '服务端发生异常', '2019-09-08 23:30:02');
INSERT INTO `access_log` VALUES (77171, '64.78.15679566079400837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '1.86.10.134', '2019-09-08 23:30:08', 6, 0, '', '2019-09-08 23:30:08');
INSERT INTO `access_log` VALUES (77172, '64.83.15679566081140809', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '1.86.10.134', '2019-09-08 23:30:08', 3, 0, '', '2019-09-08 23:30:08');
INSERT INTO `access_log` VALUES (77173, '59.75.15679566177880363', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '1.86.10.134', '2019-09-08 23:30:18', 3, 0, '', '2019-09-08 23:30:18');
INSERT INTO `access_log` VALUES (77174, '59.80.15679566177930325', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.87 Safari/537.36', '1.86.10.134', '2019-09-08 23:30:18', 32, 2001001000, '服务端发生异常', '2019-09-08 23:30:18');
INSERT INTO `access_log` VALUES (77175, '59.78.15679585199880391', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.253.81.201', '2019-09-09 00:02:00', 9, 0, '', '2019-09-09 00:02:00');
INSERT INTO `access_log` VALUES (77176, '59.75.15679585199880389', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.253.81.201', '2019-09-09 00:02:00', 20, 2001001000, '服务端发生异常', '2019-09-09 00:02:00');
INSERT INTO `access_log` VALUES (77177, '65.45.15679585245504153', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.253.81.201', '2019-09-09 00:02:05', 0, 1002001015, '账号未登陆', '2019-09-09 00:02:05');
INSERT INTO `access_log` VALUES (77178, '65.46.15679585245534129', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.253.81.201', '2019-09-09 00:02:05', 1, 1002001015, '账号未登陆', '2019-09-09 00:02:05');
INSERT INTO `access_log` VALUES (77179, '65.3607.15679585245535901', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.253.81.201', '2019-09-09 00:02:05', 1, 1002001015, '账号未登陆', '2019-09-09 00:02:05');
INSERT INTO `access_log` VALUES (77180, '64.79.15679585679340837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.253.81.201', '2019-09-09 00:02:48', 11, 0, '', '2019-09-09 00:02:48');
INSERT INTO `access_log` VALUES (77181, '64.81.15679585681070843', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=579', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.253.81.201', '2019-09-09 00:02:48', 3, 0, '', '2019-09-09 00:02:48');
INSERT INTO `access_log` VALUES (77182, '64.84.15679585695700837', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=90', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.253.81.201', '2019-09-09 00:02:50', 2, 0, '', '2019-09-09 00:02:50');
INSERT INTO `access_log` VALUES (77183, '64.82.15679585701350853', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=793', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.253.81.201', '2019-09-09 00:02:50', 1, 0, '', '2019-09-09 00:02:50');
INSERT INTO `access_log` VALUES (77184, '65.47.15679585724524047', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.253.81.201', '2019-09-09 00:02:52', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-09 00:02:52');
INSERT INTO `access_log` VALUES (77185, '65.47.15679590001484053', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '114.253.81.201', '2019-09-09 00:10:00', 7, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-09 00:10:00');
INSERT INTO `access_log` VALUES (77186, '65.52.15679708685454331', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.131.105.57', '2019-09-09 03:27:49', 8, 1002001015, '账号未登陆', '2019-09-09 03:27:49');
INSERT INTO `access_log` VALUES (77187, '65.50.15679708685444257', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.131.105.57', '2019-09-09 03:27:49', 8, 1002001015, '账号未登陆', '2019-09-09 03:27:49');
INSERT INTO `access_log` VALUES (77188, '65.3607.15679708685456067', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.131.105.57', '2019-09-09 03:27:49', 8, 1002001015, '账号未登陆', '2019-09-09 03:27:49');
INSERT INTO `access_log` VALUES (77189, '65.46.15679708721014295', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.131.105.57', '2019-09-09 03:27:52', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-09 03:27:52');
INSERT INTO `access_log` VALUES (77190, '65.51.15679708861824313', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.131.105.57', '2019-09-09 03:28:06', 68, 0, '', '2019-09-09 03:28:06');
INSERT INTO `access_log` VALUES (77191, '65.49.15679708867044281', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.131.105.57', '2019-09-09 03:28:07', 15, 0, '', '2019-09-09 03:28:07');
INSERT INTO `access_log` VALUES (77192, '65.54.15679708867104145', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.131.105.57', '2019-09-09 03:28:07', 11, 2001001000, '服务端发生异常', '2019-09-09 03:28:07');
INSERT INTO `access_log` VALUES (77193, '65.47.15679708867154213', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '119.131.105.57', '2019-09-09 03:28:07', 13, 0, '', '2019-09-09 03:28:07');
INSERT INTO `access_log` VALUES (77194, '65.49.15679889802514523', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.53', '2019-09-09 08:29:40', 7, 1002001015, '账号未登陆', '2019-09-09 08:29:40');
INSERT INTO `access_log` VALUES (77195, '65.54.15679889802514387', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.53', '2019-09-09 08:29:40', 0, 1002001015, '账号未登陆', '2019-09-09 08:29:40');
INSERT INTO `access_log` VALUES (77196, '65.47.15679889802514455', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.53', '2019-09-09 08:29:40', 5, 1002001015, '账号未登陆', '2019-09-09 08:29:40');
INSERT INTO `access_log` VALUES (77197, '65.53.15679889866704457', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.53', '2019-09-09 08:29:47', 64, 0, '', '2019-09-09 08:29:47');
INSERT INTO `access_log` VALUES (77198, '65.52.15679889869014575', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.53', '2019-09-09 08:29:47', 50, 0, '', '2019-09-09 08:29:47');
INSERT INTO `access_log` VALUES (77199, '65.50.15679889869024501', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.53', '2019-09-09 08:29:47', 52, 2001001000, '服务端发生异常', '2019-09-09 08:29:47');
INSERT INTO `access_log` VALUES (77200, '65.3607.15679889869026311', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '122.233.200.53', '2019-09-09 08:29:47', 52, 0, '', '2019-09-09 08:29:47');
INSERT INTO `access_log` VALUES (77201, '65.53.15679897994914469', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:43:19', 0, 1002001015, '账号未登陆', '2019-09-09 08:43:19');
INSERT INTO `access_log` VALUES (77202, '65.54.15679897994834399', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:43:19', 1, 1002001015, '账号未登陆', '2019-09-09 08:43:19');
INSERT INTO `access_log` VALUES (77203, '65.49.15679897994834535', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:43:19', 1, 1002001015, '账号未登陆', '2019-09-09 08:43:19');
INSERT INTO `access_log` VALUES (77204, '65.3607.15679898095086323', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:43:30', 105, 0, '', '2019-09-09 08:43:30');
INSERT INTO `access_log` VALUES (77205, '65.52.15679898100344587', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:43:30', 17, 0, '', '2019-09-09 08:43:30');
INSERT INTO `access_log` VALUES (77206, '65.45.15679898100434575', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:43:30', 10, 0, '', '2019-09-09 08:43:30');
INSERT INTO `access_log` VALUES (77207, '65.46.15679898100354551', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:43:30', 18, 2001001000, '服务端发生异常', '2019-09-09 08:43:30');
INSERT INTO `access_log` VALUES (77208, '65.53.15679898434684471', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:03', 10, 0, '', '2019-09-09 08:44:03');
INSERT INTO `access_log` VALUES (77209, '65.54.15679898434704401', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:03', 10, 2001001000, '服务端发生异常', '2019-09-09 08:44:03');
INSERT INTO `access_log` VALUES (77210, '65.49.15679898434754537', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:03', 9, 0, '', '2019-09-09 08:44:03');
INSERT INTO `access_log` VALUES (77211, '65.50.15679898461034515', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:06', 9, 0, '', '2019-09-09 08:44:06');
INSERT INTO `access_log` VALUES (77212, '65.3607.15679898461056325', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:06', 22, 2001001000, '服务端发生异常', '2019-09-09 08:44:06');
INSERT INTO `access_log` VALUES (77213, '65.52.15679898461114589', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:06', 18, 0, '', '2019-09-09 08:44:06');
INSERT INTO `access_log` VALUES (77214, '65.47.15679898707834471', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:31', 10, 2001001000, '服务端发生异常', '2019-09-09 08:44:31');
INSERT INTO `access_log` VALUES (77215, '65.53.15679898707924473', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:31', 105, 0, '', '2019-09-09 08:44:31');
INSERT INTO `access_log` VALUES (77216, '65.51.15679898707804571', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:31', 122, 0, '', '2019-09-09 08:44:31');
INSERT INTO `access_log` VALUES (77217, '65.54.15679898778024403', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:38', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-09 08:44:38');
INSERT INTO `access_log` VALUES (77218, '65.3607.15679898867276327', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:47', 98, 0, '', '2019-09-09 08:44:47');
INSERT INTO `access_log` VALUES (77219, '65.52.15679898870134591', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:47', 10, 0, '', '2019-09-09 08:44:47');
INSERT INTO `access_log` VALUES (77220, '65.45.15679898870204579', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:47', 22, 0, '', '2019-09-09 08:44:47');
INSERT INTO `access_log` VALUES (77221, '65.50.15679898870174517', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:47', 30, 0, '', '2019-09-09 08:44:47');
INSERT INTO `access_log` VALUES (77222, '64.82.15679898975821271', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:58', 26, 0, '', '2019-09-09 08:44:58');
INSERT INTO `access_log` VALUES (77223, '64.77.15679898975851237', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:44:58', 27, 0, '', '2019-09-09 08:44:58');
INSERT INTO `access_log` VALUES (77224, '64.76.15679899043141257', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:45:04', 18, 0, '', '2019-09-09 08:45:04');
INSERT INTO `access_log` VALUES (77225, '64.80.15679899043111251', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:45:04', 21, 0, '', '2019-09-09 08:45:04');
INSERT INTO `access_log` VALUES (77226, '66.55.15679899071828107', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:45:07', 22, 0, '', '2019-09-09 08:45:07');
INSERT INTO `access_log` VALUES (77227, '65.53.15679899110544475', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:45:11', 23, 0, '', '2019-09-09 08:45:11');
INSERT INTO `access_log` VALUES (77228, '66.49.15679899174908131', 1, 2, 'user-application', '/user-api/admins/user/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:45:17', 12, 0, '', '2019-09-09 08:45:18');
INSERT INTO `access_log` VALUES (77229, '64.83.15679899195381255', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:45:20', 11, 0, '', '2019-09-09 08:45:20');
INSERT INTO `access_log` VALUES (77230, '64.78.15679899195361283', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:45:20', 15, 0, '', '2019-09-09 08:45:20');
INSERT INTO `access_log` VALUES (77231, '64.81.15679899224471263', 1, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:45:22', 10, 0, '', '2019-09-09 08:45:22');
INSERT INTO `access_log` VALUES (77232, '64.84.15679899224481257', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '61.187.92.238', '2019-09-09 08:45:22', 9, 0, '', '2019-09-09 08:45:22');
INSERT INTO `access_log` VALUES (77233, '65.49.15679929406474581', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '110.83.243.2', '2019-09-09 09:35:41', 25, 1002001012, '访问令牌已过期', '2019-09-09 09:35:41');
INSERT INTO `access_log` VALUES (77234, '65.3607.15679929406486369', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '110.83.243.2', '2019-09-09 09:35:41', 25, 1002001012, '访问令牌已过期', '2019-09-09 09:35:41');
INSERT INTO `access_log` VALUES (77235, '65.52.15679929406484633', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '110.83.243.2', '2019-09-09 09:35:41', 27, 1002001012, '访问令牌已过期', '2019-09-09 09:35:41');
INSERT INTO `access_log` VALUES (77236, '65.45.15679929423104621', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '110.83.243.2', '2019-09-09 09:35:42', 6, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-09 09:35:42');
INSERT INTO `access_log` VALUES (77237, '65.50.15679929439394559', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '110.83.243.2', '2019-09-09 09:35:44', 9, 2001001002, '参数校验不正确\n\n详细错误如下：\n密码长度为 6-16 位', '2019-09-09 09:35:44');
INSERT INTO `access_log` VALUES (77238, '65.47.15679929598534515', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=yudaoyuanma&password=yudaoyuanma&type=account', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '110.83.243.2', '2019-09-09 09:36:00', 79, 0, '', '2019-09-09 09:36:00');
INSERT INTO `access_log` VALUES (77239, '65.53.15679929601694517', 27, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '110.83.243.2', '2019-09-09 09:36:00', 10, 0, '', '2019-09-09 09:36:00');
INSERT INTO `access_log` VALUES (77240, '65.51.15679929601744615', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '110.83.243.2', '2019-09-09 09:36:00', 9, 2001001000, '服务端发生异常', '2019-09-09 09:36:00');
INSERT INTO `access_log` VALUES (77241, '65.54.15679929601774447', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '110.83.243.2', '2019-09-09 09:36:00', 8, 0, '', '2019-09-09 09:36:00');
COMMIT;

-- ----------------------------
-- Table structure for admin
-- ----------------------------
DROP TABLE IF EXISTS `admin`;
CREATE TABLE `admin` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '管理员编号',
  `username` varchar(16) NOT NULL COMMENT '登陆账号',
  `nickname` varchar(10) NOT NULL COMMENT '昵称',
  `password` varchar(32) NOT NULL COMMENT '密码\n     *\n     * TODO 芋艿 暂时最简单的 MD5',
  `status` tinyint(11) NOT NULL COMMENT '账号状态',
  `create_time` datetime NOT NULL COMMENT '创建时间',
  `update_time` datetime DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `deleted` bit(1) DEFAULT NULL,
  `deptment_id` int(11) DEFAULT NULL COMMENT '部门id',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=29 DEFAULT CHARSET=utf8mb4 COMMENT='admin_d_o';

-- ----------------------------
-- Records of admin
-- ----------------------------
BEGIN;
INSERT INTO `admin` VALUES (1, 'admin', '管理员', 'e10adc3949ba59abbe56e057f20f883e', 1, '2019-02-26 17:18:31', '2019-06-11 22:00:39', b'0', NULL);
INSERT INTO `admin` VALUES (2, '1881832432', '基哟哟', 'geilia', 2, '2019-03-02 03:03:21', '2019-05-15 00:18:47', b'1', NULL);
INSERT INTO `admin` VALUES (3, '123xx', '123xx', '123', 2, '2019-03-06 07:05:04', '2019-05-15 00:18:47', b'1', NULL);
INSERT INTO `admin` VALUES (4, 'lilizaimu', '我也想变成管理员', '133ff1e10a8b244767ef734fb86f37fd', 2, '2019-03-19 02:32:59', '2019-05-15 12:07:07', b'1', NULL);
INSERT INTO `admin` VALUES (5, 'mimangxiaodai', '迷茫小呆', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-03-19 02:33:13', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (6, 'gudujianke', '孤独剑客', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-03-19 02:33:27', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (7, 'huibuhui', '敷衍太多', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-03-19 02:40:21', '2019-05-15 00:28:57', b'1', NULL);
INSERT INTO `admin` VALUES (8, 'jiangzhende', '各自好好过', '29923fe1b1f7f62110765ac9b11b3491', 1, '2019-03-19 02:40:40', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (9, 'zhishaonengshuo', '哈哈哈哈', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-03-19 02:40:50', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (10, 'xinlangweibo', '新浪微博', '29923fe1b1f7f62110765ac9b11b3491', 1, '2019-03-19 02:41:03', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (11, 'tengxunqq', '腾讯QQ', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-03-19 02:41:15', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (12, '18818818818', '188', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-03-19 02:41:31', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (13, 'duoyubaoqian', '哈哈哈哈', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-03-19 02:42:45', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (14, '18817715513', '基佬', 'e10adc3949ba59abbe56e057f20f883e', 1, '2019-03-19 05:55:14', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (15, 'future', '未来', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-03-21 20:14:05', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (16, 'weilai', '未来君', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-03-21 20:16:41', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (17, '好啊好啊哦啊哦哦', '基佬', 'e10adc3949ba59abbe56e057f20f883e', 2, '2019-03-21 23:39:55', '2019-05-15 00:18:47', b'1', NULL);
INSERT INTO `admin` VALUES (18, '123456', '123456333', '123456', 1, '2019-04-09 15:51:14', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (19, 'kennyhe', 'kenny', '7b04447d33665113f65213385d8ec8fb', 1, '2019-04-29 14:32:42', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (20, 'tianjiji', '田基基', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-05-14 23:52:22', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (21, 'laotian', '老田', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-05-14 23:55:53', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (22, 'wangyunai', '王芋艿', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-05-14 23:57:54', '2019-05-15 00:18:47', b'0', NULL);
INSERT INTO `admin` VALUES (23, 'doudou', '我是豆豆', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-05-15 00:19:00', '2019-05-15 00:18:59', b'0', NULL);
INSERT INTO `admin` VALUES (24, 'doudouo', '管理员', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-05-15 00:19:21', '2019-05-15 00:19:20', b'0', NULL);
INSERT INTO `admin` VALUES (25, 'huibuhui', '会不会', '133ff1e10a8b244767ef734fb86f37fd', 2, '2019-05-15 00:28:59', '2019-05-15 12:07:19', b'1', NULL);
INSERT INTO `admin` VALUES (26, '15601691300', '小王', '133ff1e10a8b244767ef734fb86f37fd', 1, '2019-05-17 17:07:42', '2019-05-17 17:07:41', b'0', NULL);
INSERT INTO `admin` VALUES (27, 'yudaoyuanma', '芋道源码（演示账号）', 'A99E3ACDE2A8BB39F858D539FD6419A1', 1, '2019-05-17 17:08:27', '2019-05-17 18:24:49', b'0', NULL);
INSERT INTO `admin` VALUES (28, 'zhangxinzhe', '张信哲', '123456', 1, '2019-09-04 22:56:04', '2019-09-08 22:58:46', b'0', NULL);
COMMIT;

-- ----------------------------
-- Table structure for admin_role
-- ----------------------------
DROP TABLE IF EXISTS `admin_role`;
CREATE TABLE `admin_role` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '编号',
  `admin_id` int(11) NOT NULL COMMENT '管理员编号(外键：{@link AdminDO}',
  `role_id` int(11) NOT NULL COMMENT '角色编号(外键：{@link RoleDO}',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` datetime DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
  `deleted` bit(1) DEFAULT b'0' COMMENT '是否删除',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=44 DEFAULT CHARSET=utf8mb4 COMMENT='admin_role_d_o';

-- ----------------------------
-- Records of admin_role
-- ----------------------------
BEGIN;
INSERT INTO `admin_role` VALUES (1, 1, 1, '2019-02-24 09:03:39', '2019-05-15 15:29:14', b'1');
INSERT INTO `admin_role` VALUES (2, 2, 1, '2019-03-02 04:16:32', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (3, 2, 2, '2019-03-02 04:16:32', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (4, 2, 1, '2019-03-02 04:16:48', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (5, 2, 2, '2019-03-02 04:16:48', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (6, 2, 3, '2019-03-02 04:16:48', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (7, 2, 6, '2019-03-12 15:40:26', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (8, 2, 6, '2019-03-12 19:42:52', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (9, 1, 6, '2019-03-12 19:42:55', '2019-05-15 15:29:14', b'1');
INSERT INTO `admin_role` VALUES (10, 2, 6, '2019-03-12 19:45:41', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (11, 1, 6, '2019-03-12 20:14:37', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (12, 1, 6, '2019-03-12 20:14:44', '2019-05-15 15:29:01', b'1');
INSERT INTO `admin_role` VALUES (13, 2, 6, '2019-03-22 14:22:05', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (14, 4, 6, '2019-03-22 14:24:07', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (15, 4, 6, '2019-03-22 14:24:08', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (16, 4, 6, '2019-03-22 14:24:24', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (17, 2, 6, '2019-03-22 14:24:43', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (18, 4, 6, '2019-03-22 14:24:48', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (19, 5, 6, '2019-03-22 14:25:01', '2019-05-15 15:45:12', b'1');
INSERT INTO `admin_role` VALUES (20, 2, 6, '2019-03-22 14:27:44', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (21, 4, 6, '2019-03-22 14:27:48', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (22, 2, 2, '2019-03-22 14:30:06', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (23, 2, 6, '2019-03-22 14:30:06', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (24, 2, 2, '2019-03-22 14:31:14', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (25, 2, 6, '2019-03-22 14:31:14', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (26, 2, 2, '2019-03-22 14:43:15', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (27, 2, 6, '2019-03-22 14:43:15', '2019-05-15 14:41:24', b'1');
INSERT INTO `admin_role` VALUES (28, 6, 2, '2019-04-04 18:21:54', '2019-06-11 15:10:50', b'1');
INSERT INTO `admin_role` VALUES (29, 1, 1, '2019-05-15 15:29:15', '2019-05-17 17:09:05', b'1');
INSERT INTO `admin_role` VALUES (30, 1, 2, '2019-05-15 15:29:15', '2019-05-17 17:09:05', b'1');
INSERT INTO `admin_role` VALUES (31, 1, 6, '2019-05-15 15:29:15', '2019-05-17 17:09:05', b'1');
INSERT INTO `admin_role` VALUES (32, 5, 2, '2019-05-15 15:45:13', '2019-05-16 17:35:35', b'1');
INSERT INTO `admin_role` VALUES (33, 5, 6, '2019-05-15 15:45:13', '2019-05-16 17:35:35', b'1');
INSERT INTO `admin_role` VALUES (34, 5, 2, '2019-05-16 17:35:36', '2019-06-11 15:06:34', b'1');
INSERT INTO `admin_role` VALUES (35, 27, 1, '2019-05-17 17:08:37', '2019-05-17 17:08:37', b'0');
INSERT INTO `admin_role` VALUES (36, 1, 1, '2019-05-17 17:09:05', '2019-06-11 15:07:00', b'1');
INSERT INTO `admin_role` VALUES (37, 1, 2, '2019-05-17 17:09:05', '2019-06-11 15:07:00', b'1');
INSERT INTO `admin_role` VALUES (38, 1, 6, '2019-05-17 17:09:05', '2019-06-11 15:07:00', b'1');
INSERT INTO `admin_role` VALUES (39, 5, 1, '2019-06-11 15:06:35', '2019-06-11 15:07:11', b'1');
INSERT INTO `admin_role` VALUES (40, 5, 2, '2019-06-11 15:06:35', '2019-06-11 15:07:11', b'1');
INSERT INTO `admin_role` VALUES (41, 1, 2, '2019-06-11 15:07:00', '2019-06-11 15:10:50', b'1');
INSERT INTO `admin_role` VALUES (42, 1, 6, '2019-06-11 15:07:00', '2019-06-11 15:07:00', b'0');
INSERT INTO `admin_role` VALUES (43, 28, 11, '2019-09-04 22:57:23', '2019-09-04 22:57:23', b'0');
COMMIT;

-- ----------------------------
-- Table structure for data_dict
-- ----------------------------
DROP TABLE IF EXISTS `data_dict`;
CREATE TABLE `data_dict` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '编号',
  `enum_value` varchar(50) NOT NULL DEFAULT '' COMMENT '大类枚举值',
  `display_name` varchar(50) NOT NULL DEFAULT '' COMMENT '展示名',
  `sort` int(11) NOT NULL DEFAULT '-1' COMMENT '排序值',
  `memo` varchar(50) DEFAULT '' COMMENT '备注',
  `value` varchar(50) NOT NULL DEFAULT '' COMMENT '小类数值',
  `deleted` tinyint(11) NOT NULL DEFAULT '0' COMMENT '是否删除',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '最后更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=63 DEFAULT CHARSET=utf8mb4 COMMENT='data_dict';

-- ----------------------------
-- Records of data_dict
-- ----------------------------
BEGIN;
INSERT INTO `data_dict` VALUES (1, 'gender', '男', 1, '性别 - 男（嗨）', '1', 0, '2019-03-03 13:03:46', '2019-03-15 16:51:45');
INSERT INTO `data_dict` VALUES (2, 'gender', '女', 2, '性别（女）', '2', 0, '2019-03-03 13:04:00', '2019-03-15 17:19:20');
INSERT INTO `data_dict` VALUES (3, 'gender', '未知', 10, NULL, '3', 1, '2019-03-02 23:09:19', '2019-03-03 13:11:47');
INSERT INTO `data_dict` VALUES (4, 'common_status', '开启', 1, '状态 - 开启', '1', 0, '2019-03-15 17:28:08', '2019-03-15 17:28:07');
INSERT INTO `data_dict` VALUES (5, 'common_status', '禁用', 2, '状态 - 禁用', '2', 0, '2019-03-15 17:28:54', '2019-03-15 17:28:54');
INSERT INTO `data_dict` VALUES (6, 'test', '测试', 1, '你猜', '1', 1, '2019-03-15 17:36:54', '2019-03-15 17:36:59');
INSERT INTO `data_dict` VALUES (7, 'test', '测试', 1, '1', '1', 1, '2019-03-15 17:37:13', '2019-03-15 18:46:21');
INSERT INTO `data_dict` VALUES (8, 'delete_status', '未删除', 0, '正常/未删除', '0', 0, '2019-03-22 21:20:59', '2019-03-22 21:20:59');
INSERT INTO `data_dict` VALUES (9, 'delete_status', '删除', 1, '删除', '1', 0, '2019-03-22 21:23:20', '2019-03-22 21:23:20');
INSERT INTO `data_dict` VALUES (10, 'order_status', '等待付款', 1, '订单状态', '1', 0, '2019-03-24 16:17:55', '2019-03-24 16:20:24');
INSERT INTO `data_dict` VALUES (11, 'order_status', '等待发货', 2, '	等待发货', '2', 0, '2019-03-24 16:18:39', '2019-03-24 16:20:14');
INSERT INTO `data_dict` VALUES (12, 'order_status', '已发货', 3, '已发货', '3', 0, '2019-03-24 16:19:14', '2019-03-24 16:20:07');
INSERT INTO `data_dict` VALUES (13, 'order_status', '已完成', 4, '	已完成', '4', 0, '2019-03-24 16:19:37', '2019-03-24 16:20:03');
INSERT INTO `data_dict` VALUES (14, 'order_status', '已关闭', 5, '已关闭', '5', 0, '2019-03-24 16:19:50', '2019-03-24 16:19:50');
INSERT INTO `data_dict` VALUES (15, 'order_has_return_exchange', '无退换货', 1, '.', '1', 0, '2019-03-24 16:51:27', '2019-03-24 16:51:26');
INSERT INTO `data_dict` VALUES (16, 'order_has_return_exchange', '退货', 2, '.', '2', 0, '2019-03-24 16:51:36', '2019-03-24 16:51:35');
INSERT INTO `data_dict` VALUES (17, 'order_has_return_exchange', '换货', 3, '.', '3', 0, '2019-03-24 16:51:45', '2019-03-24 16:51:44');
INSERT INTO `data_dict` VALUES (18, 'order_has_return_exchange', '退换货', 4, '。', '4', 0, '2019-03-24 16:52:01', '2019-03-24 16:52:00');
INSERT INTO `data_dict` VALUES (19, 'order_cancel_reasons', '无法联系上买家', 1, '.', '1', 0, '2019-03-30 15:19:18', '2019-03-30 15:19:17');
INSERT INTO `data_dict` VALUES (20, 'order_cancel_reasons', '买家误拍或重拍了', 2, ',', '2', 0, '2019-03-30 15:19:31', '2019-03-30 15:19:30');
INSERT INTO `data_dict` VALUES (21, 'order_cancel_reasons', '买家无诚意完成交易', 3, '.', '3', 0, '2019-03-30 15:19:42', '2019-03-30 15:19:41');
INSERT INTO `data_dict` VALUES (22, 'order_cancel_reasons', '已通过银行线下汇款', 4, '.', '4', 0, '2019-03-30 15:19:56', '2019-03-30 15:19:56');
INSERT INTO `data_dict` VALUES (23, 'order_cancel_reasons', '已通过同城见面交易', 5, '.', '5', 0, '2019-03-30 15:20:21', '2019-03-30 15:20:21');
INSERT INTO `data_dict` VALUES (24, 'order_cancel_reasons', '已通过货到付款交易', 6, '.', '6', 0, '2019-03-30 15:20:37', '2019-03-30 15:20:37');
INSERT INTO `data_dict` VALUES (25, 'order_cancel_reasons', '已通过网上银行直接汇款', 7, '.', '7', 0, '2019-03-30 15:20:48', '2019-03-30 15:20:47');
INSERT INTO `data_dict` VALUES (26, 'order_cancel_reasons', '已经缺货无法交易', 8, '.', '8', 0, '2019-03-30 15:21:01', '2019-03-30 15:21:01');
INSERT INTO `data_dict` VALUES (27, 'order_cancel_reasons', '其他', 20, '.', '20', 0, '2019-03-30 17:16:27', '2019-03-30 17:16:27');
INSERT INTO `data_dict` VALUES (28, 'logistics_company', '顺丰快递', 1, '.', '1', 0, '2019-04-05 16:26:22', '2019-04-05 16:26:22');
INSERT INTO `data_dict` VALUES (29, 'logistics_company', '顺风速运', 2, '.', '2', 0, '2019-04-05 16:26:40', '2019-04-05 16:27:48');
INSERT INTO `data_dict` VALUES (30, 'logistics_company', '圆通快递', 3, '.', '3', 0, '2019-04-05 16:26:57', '2019-04-05 16:26:56');
INSERT INTO `data_dict` VALUES (31, 'logistics_company', '申通快递', 4, '.', '4', 0, '2019-04-05 16:27:14', '2019-04-05 16:27:14');
INSERT INTO `data_dict` VALUES (32, 'logistics_company', 'EMS', 5, '.', '5', 0, '2019-04-05 16:28:00', '2019-04-05 16:28:00');
INSERT INTO `data_dict` VALUES (33, 'logistics_company', '申通快递', 6, '.', '6', 0, '2019-04-05 16:28:40', '2019-04-05 16:28:40');
INSERT INTO `data_dict` VALUES (34, 'logistics_company', '天天快递', 7, '.', '7', 0, '2019-04-05 16:28:51', '2019-04-05 16:28:51');
INSERT INTO `data_dict` VALUES (35, 'logistics_company', '环球速运', 8, '.', '8', 0, '2019-04-05 16:29:12', '2019-04-05 16:29:12');
INSERT INTO `data_dict` VALUES (36, 'testOne', 'ttest', 1, '1', 'testO', 0, '2019-04-11 17:48:29', '2019-04-11 17:48:28');
INSERT INTO `data_dict` VALUES (37, 'order_return_reason', '退货原因', 1, '退货原因', '0', 1, '2019-04-25 23:25:10', '2019-04-25 23:27:02');
INSERT INTO `data_dict` VALUES (38, 'order_return_reason', '不想要了', 1, '.', '1', 0, '2019-04-25 23:25:55', '2019-04-25 23:25:55');
INSERT INTO `data_dict` VALUES (39, 'order_return_reason', '多拍重拍', 2, '.', '2', 0, '2019-04-25 23:26:23', '2019-04-25 23:26:23');
INSERT INTO `data_dict` VALUES (40, 'order_return_reason', '少货', 3, '.', '3', 0, '2019-04-25 23:26:48', '2019-04-25 23:26:47');
INSERT INTO `data_dict` VALUES (41, 'order_return_return_type', '订单退货类型', 1, '.', '-1', 1, '2019-04-27 11:57:45', '2019-04-27 11:58:16');
INSERT INTO `data_dict` VALUES (42, 'order_return_return_type', '退货退款', 1, '.', '1', 1, '2019-04-27 11:58:05', '2019-04-27 12:12:01');
INSERT INTO `data_dict` VALUES (43, 'order_return_return_type', '退款', 2, '.', '2', 1, '2019-04-27 11:58:14', '2019-04-27 12:12:03');
INSERT INTO `data_dict` VALUES (44, 'order_return_service_type', '退货退款', 1, '.', '1', 0, '2019-04-27 12:12:26', '2019-04-27 12:12:25');
INSERT INTO `data_dict` VALUES (45, 'order_return_service_type', '退款', 2, '2', '2', 0, '2019-04-27 12:12:36', '2019-04-27 12:12:35');
INSERT INTO `data_dict` VALUES (46, 'order_return_status', '退货申请', 1, '1', '1', 0, '2019-05-06 22:50:06', '2019-05-06 22:50:05');
INSERT INTO `data_dict` VALUES (47, 'order_return_status', '2', 2, '2', '2', 1, '2019-05-06 22:50:46', '2019-05-06 22:51:57');
INSERT INTO `data_dict` VALUES (48, 'order_return_status', '1', 1, '1', '-1', 1, '2019-05-06 22:51:07', '2019-05-06 22:52:00');
INSERT INTO `data_dict` VALUES (49, 'order_return_status', '0', 0, '0', '0', 1, '2019-05-06 22:51:39', '2019-05-06 22:52:02');
INSERT INTO `data_dict` VALUES (50, 'order_return_status', '申请成功', 2, '.', '2', 0, '2019-05-06 22:52:13', '2019-05-06 22:52:12');
INSERT INTO `data_dict` VALUES (51, 'order_return_status', '申请失败', 3, '.', '3', 0, '2019-05-06 22:52:34', '2019-05-06 22:52:34');
INSERT INTO `data_dict` VALUES (52, 'order_return_status', '退货中', 4, '.', '4', 0, '2019-05-06 22:52:44', '2019-05-06 22:52:43');
INSERT INTO `data_dict` VALUES (53, 'order_return_status', '已收货', 5, '.', '5', 0, '2019-05-06 22:52:57', '2019-05-09 22:17:35');
INSERT INTO `data_dict` VALUES (54, 'order_return_status', '退款成功', 6, '.', '6', 0, '2019-05-09 22:17:52', '2019-05-09 22:17:51');
INSERT INTO `data_dict` VALUES (55, 'sms_platform', '云片', 1, '短信服务云片', '1', 0, '2019-05-26 15:09:37', '2019-05-26 15:09:37');
INSERT INTO `data_dict` VALUES (56, 'sms_platform', '阿里云', 2, '阿里云短信服务', '2', 0, '2019-05-26 15:09:56', '2019-05-26 15:09:56');
INSERT INTO `data_dict` VALUES (57, 'sms_apply_status', '审核中', 1, '审核中', '1', 0, '2019-05-26 15:11:27', '2019-05-26 15:11:27');
INSERT INTO `data_dict` VALUES (58, 'sms_apply_status', '审核成功', 2, '审核成功', '2', 0, '2019-05-26 15:11:40', '2019-05-26 15:11:40');
INSERT INTO `data_dict` VALUES (59, 'sms_apply_status', '审核失败', 10, '审核失败', '10', 0, '2019-05-26 15:12:10', '2019-05-26 15:12:10');
INSERT INTO `data_dict` VALUES (60, 'sms_type', '验证码', 1, '验证码', '1', 0, '2019-05-26 23:51:15', '2019-05-26 23:51:15');
INSERT INTO `data_dict` VALUES (61, 'sms_type', '通知', 2, '通知', '2', 0, '2019-05-26 23:51:29', '2019-05-26 23:51:28');
INSERT INTO `data_dict` VALUES (62, 'sms_type', '营销', 3, '营销', '3', 0, '2019-05-26 23:51:47', '2019-05-26 23:51:46');
COMMIT;

-- ----------------------------
-- Table structure for deptment
-- ----------------------------
DROP TABLE IF EXISTS `deptment`;
CREATE TABLE `deptment` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '部门主键id',
  `name` varchar(100) COLLATE utf8mb4_bin NOT NULL COMMENT '部门名称',
  `sort` int(11) NOT NULL DEFAULT '0' COMMENT '排序字段',
  `pid` int(11) NOT NULL DEFAULT '0' COMMENT '父级部门id',
  `create_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
  `deleted` bit(1) NOT NULL DEFAULT b'0' COMMENT '删除标记',
  PRIMARY KEY (`id`),
  UNIQUE KEY `deptment_id_uindex` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_bin;

-- ----------------------------
-- Table structure for exception_log
-- ----------------------------
DROP TABLE IF EXISTS `exception_log`;
CREATE TABLE `exception_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '编号',
  `trace_id` varchar(64) NOT NULL COMMENT '链路追踪编号\n     *\n     * 一般来说，通过链路追踪编号，可以将访问日志，错误日志，链路追踪日志，logger 打印日志等，结合在一起，从而进行排错。',
  `user_id` int(11) NOT NULL COMMENT '用户编号.\n     *\n     * 当管理员为空时，该值为 {@link cn.iocoder.mall.admin.api.dto.AccessLogAddDTO#USER_ID_NULL}',
  `user_type` tinyint(4) NOT NULL COMMENT '用户类型',
  `application_name` varchar(50) NOT NULL COMMENT '应用名\n     *\n     * 目前读取 spring.application.name',
  `uri` varchar(4096) NOT NULL COMMENT '访问地址',
  `query_string` varchar(4096) NOT NULL COMMENT '参数',
  `method` varchar(50) NOT NULL COMMENT 'http 方法',
  `user_agent` varchar(1024) NOT NULL COMMENT 'userAgent',
  `ip` varchar(50) NOT NULL COMMENT 'ip',
  `exception_time` datetime NOT NULL COMMENT '异常发生时间',
  `exception_name` varchar(128) NOT NULL DEFAULT '' COMMENT '异常名\n     *\n     * {@link Throwable#getClass()} 的类全名',
  `exception_message` text NOT NULL COMMENT '异常导致的消息\n     *\n     * {@link cn.iocoder.common.framework.util.ExceptionUtil#getMessage(Throwable)}',
  `exception_root_cause_message` text NOT NULL COMMENT '异常导致的根消息\n     *\n     * {@link cn.iocoder.common.framework.util.ExceptionUtil#getRootCauseMessage(Throwable)}',
  `exception_stack_trace` text NOT NULL COMMENT '异常的栈轨迹\n     *\n     * {@link cn.iocoder.common.framework.util.ExceptionUtil#getServiceException(Exception)}',
  `exception_class_name` varchar(512) NOT NULL COMMENT '异常发生的类全名\n     *\n     * {@link StackTraceElement#getClassName()}',
  `exception_file_name` varchar(512) NOT NULL COMMENT '异常发生的类文件\n     *\n     * {@link StackTraceElement#getFileName()}',
  `exception_method_name` varchar(512) NOT NULL COMMENT '异常发生的方法名\n     *\n     * {@link StackTraceElement#getMethodName()}',
  `exception_line_number` int(11) NOT NULL COMMENT '异常发生的方法所在行\n     *\n     * {@link StackTraceElement#getLineNumber()}',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=819 DEFAULT CHARSET=utf8mb4 COMMENT='exception_log';

-- ----------------------------
-- Records of exception_log
-- ----------------------------
BEGIN;
INSERT INTO `exception_log` VALUES (1, 'aee96c94-f5c9-4169-b9eb-5b4bfddf3051', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:44:24', 'java.lang.NullPointerException', 'NullPointerException: 阿拉啦啦啦', 'NullPointerException: 阿拉啦啦啦', 'java.lang.NullPointerException: 阿拉啦啦啦\n	at cn.iocoder.mall.admin.service.DataDictServiceImpl.selectDataDictList(DataDictServiceImpl.java:36)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.selectDataDictList(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.selectDataDictList(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.DataDictController.tree(DataDictController.java:43)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.admin.service.DataDictServiceImpl', 'DataDictServiceImpl.java', 'selectDataDictList', 36, '2019-05-11 02:44:24');
INSERT INTO `exception_log` VALUES (2, '9dcdf359-426f-4217-9c11-bdb381f59f80', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:48:05', 'java.lang.NullPointerException', 'NullPointerException: 阿拉啦啦啦', 'NullPointerException: 阿拉啦啦啦', 'java.lang.NullPointerException: 阿拉啦啦啦\n	at cn.iocoder.mall.admin.service.DataDictServiceImpl.selectDataDictList(DataDictServiceImpl.java:36)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.selectDataDictList(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.selectDataDictList(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.DataDictController.tree(DataDictController.java:43)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.admin.service.DataDictServiceImpl', 'DataDictServiceImpl.java', 'selectDataDictList', 36, '2019-05-11 02:48:05');
INSERT INTO `exception_log` VALUES (3, 'e781744b-09c5-4e16-a37d-6a3adf3a59ff', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 02:48:06', 'java.lang.NullPointerException', 'NullPointerException: 阿拉啦啦啦', 'NullPointerException: 阿拉啦啦啦', 'java.lang.NullPointerException: 阿拉啦啦啦\n	at cn.iocoder.mall.admin.service.DataDictServiceImpl.selectDataDictList(DataDictServiceImpl.java:36)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.selectDataDictList(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.selectDataDictList(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.DataDictController.tree(DataDictController.java:43)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.admin.service.DataDictServiceImpl', 'DataDictServiceImpl.java', 'selectDataDictList', 36, '2019-05-11 02:48:06');
INSERT INTO `exception_log` VALUES (4, '966be233-68d6-44ae-992e-c55dc228aad3', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:05:32', 'java.lang.reflect.UndeclaredThrowableException', 'UndeclaredThrowableException: ', 'TimeoutException: cost 59741 ms', 'java.lang.reflect.UndeclaredThrowableException\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$7aee457a.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy144.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:65)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: io.seata.core.exception.TransactionException: java.util.concurrent.TimeoutException: cost 59741 ms\n	at io.seata.tm.DefaultTransactionManager.syncCall(DefaultTransactionManager.java:81)\n	at io.seata.tm.DefaultTransactionManager.rollback(DefaultTransactionManager.java:65)\n	at io.seata.tm.api.DefaultGlobalTransaction.rollback(DefaultGlobalTransaction.java:142)\n	at io.seata.tm.api.TransactionalTemplate.rollbackTransaction(TransactionalTemplate.java:114)\n	at io.seata.tm.api.TransactionalTemplate.completeTransactionAfterThrowing(TransactionalTemplate.java:88)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:69)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	... 112 more\nCaused by: java.util.concurrent.TimeoutException: cost 59741 ms\n	at io.seata.core.protocol.MessageFuture.get(MessageFuture.java:64)\n	at io.seata.core.rpc.netty.AbstractRpcRemoting.sendAsyncRequest(AbstractRpcRemoting.java:265)\n	at io.seata.core.rpc.netty.AbstractRpcRemoting.sendAsyncRequestWithResponse(AbstractRpcRemoting.java:195)\n	at io.seata.core.rpc.netty.TmRpcClient.sendMsgWithResponse(TmRpcClient.java:167)\n	at io.seata.core.rpc.netty.TmRpcClient.sendMsgWithResponse(TmRpcClient.java:178)\n	at io.seata.tm.DefaultTransactionManager.syncCall(DefaultTransactionManager.java:79)\n	... 121 more\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$7aee457a', '<generated>', 'createOrder', -1, '2019-05-11 18:05:32');
INSERT INTO `exception_log` VALUES (5, '4eec51e2-f756-43e0-8de0-b8e9ee32b6ff', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-11 18:08:46', 'org.springframework.http.converter.HttpMessageNotReadableException', 'HttpMessageNotReadableException: Required request body is missing: public cn.iocoder.common.framework.vo.CommonResult<cn.iocoder.mall.order.api.bo.OrderCreateBO> cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(cn.iocoder.mall.order.application.po.user.OrderCreatePO,javax.servlet.http.HttpServletRequest)', 'HttpMessageNotReadableException: Required request body is missing: public cn.iocoder.common.framework.vo.CommonResult<cn.iocoder.mall.order.api.bo.OrderCreateBO> cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(cn.iocoder.mall.order.application.po.user.OrderCreatePO,javax.servlet.http.HttpServletRequest)', 'org.springframework.http.converter.HttpMessageNotReadableException: Required request body is missing: public cn.iocoder.common.framework.vo.CommonResult<cn.iocoder.mall.order.api.bo.OrderCreateBO> cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(cn.iocoder.mall.order.application.po.user.OrderCreatePO,javax.servlet.http.HttpServletRequest)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.readWithMessageConverters(RequestResponseBodyMethodProcessor.java:160)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.resolveArgument(RequestResponseBodyMethodProcessor.java:130)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor', 'RequestResponseBodyMethodProcessor.java', 'readWithMessageConverters', 160, '2019-05-11 18:08:46');
INSERT INTO `exception_log` VALUES (6, '53ea5a59-9905-4c34-a68b-a2e6cb9e51e9', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:26:31', 'java.lang.ClassCastException', 'ClassCastException: cn.iocoder.mall.pay.api.dto.PayTransactionCreateDTO cannot be cast to cn.iocoder.mall.pay.api.dto.PayTransactionCreateDTO', 'ClassCastException: cn.iocoder.mall.pay.api.dto.PayTransactionCreateDTO cannot be cast to cn.iocoder.mall.pay.api.dto.PayTransactionCreateDTO', 'java.lang.ClassCastException: cn.iocoder.mall.pay.api.dto.PayTransactionCreateDTO cannot be cast to cn.iocoder.mall.pay.api.dto.PayTransactionCreateDTO\n	at org.apache.dubbo.common.bytecode.Wrapper10.invokeMethod(Wrapper10.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\n', 'org.apache.dubbo.common.bytecode.Wrapper10', 'Wrapper10.java', 'invokeMethod', -1, '2019-05-12 00:26:31');
INSERT INTO `exception_log` VALUES (7, 'cceb9176-6789-447e-8959-6610ba6a7f18', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:29:32', 'java.lang.ClassCastException', 'ClassCastException: cn.iocoder.mall.pay.api.dto.PayTransactionCreateDTO cannot be cast to cn.iocoder.mall.pay.api.dto.PayTransactionCreateDTO', 'ClassCastException: cn.iocoder.mall.pay.api.dto.PayTransactionCreateDTO cannot be cast to cn.iocoder.mall.pay.api.dto.PayTransactionCreateDTO', 'java.lang.ClassCastException: cn.iocoder.mall.pay.api.dto.PayTransactionCreateDTO cannot be cast to cn.iocoder.mall.pay.api.dto.PayTransactionCreateDTO\n	at org.apache.dubbo.common.bytecode.Wrapper10.invokeMethod(Wrapper10.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\n', 'org.apache.dubbo.common.bytecode.Wrapper10', 'Wrapper10.java', 'invokeMethod', -1, '2019-05-12 00:29:32');
INSERT INTO `exception_log` VALUES (8, 'fee8f691-3744-4913-9b9e-a57547ba5d84', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:30:33', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method createTransaction in the service cn.iocoder.mall.pay.api.PayTransactionService. Tried 3 times of the providers [192.168.3.26:20882] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: createTransaction, provider: dubbo://192.168.3.26:20882/cn.iocoder.mall.pay.api.PayTransactionService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.pay.api.PayTransactionService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.pay.api.PayTransactionService&lazy=false&methods=getTransactionList,getTransactionPage,cancelTransaction,updateTransactionPaySuccess,submitTransaction,createTransaction,getTransaction&pid=90716&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=pay-service&remote.timestamp=1557334368329&revision=1.0.0&side=consumer&sticky=false&timestamp=1557592158222&validation=true&version=1.0.0, cause: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=532, dubbo=2.0.2, version=1.0.0}]', 'RemotingException: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=532, dubbo=2.0.2, version=1.0.0}]', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method createTransaction in the service cn.iocoder.mall.pay.api.PayTransactionService. Tried 3 times of the providers [192.168.3.26:20882] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: createTransaction, provider: dubbo://192.168.3.26:20882/cn.iocoder.mall.pay.api.PayTransactionService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.pay.api.PayTransactionService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.pay.api.PayTransactionService&lazy=false&methods=getTransactionList,getTransactionPage,cancelTransaction,updateTransactionPaySuccess,submitTransaction,createTransaction,getTransaction&pid=90716&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=pay-service&remote.timestamp=1557334368329&revision=1.0.0&side=consumer&sticky=false&timestamp=1557592158222&validation=true&version=1.0.0, cause: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=532, dubbo=2.0.2, version=1.0.0}]\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy6.createTransaction(proxy6.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy143.createTransaction(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createPayTransaction(OrderServiceImpl.java:361)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:327)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$89c256d5.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy144.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:65)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.RemotingException: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=532, dubbo=2.0.2, version=1.0.0}]\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:297)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 137 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 00:30:33');
INSERT INTO `exception_log` VALUES (9, '856ed67f-edcf-4880-a764-65d0a334182a', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 00:30:47', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method createTransaction in the service cn.iocoder.mall.pay.api.PayTransactionService. Tried 3 times of the providers [192.168.3.26:20882] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: createTransaction, provider: dubbo://192.168.3.26:20882/cn.iocoder.mall.pay.api.PayTransactionService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.pay.api.PayTransactionService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.pay.api.PayTransactionService&lazy=false&methods=getTransactionList,getTransactionPage,cancelTransaction,updateTransactionPaySuccess,submitTransaction,createTransaction,getTransaction&pid=90716&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=pay-service&remote.timestamp=1557334368329&revision=1.0.0&side=consumer&sticky=false&timestamp=1557592158222&validation=true&version=1.0.0, cause: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=532, dubbo=2.0.2, version=1.0.0}]', 'RemotingException: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=532, dubbo=2.0.2, version=1.0.0}]', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method createTransaction in the service cn.iocoder.mall.pay.api.PayTransactionService. Tried 3 times of the providers [192.168.3.26:20882] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: createTransaction, provider: dubbo://192.168.3.26:20882/cn.iocoder.mall.pay.api.PayTransactionService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.pay.api.PayTransactionService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.pay.api.PayTransactionService&lazy=false&methods=getTransactionList,getTransactionPage,cancelTransaction,updateTransactionPaySuccess,submitTransaction,createTransaction,getTransaction&pid=90716&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=pay-service&remote.timestamp=1557334368329&revision=1.0.0&side=consumer&sticky=false&timestamp=1557592158222&validation=true&version=1.0.0, cause: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=532, dubbo=2.0.2, version=1.0.0}]\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy6.createTransaction(proxy6.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy143.createTransaction(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createPayTransaction(OrderServiceImpl.java:361)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:327)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$89c256d5.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy144.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:65)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.RemotingException: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=532, dubbo=2.0.2, version=1.0.0}]\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:297)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 137 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 00:30:47');
INSERT INTO `exception_log` VALUES (10, '1498bc97-0921-44e7-8259-19a61cf05f66', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:00:58', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/4) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=91542&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557566510852&revision=1.0.0&side=consumer&sticky=false&timestamp=1557593496463&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:00:56.650, end time: 2019-05-12 01:00:57.655, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=94, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282467, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60250 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:00:56.650, end time: 2019-05-12 01:00:57.655, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=94, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282467, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60250 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/4) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=91542&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557566510852&revision=1.0.0&side=consumer&sticky=false&timestamp=1557593496463&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:00:56.650, end time: 2019-05-12 01:00:57.655, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=94, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282467, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60250 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$b3b9ee4a.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:00:56.650, end time: 2019-05-12 01:00:57.655, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=94, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282467, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60250 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 01:00:58');
INSERT INTO `exception_log` VALUES (11, '85ee8eed-9522-4814-a0db-00048bbfbcdf', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:01:44', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/4) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=91542&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557593606485&revision=1.0.0&side=consumer&sticky=false&timestamp=1557593496463&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:01:42.813, end time: 2019-05-12 01:01:43.818, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=119, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282470, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60250 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:01:42.813, end time: 2019-05-12 01:01:43.818, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=119, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282470, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60250 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/4) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=91542&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557593606485&revision=1.0.0&side=consumer&sticky=false&timestamp=1557593496463&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:01:42.813, end time: 2019-05-12 01:01:43.818, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=119, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282470, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60250 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$b3b9ee4a.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:01:42.813, end time: 2019-05-12 01:01:43.818, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=119, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282470, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60250 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 01:01:44');
INSERT INTO `exception_log` VALUES (12, '3b67c5c7-5c03-44d9-88d2-7ca2a30edfa6', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:42:48', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557566510852&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:42:47.005, end time: 2019-05-12 01:42:48.006, client elapsed: 0 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=23, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282471, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:42:47.005, end time: 2019-05-12 01:42:48.006, client elapsed: 0 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=23, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282471, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557566510852&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:42:47.005, end time: 2019-05-12 01:42:48.006, client elapsed: 0 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=23, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282471, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$a87deb38.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:42:47.005, end time: 2019-05-12 01:42:48.006, client elapsed: 0 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=23, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282471, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 01:42:48');
INSERT INTO `exception_log` VALUES (13, '6571b2bc-d740-4c39-a99b-87864a30b2fc', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:44:01', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/promotion/promotion-service-impl/target/classes/mapper/CouponCardMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: UPDATE coupon_card          SET status = ?,                                           used_time = ?          WHERE id = ?         AND status = ?\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/promotion/promotion-service-impl/target/classes/mapper/CouponCardMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: UPDATE coupon_card          SET status = ?,                                           used_time = ?          WHERE id = ?         AND status = ?\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy85.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy95.updateByIdAndStatus(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy96.updateByIdAndStatus(Unknown Source)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl.useCouponCard(CouponServiceImpl.java:252)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl$$FastClassBySpringCGLIB$$4c1d1cc8.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl$$EnhancerBySpringCGLIB$$4d30ae3a.useCouponCard(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:193)\n	at io.seata.rm.datasource.ConnectionProxy.commit(ConnectionProxy.java:159)\n	at io.seata.rm.datasource.ConnectionProxy.setAutoCommit(ConnectionProxy.java:221)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.executeAutoCommitTrue(AbstractDMLBaseExecutor.java:107)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.doExecute(AbstractDMLBaseExecutor.java:57)\n	at io.seata.rm.datasource.exec.BaseTransactionalExecutor.execute(BaseTransactionalExecutor.java:86)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:101)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 54 more\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2079)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2013)\n	at com.mysql.jdbc.PreparedStatement.executeLargeUpdate(PreparedStatement.java:5104)\n	at com.mysql.jdbc.PreparedStatement.executeUpdate(PreparedStatement.java:1998)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.executeUpdate(DruidPooledPreparedStatement.java:256)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLog(UndoLogManager.java:340)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLogWithNormal(UndoLogManager.java:323)\n	at io.seata.rm.datasource.undo.UndoLogManager.flushUndoLogs(UndoLogManager.java:112)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:187)\n	... 73 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/promotion/promotion-service-impl/target/classes/mapper/CouponCardMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: UPDATE coupon_card          SET status = ?,                                           used_time = ?          WHERE id = ?         AND status = ?\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/promotion/promotion-service-impl/target/classes/mapper/CouponCardMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: UPDATE coupon_card          SET status = ?,                                           used_time = ?          WHERE id = ?         AND status = ?\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy85.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy95.updateByIdAndStatus(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy96.updateByIdAndStatus(Unknown Source)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl.useCouponCard(CouponServiceImpl.java:252)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl$$FastClassBySpringCGLIB$$4c1d1cc8.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl$$EnhancerBySpringCGLIB$$4d30ae3a.useCouponCard(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:193)\n	at io.seata.rm.datasource.ConnectionProxy.commit(ConnectionProxy.java:159)\n	at io.seata.rm.datasource.ConnectionProxy.setAutoCommit(ConnectionProxy.java:221)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.executeAutoCommitTrue(AbstractDMLBaseExecutor.java:107)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.doExecute(AbstractDMLBaseExecutor.java:57)\n	at io.seata.rm.datasource.exec.BaseTransactionalExecutor.execute(BaseTransactionalExecutor.java:86)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:101)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 54 more\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2079)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2013)\n	at com.mysql.jdbc.PreparedStatement.executeLargeUpdate(PreparedStatement.java:5104)\n	at com.mysql.jdbc.PreparedStatement.executeUpdate(PreparedStatement.java:1998)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.executeUpdate(DruidPooledPreparedStatement.java:256)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLog(UndoLogManager.java:340)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLogWithNormal(UndoLogManager.java:323)\n	at io.seata.rm.datasource.undo.UndoLogManager.flushUndoLogs(UndoLogManager.java:112)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:187)\n	... 73 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/promotion/promotion-service-impl/target/classes/mapper/CouponCardMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: UPDATE coupon_card          SET status = ?,                                           used_time = ?          WHERE id = ?         AND status = ?\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/promotion/promotion-service-impl/target/classes/mapper/CouponCardMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: UPDATE coupon_card          SET status = ?,                                           used_time = ?          WHERE id = ?         AND status = ?\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy85.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy95.updateByIdAndStatus(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy96.updateByIdAndStatus(Unknown Source)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl.useCouponCard(CouponServiceImpl.java:252)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl$$FastClassBySpringCGLIB$$4c1d1cc8.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl$$EnhancerBySpringCGLIB$$4d30ae3a.useCouponCard(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:193)\n	at io.seata.rm.datasource.ConnectionProxy.commit(ConnectionProxy.java:159)\n	at io.seata.rm.datasource.ConnectionProxy.setAutoCommit(ConnectionProxy.java:221)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.executeAutoCommitTrue(AbstractDMLBaseExecutor.java:107)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.doExecute(AbstractDMLBaseExecutor.java:57)\n	at io.seata.rm.datasource.exec.BaseTransactionalExecutor.execute(BaseTransactionalExecutor.java:86)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:101)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 54 more\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_promotion.undo_log\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2079)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2013)\n	at com.mysql.jdbc.PreparedStatement.executeLargeUpdate(PreparedStatement.java:5104)\n	at com.mysql.jdbc.PreparedStatement.executeUpdate(PreparedStatement.java:1998)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.executeUpdate(DruidPooledPreparedStatement.java:256)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLog(UndoLogManager.java:340)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLogWithNormal(UndoLogManager.java:323)\n	at io.seata.rm.datasource.undo.UndoLogManager.flushUndoLogs(UndoLogManager.java:112)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:187)\n	... 73 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-12 01:44:01');
INSERT INTO `exception_log` VALUES (14, 'f5edaf72-d8e1-42c7-9e4e-9f52cdb48c7d', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:46:13', 'org.springframework.http.converter.HttpMessageNotReadableException', 'HttpMessageNotReadableException: Required request body is missing: public cn.iocoder.common.framework.vo.CommonResult<cn.iocoder.mall.order.api.bo.OrderCreateBO> cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(cn.iocoder.mall.order.application.po.user.OrderCreatePO,javax.servlet.http.HttpServletRequest)', 'HttpMessageNotReadableException: Required request body is missing: public cn.iocoder.common.framework.vo.CommonResult<cn.iocoder.mall.order.api.bo.OrderCreateBO> cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(cn.iocoder.mall.order.application.po.user.OrderCreatePO,javax.servlet.http.HttpServletRequest)', 'org.springframework.http.converter.HttpMessageNotReadableException: Required request body is missing: public cn.iocoder.common.framework.vo.CommonResult<cn.iocoder.mall.order.api.bo.OrderCreateBO> cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(cn.iocoder.mall.order.application.po.user.OrderCreatePO,javax.servlet.http.HttpServletRequest)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.readWithMessageConverters(RequestResponseBodyMethodProcessor.java:160)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.resolveArgument(RequestResponseBodyMethodProcessor.java:130)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor', 'RequestResponseBodyMethodProcessor.java', 'readWithMessageConverters', 160, '2019-05-12 01:46:13');
INSERT INTO `exception_log` VALUES (15, 'f1fc67d8-dc09-4a96-ba97-9ae0b1c93185', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:48:07', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557566510852&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:48:01.950, end time: 2019-05-12 01:48:02.955, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=97, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282477, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:48:01.950, end time: 2019-05-12 01:48:02.955, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=97, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282477, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557566510852&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:48:01.950, end time: 2019-05-12 01:48:02.955, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=97, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282477, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$a87deb38.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:48:01.950, end time: 2019-05-12 01:48:02.955, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=97, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282477, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 01:48:07');
INSERT INTO `exception_log` VALUES (16, '9f70f9c3-663c-4da3-8748-34f208ab212f', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:50:21', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557566510852&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:50:19.769, end time: 2019-05-12 01:50:20.773, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=129, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 2], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282483, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:50:19.769, end time: 2019-05-12 01:50:20.773, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=129, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 2], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282483, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557566510852&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:50:19.769, end time: 2019-05-12 01:50:20.773, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=129, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 2], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282483, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$a87deb38.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:50:19.769, end time: 2019-05-12 01:50:20.773, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=129, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 2], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282483, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 01:50:21');
INSERT INTO `exception_log` VALUES (17, '3d985565-8a20-4f4e-ae4b-2f74d8361f47', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:51:24', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponCardList,getCouponTemplatePage,useCouponCode,updateCouponCardTemplate,addCouponCodeTemplate,useCouponCard,getCouponTemplate,getCouponCardDetail,addCouponCard,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557594173466&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:51:22.648, end time: 2019-05-12 01:51:23.652, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=156, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282484, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:51:22.648, end time: 2019-05-12 01:51:23.652, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=156, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282484, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponCardList,getCouponTemplatePage,useCouponCode,updateCouponCardTemplate,addCouponCodeTemplate,useCouponCard,getCouponTemplate,getCouponCardDetail,addCouponCard,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557594173466&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:51:22.648, end time: 2019-05-12 01:51:23.652, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=156, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282484, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$a87deb38.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:51:22.648, end time: 2019-05-12 01:51:23.652, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=156, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282484, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 01:51:24');
INSERT INTO `exception_log` VALUES (18, '89fe9da4-405c-4932-9999-4c1ab6d91d51', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:52:31', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557593606485&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:52:30.090, end time: 2019-05-12 01:52:31.094, client elapsed: 1 ms, server elapsed: 1003 ms, timeout: 1000 ms, request: Request [id=176, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282489, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:52:30.090, end time: 2019-05-12 01:52:31.094, client elapsed: 1 ms, server elapsed: 1003 ms, timeout: 1000 ms, request: Request [id=176, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282489, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557593606485&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:52:30.090, end time: 2019-05-12 01:52:31.094, client elapsed: 1 ms, server elapsed: 1003 ms, timeout: 1000 ms, request: Request [id=176, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282489, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$a87deb38.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:52:30.090, end time: 2019-05-12 01:52:31.094, client elapsed: 1 ms, server elapsed: 1003 ms, timeout: 1000 ms, request: Request [id=176, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282489, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 01:52:31');
INSERT INTO `exception_log` VALUES (19, '89fe9da4-405c-4932-9999-4c1ab6d91d51', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:52:31', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557593606485&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:52:30.090, end time: 2019-05-12 01:52:31.094, client elapsed: 1 ms, server elapsed: 1003 ms, timeout: 1000 ms, request: Request [id=176, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282489, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:52:30.090, end time: 2019-05-12 01:52:31.094, client elapsed: 1 ms, server elapsed: 1003 ms, timeout: 1000 ms, request: Request [id=176, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282489, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557593606485&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:52:30.090, end time: 2019-05-12 01:52:31.094, client elapsed: 1 ms, server elapsed: 1003 ms, timeout: 1000 ms, request: Request [id=176, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282489, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$a87deb38.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:52:30.090, end time: 2019-05-12 01:52:31.094, client elapsed: 1 ms, server elapsed: 1003 ms, timeout: 1000 ms, request: Request [id=176, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282489, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 01:52:32');
INSERT INTO `exception_log` VALUES (20, 'b154473b-37ed-4855-929b-832fa0cb7a8d', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:53:03', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557592776368&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:53:01.465, end time: 2019-05-12 01:53:02.470, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=187, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282490, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:53:01.465, end time: 2019-05-12 01:53:02.470, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=187, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282490, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557592776368&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:53:01.465, end time: 2019-05-12 01:53:02.470, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=187, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282490, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$a87deb38.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:53:01.465, end time: 2019-05-12 01:53:02.470, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=187, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282490, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 01:53:03');
INSERT INTO `exception_log` VALUES (21, 'ae7cd5f4-7b3c-4c30-8ce5-992cd091ea2d', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:54:45', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponCardList,getCouponTemplatePage,useCouponCode,updateCouponCardTemplate,addCouponCodeTemplate,useCouponCard,getCouponTemplate,getCouponCardDetail,addCouponCard,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557594173466&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:54:43.618, end time: 2019-05-12 01:54:44.623, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=225, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282491, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:54:43.618, end time: 2019-05-12 01:54:44.623, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=225, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282491, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponCardList,getCouponTemplatePage,useCouponCode,updateCouponCardTemplate,addCouponCodeTemplate,useCouponCard,getCouponTemplate,getCouponCardDetail,addCouponCard,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557594173466&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:54:43.618, end time: 2019-05-12 01:54:44.623, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=225, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282491, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$a87deb38.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:54:43.618, end time: 2019-05-12 01:54:44.623, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=225, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282491, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 01:54:45');
INSERT INTO `exception_log` VALUES (22, '5627c350-c9c8-4abc-9569-04f32adfe0e6', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:56:09', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557566510852&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:56:07.804, end time: 2019-05-12 01:56:08.809, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=240, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282492, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:56:07.804, end time: 2019-05-12 01:56:08.809, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=240, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282492, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557566510852&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:56:07.804, end time: 2019-05-12 01:56:08.809, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=240, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282492, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$a87deb38.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:56:07.804, end time: 2019-05-12 01:56:08.809, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=240, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282492, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 01:56:09');
INSERT INTO `exception_log` VALUES (23, '5627c350-c9c8-4abc-9569-04f32adfe0e6', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:56:09', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557566510852&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:56:07.804, end time: 2019-05-12 01:56:08.809, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=240, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282492, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:56:07.804, end time: 2019-05-12 01:56:08.809, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=240, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282492, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557566510852&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:56:07.804, end time: 2019-05-12 01:56:08.809, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=240, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282492, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$a87deb38.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:56:07.804, end time: 2019-05-12 01:56:08.809, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=240, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282492, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 01:56:10');
INSERT INTO `exception_log` VALUES (24, '31b7ca05-2d8a-41dd-89f3-480e703c2092', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 01:56:59', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557593364694&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:56:57.970, end time: 2019-05-12 01:56:58.974, client elapsed: 1 ms, server elapsed: 1003 ms, timeout: 1000 ms, request: Request [id=266, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 3], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282497, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:56:57.970, end time: 2019-05-12 01:56:58.974, client elapsed: 1 ms, server elapsed: 1003 ms, timeout: 1000 ms, request: Request [id=266, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 3], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282497, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=93473&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557593364694&revision=1.0.0&side=consumer&sticky=false&timestamp=1557596541327&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 01:56:57.970, end time: 2019-05-12 01:56:58.974, client elapsed: 1 ms, server elapsed: 1003 ms, timeout: 1000 ms, request: Request [id=266, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 3], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282497, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$a87deb38.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 01:56:57.970, end time: 2019-05-12 01:56:58.974, client elapsed: 1 ms, server elapsed: 1003 ms, timeout: 1000 ms, request: Request [id=266, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 3], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.43.240:8091:2011282497, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:60407 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 01:56:59');
INSERT INTO `exception_log` VALUES (25, '2602b607-9625-4b1b-adae-19a42e25b536', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:26:05', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/2) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,getCouponCardDetail,addCouponCard,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=6108&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216800&revision=1.0.0&side=consumer&sticky=false&timestamp=1557655554608&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 18:26:03.586, end time: 2019-05-12 18:26:04.591, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=125, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.3.26:8091:2011359066, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:59362 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 18:26:03.586, end time: 2019-05-12 18:26:04.591, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=125, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.3.26:8091:2011359066, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:59362 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/2) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,getCouponCardDetail,addCouponCard,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=6108&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216800&revision=1.0.0&side=consumer&sticky=false&timestamp=1557655554608&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 18:26:03.586, end time: 2019-05-12 18:26:04.591, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=125, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.3.26:8091:2011359066, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:59362 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$929d18e5.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 18:26:03.586, end time: 2019-05-12 18:26:04.591, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=125, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.3.26:8091:2011359066, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:59362 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 18:26:05');
INSERT INTO `exception_log` VALUES (26, '7e0abb0d-0d23-4ee2-b8eb-36ec186b62e2', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:33:40', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/2) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=6108&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557655507560&revision=1.0.0&side=consumer&sticky=false&timestamp=1557655554608&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 18:33:38.688, end time: 2019-05-12 18:33:39.692, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=170, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.3.26:8091:2011359067, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:59362 -> /192.168.3.26:20884', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 18:33:38.688, end time: 2019-05-12 18:33:39.692, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=170, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.3.26:8091:2011359067, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:59362 -> /192.168.3.26:20884', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method useCouponCard in the service cn.iocoder.mall.promotion.api.CouponService. Tried 3 times of the providers [192.168.3.26:20884] (1/2) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: useCouponCard, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.CouponService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.CouponService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.CouponService&lazy=false&methods=addCouponCardTemplate,updateCouponTemplateStatus,getCouponTemplatePage,getCouponCardList,updateCouponCardTemplate,useCouponCode,addCouponCodeTemplate,useCouponCard,getCouponTemplate,addCouponCard,getCouponCardDetail,cancelUseCouponCard,updateCouponCodeTemplate,getCouponCardPage&pid=6108&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557655507560&revision=1.0.0&side=consumer&sticky=false&timestamp=1557655554608&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-12 18:33:38.688, end time: 2019-05-12 18:33:39.692, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=170, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.3.26:8091:2011359067, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:59362 -> /192.168.3.26:20884\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.useCouponCard(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.useCouponCard(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:262)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$929d18e5.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-12 18:33:38.688, end time: 2019-05-12 18:33:39.692, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=170, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=useCouponCard, parameterTypes=[class java.lang.Integer, class java.lang.Integer], arguments=[1, 1], attachments={path=cn.iocoder.mall.promotion.api.CouponService, TX_XID=192.168.3.26:8091:2011359067, interface=cn.iocoder.mall.promotion.api.CouponService, version=1.0.0}]], channel: /192.168.3.26:59362 -> /192.168.3.26:20884\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 136 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 18:33:40');
INSERT INTO `exception_log` VALUES (27, '2be99b52-b7f4-4f1d-a5c7-ed1dc045ffb9', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 18:42:33', 'java.lang.RuntimeException', 'RuntimeException: 测试 seata 事务回滚', 'RuntimeException: 测试 seata 事务回滚', 'java.lang.RuntimeException: 测试 seata 事务回滚\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:327)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$dd4901cb.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl', 'OrderServiceImpl.java', 'createOrder', 327, '2019-05-12 18:42:33');
INSERT INTO `exception_log` VALUES (28, 'e7ad1163-bd6b-4160-b2b5-a4c332e1b657', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:46:41', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getPromotionActivityListBySpuIds in the service cn.iocoder.mall.promotion.api.PromotionActivityService. Tried 3 times of the providers [192.168.3.26:20884] (1/4) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getPromotionActivityListBySpuIds, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=7280&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557663986985&revision=1.0.0&side=consumer&sticky=false&timestamp=1557657667685&validation=true&version=1.0.0, cause: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=7280&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557657667685&validation=true&version=1.0.0', 'RemotingException: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=7280&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557657667685&validation=true&version=1.0.0', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getPromotionActivityListBySpuIds in the service cn.iocoder.mall.promotion.api.PromotionActivityService. Tried 3 times of the providers [192.168.3.26:20884] (1/4) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getPromotionActivityListBySpuIds, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=7280&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557663986985&revision=1.0.0&side=consumer&sticky=false&timestamp=1557657667685&validation=true&version=1.0.0, cause: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=7280&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557657667685&validation=true&version=1.0.0\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getPromotionActivityListBySpuIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy137.getPromotionActivityListBySpuIds(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.CartServiceImpl.calcOrderPrice(CartServiceImpl.java:160)\n	at org.apache.dubbo.common.bytecode.Wrapper11.invokeMethod(Wrapper11.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.calcOrderPrice(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy142.calcOrderPrice(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getConfirmCreateOrder(OrderController.java:112)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.RemotingException: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=7280&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557657667685&validation=true&version=1.0.0\n	at org.apache.dubbo.remoting.transport.AbstractClient.send(AbstractClient.java:171)\n	at org.apache.dubbo.remoting.transport.AbstractPeer.send(AbstractPeer.java:53)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeChannel.request(HeaderExchangeChannel.java:116)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeClient.request(HeaderExchangeClient.java:81)\n	at org.apache.dubbo.rpc.protocol.dubbo.ReferenceCountExchangeClient.request(ReferenceCountExchangeClient.java:76)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 122 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 20:46:41');
INSERT INTO `exception_log` VALUES (29, '4045d9b2-4efd-4663-9267-940b480df65f', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:46:43', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getPromotionActivityListBySpuIds in the service cn.iocoder.mall.promotion.api.PromotionActivityService. Tried 3 times of the providers [192.168.3.26:20884] (1/4) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getPromotionActivityListBySpuIds, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=7280&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557665188941&revision=1.0.0&side=consumer&sticky=false&timestamp=1557657667685&validation=true&version=1.0.0, cause: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=7280&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557657667685&validation=true&version=1.0.0', 'RemotingException: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=7280&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557657667685&validation=true&version=1.0.0', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getPromotionActivityListBySpuIds in the service cn.iocoder.mall.promotion.api.PromotionActivityService. Tried 3 times of the providers [192.168.3.26:20884] (1/4) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getPromotionActivityListBySpuIds, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=7280&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557665188941&revision=1.0.0&side=consumer&sticky=false&timestamp=1557657667685&validation=true&version=1.0.0, cause: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=7280&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557657667685&validation=true&version=1.0.0\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getPromotionActivityListBySpuIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy137.getPromotionActivityListBySpuIds(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.CartServiceImpl.calcOrderPrice(CartServiceImpl.java:160)\n	at org.apache.dubbo.common.bytecode.Wrapper11.invokeMethod(Wrapper11.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.calcOrderPrice(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy142.calcOrderPrice(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getConfirmCreateOrder(OrderController.java:112)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.RemotingException: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=7280&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557657667685&validation=true&version=1.0.0\n	at org.apache.dubbo.remoting.transport.AbstractClient.send(AbstractClient.java:171)\n	at org.apache.dubbo.remoting.transport.AbstractPeer.send(AbstractPeer.java:53)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeChannel.request(HeaderExchangeChannel.java:116)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeClient.request(HeaderExchangeClient.java:81)\n	at org.apache.dubbo.rpc.protocol.dubbo.ReferenceCountExchangeClient.request(ReferenceCountExchangeClient.java:76)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 122 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-12 20:46:43');
INSERT INTO `exception_log` VALUES (30, '61ab9d4a-45c9-4dbe-a3ce-7cdf0aa710b6', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:49:54', 'java.lang.RuntimeException', 'RuntimeException: 测试 seata 事务回滚', 'RuntimeException: 测试 seata 事务回滚', 'java.lang.RuntimeException: 测试 seata 事务回滚\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:327)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$24d5ea87.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl', 'OrderServiceImpl.java', 'createOrder', 327, '2019-05-12 20:49:54');
INSERT INTO `exception_log` VALUES (31, 'bd0bc312-7f73-4e63-b9d9-7082e054bfce', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:50:09', 'java.lang.RuntimeException', 'RuntimeException: 测试 seata 事务回滚', 'RuntimeException: 测试 seata 事务回滚', 'java.lang.RuntimeException: 测试 seata 事务回滚\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:327)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$24d5ea87.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl', 'OrderServiceImpl.java', 'createOrder', 327, '2019-05-12 20:50:09');
INSERT INTO `exception_log` VALUES (32, '6f3e485c-00d0-41b9-a064-9ce3053c56c6', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-12 20:50:32', 'java.lang.RuntimeException', 'RuntimeException: 测试 seata 事务回滚', 'RuntimeException: 测试 seata 事务回滚', 'java.lang.RuntimeException: 测试 seata 事务回滚\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:327)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$24d5ea87.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl', 'OrderServiceImpl.java', 'createOrder', 327, '2019-05-12 20:50:32');
INSERT INTO `exception_log` VALUES (33, '7b18a988-2b58-4f63-b01b-3f4a3b4d2600', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:30', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `status` = ?                               AND `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `status` = ?                               AND `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy108.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy109.selectPageCount(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy111.selectPageCount(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.getOrderPage(OrderServiceImpl.java:81)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:82)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$6821fd03.getOrderPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.getOrderPage(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getOrderPage(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getOrderPage(OrderController.java:61)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:498)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy170.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 134 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-12 21:07:30');
INSERT INTO `exception_log` VALUES (34, '65d5ec8c-9413-46b0-ab92-405ee73073c2', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:31', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy108.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy109.selectPageCount(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy111.selectPageCount(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.getOrderPage(OrderServiceImpl.java:81)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:82)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$6821fd03.getOrderPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.getOrderPage(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getOrderPage(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getOrderPage(OrderController.java:61)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:498)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy170.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 134 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-12 21:07:31');
INSERT INTO `exception_log` VALUES (35, '33f0410f-1e51-4d8d-9ddc-96434693ab01', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:31', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy108.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy109.selectPageCount(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy111.selectPageCount(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.getOrderPage(OrderServiceImpl.java:81)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:82)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$6821fd03.getOrderPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.getOrderPage(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getOrderPage(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getOrderPage(OrderController.java:61)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:498)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy170.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 134 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-12 21:07:31');
INSERT INTO `exception_log` VALUES (36, '122aba50-68e6-451e-90bf-767efa11c45e', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:33', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `status` = ?                               AND `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `status` = ?                               AND `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy108.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy109.selectPageCount(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy111.selectPageCount(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.getOrderPage(OrderServiceImpl.java:81)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:82)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$6821fd03.getOrderPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.getOrderPage(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getOrderPage(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getOrderPage(OrderController.java:61)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:498)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy170.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 134 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-12 21:07:33');
INSERT INTO `exception_log` VALUES (37, 'c4303fee-dafe-4105-9396-1797bdd326ef', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:33', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `status` = ?                               AND `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `status` = ?                               AND `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy108.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy109.selectPageCount(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy111.selectPageCount(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.getOrderPage(OrderServiceImpl.java:81)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:82)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$6821fd03.getOrderPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.getOrderPage(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getOrderPage(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getOrderPage(OrderController.java:61)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:498)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy170.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 134 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-12 21:07:33');
INSERT INTO `exception_log` VALUES (38, '3c52a247-4b56-4204-8291-af0ca31801cb', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=4', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:34', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `status` = ?                               AND `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `status` = ?                               AND `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy108.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy109.selectPageCount(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy111.selectPageCount(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.getOrderPage(OrderServiceImpl.java:81)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:82)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$6821fd03.getOrderPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.getOrderPage(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getOrderPage(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getOrderPage(OrderController.java:61)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:498)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy170.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 134 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-12 21:07:34');
INSERT INTO `exception_log` VALUES (39, '0051cfd4-0316-447e-bec9-ee01720e2816', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:07:40', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy108.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy109.selectPageCount(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy111.selectPageCount(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.getOrderPage(OrderServiceImpl.java:81)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:82)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$6821fd03.getOrderPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.getOrderPage(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getOrderPage(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getOrderPage(OrderController.java:61)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:498)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy170.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 134 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-12 21:07:40');
INSERT INTO `exception_log` VALUES (40, '95384b6c-9bf0-4638-8d24-8ca76223dfed', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:10:34', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy108.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy109.selectPageCount(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy111.selectPageCount(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.getOrderPage(OrderServiceImpl.java:81)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:82)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$6821fd03.getOrderPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.getOrderPage(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getOrderPage(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getOrderPage(OrderController.java:61)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:498)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy170.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 134 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-12 21:10:34');
INSERT INTO `exception_log` VALUES (41, '89bd39f8-8862-42fe-ad41-501948b8799d', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:17:29', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy108.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy109.selectPageCount(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy111.selectPageCount(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.getOrderPage(OrderServiceImpl.java:81)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:82)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$e8ed5bc8.getOrderPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.getOrderPage(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getOrderPage(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getOrderPage(OrderController.java:61)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:498)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy170.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 134 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-12 21:17:29');
INSERT INTO `exception_log` VALUES (42, '8b4f3e6c-02b4-4589-b210-e4692d680f4d', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:17:33', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `status` = ?                               AND `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `status` = ?                               AND `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy108.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy109.selectPageCount(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy111.selectPageCount(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.getOrderPage(OrderServiceImpl.java:81)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:82)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$e8ed5bc8.getOrderPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.getOrderPage(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getOrderPage(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getOrderPage(OrderController.java:61)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:498)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy170.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 134 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-12 21:17:33');
INSERT INTO `exception_log` VALUES (43, '83f1293b-5853-4489-9ff8-f1c5c17035f5', 29, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:17:29', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `status` = ?                               AND `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n### The error may exist in file [/Users/Sin/code-aliyun/onemall/order/order-service-impl/target/classes/mapper/OrderMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT         COUNT(*)         FROM `order`          WHERE  `status` = ?                               AND `user_id` = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy108.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy109.selectPageCount(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy111.selectPageCount(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.getOrderPage(OrderServiceImpl.java:81)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:82)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$e8ed5bc8.getOrderPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.getOrderPage(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getOrderPage(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getOrderPage(OrderController.java:61)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_order.order\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:498)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy170.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 134 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-12 21:17:29');
INSERT INTO `exception_log` VALUES (44, '73897611-f7c5-4b69-ab78-250442dcec08', 29, 1, 'order-application', '/order-api/users/order/create_order_from_cart', 'userAddressId=6&remark=', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:21:13', 'io.seata.common.exception.FrameworkException', 'FrameworkException: can not register TM,err:can not connect to services-server.', 'FrameworkException: can not register TM,err:can not connect to services-server.', 'io.seata.common.exception.FrameworkException: can not register TM,err:can not connect to services-server.\n	at io.seata.core.rpc.netty.TmRpcClient.doConnect(TmRpcClient.java:325)\n	at io.seata.core.rpc.netty.TmRpcClient.connect(TmRpcClient.java:257)\n	at io.seata.core.rpc.netty.TmRpcClient.sendMsgWithResponse(TmRpcClient.java:166)\n	at io.seata.core.rpc.netty.TmRpcClient.sendMsgWithResponse(TmRpcClient.java:178)\n	at io.seata.tm.DefaultTransactionManager.syncCall(DefaultTransactionManager.java:79)\n	at io.seata.tm.DefaultTransactionManager.begin(DefaultTransactionManager.java:49)\n	at io.seata.tm.api.DefaultGlobalTransaction.begin(DefaultGlobalTransaction.java:95)\n	at io.seata.tm.api.TransactionalTemplate.beginTransaction(TransactionalTemplate.java:123)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:58)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$91a18be1.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.createOrder(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrderFromCart(OrderController.java:91)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'io.seata.core.rpc.netty.TmRpcClient', 'TmRpcClient.java', 'doConnect', 325, '2019-05-12 21:21:13');
INSERT INTO `exception_log` VALUES (45, 'c6f4354c-bf92-4866-9400-0a6188250723', 29, 1, 'product-application', '/product-api/users/spu/info', 'id=undefined', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:23:17', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException', 'MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"undefined\"', 'NumberFormatException: For input string: \"undefined\"', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"undefined\"\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:132)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.lang.NumberFormatException: For input string: \"undefined\"\n	at java.lang.NumberFormatException.forInputString(NumberFormatException.java:65)\n	at java.lang.Integer.parseInt(Integer.java:580)\n	at java.lang.Integer.valueOf(Integer.java:766)\n	at org.springframework.util.NumberUtils.parseNumber(NumberUtils.java:211)\n	at org.springframework.beans.propertyeditors.CustomNumberEditor.setAsText(CustomNumberEditor.java:115)\n	at org.springframework.beans.TypeConverterDelegate.doConvertTextValue(TypeConverterDelegate.java:429)\n	at org.springframework.beans.TypeConverterDelegate.doConvertValue(TypeConverterDelegate.java:402)\n	at org.springframework.beans.TypeConverterDelegate.convertIfNecessary(TypeConverterDelegate.java:155)\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:73)\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:53)\n	at org.springframework.validation.DataBinder.convertIfNecessary(DataBinder.java:693)\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:124)\n	... 60 more\n', 'org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver', 'AbstractNamedValueMethodArgumentResolver.java', 'resolveArgument', 132, '2019-05-12 21:23:17');
INSERT INTO `exception_log` VALUES (46, 'b0781550-81c2-46fd-9ca8-04e9f390a0b2', 29, 1, 'order-application', '/order-api/users/order_return/apply', '', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:31:34', 'org.mybatis.spring.MyBatisSystemException', 'MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'refuse_time\' in \'class cn.iocoder.mall.order.biz.dataobject.OrderReturnDO\'', 'ReflectionException: There is no getter for property named \'refuse_time\' in \'class cn.iocoder.mall.order.biz.dataobject.OrderReturnDO\'', 'org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'refuse_time\' in \'class cn.iocoder.mall.order.biz.dataobject.OrderReturnDO\'\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy108.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy114.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy115.insert(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderReturnServiceImpl.orderReturnApply(OrderReturnServiceImpl.java:81)\n	at cn.iocoder.mall.order.biz.service.OrderReturnServiceImpl$$FastClassBySpringCGLIB$$1237e033.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.order.biz.service.OrderReturnServiceImpl$$EnhancerBySpringCGLIB$$821a2871.orderReturnApply(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper14.invokeMethod(Wrapper14.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy13.orderReturnApply(proxy13.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy143.orderReturnApply(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderReturnController.orderReturnApply(OrderReturnController.java:43)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'refuse_time\' in \'class cn.iocoder.mall.order.biz.dataobject.OrderReturnDO\'\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.setParameters(MybatisDefaultParameterHandler.java:219)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.parameterize(PreparedStatementHandler.java:94)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.parameterize(RoutingStatementHandler.java:64)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.prepareStatement(MybatisSimpleExecutor.java:99)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:53)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 130 more\n', 'org.mybatis.spring.MyBatisExceptionTranslator', 'MyBatisExceptionTranslator.java', 'translateExceptionIfPossible', 77, '2019-05-12 21:31:34');
INSERT INTO `exception_log` VALUES (47, 'adc6ce1d-51fe-4683-90ec-e742676da846', 29, 1, 'order-application', '/order-api/users/order_return/apply', '', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-12 21:31:53', 'org.mybatis.spring.MyBatisSystemException', 'MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'refuse_time\' in \'class cn.iocoder.mall.order.biz.dataobject.OrderReturnDO\'', 'ReflectionException: There is no getter for property named \'refuse_time\' in \'class cn.iocoder.mall.order.biz.dataobject.OrderReturnDO\'', 'org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'refuse_time\' in \'class cn.iocoder.mall.order.biz.dataobject.OrderReturnDO\'\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy108.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy114.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy115.insert(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderReturnServiceImpl.orderReturnApply(OrderReturnServiceImpl.java:81)\n	at cn.iocoder.mall.order.biz.service.OrderReturnServiceImpl$$FastClassBySpringCGLIB$$1237e033.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.order.biz.service.OrderReturnServiceImpl$$EnhancerBySpringCGLIB$$821a2871.orderReturnApply(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper14.invokeMethod(Wrapper14.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy13.orderReturnApply(proxy13.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy143.orderReturnApply(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderReturnController.orderReturnApply(OrderReturnController.java:43)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'refuse_time\' in \'class cn.iocoder.mall.order.biz.dataobject.OrderReturnDO\'\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.setParameters(MybatisDefaultParameterHandler.java:219)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.parameterize(PreparedStatementHandler.java:94)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.parameterize(RoutingStatementHandler.java:64)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.prepareStatement(MybatisSimpleExecutor.java:99)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:53)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 130 more\n', 'org.mybatis.spring.MyBatisExceptionTranslator', 'MyBatisExceptionTranslator.java', 'translateExceptionIfPossible', 77, '2019-05-12 21:31:53');
INSERT INTO `exception_log` VALUES (48, '4fd2ebf0-d883-4112-bd5e-865ead8ad55c', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:03:17', 'java.lang.RuntimeException', 'RuntimeException: 测试 seata 事务回滚', 'RuntimeException: 测试 seata 事务回滚', 'java.lang.RuntimeException: 测试 seata 事务回滚\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:327)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl', 'OrderServiceImpl.java', 'createOrder', 327, '2019-05-13 00:03:17');
INSERT INTO `exception_log` VALUES (49, '0e7f7f33-8820-4b25-b086-b5df6d46e90a', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:03:32', 'java.lang.RuntimeException', 'RuntimeException: 测试 seata 事务回滚', 'RuntimeException: 测试 seata 事务回滚', 'java.lang.RuntimeException: 测试 seata 事务回滚\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:327)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl', 'OrderServiceImpl.java', 'createOrder', 327, '2019-05-13 00:03:32');
INSERT INTO `exception_log` VALUES (50, '7be7d518-47bf-4f1e-9299-16c702a87781', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:03:32', 'java.lang.RuntimeException', 'RuntimeException: 测试 seata 事务回滚', 'RuntimeException: 测试 seata 事务回滚', 'java.lang.RuntimeException: 测试 seata 事务回滚\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:327)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl', 'OrderServiceImpl.java', 'createOrder', 327, '2019-05-13 00:03:32');
INSERT INTO `exception_log` VALUES (51, 'bf053e8a-7da3-46ca-aca2-4e25a366a31a', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:03:32', 'java.lang.RuntimeException', 'RuntimeException: 测试 seata 事务回滚', 'RuntimeException: 测试 seata 事务回滚', 'java.lang.RuntimeException: 测试 seata 事务回滚\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:327)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl', 'OrderServiceImpl.java', 'createOrder', 327, '2019-05-13 00:03:32');
INSERT INTO `exception_log` VALUES (52, '21aaedb9-159d-48b5-9376-915713440a92', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:03:32', 'java.lang.RuntimeException', 'RuntimeException: 测试 seata 事务回滚', 'RuntimeException: 测试 seata 事务回滚', 'java.lang.RuntimeException: 测试 seata 事务回滚\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:327)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl', 'OrderServiceImpl.java', 'createOrder', 327, '2019-05-13 00:03:32');
INSERT INTO `exception_log` VALUES (53, 'fd69b766-34dc-4bb8-9b7b-52f3667c77ff', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:18:24', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.UncategorizedSQLException: \n### Error updating database.  Cause: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n### The error may exist in file [/Users/yunai/Java/mall-two/promotion/promotion-service-impl/target/classes/mapper/CouponCardMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: UPDATE coupon_card          SET status = ?,                                           used_time = ?          WHERE id = ?         AND status = ?\n### Cause: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n; uncategorized SQLException; SQL state [null]; error code [0]; io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]; nested exception is java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\norg.springframework.jdbc.UncategorizedSQLException: \n### Error updating database.  Cause: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n### The error may exist in file [/Users/yunai/Java/mall-two/promotion/promotion-service-impl/target/classes/mapper/CouponCardMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: UPDATE coupon_card          SET status = ?,                                           used_time = ?          WHERE id = ?         AND status = ?\n### Cause: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n; uncategorized SQLException; SQL state [null]; error code [0]; io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]; nested exception is java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:89)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:81)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:81)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy86.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy96.updateByIdAndStatus(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy97.updateByIdAndStatus(Unknown Source)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl.useCouponCard(CouponServiceImpl.java:252)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl$$FastClassBySpringCGLIB$$4c1d1cc8.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl$$EnhancerBySpringCGLIB$$35783284.useCouponCard(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n	at io.seata.rm.datasource.ConnectionProxy.recognizeLockKeyConflictException(ConnectionProxy.java:133)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:182)\n	at io.seata.rm.datasource.ConnectionProxy.commit(ConnectionProxy.java:159)\n	at io.seata.rm.datasource.ConnectionProxy.setAutoCommit(ConnectionProxy.java:221)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.executeAutoCommitTrue(AbstractDMLBaseExecutor.java:107)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.doExecute(AbstractDMLBaseExecutor.java:57)\n	at io.seata.rm.datasource.exec.BaseTransactionalExecutor.execute(BaseTransactionalExecutor.java:86)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:101)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 54 more\nCaused by: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n	at io.seata.rm.AbstractResourceManager.branchRegister(AbstractResourceManager.java:68)\n	at io.seata.rm.DefaultResourceManager.branchRegister(DefaultResourceManager.java:96)\n	at io.seata.rm.datasource.ConnectionProxy.register(ConnectionProxy.java:201)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:180)\n	... 73 more\n', 'RuntimeException: org.springframework.jdbc.UncategorizedSQLException: \n### Error updating database.  Cause: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n### The error may exist in file [/Users/yunai/Java/mall-two/promotion/promotion-service-impl/target/classes/mapper/CouponCardMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: UPDATE coupon_card          SET status = ?,                                           used_time = ?          WHERE id = ?         AND status = ?\n### Cause: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n; uncategorized SQLException; SQL state [null]; error code [0]; io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]; nested exception is java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\norg.springframework.jdbc.UncategorizedSQLException: \n### Error updating database.  Cause: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n### The error may exist in file [/Users/yunai/Java/mall-two/promotion/promotion-service-impl/target/classes/mapper/CouponCardMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: UPDATE coupon_card          SET status = ?,                                           used_time = ?          WHERE id = ?         AND status = ?\n### Cause: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n; uncategorized SQLException; SQL state [null]; error code [0]; io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]; nested exception is java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:89)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:81)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:81)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy86.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy96.updateByIdAndStatus(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy97.updateByIdAndStatus(Unknown Source)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl.useCouponCard(CouponServiceImpl.java:252)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl$$FastClassBySpringCGLIB$$4c1d1cc8.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl$$EnhancerBySpringCGLIB$$35783284.useCouponCard(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n	at io.seata.rm.datasource.ConnectionProxy.recognizeLockKeyConflictException(ConnectionProxy.java:133)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:182)\n	at io.seata.rm.datasource.ConnectionProxy.commit(ConnectionProxy.java:159)\n	at io.seata.rm.datasource.ConnectionProxy.setAutoCommit(ConnectionProxy.java:221)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.executeAutoCommitTrue(AbstractDMLBaseExecutor.java:107)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.doExecute(AbstractDMLBaseExecutor.java:57)\n	at io.seata.rm.datasource.exec.BaseTransactionalExecutor.execute(BaseTransactionalExecutor.java:86)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:101)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 54 more\nCaused by: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n	at io.seata.rm.AbstractResourceManager.branchRegister(AbstractResourceManager.java:68)\n	at io.seata.rm.DefaultResourceManager.branchRegister(DefaultResourceManager.java:96)\n	at io.seata.rm.datasource.ConnectionProxy.register(ConnectionProxy.java:201)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:180)\n	... 73 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.UncategorizedSQLException: \n### Error updating database.  Cause: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n### The error may exist in file [/Users/yunai/Java/mall-two/promotion/promotion-service-impl/target/classes/mapper/CouponCardMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: UPDATE coupon_card          SET status = ?,                                           used_time = ?          WHERE id = ?         AND status = ?\n### Cause: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n; uncategorized SQLException; SQL state [null]; error code [0]; io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]; nested exception is java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\norg.springframework.jdbc.UncategorizedSQLException: \n### Error updating database.  Cause: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n### The error may exist in file [/Users/yunai/Java/mall-two/promotion/promotion-service-impl/target/classes/mapper/CouponCardMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: UPDATE coupon_card          SET status = ?,                                           used_time = ?          WHERE id = ?         AND status = ?\n### Cause: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n; uncategorized SQLException; SQL state [null]; error code [0]; io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]; nested exception is java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:89)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:81)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:81)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy86.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy96.updateByIdAndStatus(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy97.updateByIdAndStatus(Unknown Source)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl.useCouponCard(CouponServiceImpl.java:252)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl$$FastClassBySpringCGLIB$$4c1d1cc8.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl$$EnhancerBySpringCGLIB$$35783284.useCouponCard(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n	at io.seata.rm.datasource.ConnectionProxy.recognizeLockKeyConflictException(ConnectionProxy.java:133)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:182)\n	at io.seata.rm.datasource.ConnectionProxy.commit(ConnectionProxy.java:159)\n	at io.seata.rm.datasource.ConnectionProxy.setAutoCommit(ConnectionProxy.java:221)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.executeAutoCommitTrue(AbstractDMLBaseExecutor.java:107)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.doExecute(AbstractDMLBaseExecutor.java:57)\n	at io.seata.rm.datasource.exec.BaseTransactionalExecutor.execute(BaseTransactionalExecutor.java:86)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:101)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 54 more\nCaused by: io.seata.core.exception.TransactionException: Response[TransactionException[2011404232]]\n	at io.seata.rm.AbstractResourceManager.branchRegister(AbstractResourceManager.java:68)\n	at io.seata.rm.DefaultResourceManager.branchRegister(DefaultResourceManager.java:96)\n	at io.seata.rm.datasource.ConnectionProxy.register(ConnectionProxy.java:201)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:180)\n	... 73 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-13 00:18:24');
INSERT INTO `exception_log` VALUES (54, '8567955b-b245-4910-8fd4-3da8553f62b2', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:18:49', 'java.lang.RuntimeException', 'RuntimeException: 测试 seata 事务回滚', 'RuntimeException: 测试 seata 事务回滚', 'java.lang.RuntimeException: 测试 seata 事务回滚\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:327)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl', 'OrderServiceImpl.java', 'createOrder', 327, '2019-05-13 00:18:49');
INSERT INTO `exception_log` VALUES (55, '02a7069a-d821-481b-b8b3-034bf7f69bad', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:22:20', 'java.lang.reflect.UndeclaredThrowableException', 'UndeclaredThrowableException: ', 'TimeoutException: cost 30005 ms', 'java.lang.reflect.UndeclaredThrowableException\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: io.seata.core.exception.TransactionException: java.util.concurrent.TimeoutException: cost 30005 ms\n	at io.seata.tm.DefaultTransactionManager.syncCall(DefaultTransactionManager.java:81)\n	at io.seata.tm.DefaultTransactionManager.rollback(DefaultTransactionManager.java:65)\n	at io.seata.tm.api.DefaultGlobalTransaction.rollback(DefaultGlobalTransaction.java:142)\n	at io.seata.tm.api.TransactionalTemplate.rollbackTransaction(TransactionalTemplate.java:114)\n	at io.seata.tm.api.TransactionalTemplate.completeTransactionAfterThrowing(TransactionalTemplate.java:88)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:69)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	... 112 more\nCaused by: java.util.concurrent.TimeoutException: cost 30005 ms\n	at io.seata.core.protocol.MessageFuture.get(MessageFuture.java:64)\n	at io.seata.core.rpc.netty.AbstractRpcRemoting.sendAsyncRequest(AbstractRpcRemoting.java:265)\n	at io.seata.core.rpc.netty.AbstractRpcRemoting.sendAsyncRequestWithResponse(AbstractRpcRemoting.java:195)\n	at io.seata.core.rpc.netty.TmRpcClient.sendMsgWithResponse(TmRpcClient.java:165)\n	at io.seata.core.rpc.netty.TmRpcClient.sendMsgWithResponse(TmRpcClient.java:176)\n	at io.seata.tm.DefaultTransactionManager.syncCall(DefaultTransactionManager.java:79)\n	... 121 more\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c', '<generated>', 'createOrder', -1, '2019-05-13 00:22:20');
INSERT INTO `exception_log` VALUES (56, '222bbd66-baa8-4252-900f-c28dbcae53c7', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:24:01', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getPromotionActivityListBySpuIds in the service cn.iocoder.mall.promotion.api.PromotionActivityService. Tried 3 times of the providers [192.168.3.26:20884] (1/5) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getPromotionActivityListBySpuIds, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557663986985&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0, cause: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0', 'RemotingException: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getPromotionActivityListBySpuIds in the service cn.iocoder.mall.promotion.api.PromotionActivityService. Tried 3 times of the providers [192.168.3.26:20884] (1/5) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getPromotionActivityListBySpuIds, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557663986985&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0, cause: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getPromotionActivityListBySpuIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy137.getPromotionActivityListBySpuIds(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.CartServiceImpl.calcOrderPrice(CartServiceImpl.java:160)\n	at org.apache.dubbo.common.bytecode.Wrapper11.invokeMethod(Wrapper11.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.calcOrderPrice(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy142.calcOrderPrice(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getConfirmCreateOrder(OrderController.java:112)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.RemotingException: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0\n	at org.apache.dubbo.remoting.transport.AbstractClient.send(AbstractClient.java:171)\n	at org.apache.dubbo.remoting.transport.AbstractPeer.send(AbstractPeer.java:53)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeChannel.request(HeaderExchangeChannel.java:116)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeClient.request(HeaderExchangeClient.java:81)\n	at org.apache.dubbo.rpc.protocol.dubbo.ReferenceCountExchangeClient.request(ReferenceCountExchangeClient.java:76)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 122 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-13 00:24:01');
INSERT INTO `exception_log` VALUES (57, 'a21ee471-3d74-42bd-ad5d-7e9b2b1e5ae1', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:24:02', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getPromotionActivityListBySpuIds in the service cn.iocoder.mall.promotion.api.PromotionActivityService. Tried 3 times of the providers [192.168.3.26:20884] (1/5) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getPromotionActivityListBySpuIds, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0, cause: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0', 'RemotingException: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getPromotionActivityListBySpuIds in the service cn.iocoder.mall.promotion.api.PromotionActivityService. Tried 3 times of the providers [192.168.3.26:20884] (1/5) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getPromotionActivityListBySpuIds, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0, cause: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getPromotionActivityListBySpuIds(proxy3.java)\n	at sun.reflect.GeneratedMethodAccessor425.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy137.getPromotionActivityListBySpuIds(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.CartServiceImpl.calcOrderPrice(CartServiceImpl.java:160)\n	at org.apache.dubbo.common.bytecode.Wrapper11.invokeMethod(Wrapper11.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.calcOrderPrice(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy142.calcOrderPrice(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getConfirmCreateOrder(OrderController.java:112)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.RemotingException: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0\n	at org.apache.dubbo.remoting.transport.AbstractClient.send(AbstractClient.java:171)\n	at org.apache.dubbo.remoting.transport.AbstractPeer.send(AbstractPeer.java:53)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeChannel.request(HeaderExchangeChannel.java:116)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeClient.request(HeaderExchangeClient.java:81)\n	at org.apache.dubbo.rpc.protocol.dubbo.ReferenceCountExchangeClient.request(ReferenceCountExchangeClient.java:76)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 121 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-13 00:24:02');
INSERT INTO `exception_log` VALUES (58, 'dbe0cb0d-1ad9-4a76-8936-786a7a3e192c', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:24:05', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getPromotionActivityListBySpuIds in the service cn.iocoder.mall.promotion.api.PromotionActivityService. Tried 3 times of the providers [192.168.3.26:20884] (1/5) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getPromotionActivityListBySpuIds, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0, cause: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0', 'RemotingException: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getPromotionActivityListBySpuIds in the service cn.iocoder.mall.promotion.api.PromotionActivityService. Tried 3 times of the providers [192.168.3.26:20884] (1/5) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getPromotionActivityListBySpuIds, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0, cause: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getPromotionActivityListBySpuIds(proxy3.java)\n	at sun.reflect.GeneratedMethodAccessor425.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy137.getPromotionActivityListBySpuIds(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.CartServiceImpl.calcOrderPrice(CartServiceImpl.java:160)\n	at org.apache.dubbo.common.bytecode.Wrapper11.invokeMethod(Wrapper11.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.calcOrderPrice(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy142.calcOrderPrice(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getConfirmCreateOrder(OrderController.java:112)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.RemotingException: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0\n	at org.apache.dubbo.remoting.transport.AbstractClient.send(AbstractClient.java:171)\n	at org.apache.dubbo.remoting.transport.AbstractPeer.send(AbstractPeer.java:53)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeChannel.request(HeaderExchangeChannel.java:116)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeClient.request(HeaderExchangeClient.java:81)\n	at org.apache.dubbo.rpc.protocol.dubbo.ReferenceCountExchangeClient.request(ReferenceCountExchangeClient.java:76)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 121 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-13 00:24:05');
INSERT INTO `exception_log` VALUES (59, 'fb959401-c91e-418f-ad98-42d0372d0bfd', 1, 1, 'order-application', '/order-api/users/order/confirm_create_order', 'skuId=36&quantity=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:24:06', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getPromotionActivityListBySpuIds in the service cn.iocoder.mall.promotion.api.PromotionActivityService. Tried 3 times of the providers [192.168.3.26:20884] (1/5) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getPromotionActivityListBySpuIds, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0, cause: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0', 'RemotingException: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getPromotionActivityListBySpuIds in the service cn.iocoder.mall.promotion.api.PromotionActivityService. Tried 3 times of the providers [192.168.3.26:20884] (1/5) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getPromotionActivityListBySpuIds, provider: dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0, cause: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getPromotionActivityListBySpuIds(proxy3.java)\n	at sun.reflect.GeneratedMethodAccessor425.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy137.getPromotionActivityListBySpuIds(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.CartServiceImpl.calcOrderPrice(CartServiceImpl.java:160)\n	at org.apache.dubbo.common.bytecode.Wrapper11.invokeMethod(Wrapper11.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.calcOrderPrice(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy142.calcOrderPrice(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.getConfirmCreateOrder(OrderController.java:112)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.RemotingException: message can not send, because channel is closed . url:dubbo://192.168.3.26:20884/cn.iocoder.mall.promotion.api.PromotionActivityService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.promotion.api.PromotionActivityService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.promotion.api.PromotionActivityService&lazy=false&methods=getPromotionActivityPage,getPromotionActivityListBySpuId,getPromotionActivityListBySpuIds&pid=15286&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=promotion-service&remote.timestamp=1557631216834&revision=1.0.0&side=consumer&sticky=false&timestamp=1557673510611&validation=true&version=1.0.0\n	at org.apache.dubbo.remoting.transport.AbstractClient.send(AbstractClient.java:171)\n	at org.apache.dubbo.remoting.transport.AbstractPeer.send(AbstractPeer.java:53)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeChannel.request(HeaderExchangeChannel.java:116)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeClient.request(HeaderExchangeClient.java:81)\n	at org.apache.dubbo.rpc.protocol.dubbo.ReferenceCountExchangeClient.request(ReferenceCountExchangeClient.java:76)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 121 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-13 00:24:06');
INSERT INTO `exception_log` VALUES (60, 'a25ae710-01ba-4d98-a2f6-7dca531487c2', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:28:11', 'java.lang.reflect.UndeclaredThrowableException', 'UndeclaredThrowableException: ', 'TimeoutException: cost 30004 ms', 'java.lang.reflect.UndeclaredThrowableException\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: io.seata.core.exception.TransactionException: java.util.concurrent.TimeoutException: cost 30004 ms\n	at io.seata.tm.DefaultTransactionManager.syncCall(DefaultTransactionManager.java:81)\n	at io.seata.tm.DefaultTransactionManager.rollback(DefaultTransactionManager.java:65)\n	at io.seata.tm.api.DefaultGlobalTransaction.rollback(DefaultGlobalTransaction.java:142)\n	at io.seata.tm.api.TransactionalTemplate.rollbackTransaction(TransactionalTemplate.java:114)\n	at io.seata.tm.api.TransactionalTemplate.completeTransactionAfterThrowing(TransactionalTemplate.java:88)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:69)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	... 112 more\nCaused by: java.util.concurrent.TimeoutException: cost 30004 ms\n	at io.seata.core.protocol.MessageFuture.get(MessageFuture.java:64)\n	at io.seata.core.rpc.netty.AbstractRpcRemoting.sendAsyncRequest(AbstractRpcRemoting.java:265)\n	at io.seata.core.rpc.netty.AbstractRpcRemoting.sendAsyncRequestWithResponse(AbstractRpcRemoting.java:195)\n	at io.seata.core.rpc.netty.TmRpcClient.sendMsgWithResponse(TmRpcClient.java:165)\n	at io.seata.core.rpc.netty.TmRpcClient.sendMsgWithResponse(TmRpcClient.java:176)\n	at io.seata.tm.DefaultTransactionManager.syncCall(DefaultTransactionManager.java:79)\n	... 121 more\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c', '<generated>', 'createOrder', -1, '2019-05-13 00:28:11');
INSERT INTO `exception_log` VALUES (61, 'a80520be-177b-43c1-9dc7-3700e3b324aa', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:30:50', 'java.lang.RuntimeException', 'RuntimeException: 测试 seata 事务回滚', 'RuntimeException: 测试 seata 事务回滚', 'java.lang.RuntimeException: 测试 seata 事务回滚\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:327)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl', 'OrderServiceImpl.java', 'createOrder', 327, '2019-05-13 00:30:50');
INSERT INTO `exception_log` VALUES (62, '3b930e99-7267-4709-984f-7cfd5a4175c7', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:31:24', 'java.lang.reflect.UndeclaredThrowableException', 'UndeclaredThrowableException: ', 'TimeoutException: cost 30005 ms', 'java.lang.reflect.UndeclaredThrowableException\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: io.seata.core.exception.TransactionException: java.util.concurrent.TimeoutException: cost 30005 ms\n	at io.seata.tm.DefaultTransactionManager.syncCall(DefaultTransactionManager.java:81)\n	at io.seata.tm.DefaultTransactionManager.rollback(DefaultTransactionManager.java:65)\n	at io.seata.tm.api.DefaultGlobalTransaction.rollback(DefaultGlobalTransaction.java:142)\n	at io.seata.tm.api.TransactionalTemplate.rollbackTransaction(TransactionalTemplate.java:114)\n	at io.seata.tm.api.TransactionalTemplate.completeTransactionAfterThrowing(TransactionalTemplate.java:88)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:69)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	... 112 more\nCaused by: java.util.concurrent.TimeoutException: cost 30005 ms\n	at io.seata.core.protocol.MessageFuture.get(MessageFuture.java:64)\n	at io.seata.core.rpc.netty.AbstractRpcRemoting.sendAsyncRequest(AbstractRpcRemoting.java:265)\n	at io.seata.core.rpc.netty.AbstractRpcRemoting.sendAsyncRequestWithResponse(AbstractRpcRemoting.java:195)\n	at io.seata.core.rpc.netty.TmRpcClient.sendMsgWithResponse(TmRpcClient.java:165)\n	at io.seata.core.rpc.netty.TmRpcClient.sendMsgWithResponse(TmRpcClient.java:176)\n	at io.seata.tm.DefaultTransactionManager.syncCall(DefaultTransactionManager.java:79)\n	... 121 more\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c', '<generated>', 'createOrder', -1, '2019-05-13 00:31:24');
INSERT INTO `exception_log` VALUES (63, '7e2a96b1-a27e-4716-946b-5808a263146a', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-13 00:32:47', 'java.lang.reflect.UndeclaredThrowableException', 'UndeclaredThrowableException: ', 'TimeoutException: cost 30006 ms', 'java.lang.reflect.UndeclaredThrowableException\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java:71)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: io.seata.core.exception.TransactionException: java.util.concurrent.TimeoutException: cost 30006 ms\n	at io.seata.tm.DefaultTransactionManager.syncCall(DefaultTransactionManager.java:81)\n	at io.seata.tm.DefaultTransactionManager.rollback(DefaultTransactionManager.java:65)\n	at io.seata.tm.api.DefaultGlobalTransaction.rollback(DefaultGlobalTransaction.java:142)\n	at io.seata.tm.api.TransactionalTemplate.rollbackTransaction(TransactionalTemplate.java:114)\n	at io.seata.tm.api.TransactionalTemplate.completeTransactionAfterThrowing(TransactionalTemplate.java:88)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:69)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	... 112 more\nCaused by: java.util.concurrent.TimeoutException: cost 30006 ms\n	at io.seata.core.protocol.MessageFuture.get(MessageFuture.java:64)\n	at io.seata.core.rpc.netty.AbstractRpcRemoting.sendAsyncRequest(AbstractRpcRemoting.java:265)\n	at io.seata.core.rpc.netty.AbstractRpcRemoting.sendAsyncRequestWithResponse(AbstractRpcRemoting.java:195)\n	at io.seata.core.rpc.netty.TmRpcClient.sendMsgWithResponse(TmRpcClient.java:165)\n	at io.seata.core.rpc.netty.TmRpcClient.sendMsgWithResponse(TmRpcClient.java:176)\n	at io.seata.tm.DefaultTransactionManager.syncCall(DefaultTransactionManager.java:79)\n	... 121 more\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$8505f94c', '<generated>', 'createOrder', -1, '2019-05-13 00:32:47');
INSERT INTO `exception_log` VALUES (64, '35.80.15577929563470001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-14 08:15:58', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 08:16:01');
INSERT INTO `exception_log` VALUES (65, '35.80.15577929563470001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-14 08:15:58', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 08:16:01');
INSERT INTO `exception_log` VALUES (66, '35.73.15577929563510001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-14 08:15:58', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 08:16:01');
INSERT INTO `exception_log` VALUES (67, '35.80.15577929563470001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-14 08:15:58', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 08:16:01');
INSERT INTO `exception_log` VALUES (68, '35.73.15577929563510001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-14 08:15:58', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 08:16:01');
INSERT INTO `exception_log` VALUES (69, '35.73.15577929563510001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-14 08:15:58', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 08:16:01');
INSERT INTO `exception_log` VALUES (70, '31.50.15577929577650001', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-14 08:15:59', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.checkToken(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:37)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 08:16:01');
INSERT INTO `exception_log` VALUES (71, '31.50.15577929577650001', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-14 08:15:59', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.checkToken(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:37)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 08:16:01');
INSERT INTO `exception_log` VALUES (72, '31.50.15577929577650001', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-14 08:15:59', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.checkToken(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:37)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 08:16:02');
INSERT INTO `exception_log` VALUES (73, '31.48.15577929650580001', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-14 08:16:05', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy98.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy99.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:87)\n	at org.apache.dubbo.common.bytecode.Wrapper5.invokeMethod(Wrapper5.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.send(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy106.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend$original$SRU2CEln(PassportController.java:61)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$TKKhn5Sc.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 08:16:05');
INSERT INTO `exception_log` VALUES (74, '30.66.15577970851340005', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '49.4.151.24', '2019-05-14 09:24:46', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf(AdminController.java:80)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$hIfPWlkH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 09:24:47');
INSERT INTO `exception_log` VALUES (75, '30.73.15577970851280003', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '49.4.151.24', '2019-05-14 09:24:46', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy1', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy1', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy1\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf(AdminController.java:52)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$IlnEqSoF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy1\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\n	... 95 more\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy1\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\n	at javassist.compiler.Javac.compile(Javac.java:95)\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\n	... 97 more\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-05-14 09:24:47');
INSERT INTO `exception_log` VALUES (76, '31.46.15577990927100001', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18611112222&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:58:13', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy93.selectByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy95.selectByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.getUser(UserServiceImpl.java:41)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$338719e3.getUser(<generated>)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:58)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAccessToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln(PassportController.java:52)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$CJXxcoww.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 09:58:13');
INSERT INTO `exception_log` VALUES (77, '31.52.15577990975920003', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18611112222&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:58:18', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy93.selectByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy95.selectByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.getUser(UserServiceImpl.java:41)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$338719e3.getUser(<generated>)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:58)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAccessToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln(PassportController.java:52)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$CJXxcoww.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 09:58:18');
INSERT INTO `exception_log` VALUES (78, '31.50.15577991005950003', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=18611112222', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '60.176.145.199', '2019-05-14 09:58:21', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy98.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy99.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:87)\n	at org.apache.dubbo.common.bytecode.Wrapper5.invokeMethod(Wrapper5.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.send(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy106.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend$original$SRU2CEln(PassportController.java:61)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$TKKhn5Sc.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 09:58:21');
INSERT INTO `exception_log` VALUES (79, '35.80.15578003356280005', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.54.41.188', '2019-05-14 10:18:56', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 10:18:56');
INSERT INTO `exception_log` VALUES (80, '35.73.15578003356250005', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '183.54.41.188', '2019-05-14 10:18:56', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 10:18:56');
INSERT INTO `exception_log` VALUES (81, '30.69.15578049225800003', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '119.139.199.184', '2019-05-14 11:35:23', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf(AdminController.java:52)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$IlnEqSoF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 11:35:23');
INSERT INTO `exception_log` VALUES (82, '30.72.15578049226250003', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/49.0.2623.112 Safari/537.36', '119.139.199.184', '2019-05-14 11:35:23', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf(AdminController.java:80)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$hIfPWlkH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 11:35:23');
INSERT INTO `exception_log` VALUES (83, '30.67.15578055312320009', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:31', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf(AdminController.java:52)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$IlnEqSoF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 11:45:31');
INSERT INTO `exception_log` VALUES (84, '30.73.15578055312300005', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:31', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf(AdminController.java:80)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$hIfPWlkH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 11:45:31');
INSERT INTO `exception_log` VALUES (85, '30.71.15578055401150007', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:40', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf(AdminController.java:52)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$IlnEqSoF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 11:45:40');
INSERT INTO `exception_log` VALUES (86, '30.65.15578055401140011', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.41.161.175', '2019-05-14 11:45:40', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf(AdminController.java:80)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$hIfPWlkH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 11:45:40');
INSERT INTO `exception_log` VALUES (87, '31.53.15578057371460001', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678901&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.41.161.175', '2019-05-14 11:48:57', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy93.selectByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy95.selectByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.getUser(UserServiceImpl.java:41)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$338719e3.getUser(<generated>)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:58)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAccessToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln(PassportController.java:52)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$CJXxcoww.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 11:48:57');
INSERT INTO `exception_log` VALUES (88, '31.48.15578057394250003', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=12345678901', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.41.161.175', '2019-05-14 11:48:59', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy98.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy99.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:87)\n	at org.apache.dubbo.common.bytecode.Wrapper5.invokeMethod(Wrapper5.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.send(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy106.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend$original$SRU2CEln(PassportController.java:61)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$TKKhn5Sc.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 11:48:59');
INSERT INTO `exception_log` VALUES (89, '31.45.15578057409990003', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=12345678901&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '59.41.161.175', '2019-05-14 11:49:01', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy93.selectByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy95.selectByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.getUser(UserServiceImpl.java:41)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$338719e3.getUser(<generated>)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:58)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAccessToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln(PassportController.java:52)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$CJXxcoww.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 11:49:01');
INSERT INTO `exception_log` VALUES (90, '30.68.15578089411540009', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '106.38.115.24', '2019-05-14 12:42:21', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf(AdminController.java:52)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$IlnEqSoF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 12:42:21');
INSERT INTO `exception_log` VALUES (91, '30.72.15578089411540005', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.0 Safari/605.1.15', '106.38.115.24', '2019-05-14 12:42:21', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf(AdminController.java:80)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$hIfPWlkH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 12:42:21');
INSERT INTO `exception_log` VALUES (92, '30.66.15578124125690009', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:40:13', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf(AdminController.java:80)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$hIfPWlkH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 13:40:13');
INSERT INTO `exception_log` VALUES (93, '30.71.15578124125690009', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '219.143.150.195', '2019-05-14 13:40:13', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf(AdminController.java:52)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$IlnEqSoF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 13:40:13');
INSERT INTO `exception_log` VALUES (94, '30.68.15578138394760013', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '218.17.157.169', '2019-05-14 14:04:00', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf(AdminController.java:80)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$hIfPWlkH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 14:04:00');
INSERT INTO `exception_log` VALUES (95, '30.64.15578138394770011', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '218.17.157.169', '2019-05-14 14:04:00', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf(AdminController.java:52)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$IlnEqSoF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 14:04:00');
INSERT INTO `exception_log` VALUES (96, '30.67.15578140401310015', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '218.17.157.169', '2019-05-14 14:07:20', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf(AdminController.java:80)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$hIfPWlkH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 14:07:20');
INSERT INTO `exception_log` VALUES (97, '30.66.15578140401310011', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/11.1.2 Safari/605.1.15', '218.17.157.169', '2019-05-14 14:07:20', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf(AdminController.java:52)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$IlnEqSoF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 14:07:20');
INSERT INTO `exception_log` VALUES (98, '30.72.15578175867110007', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '119.236.185.93', '2019-05-14 15:06:27', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy123.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf(AdminController.java:52)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$fxfXpgEf$accessor$jsSIQtXr(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$IlnEqSoF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$xKIWDF30$accessor$uwwmzpwJ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$cZwtNvBF.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-14 15:06:27');
INSERT INTO `exception_log` VALUES (99, '31.53.15578288843730003', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:14:44', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy93.selectByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy95.selectByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.getUser(UserServiceImpl.java:41)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$338719e3.getUser(<generated>)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:58)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAccessToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln(PassportController.java:52)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$CJXxcoww.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 18:14:44');
INSERT INTO `exception_log` VALUES (100, '31.48.15578288846720005', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '113.110.231.126', '2019-05-14 18:14:45', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy93.selectByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy95.selectByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.getUser(UserServiceImpl.java:41)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$338719e3.getUser(<generated>)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:58)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAccessToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln(PassportController.java:52)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$CJXxcoww.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 18:14:45');
INSERT INTO `exception_log` VALUES (101, '31.51.15578379450590005', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13111111111&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '123.113.106.247', '2019-05-14 20:45:45', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy93.selectByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy95.selectByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.getUser(UserServiceImpl.java:41)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$338719e3.getUser(<generated>)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:58)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAccessToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln(PassportController.java:52)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$CJXxcoww.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 20:45:45');
INSERT INTO `exception_log` VALUES (102, '31.49.15578423284470003', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18092176625&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '117.35.132.118', '2019-05-14 21:58:48', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy93.selectByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy95.selectByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.getUser(UserServiceImpl.java:41)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$338719e3.getUser(<generated>)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:58)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAccessToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln(PassportController.java:52)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$CJXxcoww.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 21:58:48');
INSERT INTO `exception_log` VALUES (103, '31.46.15578446293700005', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=17765823217', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-14 22:37:12', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy98.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy99.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:87)\n	at org.apache.dubbo.common.bytecode.Wrapper5.invokeMethod(Wrapper5.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.send(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy106.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend$original$SRU2CEln(PassportController.java:61)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$TKKhn5Sc.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-14 22:37:12');
INSERT INTO `exception_log` VALUES (104, 'db47608b-6cc9-4fd0-beeb-a95d75c382e3', 1, 2, 'admin-application', '/admin-api/admins/admin/add', 'username=doudou&nickname=我是豆豆&password=buzhidao', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 00:17:41', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,username,nickname,password,status,deleted,create_time,update_time  FROM admin     WHERE username = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,username,nickname,password,status,deleted,create_time,update_time  FROM admin     WHERE username = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy116.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy123.selectOne(Unknown Source)\n	at cn.iocoder.mall.admin.dao.AdminMapper.selectByUsername(AdminMapper.java:17)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy123.selectByUsername(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy124.selectByUsername(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.addAdmin(AdminServiceImpl.java:84)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$aeacb9f5.addAdmin(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.addAdmin(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy133.addAdmin(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.add(AdminController.java:104)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 139 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,username,nickname,password,status,deleted,create_time,update_time  FROM admin     WHERE username = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,username,nickname,password,status,deleted,create_time,update_time  FROM admin     WHERE username = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy116.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy123.selectOne(Unknown Source)\n	at cn.iocoder.mall.admin.dao.AdminMapper.selectByUsername(AdminMapper.java:17)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy123.selectByUsername(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy124.selectByUsername(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.addAdmin(AdminServiceImpl.java:84)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$aeacb9f5.addAdmin(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.addAdmin(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy133.addAdmin(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.add(AdminController.java:104)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 139 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,username,nickname,password,status,deleted,create_time,update_time  FROM admin     WHERE username = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,username,nickname,password,status,deleted,create_time,update_time  FROM admin     WHERE username = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy116.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy123.selectOne(Unknown Source)\n	at cn.iocoder.mall.admin.dao.AdminMapper.selectByUsername(AdminMapper.java:17)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy123.selectByUsername(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy124.selectByUsername(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.addAdmin(AdminServiceImpl.java:84)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$aeacb9f5.addAdmin(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.addAdmin(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy133.addAdmin(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.add(AdminController.java:104)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 139 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.addAdmin(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy133.addAdmin(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.add(AdminController.java:104)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 00:17:41');
INSERT INTO `exception_log` VALUES (105, '266c6fd0-9e0d-4f30-ae9e-91eb0cb8d7c3', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=sdsfsdf', 'POST', 'PostmanRuntime/6.2.5', '0:0:0:0:0:0:0:1', '2019-05-15 01:00:28', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2RefreshTokenMapper.selectById', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2RefreshTokenMapper.selectById', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2RefreshTokenMapper.selectById\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy91.selectById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy92.selectById(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.refreshToken(OAuth2ServiceImpl.java:91)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$b991749b.refreshToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.refreshToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy97.refreshToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.refreshToken(PassportController.java:84)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-15 01:00:29');
INSERT INTO `exception_log` VALUES (106, '31.47.15578908788750005', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15521508114', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-15 11:27:59', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy98.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy99.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:87)\n	at org.apache.dubbo.common.bytecode.Wrapper5.invokeMethod(Wrapper5.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.send(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy106.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend$original$SRU2CEln(PassportController.java:61)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$TKKhn5Sc.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-15 11:27:59');
INSERT INTO `exception_log` VALUES (107, 'e63ecd42-9adf-404f-b949-1daa5d6b9e2a', 1, 2, 'admin-application', '/admin-api/admins/admin/delete', 'id=4', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:02:02', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.AdminMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE admin    WHERE id=?   AND deleted=0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.AdminMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE admin    WHERE id=?   AND deleted=0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy126.updateById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy127.updateById(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.deleteAdmin(AdminServiceImpl.java:157)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$25df059a.deleteAdmin(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.deleteAdmin(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.deleteAdmin(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.delete(AdminController.java:124)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor456.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 139 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.AdminMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE admin    WHERE id=?   AND deleted=0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.AdminMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE admin    WHERE id=?   AND deleted=0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy126.updateById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy127.updateById(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.deleteAdmin(AdminServiceImpl.java:157)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$25df059a.deleteAdmin(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.deleteAdmin(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.deleteAdmin(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.delete(AdminController.java:124)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor456.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 139 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.AdminMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE admin    WHERE id=?   AND deleted=0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.AdminMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE admin    WHERE id=?   AND deleted=0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy126.updateById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy127.updateById(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.deleteAdmin(AdminServiceImpl.java:157)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$25df059a.deleteAdmin(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.deleteAdmin(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.deleteAdmin(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.delete(AdminController.java:124)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor456.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 139 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.deleteAdmin(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.deleteAdmin(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.delete(AdminController.java:124)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 12:02:02');
INSERT INTO `exception_log` VALUES (108, 'c7d2725f-977e-49b4-99f7-0cb15c93c463', 1, 2, 'admin-application', '/admin-api/admins/admin/delete', 'id=4', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 12:06:02', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.AdminMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE admin    WHERE id=?   AND deleted=0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.AdminMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE admin    WHERE id=?   AND deleted=0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy126.updateById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy127.updateById(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.deleteAdmin(AdminServiceImpl.java:157)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$2dc9dd11.deleteAdmin(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.deleteAdmin(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.deleteAdmin(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.delete(AdminController.java:124)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor470.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 139 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.AdminMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE admin    WHERE id=?   AND deleted=0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.AdminMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE admin    WHERE id=?   AND deleted=0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy126.updateById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy127.updateById(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.deleteAdmin(AdminServiceImpl.java:157)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$2dc9dd11.deleteAdmin(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.deleteAdmin(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.deleteAdmin(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.delete(AdminController.java:124)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor470.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 139 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.AdminMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE admin    WHERE id=?   AND deleted=0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.AdminMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE admin    WHERE id=?   AND deleted=0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy126.updateById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy127.updateById(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.deleteAdmin(AdminServiceImpl.java:157)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$2dc9dd11.deleteAdmin(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.deleteAdmin(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.deleteAdmin(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.delete(AdminController.java:124)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'WHERE id=4   AND deleted=0\' at line 1\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor470.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 139 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.deleteAdmin(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.deleteAdmin(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.delete(AdminController.java:124)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 12:06:02');
INSERT INTO `exception_log` VALUES (109, '21e548a9-39f5-41a7-8019-a03143360413', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:40:15', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/AdminRoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,admin_id,role_id,deleted,create_time,update_time  FROM admin_role_d_o   WHERE  deleted=0  AND adminId IN (?,?,?,?,?,?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/AdminRoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,admin_id,role_id,deleted,create_time,update_time  FROM admin_role_d_o   WHERE  deleted=0  AND adminId IN (?,?,?,?,?,?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy128.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.AdminRoleMapper.selectListByAdminIds(AdminRoleMapper.java:18)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy128.selectListByAdminIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy129.selectListByAdminIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.getAdminRolesMap(AdminServiceImpl.java:170)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$e0e5e5f.getAdminRolesMap(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.getAdminRolesMap(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.getAdminRolesMap(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:100)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor476.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 140 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/AdminRoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,admin_id,role_id,deleted,create_time,update_time  FROM admin_role_d_o   WHERE  deleted=0  AND adminId IN (?,?,?,?,?,?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/AdminRoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,admin_id,role_id,deleted,create_time,update_time  FROM admin_role_d_o   WHERE  deleted=0  AND adminId IN (?,?,?,?,?,?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy128.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.AdminRoleMapper.selectListByAdminIds(AdminRoleMapper.java:18)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy128.selectListByAdminIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy129.selectListByAdminIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.getAdminRolesMap(AdminServiceImpl.java:170)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$e0e5e5f.getAdminRolesMap(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.getAdminRolesMap(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.getAdminRolesMap(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:100)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor476.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 140 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/AdminRoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,admin_id,role_id,deleted,create_time,update_time  FROM admin_role_d_o   WHERE  deleted=0  AND adminId IN (?,?,?,?,?,?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/AdminRoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,admin_id,role_id,deleted,create_time,update_time  FROM admin_role_d_o   WHERE  deleted=0  AND adminId IN (?,?,?,?,?,?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy128.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.AdminRoleMapper.selectListByAdminIds(AdminRoleMapper.java:18)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy128.selectListByAdminIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy129.selectListByAdminIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.getAdminRolesMap(AdminServiceImpl.java:170)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$e0e5e5f.getAdminRolesMap(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.getAdminRolesMap(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.getAdminRolesMap(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:100)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.admin_role_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor476.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 140 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.getAdminRolesMap(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.getAdminRolesMap(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:100)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 14:40:15');
INSERT INTO `exception_log` VALUES (110, '348c95a7-5f07-4ab5-8f20-6d85c534f38a', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 14:41:34', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminRoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,admin_id,role_id,deleted,create_time,update_time  FROM admin_role   WHERE  deleted=0  AND adminId IN (?,?,?,?,?,?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminRoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,admin_id,role_id,deleted,create_time,update_time  FROM admin_role   WHERE  deleted=0  AND adminId IN (?,?,?,?,?,?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy128.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.AdminRoleMapper.selectListByAdminIds(AdminRoleMapper.java:18)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy128.selectListByAdminIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy129.selectListByAdminIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.getAdminRolesMap(AdminServiceImpl.java:170)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$3a92c7c.getAdminRolesMap(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getAdminRolesMap(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.getAdminRolesMap(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:100)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 140 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminRoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,admin_id,role_id,deleted,create_time,update_time  FROM admin_role   WHERE  deleted=0  AND adminId IN (?,?,?,?,?,?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminRoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,admin_id,role_id,deleted,create_time,update_time  FROM admin_role   WHERE  deleted=0  AND adminId IN (?,?,?,?,?,?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy128.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.AdminRoleMapper.selectListByAdminIds(AdminRoleMapper.java:18)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy128.selectListByAdminIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy129.selectListByAdminIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.getAdminRolesMap(AdminServiceImpl.java:170)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$3a92c7c.getAdminRolesMap(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getAdminRolesMap(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.getAdminRolesMap(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:100)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 140 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminRoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,admin_id,role_id,deleted,create_time,update_time  FROM admin_role   WHERE  deleted=0  AND adminId IN (?,?,?,?,?,?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminRoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,admin_id,role_id,deleted,create_time,update_time  FROM admin_role   WHERE  deleted=0  AND adminId IN (?,?,?,?,?,?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy128.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.AdminRoleMapper.selectListByAdminIds(AdminRoleMapper.java:18)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy128.selectListByAdminIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy129.selectListByAdminIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.getAdminRolesMap(AdminServiceImpl.java:170)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$3a92c7c.getAdminRolesMap(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getAdminRolesMap(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.getAdminRolesMap(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:100)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'adminId\' in \'where clause\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 140 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getAdminRolesMap(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.getAdminRolesMap(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:100)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 14:41:34');
INSERT INTO `exception_log` VALUES (111, '636c2661-defd-4ef1-b422-f81099a38a63', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 15:24:59', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/RoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,deleted,create_time,update_time  FROM role   WHERE  deleted=0  AND id IN (?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/RoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,deleted,create_time,update_time  FROM role   WHERE  deleted=0  AND id IN (?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy134.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.RoleMapper.selectListByIds(RoleMapper.java:26)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy134.selectListByIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy135.selectListByIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl.getRoleList(RoleServiceImpl.java:77)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl$$FastClassBySpringCGLIB$$830ec1bf.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl$$EnhancerBySpringCGLIB$$84258fe.getRoleList(<generated>)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.getAdminRolesMap(AdminServiceImpl.java:175)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$8dc13a33.getAdminRolesMap(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getAdminRolesMap(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.getAdminRolesMap(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:100)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor457.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 145 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/RoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,deleted,create_time,update_time  FROM role   WHERE  deleted=0  AND id IN (?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/RoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,deleted,create_time,update_time  FROM role   WHERE  deleted=0  AND id IN (?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy134.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.RoleMapper.selectListByIds(RoleMapper.java:26)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy134.selectListByIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy135.selectListByIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl.getRoleList(RoleServiceImpl.java:77)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl$$FastClassBySpringCGLIB$$830ec1bf.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl$$EnhancerBySpringCGLIB$$84258fe.getRoleList(<generated>)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.getAdminRolesMap(AdminServiceImpl.java:175)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$8dc13a33.getAdminRolesMap(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getAdminRolesMap(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.getAdminRolesMap(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:100)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor457.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 145 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/RoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,deleted,create_time,update_time  FROM role   WHERE  deleted=0  AND id IN (?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/RoleMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,deleted,create_time,update_time  FROM role   WHERE  deleted=0  AND id IN (?,?,?,?,?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy119.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy134.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.RoleMapper.selectListByIds(RoleMapper.java:26)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy134.selectListByIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy135.selectListByIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl.getRoleList(RoleServiceImpl.java:77)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl$$FastClassBySpringCGLIB$$830ec1bf.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl$$EnhancerBySpringCGLIB$$84258fe.getRoleList(<generated>)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.getAdminRolesMap(AdminServiceImpl.java:175)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$8dc13a33.getAdminRolesMap(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getAdminRolesMap(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.getAdminRolesMap(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:100)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'update_time\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor457.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy187.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy185.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 145 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getAdminRolesMap(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy136.getAdminRolesMap(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:100)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 15:24:59');
INSERT INTO `exception_log` VALUES (112, '35.74.15579139659070047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:52:46', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-15 17:52:46');
INSERT INTO `exception_log` VALUES (113, '35.75.15579139659090051', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:52:46', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-15 17:52:46');
INSERT INTO `exception_log` VALUES (114, '35.76.15579139798440049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:53:00', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-15 17:53:00');
INSERT INTO `exception_log` VALUES (115, '35.80.15579139798430047', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:53:00', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-15 17:53:00');
INSERT INTO `exception_log` VALUES (116, '35.77.15579142062220049', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:56:46', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-15 17:56:46');
INSERT INTO `exception_log` VALUES (117, '35.78.15579142062160049', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-15 17:56:46', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-15 17:56:46');
INSERT INTO `exception_log` VALUES (118, 'e1bc78ff-ddc5-4b96-8b52-2ea00e4b1146', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:19', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:65)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:62)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 65, '2019-05-15 22:27:19');
INSERT INTO `exception_log` VALUES (119, '19bdacb7-775c-4197-9ea6-7ba35e396cb0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:26', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:65)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:62)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 65, '2019-05-15 22:27:26');
INSERT INTO `exception_log` VALUES (120, 'a80a79cf-b97b-438f-88d9-f0a18fc7ced8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:27:30', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:65)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:62)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 65, '2019-05-15 22:27:30');
INSERT INTO `exception_log` VALUES (121, '44e3a1c9-f607-4869-85a6-294084ed80e2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:28:11', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:65)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:62)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 65, '2019-05-15 22:28:11');
INSERT INTO `exception_log` VALUES (122, '0f0609ab-8f39-4ba4-a25f-ef17b4c7e142', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:33:17', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:68)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:62)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 68, '2019-05-15 22:33:17');
INSERT INTO `exception_log` VALUES (123, '323fca04-4973-4c44-882f-65363f4d7a5e', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:33:17', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-15 22:33:17');
INSERT INTO `exception_log` VALUES (124, '6cab2273-d745-4864-b39c-7af3ef32c561', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:33:21', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:68)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:62)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 68, '2019-05-15 22:33:21');
INSERT INTO `exception_log` VALUES (125, '6771d108-2df1-4def-af45-35a0d2bd6304', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:33:23', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:68)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:62)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 68, '2019-05-15 22:33:23');
INSERT INTO `exception_log` VALUES (126, '45600d1b-c002-4c2b-8dde-4fca425cfe7b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:35:04', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:68)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:62)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 68, '2019-05-15 22:35:04');
INSERT INTO `exception_log` VALUES (127, '4c1c4dc6-0d5f-4d52-bbf7-d3b3cf54dd88', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 22:35:04', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-15 22:35:04');
INSERT INTO `exception_log` VALUES (128, '08ba9b86-a6f7-4680-91f9-bed9181f2ee1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:20', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:01:21');
INSERT INTO `exception_log` VALUES (129, '94a2a8d6-cd1b-4d32-a0ac-b84d6872c594', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:20', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:01:21');
INSERT INTO `exception_log` VALUES (130, '6cb0372c-cc15-4b3b-b55a-74798b069ec5', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:22', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:01:22');
INSERT INTO `exception_log` VALUES (131, 'e4e1663c-dce0-4819-9b6d-0b128843c665', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:25', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:01:25');
INSERT INTO `exception_log` VALUES (132, 'd99a063e-f455-40f4-802f-561835af93f5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:25', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:01:25');
INSERT INTO `exception_log` VALUES (133, '32a4297a-c476-4c75-a611-86d2e23d2019', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:25', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:01:25');
INSERT INTO `exception_log` VALUES (134, '9da3631b-0364-4117-bfa5-efa123c49dd5', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:27', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:01:27');
INSERT INTO `exception_log` VALUES (135, '1ebf163d-bb4b-428b-b48b-5e4becf4eeab', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:27', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:01:27');
INSERT INTO `exception_log` VALUES (136, '58d12e31-09ff-4823-98b4-1d7649f91bf7', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:28', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:01:28');
INSERT INTO `exception_log` VALUES (137, 'bdd2d9ca-bdd9-4512-9f74-2c9315643a3f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:38', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:01:38');
INSERT INTO `exception_log` VALUES (138, '1f5402b4-7635-46f0-ade9-78abdda5bdbc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:38', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:01:38');
INSERT INTO `exception_log` VALUES (139, '49be36f9-891e-431f-9cd2-c5dafad50566', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:01:38', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:01:38');
INSERT INTO `exception_log` VALUES (140, '1f94b155-dd0e-462c-a2d9-a52607918e50', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:03:11', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:03:11');
INSERT INTO `exception_log` VALUES (141, '5804c7e2-abc8-498a-af16-01483e9aca04', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:03:11', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor537.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor547.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:03:11');
INSERT INTO `exception_log` VALUES (142, '2fea8795-6e3b-4f18-80d5-8053d3d4e221', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:03:11', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor542.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$898fa25d.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor446.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor498.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByType(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor541.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:03:11');
INSERT INTO `exception_log` VALUES (143, '2c1cfb88-edb0-4f38-9d96-83e10d0b41bd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:05:50', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:05:50');
INSERT INTO `exception_log` VALUES (144, '2c8f39ba-de2d-4cb5-b30b-e0732f23d3eb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:05:50', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:05:50');
INSERT INTO `exception_log` VALUES (145, 'ee7a42a1-3c92-4e7c-b9e7-46ffc30cd34e', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:05:50', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByType(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByType(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByType(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByType(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:05:50');
INSERT INTO `exception_log` VALUES (146, '64c73118-8b29-45b0-9173-bdb5fbf1c322', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:05:51', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor428.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor428.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor428.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:05:51');
INSERT INTO `exception_log` VALUES (147, '97a5abf3-92ff-491b-849a-f16aa6fbe62e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:05:51', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor428.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor428.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor428.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:05:51');
INSERT INTO `exception_log` VALUES (148, '7ac0a3d7-64d6-4c4c-98fc-6f6f60f9d9cb', 1, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:05:51', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByType(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor428.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByType(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor428.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByType(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:48)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$75531036.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByType(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor428.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor435.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByType(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java:38)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:05:51');
INSERT INTO `exception_log` VALUES (149, '86ea1739-1b6f-41ac-95d8-bfaab1917613', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:06:55', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:06:55');
INSERT INTO `exception_log` VALUES (150, '5d440e65-183e-44a1-8cdb-cf0da3ae9a2d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:06:55', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:06:55');
INSERT INTO `exception_log` VALUES (151, 'e340adc1-ea09-46f2-a5cd-3330816da824', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:06:57', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:06:57');
INSERT INTO `exception_log` VALUES (152, 'b9a90c83-7cf1-4b29-a1f2-3c3a7a4f932e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:06:57', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:06:57');
INSERT INTO `exception_log` VALUES (153, '963fd5a3-5f36-44d6-a55b-bb3902ba912f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:07:39', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:07:39');
INSERT INTO `exception_log` VALUES (154, '52d8d63e-67f1-4de1-8c17-ba04c183ab5b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:07:39', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:07:39');
INSERT INTO `exception_log` VALUES (155, '8b648c29-1e2d-4bf0-ac13-58b5b53532e5', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:25', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:08:25');
INSERT INTO `exception_log` VALUES (156, '78a35e98-cd1e-4f61-9294-d8e48e84670e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:25', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:08:25');
INSERT INTO `exception_log` VALUES (157, '15eec96a-9a46-4225-a0f6-4c7979e01521', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:27', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:08:27');
INSERT INTO `exception_log` VALUES (158, '5a03e2c1-9b54-4480-8294-ed394d53aba2', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:27', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:08:27');
INSERT INTO `exception_log` VALUES (159, '7c10d023-9281-46c4-991a-3f1582e77a43', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:43', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:08:43');
INSERT INTO `exception_log` VALUES (160, '4bc02718-3b26-4862-b907-09dd299cfb02', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:08:43', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:08:43');
INSERT INTO `exception_log` VALUES (161, '03664931-b669-4195-a30e-35057378f8e8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:09:14', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:09:14');
INSERT INTO `exception_log` VALUES (162, '2d7ee1eb-4385-4af5-9b02-d9f982ef09bd', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:09:14', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:09:14');
INSERT INTO `exception_log` VALUES (163, 'c0e0dc7e-d437-4027-bc3f-0a526b87b16e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:10:52', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:10:52');
INSERT INTO `exception_log` VALUES (164, '55f4c759-1df8-4c4a-bc7d-c2c6c00eb97e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:10:52', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:10:52');
INSERT INTO `exception_log` VALUES (165, '7e91c4e0-b829-48de-9ba8-41ce7c4d625a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:06', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:06');
INSERT INTO `exception_log` VALUES (166, '8553b147-b312-41f4-abfd-615e25235d57', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:06', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:06');
INSERT INTO `exception_log` VALUES (167, '5f1ceab6-be9c-4fdf-a393-c49c5382ee8b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:07', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:07');
INSERT INTO `exception_log` VALUES (168, '28b3b58d-bbb0-43e8-963b-2e6fefffc49f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:07', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:07');
INSERT INTO `exception_log` VALUES (169, '03046432-1041-437e-bfa2-a33a040f97cb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:12', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:12');
INSERT INTO `exception_log` VALUES (170, '14309918-1203-437a-a669-f657cbad62bc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:12', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:12');
INSERT INTO `exception_log` VALUES (171, 'e5981b2b-9c7a-45cd-a9ac-60efdfce1f35', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:15', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:15');
INSERT INTO `exception_log` VALUES (172, '31a47558-7e41-4ec9-8013-82130eb3f68f', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:15', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:15');
INSERT INTO `exception_log` VALUES (173, '73ccead7-a388-463f-81c0-d8123488f5c3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:21', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:21');
INSERT INTO `exception_log` VALUES (174, 'bb7d0bf9-aaaf-49b4-b263-2bf45373bd44', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:21', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:21');
INSERT INTO `exception_log` VALUES (175, 'c70d4f09-4748-449c-af67-04f30452c3a3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:24', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:24');
INSERT INTO `exception_log` VALUES (176, '1ad77b81-89de-40f4-aafe-dec1db299dd7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:24', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:24');
INSERT INTO `exception_log` VALUES (177, '1ec6ced3-e9ea-4ce0-897b-1f94aaf0d4bb', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:25', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:25');
INSERT INTO `exception_log` VALUES (178, 'e73729a8-a816-4764-998b-5093fc7c16c0', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:25', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:25');
INSERT INTO `exception_log` VALUES (179, 'c6cf539d-989b-43e1-8d06-cfe8e59595dc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:41', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:41');
INSERT INTO `exception_log` VALUES (180, 'f683971d-6378-45bb-bdc3-4c06cafd4da9', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:41', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:41');
INSERT INTO `exception_log` VALUES (181, 'affbbffb-3f09-4085-bff9-a06c5a0db4a8', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:47', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:47');
INSERT INTO `exception_log` VALUES (182, 'cd99fc2b-7e56-4737-8598-d8ec7a81fe78', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:47', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:47');
INSERT INTO `exception_log` VALUES (183, '2d6038ed-3412-4a63-a6e8-568acdde8afc', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:52', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:52');
INSERT INTO `exception_log` VALUES (184, '03686264-70f4-424d-8e7e-ed623c9e57ec', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:52', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:52');
INSERT INTO `exception_log` VALUES (185, 'fc97dafe-f5c7-43ab-b0f4-d23521a24059', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:53', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:53');
INSERT INTO `exception_log` VALUES (186, '89d4c45c-74d5-4d64-9e48-566bff507f0e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:11:53', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:11:53');
INSERT INTO `exception_log` VALUES (187, 'fb1770c3-4f5d-4743-ba37-5b371cc95d41', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:12:28', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:12:28');
INSERT INTO `exception_log` VALUES (188, '4891b36e-a251-420f-b240-4871bc78393e', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:12:28', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:12:28');
INSERT INTO `exception_log` VALUES (189, '50180095-95e2-428d-987d-8bcb281646ac', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:14:00', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:14:00');
INSERT INTO `exception_log` VALUES (190, '0e45f69a-0ecb-41a8-b0b7-cf7488ec89fe', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:14:00', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:14:00');
INSERT INTO `exception_log` VALUES (191, '66e030e6-ef23-49e8-a145-f20e168d5911', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:14:04', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:14:04');
INSERT INTO `exception_log` VALUES (192, '23911221-e998-4d35-9d5f-fcdca43677ba', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:14:04', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:14:04');
INSERT INTO `exception_log` VALUES (193, '3215b6b0-cde5-44e9-b724-c6b18de5a6bf', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:38', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:18:38');
INSERT INTO `exception_log` VALUES (194, 'ddd30385-22df-4bbc-a660-6eff0e87d786', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:38', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:18:38');
INSERT INTO `exception_log` VALUES (195, 'fd323808-089b-4d48-ade8-99fb995456a3', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=33&type=1&sort=2&displayName=店铺资产&createTime=2019-05-02T16:02:57.000+0000&pid=0&children[0][id]=44&children[0][name]=&children[0][type]=1&children[0][sort]=1&children[0][displayName]=支付单&children[0][createTime]=2019-05-08T06:17:15.000+0000&children[0][pid]=33&children[0][handler]=/pay/transaction-list&children[0][children]=&children[1][id]=45&children[1][name]=&children[1][type]=1&children[1][sort]=2&children[1][displayName]=退款单&children[1][createTime]=2019-05-08T08:58:05.000+0000&children[1][pid]=33&children[1][handler]=/pay/refund-list&children[1][children]=&icon=money-collect', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:48', 'java.lang.RuntimeException', 'RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.update(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.update(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.updateResource(ResourceServiceImpl.java:83)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.updateResource(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.updateResource(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.updateResource(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.update(ResourceController.java:70)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextMap.get(DynamicContext.java:94)\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextAccessor.getProperty(DynamicContext.java:107)\n	at org.apache.ibatis.ognl.OgnlRuntime.getProperty(OgnlRuntime.java:2719)\n	at org.apache.ibatis.ognl.ASTProperty.getValueBody(ASTProperty.java:114)\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\n	at org.apache.ibatis.ognl.ASTNotEq.getValueBody(ASTNotEq.java:50)\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:493)\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:457)\n	at org.apache.ibatis.scripting.xmltags.OgnlCache.getValue(OgnlCache.java:46)\n	at org.apache.ibatis.scripting.xmltags.ExpressionEvaluator.evaluateBoolean(ExpressionEvaluator.java:32)\n	at org.apache.ibatis.scripting.xmltags.IfSqlNode.apply(IfSqlNode.java:34)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\n	at org.apache.ibatis.scripting.xmltags.TrimSqlNode.apply(TrimSqlNode.java:55)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\n	at org.apache.ibatis.scripting.xmltags.DynamicSqlSource.getBoundSql(DynamicSqlSource.java:39)\n	at org.apache.ibatis.mapping.MappedStatement.getBoundSql(MappedStatement.java:297)\n	at org.apache.ibatis.executor.statement.BaseStatementHandler.<init>(BaseStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.<init>(PreparedStatementHandler.java:41)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.<init>(RoutingStatementHandler.java:46)\n	at org.apache.ibatis.session.Configuration.newStatementHandler(Configuration.java:576)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:52)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 137 more\n', 'RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.update(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.update(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.updateResource(ResourceServiceImpl.java:83)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.updateResource(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.updateResource(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.updateResource(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.update(ResourceController.java:70)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextMap.get(DynamicContext.java:94)\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextAccessor.getProperty(DynamicContext.java:107)\n	at org.apache.ibatis.ognl.OgnlRuntime.getProperty(OgnlRuntime.java:2719)\n	at org.apache.ibatis.ognl.ASTProperty.getValueBody(ASTProperty.java:114)\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\n	at org.apache.ibatis.ognl.ASTNotEq.getValueBody(ASTNotEq.java:50)\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:493)\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:457)\n	at org.apache.ibatis.scripting.xmltags.OgnlCache.getValue(OgnlCache.java:46)\n	at org.apache.ibatis.scripting.xmltags.ExpressionEvaluator.evaluateBoolean(ExpressionEvaluator.java:32)\n	at org.apache.ibatis.scripting.xmltags.IfSqlNode.apply(IfSqlNode.java:34)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\n	at org.apache.ibatis.scripting.xmltags.TrimSqlNode.apply(TrimSqlNode.java:55)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\n	at org.apache.ibatis.scripting.xmltags.DynamicSqlSource.getBoundSql(DynamicSqlSource.java:39)\n	at org.apache.ibatis.mapping.MappedStatement.getBoundSql(MappedStatement.java:297)\n	at org.apache.ibatis.executor.statement.BaseStatementHandler.<init>(BaseStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.<init>(PreparedStatementHandler.java:41)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.<init>(RoutingStatementHandler.java:46)\n	at org.apache.ibatis.session.Configuration.newStatementHandler(Configuration.java:576)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:52)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 137 more\n', 'java.lang.RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.update(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.update(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.updateResource(ResourceServiceImpl.java:83)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.updateResource(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.updateResource(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.updateResource(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.update(ResourceController.java:70)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextMap.get(DynamicContext.java:94)\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextAccessor.getProperty(DynamicContext.java:107)\n	at org.apache.ibatis.ognl.OgnlRuntime.getProperty(OgnlRuntime.java:2719)\n	at org.apache.ibatis.ognl.ASTProperty.getValueBody(ASTProperty.java:114)\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\n	at org.apache.ibatis.ognl.ASTNotEq.getValueBody(ASTNotEq.java:50)\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:493)\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:457)\n	at org.apache.ibatis.scripting.xmltags.OgnlCache.getValue(OgnlCache.java:46)\n	at org.apache.ibatis.scripting.xmltags.ExpressionEvaluator.evaluateBoolean(ExpressionEvaluator.java:32)\n	at org.apache.ibatis.scripting.xmltags.IfSqlNode.apply(IfSqlNode.java:34)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\n	at org.apache.ibatis.scripting.xmltags.TrimSqlNode.apply(TrimSqlNode.java:55)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\n	at org.apache.ibatis.scripting.xmltags.DynamicSqlSource.getBoundSql(DynamicSqlSource.java:39)\n	at org.apache.ibatis.mapping.MappedStatement.getBoundSql(MappedStatement.java:297)\n	at org.apache.ibatis.executor.statement.BaseStatementHandler.<init>(BaseStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.<init>(PreparedStatementHandler.java:41)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.<init>(RoutingStatementHandler.java:46)\n	at org.apache.ibatis.session.Configuration.newStatementHandler(Configuration.java:576)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:52)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 137 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.updateResource(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.updateResource(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.update(ResourceController.java:70)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:18:48');
INSERT INTO `exception_log` VALUES (196, '4cb69b06-306b-4334-951f-d3f49977d8fa', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:51', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor565.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:18:51');
INSERT INTO `exception_log` VALUES (197, 'e5ff15c7-929a-489e-b9b1-ce17fa641b2b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:18:51', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor559.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor103.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor465.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor492.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor558.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor564.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:18:51');
INSERT INTO `exception_log` VALUES (198, '645cc806-29f4-4ce2-8bbe-30be5f6284a9', 1, 2, 'admin-application', '/admin-api/admins/resource/update', 'id=33&type=1&sort=2&displayName=店铺资产&createTime=2019-05-02T16:02:57.000+0000&pid=0&children[0][id]=44&children[0][name]=&children[0][type]=1&children[0][sort]=1&children[0][displayName]=支付单&children[0][createTime]=2019-05-08T06:17:15.000+0000&children[0][pid]=33&children[0][handler]=/pay/transaction-list&children[0][children]=&children[1][id]=45&children[1][name]=&children[1][type]=1&children[1][sort]=2&children[1][displayName]=退款单&children[1][createTime]=2019-05-08T08:58:05.000+0000&children[1][pid]=33&children[1][handler]=/pay/refund-list&children[1][children]=&icon=money-collect', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:20:35', 'java.lang.RuntimeException', 'RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.update(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.update(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.updateResource(ResourceServiceImpl.java:83)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.updateResource(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.updateResource(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.updateResource(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.update(ResourceController.java:70)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextMap.get(DynamicContext.java:94)\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextAccessor.getProperty(DynamicContext.java:107)\n	at org.apache.ibatis.ognl.OgnlRuntime.getProperty(OgnlRuntime.java:2719)\n	at org.apache.ibatis.ognl.ASTProperty.getValueBody(ASTProperty.java:114)\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\n	at org.apache.ibatis.ognl.ASTNotEq.getValueBody(ASTNotEq.java:50)\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:493)\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:457)\n	at org.apache.ibatis.scripting.xmltags.OgnlCache.getValue(OgnlCache.java:46)\n	at org.apache.ibatis.scripting.xmltags.ExpressionEvaluator.evaluateBoolean(ExpressionEvaluator.java:32)\n	at org.apache.ibatis.scripting.xmltags.IfSqlNode.apply(IfSqlNode.java:34)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\n	at org.apache.ibatis.scripting.xmltags.TrimSqlNode.apply(TrimSqlNode.java:55)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\n	at org.apache.ibatis.scripting.xmltags.DynamicSqlSource.getBoundSql(DynamicSqlSource.java:39)\n	at org.apache.ibatis.mapping.MappedStatement.getBoundSql(MappedStatement.java:297)\n	at org.apache.ibatis.executor.statement.BaseStatementHandler.<init>(BaseStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.<init>(PreparedStatementHandler.java:41)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.<init>(RoutingStatementHandler.java:46)\n	at org.apache.ibatis.session.Configuration.newStatementHandler(Configuration.java:576)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:52)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 137 more\n', 'RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.update(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.update(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.updateResource(ResourceServiceImpl.java:83)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.updateResource(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.updateResource(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.updateResource(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.update(ResourceController.java:70)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextMap.get(DynamicContext.java:94)\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextAccessor.getProperty(DynamicContext.java:107)\n	at org.apache.ibatis.ognl.OgnlRuntime.getProperty(OgnlRuntime.java:2719)\n	at org.apache.ibatis.ognl.ASTProperty.getValueBody(ASTProperty.java:114)\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\n	at org.apache.ibatis.ognl.ASTNotEq.getValueBody(ASTNotEq.java:50)\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:493)\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:457)\n	at org.apache.ibatis.scripting.xmltags.OgnlCache.getValue(OgnlCache.java:46)\n	at org.apache.ibatis.scripting.xmltags.ExpressionEvaluator.evaluateBoolean(ExpressionEvaluator.java:32)\n	at org.apache.ibatis.scripting.xmltags.IfSqlNode.apply(IfSqlNode.java:34)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\n	at org.apache.ibatis.scripting.xmltags.TrimSqlNode.apply(TrimSqlNode.java:55)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\n	at org.apache.ibatis.scripting.xmltags.DynamicSqlSource.getBoundSql(DynamicSqlSource.java:39)\n	at org.apache.ibatis.mapping.MappedStatement.getBoundSql(MappedStatement.java:297)\n	at org.apache.ibatis.executor.statement.BaseStatementHandler.<init>(BaseStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.<init>(PreparedStatementHandler.java:41)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.<init>(RoutingStatementHandler.java:46)\n	at org.apache.ibatis.session.Configuration.newStatementHandler(Configuration.java:576)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:52)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 137 more\n', 'java.lang.RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.update(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.update(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.updateResource(ResourceServiceImpl.java:83)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$dbab1081.updateResource(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.updateResource(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.updateResource(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.update(ResourceController.java:70)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'name\' in \'class cn.iocoder.mall.admin.dataobject.ResourceDO\'\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextMap.get(DynamicContext.java:94)\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextAccessor.getProperty(DynamicContext.java:107)\n	at org.apache.ibatis.ognl.OgnlRuntime.getProperty(OgnlRuntime.java:2719)\n	at org.apache.ibatis.ognl.ASTProperty.getValueBody(ASTProperty.java:114)\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\n	at org.apache.ibatis.ognl.ASTNotEq.getValueBody(ASTNotEq.java:50)\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:493)\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:457)\n	at org.apache.ibatis.scripting.xmltags.OgnlCache.getValue(OgnlCache.java:46)\n	at org.apache.ibatis.scripting.xmltags.ExpressionEvaluator.evaluateBoolean(ExpressionEvaluator.java:32)\n	at org.apache.ibatis.scripting.xmltags.IfSqlNode.apply(IfSqlNode.java:34)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\n	at org.apache.ibatis.scripting.xmltags.TrimSqlNode.apply(TrimSqlNode.java:55)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\n	at org.apache.ibatis.scripting.xmltags.DynamicSqlSource.getBoundSql(DynamicSqlSource.java:39)\n	at org.apache.ibatis.mapping.MappedStatement.getBoundSql(MappedStatement.java:297)\n	at org.apache.ibatis.executor.statement.BaseStatementHandler.<init>(BaseStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.<init>(PreparedStatementHandler.java:41)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.<init>(RoutingStatementHandler.java:46)\n	at org.apache.ibatis.session.Configuration.newStatementHandler(Configuration.java:576)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:52)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 137 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.updateResource(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.updateResource(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.update(ResourceController.java:70)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:20:35');
INSERT INTO `exception_log` VALUES (199, '59241fce-9c4b-48f1-81cb-6c78117477cc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:22:07', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:22:07');
INSERT INTO `exception_log` VALUES (200, '03cd1f7f-db80-4ab3-969a-ccb5ccdddf19', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:22:07', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:22:07');
INSERT INTO `exception_log` VALUES (201, '300a2bf9-be98-4996-9eab-5cba3c4cacab', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:23:30', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor411.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor417.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor411.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor417.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor411.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor417.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:23:30');
INSERT INTO `exception_log` VALUES (202, '55defc3e-8619-4791-99a0-142fd023eaf6', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:23:30', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor411.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor417.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor411.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor417.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor411.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor417.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:23:30');
INSERT INTO `exception_log` VALUES (203, 'd08be332-4f50-4d2c-851b-ed591f6fa339', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:23:40', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor411.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor417.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor443.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor411.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor417.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor443.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor411.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor417.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor443.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:23:40');
INSERT INTO `exception_log` VALUES (204, '59018929-4fca-43ee-a0fb-d51cb8d24fba', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:23:40', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor411.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor417.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor443.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor411.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor417.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor443.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$6b6dd972.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor411.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor417.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor443.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:23:40');
INSERT INTO `exception_log` VALUES (205, '574e5260-35fa-4db5-9721-62ab608c87ae', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:27:08', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:27:08');
INSERT INTO `exception_log` VALUES (206, '54a8a982-0209-4f41-a98d-24fd337729a6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:27:08', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:27:08');
INSERT INTO `exception_log` VALUES (207, 'bbfa839e-f359-400e-9d60-55b0b43ebc1e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:13', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:28:13');
INSERT INTO `exception_log` VALUES (208, 'ea709077-cd58-4a24-8c9e-1f74d285cf16', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:13', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:28:13');
INSERT INTO `exception_log` VALUES (209, 'c9566c14-7a8b-4843-9164-ad4550f3835e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:20', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:28:20');
INSERT INTO `exception_log` VALUES (210, '73c87089-6495-45a0-9dc1-5fc07c9ce7f4', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:20', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:28:20');
INSERT INTO `exception_log` VALUES (211, '69cb3623-4dfe-437f-a246-1013608371b9', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:22', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:28:22');
INSERT INTO `exception_log` VALUES (212, '9ca653ad-c04a-4e56-b490-5ee2d5742a10', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:22', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:28:22');
INSERT INTO `exception_log` VALUES (213, '141eaa5c-893d-4149-963d-16059b09bd21', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:49', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:28:49');
INSERT INTO `exception_log` VALUES (214, '7b1b75cd-f361-434d-aa72-3e9297da3327', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:49', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:28:49');
INSERT INTO `exception_log` VALUES (215, 'e7b82032-5ab6-44ec-8935-e5e8484f6e72', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:50', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:28:50');
INSERT INTO `exception_log` VALUES (216, '9d9fa8dd-4c48-4d12-a145-f562be655714', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:28:50', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:28:50');
INSERT INTO `exception_log` VALUES (217, 'e9dfa175-4ba4-4e19-8eef-055259b58868', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:29:08', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:29:08');
INSERT INTO `exception_log` VALUES (218, 'dd52cf6d-2fd0-4272-af6a-96c8e632de7b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:29:08', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:29:08');
INSERT INTO `exception_log` VALUES (219, '9f1def9d-be1e-4343-93dd-8c3c450f4153', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:29:09', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:29:09');
INSERT INTO `exception_log` VALUES (220, '357bd8a8-78b9-4a1f-a845-2b5418e4b601', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:29:09', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:29:09');
INSERT INTO `exception_log` VALUES (221, '34751de4-c43b-4cc6-b87f-d79f780c7161', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:10', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:35:10');
INSERT INTO `exception_log` VALUES (222, 'be73f967-18e9-4667-8357-51b80b4ec62c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:10', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:35:10');
INSERT INTO `exception_log` VALUES (223, 'f9ebf2b8-0cc7-4f93-839e-eefb2c81b718', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:24', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:35:24');
INSERT INTO `exception_log` VALUES (224, '240df734-df1f-4a01-a930-b8d1de7e0205', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:24', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:35:24');
INSERT INTO `exception_log` VALUES (225, '10378ea4-ae38-4b99-a2b0-7cd784bb3cef', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:26', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:35:26');
INSERT INTO `exception_log` VALUES (226, '5ead9e8e-7643-436e-a965-20f28e20b50c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:26', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:35:26');
INSERT INTO `exception_log` VALUES (227, '0b0896c0-2c78-4534-8bad-59198386c80d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:39', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:35:39');
INSERT INTO `exception_log` VALUES (228, '5a8b185f-a7cf-42e7-971b-947f377ee45d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:39', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:35:39');
INSERT INTO `exception_log` VALUES (229, '75095a27-b580-430e-b73c-284c6fb41483', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:59', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:35:59');
INSERT INTO `exception_log` VALUES (230, '0b5f7238-f4a6-4050-b00d-22b8bdc63c2b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:35:59', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:35:59');
INSERT INTO `exception_log` VALUES (231, 'ee45e453-eab8-402a-a2e1-edcf794d2746', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:00', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:36:00');
INSERT INTO `exception_log` VALUES (232, '0db756d1-f150-4dc0-98da-218dff38a4e4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:00', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:36:00');
INSERT INTO `exception_log` VALUES (233, '58e26df5-868e-4822-b098-a3a8fc3fae08', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:11', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:36:11');
INSERT INTO `exception_log` VALUES (234, 'ab4493b3-8db5-4afe-8325-ab5e6520c697', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:11', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:36:11');
INSERT INTO `exception_log` VALUES (235, '7c9e2d54-38a1-4669-9a49-05c7bbaac625', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:13', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:36:13');
INSERT INTO `exception_log` VALUES (236, '0aeb3372-2c47-43d7-bb05-6754100e223e', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:13', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 136 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:36:13');
INSERT INTO `exception_log` VALUES (237, 'bf5a8220-026b-40e2-b4ae-bced9fe55185', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:21', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:36:21');
INSERT INTO `exception_log` VALUES (238, '1fe35fa0-078d-422f-a888-83ae030d95c7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:36:21', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:36:21');
INSERT INTO `exception_log` VALUES (239, 'da8d0f36-6a52-4b47-baf9-b8e2fb2de55f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:37:54', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:37:54');
INSERT INTO `exception_log` VALUES (240, '67567b51-be1b-4914-9920-d6b153c7b3df', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:37:54', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:37:54');
INSERT INTO `exception_log` VALUES (241, 'ffcd0bf9-98b8-494f-8f63-f61437fde13b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:39:03', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:39:03');
INSERT INTO `exception_log` VALUES (242, '243f4957-13da-4ebf-9b4a-9be5a0ad947c', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:39:03', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:39:03');
INSERT INTO `exception_log` VALUES (243, '8197198e-cc2d-403f-bf0e-79d50faddc3a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:39:58', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:39:58');
INSERT INTO `exception_log` VALUES (244, '8083dda2-0fc7-46f8-8ea8-14adac1bbf23', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:39:58', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:39:58');
INSERT INTO `exception_log` VALUES (245, '882f3e3a-738e-4476-83ba-fae1af46015c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:13', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:40:13');
INSERT INTO `exception_log` VALUES (246, 'b046b955-1e36-4861-8ff6-05883dbf5fb3', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:13', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:40:13');
INSERT INTO `exception_log` VALUES (247, '4949f81a-caac-4994-b35f-d0635c3c1b62', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:20', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:40:20');
INSERT INTO `exception_log` VALUES (248, '60055fb0-8e44-42e1-a8a8-bdf4efe5dd56', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:20', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:40:20');
INSERT INTO `exception_log` VALUES (249, 'dbf0ae73-4e6b-4a40-8eaa-2cc2be74d820', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:23', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:40:23');
INSERT INTO `exception_log` VALUES (250, 'bb6979a6-8473-4872-b511-56bd3b5053e4', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:23', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:40:23');
INSERT INTO `exception_log` VALUES (251, '28889122-9696-485c-a85d-043350ebeaaf', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:38', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:40:38');
INSERT INTO `exception_log` VALUES (252, '60d48b72-883b-4764-bcc5-ac2b33512546', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:38', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:40:38');
INSERT INTO `exception_log` VALUES (253, 'fbe42470-81e7-4e93-888b-71831577a6e3', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:58', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:40:58');
INSERT INTO `exception_log` VALUES (254, 'f5f8fa67-3ce3-4143-a6d7-c4b5ac2d98b6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:40:58', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:40:58');
INSERT INTO `exception_log` VALUES (255, 'c978248f-dc6e-43e5-b9dd-803b3d3288ed', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:03', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:41:03');
INSERT INTO `exception_log` VALUES (256, 'b1a4e3df-c714-4cbb-a58f-6ab2c4da8ddc', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:03', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:41:03');
INSERT INTO `exception_log` VALUES (257, '8e61df6e-ba84-4a13-9eee-b966f36cc164', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:06', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:41:06');
INSERT INTO `exception_log` VALUES (258, 'be2f23ca-46f2-435a-bca3-8ae92e9f2709', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:06', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:41:06');
INSERT INTO `exception_log` VALUES (259, '83678f5f-bcd8-4cfb-9379-e6a10d12de85', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:10', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:41:10');
INSERT INTO `exception_log` VALUES (260, '171bc4fc-8754-44c1-9189-cb007db1973c', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:10', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:41:10');
INSERT INTO `exception_log` VALUES (261, 'c5db9938-e3b0-4033-80ba-12f5d7a46632', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:13', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:41:13');
INSERT INTO `exception_log` VALUES (262, '4acb32ed-e1bc-48d5-99b1-bff56fce7510', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:13', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:41:13');
INSERT INTO `exception_log` VALUES (263, '64952411-8f98-4868-89c1-a7330b7dd043', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:34', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:41:34');
INSERT INTO `exception_log` VALUES (264, 'fe552f56-1a8f-42dc-8804-731edba062ae', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:34', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:41:34');
INSERT INTO `exception_log` VALUES (265, '5a94ffc6-9e54-4aa4-9232-5e8484cf6422', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:40', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:41:40');
INSERT INTO `exception_log` VALUES (266, 'ac2d1d06-7c5e-492f-a480-04023a919c3b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:40', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:41:40');
INSERT INTO `exception_log` VALUES (267, 'df39b59f-48e4-4696-ae24-0ed4a1ad2b4d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:58', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:41:58');
INSERT INTO `exception_log` VALUES (268, '10601d37-100c-4176-aadc-ad826f5fb9e8', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:41:58', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:41:58');
INSERT INTO `exception_log` VALUES (269, '2cf8abad-edc2-4fd7-afaf-1423c0601edf', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:09', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:42:09');
INSERT INTO `exception_log` VALUES (270, '93eb29f9-f6b1-4e7d-be6b-a77489a3db70', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:09', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:42:09');
INSERT INTO `exception_log` VALUES (271, 'd0549ccf-50fe-462c-8170-80ab795b3f1f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:56', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:42:56');
INSERT INTO `exception_log` VALUES (272, 'bd77eb4f-73ac-47ec-8b85-e9f3343b4367', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:56', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:42:56');
INSERT INTO `exception_log` VALUES (273, '3a1d6bc2-cb4e-4633-aae7-e6e961c4d674', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:58', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:42:58');
INSERT INTO `exception_log` VALUES (274, 'd9439ba4-1c75-4913-9414-35532751e9ea', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:42:58', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:42:58');
INSERT INTO `exception_log` VALUES (275, 'd2034ef0-eb76-4743-aa23-82fb43135306', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:44:01', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:44:01');
INSERT INTO `exception_log` VALUES (276, 'f6829a85-f672-495a-8472-6fc482737c7a', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:44:01', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:44:01');
INSERT INTO `exception_log` VALUES (277, '481f4a6f-0eda-429e-9ba3-bbb1fac224bd', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:44:37', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:44:37');
INSERT INTO `exception_log` VALUES (278, 'e8230304-1eaa-4efd-b295-e2cba836a474', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:44:37', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:44:37');
INSERT INTO `exception_log` VALUES (279, 'a2e7c500-9a36-4526-ba17-dd8a9752d230', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:45:15', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:45:15');
INSERT INTO `exception_log` VALUES (280, '04453ebf-124c-4bc0-bfc4-de95d8d62127', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:45:15', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:45:15');
INSERT INTO `exception_log` VALUES (281, 'ff9cdfa6-e50a-447c-b556-01ac74e1ba13', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:46:49', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:46:49');
INSERT INTO `exception_log` VALUES (282, '7b7bfbd6-2448-4611-ab28-60b355d2514f', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-15 23:46:49', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor472.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:43)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$834f39e7.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.GeneratedConstructorAccessor99.newInstance(Unknown Source)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor374.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor395.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor409.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 135 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor471.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.GeneratedMethodAccessor478.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-15 23:46:49');
INSERT INTO `exception_log` VALUES (283, 'cb21ff2b-3c48-446f-9958-5f8a2d5c208b', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:25', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$3a6c30df.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$3a6c30df.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$3a6c30df.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 00:23:25');
INSERT INTO `exception_log` VALUES (284, '2ddc4b99-6ed2-4fe2-905a-f30f940624f1', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:25', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$3a6c30df.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$3a6c30df.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$3a6c30df.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 00:23:25');
INSERT INTO `exception_log` VALUES (285, '268fa78b-6d78-435e-9661-39f2a41bed34', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:34', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$3a6c30df.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor473.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$3a6c30df.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor473.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$3a6c30df.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor473.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:82)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 00:23:34');
INSERT INTO `exception_log` VALUES (286, '3d57d05c-0808-4b27-b7e9-d83b7bdabbe7', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 00:23:34', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$3a6c30df.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor473.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$3a6c30df.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor473.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$3a6c30df.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor473.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getResourcesByTypeAndRoleIds(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:54)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 00:23:34');
INSERT INTO `exception_log` VALUES (287, 'bd0b8086-edf7-4e64-a7e4-3e8439b6e99d', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:04', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 10:43:04');
INSERT INTO `exception_log` VALUES (288, 'e4fb5da4-4843-478f-9a34-792486d103b2', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:04', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 10:43:04');
INSERT INTO `exception_log` VALUES (289, '402c2608-d988-47e6-8e0a-bcbdaf9f938d', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:16', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 10:43:16');
INSERT INTO `exception_log` VALUES (290, 'd371f096-c75e-426c-bf8d-7eb58e570472', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:16', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 10:43:16');
INSERT INTO `exception_log` VALUES (291, '5206ba67-f516-4bea-a574-82abfc20b737', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:27', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 10:43:27');
INSERT INTO `exception_log` VALUES (292, '9c30a162-05d2-41a6-951a-51235341f9ed', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:27', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 10:43:27');
INSERT INTO `exception_log` VALUES (293, '4f0e7833-8260-4bfc-bb8b-f45bb1b6fac6', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:37', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 10:43:37');
INSERT INTO `exception_log` VALUES (294, 'c56dcb88-1ce4-4a7a-abc2-e1892e41620b', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:37', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 10:43:37');
INSERT INTO `exception_log` VALUES (295, 'e8e0b108-9913-4f3c-ad58-2e4e70b71947', 1, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:48', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 10:43:48');
INSERT INTO `exception_log` VALUES (296, 'a2963d55-c346-4091-875e-7e83cbd95013', 1, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 10:43:48', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/system/system-service-impl/target/classes/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                       AND r.type = ?                   AND rr.role_id IN              (                   ?              ,                  ?              ,                  ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy130.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:42)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$93c9f9e6.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor359.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor442.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 138 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getResourcesByTypeAndRoleIds(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.urlResourceList(AdminController.java:83)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 10:43:48');
INSERT INTO `exception_log` VALUES (297, '37.64.15579762649020011', 0, 2, 'admin-application', '/admin-api/admins/resource/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-16 11:11:05', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in URL [jar:file:/work2/project/system/system-application-1.0-SNAPSHOT.jar!/BOOT-INF/lib/system-service-impl-1.0-SNAPSHOT.jar!/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'', 'MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n### The error may exist in URL [jar:file:/work2/project/system/system-application-1.0-SNAPSHOT.jar!/BOOT-INF/lib/system-service-impl-1.0-SNAPSHOT.jar!/mapper/ResourceMapper.xml]\n### The error may involve cn.iocoder.mall.admin.dao.ResourceMapper.selectListByType-Inline\n### The error occurred while setting parameters\n### SQL: SELECT                     id, name, type, sort, display_name,         create_time, pid, handler               FROM resource          WHERE  deleted = 0\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy131.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectListByType(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy140.selectListByType(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByType(ResourceServiceImpl.java:49)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$2700534c.getResourcesByType(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper5.invokeMethod(Wrapper5.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CFfnAnX6(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CFfnAnX6$accessor$jKbaNoNK(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$EhJZBpmZ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CFfnAnX6(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CFfnAnX6$accessor$jKbaNoNK(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$EhJZBpmZ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByType(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy142.getResourcesByType(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree$original$hBZT4ppX(ResourceController.java:38)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree$original$hBZT4ppX$accessor$62YcPBkF(ResourceController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController$auxiliary$RbtutIR2.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.ResourceController.tree(ResourceController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$uQCZ0cSR(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$uQCZ0cSR$accessor$N4J7Ly9l(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$6zqUi0aD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute$original$OTzAUu2C(PreparedStatement.java:1197)\n	at com.mysql.jdbc.PreparedStatement.execute$original$OTzAUu2C$accessor$Qv8DsdGO(PreparedStatement.java)\n	at com.mysql.jdbc.PreparedStatement$auxiliary$Toofd6Rj.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute$accessor$ICx9mQu9(JDBC42PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement$auxiliary$oGLIXb8S.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute(JDBC42PreparedStatement.java)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 152 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-16 11:11:05');
INSERT INTO `exception_log` VALUES (298, '37.72.15579762742510011', 0, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-16 11:11:14', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in URL [jar:file:/work2/project/system/system-application-1.0-SNAPSHOT.jar!/BOOT-INF/lib/system-service-impl-1.0-SNAPSHOT.jar!/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                   AND rr.role_id IN              (                   ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'', 'MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in URL [jar:file:/work2/project/system/system-application-1.0-SNAPSHOT.jar!/BOOT-INF/lib/system-service-impl-1.0-SNAPSHOT.jar!/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                   AND rr.role_id IN              (                   ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy131.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy140.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:44)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$2700534c.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper5.invokeMethod(Wrapper5.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CFfnAnX6(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CFfnAnX6$accessor$jKbaNoNK(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$EhJZBpmZ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CFfnAnX6(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CFfnAnX6$accessor$jKbaNoNK(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$EhJZBpmZ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy142.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.RoleController.resourceTree$original$IYitC2cu(RoleController.java:87)\n	at cn.iocoder.mall.admin.application.controller.admins.RoleController.resourceTree$original$IYitC2cu$accessor$26cpNzPg(RoleController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.RoleController$auxiliary$XE7zIlDh.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.RoleController.resourceTree(RoleController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$uQCZ0cSR(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$uQCZ0cSR$accessor$N4J7Ly9l(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$6zqUi0aD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute$original$OTzAUu2C(PreparedStatement.java:1197)\n	at com.mysql.jdbc.PreparedStatement.execute$original$OTzAUu2C$accessor$Qv8DsdGO(PreparedStatement.java)\n	at com.mysql.jdbc.PreparedStatement$auxiliary$Toofd6Rj.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute$accessor$ICx9mQu9(JDBC42PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement$auxiliary$oGLIXb8S.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute(JDBC42PreparedStatement.java)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 152 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-16 11:11:14');
INSERT INTO `exception_log` VALUES (299, '32.80.15579763817030063', 0, 2, 'product-application', '/product-api/admins/spu/add', 'cid=反正我是信了&description=你就说强不强 MQ 骚操作&name=厮大牛逼&picUrls=http://www.iocoder.cn&sellPoint=各种 MQ 骚操作&skuStr=[{\"attrs\": [1,3 ], \"price\": 1, \"quantity\": 100, \"picUrl\": \"http://www.iocoder.cn\"}]&visible=true', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-16 11:13:02', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException', 'MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"反正我是信了\"', 'NumberFormatException: For input string: \"反正我是信了\"', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"反正我是信了\"\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:132)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$KTeWuuIN(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$KTeWuuIN$accessor$1olImTPc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$dTtHPTX8.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.lang.NumberFormatException: For input string: \"反正我是信了\"\n	at java.lang.NumberFormatException.forInputString(NumberFormatException.java:65)\n	at java.lang.Integer.parseInt(Integer.java:580)\n	at java.lang.Integer.valueOf(Integer.java:766)\n	at org.springframework.util.NumberUtils.parseNumber(NumberUtils.java:211)\n	at org.springframework.beans.propertyeditors.CustomNumberEditor.setAsText(CustomNumberEditor.java:115)\n	at org.springframework.beans.TypeConverterDelegate.doConvertTextValue(TypeConverterDelegate.java:429)\n	at org.springframework.beans.TypeConverterDelegate.doConvertValue(TypeConverterDelegate.java:402)\n	at org.springframework.beans.TypeConverterDelegate.convertIfNecessary(TypeConverterDelegate.java:155)\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:73)\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:53)\n	at org.springframework.validation.DataBinder.convertIfNecessary(DataBinder.java:693)\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:124)\n	... 64 more\n', 'org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver', 'AbstractNamedValueMethodArgumentResolver.java', 'resolveArgument', 132, '2019-05-16 11:13:02');
INSERT INTO `exception_log` VALUES (300, '9416514c-492f-422c-8694-fb4227f0a15b', 0, 2, 'admin-application', '/admin-api/admins/role/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:09:38', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.selectById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.selectById(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAuthentication(OAuth2ServiceImpl.java:123)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$9b0154c6.getAuthentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy206.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy204.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 128 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.selectById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.selectById(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAuthentication(OAuth2ServiceImpl.java:123)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$9b0154c6.getAuthentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy206.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy204.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 128 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.selectById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.selectById(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAuthentication(OAuth2ServiceImpl.java:123)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$9b0154c6.getAuthentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy206.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy204.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 128 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 15:09:38');
INSERT INTO `exception_log` VALUES (301, '8ef7f9a7-b6f4-4677-921f-6ab3a6b00a5d', 0, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:09:38', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.selectById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.selectById(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAuthentication(OAuth2ServiceImpl.java:123)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$9b0154c6.getAuthentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy206.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy204.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 128 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.selectById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.selectById(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAuthentication(OAuth2ServiceImpl.java:123)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$9b0154c6.getAuthentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy206.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy204.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 128 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.selectById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.selectById(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAuthentication(OAuth2ServiceImpl.java:123)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$9b0154c6.getAuthentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy206.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy204.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 128 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 15:09:38');
INSERT INTO `exception_log` VALUES (302, 'e1303158-4dbb-4089-9f40-9773dda7bf6c', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:09:38', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.selectById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.selectById(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAuthentication(OAuth2ServiceImpl.java:123)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$9b0154c6.getAuthentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy206.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy204.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 128 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.selectById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.selectById(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAuthentication(OAuth2ServiceImpl.java:123)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$9b0154c6.getAuthentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy206.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy204.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 128 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.selectById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.selectById(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAuthentication(OAuth2ServiceImpl.java:123)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$9b0154c6.getAuthentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy206.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy204.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 128 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 15:09:38');
INSERT INTO `exception_log` VALUES (303, '0c2f49c8-9701-48cb-a0b0-d4e22afbb53c', 0, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:09:38', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.selectById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.selectById(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAuthentication(OAuth2ServiceImpl.java:123)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$9b0154c6.getAuthentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy206.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy204.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 128 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.selectById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.selectById(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAuthentication(OAuth2ServiceImpl.java:123)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$9b0154c6.getAuthentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy206.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy204.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 128 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,admin_id,create_time,update_time FROM o_auth2_access_token_d_o WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.selectById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.selectById(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAuthentication(OAuth2ServiceImpl.java:123)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$9b0154c6.getAuthentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.o_auth2_access_token_d_o\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy206.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy204.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 128 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:61)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 15:09:38');
INSERT INTO `exception_log` VALUES (304, 'c7c4ca1e-5348-4cf6-a2cb-f1547bc1806b', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:10:49', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$d58948cd.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n', 'RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$d58948cd.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n', 'java.lang.RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$d58948cd.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 15:10:49');
INSERT INTO `exception_log` VALUES (305, '75388d8d-d251-49d5-94d2-6e30d03a70af', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:11:15', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$d58948cd.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n', 'RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$d58948cd.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n', 'java.lang.RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$d58948cd.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 15:11:15');
INSERT INTO `exception_log` VALUES (306, 'aa628b2d-b10a-42df-99cc-f811936a5a42', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:13:55', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:147)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:65)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$d58948cd.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n', 'RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:147)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:65)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$d58948cd.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n', 'java.lang.RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:147)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:65)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$d58948cd.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 15:13:55');
INSERT INTO `exception_log` VALUES (307, 'ab4c369e-338d-4de5-bb06-437631de7a34', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:14:38', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:147)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:65)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$d58948cd.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n', 'RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:147)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:65)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$d58948cd.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n', 'java.lang.RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token,   expires_time, valid, admin_id )  VALUES  ( ?,   ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy129.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy140.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:147)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:65)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$d58948cd.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy207.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy205.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 15:14:38');
INSERT INTO `exception_log` VALUES (308, '5be89c78-2d46-4cbd-a416-7b02c1cfbeed', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:19:36', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy142.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$3d795149.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy208.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy206.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy142.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$3d795149.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy208.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy206.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy142.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$3d795149.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'user_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy208.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy206.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 15:19:36');
INSERT INTO `exception_log` VALUES (309, 'd39ca4ca-329f-4698-a729-4e4ba379b890', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:22:12', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy142.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$3d795149.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy208.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy206.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n', 'RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy142.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$3d795149.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy208.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy206.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n', 'java.lang.RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy142.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$3d795149.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy208.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy206.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 15:22:12');
INSERT INTO `exception_log` VALUES (310, '5898ab7c-f4bd-40aa-8077-e990768beb34', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:23:32', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy142.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$5273834.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy208.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy206.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n', 'RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy142.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$5273834.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy208.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy206.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n', 'java.lang.RuntimeException: org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\norg.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.OAuth2AccessTokenMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO oauth2_access_token  ( refresh_token, user_id, user_type, expires_time, valid )  VALUES  ( ?, ?, ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n; Field \'id\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy141.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy142.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2AccessToken(OAuth2ServiceImpl.java:146)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:64)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$5273834.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: Field \'id\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy208.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy206.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 143 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAccessToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:34)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 15:23:33');
INSERT INTO `exception_log` VALUES (311, '197feba6-4503-4f90-9b50-13547be84efa', 0, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=2&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 15:40:12', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n### The error may exist in cn/iocoder/mall/admin/dao/RoleResourceMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,role_id,resource_id,deleted,create_time,update_time  FROM role_resource   WHERE  deleted=0  AND resourceId IN (?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n### The error may exist in cn/iocoder/mall/admin/dao/RoleResourceMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,role_id,resource_id,deleted,create_time,update_time  FROM role_resource   WHERE  deleted=0  AND resourceId IN (?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy131.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy135.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.RoleResourceMapper.selectListByResourceId(RoleResourceMapper.java:22)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy135.selectListByResourceId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy136.selectListByResourceId(Unknown Source)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl.getPermissionRoleMap(RoleServiceImpl.java:175)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl$$FastClassBySpringCGLIB$$830ec1bf.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl$$EnhancerBySpringCGLIB$$55fb3dfd.getPermissionRoleMap(<generated>)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.checkPermissions(AdminServiceImpl.java:229)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$db7a1f32.checkPermissions(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.checkPermissions(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.checkPermissions(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.checkPermission(AdminSecurityInterceptor.java:112)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:82)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy208.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy206.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 140 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n### The error may exist in cn/iocoder/mall/admin/dao/RoleResourceMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,role_id,resource_id,deleted,create_time,update_time  FROM role_resource   WHERE  deleted=0  AND resourceId IN (?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n### The error may exist in cn/iocoder/mall/admin/dao/RoleResourceMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,role_id,resource_id,deleted,create_time,update_time  FROM role_resource   WHERE  deleted=0  AND resourceId IN (?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy131.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy135.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.RoleResourceMapper.selectListByResourceId(RoleResourceMapper.java:22)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy135.selectListByResourceId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy136.selectListByResourceId(Unknown Source)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl.getPermissionRoleMap(RoleServiceImpl.java:175)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl$$FastClassBySpringCGLIB$$830ec1bf.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl$$EnhancerBySpringCGLIB$$55fb3dfd.getPermissionRoleMap(<generated>)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.checkPermissions(AdminServiceImpl.java:229)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$db7a1f32.checkPermissions(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.checkPermissions(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.checkPermissions(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.checkPermission(AdminSecurityInterceptor.java:112)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:82)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy208.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy206.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 140 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n### The error may exist in cn/iocoder/mall/admin/dao/RoleResourceMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,role_id,resource_id,deleted,create_time,update_time  FROM role_resource   WHERE  deleted=0  AND resourceId IN (?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n### The error may exist in cn/iocoder/mall/admin/dao/RoleResourceMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,role_id,resource_id,deleted,create_time,update_time  FROM role_resource   WHERE  deleted=0  AND resourceId IN (?)\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy131.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy135.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.RoleResourceMapper.selectListByResourceId(RoleResourceMapper.java:22)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy135.selectListByResourceId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy136.selectListByResourceId(Unknown Source)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl.getPermissionRoleMap(RoleServiceImpl.java:175)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl$$FastClassBySpringCGLIB$$830ec1bf.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.RoleServiceImpl$$EnhancerBySpringCGLIB$$55fb3dfd.getPermissionRoleMap(<generated>)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.checkPermissions(AdminServiceImpl.java:229)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$db7a1f32.checkPermissions(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.checkPermissions(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.checkPermissions(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.checkPermission(AdminSecurityInterceptor.java:112)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:82)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'resourceId\' in \'where clause\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy208.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy206.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 140 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.checkPermissions(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.checkPermissions(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.checkPermission(AdminSecurityInterceptor.java:112)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:82)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 15:40:12');
INSERT INTO `exception_log` VALUES (312, '31.52.15579937918380011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '103.37.140.19', '2019-05-16 16:03:13', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy93.selectByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy95.selectByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.getUser(UserServiceImpl.java:41)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$338719e3.getUser(<generated>)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:58)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAccessToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln(PassportController.java:52)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$CJXxcoww.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 16:03:13');
INSERT INTO `exception_log` VALUES (313, '78409325-09df-4cd9-95c4-42f091aef94a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:02:30', 'java.lang.RuntimeException', 'RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy131.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy144.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy145.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2RefreshToken(OAuth2ServiceImpl.java:109)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createToken(OAuth2ServiceImpl.java:55)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$2a03880a.createToken(<generated>)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:70)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$bfd1bb6e.authentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.authentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.authentication(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:31)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.setParameters(MybatisDefaultParameterHandler.java:219)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.parameterize(PreparedStatementHandler.java:94)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.parameterize(RoutingStatementHandler.java:64)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy207.parameterize(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.prepareStatement(MybatisSimpleExecutor.java:99)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:53)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 148 more\n', 'RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy131.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy144.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy145.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2RefreshToken(OAuth2ServiceImpl.java:109)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createToken(OAuth2ServiceImpl.java:55)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$2a03880a.createToken(<generated>)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:70)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$bfd1bb6e.authentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.authentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.authentication(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:31)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.setParameters(MybatisDefaultParameterHandler.java:219)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.parameterize(PreparedStatementHandler.java:94)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.parameterize(RoutingStatementHandler.java:64)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy207.parameterize(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.prepareStatement(MybatisSimpleExecutor.java:99)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:53)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 148 more\n', 'java.lang.RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy131.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy144.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy145.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2RefreshToken(OAuth2ServiceImpl.java:109)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createToken(OAuth2ServiceImpl.java:55)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$2a03880a.createToken(<generated>)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:70)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$bfd1bb6e.authentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.authentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.authentication(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:31)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.setParameters(MybatisDefaultParameterHandler.java:219)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.parameterize(PreparedStatementHandler.java:94)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.parameterize(RoutingStatementHandler.java:64)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy207.parameterize(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.prepareStatement(MybatisSimpleExecutor.java:99)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:53)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 148 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.authentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.authentication(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:31)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 17:02:30');
INSERT INTO `exception_log` VALUES (314, 'd9e02462-6939-4c51-9266-00849288a4e4', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 17:12:46', 'java.lang.RuntimeException', 'RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy131.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy144.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy145.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2RefreshToken(OAuth2ServiceImpl.java:109)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createToken(OAuth2ServiceImpl.java:55)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$2a03880a.createToken(<generated>)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:70)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$bfd1bb6e.authentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.authentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.authentication(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:31)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.setParameters(MybatisDefaultParameterHandler.java:219)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.parameterize(PreparedStatementHandler.java:94)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.parameterize(RoutingStatementHandler.java:64)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy207.parameterize(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.prepareStatement(MybatisSimpleExecutor.java:99)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:53)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 148 more\n', 'RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy131.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy144.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy145.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2RefreshToken(OAuth2ServiceImpl.java:109)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createToken(OAuth2ServiceImpl.java:55)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$2a03880a.createToken(<generated>)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:70)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$bfd1bb6e.authentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.authentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.authentication(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:31)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.setParameters(MybatisDefaultParameterHandler.java:219)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.parameterize(PreparedStatementHandler.java:94)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.parameterize(RoutingStatementHandler.java:64)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy207.parameterize(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.prepareStatement(MybatisSimpleExecutor.java:99)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:53)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 148 more\n', 'java.lang.RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy131.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy144.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy145.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createOAuth2RefreshToken(OAuth2ServiceImpl.java:109)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.createToken(OAuth2ServiceImpl.java:55)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$2a03880a.createToken(<generated>)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:70)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$bfd1bb6e.authentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.authentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.authentication(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:31)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'adminId\' in \'class cn.iocoder.mall.admin.dataobject.OAuth2RefreshTokenDO\'\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.setParameters(MybatisDefaultParameterHandler.java:219)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.parameterize(PreparedStatementHandler.java:94)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.parameterize(RoutingStatementHandler.java:64)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy207.parameterize(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.prepareStatement(MybatisSimpleExecutor.java:99)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:53)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 148 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.authentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.authentication(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:31)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 17:12:46');
INSERT INTO `exception_log` VALUES (315, '35.73.15579985118420063', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.55', '2019-05-16 17:21:52', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 17:21:52');
INSERT INTO `exception_log` VALUES (316, '35.71.15579985118410061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.55', '2019-05-16 17:21:52', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 17:21:52');
INSERT INTO `exception_log` VALUES (317, '32.85.15579985240690067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.55', '2019-05-16 17:22:04', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 17:22:04');
INSERT INTO `exception_log` VALUES (318, '36.88.15579985280810009', 0, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '112.65.61.55', '2019-05-16 17:22:08', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 17:22:08');
INSERT INTO `exception_log` VALUES (319, '36.90.15579985364010011', 0, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.55', '2019-05-16 17:22:16', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 17:22:16');
INSERT INTO `exception_log` VALUES (320, '32.82.15579985410170065', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.55', '2019-05-16 17:22:21', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 17:22:21');
INSERT INTO `exception_log` VALUES (321, '35.80.15579985453890059', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.55', '2019-05-16 17:22:25', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 17:22:25');
INSERT INTO `exception_log` VALUES (322, '35.74.15579985453900061', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.65.61.55', '2019-05-16 17:22:25', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 17:22:25');
INSERT INTO `exception_log` VALUES (323, '31.45.15580159981530009', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13133336666&code=9999', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-16 22:13:18', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy93.selectByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy95.selectByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.getUser(UserServiceImpl.java:41)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$338719e3.getUser(<generated>)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:58)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAccessToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln(PassportController.java:52)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$CJXxcoww.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 22:13:18');
INSERT INTO `exception_log` VALUES (324, '37.66.15580197791000017', 0, 2, 'admin-application', '/admin-api/admins/role/resource_tree', 'id=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '218.92.219.147', '2019-05-16 23:16:19', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in URL [jar:file:/work2/project/system/system-application-1.0-SNAPSHOT.jar!/BOOT-INF/lib/system-service-impl-1.0-SNAPSHOT.jar!/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                   AND rr.role_id IN              (                   ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'', 'MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n### The error may exist in URL [jar:file:/work2/project/system/system-application-1.0-SNAPSHOT.jar!/BOOT-INF/lib/system-service-impl-1.0-SNAPSHOT.jar!/mapper/ResourceMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT             r.id, r.name, r.type, r.sort, r.display_name,             r.create_time, r.pid, r.handler         FROM resource r, role_resource rr         WHERE r.deleted = 0         AND rr.deleted = 0                   AND rr.role_id IN              (                   ?              )          AND r.id = rr.resource_id\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy131.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectListByTypeAndRoleIds(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy140.selectListByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl.getResourcesByTypeAndRoleIds(ResourceServiceImpl.java:44)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$FastClassBySpringCGLIB$$34ceff27.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.ResourceServiceImpl$$EnhancerBySpringCGLIB$$2700534c.getResourcesByTypeAndRoleIds(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper5.invokeMethod(Wrapper5.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CFfnAnX6(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CFfnAnX6$accessor$jKbaNoNK(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$EhJZBpmZ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CFfnAnX6(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CFfnAnX6$accessor$jKbaNoNK(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$EhJZBpmZ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getResourcesByTypeAndRoleIds(proxy1.java)\n	at sun.reflect.GeneratedMethodAccessor525.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy142.getResourcesByTypeAndRoleIds(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.RoleController.resourceTree$original$IYitC2cu(RoleController.java:87)\n	at cn.iocoder.mall.admin.application.controller.admins.RoleController.resourceTree$original$IYitC2cu$accessor$26cpNzPg(RoleController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.RoleController$auxiliary$XE7zIlDh.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.RoleController.resourceTree(RoleController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$uQCZ0cSR(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$uQCZ0cSR$accessor$N4J7Ly9l(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$6zqUi0aD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'r.name\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute$original$OTzAUu2C(PreparedStatement.java:1197)\n	at com.mysql.jdbc.PreparedStatement.execute$original$OTzAUu2C$accessor$Qv8DsdGO(PreparedStatement.java)\n	at com.mysql.jdbc.PreparedStatement$auxiliary$Toofd6Rj.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute$accessor$ICx9mQu9(JDBC42PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement$auxiliary$oGLIXb8S.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute(JDBC42PreparedStatement.java)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor527.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 151 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-16 23:16:19');
INSERT INTO `exception_log` VALUES (325, '35.75.15580204386350069', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:19', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 23:27:19');
INSERT INTO `exception_log` VALUES (326, '35.72.15580204386350067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:19', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 23:27:19');
INSERT INTO `exception_log` VALUES (327, '32.85.15580204411380069', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:21', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 23:27:21');
INSERT INTO `exception_log` VALUES (328, '36.87.15580204431870013', 0, 1, 'order-application', '/order-api/users/cart/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:23', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 23:27:23');
INSERT INTO `exception_log` VALUES (329, '32.81.15580204471540067', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:27', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 23:27:27');
INSERT INTO `exception_log` VALUES (330, '35.79.15580204477870067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:28', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 23:27:28');
INSERT INTO `exception_log` VALUES (331, '35.78.15580204477860065', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:27:28', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 23:27:28');
INSERT INTO `exception_log` VALUES (332, '55425400-1c3b-44b9-b686-95c34d4dfe3f', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-16 23:40:05', 'java.lang.RuntimeException', 'RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: Could not set property \'id\' of \'class cn.iocoder.mall.user.biz.dataobject.MobileCodeDO\' with value \'1129048884337631234\' Cause: java.lang.IllegalArgumentException: argument type mismatch\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: Could not set property \'id\' of \'class cn.iocoder.mall.user.biz.dataobject.MobileCodeDO\' with value \'1129048884337631234\' Cause: java.lang.IllegalArgumentException: argument type mismatch\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.insert(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:104)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.send(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy103.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: Could not set property \'id\' of \'class cn.iocoder.mall.user.biz.dataobject.MobileCodeDO\' with value \'1129048884337631234\' Cause: java.lang.IllegalArgumentException: argument type mismatch\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.setBeanProperty(BeanWrapper.java:185)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.set(BeanWrapper.java:59)\n	at org.apache.ibatis.reflection.MetaObject.setValue(MetaObject.java:140)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.populateKeys(MybatisDefaultParameterHandler.java:180)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.processBatch(MybatisDefaultParameterHandler.java:122)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.<init>(MybatisDefaultParameterHandler.java:51)\n	at com.baomidou.mybatisplus.core.MybatisXMLLanguageDriver.createParameterHandler(MybatisXMLLanguageDriver.java:34)\n	at com.baomidou.mybatisplus.core.MybatisXMLLanguageDriver.createParameterHandler(MybatisXMLLanguageDriver.java:28)\n	at org.apache.ibatis.session.Configuration.newParameterHandler(Configuration.java:563)\n	at org.apache.ibatis.executor.statement.BaseStatementHandler.<init>(BaseStatementHandler.java:69)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.<init>(PreparedStatementHandler.java:41)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.<init>(RoutingStatementHandler.java:46)\n	at org.apache.ibatis.session.Configuration.newStatementHandler(Configuration.java:576)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:52)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 115 more\nCaused by: java.lang.IllegalArgumentException: argument type mismatch\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.reflection.invoker.MethodInvoker.invoke(MethodInvoker.java:44)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.setBeanProperty(BeanWrapper.java:180)\n	... 137 more\n', 'RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: Could not set property \'id\' of \'class cn.iocoder.mall.user.biz.dataobject.MobileCodeDO\' with value \'1129048884337631234\' Cause: java.lang.IllegalArgumentException: argument type mismatch\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: Could not set property \'id\' of \'class cn.iocoder.mall.user.biz.dataobject.MobileCodeDO\' with value \'1129048884337631234\' Cause: java.lang.IllegalArgumentException: argument type mismatch\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.insert(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:104)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.send(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy103.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: Could not set property \'id\' of \'class cn.iocoder.mall.user.biz.dataobject.MobileCodeDO\' with value \'1129048884337631234\' Cause: java.lang.IllegalArgumentException: argument type mismatch\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.setBeanProperty(BeanWrapper.java:185)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.set(BeanWrapper.java:59)\n	at org.apache.ibatis.reflection.MetaObject.setValue(MetaObject.java:140)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.populateKeys(MybatisDefaultParameterHandler.java:180)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.processBatch(MybatisDefaultParameterHandler.java:122)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.<init>(MybatisDefaultParameterHandler.java:51)\n	at com.baomidou.mybatisplus.core.MybatisXMLLanguageDriver.createParameterHandler(MybatisXMLLanguageDriver.java:34)\n	at com.baomidou.mybatisplus.core.MybatisXMLLanguageDriver.createParameterHandler(MybatisXMLLanguageDriver.java:28)\n	at org.apache.ibatis.session.Configuration.newParameterHandler(Configuration.java:563)\n	at org.apache.ibatis.executor.statement.BaseStatementHandler.<init>(BaseStatementHandler.java:69)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.<init>(PreparedStatementHandler.java:41)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.<init>(RoutingStatementHandler.java:46)\n	at org.apache.ibatis.session.Configuration.newStatementHandler(Configuration.java:576)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:52)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 115 more\nCaused by: java.lang.IllegalArgumentException: argument type mismatch\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.reflection.invoker.MethodInvoker.invoke(MethodInvoker.java:44)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.setBeanProperty(BeanWrapper.java:180)\n	... 137 more\n', 'java.lang.RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: Could not set property \'id\' of \'class cn.iocoder.mall.user.biz.dataobject.MobileCodeDO\' with value \'1129048884337631234\' Cause: java.lang.IllegalArgumentException: argument type mismatch\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: Could not set property \'id\' of \'class cn.iocoder.mall.user.biz.dataobject.MobileCodeDO\' with value \'1129048884337631234\' Cause: java.lang.IllegalArgumentException: argument type mismatch\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.insert(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:104)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.send(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy103.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.reflection.ReflectionException: Could not set property \'id\' of \'class cn.iocoder.mall.user.biz.dataobject.MobileCodeDO\' with value \'1129048884337631234\' Cause: java.lang.IllegalArgumentException: argument type mismatch\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.setBeanProperty(BeanWrapper.java:185)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.set(BeanWrapper.java:59)\n	at org.apache.ibatis.reflection.MetaObject.setValue(MetaObject.java:140)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.populateKeys(MybatisDefaultParameterHandler.java:180)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.processBatch(MybatisDefaultParameterHandler.java:122)\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.<init>(MybatisDefaultParameterHandler.java:51)\n	at com.baomidou.mybatisplus.core.MybatisXMLLanguageDriver.createParameterHandler(MybatisXMLLanguageDriver.java:34)\n	at com.baomidou.mybatisplus.core.MybatisXMLLanguageDriver.createParameterHandler(MybatisXMLLanguageDriver.java:28)\n	at org.apache.ibatis.session.Configuration.newParameterHandler(Configuration.java:563)\n	at org.apache.ibatis.executor.statement.BaseStatementHandler.<init>(BaseStatementHandler.java:69)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.<init>(PreparedStatementHandler.java:41)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.<init>(RoutingStatementHandler.java:46)\n	at org.apache.ibatis.session.Configuration.newStatementHandler(Configuration.java:576)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:52)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 115 more\nCaused by: java.lang.IllegalArgumentException: argument type mismatch\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.reflection.invoker.MethodInvoker.invoke(MethodInvoker.java:44)\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.setBeanProperty(BeanWrapper.java:180)\n	... 137 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.send(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy103.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-16 23:40:05');
INSERT INTO `exception_log` VALUES (333, '31.51.15580212162210011', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'code=9999&mobile=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:40:16', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy93.selectByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy95.selectByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.getUser(UserServiceImpl.java:41)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$338719e3.getUser(<generated>)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:58)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAccessToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln(PassportController.java:52)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$CJXxcoww.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 23:40:16');
INSERT INTO `exception_log` VALUES (334, '31.46.15580212632810011', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691300', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-16 23:41:03', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy98.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy99.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:87)\n	at org.apache.dubbo.common.bytecode.Wrapper5.invokeMethod(Wrapper5.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.send(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy106.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend$original$SRU2CEln(PassportController.java:61)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$TKKhn5Sc.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-16 23:41:03');
INSERT INTO `exception_log` VALUES (335, '48dba92b-9a08-4a1b-8a99-b15a5342486d', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:12:46', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/user/biz/dao/MobileCodeMapper.java (best guess)\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE mobile_code  SET used=?, used_user_id=?, used_time=?  WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/user/biz/dao/MobileCodeMapper.java (best guess)\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE mobile_code  SET used=?, used_user_id=?, used_time=?  WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.updateById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.updateById(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.useMobileCode(MobileCodeServiceImpl.java:78)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.authenticationByMobileCode(UserServiceImpl.java:103)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$57d87ed6.authenticationByMobileCode(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper9.invokeMethod(Wrapper9.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy94.authenticationByMobileCode(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:47)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 125 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/user/biz/dao/MobileCodeMapper.java (best guess)\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE mobile_code  SET used=?, used_user_id=?, used_time=?  WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/user/biz/dao/MobileCodeMapper.java (best guess)\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE mobile_code  SET used=?, used_user_id=?, used_time=?  WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.updateById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.updateById(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.useMobileCode(MobileCodeServiceImpl.java:78)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.authenticationByMobileCode(UserServiceImpl.java:103)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$57d87ed6.authenticationByMobileCode(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper9.invokeMethod(Wrapper9.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy94.authenticationByMobileCode(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:47)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 125 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/user/biz/dao/MobileCodeMapper.java (best guess)\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE mobile_code  SET used=?, used_user_id=?, used_time=?  WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/user/biz/dao/MobileCodeMapper.java (best guess)\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.updateById-Inline\n### The error occurred while setting parameters\n### SQL: UPDATE mobile_code  SET used=?, used_user_id=?, used_time=?  WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.update(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.updateById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.updateById(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.useMobileCode(MobileCodeServiceImpl.java:78)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.authenticationByMobileCode(UserServiceImpl.java:103)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$57d87ed6.authenticationByMobileCode(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper9.invokeMethod(Wrapper9.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy94.authenticationByMobileCode(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:47)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'used_user_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 125 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy94.authenticationByMobileCode(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:47)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-17 00:12:46');
INSERT INTO `exception_log` VALUES (336, '95ae8574-bcb6-434b-b478-b8bd5ae80fc2', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:13:49', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/user/user-service-impl/target/classes/mapper/MobileCodeMapper.xml]\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile-Inline\n### The error occurred while setting parameters\n### SQL: SELECT           id, mobile, code, today_index, used,           userd_user_id, used_time, create_time       FROM mobile_code       WHERE mobile = ?       ORDER BY id DESC       LIMIT 1\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/user/user-service-impl/target/classes/mapper/MobileCodeMapper.xml]\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile-Inline\n### The error occurred while setting parameters\n### SQL: SELECT           id, mobile, code, today_index, used,           userd_user_id, used_time, create_time       FROM mobile_code       WHERE mobile = ?       ORDER BY id DESC       LIMIT 1\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.validLastMobileCode(MobileCodeServiceImpl.java:54)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.authenticationByMobileCode(UserServiceImpl.java:91)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$57d87ed6.authenticationByMobileCode(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper9.invokeMethod(Wrapper9.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy94.authenticationByMobileCode(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:47)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 125 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/user/user-service-impl/target/classes/mapper/MobileCodeMapper.xml]\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile-Inline\n### The error occurred while setting parameters\n### SQL: SELECT           id, mobile, code, today_index, used,           userd_user_id, used_time, create_time       FROM mobile_code       WHERE mobile = ?       ORDER BY id DESC       LIMIT 1\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/user/user-service-impl/target/classes/mapper/MobileCodeMapper.xml]\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile-Inline\n### The error occurred while setting parameters\n### SQL: SELECT           id, mobile, code, today_index, used,           userd_user_id, used_time, create_time       FROM mobile_code       WHERE mobile = ?       ORDER BY id DESC       LIMIT 1\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.validLastMobileCode(MobileCodeServiceImpl.java:54)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.authenticationByMobileCode(UserServiceImpl.java:91)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$57d87ed6.authenticationByMobileCode(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper9.invokeMethod(Wrapper9.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy94.authenticationByMobileCode(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:47)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 125 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/user/user-service-impl/target/classes/mapper/MobileCodeMapper.xml]\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile-Inline\n### The error occurred while setting parameters\n### SQL: SELECT           id, mobile, code, today_index, used,           userd_user_id, used_time, create_time       FROM mobile_code       WHERE mobile = ?       ORDER BY id DESC       LIMIT 1\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/user/user-service-impl/target/classes/mapper/MobileCodeMapper.xml]\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile-Inline\n### The error occurred while setting parameters\n### SQL: SELECT           id, mobile, code, today_index, used,           userd_user_id, used_time, create_time       FROM mobile_code       WHERE mobile = ?       ORDER BY id DESC       LIMIT 1\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.validLastMobileCode(MobileCodeServiceImpl.java:54)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.authenticationByMobileCode(UserServiceImpl.java:91)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$57d87ed6.authenticationByMobileCode(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper9.invokeMethod(Wrapper9.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy94.authenticationByMobileCode(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:47)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 125 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy94.authenticationByMobileCode(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:47)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-17 00:13:49');
INSERT INTO `exception_log` VALUES (337, 'c6ef4870-f2ef-4d1c-81e8-19d10e589f79', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:13:58', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/user/user-service-impl/target/classes/mapper/MobileCodeMapper.xml]\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile-Inline\n### The error occurred while setting parameters\n### SQL: SELECT           id, mobile, code, today_index, used,           userd_user_id, used_time, create_time       FROM mobile_code       WHERE mobile = ?       ORDER BY id DESC       LIMIT 1\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/user/user-service-impl/target/classes/mapper/MobileCodeMapper.xml]\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile-Inline\n### The error occurred while setting parameters\n### SQL: SELECT           id, mobile, code, today_index, used,           userd_user_id, used_time, create_time       FROM mobile_code       WHERE mobile = ?       ORDER BY id DESC       LIMIT 1\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.validLastMobileCode(MobileCodeServiceImpl.java:54)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.authenticationByMobileCode(UserServiceImpl.java:91)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$57d87ed6.authenticationByMobileCode(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper9.invokeMethod(Wrapper9.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy94.authenticationByMobileCode(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:47)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 125 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/user/user-service-impl/target/classes/mapper/MobileCodeMapper.xml]\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile-Inline\n### The error occurred while setting parameters\n### SQL: SELECT           id, mobile, code, today_index, used,           userd_user_id, used_time, create_time       FROM mobile_code       WHERE mobile = ?       ORDER BY id DESC       LIMIT 1\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/user/user-service-impl/target/classes/mapper/MobileCodeMapper.xml]\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile-Inline\n### The error occurred while setting parameters\n### SQL: SELECT           id, mobile, code, today_index, used,           userd_user_id, used_time, create_time       FROM mobile_code       WHERE mobile = ?       ORDER BY id DESC       LIMIT 1\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.validLastMobileCode(MobileCodeServiceImpl.java:54)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.authenticationByMobileCode(UserServiceImpl.java:91)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$57d87ed6.authenticationByMobileCode(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper9.invokeMethod(Wrapper9.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy94.authenticationByMobileCode(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:47)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 125 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/user/user-service-impl/target/classes/mapper/MobileCodeMapper.xml]\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile-Inline\n### The error occurred while setting parameters\n### SQL: SELECT           id, mobile, code, today_index, used,           userd_user_id, used_time, create_time       FROM mobile_code       WHERE mobile = ?       ORDER BY id DESC       LIMIT 1\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\norg.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n### The error may exist in file [/Users/yunai/Java/mall-two/user/user-service-impl/target/classes/mapper/MobileCodeMapper.xml]\n### The error may involve cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile-Inline\n### The error occurred while setting parameters\n### SQL: SELECT           id, mobile, code, today_index, used,           userd_user_id, used_time, create_time       FROM mobile_code       WHERE mobile = ?       ORDER BY id DESC       LIMIT 1\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.validLastMobileCode(MobileCodeServiceImpl.java:54)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.authenticationByMobileCode(UserServiceImpl.java:91)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$57d87ed6.authenticationByMobileCode(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper9.invokeMethod(Wrapper9.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy94.authenticationByMobileCode(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:47)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'userd_user_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 125 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy94.authenticationByMobileCode(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:47)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-17 00:13:58');
INSERT INTO `exception_log` VALUES (338, 'c3c568ce-3229-4ced-80f9-3a0a949a0281', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:18:02', 'java.lang.RuntimeException', 'RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile(MobileCodeMapper.java:21)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy89.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:87)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.send(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy103.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:80)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 120 more\n', 'RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile(MobileCodeMapper.java:21)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy89.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:87)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.send(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy103.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:80)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 120 more\n', 'java.lang.RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile(MobileCodeMapper.java:21)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy89.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:87)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.send(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy103.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:80)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 120 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.send(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy103.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-17 00:18:02');
INSERT INTO `exception_log` VALUES (339, 'd7627124-e56b-4b50-aa20-2631e27a7d6f', 0, 1, 'user-application', '/user-api/users/passport/mobile/send_register_code', 'mobile=15601691399', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:18:04', 'java.lang.RuntimeException', 'RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile(MobileCodeMapper.java:21)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy89.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:87)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.send(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy103.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:80)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 120 more\n', 'RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile(MobileCodeMapper.java:21)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy89.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:87)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.send(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy103.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:80)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 120 more\n', 'java.lang.RuntimeException: org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\norg.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy82.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy89.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.MobileCodeMapper.selectLast1ByMobile(MobileCodeMapper.java:21)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy89.selectLast1ByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy90.selectLast1ByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.MobileCodeServiceImpl.send(MobileCodeServiceImpl.java:87)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.send(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy103.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 112\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:80)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 120 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.send(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy103.send(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileSend(PassportController.java:55)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-17 00:18:04');
INSERT INTO `exception_log` VALUES (340, 'f5c6aa74-6f4e-4709-a397-87b225fe6b98', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15601691399&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 00:20:06', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method createToken in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.26:20880] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: createToken, provider: dubbo://192.168.3.26:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=user-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken&pid=57229&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=admin-service&remote.timestamp=1558023042801&revision=1.0.0&side=consumer&sticky=false&timestamp=1558023568269&validation=true&version=1.0.0, cause: io.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2CreateTokenDTO must implement java.io.Serializable\nio.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2CreateTokenDTO must implement java.io.Serializable\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:125)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.handler.timeout.IdleStateHandler.write(IdleStateHandler.java:304)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.channel.ChannelDuplexHandler.write(ChannelDuplexHandler.java:106)\n	at org.apache.dubbo.remoting.transport.netty4.NettyClientHandler.write(NettyClientHandler.java:87)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.access$1700(AbstractChannelHandlerContext.java:38)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.write(AbstractChannelHandlerContext.java:1127)\n	at io.netty.channel.AbstractChannelHandlerContext$WriteAndFlushTask.write(AbstractChannelHandlerContext.java:1174)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.run(AbstractChannelHandlerContext.java:1098)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute$$$capture(AbstractEventExecutor.java:163)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute(AbstractEventExecutor.java)\n	at io.netty.util.concurrent.SingleThreadEventExecutor.runAllTasks(SingleThreadEventExecutor.java:404)\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:495)\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:905)\n	at io.netty.util.concurrent.FastThreadLocalRunnable.run(FastThreadLocalRunnable.java:30)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2CreateTokenDTO must implement java.io.Serializable\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getDefaultSerializer(SerializerFactory.java:401)\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getSerializer(SerializerFactory.java:375)\n	at com.alibaba.com.caucho.hessian.io.Hessian2Output.writeObject(Hessian2Output.java:389)\n	at org.apache.dubbo.common.serialize.hessian2.Hessian2ObjectOutput.writeObject(Hessian2ObjectOutput.java:89)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCodec.encodeRequestData(DubboCodec.java:184)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encodeRequest(ExchangeCodec.java:238)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encode(ExchangeCodec.java:69)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCountCodec.encode(DubboCountCodec.java:38)\n	at org.apache.dubbo.remoting.transport.netty4.NettyCodecAdapter$InternalEncoder.encode(NettyCodecAdapter.java:70)\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:107)\n	... 24 more\n', 'RemotingException: io.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2CreateTokenDTO must implement java.io.Serializable\nio.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2CreateTokenDTO must implement java.io.Serializable\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:125)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.handler.timeout.IdleStateHandler.write(IdleStateHandler.java:304)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.channel.ChannelDuplexHandler.write(ChannelDuplexHandler.java:106)\n	at org.apache.dubbo.remoting.transport.netty4.NettyClientHandler.write(NettyClientHandler.java:87)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.access$1700(AbstractChannelHandlerContext.java:38)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.write(AbstractChannelHandlerContext.java:1127)\n	at io.netty.channel.AbstractChannelHandlerContext$WriteAndFlushTask.write(AbstractChannelHandlerContext.java:1174)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.run(AbstractChannelHandlerContext.java:1098)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute$$$capture(AbstractEventExecutor.java:163)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute(AbstractEventExecutor.java)\n	at io.netty.util.concurrent.SingleThreadEventExecutor.runAllTasks(SingleThreadEventExecutor.java:404)\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:495)\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:905)\n	at io.netty.util.concurrent.FastThreadLocalRunnable.run(FastThreadLocalRunnable.java:30)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2CreateTokenDTO must implement java.io.Serializable\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getDefaultSerializer(SerializerFactory.java:401)\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getSerializer(SerializerFactory.java:375)\n	at com.alibaba.com.caucho.hessian.io.Hessian2Output.writeObject(Hessian2Output.java:389)\n	at org.apache.dubbo.common.serialize.hessian2.Hessian2ObjectOutput.writeObject(Hessian2ObjectOutput.java:89)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCodec.encodeRequestData(DubboCodec.java:184)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encodeRequest(ExchangeCodec.java:238)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encode(ExchangeCodec.java:69)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCountCodec.encode(DubboCountCodec.java:38)\n	at org.apache.dubbo.remoting.transport.netty4.NettyCodecAdapter$InternalEncoder.encode(NettyCodecAdapter.java:70)\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:107)\n	... 24 more\n', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method createToken in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.26:20880] (1/6) from the registry 127.0.0.1:2181 on the consumer 192.168.3.26 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: createToken, provider: dubbo://192.168.3.26:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=user-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken&pid=57229&qos.enable=false&register=true&register.ip=192.168.3.26&release=2.7.1&remote.application=admin-service&remote.timestamp=1558023042801&revision=1.0.0&side=consumer&sticky=false&timestamp=1558023568269&validation=true&version=1.0.0, cause: io.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2CreateTokenDTO must implement java.io.Serializable\nio.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2CreateTokenDTO must implement java.io.Serializable\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:125)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.handler.timeout.IdleStateHandler.write(IdleStateHandler.java:304)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.channel.ChannelDuplexHandler.write(ChannelDuplexHandler.java:106)\n	at org.apache.dubbo.remoting.transport.netty4.NettyClientHandler.write(NettyClientHandler.java:87)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.access$1700(AbstractChannelHandlerContext.java:38)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.write(AbstractChannelHandlerContext.java:1127)\n	at io.netty.channel.AbstractChannelHandlerContext$WriteAndFlushTask.write(AbstractChannelHandlerContext.java:1174)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.run(AbstractChannelHandlerContext.java:1098)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute$$$capture(AbstractEventExecutor.java:163)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute(AbstractEventExecutor.java)\n	at io.netty.util.concurrent.SingleThreadEventExecutor.runAllTasks(SingleThreadEventExecutor.java:404)\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:495)\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:905)\n	at io.netty.util.concurrent.FastThreadLocalRunnable.run(FastThreadLocalRunnable.java:30)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2CreateTokenDTO must implement java.io.Serializable\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getDefaultSerializer(SerializerFactory.java:401)\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getSerializer(SerializerFactory.java:375)\n	at com.alibaba.com.caucho.hessian.io.Hessian2Output.writeObject(Hessian2Output.java:389)\n	at org.apache.dubbo.common.serialize.hessian2.Hessian2ObjectOutput.writeObject(Hessian2ObjectOutput.java:89)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCodec.encodeRequestData(DubboCodec.java:184)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encodeRequest(ExchangeCodec.java:238)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encode(ExchangeCodec.java:69)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCountCodec.encode(DubboCountCodec.java:38)\n	at org.apache.dubbo.remoting.transport.netty4.NettyCodecAdapter$InternalEncoder.encode(NettyCodecAdapter.java:70)\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:107)\n	... 24 more\n\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.createToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy93.createToken(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.authenticationByMobileCode(UserServiceImpl.java:105)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$a4b9307d.authenticationByMobileCode(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper9.invokeMethod(Wrapper9.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.authenticationByMobileCode(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy94.authenticationByMobileCode(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:47)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.RemotingException: io.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2CreateTokenDTO must implement java.io.Serializable\nio.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2CreateTokenDTO must implement java.io.Serializable\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:125)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.handler.timeout.IdleStateHandler.write(IdleStateHandler.java:304)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.channel.ChannelDuplexHandler.write(ChannelDuplexHandler.java:106)\n	at org.apache.dubbo.remoting.transport.netty4.NettyClientHandler.write(NettyClientHandler.java:87)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.access$1700(AbstractChannelHandlerContext.java:38)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.write(AbstractChannelHandlerContext.java:1127)\n	at io.netty.channel.AbstractChannelHandlerContext$WriteAndFlushTask.write(AbstractChannelHandlerContext.java:1174)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.run(AbstractChannelHandlerContext.java:1098)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute$$$capture(AbstractEventExecutor.java:163)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute(AbstractEventExecutor.java)\n	at io.netty.util.concurrent.SingleThreadEventExecutor.runAllTasks(SingleThreadEventExecutor.java:404)\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:495)\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:905)\n	at io.netty.util.concurrent.FastThreadLocalRunnable.run(FastThreadLocalRunnable.java:30)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2CreateTokenDTO must implement java.io.Serializable\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getDefaultSerializer(SerializerFactory.java:401)\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getSerializer(SerializerFactory.java:375)\n	at com.alibaba.com.caucho.hessian.io.Hessian2Output.writeObject(Hessian2Output.java:389)\n	at org.apache.dubbo.common.serialize.hessian2.Hessian2ObjectOutput.writeObject(Hessian2ObjectOutput.java:89)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCodec.encodeRequestData(DubboCodec.java:184)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encodeRequest(ExchangeCodec.java:238)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encode(ExchangeCodec.java:69)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCountCodec.encode(DubboCountCodec.java:38)\n	at org.apache.dubbo.remoting.transport.netty4.NettyCodecAdapter$InternalEncoder.encode(NettyCodecAdapter.java:70)\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:107)\n	... 24 more\n\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:297)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 118 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 00:20:06');
INSERT INTO `exception_log` VALUES (341, '35.80.15580331661520063', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:26', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 02:59:26');
INSERT INTO `exception_log` VALUES (342, '35.74.15580331661530065', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:26', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 02:59:26');
INSERT INTO `exception_log` VALUES (343, '32.80.15580331693640075', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:29', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 02:59:29');
INSERT INTO `exception_log` VALUES (344, '35.76.15580331715380067', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:32', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 02:59:32');
INSERT INTO `exception_log` VALUES (345, '35.77.15580331715390067', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:32', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 02:59:32');
INSERT INTO `exception_log` VALUES (346, '31.54.15580331736810013', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:34', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.checkToken(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:37)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 02:59:34');
INSERT INTO `exception_log` VALUES (347, '35.72.15580331762730069', 0, 1, 'promotion-application', '/promotion-api/users/coupon/card/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:36', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 02:59:36');
INSERT INTO `exception_log` VALUES (348, '31.53.15580331785200013', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:39', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.checkToken(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:37)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 02:59:39');
INSERT INTO `exception_log` VALUES (349, '36.89.15580331861600007', 0, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:46', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 02:59:46');
INSERT INTO `exception_log` VALUES (350, '36.81.15580331886480015', 0, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=3', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:49', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 02:59:49');
INSERT INTO `exception_log` VALUES (351, '36.84.15580331910340013', 0, 1, 'order-application', '/order-api/users/order/order_page', 'pageNo=0&pageSize=10&status=5', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:51', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 02:59:51');
INSERT INTO `exception_log` VALUES (352, '31.47.15580331932340013', 0, 1, 'user-application', '/user-api/users/user/info', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-17 02:59:53', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.checkToken(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:37)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 02:59:53');
INSERT INTO `exception_log` VALUES (353, '31.52.15580625138870015', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=13900223331&code=9999', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '1.119.154.179', '2019-05-17 11:08:34', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy93.selectByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy95.selectByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.getUser(UserServiceImpl.java:41)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$338719e3.getUser(<generated>)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:58)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAccessToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln(PassportController.java:52)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$CJXxcoww.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 11:08:34');
INSERT INTO `exception_log` VALUES (354, '22c92a97-ea33-4098-a08f-c57268952011', 0, 1, 'user-application', '/user-api/users/passport/refresh_token', 'refreshToken=53a7619e43b748499579bb7ce44f236c', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 11:56:29', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method refreshToken in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.88.69:20880] (1/8) from the registry 127.0.0.1:2181 on the consumer 192.168.88.69 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: refreshToken, provider: dubbo://192.168.88.69:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=user-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken&pid=62002&qos.enable=false&register=true&register.ip=192.168.88.69&release=2.7.1&remote.application=admin-service&remote.timestamp=1558061413606&revision=1.0.0&side=consumer&sticky=false&timestamp=1558065127837&validation=true&version=1.0.0, cause: io.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2RefreshTokenDTO must implement java.io.Serializable\nio.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2RefreshTokenDTO must implement java.io.Serializable\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:125)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.handler.timeout.IdleStateHandler.write(IdleStateHandler.java:304)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.channel.ChannelDuplexHandler.write(ChannelDuplexHandler.java:106)\n	at org.apache.dubbo.remoting.transport.netty4.NettyClientHandler.write(NettyClientHandler.java:87)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.access$1700(AbstractChannelHandlerContext.java:38)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.write(AbstractChannelHandlerContext.java:1127)\n	at io.netty.channel.AbstractChannelHandlerContext$WriteAndFlushTask.write(AbstractChannelHandlerContext.java:1174)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.run(AbstractChannelHandlerContext.java:1098)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute(AbstractEventExecutor.java:163)\n	at io.netty.util.concurrent.SingleThreadEventExecutor.runAllTasks(SingleThreadEventExecutor.java:404)\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:495)\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:905)\n	at io.netty.util.concurrent.FastThreadLocalRunnable.run(FastThreadLocalRunnable.java:30)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2RefreshTokenDTO must implement java.io.Serializable\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getDefaultSerializer(SerializerFactory.java:401)\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getSerializer(SerializerFactory.java:375)\n	at com.alibaba.com.caucho.hessian.io.Hessian2Output.writeObject(Hessian2Output.java:389)\n	at org.apache.dubbo.common.serialize.hessian2.Hessian2ObjectOutput.writeObject(Hessian2ObjectOutput.java:89)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCodec.encodeRequestData(DubboCodec.java:184)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encodeRequest(ExchangeCodec.java:238)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encode(ExchangeCodec.java:69)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCountCodec.encode(DubboCountCodec.java:38)\n	at org.apache.dubbo.remoting.transport.netty4.NettyCodecAdapter$InternalEncoder.encode(NettyCodecAdapter.java:70)\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:107)\n	... 23 more\n', 'RemotingException: io.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2RefreshTokenDTO must implement java.io.Serializable\nio.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2RefreshTokenDTO must implement java.io.Serializable\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:125)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.handler.timeout.IdleStateHandler.write(IdleStateHandler.java:304)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.channel.ChannelDuplexHandler.write(ChannelDuplexHandler.java:106)\n	at org.apache.dubbo.remoting.transport.netty4.NettyClientHandler.write(NettyClientHandler.java:87)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.access$1700(AbstractChannelHandlerContext.java:38)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.write(AbstractChannelHandlerContext.java:1127)\n	at io.netty.channel.AbstractChannelHandlerContext$WriteAndFlushTask.write(AbstractChannelHandlerContext.java:1174)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.run(AbstractChannelHandlerContext.java:1098)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute(AbstractEventExecutor.java:163)\n	at io.netty.util.concurrent.SingleThreadEventExecutor.runAllTasks(SingleThreadEventExecutor.java:404)\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:495)\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:905)\n	at io.netty.util.concurrent.FastThreadLocalRunnable.run(FastThreadLocalRunnable.java:30)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2RefreshTokenDTO must implement java.io.Serializable\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getDefaultSerializer(SerializerFactory.java:401)\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getSerializer(SerializerFactory.java:375)\n	at com.alibaba.com.caucho.hessian.io.Hessian2Output.writeObject(Hessian2Output.java:389)\n	at org.apache.dubbo.common.serialize.hessian2.Hessian2ObjectOutput.writeObject(Hessian2ObjectOutput.java:89)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCodec.encodeRequestData(DubboCodec.java:184)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encodeRequest(ExchangeCodec.java:238)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encode(ExchangeCodec.java:69)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCountCodec.encode(DubboCountCodec.java:38)\n	at org.apache.dubbo.remoting.transport.netty4.NettyCodecAdapter$InternalEncoder.encode(NettyCodecAdapter.java:70)\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:107)\n	... 23 more\n', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method refreshToken in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.88.69:20880] (1/8) from the registry 127.0.0.1:2181 on the consumer 192.168.88.69 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: refreshToken, provider: dubbo://192.168.88.69:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=user-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken&pid=62002&qos.enable=false&register=true&register.ip=192.168.88.69&release=2.7.1&remote.application=admin-service&remote.timestamp=1558061413606&revision=1.0.0&side=consumer&sticky=false&timestamp=1558065127837&validation=true&version=1.0.0, cause: io.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2RefreshTokenDTO must implement java.io.Serializable\nio.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2RefreshTokenDTO must implement java.io.Serializable\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:125)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.handler.timeout.IdleStateHandler.write(IdleStateHandler.java:304)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.channel.ChannelDuplexHandler.write(ChannelDuplexHandler.java:106)\n	at org.apache.dubbo.remoting.transport.netty4.NettyClientHandler.write(NettyClientHandler.java:87)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.access$1700(AbstractChannelHandlerContext.java:38)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.write(AbstractChannelHandlerContext.java:1127)\n	at io.netty.channel.AbstractChannelHandlerContext$WriteAndFlushTask.write(AbstractChannelHandlerContext.java:1174)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.run(AbstractChannelHandlerContext.java:1098)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute(AbstractEventExecutor.java:163)\n	at io.netty.util.concurrent.SingleThreadEventExecutor.runAllTasks(SingleThreadEventExecutor.java:404)\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:495)\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:905)\n	at io.netty.util.concurrent.FastThreadLocalRunnable.run(FastThreadLocalRunnable.java:30)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2RefreshTokenDTO must implement java.io.Serializable\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getDefaultSerializer(SerializerFactory.java:401)\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getSerializer(SerializerFactory.java:375)\n	at com.alibaba.com.caucho.hessian.io.Hessian2Output.writeObject(Hessian2Output.java:389)\n	at org.apache.dubbo.common.serialize.hessian2.Hessian2ObjectOutput.writeObject(Hessian2ObjectOutput.java:89)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCodec.encodeRequestData(DubboCodec.java:184)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encodeRequest(ExchangeCodec.java:238)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encode(ExchangeCodec.java:69)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCountCodec.encode(DubboCountCodec.java:38)\n	at org.apache.dubbo.remoting.transport.netty4.NettyCodecAdapter$InternalEncoder.encode(NettyCodecAdapter.java:70)\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:107)\n	... 23 more\n\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.refreshToken(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy93.refreshToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.refreshToken(PassportController.java:72)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.RemotingException: io.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2RefreshTokenDTO must implement java.io.Serializable\nio.netty.handler.codec.EncoderException: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2RefreshTokenDTO must implement java.io.Serializable\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:125)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.handler.timeout.IdleStateHandler.write(IdleStateHandler.java:304)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.channel.ChannelDuplexHandler.write(ChannelDuplexHandler.java:106)\n	at org.apache.dubbo.remoting.transport.netty4.NettyClientHandler.write(NettyClientHandler.java:87)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.access$1700(AbstractChannelHandlerContext.java:38)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.write(AbstractChannelHandlerContext.java:1127)\n	at io.netty.channel.AbstractChannelHandlerContext$WriteAndFlushTask.write(AbstractChannelHandlerContext.java:1174)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.run(AbstractChannelHandlerContext.java:1098)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute(AbstractEventExecutor.java:163)\n	at io.netty.util.concurrent.SingleThreadEventExecutor.runAllTasks(SingleThreadEventExecutor.java:404)\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:495)\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:905)\n	at io.netty.util.concurrent.FastThreadLocalRunnable.run(FastThreadLocalRunnable.java:30)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2RefreshTokenDTO must implement java.io.Serializable\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getDefaultSerializer(SerializerFactory.java:401)\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getSerializer(SerializerFactory.java:375)\n	at com.alibaba.com.caucho.hessian.io.Hessian2Output.writeObject(Hessian2Output.java:389)\n	at org.apache.dubbo.common.serialize.hessian2.Hessian2ObjectOutput.writeObject(Hessian2ObjectOutput.java:89)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCodec.encodeRequestData(DubboCodec.java:184)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encodeRequest(ExchangeCodec.java:238)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encode(ExchangeCodec.java:69)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCountCodec.encode(DubboCountCodec.java:38)\n	at org.apache.dubbo.remoting.transport.netty4.NettyCodecAdapter$InternalEncoder.encode(NettyCodecAdapter.java:70)\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:107)\n	... 23 more\n\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:297)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 68 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 11:56:29');
INSERT INTO `exception_log` VALUES (355, '35.75.15580655570820077', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-17 11:59:17', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 11:59:17');
INSERT INTO `exception_log` VALUES (356, '35.72.15580655570830075', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '180.167.213.26', '2019-05-17 11:59:17', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.OAuth2AccessTokenMapper.selectByTokenId\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy100.selectByTokenId(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor427.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy101.selectByTokenId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.checkToken(OAuth2ServiceImpl.java:75)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.checkToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 11:59:17');
INSERT INTO `exception_log` VALUES (357, '174519eb-d447-488e-ae0e-7f8ed6049c49', 0, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:28:42', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [192.168.88.69:20880] (1/8) from the registry 127.0.0.1:2181 on the consumer 192.168.88.69 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: checkPermissions, provider: dubbo://192.168.88.69:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=updateAdminStatus,deleteAdmin,getAdminPage,updateAdmin,addAdmin,getRoleList,assignAdminRole,checkPermissions,getAdminRolesMap,authentication&pid=65254&qos.enable=false&register=true&register.ip=192.168.88.69&release=2.7.1&remote.application=admin-service&remote.timestamp=1558061413009&revision=1.0.0&side=consumer&sticky=false&timestamp=1558070909965&validation=true&version=1.0.0, cause: Failed to send response: Response [id=3, version=2.0.2, status=20, event=false, error=null, result=RpcResult [result=AdminAuthorizationBO(id=1, roleIds=[1, 2, 6]), exception=null]], cause: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.bo.admin.AdminAuthorizationBO must implement java.io.Serializable\njava.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.bo.admin.AdminAuthorizationBO must implement java.io.Serializable\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getDefaultSerializer(SerializerFactory.java:401)\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getSerializer(SerializerFactory.java:375)\n	at com.alibaba.com.caucho.hessian.io.Hessian2Output.writeObject(Hessian2Output.java:389)\n	at org.apache.dubbo.common.serialize.hessian2.Hessian2ObjectOutput.writeObject(Hessian2ObjectOutput.java:89)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCodec.encodeResponseData(DubboCodec.java:202)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encodeResponse(ExchangeCodec.java:283)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encode(ExchangeCodec.java:71)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCountCodec.encode(DubboCountCodec.java:38)\n	at org.apache.dubbo.remoting.transport.netty4.NettyCodecAdapter$InternalEncoder.encode(NettyCodecAdapter.java:70)\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:107)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.handler.timeout.IdleStateHandler.write(IdleStateHandler.java:302)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.channel.ChannelDuplexHandler.write(ChannelDuplexHandler.java:106)\n	at org.apache.dubbo.remoting.transport.netty4.NettyServerHandler.write(NettyServerHandler.java:100)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.access$1700(AbstractChannelHandlerContext.java:38)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.write(AbstractChannelHandlerContext.java:1127)\n	at io.netty.channel.AbstractChannelHandlerContext$WriteAndFlushTask.write(AbstractChannelHandlerContext.java:1174)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.run(AbstractChannelHandlerContext.java:1098)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute(AbstractEventExecutor.java:163)\n	at io.netty.util.concurrent.SingleThreadEventExecutor.runAllTasks(SingleThreadEventExecutor.java:404)\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:495)\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:905)\n	at io.netty.util.concurrent.FastThreadLocalRunnable.run(FastThreadLocalRunnable.java:30)\n	at java.lang.Thread.run(Thread.java:745)\n', 'RemotingException: Failed to send response: Response [id=3, version=2.0.2, status=20, event=false, error=null, result=RpcResult [result=AdminAuthorizationBO(id=1, roleIds=[1, 2, 6]), exception=null]], cause: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.bo.admin.AdminAuthorizationBO must implement java.io.Serializable\njava.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.bo.admin.AdminAuthorizationBO must implement java.io.Serializable\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getDefaultSerializer(SerializerFactory.java:401)\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getSerializer(SerializerFactory.java:375)\n	at com.alibaba.com.caucho.hessian.io.Hessian2Output.writeObject(Hessian2Output.java:389)\n	at org.apache.dubbo.common.serialize.hessian2.Hessian2ObjectOutput.writeObject(Hessian2ObjectOutput.java:89)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCodec.encodeResponseData(DubboCodec.java:202)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encodeResponse(ExchangeCodec.java:283)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encode(ExchangeCodec.java:71)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCountCodec.encode(DubboCountCodec.java:38)\n	at org.apache.dubbo.remoting.transport.netty4.NettyCodecAdapter$InternalEncoder.encode(NettyCodecAdapter.java:70)\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:107)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.handler.timeout.IdleStateHandler.write(IdleStateHandler.java:302)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.channel.ChannelDuplexHandler.write(ChannelDuplexHandler.java:106)\n	at org.apache.dubbo.remoting.transport.netty4.NettyServerHandler.write(NettyServerHandler.java:100)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.access$1700(AbstractChannelHandlerContext.java:38)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.write(AbstractChannelHandlerContext.java:1127)\n	at io.netty.channel.AbstractChannelHandlerContext$WriteAndFlushTask.write(AbstractChannelHandlerContext.java:1174)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.run(AbstractChannelHandlerContext.java:1098)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute(AbstractEventExecutor.java:163)\n	at io.netty.util.concurrent.SingleThreadEventExecutor.runAllTasks(SingleThreadEventExecutor.java:404)\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:495)\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:905)\n	at io.netty.util.concurrent.FastThreadLocalRunnable.run(FastThreadLocalRunnable.java:30)\n	at java.lang.Thread.run(Thread.java:745)\n', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [192.168.88.69:20880] (1/8) from the registry 127.0.0.1:2181 on the consumer 192.168.88.69 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: checkPermissions, provider: dubbo://192.168.88.69:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=updateAdminStatus,deleteAdmin,getAdminPage,updateAdmin,addAdmin,getRoleList,assignAdminRole,checkPermissions,getAdminRolesMap,authentication&pid=65254&qos.enable=false&register=true&register.ip=192.168.88.69&release=2.7.1&remote.application=admin-service&remote.timestamp=1558061413009&revision=1.0.0&side=consumer&sticky=false&timestamp=1558070909965&validation=true&version=1.0.0, cause: Failed to send response: Response [id=3, version=2.0.2, status=20, event=false, error=null, result=RpcResult [result=AdminAuthorizationBO(id=1, roleIds=[1, 2, 6]), exception=null]], cause: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.bo.admin.AdminAuthorizationBO must implement java.io.Serializable\njava.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.bo.admin.AdminAuthorizationBO must implement java.io.Serializable\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getDefaultSerializer(SerializerFactory.java:401)\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getSerializer(SerializerFactory.java:375)\n	at com.alibaba.com.caucho.hessian.io.Hessian2Output.writeObject(Hessian2Output.java:389)\n	at org.apache.dubbo.common.serialize.hessian2.Hessian2ObjectOutput.writeObject(Hessian2ObjectOutput.java:89)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCodec.encodeResponseData(DubboCodec.java:202)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encodeResponse(ExchangeCodec.java:283)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encode(ExchangeCodec.java:71)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCountCodec.encode(DubboCountCodec.java:38)\n	at org.apache.dubbo.remoting.transport.netty4.NettyCodecAdapter$InternalEncoder.encode(NettyCodecAdapter.java:70)\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:107)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.handler.timeout.IdleStateHandler.write(IdleStateHandler.java:302)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.channel.ChannelDuplexHandler.write(ChannelDuplexHandler.java:106)\n	at org.apache.dubbo.remoting.transport.netty4.NettyServerHandler.write(NettyServerHandler.java:100)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.access$1700(AbstractChannelHandlerContext.java:38)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.write(AbstractChannelHandlerContext.java:1127)\n	at io.netty.channel.AbstractChannelHandlerContext$WriteAndFlushTask.write(AbstractChannelHandlerContext.java:1174)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.run(AbstractChannelHandlerContext.java:1098)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute(AbstractEventExecutor.java:163)\n	at io.netty.util.concurrent.SingleThreadEventExecutor.runAllTasks(SingleThreadEventExecutor.java:404)\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:495)\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:905)\n	at io.netty.util.concurrent.FastThreadLocalRunnable.run(FastThreadLocalRunnable.java:30)\n	at java.lang.Thread.run(Thread.java:745)\n\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy9.checkPermissions(proxy9.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy162.checkPermissions(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.checkPermission(AdminSecurityInterceptor.java:112)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:82)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.dubbo.remoting.RemotingException: Failed to send response: Response [id=3, version=2.0.2, status=20, event=false, error=null, result=RpcResult [result=AdminAuthorizationBO(id=1, roleIds=[1, 2, 6]), exception=null]], cause: java.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.bo.admin.AdminAuthorizationBO must implement java.io.Serializable\njava.lang.IllegalStateException: Serialized class cn.iocoder.mall.admin.api.bo.admin.AdminAuthorizationBO must implement java.io.Serializable\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getDefaultSerializer(SerializerFactory.java:401)\n	at com.alibaba.com.caucho.hessian.io.SerializerFactory.getSerializer(SerializerFactory.java:375)\n	at com.alibaba.com.caucho.hessian.io.Hessian2Output.writeObject(Hessian2Output.java:389)\n	at org.apache.dubbo.common.serialize.hessian2.Hessian2ObjectOutput.writeObject(Hessian2ObjectOutput.java:89)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCodec.encodeResponseData(DubboCodec.java:202)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encodeResponse(ExchangeCodec.java:283)\n	at org.apache.dubbo.remoting.exchange.codec.ExchangeCodec.encode(ExchangeCodec.java:71)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboCountCodec.encode(DubboCountCodec.java:38)\n	at org.apache.dubbo.remoting.transport.netty4.NettyCodecAdapter$InternalEncoder.encode(NettyCodecAdapter.java:70)\n	at io.netty.handler.codec.MessageToByteEncoder.write(MessageToByteEncoder.java:107)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.handler.timeout.IdleStateHandler.write(IdleStateHandler.java:302)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:816)\n	at io.netty.channel.AbstractChannelHandlerContext.write(AbstractChannelHandlerContext.java:723)\n	at io.netty.channel.ChannelDuplexHandler.write(ChannelDuplexHandler.java:106)\n	at org.apache.dubbo.remoting.transport.netty4.NettyServerHandler.write(NettyServerHandler.java:100)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite0(AbstractChannelHandlerContext.java:738)\n	at io.netty.channel.AbstractChannelHandlerContext.invokeWrite(AbstractChannelHandlerContext.java:730)\n	at io.netty.channel.AbstractChannelHandlerContext.access$1700(AbstractChannelHandlerContext.java:38)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.write(AbstractChannelHandlerContext.java:1127)\n	at io.netty.channel.AbstractChannelHandlerContext$WriteAndFlushTask.write(AbstractChannelHandlerContext.java:1174)\n	at io.netty.channel.AbstractChannelHandlerContext$AbstractWriteTask.run(AbstractChannelHandlerContext.java:1098)\n	at io.netty.util.concurrent.AbstractEventExecutor.safeExecute(AbstractEventExecutor.java:163)\n	at io.netty.util.concurrent.SingleThreadEventExecutor.runAllTasks(SingleThreadEventExecutor.java:404)\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:495)\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:905)\n	at io.netty.util.concurrent.FastThreadLocalRunnable.run(FastThreadLocalRunnable.java:30)\n	at java.lang.Thread.run(Thread.java:745)\n\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:297)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 72 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 13:28:42');
INSERT INTO `exception_log` VALUES (358, '7c0d832a-e38f-4a1c-9623-f7d8def06251', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:30:14', 'java.lang.IllegalStateException', 'IllegalStateException: Failed to check the status of the service cn.iocoder.mall.order.api.OrderService. No provider available for the service cn.iocoder.mall.order.api.OrderService from the url zookeeper://127.0.0.1:2181/org.apache.dubbo.registry.RegistryService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.order.api.OrderService&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.order.api.OrderService&lazy=false&methods=createOrder,orderDelivery,cancelOrder,updateOrderItem,listenerExchangeGoods,getOrderItems,confirmReceiving,updateOrderItemPayAmount,updatePaySuccess,updateOrderRemake,getOrderPage,deleteOrderItem,listenerConfirmGoods,deleteOrder,getOrderRecipientBO,updateLogistics,info&pid=65312&qos.enable=false&register=true&register.ip=192.168.88.69&release=2.7.1&remote.application=order-service&remote.timestamp=1557657480898&side=consumer&sticky=false&timestamp=1558071010698&validation=true to the consumer 192.168.88.69 use dubbo version 2.7.1', 'IllegalStateException: Failed to check the status of the service cn.iocoder.mall.order.api.OrderService. No provider available for the service cn.iocoder.mall.order.api.OrderService from the url zookeeper://127.0.0.1:2181/org.apache.dubbo.registry.RegistryService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.order.api.OrderService&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.order.api.OrderService&lazy=false&methods=createOrder,orderDelivery,cancelOrder,updateOrderItem,listenerExchangeGoods,getOrderItems,confirmReceiving,updateOrderItemPayAmount,updatePaySuccess,updateOrderRemake,getOrderPage,deleteOrderItem,listenerConfirmGoods,deleteOrder,getOrderRecipientBO,updateLogistics,info&pid=65312&qos.enable=false&register=true&register.ip=192.168.88.69&release=2.7.1&remote.application=order-service&remote.timestamp=1557657480898&side=consumer&sticky=false&timestamp=1558071010698&validation=true to the consumer 192.168.88.69 use dubbo version 2.7.1', 'java.lang.IllegalStateException: Failed to check the status of the service cn.iocoder.mall.order.api.OrderService. No provider available for the service cn.iocoder.mall.order.api.OrderService from the url zookeeper://127.0.0.1:2181/org.apache.dubbo.registry.RegistryService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.order.api.OrderService&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.order.api.OrderService&lazy=false&methods=createOrder,orderDelivery,cancelOrder,updateOrderItem,listenerExchangeGoods,getOrderItems,confirmReceiving,updateOrderItemPayAmount,updatePaySuccess,updateOrderRemake,getOrderPage,deleteOrderItem,listenerConfirmGoods,deleteOrder,getOrderRecipientBO,updateLogistics,info&pid=65312&qos.enable=false&register=true&register.ip=192.168.88.69&release=2.7.1&remote.application=order-service&remote.timestamp=1557657480898&side=consumer&sticky=false&timestamp=1558071010698&validation=true to the consumer 192.168.88.69 use dubbo version 2.7.1\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:390)\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\n	at com.sun.proxy.$Proxy148.getOrderPage(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.admins.AdminsOrderController.getOrderPage(AdminsOrderController.java:42)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'org.apache.dubbo.config.ReferenceConfig', 'ReferenceConfig.java', 'createProxy', 390, '2019-05-17 13:30:14');
INSERT INTO `exception_log` VALUES (359, '4e54562d-e08f-420f-ada9-cf41dd7659b5', 1, 2, 'order-application', '/order-api/admins/order/page', 'pageNo=0&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:30:27', 'java.lang.IllegalStateException', 'IllegalStateException: Failed to check the status of the service cn.iocoder.mall.order.api.OrderService. No provider available for the service cn.iocoder.mall.order.api.OrderService from the url registry://127.0.0.1:2181/org.apache.dubbo.registry.RegistryService?application=order-service&cluster=registryaware&default.lazy=false&default.sticky=false&default.timeout=120000&dubbo=2.0.2&interface=cn.iocoder.mall.order.api.OrderService&lazy=false&methods=createOrder,orderDelivery,cancelOrder,updateOrderItem,listenerExchangeGoods,getOrderItems,confirmReceiving,updateOrderItemPayAmount,updatePaySuccess,updateOrderRemake,getOrderPage,deleteOrderItem,listenerConfirmGoods,deleteOrder,getOrderRecipientBO,updateLogistics,info&pid=65312&qos.enable=false&refer=application%3Dorder-service%26default.lazy%3Dfalse%26default.sticky%3Dfalse%26default.timeout%3D120000%26dubbo%3D2.0.2%26interface%3Dcn.iocoder.mall.order.api.OrderService%26lazy%3Dfalse%26methods%3DcreateOrder%2CorderDelivery%2CcancelOrder%2CupdateOrderItem%2ClistenerExchangeGoods%2CgetOrderItems%2CconfirmReceiving%2CupdateOrderItemPayAmount%2CupdatePaySuccess%2CupdateOrderRemake%2CgetOrderPage%2CdeleteOrderItem%2ClistenerConfirmGoods%2CdeleteOrder%2CgetOrderRecipientBO%2CupdateLogistics%2Cinfo%26pid%3D65312%26qos.enable%3Dfalse%26register.ip%3D192.168.88.69%26release%3D2.7.1%26side%3Dconsumer%26sticky%3Dfalse%26timestamp%3D1558071027244%26validation%3Dtrue&register.ip=192.168.88.69&registry=zookeeper&release=2.7.1&side=consumer&sticky=false&timestamp=1558071027244&validation=true to the consumer 192.168.88.69 use dubbo version 2.7.1', 'IllegalStateException: Failed to check the status of the service cn.iocoder.mall.order.api.OrderService. No provider available for the service cn.iocoder.mall.order.api.OrderService from the url registry://127.0.0.1:2181/org.apache.dubbo.registry.RegistryService?application=order-service&cluster=registryaware&default.lazy=false&default.sticky=false&default.timeout=120000&dubbo=2.0.2&interface=cn.iocoder.mall.order.api.OrderService&lazy=false&methods=createOrder,orderDelivery,cancelOrder,updateOrderItem,listenerExchangeGoods,getOrderItems,confirmReceiving,updateOrderItemPayAmount,updatePaySuccess,updateOrderRemake,getOrderPage,deleteOrderItem,listenerConfirmGoods,deleteOrder,getOrderRecipientBO,updateLogistics,info&pid=65312&qos.enable=false&refer=application%3Dorder-service%26default.lazy%3Dfalse%26default.sticky%3Dfalse%26default.timeout%3D120000%26dubbo%3D2.0.2%26interface%3Dcn.iocoder.mall.order.api.OrderService%26lazy%3Dfalse%26methods%3DcreateOrder%2CorderDelivery%2CcancelOrder%2CupdateOrderItem%2ClistenerExchangeGoods%2CgetOrderItems%2CconfirmReceiving%2CupdateOrderItemPayAmount%2CupdatePaySuccess%2CupdateOrderRemake%2CgetOrderPage%2CdeleteOrderItem%2ClistenerConfirmGoods%2CdeleteOrder%2CgetOrderRecipientBO%2CupdateLogistics%2Cinfo%26pid%3D65312%26qos.enable%3Dfalse%26register.ip%3D192.168.88.69%26release%3D2.7.1%26side%3Dconsumer%26sticky%3Dfalse%26timestamp%3D1558071027244%26validation%3Dtrue&register.ip=192.168.88.69&registry=zookeeper&release=2.7.1&side=consumer&sticky=false&timestamp=1558071027244&validation=true to the consumer 192.168.88.69 use dubbo version 2.7.1', 'java.lang.IllegalStateException: Failed to check the status of the service cn.iocoder.mall.order.api.OrderService. No provider available for the service cn.iocoder.mall.order.api.OrderService from the url registry://127.0.0.1:2181/org.apache.dubbo.registry.RegistryService?application=order-service&cluster=registryaware&default.lazy=false&default.sticky=false&default.timeout=120000&dubbo=2.0.2&interface=cn.iocoder.mall.order.api.OrderService&lazy=false&methods=createOrder,orderDelivery,cancelOrder,updateOrderItem,listenerExchangeGoods,getOrderItems,confirmReceiving,updateOrderItemPayAmount,updatePaySuccess,updateOrderRemake,getOrderPage,deleteOrderItem,listenerConfirmGoods,deleteOrder,getOrderRecipientBO,updateLogistics,info&pid=65312&qos.enable=false&refer=application%3Dorder-service%26default.lazy%3Dfalse%26default.sticky%3Dfalse%26default.timeout%3D120000%26dubbo%3D2.0.2%26interface%3Dcn.iocoder.mall.order.api.OrderService%26lazy%3Dfalse%26methods%3DcreateOrder%2CorderDelivery%2CcancelOrder%2CupdateOrderItem%2ClistenerExchangeGoods%2CgetOrderItems%2CconfirmReceiving%2CupdateOrderItemPayAmount%2CupdatePaySuccess%2CupdateOrderRemake%2CgetOrderPage%2CdeleteOrderItem%2ClistenerConfirmGoods%2CdeleteOrder%2CgetOrderRecipientBO%2CupdateLogistics%2Cinfo%26pid%3D65312%26qos.enable%3Dfalse%26register.ip%3D192.168.88.69%26release%3D2.7.1%26side%3Dconsumer%26sticky%3Dfalse%26timestamp%3D1558071027244%26validation%3Dtrue&register.ip=192.168.88.69&registry=zookeeper&release=2.7.1&side=consumer&sticky=false&timestamp=1558071027244&validation=true to the consumer 192.168.88.69 use dubbo version 2.7.1\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:390)\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\n	at com.sun.proxy.$Proxy148.getOrderPage(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.admins.AdminsOrderController.getOrderPage(AdminsOrderController.java:42)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'org.apache.dubbo.config.ReferenceConfig', 'ReferenceConfig.java', 'createProxy', 390, '2019-05-17 13:30:27');
INSERT INTO `exception_log` VALUES (360, '640bf42b-71c0-4b09-8ae4-275356870621', 1, 1, 'order-application', '/order-api/users/order/create_order_from_cart', 'userAddressId=1&remark=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:49:16', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/pay/pay-service-impl/target/classes/mapper/PayTransactionMapper.xml]\n### The error may involve cn.iocoder.mall.pay.biz.dao.PayTransactionMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO transaction (             app_id, create_ip, order_id, order_subject,             order_description, order_memo, price, status, expire_time,             finish_time, notify_url, extension_id, pay_channel, payment_time,             notify_time, trade_no, create_time         ) VALUES (             ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?         )\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/pay/pay-service-impl/target/classes/mapper/PayTransactionMapper.xml]\n### The error may involve cn.iocoder.mall.pay.biz.dao.PayTransactionMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO transaction (             app_id, create_ip, order_id, order_subject,             order_description, order_memo, price, status, expire_time,             finish_time, notify_url, extension_id, pay_channel, payment_time,             notify_time, trade_no, create_time         ) VALUES (             ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?         )\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy113.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy121.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy122.insert(Unknown Source)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.createTransaction(PayTransactionServiceImpl.java:100)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$d61b04e.createTransaction(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:193)\n	at io.seata.rm.datasource.ConnectionProxy.commit(ConnectionProxy.java:159)\n	at io.seata.rm.datasource.ConnectionProxy.setAutoCommit(ConnectionProxy.java:221)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.executeAutoCommitTrue(AbstractDMLBaseExecutor.java:107)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.doExecute(AbstractDMLBaseExecutor.java:57)\n	at io.seata.rm.datasource.exec.BaseTransactionalExecutor.execute(BaseTransactionalExecutor.java:86)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:101)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 54 more\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2079)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2013)\n	at com.mysql.jdbc.PreparedStatement.executeLargeUpdate(PreparedStatement.java:5104)\n	at com.mysql.jdbc.PreparedStatement.executeUpdate(PreparedStatement.java:1998)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.executeUpdate(DruidPooledPreparedStatement.java:255)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLog(UndoLogManager.java:340)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLogWithNormal(UndoLogManager.java:323)\n	at io.seata.rm.datasource.undo.UndoLogManager.flushUndoLogs(UndoLogManager.java:112)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:187)\n	... 74 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/pay/pay-service-impl/target/classes/mapper/PayTransactionMapper.xml]\n### The error may involve cn.iocoder.mall.pay.biz.dao.PayTransactionMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO transaction (             app_id, create_ip, order_id, order_subject,             order_description, order_memo, price, status, expire_time,             finish_time, notify_url, extension_id, pay_channel, payment_time,             notify_time, trade_no, create_time         ) VALUES (             ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?         )\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/pay/pay-service-impl/target/classes/mapper/PayTransactionMapper.xml]\n### The error may involve cn.iocoder.mall.pay.biz.dao.PayTransactionMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO transaction (             app_id, create_ip, order_id, order_subject,             order_description, order_memo, price, status, expire_time,             finish_time, notify_url, extension_id, pay_channel, payment_time,             notify_time, trade_no, create_time         ) VALUES (             ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?         )\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy113.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy121.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy122.insert(Unknown Source)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.createTransaction(PayTransactionServiceImpl.java:100)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$d61b04e.createTransaction(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:193)\n	at io.seata.rm.datasource.ConnectionProxy.commit(ConnectionProxy.java:159)\n	at io.seata.rm.datasource.ConnectionProxy.setAutoCommit(ConnectionProxy.java:221)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.executeAutoCommitTrue(AbstractDMLBaseExecutor.java:107)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.doExecute(AbstractDMLBaseExecutor.java:57)\n	at io.seata.rm.datasource.exec.BaseTransactionalExecutor.execute(BaseTransactionalExecutor.java:86)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:101)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 54 more\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2079)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2013)\n	at com.mysql.jdbc.PreparedStatement.executeLargeUpdate(PreparedStatement.java:5104)\n	at com.mysql.jdbc.PreparedStatement.executeUpdate(PreparedStatement.java:1998)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.executeUpdate(DruidPooledPreparedStatement.java:255)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLog(UndoLogManager.java:340)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLogWithNormal(UndoLogManager.java:323)\n	at io.seata.rm.datasource.undo.UndoLogManager.flushUndoLogs(UndoLogManager.java:112)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:187)\n	... 74 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/pay/pay-service-impl/target/classes/mapper/PayTransactionMapper.xml]\n### The error may involve cn.iocoder.mall.pay.biz.dao.PayTransactionMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO transaction (             app_id, create_ip, order_id, order_subject,             order_description, order_memo, price, status, expire_time,             finish_time, notify_url, extension_id, pay_channel, payment_time,             notify_time, trade_no, create_time         ) VALUES (             ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?         )\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/pay/pay-service-impl/target/classes/mapper/PayTransactionMapper.xml]\n### The error may involve cn.iocoder.mall.pay.biz.dao.PayTransactionMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO transaction (             app_id, create_ip, order_id, order_subject,             order_description, order_memo, price, status, expire_time,             finish_time, notify_url, extension_id, pay_channel, payment_time,             notify_time, trade_no, create_time         ) VALUES (             ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?         )\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy113.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy121.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy122.insert(Unknown Source)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.createTransaction(PayTransactionServiceImpl.java:100)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$d61b04e.createTransaction(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:193)\n	at io.seata.rm.datasource.ConnectionProxy.commit(ConnectionProxy.java:159)\n	at io.seata.rm.datasource.ConnectionProxy.setAutoCommit(ConnectionProxy.java:221)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.executeAutoCommitTrue(AbstractDMLBaseExecutor.java:107)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.doExecute(AbstractDMLBaseExecutor.java:57)\n	at io.seata.rm.datasource.exec.BaseTransactionalExecutor.execute(BaseTransactionalExecutor.java:86)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:101)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 54 more\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2079)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2013)\n	at com.mysql.jdbc.PreparedStatement.executeLargeUpdate(PreparedStatement.java:5104)\n	at com.mysql.jdbc.PreparedStatement.executeUpdate(PreparedStatement.java:1998)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.executeUpdate(DruidPooledPreparedStatement.java:255)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLog(UndoLogManager.java:340)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLogWithNormal(UndoLogManager.java:323)\n	at io.seata.rm.datasource.undo.UndoLogManager.flushUndoLogs(UndoLogManager.java:112)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:187)\n	... 74 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-17 13:49:16');
INSERT INTO `exception_log` VALUES (361, 'e03fa011-6a1a-4512-b37b-ccb4dcce5b3c', 1, 1, 'order-application', '/order-api/users/order/create_order_from_cart', 'userAddressId=1&remark=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:49:18', 'java.lang.reflect.UndeclaredThrowableException', 'UndeclaredThrowableException: ', 'TimeoutException: cost 30006 ms', 'java.lang.reflect.UndeclaredThrowableException\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$46f6b293.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper15.invokeMethod(Wrapper15.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy10.createOrder(proxy10.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy149.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrderFromCart(OrderController.java:94)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: io.seata.core.exception.TransactionException: java.util.concurrent.TimeoutException: cost 30006 ms\n	at io.seata.tm.DefaultTransactionManager.syncCall(DefaultTransactionManager.java:81)\n	at io.seata.tm.DefaultTransactionManager.rollback(DefaultTransactionManager.java:65)\n	at io.seata.tm.api.DefaultGlobalTransaction.rollback(DefaultGlobalTransaction.java:142)\n	at io.seata.tm.api.TransactionalTemplate.rollbackTransaction(TransactionalTemplate.java:114)\n	at io.seata.tm.api.TransactionalTemplate.completeTransactionAfterThrowing(TransactionalTemplate.java:88)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:69)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	... 115 more\nCaused by: java.util.concurrent.TimeoutException: cost 30006 ms\n	at io.seata.core.protocol.MessageFuture.get(MessageFuture.java:64)\n	at io.seata.core.rpc.netty.AbstractRpcRemoting.sendAsyncRequest(AbstractRpcRemoting.java:265)\n	at io.seata.core.rpc.netty.AbstractRpcRemoting.sendAsyncRequestWithResponse(AbstractRpcRemoting.java:195)\n	at io.seata.core.rpc.netty.TmRpcClient.sendMsgWithResponse(TmRpcClient.java:167)\n	at io.seata.core.rpc.netty.TmRpcClient.sendMsgWithResponse(TmRpcClient.java:178)\n	at io.seata.tm.DefaultTransactionManager.syncCall(DefaultTransactionManager.java:79)\n	... 124 more\n', 'cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$46f6b293', '<generated>', 'createOrder', -1, '2019-05-17 13:49:18');
INSERT INTO `exception_log` VALUES (362, '5f735b30-778f-485a-9996-c0afbc170a39', 1, 1, 'order-application', '/order-api/users/order/create_order_from_cart', 'userAddressId=1&remark=', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-05-17 13:50:06', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/pay/pay-service-impl/target/classes/mapper/PayTransactionMapper.xml]\n### The error may involve cn.iocoder.mall.pay.biz.dao.PayTransactionMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO transaction (             app_id, create_ip, order_id, order_subject,             order_description, order_memo, price, status, expire_time,             finish_time, notify_url, extension_id, pay_channel, payment_time,             notify_time, trade_no, create_time         ) VALUES (             ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?         )\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/pay/pay-service-impl/target/classes/mapper/PayTransactionMapper.xml]\n### The error may involve cn.iocoder.mall.pay.biz.dao.PayTransactionMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO transaction (             app_id, create_ip, order_id, order_subject,             order_description, order_memo, price, status, expire_time,             finish_time, notify_url, extension_id, pay_channel, payment_time,             notify_time, trade_no, create_time         ) VALUES (             ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?         )\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy113.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy121.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy122.insert(Unknown Source)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.createTransaction(PayTransactionServiceImpl.java:100)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$d61b04e.createTransaction(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:193)\n	at io.seata.rm.datasource.ConnectionProxy.commit(ConnectionProxy.java:159)\n	at io.seata.rm.datasource.ConnectionProxy.setAutoCommit(ConnectionProxy.java:221)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.executeAutoCommitTrue(AbstractDMLBaseExecutor.java:107)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.doExecute(AbstractDMLBaseExecutor.java:57)\n	at io.seata.rm.datasource.exec.BaseTransactionalExecutor.execute(BaseTransactionalExecutor.java:86)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:101)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 54 more\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2079)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2013)\n	at com.mysql.jdbc.PreparedStatement.executeLargeUpdate(PreparedStatement.java:5104)\n	at com.mysql.jdbc.PreparedStatement.executeUpdate(PreparedStatement.java:1998)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.executeUpdate(DruidPooledPreparedStatement.java:255)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLog(UndoLogManager.java:340)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLogWithNormal(UndoLogManager.java:323)\n	at io.seata.rm.datasource.undo.UndoLogManager.flushUndoLogs(UndoLogManager.java:112)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:187)\n	... 74 more\n', 'RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/pay/pay-service-impl/target/classes/mapper/PayTransactionMapper.xml]\n### The error may involve cn.iocoder.mall.pay.biz.dao.PayTransactionMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO transaction (             app_id, create_ip, order_id, order_subject,             order_description, order_memo, price, status, expire_time,             finish_time, notify_url, extension_id, pay_channel, payment_time,             notify_time, trade_no, create_time         ) VALUES (             ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?         )\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/pay/pay-service-impl/target/classes/mapper/PayTransactionMapper.xml]\n### The error may involve cn.iocoder.mall.pay.biz.dao.PayTransactionMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO transaction (             app_id, create_ip, order_id, order_subject,             order_description, order_memo, price, status, expire_time,             finish_time, notify_url, extension_id, pay_channel, payment_time,             notify_time, trade_no, create_time         ) VALUES (             ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?         )\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy113.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy121.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy122.insert(Unknown Source)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.createTransaction(PayTransactionServiceImpl.java:100)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$d61b04e.createTransaction(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:193)\n	at io.seata.rm.datasource.ConnectionProxy.commit(ConnectionProxy.java:159)\n	at io.seata.rm.datasource.ConnectionProxy.setAutoCommit(ConnectionProxy.java:221)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.executeAutoCommitTrue(AbstractDMLBaseExecutor.java:107)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.doExecute(AbstractDMLBaseExecutor.java:57)\n	at io.seata.rm.datasource.exec.BaseTransactionalExecutor.execute(BaseTransactionalExecutor.java:86)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:101)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 54 more\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2079)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2013)\n	at com.mysql.jdbc.PreparedStatement.executeLargeUpdate(PreparedStatement.java:5104)\n	at com.mysql.jdbc.PreparedStatement.executeUpdate(PreparedStatement.java:1998)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.executeUpdate(DruidPooledPreparedStatement.java:255)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLog(UndoLogManager.java:340)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLogWithNormal(UndoLogManager.java:323)\n	at io.seata.rm.datasource.undo.UndoLogManager.flushUndoLogs(UndoLogManager.java:112)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:187)\n	... 74 more\n', 'java.lang.RuntimeException: org.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/pay/pay-service-impl/target/classes/mapper/PayTransactionMapper.xml]\n### The error may involve cn.iocoder.mall.pay.biz.dao.PayTransactionMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO transaction (             app_id, create_ip, order_id, order_subject,             order_description, order_memo, price, status, expire_time,             finish_time, notify_url, extension_id, pay_channel, payment_time,             notify_time, trade_no, create_time         ) VALUES (             ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?         )\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\norg.springframework.jdbc.BadSqlGrammarException: \n### Error updating database.  Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n### The error may exist in file [/Users/yunai/Java/mall-two/pay/pay-service-impl/target/classes/mapper/PayTransactionMapper.xml]\n### The error may involve cn.iocoder.mall.pay.biz.dao.PayTransactionMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO transaction (             app_id, create_ip, order_id, order_subject,             order_description, order_memo, price, status, expire_time,             finish_time, notify_url, extension_id, pay_channel, payment_time,             notify_time, trade_no, create_time         ) VALUES (             ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?, ?, ?,             ?, ?, ?         )\n### Cause: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n; bad SQL grammar []; nested exception is java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy113.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy121.insert(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy122.insert(Unknown Source)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.createTransaction(PayTransactionServiceImpl.java:100)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$d61b04e.createTransaction(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.config.invoker.DelegateProviderMetaDataInvoker.invoke(DelegateProviderMetaDataInvoker.java:56)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.sql.SQLException: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:193)\n	at io.seata.rm.datasource.ConnectionProxy.commit(ConnectionProxy.java:159)\n	at io.seata.rm.datasource.ConnectionProxy.setAutoCommit(ConnectionProxy.java:221)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.executeAutoCommitTrue(AbstractDMLBaseExecutor.java:107)\n	at io.seata.rm.datasource.exec.AbstractDMLBaseExecutor.doExecute(AbstractDMLBaseExecutor.java:57)\n	at io.seata.rm.datasource.exec.BaseTransactionalExecutor.execute(BaseTransactionalExecutor.java:86)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:101)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 54 more\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_pay.undo_log\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2079)\n	at com.mysql.jdbc.PreparedStatement.executeUpdateInternal(PreparedStatement.java:2013)\n	at com.mysql.jdbc.PreparedStatement.executeLargeUpdate(PreparedStatement.java:5104)\n	at com.mysql.jdbc.PreparedStatement.executeUpdate(PreparedStatement.java:1998)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.executeUpdate(DruidPooledPreparedStatement.java:255)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLog(UndoLogManager.java:340)\n	at io.seata.rm.datasource.undo.UndoLogManager.insertUndoLogWithNormal(UndoLogManager.java:323)\n	at io.seata.rm.datasource.undo.UndoLogManager.flushUndoLogs(UndoLogManager.java:112)\n	at io.seata.rm.datasource.ConnectionProxy.processGlobalTransactionCommit(ConnectionProxy.java:187)\n	... 74 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:128)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-17 13:50:06');
INSERT INTO `exception_log` VALUES (363, 'a4dcc61f-b70f-4b9f-9a0a-1a851ca459ea', 0, 1, 'pay-application', '/pay-api/users/transaction/pingxx_pay_success', '', 'POST', 'Go-http-client/1.1', '120.27.254.247', '2019-05-17 13:51:21', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$d61b04e.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy126.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n', 'RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$d61b04e.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy126.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n', 'java.lang.RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$d61b04e.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy126.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [9]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy126.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-17 13:51:21');
INSERT INTO `exception_log` VALUES (364, '0ea79700-3f16-4200-9baa-81054cd21207', 0, 1, 'pay-application', '/pay-api/users/transaction/pingxx_pay_success', '', 'POST', 'Go-http-client/1.1', '120.27.254.247', '2019-05-17 14:05:19', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$3af8ab7b.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n', 'RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$3af8ab7b.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n', 'java.lang.RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$3af8ab7b.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [22]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-17 14:05:19');
INSERT INTO `exception_log` VALUES (365, 'db9b12b2-6fb7-45a5-997b-0026ffc053c4', 0, 1, 'pay-application', '/pay-api/users/transaction/pingxx_pay_success', '', 'POST', 'Go-http-client/1.1', '116.62.75.199', '2019-05-17 14:05:22', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$3af8ab7b.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n', 'RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$3af8ab7b.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n', 'java.lang.RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$3af8ab7b.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [4]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-17 14:05:22');
INSERT INTO `exception_log` VALUES (366, 'd01cfeb1-28de-409f-8a37-4b9d6ac3c84f', 0, 1, 'pay-application', '/pay-api/users/transaction/pingxx_pay_success', '', 'POST', 'Go-http-client/1.1', '116.62.75.199', '2019-05-17 14:05:39', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$3af8ab7b.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n', 'RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$3af8ab7b.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n', 'java.lang.RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$3af8ab7b.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [5]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-17 14:05:39');
INSERT INTO `exception_log` VALUES (367, '31.47.15580733049070015', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=&code=', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '125.77.84.30', '2019-05-17 14:08:25', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy93.selectByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy95.selectByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.getUser(UserServiceImpl.java:41)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$338719e3.getUser(<generated>)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:58)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAccessToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln(PassportController.java:52)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$CJXxcoww.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 14:08:25');
INSERT INTO `exception_log` VALUES (368, '0b48b308-8df6-4160-8edf-eba6798b890b', 0, 1, 'pay-application', '/pay-api/users/transaction/pingxx_pay_success', '', 'POST', 'Go-http-client/1.1', '116.62.75.199', '2019-05-17 14:11:19', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$1b71286.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n', 'RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$1b71286.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n', 'java.lang.RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$1b71286.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-17 14:11:19');
INSERT INTO `exception_log` VALUES (369, 'bf0c486a-ef00-4ff2-b11a-2e47d7afb2a2', 0, 1, 'pay-application', '/pay-api/users/transaction/pingxx_pay_success', '', 'POST', 'Go-http-client/1.1', '120.27.254.247', '2019-05-17 14:11:37', 'java.lang.RuntimeException', 'RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$1b71286.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n', 'RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$1b71286.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n', 'java.lang.RuntimeException: org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\norg.springframework.messaging.MessagingException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.sendNotifyMessage(PayNotifyServiceImpl.java:64)\n	at cn.iocoder.mall.pay.biz.service.PayNotifyServiceImpl.addTransactionNotifyTask(PayNotifyServiceImpl.java:50)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.updateTransactionPaySuccess(PayTransactionServiceImpl.java:195)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$1b71286.updateTransactionPaySuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.invoke(DubboExceptionFilter.java:37)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [6]ms, Topic: PAY_TRANSACTION_SUCCESS, BrokersSent: [broker-a, broker-a, broker-a]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 134 more\nCaused by: org.apache.rocketmq.client.exception.MQBrokerException: CODE: 14  DESC: service not available now, maybe disk full, CL:  0.93 CQ:  0.93 INDEX:  0.93, maybe your broker machine memory too small.\nFor more information, please visit the url, http://rocketmq.apache.org/docs/faq/\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.processSendResponse(MQClientAPIImpl.java:556)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:358)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 137 more\n\n	at cn.iocoder.common.framework.dubbo.DubboExceptionFilter.onResponse(DubboExceptionFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:79)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.updateTransactionPaySuccess(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy127.updateTransactionPaySuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.pingxxPaySuccess(UsersPayTransactionController.java:66)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'cn.iocoder.common.framework.dubbo.DubboExceptionFilter', 'DubboExceptionFilter.java', 'onResponse', 93, '2019-05-17 14:11:37');
INSERT INTO `exception_log` VALUES (370, '0188beb2-e7ee-4db3-82c7-fb6836a79b02', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=undefined', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:38', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException', 'MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"undefined\"', 'NumberFormatException: For input string: \"undefined\"', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"undefined\"\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:132)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.lang.NumberFormatException: For input string: \"undefined\"\n	at java.lang.NumberFormatException.forInputString(NumberFormatException.java:65)\n	at java.lang.Integer.parseInt(Integer.java:580)\n	at java.lang.Integer.valueOf(Integer.java:766)\n	at org.springframework.util.NumberUtils.parseNumber(NumberUtils.java:211)\n	at org.springframework.beans.propertyeditors.CustomNumberEditor.setAsText(CustomNumberEditor.java:115)\n	at org.springframework.beans.TypeConverterDelegate.doConvertTextValue(TypeConverterDelegate.java:429)\n	at org.springframework.beans.TypeConverterDelegate.doConvertValue(TypeConverterDelegate.java:402)\n	at org.springframework.beans.TypeConverterDelegate.convertIfNecessary(TypeConverterDelegate.java:155)\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:73)\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:53)\n	at org.springframework.validation.DataBinder.convertIfNecessary(DataBinder.java:693)\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:124)\n	... 57 more\n', 'org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver', 'AbstractNamedValueMethodArgumentResolver.java', 'resolveArgument', 132, '2019-05-17 17:47:38');
INSERT INTO `exception_log` VALUES (371, 'c0a16918-6146-4cff-bb7d-51ba194c6e56', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=undefined', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:42', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException', 'MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"undefined\"', 'NumberFormatException: For input string: \"undefined\"', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"undefined\"\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:132)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.lang.NumberFormatException: For input string: \"undefined\"\n	at java.lang.NumberFormatException.forInputString(NumberFormatException.java:65)\n	at java.lang.Integer.parseInt(Integer.java:580)\n	at java.lang.Integer.valueOf(Integer.java:766)\n	at org.springframework.util.NumberUtils.parseNumber(NumberUtils.java:211)\n	at org.springframework.beans.propertyeditors.CustomNumberEditor.setAsText(CustomNumberEditor.java:115)\n	at org.springframework.beans.TypeConverterDelegate.doConvertTextValue(TypeConverterDelegate.java:429)\n	at org.springframework.beans.TypeConverterDelegate.doConvertValue(TypeConverterDelegate.java:402)\n	at org.springframework.beans.TypeConverterDelegate.convertIfNecessary(TypeConverterDelegate.java:155)\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:73)\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:53)\n	at org.springframework.validation.DataBinder.convertIfNecessary(DataBinder.java:693)\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:124)\n	... 57 more\n', 'org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver', 'AbstractNamedValueMethodArgumentResolver.java', 'resolveArgument', 132, '2019-05-17 17:47:42');
INSERT INTO `exception_log` VALUES (372, '48d9db0a-715a-4605-94c1-f7205de80e70', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=undefined', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:47:50', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException', 'MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"undefined\"', 'NumberFormatException: For input string: \"undefined\"', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"undefined\"\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:132)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\nCaused by: java.lang.NumberFormatException: For input string: \"undefined\"\n	at java.lang.NumberFormatException.forInputString(NumberFormatException.java:65)\n	at java.lang.Integer.parseInt(Integer.java:580)\n	at java.lang.Integer.valueOf(Integer.java:766)\n	at org.springframework.util.NumberUtils.parseNumber(NumberUtils.java:211)\n	at org.springframework.beans.propertyeditors.CustomNumberEditor.setAsText(CustomNumberEditor.java:115)\n	at org.springframework.beans.TypeConverterDelegate.doConvertTextValue(TypeConverterDelegate.java:429)\n	at org.springframework.beans.TypeConverterDelegate.doConvertValue(TypeConverterDelegate.java:402)\n	at org.springframework.beans.TypeConverterDelegate.convertIfNecessary(TypeConverterDelegate.java:155)\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:73)\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:53)\n	at org.springframework.validation.DataBinder.convertIfNecessary(DataBinder.java:693)\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:124)\n	... 57 more\n', 'org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver', 'AbstractNamedValueMethodArgumentResolver.java', 'resolveArgument', 132, '2019-05-17 17:47:50');
INSERT INTO `exception_log` VALUES (373, '9f6d73b1-2074-40a9-8065-248852b77083', 73, 1, 'user-application', '/user-api/users/address/add', 'name=你猜&tel=15601691388&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=你猜&isDefault=false&address=你猜&areaNo=110101&mobile=15601691388&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:50:16', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [你猜]; codes [Size.userAddressAddPO.address,Size.address,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [你猜]; codes [Size.userAddressAddPO.address,Size.address,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [你猜]; codes [Size.userAddressAddPO.address,Size.address,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-17 17:50:16');
INSERT INTO `exception_log` VALUES (374, '7d60ac54-84ee-48cc-bb29-5378b349a5df', 73, 1, 'user-application', '/user-api/users/address/add', 'name=芋道源码&tel=15601691388&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=你猜&isDefault=false&address=你猜&areaNo=110101&mobile=15601691388&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:52:05', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [你猜]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [你猜]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [你猜]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-17 17:52:05');
INSERT INTO `exception_log` VALUES (375, '71b9724c-799c-4678-a4d5-799c46a0e574', 73, 1, 'user-application', '/user-api/users/address/add', 'name=芋道源码&tel=15601691388&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=你猜&isDefault=false&address=你猜&areaNo=110101&mobile=15601691388&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:53:26', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [你猜]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [你猜]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [你猜]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-17 17:53:26');
INSERT INTO `exception_log` VALUES (376, '3f2494ff-f54e-466b-a1bf-16c47bf69ec6', 73, 1, 'user-application', '/user-api/users/address/add', 'name=芋道源码&tel=15601691388&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=你猜&isDefault=false&address=你猜&areaNo=110101&mobile=15601691388&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-05-17 17:54:34', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [你猜]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [你猜]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [你猜]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:745)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-17 17:54:34');
INSERT INTO `exception_log` VALUES (377, '31.51.15580915003470017', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17765823217&code=9999', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '122.224.234.14', '2019-05-17 19:11:40', 'org.apache.ibatis.binding.BindingException', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile', 'org.apache.ibatis.binding.BindingException: Invalid bound statement (not found): cn.iocoder.mall.user.biz.dao.UserMapper.selectByMobile\n	at org.apache.ibatis.binding.MapperMethod$SqlCommand.<init>(MapperMethod.java:235)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.<init>(MybatisMapperMethod.java:49)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.lambda$cachedMapperMethod$0(MybatisMapperProxy.java:66)\n	at java.util.concurrent.ConcurrentHashMap.computeIfAbsent(ConcurrentHashMap.java:1660)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.cachedMapperMethod(MybatisMapperProxy.java:66)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:61)\n	at com.sun.proxy.$Proxy93.selectByMobile(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy95.selectByMobile(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl.getUser(UserServiceImpl.java:41)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$FastClassBySpringCGLIB$$4800153b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$338719e3.getUser(<generated>)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl.getAccessToken(OAuth2ServiceImpl.java:58)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$6aa5926b.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.user.biz.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$89774f73.getAccessToken(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper2.invokeMethod(Wrapper2.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ch6pPm8B$accessor$fVcQxp6G(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$NvkKfWna.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAccessToken(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy104.getAccessToken(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln(PassportController.java:52)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister$original$SRU2CEln$accessor$6y05qonW(PassportController.java)\n	at cn.iocoder.mall.user.application.controller.users.PassportController$auxiliary$CJXxcoww.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$2kF6NRfV$accessor$5SxoU2mc(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$wsjWq7ez.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.apache.ibatis.binding.MapperMethod$SqlCommand', 'MapperMethod.java', '<init>', 235, '2019-05-17 19:11:40');
INSERT INTO `exception_log` VALUES (378, '42.73.15581005407690001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:42:27', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=6047&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557922357464&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100331612&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.906, end time: 2019-05-17 21:42:25.923, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=13, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.906, end time: 2019-05-17 21:42:25.923, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=13, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=6047&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557922357464&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100331612&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.906, end time: 2019-05-17 21:42:25.923, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=13, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG$accessor$QEpI7Bhx(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eENbetSH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.906, end time: 2019-05-17 21:42:25.923, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=13, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$3qRY2N9j(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$3qRY2N9j$accessor$B2fRNyvW(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$GhF2PxeY.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:42:33');
INSERT INTO `exception_log` VALUES (379, '42.74.15581005407690001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:42:27', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=6047&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557402118852&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100331612&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.934, end time: 2019-05-17 21:42:25.953, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=14, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.934, end time: 2019-05-17 21:42:25.953, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=14, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=6047&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557402118852&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100331612&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.934, end time: 2019-05-17 21:42:25.953, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=14, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG$accessor$QEpI7Bhx(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eENbetSH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.934, end time: 2019-05-17 21:42:25.953, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=14, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$3qRY2N9j(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$3qRY2N9j$accessor$B2fRNyvW(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$GhF2PxeY.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:42:33');
INSERT INTO `exception_log` VALUES (380, '42.73.15581005407690001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:42:27', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=6047&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557922357464&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100331612&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.906, end time: 2019-05-17 21:42:25.923, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=13, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.906, end time: 2019-05-17 21:42:25.923, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=13, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=6047&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557922357464&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100331612&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.906, end time: 2019-05-17 21:42:25.923, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=13, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG$accessor$QEpI7Bhx(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eENbetSH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.906, end time: 2019-05-17 21:42:25.923, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=13, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$3qRY2N9j(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$3qRY2N9j$accessor$B2fRNyvW(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$GhF2PxeY.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:42:33');
INSERT INTO `exception_log` VALUES (381, '42.74.15581005407690001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:42:27', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=6047&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557402118852&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100331612&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.934, end time: 2019-05-17 21:42:25.953, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=14, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.934, end time: 2019-05-17 21:42:25.953, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=14, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=6047&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557402118852&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100331612&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.934, end time: 2019-05-17 21:42:25.953, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=14, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG$accessor$QEpI7Bhx(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eENbetSH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.934, end time: 2019-05-17 21:42:25.953, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=14, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$3qRY2N9j(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$3qRY2N9j$accessor$B2fRNyvW(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$GhF2PxeY.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:42:33');
INSERT INTO `exception_log` VALUES (382, '42.73.15581005407690001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:42:27', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=6047&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557922357464&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100331612&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.906, end time: 2019-05-17 21:42:25.923, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=13, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.906, end time: 2019-05-17 21:42:25.923, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=13, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=6047&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557922357464&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100331612&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.906, end time: 2019-05-17 21:42:25.923, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=13, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG$accessor$QEpI7Bhx(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eENbetSH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.906, end time: 2019-05-17 21:42:25.923, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=13, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzMuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$3qRY2N9j(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$3qRY2N9j$accessor$B2fRNyvW(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$GhF2PxeY.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:42:32');
INSERT INTO `exception_log` VALUES (383, '42.74.15581005407690001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:42:27', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=6047&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557402118852&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100331612&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.934, end time: 2019-05-17 21:42:25.953, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=14, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.934, end time: 2019-05-17 21:42:25.953, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=14, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=6047&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557402118852&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100331612&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.934, end time: 2019-05-17 21:42:25.953, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=14, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG$accessor$QEpI7Bhx(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eENbetSH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:42:24.934, end time: 2019-05-17 21:42:25.953, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=14, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=57fade0d2ec649a4bb157ec72e29d6fc, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDE=-NDIuNzQuMTU1ODEwMDU0MDc2OTAwMDA=-3-42-42-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:35390 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$3qRY2N9j(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$3qRY2N9j$accessor$B2fRNyvW(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$GhF2PxeY.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:42:33');
INSERT INTO `exception_log` VALUES (384, '42.75.15581007983930001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:46:40', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy5', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\n	at com.sun.proxy.$Proxy107.getBannerListByStatus(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list$original$gZHdxNO8(UsersBannerController.java:31)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list$original$gZHdxNO8$accessor$TzEThW1l(UsersBannerController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController$auxiliary$DtKd3HwP.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG$accessor$QEpI7Bhx(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eENbetSH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\n	... 83 more\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy5\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\n	at javassist.compiler.Javac.compile(Javac.java:95)\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\n	... 85 more\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-05-17 21:46:40');
INSERT INTO `exception_log` VALUES (385, '42.77.15581008066230001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:46:47', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy107.getBannerListByStatus(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list$original$gZHdxNO8(UsersBannerController.java:31)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list$original$gZHdxNO8$accessor$TzEThW1l(UsersBannerController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController$auxiliary$DtKd3HwP.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG$accessor$QEpI7Bhx(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eENbetSH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-17 21:46:47');
INSERT INTO `exception_log` VALUES (386, '42.79.15581008123080001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:46:52', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy107.getBannerListByStatus(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list$original$gZHdxNO8(UsersBannerController.java:31)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list$original$gZHdxNO8$accessor$TzEThW1l(UsersBannerController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController$auxiliary$DtKd3HwP.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG$accessor$QEpI7Bhx(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eENbetSH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-17 21:46:52');
INSERT INTO `exception_log` VALUES (387, '42.72.15581008339720003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:47:14', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy107.getBannerListByStatus(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list$original$gZHdxNO8(UsersBannerController.java:31)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list$original$gZHdxNO8$accessor$TzEThW1l(UsersBannerController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController$auxiliary$DtKd3HwP.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG$accessor$QEpI7Bhx(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eENbetSH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-17 21:47:14');
INSERT INTO `exception_log` VALUES (388, '42.73.15581009363820003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-17 21:48:57', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy107.getBannerListByStatus(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list$original$gZHdxNO8(UsersBannerController.java:31)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list$original$gZHdxNO8$accessor$TzEThW1l(UsersBannerController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController$auxiliary$DtKd3HwP.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$BmdIotkG$accessor$QEpI7Bhx(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eENbetSH.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-17 21:48:57');
INSERT INTO `exception_log` VALUES (389, '45.80.15581011142400001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:51:57', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557383125237&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-17 21:51:56.290, end time: 2019-05-17 21:51:57.291, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=26, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuODAuMTU1ODEwMTExNDI0MDAwMDE=-NDUuODAuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-17 21:51:56.290, end time: 2019-05-17 21:51:57.291, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=26, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuODAuMTU1ODEwMTExNDI0MDAwMDE=-NDUuODAuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557383125237&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-17 21:51:56.290, end time: 2019-05-17 21:51:57.291, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=26, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuODAuMTU1ODEwMTExNDI0MDAwMDE=-NDUuODAuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-17 21:51:56.290, end time: 2019-05-17 21:51:57.291, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=26, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuODAuMTU1ODEwMTExNDI0MDAwMDE=-NDUuODAuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:52:06');
INSERT INTO `exception_log` VALUES (390, '45.80.15581011142400001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:51:57', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557383125237&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-17 21:51:56.290, end time: 2019-05-17 21:51:57.291, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=26, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuODAuMTU1ODEwMTExNDI0MDAwMDE=-NDUuODAuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-17 21:51:56.290, end time: 2019-05-17 21:51:57.291, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=26, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuODAuMTU1ODEwMTExNDI0MDAwMDE=-NDUuODAuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557383125237&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-17 21:51:56.290, end time: 2019-05-17 21:51:57.291, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=26, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuODAuMTU1ODEwMTExNDI0MDAwMDE=-NDUuODAuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-17 21:51:56.290, end time: 2019-05-17 21:51:57.291, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=26, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuODAuMTU1ODEwMTExNDI0MDAwMDE=-NDUuODAuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:52:07');
INSERT INTO `exception_log` VALUES (391, '45.79.15581011142400001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:51:57', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760068744&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:51:56.314, end time: 2019-05-17 21:51:57.332, client elapsed: 1 ms, server elapsed: 1017 ms, timeout: 1000 ms, request: Request [id=27, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDE=-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:51:56.314, end time: 2019-05-17 21:51:57.332, client elapsed: 1 ms, server elapsed: 1017 ms, timeout: 1000 ms, request: Request [id=27, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDE=-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760068744&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:51:56.314, end time: 2019-05-17 21:51:57.332, client elapsed: 1 ms, server elapsed: 1017 ms, timeout: 1000 ms, request: Request [id=27, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDE=-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:51:56.314, end time: 2019-05-17 21:51:57.332, client elapsed: 1 ms, server elapsed: 1017 ms, timeout: 1000 ms, request: Request [id=27, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDE=-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:52:06');
INSERT INTO `exception_log` VALUES (392, '45.80.15581011142400001', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:51:57', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557383125237&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-17 21:51:56.290, end time: 2019-05-17 21:51:57.291, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=26, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuODAuMTU1ODEwMTExNDI0MDAwMDE=-NDUuODAuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-05-17 21:51:56.290, end time: 2019-05-17 21:51:57.291, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=26, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuODAuMTU1ODEwMTExNDI0MDAwMDE=-NDUuODAuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557383125237&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-05-17 21:51:56.290, end time: 2019-05-17 21:51:57.291, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=26, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuODAuMTU1ODEwMTExNDI0MDAwMDE=-NDUuODAuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-05-17 21:51:56.290, end time: 2019-05-17 21:51:57.291, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=26, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuODAuMTU1ODEwMTExNDI0MDAwMDE=-NDUuODAuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:52:07');
INSERT INTO `exception_log` VALUES (393, '45.79.15581011142400001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:51:57', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760068744&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:51:56.314, end time: 2019-05-17 21:51:57.332, client elapsed: 1 ms, server elapsed: 1017 ms, timeout: 1000 ms, request: Request [id=27, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDE=-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:51:56.314, end time: 2019-05-17 21:51:57.332, client elapsed: 1 ms, server elapsed: 1017 ms, timeout: 1000 ms, request: Request [id=27, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDE=-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760068744&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:51:56.314, end time: 2019-05-17 21:51:57.332, client elapsed: 1 ms, server elapsed: 1017 ms, timeout: 1000 ms, request: Request [id=27, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDE=-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:51:56.314, end time: 2019-05-17 21:51:57.332, client elapsed: 1 ms, server elapsed: 1017 ms, timeout: 1000 ms, request: Request [id=27, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDE=-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:52:07');
INSERT INTO `exception_log` VALUES (394, '45.72.15581011208460003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:04', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426643&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.903, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=39, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDM=-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.903, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=39, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDM=-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426643&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.903, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=39, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDM=-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.903, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=39, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDM=-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:52:07');
INSERT INTO `exception_log` VALUES (395, '44.79.15581011222070003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:07', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=7462&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760068744&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100700601&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:04.315, end time: 2019-05-17 21:52:05.332, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=23, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDM=-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDI=-3-44-44-NQ==-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:36146 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:04.315, end time: 2019-05-17 21:52:05.332, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=23, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDM=-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDI=-3-44-44-NQ==-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:36146 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=7462&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760068744&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100700601&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:04.315, end time: 2019-05-17 21:52:05.332, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=23, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDM=-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDI=-3-44-44-NQ==-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:36146 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getAuthentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy139.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$s85cL8zb(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$s85cL8zb$accessor$AqJ0xflq(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$c3ztt3lS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:04.315, end time: 2019-05-17 21:52:05.332, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=23, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDM=-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDI=-3-44-44-NQ==-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:36146 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$Of4zJkas(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$Of4zJkas$accessor$cGWO94DP(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$Pr0FdOFZ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 72 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:52:07');
INSERT INTO `exception_log` VALUES (396, '45.79.15581011142400001', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:51:57', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760068744&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:51:56.314, end time: 2019-05-17 21:51:57.332, client elapsed: 1 ms, server elapsed: 1017 ms, timeout: 1000 ms, request: Request [id=27, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDE=-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:51:56.314, end time: 2019-05-17 21:51:57.332, client elapsed: 1 ms, server elapsed: 1017 ms, timeout: 1000 ms, request: Request [id=27, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDE=-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760068744&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:51:56.314, end time: 2019-05-17 21:51:57.332, client elapsed: 1 ms, server elapsed: 1017 ms, timeout: 1000 ms, request: Request [id=27, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDE=-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:51:56.314, end time: 2019-05-17 21:51:57.332, client elapsed: 1 ms, server elapsed: 1017 ms, timeout: 1000 ms, request: Request [id=27, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDE=-NDUuNzkuMTU1ODEwMTExNDI0MDAwMDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:52:07');
INSERT INTO `exception_log` VALUES (397, '45.71.15581011208420003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:04', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426643&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.902, client elapsed: 0 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=38, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDM=-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.902, client elapsed: 0 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=38, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDM=-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426643&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.902, client elapsed: 0 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=38, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDM=-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.902, client elapsed: 0 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=38, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDM=-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:52:07');
INSERT INTO `exception_log` VALUES (398, '45.72.15581011208460003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:04', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426643&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.903, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=39, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDM=-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.903, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=39, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDM=-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426643&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.903, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=39, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDM=-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.903, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=39, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDM=-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:52:07');
INSERT INTO `exception_log` VALUES (399, '45.71.15581011208420003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:04', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426643&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.902, client elapsed: 0 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=38, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDM=-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.902, client elapsed: 0 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=38, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDM=-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426643&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.902, client elapsed: 0 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=38, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDM=-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.902, client elapsed: 0 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=38, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDM=-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:52:07');
INSERT INTO `exception_log` VALUES (400, '45.72.15581011208460003', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:04', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426643&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.903, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=39, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDM=-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.903, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=39, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDM=-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426643&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.903, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=39, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDM=-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.903, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=39, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDM=-NDUuNzIuMTU1ODEwMTEyMDg0NjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL3Byb2R1Y3RfcmVjb21tZW5kL2xpc3Q=, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:52:08');
INSERT INTO `exception_log` VALUES (401, '45.71.15581011208420003', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:04', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426643&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.902, client elapsed: 0 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=38, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDM=-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.902, client elapsed: 0 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=38, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDM=-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426643&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.902, client elapsed: 0 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=38, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDM=-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:02.884, end time: 2019-05-17 21:52:03.902, client elapsed: 0 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=38, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDM=-NDUuNzEuMTU1ODEwMTEyMDg0MjAwMDI=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0-Iy9wcm9tb3Rpb24tYXBpL3VzZXJzL2Jhbm5lci9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 66 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:52:08');
INSERT INTO `exception_log` VALUES (402, '44.79.15581011222070003', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:52:07', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=7462&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760068744&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100700601&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:04.315, end time: 2019-05-17 21:52:05.332, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=23, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDM=-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDI=-3-44-44-NQ==-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:36146 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:04.315, end time: 2019-05-17 21:52:05.332, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=23, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDM=-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDI=-3-44-44-NQ==-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:36146 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=7462&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760068744&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558100700601&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:04.315, end time: 2019-05-17 21:52:05.332, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=23, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDM=-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDI=-3-44-44-NQ==-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:36146 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getAuthentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy139.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$s85cL8zb(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$s85cL8zb$accessor$AqJ0xflq(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$c3ztt3lS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-17 21:52:04.315, end time: 2019-05-17 21:52:05.332, client elapsed: 1 ms, server elapsed: 1016 ms, timeout: 1000 ms, request: Request [id=23, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=958f91bc96874f69aa61523a1f38ba17, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDM=-NDQuNzkuMTU1ODEwMTEyMjIwNzAwMDI=-3-44-44-NQ==-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0-Iy9wcm9kdWN0LWFwaS91c2Vycy9jYXRlZ29yeS9saXN0, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:36146 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$Of4zJkas(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$Of4zJkas$accessor$cGWO94DP(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$Pr0FdOFZ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 72 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-17 21:52:08');
INSERT INTO `exception_log` VALUES (403, '44.83.15581012150450009', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=undefined', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:35', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException', 'MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"undefined\"', 'NumberFormatException: For input string: \"undefined\"', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"undefined\"\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:132)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$s85cL8zb(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$s85cL8zb$accessor$AqJ0xflq(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$c3ztt3lS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.lang.NumberFormatException: For input string: \"undefined\"\n	at java.lang.NumberFormatException.forInputString(NumberFormatException.java:65)\n	at java.lang.Integer.parseInt(Integer.java:580)\n	at java.lang.Integer.valueOf(Integer.java:766)\n	at org.springframework.util.NumberUtils.parseNumber(NumberUtils.java:211)\n	at org.springframework.beans.propertyeditors.CustomNumberEditor.setAsText(CustomNumberEditor.java:115)\n	at org.springframework.beans.TypeConverterDelegate.doConvertTextValue(TypeConverterDelegate.java:429)\n	at org.springframework.beans.TypeConverterDelegate.doConvertValue(TypeConverterDelegate.java:402)\n	at org.springframework.beans.TypeConverterDelegate.convertIfNecessary(TypeConverterDelegate.java:155)\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:73)\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:53)\n	at org.springframework.validation.DataBinder.convertIfNecessary(DataBinder.java:693)\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:124)\n	... 67 more\n', 'org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver', 'AbstractNamedValueMethodArgumentResolver.java', 'resolveArgument', 132, '2019-05-17 21:53:35');
INSERT INTO `exception_log` VALUES (404, '39.52.15581012149650005', 74, 1, 'user-application', '/user-api/users/address/add', 'name=test&tel=13100000000&country=&province=浙江省&city=杭州市&county=萧山区&areaCode=330109&postalCode=&addressDetail=123&isDefault=false&address=123&areaNo=330109&mobile=13100000000&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:36', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$Fr7trRph(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$Fr7trRph$accessor$ZmnVzqCZ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$lBV6AXE9.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-17 21:53:36');
INSERT INTO `exception_log` VALUES (405, '39.57.15581012165900005', 74, 1, 'user-application', '/user-api/users/address/add', 'name=test&tel=13100000000&country=&province=浙江省&city=杭州市&county=萧山区&areaCode=330109&postalCode=&addressDetail=123&isDefault=false&address=123&areaNo=330109&mobile=13100000000&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:37', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$Fr7trRph(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$Fr7trRph$accessor$ZmnVzqCZ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$lBV6AXE9.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-17 21:53:37');
INSERT INTO `exception_log` VALUES (406, '39.56.15581012198900005', 74, 1, 'user-application', '/user-api/users/address/add', 'name=test&tel=13100000000&country=&province=浙江省&city=杭州市&county=萧山区&areaCode=330109&postalCode=&addressDetail=123&isDefault=false&address=123&areaNo=330109&mobile=13100000000&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:40', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$Fr7trRph(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$Fr7trRph$accessor$ZmnVzqCZ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$lBV6AXE9.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-17 21:53:40');
INSERT INTO `exception_log` VALUES (407, '44.82.15581012220680009', 1, 1, 'product-application', '/product-api/users/spu/info', 'id=undefined', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '124.77.208.137', '2019-05-17 21:53:42', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException', 'MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"undefined\"', 'NumberFormatException: For input string: \"undefined\"', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"undefined\"\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:132)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$s85cL8zb(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$s85cL8zb$accessor$AqJ0xflq(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$c3ztt3lS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.lang.NumberFormatException: For input string: \"undefined\"\n	at java.lang.NumberFormatException.forInputString(NumberFormatException.java:65)\n	at java.lang.Integer.parseInt(Integer.java:580)\n	at java.lang.Integer.valueOf(Integer.java:766)\n	at org.springframework.util.NumberUtils.parseNumber(NumberUtils.java:211)\n	at org.springframework.beans.propertyeditors.CustomNumberEditor.setAsText(CustomNumberEditor.java:115)\n	at org.springframework.beans.TypeConverterDelegate.doConvertTextValue(TypeConverterDelegate.java:429)\n	at org.springframework.beans.TypeConverterDelegate.doConvertValue(TypeConverterDelegate.java:402)\n	at org.springframework.beans.TypeConverterDelegate.convertIfNecessary(TypeConverterDelegate.java:155)\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:73)\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:53)\n	at org.springframework.validation.DataBinder.convertIfNecessary(DataBinder.java:693)\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:124)\n	... 67 more\n', 'org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver', 'AbstractNamedValueMethodArgumentResolver.java', 'resolveArgument', 132, '2019-05-17 21:53:42');
INSERT INTO `exception_log` VALUES (408, '39.55.15581012227770005', 74, 1, 'user-application', '/user-api/users/address/add', 'name=test&tel=13100000000&country=&province=浙江省&city=杭州市&county=萧山区&areaCode=330109&postalCode=&addressDetail=123&isDefault=true&address=123&areaNo=330109&mobile=13100000000&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A5010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044611 Mobile Safari/537.36 MMWEBID/5321 MicroMessenger/7.0.4.1420(0x2700043A) Process/tools NetType/WIFI Language/zh_CN', '125.118.196.50', '2019-05-17 21:53:43', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$Fr7trRph(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$Fr7trRph$accessor$ZmnVzqCZ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$lBV6AXE9.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-17 21:53:43');
INSERT INTO `exception_log` VALUES (409, '41.88.15581824143060019', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:27:00', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method createTransaction in the service cn.iocoder.mall.pay.api.PayTransactionService. Tried 3 times of the providers [127.0.0.1:20884, 127.0.0.1:20883] (2/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: createTransaction, provider: dubbo://127.0.0.1:20883/cn.iocoder.mall.pay.api.PayTransactionService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.pay.api.PayTransactionService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.pay.api.PayTransactionService&lazy=false&methods=getTransactionPage,getTransactionList,cancelTransaction,updateTransactionPaySuccess,submitTransaction,createTransaction,getTransaction&pid=5082&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=pay-service&remote.timestamp=1557327509746&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558099806868&validation=true&version=1.0.0, cause: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=741, dubbo=2.0.2, version=1.0.0}]', 'RemotingException: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=741, dubbo=2.0.2, version=1.0.0}]', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method createTransaction in the service cn.iocoder.mall.pay.api.PayTransactionService. Tried 3 times of the providers [127.0.0.1:20884, 127.0.0.1:20883] (2/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: createTransaction, provider: dubbo://127.0.0.1:20883/cn.iocoder.mall.pay.api.PayTransactionService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.pay.api.PayTransactionService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.pay.api.PayTransactionService&lazy=false&methods=getTransactionPage,getTransactionList,cancelTransaction,updateTransactionPaySuccess,submitTransaction,createTransaction,getTransaction&pid=5082&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=pay-service&remote.timestamp=1557327509746&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558099806868&validation=true&version=1.0.0, cause: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=741, dubbo=2.0.2, version=1.0.0}]\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.createTransaction(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy156.createTransaction(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createPayTransaction(OrderServiceImpl.java:362)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:328)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$58ca941d.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper13.invokeMethod(Wrapper13.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CMozWu3T(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CMozWu3T$accessor$xCibRy9H(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$dFM3iSWT.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CMozWu3T(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CMozWu3T$accessor$xCibRy9H(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$dFM3iSWT.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy157.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder$original$EQEhrbpp(OrderController.java:77)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder$original$EQEhrbpp$accessor$etoDA93e(OrderController.java)\n	at cn.iocoder.mall.order.application.controller.users.OrderController$auxiliary$bZHFHimk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$TvP6xzhv(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$TvP6xzhv$accessor$IcXOMVr5(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$CuXZROWq.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.RemotingException: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=741, dubbo=2.0.2, version=1.0.0}]\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:297)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CMozWu3T(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CMozWu3T$accessor$xCibRy9H(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$dFM3iSWT.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 157 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-18 20:27:00');
INSERT INTO `exception_log` VALUES (410, '41.89.15581824247880021', 1, 1, 'order-application', '/order-api/users/order/create_order', '', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '124.77.208.137', '2019-05-18 20:27:06', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method createTransaction in the service cn.iocoder.mall.pay.api.PayTransactionService. Tried 3 times of the providers [127.0.0.1:20884] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: createTransaction, provider: dubbo://127.0.0.1:20884/cn.iocoder.mall.pay.api.PayTransactionService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.pay.api.PayTransactionService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.pay.api.PayTransactionService&lazy=false&methods=getTransactionPage,getTransactionList,cancelTransaction,updateTransactionPaySuccess,submitTransaction,createTransaction,getTransaction&pid=5082&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=pay-service&remote.timestamp=1557404253386&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558099806868&validation=true&version=1.0.0, cause: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=741, dubbo=2.0.2, version=1.0.0}]', 'RemotingException: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=741, dubbo=2.0.2, version=1.0.0}]', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method createTransaction in the service cn.iocoder.mall.pay.api.PayTransactionService. Tried 3 times of the providers [127.0.0.1:20884] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: createTransaction, provider: dubbo://127.0.0.1:20884/cn.iocoder.mall.pay.api.PayTransactionService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.pay.api.PayTransactionService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.pay.api.PayTransactionService&lazy=false&methods=getTransactionPage,getTransactionList,cancelTransaction,updateTransactionPaySuccess,submitTransaction,createTransaction,getTransaction&pid=5082&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=pay-service&remote.timestamp=1557404253386&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558099806868&validation=true&version=1.0.0, cause: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=741, dubbo=2.0.2, version=1.0.0}]\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.createTransaction(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy156.createTransaction(Unknown Source)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createPayTransaction(OrderServiceImpl.java:362)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl.createOrder(OrderServiceImpl.java:328)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$FastClassBySpringCGLIB$$b7a8f603.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor$2.execute(GlobalTransactionalInterceptor.java:109)\n	at io.seata.tm.api.TransactionalTemplate.execute(TransactionalTemplate.java:64)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.handleGlobalTransaction(GlobalTransactionalInterceptor.java:106)\n	at io.seata.spring.annotation.GlobalTransactionalInterceptor.invoke(GlobalTransactionalInterceptor.java:78)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.order.biz.service.OrderServiceImpl$$EnhancerBySpringCGLIB$$58ca941d.createOrder(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper13.invokeMethod(Wrapper13.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CMozWu3T(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CMozWu3T$accessor$xCibRy9H(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$dFM3iSWT.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CMozWu3T(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CMozWu3T$accessor$xCibRy9H(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$dFM3iSWT.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy11.createOrder(proxy11.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy157.createOrder(Unknown Source)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder$original$EQEhrbpp(OrderController.java:77)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder$original$EQEhrbpp$accessor$etoDA93e(OrderController.java)\n	at cn.iocoder.mall.order.application.controller.users.OrderController$auxiliary$bZHFHimk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.order.application.controller.users.OrderController.createOrder(OrderController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$TvP6xzhv(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$TvP6xzhv$accessor$IcXOMVr5(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$CuXZROWq.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.RemotingException: Fail to decode request due to: RpcInvocation [methodName=createTransaction, parameterTypes=null, arguments=null, attachments={path=cn.iocoder.mall.pay.api.PayTransactionService, input=741, dubbo=2.0.2, version=1.0.0}]\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:297)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CMozWu3T(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$CMozWu3T$accessor$xCibRy9H(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$dFM3iSWT.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 157 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-18 20:27:06');
INSERT INTO `exception_log` VALUES (411, '45.71.15583313829200041', 0, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '106.120.198.2', '2019-05-20 13:49:46', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557382230870&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-20 13:49:44.943, end time: 2019-05-20 13:49:45.962, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=11955, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=17a1e437f514459c963c87b0f12a00f7, userType=2)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDE=-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-20 13:49:44.943, end time: 2019-05-20 13:49:45.962, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=11955, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=17a1e437f514459c963c87b0f12a00f7, userType=2)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDE=-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557382230870&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-20 13:49:44.943, end time: 2019-05-20 13:49:45.962, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=11955, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=17a1e437f514459c963c87b0f12a00f7, userType=2)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDE=-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor331.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:64)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-20 13:49:44.943, end time: 2019-05-20 13:49:45.962, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=11955, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=17a1e437f514459c963c87b0f12a00f7, userType=2)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDE=-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 65 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-20 13:49:46');
INSERT INTO `exception_log` VALUES (412, '45.71.15583313829200041', 0, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '106.120.198.2', '2019-05-20 13:49:46', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557382230870&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-20 13:49:44.943, end time: 2019-05-20 13:49:45.962, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=11955, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=17a1e437f514459c963c87b0f12a00f7, userType=2)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDE=-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-20 13:49:44.943, end time: 2019-05-20 13:49:45.962, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=11955, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=17a1e437f514459c963c87b0f12a00f7, userType=2)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDE=-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557382230870&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-20 13:49:44.943, end time: 2019-05-20 13:49:45.962, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=11955, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=17a1e437f514459c963c87b0f12a00f7, userType=2)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDE=-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor331.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:64)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-20 13:49:44.943, end time: 2019-05-20 13:49:45.962, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=11955, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=17a1e437f514459c963c87b0f12a00f7, userType=2)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDE=-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 65 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-20 13:49:47');
INSERT INTO `exception_log` VALUES (413, '45.71.15583313829200041', 0, 2, 'promotion-application', '/promotion-api/admins/coupon/template/page', 'pageNo=1&pageSize=10&type=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '106.120.198.2', '2019-05-20 13:49:46', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557382230870&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-20 13:49:44.943, end time: 2019-05-20 13:49:45.962, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=11955, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=17a1e437f514459c963c87b0f12a00f7, userType=2)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDE=-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-20 13:49:44.943, end time: 2019-05-20 13:49:45.962, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=11955, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=17a1e437f514459c963c87b0f12a00f7, userType=2)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDE=-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [127.0.0.1:20880] (1/9) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=checkPermission,checkToken,getAccessToken&pid=8318&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557382230870&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558101040385&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-20 13:49:44.943, end time: 2019-05-20 13:49:45.962, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=11955, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=17a1e437f514459c963c87b0f12a00f7, userType=2)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDE=-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor331.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy135.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:64)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tjiqTtly$accessor$zLGHkxLS(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$S5SrTZUE.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-20 13:49:44.943, end time: 2019-05-20 13:49:45.962, client elapsed: 1 ms, server elapsed: 1018 ms, timeout: 1000 ms, request: Request [id=11955, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=17a1e437f514459c963c87b0f12a00f7, userType=2)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, sw6=1-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDE=-NDUuNzEuMTU1ODMzMTM4MjkyMDAwNDA=-3-45-45-NQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==-Iy9wcm9tb3Rpb24tYXBpL2FkbWlucy9jb3Vwb24vdGVtcGxhdGUvcGFnZQ==, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /127.0.0.1:37602 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$bQ9s2iZ2$accessor$O7Wk4pc5(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$HtWD3MVQ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 65 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-20 13:49:48');
INSERT INTO `exception_log` VALUES (414, '59.71.15583624123090017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '111.14.211.69', '2019-05-20 22:26:53', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy5', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\n	... 92 more\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy5\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\n	at javassist.compiler.Javac.compile(Javac.java:95)\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\n	... 94 more\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-05-20 22:26:56');
INSERT INTO `exception_log` VALUES (415, '59.71.15583624123090017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '111.14.211.69', '2019-05-20 22:26:53', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy5', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\n	... 92 more\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy5\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\n	at javassist.compiler.Javac.compile(Javac.java:95)\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\n	... 94 more\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-05-20 22:26:56');
INSERT INTO `exception_log` VALUES (416, '59.71.15583624123090017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '111.14.211.69', '2019-05-20 22:26:53', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy5', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\n	... 92 more\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy5\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\n	at javassist.compiler.Javac.compile(Javac.java:95)\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\n	... 94 more\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-05-20 22:26:56');
INSERT INTO `exception_log` VALUES (417, '59.77.15583624722630017', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_12_4) AppleWebKit/537.36 (KHTML, like Gecko) 			Chrome/55.0.2883.95 Safari/537.36', '183.192.164.85', '2019-05-20 22:27:52', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-20 22:27:52');
INSERT INTO `exception_log` VALUES (418, '59.73.15583646347490047', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:03:55', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-20 23:03:55');
INSERT INTO `exception_log` VALUES (419, '59.72.15583647399120049', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.20 Safari/537.36', '119.123.204.188', '2019-05-20 23:05:40', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-20 23:05:40');
INSERT INTO `exception_log` VALUES (420, '59.75.15583918044780417', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.121 Safari/537.36', '59.63.204.74', '2019-05-21 06:36:45', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 06:36:46');
INSERT INTO `exception_log` VALUES (421, '59.72.15584031408790567', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-21 09:45:43', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 09:45:43');
INSERT INTO `exception_log` VALUES (422, '59.72.15584031408790567', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '121.32.29.182', '2019-05-21 09:45:43', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 09:45:44');
INSERT INTO `exception_log` VALUES (423, '59.79.15584046164620589', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:10:17', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 10:10:17');
INSERT INTO `exception_log` VALUES (424, '59.71.15584046780830593', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '222.223.215.55', '2019-05-21 10:11:18', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 10:11:18');
INSERT INTO `exception_log` VALUES (425, '59.76.15584096183230657', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:33:38', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 11:33:38');
INSERT INTO `exception_log` VALUES (426, '63.77.15584100516430611', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=updateAdminStatus,deleteAdmin,getAdminPage,updateAdmin,addAdmin,assignRole&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426390&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:54.006, end time: 2019-05-21 11:40:55.027, client elapsed: 0 ms, server elapsed: 1021 ms, timeout: 1000 ms, request: Request [id=916, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTE=-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTA=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:54.006, end time: 2019-05-21 11:40:55.027, client elapsed: 0 ms, server elapsed: 1021 ms, timeout: 1000 ms, request: Request [id=916, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTE=-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTA=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=updateAdminStatus,deleteAdmin,getAdminPage,updateAdmin,addAdmin,assignRole&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426390&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:54.006, end time: 2019-05-21 11:40:55.027, client elapsed: 0 ms, server elapsed: 1021 ms, timeout: 1000 ms, request: Request [id=916, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTE=-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTA=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkPermissions(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor350.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy161.checkPermissions(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.checkPermission(AdminSecurityInterceptor.java:113)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:82)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4$accessor$VUxyMlGY(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$tdIthUiC.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:54.006, end time: 2019-05-21 11:40:55.027, client elapsed: 0 ms, server elapsed: 1021 ms, timeout: 1000 ms, request: Request [id=916, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTE=-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTA=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa$accessor$KPWJ8D5D(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$PTbN7yYt.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 81 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-21 11:40:57');
INSERT INTO `exception_log` VALUES (427, '63.85.15584100509300609', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=updateAdminStatus,deleteAdmin,getAdminPage,updateAdmin,addAdmin,assignRole&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760070163&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=915, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDk=-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDg=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=915, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDk=-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDg=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=updateAdminStatus,deleteAdmin,getAdminPage,updateAdmin,addAdmin,assignRole&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760070163&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=915, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDk=-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDg=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkPermissions(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor350.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy161.checkPermissions(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.checkPermission(AdminSecurityInterceptor.java:113)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:82)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4$accessor$VUxyMlGY(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$tdIthUiC.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=915, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDk=-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDg=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa$accessor$KPWJ8D5D(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$PTbN7yYt.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 81 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-21 11:40:57');
INSERT INTO `exception_log` VALUES (428, '63.78.15584100509350613', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=deleteAdmin,updateAdminStatus,getAdminPage,updateAdmin,addAdmin,getRoleList,assignAdminRole,checkPermissions,getAdminRolesMap,authentication&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1558093433237&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=914, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTM=-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTI=-5-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=914, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTM=-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTI=-5-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=deleteAdmin,updateAdminStatus,getAdminPage,updateAdmin,addAdmin,getRoleList,assignAdminRole,checkPermissions,getAdminRolesMap,authentication&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1558093433237&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=914, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTM=-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTI=-5-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkPermissions(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor350.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy161.checkPermissions(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.checkPermission(AdminSecurityInterceptor.java:113)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:82)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4$accessor$VUxyMlGY(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$tdIthUiC.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=914, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTM=-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTI=-5-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa$accessor$KPWJ8D5D(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$PTbN7yYt.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 81 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-21 11:40:55');
INSERT INTO `exception_log` VALUES (429, '63.85.15584100509300609', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=updateAdminStatus,deleteAdmin,getAdminPage,updateAdmin,addAdmin,assignRole&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760070163&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=915, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDk=-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDg=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=915, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDk=-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDg=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=updateAdminStatus,deleteAdmin,getAdminPage,updateAdmin,addAdmin,assignRole&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760070163&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=915, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDk=-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDg=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkPermissions(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor350.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy161.checkPermissions(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.checkPermission(AdminSecurityInterceptor.java:113)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:82)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4$accessor$VUxyMlGY(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$tdIthUiC.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=915, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDk=-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDg=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa$accessor$KPWJ8D5D(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$PTbN7yYt.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 81 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-21 11:40:55');
INSERT INTO `exception_log` VALUES (430, '63.78.15584100509350613', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=deleteAdmin,updateAdminStatus,getAdminPage,updateAdmin,addAdmin,getRoleList,assignAdminRole,checkPermissions,getAdminRolesMap,authentication&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1558093433237&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=914, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTM=-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTI=-5-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=914, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTM=-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTI=-5-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=deleteAdmin,updateAdminStatus,getAdminPage,updateAdmin,addAdmin,getRoleList,assignAdminRole,checkPermissions,getAdminRolesMap,authentication&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1558093433237&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=914, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTM=-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTI=-5-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkPermissions(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor350.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy161.checkPermissions(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.checkPermission(AdminSecurityInterceptor.java:113)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:82)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4$accessor$VUxyMlGY(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$tdIthUiC.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=914, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTM=-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTI=-5-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa$accessor$KPWJ8D5D(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$PTbN7yYt.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 81 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-21 11:40:57');
INSERT INTO `exception_log` VALUES (431, '63.85.15584100509300609', 0, 2, 'product-application', '/product-api/admins/spu/page', 'status=1&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=updateAdminStatus,deleteAdmin,getAdminPage,updateAdmin,addAdmin,assignRole&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760070163&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=915, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDk=-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDg=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=915, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDk=-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDg=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=updateAdminStatus,deleteAdmin,getAdminPage,updateAdmin,addAdmin,assignRole&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557760070163&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=915, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDk=-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDg=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkPermissions(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor350.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy161.checkPermissions(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.checkPermission(AdminSecurityInterceptor.java:113)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:82)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4$accessor$VUxyMlGY(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$tdIthUiC.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=915, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDk=-NjMuODUuMTU1ODQxMDA1MDkzMDA2MDg=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvc3B1L3BhZ2U=, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa$accessor$KPWJ8D5D(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$PTbN7yYt.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 81 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-21 11:40:56');
INSERT INTO `exception_log` VALUES (432, '63.77.15584100516430611', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=updateAdminStatus,deleteAdmin,getAdminPage,updateAdmin,addAdmin,assignRole&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426390&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:54.006, end time: 2019-05-21 11:40:55.027, client elapsed: 0 ms, server elapsed: 1021 ms, timeout: 1000 ms, request: Request [id=916, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTE=-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTA=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:54.006, end time: 2019-05-21 11:40:55.027, client elapsed: 0 ms, server elapsed: 1021 ms, timeout: 1000 ms, request: Request [id=916, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTE=-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTA=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=updateAdminStatus,deleteAdmin,getAdminPage,updateAdmin,addAdmin,assignRole&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426390&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:54.006, end time: 2019-05-21 11:40:55.027, client elapsed: 0 ms, server elapsed: 1021 ms, timeout: 1000 ms, request: Request [id=916, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTE=-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTA=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkPermissions(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor350.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy161.checkPermissions(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.checkPermission(AdminSecurityInterceptor.java:113)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:82)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4$accessor$VUxyMlGY(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$tdIthUiC.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:54.006, end time: 2019-05-21 11:40:55.027, client elapsed: 0 ms, server elapsed: 1021 ms, timeout: 1000 ms, request: Request [id=916, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTE=-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTA=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa$accessor$KPWJ8D5D(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$PTbN7yYt.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 81 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-21 11:40:55');
INSERT INTO `exception_log` VALUES (433, '63.77.15584100516430611', 0, 2, 'product-application', '/product-api/admins/attr/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=updateAdminStatus,deleteAdmin,getAdminPage,updateAdmin,addAdmin,assignRole&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426390&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:54.006, end time: 2019-05-21 11:40:55.027, client elapsed: 0 ms, server elapsed: 1021 ms, timeout: 1000 ms, request: Request [id=916, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTE=-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTA=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:54.006, end time: 2019-05-21 11:40:55.027, client elapsed: 0 ms, server elapsed: 1021 ms, timeout: 1000 ms, request: Request [id=916, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTE=-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTA=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=updateAdminStatus,deleteAdmin,getAdminPage,updateAdmin,addAdmin,assignRole&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1557324426390&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:54.006, end time: 2019-05-21 11:40:55.027, client elapsed: 0 ms, server elapsed: 1021 ms, timeout: 1000 ms, request: Request [id=916, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTE=-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTA=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkPermissions(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor350.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy161.checkPermissions(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.checkPermission(AdminSecurityInterceptor.java:113)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:82)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4$accessor$VUxyMlGY(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$tdIthUiC.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:54.006, end time: 2019-05-21 11:40:55.027, client elapsed: 0 ms, server elapsed: 1021 ms, timeout: 1000 ms, request: Request [id=916, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTE=-NjMuNzcuMTU1ODQxMDA1MTY0MzA2MTA=-4-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvYXR0ci90cmVl, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa$accessor$KPWJ8D5D(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$PTbN7yYt.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 81 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-21 11:40:56');
INSERT INTO `exception_log` VALUES (434, '63.78.15584100509350613', 0, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '119.162.244.190', '2019-05-21 11:40:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=deleteAdmin,updateAdminStatus,getAdminPage,updateAdmin,addAdmin,getRoleList,assignAdminRole,checkPermissions,getAdminRolesMap,authentication&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1558093433237&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=914, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTM=-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTI=-5-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=914, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTM=-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTI=-5-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method checkPermissions in the service cn.iocoder.mall.admin.api.AdminService. Tried 3 times of the providers [127.0.0.1:20880] (1/12) from the registry 127.0.0.1:2181 on the consumer 127.0.0.1 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: checkPermissions, provider: dubbo://127.0.0.1:20880/cn.iocoder.mall.admin.api.AdminService?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.AdminService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.generic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.AdminService&lazy=false&methods=deleteAdmin,updateAdminStatus,getAdminPage,updateAdmin,addAdmin,getRoleList,assignAdminRole,checkPermissions,getAdminRolesMap,authentication&pid=28071&qos.enable=false&register=true&register.ip=127.0.0.1&release=2.7.1&remote.application=admin-service&remote.timestamp=1558093433237&revision=1.0-SNAPSHOT&side=consumer&sticky=false&timestamp=1558365060848&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=914, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTM=-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTI=-5-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.checkPermissions(proxy2.java)\n	at sun.reflect.GeneratedMethodAccessor350.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy161.checkPermissions(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.checkPermission(AdminSecurityInterceptor.java:113)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:82)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$iLVrAPn4$accessor$VUxyMlGY(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$tdIthUiC.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-05-21 11:40:53.979, end time: 2019-05-21 11:40:54.998, client elapsed: 0 ms, server elapsed: 1019 ms, timeout: 1000 ms, request: Request [id=914, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=checkPermissions, parameterTypes=[class java.lang.Integer, interface java.util.List], arguments=[27, null], attachments={path=cn.iocoder.mall.admin.api.AdminService, sw6=1-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTM=-NjMuNzguMTU1ODQxMDA1MDkzNTA2MTI=-5-63-63-NQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==-Iy9wcm9kdWN0LWFwaS9hZG1pbnMvY2F0ZWdvcnkvdHJlZQ==, interface=cn.iocoder.mall.admin.api.AdminService, version=1.0.0}]], channel: /127.0.0.1:46134 -> /127.0.0.1:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HFD6LQMa$accessor$KPWJ8D5D(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$PTbN7yYt.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 81 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-21 11:40:56');
INSERT INTO `exception_log` VALUES (435, '59.71.15584213471310815', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '180.117.163.66', '2019-05-21 14:49:07', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 14:49:07');
INSERT INTO `exception_log` VALUES (436, '59.77.15584260484330863', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.109 Safari/537.36', '113.67.157.22', '2019-05-21 16:07:28', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 16:07:29');
INSERT INTO `exception_log` VALUES (437, '59.74.15584280368330891', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:40:37', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 16:40:37');
INSERT INTO `exception_log` VALUES (438, '59.71.15584281221130893', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0', '222.128.15.59', '2019-05-21 16:42:02', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 16:42:02');
INSERT INTO `exception_log` VALUES (439, '59.71.15584301383840921', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '112.224.23.179', '2019-05-21 17:15:38', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 17:15:38');
INSERT INTO `exception_log` VALUES (440, '59.79.15584311191680931', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '106.122.175.121', '2019-05-21 17:31:59', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 17:31:59');
INSERT INTO `exception_log` VALUES (441, '59.76.15584382377481025', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '182.150.36.6', '2019-05-21 19:30:38', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 19:30:38');
INSERT INTO `exception_log` VALUES (442, '59.75.15584382465791029', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '125.71.200.13', '2019-05-21 19:30:47', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 19:30:47');
INSERT INTO `exception_log` VALUES (443, '59.78.15584438948441105', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.63.15', '2019-05-21 21:04:55', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 21:04:55');
INSERT INTO `exception_log` VALUES (444, '59.71.15584439480751107', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '223.104.63.15', '2019-05-21 21:05:48', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-21 21:05:48');
INSERT INTO `exception_log` VALUES (445, '59.78.15584905383351729', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:02:18', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-22 10:02:18');
INSERT INTO `exception_log` VALUES (446, '59.78.15584906435641731', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:04:04', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-22 10:04:04');
INSERT INTO `exception_log` VALUES (447, '59.76.15584907033281729', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:05:03', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-22 10:05:03');
INSERT INTO `exception_log` VALUES (448, '59.79.15584907139971731', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.223.204.4', '2019-05-22 10:05:14', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-22 10:05:14');
INSERT INTO `exception_log` VALUES (449, '59.72.15584947961261787', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:13:16', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-22 11:13:16');
INSERT INTO `exception_log` VALUES (450, '59.74.15584953080721799', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '124.161.16.164', '2019-05-22 11:21:48', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU(UsersProductRecommendController.java:40)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list$original$zwBEpAEU$accessor$3AJZJ2aF(UsersProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController$auxiliary$9y3DN1Kk.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-22 11:21:48');
INSERT INTO `exception_log` VALUES (451, '59.79.15584976264921829', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '117.107.137.62', '2019-05-22 12:00:27', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-22 12:00:27');
INSERT INTO `exception_log` VALUES (452, '59.78.15585071317921965', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36', '61.185.255.174', '2019-05-22 14:38:52', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-22 14:38:52');
INSERT INTO `exception_log` VALUES (453, '59.79.15585099770862007', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Safari/537.36', '182.48.96.164', '2019-05-22 15:26:17', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-22 15:26:17');
INSERT INTO `exception_log` VALUES (454, '66.56.15585115615911107', 78, 1, 'user-application', '/user-api/users/address/add', 'name=zs&tel=18500020583&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=gsfdgdsg&isDefault=true&address=gsfdgdsg&areaNo=110101&mobile=18500020583&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:52:42', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [gsfdgdsg]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [gsfdgdsg]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [gsfdgdsg]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-22 15:52:42');
INSERT INTO `exception_log` VALUES (455, '66.48.15585115825611107', 78, 1, 'user-application', '/user-api/users/address/add', 'name=zs&tel=18500020583&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=皮套胡同&isDefault=true&address=皮套胡同&areaNo=110101&mobile=18500020583&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:53:03', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [皮套胡同]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [皮套胡同]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [皮套胡同]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-22 15:53:03');
INSERT INTO `exception_log` VALUES (456, '66.49.15585116397111111', 78, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=18500020583&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=来来来&isDefault=false&address=来来来&areaNo=110101&mobile=18500020583&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:00', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [来来来]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [来来来]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [来来来]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-22 15:54:00');
INSERT INTO `exception_log` VALUES (457, '66.51.15585116432111111', 78, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=18500020583&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=来来来&isDefault=true&address=来来来&areaNo=110101&mobile=18500020583&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.81 Mobile Safari/537.36', '182.48.96.164', '2019-05-22 15:54:03', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [来来来]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [来来来]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [来来来]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-22 15:54:03');
INSERT INTO `exception_log` VALUES (458, '59.79.15585289478302273', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:42:28', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-22 20:42:28');
INSERT INTO `exception_log` VALUES (459, '59.71.15585289668882277', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.77 Safari/537.36', '218.92.219.199', '2019-05-22 20:42:47', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-22 20:42:47');
INSERT INTO `exception_log` VALUES (460, '59.71.15585821168422989', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.128.107.186', '2019-05-23 11:28:37', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-23 11:28:37');
INSERT INTO `exception_log` VALUES (461, '59.72.15585896152113085', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Safari/537.36', '61.153.7.60', '2019-05-23 13:33:35', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-23 13:33:35');
INSERT INTO `exception_log` VALUES (462, '59.76.15585898787603089', 27, 2, 'promotion-application', '/promotion-api/admins/product_recommend/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.130.142.166', '2019-05-23 13:37:59', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy130.getProductRecommendPage(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF(AdminsProductRecommendController.java:49)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page$original$PM0xtVgF$accessor$K202y1VA(AdminsProductRecommendController.java)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController$auxiliary$U0nZvwxW.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsProductRecommendController.page(AdminsProductRecommendController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$fz8dEj7v$accessor$1IvSJO19(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$5BQ4RvDG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-23 13:37:59');
INSERT INTO `exception_log` VALUES (463, '66.53.15586728854423277', 82, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=17612184394&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=滴滴滴&isDefault=true&address=滴滴滴&areaNo=110101&mobile=17612184394&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:41:25', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [滴滴滴]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [滴滴滴]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [滴滴滴]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-24 12:41:25');
INSERT INTO `exception_log` VALUES (464, '66.52.15586728881273273', 82, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=17612184394&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=滴滴滴&isDefault=true&address=滴滴滴&areaNo=110101&mobile=17612184394&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:41:28', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [滴滴滴]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [滴滴滴]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [滴滴滴]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-24 12:41:28');
INSERT INTO `exception_log` VALUES (465, '66.49.15586729561413279', 82, 1, 'user-application', '/user-api/users/address/add', 'name=订单&tel=17612184394&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=滴滴滴&isDefault=true&address=滴滴滴&areaNo=110101&mobile=17612184394&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.167.101.22', '2019-05-24 12:42:36', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [滴滴滴]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [滴滴滴]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [滴滴滴]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-24 12:42:36');
INSERT INTO `exception_log` VALUES (466, '66.51.15586912642613527', 83, 1, 'user-application', '/user-api/users/address/add', 'name=adfa&tel=13456565656&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=dadsfa&isDefault=false&address=dadsfa&areaNo=110101&mobile=13456565656&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:44', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dadsfa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dadsfa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dadsfa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-24 17:47:44');
INSERT INTO `exception_log` VALUES (467, '66.53.15586912671813529', 83, 1, 'user-application', '/user-api/users/address/add', 'name=adfa&tel=13456565656&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=dadsfa&isDefault=false&address=dadsfa&areaNo=110101&mobile=13456565656&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:47', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dadsfa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dadsfa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dadsfa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-24 17:47:47');
INSERT INTO `exception_log` VALUES (468, '66.49.15586912753123529', 83, 1, 'user-application', '/user-api/users/address/add', 'name=adfa&tel=13522225555&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=dadsfa&isDefault=false&address=dadsfa&areaNo=110101&mobile=13522225555&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:55', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dadsfa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dadsfa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dadsfa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-24 17:47:55');
INSERT INTO `exception_log` VALUES (469, '66.50.15586912772193525', 83, 1, 'user-application', '/user-api/users/address/add', 'name=adfa&tel=13522225555&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=dadsfa&isDefault=false&address=dadsfa&areaNo=110101&mobile=13522225555&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Mobile Safari/537.36', '116.24.65.68', '2019-05-24 17:47:57', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dadsfa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dadsfa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dadsfa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-24 17:47:57');
INSERT INTO `exception_log` VALUES (470, '124058c2-97d5-4218-b0ef-210cf582781b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:04:06', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 12:04:06');
INSERT INTO `exception_log` VALUES (471, 'c2e8ec34-56be-494e-9c93-615c39eee876', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 12:23:00', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 12:23:00');
INSERT INTO `exception_log` VALUES (472, '86b01f69-336d-4b09-8ef5-0d2d4ba061c9', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:03:14', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 14:03:14');
INSERT INTO `exception_log` VALUES (473, 'ed5eb2cd-aac0-4f59-b29d-ffbce3a545dd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:06:20', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 14:06:20');
INSERT INTO `exception_log` VALUES (474, 'eb30fad8-eb57-43cd-8143-b047cf902e31', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:09:44', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 14:09:44');
INSERT INTO `exception_log` VALUES (475, '3a7209bc-985f-437d-9a91-38e6b1dfe6e2', 1, 2, 'admin-application', '/admin-api/admins/sms/sign/page', 'current=0&total=0&size=0', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:23:40', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.service.SmsServiceImpl.pageSmsSign(SmsServiceImpl.java:69)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$FastClassBySpringCGLIB$$612329bc.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$EnhancerBySpringCGLIB$$e79438e6.pageSmsSign(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.SmsSignController.pageSign(SmsSignController.java:27)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.service.SmsServiceImpl', 'SmsServiceImpl.java', 'pageSmsSign', 69, '2019-05-26 14:23:40');
INSERT INTO `exception_log` VALUES (476, 'c3105518-f006-4a3d-b28f-5a03306aa870', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:40:58', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 14:40:58');
INSERT INTO `exception_log` VALUES (477, '50de92ae-505a-4c73-bfef-6d0ca32109e2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:07', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 14:41:07');
INSERT INTO `exception_log` VALUES (478, '8914b0de-7635-4db1-9822-96b917f7cbd3', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:41:35', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 14:41:35');
INSERT INTO `exception_log` VALUES (479, '8d8ee717-7f17-4899-9c2c-3ccf503e35bd', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 14:43:16', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 14:43:16');
INSERT INTO `exception_log` VALUES (480, '2b28171f-2e2e-4ae9-bb5b-d3fced0fd5e2', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 15:46:14', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 15:46:14');
INSERT INTO `exception_log` VALUES (481, 'c1e06811-e67c-4f07-9cf0-57f8284add8c', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:10:05', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 16:10:05');
INSERT INTO `exception_log` VALUES (482, 'c8f3d5a5-24d9-451e-8adc-0dd2cbd117a7', 0, 2, 'admin-application', '/admin-api/admins/admin/url_resource_list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:37:26', 'org.springframework.dao.RecoverableDataAccessException', 'RecoverableDataAccessException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.CommunicationsException: Communications link failure\n\nThe last packet successfully received from the server was 38,689 milliseconds ago.  The last packet sent successfully to the server was 18,988 milliseconds ago.\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,create_time,update_time FROM oauth2_access_token WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.CommunicationsException: Communications link failure\n\nThe last packet successfully received from the server was 38,689 milliseconds ago.  The last packet sent successfully to the server was 18,988 milliseconds ago.\n; Communications link failure\n\nThe last packet successfully received from the server was 38,689 milliseconds ago.  The last packet sent successfully to the server was 18,988 milliseconds ago.; nested exception is com.mysql.jdbc.exceptions.jdbc4.CommunicationsException: Communications link failure\n\nThe last packet successfully received from the server was 38,689 milliseconds ago.  The last packet sent successfully to the server was 18,988 milliseconds ago.', 'SocketException: Operation timed out (Read failed)', 'org.springframework.dao.RecoverableDataAccessException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.CommunicationsException: Communications link failure\n\nThe last packet successfully received from the server was 38,689 milliseconds ago.  The last packet sent successfully to the server was 18,988 milliseconds ago.\n### The error may exist in cn/iocoder/mall/admin/dao/OAuth2AccessTokenMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT id,refresh_token,user_id,user_type,expires_time,valid,create_time,update_time FROM oauth2_access_token WHERE id=?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.CommunicationsException: Communications link failure\n\nThe last packet successfully received from the server was 38,689 milliseconds ago.  The last packet sent successfully to the server was 18,988 milliseconds ago.\n; Communications link failure\n\nThe last packet successfully received from the server was 38,689 milliseconds ago.  The last packet sent successfully to the server was 18,988 milliseconds ago.; nested exception is com.mysql.jdbc.exceptions.jdbc4.CommunicationsException: Communications link failure\n\nThe last packet successfully received from the server was 38,689 milliseconds ago.  The last packet sent successfully to the server was 18,988 milliseconds ago.\n	at org.springframework.jdbc.support.SQLExceptionSubclassTranslator.doTranslate(SQLExceptionSubclassTranslator.java:100)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:81)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy132.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy144.selectById(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy145.selectById(Unknown Source)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl.getAuthentication(OAuth2ServiceImpl.java:99)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$FastClassBySpringCGLIB$$984394ba.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$2ceddb00.getAuthentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getAuthentication(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy155.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.admin.sdk.interceptor.AdminSecurityInterceptor.preHandle(AdminSecurityInterceptor.java:64)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.CommunicationsException: Communications link failure\n\nThe last packet successfully received from the server was 38,689 milliseconds ago.  The last packet sent successfully to the server was 18,988 milliseconds ago.\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.SQLError.createCommunicationsException(SQLError.java:990)\n	at com.mysql.jdbc.MysqlIO.reuseAndReadPacket(MysqlIO.java:3562)\n	at com.mysql.jdbc.MysqlIO.reuseAndReadPacket(MysqlIO.java:3462)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3903)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor420.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy217.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor419.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy215.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 126 more\nCaused by: java.net.SocketException: Operation timed out (Read failed)\n	at java.net.SocketInputStream.socketRead0(Native Method)\n	at java.net.SocketInputStream.socketRead(SocketInputStream.java:116)\n	at java.net.SocketInputStream.read(SocketInputStream.java:171)\n	at java.net.SocketInputStream.read(SocketInputStream.java:141)\n	at com.mysql.jdbc.util.ReadAheadInputStream.fill(ReadAheadInputStream.java:101)\n	at com.mysql.jdbc.util.ReadAheadInputStream.readFromUnderlyingStreamIfNecessary(ReadAheadInputStream.java:144)\n	at com.mysql.jdbc.util.ReadAheadInputStream.read(ReadAheadInputStream.java:174)\n	at com.mysql.jdbc.MysqlIO.readFully(MysqlIO.java:3011)\n	at com.mysql.jdbc.MysqlIO.reuseAndReadPacket(MysqlIO.java:3472)\n	... 159 more\n', 'org.springframework.jdbc.support.SQLExceptionSubclassTranslator', 'SQLExceptionSubclassTranslator.java', 'doTranslate', 100, '2019-05-26 16:37:26');
INSERT INTO `exception_log` VALUES (483, '2b30466b-e2a3-4318-931d-92a323f6b808', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:32', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 16:38:32');
INSERT INTO `exception_log` VALUES (484, '82ca5370-5668-4d60-a087-8edb0a995861', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:38:42', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 16:38:42');
INSERT INTO `exception_log` VALUES (485, 'ec4890af-ce2b-4bb1-b6fc-a667b6a2ee4b', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 16:39:39', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 16:39:39');
INSERT INTO `exception_log` VALUES (486, 'c6376c08-cb62-40c3-bfcf-1ee49d1f5516', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 17:37:51', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 17:37:51');
INSERT INTO `exception_log` VALUES (487, '51fc8399-1417-480c-b921-7328a0920bb6', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:35:50', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-26 23:35:50');
INSERT INTO `exception_log` VALUES (488, '90010e62-2ed5-4631-92e4-0b18b76b552d', 1, 2, 'admin-application', '/admin-api/admins/sms/template/add', 'smsSignId=6&platform=1&templateCode=SM_0023&template=dafa', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-26 23:48:52', 'org.springframework.dao.DataIntegrityViolationException', 'DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'sms_type\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/SmsTemplateMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.SmsTemplateMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO sms_template  ( sms_sign_id, template_code, platform, template,  apply_status, apply_message, deleted, create_time )  VALUES  ( ?, ?, ?, ?,  ?, ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'sms_type\' doesn\'t have a default value\n; Field \'sms_type\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'sms_type\' doesn\'t have a default value', 'SQLException: Field \'sms_type\' doesn\'t have a default value', 'org.springframework.dao.DataIntegrityViolationException: \n### Error updating database.  Cause: java.sql.SQLException: Field \'sms_type\' doesn\'t have a default value\n### The error may exist in cn/iocoder/mall/admin/dao/SmsTemplateMapper.java (best guess)\n### The error may involve cn.iocoder.mall.admin.dao.SmsTemplateMapper.insert-Inline\n### The error occurred while setting parameters\n### SQL: INSERT INTO sms_template  ( sms_sign_id, template_code, platform, template,  apply_status, apply_message, deleted, create_time )  VALUES  ( ?, ?, ?, ?,  ?, ?, ?, ? )\n### Cause: java.sql.SQLException: Field \'sms_type\' doesn\'t have a default value\n; Field \'sms_type\' doesn\'t have a default value; nested exception is java.sql.SQLException: Field \'sms_type\' doesn\'t have a default value\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:246)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy132.insert(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy160.insert(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor477.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy161.insert(Unknown Source)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl.addTemplate(SmsServiceImpl.java:241)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$FastClassBySpringCGLIB$$612329bc.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$EnhancerBySpringCGLIB$$4c4a5389.addTemplate(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.SmsTemplateController.addSign(SmsTemplateController.java:38)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.sql.SQLException: Field \'sms_type\' doesn\'t have a default value\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:965)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor415.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy217.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\n	at sun.reflect.GeneratedMethodAccessor479.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy215.update(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\n	at sun.reflect.GeneratedMethodAccessor482.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 101 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 246, '2019-05-26 23:48:52');
INSERT INTO `exception_log` VALUES (489, '45ac0971-ec4b-4a2b-9875-d5cc79e100b0', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:07:32', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-27 00:07:32');
INSERT INTO `exception_log` VALUES (490, 'a33bfc2f-773c-4cde-a03d-2fefa88e23f2', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:12:55', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy132.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy158.selectList(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor544.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy159.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl.pageSmsTemplate(SmsServiceImpl.java:119)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$FastClassBySpringCGLIB$$612329bc.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$EnhancerBySpringCGLIB$$fa2a6b33.pageSmsTemplate(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.SmsTemplateController.pageSign(SmsTemplateController.java:32)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor399.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy217.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor397.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy215.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor453.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 96 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-27 00:12:55');
INSERT INTO `exception_log` VALUES (491, 'af026b00-b758-41b1-9c7e-022bb3365257', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:13:05', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy132.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy158.selectList(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor544.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy159.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl.pageSmsTemplate(SmsServiceImpl.java:119)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$FastClassBySpringCGLIB$$612329bc.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$EnhancerBySpringCGLIB$$fa2a6b33.pageSmsTemplate(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.SmsTemplateController.pageSign(SmsTemplateController.java:32)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor399.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy217.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor397.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy215.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor453.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 96 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-27 00:13:05');
INSERT INTO `exception_log` VALUES (492, '0b12afad-eee4-4255-b5f0-d69df75f6441', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:13:07', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy132.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy158.selectList(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor544.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy159.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl.pageSmsTemplate(SmsServiceImpl.java:119)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$FastClassBySpringCGLIB$$612329bc.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$EnhancerBySpringCGLIB$$fa2a6b33.pageSmsTemplate(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.SmsTemplateController.pageSign(SmsTemplateController.java:32)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor399.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy217.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor397.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy215.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor453.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 96 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-27 00:13:07');
INSERT INTO `exception_log` VALUES (493, 'f373941b-ae6a-4dfc-b5a9-29e469ef1b6e', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:13:08', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy132.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy158.selectList(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor544.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy159.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl.pageSmsTemplate(SmsServiceImpl.java:119)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$FastClassBySpringCGLIB$$612329bc.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$EnhancerBySpringCGLIB$$fa2a6b33.pageSmsTemplate(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.SmsTemplateController.pageSign(SmsTemplateController.java:32)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor399.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy217.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor397.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy215.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor453.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 96 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-27 00:13:08');
INSERT INTO `exception_log` VALUES (494, '60631448-3987-43a6-b6c8-7715f35602a8', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=6', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:13:09', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy132.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy158.selectList(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor544.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy159.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl.pageSmsTemplate(SmsServiceImpl.java:119)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$FastClassBySpringCGLIB$$612329bc.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$EnhancerBySpringCGLIB$$fa2a6b33.pageSmsTemplate(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.SmsTemplateController.pageSign(SmsTemplateController.java:32)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor399.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy217.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor397.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy215.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor453.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 96 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-27 00:13:09');
INSERT INTO `exception_log` VALUES (495, '26a07365-f499-4b92-b79e-cd505bbcd71f', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:14:36', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy132.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy158.selectList(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor544.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy159.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl.pageSmsTemplate(SmsServiceImpl.java:119)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$FastClassBySpringCGLIB$$612329bc.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$EnhancerBySpringCGLIB$$fa2a6b33.pageSmsTemplate(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.SmsTemplateController.pageSign(SmsTemplateController.java:32)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor399.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy217.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor397.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy215.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor453.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 96 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-27 00:14:36');
INSERT INTO `exception_log` VALUES (496, '63771667-f5c4-4d7d-8fb7-88fe937a4060', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:14:59', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy132.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy158.selectList(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor544.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy159.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl.pageSmsTemplate(SmsServiceImpl.java:119)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$FastClassBySpringCGLIB$$612329bc.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$EnhancerBySpringCGLIB$$fa2a6b33.pageSmsTemplate(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.SmsTemplateController.pageSign(SmsTemplateController.java:32)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor399.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy217.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor397.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy215.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor453.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 96 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-27 00:14:59');
INSERT INTO `exception_log` VALUES (497, 'b95ddae0-526b-4503-8a8d-c0dab9926d04', 1, 2, 'admin-application', '/admin-api/admins/sms/template/page', 'current=1&total=0&size=10&smsSignId=1', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:15:09', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n### The error may exist in cn/iocoder/mall/admin/dao/SmsSignMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,sign,platform,apply_status,apply_message,deleted,create_time,update_time  FROM sms_sign   WHERE  deleted=0  AND id IN ()\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy132.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy158.selectList(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor544.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy159.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl.pageSmsTemplate(SmsServiceImpl.java:119)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$FastClassBySpringCGLIB$$612329bc.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.SmsServiceImpl$$EnhancerBySpringCGLIB$$fa2a6b33.pageSmsTemplate(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.SmsTemplateController.pageSign(SmsTemplateController.java:32)\n	at sun.reflect.GeneratedMethodAccessor540.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \')\' at line 4\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor399.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy217.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor397.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy215.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor453.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 96 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-27 00:15:09');
INSERT INTO `exception_log` VALUES (498, '80033e2c-098e-4444-bf71-4eb0c625cd80', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:19:48', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-27 00:19:48');
INSERT INTO `exception_log` VALUES (499, '43f44383-cbd7-4a22-8f0b-a5caba154984', 1, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-27 00:20:16', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.ChunkedOutputFilter.flush(ChunkedOutputFilter.java:157)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 78 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-05-27 00:20:16');
INSERT INTO `exception_log` VALUES (500, '62.89.15589514739797931', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 18:04:18&createEndTime=2019-05-21 18:04:18&paymentBeginTime=2019-06-27 18:04:18&paymentEndTime=2019-06-27 18:04:18&orderSubject=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:35', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 25\n### The error may exist in class path resource [mapper/PayTransactionMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT                       id, app_id, create_ip, order_id, order_subject,         order_description, order_memo, price, status, expire_time,         finish_time, notify_url, extension_id, pay_channel, payment_time,         notify_time, trade_no, refund_total, create_time               FROM transaction          WHERE  create_time >= ?                                           AND ? >= create_time                                           AND payment_time >= ?                                           AND ? >= payment_time                                                                                               order_subject LIKE \"%\"?\"%\"          LIMIT ?, ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 25\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 25', 'MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 25', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 25\n### The error may exist in class path resource [mapper/PayTransactionMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT                       id, app_id, create_ip, order_id, order_subject,         order_description, order_memo, price, status, expire_time,         finish_time, notify_url, extension_id, pay_channel, payment_time,         notify_time, trade_no, refund_total, create_time               FROM transaction          WHERE  create_time >= ?                                           AND ? >= create_time                                           AND payment_time >= ?                                           AND ? >= payment_time                                                                                               order_subject LIKE \"%\"?\"%\"          LIMIT ?, ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 25\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 25\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy134.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy142.selectListByPage(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor337.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy143.selectListByPage(Unknown Source)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.getTransactionPage(PayTransactionServiceImpl.java:205)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$12b4896a.getTransactionPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps$accessor$udHWkIOS(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$j1lwYsbN.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps$accessor$udHWkIOS(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$j1lwYsbN.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getTransactionPage(proxy3.java)\n	at sun.reflect.GeneratedMethodAccessor336.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy147.getTransactionPage(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayTransactionController.page$original$pcmvaYrc(AdminsPayTransactionController.java:47)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayTransactionController.page$original$pcmvaYrc$accessor$KsnRVJq5(AdminsPayTransactionController.java)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayTransactionController$auxiliary$zv6H0Rp5.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayTransactionController.page(AdminsPayTransactionController.java)\n	at sun.reflect.GeneratedMethodAccessor335.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$E6xJFBXh(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$E6xJFBXh$accessor$B14rviGT(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$Qx1CllIG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 25\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute$original$77pxNfs1(PreparedStatement.java:1197)\n	at com.mysql.jdbc.PreparedStatement.execute$original$77pxNfs1$accessor$VtRofi65(PreparedStatement.java)\n	at com.mysql.jdbc.PreparedStatement$auxiliary$M8aQLh7C.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute$accessor$EuHyc7E6(JDBC42PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement$auxiliary$BiUdXa1f.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute(JDBC42PreparedStatement.java)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor313.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 153 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-27 18:04:35');
INSERT INTO `exception_log` VALUES (501, '62.87.15589514977707941', 27, 2, 'pay-application', '/pay-api/admins/transaction/page', 'pageNo=1&pageSize=10&createBeginTime=2019-05-01 18:04:18&createEndTime=2019-06-30 18:04:18&orderSubject=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '219.137.53.116', '2019-05-27 18:04:58', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 21\n### The error may exist in class path resource [mapper/PayTransactionMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT                       id, app_id, create_ip, order_id, order_subject,         order_description, order_memo, price, status, expire_time,         finish_time, notify_url, extension_id, pay_channel, payment_time,         notify_time, trade_no, refund_total, create_time               FROM transaction          WHERE  create_time >= ?                                           AND ? >= create_time                                                                                                                         order_subject LIKE \"%\"?\"%\"          LIMIT ?, ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 21\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 21', 'MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 21', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 21\n### The error may exist in class path resource [mapper/PayTransactionMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT                       id, app_id, create_ip, order_id, order_subject,         order_description, order_memo, price, status, expire_time,         finish_time, notify_url, extension_id, pay_channel, payment_time,         notify_time, trade_no, refund_total, create_time               FROM transaction          WHERE  create_time >= ?                                           AND ? >= create_time                                                                                                                         order_subject LIKE \"%\"?\"%\"          LIMIT ?, ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 21\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 21\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy134.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy142.selectListByPage(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor337.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy143.selectListByPage(Unknown Source)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.getTransactionPage(PayTransactionServiceImpl.java:205)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$12b4896a.getTransactionPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper3.invokeMethod(Wrapper3.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps$accessor$udHWkIOS(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$j1lwYsbN.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps$accessor$udHWkIOS(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$j1lwYsbN.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.getTransactionPage(proxy3.java)\n	at sun.reflect.GeneratedMethodAccessor336.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy147.getTransactionPage(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayTransactionController.page$original$pcmvaYrc(AdminsPayTransactionController.java:47)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayTransactionController.page$original$pcmvaYrc$accessor$KsnRVJq5(AdminsPayTransactionController.java)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayTransactionController$auxiliary$zv6H0Rp5.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayTransactionController.page(AdminsPayTransactionController.java)\n	at sun.reflect.GeneratedMethodAccessor335.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$E6xJFBXh(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$E6xJFBXh$accessor$B14rviGT(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$Qx1CllIG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'order_subject LIKE \"%\"\'1\'\"%\" \n        LIMIT 0, 10\' at line 21\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute$original$77pxNfs1(PreparedStatement.java:1197)\n	at com.mysql.jdbc.PreparedStatement.execute$original$77pxNfs1$accessor$VtRofi65(PreparedStatement.java)\n	at com.mysql.jdbc.PreparedStatement$auxiliary$M8aQLh7C.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute$accessor$EuHyc7E6(JDBC42PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement$auxiliary$BiUdXa1f.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute(JDBC42PreparedStatement.java)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor313.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 153 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-27 18:04:58');
INSERT INTO `exception_log` VALUES (502, '1f40c8b5-a990-4351-b2ae-9fddfcc114a0', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageSize=10&cid=10&name=小王&pageNo=1&status=可选值：1-在售中；2-已售罄；3-仓库中；', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:20:16', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException', 'MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"可选值：1-在售中；2-已售罄；3-仓库中；\"', 'NumberFormatException: For input string: \"可选值：1-在售中；2-已售罄；3-仓库中；\"', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"可选值：1-在售中；2-已售罄；3-仓库中；\"\r\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:132)\r\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\nCaused by: java.lang.NumberFormatException: For input string: \"可选值：1-在售中；2-已售罄；3-仓库中；\"\r\n	at java.lang.NumberFormatException.forInputString(NumberFormatException.java:65)\r\n	at java.lang.Integer.parseInt(Integer.java:580)\r\n	at java.lang.Integer.valueOf(Integer.java:766)\r\n	at org.springframework.util.NumberUtils.parseNumber(NumberUtils.java:211)\r\n	at org.springframework.beans.propertyeditors.CustomNumberEditor.setAsText(CustomNumberEditor.java:115)\r\n	at org.springframework.beans.TypeConverterDelegate.doConvertTextValue(TypeConverterDelegate.java:429)\r\n	at org.springframework.beans.TypeConverterDelegate.doConvertValue(TypeConverterDelegate.java:402)\r\n	at org.springframework.beans.TypeConverterDelegate.convertIfNecessary(TypeConverterDelegate.java:155)\r\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:73)\r\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:53)\r\n	at org.springframework.validation.DataBinder.convertIfNecessary(DataBinder.java:693)\r\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:124)\r\n	... 73 more\r\n', 'org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver', 'AbstractNamedValueMethodArgumentResolver.java', 'resolveArgument', 132, '2019-05-28 16:20:16');
INSERT INTO `exception_log` VALUES (503, '06e10ef8-d0da-41a4-8b04-a14a77feecba', 27, 2, 'product-application', '/product-api/admins/spu/page', 'pageSize=10&cid=10&name=小王&pageNo=1&status=可选值：1-在售中；2-已售罄；3-仓库中；', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:20:37', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException', 'MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"可选值：1-在售中；2-已售罄；3-仓库中；\"', 'NumberFormatException: For input string: \"可选值：1-在售中；2-已售罄；3-仓库中；\"', 'org.springframework.web.method.annotation.MethodArgumentTypeMismatchException: Failed to convert value of type \'java.lang.String\' to required type \'java.lang.Integer\'; nested exception is java.lang.NumberFormatException: For input string: \"可选值：1-在售中；2-已售罄；3-仓库中；\"\r\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:132)\r\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\nCaused by: java.lang.NumberFormatException: For input string: \"可选值：1-在售中；2-已售罄；3-仓库中；\"\r\n	at java.lang.NumberFormatException.forInputString(NumberFormatException.java:65)\r\n	at java.lang.Integer.parseInt(Integer.java:580)\r\n	at java.lang.Integer.valueOf(Integer.java:766)\r\n	at org.springframework.util.NumberUtils.parseNumber(NumberUtils.java:211)\r\n	at org.springframework.beans.propertyeditors.CustomNumberEditor.setAsText(CustomNumberEditor.java:115)\r\n	at org.springframework.beans.TypeConverterDelegate.doConvertTextValue(TypeConverterDelegate.java:429)\r\n	at org.springframework.beans.TypeConverterDelegate.doConvertValue(TypeConverterDelegate.java:402)\r\n	at org.springframework.beans.TypeConverterDelegate.convertIfNecessary(TypeConverterDelegate.java:155)\r\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:73)\r\n	at org.springframework.beans.TypeConverterSupport.convertIfNecessary(TypeConverterSupport.java:53)\r\n	at org.springframework.validation.DataBinder.convertIfNecessary(DataBinder.java:693)\r\n	at org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver.resolveArgument(AbstractNamedValueMethodArgumentResolver.java:124)\r\n	... 73 more\r\n', 'org.springframework.web.method.annotation.AbstractNamedValueMethodArgumentResolver', 'AbstractNamedValueMethodArgumentResolver.java', 'resolveArgument', 132, '2019-05-28 16:20:37');
INSERT INTO `exception_log` VALUES (504, 'd72d8245-6583-4d06-aef7-1a9c25b474d4', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:23:49', 'javax.validation.UnexpectedTypeException', 'UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'', 'UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'', 'javax.validation.UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.getExceptionForNullValidator(ConstraintTree.java:108)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.getInitializedConstraintValidator(ConstraintTree.java:140)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.SimpleConstraintTree.validateConstraints(SimpleConstraintTree.java:55)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.validateConstraints(ConstraintTree.java:73)\r\n	at org.hibernate.validator.internal.metadata.core.MetaConstraint.doValidateConstraint(MetaConstraint.java:127)\r\n	at org.hibernate.validator.internal.metadata.core.MetaConstraint.validateConstraint(MetaConstraint.java:120)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateMetaConstraint(ValidatorImpl.java:552)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForSingleDefaultGroupElement(ValidatorImpl.java:515)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForDefaultGroup(ValidatorImpl.java:485)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForCurrentGroup(ValidatorImpl.java:447)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateInContext(ValidatorImpl.java:397)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validate(ValidatorImpl.java:173)\r\n	at org.apache.dubbo.validation.support.jvalidation.JValidator.validate(JValidator.java:312)\r\n	at org.apache.dubbo.validation.support.jvalidation.JValidator.validate(JValidator.java:271)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:85)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy5.addProductBrand(proxy5.java)\r\n	at sun.reflect.GeneratedMethodAccessor743.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.addProductBrand(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.add(AdminsProductBrandController.java:47)\r\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\n', 'org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree', 'ConstraintTree.java', 'getExceptionForNullValidator', 108, '2019-05-28 16:23:49');
INSERT INTO `exception_log` VALUES (505, '5fdd306d-32bd-4e97-8e30-d41a96e8dd58', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:24:35', 'javax.validation.UnexpectedTypeException', 'UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'', 'UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'', 'javax.validation.UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.getExceptionForNullValidator(ConstraintTree.java:108)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.getInitializedConstraintValidator(ConstraintTree.java:140)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.SimpleConstraintTree.validateConstraints(SimpleConstraintTree.java:55)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.validateConstraints(ConstraintTree.java:73)\r\n	at org.hibernate.validator.internal.metadata.core.MetaConstraint.doValidateConstraint(MetaConstraint.java:127)\r\n	at org.hibernate.validator.internal.metadata.core.MetaConstraint.validateConstraint(MetaConstraint.java:120)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateMetaConstraint(ValidatorImpl.java:552)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForSingleDefaultGroupElement(ValidatorImpl.java:515)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForDefaultGroup(ValidatorImpl.java:485)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForCurrentGroup(ValidatorImpl.java:447)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateInContext(ValidatorImpl.java:397)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validate(ValidatorImpl.java:173)\r\n	at org.apache.dubbo.validation.support.jvalidation.JValidator.validate(JValidator.java:312)\r\n	at org.apache.dubbo.validation.support.jvalidation.JValidator.validate(JValidator.java:271)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:85)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy5.addProductBrand(proxy5.java)\r\n	at sun.reflect.GeneratedMethodAccessor743.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.addProductBrand(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.add(AdminsProductBrandController.java:47)\r\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\n', 'org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree', 'ConstraintTree.java', 'getExceptionForNullValidator', 108, '2019-05-28 16:24:35');
INSERT INTO `exception_log` VALUES (506, '26715430-7ade-45f7-984c-53695057cb19', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:26:50', 'javax.validation.UnexpectedTypeException', 'UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'', 'UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'', 'javax.validation.UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.getExceptionForNullValidator(ConstraintTree.java:108)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.getInitializedConstraintValidator(ConstraintTree.java:140)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.SimpleConstraintTree.validateConstraints(SimpleConstraintTree.java:55)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.validateConstraints(ConstraintTree.java:73)\r\n	at org.hibernate.validator.internal.metadata.core.MetaConstraint.doValidateConstraint(MetaConstraint.java:127)\r\n	at org.hibernate.validator.internal.metadata.core.MetaConstraint.validateConstraint(MetaConstraint.java:120)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateMetaConstraint(ValidatorImpl.java:552)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForSingleDefaultGroupElement(ValidatorImpl.java:515)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForDefaultGroup(ValidatorImpl.java:485)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForCurrentGroup(ValidatorImpl.java:447)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateInContext(ValidatorImpl.java:397)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validate(ValidatorImpl.java:173)\r\n	at org.apache.dubbo.validation.support.jvalidation.JValidator.validate(JValidator.java:312)\r\n	at org.apache.dubbo.validation.support.jvalidation.JValidator.validate(JValidator.java:271)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:85)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy5.addProductBrand(proxy5.java)\r\n	at sun.reflect.GeneratedMethodAccessor743.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.addProductBrand(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.add(AdminsProductBrandController.java:47)\r\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\n', 'org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree', 'ConstraintTree.java', 'getExceptionForNullValidator', 108, '2019-05-28 16:26:50');
INSERT INTO `exception_log` VALUES (507, 'a27b3478-98fb-4d44-a352-82aec8236e04', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:28:51', 'org.mybatis.spring.MyBatisSystemException', 'MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'pic_url\' in \'class cn.iocoder.mall.product.dataobject.ProductBrandDO\'', 'ReflectionException: There is no getter for property named \'pic_url\' in \'class cn.iocoder.mall.product.dataobject.ProductBrandDO\'', 'org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'pic_url\' in \'class cn.iocoder.mall.product.dataobject.ProductBrandDO\'\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy131.insert(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy137.insert(Unknown Source)\r\n	at sun.reflect.GeneratedMethodAccessor654.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\r\n	at com.sun.proxy.$Proxy138.insert(Unknown Source)\r\n	at cn.iocoder.mall.product.service.ProductBrandServiceImpl.addProductBrand(ProductBrandServiceImpl.java:78)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.addProductBrand(proxy3.java)\r\n	at sun.reflect.GeneratedMethodAccessor647.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.addProductBrand(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.add(AdminsProductBrandController.java:47)\r\n	at sun.reflect.GeneratedMethodAccessor401.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'pic_url\' in \'class cn.iocoder.mall.product.dataobject.ProductBrandDO\'\r\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\r\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\r\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\r\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\r\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\r\n	at com.baomidou.mybatisplus.core.MybatisDefaultParameterHandler.setParameters(MybatisDefaultParameterHandler.java:219)\r\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.parameterize(PreparedStatementHandler.java:94)\r\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.parameterize(RoutingStatementHandler.java:64)\r\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.prepareStatement(MybatisSimpleExecutor.java:99)\r\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:53)\r\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\r\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\r\n	at sun.reflect.GeneratedMethodAccessor655.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 133 more\r\n', 'org.mybatis.spring.MyBatisExceptionTranslator', 'MyBatisExceptionTranslator.java', 'translateExceptionIfPossible', 77, '2019-05-28 16:28:51');
INSERT INTO `exception_log` VALUES (508, '87619cb9-aa21-48d1-925b-27c4c32ae6c9', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋1&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:51:26', 'org.mybatis.spring.MyBatisSystemException', 'MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 5', 'TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 5', 'org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 5\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy131.selectOne(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy137.selectByName(Unknown Source)\r\n	at sun.reflect.GeneratedMethodAccessor656.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\r\n	at com.sun.proxy.$Proxy138.selectByName(Unknown Source)\r\n	at cn.iocoder.mall.product.service.ProductBrandServiceImpl.addProductBrand(ProductBrandServiceImpl.java:73)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.addProductBrand(proxy3.java)\r\n	at sun.reflect.GeneratedMethodAccessor651.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.addProductBrand(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.add(AdminsProductBrandController.java:47)\r\n	at sun.reflect.GeneratedMethodAccessor405.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\nCaused by: org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 5\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:80)\r\n	at sun.reflect.GeneratedMethodAccessor657.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 133 more\r\n', 'org.mybatis.spring.MyBatisExceptionTranslator', 'MyBatisExceptionTranslator.java', 'translateExceptionIfPossible', 77, '2019-05-28 16:51:26');
INSERT INTO `exception_log` VALUES (509, '87619cb9-aa21-48d1-925b-27c4c32ae6c9', 1, 2, 'product-application', '/product-api/admins/brand/add', 'description=安踏拖鞋1&name=安踏&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:51:26', 'org.mybatis.spring.MyBatisSystemException', 'MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 5', 'TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 5', 'org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 5\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy131.selectOne(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy137.selectByName(Unknown Source)\r\n	at sun.reflect.GeneratedMethodAccessor656.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\r\n	at com.sun.proxy.$Proxy138.selectByName(Unknown Source)\r\n	at cn.iocoder.mall.product.service.ProductBrandServiceImpl.addProductBrand(ProductBrandServiceImpl.java:73)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.addProductBrand(proxy3.java)\r\n	at sun.reflect.GeneratedMethodAccessor651.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.addProductBrand(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.add(AdminsProductBrandController.java:47)\r\n	at sun.reflect.GeneratedMethodAccessor405.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\nCaused by: org.apache.ibatis.exceptions.TooManyResultsException: Expected one result (or null) to be returned by selectOne(), but found: 5\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:80)\r\n	at sun.reflect.GeneratedMethodAccessor657.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 133 more\r\n', 'org.mybatis.spring.MyBatisExceptionTranslator', 'MyBatisExceptionTranslator.java', 'translateExceptionIfPossible', 77, '2019-05-28 16:51:27');
INSERT INTO `exception_log` VALUES (510, '553f537b-8bd4-4560-8690-384c8900bfe4', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:53:07', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \r\n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9\r\n### The error may exist in file [D:\\ypl\\github\\onemall\\product\\product-service-impl\\target\\classes\\mapper\\ProductBrandMapper.xml]\r\n### The error may involve defaultParameterMap\r\n### The error occurred while setting parameters\r\n### SQL: SELECT                       id, name, description, pic_url, status, create_time               FROM product_brand          WHERE name LIKE \"%\"?\"%\"                                           description LIKE \"%\"?\"%\"                                           status = ?                          AND deleted = 0          LIMIT ?, ?\r\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9', 'MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9', 'org.springframework.jdbc.BadSqlGrammarException: \r\n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9\r\n### The error may exist in file [D:\\ypl\\github\\onemall\\product\\product-service-impl\\target\\classes\\mapper\\ProductBrandMapper.xml]\r\n### The error may involve defaultParameterMap\r\n### The error occurred while setting parameters\r\n### SQL: SELECT                       id, name, description, pic_url, status, create_time               FROM product_brand          WHERE name LIKE \"%\"?\"%\"                                           description LIKE \"%\"?\"%\"                                           status = ?                          AND deleted = 0          LIMIT ?, ?\r\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9\r\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\r\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy131.selectList(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy137.selectListByParams(Unknown Source)\r\n	at sun.reflect.GeneratedMethodAccessor729.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\r\n	at com.sun.proxy.$Proxy138.selectListByParams(Unknown Source)\r\n	at cn.iocoder.mall.product.service.ProductBrandServiceImpl.getProductBrandPage(ProductBrandServiceImpl.java:41)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.getProductBrandPage(proxy3.java)\r\n	at sun.reflect.GeneratedMethodAccessor726.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.getProductBrandPage(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.attrPage(AdminsProductBrandController.java:105)\r\n	at sun.reflect.GeneratedMethodAccessor725.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9\r\n	at sun.reflect.GeneratedConstructorAccessor599.newInstance(Unknown Source)\r\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45005)\r\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\r\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\r\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\r\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\r\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\r\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\r\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\r\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\r\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\r\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\r\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\r\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\r\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\r\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\r\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\r\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\r\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\r\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\r\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\r\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\r\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\r\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\r\n	at sun.reflect.GeneratedMethodAccessor730.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 134 more\r\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-28 16:53:07');
INSERT INTO `exception_log` VALUES (511, '4e894960-bd1a-4ddc-a713-3760c9ca1f39', 1, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:53:28', 'javax.validation.UnexpectedTypeException', 'UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'', 'UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'', 'javax.validation.UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.getExceptionForNullValidator(ConstraintTree.java:108)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.getInitializedConstraintValidator(ConstraintTree.java:140)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.SimpleConstraintTree.validateConstraints(SimpleConstraintTree.java:55)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.validateConstraints(ConstraintTree.java:73)\r\n	at org.hibernate.validator.internal.metadata.core.MetaConstraint.doValidateConstraint(MetaConstraint.java:127)\r\n	at org.hibernate.validator.internal.metadata.core.MetaConstraint.validateConstraint(MetaConstraint.java:120)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateMetaConstraint(ValidatorImpl.java:552)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForSingleDefaultGroupElement(ValidatorImpl.java:515)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForDefaultGroup(ValidatorImpl.java:485)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForCurrentGroup(ValidatorImpl.java:447)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateInContext(ValidatorImpl.java:397)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validate(ValidatorImpl.java:173)\r\n	at org.apache.dubbo.validation.support.jvalidation.JValidator.validate(JValidator.java:312)\r\n	at org.apache.dubbo.validation.support.jvalidation.JValidator.validate(JValidator.java:271)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:85)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.updateProductBrand(proxy3.java)\r\n	at sun.reflect.GeneratedMethodAccessor749.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.updateProductBrand(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.update(AdminsProductBrandController.java:68)\r\n	at sun.reflect.GeneratedMethodAccessor748.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\n', 'org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree', 'ConstraintTree.java', 'getExceptionForNullValidator', 108, '2019-05-28 16:53:28');
INSERT INTO `exception_log` VALUES (512, 'a7dc9807-76d9-478d-a195-05e4b1622bce', 1, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:53:38', 'javax.validation.UnexpectedTypeException', 'UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'', 'UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'', 'javax.validation.UnexpectedTypeException: HV000030: No validator could be found for constraint \'javax.validation.constraints.NotEmpty\' validating type \'java.lang.Integer\'. Check configuration for \'status\'\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.getExceptionForNullValidator(ConstraintTree.java:108)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.getInitializedConstraintValidator(ConstraintTree.java:140)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.SimpleConstraintTree.validateConstraints(SimpleConstraintTree.java:55)\r\n	at org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree.validateConstraints(ConstraintTree.java:73)\r\n	at org.hibernate.validator.internal.metadata.core.MetaConstraint.doValidateConstraint(MetaConstraint.java:127)\r\n	at org.hibernate.validator.internal.metadata.core.MetaConstraint.validateConstraint(MetaConstraint.java:120)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateMetaConstraint(ValidatorImpl.java:552)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForSingleDefaultGroupElement(ValidatorImpl.java:515)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForDefaultGroup(ValidatorImpl.java:485)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateConstraintsForCurrentGroup(ValidatorImpl.java:447)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validateInContext(ValidatorImpl.java:397)\r\n	at org.hibernate.validator.internal.engine.ValidatorImpl.validate(ValidatorImpl.java:173)\r\n	at org.apache.dubbo.validation.support.jvalidation.JValidator.validate(JValidator.java:312)\r\n	at org.apache.dubbo.validation.support.jvalidation.JValidator.validate(JValidator.java:271)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:85)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.updateProductBrand(proxy3.java)\r\n	at sun.reflect.GeneratedMethodAccessor749.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.updateProductBrand(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.update(AdminsProductBrandController.java:68)\r\n	at sun.reflect.GeneratedMethodAccessor748.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\n', 'org.hibernate.validator.internal.engine.constraintvalidation.ConstraintTree', 'ConstraintTree.java', 'getExceptionForNullValidator', 108, '2019-05-28 16:53:38');
INSERT INTO `exception_log` VALUES (513, '55e2a319-cd4f-4714-934c-480546c050c7', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 16:54:45', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \r\n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9\r\n### The error may exist in file [D:\\ypl\\github\\onemall\\product\\product-service-impl\\target\\classes\\mapper\\ProductBrandMapper.xml]\r\n### The error may involve defaultParameterMap\r\n### The error occurred while setting parameters\r\n### SQL: SELECT                       id, name, description, pic_url, status, create_time               FROM product_brand          WHERE name LIKE \"%\"?\"%\"                                           description LIKE \"%\"?\"%\"                                           status = ?                          AND deleted = 0          LIMIT ?, ?\r\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9', 'MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9', 'org.springframework.jdbc.BadSqlGrammarException: \r\n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9\r\n### The error may exist in file [D:\\ypl\\github\\onemall\\product\\product-service-impl\\target\\classes\\mapper\\ProductBrandMapper.xml]\r\n### The error may involve defaultParameterMap\r\n### The error occurred while setting parameters\r\n### SQL: SELECT                       id, name, description, pic_url, status, create_time               FROM product_brand          WHERE name LIKE \"%\"?\"%\"                                           description LIKE \"%\"?\"%\"                                           status = ?                          AND deleted = 0          LIMIT ?, ?\r\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9\r\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\r\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy131.selectList(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy137.selectListByParams(Unknown Source)\r\n	at sun.reflect.GeneratedMethodAccessor729.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\r\n	at com.sun.proxy.$Proxy138.selectListByParams(Unknown Source)\r\n	at cn.iocoder.mall.product.service.ProductBrandServiceImpl.getProductBrandPage(ProductBrandServiceImpl.java:41)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.getProductBrandPage(proxy3.java)\r\n	at sun.reflect.GeneratedMethodAccessor726.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.getProductBrandPage(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.attrPage(AdminsProductBrandController.java:105)\r\n	at sun.reflect.GeneratedMethodAccessor725.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: You have an error in your SQL syntax; check the manual that corresponds to your MySQL server version for the right syntax to use near \'description LIKE \"%\"\'安踏拖鞋\'\"%\"\n            \n            \n                \' at line 9\r\n	at sun.reflect.GeneratedConstructorAccessor629.newInstance(Unknown Source)\r\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45005)\r\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\r\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\r\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\r\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\r\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\r\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\r\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\r\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\r\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\r\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\r\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\r\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\r\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\r\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\r\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\r\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\r\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\r\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\r\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\r\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\r\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\r\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\r\n	at sun.reflect.GeneratedMethodAccessor730.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 134 more\r\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-05-28 16:54:45');
INSERT INTO `exception_log` VALUES (514, '5981e23e-d678-483d-bb78-e4c87232db4c', 87, 1, 'search-application', '/search-api/users/product/condition', 'keyword=77777777', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 16:55:02', 'java.lang.ClassCastException', 'ClassCastException: org.elasticsearch.search.aggregations.bucket.terms.UnmappedTerms cannot be cast to org.elasticsearch.search.aggregations.bucket.terms.LongTerms', 'ClassCastException: org.elasticsearch.search.aggregations.bucket.terms.UnmappedTerms cannot be cast to org.elasticsearch.search.aggregations.bucket.terms.LongTerms', 'java.lang.ClassCastException: org.elasticsearch.search.aggregations.bucket.terms.UnmappedTerms cannot be cast to org.elasticsearch.search.aggregations.bucket.terms.LongTerms\r\n	at cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl.lambda$getSearchCondition$1(ProductSearchServiceImpl.java:141)\r\n	at org.springframework.data.elasticsearch.core.ElasticsearchTemplate.query(ElasticsearchTemplate.java:321)\r\n	at cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl.getSearchCondition(ProductSearchServiceImpl.java:135)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy5.getSearchCondition(proxy5.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy126.getSearchCondition(Unknown Source)\r\n	at cn.iocoder.mall.search.application.controller.users.UsersProductSearchController.condition(UsersProductSearchController.java:56)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl', 'ProductSearchServiceImpl.java', 'lambda$getSearchCondition$1', 141, '2019-05-28 16:55:02');
INSERT INTO `exception_log` VALUES (515, 'c3953edf-ea29-47d9-b13a-1e6d274cea89', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:09:27', 'org.mybatis.spring.MyBatisSystemException', 'MyBatisSystemException: nested exception is org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]', 'BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]', 'org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy131.selectOne(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy137.selectListByParams(Unknown Source)\r\n	at sun.reflect.GeneratedMethodAccessor653.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\r\n	at com.sun.proxy.$Proxy138.selectListByParams(Unknown Source)\r\n	at cn.iocoder.mall.product.service.ProductBrandServiceImpl.getProductBrandPage(ProductBrandServiceImpl.java:46)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.getProductBrandPage(proxy3.java)\r\n	at sun.reflect.GeneratedMethodAccessor645.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.getProductBrandPage(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.attrPage(AdminsProductBrandController.java:105)\r\n	at sun.reflect.GeneratedMethodAccessor402.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\nCaused by: org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]\r\n	at org.apache.ibatis.binding.MapperMethod$ParamMap.get(MapperMethod.java:212)\r\n	at org.apache.ibatis.reflection.wrapper.MapWrapper.get(MapWrapper.java:45)\r\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\r\n	at com.baomidou.mybatisplus.core.executor.AbstractBaseExecutor.createCacheKey(AbstractBaseExecutor.java:88)\r\n	at org.apache.ibatis.executor.CachingExecutor.createCacheKey(CachingExecutor.java:146)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:82)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\r\n	at sun.reflect.GeneratedMethodAccessor654.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 133 more\r\n', 'org.mybatis.spring.MyBatisExceptionTranslator', 'MyBatisExceptionTranslator.java', 'translateExceptionIfPossible', 77, '2019-05-28 17:09:27');
INSERT INTO `exception_log` VALUES (516, 'fa9157a1-0d0e-439e-8b40-a4f94f6d907a', 1, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:09:54', 'org.mybatis.spring.MyBatisSystemException', 'MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'pic_url\' in \'class cn.iocoder.mall.product.dataobject.ProductBrandDO\'', 'ReflectionException: There is no getter for property named \'pic_url\' in \'class cn.iocoder.mall.product.dataobject.ProductBrandDO\'', 'org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'pic_url\' in \'class cn.iocoder.mall.product.dataobject.ProductBrandDO\'\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy131.update(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy137.update(Unknown Source)\r\n	at sun.reflect.GeneratedMethodAccessor702.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\r\n	at com.sun.proxy.$Proxy138.update(Unknown Source)\r\n	at cn.iocoder.mall.product.service.ProductBrandServiceImpl.updateProductBrand(ProductBrandServiceImpl.java:92)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.updateProductBrand(proxy3.java)\r\n	at sun.reflect.GeneratedMethodAccessor697.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.updateProductBrand(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.update(AdminsProductBrandController.java:68)\r\n	at sun.reflect.GeneratedMethodAccessor696.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'pic_url\' in \'class cn.iocoder.mall.product.dataobject.ProductBrandDO\'\r\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\r\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\r\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\r\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\r\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\r\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextMap.get(DynamicContext.java:94)\r\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextAccessor.getProperty(DynamicContext.java:107)\r\n	at org.apache.ibatis.ognl.OgnlRuntime.getProperty(OgnlRuntime.java:2719)\r\n	at org.apache.ibatis.ognl.ASTProperty.getValueBody(ASTProperty.java:114)\r\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\r\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\r\n	at org.apache.ibatis.ognl.ASTNotEq.getValueBody(ASTNotEq.java:50)\r\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\r\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\r\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:493)\r\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:457)\r\n	at org.apache.ibatis.scripting.xmltags.OgnlCache.getValue(OgnlCache.java:46)\r\n	at org.apache.ibatis.scripting.xmltags.ExpressionEvaluator.evaluateBoolean(ExpressionEvaluator.java:32)\r\n	at org.apache.ibatis.scripting.xmltags.IfSqlNode.apply(IfSqlNode.java:34)\r\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\r\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\r\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\r\n	at org.apache.ibatis.scripting.xmltags.TrimSqlNode.apply(TrimSqlNode.java:55)\r\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\r\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\r\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\r\n	at org.apache.ibatis.scripting.xmltags.DynamicSqlSource.getBoundSql(DynamicSqlSource.java:39)\r\n	at org.apache.ibatis.mapping.MappedStatement.getBoundSql(MappedStatement.java:297)\r\n	at org.apache.ibatis.executor.statement.BaseStatementHandler.<init>(BaseStatementHandler.java:64)\r\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.<init>(PreparedStatementHandler.java:41)\r\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.<init>(RoutingStatementHandler.java:46)\r\n	at org.apache.ibatis.session.Configuration.newStatementHandler(Configuration.java:576)\r\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:52)\r\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\r\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\r\n	at sun.reflect.GeneratedMethodAccessor703.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 133 more\r\n', 'org.mybatis.spring.MyBatisExceptionTranslator', 'MyBatisExceptionTranslator.java', 'translateExceptionIfPossible', 77, '2019-05-28 17:09:54');
INSERT INTO `exception_log` VALUES (517, '20120819-5b92-496b-b5e7-f3eb08cc7046', 1, 2, 'product-application', '/product-api/admins/brand/update', 'description=安踏拖鞋更新&name=安踏更新&picUrl=http://www.iocoder.cn&status=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:10:04', 'org.mybatis.spring.MyBatisSystemException', 'MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'pic_url\' in \'class cn.iocoder.mall.product.dataobject.ProductBrandDO\'', 'ReflectionException: There is no getter for property named \'pic_url\' in \'class cn.iocoder.mall.product.dataobject.ProductBrandDO\'', 'org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'pic_url\' in \'class cn.iocoder.mall.product.dataobject.ProductBrandDO\'\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy131.update(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.update(SqlSessionTemplate.java:294)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:63)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy137.update(Unknown Source)\r\n	at sun.reflect.GeneratedMethodAccessor702.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\r\n	at com.sun.proxy.$Proxy138.update(Unknown Source)\r\n	at cn.iocoder.mall.product.service.ProductBrandServiceImpl.updateProductBrand(ProductBrandServiceImpl.java:92)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.updateProductBrand(proxy3.java)\r\n	at sun.reflect.GeneratedMethodAccessor697.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.updateProductBrand(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.update(AdminsProductBrandController.java:68)\r\n	at sun.reflect.GeneratedMethodAccessor696.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\nCaused by: org.apache.ibatis.reflection.ReflectionException: There is no getter for property named \'pic_url\' in \'class cn.iocoder.mall.product.dataobject.ProductBrandDO\'\r\n	at org.apache.ibatis.reflection.Reflector.getGetInvoker(Reflector.java:395)\r\n	at org.apache.ibatis.reflection.MetaClass.getGetInvoker(MetaClass.java:163)\r\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.getBeanProperty(BeanWrapper.java:162)\r\n	at org.apache.ibatis.reflection.wrapper.BeanWrapper.get(BeanWrapper.java:49)\r\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\r\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextMap.get(DynamicContext.java:94)\r\n	at org.apache.ibatis.scripting.xmltags.DynamicContext$ContextAccessor.getProperty(DynamicContext.java:107)\r\n	at org.apache.ibatis.ognl.OgnlRuntime.getProperty(OgnlRuntime.java:2719)\r\n	at org.apache.ibatis.ognl.ASTProperty.getValueBody(ASTProperty.java:114)\r\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\r\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\r\n	at org.apache.ibatis.ognl.ASTNotEq.getValueBody(ASTNotEq.java:50)\r\n	at org.apache.ibatis.ognl.SimpleNode.evaluateGetValueBody(SimpleNode.java:212)\r\n	at org.apache.ibatis.ognl.SimpleNode.getValue(SimpleNode.java:258)\r\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:493)\r\n	at org.apache.ibatis.ognl.Ognl.getValue(Ognl.java:457)\r\n	at org.apache.ibatis.scripting.xmltags.OgnlCache.getValue(OgnlCache.java:46)\r\n	at org.apache.ibatis.scripting.xmltags.ExpressionEvaluator.evaluateBoolean(ExpressionEvaluator.java:32)\r\n	at org.apache.ibatis.scripting.xmltags.IfSqlNode.apply(IfSqlNode.java:34)\r\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\r\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\r\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\r\n	at org.apache.ibatis.scripting.xmltags.TrimSqlNode.apply(TrimSqlNode.java:55)\r\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.lambda$apply$0(MixedSqlNode.java:32)\r\n	at java.util.ArrayList.forEach(ArrayList.java:1249)\r\n	at org.apache.ibatis.scripting.xmltags.MixedSqlNode.apply(MixedSqlNode.java:32)\r\n	at org.apache.ibatis.scripting.xmltags.DynamicSqlSource.getBoundSql(DynamicSqlSource.java:39)\r\n	at org.apache.ibatis.mapping.MappedStatement.getBoundSql(MappedStatement.java:297)\r\n	at org.apache.ibatis.executor.statement.BaseStatementHandler.<init>(BaseStatementHandler.java:64)\r\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.<init>(PreparedStatementHandler.java:41)\r\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.<init>(RoutingStatementHandler.java:46)\r\n	at org.apache.ibatis.session.Configuration.newStatementHandler(Configuration.java:576)\r\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:52)\r\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\r\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\r\n	at sun.reflect.GeneratedMethodAccessor703.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 133 more\r\n', 'org.mybatis.spring.MyBatisExceptionTranslator', 'MyBatisExceptionTranslator.java', 'translateExceptionIfPossible', 77, '2019-05-28 17:10:04');
INSERT INTO `exception_log` VALUES (518, '75734bd1-3780-4ba0-a91d-4d2ad5713240', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:10:37', 'org.mybatis.spring.MyBatisSystemException', 'MyBatisSystemException: nested exception is org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]', 'BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]', 'org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy131.selectOne(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy137.selectListByParams(Unknown Source)\r\n	at sun.reflect.GeneratedMethodAccessor653.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\r\n	at com.sun.proxy.$Proxy138.selectListByParams(Unknown Source)\r\n	at cn.iocoder.mall.product.service.ProductBrandServiceImpl.getProductBrandPage(ProductBrandServiceImpl.java:46)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.getProductBrandPage(proxy3.java)\r\n	at sun.reflect.GeneratedMethodAccessor645.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.getProductBrandPage(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.attrPage(AdminsProductBrandController.java:105)\r\n	at sun.reflect.GeneratedMethodAccessor402.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\nCaused by: org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]\r\n	at org.apache.ibatis.binding.MapperMethod$ParamMap.get(MapperMethod.java:212)\r\n	at org.apache.ibatis.reflection.wrapper.MapWrapper.get(MapWrapper.java:45)\r\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\r\n	at com.baomidou.mybatisplus.core.executor.AbstractBaseExecutor.createCacheKey(AbstractBaseExecutor.java:88)\r\n	at org.apache.ibatis.executor.CachingExecutor.createCacheKey(CachingExecutor.java:146)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:82)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\r\n	at sun.reflect.GeneratedMethodAccessor654.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 133 more\r\n', 'org.mybatis.spring.MyBatisExceptionTranslator', 'MyBatisExceptionTranslator.java', 'translateExceptionIfPossible', 77, '2019-05-28 17:10:37');
INSERT INTO `exception_log` VALUES (519, 'cfc5751b-a7dc-4a54-ac50-029101b624ac', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:13:01', 'org.mybatis.spring.MyBatisSystemException', 'MyBatisSystemException: nested exception is org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]', 'BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]', 'org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy131.selectOne(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy137.selectListByParams(Unknown Source)\r\n	at sun.reflect.GeneratedMethodAccessor653.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\r\n	at com.sun.proxy.$Proxy138.selectListByParams(Unknown Source)\r\n	at cn.iocoder.mall.product.service.ProductBrandServiceImpl.getProductBrandPage(ProductBrandServiceImpl.java:46)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.getProductBrandPage(proxy3.java)\r\n	at sun.reflect.GeneratedMethodAccessor645.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.getProductBrandPage(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.attrPage(AdminsProductBrandController.java:105)\r\n	at sun.reflect.GeneratedMethodAccessor402.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\nCaused by: org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]\r\n	at org.apache.ibatis.binding.MapperMethod$ParamMap.get(MapperMethod.java:212)\r\n	at org.apache.ibatis.reflection.wrapper.MapWrapper.get(MapWrapper.java:45)\r\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\r\n	at com.baomidou.mybatisplus.core.executor.AbstractBaseExecutor.createCacheKey(AbstractBaseExecutor.java:88)\r\n	at org.apache.ibatis.executor.CachingExecutor.createCacheKey(CachingExecutor.java:146)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:82)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\r\n	at sun.reflect.GeneratedMethodAccessor654.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 133 more\r\n', 'org.mybatis.spring.MyBatisExceptionTranslator', 'MyBatisExceptionTranslator.java', 'translateExceptionIfPossible', 77, '2019-05-28 17:13:01');
INSERT INTO `exception_log` VALUES (520, '99d28831-d3f4-46d8-a6c1-c0f58ae17e79', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:14:50', 'org.mybatis.spring.MyBatisSystemException', 'MyBatisSystemException: nested exception is org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]', 'BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]', 'org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy131.selectOne(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy137.selectListByParams(Unknown Source)\r\n	at sun.reflect.GeneratedMethodAccessor654.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\r\n	at com.sun.proxy.$Proxy138.selectListByParams(Unknown Source)\r\n	at cn.iocoder.mall.product.service.ProductBrandServiceImpl.getProductBrandPage(ProductBrandServiceImpl.java:46)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.getProductBrandPage(proxy3.java)\r\n	at sun.reflect.GeneratedMethodAccessor649.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.getProductBrandPage(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.attrPage(AdminsProductBrandController.java:105)\r\n	at sun.reflect.GeneratedMethodAccessor403.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\nCaused by: org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]\r\n	at org.apache.ibatis.binding.MapperMethod$ParamMap.get(MapperMethod.java:212)\r\n	at org.apache.ibatis.reflection.wrapper.MapWrapper.get(MapWrapper.java:45)\r\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\r\n	at com.baomidou.mybatisplus.core.executor.AbstractBaseExecutor.createCacheKey(AbstractBaseExecutor.java:88)\r\n	at org.apache.ibatis.executor.CachingExecutor.createCacheKey(CachingExecutor.java:146)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:82)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\r\n	at sun.reflect.GeneratedMethodAccessor655.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 133 more\r\n', 'org.mybatis.spring.MyBatisExceptionTranslator', 'MyBatisExceptionTranslator.java', 'translateExceptionIfPossible', 77, '2019-05-28 17:14:50');
INSERT INTO `exception_log` VALUES (521, 'c5298d8c-3215-4b5b-85f2-564381487dc5', 1, 2, 'product-application', '/product-api/admins/brand/page', 'description=安踏拖鞋&name=安踏&pageNo=1&pageSize=10&status=1', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/71.0.3578.98 Safari/537.36', '127.0.0.1', '2019-05-28 17:15:55', 'org.mybatis.spring.MyBatisSystemException', 'MyBatisSystemException: nested exception is org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]', 'BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]', 'org.mybatis.spring.MyBatisSystemException: nested exception is org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:77)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy131.selectOne(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy137.selectListByParams(Unknown Source)\r\n	at sun.reflect.GeneratedMethodAccessor654.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\r\n	at com.sun.proxy.$Proxy138.selectListByParams(Unknown Source)\r\n	at cn.iocoder.mall.product.service.ProductBrandServiceImpl.getProductBrandPage(ProductBrandServiceImpl.java:46)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.getProductBrandPage(proxy3.java)\r\n	at sun.reflect.GeneratedMethodAccessor649.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy139.getProductBrandPage(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductBrandController.attrPage(AdminsProductBrandController.java:105)\r\n	at sun.reflect.GeneratedMethodAccessor403.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:745)\r\nCaused by: org.apache.ibatis.binding.BindingException: Parameter \'offset\' not found. Available parameters are [name, description, param3, param1, param2, status]\r\n	at org.apache.ibatis.binding.MapperMethod$ParamMap.get(MapperMethod.java:212)\r\n	at org.apache.ibatis.reflection.wrapper.MapWrapper.get(MapWrapper.java:45)\r\n	at org.apache.ibatis.reflection.MetaObject.getValue(MetaObject.java:122)\r\n	at com.baomidou.mybatisplus.core.executor.AbstractBaseExecutor.createCacheKey(AbstractBaseExecutor.java:88)\r\n	at org.apache.ibatis.executor.CachingExecutor.createCacheKey(CachingExecutor.java:146)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:82)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\r\n	at sun.reflect.GeneratedMethodAccessor655.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 133 more\r\n', 'org.mybatis.spring.MyBatisExceptionTranslator', 'MyBatisExceptionTranslator.java', 'translateExceptionIfPossible', 77, '2019-05-28 17:15:55');
INSERT INTO `exception_log` VALUES (522, 'e36201a6-7fb5-4835-a03a-010cab51bc82', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=77777777', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 17:49:24', 'java.lang.ClassCastException', 'ClassCastException: org.elasticsearch.search.aggregations.bucket.terms.UnmappedTerms cannot be cast to org.elasticsearch.search.aggregations.bucket.terms.LongTerms', 'ClassCastException: org.elasticsearch.search.aggregations.bucket.terms.UnmappedTerms cannot be cast to org.elasticsearch.search.aggregations.bucket.terms.LongTerms', 'java.lang.ClassCastException: org.elasticsearch.search.aggregations.bucket.terms.UnmappedTerms cannot be cast to org.elasticsearch.search.aggregations.bucket.terms.LongTerms\r\n	at cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl.lambda$getSearchCondition$1(ProductSearchServiceImpl.java:141)\r\n	at org.springframework.data.elasticsearch.core.ElasticsearchTemplate.query(ElasticsearchTemplate.java:321)\r\n	at cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl.getSearchCondition(ProductSearchServiceImpl.java:135)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy5.getSearchCondition(proxy5.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy126.getSearchCondition(Unknown Source)\r\n	at cn.iocoder.mall.search.application.controller.users.UsersProductSearchController.condition(UsersProductSearchController.java:56)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl', 'ProductSearchServiceImpl.java', 'lambda$getSearchCondition$1', 141, '2019-05-28 17:49:24');
INSERT INTO `exception_log` VALUES (523, '0e661b19-9c48-495c-a3b7-82b2093b5509', 0, 1, 'search-application', '/search-api/users/product/page', 'keyword=77777777&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:03:09', 'org.elasticsearch.index.IndexNotFoundException', 'IndexNotFoundException: no such index', 'IndexNotFoundException: no such index', '[product] IndexNotFoundException[no such index]\r\n	at org.elasticsearch.cluster.metadata.IndexNameExpressionResolver$WildcardExpressionResolver.indexNotFoundException(IndexNameExpressionResolver.java:728)\r\n	at org.elasticsearch.cluster.metadata.IndexNameExpressionResolver$WildcardExpressionResolver.innerResolve(IndexNameExpressionResolver.java:680)\r\n	at org.elasticsearch.cluster.metadata.IndexNameExpressionResolver$WildcardExpressionResolver.resolve(IndexNameExpressionResolver.java:636)\r\n	at org.elasticsearch.cluster.metadata.IndexNameExpressionResolver.concreteIndices(IndexNameExpressionResolver.java:163)\r\n	at org.elasticsearch.cluster.metadata.IndexNameExpressionResolver.concreteIndices(IndexNameExpressionResolver.java:138)\r\n	at org.elasticsearch.action.search.TransportSearchAction.resolveLocalIndices(TransportSearchAction.java:288)\r\n	at org.elasticsearch.action.search.TransportSearchAction.executeSearch(TransportSearchAction.java:302)\r\n	at org.elasticsearch.action.search.TransportSearchAction.lambda$doExecute$4(TransportSearchAction.java:194)\r\n	at org.elasticsearch.action.ActionListener$1.onResponse(ActionListener.java:61)\r\n	at org.elasticsearch.index.query.Rewriteable.rewriteAndFetch(Rewriteable.java:114)\r\n	at org.elasticsearch.index.query.Rewriteable.rewriteAndFetch(Rewriteable.java:87)\r\n	at org.elasticsearch.action.search.TransportSearchAction.doExecute(TransportSearchAction.java:216)\r\n	at org.elasticsearch.action.search.TransportSearchAction.doExecute(TransportSearchAction.java:70)\r\n	at org.elasticsearch.action.support.TransportAction$RequestFilterChain.proceed(TransportAction.java:167)\r\n	at org.elasticsearch.xpack.security.action.filter.SecurityActionFilter.apply(SecurityActionFilter.java:120)\r\n	at org.elasticsearch.action.support.TransportAction$RequestFilterChain.proceed(TransportAction.java:165)\r\n	at org.elasticsearch.action.support.TransportAction.execute(TransportAction.java:139)\r\n	at org.elasticsearch.action.support.HandledTransportAction$TransportHandler.messageReceived(HandledTransportAction.java:89)\r\n	at org.elasticsearch.action.support.HandledTransportAction$TransportHandler.messageReceived(HandledTransportAction.java:80)\r\n	at org.elasticsearch.xpack.security.transport.SecurityServerTransportInterceptor$ProfileSecuredRequestHandler$1.doRun(SecurityServerTransportInterceptor.java:250)\r\n	at org.elasticsearch.common.util.concurrent.AbstractRunnable.run(AbstractRunnable.java:37)\r\n	at org.elasticsearch.xpack.security.transport.SecurityServerTransportInterceptor$ProfileSecuredRequestHandler.messageReceived(SecurityServerTransportInterceptor.java:308)\r\n	at org.elasticsearch.transport.RequestHandlerRegistry.processMessageReceived(RequestHandlerRegistry.java:66)\r\n	at org.elasticsearch.transport.TcpTransport$RequestHandler.doRun(TcpTransport.java:1087)\r\n	at org.elasticsearch.common.util.concurrent.AbstractRunnable.run(AbstractRunnable.java:37)\r\n	at org.elasticsearch.common.util.concurrent.EsExecutors$DirectExecutorService.execute(EsExecutors.java:192)\r\n	at org.elasticsearch.transport.TcpTransport.handleRequest(TcpTransport.java:1046)\r\n	at org.elasticsearch.transport.TcpTransport.messageReceived(TcpTransport.java:932)\r\n	at org.elasticsearch.transport.TcpTransport.inboundMessage(TcpTransport.java:763)\r\n	at org.elasticsearch.transport.netty4.Netty4MessageChannelHandler.channelRead(Netty4MessageChannelHandler.java:53)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.fireChannelRead(ByteToMessageDecoder.java:323)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.channelRead(ByteToMessageDecoder.java:297)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.handler.logging.LoggingHandler.channelRead(LoggingHandler.java:241)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.channel.DefaultChannelPipeline$HeadContext.channelRead(DefaultChannelPipeline.java:1434)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.DefaultChannelPipeline.fireChannelRead(DefaultChannelPipeline.java:965)\r\n	at io.netty.channel.nio.AbstractNioByteChannel$NioByteUnsafe.read(AbstractNioByteChannel.java:163)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKey(NioEventLoop.java:656)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKeysPlain(NioEventLoop.java:556)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKeys(NioEventLoop.java:510)\r\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:470)\r\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:909)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'org.elasticsearch.cluster.metadata.IndexNameExpressionResolver$WildcardExpressionResolver', 'IndexNameExpressionResolver.java', 'indexNotFoundException', 728, '2019-05-28 18:03:09');
INSERT INTO `exception_log` VALUES (524, '632b4639-71f9-4ca1-81cc-ac2b5697ac23', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=77777777', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:04:02', 'java.lang.ClassCastException', 'ClassCastException: org.elasticsearch.search.aggregations.bucket.terms.UnmappedTerms cannot be cast to org.elasticsearch.search.aggregations.bucket.terms.LongTerms', 'ClassCastException: org.elasticsearch.search.aggregations.bucket.terms.UnmappedTerms cannot be cast to org.elasticsearch.search.aggregations.bucket.terms.LongTerms', 'java.lang.ClassCastException: org.elasticsearch.search.aggregations.bucket.terms.UnmappedTerms cannot be cast to org.elasticsearch.search.aggregations.bucket.terms.LongTerms\r\n	at cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl.lambda$getSearchCondition$1(ProductSearchServiceImpl.java:141)\r\n	at org.springframework.data.elasticsearch.core.ElasticsearchTemplate.query(ElasticsearchTemplate.java:321)\r\n	at cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl.getSearchCondition(ProductSearchServiceImpl.java:135)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy5.getSearchCondition(proxy5.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy126.getSearchCondition(Unknown Source)\r\n	at cn.iocoder.mall.search.application.controller.users.UsersProductSearchController.condition(UsersProductSearchController.java:56)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl', 'ProductSearchServiceImpl.java', 'lambda$getSearchCondition$1', 141, '2019-05-28 18:04:02');
INSERT INTO `exception_log` VALUES (525, '0c866399-1d71-4f2b-b127-efbfa7518591', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:06:23', 'org.elasticsearch.action.search.SearchPhaseExecutionException', 'SearchPhaseExecutionException: all shards failed', 'QueryShardException: No mapping found for [sort] in order to sort on', 'Failed to execute phase [query], all shards failed; shardFailures {[BtCuZg66R7GnjLKRmHkS7w][product][0]: RemoteTransportException[[BtCuZg6][127.0.0.1:9300][indices:data/read/search[phase/query]]]; nested: QueryShardException[No mapping found for [sort] in order to sort on]; }\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.onPhaseFailure(AbstractSearchAsyncAction.java:291)\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.executeNextPhase(AbstractSearchAsyncAction.java:133)\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.onPhaseDone(AbstractSearchAsyncAction.java:254)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.onShardFailure(InitialSearchPhase.java:100)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.access$100(InitialSearchPhase.java:48)\r\n	at org.elasticsearch.action.search.InitialSearchPhase$2.lambda$onFailure$1(InitialSearchPhase.java:220)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.maybeFork(InitialSearchPhase.java:174)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.access$000(InitialSearchPhase.java:48)\r\n	at org.elasticsearch.action.search.InitialSearchPhase$2.onFailure(InitialSearchPhase.java:220)\r\n	at org.elasticsearch.action.search.SearchExecutionStatsCollector.onFailure(SearchExecutionStatsCollector.java:73)\r\n	at org.elasticsearch.action.ActionListenerResponseHandler.handleException(ActionListenerResponseHandler.java:59)\r\n	at org.elasticsearch.action.search.SearchTransportService$ConnectionCountingHandler.handleException(SearchTransportService.java:463)\r\n	at org.elasticsearch.transport.TransportService$ContextRestoreResponseHandler.handleException(TransportService.java:1108)\r\n	at org.elasticsearch.transport.TransportService$DirectResponseChannel.processException(TransportService.java:1220)\r\n	at org.elasticsearch.transport.TransportService$DirectResponseChannel.sendResponse(TransportService.java:1194)\r\n	at org.elasticsearch.transport.TaskTransportChannel.sendResponse(TaskTransportChannel.java:60)\r\n	at org.elasticsearch.action.support.ChannelActionListener.onFailure(ChannelActionListener.java:56)\r\n	at org.elasticsearch.search.SearchService$2.onFailure(SearchService.java:366)\r\n	at org.elasticsearch.search.SearchService$2.onResponse(SearchService.java:360)\r\n	at org.elasticsearch.search.SearchService$2.onResponse(SearchService.java:354)\r\n	at org.elasticsearch.search.SearchService$4.doRun(SearchService.java:1085)\r\n	at org.elasticsearch.common.util.concurrent.AbstractRunnable.run(AbstractRunnable.java:37)\r\n	at org.elasticsearch.common.util.concurrent.TimedRunnable.doRun(TimedRunnable.java:41)\r\n	at org.elasticsearch.common.util.concurrent.ThreadContext$ContextPreservingAbstractRunnable.doRun(ThreadContext.java:751)\r\n	at org.elasticsearch.common.util.concurrent.AbstractRunnable.run(AbstractRunnable.java:37)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: [product/uUO5YT2JQjmxci_UQ_oAAg] QueryShardException[No mapping found for [sort] in order to sort on]\r\n	at org.elasticsearch.search.sort.FieldSortBuilder.build(FieldSortBuilder.java:319)\r\n	at org.elasticsearch.search.sort.SortBuilder.buildSort(SortBuilder.java:153)\r\n	at org.elasticsearch.search.SearchService.parseSource(SearchService.java:786)\r\n	at org.elasticsearch.search.SearchService.createContext(SearchService.java:620)\r\n	at org.elasticsearch.search.SearchService.createAndPutContext(SearchService.java:595)\r\n	at org.elasticsearch.search.SearchService.executeQueryPhase(SearchService.java:386)\r\n	at org.elasticsearch.search.SearchService.access$100(SearchService.java:125)\r\n	at org.elasticsearch.search.SearchService$2.onResponse(SearchService.java:358)\r\n	... 9 more\r\n', 'org.elasticsearch.action.search.AbstractSearchAsyncAction', 'AbstractSearchAsyncAction.java', 'onPhaseFailure', 291, '2019-05-28 18:06:23');
INSERT INTO `exception_log` VALUES (526, '73f94fdd-91a8-4eb2-9810-357cc6168dc8', 0, 1, 'search-application', '/search-api/users/product/condition', 'keyword=7777777777', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 18:06:30', 'java.lang.ClassCastException', 'ClassCastException: org.elasticsearch.search.aggregations.bucket.terms.UnmappedTerms cannot be cast to org.elasticsearch.search.aggregations.bucket.terms.LongTerms', 'ClassCastException: org.elasticsearch.search.aggregations.bucket.terms.UnmappedTerms cannot be cast to org.elasticsearch.search.aggregations.bucket.terms.LongTerms', 'java.lang.ClassCastException: org.elasticsearch.search.aggregations.bucket.terms.UnmappedTerms cannot be cast to org.elasticsearch.search.aggregations.bucket.terms.LongTerms\r\n	at cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl.lambda$getSearchCondition$1(ProductSearchServiceImpl.java:141)\r\n	at org.springframework.data.elasticsearch.core.ElasticsearchTemplate.query(ElasticsearchTemplate.java:321)\r\n	at cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl.getSearchCondition(ProductSearchServiceImpl.java:135)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy5.getSearchCondition(proxy5.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy126.getSearchCondition(Unknown Source)\r\n	at cn.iocoder.mall.search.application.controller.users.UsersProductSearchController.condition(UsersProductSearchController.java:56)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl', 'ProductSearchServiceImpl.java', 'lambda$getSearchCondition$1', 141, '2019-05-28 18:06:30');
INSERT INTO `exception_log` VALUES (527, '79166729-8b34-4090-a3a8-e18066a7fca3', 0, 1, 'order-application', '/order-api/users/cart/calc_sku_price', 'skuId=50', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '127.0.0.1', '2019-05-28 20:37:03', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getProductSku in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.211.1:20882] (1/4) from the registry 127.0.0.1:2181 on the consumer 192.168.211.1 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getProductSku, provider: dubbo://192.168.211.1:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuPage,getProductSpuDetailListForSync,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=25236&qos.enable=false&register=true&register.ip=192.168.211.1&release=2.7.1&remote.application=product-service&remote.timestamp=1559047004576&revision=1.0.0&side=consumer&sticky=false&timestamp=1559032037343&validation=true&version=1.0.0, cause: message can not send, because channel is closed . url:dubbo://192.168.211.1:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuDetailListForSync,getProductSpuPage,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=25236&qos.enable=false&register=true&register.ip=192.168.211.1&release=2.7.1&remote.application=product-service&remote.timestamp=1559029611343&revision=1.0.0&side=consumer&sticky=false&timestamp=1559032037343&validation=true&version=1.0.0', 'RemotingException: message can not send, because channel is closed . url:dubbo://192.168.211.1:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuDetailListForSync,getProductSpuPage,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=25236&qos.enable=false&register=true&register.ip=192.168.211.1&release=2.7.1&remote.application=product-service&remote.timestamp=1559029611343&revision=1.0.0&side=consumer&sticky=false&timestamp=1559032037343&validation=true&version=1.0.0', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getProductSku in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.211.1:20882] (1/4) from the registry 127.0.0.1:2181 on the consumer 192.168.211.1 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getProductSku, provider: dubbo://192.168.211.1:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuPage,getProductSpuDetailListForSync,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=25236&qos.enable=false&register=true&register.ip=192.168.211.1&release=2.7.1&remote.application=product-service&remote.timestamp=1559047004576&revision=1.0.0&side=consumer&sticky=false&timestamp=1559032037343&validation=true&version=1.0.0, cause: message can not send, because channel is closed . url:dubbo://192.168.211.1:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuDetailListForSync,getProductSpuPage,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=25236&qos.enable=false&register=true&register.ip=192.168.211.1&release=2.7.1&remote.application=product-service&remote.timestamp=1559029611343&revision=1.0.0&side=consumer&sticky=false&timestamp=1559032037343&validation=true&version=1.0.0\r\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\r\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\r\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy2.getProductSku(proxy2.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy146.getProductSku(Unknown Source)\r\n	at cn.iocoder.mall.order.biz.service.CartServiceImpl.calcSkuPrice(CartServiceImpl.java:197)\r\n	at org.apache.dubbo.common.bytecode.Wrapper11.invokeMethod(Wrapper11.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy11.calcSkuPrice(proxy11.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy153.calcSkuPrice(Unknown Source)\r\n	at cn.iocoder.mall.order.application.controller.users.UsersCartController.calcSkuPrice(UsersCartController.java:131)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: org.apache.dubbo.remoting.RemotingException: message can not send, because channel is closed . url:dubbo://192.168.211.1:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=order-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&codec=dubbo&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&default.timeout=120000&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&heartbeat=60000&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuDetailListForSync,getProductSpuPage,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=25236&qos.enable=false&register=true&register.ip=192.168.211.1&release=2.7.1&remote.application=product-service&remote.timestamp=1559029611343&revision=1.0.0&side=consumer&sticky=false&timestamp=1559032037343&validation=true&version=1.0.0\r\n	at org.apache.dubbo.remoting.transport.AbstractClient.send(AbstractClient.java:171)\r\n	at org.apache.dubbo.remoting.transport.AbstractPeer.send(AbstractPeer.java:53)\r\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeChannel.request(HeaderExchangeChannel.java:116)\r\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeClient.request(HeaderExchangeClient.java:81)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.ReferenceCountExchangeClient.request(ReferenceCountExchangeClient.java:76)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\r\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\r\n	... 123 more\r\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-05-28 20:37:03');
INSERT INTO `exception_log` VALUES (528, 'dcb35e09-bb72-4c54-b751-3cea0432bd57', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:43:45', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy4', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\n	at com.sun.proxy.$Proxy132.getAll(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductCategoryController.tree(AdminsProductCategoryController.java:39)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\n	... 84 more\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy4\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\n	at javassist.compiler.Javac.compile(Javac.java:95)\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\n	... 86 more\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-05-30 17:43:45');
INSERT INTO `exception_log` VALUES (529, '78a63fa2-373b-446d-af16-24276814e5c8', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:43:45', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy132.getAll(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductCategoryController.tree(AdminsProductCategoryController.java:39)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-30 17:43:45');
INSERT INTO `exception_log` VALUES (530, 'eb1143f5-77b7-43c4-a4ed-18e1dcd1d32f', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:45:17', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy132.getAll(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductCategoryController.tree(AdminsProductCategoryController.java:39)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-30 17:45:17');
INSERT INTO `exception_log` VALUES (531, '9352b857-d1d7-4500-b473-67eb8b07eb18', 1, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=false&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:45:33', 'com.alibaba.fastjson.JSONException', 'JSONException: parseInt error, field : price', 'NumberFormatException: 12500000000', 'com.alibaba.fastjson.JSONException: parseInt error, field : price\n	at com.alibaba.fastjson.serializer.IntegerCodec.deserialze(IntegerCodec.java:101)\n	at com.alibaba.fastjson.parser.deserializer.DefaultFieldDeserializer.parseField(DefaultFieldDeserializer.java:85)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.parseField(JavaBeanDeserializer.java:1183)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.deserialze(JavaBeanDeserializer.java:822)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.parseRest(JavaBeanDeserializer.java:1425)\n	at com.alibaba.fastjson.parser.deserializer.FastjsonASMDeserializer_5_ProductSkuAddOrUpdateDTO.deserialze(Unknown Source)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.deserialze(JavaBeanDeserializer.java:269)\n	at com.alibaba.fastjson.parser.DefaultJSONParser.parseArray(DefaultJSONParser.java:762)\n	at com.alibaba.fastjson.parser.DefaultJSONParser.parseArray(DefaultJSONParser.java:696)\n	at com.alibaba.fastjson.parser.DefaultJSONParser.parseArray(DefaultJSONParser.java:691)\n	at com.alibaba.fastjson.JSON.parseArray(JSON.java:593)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.parseSkus(AdminsProductSpuController.java:165)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.update(AdminsProductSpuController.java:86)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.lang.NumberFormatException: 12500000000\n	at com.alibaba.fastjson.parser.JSONLexerBase.intValue(JSONLexerBase.java:1060)\n	at com.alibaba.fastjson.serializer.IntegerCodec.deserialze(IntegerCodec.java:79)\n	... 81 more\n', 'com.alibaba.fastjson.serializer.IntegerCodec', 'IntegerCodec.java', 'deserialze', 101, '2019-05-30 17:45:33');
INSERT INTO `exception_log` VALUES (532, 'a97f7485-9046-48cd-b344-95bb5695b10b', 1, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:45:54', 'com.alibaba.fastjson.JSONException', 'JSONException: parseInt error, field : price', 'NumberFormatException: 12500000000', 'com.alibaba.fastjson.JSONException: parseInt error, field : price\n	at com.alibaba.fastjson.serializer.IntegerCodec.deserialze(IntegerCodec.java:101)\n	at com.alibaba.fastjson.parser.deserializer.DefaultFieldDeserializer.parseField(DefaultFieldDeserializer.java:85)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.parseField(JavaBeanDeserializer.java:1183)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.deserialze(JavaBeanDeserializer.java:822)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.parseRest(JavaBeanDeserializer.java:1425)\n	at com.alibaba.fastjson.parser.deserializer.FastjsonASMDeserializer_5_ProductSkuAddOrUpdateDTO.deserialze(Unknown Source)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.deserialze(JavaBeanDeserializer.java:269)\n	at com.alibaba.fastjson.parser.DefaultJSONParser.parseArray(DefaultJSONParser.java:762)\n	at com.alibaba.fastjson.parser.DefaultJSONParser.parseArray(DefaultJSONParser.java:696)\n	at com.alibaba.fastjson.parser.DefaultJSONParser.parseArray(DefaultJSONParser.java:691)\n	at com.alibaba.fastjson.JSON.parseArray(JSON.java:593)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.parseSkus(AdminsProductSpuController.java:165)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.update(AdminsProductSpuController.java:86)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.lang.NumberFormatException: 12500000000\n	at com.alibaba.fastjson.parser.JSONLexerBase.intValue(JSONLexerBase.java:1060)\n	at com.alibaba.fastjson.serializer.IntegerCodec.deserialze(IntegerCodec.java:79)\n	... 81 more\n', 'com.alibaba.fastjson.serializer.IntegerCodec', 'IntegerCodec.java', 'deserialze', 101, '2019-05-30 17:45:54');
INSERT INTO `exception_log` VALUES (533, '0cdbf8d9-5a38-44ee-8e57-0ac7bc7fe65c', 92, 1, 'user-application', '/user-api/users/address/add', 'name=333&tel=13511111111&country=&province=北京市&city=北京市&county=西城区&areaCode=110102&postalCode=&addressDetail=333&isDefault=true&address=333&areaNo=110102&mobile=13511111111&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:49:58', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [333]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [333]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [333]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-30 17:49:58');
INSERT INTO `exception_log` VALUES (534, '0ac933b8-2c9a-44d6-9df5-8a30cf901e98', 92, 1, 'user-application', '/user-api/users/address/add', 'name=333&tel=13511111111&country=&province=北京市&city=北京市&county=西城区&areaCode=110102&postalCode=&addressDetail=1&isDefault=true&address=1&areaNo=110102&mobile=13511111111&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:50:39', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-30 17:50:39');
INSERT INTO `exception_log` VALUES (535, '23636185-f1ce-4a77-b371-fcb8c81cbb1c', 92, 1, 'user-application', '/user-api/users/address/add', 'name=333&tel=13511111111&country=&province=北京市&city=北京市&county=西城区&areaCode=110102&postalCode=&addressDetail=北京市商城测试地址&isDefault=true&address=北京市商城测试地址&areaNo=110102&mobile=13511111111&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:50:51', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [北京市商城测试地址]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [北京市商城测试地址]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [北京市商城测试地址]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-30 17:50:51');
INSERT INTO `exception_log` VALUES (536, '8436c17f-b245-4716-8135-05553cfc08a9', 92, 1, 'user-application', '/user-api/users/address/add', 'name=测&tel= 13666666660&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=35466777777777&isDefault=true&address=35466777777777&areaNo=110101&mobile= 13666666660&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:51:46', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13666666660]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13666666660]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13666666660]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-30 17:51:46');
INSERT INTO `exception_log` VALUES (537, '2310869c-8bc2-4d1d-8f78-877a0c3d1453', 92, 1, 'user-application', '/user-api/users/address/add', 'name=测&tel= 13666666660&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=3546677777&isDefault=true&address=3546677777&areaNo=110101&mobile= 13666666660&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:51:59', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13666666660]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13666666660]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13666666660]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-30 17:51:59');
INSERT INTO `exception_log` VALUES (538, '12fe5465-b47f-486e-9c86-96462aed6265', 92, 1, 'user-application', '/user-api/users/address/add', 'name=测&tel= 13666666660&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=3测大声道是546677777&isDefault=true&address=3测大声道是546677777&areaNo=110101&mobile= 13666666660&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:52:05', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13666666660]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13666666660]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13666666660]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-30 17:52:05');
INSERT INTO `exception_log` VALUES (539, '5b9601cb-2ed7-4585-aa1e-10d7fe35b760', 92, 1, 'user-application', '/user-api/users/address/add', 'name=测&tel= 13612345678&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=测试地址的打对方 13666&isDefault=true&address=测试地址的打对方 13666&areaNo=110101&mobile= 13612345678&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:52:29', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13612345678]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13612345678]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13612345678]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-30 17:52:29');
INSERT INTO `exception_log` VALUES (540, '8409f243-e699-44c9-abad-01a5faef0887', 92, 1, 'user-application', '/user-api/users/address/add', 'name=测&tel= 13612345678&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=测试地址的打对方 13666&isDefault=true&address=测试地址的打对方 13666&areaNo=110101&mobile= 13612345678&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:52:49', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13612345678]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13612345678]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'mobile\': rejected value [ 13612345678]; codes [Size.userAddressAddPO.mobile,Size.mobile,Size.java.lang.String,Size]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.mobile,mobile]; arguments []; default message [mobile],11,11]; default message [手机号为 11 位!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-30 17:52:49');
INSERT INTO `exception_log` VALUES (541, '518c5b99-0db0-4fad-87a6-71272898c619', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-05-30 17:59:50', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy132.getAll(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductCategoryController.tree(AdminsProductCategoryController.java:39)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-05-30 17:59:50');
INSERT INTO `exception_log` VALUES (542, '66.48.15592939078391619', 93, 1, 'user-application', '/user-api/users/address/add', 'name=1&tel=18962222222&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=3&isDefault=true&address=3&areaNo=110101&mobile=18962222222&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3 like Mac OS X) AppleWebKit/602.1.50 (KHTML, like Gecko) CriOS/56.0.2924.75 Mobile/14E5239e Safari/602.1', '114.216.22.216', '2019-05-31 17:11:48', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [3]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [3]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [3]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-05-31 17:11:48');
INSERT INTO `exception_log` VALUES (543, 'b3ba4355-1603-4206-ba76-78993bfccb79', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:28:13', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy3', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy3', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy3\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\n	at com.sun.proxy.$Proxy140.getAll(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductCategoryController.tree(AdminsProductCategoryController.java:39)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy3\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\n	... 90 more\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy3\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\n	at javassist.compiler.Javac.compile(Javac.java:95)\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\n	... 92 more\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-06-03 16:28:13');
INSERT INTO `exception_log` VALUES (544, 'b3ba4355-1603-4206-ba76-78993bfccb79', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:28:13', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy3', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy3', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy3\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\n	at com.sun.proxy.$Proxy140.getAll(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductCategoryController.tree(AdminsProductCategoryController.java:39)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy3\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\n	... 90 more\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy3\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\n	at javassist.compiler.Javac.compile(Javac.java:95)\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\n	... 92 more\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-06-03 16:28:15');
INSERT INTO `exception_log` VALUES (545, 'b3ba4355-1603-4206-ba76-78993bfccb79', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:28:13', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy3', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy3', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy3\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\n	at com.sun.proxy.$Proxy140.getAll(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductCategoryController.tree(AdminsProductCategoryController.java:39)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy3\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\n	... 90 more\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy3\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\n	at javassist.compiler.Javac.compile(Javac.java:95)\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\n	... 92 more\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-06-03 16:28:14');
INSERT INTO `exception_log` VALUES (546, '0ca098e7-28b5-4e5c-9741-4d9411a9831d', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-03 16:28:18', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.getAll(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductCategoryController.tree(AdminsProductCategoryController.java:39)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-06-03 16:28:18');
INSERT INTO `exception_log` VALUES (547, '62.89.15596128614997137', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10&payChannel=200', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '111.121.71.213', '2019-06-04 09:47:42', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n### The error may exist in class path resource [mapper/PayRefundMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT                       id, transaction_id, refund_code, app_id, create_ip, order_id,         order_description, price, status,         finish_time, notify_url, extension_data, refund_channel, refund_time, notify_time,         trade_no, create_time               FROM refund          WHERE  pay_channel = ?          LIMIT ?, ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'', 'MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n### The error may exist in class path resource [mapper/PayRefundMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT                       id, transaction_id, refund_code, app_id, create_ip, order_id,         order_description, price, status,         finish_time, notify_url, extension_data, refund_channel, refund_time, notify_time,         trade_no, create_time               FROM refund          WHERE  pay_channel = ?          LIMIT ?, ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy134.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy135.selectListByPage(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor434.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy137.selectListByPage(Unknown Source)\n	at cn.iocoder.mall.pay.biz.service.PayRefundServiceImpl.getRefundPage(PayRefundServiceImpl.java:154)\n	at cn.iocoder.mall.pay.biz.service.PayRefundServiceImpl$$FastClassBySpringCGLIB$$20ded9b7.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.pay.biz.service.PayRefundServiceImpl$$EnhancerBySpringCGLIB$$fb00a978.getRefundPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps$accessor$udHWkIOS(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$j1lwYsbN.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps$accessor$udHWkIOS(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$j1lwYsbN.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.getRefundPage(proxy4.java)\n	at sun.reflect.GeneratedMethodAccessor433.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy146.getRefundPage(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayRefundController.page$original$uwVerS3G(AdminsPayRefundController.java:53)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayRefundController.page$original$uwVerS3G$accessor$d7REhGfv(AdminsPayRefundController.java)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayRefundController$auxiliary$eKnSDkKb.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayRefundController.page(AdminsPayRefundController.java)\n	at sun.reflect.GeneratedMethodAccessor432.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$E6xJFBXh(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$E6xJFBXh$accessor$B14rviGT(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$Qx1CllIG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute$original$77pxNfs1(PreparedStatement.java:1197)\n	at com.mysql.jdbc.PreparedStatement.execute$original$77pxNfs1$accessor$VtRofi65(PreparedStatement.java)\n	at com.mysql.jdbc.PreparedStatement$auxiliary$M8aQLh7C.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute$accessor$EuHyc7E6(JDBC42PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement$auxiliary$BiUdXa1f.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute(JDBC42PreparedStatement.java)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor313.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 153 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-06-04 09:47:42');
INSERT INTO `exception_log` VALUES (548, '62.84.15596290025387363', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3472.3 Safari/537.36', '115.236.48.202', '2019-06-04 14:16:43', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n### The error may exist in class path resource [mapper/PayRefundMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT                       id, transaction_id, refund_code, app_id, create_ip, order_id,         order_description, price, status,         finish_time, notify_url, extension_data, refund_channel, refund_time, notify_time,         trade_no, create_time               FROM refund          WHERE  pay_channel = ?          LIMIT ?, ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'', 'MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n### The error may exist in class path resource [mapper/PayRefundMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT                       id, transaction_id, refund_code, app_id, create_ip, order_id,         order_description, price, status,         finish_time, notify_url, extension_data, refund_channel, refund_time, notify_time,         trade_no, create_time               FROM refund          WHERE  pay_channel = ?          LIMIT ?, ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy134.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy135.selectListByPage(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor434.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy137.selectListByPage(Unknown Source)\n	at cn.iocoder.mall.pay.biz.service.PayRefundServiceImpl.getRefundPage(PayRefundServiceImpl.java:154)\n	at cn.iocoder.mall.pay.biz.service.PayRefundServiceImpl$$FastClassBySpringCGLIB$$20ded9b7.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.pay.biz.service.PayRefundServiceImpl$$EnhancerBySpringCGLIB$$fb00a978.getRefundPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps$accessor$udHWkIOS(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$j1lwYsbN.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps$accessor$udHWkIOS(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$j1lwYsbN.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.getRefundPage(proxy4.java)\n	at sun.reflect.GeneratedMethodAccessor433.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy146.getRefundPage(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayRefundController.page$original$uwVerS3G(AdminsPayRefundController.java:53)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayRefundController.page$original$uwVerS3G$accessor$d7REhGfv(AdminsPayRefundController.java)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayRefundController$auxiliary$eKnSDkKb.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayRefundController.page(AdminsPayRefundController.java)\n	at sun.reflect.GeneratedMethodAccessor432.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$E6xJFBXh(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$E6xJFBXh$accessor$B14rviGT(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$Qx1CllIG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute$original$77pxNfs1(PreparedStatement.java:1197)\n	at com.mysql.jdbc.PreparedStatement.execute$original$77pxNfs1$accessor$VtRofi65(PreparedStatement.java)\n	at com.mysql.jdbc.PreparedStatement$auxiliary$M8aQLh7C.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute$accessor$EuHyc7E6(JDBC42PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement$auxiliary$BiUdXa1f.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute(JDBC42PreparedStatement.java)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor313.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 153 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-06-04 14:16:43');
INSERT INTO `exception_log` VALUES (549, '62.80.15598909449241013', 27, 2, 'pay-application', '/pay-api/admins/refund/page', 'pageNo=1&pageSize=10&createBeginTime=2019-06-08 15:02:01&createEndTime=2019-06-08 15:02:01&status=2&payChannel=100', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '219.134.114.161', '2019-06-07 15:02:25', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n### The error may exist in class path resource [mapper/PayRefundMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT                       id, transaction_id, refund_code, app_id, create_ip, order_id,         order_description, price, status,         finish_time, notify_url, extension_data, refund_channel, refund_time, notify_time,         trade_no, create_time               FROM refund          WHERE  create_time >= ?                                           AND ? >= create_time                                                                     AND status = ?                                           AND pay_channel = ?          LIMIT ?, ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'', 'MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n### The error may exist in class path resource [mapper/PayRefundMapper.xml]\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT                       id, transaction_id, refund_code, app_id, create_ip, order_id,         order_description, price, status,         finish_time, notify_url, extension_data, refund_channel, refund_time, notify_time,         trade_no, create_time               FROM refund          WHERE  create_time >= ?                                           AND ? >= create_time                                                                     AND status = ?                                           AND pay_channel = ?          LIMIT ?, ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy134.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy135.selectListByPage(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor434.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy137.selectListByPage(Unknown Source)\n	at cn.iocoder.mall.pay.biz.service.PayRefundServiceImpl.getRefundPage(PayRefundServiceImpl.java:154)\n	at cn.iocoder.mall.pay.biz.service.PayRefundServiceImpl$$FastClassBySpringCGLIB$$20ded9b7.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.pay.biz.service.PayRefundServiceImpl$$EnhancerBySpringCGLIB$$fb00a978.getRefundPage(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps$accessor$udHWkIOS(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$j1lwYsbN.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps$accessor$udHWkIOS(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$j1lwYsbN.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.getRefundPage(proxy4.java)\n	at sun.reflect.GeneratedMethodAccessor433.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy146.getRefundPage(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayRefundController.page$original$uwVerS3G(AdminsPayRefundController.java:53)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayRefundController.page$original$uwVerS3G$accessor$d7REhGfv(AdminsPayRefundController.java)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayRefundController$auxiliary$eKnSDkKb.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.pay.application.controller.admins.AdminsPayRefundController.page(AdminsPayRefundController.java)\n	at sun.reflect.GeneratedMethodAccessor432.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$E6xJFBXh(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$E6xJFBXh$accessor$B14rviGT(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$Qx1CllIG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'pay_channel\' in \'where clause\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute$original$77pxNfs1(PreparedStatement.java:1197)\n	at com.mysql.jdbc.PreparedStatement.execute$original$77pxNfs1$accessor$VtRofi65(PreparedStatement.java)\n	at com.mysql.jdbc.PreparedStatement$auxiliary$M8aQLh7C.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute$accessor$EuHyc7E6(JDBC42PreparedStatement.java)\n	at com.mysql.jdbc.JDBC42PreparedStatement$auxiliary$BiUdXa1f.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at com.mysql.jdbc.JDBC42PreparedStatement.execute(JDBC42PreparedStatement.java)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor313.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 153 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-06-07 15:02:25');
INSERT INTO `exception_log` VALUES (550, '58.87.15601631258074263', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=&keyword=&pageNo=&pageSize=&sortField=&sortOrder=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '218.88.125.180', '2019-06-10 18:38:46', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.search.biz.dao.ProductRepository.search(ProductRepository.java:32)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at org.springframework.data.projection.DefaultMethodInvokingMethodInterceptor.invoke(DefaultMethodInvokingMethodInterceptor.java:65)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:93)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.data.repository.core.support.SurroundingTransactionDetectorMethodInterceptor.invoke(SurroundingTransactionDetectorMethodInterceptor.java:61)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.search(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor227.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.search(Unknown Source)\n	at cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl.getSearchPage(ProductSearchServiceImpl.java:103)\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ScLXhDA3(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ScLXhDA3$accessor$gHfr9lQy(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$VnK45CU7.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ScLXhDA3(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ScLXhDA3$accessor$gHfr9lQy(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$VnK45CU7.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.getSearchPage(proxy5.java)\n	at sun.reflect.GeneratedMethodAccessor226.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.getSearchPage(Unknown Source)\n	at cn.iocoder.mall.search.application.controller.users.UsersProductSearchController.page$original$jaA1F9PZ(UsersProductSearchController.java:47)\n	at cn.iocoder.mall.search.application.controller.users.UsersProductSearchController.page$original$jaA1F9PZ$accessor$l6AbuJOC(UsersProductSearchController.java)\n	at cn.iocoder.mall.search.application.controller.users.UsersProductSearchController$auxiliary$Frvwosjp.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.search.application.controller.users.UsersProductSearchController.page(UsersProductSearchController.java)\n	at sun.reflect.GeneratedMethodAccessor225.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tFW93yrV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tFW93yrV$accessor$2JdIkZhj(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$34tPQwLt.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.search.biz.dao.ProductRepository', 'ProductRepository.java', 'search', 32, '2019-06-10 18:38:46');
INSERT INTO `exception_log` VALUES (551, '65.49.15602395791506381', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.173.28.175', '2019-06-11 15:52:59', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 15:52:59');
INSERT INTO `exception_log` VALUES (552, '65.52.15602395891046361', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '59.173.28.175', '2019-06-11 15:53:09', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 15:53:09');
INSERT INTO `exception_log` VALUES (553, '66.51.15602396324844379', 118, 1, 'user-application', '/user-api/users/address/add', 'name=3213&tel=15556906631&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=111&isDefault=true&address=111&areaNo=110101&mobile=15556906631&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:52', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 15:53:53');
INSERT INTO `exception_log` VALUES (554, '66.52.15602396341194375', 118, 1, 'user-application', '/user-api/users/address/add', 'name=3213&tel=15556906631&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=111&isDefault=true&address=111&areaNo=110101&mobile=15556906631&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:54', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 15:53:54');
INSERT INTO `exception_log` VALUES (555, '66.56.15602396359404375', 118, 1, 'user-application', '/user-api/users/address/add', 'name=3213&tel=15556906631&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=111&isDefault=true&address=111&areaNo=110101&mobile=15556906631&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:56', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 15:53:56');
INSERT INTO `exception_log` VALUES (556, '66.48.15602396377604385', 118, 1, 'user-application', '/user-api/users/address/add', 'name=3213&tel=15556906631&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=111&isDefault=true&address=111&areaNo=110101&mobile=15556906631&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:53:58', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 15:53:58');
INSERT INTO `exception_log` VALUES (557, '66.51.15602396697394381', 118, 1, 'user-application', '/user-api/users/address/add', 'name=3213&tel=15556906631&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=111&isDefault=true&address=111&areaNo=110101&mobile=15556906631&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:54:30', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 15:54:30');
INSERT INTO `exception_log` VALUES (558, '66.49.15602396792594389', 118, 1, 'user-application', '/user-api/users/address/add', 'name=3213&tel=15556906631&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=111&isDefault=true&address=111&areaNo=110101&mobile=15556906631&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 10_3_1 like Mac OS X) AppleWebKit/603.1.30 (KHTML, like Gecko) Version/10.0 Mobile/14E304 Safari/602.1', '114.222.120.209', '2019-06-11 15:54:39', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 15:54:39');
INSERT INTO `exception_log` VALUES (559, '65.51.15602397550846369', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.90.244', '2019-06-11 15:55:55', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 15:55:55');
INSERT INTO `exception_log` VALUES (560, '65.52.15602400519706371', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:52', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 16:00:52');
INSERT INTO `exception_log` VALUES (561, '65.46.15602400558666365', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '114.222.120.209', '2019-06-11 16:00:56', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 16:00:56');
INSERT INTO `exception_log` VALUES (562, '65.50.15602408382626389', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '117.136.45.143', '2019-06-11 16:13:58', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 16:13:58');
INSERT INTO `exception_log` VALUES (563, '65.54.15602408629866343', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1.1 Safari/605.1.15', '117.136.45.143', '2019-06-11 16:14:23', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 16:14:23');
INSERT INTO `exception_log` VALUES (564, '65.3607.15602436555318181', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:00:56', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 17:00:56');
INSERT INTO `exception_log` VALUES (565, '65.49.15602436654366443', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:01:05', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 17:01:05');
INSERT INTO `exception_log` VALUES (566, '65.54.15602436951036385', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.80 Safari/537.36', '125.118.64.136', '2019-06-11 17:01:35', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 17:01:35');
INSERT INTO `exception_log` VALUES (567, '65.50.15602457801496461', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.19.1.62', '2019-06-11 17:36:20', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 17:36:20');
INSERT INTO `exception_log` VALUES (568, 'c77b2701-d498-48d0-b591-cc725e096c87', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-11 18:50:44', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy5', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\r\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\r\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\r\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\r\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\r\n	at com.sun.proxy.$Proxy131.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\r\n	... 90 more\r\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\r\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\r\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\r\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\r\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\r\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\r\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\r\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\r\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\r\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\r\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\r\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\r\n	at javassist.compiler.Javac.compile(Javac.java:95)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\r\n	... 92 more\r\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-06-11 18:50:46');
INSERT INTO `exception_log` VALUES (569, 'c77b2701-d498-48d0-b591-cc725e096c87', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-11 18:50:44', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy5', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\r\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\r\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\r\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\r\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\r\n	at com.sun.proxy.$Proxy131.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\r\n	... 90 more\r\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\r\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\r\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\r\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\r\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\r\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\r\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\r\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\r\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\r\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\r\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\r\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\r\n	at javassist.compiler.Javac.compile(Javac.java:95)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\r\n	... 92 more\r\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-06-11 18:50:46');
INSERT INTO `exception_log` VALUES (570, 'c77b2701-d498-48d0-b591-cc725e096c87', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '127.0.0.1', '2019-06-11 18:50:44', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy5', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\r\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\r\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\r\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\r\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\r\n	at com.sun.proxy.$Proxy131.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\r\n	... 90 more\r\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\r\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\r\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\r\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\r\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\r\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\r\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\r\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\r\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\r\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\r\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\r\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\r\n	at javassist.compiler.Javac.compile(Javac.java:95)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\r\n	... 92 more\r\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-06-11 18:50:46');
INSERT INTO `exception_log` VALUES (571, 'd63b829d-dce7-4d3b-8804-1c9a1ff2c102', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:51:10', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy131.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-06-11 18:51:10');
INSERT INTO `exception_log` VALUES (572, 'eef78889-e058-4aa8-ac20-13580a768872', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:51:37', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy131.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-06-11 18:51:37');
INSERT INTO `exception_log` VALUES (573, 'ff07fa22-a517-463c-a75e-dee45189b564', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:52:14', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy131.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-06-11 18:52:14');
INSERT INTO `exception_log` VALUES (574, '8843d56e-b8ba-4f00-8062-af35642fecc4', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:52:48', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy131.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-06-11 18:52:48');
INSERT INTO `exception_log` VALUES (575, '7e0ad298-caa7-4980-8b45-e26a5c4d2102', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:53:33', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy131.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-06-11 18:53:33');
INSERT INTO `exception_log` VALUES (576, '805a89b7-0b2c-4059-8e56-f37babf71dba', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:54:38', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy131.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-06-11 18:54:38');
INSERT INTO `exception_log` VALUES (577, '6e335ae6-f6ee-45e1-b641-1b9ba8ca5b62', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:54:57', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy131.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-06-11 18:54:57');
INSERT INTO `exception_log` VALUES (578, '037d97d1-eabf-471e-a89d-30d8aa06ae7b', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 18:55:38', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy131.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-06-11 18:55:38');
INSERT INTO `exception_log` VALUES (579, 'd651df81-ed97-4917-a26b-7eda3dd02bfe', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:00:57', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy131.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-06-11 19:00:57');
INSERT INTO `exception_log` VALUES (580, 'f4d74c0c-930d-441c-8b41-919f882b4fa0', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:01:05', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy131.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-06-11 19:01:05');
INSERT INTO `exception_log` VALUES (581, '9eecda78-75e6-468e-aff0-517731c6001c', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:03:26', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy131.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-06-11 19:03:27');
INSERT INTO `exception_log` VALUES (582, '05f9a7e0-26cf-4d62-88ad-72acc68bfbd6', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-06-11 19:29:16', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [172.16.21.146:20881, 172.16.21.146:20882] (2/2) from the registry 127.0.0.1:2181 on the consumer 172.16.21.146 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getProductSpuList, provider: dubbo://172.16.21.146:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuPage,getProductSpuDetailListForSync,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=10756&qos.enable=false&register=true&register.ip=172.16.21.146&release=2.7.1&remote.application=product-service&remote.timestamp=1560241172881&revision=1.0.0&side=consumer&sticky=false&timestamp=1560252214395&validation=true&version=1.0.0, cause: org.apache.dubbo.remoting.RemotingException: Not found exported service: cn.iocoder.mall.product.api.ProductSpuService:1.0.0:20882 in [cn.iocoder.mall.pay.api.PayRefundService:1.0.0:20882, cn.iocoder.mall.pay.api.PayTransactionService:1.0.0:20882], may be version or group mismatch , channel: consumer: /172.16.21.146:62186 --> provider: /172.16.21.146:20882, message:RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, input=266, dubbo=2.0.2, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]\r\norg.apache.dubbo.remoting.RemotingException: Not found exported service: cn.iocoder.mall.product.api.ProductSpuService:1.0.0:20882 in [cn.iocoder.mall.pay.api.PayRefundService:1.0.0:20882, cn.iocoder.mall.pay.api.PayTransactionService:1.0.0:20882], may be version or group mismatch , channel: consumer: /172.16.21.146:62186 --> provider: /172.16.21.146:20882, message:RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, input=266, dubbo=2.0.2, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]\r\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol.getInvoker(DubboProtocol.java:248)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:102)\r\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\r\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\r\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\r\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'RemotingException: org.apache.dubbo.remoting.RemotingException: Not found exported service: cn.iocoder.mall.product.api.ProductSpuService:1.0.0:20882 in [cn.iocoder.mall.pay.api.PayRefundService:1.0.0:20882, cn.iocoder.mall.pay.api.PayTransactionService:1.0.0:20882], may be version or group mismatch , channel: consumer: /172.16.21.146:62186 --> provider: /172.16.21.146:20882, message:RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, input=266, dubbo=2.0.2, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]\r\norg.apache.dubbo.remoting.RemotingException: Not found exported service: cn.iocoder.mall.product.api.ProductSpuService:1.0.0:20882 in [cn.iocoder.mall.pay.api.PayRefundService:1.0.0:20882, cn.iocoder.mall.pay.api.PayTransactionService:1.0.0:20882], may be version or group mismatch , channel: consumer: /172.16.21.146:62186 --> provider: /172.16.21.146:20882, message:RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, input=266, dubbo=2.0.2, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]\r\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol.getInvoker(DubboProtocol.java:248)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:102)\r\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\r\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\r\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\r\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [172.16.21.146:20881, 172.16.21.146:20882] (2/2) from the registry 127.0.0.1:2181 on the consumer 172.16.21.146 using the dubbo version 2.7.1. Last error is: Failed to invoke remote method: getProductSpuList, provider: dubbo://172.16.21.146:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuPage,getProductSpuDetailListForSync,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=10756&qos.enable=false&register=true&register.ip=172.16.21.146&release=2.7.1&remote.application=product-service&remote.timestamp=1560241172881&revision=1.0.0&side=consumer&sticky=false&timestamp=1560252214395&validation=true&version=1.0.0, cause: org.apache.dubbo.remoting.RemotingException: Not found exported service: cn.iocoder.mall.product.api.ProductSpuService:1.0.0:20882 in [cn.iocoder.mall.pay.api.PayRefundService:1.0.0:20882, cn.iocoder.mall.pay.api.PayTransactionService:1.0.0:20882], may be version or group mismatch , channel: consumer: /172.16.21.146:62186 --> provider: /172.16.21.146:20882, message:RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, input=266, dubbo=2.0.2, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]\r\norg.apache.dubbo.remoting.RemotingException: Not found exported service: cn.iocoder.mall.product.api.ProductSpuService:1.0.0:20882 in [cn.iocoder.mall.pay.api.PayRefundService:1.0.0:20882, cn.iocoder.mall.pay.api.PayTransactionService:1.0.0:20882], may be version or group mismatch , channel: consumer: /172.16.21.146:62186 --> provider: /172.16.21.146:20882, message:RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, input=266, dubbo=2.0.2, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]\r\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol.getInvoker(DubboProtocol.java:248)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:102)\r\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\r\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\r\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\r\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n\r\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\r\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\r\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy0.getProductSpuList(proxy0.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy141.getProductSpuList(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:43)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: org.apache.dubbo.remoting.RemotingException: org.apache.dubbo.remoting.RemotingException: Not found exported service: cn.iocoder.mall.product.api.ProductSpuService:1.0.0:20882 in [cn.iocoder.mall.pay.api.PayRefundService:1.0.0:20882, cn.iocoder.mall.pay.api.PayTransactionService:1.0.0:20882], may be version or group mismatch , channel: consumer: /172.16.21.146:62186 --> provider: /172.16.21.146:20882, message:RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, input=266, dubbo=2.0.2, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]\r\norg.apache.dubbo.remoting.RemotingException: Not found exported service: cn.iocoder.mall.product.api.ProductSpuService:1.0.0:20882 in [cn.iocoder.mall.pay.api.PayRefundService:1.0.0:20882, cn.iocoder.mall.pay.api.PayTransactionService:1.0.0:20882], may be version or group mismatch , channel: consumer: /172.16.21.146:62186 --> provider: /172.16.21.146:20882, message:RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, input=266, dubbo=2.0.2, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]\r\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol.getInvoker(DubboProtocol.java:248)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboProtocol$1.reply(DubboProtocol.java:102)\r\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.handleRequest(HeaderExchangeHandler.java:103)\r\n	at org.apache.dubbo.remoting.exchange.support.header.HeaderExchangeHandler.received(HeaderExchangeHandler.java:200)\r\n	at org.apache.dubbo.remoting.transport.DecodeHandler.received(DecodeHandler.java:51)\r\n	at org.apache.dubbo.remoting.transport.dispatcher.ChannelEventRunnable.run(ChannelEventRunnable.java:57)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n\r\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:297)\r\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\r\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\r\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\r\n	... 86 more\r\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-06-11 19:29:16');
INSERT INTO `exception_log` VALUES (583, '65.46.15602552009156579', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:13:21', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 20:13:21');
INSERT INTO `exception_log` VALUES (584, '65.47.15602552061976573', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '112.10.84.187', '2019-06-11 20:13:26', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 20:13:26');
INSERT INTO `exception_log` VALUES (585, '65.47.15602552603676575', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '180.164.56.129', '2019-06-11 20:14:20', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 20:14:20');
INSERT INTO `exception_log` VALUES (586, '66.51.15602552827054593', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=12312332333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=false&address=23&areaNo=110101&mobile=12312332333&hasDefault=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:14:43', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:14:43');
INSERT INTO `exception_log` VALUES (587, '66.50.15602552848724583', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=12312332333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=false&address=23&areaNo=110101&mobile=12312332333&hasDefault=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:14:45', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:14:45');
INSERT INTO `exception_log` VALUES (588, '66.49.15602552860314605', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=12312332333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=false&address=23&areaNo=110101&mobile=12312332333&hasDefault=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:14:46', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:14:46');
INSERT INTO `exception_log` VALUES (589, '66.54.15602552956054593', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=false&address=23&areaNo=110101&mobile=13514532333&hasDefault=1', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:14:56', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:14:56');
INSERT INTO `exception_log` VALUES (590, '66.57.15602553002924595', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:00', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:15:00');
INSERT INTO `exception_log` VALUES (591, '66.53.15602553015874589', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:02', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:15:02');
INSERT INTO `exception_log` VALUES (592, '66.51.15602553017994595', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:02', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:15:02');
INSERT INTO `exception_log` VALUES (593, '66.51.15602553017994595', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:02', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:15:03');
INSERT INTO `exception_log` VALUES (594, '66.55.15602553012564589', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:02', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:15:02');
INSERT INTO `exception_log` VALUES (595, '66.52.15602553023164593', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:02', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:15:02');
INSERT INTO `exception_log` VALUES (596, '66.55.15602553012564589', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:02', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:15:03');
INSERT INTO `exception_log` VALUES (597, '66.49.15602553019704607', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:03', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:15:03');
INSERT INTO `exception_log` VALUES (598, '66.55.15602553012564589', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:02', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:15:04');
INSERT INTO `exception_log` VALUES (599, '66.52.15602553023164593', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:02', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:15:03');
INSERT INTO `exception_log` VALUES (600, '66.49.15602553019704607', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:03', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:15:04');
INSERT INTO `exception_log` VALUES (601, '66.50.15602553021354585', 121, 1, 'user-application', '/user-api/users/address/add', 'name=23&tel=13514532333&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=23&isDefault=true&address=23&areaNo=110101&mobile=13514532333&hasDefault=2', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '124.204.66.82', '2019-06-11 20:15:04', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [23]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-11 20:15:04');
INSERT INTO `exception_log` VALUES (602, '65.52.15602570772216617', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:44:37', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 20:44:37');
INSERT INTO `exception_log` VALUES (603, '65.50.15602570888566617', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '223.104.7.132', '2019-06-11 20:44:49', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 20:44:49');
INSERT INTO `exception_log` VALUES (604, '65.46.15602627800296687', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:67.0) Gecko/20100101 Firefox/67.0', '59.47.37.199', '2019-06-11 22:19:40', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 22:19:40');
INSERT INTO `exception_log` VALUES (605, '65.52.15602642458636719', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:44:06', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 22:44:06');
INSERT INTO `exception_log` VALUES (606, '65.45.15602642549436719', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/12.1 Safari/605.1.15', '27.8.134.154', '2019-06-11 22:44:15', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 22:44:15');
INSERT INTO `exception_log` VALUES (607, '65.50.15602650195216733', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '223.166.231.118', '2019-06-11 22:57:00', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-11 22:57:00');
INSERT INTO `exception_log` VALUES (608, '65.52.15602999288077199', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:38:49', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 08:38:49');
INSERT INTO `exception_log` VALUES (609, '65.53.15602999397477163', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '58.243.250.13', '2019-06-12 08:39:00', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 08:39:00');
INSERT INTO `exception_log` VALUES (610, '65.49.15603000501667215', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '58.248.159.4', '2019-06-12 08:40:50', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 08:40:50');
INSERT INTO `exception_log` VALUES (611, '65.54.15603036253977205', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:40:25', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 09:40:25');
INSERT INTO `exception_log` VALUES (612, '65.46.15603036319437245', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:40:32', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 09:40:32');
INSERT INTO `exception_log` VALUES (613, '65.47.15603036623797237', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '183.157.5.186', '2019-06-12 09:41:02', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 09:41:02');
INSERT INTO `exception_log` VALUES (614, '65.51.15603042330417261', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.22.197.198', '2019-06-12 09:50:33', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 09:50:33');
INSERT INTO `exception_log` VALUES (615, '65.49.15603059423147301', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:19:02', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 10:19:02');
INSERT INTO `exception_log` VALUES (616, '65.47.15603059477977271', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:19:08', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 10:19:08');
INSERT INTO `exception_log` VALUES (617, '65.54.15603059488757241', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '101.87.220.13', '2019-06-12 10:19:09', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 10:19:09');
INSERT INTO `exception_log` VALUES (618, '65.50.15603068031257305', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '182.150.24.71', '2019-06-12 10:33:23', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 10:33:23');
INSERT INTO `exception_log` VALUES (619, '65.3607.15603100876479101', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.224.234.14', '2019-06-12 11:28:08', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 11:28:08');
INSERT INTO `exception_log` VALUES (620, '65.53.15603104894077321', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '218.17.162.87', '2019-06-12 11:34:49', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 11:34:49');
INSERT INTO `exception_log` VALUES (621, '65.3607.15603117829829127', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:23', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 11:56:23');
INSERT INTO `exception_log` VALUES (622, '65.52.15603117902947375', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:30', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 11:56:30');
INSERT INTO `exception_log` VALUES (623, '65.49.15603118190607389', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '61.156.119.218', '2019-06-12 11:56:59', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 11:56:59');
INSERT INTO `exception_log` VALUES (624, '65.49.15603135038177413', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:25:04', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 12:25:04');
INSERT INTO `exception_log` VALUES (625, '65.52.15603135232747401', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:25:24', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 12:25:24');
INSERT INTO `exception_log` VALUES (626, '65.3607.15603135271769155', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '73.211.227.144', '2019-06-12 12:25:27', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 12:25:27');
INSERT INTO `exception_log` VALUES (627, '65.49.15603194543257495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:14', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 14:04:14');
INSERT INTO `exception_log` VALUES (628, '65.52.15603194595717485', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:20', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 14:04:20');
INSERT INTO `exception_log` VALUES (629, '65.3607.15603194825249239', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:43', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 14:04:43');
INSERT INTO `exception_log` VALUES (630, '65.45.15603194954407491', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:04:55', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 14:04:55');
INSERT INTO `exception_log` VALUES (631, '65.46.15603195177587481', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:05:18', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 14:05:18');
INSERT INTO `exception_log` VALUES (632, '65.47.15603195879097473', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:06:28', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 14:06:28');
INSERT INTO `exception_log` VALUES (633, '65.52.15603199352807495', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:12:15', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 14:12:15');
INSERT INTO `exception_log` VALUES (634, '65.3607.15603199471049249', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.157 Safari/537.36', '183.13.204.65', '2019-06-12 14:12:27', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 14:12:27');
INSERT INTO `exception_log` VALUES (635, '65.54.15603211538157473', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:32:34', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 14:32:34');
INSERT INTO `exception_log` VALUES (636, '65.52.15603211639957517', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '222.211.204.249', '2019-06-12 14:32:44', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 14:32:44');
INSERT INTO `exception_log` VALUES (637, '65.50.15603217830577531', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.96 Safari/537.36', '61.163.210.202', '2019-06-12 14:43:03', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 14:43:03');
INSERT INTO `exception_log` VALUES (638, '65.53.15603233578197517', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3626.119 Safari/537.36', '123.233.246.107', '2019-06-12 15:09:18', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 15:09:18');
INSERT INTO `exception_log` VALUES (639, '65.3607.15603238480549309', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:17:28', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 15:17:28');
INSERT INTO `exception_log` VALUES (640, '65.50.15603238735837563', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.110 Safari/537.36', '220.181.38.109', '2019-06-12 15:17:54', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 15:17:54');
INSERT INTO `exception_log` VALUES (641, '65.45.15603240595567565', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:21:00', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 15:21:00');
INSERT INTO `exception_log` VALUES (642, '65.53.15603240669357533', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:21:07', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 15:21:07');
INSERT INTO `exception_log` VALUES (643, '65.46.15603249116517569', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '36.102.10.145', '2019-06-12 15:35:12', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 15:35:12');
INSERT INTO `exception_log` VALUES (644, '65.47.15603253322867565', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:12', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 15:42:12');
INSERT INTO `exception_log` VALUES (645, '65.3607.15603253503539339', 27, 2, 'admin-application', '/admin-api/admins/admin/menu_resource_tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '123.52.42.83', '2019-06-12 15:42:30', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.lambda$menuResourceTree$2(AdminController.java:66)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.accept(ForEachOps.java:184)\n	at java.util.stream.ReferencePipeline$2$1.accept(ReferencePipeline.java:175)\n	at java.util.Iterator.forEachRemaining(Iterator.java:116)\n	at java.util.Spliterators$IteratorSpliterator.forEachRemaining(Spliterators.java:1801)\n	at java.util.stream.AbstractPipeline.copyInto(AbstractPipeline.java:481)\n	at java.util.stream.AbstractPipeline.wrapAndCopyInto(AbstractPipeline.java:471)\n	at java.util.stream.ForEachOps$ForEachOp.evaluateSequential(ForEachOps.java:151)\n	at java.util.stream.ForEachOps$ForEachOp$OfRef.evaluateSequential(ForEachOps.java:174)\n	at java.util.stream.AbstractPipeline.evaluate(AbstractPipeline.java:234)\n	at java.util.stream.ReferencePipeline.forEach(ReferencePipeline.java:418)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF(AdminController.java:63)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree$original$RSBltCBF$accessor$zG2gPmyv(AdminController.java)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController$auxiliary$AycjO4r3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.menuResourceTree(AdminController.java)\n	at sun.reflect.GeneratedMethodAccessor742.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.admin.application.controller.admins.AdminController', 'AdminController.java', 'lambda$menuResourceTree$2', 66, '2019-06-12 15:42:30');
INSERT INTO `exception_log` VALUES (646, '66.49.15605100777048013', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:18', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-14 19:01:18');
INSERT INTO `exception_log` VALUES (647, '66.52.15605100792598011', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:19', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-14 19:01:19');
INSERT INTO `exception_log` VALUES (648, '66.54.15605100837298007', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11222&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:24', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-14 19:01:24');
INSERT INTO `exception_log` VALUES (649, '66.53.15605100859648005', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11222&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:26', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-14 19:01:26');
INSERT INTO `exception_log` VALUES (650, '66.55.15605100871238001', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11222&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:27', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-14 19:01:27');
INSERT INTO `exception_log` VALUES (651, '66.51.15605100881878009', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11222&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:28', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-14 19:01:28');
INSERT INTO `exception_log` VALUES (652, '66.48.15605100891898017', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11222&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:29', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-14 19:01:29');
INSERT INTO `exception_log` VALUES (653, '66.49.15605101032678015', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11222&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:01:43', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-14 19:01:43');
INSERT INTO `exception_log` VALUES (654, '66.56.15605101308928011', 125, 1, 'user-application', '/user-api/users/address/add', 'name=11222&tel=17758710030&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=120102&mobile=17758710030&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Mobile Safari/537.36', '61.131.96.155', '2019-06-14 19:02:11', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-14 19:02:11');
INSERT INTO `exception_log` VALUES (655, '64.76.15608356595373935', 1, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=true&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '122.235.213.224', '2019-06-18 13:27:40', 'com.alibaba.fastjson.JSONException', 'JSONException: parseInt error, field : price', 'NumberFormatException: 12500000000', 'com.alibaba.fastjson.JSONException: parseInt error, field : price\n	at com.alibaba.fastjson.serializer.IntegerCodec.deserialze(IntegerCodec.java:101)\n	at com.alibaba.fastjson.parser.deserializer.DefaultFieldDeserializer.parseField(DefaultFieldDeserializer.java:85)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.parseField(JavaBeanDeserializer.java:1183)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.deserialze(JavaBeanDeserializer.java:822)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.parseRest(JavaBeanDeserializer.java:1425)\n	at com.alibaba.fastjson.parser.deserializer.FastjsonASMDeserializer_5_ProductSkuAddOrUpdateDTO.deserialze(Unknown Source)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.deserialze(JavaBeanDeserializer.java:269)\n	at com.alibaba.fastjson.parser.DefaultJSONParser.parseArray(DefaultJSONParser.java:762)\n	at com.alibaba.fastjson.parser.DefaultJSONParser.parseArray(DefaultJSONParser.java:696)\n	at com.alibaba.fastjson.parser.DefaultJSONParser.parseArray(DefaultJSONParser.java:691)\n	at com.alibaba.fastjson.JSON.parseArray(JSON.java:593)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.parseSkus(AdminsProductSpuController.java:165)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.update$original$pMLWVoQz(AdminsProductSpuController.java:86)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.update$original$pMLWVoQz$accessor$3Lvpt4vw(AdminsProductSpuController.java)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController$auxiliary$WveSZHUR.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.update(AdminsProductSpuController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0$accessor$7vT1VInN(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$iFD4aFHO.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.lang.NumberFormatException: 12500000000\n	at com.alibaba.fastjson.parser.JSONLexerBase.intValue(JSONLexerBase.java:1060)\n	at com.alibaba.fastjson.serializer.IntegerCodec.deserialze(IntegerCodec.java:79)\n	... 95 more\n', 'com.alibaba.fastjson.serializer.IntegerCodec', 'IntegerCodec.java', 'deserialze', 101, '2019-06-18 13:27:40');
INSERT INTO `exception_log` VALUES (656, '66.50.15610994185205893', 132, 1, 'user-application', '/user-api/users/address/add', 'name=12&tel=18105822099&country=&province=北京市&city=北京市&county=西城区&areaCode=110102&postalCode=&addressDetail=12121&isDefault=true&address=12121&areaNo=110102&mobile=18105822099&hasDefault=2', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:43:39', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12121]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12121]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12121]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-21 14:43:39');
INSERT INTO `exception_log` VALUES (657, '66.52.15610994205845901', 132, 1, 'user-application', '/user-api/users/address/add', 'name=12&tel=18105822099&country=&province=北京市&city=北京市&county=西城区&areaCode=110102&postalCode=&addressDetail=12121&isDefault=true&address=12121&areaNo=110102&mobile=18105822099&hasDefault=2', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36', '115.236.62.130', '2019-06-21 14:43:41', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12121]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12121]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12121]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-21 14:43:41');
INSERT INTO `exception_log` VALUES (658, '65.52.15612669066050877', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '119.145.82.204', '2019-06-23 13:15:07', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.IdentityOutputFilter.flush(IdentityOutputFilter.java:117)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 82 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-06-23 13:15:07');
INSERT INTO `exception_log` VALUES (659, '66.50.15612877472028405', 134, 1, 'user-application', '/user-api/users/address/add', 'name=sdf&tel=19181109112&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=dsfds&isDefault=true&address=dsfds&areaNo=110101&mobile=19181109112&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '118.114.112.196', '2019-06-23 19:02:27', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dsfds]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dsfds]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dsfds]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-23 19:02:27');
INSERT INTO `exception_log` VALUES (660, '66.51.15613566927349351', 136, 1, 'user-application', '/user-api/users/address/add', 'name=陈飞龙&tel=18682256725&country=&province=广东省&city=深圳市&county=罗湖区&areaCode=440303&postalCode=&addressDetail=深城投中心&isDefault=true&address=深城投中心&areaNo=440303&mobile=18682256725&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:11:33', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [深城投中心]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [深城投中心]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [深城投中心]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-24 14:11:33');
INSERT INTO `exception_log` VALUES (661, '66.56.15613566948929345', 136, 1, 'user-application', '/user-api/users/address/add', 'name=陈飞龙&tel=18682256725&country=&province=广东省&city=深圳市&county=罗湖区&areaCode=440303&postalCode=&addressDetail=深城投中心&isDefault=true&address=深城投中心&areaNo=440303&mobile=18682256725&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.90 Mobile Safari/537.36', '113.118.190.227', '2019-06-24 14:11:35', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [深城投中心]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [深城投中心]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [深城投中心]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-24 14:11:35');
INSERT INTO `exception_log` VALUES (662, '66.57.15613603925459393', 137, 1, 'user-application', '/user-api/users/address/add', 'name=123&tel=18408221234&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=2131&isDefault=true&address=2131&areaNo=110101&mobile=18408221234&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:13', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [2131]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [2131]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [2131]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-24 15:13:13');
INSERT INTO `exception_log` VALUES (663, '66.54.15613603944939397', 137, 1, 'user-application', '/user-api/users/address/add', 'name=123&tel=18408221234&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=2131&isDefault=true&address=2131&areaNo=110101&mobile=18408221234&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-24 15:13:15', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [2131]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [2131]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [2131]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-24 15:13:15');
INSERT INTO `exception_log` VALUES (664, '66.55.15614557624590669', 0, 1, 'user-application', '/user-api/users/address/add', 'name=1&tel=18408221234&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=1&isDefault=false&address=1&areaNo=110101&mobile=18408221234&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-25 17:42:42', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-25 17:42:42');
INSERT INTO `exception_log` VALUES (665, '66.56.15615408940101829', 0, 1, 'user-application', '/user-api/users/address/add', 'name=1&tel=18408221234&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=1&isDefault=false&address=1&areaNo=110101&mobile=18408221234&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Mobile Safari/537.36', '116.1.72.75', '2019-06-26 17:21:34', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-26 17:21:34');
INSERT INTO `exception_log` VALUES (666, '58.85.15617008649334917', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=&keyword=&pageNo=&pageSize=&sortField=&sortOrder=', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:67.0) Gecko/20100101 Firefox/67.0', '211.145.41.161', '2019-06-28 13:47:45', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.search.biz.dao.ProductRepository.search(ProductRepository.java:32)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at org.springframework.data.projection.DefaultMethodInvokingMethodInterceptor.invoke(DefaultMethodInvokingMethodInterceptor.java:65)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:93)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.data.repository.core.support.SurroundingTransactionDetectorMethodInterceptor.invoke(SurroundingTransactionDetectorMethodInterceptor.java:61)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.search(Unknown Source)\n	at sun.reflect.GeneratedMethodAccessor227.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy132.search(Unknown Source)\n	at cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl.getSearchPage(ProductSearchServiceImpl.java:103)\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ScLXhDA3(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ScLXhDA3$accessor$gHfr9lQy(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$VnK45CU7.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ScLXhDA3(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$ScLXhDA3$accessor$gHfr9lQy(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$VnK45CU7.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.getSearchPage(proxy5.java)\n	at sun.reflect.GeneratedMethodAccessor226.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy138.getSearchPage(Unknown Source)\n	at cn.iocoder.mall.search.application.controller.users.UsersProductSearchController.page$original$jaA1F9PZ(UsersProductSearchController.java:47)\n	at cn.iocoder.mall.search.application.controller.users.UsersProductSearchController.page$original$jaA1F9PZ$accessor$l6AbuJOC(UsersProductSearchController.java)\n	at cn.iocoder.mall.search.application.controller.users.UsersProductSearchController$auxiliary$Frvwosjp.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.search.application.controller.users.UsersProductSearchController.page(UsersProductSearchController.java)\n	at sun.reflect.GeneratedMethodAccessor225.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tFW93yrV(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$tFW93yrV$accessor$2JdIkZhj(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$34tPQwLt.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.search.biz.dao.ProductRepository', 'ProductRepository.java', 'search', 32, '2019-06-28 13:47:45');
INSERT INTO `exception_log` VALUES (667, '8122407b-e766-4334-b63d-799059a1c408', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:46:10', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy5', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\r\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\r\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\r\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\r\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\r\n	at com.sun.proxy.$Proxy132.getProductRecommendList(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:40)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\r\n	... 90 more\r\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\r\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\r\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\r\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\r\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\r\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\r\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\r\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\r\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\r\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\r\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\r\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\r\n	at javassist.compiler.Javac.compile(Javac.java:95)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\r\n	... 92 more\r\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-06-30 15:46:16');
INSERT INTO `exception_log` VALUES (668, '8122407b-e766-4334-b63d-799059a1c408', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:46:10', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy5', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\r\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\r\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\r\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\r\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\r\n	at com.sun.proxy.$Proxy132.getProductRecommendList(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:40)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\r\n	... 90 more\r\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\r\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\r\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\r\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\r\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\r\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\r\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\r\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\r\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\r\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\r\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\r\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\r\n	at javassist.compiler.Javac.compile(Javac.java:95)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\r\n	... 92 more\r\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-06-30 15:46:16');
INSERT INTO `exception_log` VALUES (669, '8122407b-e766-4334-b63d-799059a1c408', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:46:10', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy5', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\r\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\r\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\r\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\r\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\r\n	at com.sun.proxy.$Proxy132.getProductRecommendList(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:40)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\r\n	... 90 more\r\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\r\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\r\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\r\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\r\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\r\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\r\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\r\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\r\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\r\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\r\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\r\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\r\n	at javassist.compiler.Javac.compile(Javac.java:95)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\r\n	... 92 more\r\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-06-30 15:46:17');
INSERT INTO `exception_log` VALUES (670, '2fa23737-e312-4392-8f0c-cba278d1adda', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-06-30 15:46:23', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy132.getProductRecommendList(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:40)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-06-30 15:46:23');
INSERT INTO `exception_log` VALUES (671, '66.56.15618977953726605', 143, 1, 'user-application', '/user-api/users/address/add', 'name=单独&tel=13818938640&country=&province=上海市&city=上海市&county=黄浦区&areaCode=310101&postalCode=&addressDetail=123123&isDefault=true&address=123123&areaNo=310101&mobile=13818938640&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:29:55', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-30 20:29:55');
INSERT INTO `exception_log` VALUES (672, '66.52.15618977983276595', 143, 1, 'user-application', '/user-api/users/address/add', 'name=单独&tel=13818938640&country=&province=上海市&city=上海市&county=黄浦区&areaCode=310101&postalCode=&addressDetail=123123&isDefault=true&address=123123&areaNo=310101&mobile=13818938640&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 7.1.2; Redmi 4X Build/N2G47H; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044705 Mobile Safari/537.36 MMWEBID/3516 MicroMessenger/7.0.4.1420(0x27000435) Process/tools NetType/4G Language/zh_CN', '223.104.210.149', '2019-06-30 20:29:58', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [123123]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-06-30 20:29:58');
INSERT INTO `exception_log` VALUES (673, '66.57.15619791419387689', 146, 1, 'user-application', '/user-api/users/address/add', 'name=jjj&tel=13701501490&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=jjjjjjj&isDefault=false&address=jjjjjjj&areaNo=110101&mobile=13701501490&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:05:42', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [jjjjjjj]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [jjjjjjj]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [jjjjjjj]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-01 19:05:42');
INSERT INTO `exception_log` VALUES (674, '66.53.15619791459097683', 146, 1, 'user-application', '/user-api/users/address/add', 'name=jjj&tel=13701501490&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=jjjjjjj&isDefault=false&address=jjjjjjj&areaNo=110101&mobile=13701501490&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/69.0.3497.100 Mobile Safari/537.36', '111.40.189.55', '2019-07-01 19:05:46', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [jjjjjjj]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [jjjjjjj]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [jjjjjjj]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-01 19:05:46');
INSERT INTO `exception_log` VALUES (675, '66.54.15620333907868429', 149, 1, 'user-application', '/user-api/users/address/add', 'name=等红灯&tel=15111111111&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=好的&isDefault=true&address=好的&areaNo=110101&mobile=15111111111&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:51', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [好的]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [好的]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [好的]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-02 10:09:51');
INSERT INTO `exception_log` VALUES (676, '66.48.15620333940248437', 149, 1, 'user-application', '/user-api/users/address/add', 'name=等红灯&tel=15111111111&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=好的&isDefault=true&address=好的&areaNo=110101&mobile=15111111111&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:54', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [好的]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [好的]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [好的]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-02 10:09:54');
INSERT INTO `exception_log` VALUES (677, '66.53.15620333964238417', 149, 1, 'user-application', '/user-api/users/address/add', 'name=等红灯&tel=15111111111&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=好的&isDefault=true&address=好的&areaNo=110101&mobile=15111111111&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 9; MIX 2 Build/PKQ1.190118.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044803 Mobile Safari/537.36 MMWEBID/8093 MicroMessenger/7.0.4.1420(0x2700043C) Process/tools NetType/4G Language/zh_CN', '223.104.247.118', '2019-07-02 10:09:56', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [好的]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [好的]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [好的]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-02 10:09:56');
INSERT INTO `exception_log` VALUES (678, '64.77.15620385848570437', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=111&sellPoint=111&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/f97c1bce-48ff-4b26-8d34-d38137a306dd&skuStr=[{\"attrs\":[1,3],\"price\":111100,\"quantity\":1111},{\"attrs\":[2,3],\"price\":111100,\"quantity\":1111}]&description=<p>123</p><div class=\"media-wrap image-wrap align-center\" style=\"text-align:center\"><img src=\"http://static.shop.iocoder.cn/57aa3c2a-56d7-4491-92b4-61c2461b3412\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:36:26', 'org.springframework.messaging.MessagingException', 'MessagingException: Send [3] times, still failed, cost [53]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [53]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.', 'RemotingConnectException: connect to <192.168.88.14:10909> failed', 'org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [53]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [53]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.addProductSpu(ProductSpuServiceImpl.java:93)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$50114869.addProductSpu(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.addProductSpu(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy150.addProductSpu(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz(AdminsProductSpuController.java:58)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz$accessor$3Lvpt4vw(AdminsProductSpuController.java)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController$auxiliary$7LKbfGk3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add(AdminsProductSpuController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0$accessor$7vT1VInN(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$iFD4aFHO.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [53]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 148 more\nCaused by: org.apache.rocketmq.remoting.exception.RemotingConnectException: connect to <192.168.88.14:10909> failed\n	at org.apache.rocketmq.remoting.netty.NettyRemotingClient.invokeSync(NettyRemotingClient.java:393)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:356)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC$accessor$lQ2PcgrU(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl$auxiliary$Ns31PXYD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 151 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-07-02 11:36:26');
INSERT INTO `exception_log` VALUES (679, '64.84.15620385985330445', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=111&sellPoint=111&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/f97c1bce-48ff-4b26-8d34-d38137a306dd&skuStr=[{\"attrs\":[1,3],\"price\":111100,\"quantity\":1111},{\"attrs\":[2,3],\"price\":111100,\"quantity\":1111}]&description=<p>123</p><div class=\"media-wrap image-wrap align-center\" style=\"text-align:center\"><img src=\"http://static.shop.iocoder.cn/57aa3c2a-56d7-4491-92b4-61c2461b3412\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:36:39', 'org.springframework.messaging.MessagingException', 'MessagingException: Send [3] times, still failed, cost [14]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [14]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.', 'RemotingConnectException: connect to <192.168.88.14:10909> failed', 'org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [14]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [14]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.addProductSpu(ProductSpuServiceImpl.java:93)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$50114869.addProductSpu(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.addProductSpu(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy150.addProductSpu(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz(AdminsProductSpuController.java:58)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz$accessor$3Lvpt4vw(AdminsProductSpuController.java)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController$auxiliary$7LKbfGk3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add(AdminsProductSpuController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0$accessor$7vT1VInN(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$iFD4aFHO.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [14]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 148 more\nCaused by: org.apache.rocketmq.remoting.exception.RemotingConnectException: connect to <192.168.88.14:10909> failed\n	at org.apache.rocketmq.remoting.netty.NettyRemotingClient.invokeSync(NettyRemotingClient.java:393)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:356)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC$accessor$lQ2PcgrU(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl$auxiliary$Ns31PXYD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 151 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-07-02 11:36:39');
INSERT INTO `exception_log` VALUES (680, '64.76.15620386728860445', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=111&sellPoint=111&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/f97c1bce-48ff-4b26-8d34-d38137a306dd&skuStr=[{\"attrs\":[1,3,6],\"price\":11100,\"quantity\":111},{\"attrs\":[2,3,6],\"price\":11100,\"quantity\":111}]&description=<p>123</p><div class=\"media-wrap image-wrap align-center\" style=\"text-align:center\"><img src=\"http://static.shop.iocoder.cn/57aa3c2a-56d7-4491-92b4-61c2461b3412\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.186', '2019-07-02 11:37:53', 'org.springframework.messaging.MessagingException', 'MessagingException: Send [3] times, still failed, cost [9]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [9]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.', 'RemotingConnectException: connect to <192.168.88.14:10909> failed', 'org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [9]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [9]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.addProductSpu(ProductSpuServiceImpl.java:93)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$50114869.addProductSpu(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.addProductSpu(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy150.addProductSpu(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz(AdminsProductSpuController.java:58)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz$accessor$3Lvpt4vw(AdminsProductSpuController.java)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController$auxiliary$7LKbfGk3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add(AdminsProductSpuController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0$accessor$7vT1VInN(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$iFD4aFHO.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [9]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 148 more\nCaused by: org.apache.rocketmq.remoting.exception.RemotingConnectException: connect to <192.168.88.14:10909> failed\n	at org.apache.rocketmq.remoting.netty.NettyRemotingClient.invokeSync(NettyRemotingClient.java:393)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:356)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC$accessor$lQ2PcgrU(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl$auxiliary$Ns31PXYD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 151 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-07-02 11:37:53');
INSERT INTO `exception_log` VALUES (681, '66.52.15620550257128717', 153, 1, 'user-application', '/user-api/users/address/add', 'name=dasdad&tel=12345678911&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=dsadasdas&isDefault=true&address=dsadasdas&areaNo=110101&mobile=12345678911&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:10:26', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dsadasdas]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dsadasdas]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dsadasdas]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-02 16:10:26');
INSERT INTO `exception_log` VALUES (682, '66.55.15620550271198701', 153, 1, 'user-application', '/user-api/users/address/add', 'name=dasdad&tel=12345678911&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=dsadasdas&isDefault=true&address=dsadasdas&areaNo=110101&mobile=12345678911&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 5.0; SM-G900P Build/LRX21T) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Mobile Safari/537.36', '110.184.64.24', '2019-07-02 16:10:27', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dsadasdas]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dsadasdas]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [dsadasdas]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-02 16:10:27');
INSERT INTO `exception_log` VALUES (683, '66.50.15620703287698925', 154, 1, 'user-application', '/user-api/users/address/add', 'name=sdfs&tel=13213232132&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=12321312&isDefault=false&address=12321312&areaNo=120102&mobile=13213232132&hasDefault=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:25:29', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12321312]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12321312]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12321312]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-02 20:25:29');
INSERT INTO `exception_log` VALUES (684, '66.51.15620703310138945', 154, 1, 'user-application', '/user-api/users/address/add', 'name=sdfs&tel=13213232132&country=&province=天津市&city=天津市&county=河东区&areaCode=120102&postalCode=&addressDetail=12321312&isDefault=false&address=12321312&areaNo=120102&mobile=13213232132&hasDefault=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '117.136.31.221', '2019-07-02 20:25:31', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12321312]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12321312]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12321312]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-02 20:25:31');
INSERT INTO `exception_log` VALUES (685, '64.82.15621226240511631', 1, 2, 'product-application', '/product-api/admins/spu/update', 'name=农夫山泉&sellPoint=有点甜&cid=637&visible=false&id=32&picUrls=https://img.1000.com/qm-a-img/prod/000000/68635d48f57444c8a5ffd47a257dc3d7.jpg&skuStr=[{\"attrs\":[1,3],\"price\":12500000000,\"quantity\":20},{\"attrs\":[1,4],\"price\":141006540800,\"quantity\":30}]&description=<p>我就是一个水</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.12.114', '2019-07-03 10:57:04', 'com.alibaba.fastjson.JSONException', 'JSONException: parseInt error, field : price', 'NumberFormatException: 12500000000', 'com.alibaba.fastjson.JSONException: parseInt error, field : price\n	at com.alibaba.fastjson.serializer.IntegerCodec.deserialze(IntegerCodec.java:101)\n	at com.alibaba.fastjson.parser.deserializer.DefaultFieldDeserializer.parseField(DefaultFieldDeserializer.java:85)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.parseField(JavaBeanDeserializer.java:1183)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.deserialze(JavaBeanDeserializer.java:822)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.parseRest(JavaBeanDeserializer.java:1425)\n	at com.alibaba.fastjson.parser.deserializer.FastjsonASMDeserializer_5_ProductSkuAddOrUpdateDTO.deserialze(Unknown Source)\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.deserialze(JavaBeanDeserializer.java:269)\n	at com.alibaba.fastjson.parser.DefaultJSONParser.parseArray(DefaultJSONParser.java:762)\n	at com.alibaba.fastjson.parser.DefaultJSONParser.parseArray(DefaultJSONParser.java:696)\n	at com.alibaba.fastjson.parser.DefaultJSONParser.parseArray(DefaultJSONParser.java:691)\n	at com.alibaba.fastjson.JSON.parseArray(JSON.java:593)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.parseSkus(AdminsProductSpuController.java:165)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.update$original$pMLWVoQz(AdminsProductSpuController.java:86)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.update$original$pMLWVoQz$accessor$3Lvpt4vw(AdminsProductSpuController.java)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController$auxiliary$WveSZHUR.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.update(AdminsProductSpuController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0$accessor$7vT1VInN(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$iFD4aFHO.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.lang.NumberFormatException: 12500000000\n	at com.alibaba.fastjson.parser.JSONLexerBase.intValue(JSONLexerBase.java:1060)\n	at com.alibaba.fastjson.serializer.IntegerCodec.deserialze(IntegerCodec.java:79)\n	... 95 more\n', 'com.alibaba.fastjson.serializer.IntegerCodec', 'IntegerCodec.java', 'deserialze', 101, '2019-07-03 10:57:04');
INSERT INTO `exception_log` VALUES (686, '65.3607.15623101650857427', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '116.21.15.82', '2019-07-05 15:02:45', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.IdentityOutputFilter.flush(IdentityOutputFilter.java:117)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 82 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-07-05 15:02:45');
INSERT INTO `exception_log` VALUES (687, '64.79.15623124618034229', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=aaaa&sellPoint=a&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/c7f1a2c8-4015-4c28-bc64-a92ad72fbe12&skuStr=[{\"attrs\":[46],\"price\":1100,\"quantity\":1111},{\"attrs\":[4],\"price\":1100,\"quantity\":111}]&description=<p>111111111111111111111111</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '121.32.126.196', '2019-07-05 15:41:02', 'org.springframework.messaging.MessagingException', 'MessagingException: Send [3] times, still failed, cost [14]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [14]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.', 'RemotingConnectException: connect to <192.168.88.14:10909> failed', 'org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [14]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [14]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.addProductSpu(ProductSpuServiceImpl.java:93)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$50114869.addProductSpu(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.addProductSpu(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy150.addProductSpu(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz(AdminsProductSpuController.java:58)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz$accessor$3Lvpt4vw(AdminsProductSpuController.java)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController$auxiliary$7LKbfGk3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add(AdminsProductSpuController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0$accessor$7vT1VInN(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$iFD4aFHO.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [14]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 148 more\nCaused by: org.apache.rocketmq.remoting.exception.RemotingConnectException: connect to <192.168.88.14:10909> failed\n	at org.apache.rocketmq.remoting.netty.NettyRemotingClient.invokeSync(NettyRemotingClient.java:393)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:356)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC$accessor$lQ2PcgrU(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl$auxiliary$Ns31PXYD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 151 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-07-05 15:41:02');
INSERT INTO `exception_log` VALUES (688, '143844e1-f3e3-4efe-950d-49d401719de5', 1, 2, 'promotion-application', '/promotion-api/admins/banner/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:01:32', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy5', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\r\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\r\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\r\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\r\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\r\n	at com.sun.proxy.$Proxy133.getBannerPage(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.admins.AdminsBannerController.page(AdminsBannerController.java:40)\r\n	at sun.reflect.GeneratedMethodAccessor582.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\r\n	... 90 more\r\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\r\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\r\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\r\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\r\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\r\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\r\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\r\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\r\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\r\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\r\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\r\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\r\n	at javassist.compiler.Javac.compile(Javac.java:95)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\r\n	... 92 more\r\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-07-07 16:01:32');
INSERT INTO `exception_log` VALUES (689, '517b17eb-67bb-4818-9bd8-c577d4667e65', 1, 2, 'product-application', '/product-api/admins/category/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.131 Safari/537.36', '127.0.0.1', '2019-07-07 16:04:53', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy4', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\r\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\r\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\r\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\r\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\r\n	at com.sun.proxy.$Proxy142.getAll(Unknown Source)\r\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductCategoryController.tree(AdminsProductCategoryController.java:39)\r\n	at sun.reflect.GeneratedMethodAccessor406.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:45005)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\r\n	... 90 more\r\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy4\r\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\r\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\r\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\r\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\r\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\r\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\r\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\r\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\r\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\r\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\r\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\r\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\r\n	at javassist.compiler.Javac.compile(Javac.java:95)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\r\n	... 92 more\r\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-07-07 16:04:53');
INSERT INTO `exception_log` VALUES (690, 'dce1a68e-204c-43de-85ab-b806cd242a41', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-08 17:21:02', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [10.28.151.5:20883] (1/1) from the registry 127.0.0.1:2181 on the consumer 10.28.151.5 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://10.28.151.5:20883/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuDetailListForSync,getProductSpuPage,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=60346&qos.enable=false&register=true&register.ip=10.28.151.5&release=2.7.1&remote.application=product-service&remote.timestamp=1562574300276&revision=1.0.0&side=consumer&sticky=false&timestamp=1562574723771&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-07-08 17:21:01.388, end time: 2019-07-08 17:21:02.393, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=101, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /10.28.151.5:55785 -> /10.28.151.5:20883', 'TimeoutException: Waiting server-side response timeout. start time: 2019-07-08 17:21:01.388, end time: 2019-07-08 17:21:02.393, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=101, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /10.28.151.5:55785 -> /10.28.151.5:20883', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [10.28.151.5:20883] (1/1) from the registry 127.0.0.1:2181 on the consumer 10.28.151.5 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://10.28.151.5:20883/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuDetailListForSync,getProductSpuPage,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=60346&qos.enable=false&register=true&register.ip=10.28.151.5&release=2.7.1&remote.application=product-service&remote.timestamp=1562574300276&revision=1.0.0&side=consumer&sticky=false&timestamp=1562574723771&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-07-08 17:21:01.388, end time: 2019-07-08 17:21:02.393, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=101, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /10.28.151.5:55785 -> /10.28.151.5:20883\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getProductSpuList(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getProductSpuList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:43)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-07-08 17:21:01.388, end time: 2019-07-08 17:21:02.393, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=101, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /10.28.151.5:55785 -> /10.28.151.5:20883\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 86 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-07-08 17:21:03');
INSERT INTO `exception_log` VALUES (691, '62bea437-d57b-4d03-9c32-b50ffa54f904', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_5) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '127.0.0.1', '2019-07-08 17:21:06', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [10.28.151.5:20883] (1/1) from the registry 127.0.0.1:2181 on the consumer 10.28.151.5 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://10.28.151.5:20883/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuDetailListForSync,getProductSpuPage,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=60346&qos.enable=false&register=true&register.ip=10.28.151.5&release=2.7.1&remote.application=product-service&remote.timestamp=1562574300276&revision=1.0.0&side=consumer&sticky=false&timestamp=1562574723771&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-07-08 17:21:04.901, end time: 2019-07-08 17:21:05.907, client elapsed: 0 ms, server elapsed: 1006 ms, timeout: 1000 ms, request: Request [id=108, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /10.28.151.5:55785 -> /10.28.151.5:20883', 'TimeoutException: Waiting server-side response timeout. start time: 2019-07-08 17:21:04.901, end time: 2019-07-08 17:21:05.907, client elapsed: 0 ms, server elapsed: 1006 ms, timeout: 1000 ms, request: Request [id=108, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /10.28.151.5:55785 -> /10.28.151.5:20883', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [10.28.151.5:20883] (1/1) from the registry 127.0.0.1:2181 on the consumer 10.28.151.5 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://10.28.151.5:20883/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuDetailListForSync,getProductSpuPage,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=60346&qos.enable=false&register=true&register.ip=10.28.151.5&release=2.7.1&remote.application=product-service&remote.timestamp=1562574300276&revision=1.0.0&side=consumer&sticky=false&timestamp=1562574723771&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-07-08 17:21:04.901, end time: 2019-07-08 17:21:05.907, client elapsed: 0 ms, server elapsed: 1006 ms, timeout: 1000 ms, request: Request [id=108, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /10.28.151.5:55785 -> /10.28.151.5:20883\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getProductSpuList(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getProductSpuList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:43)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-07-08 17:21:04.901, end time: 2019-07-08 17:21:05.907, client elapsed: 0 ms, server elapsed: 1006 ms, timeout: 1000 ms, request: Request [id=108, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /10.28.151.5:55785 -> /10.28.151.5:20883\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 86 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-07-08 17:21:06');
INSERT INTO `exception_log` VALUES (692, '66.56.15625790530915743', 0, 1, 'user-application', '/user-api/users/address/add', 'name=1&tel=18758051655&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=12&isDefault=true&address=12&areaNo=110101&mobile=18758051655&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '112.17.169.238', '2019-07-08 17:44:13', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [12]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-08 17:44:13');
INSERT INTO `exception_log` VALUES (693, '64.76.15626753704699163', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=测试&sellPoint=测试&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/1b4195db-93b9-4f8d-b8bb-3a88df28459d&skuStr=[{\"attrs\":[3],\"price\":21213300,\"quantity\":23123}]&description=<p>21121212121</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:29:31', 'org.springframework.messaging.MessagingException', 'MessagingException: Send [3] times, still failed, cost [22]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [22]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.', 'RemotingConnectException: connect to <192.168.88.14:10909> failed', 'org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [22]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [22]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.addProductSpu(ProductSpuServiceImpl.java:93)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$50114869.addProductSpu(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.addProductSpu(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy150.addProductSpu(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz(AdminsProductSpuController.java:58)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz$accessor$3Lvpt4vw(AdminsProductSpuController.java)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController$auxiliary$7LKbfGk3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add(AdminsProductSpuController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0$accessor$7vT1VInN(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$iFD4aFHO.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [22]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 148 more\nCaused by: org.apache.rocketmq.remoting.exception.RemotingConnectException: connect to <192.168.88.14:10909> failed\n	at org.apache.rocketmq.remoting.netty.NettyRemotingClient.invokeSync(NettyRemotingClient.java:393)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:356)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC$accessor$lQ2PcgrU(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl$auxiliary$Ns31PXYD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 151 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-07-09 20:29:31');
INSERT INTO `exception_log` VALUES (694, '64.79.15626753802749175', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=测试&sellPoint=测试&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/1b4195db-93b9-4f8d-b8bb-3a88df28459d&skuStr=[{\"attrs\":[3],\"price\":21213300,\"quantity\":23123}]&description=<p>21121212121</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:29:40', 'org.springframework.messaging.MessagingException', 'MessagingException: Send [3] times, still failed, cost [15]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [15]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.', 'RemotingConnectException: connect to <192.168.88.14:10909> failed', 'org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [15]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [15]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.addProductSpu(ProductSpuServiceImpl.java:93)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$50114869.addProductSpu(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.addProductSpu(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy150.addProductSpu(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz(AdminsProductSpuController.java:58)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz$accessor$3Lvpt4vw(AdminsProductSpuController.java)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController$auxiliary$7LKbfGk3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add(AdminsProductSpuController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0$accessor$7vT1VInN(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$iFD4aFHO.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [15]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 148 more\nCaused by: org.apache.rocketmq.remoting.exception.RemotingConnectException: connect to <192.168.88.14:10909> failed\n	at org.apache.rocketmq.remoting.netty.NettyRemotingClient.invokeSync(NettyRemotingClient.java:393)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:356)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC$accessor$lQ2PcgrU(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl$auxiliary$Ns31PXYD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 151 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-07-09 20:29:40');
INSERT INTO `exception_log` VALUES (695, '64.77.15626755467139155', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=测试&sellPoint=测试&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/124519dc-5b11-4bf1-96e3-ac29d18a603b&skuStr=[{\"attrs\":[3],\"price\":21213300,\"quantity\":23123}]&description=<p>21121212121</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/65.0.3325.181 Safari/537.36', '113.116.181.138', '2019-07-09 20:32:27', 'org.springframework.messaging.MessagingException', 'MessagingException: Send [3] times, still failed, cost [11]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [11]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.', 'RemotingConnectException: connect to <192.168.88.14:10909> failed', 'org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [11]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [11]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.addProductSpu(ProductSpuServiceImpl.java:93)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$50114869.addProductSpu(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.addProductSpu(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy150.addProductSpu(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz(AdminsProductSpuController.java:58)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz$accessor$3Lvpt4vw(AdminsProductSpuController.java)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController$auxiliary$7LKbfGk3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add(AdminsProductSpuController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0$accessor$7vT1VInN(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$iFD4aFHO.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [11]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 148 more\nCaused by: org.apache.rocketmq.remoting.exception.RemotingConnectException: connect to <192.168.88.14:10909> failed\n	at org.apache.rocketmq.remoting.netty.NettyRemotingClient.invokeSync(NettyRemotingClient.java:393)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:356)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC$accessor$lQ2PcgrU(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl$auxiliary$Ns31PXYD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 151 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-07-09 20:32:27');
INSERT INTO `exception_log` VALUES (696, '66.48.15626766293687059', 164, 1, 'user-application', '/user-api/users/address/add', 'name=c&tel=13501831986&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail= 测试路129号&isDefault=false&address= 测试路129号&areaNo=110101&mobile=13501831986&hasDefault=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:50:29', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [ 测试路129号]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [ 测试路129号]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [ 测试路129号]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-09 20:50:29');
INSERT INTO `exception_log` VALUES (697, '66.53.15626766334687053', 164, 1, 'user-application', '/user-api/users/address/add', 'name=c&tel=13501831986&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail= 测试路129号&isDefault=true&address= 测试路129号&areaNo=110101&mobile=13501831986&hasDefault=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:50:33', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [ 测试路129号]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [ 测试路129号]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [ 测试路129号]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-09 20:50:33');
INSERT INTO `exception_log` VALUES (698, '66.52.15626766405317039', 164, 1, 'user-application', '/user-api/users/address/add', 'name=测试&tel=13501831986&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail= 测试路129号&isDefault=true&address= 测试路129号&areaNo=110101&mobile=13501831986&hasDefault=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.100 Safari/537.36', '101.88.246.130', '2019-07-09 20:50:41', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [ 测试路129号]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [ 测试路129号]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [ 测试路129号]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-09 20:50:41');
INSERT INTO `exception_log` VALUES (699, '66.55.15628071598338781', 166, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=13422129567&country=&province=广东省&city=广州市&county=天河区&areaCode=440106&postalCode=&addressDetail=五楼&isDefault=false&address=五楼&areaNo=440106&mobile=13422129567&hasDefault=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:06:00', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [五楼]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [五楼]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [五楼]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-11 09:06:00');
INSERT INTO `exception_log` VALUES (700, '66.54.15628071620048801', 166, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=13422129567&country=&province=广东省&city=广州市&county=天河区&areaCode=440106&postalCode=&addressDetail=五楼&isDefault=false&address=五楼&areaNo=440106&mobile=13422129567&hasDefault=1', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '113.98.117.125', '2019-07-11 09:06:02', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [五楼]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [五楼]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [五楼]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-11 09:06:02');
INSERT INTO `exception_log` VALUES (701, '66.56.15628141990428905', 167, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=15287456321&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=10010&isDefault=false&address=10010&areaNo=110101&mobile=15287456321&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 11:03:19', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [10010]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [10010]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [10010]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-11 11:03:19');
INSERT INTO `exception_log` VALUES (702, '66.52.15628142012108885', 167, 1, 'user-application', '/user-api/users/address/add', 'name=张三&tel=15287456321&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=10010&isDefault=false&address=10010&areaNo=110101&mobile=15287456321&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '180.130.2.80', '2019-07-11 11:03:21', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [10010]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [10010]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [10010]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-11 11:03:21');
INSERT INTO `exception_log` VALUES (703, '65.54.15628389175662989', 27, 2, 'admin-application', '/admin-api/admins/data_dict/tree', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; WOW64; Trident/7.0; rv:11.0) like Gecko', '113.90.237.146', '2019-07-11 17:55:18', 'org.apache.catalina.connector.ClientAbortException', 'ClientAbortException: java.io.IOException: Broken pipe', 'IOException: Broken pipe', 'org.apache.catalina.connector.ClientAbortException: java.io.IOException: Broken pipe\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:299)\n	at org.apache.catalina.connector.OutputBuffer.flush(OutputBuffer.java:262)\n	at org.apache.catalina.connector.CoyoteOutputStream.flush(CoyoteOutputStream.java:118)\n	at com.fasterxml.jackson.core.json.UTF8JsonGenerator.flush(UTF8JsonGenerator.java:1100)\n	at com.fasterxml.jackson.databind.ObjectWriter.writeValue(ObjectWriter.java:915)\n	at org.springframework.http.converter.json.AbstractJackson2HttpMessageConverter.writeInternal(AbstractJackson2HttpMessageConverter.java:287)\n	at org.springframework.http.converter.AbstractGenericHttpMessageConverter.write(AbstractGenericHttpMessageConverter.java:103)\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodProcessor.writeWithMessageConverters(AbstractMessageConverterMethodProcessor.java:290)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.handleReturnValue(RequestResponseBodyMethodProcessor.java:180)\n	at org.springframework.web.method.support.HandlerMethodReturnValueHandlerComposite.handleReturnValue(HandlerMethodReturnValueHandlerComposite.java:82)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:119)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$LkxPCMjj$accessor$Ala5ciQQ(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$ht4azYiS.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: java.io.IOException: Broken pipe\n	at sun.nio.ch.FileDispatcherImpl.write0(Native Method)\n	at sun.nio.ch.SocketDispatcher.write(SocketDispatcher.java:47)\n	at sun.nio.ch.IOUtil.writeFromNativeBuffer(IOUtil.java:93)\n	at sun.nio.ch.IOUtil.write(IOUtil.java:65)\n	at sun.nio.ch.SocketChannelImpl.write(SocketChannelImpl.java:471)\n	at org.apache.tomcat.util.net.NioChannel.write(NioChannel.java:134)\n	at org.apache.tomcat.util.net.NioBlockingSelector.write(NioBlockingSelector.java:105)\n	at org.apache.tomcat.util.net.NioSelectorPool.write(NioSelectorPool.java:144)\n	at org.apache.tomcat.util.net.NioEndpoint$NioSocketWrapper.doWrite(NioEndpoint.java:1223)\n	at org.apache.tomcat.util.net.SocketWrapperBase.doWrite(SocketWrapperBase.java:743)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flushBlocking(SocketWrapperBase.java:696)\n	at org.apache.tomcat.util.net.SocketWrapperBase.flush(SocketWrapperBase.java:686)\n	at org.apache.coyote.http11.Http11OutputBuffer$SocketOutputBuffer.flush(Http11OutputBuffer.java:553)\n	at org.apache.coyote.http11.filters.IdentityOutputFilter.flush(IdentityOutputFilter.java:117)\n	at org.apache.coyote.http11.Http11OutputBuffer.flush(Http11OutputBuffer.java:216)\n	at org.apache.coyote.http11.Http11Processor.flush(Http11Processor.java:1149)\n	at org.apache.coyote.AbstractProcessor.action(AbstractProcessor.java:394)\n	at org.apache.coyote.Response.action(Response.java:209)\n	at org.apache.catalina.connector.OutputBuffer.doFlush(OutputBuffer.java:295)\n	... 82 more\n', 'org.apache.catalina.connector.OutputBuffer', 'OutputBuffer.java', 'doFlush', 299, '2019-07-11 17:55:18');
INSERT INTO `exception_log` VALUES (704, '62.83.15629039553811363', 0, 1, 'pay-application', '/pay-api/users/refund/pingxx_refund_success', '', 'POST', 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.132 Safari/537.36', '218.13.14.198', '2019-07-12 11:59:16', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\n	at cn.iocoder.mall.pay.biz.client.PingxxPaySDK.parseRefundSuccessParams(PingxxPaySDK.java:104)\n	at cn.iocoder.mall.pay.biz.service.PayRefundServiceImpl.updateRefundSuccess(PayRefundServiceImpl.java:103)\n	at cn.iocoder.mall.pay.biz.service.PayRefundServiceImpl$$FastClassBySpringCGLIB$$20ded9b7.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\n	at cn.iocoder.mall.pay.biz.service.PayRefundServiceImpl$$EnhancerBySpringCGLIB$$fb00a978.updateRefundSuccess(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps$accessor$udHWkIOS(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$j1lwYsbN.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$HEPmUQps$accessor$udHWkIOS(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$j1lwYsbN.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy4.updateRefundSuccess(proxy4.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy146.updateRefundSuccess(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayRefundController.pingxxRefundSuccess$original$SWVFq6wE(UsersPayRefundController.java:39)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayRefundController.pingxxRefundSuccess$original$SWVFq6wE$accessor$a32Rk7IX(UsersPayRefundController.java)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayRefundController$auxiliary$ZkSMWnHZ.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayRefundController.pingxxRefundSuccess(UsersPayRefundController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$E6xJFBXh(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$E6xJFBXh$accessor$B14rviGT(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$Qx1CllIG.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'cn.iocoder.mall.pay.biz.client.PingxxPaySDK', 'PingxxPaySDK.java', 'parseRefundSuccessParams', 104, '2019-07-12 11:59:16');
INSERT INTO `exception_log` VALUES (705, '64.80.15633605813618513', 1, 2, 'product-application', '/product-api/admins/spu/update_sort', 'id=32&sort=-4', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '106.38.115.23', '2019-07-17 18:49:42', 'org.springframework.messaging.MessagingException', 'MessagingException: Send [3] times, still failed, cost [16]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [16]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.', 'RemotingConnectException: connect to <192.168.88.14:10909> failed', 'org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [16]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [16]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.updateProductSpuSort(ProductSpuServiceImpl.java:217)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$50114869.updateProductSpuSort(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.updateProductSpuSort(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy150.updateProductSpuSort(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.updateSort$original$pMLWVoQz(AdminsProductSpuController.java:96)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.updateSort$original$pMLWVoQz$accessor$3Lvpt4vw(AdminsProductSpuController.java)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController$auxiliary$vYFlQ2ng.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.updateSort(AdminsProductSpuController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0$accessor$7vT1VInN(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$iFD4aFHO.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [16]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 148 more\nCaused by: org.apache.rocketmq.remoting.exception.RemotingConnectException: connect to <192.168.88.14:10909> failed\n	at org.apache.rocketmq.remoting.netty.NettyRemotingClient.invokeSync(NettyRemotingClient.java:393)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:356)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC$accessor$lQ2PcgrU(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl$auxiliary$Ns31PXYD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 151 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-07-17 18:49:42');
INSERT INTO `exception_log` VALUES (706, 'f8e1814d-1a6d-4815-bedb-27fbeb785bd4', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'PostmanRuntime/7.15.0', '0:0:0:0:0:0:0:1', '2019-07-21 13:45:48', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \r\n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\r\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\r\n### The error may involve defaultParameterMap\r\n### The error occurred while setting parameters\r\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\r\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \r\n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\r\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\r\n### The error may involve defaultParameterMap\r\n### The error occurred while setting parameters\r\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\r\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\r\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\r\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy132.selectList(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy155.selectList(Unknown Source)\r\n	at cn.iocoder.mall.admin.dao.DeptmentMapper.getDeptByPid(DeptmentMapper.java:42)\r\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\r\n	at com.sun.proxy.$Proxy155.getDeptByPid(Unknown Source)\r\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl.getAllDeptments(DeptmentServiceImpl.java:108)\r\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$FastClassBySpringCGLIB$$d744caf2.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\r\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$EnhancerBySpringCGLIB$$613a1f10.getAllDeptments(<generated>)\r\n	at cn.iocoder.mall.admin.application.controller.admins.DeptmentController.treeAll(DeptmentController.java:50)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\r\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\r\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\r\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\r\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\r\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\r\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\r\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\r\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\r\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\r\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\r\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\r\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\r\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\r\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\r\n	at sun.reflect.GeneratedMethodAccessor357.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\r\n	at com.sun.proxy.$Proxy224.execute(Unknown Source)\r\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\r\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\r\n	at sun.reflect.GeneratedMethodAccessor363.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\r\n	at com.sun.proxy.$Proxy222.query(Unknown Source)\r\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\r\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\r\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 92 more\r\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-07-21 13:45:48');
INSERT INTO `exception_log` VALUES (707, '693e098d-0130-43e5-a2be-2e5086274458', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'PostmanRuntime/7.15.0', '0:0:0:0:0:0:0:1', '2019-07-21 13:45:50', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \r\n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\r\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\r\n### The error may involve defaultParameterMap\r\n### The error occurred while setting parameters\r\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\r\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \r\n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\r\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\r\n### The error may involve defaultParameterMap\r\n### The error occurred while setting parameters\r\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\r\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\r\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\r\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy132.selectList(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy155.selectList(Unknown Source)\r\n	at cn.iocoder.mall.admin.dao.DeptmentMapper.getDeptByPid(DeptmentMapper.java:42)\r\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\r\n	at com.sun.proxy.$Proxy155.getDeptByPid(Unknown Source)\r\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl.getAllDeptments(DeptmentServiceImpl.java:108)\r\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$FastClassBySpringCGLIB$$d744caf2.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\r\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$EnhancerBySpringCGLIB$$613a1f10.getAllDeptments(<generated>)\r\n	at cn.iocoder.mall.admin.application.controller.admins.DeptmentController.treeAll(DeptmentController.java:50)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\r\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\r\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\r\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\r\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\r\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\r\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\r\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\r\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\r\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\r\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\r\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\r\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\r\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\r\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\r\n	at sun.reflect.GeneratedMethodAccessor357.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\r\n	at com.sun.proxy.$Proxy224.execute(Unknown Source)\r\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\r\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\r\n	at sun.reflect.GeneratedMethodAccessor363.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\r\n	at com.sun.proxy.$Proxy222.query(Unknown Source)\r\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\r\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\r\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 92 more\r\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-07-21 13:45:51');
INSERT INTO `exception_log` VALUES (708, '2ead2e5a-0ec3-4da5-a0d1-65a79dcf474c', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'PostmanRuntime/7.15.0', '0:0:0:0:0:0:0:1', '2019-07-21 13:45:58', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \r\n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\r\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\r\n### The error may involve defaultParameterMap\r\n### The error occurred while setting parameters\r\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\r\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \r\n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\r\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\r\n### The error may involve defaultParameterMap\r\n### The error occurred while setting parameters\r\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\r\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\r\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\r\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy132.selectList(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy155.selectList(Unknown Source)\r\n	at cn.iocoder.mall.admin.dao.DeptmentMapper.getDeptByPid(DeptmentMapper.java:42)\r\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\r\n	at com.sun.proxy.$Proxy155.getDeptByPid(Unknown Source)\r\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl.getAllDeptments(DeptmentServiceImpl.java:108)\r\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$FastClassBySpringCGLIB$$d744caf2.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\r\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$EnhancerBySpringCGLIB$$613a1f10.getAllDeptments(<generated>)\r\n	at cn.iocoder.mall.admin.application.controller.admins.DeptmentController.treeAll(DeptmentController.java:50)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\r\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\r\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\r\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\r\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\r\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\r\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\r\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\r\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\r\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\r\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\r\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\r\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\r\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\r\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\r\n	at sun.reflect.GeneratedMethodAccessor357.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\r\n	at com.sun.proxy.$Proxy224.execute(Unknown Source)\r\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\r\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\r\n	at sun.reflect.GeneratedMethodAccessor363.invoke(Unknown Source)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\r\n	at com.sun.proxy.$Proxy222.query(Unknown Source)\r\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\r\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\r\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\r\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 92 more\r\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-07-21 13:45:58');
INSERT INTO `exception_log` VALUES (709, '637c2439-c6ad-4276-aed8-e605a71a967f', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/page', '', 'GET', 'PostmanRuntime/7.15.0', '0:0:0:0:0:0:0:1', '2019-07-21 13:46:30', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 2 errors\nField error in object \'deptmentPageDTO\' on field \'pageSize\': rejected value [null]; codes [NotNull.deptmentPageDTO.pageSize,NotNull.pageSize,NotNull.java.lang.Integer,NotNull]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [deptmentPageDTO.pageSize,pageSize]; arguments []; default message [pageSize]]; default message [每页条数不能为空]\nField error in object \'deptmentPageDTO\' on field \'pageNo\': rejected value [null]; codes [NotNull.deptmentPageDTO.pageNo,NotNull.pageNo,NotNull.java.lang.Integer,NotNull]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [deptmentPageDTO.pageNo,pageNo]; arguments []; default message [pageNo]]; default message [页码不能为空]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 2 errors\nField error in object \'deptmentPageDTO\' on field \'pageSize\': rejected value [null]; codes [NotNull.deptmentPageDTO.pageSize,NotNull.pageSize,NotNull.java.lang.Integer,NotNull]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [deptmentPageDTO.pageSize,pageSize]; arguments []; default message [pageSize]]; default message [每页条数不能为空]\nField error in object \'deptmentPageDTO\' on field \'pageNo\': rejected value [null]; codes [NotNull.deptmentPageDTO.pageNo,NotNull.pageNo,NotNull.java.lang.Integer,NotNull]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [deptmentPageDTO.pageNo,pageNo]; arguments []; default message [pageNo]]; default message [页码不能为空]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 2 errors\nField error in object \'deptmentPageDTO\' on field \'pageSize\': rejected value [null]; codes [NotNull.deptmentPageDTO.pageSize,NotNull.pageSize,NotNull.java.lang.Integer,NotNull]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [deptmentPageDTO.pageSize,pageSize]; arguments []; default message [pageSize]]; default message [每页条数不能为空]\nField error in object \'deptmentPageDTO\' on field \'pageNo\': rejected value [null]; codes [NotNull.deptmentPageDTO.pageNo,NotNull.pageNo,NotNull.java.lang.Integer,NotNull]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [deptmentPageDTO.pageNo,pageNo]; arguments []; default message [pageNo]]; default message [页码不能为空]\r\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\r\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-07-21 13:46:30');
INSERT INTO `exception_log` VALUES (710, '66.54.15646693024503717', 188, 1, 'user-application', '/user-api/users/address/add', 'name=看看&tel=18373353229&country=&province=河北省&city=石家庄市&county=桥西区&areaCode=130104&postalCode=&addressDetail=明年&isDefault=true&address=明年&areaNo=130104&mobile=18373353229&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:21:42', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [明年]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [明年]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [明年]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-08-01 22:21:42');
INSERT INTO `exception_log` VALUES (711, '66.48.15646693044103723', 188, 1, 'user-application', '/user-api/users/address/add', 'name=看看&tel=18373353229&country=&province=河北省&city=石家庄市&county=桥西区&areaCode=130104&postalCode=&addressDetail=明年&isDefault=true&address=明年&areaNo=130104&mobile=18373353229&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:21:44', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [明年]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [明年]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [明年]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-08-01 22:21:44');
INSERT INTO `exception_log` VALUES (712, '66.52.15646693064743703', 188, 1, 'user-application', '/user-api/users/address/add', 'name=看看&tel=18373353229&country=&province=河北省&city=石家庄市&county=桥西区&areaCode=130104&postalCode=&addressDetail=明年&isDefault=true&address=明年&areaNo=130104&mobile=18373353229&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 7.0; M3 Max Build/NRD90M; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044807 Mobile Safari/537.36 MMWEBID/7835 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '58.254.69.121', '2019-08-01 22:21:46', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [明年]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [明年]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [明年]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-08-01 22:21:46');
INSERT INTO `exception_log` VALUES (713, 'aa0d3c43-48d1-45a2-bf99-8f2c5b0d70ed', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=28', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:35', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.hasUserSpuFavorite(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:28:35');
INSERT INTO `exception_log` VALUES (714, '0e798343-3112-4155-aa11-4f3fb2feedfd', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:28:40', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.hasUserSpuFavorite(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:28:40');
INSERT INTO `exception_log` VALUES (715, 'd26a61a1-72d1-4f24-8ba5-e2d369483a1f', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:11', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.hasUserSpuFavorite(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:29:11');
INSERT INTO `exception_log` VALUES (716, '4f64ad5d-1132-4934-a8de-8d75d2a1a284', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:16', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.hasUserSpuFavorite(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:29:16');
INSERT INTO `exception_log` VALUES (717, 'a8769fcd-e9f9-4d10-8cb2-5e7d868a9de3', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:29:29', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.hasUserSpuFavorite(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:29:29');
INSERT INTO `exception_log` VALUES (718, '4af83c75-cd42-476e-8669-71dc419f98e2', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:30:56', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.hasUserSpuFavorite(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:30:56');
INSERT INTO `exception_log` VALUES (719, '7c5a8086-cb84-4aa0-87e9-813170737c81', 197, 1, 'user-application', '/user-api/users/address/add', 'name=胡家明&tel=18856655656&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=1231231&isDefault=true&address=1231231&areaNo=110101&mobile=18856655656&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:42', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1231231]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1231231]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1231231]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-08-12 17:33:42');
INSERT INTO `exception_log` VALUES (720, 'cdbb08b7-f3ee-4e6f-9732-8e4cfa7b8f8a', 197, 1, 'user-application', '/user-api/users/address/add', 'name=胡家明&tel=18856655656&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=44&isDefault=true&address=44&areaNo=110101&mobile=18856655656&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:33:50', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-08-12 17:33:50');
INSERT INTO `exception_log` VALUES (721, '98ba8063-eba1-45b5-9bef-6ba12f3b3e5d', 197, 1, 'user-application', '/user-api/users/address/add', 'name=胡家明&tel=18856655656&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=44&isDefault=true&address=44&areaNo=110101&mobile=18856655656&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:34:19', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-08-12 17:34:19');
INSERT INTO `exception_log` VALUES (722, '92ec270e-5f8a-45ba-bad9-bd93b6280995', 197, 1, 'user-application', '/user-api/users/address/add', 'name=胡家明&tel=18856655656&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=44&isDefault=true&address=44&areaNo=110101&mobile=18856655656&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:34:46', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-08-12 17:34:46');
INSERT INTO `exception_log` VALUES (723, '8e996186-84d3-4939-bda1-124436031718', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:35:37', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.hasUserSpuFavorite(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.GeneratedMethodAccessor364.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:35:37');
INSERT INTO `exception_log` VALUES (724, '77768901-c5f4-4543-a172-769a6e1a114d', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:36:20', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.hasUserSpuFavorite(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.GeneratedMethodAccessor364.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:36:20');
INSERT INTO `exception_log` VALUES (725, 'a4a2f576-4c77-4bd4-959d-004aeb206c06', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:36:26', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.hasUserSpuFavorite(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.GeneratedMethodAccessor364.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:36:26');
INSERT INTO `exception_log` VALUES (726, 'af394e5e-9c23-4938-bbab-ff4f0d1971c2', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:38:23', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.hasUserSpuFavorite(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.GeneratedMethodAccessor364.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:38:23');
INSERT INTO `exception_log` VALUES (727, 'cde90d47-865b-4291-933b-b7a4e5fbcd5a', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=35', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 17:38:32', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.hasUserSpuFavorite(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.GeneratedMethodAccessor364.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:38:32');
INSERT INTO `exception_log` VALUES (728, '063f3e51-0911-4f5b-b9c4-27811717500f', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=35', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:38:45', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.hasUserSpuFavorite(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.GeneratedMethodAccessor364.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:38:45');
INSERT INTO `exception_log` VALUES (729, 'ad834099-a097-4e34-84bc-2069baad4069', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=34', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:18', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.hasUserSpuFavorite(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.GeneratedMethodAccessor364.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:39:18');
INSERT INTO `exception_log` VALUES (730, 'bfbb6569-2bb8-4d82-b09b-155f784bfb06', 197, 1, 'search-application', '/search-api/users/product/page', 'cid=794&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:39:28', 'org.elasticsearch.client.transport.NoNodeAvailableException', 'NoNodeAvailableException: None of the configured nodes are available: [{#transport#-1}{TEXE5dGLS22GHzPla_rGEQ}{127.0.0.1}{127.0.0.1:9300}]', 'NoNodeAvailableException: None of the configured nodes are available: [{#transport#-1}{TEXE5dGLS22GHzPla_rGEQ}{127.0.0.1}{127.0.0.1:9300}]', 'NoNodeAvailableException[None of the configured nodes are available: [{#transport#-1}{TEXE5dGLS22GHzPla_rGEQ}{127.0.0.1}{127.0.0.1:9300}]]\n	at org.elasticsearch.client.transport.TransportClientNodesService.ensureNodesAreAvailable(TransportClientNodesService.java:349)\n	at org.elasticsearch.client.transport.TransportClientNodesService.execute(TransportClientNodesService.java:247)\n	at org.elasticsearch.client.transport.TransportProxyClient.execute(TransportProxyClient.java:60)\n	at org.elasticsearch.client.transport.TransportClient.doExecute(TransportClient.java:381)\n	at org.elasticsearch.client.support.AbstractClient.execute(AbstractClient.java:407)\n	at org.elasticsearch.client.support.AbstractClient.execute(AbstractClient.java:396)\n	at org.elasticsearch.action.ActionRequestBuilder.execute(ActionRequestBuilder.java:46)\n	at org.springframework.data.elasticsearch.core.ElasticsearchTemplate.getSearchResponse(ElasticsearchTemplate.java:946)\n	at org.springframework.data.elasticsearch.core.ElasticsearchTemplate.doSearch(ElasticsearchTemplate.java:937)\n	at org.springframework.data.elasticsearch.core.ElasticsearchTemplate.queryForPage(ElasticsearchTemplate.java:314)\n	at org.springframework.data.elasticsearch.core.ElasticsearchTemplate.queryForPage(ElasticsearchTemplate.java:309)\n	at org.springframework.data.elasticsearch.core.ElasticsearchTemplate.queryForPage(ElasticsearchTemplate.java:139)\n	at org.springframework.data.elasticsearch.repository.support.AbstractElasticsearchRepository.search(AbstractElasticsearchRepository.java:214)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.data.repository.core.support.RepositoryComposition$RepositoryFragments.invoke(RepositoryComposition.java:359)\n	at org.springframework.data.repository.core.support.RepositoryComposition.invoke(RepositoryComposition.java:200)\n	at org.springframework.data.repository.core.support.RepositoryFactorySupport$ImplementationMethodExecutionInterceptor.invoke(RepositoryFactorySupport.java:644)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.data.repository.core.support.RepositoryFactorySupport$QueryExecutorMethodInterceptor.doInvoke(RepositoryFactorySupport.java:608)\n	at org.springframework.data.repository.core.support.RepositoryFactorySupport$QueryExecutorMethodInterceptor.lambda$invoke$3(RepositoryFactorySupport.java:595)\n	at org.springframework.data.repository.core.support.RepositoryFactorySupport$QueryExecutorMethodInterceptor.invoke(RepositoryFactorySupport.java:595)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.data.projection.DefaultMethodInvokingMethodInterceptor.invoke(DefaultMethodInvokingMethodInterceptor.java:59)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:93)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.data.repository.core.support.SurroundingTransactionDetectorMethodInterceptor.invoke(SurroundingTransactionDetectorMethodInterceptor.java:61)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy120.search(Unknown Source)\n	at cn.iocoder.mall.search.biz.dao.ProductRepository.search(ProductRepository.java:66)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at org.springframework.data.projection.DefaultMethodInvokingMethodInterceptor.invoke(DefaultMethodInvokingMethodInterceptor.java:65)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:93)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.data.repository.core.support.SurroundingTransactionDetectorMethodInterceptor.invoke(SurroundingTransactionDetectorMethodInterceptor.java:61)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy120.search(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy120.search(Unknown Source)\n	at cn.iocoder.mall.search.biz.service.ProductSearchServiceImpl.getSearchPage(ProductSearchServiceImpl.java:103)\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.getSearchPage(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy126.getSearchPage(Unknown Source)\n	at cn.iocoder.mall.search.application.controller.users.UsersProductSearchController.page(UsersProductSearchController.java:47)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.elasticsearch.client.transport.TransportClientNodesService', 'TransportClientNodesService.java', 'ensureNodesAreAvailable', 349, '2019-08-12 17:39:28');
INSERT INTO `exception_log` VALUES (731, '65244362-4480-4de4-9b4b-6080fed9a426', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:55:49', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.hasUserSpuFavorite(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:55:49');
INSERT INTO `exception_log` VALUES (732, 'b4b5d1ac-712b-44e7-b525-c96478e240c9', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:56:12', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.hasUserSpuFavorite(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:56:12');
INSERT INTO `exception_log` VALUES (733, '49719fa5-5d2a-4288-9dfe-786a72c283c1', 197, 1, 'user-application', '/user-api/users/favorite/hasUserFavorite', 'spuId=33', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:57:12', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/user/biz/dao/UserProductSpuCollectionsMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,user_id,nickname,spu_id,spu_name,spu_image,sell_point,price,create_time,update_time,deleted  FROM user_spu_collections     WHERE user_id = ? AND spu_id = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy121.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy139.selectOne(Unknown Source)\n	at cn.iocoder.mall.user.biz.dao.UserProductSpuCollectionsMapper.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsMapper.java:28)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy139.getUserSpuCollectionsByUserIdAndSpuId(Unknown Source)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.getUserSpuCollectionsByUserIdAndSpuId(UserProductSpuCollectionsServiceImpl.java:52)\n	at cn.iocoder.mall.user.biz.service.UserProductSpuCollectionsServiceImpl.hasUserSpuFavorite(UserProductSpuCollectionsServiceImpl.java:122)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.hasUserSpuFavorite(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy140.hasUserSpuFavorite(Unknown Source)\n	at cn.iocoder.mall.user.application.controller.users.UserFavoriteController.hasUserSpuFavorite(UserFavoriteController.java:52)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_user.user_spu_collections\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 123 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 17:57:12');
INSERT INTO `exception_log` VALUES (734, 'b07f6bf8-bb63-4dc1-aabc-f18f32155837', 197, 1, 'pay-application', '/pay-api/users/transaction/submit', 'appId=POd4RC6a&orderId=224&payChannel=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 17:59:22', 'java.lang.RuntimeException', 'RuntimeException: com.pingplusplus.exception.APIConnectionException: IOException during API request to Pingpp (https://api.pingxx.com): /Users/yunai/Downloads/pingxx.pem (No such file or directory) Please check your internet connection and try again. If this problem persists,you should check Pingpp\'s service status at https://pingxx.com/status.', 'FileNotFoundException: /Users/yunai/Downloads/pingxx.pem (No such file or directory)', 'java.lang.RuntimeException: com.pingplusplus.exception.APIConnectionException: IOException during API request to Pingpp (https://api.pingxx.com): /Users/yunai/Downloads/pingxx.pem (No such file or directory) Please check your internet connection and try again. If this problem persists,you should check Pingpp\'s service status at https://pingxx.com/status.\n	at cn.iocoder.mall.pay.biz.client.PingxxPaySDK.submitTransaction(PingxxPaySDK.java:41)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl.submitTransaction(PayTransactionServiceImpl.java:128)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$FastClassBySpringCGLIB$$56519f1d.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.pay.biz.service.PayTransactionServiceImpl$$EnhancerBySpringCGLIB$$81a35629.submitTransaction(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper4.invokeMethod(Wrapper4.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.submitTransaction(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.submitTransaction(Unknown Source)\n	at cn.iocoder.mall.pay.application.controller.users.UsersPayTransactionController.submit(UsersPayTransactionController.java:49)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.pingplusplus.exception.APIConnectionException: IOException during API request to Pingpp (https://api.pingxx.com): /Users/yunai/Downloads/pingxx.pem (No such file or directory) Please check your internet connection and try again. If this problem persists,you should check Pingpp\'s service status at https://pingxx.com/status.\n	at com.pingplusplus.net.APIResource.makeURLConnectionRequest(Unknown Source)\n	at com.pingplusplus.net.APIResource.request(Unknown Source)\n	at com.pingplusplus.model.Charge.create(Unknown Source)\n	at cn.iocoder.mall.pay.biz.client.PingxxPaySDK.submitTransaction(PingxxPaySDK.java:34)\n	... 123 more\nCaused by: java.io.FileNotFoundException: /Users/yunai/Downloads/pingxx.pem (No such file or directory)\n	at java.io.FileInputStream.open0(Native Method)\n	at java.io.FileInputStream.open(FileInputStream.java:195)\n	at java.io.FileInputStream.<init>(FileInputStream.java:138)\n	at java.io.FileInputStream.<init>(FileInputStream.java:93)\n	at com.pingplusplus.net.APIResource.generateSign(Unknown Source)\n	at com.pingplusplus.net.APIResource.createPostConnection(Unknown Source)\n	... 127 more\n', 'cn.iocoder.mall.pay.biz.client.PingxxPaySDK', 'PingxxPaySDK.java', 'submitTransaction', 41, '2019-08-12 17:59:22');
INSERT INTO `exception_log` VALUES (735, '1c44ed01-01a9-4efc-8d2e-0f08dc663488', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:09:55', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,username,nickname,password,status,deptment_id,deleted,create_time,update_time  FROM admin   WHERE  deleted=0  AND username = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'', 'MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,username,nickname,password,status,deptment_id,deleted,create_time,update_time  FROM admin   WHERE  deleted=0  AND username = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy134.selectOne(Unknown Source)\n	at cn.iocoder.mall.admin.dao.AdminMapper.selectByUsername(AdminMapper.java:18)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy134.selectByUsername(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy135.selectByUsername(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:53)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$e9d09694.authentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.authentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.authentication(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:41)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor356.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy221.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor368.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy219.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.GeneratedMethodAccessor384.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 140 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 18:09:55');
INSERT INTO `exception_log` VALUES (736, '3c2df614-158d-4f96-868b-89e6f9f2ad4f', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:10:08', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,username,nickname,password,status,deptment_id,deleted,create_time,update_time  FROM admin   WHERE  deleted=0  AND username = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'', 'MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,username,nickname,password,status,deptment_id,deleted,create_time,update_time  FROM admin   WHERE  deleted=0  AND username = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy134.selectOne(Unknown Source)\n	at cn.iocoder.mall.admin.dao.AdminMapper.selectByUsername(AdminMapper.java:18)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy134.selectByUsername(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy135.selectByUsername(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:53)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$e9d09694.authentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.authentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.authentication(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:41)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor356.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy221.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor368.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy219.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.GeneratedMethodAccessor384.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 140 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 18:10:08');
INSERT INTO `exception_log` VALUES (737, '0a608803-e828-4a59-8c63-08a88c011149', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=nicai&type=account', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:10:18', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,username,nickname,password,status,deptment_id,deleted,create_time,update_time  FROM admin   WHERE  deleted=0  AND username = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'', 'MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n### The error may exist in cn/iocoder/mall/admin/dao/AdminMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,username,nickname,password,status,deptment_id,deleted,create_time,update_time  FROM admin   WHERE  deleted=0  AND username = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.selectOne(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectOne(SqlSessionTemplate.java:166)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:89)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy134.selectOne(Unknown Source)\n	at cn.iocoder.mall.admin.dao.AdminMapper.selectByUsername(AdminMapper.java:18)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy134.selectByUsername(Unknown Source)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\n	at com.sun.proxy.$Proxy135.selectByUsername(Unknown Source)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:53)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$e9d09694.authentication(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.authentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy152.authentication(Unknown Source)\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:41)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Unknown column \'deptment_id\' in \'field list\'\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor356.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy221.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor368.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy219.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectOne(DefaultSqlSession.java:76)\n	at sun.reflect.GeneratedMethodAccessor384.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 140 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 18:10:18');
INSERT INTO `exception_log` VALUES (738, 'b7fabed8-e08a-4ea7-8ab9-610f42e0ba59', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:12:27', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy131.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.DeptmentMapper.getDeptByPid(DeptmentMapper.java:42)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy131.getDeptByPid(Unknown Source)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl.getAllDeptments(DeptmentServiceImpl.java:114)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$FastClassBySpringCGLIB$$d744caf2.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$EnhancerBySpringCGLIB$$127da8d8.getAllDeptments(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.DeptmentController.treeAll(DeptmentController.java:50)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor356.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy221.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor368.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy219.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 92 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 18:12:27');
INSERT INTO `exception_log` VALUES (739, '723f4305-6422-4513-9fd9-47ac263d46af', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:12:27', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy131.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.DeptmentMapper.getDeptByPid(DeptmentMapper.java:42)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy131.getDeptByPid(Unknown Source)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl.getAllDeptments(DeptmentServiceImpl.java:114)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$FastClassBySpringCGLIB$$d744caf2.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$EnhancerBySpringCGLIB$$127da8d8.getAllDeptments(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:108)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor356.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy221.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor368.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy219.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 92 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 18:12:27');
INSERT INTO `exception_log` VALUES (740, '20b53010-aaec-4bab-bfab-4c3122c9a722', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:13:06', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy131.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.DeptmentMapper.getDeptByPid(DeptmentMapper.java:42)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy131.getDeptByPid(Unknown Source)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl.getAllDeptments(DeptmentServiceImpl.java:114)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$FastClassBySpringCGLIB$$d744caf2.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$EnhancerBySpringCGLIB$$127da8d8.getAllDeptments(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.DeptmentController.treeAll(DeptmentController.java:50)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor356.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy221.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor368.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy219.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 92 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 18:13:06');
INSERT INTO `exception_log` VALUES (741, 'bb98a66d-8cad-44e7-824e-c51aaf6a2bd1', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:13:06', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy131.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.DeptmentMapper.getDeptByPid(DeptmentMapper.java:42)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy131.getDeptByPid(Unknown Source)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl.getAllDeptments(DeptmentServiceImpl.java:114)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$FastClassBySpringCGLIB$$d744caf2.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$EnhancerBySpringCGLIB$$127da8d8.getAllDeptments(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:108)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor356.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy221.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor368.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy219.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 92 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 18:13:06');
INSERT INTO `exception_log` VALUES (742, '7fedd17f-8bff-4c39-83c3-394495e304a2', 1, 2, 'admin-application', '/admin-api/admins/dept/tree/all', '', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:13:16', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy131.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.DeptmentMapper.getDeptByPid(DeptmentMapper.java:42)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy131.getDeptByPid(Unknown Source)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl.getAllDeptments(DeptmentServiceImpl.java:114)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$FastClassBySpringCGLIB$$d744caf2.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$EnhancerBySpringCGLIB$$127da8d8.getAllDeptments(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.DeptmentController.treeAll(DeptmentController.java:50)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor356.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy221.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor368.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy219.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 92 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 18:13:16');
INSERT INTO `exception_log` VALUES (743, '965f5bef-0e1c-4c32-948b-a2fd618e972d', 1, 2, 'admin-application', '/admin-api/admins/admin/page', 'pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:13:17', 'org.springframework.jdbc.BadSqlGrammarException', 'BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist', 'org.springframework.jdbc.BadSqlGrammarException: \n### Error querying database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n### The error may exist in cn/iocoder/mall/admin/dao/DeptmentMapper.java (best guess)\n### The error may involve defaultParameterMap\n### The error occurred while setting parameters\n### SQL: SELECT  id,name,sort,pid,deleted,create_time,update_time  FROM deptment   WHERE  deleted=0  AND deleted = ?\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n; bad SQL grammar []; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n	at org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator.doTranslate(SQLErrorCodeSQLExceptionTranslator.java:234)\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\n	at com.sun.proxy.$Proxy130.selectList(Unknown Source)\n	at org.mybatis.spring.SqlSessionTemplate.selectList(SqlSessionTemplate.java:230)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.executeForMany(MybatisMapperMethod.java:158)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:76)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\n	at com.sun.proxy.$Proxy131.selectList(Unknown Source)\n	at cn.iocoder.mall.admin.dao.DeptmentMapper.getDeptByPid(DeptmentMapper.java:42)\n	at java.lang.invoke.MethodHandle.invokeWithArguments(MethodHandle.java:627)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invokeDefaultMethod(MybatisMapperProxy.java:81)\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:56)\n	at com.sun.proxy.$Proxy131.getDeptByPid(Unknown Source)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl.getAllDeptments(DeptmentServiceImpl.java:114)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$FastClassBySpringCGLIB$$d744caf2.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.admin.service.DeptmentServiceImpl$$EnhancerBySpringCGLIB$$127da8d8.getAllDeptments(<generated>)\n	at cn.iocoder.mall.admin.application.controller.admins.AdminController.page(AdminController.java:108)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLSyntaxErrorException: Table \'mall_admin.deptment\' doesn\'t exist\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:944)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\n	at sun.reflect.GeneratedMethodAccessor356.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:59)\n	at com.sun.proxy.$Proxy221.execute(Unknown Source)\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.query(PreparedStatementHandler.java:64)\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.query(RoutingStatementHandler.java:79)\n	at sun.reflect.GeneratedMethodAccessor368.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.$Proxy219.query(Unknown Source)\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doQuery(MybatisSimpleExecutor.java:67)\n	at org.apache.ibatis.executor.BaseExecutor.queryFromDatabase(BaseExecutor.java:324)\n	at org.apache.ibatis.executor.BaseExecutor.query(BaseExecutor.java:156)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:109)\n	at org.apache.ibatis.executor.CachingExecutor.query(CachingExecutor.java:83)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:147)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.selectList(DefaultSqlSession.java:140)\n	at sun.reflect.GeneratedMethodAccessor536.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\n	... 92 more\n', 'org.springframework.jdbc.support.SQLErrorCodeSQLExceptionTranslator', 'SQLErrorCodeSQLExceptionTranslator.java', 'doTranslate', 234, '2019-08-12 18:13:17');
INSERT INTO `exception_log` VALUES (744, '63cf881c-54d1-456b-b96c-61ad0988c883', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=<script>alert(1111)</script>&sellPoint=123&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/a7c70291-3d6e-46c2-90b8-f2b43f134b2b&skuStr=[{\"attrs\":[47,48],\"price\":1200,\"quantity\":2}]&description=<p>123123321</p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/45bae085-0f13-42c8-a048-296ecc2dba2c\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:49:02', 'org.springframework.messaging.MessagingException', 'MessagingException: sendDefaultImpl call timeout; nested exception is org.apache.rocketmq.remoting.exception.RemotingTooMuchRequestException: sendDefaultImpl call timeout', 'RemotingTooMuchRequestException: sendDefaultImpl call timeout', 'org.springframework.messaging.MessagingException: sendDefaultImpl call timeout; nested exception is org.apache.rocketmq.remoting.exception.RemotingTooMuchRequestException: sendDefaultImpl call timeout\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.addProductSpu(ProductSpuServiceImpl.java:93)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$b754724d.addProductSpu(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper11.invokeMethod(Wrapper11.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.addProductSpu(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.addProductSpu(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add(AdminsProductSpuController.java:58)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.remoting.exception.RemotingTooMuchRequestException: sendDefaultImpl call timeout\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:612)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 132 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-08-12 18:49:02');
INSERT INTO `exception_log` VALUES (745, '18216b83-a3c8-48a8-8812-2fc21a57a5c3', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=<script>alert(1111)</script>&sellPoint=123&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/a7c70291-3d6e-46c2-90b8-f2b43f134b2b&skuStr=[{\"attrs\":[47,48],\"price\":1200,\"quantity\":2}]&description=<p>123123321</p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/45bae085-0f13-42c8-a048-296ecc2dba2c\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:49:06', 'org.springframework.messaging.MessagingException', 'MessagingException: sendDefaultImpl call timeout; nested exception is org.apache.rocketmq.remoting.exception.RemotingTooMuchRequestException: sendDefaultImpl call timeout', 'RemotingTooMuchRequestException: sendDefaultImpl call timeout', 'org.springframework.messaging.MessagingException: sendDefaultImpl call timeout; nested exception is org.apache.rocketmq.remoting.exception.RemotingTooMuchRequestException: sendDefaultImpl call timeout\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.addProductSpu(ProductSpuServiceImpl.java:93)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$b754724d.addProductSpu(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper11.invokeMethod(Wrapper11.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.addProductSpu(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.addProductSpu(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add(AdminsProductSpuController.java:58)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.remoting.exception.RemotingTooMuchRequestException: sendDefaultImpl call timeout\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:612)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 132 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-08-12 18:49:06');
INSERT INTO `exception_log` VALUES (746, '46070900-168c-4bd0-9317-abda3c9d6a2a', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=<script>alert(1111)</script>&sellPoint=123&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/a7c70291-3d6e-46c2-90b8-f2b43f134b2b&skuStr=[{\"attrs\":[47,48],\"price\":1200,\"quantity\":2}]&description=<p>123123321</p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/45bae085-0f13-42c8-a048-296ecc2dba2c\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:49:22', 'org.springframework.messaging.MessagingException', 'MessagingException: sendDefaultImpl call timeout; nested exception is org.apache.rocketmq.remoting.exception.RemotingTooMuchRequestException: sendDefaultImpl call timeout', 'RemotingTooMuchRequestException: sendDefaultImpl call timeout', 'org.springframework.messaging.MessagingException: sendDefaultImpl call timeout; nested exception is org.apache.rocketmq.remoting.exception.RemotingTooMuchRequestException: sendDefaultImpl call timeout\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.addProductSpu(ProductSpuServiceImpl.java:93)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$b754724d.addProductSpu(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper11.invokeMethod(Wrapper11.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.addProductSpu(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.addProductSpu(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add(AdminsProductSpuController.java:58)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.remoting.exception.RemotingTooMuchRequestException: sendDefaultImpl call timeout\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:612)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 132 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-08-12 18:49:22');
INSERT INTO `exception_log` VALUES (747, '931d94fa-047e-4dbc-a01b-a1f6258a3b08', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=<script>alert(1111)</script>&sellPoint=123&cid=784&visible=true&picUrls=http://static.shop.iocoder.cn/a7c70291-3d6e-46c2-90b8-f2b43f134b2b&skuStr=[{\"attrs\":[47,48],\"price\":1200,\"quantity\":2}]&description=<p>123123321</p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/45bae085-0f13-42c8-a048-296ecc2dba2c\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_14_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '127.0.0.1', '2019-08-12 18:50:51', 'org.springframework.messaging.MessagingException', 'MessagingException: sendDefaultImpl call timeout; nested exception is org.apache.rocketmq.remoting.exception.RemotingTooMuchRequestException: sendDefaultImpl call timeout', 'RemotingTooMuchRequestException: sendDefaultImpl call timeout', 'org.springframework.messaging.MessagingException: sendDefaultImpl call timeout; nested exception is org.apache.rocketmq.remoting.exception.RemotingTooMuchRequestException: sendDefaultImpl call timeout\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.addProductSpu(ProductSpuServiceImpl.java:93)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$b754724d.addProductSpu(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper11.invokeMethod(Wrapper11.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy3.addProductSpu(proxy3.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy148.addProductSpu(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add(AdminsProductSpuController.java:58)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.remoting.exception.RemotingTooMuchRequestException: sendDefaultImpl call timeout\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:612)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 132 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-08-12 18:50:51');
INSERT INTO `exception_log` VALUES (748, '64.84.15656243125659189', 1, 2, 'product-application', '/product-api/admins/spu/update', 'name=Oracle&sellPoint=数据库服务器&cid=639&visible=true&id=35&picUrls=https://static.oschina.net/img/logo/oracle.gif&skuStr=[{\"attrs\":[3],\"price\":500000,\"quantity\":11},{\"attrs\":[4],\"price\":200000,\"quantity\":22}]&description=<p>Oracle是一个面向Internet计算环境的数据库。它是在数据库领域一直处于领先地位的Oracle（即甲骨文公司）的产品。可以说Oracle 关系数据库系统是目前世界上流行的关系数据库管理系统，系统可移植性好、使用方便、功能强，适用于各类大、中、小、微机环境。它是一种高效率、可靠性好的 适应高吞吐量的数据库解决方案。</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:38:33', 'org.springframework.messaging.MessagingException', 'MessagingException: Send [3] times, still failed, cost [12]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.', 'RemotingConnectException: connect to <192.168.88.14:10909> failed', 'org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [12]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.updateProductSpu(ProductSpuServiceImpl.java:142)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$50114869.updateProductSpu(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.updateProductSpu(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy150.updateProductSpu(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.update$original$pMLWVoQz(AdminsProductSpuController.java:88)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.update$original$pMLWVoQz$accessor$3Lvpt4vw(AdminsProductSpuController.java)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController$auxiliary$WveSZHUR.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.update(AdminsProductSpuController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0$accessor$7vT1VInN(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$iFD4aFHO.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 148 more\nCaused by: org.apache.rocketmq.remoting.exception.RemotingConnectException: connect to <192.168.88.14:10909> failed\n	at org.apache.rocketmq.remoting.netty.NettyRemotingClient.invokeSync(NettyRemotingClient.java:393)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:356)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC$accessor$lQ2PcgrU(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl$auxiliary$Ns31PXYD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 151 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-08-12 23:38:33');
INSERT INTO `exception_log` VALUES (749, '64.77.15656247717099195', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=Hadoop&sellPoint=有点小贵&cid=794&visible=true&picUrls=http://static.shop.iocoder.cn/4870d103-1c00-42e1-8eb7-177e227d5e03&skuStr=[{\"attrs\":[1],\"price\":10000,\"quantity\":100}]&description=<p>好看的不得了</p><div class=\"media-wrap image-wrap\"><img src=\"http://static.shop.iocoder.cn/d5dccd13-1f82-483e-bb87-fc47e14cb19f\"/></div><p></p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '171.43.143.65', '2019-08-12 23:46:12', 'org.springframework.messaging.MessagingException', 'MessagingException: Send [3] times, still failed, cost [12]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.', 'RemotingConnectException: connect to <192.168.88.14:10909> failed', 'org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [12]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.addProductSpu(ProductSpuServiceImpl.java:93)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$50114869.addProductSpu(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.addProductSpu(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy150.addProductSpu(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz(AdminsProductSpuController.java:58)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz$accessor$3Lvpt4vw(AdminsProductSpuController.java)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController$auxiliary$7LKbfGk3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add(AdminsProductSpuController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0$accessor$7vT1VInN(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$iFD4aFHO.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [12]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 148 more\nCaused by: org.apache.rocketmq.remoting.exception.RemotingConnectException: connect to <192.168.88.14:10909> failed\n	at org.apache.rocketmq.remoting.netty.NettyRemotingClient.invokeSync(NettyRemotingClient.java:393)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:356)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC$accessor$lQ2PcgrU(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl$auxiliary$Ns31PXYD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 151 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-08-12 23:46:12');
INSERT INTO `exception_log` VALUES (750, 'a4078788-29d1-4bd8-83f2-f40a59f83a52', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:51', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=105, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=105, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=105, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=105, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:58:51');
INSERT INTO `exception_log` VALUES (751, '6512554f-1e00-4595-aafb-33c0449e3185', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:51', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=104, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=104, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=104, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=104, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:58:51');
INSERT INTO `exception_log` VALUES (752, 'a4078788-29d1-4bd8-83f2-f40a59f83a52', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:51', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=105, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=105, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=105, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=105, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:58:52');
INSERT INTO `exception_log` VALUES (753, '6512554f-1e00-4595-aafb-33c0449e3185', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:51', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=104, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=104, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=104, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=104, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:58:52');
INSERT INTO `exception_log` VALUES (754, 'a4078788-29d1-4bd8-83f2-f40a59f83a52', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:51', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=105, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=105, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=105, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 1 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=105, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:58:53');
INSERT INTO `exception_log` VALUES (755, '6512554f-1e00-4595-aafb-33c0449e3185', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:51', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=104, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=104, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=104, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:50.311, end time: 2019-08-12 23:58:51.317, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=104, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:58:53');
INSERT INTO `exception_log` VALUES (756, 'f169fc46-536c-4a05-af8e-b9bfc4a207b1', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=117, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=117, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=117, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=117, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:58:55');
INSERT INTO `exception_log` VALUES (757, '0811289d-7adc-4b42-97f1-27f749c4bb83', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=116, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=116, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=116, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=116, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:58:55');
INSERT INTO `exception_log` VALUES (758, 'f169fc46-536c-4a05-af8e-b9bfc4a207b1', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=117, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=117, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=117, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=117, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:58:56');
INSERT INTO `exception_log` VALUES (759, '0811289d-7adc-4b42-97f1-27f749c4bb83', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=116, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=116, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=116, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=116, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:58:56');
INSERT INTO `exception_log` VALUES (760, '0811289d-7adc-4b42-97f1-27f749c4bb83', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=116, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=116, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=116, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=116, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:58:57');
INSERT INTO `exception_log` VALUES (761, 'f169fc46-536c-4a05-af8e-b9bfc4a207b1', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:58:55', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=117, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=117, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623415732&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=117, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy2.getAuthentication(proxy2.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy153.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:58:54.239, end time: 2019-08-12 23:58:55.242, client elapsed: 1 ms, server elapsed: 1001 ms, timeout: 1000 ms, request: Request [id=117, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51287 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:58:57');
INSERT INTO `exception_log` VALUES (762, '7976cc24-a1de-4312-8c3c-6dc9c9caa119', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:59:22', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.3.7:20882] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://192.168.3.7:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuDetailListForSync,getProductSpuPage,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=product-service&remote.timestamp=1565623362355&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623413006&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:59:20.839, end time: 2019-08-12 23:59:21.844, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=145, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.3.7:51283 -> /192.168.3.7:20882', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:59:20.839, end time: 2019-08-12 23:59:21.844, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=145, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.3.7:51283 -> /192.168.3.7:20882', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.3.7:20882] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://192.168.3.7:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuDetailListForSync,getProductSpuPage,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=product-service&remote.timestamp=1565623362355&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623413006&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:59:20.839, end time: 2019-08-12 23:59:21.844, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=145, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.3.7:51283 -> /192.168.3.7:20882\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getProductSpuList(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getProductSpuList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:43)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:59:20.839, end time: 2019-08-12 23:59:21.844, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=145, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.3.7:51283 -> /192.168.3.7:20882\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 86 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:59:22');
INSERT INTO `exception_log` VALUES (763, '7976cc24-a1de-4312-8c3c-6dc9c9caa119', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:59:22', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.3.7:20882] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://192.168.3.7:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuDetailListForSync,getProductSpuPage,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=product-service&remote.timestamp=1565623362355&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623413006&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:59:20.839, end time: 2019-08-12 23:59:21.844, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=145, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.3.7:51283 -> /192.168.3.7:20882', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:59:20.839, end time: 2019-08-12 23:59:21.844, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=145, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.3.7:51283 -> /192.168.3.7:20882', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.3.7:20882] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://192.168.3.7:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuDetailListForSync,getProductSpuPage,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=product-service&remote.timestamp=1565623362355&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623413006&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:59:20.839, end time: 2019-08-12 23:59:21.844, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=145, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.3.7:51283 -> /192.168.3.7:20882\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getProductSpuList(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getProductSpuList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:43)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:59:20.839, end time: 2019-08-12 23:59:21.844, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=145, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.3.7:51283 -> /192.168.3.7:20882\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 86 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:59:23');
INSERT INTO `exception_log` VALUES (764, '7976cc24-a1de-4312-8c3c-6dc9c9caa119', 197, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-12 23:59:22', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.3.7:20882] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://192.168.3.7:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuDetailListForSync,getProductSpuPage,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=product-service&remote.timestamp=1565623362355&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623413006&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:59:20.839, end time: 2019-08-12 23:59:21.844, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=145, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.3.7:51283 -> /192.168.3.7:20882', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:59:20.839, end time: 2019-08-12 23:59:21.844, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=145, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.3.7:51283 -> /192.168.3.7:20882', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.3.7:20882] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://192.168.3.7:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuDetailListForSync,getProductSpuPage,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=3000&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=product-service&remote.timestamp=1565623362355&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623413006&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-12 23:59:20.839, end time: 2019-08-12 23:59:21.844, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=145, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.3.7:51283 -> /192.168.3.7:20882\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy0.getProductSpuList(proxy0.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy141.getProductSpuList(Unknown Source)\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:43)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-12 23:59:20.839, end time: 2019-08-12 23:59:21.844, client elapsed: 0 ms, server elapsed: 1005 ms, timeout: 1000 ms, request: Request [id=145, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.3.7:51283 -> /192.168.3.7:20882\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 86 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-12 23:59:24');
INSERT INTO `exception_log` VALUES (765, 'bd22c2c2-98f8-441d-b68f-9856f8dec6de', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:20', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=2973&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623359848&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-13 00:01:19.139, end time: 2019-08-13 00:01:20.143, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=80, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51186 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-13 00:01:19.139, end time: 2019-08-13 00:01:20.143, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=80, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51186 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=2973&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623359848&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-13 00:01:19.139, end time: 2019-08-13 00:01:20.143, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=80, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51186 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getAuthentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy158.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-13 00:01:19.139, end time: 2019-08-13 00:01:20.143, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=80, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51186 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-13 00:01:20');
INSERT INTO `exception_log` VALUES (766, 'bd22c2c2-98f8-441d-b68f-9856f8dec6de', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:20', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=2973&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623359848&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-13 00:01:19.139, end time: 2019-08-13 00:01:20.143, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=80, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51186 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-13 00:01:19.139, end time: 2019-08-13 00:01:20.143, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=80, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51186 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=2973&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623359848&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-13 00:01:19.139, end time: 2019-08-13 00:01:20.143, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=80, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51186 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getAuthentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy158.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-13 00:01:19.139, end time: 2019-08-13 00:01:20.143, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=80, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51186 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-13 00:01:21');
INSERT INTO `exception_log` VALUES (767, 'bd22c2c2-98f8-441d-b68f-9856f8dec6de', 0, 1, 'product-application', '/product-api/users/category/list', 'pid=0', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-13 00:01:20', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=2973&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623359848&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-13 00:01:19.139, end time: 2019-08-13 00:01:20.143, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=80, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51186 -> /192.168.3.7:20880', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-13 00:01:19.139, end time: 2019-08-13 00:01:20.143, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=80, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51186 -> /192.168.3.7:20880', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getAuthentication in the service cn.iocoder.mall.admin.api.OAuth2Service. Tried 3 times of the providers [192.168.3.7:20880] (1/1) from the registry 127.0.0.1:2181 on the consumer 192.168.3.7 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getAuthentication, provider: dubbo://192.168.3.7:20880/cn.iocoder.mall.admin.api.OAuth2Service?anyhost=true&application=product-service&bean.name=providers:dubbo:cn.iocoder.mall.admin.api.OAuth2Service:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.admin.api.OAuth2Service&lazy=false&methods=getAuthentication,removeToken,createToken,refreshToken&pid=2973&qos.enable=false&register=true&register.ip=192.168.3.7&release=2.7.1&remote.application=admin-service&remote.timestamp=1565623301671&revision=1.0.0&side=consumer&sticky=false&timestamp=1565623359848&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-13 00:01:19.139, end time: 2019-08-13 00:01:20.143, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=80, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51186 -> /192.168.3.7:20880\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy1.getAuthentication(proxy1.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy158.getAuthentication(Unknown Source)\n	at cn.iocoder.mall.user.sdk.interceptor.UserSecurityInterceptor.preHandle(UserSecurityInterceptor.java:43)\n	at org.springframework.web.servlet.HandlerExecutionChain.applyPreHandle(HandlerExecutionChain.java:136)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1033)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1142)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:617)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-13 00:01:19.139, end time: 2019-08-13 00:01:20.143, client elapsed: 0 ms, server elapsed: 1004 ms, timeout: 1000 ms, request: Request [id=80, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getAuthentication, parameterTypes=[class cn.iocoder.mall.admin.api.dto.oauth2.OAuth2GetTokenDTO], arguments=[OAuth2GetTokenDTO(accessToken=bf390d0e06634cccbeeea152795257f1, userType=1)], attachments={path=cn.iocoder.mall.admin.api.OAuth2Service, interface=cn.iocoder.mall.admin.api.OAuth2Service, version=1.0.0}]], channel: /192.168.3.7:51186 -> /192.168.3.7:20880\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\n	... 77 more\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-13 00:01:22');
INSERT INTO `exception_log` VALUES (768, '66.53.15656819591367241', 198, 1, 'user-application', '/user-api/users/address/add', 'name=哈哈&tel=13693100472&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=哈哈&isDefault=false&address=哈哈&areaNo=110101&mobile=13693100472&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:39:19', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [哈哈]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [哈哈]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [哈哈]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-08-13 15:39:19');
INSERT INTO `exception_log` VALUES (769, '66.54.15656819609987257', 198, 1, 'user-application', '/user-api/users/address/add', 'name=哈哈&tel=13693100472&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=哈哈&isDefault=false&address=哈哈&areaNo=110101&mobile=13693100472&hasDefault=1', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:39:21', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [哈哈]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [哈哈]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [哈哈]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-08-13 15:39:21');
INSERT INTO `exception_log` VALUES (770, '66.50.15656819632327247', 198, 1, 'user-application', '/user-api/users/address/add', 'name=哈哈&tel=13693100472&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=哈哈&isDefault=true&address=哈哈&areaNo=110101&mobile=13693100472&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 9; ONEPLUS A6010 Build/PKQ1.180716.001; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/66.0.3359.126 MQQBrowser/6.2 TBS/044813 Mobile Safari/537.36 MMWEBID/8964 MicroMessenger/7.0.6.1460(0x27000634) Process/tools NetType/WIFI Language/zh_CN', '219.143.154.194', '2019-08-13 15:39:23', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [哈哈]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [哈哈]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [哈哈]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-08-13 15:39:23');
INSERT INTO `exception_log` VALUES (771, '66.53.15657471495708119', 200, 1, 'user-application', '/user-api/users/address/add', 'name=4&tel=18825146607&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=44&isDefault=true&address=44&areaNo=110101&mobile=18825146607&hasDefault=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:50', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-08-14 09:45:50');
INSERT INTO `exception_log` VALUES (772, '66.52.15657471561878123', 200, 1, 'user-application', '/user-api/users/address/add', 'name=东方故事代发工资&tel=18825146607&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=44&isDefault=true&address=44&areaNo=110101&mobile=18825146607&hasDefault=2', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.100 Safari/537.36', '113.111.63.54', '2019-08-14 09:45:56', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [44]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-08-14 09:45:56');
INSERT INTO `exception_log` VALUES (773, 'd9f61418-a6d9-4be6-a9c4-7be970668f11', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '127.0.0.1', '2019-08-20 17:49:09', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy5', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\r\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\r\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\r\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\r\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\r\n	at com.sun.proxy.$Proxy142.getProductRecommendList(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:40)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\r\n	... 90 more\r\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\r\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\r\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\r\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\r\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\r\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\r\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\r\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\r\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\r\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\r\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\r\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\r\n	at javassist.compiler.Javac.compile(Javac.java:95)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\r\n	... 92 more\r\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-08-20 17:49:09');
INSERT INTO `exception_log` VALUES (774, 'af6089bd-29ec-4cd1-a6a0-03e37a31fa0b', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:03:52', 'org.elasticsearch.action.search.SearchPhaseExecutionException', 'SearchPhaseExecutionException: all shards failed', 'QueryShardException: No mapping found for [sort] in order to sort on', 'Failed to execute phase [query], all shards failed; shardFailures {[Zm4jbjlDRruYNMpBFSr3SQ][product][0]: RemoteTransportException[[es-node2][172.23.0.5:9302][indices:data/read/search[phase/query]]]; nested: QueryShardException[No mapping found for [sort] in order to sort on]; }\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.onPhaseFailure(AbstractSearchAsyncAction.java:293)\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.executeNextPhase(AbstractSearchAsyncAction.java:133)\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.onPhaseDone(AbstractSearchAsyncAction.java:254)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.onShardFailure(InitialSearchPhase.java:101)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.access$100(InitialSearchPhase.java:48)\r\n	at org.elasticsearch.action.search.InitialSearchPhase$2.lambda$onFailure$1(InitialSearchPhase.java:222)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.maybeFork(InitialSearchPhase.java:176)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.access$000(InitialSearchPhase.java:48)\r\n	at org.elasticsearch.action.search.InitialSearchPhase$2.onFailure(InitialSearchPhase.java:222)\r\n	at org.elasticsearch.action.search.SearchExecutionStatsCollector.onFailure(SearchExecutionStatsCollector.java:73)\r\n	at org.elasticsearch.action.ActionListenerResponseHandler.handleException(ActionListenerResponseHandler.java:51)\r\n	at org.elasticsearch.action.search.SearchTransportService$ConnectionCountingHandler.handleException(SearchTransportService.java:464)\r\n	at org.elasticsearch.transport.TransportService$ContextRestoreResponseHandler.handleException(TransportService.java:1130)\r\n	at org.elasticsearch.transport.TcpTransport.lambda$handleException$32(TcpTransport.java:1268)\r\n	at org.elasticsearch.common.util.concurrent.EsExecutors$1.execute(EsExecutors.java:135)\r\n	at org.elasticsearch.transport.TcpTransport.handleException(TcpTransport.java:1266)\r\n	at org.elasticsearch.transport.TcpTransport.handlerResponseError(TcpTransport.java:1258)\r\n	at org.elasticsearch.transport.TcpTransport.messageReceived(TcpTransport.java:1188)\r\n	at org.elasticsearch.transport.netty4.Netty4MessageChannelHandler.channelRead(Netty4MessageChannelHandler.java:65)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.fireChannelRead(ByteToMessageDecoder.java:323)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.fireChannelRead(ByteToMessageDecoder.java:310)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.callDecode(ByteToMessageDecoder.java:426)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.channelRead(ByteToMessageDecoder.java:278)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.handler.logging.LoggingHandler.channelRead(LoggingHandler.java:241)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.channel.DefaultChannelPipeline$HeadContext.channelRead(DefaultChannelPipeline.java:1434)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.DefaultChannelPipeline.fireChannelRead(DefaultChannelPipeline.java:965)\r\n	at io.netty.channel.nio.AbstractNioByteChannel$NioByteUnsafe.read(AbstractNioByteChannel.java:163)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKey(NioEventLoop.java:644)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKeysPlain(NioEventLoop.java:544)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKeys(NioEventLoop.java:498)\r\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:458)\r\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:897)\r\n	at java.lang.Thread.run(Thread.java:834)\r\nCaused by: [product/apdpPtb2QuaqCdvhYVdlWg] QueryShardException[No mapping found for [sort] in order to sort on]\r\n	at org.elasticsearch.search.sort.FieldSortBuilder.build(FieldSortBuilder.java:319)\r\n	at org.elasticsearch.search.sort.SortBuilder.buildSort(SortBuilder.java:153)\r\n	at org.elasticsearch.search.SearchService.parseSource(SearchService.java:782)\r\n	at org.elasticsearch.search.SearchService.createContext(SearchService.java:616)\r\n	at org.elasticsearch.search.SearchService.createAndPutContext(SearchService.java:592)\r\n	at org.elasticsearch.search.SearchService.executeQueryPhase(SearchService.java:367)\r\n	at org.elasticsearch.search.SearchService.access$100(SearchService.java:121)\r\n	at org.elasticsearch.search.SearchService$2.onResponse(SearchService.java:339)\r\n	at org.elasticsearch.search.SearchService$2.onResponse(SearchService.java:335)\r\n	at org.elasticsearch.search.SearchService$4.doRun(SearchService.java:1082)\r\n	at org.elasticsearch.common.util.concurrent.ThreadContext$ContextPreservingAbstractRunnable.doRun(ThreadContext.java:723)\r\n	at org.elasticsearch.common.util.concurrent.AbstractRunnable.run(AbstractRunnable.java:37)\r\n	at org.elasticsearch.common.util.concurrent.TimedRunnable.doRun(TimedRunnable.java:41)\r\n	at org.elasticsearch.common.util.concurrent.AbstractRunnable.run(AbstractRunnable.java:37)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1128)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:628)\r\n	... 1 more\r\n', 'org.elasticsearch.action.search.AbstractSearchAsyncAction', 'AbstractSearchAsyncAction.java', 'onPhaseFailure', 293, '2019-08-22 12:03:52');
INSERT INTO `exception_log` VALUES (775, '2d8e8276-568b-4516-8d31-3213f7f19929', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=638&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:03:55', 'org.elasticsearch.action.search.SearchPhaseExecutionException', 'SearchPhaseExecutionException: all shards failed', 'QueryShardException: No mapping found for [sort] in order to sort on', 'Failed to execute phase [query], all shards failed; shardFailures {[Zm4jbjlDRruYNMpBFSr3SQ][product][0]: RemoteTransportException[[es-node2][172.23.0.5:9302][indices:data/read/search[phase/query]]]; nested: QueryShardException[No mapping found for [sort] in order to sort on]; }\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.onPhaseFailure(AbstractSearchAsyncAction.java:293)\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.executeNextPhase(AbstractSearchAsyncAction.java:133)\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.onPhaseDone(AbstractSearchAsyncAction.java:254)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.onShardFailure(InitialSearchPhase.java:101)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.access$100(InitialSearchPhase.java:48)\r\n	at org.elasticsearch.action.search.InitialSearchPhase$2.lambda$onFailure$1(InitialSearchPhase.java:222)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.maybeFork(InitialSearchPhase.java:176)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.access$000(InitialSearchPhase.java:48)\r\n	at org.elasticsearch.action.search.InitialSearchPhase$2.onFailure(InitialSearchPhase.java:222)\r\n	at org.elasticsearch.action.search.SearchExecutionStatsCollector.onFailure(SearchExecutionStatsCollector.java:73)\r\n	at org.elasticsearch.action.ActionListenerResponseHandler.handleException(ActionListenerResponseHandler.java:51)\r\n	at org.elasticsearch.action.search.SearchTransportService$ConnectionCountingHandler.handleException(SearchTransportService.java:464)\r\n	at org.elasticsearch.transport.TransportService$ContextRestoreResponseHandler.handleException(TransportService.java:1130)\r\n	at org.elasticsearch.transport.TcpTransport.lambda$handleException$32(TcpTransport.java:1268)\r\n	at org.elasticsearch.common.util.concurrent.EsExecutors$1.execute(EsExecutors.java:135)\r\n	at org.elasticsearch.transport.TcpTransport.handleException(TcpTransport.java:1266)\r\n	at org.elasticsearch.transport.TcpTransport.handlerResponseError(TcpTransport.java:1258)\r\n	at org.elasticsearch.transport.TcpTransport.messageReceived(TcpTransport.java:1188)\r\n	at org.elasticsearch.transport.netty4.Netty4MessageChannelHandler.channelRead(Netty4MessageChannelHandler.java:65)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.fireChannelRead(ByteToMessageDecoder.java:323)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.fireChannelRead(ByteToMessageDecoder.java:310)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.callDecode(ByteToMessageDecoder.java:426)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.channelRead(ByteToMessageDecoder.java:278)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.handler.logging.LoggingHandler.channelRead(LoggingHandler.java:241)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.channel.DefaultChannelPipeline$HeadContext.channelRead(DefaultChannelPipeline.java:1434)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.DefaultChannelPipeline.fireChannelRead(DefaultChannelPipeline.java:965)\r\n	at io.netty.channel.nio.AbstractNioByteChannel$NioByteUnsafe.read(AbstractNioByteChannel.java:163)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKey(NioEventLoop.java:644)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKeysPlain(NioEventLoop.java:544)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKeys(NioEventLoop.java:498)\r\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:458)\r\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:897)\r\n	at java.lang.Thread.run(Thread.java:834)\r\nCaused by: [product/apdpPtb2QuaqCdvhYVdlWg] QueryShardException[No mapping found for [sort] in order to sort on]\r\n	at org.elasticsearch.search.sort.FieldSortBuilder.build(FieldSortBuilder.java:319)\r\n	at org.elasticsearch.search.sort.SortBuilder.buildSort(SortBuilder.java:153)\r\n	at org.elasticsearch.search.SearchService.parseSource(SearchService.java:782)\r\n	at org.elasticsearch.search.SearchService.createContext(SearchService.java:616)\r\n	at org.elasticsearch.search.SearchService.createAndPutContext(SearchService.java:592)\r\n	at org.elasticsearch.search.SearchService.executeQueryPhase(SearchService.java:367)\r\n	at org.elasticsearch.search.SearchService.access$100(SearchService.java:121)\r\n	at org.elasticsearch.search.SearchService$2.onResponse(SearchService.java:339)\r\n	at org.elasticsearch.search.SearchService$2.onResponse(SearchService.java:335)\r\n	at org.elasticsearch.search.SearchService$4.doRun(SearchService.java:1082)\r\n	at org.elasticsearch.common.util.concurrent.ThreadContext$ContextPreservingAbstractRunnable.doRun(ThreadContext.java:723)\r\n	at org.elasticsearch.common.util.concurrent.AbstractRunnable.run(AbstractRunnable.java:37)\r\n	at org.elasticsearch.common.util.concurrent.TimedRunnable.doRun(TimedRunnable.java:41)\r\n	at org.elasticsearch.common.util.concurrent.AbstractRunnable.run(AbstractRunnable.java:37)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1128)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:628)\r\n	... 1 more\r\n', 'org.elasticsearch.action.search.AbstractSearchAsyncAction', 'AbstractSearchAsyncAction.java', 'onPhaseFailure', 293, '2019-08-22 12:03:55');
INSERT INTO `exception_log` VALUES (776, '4a412a3f-a2c6-45cb-ada3-c156a01b65d3', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=796&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:04:01', 'org.elasticsearch.action.search.SearchPhaseExecutionException', 'SearchPhaseExecutionException: all shards failed', 'QueryShardException: No mapping found for [sort] in order to sort on', 'Failed to execute phase [query], all shards failed; shardFailures {[Zm4jbjlDRruYNMpBFSr3SQ][product][0]: RemoteTransportException[[es-node2][172.23.0.5:9302][indices:data/read/search[phase/query]]]; nested: QueryShardException[No mapping found for [sort] in order to sort on]; }\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.onPhaseFailure(AbstractSearchAsyncAction.java:293)\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.executeNextPhase(AbstractSearchAsyncAction.java:133)\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.onPhaseDone(AbstractSearchAsyncAction.java:254)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.onShardFailure(InitialSearchPhase.java:101)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.access$100(InitialSearchPhase.java:48)\r\n	at org.elasticsearch.action.search.InitialSearchPhase$2.lambda$onFailure$1(InitialSearchPhase.java:222)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.maybeFork(InitialSearchPhase.java:176)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.access$000(InitialSearchPhase.java:48)\r\n	at org.elasticsearch.action.search.InitialSearchPhase$2.onFailure(InitialSearchPhase.java:222)\r\n	at org.elasticsearch.action.search.SearchExecutionStatsCollector.onFailure(SearchExecutionStatsCollector.java:73)\r\n	at org.elasticsearch.action.ActionListenerResponseHandler.handleException(ActionListenerResponseHandler.java:51)\r\n	at org.elasticsearch.action.search.SearchTransportService$ConnectionCountingHandler.handleException(SearchTransportService.java:464)\r\n	at org.elasticsearch.transport.TransportService$ContextRestoreResponseHandler.handleException(TransportService.java:1130)\r\n	at org.elasticsearch.transport.TcpTransport.lambda$handleException$32(TcpTransport.java:1268)\r\n	at org.elasticsearch.common.util.concurrent.EsExecutors$1.execute(EsExecutors.java:135)\r\n	at org.elasticsearch.transport.TcpTransport.handleException(TcpTransport.java:1266)\r\n	at org.elasticsearch.transport.TcpTransport.handlerResponseError(TcpTransport.java:1258)\r\n	at org.elasticsearch.transport.TcpTransport.messageReceived(TcpTransport.java:1188)\r\n	at org.elasticsearch.transport.netty4.Netty4MessageChannelHandler.channelRead(Netty4MessageChannelHandler.java:65)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.fireChannelRead(ByteToMessageDecoder.java:323)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.fireChannelRead(ByteToMessageDecoder.java:310)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.callDecode(ByteToMessageDecoder.java:426)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.channelRead(ByteToMessageDecoder.java:278)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.handler.logging.LoggingHandler.channelRead(LoggingHandler.java:241)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.channel.DefaultChannelPipeline$HeadContext.channelRead(DefaultChannelPipeline.java:1434)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.DefaultChannelPipeline.fireChannelRead(DefaultChannelPipeline.java:965)\r\n	at io.netty.channel.nio.AbstractNioByteChannel$NioByteUnsafe.read(AbstractNioByteChannel.java:163)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKey(NioEventLoop.java:644)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKeysPlain(NioEventLoop.java:544)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKeys(NioEventLoop.java:498)\r\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:458)\r\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:897)\r\n	at java.lang.Thread.run(Thread.java:834)\r\nCaused by: [product/apdpPtb2QuaqCdvhYVdlWg] QueryShardException[No mapping found for [sort] in order to sort on]\r\n	at org.elasticsearch.search.sort.FieldSortBuilder.build(FieldSortBuilder.java:319)\r\n	at org.elasticsearch.search.sort.SortBuilder.buildSort(SortBuilder.java:153)\r\n	at org.elasticsearch.search.SearchService.parseSource(SearchService.java:782)\r\n	at org.elasticsearch.search.SearchService.createContext(SearchService.java:616)\r\n	at org.elasticsearch.search.SearchService.createAndPutContext(SearchService.java:592)\r\n	at org.elasticsearch.search.SearchService.executeQueryPhase(SearchService.java:367)\r\n	at org.elasticsearch.search.SearchService.access$100(SearchService.java:121)\r\n	at org.elasticsearch.search.SearchService$2.onResponse(SearchService.java:339)\r\n	at org.elasticsearch.search.SearchService$2.onResponse(SearchService.java:335)\r\n	at org.elasticsearch.search.SearchService$4.doRun(SearchService.java:1082)\r\n	at org.elasticsearch.common.util.concurrent.ThreadContext$ContextPreservingAbstractRunnable.doRun(ThreadContext.java:723)\r\n	at org.elasticsearch.common.util.concurrent.AbstractRunnable.run(AbstractRunnable.java:37)\r\n	at org.elasticsearch.common.util.concurrent.TimedRunnable.doRun(TimedRunnable.java:41)\r\n	at org.elasticsearch.common.util.concurrent.AbstractRunnable.run(AbstractRunnable.java:37)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1128)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:628)\r\n	... 1 more\r\n', 'org.elasticsearch.action.search.AbstractSearchAsyncAction', 'AbstractSearchAsyncAction.java', 'onPhaseFailure', 293, '2019-08-22 12:04:01');
INSERT INTO `exception_log` VALUES (777, '46bd6f79-cf83-49ae-8ac3-a632514b4c64', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17602176892&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:04:33', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport', 'ZipException: invalid LOC header (bad signature)', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport\r\n	at java.lang.ClassLoader.defineClass1(Native Method)\r\n	at java.lang.ClassLoader.defineClass(ClassLoader.java:763)\r\n	at java.security.SecureClassLoader.defineClass(SecureClassLoader.java:142)\r\n	at java.net.URLClassLoader.defineClass(URLClassLoader.java:467)\r\n	at java.net.URLClassLoader.access$100(URLClassLoader.java:73)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:368)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:362)\r\n	at java.security.AccessController.doPrivileged(Native Method)\r\n	at java.net.URLClassLoader.findClass(URLClassLoader.java:361)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:424)\r\n	at sun.misc.Launcher$AppClassLoader.loadClass(Launcher.java:338)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:357)\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$bc510cd0.authenticationByMobileCode(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper8.invokeMethod(Wrapper8.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy130.authenticationByMobileCode(Unknown Source)\r\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:45)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 61 more\r\nCaused by: java.lang.ClassNotFoundException: org.springframework.jdbc.datasource.JdbcTransactionObjectSupport\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:370)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:362)\r\n	at java.security.AccessController.doPrivileged(Native Method)\r\n	at java.net.URLClassLoader.findClass(URLClassLoader.java:361)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:424)\r\n	at sun.misc.Launcher$AppClassLoader.loadClass(Launcher.java:338)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:357)\r\n	... 131 more\r\nCaused by: java.util.zip.ZipException: invalid LOC header (bad signature)\r\n	at java.util.zip.ZipFile.read(Native Method)\r\n	at java.util.zip.ZipFile.access$1400(ZipFile.java:60)\r\n	at java.util.zip.ZipFile$ZipFileInputStream.read(ZipFile.java:734)\r\n	at java.util.zip.ZipFile$ZipFileInflaterInputStream.fill(ZipFile.java:434)\r\n	at java.util.zip.InflaterInputStream.read(InflaterInputStream.java:158)\r\n	at sun.misc.Resource.getBytes(Resource.java:124)\r\n	at java.net.URLClassLoader.defineClass(URLClassLoader.java:462)\r\n	at java.net.URLClassLoader.access$100(URLClassLoader.java:73)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:368)\r\n	... 137 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 12:04:33');
INSERT INTO `exception_log` VALUES (778, 'd8857c5b-8947-42b1-94fb-226a09ed3663', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=17602176892&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:04:38', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$bc510cd0.authenticationByMobileCode(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper8.invokeMethod(Wrapper8.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy130.authenticationByMobileCode(Unknown Source)\r\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:45)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 61 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 12:04:38');
INSERT INTO `exception_log` VALUES (779, '79b93d33-e345-422d-88bf-66c73762e77f', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18777777777&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:05:31', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$bc510cd0.authenticationByMobileCode(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper8.invokeMethod(Wrapper8.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy130.authenticationByMobileCode(Unknown Source)\r\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:45)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 61 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 12:05:31');
INSERT INTO `exception_log` VALUES (780, '7f364b5c-60e9-465b-9c5b-f60bbec0b7dc', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:05:43', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.10.64:20882] (1/7) from the registry 192.168.10.67:2181 on the consumer 192.168.10.64 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://192.168.10.64:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuPage,getProductSpuDetailListForSync,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=10660&qos.enable=false&register=true&register.ip=192.168.10.64&release=2.7.1&remote.application=product-service&remote.timestamp=1566438479224&revision=1.0.0&side=consumer&sticky=false&timestamp=1566446526358&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-22 12:05:41.766, end time: 2019-08-22 12:05:42.768, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=17, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882', 'TimeoutException: Waiting server-side response timeout. start time: 2019-08-22 12:05:41.766, end time: 2019-08-22 12:05:42.768, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=17, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.10.64:20882] (1/7) from the registry 192.168.10.67:2181 on the consumer 192.168.10.64 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://192.168.10.64:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuPage,getProductSpuDetailListForSync,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=10660&qos.enable=false&register=true&register.ip=192.168.10.64&release=2.7.1&remote.application=product-service&remote.timestamp=1566438479224&revision=1.0.0&side=consumer&sticky=false&timestamp=1566446526358&validation=true&version=1.0.0, cause: Waiting server-side response timeout. start time: 2019-08-22 12:05:41.766, end time: 2019-08-22 12:05:42.768, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=17, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882\r\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\r\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\r\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy0.getProductSpuList(proxy0.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy141.getProductSpuList(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:43)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout. start time: 2019-08-22 12:05:41.766, end time: 2019-08-22 12:05:42.768, client elapsed: 1 ms, server elapsed: 1000 ms, timeout: 1000 ms, request: Request [id=17, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882\r\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:188)\r\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\r\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\r\n	... 86 more\r\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-22 12:05:43');
INSERT INTO `exception_log` VALUES (781, '47bb9afa-948c-4ea4-8625-6860f1391e52', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:05:43', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.10.64:20882] (1/7) from the registry 192.168.10.67:2181 on the consumer 192.168.10.64 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://192.168.10.64:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuPage,getProductSpuDetailListForSync,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=10660&qos.enable=false&register=true&register.ip=192.168.10.64&release=2.7.1&remote.application=product-service&remote.timestamp=1566441188671&revision=1.0.0&side=consumer&sticky=false&timestamp=1566446526358&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-08-22 12:05:41.822, end time: 2019-08-22 12:05:42.829, client elapsed: 0 ms, server elapsed: 1007 ms, timeout: 1000 ms, request: Request [id=19, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-08-22 12:05:41.822, end time: 2019-08-22 12:05:42.829, client elapsed: 0 ms, server elapsed: 1007 ms, timeout: 1000 ms, request: Request [id=19, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.10.64:20882] (1/7) from the registry 192.168.10.67:2181 on the consumer 192.168.10.64 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://192.168.10.64:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuPage,getProductSpuDetailListForSync,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=10660&qos.enable=false&register=true&register.ip=192.168.10.64&release=2.7.1&remote.application=product-service&remote.timestamp=1566441188671&revision=1.0.0&side=consumer&sticky=false&timestamp=1566446526358&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-08-22 12:05:41.822, end time: 2019-08-22 12:05:42.829, client elapsed: 0 ms, server elapsed: 1007 ms, timeout: 1000 ms, request: Request [id=19, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882\r\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\r\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\r\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy0.getProductSpuList(proxy0.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy141.getProductSpuList(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:43)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-08-22 12:05:41.822, end time: 2019-08-22 12:05:42.829, client elapsed: 0 ms, server elapsed: 1007 ms, timeout: 1000 ms, request: Request [id=19, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882\r\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\r\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\r\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\r\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\r\n	... 86 more\r\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-22 12:05:43');
INSERT INTO `exception_log` VALUES (782, 'a9525280-d042-44ad-8fe5-520d175fc856', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:05:43', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.10.64:20882] (1/7) from the registry 192.168.10.67:2181 on the consumer 192.168.10.64 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://192.168.10.64:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuPage,getProductSpuDetailListForSync,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=10660&qos.enable=false&register=true&register.ip=192.168.10.64&release=2.7.1&remote.application=product-service&remote.timestamp=1566399976497&revision=1.0.0&side=consumer&sticky=false&timestamp=1566446526358&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-08-22 12:05:41.784, end time: 2019-08-22 12:05:42.799, client elapsed: 1 ms, server elapsed: 1014 ms, timeout: 1000 ms, request: Request [id=18, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-08-22 12:05:41.784, end time: 2019-08-22 12:05:42.799, client elapsed: 1 ms, server elapsed: 1014 ms, timeout: 1000 ms, request: Request [id=18, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.10.64:20882] (1/7) from the registry 192.168.10.67:2181 on the consumer 192.168.10.64 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://192.168.10.64:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuPage,getProductSpuDetailListForSync,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=10660&qos.enable=false&register=true&register.ip=192.168.10.64&release=2.7.1&remote.application=product-service&remote.timestamp=1566399976497&revision=1.0.0&side=consumer&sticky=false&timestamp=1566446526358&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-08-22 12:05:41.784, end time: 2019-08-22 12:05:42.799, client elapsed: 1 ms, server elapsed: 1014 ms, timeout: 1000 ms, request: Request [id=18, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882\r\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\r\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\r\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy0.getProductSpuList(proxy0.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy141.getProductSpuList(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:43)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-08-22 12:05:41.784, end time: 2019-08-22 12:05:42.799, client elapsed: 1 ms, server elapsed: 1014 ms, timeout: 1000 ms, request: Request [id=18, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882\r\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\r\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\r\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\r\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\r\n	... 86 more\r\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-22 12:05:43');
INSERT INTO `exception_log` VALUES (783, 'bc85eba2-eea2-4868-ae50-697c3ba460df', 0, 1, 'promotion-application', '/promotion-api/users/product_recommend/list', '', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:05:43', 'org.apache.dubbo.rpc.RpcException', 'RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.10.64:20882] (1/7) from the registry 192.168.10.67:2181 on the consumer 192.168.10.64 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://192.168.10.64:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuPage,getProductSpuDetailListForSync,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=10660&qos.enable=false&register=true&register.ip=192.168.10.64&release=2.7.1&remote.application=product-service&remote.timestamp=1566399976497&revision=1.0.0&side=consumer&sticky=false&timestamp=1566446526358&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-08-22 12:05:41.714, end time: 2019-08-22 12:05:42.739, client elapsed: 0 ms, server elapsed: 1025 ms, timeout: 1000 ms, request: Request [id=16, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882', 'TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-08-22 12:05:41.714, end time: 2019-08-22 12:05:42.739, client elapsed: 0 ms, server elapsed: 1025 ms, timeout: 1000 ms, request: Request [id=16, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882', 'org.apache.dubbo.rpc.RpcException: Failed to invoke the method getProductSpuList in the service cn.iocoder.mall.product.api.ProductSpuService. Tried 3 times of the providers [192.168.10.64:20882] (1/7) from the registry 192.168.10.67:2181 on the consumer 192.168.10.64 using the dubbo version 2.7.1. Last error is: Invoke remote method timeout. method: getProductSpuList, provider: dubbo://192.168.10.64:20882/cn.iocoder.mall.product.api.ProductSpuService?anyhost=true&application=promotion-service&bean.name=providers:dubbo:cn.iocoder.mall.product.api.ProductSpuService:1.0.0&check=false&default.deprecated=false&default.dynamic=false&default.lazy=false&default.register=true&default.service.filter=-exception&default.sticky=false&deprecated=false&dubbo=2.0.2&dynamic=false&generic=false&interface=cn.iocoder.mall.product.api.ProductSpuService&lazy=false&methods=getProductSkuDetailList,getProductSpuPage,getProductSpuDetailListForSync,getProductSpuSearchList,getProductSpuList,addProductSpu,updateProductSpuSort,getProductSku,updateProductSpu,getProductSpuDetail&pid=10660&qos.enable=false&register=true&register.ip=192.168.10.64&release=2.7.1&remote.application=product-service&remote.timestamp=1566399976497&revision=1.0.0&side=consumer&sticky=false&timestamp=1566446526358&validation=true&version=1.0.0, cause: Waiting server-side response timeout by scan timer. start time: 2019-08-22 12:05:41.714, end time: 2019-08-22 12:05:42.739, client elapsed: 0 ms, server elapsed: 1025 ms, timeout: 1000 ms, request: Request [id=16, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882\r\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:111)\r\n	at org.apache.dubbo.rpc.cluster.support.AbstractClusterInvoker.invoke(AbstractClusterInvoker.java:242)\r\n	at org.apache.dubbo.rpc.cluster.support.wrapper.MockClusterInvoker.invoke(MockClusterInvoker.java:76)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy0.getProductSpuList(proxy0.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy141.getProductSpuList(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersProductRecommendController.list(UsersProductRecommendController.java:43)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: org.apache.dubbo.remoting.TimeoutException: Waiting server-side response timeout by scan timer. start time: 2019-08-22 12:05:41.714, end time: 2019-08-22 12:05:42.739, client elapsed: 0 ms, server elapsed: 1025 ms, timeout: 1000 ms, request: Request [id=16, version=2.0.2, twoway=true, event=false, broken=false, data=RpcInvocation [methodName=getProductSpuList, parameterTypes=[interface java.util.Collection], arguments=[[33, 34, 35, 36, 41, 28]], attachments={path=cn.iocoder.mall.product.api.ProductSpuService, interface=cn.iocoder.mall.product.api.ProductSpuService, version=1.0.0}]], channel: /192.168.10.64:59696 -> /192.168.10.64:20882\r\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.returnFromResponse(DefaultFuture.java:295)\r\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:191)\r\n	at org.apache.dubbo.remoting.exchange.support.DefaultFuture.get(DefaultFuture.java:164)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.DubboInvoker.doInvoke(DubboInvoker.java:108)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.InvokerWrapper.invoke(InvokerWrapper.java:56)\r\n	at org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker.doInvoke(FailoverClusterInvoker.java:80)\r\n	... 86 more\r\n', 'org.apache.dubbo.rpc.cluster.support.FailoverClusterInvoker', 'FailoverClusterInvoker.java', 'doInvoke', 111, '2019-08-22 12:05:43');
INSERT INTO `exception_log` VALUES (784, '413ad66b-e140-4f7a-bc4c-d4ca1f0cbc02', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=15579872216&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:07:23', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$bc510cd0.authenticationByMobileCode(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper8.invokeMethod(Wrapper8.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy130.authenticationByMobileCode(Unknown Source)\r\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:45)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 61 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 12:07:23');
INSERT INTO `exception_log` VALUES (785, '2bd47e00-2785-48d1-91ce-a9741a5bb4c2', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18777777777&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:20:33', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$bc510cd0.authenticationByMobileCode(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper8.invokeMethod(Wrapper8.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy130.authenticationByMobileCode(Unknown Source)\r\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:45)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 61 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 12:20:33');
INSERT INTO `exception_log` VALUES (786, 'd16fbbea-dcf1-4a36-a604-0ed646b82998', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18777777777&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:20:45', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$bc510cd0.authenticationByMobileCode(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper8.invokeMethod(Wrapper8.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy130.authenticationByMobileCode(Unknown Source)\r\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:45)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 61 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 12:20:45');
INSERT INTO `exception_log` VALUES (787, '6cf34346-12e1-42a3-8571-f083e074feb5', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18777777777&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:22:04', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$bc510cd0.authenticationByMobileCode(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper8.invokeMethod(Wrapper8.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy130.authenticationByMobileCode(Unknown Source)\r\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:45)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 61 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 12:22:04');
INSERT INTO `exception_log` VALUES (788, '6cfa321b-beb0-409e-9195-353b78b0cd03', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18777777777&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:22:46', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$bc510cd0.authenticationByMobileCode(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper8.invokeMethod(Wrapper8.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy130.authenticationByMobileCode(Unknown Source)\r\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:45)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 61 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 12:22:46');
INSERT INTO `exception_log` VALUES (789, '6c60764e-d9f5-4555-a9df-60ac197ece0f', 0, 1, 'user-application', '/user-api/users/passport/mobile/register', 'mobile=18777777777&code=9999', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-22 12:23:22', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.user.biz.service.UserServiceImpl$$EnhancerBySpringCGLIB$$bc510cd0.authenticationByMobileCode(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper8.invokeMethod(Wrapper8.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy3.authenticationByMobileCode(proxy3.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy130.authenticationByMobileCode(Unknown Source)\r\n	at cn.iocoder.mall.user.application.controller.users.PassportController.mobileRegister(PassportController.java:45)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 61 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 12:23:22');
INSERT INTO `exception_log` VALUES (790, '818d9349-9fcf-4267-accb-2789a8409f7d', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:30:44', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport', 'ZipException: invalid LOC header (bad signature)', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport\r\n	at java.lang.ClassLoader.defineClass1(Native Method)\r\n	at java.lang.ClassLoader.defineClass(ClassLoader.java:763)\r\n	at java.security.SecureClassLoader.defineClass(SecureClassLoader.java:142)\r\n	at java.net.URLClassLoader.defineClass(URLClassLoader.java:467)\r\n	at java.net.URLClassLoader.access$100(URLClassLoader.java:73)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:368)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:362)\r\n	at java.security.AccessController.doPrivileged(Native Method)\r\n	at java.net.URLClassLoader.findClass(URLClassLoader.java:361)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:424)\r\n	at sun.misc.Launcher$AppClassLoader.loadClass(Launcher.java:338)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:357)\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$8ac6c0d.createToken(<generated>)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:67)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$9e7a9f71.authentication(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy1.authentication(proxy1.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy151.authentication(Unknown Source)\r\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:41)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 64 more\r\nCaused by: java.lang.ClassNotFoundException: org.springframework.jdbc.datasource.JdbcTransactionObjectSupport\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:370)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:362)\r\n	at java.security.AccessController.doPrivileged(Native Method)\r\n	at java.net.URLClassLoader.findClass(URLClassLoader.java:361)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:424)\r\n	at sun.misc.Launcher$AppClassLoader.loadClass(Launcher.java:338)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:357)\r\n	... 139 more\r\nCaused by: java.util.zip.ZipException: invalid LOC header (bad signature)\r\n	at java.util.zip.ZipFile.read(Native Method)\r\n	at java.util.zip.ZipFile.access$1400(ZipFile.java:60)\r\n	at java.util.zip.ZipFile$ZipFileInputStream.read(ZipFile.java:734)\r\n	at java.util.zip.ZipFile$ZipFileInflaterInputStream.fill(ZipFile.java:434)\r\n	at java.util.zip.InflaterInputStream.read(InflaterInputStream.java:158)\r\n	at sun.misc.Resource.getBytes(Resource.java:124)\r\n	at java.net.URLClassLoader.defineClass(URLClassLoader.java:462)\r\n	at java.net.URLClassLoader.access$100(URLClassLoader.java:73)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:368)\r\n	... 145 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 14:30:44');
INSERT INTO `exception_log` VALUES (791, '8079184c-cb9d-497a-abd4-a111d0e212cb', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:33:21', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$8ac6c0d.createToken(<generated>)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:67)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$9e7a9f71.authentication(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy1.authentication(proxy1.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy151.authentication(Unknown Source)\r\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:41)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 64 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 14:33:21');
INSERT INTO `exception_log` VALUES (792, '93673a44-b5d5-4cbf-909b-1fc27f4001f5', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 14:33:49', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$8ac6c0d.createToken(<generated>)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:67)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$9e7a9f71.authentication(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy1.authentication(proxy1.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy151.authentication(Unknown Source)\r\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:41)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 64 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 14:33:49');
INSERT INTO `exception_log` VALUES (793, 'a122de4d-deb7-4c0c-a283-374986ba2e99', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 15:42:54', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport', 'ZipException: invalid LOC header (bad signature)', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport\r\n	at java.lang.ClassLoader.defineClass1(Native Method)\r\n	at java.lang.ClassLoader.defineClass(ClassLoader.java:763)\r\n	at java.security.SecureClassLoader.defineClass(SecureClassLoader.java:142)\r\n	at java.net.URLClassLoader.defineClass(URLClassLoader.java:467)\r\n	at java.net.URLClassLoader.access$100(URLClassLoader.java:73)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:368)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:362)\r\n	at java.security.AccessController.doPrivileged(Native Method)\r\n	at java.net.URLClassLoader.findClass(URLClassLoader.java:361)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:424)\r\n	at sun.misc.Launcher$AppClassLoader.loadClass(Launcher.java:338)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:357)\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$54c9a3a.createToken(<generated>)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:67)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$9b1acd9e.authentication(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy0.authentication(proxy0.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy151.authentication(Unknown Source)\r\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:41)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 64 more\r\nCaused by: java.lang.ClassNotFoundException: org.springframework.jdbc.datasource.JdbcTransactionObjectSupport\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:370)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:362)\r\n	at java.security.AccessController.doPrivileged(Native Method)\r\n	at java.net.URLClassLoader.findClass(URLClassLoader.java:361)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:424)\r\n	at sun.misc.Launcher$AppClassLoader.loadClass(Launcher.java:338)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:357)\r\n	... 139 more\r\nCaused by: java.util.zip.ZipException: invalid LOC header (bad signature)\r\n	at java.util.zip.ZipFile.read(Native Method)\r\n	at java.util.zip.ZipFile.access$1400(ZipFile.java:60)\r\n	at java.util.zip.ZipFile$ZipFileInputStream.read(ZipFile.java:734)\r\n	at java.util.zip.ZipFile$ZipFileInflaterInputStream.fill(ZipFile.java:434)\r\n	at java.util.zip.InflaterInputStream.read(InflaterInputStream.java:158)\r\n	at sun.misc.Resource.getBytes(Resource.java:124)\r\n	at java.net.URLClassLoader.defineClass(URLClassLoader.java:462)\r\n	at java.net.URLClassLoader.access$100(URLClassLoader.java:73)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:368)\r\n	... 145 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 15:42:54');
INSERT INTO `exception_log` VALUES (794, '55055a16-3400-4000-a296-7e7ef4276fb1', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 15:47:14', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$54c9a3a.createToken(<generated>)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:67)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$9b1acd9e.authentication(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy0.authentication(proxy0.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy151.authentication(Unknown Source)\r\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:41)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 64 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 15:47:14');
INSERT INTO `exception_log` VALUES (795, '48bc1bb9-a2db-426e-a510-d2897014694d', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 15:53:35', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport', 'ZipException: invalid LOC header (bad signature)', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport\r\n	at java.lang.ClassLoader.defineClass1(Native Method)\r\n	at java.lang.ClassLoader.defineClass(ClassLoader.java:763)\r\n	at java.security.SecureClassLoader.defineClass(SecureClassLoader.java:142)\r\n	at java.net.URLClassLoader.defineClass(URLClassLoader.java:467)\r\n	at java.net.URLClassLoader.access$100(URLClassLoader.java:73)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:368)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:362)\r\n	at java.security.AccessController.doPrivileged(Native Method)\r\n	at java.net.URLClassLoader.findClass(URLClassLoader.java:361)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:424)\r\n	at sun.misc.Launcher$AppClassLoader.loadClass(Launcher.java:338)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:357)\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$b7b65df1.createToken(<generated>)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:67)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$4d849155.authentication(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy0.authentication(proxy0.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy151.authentication(Unknown Source)\r\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:41)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 64 more\r\nCaused by: java.lang.ClassNotFoundException: org.springframework.jdbc.datasource.JdbcTransactionObjectSupport\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:370)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:362)\r\n	at java.security.AccessController.doPrivileged(Native Method)\r\n	at java.net.URLClassLoader.findClass(URLClassLoader.java:361)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:424)\r\n	at sun.misc.Launcher$AppClassLoader.loadClass(Launcher.java:338)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:357)\r\n	... 139 more\r\nCaused by: java.util.zip.ZipException: invalid LOC header (bad signature)\r\n	at java.util.zip.ZipFile.read(Native Method)\r\n	at java.util.zip.ZipFile.access$1400(ZipFile.java:60)\r\n	at java.util.zip.ZipFile$ZipFileInputStream.read(ZipFile.java:734)\r\n	at java.util.zip.ZipFile$ZipFileInflaterInputStream.fill(ZipFile.java:434)\r\n	at java.util.zip.InflaterInputStream.read(InflaterInputStream.java:158)\r\n	at sun.misc.Resource.getBytes(Resource.java:124)\r\n	at java.net.URLClassLoader.defineClass(URLClassLoader.java:462)\r\n	at java.net.URLClassLoader.access$100(URLClassLoader.java:73)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:368)\r\n	... 145 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 15:53:35');
INSERT INTO `exception_log` VALUES (796, '8410ab6a-9e84-4ea8-9d15-703b0e35522d', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 15:55:02', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$b7b65df1.createToken(<generated>)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:67)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$4d849155.authentication(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy0.authentication(proxy0.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy151.authentication(Unknown Source)\r\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:41)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 64 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 15:55:02');
INSERT INTO `exception_log` VALUES (797, '346e6d51-6f59-4b63-8761-8447cdef57f0', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 16:03:53', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/DataSourceTransactionManager$DataSourceTransactionObject\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$b7b65df1.createToken(<generated>)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:67)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$4d849155.authentication(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy0.authentication(proxy0.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy151.authentication(Unknown Source)\r\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:41)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 64 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 16:03:53');
INSERT INTO `exception_log` VALUES (798, '4b735919-6862-4dd3-b669-2bbfe4cb77ca', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64; Trident/7.0; rv:11.0) like Gecko', '127.0.0.1', '2019-08-22 18:00:13', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport', 'ZipException: invalid LOC header (bad signature)', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport\r\n	at java.lang.ClassLoader.defineClass1(Native Method)\r\n	at java.lang.ClassLoader.defineClass(ClassLoader.java:763)\r\n	at java.security.SecureClassLoader.defineClass(SecureClassLoader.java:142)\r\n	at java.net.URLClassLoader.defineClass(URLClassLoader.java:467)\r\n	at java.net.URLClassLoader.access$100(URLClassLoader.java:73)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:368)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:362)\r\n	at java.security.AccessController.doPrivileged(Native Method)\r\n	at java.net.URLClassLoader.findClass(URLClassLoader.java:361)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:424)\r\n	at sun.misc.Launcher$AppClassLoader.loadClass(Launcher.java:338)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:357)\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$840f5f5a.createToken(<generated>)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:67)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$19dd92be.authentication(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy0.authentication(proxy0.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy151.authentication(Unknown Source)\r\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:41)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 64 more\r\nCaused by: java.lang.ClassNotFoundException: org.springframework.jdbc.datasource.JdbcTransactionObjectSupport\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:370)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:362)\r\n	at java.security.AccessController.doPrivileged(Native Method)\r\n	at java.net.URLClassLoader.findClass(URLClassLoader.java:361)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:424)\r\n	at sun.misc.Launcher$AppClassLoader.loadClass(Launcher.java:338)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:357)\r\n	... 139 more\r\nCaused by: java.util.zip.ZipException: invalid LOC header (bad signature)\r\n	at java.util.zip.ZipFile.read(Native Method)\r\n	at java.util.zip.ZipFile.access$1400(ZipFile.java:60)\r\n	at java.util.zip.ZipFile$ZipFileInputStream.read(ZipFile.java:734)\r\n	at java.util.zip.ZipFile$ZipFileInflaterInputStream.fill(ZipFile.java:434)\r\n	at java.util.zip.InflaterInputStream.read(InflaterInputStream.java:158)\r\n	at sun.misc.Resource.getBytes(Resource.java:124)\r\n	at java.net.URLClassLoader.defineClass(URLClassLoader.java:462)\r\n	at java.net.URLClassLoader.access$100(URLClassLoader.java:73)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:368)\r\n	... 145 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 18:00:13');
INSERT INTO `exception_log` VALUES (799, '094bb267-e3e4-43e1-ba19-1ad8ce6cb26a', 0, 2, 'admin-application', '/admin-api/admins/passport/login', 'username=admin&password=123456&type=account', 'POST', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36', '127.0.0.1', '2019-08-22 18:10:17', 'org.springframework.web.util.NestedServletException', 'NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport', 'ZipException: invalid LOC header (bad signature)', 'org.springframework.web.util.NestedServletException: Handler dispatch failed; nested exception is java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1053)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: java.lang.NoClassDefFoundError: org/springframework/jdbc/datasource/JdbcTransactionObjectSupport\r\n	at java.lang.ClassLoader.defineClass1(Native Method)\r\n	at java.lang.ClassLoader.defineClass(ClassLoader.java:763)\r\n	at java.security.SecureClassLoader.defineClass(SecureClassLoader.java:142)\r\n	at java.net.URLClassLoader.defineClass(URLClassLoader.java:467)\r\n	at java.net.URLClassLoader.access$100(URLClassLoader.java:73)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:368)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:362)\r\n	at java.security.AccessController.doPrivileged(Native Method)\r\n	at java.net.URLClassLoader.findClass(URLClassLoader.java:361)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:424)\r\n	at sun.misc.Launcher$AppClassLoader.loadClass(Launcher.java:338)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:357)\r\n	at org.springframework.jdbc.datasource.DataSourceTransactionManager.doGetTransaction(DataSourceTransactionManager.java:237)\r\n	at org.springframework.transaction.support.AbstractPlatformTransactionManager.getTransaction(AbstractPlatformTransactionManager.java:342)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.createTransactionIfNecessary(TransactionAspectSupport.java:474)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:289)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.admin.service.OAuth2ServiceImpl$$EnhancerBySpringCGLIB$$f0d1d7a1.createToken(<generated>)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl.authentication(AdminServiceImpl.java:67)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$FastClassBySpringCGLIB$$c4569606.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\r\n	at cn.iocoder.mall.admin.service.AdminServiceImpl$$EnhancerBySpringCGLIB$$86a00b05.authentication(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper0.invokeMethod(Wrapper0.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy0.authentication(proxy0.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy151.authentication(Unknown Source)\r\n	at cn.iocoder.mall.admin.application.controller.admins.PassportController.login(PassportController.java:41)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	... 64 more\r\nCaused by: java.lang.ClassNotFoundException: org.springframework.jdbc.datasource.JdbcTransactionObjectSupport\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:370)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:362)\r\n	at java.security.AccessController.doPrivileged(Native Method)\r\n	at java.net.URLClassLoader.findClass(URLClassLoader.java:361)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:424)\r\n	at sun.misc.Launcher$AppClassLoader.loadClass(Launcher.java:338)\r\n	at java.lang.ClassLoader.loadClass(ClassLoader.java:357)\r\n	... 139 more\r\nCaused by: java.util.zip.ZipException: invalid LOC header (bad signature)\r\n	at java.util.zip.ZipFile.read(Native Method)\r\n	at java.util.zip.ZipFile.access$1400(ZipFile.java:60)\r\n	at java.util.zip.ZipFile$ZipFileInputStream.read(ZipFile.java:734)\r\n	at java.util.zip.ZipFile$ZipFileInflaterInputStream.fill(ZipFile.java:434)\r\n	at java.util.zip.InflaterInputStream.read(InflaterInputStream.java:158)\r\n	at sun.misc.Resource.getBytes(Resource.java:124)\r\n	at java.net.URLClassLoader.defineClass(URLClassLoader.java:462)\r\n	at java.net.URLClassLoader.access$100(URLClassLoader.java:73)\r\n	at java.net.URLClassLoader$1.run(URLClassLoader.java:368)\r\n	... 145 more\r\n', 'org.springframework.web.servlet.DispatcherServlet', 'DispatcherServlet.java', 'doDispatch', 1053, '2019-08-22 18:10:17');
INSERT INTO `exception_log` VALUES (800, '64d0ea6b-5a64-4816-b0a8-24d1452aeb82', 0, 1, 'search-application', '/search-api/users/product/page', 'cid=637&pageNo=1&pageSize=10', 'GET', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:23:48', 'org.elasticsearch.action.search.SearchPhaseExecutionException', 'SearchPhaseExecutionException: all shards failed', 'QueryShardException: No mapping found for [sort] in order to sort on', 'Failed to execute phase [query], all shards failed; shardFailures {[Zm4jbjlDRruYNMpBFSr3SQ][product][0]: RemoteTransportException[[es-node2][172.23.0.5:9302][indices:data/read/search[phase/query]]]; nested: QueryShardException[No mapping found for [sort] in order to sort on]; }\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.onPhaseFailure(AbstractSearchAsyncAction.java:293)\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.executeNextPhase(AbstractSearchAsyncAction.java:133)\r\n	at org.elasticsearch.action.search.AbstractSearchAsyncAction.onPhaseDone(AbstractSearchAsyncAction.java:254)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.onShardFailure(InitialSearchPhase.java:101)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.access$100(InitialSearchPhase.java:48)\r\n	at org.elasticsearch.action.search.InitialSearchPhase$2.lambda$onFailure$1(InitialSearchPhase.java:222)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.maybeFork(InitialSearchPhase.java:176)\r\n	at org.elasticsearch.action.search.InitialSearchPhase.access$000(InitialSearchPhase.java:48)\r\n	at org.elasticsearch.action.search.InitialSearchPhase$2.onFailure(InitialSearchPhase.java:222)\r\n	at org.elasticsearch.action.search.SearchExecutionStatsCollector.onFailure(SearchExecutionStatsCollector.java:73)\r\n	at org.elasticsearch.action.ActionListenerResponseHandler.handleException(ActionListenerResponseHandler.java:51)\r\n	at org.elasticsearch.action.search.SearchTransportService$ConnectionCountingHandler.handleException(SearchTransportService.java:464)\r\n	at org.elasticsearch.transport.TransportService$ContextRestoreResponseHandler.handleException(TransportService.java:1130)\r\n	at org.elasticsearch.transport.TcpTransport.lambda$handleException$32(TcpTransport.java:1268)\r\n	at org.elasticsearch.common.util.concurrent.EsExecutors$1.execute(EsExecutors.java:135)\r\n	at org.elasticsearch.transport.TcpTransport.handleException(TcpTransport.java:1266)\r\n	at org.elasticsearch.transport.TcpTransport.handlerResponseError(TcpTransport.java:1258)\r\n	at org.elasticsearch.transport.TcpTransport.messageReceived(TcpTransport.java:1188)\r\n	at org.elasticsearch.transport.netty4.Netty4MessageChannelHandler.channelRead(Netty4MessageChannelHandler.java:65)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.fireChannelRead(ByteToMessageDecoder.java:323)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.fireChannelRead(ByteToMessageDecoder.java:310)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.callDecode(ByteToMessageDecoder.java:426)\r\n	at io.netty.handler.codec.ByteToMessageDecoder.channelRead(ByteToMessageDecoder.java:278)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.handler.logging.LoggingHandler.channelRead(LoggingHandler.java:241)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.AbstractChannelHandlerContext.fireChannelRead(AbstractChannelHandlerContext.java:340)\r\n	at io.netty.channel.DefaultChannelPipeline$HeadContext.channelRead(DefaultChannelPipeline.java:1434)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:362)\r\n	at io.netty.channel.AbstractChannelHandlerContext.invokeChannelRead(AbstractChannelHandlerContext.java:348)\r\n	at io.netty.channel.DefaultChannelPipeline.fireChannelRead(DefaultChannelPipeline.java:965)\r\n	at io.netty.channel.nio.AbstractNioByteChannel$NioByteUnsafe.read(AbstractNioByteChannel.java:163)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKey(NioEventLoop.java:644)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKeysPlain(NioEventLoop.java:544)\r\n	at io.netty.channel.nio.NioEventLoop.processSelectedKeys(NioEventLoop.java:498)\r\n	at io.netty.channel.nio.NioEventLoop.run(NioEventLoop.java:458)\r\n	at io.netty.util.concurrent.SingleThreadEventExecutor$5.run(SingleThreadEventExecutor.java:897)\r\n	at java.lang.Thread.run(Thread.java:834)\r\nCaused by: [product/apdpPtb2QuaqCdvhYVdlWg] QueryShardException[No mapping found for [sort] in order to sort on]\r\n	at org.elasticsearch.search.sort.FieldSortBuilder.build(FieldSortBuilder.java:319)\r\n	at org.elasticsearch.search.sort.SortBuilder.buildSort(SortBuilder.java:153)\r\n	at org.elasticsearch.search.SearchService.parseSource(SearchService.java:782)\r\n	at org.elasticsearch.search.SearchService.createContext(SearchService.java:616)\r\n	at org.elasticsearch.search.SearchService.createAndPutContext(SearchService.java:592)\r\n	at org.elasticsearch.search.SearchService.executeQueryPhase(SearchService.java:367)\r\n	at org.elasticsearch.search.SearchService.access$100(SearchService.java:121)\r\n	at org.elasticsearch.search.SearchService$2.onResponse(SearchService.java:339)\r\n	at org.elasticsearch.search.SearchService$2.onResponse(SearchService.java:335)\r\n	at org.elasticsearch.search.SearchService$4.doRun(SearchService.java:1082)\r\n	at org.elasticsearch.common.util.concurrent.ThreadContext$ContextPreservingAbstractRunnable.doRun(ThreadContext.java:723)\r\n	at org.elasticsearch.common.util.concurrent.AbstractRunnable.run(AbstractRunnable.java:37)\r\n	at org.elasticsearch.common.util.concurrent.TimedRunnable.doRun(TimedRunnable.java:41)\r\n	at org.elasticsearch.common.util.concurrent.AbstractRunnable.run(AbstractRunnable.java:37)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1128)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:628)\r\n	... 1 more\r\n', 'org.elasticsearch.action.search.AbstractSearchAsyncAction', 'AbstractSearchAsyncAction.java', 'onPhaseFailure', 293, '2019-08-26 10:23:48');
INSERT INTO `exception_log` VALUES (801, 'eb57f4e6-942d-4e6c-8702-ad01f2ae3cd1', 0, 1, 'promotion-application', '/promotion-api/users/coupon/card/add', 'templateId=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '127.0.0.1', '2019-08-26 10:26:08', 'org.springframework.dao.DataIntegrityViolationException', 'DataIntegrityViolationException: \r\n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLIntegrityConstraintViolationException: Column \'user_id\' cannot be null\r\n### The error may exist in file [D:\\open-source-project\\onemall\\promotion\\promotion-service-impl\\target\\classes\\mapper\\CouponCardMapper.xml]\r\n### The error may involve cn.iocoder.mall.promotion.biz.dao.CouponCardMapper.insert-Inline\r\n### The error occurred while setting parameters\r\n### SQL: INSERT INTO coupon_card (           template_id, title, status, user_id, take_type,           price_available, valid_start_time, valid_end_time, preferential_type, percent_off, price_off,           discount_price_limit, used_time,           create_time         ) VALUES (           ?, ?, ?, ?, ?,           ?, ?, ?, ?, ?, ?,           ?, ?,           ?         )\r\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLIntegrityConstraintViolationException: Column \'user_id\' cannot be null\n; Column \'user_id\' cannot be null; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLIntegrityConstraintViolationException: Column \'user_id\' cannot be null', 'MySQLIntegrityConstraintViolationException: Column \'user_id\' cannot be null', 'org.springframework.dao.DataIntegrityViolationException: \r\n### Error updating database.  Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLIntegrityConstraintViolationException: Column \'user_id\' cannot be null\r\n### The error may exist in file [D:\\open-source-project\\onemall\\promotion\\promotion-service-impl\\target\\classes\\mapper\\CouponCardMapper.xml]\r\n### The error may involve cn.iocoder.mall.promotion.biz.dao.CouponCardMapper.insert-Inline\r\n### The error occurred while setting parameters\r\n### SQL: INSERT INTO coupon_card (           template_id, title, status, user_id, take_type,           price_available, valid_start_time, valid_end_time, preferential_type, percent_off, price_off,           discount_price_limit, used_time,           create_time         ) VALUES (           ?, ?, ?, ?, ?,           ?, ?, ?, ?, ?, ?,           ?, ?,           ?         )\r\n### Cause: com.mysql.jdbc.exceptions.jdbc4.MySQLIntegrityConstraintViolationException: Column \'user_id\' cannot be null\n; Column \'user_id\' cannot be null; nested exception is com.mysql.jdbc.exceptions.jdbc4.MySQLIntegrityConstraintViolationException: Column \'user_id\' cannot be null\r\n	at org.springframework.jdbc.support.SQLExceptionSubclassTranslator.doTranslate(SQLExceptionSubclassTranslator.java:87)\r\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:72)\r\n	at org.springframework.jdbc.support.AbstractFallbackSQLExceptionTranslator.translate(AbstractFallbackSQLExceptionTranslator.java:81)\r\n	at org.mybatis.spring.MyBatisExceptionTranslator.translateExceptionIfPossible(MyBatisExceptionTranslator.java:73)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:446)\r\n	at com.sun.proxy.$Proxy125.insert(Unknown Source)\r\n	at org.mybatis.spring.SqlSessionTemplate.insert(SqlSessionTemplate.java:278)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperMethod.execute(MybatisMapperMethod.java:58)\r\n	at com.baomidou.mybatisplus.core.override.MybatisMapperProxy.invoke(MybatisMapperProxy.java:62)\r\n	at com.sun.proxy.$Proxy133.insert(Unknown Source)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection(AopUtils.java:343)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.invokeJoinpoint(ReflectiveMethodInvocation.java:198)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.dao.support.PersistenceExceptionTranslationInterceptor.invoke(PersistenceExceptionTranslationInterceptor.java:139)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.JdkDynamicAopProxy.invoke(JdkDynamicAopProxy.java:212)\r\n	at com.sun.proxy.$Proxy134.insert(Unknown Source)\r\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl.addCouponCard(CouponServiceImpl.java:229)\r\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl$$FastClassBySpringCGLIB$$4c1d1cc8.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\r\n	at org.springframework.aop.framework.CglibAopProxy$CglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:749)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\r\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:186)\r\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:688)\r\n	at cn.iocoder.mall.promotion.biz.service.CouponServiceImpl$$EnhancerBySpringCGLIB$$62636c42.addCouponCard(<generated>)\r\n	at org.apache.dubbo.common.bytecode.Wrapper6.invokeMethod(Wrapper6.java)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\r\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\r\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java:88)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\r\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\r\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\r\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\r\n	at org.apache.dubbo.common.bytecode.proxy6.addCouponCard(proxy6.java)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy135.addCouponCard(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersCouponController.cardAdd(UsersCouponController.java:64)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:665)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: com.mysql.jdbc.exceptions.jdbc4.MySQLIntegrityConstraintViolationException: Column \'user_id\' cannot be null\r\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\r\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\r\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\r\n	at com.mysql.jdbc.Util.handleNewInstance(Util.java:425)\r\n	at com.mysql.jdbc.Util.getInstance(Util.java:408)\r\n	at com.mysql.jdbc.SQLError.createSQLException(SQLError.java:936)\r\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3976)\r\n	at com.mysql.jdbc.MysqlIO.checkErrorPacket(MysqlIO.java:3912)\r\n	at com.mysql.jdbc.MysqlIO.sendCommand(MysqlIO.java:2530)\r\n	at com.mysql.jdbc.MysqlIO.sqlQueryDirect(MysqlIO.java:2683)\r\n	at com.mysql.jdbc.ConnectionImpl.execSQL(ConnectionImpl.java:2486)\r\n	at com.mysql.jdbc.PreparedStatement.executeInternal(PreparedStatement.java:1858)\r\n	at com.mysql.jdbc.PreparedStatement.execute(PreparedStatement.java:1197)\r\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.execute(DruidPooledPreparedStatement.java:497)\r\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:68)\r\n	at io.seata.rm.datasource.PreparedStatementProxy$1.execute(PreparedStatementProxy.java:65)\r\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:69)\r\n	at io.seata.rm.datasource.exec.ExecuteTemplate.execute(ExecuteTemplate.java:47)\r\n	at io.seata.rm.datasource.PreparedStatementProxy.execute(PreparedStatementProxy.java:65)\r\n	at org.apache.ibatis.executor.statement.PreparedStatementHandler.update(PreparedStatementHandler.java:47)\r\n	at org.apache.ibatis.executor.statement.RoutingStatementHandler.update(RoutingStatementHandler.java:74)\r\n	at com.baomidou.mybatisplus.core.executor.MybatisSimpleExecutor.doUpdate(MybatisSimpleExecutor.java:54)\r\n	at org.apache.ibatis.executor.BaseExecutor.update(BaseExecutor.java:117)\r\n	at org.apache.ibatis.executor.CachingExecutor.update(CachingExecutor.java:76)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.update(DefaultSqlSession.java:197)\r\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.insert(DefaultSqlSession.java:184)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.mybatis.spring.SqlSessionTemplate$SqlSessionInterceptor.invoke(SqlSessionTemplate.java:433)\r\n	... 144 more\r\n', 'org.springframework.jdbc.support.SQLExceptionSubclassTranslator', 'SQLExceptionSubclassTranslator.java', 'doTranslate', 87, '2019-08-26 10:26:08');
INSERT INTO `exception_log` VALUES (802, '3bd304bf-2860-4ec5-850b-3b4502c128ae', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:12:29', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy4', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\r\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\r\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\r\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\r\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\r\n	at com.sun.proxy.$Proxy130.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\r\n	... 90 more\r\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy4\r\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\r\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\r\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\r\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\r\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\r\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\r\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\r\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\r\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\r\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\r\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\r\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\r\n	at javassist.compiler.Javac.compile(Javac.java:95)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\r\n	... 92 more\r\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-08-27 12:12:31');
INSERT INTO `exception_log` VALUES (803, '3bd304bf-2860-4ec5-850b-3b4502c128ae', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:12:29', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy4', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\r\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\r\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\r\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\r\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\r\n	at com.sun.proxy.$Proxy130.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\r\n	... 90 more\r\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy4\r\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\r\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\r\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\r\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\r\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\r\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\r\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\r\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\r\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\r\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\r\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\r\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\r\n	at javassist.compiler.Javac.compile(Javac.java:95)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\r\n	... 92 more\r\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-08-27 12:12:30');
INSERT INTO `exception_log` VALUES (804, '3bd304bf-2860-4ec5-850b-3b4502c128ae', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:12:29', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy4', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\r\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\r\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\r\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\r\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\r\n	at com.sun.proxy.$Proxy130.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy4\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\r\n	... 90 more\r\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy4\r\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\r\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\r\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\r\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\r\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\r\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\r\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\r\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\r\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\r\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\r\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\r\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\r\n	at javassist.compiler.Javac.compile(Javac.java:95)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\r\n	... 92 more\r\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-08-27 12:12:30');
INSERT INTO `exception_log` VALUES (805, '4b74d8f8-a199-4686-a283-658d27bcca4c', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:13:39', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy130.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-08-27 12:13:39');
INSERT INTO `exception_log` VALUES (806, 'cfc0f992-dee5-442d-a1ac-5af06c9f981b', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:14:39', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy130.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-08-27 12:14:39');
INSERT INTO `exception_log` VALUES (807, '1963df96-3afc-42da-b0b0-c2bfe87a92fe', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Safari/537.36', '127.0.0.1', '2019-08-27 12:15:12', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy130.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-08-27 12:15:12');
INSERT INTO `exception_log` VALUES (808, '14af222e-cd8b-40c3-86e4-97ca44fefdcc', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:52:33', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy5', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\r\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\r\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\r\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\r\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\r\n	at com.sun.proxy.$Proxy135.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\r\n	... 90 more\r\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\r\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\r\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\r\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\r\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\r\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\r\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\r\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\r\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\r\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\r\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\r\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\r\n	at javassist.compiler.Javac.compile(Javac.java:95)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\r\n	... 92 more\r\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-08-30 17:52:34');
INSERT INTO `exception_log` VALUES (809, '14af222e-cd8b-40c3-86e4-97ca44fefdcc', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:52:33', 'java.lang.RuntimeException', 'RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5', 'CompileError: no such class: org.apache.dubbo.common.bytecode.proxy5', 'java.lang.RuntimeException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:349)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:288)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:201)\r\n	at org.apache.dubbo.common.bytecode.Proxy.getProxy(Proxy.java:65)\r\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory.getProxy(JavassistProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:66)\r\n	at org.apache.dubbo.rpc.proxy.AbstractProxyFactory.getProxy(AbstractProxyFactory.java:35)\r\n	at org.apache.dubbo.rpc.proxy.wrapper.StubProxyFactoryWrapper.getProxy(StubProxyFactoryWrapper.java:66)\r\n	at org.apache.dubbo.rpc.ProxyFactory$Adaptive.getProxy(ProxyFactory$Adaptive.java)\r\n	at org.apache.dubbo.config.ReferenceConfig.createProxy(ReferenceConfig.java:405)\r\n	at org.apache.dubbo.config.ReferenceConfig.init(ReferenceConfig.java:305)\r\n	at org.apache.dubbo.config.ReferenceConfig.get(ReferenceConfig.java:231)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.init(ReferenceAnnotationBeanPostProcessor.java:176)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:165)\r\n	at com.sun.proxy.$Proxy135.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: javassist.CannotCompileException: [source error] no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:79)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:45)\r\n	at org.apache.dubbo.common.bytecode.ClassGenerator.toClass(ClassGenerator.java:324)\r\n	... 90 more\r\nCaused by: compile error: no such class: org.apache.dubbo.common.bytecode.proxy5\r\n	at javassist.compiler.MemberResolver.searchImports(MemberResolver.java:468)\r\n	at javassist.compiler.MemberResolver.lookupClass(MemberResolver.java:412)\r\n	at javassist.compiler.MemberResolver.lookupClassByName(MemberResolver.java:315)\r\n	at javassist.compiler.TypeChecker.atNewExpr(TypeChecker.java:146)\r\n	at javassist.compiler.ast.NewExpr.accept(NewExpr.java:73)\r\n	at javassist.compiler.CodeGen.doTypeCheck(CodeGen.java:242)\r\n	at javassist.compiler.CodeGen.compileExpr(CodeGen.java:229)\r\n	at javassist.compiler.CodeGen.atReturnStmnt2(CodeGen.java:615)\r\n	at javassist.compiler.JvstCodeGen.atReturnStmnt(JvstCodeGen.java:425)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:363)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atStmnt(CodeGen.java:351)\r\n	at javassist.compiler.ast.Stmnt.accept(Stmnt.java:50)\r\n	at javassist.compiler.CodeGen.atMethodBody(CodeGen.java:292)\r\n	at javassist.compiler.CodeGen.atMethodDecl(CodeGen.java:274)\r\n	at javassist.compiler.ast.MethodDecl.accept(MethodDecl.java:44)\r\n	at javassist.compiler.Javac.compileMethod(Javac.java:169)\r\n	at javassist.compiler.Javac.compile(Javac.java:95)\r\n	at javassist.CtNewMethod.make(CtNewMethod.java:74)\r\n	... 92 more\r\n', 'org.apache.dubbo.common.bytecode.ClassGenerator', 'ClassGenerator.java', 'toClass', 349, '2019-08-30 17:52:34');
INSERT INTO `exception_log` VALUES (810, '7372c389-4620-4cd6-941d-6ef04577ea6f', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:52:52', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy135.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-08-30 17:52:52');
INSERT INTO `exception_log` VALUES (811, '9ec12123-84ec-473a-ba01-0d72e0291899', 0, 1, 'promotion-application', '/promotion-api/users/banner/list', '', 'GET', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/72.0.3616.0 Safari/537.36', '127.0.0.1', '2019-08-30 17:53:04', 'java.lang.NullPointerException', 'NullPointerException: ', 'NullPointerException: ', 'java.lang.NullPointerException\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\r\n	at com.sun.proxy.$Proxy135.getBannerListByStatus(Unknown Source)\r\n	at cn.iocoder.mall.promotion.application.controller.users.UsersBannerController.list(UsersBannerController.java:31)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.lang.reflect.Method.invoke(Method.java:498)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\r\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:897)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:645)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:750)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\r\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\r\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\n', 'sun.reflect.NativeMethodAccessorImpl', 'NativeMethodAccessorImpl.java', 'invoke0', -2, '2019-08-30 17:53:04');
INSERT INTO `exception_log` VALUES (812, '66.50.15676499822353579', 220, 1, 'user-application', '/user-api/users/address/add', 'name=z&tel=18812345678&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=zz&isDefault=true&address=zz&areaNo=110101&mobile=18812345678&hasDefault=2', 'POST', 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/76.0.3809.132 Mobile Safari/537.36', '183.237.67.146', '2019-09-05 10:19:42', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [zz]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [zz]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [zz]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-09-05 10:19:42');
INSERT INTO `exception_log` VALUES (813, '64.76.15676512843166669', 1, 2, 'product-application', '/product-api/admins/spu/add', 'name=金坷垃&sellPoint=农民伯伯都爱它&cid=783&visible=true&picUrls=http://static.shop.iocoder.cn/8fb41fd6-2ace-4e66-870d-28cff91084ae&skuStr=[{\"attrs\":[49,50],\"price\":10000,\"quantity\":100}]&description=<p>金坷拉</p>', 'POST', 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.86 Safari/537.36', '61.131.6.245', '2019-09-05 10:41:25', 'org.springframework.messaging.MessagingException', 'MessagingException: Send [3] times, still failed, cost [16]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [16]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.', 'RemotingConnectException: connect to <192.168.88.14:10909> failed', 'org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [16]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [16]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.addProductSpu(ProductSpuServiceImpl.java:93)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$50114869.addProductSpu(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.addProductSpu(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy150.addProductSpu(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz(AdminsProductSpuController.java:58)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add$original$pMLWVoQz$accessor$3Lvpt4vw(AdminsProductSpuController.java)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController$auxiliary$7LKbfGk3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.add(AdminsProductSpuController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0$accessor$7vT1VInN(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$iFD4aFHO.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [16]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 148 more\nCaused by: org.apache.rocketmq.remoting.exception.RemotingConnectException: connect to <192.168.88.14:10909> failed\n	at org.apache.rocketmq.remoting.netty.NettyRemotingClient.invokeSync(NettyRemotingClient.java:393)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:356)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC$accessor$lQ2PcgrU(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl$auxiliary$Ns31PXYD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 151 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-09-05 10:41:25');
INSERT INTO `exception_log` VALUES (814, '66.51.15676676581483835', 222, 1, 'user-application', '/user-api/users/address/add', 'name=a&tel=19898323232&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=aaa&isDefault=false&address=aaa&areaNo=110101&mobile=19898323232&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:18', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [aaa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [aaa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [aaa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-09-05 15:14:18');
INSERT INTO `exception_log` VALUES (815, '66.49.15676676602823821', 222, 1, 'user-application', '/user-api/users/address/add', 'name=a&tel=19898323232&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=aaa&isDefault=false&address=aaa&areaNo=110101&mobile=19898323232&hasDefault=1', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '49.74.106.33', '2019-09-05 15:14:20', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [aaa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [aaa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [aaa]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-09-05 15:14:20');
INSERT INTO `exception_log` VALUES (816, '66.57.15676750102653917', 223, 1, 'user-application', '/user-api/users/address/add', 'name=刘&tel=15039141227&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=110101&mobile=15039141227&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:16:50', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-09-05 17:16:50');
INSERT INTO `exception_log` VALUES (817, '66.56.15676750239283935', 223, 1, 'user-application', '/user-api/users/address/add', 'name=刘&tel=15039141227&country=&province=北京市&city=北京市&county=东城区&areaCode=110101&postalCode=&addressDetail=1111&isDefault=true&address=1111&areaNo=110101&mobile=15039141227&hasDefault=2', 'POST', 'Mozilla/5.0 (iPhone; CPU iPhone OS 11_0 like Mac OS X) AppleWebKit/604.1.38 (KHTML, like Gecko) Version/11.0 Mobile/15A372 Safari/604.1', '122.224.217.58', '2019-09-05 17:17:04', 'org.springframework.validation.BindException', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]', 'org.springframework.validation.BindException: org.springframework.validation.BeanPropertyBindingResult: 1 errors\nField error in object \'userAddressAddPO\' on field \'address\': rejected value [1111]; codes [Length.userAddressAddPO.address,Length.address,Length.java.lang.String,Length]; arguments [org.springframework.context.support.DefaultMessageSourceResolvable: codes [userAddressAddPO.address,address]; arguments []; default message [address],100,10]; default message [地址在 10 ~ 100 字之间!]\n	at org.springframework.web.method.annotation.ModelAttributeMethodProcessor.resolveArgument(ModelAttributeMethodProcessor.java:164)\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:126)\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:166)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:134)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$jfNWHCH5$accessor$W8pJyiC8(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$eeTiciN3.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n', 'org.springframework.web.method.annotation.ModelAttributeMethodProcessor', 'ModelAttributeMethodProcessor.java', 'resolveArgument', 164, '2019-09-05 17:17:04');
INSERT INTO `exception_log` VALUES (818, '64.85.15677387163477899', 1, 2, 'product-application', '/product-api/admins/spu/update_sort', 'id=32&sort=1', 'POST', 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36', '116.31.81.130', '2019-09-06 10:58:36', 'org.springframework.messaging.MessagingException', 'MessagingException: Send [3] times, still failed, cost [10]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [10]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.', 'RemotingConnectException: connect to <192.168.88.14:10909> failed', 'org.springframework.messaging.MessagingException: Send [3] times, still failed, cost [10]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.; nested exception is org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [10]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:153)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:122)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:110)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:458)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.doSend(RocketMQTemplate.java:49)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.send(AbstractMessageSendingTemplate.java:109)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:151)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:129)\n	at org.springframework.messaging.core.AbstractMessageSendingTemplate.convertAndSend(AbstractMessageSendingTemplate.java:122)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.sendProductUpdateMessage(ProductSpuServiceImpl.java:350)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl.updateProductSpuSort(ProductSpuServiceImpl.java:217)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$FastClassBySpringCGLIB$$259a05ac.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:218)\n	at org.springframework.aop.framework.CglibAopProxy$DynamicAdvisedInterceptor.intercept(CglibAopProxy.java:684)\n	at cn.iocoder.mall.product.service.ProductSpuServiceImpl$$EnhancerBySpringCGLIB$$50114869.updateProductSpuSort(<generated>)\n	at org.apache.dubbo.common.bytecode.Wrapper7.invokeMethod(Wrapper7.java)\n	at org.apache.dubbo.rpc.proxy.javassist.JavassistProxyFactory$1.doInvoke(JavassistProxyFactory.java:47)\n	at org.apache.dubbo.rpc.proxy.AbstractProxyInvoker.invoke(AbstractProxyInvoker.java:86)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.TimeoutFilter.invoke(TimeoutFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.TraceFilter.invoke(TraceFilter.java:80)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ContextFilter.invoke(ContextFilter.java:79)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.GenericFilter.invoke(GenericFilter.java:137)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ClassLoaderFilter.invoke(ClassLoaderFilter.java:38)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.EchoFilter.invoke(EchoFilter.java:39)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.injvm.InjvmInvoker.doInvoke(InjvmInvoker.java:62)\n	at org.apache.dubbo.rpc.protocol.AbstractInvoker.invoke(AbstractInvoker.java:157)\n	at org.apache.dubbo.validation.filter.ValidationFilter.invoke(ValidationFilter.java:93)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at io.seata.integration.dubbo.TransactionPropagationFilter.invoke(TransactionPropagationFilter.java:60)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT(MonitorFilter.java:88)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke$original$1AGxZ0pT$accessor$HSvNHXqE(MonitorFilter.java)\n	at org.apache.dubbo.monitor.support.MonitorFilter$auxiliary$pWy6SzXr.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.dubbo.monitor.support.MonitorFilter.invoke(MonitorFilter.java)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.protocol.dubbo.filter.FutureFilter.invoke(FutureFilter.java:49)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.filter.ConsumerContextFilter.invoke(ConsumerContextFilter.java:54)\n	at org.apache.dubbo.rpc.protocol.ProtocolFilterWrapper$1.invoke(ProtocolFilterWrapper.java:73)\n	at org.apache.dubbo.rpc.listener.ListenerInvokerWrapper.invoke(ListenerInvokerWrapper.java:78)\n	at org.apache.dubbo.rpc.proxy.InvokerInvocationHandler.invoke(InvokerInvocationHandler.java:57)\n	at org.apache.dubbo.common.bytecode.proxy5.updateProductSpuSort(proxy5.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.dubbo.config.spring.beans.factory.annotation.ReferenceAnnotationBeanPostProcessor$ReferenceBeanInvocationHandler.invoke(ReferenceAnnotationBeanPostProcessor.java:167)\n	at com.sun.proxy.$Proxy150.updateProductSpuSort(Unknown Source)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.updateSort$original$pMLWVoQz(AdminsProductSpuController.java:96)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.updateSort$original$pMLWVoQz$accessor$3Lvpt4vw(AdminsProductSpuController.java)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController$auxiliary$vYFlQ2ng.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at cn.iocoder.mall.product.application.controller.admins.AdminsProductSpuController.updateSort(AdminsProductSpuController.java)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:189)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:138)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:895)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:800)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:1038)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:942)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:1005)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:908)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:882)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.SecurityBasicAuthFilter.doFilter(SecurityBasicAuthFilter.java:84)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.github.xiaoymin.swaggerbootstrapui.filter.ProductionSecurityFilter.doFilter(ProductionSecurityFilter.java:53)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at cn.iocoder.common.framework.servlet.CorsFilter.doFilter(CorsFilter.java:33)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.web.trace.servlet.HttpTraceFilter.doFilterInternal(HttpTraceFilter.java:90)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.FormContentFilter.doFilterInternal(FormContentFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:93)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.filterAndRecordMetrics(WebMvcMetricsFilter.java:117)\n	at org.springframework.boot.actuate.metrics.web.servlet.WebMvcMetricsFilter.doFilterInternal(WebMvcMetricsFilter.java:106)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.csp.sentinel.adapter.servlet.CommonFilter.doFilter(CommonFilter.java:89)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:200)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:490)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0(StandardHostValve.java:139)\n	at org.apache.catalina.core.StandardHostValve.invoke$original$OEiZh5q0$accessor$7vT1VInN(StandardHostValve.java)\n	at org.apache.catalina.core.StandardHostValve$auxiliary$iFD4aFHO.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:92)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:74)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:408)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocol$ConnectionHandler.process(AbstractProtocol.java:834)\n	at org.apache.tomcat.util.net.NioEndpoint$SocketProcessor.doRun(NioEndpoint.java:1415)\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutor$Worker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThread$WrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.rocketmq.client.exception.MQClientException: Send [3] times, still failed, cost [10]ms, Topic: ProductUpdate, BrokersSent: [localhost.localdomain, localhost.localdomain, localhost.localdomain]\nSee http://rocketmq.apache.org/docs/faq/ for further details.\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:610)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.send(DefaultMQProducerImpl.java:1253)\n	at org.apache.rocketmq.client.producer.DefaultMQProducer.send(DefaultMQProducer.java:232)\n	at org.apache.rocketmq.spring.core.RocketMQTemplate.syncSend(RocketMQTemplate.java:147)\n	... 148 more\nCaused by: org.apache.rocketmq.remoting.exception.RemotingConnectException: connect to <192.168.88.14:10909> failed\n	at org.apache.rocketmq.remoting.netty.NettyRemotingClient.invokeSync(NettyRemotingClient.java:393)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessageSync(MQClientAPIImpl.java:356)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC(MQClientAPIImpl.java:340)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage$original$xQkSW5LC$accessor$lQ2PcgrU(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl$auxiliary$Ns31PXYD.call(Unknown Source)\n	at org.apache.skywalking.apm.agent.core.plugin.interceptor.enhance.InstMethodsInter.intercept(InstMethodsInter.java:93)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java)\n	at org.apache.rocketmq.client.impl.MQClientAPIImpl.sendMessage(MQClientAPIImpl.java:294)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendKernelImpl(DefaultMQProducerImpl.java:785)\n	at org.apache.rocketmq.client.impl.producer.DefaultMQProducerImpl.sendDefaultImpl(DefaultMQProducerImpl.java:529)\n	... 151 more\n', 'org.apache.rocketmq.spring.core.RocketMQTemplate', 'RocketMQTemplate.java', 'syncSend', 153, '2019-09-06 10:58:36');
COMMIT;

-- ----------------------------
-- Table structure for oauth2_access_token
-- ----------------------------
DROP TABLE IF EXISTS `oauth2_access_token`;
CREATE TABLE `oauth2_access_token` (
  `id` varchar(32) NOT NULL,
  `refresh_token` varchar(32) NOT NULL,
  `user_id` int(11) DEFAULT NULL COMMENT '用户编号',
  `user_type` tinyint(255) DEFAULT NULL COMMENT '用户类型',
  `valid` tinyint(4) DEFAULT NULL,
  `expires_time` datetime NOT NULL,
  `create_time` datetime DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '最后更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Records of oauth2_access_token
-- ----------------------------
BEGIN;
INSERT INTO `oauth2_access_token` VALUES ('00020325371a4c11ab46d48440561d29', '39fdfc40efc942f382e5b85ac2d86261', 27, 2, 1, '2019-08-19 09:54:12', '2019-08-19 09:06:12', '2019-08-19 09:06:12');
INSERT INTO `oauth2_access_token` VALUES ('0005e2b0b8274236a5f784e9af1dbb07', '7b7572bb86d24599bd673fa5659d0148', 27, 2, 1, '2019-09-04 16:02:28', '2019-09-04 15:14:28', '2019-09-04 15:14:28');
INSERT INTO `oauth2_access_token` VALUES ('00102a45e59b4199a67b63cf153c42de', 'cb30cf3e82f84a2a86028780dafb7a4d', 27, 2, 1, '2019-06-14 15:11:48', '2019-06-14 14:23:48', '2019-06-14 14:23:48');
INSERT INTO `oauth2_access_token` VALUES ('001c5c8f2f1c49b89953731095fa8eda', '2465fd896ccf4964ab7062a78e557b4a', 27, 2, 1, '2019-06-05 12:03:14', '2019-06-05 11:15:14', '2019-06-05 11:15:14');
INSERT INTO `oauth2_access_token` VALUES ('001e8f49b20e47f7b3a2de774497cd50', 'e87425dc5fe54111b4450a56ab1c9a63', NULL, NULL, 1, '2019-05-01 22:44:30', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('002be0fb43794281b6526835685ae57a', '88910c775bf94d1b88fb5f5401132085', 27, 2, 1, '2019-06-23 23:19:57', '2019-06-23 22:31:57', '2019-06-23 22:31:57');
INSERT INTO `oauth2_access_token` VALUES ('003cae04aca74b518163aa414d17e7bd', 'c18cc2929fcb4355bb59d8b9aa6041c4', NULL, NULL, 1, '2019-04-22 19:13:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('005b5b9a20a2421aaec689bb60e9e70a', '15040244aaae436fb2003ce73b4ad787', 27, 2, 1, '2019-06-04 18:31:56', '2019-06-04 17:43:56', '2019-06-04 17:43:56');
INSERT INTO `oauth2_access_token` VALUES ('00615fa44c6f409396fca1cd748aa30d', 'f591665c19ff403aa7c20ef958f6ae72', 27, 2, 1, '2019-08-23 18:20:53', '2019-08-23 17:32:53', '2019-08-23 17:32:53');
INSERT INTO `oauth2_access_token` VALUES ('007a764770d046ccb0607503cc9b710d', 'de84ec58a4ff4e68baf9bb9da2fe26bc', NULL, NULL, 1, '2019-04-30 22:53:25', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('00a5bbb3437c47d5b261ab1828f38092', '47e6a3cb16b94e26ac614f85b0e577cd', NULL, NULL, 1, '2019-05-15 16:17:05', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('00c843021e2e4d09bb83213a54ff95c0', '68a38083dd5340d390550cbd2d3ced6e', 27, 2, 1, '2019-07-10 18:46:51', '2019-07-10 17:58:51', '2019-07-10 17:58:51');
INSERT INTO `oauth2_access_token` VALUES ('00d8392bfc9b4e488323be34bdcd4a32', 'b6016745db86453fb508ba6eba7258dc', 27, 2, 1, '2019-07-29 19:00:45', '2019-07-29 18:12:44', '2019-07-29 18:12:44');
INSERT INTO `oauth2_access_token` VALUES ('00f282690ef243619f1fbcfde80b47a0', 'cee9d6363985430899ddaffda32b0772', NULL, NULL, 1, '2019-05-05 10:30:38', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('00f3c79e1c4a45019bed40b8c97d7acc', 'b1b59a4c0f6e493f84205d18f49a1574', 27, 2, 1, '2019-06-04 16:31:40', '2019-06-04 15:43:40', '2019-06-04 15:43:40');
INSERT INTO `oauth2_access_token` VALUES ('00fb5c4dd53941af89ea58b61bef6835', 'd6f7510827f34250bfa7a60a014352fd', 27, 2, 1, '2019-08-15 14:10:04', '2019-08-15 13:22:03', '2019-08-15 13:22:03');
INSERT INTO `oauth2_access_token` VALUES ('010068b2eae042c98ab7d2bffba035c1', 'e15c97c6c0ce4a1ebd852785a44aaa71', 27, 2, 1, '2019-06-24 17:13:28', '2019-06-24 16:25:28', '2019-06-24 16:25:28');
INSERT INTO `oauth2_access_token` VALUES ('0108b93a3b494987b8197a31c922f059', 'bb9c24ae96d9406c85c34adc0583866b', 1, 2, 0, '2019-07-03 11:33:47', '2019-07-03 10:45:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('011237d9b2f246c3ba5b763a72348c04', 'fa453886ac0549b3bdd0cf1fa7718dfe', 1, 2, 0, '2019-09-02 20:58:06', '2019-09-02 20:10:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('01177a092dc448ecbe671d6b04114c40', 'e524c7ea86e7494784884f611bcb8163', 27, 2, 1, '2019-07-08 17:23:14', '2019-07-08 16:35:14', '2019-07-08 16:35:14');
INSERT INTO `oauth2_access_token` VALUES ('0123253a0cee4b158caacd38cb4b8ef6', '26f924e4f31d477a8cdaec45d6921cc8', 27, 2, 1, '2019-06-20 11:36:24', '2019-06-20 10:48:24', '2019-06-20 10:48:24');
INSERT INTO `oauth2_access_token` VALUES ('01299db04e574c77ba0ed05b97de1bda', 'b8d5df0bb9a842268f819da04b88432d', 27, 2, 1, '2019-06-03 10:05:52', '2019-06-03 09:17:51', '2019-06-03 09:17:51');
INSERT INTO `oauth2_access_token` VALUES ('0141c1f31b14428ab437cf5f9a46624d', '74c0f3822492438e862b48c03a159cc7', 1, 2, 0, '2019-05-31 18:53:12', '2019-05-31 18:05:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('014fd5da28f34ad8bdea69e0f0380146', '1a31848b9ed44954976e57d95aa6fdde', 27, 2, 1, '2019-05-28 23:07:49', '2019-05-28 22:19:49', '2019-05-28 22:19:49');
INSERT INTO `oauth2_access_token` VALUES ('016c16203ba54b3db2eb062487cb43a5', 'ddeebe7a27b9474abf1d564b01a974ad', 27, 2, 1, '2019-06-05 16:23:38', '2019-06-05 15:35:38', '2019-06-05 15:35:38');
INSERT INTO `oauth2_access_token` VALUES ('01743f9a886b4236bf1f259cc9b55b71', 'ea076f807fb54ec2943f1cb28ff234c7', 27, 2, 1, '2019-08-07 17:46:52', '2019-08-07 16:58:51', '2019-08-07 16:58:51');
INSERT INTO `oauth2_access_token` VALUES ('0196e97f97624b37bd92557de5a2d2b4', 'fd9d4cf14c3a4463a1a3f4ba989ed3e9', 27, 2, 1, '2019-06-22 21:57:08', '2019-06-22 21:09:08', '2019-06-22 21:09:08');
INSERT INTO `oauth2_access_token` VALUES ('01a083fe69af4b1696276fd3309e051f', '61f0596454fe40b19131231e46733335', 27, 2, 1, '2019-08-20 19:50:45', '2019-08-20 19:02:44', '2019-08-20 19:02:44');
INSERT INTO `oauth2_access_token` VALUES ('01a349a6ab434de98934f1be71d77955', '13cacb59505944a7b00c4a3ecd00822a', 163, 1, 1, '2019-07-09 18:45:59', '2019-07-09 17:57:59', '2019-07-09 17:57:59');
INSERT INTO `oauth2_access_token` VALUES ('01a4e5a7d52b43c39d9d7738470b3c06', '8a884abafae44e0f9e8df06df9be8f9c', 1, 2, 0, '2019-08-21 12:05:10', '2019-08-21 11:17:09', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('01bb340b4b154d6d98728b55804e6a6a', '49a6bdbf832a41108520b230b3f61b49', 27, 2, 1, '2019-08-12 10:08:25', '2019-08-12 09:20:25', '2019-08-12 09:20:25');
INSERT INTO `oauth2_access_token` VALUES ('01d2988885c3480686794436bb4ba6d9', '44f476de360c4d10a81121c815833efc', 27, 2, 1, '2019-06-26 18:40:37', '2019-06-26 17:52:37', '2019-06-26 17:52:37');
INSERT INTO `oauth2_access_token` VALUES ('01d862ba0c3d4da59eb687e17266e301', 'a47d7bf20cd7477a9510c6c92d8067d6', 27, 2, 1, '2019-06-05 10:02:27', '2019-06-05 09:14:27', '2019-06-05 09:14:27');
INSERT INTO `oauth2_access_token` VALUES ('01edb21ea5b54f639431f6a67c8b6083', '36332860db0e4a289ad3d94c4118d7a5', 27, 2, 1, '2019-07-17 16:20:52', '2019-07-17 15:32:51', '2019-07-17 15:32:51');
INSERT INTO `oauth2_access_token` VALUES ('01ee1f97d54c4a29b2063dbc4ee9e701', 'b96758b1dbc144b39a525e8d36f86a5f', 27, 2, 1, '2019-05-30 10:23:43', '2019-05-30 09:35:43', '2019-05-30 09:35:43');
INSERT INTO `oauth2_access_token` VALUES ('01f4740c040c4670978a7e5bf028079b', 'a4964d041acc48bd924405218c97a9e2', 27, 2, 1, '2019-06-01 17:50:32', '2019-06-01 17:02:31', '2019-06-01 17:02:31');
INSERT INTO `oauth2_access_token` VALUES ('01f5729136b84e7ebcb584c457b2a00a', '5b2b1a5dc26f40c1af7ef9a9565e95d8', 1, 2, 0, '2019-05-17 19:10:10', '2019-05-17 18:22:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('01f6fd01627f410eb1c5c9fc833381d7', '73c06927f18645ddb9c028851bd4feac', 27, 2, 1, '2019-06-10 10:33:18', '2019-06-10 09:45:17', '2019-06-10 09:45:17');
INSERT INTO `oauth2_access_token` VALUES ('02058ccbe9c64b80850b428efb06d1b9', '424ea38d5b954e0cb2521c224cbede0d', 1, 2, 0, '2019-07-15 16:58:10', '2019-07-15 16:10:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('021a80760e1b47fa87a09dbbba6d855d', '8b0f938281c34e968e1e289e0b58bf62', 27, 2, 1, '2019-07-12 19:04:40', '2019-07-12 18:16:39', '2019-07-12 18:16:39');
INSERT INTO `oauth2_access_token` VALUES ('023985b9b25a4d4fa9b519890ef8502e', 'c70bba37637641f396b3115125f87e06', 27, 2, 1, '2019-07-23 15:52:50', '2019-07-23 15:04:49', '2019-07-23 15:04:49');
INSERT INTO `oauth2_access_token` VALUES ('024f764a283d41069990070c8cafd562', 'd8d55c5e53664e3b95082246f6fb1a06', 27, 2, 1, '2019-05-19 12:06:35', '2019-05-19 11:18:35', '2019-05-19 11:18:35');
INSERT INTO `oauth2_access_token` VALUES ('027ff0f3db564f2cbf11f97e1ee5db7c', '8091c43219f54d99ae18a11049155276', 27, 2, 1, '2019-06-03 10:48:00', '2019-06-03 10:00:00', '2019-06-03 10:00:00');
INSERT INTO `oauth2_access_token` VALUES ('0282e98f418f4173a43ba46e4d160f31', '1404f2c5a20046bcb2eae31126ee6311', 27, 2, 1, '2019-08-15 17:29:51', '2019-08-15 16:41:51', '2019-08-15 16:41:51');
INSERT INTO `oauth2_access_token` VALUES ('02928dc610464aad8771e094a03ebf34', '94623386b3cb4d7fbf5d55c84503ac66', 27, 2, 1, '2019-05-17 19:15:45', '2019-05-17 18:27:44', '2019-05-17 18:27:44');
INSERT INTO `oauth2_access_token` VALUES ('02996b14e97246c1a34af512f45ea4b7', '527e843882de40d297a4bd32d361028d', 175, 1, 1, '2019-07-18 10:29:55', '2019-07-18 09:41:54', '2019-07-18 09:41:54');
INSERT INTO `oauth2_access_token` VALUES ('02a03a9459a04d0a860d2b449f2d4b0c', 'a5341875755640b6995f74bf6e9795be', 27, 2, 1, '2019-08-07 10:14:51', '2019-08-07 09:26:51', '2019-08-07 09:26:51');
INSERT INTO `oauth2_access_token` VALUES ('02a348774cf54a2abc62335ef3d13b02', '72b009a3c749433e9ae8fefa169c420f', 27, 2, 1, '2019-06-05 20:44:38', '2019-06-05 19:56:38', '2019-06-05 19:56:38');
INSERT INTO `oauth2_access_token` VALUES ('02a9d91065d04488b12ed71641929a50', '91fca003fed44b86aafd70be99699f70', 27, 2, 1, '2019-09-03 22:37:20', '2019-09-03 21:49:20', '2019-09-03 21:49:20');
INSERT INTO `oauth2_access_token` VALUES ('02b0fef3b2f549f4982d85367612c59f', 'fe0a9a927442414e92acd4a640d60c0e', 188, 1, 1, '2019-08-01 23:05:42', '2019-08-01 22:17:41', '2019-08-01 22:17:41');
INSERT INTO `oauth2_access_token` VALUES ('02b51ec1520f47c8a34444854ccb9e85', '2f0d8f7830dd40d7afa2ed1089c63dfc', 27, 2, 1, '2019-07-10 14:54:46', '2019-07-10 14:06:46', '2019-07-10 14:06:46');
INSERT INTO `oauth2_access_token` VALUES ('02c8a4bb0b5d458eb19681e5a87ebcb2', 'baf38b2610364bfc9d92a5066f683002', 27, 2, 1, '2019-05-29 18:44:18', '2019-05-29 17:56:17', '2019-05-29 17:56:17');
INSERT INTO `oauth2_access_token` VALUES ('02cc12ff433d444a8bde3906a4919de4', 'bb7509a6824e4be8b5b2b73a464f6a2a', 27, 2, 1, '2019-06-04 20:43:31', '2019-06-04 19:55:31', '2019-06-04 19:55:31');
INSERT INTO `oauth2_access_token` VALUES ('02ccb95477004fef9e6290fe04096c1a', '07e47eca6a9244c19d33e5435c54de6a', NULL, NULL, 1, '2019-05-10 15:17:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('02d73c17d88044888ab9f8a612226100', '870c5443abb14619a792de6206c21ae6', 27, 2, 1, '2019-06-27 21:15:33', '2019-06-27 20:27:33', '2019-06-27 20:27:33');
INSERT INTO `oauth2_access_token` VALUES ('02f9ccc2d4514dce9a811f79be2d100d', 'fcf09369ceb94cf88b6027b65bc6dc62', 27, 2, 1, '2019-07-18 17:59:32', '2019-07-18 17:11:31', '2019-07-18 17:11:31');
INSERT INTO `oauth2_access_token` VALUES ('02fb1ab1fd834b529768e1105d1bf3e9', '46f7d5026b5f4cbf84bfb5b1bfad1ca0', 27, 2, 1, '2019-08-20 16:47:24', '2019-08-20 15:59:24', '2019-08-20 15:59:24');
INSERT INTO `oauth2_access_token` VALUES ('02fea7ae5086447eb22a4a3ba457d7ff', '994bae82ae944ae1ba5f23b2018138fe', NULL, NULL, 1, '2019-03-10 10:57:25', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0300b312ffcd47daa31609361c90f04b', '3aa6006aabca4caebceae8c69325b2d4', 27, 2, 1, '2019-08-29 11:32:09', '2019-08-29 10:44:08', '2019-08-29 10:44:08');
INSERT INTO `oauth2_access_token` VALUES ('0307e0959cd44565a85888cfecb82029', '064940ef2184428abfef3842f338e2a2', 27, 2, 1, '2019-07-09 21:25:22', '2019-07-09 20:37:21', '2019-07-09 20:37:21');
INSERT INTO `oauth2_access_token` VALUES ('0310d1d154cc4505a87d5230603b2469', 'e3951384a2734ca9bffb9d2ebddfb138', 27, 2, 1, '2019-06-05 11:12:44', '2019-06-05 10:24:44', '2019-06-05 10:24:44');
INSERT INTO `oauth2_access_token` VALUES ('03215981d104450dbea193e94a5efc70', '0c04cc1c92514c189e552066aad9c340', 27, 2, 1, '2019-06-05 11:55:32', '2019-06-05 11:07:31', '2019-06-05 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0325a4f956324e179fddde042468f203', '5ab3670427294a69be742ad10491f859', 27, 2, 1, '2019-07-22 09:59:04', '2019-07-22 09:11:03', '2019-07-22 09:11:03');
INSERT INTO `oauth2_access_token` VALUES ('0327f6a8c654480aa79933ba94cce5a5', '4a12a1e286164d1cb8ca2ed13f038ff1', NULL, NULL, 1, '2019-05-02 23:56:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('032af608116a47c19f1c6235d4dd30c5', '724171a9f25340afa11dbe53624dba18', 27, 2, 1, '2019-06-14 12:06:38', '2019-06-14 11:18:38', '2019-06-14 11:18:38');
INSERT INTO `oauth2_access_token` VALUES ('03348613a83342af93d93b1bbed14bd8', '02663ec8f5ea448eb9fa4cfad3fd9b7f', 27, 2, 1, '2019-06-17 17:27:34', '2019-06-17 16:39:33', '2019-06-17 16:39:33');
INSERT INTO `oauth2_access_token` VALUES ('0344ddfcbaef4ee2b2f2331254733966', 'a77a44076e4f4c38a9888f38ded2ed3f', 27, 2, 1, '2019-07-12 10:48:30', '2019-07-12 10:00:29', '2019-07-12 10:00:29');
INSERT INTO `oauth2_access_token` VALUES ('034703ecd8d74f09a04bcef76664ef7e', '7b380fcc3a4e40c1896a3ec716a12437', 27, 2, 1, '2019-07-06 11:13:56', '2019-07-06 10:25:56', '2019-07-06 10:25:56');
INSERT INTO `oauth2_access_token` VALUES ('03bb33c56e1742998840d79bce7a7dbf', 'fad8b6334c584bff9fbc779aceabdcd5', 27, 2, 1, '2019-06-03 11:13:55', '2019-06-03 10:25:55', '2019-06-03 10:25:55');
INSERT INTO `oauth2_access_token` VALUES ('03c11dc3a45349ff99195d702ac096c1', '50418dab522948aea568d908b57d2bc7', 27, 2, 1, '2019-06-10 11:57:32', '2019-06-10 11:09:32', '2019-06-10 11:09:32');
INSERT INTO `oauth2_access_token` VALUES ('03da9d1374db4fc3b324fd6ff6dc7bc8', '2ee04e0688384b6fb0d2e3aeedaac3b7', 27, 2, 1, '2019-09-05 10:57:34', '2019-09-05 10:09:33', '2019-09-05 10:09:33');
INSERT INTO `oauth2_access_token` VALUES ('042327ae49334bb1b43fb0b90b67c3b4', 'f08263f0f81c430291a38e3c644675d8', 1, 2, 0, '2019-08-01 13:03:06', '2019-08-01 12:15:06', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('04272a9bb1fc490bab409b2b14377eff', 'dfb159480bf64471af6193c2f8e6be6b', 27, 2, 1, '2019-07-18 17:43:56', '2019-07-18 16:55:55', '2019-07-18 16:55:55');
INSERT INTO `oauth2_access_token` VALUES ('043856707d8e42dda51aaffd4e65a17b', '4ae23df04bbf4ee4a94bcc4267f299e1', 27, 2, 1, '2019-06-13 12:51:57', '2019-06-13 12:03:57', '2019-06-13 12:03:57');
INSERT INTO `oauth2_access_token` VALUES ('045790b2e41f43c09a95611960dd1b24', '7121a49146224b02a8314ff4208663ed', NULL, NULL, 1, '2019-04-28 18:02:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('045f40c332bd445a92b96f7457c470f0', 'e068ea9c3ab2472c8d7a96e939aa9e3a', 27, 2, 1, '2019-07-11 17:29:46', '2019-07-11 16:41:46', '2019-07-11 16:41:46');
INSERT INTO `oauth2_access_token` VALUES ('045f61d887b546aab10cb6daf1b47f4a', '5d67f0d6a20642fd84c7642840f73e81', 91, 1, 1, '2019-05-30 10:26:34', '2019-05-30 09:38:33', '2019-05-30 09:38:33');
INSERT INTO `oauth2_access_token` VALUES ('0463132804df4e8592504849f199ae3e', 'bf176a27afa44aff8c50021832041a5c', 27, 2, 1, '2019-07-04 15:56:03', '2019-07-04 15:08:02', '2019-07-04 15:08:02');
INSERT INTO `oauth2_access_token` VALUES ('0478eb79fef34e999253e39086b92cff', 'c440eb42c9b942d493a0cd719ce1b5c3', 27, 2, 1, '2019-07-04 10:52:15', '2019-07-04 10:04:14', '2019-07-04 10:04:14');
INSERT INTO `oauth2_access_token` VALUES ('0479bb106ebc484db37c72dd7527180b', '7af020135d3243e3b33fc2576349f9b4', 27, 2, 1, '2019-06-17 16:30:01', '2019-06-17 15:42:01', '2019-06-17 15:42:01');
INSERT INTO `oauth2_access_token` VALUES ('0486ea6293eb4284b2602eaef53bf728', 'd8681ece23c347ebbc72930c7cb98610', 27, 2, 1, '2019-09-09 04:16:06', '2019-09-09 03:28:06', '2019-09-09 03:28:06');
INSERT INTO `oauth2_access_token` VALUES ('04a0e60d04a14053bdc276aae6b6c6f4', '597f074090b34feeaa235cdbb30ffe66', 27, 2, 1, '2019-07-06 19:11:26', '2019-07-06 18:23:25', '2019-07-06 18:23:25');
INSERT INTO `oauth2_access_token` VALUES ('04c2b39121a74268bb214dcdd3ea6163', '8baa1c8507e1409bb04d9c451f8da049', NULL, NULL, 1, '2019-05-05 22:22:47', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('04ce919cd66d4d319f144f494b5abdf0', '9964c1c4d7354965ab80f62bf59750ad', 27, 2, 1, '2019-06-25 09:38:09', '2019-06-25 08:50:08', '2019-06-25 08:50:08');
INSERT INTO `oauth2_access_token` VALUES ('04cf332a47714ee58d3d971610934331', '8781e4cc2d884302a8437384cf6871c8', 27, 2, 1, '2019-06-03 11:02:12', '2019-06-03 10:14:11', '2019-06-03 10:14:11');
INSERT INTO `oauth2_access_token` VALUES ('04d4341d36ac42a89e8d08c67bfca9b9', 'e0505ca71799468697300ce068988ebe', 27, 2, 1, '2019-07-16 12:36:04', '2019-07-16 11:48:04', '2019-07-16 11:48:04');
INSERT INTO `oauth2_access_token` VALUES ('04d857d837ff4ce8b07a3968e243e04f', '636400aa9175431f9650e2b179d67537', 27, 2, 1, '2019-06-05 12:51:58', '2019-06-05 12:03:57', '2019-06-05 12:03:57');
INSERT INTO `oauth2_access_token` VALUES ('04e70ad75f8546689799a387877ca6e8', '848be18ed2a34a96bb2b61daf0f71465', 1, 2, 0, '2019-05-28 17:59:20', '2019-05-28 17:10:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('04eb5f82f15340958e0bbb6f4ecbb352', '7e7cb4e5e3b944a087de340a80493393', 27, 2, 1, '2019-08-14 11:06:57', '2019-08-14 10:18:57', '2019-08-14 10:18:57');
INSERT INTO `oauth2_access_token` VALUES ('04f8019889fe4f3aa03543e4db4e9487', 'fa0c57ff79684a4c991d89b541582eff', 27, 2, 1, '2019-07-12 15:23:59', '2019-07-12 14:35:59', '2019-07-12 14:35:59');
INSERT INTO `oauth2_access_token` VALUES ('051bc279b76044c3b3c51234882baa1f', '08c1d8a7d3c44dba9b1f15bfd7568c07', 27, 2, 1, '2019-06-20 10:26:02', '2019-06-20 09:38:01', '2019-06-20 09:38:01');
INSERT INTO `oauth2_access_token` VALUES ('051bd6b0d82c43229e9355fb6b706c77', 'cdf37bc26e5545308b326795df4a9443', 27, 2, 1, '2019-06-01 08:54:27', '2019-06-01 08:06:27', '2019-06-01 08:06:27');
INSERT INTO `oauth2_access_token` VALUES ('05278b34a5594f8aacef8a5ab7b99d35', '947e88ff64894dfe94b58b08e2799aa8', 27, 2, 1, '2019-05-28 18:14:44', '2019-05-28 17:26:43', '2019-05-28 17:26:43');
INSERT INTO `oauth2_access_token` VALUES ('053122b61f7c42439f65d538fcaa32e8', '3a974c7d99f84ccbb571f99fdcff1864', 27, 2, 1, '2019-08-02 16:57:31', '2019-08-02 16:09:30', '2019-08-02 16:09:30');
INSERT INTO `oauth2_access_token` VALUES ('053a6c0bb17046779c97a079c0e63d3d', '656a0da6077e42caa5ae2ddf2b10f7c8', NULL, NULL, 1, '2019-04-26 00:32:07', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('054859cf1ca94ce395b936a5e969b59a', 'b870dd124cdd41ef894f2e5b2542920a', NULL, NULL, 0, '2019-03-04 03:05:39', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('054df1f1e6ee47c995efa1941f0142e1', 'f7f2074317c0455bb26b7966475d11e4', 27, 2, 1, '2019-07-02 11:36:04', '2019-07-02 10:48:03', '2019-07-02 10:48:03');
INSERT INTO `oauth2_access_token` VALUES ('0569f7a8a60c4226a88f643c69abd957', '6ab9192896754829b820271158700b1a', 27, 2, 1, '2019-06-03 01:03:08', '2019-06-03 00:15:07', '2019-06-03 00:15:07');
INSERT INTO `oauth2_access_token` VALUES ('05786a911efe498cb1603806e08d7910', '64f84f1ab935416aa0c105d9752bd809', 144, 1, 1, '2019-07-01 17:34:04', '2019-07-01 16:46:03', '2019-07-01 16:46:03');
INSERT INTO `oauth2_access_token` VALUES ('058c5f806ac04428a4797836c080b304', '06a74ce2119148b9a8d9dd486152655d', 27, 2, 1, '2019-06-27 12:15:48', '2019-06-27 11:27:47', '2019-06-27 11:27:47');
INSERT INTO `oauth2_access_token` VALUES ('05984c549b484cf3b8a25621b0624140', '5b87271011ac4b898e692e25e19ead0c', 27, 2, 1, '2019-08-16 12:23:15', '2019-08-16 11:35:14', '2019-08-16 11:35:14');
INSERT INTO `oauth2_access_token` VALUES ('05c53cee0b3e4c5482a898b66a942ade', '9f35db0e118a42b8bd95f11273c1c277', NULL, NULL, 1, '2019-04-30 22:16:52', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('05e88fc1f6e5471e8c907f8eea6d1714', 'f54c1634a96147558e617d559f97b3b3', 109, 1, 1, '2019-06-05 18:30:21', '2019-06-05 17:42:20', '2019-06-05 17:42:20');
INSERT INTO `oauth2_access_token` VALUES ('060afb0393694b6987d54570d8351106', '6a3c4a8fe8a64f9992da053ef4d5da93', NULL, NULL, 1, '2019-05-03 13:50:26', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('06196e6d424d41658af995f0cc2df752', 'b2a8bac9e8ec4338b4111608b6f5a446', 27, 2, 1, '2019-05-18 02:08:28', '2019-05-18 01:20:28', '2019-05-18 01:20:28');
INSERT INTO `oauth2_access_token` VALUES ('06313feceed44d7ea679270eaf9ab321', '2ade78da6aa748918e161be06edeb516', 27, 2, 1, '2019-07-28 18:16:44', '2019-07-28 17:28:43', '2019-07-28 17:28:43');
INSERT INTO `oauth2_access_token` VALUES ('063bfea1d15f44cebb07f148cb1ef969', 'c401c19701204d4cb44fe6a1ac8cd350', 27, 2, 1, '2019-07-03 18:19:54', '2019-07-03 17:31:53', '2019-07-03 17:31:53');
INSERT INTO `oauth2_access_token` VALUES ('063f1887aa1f47618040cb64711cad50', '1af142c16da84533bdfaa26cf5290f88', 27, 2, 1, '2019-07-20 21:30:50', '2019-07-20 20:42:50', '2019-07-20 20:42:50');
INSERT INTO `oauth2_access_token` VALUES ('064268500d644ed1b90d332ff1c3c327', '40ec280c32df4df69c49fe1fc01f8267', NULL, NULL, 1, '2019-05-04 13:13:23', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0642711bcd5f4a59a1ccb9ab30e74408', 'b752c451020943cb84dacfc33541146d', NULL, NULL, 1, '2019-04-11 18:21:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('065257c8f98e4046b90cd9a050498992', 'ea877db4ecb748319e3c95a27d6ad3b3', 1, 2, 0, '2019-08-21 18:51:03', '2019-08-21 18:03:02', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('06532a8660e1435bb1aef24585b16d6f', '68ab92e6a2af44d1a568718b22faebc0', 27, 2, 1, '2019-09-04 12:02:48', '2019-09-04 11:14:47', '2019-09-04 11:14:47');
INSERT INTO `oauth2_access_token` VALUES ('0665f56fb82b421e94c26723cfb5ba93', '11fa6d99107d49cf8c679d34f9e82f7e', 1, 2, 0, '2019-07-07 19:15:14', '2019-07-07 18:27:13', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('067a008910724de2bca994b81819418e', 'b9a6f0824012420881219b07becb36c6', 27, 2, 1, '2019-07-17 08:22:05', '2019-07-17 07:34:05', '2019-07-17 07:34:05');
INSERT INTO `oauth2_access_token` VALUES ('067b316c02c94406933a9ee6bffc37c5', 'f747e37cf63d4f9eb2bbc925991ce268', 27, 2, 1, '2019-07-01 11:15:17', '2019-07-01 10:27:16', '2019-07-01 10:27:16');
INSERT INTO `oauth2_access_token` VALUES ('068bf184ac3240508aa827f7dcf3fa46', '0e8eb2d8a36d4efe9070536596202cbf', 27, 2, 1, '2019-06-02 18:55:40', '2019-06-02 18:07:40', '2019-06-02 18:07:40');
INSERT INTO `oauth2_access_token` VALUES ('06b1eaa051af46f196c977fff9fd53a2', '432140825a474e959309e785cb75b889', 27, 2, 1, '2019-08-12 17:53:11', '2019-08-12 17:05:11', '2019-08-12 17:05:11');
INSERT INTO `oauth2_access_token` VALUES ('06cbba474b2c4159bb317f227af80e18', 'b66c4078985c402da620fad36c43b1a0', 27, 2, 1, '2019-05-24 18:31:26', '2019-05-24 17:43:26', '2019-05-24 17:43:26');
INSERT INTO `oauth2_access_token` VALUES ('06cebcefb0184527805a477a15a5a303', 'b457f3a270044a05b5e4a0640f7e446d', 27, 2, 1, '2019-08-28 22:58:41', '2019-08-28 22:10:41', '2019-08-28 22:10:41');
INSERT INTO `oauth2_access_token` VALUES ('06da18474d0f49a996f7b60933a83d3d', '9e082530a14243a7a5f55dbd3fdee00b', 27, 2, 1, '2019-06-26 12:53:25', '2019-06-26 12:05:24', '2019-06-26 12:05:24');
INSERT INTO `oauth2_access_token` VALUES ('06eaa6e0c4c749acb651b691578e427b', '17615a1f2a164df7b6b689b9dde09135', 27, 2, 1, '2019-06-03 14:55:00', '2019-06-03 14:06:59', '2019-06-03 14:06:59');
INSERT INTO `oauth2_access_token` VALUES ('06f245712eaa4bc6adbe85a6a2f34ced', '5ad4e62aee974ac18a7e884ac52f69aa', 27, 2, 1, '2019-06-28 15:45:32', '2019-06-28 14:57:32', '2019-06-28 14:57:32');
INSERT INTO `oauth2_access_token` VALUES ('06f60d50dab74238a64a8413d1e68862', '83c6ca22e33f44c9a6fbd8b22d4e903c', NULL, NULL, 1, '2019-05-13 22:50:46', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('072145c898bc44f0abcfc8639b433916', '7750b9581e714aa791135e7ae8246700', 27, 2, 1, '2019-07-02 11:53:51', '2019-07-02 11:05:51', '2019-07-02 11:05:51');
INSERT INTO `oauth2_access_token` VALUES ('07256a86b7a548af9e7648f16d9cbd53', 'b110816197194eeb94d3f000089533a0', 27, 2, 1, '2019-06-28 11:22:56', '2019-06-28 10:34:56', '2019-06-28 10:34:56');
INSERT INTO `oauth2_access_token` VALUES ('072a4b7e9cd24ffabd2df3f2ad140192', 'a2198f25731241d8a3aa7e8a6edba76f', 27, 2, 1, '2019-08-08 21:18:34', '2019-08-08 20:30:34', '2019-08-08 20:30:34');
INSERT INTO `oauth2_access_token` VALUES ('072e09d5b89942c2a587646307fa4a90', 'e96243d4896f4397a520c9cf9f952955', 27, 2, 1, '2019-08-12 10:00:43', '2019-08-12 09:12:43', '2019-08-12 09:12:43');
INSERT INTO `oauth2_access_token` VALUES ('072f7127c2414550b75c36ee68b37cb3', 'b5390c6e73e840a6b0f04e4b9f7c56bd', 27, 2, 1, '2019-06-09 12:33:41', '2019-06-09 11:45:41', '2019-06-09 11:45:41');
INSERT INTO `oauth2_access_token` VALUES ('073ed26d25764b8da49f8f65c6e7f68f', 'afb88688aa5e488f9b09bead58c93979', 27, 2, 1, '2019-05-26 23:23:51', '2019-05-26 22:35:51', '2019-05-26 22:35:51');
INSERT INTO `oauth2_access_token` VALUES ('0743df4ebc444662833e4ac865c01b2e', '1ed0b75578ec432b9779cda17824ae0d', 27, 2, 1, '2019-06-10 20:38:26', '2019-06-10 19:50:25', '2019-06-10 19:50:25');
INSERT INTO `oauth2_access_token` VALUES ('0747bd3c2e224c61bbb65470cfbda5db', 'ce09199ac2484d81a2b7ff34e14615ab', 27, 2, 1, '2019-07-01 19:49:07', '2019-07-01 19:01:06', '2019-07-01 19:01:06');
INSERT INTO `oauth2_access_token` VALUES ('0756327fdb50421fbc0bf9c79dd967a0', 'c1716674a9ae482bb19e6a6fccccacf1', NULL, NULL, 1, '2019-05-05 16:44:33', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('079ad0327a234f1eba7db5c3928bc86a', '7ee5ae75bda3495aa8644312f0fe0ca8', 27, 2, 1, '2019-06-02 15:57:45', '2019-06-02 15:09:44', '2019-06-02 15:09:44');
INSERT INTO `oauth2_access_token` VALUES ('07a8b0e6bead49c990801b2eedb696b8', '652a9ecfe26a4863a6d0d16daddc0426', 27, 2, 1, '2019-07-25 18:55:12', '2019-07-25 18:07:11', '2019-07-25 18:07:11');
INSERT INTO `oauth2_access_token` VALUES ('07b93700228548338e6735d9225e3421', '77058c5b16d3402dbc0ec2b7232ce704', 27, 2, 1, '2019-07-22 11:10:52', '2019-07-22 10:22:51', '2019-07-22 10:22:51');
INSERT INTO `oauth2_access_token` VALUES ('07ca8c9a87c24405a5b9ee34bbb0273d', 'c6cd18e230c446eb9929067fdb5d563d', 27, 2, 1, '2019-06-28 18:06:46', '2019-06-28 17:18:45', '2019-06-28 17:18:45');
INSERT INTO `oauth2_access_token` VALUES ('07cbf78e2bd340399f1a84c80c158ac3', 'c6400be52df64b9a9f1bc35ff247506c', 138, 1, 1, '2019-06-24 18:27:36', '2019-06-24 17:39:35', '2019-06-24 17:39:35');
INSERT INTO `oauth2_access_token` VALUES ('07dc78e2b2a1478e9a2ab794374ec7e3', '1bd8f209984c4c339807c866afde56a6', 27, 2, 1, '2019-08-26 00:42:56', '2019-08-25 23:54:56', '2019-08-25 23:54:56');
INSERT INTO `oauth2_access_token` VALUES ('07f1c8fbe83443dba748a0d4645d6528', '4ad1bbf277954c9d8d7fc9d43bee30cd', 27, 2, 1, '2019-06-01 16:23:56', '2019-06-01 15:35:55', '2019-06-01 15:35:55');
INSERT INTO `oauth2_access_token` VALUES ('07f2536601d042a7a7ef28b0e5bd0d1a', 'f956b88492b948f4853fd73372b26231', NULL, NULL, 1, '2019-05-06 16:21:39', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('07f3c1ca02a7433b8683cff0bde35cac', '4944f7674ca54401be5aa0fdd0bede3e', NULL, NULL, 1, '2019-03-10 08:37:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('07fc98efb2024e97ae84e6631c863b16', '9a0a90ee15814f5380eccdde31ecbfa5', 27, 2, 1, '2019-08-13 14:34:05', '2019-08-13 13:46:05', '2019-08-13 13:46:05');
INSERT INTO `oauth2_access_token` VALUES ('081d7fe70b8748a78529f664bd157508', 'e498d81538884700a2fc67df8042ff5a', 1, 2, 0, '2019-06-11 15:50:15', '2019-06-11 15:02:15', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('083301e0de004b318c5063fc13b839be', '24b18caf50d64590bc797d9ca087c579', 27, 2, 1, '2019-07-26 16:32:47', '2019-07-26 15:44:46', '2019-07-26 15:44:46');
INSERT INTO `oauth2_access_token` VALUES ('08380aac8c5f454789c3bb73bcfc968b', '816057f4ec1c47bdae5424f6106d9d46', 27, 2, 1, '2019-06-05 14:49:45', '2019-06-05 14:01:44', '2019-06-05 14:01:44');
INSERT INTO `oauth2_access_token` VALUES ('085407a2b3874147bd496687291e3089', '2fea55f06b5e4d109cffa3f6e9dacf2e', 1, 2, 0, '2019-06-03 17:13:06', '2019-06-03 16:25:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('0854294143394203a75c9034f61c2925', '8d11e92207c6449ebc76d104e91d2f8c', 27, 2, 1, '2019-06-24 12:09:18', '2019-06-24 11:21:17', '2019-06-24 11:21:17');
INSERT INTO `oauth2_access_token` VALUES ('088cb55a44fe40c79164f0e091eacaa1', '8887617ae8ef4741bd534b79ab841019', 27, 2, 1, '2019-08-20 19:24:18', '2019-08-20 18:36:18', '2019-08-20 18:36:18');
INSERT INTO `oauth2_access_token` VALUES ('08b744fae0444d6284e8eda6ce448cd0', '14aefa11b4174c9ea98e6e60aa9ce14f', 27, 2, 1, '2019-06-02 22:03:29', '2019-06-02 21:15:29', '2019-06-02 21:15:29');
INSERT INTO `oauth2_access_token` VALUES ('08bf7638d0f34a6c9814e264eb20b837', 'bbd113a85f34494db1da396f4df9e461', 27, 2, 1, '2019-06-01 10:43:20', '2019-06-01 09:55:20', '2019-06-01 09:55:20');
INSERT INTO `oauth2_access_token` VALUES ('08c8f0646e1749a6a8bac33127f54cde', 'f8882fe32e6e445aa90440dca0d94dba', 27, 2, 1, '2019-07-02 17:53:16', '2019-07-02 17:05:15', '2019-07-02 17:05:15');
INSERT INTO `oauth2_access_token` VALUES ('08d69805097c41ef8348479d86a0ee74', '83e051debafd46a3a1ece6a04b4314eb', 27, 2, 1, '2019-08-14 17:36:38', '2019-08-14 16:48:38', '2019-08-14 16:48:38');
INSERT INTO `oauth2_access_token` VALUES ('08e5e60c95a14d2982cfc188b90fb31e', 'cf7201261c2a4f779f0d155822b62ca9', 27, 2, 1, '2019-08-31 12:33:45', '2019-08-31 11:45:45', '2019-08-31 11:45:45');
INSERT INTO `oauth2_access_token` VALUES ('08e9c5ba64b840f3902ed447cc724f0a', '367772bd5fe84dc29cce2845ae855965', 27, 2, 1, '2019-06-05 10:21:10', '2019-06-05 09:33:10', '2019-06-05 09:33:10');
INSERT INTO `oauth2_access_token` VALUES ('08f3e3c9c0434c0eacaeeb57ea6ce26d', '11cf8e90730e4cba96d3786a84f07dcb', 27, 2, 1, '2019-05-31 17:37:31', '2019-05-31 16:49:31', '2019-05-31 16:49:31');
INSERT INTO `oauth2_access_token` VALUES ('091862928e094a7193fe2c3a964e097b', 'ff6efb44987e465f9808772198575f19', 27, 2, 1, '2019-06-12 18:10:38', '2019-06-12 17:22:37', '2019-06-12 17:22:37');
INSERT INTO `oauth2_access_token` VALUES ('091c1fddd2954b27864e686c279384be', '4a6a33b8a6e94f3d8566fd8f70d1be4d', 27, 2, 1, '2019-08-03 22:59:59', '2019-08-03 22:11:58', '2019-08-03 22:11:58');
INSERT INTO `oauth2_access_token` VALUES ('093264e6ded649bcb70c048311e938df', 'a86c03dc5ce84d999a0343333cca04ba', 1, 2, 0, '2019-09-01 23:54:51', '2019-09-01 23:06:50', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('0961b9a565b64d0d82b7215c020c736a', '0f949e5c4f474113a5e6fdc0297879b5', 27, 2, 1, '2019-06-29 10:06:28', '2019-06-29 09:18:27', '2019-06-29 09:18:27');
INSERT INTO `oauth2_access_token` VALUES ('09628c086a6344d4a8b5cb89c3a77a11', '2691851afcc64815a9bfb64ef110410a', 27, 1, 1, '2019-05-17 01:13:12', '2019-05-17 00:25:11', '2019-05-17 00:25:11');
INSERT INTO `oauth2_access_token` VALUES ('096525a1f73942b0b7a61365bd425d72', '1bd50bc89ed2487a95e37991d3ae07e8', 27, 2, 1, '2019-07-26 17:26:03', '2019-07-26 16:38:03', '2019-07-26 16:38:03');
INSERT INTO `oauth2_access_token` VALUES ('0991dfab92d24e12815337b65399391d', 'b5714ddf4ea94cb6a42fb1ddf5f68ec7', 27, 2, 1, '2019-08-13 16:28:21', '2019-08-13 15:40:21', '2019-08-13 15:40:21');
INSERT INTO `oauth2_access_token` VALUES ('09ab7435d93f4cbca62bc5434c8313f2', '162b29a9fba742988d9fbdbede5eb6f0', NULL, NULL, 1, '2019-03-12 02:12:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('09b21bc932ee46e2845785ac296f91a9', 'c52ccc89afb94822b6c85e28095b565e', 27, 2, 1, '2019-08-16 15:16:28', '2019-08-16 14:28:27', '2019-08-16 14:28:27');
INSERT INTO `oauth2_access_token` VALUES ('09b9b0755a624c7db8d198c0b06a63d5', 'd9f454c0f13042ccba9a7308c8bdaed0', 27, 2, 1, '2019-06-03 21:00:04', '2019-06-03 20:12:03', '2019-06-03 20:12:03');
INSERT INTO `oauth2_access_token` VALUES ('09c70a2fc4544f219fab8230cc80970c', '0c514a5dbacb42f8bce7ae4990ca5db3', 27, 2, 1, '2019-06-03 14:35:33', '2019-06-03 13:47:33', '2019-06-03 13:47:33');
INSERT INTO `oauth2_access_token` VALUES ('09d4da63791a4c5d84da8529d349a3d1', 'c6a57b4c280c4cf38483fdc9525119a7', 72, 1, 1, '2019-05-17 01:13:54', '2019-05-17 00:25:53', '2019-05-17 00:25:53');
INSERT INTO `oauth2_access_token` VALUES ('09ddb2eee8c84528b87cc2de816c6670', '97cc87c6786f46e4a31a2bb794ece753', NULL, NULL, 1, '2019-03-22 01:19:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('09e79ece30a541dcbaeaba06cb67e9bf', '6f8526d455414b589a9ce0ae22ce37c8', 27, 2, 1, '2019-07-12 10:38:51', '2019-07-12 09:50:50', '2019-07-12 09:50:50');
INSERT INTO `oauth2_access_token` VALUES ('09f04d0e202a4deeb2c207557a2a7b44', 'b1af96f8cfe741baab18886806c7e92b', NULL, NULL, 1, '2019-05-13 00:14:03', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('09fe05a0c2ec45e7be3cd8c240cbc152', '01cdbcd89f9f444881816b16fad20d39', NULL, NULL, 1, '2019-05-10 09:47:13', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0a0734f678284a6db34eda3535ab16c3', '9ac5bde5545d453e9fbbae6169059712', 27, 2, 1, '2019-06-06 11:44:21', '2019-06-06 10:56:20', '2019-06-06 10:56:20');
INSERT INTO `oauth2_access_token` VALUES ('0a10bc5f09404aa2b486522e125a1ad6', '59346bb134bd447ca8f091206f6256c3', NULL, NULL, 1, '2019-05-02 17:46:46', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0a242d9319c645c197c51255a8c16eb0', 'c9cb7830afba43509c8592c507dbd7a2', 27, 2, 1, '2019-06-19 16:27:35', '2019-06-19 15:39:34', '2019-06-19 15:39:34');
INSERT INTO `oauth2_access_token` VALUES ('0a2a28006f7f47f98093265e3d4c9489', '6e58fc0d17c44725822c4fff619bd1ee', 27, 2, 1, '2019-08-02 10:07:10', '2019-08-02 09:19:10', '2019-08-02 09:19:10');
INSERT INTO `oauth2_access_token` VALUES ('0a3328b0742348b2bb503d0c39255826', '82d0322e97a84ba98a139275c2e0b412', 218, 1, 1, '2019-09-03 16:29:57', '2019-09-03 15:41:56', '2019-09-03 15:41:56');
INSERT INTO `oauth2_access_token` VALUES ('0a578bd92de0424e86511b1ad2ef7bad', '235b294a658c4751ad18635a08611872', 27, 2, 1, '2019-06-29 21:56:44', '2019-06-29 21:08:44', '2019-06-29 21:08:44');
INSERT INTO `oauth2_access_token` VALUES ('0a90c4b0a1464d539f79de83954515f1', 'bca7ef714e434e3a816831a2dd4cb879', 27, 2, 1, '2019-07-31 11:30:06', '2019-07-31 10:42:05', '2019-07-31 10:42:05');
INSERT INTO `oauth2_access_token` VALUES ('0ac24469306340d88d479e7d26e833c7', '624227a9f5844e5db7f0dfa10a3b1f57', NULL, NULL, 1, '2019-03-30 15:24:50', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0ad8fbf8e18a4ee7b7bb3b7860f01cf5', 'd592b981fa924686a3bb928570adabb6', NULL, NULL, 1, '2019-05-06 12:33:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0ae4ed220c65490ba78ef6886ac6df19', 'd9d47089429f4510889e1263290867ce', 27, 2, 1, '2019-08-18 12:16:16', '2019-08-18 11:28:15', '2019-08-18 11:28:15');
INSERT INTO `oauth2_access_token` VALUES ('0afed0453c4249a796ad16853f020dbb', 'b1ec41f1c8d442e8b89fc3cac5e458fd', 27, 2, 1, '2019-08-21 17:50:22', '2019-08-21 17:02:22', '2019-08-21 17:02:22');
INSERT INTO `oauth2_access_token` VALUES ('0affe498bfd84d698494c1a36a2453d3', 'e559e2a33003400caa1d33097639b79c', 27, 2, 1, '2019-06-13 15:48:39', '2019-06-13 15:00:38', '2019-06-13 15:00:38');
INSERT INTO `oauth2_access_token` VALUES ('0b0d6d419a4845219291926ca0947e0a', '3561d12678d3492f85110e93535e552c', NULL, NULL, 1, '2019-03-12 20:32:09', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0b37e99001304aa38b9b07b7e50d4f3f', 'b7c40d8627e440fc9a9db0675d5390f5', 27, 2, 1, '2019-08-10 00:12:53', '2019-08-09 23:24:52', '2019-08-09 23:24:52');
INSERT INTO `oauth2_access_token` VALUES ('0b92ff747f41472a9b2724f470f99584', '2c08082ccaf24d789d28eb6d5d1b5ce7', 27, 2, 1, '2019-09-07 21:08:10', '2019-09-07 20:20:10', '2019-09-07 20:20:10');
INSERT INTO `oauth2_access_token` VALUES ('0bd4d346c6184a4ba3af3240fe129ca8', '48f54e0e6ced40a4baedcd6706ae6771', NULL, NULL, 1, '2019-05-05 18:51:26', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0bdee041aea84cc28f2eebdb41bdaf08', '1a55f8af40d44832934821d6c643442f', 27, 2, 1, '2019-07-23 14:29:20', '2019-07-23 13:41:20', '2019-07-23 13:41:20');
INSERT INTO `oauth2_access_token` VALUES ('0be83f72328842c5b6a441dfb8107b6b', '1ab8f0dcdfd14ce9bd3a03d9bdf7a970', 27, 2, 1, '2019-06-03 16:29:36', '2019-06-03 15:41:36', '2019-06-03 15:41:36');
INSERT INTO `oauth2_access_token` VALUES ('0be858d9ae9d4dd5ab250bb37851ba95', '4f17a5d147d14795b3cd61ee955c92b7', 27, 2, 1, '2019-08-05 17:29:03', '2019-08-05 16:41:03', '2019-08-05 16:41:03');
INSERT INTO `oauth2_access_token` VALUES ('0bf5e24c22e34992bbb07a09b7ce5200', '1c6cfc2b73954fc8a1b87c58e5b33d4f', 173, 1, 1, '2019-07-17 08:20:39', '2019-07-17 07:32:39', '2019-07-17 07:32:39');
INSERT INTO `oauth2_access_token` VALUES ('0bf66c37f52e48e795ddabef2696944c', 'ac1b13df241d41b9a42d95bd17aecb89', 27, 2, 1, '2019-08-08 10:58:42', '2019-08-08 10:10:42', '2019-08-08 10:10:42');
INSERT INTO `oauth2_access_token` VALUES ('0bf928d0fb594ed5b884178bcc8d9559', 'b70a921b55674c1cb8ce83ee9693a068', 27, 2, 1, '2019-09-03 23:01:53', '2019-09-03 22:13:53', '2019-09-03 22:13:53');
INSERT INTO `oauth2_access_token` VALUES ('0c2d2e10fd1a467f892115ba39cac95c', 'ff53f07456b4406e9bf4a4dbabce0201', 27, 2, 1, '2019-07-13 07:22:41', '2019-07-13 06:34:40', '2019-07-13 06:34:40');
INSERT INTO `oauth2_access_token` VALUES ('0c3584f6d7a242eba81c8b51468e0c8b', '2ef7bed19389428790a0aca847190043', 27, 2, 1, '2019-09-02 23:24:23', '2019-09-02 22:36:22', '2019-09-02 22:36:22');
INSERT INTO `oauth2_access_token` VALUES ('0c3c97ae0799442b8e24829b2aebdc1b', '86a7ee0c997f48de8f41fb8f8f6fa606', 1, 2, 0, '2019-09-05 11:26:06', '2019-09-05 10:38:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('0c4d5b791b0d4ef492b177a8ed1d5cc3', '6e57ec4d2c1a4b33b374c07f4dbca006', 27, 2, 1, '2019-06-13 18:48:22', '2019-06-13 18:00:21', '2019-06-13 18:00:21');
INSERT INTO `oauth2_access_token` VALUES ('0c565616f734411b90a84a6d6e08e54d', '53d79a4b0f8a4fd19eae98a29cb2502c', 27, 2, 1, '2019-07-02 16:04:05', '2019-07-02 15:16:05', '2019-07-02 15:16:05');
INSERT INTO `oauth2_access_token` VALUES ('0c6b292220ff45cdb67c2005d014e3aa', 'dcc6c6a1a2d9492789de045761e80033', 27, 2, 1, '2019-06-12 18:06:33', '2019-06-12 17:18:32', '2019-06-12 17:18:32');
INSERT INTO `oauth2_access_token` VALUES ('0c6ebe52ddc34017b754c3a4467932e0', '5e00cef0772d4fe4b6eb65e96afb978a', 1, 2, 0, '2019-06-28 15:04:12', '2019-06-28 14:16:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('0c6f3daa88be4d749b5c45c49e138d94', '8434e42aade941db9fab3267c255556a', NULL, NULL, 1, '2019-04-29 16:32:33', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0c7088c383d0432da9e90ab168df72d5', '3206207475da4d8b826bd89a55e89324', 27, 2, 1, '2019-06-19 10:58:10', '2019-06-19 10:10:10', '2019-06-19 10:10:10');
INSERT INTO `oauth2_access_token` VALUES ('0c733519cb5c46448ec89b3cf229e57b', '3c58f3c6d75048769e348048aaed51b0', 27, 2, 1, '2019-06-28 18:02:44', '2019-06-28 17:14:44', '2019-06-28 17:14:44');
INSERT INTO `oauth2_access_token` VALUES ('0c88969739de4b64a98439077e8f6e45', '59a767b37ccd421e944d50b8704631ad', 27, 2, 1, '2019-07-24 21:50:36', '2019-07-24 21:02:36', '2019-07-24 21:02:36');
INSERT INTO `oauth2_access_token` VALUES ('0cc0e6d30b854b3a9b2db4eaf7127ec7', '44c5c435b1b94767971fb2465c65563c', 27, 2, 1, '2019-06-14 13:25:52', '2019-06-14 12:37:52', '2019-06-14 12:37:52');
INSERT INTO `oauth2_access_token` VALUES ('0cc19ef900154ee891abb3d540c369e8', '8dc3bce249c645758474af4eaeff50b1', 27, 2, 1, '2019-06-06 13:01:30', '2019-06-06 12:13:30', '2019-06-06 12:13:30');
INSERT INTO `oauth2_access_token` VALUES ('0ce0d4bf64b74645882fabe6c01e0382', '9ea6927d931448ff9b9de491505b38d9', 27, 2, 1, '2019-06-11 16:43:55', '2019-06-11 15:55:54', '2019-06-11 15:55:54');
INSERT INTO `oauth2_access_token` VALUES ('0ce3c1d673c647b884c65a46b3a970b4', '9872d744317c4453877c8b673c6772a2', 27, 2, 1, '2019-05-21 10:33:30', '2019-05-21 09:45:29', '2019-05-21 09:45:29');
INSERT INTO `oauth2_access_token` VALUES ('0cfafca296694bb2bf05bfdd19534b3f', 'c6c75399bd61401baae34b1f5c1263c5', 27, 2, 1, '2019-05-20 18:53:06', '2019-05-20 18:05:06', '2019-05-20 18:05:06');
INSERT INTO `oauth2_access_token` VALUES ('0cff01c638494e3ab2adba644aa6029e', '39420892ddb34732ae44c27a2064631f', NULL, NULL, 1, '2019-03-24 17:17:07', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0d2ae714ce9e4a08ba1a1f7c9ecfe703', '86c817486f76432ea4244f2b6621a571', 27, 2, 1, '2019-09-03 14:40:51', '2019-09-03 13:52:51', '2019-09-03 13:52:51');
INSERT INTO `oauth2_access_token` VALUES ('0d2e74c4f4194df5a1583a91d422934a', '8be7216f66a64f80a707f4134e10624c', 27, 2, 1, '2019-05-31 22:30:59', '2019-05-31 21:42:58', '2019-05-31 21:42:58');
INSERT INTO `oauth2_access_token` VALUES ('0d3abedc5ab145fc8dd228b55aad6959', 'a7c4a12c705f44438ed0adb7b0c2a5ea', 27, 2, 1, '2019-08-25 12:08:27', '2019-08-25 11:20:27', '2019-08-25 11:20:27');
INSERT INTO `oauth2_access_token` VALUES ('0d420e96619f4716a71dfb8a68a7948d', '1a15fe74529f4d639a17b9251205ddbb', 27, 2, 1, '2019-05-30 15:48:21', '2019-05-30 15:00:20', '2019-05-30 15:00:20');
INSERT INTO `oauth2_access_token` VALUES ('0d55e5bd13b34799849e00251926d3e5', '985ada91c2cc48608a4cf53e96baf4bb', 27, 2, 1, '2019-06-15 11:37:25', '2019-06-15 10:49:25', '2019-06-15 10:49:25');
INSERT INTO `oauth2_access_token` VALUES ('0d6134cc08574d0ba451dc7d8342b1f8', '627401feafdc4dbaa54f1fd7cb6b38c8', 27, 2, 1, '2019-06-03 10:03:40', '2019-06-03 09:15:39', '2019-06-03 09:15:39');
INSERT INTO `oauth2_access_token` VALUES ('0d6a257da38841ad9a5cae70b43c2758', '998b63729f04415fa82ec3b7a69630b8', NULL, NULL, 1, '2019-05-08 12:29:09', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0d6f101801734439902cfe94b3bd08c8', '8f119606e2c74d6cab2815e18b3a92d1', NULL, NULL, 1, '2019-03-15 12:12:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0d81c3c022e042ca8334636f94c88d12', 'e20a21dde01a441db1990f5791bbd790', 27, 2, 1, '2019-07-13 16:25:55', '2019-07-13 15:37:54', '2019-07-13 15:37:54');
INSERT INTO `oauth2_access_token` VALUES ('0d85a7ca0f1c4d39aa81319d4e200441', '971f20efb73f4d08b7d67193e90ced9e', 27, 2, 1, '2019-06-15 14:15:22', '2019-06-15 13:27:21', '2019-06-15 13:27:21');
INSERT INTO `oauth2_access_token` VALUES ('0d8c738d07074fa68ff04a0e8d7e59b7', 'd58b81f2fbc44e6d89ff48c471cfab87', 27, 2, 1, '2019-06-10 17:39:15', '2019-06-10 16:51:14', '2019-06-10 16:51:14');
INSERT INTO `oauth2_access_token` VALUES ('0da9a4858e974e64add30061b6336267', 'a8f334fbbc3f45f895dfdc870dda89d6', 27, 2, 1, '2019-07-01 17:16:58', '2019-07-01 16:28:57', '2019-07-01 16:28:57');
INSERT INTO `oauth2_access_token` VALUES ('0dbdfa711d954d6dbf8e6593445a8dd9', '2c081cb902974acc9da20279eeb927f2', 27, 2, 1, '2019-07-27 19:31:07', '2019-07-27 18:43:07', '2019-07-27 18:43:07');
INSERT INTO `oauth2_access_token` VALUES ('0dbe4ca8ddd14de7937f1543f853593f', '23b98ef65bf244ac8106276cc8f3af0f', 27, 2, 1, '2019-05-29 10:36:46', '2019-05-29 09:48:46', '2019-05-29 09:48:46');
INSERT INTO `oauth2_access_token` VALUES ('0dd47050c3164ba1a6fd5e28d1ce6234', '85734b53c75645a4b3e83159186a8eb7', 27, 2, 1, '2019-06-29 13:04:58', '2019-06-29 12:16:57', '2019-06-29 12:16:57');
INSERT INTO `oauth2_access_token` VALUES ('0dd592359311402782960d7d725dd0d5', '951557935b6c4cf988fc5fa2713b51fe', 27, 2, 1, '2019-06-13 19:23:01', '2019-06-13 18:35:00', '2019-06-13 18:35:00');
INSERT INTO `oauth2_access_token` VALUES ('0dd5c416821649d2a473f3cb1132f64c', 'd057ac9f67964c6986e874a42f79299f', 27, 2, 1, '2019-07-03 11:36:18', '2019-07-03 10:48:17', '2019-07-03 10:48:17');
INSERT INTO `oauth2_access_token` VALUES ('0df86576aa9e4a048a1cabf032fa1f76', '1b709c32ddd14ef881dfe0c4d0844d2e', 220, 1, 1, '2019-09-05 11:06:07', '2019-09-05 10:18:07', '2019-09-05 10:18:07');
INSERT INTO `oauth2_access_token` VALUES ('0dfa15025288440fb810c6925560f335', '966ff7414e9943919867d4284fd64c8d', 27, 2, 1, '2019-06-23 23:14:36', '2019-06-23 22:26:35', '2019-06-23 22:26:35');
INSERT INTO `oauth2_access_token` VALUES ('0e0cebf92c204689b959ce6888237922', '813ae37af582472d92a35b3047025da4', 27, 2, 1, '2019-08-02 19:47:30', '2019-08-02 18:59:29', '2019-08-02 18:59:29');
INSERT INTO `oauth2_access_token` VALUES ('0e20b459b1474e29ab9f8837d03e8ee7', '6a646205951340ac86fc77c93d42d325', 27, 2, 1, '2019-06-04 10:04:14', '2019-06-04 09:16:14', '2019-06-04 09:16:14');
INSERT INTO `oauth2_access_token` VALUES ('0e24ad481c5f41b9bd5f3f276da28974', '3de3b1641b5043b98fd3b17e7a28c6ec', 27, 2, 1, '2019-05-24 17:24:24', '2019-05-24 16:36:23', '2019-05-24 16:36:23');
INSERT INTO `oauth2_access_token` VALUES ('0e2cde0345a34114b436c86544e04f0f', 'e85ba9d03d694b0c8c0310ce466688f3', 27, 2, 1, '2019-05-31 17:05:28', '2019-05-31 16:17:28', '2019-05-31 16:17:28');
INSERT INTO `oauth2_access_token` VALUES ('0e2df19b01904714ae63f608e9b7dcbf', '372e4fd2d2c644f684ebde3bd93e87d9', 27, 2, 1, '2019-06-02 15:45:32', '2019-06-02 14:57:31', '2019-06-02 14:57:31');
INSERT INTO `oauth2_access_token` VALUES ('0e303b598a654a61b4e0a3604e0001d3', '31fcc1e1e0744d6a991578288ddd7159', 27, 2, 1, '2019-05-30 13:47:51', '2019-05-30 12:59:50', '2019-05-30 12:59:50');
INSERT INTO `oauth2_access_token` VALUES ('0e4e03612f41417fba06a43907c5891e', '9cc82cbba4c64acf9003fc6cb1f951f1', 27, 2, 1, '2019-09-05 22:28:15', '2019-09-05 21:40:15', '2019-09-05 21:40:15');
INSERT INTO `oauth2_access_token` VALUES ('0e8dd23d292c412aabd3749b696be68c', '7163f5aee22c4ed3a90c6325f09c0367', 27, 2, 1, '2019-06-10 11:32:37', '2019-06-10 10:44:37', '2019-06-10 10:44:37');
INSERT INTO `oauth2_access_token` VALUES ('0ea95910b9fc4416b2929862c8b47060', '12c9dba1f2d34ee1902ca026bceddf95', NULL, NULL, 0, '2019-02-26 17:50:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0ed6558af7744713bb3fd401f50f1f15', '5ff60b28a6e2430eb070b668e552092c', 27, 2, 1, '2019-08-12 12:28:03', '2019-08-12 11:40:02', '2019-08-12 11:40:02');
INSERT INTO `oauth2_access_token` VALUES ('0ee62184947340f48869422dd47b4331', '54af540b412c499faae285286838731a', 27, 2, 1, '2019-07-27 16:27:30', '2019-07-27 15:39:30', '2019-07-27 15:39:30');
INSERT INTO `oauth2_access_token` VALUES ('0f1d0267adf34cfe893a2443cd46df4a', '5c5c6f79fd1942c799732bdedc564a61', NULL, NULL, 1, '2019-05-05 16:57:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0f29a82cff814d278f4ad168c1514088', '971e55ef22f14184831c4276ddaea009', 27, 2, 1, '2019-06-11 17:01:57', '2019-06-11 16:13:57', '2019-06-11 16:13:57');
INSERT INTO `oauth2_access_token` VALUES ('0f3afdba49ba4c89b4a6e686dad90b99', 'a1d149fe8a8f485e9aa553ffa31ea691', 27, 2, 1, '2019-06-26 11:50:04', '2019-06-26 11:02:03', '2019-06-26 11:02:03');
INSERT INTO `oauth2_access_token` VALUES ('0f43b67bf769476b868d8f5752570184', '54e75b245e0b4c5eb8280eb098751553', NULL, NULL, 1, '2019-05-04 14:28:38', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0f47bb22381c4ccc8a2a4123c5771097', '5f725b59b800489d884d7b4cc5b472fd', 27, 2, 1, '2019-06-26 10:44:36', '2019-06-26 09:56:35', '2019-06-26 09:56:35');
INSERT INTO `oauth2_access_token` VALUES ('0f5832b47aea4395a81268d0210f708c', '957bd3e8da8c481b989300907ffee528', 27, 2, 1, '2019-08-14 21:50:38', '2019-08-14 21:02:37', '2019-08-14 21:02:37');
INSERT INTO `oauth2_access_token` VALUES ('0f7081fc13cd4e719871e2cd354f4282', '4d3cc2e09b304f69bfa49d75af01ab79', 27, 2, 1, '2019-07-17 14:45:12', '2019-07-17 13:57:12', '2019-07-17 13:57:12');
INSERT INTO `oauth2_access_token` VALUES ('0f7a89f32e474038b9a079a79b3e397a', '2ac88f7c940e4c6292308589f8c429c8', 27, 2, 1, '2019-06-23 03:51:36', '2019-06-23 03:03:36', '2019-06-23 03:03:36');
INSERT INTO `oauth2_access_token` VALUES ('0f9124bdfc7b43e995fbb0945ea7ccff', '6022f659a6b5421788e0ef63a178782b', 1, 2, 0, '2019-07-09 21:15:06', '2019-07-09 20:27:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('0fab051365e14890a2ee07844c526cbb', '77baeef80c8e462d894fe45001e92824', 27, 2, 1, '2019-06-04 14:38:57', '2019-06-04 13:50:57', '2019-06-04 13:50:57');
INSERT INTO `oauth2_access_token` VALUES ('0fc64128dda14d9eb33904f81b02994b', 'bf27aeba95ab44c1bef7d9b5e04a31bd', 27, 2, 1, '2019-07-30 18:05:10', '2019-07-30 17:17:10', '2019-07-30 17:17:10');
INSERT INTO `oauth2_access_token` VALUES ('0fd648e23d2a4c149e8445260d20e457', 'd352c49db6bf4a38ab880c073f648d30', 27, 2, 1, '2019-06-23 11:27:25', '2019-06-23 10:39:24', '2019-06-23 10:39:24');
INSERT INTO `oauth2_access_token` VALUES ('0fd8f5a2885243e6ac57f8e9a256f0d7', '7b3bfc280ee647a284e1b74b782247ae', 27, 2, 1, '2019-08-20 17:10:25', '2019-08-20 16:22:25', '2019-08-20 16:22:25');
INSERT INTO `oauth2_access_token` VALUES ('0fe845fa98a84e5bbefa3d181242cdd6', 'd1f49cfaf5a940df98c0e96cf1adccd0', NULL, NULL, 1, '2019-05-13 00:13:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('0ff141d7a02741dbbd1177df5248cc53', 'cd5d9043da6148758238b2e22231e244', 1, 2, 0, '2019-08-21 18:51:04', '2019-08-21 18:03:03', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('1009400f18a1461eb0cbf8ec70884662', '6d8f01ec8dbf4115a9669dc56093bdbe', 27, 2, 1, '2019-08-28 21:36:44', '2019-08-28 20:48:44', '2019-08-28 20:48:44');
INSERT INTO `oauth2_access_token` VALUES ('100e0c6dbda14c7fb5c987678bcd3a28', '0d63048d141f426fb4d28764b2a3d74f', 27, 2, 1, '2019-08-29 16:36:54', '2019-08-29 15:48:54', '2019-08-29 15:48:54');
INSERT INTO `oauth2_access_token` VALUES ('1037013f3e4e486b9177a2075840bed7', '7f1fef7f8bb145a9be933f3027732038', 27, 2, 1, '2019-05-24 23:34:13', '2019-05-24 22:46:13', '2019-05-24 22:46:13');
INSERT INTO `oauth2_access_token` VALUES ('106bb0eb7ab14d6aadfd4b9060facccb', '27b50af73d5843d4a88f616d8c351b9b', 27, 2, 1, '2019-06-05 14:56:24', '2019-06-05 14:08:23', '2019-06-05 14:08:23');
INSERT INTO `oauth2_access_token` VALUES ('108bc77502ff4ad5933bbaa719311dda', '4ad3b42e1c214fdebe122e8363c0bff4', NULL, NULL, 1, '2019-04-22 20:30:25', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('10b1b69e3c044020afe602c4378aff64', '9f3e30c0a6a74892af5f965c65f0084a', NULL, NULL, 1, '2019-05-03 01:41:20', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('10da309f0ea948d8ba1f9d5f6fe08d81', '48a2edc55c4b454ea3bc12987446861c', NULL, NULL, 1, '2019-03-16 21:06:47', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('10e342339df24d16832d58567c08203f', '97f71d12a23f4182a476e7be24d4935a', 27, 2, 1, '2019-06-20 14:56:53', '2019-06-20 14:08:53', '2019-06-20 14:08:53');
INSERT INTO `oauth2_access_token` VALUES ('10e58b074e594978816369de1107366c', 'ba1b2bfa1cd7456b9b382241e6d26488', 128, 1, 1, '2019-07-11 18:17:01', '2019-07-11 17:29:00', '2019-07-11 17:29:00');
INSERT INTO `oauth2_access_token` VALUES ('1100458aaf444c6cb6c4f330fafe8dc5', 'af0f4819d19e470b9aaa6b48f6a6a34e', 27, 2, 1, '2019-06-02 19:35:06', '2019-06-02 18:47:06', '2019-06-02 18:47:06');
INSERT INTO `oauth2_access_token` VALUES ('1118d027d0fc428c84726f5482da2791', '38d8de112a9a4e3a95645d0248c08b97', 27, 2, 1, '2019-08-15 09:37:30', '2019-08-15 08:49:30', '2019-08-15 08:49:30');
INSERT INTO `oauth2_access_token` VALUES ('11404d00520741259296ba73b18fff0c', '40537da1f859489b885d4f6d958a9297', 27, 2, 1, '2019-07-27 16:00:56', '2019-07-27 15:12:55', '2019-07-27 15:12:55');
INSERT INTO `oauth2_access_token` VALUES ('11541f996af141f19e06483a31c74853', 'ad20422b42b24faba033cf9eec70c249', 75, 1, 1, '2019-05-18 16:43:44', '2019-05-18 15:55:43', '2019-05-18 15:55:43');
INSERT INTO `oauth2_access_token` VALUES ('115804daff3148d9b88f89fd4a71c928', '2478dede628846109e80276edf6c0de6', 27, 2, 1, '2019-07-21 20:01:01', '2019-07-21 19:13:00', '2019-07-21 19:13:00');
INSERT INTO `oauth2_access_token` VALUES ('11589daa2e4d4c0ea13f7cb46a4477b8', 'ce114d521d1b4ee0a2d4ef242a5a94c1', 27, 2, 1, '2019-08-21 17:05:47', '2019-08-21 16:17:47', '2019-08-21 16:17:47');
INSERT INTO `oauth2_access_token` VALUES ('115ab7dbe3534f5083cf098deea0360d', 'eb6bddc55c22475dbae07a4a542cefa0', 27, 2, 1, '2019-05-21 22:25:30', '2019-05-21 21:37:29', '2019-05-21 21:37:29');
INSERT INTO `oauth2_access_token` VALUES ('11692d6a316a45ffa4cfcd0ea691c326', 'd6b1ae8fbb3c4c92bf753bfca1ea6f17', 27, 2, 1, '2019-07-05 22:36:50', '2019-07-05 21:48:50', '2019-07-05 21:48:50');
INSERT INTO `oauth2_access_token` VALUES ('117425f9483748159162fc0f08292cc3', '58b1e33897784ac7a61ee3e99e5a3812', 27, 2, 1, '2019-06-01 10:47:39', '2019-06-01 09:59:39', '2019-06-01 09:59:39');
INSERT INTO `oauth2_access_token` VALUES ('1190770f8489426bbf5d6fe02602f7fa', '463480e8ac8f4d9aab17e591d4a695dc', 1, 2, 0, '2019-07-04 09:55:38', '2019-07-04 09:07:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('11af476b7a6a41fcb10450c06ce36667', '95fbe95d14904ee89a83ddd47ee1ee08', NULL, NULL, 1, '2019-05-07 18:50:03', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('11cc6401f3b6470e9d2d6c2176b97e20', '1b711c38e7b44173a5a2dc23988255d1', 27, 2, 1, '2019-08-30 18:03:56', '2019-08-30 17:15:56', '2019-08-30 17:15:56');
INSERT INTO `oauth2_access_token` VALUES ('11d7cb330bf54ac38fddde510f5f0ea2', 'ebc8caeae5da4781bf5b6350340f5b2f', 27, 2, 1, '2019-06-25 11:07:57', '2019-06-25 10:19:57', '2019-06-25 10:19:57');
INSERT INTO `oauth2_access_token` VALUES ('11da5d67ca8d4f00816748ca86c84454', '22113d09591145eabce89907fd5dc749', 27, 2, 1, '2019-06-04 12:02:15', '2019-06-04 11:14:14', '2019-06-04 11:14:14');
INSERT INTO `oauth2_access_token` VALUES ('11de3367082d4fe49f34d9ddece3bab7', 'b92ba63a515c42ccb0aadd3c0f8f5bfb', 27, 2, 1, '2019-06-08 17:01:34', '2019-06-08 16:13:34', '2019-06-08 16:13:34');
INSERT INTO `oauth2_access_token` VALUES ('11e525490d594cbbabac11bb06d3298b', 'f80afe65614a41008a4e83dcfaa39687', 27, 2, 1, '2019-09-05 11:00:21', '2019-09-05 10:12:20', '2019-09-05 10:12:20');
INSERT INTO `oauth2_access_token` VALUES ('11eb01ab59754591af4b34ed79374ef5', 'efeb1af6b7774118842d2d8147d6846f', 27, 2, 1, '2019-05-29 14:21:30', '2019-05-29 13:33:30', '2019-05-29 13:33:30');
INSERT INTO `oauth2_access_token` VALUES ('11ee3b15b2ef42409eb5ea17c1c9dd7a', 'dc28571562194eb8bea7ae6adc636674', 198, 1, 1, '2019-08-27 16:40:04', '2019-08-27 15:52:04', '2019-08-27 15:52:04');
INSERT INTO `oauth2_access_token` VALUES ('1218daa07b0c4ab2abe047336e18e690', '2f70ad2a9f3b47ecac3d6cef48d6536d', NULL, NULL, 1, '2019-03-22 00:26:34', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1221e9ed164940a29caf8c5c6f59bbcc', 'f759c5032e0c4760bb082dd60b0bffaa', 27, 2, 1, '2019-08-14 09:22:09', '2019-08-14 08:34:08', '2019-08-14 08:34:08');
INSERT INTO `oauth2_access_token` VALUES ('12259e8e778d4fe0aed1bda7444e9145', '851b7018a3e247feacb7e5918fa4b920', 27, 2, 1, '2019-06-04 14:20:38', '2019-06-04 13:32:38', '2019-06-04 13:32:38');
INSERT INTO `oauth2_access_token` VALUES ('1226474c93d3410f8db3aa6455a1be6c', 'e9e5fd7f11ce4d2a95a316f77be59a84', 27, 2, 1, '2019-06-24 21:45:13', '2019-06-24 20:57:13', '2019-06-24 20:57:13');
INSERT INTO `oauth2_access_token` VALUES ('122b1e563a0144a7823a6d68a7ac2d98', 'a966a222a34c4a5a88e11cb2ab5a796f', NULL, NULL, 1, '2019-05-07 23:36:43', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('122e9301cfac458cb1e55b957b53973f', '709dff5b61fa4af2a9a83c342cd6341e', 1, 2, 0, '2019-05-21 21:49:59', '2019-05-21 21:01:58', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('123fbe4161904ab18157805f44ee2e6f', 'b3405fbce793425c8c671553c0cc3bde', 27, 2, 1, '2019-06-13 11:45:40', '2019-06-13 10:57:39', '2019-06-13 10:57:39');
INSERT INTO `oauth2_access_token` VALUES ('1257eb140e7f4dc79136749f1a3908d2', 'ed83cfd17715497ab08a1503449a5905', 27, 2, 1, '2019-05-27 00:29:26', '2019-05-26 23:41:26', '2019-05-26 23:41:26');
INSERT INTO `oauth2_access_token` VALUES ('125ac99768f74ee2bd25986814070638', '7e94cbf8d8ed4790947ce528fce27478', 137, 1, 1, '2019-06-24 15:56:54', '2019-06-24 15:08:54', '2019-06-24 15:08:54');
INSERT INTO `oauth2_access_token` VALUES ('12681038b5654170a7a4e507adc88328', '0eb21f630ffa41b5bc67e0905541d80c', 27, 2, 1, '2019-06-24 20:59:33', '2019-06-24 20:11:33', '2019-06-24 20:11:33');
INSERT INTO `oauth2_access_token` VALUES ('1281a089361a4c12be345d8cf288dab0', 'bd389be11b044916bd542bf2f5a5df79', NULL, NULL, 0, '2019-03-01 03:37:31', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('12885d5ebf674163889865f29d1a08ff', '4f75977cb4df410a9970392c9c2c7a08', NULL, NULL, 1, '2019-04-05 20:42:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('129b98fc92794db99ceb40a080bfb1d9', '9c63419b82324d75a20617b7b1e3bd45', 27, 2, 1, '2019-07-04 22:05:29', '2019-07-04 21:17:29', '2019-07-04 21:17:29');
INSERT INTO `oauth2_access_token` VALUES ('12bad3944e644b95b022482d36478073', '7237af877f344b90895fdb3b74988e87', NULL, NULL, 1, '2019-05-11 01:12:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('12bc3d3daf154f00a551fb8f24901495', 'c70ec77a1b9d40a98f2214a15b8e58d0', NULL, NULL, 1, '2019-05-05 16:51:58', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('12d4296842c549bbb3d5e43c7985a517', '24311d2bdaf546ef8591ba65496b3f28', NULL, NULL, 1, '2019-05-14 14:55:20', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('12d4f274dc6a48c1a1ff516bb348bc6c', '31232677df454c28a993dabde325346c', 27, 2, 1, '2019-06-18 11:33:53', '2019-06-18 10:45:53', '2019-06-18 10:45:53');
INSERT INTO `oauth2_access_token` VALUES ('12d83ba794ae4e4c921a07635357357f', '94a20594d72244148cc71b8af251f1d7', 27, 2, 1, '2019-08-21 15:29:28', '2019-08-21 14:41:28', '2019-08-21 14:41:28');
INSERT INTO `oauth2_access_token` VALUES ('12d9b7cf117540feb48a13af1cce06f4', 'ea1e41f2e93a471a954f9cd80324c2a7', 27, 2, 1, '2019-08-16 15:46:22', '2019-08-16 14:58:22', '2019-08-16 14:58:22');
INSERT INTO `oauth2_access_token` VALUES ('12e501a06ac44d7bbf7daba10efe0e74', '14fe18faebea4e9c83c368f7a9669972', 27, 2, 1, '2019-08-17 12:23:36', '2019-08-17 11:35:36', '2019-08-17 11:35:36');
INSERT INTO `oauth2_access_token` VALUES ('12f5b38a2e3a4880bf5207d4010f1f99', 'db490e224c344fdebaf43a8c5e85fa06', 27, 2, 1, '2019-08-23 11:24:01', '2019-08-23 10:36:00', '2019-08-23 10:36:00');
INSERT INTO `oauth2_access_token` VALUES ('131cb9c2a62d4148b8fb2ae569425d90', '9ef874708f1845c699a844d32070d799', NULL, NULL, 1, '2019-05-08 01:00:01', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1321b5799102418db7334306422177e7', 'd8be74b3a5e1448b82321984d99b9874', 1, 2, 0, '2019-08-28 14:44:26', '2019-08-28 13:56:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('135b5f545aea4713a8cd9e9cce7c89f8', '002d83ec6c574f2e9502b59ca6dffa16', 27, 2, 1, '2019-06-11 11:16:39', '2019-06-11 10:28:39', '2019-06-11 10:28:39');
INSERT INTO `oauth2_access_token` VALUES ('13a9f00cf54440ca95e053014e6090e9', '299c9203d0ba45ccba859142d143ec7b', 27, 2, 1, '2019-08-05 21:08:40', '2019-08-05 20:20:40', '2019-08-05 20:20:40');
INSERT INTO `oauth2_access_token` VALUES ('13b079b793f14b31bf6ba83438c8b6aa', '6c72de4e54f749b69f9907a89748b6a3', NULL, NULL, 1, '2019-05-08 23:55:02', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('13bd17c5e83b42a186374eeceae5120e', '3d49b661d068485089c8f1c4f900bc7e', NULL, NULL, 1, '2019-05-06 14:21:04', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('13e848cf8e344d9cb44343a73f736fab', '11530764b623476c968c5c2f373b5b91', 27, 2, 1, '2019-09-02 12:31:46', '2019-09-02 11:43:45', '2019-09-02 11:43:45');
INSERT INTO `oauth2_access_token` VALUES ('13f9748d28e2406f8d466bf33ec6cca1', 'dab00ae34d2a40739c8aeb89e9a78eb0', 1, 2, 0, '2019-06-28 16:02:01', '2019-06-28 15:14:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('140e6c8ff2b14598bfd9f25b161d98a8', '16d2b6e67b414e848e37a7a6932382a1', 27, 2, 1, '2019-06-27 11:43:18', '2019-06-27 10:55:18', '2019-06-27 10:55:18');
INSERT INTO `oauth2_access_token` VALUES ('1415e3c027bb448a9c747083865450a8', '8dfdcb82cc6a42a99094470574db1798', NULL, NULL, 1, '2019-04-29 14:53:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('143a2bd17a5d4295b48cd9ebafd2f8d2', 'dfa1f7ab800d45dc997623ffad6064eb', 27, 2, 1, '2019-08-05 10:36:02', '2019-08-05 09:48:02', '2019-08-05 09:48:02');
INSERT INTO `oauth2_access_token` VALUES ('1464cc38517a49af953ffe6b3d88aeb1', 'f5e88a3f09a34b2a8f3a94384f376a68', 193, 1, 1, '2019-08-07 14:28:20', '2019-08-07 13:40:19', '2019-08-07 13:40:19');
INSERT INTO `oauth2_access_token` VALUES ('146b166b402e43648b15ef20e9fc7458', 'cbdc99ea8557426da35d8507cdf4261d', NULL, NULL, 1, '2019-05-08 16:42:50', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1472cb32552e4ed296dbb8f834bf3958', '1120e72c4b6844aca39230390b7ff0f1', 27, 2, 1, '2019-06-06 14:07:38', '2019-06-06 13:19:37', '2019-06-06 13:19:37');
INSERT INTO `oauth2_access_token` VALUES ('14735eae96aa4920a398267368d2aa4f', 'd681818e4d944bc5865b63b699e151bd', 1, 2, 1, '2019-09-08 22:52:48', '2019-09-08 22:04:48', '2019-09-08 22:04:48');
INSERT INTO `oauth2_access_token` VALUES ('14811a4e45ab4cfeb325e3a50a71b3f4', 'b05908bc65e54c419646fc8b94deacfe', NULL, NULL, 0, '2019-02-28 11:18:33', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('148ad51f185c40219610a25077c1b40f', 'cde7243924364a78ae9d35314fe5c568', 155, 1, 1, '2019-07-03 12:03:39', '2019-07-03 11:15:39', '2019-07-03 11:15:39');
INSERT INTO `oauth2_access_token` VALUES ('14a96519d3604b1c936ddc7cf0c43dd2', '5d67c67a502c4c6283a5a04c379dedba', 94, 1, 1, '2019-06-01 08:52:59', '2019-06-01 08:04:59', '2019-06-01 08:04:59');
INSERT INTO `oauth2_access_token` VALUES ('14aee00188624036874c283ea88c1400', '378d19802a94431c8431be877543e560', 1, 2, 0, '2019-07-03 16:36:05', '2019-07-03 15:48:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('14b2d7ff20d84140b8502f630fce382d', '4898d36991964ab69e1bf8bae6d92c3c', 27, 2, 1, '2019-05-18 12:38:49', '2019-05-18 11:50:48', '2019-05-18 11:50:48');
INSERT INTO `oauth2_access_token` VALUES ('14bf6096b0694bc9946d5a2a5529f1b7', 'baa75298448b4b76a1bad4fd76a0596b', 27, 2, 1, '2019-06-04 12:36:05', '2019-06-04 11:48:04', '2019-06-04 11:48:04');
INSERT INTO `oauth2_access_token` VALUES ('14cc082b335740d085ec5865f8c24bcc', 'da8c6f986cb347178cb6cf3f2f99bdd5', NULL, NULL, 1, '2019-05-05 09:49:48', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('14d5981f84db412b8e262a676eede367', '2f6bd9bafad74db39c56b8fe3b59124c', NULL, NULL, 1, '2019-04-04 18:01:57', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('14db1f44f82f434eb08cd2dc75ad3ae8', '01df3e8b3c764a89a8df96a60c604122', NULL, NULL, 0, '2019-02-27 07:13:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('14e03bc0850346c9a64106dd6a6c2058', 'fcace0004711465e813b7b6756ddc40d', 27, 2, 1, '2019-06-03 11:13:13', '2019-06-03 10:25:12', '2019-06-03 10:25:12');
INSERT INTO `oauth2_access_token` VALUES ('14e1e4c05ca045d8afd87670ba44f70f', 'fd6fef9433ab49a5a12f597c1b7e0a50', 27, 2, 1, '2019-06-02 22:07:26', '2019-06-02 21:19:26', '2019-06-02 21:19:26');
INSERT INTO `oauth2_access_token` VALUES ('14e31d06df4845b1a8459b03d086a888', '0db26637f3274d48becc1b86d4952de6', 102, 1, 1, '2019-06-03 18:00:47', '2019-06-03 17:12:47', '2019-06-03 17:12:47');
INSERT INTO `oauth2_access_token` VALUES ('14e6e611af94493a81d202501655aee7', '1952876b03684175bf54aa4e33ebbad5', 162, 1, 1, '2019-07-09 15:23:46', '2019-07-09 14:35:46', '2019-07-09 14:35:46');
INSERT INTO `oauth2_access_token` VALUES ('15001a93a0ce4cfb860be09a2659c7e7', 'ab0a02089e214903b139d0205c77901e', 1, 2, 0, '2019-07-05 16:28:29', '2019-07-05 15:40:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('151dda67549c430a9ec4f7e24afb0467', 'efbb7638051942ccaa0c12e7b6411588', 27, 2, 1, '2019-07-23 21:30:44', '2019-07-23 20:42:43', '2019-07-23 20:42:43');
INSERT INTO `oauth2_access_token` VALUES ('15207533718e4abcb5487e57c2635f57', 'fb3505656d07496bad832dbd01c112bd', 1, 2, 0, '2019-07-05 19:26:50', '2019-07-05 18:38:50', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('1545d36b27a44e5dbbe295fa9aef0c8c', 'd93c956753c5482aa25eeaf1f4e0cfb4', 27, 2, 1, '2019-06-05 00:35:29', '2019-06-04 23:47:29', '2019-06-04 23:47:29');
INSERT INTO `oauth2_access_token` VALUES ('154a4c07ab864840b239f93a16304c80', 'c7fa2bf927794f5fb58eb1183c884ee1', NULL, NULL, 1, '2019-04-05 16:09:36', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('154feb79ef0740d998955fa5fdfcd6c0', '070a9d0f7da443f399a7a65ce5237da6', 27, 2, 1, '2019-06-24 17:18:22', '2019-06-24 16:30:22', '2019-06-24 16:30:22');
INSERT INTO `oauth2_access_token` VALUES ('155d091bab2b485ab23ca4942cb84163', '1b8a88b7abdd43998d1dadfc945cbc95', NULL, NULL, 1, '2019-05-04 19:13:04', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('157175a0e28d4817b3e0e4fa83c4ee31', 'f04d9198eb034b369d901eb79b55876c', 27, 2, 1, '2019-07-03 17:04:25', '2019-07-03 16:16:25', '2019-07-03 16:16:25');
INSERT INTO `oauth2_access_token` VALUES ('1583e3ec8ea04bea8def6bc96aaf93e4', '294bca5151c745e5bcd58fcb6a15589b', 27, 2, 1, '2019-07-04 12:16:36', '2019-07-04 11:28:36', '2019-07-04 11:28:36');
INSERT INTO `oauth2_access_token` VALUES ('1587a7dbdca04f308299909ab46cfc07', 'da1e8b0569674d19bf4f0135ca5f672e', 27, 2, 1, '2019-07-10 10:23:56', '2019-07-10 09:35:55', '2019-07-10 09:35:55');
INSERT INTO `oauth2_access_token` VALUES ('158ec7efa047448aa9b3c4984188be6c', 'be1d0a3a906d4c9b8bfbdb65496f9ac4', 27, 2, 1, '2019-08-27 23:36:35', '2019-08-27 22:48:35', '2019-08-27 22:48:35');
INSERT INTO `oauth2_access_token` VALUES ('159af89195334124a9b7ace78c00b7d3', '5bd5faba15844e98b5d271c8d79d7e5c', 27, 2, 1, '2019-06-03 18:44:29', '2019-06-03 17:56:28', '2019-06-03 17:56:28');
INSERT INTO `oauth2_access_token` VALUES ('15a1890cc64e44b1995d7389dbb7d167', 'cee09ead1a3842b69d68db3b8b9ebb04', 27, 2, 1, '2019-08-04 08:37:17', '2019-08-04 07:49:16', '2019-08-04 07:49:16');
INSERT INTO `oauth2_access_token` VALUES ('15ae5464e89d479abaacc654d1f98dd3', '7435d30601fb41349ad0a9dc4b2a3da4', 27, 2, 1, '2019-06-01 14:00:15', '2019-06-01 13:12:15', '2019-06-01 13:12:15');
INSERT INTO `oauth2_access_token` VALUES ('15b2c0aa7dbb446da3f2e3243486c345', '299cde2738924b0a8cc272be7e7e7173', 27, 2, 1, '2019-06-13 12:25:43', '2019-06-13 11:37:42', '2019-06-13 11:37:42');
INSERT INTO `oauth2_access_token` VALUES ('15b78b9673444c64a437a368524ffe5e', '62bd432602314147937fced5e0f2f523', NULL, NULL, 1, '2019-05-07 19:04:23', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('15b963099125472aa04244ca955d3e67', '88e5091dadf44f71b3d22a43adff551e', 27, 2, 1, '2019-06-05 11:35:07', '2019-06-05 10:47:06', '2019-06-05 10:47:06');
INSERT INTO `oauth2_access_token` VALUES ('15ba86a3782f4265a948ded7b2ebb6d9', 'f16f6c6542ff446c811c5c9f5f1acf90', NULL, NULL, 1, '2019-03-26 18:29:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('15bc30f4c17c4449a8fc7d938ae1bf57', '81384f4dde5b4d2cadcb2456aadf9fc0', NULL, NULL, 1, '2019-05-13 00:08:50', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('15bc78a362f14a1f81fa92bbbdfa38e9', '4d9d585f3e534dee8bc2026ef48902c3', 27, 2, 1, '2019-06-16 23:34:01', '2019-06-16 22:46:01', '2019-06-16 22:46:01');
INSERT INTO `oauth2_access_token` VALUES ('15e1801425f54c8b820b8acc4c5a9bbd', '602dd95636fa4f73b76f3a793403ec59', 27, 2, 1, '2019-06-02 19:34:02', '2019-06-02 18:46:01', '2019-06-02 18:46:01');
INSERT INTO `oauth2_access_token` VALUES ('15e91a0595434034b8dafe03aabdb2e4', 'ad7a45ad2a784cfda293ae268745d1ef', 27, 2, 1, '2019-06-15 19:00:24', '2019-06-15 18:12:23', '2019-06-15 18:12:23');
INSERT INTO `oauth2_access_token` VALUES ('160018e0c1714146839f67721754134e', '10a378c7e71c4049b8c792976f01dea8', 27, 2, 1, '2019-07-28 14:03:30', '2019-07-28 13:15:30', '2019-07-28 13:15:30');
INSERT INTO `oauth2_access_token` VALUES ('1601948b630f479195252596fb2f8b65', 'b77e4088d81649c69c3200c683456237', NULL, NULL, 1, '2019-05-06 13:50:48', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('160338603ec14261ba160f1a876a6500', '3146e6af937c4611a8a6a6e5c48a0a12', 27, 2, 1, '2019-06-19 16:10:46', '2019-06-19 15:22:46', '2019-06-19 15:22:46');
INSERT INTO `oauth2_access_token` VALUES ('160aba01c910460c890c6722bc274a01', 'f6113ae6011b4d0d90258f5473aa7c6d', 27, 2, 1, '2019-08-23 17:00:30', '2019-08-23 16:12:30', '2019-08-23 16:12:30');
INSERT INTO `oauth2_access_token` VALUES ('16159433ac7d4c6282d6add87121511a', '865f9a87df2647709e85eaf5890efc81', 27, 2, 1, '2019-07-10 23:52:08', '2019-07-10 23:04:07', '2019-07-10 23:04:07');
INSERT INTO `oauth2_access_token` VALUES ('1619a4837bfb4204a1161740fccaedde', '4733768481844c04bbe4825c0f69957e', 27, 2, 1, '2019-06-20 14:43:31', '2019-06-20 13:55:30', '2019-06-20 13:55:30');
INSERT INTO `oauth2_access_token` VALUES ('161c5a0c77b540bd8c2cdf33fa08a2c7', 'aaab312210514bd79e7f4f1784037531', 27, 2, 1, '2019-07-06 10:25:00', '2019-07-06 09:37:00', '2019-07-06 09:37:00');
INSERT INTO `oauth2_access_token` VALUES ('161eb82e109144059931d8bd65b12571', 'aab3d359eb6e4e2bb1ab31f05d0de6af', 27, 2, 1, '2019-06-20 11:31:07', '2019-06-20 10:43:06', '2019-06-20 10:43:06');
INSERT INTO `oauth2_access_token` VALUES ('16383486a34c421f8c6d67c32fbbb345', 'f5583cb31d8241c8bd3ee23943a1fd7f', 27, 2, 1, '2019-08-28 12:29:35', '2019-08-28 11:41:35', '2019-08-28 11:41:35');
INSERT INTO `oauth2_access_token` VALUES ('163eb22ce46d4250ad80f0d751ef9fad', '2280a6ea23154c5db0c143efc56529bb', 27, 2, 1, '2019-07-23 12:05:09', '2019-07-23 11:17:09', '2019-07-23 11:17:09');
INSERT INTO `oauth2_access_token` VALUES ('16473be40b70404bb167fb97bd1e7c97', '7b4e477b021b4335bf12351f21355e0b', 27, 2, 1, '2019-07-25 11:24:33', '2019-07-25 10:36:33', '2019-07-25 10:36:33');
INSERT INTO `oauth2_access_token` VALUES ('1651c120531f4fa88691abd824b76731', '7aad869f3a3e427aa8553967c4caa229', 27, 2, 1, '2019-08-21 21:08:40', '2019-08-21 20:20:40', '2019-08-21 20:20:40');
INSERT INTO `oauth2_access_token` VALUES ('165e0a6d7b2e4b13ae5e1d125879da99', 'f78785550ca547aaa9f515c15befd36e', 27, 2, 1, '2019-09-02 20:44:27', '2019-09-02 19:56:27', '2019-09-02 19:56:27');
INSERT INTO `oauth2_access_token` VALUES ('169b6a0801b743a1af0fe0cfc4061c60', '3b035704b983491681ffa93a76c9e66a', 27, 2, 1, '2019-05-17 23:59:18', '2019-05-17 23:11:18', '2019-05-17 23:11:18');
INSERT INTO `oauth2_access_token` VALUES ('16a40eca17c24a9c9a8f6ab48fcc2f41', 'ebe0e86557274a6da966372886c9c78f', 27, 2, 1, '2019-07-31 13:33:28', '2019-07-31 12:45:27', '2019-07-31 12:45:27');
INSERT INTO `oauth2_access_token` VALUES ('16e0db3fe1ae487d9ff2be16e45b42fc', 'd42fe0dacc3c4f2f92fb35672e1f38d8', 73, 1, 1, '2019-05-17 18:39:48', '2019-05-17 17:51:47', '2019-05-17 17:51:47');
INSERT INTO `oauth2_access_token` VALUES ('173136a085574442806823780dd737ad', '2497185ba9874e9fa66178e1b675f45c', NULL, NULL, 0, '2019-03-03 22:59:08', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1736028d4d714488b014fd6aad9f8965', '96889d39624f437aa304fc95e08e1668', 27, 2, 1, '2019-06-17 11:27:53', '2019-06-17 10:39:53', '2019-06-17 10:39:53');
INSERT INTO `oauth2_access_token` VALUES ('17540afc84ca451bada2e5e88d8827c4', '97bad996f74e451d903db5f0ddc3d04d', 27, 2, 1, '2019-07-21 18:20:56', '2019-07-21 17:32:56', '2019-07-21 17:32:56');
INSERT INTO `oauth2_access_token` VALUES ('176441491b7d44fa81e8e40da535f9ad', '53e70c3204424585b5457523859cab2f', 5, 2, 1, '2019-06-03 17:06:37', '2019-06-03 16:18:36', '2019-06-03 16:18:36');
INSERT INTO `oauth2_access_token` VALUES ('176bef8b609f4e2ebcd908461efe972c', 'd33454eb13a44396b1230b0602cf2785', 27, 2, 1, '2019-07-18 14:41:38', '2019-07-18 13:53:37', '2019-07-18 13:53:37');
INSERT INTO `oauth2_access_token` VALUES ('1775275264d649c68380d103acf51992', '435f2c483a3f44afb8dcc1c50e976d7d', 191, 1, 1, '2019-08-02 20:16:21', '2019-08-02 19:28:21', '2019-08-02 19:28:21');
INSERT INTO `oauth2_access_token` VALUES ('1788fb9561544d5c870f5e6e21dd88cf', 'c06fe360c3a240f3affdc31ae5c0d290', 27, 2, 1, '2019-07-25 17:49:31', '2019-07-25 17:01:31', '2019-07-25 17:01:31');
INSERT INTO `oauth2_access_token` VALUES ('179f0f637d91452b9d52655d0edc75be', '1aec688d9d6a4d43ad1cb7f522d460ce', 27, 2, 1, '2019-07-26 15:00:31', '2019-07-26 14:12:31', '2019-07-26 14:12:31');
INSERT INTO `oauth2_access_token` VALUES ('17a1e437f514459c963c87b0f12a00f7', '157ef76f1b434338a8ee66822b425183', 27, 2, 1, '2019-05-20 14:35:58', '2019-05-20 13:47:58', '2019-05-20 13:47:58');
INSERT INTO `oauth2_access_token` VALUES ('17a547dab1a14b29b3b5e07b78700cc1', '9f1fe1bcd5c94941afabc5bc76e06d61', 1, 2, 0, '2019-05-29 23:56:32', '2019-05-29 23:08:32', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('17a64969bda240f98433fb7b0d9f948b', 'd50c7700b0924aa789f8dd40cee640b0', 27, 2, 1, '2019-06-18 14:53:41', '2019-06-18 14:05:40', '2019-06-18 14:05:40');
INSERT INTO `oauth2_access_token` VALUES ('17a93b6eaa57406fafa2ccd83599382d', '3371f73a995e4269a8cdd688fa8c66c8', 27, 2, 1, '2019-07-31 17:30:09', '2019-07-31 16:42:09', '2019-07-31 16:42:09');
INSERT INTO `oauth2_access_token` VALUES ('17b6b8ba9fcb4d8e95ab75bf47173cc8', 'ba6db75b25e24baea14602786b5cd250', 27, 2, 1, '2019-08-26 11:19:57', '2019-08-26 10:31:56', '2019-08-26 10:31:56');
INSERT INTO `oauth2_access_token` VALUES ('17f7c2fb485c463f97864243b25864b1', '1bfdae4e56d64449ae52abfc1d1936ec', 27, 2, 1, '2019-06-20 12:14:15', '2019-06-20 11:26:15', '2019-06-20 11:26:15');
INSERT INTO `oauth2_access_token` VALUES ('18147e40127a464693f31ac0c14dca20', 'b96facf988f0477ba1a369a0caf57549', 27, 2, 1, '2019-06-01 12:07:09', '2019-06-01 11:19:09', '2019-06-01 11:19:09');
INSERT INTO `oauth2_access_token` VALUES ('184a2d76a0b6446684c2ff85972bd191', 'cc8a0ba4c7aa41a2ae081c6323540f61', 27, 2, 1, '2019-09-06 15:29:52', '2019-09-06 14:41:52', '2019-09-06 14:41:52');
INSERT INTO `oauth2_access_token` VALUES ('18532e5ba49a444ba08a4f4876b99103', 'a2ccb7308dc145bc90988c0bfd93e09f', 27, 2, 1, '2019-08-26 23:40:52', '2019-08-26 22:52:51', '2019-08-26 22:52:51');
INSERT INTO `oauth2_access_token` VALUES ('185d5025c6d84bc4802b5cfeb78098d8', '6de21eb16bb64e97b0326eac9d156d21', 1, 2, 0, '2019-07-21 14:28:10', '2019-07-21 13:40:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('186ac4a701c144b2b8835a621c1abb54', '828eaca50c8c4e67875a1488b235d45a', 147, 1, 1, '2019-07-09 21:13:21', '2019-07-09 20:25:21', '2019-07-09 20:25:21');
INSERT INTO `oauth2_access_token` VALUES ('186c14d7cfd64386bb21c746ff08b120', 'cff2ee7d6b2745919dd759a8b9808f06', 95, 1, 1, '2019-06-01 10:57:17', '2019-06-01 10:09:16', '2019-06-01 10:09:16');
INSERT INTO `oauth2_access_token` VALUES ('186c606e931948e4a2c27897994ad70a', 'cccacecbe359453c933f1cf451b8ec55', NULL, NULL, 1, '2019-05-08 02:04:05', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('187309a28e84413993c0356b91689460', '2957dd39574a418aaedd0df53b41602e', 27, 2, 1, '2019-06-14 23:34:59', '2019-06-14 22:46:59', '2019-06-14 22:46:59');
INSERT INTO `oauth2_access_token` VALUES ('189e2f72b460421e99f34f7738e970c4', 'a8bf0346f4014b6297a51a48cebd53dc', NULL, NULL, 1, '2019-04-26 11:53:01', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('18ab36dec1ce474e9987e7c8d4cd1574', 'f6f97fc7ab9749c29ef302754625b6b7', 27, 2, 1, '2019-05-17 22:39:42', '2019-05-17 21:51:41', '2019-05-17 21:51:41');
INSERT INTO `oauth2_access_token` VALUES ('18c7459fe3894917999154ff9a44cb0c', '6435e0d739014b7f912a80c446e9c263', 1, 2, 0, '2019-06-23 23:52:13', '2019-06-23 23:04:13', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('18d340b07ed64e1498214950b47ebfb3', '74a2a94e3e074650abee1d6c53a824f9', NULL, NULL, 1, '2019-04-22 19:22:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('18d56d45fe82482890fc86e2947669f3', 'd3c6f8738a2c4463a2d24cc85ac79d01', 27, 2, 1, '2019-07-26 12:48:02', '2019-07-26 12:00:01', '2019-07-26 12:00:01');
INSERT INTO `oauth2_access_token` VALUES ('18e2bed288884d43bcd698ae3642e9dc', '4bff073b260245ee9b07091d817e9eb1', 27, 2, 1, '2019-05-26 22:48:51', '2019-05-26 22:00:50', '2019-05-26 22:00:50');
INSERT INTO `oauth2_access_token` VALUES ('18ef7fb6bb3040f397d688cf4d083385', '51f9d6a68f5d4b38afb04e5ad5f5132c', 27, 2, 1, '2019-08-11 17:01:38', '2019-08-11 16:13:38', '2019-08-11 16:13:38');
INSERT INTO `oauth2_access_token` VALUES ('18f517d2ce664c29b274c75d1f87a28d', 'a73da9612c904af6a97f679c4a744467', 129, 1, 1, '2019-06-20 08:34:15', '2019-06-20 07:46:14', '2019-06-20 07:46:14');
INSERT INTO `oauth2_access_token` VALUES ('18f85e8a77014fac8c9003cb33a767c1', '31326daab26247179c4b71d7a4dd9023', 1, 2, 0, '2019-06-24 12:02:21', '2019-06-24 11:14:20', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('18f978ebfb794eb08c2031b79f9e66a6', 'f37351e34bae4529a32554c0ad6bab57', 211, 1, 1, '2019-08-24 07:42:18', '2019-08-24 06:54:18', '2019-08-24 06:54:18');
INSERT INTO `oauth2_access_token` VALUES ('18fa8108ecc3482d92a3b99ae5d11790', '718b5c9f81c64209b0845910ddb5724c', 27, 2, 1, '2019-05-30 18:11:29', '2019-05-30 17:23:29', '2019-05-30 17:23:29');
INSERT INTO `oauth2_access_token` VALUES ('18fd93aa28f845b9a71548eb33302fc0', 'be37d1fdae064ffcb2d44bc01a522fa8', 27, 2, 1, '2019-06-01 00:21:01', '2019-05-31 23:33:01', '2019-05-31 23:33:01');
INSERT INTO `oauth2_access_token` VALUES ('19098c98cfca47529b0f1d7f10f6be0e', 'd5c7cf565a0e4b4ca00bdd4da488660d', 27, 2, 1, '2019-06-19 22:24:22', '2019-06-19 21:36:21', '2019-06-19 21:36:21');
INSERT INTO `oauth2_access_token` VALUES ('190cda52e3f649c4840b31bbf0083437', 'd68e23332ab94e408deab6af2d32284d', 27, 2, 1, '2019-06-01 00:04:07', '2019-05-31 23:16:07', '2019-05-31 23:16:07');
INSERT INTO `oauth2_access_token` VALUES ('192784ff9ea24be0b2f70a55e4ace3a1', '8931a209201240109bea2c5c9a6a8c08', 27, 2, 1, '2019-07-19 14:32:19', '2019-07-19 13:44:19', '2019-07-19 13:44:19');
INSERT INTO `oauth2_access_token` VALUES ('19331bb9472a4777bf47657a7b9ece57', 'f299d65230eb41f0862ca4de49a8976a', 27, 2, 1, '2019-07-19 15:57:17', '2019-07-19 15:09:17', '2019-07-19 15:09:17');
INSERT INTO `oauth2_access_token` VALUES ('194b5eec13164bd4a79fbc16f0df6a22', 'e4e1bf4e19234704a60a6695fc8bc44c', 27, 2, 1, '2019-06-13 10:38:26', '2019-06-13 09:50:26', '2019-06-13 09:50:26');
INSERT INTO `oauth2_access_token` VALUES ('194f2a84c11c41fca5d6ceaba258a4d1', '19c242494ed24029a6bec772f247be95', 27, 2, 1, '2019-07-10 23:23:26', '2019-07-10 22:35:25', '2019-07-10 22:35:25');
INSERT INTO `oauth2_access_token` VALUES ('195dfbbaf4654e2b96a661802cfc203e', '770bbc3b1f384deb80b68353f431b281', 27, 2, 1, '2019-07-04 16:04:23', '2019-07-04 15:16:23', '2019-07-04 15:16:23');
INSERT INTO `oauth2_access_token` VALUES ('19785063a27e4dbab821b52e4484d1d9', 'd002797a15be4953b7fa892d4fe5009a', 27, 2, 1, '2019-06-23 18:03:57', '2019-06-23 17:15:56', '2019-06-23 17:15:56');
INSERT INTO `oauth2_access_token` VALUES ('197f4178271d444aafcc6dad1abb8c1b', 'd7a5330d67f04908b19a576daf6295aa', 113, 1, 1, '2019-06-08 23:08:00', '2019-06-08 22:20:00', '2019-06-08 22:20:00');
INSERT INTO `oauth2_access_token` VALUES ('19a3e6f8267b406aa663433e338f645d', '4ae17651713c4ba0a01ddc908738e996', 27, 2, 1, '2019-07-23 16:47:32', '2019-07-23 15:59:32', '2019-07-23 15:59:32');
INSERT INTO `oauth2_access_token` VALUES ('19aa3b3285354cb286cddff76d10d4c6', '02be0bb4fa3245798acadd25c98c7e4f', 168, 1, 1, '2019-07-11 11:55:21', '2019-07-11 11:07:20', '2019-07-11 11:07:20');
INSERT INTO `oauth2_access_token` VALUES ('19c2cd73f72a4bf49d488b37dcd53a2d', 'f6d1ea2cd9ad41ee88fe439df03c553b', 27, 2, 1, '2019-06-17 17:43:07', '2019-06-17 16:55:06', '2019-06-17 16:55:06');
INSERT INTO `oauth2_access_token` VALUES ('19cf7128251a4d0a8e86f5fca737175d', 'f50617d52473483f9b0192a70d5ce9ed', NULL, NULL, 1, '2019-03-19 04:57:49', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('19fc6926879d49d99ddaf04293527048', 'c4a94092756241cbaa84b265e7148adb', 27, 2, 1, '2019-07-25 01:32:11', '2019-07-25 00:44:10', '2019-07-25 00:44:10');
INSERT INTO `oauth2_access_token` VALUES ('1a0a2b0404b24638865d4c9803552bc0', '29648d9b5f104f16bbbeb1dbfed38aef', 27, 2, 1, '2019-06-09 00:12:36', '2019-06-08 23:24:36', '2019-06-08 23:24:36');
INSERT INTO `oauth2_access_token` VALUES ('1a14cddad52a44a0bc26a2e6058df6f1', '38c7af1f8b59409b8cecf9df1c5333e0', 27, 2, 1, '2019-06-27 16:05:51', '2019-06-27 15:17:50', '2019-06-27 15:17:50');
INSERT INTO `oauth2_access_token` VALUES ('1a2b0de70e694ee28fa60166180b24ff', '8bf0b8d32b55439a8cd3def8558cfde0', 27, 2, 1, '2019-06-09 22:19:26', '2019-06-09 21:31:26', '2019-06-09 21:31:26');
INSERT INTO `oauth2_access_token` VALUES ('1a42e4a618d74ef4a84cffcc7c3f0694', 'd9409a4477314a9fb9ab82dd4fb39eb6', 27, 2, 1, '2019-08-28 14:27:00', '2019-08-28 13:39:00', '2019-08-28 13:39:00');
INSERT INTO `oauth2_access_token` VALUES ('1a512fccb8864dd9a0d1d85e01026d35', '7d279ec33c504bfba51f5f7163fbcd2e', 94, 1, 1, '2019-06-01 08:52:59', '2019-06-01 08:04:59', '2019-06-01 08:04:59');
INSERT INTO `oauth2_access_token` VALUES ('1a542903ba0644c48bdad971a27c2d3b', '7797e93c571d4fa79f544f35235dedad', NULL, NULL, 1, '2019-05-06 14:41:08', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1a549d953ce54f8f9d5634bc6cdee9c1', 'd2e3342fb4a8461ebcdea3848928471e', 27, 2, 1, '2019-06-07 12:38:06', '2019-06-07 11:50:05', '2019-06-07 11:50:05');
INSERT INTO `oauth2_access_token` VALUES ('1a7ff44bb83a462f97d4ba62bff81558', '3dc4387c632842f1aae8de2db6be56ed', 27, 2, 1, '2019-07-16 11:52:50', '2019-07-16 11:04:50', '2019-07-16 11:04:50');
INSERT INTO `oauth2_access_token` VALUES ('1a8d6c615e694a85b564a659df0a2496', '81e7f36a416a464f9e12b5727a95f2d5', 1, 2, 0, '2019-07-03 10:56:33', '2019-07-03 10:08:33', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('1a90b0b228da47949a962b38e1b2d414', '05dbb8c1b3cd40a3a93e7cfbb5a696c7', 27, 2, 1, '2019-07-09 15:08:03', '2019-07-09 14:20:03', '2019-07-09 14:20:03');
INSERT INTO `oauth2_access_token` VALUES ('1a917d39c53b4e8389501f86964a9900', '48355ff143224b3b9d545805ca67bac3', NULL, NULL, 1, '2019-04-22 20:34:02', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1aa22ad908964d93903368c2c08be687', 'e4a0b9bb25cc484199f8eacf0989c38d', 27, 2, 1, '2019-07-12 00:35:15', '2019-07-11 23:47:14', '2019-07-11 23:47:14');
INSERT INTO `oauth2_access_token` VALUES ('1aa6da58953f4facb04f11bb794a60a0', 'c0b1430e2cb24475827d734dd4ddb777', 1, 2, 0, '2019-05-17 15:10:52', '2019-05-17 14:22:52', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('1aab2182683f49a99e618cf2182464b6', '5d069a3b37ce4a5abd30696eea8a4946', NULL, NULL, 1, '2019-04-16 13:58:26', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1abbcd0944624c7884706fe3c24e9e67', '971f588c713e4b2aa435f1a72388a6aa', NULL, NULL, 1, '2019-04-22 19:32:08', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1acbd4733dc24f2993de414d4b65862f', 'c7046757d5ad4411887e898722ad4af5', NULL, NULL, 1, '2019-05-04 22:06:52', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1acf63e2a1bc4901b79d179511e163ec', 'a4dda1c8b48b4c03bd8e43edcc5fdc45', NULL, NULL, 1, '2019-04-24 17:32:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1ad165fe56974b89868a4f43a190fb74', '8c8ef34f45744b91b32cebf8a476269e', 27, 2, 1, '2019-06-02 19:34:15', '2019-06-02 18:46:14', '2019-06-02 18:46:14');
INSERT INTO `oauth2_access_token` VALUES ('1ad61abab63a4176b26089439d60a371', '18d98fc4e8f544d3a283ef5757f71296', 27, 2, 1, '2019-07-05 15:50:27', '2019-07-05 15:02:27', '2019-07-05 15:02:27');
INSERT INTO `oauth2_access_token` VALUES ('1aea8db3fe034be8a74ee399c95aae6d', 'f304eab2a2664ee1841d9a92eecc24c9', 27, 2, 1, '2019-06-21 22:41:08', '2019-06-21 21:53:07', '2019-06-21 21:53:07');
INSERT INTO `oauth2_access_token` VALUES ('1b0a9e6d160b440292bbdc141b0a0f6c', 'e237ea58cf594547a1e0731cf843b453', 27, 2, 1, '2019-05-23 15:15:03', '2019-05-23 14:27:03', '2019-05-23 14:27:03');
INSERT INTO `oauth2_access_token` VALUES ('1b12f6ba56aa422cbb7d6eec17f404aa', 'd03bb4f2f8a948c781214b5012a1aa9e', 27, 2, 1, '2019-08-16 17:05:04', '2019-08-16 16:17:04', '2019-08-16 16:17:04');
INSERT INTO `oauth2_access_token` VALUES ('1b1c0088929b4ed9894121ec43819dc8', 'fda99c255b2a4b2994d46731cdbd8470', 27, 2, 1, '2019-08-17 23:33:37', '2019-08-17 22:45:37', '2019-08-17 22:45:37');
INSERT INTO `oauth2_access_token` VALUES ('1b36dcc8bcc54f11b69aa60fe5c30b61', '90f77420470e4840a02d3470b8399d06', 27, 2, 1, '2019-06-28 18:02:24', '2019-06-28 17:14:24', '2019-06-28 17:14:24');
INSERT INTO `oauth2_access_token` VALUES ('1b8ae1dd733f4c6db838fcc0deb622d3', '125b1ffd588f40ab87430cedf5ef516b', 27, 2, 1, '2019-07-11 15:06:49', '2019-07-11 14:18:49', '2019-07-11 14:18:49');
INSERT INTO `oauth2_access_token` VALUES ('1b9412984ce54dd6a6b1e49818923eb2', 'ea452ca45b414a65bd23476f4e82f298', 27, 2, 1, '2019-06-21 17:51:02', '2019-06-21 17:03:02', '2019-06-21 17:03:02');
INSERT INTO `oauth2_access_token` VALUES ('1b98fff4f99f4b7789ec01e02b0bc39c', '548dd7de6425481c8b20255edfad950c', 27, 2, 1, '2019-08-01 18:38:17', '2019-08-01 17:50:17', '2019-08-01 17:50:17');
INSERT INTO `oauth2_access_token` VALUES ('1b9c39d9cca1475a9bfaed57a194e31d', '57e059f5abf84f71b3c7cf527586d50c', 27, 2, 1, '2019-06-12 14:48:55', '2019-06-12 14:00:54', '2019-06-12 14:00:54');
INSERT INTO `oauth2_access_token` VALUES ('1bb01107c9094288a8af5157941e279b', '496e8941426d40698c654e73ead755a5', 27, 2, 1, '2019-08-26 15:16:04', '2019-08-26 14:28:03', '2019-08-26 14:28:03');
INSERT INTO `oauth2_access_token` VALUES ('1bb1790a8a3d4f459c36056cf40d2771', '0a7e1922fdde4b5789053630d612303e', 27, 2, 1, '2019-06-04 18:35:31', '2019-06-04 17:47:30', '2019-06-04 17:47:30');
INSERT INTO `oauth2_access_token` VALUES ('1bc4ba5a13e2432f818e0e5f32534a9f', '421be6a7ea4b4f30b6de5a2e1b4a53bb', 1, 2, 0, '2019-06-09 12:58:12', '2019-06-09 12:10:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('1bd7e9b8252d440e91a2bbff88260d02', 'ffa271c12b0b4516a0a2c45e109d9a78', 27, 2, 1, '2019-06-10 16:54:04', '2019-06-10 16:06:04', '2019-06-10 16:06:04');
INSERT INTO `oauth2_access_token` VALUES ('1c0de06eabb74f8cb73a984e907d450f', '402db7a9d25146ef8f80c2732eac0d74', 27, 2, 1, '2019-07-12 17:37:28', '2019-07-12 16:49:27', '2019-07-12 16:49:27');
INSERT INTO `oauth2_access_token` VALUES ('1c110035818d4ee2b4fc486f372f1bc7', 'de388e2cd14341c88abab5e106bb160b', 27, 2, 1, '2019-06-03 10:03:56', '2019-06-03 09:15:56', '2019-06-03 09:15:56');
INSERT INTO `oauth2_access_token` VALUES ('1c1824d2e15e44a0af97b462b9e1f284', 'f73271b6a4804653ae12dc0f3d2b6aea', NULL, NULL, 1, '2019-05-13 17:21:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1c1b9dfd0c6649a8869ade397669a1aa', '3bc984ee840b4deebea3ec4dc3ab9f19', 27, 2, 1, '2019-06-03 13:26:54', '2019-06-03 12:38:54', '2019-06-03 12:38:54');
INSERT INTO `oauth2_access_token` VALUES ('1c23603c3dae4243aa29da8ed8432213', 'b6992eb011db4d5fa24758e6f4c5be59', 27, 2, 1, '2019-06-14 23:50:19', '2019-06-14 23:02:18', '2019-06-14 23:02:18');
INSERT INTO `oauth2_access_token` VALUES ('1c25b384f13244e7baadf7f4b4514c36', '31eb9b5fc5fc4c27aa4856324c5b9f93', 27, 2, 1, '2019-07-31 15:37:17', '2019-07-31 14:49:16', '2019-07-31 14:49:16');
INSERT INTO `oauth2_access_token` VALUES ('1c38c7b4d5ae4dc88434d5950b40a8e5', '0ff9a67c575a41ffa2acb7b02f5c5c69', 27, 2, 1, '2019-08-12 16:48:18', '2019-08-12 16:00:18', '2019-08-12 16:00:18');
INSERT INTO `oauth2_access_token` VALUES ('1c3d39bd1e62414195fa719e548ebb6e', 'bb11d92976204127a390f642341ad093', NULL, NULL, 1, '2019-05-10 00:33:48', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1c5a0c67d3cd4cf7a00b78e2ba889ae9', '47bd2082e43a4edf800cd33542c3d7e8', NULL, NULL, 1, '2019-04-24 14:50:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1c7a305076724c83b71b3ba42acd6879', 'a1b83a379380420995cdb6f3bc062912', NULL, NULL, 1, '2019-03-12 23:06:30', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1c7b6514f3144a1bbcbf3fdd3430cfd0', '85317c73807848e3a031dbc9280afa68', 27, 2, 1, '2019-06-28 14:40:46', '2019-06-28 13:52:46', '2019-06-28 13:52:46');
INSERT INTO `oauth2_access_token` VALUES ('1c84251a3c464dbaa14c2bcff5b77dda', '60daec63b81e43c58d80999c9c40d55c', NULL, NULL, 1, '2019-03-12 20:30:32', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1cb251007ebf4e29a0b6f21cdadf6e00', 'e253de09c4924603bda20c43270c3971', 27, 2, 1, '2019-05-18 19:28:55', '2019-05-18 18:40:54', '2019-05-18 18:40:54');
INSERT INTO `oauth2_access_token` VALUES ('1cb3b3675af14b029663a616dc7563c5', '933b5e4d8cc44f34ad9609c4042bc846', 27, 2, 1, '2019-08-13 05:01:01', '2019-08-13 04:13:01', '2019-08-13 04:13:01');
INSERT INTO `oauth2_access_token` VALUES ('1cdb44b1d517433e8f0a54271b9801de', '6eb6c02bfb464190aaf4edb45933b63d', 27, 2, 1, '2019-06-04 17:26:12', '2019-06-04 16:38:12', '2019-06-04 16:38:12');
INSERT INTO `oauth2_access_token` VALUES ('1cea341436294d4cb004a435d0a11748', '675f8839e92c4c958d81db5a3cc6f056', 27, 2, 1, '2019-06-28 15:52:50', '2019-06-28 15:04:49', '2019-06-28 15:04:49');
INSERT INTO `oauth2_access_token` VALUES ('1cf4085ae9084d28b7de81709cb36bcf', '99990a0da40a4455882cae5f87294b13', 27, 2, 1, '2019-07-17 21:25:54', '2019-07-17 20:37:53', '2019-07-17 20:37:53');
INSERT INTO `oauth2_access_token` VALUES ('1cfdad2639d34c1d8c4de801e2d8a154', '1916f8bf70694dafb2d6f5fcf0979632', 27, 2, 1, '2019-08-20 10:20:05', '2019-08-20 09:32:04', '2019-08-20 09:32:04');
INSERT INTO `oauth2_access_token` VALUES ('1d0a6d48f97e47a898f16f046e88c1fa', 'c3382d92db0d4d9fb2dd34a9dea1faab', 27, 2, 1, '2019-06-13 11:53:49', '2019-06-13 11:05:49', '2019-06-13 11:05:49');
INSERT INTO `oauth2_access_token` VALUES ('1d113fa52ccd44afa74914c8e21eb7a7', 'f1164dc5ada847598364bca7447926dc', 27, 2, 1, '2019-06-24 17:58:46', '2019-06-24 17:10:45', '2019-06-24 17:10:45');
INSERT INTO `oauth2_access_token` VALUES ('1d143168c5304c3992486a13635c8d28', 'aa749c3690c149698f7b0fbe858389a2', 27, 2, 1, '2019-06-26 23:35:38', '2019-06-26 22:47:38', '2019-06-26 22:47:38');
INSERT INTO `oauth2_access_token` VALUES ('1d2a9152be8346a494dfa91e18d1458b', 'af07b7bc3a2447c7b090c0c72cf15883', NULL, NULL, 1, '2019-05-12 09:29:10', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1d369511fb5b40adbc942f395d3618bd', 'd68e84002c1041ef952dd3bfcdbf1342', NULL, NULL, 1, '2019-05-09 17:39:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1d432995dc2745808b2be8b660b05f5b', '6f08d53d78b24f5b92a586803ba7a1e6', NULL, NULL, 1, '2019-03-10 07:25:43', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1d45d23e9fe147ec83609c591e1939c6', '45e65cc991294ca4a7f85276295495eb', 27, 2, 1, '2019-08-12 16:55:19', '2019-08-12 16:07:19', '2019-08-12 16:07:19');
INSERT INTO `oauth2_access_token` VALUES ('1d47a13e9d4148a597b95150b4faa950', '189a48158cf049a3aec9abec81ef6251', 27, 2, 1, '2019-07-16 14:28:01', '2019-07-16 13:40:01', '2019-07-16 13:40:01');
INSERT INTO `oauth2_access_token` VALUES ('1d4a395c875e49ad94f5ae8f9d0b0f53', 'c135b860062b492aa022e1bb43a7728d', 27, 2, 1, '2019-06-20 19:43:31', '2019-06-20 18:55:30', '2019-06-20 18:55:30');
INSERT INTO `oauth2_access_token` VALUES ('1d5aea0519fe4066898974dc5ae0ad7c', '805dd218ac144af9856a2ae557d4cc83', 27, 2, 1, '2019-07-29 20:08:04', '2019-07-29 19:20:04', '2019-07-29 19:20:04');
INSERT INTO `oauth2_access_token` VALUES ('1d8f642a7482475cb9aa8753b0f24f31', 'e5dab18a376a4f6b95d3ea6f534156b5', 27, 2, 1, '2019-05-28 21:15:21', '2019-05-28 20:27:21', '2019-05-28 20:27:21');
INSERT INTO `oauth2_access_token` VALUES ('1d988ec7b853462a8475fcb9ca2e6d28', '0f269b28a7f54b66a634d28e0e2e4c0d', NULL, NULL, 1, '2019-04-28 14:52:01', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1d9bfe600325486d9fc1aa81fd303bc7', '2930d8a0724340cb874d373215b09697', 27, 2, 1, '2019-08-14 11:47:55', '2019-08-14 10:59:54', '2019-08-14 10:59:54');
INSERT INTO `oauth2_access_token` VALUES ('1da7137178c449c98535e8c77fa675a3', 'b17c04f01fcd4063b824420eacdda05b', 27, 2, 1, '2019-06-04 19:50:09', '2019-06-04 19:02:08', '2019-06-04 19:02:08');
INSERT INTO `oauth2_access_token` VALUES ('1dbcd56e02c84692a347186c55857acb', 'da53533e02f048a5bdcf7d3c0802b57e', NULL, NULL, 1, '2019-05-06 11:50:58', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1dc989d006a6440c98b59f4d26bb650a', 'ecd59c42c8d24919bab26265d6174918', 27, 2, 1, '2019-08-07 16:16:08', '2019-08-07 15:28:08', '2019-08-07 15:28:08');
INSERT INTO `oauth2_access_token` VALUES ('1e23e1841b3b4cd4ae5687339876a297', '989536df91664c6ca9264b64c1c28245', 27, 2, 1, '2019-06-01 16:41:51', '2019-06-01 15:53:51', '2019-06-01 15:53:51');
INSERT INTO `oauth2_access_token` VALUES ('1e250fea43f24efc98cdc93501288e02', '7870ae25a0d147e8899f0493feb1a2a4', 82, 1, 1, '2019-05-24 13:28:53', '2019-05-24 12:40:52', '2019-05-24 12:40:52');
INSERT INTO `oauth2_access_token` VALUES ('1e2bef4b02124c41b40a7445dad63bf6', '099e435f58974f06a15e35e427888e4c', NULL, NULL, 0, '2019-03-03 22:57:58', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1e343bf72060444fbb55ac53641d5491', '3fb818e7af9c4fbab02d7f590fc94a33', NULL, NULL, 0, '2019-02-28 05:07:47', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1e472a3651d843c4a12032564169a047', '257c6fabc67e4468a2cd6df1858baea5', 112, 1, 1, '2019-06-07 15:18:31', '2019-06-07 14:30:31', '2019-06-07 14:30:31');
INSERT INTO `oauth2_access_token` VALUES ('1e48e7cc357343b2b11917e39b217f84', 'af3c09a7970b4d4f94ba2576d80e496c', NULL, NULL, 1, '2019-05-04 16:01:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1e667f4844ea4ac59d409fe1127253a4', '7b6186fed7d74941aadb41e2245ce78a', 27, 2, 1, '2019-06-11 18:24:20', '2019-06-11 17:36:19', '2019-06-11 17:36:19');
INSERT INTO `oauth2_access_token` VALUES ('1e80ed62df454866872718ef85064aa5', '5d47b7b80abf407f8ef11f792f103fe1', 160, 1, 1, '2019-07-08 18:32:49', '2019-07-08 17:44:49', '2019-07-08 17:44:49');
INSERT INTO `oauth2_access_token` VALUES ('1e88f459fa8a462fb90d49e062b3a895', '03d07a56ad3d436b8d641c15b0980008', NULL, NULL, 1, '2019-05-14 12:33:40', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1e8a78611021471380cd2e7258ae6126', '13d23e6b874d467c94ad7f12f0f80515', 27, 2, 1, '2019-06-27 18:42:45', '2019-06-27 17:54:45', '2019-06-27 17:54:45');
INSERT INTO `oauth2_access_token` VALUES ('1eb8819a2c65402ebb44cddfe42b3fd0', '5da9df5b66da40809068d053b51e28f8', NULL, NULL, 1, '2019-05-01 09:48:25', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1ed75e33b7224de28e1215029ee5c73e', '5562263edee34215b8b063188b740b43', NULL, NULL, 1, '2019-04-01 23:19:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1ee849c57e874361876b5084f0d4d15e', '67cd17a0d49f4477818ed5c63dfb8e60', 27, 2, 1, '2019-06-20 14:55:41', '2019-06-20 14:07:41', '2019-06-20 14:07:41');
INSERT INTO `oauth2_access_token` VALUES ('1f040621229e47ce8b2040046c6e10db', '62361f54362f4fa1b0b83f52830bf44d', 27, 2, 1, '2019-07-07 17:57:10', '2019-07-07 17:09:10', '2019-07-07 17:09:10');
INSERT INTO `oauth2_access_token` VALUES ('1f0715c7f39844d1ab650b0cd1097532', 'e71f5763ec594adfa1a7fe5fd174d132', 1, 2, 0, '2019-08-21 18:49:50', '2019-08-21 18:01:50', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('1f216c8e722a41799fcca34a5f7b2729', '1026517b975d423ca865275e09e101f7', 27, 2, 1, '2019-06-04 10:03:26', '2019-06-04 09:15:25', '2019-06-04 09:15:25');
INSERT INTO `oauth2_access_token` VALUES ('1f25bd82a4534d0a9f7ee4bbd3841c45', '1c59834f6b1446dab5c1f6f439747381', NULL, NULL, 1, '2019-03-13 00:17:32', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1f2f4190d3014b2ea9684ddd56487cac', 'c8205d66dfb445b19d91c17483a9fd1c', 27, 2, 1, '2019-08-22 16:17:58', '2019-08-22 15:29:58', '2019-08-22 15:29:58');
INSERT INTO `oauth2_access_token` VALUES ('1f3d2c69835143de8077de98194b7109', '1b824bfe52e44c8e914d60708e1d963a', 27, 2, 1, '2019-08-23 17:47:15', '2019-08-23 16:59:15', '2019-08-23 16:59:15');
INSERT INTO `oauth2_access_token` VALUES ('1f6d1c94cbd34d7a98f54f876a747f02', '1eab79ffb3964b76a1d126a60bbc4cbc', 27, 2, 1, '2019-08-05 00:20:48', '2019-08-04 23:32:48', '2019-08-04 23:32:48');
INSERT INTO `oauth2_access_token` VALUES ('1f7c98aab4fa459babccca13c2d02253', 'b34cc7a38c414351a0bd0b3e835bca86', 27, 2, 1, '2019-06-01 19:13:36', '2019-06-01 18:25:36', '2019-06-01 18:25:36');
INSERT INTO `oauth2_access_token` VALUES ('1f9714220aa4405a9d95a7dfaae11041', '94b710042b9b40eb9c870045589d85eb', NULL, NULL, 1, '2019-04-22 19:22:29', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1fa41dc6d8364824b5178753d587465e', '37ae5186ae6d47178cb2c939320d340f', 27, 2, 1, '2019-06-28 16:22:10', '2019-06-28 15:34:10', '2019-06-28 15:34:10');
INSERT INTO `oauth2_access_token` VALUES ('1faf3368c37f49c38cff2108214df332', '80946d713dab4b559b35edf700da4d9e', NULL, NULL, 1, '2019-04-27 17:40:42', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('1ff74ad0c84647b7a489f78fae87000f', '1401c605c8de47e6ae0dba0aff56e530', 1, 2, 0, '2019-07-12 10:15:56', '2019-07-12 09:27:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('1ff9c94b728845558c27001dbc1ea0f1', 'a649c84bfd4943c8b17d3b1a4ca5f049', NULL, NULL, 1, '2019-04-22 12:23:29', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('200b276f22934f18bc40200f86be98a0', 'd31602cad048416aa34ba1e1f11deaab', NULL, NULL, 1, '2019-03-13 14:19:06', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('201098e0ae2a42c1a1945145ae75e57f', '2ac9631779aa4c55a45f2e69d5ad95d3', 27, 2, 1, '2019-06-11 14:30:25', '2019-06-11 13:42:25', '2019-06-11 13:42:25');
INSERT INTO `oauth2_access_token` VALUES ('2039318a8e53413a9f3453ba6bc41872', 'ddf001ac682848288a685a990e4d24de', 27, 2, 1, '2019-06-17 10:24:09', '2019-06-17 09:36:08', '2019-06-17 09:36:08');
INSERT INTO `oauth2_access_token` VALUES ('20480d29337d4cb1aeb6f7b7481dfca5', 'd595f6dc2bb04eb08e23b1152c4a1057', 1, 2, 1, '2019-09-08 12:26:42', '2019-09-08 11:38:42', '2019-09-08 11:38:42');
INSERT INTO `oauth2_access_token` VALUES ('204fb95c64124827a7910ace9c6d79e9', '7ad12b318b964bb58a24ba7fa3dce0d0', 27, 2, 1, '2019-06-01 10:38:25', '2019-06-01 09:50:25', '2019-06-01 09:50:25');
INSERT INTO `oauth2_access_token` VALUES ('2054d62bc63b4ab1a47466c47312abbf', '35c079bc25c14e81ab54f501cc125726', 27, 2, 1, '2019-05-29 10:18:03', '2019-05-29 09:30:02', '2019-05-29 09:30:02');
INSERT INTO `oauth2_access_token` VALUES ('207be115340e478b90f41094195f0834', '531ae5d2922349f9a22016ffbeb9e87e', NULL, NULL, 1, '2019-05-02 00:56:15', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2084ba9ad0394136b6ce4efa0b7fab89', '9f65e925f1a8493aa60db5bbf78b094f', 27, 2, 1, '2019-07-17 14:46:23', '2019-07-17 13:58:22', '2019-07-17 13:58:22');
INSERT INTO `oauth2_access_token` VALUES ('20851983e580436788b7a047039b67fe', '61699ab44ca24a19a7d184311cbd01ff', 27, 2, 1, '2019-07-15 17:24:41', '2019-07-15 16:36:40', '2019-07-15 16:36:40');
INSERT INTO `oauth2_access_token` VALUES ('208f103e07a047848b592c7b27b8ba1b', '59ec28b1f89343cd96c5d69fefe33036', 27, 2, 1, '2019-08-16 17:58:57', '2019-08-16 17:10:56', '2019-08-16 17:10:56');
INSERT INTO `oauth2_access_token` VALUES ('209c04c6716e4b64b9d6e2214b8fe321', '01f80d8433f741f0a2747eeac2108a14', NULL, NULL, 1, '2019-04-24 10:13:07', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('20a62860a04d443c82a2676c91ef0140', '900b95fb044f4a1b80f07329e699f0e5', 27, 2, 1, '2019-07-22 10:39:37', '2019-07-22 09:51:36', '2019-07-22 09:51:36');
INSERT INTO `oauth2_access_token` VALUES ('20b99e844d3e43bea2871a3e5c2b4706', 'bca732e799a94721840f33f6f6fc012f', 27, 2, 1, '2019-05-31 12:30:22', '2019-05-31 11:42:22', '2019-05-31 11:42:22');
INSERT INTO `oauth2_access_token` VALUES ('20edbe6af8df4308936abc6d4e6100e7', '56f6ecd8c55b41acbc064a2a39a27548', 27, 2, 1, '2019-06-20 11:20:13', '2019-06-20 10:32:12', '2019-06-20 10:32:12');
INSERT INTO `oauth2_access_token` VALUES ('20ee15b34fda412fa5ab32bb34626453', '44359963f1bc467c890dfe4ae27ec3f7', 27, 2, 1, '2019-08-01 14:44:51', '2019-08-01 13:56:50', '2019-08-01 13:56:50');
INSERT INTO `oauth2_access_token` VALUES ('20fbb584cd1f4517829a894df29c2fbf', 'ab624257f6eb433e8b9c9eb99c7680b4', 27, 2, 1, '2019-05-28 11:03:13', '2019-05-28 10:15:13', '2019-05-28 10:15:13');
INSERT INTO `oauth2_access_token` VALUES ('210e6810e7bc42fcab69b8c92f568c70', '900adda5ac5e41f6a81706dde3b29d03', NULL, NULL, 1, '2019-04-30 21:01:00', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2120beab9a7049f5b344988abae5ad89', '58a428b2349f45a3b64374b2f101920b', 27, 2, 1, '2019-06-06 12:49:48', '2019-06-06 12:01:48', '2019-06-06 12:01:48');
INSERT INTO `oauth2_access_token` VALUES ('2122bda3df96479b8d1782a97de3cd70', 'fd0a330853284673bac781de6bd22caf', 27, 2, 1, '2019-05-27 18:52:07', '2019-05-27 18:04:07', '2019-05-27 18:04:07');
INSERT INTO `oauth2_access_token` VALUES ('212b847df51946bcad2c97cba363235c', '0097cce2e3cd46ceaae40b19af2e2b3f', 27, 2, 1, '2019-06-29 12:13:28', '2019-06-29 11:25:28', '2019-06-29 11:25:28');
INSERT INTO `oauth2_access_token` VALUES ('212e39f1e963410d946d39193c176bed', '6cd1cc21f20e4f6393e19ae67b29c16d', 27, 2, 1, '2019-06-05 17:30:24', '2019-06-05 16:42:23', '2019-06-05 16:42:23');
INSERT INTO `oauth2_access_token` VALUES ('21424879df6b4df1bd5b3453af9fba6c', '3571c666a8a344a19e62dcdfec7ffb48', NULL, NULL, 1, '2019-03-14 22:04:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('21529330075e40378c36c3c6d0d2322f', '9aa5658052a543a9a77e2a183b6da3d3', 27, 2, 1, '2019-06-14 16:43:58', '2019-06-14 15:55:58', '2019-06-14 15:55:58');
INSERT INTO `oauth2_access_token` VALUES ('216248393b37407a9d2c0cc1cd2e0095', 'a17aeb8847d041d983c427883e601969', 27, 2, 1, '2019-08-09 00:49:43', '2019-08-09 00:01:43', '2019-08-09 00:01:43');
INSERT INTO `oauth2_access_token` VALUES ('2170a60e31f647d0b89b234de24df892', '4c21b6ebf5b44bad89e145325b4d3835', 27, 2, 1, '2019-08-20 18:59:40', '2019-08-20 18:11:40', '2019-08-20 18:11:40');
INSERT INTO `oauth2_access_token` VALUES ('21899abcd97d4991b0a8ebd03849ed9c', '9de0e8a8623e40ed9f9acf5297b120f3', 27, 2, 1, '2019-06-01 20:30:12', '2019-06-01 19:42:12', '2019-06-01 19:42:12');
INSERT INTO `oauth2_access_token` VALUES ('219215f9ab5f45d489295cb7089f6baf', 'cad555cfbe744265be10f9bac7727912', NULL, NULL, 1, '2019-05-01 12:40:48', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('21974d059fb74c61b75b9450647608f4', 'a7de5ffe4c664f6785c2a9c90d06988f', 27, 2, 1, '2019-07-02 17:23:41', '2019-07-02 16:35:40', '2019-07-02 16:35:40');
INSERT INTO `oauth2_access_token` VALUES ('21adba4b1bd240b89837dd172f761fb1', '144d5ebd40aa4ed096603e7b255b8edc', NULL, NULL, 1, '2019-04-22 20:31:38', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('21b5f6ebc32845f3927db76cff0b1469', '08a4b620c9384de9a50d8ca978fafa01', 27, 2, 1, '2019-06-04 10:59:31', '2019-06-04 10:11:30', '2019-06-04 10:11:30');
INSERT INTO `oauth2_access_token` VALUES ('21bb1ba97b1a4c969aca4d40f17a0b6b', '37a6d42b98e8465cbdda26c2ef8bb6ac', 27, 2, 1, '2019-07-04 20:51:56', '2019-07-04 20:03:56', '2019-07-04 20:03:56');
INSERT INTO `oauth2_access_token` VALUES ('21bdf947ddce49bc8019ba8b21ce47a3', 'd2f1676e992d46f6a7e7fd490605c7db', 27, 2, 1, '2019-07-09 00:20:23', '2019-07-08 23:32:22', '2019-07-08 23:32:22');
INSERT INTO `oauth2_access_token` VALUES ('21c225c3ce244116b155d21d60bef8c2', '5029db24a3c7495cbd5a4626309ec1a1', NULL, NULL, 1, '2019-03-10 04:22:15', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('21e757519e194621be1714a4f9f204dd', '3689fc8379714c4888f79369c0a6761a', 93, 1, 1, '2019-05-31 17:58:44', '2019-05-31 17:10:44', '2019-05-31 17:10:44');
INSERT INTO `oauth2_access_token` VALUES ('21e8e1ef0e13486488ff28e358dff86b', '8b98ec1080a64f79a5809150402adf01', NULL, NULL, 1, '2019-03-27 19:51:25', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('21f276d3b94b40ec88146c889e688b84', '2507f2cf7209478e991ac980715e70ba', 27, 2, 1, '2019-08-30 09:05:14', '2019-08-30 08:17:13', '2019-08-30 08:17:13');
INSERT INTO `oauth2_access_token` VALUES ('220d9d3ac9f64cd1aa74fbc8b7266709', '3d5cae1a11334bbc8e024be89fea4589', 145, 1, 1, '2019-07-01 19:25:10', '2019-07-01 18:37:09', '2019-07-01 18:37:09');
INSERT INTO `oauth2_access_token` VALUES ('221683acdd364b5d906f86b9dac22171', '105b5ee8c6644fe887c51ceb57880757', 27, 2, 1, '2019-07-20 13:03:41', '2019-07-20 12:15:40', '2019-07-20 12:15:40');
INSERT INTO `oauth2_access_token` VALUES ('222dfcc540f245f38e0425a2ea45f71b', '3f371ed2dcd2416f9a3d3f5fa44d14ee', 27, 2, 1, '2019-08-25 12:18:29', '2019-08-25 11:30:29', '2019-08-25 11:30:29');
INSERT INTO `oauth2_access_token` VALUES ('22482bb2a705407abbcf3a0e0bc3bed2', '56cc78820252485685f6600819df2530', 27, 2, 1, '2019-08-20 19:12:16', '2019-08-20 18:24:16', '2019-08-20 18:24:16');
INSERT INTO `oauth2_access_token` VALUES ('224c06852424472ba0cd72579d739f45', 'f8317f6b8f5c417f9c0767c02945f2e3', 28, 2, 1, '2019-09-04 23:46:23', '2019-09-04 22:58:22', '2019-09-04 22:58:22');
INSERT INTO `oauth2_access_token` VALUES ('2255bb62db4d434aa8097e7c6c34a19b', 'a2407c1f0a8d4c8cbadfc55b9797f3ea', 27, 2, 1, '2019-06-01 10:52:48', '2019-06-01 10:04:47', '2019-06-01 10:04:47');
INSERT INTO `oauth2_access_token` VALUES ('2277f8cf3789468fb2199ff8db6d9137', 'ced7a71322474ec794c7fc86d48d3ef8', 27, 2, 1, '2019-05-29 17:57:16', '2019-05-29 17:09:16', '2019-05-29 17:09:16');
INSERT INTO `oauth2_access_token` VALUES ('227c8fd9fe6b4b02b5322e435fd6e6d5', '6ffa6233efd842d5aed0fdcbe20c64b5', 27, 2, 1, '2019-06-21 11:00:03', '2019-06-21 10:12:03', '2019-06-21 10:12:03');
INSERT INTO `oauth2_access_token` VALUES ('227f1decb6504153b54d0b597fbf9a56', '142f93b6e8384cc3a6e62a3b0bf2d8e6', 27, 2, 1, '2019-06-19 12:45:08', '2019-06-19 11:57:07', '2019-06-19 11:57:07');
INSERT INTO `oauth2_access_token` VALUES ('228774c41a57487f8873552b40aaef4a', '9d8b3dc0967940d890821a5ea5603ca9', 27, 2, 1, '2019-07-13 00:59:56', '2019-07-13 00:11:55', '2019-07-13 00:11:55');
INSERT INTO `oauth2_access_token` VALUES ('22886d8eddcf4471abe2d0713f45027e', '444d644fe56048d7bf538de31ef49d0d', 27, 2, 1, '2019-05-29 14:20:24', '2019-05-29 13:32:23', '2019-05-29 13:32:23');
INSERT INTO `oauth2_access_token` VALUES ('22c4e8b8b50f4454b94bae226543be6b', '0baf9b718b9a49edae994537e5a1aabf', 27, 2, 1, '2019-07-03 14:44:12', '2019-07-03 13:56:12', '2019-07-03 13:56:12');
INSERT INTO `oauth2_access_token` VALUES ('22d8439b2ff84bd889e6e20918e4259a', '4cae72cdc42a4b8fa47a55e5c8dbaa63', 27, 2, 1, '2019-08-27 09:34:05', '2019-08-27 08:46:04', '2019-08-27 08:46:04');
INSERT INTO `oauth2_access_token` VALUES ('22e3c7fc189e462983482aecd3810eaf', '29a6d47ef9df428db6fee195e6c5a021', 27, 2, 1, '2019-07-13 10:28:50', '2019-07-13 09:40:50', '2019-07-13 09:40:50');
INSERT INTO `oauth2_access_token` VALUES ('230458cf94404f07bf5bf0f64645260d', '37d0183224d942428f4555dc8326223c', 27, 2, 1, '2019-06-08 02:09:15', '2019-06-08 01:21:14', '2019-06-08 01:21:14');
INSERT INTO `oauth2_access_token` VALUES ('230695ced93d44c4bc19ee5d6232e7e4', '00f06357cb6144238aabe0b3ac1eaf59', 27, 2, 1, '2019-06-02 00:26:13', '2019-06-01 23:38:12', '2019-06-01 23:38:12');
INSERT INTO `oauth2_access_token` VALUES ('230ed96686ee400eac1f08362cc44f7a', '14028f91954541468a36e63f1d92a839', 27, 2, 1, '2019-05-31 23:29:21', '2019-05-31 22:41:20', '2019-05-31 22:41:20');
INSERT INTO `oauth2_access_token` VALUES ('233b6a18481a4a2390488c3e29027fe8', 'e2b173e1cd2a4579b0f8f12dcb3c8eaa', 133, 1, 1, '2019-06-21 16:27:05', '2019-06-21 15:39:04', '2019-06-21 15:39:04');
INSERT INTO `oauth2_access_token` VALUES ('233bd4d3f160483b9c3f5b4f7914a5da', 'baf5844b2fb249378c703044ea998f0e', 27, 2, 1, '2019-08-15 17:33:17', '2019-08-15 16:45:17', '2019-08-15 16:45:17');
INSERT INTO `oauth2_access_token` VALUES ('2346ea11c4aa4fe985868935c68f441b', '9cb199038b2b4959847d962fb21e5311', 27, 2, 1, '2019-07-15 11:55:09', '2019-07-15 11:07:08', '2019-07-15 11:07:08');
INSERT INTO `oauth2_access_token` VALUES ('234d76a6ad3246fe8f7bb456e90fed80', 'a7d11c86d446441bb05d51a4464d6a51', 27, 2, 1, '2019-07-01 12:57:59', '2019-07-01 12:09:58', '2019-07-01 12:09:58');
INSERT INTO `oauth2_access_token` VALUES ('236f3a43167344129b9f4e439efbc7c8', 'b696a95c1ef7417a8596b64696d8eabc', NULL, NULL, 1, '2019-05-09 16:26:01', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('23b06e97acf947888d84e19ef2d0750d', 'bd6cd56c85db4ca2b5e71d26052df105', 1, 2, 0, '2019-06-02 00:32:12', '2019-06-01 23:44:12', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('23cbf910a7354ebb9f6d805743a185fb', '1d36dbfec9104232adc4e4b65197e357', 27, 2, 1, '2019-07-24 18:03:26', '2019-07-24 17:15:26', '2019-07-24 17:15:26');
INSERT INTO `oauth2_access_token` VALUES ('23d51ee3756a459d87dbc97144037053', 'b4be2b6648db42a1be6b19d97daa803d', 27, 2, 1, '2019-05-30 15:52:25', '2019-05-30 15:04:25', '2019-05-30 15:04:25');
INSERT INTO `oauth2_access_token` VALUES ('2400ca9c2a8040898ae2d5207f66c71e', '686dbded823248c4be1c8891f90bc0be', 1, 2, 0, '2019-08-28 12:16:10', '2019-08-28 11:28:09', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('2405341e6cce404790ef91e5cd5e707e', 'ae3df2de5598423db068f55ab1069b7e', NULL, NULL, 1, '2019-04-25 16:26:40', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('240db16d93184d0a90d49290668a8d89', 'a8e7d11f04a34c669d6a6c29263f4435', 27, 2, 1, '2019-07-20 09:55:15', '2019-07-20 09:07:15', '2019-07-20 09:07:15');
INSERT INTO `oauth2_access_token` VALUES ('245298bf2b9e46b2a09f923202965b32', '086134896af24d6a8fdfea399fa05abf', 27, 2, 1, '2019-08-03 15:59:40', '2019-08-03 15:11:39', '2019-08-03 15:11:39');
INSERT INTO `oauth2_access_token` VALUES ('245ddef006c84e86ba9bd58d96be86c5', '0fbe7a1dbc6a4330806e2e1304973e6c', 27, 2, 1, '2019-08-26 11:27:32', '2019-08-26 10:39:32', '2019-08-26 10:39:32');
INSERT INTO `oauth2_access_token` VALUES ('2463c5fe56b248f9b6cd9b2bacc41162', '9181e9e7fb9d46048c8042a28905045a', 27, 2, 1, '2019-07-10 19:33:32', '2019-07-10 18:45:32', '2019-07-10 18:45:32');
INSERT INTO `oauth2_access_token` VALUES ('246dc27ceae34f31bee34dc60c187e5c', '71b7c0f660d6465aae359663934ef2c7', 27, 2, 1, '2019-06-01 14:37:56', '2019-06-01 13:49:56', '2019-06-01 13:49:56');
INSERT INTO `oauth2_access_token` VALUES ('247cd4420b9c4c86bf8d175ed0e0c9c6', 'e0be3e2ebd3e4f2bb47cf6aca4dac92b', 27, 2, 1, '2019-06-01 12:18:57', '2019-06-01 11:30:57', '2019-06-01 11:30:57');
INSERT INTO `oauth2_access_token` VALUES ('2482c00956304d5db6d9181b772251d8', 'e36c76db9a394e5bb9058b88b87ea291', 27, 2, 1, '2019-06-20 14:46:29', '2019-06-20 13:58:28', '2019-06-20 13:58:28');
INSERT INTO `oauth2_access_token` VALUES ('248cbd73b44342ceaf865daf0b432296', '84e801e5e1564b9f85ed56c793fc7824', 27, 2, 1, '2019-07-03 18:33:28', '2019-07-03 17:45:27', '2019-07-03 17:45:27');
INSERT INTO `oauth2_access_token` VALUES ('24a422bedccb4426b107d68569a01e3e', '03b711ef78f346f68569713426d43f28', 1, 2, 0, '2019-07-19 09:51:32', '2019-07-19 09:03:32', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('24a6f16d12de461a9b6f7c4b010279b5', 'c94f3d5af86c43d1946311ad2707b474', 27, 2, 1, '2019-06-10 12:20:07', '2019-06-10 11:32:06', '2019-06-10 11:32:06');
INSERT INTO `oauth2_access_token` VALUES ('24b4898cd6a64c71afb02e319227fda4', '089d9f467a474f7e841549894dfeb38a', 27, 2, 1, '2019-07-19 00:24:45', '2019-07-18 23:36:44', '2019-07-18 23:36:44');
INSERT INTO `oauth2_access_token` VALUES ('24be832b305e46968e92fdeb6bb13879', '9764e9a34d64423f8af66f09b4f24cf7', 27, 2, 1, '2019-08-27 17:31:05', '2019-08-27 16:43:05', '2019-08-27 16:43:05');
INSERT INTO `oauth2_access_token` VALUES ('24cafc01d59a4ad28fefc0c050bf23a7', 'afa25c0c9f0047a1a66d99d119197b5a', NULL, NULL, 1, '2019-03-30 00:27:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('24e806f769334a6e9773dc84d1f28d31', '3295af4f94a24f5aa5454dde7b3a2732', NULL, NULL, 0, '2019-03-01 10:44:23', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('24eeff6cb35c4d0f87d5b9dcd656795a', '516db115d41642bebca08452ec35e02e', 27, 2, 1, '2019-05-29 12:02:21', '2019-05-29 11:14:21', '2019-05-29 11:14:21');
INSERT INTO `oauth2_access_token` VALUES ('250b5242356c4342bb383c9cbd52c2fd', 'bc1a9b57e3bd4417b64ce0c1f2c0e17a', 27, 2, 1, '2019-06-02 06:43:49', '2019-06-02 05:55:48', '2019-06-02 05:55:48');
INSERT INTO `oauth2_access_token` VALUES ('2536816ec1434d38aefe42d4e84e5f5d', '6ad90c36508a425597ddc32a360beb78', 27, 2, 1, '2019-08-30 18:53:00', '2019-08-30 18:04:59', '2019-08-30 18:04:59');
INSERT INTO `oauth2_access_token` VALUES ('256a9d4270494eec9ed0028b92c0eac1', '1b066db6175143a5b5ea60a9ef1723e1', NULL, NULL, 1, '2019-03-10 04:22:05', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('25867a9e35054435ae66fc1956566644', 'a76dcee6a29d4ffdbe2f5892d9b50dc0', 27, 2, 1, '2019-06-22 23:28:10', '2019-06-22 22:40:10', '2019-06-22 22:40:10');
INSERT INTO `oauth2_access_token` VALUES ('258d8c02310645bfbc45a1b9bc5cdf70', '5637052a7bf3483fb49d3c6407f35dfb', 27, 2, 1, '2019-09-02 08:39:14', '2019-09-02 07:51:14', '2019-09-02 07:51:14');
INSERT INTO `oauth2_access_token` VALUES ('25a2c3edbaca42a7b549f2a0b70588b5', '237bc6d20ae44c38a145a4e1748b3ac7', 27, 2, 1, '2019-06-01 16:34:15', '2019-06-01 15:46:14', '2019-06-01 15:46:14');
INSERT INTO `oauth2_access_token` VALUES ('25b9fdf3286e41dc8e49d3d341111caa', 'acb2d704c8424a9e875a93c0c05f63d7', 27, 2, 1, '2019-06-14 11:23:31', '2019-06-14 10:35:30', '2019-06-14 10:35:30');
INSERT INTO `oauth2_access_token` VALUES ('25c0a2b80dc84031bdc09b7d3144e24c', '08d4d4e579ae4a3da2663ead543cd723', 27, 2, 1, '2019-07-15 23:16:39', '2019-07-15 22:28:39', '2019-07-15 22:28:39');
INSERT INTO `oauth2_access_token` VALUES ('25eb7dc0301f4ac38e0a401d4f6062b5', '82625d4c6ce2435ca9df80a5d8502e73', 1, 2, 0, '2019-06-08 18:20:30', '2019-06-08 17:32:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('25f32e1ea0774c32b826902b1edae803', 'af926d47aa254555a6c8ccc9255ee29a', NULL, NULL, 1, '2019-04-30 20:54:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('25f68a9c90ab4b45b21bab3b85f44282', '0dbc11fd2290429d8e4d7b85e90c0a41', 27, 2, 1, '2019-06-03 12:45:11', '2019-06-03 11:57:11', '2019-06-03 11:57:11');
INSERT INTO `oauth2_access_token` VALUES ('2616248cb6c649f0a6216a2cafc285fc', '5b3fd51cdf3d4b598610ccb3f255836e', 27, 2, 1, '2019-07-08 16:52:43', '2019-07-08 16:04:42', '2019-07-08 16:04:42');
INSERT INTO `oauth2_access_token` VALUES ('262b7abb91424f3992ea934c9a322773', 'd97335100fa44b70914dc5569cbf75fc', 27, 2, 1, '2019-06-01 15:41:32', '2019-06-01 14:53:32', '2019-06-01 14:53:32');
INSERT INTO `oauth2_access_token` VALUES ('26428e62245948e887b472dd42003c6b', 'ea100b1b1470468790ee7c9160495b9b', 27, 2, 1, '2019-06-16 18:50:53', '2019-06-16 18:02:52', '2019-06-16 18:02:52');
INSERT INTO `oauth2_access_token` VALUES ('2650f370d327437db1cc3c273e8f34d1', 'cc574ec23c404a5b9d5b1c92fb8efcbf', 27, 2, 1, '2019-06-29 23:06:19', '2019-06-29 22:18:18', '2019-06-29 22:18:18');
INSERT INTO `oauth2_access_token` VALUES ('26521495888d4cc298ed4effe0d28043', '02fe7c8b66384e7c8759dbd36264d212', 27, 2, 1, '2019-08-15 15:11:38', '2019-08-15 14:23:37', '2019-08-15 14:23:37');
INSERT INTO `oauth2_access_token` VALUES ('266064899a954f8e87c2b22ebc77dc21', 'da6b5eba9fd04715a25a2c1a93cb9ab1', 27, 2, 1, '2019-09-07 10:48:12', '2019-09-07 10:00:11', '2019-09-07 10:00:11');
INSERT INTO `oauth2_access_token` VALUES ('2665d79219824e56be80b50deb713991', 'c84c03d59822410e8073ea4798c4b1a2', NULL, NULL, 1, '2019-04-22 19:08:36', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('267a4f602b034a30a6d7e9b945bfba21', 'a32c8e9a77464a53aea2cf5efa8c7036', 27, 2, 1, '2019-08-17 14:10:49', '2019-08-17 13:22:48', '2019-08-17 13:22:48');
INSERT INTO `oauth2_access_token` VALUES ('26832e9e03574f6eba226f46084140fc', 'f72c6265d4d04870a80f78c2e1128d86', 27, 2, 1, '2019-08-15 17:17:25', '2019-08-15 16:29:25', '2019-08-15 16:29:25');
INSERT INTO `oauth2_access_token` VALUES ('268a7b38746142758575e2c1273dc177', '341011c29b8d4f7680b32bb16bd68d30', 27, 2, 1, '2019-06-12 21:02:29', '2019-06-12 20:14:28', '2019-06-12 20:14:28');
INSERT INTO `oauth2_access_token` VALUES ('268bca39aa6b40d8a190ef842c3677f2', '1994dda719ed45a8a9c1b4fef3fe2b2f', 27, 2, 1, '2019-06-28 12:14:01', '2019-06-28 11:26:00', '2019-06-28 11:26:00');
INSERT INTO `oauth2_access_token` VALUES ('26970a3e067d4f5ba1163e052b65285f', '26a2ca69b66f42d6b25932baee11d28a', 27, 2, 1, '2019-06-26 16:58:02', '2019-06-26 16:10:02', '2019-06-26 16:10:02');
INSERT INTO `oauth2_access_token` VALUES ('26a06d2673ba445bb3b9892d8c5f1a60', '5067407883ab47368703f22884109d21', 27, 2, 1, '2019-06-28 16:39:27', '2019-06-28 15:51:26', '2019-06-28 15:51:26');
INSERT INTO `oauth2_access_token` VALUES ('26b8b4cadc8c485a884efccadf799521', '2b49cb1e4f924940ae69715619c209df', NULL, NULL, 1, '2019-04-24 11:54:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('26bbbd1945664cb692ca3858f43066e6', 'df688f0f134947e7aae103ae29885969', 27, 2, 1, '2019-06-01 13:40:12', '2019-06-01 12:52:11', '2019-06-01 12:52:11');
INSERT INTO `oauth2_access_token` VALUES ('26ccbb0db7eb46408fa11065caa6e4b3', 'f97fb48e51834d2dbc670640068f69b8', NULL, NULL, 1, '2019-04-29 11:12:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('26f24d94d3fa4e518532ae853fb59285', '0eed2937bfa047d0bb4efc2ff332d27f', 27, 2, 1, '2019-08-15 15:12:31', '2019-08-15 14:24:31', '2019-08-15 14:24:31');
INSERT INTO `oauth2_access_token` VALUES ('27044abe503a4e20a8236f7151fdc0d9', '32a06021dc764db79a9eb147b4c53f5d', 27, 2, 1, '2019-07-08 19:00:29', '2019-07-08 18:12:29', '2019-07-08 18:12:29');
INSERT INTO `oauth2_access_token` VALUES ('270fb48a49d5480b926ff624ab7a19cd', '0a181c5d860a45078c400f9cbe6f4e6b', NULL, NULL, 1, '2019-03-13 11:05:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('271c4d4cb66b4d34b53033005fabd5cf', '43e46a871f5f4ad185acbaa73d058711', 27, 2, 1, '2019-09-03 10:41:05', '2019-09-03 09:53:05', '2019-09-03 09:53:05');
INSERT INTO `oauth2_access_token` VALUES ('2720661f6f4a401e8812fed934cdf62d', '8f77bd296d684a9c96c4bbb719bf3501', 27, 2, 1, '2019-08-05 11:30:26', '2019-08-05 10:42:26', '2019-08-05 10:42:26');
INSERT INTO `oauth2_access_token` VALUES ('2727735c3b0c41d68f6aa2b8289a3a6a', '8147a5bc1c9c424e97f3c80ac9bf8630', 27, 2, 1, '2019-06-26 10:44:56', '2019-06-26 09:56:55', '2019-06-26 09:56:55');
INSERT INTO `oauth2_access_token` VALUES ('272ad9846037461ab74037457ae4a774', 'addf389141e34dc4b56ccf25a0be31c3', 27, 2, 1, '2019-07-31 15:04:49', '2019-07-31 14:16:49', '2019-07-31 14:16:49');
INSERT INTO `oauth2_access_token` VALUES ('2737eb0ce6da491fbffbfbd6400b3e3f', '73688418048c4172bc44d4e2faea2497', NULL, NULL, 1, '2019-05-02 00:47:16', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('274bf44127874e16bace7eaf4a2874ab', '335181cd60824c96b40f188f4a53a39e', 27, 2, 1, '2019-08-07 17:45:57', '2019-08-07 16:57:57', '2019-08-07 16:57:57');
INSERT INTO `oauth2_access_token` VALUES ('274d7e795b8c43ae8b69136c06a922fb', '7f3c6a469a9c44f1ad2127b32ba189d6', 1, 2, 0, '2019-08-26 10:27:35', '2019-08-26 09:39:33', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('27537b7278fc4af9970ae7152cae5469', '1fe9b23122034f6b9d230378eb1c3636', 1, 2, 0, '2019-08-16 18:24:36', '2019-08-16 17:36:35', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('27596086e780470b89e892510f00c5d6', '4058dd89a24d4f8a9ae977ad5a00012a', NULL, NULL, 1, '2019-05-05 13:44:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('277327824d0d4592b3d8c9f6ac3a937d', 'e6de8e53629448b4937f3a6b01c9fbab', 27, 2, 1, '2019-06-03 15:12:32', '2019-06-03 14:24:32', '2019-06-03 14:24:32');
INSERT INTO `oauth2_access_token` VALUES ('2790898d1f684955a340b4740d5a4c12', '74796babd7a74a42afa946bbbd6225cd', 27, 2, 1, '2019-07-07 23:21:21', '2019-07-07 22:33:20', '2019-07-07 22:33:20');
INSERT INTO `oauth2_access_token` VALUES ('2796f1225f4e4bb19ee22f89895968e0', '7305d1fc1fe248758a513a5834e13957', NULL, NULL, 1, '2019-03-15 20:44:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('27a6f61bd92240d69395ad1387bf586b', 'f6cd866cff654730bf03ff628d9f1ccc', 27, 2, 1, '2019-07-19 12:08:08', '2019-07-19 11:20:07', '2019-07-19 11:20:07');
INSERT INTO `oauth2_access_token` VALUES ('27aa366293e8468f85c65dcae07628a0', 'f506c47f60014117a472d55384dd3352', 27, 2, 1, '2019-05-27 20:37:35', '2019-05-27 19:49:35', '2019-05-27 19:49:35');
INSERT INTO `oauth2_access_token` VALUES ('27d83907b0304cd4a522c57215e1801d', '29d9eb760a044187ba5f81cac42e67f4', 27, 2, 1, '2019-09-02 17:22:48', '2019-09-02 16:34:47', '2019-09-02 16:34:47');
INSERT INTO `oauth2_access_token` VALUES ('27f9004094004ef8931481a6fda4b41f', 'c3a3b0ad7ead4088be56b4763ddca277', NULL, NULL, 1, '2019-04-12 16:44:07', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('28028b99154b4184845f206ed2160786', '4679b2237bf24a32a5c6c14a21a3553f', 27, 2, 1, '2019-08-12 12:27:41', '2019-08-12 11:39:40', '2019-08-12 11:39:40');
INSERT INTO `oauth2_access_token` VALUES ('280c9076145445a299d619755f93786d', '2102d892dfd6467688fdb205b3e174ca', 27, 2, 1, '2019-06-03 11:47:27', '2019-06-03 10:59:27', '2019-06-03 10:59:27');
INSERT INTO `oauth2_access_token` VALUES ('280eadd506a74ccb99828e137f9bfe7a', 'd22bd842c5ed4238b9ce732e1f8b13e9', 27, 2, 1, '2019-06-19 15:12:42', '2019-06-19 14:24:41', '2019-06-19 14:24:41');
INSERT INTO `oauth2_access_token` VALUES ('28410c8fc7b047808331c2cb40f61f5a', '2c3120629dda47e58a057240e1077387', 27, 2, 1, '2019-08-19 11:47:38', '2019-08-19 10:59:38', '2019-08-19 10:59:38');
INSERT INTO `oauth2_access_token` VALUES ('2845b6ab63524da8b6bda78ddf62642d', '12d64546b50c4121b54cb78a7a191af4', 27, 2, 1, '2019-05-30 18:26:19', '2019-05-30 17:38:18', '2019-05-30 17:38:18');
INSERT INTO `oauth2_access_token` VALUES ('284b353cd19f4604a57baef95d518ac8', '738f3a28d511448fb93646d0c49acaaf', 27, 2, 1, '2019-07-07 10:49:12', '2019-07-07 10:01:12', '2019-07-07 10:01:12');
INSERT INTO `oauth2_access_token` VALUES ('28734aba86dd4c49a2fa6be82037f505', 'dfa007533aaf4ec989ff59a38fd97b74', 27, 2, 1, '2019-08-15 17:17:36', '2019-08-15 16:29:36', '2019-08-15 16:29:36');
INSERT INTO `oauth2_access_token` VALUES ('2899e3aeab104ff9adf3451dc90f22d4', '5d4ff3a64e274a14862ebd5a080b5e90', NULL, NULL, 1, '2019-04-06 22:31:50', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('28ae5fc2cd4745a1b0f7e90f0f13c527', '76f6ba125e6a4cf281f9a3f3aa0c0f3d', 1, 2, 0, '2019-06-25 12:37:37', '2019-06-25 11:49:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('28c2084ca26f4f6db338ad0f6f642c4e', '387b71db862c4d099c2ca50b3bb3c585', 27, 2, 1, '2019-08-14 09:44:24', '2019-08-14 08:56:24', '2019-08-14 08:56:24');
INSERT INTO `oauth2_access_token` VALUES ('2908c1366f0846439926e7851831f2e7', '69c7d940c6834a479e837d42e9932049', 27, 2, 1, '2019-06-03 11:37:34', '2019-06-03 10:49:34', '2019-06-03 10:49:34');
INSERT INTO `oauth2_access_token` VALUES ('290aad74e26f4300aee37e1278a421e7', '985672546f51453892d527f424b99f5c', 209, 1, 1, '2019-08-20 20:03:43', '2019-08-20 19:15:43', '2019-08-20 19:15:43');
INSERT INTO `oauth2_access_token` VALUES ('291af63c91e7439da74695d1e3c84035', 'a38f02d9cd82485baa64b77c03f10ab6', 1, 2, 0, '2019-05-17 16:50:47', '2019-05-17 16:02:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('2939f1eedec84956b457ddae93091a97', '6a634d9842d24d768e0a50b2e16d416b', 27, 2, 1, '2019-06-03 10:42:46', '2019-06-03 09:54:46', '2019-06-03 09:54:46');
INSERT INTO `oauth2_access_token` VALUES ('296ca950a1a84c6bbcac08a238b09305', 'f95506f90622413b9266769a6085ae46', 27, 2, 1, '2019-06-04 17:54:41', '2019-06-04 17:06:40', '2019-06-04 17:06:40');
INSERT INTO `oauth2_access_token` VALUES ('2983a594077c489fbd24f5ba8d6bafaa', '6eba71b5600e425796445a2b4c74cbdd', 27, 2, 1, '2019-09-06 16:50:30', '2019-09-06 16:02:30', '2019-09-06 16:02:30');
INSERT INTO `oauth2_access_token` VALUES ('298e3428de20466eaf974313597f7606', 'b3e0d6df90274cd4b9c2f98eab6f50a7', NULL, NULL, 1, '2019-04-01 14:48:34', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2992df6a36b64c86904ab0d6001d72a7', 'f85e2af71a6c461e9641f0f9068af030', NULL, NULL, 1, '2019-05-13 11:46:00', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('299a11a6351643d3ad2b4de8f68e2fd7', '5e67a2458a8a469d835c1c8b92671a52', 27, 2, 1, '2019-08-24 23:25:11', '2019-08-24 22:37:10', '2019-08-24 22:37:10');
INSERT INTO `oauth2_access_token` VALUES ('29a49176a5594c8ea62eaa2c7f4d2e13', 'abc0f3a5925042a1bb08a3ef33f35150', 27, 2, 1, '2019-07-27 21:29:22', '2019-07-27 20:41:21', '2019-07-27 20:41:21');
INSERT INTO `oauth2_access_token` VALUES ('29aef424f8384a238833aa642cfbe992', '226fafe8f33f474488962df8bf212b41', 27, 2, 1, '2019-07-05 15:40:04', '2019-07-05 14:52:03', '2019-07-05 14:52:03');
INSERT INTO `oauth2_access_token` VALUES ('29be4dc5d0a045de89d0e2c0127c8ce8', '8e28bde38c2e46cf9b3fba01205d2189', NULL, NULL, 1, '2019-03-12 21:26:17', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('29c904415f0c47fabb4eeaac766ba566', 'ca83fa9851c84af1844f6f4681b3f1a6', 27, 2, 1, '2019-06-14 16:02:31', '2019-06-14 15:14:30', '2019-06-14 15:14:30');
INSERT INTO `oauth2_access_token` VALUES ('29e74b4e00ce4f7697f3a6bc6bf1bdde', 'aa5ec060a2eb4f8eaf60b9807956f65b', 27, 2, 1, '2019-07-01 11:49:03', '2019-07-01 11:01:02', '2019-07-01 11:01:02');
INSERT INTO `oauth2_access_token` VALUES ('2a016b1f0202462da6c347aadcd83140', '26d3462044974d3e8d99e0366b17de2f', 27, 2, 1, '2019-05-26 22:32:05', '2019-05-26 21:44:04', '2019-05-26 21:44:04');
INSERT INTO `oauth2_access_token` VALUES ('2a13b7106ddb4b1398cecad2d9cd289b', 'a78940630e08479789ad07bc23402f82', 27, 2, 1, '2019-07-30 15:23:59', '2019-07-30 14:35:59', '2019-07-30 14:35:59');
INSERT INTO `oauth2_access_token` VALUES ('2a173c3da82a432b9c3b3e91e2b35374', '2348af4614fb4b42bc7c0a7b698a5115', 27, 2, 1, '2019-06-20 17:46:22', '2019-06-20 16:58:21', '2019-06-20 16:58:21');
INSERT INTO `oauth2_access_token` VALUES ('2a21379153ab44268f16204b3ca2c555', '62664fe690184ca3aa16f1cf546ea9b8', 27, 2, 1, '2019-08-19 11:10:19', '2019-08-19 10:22:18', '2019-08-19 10:22:18');
INSERT INTO `oauth2_access_token` VALUES ('2a41ef6ca5a04a3da06d627983ced04f', 'a4583bb9c66449bc86e92ce9e464570b', 27, 2, 1, '2019-06-29 12:11:35', '2019-06-29 11:23:35', '2019-06-29 11:23:35');
INSERT INTO `oauth2_access_token` VALUES ('2a4c90baff434d11a2e45e19078018d4', '89f419f25f0144d5afba5c0ad3536382', 27, 2, 1, '2019-08-15 19:57:04', '2019-08-15 19:09:03', '2019-08-15 19:09:03');
INSERT INTO `oauth2_access_token` VALUES ('2a539849b2ee4aaf8852204f4f366ea8', '0e4d2112df1342a8a7b8eac7c0e9e24a', 27, 2, 1, '2019-08-30 17:47:38', '2019-08-30 16:59:37', '2019-08-30 16:59:37');
INSERT INTO `oauth2_access_token` VALUES ('2a5a103194ce4ceda9abed2558e3e94d', '47733c61b28c4cce9472d23f1b67fb33', NULL, NULL, 1, '2019-05-05 23:24:30', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2a633a6f5e614997a6c72778a720dcc5', '09ae1ed413d7449d84d66d76ecd78dab', 27, 2, 1, '2019-06-26 14:40:36', '2019-06-26 13:52:35', '2019-06-26 13:52:35');
INSERT INTO `oauth2_access_token` VALUES ('2a7d3a946fa040dd8b6c90244e0974ab', '3f642546572e4be49c71dba23dbfb1f3', 27, 2, 1, '2019-06-14 13:22:43', '2019-06-14 12:34:42', '2019-06-14 12:34:42');
INSERT INTO `oauth2_access_token` VALUES ('2a97271f9edf4fb98ed6c0807a68b83d', '499e7852c47c4340bbf2e48f67a412ad', NULL, NULL, 1, '2019-05-13 13:18:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2aa234441f634f93b90ba32589316974', '7f43ca7bde674c50b396e74f807636cd', NULL, NULL, 1, '2019-03-20 22:00:05', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2ab4f934e4c04909848a30491ce805f4', '2c7ef36c254a4032ba2d7b3fd19434b9', NULL, NULL, 1, '2019-05-08 22:56:40', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2ab663284b054e21b18c4690cb6a4c40', 'ed05365c4aed4a4f9e57509d0a3199b3', 27, 2, 1, '2019-06-29 23:51:20', '2019-06-29 23:03:20', '2019-06-29 23:03:20');
INSERT INTO `oauth2_access_token` VALUES ('2acb9468e4f24ebfa5f5ff2523bc90f6', 'd61f249fbbba4d46860dd9d46dfa9a2c', 27, 2, 1, '2019-07-18 17:10:20', '2019-07-18 16:22:20', '2019-07-18 16:22:20');
INSERT INTO `oauth2_access_token` VALUES ('2ae597eaa5234c46837cfa88ceea542d', '3a15be232caa49389fbecdced542153d', 27, 2, 1, '2019-06-19 20:33:21', '2019-06-19 19:45:20', '2019-06-19 19:45:20');
INSERT INTO `oauth2_access_token` VALUES ('2ae5c28307b947c18ce2a2c1890aea25', '15bdf4510eed4249852bd6e018ce422b', NULL, NULL, 1, '2019-04-04 19:11:27', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2aff361ff9064d97b7372540698bd7b1', 'bc6e844e6d3d45df8f2564b40b82e91e', 27, 2, 1, '2019-06-14 22:20:57', '2019-06-14 21:32:57', '2019-06-14 21:32:57');
INSERT INTO `oauth2_access_token` VALUES ('2b10978b404a49449b20fb69564c0d5b', '72df8d81291e4526a154ec359c835e85', 27, 2, 1, '2019-07-22 12:13:48', '2019-07-22 11:25:48', '2019-07-22 11:25:48');
INSERT INTO `oauth2_access_token` VALUES ('2b1534f6dc884274ac0a06273e489466', '6062cb2d36df48b59b93877993bd7ec2', NULL, NULL, 1, '2019-05-06 23:20:38', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2b3ba5420d6840e0a93cf7b51203e321', 'ee27b55e02744c739d1f5fac41458d66', 1, 2, 0, '2019-06-27 21:27:48', '2019-06-27 20:39:48', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('2b3e43330a2f43499ec4bd50a4beed24', '7886be49343941f49892824a69b63201', 27, 2, 1, '2019-08-17 23:17:01', '2019-08-17 22:29:00', '2019-08-17 22:29:00');
INSERT INTO `oauth2_access_token` VALUES ('2b52ae2bf8994f2b80f60d43509f5c87', '3398f62356c84766b509cb4aac1c58dd', 1, 2, 0, '2019-06-20 17:48:22', '2019-06-20 17:00:21', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('2b5b98a5759f499eb5baf3b8491e54a6', '8b8ed89f176545fdb4508955aa15e864', 27, 2, 1, '2019-05-31 14:33:15', '2019-05-31 13:45:15', '2019-05-31 13:45:15');
INSERT INTO `oauth2_access_token` VALUES ('2b6f463c4d2a427593a125196e527e0e', '3f6e92aef33c42e89bf26256e19fd347', 27, 2, 1, '2019-07-26 01:16:18', '2019-07-26 00:28:18', '2019-07-26 00:28:18');
INSERT INTO `oauth2_access_token` VALUES ('2b7f69aa78c6427f946addbc82f6e656', '137cccd1c9574732854eab554a82c5c6', NULL, NULL, 1, '2019-03-11 23:40:23', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2b8290021b0f436191fc807f122ac2e0', 'e18075511a4344a7a4593779c4f47f75', 27, 2, 1, '2019-06-29 16:26:41', '2019-06-29 15:38:41', '2019-06-29 15:38:41');
INSERT INTO `oauth2_access_token` VALUES ('2b9e0aa7e89c41a4b1370b7eebcc6625', 'e2a76723fdf243c6af29ad263475abbc', 27, 2, 1, '2019-05-27 10:47:23', '2019-05-27 09:59:23', '2019-05-27 09:59:23');
INSERT INTO `oauth2_access_token` VALUES ('2ba3bf2717a24623b34fbfc17b30a735', 'f22cec24bce14180be8e43c7d4c7ca29', 27, 2, 1, '2019-08-20 12:41:00', '2019-08-20 11:52:59', '2019-08-20 11:52:59');
INSERT INTO `oauth2_access_token` VALUES ('2bab586d5a8f4e5db6a6b52cc17aee69', '6c76d712f5e34f578befb6cc5e4d05d0', 27, 2, 1, '2019-07-11 10:42:03', '2019-07-11 09:54:02', '2019-07-11 09:54:02');
INSERT INTO `oauth2_access_token` VALUES ('2bb6fdbca3b146b1a3c72ecd6ccc1d9c', '2e9383c54cd94c9d8931616299ef5a5a', 1, 2, 0, '2019-06-26 15:56:52', '2019-06-26 15:08:51', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('2bb7459ced284052a52a166be7a9d81a', '6679c74600d44f3590e19825013bceaa', 27, 2, 1, '2019-06-18 17:43:48', '2019-06-18 16:55:47', '2019-06-18 16:55:47');
INSERT INTO `oauth2_access_token` VALUES ('2bb9b5737b864b57a75a388af5834c22', 'd6a60733ae274a3ca928534954950e4e', NULL, NULL, 1, '2019-04-30 21:13:36', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2bc3966b90a94ca680eb6106073216e6', 'faae1af83c8b483cbe54392577371469', 1, 2, 0, '2019-06-10 11:28:50', '2019-06-10 10:40:50', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('2bc69c2597494466b2c0ed371e3bf491', '0ba550ca40c3405192403a3c195b4e85', 27, 2, 1, '2019-08-27 23:36:48', '2019-08-27 22:48:48', '2019-08-27 22:48:48');
INSERT INTO `oauth2_access_token` VALUES ('2bc9dee327ce4c608912058574d14efc', '6d163d6083c14f52b7f410c10b7312d3', 1, 2, 0, '2019-06-02 23:18:12', '2019-06-02 22:30:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('2bcb5e2ca16f4c3c9190178d72b6060b', '3edd0c618e6d4ffeb04b3ced998932d0', NULL, NULL, 1, '2019-05-02 13:15:36', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2bd5f39749854985b2ff4c9aa8125767', 'a790a179c178411e971e4374f1584cda', NULL, NULL, 1, '2019-04-05 22:19:20', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2beb2cdbf0c84d28916f2f7ac2bc81e6', '888bc942b0d3449285383b1e72e85e71', NULL, NULL, 1, '2019-05-02 18:39:07', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2c084d7f55c040129c87210547f93ce5', '4ccf14bc696b47578cd346cf39e72dec', NULL, NULL, 1, '2019-05-07 14:33:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2c1c3a78897e46cd8ba70e7ce6f2710a', '4c4022cba2a247878858835746337352', 1, 2, 0, '2019-06-25 00:20:17', '2019-06-24 23:32:16', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('2c1fb0d02e12495998932278115c06c5', '0d9225bc75744e12b89395c4e75f8de9', 27, 2, 1, '2019-07-17 16:47:59', '2019-07-17 15:59:58', '2019-07-17 15:59:58');
INSERT INTO `oauth2_access_token` VALUES ('2c23cb445f6e4b7d9fb74dd6c14bc0b8', '462e193e72ce426396dc50f9c5d1e683', NULL, NULL, 1, '2019-05-03 10:02:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2c630cff77b44ab0a8d55d57a1957e16', '6a80094850124a568aefefa231edd940', NULL, NULL, 1, '2019-05-13 14:35:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2c8b4ae1090c4c5db36dd057173366dd', 'c8621a5f92834838b696ee30b0bf238d', 1, 2, 0, '2019-07-18 20:40:17', '2019-07-18 19:52:17', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('2cb2b822b9fd4463be0ae1785401a32c', 'bf01df88c5974363aa4323c2121081a3', 27, 2, 1, '2019-08-15 17:55:50', '2019-08-15 17:07:49', '2019-08-15 17:07:49');
INSERT INTO `oauth2_access_token` VALUES ('2cb5b767318946a4b7924ee297fe8b32', '17c57ae9f7774cc8817187af0f3e368f', 27, 2, 1, '2019-08-27 10:30:32', '2019-08-27 09:42:31', '2019-08-27 09:42:31');
INSERT INTO `oauth2_access_token` VALUES ('2cb763a9c9ee417b9252a6d637b9da32', '5e6294ed3ab54a23967d3986b9708784', NULL, NULL, 1, '2019-05-07 18:50:32', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2cb9122940d641a8b918b9203e7d0148', '70825cead30241c5aedc5524326632de', 27, 2, 1, '2019-05-24 22:49:33', '2019-05-24 22:01:33', '2019-05-24 22:01:33');
INSERT INTO `oauth2_access_token` VALUES ('2cbfe39173e5461680d890d5b2b2b21f', '78e321d3487543c19ed1fbc0a2ef9e04', 27, 2, 1, '2019-06-12 15:57:17', '2019-06-12 15:09:17', '2019-06-12 15:09:17');
INSERT INTO `oauth2_access_token` VALUES ('2cd9e334846142f1b3b755e6033e2459', 'cb7e4defddd943a095ea5f03d6464a63', NULL, NULL, 1, '2019-05-08 12:12:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2cf6aaca61fc49ae9b1a3a999cdbc66d', '2334c01fe6de429fa6de23ac0bcf3acf', NULL, NULL, 1, '2019-03-30 18:03:04', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2d1353629f824fddb2d2c8398336a00e', 'ef1a23f1af254860ac967704215a58e4', 27, 2, 1, '2019-05-27 17:23:48', '2019-05-27 16:35:48', '2019-05-27 16:35:48');
INSERT INTO `oauth2_access_token` VALUES ('2d33f6d6754d44999592a280ea60cd10', '091dc0256c044f1fac3f6ef09837e6e1', 27, 2, 1, '2019-06-21 10:13:19', '2019-06-21 09:25:18', '2019-06-21 09:25:18');
INSERT INTO `oauth2_access_token` VALUES ('2d59bb3dde2147519d97d416052173dc', 'f021def591f243ef98ec1916b40cb2ca', NULL, NULL, 1, '2019-04-28 09:38:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2d6a4c36d8294b098b19662f89fa6df4', 'c70ef16bb5654cb98a54989c97f5f1a2', 27, 2, 1, '2019-07-11 18:15:27', '2019-07-11 17:27:26', '2019-07-11 17:27:26');
INSERT INTO `oauth2_access_token` VALUES ('2d8ffbb285034290864744d74afcad32', 'f8cae7a080314d7c9aa74b49bf9c2a70', 27, 2, 1, '2019-08-27 21:45:20', '2019-08-27 20:57:19', '2019-08-27 20:57:19');
INSERT INTO `oauth2_access_token` VALUES ('2dd7c9e31dbd4340a1a0911d5e87aae3', 'ad5eac111b4a402295df2a619496ea81', 27, 2, 1, '2019-06-05 17:06:30', '2019-06-05 16:18:29', '2019-06-05 16:18:29');
INSERT INTO `oauth2_access_token` VALUES ('2ddf04792c6a404fbe6c85147e9e775c', '8a8e506126c449fe9e6e9a6f2c300158', 27, 2, 1, '2019-08-01 13:06:24', '2019-08-01 12:18:23', '2019-08-01 12:18:23');
INSERT INTO `oauth2_access_token` VALUES ('2ddff8fc247b410dbcce7f74f920d2d6', '78c48b3baf30471880d281a21811b5cf', 27, 2, 1, '2019-05-17 19:13:38', '2019-05-17 18:25:37', '2019-05-17 18:25:37');
INSERT INTO `oauth2_access_token` VALUES ('2def1455036f462ca9b642150405bb34', '741e1af77ec944219adf4120e1bc7af4', 27, 2, 1, '2019-07-11 15:20:59', '2019-07-11 14:32:58', '2019-07-11 14:32:58');
INSERT INTO `oauth2_access_token` VALUES ('2e142bdbac2345cb868e6ad59f1289af', 'd60a2a38a92c4defa52f0e96e2cb2ecc', 27, 2, 1, '2019-07-27 01:34:50', '2019-07-27 00:46:49', '2019-07-27 00:46:49');
INSERT INTO `oauth2_access_token` VALUES ('2e2012a9a4d34343b97a4e3fffd7e2e0', '1185cca6935949b987eabf12aa46e403', 27, 2, 1, '2019-07-31 10:51:30', '2019-07-31 10:03:30', '2019-07-31 10:03:30');
INSERT INTO `oauth2_access_token` VALUES ('2e3619883e514857a8b194f33138d461', '557b953489aa40ad82f9659386e6197d', 27, 2, 1, '2019-07-19 11:37:44', '2019-07-19 10:49:44', '2019-07-19 10:49:44');
INSERT INTO `oauth2_access_token` VALUES ('2e389ff95c6e4bcb93470c3861f17479', 'bf4ca79f10bf40488714e65a078d0a92', 27, 2, 1, '2019-06-27 17:09:49', '2019-06-27 16:21:49', '2019-06-27 16:21:49');
INSERT INTO `oauth2_access_token` VALUES ('2e3c82ada83744e6a70cc06c0ccf9df3', 'd46293765d47499a985c732df4dfb849', 27, 2, 1, '2019-07-12 15:12:44', '2019-07-12 14:24:43', '2019-07-12 14:24:43');
INSERT INTO `oauth2_access_token` VALUES ('2e493680225e4853be791caf4e17f544', '610bab2c8a114f768036fc005a80acd9', 27, 2, 1, '2019-05-17 22:57:07', '2019-05-17 22:09:07', '2019-05-17 22:09:07');
INSERT INTO `oauth2_access_token` VALUES ('2e5ae69484a04cc4b3e6b40d927b4630', 'b290704811e64877a86efbfb914d1b03', 27, 2, 1, '2019-06-12 15:20:33', '2019-06-12 14:32:33', '2019-06-12 14:32:33');
INSERT INTO `oauth2_access_token` VALUES ('2e67dfc4e6be450c95b723afe695f864', '0c7b19c0427842bfa104cab184bf335b', 27, 2, 1, '2019-05-22 15:18:58', '2019-05-22 14:30:58', '2019-05-22 14:30:58');
INSERT INTO `oauth2_access_token` VALUES ('2e72a42b7cee408cb57a4557784aefcd', '124ba929d4cf45f4bcb3ea529f7e0dfc', 27, 2, 1, '2019-06-04 09:26:03', '2019-06-04 08:38:02', '2019-06-04 08:38:02');
INSERT INTO `oauth2_access_token` VALUES ('2e80c81ec3a849ecb2f81a9cf2e9465d', '84a37786769c45dc892badd48d960008', 27, 2, 1, '2019-07-12 16:26:51', '2019-07-12 15:38:51', '2019-07-12 15:38:51');
INSERT INTO `oauth2_access_token` VALUES ('2e828991d3f747fa8f2f27197fffc3d1', 'b74954fd87dd475e9b5ed18b3e8d6ed6', 27, 2, 1, '2019-08-14 09:15:49', '2019-08-14 08:27:48', '2019-08-14 08:27:48');
INSERT INTO `oauth2_access_token` VALUES ('2e8626be57cb4bd4b37304d16960a010', 'c99438bfa2e442a6a4385e294a651d32', 1, 2, 0, '2019-07-23 11:57:54', '2019-07-23 11:09:53', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('2e90b90d7ff949478d9a9842fffe7b7e', '418980e3d42b4a0b9f6ca1bcb5af6875', 27, 2, 1, '2019-06-06 17:14:06', '2019-06-06 16:26:05', '2019-06-06 16:26:05');
INSERT INTO `oauth2_access_token` VALUES ('2e99299808864fb79d2d283caf39afce', 'fe85d96937a94ae192e5f095953c4ee6', 27, 2, 1, '2019-09-02 19:10:00', '2019-09-02 18:21:59', '2019-09-02 18:21:59');
INSERT INTO `oauth2_access_token` VALUES ('2eb2b8f8958b4258a11db2c4d49d7dc5', '06c4b7cf9a8c492b83145dd13c508198', 27, 2, 1, '2019-08-09 11:37:09', '2019-08-09 10:49:08', '2019-08-09 10:49:08');
INSERT INTO `oauth2_access_token` VALUES ('2eb9f83f65334e3d8ede10b5c978e822', '958b64476b9a4cbca6000b4a524cc119', 27, 2, 1, '2019-06-21 15:53:00', '2019-06-21 15:05:00', '2019-06-21 15:05:00');
INSERT INTO `oauth2_access_token` VALUES ('2ebd4e3261f04a3486ccb5651b470ef4', 'f6d1108246844728a34e2eadc1c80fc8', 27, 2, 1, '2019-06-06 12:30:41', '2019-06-06 11:42:41', '2019-06-06 11:42:41');
INSERT INTO `oauth2_access_token` VALUES ('2ec859b36eac473eb4142b647efd65e3', 'e604538d753c4b7eb2d8f7b681773e5a', 27, 2, 1, '2019-06-19 15:54:40', '2019-06-19 15:06:39', '2019-06-19 15:06:39');
INSERT INTO `oauth2_access_token` VALUES ('2ed6a02c460b418e8ece712be840acea', 'a25fe26fe5da49ffa5f3aa54b4c649dd', 27, 2, 1, '2019-06-17 16:23:51', '2019-06-17 15:35:51', '2019-06-17 15:35:51');
INSERT INTO `oauth2_access_token` VALUES ('2ee10b042dad46828b14d8fee27c31f4', 'a80c7cae68ce437f91daf04dd18acee8', 27, 2, 1, '2019-06-02 14:00:26', '2019-06-02 13:12:26', '2019-06-02 13:12:26');
INSERT INTO `oauth2_access_token` VALUES ('2ee183090fd24182b872d3c1404720d4', 'cdd1cb4506ac4faca7b47032d66ef375', 27, 2, 1, '2019-07-08 19:06:48', '2019-07-08 18:18:47', '2019-07-08 18:18:47');
INSERT INTO `oauth2_access_token` VALUES ('2f02f7d8e3d5494ead079b1f026b9e3f', '767fec08391943818a50d8deb2ad14e9', 27, 2, 1, '2019-06-26 10:24:47', '2019-06-26 09:36:46', '2019-06-26 09:36:46');
INSERT INTO `oauth2_access_token` VALUES ('2f114829154c4d97a86fb62c3212f0b9', 'fbd883762da247fc9758b4becfc80616', 27, 2, 1, '2019-06-01 10:07:03', '2019-06-01 09:19:02', '2019-06-01 09:19:02');
INSERT INTO `oauth2_access_token` VALUES ('2f283ae78012445093c8f922750e6298', '67393756c3784fffbae9d886c9652ce5', 27, 2, 1, '2019-07-04 17:24:23', '2019-07-04 16:36:22', '2019-07-04 16:36:22');
INSERT INTO `oauth2_access_token` VALUES ('2f3264b96aa647f9b44d400bafcb829e', 'f06d6c23cd3a4855bb9ee4ddf72c4d66', 27, 2, 1, '2019-06-02 19:58:50', '2019-06-02 19:10:50', '2019-06-02 19:10:50');
INSERT INTO `oauth2_access_token` VALUES ('2f49a6e80775441ebeb60bac446b3a6e', 'fe85d98201bc422ab9d515cf60c743c1', 215, 1, 1, '2019-08-30 10:01:12', '2019-08-30 09:13:11', '2019-08-30 09:13:11');
INSERT INTO `oauth2_access_token` VALUES ('2f5fadce01f746ddb6ca97f0e2f797e2', 'aab66488a21b4695886e03968c0d84bb', 27, 2, 1, '2019-08-03 14:16:55', '2019-08-03 13:28:54', '2019-08-03 13:28:54');
INSERT INTO `oauth2_access_token` VALUES ('2f81063faf33467eb089083e5e2ccd7d', '45c070f5d07b47c4ab6f24b184ad6728', NULL, NULL, 1, '2019-05-09 20:01:33', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('2f8912935ef44896ba78ed82db8e2db5', '2b9f751cb93f4985a07cc524d01bf4bd', 27, 2, 1, '2019-08-05 15:15:55', '2019-08-05 14:27:54', '2019-08-05 14:27:54');
INSERT INTO `oauth2_access_token` VALUES ('2f8d388b20514c5bb0823b94af8152dd', 'f2a4df182d1342378afe5bd0de4d3fa4', 27, 2, 1, '2019-08-06 16:13:06', '2019-08-06 15:25:06', '2019-08-06 15:25:06');
INSERT INTO `oauth2_access_token` VALUES ('2fabb3a5114442f4ade9d27daed38823', 'da1089f6b79348c7b9a4a5f391a3fe9c', 27, 2, 1, '2019-06-11 14:55:14', '2019-06-11 14:07:14', '2019-06-11 14:07:14');
INSERT INTO `oauth2_access_token` VALUES ('2fc4b6586c0243ef86408aaba87b27ee', 'da694ca7b69d47999271a7caf98af3a8', 1, 2, 0, '2019-08-21 18:49:54', '2019-08-21 18:01:54', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('2fde6b84882f44c582228546fa838226', '12525ce6e81f497080b5af33c04aed5d', 125, 1, 1, '2019-06-14 19:48:09', '2019-06-14 19:00:09', '2019-06-14 19:00:09');
INSERT INTO `oauth2_access_token` VALUES ('2fe4cc7865084fd88d55b94721f238db', '34c995a69a0240d896e671a2e5119dad', 27, 2, 1, '2019-05-20 19:12:19', '2019-05-20 18:24:19', '2019-05-20 18:24:19');
INSERT INTO `oauth2_access_token` VALUES ('302d52542d2f47e8a0b7b164c4a0b7ca', '3873f93a9ee9430aa59c9632a7cf53c7', 1, 2, 0, '2019-07-12 14:50:49', '2019-07-12 14:02:48', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('302f4d13a3964a51a5fada324982fdf9', '14dc06b2a8f348d6ad3557f30946535b', 27, 2, 1, '2019-06-13 10:46:39', '2019-06-13 09:58:39', '2019-06-13 09:58:39');
INSERT INTO `oauth2_access_token` VALUES ('3038f61f741c4dd89d831d40853ef03b', 'e7d4f66acee14d6790a6c3627e30a449', NULL, NULL, 1, '2019-04-04 18:51:08', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3045698651b443abae6c802fcb51b586', '9e0d21cd1a3741d593a150efe812fa4b', 27, 2, 1, '2019-05-23 14:20:38', '2019-05-23 13:32:38', '2019-05-23 13:32:38');
INSERT INTO `oauth2_access_token` VALUES ('3050f491859946f99bae686ce57e7536', '22da87f23d364b3781f18e27ebd98a87', 1, 2, 0, '2019-09-03 00:35:00', '2019-09-02 23:46:59', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('305a614e664545aa9d75bd34458998ea', 'f5a0e64a279446898542a52c1f21047f', 27, 2, 1, '2019-08-22 18:19:24', '2019-08-22 17:31:24', '2019-08-22 17:31:24');
INSERT INTO `oauth2_access_token` VALUES ('30c28216fce94daf976e74613d63ee8e', 'c729d791a9ee4b77b08280ff57a4f725', NULL, NULL, 0, '2019-03-01 03:41:02', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('30cf23ffae924ce295166d70ceed64d9', '2f5b6163c16f4fc793b3604fbf406800', 27, 2, 1, '2019-07-31 11:18:08', '2019-07-31 10:30:07', '2019-07-31 10:30:07');
INSERT INTO `oauth2_access_token` VALUES ('30e2b9cb34484b93b9112a2971bd03a5', 'a1879903eaab4acea187c0753883fd26', NULL, NULL, 1, '2019-05-09 23:04:17', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('30e7e4c15d614478a2d3a952394ced5c', 'e4c41c51dfa344e7864364664b635895', 27, 2, 1, '2019-09-03 20:14:01', '2019-09-03 19:26:01', '2019-09-03 19:26:01');
INSERT INTO `oauth2_access_token` VALUES ('30e83fe201a54ef7aa7232415982629d', 'f94eb3021dd248ff97c2808f3d196a40', 27, 2, 1, '2019-08-28 14:26:52', '2019-08-28 13:38:52', '2019-08-28 13:38:52');
INSERT INTO `oauth2_access_token` VALUES ('310f1a6f820d4749bcf0c647928f7b13', '374103b44e2b4e028d501af453a27645', 27, 2, 1, '2019-07-18 11:56:28', '2019-07-18 11:08:28', '2019-07-18 11:08:28');
INSERT INTO `oauth2_access_token` VALUES ('312ae875e3be4cd1a107f3cf880626aa', '7a25bd327b2145158d560f95920cb4fe', 27, 2, 1, '2019-08-26 10:53:19', '2019-08-26 10:05:18', '2019-08-26 10:05:18');
INSERT INTO `oauth2_access_token` VALUES ('314d317e3cdd4aabba6fb5b70482712e', 'f075d6d375374a39bef6dc126e6f99ec', 27, 2, 1, '2019-08-30 10:06:47', '2019-08-30 09:18:46', '2019-08-30 09:18:46');
INSERT INTO `oauth2_access_token` VALUES ('3154f5fbf9304c8b91c499c790633d84', 'e3c0a25560eb47eeac517a8e8659fb90', 27, 2, 1, '2019-07-17 10:10:01', '2019-07-17 09:22:00', '2019-07-17 09:22:00');
INSERT INTO `oauth2_access_token` VALUES ('315f09d5fbbc4476ab6ce0a92e7fd13f', 'c293ed4a39634bd9b2fe0675d3a7f097', 27, 2, 1, '2019-06-24 10:55:36', '2019-06-24 10:07:36', '2019-06-24 10:07:36');
INSERT INTO `oauth2_access_token` VALUES ('317c551567f0451fba7e440c69664f52', '750ae20b9b094f3398cc1dc7b8639da1', 27, 2, 1, '2019-06-19 19:07:03', '2019-06-19 18:19:03', '2019-06-19 18:19:03');
INSERT INTO `oauth2_access_token` VALUES ('317ce7989e1c4e40b77bd2d193ec6cf3', '10c44086fc204ddd8a4051b0ab91357a', 27, 2, 1, '2019-05-28 22:32:29', '2019-05-28 21:44:28', '2019-05-28 21:44:28');
INSERT INTO `oauth2_access_token` VALUES ('31892529670141188378204666223469', 'ff3d70e200854fb3aeac1a20b26e65b8', 1, 2, 0, '2019-05-31 15:11:37', '2019-05-31 14:22:17', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('31a50b549d65414a89fd386a43d690df', '924f68d7cfdf4b418f95338bc49a6977', 27, 2, 1, '2019-08-27 12:05:42', '2019-08-27 11:17:41', '2019-08-27 11:17:41');
INSERT INTO `oauth2_access_token` VALUES ('31a7e87b8b25446c9b0641106fcccd02', '583fcd4f418445848ee254f0f3a345ea', 27, 2, 1, '2019-06-19 22:35:08', '2019-06-19 21:47:08', '2019-06-19 21:47:08');
INSERT INTO `oauth2_access_token` VALUES ('31b03e56ee0b472dbef5434831a9b4af', 'bba68eff954c4da6bb2fa74a39a60954', 1, 2, 0, '2019-05-31 21:25:51', '2019-05-31 20:37:50', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('31b876eedb994f49a9c4581d496eaf24', '7929865acb9e47d98bb75736d788ed94', NULL, NULL, 1, '2019-05-05 16:55:04', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('31b90012d996486c9f463070791aa86b', '8a9cf65fc43446ce836bc96dc5d562fb', NULL, NULL, 1, '2019-03-12 14:14:47', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('31e1e4339a7b46fb8a488578943fb03e', 'f298f87054034d1a8badb491836260e6', 27, 2, 1, '2019-05-17 23:04:53', '2019-05-17 22:16:53', '2019-05-17 22:16:53');
INSERT INTO `oauth2_access_token` VALUES ('31e231e3a39c4b2f8dbf795785267ca3', 'b684f41ee7b449059ec49c102dae79eb', 120, 1, 1, '2019-06-11 20:18:48', '2019-06-11 19:30:13', '2019-06-11 19:30:13');
INSERT INTO `oauth2_access_token` VALUES ('31e2ae86901041e3a9ef7942f9ab6089', '30f91dd8e35940d4a16d8dd4f78d915e', 27, 2, 1, '2019-07-31 17:30:22', '2019-07-31 16:42:21', '2019-07-31 16:42:21');
INSERT INTO `oauth2_access_token` VALUES ('31ebc0e1631a45cc9f57c07f12727b9c', '08c75e5d14aa470f992bdb9d1e6d5db8', 1, 2, 0, '2019-09-02 23:20:52', '2019-09-02 22:32:52', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('31ff707ae90a4cf2bff6d9c5308c9cd9', 'd3786e13ffa64b7e99049ca4312f6ebb', 27, 2, 1, '2019-09-05 15:41:10', '2019-09-05 14:53:09', '2019-09-05 14:53:09');
INSERT INTO `oauth2_access_token` VALUES ('320a93c8cc564dbf9ef9d8a42312f5e3', 'bec8d8ae72ba4bfe9aee9a5e34d1dc63', 27, 2, 1, '2019-08-27 10:50:30', '2019-08-27 10:02:30', '2019-08-27 10:02:30');
INSERT INTO `oauth2_access_token` VALUES ('32252ee36f5c4e4d8e2dcef6a02fb6a7', '73ec7515046843b185e7a39cc197b7bd', 27, 2, 1, '2019-06-01 00:19:33', '2019-05-31 23:31:32', '2019-05-31 23:31:32');
INSERT INTO `oauth2_access_token` VALUES ('323036af14474dd5afbf3c56411633b9', '5744b3554db8475d9e4a3be20e2a18ab', 27, 2, 1, '2019-06-05 18:25:03', '2019-06-05 17:37:02', '2019-06-05 17:37:02');
INSERT INTO `oauth2_access_token` VALUES ('32388fffa56c409182990cf465a9f255', '61289d45d9f44b2cae7a5bbddb8e9f81', 27, 2, 1, '2019-06-05 10:54:38', '2019-06-05 10:06:38', '2019-06-05 10:06:38');
INSERT INTO `oauth2_access_token` VALUES ('32499bef78b744968297541a57706ae8', '268fe65d580e4f339e1ec3d168fe26f8', 27, 2, 1, '2019-07-22 21:25:35', '2019-07-22 20:37:34', '2019-07-22 20:37:34');
INSERT INTO `oauth2_access_token` VALUES ('324d255c5e3449ca993f960f8910e721', 'fc87e383a0ca45dd84b89a42676e0956', 27, 2, 1, '2019-07-22 15:47:04', '2019-07-22 14:59:04', '2019-07-22 14:59:04');
INSERT INTO `oauth2_access_token` VALUES ('325b17f4e65f43f4ba25f4c36b2fae8e', 'dd6771b1e0a94a52853f752817527b05', 27, 2, 1, '2019-06-02 18:02:01', '2019-06-02 17:14:01', '2019-06-02 17:14:01');
INSERT INTO `oauth2_access_token` VALUES ('32752150352840939edf3b8d3a24cf39', '734ca690d3b343a29c94e52f3e5cc685', NULL, NULL, 1, '2019-03-21 21:43:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('328ff587e42646e3b6d34539d8837360', '4a90205bb8c5407cad5852d41dd526b8', 27, 2, 1, '2019-06-23 23:13:21', '2019-06-23 22:25:20', '2019-06-23 22:25:20');
INSERT INTO `oauth2_access_token` VALUES ('32a639ffba5545ea9db18bac758ad53b', '24db243a23ef456d9737049f0494789a', 27, 2, 1, '2019-08-06 21:25:07', '2019-08-06 20:37:06', '2019-08-06 20:37:06');
INSERT INTO `oauth2_access_token` VALUES ('32b12609e3c84b2eb6812c69ff8f9531', '0cd31e8a906544dcaf97e31d47e93f13', 27, 2, 1, '2019-06-06 12:28:37', '2019-06-06 11:40:37', '2019-06-06 11:40:37');
INSERT INTO `oauth2_access_token` VALUES ('32c1648db743439d80f2d896173e8d75', '8d2649754248428f9d4200de644caa33', 153, 1, 1, '2019-07-04 16:03:43', '2019-07-04 15:15:43', '2019-07-04 15:15:43');
INSERT INTO `oauth2_access_token` VALUES ('32c7a86fca5149c296ccb6d321b669b0', '7cab3f1b1be24c06a29f34548f50b6ad', 27, 2, 1, '2019-05-31 21:56:01', '2019-05-31 21:08:01', '2019-05-31 21:08:01');
INSERT INTO `oauth2_access_token` VALUES ('32e0a1fb4af544719b9629c536ec2e3e', 'caa3a5e7f15e465ba47344901323fea2', 27, 2, 1, '2019-07-23 11:41:16', '2019-07-23 10:53:16', '2019-07-23 10:53:16');
INSERT INTO `oauth2_access_token` VALUES ('32e11dd78046419abaa0fcfa16ff038b', 'a1f55ec136a746fe8195e8aacbabb8cc', 27, 2, 1, '2019-07-08 16:28:54', '2019-07-08 15:40:53', '2019-07-08 15:40:53');
INSERT INTO `oauth2_access_token` VALUES ('32e66bbf1d2648d797c956c8ef334c25', 'd3f4920d20144efca6e5441c628e9940', 27, 2, 1, '2019-07-27 00:20:15', '2019-07-26 23:32:14', '2019-07-26 23:32:14');
INSERT INTO `oauth2_access_token` VALUES ('32f83b53ce524cc0b62768d590db4e73', '69f1c83f87134633995fd7082143d174', 1, 2, 0, '2019-05-31 19:06:53', '2019-05-31 18:17:34', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('32fa5527a2b645419679036741025484', '8464e429c33f432f9a44b44fac3c61a3', 27, 2, 1, '2019-07-22 09:52:05', '2019-07-22 09:04:04', '2019-07-22 09:04:04');
INSERT INTO `oauth2_access_token` VALUES ('331b973da2cd42bdac0164cc57ccf137', 'e5f4fed25bb54dca89651f0c8dece98f', 27, 2, 1, '2019-07-18 16:25:09', '2019-07-18 15:37:09', '2019-07-18 15:37:09');
INSERT INTO `oauth2_access_token` VALUES ('332bfc72efe341b09edc8d2bdb8fe089', 'be1055da81e84f1e9641e7c2be9090f1', NULL, NULL, 0, '2019-03-06 08:26:03', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('33394ca2e84f4fa19be9fb00a4b4e166', '9593527e19de4ae2a146809247cf57c5', 1, 2, 0, '2019-06-21 11:14:48', '2019-06-21 10:26:47', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('333eb47b44a94efb9896c8012a817c56', 'a75cf477eefe4efbb533b6cb6de15cec', NULL, NULL, 0, '2019-03-03 23:01:02', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('334b5c7a43494c23a393099db7eeb979', '471fe70866544162a4f365509d092c56', 27, 2, 1, '2019-05-18 17:24:55', '2019-05-18 16:36:54', '2019-05-18 16:36:54');
INSERT INTO `oauth2_access_token` VALUES ('334e69399dc04e71a72fdb9bdae5cb67', '9cc0adfaba4a4d04a49581407ce36f6e', NULL, NULL, 1, '2019-05-06 15:53:21', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3358ef942311487c8b09c3d0e2377ef2', '8d0e1e760f85436a93c4e5c18c7f8769', 27, 2, 1, '2019-08-21 11:33:30', '2019-08-21 10:45:29', '2019-08-21 10:45:29');
INSERT INTO `oauth2_access_token` VALUES ('335dc05137a140abb3a015ed80b67e90', '331999635d1c46c4ba5f5ab7091ec4db', 1, 2, 0, '2019-05-28 16:25:49', '2019-05-28 15:37:49', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('337d18bad9d943a68cd0085014328168', 'b6a1da473a414670a0c662f5872f3cc8', 1, 2, 0, '2019-06-04 17:44:15', '2019-06-04 16:56:15', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('339a969efd6048209d675ef94d24d6e4', 'a05431a92f384889b47418ee8c742c4c', 27, 2, 1, '2019-06-17 16:22:02', '2019-06-17 15:34:01', '2019-06-17 15:34:01');
INSERT INTO `oauth2_access_token` VALUES ('33d3bf1add314c4d9b27cb9201cc460e', 'c277fa5d6f234cf38bf5e027b36bd903', 27, 2, 1, '2019-08-18 11:37:29', '2019-08-18 10:49:29', '2019-08-18 10:49:29');
INSERT INTO `oauth2_access_token` VALUES ('33e5ab4147d84869b4ad472930cce3ce', '27c074ff3e09479c8b5b43809eb8fa8b', 27, 2, 1, '2019-08-05 16:11:37', '2019-08-05 15:23:37', '2019-08-05 15:23:37');
INSERT INTO `oauth2_access_token` VALUES ('33e872ee7027448e9c2d19e6f862acb9', 'da867788c07c4f1197aad2e1a7d932d2', 1, 2, 0, '2019-06-20 11:47:58', '2019-06-20 10:59:57', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('33f40ed9c0ec455e94ccf3b5c39be779', '48385621c96d4aa88bdd9e320265407e', NULL, NULL, 1, '2019-05-06 01:10:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3414decaa0794f1793dbd92b52da5768', '4a13b540108e4820b157061dd1160305', 27, 2, 1, '2019-08-14 09:26:58', '2019-08-14 08:38:58', '2019-08-14 08:38:58');
INSERT INTO `oauth2_access_token` VALUES ('341c4afcd68b4e25ba77fcfc9142d48b', 'e2b463db16204df694c55c6188050866', 1, 2, 0, '2019-06-01 00:03:44', '2019-05-31 23:15:44', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('342243c27ffc45329da0869650ddf0ae', '336abaa69e1644f1a0abe3076251cba8', 27, 2, 1, '2019-05-17 19:16:40', '2019-05-17 18:28:40', '2019-05-17 18:28:40');
INSERT INTO `oauth2_access_token` VALUES ('343427207b3b4f248f1e3f8f4bf97706', '45575365d39d4485bd65b1e67412ba0c', 27, 2, 1, '2019-07-06 10:25:04', '2019-07-06 09:37:04', '2019-07-06 09:37:04');
INSERT INTO `oauth2_access_token` VALUES ('3435ae96196b45bd9610327a2f8ca13e', 'c33c148e8c5c498d90a8dd23d4184b41', NULL, NULL, 1, '2019-05-06 23:12:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('343bde5ed383414f817692e524f614cc', '59b1df7a3cb344f69fdf9fe0e9fea80d', NULL, NULL, 1, '2019-03-10 05:08:17', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('345b3ecc5ba043b6a79a939e7864f156', 'bec3717b296a456190e46a6b2b624773', 27, 2, 1, '2019-05-28 09:56:44', '2019-05-28 09:08:43', '2019-05-28 09:08:43');
INSERT INTO `oauth2_access_token` VALUES ('345ead6fac8c4d3abd01bdf2ae1cc466', '89237c31ab044f9590d8254e9042a5d8', NULL, NULL, 1, '2019-05-06 10:25:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('348caeec29994b59b3a99d7d4995c4d4', '71df3d680ff149b69fd218f9b31bd1db', 27, 2, 1, '2019-09-09 09:31:30', '2019-09-09 08:43:29', '2019-09-09 08:43:29');
INSERT INTO `oauth2_access_token` VALUES ('34989105956a413cb3cd8115c08fcd95', '9a5b5d6707f94dc7a9cbd4bb2fc79fc1', 184, 1, 1, '2019-07-30 23:18:36', '2019-07-30 22:30:36', '2019-07-30 22:30:36');
INSERT INTO `oauth2_access_token` VALUES ('34b272bc18e64a9881e85416231fd8ea', 'f42e48e1fb7343e5b00100bb490754ce', 27, 2, 1, '2019-08-21 20:46:53', '2019-08-21 19:58:53', '2019-08-21 19:58:53');
INSERT INTO `oauth2_access_token` VALUES ('34b5aff6d7ce4cef98bdd51bce35bf46', '08814deaa8cf4f2c8b478c5f9cadae98', 27, 2, 1, '2019-07-07 19:14:50', '2019-07-07 18:26:50', '2019-07-07 18:26:50');
INSERT INTO `oauth2_access_token` VALUES ('34bce86417ce4b8db0e3d3b08f2aaddf', '0d410105d8b34918940ce0a822d758d4', 27, 2, 1, '2019-07-22 11:20:19', '2019-07-22 10:32:19', '2019-07-22 10:32:19');
INSERT INTO `oauth2_access_token` VALUES ('34e95a2c05694185a9f002779df172bf', '74cb5404428d4b3895c3d404be33e5ff', 27, 2, 1, '2019-08-09 12:13:39', '2019-08-09 11:25:38', '2019-08-09 11:25:38');
INSERT INTO `oauth2_access_token` VALUES ('34f1968d5b754f66bcbd33b3d5f5b377', '0a8277630e2743ab8e0a1f39d3c349f7', 1, 2, 0, '2019-09-06 15:30:21', '2019-09-06 14:42:21', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('34f95d19c005450392eb3448409103e3', '3b5742abd5aa4a02822708a6fd2d0c42', 27, 2, 1, '2019-08-29 02:43:44', '2019-08-29 01:55:44', '2019-08-29 01:55:44');
INSERT INTO `oauth2_access_token` VALUES ('350042269e894dbd8d27ac082699ba31', '442096039f3946fb80ab5d87651cd7ab', 27, 2, 1, '2019-06-05 00:35:23', '2019-06-04 23:47:23', '2019-06-04 23:47:23');
INSERT INTO `oauth2_access_token` VALUES ('35025c7cb9e54fee8d43486fd8e2c7a9', 'd6b8a5cbe2ef456a90a12660e0b8635e', NULL, NULL, 1, '2019-03-11 20:31:23', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3523f371fad8472bbecba3387025e58d', 'ba590a655e1842f6b6cf1b30f640b632', 27, 2, 1, '2019-06-10 18:45:13', '2019-06-10 17:57:13', '2019-06-10 17:57:13');
INSERT INTO `oauth2_access_token` VALUES ('354254bc0484406681377070f9cf4ee3', 'a23a3ce4c0ed46adbc824cdf4ce2933d', 27, 2, 1, '2019-05-27 19:14:06', '2019-05-27 18:26:05', '2019-05-27 18:26:05');
INSERT INTO `oauth2_access_token` VALUES ('354989f5410b458baf5be341b78d8a1b', '9db4969b6c8b4d80bf59d0ab12f43ab8', 27, 2, 1, '2019-06-20 14:51:06', '2019-06-20 14:03:05', '2019-06-20 14:03:05');
INSERT INTO `oauth2_access_token` VALUES ('354f9fcbd7bb492a8e3809250830844b', '5e541e6acb7a4350a069ae1563b1f138', 27, 2, 1, '2019-06-09 19:57:08', '2019-06-09 19:09:07', '2019-06-09 19:09:07');
INSERT INTO `oauth2_access_token` VALUES ('355728c7159d41079787096c8b58dd63', '4a753fc641db48de9d8d7efe667a219e', 27, 2, 1, '2019-05-31 17:43:22', '2019-05-31 16:55:22', '2019-05-31 16:55:22');
INSERT INTO `oauth2_access_token` VALUES ('356dc6d126e44e20a58283d6e7ced2e9', '58977cf9cf4d41569dd8232830eed787', NULL, NULL, 1, '2019-03-10 04:22:39', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('356ea70e9f014c1c9156e0392ff06632', 'b5609cd856044d93bb38be1d2d1e5778', 27, 2, 1, '2019-05-31 18:24:39', '2019-05-31 17:36:38', '2019-05-31 17:36:38');
INSERT INTO `oauth2_access_token` VALUES ('35802be4f1ca4cc1b4174e624257af01', '0bc89e7c8fba42d4a5483889dca8d67a', 89, 1, 1, '2019-05-28 23:27:22', '2019-05-28 22:39:21', '2019-05-28 22:39:21');
INSERT INTO `oauth2_access_token` VALUES ('35b8e4f9eda547df9a500abb02b786f9', '0f9f19952543452d93e8f96edbe8e2e8', 27, 2, 1, '2019-06-26 21:56:01', '2019-06-26 21:08:00', '2019-06-26 21:08:00');
INSERT INTO `oauth2_access_token` VALUES ('35beb8748ea44281ad5edade71ced8a6', '5f3033e44cb44ed383961155f21f72ba', 1, 2, 0, '2019-09-04 18:38:34', '2019-09-04 17:50:34', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('35c1e5f9306e4078993de842a0bd5820', '97afa1a4f1d04cd897841a6dc50cbcde', NULL, NULL, 1, '2019-05-06 16:30:15', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('360042b3748a4c0495bceb38ae612651', 'b8555c5374514d9d9d569b5ed54094a9', NULL, NULL, 1, '2019-05-08 15:04:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3606848999a742568a3d17050a251eab', 'a885cfc0529a4665a9e8d6db6b8b2b42', NULL, NULL, 1, '2019-04-24 17:22:10', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('361f7d061df040cea73e732ae57dca7d', '9035a2be8a244511aebe0ad47d5ddccc', 27, 2, 1, '2019-07-28 09:28:30', '2019-07-28 08:40:30', '2019-07-28 08:40:30');
INSERT INTO `oauth2_access_token` VALUES ('361ffb6c2d274f9cbef1fb2d79ea0b48', 'f940d894c4ae44259e54ede745c189c6', 27, 2, 1, '2019-08-22 21:55:16', '2019-08-22 21:07:16', '2019-08-22 21:07:16');
INSERT INTO `oauth2_access_token` VALUES ('36598469f54543709df54461cd61d0c2', '1f3ab0a46c3148499b6cfd027f819778', 27, 2, 1, '2019-07-10 15:13:57', '2019-07-10 14:25:56', '2019-07-10 14:25:56');
INSERT INTO `oauth2_access_token` VALUES ('366d703328d24c75924a2570260c4128', '3aee6ca05db048d6b2f4ca231cc46c00', NULL, NULL, 1, '2019-05-08 10:29:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('366f7043c2c84d05b820e07823566352', '88cb2c1d7b5f441190833608d2328daa', 27, 2, 1, '2019-07-02 09:01:07', '2019-07-02 08:13:07', '2019-07-02 08:13:07');
INSERT INTO `oauth2_access_token` VALUES ('368a544dc33b43518500f77c46835a3d', '684eb94444944f9091a4ed04db3c7b20', 27, 2, 1, '2019-08-13 17:49:28', '2019-08-13 17:01:28', '2019-08-13 17:01:28');
INSERT INTO `oauth2_access_token` VALUES ('368d3513c4bd4ee291ee15d0293988a2', '02e966ca04174b64b1ff328a4acbd552', 27, 2, 1, '2019-07-02 16:53:32', '2019-07-02 16:05:32', '2019-07-02 16:05:32');
INSERT INTO `oauth2_access_token` VALUES ('369603b667f74047b6e352ee5988283b', '16339e70dc5040b2b90cd9e8c21b5636', 27, 2, 1, '2019-06-20 11:17:02', '2019-06-20 10:29:02', '2019-06-20 10:29:02');
INSERT INTO `oauth2_access_token` VALUES ('36a2b6de0cf74b5b8903da5ef09ae333', 'a20434a6474e493ab3771d49deb6ad04', NULL, NULL, 1, '2019-03-20 23:15:49', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('36a3145833fe43f68b88b5177b3e740e', '7afd52443b934be9a9a7720f028bd382', 27, 2, 1, '2019-06-01 11:09:00', '2019-06-01 10:20:59', '2019-06-01 10:20:59');
INSERT INTO `oauth2_access_token` VALUES ('36be7b0787dd47d1a2027e7fdce29cb8', '98d30edbd4584062b384f45497e82e44', 185, 1, 1, '2019-07-31 11:29:00', '2019-07-31 10:41:00', '2019-07-31 10:41:00');
INSERT INTO `oauth2_access_token` VALUES ('36c4e94a48a54cffaac2f621c51a79fd', '13115365b25d45faa215b042dd06efba', 27, 2, 1, '2019-06-03 10:27:54', '2019-06-03 09:39:54', '2019-06-03 09:39:54');
INSERT INTO `oauth2_access_token` VALUES ('36c9bdad793d48209a472fa485abc54d', '0cf549d5dc5d40a5b1158b64ba150cbd', 27, 2, 1, '2019-06-14 09:38:35', '2019-06-14 08:50:34', '2019-06-14 08:50:34');
INSERT INTO `oauth2_access_token` VALUES ('36d03ac1f14147e2ba57a5fffcd44780', '27882f8a8d1a4c79903e163185ef56d9', 27, 2, 1, '2019-06-20 09:46:52', '2019-06-20 08:58:52', '2019-06-20 08:58:52');
INSERT INTO `oauth2_access_token` VALUES ('36f501970be143bc9a050c6d755dc6c8', '0810615dafdf4f5ea2456d9e7bbdcc65', NULL, NULL, 1, '2019-04-26 11:52:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3706ca7ece884ca5a19a415cf84c2dd7', '3863199c598b433ba83f8aa9538aee01', NULL, NULL, 1, '2019-05-07 14:36:57', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3716ff0340e8475a8218ecbd032fe4b4', 'e27a86ea5923405784f5b9abfddcbd0c', 1, 2, 0, '2019-08-12 18:59:43', '2019-08-12 18:11:42', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('3726e82d4cd74aeca89271f53aa2ebfa', '8fdedb15be7c470d8055ef5de2f56697', 27, 2, 1, '2019-06-12 16:08:59', '2019-06-12 15:20:59', '2019-06-12 15:20:59');
INSERT INTO `oauth2_access_token` VALUES ('372777c6a5da4c34b555128ba51b2932', '6603323435b94c87acb03e4fb93023ac', 27, 2, 1, '2019-08-27 21:36:58', '2019-08-27 20:48:58', '2019-08-27 20:48:58');
INSERT INTO `oauth2_access_token` VALUES ('37578e6a8c4e45108323f7b40110eb0e', '23b2937104b649cd8a95b8051b1b8991', NULL, NULL, 1, '2019-05-16 11:31:03', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('375de603b54945bbab33439990e22310', '6af810aa5b6c488583404837128ff1b0', 27, 2, 1, '2019-06-05 10:45:39', '2019-06-05 09:57:39', '2019-06-05 09:57:39');
INSERT INTO `oauth2_access_token` VALUES ('37712a5f99d84c11a114f538eb41dd7e', '950adf6d7a004a259a2dedf39930c3bb', 27, 2, 1, '2019-06-18 15:17:33', '2019-06-18 14:29:32', '2019-06-18 14:29:32');
INSERT INTO `oauth2_access_token` VALUES ('3771765d9d164681b06a8fbc2c4c9224', '7492b1d113c34003bb75a65ccd1058b5', 27, 2, 1, '2019-06-25 19:07:59', '2019-06-25 18:19:59', '2019-06-25 18:19:59');
INSERT INTO `oauth2_access_token` VALUES ('3778e78fdb9340b3bb82a0579df90aff', '78f432ed52894e1381e75d5044d62405', 97, 1, 1, '2019-06-01 19:09:57', '2019-06-01 18:21:56', '2019-06-01 18:21:56');
INSERT INTO `oauth2_access_token` VALUES ('377c4b3822754f8abc2bc9397af00847', '5cb2cb3beb8544fda7a25bd29ec91dee', 27, 2, 1, '2019-08-20 22:19:49', '2019-08-20 21:31:48', '2019-08-20 21:31:48');
INSERT INTO `oauth2_access_token` VALUES ('37875a6fcdeb47f885ca94c555cf9ea9', '8c974558915b4a8488dcf6ae42b48212', 27, 2, 1, '2019-06-11 15:41:45', '2019-06-11 14:53:45', '2019-06-11 14:53:45');
INSERT INTO `oauth2_access_token` VALUES ('37a350889c424b96824183f568af90e6', '27629965c8704307b1b765e24ac6f45e', 27, 2, 1, '2019-05-31 21:40:25', '2019-05-31 20:52:25', '2019-05-31 20:52:25');
INSERT INTO `oauth2_access_token` VALUES ('37c978374c52483f8163aaddf72dc00d', '9a98c7f40f5e4b1596648115b16e34a3', 27, 2, 1, '2019-06-03 14:42:09', '2019-06-03 13:54:08', '2019-06-03 13:54:08');
INSERT INTO `oauth2_access_token` VALUES ('37cb5b1faf94493591c9dd4745e1a4fc', '13fbf535bd5f472c87e565504f61d051', 27, 2, 1, '2019-08-09 15:38:47', '2019-08-09 14:50:46', '2019-08-09 14:50:46');
INSERT INTO `oauth2_access_token` VALUES ('37d318981322499b93672ade99b5b042', '2dd82abc3ed94f7a9cd529dd7ff769ce', 27, 2, 1, '2019-07-31 17:26:52', '2019-07-31 16:38:51', '2019-07-31 16:38:51');
INSERT INTO `oauth2_access_token` VALUES ('380ed1102ac84941a6149b86d1c5a118', '5ed51ee5f1d3467e8181d841a8d2800d', NULL, NULL, 1, '2019-05-07 19:56:57', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('381364da10614be09b2a9223b633cdf6', '0642e898f505463f9dd025b233372a08', 27, 2, 1, '2019-06-30 15:29:21', '2019-06-30 14:41:21', '2019-06-30 14:41:21');
INSERT INTO `oauth2_access_token` VALUES ('3830eeeb8c8f45beb7d706673bbf2f19', '6e95fbdd3fc6448eba1848a674890cb9', NULL, NULL, 1, '2019-05-10 23:05:00', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('383ecb4f563a4c189b168023a911cdd1', 'edcc8856293d44b89d1e63fe9d84bad5', 27, 2, 1, '2019-06-05 13:58:58', '2019-06-05 13:10:58', '2019-06-05 13:10:58');
INSERT INTO `oauth2_access_token` VALUES ('386181a646a141e6ac11e2d8cf79c49f', 'bc861bc3aed14b3a9f8cceeba864dc84', 27, 2, 1, '2019-06-01 09:51:15', '2019-06-01 09:03:14', '2019-06-01 09:03:14');
INSERT INTO `oauth2_access_token` VALUES ('3861a41dd9eb4b1582c885e359072de9', '07dfe7aa15c74aa69c9e916d96e1e760', 27, 2, 1, '2019-06-04 09:46:03', '2019-06-04 08:58:03', '2019-06-04 08:58:03');
INSERT INTO `oauth2_access_token` VALUES ('3898a8c0c9b14cbfa3afda26d25d697f', '63fe4b91c8c54b8bb39c84b003064be9', 1, 2, 0, '2019-05-27 17:19:37', '2019-05-27 16:31:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('38adddf321784a088db34ce789b429da', 'e7d44005f1c84bf6a3680590c76d8dc1', NULL, NULL, 1, '2019-05-06 13:54:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('38bd96cac368475bb69428aa401e16ed', '82aa35c6947247c886e95af4fa4a7330', NULL, NULL, 1, '2019-03-15 21:30:08', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('38ddd60e17ec4df781fadcffa31f9a42', '0f11177aa49645fa8e3e601b6473fac5', 214, 1, 1, '2019-08-27 16:46:02', '2019-08-27 15:58:01', '2019-08-27 15:58:01');
INSERT INTO `oauth2_access_token` VALUES ('38e7bd9b9ba04fd7b3328d3ed75eef90', '718ef5aa9dc343bb942f4fa1a6108952', 27, 2, 1, '2019-07-31 17:07:24', '2019-07-31 16:19:23', '2019-07-31 16:19:23');
INSERT INTO `oauth2_access_token` VALUES ('38ebd4d71d3c4851be5da3ec6bd2896b', '94fd06496af7477d94ce513560b8b8b3', 27, 2, 1, '2019-05-18 18:47:51', '2019-05-18 17:59:50', '2019-05-18 17:59:50');
INSERT INTO `oauth2_access_token` VALUES ('38f3aeee2f4a4b93a68f846cba0b295e', '294c817a3790478b9c532fe763cc4361', 74, 1, 1, '2019-06-10 14:42:05', '2019-06-10 13:54:05', '2019-06-10 13:54:05');
INSERT INTO `oauth2_access_token` VALUES ('38f424f0c0944e958e9f72af9f447618', '66fb40c01b5b44059b3c5a94734a742b', 1, 2, 0, '2019-06-20 21:12:44', '2019-06-20 20:24:43', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('3925766bbfd649ca902befeb57b39ded', 'a74a363bb1c945138b87b84b8eccf4d3', NULL, NULL, 1, '2019-04-24 09:31:13', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3937ae3bf32540ef842fba75282933f3', '66cafdc2be524f7e922995f8a8633ffe', 27, 2, 1, '2019-07-19 00:14:12', '2019-07-18 23:26:11', '2019-07-18 23:26:11');
INSERT INTO `oauth2_access_token` VALUES ('39384c37f6af41d2b1b718717295a9d2', 'f56078ca5ddc467b8f6c0e1486d99c4b', 27, 2, 1, '2019-06-03 12:05:33', '2019-06-03 11:17:33', '2019-06-03 11:17:33');
INSERT INTO `oauth2_access_token` VALUES ('3944c2e62b484bdbbaa4d4e6dec7e62d', 'c044bba06f9c4271ab09e2c0bb8f7358', 1, 2, 0, '2019-05-23 20:55:03', '2019-05-23 20:07:03', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('395cc309ffb143f79080ac9ea6a59f00', 'b166715387574a7fa256b6a9d3b66031', 27, 2, 1, '2019-06-03 10:09:13', '2019-06-03 09:21:13', '2019-06-03 09:21:13');
INSERT INTO `oauth2_access_token` VALUES ('395f3db8c1f745f5ae897c8e7dc3fb3f', 'e0b123b7314b41ab94e4d5ecdf4b1808', 27, 2, 1, '2019-09-02 13:51:28', '2019-09-02 13:03:27', '2019-09-02 13:03:27');
INSERT INTO `oauth2_access_token` VALUES ('397aeb8383a64774a3dfa27aa276284f', 'a83f12a441d1463e9f3dc49d2c29b555', 27, 2, 1, '2019-08-15 09:49:50', '2019-08-15 09:01:50', '2019-08-15 09:01:50');
INSERT INTO `oauth2_access_token` VALUES ('3987bbc23d534cbba3203a198dfd285a', 'b3868bf7996a4f08bcbeb7ec3e129618', 27, 2, 1, '2019-08-14 19:11:47', '2019-08-14 18:23:47', '2019-08-14 18:23:47');
INSERT INTO `oauth2_access_token` VALUES ('398a1515135c4c6ebc59666cc7b27365', '32e7690056b44f3d8f7d7ccf001b0782', 27, 2, 1, '2019-06-06 11:54:27', '2019-06-06 11:06:27', '2019-06-06 11:06:27');
INSERT INTO `oauth2_access_token` VALUES ('398b006713b0487b8aecb91ab31b094d', '02a59ea295644d2bbe7287ae70715a85', 157, 1, 1, '2019-07-05 16:11:13', '2019-07-05 15:23:12', '2019-07-05 15:23:12');
INSERT INTO `oauth2_access_token` VALUES ('3994e08c2c9140028c02c7ca69fe3e15', '39b014fb2b51449ab472a9204bba6345', 27, 2, 1, '2019-09-06 20:40:47', '2019-09-06 19:52:46', '2019-09-06 19:52:46');
INSERT INTO `oauth2_access_token` VALUES ('399e24e611c7448489f0604316d52af9', '0ec618d1c7d24574a7775540aa1ca3cd', NULL, NULL, 1, '2019-04-22 19:08:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('399e252b10b74a15bbb0b68a93ebcaee', '6235428e8b2c463fa142ea5cca70f234', 27, 2, 1, '2019-08-02 15:06:50', '2019-08-02 14:18:50', '2019-08-02 14:18:50');
INSERT INTO `oauth2_access_token` VALUES ('39a71330dc4147b3be8d53ad8a20c1ae', '108472fe5422414590427304fcf1e178', 1, 2, 1, '2019-09-08 04:34:10', '2019-09-08 03:46:10', '2019-09-08 03:46:10');
INSERT INTO `oauth2_access_token` VALUES ('39b205a9055a4073934bf48211a3ae82', 'dd189db271e140eeb427794d0e45b90e', 27, 2, 1, '2019-09-03 18:42:25', '2019-09-03 17:54:24', '2019-09-03 17:54:24');
INSERT INTO `oauth2_access_token` VALUES ('39b814037d8e43afb050b704ad279b65', 'd70e097f8ef7468298448d1dafc7ce19', 27, 2, 1, '2019-05-21 15:58:08', '2019-05-21 15:10:07', '2019-05-21 15:10:07');
INSERT INTO `oauth2_access_token` VALUES ('39d28b40f9a34648ace9af64c95f57a0', 'ace5f112bb3144af8d62ef1008797571', 27, 2, 1, '2019-08-02 17:08:20', '2019-08-02 16:20:19', '2019-08-02 16:20:19');
INSERT INTO `oauth2_access_token` VALUES ('39e7008c251042539ec4731c87bb7348', '03acec06817c4058b9f35243a86bb372', 27, 2, 1, '2019-08-02 22:17:19', '2019-08-02 21:29:18', '2019-08-02 21:29:18');
INSERT INTO `oauth2_access_token` VALUES ('39eee85bb4194825b4ff64900465e4ca', '4bca174e478445d6b7ae7fecfcc9c120', 27, 2, 1, '2019-06-03 16:58:59', '2019-06-03 16:10:59', '2019-06-03 16:10:59');
INSERT INTO `oauth2_access_token` VALUES ('39f34c5fdccb4f0694cdd46bcd50da64', '9677b7d3221b4d9e92cd821e960063c8', 27, 2, 1, '2019-06-03 14:31:45', '2019-06-03 13:43:44', '2019-06-03 13:43:44');
INSERT INTO `oauth2_access_token` VALUES ('39f4dc8ee2e34bc597d196203a789598', '6d0ac1b29553412bbe6f53f938366225', NULL, NULL, 0, '2019-03-05 05:33:21', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('39f77f2c323a43779b10fbbe4ad3eecd', '24b73f8480db41e5ab68c2e19dd88f81', 27, 2, 1, '2019-07-02 11:42:51', '2019-07-02 10:54:51', '2019-07-02 10:54:51');
INSERT INTO `oauth2_access_token` VALUES ('3a1130c558fa430aa46323f4d38123d3', 'da63c64f70e24422b7217d1568b26bb1', 27, 2, 1, '2019-08-02 16:59:16', '2019-08-02 16:11:15', '2019-08-02 16:11:15');
INSERT INTO `oauth2_access_token` VALUES ('3a14e6cf922945819f595af8867996f4', '90a8eb7fbe0143a8bec42c8b91746510', NULL, NULL, 1, '2019-05-05 17:06:32', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3a1b3fe00fff4992a7f545f750bb4406', '671740ec95ce449da53cabd60fe43b71', 1, 2, 0, '2019-06-06 23:17:20', '2019-06-06 22:29:19', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('3a3009a131fa4d8f8a62470484ef6ecf', 'a9d02048412e488f8d16962ab1af2edf', 27, 2, 1, '2019-08-30 18:04:23', '2019-08-30 17:16:23', '2019-08-30 17:16:23');
INSERT INTO `oauth2_access_token` VALUES ('3a62eea558fe402ca8139ef2222b4233', '0260bb3f960a47339721b22630e2d4f9', 27, 2, 1, '2019-07-19 22:21:50', '2019-07-19 21:33:50', '2019-07-19 21:33:50');
INSERT INTO `oauth2_access_token` VALUES ('3a7e7838bfae4ca395555bf0738a367e', '89cf76a87ce64421bb140cb157cf9651', 27, 2, 1, '2019-06-03 20:43:30', '2019-06-03 19:55:30', '2019-06-03 19:55:30');
INSERT INTO `oauth2_access_token` VALUES ('3ae73cdc512748879e3ba6108cf2d3ad', '0795aa2a094347459577d1cf05c7b947', 27, 2, 1, '2019-05-28 16:40:04', '2019-05-28 15:50:46', '2019-05-28 15:50:46');
INSERT INTO `oauth2_access_token` VALUES ('3aefa0437c1246afbf15c2da5cf53d52', '8be7d6f5994b42fb85a67cf20066caa3', NULL, NULL, 1, '2019-05-02 20:28:48', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3b06fb4cf27f43eb893434d980ad872a', '930e0a5d97cf421cbcad35a929000df6', 1, 2, 0, '2019-05-31 11:40:39', '2019-05-31 10:51:19', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('3b2e33f7b683407b8608e9ff3358f5eb', '07d9a1603cfa4147bf8a9a528d1a68b8', 27, 2, 1, '2019-09-03 15:41:43', '2019-09-03 14:53:42', '2019-09-03 14:53:42');
INSERT INTO `oauth2_access_token` VALUES ('3bb0cc86cd1f45888abfb56c3e29b6a5', 'dafe21789e784a2aaa60ddf930853b35', 27, 2, 1, '2019-05-27 18:34:26', '2019-05-27 17:46:25', '2019-05-27 17:46:25');
INSERT INTO `oauth2_access_token` VALUES ('3bbcde8e78ab4b5d890d858921977f3c', 'f2b251ea0b124787957403ecd02b3e7e', NULL, NULL, 1, '2019-04-24 09:35:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3bee5226a06347ef89b1ab0edbf5ffa4', 'c573053067ce4302a5b7875fd20bc582', 27, 2, 1, '2019-07-04 14:00:50', '2019-07-04 13:12:49', '2019-07-04 13:12:49');
INSERT INTO `oauth2_access_token` VALUES ('3c126e8a73ad42f1883d234fc4235514', '26b2340a809a49d590102a49219cd663', 27, 2, 1, '2019-06-09 17:56:34', '2019-06-09 17:08:33', '2019-06-09 17:08:33');
INSERT INTO `oauth2_access_token` VALUES ('3c1d69d4da9f4a3f8bde3fe7700d8838', 'ce3bafcc71394371b377013538775ab8', 27, 2, 1, '2019-08-01 16:28:12', '2019-08-01 15:40:12', '2019-08-01 15:40:12');
INSERT INTO `oauth2_access_token` VALUES ('3c390ecfb0254bac875fc24e4ac92929', '851cc90beb8647ed8169b3622581e94e', 27, 2, 1, '2019-07-31 21:57:32', '2019-07-31 21:09:31', '2019-07-31 21:09:31');
INSERT INTO `oauth2_access_token` VALUES ('3c5342f5ec754c80aaed41f8afe0c3d7', '1827c2fb8c2d4d639443defa2b9a6344', 27, 2, 1, '2019-07-10 20:55:24', '2019-07-10 20:07:23', '2019-07-10 20:07:23');
INSERT INTO `oauth2_access_token` VALUES ('3c57eda60cac42659817c5f94568babd', '31002ec5c96e409096dc7089c8878223', 27, 2, 1, '2019-07-10 23:45:33', '2019-07-10 22:57:32', '2019-07-10 22:57:32');
INSERT INTO `oauth2_access_token` VALUES ('3c604e35dffa4c189b3ed9dee30ae0e7', '0c7fe3e298114abf837d2e82008d39e0', 27, 2, 1, '2019-05-24 13:20:35', '2019-05-24 12:32:34', '2019-05-24 12:32:34');
INSERT INTO `oauth2_access_token` VALUES ('3c7221bb3dbf4074aa1c5f8f18598a70', 'ad180e1550304562b2b9ebf63b7ac6c9', 27, 2, 1, '2019-05-24 14:26:18', '2019-05-24 13:37:02', '2019-05-24 13:37:02');
INSERT INTO `oauth2_access_token` VALUES ('3c880272841e4bf6acd81ed5dd64e9d8', '36515d16a70948d9a51a96c3e97b5d0f', 27, 2, 1, '2019-07-11 15:20:59', '2019-07-11 14:32:58', '2019-07-11 14:32:58');
INSERT INTO `oauth2_access_token` VALUES ('3c8f46268d98448f880f257395790219', '7f3d8f6812904c90bc1663c7f24ce541', 27, 2, 1, '2019-07-03 17:51:47', '2019-07-03 17:03:47', '2019-07-03 17:03:47');
INSERT INTO `oauth2_access_token` VALUES ('3c9913d3740e40f68d9956ac70a85ba1', '2ae4da974f2240a28c5007e6e980678a', 27, 2, 1, '2019-06-05 09:05:09', '2019-06-05 08:17:09', '2019-06-05 08:17:09');
INSERT INTO `oauth2_access_token` VALUES ('3cdfc2616bb943268287187807601574', '16a72b4aed44436d877aaff0548cab6b', 27, 2, 1, '2019-07-16 15:51:17', '2019-07-16 15:03:16', '2019-07-16 15:03:16');
INSERT INTO `oauth2_access_token` VALUES ('3cdfcba58050424280b4dbd40af71309', '9987db62e5d64b2cbc0a3419f2ae2a3a', 27, 2, 1, '2019-05-23 20:35:29', '2019-05-23 19:47:28', '2019-05-23 19:47:28');
INSERT INTO `oauth2_access_token` VALUES ('3ce504b3a6dc4d6cb31b445de1a30b49', '0b98d2d6df2049b8a82fb720fd225a6d', 27, 2, 1, '2019-08-01 10:50:13', '2019-08-01 10:02:12', '2019-08-01 10:02:12');
INSERT INTO `oauth2_access_token` VALUES ('3ce67fcf9d184ef78d09cfd625735216', 'bb3ba34a1bd24647aa82d626796816b7', 27, 2, 1, '2019-07-18 18:11:59', '2019-07-18 17:23:59', '2019-07-18 17:23:59');
INSERT INTO `oauth2_access_token` VALUES ('3cf02c02c00e49a68ffefe477c2b5190', 'cd3673a600ed4066a1fc7ae7af5f5a0d', 27, 2, 1, '2019-08-26 18:28:38', '2019-08-26 17:40:38', '2019-08-26 17:40:38');
INSERT INTO `oauth2_access_token` VALUES ('3cf8bf281d15428da7b17d4c0738f8fb', 'dda5cd98d94a433aad326c37d306858e', 27, 2, 1, '2019-06-19 22:41:58', '2019-06-19 21:53:58', '2019-06-19 21:53:58');
INSERT INTO `oauth2_access_token` VALUES ('3d0ac6e58729490fbedff3c3ebe38b9b', '895a8a50e1c04872adf36a9256fab399', 27, 2, 1, '2019-07-10 17:17:53', '2019-07-10 16:29:52', '2019-07-10 16:29:52');
INSERT INTO `oauth2_access_token` VALUES ('3d0d2b63e5f4475e885e342d6a6db7da', 'd19a10765cff4bc9995d3b51df24e94f', 27, 2, 1, '2019-06-22 16:23:49', '2019-06-22 15:35:49', '2019-06-22 15:35:49');
INSERT INTO `oauth2_access_token` VALUES ('3d237333cc5346a48d0cceb2be9836a7', 'be9687ccd83a41c6a66cd9ee62c14465', NULL, NULL, 1, '2019-05-17 00:31:13', NULL, '2019-05-16 23:43:12');
INSERT INTO `oauth2_access_token` VALUES ('3d242f96bfac4066badd269586be6e0a', '89ca61db47974b4a9220b9f203ed9fb1', NULL, NULL, 1, '2019-04-29 15:08:26', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3d26f624f2b24c949f82bf8f86a84541', '0f39d327c62b42ce8d837da7545e41fa', NULL, NULL, 1, '2019-05-08 00:11:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3d35d370afd04b5996d45b6566711ab7', 'dfa1b2b4be084977849251eb7aaff4bb', 27, 2, 1, '2019-08-16 17:24:09', '2019-08-16 16:36:08', '2019-08-16 16:36:08');
INSERT INTO `oauth2_access_token` VALUES ('3d6be9284aa04bd8ad73d7046a074fef', 'ea1ccc1f03434ed9b6fa78d2362c54e0', 1, 2, 0, '2019-08-02 00:42:57', '2019-08-01 23:54:57', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('3d6f3fb1e5914bd586ddaeac0de43ca3', '820b7fd6f7424592a952deb608407f25', 27, 2, 1, '2019-07-27 01:36:39', '2019-07-27 00:48:38', '2019-07-27 00:48:38');
INSERT INTO `oauth2_access_token` VALUES ('3d7333f3e6b4472cbe7392b92edb9237', '6a21a52ada5640c8a359c5694f837646', 1, 2, 0, '2019-08-25 21:15:26', '2019-08-25 20:27:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('3d744b0057014fa9a40e97a2d3a77be1', '990df4bb9513415a923a95f2baa6ea07', 27, 2, 1, '2019-06-30 21:59:57', '2019-06-30 21:11:56', '2019-06-30 21:11:56');
INSERT INTO `oauth2_access_token` VALUES ('3d7d1b7d8c7f4f86986582439bd8e0d9', '0d0687562708455ea7b68f8dd1e943d9', 27, 2, 1, '2019-07-26 14:34:29', '2019-07-26 13:46:28', '2019-07-26 13:46:28');
INSERT INTO `oauth2_access_token` VALUES ('3dd5f38507f24a359a3f1dd59b490205', 'bc6b9c7a3ac148c080a583b900336156', 27, 2, 1, '2019-08-27 10:16:25', '2019-08-27 09:28:24', '2019-08-27 09:28:24');
INSERT INTO `oauth2_access_token` VALUES ('3e0817213dd34a9a96c4f1ecf8833c2f', '76a1389046754fd89a56f1bc1ac10f68', 27, 2, 1, '2019-05-20 12:52:40', '2019-05-20 12:04:40', '2019-05-20 12:04:40');
INSERT INTO `oauth2_access_token` VALUES ('3e2cc595553849169cc84edffa608f6f', '2e634a53a1c84325ab0c0f9927575799', 27, 2, 1, '2019-07-03 16:56:23', '2019-07-03 16:08:22', '2019-07-03 16:08:22');
INSERT INTO `oauth2_access_token` VALUES ('3e315b6ac7114876b4b7242706a1bb24', 'b035e1049dda4d9d8370342588d34b5b', 27, 2, 1, '2019-06-14 15:21:59', '2019-06-14 14:33:59', '2019-06-14 14:33:59');
INSERT INTO `oauth2_access_token` VALUES ('3e35192a2d334b37bcc186c0ab1af6da', 'ae8e18d2f50b4c51ad74a30d0f1990de', 27, 2, 1, '2019-06-27 11:54:01', '2019-06-27 11:06:01', '2019-06-27 11:06:01');
INSERT INTO `oauth2_access_token` VALUES ('3e3e9fb3fa0341a69aad380a97d1cae7', '99547e27385148479ad6b6db51fc9d54', 27, 2, 1, '2019-08-29 22:57:37', '2019-08-29 22:09:37', '2019-08-29 22:09:37');
INSERT INTO `oauth2_access_token` VALUES ('3e6d4d73be214746a44a95f88146eb6c', '35529e33c0e849288e7dbb117daa3f6f', NULL, NULL, 1, '2019-05-08 12:03:31', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3ea5e47631a84dcabe1bc9b6769d3a11', 'f014fe464c374ab09013090ec631f49b', 27, 2, 1, '2019-06-13 16:05:31', '2019-06-13 15:17:31', '2019-06-13 15:17:31');
INSERT INTO `oauth2_access_token` VALUES ('3ead903664654336b264a65d583cd4a4', '010ba88f6ebd4cd29f04a6416d0a176a', NULL, NULL, 1, '2019-03-21 00:03:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3eb507cef5264421a81192498b7f2d78', '1965e2a32b5a48dab616139d6af4156a', 27, 2, 1, '2019-08-03 22:02:27', '2019-08-03 21:14:26', '2019-08-03 21:14:26');
INSERT INTO `oauth2_access_token` VALUES ('3eb672f2869549f697fc7b5492aac182', '125e4ff25bfe470aa6904be41f75028e', 27, 2, 1, '2019-06-08 14:15:41', '2019-06-08 13:27:40', '2019-06-08 13:27:40');
INSERT INTO `oauth2_access_token` VALUES ('3ec0178cad0b44758302ded2bbd783e9', '3cf8f3f225034c578c153c54c19e16de', 27, 2, 1, '2019-06-02 11:23:03', '2019-06-02 10:35:02', '2019-06-02 10:35:02');
INSERT INTO `oauth2_access_token` VALUES ('3ecab319b0df45929d009901733dbf0c', '99c88191457a4e26bc2bffe0ddcd310c', 27, 2, 1, '2019-06-02 22:39:44', '2019-06-02 21:51:43', '2019-06-02 21:51:43');
INSERT INTO `oauth2_access_token` VALUES ('3ed3f8c8a5e6427bbb9b87de12d51f5a', 'bb7ec167d7ee494ebe5cd35f5d65ef5f', 27, 2, 1, '2019-08-30 16:32:13', '2019-08-30 15:44:13', '2019-08-30 15:44:13');
INSERT INTO `oauth2_access_token` VALUES ('3efd41e34c1a4a9c8762ffc40289a745', '5cdf529e96f047a39f062cbb17f2d327', 27, 2, 1, '2019-08-04 11:52:30', '2019-08-04 11:04:30', '2019-08-04 11:04:30');
INSERT INTO `oauth2_access_token` VALUES ('3efe2394d4b844e894769ca6cd4974d9', 'b905d28a26544993a4bc57e1d74a8a48', 27, 2, 1, '2019-06-04 11:14:35', '2019-06-04 10:26:35', '2019-06-04 10:26:35');
INSERT INTO `oauth2_access_token` VALUES ('3f05174a7b6a4b49a373d506cb2254f2', '19a8b51051834189a49028d4a15a9463', NULL, NULL, 1, '2019-05-13 11:46:07', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3f0fb6414c8b42d0860fb270cedc1882', 'fea8002073244b0795d593228ab02c51', NULL, NULL, 1, '2019-04-29 14:57:46', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3f2aee75d50c4c57a7372139b63a4977', '39f0757a4e624d658303953486f3779b', 27, 2, 1, '2019-06-04 14:22:50', '2019-06-04 13:34:49', '2019-06-04 13:34:49');
INSERT INTO `oauth2_access_token` VALUES ('3f47ebaa467047e2aef935141c5825f1', '5bb25413d35940108b28375e3cea464b', 1, 2, 0, '2019-06-24 09:15:37', '2019-06-24 08:27:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('3f4e087c8146448b8b36810f1edf9638', '65ee5edb3a3b48c6a82a66bec95c185f', 27, 2, 1, '2019-07-11 00:24:20', '2019-07-10 23:36:19', '2019-07-10 23:36:19');
INSERT INTO `oauth2_access_token` VALUES ('3f53b81d96fa4b9faa1a07f764a5bcdc', 'fe848f84d73b4c15a75aa4c789b0043b', 27, 2, 1, '2019-09-05 12:42:18', '2019-09-05 11:54:18', '2019-09-05 11:54:18');
INSERT INTO `oauth2_access_token` VALUES ('3f53d43475054bc8bfb7652b86dedff8', 'c500cbdedf8d45e090630d7620e7929e', 27, 2, 1, '2019-06-03 16:48:07', '2019-06-03 16:00:06', '2019-06-03 16:00:06');
INSERT INTO `oauth2_access_token` VALUES ('3f5c57b508e94db5b2084b8d3d2e7779', '1e71db772b064f94b1560b4fe2950d05', 27, 2, 1, '2019-09-06 11:02:01', '2019-09-06 10:14:00', '2019-09-06 10:14:00');
INSERT INTO `oauth2_access_token` VALUES ('3f6530f786794dbf87067b918a2559a9', '4c6651878c1c4ccdbef040d8ce8b34bb', 27, 2, 1, '2019-07-30 09:05:53', '2019-07-30 08:17:52', '2019-07-30 08:17:52');
INSERT INTO `oauth2_access_token` VALUES ('3f6532284f594b4eb56da2f5aa5819f4', '4b6f1b70e8684cabb90e1d3e229ea9de', 197, 1, 0, '2019-08-12 18:16:19', '2019-08-12 17:28:19', '2019-08-12 18:29:55');
INSERT INTO `oauth2_access_token` VALUES ('3f6b91dc149345d0a6357c8e774fb611', 'ade30a9e376c4368a56998a1a9597431', 1, 2, 0, '2019-09-05 10:10:56', '2019-09-05 09:22:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('3f6f5d95e37d47d9b661c85532f3c56f', '5738977de7144691a1576af1bed0427b', 27, 2, 1, '2019-08-26 11:56:59', '2019-08-26 11:08:59', '2019-08-26 11:08:59');
INSERT INTO `oauth2_access_token` VALUES ('3f763cdd267748289b718e97f2bdebf2', 'cd7c3ecc540b413da75b1748f80c532b', 27, 2, 1, '2019-05-20 15:33:01', '2019-05-20 14:45:01', '2019-05-20 14:45:01');
INSERT INTO `oauth2_access_token` VALUES ('3f9e1391760040ca8dc5d2a3b81a9870', '64c6e484b61341af94bbf9fc377cbda3', 27, 2, 1, '2019-05-22 11:58:49', '2019-05-22 11:10:48', '2019-05-22 11:10:48');
INSERT INTO `oauth2_access_token` VALUES ('3fa440aede644910a5981a5776ff49e9', '705ce571fc6545c7aa51d488a3a895d6', NULL, NULL, 1, '2019-04-01 19:12:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3faad30df3d748d5a8ee15b3a387037c', 'b1d04067565f4967ac2660664fe283f7', NULL, NULL, 1, '2019-04-29 17:05:17', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3fad66923d294161b7de6fcd20efc139', '1c82bad7df1449ffa38a55cc7ad3f0a1', 27, 2, 1, '2019-08-13 23:14:59', '2019-08-13 22:26:59', '2019-08-13 22:26:59');
INSERT INTO `oauth2_access_token` VALUES ('3fba1126a2c747988b252cb8c876c660', 'afde2b22880447428c4b075f3a083830', NULL, NULL, 1, '2019-03-15 20:11:09', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('3fcde18c447e441b8fd45992d1e2e910', 'acb5dff8b2b2497a9966a2322317ccb0', 27, 2, 1, '2019-07-12 18:00:34', '2019-07-12 17:12:34', '2019-07-12 17:12:34');
INSERT INTO `oauth2_access_token` VALUES ('3fe0da0bcb7544ee9ff50741d129a8bc', '3872c983513148839a6b0d450df65ed4', 27, 2, 1, '2019-07-02 22:16:06', '2019-07-02 21:28:05', '2019-07-02 21:28:05');
INSERT INTO `oauth2_access_token` VALUES ('3fe20d4d0f674a1cbb90a28c2192e9b7', '21e663cabcad4392b05ad60e4c9bf1b4', 27, 2, 1, '2019-06-20 14:32:18', '2019-06-20 13:44:18', '2019-06-20 13:44:18');
INSERT INTO `oauth2_access_token` VALUES ('3fe4c6ad33e14891a12058f8cc10a2a1', '6544fcd464ce4d4f93267d52db308b59', 1, 2, 0, '2019-07-20 16:32:51', '2019-07-20 15:44:50', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('3fe90375fd79440d843d6056b853381e', '74397fd2a1c249379b6abf93f17e1963', 27, 2, 1, '2019-07-13 21:04:56', '2019-07-13 20:16:56', '2019-07-13 20:16:56');
INSERT INTO `oauth2_access_token` VALUES ('3feba5ab98a54d24976bb7089541a003', 'a084c83324e54d728d232ad8af1aac80', 27, 2, 1, '2019-07-29 21:40:28', '2019-07-29 20:52:27', '2019-07-29 20:52:27');
INSERT INTO `oauth2_access_token` VALUES ('3fedbd0a032e44879471438d0f22b34b', '2cd3220e35164829882bd669dc52cfd3', 27, 2, 1, '2019-08-08 18:18:44', '2019-08-08 17:30:43', '2019-08-08 17:30:43');
INSERT INTO `oauth2_access_token` VALUES ('3ff82eab8d7b472da04d39744956d515', '7ef144ad7ebe4867a702e8961f2423f1', 27, 2, 1, '2019-08-24 09:42:15', '2019-08-24 08:54:15', '2019-08-24 08:54:15');
INSERT INTO `oauth2_access_token` VALUES ('3ff9605a7fd740488be293706fdc1204', 'f8a10b93e3e74e97bb20a8037341c881', 27, 2, 1, '2019-07-01 18:41:41', '2019-07-01 17:53:40', '2019-07-01 17:53:40');
INSERT INTO `oauth2_access_token` VALUES ('401c31d3b6354fec91e6a9ea7d3bf520', '9b9fa17ab2d142c0936f4928a3854504', NULL, NULL, 1, '2019-04-28 14:46:49', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4028f2855622455985661a7872fbb1fa', '3aa7592177274693a158dcea2af204af', NULL, NULL, 1, '2019-04-29 15:21:00', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('40297d8a6962464393f31a6a8a933585', 'c3117b7990b2443f87606c43b2011809', 27, 2, 1, '2019-06-21 22:14:06', '2019-06-21 21:26:06', '2019-06-21 21:26:06');
INSERT INTO `oauth2_access_token` VALUES ('40324b96664c40a3976571450b2bdd5c', '8d56052f96b944f6830a9741f3c21011', 27, 2, 1, '2019-08-09 21:42:16', '2019-08-09 20:54:16', '2019-08-09 20:54:16');
INSERT INTO `oauth2_access_token` VALUES ('404a7efa58624635a2f0c65a5b2931be', '07a094165a0c45ecbd0d667476347c19', 1, 2, 0, '2019-06-05 10:28:47', '2019-06-05 09:40:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('40616750d4774706891ce0fbb2baf0f3', 'c2a6cb5ce2a342189dcd421bfb9eab1c', 27, 2, 1, '2019-09-05 14:49:58', '2019-09-05 14:01:57', '2019-09-05 14:01:57');
INSERT INTO `oauth2_access_token` VALUES ('4068b6331033494291613d333421f4e3', '04d91eefcb68437381fe69c6ab2d4e66', 27, 2, 1, '2019-06-19 15:53:13', '2019-06-19 15:05:12', '2019-06-19 15:05:12');
INSERT INTO `oauth2_access_token` VALUES ('409a408adc404ec1858a06a022549dce', 'd9953d3872ea46778d587337628b489c', 27, 2, 1, '2019-06-26 14:33:32', '2019-06-26 13:45:32', '2019-06-26 13:45:32');
INSERT INTO `oauth2_access_token` VALUES ('40c5f22033a147908027bbd5085cfc29', 'f6a6c3d5ebbd4e4dba81d6b94bac75ed', 27, 2, 1, '2019-06-06 10:38:44', '2019-06-06 09:50:44', '2019-06-06 09:50:44');
INSERT INTO `oauth2_access_token` VALUES ('40ca0320a1404442bc213e74911ca379', '974836dc2c704f0eafb16bc7f8d65333', 27, 2, 1, '2019-06-02 11:21:05', '2019-06-02 10:33:04', '2019-06-02 10:33:04');
INSERT INTO `oauth2_access_token` VALUES ('40cd3a5381fe46b185f7031a9b8dd910', '71341e1aa21546ee84f0305e95dcc993', 27, 2, 1, '2019-07-11 11:50:55', '2019-07-11 11:02:54', '2019-07-11 11:02:54');
INSERT INTO `oauth2_access_token` VALUES ('40fa6d5fcd6e433d9029756c60636c9d', 'a5d3a44090664bdb9b0a733eba8ea049', 27, 2, 1, '2019-07-17 22:26:12', '2019-07-17 21:38:11', '2019-07-17 21:38:11');
INSERT INTO `oauth2_access_token` VALUES ('4109ed148b2145f4968d7fd7a15745be', 'd17f59fa21e943e1b410d220f21bf006', NULL, NULL, 1, '2019-05-05 22:44:36', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('41200d2fe44f438986eb7edb8c87e2e7', '798189be090f431ab863a81999b5421b', 27, 2, 1, '2019-06-11 16:40:59', '2019-06-11 15:52:58', '2019-06-11 15:52:58');
INSERT INTO `oauth2_access_token` VALUES ('412853636d614fc1843d541cdab8349c', 'c74198e7c83c4f85a0fecc74ec7a616e', 27, 2, 1, '2019-07-12 10:58:04', '2019-07-12 10:10:04', '2019-07-12 10:10:04');
INSERT INTO `oauth2_access_token` VALUES ('413487ac8ba94ef988373f30ad228af4', '31372ce77b3e43058abfb62556b7147a', 27, 2, 1, '2019-07-20 18:34:27', '2019-07-20 17:46:26', '2019-07-20 17:46:26');
INSERT INTO `oauth2_access_token` VALUES ('4139011c74f643d4a0655419699201f7', '97faa7e5823749829fff66f6b287e085', 27, 2, 1, '2019-07-23 23:04:56', '2019-07-23 22:16:55', '2019-07-23 22:16:55');
INSERT INTO `oauth2_access_token` VALUES ('41687de4354a46978c21c2241cad8a0f', '983795b5cc834c50a9a0a839773b9e0d', NULL, NULL, 1, '2019-05-05 15:17:42', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('416d4f4013f448ff9ef868fbb9d732be', 'e21beefb0ce9486199258c1c742bd0bb', 27, 2, 1, '2019-06-11 12:07:12', '2019-06-11 11:19:11', '2019-06-11 11:19:11');
INSERT INTO `oauth2_access_token` VALUES ('4171a09b370a4a8dbdf825403ea4fb83', 'c984b961bb5b4cb981e416587301b21a', 27, 2, 1, '2019-06-10 11:20:46', '2019-06-10 10:32:45', '2019-06-10 10:32:45');
INSERT INTO `oauth2_access_token` VALUES ('41785acd3a554a02978bc1846a1a7273', '05a188dd885b4737be4dc402625dde0e', 27, 2, 1, '2019-09-03 17:54:19', '2019-09-03 17:06:18', '2019-09-03 17:06:18');
INSERT INTO `oauth2_access_token` VALUES ('4188dd42f7a14d7980888fb2fcb04851', '5587a66ac1af49d19f57376635191608', 27, 2, 1, '2019-08-08 15:15:37', '2019-08-08 14:27:37', '2019-08-08 14:27:37');
INSERT INTO `oauth2_access_token` VALUES ('418aa7412c1741c6a88937b51f89d351', 'cfef6841b6a843829059f5ad3fbe65a4', 84, 1, 1, '2019-05-27 10:46:17', '2019-05-27 09:58:16', '2019-05-27 09:58:16');
INSERT INTO `oauth2_access_token` VALUES ('418d3ef51b8848ef9ca8ef330e14150a', '1a599a741df14c5c81e7d5fec3bb10c5', 1, 2, 0, '2019-08-23 10:22:06', '2019-08-23 09:34:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('41a5431693a948b688086097236bce64', '213f981c4e864f7b82e27e59d00bf136', 27, 2, 1, '2019-06-25 12:19:06', '2019-06-25 11:31:05', '2019-06-25 11:31:05');
INSERT INTO `oauth2_access_token` VALUES ('41aacfa0268343b0be2ef39b9d0f63a7', '72e19c58629744fea2d0b624a33d3bfe', 27, 2, 1, '2019-06-03 11:30:29', '2019-06-03 10:42:29', '2019-06-03 10:42:29');
INSERT INTO `oauth2_access_token` VALUES ('41b268a9560e4ed1972e3d8bae5f8e1d', 'b4cdde90e7ed40caba3775bd70403686', 27, 2, 1, '2019-06-01 11:25:47', '2019-06-01 10:37:47', '2019-06-01 10:37:47');
INSERT INTO `oauth2_access_token` VALUES ('41b7312b1b854115a664910c1bdbba7c', '5ddb7a08fe5f45a2a9840fdd4d902495', 27, 2, 1, '2019-08-20 19:12:12', '2019-08-20 18:24:12', '2019-08-20 18:24:12');
INSERT INTO `oauth2_access_token` VALUES ('41c155417ecd44cfb72da853d5d1543e', 'dfc5438af81642cb939051404fd71d8f', NULL, NULL, 1, '2019-03-12 23:53:03', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('41d348750995449ba2abeeca6634aa5c', 'f5145ae1e6b94a339696bc7cd8f09f05', NULL, NULL, 1, '2019-03-22 12:45:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('41d6a89cfe9f4569a7afdad22a124eac', 'cf34052b37e4459fa306d343b0295c89', 27, 2, 1, '2019-07-15 19:03:08', '2019-07-15 18:15:07', '2019-07-15 18:15:07');
INSERT INTO `oauth2_access_token` VALUES ('41dd5e695bd343fb8ce7bb03b0f001e8', '8d74a19fd67e43b3ac6dde6c4e88023d', NULL, NULL, 1, '2019-03-15 16:57:42', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('41e5e6c3b7104261a6fcbe54315956a2', 'e3bf34f3961947a184e87b8f84ede03b', 27, 2, 1, '2019-07-23 10:22:05', '2019-07-23 09:34:04', '2019-07-23 09:34:04');
INSERT INTO `oauth2_access_token` VALUES ('41e95fc1bfe94d83b0c10f7b37ed1757', '0789b872b14043268817941a0c474644', 27, 2, 1, '2019-06-08 18:40:57', '2019-06-08 17:52:56', '2019-06-08 17:52:56');
INSERT INTO `oauth2_access_token` VALUES ('42042e868e08405eacf24a713bb31098', 'e73f5f3b28994172b7dc2157027d3695', 27, 2, 1, '2019-07-05 18:38:04', '2019-07-05 17:50:03', '2019-07-05 17:50:03');
INSERT INTO `oauth2_access_token` VALUES ('4208881bd4b9413385446b510db7712c', 'e853211bd41e488f9ea4efb808e56c79', NULL, NULL, 1, '2019-03-11 23:52:58', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('422874b2374a492d9ac4bd696eaaab6e', '531e587c5f934260980f7d7bd0ef22eb', 27, 2, 1, '2019-06-25 12:11:49', '2019-06-25 11:23:48', '2019-06-25 11:23:48');
INSERT INTO `oauth2_access_token` VALUES ('4239d68c34ad4176b75b8a519774e11a', '664e9b0f8ae7428389b27b37b8c35436', 27, 2, 1, '2019-08-27 01:15:44', '2019-08-27 00:27:44', '2019-08-27 00:27:44');
INSERT INTO `oauth2_access_token` VALUES ('42585a3e55e14b18a22c2cc4f1ee3b1f', '23dd6503c3c2477583c57beeabd1e56c', NULL, NULL, 1, '2019-05-13 01:09:09', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('427962b49d8b4232a32e7da27204a63f', '53a7619e43b748499579bb7ce44f236c', 1, 1, 0, '2019-05-17 12:46:09', '2019-05-17 11:58:08', '2019-05-17 13:45:39');
INSERT INTO `oauth2_access_token` VALUES ('4280a89344bd46f0ad37debc4b60ee35', '087c3fec9e83455085caccf283bbc009', NULL, NULL, 1, '2019-05-11 11:50:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4281955f646a4a8691c8df9241bada31', '03a38bac9bbd451394bacbbc3ae92267', 27, 2, 1, '2019-07-18 17:54:31', '2019-07-18 17:06:31', '2019-07-18 17:06:31');
INSERT INTO `oauth2_access_token` VALUES ('428460c86163463187908ca4bfedcf31', '364a885afc204502806867aca5ba6a85', NULL, NULL, 1, '2019-04-24 07:18:58', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4286d684a37e4728a84664ccfd6a4648', '8337f83d36454697bb447e391b005633', NULL, NULL, 0, '2019-03-03 22:29:10', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('428904733d91462fa49424bcd85934fb', '09e6bc7863f140c9bbeb4e51d62bfc13', 27, 2, 1, '2019-06-22 23:54:35', '2019-06-22 23:06:34', '2019-06-22 23:06:34');
INSERT INTO `oauth2_access_token` VALUES ('429607be98cd46d2af3b3816ab864bb9', '727f39dc8ca54068906be6be2c9131e4', 27, 2, 1, '2019-05-28 11:55:44', '2019-05-28 11:07:43', '2019-05-28 11:07:43');
INSERT INTO `oauth2_access_token` VALUES ('42992f3cc5234456b880456977c8ad49', '9d1eb44ffc1c44d2a6f429f6d95c4614', 27, 2, 1, '2019-06-24 15:29:26', '2019-06-24 14:41:26', '2019-06-24 14:41:26');
INSERT INTO `oauth2_access_token` VALUES ('429f99641d3b4ac3bf1e72d1154f5d67', 'dc13d98e3f034f6dad29ffe459bdf912', 27, 2, 1, '2019-06-08 14:43:18', '2019-06-08 13:55:18', '2019-06-08 13:55:18');
INSERT INTO `oauth2_access_token` VALUES ('42acd0effc9a4538b2b516a610ccdf2a', '11fee2629ff1409c947d553be382fb1f', 27, 2, 1, '2019-09-04 18:12:41', '2019-09-04 17:24:41', '2019-09-04 17:24:41');
INSERT INTO `oauth2_access_token` VALUES ('42b0d2cf21b44fdbb945fb85a09e6174', 'a9e7e8151ccb44588ee661d77669cc4b', 27, 2, 1, '2019-06-11 14:40:00', '2019-06-11 13:51:59', '2019-06-11 13:51:59');
INSERT INTO `oauth2_access_token` VALUES ('42c34b8cc5f84767b2b72515b1e4efdc', 'ec79bc01b7fc4f85a0ebd93fb574b22b', 27, 2, 1, '2019-08-12 12:28:59', '2019-08-12 11:40:58', '2019-08-12 11:40:58');
INSERT INTO `oauth2_access_token` VALUES ('42dc3419707e4d4593a6116f6951f3fc', '5711ef1daa8f4e1aae31272afa826b5d', 27, 2, 1, '2019-06-02 17:59:11', '2019-06-02 17:11:11', '2019-06-02 17:11:11');
INSERT INTO `oauth2_access_token` VALUES ('42ef8e82cdc941ff951507ea72165613', 'd7b1e96bfefe4949b9bc12377aaac884', NULL, NULL, 1, '2019-05-09 15:16:54', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('42f017dbe961494bbd905a6e086bec44', 'a9ebd9d601f24aa096f5e5e38befdef7', 27, 2, 1, '2019-07-17 16:44:15', '2019-07-17 15:56:14', '2019-07-17 15:56:14');
INSERT INTO `oauth2_access_token` VALUES ('42f1a312c7b544ffb9b0fa98c5dce6ac', 'ec0812f1a6124af9857dba73cf6ba826', NULL, NULL, 1, '2019-05-08 20:43:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('42f5d59add1d4b94a9f087e6035df848', 'ee5bdc47c64048c79c7932b52375c65a', 27, 2, 1, '2019-05-31 20:15:41', '2019-05-31 19:27:41', '2019-05-31 19:27:41');
INSERT INTO `oauth2_access_token` VALUES ('4313077aae594dffbf10e9c5c8273ce3', '5d2960a7ed844a009e97df04a396554f', NULL, NULL, 1, '2019-05-12 23:21:21', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4315873648544ef9b72db1a6a9a4dfd5', 'ff92c90db36b42b38bb01775079e11c3', NULL, NULL, 1, '2019-03-22 14:17:06', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('43279877c0524f7f89881d96214d9d1e', 'dc44740dfd284f5abfb72a33bd766f44', 27, 2, 1, '2019-08-19 15:55:35', '2019-08-19 15:07:34', '2019-08-19 15:07:34');
INSERT INTO `oauth2_access_token` VALUES ('4359d9b814f542f199bfb493cad2ecf8', 'd8561121c97540b6bbc0807884ebebb6', NULL, NULL, 1, '2019-04-12 20:15:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('436094f5ff714ebfbe16be18428ac727', '5e0fc392bbcb405b8af5175ef56bbbe9', 1, 2, 0, '2019-07-27 01:37:16', '2019-07-27 00:49:15', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('43890afe0bd3425db0b4e4a198d36acd', 'bd85db53d45243fb9e69e1b231d88876', 27, 2, 1, '2019-08-22 14:52:00', '2019-08-22 14:04:00', '2019-08-22 14:04:00');
INSERT INTO `oauth2_access_token` VALUES ('43955ee9f36d44c7861098414f2a4869', '4de7a43e4f8e4de78dc166b9f848b368', 27, 2, 1, '2019-07-16 16:13:22', '2019-07-16 15:25:21', '2019-07-16 15:25:21');
INSERT INTO `oauth2_access_token` VALUES ('43bb106f37044915b94d39aaad4a4395', '85f74c15097641299ac356bd275d01ee', NULL, NULL, 1, '2019-05-15 23:15:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('43bf1dc271b64f8f8b8eecfe7f478e28', '34fc43241a8740758870fa96624e7fb9', 27, 2, 1, '2019-06-19 14:43:14', '2019-06-19 13:55:13', '2019-06-19 13:55:13');
INSERT INTO `oauth2_access_token` VALUES ('43c7fcdf09a74fb59648de4583f53e3e', 'de03f4e50cd44260bfc88b3580ac3b0c', 1, 2, 0, '2019-08-28 16:42:36', '2019-08-28 15:54:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('43caf4ba1bfc4ddcbdf2f340bc0915f5', 'dcf35e0af46a47a493846baad97a3bf9', 222, 1, 1, '2019-09-05 16:01:54', '2019-09-05 15:13:53', '2019-09-05 15:13:53');
INSERT INTO `oauth2_access_token` VALUES ('43cf0398f52a44faad5fc0354da94114', '7009cff2c6a54cfc93bd9be74715f1ff', 27, 2, 1, '2019-06-16 18:38:24', '2019-06-16 17:50:24', '2019-06-16 17:50:24');
INSERT INTO `oauth2_access_token` VALUES ('43d1343ab07e47aca709faac0c7c6ed3', '2436b7fb8f5e4f2f933873031f815be1', NULL, NULL, 1, '2019-05-04 03:11:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('43d3a4b030e44a1fa4ca8b1d78c7c7d2', '09e7fd57ebd348c3b35859e4717053fe', NULL, NULL, 1, '2019-05-03 14:34:00', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('43d852370f324a92a7737206c0cc121a', '4fee2a420a444d19bacfcbe301df126d', 27, 2, 1, '2019-06-04 12:14:39', '2019-06-04 11:26:38', '2019-06-04 11:26:38');
INSERT INTO `oauth2_access_token` VALUES ('43db9cf66e344bb1a9b516210338b953', '7e44afcc3983424a92d77ae61e2764e0', 27, 2, 1, '2019-08-28 01:17:35', '2019-08-28 00:29:34', '2019-08-28 00:29:34');
INSERT INTO `oauth2_access_token` VALUES ('43f673f9b50c4cd0ae4f974f81f3c752', '5fe9d1977f0945cc95ff599dbfe2543d', 27, 2, 1, '2019-07-24 11:57:33', '2019-07-24 11:09:32', '2019-07-24 11:09:32');
INSERT INTO `oauth2_access_token` VALUES ('4409bac0a2514de0ade1999932f76aaf', '0319ab2dd47c4de69be3c8efdb43519e', 1, 2, 0, '2019-05-16 21:10:10', '2019-05-16 20:22:09', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('442a8cfebc0d47109f460c0982a4727a', '03b6c115695742c8b0ddaed3909e0f41', 27, 2, 1, '2019-07-07 16:58:45', '2019-07-07 16:10:45', '2019-07-07 16:10:45');
INSERT INTO `oauth2_access_token` VALUES ('442d686261e2446bb1f5820d276c867f', '4446ef4641be40a090d05e77c7977049', NULL, NULL, 1, '2019-05-02 02:30:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4433ae0e55814a78987e8d3d1df1d04e', '0d8d7b8341af4077852c5f04a5472701', 1, 2, 0, '2019-06-25 13:43:05', '2019-06-25 12:55:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('4435b60edd174c6daa0038b80e3c9a2f', 'fe461a1ee724484797511c27aeb1b108', 27, 2, 1, '2019-06-01 10:46:00', '2019-06-01 09:58:00', '2019-06-01 09:58:00');
INSERT INTO `oauth2_access_token` VALUES ('44606b7b118344b98c2324edc2e7d562', '7f346400149a49258d79d67e423f51ee', 27, 2, 1, '2019-06-04 09:34:12', '2019-06-04 08:46:12', '2019-06-04 08:46:12');
INSERT INTO `oauth2_access_token` VALUES ('44644b9209e14209abf2a9d097dba1c7', '45870c453f6c4983ab2fd7720f11644f', 27, 2, 1, '2019-09-03 17:18:55', '2019-09-03 16:30:54', '2019-09-03 16:30:54');
INSERT INTO `oauth2_access_token` VALUES ('446bc532d73e4d8996441844fe400d37', '2d06c8583a3d4a62bfb7152b03037072', 27, 2, 1, '2019-06-14 10:04:49', '2019-06-14 09:16:49', '2019-06-14 09:16:49');
INSERT INTO `oauth2_access_token` VALUES ('447425ca59f24bf9bcaa13205d00e252', '84b9685cecaf49928ee1a621e8288dcc', NULL, NULL, 1, '2019-05-08 15:54:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('448dc643505240f9b0bd65877d36741d', '0734d1c9986a42e9b8924ebb3f64a109', 27, 2, 1, '2019-09-03 09:18:18', '2019-09-03 08:30:18', '2019-09-03 08:30:18');
INSERT INTO `oauth2_access_token` VALUES ('4493f71c011c48a188ee0c3009bca153', '5b9b8a43a1574799a2e58f19b785ad8f', NULL, NULL, 1, '2019-05-09 16:57:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('449b2a1ca8a7462789e32c74aa0be752', 'bc077a5bd704424a8be6c5ce6c1647ca', 27, 2, 1, '2019-08-25 11:55:31', '2019-08-25 11:07:30', '2019-08-25 11:07:30');
INSERT INTO `oauth2_access_token` VALUES ('449f766444534560a64c372920e399e2', 'bf7f6a94b2cb4c9fa4ea7c748936c6aa', 27, 2, 1, '2019-08-11 09:06:41', '2019-08-11 08:18:41', '2019-08-11 08:18:41');
INSERT INTO `oauth2_access_token` VALUES ('44a4098ca1e0401fa13f7818f6548c16', 'be4fdcb51c3c479fa45d8cf601426c8f', 27, 2, 1, '2019-06-12 14:49:02', '2019-06-12 14:01:01', '2019-06-12 14:01:01');
INSERT INTO `oauth2_access_token` VALUES ('44af1760179f425395fc724451c11cee', '0106f4bfa30d49ebb6c15269c9b76c41', 27, 2, 1, '2019-05-27 16:10:04', '2019-05-27 15:22:04', '2019-05-27 15:22:04');
INSERT INTO `oauth2_access_token` VALUES ('44b2864b34fe478da458d940ee8c0ea3', '18c99d34796849febb3bcc2d779a4fc9', 27, 2, 1, '2019-06-25 17:44:36', '2019-06-25 16:56:36', '2019-06-25 16:56:36');
INSERT INTO `oauth2_access_token` VALUES ('44ba362202114d0696f751d743d69aea', '0b7abf23e3b748a7adb30f4763f87bad', 27, 2, 1, '2019-08-18 22:31:08', '2019-08-18 21:43:08', '2019-08-18 21:43:08');
INSERT INTO `oauth2_access_token` VALUES ('44ba9526e7c54974ab2b4fa966870d5f', '666c30f9ab0d446bba16ddabe6c08141', 27, 2, 1, '2019-06-12 09:26:49', '2019-06-12 08:38:48', '2019-06-12 08:38:48');
INSERT INTO `oauth2_access_token` VALUES ('44c92ac079364956b2eb45af7efd9394', '31051e034891462dadb3c82498318666', 27, 2, 1, '2019-06-03 01:42:13', '2019-06-03 00:54:12', '2019-06-03 00:54:12');
INSERT INTO `oauth2_access_token` VALUES ('44d4a9a565684564844efa1ae1ad4b9a', '1428afb592f749c0881d193a014cec3d', 1, 2, 0, '2019-08-21 18:49:54', '2019-08-21 18:01:53', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('44d7f3478abc4f19a105de4cf178da27', '650f8933819f490ba94860876008889f', 27, 2, 1, '2019-07-30 10:17:44', '2019-07-30 09:29:44', '2019-07-30 09:29:44');
INSERT INTO `oauth2_access_token` VALUES ('44e8c7a0f178408d855c475da25571d0', '6e2ed49b235d4678b868103420284807', 27, 2, 1, '2019-08-23 10:41:33', '2019-08-23 09:53:33', '2019-08-23 09:53:33');
INSERT INTO `oauth2_access_token` VALUES ('44f7169356f84e7380bf8127eaf8b2a8', '38bf46d9cdf94610b22effffddc15be6', 27, 2, 1, '2019-06-03 10:23:14', '2019-06-03 09:35:14', '2019-06-03 09:35:14');
INSERT INTO `oauth2_access_token` VALUES ('4504a2cb3cc74272b68580d1b7ecfa3d', 'ec959a2a5db9445c8a449ca06901112a', 27, 2, 1, '2019-05-31 14:32:59', '2019-05-31 13:44:59', '2019-05-31 13:44:59');
INSERT INTO `oauth2_access_token` VALUES ('450f413469b842238b3bda2ad25924ac', '1cf1efa56e8c459986330a7cc7f88e46', NULL, NULL, 0, '2019-02-28 05:42:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('451ed71003514f41b3fb3cdd2685998a', '8040fb73cbcb46ecb45bf91824a6029a', 27, 2, 1, '2019-07-08 23:30:16', '2019-07-08 22:42:16', '2019-07-08 22:42:16');
INSERT INTO `oauth2_access_token` VALUES ('4529f80ad150424795ed547c55fa2034', '0038ab4a0ef14bb689ef8421e7521db3', 27, 2, 1, '2019-06-22 13:35:37', '2019-06-22 12:47:36', '2019-06-22 12:47:36');
INSERT INTO `oauth2_access_token` VALUES ('4536415dbd3b441c85af04d4e0c0b041', 'a419566b878b4beb90dbba9fcea788e9', 27, 2, 1, '2019-06-08 01:33:24', '2019-06-08 00:45:24', '2019-06-08 00:45:24');
INSERT INTO `oauth2_access_token` VALUES ('4539f4a7477a4818807fcef7d3a0c77a', 'e64cbe60f2f741b593c82074884e339a', NULL, NULL, 1, '2019-04-24 08:13:03', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('453b9dbd6d8942178aabca6d8a6cfb81', '85d895cb981640eb978a7240d0fe8e9a', 27, 2, 1, '2019-08-07 15:39:30', '2019-08-07 14:51:29', '2019-08-07 14:51:29');
INSERT INTO `oauth2_access_token` VALUES ('4543c7ed83854282bd38d63469d7e2ca', 'a5406c7a2973453bb8017494949e1485', 27, 2, 1, '2019-08-15 18:10:36', '2019-08-15 17:22:36', '2019-08-15 17:22:36');
INSERT INTO `oauth2_access_token` VALUES ('4561c998781c463aadd112c9bf769d80', '985b32b4c1094811aa1265e8dc85c414', 27, 2, 1, '2019-06-03 16:49:58', '2019-06-03 16:01:57', '2019-06-03 16:01:57');
INSERT INTO `oauth2_access_token` VALUES ('458aeabc7b73497cb48b71bdd4969012', 'ad664a2eca0d4a0ba7f485b434ca79a3', 27, 2, 1, '2019-07-25 00:22:04', '2019-07-24 23:34:04', '2019-07-24 23:34:04');
INSERT INTO `oauth2_access_token` VALUES ('458bca57b9e74b4ea62a552208bec5b0', '11b933ec4caa489f95bbdb3931d8e790', 27, 2, 1, '2019-07-12 18:37:48', '2019-07-12 17:49:48', '2019-07-12 17:49:48');
INSERT INTO `oauth2_access_token` VALUES ('45a075ab843a4fd98feed6fa5f6bb3a9', '9b386fe97a1d432b8cf4f790930885f4', 27, 2, 1, '2019-06-23 17:01:47', '2019-06-23 16:13:46', '2019-06-23 16:13:46');
INSERT INTO `oauth2_access_token` VALUES ('45b4b7c07e914113be5f439362f2bc97', '0c54c4fb84034ad8b0ff084e852b1214', NULL, NULL, 1, '2019-04-28 10:00:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('45c0b25cb72a4129a41c4ee359590130', '2a194a966c234d5595b3a2e734755a61', 27, 2, 1, '2019-06-14 10:05:57', '2019-06-14 09:17:56', '2019-06-14 09:17:56');
INSERT INTO `oauth2_access_token` VALUES ('45c134ca62de42ef9717503ab8eb7b28', '9e3f30fd2108451286fde130083f5fe1', 27, 2, 1, '2019-06-03 14:44:24', '2019-06-03 13:56:23', '2019-06-03 13:56:23');
INSERT INTO `oauth2_access_token` VALUES ('45d6419a0a0344e193b323f803143e93', '2dfc816063ae44d48c50711107561585', 27, 2, 1, '2019-09-08 11:35:43', '2019-09-08 10:47:43', '2019-09-08 10:47:43');
INSERT INTO `oauth2_access_token` VALUES ('45d9b9ac0cf84790bf27b753bcc2ec3d', '368721708ff442d99d24de221d9b9953', NULL, NULL, 0, '2019-03-03 22:58:30', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('45e0cc9039d84243ac129b311269040e', '81e73c9d5ccd4ffaade78a324e578d7d', 27, 2, 1, '2019-07-11 18:43:17', '2019-07-11 17:55:17', '2019-07-11 17:55:17');
INSERT INTO `oauth2_access_token` VALUES ('45e118cfa9754688953657e9f315fdfd', '1a1bbf00130b4d809ac11b7586d40069', 27, 2, 1, '2019-07-04 20:50:20', '2019-07-04 20:02:19', '2019-07-04 20:02:19');
INSERT INTO `oauth2_access_token` VALUES ('45ed9a6ef9df4b3491420d95ebbc4c57', '8bfc37d30a0446a0ae67baf20ac64c74', 27, 2, 1, '2019-06-20 09:59:45', '2019-06-20 09:11:45', '2019-06-20 09:11:45');
INSERT INTO `oauth2_access_token` VALUES ('45f869841f394ae8b4eed3bf6fc17ce9', 'e7f46459eb0e4ae39e2037e018ca365d', 1, 2, 0, '2019-08-11 17:30:36', '2019-08-11 16:42:35', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('45f8f4cfed9a4463b5b61ec2713d2ef5', 'be9d84e5ae044d679c56efd4bae16e81', 27, 2, 1, '2019-07-10 16:23:39', '2019-07-10 15:35:38', '2019-07-10 15:35:38');
INSERT INTO `oauth2_access_token` VALUES ('461cf53681294521a38155f61f7f2b7c', '2167ea26e59d4be1807e8d510f130d77', NULL, NULL, 1, '2019-05-13 15:35:26', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4641f28057d74243b09134883ef2602c', 'd857f0a60ca24be0be4123ee9f339b0f', NULL, NULL, 1, '2019-05-13 15:54:21', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('46578064cf5f4a86b931f4936dee0dd3', 'a6d9b5f74f4f4e58af9ae73e5b255a5a', 27, 2, 1, '2019-08-27 15:56:01', '2019-08-27 15:08:01', '2019-08-27 15:08:01');
INSERT INTO `oauth2_access_token` VALUES ('465fa3515efa40d9948352b1c6304172', '35d7ad872b414c708094462dbcf34e97', 27, 2, 1, '2019-09-02 23:37:07', '2019-09-02 22:49:06', '2019-09-02 22:49:06');
INSERT INTO `oauth2_access_token` VALUES ('4667312106284c4887735bd837196960', '1727db50a7af45b6a645c147c5c2866f', 27, 2, 1, '2019-08-21 18:50:44', '2019-08-21 18:02:43', '2019-08-21 18:02:43');
INSERT INTO `oauth2_access_token` VALUES ('46794f363b9b4250994ab022ff6257db', '1a790d454c784259b78fbd42d94cb146', 27, 2, 1, '2019-08-21 17:30:47', '2019-08-21 16:42:47', '2019-08-21 16:42:47');
INSERT INTO `oauth2_access_token` VALUES ('46ac5951bda045a9b1c30c341bb8b022', '77728e711aa8445784224a175fe8487b', 27, 2, 1, '2019-07-22 10:49:39', '2019-07-22 10:01:38', '2019-07-22 10:01:38');
INSERT INTO `oauth2_access_token` VALUES ('46b8ac25c395421398ee427c97e056ec', 'f680bfaa04ed445fbfd932fb8927cfa7', 27, 2, 1, '2019-06-04 09:46:45', '2019-06-04 08:58:45', '2019-06-04 08:58:45');
INSERT INTO `oauth2_access_token` VALUES ('46ba33313fb3461996dd440dec33a9aa', '827bbbff7f104620bd2ac5314ac3206f', 27, 2, 1, '2019-06-14 00:36:20', '2019-06-13 23:48:19', '2019-06-13 23:48:19');
INSERT INTO `oauth2_access_token` VALUES ('46cd0746b8dd45c197d483528dbed8af', 'ac1ed21a95ed4cde8b48d5a49aa0a089', 27, 2, 1, '2019-07-01 00:20:54', '2019-06-30 23:32:53', '2019-06-30 23:32:53');
INSERT INTO `oauth2_access_token` VALUES ('46cea575fb65444f9a2f0d3cc1106772', 'ad30ad871935453a951f4465c58294e7', 27, 2, 1, '2019-08-05 12:02:45', '2019-08-05 11:14:44', '2019-08-05 11:14:44');
INSERT INTO `oauth2_access_token` VALUES ('46d682d22c1241178d790597a0d738ac', '0c5f736259bd43beab97f7ccea50e43b', 27, 2, 1, '2019-07-16 18:47:49', '2019-07-16 17:59:49', '2019-07-16 17:59:49');
INSERT INTO `oauth2_access_token` VALUES ('472a3e4bb7064793a9a8654c196fb5d5', 'a29d9b638e0a43ea8de6cee962d46d90', NULL, NULL, 1, '2019-05-09 00:32:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('47349dabe2a649b49721ec28863c228b', 'a3f9026b8d85432a986c506b5407ad1a', NULL, NULL, 1, '2019-05-05 21:56:21', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4745c9080c4f4e009fbc35e90c4e2f17', 'c55cc62fc4dd4fa880fd176dc5fa9683', 27, 2, 1, '2019-06-25 00:55:07', '2019-06-25 00:07:07', '2019-06-25 00:07:07');
INSERT INTO `oauth2_access_token` VALUES ('4759d7f6dea64cac9bd90f2b652d8898', '5998008333ae4374b2e9cfff2c066fd1', 27, 2, 1, '2019-06-10 11:57:42', '2019-06-10 11:09:41', '2019-06-10 11:09:41');
INSERT INTO `oauth2_access_token` VALUES ('4763d08bc4574580970fdf2930ac272e', 'f9ac27490936438fbe1358b34b326415', 27, 2, 1, '2019-06-03 11:06:07', '2019-06-03 10:18:07', '2019-06-03 10:18:07');
INSERT INTO `oauth2_access_token` VALUES ('476add4d91a24fd78a81658472cb2316', '573bd665d5e340f2b93b704cb9cc1f3b', 27, 2, 1, '2019-06-01 09:58:36', '2019-06-01 09:10:35', '2019-06-01 09:10:35');
INSERT INTO `oauth2_access_token` VALUES ('477c6ac628f44d4c94639b0523e921e4', '055a6ca5fdf742d9970679a4be75c496', 1, 2, 0, '2019-05-27 00:40:54', '2019-05-26 23:52:53', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('478314ad861640fe8865c6946aaf843c', '859c62c37b6241758ff4c6133a059574', 27, 2, 1, '2019-06-11 23:32:05', '2019-06-11 22:44:05', '2019-06-11 22:44:05');
INSERT INTO `oauth2_access_token` VALUES ('4796031908e34e6597b1a880e89590d9', 'a2d625c4515c4d8598c7212ac4a989ad', NULL, NULL, 0, '2019-02-28 20:31:09', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('47a4626c2c724598b2896de36a359738', '99f042cc852e42eeb7be5eebcbfd3a16', 1, 2, 0, '2019-07-15 20:39:25', '2019-07-15 19:51:24', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('47aa31a269e745d5bf1efa304c58d689', '718610b3af2f41988557e284ee1888b4', 27, 2, 1, '2019-06-13 23:17:03', '2019-06-13 22:29:02', '2019-06-13 22:29:02');
INSERT INTO `oauth2_access_token` VALUES ('47b198d2026f46debf33bcafad07a272', '09de12b4899a43a4b78aa96c65a35ce4', 27, 2, 1, '2019-06-03 16:08:56', '2019-06-03 15:20:56', '2019-06-03 15:20:56');
INSERT INTO `oauth2_access_token` VALUES ('47d49046a3384515aaed9b232cb27a92', '9369a1a70bc745eab160be3e6e440dd9', NULL, NULL, 1, '2019-04-05 12:10:29', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('47d6f80f888745e790a83328c185ebd0', '46bb7d927c4641d99afbeba09a40e554', 27, 2, 1, '2019-06-25 15:40:09', '2019-06-25 14:52:09', '2019-06-25 14:52:09');
INSERT INTO `oauth2_access_token` VALUES ('47e5aa1e938a4e6bacb17a4e2063873e', '660fff3739a6414898295d5f4bcc54be', 27, 2, 1, '2019-06-02 17:42:22', '2019-06-02 16:54:22', '2019-06-02 16:54:22');
INSERT INTO `oauth2_access_token` VALUES ('47fd9df94eba4e6aa59e9df82aebcecb', '97a81b46cc614518b1733badf7e85dac', NULL, NULL, 1, '2019-05-13 14:29:57', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4800c655b4df4f17bd2d6ccac450585c', '64b336f91e5c4dcc90fd142dd96f085b', NULL, NULL, 1, '2019-04-29 15:18:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4808c7361142473e8803dfef68eaf515', '54b9c5a11e734c60b3fa4a88f62fc2d3', 1, 2, 0, '2019-08-13 00:25:54', '2019-08-12 23:37:53', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('480d4bd1a59f43c8b4ee2b8a577bc471', '742313d700e64ce9b5c3eb6b87cb710b', 27, 2, 1, '2019-06-08 17:09:53', '2019-06-08 16:21:52', '2019-06-08 16:21:52');
INSERT INTO `oauth2_access_token` VALUES ('481713287dfd4667853ce3a03d2ddcc7', '41f3890ca5e1419f9be992262cee4d50', 27, 2, 1, '2019-07-03 19:20:30', '2019-07-03 18:32:29', '2019-07-03 18:32:29');
INSERT INTO `oauth2_access_token` VALUES ('481e2a8e040f4f9a8957e63c1a851d51', 'a8b3b767389b48059881796f0d41eaf3', 27, 2, 1, '2019-07-24 15:16:30', '2019-07-24 14:28:29', '2019-07-24 14:28:29');
INSERT INTO `oauth2_access_token` VALUES ('48560cb762d24f588502bcb65bbf319a', 'db688ad684774f448c21574808530b26', 27, 2, 1, '2019-05-24 11:32:04', '2019-05-24 10:44:03', '2019-05-24 10:44:03');
INSERT INTO `oauth2_access_token` VALUES ('487430a595764c688803c4adcf31a7b0', '847e5abef43647649693fa9348637b5d', 27, 2, 1, '2019-05-25 01:36:29', '2019-05-25 00:48:28', '2019-05-25 00:48:28');
INSERT INTO `oauth2_access_token` VALUES ('48762c91d9c6470c84a522b89946fa43', 'a32291e0c3144d5ebaf39efd66889ea9', 27, 2, 1, '2019-05-31 22:10:14', '2019-05-31 21:22:13', '2019-05-31 21:22:13');
INSERT INTO `oauth2_access_token` VALUES ('4877f4492e5c46ff8f674113f4e5d766', '033d6bf5b9aa42fdbcf266123662bfd6', 27, 2, 1, '2019-06-27 23:23:02', '2019-06-27 22:35:01', '2019-06-27 22:35:01');
INSERT INTO `oauth2_access_token` VALUES ('488ec7b29e0d4ed5a1e1edbe22213c87', '75437aaefc424e048b9e4cca19931142', 27, 2, 1, '2019-09-04 10:40:33', '2019-09-04 09:52:33', '2019-09-04 09:52:33');
INSERT INTO `oauth2_access_token` VALUES ('488f66cf43d849f78b532b9b9085842f', 'a37f3efdd49a4f7f88197f5b4a22d229', NULL, NULL, 0, '2019-03-03 22:59:10', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4899a0e7cc27404aabd49ddba5910a2f', '574c83544e084f1188051fabd979cc1c', 27, 2, 1, '2019-06-10 15:56:06', '2019-06-10 15:08:05', '2019-06-10 15:08:05');
INSERT INTO `oauth2_access_token` VALUES ('48b15b28ecb24f1dbcf5e3f3b2469258', '67b96142719b4bc1b913f25f5207c60e', 27, 2, 1, '2019-06-26 01:03:39', '2019-06-26 00:15:38', '2019-06-26 00:15:38');
INSERT INTO `oauth2_access_token` VALUES ('48b3871346b94486b30f646a64ffa7b1', 'ae8949548f4c4e638a122e9f5cff0b92', 27, 2, 1, '2019-07-16 14:57:36', '2019-07-16 14:09:35', '2019-07-16 14:09:35');
INSERT INTO `oauth2_access_token` VALUES ('48bf8f2aae9c4a8f8194347e4a213e06', '749e66bc32dc4afb95931a32855c9ed6', 27, 2, 1, '2019-06-09 11:35:08', '2019-06-09 10:47:08', '2019-06-09 10:47:08');
INSERT INTO `oauth2_access_token` VALUES ('48bfe36919a74a3c990aab4653e65ea3', '63c4509a21d340b89905273895bd4da1', 27, 2, 1, '2019-06-06 17:10:03', '2019-06-06 16:22:03', '2019-06-06 16:22:03');
INSERT INTO `oauth2_access_token` VALUES ('48dfde3be7844a31bcdc75d6193d4c4b', '0c873a31ef2e4819a8f542f70013b38f', 27, 2, 1, '2019-05-30 10:44:42', '2019-05-30 09:56:42', '2019-05-30 09:56:42');
INSERT INTO `oauth2_access_token` VALUES ('48efcb12c92f40bb8c3ff39a8434e6e2', '15536e98ef5c4ce09c5acd15e1109906', NULL, NULL, 1, '2019-05-06 23:55:04', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('48f818b4c70641b2b72e3cb8ba613b6c', 'a9d0c5cc3772474385366b61463382db', NULL, NULL, 1, '2019-04-26 22:30:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('490a4852a445478796b001adb1a28f00', 'dd34d3ba368d475d9bd5848df78da3d1', 1, 2, 0, '2019-08-20 23:49:02', '2019-08-20 23:01:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('491a422d775e4e5189f4529d07a0013f', 'ee7d94668338465dafa712e008b25daa', 27, 2, 1, '2019-07-03 23:19:29', '2019-07-03 22:31:28', '2019-07-03 22:31:28');
INSERT INTO `oauth2_access_token` VALUES ('491f0263e1e74b58ae4b5c4eefde9b07', '5a89e7d026a34b9c9299ce5e39d70af9', 27, 2, 1, '2019-06-21 14:48:12', '2019-06-21 14:00:12', '2019-06-21 14:00:12');
INSERT INTO `oauth2_access_token` VALUES ('4920f1351bb84e4682de5b60c08c803e', 'c765d42a39da427494913af3ed058e9a', 27, 2, 1, '2019-07-27 12:50:36', '2019-07-27 12:02:35', '2019-07-27 12:02:35');
INSERT INTO `oauth2_access_token` VALUES ('4932d18c6c974bc08900ea69c8540bdb', '0550d7345f30412f93dcd6a157d82b98', 27, 2, 1, '2019-06-20 18:01:30', '2019-06-20 17:13:29', '2019-06-20 17:13:29');
INSERT INTO `oauth2_access_token` VALUES ('493b82d587fc43bb91e78580d0688f5f', 'a75951e9bf3f41a5b6700c3c34c34bc7', 27, 2, 1, '2019-06-03 00:32:57', '2019-06-02 23:44:56', '2019-06-02 23:44:56');
INSERT INTO `oauth2_access_token` VALUES ('4942d61895bb47e58eda8a7ebcc36481', '17ab9ab27abd476f8fae04fceeffa58b', 27, 2, 1, '2019-06-20 10:29:04', '2019-06-20 09:41:03', '2019-06-20 09:41:03');
INSERT INTO `oauth2_access_token` VALUES ('495206b25959403da4c4bbafa5dc8355', 'e7945ed2da264d25a863e41446997842', 1, 2, 0, '2019-08-14 08:42:58', '2019-08-14 07:54:58', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('496b0242e99d43ad90dfe10bc294746d', 'c28bcc7fcc144a17be713b712c348ed5', 27, 2, 1, '2019-06-28 18:04:16', '2019-06-28 17:16:16', '2019-06-28 17:16:16');
INSERT INTO `oauth2_access_token` VALUES ('496ebe84a0ba4519ba12306d8fd66fd2', '2f27bf8a56d74d9794854dbb74623312', 27, 2, 1, '2019-08-30 13:29:24', '2019-08-30 12:41:23', '2019-08-30 12:41:23');
INSERT INTO `oauth2_access_token` VALUES ('498306663e66466da4e2cf42d8179606', 'f1747cd256ea4d03901309bae1e893f8', NULL, NULL, 0, '2019-03-03 22:58:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('49893e79ada841bd919c06fea40632ef', '1281fbd2e6964dea984dad7e2f0b303b', NULL, NULL, 1, '2019-04-22 19:13:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4991e298513a497d9ed0daf8068d10b9', '5fb4a334a7fa4c16b9a98de0683c4d28', 27, 2, 1, '2019-07-21 11:20:59', '2019-07-21 10:32:58', '2019-07-21 10:32:58');
INSERT INTO `oauth2_access_token` VALUES ('49aa44dd91bc497f8e3ecaf3806bf14b', '401a6f70cbf0442f8689e88bc0fe1a98', 27, 2, 1, '2019-07-12 09:49:01', '2019-07-12 09:01:01', '2019-07-12 09:01:01');
INSERT INTO `oauth2_access_token` VALUES ('49ab6f4331e1428a881823eea60b510b', '27103374d1f14303a285d84b5dded6b0', NULL, NULL, 1, '2019-03-10 06:06:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('49b0c21b61d44362999e4e75dff646a6', 'dcbc0938b2d947c8880365e6e5a17190', NULL, NULL, 1, '2019-04-04 19:46:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('49bea3bc059045babfe1f327009e4b52', 'a6138d02e0cc4247a6629ed2e93a44b9', 27, 2, 1, '2019-06-04 16:52:17', '2019-06-04 16:04:17', '2019-06-04 16:04:17');
INSERT INTO `oauth2_access_token` VALUES ('49c3b62e997047a39132bf211d6f8509', 'dfd3e891bf2343bbbaf5dc035f0736cd', 27, 2, 1, '2019-06-04 17:57:12', '2019-06-04 17:09:11', '2019-06-04 17:09:11');
INSERT INTO `oauth2_access_token` VALUES ('49c946b09a9443c6bde71830c8eb1ffe', '5786a5abb7d245efacaeafd4a7ad3774', 27, 2, 1, '2019-06-25 22:07:17', '2019-06-25 21:19:16', '2019-06-25 21:19:16');
INSERT INTO `oauth2_access_token` VALUES ('49d03ee1d9cc49a39b57c42d3b6a359b', '1705f3cc19c04570b480a16df5913a2b', 223, 1, 1, '2019-09-05 19:01:51', '2019-09-05 18:13:51', '2019-09-05 18:13:51');
INSERT INTO `oauth2_access_token` VALUES ('49d2f1d558d0471690fcf3c6b9bdf49f', '440fd085afce4f0b9cf76bed812cebb6', 27, 2, 1, '2019-06-01 20:23:38', '2019-06-01 19:35:38', '2019-06-01 19:35:38');
INSERT INTO `oauth2_access_token` VALUES ('49dcdbd424be4db18b310b36776b2b40', 'b2752390170043a99989ed0ba9b2548d', 1, 2, 0, '2019-09-06 11:43:56', '2019-09-06 10:55:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('49fa841512654eee8c84dd8207a2606c', 'c6fbff5a9b8a468ca12b4bd1fc5047a7', 27, 2, 1, '2019-06-18 15:17:22', '2019-06-18 14:29:22', '2019-06-18 14:29:22');
INSERT INTO `oauth2_access_token` VALUES ('49fae2e496f849b5b6e36b4e91799cb1', '3261a834824e46f190b8bfafe93bbcaa', 27, 2, 1, '2019-06-29 17:19:06', '2019-06-29 16:31:06', '2019-06-29 16:31:06');
INSERT INTO `oauth2_access_token` VALUES ('4a19b7cd79a548128dcdac2463a3e78d', '4fe3358deaf04511af51f78cddb31c0a', 27, 2, 1, '2019-06-20 10:16:42', '2019-06-20 09:28:41', '2019-06-20 09:28:41');
INSERT INTO `oauth2_access_token` VALUES ('4a1f2e924a1949b086b605771f07beb5', '9417222071d24f58b367b728ce381465', 27, 2, 1, '2019-06-01 16:15:33', '2019-06-01 15:27:32', '2019-06-01 15:27:32');
INSERT INTO `oauth2_access_token` VALUES ('4a4577c2d10b4d80b8f3ab6c78830b08', '2f09b74f11c742d4aabc1594ec6c1d77', 27, 2, 1, '2019-07-28 11:13:07', '2019-07-28 10:25:07', '2019-07-28 10:25:07');
INSERT INTO `oauth2_access_token` VALUES ('4a64ecfafa2a4cf0acd0a1e56e073cb3', '1ae98ba9f59f4c8383de24cca34f18bf', 27, 2, 1, '2019-05-23 11:56:22', '2019-05-23 11:08:21', '2019-05-23 11:08:21');
INSERT INTO `oauth2_access_token` VALUES ('4a6604dc60ed4a14a1a909f83e6fb123', 'df5198fd9c314aba84a3147b33548ffa', 27, 2, 1, '2019-05-25 15:22:08', '2019-05-25 14:34:08', '2019-05-25 14:34:08');
INSERT INTO `oauth2_access_token` VALUES ('4a74ebf3d9164009a21306be77579462', '9bbb7f0203064ee1a39eb1521063024f', 27, 2, 1, '2019-06-03 21:58:24', '2019-06-03 21:10:24', '2019-06-03 21:10:24');
INSERT INTO `oauth2_access_token` VALUES ('4a7a517163a44f71b1fdc727902f14ac', 'ed999c87e05644e5b0f1f22da22eaf12', 1, 2, 0, '2019-06-27 17:46:57', '2019-06-27 16:58:56', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('4a7b671b3094466fb9e28d5de3e9b85d', 'dfb7ce63914d456d8b0aee1ff0c96560', 92, 1, 1, '2019-05-30 18:37:37', '2019-05-30 17:49:37', '2019-05-30 17:49:37');
INSERT INTO `oauth2_access_token` VALUES ('4a852ea395094902aeea32868d4337a2', '5442e23c264343cbb2dcbdbe0cb587b3', 27, 2, 1, '2019-08-08 09:39:58', '2019-08-08 08:51:58', '2019-08-08 08:51:58');
INSERT INTO `oauth2_access_token` VALUES ('4a9d3a15f1e24b019a80294f3c46fb78', '7b9a677ccc43464f918d2274f3827850', 27, 2, 1, '2019-08-28 18:16:15', '2019-08-28 17:28:15', '2019-08-28 17:28:15');
INSERT INTO `oauth2_access_token` VALUES ('4aa6e224a33e4236940576c34fec1270', '0e8d63e10dbe460b83df69a0be3e469d', 27, 2, 1, '2019-06-01 23:42:10', '2019-06-01 22:54:09', '2019-06-01 22:54:09');
INSERT INTO `oauth2_access_token` VALUES ('4ab4c4db386a499e946373f085aa4d70', '9f26de03c4814b73ab3c400cf3a00779', 27, 2, 1, '2019-07-07 08:15:56', '2019-07-07 07:27:55', '2019-07-07 07:27:55');
INSERT INTO `oauth2_access_token` VALUES ('4ae175c6da524c18a2c26139bae15117', '31f9e85e5b114e6f9e0acf583ad03da3', NULL, NULL, 1, '2019-04-28 12:29:10', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4b0f373320d4432d956fcde66d3e3c4f', '67b398a20f624ceda727216daae2688d', 27, 2, 1, '2019-06-03 11:20:52', '2019-06-03 10:32:52', '2019-06-03 10:32:52');
INSERT INTO `oauth2_access_token` VALUES ('4b0ffed309474398beaa76e3a2eb325f', '92a2f138b10a42a1903ad78947284826', 27, 2, 1, '2019-09-02 12:27:50', '2019-09-02 11:39:49', '2019-09-02 11:39:49');
INSERT INTO `oauth2_access_token` VALUES ('4b114b0f5e924c1bb7d3084c51be0142', '87ffdfc9d12a4d79a03755d416e82c1f', NULL, NULL, 1, '2019-04-25 11:54:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4b28e268779c40d6adcb2bd346534052', '1ebb82d3cb4a4ec9b20d6a68a7227213', 27, 2, 1, '2019-06-20 13:04:16', '2019-06-20 12:16:15', '2019-06-20 12:16:15');
INSERT INTO `oauth2_access_token` VALUES ('4b2d405b35944f8db9e0bf53167c5443', 'c1ca6d07615c4fa789de27ca5a404309', 1, 2, 0, '2019-05-31 16:58:48', '2019-05-31 16:09:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('4b4d4e1666464542bec4107d28407b1d', '92c3ecd1d71b48eebfddd4fb5afcb5ad', 27, 2, 1, '2019-07-23 10:49:49', '2019-07-23 10:01:48', '2019-07-23 10:01:48');
INSERT INTO `oauth2_access_token` VALUES ('4b554f09c8574e068120a9e18aecea82', '7ea07c439baa4407bd21a79896002bc6', NULL, NULL, 1, '2019-05-05 22:31:27', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4b65f1f95ce6445c82677303ab4a3379', '85e6fdc482934cf9a465de1c9451ee93', 27, 2, 1, '2019-06-28 16:47:36', '2019-06-28 15:59:36', '2019-06-28 15:59:36');
INSERT INTO `oauth2_access_token` VALUES ('4b6975a50e454b66aaa3686d142fdc5b', 'a6012b242c5244f1a7deac60f29e0373', 27, 2, 1, '2019-06-28 12:41:14', '2019-06-28 11:53:14', '2019-06-28 11:53:14');
INSERT INTO `oauth2_access_token` VALUES ('4b6f37cb5e174e50a4e92803607b2cd4', 'dd8be0ecd46640cbb8d3c29d82d49a4b', 27, 2, 1, '2019-08-21 12:40:07', '2019-08-21 11:52:06', '2019-08-21 11:52:06');
INSERT INTO `oauth2_access_token` VALUES ('4b7282a478124a34bde7583732eb43f9', '64eb71b6aa034668ba8e26cd47bbb72b', 27, 2, 1, '2019-06-03 11:25:28', '2019-06-03 10:37:28', '2019-06-03 10:37:28');
INSERT INTO `oauth2_access_token` VALUES ('4b8a14950ecd4919975402f5ed244010', 'bf174e364e9e4e6093dcaf055ac017e1', 27, 2, 1, '2019-05-18 00:34:26', '2019-05-17 23:46:25', '2019-05-17 23:46:25');
INSERT INTO `oauth2_access_token` VALUES ('4b983ae3cf3d4e8b9e79903c8b1cda8e', '2410a4656ccd49a89e8e114078f999dc', 27, 2, 1, '2019-06-03 10:49:27', '2019-06-03 10:01:27', '2019-06-03 10:01:27');
INSERT INTO `oauth2_access_token` VALUES ('4bc378c5bbfb4818889302aa51f7a52e', 'd347c73e04504a09aa630b6e3bd614ea', NULL, NULL, 1, '2019-05-05 17:40:23', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4bcd6c5cb1244e17908fa4cd3881dcca', 'cc46eb3a9e85485a80a207f56e330bad', 27, 2, 1, '2019-07-01 18:30:53', '2019-07-01 17:42:53', '2019-07-01 17:42:53');
INSERT INTO `oauth2_access_token` VALUES ('4bd0392228d84a289cb4554bf43d2360', '67dd5265512b41b2933b8b828daa7b9c', 27, 2, 1, '2019-09-02 16:00:01', '2019-09-02 15:12:00', '2019-09-02 15:12:00');
INSERT INTO `oauth2_access_token` VALUES ('4bd66962ac4f44a59b850e8d49e7e0a4', 'e27a22a43b1b416083b6903910bf5cfd', 27, 2, 1, '2019-08-21 11:34:31', '2019-08-21 10:46:31', '2019-08-21 10:46:31');
INSERT INTO `oauth2_access_token` VALUES ('4bdf18298d85492599c894462b91701d', '221c920126d1439790d92c1fc118c532', 27, 2, 1, '2019-05-27 18:19:58', '2019-05-27 17:31:57', '2019-05-27 17:31:57');
INSERT INTO `oauth2_access_token` VALUES ('4be2da4d89584185b7562768bf063e49', 'ddef14f296c04a009a0012f38070d461', 27, 2, 1, '2019-08-22 23:43:21', '2019-08-22 22:55:20', '2019-08-22 22:55:20');
INSERT INTO `oauth2_access_token` VALUES ('4c00656eef154ae8b2276db1db95d6b9', '5e4c51fb0b6045b6906be8dcea83bc9a', 27, 2, 1, '2019-09-05 18:07:00', '2019-09-05 17:19:00', '2019-09-05 17:19:00');
INSERT INTO `oauth2_access_token` VALUES ('4c0749807f034fdcbbc1ae6e738b29d4', '7845053e2ff746b7b7d0288f36da589e', NULL, NULL, 1, '2019-04-27 12:54:00', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4c0d6dd205b34e429f211a5d9144fa96', 'de66a83c542d48e0aa7ea3b2e226c760', 27, 2, 1, '2019-06-13 14:27:27', '2019-06-13 13:39:27', '2019-06-13 13:39:27');
INSERT INTO `oauth2_access_token` VALUES ('4c13343ad71a4fb1af6e497ac1f49aa0', '225c1c4e221f4348b6ee0e15aa86751f', 27, 2, 1, '2019-07-08 11:54:37', '2019-07-08 11:06:36', '2019-07-08 11:06:36');
INSERT INTO `oauth2_access_token` VALUES ('4c267fc6fb0c447e96678858f8ec1892', '176b927cdd8d4be6b019ef0349c5dfba', 1, 2, 0, '2019-08-20 16:29:45', '2019-08-20 15:41:44', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('4c274c061f0f493da295125fa9d9b315', '04b5003baffb4fb4b511827ba98d754c', 27, 2, 1, '2019-09-06 15:27:06', '2019-09-06 14:39:06', '2019-09-06 14:39:06');
INSERT INTO `oauth2_access_token` VALUES ('4c8df9efa360407ab3eec9e23894dfce', 'dbde836a94a44eccb652250a044cfc0f', 27, 2, 1, '2019-08-30 17:46:02', '2019-08-30 16:58:01', '2019-08-30 16:58:01');
INSERT INTO `oauth2_access_token` VALUES ('4c9b992b24b247d090a48617787a4ce5', '690485b9393347e1ae299fededc3a2eb', NULL, NULL, 1, '2019-05-03 20:38:57', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4ca1177e000542b4be75b2e2f30e93cb', '0011ab788ca548e1be9b593b0c954304', 27, 2, 1, '2019-06-12 17:19:04', '2019-06-12 16:31:03', '2019-06-12 16:31:03');
INSERT INTO `oauth2_access_token` VALUES ('4caa4dd5dcfa435bac5fd7610bcf0949', '174f089f005f45f78421c81157761d38', 27, 2, 1, '2019-06-11 01:02:37', '2019-06-11 00:14:37', '2019-06-11 00:14:37');
INSERT INTO `oauth2_access_token` VALUES ('4cae35c6d48e4998b493ad21ef0c4379', '8e984d69b1f940b7ae606ae3af5f0156', 27, 2, 1, '2019-06-26 18:47:24', '2019-06-26 17:59:23', '2019-06-26 17:59:23');
INSERT INTO `oauth2_access_token` VALUES ('4cc7b8e69f9243c6879b6c8d3ace6828', '39c9680d5ec64a71bccd0bd2378c5bd0', 27, 2, 1, '2019-06-10 15:54:30', '2019-06-10 15:06:30', '2019-06-10 15:06:30');
INSERT INTO `oauth2_access_token` VALUES ('4cc9f6aedfe348e98a3c3f301d6e1dac', '17d9ec1d382e4bdbb554767285e9d501', 27, 2, 1, '2019-06-25 10:23:26', '2019-06-25 09:35:26', '2019-06-25 09:35:26');
INSERT INTO `oauth2_access_token` VALUES ('4d06a3e2a9ce4c69a932353c4feb7981', '3270e9fd8105413abbb9c7169853b1da', 27, 2, 1, '2019-06-02 22:17:08', '2019-06-02 21:29:08', '2019-06-02 21:29:08');
INSERT INTO `oauth2_access_token` VALUES ('4d16b666a1674989a1cb3da58355f1f2', 'dfad2db87488411493e7bf11af98af44', 27, 2, 1, '2019-06-06 12:32:26', '2019-06-06 11:44:26', '2019-06-06 11:44:26');
INSERT INTO `oauth2_access_token` VALUES ('4d2124240f7343259479ad96fbc09f83', '3fd72c4e7fac4da9a8de036ea6afb494', 27, 2, 1, '2019-08-08 16:36:36', '2019-08-08 15:48:35', '2019-08-08 15:48:35');
INSERT INTO `oauth2_access_token` VALUES ('4d36f417645644099933520accad4b5a', 'fc302e33c9da40b7862d20379c688d25', 27, 2, 1, '2019-06-29 12:15:07', '2019-06-29 11:27:06', '2019-06-29 11:27:06');
INSERT INTO `oauth2_access_token` VALUES ('4d50202af4ae44b1a7cbaf6245e6f7bf', 'cc6380aa0db54ba3a05ef8408b5e9e68', 27, 2, 1, '2019-09-06 11:31:36', '2019-09-06 10:43:35', '2019-09-06 10:43:35');
INSERT INTO `oauth2_access_token` VALUES ('4d5f456aca044c0886c45dd5011bbc11', '9cd4f90d3e2b44eaa2f488ec34b07236', 27, 2, 1, '2019-07-10 18:37:27', '2019-07-10 17:49:26', '2019-07-10 17:49:26');
INSERT INTO `oauth2_access_token` VALUES ('4d6fdc0b241647e8b0d91df9be0b0aad', 'dfc995299cf84ec6a1b0d75b3cca3713', 27, 2, 1, '2019-06-20 21:14:12', '2019-06-20 20:26:12', '2019-06-20 20:26:12');
INSERT INTO `oauth2_access_token` VALUES ('4d906d3cecbe4485ad17075a238625af', '28b6ff4d8e2b46c086c459ba6b6a30f6', 1, 2, 0, '2019-07-07 18:30:00', '2019-07-07 17:41:59', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('4d96f397e37049e3b14174f8a252693f', 'd9678fc1a3224fe9a66572e80e44b40f', 201, 1, 1, '2019-08-14 12:32:44', '2019-08-14 11:44:43', '2019-08-14 11:44:43');
INSERT INTO `oauth2_access_token` VALUES ('4da3d363bed54247b6659cf35374be81', '8dd31debe08a41dd816cdc853f9bdc29', 27, 2, 1, '2019-07-08 11:55:54', '2019-07-08 11:07:54', '2019-07-08 11:07:54');
INSERT INTO `oauth2_access_token` VALUES ('4dc067fa25ac43ea9018d8b8b15e3c65', '7a0d4d982fd24335b46605781af46564', 27, 2, 1, '2019-06-01 04:53:51', '2019-06-01 04:05:51', '2019-06-01 04:05:51');
INSERT INTO `oauth2_access_token` VALUES ('4dc10f555c7047d48e0065380216ee5c', '2f29260a1af84eb2a70e6495efa4d99d', 1, 2, 0, '2019-08-21 18:49:39', '2019-08-21 18:01:39', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('4dccaf42be2c4459a077b11c64c7c5b5', 'a12624fe4ef64838901934ca085db5e6', 27, 2, 1, '2019-08-09 11:32:02', '2019-08-09 10:44:02', '2019-08-09 10:44:02');
INSERT INTO `oauth2_access_token` VALUES ('4de1c74c7cd84f7e84afb9e33f965cdc', '87f2551fb9f348fbb1951f9061b93371', 27, 2, 1, '2019-09-04 21:27:43', '2019-09-04 20:39:42', '2019-09-04 20:39:42');
INSERT INTO `oauth2_access_token` VALUES ('4e03c732ad594f2281640c8321df8374', '5a7b423d19bb420fb84d27fd4b7f2045', 27, 2, 1, '2019-06-17 17:38:54', '2019-06-17 16:50:54', '2019-06-17 16:50:54');
INSERT INTO `oauth2_access_token` VALUES ('4e15a38062f84f34bde0d1fba8eb82d6', '382edd0e400d492f94e9b2d9f8053599', 27, 2, 1, '2019-07-02 15:43:35', '2019-07-02 14:55:35', '2019-07-02 14:55:35');
INSERT INTO `oauth2_access_token` VALUES ('4e15f761819a4261802edd538c006b7f', '381d0b176243420dae72a7ea506d9778', 27, 2, 1, '2019-08-27 15:56:27', '2019-08-27 15:08:26', '2019-08-27 15:08:26');
INSERT INTO `oauth2_access_token` VALUES ('4e198962b9b84b9c8d3512185a8fc54f', 'fb9ca2b59cc54eca88ef98bd74e7e715', 27, 2, 1, '2019-09-06 09:26:31', '2019-09-06 08:38:30', '2019-09-06 08:38:30');
INSERT INTO `oauth2_access_token` VALUES ('4e21901caebb4e30a74fcea83271df7a', '53490b57a273418dbfc5ddca33e23675', 1, 2, 0, '2019-07-21 11:26:12', '2019-07-21 10:38:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('4e2ca2ec17844d5298ea9ede9e21b1fe', '03a1d4b488ca4426b8b5fdadb6b04246', 27, 2, 1, '2019-07-04 21:57:13', '2019-07-04 21:09:12', '2019-07-04 21:09:12');
INSERT INTO `oauth2_access_token` VALUES ('4e426d1533024fb7b9f5ff9be4787a19', '730a6d152790423eb7ec9973e663d793', 27, 2, 1, '2019-06-03 22:26:38', '2019-06-03 21:38:37', '2019-06-03 21:38:37');
INSERT INTO `oauth2_access_token` VALUES ('4e4ca50d285b4dffb637bc16727bc806', '0011dd3d90094f19bbe57ac1719275ca', 27, 2, 1, '2019-08-07 19:40:51', '2019-08-07 18:52:50', '2019-08-07 18:52:50');
INSERT INTO `oauth2_access_token` VALUES ('4e50e8dfa1744155a6a4444124edb0b5', 'e80085658a05441e9b8a67758234a4b3', 27, 2, 1, '2019-06-14 12:44:47', '2019-06-14 11:56:47', '2019-06-14 11:56:47');
INSERT INTO `oauth2_access_token` VALUES ('4e58ef2dbf0747c48d8523feab035336', 'd467ef928e464b26ad4eafed25f01253', 27, 2, 1, '2019-06-08 21:01:40', '2019-06-08 20:13:40', '2019-06-08 20:13:40');
INSERT INTO `oauth2_access_token` VALUES ('4e6bc19ed52042b0ba4917b7899c218b', 'd29523d51e254b6399914939b567ce48', 212, 1, 1, '2019-08-26 11:12:28', '2019-08-26 10:24:25', '2019-08-26 10:24:25');
INSERT INTO `oauth2_access_token` VALUES ('4e93540f16b24023bccb6f189c071465', 'e14adc26dff2460dbbe2b12b7064f7f9', 27, 2, 1, '2019-07-27 16:48:28', '2019-07-27 16:00:28', '2019-07-27 16:00:28');
INSERT INTO `oauth2_access_token` VALUES ('4ea33f097eec43c9a2ff232e5ce2b42b', '23a932a887d7454f89aeba846b42809f', 27, 2, 1, '2019-07-26 11:06:48', '2019-07-26 10:18:47', '2019-07-26 10:18:47');
INSERT INTO `oauth2_access_token` VALUES ('4eaea20683de42c881ee82222c8eda65', '8bfbee1765a941d98e49902e6ba71959', 27, 2, 1, '2019-06-15 19:47:53', '2019-06-15 18:59:53', '2019-06-15 18:59:53');
INSERT INTO `oauth2_access_token` VALUES ('4ecee95a704d429aabbc13b41f3cda09', '77b0a9f755be406281cca5824aaab0dd', 27, 2, 1, '2019-09-05 18:12:30', '2019-09-05 17:24:29', '2019-09-05 17:24:29');
INSERT INTO `oauth2_access_token` VALUES ('4f10e492f59d4c5e9819628440e657ef', '6abbb331a65544889750c0ebeb42725c', 27, 2, 1, '2019-07-04 17:24:54', '2019-07-04 16:36:53', '2019-07-04 16:36:53');
INSERT INTO `oauth2_access_token` VALUES ('4f4e4d72f94d4e279bc96001ae94faf0', '7328f291bbae48a4adba2d8253e55220', 1, 2, 0, '2019-06-10 12:01:22', '2019-06-10 11:13:22', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('4f6df45de9474009a2e7fa03de3c00c6', '05b950bc7022442e92173b887e571e1f', NULL, NULL, 1, '2019-04-24 11:29:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('4f795af6466a4be48cae721ca1f2e11b', 'cd284346c8a84473a4b3d57c35a1d9b7', 27, 2, 1, '2019-05-20 12:27:55', '2019-05-20 11:39:54', '2019-05-20 11:39:54');
INSERT INTO `oauth2_access_token` VALUES ('4fafe0ec990f47d29e3907f77cd5efc7', 'de02702c988a452ba4e84f2b077d7507', 27, 2, 1, '2019-06-26 12:04:11', '2019-06-26 11:16:11', '2019-06-26 11:16:11');
INSERT INTO `oauth2_access_token` VALUES ('5003a6bbe73d43e2811e10861297c3f2', '3afe78861b07490cb1a7bb699bc5f572', NULL, NULL, 1, '2019-03-12 22:00:17', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5036dd814e884c6b874602a2702130c5', '6415ead6c73b4c50bd89863b1bb4e3fc', 27, 2, 1, '2019-09-06 23:17:36', '2019-09-06 22:29:35', '2019-09-06 22:29:35');
INSERT INTO `oauth2_access_token` VALUES ('503e67a27b0247218753921bd2a8a6e8', '60d26f460916480e804c7fce11809410', 27, 2, 1, '2019-05-29 11:17:42', '2019-05-29 10:29:42', '2019-05-29 10:29:42');
INSERT INTO `oauth2_access_token` VALUES ('504737baa2334eaba61814c9e4a87c19', '56c79cc7549848a4a389254686884da4', 27, 2, 1, '2019-05-31 22:39:09', '2019-05-31 21:51:08', '2019-05-31 21:51:08');
INSERT INTO `oauth2_access_token` VALUES ('5053585ada7f4a448c96e7f4bfb05dbc', '50667aa588a74f3996b89677598a782a', 27, 2, 1, '2019-06-23 14:04:50', '2019-06-23 13:16:50', '2019-06-23 13:16:50');
INSERT INTO `oauth2_access_token` VALUES ('5058ae7895dc4b6498ccbdbab8835048', 'd15667c7b7fa4ef890247d74992008f2', 27, 2, 1, '2019-07-03 18:11:27', '2019-07-03 17:23:26', '2019-07-03 17:23:26');
INSERT INTO `oauth2_access_token` VALUES ('505d35c3c7554e5a97c39ec85e972f00', 'c41a07104eb94b4d9a06fc9ec97b12d3', 27, 2, 1, '2019-05-27 20:14:21', '2019-05-27 19:26:21', '2019-05-27 19:26:21');
INSERT INTO `oauth2_access_token` VALUES ('5063664e857b493793891055ce08a3bb', 'fa0f09a9e1394d668739fbd706e962f2', 27, 2, 1, '2019-05-29 09:48:23', '2019-05-29 09:00:23', '2019-05-29 09:00:23');
INSERT INTO `oauth2_access_token` VALUES ('506439f3fa834db6939319863e9a7111', 'e07ad3e7a6434678a329bd14ea0addcf', 27, 2, 1, '2019-09-02 15:56:10', '2019-09-02 15:08:10', '2019-09-02 15:08:10');
INSERT INTO `oauth2_access_token` VALUES ('50675c3509f74c9a81fe2824a9e85ca5', '94a0a5c1c5294d85869ac3553d4c4605', NULL, NULL, 1, '2019-04-22 19:32:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5080bc4e6def403d8c15d99aa0ca74ed', 'cb0b239029234636b9459ace17d58ee6', 27, 2, 1, '2019-07-22 18:07:41', '2019-07-22 17:19:41', '2019-07-22 17:19:41');
INSERT INTO `oauth2_access_token` VALUES ('50810c5e6ca848b9ad08ac7d86af6572', '785d40a8206843d39f4f1c0572201db4', NULL, NULL, 1, '2019-04-24 11:01:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5088098367564c7795a57e0ac8a5d6ba', 'd037c713386c47b6ae71e83639639477', NULL, NULL, 1, '2019-04-29 15:07:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('508b3951fd3d4eecbf340bc3990242eb', '154effaf709f49d9bba075a0d40f3790', 27, 2, 1, '2019-06-03 01:19:04', '2019-06-03 00:31:03', '2019-06-03 00:31:03');
INSERT INTO `oauth2_access_token` VALUES ('50b62b0148ca400fbe750378368fd598', '1a2ac79deb214be9bd95948628d6cd8c', 27, 2, 1, '2019-07-01 00:54:45', '2019-07-01 00:06:44', '2019-07-01 00:06:44');
INSERT INTO `oauth2_access_token` VALUES ('50c9b4b18d64405681b670dfb66fe58a', '68f68165f4114dd88eb60cfcb16bc8e3', 27, 2, 1, '2019-06-02 16:45:20', '2019-06-02 15:57:20', '2019-06-02 15:57:20');
INSERT INTO `oauth2_access_token` VALUES ('50d2bc2012e44ab18054216decaed965', 'c41ab15bc47546c3a7f89dc57f0ddfe7', NULL, NULL, 1, '2019-05-15 00:39:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('50e7003f58804d5686d11920289caabc', '03e211e8705642a4a28179cc028177f8', 27, 2, 1, '2019-08-29 20:48:56', '2019-08-29 20:00:56', '2019-08-29 20:00:56');
INSERT INTO `oauth2_access_token` VALUES ('50e7c3b00ed24343b5da4acfc2d35dc9', 'f5659c3bc2804c209f6a5c490b747abf', 27, 2, 1, '2019-08-20 00:07:11', '2019-08-19 23:19:11', '2019-08-19 23:19:11');
INSERT INTO `oauth2_access_token` VALUES ('50ee66748908485bb0f9896eca644a38', '4a4f51b0b8f5446faa935d2816e3ae29', 27, 2, 1, '2019-07-05 09:06:12', '2019-07-05 08:18:11', '2019-07-05 08:18:11');
INSERT INTO `oauth2_access_token` VALUES ('50f9e82d5c3441099535770efb328125', '7e6b2defa5e44f0ab8e1996c6f9c3e0b', NULL, NULL, 1, '2019-04-05 23:07:34', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5119b14c9e744715a72c3a05e720f992', '4d341f152f394b298fb726c01fd264aa', 27, 2, 1, '2019-07-09 15:20:23', '2019-07-09 14:32:22', '2019-07-09 14:32:22');
INSERT INTO `oauth2_access_token` VALUES ('51298d5aad7a4ad889d19ea7182ec306', 'f238ae272dbf4fac94251db8e0305ee6', 1, 2, 0, '2019-06-06 18:22:57', '2019-06-06 17:36:09', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('5177bf19b8504292ae55e4a58d4cd8c4', '623b752f4d65400ba7933a79d3b1b1ac', 66, 1, 1, '2019-05-27 17:06:58', '2019-05-27 16:18:57', '2019-05-27 16:18:57');
INSERT INTO `oauth2_access_token` VALUES ('517823e0991b470f9d25508f365c5716', 'b4d1839b9228477d84d1cc28728333ea', 27, 2, 1, '2019-05-27 10:14:33', '2019-05-27 09:26:32', '2019-05-27 09:26:32');
INSERT INTO `oauth2_access_token` VALUES ('517bea22c84c43879ef971139917d19f', 'aa80af7fd5f9402da53e9e24a4ca6195', NULL, NULL, 1, '2019-04-09 16:27:41', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('51a0e3dae45a4198b0c3eca509a6dfac', 'cc3b43ee087c4a12bd665cde28e09786', 27, 2, 1, '2019-06-04 16:41:59', '2019-06-04 15:53:59', '2019-06-04 15:53:59');
INSERT INTO `oauth2_access_token` VALUES ('51b10df14caf4865a832c06b96285d34', '9e847011a5574697b661bdc61089ddbe', 27, 2, 1, '2019-07-03 21:30:13', '2019-07-03 20:42:12', '2019-07-03 20:42:12');
INSERT INTO `oauth2_access_token` VALUES ('51bf7ea7ec384089ad90131122f8d238', '7ed0157b6569453589ce3cd2024e3a7f', 1, 2, 0, '2019-08-21 18:49:51', '2019-08-21 18:01:50', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('51ff0339686c4c2bbb1ce2e407e8d498', 'e0d53b2d49cd4d7788fbb026c6605565', 27, 2, 1, '2019-07-11 10:13:39', '2019-07-11 09:25:39', '2019-07-11 09:25:39');
INSERT INTO `oauth2_access_token` VALUES ('52177cb94eab4c50bec29f0eff6d9cbb', '35edc0a9a02f48c98e06ee4707ef588d', 27, 2, 1, '2019-06-06 11:37:29', '2019-06-06 10:49:28', '2019-06-06 10:49:28');
INSERT INTO `oauth2_access_token` VALUES ('521ea530238b473e97290dcc9cb7af69', '662b7aeb841c4b8cb6a82a24abe1f487', 27, 2, 1, '2019-06-21 13:39:20', '2019-06-21 12:51:20', '2019-06-21 12:51:20');
INSERT INTO `oauth2_access_token` VALUES ('523012601f1f492fb85136c282469ae4', 'dba7cf9263a94cf6a9b367d95f84f3ea', 27, 2, 1, '2019-06-02 19:57:37', '2019-06-02 19:09:37', '2019-06-02 19:09:37');
INSERT INTO `oauth2_access_token` VALUES ('5239402d40304f0599aeccfd43b8bddd', 'd74bf3ab6c904eb596fc17b56812af35', 27, 2, 1, '2019-08-03 14:11:20', '2019-08-03 13:23:19', '2019-08-03 13:23:19');
INSERT INTO `oauth2_access_token` VALUES ('523dc587933449d89a0a8d359e637986', 'b7e29ab9e28b4d38a4baad569f86f9fe', 27, 2, 1, '2019-06-02 20:24:49', '2019-06-02 19:36:48', '2019-06-02 19:36:48');
INSERT INTO `oauth2_access_token` VALUES ('5249470eca8c4f9ba5eb27922b6c862e', '7f3fd831ce00459faf9bdee2f0a48f1f', 27, 2, 1, '2019-06-02 00:30:02', '2019-06-01 23:42:02', '2019-06-01 23:42:02');
INSERT INTO `oauth2_access_token` VALUES ('525a54a18871412389ddc85572712afd', '4f25a268221e4558be75d155f5c5bbc0', 27, 2, 1, '2019-09-02 11:35:42', '2019-09-02 10:47:41', '2019-09-02 10:47:41');
INSERT INTO `oauth2_access_token` VALUES ('525d6b4bda2443b3bb55341f330cb153', 'eb6f4db1cd7547f6921080422af4ef16', 27, 2, 1, '2019-06-04 14:30:43', '2019-06-04 13:42:43', '2019-06-04 13:42:43');
INSERT INTO `oauth2_access_token` VALUES ('527a0137efb542e2a4d4e3702cfa286d', '2791b27789a348f28b323df5401f49fe', NULL, NULL, 1, '2019-04-22 19:13:20', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('52b8686d15474b6f8475178358ef7be4', '48db20c7e9864e148fc6eb09ef1257d5', NULL, NULL, 1, '2019-03-13 00:32:57', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('52c0c98a712146dda1e3359bc169ac4b', 'bb0da8bd41574deeb5383a4145a45f40', 27, 2, 1, '2019-08-13 12:49:09', '2019-08-13 12:01:08', '2019-08-13 12:01:08');
INSERT INTO `oauth2_access_token` VALUES ('52c2ba42a8144ca59007496288cd197c', 'c0039cec6aba456d8422c64052ae681e', 1, 1, 1, '2019-05-18 21:14:32', '2019-05-18 20:26:32', '2019-05-18 20:26:32');
INSERT INTO `oauth2_access_token` VALUES ('52e41cb2c47549dcba8f28d939f445cd', 'dadbbbf6e6394d91ba6739bff4b61f96', 27, 2, 1, '2019-07-19 06:59:56', '2019-07-19 06:11:55', '2019-07-19 06:11:55');
INSERT INTO `oauth2_access_token` VALUES ('52ebc79689834537961561eb6508d8b5', '3fe95522bfdc42b5b0152ddc28bf74a6', 27, 2, 1, '2019-07-20 19:15:00', '2019-07-20 18:26:59', '2019-07-20 18:26:59');
INSERT INTO `oauth2_access_token` VALUES ('52f527d8170e48acb292cbe9c6baec70', '29b00491f4a84f0ea69d091be0bc0f07', 27, 2, 1, '2019-06-01 17:34:58', '2019-06-01 16:46:58', '2019-06-01 16:46:58');
INSERT INTO `oauth2_access_token` VALUES ('52fb9fae72ba4dd395c4a65ae2e0fac3', '312e19a7babf4a3d83edd9fec5be5546', 27, 2, 1, '2019-08-12 17:08:00', '2019-08-12 16:20:00', '2019-08-12 16:20:00');
INSERT INTO `oauth2_access_token` VALUES ('532464ba5697463b88e96807602bdacd', 'b8d91aea0fc04fd38d1f6b9a9b756f95', 27, 2, 1, '2019-06-20 20:07:57', '2019-06-20 19:19:57', '2019-06-20 19:19:57');
INSERT INTO `oauth2_access_token` VALUES ('533c84f2188c4b90b663305f935f8724', 'abf6429710ae4b1cb9b414772fa1bbde', NULL, NULL, 1, '2019-05-10 16:29:43', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('53469189ea244fe1bd498904f194f0cf', '169955b17f374e6597e29d52ad0accb0', 147, 1, 1, '2019-07-01 22:33:07', '2019-07-01 21:45:06', '2019-07-01 21:45:06');
INSERT INTO `oauth2_access_token` VALUES ('534a0a0e9e6c4113835f815ed63d3f68', '630247e1e0ab4d85ad540c81c199f1c8', 27, 2, 1, '2019-08-05 15:15:50', '2019-08-05 14:27:50', '2019-08-05 14:27:50');
INSERT INTO `oauth2_access_token` VALUES ('534d045b5ab14a0db4708fcedbf3201d', '8c6e3c99852f4a8b93322326e4f356c6', 27, 2, 1, '2019-08-29 16:33:43', '2019-08-29 15:45:43', '2019-08-29 15:45:43');
INSERT INTO `oauth2_access_token` VALUES ('534effa453e24fd09706765ae2a4e59b', '4f4413b4c4424d63a5cb2720ca131b40', 27, 2, 1, '2019-06-24 21:43:43', '2019-06-24 20:55:43', '2019-06-24 20:55:43');
INSERT INTO `oauth2_access_token` VALUES ('53759bef5ac147fd91fef84d24a9f70c', '63710b0b7f2c4bda920a6545f3e3bc01', NULL, NULL, 1, '2019-03-19 04:09:26', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5382b990def649aa94c5bc8a2a89cc8b', 'f431cce162104b4bbdaa0699a0eb9edc', 27, 2, 1, '2019-06-19 13:21:04', '2019-06-19 12:33:03', '2019-06-19 12:33:03');
INSERT INTO `oauth2_access_token` VALUES ('53b520db09c146dbb9e9ae8e5edd7425', 'fca4e32a738d4598a9d9a3ea29ee06ba', 27, 2, 1, '2019-06-03 15:45:41', '2019-06-03 14:57:41', '2019-06-03 14:57:41');
INSERT INTO `oauth2_access_token` VALUES ('53b6148f2bbc46a2a13af5fd4ee75325', '3a71ebab56f44d68a04b4e07e756f894', 27, 2, 1, '2019-06-03 23:11:30', '2019-06-03 22:23:30', '2019-06-03 22:23:30');
INSERT INTO `oauth2_access_token` VALUES ('53cf29e77790447d96aefeff67d91ba1', 'c157146f5bfb4940921739f0927e91d6', 27, 2, 1, '2019-09-08 16:09:17', '2019-09-08 15:21:16', '2019-09-08 15:21:16');
INSERT INTO `oauth2_access_token` VALUES ('53d4647f443a4dff99f9aed57c9b65ac', '14e006414482463ca7152885a643abfa', NULL, NULL, 1, '2019-04-02 00:38:43', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('53fa324ee8cb47e8ba5723aa76abca02', 'f60d2f39814a4a5ca4ca591fc1798001', 27, 2, 1, '2019-08-03 00:31:00', '2019-08-02 23:43:00', '2019-08-02 23:43:00');
INSERT INTO `oauth2_access_token` VALUES ('5419481cd4824e3ab102f4ba52bca959', 'e12e31f2ebbe4d2e828d064db8dfe2b8', 27, 2, 1, '2019-06-21 14:58:34', '2019-06-21 14:10:34', '2019-06-21 14:10:34');
INSERT INTO `oauth2_access_token` VALUES ('5423491664064a5daf8d39f86efb7f88', '42f310c784494afdb1e9cb11c1e0af8c', 27, 2, 1, '2019-07-31 11:18:42', '2019-07-31 10:30:42', '2019-07-31 10:30:42');
INSERT INTO `oauth2_access_token` VALUES ('5426471f323b446a8c21dd1f90b53c9a', 'ac6d35eb791742d48d1f674ece2f36b9', 27, 2, 1, '2019-06-13 17:20:14', '2019-06-13 16:32:14', '2019-06-13 16:32:14');
INSERT INTO `oauth2_access_token` VALUES ('54299346caee4ca0b60a96d641fb2dc2', '7a70eaf733b74135a303b9527e366068', 27, 2, 1, '2019-07-13 11:39:28', '2019-07-13 10:51:27', '2019-07-13 10:51:27');
INSERT INTO `oauth2_access_token` VALUES ('5430465b0ebe47f896fd5f5a2cc60972', '51886241e43f40fe9b79b394de344325', 27, 2, 1, '2019-08-28 18:33:10', '2019-08-28 17:45:10', '2019-08-28 17:45:10');
INSERT INTO `oauth2_access_token` VALUES ('543a79bdae9947d098f26a5496b13546', 'f314b6a5e2474d92876b2f94696a4590', 27, 2, 1, '2019-09-05 18:41:55', '2019-09-05 17:53:55', '2019-09-05 17:53:55');
INSERT INTO `oauth2_access_token` VALUES ('543d0270889244c88fe504e474696a65', '7d3c04767434468fa5ce1fd03aa1b198', 27, 2, 1, '2019-07-04 11:44:54', '2019-07-04 10:56:53', '2019-07-04 10:56:53');
INSERT INTO `oauth2_access_token` VALUES ('54482b9fd4454d8ca2d6b638cc894c42', '3e816dd5420e48d59270c6a375cad888', 27, 2, 1, '2019-05-21 17:17:40', '2019-05-21 16:29:40', '2019-05-21 16:29:40');
INSERT INTO `oauth2_access_token` VALUES ('54569174b6654f20a5dfaca0ae392796', '950341f2031240789d6f7c129bd7972b', NULL, NULL, 1, '2019-04-24 22:52:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5457ad3416174c478651aa9ed71729c9', '5f83a91152fc49139241de7537f56513', 27, 2, 1, '2019-06-06 18:28:32', '2019-06-06 17:40:32', '2019-06-06 17:40:32');
INSERT INTO `oauth2_access_token` VALUES ('54647e41eaaa456e919542baef4c7853', 'd63004e528c24769b65db1ccae36d1dd', 27, 2, 1, '2019-06-14 15:56:50', '2019-06-14 15:08:49', '2019-06-14 15:08:49');
INSERT INTO `oauth2_access_token` VALUES ('5477b269d56546bc88608d0666db79e0', '1cf486bf835149a687ccf68f38d091ec', 27, 2, 1, '2019-08-01 11:11:52', '2019-08-01 10:23:51', '2019-08-01 10:23:51');
INSERT INTO `oauth2_access_token` VALUES ('54a0e61734684cf9a91e45f0b2dbb7e2', '5806283f4b70466bb9606d6757c37ab9', 27, 2, 1, '2019-08-10 15:19:13', '2019-08-10 14:31:13', '2019-08-10 14:31:13');
INSERT INTO `oauth2_access_token` VALUES ('54ab1e1bec104a83941902d6a04a92c1', '8368bf9822b24579863d36c244f14b40', 27, 2, 1, '2019-05-31 18:14:31', '2019-05-31 17:26:31', '2019-05-31 17:26:31');
INSERT INTO `oauth2_access_token` VALUES ('54ea173caa314c298256c0b546284b6b', 'e34c8fa9a9f64918add95e6c7c79a581', 27, 2, 1, '2019-08-03 20:42:52', '2019-08-03 19:54:52', '2019-08-03 19:54:52');
INSERT INTO `oauth2_access_token` VALUES ('54f5049fb1ff415e91a9974753635560', 'c626d816e4c34c43a2da9eddaf88f6c9', 27, 2, 1, '2019-06-06 12:26:27', '2019-06-06 11:38:27', '2019-06-06 11:38:27');
INSERT INTO `oauth2_access_token` VALUES ('54f5b6c4e88b463db946b4be86b985d3', '206ff78aad574895869a12da603e232f', 27, 2, 1, '2019-07-08 18:16:26', '2019-07-08 17:28:26', '2019-07-08 17:28:26');
INSERT INTO `oauth2_access_token` VALUES ('550b450c45b4491db55ac0986122d862', '198f93b7e54a468fb95dfb9d55605e3d', 27, 2, 1, '2019-06-03 14:09:18', '2019-06-03 13:21:17', '2019-06-03 13:21:17');
INSERT INTO `oauth2_access_token` VALUES ('55188cb54cc0484e8bd1ab43dd3c09b5', '86a49d94519a4fd39e7237c4cc630234', 27, 2, 1, '2019-06-25 14:38:59', '2019-06-25 13:50:58', '2019-06-25 13:50:58');
INSERT INTO `oauth2_access_token` VALUES ('5520222376704ecfaddd010d446869be', 'b252ac9721754c5db65667b8e32f1301', 27, 2, 1, '2019-07-24 19:00:45', '2019-07-24 18:12:44', '2019-07-24 18:12:44');
INSERT INTO `oauth2_access_token` VALUES ('552cd01545df491c954f661a416c3deb', '55f60dfe6c7e45629bafade224696053', 27, 2, 1, '2019-05-31 17:59:46', '2019-05-31 17:11:45', '2019-05-31 17:11:45');
INSERT INTO `oauth2_access_token` VALUES ('55346427a63c4f258fd0bb13106edf8e', '276dfecc04b44981b0d695909dfcd16f', 87, 1, 1, '2019-05-28 21:47:22', '2019-05-28 20:59:24', '2019-05-28 20:59:24');
INSERT INTO `oauth2_access_token` VALUES ('55403cae178f4dd8ade289919bd807be', '6187e6e4afef482e9bdc8b0afda6e683', 27, 2, 1, '2019-06-02 08:06:13', '2019-06-02 07:18:12', '2019-06-02 07:18:12');
INSERT INTO `oauth2_access_token` VALUES ('55725267265b4dca913fb61de710dffa', '4a01ad6c591f44b6919ea3bdd5d1debb', 187, 1, 1, '2019-08-01 16:29:15', '2019-08-01 15:41:14', '2019-08-01 15:41:14');
INSERT INTO `oauth2_access_token` VALUES ('559cc71050c540cc89140419da6732c8', '4574d23649c54974b4276e6272f3c086', 27, 2, 1, '2019-06-06 15:12:30', '2019-06-06 14:24:30', '2019-06-06 14:24:30');
INSERT INTO `oauth2_access_token` VALUES ('55f30756ea59405eb3b3c795b898b5bf', '239894a1ab154f229248c0a57976825e', 27, 2, 1, '2019-07-31 22:21:00', '2019-07-31 21:32:59', '2019-07-31 21:32:59');
INSERT INTO `oauth2_access_token` VALUES ('55fb29efc9fa413fb5e22f16b58c73a8', '8c29b024e909471dafb138e8239ba17d', 27, 2, 1, '2019-08-06 10:12:21', '2019-08-06 09:24:20', '2019-08-06 09:24:20');
INSERT INTO `oauth2_access_token` VALUES ('560217c900ed4821ab653a2fcf56aa25', '0b0af24e3adb4ec7a29f3a8ebc82d253', 27, 2, 1, '2019-07-12 00:06:29', '2019-07-11 23:18:28', '2019-07-11 23:18:28');
INSERT INTO `oauth2_access_token` VALUES ('5606c9baa3a0441b9cd9a5486ec08af8', 'e4a289fd13204b368cb83dc84f931c21', 1, 2, 0, '2019-07-30 12:39:31', '2019-07-30 11:51:30', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('56125cf2d3ea43fc901672b9d3fdaad9', '5037a04e4a8f460e90f564b15af00458', NULL, NULL, 1, '2019-04-22 19:22:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('562d873b37354cd5ab1f08bfbc6dbec1', '3d9357a0ee8045878955ab02ea6b8a47', 27, 2, 1, '2019-07-01 23:10:47', '2019-07-01 22:22:47', '2019-07-01 22:22:47');
INSERT INTO `oauth2_access_token` VALUES ('563009579a4c4c0c8728dcd59101c17d', '65d3c3ed819c4cd189b74f8257cbe179', 1, 2, 0, '2019-08-21 18:49:52', '2019-08-21 18:01:52', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('567616d1ee6d4edb8212db4433d5ba6c', '071de72bc40348a38f7f93b2b2e02bb9', NULL, NULL, 1, '2019-05-05 10:18:44', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('569012e10f2f48779902c1e71bcebf5f', 'd5500833ab8b4d2ca43f37eee3f41d0d', 27, 2, 1, '2019-09-05 12:26:11', '2019-09-05 11:38:11', '2019-09-05 11:38:11');
INSERT INTO `oauth2_access_token` VALUES ('569600ca10a04d838b18a8fb5541bdde', 'a6a1fe6c6a25492a836982132228d977', 27, 2, 1, '2019-06-02 00:40:52', '2019-06-01 23:52:52', '2019-06-01 23:52:52');
INSERT INTO `oauth2_access_token` VALUES ('56a0d969da384340ac72835f012aa519', 'f1028dcf551d4c62a442db610dc20502', 1, 2, 0, '2019-08-30 03:30:16', '2019-08-30 02:42:16', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('56afd8e4c2b74cf2a7adadd42b3e055d', '01996333469a452ab23a5cd48159022e', NULL, NULL, 1, '2019-05-06 13:49:03', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('56affad63ca346e9bdc52a37e18a6c0e', '786eb338d2dd477bacdff72ba00016fe', 27, 2, 1, '2019-05-31 18:14:06', '2019-05-31 17:26:06', '2019-05-31 17:26:06');
INSERT INTO `oauth2_access_token` VALUES ('56b23d13143740ea86544b59f2cdb9f2', '61d369b653e9496289a280737ccb828f', 27, 2, 1, '2019-06-23 11:11:03', '2019-06-23 10:23:03', '2019-06-23 10:23:03');
INSERT INTO `oauth2_access_token` VALUES ('56ba0b809df04693a4e0b53df711a71c', 'd2f7abdf11e54662a62cbafa34716a79', 27, 2, 1, '2019-05-31 19:07:02', '2019-05-31 18:19:01', '2019-05-31 18:19:01');
INSERT INTO `oauth2_access_token` VALUES ('56c3a07b9d7d4fd9ba770d8e7a9dcffc', '399b6c65498342b6a1c8e7ca4ba796e6', 1, 2, 0, '2019-07-09 09:03:08', '2019-07-09 08:15:08', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('56c59311469b493a80c3ae7345a91c99', 'dd5e8e5e6f884a41b1c53d901d12e868', 27, 2, 1, '2019-08-06 15:28:09', '2019-08-06 14:40:08', '2019-08-06 14:40:08');
INSERT INTO `oauth2_access_token` VALUES ('56d5a072727f4885a146be11333b307f', 'efe568813166466dad3026cfaf4b0244', 27, 2, 1, '2019-08-17 19:13:58', '2019-08-17 18:25:57', '2019-08-17 18:25:57');
INSERT INTO `oauth2_access_token` VALUES ('56db52c8eac642acbd66dcbc82e39b07', '3951cecbcb984b74babb9e213225ce4c', 27, 2, 1, '2019-07-15 22:04:08', '2019-07-15 21:16:07', '2019-07-15 21:16:07');
INSERT INTO `oauth2_access_token` VALUES ('56e105ddd2ef4148950a8a82690f2350', 'e8928124979d4f29b8f77c1aa9571936', 27, 2, 1, '2019-06-21 02:47:04', '2019-06-21 01:59:03', '2019-06-21 01:59:03');
INSERT INTO `oauth2_access_token` VALUES ('56eb1e298d4a4b228c69f5e991629cc4', '763afeda3c00437e9cfb96ee87d68305', 27, 2, 1, '2019-06-30 14:21:11', '2019-06-30 13:33:10', '2019-06-30 13:33:10');
INSERT INTO `oauth2_access_token` VALUES ('56ed3712f4a94af0afd0e18f5ef85cc6', '544ebf922ce54183980b061873150aa0', 1, 2, 0, '2019-06-07 14:18:37', '2019-06-07 13:30:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('56f17a3590f64c9983b32866d2d994ba', '964b3fec63f34082b4bc34326db6007a', NULL, NULL, 1, '2019-04-04 16:16:52', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('56f94c9e99264edd94175ffa660b5ab7', '90c41c00021c4022ab4457c253788ab9', NULL, NULL, 1, '2019-04-03 18:32:08', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('56f988be03034e678f0bcf638b7c1c07', 'fc5a16bb3b7a40d5bf5697102a7ffcc8', 27, 2, 1, '2019-06-01 10:04:40', '2019-06-01 09:16:40', '2019-06-01 09:16:40');
INSERT INTO `oauth2_access_token` VALUES ('57066aac137f4aecb684ba859e22fac0', '8866973b37d44d34a39f912e3f79ba13', NULL, NULL, 1, '2019-04-24 09:04:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('57095dedc562483caa0472c85c2a553f', 'b84e22f153d2497e83ebdd970a0756a7', 27, 2, 1, '2019-08-14 16:33:08', '2019-08-14 15:45:07', '2019-08-14 15:45:07');
INSERT INTO `oauth2_access_token` VALUES ('5712ddd75a2e4bbbaf8d33a3b866adc0', '7949709e15464224a15f68f51ff6330d', NULL, NULL, 1, '2019-05-06 10:47:00', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('571dbc9acb4d40068670072151050a2e', '45433f62ef9340068a786f64888471b0', NULL, NULL, 0, '2019-02-28 04:56:33', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('57268813aa4942f8a79563ed92d71e2f', 'e81714ab6e434ed98b9d4ca80a2c4e8e', NULL, NULL, 1, '2019-05-08 10:27:30', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('573a7ef3e4db431fa272e66759403273', 'ba7a3b271f8944c9a4b773c5e6af12f1', 27, 2, 1, '2019-07-18 12:12:06', '2019-07-18 11:24:05', '2019-07-18 11:24:05');
INSERT INTO `oauth2_access_token` VALUES ('573fc38f8ab84b34a876906cf189726d', 'ebc891372feb45d3b00a64e41909d1d4', 174, 1, 1, '2019-07-17 14:02:09', '2019-07-17 13:14:08', '2019-07-17 13:14:08');
INSERT INTO `oauth2_access_token` VALUES ('5777adce998648d2a27ee7d1183f4c7d', '5f814f2c15a24afcb1a92a54897715f6', NULL, NULL, 1, '2019-05-11 13:54:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5781af95904e45308b4312f553261d83', 'f6c36fb78524451d8c56c8f1d972cd50', 27, 2, 1, '2019-07-21 11:06:13', '2019-07-21 10:18:12', '2019-07-21 10:18:12');
INSERT INTO `oauth2_access_token` VALUES ('579f5d7a4a1d4890b758c1291b67123e', '499d8fef957f41d8b8a1dcf148df1a9c', 27, 2, 1, '2019-05-31 18:02:28', '2019-05-31 17:14:28', '2019-05-31 17:14:28');
INSERT INTO `oauth2_access_token` VALUES ('57a1b0186cc549178f515484b5308029', 'b3145893956e4da5a354695f3000b578', 27, 2, 1, '2019-07-13 10:14:00', '2019-07-13 09:26:00', '2019-07-13 09:26:00');
INSERT INTO `oauth2_access_token` VALUES ('57b04df2eeaa46b28010405cad9b864c', '20ccd60e391c4043961a7bf49493ef6a', 27, 2, 1, '2019-06-01 22:16:29', '2019-06-01 21:28:29', '2019-06-01 21:28:29');
INSERT INTO `oauth2_access_token` VALUES ('57bd6ee7cb3b4ce4ac76ae7f75257e19', 'f9ed17ff1e9349a2ba100ed5a30429a3', 27, 2, 1, '2019-08-29 09:34:08', '2019-08-29 08:46:07', '2019-08-29 08:46:07');
INSERT INTO `oauth2_access_token` VALUES ('57c293c6c2cd48e9ae773b200aad7536', '1f35aaa913344324aa0c76eea5b79a53', 27, 2, 1, '2019-06-28 10:48:05', '2019-06-28 10:00:04', '2019-06-28 10:00:04');
INSERT INTO `oauth2_access_token` VALUES ('57f54d95f04f4d92888273131aaa12cf', '6879b992b2534a9997db99a6421ffec6', 27, 2, 1, '2019-07-17 21:39:18', '2019-07-17 20:51:17', '2019-07-17 20:51:17');
INSERT INTO `oauth2_access_token` VALUES ('57fed937f8a04217af716e71a27c52b1', '1e68e85ea97a4a4596d4e95982dedf46', NULL, NULL, 1, '2019-04-09 14:51:30', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5831c6ace8ca4235bfec1b56cda57f0a', '06970e8279cb401ead0433b2479e39fb', 1, 2, 0, '2019-06-01 10:46:56', '2019-06-01 09:58:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('5857dd14a7d848e6acb7743ae5becf5e', '14d0a4afb3094be0b2afc9e9d6e7b9ec', 27, 2, 1, '2019-08-07 17:52:06', '2019-08-07 17:04:06', '2019-08-07 17:04:06');
INSERT INTO `oauth2_access_token` VALUES ('585ae0b94a584d5cb42e2c5e4669ac8f', 'a5fb9bbda64e4eae9b7d1e662d5f2948', 1, 2, 0, '2019-06-26 21:16:01', '2019-06-26 20:28:00', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('586b1791c0cd41f0905bf75c1c253064', '9b32c289900a431e9a1e4642b5bc908b', 27, 2, 1, '2019-07-09 21:33:45', '2019-07-09 20:45:44', '2019-07-09 20:45:44');
INSERT INTO `oauth2_access_token` VALUES ('587163d764ed4094a3b8baf5370fdd8d', 'aaa43a46dc86495e8f7e3eb1458e92aa', 154, 1, 1, '2019-07-02 21:13:01', '2019-07-02 20:25:00', '2019-07-02 20:25:00');
INSERT INTO `oauth2_access_token` VALUES ('587b9d72e2ec45a6bf5fe12c9605892d', 'dcbd8f0cebb84c2c99aefb6e9aa3c3dc', NULL, NULL, 1, '2019-04-22 19:08:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('587ba159349447648f9e70f97a6e31c1', '323a7bf1bc314e8788fe0ed898349241', 27, 2, 1, '2019-06-19 16:44:17', '2019-06-19 15:56:17', '2019-06-19 15:56:17');
INSERT INTO `oauth2_access_token` VALUES ('587f5315678549b5a0d4496604b45775', '2f6cdc3ca7904fe5819af71385c62099', NULL, NULL, 1, '2019-05-05 16:08:26', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5896ce54d4b3475087eac221d4df87d3', '4e2d7d67905240df937de5c457bdfb2f', 27, 2, 1, '2019-08-09 18:56:55', '2019-08-09 18:08:55', '2019-08-09 18:08:55');
INSERT INTO `oauth2_access_token` VALUES ('589afbf8b1fe4379809dde9425620f5c', 'd9687f98894c41f98f5ceb039fb583ee', 27, 2, 1, '2019-06-03 01:25:09', '2019-06-03 00:37:09', '2019-06-03 00:37:09');
INSERT INTO `oauth2_access_token` VALUES ('58a7a21d01084b9ba3f12d8618cfe18f', 'ff215e32c98b4de1a940cf2b9349b219', 27, 2, 1, '2019-06-03 09:54:45', '2019-06-03 09:06:45', '2019-06-03 09:06:45');
INSERT INTO `oauth2_access_token` VALUES ('58f2f0086f594a3aa01f4931e942404e', '9ed4d95eeb254ebab5f860d30b8b7154', 158, 1, 1, '2019-07-06 12:20:23', '2019-07-06 11:32:23', '2019-07-06 11:32:23');
INSERT INTO `oauth2_access_token` VALUES ('58fe3622bca7442084816834abf91ffe', 'bc12908b83674b26ab0219d88ec822e0', 1, 2, 0, '2019-09-05 10:27:49', '2019-09-05 09:39:48', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('58fed4a0d43e429b85c8393fb6dcfee1', '10fb11c17e6c4f77ab1ea1237a8253e9', 27, 2, 1, '2019-06-01 10:11:49', '2019-06-01 09:23:49', '2019-06-01 09:23:49');
INSERT INTO `oauth2_access_token` VALUES ('59016dcd798b40009ca7d07b856a683e', '7ce1b08dc12549bf9ba7cd5925493951', NULL, NULL, 1, '2019-04-11 18:28:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5921c6156f01425ba355896e230f2f89', 'c4dacc686ed94611a1a14bce64085e73', 27, 2, 1, '2019-07-08 10:20:20', '2019-07-08 09:32:19', '2019-07-08 09:32:19');
INSERT INTO `oauth2_access_token` VALUES ('593479dec2044ec3b8c141717f0cf198', '079ad9e495be45afb377a463905e18b4', 27, 2, 1, '2019-07-23 15:58:57', '2019-07-23 15:10:57', '2019-07-23 15:10:57');
INSERT INTO `oauth2_access_token` VALUES ('593f5fca789f45708f4e1e89010fb756', '001f07f992f44120b92afae706dae2bb', 27, 2, 1, '2019-08-10 11:45:02', '2019-08-10 10:57:01', '2019-08-10 10:57:01');
INSERT INTO `oauth2_access_token` VALUES ('59a1846af0bd448fb2298e802b2604cc', 'b72268813a2a40d7a58d758f9938de16', NULL, NULL, 1, '2019-03-30 23:56:52', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('59a93971c70445d3bae42d6c1532fc27', 'ddf218fd31d546469f7668c6ac9774b0', 92, 1, 1, '2019-05-30 18:39:15', '2019-05-30 17:51:15', '2019-05-30 17:51:15');
INSERT INTO `oauth2_access_token` VALUES ('59bc801722c640b5aa71d5a09f8f8819', '59c70e4b7b9449feac9c4544e90b5d89', 208, 1, 1, '2019-08-20 18:39:36', '2019-08-20 17:51:36', '2019-08-20 17:51:36');
INSERT INTO `oauth2_access_token` VALUES ('59ca80fef8e54d61a2b1a8f0c920d9ec', 'd8bfee7fd32e47f7bc4f8d6aaabf3753', 1, 2, 0, '2019-07-27 11:44:56', '2019-07-27 10:56:56', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('59d13476c7e64533a1399f9f1fb4c15d', 'a42ca762bcae4220a30d2abfa2f8c132', 27, 2, 1, '2019-07-11 14:45:04', '2019-07-11 13:57:03', '2019-07-11 13:57:03');
INSERT INTO `oauth2_access_token` VALUES ('59dda0acf11f4996a4ff4d8361eb5310', '3ef397977dcb450bb6e7e3cb6d742710', 27, 2, 1, '2019-07-24 19:49:35', '2019-07-24 19:01:35', '2019-07-24 19:01:35');
INSERT INTO `oauth2_access_token` VALUES ('59e1c19e75124c76ace9a6382348a43f', '5737d9707b514bf0ba13ae3f6848b6b6', 27, 2, 1, '2019-06-21 09:46:39', '2019-06-21 08:58:39', '2019-06-21 08:58:39');
INSERT INTO `oauth2_access_token` VALUES ('59e5dabc99d145b39e53f14a9e3c2593', 'fbc05f9a139546cf9df46b759fb0acca', 1, 2, 0, '2019-08-29 16:35:20', '2019-08-29 15:47:20', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('59ff55f781a44efbaac99b58159277a9', 'c2117efb86954962a7300ef0ec6ca528', 27, 2, 1, '2019-08-16 09:35:05', '2019-08-16 08:47:05', '2019-08-16 08:47:05');
INSERT INTO `oauth2_access_token` VALUES ('5a0fc057f87543019fca14e5a601214a', '463c633b4cf54f268fa54b4fffe6aa43', NULL, NULL, 1, '2019-04-28 18:34:31', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5a15e9b8898a480583fb5ce219379e6e', 'd15144b987564a2a829ee4a897cad38d', 27, 2, 1, '2019-08-16 16:56:46', '2019-08-16 16:08:46', '2019-08-16 16:08:46');
INSERT INTO `oauth2_access_token` VALUES ('5a3d036b773540ada886aaf5b2f798b6', '960f6157bf104643b395f10016a5a03c', 27, 2, 1, '2019-05-27 12:48:36', '2019-05-27 12:00:35', '2019-05-27 12:00:35');
INSERT INTO `oauth2_access_token` VALUES ('5a3d053abc844b26bfef09b0f47d965f', 'c1520761214c4086bbfb82865fdd102c', 27, 2, 1, '2019-06-23 12:52:00', '2019-06-23 12:03:59', '2019-06-23 12:03:59');
INSERT INTO `oauth2_access_token` VALUES ('5a579edb021247ffb0f63adaad7ef124', '35597f6f3561467a82e5f638dc88b3c3', 1, 2, 0, '2019-06-18 14:04:18', '2019-06-18 13:16:18', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('5a5afe0b8d564ff1bea935a1bb24a266', '88d63951608d42b9b9d1bcd073b32251', 27, 2, 1, '2019-06-22 17:43:38', '2019-06-22 16:55:38', '2019-06-22 16:55:38');
INSERT INTO `oauth2_access_token` VALUES ('5a6553bac22f4604924783eb26468ca2', 'e68d44e7518447219a1243fd1df8accf', 27, 2, 1, '2019-08-12 15:08:36', '2019-08-12 14:20:35', '2019-08-12 14:20:35');
INSERT INTO `oauth2_access_token` VALUES ('5a69bc3722ce41a8b47d59d2e9985138', 'bdfa215667a644bd9193435f1d7ddcba', 27, 2, 1, '2019-07-15 15:57:29', '2019-07-15 15:09:29', '2019-07-15 15:09:29');
INSERT INTO `oauth2_access_token` VALUES ('5a7229eb12c24518b7984d53cfd6673c', '9231143e9f234a098f759653fb165cad', 27, 2, 1, '2019-07-12 22:51:23', '2019-07-12 22:03:22', '2019-07-12 22:03:22');
INSERT INTO `oauth2_access_token` VALUES ('5a7804e942ff4e74b57f641a87e548b1', 'c6fb02257d4c470986eb518d42270367', 27, 2, 1, '2019-06-10 11:07:34', '2019-06-10 10:19:34', '2019-06-10 10:19:34');
INSERT INTO `oauth2_access_token` VALUES ('5a960b2549ed49478ab1762c1e4739aa', '3df5842ca7014849ad07b49e4168a91e', 200, 1, 1, '2019-08-14 10:32:26', '2019-08-14 09:44:25', '2019-08-14 09:44:25');
INSERT INTO `oauth2_access_token` VALUES ('5aa936256d174f099afebded4d1d439c', '9730ded7920440ca952a57508fda4fc7', 27, 2, 1, '2019-05-22 15:26:05', '2019-05-22 14:38:05', '2019-05-22 14:38:05');
INSERT INTO `oauth2_access_token` VALUES ('5aafd0089d3d42acb09e11fb973b6f9e', '374362624ab24312b5ed9bc947c8f8f9', 27, 2, 1, '2019-07-13 15:35:13', '2019-07-13 14:47:13', '2019-07-13 14:47:13');
INSERT INTO `oauth2_access_token` VALUES ('5adfff038650487790e44288d133ee28', '8c1f2833e9764f12a77162715050a193', 27, 2, 1, '2019-05-31 19:16:22', '2019-05-31 18:28:21', '2019-05-31 18:28:21');
INSERT INTO `oauth2_access_token` VALUES ('5ae55592296e4b07a0bc1f8524502e48', '4f8ab6df977e45c2bd6d14813441e18e', 27, 2, 1, '2019-06-26 15:52:48', '2019-06-26 15:04:48', '2019-06-26 15:04:48');
INSERT INTO `oauth2_access_token` VALUES ('5aef3d763c6f4b669c1a729cd5ddd6e0', 'cc522e89b3634e18a538314b30a1b855', 27, 2, 1, '2019-06-06 15:34:56', '2019-06-06 14:46:56', '2019-06-06 14:46:56');
INSERT INTO `oauth2_access_token` VALUES ('5afe1b9fe145428c855baba4d7850252', '5cce099443024c2ab57c67f4a6f7dc28', 27, 2, 1, '2019-06-04 17:38:29', '2019-06-04 16:50:28', '2019-06-04 16:50:28');
INSERT INTO `oauth2_access_token` VALUES ('5b0752e0570e4381878878ace0e344ec', 'ba1ffd5d363342cfac0785e2d99f2f1c', 27, 2, 1, '2019-07-09 12:06:51', '2019-07-09 11:18:50', '2019-07-09 11:18:50');
INSERT INTO `oauth2_access_token` VALUES ('5b0a8f20f25d4270ae0f65bd4047ac1e', '600395e470db43838958141424cbdadf', 27, 2, 1, '2019-06-26 15:56:26', '2019-06-26 15:08:26', '2019-06-26 15:08:26');
INSERT INTO `oauth2_access_token` VALUES ('5b24365ec0894bc193311879e0e59a88', '88ac408c8e1e473587d613f8877b32f2', NULL, NULL, 1, '2019-05-10 01:49:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5b4441f3971f48508492f0af867997c7', 'caabe9a844aa41b0868abf0932168393', 27, 2, 1, '2019-07-02 17:39:49', '2019-07-02 16:51:49', '2019-07-02 16:51:49');
INSERT INTO `oauth2_access_token` VALUES ('5b5ff02544ac47c0bb0c69a0015cc26f', 'a7f44b317c504668b9a4b9bdb0cd058d', 27, 2, 1, '2019-07-02 14:16:41', '2019-07-02 13:28:41', '2019-07-02 13:28:41');
INSERT INTO `oauth2_access_token` VALUES ('5b609a391f554db58f2928d3dd63a4ed', 'b909ef7462ca4826bb4b9acbee54cc5d', 27, 2, 1, '2019-06-17 17:05:06', '2019-06-17 16:17:06', '2019-06-17 16:17:06');
INSERT INTO `oauth2_access_token` VALUES ('5b98c0ee5f4740dd9148ea6143cec9ea', 'be45de965eca4734ac383bd0ac299f16', 27, 2, 1, '2019-06-19 16:45:46', '2019-06-19 15:57:46', '2019-06-19 15:57:46');
INSERT INTO `oauth2_access_token` VALUES ('5ba5ac81862c4c58a38c2958fc9ef03d', '06003a97ebe749418fde2465224f34a3', 27, 2, 1, '2019-08-26 10:55:37', '2019-08-26 10:07:36', '2019-08-26 10:07:36');
INSERT INTO `oauth2_access_token` VALUES ('5bb409b88ceb4f4a9b57c5c5b6794f7d', '4beaf6e0bdcc46c0968e676b8695715a', 27, 2, 1, '2019-08-29 10:19:43', '2019-08-29 09:31:42', '2019-08-29 09:31:42');
INSERT INTO `oauth2_access_token` VALUES ('5bc3e7c92b5a44878df41fef2c852766', '6686802383c84dae9a2390dbb407655e', NULL, NULL, 0, '2019-02-27 16:59:01', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5bc92f8aa02846b6b596409d468b0d87', 'd2cdd3373d244994ae1562238fedf3c8', 27, 2, 1, '2019-08-08 15:21:35', '2019-08-08 14:33:35', '2019-08-08 14:33:35');
INSERT INTO `oauth2_access_token` VALUES ('5bdd233389c94fefb7b3bd5a04a01030', '71223b9f4d2c42ca9944f93d44f5a5f5', 27, 2, 1, '2019-06-02 11:46:33', '2019-06-02 10:58:32', '2019-06-02 10:58:32');
INSERT INTO `oauth2_access_token` VALUES ('5be7429253d3470fbbeff323cfd398df', '178d20b6402646aba1c63275691b16b8', 27, 2, 1, '2019-06-04 10:57:17', '2019-06-04 10:09:17', '2019-06-04 10:09:17');
INSERT INTO `oauth2_access_token` VALUES ('5bf5d238e2aa48aa9fe008298245fd94', '9bbf64d1e9874056a44059d7bff45081', NULL, NULL, 1, '2019-04-25 17:51:38', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5bf61116e76445c1ab8eab2ee3b858d1', '173a22cd13244c7fb930430f0d70a78e', 27, 2, 1, '2019-06-20 10:44:19', '2019-06-20 09:56:18', '2019-06-20 09:56:18');
INSERT INTO `oauth2_access_token` VALUES ('5bfc761086644dddbb015aff8f13aae9', 'ddde5ca61fb9410fbe3334bb67434590', 27, 2, 1, '2019-06-28 18:07:48', '2019-06-28 17:19:47', '2019-06-28 17:19:47');
INSERT INTO `oauth2_access_token` VALUES ('5c0bafb24d9445f0960230898ce36b9e', '004f710b82fe4c028276bac18aa0fd59', 27, 2, 1, '2019-06-24 22:12:39', '2019-06-24 21:24:39', '2019-06-24 21:24:39');
INSERT INTO `oauth2_access_token` VALUES ('5c3b054bea0e4b84a324c97363fb95f3', 'e91e36216f3a4693a37e13e8a0e7559f', 1, 2, 0, '2019-06-21 11:37:37', '2019-06-21 10:49:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('5c3c760649424280996dc0e11912fba0', 'fb18ba534f8e4fc8bd9b0c7b73e6b3f5', 27, 2, 1, '2019-08-30 09:30:59', '2019-08-30 08:42:58', '2019-08-30 08:42:58');
INSERT INTO `oauth2_access_token` VALUES ('5c3e8d9491fc4377a89471b7bb70bd93', '8c82a2ae8bc541888686afcd8ede74c3', 27, 2, 1, '2019-06-06 18:20:33', '2019-06-06 17:32:33', '2019-06-06 17:32:33');
INSERT INTO `oauth2_access_token` VALUES ('5c63df9efe3c49bb8db08e2c3f6ce80e', '70ebc06cbad94c54b360042b5b4bfd4f', 27, 2, 1, '2019-08-15 20:27:06', '2019-08-15 19:39:05', '2019-08-15 19:39:05');
INSERT INTO `oauth2_access_token` VALUES ('5c83d6578752463f9a7ee0367cf286bb', 'af10b853f3054d5fb58a548b00a44bf6', 1, 2, 0, '2019-05-26 14:50:44', '2019-05-26 14:02:44', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('5ca6991f86dc4834a975f50e194fab58', '0c1a73876b224e948dbbf95acda3a8a0', 27, 2, 1, '2019-08-19 21:31:24', '2019-08-19 20:43:24', '2019-08-19 20:43:24');
INSERT INTO `oauth2_access_token` VALUES ('5ca73329f9fa4cadacf2a753eae9e338', '316c30670d14459683fa75b881eb45fb', 27, 2, 1, '2019-08-08 15:35:01', '2019-08-08 14:47:00', '2019-08-08 14:47:00');
INSERT INTO `oauth2_access_token` VALUES ('5ca755c30c4846c2830dc88c6d38384b', 'b06de39326e54b35979b78b89a269284', 27, 2, 1, '2019-08-18 17:56:32', '2019-08-18 17:08:32', '2019-08-18 17:08:32');
INSERT INTO `oauth2_access_token` VALUES ('5cad293a8a9f42c58c232c9854d65ef5', '2b10595c2e754499ac6cc25a21dc2b9e', 27, 2, 1, '2019-07-29 15:34:04', '2019-07-29 14:46:04', '2019-07-29 14:46:04');
INSERT INTO `oauth2_access_token` VALUES ('5ce79ed0e0554d3796004d59a10d8a50', 'def4d7d5eaf248ffb9bde3d73e3a9e36', NULL, NULL, 0, '2019-03-03 22:56:02', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5cefdf435dbe4788b99b87d2cf9128b3', '1d998cc166b54ff9947665fa43943b0d', 27, 2, 1, '2019-07-05 16:42:57', '2019-07-05 15:54:57', '2019-07-05 15:54:57');
INSERT INTO `oauth2_access_token` VALUES ('5cfb2a0e8b504ac5a90358baf5acc8e2', '7d20a092454b4634aa0dbfaf72df9ce8', 27, 2, 1, '2019-07-07 16:05:37', '2019-07-07 15:17:37', '2019-07-07 15:17:37');
INSERT INTO `oauth2_access_token` VALUES ('5cffecc01ba448d593003f4c625e194a', 'afefa066abb34aa8a0026d8466724315', 27, 2, 1, '2019-05-28 15:29:11', '2019-05-28 14:41:11', '2019-05-28 14:41:11');
INSERT INTO `oauth2_access_token` VALUES ('5d0b2962c77a47268e554a622493ae62', '432f8b7ebd264806b9c29b71eee8badb', 27, 2, 1, '2019-07-21 10:28:44', '2019-07-21 09:40:44', '2019-07-21 09:40:44');
INSERT INTO `oauth2_access_token` VALUES ('5d0b6e1f1f144463b473c9d2c9c03259', '8414d4617a7744a295c42e2d61e9a8f3', NULL, NULL, 1, '2019-05-08 09:18:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5d0e289938614bc8bd0f0979a935e1d5', 'ccaaaf9e898d472aab0201cc67a7a9fb', NULL, NULL, 1, '2019-03-10 09:36:04', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5d229b6556ab4770bc59d95f465e9781', '4127908df1aa4bffb7286e80f0bd0931', 27, 2, 1, '2019-06-19 16:26:46', '2019-06-19 15:38:46', '2019-06-19 15:38:46');
INSERT INTO `oauth2_access_token` VALUES ('5d4b94ebbd2749dbb6646eb06ab868a3', 'c7c496c47dec494a9159965a76204c66', 27, 2, 1, '2019-06-07 15:49:26', '2019-06-07 15:01:26', '2019-06-07 15:01:26');
INSERT INTO `oauth2_access_token` VALUES ('5d542eb265034c468fbf0b166689398c', 'e1bf1e58de6445d28f8f9e138a7f79a1', 27, 2, 1, '2019-07-04 18:17:40', '2019-07-04 17:29:39', '2019-07-04 17:29:39');
INSERT INTO `oauth2_access_token` VALUES ('5d607d4f808b40ceb19046ff744d0343', '39366a4eeb074f0bbcf71399d6bc9bd3', 27, 2, 1, '2019-06-06 15:23:15', '2019-06-06 14:35:14', '2019-06-06 14:35:14');
INSERT INTO `oauth2_access_token` VALUES ('5d691d4d33c142e6a1a66b2674be782d', 'f445f26fe428400bb0d39772b9a8a5a9', 27, 2, 1, '2019-08-05 16:03:23', '2019-08-05 15:15:22', '2019-08-05 15:15:22');
INSERT INTO `oauth2_access_token` VALUES ('5d7dc7a9baa548e5860e247433dc2624', '6e8b0f82b7fe4e3aa438328c4607b9bf', NULL, NULL, 1, '2019-04-01 23:25:52', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5da7ba7cf5dc430491d3f162cbb77780', '2d81c4ef99244a73a916a48aaafa39da', 27, 2, 1, '2019-08-23 15:52:31', '2019-08-23 15:04:30', '2019-08-23 15:04:30');
INSERT INTO `oauth2_access_token` VALUES ('5dafe12f75734e23b26e20095106b4e1', '18599ca8d6f740068f681777ae2a614e', 27, 2, 1, '2019-06-05 12:34:23', '2019-06-05 11:46:23', '2019-06-05 11:46:23');
INSERT INTO `oauth2_access_token` VALUES ('5dc824a8b83c44e8a11debf98904e045', '0ae42900437a4ac09e474f5eeaebdbae', 27, 2, 1, '2019-06-17 14:59:11', '2019-06-17 14:11:11', '2019-06-17 14:11:11');
INSERT INTO `oauth2_access_token` VALUES ('5dd908a5bc3348de965ad2710d292b27', '3d05d8b1a4bd4d94bc054e8ad4f3cc1f', 27, 2, 1, '2019-08-12 18:17:04', '2019-08-12 17:29:03', '2019-08-12 17:29:03');
INSERT INTO `oauth2_access_token` VALUES ('5dde7bba5ae7478d981d57a7da143179', '80eb0c1e43e646b49999a89e42964cc3', 135, 1, 1, '2019-06-23 23:12:30', '2019-06-23 22:24:29', '2019-06-23 22:24:29');
INSERT INTO `oauth2_access_token` VALUES ('5e038998c65745dfb0a08ee56d1179a5', '2328d682d9944caf8d510c1846255042', 27, 2, 1, '2019-07-31 11:10:29', '2019-07-31 10:22:29', '2019-07-31 10:22:29');
INSERT INTO `oauth2_access_token` VALUES ('5e2dc57f26aa4f92a88c0c81856751d9', '7e4761b8dd6f40a6873631bb3d2d1a74', 27, 2, 1, '2019-09-01 22:55:10', '2019-09-01 22:07:10', '2019-09-01 22:07:10');
INSERT INTO `oauth2_access_token` VALUES ('5e2f6cf1fc50487aa6053df9f4db5f0d', '8238a8edf3cf4a3b820e4ce1e2e5def5', 27, 2, 1, '2019-07-22 14:58:08', '2019-07-22 14:10:08', '2019-07-22 14:10:08');
INSERT INTO `oauth2_access_token` VALUES ('5e3232de71b74bc8b7b94c6ebf6e27a3', '2de47c27bb0b41ec8880b1014cbf8aba', 101, 1, 1, '2019-06-02 23:26:28', '2019-06-02 22:38:27', '2019-06-02 22:38:27');
INSERT INTO `oauth2_access_token` VALUES ('5e362aabd97c4343b65ae8699b89b1b6', 'f996838d12264f1ca727bc27f6a6127d', 27, 2, 1, '2019-08-05 15:44:41', '2019-08-05 14:56:41', '2019-08-05 14:56:41');
INSERT INTO `oauth2_access_token` VALUES ('5e3bb4d042a3473989a50e58c95d6093', '0cc9cd2254534d1fa734d558b48cfbe1', 27, 2, 1, '2019-06-04 17:00:10', '2019-06-04 16:12:10', '2019-06-04 16:12:10');
INSERT INTO `oauth2_access_token` VALUES ('5e501b6f03e64e50a80696ca4e213a33', '479286c16bbe45e4a8df33091021debb', 27, 2, 1, '2019-07-31 14:26:21', '2019-07-31 13:38:21', '2019-07-31 13:38:21');
INSERT INTO `oauth2_access_token` VALUES ('5e5745ea93874e44af1fb926dc5b06dd', 'd9b9ac71ffa843bd9d6568debf315f9a', 1, 2, 0, '2019-06-06 18:54:10', '2019-06-06 18:06:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('5e5a2494391448dc97f97db28d7211ce', 'fa7efaae862347d2891e2b2b99eb7606', NULL, NULL, 1, '2019-05-05 10:37:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5ec3812cd38e43ea95dd2acd41d824eb', 'ab1901e6b881421dbaad0903ea2e2d46', 27, 2, 1, '2019-06-02 12:36:59', '2019-06-02 11:48:59', '2019-06-02 11:48:59');
INSERT INTO `oauth2_access_token` VALUES ('5ecc0603c3374cf39477b93c59c521f1', '380e472f3910451c899328b6cdab6cd6', 27, 2, 1, '2019-06-06 12:26:43', '2019-06-06 11:38:42', '2019-06-06 11:38:42');
INSERT INTO `oauth2_access_token` VALUES ('5ecfc0c01930405b8437a92547f6009c', '4f145cca36524bb88cada35a450b8ea8', 27, 2, 1, '2019-07-11 13:46:40', '2019-07-11 12:58:40', '2019-07-11 12:58:40');
INSERT INTO `oauth2_access_token` VALUES ('5ed87d744a59455db6f780cb1f7729a0', 'b574b29987f748d288d539e372b6893b', NULL, NULL, 1, '2019-05-10 14:18:17', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5edb28a3b87c43ecb17702ecca5b6be1', '9dd36a3c5d44486ab6e98c03eb5d6c71', 27, 2, 1, '2019-06-01 01:36:40', '2019-06-01 00:48:39', '2019-06-01 00:48:39');
INSERT INTO `oauth2_access_token` VALUES ('5ee0a9d6549f4f86955e02fba2a5302d', '5e6ff68134784d92b4badd8a3095bb89', 27, 2, 1, '2019-06-08 21:00:45', '2019-06-08 20:12:44', '2019-06-08 20:12:44');
INSERT INTO `oauth2_access_token` VALUES ('5ee3d3811ead42f895d8ddca402a16ae', '35eab30784ce4269b85490e59efd8e02', 27, 2, 1, '2019-06-02 00:28:22', '2019-06-01 23:40:22', '2019-06-01 23:40:22');
INSERT INTO `oauth2_access_token` VALUES ('5f1008f5caa041e0814ae0f3ce477110', '5be25e6c59614fe79275566bf170b185', 27, 2, 1, '2019-07-06 11:51:02', '2019-07-06 11:03:01', '2019-07-06 11:03:01');
INSERT INTO `oauth2_access_token` VALUES ('5f160d63b558443c82555a3bfa703999', 'e5185ba3de1d4bba82986a7776c1b8f3', NULL, NULL, 1, '2019-05-09 23:18:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5f265912845c47dd84dcf3c0eac15bd3', '15310244f759414bbd2852f9ed783a9d', 27, 2, 1, '2019-08-13 23:58:29', '2019-08-13 23:10:28', '2019-08-13 23:10:28');
INSERT INTO `oauth2_access_token` VALUES ('5f3bb74ebd8e493eae9de88ea09578bf', 'b04ce488566d464bae757383f30241e3', NULL, NULL, 1, '2019-05-05 13:43:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5f3dcf50bfc84546b51dbdb6fff9d483', '11409021862c499098821e5682c6c3dc', 27, 2, 1, '2019-06-03 17:33:50', '2019-06-03 16:45:49', '2019-06-03 16:45:49');
INSERT INTO `oauth2_access_token` VALUES ('5f51b38bfbe0491a8896575860d02f38', 'c8806a97e1fd49ddb8584f787113a520', 27, 2, 1, '2019-08-16 15:16:14', '2019-08-16 14:28:13', '2019-08-16 14:28:13');
INSERT INTO `oauth2_access_token` VALUES ('5f5865dd3f4f4ad1bb75a7ab9ea66b9b', '70408c0aa9de4fc3be0c8ce00fb8a638', 27, 2, 1, '2019-06-01 15:28:21', '2019-06-01 14:40:21', '2019-06-01 14:40:21');
INSERT INTO `oauth2_access_token` VALUES ('5f7048d0a4334d5f9d1b8b30a3292c1c', '7daefb8c14204dfb8524a576ac395f6d', 27, 2, 1, '2019-06-01 12:52:01', '2019-06-01 12:04:00', '2019-06-01 12:04:00');
INSERT INTO `oauth2_access_token` VALUES ('5f7cdbdce0aa4021bdfbc6d52ae1dc51', '1a6c4a75478847d8b4e68cebeb5e3b8c', NULL, NULL, 1, '2019-04-24 22:06:24', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5f98faa7146847c39daf304389813c98', '14b9e572ee7a4d30b810029f4f89ce5e', NULL, NULL, 1, '2019-04-11 18:28:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('5fb894160e4f45cb9fd5fd0a157097a3', 'd42b9044b0f24332bf23b16283ad2a7a', 1, 2, 0, '2019-05-30 18:30:33', '2019-05-30 17:42:33', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('5fbd55b5d72c4632a57c2731a7deea03', '442eb5e01aab4bc8ab352b01c3540e93', 27, 2, 1, '2019-06-06 12:25:55', '2019-06-06 11:37:54', '2019-06-06 11:37:54');
INSERT INTO `oauth2_access_token` VALUES ('5fcfa73a656d4e7fad53f25a41954fcb', '2723d9dc20d34d2c8b7c46df3052c4ec', 27, 2, 1, '2019-08-24 10:54:59', '2019-08-24 10:06:58', '2019-08-24 10:06:58');
INSERT INTO `oauth2_access_token` VALUES ('5fdbcf0249ed43298b7e907b8b1ad0fd', '5e048d1131cc4c709b8a392eeabde58e', 27, 2, 1, '2019-06-18 12:41:44', '2019-06-18 11:53:43', '2019-06-18 11:53:43');
INSERT INTO `oauth2_access_token` VALUES ('5fe70d7894fc4b3498db4a3009756e62', '1f84b982454240a5aacfea5e270caa6f', 27, 2, 1, '2019-06-04 16:40:29', '2019-06-04 15:52:28', '2019-06-04 15:52:28');
INSERT INTO `oauth2_access_token` VALUES ('5ff31ae5ac6c4946a48883b2fa685c0a', '5d6feead40514f4a8b8fee12c78ce857', 27, 2, 1, '2019-06-25 11:09:57', '2019-06-25 10:21:56', '2019-06-25 10:21:56');
INSERT INTO `oauth2_access_token` VALUES ('5ff85acd85914851ad8f1c45ca474bb4', '1a5ee8c1890a4cb0afa4d567a15d3165', NULL, NULL, 1, '2019-05-13 13:24:07', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('600eaa693a52447fa04d794c150c4c86', 'f29a0260aacd47ff9c98b4e006f56e62', 27, 2, 1, '2019-09-04 17:39:25', '2019-09-04 16:51:25', '2019-09-04 16:51:25');
INSERT INTO `oauth2_access_token` VALUES ('6039ba41fd5640f5a73d8f5f14955acc', 'd8e04308fc2d4d10aabc1187f66fefcc', 27, 2, 1, '2019-06-09 15:22:05', '2019-06-09 14:34:05', '2019-06-09 14:34:05');
INSERT INTO `oauth2_access_token` VALUES ('605536e6c1274d918d0b9b9c56e23c4c', 'dd1cfefe1d7b41a495c8b91c0204483d', 27, 2, 1, '2019-06-25 21:11:01', '2019-06-25 20:23:01', '2019-06-25 20:23:01');
INSERT INTO `oauth2_access_token` VALUES ('605a2e0f8c204c85bae64f903dcec030', 'cdc398048fcf43cb9c7c21e5dc6b21cd', 27, 2, 1, '2019-06-21 14:06:47', '2019-06-21 13:18:47', '2019-06-21 13:18:47');
INSERT INTO `oauth2_access_token` VALUES ('6067d8915f6a4555ac683e3b96380e7d', '3baad1cd336c4ca895fe21edc8bcdbef', NULL, NULL, 1, '2019-04-25 09:28:46', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('60695ee674bd45d18a5f995232c71dd7', '0db2330a05a547e999729e46d53b7e0f', 27, 2, 1, '2019-05-20 18:41:37', '2019-05-20 17:53:37', '2019-05-20 17:53:37');
INSERT INTO `oauth2_access_token` VALUES ('607b243c3ebb49e2b1c3ded056c96dc9', 'dd1bfa3ee9474eff80ded9f94208d7ac', NULL, NULL, 1, '2019-04-27 22:53:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6092b1f9d4e844f48e1367c48a3c155a', 'efbf3844449f40b9ada64b8ef8e854c0', 27, 2, 1, '2019-07-13 21:05:04', '2019-07-13 20:17:04', '2019-07-13 20:17:04');
INSERT INTO `oauth2_access_token` VALUES ('609a96797af34865a6d8603c2a0195ef', '75e439a4280b4cc89aaf3773ac0a1b13', 27, 2, 1, '2019-08-15 18:09:54', '2019-08-15 17:21:53', '2019-08-15 17:21:53');
INSERT INTO `oauth2_access_token` VALUES ('60a5538e5dfc4fe5a0ae9cea168cb5dc', '82cfe8fcbda2458bac420f6425323ba2', 27, 2, 1, '2019-07-25 11:53:59', '2019-07-25 11:05:58', '2019-07-25 11:05:58');
INSERT INTO `oauth2_access_token` VALUES ('60af53630c744e2590d1f6d657fea5a6', '61cb5aa26b664154aacbbaefc2fa97f3', NULL, NULL, 1, '2019-04-22 19:08:32', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('60c262c3644e488aa0a3dc9ca991e32f', '0a1648bd2a0e4f09a5e7d6aa5e322b3c', 27, 2, 1, '2019-06-05 14:30:07', '2019-06-05 13:42:07', '2019-06-05 13:42:07');
INSERT INTO `oauth2_access_token` VALUES ('60c8782e7bf544af86205f60c907b54d', '7f502c29b25348cbbb987727edc5cb1e', 27, 2, 1, '2019-07-31 11:18:29', '2019-07-31 10:30:28', '2019-07-31 10:30:28');
INSERT INTO `oauth2_access_token` VALUES ('60cb3e40e9a549309b25e9db188161dd', '1acf8ae870f342f1a0c6e6abd1e21526', 27, 2, 1, '2019-06-01 15:09:26', '2019-06-01 14:21:26', '2019-06-01 14:21:26');
INSERT INTO `oauth2_access_token` VALUES ('60db17db675242b299d35db00b2cd6c2', '2493b2fc3fdc4f3f97d83dfcff90afbf', 27, 2, 1, '2019-06-10 15:13:49', '2019-06-10 14:25:49', '2019-06-10 14:25:49');
INSERT INTO `oauth2_access_token` VALUES ('60ecfb6294da4f3b8450ba89f95da778', '68636d21a2f34323aaa78d63297b6367', NULL, NULL, 1, '2019-04-30 20:55:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('60fb4ba524754a5989c2f2794f246986', '4396ea13db964d5c8af8b4cc67dec5a7', 27, 2, 1, '2019-07-25 18:06:26', '2019-07-25 17:18:25', '2019-07-25 17:18:25');
INSERT INTO `oauth2_access_token` VALUES ('610638ad724b4439a4eb761e7aba6017', '4eabf37e1e57416cb153b52a8c363d43', 27, 2, 1, '2019-06-03 16:15:07', '2019-06-03 15:27:07', '2019-06-03 15:27:07');
INSERT INTO `oauth2_access_token` VALUES ('611eac580f2247adb5825151c740d3ba', '372eaee13f984d33a2f184f81bc961c0', 90, 1, 1, '2019-05-29 19:19:59', '2019-05-29 18:31:59', '2019-05-29 18:31:59');
INSERT INTO `oauth2_access_token` VALUES ('61399f0551ad499a80c152621ac4e89b', 'f3336efaf3b2451db15d3c925454c0b0', 27, 2, 1, '2019-06-05 09:58:45', '2019-06-05 09:10:45', '2019-06-05 09:10:45');
INSERT INTO `oauth2_access_token` VALUES ('613a6ee69305406aa3199155da02ac46', '85d329a304584d1da47c2787ea009db7', 27, 2, 1, '2019-06-05 13:01:40', '2019-06-05 12:13:39', '2019-06-05 12:13:39');
INSERT INTO `oauth2_access_token` VALUES ('614eff1b02b14f6b99a3c3e37da3163f', '2986c8c9bf0343fba1d775285f768d4a', 27, 2, 1, '2019-06-23 17:22:44', '2019-06-23 16:34:44', '2019-06-23 16:34:44');
INSERT INTO `oauth2_access_token` VALUES ('615b684fa1574880b476120f11c98b6d', 'd3739b01fc2344fa9220b3a8cb1f8fd5', 27, 2, 1, '2019-08-14 09:55:09', '2019-08-14 09:07:08', '2019-08-14 09:07:08');
INSERT INTO `oauth2_access_token` VALUES ('6164a5c6b93c44d9b21018dab3ac33e2', '185f97923c1d46f399a4ced3f4360492', 27, 2, 1, '2019-06-03 19:01:07', '2019-06-03 18:13:06', '2019-06-03 18:13:06');
INSERT INTO `oauth2_access_token` VALUES ('6175fc3b1a3f44f48ef100a4a678c422', '79c5323d0b1d451987cc17652abddc27', 27, 2, 1, '2019-05-23 18:32:26', '2019-05-23 17:44:26', '2019-05-23 17:44:26');
INSERT INTO `oauth2_access_token` VALUES ('6177308f69174b6e9ea436c042472e27', 'b0f520088c374276b15b58e22daeac6f', 27, 2, 1, '2019-09-04 09:03:41', '2019-09-04 08:15:40', '2019-09-04 08:15:40');
INSERT INTO `oauth2_access_token` VALUES ('617b5a1280e745ff94486e2fa3a7ccb4', '72db397ba90f4abfb554ca2088863da4', 1, 2, 0, '2019-06-03 13:17:04', '2019-06-03 12:29:03', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('617e7b945db4459a841b0d67e32e45c4', 'c4b80eb2b09c4ae18ff934ca36f2b64c', 128, 1, 1, '2019-06-19 15:23:26', '2019-06-19 14:35:26', '2019-06-19 14:35:26');
INSERT INTO `oauth2_access_token` VALUES ('6188d40521984223b3772ddb2f2da54a', '548dcdc050bb4a6a96a4409f78216cac', 27, 2, 1, '2019-06-01 00:57:42', '2019-06-01 00:09:42', '2019-06-01 00:09:42');
INSERT INTO `oauth2_access_token` VALUES ('6192edad1b764e19b22b5906b42ac5ee', 'c760338e197a4b08ba5762772fc9e251', 27, 2, 1, '2019-06-22 02:40:28', '2019-06-22 01:52:27', '2019-06-22 01:52:27');
INSERT INTO `oauth2_access_token` VALUES ('61a66e8c8cef4d1d842ad9705514f239', 'f13c026fa5f1474c92634c761893384f', 27, 2, 1, '2019-08-29 14:43:09', '2019-08-29 13:55:09', '2019-08-29 13:55:09');
INSERT INTO `oauth2_access_token` VALUES ('61aa473e43ca4708841932c15f5c02ab', '1c94897b271a441586dbb7a6d31e1d52', NULL, NULL, 1, '2019-04-03 19:06:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('61aeb4a7d2e541b2bb0924eb79a7ccfe', '68d3c68b33bb4ac5836148da76cffaaf', 27, 2, 1, '2019-07-17 15:13:01', '2019-07-17 14:25:00', '2019-07-17 14:25:00');
INSERT INTO `oauth2_access_token` VALUES ('61bdd641dfb3495d9d2921366179808c', '35f4550517c845508c88fa1b6b7cc631', 27, 2, 1, '2019-07-22 18:21:18', '2019-07-22 17:33:18', '2019-07-22 17:33:18');
INSERT INTO `oauth2_access_token` VALUES ('61cd473135be41e3aacb63dc5da841d4', '6286db65ad6847ab9b728e1c3c466f29', 27, 2, 1, '2019-06-03 16:42:53', '2019-06-03 15:54:53', '2019-06-03 15:54:53');
INSERT INTO `oauth2_access_token` VALUES ('61d695fac2fa4dfa907edbd54c3db587', 'd22e4554183049ba955427c9e656ffc8', 27, 2, 1, '2019-09-07 15:49:46', '2019-09-07 15:01:45', '2019-09-07 15:01:45');
INSERT INTO `oauth2_access_token` VALUES ('61dfb9474eeb42829aa0037ab2dc9c63', 'd0b86a38f67d426b846713cfd3c3f4f8', 27, 2, 1, '2019-05-24 17:51:59', '2019-05-24 17:03:59', '2019-05-24 17:03:59');
INSERT INTO `oauth2_access_token` VALUES ('61f28fb5725940979ab36fc65ea89655', 'f899a01c28314988860fe1fd32f8540d', 27, 2, 1, '2019-08-20 18:14:39', '2019-08-20 17:26:38', '2019-08-20 17:26:38');
INSERT INTO `oauth2_access_token` VALUES ('61f971de80dd4eb9bc91cb363caad437', '5ae9ba6d39d440eb854f373057d69140', 27, 2, 1, '2019-07-03 10:31:11', '2019-07-03 09:43:11', '2019-07-03 09:43:11');
INSERT INTO `oauth2_access_token` VALUES ('61fd14f93b6543449cb6e05a37319f1f', '184351f002ec4ffeb2ed64c7d1caa7aa', 1, 2, 0, '2019-05-20 16:49:26', '2019-05-20 16:01:25', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('620b45a584f448f38c9961504358ad9f', 'f98a294cc6a24191a13703ff3e806b9d', NULL, NULL, 1, '2019-05-04 18:11:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('621e88cec22d4b04b70b1d09f6c1dac3', '2cedbee3d2114a64b49f8b572ab60f47', 27, 2, 1, '2019-05-31 11:19:13', '2019-05-31 10:31:13', '2019-05-31 10:31:13');
INSERT INTO `oauth2_access_token` VALUES ('621f26b1147842c98eab62eebfb30515', '1c81496ff20b42d29da30d668eef1233', NULL, NULL, 1, '2019-05-10 23:01:47', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('622f28d0b77c41628a45bb62d4f857da', 'f4bcde9dd464439db7d05a0a16281d39', 27, 2, 1, '2019-06-24 15:51:00', '2019-06-24 15:02:59', '2019-06-24 15:02:59');
INSERT INTO `oauth2_access_token` VALUES ('62369818f49d4b4181010f1d135b79d0', '3744ca666b9b4046a4f38e94a83eb65d', 27, 2, 1, '2019-08-12 11:28:24', '2019-08-12 10:40:23', '2019-08-12 10:40:23');
INSERT INTO `oauth2_access_token` VALUES ('626242864ea64230a1ea43697bb099b9', 'ef616f7ef4e9482e884059cffe61b5b1', 27, 2, 1, '2019-06-13 23:45:24', '2019-06-13 22:57:24', '2019-06-13 22:57:24');
INSERT INTO `oauth2_access_token` VALUES ('628c7929c6d94ac5bc14bad14a3db3a9', '3da6f97f1adb486eab8083822ccbf8d8', 27, 2, 1, '2019-07-11 16:17:00', '2019-07-11 15:28:59', '2019-07-11 15:28:59');
INSERT INTO `oauth2_access_token` VALUES ('628fe06f0d58470a9d164fea0adec25b', '2f9979e6bb6f4a74bec1e3df3cb6273c', 27, 2, 1, '2019-07-21 19:08:24', '2019-07-21 18:20:23', '2019-07-21 18:20:23');
INSERT INTO `oauth2_access_token` VALUES ('62a47b750d9a464eb68f853a1535f67a', '70bbdde547ac4b75b1a3a93b3754ab2e', NULL, NULL, 1, '2019-04-22 20:30:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('62a5813abad04fa49801bd244f4b4d35', 'c9c4fefa84124a308d1237ccd246ca47', 27, 2, 1, '2019-07-17 15:32:57', '2019-07-17 14:44:56', '2019-07-17 14:44:56');
INSERT INTO `oauth2_access_token` VALUES ('62abc522cb3f424aa412c187be79ebf4', '75176188dece437297a28fd7154904ba', 1, 2, 0, '2019-06-14 22:31:59', '2019-06-14 21:43:58', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('62b01425eb384106a7eddf339422be08', '812fea4b830b486fbd4f4085beaa2002', 27, 2, 1, '2019-08-17 18:18:31', '2019-08-17 17:30:30', '2019-08-17 17:30:30');
INSERT INTO `oauth2_access_token` VALUES ('62ba6f4492cc48d08f82147cdb31af01', '4d7f13248b654d2aa7e9a1b6ec521639', 1, 2, 1, '2019-09-09 09:32:47', '2019-09-09 08:44:46', '2019-09-09 08:44:46');
INSERT INTO `oauth2_access_token` VALUES ('62c180eaf57048f58dcfe5c759da9f1a', '501d09d791124ff2896e65eacd83eca3', 170, 1, 1, '2019-07-16 10:40:56', '2019-07-16 09:52:56', '2019-07-16 09:52:56');
INSERT INTO `oauth2_access_token` VALUES ('62d1f23410f6465c8d27432ca7451277', 'df9ff267a0d442a7b7bb676fa31f6cbf', 27, 2, 1, '2019-06-14 13:51:14', '2019-06-14 13:03:13', '2019-06-14 13:03:13');
INSERT INTO `oauth2_access_token` VALUES ('62e3605f34e5483d8290bd6b583e8183', '0e64dcaf80934a2face5235b43c2cd9c', 27, 2, 1, '2019-05-30 14:25:26', '2019-05-30 13:37:26', '2019-05-30 13:37:26');
INSERT INTO `oauth2_access_token` VALUES ('62ed4dc1200f44eaacd886ee871cf7c9', 'ba51b8c847c349b5bc189b93fc8738cd', 1, 2, 0, '2019-08-02 15:16:48', '2019-08-02 14:28:48', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('62f40e7c8ea945cb8f7a3627ff3fa8aa', 'd40039c135d4481a87dd76dc817bd706', 1, 2, 0, '2019-07-07 17:35:00', '2019-07-07 16:46:59', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('62f451f8503b40118295b8a1ed90000d', '29c828de9b1048f7971e6e695df7e992', 1, 2, 0, '2019-05-31 14:20:01', '2019-05-31 13:30:41', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('62f49c4c26ad4eb394aed67fca9f1e1b', '52d0241fa3d8405bade3fb67611a2081', 27, 2, 1, '2019-08-26 08:10:34', '2019-08-26 07:22:33', '2019-08-26 07:22:33');
INSERT INTO `oauth2_access_token` VALUES ('62f9f2ab7b084ee880209c93f0945574', 'dcc2b80166b14c7f927e685fd15e9935', 27, 2, 1, '2019-09-05 12:19:06', '2019-09-05 11:31:06', '2019-09-05 11:31:06');
INSERT INTO `oauth2_access_token` VALUES ('630ea61fdc8a4a31a455c8dc6f8015c8', 'fbd0d0bdf16945829fdb505934611883', 27, 2, 1, '2019-08-21 23:09:29', '2019-08-21 22:21:29', '2019-08-21 22:21:29');
INSERT INTO `oauth2_access_token` VALUES ('632375eecc0541998370390ec836913d', '97d0ee0026b442b99a4dcd34435cd593', 27, 2, 1, '2019-08-28 23:02:06', '2019-08-28 22:14:06', '2019-08-28 22:14:06');
INSERT INTO `oauth2_access_token` VALUES ('6344f61b08d44bc4b820bfcae791cc57', '8b7453cc0d99400f976db96d381c15ab', 27, 2, 1, '2019-07-12 15:11:08', '2019-07-12 14:23:08', '2019-07-12 14:23:08');
INSERT INTO `oauth2_access_token` VALUES ('636cfdcc2add4d6a9cadcf95a90abbd1', '4f8ede5fd55a49ceb563d2390d4fefc1', 27, 2, 1, '2019-08-14 11:30:49', '2019-08-14 10:42:48', '2019-08-14 10:42:48');
INSERT INTO `oauth2_access_token` VALUES ('637ac442b7bc449590f09498a6e9ccba', 'dcbb9dce4cb44ccbb4e5fcdf43455663', NULL, NULL, 1, '2019-04-25 17:41:54', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('63c3667b6e3749a090991f089fc24b6d', '21a5004f3297473d8127c3f0bc804b73', 27, 2, 1, '2019-07-15 17:56:55', '2019-07-15 17:08:54', '2019-07-15 17:08:54');
INSERT INTO `oauth2_access_token` VALUES ('63e9459e89bc4ae09a902eda5ae3fddb', '04ec2cd62cb0400f98fe19fd825bf275', 1, 2, 0, '2019-09-04 23:41:25', '2019-09-04 22:53:24', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('640939d492b34084801320b2b2144d53', 'fdddcd2d0b684f4f81ec3b63d43f76a7', 27, 2, 1, '2019-08-27 15:16:33', '2019-08-27 14:28:33', '2019-08-27 14:28:33');
INSERT INTO `oauth2_access_token` VALUES ('644e85d936ba437aadbebbb722294041', '299a8a742401442fb7986ae865c7513a', NULL, NULL, 1, '2019-05-08 16:42:48', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('645513259b7c46d78132ee3dfa49fc35', 'cc099c4678654cfea543e16cad524679', 27, 2, 1, '2019-07-22 17:32:43', '2019-07-22 16:44:43', '2019-07-22 16:44:43');
INSERT INTO `oauth2_access_token` VALUES ('645beaf6dccf4f51930720998bd5e304', '3db211b880e942b0851a38b4ca67c7e3', 134, 1, 1, '2019-06-23 19:49:58', '2019-06-23 19:01:57', '2019-06-23 19:01:57');
INSERT INTO `oauth2_access_token` VALUES ('6466b9a13494420690ad1a508eb916fc', '71802b920b6f45ecae659a93111cb3d3', 150, 1, 1, '2019-07-02 12:02:08', '2019-07-02 11:14:08', '2019-07-02 11:14:08');
INSERT INTO `oauth2_access_token` VALUES ('646e89396599447994a635707328acf9', '56811581512c4967a64fc90eafa44f8f', NULL, NULL, 1, '2019-05-03 18:36:37', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('649ad32716a14697844282663c33274b', 'e18173bd6d9c4f6ba12da47fab688d01', 213, 1, 1, '2019-08-27 15:55:39', '2019-08-27 15:07:39', '2019-08-27 15:07:39');
INSERT INTO `oauth2_access_token` VALUES ('64a47ddfebae4264a5c499603084a94a', '38f94085e4f14cd1af01deae83893a01', 27, 2, 1, '2019-07-29 12:14:39', '2019-07-29 11:26:39', '2019-07-29 11:26:39');
INSERT INTO `oauth2_access_token` VALUES ('64ab4761325740c986aa0a6ced23523f', 'bdc905c7cd6041b28b8066d641d0c2ba', 27, 2, 1, '2019-09-03 09:31:29', '2019-09-03 08:43:29', '2019-09-03 08:43:29');
INSERT INTO `oauth2_access_token` VALUES ('64af4ebf6e6e4819bd37d020fcaeba88', 'f0e8c46cf9da4edc990fb9541e7b587b', 1, 1, 1, '2019-05-17 01:12:18', '2019-05-17 00:24:17', '2019-05-17 00:24:17');
INSERT INTO `oauth2_access_token` VALUES ('64b060aec59f4185aaf5ce776145f31b', '043c99d4288847ff97bae86dc18c1f07', 27, 2, 1, '2019-08-13 01:28:02', '2019-08-13 00:40:01', '2019-08-13 00:40:01');
INSERT INTO `oauth2_access_token` VALUES ('64b48249633441969e32dc56cd5b5c0b', 'e7066152e2a54dd59b0183de7a5729bc', 27, 2, 1, '2019-08-18 14:49:21', '2019-08-18 14:01:21', '2019-08-18 14:01:21');
INSERT INTO `oauth2_access_token` VALUES ('64b7e077605e4433b36d5a84c82874d1', '451016d4a9354096b0bd737d394a9420', 27, 2, 1, '2019-08-14 15:44:20', '2019-08-14 14:56:19', '2019-08-14 14:56:19');
INSERT INTO `oauth2_access_token` VALUES ('64bb4ebbf9294d598746a8bd5ea0fb4b', '29194f56c34d4d41a042e1cbebf5cbb1', 27, 2, 1, '2019-07-18 17:18:30', '2019-07-18 16:30:30', '2019-07-18 16:30:30');
INSERT INTO `oauth2_access_token` VALUES ('64c71bdfdfa6480dbb23f18bc40f0e38', 'ed9b4349fa6c4388abed1c6da3dd0878', 27, 2, 1, '2019-05-30 16:59:01', '2019-05-30 16:11:00', '2019-05-30 16:11:00');
INSERT INTO `oauth2_access_token` VALUES ('64cf63f03e6b42178002fa20a283e27a', 'fe7e04b0c2ca4eadab19784eda28b25c', 27, 2, 1, '2019-07-02 13:25:25', '2019-07-02 12:37:24', '2019-07-02 12:37:24');
INSERT INTO `oauth2_access_token` VALUES ('64d8e8c8ebeb44f784de5c0a561f4aa0', '765e4cb7e7d44e359029e44acdf8aa6f', 1, 2, 0, '2019-06-05 12:55:37', '2019-06-05 12:07:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('64db72f07ce3437bbcdd2d51ad13c951', '5dde5c9d011e40b9874c00b14e853cb8', 27, 2, 1, '2019-07-27 01:37:01', '2019-07-27 00:49:00', '2019-07-27 00:49:00');
INSERT INTO `oauth2_access_token` VALUES ('64dd99c87eb242b692864c650f2112f5', '59fc671a9f944a4aa4e78f04a2808ec4', 27, 2, 1, '2019-06-19 20:32:48', '2019-06-19 19:44:47', '2019-06-19 19:44:47');
INSERT INTO `oauth2_access_token` VALUES ('64e2b212ef1745618990752e948c4a62', '9b0958f2727e44668497849610415d1d', 27, 2, 1, '2019-05-24 17:45:59', '2019-05-24 16:57:59', '2019-05-24 16:57:59');
INSERT INTO `oauth2_access_token` VALUES ('64fac2d2f6c54391b4b123dd6e0f91bf', '732b16b3e54f446a85791a2fcb4313ff', NULL, NULL, 1, '2019-03-21 16:27:40', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('651a923a9e6e4d279194743c90ba0508', 'd3ca3d96811a43efbc7b08917ce5fa7f', 27, 2, 1, '2019-07-24 15:39:45', '2019-07-24 14:51:45', '2019-07-24 14:51:45');
INSERT INTO `oauth2_access_token` VALUES ('65225af72c5b49ceb7face0bfdd75928', '757c9a1996fe4abab73b600296e52ed2', 27, 2, 1, '2019-07-07 13:33:16', '2019-07-07 12:45:16', '2019-07-07 12:45:16');
INSERT INTO `oauth2_access_token` VALUES ('65302cde2dc3413da8438a5f94cd90ba', '3389fb2d917b46aa9291fb417ce1576d', 1, 2, 0, '2019-08-20 15:53:41', '2019-08-20 15:05:41', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('6538f43da77a4dce865147d195b79eda', '4903463bdd45434ab7fa02c23befe936', 27, 2, 1, '2019-06-20 16:21:22', '2019-06-20 15:33:21', '2019-06-20 15:33:21');
INSERT INTO `oauth2_access_token` VALUES ('6555fa364fdc456a93e6a904a92c8e7d', '79243fdb2d4045b39eb0200abb00adff', 1, 2, 1, '2019-09-07 23:35:22', '2019-09-07 22:47:22', '2019-09-07 22:47:22');
INSERT INTO `oauth2_access_token` VALUES ('6597ffc1aec844008cf3e441734d4467', 'b272dd3ce156490aac5838687e9894ae', 27, 2, 1, '2019-06-04 21:15:25', '2019-06-04 20:27:25', '2019-06-04 20:27:25');
INSERT INTO `oauth2_access_token` VALUES ('65982501949f4105b319bde6bb092a1d', 'bca5072d355349c980d27c4caf7dee18', 27, 2, 1, '2019-06-25 17:11:14', '2019-06-25 16:23:13', '2019-06-25 16:23:13');
INSERT INTO `oauth2_access_token` VALUES ('65c3d4eafae74797a398608a3a39df40', 'fb741736b0de43ebb1df665e4baa91ee', 27, 2, 1, '2019-07-17 17:30:12', '2019-07-17 16:42:11', '2019-07-17 16:42:11');
INSERT INTO `oauth2_access_token` VALUES ('65e0f87d028143738f50ecdfa8375f8b', '42927719d2c04ac28bb136aa36b87809', 27, 2, 1, '2019-07-24 11:13:39', '2019-07-24 10:25:38', '2019-07-24 10:25:38');
INSERT INTO `oauth2_access_token` VALUES ('65f5b2ccc3d54938b70d3265714c833f', 'bf20068d982940a190202d1ad27486d1', 27, 2, 1, '2019-07-13 10:12:52', '2019-07-13 09:24:52', '2019-07-13 09:24:52');
INSERT INTO `oauth2_access_token` VALUES ('65fbc139b3c54a82a079bc039f2e40c3', '007f60a32a514fffba89d5063bac494e', 169, 1, 1, '2019-07-11 13:20:56', '2019-07-11 12:32:55', '2019-07-11 12:32:55');
INSERT INTO `oauth2_access_token` VALUES ('6605fbb869e6416d9bd1cc79a98edf9f', 'ab90aceab1274bb087d6d54dcfed3879', 27, 2, 1, '2019-08-31 15:31:21', '2019-08-31 14:43:20', '2019-08-31 14:43:20');
INSERT INTO `oauth2_access_token` VALUES ('6608d90a2ee442a893e2be2954c091f8', '41ac10fae8ef48cda38412eafd668d1a', 27, 2, 1, '2019-08-22 11:50:36', '2019-08-22 11:02:35', '2019-08-22 11:02:35');
INSERT INTO `oauth2_access_token` VALUES ('661452ead32c4e3eaa3707b7feb61e9b', '33f586f5faac4b3f97bc462699059aac', 27, 2, 1, '2019-05-31 16:56:52', '2019-05-31 16:08:52', '2019-05-31 16:08:52');
INSERT INTO `oauth2_access_token` VALUES ('667d9b9ab7c94abdaaf3a58b01f1645d', '688621fb3e184103a3fb3914213627e9', 27, 2, 1, '2019-05-31 12:14:23', '2019-05-31 11:26:23', '2019-05-31 11:26:23');
INSERT INTO `oauth2_access_token` VALUES ('669253aa61b04f32ace5f168375e2831', '5712034a27724ae79455e66d7394bccf', 27, 2, 1, '2019-08-06 09:27:59', '2019-08-06 08:39:58', '2019-08-06 08:39:58');
INSERT INTO `oauth2_access_token` VALUES ('66a709ff1e194d2dac49afeec211164e', '54cf4b710cb74951bce5e2c5bd8978b1', 81, 1, 1, '2019-05-24 12:19:45', '2019-05-24 11:31:45', '2019-05-24 11:31:45');
INSERT INTO `oauth2_access_token` VALUES ('66e6cb90ebad421e93931ac68155e877', '93d76971e02c426ca2cb3cbf70e0da3c', 27, 2, 1, '2019-06-18 10:17:42', '2019-06-18 09:29:41', '2019-06-18 09:29:41');
INSERT INTO `oauth2_access_token` VALUES ('66ec59c1902848848e7489a03b96cf3f', '95172191136e44c9a0d1c696fc4fee82', 27, 2, 1, '2019-06-06 14:33:48', '2019-06-06 13:45:48', '2019-06-06 13:45:48');
INSERT INTO `oauth2_access_token` VALUES ('66f03640eba24e688149706ef3641cb5', 'c66502fca7ac48569aff62dbc77aa5f3', 27, 2, 1, '2019-07-04 21:02:09', '2019-07-04 20:14:08', '2019-07-04 20:14:08');
INSERT INTO `oauth2_access_token` VALUES ('671181d9fcbc4833814926dab32c1686', '03445adbaef24672b60a59afc1390bc9', 27, 2, 1, '2019-06-18 11:36:43', '2019-06-18 10:48:42', '2019-06-18 10:48:42');
INSERT INTO `oauth2_access_token` VALUES ('671ee42bc2f246e39102f1ff33446431', '92335ba8680449d78b50ef4c40ec6441', NULL, NULL, 1, '2019-04-26 15:59:43', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('672c28206dfb44b6aceb4f9bb8307235', 'ec57b7120f4646e898729340ae653f6f', 27, 2, 1, '2019-06-07 16:41:08', '2019-06-07 15:53:08', '2019-06-07 15:53:08');
INSERT INTO `oauth2_access_token` VALUES ('673452fe9a304a7caf028eae38115d14', 'bade320c289140ae9ea283f516d2d121', 27, 2, 1, '2019-08-23 10:23:48', '2019-08-23 09:35:48', '2019-08-23 09:35:48');
INSERT INTO `oauth2_access_token` VALUES ('6761fe7168a24133a21e47724e0d0e42', '3ef0330be8764d0d9ebe8b3fcb424560', 199, 1, 1, '2019-08-13 18:56:35', '2019-08-13 18:08:34', '2019-08-13 18:08:34');
INSERT INTO `oauth2_access_token` VALUES ('6764c79fef34441ca86c84f0e917ab4e', '661045d037df403ba666266664066d7a', 27, 2, 1, '2019-06-07 23:19:53', '2019-06-07 22:31:52', '2019-06-07 22:31:52');
INSERT INTO `oauth2_access_token` VALUES ('6781116e8f5f46f2bd715a91920806f1', 'df1ae02fae5e41c880d33dea9c0591f6', NULL, NULL, 1, '2019-04-27 11:38:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6784adb92c7c4d3298f03ebbebb40782', '3b1ed4a70590447ebe6cfb2c05067532', NULL, NULL, 1, '2019-04-01 23:21:57', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('678ee9831a044693b1ffa183a578a1e4', '2925d4f1555b4052a626d9311dbdf111', 27, 2, 1, '2019-07-01 22:16:35', '2019-07-01 21:28:34', '2019-07-01 21:28:34');
INSERT INTO `oauth2_access_token` VALUES ('67e1a847212845c2baf26404730de696', 'ff2fe1ce66af41aab17713c47125a22c', 27, 2, 1, '2019-07-10 17:58:00', '2019-07-10 17:10:00', '2019-07-10 17:10:00');
INSERT INTO `oauth2_access_token` VALUES ('67ee3e027af8454d82064fdc2f958b7c', 'aaf5238940ea4b75ac321634d173d3f8', 27, 2, 1, '2019-08-19 11:50:27', '2019-08-19 11:02:27', '2019-08-19 11:02:27');
INSERT INTO `oauth2_access_token` VALUES ('67f39040fb65405fa24e99a8ad4e0f12', '74edc646bce94e3ea6a9faa7df40ce51', 27, 2, 1, '2019-06-06 01:55:32', '2019-06-06 01:07:32', '2019-06-06 01:07:32');
INSERT INTO `oauth2_access_token` VALUES ('68378ba3028741d89ae0c330e20fe19c', '1e846bb6cc6e457090bf80157b144ccf', 27, 2, 1, '2019-08-15 16:37:33', '2019-08-15 15:49:32', '2019-08-15 15:49:32');
INSERT INTO `oauth2_access_token` VALUES ('6837aae9dc394d289cb4bd8a1137f91e', '58563a919d11416cab17218c960807c4', 27, 2, 1, '2019-07-18 09:52:15', '2019-07-18 09:04:14', '2019-07-18 09:04:14');
INSERT INTO `oauth2_access_token` VALUES ('684476c5ae3042c0823b5c3aa4ef0a86', '188b2962940f42e2a4c40783e237283f', 27, 2, 1, '2019-06-05 15:08:12', '2019-06-05 14:20:11', '2019-06-05 14:20:11');
INSERT INTO `oauth2_access_token` VALUES ('6853b95c6d8f45f2ba095e63cbdc2888', 'cb972184d20e4190aef3a2ca89567409', 1, 2, 0, '2019-05-31 12:40:27', '2019-05-31 11:51:07', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('68549fb120ed4ae280c7ca2312c307ed', '44e6e795da2446ecb7a3fddb59ee315f', 1, 2, 0, '2019-05-26 16:29:37', '2019-05-26 15:41:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('685bfea9c05c40e5a1f42ac7bc2d9ca2', 'd4ec0f34a7c243b3a283ce4f8a655e26', 27, 2, 1, '2019-05-31 19:05:27', '2019-05-31 18:17:26', '2019-05-31 18:17:26');
INSERT INTO `oauth2_access_token` VALUES ('68688f6e3ac44c828a9676246cbdc25b', '50953222cb2f403d9697904b68b6844d', 27, 2, 1, '2019-06-11 21:32:37', '2019-06-11 20:44:36', '2019-06-11 20:44:36');
INSERT INTO `oauth2_access_token` VALUES ('68702686057e4e9f9444d7096ac4b522', 'c93bb17104414cb69441a168f4ff19f1', 1, 2, 0, '2019-06-28 15:37:31', '2019-06-28 14:49:31', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('688a3b76e6cf44a4bb673c3a9b13de46', '9fe7fa2890934fcd9276d5ae2023ff42', 27, 2, 1, '2019-05-31 22:02:14', '2019-05-31 21:14:14', '2019-05-31 21:14:14');
INSERT INTO `oauth2_access_token` VALUES ('68a42ba25e674a4f85f2153f86435b2a', '377e00f7c9b040f7b847a92ecc5b3c79', 27, 2, 1, '2019-07-09 09:35:14', '2019-07-09 08:47:13', '2019-07-09 08:47:13');
INSERT INTO `oauth2_access_token` VALUES ('68f1d7d44c5847c598ff1ee2f3656d28', '9269e02da5544db6b50e7002efbade1e', 27, 2, 1, '2019-06-22 22:13:24', '2019-06-22 21:25:24', '2019-06-22 21:25:24');
INSERT INTO `oauth2_access_token` VALUES ('68f7d07d6adb4d169e2ffeb1852b8320', '53f46bdf0e654cc4a8e1bc3a4c5066e6', 27, 2, 1, '2019-05-18 12:43:48', '2019-05-18 11:55:48', '2019-05-18 11:55:48');
INSERT INTO `oauth2_access_token` VALUES ('68fc2ec005a049d88984836f99920521', '7527252856a14798a1db9e6b1da92a4b', 27, 2, 1, '2019-06-28 10:24:19', '2019-06-28 09:36:19', '2019-06-28 09:36:19');
INSERT INTO `oauth2_access_token` VALUES ('6929ca6551394daebf85939b04c06c53', '708f898746d849ccb60ac1aadedc36e3', 94, 1, 1, '2019-06-01 08:52:59', '2019-06-01 08:04:59', '2019-06-01 08:04:59');
INSERT INTO `oauth2_access_token` VALUES ('6947520cd947484fb72117c6b66eeb59', '9fd5e0f2086f406a98b48a5dc3ea34b1', NULL, NULL, 1, '2019-05-13 13:25:06', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('69488fd325bd4932885eb894125e6b54', 'a0bdbc5d990042cfaac3f40ed9459799', 27, 2, 1, '2019-07-04 12:46:29', '2019-07-04 11:58:29', '2019-07-04 11:58:29');
INSERT INTO `oauth2_access_token` VALUES ('694e2aeb069f4d9b85c76214934e97b3', '5180ffde75834996919e633b55eb11c2', 27, 2, 1, '2019-06-03 10:25:33', '2019-06-03 09:37:33', '2019-06-03 09:37:33');
INSERT INTO `oauth2_access_token` VALUES ('696966d6d56147748a19788d6c5c7726', 'a5fc9dca3e0548b89920633e16433f63', 27, 2, 1, '2019-08-16 17:56:21', '2019-08-16 17:08:21', '2019-08-16 17:08:21');
INSERT INTO `oauth2_access_token` VALUES ('6969d3f2af5b410998fab4d34d5cf1f8', '43002a68701e475dbb0e440fd51ea5e5', NULL, NULL, 1, '2019-04-05 15:09:13', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('696d0c529f124724a8e900e086cd1c1f', '3e38a0716d9f4357a8b067e395b1c653', NULL, NULL, 1, '2019-04-26 00:11:02', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6986a8387e4f4fcbb9b85b3dd05c8c7e', '32b25d44da4046cf832a0bc84c0c8293', 176, 1, 1, '2019-07-18 16:24:29', '2019-07-18 15:36:29', '2019-07-18 15:36:29');
INSERT INTO `oauth2_access_token` VALUES ('69907864f89544d495093e4d091fceef', 'bcb299c6b0fb4175a22d755f40c876f4', 27, 2, 1, '2019-06-17 16:31:15', '2019-06-17 15:43:15', '2019-06-17 15:43:15');
INSERT INTO `oauth2_access_token` VALUES ('69aae130752e4c1ab70ca8c3277a0821', '2f845649bbb74e0ab9da81d22573bca6', NULL, NULL, 1, '2019-03-12 19:07:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('69ae661a7d3d4a48ab630722627b570f', 'a1a53cf36b70449fa60379fd11889e97', 27, 2, 1, '2019-08-21 10:14:01', '2019-08-21 09:26:00', '2019-08-21 09:26:00');
INSERT INTO `oauth2_access_token` VALUES ('69bb3fa0293744baa8bc6d7f6f7918c3', 'c7f132ca32de410988b247f9522db951', 27, 2, 1, '2019-06-28 17:11:44', '2019-06-28 16:23:44', '2019-06-28 16:23:44');
INSERT INTO `oauth2_access_token` VALUES ('69ddf21f9cfc41648010882bc73de1f6', '112d76164d044313909b5cc83733ef7c', NULL, NULL, 1, '2019-05-05 18:36:44', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6a0e6a36cf4f485f9a29cd76f451d2b8', '47fc77824314443abb2a5cf8e4256b78', 27, 2, 1, '2019-06-05 01:54:43', '2019-06-05 01:06:42', '2019-06-05 01:06:42');
INSERT INTO `oauth2_access_token` VALUES ('6a0f7cb86d7e415b94f82ccbf06753a3', '88f1dd83ab114ca393b845520b89e11e', 27, 2, 1, '2019-07-22 22:08:03', '2019-07-22 21:20:02', '2019-07-22 21:20:02');
INSERT INTO `oauth2_access_token` VALUES ('6a16b0e4d67140869df429a9190b3346', '7de56f7aaa0045ff9e271ee9d5f9f9c3', 27, 2, 1, '2019-09-06 16:40:26', '2019-09-06 15:52:26', '2019-09-06 15:52:26');
INSERT INTO `oauth2_access_token` VALUES ('6a2284574c9047b8a61d442e8eaa3c7f', '7e2d8c0b51304b86a320df2cc30e24aa', 27, 2, 1, '2019-06-02 11:35:15', '2019-06-02 10:47:15', '2019-06-02 10:47:15');
INSERT INTO `oauth2_access_token` VALUES ('6a22f2ee983e403099576422a6a3f6ea', '3475473e4f3c4201a57e9012f2e07744', 27, 2, 1, '2019-08-29 11:43:01', '2019-08-29 10:55:01', '2019-08-29 10:55:01');
INSERT INTO `oauth2_access_token` VALUES ('6a23127b420f47de82ceb68fece8aebe', '734a23f3632d43499a69e5ad7545fc27', 27, 2, 1, '2019-07-31 12:04:20', '2019-07-31 11:16:19', '2019-07-31 11:16:19');
INSERT INTO `oauth2_access_token` VALUES ('6a2e18628ab74ec68a7f1c706931c5c1', '8ab0bfa80a8f46d7b0472f8eac33692c', NULL, NULL, 1, '2019-05-05 22:59:24', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6a3068023eeb4cfb9b4c20d2290047b0', '0470683e4b3543a09d842d538e5f2c78', NULL, NULL, 1, '2019-05-13 16:41:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6a6ed8c85bb14ac4a833bffcb3d2090d', 'a1bc1fc667424f09892463137d60e9e7', 27, 2, 1, '2019-06-24 20:54:49', '2019-06-24 20:06:48', '2019-06-24 20:06:48');
INSERT INTO `oauth2_access_token` VALUES ('6a752d0e09744354a78c3282977666df', '8be33c44765e4dd6acb64e77b3299eac', 27, 2, 1, '2019-08-03 16:46:26', '2019-08-03 15:58:25', '2019-08-03 15:58:25');
INSERT INTO `oauth2_access_token` VALUES ('6a7fa9cb72414d3da830fc2913282c73', '53a7619e43b748499579bb7ce44f236c', 1, 1, 0, '2019-05-17 14:33:39', '2019-05-17 13:45:39', '2019-05-17 15:18:15');
INSERT INTO `oauth2_access_token` VALUES ('6a98b658c33a4217a9d9c863cda36c2b', '33824b12fe974d2bb0086e44e59c220d', NULL, NULL, 1, '2019-05-07 17:16:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6a9d6a58c14d4bf5832cfabc420fb2ed', 'dbd147f7b8bd4ee89f9d5f60243e787b', 216, 1, 1, '2019-08-30 12:25:46', '2019-08-30 11:37:46', '2019-08-30 11:37:46');
INSERT INTO `oauth2_access_token` VALUES ('6aa7558a513547268bfe17e9c4789b33', 'dd43f285813a492fb1566e66164e4944', 27, 2, 1, '2019-08-29 16:51:57', '2019-08-29 16:03:56', '2019-08-29 16:03:56');
INSERT INTO `oauth2_access_token` VALUES ('6aba66913c764f668f3da9b1513995bd', 'e611df2f4cbd4045acdbaba33489e3af', 1, 2, 0, '2019-06-05 11:43:12', '2019-06-05 10:55:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('6ac054ff322043deb68f1fb4f757f016', 'b9f08e4a5bba4272a8d82c727261af47', 27, 2, 1, '2019-07-16 18:34:07', '2019-07-16 17:46:06', '2019-07-16 17:46:06');
INSERT INTO `oauth2_access_token` VALUES ('6ae29056925c4966a0331836b3cba381', 'b9a35dc5c5054a5bbed3f981c2c738b8', 1, 2, 0, '2019-07-08 18:16:45', '2019-07-08 17:28:45', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('6aec4efe39b843ac88b203a014c67c18', '64864977062e4f55866a9d5b8ca0a23c', 27, 2, 1, '2019-09-04 14:46:57', '2019-09-04 13:58:57', '2019-09-04 13:58:57');
INSERT INTO `oauth2_access_token` VALUES ('6af0c6e94ce743b1bd7e466be8df3c9d', '9d4a4d62d5f440b89a57d4bf46d3afb3', 27, 2, 1, '2019-05-20 20:49:31', '2019-05-20 20:01:30', '2019-05-20 20:01:30');
INSERT INTO `oauth2_access_token` VALUES ('6af83cb4a5f14f70bd512ae8e59f5a91', 'ab02999f1e194a4e986aa132a89992af', 27, 2, 1, '2019-08-28 02:02:01', '2019-08-28 01:14:01', '2019-08-28 01:14:01');
INSERT INTO `oauth2_access_token` VALUES ('6b082bc2b8924d629030307ff9815a62', 'b98845419bdf4ccf92670cb4ba39221b', 159, 1, 1, '2019-07-07 18:45:21', '2019-07-07 17:57:20', '2019-07-07 17:57:20');
INSERT INTO `oauth2_access_token` VALUES ('6b08cf90f0874a0d8f1987adba8c1ef9', '835504be0438479f8cca7a8afa667bc8', 27, 2, 1, '2019-05-28 15:50:24', '2019-05-28 15:01:06', '2019-05-28 15:01:06');
INSERT INTO `oauth2_access_token` VALUES ('6b1a567eb3a148119b62dba3866486cd', '9aa49276ddda49a5a12953ff0738b67e', 27, 2, 1, '2019-06-06 23:13:07', '2019-06-06 22:25:06', '2019-06-06 22:25:06');
INSERT INTO `oauth2_access_token` VALUES ('6b330337d1044a648b59bb73e7f1027e', '37e9b3645ddc4eea9ba1a46f5d0b3342', 27, 2, 1, '2019-07-03 21:48:31', '2019-07-03 21:00:31', '2019-07-03 21:00:31');
INSERT INTO `oauth2_access_token` VALUES ('6b5ce8cc62af40539cd97e03ba2ce594', '485d61f252554882a2a49463514ab498', 27, 2, 1, '2019-06-13 07:27:35', '2019-06-13 06:39:34', '2019-06-13 06:39:34');
INSERT INTO `oauth2_access_token` VALUES ('6b5f23c635b54d2a9f201fca5a0dc9f0', '45954cd5a70b41e5a1d9014bc89ee8d1', 27, 2, 1, '2019-05-28 17:21:05', '2019-05-28 16:33:05', '2019-05-28 16:33:05');
INSERT INTO `oauth2_access_token` VALUES ('6b683ce5cc074cceab767d7079978b44', '004a1caecf9a4c518f1ce252d258ae83', 27, 2, 1, '2019-06-02 07:02:12', '2019-06-02 06:14:11', '2019-06-02 06:14:11');
INSERT INTO `oauth2_access_token` VALUES ('6b6b388022aa4bbfaf968a8c6463bfc0', 'a3524bf455d443e2a1e030a1ac2c97e3', 27, 2, 1, '2019-06-12 11:21:23', '2019-06-12 10:33:22', '2019-06-12 10:33:22');
INSERT INTO `oauth2_access_token` VALUES ('6b710cf6880e4862a72e24ac5ecb7664', '4c13e445d73b4608a96167c19f20f5de', NULL, NULL, 1, '2019-05-02 22:14:01', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6b940e083ddb4cf0b1f69f1db055716f', 'f498e981a32b4ef8a1ddac617a6748a7', 27, 2, 1, '2019-07-19 11:17:26', '2019-07-19 10:29:26', '2019-07-19 10:29:26');
INSERT INTO `oauth2_access_token` VALUES ('6bb4334000f94813bd475ac1583f6a77', '6593199b13134905a0b5c823b4409967', 27, 2, 1, '2019-07-09 12:17:57', '2019-07-09 11:29:57', '2019-07-09 11:29:57');
INSERT INTO `oauth2_access_token` VALUES ('6bb4a14d53264463b8a3e9b61805de00', '596341708ac2482ba46b59f737c9cc96', 1, 2, 0, '2019-07-25 16:41:16', '2019-07-25 15:53:16', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('6bc135f9e6c04853b23ccabe2428441e', '4ea6809d15fc45efbee4038c730550cf', 27, 2, 1, '2019-07-29 11:23:15', '2019-07-29 10:35:14', '2019-07-29 10:35:14');
INSERT INTO `oauth2_access_token` VALUES ('6bc687166d3d4c25a6595a199ec8aa77', '0dd18ffda01648e9bbc035dcd5d92518', 27, 2, 1, '2019-09-04 19:56:20', '2019-09-04 19:08:19', '2019-09-04 19:08:19');
INSERT INTO `oauth2_access_token` VALUES ('6bd5275da15942babfdcabd7c9152e0f', '1f075650bb2a462f9793da434c1db0a2', NULL, NULL, 0, '2019-03-03 23:01:16', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6bd78a3bd95649408056fb196bee69bf', '6316a3dae97c4c8ca38d338b187e412a', 27, 2, 1, '2019-07-12 11:02:32', '2019-07-12 10:14:31', '2019-07-12 10:14:31');
INSERT INTO `oauth2_access_token` VALUES ('6bf2cd1516784f60b94eec9952a849ed', 'a3f25565c24549b1a9d6ef5efdf50e85', 27, 2, 1, '2019-06-01 11:26:04', '2019-06-01 10:38:03', '2019-06-01 10:38:03');
INSERT INTO `oauth2_access_token` VALUES ('6bf58cfa378f49ce8bddecf8e823c295', '0693377223834e6898e0521550835257', 27, 2, 1, '2019-08-30 13:53:52', '2019-08-30 13:05:51', '2019-08-30 13:05:51');
INSERT INTO `oauth2_access_token` VALUES ('6bfe6e4fd34b41fc8187728c41eae3cb', '5f3430342e5b40019e6b0d1d1682b203', 27, 2, 1, '2019-06-03 10:04:02', '2019-06-03 09:16:02', '2019-06-03 09:16:02');
INSERT INTO `oauth2_access_token` VALUES ('6c08dd2a0682442dab1fec4950a71d87', '756ea75bb301446fab72bc867c85f6a2', 27, 2, 1, '2019-06-28 16:10:32', '2019-06-28 15:22:32', '2019-06-28 15:22:32');
INSERT INTO `oauth2_access_token` VALUES ('6c21b7cf49534726874b17f285fc156e', '455e97286c8e4b45a086b8d2e26ea81a', 27, 2, 1, '2019-05-22 15:43:18', '2019-05-22 14:55:17', '2019-05-22 14:55:17');
INSERT INTO `oauth2_access_token` VALUES ('6c22d8be21b4487b8fdd26bf0ce9373f', '60a355493dac41ecb20fbc4a75812940', 1, 2, 0, '2019-08-21 18:50:03', '2019-08-21 18:02:02', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('6c27ca85f2084775abcfe8d81a414271', 'ca0ed997213043b19299725ebf066f52', 27, 2, 1, '2019-06-20 16:01:55', '2019-06-20 15:13:55', '2019-06-20 15:13:55');
INSERT INTO `oauth2_access_token` VALUES ('6c280eacf5de408d836e25bfd1d29836', '52473a362a6d43278a4cff0e77fce1c3', NULL, NULL, 1, '2019-03-15 22:34:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6c3cde0ba7224cd2af8418a60ee4bc21', '25086bffb4c04c0f91f7458edfa578e7', NULL, NULL, 1, '2019-05-05 09:29:32', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6c4db5a7bc554114acb3ccbb19fa44b4', 'c62b2358917e4c3a86b48975a347ca5b', 27, 2, 1, '2019-06-20 21:45:23', '2019-06-20 20:57:22', '2019-06-20 20:57:22');
INSERT INTO `oauth2_access_token` VALUES ('6c548145667c4e4c8c2c358abd3aef39', 'a75de6da06784fbbad363b21ebc43d79', 27, 2, 1, '2019-06-28 14:40:33', '2019-06-28 13:52:32', '2019-06-28 13:52:32');
INSERT INTO `oauth2_access_token` VALUES ('6c70f009298a4733ad86429960a8a539', 'ca03991ab30d4985ac8a1fc0b9186dd9', NULL, NULL, 1, '2019-04-02 00:21:40', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6c883fe533e94151b68ada7556ea1ba2', '339162eb43ff449088b11152b63b578a', 27, 2, 1, '2019-06-13 21:56:41', '2019-06-13 21:08:40', '2019-06-13 21:08:40');
INSERT INTO `oauth2_access_token` VALUES ('6c93a1c54f7148b689e37c704c3d8789', '7e3dbc5b296647d4a136885b857b07d8', 27, 2, 1, '2019-06-04 09:52:02', '2019-06-04 09:04:02', '2019-06-04 09:04:02');
INSERT INTO `oauth2_access_token` VALUES ('6c99cf9423884884bf64f6385c027bc7', '78c1298ff5784d0e87d3f17c3289fba2', 27, 2, 1, '2019-07-12 11:17:10', '2019-07-12 10:29:10', '2019-07-12 10:29:10');
INSERT INTO `oauth2_access_token` VALUES ('6cafe4e4a5fb4af8b8902aef4ffef9ab', '7a8153eb2bcc474f93cc95d88d634a41', 27, 2, 1, '2019-08-22 08:36:08', '2019-08-22 07:48:07', '2019-08-22 07:48:07');
INSERT INTO `oauth2_access_token` VALUES ('6cd51480fcdf4259af62ac9f4545742d', '9f07724af4fd4ef192b64f2f9677ce73', 27, 2, 1, '2019-06-02 15:26:24', '2019-06-02 14:38:23', '2019-06-02 14:38:23');
INSERT INTO `oauth2_access_token` VALUES ('6d02982caf7c433fa0a50ca572107557', '265c01df3a7748ca94e6b81953761638', 27, 2, 1, '2019-05-22 20:05:00', '2019-05-22 19:16:59', '2019-05-22 19:16:59');
INSERT INTO `oauth2_access_token` VALUES ('6d09a81848a24d3db7d2f927e42e5ab8', '7c636c73dde5409d9827d6b9d17cc8df', 27, 2, 1, '2019-06-14 01:17:05', '2019-06-14 00:29:04', '2019-06-14 00:29:04');
INSERT INTO `oauth2_access_token` VALUES ('6d0d7fb4f7b946eb98e11067ba5d002e', '85d2f9ba43c046e8b5903a2096ce2010', 27, 2, 1, '2019-06-22 12:57:27', '2019-06-22 12:09:26', '2019-06-22 12:09:26');
INSERT INTO `oauth2_access_token` VALUES ('6d0e971ce2904ea4808f97b805b20e5d', '5b079f32d7a74f7bb3b8504e4d479adf', 27, 2, 1, '2019-06-26 09:15:51', '2019-06-26 08:27:50', '2019-06-26 08:27:50');
INSERT INTO `oauth2_access_token` VALUES ('6d1b04608d67489f83e622af8655f8dd', '26b2fdcae0464385af9e29534ef83124', 27, 2, 1, '2019-05-21 12:19:25', '2019-05-21 11:31:24', '2019-05-21 11:31:24');
INSERT INTO `oauth2_access_token` VALUES ('6d1dd812d49745cabf5b95b1aef95e49', 'ccc3ef94f69b46a6b665cbbc26e83da3', 27, 2, 1, '2019-08-12 09:28:43', '2019-08-12 08:40:42', '2019-08-12 08:40:42');
INSERT INTO `oauth2_access_token` VALUES ('6d3280159b3942958eb0e84d69ffa739', '6ddfd83b5219489d915a9661a27e5a90', 27, 2, 1, '2019-06-14 15:03:06', '2019-06-14 14:15:05', '2019-06-14 14:15:05');
INSERT INTO `oauth2_access_token` VALUES ('6d457010946e47558231a1646635331c', '35925ee6d3724da68b6d7258902d208b', 27, 2, 1, '2019-07-03 18:16:22', '2019-07-03 17:28:22', '2019-07-03 17:28:22');
INSERT INTO `oauth2_access_token` VALUES ('6d4a82579d894051bd2c9ff0a599d913', 'b3a613cbfa1f4b1e8659c3d7cf76450f', 27, 2, 1, '2019-07-16 20:09:06', '2019-07-16 19:21:06', '2019-07-16 19:21:06');
INSERT INTO `oauth2_access_token` VALUES ('6d5361c8cfb34b9faea04fab05ea1028', '7bbc28c5802d4c7a8cc1c305fb06f867', 27, 2, 1, '2019-06-24 16:03:34', '2019-06-24 15:15:34', '2019-06-24 15:15:34');
INSERT INTO `oauth2_access_token` VALUES ('6d6117e7d4e0420ca450d420923038a5', '631c8d6c9b5b4d7eb931b476554be81e', 27, 2, 1, '2019-05-31 18:44:44', '2019-05-31 17:56:44', '2019-05-31 17:56:44');
INSERT INTO `oauth2_access_token` VALUES ('6d6bc50c37c9418bb02c7baaf113443b', 'c72317d0fd2c4d7686c4f3213daa16e1', 27, 2, 1, '2019-08-23 12:34:31', '2019-08-23 11:46:31', '2019-08-23 11:46:31');
INSERT INTO `oauth2_access_token` VALUES ('6d81be8c3d4245c28ad5d7c2388a0028', 'c3d67fa88ad54831bf44ad78cbf4cbf6', 27, 2, 1, '2019-07-29 12:16:18', '2019-07-29 11:28:18', '2019-07-29 11:28:18');
INSERT INTO `oauth2_access_token` VALUES ('6da5369fae8b4b6f85aa25c26ed22b86', '1cef57a8a2ed44d4b3b16e40f938e334', 27, 2, 1, '2019-08-21 10:38:19', '2019-08-21 09:50:18', '2019-08-21 09:50:18');
INSERT INTO `oauth2_access_token` VALUES ('6df03969d4d04de6b243e1864b65702e', '6cf72c531e9146dbb3cf2ef1ae764259', 27, 2, 1, '2019-07-08 16:04:57', '2019-07-08 15:16:56', '2019-07-08 15:16:56');
INSERT INTO `oauth2_access_token` VALUES ('6df929284049453dad8e62aa7039cb63', '32e105b490914c538cb4b3a397cc79f6', 27, 2, 1, '2019-06-05 16:28:14', '2019-06-05 15:40:14', '2019-06-05 15:40:14');
INSERT INTO `oauth2_access_token` VALUES ('6e129e969fd047c083adc71f567e451e', '9b46c3a5f2344917a149975880b19912', 27, 2, 1, '2019-06-26 21:40:21', '2019-06-26 20:52:21', '2019-06-26 20:52:21');
INSERT INTO `oauth2_access_token` VALUES ('6e48a515dc01420fba128714bc9ab7d7', 'a569c102f0a64e598fa307e570c45ccb', 85, 1, 1, '2019-05-28 09:57:18', '2019-05-28 09:09:17', '2019-05-28 09:09:17');
INSERT INTO `oauth2_access_token` VALUES ('6e5bce332e2346c39957bb86ecffd26d', 'e265348f53fc4b14b95e7cce66f1a467', 27, 2, 1, '2019-06-23 12:56:16', '2019-06-23 12:08:15', '2019-06-23 12:08:15');
INSERT INTO `oauth2_access_token` VALUES ('6e5be4a393904d1f893a7093ac2f9b66', 'c286e653133b4f9fa9787733b67ffe38', 27, 2, 1, '2019-06-10 14:33:37', '2019-06-10 13:45:36', '2019-06-10 13:45:36');
INSERT INTO `oauth2_access_token` VALUES ('6e660ebe47dd4432955c059c0d583bdc', '7fb7d4a6d53946da90a9bb34ae489e9d', 27, 2, 1, '2019-06-04 09:59:58', '2019-06-04 09:11:58', '2019-06-04 09:11:58');
INSERT INTO `oauth2_access_token` VALUES ('6e9592b4bd22440da9852e844334770d', '3dcdcf62f36947aaa93791d7102e5c19', 1, 2, 0, '2019-07-21 11:21:34', '2019-07-21 10:33:33', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('6e9c285ec3db4cf990141a27ec6e85df', '725ae73d5b2648a6a36e3fd32619ed29', NULL, NULL, 1, '2019-05-09 18:53:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6ec85472584241caa8da114d1e7df015', 'ba1cccd09d4147a582e73c1ab19a88c7', 132, 1, 1, '2019-06-21 15:31:21', '2019-06-21 14:43:20', '2019-06-21 14:43:20');
INSERT INTO `oauth2_access_token` VALUES ('6ee05c98ed294b05850a2abfa35ada59', '65e7d39578de4ae092720af683040e46', NULL, NULL, 1, '2019-03-12 01:18:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6eef80dff8ca4600a84ecf093510eb86', 'adcb147ab81b4a4b9fe5d2fdc6206145', NULL, NULL, 1, '2019-04-30 20:57:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6f0cc59163e1421db32524abacea017a', '53818cdcc07d4032a15266cb788a0b5e', 27, 2, 1, '2019-08-17 16:46:34', '2019-08-17 15:58:33', '2019-08-17 15:58:33');
INSERT INTO `oauth2_access_token` VALUES ('6f17bbbbe5954f8ea7465aed422cc567', 'be1b5095d899470f8eeca20d2b89addd', 27, 2, 1, '2019-07-12 16:26:01', '2019-07-12 15:38:01', '2019-07-12 15:38:01');
INSERT INTO `oauth2_access_token` VALUES ('6f341e08a1bb43abbeca63bb72c0fef0', 'c12e2a55fdfa479e8e51d367c96e4ca3', NULL, NULL, 1, '2019-03-10 11:42:27', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6f3b4b06cdce4cd0b38d8acfa624eb7a', 'ba732104c5d047f68ae05c048c2b1b0e', NULL, NULL, 1, '2019-05-08 23:48:54', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6f43f01522944f65981c9a665121033a', 'd11f3c2317404cec86467ab5dfdad900', 27, 2, 1, '2019-07-31 10:34:50', '2019-07-31 09:46:50', '2019-07-31 09:46:50');
INSERT INTO `oauth2_access_token` VALUES ('6f5d77e75d564eaca1136f45892a9bf4', '035362413ea64c8eac4535501bbb32ab', NULL, NULL, 1, '2019-05-12 17:05:13', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6f82f5845d7a4442a427a7149f1df17b', 'dad86c9ed67849108132dfbea7d39d7f', 27, 2, 1, '2019-06-15 14:27:59', '2019-06-15 13:39:59', '2019-06-15 13:39:59');
INSERT INTO `oauth2_access_token` VALUES ('6fa0e486c06c49dcaa9de4e4a13b1d63', '013c9967bbac4d04963b1ac5c99e2bda', NULL, NULL, 1, '2019-03-10 04:14:58', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('6fdda49b85c8415ab9627ef5311d3c56', '94506a1681744a74bf7557e83f5ec420', 27, 2, 1, '2019-07-12 15:16:48', '2019-07-12 14:28:48', '2019-07-12 14:28:48');
INSERT INTO `oauth2_access_token` VALUES ('6ff3b8b29dfe42d89e3bfb29993e8041', 'b4fb6c06225544459ade3200befa30fb', 27, 2, 1, '2019-06-04 17:52:29', '2019-06-04 17:04:28', '2019-06-04 17:04:28');
INSERT INTO `oauth2_access_token` VALUES ('7000a60319c04ff5903d176027da8a16', '8929a0ff96ba4d1c8229cb7d67c16498', 27, 2, 1, '2019-06-03 16:47:54', '2019-06-03 15:59:53', '2019-06-03 15:59:53');
INSERT INTO `oauth2_access_token` VALUES ('700b96b1920d41dbbc8c7a1e2c93885e', '71f463e5ed244445a96d5349c63600a5', 27, 2, 1, '2019-06-04 11:32:14', '2019-06-04 10:44:14', '2019-06-04 10:44:14');
INSERT INTO `oauth2_access_token` VALUES ('701c7075be784db2b5d62180db711373', '19d5f23dc91a4c5baf9f319d29b8e958', NULL, NULL, 1, '2019-04-29 14:53:42', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('702258691455478198ba7981a5f4c3fe', 'e390d3f818a54fb8adc31ea6be58c9bc', 27, 2, 1, '2019-07-12 12:37:48', '2019-07-12 11:49:47', '2019-07-12 11:49:47');
INSERT INTO `oauth2_access_token` VALUES ('702470ffec1b48508ee72d357bfb14f0', '2271639ad22646c8a5c846e95dfc67c9', NULL, NULL, 1, '2019-04-24 16:23:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7029bb0afbc749d98292355c38d20345', '011401e6d4d94577abe06804e2504136', 27, 2, 1, '2019-07-12 15:30:12', '2019-07-12 14:42:11', '2019-07-12 14:42:11');
INSERT INTO `oauth2_access_token` VALUES ('7054c0c472dc40549d0e0668aefea96f', '9c67a3d54ab048609bb37840d108d7d8', NULL, NULL, 1, '2019-05-06 18:21:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('705c9a6556394fd7b33fd9dfe3857298', 'f1f22492b2144f55af89c386e3c2f69f', 27, 2, 1, '2019-06-05 10:02:32', '2019-06-05 09:14:31', '2019-06-05 09:14:31');
INSERT INTO `oauth2_access_token` VALUES ('706dcf90e82c4675a9f9de4852392d5e', '5ef6bceda2f74e2d96929f5080b6ce8a', 27, 2, 1, '2019-06-25 10:35:55', '2019-06-25 09:47:54', '2019-06-25 09:47:54');
INSERT INTO `oauth2_access_token` VALUES ('706e46c21e574dbeb548a6f49b9508c3', '87f5ab24fa154d0985325172a8f9c5a7', 1, 2, 0, '2019-06-25 12:45:28', '2019-06-25 11:57:27', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('707b8110f29d411ca483b1c480ddf734', '5b2a998b10a54392ac6c885f16416415', 27, 2, 1, '2019-05-29 10:13:03', '2019-05-29 09:25:03', '2019-05-29 09:25:03');
INSERT INTO `oauth2_access_token` VALUES ('709c5f61a33448afa24fcc73cb3895d0', '43165930bcd34ff7adb67638ee305238', 27, 2, 1, '2019-06-03 21:09:09', '2019-06-03 20:21:08', '2019-06-03 20:21:08');
INSERT INTO `oauth2_access_token` VALUES ('70ac300db9184c678b4258fc10c3d072', '2360735ad9644ac7b860490a123a51af', 27, 2, 1, '2019-07-27 23:00:57', '2019-07-27 22:12:57', '2019-07-27 22:12:57');
INSERT INTO `oauth2_access_token` VALUES ('70bd43be54964112bdb240e13d46553b', '7a006ad4827d4f6ab367653ff5e48631', 27, 2, 1, '2019-07-30 11:43:38', '2019-07-30 10:55:37', '2019-07-30 10:55:37');
INSERT INTO `oauth2_access_token` VALUES ('70bdfbfa514746a98fd64ca0bdd3e40b', '8a3fd03d726241a28576ed0f2fd78ae0', 1, 2, 0, '2019-07-22 18:38:09', '2019-07-22 17:50:08', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('70c5bbf32e3947c9b27748371745d0e3', '58918ed57089428d845b93bcb5167ed8', 27, 2, 1, '2019-06-02 11:21:09', '2019-06-02 10:33:08', '2019-06-02 10:33:08');
INSERT INTO `oauth2_access_token` VALUES ('710f5f101b9e40be92f27adde8416eef', '4cac4b87d3ca49e59d3df0652bd8846b', NULL, NULL, 1, '2019-03-22 16:46:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7110481d70b14792b734e70b19ad1336', 'e84a0af5a621492896e80f2dd2e6151b', 27, 2, 1, '2019-07-29 19:06:25', '2019-07-29 18:18:24', '2019-07-29 18:18:24');
INSERT INTO `oauth2_access_token` VALUES ('71133d44cd9a4f37b3fa97644da92c9e', '7d53c9fe96494388945a7eadf978aee4', 27, 2, 1, '2019-06-06 23:15:19', '2019-06-06 22:27:18', '2019-06-06 22:27:18');
INSERT INTO `oauth2_access_token` VALUES ('71157465ba6242058c30379441717e65', 'e750bad0c5c34e6eaf2522cfe167daf8', 27, 2, 1, '2019-05-23 14:25:45', '2019-05-23 13:37:44', '2019-05-23 13:37:44');
INSERT INTO `oauth2_access_token` VALUES ('711d8ec45f8148ac886b69f264e31cc6', '4584a54c66e8480ea9d2c3ca289140f6', 27, 2, 1, '2019-08-17 17:49:15', '2019-08-17 17:01:15', '2019-08-17 17:01:15');
INSERT INTO `oauth2_access_token` VALUES ('7120d6ec687842b8a50e90297259b7b6', '591da5d89f28493ebf906a2165673477', NULL, NULL, 1, '2019-03-10 03:19:29', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('71425c04e37242d9b08175836301cd58', '4404917a21034b8f8d9ed92be6ce8400', 27, 2, 1, '2019-06-27 15:44:55', '2019-06-27 14:56:55', '2019-06-27 14:56:55');
INSERT INTO `oauth2_access_token` VALUES ('71601b4c450b42bda14a6570f6f21395', '3e588ec0e94c4884936cc384d3bd23eb', 27, 2, 1, '2019-06-05 14:29:39', '2019-06-05 13:41:39', '2019-06-05 13:41:39');
INSERT INTO `oauth2_access_token` VALUES ('716b95bb182b4a87b13f9fdb7f0874cb', 'ff3bfbb7a97840319d728ae3a03a4d2c', 1, 2, 0, '2019-05-26 23:52:26', '2019-05-26 23:04:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('71719494309d4f3b8a4f8020c00db852', '5cd8292c47f5416e97535c032a9db18c', NULL, NULL, 1, '2019-03-19 04:57:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7195b9cf67e843cb807e19e6dbc925b0', 'dbadd058adbd458ca9b56750dd3dcabf', NULL, NULL, 1, '2019-04-24 11:31:23', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7199da36b8dc4fa994088633d9e39a45', '485f3a5438b14be4a3d9baa79a2861ea', NULL, NULL, 1, '2019-04-22 20:32:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('71aa46a76dd444908ba6319b6c5a67d2', 'd0a77ac12de84e0ca7da5fa6921bd3d7', NULL, NULL, 1, '2019-03-15 19:55:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('71df34df9b9643e09f94ae1ba6d1cacf', '4d54a9dd999e4ec294d521ce17decef7', NULL, NULL, 0, '2019-03-05 06:32:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('71e6970145c24fe1ac8b5c1acacdde6d', '0479b951e4f040b29b4fabc7c0691c6d', 27, 2, 1, '2019-07-06 14:50:44', '2019-07-06 14:02:44', '2019-07-06 14:02:44');
INSERT INTO `oauth2_access_token` VALUES ('71e69e69d8db412580e166d97724dc84', 'a70bebd1095d4c6185abedcff05bfe42', 27, 2, 1, '2019-06-14 15:42:44', '2019-06-14 14:54:44', '2019-06-14 14:54:44');
INSERT INTO `oauth2_access_token` VALUES ('721549a3bf9c497a9bbd3281e056a9a4', 'e027ad2c7a0c4dd09419cea24d2b1d60', 1, 2, 0, '2019-06-20 09:56:13', '2019-06-20 09:08:12', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('721cd32db9bc4578a84d311e9e5f2e19', '897ba1b4656149cf8c4942193a86ac52', 27, 2, 1, '2019-05-21 21:54:29', '2019-05-21 21:06:28', '2019-05-21 21:06:28');
INSERT INTO `oauth2_access_token` VALUES ('7220cb603ca24428bfed75e371d2935c', 'd8ea7d689ba24217aba90d88b76f3abb', 27, 2, 1, '2019-06-17 16:19:23', '2019-06-17 15:31:23', '2019-06-17 15:31:23');
INSERT INTO `oauth2_access_token` VALUES ('7238fea4c5da4062b093ddb650389c0a', '8ec51f4bedef47499c5238d915472c4f', 27, 2, 1, '2019-08-11 21:07:48', '2019-08-11 20:19:47', '2019-08-11 20:19:47');
INSERT INTO `oauth2_access_token` VALUES ('7239091fe14b412b87af1cfedcf855ae', 'ee69d2ac17194d688c322e6a26d96552', 27, 2, 1, '2019-08-30 14:45:42', '2019-08-30 13:57:42', '2019-08-30 13:57:42');
INSERT INTO `oauth2_access_token` VALUES ('7247bb948b22457e9ece148f91740f3a', '415e27a8a97d40de817cbdb276453753', 27, 2, 1, '2019-08-01 16:05:26', '2019-08-01 15:17:26', '2019-08-01 15:17:26');
INSERT INTO `oauth2_access_token` VALUES ('7258e54005364a6880d163d6bf310489', '8ddf887467e043dd896423cdd2a735d5', 27, 2, 1, '2019-07-14 15:43:32', '2019-07-14 14:55:32', '2019-07-14 14:55:32');
INSERT INTO `oauth2_access_token` VALUES ('725e278e8a2b47008b0dcfd45cdd9304', 'fff43f35fc1047b2b9b1f7a1d15ea6c8', 27, 2, 1, '2019-08-14 18:23:27', '2019-08-14 17:35:26', '2019-08-14 17:35:26');
INSERT INTO `oauth2_access_token` VALUES ('72639b380814441d8d9466e2db0f0687', 'ab1fe7008d51409b95cbfb5ee150e69a', 151, 1, 1, '2019-07-02 12:46:04', '2019-07-02 11:58:04', '2019-07-02 11:58:04');
INSERT INTO `oauth2_access_token` VALUES ('727410d9e4af455086c4ca046f8d8710', '54dff1ada36b4006b0f02747ef70c846', 27, 2, 1, '2019-07-23 07:09:44', '2019-07-23 06:21:44', '2019-07-23 06:21:44');
INSERT INTO `oauth2_access_token` VALUES ('7279528e7faa4a0d8b0785c7dcc5be9b', '7dd24fa604b3449ab1ed964cda94e160', 27, 2, 1, '2019-08-31 23:02:23', '2019-08-31 22:14:23', '2019-08-31 22:14:23');
INSERT INTO `oauth2_access_token` VALUES ('72812a34e8aa4a9293f8f3250e19300b', '1bb8e95e0ac1487d931eea2279c048ae', 27, 2, 1, '2019-06-14 15:52:05', '2019-06-14 15:04:05', '2019-06-14 15:04:05');
INSERT INTO `oauth2_access_token` VALUES ('729605b0aba946538fb3f8155d531594', '1ba08862eccd4def811b3b824337dcff', 27, 2, 1, '2019-07-29 00:14:27', '2019-07-28 23:26:26', '2019-07-28 23:26:26');
INSERT INTO `oauth2_access_token` VALUES ('7298158d429e42debb6fa36d59cf4361', '87027908f7d14850930eb489f8158099', 27, 2, 1, '2019-05-22 00:24:51', '2019-05-21 23:36:50', '2019-05-21 23:36:50');
INSERT INTO `oauth2_access_token` VALUES ('729b9bc65c83414c972a18d47656e183', '555adf9df8984978a24c30652ef92760', 27, 2, 1, '2019-06-07 17:06:28', '2019-06-07 16:18:27', '2019-06-07 16:18:27');
INSERT INTO `oauth2_access_token` VALUES ('729c380b8b614d73892a296be1b9c4a2', '309879320430462ab0418817f6286405', 27, 2, 1, '2019-07-02 16:04:34', '2019-07-02 15:16:33', '2019-07-02 15:16:33');
INSERT INTO `oauth2_access_token` VALUES ('72dd31653be44bca8f843d0a8fbebac0', 'e50e56ce40fa4abeb9131bf50a9e15de', 27, 2, 1, '2019-05-31 17:41:27', '2019-05-31 16:53:27', '2019-05-31 16:53:27');
INSERT INTO `oauth2_access_token` VALUES ('731ee7486f3744958a054e67a645d466', '54e8bb26587d46c49811d55a85000b39', 27, 2, 1, '2019-05-24 21:48:25', '2019-05-24 21:00:24', '2019-05-24 21:00:24');
INSERT INTO `oauth2_access_token` VALUES ('7329261bfe46461892c53c57a5be541d', 'c81fb0156cca4c90bc0407a9884c43ad', 27, 2, 1, '2019-07-26 01:08:41', '2019-07-26 00:20:41', '2019-07-26 00:20:41');
INSERT INTO `oauth2_access_token` VALUES ('73888a91d5984ced92c23ddf0545ed7f', '753e2a8d10804a7985b1a5927ec61381', NULL, NULL, 1, '2019-04-25 08:46:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('738add4ae6574a639f50b79c5a834657', 'daa9153c55da402e8dc464e4a041b935', 27, 2, 1, '2019-06-18 16:00:12', '2019-06-18 15:12:12', '2019-06-18 15:12:12');
INSERT INTO `oauth2_access_token` VALUES ('739f83e1327145809b2ff5eb322f0169', '1660aef37dcf4041ba947fbe4e7a19fe', NULL, NULL, 0, '2019-03-05 06:32:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('73a76905afc6408d83afb1658a2681df', 'b69a667333b04a0fb45b4755f9f13a31', 27, 2, 1, '2019-06-05 23:04:05', '2019-06-05 22:16:04', '2019-06-05 22:16:04');
INSERT INTO `oauth2_access_token` VALUES ('73b4f406a74b45e28cab3d3d7c44db84', '6cf79d0118024c70a2dde69e0a1c9e60', 27, 2, 1, '2019-06-12 16:30:12', '2019-06-12 15:42:11', '2019-06-12 15:42:11');
INSERT INTO `oauth2_access_token` VALUES ('73b6b66c603f4b9c97cd8d2f46a6289e', '4e5b2c5e8f8c4931b350cb9f02460b7f', 27, 2, 1, '2019-05-31 22:47:32', '2019-05-31 21:59:32', '2019-05-31 21:59:32');
INSERT INTO `oauth2_access_token` VALUES ('73c35de6a7314edaa35b30551e3b9fe0', '5a71ba66624641dfb507157b48869253', 27, 2, 1, '2019-05-31 23:40:52', '2019-05-31 22:52:52', '2019-05-31 22:52:52');
INSERT INTO `oauth2_access_token` VALUES ('73c37355d64b4f2398e0b0c6cae1e547', '5a967145db81417a811ab7557e749a0f', NULL, NULL, 1, '2019-05-06 10:30:06', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('73c929dac1fd4fa4ba41c4c8fb7086cf', '223a6e71a6df41feaa41570c966f4f6f', 27, 2, 1, '2019-05-20 22:20:57', '2019-05-20 21:32:56', '2019-05-20 21:32:56');
INSERT INTO `oauth2_access_token` VALUES ('73cb782b99c44c38832d4a5d589bbbb5', 'dfc4e713e7b44918a8ce506286b7621d', 1, 2, 0, '2019-08-21 18:49:52', '2019-08-21 18:01:51', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('73cc8be285c14a9fad7edd386a8ec503', 'a06ca1c058f84886ae70d13261a4e7e4', 27, 2, 1, '2019-05-31 21:56:31', '2019-05-31 21:08:30', '2019-05-31 21:08:30');
INSERT INTO `oauth2_access_token` VALUES ('73d28b48242447afa9921332dc895a6b', '037ed8ab3dcc4df4ae7002e1514ced86', 27, 2, 1, '2019-08-20 00:08:09', '2019-08-19 23:20:08', '2019-08-19 23:20:08');
INSERT INTO `oauth2_access_token` VALUES ('73eecbfd5e914ff2a4ee492f02ec32f7', '9a6d4a432c0f4e6bbca0d32bb52aae5a', NULL, NULL, 1, '2019-03-30 21:46:10', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('73fa00eff678487e9b85aa91b2621599', 'd51d2c1ad4ff492aa8f85c97866a5e44', 27, 2, 1, '2019-07-04 17:56:02', '2019-07-04 17:08:01', '2019-07-04 17:08:01');
INSERT INTO `oauth2_access_token` VALUES ('73fe8268f67e4762be686b6b48f4a788', '48bfe2d65dfc4515b43fff3b7f69bf1c', 27, 2, 1, '2019-06-01 15:19:22', '2019-06-01 14:31:22', '2019-06-01 14:31:22');
INSERT INTO `oauth2_access_token` VALUES ('7421ea1714fc46b181a99fdf86e88556', '7d3022510a8342218ab81b2f4e8f636e', 1, 2, 0, '2019-08-21 18:49:47', '2019-08-21 18:01:47', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('742670e3bdbf41a18de4e2748d225167', '873007d6117e40dd9ce7c8e6a87e4db7', 27, 2, 1, '2019-05-24 18:54:37', '2019-05-24 18:06:37', '2019-05-24 18:06:37');
INSERT INTO `oauth2_access_token` VALUES ('742ba754b3884d5e8d65648de11ae05b', 'b400239f362e4327a0e81d818c6293cc', 27, 2, 1, '2019-06-18 11:32:55', '2019-06-18 10:44:55', '2019-06-18 10:44:55');
INSERT INTO `oauth2_access_token` VALUES ('7430933d65a243e2ba788a3624d2967c', '01bf0aea8345485ebb90618521e3a76e', 27, 2, 1, '2019-05-19 01:32:01', '2019-05-19 00:44:01', '2019-05-19 00:44:01');
INSERT INTO `oauth2_access_token` VALUES ('743dc1fec2634f96bca892f251dd098a', 'd80c4b7cc41242f89297b43df1b7ef11', 27, 2, 1, '2019-06-01 10:42:29', '2019-06-01 09:54:28', '2019-06-01 09:54:28');
INSERT INTO `oauth2_access_token` VALUES ('744b84bec2ad449c94f4e3708c716d4e', '181a023155a34c4f8169f1ce1aec3a3a', 186, 1, 1, '2019-07-31 17:28:21', '2019-07-31 16:40:20', '2019-07-31 16:40:20');
INSERT INTO `oauth2_access_token` VALUES ('744c7efa8e374e29ae80a1928347ce1b', '2c5c1a63842442d69c218f99a764f176', 27, 2, 1, '2019-06-08 20:42:57', '2019-06-08 19:54:56', '2019-06-08 19:54:56');
INSERT INTO `oauth2_access_token` VALUES ('74683f1f7555440d9207b6fbd1d7d5f3', '5b89553774974490bec6fb519da5c5dd', 27, 2, 1, '2019-06-15 23:52:36', '2019-06-15 23:04:36', '2019-06-15 23:04:36');
INSERT INTO `oauth2_access_token` VALUES ('74786f7631cb46a783413984177e0916', '05c0e41de7ea41f7afdd489229bcbfc1', 1, 2, 0, '2019-08-20 14:32:38', '2019-08-20 13:44:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('747d8bc2c74840af8a8f51006f30df93', 'c131df94d7a94cfb84f91656a6be589f', 179, 1, 1, '2019-07-21 00:44:28', '2019-07-20 23:56:27', '2019-07-20 23:56:27');
INSERT INTO `oauth2_access_token` VALUES ('7484b4d95a9e41508569fb1afa742136', 'b705f4554f1d489e93a8e9eb231a2b08', 27, 2, 1, '2019-08-16 11:15:58', '2019-08-16 10:27:57', '2019-08-16 10:27:57');
INSERT INTO `oauth2_access_token` VALUES ('749617897ffb4927a497f61dc71cbb0f', '2b6875723b71491a901ae72bcfb4f1f4', 27, 2, 1, '2019-06-28 14:54:53', '2019-06-28 14:06:53', '2019-06-28 14:06:53');
INSERT INTO `oauth2_access_token` VALUES ('749c537c56c04666b49c956a0a8e54a6', '9be30425e2ec4c83aabb3f8da98c12f7', NULL, NULL, 1, '2019-05-11 17:45:05', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('74aeeaeff6d449538208062d1ce12158', 'a766628ece174b12b17160bdd1d61762', 27, 2, 1, '2019-06-12 16:49:57', '2019-06-12 16:01:56', '2019-06-12 16:01:56');
INSERT INTO `oauth2_access_token` VALUES ('74b0a72f55c44b649b75a88d28f15247', '14a0760bdf6c4b6db0d89a86d0e42e5e', 143, 1, 1, '2019-06-30 21:16:12', '2019-06-30 20:28:12', '2019-06-30 20:28:12');
INSERT INTO `oauth2_access_token` VALUES ('74b714dc76aa4dd1be97b3c38ae4ccb6', '9b3c6925301e46acaa5b757aa9826e88', 27, 2, 1, '2019-05-28 11:43:53', '2019-05-28 10:55:52', '2019-05-28 10:55:52');
INSERT INTO `oauth2_access_token` VALUES ('74b7ce2844bb46dfba16ae68bba77820', 'bd94d9fb47484252bbee2217950ff366', 27, 2, 1, '2019-06-07 17:08:04', '2019-06-07 16:20:04', '2019-06-07 16:20:04');
INSERT INTO `oauth2_access_token` VALUES ('74c67be5fe3f464e8b91767843df6cb6', '48abbb54655e4144ad6f165c85c3316f', NULL, NULL, 1, '2019-04-27 12:44:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('74cc76f52038480da8f1042db826e560', 'd02ebe9ba98b4a9596a2412ac5e7cd10', 27, 2, 1, '2019-05-27 13:14:58', '2019-05-27 12:26:57', '2019-05-27 12:26:57');
INSERT INTO `oauth2_access_token` VALUES ('74f5cefe671c4d53a0c40aea4483c8bd', 'c80e0afccaf84b8bb9f30f09b52bf772', 27, 2, 1, '2019-07-05 18:24:44', '2019-07-05 17:36:44', '2019-07-05 17:36:44');
INSERT INTO `oauth2_access_token` VALUES ('74fe7ec710914ae1af46e079b9ef9c12', '05242306bcf24c06a050e78d4d002c7c', 189, 1, 1, '2019-08-02 16:56:24', '2019-08-02 16:08:23', '2019-08-02 16:08:23');
INSERT INTO `oauth2_access_token` VALUES ('7518adf4c69c4d01ade209d411aa2e82', '0f61bc9c169948d5b935a1d833302452', 27, 2, 1, '2019-08-08 16:46:53', '2019-08-08 15:58:53', '2019-08-08 15:58:53');
INSERT INTO `oauth2_access_token` VALUES ('7518eecd200946f7ad960f07b67100e4', 'f4f923afd24d4dc6874857dc6d0abbc2', 27, 2, 1, '2019-06-14 15:40:35', '2019-06-14 14:52:35', '2019-06-14 14:52:35');
INSERT INTO `oauth2_access_token` VALUES ('751d19c1fa0a4d4d8e5b1a9d753829e5', '32aeab41a14140b493f17e02e4e6b73a', 27, 2, 1, '2019-06-03 22:50:24', '2019-06-03 22:02:23', '2019-06-03 22:02:23');
INSERT INTO `oauth2_access_token` VALUES ('75250501eca04ef9a00ce554febcf55e', 'ae1a9db7f6284a3094085ad11bb44b0a', 27, 2, 1, '2019-05-22 16:12:28', '2019-05-22 15:24:28', '2019-05-22 15:24:28');
INSERT INTO `oauth2_access_token` VALUES ('75290c08c0464a9d91441357373a074c', '2c0efcbc96bb48fab4021e531b34a700', NULL, NULL, 1, '2019-04-25 09:59:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('752e73ef11644719aedc7f99c9e770f4', '31c5edf12eca43f0aeb3126b93b9e28f', 27, 2, 1, '2019-06-24 17:19:05', '2019-06-24 16:31:04', '2019-06-24 16:31:04');
INSERT INTO `oauth2_access_token` VALUES ('75335be6f054446594c663c7fb057bb8', 'f4be2a28b8dc4e20a1f3fd8353bc918f', 27, 2, 1, '2019-08-24 16:41:41', '2019-08-24 15:53:40', '2019-08-24 15:53:40');
INSERT INTO `oauth2_access_token` VALUES ('7536dc3d6685486e881ce91754cee138', 'cb6bf16d0a584a4a98e85296af8b7965', 27, 2, 1, '2019-08-06 10:54:08', '2019-08-06 10:06:07', '2019-08-06 10:06:07');
INSERT INTO `oauth2_access_token` VALUES ('7552433132184a229290b28f65798ba2', '3d5cd247d5334009b644940f6e985af7', 27, 2, 1, '2019-07-05 10:25:41', '2019-07-05 09:37:41', '2019-07-05 09:37:41');
INSERT INTO `oauth2_access_token` VALUES ('75643936850c43b0842064d14229f10e', '94236051112044789e24bf092750c1a9', 27, 2, 1, '2019-08-15 18:11:38', '2019-08-15 17:23:38', '2019-08-15 17:23:38');
INSERT INTO `oauth2_access_token` VALUES ('7567836303814391bb8f37c6b5de14ba', '6ad5b476a2af4a52a4142b97a3589a5a', 1, 2, 0, '2019-08-14 23:12:46', '2019-08-14 22:24:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('759ca1dcce7d465b8ee2b85a301ba2a4', 'da3fb22b8c574be0aea75189413c88f5', 27, 2, 1, '2019-06-03 12:30:26', '2019-06-03 11:42:26', '2019-06-03 11:42:26');
INSERT INTO `oauth2_access_token` VALUES ('75bc238303ff44cb863811533e4c6b48', '5067eb38a11247f8badfdbe8472e2553', NULL, NULL, 1, '2019-05-12 23:29:29', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('75cb819ada4b4c0eaed86a13d4b58fda', '4fb0b1c89d5c41068a2cdb3a9798db01', NULL, NULL, 0, '2019-03-05 05:31:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('75cb8df177024fb39bd0eeb1ffc8f3d3', 'd28fcd8097464163b5bf3ae5a566230d', 27, 2, 1, '2019-07-24 15:31:27', '2019-07-24 14:43:27', '2019-07-24 14:43:27');
INSERT INTO `oauth2_access_token` VALUES ('75cf8adf5814440d95bdcfa1bd8c6323', '617878c46712468bb8709405decaa714', 27, 2, 1, '2019-06-04 21:46:45', '2019-06-04 20:58:45', '2019-06-04 20:58:45');
INSERT INTO `oauth2_access_token` VALUES ('75dab20f891546acacf5cb40a33888ae', '9b0339e401694645b04b5291482dfc5d', 27, 2, 1, '2019-07-04 10:08:55', '2019-07-04 09:20:54', '2019-07-04 09:20:54');
INSERT INTO `oauth2_access_token` VALUES ('75dc8a16b3124894ad4af59daabc7b9a', 'b175f039cfc54222bf05376e673e9c15', 27, 2, 1, '2019-07-30 18:16:01', '2019-07-30 17:28:01', '2019-07-30 17:28:01');
INSERT INTO `oauth2_access_token` VALUES ('75ebd016288f4a6fa14a54ca64bdea71', 'e2f5ab206ec74eda8b00fa43d9bdc7a8', 27, 2, 1, '2019-09-01 16:43:39', '2019-09-01 15:55:38', '2019-09-01 15:55:38');
INSERT INTO `oauth2_access_token` VALUES ('75eeeeb1861f4f328d5f131ee64ec0d9', 'f5b66f2a83464842bb8516083af4293d', 27, 2, 1, '2019-07-20 18:10:10', '2019-07-20 17:22:10', '2019-07-20 17:22:10');
INSERT INTO `oauth2_access_token` VALUES ('75f0c4ce25c349909fa9b31ad3d1737a', '57e2319082434aa186f269219f608ebc', NULL, NULL, 1, '2019-05-05 08:35:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('75fd98b256aa4ba29258a9e069a12418', 'a893a631139746159c6fdfae80eb81e0', NULL, NULL, 1, '2019-05-09 16:01:05', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('75fe264f4ea24b9f9c01c282c895458d', '64838d1f6a9842ef9538b56a3021126d', 27, 2, 1, '2019-07-13 00:28:33', '2019-07-12 23:40:33', '2019-07-12 23:40:33');
INSERT INTO `oauth2_access_token` VALUES ('76170c56e4824e1d8d78ce9ad05b5520', '627519354c1f41e8a1f8a3d9c04a4923', 1, 2, 0, '2019-07-17 19:35:27', '2019-07-17 18:47:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('763395a2a49a437398c69c461385047e', '94b8ab597abe4fe296f690c4d27ee6f4', 76, 1, 1, '2019-05-20 12:35:51', '2019-05-20 11:47:50', '2019-05-20 11:47:50');
INSERT INTO `oauth2_access_token` VALUES ('7635b66dc56f4bc287efb605642c61c5', 'e7e199ae42ed4004815a48a5b53e0ffa', 1, 2, 0, '2019-07-02 12:06:48', '2019-07-02 11:18:47', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('765c05a418ec4c8f83f15361a31ec029', '04fe54953f7f46c8999fe7b957129c25', 27, 2, 1, '2019-06-11 21:02:19', '2019-06-11 20:14:19', '2019-06-11 20:14:19');
INSERT INTO `oauth2_access_token` VALUES ('7675514649174b8db26ba3dad55a0031', 'b1513569421a436bb39f1629b4707b46', NULL, NULL, 1, '2019-04-01 13:57:13', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('767c69d89ad648f6981ee218ad632c86', 'ee5c53ffb8ac49c4a891d2a2bbd1566f', 27, 2, 1, '2019-09-02 15:53:19', '2019-09-02 15:05:19', '2019-09-02 15:05:19');
INSERT INTO `oauth2_access_token` VALUES ('76852bb4ba08476c85b660669296d04e', 'af20285fe3b146049a911b6f56815458', 27, 2, 1, '2019-08-05 15:09:08', '2019-08-05 14:21:08', '2019-08-05 14:21:08');
INSERT INTO `oauth2_access_token` VALUES ('76c25ebeb86342f7afefb7c3df23a7ff', '5fdff8f628e640c28404f18a2694d205', 27, 2, 1, '2019-07-23 22:06:12', '2019-07-23 21:18:12', '2019-07-23 21:18:12');
INSERT INTO `oauth2_access_token` VALUES ('76ecef69c5f140e0b286f391cf253cb4', '835a33aee643449bbbaa8fa203436070', 27, 2, 1, '2019-08-11 18:31:37', '2019-08-11 17:43:36', '2019-08-11 17:43:36');
INSERT INTO `oauth2_access_token` VALUES ('76f41a2f6b32494fa6fe86aadf3155f5', 'e57f0408d82a47a0bce0a216501523b4', 27, 2, 1, '2019-07-30 12:04:53', '2019-07-30 11:16:52', '2019-07-30 11:16:52');
INSERT INTO `oauth2_access_token` VALUES ('770ec13d8f974a6b89a138cbbbeda490', 'a7257e5865b640169d98b84efc1255e2', 27, 2, 1, '2019-06-03 10:47:50', '2019-06-03 09:59:49', '2019-06-03 09:59:49');
INSERT INTO `oauth2_access_token` VALUES ('7716d7ab577f497899f582c7453d660c', '538367140467411ca8083a6354d210db', 27, 2, 1, '2019-08-02 16:27:14', '2019-08-02 15:39:13', '2019-08-02 15:39:13');
INSERT INTO `oauth2_access_token` VALUES ('7729aea9b2ed4ee2a03a84c47029131f', '4825aec434144808ba332496377a8858', 1, 2, 0, '2019-07-17 20:35:40', '2019-07-17 19:47:39', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('774f00d7f08744b786eb3ce5bf7f74bd', '7f9366255f0841a4a3a9cbda1b8d0ce6', NULL, NULL, 1, '2019-04-22 19:14:58', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('777bb4cdfc234fc7bec80306939b9e40', '0aedc94e73714362901e8c66b8e92a64', 27, 2, 1, '2019-08-09 16:20:32', '2019-08-09 15:32:32', '2019-08-09 15:32:32');
INSERT INTO `oauth2_access_token` VALUES ('779f3657dc884fdd904a0074d6b59d80', 'f702903de89a44e19de2cf87596d48f0', 27, 2, 1, '2019-07-03 19:35:51', '2019-07-03 18:47:50', '2019-07-03 18:47:50');
INSERT INTO `oauth2_access_token` VALUES ('77b8627b22e24f60bfdbe05ae4397169', '95bd8d8fa40443b2a69643ce5b6c7e91', 27, 2, 1, '2019-07-19 14:32:28', '2019-07-19 13:44:27', '2019-07-19 13:44:27');
INSERT INTO `oauth2_access_token` VALUES ('77d09ed0ca4d423d8579389e3cf37a89', 'a6cefa4f10a74e20ab9566d4a38ac48d', 27, 2, 1, '2019-07-04 15:24:44', '2019-07-04 14:36:43', '2019-07-04 14:36:43');
INSERT INTO `oauth2_access_token` VALUES ('77d838328fed4ae3b3bf89771295b3d0', '1682115be0f3447baad9d323991e15b1', NULL, NULL, 1, '2019-05-05 12:35:38', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('77ff1b15dc6a43d3b87125bc1a49f416', '3b083529ebfb4fd2bb20bdb41303eaa0', 27, 2, 1, '2019-07-20 11:14:47', '2019-07-20 10:26:46', '2019-07-20 10:26:46');
INSERT INTO `oauth2_access_token` VALUES ('780566bf57ce45c0866a5a1c26ae1bb3', '008b76d0a0eb45c1b381b87f4dbda821', NULL, NULL, 0, '2019-03-05 06:40:10', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('781b3503e20d4dc8a6afb8bc774cf911', 'c34f6c32c4a44e7897b725e712447113', NULL, NULL, 1, '2019-04-16 20:41:33', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('78248a62585b4dc2b1262e9f498c2ef3', '004da14fdbae4aaa9274b0bbe9682f7c', 27, 2, 1, '2019-05-28 10:08:21', '2019-05-28 09:20:20', '2019-05-28 09:20:20');
INSERT INTO `oauth2_access_token` VALUES ('782a889f3f0c480ea93f4855f5b9ce20', '5781161d83e54040abd9a1d9c63da6d2', 27, 2, 1, '2019-07-17 15:29:11', '2019-07-17 14:41:11', '2019-07-17 14:41:11');
INSERT INTO `oauth2_access_token` VALUES ('782bd48317b64c0589e7c83f00cfe796', '9d0fbb903b504e318cdcde926acfe418', 27, 2, 1, '2019-08-16 16:35:39', '2019-08-16 15:47:39', '2019-08-16 15:47:39');
INSERT INTO `oauth2_access_token` VALUES ('782f203421ec427b9d66b0e9692ca5c9', '0ba867c92f3f4138819a74aa2cec2be4', 27, 2, 1, '2019-08-21 12:27:36', '2019-08-21 11:39:36', '2019-08-21 11:39:36');
INSERT INTO `oauth2_access_token` VALUES ('78382b55e92845bd8e65b4df89176811', '1f40f28d36b84c9faa3a3a23d39d8165', 27, 2, 1, '2019-07-04 17:24:40', '2019-07-04 16:36:40', '2019-07-04 16:36:40');
INSERT INTO `oauth2_access_token` VALUES ('785f0e91c38a46919782ff7bf435a4f3', 'df7422ce577340378136d8ae5f4cc06c', 27, 2, 1, '2019-06-06 16:45:04', '2019-06-06 15:57:04', '2019-06-06 15:57:04');
INSERT INTO `oauth2_access_token` VALUES ('78717c10536f4548b1bc6c9b7a1132e2', 'af2a7a4680dc4471b72ce6ec5024d644', 1, 2, 0, '2019-06-04 17:16:48', '2019-06-04 16:28:48', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('78731394025c4a1eb2c3e1e87b599a60', '5eb9b0df69514bcf8ec7d79442c61653', 1, 2, 0, '2019-07-05 10:53:28', '2019-07-05 10:05:27', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('787c0755d84347788b98ffd155aeb814', '616a15bf2e4a4a6bae006fdddeb02772', 27, 2, 1, '2019-08-11 18:08:22', '2019-08-11 17:20:21', '2019-08-11 17:20:21');
INSERT INTO `oauth2_access_token` VALUES ('788bfc9c1ead408aa4a89ce6f9d27a7c', '6febea3507bf450ba265fc298a48d8d4', 27, 2, 1, '2019-08-21 09:54:59', '2019-08-21 09:06:58', '2019-08-21 09:06:58');
INSERT INTO `oauth2_access_token` VALUES ('78b735a287ce4673bbe2ca661e2783e5', 'e8a86f019a9a484394fa0bb474b715ef', NULL, NULL, 1, '2019-05-06 15:52:38', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('78b8acab88b14c668a0d5431cc4e0dc2', 'e740bff2a7c64f56b928ea43451a036d', 27, 2, 1, '2019-06-03 11:02:06', '2019-06-03 10:14:05', '2019-06-03 10:14:05');
INSERT INTO `oauth2_access_token` VALUES ('78db37817163498082069f148c822dce', 'ecbdf7acf7ec4cd9b0b376ef24b78879', NULL, NULL, 1, '2019-05-01 12:39:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('78fcd567f2784fe59971d2f1fddb3687', 'bd559180cb184d04850ef15c91744bd4', 27, 2, 1, '2019-07-16 14:26:47', '2019-07-16 13:38:47', '2019-07-16 13:38:47');
INSERT INTO `oauth2_access_token` VALUES ('7937bfab80b3434f8d556a5013e82096', 'b49560247ab342d98dca2e4c93e8323b', 27, 2, 1, '2019-08-15 10:35:36', '2019-08-15 09:47:35', '2019-08-15 09:47:35');
INSERT INTO `oauth2_access_token` VALUES ('793cd8fe3b35428f844f1d0b30c9b48a', '58684165110f48399ca334a92bcfe864', 27, 2, 1, '2019-05-31 20:05:19', '2019-05-31 19:17:18', '2019-05-31 19:17:18');
INSERT INTO `oauth2_access_token` VALUES ('7964a7e61a964ad891d01dcf2f587cdf', '121221cee5f44facbf011947bc546e8b', NULL, NULL, 1, '2019-04-29 15:06:41', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('798bf7d06b8c43e8a5be3f8be0502927', '1313715d476c42099b718a46aa297ad5', NULL, NULL, 1, '2019-04-29 22:53:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7990249b696f42d79b3f749f4ad4425b', 'a2de75c486114e5ba86b5357324c4977', 1, 1, 1, '2019-05-17 18:46:10', '2019-05-17 17:58:09', '2019-05-17 17:58:09');
INSERT INTO `oauth2_access_token` VALUES ('79a2d1f804374679840a3dea58786b19', '676b04dc9446449b8cd4ca4ba4b2962d', NULL, NULL, 1, '2019-04-22 19:13:23', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('79c72aa3ed254776a3c4a8fd911cfcb7', 'bed9ee45f67c4f2db957662295d6516b', 27, 2, 1, '2019-08-15 22:07:11', '2019-08-15 21:19:11', '2019-08-15 21:19:11');
INSERT INTO `oauth2_access_token` VALUES ('79c925cee2cc43a0ace628254c8ccf21', 'e097c9a1dc784169b0fb8120043995ce', 27, 2, 1, '2019-06-19 15:10:35', '2019-06-19 14:22:34', '2019-06-19 14:22:34');
INSERT INTO `oauth2_access_token` VALUES ('79d34bf43b4047f0ba99fabf004d6563', '8ba652a03e564a1fbdc6b64a73df84ee', 27, 2, 1, '2019-09-05 11:27:16', '2019-09-05 10:39:15', '2019-09-05 10:39:15');
INSERT INTO `oauth2_access_token` VALUES ('79ef9dca22d241a1a41eb62e2c58a4c2', 'a4b66897432f47d182cff4a7a900c946', 27, 2, 1, '2019-06-04 22:13:58', '2019-06-04 21:25:57', '2019-06-04 21:25:57');
INSERT INTO `oauth2_access_token` VALUES ('79fe57fb32ed4aafbc7b9298148572cd', '1b14898e58aa403f8ee07d669b8b3f5e', 27, 2, 1, '2019-07-29 14:40:55', '2019-07-29 13:52:54', '2019-07-29 13:52:54');
INSERT INTO `oauth2_access_token` VALUES ('7a01cff02765415690351bda3d708405', '91cffea801874079a6cdcc5d6eed3855', NULL, NULL, 0, '2019-03-06 06:23:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7a034d47ca194561b31346cb47c3f8a6', 'ee006b02b9324410962b1eed96959f66', 27, 2, 1, '2019-08-29 18:41:11', '2019-08-29 17:53:10', '2019-08-29 17:53:10');
INSERT INTO `oauth2_access_token` VALUES ('7a0757858e914dd29dfc1d2aed787b46', '15e5406960384177af0ab9c1e6946f1d', 27, 2, 1, '2019-09-07 23:14:28', '2019-09-07 22:26:28', '2019-09-07 22:26:28');
INSERT INTO `oauth2_access_token` VALUES ('7a0b4447e31443b8b19b3a68771b6a29', '3b75a5b077044addbcd2487b1fedb746', 27, 2, 1, '2019-06-04 11:26:25', '2019-06-04 10:38:24', '2019-06-04 10:38:24');
INSERT INTO `oauth2_access_token` VALUES ('7a2979d8fe1d4375931a650a1663d388', '8e3be1c67d7e42dea106cd1fe511b881', 27, 2, 1, '2019-07-07 21:44:28', '2019-07-07 20:56:28', '2019-07-07 20:56:28');
INSERT INTO `oauth2_access_token` VALUES ('7a3ad2e04f824dd196050e6c5fd8f709', 'f87a3df538594114af5cec74bbfba691', 27, 2, 1, '2019-05-23 14:54:26', '2019-05-23 14:06:26', '2019-05-23 14:06:26');
INSERT INTO `oauth2_access_token` VALUES ('7a46be7926a24917a05f2eeebfc5df82', '3e66f05f9467446b8ca234c4112ac18d', 27, 2, 1, '2019-07-02 14:16:47', '2019-07-02 13:28:46', '2019-07-02 13:28:46');
INSERT INTO `oauth2_access_token` VALUES ('7a582ecbc4644fe7980fffc08dda4c90', 'cadcf0524b6746e791b65f8b8bcb636e', 27, 2, 1, '2019-06-21 21:48:26', '2019-06-21 21:00:25', '2019-06-21 21:00:25');
INSERT INTO `oauth2_access_token` VALUES ('7a5ccc8361e448c880f9239296f0a656', 'cacafb970894469bbb2735c25cb15bec', 27, 2, 1, '2019-07-08 17:13:07', '2019-07-08 16:25:07', '2019-07-08 16:25:07');
INSERT INTO `oauth2_access_token` VALUES ('7a601f348f984c359ec809a4d7710b87', '7b504c74b8b648e98286776b3631bfab', 27, 2, 1, '2019-06-03 09:41:23', '2019-06-03 08:53:22', '2019-06-03 08:53:22');
INSERT INTO `oauth2_access_token` VALUES ('7a8ffc0afe1d4685879f3a77d1904028', '05bdb77ce57b437781fd6b3a61ebe4c4', 27, 2, 1, '2019-05-20 11:34:47', '2019-05-20 10:46:47', '2019-05-20 10:46:47');
INSERT INTO `oauth2_access_token` VALUES ('7a90707bb80748cbaba66c5e8403e700', 'b24e74bad830478097aaa71cbd867950', 27, 2, 1, '2019-06-01 15:52:25', '2019-06-01 15:04:25', '2019-06-01 15:04:25');
INSERT INTO `oauth2_access_token` VALUES ('7a933f2bc2784691a7430ecc9be71b05', '21c88f6e515b4c72a1a2807d3f22f617', 161, 1, 1, '2019-07-08 23:25:08', '2019-07-08 22:37:08', '2019-07-08 22:37:08');
INSERT INTO `oauth2_access_token` VALUES ('7a95eb2719ee4fe9842924d0e86280a3', '0a9cdeb9cb7840ef9c0be048d444196f', NULL, NULL, 1, '2019-05-15 11:11:48', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7ac216c10d5642dfa75a611d6e4f3819', 'b17bb2a70559489a97d6d77a8a40020a', 27, 2, 1, '2019-06-18 12:21:32', '2019-06-18 11:33:32', '2019-06-18 11:33:32');
INSERT INTO `oauth2_access_token` VALUES ('7ae8101d50d440d584cb043073ae9548', 'b1657c8a04e645c186677367814ce777', 27, 2, 1, '2019-07-17 15:28:19', '2019-07-17 14:40:18', '2019-07-17 14:40:18');
INSERT INTO `oauth2_access_token` VALUES ('7aed14f88a264d6981a28a261bd9b32e', 'f347a72064db4532a366fc2ac6459442', 27, 2, 1, '2019-06-10 10:55:35', '2019-06-10 10:07:34', '2019-06-10 10:07:34');
INSERT INTO `oauth2_access_token` VALUES ('7b105a0424484604b41d2c60a85f6419', '592eb8b2952244048709a994f4ddc771', 27, 2, 1, '2019-08-09 18:05:28', '2019-08-09 17:17:27', '2019-08-09 17:17:27');
INSERT INTO `oauth2_access_token` VALUES ('7b1cb733168d424f91ca29d58a8237b9', '94093d3af11d4b0e90c09c8679ca5383', 27, 2, 1, '2019-09-03 10:26:04', '2019-09-03 09:38:04', '2019-09-03 09:38:04');
INSERT INTO `oauth2_access_token` VALUES ('7b323cc133b74cd0b1228751d89c01b4', '111956d1627340da9250be9ce18c650d', 27, 2, 1, '2019-06-11 10:49:37', '2019-06-11 10:01:36', '2019-06-11 10:01:36');
INSERT INTO `oauth2_access_token` VALUES ('7b34a56c4096481d8e031b2432e9d167', '6cc591ff350049c7a2cefea7c160eec9', 27, 2, 1, '2019-06-04 10:59:16', '2019-06-04 10:11:15', '2019-06-04 10:11:15');
INSERT INTO `oauth2_access_token` VALUES ('7b482eaa51be4d55ba547be020bcd927', '7a9b597d1ef541308dabbf4d3ef85943', 27, 2, 1, '2019-07-17 15:45:52', '2019-07-17 14:57:52', '2019-07-17 14:57:52');
INSERT INTO `oauth2_access_token` VALUES ('7b5e1ccbf85f4c4cac6dac0634b81091', '52c6a05e3d7c4fdfbc4332a87962db44', 27, 2, 1, '2019-06-01 00:58:48', '2019-06-01 00:10:48', '2019-06-01 00:10:48');
INSERT INTO `oauth2_access_token` VALUES ('7b61aca193544f03be5d7687d6f750df', 'ede5adb2be254629b20a6016f6db8652', 27, 2, 1, '2019-07-29 21:56:52', '2019-07-29 21:08:52', '2019-07-29 21:08:52');
INSERT INTO `oauth2_access_token` VALUES ('7b644f54671d471a95c2cbf19edeb19c', '8b7b1bbfdbc245d2a5abca17fe0cedcc', 219, 1, 1, '2019-09-04 18:34:39', '2019-09-04 17:46:39', '2019-09-04 17:46:39');
INSERT INTO `oauth2_access_token` VALUES ('7b75f832a7614ddf8bdafbfcdaa96b77', 'd0020f21794a47868e5841b18f470d79', 27, 2, 1, '2019-06-08 17:00:35', '2019-06-08 16:12:35', '2019-06-08 16:12:35');
INSERT INTO `oauth2_access_token` VALUES ('7b77ce1bbaf444bfba4e499cdbf5c6e8', 'd807a142288044e0a7b5d2322a536f3d', NULL, NULL, 1, '2019-05-05 16:36:47', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7b82ff1fdd2f4f4aab61b8a6b530f041', '238b79a0a4ad40fab7f7d09343a5ea9d', 27, 2, 1, '2019-05-24 18:35:10', '2019-05-24 17:47:09', '2019-05-24 17:47:09');
INSERT INTO `oauth2_access_token` VALUES ('7b848a4f717e4b5daffc2d31cfe4c032', 'b84b1b4e7350422fb46f57138589a7bd', 27, 2, 1, '2019-08-25 15:00:31', '2019-08-25 14:12:30', '2019-08-25 14:12:30');
INSERT INTO `oauth2_access_token` VALUES ('7b87cc494cc946059c7d89c1a1dd0907', 'cbae6794f60e4d58804f1cf713608ad3', 27, 2, 1, '2019-09-07 01:34:02', '2019-09-07 00:46:01', '2019-09-07 00:46:01');
INSERT INTO `oauth2_access_token` VALUES ('7b8b5e632c4e48c0af1f90163d0c6aa1', '65d03dceb00348b194bf7dffe5e20e81', NULL, NULL, 1, '2019-04-29 18:26:33', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7b9bae43f1094fee949b9547fc3bea50', '05029c33968c4e63b3e67f420dfc63ac', 27, 2, 1, '2019-07-12 15:59:33', '2019-07-12 15:11:32', '2019-07-12 15:11:32');
INSERT INTO `oauth2_access_token` VALUES ('7b9c5f09a5eb4770aeb30b97a91c9b0c', '304a7edc7bb34596b3ef1228b64973fa', 27, 2, 1, '2019-08-29 01:02:45', '2019-08-29 00:14:45', '2019-08-29 00:14:45');
INSERT INTO `oauth2_access_token` VALUES ('7ba689ec69ec4131abd64d38d81e9923', 'f858a1e0ea3f455d8b9b84695e172415', 27, 2, 1, '2019-08-08 08:51:41', '2019-08-08 08:03:41', '2019-08-08 08:03:41');
INSERT INTO `oauth2_access_token` VALUES ('7bd1e9dafb544860b6b4d8075f02180c', '83806986c2234f3dafe5be6f5e937f2f', NULL, NULL, 1, '2019-05-17 00:32:07', NULL, '2019-05-16 23:44:07');
INSERT INTO `oauth2_access_token` VALUES ('7bf6c941e7204e33863bd217ee734138', '44b02353ff334beaaffa9a66ef4fa91c', 27, 2, 1, '2019-08-23 18:36:00', '2019-08-23 17:48:00', '2019-08-23 17:48:00');
INSERT INTO `oauth2_access_token` VALUES ('7c001f8929a94d6b94cec7dc3713a733', '81420571aabe42d79e27eed9aac909f0', 27, 2, 1, '2019-07-06 12:13:44', '2019-07-06 11:25:44', '2019-07-06 11:25:44');
INSERT INTO `oauth2_access_token` VALUES ('7c1820d5332a475ba9feec2e69a4dc05', '4c253e52b0a04819b7f0f3d9989892c5', 27, 2, 1, '2019-08-28 23:03:14', '2019-08-28 22:15:14', '2019-08-28 22:15:14');
INSERT INTO `oauth2_access_token` VALUES ('7c4cffdfc5e543abba8c733222a51e90', '01a18ca31aba4bab8829e8d6391539a7', 27, 2, 1, '2019-06-02 12:47:17', '2019-06-02 11:59:16', '2019-06-02 11:59:16');
INSERT INTO `oauth2_access_token` VALUES ('7c550bb474114276bd9a3a491dd77a17', '9735d23edac54675bec32932f58f4128', 27, 2, 1, '2019-07-01 00:05:47', '2019-06-30 23:17:46', '2019-06-30 23:17:46');
INSERT INTO `oauth2_access_token` VALUES ('7c5b7df5025042369dadd40858d16e83', '49ef1a5bc16c4cf99c3767a2f6bb8ff9', NULL, NULL, 1, '2019-05-12 11:39:09', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7c656189cc0642308b4a50b8eeedf883', 'ed15f9f6433b425298a57c5f35bb44a5', NULL, NULL, 1, '2019-03-13 16:43:50', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7c657b41cc7b40e8a90b269fb62aa61c', '9584d03f6d4649fc9f2924f2bdf31de9', NULL, NULL, 1, '2019-05-07 17:36:37', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7c7f1eb4c9f04eab9e0be5f23df0b87c', '0d6645757248440f8d2979a249eaab91', 27, 2, 1, '2019-09-02 16:42:19', '2019-09-02 15:54:18', '2019-09-02 15:54:18');
INSERT INTO `oauth2_access_token` VALUES ('7c9aa89d4a8c4da4a89b8354fc3a07d4', 'bf5a97fdab8342f69927197e392c9f5f', 27, 2, 1, '2019-08-06 11:48:16', '2019-08-06 11:00:15', '2019-08-06 11:00:15');
INSERT INTO `oauth2_access_token` VALUES ('7ca5715998874f08b22f43d91ad72b7e', '0472d5ac801d40a884468eae2729c16e', 27, 2, 1, '2019-07-08 16:49:19', '2019-07-08 16:01:18', '2019-07-08 16:01:18');
INSERT INTO `oauth2_access_token` VALUES ('7cc89d61471a4dcb85bfdd4f99514418', '2ad17ed273a94d63b1ed3dea2068d22e', 27, 2, 1, '2019-08-26 08:49:01', '2019-08-26 08:01:00', '2019-08-26 08:01:00');
INSERT INTO `oauth2_access_token` VALUES ('7ccba09e70094d749005b639368eec85', 'e4e7ba106e9e4ceda9f51a9a1bc9c215', 27, 2, 1, '2019-06-25 18:16:33', '2019-06-25 17:28:32', '2019-06-25 17:28:32');
INSERT INTO `oauth2_access_token` VALUES ('7ce5022bb3d543fa90d11bcfeef5fb4d', '1128ee106c5d40369e714ff8fc0d6a6c', 27, 2, 1, '2019-06-04 17:29:29', '2019-06-04 16:41:28', '2019-06-04 16:41:28');
INSERT INTO `oauth2_access_token` VALUES ('7cefb7ba78ca4475a18ae5b3468a40f3', '3febe210f8be4df5bbdea9a98e352a06', 27, 2, 1, '2019-07-16 16:10:36', '2019-07-16 15:22:36', '2019-07-16 15:22:36');
INSERT INTO `oauth2_access_token` VALUES ('7cf43c65943f437aabfab120c7e54bde', 'bd878172beab47fa89adcb583fdcced2', 27, 2, 1, '2019-07-28 23:57:12', '2019-07-28 23:09:12', '2019-07-28 23:09:12');
INSERT INTO `oauth2_access_token` VALUES ('7cf4c5f298b3483995d119eeb64e364f', '206614804dc742e1ac90501b725cbcff', 1, 2, 0, '2019-09-03 00:33:07', '2019-09-02 23:45:07', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('7d03a8e37961460e8e2266d8a1108f37', 'be011678d0a14f588a4f47a4e9d611fa', 27, 2, 1, '2019-08-31 10:28:40', '2019-08-31 09:40:40', '2019-08-31 09:40:40');
INSERT INTO `oauth2_access_token` VALUES ('7d0b3edc17c045db880d21b39b710503', '3fcf2fd7c51f4699a2aa7378ed7f3a83', NULL, NULL, 1, '2019-04-11 23:32:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7d1252ef6895442499d14a8ca9674e4c', 'b59377af3ca74b4ea5aa0c6266be9b20', 27, 2, 1, '2019-08-29 14:39:41', '2019-08-29 13:51:40', '2019-08-29 13:51:40');
INSERT INTO `oauth2_access_token` VALUES ('7d14d9d4299343738d36fc1bf48fc227', '6fc965dcfb8346cbbfa14a4fa4707756', 27, 2, 1, '2019-06-21 16:04:59', '2019-06-21 15:16:59', '2019-06-21 15:16:59');
INSERT INTO `oauth2_access_token` VALUES ('7d1a042bbaf84e82b5e3d9c5ae66f9f9', 'a1c21c0ab6954c8799e338fd20f5e02a', 27, 2, 1, '2019-08-16 10:53:48', '2019-08-16 10:05:47', '2019-08-16 10:05:47');
INSERT INTO `oauth2_access_token` VALUES ('7d35ea661f8741178463b709623dc195', '7ec87b8d11284b5cbdb5345240776af4', 27, 2, 1, '2019-06-01 16:43:27', '2019-06-01 15:55:26', '2019-06-01 15:55:26');
INSERT INTO `oauth2_access_token` VALUES ('7d4f7c6f032443f69352763b005d9e34', '7e4b25dbb7ae46bcb161b77ef9c9613e', 27, 2, 1, '2019-06-05 14:47:32', '2019-06-05 13:59:32', '2019-06-05 13:59:32');
INSERT INTO `oauth2_access_token` VALUES ('7d546bce1f2e40568a410fd03b5e069b', '25e8c8e501ed4d1bbf9692d0313fa9cd', 27, 2, 1, '2019-06-17 00:21:00', '2019-06-16 23:33:00', '2019-06-16 23:33:00');
INSERT INTO `oauth2_access_token` VALUES ('7d5950f274fc48e286f052bd3a4b634c', '536bf755b8a0407aa4e23bd979810db9', 27, 2, 1, '2019-07-10 17:16:22', '2019-07-10 16:28:21', '2019-07-10 16:28:21');
INSERT INTO `oauth2_access_token` VALUES ('7d60120c41dd4698957c3928a02e7663', '6ca788bf44d644b4b9d27f753d9e8274', NULL, NULL, 1, '2019-04-12 20:11:29', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7d642a4289914493b43d012e5869cb54', 'ac327aa3484145a1ac6bc84fa184e466', 27, 2, 1, '2019-05-31 21:51:39', '2019-05-31 21:03:38', '2019-05-31 21:03:38');
INSERT INTO `oauth2_access_token` VALUES ('7d76c7f6b2c24fb693fc3ec1ce2fca19', '624d567fe78e45f38cd27c8fcb39ce31', 27, 2, 1, '2019-07-10 17:26:26', '2019-07-10 16:38:26', '2019-07-10 16:38:26');
INSERT INTO `oauth2_access_token` VALUES ('7d7e1b9912984041b94eacb6ba17b679', 'bee4b6a90beb4b199aca702f2772995b', 27, 2, 1, '2019-07-18 17:49:12', '2019-07-18 17:01:12', '2019-07-18 17:01:12');
INSERT INTO `oauth2_access_token` VALUES ('7d87d8e4fe474664b1d4dbf7fa8cb3b0', '83e7a0677a9344fdb572358a6a2f6ce2', 27, 2, 1, '2019-06-03 14:42:45', '2019-06-03 13:54:45', '2019-06-03 13:54:45');
INSERT INTO `oauth2_access_token` VALUES ('7dc220858a1e46ab98df5d81ab32b834', 'be85cdcf119e4d899f4fb7d3a48f4355', NULL, NULL, 1, '2019-04-06 00:04:13', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7dca1fa63f4e43fe83f9e93eb6af7d36', 'eab7c057048447b7b17a2bba904f1d89', 27, 2, 1, '2019-06-20 19:39:11', '2019-06-20 18:51:11', '2019-06-20 18:51:11');
INSERT INTO `oauth2_access_token` VALUES ('7dd18256c64a440d87ec16d4e490a759', '6e5dd25a9644438493140d2929467229', 27, 2, 1, '2019-09-05 16:44:03', '2019-09-05 15:56:03', '2019-09-05 15:56:03');
INSERT INTO `oauth2_access_token` VALUES ('7dd77f90d1e0486fb123469d72beac88', 'cb4eaae19b8244eea72b16a9a08d92e1', 27, 2, 1, '2019-07-08 16:52:38', '2019-07-08 16:04:37', '2019-07-08 16:04:37');
INSERT INTO `oauth2_access_token` VALUES ('7df23c1acbb040f3b110daa66eea3977', '24dd5404f48b49828862243aad635d97', 27, 2, 1, '2019-08-05 10:17:00', '2019-08-05 09:29:00', '2019-08-05 09:29:00');
INSERT INTO `oauth2_access_token` VALUES ('7df3b145be8a41a287b4bb7442bf4e94', 'ffc0bc95a227453dbc89362e99701c02', 27, 2, 1, '2019-06-01 10:41:37', '2019-06-01 09:53:36', '2019-06-01 09:53:36');
INSERT INTO `oauth2_access_token` VALUES ('7e1a5ade540a42969b2826936bacbb8f', '66cedaaaa66c444d923ba5c070c49264', 27, 2, 1, '2019-07-16 18:48:19', '2019-07-16 18:00:18', '2019-07-16 18:00:18');
INSERT INTO `oauth2_access_token` VALUES ('7e278e2cc324427f85fc8f59495e3e40', 'be67d61805754b618c1ad712e97af4ca', 27, 2, 1, '2019-06-20 13:20:06', '2019-06-20 12:32:05', '2019-06-20 12:32:05');
INSERT INTO `oauth2_access_token` VALUES ('7e4200c4ad9e4acdb833bc127004e958', 'a6a6ca8c26e44e1ba0e297b842d92221', 27, 2, 1, '2019-07-03 17:18:17', '2019-07-03 16:30:17', '2019-07-03 16:30:17');
INSERT INTO `oauth2_access_token` VALUES ('7e5a4a3ff80449c19b1feb9fcd8511ed', 'b2d0aeb3a1c84a068f40de7da6f90cba', 27, 2, 1, '2019-06-02 19:36:06', '2019-06-02 18:48:06', '2019-06-02 18:48:06');
INSERT INTO `oauth2_access_token` VALUES ('7e69107b36214b90ad5ed55ec87bf00c', 'f3a2563ce8fd4f84902f1c2e06597503', 172, 1, 1, '2019-07-16 19:02:40', '2019-07-16 18:14:39', '2019-07-16 18:14:39');
INSERT INTO `oauth2_access_token` VALUES ('7e7b63c3b16d4d879483c862969d1678', 'cf7a52d51cab46cbbc5ef9de8bfc23b7', 27, 2, 1, '2019-06-06 09:11:14', '2019-06-06 08:23:14', '2019-06-06 08:23:14');
INSERT INTO `oauth2_access_token` VALUES ('7eb7fb9532ca491c9c17d59de957211a', '99b325a68e4d4c77a6d4b81d1dc6a973', 1, 2, 0, '2019-06-03 14:44:06', '2019-06-03 13:56:06', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('7ec17ed83f8a4c8ea3bb70742fafad1a', 'cbc03ee559b846b9804f8cce8b7450e3', 27, 2, 1, '2019-06-12 09:28:50', '2019-06-12 08:40:49', '2019-06-12 08:40:49');
INSERT INTO `oauth2_access_token` VALUES ('7ed352cd888d4b14acee9e086485da6b', 'dde27407c041409c96d80ff0a76c94ff', NULL, NULL, 1, '2019-05-01 12:40:47', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7eda7afbc7b948bda78c491f347a45fe', 'a7a55c3c0ed243e2bb65d5efa59e0953', 27, 2, 1, '2019-07-04 18:19:11', '2019-07-04 17:31:10', '2019-07-04 17:31:10');
INSERT INTO `oauth2_access_token` VALUES ('7edfb8fe5b2745faba5e8d58156d0860', 'fcd922f6a60341fe92433023cd13b73a', 27, 2, 1, '2019-05-21 10:55:25', '2019-05-21 10:07:24', '2019-05-21 10:07:24');
INSERT INTO `oauth2_access_token` VALUES ('7ee86c75aaef4bd19a3b525bbf9019eb', 'f6496d8ac5a547639e6441571dcba0e3', 27, 2, 1, '2019-06-06 03:25:59', '2019-06-06 02:37:59', '2019-06-06 02:37:59');
INSERT INTO `oauth2_access_token` VALUES ('7eee13f84c5940269d1f0d69fa9234d4', '20a11d0302504616a902da051efbe950', 1, 1, 1, '2019-05-17 18:34:12', '2019-05-17 17:46:11', '2019-05-17 17:46:11');
INSERT INTO `oauth2_access_token` VALUES ('7ef2b7a2ac9b4244b4ba1299aa90e168', 'c7f28adda4f345b49bf1bdc9d855b9d1', 1, 1, 1, '2019-05-17 01:10:19', '2019-05-17 00:22:18', '2019-05-17 00:22:18');
INSERT INTO `oauth2_access_token` VALUES ('7f015891e74d443bb93aa5730c56644f', '4b9d285d05c649a6b152496a238665d2', 27, 2, 1, '2019-06-05 18:13:45', '2019-06-05 17:25:45', '2019-06-05 17:25:45');
INSERT INTO `oauth2_access_token` VALUES ('7f1423797c3d45a9b6dab70fa7349f07', '7c1a3b6d0c124c94a2167e50f80cf95e', NULL, NULL, 1, '2019-05-05 11:11:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7f216fbe836b44beb3de28fe6c214e42', 'e91489fc12604b62a6213824cfbadf8c', NULL, NULL, 1, '2019-05-09 18:23:05', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7f3b37eb6acc4a80a617ea67bbaa2287', 'a9e179330ca04d49847ae2f40fa2dac7', 27, 2, 1, '2019-09-05 15:29:38', '2019-09-05 14:41:37', '2019-09-05 14:41:37');
INSERT INTO `oauth2_access_token` VALUES ('7f3c6352d27044f08e9ddfc5d3004daa', '5825ca9f20e1452a9b09077e767825f1', 27, 2, 1, '2019-08-31 23:03:50', '2019-08-31 22:15:50', '2019-08-31 22:15:50');
INSERT INTO `oauth2_access_token` VALUES ('7f4d17c174b647bc9ed4affda8c08f11', '81977e0108d84085866b546dee0e6934', 27, 2, 1, '2019-08-01 19:18:22', '2019-08-01 18:30:22', '2019-08-01 18:30:22');
INSERT INTO `oauth2_access_token` VALUES ('7f5ac216496041ec9ed57884133545a0', '42a9f76ca533429f915d3fbf82def31e', NULL, NULL, 1, '2019-03-15 10:59:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('7f73040356af4d5ea6a8a4b7620833be', '896c97c2f33344a388ce72e2da42eb88', 1, 2, 0, '2019-07-03 09:27:55', '2019-07-03 08:39:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('7f7caa6db7114e78967a7be735baa1be', '054840bec4e94998b3884a5c5cf83474', 27, 2, 1, '2019-08-21 00:16:25', '2019-08-20 23:28:24', '2019-08-20 23:28:24');
INSERT INTO `oauth2_access_token` VALUES ('7f85954cb69b4b63992ff2066c99e033', '842e727619ec4274b169ff335d27e235', 27, 2, 1, '2019-05-28 21:15:33', '2019-05-28 20:27:33', '2019-05-28 20:27:33');
INSERT INTO `oauth2_access_token` VALUES ('7f86d9b09fbc45f98f77ed5ea2dc21c4', '7b7a5d13107b4d8fb9ce0ba29345f204', 27, 2, 1, '2019-05-30 10:34:17', '2019-05-30 09:46:16', '2019-05-30 09:46:16');
INSERT INTO `oauth2_access_token` VALUES ('7f8f9e5a665946ad959cd5ffe2cd4964', '73975d4062f643e290cb9251741f372f', 27, 2, 1, '2019-07-11 14:59:10', '2019-07-11 14:11:10', '2019-07-11 14:11:10');
INSERT INTO `oauth2_access_token` VALUES ('7f9078cdc51244edbb94661ca3dd12eb', 'c6c2fa9af67145268a8e0183f99cb286', 27, 2, 1, '2019-07-05 18:36:15', '2019-07-05 17:48:15', '2019-07-05 17:48:15');
INSERT INTO `oauth2_access_token` VALUES ('7f908aa9cffd4f6aa195de4bfe9e4c17', 'b8b7b34481ad4119a06c5f03de50f780', 27, 2, 1, '2019-06-24 21:38:21', '2019-06-24 20:50:20', '2019-06-24 20:50:20');
INSERT INTO `oauth2_access_token` VALUES ('7fad511f34c140bc9ed16918a36e9a87', '8bcc7e90af294430a5a8de16d8fc9d4d', 27, 2, 1, '2019-06-05 12:34:37', '2019-06-05 11:46:37', '2019-06-05 11:46:37');
INSERT INTO `oauth2_access_token` VALUES ('7fb1f163b27744ddb2cd88b7feb952f6', '552ce18445154257aa351cd83a5db183', 27, 2, 1, '2019-05-31 19:25:03', '2019-05-31 18:37:02', '2019-05-31 18:37:02');
INSERT INTO `oauth2_access_token` VALUES ('7fbacd28e92f4a5f8b808f24920c1e71', 'eec5bd3af43344c69dc077712c8721bc', 27, 2, 1, '2019-06-04 11:12:44', '2019-06-04 10:24:44', '2019-06-04 10:24:44');
INSERT INTO `oauth2_access_token` VALUES ('7fc0700523774a7a925fd99afcacedf6', 'd4568135d95c4f94a3873180840987f8', 27, 2, 1, '2019-06-21 17:50:55', '2019-06-21 17:02:54', '2019-06-21 17:02:54');
INSERT INTO `oauth2_access_token` VALUES ('7fe0339cef6b41138fd0a4fc774f0d72', 'e865eac54af94e3a82c8aae79200190c', NULL, NULL, 1, '2019-05-17 00:31:09', NULL, '2019-05-16 23:43:08');
INSERT INTO `oauth2_access_token` VALUES ('7fe1236949994b45b1e85570519843d2', '9b53c143ff3749aba3d730032702d308', 27, 2, 1, '2019-06-20 17:36:28', '2019-06-20 16:48:28', '2019-06-20 16:48:28');
INSERT INTO `oauth2_access_token` VALUES ('7fe46dca096f4131be809632d276457f', '4d6dfc14373c45c4a4ce73e107eca7e4', 27, 2, 1, '2019-07-11 11:51:57', '2019-07-11 11:03:57', '2019-07-11 11:03:57');
INSERT INTO `oauth2_access_token` VALUES ('7ff1fb2a8e994c748ea6b8c721ea18f7', '6572e56e61a743e59f1aa429f1db1e2e', 27, 2, 1, '2019-08-31 18:39:49', '2019-08-31 17:51:48', '2019-08-31 17:51:48');
INSERT INTO `oauth2_access_token` VALUES ('8014961230b349b19eaaf6ccf99fa652', 'e77b039bf7bc4b359ce66cab97899c31', NULL, NULL, 1, '2019-04-03 19:50:50', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('802a80babc11412880c05c67bfebc928', 'cc48508be8bd4197ae818acf9961dc28', 27, 2, 1, '2019-06-18 14:02:35', '2019-06-18 13:14:35', '2019-06-18 13:14:35');
INSERT INTO `oauth2_access_token` VALUES ('80356db792bf43b5af9b9e7bc15c13be', 'c60827a4027e4d99afb1bc966f897dee', NULL, NULL, 1, '2019-05-10 00:52:26', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8036fe7c0f7145cf8f84720ee8aaff7f', 'a0eee55db8d8418bbecf8a37067e17ce', 27, 2, 1, '2019-06-17 15:03:21', '2019-06-17 14:15:20', '2019-06-17 14:15:20');
INSERT INTO `oauth2_access_token` VALUES ('8055ab1b9a1541929c92086d414924f1', '30eac9083715462fbf03cf8b64c6bfc8', 27, 2, 1, '2019-07-29 11:57:40', '2019-07-29 11:09:39', '2019-07-29 11:09:39');
INSERT INTO `oauth2_access_token` VALUES ('805fb5650f5045a7a9df6f11a3b394a7', '4c8f9eebf6df4309918976a4d409bf20', 27, 2, 1, '2019-06-01 21:57:59', '2019-06-01 21:09:58', '2019-06-01 21:09:58');
INSERT INTO `oauth2_access_token` VALUES ('806cc95ead5b4b788fe796079afb806a', 'e67e8fdc60a24a32886b959c9167b2b3', NULL, NULL, 1, '2019-05-06 16:59:16', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('808ba09e463e433489210ef88794560a', '6f3d1c0b44554d7cba7f63115f6264db', NULL, NULL, 1, '2019-05-07 15:26:29', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('809babd8c4ad4ae8b6fd0d6ecb0a66cd', 'f390d49f1af245b5a83f70e536ca2d99', NULL, NULL, 0, '2019-02-28 02:44:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('80a6dc0eddd64b89a0677669a6c1919b', '9f781890daf349f2951e4602f2e54296', 27, 2, 1, '2019-06-06 12:43:06', '2019-06-06 11:55:05', '2019-06-06 11:55:05');
INSERT INTO `oauth2_access_token` VALUES ('80b9c747b6c74f58acc9be1d0b846ab3', '927e861e16644e998bf7d7347b68e555', 27, 2, 1, '2019-07-05 09:55:01', '2019-07-05 09:07:00', '2019-07-05 09:07:00');
INSERT INTO `oauth2_access_token` VALUES ('80bdb0943f774bd4b118a0ff753f72e4', '2da6392d49ee4afaa86a9c59b1fdc846', 27, 2, 1, '2019-07-07 21:42:58', '2019-07-07 20:54:58', '2019-07-07 20:54:58');
INSERT INTO `oauth2_access_token` VALUES ('80d300f380d741f5aa04716a4b59b783', 'baffedb535b74f5e9191e969ea721762', 27, 2, 1, '2019-08-12 12:54:49', '2019-08-12 12:06:48', '2019-08-12 12:06:48');
INSERT INTO `oauth2_access_token` VALUES ('80d61eb2718f4d24a8a18d0bbb6954f8', '413c9ea2a28c4d4599943a39a2d2b7d7', 27, 2, 1, '2019-06-04 10:34:42', '2019-06-04 09:46:41', '2019-06-04 09:46:41');
INSERT INTO `oauth2_access_token` VALUES ('80f3ceafe14f4fa7b453575fac093891', 'bc03e64087b14795a4d53085ef66f664', 27, 2, 1, '2019-06-05 11:38:22', '2019-06-05 10:50:22', '2019-06-05 10:50:22');
INSERT INTO `oauth2_access_token` VALUES ('81112bcc54624f239b2925d87fcd2e70', 'bb6e0c04c41b4da6b8108dd3078893a6', NULL, NULL, 1, '2019-03-31 11:15:37', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8112679bd9b04436a149d4b18ef9f2e9', 'a900f2ac0fc2497eac137ca97866f8c3', NULL, NULL, 1, '2019-05-13 13:24:03', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8116ff58f88d451c8ddffd02dda66d2d', '44c345b96f764da08a80d7228b4f6142', 27, 2, 1, '2019-06-03 18:29:05', '2019-06-03 17:41:05', '2019-06-03 17:41:05');
INSERT INTO `oauth2_access_token` VALUES ('8117b1df43b74225b2ae03d90f52c63e', 'c58b4b80580f42ada9dc2f04fadfb2d3', 27, 2, 1, '2019-06-20 12:07:58', '2019-06-20 11:19:58', '2019-06-20 11:19:58');
INSERT INTO `oauth2_access_token` VALUES ('811ac56563f54ebbac28b515558cbdf4', '96512b295fcc49caa13ddd79711d9c5c', 27, 2, 1, '2019-08-27 16:52:01', '2019-08-27 16:04:01', '2019-08-27 16:04:01');
INSERT INTO `oauth2_access_token` VALUES ('812501f8107044f5a06b08a177f5fab1', 'e52e074a8f904ddd8a590e00291956b3', 27, 2, 1, '2019-08-24 20:08:39', '2019-08-24 19:20:38', '2019-08-24 19:20:38');
INSERT INTO `oauth2_access_token` VALUES ('812dcf6fca114d879fbfdbc39c160966', '3e9177f488ad4d3698682ca6ed384d66', 27, 2, 1, '2019-06-20 09:35:46', '2019-06-20 08:47:45', '2019-06-20 08:47:45');
INSERT INTO `oauth2_access_token` VALUES ('81619d2ad5984fc1b68ee66d9db60e6c', 'b0ecf7b7094b4773a8a441f1627da7dc', NULL, NULL, 1, '2019-03-13 00:46:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('819b92feca0c45fca3fe483c3a106eea', 'c1f8950a3f874a9fbdb3f5adc4ad149c', 27, 2, 1, '2019-05-28 23:52:38', '2019-05-28 23:04:38', '2019-05-28 23:04:38');
INSERT INTO `oauth2_access_token` VALUES ('819c1687b6c94679b22964a6b5d6d1ee', 'bb25c1d229bb43fb9f65bffe40b0e860', NULL, NULL, 0, '2019-02-28 09:48:52', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('81e7f4c5f0f646f9a53e23e46bf35ff2', '305fa32a5cb34bda9da3d156c6635ea7', 27, 2, 1, '2019-07-24 00:14:55', '2019-07-23 23:26:54', '2019-07-23 23:26:54');
INSERT INTO `oauth2_access_token` VALUES ('81ebf7e6d0e64bc6947a758384c1fd08', 'b8c5d01ba32b4cf0a9fe8e4a68a8483f', 1, 2, 0, '2019-05-28 17:10:47', '2019-05-28 16:21:28', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('81f62a223aef40449fce4d2a75c28314', '54b3238440024c7f9d4a857c6aaafb9c', 27, 2, 1, '2019-06-23 22:48:45', '2019-06-23 22:00:45', '2019-06-23 22:00:45');
INSERT INTO `oauth2_access_token` VALUES ('820c74c6015f4492a1d6319a251932ea', 'dcee020127b74f14b829370ee16be15c', NULL, NULL, 1, '2019-04-22 20:30:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('821e8f47f1e842e68b861f70a7d42552', '7ad8767b0a59432299def0ba7689e3cb', 27, 2, 1, '2019-05-25 01:29:33', '2019-05-25 00:41:33', '2019-05-25 00:41:33');
INSERT INTO `oauth2_access_token` VALUES ('8220c5213aa04722ac0b8a2243d18bea', 'fd7c92a5a61341a9b71ed4c973a6fa72', NULL, NULL, 1, '2019-03-10 04:24:25', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('822c30e2dd614bfcb4c0277e72bf0341', '13d21632661944198ca2616b59709eaa', NULL, NULL, 1, '2019-05-10 10:11:24', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('823318f130ce4f9ab4629eaf0f52d4ab', 'c866701de67d487dae819fd4f250125d', 27, 2, 1, '2019-06-10 13:24:16', '2019-06-10 12:36:15', '2019-06-10 12:36:15');
INSERT INTO `oauth2_access_token` VALUES ('824626a3768f4929a777b3b1191bead8', '8be96ee69fdf462ba72fdbea95015042', 27, 2, 1, '2019-08-22 01:17:44', '2019-08-22 00:29:44', '2019-08-22 00:29:44');
INSERT INTO `oauth2_access_token` VALUES ('8248903bca0a493187c01942d8c1cc5d', '93edd627ce3d4f9aaae9b9d761703fe8', 27, 2, 1, '2019-06-07 11:22:33', '2019-06-07 10:34:32', '2019-06-07 10:34:32');
INSERT INTO `oauth2_access_token` VALUES ('827d1347dfd54899b882af8906f1a58c', '790e3b0ce85a4350ab49b86e0ba2832f', NULL, NULL, 1, '2019-04-04 19:09:33', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('82982673d64443608230d11b0239b58d', 'c151fb33b2654d37a642501e6019e9f7', 27, 2, 1, '2019-05-28 09:36:15', '2019-05-28 08:48:14', '2019-05-28 08:48:14');
INSERT INTO `oauth2_access_token` VALUES ('82a467c4b78643a5864d2c2a43fe0f9f', 'b07c7a3905fe4f1f87cc379f084dd30f', 1, 2, 0, '2019-07-02 15:12:46', '2019-07-02 14:24:45', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('82bde6e4421b4e858bcd60aecb251456', '82f7b5cc08ad422e93fcc024bf5ee228', 27, 2, 1, '2019-08-03 22:05:42', '2019-08-03 21:17:42', '2019-08-03 21:17:42');
INSERT INTO `oauth2_access_token` VALUES ('82c087d504bb4f7e8f74b93c10303f41', '64d42ed9ea5f4251abe9a1e2f4e71643', NULL, NULL, 1, '2019-05-05 11:01:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('82d0aacbf6f846c8acc84769da7443b3', 'bf249b412a0442a48838e99c2563e7b8', 27, 2, 1, '2019-09-04 00:57:01', '2019-09-04 00:09:01', '2019-09-04 00:09:01');
INSERT INTO `oauth2_access_token` VALUES ('82d28d500e8e4d87a1b502e3b087bd77', '1479b204eb414aa99a4770d241306384', 27, 2, 1, '2019-06-05 18:38:00', '2019-06-05 17:49:59', '2019-06-05 17:49:59');
INSERT INTO `oauth2_access_token` VALUES ('82fd8c78dd7b4ab1a2bfc76b844eff2c', 'ed68e25a7d0b4dd597be7b4a348aaa26', 27, 2, 1, '2019-05-31 11:05:08', '2019-05-31 10:17:08', '2019-05-31 10:17:08');
INSERT INTO `oauth2_access_token` VALUES ('8302654e1911440e95b8336ad4b9cc23', '8097d2f71cf849e08db2ac4a14b3dece', 27, 2, 1, '2019-06-11 14:47:08', '2019-06-11 13:59:08', '2019-06-11 13:59:08');
INSERT INTO `oauth2_access_token` VALUES ('8318458f448a4c24a221421bf5c3e19c', '07ca08c4b2154bbe9fd12939cd4ab4d3', 27, 2, 1, '2019-06-18 10:25:44', '2019-06-18 09:37:44', '2019-06-18 09:37:44');
INSERT INTO `oauth2_access_token` VALUES ('8327ed17c745495b87d436cdda1f99f3', '3ced85d7b2294ec6b0a121f4a7788dcc', 27, 2, 1, '2019-08-16 11:11:42', '2019-08-16 10:23:41', '2019-08-16 10:23:41');
INSERT INTO `oauth2_access_token` VALUES ('832e5badc66b40ad9a601b95b19084c3', '77ef3f8722114df0b578198ca7326f00', 27, 2, 1, '2019-09-03 18:24:39', '2019-09-03 17:36:39', '2019-09-03 17:36:39');
INSERT INTO `oauth2_access_token` VALUES ('8346f6be0ccb4378af690d88d39ccb44', '04083b80118d451aba4f0aa9b62de7ad', NULL, NULL, 0, '2019-03-05 05:33:37', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('834d4fe70b174691aded5169a792cea6', 'bb1867b57bed4665aad32fb268b41ffd', 27, 2, 1, '2019-07-18 10:27:48', '2019-07-18 09:39:48', '2019-07-18 09:39:48');
INSERT INTO `oauth2_access_token` VALUES ('8353e3c0701147b6ae07b4114a44b77a', 'fd30a7362bf643a8b31951c85ea063b4', 27, 2, 1, '2019-09-08 17:17:04', '2019-09-08 16:29:04', '2019-09-08 16:29:04');
INSERT INTO `oauth2_access_token` VALUES ('835448919fa94b62ba32b7aa7e5a85a9', '65c4b91775f8486ba299fd75518a3583', 27, 2, 1, '2019-05-28 02:49:28', '2019-05-28 02:01:28', '2019-05-28 02:01:28');
INSERT INTO `oauth2_access_token` VALUES ('83598107330a4be28441327dea94264a', '8d99266c2a1d4b5d81999f48eab50e35', 27, 2, 1, '2019-08-07 14:41:40', '2019-08-07 13:53:39', '2019-08-07 13:53:39');
INSERT INTO `oauth2_access_token` VALUES ('836bbe004d9b4d38ac3541904db8a215', 'f29268dad8944a2c87eecc1339f6cab8', 27, 2, 1, '2019-07-15 17:35:52', '2019-07-15 16:47:51', '2019-07-15 16:47:51');
INSERT INTO `oauth2_access_token` VALUES ('838f1c2f3b0c45dfa7452f1b272f3f22', '7c3012f1ed244074b2633d83cbaa3b01', 27, 2, 1, '2019-09-08 20:37:00', '2019-09-08 19:49:00', '2019-09-08 19:49:00');
INSERT INTO `oauth2_access_token` VALUES ('839bf16b66354b55adb7483db9f7faaa', '1f05a8c6a14d4c17a990431982bacbcc', 27, 2, 1, '2019-05-23 23:43:24', '2019-05-23 22:55:24', '2019-05-23 22:55:24');
INSERT INTO `oauth2_access_token` VALUES ('83a124d396704a95bf0e124372a65f07', '8e2b058b8bea44f980abea86de71ea99', 27, 2, 1, '2019-06-29 00:48:11', '2019-06-29 00:00:11', '2019-06-29 00:00:11');
INSERT INTO `oauth2_access_token` VALUES ('83a92a2b164e4027a5425eed7f26854d', 'd693e7c5d0924067a9fb97fe7ea6f611', NULL, NULL, 1, '2019-05-10 21:18:36', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('83aa68c3813c4841a77bcdbdccc266f7', 'a7e8ec4f26e844bea5623e32740e270e', 27, 2, 1, '2019-05-29 18:06:18', '2019-05-29 17:18:18', '2019-05-29 17:18:18');
INSERT INTO `oauth2_access_token` VALUES ('83d839b0b81c4650b5fd5d49f721cc73', '26e3b54e3ff2493e88110d4909fe523b', 27, 2, 1, '2019-06-05 16:26:16', '2019-06-05 15:38:16', '2019-06-05 15:38:16');
INSERT INTO `oauth2_access_token` VALUES ('83ec22a5549942449414cc51108b87ce', '37c96b48d7584faab86ff7ac71375b33', 1, 2, 0, '2019-08-01 15:40:06', '2019-08-01 14:52:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('83eceeae3c934f7faf2e949c4404e2c2', '599235b49cfc47739ca45dac5d7890cc', 27, 2, 1, '2019-07-12 09:46:28', '2019-07-12 08:58:27', '2019-07-12 08:58:27');
INSERT INTO `oauth2_access_token` VALUES ('83f381f0f70345ddbe32da2983e9cbfb', 'dc447e2547f24ba1b4e9914de095a7ff', 27, 2, 1, '2019-08-08 16:19:35', '2019-08-08 15:31:35', '2019-08-08 15:31:35');
INSERT INTO `oauth2_access_token` VALUES ('8418a06f0ae24119bb78cba6d7fd84a1', 'f3804be0e8aa422790ab1a5ca7ca34cb', NULL, NULL, 1, '2019-03-10 11:01:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8425ce2d2993441e8d778a3759dfaeb0', '9a1163f6eced4f9ea3721b71a9b9b3ac', NULL, NULL, 0, '2019-03-06 07:05:40', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('843dba1f0bc042509c96be57a85cf449', '53a7619e43b748499579bb7ce44f236c', 1, 1, 1, '2019-05-17 18:18:56', '2019-05-17 17:30:55', '2019-05-17 17:30:55');
INSERT INTO `oauth2_access_token` VALUES ('845be323f9f148f8a7bc20a4550cdcd7', '26c0c2ac8ab741ad98174a2ce949ea66', 27, 2, 1, '2019-06-24 12:10:01', '2019-06-24 11:22:01', '2019-06-24 11:22:01');
INSERT INTO `oauth2_access_token` VALUES ('84668a2a5a84481196b0fba1d582a1d2', '11585a8922924eefbb61cb10da171f93', 27, 2, 1, '2019-06-02 12:01:28', '2019-06-02 11:13:27', '2019-06-02 11:13:27');
INSERT INTO `oauth2_access_token` VALUES ('848318ad76114187a2bcce65ec83fbc7', '8945373f0f5348d4868f822473b1df38', 153, 1, 1, '2019-09-06 12:28:19', '2019-09-06 11:40:18', '2019-09-06 11:40:18');
INSERT INTO `oauth2_access_token` VALUES ('848c71c218d34262a831262d4ae4c7d8', 'ea1d4ab228354aeabe848cb85083d303', 27, 2, 1, '2019-08-07 16:14:18', '2019-08-07 15:26:18', '2019-08-07 15:26:18');
INSERT INTO `oauth2_access_token` VALUES ('849391e05b664f7d8ec6c369cb110b2d', '145d06a37030411b98cad90a88bb08a2', 27, 2, 1, '2019-06-14 14:29:58', '2019-06-14 13:41:57', '2019-06-14 13:41:57');
INSERT INTO `oauth2_access_token` VALUES ('84962fc1a6564fcea25347d44e9f2ebf', '37145508aac3439e847fc559c1d91771', NULL, NULL, 1, '2019-04-22 20:32:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('849a7a6f25f248f0ba7bbff89141dc29', '3f21a6caa6da48e9bd48cde5c8ee8425', NULL, NULL, 0, '2019-03-05 07:25:52', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('84ac0c52f5cd465e99600b42c2e935b3', '4a37c6b730d9451fab0f3f9dc981b98e', NULL, NULL, 0, '2019-03-03 22:54:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('84aef27d5f6f4bb384807f09a3daa38a', 'cc076ee31ae547868f4cf4887f803434', 27, 2, 1, '2019-07-03 13:08:01', '2019-07-03 12:20:01', '2019-07-03 12:20:01');
INSERT INTO `oauth2_access_token` VALUES ('84c5838b09294c7f9b8b4b5ac196a709', '289a719aeab74b93adc730bddfa50007', 27, 2, 1, '2019-07-31 11:33:36', '2019-07-31 10:45:36', '2019-07-31 10:45:36');
INSERT INTO `oauth2_access_token` VALUES ('84d18696c4964e518a1ba87aabec687d', '0b8f477262954bbfbb25d86eb8e51344', 27, 2, 1, '2019-06-28 16:46:23', '2019-06-28 15:58:22', '2019-06-28 15:58:22');
INSERT INTO `oauth2_access_token` VALUES ('851bef21309346a5a036fc1f79629d1e', '58dd731f8a9e45e19f6945cba4f2e6a1', 27, 2, 1, '2019-06-02 17:06:52', '2019-06-02 16:18:51', '2019-06-02 16:18:51');
INSERT INTO `oauth2_access_token` VALUES ('852ea76ab09a4ef4a9aaee72c58db5f8', 'dc3890d432cd45d6a398dc214e0bb9c0', 27, 2, 1, '2019-06-06 12:27:35', '2019-06-06 11:39:35', '2019-06-06 11:39:35');
INSERT INTO `oauth2_access_token` VALUES ('853866a04b3e4560bf0f76e19aa978a9', '0b861323c3bb4637b9dc7846110a96d6', 27, 2, 1, '2019-08-10 16:35:34', '2019-08-10 15:47:34', '2019-08-10 15:47:34');
INSERT INTO `oauth2_access_token` VALUES ('8546e7fb4b2a42caaf2817835bacac00', '86f21b1c903a464cb857b0aee76229a2', 27, 2, 1, '2019-06-03 12:04:50', '2019-06-03 11:16:50', '2019-06-03 11:16:50');
INSERT INTO `oauth2_access_token` VALUES ('854a78dd05154641982b2ea7a9e73743', '49f3173b68de44a1b0f3dbd5fe26b61a', 27, 2, 1, '2019-08-20 18:55:29', '2019-08-20 18:07:29', '2019-08-20 18:07:29');
INSERT INTO `oauth2_access_token` VALUES ('855bb3ffbdcf4916963e397ba3851f33', '2a39bb38a4394f9ab02153f875dbc51a', 27, 2, 1, '2019-06-05 16:07:45', '2019-06-05 15:19:45', '2019-06-05 15:19:45');
INSERT INTO `oauth2_access_token` VALUES ('856454f972274dcb80fe545bb895bf1d', '793e15d4488b461caee851aeb0a7d987', 27, 2, 1, '2019-06-17 11:13:03', '2019-06-17 10:25:02', '2019-06-17 10:25:02');
INSERT INTO `oauth2_access_token` VALUES ('856ae7f264244c84843032efd88582db', 'd58e44f8ccb04866be1cbeaeaf429e55', 27, 2, 1, '2019-09-05 10:01:31', '2019-09-05 09:13:31', '2019-09-05 09:13:31');
INSERT INTO `oauth2_access_token` VALUES ('85e44aea90fa40219970a1c749d31cf6', '2684c26fb8f14ebdb3fc7a0bebc2de6d', 27, 2, 1, '2019-06-13 17:33:37', '2019-06-13 16:45:37', '2019-06-13 16:45:37');
INSERT INTO `oauth2_access_token` VALUES ('85e47c73e7f94a589367fdc271134546', 'f4d0e487cd5e416aa34b70a1516f1c6f', 27, 2, 1, '2019-06-03 16:49:22', '2019-06-03 16:01:22', '2019-06-03 16:01:22');
INSERT INTO `oauth2_access_token` VALUES ('85ff179bf0b148989541460f89dac4d3', 'f0f70e95f0114a74b33874dd1946a0e4', 27, 2, 1, '2019-06-08 22:59:55', '2019-06-08 22:11:54', '2019-06-08 22:11:54');
INSERT INTO `oauth2_access_token` VALUES ('8602351266eb4ada9ee7092bed6f1dc7', '9e66ac64ebf64d20853413c73e372e92', 27, 2, 1, '2019-07-17 09:53:37', '2019-07-17 09:05:37', '2019-07-17 09:05:37');
INSERT INTO `oauth2_access_token` VALUES ('86169778c44b41b68aa4d1ade1dbd254', '195009b8006947bf840e2281d0dc1632', 27, 2, 1, '2019-07-18 17:55:47', '2019-07-18 17:07:47', '2019-07-18 17:07:47');
INSERT INTO `oauth2_access_token` VALUES ('862d1a9870b64e67b19286d72cdeca34', 'e90bbc21de88486fb41989c132f26a89', 1, 2, 0, '2019-05-16 16:12:22', '2019-05-16 15:24:25', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('8641fc36b932449da35fe5b427d6dcf5', '1357edea4dea4653876fe52abd31ecad', 27, 2, 1, '2019-07-17 16:39:50', '2019-07-17 15:51:50', '2019-07-17 15:51:50');
INSERT INTO `oauth2_access_token` VALUES ('864f5c6ffd6e41f5a7b455e41a8b39bc', 'f109dfb5263041fb9ec6a70128a2bdad', 130, 1, 0, '2019-06-21 12:39:25', '2019-06-21 11:51:24', '2019-06-21 13:58:17');
INSERT INTO `oauth2_access_token` VALUES ('8673108910034560af147f857ddabfee', '3aca81b60a45461398dc075536b5dc71', 27, 2, 1, '2019-07-15 15:31:26', '2019-07-15 14:43:26', '2019-07-15 14:43:26');
INSERT INTO `oauth2_access_token` VALUES ('86859daad1c14ae7a9d6c151acf0cfd6', 'fae461cc765b47fdbfdb7255aaf763bb', 27, 2, 1, '2019-08-25 13:26:54', '2019-08-25 12:38:53', '2019-08-25 12:38:53');
INSERT INTO `oauth2_access_token` VALUES ('8685b1c372fe4c118b3a3c9096ff8284', '433385e8c0f24ca1bc14e8ee4701a1d6', 197, 1, 1, '2019-08-12 18:20:39', '2019-08-12 17:32:39', '2019-08-12 17:32:39');
INSERT INTO `oauth2_access_token` VALUES ('8687b9fed6e04f9b9ed3bf18284ca63c', '129cedb335624c069503477ddd7abf61', 27, 2, 1, '2019-08-21 17:49:48', '2019-08-21 17:01:48', '2019-08-21 17:01:48');
INSERT INTO `oauth2_access_token` VALUES ('868ae7ffd2414ea592916ae00fce1694', 'a5e9470aa62f476b9c3b646a5f834753', 27, 2, 1, '2019-08-02 16:56:47', '2019-08-02 16:08:46', '2019-08-02 16:08:46');
INSERT INTO `oauth2_access_token` VALUES ('8698eb427a0a4c5da2ca8d6d6c66f2a5', '6fe0e28dc9e944be9c736f492257e286', 27, 2, 1, '2019-06-02 18:33:41', '2019-06-02 17:45:40', '2019-06-02 17:45:40');
INSERT INTO `oauth2_access_token` VALUES ('86b9a767208c44569ebf75e0aa3a6341', '95d18155c87a418688c4f5388daf55ad', 27, 2, 1, '2019-06-04 15:11:57', '2019-06-04 14:23:57', '2019-06-04 14:23:57');
INSERT INTO `oauth2_access_token` VALUES ('86c6d258168f47b588994bf0759b8f01', 'a04e690312ef49f48466545f9ec46a29', 27, 2, 1, '2019-07-15 12:13:34', '2019-07-15 11:25:34', '2019-07-15 11:25:34');
INSERT INTO `oauth2_access_token` VALUES ('86c81b6f64d443569c878a7b17a92bc0', '7181a21dd2fb446f8731fab33b0a361b', 27, 2, 1, '2019-08-06 10:56:11', '2019-08-06 10:08:11', '2019-08-06 10:08:11');
INSERT INTO `oauth2_access_token` VALUES ('86c976b93cbd4a7da6d89298a083cd3c', '3e065cbe32464a4892e22ddfdfaef8ce', NULL, NULL, 1, '2019-04-01 23:19:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('86ca648d0aa94c8fb0bec02d0125c715', 'e357353e345a47f8b68c43b2738fae32', 27, 2, 1, '2019-08-17 14:22:07', '2019-08-17 13:34:06', '2019-08-17 13:34:06');
INSERT INTO `oauth2_access_token` VALUES ('86d3cc08711646c982649ee51584f6de', 'a0bb1538d3a247ab98175a854f2e0790', 30, 1, 1, '2019-07-08 18:10:10', '2019-07-08 17:22:10', '2019-07-08 17:22:10');
INSERT INTO `oauth2_access_token` VALUES ('86e3751a14ff4c639a782e55a57d74fd', '91c277776d5b41c081ef26f1ec8f9d5a', 27, 2, 1, '2019-07-25 10:34:08', '2019-07-25 09:46:07', '2019-07-25 09:46:07');
INSERT INTO `oauth2_access_token` VALUES ('86f482f0eefc41138629243292c0ac45', '5992295349de478a95dd09c82e0de12e', 165, 1, 1, '2019-07-10 20:30:32', '2019-07-10 19:42:32', '2019-07-10 19:42:32');
INSERT INTO `oauth2_access_token` VALUES ('86f4ce2ce5754b83ab1046b674f97690', '39d67485a9af4ea8b0934ae1cad2963b', 1, 2, 0, '2019-08-31 23:07:11', '2019-08-31 22:19:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('8700369e0e944935b4fc90f1282347f7', '360667b798f848ba9f1d25473f6b9de3', 27, 2, 1, '2019-06-02 14:31:17', '2019-06-02 13:43:17', '2019-06-02 13:43:17');
INSERT INTO `oauth2_access_token` VALUES ('8722c9174ca94e608f6c02e635ac0c5a', '6795305cb3854bb1ba0eb4bb49a68025', 27, 2, 1, '2019-06-13 16:25:50', '2019-06-13 15:37:50', '2019-06-13 15:37:50');
INSERT INTO `oauth2_access_token` VALUES ('874a93b7a9ab42e7af430cdb7b74ef23', '1fbc4550443945ab9786df843735c3fc', 27, 2, 1, '2019-06-02 18:25:34', '2019-06-02 17:37:33', '2019-06-02 17:37:33');
INSERT INTO `oauth2_access_token` VALUES ('87679a2fe5604fd98ca5a03fcc0a4703', 'e352404f0841420daa654e9925899a42', NULL, NULL, 1, '2019-04-06 01:55:01', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('87687976088c48b5afdd29c7f7807f2c', '445e333b48734330a18b02f2c8a94549', 27, 2, 1, '2019-05-30 09:38:35', '2019-05-30 08:50:35', '2019-05-30 08:50:35');
INSERT INTO `oauth2_access_token` VALUES ('876e394ad23343a3a4ac31384f1da9f7', 'eaa1bab963b740a2b274c672160496b8', 27, 2, 1, '2019-06-13 13:47:13', '2019-06-13 12:59:13', '2019-06-13 12:59:13');
INSERT INTO `oauth2_access_token` VALUES ('877bb4eb9e7849609c79c689899af116', 'd02c29445da04e60aaa036b9c3d8106c', 27, 2, 1, '2019-08-20 14:43:53', '2019-08-20 13:55:52', '2019-08-20 13:55:52');
INSERT INTO `oauth2_access_token` VALUES ('87874cbf4cbb4bdd81022b41e82d983b', 'fb34d1c95416427cb453f3a8cc472d65', 27, 2, 1, '2019-07-03 09:27:59', '2019-07-03 08:39:58', '2019-07-03 08:39:58');
INSERT INTO `oauth2_access_token` VALUES ('878cb1af75884ce9934c18916cd4d419', 'd235d49c00974e7b929411466996c855', NULL, NULL, 1, '2019-03-12 20:32:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('87940eb9297d4ef685319a106cbc8d45', '58ed422ecfcb4bada08862bac02fe0bc', 27, 2, 1, '2019-07-22 11:53:09', '2019-07-22 11:05:08', '2019-07-22 11:05:08');
INSERT INTO `oauth2_access_token` VALUES ('8794f3cb66764c9692bc466dedc9dd61', 'b1b903e9a8704c4faa1ce768774c2c56', 27, 2, 1, '2019-07-18 11:23:27', '2019-07-18 10:35:27', '2019-07-18 10:35:27');
INSERT INTO `oauth2_access_token` VALUES ('87961dd617434a44bac8f6a7a3decfd6', 'cdd7ed2ba23c43bb9344b2e6faaf26ba', NULL, NULL, 0, '2019-03-01 05:09:06', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('879fd833611945ad9ec8f724500b60d0', 'cf01002ea60548bfaacffd0b29207a58', NULL, NULL, 1, '2019-04-06 13:41:09', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('87a72a503ff3458588c07120974031cc', '69a8f1a988da4a2484a92f4ad67f767e', 27, 2, 1, '2019-08-19 11:18:18', '2019-08-19 10:30:17', '2019-08-19 10:30:17');
INSERT INTO `oauth2_access_token` VALUES ('87abac96d84643279c0c3e752337d313', 'a861eae02d6147ef9853cd64fb7afd7d', 14, 2, 1, '2019-06-11 22:46:44', '2019-06-11 21:58:44', '2019-06-11 21:58:44');
INSERT INTO `oauth2_access_token` VALUES ('87bde0811ebc4508a6a213bdfec9df6d', 'ad243c42f88c48f3af25d1950c5d9a9b', 27, 2, 1, '2019-06-04 11:12:36', '2019-06-04 10:24:35', '2019-06-04 10:24:35');
INSERT INTO `oauth2_access_token` VALUES ('87c4b7a0fd4b499180a4750b3d3e5a5a', 'd0a2dd29503845508b15edd4531e5989', 27, 2, 1, '2019-06-16 00:22:46', '2019-06-15 23:34:45', '2019-06-15 23:34:45');
INSERT INTO `oauth2_access_token` VALUES ('87ca3c01ce9e44cd85bbe48b84da6c53', '65be9981b44c41eda2af32a5b7ef30cc', 27, 2, 1, '2019-07-24 14:41:53', '2019-07-24 13:53:53', '2019-07-24 13:53:53');
INSERT INTO `oauth2_access_token` VALUES ('87ef9d8ca7ec48c3852aea7fc0e8f216', 'e55811f00b264dfc8e9cef76f54a73ed', 27, 2, 1, '2019-09-06 16:21:45', '2019-09-06 15:33:45', '2019-09-06 15:33:45');
INSERT INTO `oauth2_access_token` VALUES ('87f46b69be28418aa7aed690ead8bc88', 'f809da42bcda4d96834c4f24d0b41152', 27, 2, 1, '2019-08-20 00:12:10', '2019-08-19 23:24:09', '2019-08-19 23:24:09');
INSERT INTO `oauth2_access_token` VALUES ('87f4a483823f47b6b8701db74e8ee3ee', '70a7787a7ad444728954d6fedb7e29ac', 27, 2, 1, '2019-06-27 12:13:21', '2019-06-27 11:25:20', '2019-06-27 11:25:20');
INSERT INTO `oauth2_access_token` VALUES ('87ff1d47c0f04569bb7b1830ee0fc8d0', '42716096f92d4198ac69e0134985188f', 27, 2, 1, '2019-06-03 10:37:38', '2019-06-03 09:49:38', '2019-06-03 09:49:38');
INSERT INTO `oauth2_access_token` VALUES ('8820fd72a32747ff8f36fc349396027d', '7d45220f61ad4a3f9fe23734241e0717', 27, 2, 1, '2019-06-02 16:43:10', '2019-06-02 15:55:09', '2019-06-02 15:55:09');
INSERT INTO `oauth2_access_token` VALUES ('882cfee812c24001905743947e0f7748', '64684eb884eb4332b364fb35647599a2', 27, 2, 1, '2019-08-21 10:32:45', '2019-08-21 09:44:45', '2019-08-21 09:44:45');
INSERT INTO `oauth2_access_token` VALUES ('88321afad9514c8492f9abe4c9ac3560', '09366fec7a9742a6a89d01f3d44601e4', 27, 2, 1, '2019-05-23 12:19:30', '2019-05-23 11:31:29', '2019-05-23 11:31:29');
INSERT INTO `oauth2_access_token` VALUES ('885601e2d86d43d58d75e0c6e2f1096e', 'b5ff33f75629495b8aedb9ae27dfa04e', 105, 1, 1, '2019-06-04 17:19:46', '2019-06-04 16:31:46', '2019-06-04 16:31:46');
INSERT INTO `oauth2_access_token` VALUES ('8861c99a28844ff09f344e4e16e02340', '599e4d639b8c45cfa131f859f2efa3a0', 27, 2, 1, '2019-06-03 09:54:41', '2019-06-03 09:06:41', '2019-06-03 09:06:41');
INSERT INTO `oauth2_access_token` VALUES ('887d5f7229544005b3438babf592ddca', 'a4ca7d84185149a0949781571aa2894a', NULL, NULL, 1, '2019-04-04 19:09:34', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('888afde38ff444a8aad52e55387dec00', '75339653855244f3b5c92dadae74a6f8', 27, 2, 1, '2019-08-21 17:42:55', '2019-08-21 16:54:55', '2019-08-21 16:54:55');
INSERT INTO `oauth2_access_token` VALUES ('8897197aa0be4abca7a55dd382b4d02f', '770f169e42054846bcdd8ef3251c8943', 27, 2, 1, '2019-07-05 12:25:21', '2019-07-05 11:37:21', '2019-07-05 11:37:21');
INSERT INTO `oauth2_access_token` VALUES ('88994bb40ae645f8b4ba27f36e264112', '53ef089b0ffb4b5eb96eeb9d52ab9809', 27, 2, 1, '2019-07-16 19:21:27', '2019-07-16 18:33:27', '2019-07-16 18:33:27');
INSERT INTO `oauth2_access_token` VALUES ('88d1a727165643cda5c09e2d964dadae', '06143ea19f694bc2b2e2e190964ee50f', 27, 2, 1, '2019-05-24 15:13:33', '2019-05-24 14:25:33', '2019-05-24 14:25:33');
INSERT INTO `oauth2_access_token` VALUES ('88d3ea83f5fd40a889110feaed8f8a54', '3c80a09c539d4c97b0e5f81aa4c39349', 27, 2, 1, '2019-06-18 16:14:40', '2019-06-18 15:26:40', '2019-06-18 15:26:40');
INSERT INTO `oauth2_access_token` VALUES ('88d7164fdc384b96971c96f4050ccac3', '77edfc55ba2a4e8eae3e55ada3440ecf', NULL, NULL, 1, '2019-05-07 17:13:07', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('88da2ef08a834318b9f30696b8ad3a35', 'e9a7656bc2f341ccb5f8752c36167b7a', 27, 2, 1, '2019-06-23 15:16:04', '2019-06-23 14:28:03', '2019-06-23 14:28:03');
INSERT INTO `oauth2_access_token` VALUES ('88e812890eef4327b12c6301be4ace28', 'dd548b8fd6ec4d378b254c5aa75960f0', 27, 2, 1, '2019-06-25 15:08:32', '2019-06-25 14:20:31', '2019-06-25 14:20:31');
INSERT INTO `oauth2_access_token` VALUES ('88e9f26a7dbb473a91536e4b23c58ab8', '07826e3aac124ab58b4f373c2bd741c8', 27, 2, 1, '2019-08-27 09:05:37', '2019-08-27 08:17:36', '2019-08-27 08:17:36');
INSERT INTO `oauth2_access_token` VALUES ('892d83dfdd194133808e4a2fd520e7f6', 'f60a6054c5d247cca2461d5fc7a57183', 27, 2, 1, '2019-06-18 02:05:00', '2019-06-18 01:16:59', '2019-06-18 01:16:59');
INSERT INTO `oauth2_access_token` VALUES ('892f246369f64bde8494e1e10023d89f', '4819e2f35f064bf7b0bc8476c248c6e3', 27, 2, 1, '2019-07-26 17:32:16', '2019-07-26 16:44:16', '2019-07-26 16:44:16');
INSERT INTO `oauth2_access_token` VALUES ('893475a3c6ed4784abefa6b6a237b17e', '4ad0d078c3634cc9ae32204ed5f48671', 27, 2, 1, '2019-06-19 16:59:03', '2019-06-19 16:11:03', '2019-06-19 16:11:03');
INSERT INTO `oauth2_access_token` VALUES ('8958bee84db84d5b97654d30066acd2f', '5d47b7b80abf407f8ef11f792f103fe1', 160, 1, 0, '2019-07-08 17:41:51', '2019-07-08 16:53:50', '2019-07-08 17:44:49');
INSERT INTO `oauth2_access_token` VALUES ('897424b505854f78946de929f5c63e10', '82e456d114a24b1f8f7df1a1e507bcca', 27, 2, 1, '2019-08-03 14:46:59', '2019-08-03 13:58:58', '2019-08-03 13:58:58');
INSERT INTO `oauth2_access_token` VALUES ('897a72f5a5884ffdb7e168efeac8343e', '53c1245f4d854ac1835b18ba66170e22', 27, 2, 1, '2019-09-04 17:23:55', '2019-09-04 16:35:55', '2019-09-04 16:35:55');
INSERT INTO `oauth2_access_token` VALUES ('897ba2bbc55a4b7291cd7f4403018023', '7323f5f609c24e1bb933c4dd31cb7c17', 129, 1, 1, '2019-07-01 10:39:24', '2019-07-01 09:51:24', '2019-07-01 09:51:24');
INSERT INTO `oauth2_access_token` VALUES ('8982a166b32f47a58eebed0c1a4bf577', 'd5c15b12c59b470393bade100411e7dc', 27, 2, 1, '2019-06-20 13:20:17', '2019-06-20 12:32:16', '2019-06-20 12:32:16');
INSERT INTO `oauth2_access_token` VALUES ('8987505b4ada4d409f5b02780616af0e', 'c4f62ca0170b4067a954d1550f8ee67e', NULL, NULL, 1, '2019-04-22 19:13:31', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8989f09eb0a247af83ad8bbd1dd01fa3', '93a5a1f828894592ae4e40c9b94a95ff', 1, 2, 0, '2019-05-31 23:42:25', '2019-05-31 22:54:25', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('8991c330284a41e2883199b9a2486076', '14e04fb4c3824a46abccbd3f79ad35d0', 117, 1, 1, '2019-06-11 15:46:04', '2019-06-11 14:58:04', '2019-06-11 14:58:04');
INSERT INTO `oauth2_access_token` VALUES ('89940507b5174a9d8376466af5ee86ef', 'e65d3fa5413c47c99c80fb9dc042401a', 27, 2, 1, '2019-06-10 21:56:33', '2019-06-10 21:08:32', '2019-06-10 21:08:32');
INSERT INTO `oauth2_access_token` VALUES ('89b23c8f2ad14e43a32eb9d7e7b0d031', '8724495496f84303bc9961103f3ef410', 27, 2, 1, '2019-05-31 22:29:15', '2019-05-31 21:41:14', '2019-05-31 21:41:14');
INSERT INTO `oauth2_access_token` VALUES ('89c1123d5e4642579c4a9f10f4c575b7', 'a4388dbacb274bf0ae72d4f88350d4dd', NULL, NULL, 1, '2019-05-11 23:16:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('89c1921304ef4824ae0d7376ad38cd1a', '552723b319cb4bdabbc1713ed27c3601', 27, 2, 1, '2019-06-30 18:31:20', '2019-06-30 17:43:20', '2019-06-30 17:43:20');
INSERT INTO `oauth2_access_token` VALUES ('89d40bc5cc704e8bba63a9df437a42dc', 'acb025164c1d4c0aa63d512a1c2322e8', 27, 2, 1, '2019-08-02 23:56:34', '2019-08-02 23:08:33', '2019-08-02 23:08:33');
INSERT INTO `oauth2_access_token` VALUES ('89e8a2a738e74275b2e77761e0eb4abd', 'd8f9910398e947f0aa9d6dd179c91282', 27, 2, 1, '2019-07-24 15:23:07', '2019-07-24 14:35:07', '2019-07-24 14:35:07');
INSERT INTO `oauth2_access_token` VALUES ('89e960038dc94be9a0598d4b40a21a9d', '276dfecc04b44981b0d695909dfcd16f', 87, 1, 0, '2019-05-28 17:06:00', '2019-05-28 16:18:02', '2019-05-28 20:59:24');
INSERT INTO `oauth2_access_token` VALUES ('89fc671a4d654c4985c01aef39df02a3', 'c9295a36890f445ba724729b1ab9c6d3', 27, 2, 1, '2019-05-30 10:08:51', '2019-05-30 09:20:50', '2019-05-30 09:20:50');
INSERT INTO `oauth2_access_token` VALUES ('8a013f3ffe354a30883422e1a0c3f2ab', '04c3a9f6d02245e38250d3802ebeb34f', 27, 2, 1, '2019-06-19 15:43:29', '2019-06-19 14:55:28', '2019-06-19 14:55:28');
INSERT INTO `oauth2_access_token` VALUES ('8a03b9f6bbcc41b8b70d48c3c732dd5a', '538ae561c2654ccdb904c425867c0253', NULL, NULL, 1, '2019-04-24 19:31:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8a1459719c914729addb60eabe930663', '35bcbeeb32df4da3928166ec03364165', 27, 2, 1, '2019-07-09 20:22:01', '2019-07-09 19:34:00', '2019-07-09 19:34:00');
INSERT INTO `oauth2_access_token` VALUES ('8a247ca9301a440ebfd40bcf0a0a24ca', '858850c8614b45e9b9c04c26e5ee34a7', 27, 2, 1, '2019-07-17 15:51:43', '2019-07-17 15:03:42', '2019-07-17 15:03:42');
INSERT INTO `oauth2_access_token` VALUES ('8a2681626b8743a292a8226ff941941b', 'c701201fdfe343f299189970a7272dc4', 27, 2, 1, '2019-09-05 14:45:16', '2019-09-05 13:57:15', '2019-09-05 13:57:15');
INSERT INTO `oauth2_access_token` VALUES ('8a2cab793f404f299d6b9dcf809ded57', '9128cde37fa84073a2c614e45bb29343', 27, 2, 1, '2019-07-31 20:07:32', '2019-07-31 19:19:31', '2019-07-31 19:19:31');
INSERT INTO `oauth2_access_token` VALUES ('8a4f139fe4ab4fc99580ef0a81c79efa', '27c166e45f514945a6f885de46315ac8', 1, 2, 0, '2019-06-04 11:44:15', '2019-06-04 10:56:14', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('8a4f3710d6d042b5b632178086834104', 'c908d40a475349908f752f4820aa9eaa', 1, 2, 0, '2019-06-01 09:53:20', '2019-06-01 09:05:19', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('8a5ee6cfa7104c97bd950ecd134c1230', 'e39286d2b753480899f3eef77d1b6a5b', 27, 2, 1, '2019-06-23 03:48:33', '2019-06-23 03:00:32', '2019-06-23 03:00:32');
INSERT INTO `oauth2_access_token` VALUES ('8a614c229fbd459289422176f35e897b', 'f1e3a30776424f4fbf87fad9b21e44dd', 27, 2, 1, '2019-08-13 14:56:34', '2019-08-13 14:08:33', '2019-08-13 14:08:33');
INSERT INTO `oauth2_access_token` VALUES ('8a6c162ebd4d41a1a79ff9e16ba5b54a', '8d36629e61244220b0db09aade146269', 27, 2, 1, '2019-08-10 17:55:14', '2019-08-10 17:07:13', '2019-08-10 17:07:13');
INSERT INTO `oauth2_access_token` VALUES ('8a77695b85804ac1801949ffedab3d85', '881fb0832784465ba5aca2965ba67c04', 27, 2, 1, '2019-08-06 15:13:37', '2019-08-06 14:25:36', '2019-08-06 14:25:36');
INSERT INTO `oauth2_access_token` VALUES ('8a895b1fc06447d5964dfdb541394624', '9f2424ad94cb4aeeafc355944bb7c535', 27, 2, 1, '2019-06-15 10:50:22', '2019-06-15 10:02:21', '2019-06-15 10:02:21');
INSERT INTO `oauth2_access_token` VALUES ('8a8dc577a33c4bc889d0716e300d2292', '1694da346b2a4d908084134002040cc4', 27, 2, 1, '2019-08-14 17:39:50', '2019-08-14 16:51:49', '2019-08-14 16:51:49');
INSERT INTO `oauth2_access_token` VALUES ('8a9630ffab35455db2a5c3ffbbc99856', 'df5895cef8364fb894513dabde041983', 27, 2, 1, '2019-07-17 10:53:05', '2019-07-17 10:05:04', '2019-07-17 10:05:04');
INSERT INTO `oauth2_access_token` VALUES ('8a98f999f577449e9dcbd5243882e0bb', '9aeada4f8f7d448dac8fc6ff3ce700ca', 27, 2, 1, '2019-07-04 10:22:19', '2019-07-04 09:34:19', '2019-07-04 09:34:19');
INSERT INTO `oauth2_access_token` VALUES ('8aa6079268964e1eb569a85f2c29d013', '93fe8a92bb8440e494f0a410710ed556', 27, 2, 1, '2019-06-16 20:17:29', '2019-06-16 19:29:29', '2019-06-16 19:29:29');
INSERT INTO `oauth2_access_token` VALUES ('8abbd4f80ca349c9b5499aa520938eab', '107c407609ae4dce9ef43c28de02066e', 27, 2, 1, '2019-07-03 10:31:15', '2019-07-03 09:43:15', '2019-07-03 09:43:15');
INSERT INTO `oauth2_access_token` VALUES ('8acb243da1a84b88994381401e0c231b', 'b9e7197ac64941b09bbf0c348095f8e4', 27, 2, 1, '2019-08-29 16:31:02', '2019-08-29 15:43:02', '2019-08-29 15:43:02');
INSERT INTO `oauth2_access_token` VALUES ('8af50d58b38c4e6499806195d0ec346b', 'b48cd8184c554ae194197021205d7e00', 27, 2, 1, '2019-06-26 11:52:06', '2019-06-26 11:04:05', '2019-06-26 11:04:05');
INSERT INTO `oauth2_access_token` VALUES ('8b0544d7498449049e56828bb08c2186', 'ff7a828ffc61460c939b6d17b98d2233', 27, 2, 1, '2019-08-19 17:21:46', '2019-08-19 16:33:46', '2019-08-19 16:33:46');
INSERT INTO `oauth2_access_token` VALUES ('8b0e7f27a59a4d7892c5a10d048c1df3', '9daa1610023745d9abbd197af5cc93b0', 27, 2, 1, '2019-06-19 10:58:36', '2019-06-19 10:10:35', '2019-06-19 10:10:35');
INSERT INTO `oauth2_access_token` VALUES ('8b2b3f633c584c04aed2e83187313452', 'fe20bd72f32d4bf49fad2f5b725ae0c2', NULL, NULL, 1, '2019-03-10 03:14:07', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8b4d7e1b2b2b4ebb806265860b493901', 'fcbea7ed0ae9421f924d76e4c3a41ed0', 27, 2, 1, '2019-05-30 11:16:24', '2019-05-30 10:28:24', '2019-05-30 10:28:24');
INSERT INTO `oauth2_access_token` VALUES ('8b81caad064c48ce96f76035c73cee81', 'f5d8df4be8c342f7b61358eddb05c7c0', 27, 2, 1, '2019-07-31 15:39:20', '2019-07-31 14:51:19', '2019-07-31 14:51:19');
INSERT INTO `oauth2_access_token` VALUES ('8b894aa5c8f646d0a8750cc8bb09d54d', '9f00df127f9d441eb54085c58b465334', 27, 2, 1, '2019-06-01 14:05:08', '2019-06-01 13:17:07', '2019-06-01 13:17:07');
INSERT INTO `oauth2_access_token` VALUES ('8b8db7f63a474a0f81e116877bac9a97', '139b65667153491bb2e3710dbaaa1fee', 27, 2, 1, '2019-06-03 18:07:52', '2019-06-03 17:19:52', '2019-06-03 17:19:52');
INSERT INTO `oauth2_access_token` VALUES ('8b8f2fc93a2d4845819917beb1e02a56', '6a92d32ca02c410690327dc60337b46a', 27, 2, 1, '2019-06-10 15:42:55', '2019-06-10 14:54:54', '2019-06-10 14:54:54');
INSERT INTO `oauth2_access_token` VALUES ('8b8feaef63194d499350229b91659c98', '95c16668d8404edfb9b33b08a6527a17', 27, 2, 1, '2019-06-21 09:32:50', '2019-06-21 08:44:50', '2019-06-21 08:44:50');
INSERT INTO `oauth2_access_token` VALUES ('8b9630ca420648bd8230a84772d224d5', 'e002ff1dd2b845678eb4bbad0ea2648f', 27, 2, 1, '2019-07-12 21:58:13', '2019-07-12 21:10:12', '2019-07-12 21:10:12');
INSERT INTO `oauth2_access_token` VALUES ('8b99a667e38d4b98a5dffc00a0b7731d', 'da639db8f6d34116b08c455b5fb2e921', 27, 2, 1, '2019-08-08 14:58:37', '2019-08-08 14:10:37', '2019-08-08 14:10:37');
INSERT INTO `oauth2_access_token` VALUES ('8b9d7e00d0c84399a6e5de890dfd27eb', '2cea876c8901470bb3de4733cf2600e5', 27, 2, 1, '2019-06-02 11:55:34', '2019-06-02 11:07:33', '2019-06-02 11:07:33');
INSERT INTO `oauth2_access_token` VALUES ('8b9d89b0500d4499af6dc6c45bd20e75', '0ff25f16440547b7b7e0915eeb51be31', 27, 2, 1, '2019-06-05 10:44:37', '2019-06-05 09:56:37', '2019-06-05 09:56:37');
INSERT INTO `oauth2_access_token` VALUES ('8ba73fc9e27d4cbea95985083b056dac', '9dda4b286a7f4470a5beed4e19936463', 27, 2, 1, '2019-06-11 14:46:59', '2019-06-11 13:58:59', '2019-06-11 13:58:59');
INSERT INTO `oauth2_access_token` VALUES ('8bb1ff95a8ac4fc8a599e7d89d4af2b4', 'c605b7daf43847b3ad00b4f9c024d79f', 27, 2, 1, '2019-07-11 16:44:36', '2019-07-11 15:56:36', '2019-07-11 15:56:36');
INSERT INTO `oauth2_access_token` VALUES ('8bd813abfca44ee69e84817372f174b6', 'f0f6f42c465d4195a18664532e973f17', 27, 2, 1, '2019-08-07 14:28:49', '2019-08-07 13:40:49', '2019-08-07 13:40:49');
INSERT INTO `oauth2_access_token` VALUES ('8be1f2caf92a43a38508d1cab4cc696d', 'a6253540f86e4aeaaa28b6fab2391162', 108, 1, 1, '2019-06-05 10:19:39', '2019-06-05 09:31:39', '2019-06-05 09:31:39');
INSERT INTO `oauth2_access_token` VALUES ('8bf2351f536a490eb81e0c1e91ecb76e', 'c429f21f1df146cd828bceca58396071', 27, 2, 1, '2019-06-03 16:26:59', '2019-06-03 15:38:58', '2019-06-03 15:38:58');
INSERT INTO `oauth2_access_token` VALUES ('8c009f9d09294bb88935a76cb5302a49', 'ce923dec19a84b838672d8f650ecf251', 27, 2, 1, '2019-06-06 17:08:05', '2019-06-06 16:20:05', '2019-06-06 16:20:05');
INSERT INTO `oauth2_access_token` VALUES ('8c11cbdef2a94732b7e59839853f47d7', '48a90adc2551411fbfac03e566817264', 27, 2, 1, '2019-07-05 11:46:50', '2019-07-05 10:58:49', '2019-07-05 10:58:49');
INSERT INTO `oauth2_access_token` VALUES ('8c27acb6254e47829c83823a06cf6fe1', '8c60f11bedc64ceb872d4b09df706982', 27, 2, 1, '2019-06-21 00:37:41', '2019-06-20 23:49:40', '2019-06-20 23:49:40');
INSERT INTO `oauth2_access_token` VALUES ('8c2abeddca7b417eb6ac079a862b974c', '387fcafaba9b41909fbf7770f364ca28', 27, 2, 1, '2019-06-23 20:23:48', '2019-06-23 19:35:48', '2019-06-23 19:35:48');
INSERT INTO `oauth2_access_token` VALUES ('8c307c29d6b34a77bf171c9fa0aeaa34', '90733a86efcc4669a07139b0137bca18', 1, 2, 0, '2019-06-28 09:31:45', '2019-06-28 08:43:45', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('8c33b821306546e8ab6479866d9dc6c6', 'fc722fbffe434acba115e1ff15939177', NULL, NULL, 1, '2019-03-22 22:06:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8c37bbf6e141483e8801ba435e2212cb', '080826283a524118b04ae1b2623a6389', 1, 2, 0, '2019-07-12 15:59:57', '2019-07-12 15:11:56', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('8c39508e84504da99cf9e67c33bbb818', 'f53417d82e4a4a5fa021070ad0f2d0cb', 27, 2, 1, '2019-07-11 12:50:33', '2019-07-11 12:02:32', '2019-07-11 12:02:32');
INSERT INTO `oauth2_access_token` VALUES ('8c4093831ece48bdb5576e3da5dbafff', '0ee5190b5cad4b12aba8e48546207756', 27, 2, 1, '2019-07-11 11:59:39', '2019-07-11 11:11:39', '2019-07-11 11:11:39');
INSERT INTO `oauth2_access_token` VALUES ('8c5b17040b084e799e0cfcf0be5938f8', 'a257d146531c47b094e7a716c98a0ff4', 27, 2, 1, '2019-08-08 14:54:55', '2019-08-08 14:06:55', '2019-08-08 14:06:55');
INSERT INTO `oauth2_access_token` VALUES ('8c7a64cb3c9244699ecc799963048d73', '7bb62952fb0944659eaee62d631a9224', NULL, NULL, 1, '2019-03-15 14:12:31', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8c9a0f32d4114cc5b0193c7e79635005', '0cd87558e6f544b0a2fa360d55a97506', 27, 2, 1, '2019-07-19 18:18:47', '2019-07-19 17:30:46', '2019-07-19 17:30:46');
INSERT INTO `oauth2_access_token` VALUES ('8c9fbed691a34d9d83835d6e2217e36f', '69a43bef0cfa4b33a0d014f681ea1aba', 27, 2, 1, '2019-06-12 11:07:02', '2019-06-12 10:19:01', '2019-06-12 10:19:01');
INSERT INTO `oauth2_access_token` VALUES ('8ca7ad92d04e4f49a62c1d995602d12f', 'f76509f6d6b6431ebcdc612f39274cf5', 27, 2, 1, '2019-06-01 10:34:57', '2019-06-01 09:46:57', '2019-06-01 09:46:57');
INSERT INTO `oauth2_access_token` VALUES ('8caa6b2f1e1243b09914ac28bae3f1fb', '7320e6b989ba414ebd8d508b339ab411', 27, 2, 1, '2019-06-02 19:17:10', '2019-06-02 18:29:10', '2019-06-02 18:29:10');
INSERT INTO `oauth2_access_token` VALUES ('8cbb6d3c783e45e283a55a07a8a7244e', '40f1a17c02f248368bd173ea1cc209b9', NULL, NULL, 1, '2019-04-24 19:06:08', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8cd1c58bf4e443a08e392f9920377e32', 'dd0b3658a8c344038314bd89e850b85c', NULL, NULL, 1, '2019-05-09 16:27:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8ce663962fe84894b54ec400fe1835c4', '5b016e7053a24f1ea5b3311de0bd89e3', 27, 2, 1, '2019-06-09 17:35:15', '2019-06-09 16:47:15', '2019-06-09 16:47:15');
INSERT INTO `oauth2_access_token` VALUES ('8ce97866e3c344579a5f3f48e929f1e1', '5b99c482f5b342e1a249cf9bbeae1d64', 27, 2, 1, '2019-07-26 12:35:51', '2019-07-26 11:47:50', '2019-07-26 11:47:50');
INSERT INTO `oauth2_access_token` VALUES ('8cf834ac1e784223baf4d9dbfec6c04b', 'adeffc30227546148a7bfba369420f61', 27, 2, 1, '2019-07-27 01:34:57', '2019-07-27 00:46:57', '2019-07-27 00:46:57');
INSERT INTO `oauth2_access_token` VALUES ('8d0f6bd7e2054170bddbf537990f1a3b', '9667647a0adc411d9159649e0fc40887', 27, 2, 1, '2019-06-03 15:59:06', '2019-06-03 15:11:05', '2019-06-03 15:11:05');
INSERT INTO `oauth2_access_token` VALUES ('8d1153cebd3246189e9527a1ac7eb9c2', '40f6fb43a5e1443e9362665ddc14c81f', 27, 2, 1, '2019-08-23 15:01:38', '2019-08-23 14:13:38', '2019-08-23 14:13:38');
INSERT INTO `oauth2_access_token` VALUES ('8d2c4ddf9d5149f488763770996792a8', 'c10b810d976e435096aefe2d385d72a7', 27, 2, 1, '2019-09-06 20:14:07', '2019-09-06 19:26:07', '2019-09-06 19:26:07');
INSERT INTO `oauth2_access_token` VALUES ('8d845fb191834b39990d990cd93d6801', '40594cb628a64ddba9f0e46bb65baa7d', 27, 2, 1, '2019-07-24 09:42:51', '2019-07-24 08:54:51', '2019-07-24 08:54:51');
INSERT INTO `oauth2_access_token` VALUES ('8d8b4d9af06042d1b2f68fc1275a63e5', 'aef485b9716c4dcd900165f8b143d27c', 27, 2, 1, '2019-07-29 18:29:44', '2019-07-29 17:41:43', '2019-07-29 17:41:43');
INSERT INTO `oauth2_access_token` VALUES ('8db7398a0d6c4379b7006411cd7a865c', '7165d09fd77645cfa6bbe2c81fff70ca', 1, 2, 1, '2019-09-08 20:30:50', '2019-09-08 19:42:49', '2019-09-08 19:42:49');
INSERT INTO `oauth2_access_token` VALUES ('8dc97924f363446eabfd090c33fd8fc1', '55d392b8ec6e4e7d867e29dee1cc3c17', 27, 2, 1, '2019-07-29 18:29:57', '2019-07-29 17:41:57', '2019-07-29 17:41:57');
INSERT INTO `oauth2_access_token` VALUES ('8dd0a8de7b8f465c95ab40c42ffb1b0f', '7540fc46648d4414846f80acd430ae17', NULL, NULL, 1, '2019-03-10 04:22:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8dd655e70c9a40149063cc9b33dccab8', 'fa6ad184680743cc99226ecdcf79c902', 27, 2, 1, '2019-05-23 14:20:56', '2019-05-23 13:32:55', '2019-05-23 13:32:55');
INSERT INTO `oauth2_access_token` VALUES ('8df7e428f61e45d795048a532ec9f707', '425647d02e914296961006307746c96c', NULL, NULL, 1, '2019-04-06 01:05:52', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8e04731443f440c78664ec42a4d20c7b', '601fffcef1b04b71a5f25d3e1fe434d7', 27, 2, 1, '2019-06-06 15:54:00', '2019-06-06 15:05:59', '2019-06-06 15:05:59');
INSERT INTO `oauth2_access_token` VALUES ('8e058c7b05d64428a2c5ea98182f204b', 'c51f6f02c7884d54ad5dee2c318a56e4', 27, 2, 1, '2019-08-28 22:58:49', '2019-08-28 22:10:49', '2019-08-28 22:10:49');
INSERT INTO `oauth2_access_token` VALUES ('8e15c9ef45b94e4da56c291c3c21e519', 'ed895ddaabdf4026982330304ba66b2e', 27, 2, 1, '2019-09-05 15:09:17', '2019-09-05 14:21:17', '2019-09-05 14:21:17');
INSERT INTO `oauth2_access_token` VALUES ('8e2e962cf8be49199418a3247189f60e', '17c63d46f91a499bb7c1700c8f3e8420', 1, 2, 0, '2019-07-19 11:37:58', '2019-07-19 10:49:57', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('8e3e51c2542a4304a59e14ac582072d1', 'ae95d55d1356463284c90d38a95dba2e', 27, 2, 1, '2019-06-11 14:59:18', '2019-06-11 14:11:18', '2019-06-11 14:11:18');
INSERT INTO `oauth2_access_token` VALUES ('8e4cb2f91da94346b1410c9e348257aa', '185320b1a1ee4f5485a728c0472352df', 27, 2, 1, '2019-07-31 17:14:37', '2019-07-31 16:26:37', '2019-07-31 16:26:37');
INSERT INTO `oauth2_access_token` VALUES ('8e5103dc52f346f596b51b4a36a2510e', 'f73865be8dc94adf8f667e744e9982a2', 38, 1, 1, '2019-08-14 16:37:08', '2019-08-14 15:49:08', '2019-08-14 15:49:08');
INSERT INTO `oauth2_access_token` VALUES ('8e5630af69ad45b8a805a8ccd64917f9', '0d699f9f08d44a21a4901819c779efd1', 27, 2, 1, '2019-08-21 14:57:04', '2019-08-21 14:09:03', '2019-08-21 14:09:03');
INSERT INTO `oauth2_access_token` VALUES ('8e5abb250cc74560917abfd3aa821c04', '86ba677ff71b47428286b0c1234ac753', 27, 2, 1, '2019-08-07 21:45:38', '2019-08-07 20:57:37', '2019-08-07 20:57:37');
INSERT INTO `oauth2_access_token` VALUES ('8e78076dbd69429d9cde66891fa4f260', 'ee096aa6d0e441d4b0ce31ecd02918e8', NULL, NULL, 1, '2019-03-15 21:55:57', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8e826a3953ff47a59aebe3816041d00b', '00bc9f3fa5d64ae3bfb1905119096638', 27, 2, 1, '2019-07-10 22:44:07', '2019-07-10 21:56:07', '2019-07-10 21:56:07');
INSERT INTO `oauth2_access_token` VALUES ('8e8cb56fa842435b865574ff77f0a2d8', 'd5a88029fee24e3fa59c6c6230d9c0e4', 27, 2, 1, '2019-06-19 23:58:51', '2019-06-19 23:10:51', '2019-06-19 23:10:51');
INSERT INTO `oauth2_access_token` VALUES ('8e925ff475aa4e29a73ee6930f58832c', 'e8af3e4aea2c43338643e134e3e94651', NULL, NULL, 1, '2019-05-02 21:17:40', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8ea2cd56b82e4aab86658d72472ad83b', '323981cfc1ec451fa46bff03b004f982', NULL, NULL, 1, '2019-05-11 12:30:04', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8eb5bffa32e643c08a7031dd10ea4c4f', '2a2ff13817684dec9f908b7f6197916a', NULL, NULL, 1, '2019-05-02 01:41:44', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8ebd8f9ae85b44b591302d67829cd411', 'be90a143ed8245d29317cff286f0a0e2', 27, 2, 1, '2019-07-22 16:55:45', '2019-07-22 16:07:44', '2019-07-22 16:07:44');
INSERT INTO `oauth2_access_token` VALUES ('8ec48e2daeee4999973f2a0c883c4930', 'ea1eefea5f9546af9a724008ef09d774', 27, 2, 1, '2019-08-12 11:35:59', '2019-08-12 10:47:58', '2019-08-12 10:47:58');
INSERT INTO `oauth2_access_token` VALUES ('8edf5d25f9374a8986b1402ed816bfb5', '50d7ef1ee57f4fdab87e4429fdc5e23f', 27, 2, 1, '2019-06-01 20:58:17', '2019-06-01 20:10:17', '2019-06-01 20:10:17');
INSERT INTO `oauth2_access_token` VALUES ('8ee73c0952504ffbb771d10ab1d8c541', '324e31c8e41c46b9bf8ee0bc3424af14', 1, 2, 0, '2019-08-05 11:04:30', '2019-08-05 10:16:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('8ee8fc33e51c4f1b8693cadc1c7d4d01', '7dc0149e1efe4ba79382c590c63b8bfa', 27, 2, 1, '2019-08-28 22:58:30', '2019-08-28 22:10:30', '2019-08-28 22:10:30');
INSERT INTO `oauth2_access_token` VALUES ('8f00d81eee374dbaa2c1a77ea1b02cee', 'eebe75f3699d4357b9b4a14f0c70e08b', 27, 2, 1, '2019-07-05 14:44:15', '2019-07-05 13:56:14', '2019-07-05 13:56:14');
INSERT INTO `oauth2_access_token` VALUES ('8f06af2a8d9049bfbc9bbccd62287b71', 'be4e2ef23ba24ffaa5991885152213db', NULL, NULL, 1, '2019-05-08 23:58:02', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('8f0f250a3d454a09a6b2209363c8c7a4', '5f72ab57cfe94bd79e866b181027725a', 27, 2, 1, '2019-06-29 18:55:12', '2019-06-29 18:07:12', '2019-06-29 18:07:12');
INSERT INTO `oauth2_access_token` VALUES ('8f115c9a4fdd454291473561d5701a15', '4999089097c84968ae3210f10acfc050', 27, 2, 1, '2019-07-10 11:12:02', '2019-07-10 10:24:02', '2019-07-10 10:24:02');
INSERT INTO `oauth2_access_token` VALUES ('8f3911c51aaa4e26b6d0a9e1ea49ab78', 'ed8025e9b6984c23b62fde5ec3637cd5', 27, 2, 1, '2019-07-03 17:10:26', '2019-07-03 16:22:25', '2019-07-03 16:22:25');
INSERT INTO `oauth2_access_token` VALUES ('8f39cce1c4c54847b8fb6d8fc293698d', '31c95724a1b1463aab0567f733c9e86d', 27, 2, 1, '2019-08-12 00:06:04', '2019-08-11 23:18:03', '2019-08-11 23:18:03');
INSERT INTO `oauth2_access_token` VALUES ('8f5272f82e114b96abf17daee07d97fe', 'da0f9e5857d74d48b7cf4404ce73a0f3', 27, 2, 1, '2019-06-03 17:14:27', '2019-06-03 16:26:26', '2019-06-03 16:26:26');
INSERT INTO `oauth2_access_token` VALUES ('8f579c0e02384e16ad5f818ea0921f69', 'f726549835434967a0f5f61eb22d4808', 27, 2, 1, '2019-06-03 21:56:12', '2019-06-03 21:08:11', '2019-06-03 21:08:11');
INSERT INTO `oauth2_access_token` VALUES ('8f5a800bfd0e423b8a224c4e7c9eab38', 'fb82223683c7404eb00d487655a19a87', 27, 2, 1, '2019-09-08 17:47:09', '2019-09-08 16:59:09', '2019-09-08 16:59:09');
INSERT INTO `oauth2_access_token` VALUES ('8f67a253303f43378db748f1dd583702', 'a425de6db62944669350b4a57715392d', 1, 2, 0, '2019-05-26 15:40:30', '2019-05-26 14:52:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('8f7978342dc145a3902fd4ee20b9eba2', '77e3684e23be451e9d5fd78144ee1764', 27, 2, 1, '2019-08-22 13:14:17', '2019-08-22 12:26:16', '2019-08-22 12:26:16');
INSERT INTO `oauth2_access_token` VALUES ('8f7f82cbb39c46ff8a40c39d0cc9f33d', 'd082c6d2fd8d4c14b78da10741f392e3', 27, 2, 1, '2019-06-07 17:38:15', '2019-06-07 16:50:15', '2019-06-07 16:50:15');
INSERT INTO `oauth2_access_token` VALUES ('8f975e1a9c4f423d948559463fbe6660', '38d389922b1a4f9aaedc5a89f13a6caf', 27, 2, 1, '2019-06-16 20:17:40', '2019-06-16 19:29:39', '2019-06-16 19:29:39');
INSERT INTO `oauth2_access_token` VALUES ('8fbe21274d0e4159a7592db0e9197940', '8958c74b79d34ab9a6b24727d1c0b93c', 27, 2, 1, '2019-07-21 12:29:56', '2019-07-21 11:41:56', '2019-07-21 11:41:56');
INSERT INTO `oauth2_access_token` VALUES ('900919193e914b09a0eecf8a38adfb0d', 'a284b7d6b6214e26883cbe851ec36f2a', 27, 2, 1, '2019-06-03 22:31:31', '2019-06-03 21:43:31', '2019-06-03 21:43:31');
INSERT INTO `oauth2_access_token` VALUES ('90221760aa9a47c9a56da6cef15b2168', '8b4b6cb9979d44ac93c27170610af7f0', 27, 2, 1, '2019-08-06 22:26:32', '2019-08-06 21:38:31', '2019-08-06 21:38:31');
INSERT INTO `oauth2_access_token` VALUES ('902a2b958624488eb96086290ca19536', 'f9fa5a26ae054215bbe3c8f5d9c25a45', 27, 2, 1, '2019-07-23 23:41:37', '2019-07-23 22:53:37', '2019-07-23 22:53:37');
INSERT INTO `oauth2_access_token` VALUES ('902a3660029c481fbcc6e0f188f68bdc', '485398910766438b913c3c398e96cfa9', NULL, NULL, 1, '2019-05-07 23:45:16', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('90467dc682844708a215e2b56911b409', 'af2ba05c8c434744981948891d1ca2ad', 123, 1, 1, '2019-06-12 17:20:42', '2019-06-12 16:32:41', '2019-06-12 16:32:41');
INSERT INTO `oauth2_access_token` VALUES ('9057da9c662b4116b3c07b223840dfe1', 'fae7ff7cb46f45309284b4f32ccd8925', 27, 2, 1, '2019-07-03 14:20:16', '2019-07-03 13:32:16', '2019-07-03 13:32:16');
INSERT INTO `oauth2_access_token` VALUES ('9067ce096123407b862053d8d41d69bf', '08559732b0f14aa48fb5029d4395e4f9', 27, 2, 1, '2019-07-31 15:54:00', '2019-07-31 15:05:59', '2019-07-31 15:05:59');
INSERT INTO `oauth2_access_token` VALUES ('906c842105724c6d8aaacdb922f387fc', 'bd7bd18852c841dbbc568e65d22b1270', 1, 2, 0, '2019-07-16 00:08:44', '2019-07-15 23:20:43', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('907d73c07d24464898c6d49b50a68db1', '2b85a6c1fe6a4381823389b380626775', 27, 2, 1, '2019-08-21 15:01:28', '2019-08-21 14:13:27', '2019-08-21 14:13:27');
INSERT INTO `oauth2_access_token` VALUES ('90826c91e8da4e4680c606807dc72e80', '858bfa4c985b4fcc88555109a2be87ca', NULL, NULL, 0, '2019-03-03 22:52:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('908c3202113b44f6ba246cfeb04a238c', 'fa8f35e9d2364f2e9a7d73f31bfb4039', 27, 2, 1, '2019-05-31 22:47:43', '2019-05-31 21:59:42', '2019-05-31 21:59:42');
INSERT INTO `oauth2_access_token` VALUES ('90a53fbe053b4083b43d9cdef49641e5', '439adccd8a4d48c5acab100558d4f6a5', 27, 2, 1, '2019-06-19 18:02:12', '2019-06-19 17:14:11', '2019-06-19 17:14:11');
INSERT INTO `oauth2_access_token` VALUES ('90a6242dcff54b158bd3fe093f4a4f70', 'fbf8f1cbfd9a45b7a479a09c797a433b', NULL, NULL, 1, '2019-03-10 04:24:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('90b346de0c6143d793d483ce1eebb1ad', 'f664f33aa32c49aea9d5ff28f9cfaec4', 27, 2, 1, '2019-06-16 11:15:15', '2019-06-16 10:27:14', '2019-06-16 10:27:14');
INSERT INTO `oauth2_access_token` VALUES ('90b80ba0abfd4ef98b0a10e6e5efe61f', '1618283558394e7a8a3205f434e801ef', 27, 2, 1, '2019-06-05 11:06:51', '2019-06-05 10:18:50', '2019-06-05 10:18:50');
INSERT INTO `oauth2_access_token` VALUES ('90c9eab5c0bf43d3a2d0bb4bf06239f6', '587b61efda5a4ae1a3900a3650626e27', 27, 2, 1, '2019-08-15 12:08:10', '2019-08-15 11:20:10', '2019-08-15 11:20:10');
INSERT INTO `oauth2_access_token` VALUES ('90cd3dfe8bee41cb9e11576d3f75ade3', '9377dc2f69864aa79cac7756b33fd635', NULL, NULL, 1, '2019-05-13 21:59:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('90da35bdf5834723beb3f6233b010621', '4d2314cf434a4a309f00ce3359385e18', 27, 2, 1, '2019-07-12 16:05:23', '2019-07-12 15:17:22', '2019-07-12 15:17:22');
INSERT INTO `oauth2_access_token` VALUES ('90e00be438dd452b9a50c2a0f3e45025', '01ad337519c64e56b77b393fd602fa8a', 27, 2, 1, '2019-07-29 17:33:54', '2019-07-29 16:45:53', '2019-07-29 16:45:53');
INSERT INTO `oauth2_access_token` VALUES ('90e170ea974f4c829389bfc83d94fbb0', 'af8d7b5632a6498e847389d75e0076e0', 27, 2, 1, '2019-06-05 22:05:38', '2019-06-05 21:17:37', '2019-06-05 21:17:37');
INSERT INTO `oauth2_access_token` VALUES ('90ec938893904cd0ad348b9c6f2b72a5', '1f1add486bad4e8bbc1b3270bf960599', 1, 2, 0, '2019-05-30 15:14:47', '2019-05-30 14:26:47', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('90f3698972ff49dd81154fd2c0c2f72d', '8e794205a2d64f61a87193b5ff830be2', 27, 2, 1, '2019-08-07 21:29:40', '2019-08-07 20:41:40', '2019-08-07 20:41:40');
INSERT INTO `oauth2_access_token` VALUES ('9102fdbdd1194851814ed9d8e6c08cce', 'b7454e02d8a2415c92aeb4ba099685f9', 27, 2, 1, '2019-05-29 22:33:51', '2019-05-29 21:45:50', '2019-05-29 21:45:50');
INSERT INTO `oauth2_access_token` VALUES ('911b0642a5e14b07b7cc836a21f43434', '3958fc309e444858b3416c4b9860c122', 27, 2, 1, '2019-08-20 19:19:48', '2019-08-20 18:31:48', '2019-08-20 18:31:48');
INSERT INTO `oauth2_access_token` VALUES ('911d07735312471fb04ee04d62cc2935', 'e0cb1545043c43eaaff7d2c3e53508f7', 27, 2, 1, '2019-07-16 20:47:35', '2019-07-16 19:59:35', '2019-07-16 19:59:35');
INSERT INTO `oauth2_access_token` VALUES ('91347a7075d1489aa8493bcf6567c1a0', '7d4c2b704e3c4e429637016594ef3dc3', 27, 2, 1, '2019-08-19 18:33:07', '2019-08-19 17:45:07', '2019-08-19 17:45:07');
INSERT INTO `oauth2_access_token` VALUES ('9138808109b8476b90fb8d3c24a104f5', '3d6f7524fbef43b88762e1d4e44eeb0c', 27, 2, 1, '2019-06-12 12:44:22', '2019-06-12 11:56:22', '2019-06-12 11:56:22');
INSERT INTO `oauth2_access_token` VALUES ('913b3af3016a4ec7b76ebf651250137f', '839a86706f1d4f6ab45c5427c3beba8c', 27, 2, 1, '2019-07-08 16:52:34', '2019-07-08 16:04:33', '2019-07-08 16:04:33');
INSERT INTO `oauth2_access_token` VALUES ('913daf95843c48d193c5c462facac503', '24ef8ab271654d2c944759d024a2c194', NULL, NULL, 1, '2019-03-24 17:03:57', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('915914ebabb34fd59cb89004d3053b8c', '9839a2038f4d46b1b97af5b034857c9f', 74, 1, 1, '2019-05-30 10:50:03', '2019-05-30 10:02:03', '2019-05-30 10:02:03');
INSERT INTO `oauth2_access_token` VALUES ('917d0cbe057a4cd9b184f334795447e4', '3263acbe31d4411999dfa3f3d9d51a76', 27, 2, 1, '2019-08-29 18:28:34', '2019-08-29 17:40:34', '2019-08-29 17:40:34');
INSERT INTO `oauth2_access_token` VALUES ('91807dd5254a4101989aa92e5573bd69', 'ec8f64ca69344b66884bd844a3e9ffce', 27, 2, 1, '2019-06-12 10:38:33', '2019-06-12 09:50:32', '2019-06-12 09:50:32');
INSERT INTO `oauth2_access_token` VALUES ('91ae6040ca1f4875bb89a5d3e0fb6d8f', 'b299c368cf594b2ab5f224dd84860aba', 26, 2, 1, '2019-06-04 13:35:38', '2019-06-04 12:47:37', '2019-06-04 12:47:37');
INSERT INTO `oauth2_access_token` VALUES ('91c5ed16ed2245a3a78b20ce4e45ff0b', 'e59e2372c8b640c8821d79c997f9a926', 27, 2, 1, '2019-07-05 11:51:30', '2019-07-05 11:03:30', '2019-07-05 11:03:30');
INSERT INTO `oauth2_access_token` VALUES ('91cc7d793c944fa39db916134a5b56e0', '9e8a8fec3bc1405b852cf1ec4a130f08', 27, 2, 1, '2019-06-23 14:09:13', '2019-06-23 13:21:12', '2019-06-23 13:21:12');
INSERT INTO `oauth2_access_token` VALUES ('91d58e854bce4c71960070c6b5b0433c', '67dc4485b238435bba162bca5d0bebdb', 27, 2, 1, '2019-06-01 23:09:58', '2019-06-01 22:21:58', '2019-06-01 22:21:58');
INSERT INTO `oauth2_access_token` VALUES ('91d782f9af6a4cc6834c8a7e9a1299e0', '63bfe764b7c94019a8bd1cbcd91cfe62', 27, 2, 1, '2019-07-02 19:11:30', '2019-07-02 18:23:29', '2019-07-02 18:23:29');
INSERT INTO `oauth2_access_token` VALUES ('91d9ec7c41ca4631b2b69296fc1aa892', '88daf80a915b4071940b5118b3bbd133', 27, 2, 1, '2019-06-16 13:08:44', '2019-06-16 12:20:43', '2019-06-16 12:20:43');
INSERT INTO `oauth2_access_token` VALUES ('91da599a1c6a4006bdb8a5e7ac24f0c3', '7c43fe8439d04b61ba1acd85963f0601', 27, 2, 1, '2019-06-08 14:54:16', '2019-06-08 14:06:16', '2019-06-08 14:06:16');
INSERT INTO `oauth2_access_token` VALUES ('91efc0e5dbd54770aa1344256e883287', '295346b0d5d841508a8dac4eab2edba5', 1, 2, 0, '2019-06-23 23:13:55', '2019-06-23 22:25:54', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('91f236ce7055498cac4412cb5c296814', 'affd3c113ec24079918a434ee2221f7b', 1, 2, 0, '2019-06-30 00:08:43', '2019-06-29 23:20:30', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('920610d6d9584c2ab0b91e55c742ffbb', '073125a47000431ba70fbcbf47ed3fe1', 27, 2, 1, '2019-06-11 14:43:32', '2019-06-11 13:55:32', '2019-06-11 13:55:32');
INSERT INTO `oauth2_access_token` VALUES ('92337c00ac73472fa7326e73bb227994', 'e67d30094fb144baaffc3f7f67c8ea49', NULL, NULL, 1, '2019-04-22 19:15:01', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('923fb98188994a5f8c8639fd39c5a455', '7d48357ad3da43a5a0fdc6c9dce3c0a9', 110, 1, 1, '2019-06-06 14:59:53', '2019-06-06 14:11:52', '2019-06-06 14:11:52');
INSERT INTO `oauth2_access_token` VALUES ('92410d9cb88443b8bf204d667e1e76d0', '8ec251333b2748fbb66dd291915da6df', 27, 2, 1, '2019-06-13 15:10:20', '2019-06-13 14:22:19', '2019-06-13 14:22:19');
INSERT INTO `oauth2_access_token` VALUES ('924556afe3884851b69b27093855f577', '3f2fc5e8c96b4c4fa374a5945181063a', 27, 2, 1, '2019-06-25 21:28:14', '2019-06-25 20:40:13', '2019-06-25 20:40:13');
INSERT INTO `oauth2_access_token` VALUES ('9273186533fe433f9a91603e0d70df78', '033fa8af8cf34638b03516f132e09193', 27, 2, 1, '2019-08-21 17:49:02', '2019-08-21 17:01:02', '2019-08-21 17:01:02');
INSERT INTO `oauth2_access_token` VALUES ('9277565a1eea403d9643457ef4bd8040', 'cd5382714c314707ada5b584aba183ff', 27, 2, 1, '2019-07-30 23:19:33', '2019-07-30 22:31:32', '2019-07-30 22:31:32');
INSERT INTO `oauth2_access_token` VALUES ('927dc242086c475c944d0802d5c63598', '03f72bbd207743e48f73832f513210dc', 27, 2, 1, '2019-08-10 15:03:03', '2019-08-10 14:15:03', '2019-08-10 14:15:03');
INSERT INTO `oauth2_access_token` VALUES ('928c998873214c97a3d3b295c331d4aa', 'b61374200b754c739bf2e2f9c990fc26', 27, 2, 1, '2019-06-13 01:35:31', '2019-06-13 00:47:31', '2019-06-13 00:47:31');
INSERT INTO `oauth2_access_token` VALUES ('9291e8317ee840d3b17497b6aac18c7a', 'c4ef307a2c954e21b8dc55da51421b4c', 27, 2, 1, '2019-06-14 15:57:51', '2019-06-14 15:09:51', '2019-06-14 15:09:51');
INSERT INTO `oauth2_access_token` VALUES ('92c0e0476f4147009aa9873b6f933309', '9bae9e30ba1d40449379cef52b746801', 27, 2, 1, '2019-07-29 18:09:36', '2019-07-29 17:21:36', '2019-07-29 17:21:36');
INSERT INTO `oauth2_access_token` VALUES ('92ca9fdd8fad427585dbe597de02cdf8', 'de3810037b4c4af09df7e27218c667c2', 27, 2, 1, '2019-08-14 09:26:05', '2019-08-14 08:38:05', '2019-08-14 08:38:05');
INSERT INTO `oauth2_access_token` VALUES ('93006abff06b487da96d0e141bdaae61', '986e7e9d1a87416ba67af3e3f5d61e54', 27, 2, 1, '2019-07-03 16:38:09', '2019-07-03 15:50:09', '2019-07-03 15:50:09');
INSERT INTO `oauth2_access_token` VALUES ('930b593a1b42483eb35586d6ead2c56a', '4e6c6d8640084d6b896d75639af859ed', 27, 2, 1, '2019-05-31 15:14:50', '2019-05-31 14:26:50', '2019-05-31 14:26:50');
INSERT INTO `oauth2_access_token` VALUES ('9311b9627f3441079a22196de259563a', 'cf2c0cd7146d481d8dc33b65e8060160', 27, 2, 1, '2019-07-09 19:49:14', '2019-07-09 19:01:13', '2019-07-09 19:01:13');
INSERT INTO `oauth2_access_token` VALUES ('932692ef62f74e6cae2efd59a7e53984', 'a4a4dde06aac45a8b3ee665f4f4561fd', 27, 2, 1, '2019-05-23 11:57:37', '2019-05-23 11:09:36', '2019-05-23 11:09:36');
INSERT INTO `oauth2_access_token` VALUES ('932a57fbcfd144f78f35f2c1e67dcc18', 'af525a50ab764eaeadf62cf249e1bbea', 1, 2, 0, '2019-06-27 23:10:11', '2019-06-27 22:22:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('93508b397c4f43d5b9375d5b2058072f', '0ae72ae0b6e846d883648b0d378236c2', 27, 2, 1, '2019-08-12 10:38:10', '2019-08-12 09:50:09', '2019-08-12 09:50:09');
INSERT INTO `oauth2_access_token` VALUES ('9365e6b53b014ecc8afc6777418708be', 'dfe4256855a048fa948059dd404efda1', 27, 2, 1, '2019-06-30 11:05:38', '2019-06-30 10:17:38', '2019-06-30 10:17:38');
INSERT INTO `oauth2_access_token` VALUES ('936b5deddb694984b1c59e937512cc9a', 'bd1c40e1fa244117b81377e0a2a37d12', NULL, NULL, 1, '2019-04-29 14:53:38', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('93b4185af920413ca6ee478c391196b0', 'fc2c59b4511b4944ac29fea2f0874147', 27, 2, 1, '2019-07-05 11:12:21', '2019-07-05 10:24:21', '2019-07-05 10:24:21');
INSERT INTO `oauth2_access_token` VALUES ('93c08f72c8af403db2251ad5f3dcd5f2', 'a29c1e48fe424368bb422bad1683c912', 27, 2, 1, '2019-08-28 22:58:55', '2019-08-28 22:10:54', '2019-08-28 22:10:54');
INSERT INTO `oauth2_access_token` VALUES ('93f67d0df4064cf3b031225da6b16e43', 'd4ab90931e4d42e08695073c3bcfcc20', 27, 2, 1, '2019-06-14 17:23:09', '2019-06-14 16:35:08', '2019-06-14 16:35:08');
INSERT INTO `oauth2_access_token` VALUES ('941e17aee21d4639a65b1010b79a54c6', '5ebdf4aba477479397a248d35d388e3c', 27, 2, 1, '2019-08-12 12:30:29', '2019-08-12 11:42:28', '2019-08-12 11:42:28');
INSERT INTO `oauth2_access_token` VALUES ('94234df66f8641d7a131a1e326cab80a', '41577ec0dbd84ab79c6620671808c9c3', 27, 2, 1, '2019-06-11 12:20:34', '2019-06-11 11:32:34', '2019-06-11 11:32:34');
INSERT INTO `oauth2_access_token` VALUES ('942e01ad7b7c4894903f7ab035065600', 'eebafb96bd2349bfaca476854bb0c8a6', 27, 2, 1, '2019-07-15 14:17:26', '2019-07-15 13:29:25', '2019-07-15 13:29:25');
INSERT INTO `oauth2_access_token` VALUES ('943c4158d49e4a68a3feafea36930646', '29b5f91bcaae4d79a873c9d8486f4c32', 27, 2, 1, '2019-06-13 10:57:14', '2019-06-13 10:09:13', '2019-06-13 10:09:13');
INSERT INTO `oauth2_access_token` VALUES ('948be3e46f4043558beb344180910a55', '17a5685637ff444ab69b477909af9e94', 27, 2, 1, '2019-06-04 10:27:30', '2019-06-04 09:39:29', '2019-06-04 09:39:29');
INSERT INTO `oauth2_access_token` VALUES ('94b456c724954b69964ef1aa5f2bbad2', '94037f87860f4f17bd2ac18758b36c24', 27, 2, 1, '2019-05-31 16:22:35', '2019-05-31 15:34:34', '2019-05-31 15:34:34');
INSERT INTO `oauth2_access_token` VALUES ('94caa44670b449368c0609eeb25258ad', '93485beffcbc4ae89a97f72a44d7985a', 27, 2, 1, '2019-07-04 20:00:59', '2019-07-04 19:12:58', '2019-07-04 19:12:58');
INSERT INTO `oauth2_access_token` VALUES ('94cf913955d644e59f35945bd9c28e95', '50cc034844f7472d93ed12ca0196bca4', 1, 2, 0, '2019-06-03 18:01:37', '2019-06-03 17:13:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('94e5f88cb7da46ac88dae5a40c82fc80', '90babaec6df3418fba43197d4632c3db', 1, 2, 0, '2019-07-12 14:58:56', '2019-07-12 14:10:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('9524ebf844854b00aea01445d21b846d', 'daef6b344488480283b0f7ae12abca6c', 27, 2, 1, '2019-08-19 02:59:38', '2019-08-19 02:11:38', '2019-08-19 02:11:38');
INSERT INTO `oauth2_access_token` VALUES ('95490c2f43a743aa9675548abab1216a', '803e0aa57a844866b3e9df9746ed5974', 27, 2, 1, '2019-06-04 17:41:35', '2019-06-04 16:53:34', '2019-06-04 16:53:34');
INSERT INTO `oauth2_access_token` VALUES ('954e5622e50946f49ea938e1a4cea0d3', 'fb6ae34d13a34b809d06a865c8f4a4ab', 27, 2, 1, '2019-06-15 14:56:16', '2019-06-15 14:08:16', '2019-06-15 14:08:16');
INSERT INTO `oauth2_access_token` VALUES ('955b0d6fe68448de93b96496c6653a1b', '61367efe016c4429a9ce1860bfb7cb6d', 27, 2, 1, '2019-06-04 23:12:13', '2019-06-04 22:24:12', '2019-06-04 22:24:12');
INSERT INTO `oauth2_access_token` VALUES ('956760319c0447deac8bb35f5c2342ea', 'ba7b2160a4b6424abfee6d1b62c8c7b0', 27, 2, 1, '2019-06-02 13:45:39', '2019-06-02 12:57:39', '2019-06-02 12:57:39');
INSERT INTO `oauth2_access_token` VALUES ('956bb79f688a4850b39eead12db6d72c', '52e914b70fc24b47914061ee527f34a9', 1, 2, 0, '2019-05-17 17:53:47', '2019-05-17 17:05:47', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('9575636a6b9c4092a7242f9b2187018d', 'd23f62660387464e95d13a2c480a5692', 27, 2, 1, '2019-05-29 17:09:41', '2019-05-29 16:21:41', '2019-05-29 16:21:41');
INSERT INTO `oauth2_access_token` VALUES ('95878283872141fd8db39062a7794363', '6554718e19b141488a7dd2006276615c', 27, 2, 1, '2019-07-29 19:27:51', '2019-07-29 18:39:51', '2019-07-29 18:39:51');
INSERT INTO `oauth2_access_token` VALUES ('958f91bc96874f69aa61523a1f38ba17', '5c54ff49fdf740bfbf24cf0d0a5471d3', 1, 1, 1, '2019-05-17 22:39:42', '2019-05-17 21:51:41', '2019-05-17 21:51:41');
INSERT INTO `oauth2_access_token` VALUES ('95985f07bdd34ad9b84328641990eeb2', 'f8d02b932a7a4580b6f60e33f1fad9b3', 27, 2, 1, '2019-07-09 11:20:04', '2019-07-09 10:32:03', '2019-07-09 10:32:03');
INSERT INTO `oauth2_access_token` VALUES ('95a08350bece4095a71814b640b10dd5', '7f6c973ff2754a48accba28ae51fb7cd', 27, 2, 1, '2019-07-29 15:08:05', '2019-07-29 14:20:05', '2019-07-29 14:20:05');
INSERT INTO `oauth2_access_token` VALUES ('95dff5f9f96d45b7a6a4838c50cdc7d3', '0b17b9e34bbb4299a4d23af133b20099', 27, 2, 1, '2019-06-03 19:44:13', '2019-06-03 18:56:13', '2019-06-03 18:56:13');
INSERT INTO `oauth2_access_token` VALUES ('95e15488d386427295b123dbc5e4b2b5', '0cd54ce6d5a14422a8d264f6cbb0bb79', 27, 2, 1, '2019-08-04 19:22:06', '2019-08-04 18:34:06', '2019-08-04 18:34:06');
INSERT INTO `oauth2_access_token` VALUES ('95e24b130d1d4a42b65c485e819bca3a', 'e5befd8d7e3b467e99c0b6e7911ddc60', 27, 2, 1, '2019-08-12 10:00:03', '2019-08-12 09:12:03', '2019-08-12 09:12:03');
INSERT INTO `oauth2_access_token` VALUES ('95ebe172816a48e586405bfeb901dbf8', '55afee5de486420a86bd98b9546fb7f9', NULL, NULL, 1, '2019-05-13 12:21:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('95ef1e8fbe61412e972ae1477f3299ce', 'd39a5aa52efe42048aa747d99d6e2500', 27, 2, 1, '2019-08-05 18:07:25', '2019-08-05 17:19:24', '2019-08-05 17:19:24');
INSERT INTO `oauth2_access_token` VALUES ('95f2b0cd80314e51a9f077d4b3883ae4', 'a4b88b1db39d42818f9a2d1deacdb19c', 1, 2, 1, '2019-09-08 18:30:09', '2019-09-08 17:42:09', '2019-09-08 17:42:09');
INSERT INTO `oauth2_access_token` VALUES ('960205ee60e24902816ddb80964fd9f8', '6e4090386e0444079de6a9d61fa4acd7', 1, 2, 0, '2019-06-20 11:35:07', '2019-06-20 10:47:07', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('9610cd739dd7412aa5334ef35fd6bbce', 'df15e8ec8f3f4e4b86da9df4580ee250', 27, 2, 1, '2019-07-11 12:02:28', '2019-07-11 11:14:28', '2019-07-11 11:14:28');
INSERT INTO `oauth2_access_token` VALUES ('96255161232e4cc7a53b02a77f409246', '0a2e8a4bdc164b6d89ab0abf25cb6c6a', 27, 2, 1, '2019-06-20 13:41:42', '2019-06-20 12:53:41', '2019-06-20 12:53:41');
INSERT INTO `oauth2_access_token` VALUES ('962ad54751294cedb344d74c1252232b', '83603970cbf44c359ae85f35185ae569', 27, 2, 1, '2019-06-27 10:56:38', '2019-06-27 10:08:37', '2019-06-27 10:08:37');
INSERT INTO `oauth2_access_token` VALUES ('962caa2a1788408fadd0b3fedb5a3194', 'fa4a26b7c916441db0b10a10d1e0a0be', 1, 2, 0, '2019-09-07 19:15:14', '2019-09-07 18:27:14', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('962eeccaa75d4b82b5c79a5621873f57', '599f5fadba284864b882426c4a3a5416', NULL, NULL, 1, '2019-05-11 01:34:48', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('963451b7d567443c9e33a599b3cad127', '62ac2e0677b54ee69e43d40a68d38021', 27, 2, 1, '2019-05-22 21:45:49', '2019-05-22 20:57:48', '2019-05-22 20:57:48');
INSERT INTO `oauth2_access_token` VALUES ('963e7642e6ff44019480f735f8dd0e9d', '9c99d6bef5e244a7b7b2874060197dce', NULL, NULL, 1, '2019-05-02 11:29:10', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('96522e7cf3534d618273b24fda8c066d', '7705296dc18a41ec967623ac9843d8e4', 1, 2, 0, '2019-07-05 11:17:14', '2019-07-05 10:29:14', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('9654ec30a2b8418c811e24b95a1dcbcb', 'd776f6182a8543cfb36a931aa4e53c4f', 27, 2, 1, '2019-07-18 17:12:18', '2019-07-18 16:24:17', '2019-07-18 16:24:17');
INSERT INTO `oauth2_access_token` VALUES ('9662c60a65784e3c966644ce61d55e81', '0ea58da8d269448abf6d05939fc3aee7', NULL, NULL, 0, '2019-03-03 22:51:17', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('96744621d481481386a75c1d89101ab5', '4e7cdeb1237b45de8fe1ffae881046d8', 27, 2, 1, '2019-07-09 23:34:02', '2019-07-09 22:46:02', '2019-07-09 22:46:02');
INSERT INTO `oauth2_access_token` VALUES ('9691eebea9fc404488b238d22ea9fb53', 'e62856f10bec4a8ebaf70c0b7502742d', NULL, NULL, 1, '2019-04-22 19:32:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('96935980ff2342a9aeb53a0440cdef63', 'f7b02549887948c386acfe81bf85275b', 27, 2, 1, '2019-09-06 15:19:17', '2019-09-06 14:31:17', '2019-09-06 14:31:17');
INSERT INTO `oauth2_access_token` VALUES ('969c77a8ca9345a4b747dc6773b5a8d8', '51f1f6408c054248bf130cd77cd881c4', 27, 2, 1, '2019-06-17 20:52:58', '2019-06-17 20:04:57', '2019-06-17 20:04:57');
INSERT INTO `oauth2_access_token` VALUES ('96b20680e92a42cabdc49b18050ee558', 'a75346b1fe87429a9be9048d861ffb1b', 27, 2, 1, '2019-07-05 23:12:34', '2019-07-05 22:24:33', '2019-07-05 22:24:33');
INSERT INTO `oauth2_access_token` VALUES ('96b89b6a6f4e420b8701d2f8a7a8a13e', '2fd12874059548da9e389b9e9f52db73', 27, 2, 1, '2019-06-28 10:55:33', '2019-06-28 10:07:33', '2019-06-28 10:07:33');
INSERT INTO `oauth2_access_token` VALUES ('96c1c9aaaced4e1dad0ef60358ebb735', '2167bedd2f2e49a5a8c68b1c9502e7e3', 1, 2, 0, '2019-05-31 16:49:27', '2019-05-31 16:01:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('96f09c8bd6fb4855a0163f233526d930', '8b06d0a3b32844f4a11f64f44e0e8977', 27, 2, 1, '2019-07-05 16:01:37', '2019-07-05 15:13:36', '2019-07-05 15:13:36');
INSERT INTO `oauth2_access_token` VALUES ('96f3ea276ecb4ddd8c4a40d995b716c7', '3b66e497c9cb42398add06fe8416163b', 27, 2, 1, '2019-06-22 17:53:13', '2019-06-22 17:05:12', '2019-06-22 17:05:12');
INSERT INTO `oauth2_access_token` VALUES ('973000ff3fe34a3cb339c41a4483361b', '5146db7990fc4dd79ac96889b00ee8b9', 27, 2, 1, '2019-08-15 19:57:19', '2019-08-15 19:09:19', '2019-08-15 19:09:19');
INSERT INTO `oauth2_access_token` VALUES ('9732f47a94e84c388ad5a678da088901', '8c5d4054507849d1bc4945a07a63fed0', 27, 2, 1, '2019-07-29 15:33:59', '2019-07-29 14:45:59', '2019-07-29 14:45:59');
INSERT INTO `oauth2_access_token` VALUES ('9775ceaf042449a58cd690242596d518', '5cef34c34ad04ba8a020422b7af22a83', 27, 2, 1, '2019-07-06 14:41:52', '2019-07-06 13:53:52', '2019-07-06 13:53:52');
INSERT INTO `oauth2_access_token` VALUES ('97760c5dd46246fba7926dc78a61d077', '6e28c3a4e61749008fb982fc854c4cd1', 198, 1, 1, '2019-08-13 16:26:55', '2019-08-13 15:38:55', '2019-08-13 15:38:55');
INSERT INTO `oauth2_access_token` VALUES ('97770ac2a556453783b35df97893646c', '4a828edf679140bea7d9d9120c9aea37', 27, 2, 1, '2019-06-07 18:57:25', '2019-06-07 18:09:25', '2019-06-07 18:09:25');
INSERT INTO `oauth2_access_token` VALUES ('977ba5752c724f0f998fe3d6f496d711', '5ab8cc50ca4e47cc9013b6d2df89c57d', NULL, NULL, 0, '2019-02-26 17:26:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9791fc48bf72426cb15b761c3912a31f', 'd82f6937e2de400a96b59164e3327539', 27, 2, 1, '2019-08-05 12:42:44', '2019-08-05 11:54:44', '2019-08-05 11:54:44');
INSERT INTO `oauth2_access_token` VALUES ('97b4f7d26cef4c6284ad273734dfc6e8', '82867dcd4b41476d8ab32d4dec74d6f0', 27, 2, 1, '2019-05-31 17:29:30', '2019-05-31 16:41:30', '2019-05-31 16:41:30');
INSERT INTO `oauth2_access_token` VALUES ('97bde561384647a4baff195378e91777', '993cd8c1517d495f80dd83d1025db99e', 1, 2, 0, '2019-05-18 13:47:00', '2019-05-18 12:59:00', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('97cf8bef5b824d72bdd0c1a812580709', 'dca5b3127a8d441a83c55eccaaa21764', 27, 2, 1, '2019-08-19 09:53:12', '2019-08-19 09:05:12', '2019-08-19 09:05:12');
INSERT INTO `oauth2_access_token` VALUES ('97e0f10dc641400488def1b4713b2fe4', 'a31c4231dfe244a69c1cc6449a84d9c9', NULL, NULL, 1, '2019-05-08 17:53:48', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('97e7f553cee8443ab77e7811b32c428a', '254095679e9643778390502be6232f21', NULL, NULL, 1, '2019-04-22 19:22:44', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('97ef3a71b48446ef873abea9b9c9e497', '6ecbcc4f987044fa858ab49278ebdaf1', 27, 2, 1, '2019-07-05 10:43:25', '2019-07-05 09:55:24', '2019-07-05 09:55:24');
INSERT INTO `oauth2_access_token` VALUES ('97f641d21c1b49ae91c31484819234cd', '4d320fd766bb4bf6a7bc3f903dbd9932', 27, 2, 1, '2019-09-07 02:14:21', '2019-09-07 01:26:20', '2019-09-07 01:26:20');
INSERT INTO `oauth2_access_token` VALUES ('9864141017964e28b5f9d90f1998e40e', '09525a354d804fb1b650eb86ee7fcf00', 27, 2, 1, '2019-08-20 14:20:12', '2019-08-20 13:32:11', '2019-08-20 13:32:11');
INSERT INTO `oauth2_access_token` VALUES ('98645fbe956048c2887fd313efc47f37', 'a28572275330433c812ae75d50230fd5', NULL, NULL, 1, '2019-05-08 18:10:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('98726902f52d47afabd9ead1b328aec9', 'a2185edc2223417dac80fe5090fb2e7c', 164, 1, 1, '2019-07-09 21:37:21', '2019-07-09 20:49:21', '2019-07-09 20:49:21');
INSERT INTO `oauth2_access_token` VALUES ('98ac218e243940ceb237b304bc243d61', '73691c7430dc45acb42560f39b8c4279', NULL, NULL, 1, '2019-04-22 13:53:36', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('98ed4093feb549d39ae95ece616caf08', '24a1601071c54ed7ae0d7a20ceedddf8', NULL, NULL, 1, '2019-05-09 19:45:29', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('990b8fcd03664be0827d78ad7fbbff49', 'f5e803f6d9d94876ae4424eac705fe30', 27, 2, 1, '2019-06-11 23:44:59', '2019-06-11 22:56:59', '2019-06-11 22:56:59');
INSERT INTO `oauth2_access_token` VALUES ('9940d4f0dda9457cb2a63eeb03ad9420', '2f76226e6acb440d938073a47e343f88', 27, 2, 1, '2019-06-18 14:43:02', '2019-06-18 13:55:01', '2019-06-18 13:55:01');
INSERT INTO `oauth2_access_token` VALUES ('994466c1d48d4751b315bb9ae361172f', '777a860ffb0f47d6bd35877da7dea064', 27, 2, 1, '2019-07-12 18:27:58', '2019-07-12 17:39:58', '2019-07-12 17:39:58');
INSERT INTO `oauth2_access_token` VALUES ('996cb2f1bc364473bd6c0640024a87f1', 'b806e87aad804cd2a20e8fdfbc8368a7', 27, 2, 1, '2019-07-12 10:36:52', '2019-07-12 09:48:52', '2019-07-12 09:48:52');
INSERT INTO `oauth2_access_token` VALUES ('998f9dd38709494e930090cc0818af82', 'f96d0d5622b1425eb760ddc714087d38', 27, 2, 1, '2019-07-18 11:11:01', '2019-07-18 10:23:01', '2019-07-18 10:23:01');
INSERT INTO `oauth2_access_token` VALUES ('99989bb8884443e7a49fbe255ee0fc82', '4b6f1b70e8684cabb90e1d3e229ea9de', 197, 1, 0, '2019-08-12 19:17:55', '2019-08-12 18:29:55', '2019-08-12 23:25:08');
INSERT INTO `oauth2_access_token` VALUES ('99a118b5652e4956ba45652ebcf4986b', 'a837dffa592246e7939c7d1a640be5fc', 27, 2, 1, '2019-07-03 17:47:11', '2019-07-03 16:59:11', '2019-07-03 16:59:11');
INSERT INTO `oauth2_access_token` VALUES ('99ad1eff34e54932864217e24d2e9685', '64728a35524341549c6eae06a34a4e13', 27, 2, 1, '2019-08-18 23:39:19', '2019-08-18 22:51:19', '2019-08-18 22:51:19');
INSERT INTO `oauth2_access_token` VALUES ('99afde00b04e4792a2167de585274320', '45dcd3f23f09463abf075005768c6bd4', NULL, NULL, 1, '2019-05-08 10:43:31', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('99d5d0bbeead4838b9fa9a4ee1b718e8', '460fdb6158cf407e8bc26adfdd556c13', 27, 2, 1, '2019-06-09 20:34:42', '2019-06-09 19:46:41', '2019-06-09 19:46:41');
INSERT INTO `oauth2_access_token` VALUES ('99df37221c06416aab99d9387c92a8c9', '324901bf92184dffa7ec931be4836ac6', 27, 2, 1, '2019-06-11 12:07:12', '2019-06-11 11:19:12', '2019-06-11 11:19:12');
INSERT INTO `oauth2_access_token` VALUES ('99e471dd31ac4b9fa5b15d7974027b9a', '9e49f58e55974ee48c359d3f50bbf7d3', 149, 1, 1, '2019-07-02 10:57:14', '2019-07-02 10:09:14', '2019-07-02 10:09:14');
INSERT INTO `oauth2_access_token` VALUES ('99f77123b53844c4a019af0836a6958d', '5f091ea5c9c241d081447cdafa9b372d', 26, 2, 1, '2019-07-04 16:19:42', '2019-07-04 15:31:41', '2019-07-04 15:31:41');
INSERT INTO `oauth2_access_token` VALUES ('99f783db04ab41e6853e56aa400fa751', 'effb07105a514a918f02a6a4e31b9788', 27, 2, 1, '2019-07-12 11:02:23', '2019-07-12 10:14:23', '2019-07-12 10:14:23');
INSERT INTO `oauth2_access_token` VALUES ('9a0b5edcee4d4ed59015a2a39da8bed6', '1de0107733884a5f8708ceaa365e2279', 27, 2, 1, '2019-06-01 14:50:07', '2019-06-01 14:02:07', '2019-06-01 14:02:07');
INSERT INTO `oauth2_access_token` VALUES ('9a0d351ae42b40a28496f0837c58dab7', '2498c240c0ae47d0a1a2744a9db3d8f2', 27, 2, 1, '2019-07-11 16:03:04', '2019-07-11 15:15:03', '2019-07-11 15:15:03');
INSERT INTO `oauth2_access_token` VALUES ('9a15baecc1a74634a9911da4e8986283', 'eed8a7ea17fd499ebc4e413cef4fafaf', 27, 2, 1, '2019-06-09 11:57:01', '2019-06-09 11:09:00', '2019-06-09 11:09:00');
INSERT INTO `oauth2_access_token` VALUES ('9a298d76bf96401b88b4288410b1275a', 'a45c56de25254200abe6b066e58d5167', 27, 2, 1, '2019-06-06 17:19:00', '2019-06-06 16:31:00', '2019-06-06 16:31:00');
INSERT INTO `oauth2_access_token` VALUES ('9a58692180c449f383dac305b8e7be95', 'f87b78a251674fcfacf7bd4c5c330c44', 27, 2, 1, '2019-08-07 17:12:42', '2019-08-07 16:24:41', '2019-08-07 16:24:41');
INSERT INTO `oauth2_access_token` VALUES ('9a5c439e96f245baa9bfc8d80d0a2b1c', '4c84ff6bd733480d832278972cb9ca21', 27, 2, 1, '2019-08-20 16:29:21', '2019-08-20 15:41:20', '2019-08-20 15:41:20');
INSERT INTO `oauth2_access_token` VALUES ('9a5dd09db64942dcb356f1a0761a4f82', '6d8cc199018b4db1932b38e57aa258e6', 27, 2, 1, '2019-07-10 23:52:56', '2019-07-10 23:04:56', '2019-07-10 23:04:56');
INSERT INTO `oauth2_access_token` VALUES ('9a649b4520dc4ab9a8fd9845557ea8ae', '69535c7df8fb4a29bf19a3de668a067e', 27, 2, 1, '2019-05-20 18:48:55', '2019-05-20 18:00:55', '2019-05-20 18:00:55');
INSERT INTO `oauth2_access_token` VALUES ('9a859b4f68e441d6a4fc558fbc798eb9', '6b25c62a047b4a989e07fb167f2460c7', 27, 2, 1, '2019-07-24 14:03:54', '2019-07-24 13:15:54', '2019-07-24 13:15:54');
INSERT INTO `oauth2_access_token` VALUES ('9aa16d852959468bbbe2769f8e78b623', '433c9b3f4fc54de9aed26558b36271c1', 27, 2, 1, '2019-07-26 18:26:13', '2019-07-26 17:38:12', '2019-07-26 17:38:12');
INSERT INTO `oauth2_access_token` VALUES ('9aa4e75ad12d4aa591b580a4f0059edc', '4b01ec40060a4796ab04243bf7f20c92', 27, 2, 1, '2019-05-28 16:05:03', '2019-05-28 15:17:03', '2019-05-28 15:17:03');
INSERT INTO `oauth2_access_token` VALUES ('9ac0cb60ae6543c7b36461340345fb5c', '50192503a79a4257a3ff7354efdf3ece', 27, 2, 1, '2019-08-08 19:14:40', '2019-08-08 18:26:40', '2019-08-08 18:26:40');
INSERT INTO `oauth2_access_token` VALUES ('9b3a2d7794de4bdfafd39b21be8fd013', 'c8a9cadb67cf43bdb07159baca18ba76', 27, 2, 1, '2019-08-28 12:43:43', '2019-08-28 11:55:43', '2019-08-28 11:55:43');
INSERT INTO `oauth2_access_token` VALUES ('9b5bea2902384299bed312acb67e4f75', 'b630d8c32c924e35b9d11fc8606c17f0', 1, 2, 0, '2019-05-31 16:08:44', '2019-05-31 15:19:24', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('9b6182d36d9749c0b56268ff90cf3603', 'dcf76927270f4bb2bc5cafc67eaa30d1', 27, 2, 1, '2019-07-16 16:10:06', '2019-07-16 15:22:06', '2019-07-16 15:22:06');
INSERT INTO `oauth2_access_token` VALUES ('9b66733d1468450c96162d3c921f6b34', '03cc052498fe4dc6bba72ce09a62fe88', NULL, NULL, 1, '2019-05-15 15:28:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9b798a2912054d55b02bc32529dfdd53', '4823adb544414999979027e857032e80', 27, 2, 1, '2019-06-19 17:32:53', '2019-06-19 16:44:52', '2019-06-19 16:44:52');
INSERT INTO `oauth2_access_token` VALUES ('9b83cbd1f3bf40cfa8f88330366f1fee', '122e6cd93af040d6903d4dc02c90c60f', 27, 2, 1, '2019-06-23 14:03:06', '2019-06-23 13:15:06', '2019-06-23 13:15:06');
INSERT INTO `oauth2_access_token` VALUES ('9b8fc51028a34c81b02a89be40e7b9f0', '944581c24a9e405cb8fbf550b08b682c', NULL, NULL, 1, '2019-05-06 00:14:33', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9b983c724a644f30afd28713c3b92f83', '32a40a7f665f49229b543c33161e99f5', 27, 2, 1, '2019-07-09 21:24:40', '2019-07-09 20:36:39', '2019-07-09 20:36:39');
INSERT INTO `oauth2_access_token` VALUES ('9babc2b2255a4c218deedac4c48bce28', '8c709623bd90405692f5243bc55c3e6e', 27, 2, 1, '2019-06-11 16:48:51', '2019-06-11 16:00:51', '2019-06-11 16:00:51');
INSERT INTO `oauth2_access_token` VALUES ('9bb2e90cfdb147abb5e97ef5b661af16', '6acd2a37f4804a84bc58fc493e1c7b87', 27, 2, 1, '2019-08-09 10:29:58', '2019-08-09 09:41:58', '2019-08-09 09:41:58');
INSERT INTO `oauth2_access_token` VALUES ('9bd0e795fb704889960a451826b5c4b6', '2f6729a4eda34a569362acd7419813a1', 27, 2, 1, '2019-06-03 11:29:49', '2019-06-03 10:41:49', '2019-06-03 10:41:49');
INSERT INTO `oauth2_access_token` VALUES ('9bdba48df0164fc6ac162c06eec3002d', '294bd73b4d5749b7bb0f19d16c3c2a85', 1, 2, 0, '2019-06-13 00:12:01', '2019-06-12 23:24:00', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('9bdcf4acebef44f2848732d086fcf18b', 'e42c2eff49f9447b8d84e349abecd197', 27, 2, 1, '2019-06-04 09:17:59', '2019-06-04 08:29:59', '2019-06-04 08:29:59');
INSERT INTO `oauth2_access_token` VALUES ('9be8670156244e33bceafdaa24d2c03c', '68580e5a2dc0445a83d1dc2604dfdf78', NULL, NULL, 1, '2019-04-22 19:32:10', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9be999cc1e794284a4446afaa7aff315', 'd431856829254160b671276ca815b020', 77, 1, 1, '2019-05-21 18:20:38', '2019-05-21 17:32:37', '2019-05-21 17:32:37');
INSERT INTO `oauth2_access_token` VALUES ('9c02ec03015c41e3821ea843249910b8', '2dc24371e5964c0880fabebc291433dd', NULL, NULL, 1, '2019-05-13 19:24:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9c3001c3c246499bbc2d7efe040780f1', '22c3185bebd14af1995cca7e353159ca', 27, 2, 1, '2019-06-06 16:39:59', '2019-06-06 15:51:58', '2019-06-06 15:51:58');
INSERT INTO `oauth2_access_token` VALUES ('9c3c931e0ec54ec1ae1c5c4dbbad0132', '9636c769538140149f268fe545c36dd6', 27, 2, 1, '2019-06-03 12:44:48', '2019-06-03 11:56:48', '2019-06-03 11:56:48');
INSERT INTO `oauth2_access_token` VALUES ('9c59a581d48b46b78cef3a3f93d612cc', 'cb2062b89ab741908ad97c30bee05b08', 27, 2, 1, '2019-06-02 09:27:30', '2019-06-02 08:39:30', '2019-06-02 08:39:30');
INSERT INTO `oauth2_access_token` VALUES ('9c747cee5e0f42708df704a506f6263a', 'c89cb2907acf468a8df58007fb0cd052', 27, 2, 1, '2019-07-15 18:39:41', '2019-07-15 17:51:41', '2019-07-15 17:51:41');
INSERT INTO `oauth2_access_token` VALUES ('9c83f420b0054af09c76ac13c49f002a', '7dd62d2e747c4746806b800bee7b4a25', NULL, NULL, 1, '2019-03-17 21:32:21', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9c8d1982b8574d61b7a65e23132ef987', 'bf7be425eee242709140710ddc629735', 28, 2, 1, '2019-09-08 23:47:07', '2019-09-08 22:59:06', '2019-09-08 22:59:06');
INSERT INTO `oauth2_access_token` VALUES ('9cc5eb9f7bce4b95929617cab2b65ff0', 'a906cf3567ff4f48b852630f207ff1a1', 27, 2, 1, '2019-07-08 17:37:38', '2019-07-08 16:49:37', '2019-07-08 16:49:37');
INSERT INTO `oauth2_access_token` VALUES ('9cc9438f307547f595abc09eaf788b7b', 'e2b5562f5358429ca9a7ea7b43e2eaac', NULL, NULL, 1, '2019-03-11 23:31:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9ce1f13f2bed47f3a852969aedc6bfa5', 'a61d8e00f41e40ac91f32d61494a8294', 1, 2, 0, '2019-07-02 16:06:02', '2019-07-02 15:18:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('9ce33a7304ae423c96a031927a32bcf2', 'b94e69641eae447ebf1c3260a6e247ff', 27, 2, 1, '2019-06-06 14:07:36', '2019-06-06 13:19:35', '2019-06-06 13:19:35');
INSERT INTO `oauth2_access_token` VALUES ('9cf0c437676f4d1184aa8e844eae34a6', '4036e55cdc65430280bb0638dc3092de', 27, 2, 1, '2019-06-04 16:44:34', '2019-06-04 15:56:34', '2019-06-04 15:56:34');
INSERT INTO `oauth2_access_token` VALUES ('9cf932fdc1044defb614bf1d97eb10a2', '01e202fbf9df4b249546adea58ed9593', NULL, NULL, 1, '2019-03-14 22:04:27', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9d06c54b335e49a38af4e52a553bbe5c', 'a80af1d22acd42b5ad17f99206f504fb', NULL, NULL, 1, '2019-04-24 15:54:08', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9d09222d2eb34f83abd17451d7ca8036', '549d52738d994ea1b5597b89975aa5e6', 27, 2, 1, '2019-06-05 11:54:46', '2019-06-05 11:06:46', '2019-06-05 11:06:46');
INSERT INTO `oauth2_access_token` VALUES ('9d0aa250e6a648a9a04f1bddee995288', '01c7ad52334a49e0858114edcbdcf5d9', 27, 2, 1, '2019-06-25 10:35:30', '2019-06-25 09:47:30', '2019-06-25 09:47:30');
INSERT INTO `oauth2_access_token` VALUES ('9d0d423f4066415eb88896b2f9d95bff', '6659139a3e46466189e15d126732c932', NULL, NULL, 1, '2019-03-30 23:03:17', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9d0dcc259fb945f29a87692b966efdb5', '193c12ea9c054f9fae0aa715dfa1c1cc', 111, 1, 1, '2019-06-07 14:37:30', '2019-06-07 13:49:30', '2019-06-07 13:49:30');
INSERT INTO `oauth2_access_token` VALUES ('9d1303f2ec29442aa801c28fdf303faf', 'aea8918542714513848c927a57859d1d', 1, 2, 0, '2019-06-04 15:26:17', '2019-06-04 14:38:16', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('9d4c8f37787246de8b1f948f86b5413d', 'a8f5d7b450e14b20a4fc97e60f32c235', NULL, NULL, 1, '2019-05-07 17:15:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9d5aa7ce786948418eea9a00146d96a8', '4fbbb805968440f88a3b8f41b93b762a', NULL, NULL, 1, '2019-05-14 19:02:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9d60b4170f4143e79fd5992c7c6c6181', '33b685958fc1402e99df4bd46502ef11', 27, 2, 1, '2019-08-29 11:45:57', '2019-08-29 10:57:56', '2019-08-29 10:57:56');
INSERT INTO `oauth2_access_token` VALUES ('9d6534cc4b1b40bf98092807fed2a571', '0c2d72314c9b4e6c8fb4d9a16d3abf8f', 167, 1, 1, '2019-07-11 11:45:27', '2019-07-11 10:57:26', '2019-07-11 10:57:26');
INSERT INTO `oauth2_access_token` VALUES ('9d67da112e7e49b1aca1b22904ceadaa', '80cdfa5b2bb5401fa5bfc0465ffe2a23', 27, 2, 1, '2019-08-24 12:37:57', '2019-08-24 11:49:56', '2019-08-24 11:49:56');
INSERT INTO `oauth2_access_token` VALUES ('9d9996d5d694450d8beb91b488f1f470', '88665a4cb5c1499dad7b7f92fec565b3', 27, 2, 1, '2019-06-28 14:40:05', '2019-06-28 13:52:05', '2019-06-28 13:52:05');
INSERT INTO `oauth2_access_token` VALUES ('9da28a585c1d4217bed8df269d76349b', '9a594759a2ec4fca8e16c40917c4a942', 27, 2, 1, '2019-06-21 15:28:12', '2019-06-21 14:40:11', '2019-06-21 14:40:11');
INSERT INTO `oauth2_access_token` VALUES ('9da9d8ec8cb24e6d9b95041b8c17db4a', 'd2522fa286cb454eb51bdb4c5daec68a', 27, 2, 1, '2019-06-03 16:42:45', '2019-06-03 15:54:45', '2019-06-03 15:54:45');
INSERT INTO `oauth2_access_token` VALUES ('9dac9eaef4fc4b36b7aa86ce5866b27e', 'b8ac4e78389649019947d951e490f5d4', 27, 2, 1, '2019-06-15 01:30:20', '2019-06-15 00:42:20', '2019-06-15 00:42:20');
INSERT INTO `oauth2_access_token` VALUES ('9dc1489228df434d981bf12f64a466b5', 'f809848a61d54b9da90c2fc4777e6bab', 27, 2, 1, '2019-08-14 11:04:31', '2019-08-14 10:16:30', '2019-08-14 10:16:30');
INSERT INTO `oauth2_access_token` VALUES ('9dc535a4bdfd4ec68219f63850737858', 'd26181e72a594673a4479f2560236bbf', 27, 2, 1, '2019-08-19 11:18:40', '2019-08-19 10:30:39', '2019-08-19 10:30:39');
INSERT INTO `oauth2_access_token` VALUES ('9dd12fb73fd24965b711cfb61acaca33', '29a32a3a749249d090f5f03bbd5230cc', 1, 2, 0, '2019-09-07 23:34:38', '2019-09-07 22:46:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('9dda0387c6764380ab640262d872d791', 'd986ed871dcb46cabf44fc71daf9eea9', NULL, NULL, 1, '2019-05-06 01:12:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9de1cc5bef1344d6826b4dceb021aa5d', '960fee6de63f4145b477f8eb0052e516', 27, 2, 1, '2019-07-02 11:48:57', '2019-07-02 11:00:56', '2019-07-02 11:00:56');
INSERT INTO `oauth2_access_token` VALUES ('9e1b7f36564b4716985d079521a98687', '5514f954378b4d37859b0cfa28ee04f0', 27, 2, 1, '2019-06-09 18:12:39', '2019-06-09 17:24:39', '2019-06-09 17:24:39');
INSERT INTO `oauth2_access_token` VALUES ('9e28c901ed6d41459cc67021b9298019', 'c5860e78ccce48d7bae642dedca33cbf', 27, 2, 1, '2019-05-21 17:11:26', '2019-05-21 16:23:26', '2019-05-21 16:23:26');
INSERT INTO `oauth2_access_token` VALUES ('9e2a07176be54f5c93433eaeaaaf066f', 'd42198893f1b4debaa7f459059c86472', 27, 2, 1, '2019-06-05 16:29:23', '2019-06-05 15:41:23', '2019-06-05 15:41:23');
INSERT INTO `oauth2_access_token` VALUES ('9e4e00b8338046cda1bdba3deb7df9f0', 'c5b988a3c2f04a838310b8d268cecbb7', 194, 1, 1, '2019-08-08 18:22:25', '2019-08-08 17:34:25', '2019-08-08 17:34:25');
INSERT INTO `oauth2_access_token` VALUES ('9e5e0a9aa7554432ac6005d308ace07e', '1460ab55c95a421487c8e7f72de4bacb', 27, 2, 1, '2019-07-11 16:53:34', '2019-07-11 16:05:33', '2019-07-11 16:05:33');
INSERT INTO `oauth2_access_token` VALUES ('9e7b0810e58641d583e1806bd8686ed0', '37241cfeaaf44d5c9bd33e0f166eb6ac', 27, 2, 1, '2019-06-14 13:22:33', '2019-06-14 12:34:33', '2019-06-14 12:34:33');
INSERT INTO `oauth2_access_token` VALUES ('9e7c547f4a764465af7cafeb79b5fb71', 'c1ca5add9fc54aafbf82caa5d0edb984', 27, 2, 1, '2019-07-16 15:53:13', '2019-07-16 15:05:12', '2019-07-16 15:05:12');
INSERT INTO `oauth2_access_token` VALUES ('9e9e913124d24b89a345a1d09976e9fe', 'ebbe41fa9d994de7aaf0ba69d3fa1441', 27, 2, 1, '2019-06-24 10:38:53', '2019-06-24 09:50:53', '2019-06-24 09:50:53');
INSERT INTO `oauth2_access_token` VALUES ('9eb2914209dd430abc07665fa29fb059', '4942675ae99440848e68b31ce66e986e', 27, 2, 1, '2019-06-01 18:44:15', '2019-06-01 17:56:15', '2019-06-01 17:56:15');
INSERT INTO `oauth2_access_token` VALUES ('9eb968da92f0446095961dfeb12f4be1', 'e8523a5e65d84c4a8327a82c25e76351', 1, 2, 0, '2019-06-29 21:57:24', '2019-06-29 21:09:24', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('9ebf31ebb0be4a43b916faa3d26fb03f', '79d2f3d6510247b0b9f21d7b3404b842', 27, 2, 1, '2019-08-18 17:25:12', '2019-08-18 16:37:12', '2019-08-18 16:37:12');
INSERT INTO `oauth2_access_token` VALUES ('9ec1bc1cd3ce49e588c0166aacf90351', '7f2db9c8d89247c3963be02c7f3c613e', 27, 2, 1, '2019-06-14 15:13:54', '2019-06-14 14:25:54', '2019-06-14 14:25:54');
INSERT INTO `oauth2_access_token` VALUES ('9ec56ab5cfe64995b988a5e723cbbf6a', 'bec6d13bd3a948b2a8c81980732ca4b5', 1, 2, 0, '2019-06-26 18:49:14', '2019-06-26 18:01:13', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('9ec5812770ac40d4b53b118cf957ca17', 'c8ce74d1d2104b41b73f97ff7464e64a', 27, 2, 1, '2019-06-21 15:01:55', '2019-06-21 14:13:54', '2019-06-21 14:13:54');
INSERT INTO `oauth2_access_token` VALUES ('9ec9609b1e3b4ef0a2992322c7cea588', '49a5abcdd4da46d3a28d21f4bd0d7d03', 27, 2, 1, '2019-06-01 15:18:34', '2019-06-01 14:30:33', '2019-06-01 14:30:33');
INSERT INTO `oauth2_access_token` VALUES ('9ed07a73eb0a4b0495cb20d1ee91d8b1', '5170aae9b2294245beef124ede172a04', 27, 2, 1, '2019-06-13 14:41:37', '2019-06-13 13:53:36', '2019-06-13 13:53:36');
INSERT INTO `oauth2_access_token` VALUES ('9ef7ac85571441bf848d7ae209fb9f07', 'e21770e5b69b41dcb4a44c81995c719c', NULL, NULL, 1, '2019-05-08 11:56:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9ef812473f9b4dc3ab91c0c9dc576ad8', '2b15bb7a7f8a4c33b98a9c0844932746', 27, 2, 1, '2019-07-30 16:03:44', '2019-07-30 15:15:44', '2019-07-30 15:15:44');
INSERT INTO `oauth2_access_token` VALUES ('9f18acfbf38046ab8b3a45c0f377f9d0', 'd2e0c2cf7e044cb5a1e823fce514afe7', 27, 2, 1, '2019-06-04 09:31:09', '2019-06-04 08:43:08', '2019-06-04 08:43:08');
INSERT INTO `oauth2_access_token` VALUES ('9f342751c4b34672abb7f18b86b1b44b', '917fab05c67d4a088cd96b98b47ff74f', 27, 2, 1, '2019-08-15 20:13:26', '2019-08-15 19:25:25', '2019-08-15 19:25:25');
INSERT INTO `oauth2_access_token` VALUES ('9f37d70621fc4ee9a645fb438c4056ee', '03294d7d15054b34b2920a35048ee1fd', 147, 1, 1, '2019-07-01 22:31:34', '2019-07-01 21:43:33', '2019-07-01 21:43:33');
INSERT INTO `oauth2_access_token` VALUES ('9f3f2bf3f0d04bbb90ad610ec4f707e8', '35284a1d90654316a6068025bcfae5e3', NULL, NULL, 1, '2019-05-01 12:39:13', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9f80950217fd463282406c00a358e36c', 'bd4ee71fe2be4b43a343d783b0ec1f48', 27, 2, 1, '2019-08-27 07:25:59', '2019-08-27 06:37:58', '2019-08-27 06:37:58');
INSERT INTO `oauth2_access_token` VALUES ('9f98d736b3864e7e8f0f70ee91b80168', 'a4548382030447fd9daeb70676a27f18', 27, 2, 1, '2019-07-07 21:49:50', '2019-07-07 21:01:49', '2019-07-07 21:01:49');
INSERT INTO `oauth2_access_token` VALUES ('9fa04d4f7c96496291179e1116a79353', '8245e89626914015b9c09a22b4da0f37', 27, 2, 1, '2019-06-03 17:25:21', '2019-06-03 16:37:20', '2019-06-03 16:37:20');
INSERT INTO `oauth2_access_token` VALUES ('9fcfad2b9cfe44a395785dfaecf29dd5', '82dbe96c746449b290cc65afca3ca3c3', NULL, NULL, 1, '2019-04-22 19:22:37', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9fcfff1ade1643de99f32e9a25f81ca0', '58d6954ad59d4553ac7bc052ffb67931', NULL, NULL, 1, '2019-04-28 17:30:24', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('9fd6d25ca5c443da8b86a19e71065ce1', '27d4fd0e971c4f60a71416b155fd79c2', 216, 1, 1, '2019-08-30 12:23:59', '2019-08-30 11:35:59', '2019-08-30 11:35:59');
INSERT INTO `oauth2_access_token` VALUES ('9fe2c073f1d94135bd9774fb1809744c', '7c014d1675fe4cb6970e1e4d4021921b', 27, 2, 1, '2019-06-13 19:22:01', '2019-06-13 18:34:01', '2019-06-13 18:34:01');
INSERT INTO `oauth2_access_token` VALUES ('a01652f5265242a798a71546f9f63342', '3da17eaf9c104ff3b838f74f82f5db2a', 27, 2, 1, '2019-08-30 10:48:11', '2019-08-30 10:00:10', '2019-08-30 10:00:10');
INSERT INTO `oauth2_access_token` VALUES ('a028601e3d4a4b278f319f19cca340ce', 'fd8b80e2958848d09a7ae3680e86e363', 27, 2, 1, '2019-06-16 13:10:09', '2019-06-16 12:22:08', '2019-06-16 12:22:08');
INSERT INTO `oauth2_access_token` VALUES ('a037bd7432fd42b89956b44486d6ecd7', 'cc3056ed9f4d42bbbc456172317db971', 27, 2, 1, '2019-07-26 10:16:29', '2019-07-26 09:28:28', '2019-07-26 09:28:28');
INSERT INTO `oauth2_access_token` VALUES ('a0ce73147a4a4670a54b1f54cfd397e5', '5b2ee306e6ce4536beb2b496dd48636f', 27, 2, 1, '2019-08-13 11:29:53', '2019-08-13 10:41:53', '2019-08-13 10:41:53');
INSERT INTO `oauth2_access_token` VALUES ('a0e18a74e6d344738125466c2a37704d', '8d601049f11f48578b443c2620afe5e8', NULL, NULL, 1, '2019-03-10 03:20:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a0fcc38ec91d4fbf809731d50b25afd2', '26f9fdde538e4de08a3ba868ff882c71', NULL, NULL, 1, '2019-05-04 15:28:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a103ae323a61458fa6d4cc14a7a4812b', '8c2f75c61adc49039aac4b610da4772c', 27, 2, 1, '2019-06-05 18:58:12', '2019-06-05 18:10:11', '2019-06-05 18:10:11');
INSERT INTO `oauth2_access_token` VALUES ('a1047a61aba544c594758e8af8d1d302', '9447a69a384c422f9bef225cabf116f2', 27, 2, 1, '2019-07-07 11:45:41', '2019-07-07 10:57:40', '2019-07-07 10:57:40');
INSERT INTO `oauth2_access_token` VALUES ('a1253f6f5479463ca6b2b690f6d8ca27', 'b96a278fdb2746cda68b4d532cbc15f0', 27, 2, 1, '2019-06-14 09:53:29', '2019-06-14 09:05:28', '2019-06-14 09:05:28');
INSERT INTO `oauth2_access_token` VALUES ('a12f9d0340ba4b79b6ea6da466057c8f', 'e702f60b2a224bdda86a6b5108c4cd09', 27, 2, 1, '2019-06-12 13:13:03', '2019-06-12 12:25:03', '2019-06-12 12:25:03');
INSERT INTO `oauth2_access_token` VALUES ('a19e53610a84452fa982e971b4e43035', '6cf95a7dec4146fba30b2bd1438a3c25', 27, 2, 1, '2019-05-30 02:20:46', '2019-05-30 01:32:46', '2019-05-30 01:32:46');
INSERT INTO `oauth2_access_token` VALUES ('a1a0b693d22045b4965a20246877c9c1', 'ecf48faa0c7f43c8b7a59afccec9e418', 27, 2, 1, '2019-06-19 17:41:44', '2019-06-19 16:53:43', '2019-06-19 16:53:43');
INSERT INTO `oauth2_access_token` VALUES ('a1aff62e859d439787aaf8e559516bdd', '871aa1c71ab84ca495437f5a561d9921', NULL, NULL, 1, '2019-05-08 19:08:00', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a1b359921511469d9a895d62eb53db2b', '3a910a9b176b4897a365235bd2a5b387', 27, 2, 1, '2019-06-20 12:10:37', '2019-06-20 11:22:37', '2019-06-20 11:22:37');
INSERT INTO `oauth2_access_token` VALUES ('a1d740031d1242a6a099d65244d2709e', 'e446ae70a14e4003b2c5878b641abf0c', 27, 2, 1, '2019-06-29 16:05:41', '2019-06-29 15:17:40', '2019-06-29 15:17:40');
INSERT INTO `oauth2_access_token` VALUES ('a1ddafe3fd43445d8e99b9b73b6e9d58', '68a79459c9a34614974148d4acf138fc', 27, 2, 1, '2019-06-02 10:31:41', '2019-06-02 09:43:41', '2019-06-02 09:43:41');
INSERT INTO `oauth2_access_token` VALUES ('a1fcc2534e674b36bf83c74cdb229a2a', '48d65f9fd48c4617bac17ad415418843', 27, 2, 1, '2019-06-03 17:31:05', '2019-06-03 16:43:04', '2019-06-03 16:43:04');
INSERT INTO `oauth2_access_token` VALUES ('a20173a52ddb4ca29d878674ba441a27', '8bb0193df77141c7b6db0fef88a0b5c2', NULL, NULL, 1, '2019-05-15 16:32:15', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a216cdeb3c8c46e78cf62e3ad19f40ac', '508246a4d4ff40ceb26fa71dc87fa1de', 27, 2, 1, '2019-07-28 13:05:49', '2019-07-28 12:17:49', '2019-07-28 12:17:49');
INSERT INTO `oauth2_access_token` VALUES ('a257796d30514a5db4207acb345ad465', '7e0b4adf8e624200a7ebeb51f1a66f0d', NULL, NULL, 1, '2019-04-27 23:17:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a271b4cea7784c6c9062236595523cbe', '954c03bf529a45508c141b4052d6eaf5', 1, 2, 0, '2019-05-26 12:45:44', '2019-05-26 11:57:44', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('a273e82a3f294892b6b221c46bd221e4', 'd0a58c742ec840d98fd1af9859e220f9', NULL, NULL, 1, '2019-04-27 21:14:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a280be3ac0ed42cf801a9aad73d42fc9', '7e45e9acc9d248dd9f04c087af8de763', 27, 2, 1, '2019-06-28 11:17:07', '2019-06-28 10:29:07', '2019-06-28 10:29:07');
INSERT INTO `oauth2_access_token` VALUES ('a2a559ef56ce4277accec12031755433', '12927eb5277441dd8208a84a1045fe6e', 27, 2, 1, '2019-06-04 15:39:20', '2019-06-04 14:51:20', '2019-06-04 14:51:20');
INSERT INTO `oauth2_access_token` VALUES ('a2c0166a72c346a0b8e58a81cc969657', 'f86daaa5b8ad4ee5a7a1acff6790d509', 27, 2, 1, '2019-07-14 16:16:10', '2019-07-14 15:28:10', '2019-07-14 15:28:10');
INSERT INTO `oauth2_access_token` VALUES ('a2d92f324b1f4c4b9996beda777b7860', '0b558b7a63e64647a82227cdc6f626f8', 1, 2, 0, '2019-08-22 00:46:15', '2019-08-21 23:58:15', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('a2deb50728ef49b38223d322107732a3', '4e656e94aa8c4b4fa75ffe738efa8f1b', 27, 2, 1, '2019-07-21 17:14:32', '2019-07-21 16:26:32', '2019-07-21 16:26:32');
INSERT INTO `oauth2_access_token` VALUES ('a2e72fb9bf594126afe236f6da296935', 'a9a89a0510cf41b586fa413347d26966', 27, 2, 1, '2019-06-20 09:34:01', '2019-06-20 08:46:00', '2019-06-20 08:46:00');
INSERT INTO `oauth2_access_token` VALUES ('a2f9b8d1fa4f4724a20e3c5693fe204c', 'b54887d0f6154645846d07e89ca13029', 1, 2, 0, '2019-06-07 19:12:58', '2019-06-07 18:24:58', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('a3021d1dd2d24096af25ffa40157f576', '08201cde149c47ecad22098716cb6e6a', 27, 2, 1, '2019-07-25 09:33:11', '2019-07-25 08:45:10', '2019-07-25 08:45:10');
INSERT INTO `oauth2_access_token` VALUES ('a32c8ac4644d402eb58c5e879e1801c6', '07cbb87af3014e8d92666fa8a4b90d57', NULL, NULL, 1, '2019-03-13 00:52:23', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a35649ed0fe847a8b808a34e2a3f4231', '605b4eb0f19249fbbe764f6f66f8b414', 27, 2, 1, '2019-08-30 11:57:49', '2019-08-30 11:09:49', '2019-08-30 11:09:49');
INSERT INTO `oauth2_access_token` VALUES ('a357f013a2c8424c8d4f6113767e162b', '82325cd60480438f8462df5535b83a2b', 27, 2, 1, '2019-06-12 16:05:28', '2019-06-12 15:17:27', '2019-06-12 15:17:27');
INSERT INTO `oauth2_access_token` VALUES ('a35f4fa64e7348bcb6f57adcd212364b', 'a87b0a67b03943fe929072e46c1f0b9b', 27, 2, 1, '2019-06-12 15:31:02', '2019-06-12 14:43:02', '2019-06-12 14:43:02');
INSERT INTO `oauth2_access_token` VALUES ('a37bb68694204f71a1c136723a1e079b', '87cc153e15a04c8aba858e7fb26b27fa', NULL, NULL, 1, '2019-03-11 23:04:00', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a38c44befd6a41e68c73905dd0c954ad', 'cf0879abbbb443d3b2ef1c8b3db29468', 27, 2, 1, '2019-06-16 10:29:15', '2019-06-16 09:41:15', '2019-06-16 09:41:15');
INSERT INTO `oauth2_access_token` VALUES ('a3b2ad64fb1649eeac73f4dd43395cdf', 'b677d07daf944b9eb2a86c65a4e564d3', 27, 2, 1, '2019-06-28 23:19:41', '2019-06-28 22:31:41', '2019-06-28 22:31:41');
INSERT INTO `oauth2_access_token` VALUES ('a3c64abbe7c64c0a8e1a8bc406c7e9ad', '9eae67fd0bbf41c2a2a7e2e91ebd9177', 27, 2, 1, '2019-06-25 19:19:24', '2019-06-25 18:31:24', '2019-06-25 18:31:24');
INSERT INTO `oauth2_access_token` VALUES ('a3df80b1e7e648b8b1c0785b0741e9ae', 'd15ab9faaa3345eba925adc3610f2b0f', 27, 2, 1, '2019-05-21 17:29:14', '2019-05-21 16:41:13', '2019-05-21 16:41:13');
INSERT INTO `oauth2_access_token` VALUES ('a3e0acabc3b445efb49b2e38574592a0', '5055e043e0e445cdb73c8b0b3f18bd51', 27, 2, 1, '2019-06-15 15:33:37', '2019-06-15 14:45:36', '2019-06-15 14:45:36');
INSERT INTO `oauth2_access_token` VALUES ('a3ec7d9b99704fe58afa4faaa409c17e', 'a1dbeac5a6e841c3a1af959973cd9592', 27, 2, 1, '2019-07-19 11:38:49', '2019-07-19 10:50:49', '2019-07-19 10:50:49');
INSERT INTO `oauth2_access_token` VALUES ('a40566874c644af2be1940d0d39b9f38', '7c7de38b780d411f8db476fffddfe4ab', NULL, NULL, 1, '2019-05-08 23:38:40', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a43f11a11ec14c0c8d27e86a4a684124', 'ac52e966a7a049de8db388100f3f9b00', 27, 2, 1, '2019-05-28 15:15:49', '2019-05-28 14:27:48', '2019-05-28 14:27:48');
INSERT INTO `oauth2_access_token` VALUES ('a44d7ca6202341e39e8f61f33eb02ff0', 'f1b6d995851c4c329fe3f6bc6ee18bbc', 27, 2, 1, '2019-06-13 19:21:23', '2019-06-13 18:33:22', '2019-06-13 18:33:22');
INSERT INTO `oauth2_access_token` VALUES ('a45418a2dbbc45ee82bd4410702ad1be', '1fa235dde93d41d5a3f6ecf406fc5306', NULL, NULL, 1, '2019-03-21 18:45:26', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a457f438491443b88cd1639cac25e5bb', '7f190e022a654199937c13fc2084eee3', 27, 2, 1, '2019-07-09 22:00:01', '2019-07-09 21:12:00', '2019-07-09 21:12:00');
INSERT INTO `oauth2_access_token` VALUES ('a4a3e9ff15524b339769a66eb9a2a53e', '3306f3b02f1d46f097d3089fbaee1228', 27, 2, 1, '2019-06-25 18:28:35', '2019-06-25 17:40:34', '2019-06-25 17:40:34');
INSERT INTO `oauth2_access_token` VALUES ('a4b65a7137c44d9dae1a449fbfbbfa0a', '306a7fb3a479473ab512755157580d7b', 27, 2, 1, '2019-06-02 14:23:42', '2019-06-02 13:35:42', '2019-06-02 13:35:42');
INSERT INTO `oauth2_access_token` VALUES ('a4c7eff636e54b8ab66248a6f989fe09', '0f9e55b6decf4817855866f6691632d8', NULL, NULL, 1, '2019-05-11 18:47:00', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a4c8c08b187c413e957f317f42aaae4b', '27fbe8cb56ce409a970f5c35d5fcfc22', 27, 2, 1, '2019-07-22 15:41:22', '2019-07-22 14:53:22', '2019-07-22 14:53:22');
INSERT INTO `oauth2_access_token` VALUES ('a4c9e37c1d1143e0a8496da17342777f', '2c0810614139426fbe86a72ff97440cb', 27, 2, 1, '2019-08-25 13:01:34', '2019-08-25 12:13:33', '2019-08-25 12:13:33');
INSERT INTO `oauth2_access_token` VALUES ('a4db487b1d4742848d79908e40803fe2', '51448ebfdee54d4eaf9cbc4358f003df', 27, 2, 1, '2019-08-30 16:49:29', '2019-08-30 16:01:29', '2019-08-30 16:01:29');
INSERT INTO `oauth2_access_token` VALUES ('a4f1ad90f4a14b67a03278a7abf6ce7c', '2683d1607fc9473dace87a371872d3af', 27, 2, 1, '2019-06-08 11:16:09', '2019-06-08 10:28:09', '2019-06-08 10:28:09');
INSERT INTO `oauth2_access_token` VALUES ('a50ac682be794bf19d2b94e40ba4ff4a', 'cbaee15cd85c4eca8af89fba6e2a5543', NULL, NULL, 1, '2019-04-22 19:13:58', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a51f0c2ee9a044ffa9d56e9f73951d68', '7bfa2598045c45c7a2b497a8be7df1a2', 27, 2, 1, '2019-06-15 12:16:40', '2019-06-15 11:28:40', '2019-06-15 11:28:40');
INSERT INTO `oauth2_access_token` VALUES ('a52e68d12ec246fe9ef980ad751a8308', 'a99419f6e460402dbdd17ce176beeeb8', 27, 2, 1, '2019-06-21 10:10:41', '2019-06-21 09:22:40', '2019-06-21 09:22:40');
INSERT INTO `oauth2_access_token` VALUES ('a53760f06c4949058c6f165b031e1178', 'f07596fc05984eeba643189d5fce10e1', 27, 2, 1, '2019-06-03 01:25:03', '2019-06-03 00:37:02', '2019-06-03 00:37:02');
INSERT INTO `oauth2_access_token` VALUES ('a54de28d69d241d3a63f50d2d7e752d0', '3dce012695794b6a96405bce23d9ed96', 1, 2, 0, '2019-07-30 18:00:54', '2019-07-30 17:12:53', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('a55aa322be2842ed8a70f317c25cfc51', 'c3ccd76071d94d81b39dc7e5aed9c6bc', 27, 2, 1, '2019-07-04 23:14:51', '2019-07-04 22:26:51', '2019-07-04 22:26:51');
INSERT INTO `oauth2_access_token` VALUES ('a562aa73e8c847949cfede0a9d89a736', '1c40c8f76de44570956d2bbe773fdb90', 27, 2, 1, '2019-08-28 00:05:01', '2019-08-27 23:17:00', '2019-08-27 23:17:00');
INSERT INTO `oauth2_access_token` VALUES ('a56f51ad15b8496796dfe2422fbddec4', '8596ec6c17a34714988f7a6ce0d4b845', 27, 2, 1, '2019-06-30 15:36:23', '2019-06-30 14:48:23', '2019-06-30 14:48:23');
INSERT INTO `oauth2_access_token` VALUES ('a578fcb0308840599a64ce95a2630565', '85a4161903b1483e94f3b0ccc3223b34', 27, 2, 1, '2019-08-13 00:10:25', '2019-08-12 23:22:25', '2019-08-12 23:22:25');
INSERT INTO `oauth2_access_token` VALUES ('a57a71dd59cf40a5b47f3ae36a74e4e8', 'a8cb87dd98dc4c9e8bbe6add027b44e2', 27, 2, 1, '2019-07-16 22:55:20', '2019-07-16 22:07:20', '2019-07-16 22:07:20');
INSERT INTO `oauth2_access_token` VALUES ('a5864dc476a94f83adfbb6da0df4d7e7', '302378b3b06e4a229d7d81e70fd12ff4', 27, 2, 1, '2019-05-27 11:28:18', '2019-05-27 10:40:17', '2019-05-27 10:40:17');
INSERT INTO `oauth2_access_token` VALUES ('a58d53ccc9164b909118cb8e481de036', '214238430e4e4ba28e8150dd17a50a13', NULL, NULL, 1, '2019-05-04 14:33:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a5ba03a5994e4f0c94e8d2fa9a6191f2', '0b87017f30b2479789c73f8b87a31a3f', NULL, NULL, 1, '2019-05-10 10:25:24', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a5c113a9009340e6856fe7454699e48a', '4837274635494c6c8c9e8ec7f5e3dfa7', 27, 2, 1, '2019-06-06 16:39:25', '2019-06-06 15:51:24', '2019-06-06 15:51:24');
INSERT INTO `oauth2_access_token` VALUES ('a5c96dbdf9d34cf6a05dc2684f3709cf', 'b0b1d11485d54aa597bfe2087b495c55', 27, 2, 1, '2019-07-02 15:04:33', '2019-07-02 14:16:32', '2019-07-02 14:16:32');
INSERT INTO `oauth2_access_token` VALUES ('a5d115f2a7e14d96bfb39ce2b91bf8a4', 'fde48eaf0dfa404795524c758ffc2d7d', 27, 2, 1, '2019-06-29 22:25:15', '2019-06-29 21:37:14', '2019-06-29 21:37:14');
INSERT INTO `oauth2_access_token` VALUES ('a5eaa3a5a1834afca75858fbaa463f75', '20626b40a62d4229a7eeccfb9006a21e', 27, 2, 1, '2019-07-04 23:18:18', '2019-07-04 22:30:18', '2019-07-04 22:30:18');
INSERT INTO `oauth2_access_token` VALUES ('a604478339fc48a59997c4af80d55591', 'c1427ff2c9dc457eb98071c5066a4586', 27, 2, 1, '2019-08-21 15:26:48', '2019-08-21 14:38:48', '2019-08-21 14:38:48');
INSERT INTO `oauth2_access_token` VALUES ('a606d7e4ee504397b266bc29bf07ffcb', '998179741da5460f856f175c9f329af1', 27, 2, 1, '2019-06-01 01:12:37', '2019-06-01 00:24:37', '2019-06-01 00:24:37');
INSERT INTO `oauth2_access_token` VALUES ('a60727bceabf4382b315f832710b2ea6', '2217997ed6ef4158939cf55a45abc467', 27, 2, 1, '2019-09-05 10:09:52', '2019-09-05 09:21:51', '2019-09-05 09:21:51');
INSERT INTO `oauth2_access_token` VALUES ('a611c90f662545f887cb271545fce166', '7980f51c16894058b01c257e21f9c14b', 27, 2, 1, '2019-06-05 20:59:31', '2019-06-05 20:11:31', '2019-06-05 20:11:31');
INSERT INTO `oauth2_access_token` VALUES ('a6214c7ebec445d8b6dc4217ba72adae', '0edfafd237134b9ca3e5f106565e6721', NULL, NULL, 1, '2019-04-22 20:30:57', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a62323dad4724b99b4474415a0d7a2d5', '2a011e7fcf0e4a11baf075c04d294618', 27, 2, 1, '2019-07-12 10:39:16', '2019-07-12 09:51:16', '2019-07-12 09:51:16');
INSERT INTO `oauth2_access_token` VALUES ('a633a19679bd4b4c9e375eced32eac7d', 'c0d8bd526da946309c1b77f505bc3113', 27, 2, 1, '2019-07-16 11:27:33', '2019-07-16 10:39:32', '2019-07-16 10:39:32');
INSERT INTO `oauth2_access_token` VALUES ('a66a5d5bf20b4cbfa3a3f95bfdbed127', 'b0935e3724014adb89bd31dbda638417', NULL, NULL, 1, '2019-05-09 15:14:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a68208c18a2a4eadada48a7af2ba7d7b', '17da5494009a4424aced0d3bfabe0c48', 27, 2, 1, '2019-06-07 14:52:23', '2019-06-07 14:04:23', '2019-06-07 14:04:23');
INSERT INTO `oauth2_access_token` VALUES ('a694b2ec67e84f8b9536e44cdac2e59d', '60537e26ba58422c825af5cf48713c9a', 27, 2, 1, '2019-07-16 11:07:25', '2019-07-16 10:19:25', '2019-07-16 10:19:25');
INSERT INTO `oauth2_access_token` VALUES ('a6aa50e08243419a8c7eea7a8d3ceda1', 'c3cfe2bee90a4a5cb2ea1272d64a999d', NULL, NULL, 1, '2019-05-10 15:08:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a6bc80b542ac408b9ab359f2132998e6', 'd8ccc7f67790402e97bc4cf134d87a27', 27, 2, 1, '2019-05-22 17:17:22', '2019-05-22 16:29:21', '2019-05-22 16:29:21');
INSERT INTO `oauth2_access_token` VALUES ('a6bd76ecd68441ed83d2b906b3c70b06', 'b16e8258f3f743e983b2ca63b53d88be', 27, 2, 1, '2019-07-25 14:17:20', '2019-07-25 13:29:19', '2019-07-25 13:29:19');
INSERT INTO `oauth2_access_token` VALUES ('a6c7449a44e243ff980a24645867e3ee', '75d192fcce16492aa7288164e02b89e6', 27, 2, 1, '2019-07-12 00:30:45', '2019-07-11 23:42:45', '2019-07-11 23:42:45');
INSERT INTO `oauth2_access_token` VALUES ('a6d01fbe9be2467c8261e3b1bd032492', 'fb5e774e474e460d9e7075f9cccb41d2', 27, 2, 1, '2019-06-05 16:26:19', '2019-06-05 15:38:19', '2019-06-05 15:38:19');
INSERT INTO `oauth2_access_token` VALUES ('a6eeeda1fea7469da7f26ef45440f664', 'dfd1734edf264f568e69fc273f67fdb5', 27, 2, 1, '2019-08-05 21:07:58', '2019-08-05 20:19:58', '2019-08-05 20:19:58');
INSERT INTO `oauth2_access_token` VALUES ('a712f5cb73224525bc315e738b51def2', '7318c0cc876348278d4311463e01ad6b', 27, 2, 1, '2019-06-06 12:26:01', '2019-06-06 11:38:00', '2019-06-06 11:38:00');
INSERT INTO `oauth2_access_token` VALUES ('a71f5fb63efc4ed5929bba150467de6c', '42f166f360084c3f9e32c1337e3dd7d8', 27, 2, 1, '2019-07-02 16:19:16', '2019-07-02 15:31:16', '2019-07-02 15:31:16');
INSERT INTO `oauth2_access_token` VALUES ('a7262d726f344877b0b79e0f3a8baaf0', '80a493040e7e4ad990bc65c46939a962', 27, 2, 1, '2019-06-17 13:17:45', '2019-06-17 12:29:45', '2019-06-17 12:29:45');
INSERT INTO `oauth2_access_token` VALUES ('a72671cd0c514fe39ae0fc96349b703b', '34ae2e278bcc403f90d68b91779f03a1', 27, 2, 1, '2019-05-25 10:17:51', '2019-05-25 09:29:50', '2019-05-25 09:29:50');
INSERT INTO `oauth2_access_token` VALUES ('a72b5cd6f885460daae28621b96e77cc', '93050f0d2bee4891afe1e9deabea8c5c', 27, 2, 1, '2019-06-02 23:12:51', '2019-06-02 22:24:50', '2019-06-02 22:24:50');
INSERT INTO `oauth2_access_token` VALUES ('a72dcb3bb55a48f4ac3e43e04e9c9140', '23c7cab60a974881ac702d708a6edf83', 27, 2, 1, '2019-08-04 23:01:46', '2019-08-04 22:13:45', '2019-08-04 22:13:45');
INSERT INTO `oauth2_access_token` VALUES ('a7356d63e4ca43789339765bbedc70fd', '3c2e09dc9f704c66ab597f300ea8ace4', 27, 2, 1, '2019-06-03 10:15:04', '2019-06-03 09:27:03', '2019-06-03 09:27:03');
INSERT INTO `oauth2_access_token` VALUES ('a73dfaceb19c490e9d0a255690f181b8', '31be07b5a5c64f6dbbf2a6b13cc7aea4', 27, 2, 1, '2019-05-31 23:32:16', '2019-05-31 22:44:15', '2019-05-31 22:44:15');
INSERT INTO `oauth2_access_token` VALUES ('a787b2c8007d4888bdb3c9cd5ae545b9', 'd35ad2962c05430dbb5681e8eb208065', NULL, NULL, 1, '2019-05-08 07:09:16', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a7c4c8864fb8407aac78b5500b62becb', 'f4718d1d51814c15a6e4bfb0e5f23ee3', NULL, NULL, 0, '2019-03-03 22:59:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a7d70e1125944a8d9f2496cb52285b5c', '02b304e237734f21afd658497548f97e', 27, 2, 1, '2019-07-26 03:41:01', '2019-07-26 02:53:01', '2019-07-26 02:53:01');
INSERT INTO `oauth2_access_token` VALUES ('a7e9ed51c7ce48dca265b085d523f336', '683bc7ea946d45be9017158298f8894e', 27, 2, 1, '2019-06-20 12:16:37', '2019-06-20 11:28:37', '2019-06-20 11:28:37');
INSERT INTO `oauth2_access_token` VALUES ('a7f76da6da8f4a30aecf02498117e6bf', '26c55bca13bc49d4a310de0c7e9abc54', NULL, NULL, 1, '2019-04-06 15:39:52', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a813e5a8ff23470d83afceec4799379a', '8d36e916355c4950ba67d5cb13db2b8e', 27, 2, 1, '2019-05-27 11:00:22', '2019-05-27 10:12:21', '2019-05-27 10:12:21');
INSERT INTO `oauth2_access_token` VALUES ('a81bf9c601654d8b895f20461904f1f4', 'ed27252fe767471f8f1a465754187fad', 27, 2, 1, '2019-07-26 00:12:18', '2019-07-25 23:24:17', '2019-07-25 23:24:17');
INSERT INTO `oauth2_access_token` VALUES ('a81ff781e3944a76bc058b0346e2d22b', '65f0a12a7e6748b3b99bdb4cf6e14bd6', 27, 2, 1, '2019-05-31 18:46:56', '2019-05-31 17:58:55', '2019-05-31 17:58:55');
INSERT INTO `oauth2_access_token` VALUES ('a843e51a9ee7401c97a3b7c29d420f42', 'd0e7738c952545ed8c4a2642f5692c36', 27, 2, 1, '2019-06-04 18:58:48', '2019-06-04 18:10:48', '2019-06-04 18:10:48');
INSERT INTO `oauth2_access_token` VALUES ('a86685d577b045edad4c767ed9eb3c6a', 'f00017bada24462092d869e855ea7d15', 27, 2, 1, '2019-06-12 10:28:25', '2019-06-12 09:40:24', '2019-06-12 09:40:24');
INSERT INTO `oauth2_access_token` VALUES ('a8880921ec7c430fbe5b41a3eed273eb', 'a3a363b1b71746538713360eb9cb59f4', 27, 2, 1, '2019-07-31 16:13:57', '2019-07-31 15:25:56', '2019-07-31 15:25:56');
INSERT INTO `oauth2_access_token` VALUES ('a8bbaa9e0add4315bbddc650d6224f75', 'a6fac9361cce4631b9ae8ac6c57ec62d', 27, 2, 1, '2019-08-08 17:57:15', '2019-08-08 17:09:15', '2019-08-08 17:09:15');
INSERT INTO `oauth2_access_token` VALUES ('a8bc457017d346c4b08cbe39efdd2de2', '55af69576ad94e01ac43d31684584720', 27, 2, 1, '2019-07-17 12:34:38', '2019-07-17 11:46:37', '2019-07-17 11:46:37');
INSERT INTO `oauth2_access_token` VALUES ('a8c4406f179340bdb44f982e06af9984', '5e685aa882934380886f74b3ca7ada0f', 27, 2, 1, '2019-06-30 18:30:56', '2019-06-30 17:42:56', '2019-06-30 17:42:56');
INSERT INTO `oauth2_access_token` VALUES ('a8c9994f203f46b687b8ee14a75526be', '4dc1a515ef094e04910dd578d5876824', NULL, NULL, 1, '2019-04-24 07:59:42', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a8d04ec437e54d93883dad6b36b46178', 'e6703048e4854ce086bb51931355c8db', 27, 2, 1, '2019-06-04 03:50:27', '2019-06-04 03:02:26', '2019-06-04 03:02:26');
INSERT INTO `oauth2_access_token` VALUES ('a8e420fec9624880ba7e74aa65a6d83a', '1d2d80f4557740b2bad4bcd572a4d090', 27, 2, 1, '2019-06-01 16:47:33', '2019-06-01 15:59:33', '2019-06-01 15:59:33');
INSERT INTO `oauth2_access_token` VALUES ('a911615ba0654e56be5e8f8dae55cd10', 'ee85e1f124224eb4a815dcce38936ad5', 27, 2, 1, '2019-07-18 17:50:16', '2019-07-18 17:02:16', '2019-07-18 17:02:16');
INSERT INTO `oauth2_access_token` VALUES ('a914fc5fa156419a9d2396e1c66ceba1', 'c319c003e0874185a5c0a85e4a3f72d0', 27, 2, 1, '2019-07-20 08:33:51', '2019-07-20 07:45:50', '2019-07-20 07:45:50');
INSERT INTO `oauth2_access_token` VALUES ('a91f5d62b16946eebb9963cec23377cf', '7613fd139e1f4a7cbf0d608a5ffb9a58', 27, 2, 1, '2019-05-30 21:08:21', '2019-05-30 20:20:20', '2019-05-30 20:20:20');
INSERT INTO `oauth2_access_token` VALUES ('a927acdcf15944c69a67a085441a6a92', 'd9acb6ba78d74fbfaa58b86380684d14', 27, 2, 1, '2019-08-07 18:11:06', '2019-08-07 17:23:05', '2019-08-07 17:23:05');
INSERT INTO `oauth2_access_token` VALUES ('a943c50e43e24d01b8b712354c401cf9', '9258776942cc49ec992ecc457e6cf0da', 27, 2, 1, '2019-06-03 23:07:38', '2019-06-03 22:19:37', '2019-06-03 22:19:37');
INSERT INTO `oauth2_access_token` VALUES ('a94531bab20442b6b250fca284b09135', 'b467dc41c7b04a69984f3e54630addc3', 27, 2, 1, '2019-05-28 14:08:00', '2019-05-28 13:19:59', '2019-05-28 13:19:59');
INSERT INTO `oauth2_access_token` VALUES ('a9467da90da74f8ab805ec8edda977f4', 'f5d11dc788d24fe7bf73a49254b38e4d', 27, 2, 1, '2019-06-28 10:23:17', '2019-06-28 09:35:16', '2019-06-28 09:35:16');
INSERT INTO `oauth2_access_token` VALUES ('a9501baeb2894a9b86711b9bafc6d722', '7cb164044f2e4474a9af0553bac5e004', NULL, NULL, 1, '2019-04-26 23:43:10', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a9599a1b212f46af8a7cd1988249804e', 'ed5e90d2d1fe460a9ea8330076a386f9', 27, 2, 1, '2019-06-02 00:10:15', '2019-06-01 23:22:15', '2019-06-01 23:22:15');
INSERT INTO `oauth2_access_token` VALUES ('a96d1c4e127f42e6ba2759ec540f59c5', 'a9914d3d10b643eb91f0658b51439d74', 27, 2, 1, '2019-05-27 15:04:11', '2019-05-27 14:16:10', '2019-05-27 14:16:10');
INSERT INTO `oauth2_access_token` VALUES ('a970caf5ae2049bf951f265983a7f899', '659911347198420cacd62a597f387fb3', 27, 2, 1, '2019-08-01 10:29:09', '2019-08-01 09:41:08', '2019-08-01 09:41:08');
INSERT INTO `oauth2_access_token` VALUES ('a9753b25730244b88901492566808967', 'a364fc82d00b4d35a2e4f0cc40d41f24', 27, 2, 1, '2019-08-28 14:56:35', '2019-08-28 14:08:34', '2019-08-28 14:08:34');
INSERT INTO `oauth2_access_token` VALUES ('a99eeb9c23b145a4bae3baca2431d6db', '6d7a6ddd44a84dd886cf7df92c94e95c', 27, 2, 1, '2019-06-19 22:06:57', '2019-06-19 21:18:56', '2019-06-19 21:18:56');
INSERT INTO `oauth2_access_token` VALUES ('a9a8ef7fa0b64db9bf97cd78b79c26d0', '99faca6f90a54f87a47b6848add767ce', NULL, NULL, 1, '2019-04-02 10:35:07', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('a9b948afdc85412b94a864db3a57fa61', 'a7b249e6ee734a56a4a34bc4b719d4f7', 27, 2, 1, '2019-09-05 13:37:48', '2019-09-05 12:49:47', '2019-09-05 12:49:47');
INSERT INTO `oauth2_access_token` VALUES ('a9c3913baff94470bd0824ab89625cf4', '48331dca1d414a6cb97d63af77caf4b2', 27, 2, 1, '2019-05-20 11:34:35', '2019-05-20 10:46:35', '2019-05-20 10:46:35');
INSERT INTO `oauth2_access_token` VALUES ('a9c57a2334884efc93fd8ed41aa6c0ab', 'f69f49a9c8004c0f8cb3bf15e780a495', 27, 2, 1, '2019-06-05 15:06:52', '2019-06-05 14:18:51', '2019-06-05 14:18:51');
INSERT INTO `oauth2_access_token` VALUES ('a9e5692819504d4784b05a7c93f66f02', 'bda43292ddc94803a86a7b165074997c', 27, 2, 1, '2019-08-05 11:46:19', '2019-08-05 10:58:18', '2019-08-05 10:58:18');
INSERT INTO `oauth2_access_token` VALUES ('a9fe6013b808404897f73fe3a57b0a46', 'fcb545dc65e84d4fadfec8f0f292f6be', 182, 1, 1, '2019-07-27 01:33:27', '2019-07-27 00:45:26', '2019-07-27 00:45:26');
INSERT INTO `oauth2_access_token` VALUES ('aa0ff56944ce4be9ae0594830e797002', '325c94a8cb21474a99f0965f04bd1936', 1, 2, 0, '2019-05-31 17:50:15', '2019-05-31 17:00:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('aa279d8ba3514f97a52fae32b8b751dd', 'a8c16ccd94fb4a7d8199f3647113bc01', NULL, NULL, 1, '2019-05-13 10:42:32', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('aa32faf231174774a14a9fe8f851a3dc', '20efd531e6424a43ad1a9da5ad720072', 27, 2, 1, '2019-07-10 00:21:30', '2019-07-09 23:33:29', '2019-07-09 23:33:29');
INSERT INTO `oauth2_access_token` VALUES ('aa522fc34c7a4f43b6024a10762ecf95', 'c5c85b222b44451d80b0d60f38adf613', 27, 2, 1, '2019-06-14 19:07:55', '2019-06-14 18:19:54', '2019-06-14 18:19:54');
INSERT INTO `oauth2_access_token` VALUES ('aa5acf44788c49cd8b59cd6440dcb214', '59440c90d08747c68679bb6781052b5a', 27, 2, 1, '2019-06-28 16:00:45', '2019-06-28 15:12:45', '2019-06-28 15:12:45');
INSERT INTO `oauth2_access_token` VALUES ('aa5e6348c50c4c87a5134cec366d8476', '64da55fac0de4382bb2269c5363b5e8d', NULL, NULL, 1, '2019-04-22 19:08:33', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('aa5fa6ad249741558d116a35bd06b451', '61b2df468c0b4450a0e71b7483927092', NULL, NULL, 1, '2019-04-06 22:27:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('aa68c3f9cc99486d9cd71582ced1d9d8', 'ad302badcc3b49d58c4b1cd30bef5af2', 27, 2, 1, '2019-06-26 11:11:38', '2019-06-26 10:23:37', '2019-06-26 10:23:37');
INSERT INTO `oauth2_access_token` VALUES ('aa70545f973944d3b4e15362888b92a9', 'b5a8ff418b5242998882018d7cf41169', 27, 2, 1, '2019-08-20 18:31:18', '2019-08-20 17:43:17', '2019-08-20 17:43:17');
INSERT INTO `oauth2_access_token` VALUES ('aa7b458fe54f41a69477a6db79218bbf', '6ecde9cb148e4def8428360b60ff37d6', 27, 2, 1, '2019-06-12 20:13:46', '2019-06-12 19:25:46', '2019-06-12 19:25:46');
INSERT INTO `oauth2_access_token` VALUES ('aa9e887a7b784edfa741fbf20003cc61', 'b3634d149e6e45659fabd57b10b73a95', 27, 2, 1, '2019-06-06 18:15:55', '2019-06-06 17:27:55', '2019-06-06 17:27:55');
INSERT INTO `oauth2_access_token` VALUES ('aaae402483494629bc33a03ffc603d79', '245cfecb2fe54115be170c7baa66390f', 27, 2, 1, '2019-06-13 00:10:33', '2019-06-12 23:22:33', '2019-06-12 23:22:33');
INSERT INTO `oauth2_access_token` VALUES ('aab990c0a0fd402888dcc1061dd1d43f', '4b3d778cca19420cad3e6211c2d4f4bc', 27, 2, 1, '2019-07-23 06:54:55', '2019-07-23 06:06:54', '2019-07-23 06:06:54');
INSERT INTO `oauth2_access_token` VALUES ('aadd6e9e1735469f93642f27c02bdc55', '58eddf7fbe2845fe8ec0cf3e8c97ad3d', 1, 2, 0, '2019-07-02 11:20:47', '2019-07-02 10:32:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('aae7ddddafee4dc9a516afa38cc4ce99', 'f9b2829acf3848618ccbcf9a7f89f47b', 27, 2, 1, '2019-06-27 20:35:03', '2019-06-27 19:47:02', '2019-06-27 19:47:02');
INSERT INTO `oauth2_access_token` VALUES ('aaed6947b0084c249459c4c9f18334f9', '3eb6f12fa7654eb8b33a9ac0f1f26edf', 128, 1, 1, '2019-08-09 16:44:57', '2019-08-09 15:56:56', '2019-08-09 15:56:56');
INSERT INTO `oauth2_access_token` VALUES ('ab153b5715e046d5aa84fa94c6256e03', '5c7fa243d83f48e49a57fc609875d590', 27, 2, 1, '2019-06-13 11:55:37', '2019-06-13 11:07:36', '2019-06-13 11:07:36');
INSERT INTO `oauth2_access_token` VALUES ('ab1cf07687214eae9e6e26331f01311f', 'bd1d651fad304496a23c37a87f839df7', 27, 2, 1, '2019-06-21 15:41:40', '2019-06-21 14:53:39', '2019-06-21 14:53:39');
INSERT INTO `oauth2_access_token` VALUES ('ab24fca51b0e49d19f23539a92906754', 'da3712e64f88416996141aa55cb2cbec', 27, 2, 1, '2019-07-01 00:22:54', '2019-06-30 23:34:53', '2019-06-30 23:34:53');
INSERT INTO `oauth2_access_token` VALUES ('ab2716770df149b5a6715e83369eb786', 'dd2cd79360e84957959d12ffd1265f44', 27, 2, 1, '2019-06-24 17:18:26', '2019-06-24 16:30:26', '2019-06-24 16:30:26');
INSERT INTO `oauth2_access_token` VALUES ('ab4c763a34fc4dcdb5fa74b341cbf24d', '79f0fde5f04c4b678cdf3d7e49abd07a', 27, 2, 1, '2019-07-24 15:32:57', '2019-07-24 14:44:57', '2019-07-24 14:44:57');
INSERT INTO `oauth2_access_token` VALUES ('ab56f7d6454b47d888430c3ccb1517e7', 'a6205f936d1a491f955502d2c6c26088', 27, 2, 1, '2019-08-07 17:43:40', '2019-08-07 16:55:40', '2019-08-07 16:55:40');
INSERT INTO `oauth2_access_token` VALUES ('ab6da857a7484636ac576f3f33b7d727', '39be1f9789624c1098e21ccc0cc79097', 27, 2, 1, '2019-07-30 15:54:40', '2019-07-30 15:06:40', '2019-07-30 15:06:40');
INSERT INTO `oauth2_access_token` VALUES ('ab7d78cf4209452586c5d547b7f022cc', 'dfb78452628a4884b8e19d5fb3881e80', NULL, NULL, 1, '2019-03-21 20:39:25', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ab96feab1f55497cbc9a8a6cdbc1158f', 'cc9edc110d324678a9a535d6e6f58520', 27, 2, 1, '2019-06-19 15:21:53', '2019-06-19 14:33:52', '2019-06-19 14:33:52');
INSERT INTO `oauth2_access_token` VALUES ('ab97f5e475c94b8d8480fcf54854d625', 'e8dc47f9baec4a2786efc6dcba62d47b', 27, 2, 1, '2019-06-04 13:26:56', '2019-06-04 12:38:55', '2019-06-04 12:38:55');
INSERT INTO `oauth2_access_token` VALUES ('ab9f174c529c43229fb6688de0304abd', '8ea153c179c34b468590e1f0794d2e0b', 27, 2, 1, '2019-08-04 22:16:03', '2019-08-04 21:28:03', '2019-08-04 21:28:03');
INSERT INTO `oauth2_access_token` VALUES ('aba3a98eb4e54162918f2d84a39da8a2', '246657b443064cdcae2d65fb078cb241', 79, 1, 1, '2019-05-23 15:15:45', '2019-05-23 14:27:44', '2019-05-23 14:27:44');
INSERT INTO `oauth2_access_token` VALUES ('abc8f699b3674792949a670dd47bd491', '6045ded655f34365b121b71b6e46cd25', 27, 2, 1, '2019-06-06 16:39:52', '2019-06-06 15:51:52', '2019-06-06 15:51:52');
INSERT INTO `oauth2_access_token` VALUES ('abe5015e91754e9dbcd94c42ca6ccdb9', 'cbcd096eaa204c54a1f2d49eb8e58568', 27, 2, 1, '2019-06-03 12:44:57', '2019-06-03 11:56:57', '2019-06-03 11:56:57');
INSERT INTO `oauth2_access_token` VALUES ('abfd4563e620444aa92ad3cae329441d', 'c999ce39b10d45fb88d6183272330702', NULL, NULL, 1, '2019-05-09 15:16:38', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ac3395e517374acf899923419e5ae601', '59e511c5fa6f4f3db07b1e37d49734fc', NULL, NULL, 1, '2019-04-28 17:39:13', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ac386cfa2ec24417b1dee959bcc3414b', '71aae81465b0442aad484f90abb6e40d', 27, 2, 1, '2019-08-02 18:37:34', '2019-08-02 17:49:33', '2019-08-02 17:49:33');
INSERT INTO `oauth2_access_token` VALUES ('ac399644a82c4a27855971902b1dc939', 'de63474945d041148c6c100cad67341f', NULL, NULL, 1, '2019-04-28 14:52:32', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ac3a2d9a63a54e3fa9249bdb91b1a8b0', 'e6d50f801ea0434c8d46b3ef933ab788', 27, 2, 1, '2019-06-28 16:08:26', '2019-06-28 15:20:26', '2019-06-28 15:20:26');
INSERT INTO `oauth2_access_token` VALUES ('ac61f79cc7264c02b93b07a8700609a4', 'abf2fe1038d64015a55bac1bb1ca13bd', NULL, NULL, 1, '2019-05-09 21:35:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ac731085b2c0423aab58f6e1bf6466e9', '031f97cf7d164e8cb1303002c1532667', 27, 2, 1, '2019-06-04 10:57:49', '2019-06-04 10:09:48', '2019-06-04 10:09:48');
INSERT INTO `oauth2_access_token` VALUES ('ac7cf3e6b89248268e55c30cce4f1777', '4565195d08cb4a5ea8f5386b59eee709', 27, 2, 1, '2019-08-02 18:43:19', '2019-08-02 17:55:18', '2019-08-02 17:55:18');
INSERT INTO `oauth2_access_token` VALUES ('ac830d1b350148f2a6511c8c3b07abf0', '52bce1d29f4b49bdb30231d65408bc01', 27, 2, 1, '2019-06-03 10:33:04', '2019-06-03 09:45:03', '2019-06-03 09:45:03');
INSERT INTO `oauth2_access_token` VALUES ('ac868ea564774f9097ec5865519bcc60', 'dd20fe554b45435098b495f34a985452', 27, 2, 1, '2019-08-03 00:50:30', '2019-08-03 00:02:29', '2019-08-03 00:02:29');
INSERT INTO `oauth2_access_token` VALUES ('ac87164af5464976a0946a4f0f2bc73e', 'ae8b7bc97f564fcbb58767df4a54e61f', 27, 2, 1, '2019-08-21 17:03:53', '2019-08-21 16:15:53', '2019-08-21 16:15:53');
INSERT INTO `oauth2_access_token` VALUES ('ac8afc242135445e91ebd77d1d10e233', '9bfa38bb0b3043ea8af918f333733c5f', 27, 2, 1, '2019-07-01 18:42:11', '2019-07-01 17:54:10', '2019-07-01 17:54:10');
INSERT INTO `oauth2_access_token` VALUES ('ac8c8afb71794f37953baf34e4d9ffb2', '5740261c6679411bb11c4a988eb1fd42', NULL, NULL, 1, '2019-04-22 19:15:03', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ac95a469208c4a9085ea84d3767ed47d', '46e7dfb0749f4e8984c0731cfaf65f9b', 27, 2, 1, '2019-07-15 21:20:44', '2019-07-15 20:32:43', '2019-07-15 20:32:43');
INSERT INTO `oauth2_access_token` VALUES ('ac9935d5c474479d9883c2208b2d2c84', '0896a8093f974dbd8d55e8a64335d808', 27, 2, 1, '2019-08-21 09:55:18', '2019-08-21 09:07:18', '2019-08-21 09:07:18');
INSERT INTO `oauth2_access_token` VALUES ('ac9e15e7b9c945ee8e805a1720f395d0', '9acdf618749c4c73a7baadd6e0686808', 27, 2, 1, '2019-06-11 15:49:58', '2019-06-11 15:01:57', '2019-06-11 15:01:57');
INSERT INTO `oauth2_access_token` VALUES ('aca124a2328b439e8ba9729f27a52e2d', 'acea6d853f194fbaa43fd0edc973d973', NULL, NULL, 1, '2019-05-08 12:06:23', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('aca354f4f12c41fc98c5a29b9de1cd75', '0cdba1aedb124196af223512f57a15ed', 27, 2, 1, '2019-08-02 23:54:32', '2019-08-02 23:06:31', '2019-08-02 23:06:31');
INSERT INTO `oauth2_access_token` VALUES ('acdd316881d9450c8381b8eae64f3848', '5775064e5fca4e6ab44ec162fd97977b', NULL, NULL, 1, '2019-05-09 17:33:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('aceaf83db881460caa0b107c15c305bd', '586a2056377e49938f0d0a7272ca84e2', NULL, NULL, 1, '2019-05-01 01:44:46', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('acf90694e0704e7bb52d779a58cc35ed', 'c86ce7b18572462ba92a74c76ff6c221', 27, 2, 1, '2019-08-29 22:11:52', '2019-08-29 21:23:51', '2019-08-29 21:23:51');
INSERT INTO `oauth2_access_token` VALUES ('ad1a8382ca9d4fb0bd457a04101af00e', '1e56a4038f2843738a486c25d5671232', 27, 2, 1, '2019-06-03 17:10:12', '2019-06-03 16:22:11', '2019-06-03 16:22:11');
INSERT INTO `oauth2_access_token` VALUES ('ad1b1cae211b4b699dc486a20619cfc6', 'fcc4acab7c18444a98be3b87c482631c', NULL, NULL, 1, '2019-04-26 16:42:27', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ad3363f96dfb4da5aabcd2505d804c32', '1b4c5fcf0d7e4226a57bb093c2f513b0', 27, 2, 1, '2019-06-01 11:20:24', '2019-06-01 10:32:24', '2019-06-01 10:32:24');
INSERT INTO `oauth2_access_token` VALUES ('ad3b844598f948d0bb8b67d851731d1d', 'd3daaff2258541c182b694d5b4284e3a', 27, 2, 1, '2019-05-29 16:48:43', '2019-05-29 16:00:42', '2019-05-29 16:00:42');
INSERT INTO `oauth2_access_token` VALUES ('ad3d897ea2aa408cadaae092d386e786', '0ba1998885cb4ae2ab746b3f72a0a826', 27, 2, 1, '2019-08-30 16:06:33', '2019-08-30 15:18:32', '2019-08-30 15:18:32');
INSERT INTO `oauth2_access_token` VALUES ('ad4ce6c0483949a7881a97041826f976', '733366e02ba34c019e565c4cd22bf43e', 27, 2, 1, '2019-06-03 16:30:01', '2019-06-03 15:42:00', '2019-06-03 15:42:00');
INSERT INTO `oauth2_access_token` VALUES ('ad5bd2d4dc704cbf9e82025126679828', 'a6f3837acfde403c8a7618ea147f05aa', 27, 2, 1, '2019-08-07 18:07:07', '2019-08-07 17:19:06', '2019-08-07 17:19:06');
INSERT INTO `oauth2_access_token` VALUES ('ad6b53754f1b4dfe9b43299595ce1be3', '242767a229f74263a80fc506b940b485', 27, 2, 1, '2019-08-08 18:27:41', '2019-08-08 17:39:40', '2019-08-08 17:39:40');
INSERT INTO `oauth2_access_token` VALUES ('ad7ac05d63a3407fb5a2ccbb1d1cc2f3', '463d34ccbc94422b98b5f839213b8be5', 27, 2, 1, '2019-06-12 12:22:49', '2019-06-12 11:34:48', '2019-06-12 11:34:48');
INSERT INTO `oauth2_access_token` VALUES ('ad94e472ae234dff883dd7160c1fb4f6', '9dbca05d30824da7864ccf2dd640f62c', 27, 2, 1, '2019-07-13 18:12:32', '2019-07-13 17:24:31', '2019-07-13 17:24:31');
INSERT INTO `oauth2_access_token` VALUES ('adaed8403520416fb6d9b61d71fecf5d', '0aa3020c676a44b0840a72f815b357c0', 27, 2, 1, '2019-06-27 15:14:56', '2019-06-27 14:26:55', '2019-06-27 14:26:55');
INSERT INTO `oauth2_access_token` VALUES ('adb8c455a1034fbc9cfad2806ea09c19', '720825a399be46bca98871ad4e9dffe8', 27, 2, 1, '2019-07-24 10:41:23', '2019-07-24 09:53:22', '2019-07-24 09:53:22');
INSERT INTO `oauth2_access_token` VALUES ('adb943b8d16545dba555ee701ccc519f', 'a633edc1fc4d4c3fa6197a63fae6907b', NULL, NULL, 1, '2019-03-12 15:16:49', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ade4de2f77f64d389ff0881039d94c3b', '7811849fbed54d7c84991d1202aa517e', 27, 2, 1, '2019-09-06 17:53:06', '2019-09-06 17:05:05', '2019-09-06 17:05:05');
INSERT INTO `oauth2_access_token` VALUES ('adfb07b9a2624098879ec1c255ef54d6', '45b5a508a90f419f885e3df1402d1f1f', 27, 2, 1, '2019-08-18 11:59:31', '2019-08-18 11:11:30', '2019-08-18 11:11:30');
INSERT INTO `oauth2_access_token` VALUES ('ae1d68e2f5634faaa211e209187463b5', 'a79134b6a0eb4a6dba99d173146a1f47', 27, 2, 1, '2019-08-27 19:59:36', '2019-08-27 19:11:36', '2019-08-27 19:11:36');
INSERT INTO `oauth2_access_token` VALUES ('ae245aa791ee499898eb628ee77f6b3e', '0e1b7761b8954761932f07a2945a9b4b', NULL, NULL, 1, '2019-05-06 17:04:46', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ae314d4616cb4ef498088cb98f0bfde5', '07154717dfff4459b2a02da0defa83c7', 173, 1, 1, '2019-07-17 08:17:40', '2019-07-17 07:29:40', '2019-07-17 07:29:40');
INSERT INTO `oauth2_access_token` VALUES ('ae34a36279d94fa8826d8ac00483216b', 'e0a18604955f48b3b19dae73f1c76e17', NULL, NULL, 1, '2019-03-13 00:49:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ae3a734eadf345b1a0e4b0b60e8c82c4', 'ba229229a95c4f319546cdaa76e7d207', 27, 2, 1, '2019-06-01 17:26:17', '2019-06-01 16:38:17', '2019-06-01 16:38:17');
INSERT INTO `oauth2_access_token` VALUES ('ae3e6b18ef924a90b7674e0de6852b44', 'ac14387b0cca447d9f41f608f1a646ae', 27, 2, 1, '2019-05-20 23:53:03', '2019-05-20 23:05:03', '2019-05-20 23:05:03');
INSERT INTO `oauth2_access_token` VALUES ('ae45ef8f7cd2415bb79094f601f4e8c7', 'c7831dcbd43a450aaebbaf838617f6b9', NULL, NULL, 1, '2019-03-30 22:35:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ae5489b9c5d1466e81db67c7e3641af1', '7166ff6838ea4efa9d33fe9e9ffe5b16', 27, 2, 1, '2019-06-01 08:19:46', '2019-06-01 07:31:45', '2019-06-01 07:31:45');
INSERT INTO `oauth2_access_token` VALUES ('ae645f6b9e4845849c78dfb62c8d3a4a', '9bb8a15b957f4c288ecad2ba2c21686d', 27, 2, 1, '2019-07-06 19:13:50', '2019-07-06 18:25:49', '2019-07-06 18:25:49');
INSERT INTO `oauth2_access_token` VALUES ('aeae463b79a14622b5c3f864795a55d9', 'e07bfa1a8f6c4baa8d700529fd0462db', 27, 2, 1, '2019-07-15 19:16:34', '2019-07-15 18:28:34', '2019-07-15 18:28:34');
INSERT INTO `oauth2_access_token` VALUES ('aeb8ef7c25664515ae90c20f7abe9bc3', 'eb40e2528f1348e9b3dc027e3f0d466e', 27, 2, 1, '2019-08-01 23:47:40', '2019-08-01 22:59:40', '2019-08-01 22:59:40');
INSERT INTO `oauth2_access_token` VALUES ('aebb0458d3a84db98496462931182846', '3f0b977aa0ce4996996a114f23cac192', 28, 2, 1, '2019-09-08 23:48:15', '2019-09-08 23:00:15', '2019-09-08 23:00:15');
INSERT INTO `oauth2_access_token` VALUES ('aedec11a3cd34e099505ca2403c8ae37', '944e986a683842f1a290b02fb4d5fb93', NULL, NULL, 1, '2019-05-10 14:34:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('aeeac74ae38246a4a8b3e85074bae2df', '517b3f14769d41a69da2f7f85c547dac', 27, 2, 1, '2019-06-01 18:55:22', '2019-06-01 18:07:22', '2019-06-01 18:07:22');
INSERT INTO `oauth2_access_token` VALUES ('aeed9016a4d34130b211629ffbd3acde', 'a64e6404a2ab4b34826f3e608a38b092', 27, 2, 1, '2019-06-24 14:52:41', '2019-06-24 14:04:41', '2019-06-24 14:04:41');
INSERT INTO `oauth2_access_token` VALUES ('aef39b87b6b94ca5850c90d429fa6da4', 'c02ac9669c524e598706086de9dd2c52', 27, 2, 1, '2019-07-30 19:09:37', '2019-07-30 18:21:36', '2019-07-30 18:21:36');
INSERT INTO `oauth2_access_token` VALUES ('aef97b4274f34708bf9fd663f926f2ad', '4074705836b74f26a1ade27df58c98c5', 27, 2, 1, '2019-06-03 15:31:50', '2019-06-03 14:43:49', '2019-06-03 14:43:49');
INSERT INTO `oauth2_access_token` VALUES ('af1c72603ceb4654911ea7c7ab8146c3', 'e20e85c7c9e742ad95c9572e1abc6444', 27, 2, 1, '2019-06-20 11:07:38', '2019-06-20 10:19:37', '2019-06-20 10:19:37');
INSERT INTO `oauth2_access_token` VALUES ('af2ea045b14c4934877ad4e3d9a9d0cf', '94bf4f4fcc844f658de2367f3d054ae5', 27, 2, 1, '2019-08-30 11:19:24', '2019-08-30 10:31:23', '2019-08-30 10:31:23');
INSERT INTO `oauth2_access_token` VALUES ('af3321051abd44cc9e1c86dbe04324a3', '3a4786b446bf43768d1888cd27182127', 27, 2, 1, '2019-07-15 15:02:34', '2019-07-15 14:14:34', '2019-07-15 14:14:34');
INSERT INTO `oauth2_access_token` VALUES ('af368acb63f84de9bc453b4563190a46', '36dc9dc806d64139ab7fec432514a244', 27, 2, 1, '2019-06-19 09:35:54', '2019-06-19 08:47:53', '2019-06-19 08:47:53');
INSERT INTO `oauth2_access_token` VALUES ('af5d24b1eb3942ebb1542659649c26b7', 'e8f17f5b25d84dddba55e5cd53f70cef', NULL, NULL, 1, '2019-05-05 16:51:00', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('af689582319d46759beec0cb69763357', '8e94a8e5b847477db4622cbf1d84d4ce', 27, 2, 1, '2019-07-02 10:11:53', '2019-07-02 09:23:53', '2019-07-02 09:23:53');
INSERT INTO `oauth2_access_token` VALUES ('af71da0fea734184adace2686a51283b', 'f30023e5678d4688a53a7e9a0b804320', 1, 2, 0, '2019-06-10 10:38:03', '2019-06-10 09:50:03', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('af7df46a41694fe2a2a1390374ff4c3c', '56d7e45f4c664588af331c112b6355b5', 27, 2, 1, '2019-08-06 00:31:53', '2019-08-05 23:43:52', '2019-08-05 23:43:52');
INSERT INTO `oauth2_access_token` VALUES ('af82e80ec2dc4e5993151c7553f6322e', '3f2411b7e85846d7803ebebce5ae1f05', 27, 2, 1, '2019-06-24 17:18:37', '2019-06-24 16:30:37', '2019-06-24 16:30:37');
INSERT INTO `oauth2_access_token` VALUES ('afaefa27f09743f3ac7e352976d27d19', 'e566831f9111433a99c9db5b2da54ec0', 27, 2, 1, '2019-06-25 17:53:12', '2019-06-25 17:05:11', '2019-06-25 17:05:11');
INSERT INTO `oauth2_access_token` VALUES ('afaf24bd8d8f4d29b5b9ecd7590e8e44', '1f9a0474e43549de9e5558cc812502df', 27, 2, 1, '2019-05-31 09:03:47', '2019-05-31 08:15:47', '2019-05-31 08:15:47');
INSERT INTO `oauth2_access_token` VALUES ('afc63a48aa134b459ae715895def7e63', '80c6076079e94029ac7c56042c009000', 1, 2, 0, '2019-05-16 18:05:42', '2019-05-16 17:17:42', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('afce2b4d2b1b455896baa07af2ff293c', '7da154e51d1f432aa3abd89d5a5586a7', 27, 2, 1, '2019-06-02 13:08:56', '2019-06-02 12:20:55', '2019-06-02 12:20:55');
INSERT INTO `oauth2_access_token` VALUES ('afd04a7539ed4078b09304a07b3df540', '86678ed6008449b098ac301295206aac', 1, 2, 0, '2019-05-17 14:16:29', '2019-05-17 13:28:28', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('afd63ee9a8b94d7786e3c452824e8bf7', '0093654120424f848b1dc716b5444b96', 27, 2, 1, '2019-06-25 18:30:30', '2019-06-25 17:42:30', '2019-06-25 17:42:30');
INSERT INTO `oauth2_access_token` VALUES ('afd64f9a7dd046d9a7a036128836db30', 'adfcbbdfe73a41238719e30d8524f49c', 27, 2, 1, '2019-06-03 16:14:28', '2019-06-03 15:26:27', '2019-06-03 15:26:27');
INSERT INTO `oauth2_access_token` VALUES ('afdbc37eb2b34d329218548512115361', '31be59fa37b44d7981c210da1a9c6411', NULL, NULL, 1, '2019-04-24 15:38:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('afdea89e51d347dfa6085f2c929a402f', '3256005fb19c44698366140c81e9f99c', 27, 2, 1, '2019-08-18 09:50:20', '2019-08-18 09:02:19', '2019-08-18 09:02:19');
INSERT INTO `oauth2_access_token` VALUES ('afe006a51aa745e48bc7a19778905a9c', '1464f9f51c4e44ad9e1c6128f000e7c5', 27, 2, 1, '2019-06-04 14:49:06', '2019-06-04 14:01:06', '2019-06-04 14:01:06');
INSERT INTO `oauth2_access_token` VALUES ('afe0e1d8fac64a22a94a21f9769943c3', '3d14efea15f741b9822f35b83dab91de', 27, 2, 1, '2019-09-02 23:32:28', '2019-09-02 22:44:28', '2019-09-02 22:44:28');
INSERT INTO `oauth2_access_token` VALUES ('aff953b3956643cbbad1e07cd721e2c3', '23a1e48f2fbd40e2abc4ebc3c4a310fe', NULL, NULL, 1, '2019-05-05 15:43:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b000291d1cbd4b6dadab2f9da3302153', 'cd6817012df148138f5b3363c9a3da3c', 27, 2, 1, '2019-06-13 20:25:39', '2019-06-13 19:37:38', '2019-06-13 19:37:38');
INSERT INTO `oauth2_access_token` VALUES ('b00097ba4c154dac8fb495ed63a97a4d', '02470e289f70450d99e0d542175ed041', 27, 2, 1, '2019-07-27 16:38:41', '2019-07-27 15:50:40', '2019-07-27 15:50:40');
INSERT INTO `oauth2_access_token` VALUES ('b006dfe040444b94b45d8e9eba58ba93', '6657768d2e0b45989a9a02179832dbbe', 27, 2, 1, '2019-07-05 10:33:39', '2019-07-05 09:45:39', '2019-07-05 09:45:39');
INSERT INTO `oauth2_access_token` VALUES ('b00a0ee100884b1a8ad3d1f4c3ddc418', '6871c1ce54214f2599180a7b1585ab76', 27, 2, 1, '2019-06-20 19:43:44', '2019-06-20 18:55:43', '2019-06-20 18:55:43');
INSERT INTO `oauth2_access_token` VALUES ('b00b27457a1b4f03948bd264002d4ed1', '2f059b48236240e08a97a078557b81e6', 27, 2, 1, '2019-06-01 17:48:48', '2019-06-01 17:00:47', '2019-06-01 17:00:47');
INSERT INTO `oauth2_access_token` VALUES ('b00d2a95621e4cebbf5b9b43ce2df6b3', 'ed79a50b107e4fa89b6316e61d58f15f', 27, 2, 1, '2019-06-27 15:08:34', '2019-06-27 14:20:34', '2019-06-27 14:20:34');
INSERT INTO `oauth2_access_token` VALUES ('b013e0b87adf4777ac97b780ea7d8d27', '07a236dc86464c6ba22b7d2fcc78ca32', NULL, NULL, 1, '2019-04-30 18:28:01', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b019e6b264414501b207777efcb4df64', '203c3776e8094068aac0843d778039cf', 27, 2, 1, '2019-05-23 16:58:57', '2019-05-23 16:10:56', '2019-05-23 16:10:56');
INSERT INTO `oauth2_access_token` VALUES ('b0289c4a9a664a5da5d2a335424ea0d8', '861698ab242a46509c7d330ce3b95f6f', 27, 2, 1, '2019-07-12 10:39:08', '2019-07-12 09:51:08', '2019-07-12 09:51:08');
INSERT INTO `oauth2_access_token` VALUES ('b040ab316e314a6bb42efbf2842b8b11', '998914fceb8e467099cae7015ebb6441', 27, 2, 1, '2019-07-23 22:06:05', '2019-07-23 21:18:04', '2019-07-23 21:18:04');
INSERT INTO `oauth2_access_token` VALUES ('b051637caec34136ac80e08b64c5be22', '3fb81c06083c4c0f8df6a8c6106e9c6b', 27, 2, 1, '2019-06-26 10:11:08', '2019-06-26 09:23:07', '2019-06-26 09:23:07');
INSERT INTO `oauth2_access_token` VALUES ('b0616fb150854ae390ec362214456f76', '1697414b481d4cb9aa8b269fb01a4e42', 27, 2, 1, '2019-07-22 10:52:43', '2019-07-22 10:04:42', '2019-07-22 10:04:42');
INSERT INTO `oauth2_access_token` VALUES ('b076be971c474b42b074f8bd934859c9', 'a37846b0897f4451afce50f1c15dcd35', 27, 2, 1, '2019-07-08 12:37:59', '2019-07-08 11:49:58', '2019-07-08 11:49:58');
INSERT INTO `oauth2_access_token` VALUES ('b07c4786570c4e5ab2abad1946fd8f7a', '9437cb167718400881357f9e5e3aa098', 27, 2, 1, '2019-08-20 21:57:59', '2019-08-20 21:09:58', '2019-08-20 21:09:58');
INSERT INTO `oauth2_access_token` VALUES ('b0865ebc059848fe8c232bd9746ef8aa', 'ff64d6a9bdc44cf78351f06777a58709', 27, 2, 1, '2019-07-16 15:29:01', '2019-07-16 14:41:00', '2019-07-16 14:41:00');
INSERT INTO `oauth2_access_token` VALUES ('b0958911fb7b49e7bcbc6de3b2230279', '43c7196728ae4f3ca677b7b119f9d8c8', 27, 2, 1, '2019-06-26 17:08:52', '2019-06-26 16:20:51', '2019-06-26 16:20:51');
INSERT INTO `oauth2_access_token` VALUES ('b09fe95ec1354baca999f60051d00f4f', 'b894022c0d4243a6aa75d1e3791d6d3c', 27, 2, 1, '2019-07-01 10:40:21', '2019-07-01 09:52:21', '2019-07-01 09:52:21');
INSERT INTO `oauth2_access_token` VALUES ('b0a178e650df490393cf97d50b1c58d3', '8eac75e19cb14f809af455f9d6210ee8', 27, 2, 1, '2019-08-20 17:49:11', '2019-08-20 17:01:11', '2019-08-20 17:01:11');
INSERT INTO `oauth2_access_token` VALUES ('b0ac4d7d54f0418fbeec934dbdc543cb', '2b6b1ae0f0f04598a6d3bd1271eb9a59', 1, 2, 0, '2019-06-20 14:40:12', '2019-06-20 13:52:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('b0ad7a97db9d47a7aa6429e06a74bc1c', '7a78f845fa214e23a2c295d652ecbdd7', 27, 2, 1, '2019-07-20 10:46:58', '2019-07-20 09:58:58', '2019-07-20 09:58:58');
INSERT INTO `oauth2_access_token` VALUES ('b0c0dd6a06d048ab92a5ae05608c2edc', 'f7598e2b40ae46eba58b7512cdb09fe2', 27, 2, 1, '2019-08-19 18:54:46', '2019-08-19 18:06:46', '2019-08-19 18:06:46');
INSERT INTO `oauth2_access_token` VALUES ('b0c6614d07b44c818cf97a5a3ec5c538', 'c57bedc5f40b426ab702c0432ace9228', 27, 2, 1, '2019-07-03 18:11:47', '2019-07-03 17:23:46', '2019-07-03 17:23:46');
INSERT INTO `oauth2_access_token` VALUES ('b0dd5a56eba44652afea5e7d6fef36da', '2bb28a0ea12846f79329cb2f89680059', 27, 2, 1, '2019-06-17 15:13:43', '2019-06-17 14:25:42', '2019-06-17 14:25:42');
INSERT INTO `oauth2_access_token` VALUES ('b0e5c8ae5c19492ca382405bda8e1297', 'e0e9ac348dc7452aa3a72e23e9c3649e', NULL, NULL, 1, '2019-03-10 04:24:21', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b0f26fa5c25c4f529530703d3c0f50b3', '0ebcbd4b1b7443d7b8ddf6c2d305692a', NULL, NULL, 1, '2019-03-10 04:22:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b12e241197414ae2bebf49f1632de09b', '03aa8384eb8f4dcb99549976c49293f8', 131, 1, 1, '2019-06-21 14:58:56', '2019-06-21 14:10:56', '2019-06-21 14:10:56');
INSERT INTO `oauth2_access_token` VALUES ('b1434c26c9234e9d94fdd92394381ae2', '97e1e05edced45d9a9e6ac98ab9e2406', 27, 2, 1, '2019-06-25 18:33:55', '2019-06-25 17:45:55', '2019-06-25 17:45:55');
INSERT INTO `oauth2_access_token` VALUES ('b147d93665f446219701f24b49a398ba', '703c53b8f25b4da28d0e135eb0cd41dc', 27, 2, 1, '2019-07-13 21:04:40', '2019-07-13 20:16:39', '2019-07-13 20:16:39');
INSERT INTO `oauth2_access_token` VALUES ('b14eb73ea5134a8485c1302641028b7e', '97c644e1e7de4fe48c5fe5da943ebd3c', 27, 2, 1, '2019-05-23 14:20:48', '2019-05-23 13:32:48', '2019-05-23 13:32:48');
INSERT INTO `oauth2_access_token` VALUES ('b165425c578f4ea682730659fc3afb86', '0b30e9cc949e428a9371b3e4955ec0b3', 27, 2, 1, '2019-07-23 16:45:55', '2019-07-23 15:57:54', '2019-07-23 15:57:54');
INSERT INTO `oauth2_access_token` VALUES ('b181472de0a64531a57db848baaee3eb', '63db0c55cc42446e815fad6dbeb06120', 27, 2, 1, '2019-06-24 18:09:12', '2019-06-24 17:21:12', '2019-06-24 17:21:12');
INSERT INTO `oauth2_access_token` VALUES ('b185690ddc7a4035892dbbc057fafcaa', '94f25351a93b4ddc88c835b8c65c7f2c', 27, 2, 1, '2019-06-03 10:16:05', '2019-06-03 09:28:04', '2019-06-03 09:28:04');
INSERT INTO `oauth2_access_token` VALUES ('b1e6913f7bc6424587db5a04355847ad', '87313f0f8fcc4d5eac136794718525cf', 27, 2, 1, '2019-06-04 15:00:50', '2019-06-04 14:12:49', '2019-06-04 14:12:49');
INSERT INTO `oauth2_access_token` VALUES ('b1edb1333204477e9415c75b5fabc753', '80848e3c315c406fa9e4000aa07aad7e', 27, 2, 1, '2019-09-06 15:57:17', '2019-09-06 15:09:16', '2019-09-06 15:09:16');
INSERT INTO `oauth2_access_token` VALUES ('b1f74697ea9b45d1a7aad5a3a361167b', '2c65cd4a1d5a432aa94c88a938cfc8f9', 27, 2, 1, '2019-07-09 15:05:28', '2019-07-09 14:17:27', '2019-07-09 14:17:27');
INSERT INTO `oauth2_access_token` VALUES ('b1fcf2d036104baa994ffb47c4c86cff', '441e81821345460a89c3d9a5768893c3', 27, 2, 1, '2019-06-13 13:47:38', '2019-06-13 12:59:37', '2019-06-13 12:59:37');
INSERT INTO `oauth2_access_token` VALUES ('b2022263f26e47b0b006931f783ae897', 'dcce34653b7d46f8af95e00f060278e1', 27, 2, 1, '2019-08-16 17:13:35', '2019-08-16 16:25:34', '2019-08-16 16:25:34');
INSERT INTO `oauth2_access_token` VALUES ('b20a316a26994f229a6fd44487cc0b56', '777f14bf03424cb3972295fa0e65d314', 27, 2, 1, '2019-06-11 15:29:03', '2019-06-11 14:41:03', '2019-06-11 14:41:03');
INSERT INTO `oauth2_access_token` VALUES ('b242b59b542c4005b157cead63c00f59', 'ca6b4b227ec046189d82fc98b9143cce', 27, 2, 1, '2019-05-23 15:12:14', '2019-05-23 14:24:13', '2019-05-23 14:24:13');
INSERT INTO `oauth2_access_token` VALUES ('b24ab941513e432a9ba75c3de326c593', '585873617cb045ecb72e9067476e4f6a', NULL, NULL, 1, '2019-05-10 12:14:15', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b256cb2cce08447cb91b252458ab59bf', 'dffb0566dd6a4b29afcce05c04148acd', 27, 2, 1, '2019-08-09 17:36:17', '2019-08-09 16:48:17', '2019-08-09 16:48:17');
INSERT INTO `oauth2_access_token` VALUES ('b25991ff9f5245c9962ad83ed5320022', '0eff8baec52e491fbdb9c73611d5671d', 221, 1, 1, '2019-09-05 16:00:28', '2019-09-05 15:12:27', '2019-09-05 15:12:27');
INSERT INTO `oauth2_access_token` VALUES ('b27f64d4466841d189c2e32b7ba5e9b5', 'e47c3afce2924163bf2923046f40665c', 27, 2, 1, '2019-09-08 23:34:25', '2019-09-08 22:46:24', '2019-09-08 22:46:24');
INSERT INTO `oauth2_access_token` VALUES ('b29e2ac5e461417a973f04f2c72da47f', '8df5c959189a419dab7c2a0dced5bc1e', 27, 2, 1, '2019-07-17 21:07:05', '2019-07-17 20:19:05', '2019-07-17 20:19:05');
INSERT INTO `oauth2_access_token` VALUES ('b2b105a25b494bc9906c65ee8c58d5cb', '852fcc089a5547af88fbf5e175868c46', 1, 2, 0, '2019-09-05 23:46:01', '2019-09-05 22:58:00', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('b2bb303f25d24a64bed01c2d216b9048', 'b35f35b6a7214b0aba7958640e6c2f37', 27, 2, 1, '2019-07-16 14:39:54', '2019-07-16 13:51:53', '2019-07-16 13:51:53');
INSERT INTO `oauth2_access_token` VALUES ('b2dc4a4927184da7a8baf89af79d5f15', 'e50bf80533104b829d6b67c198eaadd1', 27, 2, 1, '2019-06-01 16:21:54', '2019-06-01 15:33:54', '2019-06-01 15:33:54');
INSERT INTO `oauth2_access_token` VALUES ('b2e1b20dfe684388a2a9ced564aee44c', 'ed482b4b2fba4ab89b2caebf3c77927b', 27, 2, 1, '2019-08-28 21:06:29', '2019-08-28 20:18:28', '2019-08-28 20:18:28');
INSERT INTO `oauth2_access_token` VALUES ('b2e81ae2e1ab4b1b8ad87e748d9fb315', '4df7a01a59694b9d8773516cebb8ea06', 27, 2, 1, '2019-09-08 17:44:36', '2019-09-08 16:56:35', '2019-09-08 16:56:35');
INSERT INTO `oauth2_access_token` VALUES ('b2fac60b14194937b104376648f9709d', '7a270279270a48adb53958de1510e505', 27, 2, 1, '2019-07-02 11:58:42', '2019-07-02 11:10:41', '2019-07-02 11:10:41');
INSERT INTO `oauth2_access_token` VALUES ('b3091bd8503148c888a613daca595074', '32ed5e94bf0e433b84c9e3ed8d32bae1', 27, 2, 1, '2019-07-15 15:58:33', '2019-07-15 15:10:33', '2019-07-15 15:10:33');
INSERT INTO `oauth2_access_token` VALUES ('b30a16c7682246d2b569b9a32f2c2595', '6b45e1bff9194ddb8b0694bf8ef0e490', 1, 2, 0, '2019-07-07 16:45:37', '2019-07-07 15:57:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('b30c894698aa4459be3f3eb0aa814531', 'a6c680087f164fc0a65e9c62f8dd659e', 27, 2, 1, '2019-07-08 11:55:42', '2019-07-08 11:07:41', '2019-07-08 11:07:41');
INSERT INTO `oauth2_access_token` VALUES ('b31e69d1d28f4faba71afcc75b55ebc7', '2649ac5f073a477dbbbd94af6f458775', 27, 2, 1, '2019-09-03 16:00:10', '2019-09-03 15:12:09', '2019-09-03 15:12:09');
INSERT INTO `oauth2_access_token` VALUES ('b3365223dc854bf79306222f9fc1130e', '18c3c1bf9beb413cb218fb89d92036ab', 27, 2, 1, '2019-06-16 12:45:48', '2019-06-16 11:57:48', '2019-06-16 11:57:48');
INSERT INTO `oauth2_access_token` VALUES ('b35d1507d69247a5afbe59448d019dcf', 'e76c7d8874ec4122b02eb054d2caf842', 27, 2, 1, '2019-07-04 11:49:18', '2019-07-04 11:01:18', '2019-07-04 11:01:18');
INSERT INTO `oauth2_access_token` VALUES ('b3779b6776794c909bc752d353d2c995', 'b9c670ab4dee48a0a5b9a52fd0e54b29', NULL, NULL, 1, '2019-05-10 13:11:27', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b381e30610c8422a87c1d9304c21ea95', '172b918e72cc47328a7a41086f7d47ce', 27, 2, 1, '2019-08-06 10:11:56', '2019-08-06 09:23:56', '2019-08-06 09:23:56');
INSERT INTO `oauth2_access_token` VALUES ('b38535380bfc418a8369126d0f9c2dc6', 'f5a863ea55c9448e86cefae58eaa18b1', 27, 2, 1, '2019-05-31 23:37:39', '2019-05-31 22:49:38', '2019-05-31 22:49:38');
INSERT INTO `oauth2_access_token` VALUES ('b3925960365f4e6f96dc3f0f567306a6', '3ba7d9964f344b9ea0c8ec235f058bcf', 27, 2, 1, '2019-07-18 09:53:40', '2019-07-18 09:05:39', '2019-07-18 09:05:39');
INSERT INTO `oauth2_access_token` VALUES ('b3a4f73a6f6e4913b5cb1a776f5e727e', 'b6b688f7568747f9a1180b8362525774', 27, 2, 1, '2019-08-07 18:32:50', '2019-08-07 17:44:49', '2019-08-07 17:44:49');
INSERT INTO `oauth2_access_token` VALUES ('b3a899de37a9406e88ae3f382f94ea78', '32486262d9ad485da1f446294c30a2de', 1, 2, 0, '2019-07-04 10:49:41', '2019-07-04 10:01:40', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('b3bbb12084c344e58cc3a1b6db4b99db', 'bb944a97eb474b8cac8f96a017afefc1', NULL, NULL, 1, '2019-05-08 23:58:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b3ef3cc2731f4452b077feeb1694ca15', 'ca68cc4ab2f14a66a9a31b42aee97ddf', 27, 2, 1, '2019-08-20 17:39:46', '2019-08-20 16:51:46', '2019-08-20 16:51:46');
INSERT INTO `oauth2_access_token` VALUES ('b3efa84f5905457f9edf39087fab618e', '22c68ae929174053af883df1aca99a08', NULL, NULL, 1, '2019-05-01 21:48:05', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b4046be864bf46da8ca890d764070df3', '2a6cd5dba7804c709fdcfbe5c829204c', 27, 2, 1, '2019-06-01 15:36:01', '2019-06-01 14:48:00', '2019-06-01 14:48:00');
INSERT INTO `oauth2_access_token` VALUES ('b423ec485b4a4933ade39fc62554dc03', 'c77a7531ccde46439f9e88457ff4a826', 27, 2, 1, '2019-07-13 14:30:10', '2019-07-13 13:42:10', '2019-07-13 13:42:10');
INSERT INTO `oauth2_access_token` VALUES ('b428a94b7cfd48c499f22f8c5e3425a0', 'd9112c7574ef42138e50892dcc8349c8', NULL, NULL, 1, '2019-03-22 21:20:04', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b43a655e19e54bb1984042da594076e5', 'a4bd94b9cc0f470da3b786a0be000b89', 27, 2, 1, '2019-08-11 11:58:28', '2019-08-11 11:10:27', '2019-08-11 11:10:27');
INSERT INTO `oauth2_access_token` VALUES ('b43e3e800a9242ab864f65214efe07ae', '89d72d7250a54085bb365fdb948d2f8e', 27, 2, 1, '2019-08-21 12:27:05', '2019-08-21 11:39:05', '2019-08-21 11:39:05');
INSERT INTO `oauth2_access_token` VALUES ('b44c3d9344254fc7ae960a5203eb9a12', '659afefe57154447b7d3ff5f80ac83a3', 27, 2, 1, '2019-07-01 15:47:43', '2019-07-01 14:59:43', '2019-07-01 14:59:43');
INSERT INTO `oauth2_access_token` VALUES ('b455460079f541db99fd5928bffbc12e', '0812f78adf794301a6e5245093e264d9', 27, 2, 1, '2019-05-28 15:31:14', '2019-05-28 14:43:13', '2019-05-28 14:43:13');
INSERT INTO `oauth2_access_token` VALUES ('b45605abe78f4b06834dd3ba5257cb12', 'ffddd31023bf446697aa3ea941ebc073', NULL, NULL, 1, '2019-04-25 14:30:20', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b46aa60a5b744d72a9f064e955c79107', 'bf5994b4c0c84278b98f3ea26025d84f', 27, 2, 1, '2019-07-10 01:06:50', '2019-07-10 00:18:49', '2019-07-10 00:18:49');
INSERT INTO `oauth2_access_token` VALUES ('b48873941422499ebfbeb24532daaa46', '153d099566c942368a036d6c9c0ba5cb', 27, 2, 1, '2019-08-09 10:15:46', '2019-08-09 09:27:46', '2019-08-09 09:27:46');
INSERT INTO `oauth2_access_token` VALUES ('b48e90387c1f40468c1ea6988bb754a3', '9758002ef92b44d9812dd1e1958dcaa9', 27, 2, 1, '2019-06-05 20:25:06', '2019-06-05 19:37:06', '2019-06-05 19:37:06');
INSERT INTO `oauth2_access_token` VALUES ('b4aa2efa53174a99af18d47d02ee4044', 'a5a160f40b01414d9bf4b519685fadbb', 27, 2, 1, '2019-05-20 18:41:29', '2019-05-20 17:53:28', '2019-05-20 17:53:28');
INSERT INTO `oauth2_access_token` VALUES ('b4af0785194f4e9fb4594122043646a2', '1f8c7c44d1934acfa67dc9b50ea0b0e0', 27, 2, 1, '2019-07-26 14:34:33', '2019-07-26 13:46:33', '2019-07-26 13:46:33');
INSERT INTO `oauth2_access_token` VALUES ('b4c8336f85724d5fb6ab82d45b8a6741', 'ea98b6e695f04461baab69a72f89583a', 27, 2, 1, '2019-06-28 22:08:06', '2019-06-28 21:20:06', '2019-06-28 21:20:06');
INSERT INTO `oauth2_access_token` VALUES ('b4cd037d1e524661b202436b656882cf', 'e14476177bab41418fe45259ffccb704', 27, 2, 1, '2019-08-11 23:55:32', '2019-08-11 23:07:32', '2019-08-11 23:07:32');
INSERT INTO `oauth2_access_token` VALUES ('b4eb1127adbb4bdeb321a69dd0ef132c', 'f4bdcf0abb1f460789c5a6a05aea7288', 1, 2, 0, '2019-08-21 18:49:53', '2019-08-21 18:01:53', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('b4eba4faeeb546039c25473a378065c7', '6afdcadcaf6d4b758cdf43c968efdb1f', 27, 2, 1, '2019-06-03 22:41:30', '2019-06-03 21:53:29', '2019-06-03 21:53:29');
INSERT INTO `oauth2_access_token` VALUES ('b5046e8490ce471599596631dd1dab83', '926c9d1bfc294da1babb724f5a32742e', 27, 2, 1, '2019-05-22 21:24:04', '2019-05-22 20:36:03', '2019-05-22 20:36:03');
INSERT INTO `oauth2_access_token` VALUES ('b528f62e26bd4304b755b9c60642e681', 'b7a03d9a00644aecba1594dc9824a410', 27, 2, 1, '2019-08-12 18:13:48', '2019-08-12 17:25:47', '2019-08-12 17:25:47');
INSERT INTO `oauth2_access_token` VALUES ('b52f02101f8946bfaf339d218c978f00', '3917ca80583a428895fed67a9b019b89', 86, 1, 1, '2019-05-28 14:58:39', '2019-05-28 14:10:39', '2019-05-28 14:10:39');
INSERT INTO `oauth2_access_token` VALUES ('b53228bbee6b4fa4bdf79c51dddb27ba', '1bf9dde1231446ed85cf500a272db4a3', 27, 2, 1, '2019-06-05 10:52:37', '2019-06-05 10:04:36', '2019-06-05 10:04:36');
INSERT INTO `oauth2_access_token` VALUES ('b53cca2bb88a4404b831c18e1e7c29dd', 'b70aa00ae0b94ea1aa48e11ed7d08610', 27, 2, 1, '2019-07-06 23:01:31', '2019-07-06 22:13:30', '2019-07-06 22:13:30');
INSERT INTO `oauth2_access_token` VALUES ('b55443429f98476e9e64d0ddb813a64f', '496a2a06b05b42c58c6481372e0932cd', 27, 2, 1, '2019-06-18 15:19:41', '2019-06-18 14:31:40', '2019-06-18 14:31:40');
INSERT INTO `oauth2_access_token` VALUES ('b57abb8d11834b98982166cd4b102da0', '085926a44732410d82b6db80c653993a', 27, 2, 1, '2019-09-03 17:41:00', '2019-09-03 16:52:59', '2019-09-03 16:52:59');
INSERT INTO `oauth2_access_token` VALUES ('b57b8f7ab2e54e91a23c5cf7cbbfe426', 'dd2543c2b7144b5d8935cc072581cc73', 27, 2, 1, '2019-06-01 00:36:51', '2019-05-31 23:48:50', '2019-05-31 23:48:50');
INSERT INTO `oauth2_access_token` VALUES ('b584f3e54d2040a384eecb31129d18ff', 'baa06d279ef7475c9a6b6017bb0dc53f', 27, 2, 1, '2019-06-03 09:45:42', '2019-06-03 08:57:42', '2019-06-03 08:57:42');
INSERT INTO `oauth2_access_token` VALUES ('b598c6315b874d7c837c598b8dac78a6', 'f67b1f8de3c44c8f9bdd2cac037f348d', 27, 2, 1, '2019-05-25 09:47:55', '2019-05-25 08:59:54', '2019-05-25 08:59:54');
INSERT INTO `oauth2_access_token` VALUES ('b59ab20f6a8b4c90a449cf22da779b57', '5656fa6d35f04ff38efd672ab5bd51b4', 27, 2, 1, '2019-06-03 11:02:33', '2019-06-03 10:14:32', '2019-06-03 10:14:32');
INSERT INTO `oauth2_access_token` VALUES ('b59b1c5c4b594d82a7d3b53c2666734b', '401e3050b684454484cd26f380d9287d', 27, 2, 1, '2019-07-04 10:44:44', '2019-07-04 09:56:43', '2019-07-04 09:56:43');
INSERT INTO `oauth2_access_token` VALUES ('b5a9f227e28d4e7dad6a05a27bf16ceb', '5103fbcee9a443b5a4965b77f88706a9', 116, 1, 1, '2019-06-09 23:44:12', '2019-06-09 22:56:11', '2019-06-09 22:56:11');
INSERT INTO `oauth2_access_token` VALUES ('b5abad83965047c381bea473f21739f2', 'f47c58ce413d49c1bf5976a4a1bce5d4', 27, 2, 1, '2019-08-27 10:32:18', '2019-08-27 09:44:18', '2019-08-27 09:44:18');
INSERT INTO `oauth2_access_token` VALUES ('b5ac3b2270cb4b28a458b73a966d3988', 'f395dbe9f982465db4e68c4cd9aa6ffe', 27, 2, 1, '2019-07-25 14:17:52', '2019-07-25 13:29:51', '2019-07-25 13:29:51');
INSERT INTO `oauth2_access_token` VALUES ('b5ad12e5c12a41faa8cc5815b8fd699c', '5b06527af89843f8a61db61a3d30ba00', NULL, NULL, 1, '2019-05-09 13:39:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b5f267a39cdf4900b479c453509cf027', '46ff66b7f67a4f1cb5694481a48f8d95', NULL, NULL, 0, '2019-03-06 07:41:39', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b60354f7aaf3460a83751ba348210daa', '29e48b6483c34b5aa9adbf7d7275b075', NULL, NULL, 1, '2019-03-19 06:43:00', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b632b8564b9349cda0a3d7c5e465d34f', '780e60085b944a7893f67acd5cf5dd39', 27, 2, 1, '2019-07-17 12:59:47', '2019-07-17 12:11:47', '2019-07-17 12:11:47');
INSERT INTO `oauth2_access_token` VALUES ('b65b3d2231d04be3aace8de2278a6532', 'ef11ce0cb20d48b791fe8de8a2b45bb1', 27, 2, 1, '2019-07-29 13:08:22', '2019-07-29 12:20:21', '2019-07-29 12:20:21');
INSERT INTO `oauth2_access_token` VALUES ('b660711930c8454cb88c819efc129679', '5951d5cb8e594f35adcca67a62a6780f', 27, 2, 1, '2019-06-03 15:54:08', '2019-06-03 15:06:07', '2019-06-03 15:06:07');
INSERT INTO `oauth2_access_token` VALUES ('b660f046e7da4d7bb834ce05950436e5', 'adae51dca04945e6bf3e662a6cf9ac5e', NULL, NULL, 1, '2019-05-07 21:27:02', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b661820a29334d00b3fa69b42aa7c79e', '84822cb713a54068986e8ff41ef146c8', 27, 2, 1, '2019-06-03 13:29:54', '2019-06-03 12:41:54', '2019-06-03 12:41:54');
INSERT INTO `oauth2_access_token` VALUES ('b666004c74b647a483315c852c15fd5b', '38e3afb012744d4389946aede4bb85d4', NULL, NULL, 1, '2019-05-16 01:11:25', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b675c113189d473b99ed7d0dfaec58b1', '90615279ee3549b080e1fa4eb5f67fd6', 1, 2, 0, '2019-07-19 11:37:30', '2019-07-19 10:49:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('b68e361f459f48ddb43bf6554541cedb', '0136a42fbe074faf85dd26b9ff30509b', 1, 2, 0, '2019-07-21 11:28:26', '2019-07-21 10:40:25', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('b69e91ba176b48b69b6c19c07344cf9e', '8bcea1afede1448f89d1aefc775b2dad', 27, 2, 1, '2019-06-20 09:52:22', '2019-06-20 09:04:22', '2019-06-20 09:04:22');
INSERT INTO `oauth2_access_token` VALUES ('b6a3ecab343e44f981ad4701e9c22fb8', 'b3afc54787b542a0ba5ecb7e8b4a9367', 27, 2, 1, '2019-08-09 11:06:29', '2019-08-09 10:18:29', '2019-08-09 10:18:29');
INSERT INTO `oauth2_access_token` VALUES ('b6c72137d4a74f419d8208e482005b94', 'b8c558def7c749a781bcd52d0fcd96b6', 27, 2, 1, '2019-07-04 11:48:36', '2019-07-04 11:00:35', '2019-07-04 11:00:35');
INSERT INTO `oauth2_access_token` VALUES ('b6d03b2540074a4e84ce2de0bdcdae5b', '686f918e673c421f9b0f89b41885b0eb', 27, 2, 1, '2019-06-03 19:34:39', '2019-06-03 18:46:38', '2019-06-03 18:46:38');
INSERT INTO `oauth2_access_token` VALUES ('b6f368abca02460bb836c635ae4147cf', '63dea74719514ebfb2dc8491c71ff0e0', 27, 2, 1, '2019-06-05 11:30:15', '2019-06-05 10:42:14', '2019-06-05 10:42:14');
INSERT INTO `oauth2_access_token` VALUES ('b6f7dd37819f424e891837127dc1b89a', '7aae1e0e5b5645a0a875c940a8da1f83', 166, 1, 1, '2019-07-11 09:52:59', '2019-07-11 09:04:59', '2019-07-11 09:04:59');
INSERT INTO `oauth2_access_token` VALUES ('b6fb5f4e2ead45fcb89f7478f16e3e2c', '4af47850893c4884a5925f959049d884', 27, 2, 1, '2019-06-16 20:17:21', '2019-06-16 19:29:20', '2019-06-16 19:29:20');
INSERT INTO `oauth2_access_token` VALUES ('b6fe8d1fa1b24b53a3ed043dae7a4f31', '7dced97cc81e4fea8600329f0669ff5e', NULL, NULL, 1, '2019-05-09 00:06:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b70077544ad843df9c464e7676c431ff', 'a4a63733bf5948ad9afc48381932f7d3', 1, 2, 0, '2019-08-02 11:02:00', '2019-08-02 10:13:59', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('b711fde3c8734f18ac32c1ef439d3b7e', '48084ca6fdb047ce999532fd43696839', 27, 2, 1, '2019-06-02 15:26:10', '2019-06-02 14:38:10', '2019-06-02 14:38:10');
INSERT INTO `oauth2_access_token` VALUES ('b71a4ef0457d4f83afcb2fa5cce2fd82', '5e92a1d0027440bdb1a88d8e91843e98', 27, 2, 1, '2019-06-01 15:41:23', '2019-06-01 14:53:22', '2019-06-01 14:53:22');
INSERT INTO `oauth2_access_token` VALUES ('b72df0eef79d497aa1cac4edd798421e', '1d6ced9548274cc6b4ba5217b05ca1fa', 27, 2, 1, '2019-06-02 11:45:14', '2019-06-02 10:57:13', '2019-06-02 10:57:13');
INSERT INTO `oauth2_access_token` VALUES ('b76302ba316d40d18e1b2740400596a6', '2ca1218822d2405ba129a800b3e86148', 27, 2, 1, '2019-08-09 18:56:43', '2019-08-09 18:08:42', '2019-08-09 18:08:42');
INSERT INTO `oauth2_access_token` VALUES ('b7712abad6ed43efa5381ec1d21bde03', '31bd34dffe834ae099b7287fb0d59c19', 27, 2, 1, '2019-06-06 18:07:24', '2019-06-06 17:19:24', '2019-06-06 17:19:24');
INSERT INTO `oauth2_access_token` VALUES ('b78d130a1fea473f9f31050e51262ba3', '394a2a620f8b4929a4f411f391c4b101', 27, 2, 1, '2019-06-21 14:31:22', '2019-06-21 13:43:22', '2019-06-21 13:43:22');
INSERT INTO `oauth2_access_token` VALUES ('b78d74f5a52d45128c3d1efb3d5c4767', 'f8f160bbc5ef4c4e82bb237433e4833a', 27, 2, 1, '2019-08-14 15:43:42', '2019-08-14 14:55:42', '2019-08-14 14:55:42');
INSERT INTO `oauth2_access_token` VALUES ('b796686f290c4a1a966cf0850a54430d', 'e442c83bc5884c2180ef1b95bb1a804a', 27, 2, 1, '2019-06-20 10:50:45', '2019-06-20 10:02:45', '2019-06-20 10:02:45');
INSERT INTO `oauth2_access_token` VALUES ('b7bcdb71ed854769b002628adc6fff8f', '190bbd101b6a4b00898801c0e2fd3141', 27, 2, 1, '2019-08-13 09:44:22', '2019-08-13 08:56:22', '2019-08-13 08:56:22');
INSERT INTO `oauth2_access_token` VALUES ('b7c1a294881345e2b9e1109196e028dc', 'fc33578905904c56ade3f43d2d221c12', NULL, NULL, 1, '2019-04-24 10:36:08', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b7c7591edf6245468e40d7b0e4c91bb8', '727a3a6a95a94457a618ea92e665fbf4', 27, 2, 1, '2019-07-31 17:30:33', '2019-07-31 16:42:32', '2019-07-31 16:42:32');
INSERT INTO `oauth2_access_token` VALUES ('b7cb8f34f593479097aa068378662a8f', '44b6c4b3c70c4f84a0ee5bea73081172', 27, 2, 1, '2019-07-15 15:57:19', '2019-07-15 15:09:19', '2019-07-15 15:09:19');
INSERT INTO `oauth2_access_token` VALUES ('b7d8abc3d4374a6d98f7e02b27dd5ca8', '49e8dd514ad84bf8ba0ae56d2791c787', 27, 2, 1, '2019-06-02 00:36:46', '2019-06-01 23:48:45', '2019-06-01 23:48:45');
INSERT INTO `oauth2_access_token` VALUES ('b80c7294e37b4c07aeb3faa3a1a966cb', '5a0f469e1ad84bb0a63e94c48591ccfc', NULL, NULL, 1, '2019-04-30 18:34:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b8213c3b74f74d51a14e632e28c1d518', '1bc0613bdc9c4bc4af5387777d2a27a0', NULL, NULL, 1, '2019-03-20 19:57:50', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b8387b90fccb40d990aee7ffc6cc3c11', '3bfefbe3ab6244958c12f04d808b998c', 27, 2, 1, '2019-07-15 16:48:53', '2019-07-15 16:00:53', '2019-07-15 16:00:53');
INSERT INTO `oauth2_access_token` VALUES ('b880cb5e1fb04c6a8c6e42d249e49a12', '39ecd1f3b57a4bd9a5bc0f2ca9857779', 27, 2, 1, '2019-07-12 15:53:39', '2019-07-12 15:05:38', '2019-07-12 15:05:38');
INSERT INTO `oauth2_access_token` VALUES ('b8884960b8e14708b4cfdaa3d54a4139', '0e5cb1ddab7743518329d27a95c5b264', 27, 2, 1, '2019-08-13 13:16:39', '2019-08-13 12:28:39', '2019-08-13 12:28:39');
INSERT INTO `oauth2_access_token` VALUES ('b88f2bd4d7ad4ac68f28088efcfb97c1', '002c8c5b2cc3426785c8a61a7e33d545', 27, 2, 1, '2019-08-03 21:19:11', '2019-08-03 20:31:10', '2019-08-03 20:31:10');
INSERT INTO `oauth2_access_token` VALUES ('b88fb6d648a34d9e9403cb2529496788', '0818b1135dc1425c829e1733408ccf2c', 27, 2, 1, '2019-06-26 17:49:59', '2019-06-26 17:01:59', '2019-06-26 17:01:59');
INSERT INTO `oauth2_access_token` VALUES ('b8a6310c017a4472828b130aeed48ec7', 'd92dd8cd51aa488b89c81bb446a1220e', 27, 2, 1, '2019-05-27 11:31:34', '2019-05-27 10:43:34', '2019-05-27 10:43:34');
INSERT INTO `oauth2_access_token` VALUES ('b8a7c14b723f4591ab6b1f2d563f7f09', 'eb8448caf39844d7ac5433556b77f141', 171, 1, 1, '2019-07-16 15:52:37', '2019-07-16 15:04:36', '2019-07-16 15:04:36');
INSERT INTO `oauth2_access_token` VALUES ('b8b4af7212534f999fcbec32d888952c', 'bb8dfdde93d241068b47cee0f94ec4a8', NULL, NULL, 1, '2019-03-30 00:30:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b8b88888f0ec49ffade9044d8fca20fd', '31b39f094a2548c8a3460fe065a7e72a', 206, 1, 1, '2019-08-18 01:55:01', '2019-08-18 01:07:00', '2019-08-18 01:07:00');
INSERT INTO `oauth2_access_token` VALUES ('b8dcd879ddf54eb988d42158d65adae6', '5b306d45366e45988704f7fa76b5bcb8', 27, 2, 1, '2019-06-03 12:45:05', '2019-06-03 11:57:05', '2019-06-03 11:57:05');
INSERT INTO `oauth2_access_token` VALUES ('b8e8b59c74a04453bfdf4ca4b34e3f35', 'baf5f0c04df749dd946f2fe8b63dcf0a', 27, 2, 1, '2019-07-16 14:46:53', '2019-07-16 13:58:53', '2019-07-16 13:58:53');
INSERT INTO `oauth2_access_token` VALUES ('b8fbcd46682447178deecc058e5dd41d', 'c4f087e9ea17448ba700d92473f49883', 27, 2, 1, '2019-08-12 17:53:15', '2019-08-12 17:05:15', '2019-08-12 17:05:15');
INSERT INTO `oauth2_access_token` VALUES ('b90182fdb0994fb1994369e9d0586245', '3ba1f77aaf654fbe986f339ba6b1bf47', 27, 2, 1, '2019-05-28 00:42:40', '2019-05-27 23:54:40', '2019-05-27 23:54:40');
INSERT INTO `oauth2_access_token` VALUES ('b9127cdd3b64461992bd02598ec4ccd4', 'c8d4a023da34402883df774dc655da49', NULL, NULL, 1, '2019-05-09 22:03:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b914df13712b4bf6b23cd91198556366', 'faf4cf268b354ccc97ed570a9a23cb4e', 27, 2, 1, '2019-08-30 17:47:03', '2019-08-30 16:59:02', '2019-08-30 16:59:02');
INSERT INTO `oauth2_access_token` VALUES ('b925d466a3144471aaec7a4ccfbebfa9', '18e7b73369294fa0b4c5b600b67a392f', 27, 2, 1, '2019-06-03 11:45:45', '2019-06-03 10:57:45', '2019-06-03 10:57:45');
INSERT INTO `oauth2_access_token` VALUES ('b946453fc3b74c82b16d24f98c24169c', '888bf7c7cbf8425f955679737102235c', 181, 1, 1, '2019-07-26 12:35:54', '2019-07-26 11:47:53', '2019-07-26 11:47:53');
INSERT INTO `oauth2_access_token` VALUES ('b9968a77d4814898b516a9037cf53a07', '774d7043ad684baab87d3e4ee55ed58f', NULL, NULL, 1, '2019-04-06 22:49:16', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('b9ad8d78c0a94b378c746d84151c3b7e', '3f88a228b6fa45f8a00cba940dea92d7', 27, 2, 1, '2019-09-07 22:11:22', '2019-09-07 21:23:21', '2019-09-07 21:23:21');
INSERT INTO `oauth2_access_token` VALUES ('b9c081a4ff1043aa9f89185cdb47cb77', '7b75a06f3b0f4f9687e7ba61357d9827', 27, 2, 1, '2019-07-11 23:29:46', '2019-07-11 22:41:46', '2019-07-11 22:41:46');
INSERT INTO `oauth2_access_token` VALUES ('b9c5c0a3e02d4cbabf806723f8418310', 'dfa952ca4ea04aa6a38a470e3cdf5cbc', 27, 2, 1, '2019-06-21 16:16:03', '2019-06-21 15:28:02', '2019-06-21 15:28:02');
INSERT INTO `oauth2_access_token` VALUES ('b9ca6c6bb0f44b0babf6bfbb245dc36d', '1f4f485d904a4c60a0d7a371a4ef84c1', 1, 2, 0, '2019-07-26 16:13:49', '2019-07-26 15:25:48', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('b9f7715624d04ad4a422450ad0464ecf', 'c5a5a48ec3dd42a4a1ab7d78f6e3a344', 126, 1, 1, '2019-06-18 16:20:21', '2019-06-18 15:32:20', '2019-06-18 15:32:20');
INSERT INTO `oauth2_access_token` VALUES ('b9fbc97591e74dc6906f9f2009e1b840', 'bf2f1d0f05624d448cdb1a3d94289211', 27, 2, 1, '2019-09-06 12:29:04', '2019-09-06 11:41:03', '2019-09-06 11:41:03');
INSERT INTO `oauth2_access_token` VALUES ('ba1574176d7d4f25a1bc7e1a3a8b525c', '5dfe3e9552544998b45a8f3802846172', 27, 2, 1, '2019-06-04 16:07:00', '2019-06-04 15:19:00', '2019-06-04 15:19:00');
INSERT INTO `oauth2_access_token` VALUES ('ba368ca9af7f4ae6a707e923a9a75b4f', 'b2e22f533e9b4f4c9b943d98c0597cd8', 146, 1, 1, '2019-07-01 19:53:10', '2019-07-01 19:05:09', '2019-07-01 19:05:09');
INSERT INTO `oauth2_access_token` VALUES ('ba477c101ca14c18bc2880cedd5fce31', '8701217312df423f94d0ac13360ce97c', 27, 2, 1, '2019-07-03 13:58:38', '2019-07-03 13:10:37', '2019-07-03 13:10:37');
INSERT INTO `oauth2_access_token` VALUES ('ba54a6c9f7014aba83443868adc1e6d6', '0b296d4918d34bb7b49e6251d9beb09d', 27, 2, 1, '2019-08-28 14:58:04', '2019-08-28 14:10:03', '2019-08-28 14:10:03');
INSERT INTO `oauth2_access_token` VALUES ('ba591d7db84b4f189019c1ece61e2130', 'dadd6b47205148aea7d42da8e0b3ce68', 27, 2, 1, '2019-08-02 16:23:07', '2019-08-02 15:35:06', '2019-08-02 15:35:06');
INSERT INTO `oauth2_access_token` VALUES ('ba621f5fac82497fabc2e96c0a488efb', '42781f9355e24a828054bc07b6128d9e', 27, 2, 1, '2019-05-31 17:39:13', '2019-05-31 16:51:13', '2019-05-31 16:51:13');
INSERT INTO `oauth2_access_token` VALUES ('ba69123498294ac8b6f3052775ef6824', 'a90071b6615d4f45980dd3d79974fb7d', 1, 2, 0, '2019-08-04 22:16:46', '2019-08-04 21:28:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('ba78fbe4b9ec494aba69268bafa810c0', '742f158e423b46cb863b9c420c2816ed', 27, 2, 1, '2019-08-22 15:37:55', '2019-08-22 14:49:54', '2019-08-22 14:49:54');
INSERT INTO `oauth2_access_token` VALUES ('ba9067fad6d644d19c1cc680f39842db', 'f252213a43ed4bee8e61526c1836594e', 27, 2, 1, '2019-07-08 19:51:42', '2019-07-08 19:03:42', '2019-07-08 19:03:42');
INSERT INTO `oauth2_access_token` VALUES ('ba9cfa69848243549ccb1af001fa165d', '8bea3a1316ef44e3b03263da74a4752f', 1, 2, 0, '2019-09-04 23:45:52', '2019-09-04 22:57:52', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('baba11be4e854f8c87e410eadb2ac68d', '073160361b60452faabbd61448e49b81', NULL, NULL, 1, '2019-04-22 22:50:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('babdf772f4a84ee99e10e6ea28b7f066', '69cf20779aa94296980d47b520d25e32', 27, 2, 1, '2019-06-04 10:00:35', '2019-06-04 09:12:35', '2019-06-04 09:12:35');
INSERT INTO `oauth2_access_token` VALUES ('bac0d7223c144ed8b3e4699af9e85253', '63812c2c13b24b4bb2821fbd6b615333', 27, 2, 1, '2019-06-19 22:10:54', '2019-06-19 21:22:54', '2019-06-19 21:22:54');
INSERT INTO `oauth2_access_token` VALUES ('bad10b259baf449ba82335ad6c4bb727', 'de7910a0383540bb9c5cda3774b63920', 27, 2, 1, '2019-06-28 17:29:39', '2019-06-28 16:41:39', '2019-06-28 16:41:39');
INSERT INTO `oauth2_access_token` VALUES ('baddd4b69e774e729c9a87bb63805a39', '73a90e8ee4d94145a7a2f01b27ade2c5', 27, 2, 1, '2019-05-29 17:15:08', '2019-05-29 16:27:08', '2019-05-29 16:27:08');
INSERT INTO `oauth2_access_token` VALUES ('baedf1675519432fab4dbf821e5ec632', '0bada6b6016144ddb35a676c0f3aa203', 96, 1, 1, '2019-06-01 16:46:38', '2019-06-01 15:58:38', '2019-06-01 15:58:38');
INSERT INTO `oauth2_access_token` VALUES ('baf14e9be557405d8ba64fa41aeb7b8c', 'cedd78c601f34a6482fb9871e461c6d4', 27, 2, 1, '2019-05-24 17:24:55', '2019-05-24 16:36:54', '2019-05-24 16:36:54');
INSERT INTO `oauth2_access_token` VALUES ('baf4678d11254d7788af75917f9591ee', '44ab6e4338b647acafc044211334b8d4', 27, 2, 1, '2019-08-08 10:30:14', '2019-08-08 09:42:14', '2019-08-08 09:42:14');
INSERT INTO `oauth2_access_token` VALUES ('bb21fa08f9ef4555ae9df96fd938806a', 'ce40e635677d4fc5b4a44a85dc1b266f', 27, 2, 1, '2019-06-19 17:27:11', '2019-06-19 16:39:11', '2019-06-19 16:39:11');
INSERT INTO `oauth2_access_token` VALUES ('bb2ab52983764bb7bb3a788529c16989', '413914c46fc64c348dd9fad659319072', 27, 2, 1, '2019-07-29 19:04:58', '2019-07-29 18:16:57', '2019-07-29 18:16:57');
INSERT INTO `oauth2_access_token` VALUES ('bb3404aa85ba4e66b16bae3af936f301', '0df4f2bca387483c8737cb9a02ffe079', NULL, NULL, 1, '2019-03-10 05:17:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bb38e904b7944009b1b1128fe8312976', '36b50f2c5bb84be295115cbecf118657', 27, 2, 1, '2019-05-31 17:29:06', '2019-05-31 16:41:05', '2019-05-31 16:41:05');
INSERT INTO `oauth2_access_token` VALUES ('bb4d28d7367244b78cf1cbc25eba121b', '34ca793ede9c4a2b84a34d1413fb3f3e', 27, 2, 1, '2019-07-29 15:36:14', '2019-07-29 14:48:13', '2019-07-29 14:48:13');
INSERT INTO `oauth2_access_token` VALUES ('bb4d2c437760488c99d45b5731532cf4', 'f87d6a27b7b04c2db8f0123e174a2882', 27, 2, 1, '2019-06-14 11:18:47', '2019-06-14 10:30:47', '2019-06-14 10:30:47');
INSERT INTO `oauth2_access_token` VALUES ('bb5ea694ebba477f90864afdaff085a6', '84b658c49f594381bc34671942d1bf67', 27, 2, 1, '2019-06-21 14:39:42', '2019-06-21 13:51:42', '2019-06-21 13:51:42');
INSERT INTO `oauth2_access_token` VALUES ('bb7c8883d3024e2580d82b6e070a531d', '748e4e41dd3147efb407f4946ec82e93', 27, 2, 1, '2019-07-05 15:50:50', '2019-07-05 15:02:49', '2019-07-05 15:02:49');
INSERT INTO `oauth2_access_token` VALUES ('bba849df04fe4b658dac6a45944e1e7b', 'dee3257860e744bbb03b493f24eba9aa', 27, 2, 1, '2019-08-23 11:11:33', '2019-08-23 10:23:33', '2019-08-23 10:23:33');
INSERT INTO `oauth2_access_token` VALUES ('bbaced6fccfd45799e89f77698cd7899', 'c5fb93367101410e859ad033f9ac6717', 27, 2, 1, '2019-08-17 11:56:37', '2019-08-17 11:08:37', '2019-08-17 11:08:37');
INSERT INTO `oauth2_access_token` VALUES ('bbc39ee49acf46adbce3f253569b5594', '7806e73123eb4beb9cd2db3f25d6c8f5', 27, 2, 1, '2019-07-31 17:30:02', '2019-07-31 16:42:01', '2019-07-31 16:42:01');
INSERT INTO `oauth2_access_token` VALUES ('bbd9187bb99d47c0bed89991de6683c3', '579ac17c66d1460db27c039f71409a3a', NULL, NULL, 1, '2019-04-05 21:31:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bbdf61d464064f9f9a8b5c416fa8e904', '2c89fd00564b4ca7b61f8e7cf205eee1', 27, 2, 1, '2019-06-04 11:50:56', '2019-06-04 11:02:56', '2019-06-04 11:02:56');
INSERT INTO `oauth2_access_token` VALUES ('bbe22a386d2f4f3fb0e9864c65e7631c', '7391577ceecb4a62bba477f2ad12b432', 27, 2, 1, '2019-09-03 10:29:15', '2019-09-03 09:41:14', '2019-09-03 09:41:14');
INSERT INTO `oauth2_access_token` VALUES ('bbf2324aa0994477a90990f0261d4928', '395c967849014b869c2a5176365ee175', 27, 2, 1, '2019-07-19 13:49:07', '2019-07-19 13:01:06', '2019-07-19 13:01:06');
INSERT INTO `oauth2_access_token` VALUES ('bbf2952edacd4823ac43f21ad3499d75', '30af768878a343058bb175d9bee20fb6', 27, 2, 1, '2019-06-20 09:34:22', '2019-06-20 08:46:21', '2019-06-20 08:46:21');
INSERT INTO `oauth2_access_token` VALUES ('bc0ac8bd56dc464f8576efd89ffc7afb', 'f6348af5f17e4f3c8fa4b1ca362347a3', NULL, NULL, 1, '2019-05-05 14:27:08', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bc28cab2e5034b66b88b50cfbf983055', '764ef8af5a5e47719af9d1e8a4260c20', NULL, NULL, 1, '2019-03-10 21:36:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bc322fff0eaa4cd0a1b99f7bea343e76', '66597fb7b88c4b2dbbd118523a4df5c2', 27, 2, 1, '2019-06-27 10:56:54', '2019-06-27 10:08:53', '2019-06-27 10:08:53');
INSERT INTO `oauth2_access_token` VALUES ('bc6da257ae61447e9dfd77bdeaf1c381', '30bce16d5ba24c16be3497a3c354d574', 27, 2, 1, '2019-06-14 12:43:59', '2019-06-14 11:55:58', '2019-06-14 11:55:58');
INSERT INTO `oauth2_access_token` VALUES ('bc8eeda3ac68476bab6ac655c4c3802b', 'ee9736a0d00f4449ba2ebcce861ece62', 27, 2, 1, '2019-08-28 09:37:44', '2019-08-28 08:49:43', '2019-08-28 08:49:43');
INSERT INTO `oauth2_access_token` VALUES ('bc99a89a7480472786a865c761e36613', '73da90a72cf14bd0bd0161c74ac6924a', 27, 2, 1, '2019-06-05 15:34:15', '2019-06-05 14:46:14', '2019-06-05 14:46:14');
INSERT INTO `oauth2_access_token` VALUES ('bcb50f39444c478ea4758867a8f8d56d', '76174fd46861415a8b22eaa3d581eb17', 27, 2, 1, '2019-05-20 11:40:37', '2019-05-20 10:52:36', '2019-05-20 10:52:36');
INSERT INTO `oauth2_access_token` VALUES ('bccadffe58454ce38929ba6d29473e39', '6eb4d220ae024f1cbaed6e175b5e58a4', NULL, NULL, 1, '2019-05-05 17:45:36', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bcccc3359ef54cea8c3aebe5919cd5d0', 'c09bd431ed5b4dd6ae02f51f70f208bb', 27, 2, 1, '2019-08-02 12:10:55', '2019-08-02 11:22:55', '2019-08-02 11:22:55');
INSERT INTO `oauth2_access_token` VALUES ('bcd76dcaaf58481bb250ebeeccf96d10', '3f739841139d4c04b58be233d3d447fe', 27, 2, 1, '2019-06-21 18:41:49', '2019-06-21 17:53:49', '2019-06-21 17:53:49');
INSERT INTO `oauth2_access_token` VALUES ('bce604ce8add40479dfb1f7349b897fa', '7fc42671a26d465bba9eee8f5e642ba3', 27, 2, 1, '2019-07-26 11:11:34', '2019-07-26 10:23:33', '2019-07-26 10:23:33');
INSERT INTO `oauth2_access_token` VALUES ('bd18ac82d649473ba63ed6422648ef98', 'f01298a699d84ba6b103fb608d8dff80', 140, 1, 1, '2019-06-25 12:15:30', '2019-06-25 11:27:30', '2019-06-25 11:27:30');
INSERT INTO `oauth2_access_token` VALUES ('bd406e5fd0b84c69859c64e27e1ad944', '73fbe6b520ef4be8ac29ed056c44f995', 27, 2, 1, '2019-05-28 23:12:14', '2019-05-28 22:24:13', '2019-05-28 22:24:13');
INSERT INTO `oauth2_access_token` VALUES ('bd4224acafd943c89e0219b1f9b542ab', 'fb36895f87df4c5eb3397264fcc8601b', 27, 2, 1, '2019-08-30 11:03:07', '2019-08-30 10:15:07', '2019-08-30 10:15:07');
INSERT INTO `oauth2_access_token` VALUES ('bd4572f894a64e5a832b17de0a2e581e', 'ccbd25f81f404611b907d9b2cc3fa978', 27, 2, 1, '2019-07-10 12:21:49', '2019-07-10 11:33:48', '2019-07-10 11:33:48');
INSERT INTO `oauth2_access_token` VALUES ('bd4a3a84ddcc4755bf9b6946cc594cdc', 'dd60a55fe0b24f87b0e37bd8459ed0e1', 27, 2, 1, '2019-06-12 20:24:22', '2019-06-12 19:36:22', '2019-06-12 19:36:22');
INSERT INTO `oauth2_access_token` VALUES ('bd4d5a5ccb3642c7b7368695d66302ad', 'a1d844480ee646a3aa7fb264cf2336eb', NULL, NULL, 1, '2019-04-05 11:13:37', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bd7da77ec1be4c82a3d39ec929df7a1c', '1562449f05be4912b100b8a041cbab49', 1, 2, 0, '2019-09-04 23:28:41', '2019-09-04 22:40:41', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('bd959c5878714442afe23edc53a57012', 'd9cec5bb87344e15b5e2ba2906ff2d04', 73, 1, 1, '2019-05-17 18:37:25', '2019-05-17 17:49:25', '2019-05-17 17:49:25');
INSERT INTO `oauth2_access_token` VALUES ('bd99721f17394da0b9e4ff408080f06d', 'e8a33935b6164e45bcd91dd97ae0246a', NULL, NULL, 1, '2019-05-06 09:43:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bd9ab17358af4f919b84c6f87e23ef4e', '38a37a79bda1480d84c518f06c8d3049', 27, 2, 1, '2019-07-26 10:15:55', '2019-07-26 09:27:55', '2019-07-26 09:27:55');
INSERT INTO `oauth2_access_token` VALUES ('bdad8681c8174169b12a6d6f7016ea96', '47f2b3ad21534931a7b067f612c42c10', 27, 2, 1, '2019-06-26 18:58:53', '2019-06-26 18:10:52', '2019-06-26 18:10:52');
INSERT INTO `oauth2_access_token` VALUES ('bdb02402503c44aeb23b4bc08f39e770', 'f109dfb5263041fb9ec6a70128a2bdad', 130, 1, 1, '2019-06-21 14:46:17', '2019-06-21 13:58:17', '2019-06-21 13:58:17');
INSERT INTO `oauth2_access_token` VALUES ('bdb17eccc3064be8899702a4189e133b', 'a7d6f692fad4432e86c1e104c54ba102', 27, 2, 1, '2019-07-04 15:52:44', '2019-07-04 15:04:43', '2019-07-04 15:04:43');
INSERT INTO `oauth2_access_token` VALUES ('bdc3c035dbd44cea92d1090e23a6fa6f', '3ab8e988118e4016b782796034f6c47c', NULL, NULL, 1, '2019-05-11 10:28:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bdcbd8a0a8a8476baeb12f871f3a389f', 'f5b2c37bf39b44958b61c9a4e05f7818', 27, 2, 1, '2019-05-27 18:38:58', '2019-05-27 17:50:58', '2019-05-27 17:50:58');
INSERT INTO `oauth2_access_token` VALUES ('bdd82efa3aa34a738846b3f249117fd0', 'f9242de5946d417896eeed2a16b5d328', 27, 2, 1, '2019-07-02 15:17:58', '2019-07-02 14:29:57', '2019-07-02 14:29:57');
INSERT INTO `oauth2_access_token` VALUES ('bdda0c112ee347768c1d3fa761393ebe', '9dc2ce724cbf44229163dbcebfa4134a', 27, 2, 1, '2019-06-21 20:23:09', '2019-06-21 19:35:08', '2019-06-21 19:35:08');
INSERT INTO `oauth2_access_token` VALUES ('bdf25dcd7e314f148e05d14ccc7eaec5', 'ea5e48c803bb4ef8abf2e86e6398d2fc', 27, 2, 1, '2019-07-23 17:33:00', '2019-07-23 16:45:00', '2019-07-23 16:45:00');
INSERT INTO `oauth2_access_token` VALUES ('bdf3dea4354e43a08486c3ffcc7194ac', '70d2686739cf4f12a7ab797d2484bc27', 27, 2, 1, '2019-08-29 14:53:10', '2019-08-29 14:05:10', '2019-08-29 14:05:10');
INSERT INTO `oauth2_access_token` VALUES ('bdf7750a97c8488da0b9ce7e7ec07898', 'bfd8070812ac497b9ddd57a68dadb5ab', 27, 2, 1, '2019-08-29 12:03:25', '2019-08-29 11:15:25', '2019-08-29 11:15:25');
INSERT INTO `oauth2_access_token` VALUES ('be00c5e89bb5430b8c548c9be6deefff', '443aeccb3b5e40a9b57cdaa834c20454', 27, 2, 1, '2019-08-09 16:13:24', '2019-08-09 15:25:23', '2019-08-09 15:25:23');
INSERT INTO `oauth2_access_token` VALUES ('be0d67c90f4149cebfe7951f76d4daa2', '36c0cca4d276457a97de2151edea6b41', NULL, NULL, 0, '2019-03-02 03:45:54', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('be4431d49408404da70d1f040df1e68b', '2ddeb7448d4645a0821db3019477e197', NULL, NULL, 1, '2019-05-10 15:00:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('be46d59b003047838863c9531f2bd594', '02f186198c934015bc17f11579741072', 27, 2, 1, '2019-07-18 18:00:36', '2019-07-18 17:12:35', '2019-07-18 17:12:35');
INSERT INTO `oauth2_access_token` VALUES ('be4fd2cbe3fd475190097d4975f54cc9', 'a634664950ec4140921b597d71addb62', 27, 2, 1, '2019-08-12 16:21:25', '2019-08-12 15:33:25', '2019-08-12 15:33:25');
INSERT INTO `oauth2_access_token` VALUES ('be520ae2dc5c49d0a219db53d6d3ce3b', '82a2f6b184d44eea99258f8360e89d08', 27, 2, 1, '2019-07-25 15:21:02', '2019-07-25 14:33:02', '2019-07-25 14:33:02');
INSERT INTO `oauth2_access_token` VALUES ('be6ca82f28554a8ab2b890ef7f2b82a1', '2f2bbbc3b0b94f308f40ac9b9f06b2c2', 27, 2, 1, '2019-06-26 15:39:45', '2019-06-26 14:51:45', '2019-06-26 14:51:45');
INSERT INTO `oauth2_access_token` VALUES ('be70fa898a434e32958922143fd33c94', 'beeb5274836b47ada2244e787cc7bae2', 1, 2, 0, '2019-05-20 12:56:01', '2019-05-20 12:08:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('be7c2add526149d1b4d1a12e17ef9729', 'd6aba0392223419e99ef65ede5d0cdd1', 27, 2, 1, '2019-07-03 10:13:11', '2019-07-03 09:25:10', '2019-07-03 09:25:10');
INSERT INTO `oauth2_access_token` VALUES ('be84d279d9cc468b82e7ed6c54b41b29', '48f22611785447dd9c165a3994b7992b', NULL, NULL, 1, '2019-05-01 22:49:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('be8d7855ceeb4293b29f63e234677c4b', '1aeeaa7cd0d242f9ac8f8c957e901c39', NULL, NULL, 1, '2019-05-06 23:32:34', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('be93924c53e546deabd3909ec3d229b4', '2ae0eae54f8040bb83dbd6d64447bc09', 27, 2, 1, '2019-07-24 14:28:27', '2019-07-24 13:40:26', '2019-07-24 13:40:26');
INSERT INTO `oauth2_access_token` VALUES ('be94a230786c4b199fdebbbd88f74bb5', 'eb91bed0b3704bf08dbfc81bb46ff511', 27, 2, 1, '2019-06-22 09:27:35', '2019-06-22 08:39:35', '2019-06-22 08:39:35');
INSERT INTO `oauth2_access_token` VALUES ('beadf87620fe4c809c1f92cc13c0663f', '9ed2adca400b4347bbefd10834be9d7a', 27, 2, 1, '2019-09-04 10:56:42', '2019-09-04 10:08:42', '2019-09-04 10:08:42');
INSERT INTO `oauth2_access_token` VALUES ('beb0ac088deb427eb16c16fd57e504c8', '2c507047edf742af8c4182e9e06db348', 27, 2, 1, '2019-06-05 12:24:23', '2019-06-05 11:36:23', '2019-06-05 11:36:23');
INSERT INTO `oauth2_access_token` VALUES ('beb3eb85ba2e464aa90afe545c6ce53f', '845a33f374e3476796cf750a0d0b38c6', 27, 2, 1, '2019-07-26 14:41:10', '2019-07-26 13:53:09', '2019-07-26 13:53:09');
INSERT INTO `oauth2_access_token` VALUES ('bebffc020fb04d7a92e6570edbc49227', '1cb4635c5c254ab2a59c89c0d2b4e21f', NULL, NULL, 0, '2019-03-03 23:00:25', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bec2803b72494d0a9f02e608b57ea223', 'aaf72e8a29f745cab3176637c48f0910', 27, 2, 1, '2019-06-03 14:11:47', '2019-06-03 13:23:46', '2019-06-03 13:23:46');
INSERT INTO `oauth2_access_token` VALUES ('bee45e1086e24f8e8a8f838401490f21', '9b36368042e0428aa7f27d878e382239', NULL, NULL, 1, '2019-05-08 17:31:09', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bee6725fdd674e0c813b47bb0a3530c7', '84896b7655b8483a98af8369172a3901', 27, 2, 1, '2019-08-10 18:07:41', '2019-08-10 17:19:41', '2019-08-10 17:19:41');
INSERT INTO `oauth2_access_token` VALUES ('bee70cc26bf64b50b14b8a0713707fd1', '5d945ced8ed24db1a059f8dcc2151e43', NULL, NULL, 1, '2019-05-07 23:19:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bf07c4a8f0e843f1b630e5c6b5042e08', '34f5da1b74ea437aa1715e61a94fbfae', 27, 2, 1, '2019-09-02 16:41:23', '2019-09-02 15:53:23', '2019-09-02 15:53:23');
INSERT INTO `oauth2_access_token` VALUES ('bf0cef7f8d034b24937f96a1f28da5d2', 'b7b3fd12515d41c381353af7129cc5a1', NULL, NULL, 1, '2019-04-27 22:51:42', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bf2635450a524d43a43de8cd9ad53883', '5894812b2f0843608f8c0af68cfd6e43', 27, 2, 1, '2019-08-02 10:17:38', '2019-08-02 09:29:38', '2019-08-02 09:29:38');
INSERT INTO `oauth2_access_token` VALUES ('bf2cb45903484410a136ee5590d14656', '29d47329edfc4292971602034995f56e', NULL, NULL, 1, '2019-03-22 15:56:32', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bf35356b79414376908186bb64eec3f9', '7ae0ec68081e4a3cb71e31af4f19df29', 27, 2, 1, '2019-06-08 21:00:37', '2019-06-08 20:12:37', '2019-06-08 20:12:37');
INSERT INTO `oauth2_access_token` VALUES ('bf354ee9815c4ca9a508860a01c9874f', '32f332ec14fa469abfd7bf90962c87b4', NULL, NULL, 1, '2019-05-05 14:24:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bf390d0e06634cccbeeea152795257f1', '4b6f1b70e8684cabb90e1d3e229ea9de', 197, 1, 1, '2019-08-13 00:13:08', '2019-08-12 23:25:08', '2019-08-12 23:25:08');
INSERT INTO `oauth2_access_token` VALUES ('bf48238c0c214d95ba3df8011deab4f4', 'be52bf4548e244fea2ee9645e8f0c92b', 27, 2, 1, '2019-08-14 15:38:35', '2019-08-14 14:50:34', '2019-08-14 14:50:34');
INSERT INTO `oauth2_access_token` VALUES ('bf51c8513ba4496f8bd5906b25debc18', '60f15795ee40425f9fabbd6be2727bbf', 27, 2, 1, '2019-07-22 19:29:41', '2019-07-22 18:41:41', '2019-07-22 18:41:41');
INSERT INTO `oauth2_access_token` VALUES ('bf5628079d944a84a117c0e92fcd7d4e', 'e3c48034933a42348875c24ba3aa6fd5', 27, 2, 1, '2019-08-09 17:36:44', '2019-08-09 16:48:43', '2019-08-09 16:48:43');
INSERT INTO `oauth2_access_token` VALUES ('bf563289ba5244e5b0462868ea10c51f', 'ca939da43e894e4489887806121c3b28', 27, 2, 1, '2019-05-22 16:23:05', '2019-05-22 15:35:04', '2019-05-22 15:35:04');
INSERT INTO `oauth2_access_token` VALUES ('bf7ebd73cdb54993b2af2e0f01e50279', 'e95b8f882c38469589c7cfadfe75b5db', 27, 2, 1, '2019-06-30 01:32:18', '2019-06-30 00:44:18', '2019-06-30 00:44:18');
INSERT INTO `oauth2_access_token` VALUES ('bf9342bb13ae400b96326e2416972851', 'b996bac3fd1343009aba9042d6588475', 27, 2, 1, '2019-08-13 13:14:40', '2019-08-13 12:26:40', '2019-08-13 12:26:40');
INSERT INTO `oauth2_access_token` VALUES ('bf9c3cdf76a34e2489944597e130fda7', 'fc639d8db85f46f2983d4fd729e1fdab', 27, 2, 1, '2019-07-01 15:41:32', '2019-07-01 14:53:31', '2019-07-01 14:53:31');
INSERT INTO `oauth2_access_token` VALUES ('bfb0fd2ceb824e45879772ca60c69966', 'fe03589217de4a1f8d1a6aa249eb1aaf', 27, 2, 1, '2019-08-17 13:58:18', '2019-08-17 13:10:18', '2019-08-17 13:10:18');
INSERT INTO `oauth2_access_token` VALUES ('bfb12b220f0548c693fa585fc576803d', '841305ff72a04cdfa09006b51f929e91', 27, 2, 1, '2019-07-25 17:31:02', '2019-07-25 16:43:01', '2019-07-25 16:43:01');
INSERT INTO `oauth2_access_token` VALUES ('bfb44a2fc2424b9a832f7ce2918d24b2', '73aa8888524f4e049a28b08372d1fe14', NULL, NULL, 1, '2019-04-22 19:08:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bfb53b94b2c44e58b9cf09403eddacfe', '3a1278c5a88b43d8bedf4b66b7f721ce', NULL, NULL, 1, '2019-05-05 10:40:37', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bfb60d3887a341f2a3aaa2b4cd1dc17d', '23fd2932f23e40e58e1ab5c2507c6219', 27, 2, 1, '2019-06-03 10:02:28', '2019-06-03 09:14:27', '2019-06-03 09:14:27');
INSERT INTO `oauth2_access_token` VALUES ('bfddaf462b3142eabd062952f145f8f2', 'b8cf666f251c45cd8e69fe24c9698100', NULL, NULL, 1, '2019-05-09 16:24:16', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bff0ada2f4864890a794de7664d56a95', 'd47ce23068514e69b1c43fd54802b2c5', 27, 2, 1, '2019-06-10 11:22:12', '2019-06-10 10:34:11', '2019-06-10 10:34:11');
INSERT INTO `oauth2_access_token` VALUES ('bff165f99a884e9d8cd60d9cd6c90921', '80467d97b01848e8baf360f4db738105', NULL, NULL, 1, '2019-03-15 21:33:13', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('bff3ba31da8f40e8ad97f6fa573f5871', 'e99fbe3623f34fde9dc99d9ccbc034fc', 27, 2, 1, '2019-07-10 18:47:37', '2019-07-10 17:59:37', '2019-07-10 17:59:37');
INSERT INTO `oauth2_access_token` VALUES ('bfff8ffa54854fa784fd1b5732a01ee6', '847ce170d8c1417f88bbe27cab8ab375', 27, 2, 1, '2019-06-04 18:07:52', '2019-06-04 17:19:52', '2019-06-04 17:19:52');
INSERT INTO `oauth2_access_token` VALUES ('c012d96ca6534510bdca5850b036436a', '72fab45466f049aeb0176757850ec9f9', 27, 2, 1, '2019-07-02 18:49:58', '2019-07-02 18:01:57', '2019-07-02 18:01:57');
INSERT INTO `oauth2_access_token` VALUES ('c033958d4f7a45f5aa69570e33e15cf2', 'a185ed24dbf147848f4a6266dd0d5486', NULL, NULL, 1, '2019-05-13 00:34:40', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c041ae101bbf41a68edeffde95378a06', 'd970470a3d8340cdae6c6a00e4b4c3b5', NULL, NULL, 1, '2019-05-08 21:05:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c044e5a1d4184577877a07db812cd073', '65f2ff97f26c415a8cf614867d8943bc', NULL, NULL, 1, '2019-05-11 03:14:43', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c0496870f528459c91c4c17cc49400bb', '98e66869e2bf4f1db29dee6b1809f149', 27, 2, 1, '2019-05-20 22:35:17', '2019-05-20 21:47:17', '2019-05-20 21:47:17');
INSERT INTO `oauth2_access_token` VALUES ('c057d1a13917419b91459362ea8f7ac8', '45d607aeafd9432a915492f32b5906d2', 1, 2, 0, '2019-05-28 15:03:22', '2019-05-28 14:15:22', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('c06ddce0cfa743b9b2ef087b552757a4', 'd6bd3c12350148c5b32cb7f5b60a3e0a', NULL, NULL, 1, '2019-05-05 11:08:47', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c07ee3ac84a042d0840dc6e3100a57b1', '37f0e166108a4a14a57395bc021d5fda', 27, 2, 1, '2019-07-03 14:01:20', '2019-07-03 13:13:20', '2019-07-03 13:13:20');
INSERT INTO `oauth2_access_token` VALUES ('c08b506ea62e42ad81633f7f9553b042', 'b211932b6a1f4bc7bcd6a5f16199d7c5', 22, 2, 1, '2019-07-01 10:42:01', '2019-07-01 09:54:01', '2019-07-01 09:54:01');
INSERT INTO `oauth2_access_token` VALUES ('c0ab168b19574bb2ac58d01ac1b58e15', '4ae4ed8baffc4e25807a5dd4f132d3b9', 27, 2, 1, '2019-08-21 10:33:12', '2019-08-21 09:45:12', '2019-08-21 09:45:12');
INSERT INTO `oauth2_access_token` VALUES ('c0b6d3021ee94a54acab86432b30a84b', 'a953053b07b74f2287fa2b06a9e02d88', 156, 1, 1, '2019-07-03 12:25:02', '2019-07-03 11:37:02', '2019-07-03 11:37:02');
INSERT INTO `oauth2_access_token` VALUES ('c0dc136128cc48e7af4d48a3df24c8c4', '1a5db6fd378f4d68a2ef1c91cd0312a2', 27, 2, 1, '2019-08-30 16:28:15', '2019-08-30 15:40:15', '2019-08-30 15:40:15');
INSERT INTO `oauth2_access_token` VALUES ('c1112d9d199048cb821c083b9129da89', '842c37e038424958a615a8a7b5793e60', 27, 2, 1, '2019-05-24 20:53:53', '2019-05-24 20:05:53', '2019-05-24 20:05:53');
INSERT INTO `oauth2_access_token` VALUES ('c12ccf4b665043e389b77906d14df467', 'df46991063c344d8b3657c30dee83e8f', 27, 2, 1, '2019-06-04 15:06:34', '2019-06-04 14:18:33', '2019-06-04 14:18:33');
INSERT INTO `oauth2_access_token` VALUES ('c13f27bcda324ac29e12c903ceaaba2b', 'a3a4e6e382c8402e8e82ed733253498f', 27, 2, 1, '2019-08-23 15:53:14', '2019-08-23 15:05:13', '2019-08-23 15:05:13');
INSERT INTO `oauth2_access_token` VALUES ('c14162bafa154855a58961b05e5f84bb', 'ca56cf931d074bb2a3fc8f456d857f65', 1, 2, 0, '2019-05-17 19:10:58', '2019-05-17 18:22:58', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('c1461ad3ef5c485cb8dc943231c94762', '76ba1286cc924907b8a9eafecc6f4a0f', 27, 2, 1, '2019-08-09 18:03:54', '2019-08-09 17:15:54', '2019-08-09 17:15:54');
INSERT INTO `oauth2_access_token` VALUES ('c146b29ac6c24b11abd512d0325e2538', '2ba9557e8ef44c7d893b63b685b392de', 1, 2, 0, '2019-07-09 11:39:58', '2019-07-09 10:51:58', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('c163b13bc72d45bb9764111708555de0', 'd2b3f845a0204713a968e7012b46108b', 27, 2, 1, '2019-06-01 15:50:39', '2019-06-01 15:02:39', '2019-06-01 15:02:39');
INSERT INTO `oauth2_access_token` VALUES ('c17a12c3285e42499c2525f7905012b3', 'c85e6d01c95949e09f0e97edfca268d4', 1, 2, 0, '2019-06-17 11:29:38', '2019-06-17 10:41:38', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('c187015cd07c458c9b94c03ef7bb47bc', 'c94f1c68d3fa46d999fe9dcedd64e0d9', 27, 2, 1, '2019-07-26 15:55:40', '2019-07-26 15:07:39', '2019-07-26 15:07:39');
INSERT INTO `oauth2_access_token` VALUES ('c19a18a9f5e94c948d7edcb50a93cc54', 'cc1791eaaeaf423e983451959fda1b17', 27, 2, 1, '2019-08-27 18:56:28', '2019-08-27 18:08:28', '2019-08-27 18:08:28');
INSERT INTO `oauth2_access_token` VALUES ('c1b8fa78171d43e29500dd073e40ac7d', 'e676afbf65614eba8007e2a10b4d92f0', 27, 2, 1, '2019-07-04 03:12:23', '2019-07-04 02:24:23', '2019-07-04 02:24:23');
INSERT INTO `oauth2_access_token` VALUES ('c1c0ecbb21084537b8e6981cc0891160', 'fa2c4e4cbe14409d99e84be663b73dd6', 27, 2, 1, '2019-06-05 10:21:42', '2019-06-05 09:33:41', '2019-06-05 09:33:41');
INSERT INTO `oauth2_access_token` VALUES ('c1d79eba2495418e8c187bdde5398f25', 'd8aa376c6f6d4e1f9fa0730dbc45c653', 27, 2, 1, '2019-08-20 13:22:15', '2019-08-20 12:34:15', '2019-08-20 12:34:15');
INSERT INTO `oauth2_access_token` VALUES ('c1e1f21c02d74656b700a6417ad0a5af', 'a367cfa8605f472c82c427b47acf5d15', 27, 2, 1, '2019-07-12 11:01:15', '2019-07-12 10:13:14', '2019-07-12 10:13:14');
INSERT INTO `oauth2_access_token` VALUES ('c1eac72c61514026ba3224da72acc8d8', '24f27735ce3b4ca49fd2b20454508aaf', 27, 2, 1, '2019-07-29 22:05:55', '2019-07-29 21:17:55', '2019-07-29 21:17:55');
INSERT INTO `oauth2_access_token` VALUES ('c1ee0a86cfff4f2fb783389d830cc2e3', 'f49a1fe77dcf4cd19ea1d69a1f5766a2', 27, 2, 1, '2019-08-23 16:35:00', '2019-08-23 15:47:00', '2019-08-23 15:47:00');
INSERT INTO `oauth2_access_token` VALUES ('c2099d96aa8f4ac7be12c3130d90b1bf', 'f7f365b314144840b50d1c0a39651dbd', 27, 2, 1, '2019-07-15 23:55:58', '2019-07-15 23:07:58', '2019-07-15 23:07:58');
INSERT INTO `oauth2_access_token` VALUES ('c20ab6f48b514121bf594be68c7c2c7b', '892ce66f0239463587c9dfb9376adfd2', NULL, NULL, 1, '2019-05-05 11:51:05', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c21850768ac54632b76cf4017009c4a4', '7c2517ed659b4e8296bda62228878f7b', 27, 2, 1, '2019-09-04 12:38:44', '2019-09-04 11:50:44', '2019-09-04 11:50:44');
INSERT INTO `oauth2_access_token` VALUES ('c21fc56203fd4ff088bb202b3e1a2cf1', '2cd7435efeaf4d4faa9f4a3c84486a3e', 99, 1, 1, '2019-06-02 00:44:49', '2019-06-01 23:56:48', '2019-06-01 23:56:48');
INSERT INTO `oauth2_access_token` VALUES ('c2463cf4bf1645e98e70b91c12d8d7dd', '63347923c18c4a5da596f502a7fdb2f2', 27, 2, 1, '2019-08-07 23:20:36', '2019-08-07 22:32:35', '2019-08-07 22:32:35');
INSERT INTO `oauth2_access_token` VALUES ('c2543524da5740d6a4503995dcfd7bdd', '13dc64c6ae4f4616ac41be39f0bde7d3', 1, 2, 0, '2019-09-05 10:36:10', '2019-09-05 09:48:09', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('c25578abe8aa471e94f1cdc274911f14', '3856b8a18394406eb2eaf9382afc717e', 27, 2, 1, '2019-07-22 11:37:38', '2019-07-22 10:49:37', '2019-07-22 10:49:37');
INSERT INTO `oauth2_access_token` VALUES ('c25b3cda9ed24528bbd96a53a66f07e1', '93ab8ae812764c17915c469c626ef9ff', NULL, NULL, 1, '2019-03-10 04:24:23', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c26257af3af9442a9b6fd9e8710967ab', 'ebcff0dccf744d44bb911fe46e349bd3', 27, 2, 1, '2019-05-24 16:08:53', '2019-05-24 15:19:36', '2019-05-24 15:19:36');
INSERT INTO `oauth2_access_token` VALUES ('c2673562c4c94a978d62a29f3c7346f5', '1593bddcffce430281ac4efa8bae4a97', NULL, NULL, 1, '2019-03-11 00:42:04', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c26934c41fa2451bba82598918957d08', 'f34ca7c66e6a4543acec2baba26871b7', 92, 1, 1, '2019-05-30 18:35:12', '2019-05-30 17:47:11', '2019-05-30 17:47:11');
INSERT INTO `oauth2_access_token` VALUES ('c278d5f6d1e84c4c818849363a6c28e4', 'd6f02244a5c141ebaa634c02d20ca7a3', 27, 2, 1, '2019-06-12 20:12:27', '2019-06-12 19:24:27', '2019-06-12 19:24:27');
INSERT INTO `oauth2_access_token` VALUES ('c279bb629c1844419750e1b3ba546fec', 'f18b11d97c9346f0ac2a3af8b7b932e1', 27, 2, 1, '2019-06-12 15:00:15', '2019-06-12 14:12:14', '2019-06-12 14:12:14');
INSERT INTO `oauth2_access_token` VALUES ('c29796b0a9504e8dadb0027bc34bc874', '32576be4b96d40099caadf24da9a9730', 27, 2, 1, '2019-07-23 10:50:12', '2019-07-23 10:02:12', '2019-07-23 10:02:12');
INSERT INTO `oauth2_access_token` VALUES ('c2bfbed2d6dd4dd691d005ecd781515a', '697a72ad67fb4064857339fe2eb5ee6d', 1, 2, 0, '2019-09-03 22:41:25', '2019-09-03 21:53:25', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('c2d7d4018ebe4fcab8c63cf32981972b', 'ca1fb3dc8f114944a86c53bd2bf41c25', 1, 2, 0, '2019-06-06 14:23:09', '2019-06-06 13:35:08', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('c2e82745f05b4eae85b6efc54ddd6ccc', '26a3b002691846c99086a06dbee7548d', 27, 2, 1, '2019-05-20 21:59:35', '2019-05-20 21:11:35', '2019-05-20 21:11:35');
INSERT INTO `oauth2_access_token` VALUES ('c32157dc8ce041169c602a00baca63ad', 'e236907aff584598af69c12d4fbb2e18', NULL, NULL, 1, '2019-04-24 11:34:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c327387508984b23bd05b1cfb1d22419', '9c27ebe299fc46d09f864d87aa30bbb4', NULL, NULL, 1, '2019-04-29 13:45:07', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c3275f40c48c4402ac7e04ff32d0486e', 'b169a3529be0458f80aa5d0fb18b304f', 27, 2, 1, '2019-06-03 16:15:00', '2019-06-03 15:27:00', '2019-06-03 15:27:00');
INSERT INTO `oauth2_access_token` VALUES ('c34248f4812c4c8090c6e662410c8fc5', '9bf2abfa1ec8466da463b959adcb3ed1', 27, 2, 1, '2019-06-10 11:27:51', '2019-06-10 10:39:50', '2019-06-10 10:39:50');
INSERT INTO `oauth2_access_token` VALUES ('c34dd1a82a9c4e619f0ce98971baf71a', '1e4d04def37d42aba27057f2b3ee2c5a', 177, 1, 1, '2019-07-19 20:56:56', '2019-07-19 20:08:55', '2019-07-19 20:08:55');
INSERT INTO `oauth2_access_token` VALUES ('c354cef442d9445c97ad5644cdb8305f', 'df0098a2ebb64b1a826763a0779bd15a', 27, 2, 1, '2019-06-23 14:03:59', '2019-06-23 13:15:58', '2019-06-23 13:15:58');
INSERT INTO `oauth2_access_token` VALUES ('c359a11f575141a698a7eaeec8347556', '81bdc5231c4f48deb371243fe49b5df5', NULL, NULL, 1, '2019-04-24 01:22:02', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c362f525010a468bba3a041d20edca7e', '8e118ecd739b4ccaa9e576f535b337ad', 27, 2, 1, '2019-08-03 21:33:18', '2019-08-03 20:45:17', '2019-08-03 20:45:17');
INSERT INTO `oauth2_access_token` VALUES ('c38d954768cf484893eff7cdb95aabae', '5297ce22971844ffaaa10b89720ca78d', 27, 2, 1, '2019-07-24 10:56:52', '2019-07-24 10:08:51', '2019-07-24 10:08:51');
INSERT INTO `oauth2_access_token` VALUES ('c39014145d624a44a782dc582c7597fc', '37b245f77a394c3cb63cd2bde61c1d08', 27, 2, 1, '2019-08-05 14:34:16', '2019-08-05 13:46:15', '2019-08-05 13:46:15');
INSERT INTO `oauth2_access_token` VALUES ('c39d0b36afca4e6eb35ecbad460d66c4', '7acd8ef7bc004b73a7b8aac680e9bbfa', 27, 2, 1, '2019-08-01 23:16:15', '2019-08-01 22:28:14', '2019-08-01 22:28:14');
INSERT INTO `oauth2_access_token` VALUES ('c3a1951e17b9413093d9f2fd4a1b20a0', '9549439f445140c4b340bb3e8a3d992a', 27, 2, 1, '2019-06-04 17:41:36', '2019-06-04 16:53:36', '2019-06-04 16:53:36');
INSERT INTO `oauth2_access_token` VALUES ('c3c4eb3adef941d6a26ed7adcd540e47', '367314bedd23489b86cbd81746026708', 27, 2, 1, '2019-07-21 23:14:51', '2019-07-21 22:26:50', '2019-07-21 22:26:50');
INSERT INTO `oauth2_access_token` VALUES ('c3dafb4bd1954b3ba84ad82922f9dda1', 'fdf307128685414c92cacb66ce5cb19e', 27, 2, 1, '2019-08-26 15:58:22', '2019-08-26 15:10:21', '2019-08-26 15:10:21');
INSERT INTO `oauth2_access_token` VALUES ('c405a5e74ba3417fb5d84159464375f6', '4d83d54849264d258431318e4e505ac2', 27, 2, 1, '2019-06-03 16:14:33', '2019-06-03 15:26:33', '2019-06-03 15:26:33');
INSERT INTO `oauth2_access_token` VALUES ('c4147bbb29f84652be4e745d1a413db2', '673cef250c70452eb9415e1269d18108', 27, 2, 1, '2019-08-28 18:03:38', '2019-08-28 17:15:38', '2019-08-28 17:15:38');
INSERT INTO `oauth2_access_token` VALUES ('c41a9f6d35b4442e80dc96be5d3e6292', '4653acacfa154da98f85d962fa7657ca', 27, 2, 1, '2019-08-19 14:55:17', '2019-08-19 14:07:17', '2019-08-19 14:07:17');
INSERT INTO `oauth2_access_token` VALUES ('c42359320ce040f2ba8cbc8dbd5b2131', '06fc8302ac31484eb0b47c140c54c3fc', 27, 2, 1, '2019-08-04 12:27:07', '2019-08-04 11:39:06', '2019-08-04 11:39:06');
INSERT INTO `oauth2_access_token` VALUES ('c427048d388b4c62b8fc9a8f6dca32ea', '90f9590deab145d8ae413ebf454b8886', 27, 2, 1, '2019-07-09 11:52:08', '2019-07-09 11:04:08', '2019-07-09 11:04:08');
INSERT INTO `oauth2_access_token` VALUES ('c42f5ed7b09245c489f95769e137bf20', '864a84f3b4e54f0e87651c0f30f4ee22', 27, 2, 1, '2019-05-31 18:49:32', '2019-05-31 18:01:32', '2019-05-31 18:01:32');
INSERT INTO `oauth2_access_token` VALUES ('c4441c87acb24919ad95ab6a5dedf6b4', '3b3c82ec932c4f20bd3540abd16f9bc1', 27, 2, 1, '2019-06-24 18:09:07', '2019-06-24 17:21:06', '2019-06-24 17:21:06');
INSERT INTO `oauth2_access_token` VALUES ('c46300a768ea40c385d797b204076410', '89259d18bbef4236a0398bede189617e', NULL, NULL, 1, '2019-05-10 15:53:48', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c46534d602fa4afa838c8f8b7661aa4c', '33974e798cc048ffb9c934f88401ff5c', 1, 2, 0, '2019-08-21 18:49:49', '2019-08-21 18:01:49', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('c46e03e5b3954a77a83b5e417bc32841', 'e8c29d02fe944265bca1d76543844e83', 27, 2, 1, '2019-05-28 23:15:44', '2019-05-28 22:27:44', '2019-05-28 22:27:44');
INSERT INTO `oauth2_access_token` VALUES ('c470830f8e054cacaf3a8b6b7ddf6efe', '8f923e6d0dfd46abb0f1fc159732d345', 27, 2, 1, '2019-08-01 13:02:30', '2019-08-01 12:14:29', '2019-08-01 12:14:29');
INSERT INTO `oauth2_access_token` VALUES ('c48e0f41d70745ba847849d12d0c00a2', 'b6dbcd6bedbb49b6ada5657fc49e5bb9', 27, 2, 1, '2019-06-03 15:21:30', '2019-06-03 14:33:30', '2019-06-03 14:33:30');
INSERT INTO `oauth2_access_token` VALUES ('c4a1f8d4748546f4ac8072cb4e7690de', 'b8f4d52f51984a5dacf6ca6668795a32', 27, 2, 1, '2019-07-16 17:48:00', '2019-07-16 16:59:59', '2019-07-16 16:59:59');
INSERT INTO `oauth2_access_token` VALUES ('c4c3e574aa404fe597dd5b253569eefd', 'f120841b55034fe78026f3e8ea646fa8', 27, 2, 1, '2019-05-27 11:33:57', '2019-05-27 10:45:56', '2019-05-27 10:45:56');
INSERT INTO `oauth2_access_token` VALUES ('c4da665850f64061b758b5f6aafff58b', 'f81884e537b04372a5cd723634387137', 27, 2, 1, '2019-06-28 17:54:34', '2019-06-28 17:06:33', '2019-06-28 17:06:33');
INSERT INTO `oauth2_access_token` VALUES ('c4df553c276244f0a3ed08bf98dc5161', 'a1c7ec710d0942a2b4646496967b8c01', 27, 2, 1, '2019-08-27 19:59:25', '2019-08-27 19:11:24', '2019-08-27 19:11:24');
INSERT INTO `oauth2_access_token` VALUES ('c4edda0bede24e858bc2beee16b1dde8', 'ba6783efbb3b433587190f09f6ccb9dd', 27, 2, 1, '2019-06-06 18:05:20', '2019-06-06 17:17:20', '2019-06-06 17:17:20');
INSERT INTO `oauth2_access_token` VALUES ('c514e4fff4924c418286783693f34696', '973b4e7933dd4997b947d4a9867d9899', 27, 2, 1, '2019-06-14 15:54:30', '2019-06-14 15:06:29', '2019-06-14 15:06:29');
INSERT INTO `oauth2_access_token` VALUES ('c516368cf47847c78a9ddecbb920671c', 'c972c56b45df4aa9bf6397555b5d9319', 27, 2, 1, '2019-05-31 17:51:51', '2019-05-31 17:03:51', '2019-05-31 17:03:51');
INSERT INTO `oauth2_access_token` VALUES ('c518b86917ba46d299b24824840db0d1', '28973654f38843d1b9cb19359d0f40e5', 1, 2, 0, '2019-07-26 11:07:18', '2019-07-26 10:19:18', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('c51a4b90a8f04adf8ae7baaa8dc36040', '97d14581e3cb4270a504dfa9d9fc9e20', 127, 1, 1, '2019-06-19 15:18:45', '2019-06-19 14:30:44', '2019-06-19 14:30:44');
INSERT INTO `oauth2_access_token` VALUES ('c52c9f4c82f1474e9f7ac2ea4b583c9f', 'c006c54f67764e868f7caaa7fe1d6b61', 1, 2, 0, '2019-07-02 09:31:02', '2019-07-02 08:43:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('c548bd366d2c49a2b6d01d3e2b69f585', 'ab6ef9944ca3406583a9238f307e3519', 1, 2, 0, '2019-07-05 10:50:25', '2019-07-05 10:02:24', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('c5508743ec7e4743a83a453a20608ff2', '3420a434638a4469ab5b749ed5076e72', 27, 2, 1, '2019-07-09 16:54:47', '2019-07-09 16:06:46', '2019-07-09 16:06:46');
INSERT INTO `oauth2_access_token` VALUES ('c55c4d23504140bbbb3a8b62a76117b6', '097e4c1f835244bca2c3b7ca8aa35e72', 27, 2, 1, '2019-08-18 22:56:07', '2019-08-18 22:08:06', '2019-08-18 22:08:06');
INSERT INTO `oauth2_access_token` VALUES ('c564c3f759d04010909be35f647056f8', 'd3ab9560c60b41d692cc34b6ad6c40ec', 27, 2, 1, '2019-07-14 23:29:05', '2019-07-14 22:41:05', '2019-07-14 22:41:05');
INSERT INTO `oauth2_access_token` VALUES ('c568a539ffe8486faa5a98787b07cca6', '8a8ab93381d340b596f7b8d83d571677', 27, 2, 1, '2019-08-01 16:41:36', '2019-08-01 15:53:36', '2019-08-01 15:53:36');
INSERT INTO `oauth2_access_token` VALUES ('c57bd83d24d542eeac6d57af450239fd', 'd17af7338f5e4181bb09a9ec5dc1aedf', 195, 1, 1, '2019-08-10 16:24:17', '2019-08-10 15:36:18', '2019-08-10 15:36:18');
INSERT INTO `oauth2_access_token` VALUES ('c590f12f3880453096ad150ae7485d41', '7cbe2012523d4433872d19c1f8b55e48', 27, 2, 1, '2019-06-04 23:46:36', '2019-06-04 22:58:36', '2019-06-04 22:58:36');
INSERT INTO `oauth2_access_token` VALUES ('c593002735fd4646aced5251865a71ab', 'd8f3f1c5fde1492ca4530fe6b8d130e7', 27, 2, 1, '2019-07-09 16:52:12', '2019-07-09 16:04:12', '2019-07-09 16:04:12');
INSERT INTO `oauth2_access_token` VALUES ('c59772bb904043639e5664607adf31fd', 'bb93f96a4c5e442396b49b802be3f143', 27, 2, 1, '2019-09-07 12:12:37', '2019-09-07 11:24:36', '2019-09-07 11:24:36');
INSERT INTO `oauth2_access_token` VALUES ('c5aefc20fb6f4cc8b9d3f92f2d1371cb', '329bda86f9a44df588fb38801818e1f9', NULL, NULL, 1, '2019-05-05 09:22:40', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c5c51cd9dd284a1a8b194266344aab71', 'e3247029fc1342e8ac1c276139413eeb', 27, 2, 1, '2019-05-31 19:44:18', '2019-05-31 18:56:18', '2019-05-31 18:56:18');
INSERT INTO `oauth2_access_token` VALUES ('c5c6d2c25864423591fca3888ce0828f', 'f0ff136033c44d6da1a696b0b4f523e0', 27, 2, 1, '2019-08-26 15:18:10', '2019-08-26 14:30:09', '2019-08-26 14:30:09');
INSERT INTO `oauth2_access_token` VALUES ('c5fa2d44e6e547f089b04a2612ee977d', '7a3c0b7f873246b3ae111ab4eec27043', 27, 2, 1, '2019-07-19 17:40:26', '2019-07-19 16:52:26', '2019-07-19 16:52:26');
INSERT INTO `oauth2_access_token` VALUES ('c608a2a6d0af4b54945a01b36687cbe2', 'b797e00a211a4b1cb80e64f52e45d99a', 27, 2, 1, '2019-07-26 11:09:06', '2019-07-26 10:21:06', '2019-07-26 10:21:06');
INSERT INTO `oauth2_access_token` VALUES ('c6571e16b5534a73baa550b0e90e6208', '916ea653465d4cc3966238c198e3644f', 27, 2, 1, '2019-09-06 19:35:27', '2019-09-06 18:47:26', '2019-09-06 18:47:26');
INSERT INTO `oauth2_access_token` VALUES ('c68465fc707447f7abb676d8b42a443f', '317aa024ae754f0ca188977a5372b083', 27, 2, 1, '2019-07-24 15:22:59', '2019-07-24 14:34:58', '2019-07-24 14:34:58');
INSERT INTO `oauth2_access_token` VALUES ('c68bd381faa64f89a98f953675cb2b34', '59692a1b84054661b2f136b165a8d56d', NULL, NULL, 1, '2019-04-26 14:49:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c6a3871952814679a8c540fb0ad58aec', '691df86e19404bc0a039c2eded031c91', 27, 2, 1, '2019-06-20 09:21:52', '2019-06-20 08:33:51', '2019-06-20 08:33:51');
INSERT INTO `oauth2_access_token` VALUES ('c6b786ddf71d479da04e55c32f397fa2', 'b850806c051040dc886e0f7a7f1dfa30', 27, 2, 1, '2019-08-05 16:58:35', '2019-08-05 16:10:34', '2019-08-05 16:10:34');
INSERT INTO `oauth2_access_token` VALUES ('c6ba9144e8db4618b685d68691b377f3', '1bef1832f47845acb27a4c53d607b3eb', 27, 2, 1, '2019-05-31 22:08:46', '2019-05-31 21:20:46', '2019-05-31 21:20:46');
INSERT INTO `oauth2_access_token` VALUES ('c6ee80d489ed48c696ff044858b779bf', 'f8ceb67d697144bf8cff56c1c581909b', 27, 2, 1, '2019-08-23 14:21:30', '2019-08-23 13:33:30', '2019-08-23 13:33:30');
INSERT INTO `oauth2_access_token` VALUES ('c70923492bdd45d8ae8f54a8057bf2c4', 'b8da8e150f8b4722b14f57fc1a76b6f1', NULL, NULL, 1, '2019-05-08 15:29:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c70a86e2e54647d99064049b14139d06', '81e16e9de1ea46c3852bfc3c7e89904a', 27, 2, 1, '2019-07-21 15:07:58', '2019-07-21 14:19:58', '2019-07-21 14:19:58');
INSERT INTO `oauth2_access_token` VALUES ('c70aee631f6c4c7a8b947439832f291d', '8c7b1066e04f4bdb988c8861df52adf4', 27, 2, 1, '2019-07-27 15:51:58', '2019-07-27 15:03:57', '2019-07-27 15:03:57');
INSERT INTO `oauth2_access_token` VALUES ('c7444d8e3e5e41279d5c541a60098830', '9ebea079f16545f3a50889263351297d', NULL, NULL, 1, '2019-05-09 21:35:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c768a7bb3f924b47bb553f40c3571bfe', 'b79fe8df74ce48f7b678ad41520f4a83', 27, 2, 1, '2019-05-31 18:19:09', '2019-05-31 17:31:08', '2019-05-31 17:31:08');
INSERT INTO `oauth2_access_token` VALUES ('c78c13c87dea4919bc2f44ec4e9d1e37', '1a1b4e1c18d045f7b6d383af94c9f498', 27, 2, 1, '2019-06-01 13:23:37', '2019-06-01 12:35:36', '2019-06-01 12:35:36');
INSERT INTO `oauth2_access_token` VALUES ('c799bae74c7a456e886233958c27a69d', '6a83abdd0a0947739a3256859575beed', NULL, NULL, 1, '2019-05-10 22:58:10', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c7ad0df432494376b2d150b5145182df', 'bcadafbdd0c7488cb819f7d873007d52', 27, 2, 1, '2019-05-31 22:37:06', '2019-05-31 21:49:06', '2019-05-31 21:49:06');
INSERT INTO `oauth2_access_token` VALUES ('c7b3b2a0b22d488485d853c84b3ce1a2', '624dbf5625bd4b3a919aa5ca76265120', 27, 2, 1, '2019-06-19 12:00:25', '2019-06-19 11:12:24', '2019-06-19 11:12:24');
INSERT INTO `oauth2_access_token` VALUES ('c7bff17ef8e74636be27601d72d54826', '7cb927e062674b0b83fd45e12ed4f854', 27, 2, 1, '2019-06-05 02:42:26', '2019-06-05 01:54:26', '2019-06-05 01:54:26');
INSERT INTO `oauth2_access_token` VALUES ('c7eb46766d1a49b08a4cef7781ccfcd4', 'e8b2612057b246a58a08335481f7c100', 27, 2, 1, '2019-07-11 10:12:37', '2019-07-11 09:24:36', '2019-07-11 09:24:36');
INSERT INTO `oauth2_access_token` VALUES ('c84d3dd763b0468b9fd139305fd22179', '8eb692f9f37643c181b600d9f9170f77', 27, 2, 1, '2019-06-06 23:43:19', '2019-06-06 22:55:18', '2019-06-06 22:55:18');
INSERT INTO `oauth2_access_token` VALUES ('c86eb9b85d74494bad5ae69f0562eabf', '7d829c9137354674bcac6e51e192364b', 27, 2, 1, '2019-07-15 14:00:28', '2019-07-15 13:12:28', '2019-07-15 13:12:28');
INSERT INTO `oauth2_access_token` VALUES ('c8916c124958496487726e5ebf8964d9', '926d9bd34db545208ab276cebce99fac', 27, 2, 1, '2019-08-09 12:06:55', '2019-08-09 11:18:55', '2019-08-09 11:18:55');
INSERT INTO `oauth2_access_token` VALUES ('c8a8e172f19e4797b0cda4deed3e955c', '2acd683796d140c1821fdee2a7151c94', 27, 2, 1, '2019-07-10 10:06:22', '2019-07-10 09:18:21', '2019-07-10 09:18:21');
INSERT INTO `oauth2_access_token` VALUES ('c8d20dd55c9843a783c1841e5fac4980', 'c2f9894813694efeb4ba3c448098344b', 27, 2, 1, '2019-06-28 12:56:58', '2019-06-28 12:08:57', '2019-06-28 12:08:57');
INSERT INTO `oauth2_access_token` VALUES ('c8eafbe8ad634d1a8411bcb76c107c37', '9aa3ae6635bd42fa95303b13c0335db1', 141, 1, 1, '2019-06-26 15:43:31', '2019-06-26 14:55:30', '2019-06-26 14:55:30');
INSERT INTO `oauth2_access_token` VALUES ('c900c060b6d742508d2b5af777ab2b15', 'a738b4a55cba4690ac0b087ddfc1a9de', 27, 2, 1, '2019-06-20 22:54:39', '2019-06-20 22:06:38', '2019-06-20 22:06:38');
INSERT INTO `oauth2_access_token` VALUES ('c90421f2611d43dbbe41a61aeb56d7df', '73dfdb7e5e1c42a899d0db881b08c2df', 27, 2, 1, '2019-06-02 15:26:02', '2019-06-02 14:38:02', '2019-06-02 14:38:02');
INSERT INTO `oauth2_access_token` VALUES ('c90ed6e8a8e34a7db2adc08862fc49e3', '06d5418ba86c410f9fba25ecd031bd49', 27, 2, 1, '2019-06-01 11:50:48', '2019-06-01 11:02:48', '2019-06-01 11:02:48');
INSERT INTO `oauth2_access_token` VALUES ('c9102b1c63b94424afbad85054c6d50e', '2646cda31f204beeb76364502a0dae39', 27, 2, 1, '2019-06-14 10:04:37', '2019-06-14 09:16:36', '2019-06-14 09:16:36');
INSERT INTO `oauth2_access_token` VALUES ('c9159dccf7324a14ade115855f0134fa', 'ddf176f572ad4769a67f77b8da40d204', 27, 2, 1, '2019-07-08 15:27:36', '2019-07-08 14:39:36', '2019-07-08 14:39:36');
INSERT INTO `oauth2_access_token` VALUES ('c9239a1e62384bac9d5807ee3ddade6b', 'ec04062c85f840af969edbd33bc29f59', NULL, NULL, 1, '2019-04-05 13:58:58', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c928f3f2b2a047b3b1665517bca8181f', 'ed5eaf9e8dfd4cf4a8d3dd8c9fcc52a5', 27, 2, 1, '2019-09-06 10:06:45', '2019-09-06 09:18:44', '2019-09-06 09:18:44');
INSERT INTO `oauth2_access_token` VALUES ('c948bba59a1242d5b1bdf5709a9841f6', '6f969a60e9b54e89a517f343f7e5ece8', 27, 2, 1, '2019-08-12 15:05:42', '2019-08-12 14:17:42', '2019-08-12 14:17:42');
INSERT INTO `oauth2_access_token` VALUES ('c94d4609800545f8ac3a0fa5f7f31f7d', 'ce70a44c6aa34419a5db41e09230a66b', 27, 2, 1, '2019-07-03 12:13:30', '2019-07-03 11:25:29', '2019-07-03 11:25:29');
INSERT INTO `oauth2_access_token` VALUES ('c95068dd12114464ada4bf0d1b174ef4', '6661d4a8738a46d18a13891f8549d9ca', NULL, NULL, 1, '2019-03-12 23:52:46', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c9511c45bd20476e8e1ad6d312663135', '93cb534f1a114fd2b6b2f597fd113b3a', 27, 2, 1, '2019-06-11 12:11:39', '2019-06-11 11:23:39', '2019-06-11 11:23:39');
INSERT INTO `oauth2_access_token` VALUES ('c951b187183b4964a7fcdf5bf2e9bc0e', '024f69e843824ac28d44f10b8f53d70f', NULL, NULL, 1, '2019-03-19 02:01:10', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c9cf52c499754c828c61f7e9ea7ed123', '17f4ee36dc1e450fbda82b0edddbb428', 27, 2, 1, '2019-06-09 22:50:58', '2019-06-09 22:02:57', '2019-06-09 22:02:57');
INSERT INTO `oauth2_access_token` VALUES ('c9d97b03dbc74945b25bcd4da02b4411', 'd4ded3ef12f241c0b7b44ab80a11fccc', 27, 2, 1, '2019-06-01 15:35:37', '2019-06-01 14:47:37', '2019-06-01 14:47:37');
INSERT INTO `oauth2_access_token` VALUES ('c9daadea2d6b45b69dd236643b7c85fd', '8af28a5716b342dd9b712c32e5c45dca', 74, 1, 1, '2019-05-17 22:40:55', '2019-05-17 21:52:54', '2019-05-17 21:52:54');
INSERT INTO `oauth2_access_token` VALUES ('c9e5db043a4f4674b619048d4034658f', 'e6007c15afb048ad851806f355928377', NULL, NULL, 1, '2019-03-08 12:34:16', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('c9e8e138cad642eca7fd17b6599dfe58', 'a609b7043bcb4fa8b325d6415ea50081', 27, 2, 1, '2019-05-17 17:56:58', '2019-05-17 17:08:58', '2019-05-17 17:08:58');
INSERT INTO `oauth2_access_token` VALUES ('c9ec8f0b18dd406ca0b25b54a5746bd3', 'bd6b7ab64fee470e911c28fd4e198209', 27, 2, 1, '2019-07-15 02:10:27', '2019-07-15 01:22:27', '2019-07-15 01:22:27');
INSERT INTO `oauth2_access_token` VALUES ('c9ee84d1182e4f19b43f29837b1f57f5', '42bdf2afcf4f43a7ba719b8f54c6d8f5', 27, 2, 1, '2019-07-18 14:08:41', '2019-07-18 13:20:41', '2019-07-18 13:20:41');
INSERT INTO `oauth2_access_token` VALUES ('ca05929133af4a08a35c80498bbc368a', '0521fcbdedd64dc9a1e174a9b7c8816d', 27, 2, 1, '2019-08-28 02:01:55', '2019-08-28 01:13:55', '2019-08-28 01:13:55');
INSERT INTO `oauth2_access_token` VALUES ('ca0c73d6c1344a65ba5aa68736220cdd', 'f2bcbd72565544a7b2b586aad4e8c3ab', 27, 2, 1, '2019-06-14 13:26:57', '2019-06-14 12:38:56', '2019-06-14 12:38:56');
INSERT INTO `oauth2_access_token` VALUES ('ca1ab6a71ff94b94b4a0e6392afe03cd', 'ff8aeb4e8e49418e85d0f993933c35dc', 27, 2, 1, '2019-05-22 10:50:37', '2019-05-22 10:02:37', '2019-05-22 10:02:37');
INSERT INTO `oauth2_access_token` VALUES ('ca2a508d87f84fce8bbfcfb3a2630b76', 'e1c9445b3f524726b87517e177f96b7c', NULL, NULL, 1, '2019-05-07 18:01:25', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ca34092d54164cb695984e58bb6e7b8b', 'ae20c464788d4f67bbbe1e532327057a', 27, 2, 1, '2019-08-27 16:17:42', '2019-08-27 15:29:42', '2019-08-27 15:29:42');
INSERT INTO `oauth2_access_token` VALUES ('ca3b7b4cd5b54fd7b3a70e1530d975fe', '58cc5d96fd1146dc9c750a64f74b85a2', 27, 2, 1, '2019-06-14 17:06:23', '2019-06-14 16:18:23', '2019-06-14 16:18:23');
INSERT INTO `oauth2_access_token` VALUES ('ca3ea445c14b4197a61b88580e244780', 'ad53f8f154ae4d478548ac12c995be9b', NULL, NULL, 1, '2019-05-08 23:55:04', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ca430cedaa4648f7bad961d605729609', '81d9247dc76649148c6f121d5eefdd30', 1, 2, 0, '2019-07-15 11:32:36', '2019-07-15 10:44:35', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('ca4bb5a322044729a3eb5ef7c942665b', 'a1e17a525a05484e8193785efae25e37', 27, 2, 1, '2019-08-27 12:11:36', '2019-08-27 11:23:36', '2019-08-27 11:23:36');
INSERT INTO `oauth2_access_token` VALUES ('ca5105f9e1ca45c280b71d603f1fdcba', '53a7619e43b748499579bb7ce44f236c', 1, 1, 0, '2019-05-17 17:10:54', '2019-05-17 16:22:53', '2019-05-17 17:30:55');
INSERT INTO `oauth2_access_token` VALUES ('ca5871f505784c048275b42ac71a5f49', 'aa54d20804b841f8b002d29444ee5bc0', NULL, NULL, 1, '2019-03-30 00:19:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ca636ab87f4c41a4aa93ddd0c5f53d29', '2e650487f44a44279c4de72e99ec01c9', 27, 2, 1, '2019-08-27 12:21:32', '2019-08-27 11:33:31', '2019-08-27 11:33:31');
INSERT INTO `oauth2_access_token` VALUES ('ca668347b90d487e8bb0c112697616c9', '6d70ae273b894e409a5e29a80bdaa55d', 27, 2, 1, '2019-07-24 10:21:30', '2019-07-24 09:33:30', '2019-07-24 09:33:30');
INSERT INTO `oauth2_access_token` VALUES ('ca72d3968aa24732ab88576346d051ee', '35059bf52e4044d1a6fb1c6aa2c8f7e9', NULL, NULL, 1, '2019-05-05 20:18:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ca72fa8965e84d66b2cbc50abe6eb7bd', '764c02ad63644fa8a501e87b631118ff', 27, 2, 1, '2019-08-12 21:23:22', '2019-08-12 20:35:21', '2019-08-12 20:35:21');
INSERT INTO `oauth2_access_token` VALUES ('ca8a4fc05c7f42e98bdbcc2438ba356c', 'f6b2caa8f4d74b6480034ee55b09e689', 27, 2, 1, '2019-07-29 15:33:52', '2019-07-29 14:45:51', '2019-07-29 14:45:51');
INSERT INTO `oauth2_access_token` VALUES ('cabb328d02f44fb2adbf1e03bcc02145', '4cc550ac9da5477abbfb2a419d1e968d', 27, 2, 1, '2019-08-14 17:53:55', '2019-08-14 17:05:55', '2019-08-14 17:05:55');
INSERT INTO `oauth2_access_token` VALUES ('cac65d8377794131bf510db3253df475', 'f0d555f69a5848e28ff091d70a7d5667', 27, 2, 1, '2019-06-19 12:45:32', '2019-06-19 11:57:31', '2019-06-19 11:57:31');
INSERT INTO `oauth2_access_token` VALUES ('cacccad8ea834d38b04e73eb9ba6a180', 'db49ed31c43544c9ac321891497cb4c8', NULL, NULL, 1, '2019-05-09 20:40:17', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('cae90d4a5d1446c989b27fcb5a23a6fa', 'bcbdd857e25e467b9ad85b06211224ac', 27, 2, 1, '2019-07-02 17:40:12', '2019-07-02 16:52:12', '2019-07-02 16:52:12');
INSERT INTO `oauth2_access_token` VALUES ('cafcb3f392f44fa9861e7741f0419d6b', 'c66358ca910a4cbf87ce09eb623947ad', 27, 2, 1, '2019-07-18 15:27:04', '2019-07-18 14:39:04', '2019-07-18 14:39:04');
INSERT INTO `oauth2_access_token` VALUES ('cb0d2deacf5240a687a748e0ac384911', 'feebdb785c7049aca33ba931ed744b52', 27, 2, 1, '2019-06-20 19:27:43', '2019-06-20 18:39:42', '2019-06-20 18:39:42');
INSERT INTO `oauth2_access_token` VALUES ('cb231a1f8ec34415bc6a5a7597e3b560', '4dc2e4946e2f4060904eaa51f13184ce', 27, 2, 1, '2019-07-23 14:52:42', '2019-07-23 14:04:41', '2019-07-23 14:04:41');
INSERT INTO `oauth2_access_token` VALUES ('cb341b5b847e45f795eaa618b1d2a11b', '59e2b7da0ef54698b3832c833c819b83', 27, 2, 1, '2019-06-11 11:45:44', '2019-06-11 10:57:43', '2019-06-11 10:57:43');
INSERT INTO `oauth2_access_token` VALUES ('cb626ced773541a882c7f48fecf132c3', '35ffab04538a4d909ca2da7130fbae9f', NULL, NULL, 1, '2019-04-29 11:27:33', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('cb6d6f0a5c8249d7ab65417dab9d2530', '5124504ed519484ab9a0162ab558e7a9', 27, 2, 1, '2019-08-08 10:00:44', '2019-08-08 09:12:44', '2019-08-08 09:12:44');
INSERT INTO `oauth2_access_token` VALUES ('cb730e2eadc7420683503295ab09202d', '4efab12642724a6884e09028db9d4e65', 1, 2, 0, '2019-07-05 11:04:37', '2019-07-05 10:16:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('cb7f2b21b57a411597f223f1fbd27df2', 'a296e353d1154f369bb775e2ba516292', 1, 2, 0, '2019-07-12 08:50:40', '2019-07-12 08:02:39', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('cb88ffd46b9b4f3ba1b361fadc47894e', '670e54a4dc0841f28c78fba52c1c0b87', 27, 2, 1, '2019-06-18 20:41:00', '2019-06-18 19:52:59', '2019-06-18 19:52:59');
INSERT INTO `oauth2_access_token` VALUES ('cbdfa8eacfff48658090ad3b3d204e2f', 'ad7d427e6bb146b5bc08d055fba60c1e', 27, 2, 1, '2019-08-01 17:40:17', '2019-08-01 16:52:16', '2019-08-01 16:52:16');
INSERT INTO `oauth2_access_token` VALUES ('cbe605b5a8cc4f1584eaaba8507fb44d', 'b710c67478ba4754a2d7deb9da7cb993', 27, 2, 1, '2019-05-31 23:25:54', '2019-05-31 22:37:53', '2019-05-31 22:37:53');
INSERT INTO `oauth2_access_token` VALUES ('cbed3634ff0c4c06a96c76b5fc7fc273', '1153ea1dcb2b4dc0aaa8b81baed28426', 27, 2, 1, '2019-05-30 23:31:47', '2019-05-30 22:43:46', '2019-05-30 22:43:46');
INSERT INTO `oauth2_access_token` VALUES ('cbfb5b3594d346d784a71a71437990fe', '96f523ead86c488baf1d0c2dd6933389', 27, 2, 1, '2019-07-03 17:43:52', '2019-07-03 16:55:52', '2019-07-03 16:55:52');
INSERT INTO `oauth2_access_token` VALUES ('cc0bd0052b4c445fbcf354bf67e1344a', '86c447184e584ae39b870c34f283b2ce', 27, 2, 1, '2019-08-07 12:10:01', '2019-08-07 11:22:00', '2019-08-07 11:22:00');
INSERT INTO `oauth2_access_token` VALUES ('cc2ebee2f7544497b338cb9e6eb65cb4', '597632a6a0bd42d7a6496bf4ba878380', 27, 2, 1, '2019-08-12 09:26:30', '2019-08-12 08:38:30', '2019-08-12 08:38:30');
INSERT INTO `oauth2_access_token` VALUES ('cc36cdaed8de46ada7201fb72b24d52d', '9c9abb4f2c4844b49849137c44be39d7', 27, 2, 1, '2019-06-20 13:21:04', '2019-06-20 12:33:04', '2019-06-20 12:33:04');
INSERT INTO `oauth2_access_token` VALUES ('cc49dd4989484a238886c6bc5b9f0085', '8946d7b924bc4c78a098f295152ef89d', NULL, NULL, 1, '2019-03-13 11:04:09', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('cc62c4983bb94fc48ecbc7c64335f867', '9102c41e7e1f4232b602c2f6cd09775f', 27, 2, 1, '2019-06-19 16:43:58', '2019-06-19 15:55:57', '2019-06-19 15:55:57');
INSERT INTO `oauth2_access_token` VALUES ('cc83d3ccd1dd4bdf834883e293ea9b98', 'ff65b9d7548d4f0e81f0a30e24e7808a', 27, 2, 1, '2019-05-22 23:36:10', '2019-05-22 22:48:09', '2019-05-22 22:48:09');
INSERT INTO `oauth2_access_token` VALUES ('cc8903ea923a4bae9e8d0f2e18d1555e', '4be25635af034b2187b24307e959b802', 66, 1, 1, '2019-06-03 15:42:37', '2019-06-03 14:54:37', '2019-06-03 14:54:37');
INSERT INTO `oauth2_access_token` VALUES ('cc9dddaf11fa42789321b3cae2b54ff7', '43a3010ce77d47e1844f6b5cc9bd6fec', NULL, NULL, 1, '2019-03-13 00:00:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('cca7e543ba2141819724eb71f424b78f', '0acd2f3d2a7745588055c2c6dbdd5d7d', 27, 2, 1, '2019-07-04 18:51:35', '2019-07-04 18:03:35', '2019-07-04 18:03:35');
INSERT INTO `oauth2_access_token` VALUES ('cca900d8de16415ea95d74403b817f15', '26454d64e03949f2a764e7313866a310', 27, 2, 1, '2019-09-07 16:20:08', '2019-09-07 15:32:08', '2019-09-07 15:32:08');
INSERT INTO `oauth2_access_token` VALUES ('ccade07f0f694e99a826e610e23cd091', 'b35ec70325ef4aed862be4de572d65bc', 27, 2, 1, '2019-06-30 21:08:59', '2019-06-30 20:20:59', '2019-06-30 20:20:59');
INSERT INTO `oauth2_access_token` VALUES ('ccc99daabdcc47eeaffda96db0657579', '0003d19d5df74b6c85004f303c74c027', 27, 2, 1, '2019-08-07 20:38:47', '2019-08-07 19:50:46', '2019-08-07 19:50:46');
INSERT INTO `oauth2_access_token` VALUES ('cccd7151d4904686ba0fc1c256649ed0', '9eeb52c8eddf4941b9159eb17122d603', 1, 2, 0, '2019-06-13 17:35:09', '2019-06-13 16:47:08', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('ccd523785f714f27b532261aa363a4c2', 'd6b814cdd56e49c699e9856175829faf', 27, 2, 1, '2019-06-04 10:03:01', '2019-06-04 09:15:01', '2019-06-04 09:15:01');
INSERT INTO `oauth2_access_token` VALUES ('cceb65aff95544d68348ce50c44ff28a', 'b9b47cec9bb6461c9fd66397efdd86de', 27, 2, 1, '2019-06-03 16:14:51', '2019-06-03 15:26:51', '2019-06-03 15:26:51');
INSERT INTO `oauth2_access_token` VALUES ('cd47fd7a373f475c8ec5152fada50548', 'aa57faff327f4f9eb281bc75c794f4c4', 1, 2, 0, '2019-07-22 17:02:00', '2019-07-22 16:14:00', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('cd55d28373de40979e7baa8e4699dd40', '8e9ad20fa2474c1fb6b9b7e9de6199ed', 27, 2, 1, '2019-07-22 15:22:36', '2019-07-22 14:34:36', '2019-07-22 14:34:36');
INSERT INTO `oauth2_access_token` VALUES ('cd61ec9403344002870719d3bb5b632d', '170f881ec1c64bbfbd8f593d57ebaa80', 27, 2, 1, '2019-06-01 17:33:33', '2019-06-01 16:45:32', '2019-06-01 16:45:32');
INSERT INTO `oauth2_access_token` VALUES ('cd9612d567de4414817fb356b8df34c5', 'e0bfd9238f68489fb67fcb156e3d4b53', 27, 2, 1, '2019-06-02 14:21:00', '2019-06-02 13:33:00', '2019-06-02 13:33:00');
INSERT INTO `oauth2_access_token` VALUES ('cd97d2faa8b54cabbc79347dbaf48e51', '31095d78f3a54accbd3bdf176ae326aa', 27, 2, 1, '2019-07-06 11:51:09', '2019-07-06 11:03:09', '2019-07-06 11:03:09');
INSERT INTO `oauth2_access_token` VALUES ('cdb598369f19480d83f6ec61627526b5', '2c7139bf43254d299a2a47dfcd45ed2a', 27, 2, 1, '2019-05-30 15:42:09', '2019-05-30 14:54:08', '2019-05-30 14:54:08');
INSERT INTO `oauth2_access_token` VALUES ('cdd1648909114dbbb239d9706ffceb5e', 'ccdd8a61ee0b47cd868be41286deee0c', 1, 2, 0, '2019-06-02 13:08:44', '2019-06-02 12:20:44', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('cdd624a287304ed687d5ffcae6274ec5', '9e86038cda9d4f2d9cdc93581ab5e2b5', 27, 2, 1, '2019-08-05 18:08:28', '2019-08-05 17:20:27', '2019-08-05 17:20:27');
INSERT INTO `oauth2_access_token` VALUES ('cddcd263ffaa40c290c8d55168fe4082', '642924ad73294f6794b1938010dcd8b4', 27, 2, 1, '2019-08-05 12:51:43', '2019-08-05 12:03:43', '2019-08-05 12:03:43');
INSERT INTO `oauth2_access_token` VALUES ('cddee78f97de487ba859dc254ca248cd', 'b2a1abc25f4849199e77df79f9943036', 27, 2, 1, '2019-08-22 12:21:32', '2019-08-22 11:33:31', '2019-08-22 11:33:31');
INSERT INTO `oauth2_access_token` VALUES ('cdf453651a394c45b733ba6afb90d8dc', '8564854870ce4dabb5bd9906d4db48b9', 27, 2, 1, '2019-06-01 10:41:45', '2019-06-01 09:53:44', '2019-06-01 09:53:44');
INSERT INTO `oauth2_access_token` VALUES ('ce02ddc9e6e2461da1d2cae0b1e9fa2c', '241c7f9752164896bb5c2f59b77d72e5', 27, 2, 1, '2019-06-02 11:11:35', '2019-06-02 10:23:35', '2019-06-02 10:23:35');
INSERT INTO `oauth2_access_token` VALUES ('ce263f6e1e65441bae2ec2f6ac542972', '7c620894ecf94558bfcc96bd74b52d48', 27, 2, 1, '2019-06-05 14:00:21', '2019-06-05 13:12:20', '2019-06-05 13:12:20');
INSERT INTO `oauth2_access_token` VALUES ('ce295d11db454b2cb1929f9e164deebc', '74991db6fc80436f8dcfdc4687d8ec2d', 27, 2, 1, '2019-06-17 18:35:57', '2019-06-17 17:47:56', '2019-06-17 17:47:56');
INSERT INTO `oauth2_access_token` VALUES ('ce62b8a66a664d06be04778bff0ff60b', '133a34610e80411a84da86a2dd4b018a', NULL, NULL, 1, '2019-05-09 18:42:57', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ce65caebd0884aeea6c734a9aa6f90b5', '3ea3dc6f58764474a01323c3abec00e0', 27, 2, 1, '2019-06-03 17:38:57', '2019-06-03 16:50:57', '2019-06-03 16:50:57');
INSERT INTO `oauth2_access_token` VALUES ('ce6c702a0c27421d836eb8225a59cae1', '6092b1859c1040dda666cc66a27ce2ce', NULL, NULL, 1, '2019-03-15 18:06:37', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ce704d7617ff4b389975c7f501d7bf09', '5b4bd0a9efe84a5c9ca5124c4f6b56e7', 27, 2, 1, '2019-06-03 15:40:02', '2019-06-03 14:52:01', '2019-06-03 14:52:01');
INSERT INTO `oauth2_access_token` VALUES ('ce8972eff1214ae7bf5a65cafae1b6bb', '41a3efa25f65457dbb52085d3e217b56', 27, 2, 1, '2019-06-24 16:21:38', '2019-06-24 15:33:38', '2019-06-24 15:33:38');
INSERT INTO `oauth2_access_token` VALUES ('ce8be829024048bbbcfbe537dba408d0', '14a29a4431504b1db1bd980bbebdcd39', NULL, NULL, 1, '2019-05-10 02:04:07', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ce92fa577ef84602b6d614a96a85f7ae', '53a7619e43b748499579bb7ce44f236c', 1, 1, 0, '2019-05-17 16:06:16', '2019-05-17 15:18:15', '2019-05-17 16:22:53');
INSERT INTO `oauth2_access_token` VALUES ('ce95e0feb6454900be6b150ab77f925a', '14537b2e536c4e1b924178970c21791b', 1, 2, 0, '2019-06-20 11:36:11', '2019-06-20 10:48:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('ce9841cb69e344928cc37f1a6f76f169', '9c2d14ff193e43a5adaefdccfb730435', 192, 1, 1, '2019-08-05 14:17:43', '2019-08-05 13:29:42', '2019-08-05 13:29:42');
INSERT INTO `oauth2_access_token` VALUES ('ce9ca57066294df3a10f1850029a31ef', '5184e22ae510473490f78ab815ce2535', 1, 2, 1, '2019-09-08 23:46:16', '2019-09-08 22:58:15', '2019-09-08 22:58:15');
INSERT INTO `oauth2_access_token` VALUES ('ceae2f3a13ec4be0867ec4a135fdc448', '5874eecfa4a144a49818d1a35a05ee3f', NULL, NULL, 1, '2019-05-09 22:23:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('cebbf157be9744ce9ced74ebfd7adf6b', 'fc7de55c90a14253aed61786c5754317', 27, 2, 1, '2019-07-24 13:01:45', '2019-07-24 12:13:44', '2019-07-24 12:13:44');
INSERT INTO `oauth2_access_token` VALUES ('cebd1bc2f22e4355b4c18f1ae82806ee', 'cf5143ad19e34bf9927b38f3d6757601', 27, 2, 1, '2019-07-21 17:01:33', '2019-07-21 16:13:32', '2019-07-21 16:13:32');
INSERT INTO `oauth2_access_token` VALUES ('cefc499cc8004531aa7f0a4ce5136f43', '5829265f12f34a629c718d6ebfc83f25', 27, 2, 1, '2019-07-31 17:30:44', '2019-07-31 16:42:43', '2019-07-31 16:42:43');
INSERT INTO `oauth2_access_token` VALUES ('cf088ac669af44c7918d79dac4e1db19', '64038a84d2a34484a957ab500435c2b7', 27, 2, 1, '2019-07-08 18:39:23', '2019-07-08 17:51:23', '2019-07-08 17:51:23');
INSERT INTO `oauth2_access_token` VALUES ('cf0f4a853d464d61ad49cc4f1a9acc74', '19aeb7d715424b7786a94f8b29b571ec', 27, 2, 1, '2019-06-13 16:52:09', '2019-06-13 16:04:09', '2019-06-13 16:04:09');
INSERT INTO `oauth2_access_token` VALUES ('cf44beae56dc48468f242f2ce49f3098', 'c4ddc0856fc647348f6f20e0f13cc883', 27, 2, 1, '2019-07-01 00:52:17', '2019-07-01 00:04:16', '2019-07-01 00:04:16');
INSERT INTO `oauth2_access_token` VALUES ('cf9695d2a9f34902ad96210e3391d6bc', 'ef29e3ec83f1458d968e55df726dba50', 27, 2, 1, '2019-08-25 16:33:05', '2019-08-25 15:45:04', '2019-08-25 15:45:04');
INSERT INTO `oauth2_access_token` VALUES ('cfafe37893a14719ad0990b6c1caf510', '86045ff722bb492aa6bb57e4f5c647b1', 27, 2, 1, '2019-07-04 10:02:30', '2019-07-04 09:14:29', '2019-07-04 09:14:29');
INSERT INTO `oauth2_access_token` VALUES ('cfb15275b7824ba08a46034918ca0d1e', '1a62fb80dc7e4cdaa7dd088cb75c9c63', 27, 2, 1, '2019-08-04 21:54:00', '2019-08-04 21:06:00', '2019-08-04 21:06:00');
INSERT INTO `oauth2_access_token` VALUES ('cfb4c96f86794c8ea19dbf830e4482b8', '6269dca04ec04a549cfcc13267169857', 27, 2, 1, '2019-07-20 11:10:40', '2019-07-20 10:22:40', '2019-07-20 10:22:40');
INSERT INTO `oauth2_access_token` VALUES ('cfc3312a04404afda8ce99dca8ee6ef3', '41ff15ae9fa64ccfbb2a72e239fd4ccc', NULL, NULL, 1, '2019-04-05 17:56:25', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('cfd19b3aeba34405a6e1e16468070a21', '98aa3d03f0664a99a6330024414cf071', 27, 2, 1, '2019-05-20 14:55:22', '2019-05-20 14:07:22', '2019-05-20 14:07:22');
INSERT INTO `oauth2_access_token` VALUES ('cfe0fe5588b948f0b698c267f007dcf8', 'bada7f2c258248b1b8278378dca64a6b', NULL, NULL, 0, '2019-03-05 02:14:21', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('cfe945d5d5354890879ece444d64c24f', '0795031bd40a44c6a988ba0551a95565', 1, 2, 0, '2019-06-03 09:35:57', '2019-06-03 08:47:57', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('d00c92ddd0c8416ca0c84502c58fcdcf', '83a1d6888f044af8a23cc8eda1a03c0a', NULL, NULL, 1, '2019-05-03 18:32:21', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d01aa029ae6f4dcd93c57f7a23461049', '8e31de012cc24034a72f61035a1d81e8', 27, 2, 1, '2019-06-04 17:50:17', '2019-06-04 17:02:17', '2019-06-04 17:02:17');
INSERT INTO `oauth2_access_token` VALUES ('d01cae6872ef4fa08bdaf8661b9ecf2e', '4114e275ee424f52a244693eda462f1f', 121, 1, 1, '2019-06-11 21:01:58', '2019-06-11 20:13:58', '2019-06-11 20:13:58');
INSERT INTO `oauth2_access_token` VALUES ('d0237c5b60d7498b9ac233a0e61db14b', '02b18c96de68490eb8ade0e35db2e9e2', 27, 2, 1, '2019-07-20 19:14:20', '2019-07-20 18:26:19', '2019-07-20 18:26:19');
INSERT INTO `oauth2_access_token` VALUES ('d02dd72ea533448289595c38bc2a295b', '34d571a6b6144250aa05ced2b525e82b', 27, 2, 1, '2019-07-05 20:06:47', '2019-07-05 19:18:47', '2019-07-05 19:18:47');
INSERT INTO `oauth2_access_token` VALUES ('d040867c5f224d0482682606b4603035', '107415038ac54b028ea577a3d9b6cb7e', 27, 2, 1, '2019-06-25 16:18:15', '2019-06-25 15:30:15', '2019-06-25 15:30:15');
INSERT INTO `oauth2_access_token` VALUES ('d0415486e3844cb4b683a6a026ee409f', '7f9c547bc5754d12b2a4ce53551eed2d', 27, 2, 1, '2019-06-05 11:38:07', '2019-06-05 10:50:06', '2019-06-05 10:50:06');
INSERT INTO `oauth2_access_token` VALUES ('d04fa73b1d8f4621a387606f0cfa175a', 'eca273c8966e4206893e31f06bfe524f', 1, 2, 0, '2019-07-24 10:23:06', '2019-07-24 09:35:06', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('d05a581110174d319e7bd895d5d113e1', '5f26e6bd035544019750c8e03f813495', 27, 2, 1, '2019-08-23 18:21:43', '2019-08-23 17:33:42', '2019-08-23 17:33:42');
INSERT INTO `oauth2_access_token` VALUES ('d075b06cc364466a85b1a1985773e0cb', '44398c94ee984e0b8cf5d2aa4be4cba1', 1, 2, 0, '2019-06-11 12:02:09', '2019-06-11 11:14:08', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('d084e5bf78f94f7d944037bc9b1be373', '48cee5a16d1f408a902dee3c91e69748', 27, 2, 1, '2019-08-26 10:50:07', '2019-08-26 10:02:07', '2019-08-26 10:02:07');
INSERT INTO `oauth2_access_token` VALUES ('d09e514f585a442f91bb982cc0a7a2dd', '10352f46953d48d7a7ab1d48476f40ef', 27, 2, 1, '2019-08-28 22:13:27', '2019-08-28 21:25:27', '2019-08-28 21:25:27');
INSERT INTO `oauth2_access_token` VALUES ('d0b3d85d7381420094aa440e1d9fe87b', 'c481e2cd12224372b770a7e545f04691', 1, 2, 1, '2019-09-08 14:28:18', '2019-09-08 13:40:17', '2019-09-08 13:40:17');
INSERT INTO `oauth2_access_token` VALUES ('d0cea08b51274af3b48c376d69fc0acd', '6464cc08f6044745925e26157b9e3a3f', 27, 2, 1, '2019-06-13 15:50:17', '2019-06-13 15:02:16', '2019-06-13 15:02:16');
INSERT INTO `oauth2_access_token` VALUES ('d0f62b6b43634340bac4a93672879fd6', '6870c7ceba694f129cad4c6232987197', 178, 1, 1, '2019-07-20 10:29:00', '2019-07-20 09:41:00', '2019-07-20 09:41:00');
INSERT INTO `oauth2_access_token` VALUES ('d11edda085644c92a7746309d3ab7fde', 'e7c225c3b427442889aae1d0abb6f697', 27, 2, 1, '2019-06-20 18:44:06', '2019-06-20 17:56:05', '2019-06-20 17:56:05');
INSERT INTO `oauth2_access_token` VALUES ('d13f2d623e6a4d19a4de8b4015fde7d8', 'ca130e4516264478b6d60243f9e846b4', 27, 2, 1, '2019-06-10 18:39:53', '2019-06-10 17:51:53', '2019-06-10 17:51:53');
INSERT INTO `oauth2_access_token` VALUES ('d141601ac3ce41be8020c5310f10b1ea', 'af24ca5b84c94c3ebd17c33da0acb408', NULL, NULL, 1, '2019-05-08 21:08:27', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d16ac35f8c1a4f0f9808fa8f0eb4b022', '18752207bd7545c1881ed658698772b8', 27, 2, 1, '2019-09-01 19:13:53', '2019-09-01 18:25:52', '2019-09-01 18:25:52');
INSERT INTO `oauth2_access_token` VALUES ('d1930697d65d47a3aa4dba48da25b9f9', '584adff812d242dfae534e0bdb818ee0', 190, 1, 1, '2019-08-02 17:07:46', '2019-08-02 16:19:45', '2019-08-02 16:19:45');
INSERT INTO `oauth2_access_token` VALUES ('d19a795df32940e285db729756603d6c', '74bfbf7ab23940158176b1dc5cef6f3b', 114, 1, 1, '2019-06-08 23:13:01', '2019-06-08 22:25:01', '2019-06-08 22:25:01');
INSERT INTO `oauth2_access_token` VALUES ('d19a95b59eb34054bec19d53777c4e02', '7e4efdee7e0147c38886f13dbfab114e', 27, 2, 1, '2019-06-21 00:00:59', '2019-06-20 23:12:58', '2019-06-20 23:12:58');
INSERT INTO `oauth2_access_token` VALUES ('d19bc55e70784285b0087956fb52e93e', '92d9f1f5687d4a80992e7e5f9211e9c1', 27, 2, 1, '2019-08-30 18:51:39', '2019-08-30 18:03:39', '2019-08-30 18:03:39');
INSERT INTO `oauth2_access_token` VALUES ('d1a01713876049eb99f1bfeaee946824', 'f926a57d3bba4a39b5340471fc737931', 27, 2, 1, '2019-07-07 21:50:54', '2019-07-07 21:02:54', '2019-07-07 21:02:54');
INSERT INTO `oauth2_access_token` VALUES ('d1aa5ca43cb446e39f271cfeb052d6ee', '90e852728f0f4d6eb25a58db3cfb9c81', 27, 2, 1, '2019-07-23 15:32:15', '2019-07-23 14:44:14', '2019-07-23 14:44:14');
INSERT INTO `oauth2_access_token` VALUES ('d1c1f61822964d3fab5def6bce3106f0', '9064a6641a9e466996cb3401e6a91ef5', 27, 2, 1, '2019-05-23 14:21:07', '2019-05-23 13:33:06', '2019-05-23 13:33:06');
INSERT INTO `oauth2_access_token` VALUES ('d1c8b705989349bf9c4a8f2bb01202bf', 'ea421d3b1ee34dcba3d1df17c8b4ec5a', 27, 2, 1, '2019-09-02 15:41:26', '2019-09-02 14:53:26', '2019-09-02 14:53:26');
INSERT INTO `oauth2_access_token` VALUES ('d1d8a4429ab242fc99ea5e3d937582b5', 'de71ff388eb74744bbb2bdca2636286e', 27, 2, 1, '2019-06-01 10:07:14', '2019-06-01 09:19:14', '2019-06-01 09:19:14');
INSERT INTO `oauth2_access_token` VALUES ('d1d98a729969464c8e5b5459abb948fb', 'f339511ff0184f08a887451ff596a029', 216, 1, 1, '2019-08-30 12:28:42', '2019-08-30 11:40:42', '2019-08-30 11:40:42');
INSERT INTO `oauth2_access_token` VALUES ('d1fd795f9898431cb56826337609592f', '1a82039577c34d60a67605477ba79196', 27, 2, 1, '2019-08-19 18:45:36', '2019-08-19 17:57:35', '2019-08-19 17:57:35');
INSERT INTO `oauth2_access_token` VALUES ('d2042e9c695f44fca496c8513937b750', '260e74b351984fd7aae71632347b47f5', 27, 2, 1, '2019-08-19 09:54:01', '2019-08-19 09:06:00', '2019-08-19 09:06:00');
INSERT INTO `oauth2_access_token` VALUES ('d21534400bf04056b5febd548d939b27', '20099b1bb0d44bf8a754126a4400da66', 27, 2, 1, '2019-06-12 12:44:59', '2019-06-12 11:56:58', '2019-06-12 11:56:58');
INSERT INTO `oauth2_access_token` VALUES ('d23cb067369e4276845a178174be6923', '93b23552f299453d879eb04517ae53fe', 27, 2, 1, '2019-08-02 05:39:56', '2019-08-02 04:51:56', '2019-08-02 04:51:56');
INSERT INTO `oauth2_access_token` VALUES ('d24cbf80c5664557a04db4fa83922ff7', '200bc0ef0dec43ee8b2af359d1a52f3d', 27, 2, 1, '2019-08-15 15:50:40', '2019-08-15 15:02:40', '2019-08-15 15:02:40');
INSERT INTO `oauth2_access_token` VALUES ('d26582cceadc4ee1884c13d865a7ed1a', 'ee395426944143de9abb904506a510a3', NULL, NULL, 1, '2019-05-08 10:47:23', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d26cc9ea2ec44d259ad36700bc934010', 'b0777ddec4a8471899bcd27f6466e6f9', 1, 2, 0, '2019-06-05 10:33:49', '2019-06-05 09:45:49', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('d26dab041370492bb15e53afb706fb47', '53a7619e43b748499579bb7ce44f236c', 1, 1, 0, '2019-05-17 11:40:26', '2019-05-17 10:52:26', '2019-05-17 11:58:08');
INSERT INTO `oauth2_access_token` VALUES ('d28b0b9cc6e24ba19b253f28fc5c6903', 'fb56082f29024e01b996efd72d582688', 27, 2, 1, '2019-06-04 22:20:56', '2019-06-04 21:32:56', '2019-06-04 21:32:56');
INSERT INTO `oauth2_access_token` VALUES ('d290a39318a84bdb94e6e8827f98043a', '9e4cd6193b814b3a86ba5d2e30b79c53', NULL, NULL, 0, '2019-02-28 10:47:33', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d29aa4eb0db2419d8a0214b3a8e5bb41', 'a6eb8fc9fef4440e805459ea48730d45', 1, 2, 1, '2019-09-09 00:03:13', '2019-09-08 23:15:13', '2019-09-08 23:15:13');
INSERT INTO `oauth2_access_token` VALUES ('d2a84c662c13484fbe3cb592e8935063', '1710a2de28984e93b74acfb17853c9ce', NULL, NULL, 1, '2019-05-10 00:49:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d2c7b7df16af4badbca9684456d25410', 'b76cbedcad574d0793ca0623afdc08cd', 27, 2, 1, '2019-09-02 11:53:50', '2019-09-02 11:05:49', '2019-09-02 11:05:49');
INSERT INTO `oauth2_access_token` VALUES ('d2cf14f37a2c4f39a1c84d92147ac0b1', '955d9775416c479985869c42ee6edd13', 27, 2, 1, '2019-07-03 17:10:04', '2019-07-03 16:22:03', '2019-07-03 16:22:03');
INSERT INTO `oauth2_access_token` VALUES ('d2d7eb7e25c24ce1a7227ce849d0d0d1', '14322e7630084c84a4856221a656eaf4', 27, 2, 1, '2019-07-25 11:50:42', '2019-07-25 11:02:42', '2019-07-25 11:02:42');
INSERT INTO `oauth2_access_token` VALUES ('d2f4d8d406604a73ad1f9dfd4aa281c7', '9cb896d84591427fac7e5262b4191238', 27, 2, 1, '2019-06-03 16:14:45', '2019-06-03 15:26:45', '2019-06-03 15:26:45');
INSERT INTO `oauth2_access_token` VALUES ('d307bedb7ffe41fb89d9cd82e147205b', '1068d84f4dfc41cd937eb363bb60656c', 1, 2, 0, '2019-05-31 23:29:30', '2019-05-31 22:41:30', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('d30b2274081a4f8cb08cfa552307d67d', '4dd6551e78d54dd08a2edb93298c5824', 1, 2, 0, '2019-06-10 10:03:51', '2019-06-10 09:15:49', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('d3116b7855b04dd088982e22b7298708', '7500246e499e4758a2856e70340f4280', 27, 2, 1, '2019-07-06 10:28:49', '2019-07-06 09:40:48', '2019-07-06 09:40:48');
INSERT INTO `oauth2_access_token` VALUES ('d31ae5f5614c4d52a55415ee3b4d1af7', 'c69cb465644c4df68b0e1c6e953991b7', 27, 2, 1, '2019-07-12 12:11:02', '2019-07-12 11:23:01', '2019-07-12 11:23:01');
INSERT INTO `oauth2_access_token` VALUES ('d374a1ba835d47a9aabfbb136f5d73c0', 'd0de7b632a8b4e2b9778554abf63c9bb', 153, 1, 1, '2019-07-02 16:58:07', '2019-07-02 16:10:06', '2019-07-02 16:10:06');
INSERT INTO `oauth2_access_token` VALUES ('d375b93365024bb98d24e0f3e38ce8c0', '2632379da1ab423d94041e96827b8e11', 1, 2, 0, '2019-06-05 10:28:05', '2019-06-05 09:40:04', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('d3c2b2f62d6740a3a61d29fc390eb428', '4166fd3c66dc4c99b307ac8fd7ad9399', 27, 2, 1, '2019-08-31 23:13:36', '2019-08-31 22:25:36', '2019-08-31 22:25:36');
INSERT INTO `oauth2_access_token` VALUES ('d3c87d880c6f49869a81cdbe6abcd554', '3a55762a46f1473eaba3969edb59af57', 27, 2, 1, '2019-08-20 18:56:05', '2019-08-20 18:08:05', '2019-08-20 18:08:05');
INSERT INTO `oauth2_access_token` VALUES ('d40fedeb053d46ca97339780a2235b0c', 'cee88823dad0485980275557b09f99b4', NULL, NULL, 1, '2019-05-07 14:16:30', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d43474093a484875826093d1b3cc22c3', 'a33e9cfbd0994d9597d9c664e7bcaef5', 27, 2, 1, '2019-06-05 10:02:38', '2019-06-05 09:14:37', '2019-06-05 09:14:37');
INSERT INTO `oauth2_access_token` VALUES ('d43d9a3bd084495ba0801a346102c3b8', '204722b528ef4d878169a5bc9cff7aa0', 27, 2, 1, '2019-06-03 09:17:12', '2019-06-03 08:29:12', '2019-06-03 08:29:12');
INSERT INTO `oauth2_access_token` VALUES ('d4430104dce742c4aed966d5877592da', '97e49df20ea948eba80dfcef5b8e6be9', NULL, NULL, 1, '2019-05-05 23:37:07', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d44674bcf43a4355a76f3ecfa84a77b7', '8d2a0f245b51417f8e1167c3deec5741', 27, 2, 1, '2019-06-14 15:12:50', '2019-06-14 14:24:50', '2019-06-14 14:24:50');
INSERT INTO `oauth2_access_token` VALUES ('d46cc46959084c5c8f890c2dac039146', '3dd4b182d5be4e90864bc8e23832052a', 27, 2, 1, '2019-07-11 08:15:37', '2019-07-11 07:27:37', '2019-07-11 07:27:37');
INSERT INTO `oauth2_access_token` VALUES ('d471016d47bf424ab07672c8c99add0a', 'daea13d977a64201820da137afc4335a', 27, 2, 1, '2019-06-27 21:20:55', '2019-06-27 20:32:55', '2019-06-27 20:32:55');
INSERT INTO `oauth2_access_token` VALUES ('d4a37db89b7145108e6ceea181c93ac8', 'cc3c4c5bd5c7419f811504d652bd3ed7', 27, 2, 1, '2019-06-02 22:37:07', '2019-06-02 21:49:07', '2019-06-02 21:49:07');
INSERT INTO `oauth2_access_token` VALUES ('d4a7bf0725a84d49b58b3b2c298fb4b7', '098acdb47c194b18b2d9e3c8ce69601c', 27, 2, 1, '2019-06-13 12:42:15', '2019-06-13 11:54:15', '2019-06-13 11:54:15');
INSERT INTO `oauth2_access_token` VALUES ('d4c7ced00cda48158491158534c7fb26', '68690b1e20a642678501320023c8c108', 27, 2, 1, '2019-07-03 23:40:41', '2019-07-03 22:52:41', '2019-07-03 22:52:41');
INSERT INTO `oauth2_access_token` VALUES ('d4caf5db51fa4a849ef1bcc24c99626a', 'e7ac8a480b7740809e36636c2f739668', 27, 2, 1, '2019-05-28 16:56:28', '2019-05-28 16:08:27', '2019-05-28 16:08:27');
INSERT INTO `oauth2_access_token` VALUES ('d4d01de44e8a4eddba989c11b23d3405', '2291c3aaa034430bb97997feb73fd687', 27, 2, 1, '2019-09-06 11:42:37', '2019-09-06 10:54:36', '2019-09-06 10:54:36');
INSERT INTO `oauth2_access_token` VALUES ('d4d707a9b7d34a27ac3556d3dea6175d', '10734947db9e4a159b6c7cc243962790', NULL, NULL, 1, '2019-05-06 11:41:04', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d4d80cf906f1465fb89da67e3b3e351a', '6f6b29e4b1be4f76bc4481c613e8bea0', 27, 2, 1, '2019-07-08 17:15:23', '2019-07-08 16:27:22', '2019-07-08 16:27:22');
INSERT INTO `oauth2_access_token` VALUES ('d4e038a2687742669b1c7ee12082499b', 'c4b1f42e46c44c6d92f09d151f9ebae7', 27, 2, 1, '2019-07-15 19:38:50', '2019-07-15 18:50:49', '2019-07-15 18:50:49');
INSERT INTO `oauth2_access_token` VALUES ('d4e1658da5c74600810660192601175e', 'a514fe7dcc7a4c66a26d1263c16573fb', 27, 2, 1, '2019-07-22 17:01:37', '2019-07-22 16:13:37', '2019-07-22 16:13:37');
INSERT INTO `oauth2_access_token` VALUES ('d4e3c263c33d4130a08ef621429999c9', '5316e24947d941fcbe94e917cebb48ac', 27, 2, 1, '2019-07-07 00:33:57', '2019-07-06 23:45:56', '2019-07-06 23:45:56');
INSERT INTO `oauth2_access_token` VALUES ('d4e4b4239fda4f51bfff2a331d6bfdf1', '4156b9988d2c4b00aebe9db094928ada', NULL, NULL, 1, '2019-05-10 01:19:10', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d4ecdcdf771540368fad70491c3880b5', '2053fc9db6074f5992b5075880ca5b7e', 100, 1, 1, '2019-06-02 18:58:33', '2019-06-02 18:10:33', '2019-06-02 18:10:33');
INSERT INTO `oauth2_access_token` VALUES ('d50945c421fb441b907fc86d34d08853', 'b99b00177a59455fa4c8f33060bfb600', 27, 2, 1, '2019-06-11 15:29:54', '2019-06-11 14:41:53', '2019-06-11 14:41:53');
INSERT INTO `oauth2_access_token` VALUES ('d52bb736c1394292a95b62760a6e6b7b', '27781ce8f58b424aaa64cd138ad4d403', 27, 2, 1, '2019-05-22 12:47:26', '2019-05-22 11:59:25', '2019-05-22 11:59:25');
INSERT INTO `oauth2_access_token` VALUES ('d54a80e2fab44b25a86b30ddb3da54e8', '47543efadf2645a38dddf2885d0570b7', 27, 2, 1, '2019-07-25 11:52:30', '2019-07-25 11:04:29', '2019-07-25 11:04:29');
INSERT INTO `oauth2_access_token` VALUES ('d54cf76edd004ea98c3331949f76c5fd', 'a755b62ac46943f4aff9b260116734b5', 119, 1, 1, '2019-06-11 18:16:11', '2019-06-11 17:28:10', '2019-06-11 17:28:10');
INSERT INTO `oauth2_access_token` VALUES ('d54d156767fe4deabfcf5ee469b3d031', 'b2af4e6de41c49fa955ca2b96c3d4ecf', 1, 2, 0, '2019-09-07 00:04:41', '2019-09-06 23:16:40', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('d563ab597b804219aaf1e2e0d4bbf1fa', 'c16fe6b3f5ef435cb06af5cbadcbb463', 27, 2, 1, '2019-07-07 23:24:24', '2019-07-07 22:36:23', '2019-07-07 22:36:23');
INSERT INTO `oauth2_access_token` VALUES ('d57abe549c9647c991e9f9126f3daa21', '0751d99fbf064227a88cf92d953bda59', 27, 2, 1, '2019-05-31 21:52:11', '2019-05-31 21:04:11', '2019-05-31 21:04:11');
INSERT INTO `oauth2_access_token` VALUES ('d5836c89dd9341e99d139bed8872602d', '97d1e11b29c7458498a823be63f05482', 1, 1, 1, '2019-05-17 18:35:30', '2019-05-17 17:47:30', '2019-05-17 17:47:30');
INSERT INTO `oauth2_access_token` VALUES ('d58ff37de2bd49618c0cd72b33c9cbe5', '3a46c584c5cd4a5da854d243c2e27513', 27, 2, 1, '2019-06-27 18:18:22', '2019-06-27 17:30:21', '2019-06-27 17:30:21');
INSERT INTO `oauth2_access_token` VALUES ('d5ada5b2c2c44075a2fd94764c22319e', '5d7ba98f910e430b814f61805ea4f2c2', 217, 1, 1, '2019-08-30 15:57:01', '2019-08-30 15:09:00', '2019-08-30 15:09:00');
INSERT INTO `oauth2_access_token` VALUES ('d5c302c23c6848df82f55fe722defa0f', '953808a1f21f4850be36d994b0531e0d', 27, 2, 1, '2019-09-09 09:17:47', '2019-09-09 08:29:46', '2019-09-09 08:29:46');
INSERT INTO `oauth2_access_token` VALUES ('d5e31d681bb14505a0d54e4d9bf44851', 'ac35fd137d4a4720af647705df0196f1', NULL, NULL, 1, '2019-05-03 07:19:36', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d6200901709c4606a7df1bd93107179d', 'cc860a7acc73490fa8b78ef0d86667bc', 27, 2, 1, '2019-06-02 21:28:42', '2019-06-02 20:40:41', '2019-06-02 20:40:41');
INSERT INTO `oauth2_access_token` VALUES ('d629f1fffd4c408a8191262ffcbae88c', 'bfba465335f5484795432a38b3769a13', 27, 2, 1, '2019-06-29 20:03:09', '2019-06-29 19:15:08', '2019-06-29 19:15:08');
INSERT INTO `oauth2_access_token` VALUES ('d636b0d2bea94d4a85729f2f200d5f1e', '5571258378854e148558718b04892b82', 27, 2, 1, '2019-05-28 15:31:26', '2019-05-28 14:43:25', '2019-05-28 14:43:25');
INSERT INTO `oauth2_access_token` VALUES ('d636bde1fcd0412f940b1560d978007d', '47823b84ab9d4b908dfe4105ea32680f', NULL, NULL, 1, '2019-05-06 11:48:47', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d648688d15a0468192146c0c7977f0ac', '060e5d45d22640088548ae60c87916c1', 27, 2, 1, '2019-07-17 11:06:24', '2019-07-17 10:18:24', '2019-07-17 10:18:24');
INSERT INTO `oauth2_access_token` VALUES ('d673912ae80e4b7b8abaca9cce2e4922', '7dcf607107ec48abba529cf9f52551c6', NULL, NULL, 0, '2019-02-26 10:40:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d6748eb4872041d09618fe1163e83306', '81a7e50a93c341c0a71814aef5c9a240', 27, 2, 1, '2019-08-13 10:01:54', '2019-08-13 09:13:54', '2019-08-13 09:13:54');
INSERT INTO `oauth2_access_token` VALUES ('d678ebf3bf4d4878944bc87653be2e2d', '4a8e5fd0f43f4b35ab1efb5b1b1a4081', 205, 1, 1, '2019-08-17 15:50:01', '2019-08-17 15:02:00', '2019-08-17 15:02:00');
INSERT INTO `oauth2_access_token` VALUES ('d679be086aeb4ee4beabfaa51db10a46', '97d0ed44db73410c9324e6e05901f16a', 27, 2, 1, '2019-07-05 16:12:10', '2019-07-05 15:24:09', '2019-07-05 15:24:09');
INSERT INTO `oauth2_access_token` VALUES ('d6910bf1aae64a2095e22947e5b79ab3', '1773cddf3f9346e6beb4c4dd6f6249fe', NULL, NULL, 1, '2019-05-05 17:10:03', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d6ae7e72ce744b169087f0bb342cae08', 'c09205fcdec6490f9c049039ecc6b94b', 27, 2, 1, '2019-06-16 21:12:19', '2019-06-16 20:24:18', '2019-06-16 20:24:18');
INSERT INTO `oauth2_access_token` VALUES ('d6e2a45d26b24259be842081a0568d31', '09d9cda796a04453be8fba90f0489f9e', 1, 2, 0, '2019-05-31 10:40:54', '2019-05-31 09:51:34', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('d72201966dec4aa88fe08e70613681e0', '72d33465ea8348439d6c9318c4bbde9f', 27, 2, 1, '2019-07-20 10:22:51', '2019-07-20 09:34:50', '2019-07-20 09:34:50');
INSERT INTO `oauth2_access_token` VALUES ('d73b18435b934f5094605349f99751ba', 'bb263fed57384ad88a37c39bd4c9eda2', NULL, NULL, 1, '2019-04-30 21:39:06', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d7523151f99c462f84a2270132237bad', '97ac51bd647d41f0b12daa40b728a5e8', 27, 2, 1, '2019-06-23 15:16:17', '2019-06-23 14:28:16', '2019-06-23 14:28:16');
INSERT INTO `oauth2_access_token` VALUES ('d76e97a002a845318749899f88602eaf', '0eab168b650743ff82667e67bfa3c400', 27, 2, 1, '2019-08-29 13:12:43', '2019-08-29 12:24:42', '2019-08-29 12:24:42');
INSERT INTO `oauth2_access_token` VALUES ('d776f08532494aeda966d87da1f61be6', 'ec1faf263fa74f9d93663c1969ae4d66', 27, 2, 1, '2019-07-12 13:48:14', '2019-07-12 13:00:13', '2019-07-12 13:00:13');
INSERT INTO `oauth2_access_token` VALUES ('d781ebca50064283a2e7f4362747ae7c', '699b3ca9110541dfab4b55c163136dec', 27, 2, 1, '2019-06-03 11:46:34', '2019-06-03 10:58:33', '2019-06-03 10:58:33');
INSERT INTO `oauth2_access_token` VALUES ('d7ab3c363ef240efb45a310f7438d8ad', '351899c1fd0448628f381831d378dbe6', 27, 2, 1, '2019-06-12 14:53:17', '2019-06-12 14:05:17', '2019-06-12 14:05:17');
INSERT INTO `oauth2_access_token` VALUES ('d7b07a90424c4377bc8373fe50e7bb00', '571d8c18478e441c88c3e6f16166b3dc', 27, 2, 1, '2019-09-09 10:24:00', '2019-09-09 09:35:59', '2019-09-09 09:35:59');
INSERT INTO `oauth2_access_token` VALUES ('d7bb3f03ac964684b98868ad4ee19a0b', 'e64fccc6aa5147f28d8ec4d2629c3da3', 27, 2, 1, '2019-06-04 16:13:19', '2019-06-04 15:25:19', '2019-06-04 15:25:19');
INSERT INTO `oauth2_access_token` VALUES ('d7bf4e7b57c74e738e2c71e0e3c66259', 'b2fed102e1e04bd2a2d90c2a4f3b1e49', 27, 2, 1, '2019-07-18 15:44:05', '2019-07-18 14:56:04', '2019-07-18 14:56:04');
INSERT INTO `oauth2_access_token` VALUES ('d7db659573ad4bb29c25596cbeb8d749', '4b3b971802b743238b0cad06f50cb9e0', 27, 2, 1, '2019-06-13 14:56:11', '2019-06-13 14:08:11', '2019-06-13 14:08:11');
INSERT INTO `oauth2_access_token` VALUES ('d7ef8cf6eb6d43acaf21916bb47dba36', '1d1c0c552fbd4e66b36182bc314b7a6c', NULL, NULL, 1, '2019-03-10 10:57:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d7f16d1c8df3484d83c032769712c27a', '18814af794f14b0e8d6216c8b82eed51', NULL, NULL, 1, '2019-05-03 17:35:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d7f8f67c589b4068ada85ebc039162dc', 'ff62d031c7eb4a1285798b7f31fca827', 27, 2, 1, '2019-06-30 23:54:37', '2019-06-30 23:06:37', '2019-06-30 23:06:37');
INSERT INTO `oauth2_access_token` VALUES ('d81b2bdcf4294468969e9754e7f12bca', '30713016944e48a291413b083a420228', 27, 2, 1, '2019-07-27 16:07:32', '2019-07-27 15:19:32', '2019-07-27 15:19:32');
INSERT INTO `oauth2_access_token` VALUES ('d81cb6f0de474b0f9d764bf6ac2b39aa', '973fc25e4c70488787b182676d7cfe0b', 27, 2, 1, '2019-07-08 09:23:15', '2019-07-08 08:35:15', '2019-07-08 08:35:15');
INSERT INTO `oauth2_access_token` VALUES ('d82809eaab224823a2cdd3ea458e79bb', 'b707f992ddd34c109b2201439e7dc664', 27, 2, 1, '2019-06-02 16:34:22', '2019-06-02 15:46:21', '2019-06-02 15:46:21');
INSERT INTO `oauth2_access_token` VALUES ('d828807b60124f28bf4ec8f9e6279dd5', 'e350712bb59947729d210a964396b06c', 27, 2, 1, '2019-06-12 16:50:21', '2019-06-12 16:02:21', '2019-06-12 16:02:21');
INSERT INTO `oauth2_access_token` VALUES ('d82afe7659c8486da79b535003316986', '1bc753506ef5458da6e261253188ccb8', 27, 2, 1, '2019-06-06 12:32:20', '2019-06-06 11:44:20', '2019-06-06 11:44:20');
INSERT INTO `oauth2_access_token` VALUES ('d8335e8ec99a4d3d877416d7f1d1add2', '5017f5f33e244fb8adc3970321dde610', 27, 2, 1, '2019-09-04 16:57:07', '2019-09-04 16:09:07', '2019-09-04 16:09:07');
INSERT INTO `oauth2_access_token` VALUES ('d84d19bc45c24721a098536316e7730b', '0a8794db6d7c44edb3380fb842d92c34', 27, 2, 1, '2019-06-03 23:46:43', '2019-06-03 22:58:42', '2019-06-03 22:58:42');
INSERT INTO `oauth2_access_token` VALUES ('d8543765923241e7b3a7644c44adce6f', '9c3d1888ac9a4c91b9548561cf5b2fad', 27, 2, 1, '2019-06-28 10:23:30', '2019-06-28 09:35:29', '2019-06-28 09:35:29');
INSERT INTO `oauth2_access_token` VALUES ('d87a71de952d439abd4967003c001581', '065fcb4112a848d9963f068155c55e50', 27, 2, 1, '2019-06-02 19:57:48', '2019-06-02 19:09:48', '2019-06-02 19:09:48');
INSERT INTO `oauth2_access_token` VALUES ('d8974d8ef83146f3ad0e2097cf39aedb', '2b2a9ced98324c16aac56abdcffbba56', 27, 2, 1, '2019-05-27 10:54:42', '2019-05-27 10:06:42', '2019-05-27 10:06:42');
INSERT INTO `oauth2_access_token` VALUES ('d8a6bac4158b43d087344baa1393131d', '93fd5a8ee4b44c5eb6fe7172242b2d11', 27, 2, 1, '2019-06-25 01:19:02', '2019-06-25 00:31:02', '2019-06-25 00:31:02');
INSERT INTO `oauth2_access_token` VALUES ('d8b7f08064284209a0bb5a84fdb230af', '6aaa52b83bc5423f92c3cbc9a39675b9', 27, 2, 1, '2019-06-04 16:31:40', '2019-06-04 15:43:40', '2019-06-04 15:43:40');
INSERT INTO `oauth2_access_token` VALUES ('d8bf1aaa21bf446fb7852e9e54a12e54', '284f9e17e48f41c8b5f371aa639065a3', 27, 2, 1, '2019-07-23 16:31:00', '2019-07-23 15:43:00', '2019-07-23 15:43:00');
INSERT INTO `oauth2_access_token` VALUES ('d8e739488c3f45bd8e363aa78d07d410', '46505fa479b14b60a032e1f3b3d13502', 27, 2, 1, '2019-06-21 01:45:49', '2019-06-21 00:57:48', '2019-06-21 00:57:48');
INSERT INTO `oauth2_access_token` VALUES ('d8f55698565d4723b8b90e74aec76dd9', '4eeb7e008777464d9ee1da8680281a1c', 27, 2, 1, '2019-07-24 13:14:17', '2019-07-24 12:26:17', '2019-07-24 12:26:17');
INSERT INTO `oauth2_access_token` VALUES ('d93148c23ac34be3afe4a1da1838437c', 'c34c18c2468a4c30815e42fb6f2f7947', 27, 2, 1, '2019-06-06 09:46:33', '2019-06-06 08:58:32', '2019-06-06 08:58:32');
INSERT INTO `oauth2_access_token` VALUES ('d93304efdda74c66b9db4aa135e8c94c', '5bfa30ad428149138c632ca44ef4ffe5', 27, 2, 1, '2019-06-06 19:38:21', '2019-06-06 18:50:20', '2019-06-06 18:50:20');
INSERT INTO `oauth2_access_token` VALUES ('d938050803c2482d80e7bb5f675fd9d2', '5e10535fbad0451597b7c03ea974a67a', 27, 2, 1, '2019-06-03 20:18:11', '2019-06-03 19:30:10', '2019-06-03 19:30:10');
INSERT INTO `oauth2_access_token` VALUES ('d94190ed28c24ab0b4bd24e400cbdd7d', '39829ac4be634513834c24d933453f31', 27, 2, 1, '2019-08-08 11:28:36', '2019-08-08 10:40:35', '2019-08-08 10:40:35');
INSERT INTO `oauth2_access_token` VALUES ('d9629b0738644c9c8219ffb885e619d3', 'c5d4d7d50665460e9b01b5b40d402d9d', 27, 2, 1, '2019-07-12 10:33:12', '2019-07-12 09:45:11', '2019-07-12 09:45:11');
INSERT INTO `oauth2_access_token` VALUES ('d96d9ba54d4d4af89352c3a7ff743586', 'ced6a30658a2430baa53835cc8f49ddf', 1, 2, 0, '2019-08-21 18:50:04', '2019-08-21 18:02:04', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('d979404a0abb4c03985ecf68811c760c', '19242283be7841f19f35056f33497f22', 27, 2, 1, '2019-08-04 12:48:25', '2019-08-04 12:00:24', '2019-08-04 12:00:24');
INSERT INTO `oauth2_access_token` VALUES ('d98a6a886db640e9805ccdfffd2e6000', 'cb0d9bfefa7342bba9c975cee018135f', 27, 2, 1, '2019-08-01 18:16:27', '2019-08-01 17:28:26', '2019-08-01 17:28:26');
INSERT INTO `oauth2_access_token` VALUES ('d9928585fd5c418783cdc7307b4dcfb4', 'ec36e1b0c12d41eba0171f7e565cabbf', 1, 2, 0, '2019-09-04 11:04:39', '2019-09-04 10:16:38', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('d9987e343ada4400850811260c0d9759', '31b15565712d49a188ad9f7cd8e38494', 27, 2, 1, '2019-05-31 14:59:14', '2019-05-31 14:11:13', '2019-05-31 14:11:13');
INSERT INTO `oauth2_access_token` VALUES ('d99913e844a146e2860b22360c6928f0', '9eb91b10a8c241fd9f791c767b2c8d55', 27, 2, 1, '2019-06-07 10:37:27', '2019-06-07 09:49:26', '2019-06-07 09:49:26');
INSERT INTO `oauth2_access_token` VALUES ('d9a6c0731eb44fb68ec498c76df721f0', 'bf811ab87f7a425f80882f30bcc71317', 27, 2, 1, '2019-07-29 10:09:11', '2019-07-29 09:21:11', '2019-07-29 09:21:11');
INSERT INTO `oauth2_access_token` VALUES ('d9aab3ed631f4ea7b3047b9c3886d7c1', '14a673d279c44ccda9869b5dd11f0457', 83, 1, 1, '2019-05-24 18:35:00', '2019-05-24 17:47:00', '2019-05-24 17:47:00');
INSERT INTO `oauth2_access_token` VALUES ('d9abba2ab8f947da926b1e1eb9673895', '890f088aaaa1425784d01840864db891', NULL, NULL, 1, '2019-05-05 20:00:42', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('d9af94bc2a3748f4b231208e36e4fe48', '5e07bf5fa59149bbaf46cd608ae6242f', 27, 2, 1, '2019-08-05 16:37:40', '2019-08-05 15:49:39', '2019-08-05 15:49:39');
INSERT INTO `oauth2_access_token` VALUES ('d9c5e338aa5f4a94be81b2b2198d7396', 'eb861c0c107648f4b8831a56da470581', 27, 2, 1, '2019-06-26 14:40:14', '2019-06-26 13:52:14', '2019-06-26 13:52:14');
INSERT INTO `oauth2_access_token` VALUES ('d9c5e94ae22243c497277a1ddba2a4a3', '69b493f3721944128aa92c35647829a0', 80, 1, 1, '2019-05-23 18:43:58', '2019-05-23 17:55:57', '2019-05-23 17:55:57');
INSERT INTO `oauth2_access_token` VALUES ('d9d27b220683478498444bea9bd7e469', '18553727102d48c9b662944219749043', 27, 2, 1, '2019-07-28 18:16:26', '2019-07-28 17:28:25', '2019-07-28 17:28:25');
INSERT INTO `oauth2_access_token` VALUES ('d9e569dc569d4c73b86ba97d63cb307f', '9460dc886c964b6a874312c3d60dc752', 27, 2, 1, '2019-08-03 23:35:29', '2019-08-03 22:47:28', '2019-08-03 22:47:28');
INSERT INTO `oauth2_access_token` VALUES ('d9edaa7b3b074474b6d538896cdcfe83', '244ba92779df4660b5b3ba5d2adb48f7', 1, 2, 0, '2019-06-11 16:17:01', '2019-06-11 15:29:00', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('da1491f2e51143beaa7e4a34f1cf3bfc', 'ac31405edfb7493989f7fae57b459722', 27, 2, 1, '2019-06-14 19:48:39', '2019-06-14 19:00:38', '2019-06-14 19:00:38');
INSERT INTO `oauth2_access_token` VALUES ('da26fa23c0e1457486441e1884f941fe', '0efc26af567e42528d0a220e7d3f56f5', 27, 2, 1, '2019-07-24 15:18:35', '2019-07-24 14:30:35', '2019-07-24 14:30:35');
INSERT INTO `oauth2_access_token` VALUES ('da5f88ad219e496f8b3628bdfd52ea16', 'e7a36d1b722b4768986906b9d2c370bf', 27, 2, 1, '2019-07-21 01:06:57', '2019-07-21 00:18:57', '2019-07-21 00:18:57');
INSERT INTO `oauth2_access_token` VALUES ('da64ce96f31a451e841b7c5d1428dde4', 'e074968c33bd4317bf64be8e62e089e6', 1, 2, 0, '2019-07-09 15:00:32', '2019-07-09 14:12:31', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('da6c7d366a954eac811e97194b687afc', '231e393ceae24dee8d9f72f4a2861332', 27, 2, 1, '2019-08-30 11:19:44', '2019-08-30 10:31:44', '2019-08-30 10:31:44');
INSERT INTO `oauth2_access_token` VALUES ('da75b4eead1c4238bd4e7fe658b03c9d', '9669273acd6b46a2aaaf8e85de7d357e', 27, 2, 1, '2019-05-27 20:37:53', '2019-05-27 19:49:52', '2019-05-27 19:49:52');
INSERT INTO `oauth2_access_token` VALUES ('da8a6524cf314cd99400f07a94f0a4f6', '9036a8b93f3c4075a838e7fe68c0baf8', 27, 2, 1, '2019-05-24 22:45:36', '2019-05-24 21:57:35', '2019-05-24 21:57:35');
INSERT INTO `oauth2_access_token` VALUES ('da9ceec057564f55a8fb0532e0c2d5dd', 'a51bed5257fc40918108ef61827d658d', NULL, NULL, 1, '2019-05-15 12:20:15', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('da9fb6c8c22a493caf8f9cccefa70415', '6019ab8a92c84d51bc629da5ca071bbf', 27, 2, 1, '2019-06-02 12:52:40', '2019-06-02 12:04:39', '2019-06-02 12:04:39');
INSERT INTO `oauth2_access_token` VALUES ('dab5a44962f54cca9f2162f4fc432abf', 'b38a30926c8e4dc7afa636b6e15c2843', 27, 2, 1, '2019-06-12 18:16:08', '2019-06-12 17:28:07', '2019-06-12 17:28:07');
INSERT INTO `oauth2_access_token` VALUES ('dab68946ae8843739a9ddef0000b4354', 'e26bae8001a740e1837b3f5b908975a7', 27, 2, 1, '2019-06-06 16:56:25', '2019-06-06 16:08:24', '2019-06-06 16:08:24');
INSERT INTO `oauth2_access_token` VALUES ('dabc9b7d150f4609a67da99af8a69df3', '7b9fb4a4dfe746dc87243b05c1095f83', 27, 2, 1, '2019-06-18 14:01:29', '2019-06-18 13:13:29', '2019-06-18 13:13:29');
INSERT INTO `oauth2_access_token` VALUES ('dac37cfd609845fd85c5053c5fae8dca', 'c5575527e2d24cb8aee43a4ca6efe39d', 27, 2, 1, '2019-06-12 14:52:14', '2019-06-12 14:04:13', '2019-06-12 14:04:13');
INSERT INTO `oauth2_access_token` VALUES ('dacd2d81e434443595d6b8add869891c', '83c4cb94c9a94cfbbffdb96a6b2a32f8', 27, 2, 1, '2019-05-23 23:51:55', '2019-05-23 23:03:55', '2019-05-23 23:03:55');
INSERT INTO `oauth2_access_token` VALUES ('daeb1810c48f41b68b1a34e85129aaff', '1c623ed5311d4e3b9ca4d42c87f20720', NULL, NULL, 1, '2019-05-01 22:48:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('db00a4cedb584548a8ca059e27d57684', 'c3f665dd40fb4bb48eff78195ba5ee81', 1, 2, 0, '2019-08-13 00:14:27', '2019-08-12 23:26:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('db18798aff0a473893f709bb04a08ce3', '33ed8a9f1cc94d05a90d65a5cc9410c5', NULL, NULL, 1, '2019-03-10 22:50:04', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('db1d80139fb942bc9bfe533491d24901', '2d74690f928e47e29fa5e7c38b95e529', NULL, NULL, 1, '2019-05-04 17:23:50', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('db2520cedd174ed88394db86ff0e2fa9', 'cbc5e56219294ac2a1a505609036517a', 27, 2, 1, '2019-07-02 17:11:44', '2019-07-02 16:23:43', '2019-07-02 16:23:43');
INSERT INTO `oauth2_access_token` VALUES ('db29f4d1e5b8422aa6a72aaa1810ca6a', '528b72bcaa4b4134b1a3861cb7f4e390', 118, 1, 1, '2019-06-11 16:40:55', '2019-06-11 15:52:54', '2019-06-11 15:52:54');
INSERT INTO `oauth2_access_token` VALUES ('db6167c19ea04be9b5e97a82772eb313', '2c182bcb880540dbbb39db2cf5c693de', 27, 2, 1, '2019-08-07 22:30:07', '2019-08-07 21:42:06', '2019-08-07 21:42:06');
INSERT INTO `oauth2_access_token` VALUES ('db7c9e88965b4f218d88df19b7b4fd17', 'b80b7da02fda4afd9be7d36c7ca7bf8e', 27, 2, 1, '2019-06-01 12:07:52', '2019-06-01 11:19:51', '2019-06-01 11:19:51');
INSERT INTO `oauth2_access_token` VALUES ('db8568c7a8bb48f1b8c0350cbc2c7db7', 'ce7f73fbd7bc41ffb0050e3b4239a0b2', 27, 2, 1, '2019-06-01 18:15:31', '2019-06-01 17:27:30', '2019-06-01 17:27:30');
INSERT INTO `oauth2_access_token` VALUES ('db9b277d36e847fb8b01072ea2e88209', 'b6e7c5af1d3d4cf7bb63f3113de0bcfa', 27, 2, 1, '2019-08-21 12:37:18', '2019-08-21 11:49:18', '2019-08-21 11:49:18');
INSERT INTO `oauth2_access_token` VALUES ('db9b5e6b7001403889c0400ef5637c24', '7aa90be9b562476ebc6be843a3a91f4e', NULL, NULL, 1, '2019-04-26 11:52:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('dbcc35ab05a44c1ea71aaea5b64128af', 'a50e2c0aeaf04524a8b82526e17186f4', NULL, NULL, 1, '2019-05-05 19:28:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('dbccb1beda0a4a1081a6ee7c63992c25', 'a14fe853483748019f909b0e5cbd6fa7', 27, 2, 1, '2019-05-31 18:55:31', '2019-05-31 18:07:30', '2019-05-31 18:07:30');
INSERT INTO `oauth2_access_token` VALUES ('dbde50b2921e4668ab5c67388af194b4', 'e121a9e2aa134b06b98eb4f8beaf61be', 27, 2, 1, '2019-07-26 01:15:24', '2019-07-26 00:27:23', '2019-07-26 00:27:23');
INSERT INTO `oauth2_access_token` VALUES ('dbf673e0d2dd48ff8ff740bc04d6c791', 'c6b45059243f449c8f7f2ecf8b1c3ba0', 27, 2, 1, '2019-06-19 10:58:22', '2019-06-19 10:10:21', '2019-06-19 10:10:21');
INSERT INTO `oauth2_access_token` VALUES ('dc0167bdbdb8428daed39e44c8a546c0', 'c72604f5d2aa464c967c840db04f20ad', 27, 2, 1, '2019-07-10 22:40:36', '2019-07-10 21:52:35', '2019-07-10 21:52:35');
INSERT INTO `oauth2_access_token` VALUES ('dc6c562d360b4f229989a27f560233c8', '6c57a92a49704385855302f1a75e6433', 27, 2, 1, '2019-06-06 12:43:45', '2019-06-06 11:55:45', '2019-06-06 11:55:45');
INSERT INTO `oauth2_access_token` VALUES ('dc8cbecac57349138f2975e730f94b20', 'b8eb3f9638d94effb13eec205977472a', NULL, NULL, 1, '2019-03-30 18:01:03', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('dc913eb876f444698ee490b017de0247', 'db1b40b8514148979e2901d9230c8351', 27, 2, 1, '2019-07-22 11:18:48', '2019-07-22 10:30:48', '2019-07-22 10:30:48');
INSERT INTO `oauth2_access_token` VALUES ('dca1fdce2d56483488b9bb0adc5604f3', '2d7dad10509f4f3a9705b0b4a60cd576', 27, 2, 1, '2019-06-22 17:11:00', '2019-06-22 16:22:59', '2019-06-22 16:22:59');
INSERT INTO `oauth2_access_token` VALUES ('dcc4b8fc53f044aa94b7044a9018d983', '3476b7f1aa944b9e93d63c78632c7df2', 27, 2, 1, '2019-08-25 19:56:20', '2019-08-25 19:08:19', '2019-08-25 19:08:19');
INSERT INTO `oauth2_access_token` VALUES ('dcc50ae3bebb449ab07f6290aee858e9', 'be9a363159c34f568f01e7fcaaff8f35', 27, 2, 1, '2019-07-31 21:57:48', '2019-07-31 21:09:48', '2019-07-31 21:09:48');
INSERT INTO `oauth2_access_token` VALUES ('dcc693c560024826ba0681fc06a6d035', '5e0354acde394350b1a6f663da20f7cb', 27, 2, 1, '2019-07-26 18:07:09', '2019-07-26 17:19:09', '2019-07-26 17:19:09');
INSERT INTO `oauth2_access_token` VALUES ('dcd011e1456e487597035a417178275d', 'cfcd8fc95fa6417a9f652f031e6aac27', 27, 2, 1, '2019-06-03 13:05:33', '2019-06-03 12:17:32', '2019-06-03 12:17:32');
INSERT INTO `oauth2_access_token` VALUES ('dceec2084973485385ba98bd3063eb97', '4c78715a7eba4d56851eeb80c58a6287', 27, 2, 1, '2019-07-11 14:40:16', '2019-07-11 13:52:15', '2019-07-11 13:52:15');
INSERT INTO `oauth2_access_token` VALUES ('dd088a4bc00e422a98c36dbc390cc1e8', 'fc5dbd3dda9949e48b01733ce5617bf7', 27, 2, 1, '2019-07-10 17:59:24', '2019-07-10 17:11:23', '2019-07-10 17:11:23');
INSERT INTO `oauth2_access_token` VALUES ('dd1132cdfa874cc9ae143dc0ff0a8636', 'ab12f23e48eb42f6ba607e091169983e', 27, 2, 1, '2019-07-26 14:34:45', '2019-07-26 13:46:45', '2019-07-26 13:46:45');
INSERT INTO `oauth2_access_token` VALUES ('dd1d3924df6b415fa67222704b1f996a', '0eaad74bb1164efd8ffc4d627510b8b7', 27, 2, 1, '2019-08-19 09:04:39', '2019-08-19 08:16:38', '2019-08-19 08:16:38');
INSERT INTO `oauth2_access_token` VALUES ('dd44da9cf88d43878f10b356b3bcbb7a', '388f9fa0ce124bd2914fbe4556fdb2eb', NULL, NULL, 1, '2019-03-30 23:06:58', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('dd4bcf3934084e7dbee23c15eacfc92a', 'de85d6be7dba4516b7b357f60be98715', 1, 2, 0, '2019-05-17 19:13:27', '2019-05-17 18:25:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('dd742bbbd3ed4f6c9a651ac18a36f5b0', '290ae84fb2b1486f934c7d90e45e406f', 27, 2, 1, '2019-07-09 16:37:32', '2019-07-09 15:49:31', '2019-07-09 15:49:31');
INSERT INTO `oauth2_access_token` VALUES ('dd76731fa18d45dbb69880109c95d161', 'a782ebd07d72437b880dbf5907aecdc6', 27, 2, 1, '2019-07-13 11:38:44', '2019-07-13 10:50:43', '2019-07-13 10:50:43');
INSERT INTO `oauth2_access_token` VALUES ('dd8a9080c8aa4bb49d1dc0ac0d5f59d2', '4bca99a960cd47899cf7f65a3998aab4', 27, 2, 1, '2019-08-11 17:29:49', '2019-08-11 16:41:48', '2019-08-11 16:41:48');
INSERT INTO `oauth2_access_token` VALUES ('dd9bca49dcb94b6386ddfd0a44185928', 'ba05d3607cf5483694c6b2b5910d1640', 27, 2, 1, '2019-07-09 18:06:39', '2019-07-09 17:18:38', '2019-07-09 17:18:38');
INSERT INTO `oauth2_access_token` VALUES ('ddced47dafab44dcb7a887ac7065d896', 'd943c72dbb464933a2c8230ee53e3b38', 27, 2, 1, '2019-05-21 12:05:49', '2019-05-21 11:17:49', '2019-05-21 11:17:49');
INSERT INTO `oauth2_access_token` VALUES ('ddf03f29129c4237a5baae1e877d5e33', '0fbf96dbada048b98ae47c61596bb2ed', NULL, NULL, 1, '2019-04-22 19:13:16', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ddf75c825d3042dca6b8e59676778243', 'fe160604db384a5a9dfc03f73f4f28b8', 27, 2, 1, '2019-06-01 10:45:02', '2019-06-01 09:57:02', '2019-06-01 09:57:02');
INSERT INTO `oauth2_access_token` VALUES ('de1ce08d8efa4b378074dbd9de6d64a7', 'a6c6cc6242154b53ac0c3fdf5e1e743a', 27, 2, 1, '2019-07-31 21:00:30', '2019-07-31 20:12:29', '2019-07-31 20:12:29');
INSERT INTO `oauth2_access_token` VALUES ('de23ab32d76c4cd89a5d6728d045ad5d', '283d7d8421a748098ad82c6a9b79b297', 27, 2, 1, '2019-07-10 22:48:29', '2019-07-10 22:00:29', '2019-07-10 22:00:29');
INSERT INTO `oauth2_access_token` VALUES ('de3fdcdc4a2a419eb12ae545c401ef85', 'b72bc84af39f493097e83b3ccbd84e9d', NULL, NULL, 1, '2019-04-28 16:21:31', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('de518171b45e438db6a59bc31f75b458', '7c50ca619fb3440f9be4a10657c139f5', 27, 2, 1, '2019-07-29 19:52:59', '2019-07-29 19:04:58', '2019-07-29 19:04:58');
INSERT INTO `oauth2_access_token` VALUES ('de5a83f8c0454a699b0534f0afe867cd', '482c38c9098542229829d52f84a81960', 27, 2, 1, '2019-06-02 14:33:56', '2019-06-02 13:45:56', '2019-06-02 13:45:56');
INSERT INTO `oauth2_access_token` VALUES ('de65b34354dc42c6b2002d49d52aa263', '08f5248dfd3d4902846e32e4afa316d9', 27, 2, 1, '2019-07-15 15:57:11', '2019-07-15 15:09:11', '2019-07-15 15:09:11');
INSERT INTO `oauth2_access_token` VALUES ('de73a2a6c65d457c83e06579a81ce898', 'ee0bfbd5ceb44abb9cf0a197a0062730', 210, 1, 1, '2019-08-23 10:47:34', '2019-08-23 09:59:33', '2019-08-23 09:59:33');
INSERT INTO `oauth2_access_token` VALUES ('de820a22629b478a8abbbeb4cd686dfb', 'b14a07e222e44a49a88e229daa4d2d7f', 27, 2, 1, '2019-08-28 18:07:25', '2019-08-28 17:19:24', '2019-08-28 17:19:24');
INSERT INTO `oauth2_access_token` VALUES ('de8436fdef7e4888b470a4eb3caccc84', '1f447411f82a4669ad4bbcbe6bda23b4', 27, 2, 1, '2019-09-04 10:29:37', '2019-09-04 09:41:37', '2019-09-04 09:41:37');
INSERT INTO `oauth2_access_token` VALUES ('de8680aaaba743839f05eafd794479a7', '804e7dafa3f042329257a30b5482fae3', 27, 2, 1, '2019-07-21 12:35:33', '2019-07-21 11:47:33', '2019-07-21 11:47:33');
INSERT INTO `oauth2_access_token` VALUES ('de872ef20c4e4d68a701fb3408392bda', '4c66ada4baea4dd385bf741bcd16900c', 27, 2, 1, '2019-07-12 18:43:14', '2019-07-12 17:55:14', '2019-07-12 17:55:14');
INSERT INTO `oauth2_access_token` VALUES ('de945245709748ff9b8a90a4ba8e940d', 'a3e432615b7e4f248a696969400bc5af', 27, 2, 1, '2019-07-02 11:20:08', '2019-07-02 10:32:07', '2019-07-02 10:32:07');
INSERT INTO `oauth2_access_token` VALUES ('de9bb01353e94be5ad46ec8469d9ce9a', 'df525a81d4ba46fd92ea5624f4c8bfc2', 27, 2, 1, '2019-08-22 17:34:49', '2019-08-22 16:46:49', '2019-08-22 16:46:49');
INSERT INTO `oauth2_access_token` VALUES ('de9de350bc2c422088826ec65179d9f5', '3e6756a01d704850a559035636aa3ffd', 27, 2, 1, '2019-06-18 14:55:13', '2019-06-18 14:07:13', '2019-06-18 14:07:13');
INSERT INTO `oauth2_access_token` VALUES ('dea480b6c1ed4e3abc648208eec38adf', '53bea3411b1d4835b818ea8afe176a46', 27, 2, 1, '2019-05-23 11:32:29', '2019-05-23 10:44:28', '2019-05-23 10:44:28');
INSERT INTO `oauth2_access_token` VALUES ('decc49a08484495fb263d545e90c73a3', '81b813ee61314d1c91040014c5f05695', 27, 2, 1, '2019-08-26 15:33:34', '2019-08-26 14:45:33', '2019-08-26 14:45:33');
INSERT INTO `oauth2_access_token` VALUES ('ded1592fa9864d3fb93f272f82640c9a', '07d200865cce4eef849190f5a1602ff1', 27, 2, 1, '2019-07-23 11:24:43', '2019-07-23 10:36:42', '2019-07-23 10:36:42');
INSERT INTO `oauth2_access_token` VALUES ('dedd57d259cf430abe656181b6237af1', '6d2e085b84714941ac43124d5eaf33bf', 27, 2, 1, '2019-05-23 14:13:17', '2019-05-23 13:25:17', '2019-05-23 13:25:17');
INSERT INTO `oauth2_access_token` VALUES ('dee8a5819fa54dd3b9f90e9c93c72249', '803853bce74f4022a0960cd52445587b', 27, 2, 1, '2019-06-01 09:40:42', '2019-06-01 08:52:41', '2019-06-01 08:52:41');
INSERT INTO `oauth2_access_token` VALUES ('def359de19ea4c0a94ce4216985599ed', '586e32945d364d0cab5c104e49c0c913', 27, 2, 1, '2019-08-09 14:37:41', '2019-08-09 13:49:40', '2019-08-09 13:49:40');
INSERT INTO `oauth2_access_token` VALUES ('df1c6656cf614c87a3ec510957382cc6', 'a195a9298cc3475183ef7e426c1bc362', 27, 2, 1, '2019-07-05 15:41:32', '2019-07-05 14:53:32', '2019-07-05 14:53:32');
INSERT INTO `oauth2_access_token` VALUES ('df1f55355c4d4385baaff363d8870cbf', '9e66ec6a95b74121bde3097b95b2b16f', 27, 2, 1, '2019-08-27 00:03:19', '2019-08-26 23:15:18', '2019-08-26 23:15:18');
INSERT INTO `oauth2_access_token` VALUES ('df2d866910df4def9caa65eb1bba3d80', '06b4f7c5e49a437ca2bcaad463378daa', NULL, NULL, 1, '2019-05-10 14:35:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('df45046f74b5470e9255e93560840bcd', '12eb3c958f2b419d955da1a9195d44bd', 27, 2, 1, '2019-06-01 21:04:10', '2019-06-01 20:16:09', '2019-06-01 20:16:09');
INSERT INTO `oauth2_access_token` VALUES ('df45fcc693194f1da9b6523862607386', '028ca9ae967d426590c95a306c80510b', NULL, NULL, 1, '2019-04-22 20:30:32', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('df48825eeebf431aa0aba3c58015a963', '03480738d9854cfe80afae3420cd3b2e', NULL, NULL, 1, '2019-05-09 17:05:40', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('df497aa4f70b4088bb55876fe70b4c42', '39ad47843589400aabe93ec229d4a826', 27, 2, 1, '2019-06-04 15:43:49', '2019-06-04 14:55:48', '2019-06-04 14:55:48');
INSERT INTO `oauth2_access_token` VALUES ('df634c3b07f34bbdba18c0d1accfa5d0', '4bf01b9b90c04ea6948fe34b8e5b4497', 27, 2, 1, '2019-06-17 16:00:58', '2019-06-17 15:12:57', '2019-06-17 15:12:57');
INSERT INTO `oauth2_access_token` VALUES ('df7fd713abb9498295aa95f5de307b00', '8836d59bb3ae461ea4ca7fceae9e157d', NULL, NULL, 1, '2019-04-22 20:30:36', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('df844b53a4be4719a4af7d3f12529e11', '6e68d801817a40b4a6afa8026f5cdff3', 27, 2, 1, '2019-07-15 21:39:43', '2019-07-15 20:51:42', '2019-07-15 20:51:42');
INSERT INTO `oauth2_access_token` VALUES ('df9685e192bb4e3da2278bb292de6466', '6a5faba45d1f4133b209020db3a03de2', 27, 2, 1, '2019-06-01 17:47:59', '2019-06-01 16:59:59', '2019-06-01 16:59:59');
INSERT INTO `oauth2_access_token` VALUES ('dfa2ea796bc8491a8731a5752118a546', 'b7707bb296cf4671ad11082c4626a7da', 1, 2, 0, '2019-06-11 22:49:14', '2019-06-11 22:01:14', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('dfadabff498c46898bd45364e349fbb1', 'a52e77f7eeff4f87828db3cfe1c9098d', 27, 2, 1, '2019-08-19 18:22:57', '2019-08-19 17:34:56', '2019-08-19 17:34:56');
INSERT INTO `oauth2_access_token` VALUES ('dfcacc1812e343f8a44f7daf5b39336e', '9061165374084ef29d857268813b5da6', 27, 2, 1, '2019-09-03 13:49:41', '2019-09-03 13:01:41', '2019-09-03 13:01:41');
INSERT INTO `oauth2_access_token` VALUES ('dfd08a60ddaf4612b57e9a5a2ebb7a2e', '97025aad07e54edc932f8cf9df304f1b', 27, 2, 1, '2019-09-05 16:03:37', '2019-09-05 15:15:37', '2019-09-05 15:15:37');
INSERT INTO `oauth2_access_token` VALUES ('dfd2a6306fac4db3ab08aea5b2d003a8', '426752cc32d942cba634c84177041905', 122, 1, 1, '2019-06-12 16:48:27', '2019-06-12 16:00:27', '2019-06-12 16:00:27');
INSERT INTO `oauth2_access_token` VALUES ('dfd3e7e2603b405b9a5377cb94c5d3ad', '673e3eb4834249fb8b02e681e3d6c0c8', 27, 2, 1, '2019-06-05 10:15:19', '2019-06-05 09:27:19', '2019-06-05 09:27:19');
INSERT INTO `oauth2_access_token` VALUES ('dfe4556fac764d27829aa152d46e33f5', 'c453cca343204700890df0d7aed2af23', 27, 2, 1, '2019-08-29 11:35:55', '2019-08-29 10:47:54', '2019-08-29 10:47:54');
INSERT INTO `oauth2_access_token` VALUES ('dfea36122c504d9cbabc227386222065', 'e35145770f054a20856a44ad3bced84f', 1, 2, 0, '2019-05-26 18:55:37', '2019-05-26 18:07:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e0120000a7e448febe5e3e171f52c90c', '82119c51b9e64177acb816b1307b1499', 27, 2, 1, '2019-06-04 11:58:40', '2019-06-04 11:10:40', '2019-06-04 11:10:40');
INSERT INTO `oauth2_access_token` VALUES ('e02cc22e116a48919b30b0ce88399f38', 'c5036097fd3e4f53b04388c718a0419d', NULL, NULL, 1, '2019-05-07 16:51:50', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e07ce1f3fb8f44189d19f2f1f2528026', 'd0ddb87abdad48f7bdc0f3f0892f0749', 27, 2, 1, '2019-05-21 23:37:05', '2019-05-21 22:49:05', '2019-05-21 22:49:05');
INSERT INTO `oauth2_access_token` VALUES ('e07e14f14d2a49ca8904f0a57283645f', '7dd62d55ee654fc9a40a3605478ac0c3', 27, 2, 1, '2019-06-26 11:42:55', '2019-06-26 10:54:55', '2019-06-26 10:54:55');
INSERT INTO `oauth2_access_token` VALUES ('e08f8cbc8bef421b81c409326ee93d63', '27a461499b2d4742855a846f44381c7e', 27, 2, 1, '2019-07-09 11:36:02', '2019-07-09 10:48:02', '2019-07-09 10:48:02');
INSERT INTO `oauth2_access_token` VALUES ('e09ace367d3a48208d0f89e304f75d2f', '7c3040f17f104d329a5f409ffb18a813', 27, 2, 1, '2019-07-02 15:28:08', '2019-07-02 14:40:08', '2019-07-02 14:40:08');
INSERT INTO `oauth2_access_token` VALUES ('e0b0ba310fd249b09e87fb0557327fac', 'ede2787b271347669037c08a44448fff', 27, 2, 1, '2019-06-11 12:27:34', '2019-06-11 11:39:33', '2019-06-11 11:39:33');
INSERT INTO `oauth2_access_token` VALUES ('e0b75104009c458ebafc7525b5152362', 'b3e93531bda34601b4229c5589bfbd6a', 27, 2, 1, '2019-06-02 15:02:38', '2019-06-02 14:14:37', '2019-06-02 14:14:37');
INSERT INTO `oauth2_access_token` VALUES ('e0c978259d6f478bbf721dddf3cc6c1f', '89a3d9436b9048a789065b8c127cba10', 27, 2, 1, '2019-06-26 10:44:46', '2019-06-26 09:56:45', '2019-06-26 09:56:45');
INSERT INTO `oauth2_access_token` VALUES ('e0e89f8d640443ec8241491dfcf7f988', '1383aca5bd5a4267bb0b011a74ba61c6', 27, 2, 1, '2019-07-29 18:33:46', '2019-07-29 17:45:46', '2019-07-29 17:45:46');
INSERT INTO `oauth2_access_token` VALUES ('e1238040ccee454ab451b11af69bdcae', '51451c4ff77e4720bbb99a3e26eb9fc8', 27, 2, 1, '2019-06-03 19:21:40', '2019-06-03 18:33:39', '2019-06-03 18:33:39');
INSERT INTO `oauth2_access_token` VALUES ('e12794ef96d447e797932544d3b820c3', '5f18779197ca4e8a8a9c646b788d1bd5', 27, 2, 1, '2019-05-22 17:12:16', '2019-05-22 16:24:16', '2019-05-22 16:24:16');
INSERT INTO `oauth2_access_token` VALUES ('e1306ff94e24410f83107cb2ffef99ec', 'ead54d133c264429ae784c84c1ff5186', 27, 2, 1, '2019-07-02 23:04:25', '2019-07-02 22:16:25', '2019-07-02 22:16:25');
INSERT INTO `oauth2_access_token` VALUES ('e15f004c54cd41bfa8bdd55f854323b4', '7048851da857405b9ef4f79f9cf7f4d7', 27, 2, 1, '2019-06-03 01:25:21', '2019-06-03 00:37:20', '2019-06-03 00:37:20');
INSERT INTO `oauth2_access_token` VALUES ('e166e0bcaec34beba5ad9cafbd5fbe44', '57c5398d696043be96665dc01c7ff3b9', 124, 1, 1, '2019-06-14 15:21:18', '2019-06-14 14:33:18', '2019-06-14 14:33:18');
INSERT INTO `oauth2_access_token` VALUES ('e174b082af2c4af0be481cb68b09accf', '6852fa692c5548a7833c74aed32d7173', NULL, NULL, 1, '2019-05-08 01:07:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e1aae43638c740d38e70ec5416ab3f67', '867f4e6b9f0540a4813789770ea61301', 103, 1, 1, '2019-06-04 11:14:05', '2019-06-04 10:26:05', '2019-06-04 10:26:05');
INSERT INTO `oauth2_access_token` VALUES ('e1b1ece2570844ffaa1d52147e9cfed5', 'fac767eb4418429a8d8cb2500c4a4a91', 1, 2, 0, '2019-07-27 21:40:29', '2019-07-27 20:52:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e1d586f2c37e4946bd0751b781c0424b', '292614ab78ee4008b98b5326289aaca4', 27, 2, 1, '2019-06-01 01:45:16', '2019-06-01 00:57:16', '2019-06-01 00:57:16');
INSERT INTO `oauth2_access_token` VALUES ('e1d7db570d05451f91e5f8801a5ce6fe', '5599488aceb343bfb79347994aadbbc9', 27, 2, 1, '2019-08-17 15:18:32', '2019-08-17 14:30:32', '2019-08-17 14:30:32');
INSERT INTO `oauth2_access_token` VALUES ('e1de3f2cc4514c918f73774ca37514b4', '9d9e8909e76541f986d2be044771348e', 27, 2, 1, '2019-07-03 17:14:42', '2019-07-03 16:26:41', '2019-07-03 16:26:41');
INSERT INTO `oauth2_access_token` VALUES ('e1e2a62b5808485892241c526bb4d04b', 'ea29f0a780ce4c0db64ccbc18debfdb0', 27, 2, 1, '2019-07-06 10:28:37', '2019-07-06 09:40:36', '2019-07-06 09:40:36');
INSERT INTO `oauth2_access_token` VALUES ('e1e34223aef24950a3f10533e6fa9d8a', 'e7281c87a7324261afc8c4871b2463bc', 27, 2, 1, '2019-09-04 17:34:58', '2019-09-04 16:46:57', '2019-09-04 16:46:57');
INSERT INTO `oauth2_access_token` VALUES ('e1e6dbc5a1ff414bbad724b5ccd0f412', '30ab2672531c464682ee0293ff9dca9d', 1, 2, 0, '2019-09-04 10:56:12', '2019-09-04 10:08:12', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e2137b166b3e40a9a124726068ec168c', '5959d024501242e7858d9c43a6c44eac', 27, 2, 1, '2019-06-12 16:05:53', '2019-06-12 15:17:53', '2019-06-12 15:17:53');
INSERT INTO `oauth2_access_token` VALUES ('e267a077b5ce4a8b8351d7f490334382', '19ddaf16b1d845f9948c1e23c1b84906', 27, 2, 1, '2019-05-27 19:00:33', '2019-05-27 18:12:33', '2019-05-27 18:12:33');
INSERT INTO `oauth2_access_token` VALUES ('e28178747fdc4f629480776648681175', '8eadb31707e245b1ab14fd592767f98e', 140, 1, 1, '2019-07-04 09:39:51', '2019-07-04 08:51:50', '2019-07-04 08:51:50');
INSERT INTO `oauth2_access_token` VALUES ('e2860f968b324ff28b55407e53f34d61', '9f6b8c27783b4e8a8cd5ec0144bbfe72', NULL, NULL, 1, '2019-04-24 18:07:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e2aa119d714548f5a3f5fa35a39bbd1d', 'cb41be022efd4ed1bde610d6afb1f1f3', 27, 2, 1, '2019-08-09 18:45:43', '2019-08-09 17:57:43', '2019-08-09 17:57:43');
INSERT INTO `oauth2_access_token` VALUES ('e2c31c7b120745e7af022a13476b5991', 'c8be5d9834ad4d21940187f9b8275a1d', 104, 1, 1, '2019-06-04 13:29:14', '2019-06-04 12:41:13', '2019-06-04 12:41:13');
INSERT INTO `oauth2_access_token` VALUES ('e2c422efcf0340388ea2eee94df0eba3', 'ac4ac58c4c4c40aeb01bfdfcb0e9e949', 27, 2, 1, '2019-06-25 15:30:43', '2019-06-25 14:42:43', '2019-06-25 14:42:43');
INSERT INTO `oauth2_access_token` VALUES ('e2c9ec5e1c55459dbc69e16ba6e5d83d', '487c6194588c44f19d6985cca477d829', 27, 2, 1, '2019-08-18 11:26:34', '2019-08-18 10:38:34', '2019-08-18 10:38:34');
INSERT INTO `oauth2_access_token` VALUES ('e2cd10a756054cdeb086dfef49dd7042', 'ce9ddfe8531c425b9c980543f36c00aa', 27, 2, 1, '2019-07-06 11:50:57', '2019-07-06 11:02:56', '2019-07-06 11:02:56');
INSERT INTO `oauth2_access_token` VALUES ('e30747b6655b4f10ac1c6825cdcc3e29', '3787d4c601c24906a7ff623d74c77dcb', 27, 2, 1, '2019-07-25 21:58:33', '2019-07-25 21:10:33', '2019-07-25 21:10:33');
INSERT INTO `oauth2_access_token` VALUES ('e30d73eae9c0446ab4f867678b59eef8', '5f8a56a232314915a00018c45d1e4bf8', 27, 2, 1, '2019-06-14 09:41:51', '2019-06-14 08:53:50', '2019-06-14 08:53:50');
INSERT INTO `oauth2_access_token` VALUES ('e315f13a4d014c1fa63f11f4917bb281', 'a14210e574ce4717af5950f4af880f5c', 27, 2, 1, '2019-07-04 20:15:20', '2019-07-04 19:27:20', '2019-07-04 19:27:20');
INSERT INTO `oauth2_access_token` VALUES ('e333b4178e1647ad9df0593a77e25a4e', '9dc5ed7aac074201a6bf5d6d9df170ae', 27, 2, 1, '2019-09-08 11:36:33', '2019-09-08 10:48:33', '2019-09-08 10:48:33');
INSERT INTO `oauth2_access_token` VALUES ('e33c1f2382ee4bcb900b11892fa45759', '679ef8e590fd496fa1af0ef4197ee51a', 1, 2, 0, '2019-07-03 14:53:30', '2019-07-03 14:05:30', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e3427af17a6b404fb1b6a34da00f6b78', '0cb085e96e394b449ab55067a371c568', 27, 2, 1, '2019-07-07 18:49:32', '2019-07-07 18:01:31', '2019-07-07 18:01:31');
INSERT INTO `oauth2_access_token` VALUES ('e343c06397bb466d9baab2f949c79ab4', 'ed38d62aa0bf49c9b7dabfc8c5daee0c', 27, 2, 1, '2019-06-01 16:22:02', '2019-06-01 15:34:02', '2019-06-01 15:34:02');
INSERT INTO `oauth2_access_token` VALUES ('e34fec22df2f4766b986971a6c0a35bb', '53cf4a2588bc48398fabcc62198d76ec', 27, 2, 1, '2019-07-02 17:22:48', '2019-07-02 16:34:47', '2019-07-02 16:34:47');
INSERT INTO `oauth2_access_token` VALUES ('e35ee3eb2b4a40c29762dec4860b17bf', '058630e07ba243cba12871840135efb3', 27, 2, 1, '2019-06-27 21:00:20', '2019-06-27 20:12:20', '2019-06-27 20:12:20');
INSERT INTO `oauth2_access_token` VALUES ('e37a79fbc96d471d9490237c378bbbb9', 'd63951737c704b58b5863faebd121032', 27, 2, 1, '2019-07-02 14:17:06', '2019-07-02 13:29:05', '2019-07-02 13:29:05');
INSERT INTO `oauth2_access_token` VALUES ('e37fc827b1e84d69a08e04f63ae59c8f', '8a3799ece911420086992b571c539ae3', NULL, NULL, 1, '2019-05-03 22:13:22', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e39385bf354c4cd88cf718e53ec29fc6', '8245aa9f09b647a1834ba50be2837e6e', 27, 2, 1, '2019-07-24 23:11:35', '2019-07-24 22:23:34', '2019-07-24 22:23:34');
INSERT INTO `oauth2_access_token` VALUES ('e3b8f5ef19f14a6ca8238b4361a3ae50', '1036dbc3260f4fe8be12d90571eb7e6d', 27, 2, 1, '2019-08-08 18:14:31', '2019-08-08 17:26:30', '2019-08-08 17:26:30');
INSERT INTO `oauth2_access_token` VALUES ('e3efb210adf64c49b3c9989bce007257', 'bd29a45fcf874d82b330058e5382a0d3', 27, 2, 1, '2019-07-06 10:28:33', '2019-07-06 09:40:33', '2019-07-06 09:40:33');
INSERT INTO `oauth2_access_token` VALUES ('e404af2c1b0a4e64894d04363a667697', '78ba78d4f7234263a7cd87b64b7fb1c2', NULL, NULL, 1, '2019-04-30 21:00:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e423e342e651429c9ccf6010a2582abb', '4190913e676745cd938b62808824ab28', 27, 2, 1, '2019-06-15 15:26:02', '2019-06-15 14:38:02', '2019-06-15 14:38:02');
INSERT INTO `oauth2_access_token` VALUES ('e427e60a06904127a2c848de5e4c45ee', 'd1f805d80c94439f829d808fc7235c62', NULL, NULL, 1, '2019-05-05 10:40:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e4340ca4ecab4f369a048697a0f50b45', '30d3b153a56b436a830df31e5a0314cd', 1, 2, 0, '2019-08-21 18:50:03', '2019-08-21 18:02:03', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e46e4fa106ea4bc8a1a7f4a61670d59a', 'bce5eba9976743949715292f2f6beb37', NULL, NULL, 1, '2019-05-03 19:20:32', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e47295db9c7c45a8a710938ed63ab286', '9fe30d6440574c0391e1e71133c981fc', 1, 2, 0, '2019-05-31 20:38:56', '2019-05-31 19:50:56', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e48f12e81d7447338e13a937c9be7306', 'e61188ffe9014e7e9b33c89262047367', 27, 2, 1, '2019-06-03 18:27:31', '2019-06-03 17:39:31', '2019-06-03 17:39:31');
INSERT INTO `oauth2_access_token` VALUES ('e49200f46a954dcb80f6dd1fe1d12eff', 'd2cd5bf0803547bcad3ea5dbeebdeec7', 1, 2, 0, '2019-07-12 16:40:45', '2019-07-12 15:52:44', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e4ae1001d70f424aa80921691e187972', '78a64586c251480aaa8b365a67dd5655', 203, 1, 1, '2019-08-14 23:49:33', '2019-08-14 23:01:32', '2019-08-14 23:01:32');
INSERT INTO `oauth2_access_token` VALUES ('e4b1b0e21a78467285e9ae2a64bb58ff', 'c0af07d9f9f44de6a384b1d681fa9b56', NULL, NULL, 0, '2019-03-03 22:52:25', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e4c12a54d5d74633b52c401df63eb926', 'c65e58b150174f78b38379f646362d5e', 27, 2, 1, '2019-06-01 12:14:11', '2019-06-01 11:26:11', '2019-06-01 11:26:11');
INSERT INTO `oauth2_access_token` VALUES ('e4cf67f8ee3f49c589dbf3485b655c8d', 'c664e7cedcc748249ce087d36c15aed1', 1, 2, 0, '2019-06-03 14:39:56', '2019-06-03 13:51:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e4d73f575be64d78a391815648831502', 'e17fc1b248b84a268fd969cda06307c9', 1, 2, 0, '2019-08-26 11:08:38', '2019-08-26 10:20:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e4da1057e9f14cdaadbef66cd24be327', '7582a93cbe824d8e9dc85245a52dc670', 27, 2, 1, '2019-06-01 14:03:05', '2019-06-01 13:15:04', '2019-06-01 13:15:04');
INSERT INTO `oauth2_access_token` VALUES ('e4dd37a93f1e47feb682837be404a118', 'd09aec34c99343b398bfda888c6752d0', NULL, NULL, 1, '2019-04-26 11:47:17', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e506e488b73248b4a0215fa8b700aab4', '1b838e708e274601b753e9b5d5ecfcfd', 27, 2, 1, '2019-09-04 21:36:46', '2019-09-04 20:48:45', '2019-09-04 20:48:45');
INSERT INTO `oauth2_access_token` VALUES ('e50ad3099dde47859ae71c0ede5711ad', '452817926cd04814a5befefad95c5cd7', 27, 2, 1, '2019-05-27 16:56:00', '2019-05-27 16:07:59', '2019-05-27 16:07:59');
INSERT INTO `oauth2_access_token` VALUES ('e5158e8d8f7942388cbcf305d819948c', '9918ad4d161c4640b085725bf72d837a', 115, 1, 1, '2019-06-09 21:03:18', '2019-06-09 20:15:17', '2019-06-09 20:15:17');
INSERT INTO `oauth2_access_token` VALUES ('e52f23fa5a8b463195b6d88135a65c9e', '429f25ca14be498082c98a1fd51a8cbc', 27, 2, 1, '2019-05-22 10:02:50', '2019-05-22 09:14:50', '2019-05-22 09:14:50');
INSERT INTO `oauth2_access_token` VALUES ('e53101d44bd74567a26ac6d19314dbc0', 'd193bd451ec44f3cbbb6aefdb9f84107', 27, 2, 1, '2019-07-10 23:22:54', '2019-07-10 22:34:54', '2019-07-10 22:34:54');
INSERT INTO `oauth2_access_token` VALUES ('e5410ed2116b4f478eee6333d6a8d21a', 'a5f0f608b33c4b188f0249c145d43e89', 27, 2, 1, '2019-08-24 23:40:59', '2019-08-24 22:52:58', '2019-08-24 22:52:58');
INSERT INTO `oauth2_access_token` VALUES ('e5451033a2804ce590a0d16822c7a577', 'ffe9975faffd4029ab45da73ddceb929', 27, 2, 1, '2019-07-04 15:36:29', '2019-07-04 14:48:29', '2019-07-04 14:48:29');
INSERT INTO `oauth2_access_token` VALUES ('e5589e85cf5e4c7289e1dd0bae88b3e6', '4815dc94823041a6b0d9da51182e7adc', NULL, NULL, 1, '2019-04-27 16:28:12', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e55928cc6dd84548bad659ccfddcf928', 'e3dbd506dad44a599bec494543e6f27b', 27, 2, 1, '2019-07-02 17:23:54', '2019-07-02 16:35:54', '2019-07-02 16:35:54');
INSERT INTO `oauth2_access_token` VALUES ('e55a6d84a6824f90bbe622fc4fe4fa3a', '6dfbd628b9ed4246a5c12ea077073a26', 27, 2, 1, '2019-06-06 12:25:51', '2019-06-06 11:37:50', '2019-06-06 11:37:50');
INSERT INTO `oauth2_access_token` VALUES ('e5b0f3376e0b4a44b879df04202ae9da', '67978bdfe5f24b2aa3ab09c8d061d13d', 27, 2, 1, '2019-09-02 19:16:01', '2019-09-02 18:28:00', '2019-09-02 18:28:00');
INSERT INTO `oauth2_access_token` VALUES ('e5b2a818592e49649f3f4ea97bbccaa0', '64823228fd4d4d68aebe9a6e924dd29c', 27, 2, 1, '2019-07-29 13:23:17', '2019-07-29 12:35:16', '2019-07-29 12:35:16');
INSERT INTO `oauth2_access_token` VALUES ('e5bd22004bfa4d17887e5b65f273c961', '783c5ec23f8c466eb520767c14b18107', 27, 2, 1, '2019-06-20 11:36:02', '2019-06-20 10:48:01', '2019-06-20 10:48:01');
INSERT INTO `oauth2_access_token` VALUES ('e5c1adec74f54c92bfb455a38a6f154b', '544cfce6777d4241bf6821407a0892de', 128, 1, 1, '2019-08-03 21:46:41', '2019-08-03 20:58:41', '2019-08-03 20:58:41');
INSERT INTO `oauth2_access_token` VALUES ('e5d8929c8e8e4675abd0c698a2989254', 'e5bd07d32bee4fe3b48f29c8181b3114', NULL, NULL, 1, '2019-05-06 18:17:58', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e5dcc685724546d8bb21ce6127de972f', 'd29eb1158daf43bcb21bcd55f5998ec7', 27, 2, 1, '2019-05-31 17:29:31', '2019-05-31 16:41:31', '2019-05-31 16:41:31');
INSERT INTO `oauth2_access_token` VALUES ('e5ed015da1f64b55888fce03a406d4a6', 'eaeb595c78144462abfddf15b06ccba2', 27, 2, 1, '2019-07-05 15:50:44', '2019-07-05 15:02:43', '2019-07-05 15:02:43');
INSERT INTO `oauth2_access_token` VALUES ('e6030d2a96df4f3585d7e84d0b2d9cb7', 'cab636ab00b2451fb37a81b28eac8aaa', 27, 2, 1, '2019-07-08 22:49:17', '2019-07-08 22:01:16', '2019-07-08 22:01:16');
INSERT INTO `oauth2_access_token` VALUES ('e6102fc0aa794182a7514c79ef25da38', '767f1fa859c54e67be61a08c5db28914', NULL, NULL, 1, '2019-05-01 22:48:13', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e622e11ccaef426599761fbfa4302678', '478ec131a6684a338687d7830b68ed02', 27, 2, 1, '2019-07-29 09:53:53', '2019-07-29 09:05:53', '2019-07-29 09:05:53');
INSERT INTO `oauth2_access_token` VALUES ('e630f4c3bd464738bb489d611e3c1269', 'bd5331bd3361410e8047d8e8cfc7d391', NULL, NULL, 1, '2019-05-09 21:37:13', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e636854962884744a6af2d3377731385', '4016a7d8a1254c8ebebfb253b4edd0ca', 27, 2, 1, '2019-09-08 16:08:58', '2019-09-08 15:20:58', '2019-09-08 15:20:58');
INSERT INTO `oauth2_access_token` VALUES ('e65beaccc9374115865b4fcf1d7b1a9c', '8065cdea04054996b2f1cd4a2e4e44dc', 27, 2, 1, '2019-06-25 19:20:10', '2019-06-25 18:32:09', '2019-06-25 18:32:09');
INSERT INTO `oauth2_access_token` VALUES ('e660066056c4404bbb217698c9e8e3b6', '59fa64b01757455babb201e9b6566812', 27, 2, 1, '2019-07-01 23:54:21', '2019-07-01 23:06:21', '2019-07-01 23:06:21');
INSERT INTO `oauth2_access_token` VALUES ('e66661199cc2490ab3339388f9aad20c', '89a69a71ec794b6d8e48aadd5006249b', 27, 2, 1, '2019-06-03 12:08:45', '2019-06-03 11:20:44', '2019-06-03 11:20:44');
INSERT INTO `oauth2_access_token` VALUES ('e66bf9f8a1fe4a7fb974290cecca03ab', 'e83f993634b94194aa5a6b8050b57479', 27, 2, 1, '2019-06-06 10:27:53', '2019-06-06 09:39:53', '2019-06-06 09:39:53');
INSERT INTO `oauth2_access_token` VALUES ('e680c8be57ef4e94b6262ee437fac6c0', '52c5da9fb6fa461db4c5cb4add8ef7d5', 27, 2, 1, '2019-06-03 10:12:49', '2019-06-03 09:24:49', '2019-06-03 09:24:49');
INSERT INTO `oauth2_access_token` VALUES ('e69596c223754239890aefcd797d87d9', '4a132d7d7ef145f3815e3e81d8d38d75', 136, 1, 1, '2019-06-24 14:58:39', '2019-06-24 14:10:39', '2019-06-24 14:10:39');
INSERT INTO `oauth2_access_token` VALUES ('e6973be8f38f4d269665dea9de94a046', '46b5a70d672e4bfab948ceef48893744', NULL, NULL, 1, '2019-05-17 00:31:14', NULL, '2019-05-16 23:43:13');
INSERT INTO `oauth2_access_token` VALUES ('e6a815d319c444c69d87144b02a749f1', '85ce0911229f474eb22e4fa85e7b3ad5', 27, 2, 1, '2019-05-24 15:15:39', '2019-05-24 14:26:22', '2019-05-24 14:26:22');
INSERT INTO `oauth2_access_token` VALUES ('e6ccf2d5fd254b32b5a901fcd82ffdec', '53a3877db2e44f6486c5932b5d0fa606', NULL, NULL, 1, '2019-04-04 17:05:40', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e702435de8944b378149a4748b1a67ce', 'e3a0064a8fd44d69b2552806a2890f22', 1, 2, 0, '2019-06-14 14:34:58', '2019-06-14 13:46:57', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e706148d963141938c1d3256c2fa72f5', '23544bea59a94d279e1743d4a8e16324', 27, 2, 1, '2019-08-08 15:47:01', '2019-08-08 14:59:01', '2019-08-08 14:59:01');
INSERT INTO `oauth2_access_token` VALUES ('e72ef750fd864e21bf63eb6af06a0122', '53731a78afa1488a8044b28e916e87cb', NULL, NULL, 1, '2019-05-09 01:07:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e72f929174cc497cb370637d3c916f2f', 'c55fc5e022c74d07867fd6526ff7f1cb', 27, 2, 1, '2019-06-21 07:51:59', '2019-06-21 07:03:59', '2019-06-21 07:03:59');
INSERT INTO `oauth2_access_token` VALUES ('e72f9d40409f48c39e33740e4c98f2b8', '8a1d2d93f3804df099c2f63f5ec0415f', 27, 2, 1, '2019-05-31 18:09:01', '2019-05-31 17:21:01', '2019-05-31 17:21:01');
INSERT INTO `oauth2_access_token` VALUES ('e732ae3824b74f25ad4b45e8ddd6b320', 'd173084bc8a741d0931658fe2bdb0e6c', 1, 2, 0, '2019-06-04 16:42:11', '2019-06-04 15:54:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e7436fd7c5594b45aa80c3b9ae5cc429', 'f108f361f84845868d1c3231337b538c', 27, 2, 1, '2019-07-11 18:43:22', '2019-07-11 17:55:21', '2019-07-11 17:55:21');
INSERT INTO `oauth2_access_token` VALUES ('e7825902c9e24decb68bf68811effd87', 'b9c2915de03f447ab51cec998a9dff8d', 27, 2, 1, '2019-05-31 17:31:36', '2019-05-31 16:43:36', '2019-05-31 16:43:36');
INSERT INTO `oauth2_access_token` VALUES ('e788712ece12480c9d1bf24be559577c', 'd6b4f0742a3f4a978dc32c5976c6df85', 27, 2, 1, '2019-06-14 13:22:08', '2019-06-14 12:34:07', '2019-06-14 12:34:07');
INSERT INTO `oauth2_access_token` VALUES ('e78acc038c074ff38c4d5e0ed8dd1e32', 'ab50926b44764fdb9c6a7d76470c2466', 27, 2, 1, '2019-08-15 00:36:20', '2019-08-14 23:48:19', '2019-08-14 23:48:19');
INSERT INTO `oauth2_access_token` VALUES ('e79f972ea98f4b058d90fe37237c2712', 'ac5ca340fa9a4565933ce4644bdfc138', 27, 2, 1, '2019-08-01 10:40:18', '2019-08-01 09:52:18', '2019-08-01 09:52:18');
INSERT INTO `oauth2_access_token` VALUES ('e7ba35aef9b24a008f7aedab7750839b', 'a6dc13ef65794788b8b6a10460fdf394', 27, 2, 1, '2019-08-17 16:29:22', '2019-08-17 15:41:22', '2019-08-17 15:41:22');
INSERT INTO `oauth2_access_token` VALUES ('e7bc77e1d4074651add818106627cc3f', '8790dd3516ec4a76ab3ea5ea53f22bc9', 27, 2, 1, '2019-06-04 23:12:08', '2019-06-04 22:24:07', '2019-06-04 22:24:07');
INSERT INTO `oauth2_access_token` VALUES ('e7d0742db01545b79f43ecf18675025a', 'b2c0228878664d059f1f3c87b8f87446', 27, 2, 1, '2019-06-12 19:59:04', '2019-06-12 19:11:03', '2019-06-12 19:11:03');
INSERT INTO `oauth2_access_token` VALUES ('e7db1920a69f4cb59c5b493af8a6c764', 'f766d4b8d8924789ad54e697b19b2420', 27, 2, 1, '2019-07-20 10:23:03', '2019-07-20 09:35:02', '2019-07-20 09:35:02');
INSERT INTO `oauth2_access_token` VALUES ('e7e209da7709479cb402f6d49eecd826', 'd4ffb898048f44afa689e5eb5739f553', 27, 2, 1, '2019-06-04 11:13:01', '2019-06-04 10:25:00', '2019-06-04 10:25:00');
INSERT INTO `oauth2_access_token` VALUES ('e7e91237a54d4e6babb82523a0b31791', '7f967abf34d7407a9151c26efdcb3dc3', 1, 2, 0, '2019-09-07 22:24:08', '2019-09-07 21:36:07', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e7ed354861cc4c16b5683a6487b8692d', '3bd6d46a20c149b59fa73f614704a21e', 27, 2, 1, '2019-06-04 18:45:37', '2019-06-04 17:57:37', '2019-06-04 17:57:37');
INSERT INTO `oauth2_access_token` VALUES ('e7f3f6ee49c64cb8b93590b6cba5b710', 'f7ed35cc79414150bcdf1cd04cb9715a', 27, 2, 1, '2019-06-05 14:31:03', '2019-06-05 13:43:02', '2019-06-05 13:43:02');
INSERT INTO `oauth2_access_token` VALUES ('e7f73600487e40099b9dde98d879fa45', 'cc351eb864dd44958d760c90db091170', NULL, NULL, 1, '2019-05-10 16:34:53', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e805d49bd211486bb05ef862e368b194', '558b13446e5345f8a97ab6f51e2fdd9b', 98, 1, 1, '2019-06-01 19:12:07', '2019-06-01 18:24:06', '2019-06-01 18:24:06');
INSERT INTO `oauth2_access_token` VALUES ('e809b429d84d45d98514671f53b10c44', '73afa3f8b51f4a55a5760edfe8b56a22', 27, 2, 1, '2019-06-28 10:41:24', '2019-06-28 09:53:23', '2019-06-28 09:53:23');
INSERT INTO `oauth2_access_token` VALUES ('e814c6adc1dd408db8b95dfdde34a4bd', '1551d0b98fe64cb4b872539cac6dafdb', 27, 2, 1, '2019-05-30 21:12:00', '2019-05-30 20:23:59', '2019-05-30 20:23:59');
INSERT INTO `oauth2_access_token` VALUES ('e81749cdff16435883ef69d6ce101275', '3f08db7968364277bf4afedcee472414', 27, 2, 1, '2019-07-16 13:36:46', '2019-07-16 12:48:46', '2019-07-16 12:48:46');
INSERT INTO `oauth2_access_token` VALUES ('e821f0e0e489404ebf00b9fd50b77a5f', '1055e63609964cc5adb640bc4b123469', 1, 2, 0, '2019-08-01 14:55:56', '2019-08-01 14:07:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e83d4750d6824aa38c0c76b99acc4efb', '56f7457e55e543bc94434ca6886157d6', 27, 2, 1, '2019-05-31 23:29:38', '2019-05-31 22:41:38', '2019-05-31 22:41:38');
INSERT INTO `oauth2_access_token` VALUES ('e846f24b2f3d476c8bae5169abd1a40f', '10376c9c65b5470ea1082373c73a1880', 27, 2, 1, '2019-06-03 23:39:40', '2019-06-03 22:51:40', '2019-06-03 22:51:40');
INSERT INTO `oauth2_access_token` VALUES ('e856fa173829437c9d97ab89c912d709', 'f8a3fddec1654e9ea679f057eaa25b87', 27, 2, 1, '2019-06-05 14:40:56', '2019-06-05 13:52:55', '2019-06-05 13:52:55');
INSERT INTO `oauth2_access_token` VALUES ('e8771269bff64fb994b8261b1ec169ce', '0885621364c5427ea0be56951805019c', 27, 2, 1, '2019-06-19 15:53:03', '2019-06-19 15:05:03', '2019-06-19 15:05:03');
INSERT INTO `oauth2_access_token` VALUES ('e87f4cb34e784f75abf1f438360c74bc', '3f19d521a2804a3cbb13b7c47a326d62', 1, 2, 0, '2019-07-09 09:53:44', '2019-07-09 09:05:43', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e889b5a99b3147d49d4a8ad73413d01b', 'faa8aa641a4f465ea291033952a87398', NULL, NULL, 1, '2019-03-11 09:55:29', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e889ca7371714a53b4a071d825f18f65', 'd1e3a971a10242668ba096be5c376074', 27, 2, 1, '2019-07-08 23:15:02', '2019-07-08 22:27:02', '2019-07-08 22:27:02');
INSERT INTO `oauth2_access_token` VALUES ('e88d5d6afb1845a19d772e7554a16a65', '371f73bf7c574bcf81c587f07cbeb934', 27, 2, 1, '2019-06-06 11:16:14', '2019-06-06 10:28:14', '2019-06-06 10:28:14');
INSERT INTO `oauth2_access_token` VALUES ('e8a152a8fd7c400c99b7b8fecc2909f6', '5d8fca50eb57485bbe3050f45449c8bb', NULL, NULL, 1, '2019-05-02 23:03:30', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e9020bd194dc4b20ade2a552e58aee59', 'be575f444a5a4450ae809e00118f6a93', NULL, NULL, 1, '2019-03-21 21:30:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e9042f8e9cfa48469a899e61c74f56fc', 'd7f6bd675aee436894d30039abce4b2d', NULL, NULL, 1, '2019-05-10 17:30:50', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e92aed2cc60749e2bf8ecc415c214bc5', '138cb9de4f994c3f9bf319f4b082f3a5', 27, 2, 1, '2019-06-05 14:14:56', '2019-06-05 13:26:56', '2019-06-05 13:26:56');
INSERT INTO `oauth2_access_token` VALUES ('e93667dd5f424d70b326c3379b2f4e2b', '3bffcd1c2d4d43eab2d98bac4c8240e5', 27, 2, 1, '2019-07-15 11:32:08', '2019-07-15 10:44:08', '2019-07-15 10:44:08');
INSERT INTO `oauth2_access_token` VALUES ('e93f6cabd45b433684275dcfe1fe3a3d', '80578c85e7b54c6084d0527717e09e64', 27, 2, 1, '2019-05-28 14:44:07', '2019-05-28 13:56:06', '2019-05-28 13:56:06');
INSERT INTO `oauth2_access_token` VALUES ('e9483ec336e0450490c29e75a077b39a', '490a18957e5c45ec9ffb4c9abdeacf32', 27, 2, 1, '2019-07-05 19:05:22', '2019-07-05 18:17:21', '2019-07-05 18:17:21');
INSERT INTO `oauth2_access_token` VALUES ('e9503558204e44a7a215a99adfd7e57f', 'cb5c5abcc53941ad9d40c9eea814b6fb', 27, 2, 1, '2019-09-06 01:03:10', '2019-09-06 00:15:10', '2019-09-06 00:15:10');
INSERT INTO `oauth2_access_token` VALUES ('e968b2062a614507946a82131c39dda5', '648c1d4c0ba24631a0713ae3d671816e', 27, 2, 1, '2019-05-23 17:00:26', '2019-05-23 16:12:26', '2019-05-23 16:12:26');
INSERT INTO `oauth2_access_token` VALUES ('e96ac496402946bf97d5f43eff20c1e0', 'e28625b65bad4860b5c29f4b883503de', 1, 2, 0, '2019-07-07 21:46:33', '2019-07-07 20:58:32', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('e99cc0808864479681e9fc84eeee1b4c', '6d94d96897db4fa98fa67395382d1086', 139, 1, 1, '2019-06-25 10:42:06', '2019-06-25 09:54:06', '2019-06-25 09:54:06');
INSERT INTO `oauth2_access_token` VALUES ('e9ac096d3ae04fdb90a66163f856079d', '6534f660918647e4bc778eb47988d37e', 27, 2, 1, '2019-06-25 12:46:47', '2019-06-25 11:58:47', '2019-06-25 11:58:47');
INSERT INTO `oauth2_access_token` VALUES ('e9b517ea317d401f916b0ba849819c91', 'a7b7dc17ebb5434ab016106bab67912f', 27, 2, 1, '2019-08-01 16:31:21', '2019-08-01 15:43:20', '2019-08-01 15:43:20');
INSERT INTO `oauth2_access_token` VALUES ('e9b8cbca9abb4d258503d2431a8d861f', '016798b9953146f2b1d6299939ca6cbf', 27, 2, 1, '2019-09-06 11:09:04', '2019-09-06 10:21:04', '2019-09-06 10:21:04');
INSERT INTO `oauth2_access_token` VALUES ('e9c0fe6db1044b7897b50c14dfabccad', '57f4f20891444e0c92926c44002a25ef', NULL, NULL, 1, '2019-05-02 12:18:29', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('e9d3f9c133b84e2e805f5eeab8bbd1a5', '675ba1134ad24819a4f99ff311c9477d', 27, 2, 1, '2019-06-03 14:35:07', '2019-06-03 13:47:06', '2019-06-03 13:47:06');
INSERT INTO `oauth2_access_token` VALUES ('e9db686188f94e97844f5947ef7fba46', '4b1ca97a66974db78eb14e5af64d82c3', 27, 2, 1, '2019-07-08 16:51:42', '2019-07-08 16:03:41', '2019-07-08 16:03:41');
INSERT INTO `oauth2_access_token` VALUES ('e9f9d7af8e3b44c5adc1600b1fc12df8', 'b4215804b4c94ba5987534fb8771005e', 106, 1, 1, '2019-06-04 21:14:23', '2019-06-04 20:26:22', '2019-06-04 20:26:22');
INSERT INTO `oauth2_access_token` VALUES ('ea07c31b80624329aa2669f6a4275be1', 'a12e101bbc6b4ce4820a2858a5cd0e32', 27, 2, 1, '2019-07-02 17:13:04', '2019-07-02 16:25:04', '2019-07-02 16:25:04');
INSERT INTO `oauth2_access_token` VALUES ('ea1067118c3b4140ba4d118be701ad3c', '3b140c7bf1384c52a236ec7df5a8fe02', 27, 2, 1, '2019-06-11 21:01:20', '2019-06-11 20:13:20', '2019-06-11 20:13:20');
INSERT INTO `oauth2_access_token` VALUES ('ea21a55f56dc4bc5996cec955203b828', 'd64ee8577a2d45c2987cc24cf65cf1c6', 27, 2, 1, '2019-07-15 11:25:21', '2019-07-15 10:37:20', '2019-07-15 10:37:20');
INSERT INTO `oauth2_access_token` VALUES ('ea36fecc2cbc4f2684a39c42c3aedea1', 'bc2af4bec6d647b1affbd4b440f9d30f', 27, 2, 1, '2019-06-25 11:10:25', '2019-06-25 10:22:25', '2019-06-25 10:22:25');
INSERT INTO `oauth2_access_token` VALUES ('ea42f1bed787473da2f89bb89f313812', 'da7d5c5f9d7640499d058225f747029f', 27, 2, 1, '2019-05-23 15:20:27', '2019-05-23 14:32:26', '2019-05-23 14:32:26');
INSERT INTO `oauth2_access_token` VALUES ('ea4f24dcfd9748468b0c9c0a7ad173cb', '3b8b4b51998a419ba5077ee352c0271a', NULL, NULL, 1, '2019-03-08 12:34:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ea8c17d7c350456393ab4740a71bb3e1', 'e550c5d5af134ae68fb0812554ff6b60', 27, 2, 1, '2019-08-06 21:29:33', '2019-08-06 20:41:32', '2019-08-06 20:41:32');
INSERT INTO `oauth2_access_token` VALUES ('ea8f9f0ff0e84b34aecc5d06e83a71a3', '2476aac9015f40f3a3105b76b43972c3', 27, 2, 1, '2019-08-08 01:21:44', '2019-08-08 00:33:43', '2019-08-08 00:33:43');
INSERT INTO `oauth2_access_token` VALUES ('ea99383d64934bc289018e4156e10dc7', 'b48675c496fd4ac1a34318a19ae6cf10', NULL, NULL, 1, '2019-05-05 13:43:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ea9da0034b28462cb999051c22ae7f76', '6e8ba855392542578484b9b0ca3de239', 27, 2, 1, '2019-08-15 09:38:34', '2019-08-15 08:50:34', '2019-08-15 08:50:34');
INSERT INTO `oauth2_access_token` VALUES ('eaa57a182bc64466bb1d70326f14d369', '3286d13e8dfe47cb86f0db28f4c86b5b', 27, 2, 1, '2019-06-03 17:13:08', '2019-06-03 16:25:08', '2019-06-03 16:25:08');
INSERT INTO `oauth2_access_token` VALUES ('eab7df7ab964465c86e9744efed3b6b1', 'f548296ac2e84a4fb5dcef0cc1e0e051', 27, 2, 1, '2019-06-02 21:35:54', '2019-06-02 20:47:53', '2019-06-02 20:47:53');
INSERT INTO `oauth2_access_token` VALUES ('eabd18d9d2954350b24b99c205b33236', '336fcb1cc454470b95bc94630928a691', NULL, NULL, 1, '2019-04-26 11:53:02', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('eacafaaa1a96497ca21650593677605c', '2c855f483b6e4cdaa171e5def7aca8c9', 27, 2, 1, '2019-06-29 00:46:21', '2019-06-28 23:58:21', '2019-06-28 23:58:21');
INSERT INTO `oauth2_access_token` VALUES ('eadfe3aa355f4dfc964490d2c2c5c51a', '3590afe95c234d93886d3b884f36de10', 27, 2, 1, '2019-06-04 18:43:36', '2019-06-04 17:55:36', '2019-06-04 17:55:36');
INSERT INTO `oauth2_access_token` VALUES ('eae41929c91e4982b9109ff636324dbe', 'fe69577efeda4da1b3296fee10541153', NULL, NULL, 1, '2019-05-11 17:44:20', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('eae5158d3cba4592827830bf5a41bfeb', '52370a3d7ceb4f1682c9c2509ccd5a8e', NULL, NULL, 0, '2019-03-03 22:58:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('eb03512b58e44a82a50bf09fd3026515', 'cb3fac57619c478490ba52e56b7f3a5e', 27, 2, 1, '2019-09-05 18:07:51', '2019-09-05 17:19:50', '2019-09-05 17:19:50');
INSERT INTO `oauth2_access_token` VALUES ('eb0893b741c74a0da99333394bb8ceec', 'c8ad295ed96440648ae7b57945f2f729', 27, 2, 1, '2019-06-10 10:12:42', '2019-06-10 09:24:41', '2019-06-10 09:24:41');
INSERT INTO `oauth2_access_token` VALUES ('eb0dffe5ee6f475d99bd9ffea25dfe73', '68b0eb57b889488893954b1aefbcc53d', 27, 2, 1, '2019-06-30 20:37:56', '2019-06-30 19:49:56', '2019-06-30 19:49:56');
INSERT INTO `oauth2_access_token` VALUES ('eb1114e5562a40998452eab982184b11', '10efa11f2a97413badd89ff316466586', 27, 2, 1, '2019-08-12 15:00:37', '2019-08-12 14:12:37', '2019-08-12 14:12:37');
INSERT INTO `oauth2_access_token` VALUES ('eb120905fd2b47b6ab0408ddd0070582', '48a4bbc94b784c6bb6b43d063212bb60', 27, 2, 1, '2019-07-26 18:39:23', '2019-07-26 17:51:23', '2019-07-26 17:51:23');
INSERT INTO `oauth2_access_token` VALUES ('eb2a3dcdab0944a092eb24ed1805f376', 'ea5f58200c8e4bf48ab418a39da0f4e6', NULL, NULL, 1, '2019-04-24 18:11:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('eb321eacb5bd420f81bacebf8f0e1ed2', 'af070f5a743a412eb0e2804becfbea51', 27, 2, 1, '2019-06-13 14:31:42', '2019-06-13 13:43:42', '2019-06-13 13:43:42');
INSERT INTO `oauth2_access_token` VALUES ('eb420b21b16b46559ce18fbc539dd87a', '4b5de198dc7c439ca59ea2cbd553eff1', NULL, NULL, 1, '2019-05-16 00:06:37', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('eb4ae50970084d9e9b6a2daf1a71e1d5', 'e6334cd6e31f4029b5c1a8a4417685c9', 180, 1, 1, '2019-07-23 15:30:38', '2019-07-23 14:42:38', '2019-07-23 14:42:38');
INSERT INTO `oauth2_access_token` VALUES ('eb4b4acb09254f51aa9082cc020991ab', '2f7b99e30b364c87b0c0e927040ff846', NULL, NULL, 1, '2019-05-04 10:59:24', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('eb8030e51b0447688c746659d0a5ff9b', '1c6316c1f302420b88d78a0763f39ba5', 27, 2, 1, '2019-08-09 10:18:14', '2019-08-09 09:30:14', '2019-08-09 09:30:14');
INSERT INTO `oauth2_access_token` VALUES ('eb85ea2cbe564a1888e6ec0c82ffa465', 'ab9e3b87fe6e45c381e365813046deba', 27, 2, 1, '2019-06-04 09:44:29', '2019-06-04 08:56:28', '2019-06-04 08:56:28');
INSERT INTO `oauth2_access_token` VALUES ('eb9e068913734ee78486b51be2942e71', '4ffc43eb61664594bde891183ef0320d', 27, 2, 1, '2019-07-19 10:57:45', '2019-07-19 10:09:44', '2019-07-19 10:09:44');
INSERT INTO `oauth2_access_token` VALUES ('ebb299f7397043db9393f9b2b6c8adb9', '6a89e70f339248199af7c5db931af1dd', 27, 2, 1, '2019-06-13 15:15:31', '2019-06-13 14:27:30', '2019-06-13 14:27:30');
INSERT INTO `oauth2_access_token` VALUES ('ebb5eeba80754f9e8ad25a34c484b7bf', '592fb19c25e542a1a1ecd3d4d4b37a24', 27, 2, 1, '2019-07-03 12:21:26', '2019-07-03 11:33:26', '2019-07-03 11:33:26');
INSERT INTO `oauth2_access_token` VALUES ('ebc87ef60b814134b0a5013493f42bfa', '19e861b455b74fb899ea274074360a0e', 27, 2, 1, '2019-07-09 18:24:48', '2019-07-09 17:36:48', '2019-07-09 17:36:48');
INSERT INTO `oauth2_access_token` VALUES ('ebcefa026c2d4ef0a7a2c1a1d3d6861a', '4bfc01f4b8e8454b87a754f1d8bd8441', 27, 2, 1, '2019-06-16 21:28:43', '2019-06-16 20:40:42', '2019-06-16 20:40:42');
INSERT INTO `oauth2_access_token` VALUES ('ebdbbdc41465496cb7a492c97e11845e', '4d1017a9c3ad41a3bbb14d1229d0c7cc', NULL, NULL, 1, '2019-05-03 18:56:20', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ebde3a40c61843d79d610128347cf8e4', '0be31623233e4a9c8696bde7dd00d581', 27, 2, 1, '2019-06-24 19:02:53', '2019-06-24 18:14:52', '2019-06-24 18:14:52');
INSERT INTO `oauth2_access_token` VALUES ('ebe887d4ab8240b5ae8268302a09a4a6', '751f612d6cba44ee9cd0d1250b91ac86', 27, 2, 1, '2019-06-10 10:53:25', '2019-06-10 10:05:24', '2019-06-10 10:05:24');
INSERT INTO `oauth2_access_token` VALUES ('ec16c844985f49fe95f506eb25421789', '8c74ac3eddb344f3a54cfabf5f60d914', NULL, NULL, 1, '2019-03-15 16:08:08', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ec25ffaaa038462d970a7a44dde71817', '905352c71c6e4c2a98899ea1df90eaf1', 27, 2, 1, '2019-08-11 09:00:36', '2019-08-11 08:12:35', '2019-08-11 08:12:35');
INSERT INTO `oauth2_access_token` VALUES ('ec2ffccce20d413bbebf9b46bb2b4a5a', 'c78ed5e14a62411191d9649739d344cf', 27, 2, 1, '2019-05-23 17:15:00', '2019-05-23 16:26:59', '2019-05-23 16:26:59');
INSERT INTO `oauth2_access_token` VALUES ('ec3e9d2ad3ee4098abd8cb7b07a5cb6f', '37c8509bdebc429080d0204bad77402b', 27, 2, 1, '2019-07-09 14:45:49', '2019-07-09 13:57:48', '2019-07-09 13:57:48');
INSERT INTO `oauth2_access_token` VALUES ('ec537350b1e84c8880d697f8ad9ab0aa', 'a828166b66c440f595267083c5d206c3', 27, 2, 1, '2019-05-29 13:52:30', '2019-05-29 13:04:29', '2019-05-29 13:04:29');
INSERT INTO `oauth2_access_token` VALUES ('ec79668e41d94b198ada59791e59363a', 'da081d16b4394373896a8ba5f2e2e062', 27, 2, 1, '2019-07-23 20:27:45', '2019-07-23 19:39:44', '2019-07-23 19:39:44');
INSERT INTO `oauth2_access_token` VALUES ('ec7f5a2ed1da44cc8ac93c925ed3c445', '53a05218691e490085d5a0592ea2b7ec', 1, 2, 0, '2019-05-26 18:06:59', '2019-05-26 17:18:58', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('ec8cae8bbafc424e9d5935f9dbeb1a40', '6933ac1a84b140708e58c9d1e34bd06d', 27, 2, 1, '2019-06-02 14:13:31', '2019-06-02 13:25:31', '2019-06-02 13:25:31');
INSERT INTO `oauth2_access_token` VALUES ('eca007e2d63b46289b47fcdd1f9d8d01', '50f8e59e14ad4038b9dc8e93e4ebf3cc', 27, 2, 1, '2019-07-02 20:40:43', '2019-07-02 19:52:43', '2019-07-02 19:52:43');
INSERT INTO `oauth2_access_token` VALUES ('eca9cccc2b474bdd8e169ef79ca766ff', '3cea44d1f6804c26ae8a1ff177d9ba89', NULL, NULL, 1, '2019-03-11 07:30:57', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ecb39790799b4356b51fd82055716a2c', 'f53c798cdf1c479fb6f61704b076dc3b', 27, 2, 1, '2019-07-04 18:47:10', '2019-07-04 17:59:10', '2019-07-04 17:59:10');
INSERT INTO `oauth2_access_token` VALUES ('ecb689d0178640a7af053c99b9982a17', '49b99c2ad323454799b4e75d8559e593', 27, 2, 1, '2019-08-11 22:32:12', '2019-08-11 21:44:11', '2019-08-11 21:44:11');
INSERT INTO `oauth2_access_token` VALUES ('ecc4f6e360094a4587e2807bf3ba6c95', 'c13646d3d137463dba023a52025e9e70', 27, 2, 1, '2019-06-05 10:49:06', '2019-06-05 10:01:05', '2019-06-05 10:01:05');
INSERT INTO `oauth2_access_token` VALUES ('ecf6a0fd5be94026918ecee60a0d06e7', 'd70d8c35d86f41d89b80d54b0b8f8ae5', 27, 2, 1, '2019-07-09 23:39:26', '2019-07-09 22:51:25', '2019-07-09 22:51:25');
INSERT INTO `oauth2_access_token` VALUES ('ecf6eaae56804cd1a3801d00ad0004c0', '4b0b34b004c04cacbc48d0b67c331a41', 27, 2, 1, '2019-06-08 13:24:03', '2019-06-08 12:36:03', '2019-06-08 12:36:03');
INSERT INTO `oauth2_access_token` VALUES ('ecfd0d31bd4f4d4e8d2801cf6e489761', 'd44e4df391cf45e78b40bd97a87045b4', 27, 2, 1, '2019-07-06 10:26:17', '2019-07-06 09:38:16', '2019-07-06 09:38:16');
INSERT INTO `oauth2_access_token` VALUES ('ed0a7c087dac454c856bc32e05d1160b', '09269fa8e6ff4d7cabdbc016a71673d4', 1, 2, 0, '2019-08-21 18:50:49', '2019-08-21 18:02:49', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('ed21a0e96da249f3b4d87a4eb427dcd3', 'c2b36f24b3d64dba8409d75b71fac642', 27, 2, 1, '2019-06-17 16:06:05', '2019-06-17 15:18:05', '2019-06-17 15:18:05');
INSERT INTO `oauth2_access_token` VALUES ('ed50c7c38b8c4e0abf803b7c2a14bca2', 'abaebbc9b3f043069534cffd7f33853d', NULL, NULL, 1, '2019-03-12 15:21:37', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ed57784b8b2c4843a57e98143842d6cb', 'f9fb7c2a05e848fa81fc40043bf295c2', NULL, NULL, 1, '2019-04-22 19:22:36', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ed666238867a49f6be339d4c9f2bb060', 'c85c908fb3e9418bb653533f1656c739', 27, 2, 1, '2019-06-06 22:52:31', '2019-06-06 22:04:31', '2019-06-06 22:04:31');
INSERT INTO `oauth2_access_token` VALUES ('ed6d10fbaf1c44be83f60cc746355672', '754aa5d5c9cd4f7abe7e4fa37d4d6821', 27, 2, 1, '2019-06-25 18:54:25', '2019-06-25 18:06:24', '2019-06-25 18:06:24');
INSERT INTO `oauth2_access_token` VALUES ('ed7f05b260bc4f6da8951527797079a3', 'c0c8b939a62e4261b3219c37015218b4', 27, 2, 1, '2019-08-30 17:10:09', '2019-08-30 16:22:09', '2019-08-30 16:22:09');
INSERT INTO `oauth2_access_token` VALUES ('ed85d94b75fc40b2aaaa4aa20d473152', '2632a60a96534b349423ac06a814830c', 27, 2, 1, '2019-06-26 17:20:48', '2019-06-26 16:32:48', '2019-06-26 16:32:48');
INSERT INTO `oauth2_access_token` VALUES ('ed93015dd3b141f2bd0ddbf7bff2ca20', '45e6d4371f094a33a39dfa78a0107008', NULL, NULL, 1, '2019-04-05 17:13:42', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('eda4251774b54d3a9ce1adef83508d98', '89bf83a7944e4c4a8b4cc424a4cf9897', 27, 2, 1, '2019-06-19 10:44:52', '2019-06-19 09:56:52', '2019-06-19 09:56:52');
INSERT INTO `oauth2_access_token` VALUES ('eda75bc3575441b18c1a8462032aa90a', '9ec48259416e49ebb09be59514403c9a', 27, 2, 1, '2019-07-03 12:26:05', '2019-07-03 11:38:04', '2019-07-03 11:38:04');
INSERT INTO `oauth2_access_token` VALUES ('edac3f7ecff9474e83913532c898ff40', '9c99a4a7dfca4dde8fba2a1c9416b176', 27, 2, 1, '2019-05-26 00:57:25', '2019-05-26 00:09:25', '2019-05-26 00:09:25');
INSERT INTO `oauth2_access_token` VALUES ('edac66ffc6744551979d28108ae0cee5', 'd7fbdf002b9449a5a3c7092b45bfeabb', 27, 2, 1, '2019-08-17 19:47:28', '2019-08-17 18:59:27', '2019-08-17 18:59:27');
INSERT INTO `oauth2_access_token` VALUES ('edc04e70fa144d88b8a3c446e2d3cd6c', 'e9f8654d4ff840e78a70bc8cb7613031', 27, 2, 1, '2019-07-20 21:42:44', '2019-07-20 20:54:43', '2019-07-20 20:54:43');
INSERT INTO `oauth2_access_token` VALUES ('edc56e41ba5748bdb6399df94cf08258', 'b47752af455a42e49476c8c1447f3292', 27, 2, 1, '2019-07-06 10:45:22', '2019-07-06 09:57:21', '2019-07-06 09:57:21');
INSERT INTO `oauth2_access_token` VALUES ('edc83a88f4d9405fb75df6ac79d39675', '5553375167dd4453810d68f344db1934', 1, 2, 0, '2019-09-04 23:55:57', '2019-09-04 23:07:56', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('edd05436048642a5826aa53b241ab042', 'be01ac0ceae446ae83fe2fd23c4a1ba1', 27, 2, 1, '2019-08-30 16:42:19', '2019-08-30 15:54:19', '2019-08-30 15:54:19');
INSERT INTO `oauth2_access_token` VALUES ('edd2043d607245e399b08f6197e2a6f4', 'dcb2f39d2ef841a5bec6f317c6e75e6b', 27, 2, 1, '2019-05-23 14:20:18', '2019-05-23 13:32:18', '2019-05-23 13:32:18');
INSERT INTO `oauth2_access_token` VALUES ('edee1781ae67466db7b466c86c067f9c', 'c2f77df943b04328a90d79dd1bbf54a2', 27, 2, 1, '2019-07-12 14:26:03', '2019-07-12 13:38:02', '2019-07-12 13:38:02');
INSERT INTO `oauth2_access_token` VALUES ('edf14621d8ed4d0b8e42a1b7617c810c', '9150b5279f5642da833bec0c47f111d0', 1, 2, 0, '2019-07-02 17:12:43', '2019-07-02 16:24:43', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('edf6d7de95774f5c92c797d2e5ebf0ac', 'ee662620e94f479aa49ac978af6e037a', 1, 2, 0, '2019-06-29 22:44:29', '2019-06-29 21:56:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('ee14fe77423e4e298fcbbc9f49558c4a', 'f93be936cae5482cbe0aabb57968b913', 27, 2, 1, '2019-07-08 16:33:38', '2019-07-08 15:45:37', '2019-07-08 15:45:37');
INSERT INTO `oauth2_access_token` VALUES ('ee1d48f900d344eda6af9b3fbb8574f5', '8623c11943fc47fc8c2e64e77ff42baa', 27, 2, 1, '2019-09-05 22:54:42', '2019-09-05 22:06:42', '2019-09-05 22:06:42');
INSERT INTO `oauth2_access_token` VALUES ('ee42757b536f4efabd79ce2629bab990', '0c34d9766ab64239bfa8c1cbb553ac61', 1, 2, 0, '2019-06-11 12:27:42', '2019-06-11 11:39:41', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('ee551689fef84bd88c63b5097a39babe', '5243b6fe49ca4b6f809409dbeee60e7a', 27, 2, 1, '2019-07-01 15:53:09', '2019-07-01 15:05:08', '2019-07-01 15:05:08');
INSERT INTO `oauth2_access_token` VALUES ('ee8bfcfaa9ce4523a1fe1032d1aa00bf', 'dd65bbdf13f44e3080fbaefc9483aafd', 27, 2, 1, '2019-05-28 15:17:16', '2019-05-28 14:29:16', '2019-05-28 14:29:16');
INSERT INTO `oauth2_access_token` VALUES ('ee8d47a7e36741849c579f4f589b8f2e', 'ec708972357149ada3e035799b32e598', 88, 1, 1, '2019-05-28 17:43:36', '2019-05-28 16:55:36', '2019-05-28 16:55:36');
INSERT INTO `oauth2_access_token` VALUES ('eec9cc17a0844ff3a02cca1abe32d5b9', 'cb8cb484d6804433a0ab4f1424080138', 27, 2, 1, '2019-05-28 15:29:26', '2019-05-28 14:41:26', '2019-05-28 14:41:26');
INSERT INTO `oauth2_access_token` VALUES ('eed3b034dde043bf8abc413d5ee815e3', '74a98b40d8b74c318246502994a3c8f5', 1, 2, 0, '2019-08-28 01:19:26', '2019-08-28 00:31:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('eee60dd51d0d4889a16eb88e71253de7', 'ef8c1ff0390545de88c606afd6484d43', 27, 2, 1, '2019-07-17 16:51:48', '2019-07-17 16:03:48', '2019-07-17 16:03:48');
INSERT INTO `oauth2_access_token` VALUES ('ef10a2ee772b4c8995c74859d074c4b5', '31ed3eec1a384c22af7a56251b523aa6', 27, 2, 1, '2019-08-07 11:27:23', '2019-08-07 10:39:22', '2019-08-07 10:39:22');
INSERT INTO `oauth2_access_token` VALUES ('ef2e1bc56cde44a98b50512ee73f4ea5', 'c08175a56fdf477cbfb674af6d7614a3', 27, 2, 1, '2019-07-01 17:35:00', '2019-07-01 16:46:59', '2019-07-01 16:46:59');
INSERT INTO `oauth2_access_token` VALUES ('ef3d919795254a31a6536117ef90b18c', 'c02a0ea3b6f44302b6db5ba34c21806f', NULL, NULL, 1, '2019-05-05 16:57:39', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ef486f8211f04f8e810eb4388b27732b', 'e3925328393a40518e42864b2924d071', 27, 2, 1, '2019-07-27 19:07:46', '2019-07-27 18:19:45', '2019-07-27 18:19:45');
INSERT INTO `oauth2_access_token` VALUES ('ef495229482249ed8a64c94ec7321aed', 'ac57854dbafb481fba81367d2d651b1d', NULL, NULL, 1, '2019-05-15 17:28:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ef67912d06bf4358be018db91653a8fb', '2f7c364cdcbc4536a319ee56a5155182', 27, 2, 1, '2019-06-23 23:51:10', '2019-06-23 23:03:09', '2019-06-23 23:03:09');
INSERT INTO `oauth2_access_token` VALUES ('ef7442a0d2874611935b606cd7946b33', '0568318b09614068becbd10bed13f938', 27, 2, 1, '2019-07-10 17:18:38', '2019-07-10 16:30:37', '2019-07-10 16:30:37');
INSERT INTO `oauth2_access_token` VALUES ('ef824bf0735b4a4cbe3135e3b5ffd436', 'fb595cac218348feab366b5b356d621a', NULL, NULL, 0, '2019-02-26 17:27:24', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ef8defc8189b4a5e94517598d6603992', '4219cf321cb647d2a6d8b3350bf434ac', 27, 2, 1, '2019-06-24 22:39:52', '2019-06-24 21:51:52', '2019-06-24 21:51:52');
INSERT INTO `oauth2_access_token` VALUES ('ef9d749ccd454983adb7658fc1a8e416', '0b05d405b9744b31ba0e804ea2a2ce1e', NULL, NULL, 1, '2019-05-10 15:05:10', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('efa98486062049bb9ff790f17cac479b', 'ac5b2e5a49004127b05925683cfd95d8', 27, 2, 1, '2019-08-14 16:03:51', '2019-08-14 15:15:50', '2019-08-14 15:15:50');
INSERT INTO `oauth2_access_token` VALUES ('efaded414f0c4c70856751060d608060', '47c47ca3dcc944aa8518a3888068fd39', NULL, NULL, 1, '2019-04-22 19:07:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('efcdfe3da1954304bb649dd096d1d72c', '193a1fea592e44a383edd4da0ab54400', 27, 2, 1, '2019-09-03 14:28:09', '2019-09-03 13:40:08', '2019-09-03 13:40:08');
INSERT INTO `oauth2_access_token` VALUES ('efd13c8790d348e6a40928dbc729dbb0', 'c2911ba473d54f2fa9c8418b8518b110', 27, 2, 1, '2019-06-02 12:17:55', '2019-06-02 11:29:55', '2019-06-02 11:29:55');
INSERT INTO `oauth2_access_token` VALUES ('efe9d030a4b646d1849a3a9841bde303', '09e711fc7f0c4d70af9f55f4a687bf81', 27, 2, 1, '2019-06-07 18:22:48', '2019-06-07 17:34:48', '2019-06-07 17:34:48');
INSERT INTO `oauth2_access_token` VALUES ('eff544a2bd35499bbf6fe1e19afebe30', '5ab164f09c47493cbbb3a50e8c995662', 27, 2, 1, '2019-06-29 22:55:02', '2019-06-29 22:07:01', '2019-06-29 22:07:01');
INSERT INTO `oauth2_access_token` VALUES ('eff9efbd98224296ba39e890b8bfe7a1', '9eb9ba7913e640959513ffbd72f5b937', 27, 2, 1, '2019-06-26 10:44:30', '2019-06-26 09:56:29', '2019-06-26 09:56:29');
INSERT INTO `oauth2_access_token` VALUES ('effaac63626f42db96bcb30f785afee5', '1072009ff54045e69882f71d563fd17a', 27, 2, 1, '2019-06-03 10:32:49', '2019-06-03 09:44:49', '2019-06-03 09:44:49');
INSERT INTO `oauth2_access_token` VALUES ('f00471cab3e144c1b6ae728e3b9f6497', '215c585ca6d44c448268fec5892433b6', 27, 2, 1, '2019-07-18 10:01:21', '2019-07-18 09:13:21', '2019-07-18 09:13:21');
INSERT INTO `oauth2_access_token` VALUES ('f03b2846c9374610983853802a153661', '5f9733418d2540bca4b6630a77147f5e', 27, 2, 1, '2019-07-27 18:13:15', '2019-07-27 17:25:14', '2019-07-27 17:25:14');
INSERT INTO `oauth2_access_token` VALUES ('f043134c7f0a4775a3237b76bd29199a', 'd4445e1ac5034a439d282ad3dcb3dd74', 78, 1, 1, '2019-05-22 16:39:01', '2019-05-22 15:51:01', '2019-05-22 15:51:01');
INSERT INTO `oauth2_access_token` VALUES ('f0476bbaeb5946dea9152bc199709062', '4f584ba604214c63bb117e0e5fdbe619', 27, 2, 1, '2019-06-01 14:27:20', '2019-06-01 13:39:19', '2019-06-01 13:39:19');
INSERT INTO `oauth2_access_token` VALUES ('f05ba6ae744b4024b365bb6f87c93126', 'a1580a70624a41d9b2b008883e8462fb', NULL, NULL, 1, '2019-05-05 10:00:29', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f05f5d2229e8477190250e5f4c83e34e', '86cffae35ec543e6b8c72b1b6722ebb6', 27, 2, 1, '2019-07-17 22:49:12', '2019-07-17 22:01:12', '2019-07-17 22:01:12');
INSERT INTO `oauth2_access_token` VALUES ('f06e83ed7abd4a81849a1f7d9bf30856', '6314ac303d264e998b1da702f3388cc7', 27, 2, 1, '2019-07-20 00:31:44', '2019-07-19 23:43:43', '2019-07-19 23:43:43');
INSERT INTO `oauth2_access_token` VALUES ('f06ff5f1a9474ae2bfda87b59aef957a', '1a55769fff564990a7d60dc8ec778ab1', 27, 2, 1, '2019-08-22 12:30:02', '2019-08-22 11:42:02', '2019-08-22 11:42:02');
INSERT INTO `oauth2_access_token` VALUES ('f070f08795fe4e848abed70ed524b954', '5fdedbd816ae4fd39245d5c3fe57a1eb', 27, 2, 1, '2019-06-07 23:20:24', '2019-06-07 22:32:23', '2019-06-07 22:32:23');
INSERT INTO `oauth2_access_token` VALUES ('f0745c0c73734a8d8492964926b20801', '567147c44f95466ba1b6f384e6fab959', 27, 2, 1, '2019-07-07 16:31:08', '2019-07-07 15:43:07', '2019-07-07 15:43:07');
INSERT INTO `oauth2_access_token` VALUES ('f07b5f40121145e2a278f060d2ee4478', '732b9ddf6a614254b10baf97ef9cb6b3', 27, 2, 1, '2019-08-10 15:19:29', '2019-08-10 14:31:29', '2019-08-10 14:31:29');
INSERT INTO `oauth2_access_token` VALUES ('f0851a74fb4846ca87ff1a05f1f41b54', 'f7abc4e8cb9542ffb467f9c164cccfc7', 27, 2, 1, '2019-07-23 09:01:49', '2019-07-23 08:13:49', '2019-07-23 08:13:49');
INSERT INTO `oauth2_access_token` VALUES ('f08b436be9054033a912502e3bfcb5e9', '811c2b1b236d45e782ff0c22ba0540e6', 27, 2, 1, '2019-08-05 12:12:59', '2019-08-05 11:24:59', '2019-08-05 11:24:59');
INSERT INTO `oauth2_access_token` VALUES ('f09af905e6054f238277dcfa9d256a3c', '3b183202da2b4450a25907ae71a9deec', NULL, NULL, 1, '2019-05-11 23:15:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f09b77ce356748d19cfc65e5b7d524b3', 'ac2ae2c76e26424da560bed82183dd8c', NULL, NULL, 1, '2019-04-30 17:25:21', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f0ae2d866d7a47d9aded99c825044f93', '8be609ee4fa94379b237dd5f4c344f32', 27, 2, 1, '2019-08-19 10:40:31', '2019-08-19 09:52:31', '2019-08-19 09:52:31');
INSERT INTO `oauth2_access_token` VALUES ('f0b54047ab9645538853391f32e39cc5', '47fe9818e8544a3d88f1a02ee0d4ecee', 27, 2, 1, '2019-05-29 22:52:11', '2019-05-29 22:04:11', '2019-05-29 22:04:11');
INSERT INTO `oauth2_access_token` VALUES ('f0b73a5166cd47b7a846f92150579236', '3c4b4e697b6041269ee6e6fb76d546e4', 27, 2, 1, '2019-08-30 11:27:57', '2019-08-30 10:39:56', '2019-08-30 10:39:56');
INSERT INTO `oauth2_access_token` VALUES ('f0efc01408e247219e3e065f49facc60', 'cc912bde993f48d795b15b5189ccfd26', 27, 2, 1, '2019-08-09 17:17:03', '2019-08-09 16:29:03', '2019-08-09 16:29:03');
INSERT INTO `oauth2_access_token` VALUES ('f0feb2f703ac4557897ff8e7e695471f', '0c14cb19daba421eb2536d068c68d389', 27, 2, 1, '2019-05-28 17:23:50', '2019-05-28 16:35:49', '2019-05-28 16:35:49');
INSERT INTO `oauth2_access_token` VALUES ('f105874893ef40c3a1bb21082f8bdfd1', '83d63ac058794800aca317073a743fe2', 27, 2, 1, '2019-09-06 17:12:09', '2019-09-06 16:24:08', '2019-09-06 16:24:08');
INSERT INTO `oauth2_access_token` VALUES ('f1152f401a0e451c8893120956032d15', 'ec4c37f2e33a4479a74fbdbdb253fdd6', 27, 2, 1, '2019-08-21 09:55:10', '2019-08-21 09:07:10', '2019-08-21 09:07:10');
INSERT INTO `oauth2_access_token` VALUES ('f12697711222472d835e2ee1514a7a16', 'f7cf8d153158423496c926b4bf0d2259', 27, 2, 1, '2019-05-26 21:02:02', '2019-05-26 20:14:01', '2019-05-26 20:14:01');
INSERT INTO `oauth2_access_token` VALUES ('f12fc07a1f0443919f43bdc32e1141c3', 'd2b4e37c7dc343db90dc9ee29f2eef78', NULL, NULL, 1, '2019-05-07 10:42:01', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f151bc007abc438c9b166139f9ace8bf', '001112624ead422995e4ff2ff35598b7', NULL, NULL, 1, '2019-05-07 16:22:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f153b8ecebed4f3eb1f7a6cf361f9f22', '1025fd6ff13149d29bfbca7f51868963', 27, 2, 1, '2019-06-03 09:35:38', '2019-06-03 08:47:37', '2019-06-03 08:47:37');
INSERT INTO `oauth2_access_token` VALUES ('f15707d6b3f1484d8fd218649cd82ba9', 'e84ce2a85c7b48a5a89563ad84c2f19d', 27, 2, 1, '2019-07-11 14:50:09', '2019-07-11 14:02:09', '2019-07-11 14:02:09');
INSERT INTO `oauth2_access_token` VALUES ('f1751b953ec540eb91959c148098558c', 'ccf94960ea824f09bdf218fbc4e4851f', 27, 2, 1, '2019-08-09 15:43:53', '2019-08-09 14:55:52', '2019-08-09 14:55:52');
INSERT INTO `oauth2_access_token` VALUES ('f175fd587de94922964437e440a7bfe4', 'f8100b4bbc22462881bf2f0e5b613121', 27, 2, 1, '2019-06-02 15:52:41', '2019-06-02 15:04:41', '2019-06-02 15:04:41');
INSERT INTO `oauth2_access_token` VALUES ('f178b5a7539d4351b82ef55cd0484089', 'd6053bde9ca648c78bd6007258403e0e', 1, 2, 0, '2019-06-23 15:18:52', '2019-06-23 14:30:52', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('f17f450bed294848b5e15883e7857cce', '293480455dc641e9996dd2eb693e0177', NULL, NULL, 1, '2019-03-10 03:26:23', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f1872e4083344bd28a0e7a1dcb470c11', '134a212538af4606a0a7ae5ab0e064ba', 27, 2, 1, '2019-07-01 21:00:47', '2019-07-01 20:12:46', '2019-07-01 20:12:46');
INSERT INTO `oauth2_access_token` VALUES ('f1874b6ecf45463f921aadd6ab43dca6', 'd993d48b0f23413ebe74156924afc502', 196, 1, 1, '2019-08-12 16:23:59', '2019-08-12 15:35:58', '2019-08-12 15:35:58');
INSERT INTO `oauth2_access_token` VALUES ('f18e3413f34b4d0cafac9a22f8b83609', 'ad6f5963c76241e1ad08fefdfe7437bb', 27, 2, 1, '2019-08-27 17:58:29', '2019-08-27 17:10:29', '2019-08-27 17:10:29');
INSERT INTO `oauth2_access_token` VALUES ('f19059043f6942c68b2049b5cd9a3f27', '134ab5c182084343bba3c3c73e90c917', 1, 2, 1, '2019-09-08 23:47:22', '2019-09-08 22:59:22', '2019-09-08 22:59:22');
INSERT INTO `oauth2_access_token` VALUES ('f1bdb3f4872f494392b76026458feee2', 'e26cf75082f44fa9bb9a7b1c720efa93', 207, 1, 1, '2019-08-20 13:41:59', '2019-08-20 12:53:58', '2019-08-20 12:53:58');
INSERT INTO `oauth2_access_token` VALUES ('f1be4d7ac3194ecd9dc3ed6830b5e233', '5259b7aaba834c69b08217723417f0e0', NULL, NULL, 1, '2019-05-08 23:55:16', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f1d3d03b01664c6a972183cea91fa3fc', '36f059bc3eff4e35b8b3229b48f66827', 27, 2, 1, '2019-06-20 09:34:14', '2019-06-20 08:46:13', '2019-06-20 08:46:13');
INSERT INTO `oauth2_access_token` VALUES ('f1e9f0d1b9324772b39411d9efb5593f', '7c74702c388f4dbbb9a565c2ca2982e2', 27, 2, 1, '2019-06-26 11:11:29', '2019-06-26 10:23:29', '2019-06-26 10:23:29');
INSERT INTO `oauth2_access_token` VALUES ('f1f77c91d27a475b99e48bb4390b55e0', '7cf952cb4d7244e0a09d965fcf6b56af', 27, 2, 1, '2019-06-19 16:47:32', '2019-06-19 15:59:32', '2019-06-19 15:59:32');
INSERT INTO `oauth2_access_token` VALUES ('f1f96172bf6d469a98d58928b3ab57d3', '8d592ef95c514a8e93accc3c0c8dabc9', 27, 2, 1, '2019-06-04 15:48:46', '2019-06-04 15:00:46', '2019-06-04 15:00:46');
INSERT INTO `oauth2_access_token` VALUES ('f20ff0d8ee884db3ac4cf4f94f2e7c4f', '042044f66b444729b7a3f28b19ea82c4', 27, 2, 1, '2019-06-02 23:14:18', '2019-06-02 22:26:17', '2019-06-02 22:26:17');
INSERT INTO `oauth2_access_token` VALUES ('f2192493302e4e34985e8c9799d82b18', '7b4f854a148747188f1948416cde26b9', 27, 2, 1, '2019-05-22 16:11:26', '2019-05-22 15:23:26', '2019-05-22 15:23:26');
INSERT INTO `oauth2_access_token` VALUES ('f2289e8da94d4b87827e4dfd31e00066', '038014d9f48a4a45a7d2231451c17dca', 183, 1, 1, '2019-07-28 00:36:06', '2019-07-27 23:48:06', '2019-07-27 23:48:06');
INSERT INTO `oauth2_access_token` VALUES ('f2391a226fd84c769c5c5cdce40b4922', 'c8c729202e7d4dbea28bdbaacccb806a', 1, 2, 0, '2019-06-03 17:24:51', '2019-06-03 16:36:51', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('f251076584f6405f82915808486ada64', 'd96429e7a8984895b2668597be418ca1', 27, 2, 1, '2019-08-12 10:25:33', '2019-08-12 09:37:33', '2019-08-12 09:37:33');
INSERT INTO `oauth2_access_token` VALUES ('f25878af3b7344fa9e24565471213801', '5e6e0d2e46884e3db23f4fe5121eefe3', 27, 2, 1, '2019-08-01 22:51:10', '2019-08-01 22:03:09', '2019-08-01 22:03:09');
INSERT INTO `oauth2_access_token` VALUES ('f26908b509064e0eb5034f93089f1f2b', 'bf66e44d24854b019b81a9756a55903b', 107, 1, 1, '2019-06-04 22:02:13', '2019-06-04 21:14:13', '2019-06-04 21:14:13');
INSERT INTO `oauth2_access_token` VALUES ('f2936928f6ba4cf6b87f15d96d1c06dd', '2c624caef692400aa7bfcea0d3ef4817', 27, 2, 1, '2019-08-08 23:20:28', '2019-08-08 22:32:28', '2019-08-08 22:32:28');
INSERT INTO `oauth2_access_token` VALUES ('f293c745c705469a962f9f6117e1de31', '217782d1d285494fb5b32063867912fa', 27, 2, 1, '2019-08-12 16:37:17', '2019-08-12 15:49:16', '2019-08-12 15:49:16');
INSERT INTO `oauth2_access_token` VALUES ('f2a7cf506a26485d8d27ee69ac41e998', '5e0492855d734c1d8fe1c5efca5bed0e', NULL, NULL, 1, '2019-05-03 00:48:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f2acf75db33e4938b142775dcba8e972', 'e7367714dbaa4ef7b94a9aea4eadc3e2', NULL, NULL, 1, '2019-04-22 19:13:54', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f2cf5b61764b46c0954bd3cf62581fb7', 'd5dad2358600475d81295308e888eb54', 27, 2, 1, '2019-06-27 11:14:58', '2019-06-27 10:26:57', '2019-06-27 10:26:57');
INSERT INTO `oauth2_access_token` VALUES ('f2cf8900467f4474891f7d5d9582074d', '743c172e22fd4dee80bb2492a4f02a29', 27, 2, 1, '2019-06-20 10:35:42', '2019-06-20 09:47:41', '2019-06-20 09:47:41');
INSERT INTO `oauth2_access_token` VALUES ('f2eb37457d1f4590a86d3e617a96deb9', '22bf142c176f4d8ba8601a8d96cc3eb5', NULL, NULL, 1, '2019-05-08 23:57:38', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f2f54224948d46c18c073b4f07844aa2', '5e33c7af348c4bdfa4fc646fac108014', NULL, NULL, 1, '2019-05-08 23:41:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f3073381d23b493794fc05d670b314dd', '967d019ff7d647678f15912b9ccc1abe', 27, 2, 1, '2019-07-01 16:54:18', '2019-07-01 16:06:18', '2019-07-01 16:06:18');
INSERT INTO `oauth2_access_token` VALUES ('f30d24f16bda490aaecd646a67bb88bc', '153d49ae6e70413ca8c62c6bc088694d', 27, 2, 1, '2019-06-03 10:23:39', '2019-06-03 09:35:38', '2019-06-03 09:35:38');
INSERT INTO `oauth2_access_token` VALUES ('f3158172f9c849c788d8650f1594d267', '58c4d723477c4a75a454970b36507736', 27, 2, 1, '2019-05-20 20:47:08', '2019-05-20 19:59:08', '2019-05-20 19:59:08');
INSERT INTO `oauth2_access_token` VALUES ('f3212b72235c43a0a4bb023591fc90bd', 'ba21b6b196ce44378a2682dabdd50ba0', 27, 2, 1, '2019-08-05 15:09:49', '2019-08-05 14:21:48', '2019-08-05 14:21:48');
INSERT INTO `oauth2_access_token` VALUES ('f3224eb7bc0a4c3ba9748d7554db27d4', 'fd61c94969a648059c5238c58360ff7f', 27, 2, 1, '2019-06-07 22:32:49', '2019-06-07 21:44:48', '2019-06-07 21:44:48');
INSERT INTO `oauth2_access_token` VALUES ('f3363432fba34ef3a79584408b791699', 'c37a1136f8e74d699443fbfe5b1c1f76', NULL, NULL, 1, '2019-04-25 10:24:37', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f34661861e9246fab960805407a5402e', '3adaa2e725af4a54bcf1c7e64623a966', 27, 2, 1, '2019-07-06 16:02:47', '2019-07-06 15:14:47', '2019-07-06 15:14:47');
INSERT INTO `oauth2_access_token` VALUES ('f35354f2e2a84cd78868c08bbc631c76', '14469e99019d48eaa2dcb757cfb2530c', 27, 2, 1, '2019-08-09 14:55:55', '2019-08-09 14:07:55', '2019-08-09 14:07:55');
INSERT INTO `oauth2_access_token` VALUES ('f358f7c218dd40e790ceb930ccc92626', '2e5f1c9354da40bc89059ede30fdc997', 27, 2, 1, '2019-06-05 17:00:30', '2019-06-05 16:12:29', '2019-06-05 16:12:29');
INSERT INTO `oauth2_access_token` VALUES ('f35a3ca6ed7443f1868456763cdcd61c', 'd511e2a2896541069884babd7a49bd30', NULL, NULL, 1, '2019-04-29 11:10:07', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f35fcbd7bd0845f292ea9477e4a14a21', '41bf089b0e5a4cc3abe676e585cb8848', 27, 2, 1, '2019-06-28 14:31:34', '2019-06-28 13:43:33', '2019-06-28 13:43:33');
INSERT INTO `oauth2_access_token` VALUES ('f36c406bf57e488090ccc611e991a752', '106361973f1c4618ba13adc3d6932e17', 27, 2, 1, '2019-06-15 14:55:59', '2019-06-15 14:07:59', '2019-06-15 14:07:59');
INSERT INTO `oauth2_access_token` VALUES ('f398f79774c14686a01435518cd5c6d9', '0d7403de84bc4514aae223ee8d6fbd67', 27, 2, 1, '2019-06-06 15:05:28', '2019-06-06 14:17:27', '2019-06-06 14:17:27');
INSERT INTO `oauth2_access_token` VALUES ('f399715a838347379ba5c463f05a0f72', '3a9dbdfedc6f47bda2b0137abe48650e', 27, 2, 1, '2019-06-25 10:25:26', '2019-06-25 09:37:26', '2019-06-25 09:37:26');
INSERT INTO `oauth2_access_token` VALUES ('f39f5154a44744a5bcf04b51e7c622ee', '1526802d768e41af8a3d7410fec146d7', 204, 1, 1, '2019-08-17 11:28:19', '2019-08-17 10:40:18', '2019-08-17 10:40:18');
INSERT INTO `oauth2_access_token` VALUES ('f3c2dfc58a884522ad3f07a9f7154352', 'b33b60d6300b490fafb9cc1affc7dc98', 27, 2, 1, '2019-07-02 10:54:28', '2019-07-02 10:06:28', '2019-07-02 10:06:28');
INSERT INTO `oauth2_access_token` VALUES ('f3cd362d9f9d43dca7a17b6bee5f211b', 'f606d62293e740d99b369853682a91e1', 27, 2, 1, '2019-06-06 12:27:39', '2019-06-06 11:39:39', '2019-06-06 11:39:39');
INSERT INTO `oauth2_access_token` VALUES ('f3d1f5cbd40b4aba825ab037e2482e3c', '5b252c2b780f43d8a73599c37c0201e5', NULL, NULL, 1, '2019-05-13 18:53:45', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f417a29b88fc43e4a3ef40191060c27e', '86a2e62f86b24969909d6deee82cd804', NULL, NULL, 1, '2019-05-12 23:35:46', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f429fd77ab87400d9e84df80a776f426', '5f05124a3204412498d1895322a25875', 27, 2, 1, '2019-05-31 19:06:38', '2019-05-31 18:18:38', '2019-05-31 18:18:38');
INSERT INTO `oauth2_access_token` VALUES ('f43cafd337f74ce48e25739f8c0f66d8', '1496c7134a1242a28ceca735b76fe1b3', 27, 2, 1, '2019-08-30 16:03:25', '2019-08-30 15:15:24', '2019-08-30 15:15:24');
INSERT INTO `oauth2_access_token` VALUES ('f45259ab1409431e921b9a84f7699920', '999a2ebe3faa49f8a335eeb2e154d460', 27, 2, 1, '2019-06-05 14:54:36', '2019-06-05 14:06:36', '2019-06-05 14:06:36');
INSERT INTO `oauth2_access_token` VALUES ('f456183335944cdc9fa2f24aef570c38', '09eb342f8ee541e7be2768769c041da3', 142, 1, 1, '2019-06-27 15:15:14', '2019-06-27 14:27:13', '2019-06-27 14:27:13');
INSERT INTO `oauth2_access_token` VALUES ('f471eef6000244dab8a33caa779efdf0', '8a2f90fb7e154817b9e7f2b53c8e067d', NULL, NULL, 0, '2019-03-03 22:58:44', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f474840f866b4b84819faddb57731f4e', 'fd8985d6de614993be28a21fe960abd8', 27, 2, 1, '2019-05-28 10:55:35', '2019-05-28 10:07:34', '2019-05-28 10:07:34');
INSERT INTO `oauth2_access_token` VALUES ('f478bf95506d422e99096b807c4cc58b', '2263922f804a4e728e44533130340b97', 1, 2, 0, '2019-07-04 16:34:06', '2019-07-04 15:46:06', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('f48d1893a9a34107b51f3471f4d46e81', 'fd1f572de8d24b029feb72ee6fd9f523', 27, 2, 1, '2019-08-21 09:49:45', '2019-08-21 09:01:44', '2019-08-21 09:01:44');
INSERT INTO `oauth2_access_token` VALUES ('f497e307eb414815857306cdae43418f', '51fc9e46e8464c28acd6857c05f4c2c9', 27, 2, 1, '2019-07-18 12:59:28', '2019-07-18 12:11:27', '2019-07-18 12:11:27');
INSERT INTO `oauth2_access_token` VALUES ('f499a1ecd9ea43659dd9d0c632ad50e5', 'b0939f1c07a14c4392f77fe32d08d389', 27, 2, 1, '2019-07-30 09:59:01', '2019-07-30 09:11:01', '2019-07-30 09:11:01');
INSERT INTO `oauth2_access_token` VALUES ('f49b8c043e134a5d885467094b412ceb', '84bb3521ebe64e47bd3fb0aabbc0b543', NULL, NULL, 0, '2019-02-27 16:13:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f4b1eb3b94314447bd277a660ef2b31a', '671dfdb77c38472385563b694f1d17b4', NULL, NULL, 1, '2019-04-30 20:50:16', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f4b3b9afeab24648a45f587cfc999a53', '0643e81562df4aa4b28c9d2368f2df58', 27, 2, 1, '2019-06-01 13:49:31', '2019-06-01 13:01:30', '2019-06-01 13:01:30');
INSERT INTO `oauth2_access_token` VALUES ('f4b4a6b6a89d4eda92862d5fd36f2f59', '3b5c65b316cd441d9f50bcb8245fc9f6', 27, 2, 1, '2019-07-27 16:33:48', '2019-07-27 15:45:48', '2019-07-27 15:45:48');
INSERT INTO `oauth2_access_token` VALUES ('f4bb82f98a3243bdbec02f40e8e5c588', '188482753cd848ef8409d3fd076d6f8f', 27, 2, 1, '2019-08-14 23:15:35', '2019-08-14 22:27:34', '2019-08-14 22:27:34');
INSERT INTO `oauth2_access_token` VALUES ('f4d63d5eb7d44bce9d45883abc3012d4', 'bf73bb15d55140529ca4ab6624a6662f', 27, 2, 1, '2019-07-22 18:37:33', '2019-07-22 17:49:33', '2019-07-22 17:49:33');
INSERT INTO `oauth2_access_token` VALUES ('f5024eea9c3444de81774e28cfa50ee1', '54c2843d8e7944148351133c00399e2e', 27, 2, 1, '2019-07-29 21:06:14', '2019-07-29 20:18:13', '2019-07-29 20:18:13');
INSERT INTO `oauth2_access_token` VALUES ('f50742e9f37347728963f0dee19ca510', 'e1cafec549964231a59c307ab76457b3', 1, 2, 0, '2019-07-07 21:34:33', '2019-07-07 20:46:33', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('f50858189d81422c87a3f7bcbfcb5ac6', 'faf08d4d4edd4d37a3294cf452a5bcda', 1, 2, 0, '2019-05-31 19:42:15', '2019-05-31 18:54:14', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('f509c199d4da4338943d06b0c559d875', 'e135c24d9f02452aabc35c63df6f4708', 27, 2, 1, '2019-06-05 12:16:26', '2019-06-05 11:28:26', '2019-06-05 11:28:26');
INSERT INTO `oauth2_access_token` VALUES ('f50c518a556843a08dc531a498fcfadd', '853bee33fc89423288ff60318f62206a', 1, 2, 0, '2019-09-05 12:43:06', '2019-09-05 11:55:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('f50fda53eb794f5f954d420e34ab45d9', '8e754bbcb2e44ce282c8e03d3b4e7b17', NULL, NULL, 1, '2019-03-10 10:59:01', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f52fc88bc94940ac9e27a05bbb6a903b', '7d2d2e5acf274f81b67210241a2204ee', 27, 2, 1, '2019-05-31 21:36:52', '2019-05-31 20:48:51', '2019-05-31 20:48:51');
INSERT INTO `oauth2_access_token` VALUES ('f542e35137d94db8992637e87a80a01e', '45b85dc5eed84fd785eabf0eb5069c8b', NULL, NULL, 1, '2019-03-12 22:17:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f548635e535a44f7a26636b456459456', 'e206e456450b4cb2a05dcabbd050e4ac', 27, 2, 1, '2019-06-03 16:42:08', '2019-06-03 15:54:08', '2019-06-03 15:54:08');
INSERT INTO `oauth2_access_token` VALUES ('f54aaa58f8dc40ab9499158db8a99e65', '14a29f41230b48adae4f9909f1a935ea', 27, 2, 1, '2019-08-11 16:56:45', '2019-08-11 16:08:45', '2019-08-11 16:08:45');
INSERT INTO `oauth2_access_token` VALUES ('f55951f4514b4622938c8309bce93823', 'd691223d6b974307a3683a391710880c', 27, 2, 1, '2019-06-08 10:47:32', '2019-06-08 09:59:31', '2019-06-08 09:59:31');
INSERT INTO `oauth2_access_token` VALUES ('f5646f94d2d1417f948eb8365cd5ca4e', 'da204ebf3c5a4bfcb123f8774ee0b1e5', 27, 2, 1, '2019-07-22 15:22:17', '2019-07-22 14:34:17', '2019-07-22 14:34:17');
INSERT INTO `oauth2_access_token` VALUES ('f57c38666f2642bebc984294e9a2c0b8', 'a54ed7d71e8b4d1bbd4c7faca95e917d', 27, 2, 1, '2019-06-11 11:23:59', '2019-06-11 10:35:59', '2019-06-11 10:35:59');
INSERT INTO `oauth2_access_token` VALUES ('f57fb50db1494c2395c001f3a8b935db', '9b353a7680df4a148fa8035d06b73d56', 27, 2, 1, '2019-08-02 17:53:07', '2019-08-02 17:05:07', '2019-08-02 17:05:07');
INSERT INTO `oauth2_access_token` VALUES ('f5894077872b4b05abd683bddb3d8738', '5c85603109bf47efba658388653f7964', 27, 2, 1, '2019-07-22 10:05:53', '2019-07-22 09:17:53', '2019-07-22 09:17:53');
INSERT INTO `oauth2_access_token` VALUES ('f58ce3e0907a4ea89b9e4d2229d689fd', 'dbb02b8065814d5990e4a1ecbffcbdd1', NULL, NULL, 1, '2019-05-05 17:46:56', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f5a9aac19e4042f8915063ee0ce9bee4', '9ec4c59916e24b00927bc36b8ccbd659', 27, 2, 1, '2019-06-04 15:03:39', '2019-06-04 14:15:38', '2019-06-04 14:15:38');
INSERT INTO `oauth2_access_token` VALUES ('f5acd3bd1cd847e9ad9e7cc59bf8d4d0', '9e28a3783b7c4c53a3e4a2fd7596fff8', 27, 2, 1, '2019-05-22 17:31:24', '2019-05-22 16:43:24', '2019-05-22 16:43:24');
INSERT INTO `oauth2_access_token` VALUES ('f5c68358496e485abf282a20931a82f9', '2f205b81b2334a2aac147a581c94c117', NULL, NULL, 1, '2019-05-11 09:12:01', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f5d70f0dc43943ca966af753f8d7225a', '0b522135e24a477ba56c2240e18aac97', 27, 2, 1, '2019-08-05 00:11:48', '2019-08-04 23:23:48', '2019-08-04 23:23:48');
INSERT INTO `oauth2_access_token` VALUES ('f5d7ecc8d1154995b057bb2b34c09d7f', '10aa6a55e9ef40cfbf493238f9f1da85', 202, 1, 1, '2019-08-14 16:36:47', '2019-08-14 15:48:46', '2019-08-14 15:48:46');
INSERT INTO `oauth2_access_token` VALUES ('f5df30b4886741e592a3a9ac14f2c3fc', '7571fd59839f4a60abba14ba276c4ac0', 27, 2, 1, '2019-08-27 16:51:58', '2019-08-27 16:03:57', '2019-08-27 16:03:57');
INSERT INTO `oauth2_access_token` VALUES ('f5e0c44a10a546c8ae3ecf48b0a4edc7', 'b910843332d04f309b557f1a115c3143', 27, 2, 1, '2019-07-07 16:05:48', '2019-07-07 15:17:47', '2019-07-07 15:17:47');
INSERT INTO `oauth2_access_token` VALUES ('f5e1b7d0c0ea48cb93d29f236bd49f1f', '64087e030d384432981005864a1fb52f', NULL, NULL, 1, '2019-05-09 11:30:30', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f6107bdda0a24e6982c5862e686b7831', 'e21000adbe9744578c126490b8f0db14', 27, 2, 1, '2019-09-04 17:52:24', '2019-09-04 17:04:24', '2019-09-04 17:04:24');
INSERT INTO `oauth2_access_token` VALUES ('f618e7afb8d34f85b052e8e24212330d', 'f1c493a66ee34e1e9d42f50ea68e08d7', 27, 2, 1, '2019-07-28 11:51:18', '2019-07-28 11:03:17', '2019-07-28 11:03:17');
INSERT INTO `oauth2_access_token` VALUES ('f6335c29ece946b5b186dd00f27e9a92', '373a194e0bec4ec395eae3a772410495', 27, 2, 1, '2019-06-02 11:38:16', '2019-06-02 10:50:15', '2019-06-02 10:50:15');
INSERT INTO `oauth2_access_token` VALUES ('f6468f97a86c4c3ca58dd6fae33e9a02', '6cec9d45381b453484dbb6cb7b70b43c', 27, 2, 1, '2019-07-24 20:11:24', '2019-07-24 19:23:24', '2019-07-24 19:23:24');
INSERT INTO `oauth2_access_token` VALUES ('f6622ed5f0db4ecdbbe725128f8a61a0', 'fd0961d6c5ae4d71987a12e7f1b7b364', NULL, NULL, 1, '2019-05-10 09:46:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f669a271434d4a8d97d5d2ac6d08a664', '0a1f4713501d44929ed222707b962889', 1, 2, 0, '2019-08-21 15:02:37', '2019-08-21 14:14:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('f672155ebee04a528906cae9529b26f3', 'f43a5e46185e46118a2f9dd9fe3624d3', 27, 2, 1, '2019-06-11 23:07:39', '2019-06-11 22:19:39', '2019-06-11 22:19:39');
INSERT INTO `oauth2_access_token` VALUES ('f674ca7a8b4b43368b63f7ebcaff3cdf', '12b092c65f554b63973b4251413878c3', 27, 2, 1, '2019-07-27 14:39:06', '2019-07-27 13:51:06', '2019-07-27 13:51:06');
INSERT INTO `oauth2_access_token` VALUES ('f67614feb1e84a3d918bfd1d79007ca9', '018683e62b9f4177b3ca1c5ac016f8ac', 27, 2, 1, '2019-07-12 11:03:17', '2019-07-12 10:15:16', '2019-07-12 10:15:16');
INSERT INTO `oauth2_access_token` VALUES ('f682660b4e264b6ab15ea5c667b419a2', 'dbe83eeb83274794a8b8942c78cca8ed', 27, 2, 1, '2019-06-04 15:57:15', '2019-06-04 15:09:15', '2019-06-04 15:09:15');
INSERT INTO `oauth2_access_token` VALUES ('f69fe5fbdfe84ad9b8865c5a93b521a8', 'baa33d635a9148069e5c92e523d8ac2d', 27, 2, 1, '2019-07-03 15:34:57', '2019-07-03 14:46:56', '2019-07-03 14:46:56');
INSERT INTO `oauth2_access_token` VALUES ('f6bb786a08e04b1a86a7232f7577aef0', '1065ff89e00b40bb9f43451811120cc9', 27, 2, 1, '2019-06-12 12:16:07', '2019-06-12 11:28:07', '2019-06-12 11:28:07');
INSERT INTO `oauth2_access_token` VALUES ('f6c3d9e4c4c54c3da25460090b4efe89', '3d95ec1ce7dd4d7b94bf83732ff017a2', NULL, NULL, 1, '2019-05-12 20:49:40', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f6d0079c553943deb7803f3f71fb105d', 'ed1d1cdeb5f54e5eb671c9850a138a07', 27, 2, 1, '2019-06-09 13:22:23', '2019-06-09 12:34:23', '2019-06-09 12:34:23');
INSERT INTO `oauth2_access_token` VALUES ('f6f053eb525d421f8d829c5fe77b1125', '6cd4e23ff42548729643169341b0e3a9', 27, 2, 1, '2019-06-03 15:13:04', '2019-06-03 14:25:03', '2019-06-03 14:25:03');
INSERT INTO `oauth2_access_token` VALUES ('f6f198696b2e42e597fa2ec01ff9a3ba', '10a31fa7d1e54e12ab8e19fa66fcf59e', 27, 2, 1, '2019-06-05 14:39:23', '2019-06-05 13:51:22', '2019-06-05 13:51:22');
INSERT INTO `oauth2_access_token` VALUES ('f6fcf3796c754356ae747742ad2ec222', '3106a921a01d4cf5a2c64d3d73f8b744', 27, 2, 1, '2019-06-28 14:40:47', '2019-06-28 13:52:47', '2019-06-28 13:52:47');
INSERT INTO `oauth2_access_token` VALUES ('f70af97de1d94df8b360a64af616da58', '0bd9497597e84332a6909c82d82aa3b3', 27, 2, 1, '2019-06-04 17:12:01', '2019-06-04 16:24:00', '2019-06-04 16:24:00');
INSERT INTO `oauth2_access_token` VALUES ('f730f193daa94bd3a4b236874d583e32', '357ac36226984fb991247f6961017206', 27, 2, 1, '2019-07-08 19:55:18', '2019-07-08 19:07:18', '2019-07-08 19:07:18');
INSERT INTO `oauth2_access_token` VALUES ('f738b394470a4969b152db9cd5c34540', 'b43690f211ec43f2bab160dd3317ab84', 27, 2, 1, '2019-06-01 14:03:49', '2019-06-01 13:15:48', '2019-06-01 13:15:48');
INSERT INTO `oauth2_access_token` VALUES ('f742b69a7dd44f3ebf698407712be1a3', 'ead59b5eae8e44419318f0d42681c821', 27, 2, 1, '2019-06-16 13:14:51', '2019-06-16 12:26:50', '2019-06-16 12:26:50');
INSERT INTO `oauth2_access_token` VALUES ('f7449994e4314f428c75fade1f0c2a05', 'd5d6f13d9250468a87c5de00148c4f2a', 27, 2, 1, '2019-06-27 12:02:57', '2019-06-27 11:14:56', '2019-06-27 11:14:56');
INSERT INTO `oauth2_access_token` VALUES ('f7596142c2a94f2b87b4fd379442709f', '53880e7192be4aee994e71edbfc96b36', 197, 1, 1, '2019-08-13 12:41:47', '2019-08-13 11:53:47', '2019-08-13 11:53:47');
INSERT INTO `oauth2_access_token` VALUES ('f75b4ac0ced2497ea1ef7a332869c4eb', '75013179c78b44c7a3c0d3cee9ec312d', 27, 2, 1, '2019-09-03 17:50:18', '2019-09-03 17:02:18', '2019-09-03 17:02:18');
INSERT INTO `oauth2_access_token` VALUES ('f76601f7fd87427c8543ff9ecc0154e3', 'bd846ed1a02d4a0ea67879a517bbd7b9', 27, 2, 1, '2019-07-20 10:53:47', '2019-07-20 10:05:47', '2019-07-20 10:05:47');
INSERT INTO `oauth2_access_token` VALUES ('f7867d6040c948acaac0f07c8dcdd7c8', '1d67346572c8437da83551edb3bded32', 27, 2, 1, '2019-06-14 20:00:15', '2019-06-14 19:12:15', '2019-06-14 19:12:15');
INSERT INTO `oauth2_access_token` VALUES ('f7b48e3ef9844abe922fd99643bc1e48', 'ee95699156fe49aba483ce515918c0ea', 27, 2, 1, '2019-06-21 16:25:42', '2019-06-21 15:37:41', '2019-06-21 15:37:41');
INSERT INTO `oauth2_access_token` VALUES ('f7ba27d91730407e8d98bfc9bd98fc88', '25749366fec74f83a90f9144b68be28e', NULL, NULL, 1, '2019-04-24 19:19:35', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f7c7d306a3d7431baaef7dc59b92cc92', '6ff0e07004f842359cb2bedfc423b270', 27, 2, 1, '2019-07-31 21:57:21', '2019-07-31 21:09:20', '2019-07-31 21:09:20');
INSERT INTO `oauth2_access_token` VALUES ('f7d903799aa94f4194a5dc0977775782', '834d23b249da4a0f87fd79218847135d', 128, 1, 1, '2019-08-13 17:42:04', '2019-08-13 16:54:03', '2019-08-13 16:54:03');
INSERT INTO `oauth2_access_token` VALUES ('f7daa2f6d0da4b82821558f56a4d9d52', 'c7e50eea1875441aa4bd5db14197327e', 27, 2, 1, '2019-07-12 18:43:46', '2019-07-12 17:55:45', '2019-07-12 17:55:45');
INSERT INTO `oauth2_access_token` VALUES ('f7dfaa4558f84fc7a51148c2373ae28a', 'c1c06d084faa4fee9bccc2b0315723bf', 27, 2, 1, '2019-06-07 17:40:36', '2019-06-07 16:52:36', '2019-06-07 16:52:36');
INSERT INTO `oauth2_access_token` VALUES ('f7efb51be3944e52ba3ebf45c6b6b375', 'a419152914484c0595d0c4024bf85a2d', NULL, NULL, 1, '2019-03-16 21:06:47', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f80384d19c4c41f0b1791c564ba34f58', '0b0dc1d7098a466b820b0e7fa8c3594d', 27, 2, 1, '2019-05-28 15:31:21', '2019-05-28 14:43:20', '2019-05-28 14:43:20');
INSERT INTO `oauth2_access_token` VALUES ('f8095f26c2dd433bb9d46faff2a749c4', 'cf1e3256ea8b4e7cb07def84f8792252', 27, 2, 1, '2019-06-23 17:23:46', '2019-06-23 16:35:46', '2019-06-23 16:35:46');
INSERT INTO `oauth2_access_token` VALUES ('f8214095c9fd468dabfe794e7d4c5127', 'd47b390a25b345c980c27d9350299855', NULL, NULL, 1, '2019-03-15 19:34:06', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f839b5fdb9474c2c8fe8d65880818f9a', 'eb8bc0d369664cb090537055fd5e9e09', NULL, NULL, 1, '2019-05-07 17:15:54', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f85e2095906c487896fc1992aaf9b120', '1705f3cc19c04570b480a16df5913a2b', 223, 1, 0, '2019-09-05 18:04:11', '2019-09-05 17:16:11', '2019-09-05 18:13:51');
INSERT INTO `oauth2_access_token` VALUES ('f882f8c036b041a89fe46ad22d075d91', '8d2ef9d812c8417793f447e73c7ce774', 27, 2, 1, '2019-06-26 13:06:13', '2019-06-26 12:18:13', '2019-06-26 12:18:13');
INSERT INTO `oauth2_access_token` VALUES ('f8ab601682ff408e8b6c9d31d2119b06', '11aa22bf086d401c9ee00e5d0faff337', 27, 2, 1, '2019-07-12 14:39:28', '2019-07-12 13:51:27', '2019-07-12 13:51:27');
INSERT INTO `oauth2_access_token` VALUES ('f8adb327672d4a0dbca769b55a88ddc1', '823439e53ce54b21a01eb68285301a88', 27, 2, 1, '2019-09-06 16:50:50', '2019-09-06 16:02:49', '2019-09-06 16:02:49');
INSERT INTO `oauth2_access_token` VALUES ('f8df26cc88074a92a271ee10a94eee5d', 'ec62223573b4484aa49901287fce8dfb', 27, 2, 1, '2019-07-15 17:38:28', '2019-07-15 16:50:28', '2019-07-15 16:50:28');
INSERT INTO `oauth2_access_token` VALUES ('f8eaaf8b40274fd7b4be5dd0466f16c9', '68b4757be7ff42139b55c2529240d3ce', 27, 2, 1, '2019-06-21 15:29:39', '2019-06-21 14:41:39', '2019-06-21 14:41:39');
INSERT INTO `oauth2_access_token` VALUES ('f9018b892da44fb1a21cc1efac84f87d', 'a0433fb5c9e4488987c2494f19e1d23c', 27, 2, 1, '2019-07-09 11:52:55', '2019-07-09 11:04:55', '2019-07-09 11:04:55');
INSERT INTO `oauth2_access_token` VALUES ('f906ff88d25648e6a501a793b991f044', 'f7a449eb64d84f968edb66d5eea3258f', NULL, NULL, 1, '2019-03-12 16:26:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f9113d32aed445bfa838907f3f60f547', '6602b4a967934848b98917810d88b46b', 27, 2, 1, '2019-06-01 08:57:49', '2019-06-01 08:09:48', '2019-06-01 08:09:48');
INSERT INTO `oauth2_access_token` VALUES ('f925b20b30424270b9d17927a8ea4ef7', 'ec3160fdee8d4610a3fda6f39d001996', 27, 2, 1, '2019-06-03 19:51:27', '2019-06-03 19:03:27', '2019-06-03 19:03:27');
INSERT INTO `oauth2_access_token` VALUES ('f926eb821be343bbbe42ad44af1d5331', 'e4a696a03eea4745aa349982feb7f3dd', NULL, NULL, 1, '2019-05-09 00:59:47', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f938190bfcda4619affc69bc563d1bf1', '32a09238532149cc9a4973222943e014', 27, 2, 1, '2019-06-16 09:20:23', '2019-06-16 08:32:23', '2019-06-16 08:32:23');
INSERT INTO `oauth2_access_token` VALUES ('f93902672a594122b75ab01d205bfce9', 'e4686a4bbef0489f9515d0fa2f456477', 27, 2, 1, '2019-07-13 11:39:04', '2019-07-13 10:51:04', '2019-07-13 10:51:04');
INSERT INTO `oauth2_access_token` VALUES ('f94a0f3469804d3fb0981e00ede1a6e2', 'e606cea5bedd4da19f098ad015d28f28', NULL, NULL, 1, '2019-04-09 18:41:00', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f96974f9c5ca441eacae6824f6614409', 'ff59b0f67cb34f659219677879b532b1', 27, 2, 1, '2019-09-05 12:39:16', '2019-09-05 11:51:15', '2019-09-05 11:51:15');
INSERT INTO `oauth2_access_token` VALUES ('f96e5104d0d2425fb542a49adcc23432', 'bb0959cea4464780890521c11567db0a', 128, 1, 1, '2019-09-04 19:12:07', '2019-09-04 18:24:06', '2019-09-04 18:24:06');
INSERT INTO `oauth2_access_token` VALUES ('f97c79d1b52b4decb5149738e1e18c1a', 'c860d4b60942473797147a0283827576', 27, 2, 1, '2019-06-18 11:27:22', '2019-06-18 10:39:22', '2019-06-18 10:39:22');
INSERT INTO `oauth2_access_token` VALUES ('f9803e16d04e4c32af98a270bb64b168', '82f812fe64f34e79b6e5a458101cf9a6', 1, 2, 0, '2019-06-20 11:36:47', '2019-06-20 10:48:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('f9945f1878b54e128731031ddc44454d', '64f1f11d8e734b008599c71392dd919b', NULL, NULL, 1, '2019-04-06 15:29:14', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f9aa78a4a96f4af289a1dc8ca7e3c00a', 'c4d99164146847f19921e43e31dfdcf7', NULL, NULL, 1, '2019-05-13 21:10:18', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('f9e5f02a120d4b68bc71b5ebb2ff6651', '22f72aec6ebb4773ae3981be7b6501bb', 27, 2, 1, '2019-08-08 17:30:45', '2019-08-08 16:42:44', '2019-08-08 16:42:44');
INSERT INTO `oauth2_access_token` VALUES ('f9ec44e54c2e47b4831b97ecc4f6c262', 'e2082ae86e6f4e53821c2322cd7656d7', 27, 2, 1, '2019-06-02 23:37:32', '2019-06-02 22:49:32', '2019-06-02 22:49:32');
INSERT INTO `oauth2_access_token` VALUES ('fa02448b7c3a4b319d9146438806cd9d', '9456f67d399b4ca199e122549f8d6e6b', 27, 2, 1, '2019-08-08 15:50:24', '2019-08-08 15:02:23', '2019-08-08 15:02:23');
INSERT INTO `oauth2_access_token` VALUES ('fa03c85b5af44a3c9484f58c5052b427', 'd6e1996199e44a979927a47a89024cea', NULL, NULL, 1, '2019-03-20 20:47:25', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fa0d101e35d84783a2f58d355e2f9588', '68761bb924ba4795b13b004e4031e19d', 27, 2, 1, '2019-05-31 17:27:03', '2019-05-31 16:39:02', '2019-05-31 16:39:02');
INSERT INTO `oauth2_access_token` VALUES ('fa1ac9caa60b46ce981a4bb6f8544a5f', '937277c0464747ce90eda45b296475b3', NULL, NULL, 1, '2019-05-04 17:33:59', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fa1b18853c1a440d862101af9d6f91e1', '990e4595d09e42fca6c466e6c44a133e', 27, 2, 1, '2019-05-28 12:04:04', '2019-05-28 11:16:04', '2019-05-28 11:16:04');
INSERT INTO `oauth2_access_token` VALUES ('fa1d4540549f457eb30cb1bcb5f9512b', '69013f9cf4c745e6a1253db89497171a', NULL, NULL, 1, '2019-05-13 18:31:03', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fa33329523494bae89ce17e92cedda6c', '7a5134f05d72441389d7acb9bfd843b5', 27, 2, 1, '2019-06-18 11:18:15', '2019-06-18 10:30:14', '2019-06-18 10:30:14');
INSERT INTO `oauth2_access_token` VALUES ('fa44a8ff155747ef82acf7593e2412e4', 'e5fec995be0a47919a396bd8092bd35d', 152, 1, 1, '2019-07-02 14:15:55', '2019-07-02 13:27:55', '2019-07-02 13:27:55');
INSERT INTO `oauth2_access_token` VALUES ('fa4bd131154040698b1d3ce45367ae36', '18f1c17a3cff40c2abbb6edd4be245bd', 1, 2, 0, '2019-07-05 11:12:01', '2019-07-05 10:24:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('fa75554a27bd4f43aea35c9666822219', '313b2919e0444c608d7bd9882a1c9374', 27, 2, 1, '2019-07-08 15:51:52', '2019-07-08 15:03:51', '2019-07-08 15:03:51');
INSERT INTO `oauth2_access_token` VALUES ('fa80bc925d244b2bb43d65cf7e949298', '3bb9f6ba984549d5bd13b183bed13bb9', 27, 2, 1, '2019-06-25 12:09:10', '2019-06-25 11:21:09', '2019-06-25 11:21:09');
INSERT INTO `oauth2_access_token` VALUES ('fa8fbe427aea45eeb4dfe282ad9f8e34', '95b48f14841b4a00a5228e787a073d57', NULL, NULL, 1, '2019-03-10 04:22:17', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fa92251e8ab34dc8af05cce355a8f8d4', '1df3fb5ddf654549b32a6b104fe87cdf', NULL, NULL, 1, '2019-03-11 07:30:13', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('faa1fd0b12e84838966ac8c9b029c635', '594aab134b4e463fa0c4c92426ed9c1e', 27, 2, 1, '2019-05-31 23:10:26', '2019-05-31 22:22:25', '2019-05-31 22:22:25');
INSERT INTO `oauth2_access_token` VALUES ('fac15483c96644b9bd1074e9f61ac4a4', 'b6fab3bfba914bbd8f8035a1d86fb45e', 27, 2, 1, '2019-06-06 14:58:06', '2019-06-06 14:10:06', '2019-06-06 14:10:06');
INSERT INTO `oauth2_access_token` VALUES ('fac24b4c11a3486e9ded861eb3e863d6', 'f5bc77acac8847afbddbf0b861f9d587', 1, 2, 0, '2019-09-04 21:27:47', '2019-09-04 20:39:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('fac9dee3b0c24219a4bcfe752e92d50a', '8ce70b197774491bae139a9bbd739077', NULL, NULL, 1, '2019-05-08 09:25:51', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fad39268b4cf43d59ede4bb09e86ef7c', 'bae4139f35ce4dd09ea660c45ebbc07f', 27, 2, 1, '2019-07-05 11:36:21', '2019-07-05 10:48:21', '2019-07-05 10:48:21');
INSERT INTO `oauth2_access_token` VALUES ('fae56a67ede74bc193b04e484f25d996', '39716c1039ff46e39826f742904a456e', 27, 2, 1, '2019-08-28 17:20:15', '2019-08-28 16:32:15', '2019-08-28 16:32:15');
INSERT INTO `oauth2_access_token` VALUES ('fb0700495d2d45ba9c98ecceccb3cba1', 'c7f72b19363b4d1889bfd774ca50a32e', NULL, NULL, 1, '2019-04-05 17:07:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fb3f56225a0941f180116caee828f8bd', '548b3cfb33224375ad7136623d5e9fe3', 27, 2, 1, '2019-06-07 10:34:26', '2019-06-07 09:46:25', '2019-06-07 09:46:25');
INSERT INTO `oauth2_access_token` VALUES ('fb5e2300ed0e41f793b632368f1fa137', '8c316f0c21cf46b58041fa3bf45927c5', NULL, NULL, 1, '2019-05-05 21:05:42', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fb6ae3f25691499bad79d0d8c31fc80c', 'a02b3959b28340feb6d3444a33ef55b5', 27, 2, 1, '2019-05-31 18:11:55', '2019-05-31 17:23:54', '2019-05-31 17:23:54');
INSERT INTO `oauth2_access_token` VALUES ('fb8911550f7f42cebcfe415db400be2c', 'dfe60e5efb174f68bf45154c6266f9f3', 27, 2, 1, '2019-06-03 15:30:03', '2019-06-03 14:42:02', '2019-06-03 14:42:02');
INSERT INTO `oauth2_access_token` VALUES ('fb9a5545afd7430492cefea2c41a2667', '18a075e4a4f942a892c090667144a741', 27, 2, 1, '2019-06-06 17:56:24', '2019-06-06 17:08:24', '2019-06-06 17:08:24');
INSERT INTO `oauth2_access_token` VALUES ('fba47695a1e344e981696d4b1019a849', '5182c359662f49cc8251b2d5b4760f4b', NULL, NULL, 1, '2019-05-07 22:10:32', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fbb2fde035404a31a63c63a5abead93d', 'fb809803ba584770b758032cace485fc', 27, 2, 1, '2019-06-11 17:02:22', '2019-06-11 16:14:22', '2019-06-11 16:14:22');
INSERT INTO `oauth2_access_token` VALUES ('fbbb68e54cc4433fa9bea353dcc5dac0', 'a0c0b2021c094fd88fa401e609b00c85', 27, 2, 1, '2019-07-02 14:39:02', '2019-07-02 13:51:01', '2019-07-02 13:51:01');
INSERT INTO `oauth2_access_token` VALUES ('fbbdb56abc0d4a13ba49d8bc0b72c9a8', 'ef9d72ecfcf7431a978cf357ce54dbb1', 27, 2, 1, '2019-06-22 22:19:14', '2019-06-22 21:31:14', '2019-06-22 21:31:14');
INSERT INTO `oauth2_access_token` VALUES ('fbc55b690b9c4ed0a110402708c73324', 'f53edee4099c43c090cb02609f5a67b3', 27, 2, 1, '2019-08-13 10:38:04', '2019-08-13 09:50:03', '2019-08-13 09:50:03');
INSERT INTO `oauth2_access_token` VALUES ('fbcfc3d4cebf4cf58699370156ab263a', 'f8ae3b3f410140958392b5bcf7e68618', 27, 2, 1, '2019-06-18 14:53:49', '2019-06-18 14:05:49', '2019-06-18 14:05:49');
INSERT INTO `oauth2_access_token` VALUES ('fbdfeed957f3459c81c97f34e35e175b', '0a79524cda2d49fcab9df4a030a03375', 27, 2, 1, '2019-06-01 10:55:19', '2019-06-01 10:07:18', '2019-06-01 10:07:18');
INSERT INTO `oauth2_access_token` VALUES ('fbece422fb8042f7b006028ae5986d1b', 'aeb17d0b50dd43b68c08333a8eee17fb', 27, 2, 1, '2019-08-02 22:42:31', '2019-08-02 21:54:31', '2019-08-02 21:54:31');
INSERT INTO `oauth2_access_token` VALUES ('fc0484400862435c8cee2d17ef39fd12', 'd329e5927c5d49e0838489b391a190da', 27, 2, 1, '2019-06-11 17:48:55', '2019-06-11 17:00:55', '2019-06-11 17:00:55');
INSERT INTO `oauth2_access_token` VALUES ('fc1087bdb922458090d2774906956be0', 'bb9246e573f64ddfa7df427b7dce24c0', 27, 2, 1, '2019-06-01 15:58:12', '2019-06-01 15:10:12', '2019-06-01 15:10:12');
INSERT INTO `oauth2_access_token` VALUES ('fc3cfa79b3734e329f7b75826496be64', '740e7ab4c56e4e8c9a08cd1d91bf9ee8', 1, 1, 1, '2019-05-17 01:11:14', '2019-05-17 00:23:14', '2019-05-17 00:23:14');
INSERT INTO `oauth2_access_token` VALUES ('fc3e724bd42c44afb944580782dc3e2d', '589bdb1180e24ea38b2fb3d87a1e24c6', 27, 2, 1, '2019-07-05 10:37:18', '2019-07-05 09:49:18', '2019-07-05 09:49:18');
INSERT INTO `oauth2_access_token` VALUES ('fc44e94668b941b796fa44505727e336', '2a4bd0a0bdf044ef98da5a31ff31ea03', 27, 2, 1, '2019-07-22 13:56:12', '2019-07-22 13:08:11', '2019-07-22 13:08:11');
INSERT INTO `oauth2_access_token` VALUES ('fc5933f2da444bf3ab41c90a12538e31', '3715079c75294649ba2f103f06ed11bf', NULL, NULL, 1, '2019-05-12 23:34:58', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fc6d31ecf7fd42febfff61e7255b1925', '639e3dc3cfa044d8aec46f433d2c0e6c', 27, 2, 1, '2019-07-29 14:47:47', '2019-07-29 13:59:46', '2019-07-29 13:59:46');
INSERT INTO `oauth2_access_token` VALUES ('fc72fe17de73441da028303be71fc62a', '0f751a2f712841029be1d927b7f1164c', 27, 2, 1, '2019-06-27 17:30:38', '2019-06-27 16:42:37', '2019-06-27 16:42:37');
INSERT INTO `oauth2_access_token` VALUES ('fc8e7324bfc0446a8cef63567bc1b507', 'e9319d2ed9394d66a84a86815244de53', 27, 2, 1, '2019-06-02 12:11:25', '2019-06-02 11:23:24', '2019-06-02 11:23:24');
INSERT INTO `oauth2_access_token` VALUES ('fca208e8ac6f4a328b101c447e830b5b', '9c692fb67a964661a0ea3bbc4ecbf723', 27, 2, 1, '2019-08-01 12:04:58', '2019-08-01 11:16:58', '2019-08-01 11:16:58');
INSERT INTO `oauth2_access_token` VALUES ('fcb47be37ff24cfa8f4be66a8483bfe7', '394ab4c9a1b94762883002d9881c9466', 27, 2, 1, '2019-05-31 21:51:28', '2019-05-31 21:03:27', '2019-05-31 21:03:27');
INSERT INTO `oauth2_access_token` VALUES ('fcbe1f8662d94500a367659ecb1a2bcf', '3774418858c444fd9e29b6a77d9ff9ad', 27, 2, 1, '2019-05-23 14:30:03', '2019-05-23 13:42:02', '2019-05-23 13:42:02');
INSERT INTO `oauth2_access_token` VALUES ('fcc2d2b0627c4a71a979259be673d2b8', 'feabc92363f7479392a75310abf6a542', 27, 2, 1, '2019-06-20 12:27:32', '2019-06-20 11:39:32', '2019-06-20 11:39:32');
INSERT INTO `oauth2_access_token` VALUES ('fccdc5cde29b4b14b2a5867a68130fd7', '14a5438a3bf44a61bdfb900b30764c03', 27, 2, 1, '2019-07-27 11:41:22', '2019-07-27 10:53:21', '2019-07-27 10:53:21');
INSERT INTO `oauth2_access_token` VALUES ('fcd00326a99e4fe683183aed9e0852c4', '778475e8fe2b4896a06328da97351a3e', 27, 2, 1, '2019-08-21 09:49:00', '2019-08-21 09:01:00', '2019-08-21 09:01:00');
INSERT INTO `oauth2_access_token` VALUES ('fcda5ce33acf40cc92993a61d7384524', '029ce510eed546fcb1aa5f7263e5ed2a', 27, 2, 1, '2019-06-26 11:55:38', '2019-06-26 11:07:37', '2019-06-26 11:07:37');
INSERT INTO `oauth2_access_token` VALUES ('fcf79918f903436e95b795fb4e13dd76', 'ffc110b447244cf8b4ea30498b712125', 1, 2, 0, '2019-06-21 16:29:49', '2019-06-21 15:41:49', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('fd0d7529dfa64a2c94c93c4015c49529', '335fbf23df554e2ea80f8a3fe30fe5c9', 27, 2, 1, '2019-07-08 23:54:52', '2019-07-08 23:06:51', '2019-07-08 23:06:51');
INSERT INTO `oauth2_access_token` VALUES ('fd18d242ea0a48d79adc19f20002da6a', '830ed374ecdf49a6878ba3af1bdbc345', NULL, NULL, 1, '2019-05-09 15:18:28', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fd3427d0edc9452598cf0052dfe0c689', '846721b37a794737b01249d935076f37', 27, 2, 1, '2019-07-29 17:19:33', '2019-07-29 16:31:33', '2019-07-29 16:31:33');
INSERT INTO `oauth2_access_token` VALUES ('fd4f5bc2316a4130b82922d3d98978e4', '72c0173c17da430b9c5692f6bf651519', 27, 2, 1, '2019-07-18 13:05:45', '2019-07-18 12:17:44', '2019-07-18 12:17:44');
INSERT INTO `oauth2_access_token` VALUES ('fd515aeee03e4851b0e3419e4dafe7a0', '81ae9ffdbb8c487bb0a4d0b99e9d42db', 27, 2, 1, '2019-06-13 12:21:20', '2019-06-13 11:33:20', '2019-06-13 11:33:20');
INSERT INTO `oauth2_access_token` VALUES ('fd745c4f50cd4a66addcaf2a2f40f406', 'a812abd9de5d49038d1ee255a18381d9', 27, 2, 1, '2019-05-24 19:12:40', '2019-05-24 18:24:40', '2019-05-24 18:24:40');
INSERT INTO `oauth2_access_token` VALUES ('fd7cc4bb3c3c40999eefe3385c059d74', 'f8f5eabe71d74d94b2c7e78bd547f95f', NULL, NULL, 1, '2019-04-22 20:30:55', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fd83f4161a4a467493468015800ae12a', '7983a9abe7794daab4e65373d2c67483', 1, 2, 0, '2019-07-12 11:05:27', '2019-07-12 10:17:27', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('fd8d54a1b68a477187025da14312014f', '8fcbf17fbe6a4d8680ec07b6ce719b0a', 1, 2, 0, '2019-07-05 11:05:05', '2019-07-05 10:17:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('fd8ff7f933b1453a82f3f99fcb618c84', '530f8c07ab57424d8e5013abc54ad44e', NULL, NULL, 0, '2019-03-03 22:55:34', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fd9af32354f74daeb48f76b7a8f2b1ee', 'e2f1fcffa7c1425bb84e156d2af89e20', 27, 2, 1, '2019-06-14 15:56:43', '2019-06-14 15:08:42', '2019-06-14 15:08:42');
INSERT INTO `oauth2_access_token` VALUES ('fda19c7b32fc45039e31d34c4c5c191b', '151d0d8aa53c4220922dc1b7fa7b2fdd', 27, 2, 1, '2019-07-12 14:58:20', '2019-07-12 14:10:20', '2019-07-12 14:10:20');
INSERT INTO `oauth2_access_token` VALUES ('fda500cfc7c34468b0058ee11bbc29ef', 'de5658ad3f4340f69107d203ede451df', 27, 2, 1, '2019-05-23 12:11:59', '2019-05-23 11:23:59', '2019-05-23 11:23:59');
INSERT INTO `oauth2_access_token` VALUES ('fda533602b9e4345a26babd14b7f1632', '1baf4e13d4f34e2a8d2efe9116214133', 27, 2, 1, '2019-07-11 09:54:44', '2019-07-11 09:06:43', '2019-07-11 09:06:43');
INSERT INTO `oauth2_access_token` VALUES ('fdacdbcf67c644febececa733724e991', 'b39ec5b645ba48a49c2d4c66f5970e59', 27, 2, 1, '2019-06-04 12:09:22', '2019-06-04 11:21:21', '2019-06-04 11:21:21');
INSERT INTO `oauth2_access_token` VALUES ('fdc4a04f345c48c0b464f1f4ee6f2e5b', 'bcbd1ce93a1144148d6c66d9c9f58242', 27, 2, 1, '2019-08-21 17:49:15', '2019-08-21 17:01:14', '2019-08-21 17:01:14');
INSERT INTO `oauth2_access_token` VALUES ('fdc6c3467bcf403fab03fc1d695b18d2', 'a1f7856e95b94d678da95937a2b8614b', 27, 2, 1, '2019-06-03 09:29:21', '2019-06-03 08:41:21', '2019-06-03 08:41:21');
INSERT INTO `oauth2_access_token` VALUES ('fdda8dfdea59475c9b7a910c87bf709d', '680e80d565e24e44a54df93f740d13d8', 1, 2, 0, '2019-07-15 23:59:24', '2019-07-15 23:11:23', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('fddb7f8384f64233a34756529d1f9333', '0b6d9b616fa242089d1fb7d1956b1cb2', NULL, NULL, 1, '2019-03-19 03:04:37', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fddc3741298148adbf9353ad113fbba4', 'd06eadfd986c439d8878a3f3d12867d5', NULL, NULL, 1, '2019-04-29 12:48:25', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fdf1e74c36bf44e599f990c6e263501e', 'd38bedfb661f407db22386ea5b6c768f', 27, 2, 1, '2019-07-08 16:02:16', '2019-07-08 15:14:16', '2019-07-08 15:14:16');
INSERT INTO `oauth2_access_token` VALUES ('fe213b0eb62f4c308c305ca852564afc', 'bf72519d325542b7a0b81e9b0f5bde36', 27, 2, 1, '2019-08-29 01:09:54', '2019-08-29 00:21:53', '2019-08-29 00:21:53');
INSERT INTO `oauth2_access_token` VALUES ('fe2209dad5504210b93d95cec6c88ac4', '0a2b6957380143acbe672c1eb3a49a2c', 27, 2, 1, '2019-07-25 16:45:35', '2019-07-25 15:57:35', '2019-07-25 15:57:35');
INSERT INTO `oauth2_access_token` VALUES ('fe291b39143242d9b8e51cc505be4845', '9d1f70f432434b6aaf32f85456f436d1', 27, 2, 1, '2019-06-10 10:44:41', '2019-06-10 09:56:41', '2019-06-10 09:56:41');
INSERT INTO `oauth2_access_token` VALUES ('fe321b9b08fa4ccd829ec88961c1dde7', 'cc8a563fe29c4ad3a5ead3fba7b80906', NULL, NULL, 1, '2019-05-05 18:05:01', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fe372d63867c43f4aff7cf61650bdea3', '7d2ee6f682e94ccd9f63681d181c063b', 1, 2, 0, '2019-08-21 18:50:02', '2019-08-21 18:02:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('fe38217daa884d37920d159e9941627e', '8378d69bfad64e36b54e93ea1bceef05', 27, 2, 1, '2019-08-16 17:08:47', '2019-08-16 16:20:46', '2019-08-16 16:20:46');
INSERT INTO `oauth2_access_token` VALUES ('fe4efc03cd834affa319d334cb4f2e14', 'efac91c37393427baadb3d902015b4e6', 27, 2, 1, '2019-07-12 10:33:24', '2019-07-12 09:45:24', '2019-07-12 09:45:24');
INSERT INTO `oauth2_access_token` VALUES ('fe606b147c0941de8b0b686125f7e283', '21c5fcf663ea4462a2beb9909c2c4f50', 27, 2, 1, '2019-06-24 10:50:08', '2019-06-24 10:02:08', '2019-06-24 10:02:08');
INSERT INTO `oauth2_access_token` VALUES ('fe8812198748494983ca5974d9564043', '2f7f8dc82b9d4081ab84504f3f26cd6f', NULL, NULL, 0, '2019-03-15 08:35:19', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('fe8a9b4526a94f1b9b68803e33ccb2c5', '2bd73bcc65d34ef6aeac9abfe01caf50', 27, 2, 1, '2019-05-22 10:57:11', '2019-05-22 10:09:10', '2019-05-22 10:09:10');
INSERT INTO `oauth2_access_token` VALUES ('fe95b659f8a14048963d321b837ba068', '658096c3601d42de9dbd4d9bf1fc4662', 27, 2, 1, '2019-07-09 18:24:38', '2019-07-09 17:36:37', '2019-07-09 17:36:37');
INSERT INTO `oauth2_access_token` VALUES ('fed57238321c419d95a04ab417691430', '827792203dab44f5ba3c8c4c70006426', 27, 2, 1, '2019-06-27 17:47:54', '2019-06-27 16:59:54', '2019-06-27 16:59:54');
INSERT INTO `oauth2_access_token` VALUES ('feeab01dcb05463fab5586e01f046bb4', '2d310df612d945e78a0df66482ffbe88', 27, 2, 1, '2019-09-07 11:39:41', '2019-09-07 10:51:40', '2019-09-07 10:51:40');
INSERT INTO `oauth2_access_token` VALUES ('fef22fa062f04da78cbcd3a0e0d9e77c', '47b9834efddd4cb0aa041f94a58c149e', 27, 2, 1, '2019-06-24 14:39:27', '2019-06-24 13:51:27', '2019-06-24 13:51:27');
INSERT INTO `oauth2_access_token` VALUES ('fef6f71f6eb342a3a96893ad8413ad7b', '28f3697342504533bd08ac5f03b428ec', 148, 1, 1, '2019-07-01 23:52:13', '2019-07-01 23:04:12', '2019-07-01 23:04:12');
INSERT INTO `oauth2_access_token` VALUES ('ff0107275fd14e5ba2e40a98f7d46793', '5fb698e5dd1041e19ee498356da0b27a', 27, 2, 1, '2019-06-06 15:13:37', '2019-06-06 14:25:36', '2019-06-06 14:25:36');
INSERT INTO `oauth2_access_token` VALUES ('ff20e7d5645a4d66ab7230f1005ad499', 'ba1fa4c35bc148f3a8ad8b73ef8101a5', 27, 2, 1, '2019-07-12 15:20:41', '2019-07-12 14:32:41', '2019-07-12 14:32:41');
INSERT INTO `oauth2_access_token` VALUES ('ff2d15f70d274ad4b7f2b7d0a0bd9f0b', '810060c3fe1b4b8b83383a714498b855', 27, 2, 1, '2019-06-01 23:08:53', '2019-06-01 22:20:53', '2019-06-01 22:20:53');
INSERT INTO `oauth2_access_token` VALUES ('ff31f10143b44418b7819714e6e0f047', 'b404af2073464cadb77beab09d50ea36', 27, 2, 1, '2019-06-20 10:02:53', '2019-06-20 09:14:53', '2019-06-20 09:14:53');
INSERT INTO `oauth2_access_token` VALUES ('ff3e680114cc4edca8464dc3ac3afe10', '59cd027aa47942a1ac3419a7e338fcf0', NULL, NULL, 1, '2019-05-07 23:26:11', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ff65eaa004954e7b89732f40726ddfe3', '1eb7ecff47d745bda64ed50099475e0d', NULL, NULL, 1, '2019-03-22 15:07:50', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ff763bce36bb4f22850a0de0e58dbb52', '8a44c022eaa548cab513099c62848d06', 27, 2, 1, '2019-09-06 12:45:41', '2019-09-06 11:57:40', '2019-09-06 11:57:40');
INSERT INTO `oauth2_access_token` VALUES ('ff87a49ff51342dcbe48d0db0b1392e9', 'aae014d332554497aae6cf9bcddd8805', 27, 2, 1, '2019-08-23 16:54:42', '2019-08-23 16:06:42', '2019-08-23 16:06:42');
INSERT INTO `oauth2_access_token` VALUES ('ff8b3e9da6f743e48322c287cd372da4', '3ccdd89c10834655a5c039f6811b121a', 27, 2, 1, '2019-05-31 17:39:06', '2019-05-31 16:51:05', '2019-05-31 16:51:05');
INSERT INTO `oauth2_access_token` VALUES ('ffba6315f248452185fc0f28e56779a8', '33d5fa76e20547f08635989f8f551d5b', 1, 2, 0, '2019-05-26 17:18:37', '2019-05-26 16:30:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_access_token` VALUES ('ffc8b8d4cc9e499e8cb06b60878098d3', 'c3a066ab1a094d21b776159b45a220ca', NULL, NULL, 1, '2019-03-31 00:45:04', NULL, '2019-05-16 11:07:31');
INSERT INTO `oauth2_access_token` VALUES ('ffcddc31e5754d0397d3bc8fdd597b5e', '33b637450b064aeca5aea0bd7c5f4350', 27, 2, 1, '2019-07-03 16:41:44', '2019-07-03 15:53:44', '2019-07-03 15:53:44');
INSERT INTO `oauth2_access_token` VALUES ('ffdbbba454f34241a5b05725bbbe33cc', 'c6b3f578365b4ebd8780cf862498b941', 27, 2, 1, '2019-08-20 20:46:14', '2019-08-20 19:58:13', '2019-08-20 19:58:13');
INSERT INTO `oauth2_access_token` VALUES ('ffec3254c6294339af1680b953b5b9e3', '54dfc15f7b414619808135272bb7e001', 27, 2, 1, '2019-06-08 10:16:54', '2019-06-08 09:28:54', '2019-06-08 09:28:54');
COMMIT;

-- ----------------------------
-- Table structure for oauth2_refresh_token
-- ----------------------------
DROP TABLE IF EXISTS `oauth2_refresh_token`;
CREATE TABLE `oauth2_refresh_token` (
  `id` varchar(32) NOT NULL,
  `user_id` int(11) DEFAULT NULL COMMENT '用户编号',
  `user_type` tinyint(255) DEFAULT NULL COMMENT '用户类型',
  `valid` tinyint(4) DEFAULT NULL,
  `expires_time` datetime DEFAULT NULL,
  `create_time` datetime DEFAULT CURRENT_TIMESTAMP,
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '最后更新时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Records of oauth2_refresh_token
-- ----------------------------
BEGIN;
INSERT INTO `oauth2_refresh_token` VALUES ('0003d19d5df74b6c85004f303c74c027', 27, 2, 1, '2019-08-08 07:50:47', '2019-08-07 19:50:46', '2019-08-07 19:50:46');
INSERT INTO `oauth2_refresh_token` VALUES ('001112624ead422995e4ff2ff35598b7', NULL, NULL, 1, '2019-05-08 03:34:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0011ab788ca548e1be9b593b0c954304', 27, 2, 1, '2019-06-13 04:31:04', '2019-06-12 16:31:03', '2019-06-12 16:31:03');
INSERT INTO `oauth2_refresh_token` VALUES ('0011dd3d90094f19bbe57ac1719275ca', 27, 2, 1, '2019-08-08 06:52:51', '2019-08-07 18:52:50', '2019-08-07 18:52:50');
INSERT INTO `oauth2_refresh_token` VALUES ('001f07f992f44120b92afae706dae2bb', 27, 2, 1, '2019-08-10 22:57:02', '2019-08-10 10:57:01', '2019-08-10 10:57:01');
INSERT INTO `oauth2_refresh_token` VALUES ('002c8c5b2cc3426785c8a61a7e33d545', 27, 2, 1, '2019-08-04 08:31:11', '2019-08-03 20:31:10', '2019-08-03 20:31:10');
INSERT INTO `oauth2_refresh_token` VALUES ('002d83ec6c574f2e9502b59ca6dffa16', 27, 2, 1, '2019-06-11 22:28:39', '2019-06-11 10:28:39', '2019-06-11 10:28:39');
INSERT INTO `oauth2_refresh_token` VALUES ('0038ab4a0ef14bb689ef8421e7521db3', 27, 2, 1, '2019-06-23 00:47:37', '2019-06-22 12:47:36', '2019-06-22 12:47:36');
INSERT INTO `oauth2_refresh_token` VALUES ('004a1caecf9a4c518f1ce252d258ae83', 27, 2, 1, '2019-06-02 18:14:12', '2019-06-02 06:14:11', '2019-06-02 06:14:11');
INSERT INTO `oauth2_refresh_token` VALUES ('004da14fdbae4aaa9274b0bbe9682f7c', 27, 2, 1, '2019-05-28 21:20:21', '2019-05-28 09:20:20', '2019-05-28 09:20:20');
INSERT INTO `oauth2_refresh_token` VALUES ('004f710b82fe4c028276bac18aa0fd59', 27, 2, 1, '2019-06-25 09:24:39', '2019-06-24 21:24:39', '2019-06-24 21:24:39');
INSERT INTO `oauth2_refresh_token` VALUES ('007f60a32a514fffba89d5063bac494e', 169, 1, 1, '2019-07-12 00:32:56', '2019-07-11 12:32:55', '2019-07-11 12:32:55');
INSERT INTO `oauth2_refresh_token` VALUES ('008b76d0a0eb45c1b381b87f4dbda821', NULL, NULL, 0, '2019-03-05 17:52:10', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0093654120424f848b1dc716b5444b96', 27, 2, 1, '2019-06-26 05:42:30', '2019-06-25 17:42:30', '2019-06-25 17:42:30');
INSERT INTO `oauth2_refresh_token` VALUES ('0097cce2e3cd46ceaae40b19af2e2b3f', 27, 2, 1, '2019-06-29 23:25:28', '2019-06-29 11:25:28', '2019-06-29 11:25:28');
INSERT INTO `oauth2_refresh_token` VALUES ('00bc9f3fa5d64ae3bfb1905119096638', 27, 2, 1, '2019-07-11 09:56:07', '2019-07-10 21:56:07', '2019-07-10 21:56:07');
INSERT INTO `oauth2_refresh_token` VALUES ('00f06357cb6144238aabe0b3ac1eaf59', 27, 2, 1, '2019-06-02 11:38:12', '2019-06-01 23:38:12', '2019-06-01 23:38:12');
INSERT INTO `oauth2_refresh_token` VALUES ('0106f4bfa30d49ebb6c15269c9b76c41', 27, 2, 1, '2019-05-28 03:22:04', '2019-05-27 15:22:04', '2019-05-27 15:22:04');
INSERT INTO `oauth2_refresh_token` VALUES ('010ba88f6ebd4cd29f04a6416d0a176a', NULL, NULL, 1, '2019-03-21 11:15:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('011401e6d4d94577abe06804e2504136', 27, 2, 1, '2019-07-13 02:42:12', '2019-07-12 14:42:11', '2019-07-12 14:42:11');
INSERT INTO `oauth2_refresh_token` VALUES ('0136a42fbe074faf85dd26b9ff30509b', 1, 2, 0, '2019-07-21 22:40:26', '2019-07-21 10:40:25', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('013c9967bbac4d04963b1ac5c99e2bda', NULL, NULL, 1, '2019-03-10 15:26:58', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('016798b9953146f2b1d6299939ca6cbf', 27, 2, 1, '2019-09-06 22:21:04', '2019-09-06 10:21:04', '2019-09-06 10:21:04');
INSERT INTO `oauth2_refresh_token` VALUES ('018683e62b9f4177b3ca1c5ac016f8ac', 27, 2, 1, '2019-07-12 22:15:17', '2019-07-12 10:15:16', '2019-07-12 10:15:16');
INSERT INTO `oauth2_refresh_token` VALUES ('01996333469a452ab23a5cd48159022e', NULL, NULL, 1, '2019-05-07 01:01:03', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('01a18ca31aba4bab8829e8d6391539a7', 27, 2, 1, '2019-06-02 23:59:17', '2019-06-02 11:59:16', '2019-06-02 11:59:16');
INSERT INTO `oauth2_refresh_token` VALUES ('01ad337519c64e56b77b393fd602fa8a', 27, 2, 1, '2019-07-30 04:45:54', '2019-07-29 16:45:53', '2019-07-29 16:45:53');
INSERT INTO `oauth2_refresh_token` VALUES ('01bf0aea8345485ebb90618521e3a76e', 27, 2, 1, '2019-05-19 12:44:01', '2019-05-19 00:44:01', '2019-05-19 00:44:01');
INSERT INTO `oauth2_refresh_token` VALUES ('01c7ad52334a49e0858114edcbdcf5d9', 27, 2, 1, '2019-06-25 21:47:30', '2019-06-25 09:47:30', '2019-06-25 09:47:30');
INSERT INTO `oauth2_refresh_token` VALUES ('01cdbcd89f9f444881816b16fad20d39', NULL, NULL, 1, '2019-05-10 20:59:13', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('01df3e8b3c764a89a8df96a60c604122', NULL, NULL, 0, '2019-02-27 18:25:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('01e202fbf9df4b249546adea58ed9593', NULL, NULL, 1, '2019-03-15 09:16:25', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('01f80d8433f741f0a2747eeac2108a14', NULL, NULL, 1, '2019-04-24 21:25:07', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('02470e289f70450d99e0d542175ed041', 27, 2, 1, '2019-07-28 03:50:41', '2019-07-27 15:50:40', '2019-07-27 15:50:40');
INSERT INTO `oauth2_refresh_token` VALUES ('024f69e843824ac28d44f10b8f53d70f', NULL, NULL, 1, '2019-03-19 13:13:09', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0260bb3f960a47339721b22630e2d4f9', 27, 2, 1, '2019-07-20 09:33:50', '2019-07-19 21:33:50', '2019-07-19 21:33:50');
INSERT INTO `oauth2_refresh_token` VALUES ('02663ec8f5ea448eb9fa4cfad3fd9b7f', 27, 2, 1, '2019-06-18 04:39:34', '2019-06-17 16:39:33', '2019-06-17 16:39:33');
INSERT INTO `oauth2_refresh_token` VALUES ('028ca9ae967d426590c95a306c80510b', NULL, NULL, 1, '2019-04-23 07:42:32', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('029ce510eed546fcb1aa5f7263e5ed2a', 27, 2, 1, '2019-06-26 23:07:38', '2019-06-26 11:07:37', '2019-06-26 11:07:37');
INSERT INTO `oauth2_refresh_token` VALUES ('02a59ea295644d2bbe7287ae70715a85', 157, 1, 1, '2019-07-06 03:23:13', '2019-07-05 15:23:12', '2019-07-05 15:23:12');
INSERT INTO `oauth2_refresh_token` VALUES ('02b18c96de68490eb8ade0e35db2e9e2', 27, 2, 1, '2019-07-21 06:26:20', '2019-07-20 18:26:19', '2019-07-20 18:26:19');
INSERT INTO `oauth2_refresh_token` VALUES ('02b304e237734f21afd658497548f97e', 27, 2, 1, '2019-07-26 14:53:01', '2019-07-26 02:53:01', '2019-07-26 02:53:01');
INSERT INTO `oauth2_refresh_token` VALUES ('02be0bb4fa3245798acadd25c98c7e4f', 168, 1, 1, '2019-07-11 23:07:21', '2019-07-11 11:07:20', '2019-07-11 11:07:20');
INSERT INTO `oauth2_refresh_token` VALUES ('02e966ca04174b64b1ff328a4acbd552', 27, 2, 1, '2019-07-03 04:05:32', '2019-07-02 16:05:32', '2019-07-02 16:05:32');
INSERT INTO `oauth2_refresh_token` VALUES ('02f186198c934015bc17f11579741072', 27, 2, 1, '2019-07-19 05:12:36', '2019-07-18 17:12:35', '2019-07-18 17:12:35');
INSERT INTO `oauth2_refresh_token` VALUES ('02fe7c8b66384e7c8759dbd36264d212', 27, 2, 1, '2019-08-16 02:23:38', '2019-08-15 14:23:37', '2019-08-15 14:23:37');
INSERT INTO `oauth2_refresh_token` VALUES ('0319ab2dd47c4de69be3c8efdb43519e', 1, 2, 0, '2019-05-17 08:22:10', '2019-05-16 20:22:09', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('031f97cf7d164e8cb1303002c1532667', 27, 2, 1, '2019-06-04 22:09:49', '2019-06-04 10:09:48', '2019-06-04 10:09:48');
INSERT INTO `oauth2_refresh_token` VALUES ('03294d7d15054b34b2920a35048ee1fd', 147, 1, 1, '2019-07-02 09:43:34', '2019-07-01 21:43:33', '2019-07-01 21:43:33');
INSERT INTO `oauth2_refresh_token` VALUES ('033d6bf5b9aa42fdbcf266123662bfd6', 27, 2, 1, '2019-06-28 10:35:02', '2019-06-27 22:35:01', '2019-06-27 22:35:01');
INSERT INTO `oauth2_refresh_token` VALUES ('033fa8af8cf34638b03516f132e09193', 27, 2, 1, '2019-08-22 05:01:02', '2019-08-21 17:01:02', '2019-08-21 17:01:02');
INSERT INTO `oauth2_refresh_token` VALUES ('03445adbaef24672b60a59afc1390bc9', 27, 2, 1, '2019-06-18 22:48:43', '2019-06-18 10:48:42', '2019-06-18 10:48:42');
INSERT INTO `oauth2_refresh_token` VALUES ('03480738d9854cfe80afae3420cd3b2e', NULL, NULL, 1, '2019-05-10 04:17:40', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('035362413ea64c8eac4535501bbb32ab', NULL, NULL, 1, '2019-05-13 04:17:13', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('037ed8ab3dcc4df4ae7002e1514ced86', 27, 2, 1, '2019-08-20 11:20:09', '2019-08-19 23:20:08', '2019-08-19 23:20:08');
INSERT INTO `oauth2_refresh_token` VALUES ('038014d9f48a4a45a7d2231451c17dca', 183, 1, 1, '2019-07-28 11:48:06', '2019-07-27 23:48:06', '2019-07-27 23:48:06');
INSERT INTO `oauth2_refresh_token` VALUES ('03a1d4b488ca4426b8b5fdadb6b04246', 27, 2, 1, '2019-07-05 09:09:13', '2019-07-04 21:09:12', '2019-07-04 21:09:12');
INSERT INTO `oauth2_refresh_token` VALUES ('03a38bac9bbd451394bacbbc3ae92267', 27, 2, 1, '2019-07-19 05:06:31', '2019-07-18 17:06:31', '2019-07-18 17:06:31');
INSERT INTO `oauth2_refresh_token` VALUES ('03aa8384eb8f4dcb99549976c49293f8', 131, 1, 1, '2019-06-22 02:10:56', '2019-06-21 14:10:56', '2019-06-21 14:10:56');
INSERT INTO `oauth2_refresh_token` VALUES ('03acec06817c4058b9f35243a86bb372', 27, 2, 1, '2019-08-03 09:29:19', '2019-08-02 21:29:18', '2019-08-02 21:29:18');
INSERT INTO `oauth2_refresh_token` VALUES ('03b6c115695742c8b0ddaed3909e0f41', 27, 2, 1, '2019-07-08 04:10:45', '2019-07-07 16:10:45', '2019-07-07 16:10:45');
INSERT INTO `oauth2_refresh_token` VALUES ('03b711ef78f346f68569713426d43f28', 1, 2, 0, '2019-07-19 21:03:32', '2019-07-19 09:03:32', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('03cc052498fe4dc6bba72ce09a62fe88', NULL, NULL, 1, '2019-05-16 02:40:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('03d07a56ad3d436b8d641c15b0980008', NULL, NULL, 1, '2019-05-14 23:45:40', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('03e211e8705642a4a28179cc028177f8', 27, 2, 1, '2019-08-30 08:00:56', '2019-08-29 20:00:56', '2019-08-29 20:00:56');
INSERT INTO `oauth2_refresh_token` VALUES ('03f72bbd207743e48f73832f513210dc', 27, 2, 1, '2019-08-11 02:15:03', '2019-08-10 14:15:03', '2019-08-10 14:15:03');
INSERT INTO `oauth2_refresh_token` VALUES ('04083b80118d451aba4f0aa9b62de7ad', NULL, NULL, 0, '2019-03-05 16:45:37', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('042044f66b444729b7a3f28b19ea82c4', 27, 2, 1, '2019-06-03 10:26:18', '2019-06-02 22:26:17', '2019-06-02 22:26:17');
INSERT INTO `oauth2_refresh_token` VALUES ('043c99d4288847ff97bae86dc18c1f07', 27, 2, 1, '2019-08-13 12:40:02', '2019-08-13 00:40:01', '2019-08-13 00:40:01');
INSERT INTO `oauth2_refresh_token` VALUES ('0470683e4b3543a09d842d538e5f2c78', NULL, NULL, 1, '2019-05-14 03:53:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0472d5ac801d40a884468eae2729c16e', 27, 2, 1, '2019-07-09 04:01:19', '2019-07-08 16:01:18', '2019-07-08 16:01:18');
INSERT INTO `oauth2_refresh_token` VALUES ('0479b951e4f040b29b4fabc7c0691c6d', 27, 2, 1, '2019-07-07 02:02:44', '2019-07-06 14:02:44', '2019-07-06 14:02:44');
INSERT INTO `oauth2_refresh_token` VALUES ('04b5003baffb4fb4b511827ba98d754c', 27, 2, 1, '2019-09-07 02:39:06', '2019-09-06 14:39:06', '2019-09-06 14:39:06');
INSERT INTO `oauth2_refresh_token` VALUES ('04c3a9f6d02245e38250d3802ebeb34f', 27, 2, 1, '2019-06-20 02:55:29', '2019-06-19 14:55:28', '2019-06-19 14:55:28');
INSERT INTO `oauth2_refresh_token` VALUES ('04d91eefcb68437381fe69c6ab2d4e66', 27, 2, 1, '2019-06-20 03:05:13', '2019-06-19 15:05:12', '2019-06-19 15:05:12');
INSERT INTO `oauth2_refresh_token` VALUES ('04ec2cd62cb0400f98fe19fd825bf275', 1, 2, 0, '2019-09-05 10:53:25', '2019-09-04 22:53:24', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('04fe54953f7f46c8999fe7b957129c25', 27, 2, 1, '2019-06-12 08:14:19', '2019-06-11 20:14:19', '2019-06-11 20:14:19');
INSERT INTO `oauth2_refresh_token` VALUES ('05029c33968c4e63b3e67f420dfc63ac', 27, 2, 1, '2019-07-13 03:11:33', '2019-07-12 15:11:32', '2019-07-12 15:11:32');
INSERT INTO `oauth2_refresh_token` VALUES ('0521fcbdedd64dc9a1e174a9b7c8816d', 27, 2, 1, '2019-08-28 13:13:55', '2019-08-28 01:13:55', '2019-08-28 01:13:55');
INSERT INTO `oauth2_refresh_token` VALUES ('05242306bcf24c06a050e78d4d002c7c', 189, 1, 1, '2019-08-03 04:08:24', '2019-08-02 16:08:23', '2019-08-02 16:08:23');
INSERT INTO `oauth2_refresh_token` VALUES ('054840bec4e94998b3884a5c5cf83474', 27, 2, 1, '2019-08-21 11:28:25', '2019-08-20 23:28:24', '2019-08-20 23:28:24');
INSERT INTO `oauth2_refresh_token` VALUES ('0550d7345f30412f93dcd6a157d82b98', 27, 2, 1, '2019-06-21 05:13:30', '2019-06-20 17:13:29', '2019-06-20 17:13:29');
INSERT INTO `oauth2_refresh_token` VALUES ('055a6ca5fdf742d9970679a4be75c496', 1, 2, 0, '2019-05-27 11:52:54', '2019-05-26 23:52:53', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('0568318b09614068becbd10bed13f938', 27, 2, 1, '2019-07-11 04:30:38', '2019-07-10 16:30:37', '2019-07-10 16:30:37');
INSERT INTO `oauth2_refresh_token` VALUES ('058630e07ba243cba12871840135efb3', 27, 2, 1, '2019-06-28 08:12:20', '2019-06-27 20:12:20', '2019-06-27 20:12:20');
INSERT INTO `oauth2_refresh_token` VALUES ('05a188dd885b4737be4dc402625dde0e', 27, 2, 1, '2019-09-04 05:06:19', '2019-09-03 17:06:18', '2019-09-03 17:06:18');
INSERT INTO `oauth2_refresh_token` VALUES ('05b950bc7022442e92173b887e571e1f', NULL, NULL, 1, '2019-04-24 22:41:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('05bdb77ce57b437781fd6b3a61ebe4c4', 27, 2, 1, '2019-05-20 22:46:47', '2019-05-20 10:46:47', '2019-05-20 10:46:47');
INSERT INTO `oauth2_refresh_token` VALUES ('05c0e41de7ea41f7afdd489229bcbfc1', 1, 2, 0, '2019-08-21 01:44:38', '2019-08-20 13:44:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('05dbb8c1b3cd40a3a93e7cfbb5a696c7', 27, 2, 1, '2019-07-10 02:20:03', '2019-07-09 14:20:03', '2019-07-09 14:20:03');
INSERT INTO `oauth2_refresh_token` VALUES ('06003a97ebe749418fde2465224f34a3', 27, 2, 1, '2019-08-26 22:07:37', '2019-08-26 10:07:36', '2019-08-26 10:07:36');
INSERT INTO `oauth2_refresh_token` VALUES ('060e5d45d22640088548ae60c87916c1', 27, 2, 1, '2019-07-17 22:18:24', '2019-07-17 10:18:24', '2019-07-17 10:18:24');
INSERT INTO `oauth2_refresh_token` VALUES ('06143ea19f694bc2b2e2e190964ee50f', 27, 2, 1, '2019-05-25 02:25:33', '2019-05-24 14:25:33', '2019-05-24 14:25:33');
INSERT INTO `oauth2_refresh_token` VALUES ('0642e898f505463f9dd025b233372a08', 27, 2, 1, '2019-07-01 02:41:21', '2019-06-30 14:41:21', '2019-06-30 14:41:21');
INSERT INTO `oauth2_refresh_token` VALUES ('0643e81562df4aa4b28c9d2368f2df58', 27, 2, 1, '2019-06-02 01:01:31', '2019-06-01 13:01:30', '2019-06-01 13:01:30');
INSERT INTO `oauth2_refresh_token` VALUES ('064940ef2184428abfef3842f338e2a2', 27, 2, 1, '2019-07-10 08:37:22', '2019-07-09 20:37:21', '2019-07-09 20:37:21');
INSERT INTO `oauth2_refresh_token` VALUES ('065fcb4112a848d9963f068155c55e50', 27, 2, 1, '2019-06-03 07:09:48', '2019-06-02 19:09:48', '2019-06-02 19:09:48');
INSERT INTO `oauth2_refresh_token` VALUES ('0693377223834e6898e0521550835257', 27, 2, 1, '2019-08-31 01:05:52', '2019-08-30 13:05:51', '2019-08-30 13:05:51');
INSERT INTO `oauth2_refresh_token` VALUES ('06970e8279cb401ead0433b2479e39fb', 1, 2, 0, '2019-06-01 21:58:56', '2019-06-01 09:58:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('06a74ce2119148b9a8d9dd486152655d', 27, 2, 1, '2019-06-27 23:27:48', '2019-06-27 11:27:47', '2019-06-27 11:27:47');
INSERT INTO `oauth2_refresh_token` VALUES ('06b4f7c5e49a437ca2bcaad463378daa', NULL, NULL, 1, '2019-05-11 01:47:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('06c4b7cf9a8c492b83145dd13c508198', 27, 2, 1, '2019-08-09 22:49:09', '2019-08-09 10:49:08', '2019-08-09 10:49:08');
INSERT INTO `oauth2_refresh_token` VALUES ('06d5418ba86c410f9fba25ecd031bd49', 27, 2, 1, '2019-06-01 23:02:48', '2019-06-01 11:02:48', '2019-06-01 11:02:48');
INSERT INTO `oauth2_refresh_token` VALUES ('06fc8302ac31484eb0b47c140c54c3fc', 27, 2, 1, '2019-08-04 23:39:07', '2019-08-04 11:39:06', '2019-08-04 11:39:06');
INSERT INTO `oauth2_refresh_token` VALUES ('070a9d0f7da443f399a7a65ce5237da6', 27, 2, 1, '2019-06-25 04:30:22', '2019-06-24 16:30:22', '2019-06-24 16:30:22');
INSERT INTO `oauth2_refresh_token` VALUES ('07154717dfff4459b2a02da0defa83c7', 173, 1, 1, '2019-07-17 19:29:40', '2019-07-17 07:29:40', '2019-07-17 07:29:40');
INSERT INTO `oauth2_refresh_token` VALUES ('071de72bc40348a38f7f93b2b2e02bb9', NULL, NULL, 1, '2019-05-05 21:30:44', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('073125a47000431ba70fbcbf47ed3fe1', 27, 2, 1, '2019-06-12 01:55:32', '2019-06-11 13:55:32', '2019-06-11 13:55:32');
INSERT INTO `oauth2_refresh_token` VALUES ('073160361b60452faabbd61448e49b81', NULL, NULL, 1, '2019-04-23 10:02:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0734d1c9986a42e9b8924ebb3f64a109', 27, 2, 1, '2019-09-03 20:30:18', '2019-09-03 08:30:18', '2019-09-03 08:30:18');
INSERT INTO `oauth2_refresh_token` VALUES ('0751d99fbf064227a88cf92d953bda59', 27, 2, 1, '2019-06-01 09:04:11', '2019-05-31 21:04:10', '2019-05-31 21:04:10');
INSERT INTO `oauth2_refresh_token` VALUES ('07826e3aac124ab58b4f373c2bd741c8', 27, 2, 1, '2019-08-27 20:17:37', '2019-08-27 08:17:36', '2019-08-27 08:17:36');
INSERT INTO `oauth2_refresh_token` VALUES ('0789b872b14043268817941a0c474644', 27, 2, 1, '2019-06-09 05:52:57', '2019-06-08 17:52:56', '2019-06-08 17:52:56');
INSERT INTO `oauth2_refresh_token` VALUES ('0795031bd40a44c6a988ba0551a95565', 1, 2, 0, '2019-06-03 20:47:57', '2019-06-03 08:47:57', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('0795aa2a094347459577d1cf05c7b947', 27, 2, 1, '2019-05-29 03:52:04', '2019-05-28 15:50:46', '2019-05-28 15:50:46');
INSERT INTO `oauth2_refresh_token` VALUES ('079ad9e495be45afb377a463905e18b4', 27, 2, 1, '2019-07-24 03:10:57', '2019-07-23 15:10:57', '2019-07-23 15:10:57');
INSERT INTO `oauth2_refresh_token` VALUES ('07a094165a0c45ecbd0d667476347c19', 1, 2, 0, '2019-06-05 21:40:47', '2019-06-05 09:40:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('07a236dc86464c6ba22b7d2fcc78ca32', NULL, NULL, 1, '2019-05-01 05:40:01', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('07ca08c4b2154bbe9fd12939cd4ab4d3', 27, 2, 1, '2019-06-18 21:37:44', '2019-06-18 09:37:44', '2019-06-18 09:37:44');
INSERT INTO `oauth2_refresh_token` VALUES ('07cbb87af3014e8d92666fa8a4b90d57', NULL, NULL, 1, '2019-03-13 12:04:23', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('07d200865cce4eef849190f5a1602ff1', 27, 2, 1, '2019-07-23 22:36:43', '2019-07-23 10:36:42', '2019-07-23 10:36:42');
INSERT INTO `oauth2_refresh_token` VALUES ('07d9a1603cfa4147bf8a9a528d1a68b8', 27, 2, 1, '2019-09-04 02:53:43', '2019-09-03 14:53:42', '2019-09-03 14:53:42');
INSERT INTO `oauth2_refresh_token` VALUES ('07dfe7aa15c74aa69c9e916d96e1e760', 27, 2, 1, '2019-06-04 20:58:03', '2019-06-04 08:58:03', '2019-06-04 08:58:03');
INSERT INTO `oauth2_refresh_token` VALUES ('07e47eca6a9244c19d33e5435c54de6a', NULL, NULL, 1, '2019-05-11 02:29:51', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('080826283a524118b04ae1b2623a6389', 1, 2, 0, '2019-07-13 03:11:57', '2019-07-12 15:11:56', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('0810615dafdf4f5ea2456d9e7bbdcc65', NULL, NULL, 1, '2019-04-26 23:04:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0812f78adf794301a6e5245093e264d9', 27, 2, 1, '2019-05-29 02:43:14', '2019-05-28 14:43:13', '2019-05-28 14:43:13');
INSERT INTO `oauth2_refresh_token` VALUES ('0818b1135dc1425c829e1733408ccf2c', 27, 2, 1, '2019-06-27 05:01:59', '2019-06-26 17:01:59', '2019-06-26 17:01:59');
INSERT INTO `oauth2_refresh_token` VALUES ('08201cde149c47ecad22098716cb6e6a', 27, 2, 1, '2019-07-25 20:45:11', '2019-07-25 08:45:10', '2019-07-25 08:45:10');
INSERT INTO `oauth2_refresh_token` VALUES ('08559732b0f14aa48fb5029d4395e4f9', 27, 2, 1, '2019-08-01 03:06:00', '2019-07-31 15:05:59', '2019-07-31 15:05:59');
INSERT INTO `oauth2_refresh_token` VALUES ('085926a44732410d82b6db80c653993a', 27, 2, 1, '2019-09-04 04:53:00', '2019-09-03 16:52:59', '2019-09-03 16:52:59');
INSERT INTO `oauth2_refresh_token` VALUES ('086134896af24d6a8fdfea399fa05abf', 27, 2, 1, '2019-08-04 03:11:40', '2019-08-03 15:11:39', '2019-08-03 15:11:39');
INSERT INTO `oauth2_refresh_token` VALUES ('087c3fec9e83455085caccf283bbc009', NULL, NULL, 1, '2019-05-11 23:02:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('08814deaa8cf4f2c8b478c5f9cadae98', 27, 2, 1, '2019-07-08 06:26:50', '2019-07-07 18:26:50', '2019-07-07 18:26:50');
INSERT INTO `oauth2_refresh_token` VALUES ('0885621364c5427ea0be56951805019c', 27, 2, 1, '2019-06-20 03:05:03', '2019-06-19 15:05:03', '2019-06-19 15:05:03');
INSERT INTO `oauth2_refresh_token` VALUES ('0896a8093f974dbd8d55e8a64335d808', 27, 2, 1, '2019-08-21 21:07:18', '2019-08-21 09:07:18', '2019-08-21 09:07:18');
INSERT INTO `oauth2_refresh_token` VALUES ('089d9f467a474f7e841549894dfeb38a', 27, 2, 1, '2019-07-19 11:36:45', '2019-07-18 23:36:44', '2019-07-18 23:36:44');
INSERT INTO `oauth2_refresh_token` VALUES ('08a4b620c9384de9a50d8ca978fafa01', 27, 2, 1, '2019-06-04 22:11:31', '2019-06-04 10:11:30', '2019-06-04 10:11:30');
INSERT INTO `oauth2_refresh_token` VALUES ('08c1d8a7d3c44dba9b1f15bfd7568c07', 27, 2, 1, '2019-06-20 21:38:02', '2019-06-20 09:38:01', '2019-06-20 09:38:01');
INSERT INTO `oauth2_refresh_token` VALUES ('08c75e5d14aa470f992bdb9d1e6d5db8', 1, 2, 0, '2019-09-03 10:32:52', '2019-09-02 22:32:52', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('08d4d4e579ae4a3da2663ead543cd723', 27, 2, 1, '2019-07-16 10:28:39', '2019-07-15 22:28:39', '2019-07-15 22:28:39');
INSERT INTO `oauth2_refresh_token` VALUES ('08f5248dfd3d4902846e32e4afa316d9', 27, 2, 1, '2019-07-16 03:09:11', '2019-07-15 15:09:11', '2019-07-15 15:09:11');
INSERT INTO `oauth2_refresh_token` VALUES ('091dc0256c044f1fac3f6ef09837e6e1', 27, 2, 1, '2019-06-21 21:25:19', '2019-06-21 09:25:18', '2019-06-21 09:25:18');
INSERT INTO `oauth2_refresh_token` VALUES ('09269fa8e6ff4d7cabdbc016a71673d4', 1, 2, 0, '2019-08-22 06:02:49', '2019-08-21 18:02:49', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('09366fec7a9742a6a89d01f3d44601e4', 27, 2, 1, '2019-05-23 23:31:30', '2019-05-23 11:31:29', '2019-05-23 11:31:29');
INSERT INTO `oauth2_refresh_token` VALUES ('09525a354d804fb1b650eb86ee7fcf00', 27, 2, 1, '2019-08-21 01:32:12', '2019-08-20 13:32:11', '2019-08-20 13:32:11');
INSERT INTO `oauth2_refresh_token` VALUES ('097e4c1f835244bca2c3b7ca8aa35e72', 27, 2, 1, '2019-08-19 10:08:07', '2019-08-18 22:08:06', '2019-08-18 22:08:06');
INSERT INTO `oauth2_refresh_token` VALUES ('098acdb47c194b18b2d9e3c8ce69601c', 27, 2, 1, '2019-06-13 23:54:15', '2019-06-13 11:54:15', '2019-06-13 11:54:15');
INSERT INTO `oauth2_refresh_token` VALUES ('099e435f58974f06a15e35e427888e4c', NULL, NULL, 0, '2019-03-04 10:09:58', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('09ae1ed413d7449d84d66d76ecd78dab', 27, 2, 1, '2019-06-27 01:52:36', '2019-06-26 13:52:35', '2019-06-26 13:52:35');
INSERT INTO `oauth2_refresh_token` VALUES ('09d9cda796a04453be8fba90f0489f9e', 1, 2, 0, '2019-05-31 21:52:54', '2019-05-31 09:51:34', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('09de12b4899a43a4b78aa96c65a35ce4', 27, 2, 1, '2019-06-04 03:20:56', '2019-06-03 15:20:56', '2019-06-03 15:20:56');
INSERT INTO `oauth2_refresh_token` VALUES ('09e6bc7863f140c9bbeb4e51d62bfc13', 27, 2, 1, '2019-06-23 11:06:35', '2019-06-22 23:06:34', '2019-06-22 23:06:34');
INSERT INTO `oauth2_refresh_token` VALUES ('09e711fc7f0c4d70af9f55f4a687bf81', 27, 2, 1, '2019-06-08 05:34:48', '2019-06-07 17:34:48', '2019-06-07 17:34:48');
INSERT INTO `oauth2_refresh_token` VALUES ('09e7fd57ebd348c3b35859e4717053fe', NULL, NULL, 1, '2019-05-04 01:46:00', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('09eb342f8ee541e7be2768769c041da3', 142, 1, 1, '2019-06-28 02:27:14', '2019-06-27 14:27:13', '2019-06-27 14:27:13');
INSERT INTO `oauth2_refresh_token` VALUES ('0a1648bd2a0e4f09a5e7d6aa5e322b3c', 27, 2, 1, '2019-06-06 01:42:07', '2019-06-05 13:42:07', '2019-06-05 13:42:07');
INSERT INTO `oauth2_refresh_token` VALUES ('0a181c5d860a45078c400f9cbe6f4e6b', NULL, NULL, 1, '2019-03-13 22:17:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0a1f4713501d44929ed222707b962889', 1, 2, 0, '2019-08-22 02:14:37', '2019-08-21 14:14:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('0a2b6957380143acbe672c1eb3a49a2c', 27, 2, 1, '2019-07-26 03:57:35', '2019-07-25 15:57:35', '2019-07-25 15:57:35');
INSERT INTO `oauth2_refresh_token` VALUES ('0a2e8a4bdc164b6d89ab0abf25cb6c6a', 27, 2, 1, '2019-06-21 00:53:42', '2019-06-20 12:53:41', '2019-06-20 12:53:41');
INSERT INTO `oauth2_refresh_token` VALUES ('0a79524cda2d49fcab9df4a030a03375', 27, 2, 1, '2019-06-01 22:07:19', '2019-06-01 10:07:18', '2019-06-01 10:07:18');
INSERT INTO `oauth2_refresh_token` VALUES ('0a7e1922fdde4b5789053630d612303e', 27, 2, 1, '2019-06-05 05:47:31', '2019-06-04 17:47:30', '2019-06-04 17:47:30');
INSERT INTO `oauth2_refresh_token` VALUES ('0a8277630e2743ab8e0a1f39d3c349f7', 1, 2, 0, '2019-09-07 02:42:21', '2019-09-06 14:42:21', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('0a8794db6d7c44edb3380fb842d92c34', 27, 2, 1, '2019-06-04 10:58:43', '2019-06-03 22:58:42', '2019-06-03 22:58:42');
INSERT INTO `oauth2_refresh_token` VALUES ('0a9cdeb9cb7840ef9c0be048d444196f', NULL, NULL, 1, '2019-05-15 22:23:48', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0aa3020c676a44b0840a72f815b357c0', 27, 2, 1, '2019-06-28 02:26:56', '2019-06-27 14:26:55', '2019-06-27 14:26:55');
INSERT INTO `oauth2_refresh_token` VALUES ('0acd2f3d2a7745588055c2c6dbdd5d7d', 27, 2, 1, '2019-07-05 06:03:35', '2019-07-04 18:03:35', '2019-07-04 18:03:35');
INSERT INTO `oauth2_refresh_token` VALUES ('0ae42900437a4ac09e474f5eeaebdbae', 27, 2, 1, '2019-06-18 02:11:11', '2019-06-17 14:11:11', '2019-06-17 14:11:11');
INSERT INTO `oauth2_refresh_token` VALUES ('0ae72ae0b6e846d883648b0d378236c2', 27, 2, 1, '2019-08-12 21:50:10', '2019-08-12 09:50:09', '2019-08-12 09:50:09');
INSERT INTO `oauth2_refresh_token` VALUES ('0aedc94e73714362901e8c66b8e92a64', 27, 2, 1, '2019-08-10 03:32:32', '2019-08-09 15:32:32', '2019-08-09 15:32:32');
INSERT INTO `oauth2_refresh_token` VALUES ('0b05d405b9744b31ba0e804ea2a2ce1e', NULL, NULL, 1, '2019-05-11 02:17:10', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0b0af24e3adb4ec7a29f3a8ebc82d253', 27, 2, 1, '2019-07-12 11:18:29', '2019-07-11 23:18:28', '2019-07-11 23:18:28');
INSERT INTO `oauth2_refresh_token` VALUES ('0b0dc1d7098a466b820b0e7fa8c3594d', 27, 2, 1, '2019-05-29 02:43:21', '2019-05-28 14:43:20', '2019-05-28 14:43:20');
INSERT INTO `oauth2_refresh_token` VALUES ('0b17b9e34bbb4299a4d23af133b20099', 27, 2, 1, '2019-06-04 06:56:13', '2019-06-03 18:56:13', '2019-06-03 18:56:13');
INSERT INTO `oauth2_refresh_token` VALUES ('0b296d4918d34bb7b49e6251d9beb09d', 27, 2, 1, '2019-08-29 02:10:04', '2019-08-28 14:10:03', '2019-08-28 14:10:03');
INSERT INTO `oauth2_refresh_token` VALUES ('0b30e9cc949e428a9371b3e4955ec0b3', 27, 2, 1, '2019-07-24 03:57:55', '2019-07-23 15:57:54', '2019-07-23 15:57:54');
INSERT INTO `oauth2_refresh_token` VALUES ('0b522135e24a477ba56c2240e18aac97', 27, 2, 1, '2019-08-05 11:23:48', '2019-08-04 23:23:48', '2019-08-04 23:23:48');
INSERT INTO `oauth2_refresh_token` VALUES ('0b558b7a63e64647a82227cdc6f626f8', 1, 2, 0, '2019-08-22 11:58:15', '2019-08-21 23:58:15', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('0b6d9b616fa242089d1fb7d1956b1cb2', NULL, NULL, 1, '2019-03-19 14:16:37', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0b7abf23e3b748a7adb30f4763f87bad', 27, 2, 1, '2019-08-19 09:43:08', '2019-08-18 21:43:08', '2019-08-18 21:43:08');
INSERT INTO `oauth2_refresh_token` VALUES ('0b861323c3bb4637b9dc7846110a96d6', 27, 2, 1, '2019-08-11 03:47:34', '2019-08-10 15:47:34', '2019-08-10 15:47:34');
INSERT INTO `oauth2_refresh_token` VALUES ('0b87017f30b2479789c73f8b87a31a3f', NULL, NULL, 1, '2019-05-10 21:37:24', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0b8f477262954bbfbb25d86eb8e51344', 27, 2, 1, '2019-06-29 03:58:23', '2019-06-28 15:58:22', '2019-06-28 15:58:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0b98d2d6df2049b8a82fb720fd225a6d', 27, 2, 1, '2019-08-01 22:02:13', '2019-08-01 10:02:12', '2019-08-01 10:02:12');
INSERT INTO `oauth2_refresh_token` VALUES ('0ba1998885cb4ae2ab746b3f72a0a826', 27, 2, 1, '2019-08-31 03:18:33', '2019-08-30 15:18:32', '2019-08-30 15:18:32');
INSERT INTO `oauth2_refresh_token` VALUES ('0ba550ca40c3405192403a3c195b4e85', 27, 2, 1, '2019-08-28 10:48:48', '2019-08-27 22:48:48', '2019-08-27 22:48:48');
INSERT INTO `oauth2_refresh_token` VALUES ('0ba867c92f3f4138819a74aa2cec2be4', 27, 2, 1, '2019-08-21 23:39:36', '2019-08-21 11:39:36', '2019-08-21 11:39:36');
INSERT INTO `oauth2_refresh_token` VALUES ('0bada6b6016144ddb35a676c0f3aa203', 96, 1, 1, '2019-06-02 03:58:38', '2019-06-01 15:58:38', '2019-06-01 15:58:38');
INSERT INTO `oauth2_refresh_token` VALUES ('0baf9b718b9a49edae994537e5a1aabf', 27, 2, 1, '2019-07-04 01:56:12', '2019-07-03 13:56:12', '2019-07-03 13:56:12');
INSERT INTO `oauth2_refresh_token` VALUES ('0bc89e7c8fba42d4a5483889dca8d67a', 89, 1, 1, '2019-05-29 10:39:22', '2019-05-28 22:39:21', '2019-05-28 22:39:21');
INSERT INTO `oauth2_refresh_token` VALUES ('0bd9497597e84332a6909c82d82aa3b3', 27, 2, 1, '2019-06-05 04:24:01', '2019-06-04 16:24:00', '2019-06-04 16:24:00');
INSERT INTO `oauth2_refresh_token` VALUES ('0be31623233e4a9c8696bde7dd00d581', 27, 2, 1, '2019-06-25 06:14:53', '2019-06-24 18:14:52', '2019-06-24 18:14:52');
INSERT INTO `oauth2_refresh_token` VALUES ('0c04cc1c92514c189e552066aad9c340', 27, 2, 1, '2019-06-05 23:07:32', '2019-06-05 11:07:31', '2019-06-05 11:07:31');
INSERT INTO `oauth2_refresh_token` VALUES ('0c14cb19daba421eb2536d068c68d389', 27, 2, 1, '2019-05-29 04:35:50', '2019-05-28 16:35:49', '2019-05-28 16:35:49');
INSERT INTO `oauth2_refresh_token` VALUES ('0c1a73876b224e948dbbf95acda3a8a0', 27, 2, 1, '2019-08-20 08:43:24', '2019-08-19 20:43:24', '2019-08-19 20:43:24');
INSERT INTO `oauth2_refresh_token` VALUES ('0c2d72314c9b4e6c8fb4d9a16d3abf8f', 167, 1, 1, '2019-07-11 22:57:27', '2019-07-11 10:57:26', '2019-07-11 10:57:26');
INSERT INTO `oauth2_refresh_token` VALUES ('0c34d9766ab64239bfa8c1cbb553ac61', 1, 2, 0, '2019-06-11 23:39:42', '2019-06-11 11:39:41', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('0c514a5dbacb42f8bce7ae4990ca5db3', 27, 2, 1, '2019-06-04 01:47:33', '2019-06-03 13:47:33', '2019-06-03 13:47:33');
INSERT INTO `oauth2_refresh_token` VALUES ('0c54c4fb84034ad8b0ff084e852b1214', NULL, NULL, 1, '2019-04-28 21:12:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0c5f736259bd43beab97f7ccea50e43b', 27, 2, 1, '2019-07-17 05:59:49', '2019-07-16 17:59:49', '2019-07-16 17:59:49');
INSERT INTO `oauth2_refresh_token` VALUES ('0c7b19c0427842bfa104cab184bf335b', 27, 2, 1, '2019-05-23 02:30:58', '2019-05-22 14:30:58', '2019-05-22 14:30:58');
INSERT INTO `oauth2_refresh_token` VALUES ('0c7fe3e298114abf837d2e82008d39e0', 27, 2, 1, '2019-05-25 00:32:35', '2019-05-24 12:32:34', '2019-05-24 12:32:34');
INSERT INTO `oauth2_refresh_token` VALUES ('0c873a31ef2e4819a8f542f70013b38f', 27, 2, 1, '2019-05-30 21:56:42', '2019-05-30 09:56:42', '2019-05-30 09:56:42');
INSERT INTO `oauth2_refresh_token` VALUES ('0cb085e96e394b449ab55067a371c568', 27, 2, 1, '2019-07-08 06:01:32', '2019-07-07 18:01:31', '2019-07-07 18:01:31');
INSERT INTO `oauth2_refresh_token` VALUES ('0cc9cd2254534d1fa734d558b48cfbe1', 27, 2, 1, '2019-06-05 04:12:10', '2019-06-04 16:12:10', '2019-06-04 16:12:10');
INSERT INTO `oauth2_refresh_token` VALUES ('0cd31e8a906544dcaf97e31d47e93f13', 27, 2, 1, '2019-06-06 23:40:37', '2019-06-06 11:40:37', '2019-06-06 11:40:37');
INSERT INTO `oauth2_refresh_token` VALUES ('0cd54ce6d5a14422a8d264f6cbb0bb79', 27, 2, 1, '2019-08-05 06:34:06', '2019-08-04 18:34:06', '2019-08-04 18:34:06');
INSERT INTO `oauth2_refresh_token` VALUES ('0cd87558e6f544b0a2fa360d55a97506', 27, 2, 1, '2019-07-20 05:30:47', '2019-07-19 17:30:46', '2019-07-19 17:30:46');
INSERT INTO `oauth2_refresh_token` VALUES ('0cdba1aedb124196af223512f57a15ed', 27, 2, 1, '2019-08-03 11:06:32', '2019-08-02 23:06:31', '2019-08-02 23:06:31');
INSERT INTO `oauth2_refresh_token` VALUES ('0cf549d5dc5d40a5b1158b64ba150cbd', 27, 2, 1, '2019-06-14 20:50:35', '2019-06-14 08:50:34', '2019-06-14 08:50:34');
INSERT INTO `oauth2_refresh_token` VALUES ('0d0687562708455ea7b68f8dd1e943d9', 27, 2, 1, '2019-07-27 01:46:29', '2019-07-26 13:46:28', '2019-07-26 13:46:28');
INSERT INTO `oauth2_refresh_token` VALUES ('0d410105d8b34918940ce0a822d758d4', 27, 2, 1, '2019-07-22 22:32:19', '2019-07-22 10:32:19', '2019-07-22 10:32:19');
INSERT INTO `oauth2_refresh_token` VALUES ('0d63048d141f426fb4d28764b2a3d74f', 27, 2, 1, '2019-08-30 03:48:54', '2019-08-29 15:48:54', '2019-08-29 15:48:54');
INSERT INTO `oauth2_refresh_token` VALUES ('0d6645757248440f8d2979a249eaab91', 27, 2, 1, '2019-09-03 03:54:19', '2019-09-02 15:54:18', '2019-09-02 15:54:18');
INSERT INTO `oauth2_refresh_token` VALUES ('0d699f9f08d44a21a4901819c779efd1', 27, 2, 1, '2019-08-22 02:09:04', '2019-08-21 14:09:03', '2019-08-21 14:09:03');
INSERT INTO `oauth2_refresh_token` VALUES ('0d7403de84bc4514aae223ee8d6fbd67', 27, 2, 1, '2019-06-07 02:17:28', '2019-06-06 14:17:27', '2019-06-06 14:17:27');
INSERT INTO `oauth2_refresh_token` VALUES ('0d8d7b8341af4077852c5f04a5472701', 1, 2, 0, '2019-06-26 00:55:05', '2019-06-25 12:55:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('0d9225bc75744e12b89395c4e75f8de9', 27, 2, 1, '2019-07-18 03:59:59', '2019-07-17 15:59:58', '2019-07-17 15:59:58');
INSERT INTO `oauth2_refresh_token` VALUES ('0db2330a05a547e999729e46d53b7e0f', 27, 2, 1, '2019-05-21 05:53:37', '2019-05-20 17:53:37', '2019-05-20 17:53:37');
INSERT INTO `oauth2_refresh_token` VALUES ('0db26637f3274d48becc1b86d4952de6', 102, 1, 1, '2019-06-04 05:12:47', '2019-06-03 17:12:47', '2019-06-03 17:12:47');
INSERT INTO `oauth2_refresh_token` VALUES ('0dbc11fd2290429d8e4d7b85e90c0a41', 27, 2, 1, '2019-06-03 23:57:11', '2019-06-03 11:57:11', '2019-06-03 11:57:11');
INSERT INTO `oauth2_refresh_token` VALUES ('0dd18ffda01648e9bbc035dcd5d92518', 27, 2, 1, '2019-09-05 07:08:20', '2019-09-04 19:08:19', '2019-09-04 19:08:19');
INSERT INTO `oauth2_refresh_token` VALUES ('0df4f2bca387483c8737cb9a02ffe079', NULL, NULL, 1, '2019-03-10 16:29:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0e1b7761b8954761932f07a2945a9b4b', NULL, NULL, 1, '2019-05-07 04:16:46', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0e4d2112df1342a8a7b8eac7c0e9e24a', 27, 2, 1, '2019-08-31 04:59:38', '2019-08-30 16:59:37', '2019-08-30 16:59:37');
INSERT INTO `oauth2_refresh_token` VALUES ('0e5cb1ddab7743518329d27a95c5b264', 27, 2, 1, '2019-08-14 00:28:39', '2019-08-13 12:28:39', '2019-08-13 12:28:39');
INSERT INTO `oauth2_refresh_token` VALUES ('0e64dcaf80934a2face5235b43c2cd9c', 27, 2, 1, '2019-05-31 01:37:26', '2019-05-30 13:37:26', '2019-05-30 13:37:26');
INSERT INTO `oauth2_refresh_token` VALUES ('0e8d63e10dbe460b83df69a0be3e469d', 27, 2, 1, '2019-06-02 10:54:10', '2019-06-01 22:54:09', '2019-06-01 22:54:09');
INSERT INTO `oauth2_refresh_token` VALUES ('0e8eb2d8a36d4efe9070536596202cbf', 27, 2, 1, '2019-06-03 06:07:40', '2019-06-02 18:07:40', '2019-06-02 18:07:40');
INSERT INTO `oauth2_refresh_token` VALUES ('0ea58da8d269448abf6d05939fc3aee7', NULL, NULL, 0, '2019-03-04 10:03:17', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0eaad74bb1164efd8ffc4d627510b8b7', 27, 2, 1, '2019-08-19 20:16:39', '2019-08-19 08:16:38', '2019-08-19 08:16:38');
INSERT INTO `oauth2_refresh_token` VALUES ('0eab168b650743ff82667e67bfa3c400', 27, 2, 1, '2019-08-30 00:24:43', '2019-08-29 12:24:42', '2019-08-29 12:24:42');
INSERT INTO `oauth2_refresh_token` VALUES ('0eb21f630ffa41b5bc67e0905541d80c', 27, 2, 1, '2019-06-25 08:11:33', '2019-06-24 20:11:33', '2019-06-24 20:11:33');
INSERT INTO `oauth2_refresh_token` VALUES ('0ebcbd4b1b7443d7b8ddf6c2d305692a', NULL, NULL, 1, '2019-03-10 15:34:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0ec618d1c7d24574a7775540aa1ca3cd', NULL, NULL, 1, '2019-04-23 06:20:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0edfafd237134b9ca3e5f106565e6721', NULL, NULL, 1, '2019-04-23 07:42:57', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0ee5190b5cad4b12aba8e48546207756', 27, 2, 1, '2019-07-11 23:11:39', '2019-07-11 11:11:39', '2019-07-11 11:11:39');
INSERT INTO `oauth2_refresh_token` VALUES ('0eed2937bfa047d0bb4efc2ff332d27f', 27, 2, 1, '2019-08-16 02:24:31', '2019-08-15 14:24:31', '2019-08-15 14:24:31');
INSERT INTO `oauth2_refresh_token` VALUES ('0efc26af567e42528d0a220e7d3f56f5', 27, 2, 1, '2019-07-25 02:30:35', '2019-07-24 14:30:34', '2019-07-24 14:30:34');
INSERT INTO `oauth2_refresh_token` VALUES ('0eff8baec52e491fbdb9c73611d5671d', 221, 1, 1, '2019-09-06 03:12:28', '2019-09-05 15:12:27', '2019-09-05 15:12:27');
INSERT INTO `oauth2_refresh_token` VALUES ('0f11177aa49645fa8e3e601b6473fac5', 214, 1, 1, '2019-08-28 03:58:02', '2019-08-27 15:58:01', '2019-08-27 15:58:01');
INSERT INTO `oauth2_refresh_token` VALUES ('0f269b28a7f54b66a634d28e0e2e4c0d', NULL, NULL, 1, '2019-04-29 02:04:01', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0f39d327c62b42ce8d837da7545e41fa', NULL, NULL, 1, '2019-05-08 11:23:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0f61bc9c169948d5b935a1d833302452', 27, 2, 1, '2019-08-09 03:58:53', '2019-08-08 15:58:53', '2019-08-08 15:58:53');
INSERT INTO `oauth2_refresh_token` VALUES ('0f751a2f712841029be1d927b7f1164c', 27, 2, 1, '2019-06-28 04:42:38', '2019-06-27 16:42:37', '2019-06-27 16:42:37');
INSERT INTO `oauth2_refresh_token` VALUES ('0f949e5c4f474113a5e6fdc0297879b5', 27, 2, 1, '2019-06-29 21:18:28', '2019-06-29 09:18:27', '2019-06-29 09:18:27');
INSERT INTO `oauth2_refresh_token` VALUES ('0f9e55b6decf4817855866f6691632d8', NULL, NULL, 1, '2019-05-12 05:59:00', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0f9f19952543452d93e8f96edbe8e2e8', 27, 2, 1, '2019-06-27 09:08:01', '2019-06-26 21:08:00', '2019-06-26 21:08:00');
INSERT INTO `oauth2_refresh_token` VALUES ('0fbe7a1dbc6a4330806e2e1304973e6c', 27, 2, 1, '2019-08-26 22:39:32', '2019-08-26 10:39:32', '2019-08-26 10:39:32');
INSERT INTO `oauth2_refresh_token` VALUES ('0fbf96dbada048b98ae47c61596bb2ed', NULL, NULL, 1, '2019-04-23 06:25:16', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('0ff25f16440547b7b7e0915eeb51be31', 27, 2, 1, '2019-06-05 21:56:37', '2019-06-05 09:56:37', '2019-06-05 09:56:37');
INSERT INTO `oauth2_refresh_token` VALUES ('0ff9a67c575a41ffa2acb7b02f5c5c69', 27, 2, 1, '2019-08-13 04:00:18', '2019-08-12 16:00:18', '2019-08-12 16:00:18');
INSERT INTO `oauth2_refresh_token` VALUES ('1025fd6ff13149d29bfbca7f51868963', 27, 2, 1, '2019-06-03 20:47:38', '2019-06-03 08:47:37', '2019-06-03 08:47:37');
INSERT INTO `oauth2_refresh_token` VALUES ('1026517b975d423ca865275e09e101f7', 27, 2, 1, '2019-06-04 21:15:26', '2019-06-04 09:15:25', '2019-06-04 09:15:25');
INSERT INTO `oauth2_refresh_token` VALUES ('10352f46953d48d7a7ab1d48476f40ef', 27, 2, 1, '2019-08-29 09:25:27', '2019-08-28 21:25:27', '2019-08-28 21:25:27');
INSERT INTO `oauth2_refresh_token` VALUES ('1036dbc3260f4fe8be12d90571eb7e6d', 27, 2, 1, '2019-08-09 05:26:31', '2019-08-08 17:26:30', '2019-08-08 17:26:30');
INSERT INTO `oauth2_refresh_token` VALUES ('10376c9c65b5470ea1082373c73a1880', 27, 2, 1, '2019-06-04 10:51:40', '2019-06-03 22:51:40', '2019-06-03 22:51:40');
INSERT INTO `oauth2_refresh_token` VALUES ('1055e63609964cc5adb640bc4b123469', 1, 2, 0, '2019-08-02 02:07:56', '2019-08-01 14:07:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('105b5ee8c6644fe887c51ceb57880757', 27, 2, 1, '2019-07-21 00:15:41', '2019-07-20 12:15:40', '2019-07-20 12:15:40');
INSERT INTO `oauth2_refresh_token` VALUES ('106361973f1c4618ba13adc3d6932e17', 27, 2, 1, '2019-06-16 02:07:59', '2019-06-15 14:07:59', '2019-06-15 14:07:59');
INSERT INTO `oauth2_refresh_token` VALUES ('1065ff89e00b40bb9f43451811120cc9', 27, 2, 1, '2019-06-12 23:28:07', '2019-06-12 11:28:07', '2019-06-12 11:28:07');
INSERT INTO `oauth2_refresh_token` VALUES ('1068d84f4dfc41cd937eb363bb60656c', 1, 2, 0, '2019-06-01 10:41:30', '2019-05-31 22:41:30', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('1072009ff54045e69882f71d563fd17a', 27, 2, 1, '2019-06-03 21:44:49', '2019-06-03 09:44:49', '2019-06-03 09:44:49');
INSERT INTO `oauth2_refresh_token` VALUES ('10734947db9e4a159b6c7cc243962790', NULL, NULL, 1, '2019-05-06 22:53:04', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('107415038ac54b028ea577a3d9b6cb7e', 27, 2, 1, '2019-06-26 03:30:15', '2019-06-25 15:30:15', '2019-06-25 15:30:15');
INSERT INTO `oauth2_refresh_token` VALUES ('107c407609ae4dce9ef43c28de02066e', 27, 2, 1, '2019-07-03 21:43:15', '2019-07-03 09:43:15', '2019-07-03 09:43:15');
INSERT INTO `oauth2_refresh_token` VALUES ('108472fe5422414590427304fcf1e178', 1, 2, 1, '2019-09-08 15:46:10', '2019-09-08 03:46:10', '2019-09-08 03:46:10');
INSERT INTO `oauth2_refresh_token` VALUES ('10a31fa7d1e54e12ab8e19fa66fcf59e', 27, 2, 1, '2019-06-06 01:51:23', '2019-06-05 13:51:22', '2019-06-05 13:51:22');
INSERT INTO `oauth2_refresh_token` VALUES ('10a378c7e71c4049b8c792976f01dea8', 27, 2, 1, '2019-07-29 01:15:30', '2019-07-28 13:15:30', '2019-07-28 13:15:30');
INSERT INTO `oauth2_refresh_token` VALUES ('10aa6a55e9ef40cfbf493238f9f1da85', 202, 1, 1, '2019-08-15 03:48:47', '2019-08-14 15:48:46', '2019-08-14 15:48:46');
INSERT INTO `oauth2_refresh_token` VALUES ('10c44086fc204ddd8a4051b0ab91357a', 27, 2, 1, '2019-05-29 09:44:29', '2019-05-28 21:44:28', '2019-05-28 21:44:28');
INSERT INTO `oauth2_refresh_token` VALUES ('10efa11f2a97413badd89ff316466586', 27, 2, 1, '2019-08-13 02:12:37', '2019-08-12 14:12:37', '2019-08-12 14:12:37');
INSERT INTO `oauth2_refresh_token` VALUES ('10fb11c17e6c4f77ab1ea1237a8253e9', 27, 2, 1, '2019-06-01 21:23:49', '2019-06-01 09:23:49', '2019-06-01 09:23:49');
INSERT INTO `oauth2_refresh_token` VALUES ('111956d1627340da9250be9ce18c650d', 27, 2, 1, '2019-06-11 22:01:37', '2019-06-11 10:01:36', '2019-06-11 10:01:36');
INSERT INTO `oauth2_refresh_token` VALUES ('1120e72c4b6844aca39230390b7ff0f1', 27, 2, 1, '2019-06-07 01:19:38', '2019-06-06 13:19:37', '2019-06-06 13:19:37');
INSERT INTO `oauth2_refresh_token` VALUES ('1128ee106c5d40369e714ff8fc0d6a6c', 27, 2, 1, '2019-06-05 04:41:29', '2019-06-04 16:41:28', '2019-06-04 16:41:28');
INSERT INTO `oauth2_refresh_token` VALUES ('112d76164d044313909b5cc83733ef7c', NULL, NULL, 1, '2019-05-06 05:48:44', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('11409021862c499098821e5682c6c3dc', 27, 2, 1, '2019-06-04 04:45:50', '2019-06-03 16:45:49', '2019-06-03 16:45:49');
INSERT INTO `oauth2_refresh_token` VALUES ('11530764b623476c968c5c2f373b5b91', 27, 2, 1, '2019-09-02 23:43:46', '2019-09-02 11:43:45', '2019-09-02 11:43:45');
INSERT INTO `oauth2_refresh_token` VALUES ('1153ea1dcb2b4dc0aaa8b81baed28426', 27, 2, 1, '2019-05-31 10:43:47', '2019-05-30 22:43:46', '2019-05-30 22:43:46');
INSERT INTO `oauth2_refresh_token` VALUES ('11585a8922924eefbb61cb10da171f93', 27, 2, 1, '2019-06-02 23:13:28', '2019-06-02 11:13:27', '2019-06-02 11:13:27');
INSERT INTO `oauth2_refresh_token` VALUES ('1185cca6935949b987eabf12aa46e403', 27, 2, 1, '2019-07-31 22:03:30', '2019-07-31 10:03:30', '2019-07-31 10:03:30');
INSERT INTO `oauth2_refresh_token` VALUES ('11aa22bf086d401c9ee00e5d0faff337', 27, 2, 1, '2019-07-13 01:51:28', '2019-07-12 13:51:27', '2019-07-12 13:51:27');
INSERT INTO `oauth2_refresh_token` VALUES ('11b933ec4caa489f95bbdb3931d8e790', 27, 2, 1, '2019-07-13 05:49:48', '2019-07-12 17:49:48', '2019-07-12 17:49:48');
INSERT INTO `oauth2_refresh_token` VALUES ('11cf8e90730e4cba96d3786a84f07dcb', 27, 2, 1, '2019-06-01 04:49:31', '2019-05-31 16:49:31', '2019-05-31 16:49:31');
INSERT INTO `oauth2_refresh_token` VALUES ('11fa6d99107d49cf8c679d34f9e82f7e', 1, 2, 0, '2019-07-08 06:27:14', '2019-07-07 18:27:13', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('11fee2629ff1409c947d553be382fb1f', 27, 2, 1, '2019-09-05 05:24:41', '2019-09-04 17:24:41', '2019-09-04 17:24:41');
INSERT INTO `oauth2_refresh_token` VALUES ('121221cee5f44facbf011947bc546e8b', NULL, NULL, 1, '2019-04-30 02:18:41', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('122e6cd93af040d6903d4dc02c90c60f', 27, 2, 1, '2019-06-24 01:15:06', '2019-06-23 13:15:06', '2019-06-23 13:15:06');
INSERT INTO `oauth2_refresh_token` VALUES ('124ba929d4cf45f4bcb3ea529f7e0dfc', 27, 2, 1, '2019-06-04 20:38:03', '2019-06-04 08:38:02', '2019-06-04 08:38:02');
INSERT INTO `oauth2_refresh_token` VALUES ('12525ce6e81f497080b5af33c04aed5d', 125, 1, 1, '2019-06-15 07:00:09', '2019-06-14 19:00:09', '2019-06-14 19:00:09');
INSERT INTO `oauth2_refresh_token` VALUES ('125b1ffd588f40ab87430cedf5ef516b', 27, 2, 1, '2019-07-12 02:18:49', '2019-07-11 14:18:49', '2019-07-11 14:18:49');
INSERT INTO `oauth2_refresh_token` VALUES ('125e4ff25bfe470aa6904be41f75028e', 27, 2, 1, '2019-06-09 01:27:41', '2019-06-08 13:27:40', '2019-06-08 13:27:40');
INSERT INTO `oauth2_refresh_token` VALUES ('1281fbd2e6964dea984dad7e2f0b303b', NULL, NULL, 1, '2019-04-23 06:25:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('12927eb5277441dd8208a84a1045fe6e', 27, 2, 1, '2019-06-05 02:51:20', '2019-06-04 14:51:20', '2019-06-04 14:51:20');
INSERT INTO `oauth2_refresh_token` VALUES ('129cedb335624c069503477ddd7abf61', 27, 2, 1, '2019-08-22 05:01:48', '2019-08-21 17:01:48', '2019-08-21 17:01:48');
INSERT INTO `oauth2_refresh_token` VALUES ('12b092c65f554b63973b4251413878c3', 27, 2, 1, '2019-07-28 01:51:06', '2019-07-27 13:51:06', '2019-07-27 13:51:06');
INSERT INTO `oauth2_refresh_token` VALUES ('12c9dba1f2d34ee1902ca026bceddf95', NULL, NULL, 0, '2019-02-27 05:02:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('12d64546b50c4121b54cb78a7a191af4', 27, 2, 1, '2019-05-31 05:38:19', '2019-05-30 17:38:18', '2019-05-30 17:38:18');
INSERT INTO `oauth2_refresh_token` VALUES ('12eb3c958f2b419d955da1a9195d44bd', 27, 2, 1, '2019-06-02 08:16:10', '2019-06-01 20:16:09', '2019-06-01 20:16:09');
INSERT INTO `oauth2_refresh_token` VALUES ('13115365b25d45faa215b042dd06efba', 27, 2, 1, '2019-06-03 21:39:54', '2019-06-03 09:39:54', '2019-06-03 09:39:54');
INSERT INTO `oauth2_refresh_token` VALUES ('1313715d476c42099b718a46aa297ad5', NULL, NULL, 1, '2019-04-30 10:05:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('133a34610e80411a84da86a2dd4b018a', NULL, NULL, 1, '2019-05-10 05:54:57', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('134a212538af4606a0a7ae5ab0e064ba', 27, 2, 1, '2019-07-02 08:12:47', '2019-07-01 20:12:46', '2019-07-01 20:12:46');
INSERT INTO `oauth2_refresh_token` VALUES ('134ab5c182084343bba3c3c73e90c917', 1, 2, 1, '2019-09-09 10:59:22', '2019-09-08 22:59:21', '2019-09-08 22:59:21');
INSERT INTO `oauth2_refresh_token` VALUES ('1357edea4dea4653876fe52abd31ecad', 27, 2, 1, '2019-07-18 03:51:50', '2019-07-17 15:51:50', '2019-07-17 15:51:50');
INSERT INTO `oauth2_refresh_token` VALUES ('137cccd1c9574732854eab554a82c5c6', NULL, NULL, 1, '2019-03-12 10:52:23', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1383aca5bd5a4267bb0b011a74ba61c6', 27, 2, 1, '2019-07-30 05:45:46', '2019-07-29 17:45:46', '2019-07-29 17:45:46');
INSERT INTO `oauth2_refresh_token` VALUES ('138cb9de4f994c3f9bf319f4b082f3a5', 27, 2, 1, '2019-06-06 01:26:56', '2019-06-05 13:26:56', '2019-06-05 13:26:56');
INSERT INTO `oauth2_refresh_token` VALUES ('139b65667153491bb2e3710dbaaa1fee', 27, 2, 1, '2019-06-04 05:19:52', '2019-06-03 17:19:52', '2019-06-03 17:19:52');
INSERT INTO `oauth2_refresh_token` VALUES ('13cacb59505944a7b00c4a3ecd00822a', 163, 1, 1, '2019-07-10 05:57:59', '2019-07-09 17:57:59', '2019-07-09 17:57:59');
INSERT INTO `oauth2_refresh_token` VALUES ('13d21632661944198ca2616b59709eaa', NULL, NULL, 1, '2019-05-10 21:23:24', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('13d23e6b874d467c94ad7f12f0f80515', 27, 2, 1, '2019-06-28 05:54:45', '2019-06-27 17:54:45', '2019-06-27 17:54:45');
INSERT INTO `oauth2_refresh_token` VALUES ('13dc64c6ae4f4616ac41be39f0bde7d3', 1, 2, 0, '2019-09-05 21:48:10', '2019-09-05 09:48:09', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('13fbf535bd5f472c87e565504f61d051', 27, 2, 1, '2019-08-10 02:50:47', '2019-08-09 14:50:46', '2019-08-09 14:50:46');
INSERT INTO `oauth2_refresh_token` VALUES ('1401c605c8de47e6ae0dba0aff56e530', 1, 2, 0, '2019-07-12 21:27:56', '2019-07-12 09:27:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('14028f91954541468a36e63f1d92a839', 27, 2, 1, '2019-06-01 10:41:21', '2019-05-31 22:41:20', '2019-05-31 22:41:20');
INSERT INTO `oauth2_refresh_token` VALUES ('1404f2c5a20046bcb2eae31126ee6311', 27, 2, 1, '2019-08-16 04:41:51', '2019-08-15 16:41:51', '2019-08-15 16:41:51');
INSERT INTO `oauth2_refresh_token` VALUES ('1428afb592f749c0881d193a014cec3d', 1, 2, 0, '2019-08-22 06:01:54', '2019-08-21 18:01:53', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('142f93b6e8384cc3a6e62a3b0bf2d8e6', 27, 2, 1, '2019-06-19 23:57:08', '2019-06-19 11:57:07', '2019-06-19 11:57:07');
INSERT INTO `oauth2_refresh_token` VALUES ('14322e7630084c84a4856221a656eaf4', 27, 2, 1, '2019-07-25 23:02:42', '2019-07-25 11:02:42', '2019-07-25 11:02:42');
INSERT INTO `oauth2_refresh_token` VALUES ('14469e99019d48eaa2dcb757cfb2530c', 27, 2, 1, '2019-08-10 02:07:55', '2019-08-09 14:07:55', '2019-08-09 14:07:55');
INSERT INTO `oauth2_refresh_token` VALUES ('144d5ebd40aa4ed096603e7b255b8edc', NULL, NULL, 1, '2019-04-23 07:43:38', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('14537b2e536c4e1b924178970c21791b', 1, 2, 0, '2019-06-20 22:48:11', '2019-06-20 10:48:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('145d06a37030411b98cad90a88bb08a2', 27, 2, 1, '2019-06-15 01:41:58', '2019-06-14 13:41:57', '2019-06-14 13:41:57');
INSERT INTO `oauth2_refresh_token` VALUES ('1460ab55c95a421487c8e7f72de4bacb', 27, 2, 1, '2019-07-12 04:05:34', '2019-07-11 16:05:33', '2019-07-11 16:05:33');
INSERT INTO `oauth2_refresh_token` VALUES ('1464f9f51c4e44ad9e1c6128f000e7c5', 27, 2, 1, '2019-06-05 02:01:06', '2019-06-04 14:01:06', '2019-06-04 14:01:06');
INSERT INTO `oauth2_refresh_token` VALUES ('1479b204eb414aa99a4770d241306384', 27, 2, 1, '2019-06-06 05:50:00', '2019-06-05 17:49:59', '2019-06-05 17:49:59');
INSERT INTO `oauth2_refresh_token` VALUES ('1496c7134a1242a28ceca735b76fe1b3', 27, 2, 1, '2019-08-31 03:15:25', '2019-08-30 15:15:24', '2019-08-30 15:15:24');
INSERT INTO `oauth2_refresh_token` VALUES ('14a0760bdf6c4b6db0d89a86d0e42e5e', 143, 1, 1, '2019-07-01 08:28:12', '2019-06-30 20:28:12', '2019-06-30 20:28:12');
INSERT INTO `oauth2_refresh_token` VALUES ('14a29a4431504b1db1bd980bbebdcd39', NULL, NULL, 1, '2019-05-10 13:16:07', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('14a29f41230b48adae4f9909f1a935ea', 27, 2, 1, '2019-08-12 04:08:45', '2019-08-11 16:08:45', '2019-08-11 16:08:45');
INSERT INTO `oauth2_refresh_token` VALUES ('14a5438a3bf44a61bdfb900b30764c03', 27, 2, 1, '2019-07-27 22:53:22', '2019-07-27 10:53:21', '2019-07-27 10:53:21');
INSERT INTO `oauth2_refresh_token` VALUES ('14a673d279c44ccda9869b5dd11f0457', 83, 1, 1, '2019-05-25 05:47:00', '2019-05-24 17:47:00', '2019-05-24 17:47:00');
INSERT INTO `oauth2_refresh_token` VALUES ('14aefa11b4174c9ea98e6e60aa9ce14f', 27, 2, 1, '2019-06-03 09:15:29', '2019-06-02 21:15:29', '2019-06-02 21:15:29');
INSERT INTO `oauth2_refresh_token` VALUES ('14b9e572ee7a4d30b810029f4f89ce5e', NULL, NULL, 1, '2019-04-12 05:40:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('14d0a4afb3094be0b2afc9e9d6e7b9ec', 27, 2, 1, '2019-08-08 05:04:06', '2019-08-07 17:04:06', '2019-08-07 17:04:06');
INSERT INTO `oauth2_refresh_token` VALUES ('14dc06b2a8f348d6ad3557f30946535b', 27, 2, 1, '2019-06-13 21:58:39', '2019-06-13 09:58:39', '2019-06-13 09:58:39');
INSERT INTO `oauth2_refresh_token` VALUES ('14e006414482463ca7152885a643abfa', NULL, NULL, 1, '2019-04-02 11:50:42', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('14e04fb4c3824a46abccbd3f79ad35d0', 117, 1, 1, '2019-06-12 02:58:04', '2019-06-11 14:58:04', '2019-06-11 14:58:04');
INSERT INTO `oauth2_refresh_token` VALUES ('14fe18faebea4e9c83c368f7a9669972', 27, 2, 1, '2019-08-17 23:35:36', '2019-08-17 11:35:36', '2019-08-17 11:35:36');
INSERT INTO `oauth2_refresh_token` VALUES ('15040244aaae436fb2003ce73b4ad787', 27, 2, 1, '2019-06-05 05:43:56', '2019-06-04 17:43:56', '2019-06-04 17:43:56');
INSERT INTO `oauth2_refresh_token` VALUES ('151d0d8aa53c4220922dc1b7fa7b2fdd', 27, 2, 1, '2019-07-13 02:10:20', '2019-07-12 14:10:20', '2019-07-12 14:10:20');
INSERT INTO `oauth2_refresh_token` VALUES ('1526802d768e41af8a3d7410fec146d7', 204, 1, 1, '2019-08-17 22:40:19', '2019-08-17 10:40:18', '2019-08-17 10:40:18');
INSERT INTO `oauth2_refresh_token` VALUES ('15310244f759414bbd2852f9ed783a9d', 27, 2, 1, '2019-08-14 11:10:29', '2019-08-13 23:10:28', '2019-08-13 23:10:28');
INSERT INTO `oauth2_refresh_token` VALUES ('153d099566c942368a036d6c9c0ba5cb', 27, 2, 1, '2019-08-09 21:27:46', '2019-08-09 09:27:46', '2019-08-09 09:27:46');
INSERT INTO `oauth2_refresh_token` VALUES ('153d49ae6e70413ca8c62c6bc088694d', 27, 2, 1, '2019-06-03 21:35:39', '2019-06-03 09:35:38', '2019-06-03 09:35:38');
INSERT INTO `oauth2_refresh_token` VALUES ('154effaf709f49d9bba075a0d40f3790', 27, 2, 1, '2019-06-03 12:31:04', '2019-06-03 00:31:03', '2019-06-03 00:31:03');
INSERT INTO `oauth2_refresh_token` VALUES ('1551d0b98fe64cb4b872539cac6dafdb', 27, 2, 1, '2019-05-31 08:24:00', '2019-05-30 20:23:59', '2019-05-30 20:23:59');
INSERT INTO `oauth2_refresh_token` VALUES ('15536e98ef5c4ce09c5acd15e1109906', NULL, NULL, 1, '2019-05-07 11:07:04', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1562449f05be4912b100b8a041cbab49', 1, 2, 0, '2019-09-05 10:40:41', '2019-09-04 22:40:41', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('157ef76f1b434338a8ee66822b425183', 27, 2, 1, '2019-05-21 01:47:58', '2019-05-20 13:47:58', '2019-05-20 13:47:58');
INSERT INTO `oauth2_refresh_token` VALUES ('1593bddcffce430281ac4efa8bae4a97', NULL, NULL, 1, '2019-03-11 11:54:04', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('15bdf4510eed4249852bd6e018ce422b', NULL, NULL, 1, '2019-04-05 06:23:27', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('15e5406960384177af0ab9c1e6946f1d', 27, 2, 1, '2019-09-08 10:26:28', '2019-09-07 22:26:28', '2019-09-07 22:26:28');
INSERT INTO `oauth2_refresh_token` VALUES ('1618283558394e7a8a3205f434e801ef', 27, 2, 1, '2019-06-05 22:18:51', '2019-06-05 10:18:50', '2019-06-05 10:18:50');
INSERT INTO `oauth2_refresh_token` VALUES ('162b29a9fba742988d9fbdbede5eb6f0', NULL, NULL, 1, '2019-03-12 13:24:28', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('16339e70dc5040b2b90cd9e8c21b5636', 27, 2, 1, '2019-06-20 22:29:02', '2019-06-20 10:29:02', '2019-06-20 10:29:02');
INSERT INTO `oauth2_refresh_token` VALUES ('1660aef37dcf4041ba947fbe4e7a19fe', NULL, NULL, 0, '2019-03-05 17:44:12', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1682115be0f3447baad9d323991e15b1', NULL, NULL, 1, '2019-05-05 23:47:38', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1694da346b2a4d908084134002040cc4', 27, 2, 1, '2019-08-15 04:51:50', '2019-08-14 16:51:49', '2019-08-14 16:51:49');
INSERT INTO `oauth2_refresh_token` VALUES ('1697414b481d4cb9aa8b269fb01a4e42', 27, 2, 1, '2019-07-22 22:04:43', '2019-07-22 10:04:42', '2019-07-22 10:04:42');
INSERT INTO `oauth2_refresh_token` VALUES ('169955b17f374e6597e29d52ad0accb0', 147, 1, 1, '2019-07-02 09:45:07', '2019-07-01 21:45:06', '2019-07-01 21:45:06');
INSERT INTO `oauth2_refresh_token` VALUES ('16a72b4aed44436d877aaff0548cab6b', 27, 2, 1, '2019-07-17 03:03:17', '2019-07-16 15:03:16', '2019-07-16 15:03:16');
INSERT INTO `oauth2_refresh_token` VALUES ('16d2b6e67b414e848e37a7a6932382a1', 27, 2, 1, '2019-06-27 22:55:18', '2019-06-27 10:55:18', '2019-06-27 10:55:18');
INSERT INTO `oauth2_refresh_token` VALUES ('1705f3cc19c04570b480a16df5913a2b', 223, 1, 1, '2019-09-06 05:16:11', '2019-09-05 17:16:11', '2019-09-05 17:16:11');
INSERT INTO `oauth2_refresh_token` VALUES ('170f881ec1c64bbfbd8f593d57ebaa80', 27, 2, 1, '2019-06-02 04:45:33', '2019-06-01 16:45:32', '2019-06-01 16:45:32');
INSERT INTO `oauth2_refresh_token` VALUES ('1710a2de28984e93b74acfb17853c9ce', NULL, NULL, 1, '2019-05-10 12:01:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1727db50a7af45b6a645c147c5c2866f', 27, 2, 1, '2019-08-22 06:02:44', '2019-08-21 18:02:43', '2019-08-21 18:02:43');
INSERT INTO `oauth2_refresh_token` VALUES ('172b918e72cc47328a7a41086f7d47ce', 27, 2, 1, '2019-08-06 21:23:56', '2019-08-06 09:23:56', '2019-08-06 09:23:56');
INSERT INTO `oauth2_refresh_token` VALUES ('173a22cd13244c7fb930430f0d70a78e', 27, 2, 1, '2019-06-20 21:56:19', '2019-06-20 09:56:18', '2019-06-20 09:56:18');
INSERT INTO `oauth2_refresh_token` VALUES ('174f089f005f45f78421c81157761d38', 27, 2, 1, '2019-06-11 12:14:37', '2019-06-11 00:14:37', '2019-06-11 00:14:37');
INSERT INTO `oauth2_refresh_token` VALUES ('17615a1f2a164df7b6b689b9dde09135', 27, 2, 1, '2019-06-04 02:07:00', '2019-06-03 14:06:59', '2019-06-03 14:06:59');
INSERT INTO `oauth2_refresh_token` VALUES ('176b927cdd8d4be6b019ef0349c5dfba', 1, 2, 0, '2019-08-21 03:41:45', '2019-08-20 15:41:44', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('1773cddf3f9346e6beb4c4dd6f6249fe', NULL, NULL, 1, '2019-05-06 04:22:03', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('178d20b6402646aba1c63275691b16b8', 27, 2, 1, '2019-06-04 22:09:17', '2019-06-04 10:09:17', '2019-06-04 10:09:17');
INSERT INTO `oauth2_refresh_token` VALUES ('17a5685637ff444ab69b477909af9e94', 27, 2, 1, '2019-06-04 21:39:30', '2019-06-04 09:39:29', '2019-06-04 09:39:29');
INSERT INTO `oauth2_refresh_token` VALUES ('17ab9ab27abd476f8fae04fceeffa58b', 27, 2, 1, '2019-06-20 21:41:04', '2019-06-20 09:41:03', '2019-06-20 09:41:03');
INSERT INTO `oauth2_refresh_token` VALUES ('17c57ae9f7774cc8817187af0f3e368f', 27, 2, 1, '2019-08-27 21:42:32', '2019-08-27 09:42:31', '2019-08-27 09:42:31');
INSERT INTO `oauth2_refresh_token` VALUES ('17c63d46f91a499bb7c1700c8f3e8420', 1, 2, 0, '2019-07-19 22:49:58', '2019-07-19 10:49:57', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('17d9ec1d382e4bdbb554767285e9d501', 27, 2, 1, '2019-06-25 21:35:26', '2019-06-25 09:35:26', '2019-06-25 09:35:26');
INSERT INTO `oauth2_refresh_token` VALUES ('17da5494009a4424aced0d3bfabe0c48', 27, 2, 1, '2019-06-08 02:04:23', '2019-06-07 14:04:23', '2019-06-07 14:04:23');
INSERT INTO `oauth2_refresh_token` VALUES ('17f4ee36dc1e450fbda82b0edddbb428', 27, 2, 1, '2019-06-10 10:02:58', '2019-06-09 22:02:57', '2019-06-09 22:02:57');
INSERT INTO `oauth2_refresh_token` VALUES ('181a023155a34c4f8169f1ce1aec3a3a', 186, 1, 1, '2019-08-01 04:40:21', '2019-07-31 16:40:20', '2019-07-31 16:40:20');
INSERT INTO `oauth2_refresh_token` VALUES ('1827c2fb8c2d4d639443defa2b9a6344', 27, 2, 1, '2019-07-11 08:07:24', '2019-07-10 20:07:23', '2019-07-10 20:07:23');
INSERT INTO `oauth2_refresh_token` VALUES ('184351f002ec4ffeb2ed64c7d1caa7aa', 1, 2, 0, '2019-05-21 04:01:26', '2019-05-20 16:01:25', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('185320b1a1ee4f5485a728c0472352df', 27, 2, 1, '2019-08-01 04:26:37', '2019-07-31 16:26:37', '2019-07-31 16:26:37');
INSERT INTO `oauth2_refresh_token` VALUES ('18553727102d48c9b662944219749043', 27, 2, 1, '2019-07-29 05:28:26', '2019-07-28 17:28:25', '2019-07-28 17:28:25');
INSERT INTO `oauth2_refresh_token` VALUES ('18599ca8d6f740068f681777ae2a614e', 27, 2, 1, '2019-06-05 23:46:23', '2019-06-05 11:46:23', '2019-06-05 11:46:23');
INSERT INTO `oauth2_refresh_token` VALUES ('185f97923c1d46f399a4ced3f4360492', 27, 2, 1, '2019-06-04 06:13:07', '2019-06-03 18:13:06', '2019-06-03 18:13:06');
INSERT INTO `oauth2_refresh_token` VALUES ('18752207bd7545c1881ed658698772b8', 27, 2, 1, '2019-09-02 06:25:53', '2019-09-01 18:25:52', '2019-09-01 18:25:52');
INSERT INTO `oauth2_refresh_token` VALUES ('18814af794f14b0e8d6216c8b82eed51', NULL, NULL, 1, '2019-05-04 04:47:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('188482753cd848ef8409d3fd076d6f8f', 27, 2, 1, '2019-08-15 10:27:35', '2019-08-14 22:27:34', '2019-08-14 22:27:34');
INSERT INTO `oauth2_refresh_token` VALUES ('188b2962940f42e2a4c40783e237283f', 27, 2, 1, '2019-06-06 02:20:12', '2019-06-05 14:20:11', '2019-06-05 14:20:11');
INSERT INTO `oauth2_refresh_token` VALUES ('189a48158cf049a3aec9abec81ef6251', 27, 2, 1, '2019-07-17 01:40:01', '2019-07-16 13:40:01', '2019-07-16 13:40:01');
INSERT INTO `oauth2_refresh_token` VALUES ('18a075e4a4f942a892c090667144a741', 27, 2, 1, '2019-06-07 05:08:24', '2019-06-06 17:08:24', '2019-06-06 17:08:24');
INSERT INTO `oauth2_refresh_token` VALUES ('18c3c1bf9beb413cb218fb89d92036ab', 27, 2, 1, '2019-06-16 23:57:48', '2019-06-16 11:57:48', '2019-06-16 11:57:48');
INSERT INTO `oauth2_refresh_token` VALUES ('18c99d34796849febb3bcc2d779a4fc9', 27, 2, 1, '2019-06-26 04:56:36', '2019-06-25 16:56:36', '2019-06-25 16:56:36');
INSERT INTO `oauth2_refresh_token` VALUES ('18d98fc4e8f544d3a283ef5757f71296', 27, 2, 1, '2019-07-06 03:02:27', '2019-07-05 15:02:27', '2019-07-05 15:02:27');
INSERT INTO `oauth2_refresh_token` VALUES ('18e7b73369294fa0b4c5b600b67a392f', 27, 2, 1, '2019-06-03 22:57:45', '2019-06-03 10:57:45', '2019-06-03 10:57:45');
INSERT INTO `oauth2_refresh_token` VALUES ('18f1c17a3cff40c2abbb6edd4be245bd', 1, 2, 0, '2019-07-05 22:24:01', '2019-07-05 10:24:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('190bbd101b6a4b00898801c0e2fd3141', 27, 2, 1, '2019-08-13 20:56:22', '2019-08-13 08:56:22', '2019-08-13 08:56:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1916f8bf70694dafb2d6f5fcf0979632', 27, 2, 1, '2019-08-20 21:32:05', '2019-08-20 09:32:04', '2019-08-20 09:32:04');
INSERT INTO `oauth2_refresh_token` VALUES ('19242283be7841f19f35056f33497f22', 27, 2, 1, '2019-08-05 00:00:25', '2019-08-04 12:00:24', '2019-08-04 12:00:24');
INSERT INTO `oauth2_refresh_token` VALUES ('193a1fea592e44a383edd4da0ab54400', 27, 2, 1, '2019-09-04 01:40:09', '2019-09-03 13:40:08', '2019-09-03 13:40:08');
INSERT INTO `oauth2_refresh_token` VALUES ('193c12ea9c054f9fae0aa715dfa1c1cc', 111, 1, 1, '2019-06-08 01:49:30', '2019-06-07 13:49:30', '2019-06-07 13:49:30');
INSERT INTO `oauth2_refresh_token` VALUES ('195009b8006947bf840e2281d0dc1632', 27, 2, 1, '2019-07-19 05:07:47', '2019-07-18 17:07:47', '2019-07-18 17:07:47');
INSERT INTO `oauth2_refresh_token` VALUES ('1952876b03684175bf54aa4e33ebbad5', 162, 1, 1, '2019-07-10 02:35:46', '2019-07-09 14:35:46', '2019-07-09 14:35:46');
INSERT INTO `oauth2_refresh_token` VALUES ('1965e2a32b5a48dab616139d6af4156a', 27, 2, 1, '2019-08-04 09:14:27', '2019-08-03 21:14:26', '2019-08-03 21:14:26');
INSERT INTO `oauth2_refresh_token` VALUES ('198f93b7e54a468fb95dfb9d55605e3d', 27, 2, 1, '2019-06-04 01:21:18', '2019-06-03 13:21:17', '2019-06-03 13:21:17');
INSERT INTO `oauth2_refresh_token` VALUES ('1994dda719ed45a8a9c1b4fef3fe2b2f', 27, 2, 1, '2019-06-28 23:26:01', '2019-06-28 11:26:00', '2019-06-28 11:26:00');
INSERT INTO `oauth2_refresh_token` VALUES ('19a8b51051834189a49028d4a15a9463', NULL, NULL, 1, '2019-05-13 22:58:07', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('19aeb7d715424b7786a94f8b29b571ec', 27, 2, 1, '2019-06-14 04:04:09', '2019-06-13 16:04:09', '2019-06-13 16:04:09');
INSERT INTO `oauth2_refresh_token` VALUES ('19c242494ed24029a6bec772f247be95', 27, 2, 1, '2019-07-11 10:35:26', '2019-07-10 22:35:25', '2019-07-10 22:35:25');
INSERT INTO `oauth2_refresh_token` VALUES ('19d5f23dc91a4c5baf9f319d29b8e958', NULL, NULL, 1, '2019-04-30 02:05:42', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('19ddaf16b1d845f9948c1e23c1b84906', 27, 2, 1, '2019-05-28 06:12:33', '2019-05-27 18:12:33', '2019-05-27 18:12:33');
INSERT INTO `oauth2_refresh_token` VALUES ('19e861b455b74fb899ea274074360a0e', 27, 2, 1, '2019-07-10 05:36:48', '2019-07-09 17:36:48', '2019-07-09 17:36:48');
INSERT INTO `oauth2_refresh_token` VALUES ('1a15fe74529f4d639a17b9251205ddbb', 27, 2, 1, '2019-05-31 03:00:21', '2019-05-30 15:00:20', '2019-05-30 15:00:20');
INSERT INTO `oauth2_refresh_token` VALUES ('1a1b4e1c18d045f7b6d383af94c9f498', 27, 2, 1, '2019-06-02 00:35:37', '2019-06-01 12:35:36', '2019-06-01 12:35:36');
INSERT INTO `oauth2_refresh_token` VALUES ('1a1bbf00130b4d809ac11b7586d40069', 27, 2, 1, '2019-07-05 08:02:20', '2019-07-04 20:02:19', '2019-07-04 20:02:19');
INSERT INTO `oauth2_refresh_token` VALUES ('1a2ac79deb214be9bd95948628d6cd8c', 27, 2, 1, '2019-07-01 12:06:45', '2019-07-01 00:06:44', '2019-07-01 00:06:44');
INSERT INTO `oauth2_refresh_token` VALUES ('1a31848b9ed44954976e57d95aa6fdde', 27, 2, 1, '2019-05-29 10:19:49', '2019-05-28 22:19:49', '2019-05-28 22:19:49');
INSERT INTO `oauth2_refresh_token` VALUES ('1a55769fff564990a7d60dc8ec778ab1', 27, 2, 1, '2019-08-22 23:42:02', '2019-08-22 11:42:02', '2019-08-22 11:42:02');
INSERT INTO `oauth2_refresh_token` VALUES ('1a55f8af40d44832934821d6c643442f', 27, 2, 1, '2019-07-24 01:41:20', '2019-07-23 13:41:20', '2019-07-23 13:41:20');
INSERT INTO `oauth2_refresh_token` VALUES ('1a599a741df14c5c81e7d5fec3bb10c5', 1, 2, 0, '2019-08-23 21:34:06', '2019-08-23 09:34:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('1a5db6fd378f4d68a2ef1c91cd0312a2', 27, 2, 1, '2019-08-31 03:40:15', '2019-08-30 15:40:15', '2019-08-30 15:40:15');
INSERT INTO `oauth2_refresh_token` VALUES ('1a5ee8c1890a4cb0afa4d567a15d3165', NULL, NULL, 1, '2019-05-14 00:36:07', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1a62fb80dc7e4cdaa7dd088cb75c9c63', 27, 2, 1, '2019-08-05 09:06:00', '2019-08-04 21:06:00', '2019-08-04 21:06:00');
INSERT INTO `oauth2_refresh_token` VALUES ('1a6c4a75478847d8b4e68cebeb5e3b8c', NULL, NULL, 1, '2019-04-25 09:18:24', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1a790d454c784259b78fbd42d94cb146', 27, 2, 1, '2019-08-22 04:42:47', '2019-08-21 16:42:47', '2019-08-21 16:42:47');
INSERT INTO `oauth2_refresh_token` VALUES ('1a82039577c34d60a67605477ba79196', 27, 2, 1, '2019-08-20 05:57:36', '2019-08-19 17:57:35', '2019-08-19 17:57:35');
INSERT INTO `oauth2_refresh_token` VALUES ('1ab8f0dcdfd14ce9bd3a03d9bdf7a970', 27, 2, 1, '2019-06-04 03:41:36', '2019-06-03 15:41:36', '2019-06-03 15:41:36');
INSERT INTO `oauth2_refresh_token` VALUES ('1acf8ae870f342f1a0c6e6abd1e21526', 27, 2, 1, '2019-06-02 02:21:26', '2019-06-01 14:21:26', '2019-06-01 14:21:26');
INSERT INTO `oauth2_refresh_token` VALUES ('1ae98ba9f59f4c8383de24cca34f18bf', 27, 2, 1, '2019-05-23 23:08:22', '2019-05-23 11:08:21', '2019-05-23 11:08:21');
INSERT INTO `oauth2_refresh_token` VALUES ('1aec688d9d6a4d43ad1cb7f522d460ce', 27, 2, 1, '2019-07-27 02:12:31', '2019-07-26 14:12:31', '2019-07-26 14:12:31');
INSERT INTO `oauth2_refresh_token` VALUES ('1aeeaa7cd0d242f9ac8f8c957e901c39', NULL, NULL, 1, '2019-05-07 10:44:34', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1af142c16da84533bdfaa26cf5290f88', 27, 2, 1, '2019-07-21 08:42:50', '2019-07-20 20:42:50', '2019-07-20 20:42:50');
INSERT INTO `oauth2_refresh_token` VALUES ('1b066db6175143a5b5ea60a9ef1723e1', NULL, NULL, 1, '2019-03-10 15:34:05', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1b14898e58aa403f8ee07d669b8b3f5e', 27, 2, 1, '2019-07-30 01:52:55', '2019-07-29 13:52:54', '2019-07-29 13:52:54');
INSERT INTO `oauth2_refresh_token` VALUES ('1b4c5fcf0d7e4226a57bb093c2f513b0', 27, 2, 1, '2019-06-01 22:32:24', '2019-06-01 10:32:24', '2019-06-01 10:32:24');
INSERT INTO `oauth2_refresh_token` VALUES ('1b709c32ddd14ef881dfe0c4d0844d2e', 220, 1, 1, '2019-09-05 22:18:07', '2019-09-05 10:18:07', '2019-09-05 10:18:07');
INSERT INTO `oauth2_refresh_token` VALUES ('1b711c38e7b44173a5a2dc23988255d1', 27, 2, 1, '2019-08-31 05:15:56', '2019-08-30 17:15:56', '2019-08-30 17:15:56');
INSERT INTO `oauth2_refresh_token` VALUES ('1b824bfe52e44c8e914d60708e1d963a', 27, 2, 1, '2019-08-24 04:59:15', '2019-08-23 16:59:15', '2019-08-23 16:59:15');
INSERT INTO `oauth2_refresh_token` VALUES ('1b838e708e274601b753e9b5d5ecfcfd', 27, 2, 1, '2019-09-05 08:48:46', '2019-09-04 20:48:45', '2019-09-04 20:48:45');
INSERT INTO `oauth2_refresh_token` VALUES ('1b8a88b7abdd43998d1dadfc945cbc95', NULL, NULL, 1, '2019-05-05 06:25:04', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1ba08862eccd4def811b3b824337dcff', 27, 2, 1, '2019-07-29 11:26:27', '2019-07-28 23:26:26', '2019-07-28 23:26:26');
INSERT INTO `oauth2_refresh_token` VALUES ('1baf4e13d4f34e2a8d2efe9116214133', 27, 2, 1, '2019-07-11 21:06:44', '2019-07-11 09:06:43', '2019-07-11 09:06:43');
INSERT INTO `oauth2_refresh_token` VALUES ('1bb8e95e0ac1487d931eea2279c048ae', 27, 2, 1, '2019-06-15 03:04:05', '2019-06-14 15:04:05', '2019-06-14 15:04:05');
INSERT INTO `oauth2_refresh_token` VALUES ('1bc0613bdc9c4bc4af5387777d2a27a0', NULL, NULL, 1, '2019-03-21 07:09:50', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1bc753506ef5458da6e261253188ccb8', 27, 2, 1, '2019-06-06 23:44:20', '2019-06-06 11:44:20', '2019-06-06 11:44:20');
INSERT INTO `oauth2_refresh_token` VALUES ('1bd50bc89ed2487a95e37991d3ae07e8', 27, 2, 1, '2019-07-27 04:38:03', '2019-07-26 16:38:03', '2019-07-26 16:38:03');
INSERT INTO `oauth2_refresh_token` VALUES ('1bd8f209984c4c339807c866afde56a6', 27, 2, 1, '2019-08-26 11:54:56', '2019-08-25 23:54:56', '2019-08-25 23:54:56');
INSERT INTO `oauth2_refresh_token` VALUES ('1bef1832f47845acb27a4c53d607b3eb', 27, 2, 1, '2019-06-01 09:20:46', '2019-05-31 21:20:46', '2019-05-31 21:20:46');
INSERT INTO `oauth2_refresh_token` VALUES ('1bf9dde1231446ed85cf500a272db4a3', 27, 2, 1, '2019-06-05 22:04:37', '2019-06-05 10:04:36', '2019-06-05 10:04:36');
INSERT INTO `oauth2_refresh_token` VALUES ('1bfdae4e56d64449ae52abfc1d1936ec', 27, 2, 1, '2019-06-20 23:26:15', '2019-06-20 11:26:15', '2019-06-20 11:26:15');
INSERT INTO `oauth2_refresh_token` VALUES ('1c40c8f76de44570956d2bbe773fdb90', 27, 2, 1, '2019-08-28 11:17:01', '2019-08-27 23:17:00', '2019-08-27 23:17:00');
INSERT INTO `oauth2_refresh_token` VALUES ('1c59834f6b1446dab5c1f6f439747381', NULL, NULL, 1, '2019-03-13 11:29:32', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1c623ed5311d4e3b9ca4d42c87f20720', NULL, NULL, 1, '2019-05-02 10:00:19', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1c6316c1f302420b88d78a0763f39ba5', 27, 2, 1, '2019-08-09 21:30:14', '2019-08-09 09:30:14', '2019-08-09 09:30:14');
INSERT INTO `oauth2_refresh_token` VALUES ('1c6cfc2b73954fc8a1b87c58e5b33d4f', 173, 1, 1, '2019-07-17 19:32:39', '2019-07-17 07:32:39', '2019-07-17 07:32:39');
INSERT INTO `oauth2_refresh_token` VALUES ('1c81496ff20b42d29da30d668eef1233', NULL, NULL, 1, '2019-05-11 10:13:47', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1c82bad7df1449ffa38a55cc7ad3f0a1', 27, 2, 1, '2019-08-14 10:26:59', '2019-08-13 22:26:59', '2019-08-13 22:26:59');
INSERT INTO `oauth2_refresh_token` VALUES ('1c94897b271a441586dbb7a6d31e1d52', NULL, NULL, 1, '2019-04-04 06:18:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1cb4635c5c254ab2a59c89c0d2b4e21f', NULL, NULL, 0, '2019-03-04 10:12:25', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1cef57a8a2ed44d4b3b16e40f938e334', 27, 2, 1, '2019-08-21 21:50:19', '2019-08-21 09:50:18', '2019-08-21 09:50:18');
INSERT INTO `oauth2_refresh_token` VALUES ('1cf1efa56e8c459986330a7cc7f88e46', NULL, NULL, 0, '2019-02-28 16:54:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1cf486bf835149a687ccf68f38d091ec', 27, 2, 1, '2019-08-01 22:23:52', '2019-08-01 10:23:51', '2019-08-01 10:23:51');
INSERT INTO `oauth2_refresh_token` VALUES ('1d1c0c552fbd4e66b36182bc314b7a6c', NULL, NULL, 1, '2019-03-10 22:09:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1d2d80f4557740b2bad4bcd572a4d090', 27, 2, 1, '2019-06-02 03:59:33', '2019-06-01 15:59:33', '2019-06-01 15:59:33');
INSERT INTO `oauth2_refresh_token` VALUES ('1d36dbfec9104232adc4e4b65197e357', 27, 2, 1, '2019-07-25 05:15:26', '2019-07-24 17:15:26', '2019-07-24 17:15:26');
INSERT INTO `oauth2_refresh_token` VALUES ('1d67346572c8437da83551edb3bded32', 27, 2, 1, '2019-06-15 07:12:15', '2019-06-14 19:12:15', '2019-06-14 19:12:15');
INSERT INTO `oauth2_refresh_token` VALUES ('1d6ced9548274cc6b4ba5217b05ca1fa', 27, 2, 1, '2019-06-02 22:57:14', '2019-06-02 10:57:13', '2019-06-02 10:57:13');
INSERT INTO `oauth2_refresh_token` VALUES ('1d998cc166b54ff9947665fa43943b0d', 27, 2, 1, '2019-07-06 03:54:57', '2019-07-05 15:54:57', '2019-07-05 15:54:57');
INSERT INTO `oauth2_refresh_token` VALUES ('1de0107733884a5f8708ceaa365e2279', 27, 2, 1, '2019-06-02 02:02:07', '2019-06-01 14:02:07', '2019-06-01 14:02:07');
INSERT INTO `oauth2_refresh_token` VALUES ('1df3fb5ddf654549b32a6b104fe87cdf', NULL, NULL, 1, '2019-03-11 18:42:12', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1e4d04def37d42aba27057f2b3ee2c5a', 177, 1, 1, '2019-07-20 08:08:56', '2019-07-19 20:08:55', '2019-07-19 20:08:55');
INSERT INTO `oauth2_refresh_token` VALUES ('1e56a4038f2843738a486c25d5671232', 27, 2, 1, '2019-06-04 04:22:12', '2019-06-03 16:22:11', '2019-06-03 16:22:11');
INSERT INTO `oauth2_refresh_token` VALUES ('1e68e85ea97a4a4596d4e95982dedf46', NULL, NULL, 1, '2019-04-10 02:03:30', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1e71db772b064f94b1560b4fe2950d05', 27, 2, 1, '2019-09-06 22:14:01', '2019-09-06 10:14:00', '2019-09-06 10:14:00');
INSERT INTO `oauth2_refresh_token` VALUES ('1e846bb6cc6e457090bf80157b144ccf', 27, 2, 1, '2019-08-16 03:49:33', '2019-08-15 15:49:32', '2019-08-15 15:49:32');
INSERT INTO `oauth2_refresh_token` VALUES ('1eab79ffb3964b76a1d126a60bbc4cbc', 27, 2, 1, '2019-08-05 11:32:48', '2019-08-04 23:32:48', '2019-08-04 23:32:48');
INSERT INTO `oauth2_refresh_token` VALUES ('1eb7ecff47d745bda64ed50099475e0d', NULL, NULL, 1, '2019-03-23 02:19:50', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1ebb82d3cb4a4ec9b20d6a68a7227213', 27, 2, 1, '2019-06-21 00:16:16', '2019-06-20 12:16:15', '2019-06-20 12:16:15');
INSERT INTO `oauth2_refresh_token` VALUES ('1ed0b75578ec432b9779cda17824ae0d', 27, 2, 1, '2019-06-11 07:50:26', '2019-06-10 19:50:25', '2019-06-10 19:50:25');
INSERT INTO `oauth2_refresh_token` VALUES ('1f05a8c6a14d4c17a990431982bacbcc', 27, 2, 1, '2019-05-24 10:55:24', '2019-05-23 22:55:24', '2019-05-23 22:55:24');
INSERT INTO `oauth2_refresh_token` VALUES ('1f075650bb2a462f9793da434c1db0a2', NULL, NULL, 0, '2019-03-04 10:13:16', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1f1add486bad4e8bbc1b3270bf960599', 1, 2, 0, '2019-05-31 02:26:47', '2019-05-30 14:26:47', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('1f35aaa913344324aa0c76eea5b79a53', 27, 2, 1, '2019-06-28 22:00:05', '2019-06-28 10:00:04', '2019-06-28 10:00:04');
INSERT INTO `oauth2_refresh_token` VALUES ('1f3ab0a46c3148499b6cfd027f819778', 27, 2, 1, '2019-07-11 02:25:57', '2019-07-10 14:25:56', '2019-07-10 14:25:56');
INSERT INTO `oauth2_refresh_token` VALUES ('1f40f28d36b84c9faa3a3a23d39d8165', 27, 2, 1, '2019-07-05 04:36:40', '2019-07-04 16:36:40', '2019-07-04 16:36:40');
INSERT INTO `oauth2_refresh_token` VALUES ('1f447411f82a4669ad4bbcbe6bda23b4', 27, 2, 1, '2019-09-04 21:41:37', '2019-09-04 09:41:37', '2019-09-04 09:41:37');
INSERT INTO `oauth2_refresh_token` VALUES ('1f4f485d904a4c60a0d7a371a4ef84c1', 1, 2, 0, '2019-07-27 03:25:49', '2019-07-26 15:25:48', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('1f84b982454240a5aacfea5e270caa6f', 27, 2, 1, '2019-06-05 03:52:29', '2019-06-04 15:52:28', '2019-06-04 15:52:28');
INSERT INTO `oauth2_refresh_token` VALUES ('1f8c7c44d1934acfa67dc9b50ea0b0e0', 27, 2, 1, '2019-07-27 01:46:33', '2019-07-26 13:46:33', '2019-07-26 13:46:33');
INSERT INTO `oauth2_refresh_token` VALUES ('1f9a0474e43549de9e5558cc812502df', 27, 2, 1, '2019-05-31 20:15:47', '2019-05-31 08:15:47', '2019-05-31 08:15:47');
INSERT INTO `oauth2_refresh_token` VALUES ('1fa235dde93d41d5a3f6ecf406fc5306', NULL, NULL, 1, '2019-03-22 05:57:26', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('1fbc4550443945ab9786df843735c3fc', 27, 2, 1, '2019-06-03 05:37:34', '2019-06-02 17:37:33', '2019-06-02 17:37:33');
INSERT INTO `oauth2_refresh_token` VALUES ('1fe9b23122034f6b9d230378eb1c3636', 1, 2, 0, '2019-08-17 05:36:36', '2019-08-16 17:36:35', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('20099b1bb0d44bf8a754126a4400da66', 27, 2, 1, '2019-06-12 23:56:59', '2019-06-12 11:56:58', '2019-06-12 11:56:58');
INSERT INTO `oauth2_refresh_token` VALUES ('200bc0ef0dec43ee8b2af359d1a52f3d', 27, 2, 1, '2019-08-16 03:02:40', '2019-08-15 15:02:40', '2019-08-15 15:02:40');
INSERT INTO `oauth2_refresh_token` VALUES ('203c3776e8094068aac0843d778039cf', 27, 2, 1, '2019-05-24 04:10:57', '2019-05-23 16:10:56', '2019-05-23 16:10:56');
INSERT INTO `oauth2_refresh_token` VALUES ('204722b528ef4d878169a5bc9cff7aa0', 27, 2, 1, '2019-06-03 20:29:12', '2019-06-03 08:29:12', '2019-06-03 08:29:12');
INSERT INTO `oauth2_refresh_token` VALUES ('2053fc9db6074f5992b5075880ca5b7e', 100, 1, 1, '2019-06-03 06:10:33', '2019-06-02 18:10:33', '2019-06-02 18:10:33');
INSERT INTO `oauth2_refresh_token` VALUES ('20626b40a62d4229a7eeccfb9006a21e', 27, 2, 1, '2019-07-05 10:30:18', '2019-07-04 22:30:18', '2019-07-04 22:30:18');
INSERT INTO `oauth2_refresh_token` VALUES ('206614804dc742e1ac90501b725cbcff', 1, 2, 0, '2019-09-03 11:45:07', '2019-09-02 23:45:07', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('206ff78aad574895869a12da603e232f', 27, 2, 1, '2019-07-09 05:28:26', '2019-07-08 17:28:26', '2019-07-08 17:28:26');
INSERT INTO `oauth2_refresh_token` VALUES ('20a11d0302504616a902da051efbe950', 1, 1, 1, '2019-05-18 05:46:12', '2019-05-17 17:46:11', '2019-05-17 17:46:11');
INSERT INTO `oauth2_refresh_token` VALUES ('20ccd60e391c4043961a7bf49493ef6a', 27, 2, 1, '2019-06-02 09:28:29', '2019-06-01 21:28:29', '2019-06-01 21:28:29');
INSERT INTO `oauth2_refresh_token` VALUES ('20efd531e6424a43ad1a9da5ad720072', 27, 2, 1, '2019-07-10 11:33:30', '2019-07-09 23:33:29', '2019-07-09 23:33:29');
INSERT INTO `oauth2_refresh_token` VALUES ('2102d892dfd6467688fdb205b3e174ca', 27, 2, 1, '2019-06-03 22:59:27', '2019-06-03 10:59:27', '2019-06-03 10:59:27');
INSERT INTO `oauth2_refresh_token` VALUES ('213f981c4e864f7b82e27e59d00bf136', 27, 2, 1, '2019-06-25 23:31:06', '2019-06-25 11:31:05', '2019-06-25 11:31:05');
INSERT INTO `oauth2_refresh_token` VALUES ('214238430e4e4ba28e8150dd17a50a13', NULL, NULL, 1, '2019-05-05 01:45:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('215c585ca6d44c448268fec5892433b6', 27, 2, 1, '2019-07-18 21:13:21', '2019-07-18 09:13:21', '2019-07-18 09:13:21');
INSERT INTO `oauth2_refresh_token` VALUES ('2167bedd2f2e49a5a8c68b1c9502e7e3', 1, 2, 0, '2019-06-01 04:01:27', '2019-05-31 16:01:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('2167ea26e59d4be1807e8d510f130d77', NULL, NULL, 1, '2019-05-14 02:47:26', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('217782d1d285494fb5b32063867912fa', 27, 2, 1, '2019-08-13 03:49:17', '2019-08-12 15:49:16', '2019-08-12 15:49:16');
INSERT INTO `oauth2_refresh_token` VALUES ('21a5004f3297473d8127c3f0bc804b73', 27, 2, 1, '2019-07-16 05:08:55', '2019-07-15 17:08:54', '2019-07-15 17:08:54');
INSERT INTO `oauth2_refresh_token` VALUES ('21c5fcf663ea4462a2beb9909c2c4f50', 27, 2, 1, '2019-06-24 22:02:08', '2019-06-24 10:02:08', '2019-06-24 10:02:08');
INSERT INTO `oauth2_refresh_token` VALUES ('21c88f6e515b4c72a1a2807d3f22f617', 161, 1, 1, '2019-07-09 10:37:08', '2019-07-08 22:37:08', '2019-07-08 22:37:08');
INSERT INTO `oauth2_refresh_token` VALUES ('21e663cabcad4392b05ad60e4c9bf1b4', 27, 2, 1, '2019-06-21 01:44:18', '2019-06-20 13:44:18', '2019-06-20 13:44:18');
INSERT INTO `oauth2_refresh_token` VALUES ('22113d09591145eabce89907fd5dc749', 27, 2, 1, '2019-06-04 23:14:15', '2019-06-04 11:14:14', '2019-06-04 11:14:14');
INSERT INTO `oauth2_refresh_token` VALUES ('2217997ed6ef4158939cf55a45abc467', 27, 2, 1, '2019-09-05 21:21:52', '2019-09-05 09:21:51', '2019-09-05 09:21:51');
INSERT INTO `oauth2_refresh_token` VALUES ('221c920126d1439790d92c1fc118c532', 27, 2, 1, '2019-05-28 05:31:58', '2019-05-27 17:31:57', '2019-05-27 17:31:57');
INSERT INTO `oauth2_refresh_token` VALUES ('223a6e71a6df41feaa41570c966f4f6f', 27, 2, 1, '2019-05-21 09:32:57', '2019-05-20 21:32:56', '2019-05-20 21:32:56');
INSERT INTO `oauth2_refresh_token` VALUES ('225c1c4e221f4348b6ee0e15aa86751f', 27, 2, 1, '2019-07-08 23:06:37', '2019-07-08 11:06:36', '2019-07-08 11:06:36');
INSERT INTO `oauth2_refresh_token` VALUES ('2263922f804a4e728e44533130340b97', 1, 2, 0, '2019-07-05 03:46:06', '2019-07-04 15:46:06', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('226fafe8f33f474488962df8bf212b41', 27, 2, 1, '2019-07-06 02:52:04', '2019-07-05 14:52:03', '2019-07-05 14:52:03');
INSERT INTO `oauth2_refresh_token` VALUES ('2271639ad22646c8a5c846e95dfc67c9', NULL, NULL, 1, '2019-04-25 03:35:12', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2280a6ea23154c5db0c143efc56529bb', 27, 2, 1, '2019-07-23 23:17:09', '2019-07-23 11:17:09', '2019-07-23 11:17:09');
INSERT INTO `oauth2_refresh_token` VALUES ('2291c3aaa034430bb97997feb73fd687', 27, 2, 1, '2019-09-06 22:54:36', '2019-09-06 10:54:36', '2019-09-06 10:54:36');
INSERT INTO `oauth2_refresh_token` VALUES ('22bf142c176f4d8ba8601a8d96cc3eb5', NULL, NULL, 1, '2019-05-09 11:09:37', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('22c3185bebd14af1995cca7e353159ca', 27, 2, 1, '2019-06-07 03:51:59', '2019-06-06 15:51:58', '2019-06-06 15:51:58');
INSERT INTO `oauth2_refresh_token` VALUES ('22c68ae929174053af883df1aca99a08', NULL, NULL, 1, '2019-05-02 09:00:05', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('22da87f23d364b3781f18e27ebd98a87', 1, 2, 0, '2019-09-03 11:47:00', '2019-09-02 23:46:59', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('22f72aec6ebb4773ae3981be7b6501bb', 27, 2, 1, '2019-08-09 04:42:45', '2019-08-08 16:42:44', '2019-08-08 16:42:44');
INSERT INTO `oauth2_refresh_token` VALUES ('231e393ceae24dee8d9f72f4a2861332', 27, 2, 1, '2019-08-30 22:31:44', '2019-08-30 10:31:44', '2019-08-30 10:31:44');
INSERT INTO `oauth2_refresh_token` VALUES ('2328d682d9944caf8d510c1846255042', 27, 2, 1, '2019-07-31 22:22:29', '2019-07-31 10:22:29', '2019-07-31 10:22:29');
INSERT INTO `oauth2_refresh_token` VALUES ('2334c01fe6de429fa6de23ac0bcf3acf', NULL, NULL, 1, '2019-03-31 05:15:04', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2348af4614fb4b42bc7c0a7b698a5115', 27, 2, 1, '2019-06-21 04:58:22', '2019-06-20 16:58:21', '2019-06-20 16:58:21');
INSERT INTO `oauth2_refresh_token` VALUES ('23544bea59a94d279e1743d4a8e16324', 27, 2, 1, '2019-08-09 02:59:01', '2019-08-08 14:59:01', '2019-08-08 14:59:01');
INSERT INTO `oauth2_refresh_token` VALUES ('235b294a658c4751ad18635a08611872', 27, 2, 1, '2019-06-30 09:08:44', '2019-06-29 21:08:44', '2019-06-29 21:08:44');
INSERT INTO `oauth2_refresh_token` VALUES ('2360735ad9644ac7b860490a123a51af', 27, 2, 1, '2019-07-28 10:12:57', '2019-07-27 22:12:57', '2019-07-27 22:12:57');
INSERT INTO `oauth2_refresh_token` VALUES ('237bc6d20ae44c38a145a4e1748b3ac7', 27, 2, 1, '2019-06-02 03:46:15', '2019-06-01 15:46:14', '2019-06-01 15:46:14');
INSERT INTO `oauth2_refresh_token` VALUES ('238b79a0a4ad40fab7f7d09343a5ea9d', 27, 2, 1, '2019-05-25 05:47:10', '2019-05-24 17:47:09', '2019-05-24 17:47:09');
INSERT INTO `oauth2_refresh_token` VALUES ('239894a1ab154f229248c0a57976825e', 27, 2, 1, '2019-08-01 09:33:00', '2019-07-31 21:32:59', '2019-07-31 21:32:59');
INSERT INTO `oauth2_refresh_token` VALUES ('23a1e48f2fbd40e2abc4ebc3c4a310fe', NULL, NULL, 1, '2019-05-06 02:55:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('23a932a887d7454f89aeba846b42809f', 27, 2, 1, '2019-07-26 22:18:48', '2019-07-26 10:18:47', '2019-07-26 10:18:47');
INSERT INTO `oauth2_refresh_token` VALUES ('23b2937104b649cd8a95b8051b1b8991', NULL, NULL, 1, '2019-05-16 22:43:03', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('23b98ef65bf244ac8106276cc8f3af0f', 27, 2, 1, '2019-05-29 21:48:46', '2019-05-29 09:48:46', '2019-05-29 09:48:46');
INSERT INTO `oauth2_refresh_token` VALUES ('23c7cab60a974881ac702d708a6edf83', 27, 2, 1, '2019-08-05 10:13:46', '2019-08-04 22:13:45', '2019-08-04 22:13:45');
INSERT INTO `oauth2_refresh_token` VALUES ('23dd6503c3c2477583c57beeabd1e56c', NULL, NULL, 1, '2019-05-13 12:21:09', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('23fd2932f23e40e58e1ab5c2507c6219', 27, 2, 1, '2019-06-03 21:14:28', '2019-06-03 09:14:27', '2019-06-03 09:14:27');
INSERT INTO `oauth2_refresh_token` VALUES ('2410a4656ccd49a89e8e114078f999dc', 27, 2, 1, '2019-06-03 22:01:27', '2019-06-03 10:01:27', '2019-06-03 10:01:27');
INSERT INTO `oauth2_refresh_token` VALUES ('241c7f9752164896bb5c2f59b77d72e5', 27, 2, 1, '2019-06-02 22:23:35', '2019-06-02 10:23:35', '2019-06-02 10:23:35');
INSERT INTO `oauth2_refresh_token` VALUES ('242767a229f74263a80fc506b940b485', 27, 2, 1, '2019-08-09 05:39:41', '2019-08-08 17:39:40', '2019-08-08 17:39:40');
INSERT INTO `oauth2_refresh_token` VALUES ('24311d2bdaf546ef8591ba65496b3f28', NULL, NULL, 1, '2019-05-15 02:07:20', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2436b7fb8f5e4f2f933873031f815be1', NULL, NULL, 1, '2019-05-04 14:23:34', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('244ba92779df4660b5b3ba5d2adb48f7', 1, 2, 0, '2019-06-12 03:29:01', '2019-06-11 15:29:00', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('245cfecb2fe54115be170c7baa66390f', 27, 2, 1, '2019-06-13 11:22:33', '2019-06-12 23:22:33', '2019-06-12 23:22:33');
INSERT INTO `oauth2_refresh_token` VALUES ('2465fd896ccf4964ab7062a78e557b4a', 27, 2, 1, '2019-06-05 23:15:14', '2019-06-05 11:15:14', '2019-06-05 11:15:14');
INSERT INTO `oauth2_refresh_token` VALUES ('246657b443064cdcae2d65fb078cb241', 79, 1, 1, '2019-05-24 02:27:45', '2019-05-23 14:27:44', '2019-05-23 14:27:44');
INSERT INTO `oauth2_refresh_token` VALUES ('2476aac9015f40f3a3105b76b43972c3', 27, 2, 1, '2019-08-08 12:33:44', '2019-08-08 00:33:43', '2019-08-08 00:33:43');
INSERT INTO `oauth2_refresh_token` VALUES ('2478dede628846109e80276edf6c0de6', 27, 2, 1, '2019-07-22 07:13:01', '2019-07-21 19:13:00', '2019-07-21 19:13:00');
INSERT INTO `oauth2_refresh_token` VALUES ('2493b2fc3fdc4f3f97d83dfcff90afbf', 27, 2, 1, '2019-06-11 02:25:49', '2019-06-10 14:25:49', '2019-06-10 14:25:49');
INSERT INTO `oauth2_refresh_token` VALUES ('2497185ba9874e9fa66178e1b675f45c', NULL, NULL, 0, '2019-03-04 10:11:08', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2498c240c0ae47d0a1a2744a9db3d8f2', 27, 2, 1, '2019-07-12 03:15:04', '2019-07-11 15:15:03', '2019-07-11 15:15:03');
INSERT INTO `oauth2_refresh_token` VALUES ('24a1601071c54ed7ae0d7a20ceedddf8', NULL, NULL, 1, '2019-05-10 06:57:29', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('24b18caf50d64590bc797d9ca087c579', 27, 2, 1, '2019-07-27 03:44:47', '2019-07-26 15:44:46', '2019-07-26 15:44:46');
INSERT INTO `oauth2_refresh_token` VALUES ('24b73f8480db41e5ab68c2e19dd88f81', 27, 2, 1, '2019-07-02 22:54:51', '2019-07-02 10:54:51', '2019-07-02 10:54:51');
INSERT INTO `oauth2_refresh_token` VALUES ('24db243a23ef456d9737049f0494789a', 27, 2, 1, '2019-08-07 08:37:07', '2019-08-06 20:37:06', '2019-08-06 20:37:06');
INSERT INTO `oauth2_refresh_token` VALUES ('24dd5404f48b49828862243aad635d97', 27, 2, 1, '2019-08-05 21:29:00', '2019-08-05 09:29:00', '2019-08-05 09:29:00');
INSERT INTO `oauth2_refresh_token` VALUES ('24ef8ab271654d2c944759d024a2c194', NULL, NULL, 1, '2019-03-25 04:15:52', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('24f27735ce3b4ca49fd2b20454508aaf', 27, 2, 1, '2019-07-30 09:17:55', '2019-07-29 21:17:55', '2019-07-29 21:17:55');
INSERT INTO `oauth2_refresh_token` VALUES ('2507f2cf7209478e991ac980715e70ba', 27, 2, 1, '2019-08-30 20:17:14', '2019-08-30 08:17:13', '2019-08-30 08:17:13');
INSERT INTO `oauth2_refresh_token` VALUES ('25086bffb4c04c0f91f7458edfa578e7', NULL, NULL, 1, '2019-05-05 20:41:32', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('254095679e9643778390502be6232f21', NULL, NULL, 1, '2019-04-23 06:34:44', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('25749366fec74f83a90f9144b68be28e', NULL, NULL, 1, '2019-04-25 06:31:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('257c6fabc67e4468a2cd6df1858baea5', 112, 1, 1, '2019-06-08 02:30:31', '2019-06-07 14:30:31', '2019-06-07 14:30:31');
INSERT INTO `oauth2_refresh_token` VALUES ('25e8c8e501ed4d1bbf9692d0313fa9cd', 27, 2, 1, '2019-06-17 11:33:00', '2019-06-16 23:33:00', '2019-06-16 23:33:00');
INSERT INTO `oauth2_refresh_token` VALUES ('260e74b351984fd7aae71632347b47f5', 27, 2, 1, '2019-08-19 21:06:01', '2019-08-19 09:06:00', '2019-08-19 09:06:00');
INSERT INTO `oauth2_refresh_token` VALUES ('2632379da1ab423d94041e96827b8e11', 1, 2, 0, '2019-06-05 21:40:05', '2019-06-05 09:40:04', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('2632a60a96534b349423ac06a814830c', 27, 2, 1, '2019-06-27 04:32:48', '2019-06-26 16:32:48', '2019-06-26 16:32:48');
INSERT INTO `oauth2_refresh_token` VALUES ('26454d64e03949f2a764e7313866a310', 27, 2, 1, '2019-09-08 03:32:08', '2019-09-07 15:32:08', '2019-09-07 15:32:08');
INSERT INTO `oauth2_refresh_token` VALUES ('2646cda31f204beeb76364502a0dae39', 27, 2, 1, '2019-06-14 21:16:37', '2019-06-14 09:16:36', '2019-06-14 09:16:36');
INSERT INTO `oauth2_refresh_token` VALUES ('2649ac5f073a477dbbbd94af6f458775', 27, 2, 1, '2019-09-04 03:12:10', '2019-09-03 15:12:09', '2019-09-03 15:12:09');
INSERT INTO `oauth2_refresh_token` VALUES ('265c01df3a7748ca94e6b81953761638', 27, 2, 1, '2019-05-23 07:17:00', '2019-05-22 19:16:59', '2019-05-22 19:16:59');
INSERT INTO `oauth2_refresh_token` VALUES ('2683d1607fc9473dace87a371872d3af', 27, 2, 1, '2019-06-08 22:28:09', '2019-06-08 10:28:09', '2019-06-08 10:28:09');
INSERT INTO `oauth2_refresh_token` VALUES ('2684c26fb8f14ebdb3fc7a0bebc2de6d', 27, 2, 1, '2019-06-14 04:45:37', '2019-06-13 16:45:37', '2019-06-13 16:45:37');
INSERT INTO `oauth2_refresh_token` VALUES ('268fe65d580e4f339e1ec3d168fe26f8', 27, 2, 1, '2019-07-23 08:37:35', '2019-07-22 20:37:34', '2019-07-22 20:37:34');
INSERT INTO `oauth2_refresh_token` VALUES ('2691851afcc64815a9bfb64ef110410a', 27, 1, 1, '2019-05-17 12:25:12', '2019-05-17 00:25:11', '2019-05-17 00:25:11');
INSERT INTO `oauth2_refresh_token` VALUES ('26a2ca69b66f42d6b25932baee11d28a', 27, 2, 1, '2019-06-27 04:10:02', '2019-06-26 16:10:02', '2019-06-26 16:10:02');
INSERT INTO `oauth2_refresh_token` VALUES ('26a3b002691846c99086a06dbee7548d', 27, 2, 1, '2019-05-21 09:11:35', '2019-05-20 21:11:35', '2019-05-20 21:11:35');
INSERT INTO `oauth2_refresh_token` VALUES ('26b2340a809a49d590102a49219cd663', 27, 2, 1, '2019-06-10 05:08:34', '2019-06-09 17:08:33', '2019-06-09 17:08:33');
INSERT INTO `oauth2_refresh_token` VALUES ('26b2fdcae0464385af9e29534ef83124', 27, 2, 1, '2019-05-21 23:31:25', '2019-05-21 11:31:24', '2019-05-21 11:31:24');
INSERT INTO `oauth2_refresh_token` VALUES ('26c0c2ac8ab741ad98174a2ce949ea66', 27, 2, 1, '2019-06-24 23:22:01', '2019-06-24 11:22:01', '2019-06-24 11:22:01');
INSERT INTO `oauth2_refresh_token` VALUES ('26c55bca13bc49d4a310de0c7e9abc54', NULL, NULL, 1, '2019-04-07 02:51:52', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('26d3462044974d3e8d99e0366b17de2f', 27, 2, 1, '2019-05-27 09:44:05', '2019-05-26 21:44:04', '2019-05-26 21:44:04');
INSERT INTO `oauth2_refresh_token` VALUES ('26e3b54e3ff2493e88110d4909fe523b', 27, 2, 1, '2019-06-06 03:38:16', '2019-06-05 15:38:16', '2019-06-05 15:38:16');
INSERT INTO `oauth2_refresh_token` VALUES ('26f924e4f31d477a8cdaec45d6921cc8', 27, 2, 1, '2019-06-20 22:48:24', '2019-06-20 10:48:24', '2019-06-20 10:48:24');
INSERT INTO `oauth2_refresh_token` VALUES ('26f9fdde538e4de08a3ba868ff882c71', NULL, NULL, 1, '2019-05-05 02:40:50', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('27103374d1f14303a285d84b5dded6b0', NULL, NULL, 1, '2019-03-10 17:18:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2723d9dc20d34d2c8b7c46df3052c4ec', 27, 2, 1, '2019-08-24 22:06:59', '2019-08-24 10:06:58', '2019-08-24 10:06:58');
INSERT INTO `oauth2_refresh_token` VALUES ('27629965c8704307b1b765e24ac6f45e', 27, 2, 1, '2019-06-01 08:52:25', '2019-05-31 20:52:25', '2019-05-31 20:52:25');
INSERT INTO `oauth2_refresh_token` VALUES ('276dfecc04b44981b0d695909dfcd16f', 87, 1, 1, '2019-05-29 04:18:00', '2019-05-28 16:18:02', '2019-05-28 16:18:02');
INSERT INTO `oauth2_refresh_token` VALUES ('27781ce8f58b424aaa64cd138ad4d403', 27, 2, 1, '2019-05-22 23:59:26', '2019-05-22 11:59:25', '2019-05-22 11:59:25');
INSERT INTO `oauth2_refresh_token` VALUES ('27882f8a8d1a4c79903e163185ef56d9', 27, 2, 1, '2019-06-20 20:58:52', '2019-06-20 08:58:52', '2019-06-20 08:58:52');
INSERT INTO `oauth2_refresh_token` VALUES ('2791b27789a348f28b323df5401f49fe', NULL, NULL, 1, '2019-04-23 06:25:20', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('27a461499b2d4742855a846f44381c7e', 27, 2, 1, '2019-07-09 22:48:02', '2019-07-09 10:48:02', '2019-07-09 10:48:02');
INSERT INTO `oauth2_refresh_token` VALUES ('27b50af73d5843d4a88f616d8c351b9b', 27, 2, 1, '2019-06-06 02:08:24', '2019-06-05 14:08:23', '2019-06-05 14:08:23');
INSERT INTO `oauth2_refresh_token` VALUES ('27c074ff3e09479c8b5b43809eb8fa8b', 27, 2, 1, '2019-08-06 03:23:37', '2019-08-05 15:23:37', '2019-08-05 15:23:37');
INSERT INTO `oauth2_refresh_token` VALUES ('27c166e45f514945a6f885de46315ac8', 1, 2, 0, '2019-06-04 22:56:15', '2019-06-04 10:56:14', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('27d4fd0e971c4f60a71416b155fd79c2', 216, 1, 1, '2019-08-30 23:35:59', '2019-08-30 11:35:59', '2019-08-30 11:35:59');
INSERT INTO `oauth2_refresh_token` VALUES ('27fbe8cb56ce409a970f5c35d5fcfc22', 27, 2, 1, '2019-07-23 02:53:22', '2019-07-22 14:53:21', '2019-07-22 14:53:21');
INSERT INTO `oauth2_refresh_token` VALUES ('283d7d8421a748098ad82c6a9b79b297', 27, 2, 1, '2019-07-11 10:00:29', '2019-07-10 22:00:29', '2019-07-10 22:00:29');
INSERT INTO `oauth2_refresh_token` VALUES ('284f9e17e48f41c8b5f371aa639065a3', 27, 2, 1, '2019-07-24 03:43:00', '2019-07-23 15:43:00', '2019-07-23 15:43:00');
INSERT INTO `oauth2_refresh_token` VALUES ('28973654f38843d1b9cb19359d0f40e5', 1, 2, 0, '2019-07-26 22:19:18', '2019-07-26 10:19:18', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('289a719aeab74b93adc730bddfa50007', 27, 2, 1, '2019-07-31 22:45:36', '2019-07-31 10:45:36', '2019-07-31 10:45:36');
INSERT INTO `oauth2_refresh_token` VALUES ('28b6ff4d8e2b46c086c459ba6b6a30f6', 1, 2, 0, '2019-07-08 05:42:00', '2019-07-07 17:41:59', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('28f3697342504533bd08ac5f03b428ec', 148, 1, 1, '2019-07-02 11:04:13', '2019-07-01 23:04:12', '2019-07-01 23:04:12');
INSERT INTO `oauth2_refresh_token` VALUES ('290ae84fb2b1486f934c7d90e45e406f', 27, 2, 1, '2019-07-10 03:49:32', '2019-07-09 15:49:31', '2019-07-09 15:49:31');
INSERT INTO `oauth2_refresh_token` VALUES ('29194f56c34d4d41a042e1cbebf5cbb1', 27, 2, 1, '2019-07-19 04:30:30', '2019-07-18 16:30:30', '2019-07-18 16:30:30');
INSERT INTO `oauth2_refresh_token` VALUES ('2925d4f1555b4052a626d9311dbdf111', 27, 2, 1, '2019-07-02 09:28:35', '2019-07-01 21:28:34', '2019-07-01 21:28:34');
INSERT INTO `oauth2_refresh_token` VALUES ('292614ab78ee4008b98b5326289aaca4', 27, 2, 1, '2019-06-01 12:57:16', '2019-06-01 00:57:16', '2019-06-01 00:57:16');
INSERT INTO `oauth2_refresh_token` VALUES ('2930d8a0724340cb874d373215b09697', 27, 2, 1, '2019-08-14 22:59:55', '2019-08-14 10:59:54', '2019-08-14 10:59:54');
INSERT INTO `oauth2_refresh_token` VALUES ('293480455dc641e9996dd2eb693e0177', NULL, NULL, 1, '2019-03-10 14:38:23', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('294bca5151c745e5bcd58fcb6a15589b', 27, 2, 1, '2019-07-04 23:28:36', '2019-07-04 11:28:36', '2019-07-04 11:28:36');
INSERT INTO `oauth2_refresh_token` VALUES ('294bd73b4d5749b7bb0f19d16c3c2a85', 1, 2, 0, '2019-06-13 11:24:01', '2019-06-12 23:24:00', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('294c817a3790478b9c532fe763cc4361', 74, 1, 1, '2019-06-11 01:54:05', '2019-06-10 13:54:05', '2019-06-10 13:54:05');
INSERT INTO `oauth2_refresh_token` VALUES ('295346b0d5d841508a8dac4eab2edba5', 1, 2, 0, '2019-06-24 10:25:55', '2019-06-23 22:25:54', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('2957dd39574a418aaedd0df53b41602e', 27, 2, 1, '2019-06-15 10:46:59', '2019-06-14 22:46:59', '2019-06-14 22:46:59');
INSERT INTO `oauth2_refresh_token` VALUES ('29648d9b5f104f16bbbeb1dbfed38aef', 27, 2, 1, '2019-06-09 11:24:36', '2019-06-08 23:24:36', '2019-06-08 23:24:36');
INSERT INTO `oauth2_refresh_token` VALUES ('2986c8c9bf0343fba1d775285f768d4a', 27, 2, 1, '2019-06-24 04:34:44', '2019-06-23 16:34:44', '2019-06-23 16:34:44');
INSERT INTO `oauth2_refresh_token` VALUES ('299a8a742401442fb7986ae865c7513a', NULL, NULL, 1, '2019-05-09 03:54:48', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('299c9203d0ba45ccba859142d143ec7b', 27, 2, 1, '2019-08-06 08:20:40', '2019-08-05 20:20:40', '2019-08-05 20:20:40');
INSERT INTO `oauth2_refresh_token` VALUES ('299cde2738924b0a8cc272be7e7e7173', 27, 2, 1, '2019-06-13 23:37:43', '2019-06-13 11:37:42', '2019-06-13 11:37:42');
INSERT INTO `oauth2_refresh_token` VALUES ('29a32a3a749249d090f5f03bbd5230cc', 1, 2, 0, '2019-09-08 10:46:38', '2019-09-07 22:46:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('29a6d47ef9df428db6fee195e6c5a021', 27, 2, 1, '2019-07-13 21:40:50', '2019-07-13 09:40:50', '2019-07-13 09:40:50');
INSERT INTO `oauth2_refresh_token` VALUES ('29b00491f4a84f0ea69d091be0bc0f07', 27, 2, 1, '2019-06-02 04:46:58', '2019-06-01 16:46:58', '2019-06-01 16:46:58');
INSERT INTO `oauth2_refresh_token` VALUES ('29b5f91bcaae4d79a873c9d8486f4c32', 27, 2, 1, '2019-06-13 22:09:14', '2019-06-13 10:09:13', '2019-06-13 10:09:13');
INSERT INTO `oauth2_refresh_token` VALUES ('29c828de9b1048f7971e6e695df7e992', 1, 2, 0, '2019-06-01 01:32:01', '2019-05-31 13:30:41', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('29d47329edfc4292971602034995f56e', NULL, NULL, 1, '2019-03-23 03:08:32', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('29d9eb760a044187ba5f81cac42e67f4', 27, 2, 1, '2019-09-03 04:34:48', '2019-09-02 16:34:47', '2019-09-02 16:34:47');
INSERT INTO `oauth2_refresh_token` VALUES ('29e48b6483c34b5aa9adbf7d7275b075', NULL, NULL, 1, '2019-03-19 17:55:00', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2a011e7fcf0e4a11baf075c04d294618', 27, 2, 1, '2019-07-12 21:51:16', '2019-07-12 09:51:16', '2019-07-12 09:51:16');
INSERT INTO `oauth2_refresh_token` VALUES ('2a194a966c234d5595b3a2e734755a61', 27, 2, 1, '2019-06-14 21:17:57', '2019-06-14 09:17:56', '2019-06-14 09:17:56');
INSERT INTO `oauth2_refresh_token` VALUES ('2a2ff13817684dec9f908b7f6197916a', NULL, NULL, 1, '2019-05-02 12:53:44', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2a39bb38a4394f9ab02153f875dbc51a', 27, 2, 1, '2019-06-06 03:19:45', '2019-06-05 15:19:45', '2019-06-05 15:19:45');
INSERT INTO `oauth2_refresh_token` VALUES ('2a4bd0a0bdf044ef98da5a31ff31ea03', 27, 2, 1, '2019-07-23 01:08:12', '2019-07-22 13:08:11', '2019-07-22 13:08:11');
INSERT INTO `oauth2_refresh_token` VALUES ('2a6cd5dba7804c709fdcfbe5c829204c', 27, 2, 1, '2019-06-02 02:48:01', '2019-06-01 14:48:00', '2019-06-01 14:48:00');
INSERT INTO `oauth2_refresh_token` VALUES ('2ac88f7c940e4c6292308589f8c429c8', 27, 2, 1, '2019-06-23 15:03:36', '2019-06-23 03:03:36', '2019-06-23 03:03:36');
INSERT INTO `oauth2_refresh_token` VALUES ('2ac9631779aa4c55a45f2e69d5ad95d3', 27, 2, 1, '2019-06-12 01:42:25', '2019-06-11 13:42:25', '2019-06-11 13:42:25');
INSERT INTO `oauth2_refresh_token` VALUES ('2acd683796d140c1821fdee2a7151c94', 27, 2, 1, '2019-07-10 21:18:22', '2019-07-10 09:18:21', '2019-07-10 09:18:21');
INSERT INTO `oauth2_refresh_token` VALUES ('2ad17ed273a94d63b1ed3dea2068d22e', 27, 2, 1, '2019-08-26 20:01:01', '2019-08-26 08:01:00', '2019-08-26 08:01:00');
INSERT INTO `oauth2_refresh_token` VALUES ('2ade78da6aa748918e161be06edeb516', 27, 2, 1, '2019-07-29 05:28:44', '2019-07-28 17:28:43', '2019-07-28 17:28:43');
INSERT INTO `oauth2_refresh_token` VALUES ('2ae0eae54f8040bb83dbd6d64447bc09', 27, 2, 1, '2019-07-25 01:40:27', '2019-07-24 13:40:26', '2019-07-24 13:40:26');
INSERT INTO `oauth2_refresh_token` VALUES ('2ae4da974f2240a28c5007e6e980678a', 27, 2, 1, '2019-06-05 20:17:09', '2019-06-05 08:17:09', '2019-06-05 08:17:09');
INSERT INTO `oauth2_refresh_token` VALUES ('2b10595c2e754499ac6cc25a21dc2b9e', 27, 2, 1, '2019-07-30 02:46:04', '2019-07-29 14:46:04', '2019-07-29 14:46:04');
INSERT INTO `oauth2_refresh_token` VALUES ('2b15bb7a7f8a4c33b98a9c0844932746', 27, 2, 1, '2019-07-31 03:15:44', '2019-07-30 15:15:44', '2019-07-30 15:15:44');
INSERT INTO `oauth2_refresh_token` VALUES ('2b2a9ced98324c16aac56abdcffbba56', 27, 2, 1, '2019-05-27 22:06:42', '2019-05-27 10:06:42', '2019-05-27 10:06:42');
INSERT INTO `oauth2_refresh_token` VALUES ('2b49cb1e4f924940ae69715619c209df', NULL, NULL, 1, '2019-04-24 23:06:19', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2b6875723b71491a901ae72bcfb4f1f4', 27, 2, 1, '2019-06-29 02:06:53', '2019-06-28 14:06:53', '2019-06-28 14:06:53');
INSERT INTO `oauth2_refresh_token` VALUES ('2b6b1ae0f0f04598a6d3bd1271eb9a59', 1, 2, 0, '2019-06-21 01:52:12', '2019-06-20 13:52:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('2b85a6c1fe6a4381823389b380626775', 27, 2, 1, '2019-08-22 02:13:28', '2019-08-21 14:13:27', '2019-08-21 14:13:27');
INSERT INTO `oauth2_refresh_token` VALUES ('2b9f751cb93f4985a07cc524d01bf4bd', 27, 2, 1, '2019-08-06 02:27:55', '2019-08-05 14:27:54', '2019-08-05 14:27:54');
INSERT INTO `oauth2_refresh_token` VALUES ('2ba9557e8ef44c7d893b63b685b392de', 1, 2, 0, '2019-07-09 22:51:58', '2019-07-09 10:51:58', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('2bb28a0ea12846f79329cb2f89680059', 27, 2, 1, '2019-06-18 02:25:43', '2019-06-17 14:25:42', '2019-06-17 14:25:42');
INSERT INTO `oauth2_refresh_token` VALUES ('2bd73bcc65d34ef6aeac9abfe01caf50', 27, 2, 1, '2019-05-22 22:09:11', '2019-05-22 10:09:10', '2019-05-22 10:09:10');
INSERT INTO `oauth2_refresh_token` VALUES ('2c08082ccaf24d789d28eb6d5d1b5ce7', 27, 2, 1, '2019-09-08 08:20:10', '2019-09-07 20:20:10', '2019-09-07 20:20:10');
INSERT INTO `oauth2_refresh_token` VALUES ('2c0810614139426fbe86a72ff97440cb', 27, 2, 1, '2019-08-26 00:13:34', '2019-08-25 12:13:33', '2019-08-25 12:13:33');
INSERT INTO `oauth2_refresh_token` VALUES ('2c081cb902974acc9da20279eeb927f2', 27, 2, 1, '2019-07-28 06:43:07', '2019-07-27 18:43:07', '2019-07-27 18:43:07');
INSERT INTO `oauth2_refresh_token` VALUES ('2c0efcbc96bb48fab4021e531b34a700', NULL, NULL, 1, '2019-04-25 21:11:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2c182bcb880540dbbb39db2cf5c693de', 27, 2, 1, '2019-08-08 09:42:07', '2019-08-07 21:42:06', '2019-08-07 21:42:06');
INSERT INTO `oauth2_refresh_token` VALUES ('2c3120629dda47e58a057240e1077387', 27, 2, 1, '2019-08-19 22:59:38', '2019-08-19 10:59:38', '2019-08-19 10:59:38');
INSERT INTO `oauth2_refresh_token` VALUES ('2c507047edf742af8c4182e9e06db348', 27, 2, 1, '2019-06-05 23:36:23', '2019-06-05 11:36:23', '2019-06-05 11:36:23');
INSERT INTO `oauth2_refresh_token` VALUES ('2c5c1a63842442d69c218f99a764f176', 27, 2, 1, '2019-06-09 07:54:57', '2019-06-08 19:54:56', '2019-06-08 19:54:56');
INSERT INTO `oauth2_refresh_token` VALUES ('2c624caef692400aa7bfcea0d3ef4817', 27, 2, 1, '2019-08-09 10:32:28', '2019-08-08 22:32:28', '2019-08-08 22:32:28');
INSERT INTO `oauth2_refresh_token` VALUES ('2c65cd4a1d5a432aa94c88a938cfc8f9', 27, 2, 1, '2019-07-10 02:17:28', '2019-07-09 14:17:27', '2019-07-09 14:17:27');
INSERT INTO `oauth2_refresh_token` VALUES ('2c7139bf43254d299a2a47dfcd45ed2a', 27, 2, 1, '2019-05-31 02:54:09', '2019-05-30 14:54:08', '2019-05-30 14:54:08');
INSERT INTO `oauth2_refresh_token` VALUES ('2c7ef36c254a4032ba2d7b3fd19434b9', NULL, NULL, 1, '2019-05-09 10:08:40', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2c855f483b6e4cdaa171e5def7aca8c9', 27, 2, 1, '2019-06-29 11:58:21', '2019-06-28 23:58:21', '2019-06-28 23:58:21');
INSERT INTO `oauth2_refresh_token` VALUES ('2c89fd00564b4ca7b61f8e7cf205eee1', 27, 2, 1, '2019-06-04 23:02:56', '2019-06-04 11:02:56', '2019-06-04 11:02:56');
INSERT INTO `oauth2_refresh_token` VALUES ('2ca1218822d2405ba129a800b3e86148', 27, 2, 1, '2019-08-10 06:08:43', '2019-08-09 18:08:42', '2019-08-09 18:08:42');
INSERT INTO `oauth2_refresh_token` VALUES ('2cd3220e35164829882bd669dc52cfd3', 27, 2, 1, '2019-08-09 05:30:44', '2019-08-08 17:30:43', '2019-08-08 17:30:43');
INSERT INTO `oauth2_refresh_token` VALUES ('2cd7435efeaf4d4faa9f4a3c84486a3e', 99, 1, 1, '2019-06-02 11:56:49', '2019-06-01 23:56:48', '2019-06-01 23:56:48');
INSERT INTO `oauth2_refresh_token` VALUES ('2cea876c8901470bb3de4733cf2600e5', 27, 2, 1, '2019-06-02 23:07:34', '2019-06-02 11:07:33', '2019-06-02 11:07:33');
INSERT INTO `oauth2_refresh_token` VALUES ('2cedbee3d2114a64b49f8b572ab60f47', 27, 2, 1, '2019-05-31 22:31:13', '2019-05-31 10:31:13', '2019-05-31 10:31:13');
INSERT INTO `oauth2_refresh_token` VALUES ('2d06c8583a3d4a62bfb7152b03037072', 27, 2, 1, '2019-06-14 21:16:49', '2019-06-14 09:16:49', '2019-06-14 09:16:49');
INSERT INTO `oauth2_refresh_token` VALUES ('2d310df612d945e78a0df66482ffbe88', 27, 2, 1, '2019-09-07 22:51:41', '2019-09-07 10:51:40', '2019-09-07 10:51:40');
INSERT INTO `oauth2_refresh_token` VALUES ('2d74690f928e47e29fa5e7c38b95e529', NULL, NULL, 1, '2019-05-05 04:35:50', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2d7dad10509f4f3a9705b0b4a60cd576', 27, 2, 1, '2019-06-23 04:23:00', '2019-06-22 16:22:59', '2019-06-22 16:22:59');
INSERT INTO `oauth2_refresh_token` VALUES ('2d81c4ef99244a73a916a48aaafa39da', 27, 2, 1, '2019-08-24 03:04:31', '2019-08-23 15:04:30', '2019-08-23 15:04:30');
INSERT INTO `oauth2_refresh_token` VALUES ('2da6392d49ee4afaa86a9c59b1fdc846', 27, 2, 1, '2019-07-08 08:54:58', '2019-07-07 20:54:58', '2019-07-07 20:54:58');
INSERT INTO `oauth2_refresh_token` VALUES ('2dc24371e5964c0880fabebc291433dd', NULL, NULL, 1, '2019-05-14 06:36:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2dd82abc3ed94f7a9cd529dd7ff769ce', 27, 2, 1, '2019-08-01 04:38:51', '2019-07-31 16:38:51', '2019-07-31 16:38:51');
INSERT INTO `oauth2_refresh_token` VALUES ('2ddeb7448d4645a0821db3019477e197', NULL, NULL, 1, '2019-05-11 02:12:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2de47c27bb0b41ec8880b1014cbf8aba', 101, 1, 1, '2019-06-03 10:38:28', '2019-06-02 22:38:27', '2019-06-02 22:38:27');
INSERT INTO `oauth2_refresh_token` VALUES ('2dfc816063ae44d48c50711107561585', 27, 2, 1, '2019-09-08 22:47:43', '2019-09-08 10:47:43', '2019-09-08 10:47:43');
INSERT INTO `oauth2_refresh_token` VALUES ('2e5f1c9354da40bc89059ede30fdc997', 27, 2, 1, '2019-06-06 04:12:30', '2019-06-05 16:12:29', '2019-06-05 16:12:29');
INSERT INTO `oauth2_refresh_token` VALUES ('2e634a53a1c84325ab0c0f9927575799', 27, 2, 1, '2019-07-04 04:08:23', '2019-07-03 16:08:22', '2019-07-03 16:08:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2e650487f44a44279c4de72e99ec01c9', 27, 2, 1, '2019-08-27 23:33:32', '2019-08-27 11:33:31', '2019-08-27 11:33:31');
INSERT INTO `oauth2_refresh_token` VALUES ('2e9383c54cd94c9d8931616299ef5a5a', 1, 2, 0, '2019-06-27 03:08:52', '2019-06-26 15:08:51', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('2ee04e0688384b6fb0d2e3aeedaac3b7', 27, 2, 1, '2019-09-05 22:09:34', '2019-09-05 10:09:33', '2019-09-05 10:09:33');
INSERT INTO `oauth2_refresh_token` VALUES ('2ef7bed19389428790a0aca847190043', 27, 2, 1, '2019-09-03 10:36:23', '2019-09-02 22:36:22', '2019-09-02 22:36:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2f059b48236240e08a97a078557b81e6', 27, 2, 1, '2019-06-02 05:00:48', '2019-06-01 17:00:47', '2019-06-01 17:00:47');
INSERT INTO `oauth2_refresh_token` VALUES ('2f09b74f11c742d4aabc1594ec6c1d77', 27, 2, 1, '2019-07-28 22:25:07', '2019-07-28 10:25:07', '2019-07-28 10:25:07');
INSERT INTO `oauth2_refresh_token` VALUES ('2f0d8f7830dd40d7afa2ed1089c63dfc', 27, 2, 1, '2019-07-11 02:06:46', '2019-07-10 14:06:46', '2019-07-10 14:06:46');
INSERT INTO `oauth2_refresh_token` VALUES ('2f205b81b2334a2aac147a581c94c117', NULL, NULL, 1, '2019-05-11 20:24:01', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2f27bf8a56d74d9794854dbb74623312', 27, 2, 1, '2019-08-31 00:41:24', '2019-08-30 12:41:23', '2019-08-30 12:41:23');
INSERT INTO `oauth2_refresh_token` VALUES ('2f29260a1af84eb2a70e6495efa4d99d', 1, 2, 0, '2019-08-22 06:01:39', '2019-08-21 18:01:39', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('2f2bbbc3b0b94f308f40ac9b9f06b2c2', 27, 2, 1, '2019-06-27 02:51:45', '2019-06-26 14:51:45', '2019-06-26 14:51:45');
INSERT INTO `oauth2_refresh_token` VALUES ('2f5b6163c16f4fc793b3604fbf406800', 27, 2, 1, '2019-07-31 22:30:08', '2019-07-31 10:30:07', '2019-07-31 10:30:07');
INSERT INTO `oauth2_refresh_token` VALUES ('2f6729a4eda34a569362acd7419813a1', 27, 2, 1, '2019-06-03 22:41:49', '2019-06-03 10:41:49', '2019-06-03 10:41:49');
INSERT INTO `oauth2_refresh_token` VALUES ('2f6bd9bafad74db39c56b8fe3b59124c', NULL, NULL, 1, '2019-04-05 05:13:57', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2f6cdc3ca7904fe5819af71385c62099', NULL, NULL, 1, '2019-05-06 03:20:26', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2f70ad2a9f3b47ecac3d6cef48d6536d', NULL, NULL, 1, '2019-03-22 11:38:34', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2f76226e6acb440d938073a47e343f88', 27, 2, 1, '2019-06-19 01:55:02', '2019-06-18 13:55:01', '2019-06-18 13:55:01');
INSERT INTO `oauth2_refresh_token` VALUES ('2f7b99e30b364c87b0c0e927040ff846', NULL, NULL, 1, '2019-05-04 22:11:23', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2f7c364cdcbc4536a319ee56a5155182', 27, 2, 1, '2019-06-24 11:03:10', '2019-06-23 23:03:09', '2019-06-23 23:03:09');
INSERT INTO `oauth2_refresh_token` VALUES ('2f7f8dc82b9d4081ab84504f3f26cd6f', NULL, NULL, 0, '2019-03-06 19:47:19', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2f845649bbb74e0ab9da81d22573bca6', NULL, NULL, 1, '2019-03-13 06:19:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('2f9979e6bb6f4a74bec1e3df3cb6273c', 27, 2, 1, '2019-07-22 06:20:24', '2019-07-21 18:20:23', '2019-07-21 18:20:23');
INSERT INTO `oauth2_refresh_token` VALUES ('2fd12874059548da9e389b9e9f52db73', 27, 2, 1, '2019-06-28 22:07:33', '2019-06-28 10:07:33', '2019-06-28 10:07:33');
INSERT INTO `oauth2_refresh_token` VALUES ('2fea55f06b5e4d109cffa3f6e9dacf2e', 1, 2, 0, '2019-06-04 04:25:06', '2019-06-03 16:25:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('302378b3b06e4a229d7d81e70fd12ff4', 27, 2, 1, '2019-05-27 22:40:18', '2019-05-27 10:40:17', '2019-05-27 10:40:17');
INSERT INTO `oauth2_refresh_token` VALUES ('304a7edc7bb34596b3ef1228b64973fa', 27, 2, 1, '2019-08-29 12:14:45', '2019-08-29 00:14:45', '2019-08-29 00:14:45');
INSERT INTO `oauth2_refresh_token` VALUES ('305fa32a5cb34bda9da3d156c6635ea7', 27, 2, 1, '2019-07-24 11:26:55', '2019-07-23 23:26:54', '2019-07-23 23:26:54');
INSERT INTO `oauth2_refresh_token` VALUES ('306a7fb3a479473ab512755157580d7b', 27, 2, 1, '2019-06-03 01:35:42', '2019-06-02 13:35:42', '2019-06-02 13:35:42');
INSERT INTO `oauth2_refresh_token` VALUES ('30713016944e48a291413b083a420228', 27, 2, 1, '2019-07-28 03:19:32', '2019-07-27 15:19:32', '2019-07-27 15:19:32');
INSERT INTO `oauth2_refresh_token` VALUES ('309879320430462ab0418817f6286405', 27, 2, 1, '2019-07-03 03:16:34', '2019-07-02 15:16:33', '2019-07-02 15:16:33');
INSERT INTO `oauth2_refresh_token` VALUES ('30ab2672531c464682ee0293ff9dca9d', 1, 2, 0, '2019-09-04 22:08:12', '2019-09-04 10:08:12', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('30af768878a343058bb175d9bee20fb6', 27, 2, 1, '2019-06-20 20:46:22', '2019-06-20 08:46:21', '2019-06-20 08:46:21');
INSERT INTO `oauth2_refresh_token` VALUES ('30bce16d5ba24c16be3497a3c354d574', 27, 2, 1, '2019-06-14 23:55:59', '2019-06-14 11:55:58', '2019-06-14 11:55:58');
INSERT INTO `oauth2_refresh_token` VALUES ('30d3b153a56b436a830df31e5a0314cd', 1, 2, 0, '2019-08-22 06:02:03', '2019-08-21 18:02:03', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('30eac9083715462fbf03cf8b64c6bfc8', 27, 2, 1, '2019-07-29 23:09:40', '2019-07-29 11:09:39', '2019-07-29 11:09:39');
INSERT INTO `oauth2_refresh_token` VALUES ('30f91dd8e35940d4a16d8dd4f78d915e', 27, 2, 1, '2019-08-01 04:42:22', '2019-07-31 16:42:21', '2019-07-31 16:42:21');
INSERT INTO `oauth2_refresh_token` VALUES ('31002ec5c96e409096dc7089c8878223', 27, 2, 1, '2019-07-11 10:57:33', '2019-07-10 22:57:32', '2019-07-10 22:57:32');
INSERT INTO `oauth2_refresh_token` VALUES ('31051e034891462dadb3c82498318666', 27, 2, 1, '2019-06-03 12:54:13', '2019-06-03 00:54:12', '2019-06-03 00:54:12');
INSERT INTO `oauth2_refresh_token` VALUES ('3106a921a01d4cf5a2c64d3d73f8b744', 27, 2, 1, '2019-06-29 01:52:47', '2019-06-28 13:52:47', '2019-06-28 13:52:47');
INSERT INTO `oauth2_refresh_token` VALUES ('31095d78f3a54accbd3bdf176ae326aa', 27, 2, 1, '2019-07-06 23:03:09', '2019-07-06 11:03:09', '2019-07-06 11:03:09');
INSERT INTO `oauth2_refresh_token` VALUES ('31232677df454c28a993dabde325346c', 27, 2, 1, '2019-06-18 22:45:53', '2019-06-18 10:45:53', '2019-06-18 10:45:53');
INSERT INTO `oauth2_refresh_token` VALUES ('312e19a7babf4a3d83edd9fec5be5546', 27, 2, 1, '2019-08-13 04:20:00', '2019-08-12 16:20:00', '2019-08-12 16:20:00');
INSERT INTO `oauth2_refresh_token` VALUES ('31326daab26247179c4b71d7a4dd9023', 1, 2, 0, '2019-06-24 23:14:21', '2019-06-24 11:14:20', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('31372ce77b3e43058abfb62556b7147a', 27, 2, 1, '2019-07-21 05:46:27', '2019-07-20 17:46:26', '2019-07-20 17:46:26');
INSERT INTO `oauth2_refresh_token` VALUES ('313b2919e0444c608d7bd9882a1c9374', 27, 2, 1, '2019-07-09 03:03:52', '2019-07-08 15:03:51', '2019-07-08 15:03:51');
INSERT INTO `oauth2_refresh_token` VALUES ('3146e6af937c4611a8a6a6e5c48a0a12', 27, 2, 1, '2019-06-20 03:22:46', '2019-06-19 15:22:46', '2019-06-19 15:22:46');
INSERT INTO `oauth2_refresh_token` VALUES ('316c30670d14459683fa75b881eb45fb', 27, 2, 1, '2019-08-09 02:47:01', '2019-08-08 14:47:00', '2019-08-08 14:47:00');
INSERT INTO `oauth2_refresh_token` VALUES ('317aa024ae754f0ca188977a5372b083', 27, 2, 1, '2019-07-25 02:34:59', '2019-07-24 14:34:58', '2019-07-24 14:34:58');
INSERT INTO `oauth2_refresh_token` VALUES ('31b15565712d49a188ad9f7cd8e38494', 27, 2, 1, '2019-06-01 02:11:14', '2019-05-31 14:11:13', '2019-05-31 14:11:13');
INSERT INTO `oauth2_refresh_token` VALUES ('31b39f094a2548c8a3460fe065a7e72a', 206, 1, 1, '2019-08-18 13:07:01', '2019-08-18 01:07:00', '2019-08-18 01:07:00');
INSERT INTO `oauth2_refresh_token` VALUES ('31bd34dffe834ae099b7287fb0d59c19', 27, 2, 1, '2019-06-07 05:19:24', '2019-06-06 17:19:24', '2019-06-06 17:19:24');
INSERT INTO `oauth2_refresh_token` VALUES ('31be07b5a5c64f6dbbf2a6b13cc7aea4', 27, 2, 1, '2019-06-01 10:44:16', '2019-05-31 22:44:15', '2019-05-31 22:44:15');
INSERT INTO `oauth2_refresh_token` VALUES ('31be59fa37b44d7981c210da1a9c6411', NULL, NULL, 1, '2019-04-25 02:50:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('31c5edf12eca43f0aeb3126b93b9e28f', 27, 2, 1, '2019-06-25 04:31:05', '2019-06-24 16:31:04', '2019-06-24 16:31:04');
INSERT INTO `oauth2_refresh_token` VALUES ('31c95724a1b1463aab0567f733c9e86d', 27, 2, 1, '2019-08-12 11:18:04', '2019-08-11 23:18:03', '2019-08-11 23:18:03');
INSERT INTO `oauth2_refresh_token` VALUES ('31eb9b5fc5fc4c27aa4856324c5b9f93', 27, 2, 1, '2019-08-01 02:49:17', '2019-07-31 14:49:16', '2019-07-31 14:49:16');
INSERT INTO `oauth2_refresh_token` VALUES ('31ed3eec1a384c22af7a56251b523aa6', 27, 2, 1, '2019-08-07 22:39:23', '2019-08-07 10:39:22', '2019-08-07 10:39:22');
INSERT INTO `oauth2_refresh_token` VALUES ('31f9e85e5b114e6f9e0acf583ad03da3', NULL, NULL, 1, '2019-04-28 23:41:10', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('31fcc1e1e0744d6a991578288ddd7159', 27, 2, 1, '2019-05-31 00:59:51', '2019-05-30 12:59:50', '2019-05-30 12:59:50');
INSERT INTO `oauth2_refresh_token` VALUES ('3206207475da4d8b826bd89a55e89324', 27, 2, 1, '2019-06-19 22:10:10', '2019-06-19 10:10:10', '2019-06-19 10:10:10');
INSERT INTO `oauth2_refresh_token` VALUES ('323981cfc1ec451fa46bff03b004f982', NULL, NULL, 1, '2019-05-11 23:42:04', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('323a7bf1bc314e8788fe0ed898349241', 27, 2, 1, '2019-06-20 03:56:17', '2019-06-19 15:56:17', '2019-06-19 15:56:17');
INSERT INTO `oauth2_refresh_token` VALUES ('32486262d9ad485da1f446294c30a2de', 1, 2, 0, '2019-07-04 22:01:41', '2019-07-04 10:01:40', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('324901bf92184dffa7ec931be4836ac6', 27, 2, 1, '2019-06-11 23:19:12', '2019-06-11 11:19:12', '2019-06-11 11:19:12');
INSERT INTO `oauth2_refresh_token` VALUES ('324e31c8e41c46b9bf8ee0bc3424af14', 1, 2, 0, '2019-08-05 22:16:30', '2019-08-05 10:16:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('3256005fb19c44698366140c81e9f99c', 27, 2, 1, '2019-08-18 21:02:20', '2019-08-18 09:02:19', '2019-08-18 09:02:19');
INSERT INTO `oauth2_refresh_token` VALUES ('32576be4b96d40099caadf24da9a9730', 27, 2, 1, '2019-07-23 22:02:12', '2019-07-23 10:02:12', '2019-07-23 10:02:12');
INSERT INTO `oauth2_refresh_token` VALUES ('325c94a8cb21474a99f0965f04bd1936', 1, 2, 0, '2019-06-01 05:02:15', '2019-05-31 17:00:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('3261a834824e46f190b8bfafe93bbcaa', 27, 2, 1, '2019-06-30 04:31:06', '2019-06-29 16:31:06', '2019-06-29 16:31:06');
INSERT INTO `oauth2_refresh_token` VALUES ('3263acbe31d4411999dfa3f3d9d51a76', 27, 2, 1, '2019-08-30 05:40:34', '2019-08-29 17:40:34', '2019-08-29 17:40:34');
INSERT INTO `oauth2_refresh_token` VALUES ('3270e9fd8105413abbb9c7169853b1da', 27, 2, 1, '2019-06-03 09:29:08', '2019-06-02 21:29:08', '2019-06-02 21:29:08');
INSERT INTO `oauth2_refresh_token` VALUES ('3286d13e8dfe47cb86f0db28f4c86b5b', 27, 2, 1, '2019-06-04 04:25:08', '2019-06-03 16:25:08', '2019-06-03 16:25:08');
INSERT INTO `oauth2_refresh_token` VALUES ('3295af4f94a24f5aa5454dde7b3a2732', NULL, NULL, 0, '2019-03-01 21:56:23', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('329bda86f9a44df588fb38801818e1f9', NULL, NULL, 1, '2019-05-05 20:34:40', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('32a06021dc764db79a9eb147b4c53f5d', 27, 2, 1, '2019-07-09 06:12:29', '2019-07-08 18:12:29', '2019-07-08 18:12:29');
INSERT INTO `oauth2_refresh_token` VALUES ('32a09238532149cc9a4973222943e014', 27, 2, 1, '2019-06-16 20:32:23', '2019-06-16 08:32:23', '2019-06-16 08:32:23');
INSERT INTO `oauth2_refresh_token` VALUES ('32a40a7f665f49229b543c33161e99f5', 27, 2, 1, '2019-07-10 08:36:40', '2019-07-09 20:36:39', '2019-07-09 20:36:39');
INSERT INTO `oauth2_refresh_token` VALUES ('32aeab41a14140b493f17e02e4e6b73a', 27, 2, 1, '2019-06-04 10:02:24', '2019-06-03 22:02:23', '2019-06-03 22:02:23');
INSERT INTO `oauth2_refresh_token` VALUES ('32b25d44da4046cf832a0bc84c0c8293', 176, 1, 1, '2019-07-19 03:36:29', '2019-07-18 15:36:29', '2019-07-18 15:36:29');
INSERT INTO `oauth2_refresh_token` VALUES ('32e105b490914c538cb4b3a397cc79f6', 27, 2, 1, '2019-06-06 03:40:14', '2019-06-05 15:40:14', '2019-06-05 15:40:14');
INSERT INTO `oauth2_refresh_token` VALUES ('32e7690056b44f3d8f7d7ccf001b0782', 27, 2, 1, '2019-06-06 23:06:27', '2019-06-06 11:06:27', '2019-06-06 11:06:27');
INSERT INTO `oauth2_refresh_token` VALUES ('32ed5e94bf0e433b84c9e3ed8d32bae1', 27, 2, 1, '2019-07-16 03:10:33', '2019-07-15 15:10:33', '2019-07-15 15:10:33');
INSERT INTO `oauth2_refresh_token` VALUES ('32f332ec14fa469abfd7bf90962c87b4', NULL, NULL, 1, '2019-05-06 01:36:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3306f3b02f1d46f097d3089fbaee1228', 27, 2, 1, '2019-06-26 05:40:35', '2019-06-25 17:40:34', '2019-06-25 17:40:34');
INSERT INTO `oauth2_refresh_token` VALUES ('331999635d1c46c4ba5f5ab7091ec4db', 1, 2, 0, '2019-05-29 03:37:49', '2019-05-28 15:37:49', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('335181cd60824c96b40f188f4a53a39e', 27, 2, 1, '2019-08-08 04:57:57', '2019-08-07 16:57:57', '2019-08-07 16:57:57');
INSERT INTO `oauth2_refresh_token` VALUES ('335fbf23df554e2ea80f8a3fe30fe5c9', 27, 2, 1, '2019-07-09 11:06:52', '2019-07-08 23:06:51', '2019-07-08 23:06:51');
INSERT INTO `oauth2_refresh_token` VALUES ('336abaa69e1644f1a0abe3076251cba8', 27, 2, 1, '2019-05-18 06:28:40', '2019-05-17 18:28:40', '2019-05-17 18:28:40');
INSERT INTO `oauth2_refresh_token` VALUES ('336fcb1cc454470b95bc94630928a691', NULL, NULL, 1, '2019-04-26 23:05:02', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3371f73a995e4269a8cdd688fa8c66c8', 27, 2, 1, '2019-08-01 04:42:09', '2019-07-31 16:42:09', '2019-07-31 16:42:09');
INSERT INTO `oauth2_refresh_token` VALUES ('33824b12fe974d2bb0086e44e59c220d', NULL, NULL, 1, '2019-05-08 04:28:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3389fb2d917b46aa9291fb417ce1576d', 1, 2, 0, '2019-08-21 03:05:41', '2019-08-20 15:05:41', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('339162eb43ff449088b11152b63b578a', 27, 2, 1, '2019-06-14 09:08:41', '2019-06-13 21:08:40', '2019-06-13 21:08:40');
INSERT INTO `oauth2_refresh_token` VALUES ('33974e798cc048ffb9c934f88401ff5c', 1, 2, 0, '2019-08-22 06:01:49', '2019-08-21 18:01:49', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('3398f62356c84766b509cb4aac1c58dd', 1, 2, 0, '2019-06-21 05:00:22', '2019-06-20 17:00:21', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('33b637450b064aeca5aea0bd7c5f4350', 27, 2, 1, '2019-07-04 03:53:44', '2019-07-03 15:53:44', '2019-07-03 15:53:44');
INSERT INTO `oauth2_refresh_token` VALUES ('33b685958fc1402e99df4bd46502ef11', 27, 2, 1, '2019-08-29 22:57:57', '2019-08-29 10:57:56', '2019-08-29 10:57:56');
INSERT INTO `oauth2_refresh_token` VALUES ('33d5fa76e20547f08635989f8f551d5b', 1, 2, 0, '2019-05-27 04:30:37', '2019-05-26 16:30:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('33ed8a9f1cc94d05a90d65a5cc9410c5', NULL, NULL, 1, '2019-03-11 10:02:04', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('33f586f5faac4b3f97bc462699059aac', 27, 2, 1, '2019-06-01 04:08:52', '2019-05-31 16:08:52', '2019-05-31 16:08:52');
INSERT INTO `oauth2_refresh_token` VALUES ('341011c29b8d4f7680b32bb16bd68d30', 27, 2, 1, '2019-06-13 08:14:29', '2019-06-12 20:14:28', '2019-06-12 20:14:28');
INSERT INTO `oauth2_refresh_token` VALUES ('3420a434638a4469ab5b749ed5076e72', 27, 2, 1, '2019-07-10 04:06:47', '2019-07-09 16:06:46', '2019-07-09 16:06:46');
INSERT INTO `oauth2_refresh_token` VALUES ('3475473e4f3c4201a57e9012f2e07744', 27, 2, 1, '2019-08-29 22:55:01', '2019-08-29 10:55:01', '2019-08-29 10:55:01');
INSERT INTO `oauth2_refresh_token` VALUES ('3476b7f1aa944b9e93d63c78632c7df2', 27, 2, 1, '2019-08-26 07:08:20', '2019-08-25 19:08:19', '2019-08-25 19:08:19');
INSERT INTO `oauth2_refresh_token` VALUES ('34ae2e278bcc403f90d68b91779f03a1', 27, 2, 1, '2019-05-25 21:29:51', '2019-05-25 09:29:50', '2019-05-25 09:29:50');
INSERT INTO `oauth2_refresh_token` VALUES ('34c995a69a0240d896e671a2e5119dad', 27, 2, 1, '2019-05-21 06:24:19', '2019-05-20 18:24:19', '2019-05-20 18:24:19');
INSERT INTO `oauth2_refresh_token` VALUES ('34ca793ede9c4a2b84a34d1413fb3f3e', 27, 2, 1, '2019-07-30 02:48:14', '2019-07-29 14:48:13', '2019-07-29 14:48:13');
INSERT INTO `oauth2_refresh_token` VALUES ('34d571a6b6144250aa05ced2b525e82b', 27, 2, 1, '2019-07-06 07:18:47', '2019-07-05 19:18:47', '2019-07-05 19:18:47');
INSERT INTO `oauth2_refresh_token` VALUES ('34f5da1b74ea437aa1715e61a94fbfae', 27, 2, 1, '2019-09-03 03:53:23', '2019-09-02 15:53:23', '2019-09-02 15:53:23');
INSERT INTO `oauth2_refresh_token` VALUES ('34fc43241a8740758870fa96624e7fb9', 27, 2, 1, '2019-06-20 01:55:14', '2019-06-19 13:55:13', '2019-06-19 13:55:13');
INSERT INTO `oauth2_refresh_token` VALUES ('35059bf52e4044d1a6fb1c6aa2c8f7e9', NULL, NULL, 1, '2019-05-06 07:30:27', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('351899c1fd0448628f381831d378dbe6', 27, 2, 1, '2019-06-13 02:05:17', '2019-06-12 14:05:17', '2019-06-12 14:05:17');
INSERT INTO `oauth2_refresh_token` VALUES ('35284a1d90654316a6068025bcfae5e3', NULL, NULL, 1, '2019-05-01 23:51:13', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('35529e33c0e849288e7dbb117daa3f6f', NULL, NULL, 1, '2019-05-08 23:15:31', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('35597f6f3561467a82e5f638dc88b3c3', 1, 2, 0, '2019-06-19 01:16:18', '2019-06-18 13:16:18', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('3561d12678d3492f85110e93535e552c', NULL, NULL, 1, '2019-03-13 07:44:09', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3571c666a8a344a19e62dcdfec7ffb48', NULL, NULL, 1, '2019-03-15 09:16:28', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('357ac36226984fb991247f6961017206', 27, 2, 1, '2019-07-09 07:07:18', '2019-07-08 19:07:18', '2019-07-08 19:07:18');
INSERT INTO `oauth2_refresh_token` VALUES ('3590afe95c234d93886d3b884f36de10', 27, 2, 1, '2019-06-05 05:55:36', '2019-06-04 17:55:36', '2019-06-04 17:55:36');
INSERT INTO `oauth2_refresh_token` VALUES ('35925ee6d3724da68b6d7258902d208b', 27, 2, 1, '2019-07-04 05:28:22', '2019-07-03 17:28:22', '2019-07-03 17:28:22');
INSERT INTO `oauth2_refresh_token` VALUES ('35bcbeeb32df4da3928166ec03364165', 27, 2, 1, '2019-07-10 07:34:01', '2019-07-09 19:34:00', '2019-07-09 19:34:00');
INSERT INTO `oauth2_refresh_token` VALUES ('35c079bc25c14e81ab54f501cc125726', 27, 2, 1, '2019-05-29 21:30:03', '2019-05-29 09:30:02', '2019-05-29 09:30:02');
INSERT INTO `oauth2_refresh_token` VALUES ('35d7ad872b414c708094462dbcf34e97', 27, 2, 1, '2019-09-03 10:49:07', '2019-09-02 22:49:06', '2019-09-02 22:49:06');
INSERT INTO `oauth2_refresh_token` VALUES ('35eab30784ce4269b85490e59efd8e02', 27, 2, 1, '2019-06-02 11:40:22', '2019-06-01 23:40:22', '2019-06-01 23:40:22');
INSERT INTO `oauth2_refresh_token` VALUES ('35edc0a9a02f48c98e06ee4707ef588d', 27, 2, 1, '2019-06-06 22:49:29', '2019-06-06 10:49:28', '2019-06-06 10:49:28');
INSERT INTO `oauth2_refresh_token` VALUES ('35f4550517c845508c88fa1b6b7cc631', 27, 2, 1, '2019-07-23 05:33:18', '2019-07-22 17:33:18', '2019-07-22 17:33:18');
INSERT INTO `oauth2_refresh_token` VALUES ('35ffab04538a4d909ca2da7130fbae9f', NULL, NULL, 1, '2019-04-29 22:39:33', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('360667b798f848ba9f1d25473f6b9de3', 27, 2, 1, '2019-06-03 01:43:17', '2019-06-02 13:43:17', '2019-06-02 13:43:17');
INSERT INTO `oauth2_refresh_token` VALUES ('36332860db0e4a289ad3d94c4118d7a5', 27, 2, 1, '2019-07-18 03:32:52', '2019-07-17 15:32:51', '2019-07-17 15:32:51');
INSERT INTO `oauth2_refresh_token` VALUES ('364a885afc204502806867aca5ba6a85', NULL, NULL, 1, '2019-04-24 18:30:58', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('36515d16a70948d9a51a96c3e97b5d0f', 27, 2, 1, '2019-07-12 02:32:59', '2019-07-11 14:32:58', '2019-07-11 14:32:58');
INSERT INTO `oauth2_refresh_token` VALUES ('367314bedd23489b86cbd81746026708', 27, 2, 1, '2019-07-22 10:26:51', '2019-07-21 22:26:50', '2019-07-21 22:26:50');
INSERT INTO `oauth2_refresh_token` VALUES ('367772bd5fe84dc29cce2845ae855965', 27, 2, 1, '2019-06-05 21:33:10', '2019-06-05 09:33:10', '2019-06-05 09:33:10');
INSERT INTO `oauth2_refresh_token` VALUES ('368721708ff442d99d24de221d9b9953', NULL, NULL, 0, '2019-03-04 10:10:30', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3689fc8379714c4888f79369c0a6761a', 93, 1, 1, '2019-06-01 05:10:44', '2019-05-31 17:10:44', '2019-05-31 17:10:44');
INSERT INTO `oauth2_refresh_token` VALUES ('36b50f2c5bb84be295115cbecf118657', 27, 2, 1, '2019-06-01 04:41:06', '2019-05-31 16:41:05', '2019-05-31 16:41:05');
INSERT INTO `oauth2_refresh_token` VALUES ('36c0cca4d276457a97de2151edea6b41', NULL, NULL, 0, '2019-03-02 14:57:54', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('36dc9dc806d64139ab7fec432514a244', 27, 2, 1, '2019-06-19 20:47:54', '2019-06-19 08:47:53', '2019-06-19 08:47:53');
INSERT INTO `oauth2_refresh_token` VALUES ('36f059bc3eff4e35b8b3229b48f66827', 27, 2, 1, '2019-06-20 20:46:14', '2019-06-20 08:46:13', '2019-06-20 08:46:13');
INSERT INTO `oauth2_refresh_token` VALUES ('37145508aac3439e847fc559c1d91771', NULL, NULL, 1, '2019-04-23 07:44:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3715079c75294649ba2f103f06ed11bf', NULL, NULL, 1, '2019-05-13 10:46:58', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('371f73bf7c574bcf81c587f07cbeb934', 27, 2, 1, '2019-06-06 22:28:14', '2019-06-06 10:28:14', '2019-06-06 10:28:14');
INSERT INTO `oauth2_refresh_token` VALUES ('37241cfeaaf44d5c9bd33e0f166eb6ac', 27, 2, 1, '2019-06-15 00:34:33', '2019-06-14 12:34:33', '2019-06-14 12:34:33');
INSERT INTO `oauth2_refresh_token` VALUES ('372e4fd2d2c644f684ebde3bd93e87d9', 27, 2, 1, '2019-06-03 02:57:32', '2019-06-02 14:57:31', '2019-06-02 14:57:31');
INSERT INTO `oauth2_refresh_token` VALUES ('372eaee13f984d33a2f184f81bc961c0', 90, 1, 1, '2019-05-30 06:31:59', '2019-05-29 18:31:59', '2019-05-29 18:31:59');
INSERT INTO `oauth2_refresh_token` VALUES ('373a194e0bec4ec395eae3a772410495', 27, 2, 1, '2019-06-02 22:50:16', '2019-06-02 10:50:15', '2019-06-02 10:50:15');
INSERT INTO `oauth2_refresh_token` VALUES ('374103b44e2b4e028d501af453a27645', 27, 2, 1, '2019-07-18 23:08:28', '2019-07-18 11:08:28', '2019-07-18 11:08:28');
INSERT INTO `oauth2_refresh_token` VALUES ('374362624ab24312b5ed9bc947c8f8f9', 27, 2, 1, '2019-07-14 02:47:13', '2019-07-13 14:47:13', '2019-07-13 14:47:13');
INSERT INTO `oauth2_refresh_token` VALUES ('3744ca666b9b4046a4f38e94a83eb65d', 27, 2, 1, '2019-08-12 22:40:24', '2019-08-12 10:40:23', '2019-08-12 10:40:23');
INSERT INTO `oauth2_refresh_token` VALUES ('3774418858c444fd9e29b6a77d9ff9ad', 27, 2, 1, '2019-05-24 01:42:03', '2019-05-23 13:42:02', '2019-05-23 13:42:02');
INSERT INTO `oauth2_refresh_token` VALUES ('377e00f7c9b040f7b847a92ecc5b3c79', 27, 2, 1, '2019-07-09 20:47:14', '2019-07-09 08:47:13', '2019-07-09 08:47:13');
INSERT INTO `oauth2_refresh_token` VALUES ('3787d4c601c24906a7ff623d74c77dcb', 27, 2, 1, '2019-07-26 09:10:33', '2019-07-25 21:10:33', '2019-07-25 21:10:33');
INSERT INTO `oauth2_refresh_token` VALUES ('378d19802a94431c8431be877543e560', 1, 2, 0, '2019-07-04 03:48:05', '2019-07-03 15:48:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('37a6d42b98e8465cbdda26c2ef8bb6ac', 27, 2, 1, '2019-07-05 08:03:56', '2019-07-04 20:03:56', '2019-07-04 20:03:56');
INSERT INTO `oauth2_refresh_token` VALUES ('37ae5186ae6d47178cb2c939320d340f', 27, 2, 1, '2019-06-29 03:34:10', '2019-06-28 15:34:10', '2019-06-28 15:34:10');
INSERT INTO `oauth2_refresh_token` VALUES ('37b245f77a394c3cb63cd2bde61c1d08', 27, 2, 1, '2019-08-06 01:46:16', '2019-08-05 13:46:15', '2019-08-05 13:46:15');
INSERT INTO `oauth2_refresh_token` VALUES ('37c8509bdebc429080d0204bad77402b', 27, 2, 1, '2019-07-10 01:57:49', '2019-07-09 13:57:48', '2019-07-09 13:57:48');
INSERT INTO `oauth2_refresh_token` VALUES ('37c96b48d7584faab86ff7ac71375b33', 1, 2, 0, '2019-08-02 02:52:06', '2019-08-01 14:52:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('37d0183224d942428f4555dc8326223c', 27, 2, 1, '2019-06-08 13:21:15', '2019-06-08 01:21:14', '2019-06-08 01:21:14');
INSERT INTO `oauth2_refresh_token` VALUES ('37e9b3645ddc4eea9ba1a46f5d0b3342', 27, 2, 1, '2019-07-04 09:00:31', '2019-07-03 21:00:31', '2019-07-03 21:00:31');
INSERT INTO `oauth2_refresh_token` VALUES ('37f0e166108a4a14a57395bc021d5fda', 27, 2, 1, '2019-07-04 01:13:20', '2019-07-03 13:13:20', '2019-07-03 13:13:20');
INSERT INTO `oauth2_refresh_token` VALUES ('380e472f3910451c899328b6cdab6cd6', 27, 2, 1, '2019-06-06 23:38:43', '2019-06-06 11:38:42', '2019-06-06 11:38:42');
INSERT INTO `oauth2_refresh_token` VALUES ('381d0b176243420dae72a7ea506d9778', 27, 2, 1, '2019-08-28 03:08:27', '2019-08-27 15:08:26', '2019-08-27 15:08:26');
INSERT INTO `oauth2_refresh_token` VALUES ('382edd0e400d492f94e9b2d9f8053599', 27, 2, 1, '2019-07-03 02:55:35', '2019-07-02 14:55:35', '2019-07-02 14:55:35');
INSERT INTO `oauth2_refresh_token` VALUES ('3856b8a18394406eb2eaf9382afc717e', 27, 2, 1, '2019-07-22 22:49:38', '2019-07-22 10:49:37', '2019-07-22 10:49:37');
INSERT INTO `oauth2_refresh_token` VALUES ('3863199c598b433ba83f8aa9538aee01', NULL, NULL, 1, '2019-05-08 01:48:57', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3872c983513148839a6b0d450df65ed4', 27, 2, 1, '2019-07-03 09:28:06', '2019-07-02 21:28:05', '2019-07-02 21:28:05');
INSERT INTO `oauth2_refresh_token` VALUES ('3873f93a9ee9430aa59c9632a7cf53c7', 1, 2, 0, '2019-07-13 02:02:49', '2019-07-12 14:02:48', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('387b71db862c4d099c2ca50b3bb3c585', 27, 2, 1, '2019-08-14 20:56:24', '2019-08-14 08:56:24', '2019-08-14 08:56:24');
INSERT INTO `oauth2_refresh_token` VALUES ('387fcafaba9b41909fbf7770f364ca28', 27, 2, 1, '2019-06-24 07:35:48', '2019-06-23 19:35:48', '2019-06-23 19:35:48');
INSERT INTO `oauth2_refresh_token` VALUES ('388f9fa0ce124bd2914fbe4556fdb2eb', NULL, NULL, 1, '2019-03-31 10:18:58', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('38a37a79bda1480d84c518f06c8d3049', 27, 2, 1, '2019-07-26 21:27:55', '2019-07-26 09:27:55', '2019-07-26 09:27:55');
INSERT INTO `oauth2_refresh_token` VALUES ('38bf46d9cdf94610b22effffddc15be6', 27, 2, 1, '2019-06-03 21:35:14', '2019-06-03 09:35:14', '2019-06-03 09:35:14');
INSERT INTO `oauth2_refresh_token` VALUES ('38c7af1f8b59409b8cecf9df1c5333e0', 27, 2, 1, '2019-06-28 03:17:51', '2019-06-27 15:17:50', '2019-06-27 15:17:50');
INSERT INTO `oauth2_refresh_token` VALUES ('38d389922b1a4f9aaedc5a89f13a6caf', 27, 2, 1, '2019-06-17 07:29:40', '2019-06-16 19:29:39', '2019-06-16 19:29:39');
INSERT INTO `oauth2_refresh_token` VALUES ('38d8de112a9a4e3a95645d0248c08b97', 27, 2, 1, '2019-08-15 20:49:30', '2019-08-15 08:49:30', '2019-08-15 08:49:30');
INSERT INTO `oauth2_refresh_token` VALUES ('38e3afb012744d4389946aede4bb85d4', NULL, NULL, 1, '2019-05-16 12:23:25', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('38f94085e4f14cd1af01deae83893a01', 27, 2, 1, '2019-07-29 23:26:39', '2019-07-29 11:26:39', '2019-07-29 11:26:39');
INSERT INTO `oauth2_refresh_token` VALUES ('3917ca80583a428895fed67a9b019b89', 86, 1, 1, '2019-05-29 02:10:39', '2019-05-28 14:10:39', '2019-05-28 14:10:39');
INSERT INTO `oauth2_refresh_token` VALUES ('39366a4eeb074f0bbcf71399d6bc9bd3', 27, 2, 1, '2019-06-07 02:35:15', '2019-06-06 14:35:14', '2019-06-06 14:35:14');
INSERT INTO `oauth2_refresh_token` VALUES ('39420892ddb34732ae44c27a2064631f', NULL, NULL, 1, '2019-03-25 04:29:06', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('394a2a620f8b4929a4f411f391c4b101', 27, 2, 1, '2019-06-22 01:43:22', '2019-06-21 13:43:22', '2019-06-21 13:43:22');
INSERT INTO `oauth2_refresh_token` VALUES ('394ab4c9a1b94762883002d9881c9466', 27, 2, 1, '2019-06-01 09:03:28', '2019-05-31 21:03:27', '2019-05-31 21:03:27');
INSERT INTO `oauth2_refresh_token` VALUES ('3951cecbcb984b74babb9e213225ce4c', 27, 2, 1, '2019-07-16 09:16:08', '2019-07-15 21:16:07', '2019-07-15 21:16:07');
INSERT INTO `oauth2_refresh_token` VALUES ('3958fc309e444858b3416c4b9860c122', 27, 2, 1, '2019-08-21 06:31:48', '2019-08-20 18:31:48', '2019-08-20 18:31:48');
INSERT INTO `oauth2_refresh_token` VALUES ('395c967849014b869c2a5176365ee175', 27, 2, 1, '2019-07-20 01:01:07', '2019-07-19 13:01:06', '2019-07-19 13:01:06');
INSERT INTO `oauth2_refresh_token` VALUES ('39716c1039ff46e39826f742904a456e', 27, 2, 1, '2019-08-29 04:32:15', '2019-08-28 16:32:14', '2019-08-28 16:32:14');
INSERT INTO `oauth2_refresh_token` VALUES ('39829ac4be634513834c24d933453f31', 27, 2, 1, '2019-08-08 22:40:36', '2019-08-08 10:40:35', '2019-08-08 10:40:35');
INSERT INTO `oauth2_refresh_token` VALUES ('399b6c65498342b6a1c8e7ca4ba796e6', 1, 2, 0, '2019-07-09 20:15:08', '2019-07-09 08:15:08', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('39ad47843589400aabe93ec229d4a826', 27, 2, 1, '2019-06-05 02:55:49', '2019-06-04 14:55:48', '2019-06-04 14:55:48');
INSERT INTO `oauth2_refresh_token` VALUES ('39b014fb2b51449ab472a9204bba6345', 27, 2, 1, '2019-09-07 07:52:47', '2019-09-06 19:52:46', '2019-09-06 19:52:46');
INSERT INTO `oauth2_refresh_token` VALUES ('39be1f9789624c1098e21ccc0cc79097', 27, 2, 1, '2019-07-31 03:06:40', '2019-07-30 15:06:40', '2019-07-30 15:06:40');
INSERT INTO `oauth2_refresh_token` VALUES ('39c9680d5ec64a71bccd0bd2378c5bd0', 27, 2, 1, '2019-06-11 03:06:30', '2019-06-10 15:06:30', '2019-06-10 15:06:30');
INSERT INTO `oauth2_refresh_token` VALUES ('39d67485a9af4ea8b0934ae1cad2963b', 1, 2, 0, '2019-09-01 10:19:11', '2019-08-31 22:19:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('39ecd1f3b57a4bd9a5bc0f2ca9857779', 27, 2, 1, '2019-07-13 03:05:39', '2019-07-12 15:05:38', '2019-07-12 15:05:38');
INSERT INTO `oauth2_refresh_token` VALUES ('39f0757a4e624d658303953486f3779b', 27, 2, 1, '2019-06-05 01:34:50', '2019-06-04 13:34:49', '2019-06-04 13:34:49');
INSERT INTO `oauth2_refresh_token` VALUES ('39fdfc40efc942f382e5b85ac2d86261', 27, 2, 1, '2019-08-19 21:06:12', '2019-08-19 09:06:12', '2019-08-19 09:06:12');
INSERT INTO `oauth2_refresh_token` VALUES ('3a1278c5a88b43d8bedf4b66b7f721ce', NULL, NULL, 1, '2019-05-05 21:52:37', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3a15be232caa49389fbecdced542153d', 27, 2, 1, '2019-06-20 07:45:21', '2019-06-19 19:45:20', '2019-06-19 19:45:20');
INSERT INTO `oauth2_refresh_token` VALUES ('3a46c584c5cd4a5da854d243c2e27513', 27, 2, 1, '2019-06-28 05:30:22', '2019-06-27 17:30:21', '2019-06-27 17:30:21');
INSERT INTO `oauth2_refresh_token` VALUES ('3a4786b446bf43768d1888cd27182127', 27, 2, 1, '2019-07-16 02:14:34', '2019-07-15 14:14:34', '2019-07-15 14:14:34');
INSERT INTO `oauth2_refresh_token` VALUES ('3a55762a46f1473eaba3969edb59af57', 27, 2, 1, '2019-08-21 06:08:05', '2019-08-20 18:08:05', '2019-08-20 18:08:05');
INSERT INTO `oauth2_refresh_token` VALUES ('3a71ebab56f44d68a04b4e07e756f894', 27, 2, 1, '2019-06-04 10:23:30', '2019-06-03 22:23:30', '2019-06-03 22:23:30');
INSERT INTO `oauth2_refresh_token` VALUES ('3a910a9b176b4897a365235bd2a5b387', 27, 2, 1, '2019-06-20 23:22:37', '2019-06-20 11:22:37', '2019-06-20 11:22:37');
INSERT INTO `oauth2_refresh_token` VALUES ('3a974c7d99f84ccbb571f99fdcff1864', 27, 2, 1, '2019-08-03 04:09:31', '2019-08-02 16:09:30', '2019-08-02 16:09:30');
INSERT INTO `oauth2_refresh_token` VALUES ('3a9dbdfedc6f47bda2b0137abe48650e', 27, 2, 1, '2019-06-25 21:37:26', '2019-06-25 09:37:26', '2019-06-25 09:37:26');
INSERT INTO `oauth2_refresh_token` VALUES ('3aa6006aabca4caebceae8c69325b2d4', 27, 2, 1, '2019-08-29 22:44:09', '2019-08-29 10:44:08', '2019-08-29 10:44:08');
INSERT INTO `oauth2_refresh_token` VALUES ('3aa7592177274693a158dcea2af204af', NULL, NULL, 1, '2019-04-30 02:33:00', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3ab8e988118e4016b782796034f6c47c', NULL, NULL, 1, '2019-05-11 21:40:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3aca81b60a45461398dc075536b5dc71', 27, 2, 1, '2019-07-16 02:43:26', '2019-07-15 14:43:26', '2019-07-15 14:43:26');
INSERT INTO `oauth2_refresh_token` VALUES ('3adaa2e725af4a54bcf1c7e64623a966', 27, 2, 1, '2019-07-07 03:14:47', '2019-07-06 15:14:47', '2019-07-06 15:14:47');
INSERT INTO `oauth2_refresh_token` VALUES ('3aee6ca05db048d6b2f4ca231cc46c00', NULL, NULL, 1, '2019-05-08 21:41:12', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3afe78861b07490cb1a7bb699bc5f572', NULL, NULL, 1, '2019-03-13 09:12:17', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3b035704b983491681ffa93a76c9e66a', 27, 2, 1, '2019-05-18 11:11:18', '2019-05-17 23:11:18', '2019-05-17 23:11:18');
INSERT INTO `oauth2_refresh_token` VALUES ('3b083529ebfb4fd2bb20bdb41303eaa0', 27, 2, 1, '2019-07-20 22:26:47', '2019-07-20 10:26:46', '2019-07-20 10:26:46');
INSERT INTO `oauth2_refresh_token` VALUES ('3b140c7bf1384c52a236ec7df5a8fe02', 27, 2, 1, '2019-06-12 08:13:20', '2019-06-11 20:13:20', '2019-06-11 20:13:20');
INSERT INTO `oauth2_refresh_token` VALUES ('3b183202da2b4450a25907ae71a9deec', NULL, NULL, 1, '2019-05-12 10:27:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3b1ed4a70590447ebe6cfb2c05067532', NULL, NULL, 1, '2019-04-02 10:33:54', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3b3c82ec932c4f20bd3540abd16f9bc1', 27, 2, 1, '2019-06-25 05:21:07', '2019-06-24 17:21:06', '2019-06-24 17:21:06');
INSERT INTO `oauth2_refresh_token` VALUES ('3b5742abd5aa4a02822708a6fd2d0c42', 27, 2, 1, '2019-08-29 13:55:44', '2019-08-29 01:55:44', '2019-08-29 01:55:44');
INSERT INTO `oauth2_refresh_token` VALUES ('3b5c65b316cd441d9f50bcb8245fc9f6', 27, 2, 1, '2019-07-28 03:45:48', '2019-07-27 15:45:48', '2019-07-27 15:45:48');
INSERT INTO `oauth2_refresh_token` VALUES ('3b66e497c9cb42398add06fe8416163b', 27, 2, 1, '2019-06-23 05:05:13', '2019-06-22 17:05:12', '2019-06-22 17:05:12');
INSERT INTO `oauth2_refresh_token` VALUES ('3b75a5b077044addbcd2487b1fedb746', 27, 2, 1, '2019-06-04 22:38:25', '2019-06-04 10:38:24', '2019-06-04 10:38:24');
INSERT INTO `oauth2_refresh_token` VALUES ('3b8b4b51998a419ba5077ee352c0271a', NULL, NULL, 1, '2019-03-08 23:46:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3ba1f77aaf654fbe986f339ba6b1bf47', 27, 2, 1, '2019-05-28 11:54:40', '2019-05-27 23:54:40', '2019-05-27 23:54:40');
INSERT INTO `oauth2_refresh_token` VALUES ('3ba7d9964f344b9ea0c8ec235f058bcf', 27, 2, 1, '2019-07-18 21:05:40', '2019-07-18 09:05:39', '2019-07-18 09:05:39');
INSERT INTO `oauth2_refresh_token` VALUES ('3baad1cd336c4ca895fe21edc8bcdbef', NULL, NULL, 1, '2019-04-25 20:40:46', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3bb9f6ba984549d5bd13b183bed13bb9', 27, 2, 1, '2019-06-25 23:21:10', '2019-06-25 11:21:09', '2019-06-25 11:21:09');
INSERT INTO `oauth2_refresh_token` VALUES ('3bc984ee840b4deebea3ec4dc3ab9f19', 27, 2, 1, '2019-06-04 00:38:54', '2019-06-03 12:38:54', '2019-06-03 12:38:54');
INSERT INTO `oauth2_refresh_token` VALUES ('3bd6d46a20c149b59fa73f614704a21e', 27, 2, 1, '2019-06-05 05:57:37', '2019-06-04 17:57:37', '2019-06-04 17:57:37');
INSERT INTO `oauth2_refresh_token` VALUES ('3bfefbe3ab6244958c12f04d808b998c', 27, 2, 1, '2019-07-16 04:00:53', '2019-07-15 16:00:53', '2019-07-15 16:00:53');
INSERT INTO `oauth2_refresh_token` VALUES ('3bffcd1c2d4d43eab2d98bac4c8240e5', 27, 2, 1, '2019-07-15 22:44:08', '2019-07-15 10:44:08', '2019-07-15 10:44:08');
INSERT INTO `oauth2_refresh_token` VALUES ('3c2e09dc9f704c66ab597f300ea8ace4', 27, 2, 1, '2019-06-03 21:27:04', '2019-06-03 09:27:03', '2019-06-03 09:27:03');
INSERT INTO `oauth2_refresh_token` VALUES ('3c4b4e697b6041269ee6e6fb76d546e4', 27, 2, 1, '2019-08-30 22:39:57', '2019-08-30 10:39:56', '2019-08-30 10:39:56');
INSERT INTO `oauth2_refresh_token` VALUES ('3c58f3c6d75048769e348048aaed51b0', 27, 2, 1, '2019-06-29 05:14:44', '2019-06-28 17:14:44', '2019-06-28 17:14:44');
INSERT INTO `oauth2_refresh_token` VALUES ('3c80a09c539d4c97b0e5f81aa4c39349', 27, 2, 1, '2019-06-19 03:26:40', '2019-06-18 15:26:40', '2019-06-18 15:26:40');
INSERT INTO `oauth2_refresh_token` VALUES ('3ccdd89c10834655a5c039f6811b121a', 27, 2, 1, '2019-06-01 04:51:06', '2019-05-31 16:51:05', '2019-05-31 16:51:05');
INSERT INTO `oauth2_refresh_token` VALUES ('3cea44d1f6804c26ae8a1ff177d9ba89', NULL, NULL, 1, '2019-03-11 18:42:57', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3ced85d7b2294ec6b0a121f4a7788dcc', 27, 2, 1, '2019-08-16 22:23:42', '2019-08-16 10:23:41', '2019-08-16 10:23:41');
INSERT INTO `oauth2_refresh_token` VALUES ('3cf8f3f225034c578c153c54c19e16de', 27, 2, 1, '2019-06-02 22:35:03', '2019-06-02 10:35:02', '2019-06-02 10:35:02');
INSERT INTO `oauth2_refresh_token` VALUES ('3d05d8b1a4bd4d94bc054e8ad4f3cc1f', 27, 2, 1, '2019-08-13 05:29:04', '2019-08-12 17:29:03', '2019-08-12 17:29:03');
INSERT INTO `oauth2_refresh_token` VALUES ('3d14efea15f741b9822f35b83dab91de', 27, 2, 1, '2019-09-03 10:44:28', '2019-09-02 22:44:28', '2019-09-02 22:44:28');
INSERT INTO `oauth2_refresh_token` VALUES ('3d49b661d068485089c8f1c4f900bc7e', NULL, NULL, 1, '2019-05-07 01:33:04', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3d5cae1a11334bbc8e024be89fea4589', 145, 1, 1, '2019-07-02 06:37:10', '2019-07-01 18:37:09', '2019-07-01 18:37:09');
INSERT INTO `oauth2_refresh_token` VALUES ('3d5cd247d5334009b644940f6e985af7', 27, 2, 1, '2019-07-05 21:37:41', '2019-07-05 09:37:41', '2019-07-05 09:37:41');
INSERT INTO `oauth2_refresh_token` VALUES ('3d6f7524fbef43b88762e1d4e44eeb0c', 27, 2, 1, '2019-06-12 23:56:22', '2019-06-12 11:56:22', '2019-06-12 11:56:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3d9357a0ee8045878955ab02ea6b8a47', 27, 2, 1, '2019-07-02 10:22:47', '2019-07-01 22:22:47', '2019-07-01 22:22:47');
INSERT INTO `oauth2_refresh_token` VALUES ('3d95ec1ce7dd4d7b94bf83732ff017a2', NULL, NULL, 1, '2019-05-13 08:01:40', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3da17eaf9c104ff3b838f74f82f5db2a', 27, 2, 1, '2019-08-30 22:00:11', '2019-08-30 10:00:10', '2019-08-30 10:00:10');
INSERT INTO `oauth2_refresh_token` VALUES ('3da6f97f1adb486eab8083822ccbf8d8', 27, 2, 1, '2019-07-12 03:29:00', '2019-07-11 15:28:59', '2019-07-11 15:28:59');
INSERT INTO `oauth2_refresh_token` VALUES ('3db211b880e942b0851a38b4ca67c7e3', 134, 1, 1, '2019-06-24 07:01:58', '2019-06-23 19:01:57', '2019-06-23 19:01:57');
INSERT INTO `oauth2_refresh_token` VALUES ('3dc4387c632842f1aae8de2db6be56ed', 27, 2, 1, '2019-07-16 23:04:50', '2019-07-16 11:04:50', '2019-07-16 11:04:50');
INSERT INTO `oauth2_refresh_token` VALUES ('3dcdcf62f36947aaa93791d7102e5c19', 1, 2, 0, '2019-07-21 22:33:34', '2019-07-21 10:33:33', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('3dce012695794b6a96405bce23d9ed96', 1, 2, 0, '2019-07-31 05:12:54', '2019-07-30 17:12:53', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('3dd4b182d5be4e90864bc8e23832052a', 27, 2, 1, '2019-07-11 19:27:37', '2019-07-11 07:27:37', '2019-07-11 07:27:37');
INSERT INTO `oauth2_refresh_token` VALUES ('3de3b1641b5043b98fd3b17e7a28c6ec', 27, 2, 1, '2019-05-25 04:36:24', '2019-05-24 16:36:23', '2019-05-24 16:36:23');
INSERT INTO `oauth2_refresh_token` VALUES ('3df5842ca7014849ad07b49e4168a91e', 200, 1, 1, '2019-08-14 21:44:26', '2019-08-14 09:44:25', '2019-08-14 09:44:25');
INSERT INTO `oauth2_refresh_token` VALUES ('3e065cbe32464a4892e22ddfdfaef8ce', NULL, NULL, 1, '2019-04-02 10:31:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3e38a0716d9f4357a8b067e395b1c653', NULL, NULL, 1, '2019-04-26 11:23:02', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3e588ec0e94c4884936cc384d3bd23eb', 27, 2, 1, '2019-06-06 01:41:39', '2019-06-05 13:41:39', '2019-06-05 13:41:39');
INSERT INTO `oauth2_refresh_token` VALUES ('3e66f05f9467446b8ca234c4112ac18d', 27, 2, 1, '2019-07-03 01:28:47', '2019-07-02 13:28:46', '2019-07-02 13:28:46');
INSERT INTO `oauth2_refresh_token` VALUES ('3e6756a01d704850a559035636aa3ffd', 27, 2, 1, '2019-06-19 02:07:13', '2019-06-18 14:07:13', '2019-06-18 14:07:13');
INSERT INTO `oauth2_refresh_token` VALUES ('3e816dd5420e48d59270c6a375cad888', 27, 2, 1, '2019-05-22 04:29:40', '2019-05-21 16:29:40', '2019-05-21 16:29:40');
INSERT INTO `oauth2_refresh_token` VALUES ('3e9177f488ad4d3698682ca6ed384d66', 27, 2, 1, '2019-06-20 20:47:46', '2019-06-20 08:47:45', '2019-06-20 08:47:45');
INSERT INTO `oauth2_refresh_token` VALUES ('3ea3dc6f58764474a01323c3abec00e0', 27, 2, 1, '2019-06-04 04:50:57', '2019-06-03 16:50:57', '2019-06-03 16:50:57');
INSERT INTO `oauth2_refresh_token` VALUES ('3eb6f12fa7654eb8b33a9ac0f1f26edf', 128, 1, 1, '2019-08-10 03:56:57', '2019-08-09 15:56:56', '2019-08-09 15:56:56');
INSERT INTO `oauth2_refresh_token` VALUES ('3edd0c618e6d4ffeb04b3ced998932d0', NULL, NULL, 1, '2019-05-03 00:27:36', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3ef0330be8764d0d9ebe8b3fcb424560', 199, 1, 1, '2019-08-14 06:08:35', '2019-08-13 18:08:34', '2019-08-13 18:08:34');
INSERT INTO `oauth2_refresh_token` VALUES ('3ef397977dcb450bb6e7e3cb6d742710', 27, 2, 1, '2019-07-25 07:01:35', '2019-07-24 19:01:35', '2019-07-24 19:01:35');
INSERT INTO `oauth2_refresh_token` VALUES ('3f08db7968364277bf4afedcee472414', 27, 2, 1, '2019-07-17 00:48:46', '2019-07-16 12:48:46', '2019-07-16 12:48:46');
INSERT INTO `oauth2_refresh_token` VALUES ('3f0b977aa0ce4996996a114f23cac192', 28, 2, 1, '2019-09-09 11:00:15', '2019-09-08 23:00:15', '2019-09-08 23:00:15');
INSERT INTO `oauth2_refresh_token` VALUES ('3f19d521a2804a3cbb13b7c47a326d62', 1, 2, 0, '2019-07-09 21:05:44', '2019-07-09 09:05:43', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('3f21a6caa6da48e9bd48cde5c8ee8425', NULL, NULL, 0, '2019-03-05 18:37:52', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3f2411b7e85846d7803ebebce5ae1f05', 27, 2, 1, '2019-06-25 04:30:37', '2019-06-24 16:30:37', '2019-06-24 16:30:37');
INSERT INTO `oauth2_refresh_token` VALUES ('3f2fc5e8c96b4c4fa374a5945181063a', 27, 2, 1, '2019-06-26 08:40:14', '2019-06-25 20:40:13', '2019-06-25 20:40:13');
INSERT INTO `oauth2_refresh_token` VALUES ('3f371ed2dcd2416f9a3d3f5fa44d14ee', 27, 2, 1, '2019-08-25 23:30:29', '2019-08-25 11:30:29', '2019-08-25 11:30:29');
INSERT INTO `oauth2_refresh_token` VALUES ('3f642546572e4be49c71dba23dbfb1f3', 27, 2, 1, '2019-06-15 00:34:43', '2019-06-14 12:34:42', '2019-06-14 12:34:42');
INSERT INTO `oauth2_refresh_token` VALUES ('3f6e92aef33c42e89bf26256e19fd347', 27, 2, 1, '2019-07-26 12:28:18', '2019-07-26 00:28:18', '2019-07-26 00:28:18');
INSERT INTO `oauth2_refresh_token` VALUES ('3f739841139d4c04b58be233d3d447fe', 27, 2, 1, '2019-06-22 05:53:49', '2019-06-21 17:53:49', '2019-06-21 17:53:49');
INSERT INTO `oauth2_refresh_token` VALUES ('3f88a228b6fa45f8a00cba940dea92d7', 27, 2, 1, '2019-09-08 09:23:22', '2019-09-07 21:23:21', '2019-09-07 21:23:21');
INSERT INTO `oauth2_refresh_token` VALUES ('3fb818e7af9c4fbab02d7f590fc94a33', NULL, NULL, 0, '2019-02-28 16:19:47', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3fb81c06083c4c0f8df6a8c6106e9c6b', 27, 2, 1, '2019-06-26 21:23:08', '2019-06-26 09:23:07', '2019-06-26 09:23:07');
INSERT INTO `oauth2_refresh_token` VALUES ('3fcf2fd7c51f4699a2aa7378ed7f3a83', NULL, NULL, 1, '2019-04-12 10:44:28', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('3fd72c4e7fac4da9a8de036ea6afb494', 27, 2, 1, '2019-08-09 03:48:36', '2019-08-08 15:48:35', '2019-08-08 15:48:35');
INSERT INTO `oauth2_refresh_token` VALUES ('3fe95522bfdc42b5b0152ddc28bf74a6', 27, 2, 1, '2019-07-21 06:27:00', '2019-07-20 18:26:59', '2019-07-20 18:26:59');
INSERT INTO `oauth2_refresh_token` VALUES ('3febe210f8be4df5bbdea9a98e352a06', 27, 2, 1, '2019-07-17 03:22:36', '2019-07-16 15:22:36', '2019-07-16 15:22:36');
INSERT INTO `oauth2_refresh_token` VALUES ('4016a7d8a1254c8ebebfb253b4edd0ca', 27, 2, 1, '2019-09-09 03:20:58', '2019-09-08 15:20:58', '2019-09-08 15:20:58');
INSERT INTO `oauth2_refresh_token` VALUES ('401a6f70cbf0442f8689e88bc0fe1a98', 27, 2, 1, '2019-07-12 21:01:01', '2019-07-12 09:01:01', '2019-07-12 09:01:01');
INSERT INTO `oauth2_refresh_token` VALUES ('401e3050b684454484cd26f380d9287d', 27, 2, 1, '2019-07-04 21:56:44', '2019-07-04 09:56:43', '2019-07-04 09:56:43');
INSERT INTO `oauth2_refresh_token` VALUES ('402db7a9d25146ef8f80c2732eac0d74', 27, 2, 1, '2019-07-13 04:49:28', '2019-07-12 16:49:27', '2019-07-12 16:49:27');
INSERT INTO `oauth2_refresh_token` VALUES ('4036e55cdc65430280bb0638dc3092de', 27, 2, 1, '2019-06-05 03:56:34', '2019-06-04 15:56:34', '2019-06-04 15:56:34');
INSERT INTO `oauth2_refresh_token` VALUES ('40537da1f859489b885d4f6d958a9297', 27, 2, 1, '2019-07-28 03:12:56', '2019-07-27 15:12:55', '2019-07-27 15:12:55');
INSERT INTO `oauth2_refresh_token` VALUES ('4058dd89a24d4f8a9ae977ad5a00012a', NULL, NULL, 1, '2019-05-06 00:56:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('40594cb628a64ddba9f0e46bb65baa7d', 27, 2, 1, '2019-07-24 20:54:51', '2019-07-24 08:54:51', '2019-07-24 08:54:51');
INSERT INTO `oauth2_refresh_token` VALUES ('4074705836b74f26a1ade27df58c98c5', 27, 2, 1, '2019-06-04 02:43:50', '2019-06-03 14:43:49', '2019-06-03 14:43:49');
INSERT INTO `oauth2_refresh_token` VALUES ('40ec280c32df4df69c49fe1fc01f8267', NULL, NULL, 1, '2019-05-05 00:25:23', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('40f1a17c02f248368bd173ea1cc209b9', NULL, NULL, 1, '2019-04-25 06:18:08', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('40f6fb43a5e1443e9362665ddc14c81f', 27, 2, 1, '2019-08-24 02:13:38', '2019-08-23 14:13:38', '2019-08-23 14:13:38');
INSERT INTO `oauth2_refresh_token` VALUES ('4114e275ee424f52a244693eda462f1f', 121, 1, 1, '2019-06-12 08:13:58', '2019-06-11 20:13:58', '2019-06-11 20:13:58');
INSERT INTO `oauth2_refresh_token` VALUES ('4127908df1aa4bffb7286e80f0bd0931', 27, 2, 1, '2019-06-20 03:38:46', '2019-06-19 15:38:46', '2019-06-19 15:38:46');
INSERT INTO `oauth2_refresh_token` VALUES ('413914c46fc64c348dd9fad659319072', 27, 2, 1, '2019-07-30 06:16:58', '2019-07-29 18:16:57', '2019-07-29 18:16:57');
INSERT INTO `oauth2_refresh_token` VALUES ('413c9ea2a28c4d4599943a39a2d2b7d7', 27, 2, 1, '2019-06-04 21:46:42', '2019-06-04 09:46:41', '2019-06-04 09:46:41');
INSERT INTO `oauth2_refresh_token` VALUES ('4156b9988d2c4b00aebe9db094928ada', NULL, NULL, 1, '2019-05-10 12:31:10', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('41577ec0dbd84ab79c6620671808c9c3', 27, 2, 1, '2019-06-11 23:32:34', '2019-06-11 11:32:34', '2019-06-11 11:32:34');
INSERT INTO `oauth2_refresh_token` VALUES ('415e27a8a97d40de817cbdb276453753', 27, 2, 1, '2019-08-02 03:17:26', '2019-08-01 15:17:26', '2019-08-01 15:17:26');
INSERT INTO `oauth2_refresh_token` VALUES ('4166fd3c66dc4c99b307ac8fd7ad9399', 27, 2, 1, '2019-09-01 10:25:36', '2019-08-31 22:25:36', '2019-08-31 22:25:36');
INSERT INTO `oauth2_refresh_token` VALUES ('418980e3d42b4a0b9f6ca1bcb5af6875', 27, 2, 1, '2019-06-07 04:26:06', '2019-06-06 16:26:05', '2019-06-06 16:26:05');
INSERT INTO `oauth2_refresh_token` VALUES ('4190913e676745cd938b62808824ab28', 27, 2, 1, '2019-06-16 02:38:02', '2019-06-15 14:38:02', '2019-06-15 14:38:02');
INSERT INTO `oauth2_refresh_token` VALUES ('41a3efa25f65457dbb52085d3e217b56', 27, 2, 1, '2019-06-25 03:33:38', '2019-06-24 15:33:38', '2019-06-24 15:33:38');
INSERT INTO `oauth2_refresh_token` VALUES ('41ac10fae8ef48cda38412eafd668d1a', 27, 2, 1, '2019-08-22 23:02:36', '2019-08-22 11:02:35', '2019-08-22 11:02:35');
INSERT INTO `oauth2_refresh_token` VALUES ('41bf089b0e5a4cc3abe676e585cb8848', 27, 2, 1, '2019-06-29 01:43:34', '2019-06-28 13:43:33', '2019-06-28 13:43:33');
INSERT INTO `oauth2_refresh_token` VALUES ('41f3890ca5e1419f9be992262cee4d50', 27, 2, 1, '2019-07-04 06:32:30', '2019-07-03 18:32:29', '2019-07-03 18:32:29');
INSERT INTO `oauth2_refresh_token` VALUES ('41ff15ae9fa64ccfbb2a72e239fd4ccc', NULL, NULL, 1, '2019-04-06 05:08:25', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4219cf321cb647d2a6d8b3350bf434ac', 27, 2, 1, '2019-06-25 09:51:52', '2019-06-24 21:51:52', '2019-06-24 21:51:52');
INSERT INTO `oauth2_refresh_token` VALUES ('421be6a7ea4b4f30b6de5a2e1b4a53bb', 1, 2, 0, '2019-06-10 00:10:12', '2019-06-09 12:10:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('424ea38d5b954e0cb2521c224cbede0d', 1, 2, 0, '2019-07-16 04:10:10', '2019-07-15 16:10:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('425647d02e914296961006307746c96c', NULL, NULL, 1, '2019-04-06 12:17:52', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('426752cc32d942cba634c84177041905', 122, 1, 1, '2019-06-13 04:00:27', '2019-06-12 16:00:27', '2019-06-12 16:00:27');
INSERT INTO `oauth2_refresh_token` VALUES ('42716096f92d4198ac69e0134985188f', 27, 2, 1, '2019-06-03 21:49:38', '2019-06-03 09:49:38', '2019-06-03 09:49:38');
INSERT INTO `oauth2_refresh_token` VALUES ('42781f9355e24a828054bc07b6128d9e', 27, 2, 1, '2019-06-01 04:51:13', '2019-05-31 16:51:13', '2019-05-31 16:51:13');
INSERT INTO `oauth2_refresh_token` VALUES ('42927719d2c04ac28bb136aa36b87809', 27, 2, 1, '2019-07-24 22:25:39', '2019-07-24 10:25:38', '2019-07-24 10:25:38');
INSERT INTO `oauth2_refresh_token` VALUES ('429f25ca14be498082c98a1fd51a8cbc', 27, 2, 1, '2019-05-22 21:14:50', '2019-05-22 09:14:50', '2019-05-22 09:14:50');
INSERT INTO `oauth2_refresh_token` VALUES ('42a9f76ca533429f915d3fbf82def31e', NULL, NULL, 1, '2019-03-15 22:11:19', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('42bdf2afcf4f43a7ba719b8f54c6d8f5', 27, 2, 1, '2019-07-19 01:20:41', '2019-07-18 13:20:41', '2019-07-18 13:20:41');
INSERT INTO `oauth2_refresh_token` VALUES ('42f166f360084c3f9e32c1337e3dd7d8', 27, 2, 1, '2019-07-03 03:31:16', '2019-07-02 15:31:16', '2019-07-02 15:31:16');
INSERT INTO `oauth2_refresh_token` VALUES ('42f310c784494afdb1e9cb11c1e0af8c', 27, 2, 1, '2019-07-31 22:30:42', '2019-07-31 10:30:42', '2019-07-31 10:30:42');
INSERT INTO `oauth2_refresh_token` VALUES ('43002a68701e475dbb0e440fd51ea5e5', NULL, NULL, 1, '2019-04-06 02:21:13', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('43165930bcd34ff7adb67638ee305238', 27, 2, 1, '2019-06-04 08:21:09', '2019-06-03 20:21:08', '2019-06-03 20:21:08');
INSERT INTO `oauth2_refresh_token` VALUES ('432140825a474e959309e785cb75b889', 27, 2, 1, '2019-08-13 05:05:11', '2019-08-12 17:05:11', '2019-08-12 17:05:11');
INSERT INTO `oauth2_refresh_token` VALUES ('432f8b7ebd264806b9c29b71eee8badb', 27, 2, 1, '2019-07-21 21:40:44', '2019-07-21 09:40:44', '2019-07-21 09:40:44');
INSERT INTO `oauth2_refresh_token` VALUES ('433385e8c0f24ca1bc14e8ee4701a1d6', 197, 1, 1, '2019-08-13 05:32:39', '2019-08-12 17:32:39', '2019-08-12 17:32:39');
INSERT INTO `oauth2_refresh_token` VALUES ('433c9b3f4fc54de9aed26558b36271c1', 27, 2, 1, '2019-07-27 05:38:13', '2019-07-26 17:38:12', '2019-07-26 17:38:12');
INSERT INTO `oauth2_refresh_token` VALUES ('435f2c483a3f44afb8dcc1c50e976d7d', 191, 1, 1, '2019-08-03 07:28:21', '2019-08-02 19:28:21', '2019-08-02 19:28:21');
INSERT INTO `oauth2_refresh_token` VALUES ('4396ea13db964d5c8af8b4cc67dec5a7', 27, 2, 1, '2019-07-26 05:18:26', '2019-07-25 17:18:25', '2019-07-25 17:18:25');
INSERT INTO `oauth2_refresh_token` VALUES ('439adccd8a4d48c5acab100558d4f6a5', 27, 2, 1, '2019-06-20 05:14:12', '2019-06-19 17:14:11', '2019-06-19 17:14:11');
INSERT INTO `oauth2_refresh_token` VALUES ('43a3010ce77d47e1844f6b5cc9bd6fec', NULL, NULL, 1, '2019-03-13 11:12:51', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('43c7196728ae4f3ca677b7b119f9d8c8', 27, 2, 1, '2019-06-27 04:20:52', '2019-06-26 16:20:51', '2019-06-26 16:20:51');
INSERT INTO `oauth2_refresh_token` VALUES ('43e46a871f5f4ad185acbaa73d058711', 27, 2, 1, '2019-09-03 21:53:05', '2019-09-03 09:53:05', '2019-09-03 09:53:05');
INSERT INTO `oauth2_refresh_token` VALUES ('4404917a21034b8f8d9ed92be6ce8400', 27, 2, 1, '2019-06-28 02:56:55', '2019-06-27 14:56:55', '2019-06-27 14:56:55');
INSERT INTO `oauth2_refresh_token` VALUES ('440fd085afce4f0b9cf76bed812cebb6', 27, 2, 1, '2019-06-02 07:35:38', '2019-06-01 19:35:38', '2019-06-01 19:35:38');
INSERT INTO `oauth2_refresh_token` VALUES ('441e81821345460a89c3d9a5768893c3', 27, 2, 1, '2019-06-14 00:59:38', '2019-06-13 12:59:37', '2019-06-13 12:59:37');
INSERT INTO `oauth2_refresh_token` VALUES ('442096039f3946fb80ab5d87651cd7ab', 27, 2, 1, '2019-06-05 11:47:23', '2019-06-04 23:47:23', '2019-06-04 23:47:23');
INSERT INTO `oauth2_refresh_token` VALUES ('442eb5e01aab4bc8ab352b01c3540e93', 27, 2, 1, '2019-06-06 23:37:55', '2019-06-06 11:37:54', '2019-06-06 11:37:54');
INSERT INTO `oauth2_refresh_token` VALUES ('44359963f1bc467c890dfe4ae27ec3f7', 27, 2, 1, '2019-08-02 01:56:51', '2019-08-01 13:56:50', '2019-08-01 13:56:50');
INSERT INTO `oauth2_refresh_token` VALUES ('44398c94ee984e0b8cf5d2aa4be4cba1', 1, 2, 0, '2019-06-11 23:14:09', '2019-06-11 11:14:08', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('443aeccb3b5e40a9b57cdaa834c20454', 27, 2, 1, '2019-08-10 03:25:24', '2019-08-09 15:25:23', '2019-08-09 15:25:23');
INSERT INTO `oauth2_refresh_token` VALUES ('4446ef4641be40a090d05e77c7977049', NULL, NULL, 1, '2019-05-02 13:42:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('444d644fe56048d7bf538de31ef49d0d', 27, 2, 1, '2019-05-30 01:32:24', '2019-05-29 13:32:23', '2019-05-29 13:32:23');
INSERT INTO `oauth2_refresh_token` VALUES ('445e333b48734330a18b02f2c8a94549', 27, 2, 1, '2019-05-30 20:50:35', '2019-05-30 08:50:35', '2019-05-30 08:50:35');
INSERT INTO `oauth2_refresh_token` VALUES ('44ab6e4338b647acafc044211334b8d4', 27, 2, 1, '2019-08-08 21:42:14', '2019-08-08 09:42:14', '2019-08-08 09:42:14');
INSERT INTO `oauth2_refresh_token` VALUES ('44b02353ff334beaaffa9a66ef4fa91c', 27, 2, 1, '2019-08-24 05:48:00', '2019-08-23 17:48:00', '2019-08-23 17:48:00');
INSERT INTO `oauth2_refresh_token` VALUES ('44b6c4b3c70c4f84a0ee5bea73081172', 27, 2, 1, '2019-07-16 03:09:19', '2019-07-15 15:09:19', '2019-07-15 15:09:19');
INSERT INTO `oauth2_refresh_token` VALUES ('44c345b96f764da08a80d7228b4f6142', 27, 2, 1, '2019-06-04 05:41:05', '2019-06-03 17:41:05', '2019-06-03 17:41:05');
INSERT INTO `oauth2_refresh_token` VALUES ('44c5c435b1b94767971fb2465c65563c', 27, 2, 1, '2019-06-15 00:37:52', '2019-06-14 12:37:52', '2019-06-14 12:37:52');
INSERT INTO `oauth2_refresh_token` VALUES ('44e6e795da2446ecb7a3fddb59ee315f', 1, 2, 0, '2019-05-27 03:41:37', '2019-05-26 15:41:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('44f476de360c4d10a81121c815833efc', 27, 2, 1, '2019-06-27 05:52:37', '2019-06-26 17:52:37', '2019-06-26 17:52:37');
INSERT INTO `oauth2_refresh_token` VALUES ('451016d4a9354096b0bd737d394a9420', 27, 2, 1, '2019-08-15 02:56:20', '2019-08-14 14:56:19', '2019-08-14 14:56:19');
INSERT INTO `oauth2_refresh_token` VALUES ('452817926cd04814a5befefad95c5cd7', 27, 2, 1, '2019-05-28 04:08:00', '2019-05-27 16:07:59', '2019-05-27 16:07:59');
INSERT INTO `oauth2_refresh_token` VALUES ('45433f62ef9340068a786f64888471b0', NULL, NULL, 0, '2019-02-28 16:08:33', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('45575365d39d4485bd65b1e67412ba0c', 27, 2, 1, '2019-07-06 21:37:04', '2019-07-06 09:37:04', '2019-07-06 09:37:04');
INSERT INTO `oauth2_refresh_token` VALUES ('455e97286c8e4b45a086b8d2e26ea81a', 27, 2, 1, '2019-05-23 02:55:18', '2019-05-22 14:55:17', '2019-05-22 14:55:17');
INSERT INTO `oauth2_refresh_token` VALUES ('4565195d08cb4a5ea8f5386b59eee709', 27, 2, 1, '2019-08-03 05:55:19', '2019-08-02 17:55:18', '2019-08-02 17:55:18');
INSERT INTO `oauth2_refresh_token` VALUES ('4574d23649c54974b4276e6272f3c086', 27, 2, 1, '2019-06-07 02:24:29', '2019-06-06 14:24:29', '2019-06-06 14:24:29');
INSERT INTO `oauth2_refresh_token` VALUES ('4584a54c66e8480ea9d2c3ca289140f6', 27, 2, 1, '2019-08-18 05:01:15', '2019-08-17 17:01:15', '2019-08-17 17:01:15');
INSERT INTO `oauth2_refresh_token` VALUES ('45870c453f6c4983ab2fd7720f11644f', 27, 2, 1, '2019-09-04 04:30:55', '2019-09-03 16:30:54', '2019-09-03 16:30:54');
INSERT INTO `oauth2_refresh_token` VALUES ('45954cd5a70b41e5a1d9014bc89ee8d1', 27, 2, 1, '2019-05-29 04:33:05', '2019-05-28 16:33:05', '2019-05-28 16:33:05');
INSERT INTO `oauth2_refresh_token` VALUES ('45b5a508a90f419f885e3df1402d1f1f', 27, 2, 1, '2019-08-18 23:11:31', '2019-08-18 11:11:30', '2019-08-18 11:11:30');
INSERT INTO `oauth2_refresh_token` VALUES ('45b85dc5eed84fd785eabf0eb5069c8b', NULL, NULL, 1, '2019-03-13 09:29:28', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('45c070f5d07b47c4ab6f24b184ad6728', NULL, NULL, 1, '2019-05-10 07:13:33', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('45d607aeafd9432a915492f32b5906d2', 1, 2, 0, '2019-05-29 02:15:22', '2019-05-28 14:15:22', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('45dcd3f23f09463abf075005768c6bd4', NULL, NULL, 1, '2019-05-08 21:55:31', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('45e65cc991294ca4a7f85276295495eb', 27, 2, 1, '2019-08-13 04:07:19', '2019-08-12 16:07:19', '2019-08-12 16:07:19');
INSERT INTO `oauth2_refresh_token` VALUES ('45e6d4371f094a33a39dfa78a0107008', NULL, NULL, 1, '2019-04-06 04:25:42', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('460fdb6158cf407e8bc26adfdd556c13', 27, 2, 1, '2019-06-10 07:46:42', '2019-06-09 19:46:41', '2019-06-09 19:46:41');
INSERT INTO `oauth2_refresh_token` VALUES ('462e193e72ce426396dc50f9c5d1e683', NULL, NULL, 1, '2019-05-03 21:14:21', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('463480e8ac8f4d9aab17e591d4a695dc', 1, 2, 0, '2019-07-04 21:07:38', '2019-07-04 09:07:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('463c633b4cf54f268fa54b4fffe6aa43', NULL, NULL, 1, '2019-04-29 05:46:31', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('463d34ccbc94422b98b5f839213b8be5', 27, 2, 1, '2019-06-12 23:34:49', '2019-06-12 11:34:48', '2019-06-12 11:34:48');
INSERT INTO `oauth2_refresh_token` VALUES ('46505fa479b14b60a032e1f3b3d13502', 27, 2, 1, '2019-06-21 12:57:49', '2019-06-21 00:57:48', '2019-06-21 00:57:48');
INSERT INTO `oauth2_refresh_token` VALUES ('4653acacfa154da98f85d962fa7657ca', 27, 2, 1, '2019-08-20 02:07:17', '2019-08-19 14:07:17', '2019-08-19 14:07:17');
INSERT INTO `oauth2_refresh_token` VALUES ('4679b2237bf24a32a5c6c14a21a3553f', 27, 2, 1, '2019-08-12 23:39:41', '2019-08-12 11:39:40', '2019-08-12 11:39:40');
INSERT INTO `oauth2_refresh_token` VALUES ('46b5a70d672e4bfab948ceef48893744', NULL, NULL, 1, '2019-05-17 11:43:14', NULL, '2019-05-16 23:43:13');
INSERT INTO `oauth2_refresh_token` VALUES ('46bb7d927c4641d99afbeba09a40e554', 27, 2, 1, '2019-06-26 02:52:09', '2019-06-25 14:52:09', '2019-06-25 14:52:09');
INSERT INTO `oauth2_refresh_token` VALUES ('46e7dfb0749f4e8984c0731cfaf65f9b', 27, 2, 1, '2019-07-16 08:32:44', '2019-07-15 20:32:43', '2019-07-15 20:32:43');
INSERT INTO `oauth2_refresh_token` VALUES ('46f7d5026b5f4cbf84bfb5b1bfad1ca0', 27, 2, 1, '2019-08-21 03:59:24', '2019-08-20 15:59:24', '2019-08-20 15:59:24');
INSERT INTO `oauth2_refresh_token` VALUES ('46ff66b7f67a4f1cb5694481a48f8d95', NULL, NULL, 0, '2019-03-06 18:53:39', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('471fe70866544162a4f365509d092c56', 27, 2, 1, '2019-05-19 04:36:55', '2019-05-18 16:36:54', '2019-05-18 16:36:54');
INSERT INTO `oauth2_refresh_token` VALUES ('4733768481844c04bbe4825c0f69957e', 27, 2, 1, '2019-06-21 01:55:31', '2019-06-20 13:55:30', '2019-06-20 13:55:30');
INSERT INTO `oauth2_refresh_token` VALUES ('47543efadf2645a38dddf2885d0570b7', 27, 2, 1, '2019-07-25 23:04:30', '2019-07-25 11:04:29', '2019-07-25 11:04:29');
INSERT INTO `oauth2_refresh_token` VALUES ('47733c61b28c4cce9472d23f1b67fb33', NULL, NULL, 1, '2019-05-06 10:36:30', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('47823b84ab9d4b908dfe4105ea32680f', NULL, NULL, 1, '2019-05-06 23:00:47', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('478ec131a6684a338687d7830b68ed02', 27, 2, 1, '2019-07-29 21:05:53', '2019-07-29 09:05:53', '2019-07-29 09:05:53');
INSERT INTO `oauth2_refresh_token` VALUES ('479286c16bbe45e4a8df33091021debb', 27, 2, 1, '2019-08-01 01:38:21', '2019-07-31 13:38:21', '2019-07-31 13:38:21');
INSERT INTO `oauth2_refresh_token` VALUES ('47b9834efddd4cb0aa041f94a58c149e', 27, 2, 1, '2019-06-25 01:51:27', '2019-06-24 13:51:26', '2019-06-24 13:51:26');
INSERT INTO `oauth2_refresh_token` VALUES ('47bd2082e43a4edf800cd33542c3d7e8', NULL, NULL, 1, '2019-04-25 02:02:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('47c47ca3dcc944aa8518a3888068fd39', NULL, NULL, 1, '2019-04-23 06:19:51', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('47e6a3cb16b94e26ac614f85b0e577cd', NULL, NULL, 1, '2019-05-16 03:29:05', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('47f2b3ad21534931a7b067f612c42c10', 27, 2, 1, '2019-06-27 06:10:53', '2019-06-26 18:10:52', '2019-06-26 18:10:52');
INSERT INTO `oauth2_refresh_token` VALUES ('47fc77824314443abb2a5cf8e4256b78', 27, 2, 1, '2019-06-05 13:06:43', '2019-06-05 01:06:42', '2019-06-05 01:06:42');
INSERT INTO `oauth2_refresh_token` VALUES ('47fe9818e8544a3d88f1a02ee0d4ecee', 27, 2, 1, '2019-05-30 10:04:11', '2019-05-29 22:04:11', '2019-05-29 22:04:11');
INSERT INTO `oauth2_refresh_token` VALUES ('48084ca6fdb047ce999532fd43696839', 27, 2, 1, '2019-06-03 02:38:10', '2019-06-02 14:38:10', '2019-06-02 14:38:10');
INSERT INTO `oauth2_refresh_token` VALUES ('4815dc94823041a6b0d9da51182e7adc', NULL, NULL, 1, '2019-04-28 03:40:12', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4819e2f35f064bf7b0bc8476c248c6e3', 27, 2, 1, '2019-07-27 04:44:16', '2019-07-26 16:44:16', '2019-07-26 16:44:16');
INSERT INTO `oauth2_refresh_token` VALUES ('4823adb544414999979027e857032e80', 27, 2, 1, '2019-06-20 04:44:53', '2019-06-19 16:44:52', '2019-06-19 16:44:52');
INSERT INTO `oauth2_refresh_token` VALUES ('4825aec434144808ba332496377a8858', 1, 2, 0, '2019-07-18 07:47:40', '2019-07-17 19:47:39', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('482c38c9098542229829d52f84a81960', 27, 2, 1, '2019-06-03 01:45:56', '2019-06-02 13:45:56', '2019-06-02 13:45:56');
INSERT INTO `oauth2_refresh_token` VALUES ('48331dca1d414a6cb97d63af77caf4b2', 27, 2, 1, '2019-05-20 22:46:35', '2019-05-20 10:46:34', '2019-05-20 10:46:34');
INSERT INTO `oauth2_refresh_token` VALUES ('48355ff143224b3b9d545805ca67bac3', NULL, NULL, 1, '2019-04-23 07:46:02', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4837274635494c6c8c9e8ec7f5e3dfa7', 27, 2, 1, '2019-06-07 03:51:25', '2019-06-06 15:51:24', '2019-06-06 15:51:24');
INSERT INTO `oauth2_refresh_token` VALUES ('48385621c96d4aa88bdd9e320265407e', NULL, NULL, 1, '2019-05-06 12:22:28', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('485398910766438b913c3c398e96cfa9', NULL, NULL, 1, '2019-05-08 10:57:16', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('485d61f252554882a2a49463514ab498', 27, 2, 1, '2019-06-13 18:39:35', '2019-06-13 06:39:34', '2019-06-13 06:39:34');
INSERT INTO `oauth2_refresh_token` VALUES ('485f3a5438b14be4a3d9baa79a2861ea', NULL, NULL, 1, '2019-04-23 07:44:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('487c6194588c44f19d6985cca477d829', 27, 2, 1, '2019-08-18 22:38:34', '2019-08-18 10:38:34', '2019-08-18 10:38:34');
INSERT INTO `oauth2_refresh_token` VALUES ('4898d36991964ab69e1bf8bae6d92c3c', 27, 2, 1, '2019-05-18 23:50:49', '2019-05-18 11:50:48', '2019-05-18 11:50:48');
INSERT INTO `oauth2_refresh_token` VALUES ('48a2edc55c4b454ea3bc12987446861c', NULL, NULL, 1, '2019-03-17 08:18:42', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('48a4bbc94b784c6bb6b43d063212bb60', 27, 2, 1, '2019-07-27 05:51:23', '2019-07-26 17:51:23', '2019-07-26 17:51:23');
INSERT INTO `oauth2_refresh_token` VALUES ('48a90adc2551411fbfac03e566817264', 27, 2, 1, '2019-07-05 22:58:50', '2019-07-05 10:58:49', '2019-07-05 10:58:49');
INSERT INTO `oauth2_refresh_token` VALUES ('48abbb54655e4144ad6f165c85c3316f', NULL, NULL, 1, '2019-04-27 23:56:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('48bfe2d65dfc4515b43fff3b7f69bf1c', 27, 2, 1, '2019-06-02 02:31:22', '2019-06-01 14:31:22', '2019-06-01 14:31:22');
INSERT INTO `oauth2_refresh_token` VALUES ('48cee5a16d1f408a902dee3c91e69748', 27, 2, 1, '2019-08-26 22:02:07', '2019-08-26 10:02:07', '2019-08-26 10:02:07');
INSERT INTO `oauth2_refresh_token` VALUES ('48d65f9fd48c4617bac17ad415418843', 27, 2, 1, '2019-06-04 04:43:05', '2019-06-03 16:43:04', '2019-06-03 16:43:04');
INSERT INTO `oauth2_refresh_token` VALUES ('48db20c7e9864e148fc6eb09ef1257d5', NULL, NULL, 1, '2019-03-13 11:44:57', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('48f22611785447dd9c165a3994b7992b', NULL, NULL, 1, '2019-05-02 10:01:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('48f54e0e6ced40a4baedcd6706ae6771', NULL, NULL, 1, '2019-05-06 06:03:26', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4903463bdd45434ab7fa02c23befe936', 27, 2, 1, '2019-06-21 03:33:22', '2019-06-20 15:33:21', '2019-06-20 15:33:21');
INSERT INTO `oauth2_refresh_token` VALUES ('490a18957e5c45ec9ffb4c9abdeacf32', 27, 2, 1, '2019-07-06 06:17:22', '2019-07-05 18:17:21', '2019-07-05 18:17:21');
INSERT INTO `oauth2_refresh_token` VALUES ('4942675ae99440848e68b31ce66e986e', 27, 2, 1, '2019-06-02 05:56:15', '2019-06-01 17:56:15', '2019-06-01 17:56:15');
INSERT INTO `oauth2_refresh_token` VALUES ('4944f7674ca54401be5aa0fdd0bede3e', NULL, NULL, 1, '2019-03-10 19:49:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('496a2a06b05b42c58c6481372e0932cd', 27, 2, 1, '2019-06-19 02:31:41', '2019-06-18 14:31:40', '2019-06-18 14:31:40');
INSERT INTO `oauth2_refresh_token` VALUES ('496e8941426d40698c654e73ead755a5', 27, 2, 1, '2019-08-27 02:28:04', '2019-08-26 14:28:03', '2019-08-26 14:28:03');
INSERT INTO `oauth2_refresh_token` VALUES ('4999089097c84968ae3210f10acfc050', 27, 2, 1, '2019-07-10 22:24:02', '2019-07-10 10:24:02', '2019-07-10 10:24:02');
INSERT INTO `oauth2_refresh_token` VALUES ('499d8fef957f41d8b8a1dcf148df1a9c', 27, 2, 1, '2019-06-01 05:14:28', '2019-05-31 17:14:28', '2019-05-31 17:14:28');
INSERT INTO `oauth2_refresh_token` VALUES ('499e7852c47c4340bbf2e48f67a412ad', NULL, NULL, 1, '2019-05-14 00:30:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('49a5abcdd4da46d3a28d21f4bd0d7d03', 27, 2, 1, '2019-06-02 02:30:34', '2019-06-01 14:30:33', '2019-06-01 14:30:33');
INSERT INTO `oauth2_refresh_token` VALUES ('49a6bdbf832a41108520b230b3f61b49', 27, 2, 1, '2019-08-12 21:20:25', '2019-08-12 09:20:25', '2019-08-12 09:20:25');
INSERT INTO `oauth2_refresh_token` VALUES ('49b99c2ad323454799b4e75d8559e593', 27, 2, 1, '2019-08-12 09:44:12', '2019-08-11 21:44:11', '2019-08-11 21:44:11');
INSERT INTO `oauth2_refresh_token` VALUES ('49e8dd514ad84bf8ba0ae56d2791c787', 27, 2, 1, '2019-06-02 11:48:46', '2019-06-01 23:48:45', '2019-06-01 23:48:45');
INSERT INTO `oauth2_refresh_token` VALUES ('49ef1a5bc16c4cf99c3767a2f6bb8ff9', NULL, NULL, 1, '2019-05-12 22:51:09', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('49f3173b68de44a1b0f3dbd5fe26b61a', 27, 2, 1, '2019-08-21 06:07:29', '2019-08-20 18:07:29', '2019-08-20 18:07:29');
INSERT INTO `oauth2_refresh_token` VALUES ('4a01ad6c591f44b6919ea3bdd5d1debb', 187, 1, 1, '2019-08-02 03:41:15', '2019-08-01 15:41:14', '2019-08-01 15:41:14');
INSERT INTO `oauth2_refresh_token` VALUES ('4a12a1e286164d1cb8ca2ed13f038ff1', NULL, NULL, 1, '2019-05-03 11:08:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4a132d7d7ef145f3815e3e81d8d38d75', 136, 1, 1, '2019-06-25 02:10:39', '2019-06-24 14:10:39', '2019-06-24 14:10:39');
INSERT INTO `oauth2_refresh_token` VALUES ('4a13b540108e4820b157061dd1160305', 27, 2, 1, '2019-08-14 20:38:58', '2019-08-14 08:38:58', '2019-08-14 08:38:58');
INSERT INTO `oauth2_refresh_token` VALUES ('4a37c6b730d9451fab0f3f9dc981b98e', NULL, NULL, 0, '2019-03-04 10:06:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4a4f51b0b8f5446faa935d2816e3ae29', 27, 2, 1, '2019-07-05 20:18:12', '2019-07-05 08:18:11', '2019-07-05 08:18:11');
INSERT INTO `oauth2_refresh_token` VALUES ('4a6a33b8a6e94f3d8566fd8f70d1be4d', 27, 2, 1, '2019-08-04 10:11:59', '2019-08-03 22:11:58', '2019-08-03 22:11:58');
INSERT INTO `oauth2_refresh_token` VALUES ('4a753fc641db48de9d8d7efe667a219e', 27, 2, 1, '2019-06-01 04:55:22', '2019-05-31 16:55:22', '2019-05-31 16:55:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4a828edf679140bea7d9d9120c9aea37', 27, 2, 1, '2019-06-08 06:09:25', '2019-06-07 18:09:25', '2019-06-07 18:09:25');
INSERT INTO `oauth2_refresh_token` VALUES ('4a8e5fd0f43f4b35ab1efb5b1b1a4081', 205, 1, 1, '2019-08-18 03:02:01', '2019-08-17 15:02:00', '2019-08-17 15:02:00');
INSERT INTO `oauth2_refresh_token` VALUES ('4a90205bb8c5407cad5852d41dd526b8', 27, 2, 1, '2019-06-24 10:25:21', '2019-06-23 22:25:20', '2019-06-23 22:25:20');
INSERT INTO `oauth2_refresh_token` VALUES ('4ad0d078c3634cc9ae32204ed5f48671', 27, 2, 1, '2019-06-20 04:11:03', '2019-06-19 16:11:03', '2019-06-19 16:11:03');
INSERT INTO `oauth2_refresh_token` VALUES ('4ad1bbf277954c9d8d7fc9d43bee30cd', 27, 2, 1, '2019-06-02 03:35:56', '2019-06-01 15:35:55', '2019-06-01 15:35:55');
INSERT INTO `oauth2_refresh_token` VALUES ('4ad3b42e1c214fdebe122e8363c0bff4', NULL, NULL, 1, '2019-04-23 07:42:25', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4ae17651713c4ba0a01ddc908738e996', 27, 2, 1, '2019-07-24 03:59:32', '2019-07-23 15:59:32', '2019-07-23 15:59:32');
INSERT INTO `oauth2_refresh_token` VALUES ('4ae23df04bbf4ee4a94bcc4267f299e1', 27, 2, 1, '2019-06-14 00:03:57', '2019-06-13 12:03:57', '2019-06-13 12:03:57');
INSERT INTO `oauth2_refresh_token` VALUES ('4ae4ed8baffc4e25807a5dd4f132d3b9', 27, 2, 1, '2019-08-21 21:45:12', '2019-08-21 09:45:12', '2019-08-21 09:45:12');
INSERT INTO `oauth2_refresh_token` VALUES ('4af47850893c4884a5925f959049d884', 27, 2, 1, '2019-06-17 07:29:21', '2019-06-16 19:29:20', '2019-06-16 19:29:20');
INSERT INTO `oauth2_refresh_token` VALUES ('4b01ec40060a4796ab04243bf7f20c92', 27, 2, 1, '2019-05-29 03:17:03', '2019-05-28 15:17:03', '2019-05-28 15:17:03');
INSERT INTO `oauth2_refresh_token` VALUES ('4b0b34b004c04cacbc48d0b67c331a41', 27, 2, 1, '2019-06-09 00:36:03', '2019-06-08 12:36:03', '2019-06-08 12:36:03');
INSERT INTO `oauth2_refresh_token` VALUES ('4b1ca97a66974db78eb14e5af64d82c3', 27, 2, 1, '2019-07-09 04:03:42', '2019-07-08 16:03:41', '2019-07-08 16:03:41');
INSERT INTO `oauth2_refresh_token` VALUES ('4b3b971802b743238b0cad06f50cb9e0', 27, 2, 1, '2019-06-14 02:08:11', '2019-06-13 14:08:11', '2019-06-13 14:08:11');
INSERT INTO `oauth2_refresh_token` VALUES ('4b3d778cca19420cad3e6211c2d4f4bc', 27, 2, 1, '2019-07-23 18:06:55', '2019-07-23 06:06:54', '2019-07-23 06:06:54');
INSERT INTO `oauth2_refresh_token` VALUES ('4b5de198dc7c439ca59ea2cbd553eff1', NULL, NULL, 1, '2019-05-16 11:18:37', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4b6f1b70e8684cabb90e1d3e229ea9de', 197, 1, 1, '2019-08-13 05:28:19', '2019-08-12 17:28:19', '2019-08-12 17:28:19');
INSERT INTO `oauth2_refresh_token` VALUES ('4b9d285d05c649a6b152496a238665d2', 27, 2, 1, '2019-06-06 05:25:45', '2019-06-05 17:25:45', '2019-06-05 17:25:45');
INSERT INTO `oauth2_refresh_token` VALUES ('4bca174e478445d6b7ae7fecfcc9c120', 27, 2, 1, '2019-06-04 04:10:59', '2019-06-03 16:10:59', '2019-06-03 16:10:59');
INSERT INTO `oauth2_refresh_token` VALUES ('4bca99a960cd47899cf7f65a3998aab4', 27, 2, 1, '2019-08-12 04:41:49', '2019-08-11 16:41:48', '2019-08-11 16:41:48');
INSERT INTO `oauth2_refresh_token` VALUES ('4be25635af034b2187b24307e959b802', 66, 1, 1, '2019-06-04 02:54:37', '2019-06-03 14:54:37', '2019-06-03 14:54:37');
INSERT INTO `oauth2_refresh_token` VALUES ('4beaf6e0bdcc46c0968e676b8695715a', 27, 2, 1, '2019-08-29 21:31:43', '2019-08-29 09:31:42', '2019-08-29 09:31:42');
INSERT INTO `oauth2_refresh_token` VALUES ('4bf01b9b90c04ea6948fe34b8e5b4497', 27, 2, 1, '2019-06-18 03:12:58', '2019-06-17 15:12:57', '2019-06-17 15:12:57');
INSERT INTO `oauth2_refresh_token` VALUES ('4bfc01f4b8e8454b87a754f1d8bd8441', 27, 2, 1, '2019-06-17 08:40:43', '2019-06-16 20:40:42', '2019-06-16 20:40:42');
INSERT INTO `oauth2_refresh_token` VALUES ('4bff073b260245ee9b07091d817e9eb1', 27, 2, 1, '2019-05-27 10:00:51', '2019-05-26 22:00:50', '2019-05-26 22:00:50');
INSERT INTO `oauth2_refresh_token` VALUES ('4c13e445d73b4608a96167c19f20f5de', NULL, NULL, 1, '2019-05-03 09:26:01', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4c21b6ebf5b44bad89e145325b4d3835', 27, 2, 1, '2019-08-21 06:11:40', '2019-08-20 18:11:40', '2019-08-20 18:11:40');
INSERT INTO `oauth2_refresh_token` VALUES ('4c253e52b0a04819b7f0f3d9989892c5', 27, 2, 1, '2019-08-29 10:15:14', '2019-08-28 22:15:14', '2019-08-28 22:15:14');
INSERT INTO `oauth2_refresh_token` VALUES ('4c4022cba2a247878858835746337352', 1, 2, 0, '2019-06-25 11:32:17', '2019-06-24 23:32:16', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('4c6651878c1c4ccdbef040d8ce8b34bb', 27, 2, 1, '2019-07-30 20:17:53', '2019-07-30 08:17:52', '2019-07-30 08:17:52');
INSERT INTO `oauth2_refresh_token` VALUES ('4c66ada4baea4dd385bf741bcd16900c', 27, 2, 1, '2019-07-13 05:55:14', '2019-07-12 17:55:13', '2019-07-12 17:55:13');
INSERT INTO `oauth2_refresh_token` VALUES ('4c78715a7eba4d56851eeb80c58a6287', 27, 2, 1, '2019-07-12 01:52:16', '2019-07-11 13:52:15', '2019-07-11 13:52:15');
INSERT INTO `oauth2_refresh_token` VALUES ('4c84ff6bd733480d832278972cb9ca21', 27, 2, 1, '2019-08-21 03:41:21', '2019-08-20 15:41:20', '2019-08-20 15:41:20');
INSERT INTO `oauth2_refresh_token` VALUES ('4c8f9eebf6df4309918976a4d409bf20', 27, 2, 1, '2019-06-02 09:09:59', '2019-06-01 21:09:58', '2019-06-01 21:09:58');
INSERT INTO `oauth2_refresh_token` VALUES ('4cac4b87d3ca49e59d3df0652bd8846b', NULL, NULL, 1, '2019-03-23 03:58:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4cae72cdc42a4b8fa47a55e5c8dbaa63', 27, 2, 1, '2019-08-27 20:46:05', '2019-08-27 08:46:04', '2019-08-27 08:46:04');
INSERT INTO `oauth2_refresh_token` VALUES ('4cc550ac9da5477abbfb2a419d1e968d', 27, 2, 1, '2019-08-15 05:05:55', '2019-08-14 17:05:55', '2019-08-14 17:05:55');
INSERT INTO `oauth2_refresh_token` VALUES ('4ccf14bc696b47578cd346cf39e72dec', NULL, NULL, 1, '2019-05-08 01:45:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4d1017a9c3ad41a3bbb14d1229d0c7cc', NULL, NULL, 1, '2019-05-04 06:08:20', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4d2314cf434a4a309f00ce3359385e18', 27, 2, 1, '2019-07-13 03:17:23', '2019-07-12 15:17:22', '2019-07-12 15:17:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4d320fd766bb4bf6a7bc3f903dbd9932', 27, 2, 1, '2019-09-07 13:26:21', '2019-09-07 01:26:20', '2019-09-07 01:26:20');
INSERT INTO `oauth2_refresh_token` VALUES ('4d341f152f394b298fb726c01fd264aa', 27, 2, 1, '2019-07-10 02:32:23', '2019-07-09 14:32:22', '2019-07-09 14:32:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4d3cc2e09b304f69bfa49d75af01ab79', 27, 2, 1, '2019-07-18 01:57:12', '2019-07-17 13:57:12', '2019-07-17 13:57:12');
INSERT INTO `oauth2_refresh_token` VALUES ('4d54a9dd999e4ec294d521ce17decef7', NULL, NULL, 0, '2019-03-05 17:44:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4d6dfc14373c45c4a4ce73e107eca7e4', 27, 2, 1, '2019-07-11 23:03:57', '2019-07-11 11:03:57', '2019-07-11 11:03:57');
INSERT INTO `oauth2_refresh_token` VALUES ('4d7f13248b654d2aa7e9a1b6ec521639', 1, 2, 1, '2019-09-09 20:44:47', '2019-09-09 08:44:46', '2019-09-09 08:44:46');
INSERT INTO `oauth2_refresh_token` VALUES ('4d83d54849264d258431318e4e505ac2', 27, 2, 1, '2019-06-04 03:26:33', '2019-06-03 15:26:33', '2019-06-03 15:26:33');
INSERT INTO `oauth2_refresh_token` VALUES ('4d9d585f3e534dee8bc2026ef48902c3', 27, 2, 1, '2019-06-17 10:46:01', '2019-06-16 22:46:01', '2019-06-16 22:46:01');
INSERT INTO `oauth2_refresh_token` VALUES ('4dc1a515ef094e04910dd578d5876824', NULL, NULL, 1, '2019-04-24 19:11:42', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4dc2e4946e2f4060904eaa51f13184ce', 27, 2, 1, '2019-07-24 02:04:42', '2019-07-23 14:04:41', '2019-07-23 14:04:41');
INSERT INTO `oauth2_refresh_token` VALUES ('4dd6551e78d54dd08a2edb93298c5824', 1, 2, 0, '2019-06-10 21:15:50', '2019-06-10 09:15:49', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('4de7a43e4f8e4de78dc166b9f848b368', 27, 2, 1, '2019-07-17 03:25:22', '2019-07-16 15:25:21', '2019-07-16 15:25:21');
INSERT INTO `oauth2_refresh_token` VALUES ('4df7a01a59694b9d8773516cebb8ea06', 27, 2, 1, '2019-09-09 04:56:36', '2019-09-08 16:56:35', '2019-09-08 16:56:35');
INSERT INTO `oauth2_refresh_token` VALUES ('4e2d7d67905240df937de5c457bdfb2f', 27, 2, 1, '2019-08-10 06:08:55', '2019-08-09 18:08:55', '2019-08-09 18:08:55');
INSERT INTO `oauth2_refresh_token` VALUES ('4e5b2c5e8f8c4931b350cb9f02460b7f', 27, 2, 1, '2019-06-01 09:59:32', '2019-05-31 21:59:32', '2019-05-31 21:59:32');
INSERT INTO `oauth2_refresh_token` VALUES ('4e656e94aa8c4b4fa75ffe738efa8f1b', 27, 2, 1, '2019-07-22 04:26:32', '2019-07-21 16:26:32', '2019-07-21 16:26:32');
INSERT INTO `oauth2_refresh_token` VALUES ('4e6c6d8640084d6b896d75639af859ed', 27, 2, 1, '2019-06-01 02:26:50', '2019-05-31 14:26:50', '2019-05-31 14:26:50');
INSERT INTO `oauth2_refresh_token` VALUES ('4e7cdeb1237b45de8fe1ffae881046d8', 27, 2, 1, '2019-07-10 10:46:02', '2019-07-09 22:46:02', '2019-07-09 22:46:02');
INSERT INTO `oauth2_refresh_token` VALUES ('4ea6809d15fc45efbee4038c730550cf', 27, 2, 1, '2019-07-29 22:35:15', '2019-07-29 10:35:14', '2019-07-29 10:35:14');
INSERT INTO `oauth2_refresh_token` VALUES ('4eabf37e1e57416cb153b52a8c363d43', 27, 2, 1, '2019-06-04 03:27:07', '2019-06-03 15:27:07', '2019-06-03 15:27:07');
INSERT INTO `oauth2_refresh_token` VALUES ('4eeb7e008777464d9ee1da8680281a1c', 27, 2, 1, '2019-07-25 00:26:17', '2019-07-24 12:26:17', '2019-07-24 12:26:17');
INSERT INTO `oauth2_refresh_token` VALUES ('4efab12642724a6884e09028db9d4e65', 1, 2, 0, '2019-07-05 22:16:37', '2019-07-05 10:16:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('4f145cca36524bb88cada35a450b8ea8', 27, 2, 1, '2019-07-12 00:58:40', '2019-07-11 12:58:40', '2019-07-11 12:58:40');
INSERT INTO `oauth2_refresh_token` VALUES ('4f17a5d147d14795b3cd61ee955c92b7', 27, 2, 1, '2019-08-06 04:41:03', '2019-08-05 16:41:03', '2019-08-05 16:41:03');
INSERT INTO `oauth2_refresh_token` VALUES ('4f25a268221e4558be75d155f5c5bbc0', 27, 2, 1, '2019-09-02 22:47:42', '2019-09-02 10:47:41', '2019-09-02 10:47:41');
INSERT INTO `oauth2_refresh_token` VALUES ('4f4413b4c4424d63a5cb2720ca131b40', 27, 2, 1, '2019-06-25 08:55:43', '2019-06-24 20:55:43', '2019-06-24 20:55:43');
INSERT INTO `oauth2_refresh_token` VALUES ('4f584ba604214c63bb117e0e5fdbe619', 27, 2, 1, '2019-06-02 01:39:20', '2019-06-01 13:39:19', '2019-06-01 13:39:19');
INSERT INTO `oauth2_refresh_token` VALUES ('4f75977cb4df410a9970392c9c2c7a08', NULL, NULL, 1, '2019-04-06 07:54:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4f8ab6df977e45c2bd6d14813441e18e', 27, 2, 1, '2019-06-27 03:04:48', '2019-06-26 15:04:48', '2019-06-26 15:04:48');
INSERT INTO `oauth2_refresh_token` VALUES ('4f8ede5fd55a49ceb563d2390d4fefc1', 27, 2, 1, '2019-08-14 22:42:49', '2019-08-14 10:42:48', '2019-08-14 10:42:48');
INSERT INTO `oauth2_refresh_token` VALUES ('4fb0b1c89d5c41068a2cdb3a9798db01', NULL, NULL, 0, '2019-03-05 16:43:51', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4fbbb805968440f88a3b8f41b93b762a', NULL, NULL, 1, '2019-05-15 06:14:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('4fe3358deaf04511af51f78cddb31c0a', 27, 2, 1, '2019-06-20 21:28:42', '2019-06-20 09:28:41', '2019-06-20 09:28:41');
INSERT INTO `oauth2_refresh_token` VALUES ('4fee2a420a444d19bacfcbe301df126d', 27, 2, 1, '2019-06-04 23:26:39', '2019-06-04 11:26:38', '2019-06-04 11:26:38');
INSERT INTO `oauth2_refresh_token` VALUES ('4ffc43eb61664594bde891183ef0320d', 27, 2, 1, '2019-07-19 22:09:45', '2019-07-19 10:09:44', '2019-07-19 10:09:44');
INSERT INTO `oauth2_refresh_token` VALUES ('5017f5f33e244fb8adc3970321dde610', 27, 2, 1, '2019-09-05 04:09:07', '2019-09-04 16:09:07', '2019-09-04 16:09:07');
INSERT INTO `oauth2_refresh_token` VALUES ('50192503a79a4257a3ff7354efdf3ece', 27, 2, 1, '2019-08-09 06:26:40', '2019-08-08 18:26:39', '2019-08-08 18:26:39');
INSERT INTO `oauth2_refresh_token` VALUES ('501d09d791124ff2896e65eacd83eca3', 170, 1, 1, '2019-07-16 21:52:56', '2019-07-16 09:52:56', '2019-07-16 09:52:56');
INSERT INTO `oauth2_refresh_token` VALUES ('5029db24a3c7495cbd5a4626309ec1a1', NULL, NULL, 1, '2019-03-10 15:34:15', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5037a04e4a8f460e90f564b15af00458', NULL, NULL, 1, '2019-04-23 06:34:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('50418dab522948aea568d908b57d2bc7', 27, 2, 1, '2019-06-10 23:09:32', '2019-06-10 11:09:32', '2019-06-10 11:09:32');
INSERT INTO `oauth2_refresh_token` VALUES ('5055e043e0e445cdb73c8b0b3f18bd51', 27, 2, 1, '2019-06-16 02:45:37', '2019-06-15 14:45:36', '2019-06-15 14:45:36');
INSERT INTO `oauth2_refresh_token` VALUES ('50667aa588a74f3996b89677598a782a', 27, 2, 1, '2019-06-24 01:16:50', '2019-06-23 13:16:50', '2019-06-23 13:16:50');
INSERT INTO `oauth2_refresh_token` VALUES ('5067407883ab47368703f22884109d21', 27, 2, 1, '2019-06-29 03:51:27', '2019-06-28 15:51:26', '2019-06-28 15:51:26');
INSERT INTO `oauth2_refresh_token` VALUES ('5067eb38a11247f8badfdbe8472e2553', NULL, NULL, 1, '2019-05-13 10:41:29', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('508246a4d4ff40ceb26fa71dc87fa1de', 27, 2, 1, '2019-07-29 00:17:49', '2019-07-28 12:17:49', '2019-07-28 12:17:49');
INSERT INTO `oauth2_refresh_token` VALUES ('50953222cb2f403d9697904b68b6844d', 27, 2, 1, '2019-06-12 08:44:37', '2019-06-11 20:44:36', '2019-06-11 20:44:36');
INSERT INTO `oauth2_refresh_token` VALUES ('50cc034844f7472d93ed12ca0196bca4', 1, 2, 0, '2019-06-04 05:13:36', '2019-06-03 17:13:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('50d7ef1ee57f4fdab87e4429fdc5e23f', 27, 2, 1, '2019-06-02 08:10:17', '2019-06-01 20:10:17', '2019-06-01 20:10:17');
INSERT INTO `oauth2_refresh_token` VALUES ('50f8e59e14ad4038b9dc8e93e4ebf3cc', 27, 2, 1, '2019-07-03 07:52:43', '2019-07-02 19:52:43', '2019-07-02 19:52:43');
INSERT INTO `oauth2_refresh_token` VALUES ('5103fbcee9a443b5a4965b77f88706a9', 116, 1, 1, '2019-06-10 10:56:12', '2019-06-09 22:56:11', '2019-06-09 22:56:11');
INSERT INTO `oauth2_refresh_token` VALUES ('5124504ed519484ab9a0162ab558e7a9', 27, 2, 1, '2019-08-08 21:12:44', '2019-08-08 09:12:44', '2019-08-08 09:12:44');
INSERT INTO `oauth2_refresh_token` VALUES ('51448ebfdee54d4eaf9cbc4358f003df', 27, 2, 1, '2019-08-31 04:01:29', '2019-08-30 16:01:29', '2019-08-30 16:01:29');
INSERT INTO `oauth2_refresh_token` VALUES ('51451c4ff77e4720bbb99a3e26eb9fc8', 27, 2, 1, '2019-06-04 06:33:40', '2019-06-03 18:33:39', '2019-06-03 18:33:39');
INSERT INTO `oauth2_refresh_token` VALUES ('5146db7990fc4dd79ac96889b00ee8b9', 27, 2, 1, '2019-08-16 07:09:19', '2019-08-15 19:09:19', '2019-08-15 19:09:19');
INSERT INTO `oauth2_refresh_token` VALUES ('516db115d41642bebca08452ec35e02e', 27, 2, 1, '2019-05-29 23:14:21', '2019-05-29 11:14:21', '2019-05-29 11:14:21');
INSERT INTO `oauth2_refresh_token` VALUES ('5170aae9b2294245beef124ede172a04', 27, 2, 1, '2019-06-14 01:53:37', '2019-06-13 13:53:36', '2019-06-13 13:53:36');
INSERT INTO `oauth2_refresh_token` VALUES ('517b3f14769d41a69da2f7f85c547dac', 27, 2, 1, '2019-06-02 06:07:22', '2019-06-01 18:07:22', '2019-06-01 18:07:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5180ffde75834996919e633b55eb11c2', 27, 2, 1, '2019-06-03 21:37:33', '2019-06-03 09:37:33', '2019-06-03 09:37:33');
INSERT INTO `oauth2_refresh_token` VALUES ('5182c359662f49cc8251b2d5b4760f4b', NULL, NULL, 1, '2019-05-08 09:22:32', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5184e22ae510473490f78ab815ce2535', 1, 2, 1, '2019-09-09 10:58:16', '2019-09-08 22:58:15', '2019-09-08 22:58:15');
INSERT INTO `oauth2_refresh_token` VALUES ('51886241e43f40fe9b79b394de344325', 27, 2, 1, '2019-08-29 05:45:10', '2019-08-28 17:45:10', '2019-08-28 17:45:10');
INSERT INTO `oauth2_refresh_token` VALUES ('51f1f6408c054248bf130cd77cd881c4', 27, 2, 1, '2019-06-18 08:04:58', '2019-06-17 20:04:57', '2019-06-17 20:04:57');
INSERT INTO `oauth2_refresh_token` VALUES ('51f9d6a68f5d4b38afb04e5ad5f5132c', 27, 2, 1, '2019-08-12 04:13:38', '2019-08-11 16:13:38', '2019-08-11 16:13:38');
INSERT INTO `oauth2_refresh_token` VALUES ('51fc9e46e8464c28acd6857c05f4c2c9', 27, 2, 1, '2019-07-19 00:11:28', '2019-07-18 12:11:27', '2019-07-18 12:11:27');
INSERT INTO `oauth2_refresh_token` VALUES ('52370a3d7ceb4f1682c9c2509ccd5a8e', NULL, NULL, 0, '2019-03-04 10:10:19', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5243b6fe49ca4b6f809409dbeee60e7a', 27, 2, 1, '2019-07-02 03:05:09', '2019-07-01 15:05:08', '2019-07-01 15:05:08');
INSERT INTO `oauth2_refresh_token` VALUES ('52473a362a6d43278a4cff0e77fce1c3', NULL, NULL, 1, '2019-03-16 09:46:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5259b7aaba834c69b08217723417f0e0', NULL, NULL, 1, '2019-05-09 11:07:13', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('527e843882de40d297a4bd32d361028d', 175, 1, 1, '2019-07-18 21:41:55', '2019-07-18 09:41:54', '2019-07-18 09:41:54');
INSERT INTO `oauth2_refresh_token` VALUES ('528b72bcaa4b4134b1a3861cb7f4e390', 118, 1, 1, '2019-06-12 03:52:55', '2019-06-11 15:52:54', '2019-06-11 15:52:54');
INSERT INTO `oauth2_refresh_token` VALUES ('5297ce22971844ffaaa10b89720ca78d', 27, 2, 1, '2019-07-24 22:08:52', '2019-07-24 10:08:51', '2019-07-24 10:08:51');
INSERT INTO `oauth2_refresh_token` VALUES ('52bce1d29f4b49bdb30231d65408bc01', 27, 2, 1, '2019-06-03 21:45:04', '2019-06-03 09:45:03', '2019-06-03 09:45:03');
INSERT INTO `oauth2_refresh_token` VALUES ('52c5da9fb6fa461db4c5cb4add8ef7d5', 27, 2, 1, '2019-06-03 21:24:49', '2019-06-03 09:24:49', '2019-06-03 09:24:49');
INSERT INTO `oauth2_refresh_token` VALUES ('52c6a05e3d7c4fdfbc4332a87962db44', 27, 2, 1, '2019-06-01 12:10:48', '2019-06-01 00:10:48', '2019-06-01 00:10:48');
INSERT INTO `oauth2_refresh_token` VALUES ('52d0241fa3d8405bade3fb67611a2081', 27, 2, 1, '2019-08-26 19:22:34', '2019-08-26 07:22:33', '2019-08-26 07:22:33');
INSERT INTO `oauth2_refresh_token` VALUES ('52e914b70fc24b47914061ee527f34a9', 1, 2, 0, '2019-05-18 05:05:47', '2019-05-17 17:05:47', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('530f8c07ab57424d8e5013abc54ad44e', NULL, NULL, 0, '2019-03-04 10:07:34', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5316e24947d941fcbe94e917cebb48ac', 27, 2, 1, '2019-07-07 11:45:57', '2019-07-06 23:45:56', '2019-07-06 23:45:56');
INSERT INTO `oauth2_refresh_token` VALUES ('531ae5d2922349f9a22016ffbeb9e87e', NULL, NULL, 1, '2019-05-02 12:08:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('531e587c5f934260980f7d7bd0ef22eb', 27, 2, 1, '2019-06-25 23:23:49', '2019-06-25 11:23:48', '2019-06-25 11:23:48');
INSERT INTO `oauth2_refresh_token` VALUES ('53490b57a273418dbfc5ddca33e23675', 1, 2, 0, '2019-07-21 22:38:11', '2019-07-21 10:38:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('536bf755b8a0407aa4e23bd979810db9', 27, 2, 1, '2019-07-11 04:28:22', '2019-07-10 16:28:21', '2019-07-10 16:28:21');
INSERT INTO `oauth2_refresh_token` VALUES ('53731a78afa1488a8044b28e916e87cb', NULL, NULL, 1, '2019-05-09 12:19:19', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('53818cdcc07d4032a15266cb788a0b5e', 27, 2, 1, '2019-08-18 03:58:34', '2019-08-17 15:58:33', '2019-08-17 15:58:33');
INSERT INTO `oauth2_refresh_token` VALUES ('538367140467411ca8083a6354d210db', 27, 2, 1, '2019-08-03 03:39:14', '2019-08-02 15:39:13', '2019-08-02 15:39:13');
INSERT INTO `oauth2_refresh_token` VALUES ('53880e7192be4aee994e71edbfc96b36', 197, 1, 1, '2019-08-13 23:53:47', '2019-08-13 11:53:47', '2019-08-13 11:53:47');
INSERT INTO `oauth2_refresh_token` VALUES ('538ae561c2654ccdb904c425867c0253', NULL, NULL, 1, '2019-04-25 06:43:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('53a05218691e490085d5a0592ea2b7ec', 1, 2, 0, '2019-05-27 05:18:59', '2019-05-26 17:18:58', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('53a3877db2e44f6486c5932b5d0fa606', NULL, NULL, 1, '2019-04-05 04:17:40', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('53a7619e43b748499579bb7ce44f236c', 1, 1, 1, '2019-05-17 22:52:26', '2019-05-17 10:52:26', '2019-05-17 10:52:26');
INSERT INTO `oauth2_refresh_token` VALUES ('53bea3411b1d4835b818ea8afe176a46', 27, 2, 1, '2019-05-23 22:44:29', '2019-05-23 10:44:28', '2019-05-23 10:44:28');
INSERT INTO `oauth2_refresh_token` VALUES ('53c1245f4d854ac1835b18ba66170e22', 27, 2, 1, '2019-09-05 04:35:55', '2019-09-04 16:35:55', '2019-09-04 16:35:55');
INSERT INTO `oauth2_refresh_token` VALUES ('53cf4a2588bc48398fabcc62198d76ec', 27, 2, 1, '2019-07-03 04:34:48', '2019-07-02 16:34:47', '2019-07-02 16:34:47');
INSERT INTO `oauth2_refresh_token` VALUES ('53d79a4b0f8a4fd19eae98a29cb2502c', 27, 2, 1, '2019-07-03 03:16:05', '2019-07-02 15:16:05', '2019-07-02 15:16:05');
INSERT INTO `oauth2_refresh_token` VALUES ('53e70c3204424585b5457523859cab2f', 5, 2, 1, '2019-06-04 04:18:37', '2019-06-03 16:18:36', '2019-06-03 16:18:36');
INSERT INTO `oauth2_refresh_token` VALUES ('53ef089b0ffb4b5eb96eeb9d52ab9809', 27, 2, 1, '2019-07-17 06:33:27', '2019-07-16 18:33:27', '2019-07-16 18:33:27');
INSERT INTO `oauth2_refresh_token` VALUES ('53f46bdf0e654cc4a8e1bc3a4c5066e6', 27, 2, 1, '2019-05-18 23:55:48', '2019-05-18 11:55:48', '2019-05-18 11:55:48');
INSERT INTO `oauth2_refresh_token` VALUES ('5442e23c264343cbb2dcbdbe0cb587b3', 27, 2, 1, '2019-08-08 20:51:58', '2019-08-08 08:51:58', '2019-08-08 08:51:58');
INSERT INTO `oauth2_refresh_token` VALUES ('544cfce6777d4241bf6821407a0892de', 128, 1, 1, '2019-08-04 08:58:41', '2019-08-03 20:58:41', '2019-08-03 20:58:41');
INSERT INTO `oauth2_refresh_token` VALUES ('544ebf922ce54183980b061873150aa0', 1, 2, 0, '2019-06-08 01:30:37', '2019-06-07 13:30:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('548b3cfb33224375ad7136623d5e9fe3', 27, 2, 1, '2019-06-07 21:46:26', '2019-06-07 09:46:25', '2019-06-07 09:46:25');
INSERT INTO `oauth2_refresh_token` VALUES ('548dcdc050bb4a6a96a4409f78216cac', 27, 2, 1, '2019-06-01 12:09:42', '2019-06-01 00:09:42', '2019-06-01 00:09:42');
INSERT INTO `oauth2_refresh_token` VALUES ('548dd7de6425481c8b20255edfad950c', 27, 2, 1, '2019-08-02 05:50:17', '2019-08-01 17:50:17', '2019-08-01 17:50:17');
INSERT INTO `oauth2_refresh_token` VALUES ('549d52738d994ea1b5597b89975aa5e6', 27, 2, 1, '2019-06-05 23:06:46', '2019-06-05 11:06:46', '2019-06-05 11:06:46');
INSERT INTO `oauth2_refresh_token` VALUES ('54af540b412c499faae285286838731a', 27, 2, 1, '2019-07-28 03:39:30', '2019-07-27 15:39:30', '2019-07-27 15:39:30');
INSERT INTO `oauth2_refresh_token` VALUES ('54b3238440024c7f9d4a857c6aaafb9c', 27, 2, 1, '2019-06-24 10:00:45', '2019-06-23 22:00:45', '2019-06-23 22:00:45');
INSERT INTO `oauth2_refresh_token` VALUES ('54b9c5a11e734c60b3fa4a88f62fc2d3', 1, 2, 0, '2019-08-13 11:37:54', '2019-08-12 23:37:53', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('54c2843d8e7944148351133c00399e2e', 27, 2, 1, '2019-07-30 08:18:14', '2019-07-29 20:18:13', '2019-07-29 20:18:13');
INSERT INTO `oauth2_refresh_token` VALUES ('54cf4b710cb74951bce5e2c5bd8978b1', 81, 1, 1, '2019-05-24 23:31:45', '2019-05-24 11:31:45', '2019-05-24 11:31:45');
INSERT INTO `oauth2_refresh_token` VALUES ('54dfc15f7b414619808135272bb7e001', 27, 2, 1, '2019-06-08 21:28:54', '2019-06-08 09:28:54', '2019-06-08 09:28:54');
INSERT INTO `oauth2_refresh_token` VALUES ('54dff1ada36b4006b0f02747ef70c846', 27, 2, 1, '2019-07-23 18:21:44', '2019-07-23 06:21:44', '2019-07-23 06:21:44');
INSERT INTO `oauth2_refresh_token` VALUES ('54e75b245e0b4c5eb8280eb098751553', NULL, NULL, 1, '2019-05-05 01:40:38', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('54e8bb26587d46c49811d55a85000b39', 27, 2, 1, '2019-05-25 09:00:25', '2019-05-24 21:00:24', '2019-05-24 21:00:24');
INSERT INTO `oauth2_refresh_token` VALUES ('5514f954378b4d37859b0cfa28ee04f0', 27, 2, 1, '2019-06-10 05:24:39', '2019-06-09 17:24:39', '2019-06-09 17:24:39');
INSERT INTO `oauth2_refresh_token` VALUES ('552723b319cb4bdabbc1713ed27c3601', 27, 2, 1, '2019-07-01 05:43:20', '2019-06-30 17:43:20', '2019-06-30 17:43:20');
INSERT INTO `oauth2_refresh_token` VALUES ('552ce18445154257aa351cd83a5db183', 27, 2, 1, '2019-06-01 06:37:03', '2019-05-31 18:37:02', '2019-05-31 18:37:02');
INSERT INTO `oauth2_refresh_token` VALUES ('5553375167dd4453810d68f344db1934', 1, 2, 0, '2019-09-05 11:07:57', '2019-09-04 23:07:56', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('555adf9df8984978a24c30652ef92760', 27, 2, 1, '2019-06-08 04:18:28', '2019-06-07 16:18:27', '2019-06-07 16:18:27');
INSERT INTO `oauth2_refresh_token` VALUES ('5562263edee34215b8b063188b740b43', NULL, NULL, 1, '2019-04-02 10:31:19', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5571258378854e148558718b04892b82', 27, 2, 1, '2019-05-29 02:43:26', '2019-05-28 14:43:25', '2019-05-28 14:43:25');
INSERT INTO `oauth2_refresh_token` VALUES ('557b953489aa40ad82f9659386e6197d', 27, 2, 1, '2019-07-19 22:49:44', '2019-07-19 10:49:44', '2019-07-19 10:49:44');
INSERT INTO `oauth2_refresh_token` VALUES ('5587a66ac1af49d19f57376635191608', 27, 2, 1, '2019-08-09 02:27:37', '2019-08-08 14:27:37', '2019-08-08 14:27:37');
INSERT INTO `oauth2_refresh_token` VALUES ('558b13446e5345f8a97ab6f51e2fdd9b', 98, 1, 1, '2019-06-02 06:24:07', '2019-06-01 18:24:06', '2019-06-01 18:24:06');
INSERT INTO `oauth2_refresh_token` VALUES ('5599488aceb343bfb79347994aadbbc9', 27, 2, 1, '2019-08-18 02:30:32', '2019-08-17 14:30:32', '2019-08-17 14:30:32');
INSERT INTO `oauth2_refresh_token` VALUES ('55af69576ad94e01ac43d31684584720', 27, 2, 1, '2019-07-17 23:46:38', '2019-07-17 11:46:37', '2019-07-17 11:46:37');
INSERT INTO `oauth2_refresh_token` VALUES ('55afee5de486420a86bd98b9546fb7f9', NULL, NULL, 1, '2019-05-13 23:33:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('55d392b8ec6e4e7d867e29dee1cc3c17', 27, 2, 1, '2019-07-30 05:41:57', '2019-07-29 17:41:57', '2019-07-29 17:41:57');
INSERT INTO `oauth2_refresh_token` VALUES ('55f60dfe6c7e45629bafade224696053', 27, 2, 1, '2019-06-01 05:11:46', '2019-05-31 17:11:45', '2019-05-31 17:11:45');
INSERT INTO `oauth2_refresh_token` VALUES ('5637052a7bf3483fb49d3c6407f35dfb', 27, 2, 1, '2019-09-02 19:51:14', '2019-09-02 07:51:14', '2019-09-02 07:51:14');
INSERT INTO `oauth2_refresh_token` VALUES ('5656fa6d35f04ff38efd672ab5bd51b4', 27, 2, 1, '2019-06-03 22:14:33', '2019-06-03 10:14:32', '2019-06-03 10:14:32');
INSERT INTO `oauth2_refresh_token` VALUES ('567147c44f95466ba1b6f384e6fab959', 27, 2, 1, '2019-07-08 03:43:08', '2019-07-07 15:43:07', '2019-07-07 15:43:07');
INSERT INTO `oauth2_refresh_token` VALUES ('56811581512c4967a64fc90eafa44f8f', NULL, NULL, 1, '2019-05-04 05:48:37', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('56c79cc7549848a4a389254686884da4', 27, 2, 1, '2019-06-01 09:51:09', '2019-05-31 21:51:08', '2019-05-31 21:51:08');
INSERT INTO `oauth2_refresh_token` VALUES ('56cc78820252485685f6600819df2530', 27, 2, 1, '2019-08-21 06:24:16', '2019-08-20 18:24:16', '2019-08-20 18:24:16');
INSERT INTO `oauth2_refresh_token` VALUES ('56d7e45f4c664588af331c112b6355b5', 27, 2, 1, '2019-08-06 11:43:53', '2019-08-05 23:43:52', '2019-08-05 23:43:52');
INSERT INTO `oauth2_refresh_token` VALUES ('56f6ecd8c55b41acbc064a2a39a27548', 27, 2, 1, '2019-06-20 22:32:13', '2019-06-20 10:32:12', '2019-06-20 10:32:12');
INSERT INTO `oauth2_refresh_token` VALUES ('56f7457e55e543bc94434ca6886157d6', 27, 2, 1, '2019-06-01 10:41:38', '2019-05-31 22:41:38', '2019-05-31 22:41:38');
INSERT INTO `oauth2_refresh_token` VALUES ('5711ef1daa8f4e1aae31272afa826b5d', 27, 2, 1, '2019-06-03 05:11:11', '2019-06-02 17:11:11', '2019-06-02 17:11:11');
INSERT INTO `oauth2_refresh_token` VALUES ('5712034a27724ae79455e66d7394bccf', 27, 2, 1, '2019-08-06 20:39:59', '2019-08-06 08:39:58', '2019-08-06 08:39:58');
INSERT INTO `oauth2_refresh_token` VALUES ('571d8c18478e441c88c3e6f16166b3dc', 27, 2, 1, '2019-09-09 21:36:00', '2019-09-09 09:35:59', '2019-09-09 09:35:59');
INSERT INTO `oauth2_refresh_token` VALUES ('5737d9707b514bf0ba13ae3f6848b6b6', 27, 2, 1, '2019-06-21 20:58:39', '2019-06-21 08:58:39', '2019-06-21 08:58:39');
INSERT INTO `oauth2_refresh_token` VALUES ('5738977de7144691a1576af1bed0427b', 27, 2, 1, '2019-08-26 23:08:59', '2019-08-26 11:08:59', '2019-08-26 11:08:59');
INSERT INTO `oauth2_refresh_token` VALUES ('573bd665d5e340f2b93b704cb9cc1f3b', 27, 2, 1, '2019-06-01 21:10:36', '2019-06-01 09:10:35', '2019-06-01 09:10:35');
INSERT INTO `oauth2_refresh_token` VALUES ('5740261c6679411bb11c4a988eb1fd42', NULL, NULL, 1, '2019-04-23 06:27:03', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5744b3554db8475d9e4a3be20e2a18ab', 27, 2, 1, '2019-06-06 05:37:03', '2019-06-05 17:37:02', '2019-06-05 17:37:02');
INSERT INTO `oauth2_refresh_token` VALUES ('574c83544e084f1188051fabd979cc1c', 27, 2, 1, '2019-06-11 03:08:06', '2019-06-10 15:08:05', '2019-06-10 15:08:05');
INSERT INTO `oauth2_refresh_token` VALUES ('5775064e5fca4e6ab44ec162fd97977b', NULL, NULL, 1, '2019-05-10 04:45:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5781161d83e54040abd9a1d9c63da6d2', 27, 2, 1, '2019-07-18 02:41:11', '2019-07-17 14:41:11', '2019-07-17 14:41:11');
INSERT INTO `oauth2_refresh_token` VALUES ('5786a5abb7d245efacaeafd4a7ad3774', 27, 2, 1, '2019-06-26 09:19:17', '2019-06-25 21:19:16', '2019-06-25 21:19:16');
INSERT INTO `oauth2_refresh_token` VALUES ('579ac17c66d1460db27c039f71409a3a', NULL, NULL, 1, '2019-04-06 08:43:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('57c5398d696043be96665dc01c7ff3b9', 124, 1, 1, '2019-06-15 02:33:18', '2019-06-14 14:33:18', '2019-06-14 14:33:18');
INSERT INTO `oauth2_refresh_token` VALUES ('57e059f5abf84f71b3c7cf527586d50c', 27, 2, 1, '2019-06-13 02:00:55', '2019-06-12 14:00:54', '2019-06-12 14:00:54');
INSERT INTO `oauth2_refresh_token` VALUES ('57e2319082434aa186f269219f608ebc', NULL, NULL, 1, '2019-05-05 19:47:28', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('57f4f20891444e0c92926c44002a25ef', NULL, NULL, 1, '2019-05-02 23:30:29', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5806283f4b70466bb9606d6757c37ab9', 27, 2, 1, '2019-08-11 02:31:13', '2019-08-10 14:31:13', '2019-08-10 14:31:13');
INSERT INTO `oauth2_refresh_token` VALUES ('5825ca9f20e1452a9b09077e767825f1', 27, 2, 1, '2019-09-01 10:15:50', '2019-08-31 22:15:50', '2019-08-31 22:15:50');
INSERT INTO `oauth2_refresh_token` VALUES ('5829265f12f34a629c718d6ebfc83f25', 27, 2, 1, '2019-08-01 04:42:44', '2019-07-31 16:42:43', '2019-07-31 16:42:43');
INSERT INTO `oauth2_refresh_token` VALUES ('583fcd4f418445848ee254f0f3a345ea', 27, 2, 1, '2019-06-20 09:47:08', '2019-06-19 21:47:08', '2019-06-19 21:47:08');
INSERT INTO `oauth2_refresh_token` VALUES ('584adff812d242dfae534e0bdb818ee0', 190, 1, 1, '2019-08-03 04:19:46', '2019-08-02 16:19:45', '2019-08-02 16:19:45');
INSERT INTO `oauth2_refresh_token` VALUES ('58563a919d11416cab17218c960807c4', 27, 2, 1, '2019-07-18 21:04:15', '2019-07-18 09:04:14', '2019-07-18 09:04:14');
INSERT INTO `oauth2_refresh_token` VALUES ('585873617cb045ecb72e9067476e4f6a', NULL, NULL, 1, '2019-05-10 23:26:15', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('58684165110f48399ca334a92bcfe864', 27, 2, 1, '2019-06-01 07:17:19', '2019-05-31 19:17:18', '2019-05-31 19:17:18');
INSERT INTO `oauth2_refresh_token` VALUES ('586a2056377e49938f0d0a7272ca84e2', NULL, NULL, 1, '2019-05-01 12:56:46', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('586e32945d364d0cab5c104e49c0c913', 27, 2, 1, '2019-08-10 01:49:41', '2019-08-09 13:49:40', '2019-08-09 13:49:40');
INSERT INTO `oauth2_refresh_token` VALUES ('5874eecfa4a144a49818d1a35a05ee3f', NULL, NULL, 1, '2019-05-10 09:35:28', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('587b61efda5a4ae1a3900a3650626e27', 27, 2, 1, '2019-08-15 23:20:10', '2019-08-15 11:20:10', '2019-08-15 11:20:10');
INSERT INTO `oauth2_refresh_token` VALUES ('58918ed57089428d845b93bcb5167ed8', 27, 2, 1, '2019-06-02 22:33:09', '2019-06-02 10:33:08', '2019-06-02 10:33:08');
INSERT INTO `oauth2_refresh_token` VALUES ('5894812b2f0843608f8c0af68cfd6e43', 27, 2, 1, '2019-08-02 21:29:38', '2019-08-02 09:29:38', '2019-08-02 09:29:38');
INSERT INTO `oauth2_refresh_token` VALUES ('58977cf9cf4d41569dd8232830eed787', NULL, NULL, 1, '2019-03-10 15:34:39', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('589bdb1180e24ea38b2fb3d87a1e24c6', 27, 2, 1, '2019-07-05 21:49:18', '2019-07-05 09:49:18', '2019-07-05 09:49:18');
INSERT INTO `oauth2_refresh_token` VALUES ('58a428b2349f45a3b64374b2f101920b', 27, 2, 1, '2019-06-07 00:01:48', '2019-06-06 12:01:48', '2019-06-06 12:01:48');
INSERT INTO `oauth2_refresh_token` VALUES ('58b1e33897784ac7a61ee3e99e5a3812', 27, 2, 1, '2019-06-01 21:59:39', '2019-06-01 09:59:39', '2019-06-01 09:59:39');
INSERT INTO `oauth2_refresh_token` VALUES ('58c4d723477c4a75a454970b36507736', 27, 2, 1, '2019-05-21 07:59:08', '2019-05-20 19:59:08', '2019-05-20 19:59:08');
INSERT INTO `oauth2_refresh_token` VALUES ('58cc5d96fd1146dc9c750a64f74b85a2', 27, 2, 1, '2019-06-15 04:18:23', '2019-06-14 16:18:23', '2019-06-14 16:18:23');
INSERT INTO `oauth2_refresh_token` VALUES ('58d6954ad59d4553ac7bc052ffb67931', NULL, NULL, 1, '2019-04-29 04:42:24', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('58dd731f8a9e45e19f6945cba4f2e6a1', 27, 2, 1, '2019-06-03 04:18:52', '2019-06-02 16:18:51', '2019-06-02 16:18:51');
INSERT INTO `oauth2_refresh_token` VALUES ('58ed422ecfcb4bada08862bac02fe0bc', 27, 2, 1, '2019-07-22 23:05:09', '2019-07-22 11:05:08', '2019-07-22 11:05:08');
INSERT INTO `oauth2_refresh_token` VALUES ('58eddf7fbe2845fe8ec0cf3e8c97ad3d', 1, 2, 0, '2019-07-02 22:32:47', '2019-07-02 10:32:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('591da5d89f28493ebf906a2165673477', NULL, NULL, 1, '2019-03-10 14:31:29', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('592eb8b2952244048709a994f4ddc771', 27, 2, 1, '2019-08-10 05:17:28', '2019-08-09 17:17:27', '2019-08-09 17:17:27');
INSERT INTO `oauth2_refresh_token` VALUES ('592fb19c25e542a1a1ecd3d4d4b37a24', 27, 2, 1, '2019-07-03 23:33:26', '2019-07-03 11:33:26', '2019-07-03 11:33:26');
INSERT INTO `oauth2_refresh_token` VALUES ('59346bb134bd447ca8f091206f6256c3', NULL, NULL, 1, '2019-05-03 04:58:46', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('59440c90d08747c68679bb6781052b5a', 27, 2, 1, '2019-06-29 03:12:45', '2019-06-28 15:12:45', '2019-06-28 15:12:45');
INSERT INTO `oauth2_refresh_token` VALUES ('594aab134b4e463fa0c4c92426ed9c1e', 27, 2, 1, '2019-06-01 10:22:26', '2019-05-31 22:22:25', '2019-05-31 22:22:25');
INSERT INTO `oauth2_refresh_token` VALUES ('5951d5cb8e594f35adcca67a62a6780f', 27, 2, 1, '2019-06-04 03:06:08', '2019-06-03 15:06:07', '2019-06-03 15:06:07');
INSERT INTO `oauth2_refresh_token` VALUES ('5959d024501242e7858d9c43a6c44eac', 27, 2, 1, '2019-06-13 03:17:53', '2019-06-12 15:17:53', '2019-06-12 15:17:53');
INSERT INTO `oauth2_refresh_token` VALUES ('596341708ac2482ba46b59f737c9cc96', 1, 2, 0, '2019-07-26 03:53:16', '2019-07-25 15:53:16', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('59692a1b84054661b2f136b165a8d56d', NULL, NULL, 1, '2019-04-27 02:01:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('597632a6a0bd42d7a6496bf4ba878380', 27, 2, 1, '2019-08-12 20:38:30', '2019-08-12 08:38:30', '2019-08-12 08:38:30');
INSERT INTO `oauth2_refresh_token` VALUES ('597f074090b34feeaa235cdbb30ffe66', 27, 2, 1, '2019-07-07 06:23:26', '2019-07-06 18:23:25', '2019-07-06 18:23:25');
INSERT INTO `oauth2_refresh_token` VALUES ('5992295349de478a95dd09c82e0de12e', 165, 1, 1, '2019-07-11 07:42:32', '2019-07-10 19:42:32', '2019-07-10 19:42:32');
INSERT INTO `oauth2_refresh_token` VALUES ('599235b49cfc47739ca45dac5d7890cc', 27, 2, 1, '2019-07-12 20:58:28', '2019-07-12 08:58:27', '2019-07-12 08:58:27');
INSERT INTO `oauth2_refresh_token` VALUES ('5998008333ae4374b2e9cfff2c066fd1', 27, 2, 1, '2019-06-10 23:09:42', '2019-06-10 11:09:41', '2019-06-10 11:09:41');
INSERT INTO `oauth2_refresh_token` VALUES ('599e4d639b8c45cfa131f859f2efa3a0', 27, 2, 1, '2019-06-03 21:06:41', '2019-06-03 09:06:41', '2019-06-03 09:06:41');
INSERT INTO `oauth2_refresh_token` VALUES ('599f5fadba284864b882426c4a3a5416', NULL, NULL, 1, '2019-05-11 12:46:48', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('59a767b37ccd421e944d50b8704631ad', 27, 2, 1, '2019-07-25 09:02:36', '2019-07-24 21:02:36', '2019-07-24 21:02:36');
INSERT INTO `oauth2_refresh_token` VALUES ('59b1df7a3cb344f69fdf9fe0e9fea80d', NULL, NULL, 1, '2019-03-10 16:20:17', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('59c70e4b7b9449feac9c4544e90b5d89', 208, 1, 1, '2019-08-21 05:51:36', '2019-08-20 17:51:36', '2019-08-20 17:51:36');
INSERT INTO `oauth2_refresh_token` VALUES ('59cd027aa47942a1ac3419a7e338fcf0', NULL, NULL, 1, '2019-05-08 10:38:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('59e2b7da0ef54698b3832c833c819b83', 27, 2, 1, '2019-06-11 22:57:44', '2019-06-11 10:57:43', '2019-06-11 10:57:43');
INSERT INTO `oauth2_refresh_token` VALUES ('59e511c5fa6f4f3db07b1e37d49734fc', NULL, NULL, 1, '2019-04-29 04:51:13', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('59ec28b1f89343cd96c5d69fefe33036', 27, 2, 1, '2019-08-17 05:10:57', '2019-08-16 17:10:56', '2019-08-16 17:10:56');
INSERT INTO `oauth2_refresh_token` VALUES ('59fa64b01757455babb201e9b6566812', 27, 2, 1, '2019-07-02 11:06:21', '2019-07-01 23:06:21', '2019-07-01 23:06:21');
INSERT INTO `oauth2_refresh_token` VALUES ('59fc671a9f944a4aa4e78f04a2808ec4', 27, 2, 1, '2019-06-20 07:44:48', '2019-06-19 19:44:47', '2019-06-19 19:44:47');
INSERT INTO `oauth2_refresh_token` VALUES ('5a0f469e1ad84bb0a63e94c48591ccfc', NULL, NULL, 1, '2019-05-01 05:46:28', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5a71ba66624641dfb507157b48869253', 27, 2, 1, '2019-06-01 10:52:52', '2019-05-31 22:52:52', '2019-05-31 22:52:52');
INSERT INTO `oauth2_refresh_token` VALUES ('5a7b423d19bb420fb84d27fd4b7f2045', 27, 2, 1, '2019-06-18 04:50:54', '2019-06-17 16:50:54', '2019-06-17 16:50:54');
INSERT INTO `oauth2_refresh_token` VALUES ('5a89e7d026a34b9c9299ce5e39d70af9', 27, 2, 1, '2019-06-22 02:00:12', '2019-06-21 14:00:12', '2019-06-21 14:00:12');
INSERT INTO `oauth2_refresh_token` VALUES ('5a967145db81417a811ab7557e749a0f', NULL, NULL, 1, '2019-05-06 21:42:06', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5ab164f09c47493cbbb3a50e8c995662', 27, 2, 1, '2019-06-30 10:07:02', '2019-06-29 22:07:01', '2019-06-29 22:07:01');
INSERT INTO `oauth2_refresh_token` VALUES ('5ab3670427294a69be742ad10491f859', 27, 2, 1, '2019-07-22 21:11:04', '2019-07-22 09:11:03', '2019-07-22 09:11:03');
INSERT INTO `oauth2_refresh_token` VALUES ('5ab8cc50ca4e47cc9013b6d2df89c57d', NULL, NULL, 0, '2019-02-27 04:38:51', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5ad4e62aee974ac18a7e884ac52f69aa', 27, 2, 1, '2019-06-29 02:57:32', '2019-06-28 14:57:32', '2019-06-28 14:57:32');
INSERT INTO `oauth2_refresh_token` VALUES ('5ae9ba6d39d440eb854f373057d69140', 27, 2, 1, '2019-07-03 21:43:11', '2019-07-03 09:43:11', '2019-07-03 09:43:11');
INSERT INTO `oauth2_refresh_token` VALUES ('5b016e7053a24f1ea5b3311de0bd89e3', 27, 2, 1, '2019-06-10 04:47:15', '2019-06-09 16:47:15', '2019-06-09 16:47:15');
INSERT INTO `oauth2_refresh_token` VALUES ('5b06527af89843f8a61db61a3d30ba00', NULL, NULL, 1, '2019-05-10 00:51:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5b079f32d7a74f7bb3b8504e4d479adf', 27, 2, 1, '2019-06-26 20:27:51', '2019-06-26 08:27:50', '2019-06-26 08:27:50');
INSERT INTO `oauth2_refresh_token` VALUES ('5b252c2b780f43d8a73599c37c0201e5', NULL, NULL, 1, '2019-05-14 06:05:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5b2a998b10a54392ac6c885f16416415', 27, 2, 1, '2019-05-29 21:25:03', '2019-05-29 09:25:03', '2019-05-29 09:25:03');
INSERT INTO `oauth2_refresh_token` VALUES ('5b2b1a5dc26f40c1af7ef9a9565e95d8', 1, 2, 0, '2019-05-18 06:22:10', '2019-05-17 18:22:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('5b2ee306e6ce4536beb2b496dd48636f', 27, 2, 1, '2019-08-13 22:41:53', '2019-08-13 10:41:53', '2019-08-13 10:41:53');
INSERT INTO `oauth2_refresh_token` VALUES ('5b306d45366e45988704f7fa76b5bcb8', 27, 2, 1, '2019-06-03 23:57:05', '2019-06-03 11:57:05', '2019-06-03 11:57:05');
INSERT INTO `oauth2_refresh_token` VALUES ('5b3fd51cdf3d4b598610ccb3f255836e', 27, 2, 1, '2019-07-09 04:04:43', '2019-07-08 16:04:42', '2019-07-08 16:04:42');
INSERT INTO `oauth2_refresh_token` VALUES ('5b4bd0a9efe84a5c9ca5124c4f6b56e7', 27, 2, 1, '2019-06-04 02:52:02', '2019-06-03 14:52:01', '2019-06-03 14:52:01');
INSERT INTO `oauth2_refresh_token` VALUES ('5b87271011ac4b898e692e25e19ead0c', 27, 2, 1, '2019-08-16 23:35:15', '2019-08-16 11:35:14', '2019-08-16 11:35:14');
INSERT INTO `oauth2_refresh_token` VALUES ('5b89553774974490bec6fb519da5c5dd', 27, 2, 1, '2019-06-16 11:04:36', '2019-06-15 23:04:36', '2019-06-15 23:04:36');
INSERT INTO `oauth2_refresh_token` VALUES ('5b99c482f5b342e1a249cf9bbeae1d64', 27, 2, 1, '2019-07-26 23:47:51', '2019-07-26 11:47:50', '2019-07-26 11:47:50');
INSERT INTO `oauth2_refresh_token` VALUES ('5b9b8a43a1574799a2e58f19b785ad8f', NULL, NULL, 1, '2019-05-10 04:09:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5bb25413d35940108b28375e3cea464b', 1, 2, 0, '2019-06-24 20:27:37', '2019-06-24 08:27:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('5bd5faba15844e98b5d271c8d79d7e5c', 27, 2, 1, '2019-06-04 05:56:29', '2019-06-03 17:56:28', '2019-06-03 17:56:28');
INSERT INTO `oauth2_refresh_token` VALUES ('5be25e6c59614fe79275566bf170b185', 27, 2, 1, '2019-07-06 23:03:02', '2019-07-06 11:03:01', '2019-07-06 11:03:01');
INSERT INTO `oauth2_refresh_token` VALUES ('5bfa30ad428149138c632ca44ef4ffe5', 27, 2, 1, '2019-06-07 06:50:21', '2019-06-06 18:50:20', '2019-06-06 18:50:20');
INSERT INTO `oauth2_refresh_token` VALUES ('5c54ff49fdf740bfbf24cf0d0a5471d3', 1, 1, 1, '2019-05-18 09:51:42', '2019-05-17 21:51:41', '2019-05-17 21:51:41');
INSERT INTO `oauth2_refresh_token` VALUES ('5c5c6f79fd1942c799732bdedc564a61', NULL, NULL, 1, '2019-05-06 04:09:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5c7fa243d83f48e49a57fc609875d590', 27, 2, 1, '2019-06-13 23:07:37', '2019-06-13 11:07:36', '2019-06-13 11:07:36');
INSERT INTO `oauth2_refresh_token` VALUES ('5c85603109bf47efba658388653f7964', 27, 2, 1, '2019-07-22 21:17:53', '2019-07-22 09:17:53', '2019-07-22 09:17:53');
INSERT INTO `oauth2_refresh_token` VALUES ('5cb2cb3beb8544fda7a25bd29ec91dee', 27, 2, 1, '2019-08-21 09:31:49', '2019-08-20 21:31:48', '2019-08-20 21:31:48');
INSERT INTO `oauth2_refresh_token` VALUES ('5cce099443024c2ab57c67f4a6f7dc28', 27, 2, 1, '2019-06-05 04:50:29', '2019-06-04 16:50:28', '2019-06-04 16:50:28');
INSERT INTO `oauth2_refresh_token` VALUES ('5cd8292c47f5416e97535c032a9db18c', NULL, NULL, 1, '2019-03-19 16:09:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5cdf529e96f047a39f062cbb17f2d327', 27, 2, 1, '2019-08-04 23:04:30', '2019-08-04 11:04:30', '2019-08-04 11:04:30');
INSERT INTO `oauth2_refresh_token` VALUES ('5cef34c34ad04ba8a020422b7af22a83', 27, 2, 1, '2019-07-07 01:53:52', '2019-07-06 13:53:52', '2019-07-06 13:53:52');
INSERT INTO `oauth2_refresh_token` VALUES ('5d069a3b37ce4a5abd30696eea8a4946', NULL, NULL, 1, '2019-04-17 01:10:26', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5d2960a7ed844a009e97df04a396554f', NULL, NULL, 1, '2019-05-13 10:33:21', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5d47b7b80abf407f8ef11f792f103fe1', 160, 1, 1, '2019-07-09 04:53:50', '2019-07-08 16:53:50', '2019-07-08 16:53:50');
INSERT INTO `oauth2_refresh_token` VALUES ('5d4ff3a64e274a14862ebd5a080b5e90', NULL, NULL, 1, '2019-04-07 09:43:50', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5d67c67a502c4c6283a5a04c379dedba', 94, 1, 1, '2019-06-01 20:04:58', '2019-06-01 08:04:57', '2019-06-01 08:04:57');
INSERT INTO `oauth2_refresh_token` VALUES ('5d67f0d6a20642fd84c7642840f73e81', 91, 1, 1, '2019-05-30 21:38:34', '2019-05-30 09:38:33', '2019-05-30 09:38:33');
INSERT INTO `oauth2_refresh_token` VALUES ('5d6feead40514f4a8b8fee12c78ce857', 27, 2, 1, '2019-06-25 22:21:57', '2019-06-25 10:21:56', '2019-06-25 10:21:56');
INSERT INTO `oauth2_refresh_token` VALUES ('5d7ba98f910e430b814f61805ea4f2c2', 217, 1, 1, '2019-08-31 03:09:01', '2019-08-30 15:09:00', '2019-08-30 15:09:00');
INSERT INTO `oauth2_refresh_token` VALUES ('5d8fca50eb57485bbe3050f45449c8bb', NULL, NULL, 1, '2019-05-03 10:15:30', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5d945ced8ed24db1a059f8dcc2151e43', NULL, NULL, 1, '2019-05-08 10:31:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5da9df5b66da40809068d053b51e28f8', NULL, NULL, 1, '2019-05-01 21:00:24', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5ddb7a08fe5f45a2a9840fdd4d902495', 27, 2, 1, '2019-08-21 06:24:12', '2019-08-20 18:24:12', '2019-08-20 18:24:12');
INSERT INTO `oauth2_refresh_token` VALUES ('5dde5c9d011e40b9874c00b14e853cb8', 27, 2, 1, '2019-07-27 12:49:01', '2019-07-27 00:49:00', '2019-07-27 00:49:00');
INSERT INTO `oauth2_refresh_token` VALUES ('5dfe3e9552544998b45a8f3802846172', 27, 2, 1, '2019-06-05 03:19:00', '2019-06-04 15:19:00', '2019-06-04 15:19:00');
INSERT INTO `oauth2_refresh_token` VALUES ('5e00cef0772d4fe4b6eb65e96afb978a', 1, 2, 0, '2019-06-29 02:16:12', '2019-06-28 14:16:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('5e0354acde394350b1a6f663da20f7cb', 27, 2, 1, '2019-07-27 05:19:09', '2019-07-26 17:19:09', '2019-07-26 17:19:09');
INSERT INTO `oauth2_refresh_token` VALUES ('5e048d1131cc4c709b8a392eeabde58e', 27, 2, 1, '2019-06-18 23:53:44', '2019-06-18 11:53:43', '2019-06-18 11:53:43');
INSERT INTO `oauth2_refresh_token` VALUES ('5e0492855d734c1d8fe1c5efca5bed0e', NULL, NULL, 1, '2019-05-03 12:00:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5e07bf5fa59149bbaf46cd608ae6242f', 27, 2, 1, '2019-08-06 03:49:40', '2019-08-05 15:49:39', '2019-08-05 15:49:39');
INSERT INTO `oauth2_refresh_token` VALUES ('5e0fc392bbcb405b8af5175ef56bbbe9', 1, 2, 0, '2019-07-27 12:49:16', '2019-07-27 00:49:15', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('5e10535fbad0451597b7c03ea974a67a', 27, 2, 1, '2019-06-04 07:30:11', '2019-06-03 19:30:10', '2019-06-03 19:30:10');
INSERT INTO `oauth2_refresh_token` VALUES ('5e33c7af348c4bdfa4fc646fac108014', NULL, NULL, 1, '2019-05-09 10:53:17', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5e4c51fb0b6045b6906be8dcea83bc9a', 27, 2, 1, '2019-09-06 05:19:00', '2019-09-05 17:19:00', '2019-09-05 17:19:00');
INSERT INTO `oauth2_refresh_token` VALUES ('5e541e6acb7a4350a069ae1563b1f138', 27, 2, 1, '2019-06-10 07:09:08', '2019-06-09 19:09:07', '2019-06-09 19:09:07');
INSERT INTO `oauth2_refresh_token` VALUES ('5e6294ed3ab54a23967d3986b9708784', NULL, NULL, 1, '2019-05-08 06:02:32', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5e67a2458a8a469d835c1c8b92671a52', 27, 2, 1, '2019-08-25 10:37:11', '2019-08-24 22:37:10', '2019-08-24 22:37:10');
INSERT INTO `oauth2_refresh_token` VALUES ('5e685aa882934380886f74b3ca7ada0f', 27, 2, 1, '2019-07-01 05:42:56', '2019-06-30 17:42:56', '2019-06-30 17:42:56');
INSERT INTO `oauth2_refresh_token` VALUES ('5e6e0d2e46884e3db23f4fe5121eefe3', 27, 2, 1, '2019-08-02 10:03:10', '2019-08-01 22:03:09', '2019-08-01 22:03:09');
INSERT INTO `oauth2_refresh_token` VALUES ('5e6ff68134784d92b4badd8a3095bb89', 27, 2, 1, '2019-06-09 08:12:45', '2019-06-08 20:12:44', '2019-06-08 20:12:44');
INSERT INTO `oauth2_refresh_token` VALUES ('5e92a1d0027440bdb1a88d8e91843e98', 27, 2, 1, '2019-06-02 02:53:23', '2019-06-01 14:53:22', '2019-06-01 14:53:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5eb9b0df69514bcf8ec7d79442c61653', 1, 2, 0, '2019-07-05 22:05:28', '2019-07-05 10:05:27', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('5ebdf4aba477479397a248d35d388e3c', 27, 2, 1, '2019-08-12 23:42:29', '2019-08-12 11:42:28', '2019-08-12 11:42:28');
INSERT INTO `oauth2_refresh_token` VALUES ('5ed51ee5f1d3467e8181d841a8d2800d', NULL, NULL, 1, '2019-05-08 07:08:57', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5ef6bceda2f74e2d96929f5080b6ce8a', 27, 2, 1, '2019-06-25 21:47:55', '2019-06-25 09:47:54', '2019-06-25 09:47:54');
INSERT INTO `oauth2_refresh_token` VALUES ('5f05124a3204412498d1895322a25875', 27, 2, 1, '2019-06-01 06:18:38', '2019-05-31 18:18:38', '2019-05-31 18:18:38');
INSERT INTO `oauth2_refresh_token` VALUES ('5f091ea5c9c241d081447cdafa9b372d', 26, 2, 1, '2019-07-05 03:31:42', '2019-07-04 15:31:41', '2019-07-04 15:31:41');
INSERT INTO `oauth2_refresh_token` VALUES ('5f18779197ca4e8a8a9c646b788d1bd5', 27, 2, 1, '2019-05-23 04:24:16', '2019-05-22 16:24:16', '2019-05-22 16:24:16');
INSERT INTO `oauth2_refresh_token` VALUES ('5f26e6bd035544019750c8e03f813495', 27, 2, 1, '2019-08-24 05:33:43', '2019-08-23 17:33:42', '2019-08-23 17:33:42');
INSERT INTO `oauth2_refresh_token` VALUES ('5f3033e44cb44ed383961155f21f72ba', 1, 2, 0, '2019-09-05 05:50:34', '2019-09-04 17:50:34', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('5f3430342e5b40019e6b0d1d1682b203', 27, 2, 1, '2019-06-03 21:16:02', '2019-06-03 09:16:02', '2019-06-03 09:16:02');
INSERT INTO `oauth2_refresh_token` VALUES ('5f725b59b800489d884d7b4cc5b472fd', 27, 2, 1, '2019-06-26 21:56:36', '2019-06-26 09:56:35', '2019-06-26 09:56:35');
INSERT INTO `oauth2_refresh_token` VALUES ('5f72ab57cfe94bd79e866b181027725a', 27, 2, 1, '2019-06-30 06:07:12', '2019-06-29 18:07:12', '2019-06-29 18:07:12');
INSERT INTO `oauth2_refresh_token` VALUES ('5f814f2c15a24afcb1a92a54897715f6', NULL, NULL, 1, '2019-05-12 01:06:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('5f83a91152fc49139241de7537f56513', 27, 2, 1, '2019-06-07 05:40:32', '2019-06-06 17:40:32', '2019-06-06 17:40:32');
INSERT INTO `oauth2_refresh_token` VALUES ('5f8a56a232314915a00018c45d1e4bf8', 27, 2, 1, '2019-06-14 20:53:51', '2019-06-14 08:53:50', '2019-06-14 08:53:50');
INSERT INTO `oauth2_refresh_token` VALUES ('5f9733418d2540bca4b6630a77147f5e', 27, 2, 1, '2019-07-28 05:25:15', '2019-07-27 17:25:14', '2019-07-27 17:25:14');
INSERT INTO `oauth2_refresh_token` VALUES ('5fb4a334a7fa4c16b9a98de0683c4d28', 27, 2, 1, '2019-07-21 22:32:59', '2019-07-21 10:32:58', '2019-07-21 10:32:58');
INSERT INTO `oauth2_refresh_token` VALUES ('5fb698e5dd1041e19ee498356da0b27a', 27, 2, 1, '2019-06-07 02:25:37', '2019-06-06 14:25:36', '2019-06-06 14:25:36');
INSERT INTO `oauth2_refresh_token` VALUES ('5fdedbd816ae4fd39245d5c3fe57a1eb', 27, 2, 1, '2019-06-08 10:32:24', '2019-06-07 22:32:23', '2019-06-07 22:32:23');
INSERT INTO `oauth2_refresh_token` VALUES ('5fdff8f628e640c28404f18a2694d205', 27, 2, 1, '2019-07-24 09:18:12', '2019-07-23 21:18:12', '2019-07-23 21:18:12');
INSERT INTO `oauth2_refresh_token` VALUES ('5fe9d1977f0945cc95ff599dbfe2543d', 27, 2, 1, '2019-07-24 23:09:33', '2019-07-24 11:09:32', '2019-07-24 11:09:32');
INSERT INTO `oauth2_refresh_token` VALUES ('5ff60b28a6e2430eb070b668e552092c', 27, 2, 1, '2019-08-12 23:40:03', '2019-08-12 11:40:02', '2019-08-12 11:40:02');
INSERT INTO `oauth2_refresh_token` VALUES ('600395e470db43838958141424cbdadf', 27, 2, 1, '2019-06-27 03:08:26', '2019-06-26 15:08:26', '2019-06-26 15:08:26');
INSERT INTO `oauth2_refresh_token` VALUES ('6019ab8a92c84d51bc629da5ca071bbf', 27, 2, 1, '2019-06-03 00:04:40', '2019-06-02 12:04:39', '2019-06-02 12:04:39');
INSERT INTO `oauth2_refresh_token` VALUES ('601fffcef1b04b71a5f25d3e1fe434d7', 27, 2, 1, '2019-06-07 03:06:00', '2019-06-06 15:05:59', '2019-06-06 15:05:59');
INSERT INTO `oauth2_refresh_token` VALUES ('6022f659a6b5421788e0ef63a178782b', 1, 2, 0, '2019-07-10 08:27:06', '2019-07-09 20:27:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('602dd95636fa4f73b76f3a793403ec59', 27, 2, 1, '2019-06-03 06:46:02', '2019-06-02 18:46:01', '2019-06-02 18:46:01');
INSERT INTO `oauth2_refresh_token` VALUES ('6045ded655f34365b121b71b6e46cd25', 27, 2, 1, '2019-06-07 03:51:52', '2019-06-06 15:51:52', '2019-06-06 15:51:52');
INSERT INTO `oauth2_refresh_token` VALUES ('60537e26ba58422c825af5cf48713c9a', 27, 2, 1, '2019-07-16 22:19:25', '2019-07-16 10:19:25', '2019-07-16 10:19:25');
INSERT INTO `oauth2_refresh_token` VALUES ('605b4eb0f19249fbbe764f6f66f8b414', 27, 2, 1, '2019-08-30 23:09:49', '2019-08-30 11:09:49', '2019-08-30 11:09:49');
INSERT INTO `oauth2_refresh_token` VALUES ('6062cb2d36df48b59b93877993bd7ec2', NULL, NULL, 1, '2019-05-07 10:32:38', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6092b1859c1040dda666cc66a27ce2ce', NULL, NULL, 1, '2019-03-16 05:18:37', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('60a355493dac41ecb20fbc4a75812940', 1, 2, 0, '2019-08-22 06:02:03', '2019-08-21 18:02:02', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('60d26f460916480e804c7fce11809410', 27, 2, 1, '2019-05-29 22:29:42', '2019-05-29 10:29:42', '2019-05-29 10:29:42');
INSERT INTO `oauth2_refresh_token` VALUES ('60daec63b81e43c58d80999c9c40d55c', NULL, NULL, 1, '2019-03-13 07:42:32', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('60f15795ee40425f9fabbd6be2727bbf', 27, 2, 1, '2019-07-23 06:41:41', '2019-07-22 18:41:41', '2019-07-22 18:41:41');
INSERT INTO `oauth2_refresh_token` VALUES ('610bab2c8a114f768036fc005a80acd9', 27, 2, 1, '2019-05-18 10:09:07', '2019-05-17 22:09:07', '2019-05-17 22:09:07');
INSERT INTO `oauth2_refresh_token` VALUES ('61289d45d9f44b2cae7a5bbddb8e9f81', 27, 2, 1, '2019-06-05 22:06:38', '2019-06-05 10:06:38', '2019-06-05 10:06:38');
INSERT INTO `oauth2_refresh_token` VALUES ('61367efe016c4429a9ce1860bfb7cb6d', 27, 2, 1, '2019-06-05 10:24:13', '2019-06-04 22:24:12', '2019-06-04 22:24:12');
INSERT INTO `oauth2_refresh_token` VALUES ('61699ab44ca24a19a7d184311cbd01ff', 27, 2, 1, '2019-07-16 04:36:41', '2019-07-15 16:36:40', '2019-07-15 16:36:40');
INSERT INTO `oauth2_refresh_token` VALUES ('616a15bf2e4a4a6bae006fdddeb02772', 27, 2, 1, '2019-08-12 05:20:22', '2019-08-11 17:20:21', '2019-08-11 17:20:21');
INSERT INTO `oauth2_refresh_token` VALUES ('617878c46712468bb8709405decaa714', 27, 2, 1, '2019-06-05 08:58:45', '2019-06-04 20:58:45', '2019-06-04 20:58:45');
INSERT INTO `oauth2_refresh_token` VALUES ('6187e6e4afef482e9bdc8b0afda6e683', 27, 2, 1, '2019-06-02 19:18:13', '2019-06-02 07:18:12', '2019-06-02 07:18:12');
INSERT INTO `oauth2_refresh_token` VALUES ('61b2df468c0b4450a0e71b7483927092', NULL, NULL, 1, '2019-04-07 09:39:12', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('61cb5aa26b664154aacbbaefc2fa97f3', NULL, NULL, 1, '2019-04-23 06:20:32', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('61d369b653e9496289a280737ccb828f', 27, 2, 1, '2019-06-23 22:23:03', '2019-06-23 10:23:03', '2019-06-23 10:23:03');
INSERT INTO `oauth2_refresh_token` VALUES ('61f0596454fe40b19131231e46733335', 27, 2, 1, '2019-08-21 07:02:45', '2019-08-20 19:02:44', '2019-08-20 19:02:44');
INSERT INTO `oauth2_refresh_token` VALUES ('6235428e8b2c463fa142ea5cca70f234', 27, 2, 1, '2019-08-03 02:18:50', '2019-08-02 14:18:50', '2019-08-02 14:18:50');
INSERT INTO `oauth2_refresh_token` VALUES ('62361f54362f4fa1b0b83f52830bf44d', 27, 2, 1, '2019-07-08 05:09:10', '2019-07-07 17:09:10', '2019-07-07 17:09:10');
INSERT INTO `oauth2_refresh_token` VALUES ('623b752f4d65400ba7933a79d3b1b1ac', 66, 1, 1, '2019-05-28 04:18:58', '2019-05-27 16:18:57', '2019-05-27 16:18:57');
INSERT INTO `oauth2_refresh_token` VALUES ('624227a9f5844e5db7f0dfa10a3b1f57', NULL, NULL, 1, '2019-03-31 02:36:50', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('624d567fe78e45f38cd27c8fcb39ce31', 27, 2, 1, '2019-07-11 04:38:26', '2019-07-10 16:38:26', '2019-07-10 16:38:26');
INSERT INTO `oauth2_refresh_token` VALUES ('624dbf5625bd4b3a919aa5ca76265120', 27, 2, 1, '2019-06-19 23:12:25', '2019-06-19 11:12:24', '2019-06-19 11:12:24');
INSERT INTO `oauth2_refresh_token` VALUES ('62664fe690184ca3aa16f1cf546ea9b8', 27, 2, 1, '2019-08-19 22:22:19', '2019-08-19 10:22:18', '2019-08-19 10:22:18');
INSERT INTO `oauth2_refresh_token` VALUES ('6269dca04ec04a549cfcc13267169857', 27, 2, 1, '2019-07-20 22:22:39', '2019-07-20 10:22:38', '2019-07-20 10:22:38');
INSERT INTO `oauth2_refresh_token` VALUES ('627401feafdc4dbaa54f1fd7cb6b38c8', 27, 2, 1, '2019-06-03 21:15:40', '2019-06-03 09:15:39', '2019-06-03 09:15:39');
INSERT INTO `oauth2_refresh_token` VALUES ('627519354c1f41e8a1f8a3d9c04a4923', 1, 2, 0, '2019-07-18 06:47:27', '2019-07-17 18:47:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('6286db65ad6847ab9b728e1c3c466f29', 27, 2, 1, '2019-06-04 03:54:53', '2019-06-03 15:54:53', '2019-06-03 15:54:53');
INSERT INTO `oauth2_refresh_token` VALUES ('62ac2e0677b54ee69e43d40a68d38021', 27, 2, 1, '2019-05-23 08:57:49', '2019-05-22 20:57:48', '2019-05-22 20:57:48');
INSERT INTO `oauth2_refresh_token` VALUES ('62bd432602314147937fced5e0f2f523', NULL, NULL, 1, '2019-05-08 06:16:23', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('630247e1e0ab4d85ad540c81c199f1c8', 27, 2, 1, '2019-08-06 02:27:50', '2019-08-05 14:27:50', '2019-08-05 14:27:50');
INSERT INTO `oauth2_refresh_token` VALUES ('6314ac303d264e998b1da702f3388cc7', 27, 2, 1, '2019-07-20 11:43:44', '2019-07-19 23:43:43', '2019-07-19 23:43:43');
INSERT INTO `oauth2_refresh_token` VALUES ('6316a3dae97c4c8ca38d338b187e412a', 27, 2, 1, '2019-07-12 22:14:32', '2019-07-12 10:14:31', '2019-07-12 10:14:31');
INSERT INTO `oauth2_refresh_token` VALUES ('631c8d6c9b5b4d7eb931b476554be81e', 27, 2, 1, '2019-06-01 05:56:44', '2019-05-31 17:56:44', '2019-05-31 17:56:44');
INSERT INTO `oauth2_refresh_token` VALUES ('63347923c18c4a5da596f502a7fdb2f2', 27, 2, 1, '2019-08-08 10:32:36', '2019-08-07 22:32:35', '2019-08-07 22:32:35');
INSERT INTO `oauth2_refresh_token` VALUES ('636400aa9175431f9650e2b179d67537', 27, 2, 1, '2019-06-06 00:03:58', '2019-06-05 12:03:57', '2019-06-05 12:03:57');
INSERT INTO `oauth2_refresh_token` VALUES ('63710b0b7f2c4bda920a6545f3e3bc01', NULL, NULL, 1, '2019-03-19 15:21:26', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('63812c2c13b24b4bb2821fbd6b615333', 27, 2, 1, '2019-06-20 09:22:54', '2019-06-19 21:22:54', '2019-06-19 21:22:54');
INSERT INTO `oauth2_refresh_token` VALUES ('639e3dc3cfa044d8aec46f433d2c0e6c', 27, 2, 1, '2019-07-30 01:59:47', '2019-07-29 13:59:46', '2019-07-29 13:59:46');
INSERT INTO `oauth2_refresh_token` VALUES ('63bfe764b7c94019a8bd1cbcd91cfe62', 27, 2, 1, '2019-07-03 06:23:30', '2019-07-02 18:23:29', '2019-07-02 18:23:29');
INSERT INTO `oauth2_refresh_token` VALUES ('63c4509a21d340b89905273895bd4da1', 27, 2, 1, '2019-06-07 04:22:03', '2019-06-06 16:22:03', '2019-06-06 16:22:03');
INSERT INTO `oauth2_refresh_token` VALUES ('63db0c55cc42446e815fad6dbeb06120', 27, 2, 1, '2019-06-25 05:21:12', '2019-06-24 17:21:12', '2019-06-24 17:21:12');
INSERT INTO `oauth2_refresh_token` VALUES ('63dea74719514ebfb2dc8491c71ff0e0', 27, 2, 1, '2019-06-05 22:42:15', '2019-06-05 10:42:14', '2019-06-05 10:42:14');
INSERT INTO `oauth2_refresh_token` VALUES ('63fe4b91c8c54b8bb39c84b003064be9', 1, 2, 0, '2019-05-28 04:31:37', '2019-05-27 16:31:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('64038a84d2a34484a957ab500435c2b7', 27, 2, 1, '2019-07-09 05:51:23', '2019-07-08 17:51:23', '2019-07-08 17:51:23');
INSERT INTO `oauth2_refresh_token` VALUES ('64087e030d384432981005864a1fb52f', NULL, NULL, 1, '2019-05-09 22:42:30', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6415ead6c73b4c50bd89863b1bb4e3fc', 27, 2, 1, '2019-09-07 10:29:36', '2019-09-06 22:29:35', '2019-09-06 22:29:35');
INSERT INTO `oauth2_refresh_token` VALUES ('642924ad73294f6794b1938010dcd8b4', 27, 2, 1, '2019-08-06 00:03:43', '2019-08-05 12:03:43', '2019-08-05 12:03:43');
INSERT INTO `oauth2_refresh_token` VALUES ('6435e0d739014b7f912a80c446e9c263', 1, 2, 0, '2019-06-24 11:04:13', '2019-06-23 23:04:13', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('6464cc08f6044745925e26157b9e3a3f', 27, 2, 1, '2019-06-14 03:02:17', '2019-06-13 15:02:16', '2019-06-13 15:02:16');
INSERT INTO `oauth2_refresh_token` VALUES ('64684eb884eb4332b364fb35647599a2', 27, 2, 1, '2019-08-21 21:44:45', '2019-08-21 09:44:45', '2019-08-21 09:44:45');
INSERT INTO `oauth2_refresh_token` VALUES ('64728a35524341549c6eae06a34a4e13', 27, 2, 1, '2019-08-19 10:51:19', '2019-08-18 22:51:19', '2019-08-18 22:51:19');
INSERT INTO `oauth2_refresh_token` VALUES ('64823228fd4d4d68aebe9a6e924dd29c', 27, 2, 1, '2019-07-30 00:35:17', '2019-07-29 12:35:16', '2019-07-29 12:35:16');
INSERT INTO `oauth2_refresh_token` VALUES ('64838d1f6a9842ef9538b56a3021126d', 27, 2, 1, '2019-07-13 11:40:33', '2019-07-12 23:40:33', '2019-07-12 23:40:33');
INSERT INTO `oauth2_refresh_token` VALUES ('64864977062e4f55866a9d5b8ca0a23c', 27, 2, 1, '2019-09-05 01:58:57', '2019-09-04 13:58:57', '2019-09-04 13:58:57');
INSERT INTO `oauth2_refresh_token` VALUES ('648c1d4c0ba24631a0713ae3d671816e', 27, 2, 1, '2019-05-24 04:12:26', '2019-05-23 16:12:26', '2019-05-23 16:12:26');
INSERT INTO `oauth2_refresh_token` VALUES ('64b336f91e5c4dcc90fd142dd96f085b', NULL, NULL, 1, '2019-04-30 02:30:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('64c6e484b61341af94bbf9fc377cbda3', 27, 2, 1, '2019-05-22 23:10:49', '2019-05-22 11:10:48', '2019-05-22 11:10:48');
INSERT INTO `oauth2_refresh_token` VALUES ('64d42ed9ea5f4251abe9a1e2f4e71643', NULL, NULL, 1, '2019-05-05 22:13:19', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('64da55fac0de4382bb2269c5363b5e8d', NULL, NULL, 1, '2019-04-23 06:20:33', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('64eb71b6aa034668ba8e26cd47bbb72b', 27, 2, 1, '2019-06-03 22:37:28', '2019-06-03 10:37:28', '2019-06-03 10:37:28');
INSERT INTO `oauth2_refresh_token` VALUES ('64f1f11d8e734b008599c71392dd919b', NULL, NULL, 1, '2019-04-07 02:41:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('64f84f1ab935416aa0c105d9752bd809', 144, 1, 1, '2019-07-02 04:46:04', '2019-07-01 16:46:03', '2019-07-01 16:46:03');
INSERT INTO `oauth2_refresh_token` VALUES ('650f8933819f490ba94860876008889f', 27, 2, 1, '2019-07-30 21:29:44', '2019-07-30 09:29:44', '2019-07-30 09:29:44');
INSERT INTO `oauth2_refresh_token` VALUES ('652a9ecfe26a4863a6d0d16daddc0426', 27, 2, 1, '2019-07-26 06:07:12', '2019-07-25 18:07:11', '2019-07-25 18:07:11');
INSERT INTO `oauth2_refresh_token` VALUES ('6534f660918647e4bc778eb47988d37e', 27, 2, 1, '2019-06-25 23:58:47', '2019-06-25 11:58:47', '2019-06-25 11:58:47');
INSERT INTO `oauth2_refresh_token` VALUES ('6544fcd464ce4d4f93267d52db308b59', 1, 2, 0, '2019-07-21 03:44:50', '2019-07-20 15:44:50', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('6554718e19b141488a7dd2006276615c', 27, 2, 1, '2019-07-30 06:39:51', '2019-07-29 18:39:51', '2019-07-29 18:39:51');
INSERT INTO `oauth2_refresh_token` VALUES ('656a0da6077e42caa5ae2ddf2b10f7c8', NULL, NULL, 1, '2019-04-26 11:44:07', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6572e56e61a743e59f1aa429f1db1e2e', 27, 2, 1, '2019-09-01 05:51:49', '2019-08-31 17:51:48', '2019-08-31 17:51:48');
INSERT INTO `oauth2_refresh_token` VALUES ('658096c3601d42de9dbd4d9bf1fc4662', 27, 2, 1, '2019-07-10 05:36:38', '2019-07-09 17:36:37', '2019-07-09 17:36:37');
INSERT INTO `oauth2_refresh_token` VALUES ('6593199b13134905a0b5c823b4409967', 27, 2, 1, '2019-07-09 23:29:57', '2019-07-09 11:29:57', '2019-07-09 11:29:57');
INSERT INTO `oauth2_refresh_token` VALUES ('659911347198420cacd62a597f387fb3', 27, 2, 1, '2019-08-01 21:41:09', '2019-08-01 09:41:08', '2019-08-01 09:41:08');
INSERT INTO `oauth2_refresh_token` VALUES ('659afefe57154447b7d3ff5f80ac83a3', 27, 2, 1, '2019-07-02 02:59:43', '2019-07-01 14:59:43', '2019-07-01 14:59:43');
INSERT INTO `oauth2_refresh_token` VALUES ('65be9981b44c41eda2af32a5b7ef30cc', 27, 2, 1, '2019-07-25 01:53:53', '2019-07-24 13:53:53', '2019-07-24 13:53:53');
INSERT INTO `oauth2_refresh_token` VALUES ('65c4b91775f8486ba299fd75518a3583', 27, 2, 1, '2019-05-28 14:01:28', '2019-05-28 02:01:28', '2019-05-28 02:01:28');
INSERT INTO `oauth2_refresh_token` VALUES ('65d03dceb00348b194bf7dffe5e20e81', NULL, NULL, 1, '2019-04-30 05:38:33', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('65d3c3ed819c4cd189b74f8257cbe179', 1, 2, 0, '2019-08-22 06:01:52', '2019-08-21 18:01:52', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('65e7d39578de4ae092720af683040e46', NULL, NULL, 1, '2019-03-12 12:30:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('65ee5edb3a3b48c6a82a66bec95c185f', 27, 2, 1, '2019-07-11 11:36:20', '2019-07-10 23:36:19', '2019-07-10 23:36:19');
INSERT INTO `oauth2_refresh_token` VALUES ('65f0a12a7e6748b3b99bdb4cf6e14bd6', 27, 2, 1, '2019-06-01 05:58:56', '2019-05-31 17:58:55', '2019-05-31 17:58:55');
INSERT INTO `oauth2_refresh_token` VALUES ('65f2ff97f26c415a8cf614867d8943bc', NULL, NULL, 1, '2019-05-11 14:26:43', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6602b4a967934848b98917810d88b46b', 27, 2, 1, '2019-06-01 20:09:49', '2019-06-01 08:09:48', '2019-06-01 08:09:48');
INSERT INTO `oauth2_refresh_token` VALUES ('6603323435b94c87acb03e4fb93023ac', 27, 2, 1, '2019-08-28 08:48:58', '2019-08-27 20:48:58', '2019-08-27 20:48:58');
INSERT INTO `oauth2_refresh_token` VALUES ('660fff3739a6414898295d5f4bcc54be', 27, 2, 1, '2019-06-03 04:54:22', '2019-06-02 16:54:22', '2019-06-02 16:54:22');
INSERT INTO `oauth2_refresh_token` VALUES ('661045d037df403ba666266664066d7a', 27, 2, 1, '2019-06-08 10:31:53', '2019-06-07 22:31:52', '2019-06-07 22:31:52');
INSERT INTO `oauth2_refresh_token` VALUES ('662b7aeb841c4b8cb6a82a24abe1f487', 27, 2, 1, '2019-06-22 00:51:20', '2019-06-21 12:51:20', '2019-06-21 12:51:20');
INSERT INTO `oauth2_refresh_token` VALUES ('664e9b0f8ae7428389b27b37b8c35436', 27, 2, 1, '2019-08-27 12:27:44', '2019-08-27 00:27:44', '2019-08-27 00:27:44');
INSERT INTO `oauth2_refresh_token` VALUES ('6657768d2e0b45989a9a02179832dbbe', 27, 2, 1, '2019-07-05 21:45:39', '2019-07-05 09:45:39', '2019-07-05 09:45:39');
INSERT INTO `oauth2_refresh_token` VALUES ('6659139a3e46466189e15d126732c932', NULL, NULL, 1, '2019-03-31 10:15:17', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('66597fb7b88c4b2dbbd118523a4df5c2', 27, 2, 1, '2019-06-27 22:08:54', '2019-06-27 10:08:53', '2019-06-27 10:08:53');
INSERT INTO `oauth2_refresh_token` VALUES ('6661d4a8738a46d18a13891f8549d9ca', NULL, NULL, 1, '2019-03-13 11:04:46', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('666c30f9ab0d446bba16ddabe6c08141', 27, 2, 1, '2019-06-12 20:38:49', '2019-06-12 08:38:48', '2019-06-12 08:38:48');
INSERT INTO `oauth2_refresh_token` VALUES ('6679c74600d44f3590e19825013bceaa', 27, 2, 1, '2019-06-19 04:55:48', '2019-06-18 16:55:47', '2019-06-18 16:55:47');
INSERT INTO `oauth2_refresh_token` VALUES ('6686802383c84dae9a2390dbb407655e', NULL, NULL, 0, '2019-02-28 04:11:01', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('66cafdc2be524f7e922995f8a8633ffe', 27, 2, 1, '2019-07-19 11:26:12', '2019-07-18 23:26:11', '2019-07-18 23:26:11');
INSERT INTO `oauth2_refresh_token` VALUES ('66cedaaaa66c444d923ba5c070c49264', 27, 2, 1, '2019-07-17 06:00:19', '2019-07-16 18:00:18', '2019-07-16 18:00:18');
INSERT INTO `oauth2_refresh_token` VALUES ('66fb40c01b5b44059b3c5a94734a742b', 1, 2, 0, '2019-06-21 08:24:44', '2019-06-20 20:24:43', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('670e54a4dc0841f28c78fba52c1c0b87', 27, 2, 1, '2019-06-19 07:53:00', '2019-06-18 19:52:59', '2019-06-18 19:52:59');
INSERT INTO `oauth2_refresh_token` VALUES ('671740ec95ce449da53cabd60fe43b71', 1, 2, 0, '2019-06-07 10:29:20', '2019-06-06 22:29:19', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('671dfdb77c38472385563b694f1d17b4', NULL, NULL, 1, '2019-05-01 08:02:16', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('67393756c3784fffbae9d886c9652ce5', 27, 2, 1, '2019-07-05 04:36:23', '2019-07-04 16:36:22', '2019-07-04 16:36:22');
INSERT INTO `oauth2_refresh_token` VALUES ('673cef250c70452eb9415e1269d18108', 27, 2, 1, '2019-08-29 05:15:38', '2019-08-28 17:15:38', '2019-08-28 17:15:38');
INSERT INTO `oauth2_refresh_token` VALUES ('673e3eb4834249fb8b02e681e3d6c0c8', 27, 2, 1, '2019-06-05 21:27:19', '2019-06-05 09:27:19', '2019-06-05 09:27:19');
INSERT INTO `oauth2_refresh_token` VALUES ('675ba1134ad24819a4f99ff311c9477d', 27, 2, 1, '2019-06-04 01:47:07', '2019-06-03 13:47:06', '2019-06-03 13:47:06');
INSERT INTO `oauth2_refresh_token` VALUES ('675f8839e92c4c958d81db5a3cc6f056', 27, 2, 1, '2019-06-29 03:04:50', '2019-06-28 15:04:49', '2019-06-28 15:04:49');
INSERT INTO `oauth2_refresh_token` VALUES ('676b04dc9446449b8cd4ca4ba4b2962d', NULL, NULL, 1, '2019-04-23 06:25:23', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6795305cb3854bb1ba0eb4bb49a68025', 27, 2, 1, '2019-06-14 03:37:50', '2019-06-13 15:37:50', '2019-06-13 15:37:50');
INSERT INTO `oauth2_refresh_token` VALUES ('67978bdfe5f24b2aa3ab09c8d061d13d', 27, 2, 1, '2019-09-03 06:28:01', '2019-09-02 18:28:00', '2019-09-02 18:28:00');
INSERT INTO `oauth2_refresh_token` VALUES ('679ef8e590fd496fa1af0ef4197ee51a', 1, 2, 0, '2019-07-04 02:05:30', '2019-07-03 14:05:30', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('67b398a20f624ceda727216daae2688d', 27, 2, 1, '2019-06-03 22:32:52', '2019-06-03 10:32:52', '2019-06-03 10:32:52');
INSERT INTO `oauth2_refresh_token` VALUES ('67b96142719b4bc1b913f25f5207c60e', 27, 2, 1, '2019-06-26 12:15:39', '2019-06-26 00:15:38', '2019-06-26 00:15:38');
INSERT INTO `oauth2_refresh_token` VALUES ('67cd17a0d49f4477818ed5c63dfb8e60', 27, 2, 1, '2019-06-21 02:07:41', '2019-06-20 14:07:41', '2019-06-20 14:07:41');
INSERT INTO `oauth2_refresh_token` VALUES ('67dc4485b238435bba162bca5d0bebdb', 27, 2, 1, '2019-06-02 10:21:58', '2019-06-01 22:21:58', '2019-06-01 22:21:58');
INSERT INTO `oauth2_refresh_token` VALUES ('67dd5265512b41b2933b8b828daa7b9c', 27, 2, 1, '2019-09-03 03:12:01', '2019-09-02 15:12:00', '2019-09-02 15:12:00');
INSERT INTO `oauth2_refresh_token` VALUES ('680e80d565e24e44a54df93f740d13d8', 1, 2, 0, '2019-07-16 11:11:24', '2019-07-15 23:11:23', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('683bc7ea946d45be9017158298f8894e', 27, 2, 1, '2019-06-20 23:28:37', '2019-06-20 11:28:37', '2019-06-20 11:28:37');
INSERT INTO `oauth2_refresh_token` VALUES ('684eb94444944f9091a4ed04db3c7b20', 27, 2, 1, '2019-08-14 05:01:28', '2019-08-13 17:01:28', '2019-08-13 17:01:28');
INSERT INTO `oauth2_refresh_token` VALUES ('6852fa692c5548a7833c74aed32d7173', NULL, NULL, 1, '2019-05-08 12:19:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('68580e5a2dc0445a83d1dc2604dfdf78', NULL, NULL, 1, '2019-04-23 06:44:10', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('68636d21a2f34323aaa78d63297b6367', NULL, NULL, 1, '2019-05-01 08:07:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('68690b1e20a642678501320023c8c108', 27, 2, 1, '2019-07-04 10:52:41', '2019-07-03 22:52:41', '2019-07-03 22:52:41');
INSERT INTO `oauth2_refresh_token` VALUES ('686dbded823248c4be1c8891f90bc0be', 1, 2, 0, '2019-08-28 23:28:10', '2019-08-28 11:28:09', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('686f918e673c421f9b0f89b41885b0eb', 27, 2, 1, '2019-06-04 06:46:39', '2019-06-03 18:46:38', '2019-06-03 18:46:38');
INSERT INTO `oauth2_refresh_token` VALUES ('6870c7ceba694f129cad4c6232987197', 178, 1, 1, '2019-07-20 21:41:00', '2019-07-20 09:41:00', '2019-07-20 09:41:00');
INSERT INTO `oauth2_refresh_token` VALUES ('6871c1ce54214f2599180a7b1585ab76', 27, 2, 1, '2019-06-21 06:55:44', '2019-06-20 18:55:43', '2019-06-20 18:55:43');
INSERT INTO `oauth2_refresh_token` VALUES ('68761bb924ba4795b13b004e4031e19d', 27, 2, 1, '2019-06-01 04:39:03', '2019-05-31 16:39:02', '2019-05-31 16:39:02');
INSERT INTO `oauth2_refresh_token` VALUES ('6879b992b2534a9997db99a6421ffec6', 27, 2, 1, '2019-07-18 08:51:18', '2019-07-17 20:51:17', '2019-07-17 20:51:17');
INSERT INTO `oauth2_refresh_token` VALUES ('688621fb3e184103a3fb3914213627e9', 27, 2, 1, '2019-05-31 23:26:23', '2019-05-31 11:26:23', '2019-05-31 11:26:23');
INSERT INTO `oauth2_refresh_token` VALUES ('68a38083dd5340d390550cbd2d3ced6e', 27, 2, 1, '2019-07-11 05:58:51', '2019-07-10 17:58:51', '2019-07-10 17:58:51');
INSERT INTO `oauth2_refresh_token` VALUES ('68a79459c9a34614974148d4acf138fc', 27, 2, 1, '2019-06-02 21:43:41', '2019-06-02 09:43:41', '2019-06-02 09:43:41');
INSERT INTO `oauth2_refresh_token` VALUES ('68ab92e6a2af44d1a568718b22faebc0', 27, 2, 1, '2019-09-04 23:14:48', '2019-09-04 11:14:47', '2019-09-04 11:14:47');
INSERT INTO `oauth2_refresh_token` VALUES ('68b0eb57b889488893954b1aefbcc53d', 27, 2, 1, '2019-07-01 07:49:56', '2019-06-30 19:49:56', '2019-06-30 19:49:56');
INSERT INTO `oauth2_refresh_token` VALUES ('68b4757be7ff42139b55c2529240d3ce', 27, 2, 1, '2019-06-22 02:41:39', '2019-06-21 14:41:39', '2019-06-21 14:41:39');
INSERT INTO `oauth2_refresh_token` VALUES ('68d3c68b33bb4ac5836148da76cffaaf', 27, 2, 1, '2019-07-18 02:25:01', '2019-07-17 14:25:00', '2019-07-17 14:25:00');
INSERT INTO `oauth2_refresh_token` VALUES ('68f68165f4114dd88eb60cfcb16bc8e3', 27, 2, 1, '2019-06-03 03:57:20', '2019-06-02 15:57:20', '2019-06-02 15:57:20');
INSERT INTO `oauth2_refresh_token` VALUES ('69013f9cf4c745e6a1253db89497171a', NULL, NULL, 1, '2019-05-14 05:43:03', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('690485b9393347e1ae299fededc3a2eb', NULL, NULL, 1, '2019-05-04 07:50:57', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('691df86e19404bc0a039c2eded031c91', 27, 2, 1, '2019-06-20 20:33:52', '2019-06-20 08:33:51', '2019-06-20 08:33:51');
INSERT INTO `oauth2_refresh_token` VALUES ('6933ac1a84b140708e58c9d1e34bd06d', 27, 2, 1, '2019-06-03 01:25:31', '2019-06-02 13:25:31', '2019-06-02 13:25:31');
INSERT INTO `oauth2_refresh_token` VALUES ('69535c7df8fb4a29bf19a3de668a067e', 27, 2, 1, '2019-05-21 06:00:55', '2019-05-20 18:00:55', '2019-05-20 18:00:55');
INSERT INTO `oauth2_refresh_token` VALUES ('697a72ad67fb4064857339fe2eb5ee6d', 1, 2, 0, '2019-09-04 09:53:25', '2019-09-03 21:53:25', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('699b3ca9110541dfab4b55c163136dec', 27, 2, 1, '2019-06-03 22:58:34', '2019-06-03 10:58:33', '2019-06-03 10:58:33');
INSERT INTO `oauth2_refresh_token` VALUES ('69a43bef0cfa4b33a0d014f681ea1aba', 27, 2, 1, '2019-06-12 22:19:02', '2019-06-12 10:19:01', '2019-06-12 10:19:01');
INSERT INTO `oauth2_refresh_token` VALUES ('69a8f1a988da4a2484a92f4ad67f767e', 27, 2, 1, '2019-08-19 22:30:18', '2019-08-19 10:30:17', '2019-08-19 10:30:17');
INSERT INTO `oauth2_refresh_token` VALUES ('69b493f3721944128aa92c35647829a0', 80, 1, 1, '2019-05-24 05:55:58', '2019-05-23 17:55:57', '2019-05-23 17:55:57');
INSERT INTO `oauth2_refresh_token` VALUES ('69c7d940c6834a479e837d42e9932049', 27, 2, 1, '2019-06-03 22:49:34', '2019-06-03 10:49:34', '2019-06-03 10:49:34');
INSERT INTO `oauth2_refresh_token` VALUES ('69cf20779aa94296980d47b520d25e32', 27, 2, 1, '2019-06-04 21:12:35', '2019-06-04 09:12:35', '2019-06-04 09:12:35');
INSERT INTO `oauth2_refresh_token` VALUES ('69f1c83f87134633995fd7082143d174', 1, 2, 0, '2019-06-01 06:18:53', '2019-05-31 18:17:34', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('6a21a52ada5640c8a359c5694f837646', 1, 2, 0, '2019-08-26 08:27:26', '2019-08-25 20:27:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('6a3c4a8fe8a64f9992da053ef4d5da93', NULL, NULL, 1, '2019-05-04 01:02:26', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6a5faba45d1f4133b209020db3a03de2', 27, 2, 1, '2019-06-02 04:59:59', '2019-06-01 16:59:59', '2019-06-01 16:59:59');
INSERT INTO `oauth2_refresh_token` VALUES ('6a634d9842d24d768e0a50b2e16d416b', 27, 2, 1, '2019-06-03 21:54:46', '2019-06-03 09:54:46', '2019-06-03 09:54:46');
INSERT INTO `oauth2_refresh_token` VALUES ('6a646205951340ac86fc77c93d42d325', 27, 2, 1, '2019-06-04 21:16:14', '2019-06-04 09:16:14', '2019-06-04 09:16:14');
INSERT INTO `oauth2_refresh_token` VALUES ('6a80094850124a568aefefa231edd940', NULL, NULL, 1, '2019-05-14 01:47:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6a83abdd0a0947739a3256859575beed', NULL, NULL, 1, '2019-05-11 10:10:10', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6a89e70f339248199af7c5db931af1dd', 27, 2, 1, '2019-06-14 02:27:31', '2019-06-13 14:27:30', '2019-06-13 14:27:30');
INSERT INTO `oauth2_refresh_token` VALUES ('6a92d32ca02c410690327dc60337b46a', 27, 2, 1, '2019-06-11 02:54:55', '2019-06-10 14:54:54', '2019-06-10 14:54:54');
INSERT INTO `oauth2_refresh_token` VALUES ('6aaa52b83bc5423f92c3cbc9a39675b9', 27, 2, 1, '2019-06-05 03:43:40', '2019-06-04 15:43:40', '2019-06-04 15:43:40');
INSERT INTO `oauth2_refresh_token` VALUES ('6ab9192896754829b820271158700b1a', 27, 2, 1, '2019-06-03 12:15:08', '2019-06-03 00:15:07', '2019-06-03 00:15:07');
INSERT INTO `oauth2_refresh_token` VALUES ('6abbb331a65544889750c0ebeb42725c', 27, 2, 1, '2019-07-05 04:36:54', '2019-07-04 16:36:53', '2019-07-04 16:36:53');
INSERT INTO `oauth2_refresh_token` VALUES ('6acd2a37f4804a84bc58fc493e1c7b87', 27, 2, 1, '2019-08-09 21:41:58', '2019-08-09 09:41:58', '2019-08-09 09:41:58');
INSERT INTO `oauth2_refresh_token` VALUES ('6ad5b476a2af4a52a4142b97a3589a5a', 1, 2, 0, '2019-08-15 10:24:46', '2019-08-14 22:24:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('6ad90c36508a425597ddc32a360beb78', 27, 2, 1, '2019-08-31 06:05:00', '2019-08-30 18:04:59', '2019-08-30 18:04:59');
INSERT INTO `oauth2_refresh_token` VALUES ('6af810aa5b6c488583404837128ff1b0', 27, 2, 1, '2019-06-05 21:57:39', '2019-06-05 09:57:39', '2019-06-05 09:57:39');
INSERT INTO `oauth2_refresh_token` VALUES ('6afdcadcaf6d4b758cdf43c968efdb1f', 27, 2, 1, '2019-06-04 09:53:30', '2019-06-03 21:53:29', '2019-06-03 21:53:29');
INSERT INTO `oauth2_refresh_token` VALUES ('6b25c62a047b4a989e07fb167f2460c7', 27, 2, 1, '2019-07-25 01:15:54', '2019-07-24 13:15:54', '2019-07-24 13:15:54');
INSERT INTO `oauth2_refresh_token` VALUES ('6b45e1bff9194ddb8b0694bf8ef0e490', 1, 2, 0, '2019-07-08 03:57:37', '2019-07-07 15:57:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('6c57a92a49704385855302f1a75e6433', 27, 2, 1, '2019-06-06 23:55:45', '2019-06-06 11:55:45', '2019-06-06 11:55:45');
INSERT INTO `oauth2_refresh_token` VALUES ('6c72de4e54f749b69f9907a89748b6a3', NULL, NULL, 1, '2019-05-09 11:06:58', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6c76d712f5e34f578befb6cc5e4d05d0', 27, 2, 1, '2019-07-11 21:54:03', '2019-07-11 09:54:02', '2019-07-11 09:54:02');
INSERT INTO `oauth2_refresh_token` VALUES ('6ca788bf44d644b4b9d27f753d9e8274', NULL, NULL, 1, '2019-04-13 07:23:29', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6cc591ff350049c7a2cefea7c160eec9', 27, 2, 1, '2019-06-04 22:11:16', '2019-06-04 10:11:15', '2019-06-04 10:11:15');
INSERT INTO `oauth2_refresh_token` VALUES ('6cd1cc21f20e4f6393e19ae67b29c16d', 27, 2, 1, '2019-06-06 04:42:24', '2019-06-05 16:42:23', '2019-06-05 16:42:23');
INSERT INTO `oauth2_refresh_token` VALUES ('6cd4e23ff42548729643169341b0e3a9', 27, 2, 1, '2019-06-04 02:25:04', '2019-06-03 14:25:03', '2019-06-03 14:25:03');
INSERT INTO `oauth2_refresh_token` VALUES ('6cec9d45381b453484dbb6cb7b70b43c', 27, 2, 1, '2019-07-25 07:23:24', '2019-07-24 19:23:24', '2019-07-24 19:23:24');
INSERT INTO `oauth2_refresh_token` VALUES ('6cf72c531e9146dbb3cf2ef1ae764259', 27, 2, 1, '2019-07-09 03:16:57', '2019-07-08 15:16:56', '2019-07-08 15:16:56');
INSERT INTO `oauth2_refresh_token` VALUES ('6cf79d0118024c70a2dde69e0a1c9e60', 27, 2, 1, '2019-06-13 03:42:12', '2019-06-12 15:42:11', '2019-06-12 15:42:11');
INSERT INTO `oauth2_refresh_token` VALUES ('6cf95a7dec4146fba30b2bd1438a3c25', 27, 2, 1, '2019-05-30 13:32:46', '2019-05-30 01:32:46', '2019-05-30 01:32:46');
INSERT INTO `oauth2_refresh_token` VALUES ('6d0ac1b29553412bbe6f53f938366225', NULL, NULL, 0, '2019-03-05 16:45:21', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6d163d6083c14f52b7f410c10b7312d3', 1, 2, 0, '2019-06-03 10:30:12', '2019-06-02 22:30:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('6d2e085b84714941ac43124d5eaf33bf', 27, 2, 1, '2019-05-24 01:25:17', '2019-05-23 13:25:17', '2019-05-23 13:25:17');
INSERT INTO `oauth2_refresh_token` VALUES ('6d70ae273b894e409a5e29a80bdaa55d', 27, 2, 1, '2019-07-24 21:33:30', '2019-07-24 09:33:30', '2019-07-24 09:33:30');
INSERT INTO `oauth2_refresh_token` VALUES ('6d7a6ddd44a84dd886cf7df92c94e95c', 27, 2, 1, '2019-06-20 09:18:57', '2019-06-19 21:18:56', '2019-06-19 21:18:56');
INSERT INTO `oauth2_refresh_token` VALUES ('6d8cc199018b4db1932b38e57aa258e6', 27, 2, 1, '2019-07-11 11:04:56', '2019-07-10 23:04:56', '2019-07-10 23:04:56');
INSERT INTO `oauth2_refresh_token` VALUES ('6d8f01ec8dbf4115a9669dc56093bdbe', 27, 2, 1, '2019-08-29 08:48:44', '2019-08-28 20:48:44', '2019-08-28 20:48:44');
INSERT INTO `oauth2_refresh_token` VALUES ('6d94d96897db4fa98fa67395382d1086', 139, 1, 1, '2019-06-25 21:54:06', '2019-06-25 09:54:06', '2019-06-25 09:54:06');
INSERT INTO `oauth2_refresh_token` VALUES ('6ddfd83b5219489d915a9661a27e5a90', 27, 2, 1, '2019-06-15 02:15:06', '2019-06-14 14:15:05', '2019-06-14 14:15:05');
INSERT INTO `oauth2_refresh_token` VALUES ('6de21eb16bb64e97b0326eac9d156d21', 1, 2, 0, '2019-07-22 01:40:10', '2019-07-21 13:40:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('6dfbd628b9ed4246a5c12ea077073a26', 27, 2, 1, '2019-06-06 23:37:51', '2019-06-06 11:37:50', '2019-06-06 11:37:50');
INSERT INTO `oauth2_refresh_token` VALUES ('6e28c3a4e61749008fb982fc854c4cd1', 198, 1, 1, '2019-08-14 03:38:55', '2019-08-13 15:38:55', '2019-08-13 15:38:55');
INSERT INTO `oauth2_refresh_token` VALUES ('6e2ed49b235d4678b868103420284807', 27, 2, 1, '2019-08-23 21:53:33', '2019-08-23 09:53:33', '2019-08-23 09:53:33');
INSERT INTO `oauth2_refresh_token` VALUES ('6e4090386e0444079de6a9d61fa4acd7', 1, 2, 0, '2019-06-20 22:47:07', '2019-06-20 10:47:07', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('6e57ec4d2c1a4b33b374c07f4dbca006', 27, 2, 1, '2019-06-14 06:00:22', '2019-06-13 18:00:21', '2019-06-13 18:00:21');
INSERT INTO `oauth2_refresh_token` VALUES ('6e58fc0d17c44725822c4fff619bd1ee', 27, 2, 1, '2019-08-02 21:19:10', '2019-08-02 09:19:10', '2019-08-02 09:19:10');
INSERT INTO `oauth2_refresh_token` VALUES ('6e5dd25a9644438493140d2929467229', 27, 2, 1, '2019-09-06 03:56:03', '2019-09-05 15:56:03', '2019-09-05 15:56:03');
INSERT INTO `oauth2_refresh_token` VALUES ('6e68d801817a40b4a6afa8026f5cdff3', 27, 2, 1, '2019-07-16 08:51:43', '2019-07-15 20:51:42', '2019-07-15 20:51:42');
INSERT INTO `oauth2_refresh_token` VALUES ('6e8b0f82b7fe4e3aa438328c4607b9bf', NULL, NULL, 1, '2019-04-02 10:37:52', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6e8ba855392542578484b9b0ca3de239', 27, 2, 1, '2019-08-15 20:50:34', '2019-08-15 08:50:34', '2019-08-15 08:50:34');
INSERT INTO `oauth2_refresh_token` VALUES ('6e95fbdd3fc6448eba1848a674890cb9', NULL, NULL, 1, '2019-05-11 10:17:00', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6eb4d220ae024f1cbaed6e175b5e58a4', NULL, NULL, 1, '2019-05-06 04:57:36', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6eb6c02bfb464190aaf4edb45933b63d', 27, 2, 1, '2019-06-05 04:38:12', '2019-06-04 16:38:12', '2019-06-04 16:38:12');
INSERT INTO `oauth2_refresh_token` VALUES ('6eba71b5600e425796445a2b4c74cbdd', 27, 2, 1, '2019-09-07 04:02:30', '2019-09-06 16:02:30', '2019-09-06 16:02:30');
INSERT INTO `oauth2_refresh_token` VALUES ('6ecbcc4f987044fa858ab49278ebdaf1', 27, 2, 1, '2019-07-05 21:55:25', '2019-07-05 09:55:24', '2019-07-05 09:55:24');
INSERT INTO `oauth2_refresh_token` VALUES ('6ecde9cb148e4def8428360b60ff37d6', 27, 2, 1, '2019-06-13 07:25:46', '2019-06-12 19:25:46', '2019-06-12 19:25:46');
INSERT INTO `oauth2_refresh_token` VALUES ('6f08d53d78b24f5b92a586803ba7a1e6', NULL, NULL, 1, '2019-03-10 18:37:43', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6f3d1c0b44554d7cba7f63115f6264db', NULL, NULL, 1, '2019-05-08 02:38:29', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6f6b29e4b1be4f76bc4481c613e8bea0', 27, 2, 1, '2019-07-09 04:27:23', '2019-07-08 16:27:22', '2019-07-08 16:27:22');
INSERT INTO `oauth2_refresh_token` VALUES ('6f8526d455414b589a9ce0ae22ce37c8', 27, 2, 1, '2019-07-12 21:50:51', '2019-07-12 09:50:50', '2019-07-12 09:50:50');
INSERT INTO `oauth2_refresh_token` VALUES ('6f969a60e9b54e89a517f343f7e5ece8', 27, 2, 1, '2019-08-13 02:17:42', '2019-08-12 14:17:42', '2019-08-12 14:17:42');
INSERT INTO `oauth2_refresh_token` VALUES ('6fc965dcfb8346cbbfa14a4fa4707756', 27, 2, 1, '2019-06-22 03:16:59', '2019-06-21 15:16:59', '2019-06-21 15:16:59');
INSERT INTO `oauth2_refresh_token` VALUES ('6fe0e28dc9e944be9c736f492257e286', 27, 2, 1, '2019-06-03 05:45:41', '2019-06-02 17:45:40', '2019-06-02 17:45:40');
INSERT INTO `oauth2_refresh_token` VALUES ('6febea3507bf450ba265fc298a48d8d4', 27, 2, 1, '2019-08-21 21:06:59', '2019-08-21 09:06:58', '2019-08-21 09:06:58');
INSERT INTO `oauth2_refresh_token` VALUES ('6ff0e07004f842359cb2bedfc423b270', 27, 2, 1, '2019-08-01 09:09:21', '2019-07-31 21:09:20', '2019-07-31 21:09:20');
INSERT INTO `oauth2_refresh_token` VALUES ('6ffa6233efd842d5aed0fdcbe20c64b5', 27, 2, 1, '2019-06-21 22:12:03', '2019-06-21 10:12:03', '2019-06-21 10:12:03');
INSERT INTO `oauth2_refresh_token` VALUES ('7009cff2c6a54cfc93bd9be74715f1ff', 27, 2, 1, '2019-06-17 05:50:24', '2019-06-16 17:50:24', '2019-06-16 17:50:24');
INSERT INTO `oauth2_refresh_token` VALUES ('703c53b8f25b4da28d0e135eb0cd41dc', 27, 2, 1, '2019-07-14 08:16:40', '2019-07-13 20:16:39', '2019-07-13 20:16:39');
INSERT INTO `oauth2_refresh_token` VALUES ('70408c0aa9de4fc3be0c8ce00fb8a638', 27, 2, 1, '2019-06-02 02:40:21', '2019-06-01 14:40:21', '2019-06-01 14:40:21');
INSERT INTO `oauth2_refresh_token` VALUES ('7048851da857405b9ef4f79f9cf7f4d7', 27, 2, 1, '2019-06-03 12:37:21', '2019-06-03 00:37:20', '2019-06-03 00:37:20');
INSERT INTO `oauth2_refresh_token` VALUES ('705ce571fc6545c7aa51d488a3a895d6', NULL, NULL, 1, '2019-04-02 06:24:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('70825cead30241c5aedc5524326632de', 27, 2, 1, '2019-05-25 10:01:33', '2019-05-24 22:01:33', '2019-05-24 22:01:33');
INSERT INTO `oauth2_refresh_token` VALUES ('708f898746d849ccb60ac1aadedc36e3', 94, 1, 1, '2019-06-01 20:04:59', '2019-06-01 08:04:58', '2019-06-01 08:04:58');
INSERT INTO `oauth2_refresh_token` VALUES ('709dff5b61fa4af2a9a83c342cd6341e', 1, 2, 0, '2019-05-22 09:01:59', '2019-05-21 21:01:58', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('70a7787a7ad444728954d6fedb7e29ac', 27, 2, 1, '2019-06-27 23:25:21', '2019-06-27 11:25:20', '2019-06-27 11:25:20');
INSERT INTO `oauth2_refresh_token` VALUES ('70bbdde547ac4b75b1a3a93b3754ab2e', NULL, NULL, 1, '2019-04-23 07:42:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('70d2686739cf4f12a7ab797d2484bc27', 27, 2, 1, '2019-08-30 02:05:10', '2019-08-29 14:05:10', '2019-08-29 14:05:10');
INSERT INTO `oauth2_refresh_token` VALUES ('70ebc06cbad94c54b360042b5b4bfd4f', 27, 2, 1, '2019-08-16 07:39:06', '2019-08-15 19:39:05', '2019-08-15 19:39:05');
INSERT INTO `oauth2_refresh_token` VALUES ('7121a49146224b02a8314ff4208663ed', NULL, NULL, 1, '2019-04-29 05:14:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('71223b9f4d2c42ca9944f93d44f5a5f5', 27, 2, 1, '2019-06-02 22:58:33', '2019-06-02 10:58:32', '2019-06-02 10:58:32');
INSERT INTO `oauth2_refresh_token` VALUES ('71341e1aa21546ee84f0305e95dcc993', 27, 2, 1, '2019-07-11 23:02:55', '2019-07-11 11:02:54', '2019-07-11 11:02:54');
INSERT INTO `oauth2_refresh_token` VALUES ('7163f5aee22c4ed3a90c6325f09c0367', 27, 2, 1, '2019-06-10 22:44:37', '2019-06-10 10:44:37', '2019-06-10 10:44:37');
INSERT INTO `oauth2_refresh_token` VALUES ('7165d09fd77645cfa6bbe2c81fff70ca', 1, 2, 1, '2019-09-09 07:42:50', '2019-09-08 19:42:49', '2019-09-08 19:42:49');
INSERT INTO `oauth2_refresh_token` VALUES ('7166ff6838ea4efa9d33fe9e9ffe5b16', 27, 2, 1, '2019-06-01 19:31:46', '2019-06-01 07:31:45', '2019-06-01 07:31:45');
INSERT INTO `oauth2_refresh_token` VALUES ('71802b920b6f45ecae659a93111cb3d3', 150, 1, 1, '2019-07-02 23:14:08', '2019-07-02 11:14:08', '2019-07-02 11:14:08');
INSERT INTO `oauth2_refresh_token` VALUES ('7181a21dd2fb446f8731fab33b0a361b', 27, 2, 1, '2019-08-06 22:08:11', '2019-08-06 10:08:11', '2019-08-06 10:08:11');
INSERT INTO `oauth2_refresh_token` VALUES ('718610b3af2f41988557e284ee1888b4', 27, 2, 1, '2019-06-14 10:29:03', '2019-06-13 22:29:02', '2019-06-13 22:29:02');
INSERT INTO `oauth2_refresh_token` VALUES ('718b5c9f81c64209b0845910ddb5724c', 27, 2, 1, '2019-05-31 05:23:29', '2019-05-30 17:23:29', '2019-05-30 17:23:29');
INSERT INTO `oauth2_refresh_token` VALUES ('718ef5aa9dc343bb942f4fa1a6108952', 27, 2, 1, '2019-08-01 04:19:24', '2019-07-31 16:19:23', '2019-07-31 16:19:23');
INSERT INTO `oauth2_refresh_token` VALUES ('71aae81465b0442aad484f90abb6e40d', 27, 2, 1, '2019-08-03 05:49:34', '2019-08-02 17:49:33', '2019-08-02 17:49:33');
INSERT INTO `oauth2_refresh_token` VALUES ('71b7c0f660d6465aae359663934ef2c7', 27, 2, 1, '2019-06-02 01:49:56', '2019-06-01 13:49:56', '2019-06-01 13:49:56');
INSERT INTO `oauth2_refresh_token` VALUES ('71df3d680ff149b69fd218f9b31bd1db', 27, 2, 1, '2019-09-09 20:43:30', '2019-09-09 08:43:29', '2019-09-09 08:43:29');
INSERT INTO `oauth2_refresh_token` VALUES ('71f463e5ed244445a96d5349c63600a5', 27, 2, 1, '2019-06-04 22:44:14', '2019-06-04 10:44:14', '2019-06-04 10:44:14');
INSERT INTO `oauth2_refresh_token` VALUES ('720825a399be46bca98871ad4e9dffe8', 27, 2, 1, '2019-07-24 21:53:23', '2019-07-24 09:53:22', '2019-07-24 09:53:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7237af877f344b90895fdb3b74988e87', NULL, NULL, 1, '2019-05-11 12:24:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('724171a9f25340afa11dbe53624dba18', 27, 2, 1, '2019-06-14 23:18:38', '2019-06-14 11:18:38', '2019-06-14 11:18:38');
INSERT INTO `oauth2_refresh_token` VALUES ('725ae73d5b2648a6a36e3fd32619ed29', NULL, NULL, 1, '2019-05-10 06:05:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('727a3a6a95a94457a618ea92e665fbf4', 27, 2, 1, '2019-08-01 04:42:33', '2019-07-31 16:42:32', '2019-07-31 16:42:32');
INSERT INTO `oauth2_refresh_token` VALUES ('727f39dc8ca54068906be6be2c9131e4', 27, 2, 1, '2019-05-28 23:07:44', '2019-05-28 11:07:43', '2019-05-28 11:07:43');
INSERT INTO `oauth2_refresh_token` VALUES ('72b009a3c749433e9ae8fefa169c420f', 27, 2, 1, '2019-06-06 07:56:38', '2019-06-05 19:56:38', '2019-06-05 19:56:38');
INSERT INTO `oauth2_refresh_token` VALUES ('72c0173c17da430b9c5692f6bf651519', 27, 2, 1, '2019-07-19 00:17:45', '2019-07-18 12:17:44', '2019-07-18 12:17:44');
INSERT INTO `oauth2_refresh_token` VALUES ('72d33465ea8348439d6c9318c4bbde9f', 27, 2, 1, '2019-07-20 21:34:51', '2019-07-20 09:34:50', '2019-07-20 09:34:50');
INSERT INTO `oauth2_refresh_token` VALUES ('72db397ba90f4abfb554ca2088863da4', 1, 2, 0, '2019-06-04 00:29:04', '2019-06-03 12:29:03', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('72df8d81291e4526a154ec359c835e85', 27, 2, 1, '2019-07-22 23:25:48', '2019-07-22 11:25:48', '2019-07-22 11:25:48');
INSERT INTO `oauth2_refresh_token` VALUES ('72e19c58629744fea2d0b624a33d3bfe', 27, 2, 1, '2019-06-03 22:42:29', '2019-06-03 10:42:29', '2019-06-03 10:42:29');
INSERT INTO `oauth2_refresh_token` VALUES ('72fab45466f049aeb0176757850ec9f9', 27, 2, 1, '2019-07-03 06:01:58', '2019-07-02 18:01:57', '2019-07-02 18:01:57');
INSERT INTO `oauth2_refresh_token` VALUES ('7305d1fc1fe248758a513a5834e13957', NULL, NULL, 1, '2019-03-16 07:56:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('730a6d152790423eb7ec9973e663d793', 27, 2, 1, '2019-06-04 09:38:37', '2019-06-03 21:38:37', '2019-06-03 21:38:37');
INSERT INTO `oauth2_refresh_token` VALUES ('7318c0cc876348278d4311463e01ad6b', 27, 2, 1, '2019-06-06 23:38:01', '2019-06-06 11:38:00', '2019-06-06 11:38:00');
INSERT INTO `oauth2_refresh_token` VALUES ('7320e6b989ba414ebd8d508b339ab411', 27, 2, 1, '2019-06-03 06:29:10', '2019-06-02 18:29:10', '2019-06-02 18:29:10');
INSERT INTO `oauth2_refresh_token` VALUES ('7323f5f609c24e1bb933c4dd31cb7c17', 129, 1, 1, '2019-07-01 21:51:24', '2019-07-01 09:51:24', '2019-07-01 09:51:24');
INSERT INTO `oauth2_refresh_token` VALUES ('7328f291bbae48a4adba2d8253e55220', 1, 2, 0, '2019-06-10 23:13:22', '2019-06-10 11:13:22', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('732b16b3e54f446a85791a2fcb4313ff', NULL, NULL, 1, '2019-03-22 03:39:39', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('732b9ddf6a614254b10baf97ef9cb6b3', 27, 2, 1, '2019-08-11 02:31:29', '2019-08-10 14:31:28', '2019-08-10 14:31:28');
INSERT INTO `oauth2_refresh_token` VALUES ('733366e02ba34c019e565c4cd22bf43e', 27, 2, 1, '2019-06-04 03:42:01', '2019-06-03 15:42:00', '2019-06-03 15:42:00');
INSERT INTO `oauth2_refresh_token` VALUES ('734a23f3632d43499a69e5ad7545fc27', 27, 2, 1, '2019-07-31 23:16:20', '2019-07-31 11:16:19', '2019-07-31 11:16:19');
INSERT INTO `oauth2_refresh_token` VALUES ('734ca690d3b343a29c94e52f3e5cc685', NULL, NULL, 1, '2019-03-22 08:55:28', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('73688418048c4172bc44d4e2faea2497', NULL, NULL, 1, '2019-05-02 11:59:16', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('73691c7430dc45acb42560f39b8c4279', NULL, NULL, 1, '2019-04-23 01:05:36', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('738f3a28d511448fb93646d0c49acaaf', 27, 2, 1, '2019-07-07 22:01:12', '2019-07-07 10:01:12', '2019-07-07 10:01:12');
INSERT INTO `oauth2_refresh_token` VALUES ('7391577ceecb4a62bba477f2ad12b432', 27, 2, 1, '2019-09-03 21:41:15', '2019-09-03 09:41:14', '2019-09-03 09:41:14');
INSERT INTO `oauth2_refresh_token` VALUES ('73975d4062f643e290cb9251741f372f', 27, 2, 1, '2019-07-12 02:11:10', '2019-07-11 14:11:10', '2019-07-11 14:11:10');
INSERT INTO `oauth2_refresh_token` VALUES ('73a90e8ee4d94145a7a2f01b27ade2c5', 27, 2, 1, '2019-05-30 04:27:08', '2019-05-29 16:27:08', '2019-05-29 16:27:08');
INSERT INTO `oauth2_refresh_token` VALUES ('73aa8888524f4e049a28b08372d1fe14', NULL, NULL, 1, '2019-04-23 06:20:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('73afa3f8b51f4a55a5760edfe8b56a22', 27, 2, 1, '2019-06-28 21:53:24', '2019-06-28 09:53:23', '2019-06-28 09:53:23');
INSERT INTO `oauth2_refresh_token` VALUES ('73c06927f18645ddb9c028851bd4feac', 27, 2, 1, '2019-06-10 21:45:18', '2019-06-10 09:45:17', '2019-06-10 09:45:17');
INSERT INTO `oauth2_refresh_token` VALUES ('73da90a72cf14bd0bd0161c74ac6924a', 27, 2, 1, '2019-06-06 02:46:15', '2019-06-05 14:46:14', '2019-06-05 14:46:14');
INSERT INTO `oauth2_refresh_token` VALUES ('73dfdb7e5e1c42a899d0db881b08c2df', 27, 2, 1, '2019-06-03 02:38:02', '2019-06-02 14:38:02', '2019-06-02 14:38:02');
INSERT INTO `oauth2_refresh_token` VALUES ('73ec7515046843b185e7a39cc197b7bd', 27, 2, 1, '2019-06-01 11:31:33', '2019-05-31 23:31:32', '2019-05-31 23:31:32');
INSERT INTO `oauth2_refresh_token` VALUES ('73fbe6b520ef4be8ac29ed056c44f995', 27, 2, 1, '2019-05-29 10:24:14', '2019-05-28 22:24:13', '2019-05-28 22:24:13');
INSERT INTO `oauth2_refresh_token` VALUES ('740e7ab4c56e4e8c9a08cd1d91bf9ee8', 1, 1, 1, '2019-05-17 12:23:14', '2019-05-17 00:23:14', '2019-05-17 00:23:14');
INSERT INTO `oauth2_refresh_token` VALUES ('741e1af77ec944219adf4120e1bc7af4', 27, 2, 1, '2019-07-12 02:32:59', '2019-07-11 14:32:58', '2019-07-11 14:32:58');
INSERT INTO `oauth2_refresh_token` VALUES ('742313d700e64ce9b5c3eb6b87cb710b', 27, 2, 1, '2019-06-09 04:21:53', '2019-06-08 16:21:52', '2019-06-08 16:21:52');
INSERT INTO `oauth2_refresh_token` VALUES ('742f158e423b46cb863b9c420c2816ed', 27, 2, 1, '2019-08-23 02:49:55', '2019-08-22 14:49:54', '2019-08-22 14:49:54');
INSERT INTO `oauth2_refresh_token` VALUES ('7435d30601fb41349ad0a9dc4b2a3da4', 27, 2, 1, '2019-06-02 01:12:15', '2019-06-01 13:12:15', '2019-06-01 13:12:15');
INSERT INTO `oauth2_refresh_token` VALUES ('74397fd2a1c249379b6abf93f17e1963', 27, 2, 1, '2019-07-14 08:16:56', '2019-07-13 20:16:56', '2019-07-13 20:16:56');
INSERT INTO `oauth2_refresh_token` VALUES ('743c172e22fd4dee80bb2492a4f02a29', 27, 2, 1, '2019-06-20 21:47:42', '2019-06-20 09:47:41', '2019-06-20 09:47:41');
INSERT INTO `oauth2_refresh_token` VALUES ('74796babd7a74a42afa946bbbd6225cd', 27, 2, 1, '2019-07-08 10:33:21', '2019-07-07 22:33:20', '2019-07-07 22:33:20');
INSERT INTO `oauth2_refresh_token` VALUES ('748e4e41dd3147efb407f4946ec82e93', 27, 2, 1, '2019-07-06 03:02:50', '2019-07-05 15:02:49', '2019-07-05 15:02:49');
INSERT INTO `oauth2_refresh_token` VALUES ('7492b1d113c34003bb75a65ccd1058b5', 27, 2, 1, '2019-06-26 06:19:59', '2019-06-25 18:19:59', '2019-06-25 18:19:59');
INSERT INTO `oauth2_refresh_token` VALUES ('74991db6fc80436f8dcfdc4687d8ec2d', 27, 2, 1, '2019-06-18 05:47:57', '2019-06-17 17:47:56', '2019-06-17 17:47:56');
INSERT INTO `oauth2_refresh_token` VALUES ('749e66bc32dc4afb95931a32855c9ed6', 27, 2, 1, '2019-06-09 22:47:08', '2019-06-09 10:47:08', '2019-06-09 10:47:08');
INSERT INTO `oauth2_refresh_token` VALUES ('74a2a94e3e074650abee1d6c53a824f9', NULL, NULL, 1, '2019-04-23 06:34:28', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('74a98b40d8b74c318246502994a3c8f5', 1, 2, 0, '2019-08-28 12:31:26', '2019-08-28 00:31:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('74bfbf7ab23940158176b1dc5cef6f3b', 114, 1, 1, '2019-06-09 10:25:01', '2019-06-08 22:25:01', '2019-06-08 22:25:01');
INSERT INTO `oauth2_refresh_token` VALUES ('74c0f3822492438e862b48c03a159cc7', 1, 2, 0, '2019-06-01 06:05:12', '2019-05-31 18:05:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('74cb5404428d4b3895c3d404be33e5ff', 27, 2, 1, '2019-08-09 23:25:39', '2019-08-09 11:25:38', '2019-08-09 11:25:38');
INSERT INTO `oauth2_refresh_token` VALUES ('74edc646bce94e3ea6a9faa7df40ce51', 27, 2, 1, '2019-06-06 13:07:32', '2019-06-06 01:07:32', '2019-06-06 01:07:32');
INSERT INTO `oauth2_refresh_token` VALUES ('7500246e499e4758a2856e70340f4280', 27, 2, 1, '2019-07-06 21:40:49', '2019-07-06 09:40:48', '2019-07-06 09:40:48');
INSERT INTO `oauth2_refresh_token` VALUES ('75013179c78b44c7a3c0d3cee9ec312d', 27, 2, 1, '2019-09-04 05:02:18', '2019-09-03 17:02:18', '2019-09-03 17:02:18');
INSERT INTO `oauth2_refresh_token` VALUES ('750ae20b9b094f3398cc1dc7b8639da1', 27, 2, 1, '2019-06-20 06:19:03', '2019-06-19 18:19:03', '2019-06-19 18:19:03');
INSERT INTO `oauth2_refresh_token` VALUES ('75176188dece437297a28fd7154904ba', 1, 2, 0, '2019-06-15 09:43:59', '2019-06-14 21:43:58', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('751f612d6cba44ee9cd0d1250b91ac86', 27, 2, 1, '2019-06-10 22:05:25', '2019-06-10 10:05:24', '2019-06-10 10:05:24');
INSERT INTO `oauth2_refresh_token` VALUES ('7527252856a14798a1db9e6b1da92a4b', 27, 2, 1, '2019-06-28 21:36:19', '2019-06-28 09:36:19', '2019-06-28 09:36:19');
INSERT INTO `oauth2_refresh_token` VALUES ('75339653855244f3b5c92dadae74a6f8', 27, 2, 1, '2019-08-22 04:54:55', '2019-08-21 16:54:55', '2019-08-21 16:54:55');
INSERT INTO `oauth2_refresh_token` VALUES ('753e2a8d10804a7985b1a5927ec61381', NULL, NULL, 1, '2019-04-25 19:58:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7540fc46648d4414846f80acd430ae17', NULL, NULL, 1, '2019-03-10 15:34:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('75437aaefc424e048b9e4cca19931142', 27, 2, 1, '2019-09-04 21:52:33', '2019-09-04 09:52:33', '2019-09-04 09:52:33');
INSERT INTO `oauth2_refresh_token` VALUES ('754aa5d5c9cd4f7abe7e4fa37d4d6821', 27, 2, 1, '2019-06-26 06:06:24', '2019-06-25 18:06:23', '2019-06-25 18:06:23');
INSERT INTO `oauth2_refresh_token` VALUES ('756ea75bb301446fab72bc867c85f6a2', 27, 2, 1, '2019-06-29 03:22:32', '2019-06-28 15:22:32', '2019-06-28 15:22:32');
INSERT INTO `oauth2_refresh_token` VALUES ('7571fd59839f4a60abba14ba276c4ac0', 27, 2, 1, '2019-08-28 04:03:58', '2019-08-27 16:03:57', '2019-08-27 16:03:57');
INSERT INTO `oauth2_refresh_token` VALUES ('757c9a1996fe4abab73b600296e52ed2', 27, 2, 1, '2019-07-08 00:45:16', '2019-07-07 12:45:16', '2019-07-07 12:45:16');
INSERT INTO `oauth2_refresh_token` VALUES ('7582a93cbe824d8e9dc85245a52dc670', 27, 2, 1, '2019-06-02 01:15:05', '2019-06-01 13:15:04', '2019-06-01 13:15:04');
INSERT INTO `oauth2_refresh_token` VALUES ('75d192fcce16492aa7288164e02b89e6', 27, 2, 1, '2019-07-12 11:42:45', '2019-07-11 23:42:45', '2019-07-11 23:42:45');
INSERT INTO `oauth2_refresh_token` VALUES ('75e439a4280b4cc89aaf3773ac0a1b13', 27, 2, 1, '2019-08-16 05:21:54', '2019-08-15 17:21:53', '2019-08-15 17:21:53');
INSERT INTO `oauth2_refresh_token` VALUES ('7613fd139e1f4a7cbf0d608a5ffb9a58', 27, 2, 1, '2019-05-31 08:20:21', '2019-05-30 20:20:20', '2019-05-30 20:20:20');
INSERT INTO `oauth2_refresh_token` VALUES ('76174fd46861415a8b22eaa3d581eb17', 27, 2, 1, '2019-05-20 22:52:37', '2019-05-20 10:52:36', '2019-05-20 10:52:36');
INSERT INTO `oauth2_refresh_token` VALUES ('763afeda3c00437e9cfb96ee87d68305', 27, 2, 1, '2019-07-01 01:33:11', '2019-06-30 13:33:10', '2019-06-30 13:33:10');
INSERT INTO `oauth2_refresh_token` VALUES ('764c02ad63644fa8a501e87b631118ff', 27, 2, 1, '2019-08-13 08:35:22', '2019-08-12 20:35:21', '2019-08-12 20:35:21');
INSERT INTO `oauth2_refresh_token` VALUES ('764ef8af5a5e47719af9d1e8a4260c20', NULL, NULL, 1, '2019-03-11 08:48:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('765e4cb7e7d44e359029e44acdf8aa6f', 1, 2, 0, '2019-06-06 00:07:36', '2019-06-05 12:07:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('767f1fa859c54e67be61a08c5db28914', NULL, NULL, 1, '2019-05-02 10:00:13', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('767fec08391943818a50d8deb2ad14e9', 27, 2, 1, '2019-06-26 21:36:47', '2019-06-26 09:36:46', '2019-06-26 09:36:46');
INSERT INTO `oauth2_refresh_token` VALUES ('76a1389046754fd89a56f1bc1ac10f68', 27, 2, 1, '2019-05-21 00:04:40', '2019-05-20 12:04:40', '2019-05-20 12:04:40');
INSERT INTO `oauth2_refresh_token` VALUES ('76ba1286cc924907b8a9eafecc6f4a0f', 27, 2, 1, '2019-08-10 05:15:54', '2019-08-09 17:15:54', '2019-08-09 17:15:54');
INSERT INTO `oauth2_refresh_token` VALUES ('76f6ba125e6a4cf281f9a3f3aa0c0f3d', 1, 2, 0, '2019-06-25 23:49:37', '2019-06-25 11:49:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('7705296dc18a41ec967623ac9843d8e4', 1, 2, 0, '2019-07-05 22:29:14', '2019-07-05 10:29:14', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('77058c5b16d3402dbc0ec2b7232ce704', 27, 2, 1, '2019-07-22 22:22:52', '2019-07-22 10:22:51', '2019-07-22 10:22:51');
INSERT INTO `oauth2_refresh_token` VALUES ('770bbc3b1f384deb80b68353f431b281', 27, 2, 1, '2019-07-05 03:16:23', '2019-07-04 15:16:23', '2019-07-04 15:16:23');
INSERT INTO `oauth2_refresh_token` VALUES ('770f169e42054846bcdd8ef3251c8943', 27, 2, 1, '2019-07-05 23:37:21', '2019-07-05 11:37:21', '2019-07-05 11:37:21');
INSERT INTO `oauth2_refresh_token` VALUES ('774d7043ad684baab87d3e4ee55ed58f', NULL, NULL, 1, '2019-04-07 10:01:16', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7750b9581e714aa791135e7ae8246700', 27, 2, 1, '2019-07-02 23:05:51', '2019-07-02 11:05:51', '2019-07-02 11:05:51');
INSERT INTO `oauth2_refresh_token` VALUES ('77728e711aa8445784224a175fe8487b', 27, 2, 1, '2019-07-22 22:01:39', '2019-07-22 10:01:38', '2019-07-22 10:01:38');
INSERT INTO `oauth2_refresh_token` VALUES ('777a860ffb0f47d6bd35877da7dea064', 27, 2, 1, '2019-07-13 05:39:58', '2019-07-12 17:39:58', '2019-07-12 17:39:58');
INSERT INTO `oauth2_refresh_token` VALUES ('777f14bf03424cb3972295fa0e65d314', 27, 2, 1, '2019-06-12 02:41:03', '2019-06-11 14:41:03', '2019-06-11 14:41:03');
INSERT INTO `oauth2_refresh_token` VALUES ('778475e8fe2b4896a06328da97351a3e', 27, 2, 1, '2019-08-21 21:01:00', '2019-08-21 09:01:00', '2019-08-21 09:01:00');
INSERT INTO `oauth2_refresh_token` VALUES ('7797e93c571d4fa79f544f35235dedad', NULL, NULL, 1, '2019-05-07 01:53:08', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('77b0a9f755be406281cca5824aaab0dd', 27, 2, 1, '2019-09-06 05:24:30', '2019-09-05 17:24:29', '2019-09-05 17:24:29');
INSERT INTO `oauth2_refresh_token` VALUES ('77baeef80c8e462d894fe45001e92824', 27, 2, 1, '2019-06-05 01:50:57', '2019-06-04 13:50:57', '2019-06-04 13:50:57');
INSERT INTO `oauth2_refresh_token` VALUES ('77e3684e23be451e9d5fd78144ee1764', 27, 2, 1, '2019-08-23 00:26:17', '2019-08-22 12:26:16', '2019-08-22 12:26:16');
INSERT INTO `oauth2_refresh_token` VALUES ('77edfc55ba2a4e8eae3e55ada3440ecf', NULL, NULL, 1, '2019-05-08 04:25:07', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('77ef3f8722114df0b578198ca7326f00', 27, 2, 1, '2019-09-04 05:36:39', '2019-09-03 17:36:39', '2019-09-03 17:36:39');
INSERT INTO `oauth2_refresh_token` VALUES ('7806e73123eb4beb9cd2db3f25d6c8f5', 27, 2, 1, '2019-08-01 04:42:02', '2019-07-31 16:42:01', '2019-07-31 16:42:01');
INSERT INTO `oauth2_refresh_token` VALUES ('780e60085b944a7893f67acd5cf5dd39', 27, 2, 1, '2019-07-18 00:11:47', '2019-07-17 12:11:47', '2019-07-17 12:11:47');
INSERT INTO `oauth2_refresh_token` VALUES ('7811849fbed54d7c84991d1202aa517e', 27, 2, 1, '2019-09-07 05:05:06', '2019-09-06 17:05:05', '2019-09-06 17:05:05');
INSERT INTO `oauth2_refresh_token` VALUES ('783c5ec23f8c466eb520767c14b18107', 27, 2, 1, '2019-06-20 22:48:02', '2019-06-20 10:48:01', '2019-06-20 10:48:01');
INSERT INTO `oauth2_refresh_token` VALUES ('7845053e2ff746b7b7d0288f36da589e', NULL, NULL, 1, '2019-04-28 00:06:00', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('785d40a8206843d39f4f1c0572201db4', NULL, NULL, 1, '2019-04-24 22:13:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('786eb338d2dd477bacdff72ba00016fe', 27, 2, 1, '2019-06-01 05:26:06', '2019-05-31 17:26:06', '2019-05-31 17:26:06');
INSERT INTO `oauth2_refresh_token` VALUES ('7870ae25a0d147e8899f0493feb1a2a4', 82, 1, 1, '2019-05-25 00:40:53', '2019-05-24 12:40:52', '2019-05-24 12:40:52');
INSERT INTO `oauth2_refresh_token` VALUES ('7886be49343941f49892824a69b63201', 27, 2, 1, '2019-08-18 10:29:01', '2019-08-17 22:29:00', '2019-08-17 22:29:00');
INSERT INTO `oauth2_refresh_token` VALUES ('78a64586c251480aaa8b365a67dd5655', 203, 1, 1, '2019-08-15 11:01:33', '2019-08-14 23:01:32', '2019-08-14 23:01:32');
INSERT INTO `oauth2_refresh_token` VALUES ('78ba78d4f7234263a7cd87b64b7fb1c2', NULL, NULL, 1, '2019-05-01 08:12:28', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('78c1298ff5784d0e87d3f17c3289fba2', 27, 2, 1, '2019-07-12 22:29:10', '2019-07-12 10:29:10', '2019-07-12 10:29:10');
INSERT INTO `oauth2_refresh_token` VALUES ('78c48b3baf30471880d281a21811b5cf', 27, 2, 1, '2019-05-18 06:25:38', '2019-05-17 18:25:37', '2019-05-17 18:25:37');
INSERT INTO `oauth2_refresh_token` VALUES ('78e321d3487543c19ed1fbc0a2ef9e04', 27, 2, 1, '2019-06-13 03:09:17', '2019-06-12 15:09:17', '2019-06-12 15:09:17');
INSERT INTO `oauth2_refresh_token` VALUES ('78f432ed52894e1381e75d5044d62405', 97, 1, 1, '2019-06-02 06:21:57', '2019-06-01 18:21:56', '2019-06-01 18:21:56');
INSERT INTO `oauth2_refresh_token` VALUES ('790e3b0ce85a4350ab49b86e0ba2832f', NULL, NULL, 1, '2019-04-05 06:21:33', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('79243fdb2d4045b39eb0200abb00adff', 1, 2, 1, '2019-09-08 10:47:22', '2019-09-07 22:47:22', '2019-09-07 22:47:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7929865acb9e47d98bb75736d788ed94', NULL, NULL, 1, '2019-05-06 04:07:04', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('793e15d4488b461caee851aeb0a7d987', 27, 2, 1, '2019-06-17 22:25:03', '2019-06-17 10:25:02', '2019-06-17 10:25:02');
INSERT INTO `oauth2_refresh_token` VALUES ('7949709e15464224a15f68f51ff6330d', NULL, NULL, 1, '2019-05-06 21:59:00', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7980f51c16894058b01c257e21f9c14b', 27, 2, 1, '2019-06-06 08:11:31', '2019-06-05 20:11:31', '2019-06-05 20:11:31');
INSERT INTO `oauth2_refresh_token` VALUES ('798189be090f431ab863a81999b5421b', 27, 2, 1, '2019-06-12 03:52:59', '2019-06-11 15:52:58', '2019-06-11 15:52:58');
INSERT INTO `oauth2_refresh_token` VALUES ('7983a9abe7794daab4e65373d2c67483', 1, 2, 0, '2019-07-12 22:17:27', '2019-07-12 10:17:27', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('79c5323d0b1d451987cc17652abddc27', 27, 2, 1, '2019-05-24 05:44:26', '2019-05-23 17:44:26', '2019-05-23 17:44:26');
INSERT INTO `oauth2_refresh_token` VALUES ('79d2f3d6510247b0b9f21d7b3404b842', 27, 2, 1, '2019-08-19 04:37:12', '2019-08-18 16:37:12', '2019-08-18 16:37:12');
INSERT INTO `oauth2_refresh_token` VALUES ('79f0fde5f04c4b678cdf3d7e49abd07a', 27, 2, 1, '2019-07-25 02:44:57', '2019-07-24 14:44:57', '2019-07-24 14:44:57');
INSERT INTO `oauth2_refresh_token` VALUES ('7a006ad4827d4f6ab367653ff5e48631', 27, 2, 1, '2019-07-30 22:55:38', '2019-07-30 10:55:37', '2019-07-30 10:55:37');
INSERT INTO `oauth2_refresh_token` VALUES ('7a0d4d982fd24335b46605781af46564', 27, 2, 1, '2019-06-01 16:05:51', '2019-06-01 04:05:51', '2019-06-01 04:05:51');
INSERT INTO `oauth2_refresh_token` VALUES ('7a25bd327b2145158d560f95920cb4fe', 27, 2, 1, '2019-08-26 22:05:19', '2019-08-26 10:05:18', '2019-08-26 10:05:18');
INSERT INTO `oauth2_refresh_token` VALUES ('7a270279270a48adb53958de1510e505', 27, 2, 1, '2019-07-02 23:10:42', '2019-07-02 11:10:41', '2019-07-02 11:10:41');
INSERT INTO `oauth2_refresh_token` VALUES ('7a3c0b7f873246b3ae111ab4eec27043', 27, 2, 1, '2019-07-20 04:52:26', '2019-07-19 16:52:26', '2019-07-19 16:52:26');
INSERT INTO `oauth2_refresh_token` VALUES ('7a5134f05d72441389d7acb9bfd843b5', 27, 2, 1, '2019-06-18 22:30:15', '2019-06-18 10:30:14', '2019-06-18 10:30:14');
INSERT INTO `oauth2_refresh_token` VALUES ('7a70eaf733b74135a303b9527e366068', 27, 2, 1, '2019-07-13 22:51:28', '2019-07-13 10:51:27', '2019-07-13 10:51:27');
INSERT INTO `oauth2_refresh_token` VALUES ('7a78f845fa214e23a2c295d652ecbdd7', 27, 2, 1, '2019-07-20 21:58:58', '2019-07-20 09:58:58', '2019-07-20 09:58:58');
INSERT INTO `oauth2_refresh_token` VALUES ('7a8153eb2bcc474f93cc95d88d634a41', 27, 2, 1, '2019-08-22 19:48:08', '2019-08-22 07:48:07', '2019-08-22 07:48:07');
INSERT INTO `oauth2_refresh_token` VALUES ('7a9b597d1ef541308dabbf4d3ef85943', 27, 2, 1, '2019-07-18 02:57:52', '2019-07-17 14:57:52', '2019-07-17 14:57:52');
INSERT INTO `oauth2_refresh_token` VALUES ('7aa90be9b562476ebc6be843a3a91f4e', NULL, NULL, 1, '2019-04-26 23:04:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7aad869f3a3e427aa8553967c4caa229', 27, 2, 1, '2019-08-22 08:20:40', '2019-08-21 20:20:40', '2019-08-21 20:20:40');
INSERT INTO `oauth2_refresh_token` VALUES ('7aae1e0e5b5645a0a875c940a8da1f83', 166, 1, 1, '2019-07-11 21:04:59', '2019-07-11 09:04:59', '2019-07-11 09:04:59');
INSERT INTO `oauth2_refresh_token` VALUES ('7acd8ef7bc004b73a7b8aac680e9bbfa', 27, 2, 1, '2019-08-02 10:28:15', '2019-08-01 22:28:14', '2019-08-01 22:28:14');
INSERT INTO `oauth2_refresh_token` VALUES ('7ad12b318b964bb58a24ba7fa3dce0d0', 27, 2, 1, '2019-06-01 21:50:25', '2019-06-01 09:50:25', '2019-06-01 09:50:25');
INSERT INTO `oauth2_refresh_token` VALUES ('7ad8767b0a59432299def0ba7689e3cb', 27, 2, 1, '2019-05-25 12:41:33', '2019-05-25 00:41:33', '2019-05-25 00:41:33');
INSERT INTO `oauth2_refresh_token` VALUES ('7ae0ec68081e4a3cb71e31af4f19df29', 27, 2, 1, '2019-06-09 08:12:37', '2019-06-08 20:12:37', '2019-06-08 20:12:37');
INSERT INTO `oauth2_refresh_token` VALUES ('7af020135d3243e3b33fc2576349f9b4', 27, 2, 1, '2019-06-18 03:42:01', '2019-06-17 15:42:01', '2019-06-17 15:42:01');
INSERT INTO `oauth2_refresh_token` VALUES ('7afd52443b934be9a9a7720f028bd382', 27, 2, 1, '2019-06-01 22:21:00', '2019-06-01 10:20:59', '2019-06-01 10:20:59');
INSERT INTO `oauth2_refresh_token` VALUES ('7b380fcc3a4e40c1896a3ec716a12437', 27, 2, 1, '2019-07-06 22:25:56', '2019-07-06 10:25:56', '2019-07-06 10:25:56');
INSERT INTO `oauth2_refresh_token` VALUES ('7b3bfc280ee647a284e1b74b782247ae', 27, 2, 1, '2019-08-21 04:22:25', '2019-08-20 16:22:25', '2019-08-20 16:22:25');
INSERT INTO `oauth2_refresh_token` VALUES ('7b4e477b021b4335bf12351f21355e0b', 27, 2, 1, '2019-07-25 22:36:33', '2019-07-25 10:36:33', '2019-07-25 10:36:33');
INSERT INTO `oauth2_refresh_token` VALUES ('7b4f854a148747188f1948416cde26b9', 27, 2, 1, '2019-05-23 03:23:26', '2019-05-22 15:23:26', '2019-05-22 15:23:26');
INSERT INTO `oauth2_refresh_token` VALUES ('7b504c74b8b648e98286776b3631bfab', 27, 2, 1, '2019-06-03 20:53:23', '2019-06-03 08:53:22', '2019-06-03 08:53:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7b6186fed7d74941aadb41e2245ce78a', 27, 2, 1, '2019-06-12 05:36:20', '2019-06-11 17:36:19', '2019-06-11 17:36:19');
INSERT INTO `oauth2_refresh_token` VALUES ('7b7572bb86d24599bd673fa5659d0148', 27, 2, 1, '2019-09-05 03:14:28', '2019-09-04 15:14:28', '2019-09-04 15:14:28');
INSERT INTO `oauth2_refresh_token` VALUES ('7b75a06f3b0f4f9687e7ba61357d9827', 27, 2, 1, '2019-07-12 10:41:46', '2019-07-11 22:41:46', '2019-07-11 22:41:46');
INSERT INTO `oauth2_refresh_token` VALUES ('7b7a5d13107b4d8fb9ce0ba29345f204', 27, 2, 1, '2019-05-30 21:46:17', '2019-05-30 09:46:16', '2019-05-30 09:46:16');
INSERT INTO `oauth2_refresh_token` VALUES ('7b9a677ccc43464f918d2274f3827850', 27, 2, 1, '2019-08-29 05:28:15', '2019-08-28 17:28:15', '2019-08-28 17:28:15');
INSERT INTO `oauth2_refresh_token` VALUES ('7b9fb4a4dfe746dc87243b05c1095f83', 27, 2, 1, '2019-06-19 01:13:29', '2019-06-18 13:13:29', '2019-06-18 13:13:29');
INSERT INTO `oauth2_refresh_token` VALUES ('7bb62952fb0944659eaee62d631a9224', NULL, NULL, 1, '2019-03-16 01:24:31', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7bbc28c5802d4c7a8cc1c305fb06f867', 27, 2, 1, '2019-06-25 03:15:34', '2019-06-24 15:15:34', '2019-06-24 15:15:34');
INSERT INTO `oauth2_refresh_token` VALUES ('7bfa2598045c45c7a2b497a8be7df1a2', 27, 2, 1, '2019-06-15 23:28:40', '2019-06-15 11:28:40', '2019-06-15 11:28:40');
INSERT INTO `oauth2_refresh_token` VALUES ('7c014d1675fe4cb6970e1e4d4021921b', 27, 2, 1, '2019-06-14 06:34:01', '2019-06-13 18:34:01', '2019-06-13 18:34:01');
INSERT INTO `oauth2_refresh_token` VALUES ('7c1a3b6d0c124c94a2167e50f80cf95e', NULL, NULL, 1, '2019-05-05 22:23:19', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7c2517ed659b4e8296bda62228878f7b', 27, 2, 1, '2019-09-04 23:50:44', '2019-09-04 11:50:44', '2019-09-04 11:50:44');
INSERT INTO `oauth2_refresh_token` VALUES ('7c3012f1ed244074b2633d83cbaa3b01', 27, 2, 1, '2019-09-09 07:49:00', '2019-09-08 19:49:00', '2019-09-08 19:49:00');
INSERT INTO `oauth2_refresh_token` VALUES ('7c3040f17f104d329a5f409ffb18a813', 27, 2, 1, '2019-07-03 02:40:08', '2019-07-02 14:40:08', '2019-07-02 14:40:08');
INSERT INTO `oauth2_refresh_token` VALUES ('7c43fe8439d04b61ba1acd85963f0601', 27, 2, 1, '2019-06-09 02:06:16', '2019-06-08 14:06:16', '2019-06-08 14:06:16');
INSERT INTO `oauth2_refresh_token` VALUES ('7c50ca619fb3440f9be4a10657c139f5', 27, 2, 1, '2019-07-30 07:04:59', '2019-07-29 19:04:58', '2019-07-29 19:04:58');
INSERT INTO `oauth2_refresh_token` VALUES ('7c620894ecf94558bfcc96bd74b52d48', 27, 2, 1, '2019-06-06 01:12:21', '2019-06-05 13:12:20', '2019-06-05 13:12:20');
INSERT INTO `oauth2_refresh_token` VALUES ('7c636c73dde5409d9827d6b9d17cc8df', 27, 2, 1, '2019-06-14 12:29:05', '2019-06-14 00:29:04', '2019-06-14 00:29:04');
INSERT INTO `oauth2_refresh_token` VALUES ('7c74702c388f4dbbb9a565c2ca2982e2', 27, 2, 1, '2019-06-26 22:23:29', '2019-06-26 10:23:29', '2019-06-26 10:23:29');
INSERT INTO `oauth2_refresh_token` VALUES ('7c7de38b780d411f8db476fffddfe4ab', NULL, NULL, 1, '2019-05-09 10:50:39', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7cab3f1b1be24c06a29f34548f50b6ad', 27, 2, 1, '2019-06-01 09:08:01', '2019-05-31 21:08:01', '2019-05-31 21:08:01');
INSERT INTO `oauth2_refresh_token` VALUES ('7cb164044f2e4474a9af0553bac5e004', NULL, NULL, 1, '2019-04-27 10:55:10', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7cb927e062674b0b83fd45e12ed4f854', 27, 2, 1, '2019-06-05 13:54:26', '2019-06-05 01:54:26', '2019-06-05 01:54:26');
INSERT INTO `oauth2_refresh_token` VALUES ('7cbe2012523d4433872d19c1f8b55e48', 27, 2, 1, '2019-06-05 10:58:36', '2019-06-04 22:58:36', '2019-06-04 22:58:36');
INSERT INTO `oauth2_refresh_token` VALUES ('7ce1b08dc12549bf9ba7cd5925493951', NULL, NULL, 1, '2019-04-12 05:40:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7cf952cb4d7244e0a09d965fcf6b56af', 27, 2, 1, '2019-06-20 03:59:32', '2019-06-19 15:59:32', '2019-06-19 15:59:32');
INSERT INTO `oauth2_refresh_token` VALUES ('7d20a092454b4634aa0dbfaf72df9ce8', 27, 2, 1, '2019-07-08 03:17:37', '2019-07-07 15:17:37', '2019-07-07 15:17:37');
INSERT INTO `oauth2_refresh_token` VALUES ('7d279ec33c504bfba51f5f7163fbcd2e', 94, 1, 1, '2019-06-01 20:04:57', '2019-06-01 08:04:56', '2019-06-01 08:04:56');
INSERT INTO `oauth2_refresh_token` VALUES ('7d2d2e5acf274f81b67210241a2204ee', 27, 2, 1, '2019-06-01 08:48:52', '2019-05-31 20:48:51', '2019-05-31 20:48:51');
INSERT INTO `oauth2_refresh_token` VALUES ('7d2ee6f682e94ccd9f63681d181c063b', 1, 2, 0, '2019-08-22 06:02:02', '2019-08-21 18:02:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('7d3022510a8342218ab81b2f4e8f636e', 1, 2, 0, '2019-08-22 06:01:47', '2019-08-21 18:01:47', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('7d3c04767434468fa5ce1fd03aa1b198', 27, 2, 1, '2019-07-04 22:56:54', '2019-07-04 10:56:53', '2019-07-04 10:56:53');
INSERT INTO `oauth2_refresh_token` VALUES ('7d45220f61ad4a3f9fe23734241e0717', 27, 2, 1, '2019-06-03 03:55:10', '2019-06-02 15:55:09', '2019-06-02 15:55:09');
INSERT INTO `oauth2_refresh_token` VALUES ('7d48357ad3da43a5a0fdc6c9dce3c0a9', 110, 1, 1, '2019-06-07 02:11:53', '2019-06-06 14:11:52', '2019-06-06 14:11:52');
INSERT INTO `oauth2_refresh_token` VALUES ('7d4c2b704e3c4e429637016594ef3dc3', 27, 2, 1, '2019-08-20 05:45:07', '2019-08-19 17:45:07', '2019-08-19 17:45:07');
INSERT INTO `oauth2_refresh_token` VALUES ('7d53c9fe96494388945a7eadf978aee4', 27, 2, 1, '2019-06-07 10:27:19', '2019-06-06 22:27:18', '2019-06-06 22:27:18');
INSERT INTO `oauth2_refresh_token` VALUES ('7d829c9137354674bcac6e51e192364b', 27, 2, 1, '2019-07-16 01:12:28', '2019-07-15 13:12:28', '2019-07-15 13:12:28');
INSERT INTO `oauth2_refresh_token` VALUES ('7da154e51d1f432aa3abd89d5a5586a7', 27, 2, 1, '2019-06-03 00:20:56', '2019-06-02 12:20:55', '2019-06-02 12:20:55');
INSERT INTO `oauth2_refresh_token` VALUES ('7daefb8c14204dfb8524a576ac395f6d', 27, 2, 1, '2019-06-02 00:04:01', '2019-06-01 12:04:00', '2019-06-01 12:04:00');
INSERT INTO `oauth2_refresh_token` VALUES ('7dc0149e1efe4ba79382c590c63b8bfa', 27, 2, 1, '2019-08-29 10:10:30', '2019-08-28 22:10:30', '2019-08-28 22:10:30');
INSERT INTO `oauth2_refresh_token` VALUES ('7dced97cc81e4fea8600329f0669ff5e', NULL, NULL, 1, '2019-05-09 11:18:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7dcf607107ec48abba529cf9f52551c6', NULL, NULL, 0, '2019-02-26 21:52:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7dd24fa604b3449ab1ed964cda94e160', 27, 2, 1, '2019-09-01 10:14:23', '2019-08-31 22:14:23', '2019-08-31 22:14:23');
INSERT INTO `oauth2_refresh_token` VALUES ('7dd62d2e747c4746806b800bee7b4a25', NULL, NULL, 1, '2019-03-18 08:44:21', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7dd62d55ee654fc9a40a3605478ac0c3', 27, 2, 1, '2019-06-26 22:54:55', '2019-06-26 10:54:55', '2019-06-26 10:54:55');
INSERT INTO `oauth2_refresh_token` VALUES ('7de56f7aaa0045ff9e271ee9d5f9f9c3', 27, 2, 1, '2019-09-07 03:52:26', '2019-09-06 15:52:26', '2019-09-06 15:52:26');
INSERT INTO `oauth2_refresh_token` VALUES ('7e0b4adf8e624200a7ebeb51f1a66f0d', NULL, NULL, 1, '2019-04-28 10:29:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7e2d8c0b51304b86a320df2cc30e24aa', 27, 2, 1, '2019-06-02 22:47:15', '2019-06-02 10:47:15', '2019-06-02 10:47:15');
INSERT INTO `oauth2_refresh_token` VALUES ('7e3dbc5b296647d4a136885b857b07d8', 27, 2, 1, '2019-06-04 21:04:02', '2019-06-04 09:04:02', '2019-06-04 09:04:02');
INSERT INTO `oauth2_refresh_token` VALUES ('7e44afcc3983424a92d77ae61e2764e0', 27, 2, 1, '2019-08-28 12:29:35', '2019-08-28 00:29:34', '2019-08-28 00:29:34');
INSERT INTO `oauth2_refresh_token` VALUES ('7e45e9acc9d248dd9f04c087af8de763', 27, 2, 1, '2019-06-28 22:29:07', '2019-06-28 10:29:07', '2019-06-28 10:29:07');
INSERT INTO `oauth2_refresh_token` VALUES ('7e4761b8dd6f40a6873631bb3d2d1a74', 27, 2, 1, '2019-09-02 10:07:10', '2019-09-01 22:07:10', '2019-09-01 22:07:10');
INSERT INTO `oauth2_refresh_token` VALUES ('7e4b25dbb7ae46bcb161b77ef9c9613e', 27, 2, 1, '2019-06-06 01:59:32', '2019-06-05 13:59:32', '2019-06-05 13:59:32');
INSERT INTO `oauth2_refresh_token` VALUES ('7e4efdee7e0147c38886f13dbfab114e', 27, 2, 1, '2019-06-21 11:12:59', '2019-06-20 23:12:58', '2019-06-20 23:12:58');
INSERT INTO `oauth2_refresh_token` VALUES ('7e6b2defa5e44f0ab8e1996c6f9c3e0b', NULL, NULL, 1, '2019-04-06 10:19:34', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7e7cb4e5e3b944a087de340a80493393', 27, 2, 1, '2019-08-14 22:18:57', '2019-08-14 10:18:57', '2019-08-14 10:18:57');
INSERT INTO `oauth2_refresh_token` VALUES ('7e94cbf8d8ed4790947ce528fce27478', 137, 1, 1, '2019-06-25 03:08:54', '2019-06-24 15:08:54', '2019-06-24 15:08:54');
INSERT INTO `oauth2_refresh_token` VALUES ('7ea07c439baa4407bd21a79896002bc6', NULL, NULL, 1, '2019-05-06 09:43:27', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7ec87b8d11284b5cbdb5345240776af4', 27, 2, 1, '2019-06-02 03:55:27', '2019-06-01 15:55:26', '2019-06-01 15:55:26');
INSERT INTO `oauth2_refresh_token` VALUES ('7ed0157b6569453589ce3cd2024e3a7f', 1, 2, 0, '2019-08-22 06:01:51', '2019-08-21 18:01:50', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('7ee5ae75bda3495aa8644312f0fe0ca8', 27, 2, 1, '2019-06-03 03:09:45', '2019-06-02 15:09:44', '2019-06-02 15:09:44');
INSERT INTO `oauth2_refresh_token` VALUES ('7ef144ad7ebe4867a702e8961f2423f1', 27, 2, 1, '2019-08-24 20:54:15', '2019-08-24 08:54:15', '2019-08-24 08:54:15');
INSERT INTO `oauth2_refresh_token` VALUES ('7f190e022a654199937c13fc2084eee3', 27, 2, 1, '2019-07-10 09:12:01', '2019-07-09 21:12:00', '2019-07-09 21:12:00');
INSERT INTO `oauth2_refresh_token` VALUES ('7f1fef7f8bb145a9be933f3027732038', 27, 2, 1, '2019-05-25 10:46:13', '2019-05-24 22:46:13', '2019-05-24 22:46:13');
INSERT INTO `oauth2_refresh_token` VALUES ('7f2db9c8d89247c3963be02c7f3c613e', 27, 2, 1, '2019-06-15 02:25:54', '2019-06-14 14:25:54', '2019-06-14 14:25:54');
INSERT INTO `oauth2_refresh_token` VALUES ('7f346400149a49258d79d67e423f51ee', 27, 2, 1, '2019-06-04 20:46:12', '2019-06-04 08:46:12', '2019-06-04 08:46:12');
INSERT INTO `oauth2_refresh_token` VALUES ('7f3c6a469a9c44f1ad2127b32ba189d6', 1, 2, 0, '2019-08-26 21:39:35', '2019-08-26 09:39:33', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('7f3d8f6812904c90bc1663c7f24ce541', 27, 2, 1, '2019-07-04 05:03:47', '2019-07-03 17:03:47', '2019-07-03 17:03:47');
INSERT INTO `oauth2_refresh_token` VALUES ('7f3fd831ce00459faf9bdee2f0a48f1f', 27, 2, 1, '2019-06-02 11:42:02', '2019-06-01 23:42:02', '2019-06-01 23:42:02');
INSERT INTO `oauth2_refresh_token` VALUES ('7f43ca7bde674c50b396e74f807636cd', NULL, NULL, 1, '2019-03-21 09:12:04', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7f502c29b25348cbbb987727edc5cb1e', 27, 2, 1, '2019-07-31 22:30:29', '2019-07-31 10:30:28', '2019-07-31 10:30:28');
INSERT INTO `oauth2_refresh_token` VALUES ('7f6c973ff2754a48accba28ae51fb7cd', 27, 2, 1, '2019-07-30 02:20:05', '2019-07-29 14:20:05', '2019-07-29 14:20:05');
INSERT INTO `oauth2_refresh_token` VALUES ('7f9366255f0841a4a3a9cbda1b8d0ce6', NULL, NULL, 1, '2019-04-23 06:26:58', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('7f967abf34d7407a9151c26efdcb3dc3', 1, 2, 0, '2019-09-08 09:36:08', '2019-09-07 21:36:07', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('7f9c547bc5754d12b2a4ce53551eed2d', 27, 2, 1, '2019-06-05 22:50:07', '2019-06-05 10:50:06', '2019-06-05 10:50:06');
INSERT INTO `oauth2_refresh_token` VALUES ('7fb7d4a6d53946da90a9bb34ae489e9d', 27, 2, 1, '2019-06-04 21:11:58', '2019-06-04 09:11:58', '2019-06-04 09:11:58');
INSERT INTO `oauth2_refresh_token` VALUES ('7fc42671a26d465bba9eee8f5e642ba3', 27, 2, 1, '2019-07-26 22:23:34', '2019-07-26 10:23:33', '2019-07-26 10:23:33');
INSERT INTO `oauth2_refresh_token` VALUES ('803853bce74f4022a0960cd52445587b', 27, 2, 1, '2019-06-01 20:52:42', '2019-06-01 08:52:41', '2019-06-01 08:52:41');
INSERT INTO `oauth2_refresh_token` VALUES ('803e0aa57a844866b3e9df9746ed5974', 27, 2, 1, '2019-06-05 04:53:35', '2019-06-04 16:53:34', '2019-06-04 16:53:34');
INSERT INTO `oauth2_refresh_token` VALUES ('8040fb73cbcb46ecb45bf91824a6029a', 27, 2, 1, '2019-07-09 10:42:16', '2019-07-08 22:42:16', '2019-07-08 22:42:16');
INSERT INTO `oauth2_refresh_token` VALUES ('80467d97b01848e8baf360f4db738105', NULL, NULL, 1, '2019-03-16 08:45:13', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('804e7dafa3f042329257a30b5482fae3', 27, 2, 1, '2019-07-21 23:47:33', '2019-07-21 11:47:33', '2019-07-21 11:47:33');
INSERT INTO `oauth2_refresh_token` VALUES ('80578c85e7b54c6084d0527717e09e64', 27, 2, 1, '2019-05-29 01:56:07', '2019-05-28 13:56:06', '2019-05-28 13:56:06');
INSERT INTO `oauth2_refresh_token` VALUES ('805dd218ac144af9856a2ae557d4cc83', 27, 2, 1, '2019-07-30 07:20:04', '2019-07-29 19:20:04', '2019-07-29 19:20:04');
INSERT INTO `oauth2_refresh_token` VALUES ('8065cdea04054996b2f1cd4a2e4e44dc', 27, 2, 1, '2019-06-26 06:32:10', '2019-06-25 18:32:09', '2019-06-25 18:32:09');
INSERT INTO `oauth2_refresh_token` VALUES ('80848e3c315c406fa9e4000aa07aad7e', 27, 2, 1, '2019-09-07 03:09:17', '2019-09-06 15:09:16', '2019-09-06 15:09:16');
INSERT INTO `oauth2_refresh_token` VALUES ('8091c43219f54d99ae18a11049155276', 27, 2, 1, '2019-06-03 22:00:00', '2019-06-03 10:00:00', '2019-06-03 10:00:00');
INSERT INTO `oauth2_refresh_token` VALUES ('80946d713dab4b559b35edf700da4d9e', NULL, NULL, 1, '2019-04-28 04:52:42', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8097d2f71cf849e08db2ac4a14b3dece', 27, 2, 1, '2019-06-12 01:59:08', '2019-06-11 13:59:08', '2019-06-11 13:59:08');
INSERT INTO `oauth2_refresh_token` VALUES ('80a493040e7e4ad990bc65c46939a962', 27, 2, 1, '2019-06-18 00:29:45', '2019-06-17 12:29:45', '2019-06-17 12:29:45');
INSERT INTO `oauth2_refresh_token` VALUES ('80c6076079e94029ac7c56042c009000', 1, 2, 0, '2019-05-17 05:17:42', '2019-05-16 17:17:42', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('80cdfa5b2bb5401fa5bfc0465ffe2a23', 27, 2, 1, '2019-08-24 23:49:57', '2019-08-24 11:49:56', '2019-08-24 11:49:56');
INSERT INTO `oauth2_refresh_token` VALUES ('80eb0c1e43e646b49999a89e42964cc3', 135, 1, 1, '2019-06-24 10:24:30', '2019-06-23 22:24:29', '2019-06-23 22:24:29');
INSERT INTO `oauth2_refresh_token` VALUES ('810060c3fe1b4b8b83383a714498b855', 27, 2, 1, '2019-06-02 10:20:53', '2019-06-01 22:20:53', '2019-06-01 22:20:53');
INSERT INTO `oauth2_refresh_token` VALUES ('811c2b1b236d45e782ff0c22ba0540e6', 27, 2, 1, '2019-08-05 23:24:59', '2019-08-05 11:24:59', '2019-08-05 11:24:59');
INSERT INTO `oauth2_refresh_token` VALUES ('812fea4b830b486fbd4f4085beaa2002', 27, 2, 1, '2019-08-18 05:30:31', '2019-08-17 17:30:30', '2019-08-17 17:30:30');
INSERT INTO `oauth2_refresh_token` VALUES ('81384f4dde5b4d2cadcb2456aadf9fc0', NULL, NULL, 1, '2019-05-13 11:20:50', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('813ae37af582472d92a35b3047025da4', 27, 2, 1, '2019-08-03 06:59:30', '2019-08-02 18:59:29', '2019-08-02 18:59:29');
INSERT INTO `oauth2_refresh_token` VALUES ('81420571aabe42d79e27eed9aac909f0', 27, 2, 1, '2019-07-06 23:25:44', '2019-07-06 11:25:44', '2019-07-06 11:25:44');
INSERT INTO `oauth2_refresh_token` VALUES ('8147a5bc1c9c424e97f3c80ac9bf8630', 27, 2, 1, '2019-06-26 21:56:56', '2019-06-26 09:56:55', '2019-06-26 09:56:55');
INSERT INTO `oauth2_refresh_token` VALUES ('816057f4ec1c47bdae5424f6106d9d46', 27, 2, 1, '2019-06-06 02:01:45', '2019-06-05 14:01:44', '2019-06-05 14:01:44');
INSERT INTO `oauth2_refresh_token` VALUES ('81977e0108d84085866b546dee0e6934', 27, 2, 1, '2019-08-02 06:30:22', '2019-08-01 18:30:22', '2019-08-01 18:30:22');
INSERT INTO `oauth2_refresh_token` VALUES ('81a7e50a93c341c0a71814aef5c9a240', 27, 2, 1, '2019-08-13 21:13:54', '2019-08-13 09:13:54', '2019-08-13 09:13:54');
INSERT INTO `oauth2_refresh_token` VALUES ('81ae9ffdbb8c487bb0a4d0b99e9d42db', 27, 2, 1, '2019-06-13 23:33:20', '2019-06-13 11:33:20', '2019-06-13 11:33:20');
INSERT INTO `oauth2_refresh_token` VALUES ('81b813ee61314d1c91040014c5f05695', 27, 2, 1, '2019-08-27 02:45:34', '2019-08-26 14:45:33', '2019-08-26 14:45:33');
INSERT INTO `oauth2_refresh_token` VALUES ('81bdc5231c4f48deb371243fe49b5df5', NULL, NULL, 1, '2019-04-24 12:34:02', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('81d9247dc76649148c6f121d5eefdd30', 1, 2, 0, '2019-07-15 22:44:36', '2019-07-15 10:44:35', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('81e16e9de1ea46c3852bfc3c7e89904a', 27, 2, 1, '2019-07-22 02:19:58', '2019-07-21 14:19:58', '2019-07-21 14:19:58');
INSERT INTO `oauth2_refresh_token` VALUES ('81e73c9d5ccd4ffaade78a324e578d7d', 27, 2, 1, '2019-07-12 05:55:17', '2019-07-11 17:55:17', '2019-07-11 17:55:17');
INSERT INTO `oauth2_refresh_token` VALUES ('81e7f36a416a464f9e12b5727a95f2d5', 1, 2, 0, '2019-07-03 22:08:33', '2019-07-03 10:08:33', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('820b7fd6f7424592a952deb608407f25', 27, 2, 1, '2019-07-27 12:48:39', '2019-07-27 00:48:38', '2019-07-27 00:48:38');
INSERT INTO `oauth2_refresh_token` VALUES ('82119c51b9e64177acb816b1307b1499', 27, 2, 1, '2019-06-04 23:10:40', '2019-06-04 11:10:40', '2019-06-04 11:10:40');
INSERT INTO `oauth2_refresh_token` VALUES ('82325cd60480438f8462df5535b83a2b', 27, 2, 1, '2019-06-13 03:17:28', '2019-06-12 15:17:27', '2019-06-12 15:17:27');
INSERT INTO `oauth2_refresh_token` VALUES ('823439e53ce54b21a01eb68285301a88', 27, 2, 1, '2019-09-07 04:02:50', '2019-09-06 16:02:49', '2019-09-06 16:02:49');
INSERT INTO `oauth2_refresh_token` VALUES ('8238a8edf3cf4a3b820e4ce1e2e5def5', 27, 2, 1, '2019-07-23 02:10:08', '2019-07-22 14:10:08', '2019-07-22 14:10:08');
INSERT INTO `oauth2_refresh_token` VALUES ('8245aa9f09b647a1834ba50be2837e6e', 27, 2, 1, '2019-07-25 10:23:35', '2019-07-24 22:23:34', '2019-07-24 22:23:34');
INSERT INTO `oauth2_refresh_token` VALUES ('8245e89626914015b9c09a22b4da0f37', 27, 2, 1, '2019-06-04 04:37:21', '2019-06-03 16:37:20', '2019-06-03 16:37:20');
INSERT INTO `oauth2_refresh_token` VALUES ('82625d4c6ce2435ca9df80a5d8502e73', 1, 2, 0, '2019-06-09 05:32:30', '2019-06-08 17:32:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('827792203dab44f5ba3c8c4c70006426', 27, 2, 1, '2019-06-28 04:59:54', '2019-06-27 16:59:54', '2019-06-27 16:59:54');
INSERT INTO `oauth2_refresh_token` VALUES ('827bbbff7f104620bd2ac5314ac3206f', 27, 2, 1, '2019-06-14 11:48:20', '2019-06-13 23:48:19', '2019-06-13 23:48:19');
INSERT INTO `oauth2_refresh_token` VALUES ('82867dcd4b41476d8ab32d4dec74d6f0', 27, 2, 1, '2019-06-01 04:41:30', '2019-05-31 16:41:30', '2019-05-31 16:41:30');
INSERT INTO `oauth2_refresh_token` VALUES ('828eaca50c8c4e67875a1488b235d45a', 147, 1, 1, '2019-07-10 08:25:21', '2019-07-09 20:25:21', '2019-07-09 20:25:21');
INSERT INTO `oauth2_refresh_token` VALUES ('82a2f6b184d44eea99258f8360e89d08', 27, 2, 1, '2019-07-26 02:33:02', '2019-07-25 14:33:02', '2019-07-25 14:33:02');
INSERT INTO `oauth2_refresh_token` VALUES ('82aa35c6947247c886e95af4fa4a7330', NULL, NULL, 1, '2019-03-16 08:42:08', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('82cfe8fcbda2458bac420f6425323ba2', 27, 2, 1, '2019-07-25 23:05:59', '2019-07-25 11:05:58', '2019-07-25 11:05:58');
INSERT INTO `oauth2_refresh_token` VALUES ('82d0322e97a84ba98a139275c2e0b412', 218, 1, 1, '2019-09-04 03:41:57', '2019-09-03 15:41:56', '2019-09-03 15:41:56');
INSERT INTO `oauth2_refresh_token` VALUES ('82dbe96c746449b290cc65afca3ca3c3', NULL, NULL, 1, '2019-04-23 06:34:37', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('82e456d114a24b1f8f7df1a1e507bcca', 27, 2, 1, '2019-08-04 01:58:59', '2019-08-03 13:58:58', '2019-08-03 13:58:58');
INSERT INTO `oauth2_refresh_token` VALUES ('82f7b5cc08ad422e93fcc024bf5ee228', 27, 2, 1, '2019-08-04 09:17:42', '2019-08-03 21:17:42', '2019-08-03 21:17:42');
INSERT INTO `oauth2_refresh_token` VALUES ('82f812fe64f34e79b6e5a458101cf9a6', 1, 2, 0, '2019-06-20 22:48:47', '2019-06-20 10:48:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('830ed374ecdf49a6878ba3af1bdbc345', NULL, NULL, 1, '2019-05-10 02:30:28', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8337f83d36454697bb447e391b005633', NULL, NULL, 0, '2019-03-04 09:41:10', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('834d23b249da4a0f87fd79218847135d', 128, 1, 1, '2019-08-14 04:54:04', '2019-08-13 16:54:03', '2019-08-13 16:54:03');
INSERT INTO `oauth2_refresh_token` VALUES ('835504be0438479f8cca7a8afa667bc8', 27, 2, 1, '2019-05-29 03:02:24', '2019-05-28 15:01:06', '2019-05-28 15:01:06');
INSERT INTO `oauth2_refresh_token` VALUES ('835a33aee643449bbbaa8fa203436070', 27, 2, 1, '2019-08-12 05:43:37', '2019-08-11 17:43:36', '2019-08-11 17:43:36');
INSERT INTO `oauth2_refresh_token` VALUES ('83603970cbf44c359ae85f35185ae569', 27, 2, 1, '2019-06-27 22:08:38', '2019-06-27 10:08:37', '2019-06-27 10:08:37');
INSERT INTO `oauth2_refresh_token` VALUES ('8368bf9822b24579863d36c244f14b40', 27, 2, 1, '2019-06-01 05:26:31', '2019-05-31 17:26:31', '2019-05-31 17:26:31');
INSERT INTO `oauth2_refresh_token` VALUES ('8378d69bfad64e36b54e93ea1bceef05', 27, 2, 1, '2019-08-17 04:20:47', '2019-08-16 16:20:46', '2019-08-16 16:20:46');
INSERT INTO `oauth2_refresh_token` VALUES ('83806986c2234f3dafe5be6f5e937f2f', NULL, NULL, 1, '2019-05-17 11:44:07', NULL, '2019-05-16 23:44:07');
INSERT INTO `oauth2_refresh_token` VALUES ('839a86706f1d4f6ab45c5427c3beba8c', 27, 2, 1, '2019-07-09 04:04:34', '2019-07-08 16:04:33', '2019-07-08 16:04:33');
INSERT INTO `oauth2_refresh_token` VALUES ('83a1d6888f044af8a23cc8eda1a03c0a', NULL, NULL, 1, '2019-05-04 05:44:20', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('83c4cb94c9a94cfbbffdb96a6b2a32f8', 27, 2, 1, '2019-05-24 11:03:55', '2019-05-23 23:03:55', '2019-05-23 23:03:55');
INSERT INTO `oauth2_refresh_token` VALUES ('83c6ca22e33f44c9a6fbd8b22d4e903c', NULL, NULL, 1, '2019-05-14 10:02:46', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('83d63ac058794800aca317073a743fe2', 27, 2, 1, '2019-09-07 04:24:09', '2019-09-06 16:24:08', '2019-09-06 16:24:08');
INSERT INTO `oauth2_refresh_token` VALUES ('83e051debafd46a3a1ece6a04b4314eb', 27, 2, 1, '2019-08-15 04:48:38', '2019-08-14 16:48:38', '2019-08-14 16:48:38');
INSERT INTO `oauth2_refresh_token` VALUES ('83e7a0677a9344fdb572358a6a2f6ce2', 27, 2, 1, '2019-06-04 01:54:45', '2019-06-03 13:54:45', '2019-06-03 13:54:45');
INSERT INTO `oauth2_refresh_token` VALUES ('841305ff72a04cdfa09006b51f929e91', 27, 2, 1, '2019-07-26 04:43:02', '2019-07-25 16:43:01', '2019-07-25 16:43:01');
INSERT INTO `oauth2_refresh_token` VALUES ('8414d4617a7744a295c42e2d61e9a8f3', NULL, NULL, 1, '2019-05-08 20:30:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('842c37e038424958a615a8a7b5793e60', 27, 2, 1, '2019-05-25 08:05:53', '2019-05-24 20:05:53', '2019-05-24 20:05:53');
INSERT INTO `oauth2_refresh_token` VALUES ('842e727619ec4274b169ff335d27e235', 27, 2, 1, '2019-05-29 08:27:33', '2019-05-28 20:27:33', '2019-05-28 20:27:33');
INSERT INTO `oauth2_refresh_token` VALUES ('8434e42aade941db9fab3267c255556a', NULL, NULL, 1, '2019-04-30 03:44:33', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('845a33f374e3476796cf750a0d0b38c6', 27, 2, 1, '2019-07-27 01:53:10', '2019-07-26 13:53:09', '2019-07-26 13:53:09');
INSERT INTO `oauth2_refresh_token` VALUES ('8464e429c33f432f9a44b44fac3c61a3', 27, 2, 1, '2019-07-22 21:04:05', '2019-07-22 09:04:04', '2019-07-22 09:04:04');
INSERT INTO `oauth2_refresh_token` VALUES ('846721b37a794737b01249d935076f37', 27, 2, 1, '2019-07-30 04:31:33', '2019-07-29 16:31:33', '2019-07-29 16:31:33');
INSERT INTO `oauth2_refresh_token` VALUES ('847ce170d8c1417f88bbe27cab8ab375', 27, 2, 1, '2019-06-05 05:19:52', '2019-06-04 17:19:52', '2019-06-04 17:19:52');
INSERT INTO `oauth2_refresh_token` VALUES ('847e5abef43647649693fa9348637b5d', 27, 2, 1, '2019-05-25 12:48:29', '2019-05-25 00:48:28', '2019-05-25 00:48:28');
INSERT INTO `oauth2_refresh_token` VALUES ('84822cb713a54068986e8ff41ef146c8', 27, 2, 1, '2019-06-04 00:41:54', '2019-06-03 12:41:54', '2019-06-03 12:41:54');
INSERT INTO `oauth2_refresh_token` VALUES ('84896b7655b8483a98af8369172a3901', 27, 2, 1, '2019-08-11 05:19:41', '2019-08-10 17:19:41', '2019-08-10 17:19:41');
INSERT INTO `oauth2_refresh_token` VALUES ('848be18ed2a34a96bb2b61daf0f71465', 1, 2, 0, '2019-05-29 05:11:20', '2019-05-28 17:10:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('84a37786769c45dc892badd48d960008', 27, 2, 1, '2019-07-13 03:38:51', '2019-07-12 15:38:51', '2019-07-12 15:38:51');
INSERT INTO `oauth2_refresh_token` VALUES ('84b658c49f594381bc34671942d1bf67', 27, 2, 1, '2019-06-22 01:51:42', '2019-06-21 13:51:42', '2019-06-21 13:51:42');
INSERT INTO `oauth2_refresh_token` VALUES ('84b9685cecaf49928ee1a621e8288dcc', NULL, NULL, 1, '2019-05-09 03:06:12', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('84bb3521ebe64e47bd3fb0aabbc0b543', NULL, NULL, 0, '2019-02-28 03:25:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('84e801e5e1564b9f85ed56c793fc7824', 27, 2, 1, '2019-07-04 05:45:28', '2019-07-03 17:45:27', '2019-07-03 17:45:27');
INSERT INTO `oauth2_refresh_token` VALUES ('851b7018a3e247feacb7e5918fa4b920', 27, 2, 1, '2019-06-05 01:32:38', '2019-06-04 13:32:38', '2019-06-04 13:32:38');
INSERT INTO `oauth2_refresh_token` VALUES ('851cc90beb8647ed8169b3622581e94e', 27, 2, 1, '2019-08-01 09:09:32', '2019-07-31 21:09:31', '2019-07-31 21:09:31');
INSERT INTO `oauth2_refresh_token` VALUES ('852fcc089a5547af88fbf5e175868c46', 1, 2, 0, '2019-09-06 10:58:01', '2019-09-05 22:58:00', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('85317c73807848e3a031dbc9280afa68', 27, 2, 1, '2019-06-29 01:52:46', '2019-06-28 13:52:46', '2019-06-28 13:52:46');
INSERT INTO `oauth2_refresh_token` VALUES ('853bee33fc89423288ff60318f62206a', 1, 2, 0, '2019-09-05 23:55:06', '2019-09-05 11:55:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('8564854870ce4dabb5bd9906d4db48b9', 27, 2, 1, '2019-06-01 21:53:45', '2019-06-01 09:53:44', '2019-06-01 09:53:44');
INSERT INTO `oauth2_refresh_token` VALUES ('85734b53c75645a4b3e83159186a8eb7', 27, 2, 1, '2019-06-30 00:16:57', '2019-06-29 12:16:56', '2019-06-29 12:16:56');
INSERT INTO `oauth2_refresh_token` VALUES ('858850c8614b45e9b9c04c26e5ee34a7', 27, 2, 1, '2019-07-18 03:03:43', '2019-07-17 15:03:42', '2019-07-17 15:03:42');
INSERT INTO `oauth2_refresh_token` VALUES ('858bfa4c985b4fcc88555109a2be87ca', NULL, NULL, 0, '2019-03-04 10:04:28', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8596ec6c17a34714988f7a6ce0d4b845', 27, 2, 1, '2019-07-01 02:48:23', '2019-06-30 14:48:23', '2019-06-30 14:48:23');
INSERT INTO `oauth2_refresh_token` VALUES ('859c62c37b6241758ff4c6133a059574', 27, 2, 1, '2019-06-12 10:44:05', '2019-06-11 22:44:05', '2019-06-11 22:44:05');
INSERT INTO `oauth2_refresh_token` VALUES ('85a4161903b1483e94f3b0ccc3223b34', 27, 2, 1, '2019-08-13 11:22:25', '2019-08-12 23:22:25', '2019-08-12 23:22:25');
INSERT INTO `oauth2_refresh_token` VALUES ('85ce0911229f474eb22e4fa85e7b3ad5', 27, 2, 1, '2019-05-25 02:27:39', '2019-05-24 14:26:22', '2019-05-24 14:26:22');
INSERT INTO `oauth2_refresh_token` VALUES ('85d2f9ba43c046e8b5903a2096ce2010', 27, 2, 1, '2019-06-23 00:09:27', '2019-06-22 12:09:26', '2019-06-22 12:09:26');
INSERT INTO `oauth2_refresh_token` VALUES ('85d329a304584d1da47c2787ea009db7', 27, 2, 1, '2019-06-06 00:13:40', '2019-06-05 12:13:39', '2019-06-05 12:13:39');
INSERT INTO `oauth2_refresh_token` VALUES ('85d895cb981640eb978a7240d0fe8e9a', 27, 2, 1, '2019-08-08 02:51:30', '2019-08-07 14:51:29', '2019-08-07 14:51:29');
INSERT INTO `oauth2_refresh_token` VALUES ('85e6fdc482934cf9a465de1c9451ee93', 27, 2, 1, '2019-06-29 03:59:36', '2019-06-28 15:59:36', '2019-06-28 15:59:36');
INSERT INTO `oauth2_refresh_token` VALUES ('85f74c15097641299ac356bd275d01ee', NULL, NULL, 1, '2019-05-16 10:27:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('86045ff722bb492aa6bb57e4f5c647b1', 27, 2, 1, '2019-07-04 21:14:30', '2019-07-04 09:14:29', '2019-07-04 09:14:29');
INSERT INTO `oauth2_refresh_token` VALUES ('861698ab242a46509c7d330ce3b95f6f', 27, 2, 1, '2019-07-12 21:51:08', '2019-07-12 09:51:08', '2019-07-12 09:51:08');
INSERT INTO `oauth2_refresh_token` VALUES ('8623c11943fc47fc8c2e64e77ff42baa', 27, 2, 1, '2019-09-06 10:06:42', '2019-09-05 22:06:42', '2019-09-05 22:06:42');
INSERT INTO `oauth2_refresh_token` VALUES ('864a84f3b4e54f0e87651c0f30f4ee22', 27, 2, 1, '2019-06-01 06:01:32', '2019-05-31 18:01:32', '2019-05-31 18:01:32');
INSERT INTO `oauth2_refresh_token` VALUES ('865f9a87df2647709e85eaf5890efc81', 27, 2, 1, '2019-07-11 11:04:08', '2019-07-10 23:04:07', '2019-07-10 23:04:07');
INSERT INTO `oauth2_refresh_token` VALUES ('86678ed6008449b098ac301295206aac', 1, 2, 0, '2019-05-18 01:28:29', '2019-05-17 13:28:28', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('867f4e6b9f0540a4813789770ea61301', 103, 1, 1, '2019-06-04 22:26:05', '2019-06-04 10:26:05', '2019-06-04 10:26:05');
INSERT INTO `oauth2_refresh_token` VALUES ('86a2e62f86b24969909d6deee82cd804', NULL, NULL, 1, '2019-05-13 10:47:46', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('86a49d94519a4fd39e7237c4cc630234', 27, 2, 1, '2019-06-26 01:50:59', '2019-06-25 13:50:58', '2019-06-25 13:50:58');
INSERT INTO `oauth2_refresh_token` VALUES ('86a7ee0c997f48de8f41fb8f8f6fa606', 1, 2, 0, '2019-09-05 22:38:05', '2019-09-05 10:38:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('86ba677ff71b47428286b0c1234ac753', 27, 2, 1, '2019-08-08 08:57:38', '2019-08-07 20:57:37', '2019-08-07 20:57:37');
INSERT INTO `oauth2_refresh_token` VALUES ('86c447184e584ae39b870c34f283b2ce', 27, 2, 1, '2019-08-07 23:22:01', '2019-08-07 11:22:00', '2019-08-07 11:22:00');
INSERT INTO `oauth2_refresh_token` VALUES ('86c817486f76432ea4244f2b6621a571', 27, 2, 1, '2019-09-04 01:52:51', '2019-09-03 13:52:51', '2019-09-03 13:52:51');
INSERT INTO `oauth2_refresh_token` VALUES ('86cffae35ec543e6b8c72b1b6722ebb6', 27, 2, 1, '2019-07-18 10:01:12', '2019-07-17 22:01:12', '2019-07-17 22:01:12');
INSERT INTO `oauth2_refresh_token` VALUES ('86f21b1c903a464cb857b0aee76229a2', 27, 2, 1, '2019-06-03 23:16:50', '2019-06-03 11:16:50', '2019-06-03 11:16:50');
INSERT INTO `oauth2_refresh_token` VALUES ('8701217312df423f94d0ac13360ce97c', 27, 2, 1, '2019-07-04 01:10:38', '2019-07-03 13:10:37', '2019-07-03 13:10:37');
INSERT INTO `oauth2_refresh_token` VALUES ('87027908f7d14850930eb489f8158099', 27, 2, 1, '2019-05-22 11:36:51', '2019-05-21 23:36:50', '2019-05-21 23:36:50');
INSERT INTO `oauth2_refresh_token` VALUES ('870c5443abb14619a792de6206c21ae6', 27, 2, 1, '2019-06-28 08:27:33', '2019-06-27 20:27:33', '2019-06-27 20:27:33');
INSERT INTO `oauth2_refresh_token` VALUES ('871aa1c71ab84ca495437f5a561d9921', NULL, NULL, 1, '2019-05-09 06:20:00', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8724495496f84303bc9961103f3ef410', 27, 2, 1, '2019-06-01 09:41:14', '2019-05-31 21:41:14', '2019-05-31 21:41:14');
INSERT INTO `oauth2_refresh_token` VALUES ('873007d6117e40dd9ce7c8e6a87e4db7', 27, 2, 1, '2019-05-25 06:06:37', '2019-05-24 18:06:36', '2019-05-24 18:06:36');
INSERT INTO `oauth2_refresh_token` VALUES ('87313f0f8fcc4d5eac136794718525cf', 27, 2, 1, '2019-06-05 02:12:50', '2019-06-04 14:12:49', '2019-06-04 14:12:49');
INSERT INTO `oauth2_refresh_token` VALUES ('8781e4cc2d884302a8437384cf6871c8', 27, 2, 1, '2019-06-03 22:14:12', '2019-06-03 10:14:11', '2019-06-03 10:14:11');
INSERT INTO `oauth2_refresh_token` VALUES ('8790dd3516ec4a76ab3ea5ea53f22bc9', 27, 2, 1, '2019-06-05 10:24:08', '2019-06-04 22:24:07', '2019-06-04 22:24:07');
INSERT INTO `oauth2_refresh_token` VALUES ('87cc153e15a04c8aba858e7fb26b27fa', NULL, NULL, 1, '2019-03-12 10:16:00', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('87f2551fb9f348fbb1951f9061b93371', 27, 2, 1, '2019-09-05 08:39:43', '2019-09-04 20:39:42', '2019-09-04 20:39:42');
INSERT INTO `oauth2_refresh_token` VALUES ('87f5ab24fa154d0985325172a8f9c5a7', 1, 2, 0, '2019-06-25 23:57:28', '2019-06-25 11:57:27', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('87ffdfc9d12a4d79a03755d416e82c1f', NULL, NULL, 1, '2019-04-25 23:06:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('881fb0832784465ba5aca2965ba67c04', 27, 2, 1, '2019-08-07 02:25:37', '2019-08-06 14:25:36', '2019-08-06 14:25:36');
INSERT INTO `oauth2_refresh_token` VALUES ('8836d59bb3ae461ea4ca7fceae9e157d', NULL, NULL, 1, '2019-04-23 07:42:36', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('88665a4cb5c1499dad7b7f92fec565b3', 27, 2, 1, '2019-06-29 01:52:05', '2019-06-28 13:52:05', '2019-06-28 13:52:05');
INSERT INTO `oauth2_refresh_token` VALUES ('8866973b37d44d34a39f912e3f79ba13', NULL, NULL, 1, '2019-04-24 20:16:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8887617ae8ef4741bd534b79ab841019', 27, 2, 1, '2019-08-21 06:36:18', '2019-08-20 18:36:18', '2019-08-20 18:36:18');
INSERT INTO `oauth2_refresh_token` VALUES ('888bc942b0d3449285383b1e72e85e71', NULL, NULL, 1, '2019-05-03 05:51:06', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('888bf7c7cbf8425f955679737102235c', 181, 1, 1, '2019-07-26 23:47:54', '2019-07-26 11:47:53', '2019-07-26 11:47:53');
INSERT INTO `oauth2_refresh_token` VALUES ('88910c775bf94d1b88fb5f5401132085', 27, 2, 1, '2019-06-24 10:31:57', '2019-06-23 22:31:57', '2019-06-23 22:31:57');
INSERT INTO `oauth2_refresh_token` VALUES ('88ac408c8e1e473587d613f8877b32f2', NULL, NULL, 1, '2019-05-10 13:01:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('88cb2c1d7b5f441190833608d2328daa', 27, 2, 1, '2019-07-02 20:13:07', '2019-07-02 08:13:07', '2019-07-02 08:13:07');
INSERT INTO `oauth2_refresh_token` VALUES ('88d63951608d42b9b9d1bcd073b32251', 27, 2, 1, '2019-06-23 04:55:38', '2019-06-22 16:55:38', '2019-06-22 16:55:38');
INSERT INTO `oauth2_refresh_token` VALUES ('88daf80a915b4071940b5118b3bbd133', 27, 2, 1, '2019-06-17 00:20:44', '2019-06-16 12:20:43', '2019-06-16 12:20:43');
INSERT INTO `oauth2_refresh_token` VALUES ('88e5091dadf44f71b3d22a43adff551e', 27, 2, 1, '2019-06-05 22:47:07', '2019-06-05 10:47:06', '2019-06-05 10:47:06');
INSERT INTO `oauth2_refresh_token` VALUES ('88f1dd83ab114ca393b845520b89e11e', 27, 2, 1, '2019-07-23 09:20:03', '2019-07-22 21:20:02', '2019-07-22 21:20:02');
INSERT INTO `oauth2_refresh_token` VALUES ('890f088aaaa1425784d01840864db891', NULL, NULL, 1, '2019-05-06 07:12:42', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('89237c31ab044f9590d8254e9042a5d8', NULL, NULL, 1, '2019-05-06 21:37:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('89259d18bbef4236a0398bede189617e', NULL, NULL, 1, '2019-05-11 03:05:48', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8929a0ff96ba4d1c8229cb7d67c16498', 27, 2, 1, '2019-06-04 03:59:54', '2019-06-03 15:59:53', '2019-06-03 15:59:53');
INSERT INTO `oauth2_refresh_token` VALUES ('892ce66f0239463587c9dfb9376adfd2', NULL, NULL, 1, '2019-05-05 23:03:05', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8931a209201240109bea2c5c9a6a8c08', 27, 2, 1, '2019-07-20 01:44:19', '2019-07-19 13:44:19', '2019-07-19 13:44:19');
INSERT INTO `oauth2_refresh_token` VALUES ('8945373f0f5348d4868f822473b1df38', 153, 1, 1, '2019-09-06 23:40:19', '2019-09-06 11:40:18', '2019-09-06 11:40:18');
INSERT INTO `oauth2_refresh_token` VALUES ('8946d7b924bc4c78a098f295152ef89d', NULL, NULL, 1, '2019-03-13 22:16:09', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8958c74b79d34ab9a6b24727d1c0b93c', 27, 2, 1, '2019-07-21 23:41:56', '2019-07-21 11:41:56', '2019-07-21 11:41:56');
INSERT INTO `oauth2_refresh_token` VALUES ('895a8a50e1c04872adf36a9256fab399', 27, 2, 1, '2019-07-11 04:29:53', '2019-07-10 16:29:52', '2019-07-10 16:29:52');
INSERT INTO `oauth2_refresh_token` VALUES ('896c97c2f33344a388ce72e2da42eb88', 1, 2, 0, '2019-07-03 20:39:55', '2019-07-03 08:39:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('897ba1b4656149cf8c4942193a86ac52', 27, 2, 1, '2019-05-22 09:06:29', '2019-05-21 21:06:28', '2019-05-21 21:06:28');
INSERT INTO `oauth2_refresh_token` VALUES ('89a3d9436b9048a789065b8c127cba10', 27, 2, 1, '2019-06-26 21:56:46', '2019-06-26 09:56:45', '2019-06-26 09:56:45');
INSERT INTO `oauth2_refresh_token` VALUES ('89a69a71ec794b6d8e48aadd5006249b', 27, 2, 1, '2019-06-03 23:20:45', '2019-06-03 11:20:44', '2019-06-03 11:20:44');
INSERT INTO `oauth2_refresh_token` VALUES ('89bf83a7944e4c4a8b4cc424a4cf9897', 27, 2, 1, '2019-06-19 21:56:52', '2019-06-19 09:56:52', '2019-06-19 09:56:52');
INSERT INTO `oauth2_refresh_token` VALUES ('89ca61db47974b4a9220b9f203ed9fb1', NULL, NULL, 1, '2019-04-30 02:20:26', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('89cf76a87ce64421bb140cb157cf9651', 27, 2, 1, '2019-06-04 07:55:30', '2019-06-03 19:55:30', '2019-06-03 19:55:30');
INSERT INTO `oauth2_refresh_token` VALUES ('89d72d7250a54085bb365fdb948d2f8e', 27, 2, 1, '2019-08-21 23:39:05', '2019-08-21 11:39:05', '2019-08-21 11:39:05');
INSERT INTO `oauth2_refresh_token` VALUES ('89f419f25f0144d5afba5c0ad3536382', 27, 2, 1, '2019-08-16 07:09:04', '2019-08-15 19:09:03', '2019-08-15 19:09:03');
INSERT INTO `oauth2_refresh_token` VALUES ('8a1d2d93f3804df099c2f63f5ec0415f', 27, 2, 1, '2019-06-01 05:21:01', '2019-05-31 17:21:01', '2019-05-31 17:21:01');
INSERT INTO `oauth2_refresh_token` VALUES ('8a2f90fb7e154817b9e7f2b53c8e067d', NULL, NULL, 0, '2019-03-04 10:10:44', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8a3799ece911420086992b571c539ae3', NULL, NULL, 1, '2019-05-04 09:25:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8a3fd03d726241a28576ed0f2fd78ae0', 1, 2, 0, '2019-07-23 05:50:09', '2019-07-22 17:50:08', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('8a44c022eaa548cab513099c62848d06', 27, 2, 1, '2019-09-06 23:57:41', '2019-09-06 11:57:40', '2019-09-06 11:57:40');
INSERT INTO `oauth2_refresh_token` VALUES ('8a884abafae44e0f9e8df06df9be8f9c', 1, 2, 0, '2019-08-21 23:17:10', '2019-08-21 11:17:09', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('8a8ab93381d340b596f7b8d83d571677', 27, 2, 1, '2019-08-02 03:53:36', '2019-08-01 15:53:36', '2019-08-01 15:53:36');
INSERT INTO `oauth2_refresh_token` VALUES ('8a8e506126c449fe9e6e9a6f2c300158', 27, 2, 1, '2019-08-02 00:18:24', '2019-08-01 12:18:23', '2019-08-01 12:18:23');
INSERT INTO `oauth2_refresh_token` VALUES ('8a9cf65fc43446ce836bc96dc5d562fb', NULL, NULL, 1, '2019-03-13 01:26:46', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8ab0bfa80a8f46d7b0472f8eac33692c', NULL, NULL, 1, '2019-05-06 10:11:24', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8af28a5716b342dd9b712c32e5c45dca', 74, 1, 1, '2019-05-18 09:52:55', '2019-05-17 21:52:54', '2019-05-17 21:52:54');
INSERT INTO `oauth2_refresh_token` VALUES ('8b06d0a3b32844f4a11f64f44e0e8977', 27, 2, 1, '2019-07-06 03:13:37', '2019-07-05 15:13:36', '2019-07-05 15:13:36');
INSERT INTO `oauth2_refresh_token` VALUES ('8b0f938281c34e968e1e289e0b58bf62', 27, 2, 1, '2019-07-13 06:16:40', '2019-07-12 18:16:39', '2019-07-12 18:16:39');
INSERT INTO `oauth2_refresh_token` VALUES ('8b4b6cb9979d44ac93c27170610af7f0', 27, 2, 1, '2019-08-07 09:38:32', '2019-08-06 21:38:31', '2019-08-06 21:38:31');
INSERT INTO `oauth2_refresh_token` VALUES ('8b7453cc0d99400f976db96d381c15ab', 27, 2, 1, '2019-07-13 02:23:08', '2019-07-12 14:23:08', '2019-07-12 14:23:08');
INSERT INTO `oauth2_refresh_token` VALUES ('8b7b1bbfdbc245d2a5abca17fe0cedcc', 219, 1, 1, '2019-09-05 05:46:39', '2019-09-04 17:46:39', '2019-09-04 17:46:39');
INSERT INTO `oauth2_refresh_token` VALUES ('8b8ed89f176545fdb4508955aa15e864', 27, 2, 1, '2019-06-01 01:45:15', '2019-05-31 13:45:15', '2019-05-31 13:45:15');
INSERT INTO `oauth2_refresh_token` VALUES ('8b98ec1080a64f79a5809150402adf01', NULL, NULL, 1, '2019-03-28 07:03:25', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8ba652a03e564a1fbdc6b64a73df84ee', 27, 2, 1, '2019-09-05 22:39:16', '2019-09-05 10:39:15', '2019-09-05 10:39:15');
INSERT INTO `oauth2_refresh_token` VALUES ('8baa1c8507e1409bb04d9c451f8da049', NULL, NULL, 1, '2019-05-06 09:34:47', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8bb0193df77141c7b6db0fef88a0b5c2', NULL, NULL, 1, '2019-05-16 03:44:15', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8bcc7e90af294430a5a8de16d8fc9d4d', 27, 2, 1, '2019-06-05 23:46:37', '2019-06-05 11:46:37', '2019-06-05 11:46:37');
INSERT INTO `oauth2_refresh_token` VALUES ('8bcea1afede1448f89d1aefc775b2dad', 27, 2, 1, '2019-06-20 21:04:22', '2019-06-20 09:04:22', '2019-06-20 09:04:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8be33c44765e4dd6acb64e77b3299eac', 27, 2, 1, '2019-08-04 03:58:26', '2019-08-03 15:58:25', '2019-08-03 15:58:25');
INSERT INTO `oauth2_refresh_token` VALUES ('8be609ee4fa94379b237dd5f4c344f32', 27, 2, 1, '2019-08-19 21:52:31', '2019-08-19 09:52:31', '2019-08-19 09:52:31');
INSERT INTO `oauth2_refresh_token` VALUES ('8be7216f66a64f80a707f4134e10624c', 27, 2, 1, '2019-06-01 09:42:59', '2019-05-31 21:42:58', '2019-05-31 21:42:58');
INSERT INTO `oauth2_refresh_token` VALUES ('8be7d6f5994b42fb85a67cf20066caa3', NULL, NULL, 1, '2019-05-03 07:40:48', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8be96ee69fdf462ba72fdbea95015042', 27, 2, 1, '2019-08-22 12:29:44', '2019-08-22 00:29:44', '2019-08-22 00:29:44');
INSERT INTO `oauth2_refresh_token` VALUES ('8bea3a1316ef44e3b03263da74a4752f', 1, 2, 0, '2019-09-05 10:57:52', '2019-09-04 22:57:52', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('8bf0b8d32b55439a8cd3def8558cfde0', 27, 2, 1, '2019-06-10 09:31:26', '2019-06-09 21:31:26', '2019-06-09 21:31:26');
INSERT INTO `oauth2_refresh_token` VALUES ('8bfbee1765a941d98e49902e6ba71959', 27, 2, 1, '2019-06-16 06:59:53', '2019-06-15 18:59:53', '2019-06-15 18:59:53');
INSERT INTO `oauth2_refresh_token` VALUES ('8bfc37d30a0446a0ae67baf20ac64c74', 27, 2, 1, '2019-06-20 21:11:45', '2019-06-20 09:11:45', '2019-06-20 09:11:45');
INSERT INTO `oauth2_refresh_token` VALUES ('8c1f2833e9764f12a77162715050a193', 27, 2, 1, '2019-06-01 06:28:22', '2019-05-31 18:28:21', '2019-05-31 18:28:21');
INSERT INTO `oauth2_refresh_token` VALUES ('8c29b024e909471dafb138e8239ba17d', 27, 2, 1, '2019-08-06 21:24:20', '2019-08-06 09:24:19', '2019-08-06 09:24:19');
INSERT INTO `oauth2_refresh_token` VALUES ('8c2f75c61adc49039aac4b610da4772c', 27, 2, 1, '2019-06-06 06:10:12', '2019-06-05 18:10:11', '2019-06-05 18:10:11');
INSERT INTO `oauth2_refresh_token` VALUES ('8c316f0c21cf46b58041fa3bf45927c5', NULL, NULL, 1, '2019-05-06 08:17:42', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8c5d4054507849d1bc4945a07a63fed0', 27, 2, 1, '2019-07-30 02:45:59', '2019-07-29 14:45:59', '2019-07-29 14:45:59');
INSERT INTO `oauth2_refresh_token` VALUES ('8c60f11bedc64ceb872d4b09df706982', 27, 2, 1, '2019-06-21 11:49:41', '2019-06-20 23:49:40', '2019-06-20 23:49:40');
INSERT INTO `oauth2_refresh_token` VALUES ('8c6e3c99852f4a8b93322326e4f356c6', 27, 2, 1, '2019-08-30 03:45:43', '2019-08-29 15:45:43', '2019-08-29 15:45:43');
INSERT INTO `oauth2_refresh_token` VALUES ('8c709623bd90405692f5243bc55c3e6e', 27, 2, 1, '2019-06-12 04:00:51', '2019-06-11 16:00:51', '2019-06-11 16:00:51');
INSERT INTO `oauth2_refresh_token` VALUES ('8c74ac3eddb344f3a54cfabf5f60d914', NULL, NULL, 1, '2019-03-16 03:20:08', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8c7b1066e04f4bdb988c8861df52adf4', 27, 2, 1, '2019-07-28 03:03:58', '2019-07-27 15:03:57', '2019-07-27 15:03:57');
INSERT INTO `oauth2_refresh_token` VALUES ('8c82a2ae8bc541888686afcd8ede74c3', 27, 2, 1, '2019-06-07 05:32:33', '2019-06-06 17:32:33', '2019-06-06 17:32:33');
INSERT INTO `oauth2_refresh_token` VALUES ('8c8ef34f45744b91b32cebf8a476269e', 27, 2, 1, '2019-06-03 06:46:15', '2019-06-02 18:46:14', '2019-06-02 18:46:14');
INSERT INTO `oauth2_refresh_token` VALUES ('8c974558915b4a8488dcf6ae42b48212', 27, 2, 1, '2019-06-12 02:53:45', '2019-06-11 14:53:45', '2019-06-11 14:53:45');
INSERT INTO `oauth2_refresh_token` VALUES ('8ce70b197774491bae139a9bbd739077', NULL, NULL, 1, '2019-05-08 20:37:51', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8d0e1e760f85436a93c4e5c18c7f8769', 27, 2, 1, '2019-08-21 22:45:30', '2019-08-21 10:45:29', '2019-08-21 10:45:29');
INSERT INTO `oauth2_refresh_token` VALUES ('8d11e92207c6449ebc76d104e91d2f8c', 27, 2, 1, '2019-06-24 23:21:17', '2019-06-24 11:21:16', '2019-06-24 11:21:16');
INSERT INTO `oauth2_refresh_token` VALUES ('8d2649754248428f9d4200de644caa33', 153, 1, 1, '2019-07-05 03:15:43', '2019-07-04 15:15:43', '2019-07-04 15:15:43');
INSERT INTO `oauth2_refresh_token` VALUES ('8d2a0f245b51417f8e1167c3deec5741', 27, 2, 1, '2019-06-15 02:24:50', '2019-06-14 14:24:50', '2019-06-14 14:24:50');
INSERT INTO `oauth2_refresh_token` VALUES ('8d2ef9d812c8417793f447e73c7ce774', 27, 2, 1, '2019-06-27 00:18:13', '2019-06-26 12:18:13', '2019-06-26 12:18:13');
INSERT INTO `oauth2_refresh_token` VALUES ('8d36629e61244220b0db09aade146269', 27, 2, 1, '2019-08-11 05:07:14', '2019-08-10 17:07:13', '2019-08-10 17:07:13');
INSERT INTO `oauth2_refresh_token` VALUES ('8d36e916355c4950ba67d5cb13db2b8e', 27, 2, 1, '2019-05-27 22:12:22', '2019-05-27 10:12:21', '2019-05-27 10:12:21');
INSERT INTO `oauth2_refresh_token` VALUES ('8d56052f96b944f6830a9741f3c21011', 27, 2, 1, '2019-08-10 08:54:16', '2019-08-09 20:54:16', '2019-08-09 20:54:16');
INSERT INTO `oauth2_refresh_token` VALUES ('8d592ef95c514a8e93accc3c0c8dabc9', 27, 2, 1, '2019-06-05 03:00:46', '2019-06-04 15:00:46', '2019-06-04 15:00:46');
INSERT INTO `oauth2_refresh_token` VALUES ('8d601049f11f48578b443c2620afe5e8', NULL, NULL, 1, '2019-03-10 14:32:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8d74a19fd67e43b3ac6dde6c4e88023d', NULL, NULL, 1, '2019-03-16 04:09:42', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8d99266c2a1d4b5d81999f48eab50e35', 27, 2, 1, '2019-08-08 01:53:40', '2019-08-07 13:53:39', '2019-08-07 13:53:39');
INSERT INTO `oauth2_refresh_token` VALUES ('8dc3bce249c645758474af4eaeff50b1', 27, 2, 1, '2019-06-07 00:13:30', '2019-06-06 12:13:30', '2019-06-06 12:13:30');
INSERT INTO `oauth2_refresh_token` VALUES ('8dd31debe08a41dd816cdc853f9bdc29', 27, 2, 1, '2019-07-08 23:07:54', '2019-07-08 11:07:54', '2019-07-08 11:07:54');
INSERT INTO `oauth2_refresh_token` VALUES ('8ddf887467e043dd896423cdd2a735d5', 27, 2, 1, '2019-07-15 02:55:32', '2019-07-14 14:55:32', '2019-07-14 14:55:32');
INSERT INTO `oauth2_refresh_token` VALUES ('8df5c959189a419dab7c2a0dced5bc1e', 27, 2, 1, '2019-07-18 08:19:05', '2019-07-17 20:19:05', '2019-07-17 20:19:05');
INSERT INTO `oauth2_refresh_token` VALUES ('8dfdcb82cc6a42a99094470574db1798', NULL, NULL, 1, '2019-04-30 02:05:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8e118ecd739b4ccaa9e576f535b337ad', 27, 2, 1, '2019-08-04 08:45:18', '2019-08-03 20:45:17', '2019-08-03 20:45:17');
INSERT INTO `oauth2_refresh_token` VALUES ('8e28bde38c2e46cf9b3fba01205d2189', NULL, NULL, 1, '2019-03-13 08:38:17', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8e2b058b8bea44f980abea86de71ea99', 27, 2, 1, '2019-06-29 12:00:11', '2019-06-29 00:00:11', '2019-06-29 00:00:11');
INSERT INTO `oauth2_refresh_token` VALUES ('8e31de012cc24034a72f61035a1d81e8', 27, 2, 1, '2019-06-05 05:02:17', '2019-06-04 17:02:17', '2019-06-04 17:02:17');
INSERT INTO `oauth2_refresh_token` VALUES ('8e3be1c67d7e42dea106cd1fe511b881', 27, 2, 1, '2019-07-08 08:56:28', '2019-07-07 20:56:28', '2019-07-07 20:56:28');
INSERT INTO `oauth2_refresh_token` VALUES ('8e754bbcb2e44ce282c8e03d3b4e7b17', NULL, NULL, 1, '2019-03-10 22:11:01', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8e794205a2d64f61a87193b5ff830be2', 27, 2, 1, '2019-08-08 08:41:40', '2019-08-07 20:41:40', '2019-08-07 20:41:40');
INSERT INTO `oauth2_refresh_token` VALUES ('8e94a8e5b847477db4622cbf1d84d4ce', 27, 2, 1, '2019-07-02 21:23:53', '2019-07-02 09:23:53', '2019-07-02 09:23:53');
INSERT INTO `oauth2_refresh_token` VALUES ('8e984d69b1f940b7ae606ae3af5f0156', 27, 2, 1, '2019-06-27 05:59:24', '2019-06-26 17:59:23', '2019-06-26 17:59:23');
INSERT INTO `oauth2_refresh_token` VALUES ('8e9ad20fa2474c1fb6b9b7e9de6199ed', 27, 2, 1, '2019-07-23 02:34:36', '2019-07-22 14:34:36', '2019-07-22 14:34:36');
INSERT INTO `oauth2_refresh_token` VALUES ('8ea153c179c34b468590e1f0794d2e0b', 27, 2, 1, '2019-08-05 09:28:03', '2019-08-04 21:28:03', '2019-08-04 21:28:03');
INSERT INTO `oauth2_refresh_token` VALUES ('8eac75e19cb14f809af455f9d6210ee8', 27, 2, 1, '2019-08-21 05:01:11', '2019-08-20 17:01:11', '2019-08-20 17:01:11');
INSERT INTO `oauth2_refresh_token` VALUES ('8eadb31707e245b1ab14fd592767f98e', 140, 1, 1, '2019-07-04 20:51:51', '2019-07-04 08:51:50', '2019-07-04 08:51:50');
INSERT INTO `oauth2_refresh_token` VALUES ('8eb692f9f37643c181b600d9f9170f77', 27, 2, 1, '2019-06-07 10:55:19', '2019-06-06 22:55:18', '2019-06-06 22:55:18');
INSERT INTO `oauth2_refresh_token` VALUES ('8ec251333b2748fbb66dd291915da6df', 27, 2, 1, '2019-06-14 02:22:20', '2019-06-13 14:22:19', '2019-06-13 14:22:19');
INSERT INTO `oauth2_refresh_token` VALUES ('8ec51f4bedef47499c5238d915472c4f', 27, 2, 1, '2019-08-12 08:19:48', '2019-08-11 20:19:47', '2019-08-11 20:19:47');
INSERT INTO `oauth2_refresh_token` VALUES ('8f119606e2c74d6cab2815e18b3a92d1', NULL, NULL, 1, '2019-03-15 23:24:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('8f77bd296d684a9c96c4bbb719bf3501', 27, 2, 1, '2019-08-05 22:42:26', '2019-08-05 10:42:26', '2019-08-05 10:42:26');
INSERT INTO `oauth2_refresh_token` VALUES ('8f923e6d0dfd46abb0f1fc159732d345', 27, 2, 1, '2019-08-02 00:14:30', '2019-08-01 12:14:29', '2019-08-01 12:14:29');
INSERT INTO `oauth2_refresh_token` VALUES ('8fcbf17fbe6a4d8680ec07b6ce719b0a', 1, 2, 0, '2019-07-05 22:17:05', '2019-07-05 10:17:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('8fdedb15be7c470d8055ef5de2f56697', 27, 2, 1, '2019-06-13 03:20:59', '2019-06-12 15:20:59', '2019-06-12 15:20:59');
INSERT INTO `oauth2_refresh_token` VALUES ('900adda5ac5e41f6a81706dde3b29d03', NULL, NULL, 1, '2019-05-01 08:13:00', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('900b95fb044f4a1b80f07329e699f0e5', 27, 2, 1, '2019-07-22 21:51:36', '2019-07-22 09:51:36', '2019-07-22 09:51:36');
INSERT INTO `oauth2_refresh_token` VALUES ('9035a2be8a244511aebe0ad47d5ddccc', 27, 2, 1, '2019-07-28 20:40:30', '2019-07-28 08:40:30', '2019-07-28 08:40:30');
INSERT INTO `oauth2_refresh_token` VALUES ('9036a8b93f3c4075a838e7fe68c0baf8', 27, 2, 1, '2019-05-25 09:57:36', '2019-05-24 21:57:35', '2019-05-24 21:57:35');
INSERT INTO `oauth2_refresh_token` VALUES ('905352c71c6e4c2a98899ea1df90eaf1', 27, 2, 1, '2019-08-11 20:12:36', '2019-08-11 08:12:35', '2019-08-11 08:12:35');
INSERT INTO `oauth2_refresh_token` VALUES ('9061165374084ef29d857268813b5da6', 27, 2, 1, '2019-09-04 01:01:41', '2019-09-03 13:01:41', '2019-09-03 13:01:41');
INSERT INTO `oauth2_refresh_token` VALUES ('90615279ee3549b080e1fa4eb5f67fd6', 1, 2, 0, '2019-07-19 22:49:30', '2019-07-19 10:49:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('9064a6641a9e466996cb3401e6a91ef5', 27, 2, 1, '2019-05-24 01:33:07', '2019-05-23 13:33:06', '2019-05-23 13:33:06');
INSERT INTO `oauth2_refresh_token` VALUES ('90733a86efcc4669a07139b0137bca18', 1, 2, 0, '2019-06-28 20:43:45', '2019-06-28 08:43:45', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('90a8eb7fbe0143a8bec42c8b91746510', NULL, NULL, 1, '2019-05-06 04:18:32', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('90babaec6df3418fba43197d4632c3db', 1, 2, 0, '2019-07-13 02:10:56', '2019-07-12 14:10:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('90c41c00021c4022ab4457c253788ab9', NULL, NULL, 1, '2019-04-04 05:44:08', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('90e852728f0f4d6eb25a58db3cfb9c81', 27, 2, 1, '2019-07-24 02:44:15', '2019-07-23 14:44:14', '2019-07-23 14:44:14');
INSERT INTO `oauth2_refresh_token` VALUES ('90f77420470e4840a02d3470b8399d06', 27, 2, 1, '2019-06-29 05:14:24', '2019-06-28 17:14:24', '2019-06-28 17:14:24');
INSERT INTO `oauth2_refresh_token` VALUES ('90f9590deab145d8ae413ebf454b8886', 27, 2, 1, '2019-07-09 23:04:08', '2019-07-09 11:04:08', '2019-07-09 11:04:08');
INSERT INTO `oauth2_refresh_token` VALUES ('9102c41e7e1f4232b602c2f6cd09775f', 27, 2, 1, '2019-06-20 03:55:58', '2019-06-19 15:55:57', '2019-06-19 15:55:57');
INSERT INTO `oauth2_refresh_token` VALUES ('9128cde37fa84073a2c614e45bb29343', 27, 2, 1, '2019-08-01 07:19:32', '2019-07-31 19:19:31', '2019-07-31 19:19:31');
INSERT INTO `oauth2_refresh_token` VALUES ('9150b5279f5642da833bec0c47f111d0', 1, 2, 0, '2019-07-03 04:24:43', '2019-07-02 16:24:42', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('916ea653465d4cc3966238c198e3644f', 27, 2, 1, '2019-09-07 06:47:27', '2019-09-06 18:47:26', '2019-09-06 18:47:26');
INSERT INTO `oauth2_refresh_token` VALUES ('917fab05c67d4a088cd96b98b47ff74f', 27, 2, 1, '2019-08-16 07:25:26', '2019-08-15 19:25:25', '2019-08-15 19:25:25');
INSERT INTO `oauth2_refresh_token` VALUES ('9181e9e7fb9d46048c8042a28905045a', 27, 2, 1, '2019-07-11 06:45:32', '2019-07-10 18:45:32', '2019-07-10 18:45:32');
INSERT INTO `oauth2_refresh_token` VALUES ('91c277776d5b41c081ef26f1ec8f9d5a', 27, 2, 1, '2019-07-25 21:46:08', '2019-07-25 09:46:07', '2019-07-25 09:46:07');
INSERT INTO `oauth2_refresh_token` VALUES ('91cffea801874079a6cdcc5d6eed3855', NULL, NULL, 0, '2019-03-06 17:35:12', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('91fca003fed44b86aafd70be99699f70', 27, 2, 1, '2019-09-04 09:49:20', '2019-09-03 21:49:20', '2019-09-03 21:49:20');
INSERT INTO `oauth2_refresh_token` VALUES ('9231143e9f234a098f759653fb165cad', 27, 2, 1, '2019-07-13 10:03:23', '2019-07-12 22:03:22', '2019-07-12 22:03:22');
INSERT INTO `oauth2_refresh_token` VALUES ('92335ba8680449d78b50ef4c40ec6441', NULL, NULL, 1, '2019-04-27 03:11:43', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('924f68d7cfdf4b418f95338bc49a6977', 27, 2, 1, '2019-08-27 23:17:42', '2019-08-27 11:17:41', '2019-08-27 11:17:41');
INSERT INTO `oauth2_refresh_token` VALUES ('9258776942cc49ec992ecc457e6cf0da', 27, 2, 1, '2019-06-04 10:19:38', '2019-06-03 22:19:37', '2019-06-03 22:19:37');
INSERT INTO `oauth2_refresh_token` VALUES ('9269e02da5544db6b50e7002efbade1e', 27, 2, 1, '2019-06-23 09:25:24', '2019-06-22 21:25:24', '2019-06-22 21:25:24');
INSERT INTO `oauth2_refresh_token` VALUES ('926c9d1bfc294da1babb724f5a32742e', 27, 2, 1, '2019-05-23 08:36:04', '2019-05-22 20:36:03', '2019-05-22 20:36:03');
INSERT INTO `oauth2_refresh_token` VALUES ('926d9bd34db545208ab276cebce99fac', 27, 2, 1, '2019-08-09 23:18:55', '2019-08-09 11:18:55', '2019-08-09 11:18:55');
INSERT INTO `oauth2_refresh_token` VALUES ('927e861e16644e998bf7d7347b68e555', 27, 2, 1, '2019-07-05 21:07:01', '2019-07-05 09:07:00', '2019-07-05 09:07:00');
INSERT INTO `oauth2_refresh_token` VALUES ('92a2f138b10a42a1903ad78947284826', 27, 2, 1, '2019-09-02 23:39:50', '2019-09-02 11:39:49', '2019-09-02 11:39:49');
INSERT INTO `oauth2_refresh_token` VALUES ('92c3ecd1d71b48eebfddd4fb5afcb5ad', 27, 2, 1, '2019-07-23 22:01:49', '2019-07-23 10:01:48', '2019-07-23 10:01:48');
INSERT INTO `oauth2_refresh_token` VALUES ('92d9f1f5687d4a80992e7e5f9211e9c1', 27, 2, 1, '2019-08-31 06:03:39', '2019-08-30 18:03:39', '2019-08-30 18:03:39');
INSERT INTO `oauth2_refresh_token` VALUES ('93050f0d2bee4891afe1e9deabea8c5c', 27, 2, 1, '2019-06-03 10:24:51', '2019-06-02 22:24:50', '2019-06-02 22:24:50');
INSERT INTO `oauth2_refresh_token` VALUES ('930e0a5d97cf421cbcad35a929000df6', 1, 2, 0, '2019-05-31 22:52:39', '2019-05-31 10:51:19', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('933b5e4d8cc44f34ad9609c4042bc846', 27, 2, 1, '2019-08-13 16:13:01', '2019-08-13 04:13:01', '2019-08-13 04:13:01');
INSERT INTO `oauth2_refresh_token` VALUES ('93485beffcbc4ae89a97f72a44d7985a', 27, 2, 1, '2019-07-05 07:12:59', '2019-07-04 19:12:58', '2019-07-04 19:12:58');
INSERT INTO `oauth2_refresh_token` VALUES ('9369a1a70bc745eab160be3e6e440dd9', NULL, NULL, 1, '2019-04-05 23:22:29', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('937277c0464747ce90eda45b296475b3', NULL, NULL, 1, '2019-05-05 04:45:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9377dc2f69864aa79cac7756b33fd635', NULL, NULL, 1, '2019-05-14 09:11:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('93a5a1f828894592ae4e40c9b94a95ff', 1, 2, 0, '2019-06-01 10:54:25', '2019-05-31 22:54:25', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('93ab8ae812764c17915c469c626ef9ff', NULL, NULL, 1, '2019-03-10 15:36:23', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('93b23552f299453d879eb04517ae53fe', 27, 2, 1, '2019-08-02 16:51:56', '2019-08-02 04:51:56', '2019-08-02 04:51:56');
INSERT INTO `oauth2_refresh_token` VALUES ('93cb534f1a114fd2b6b2f597fd113b3a', 27, 2, 1, '2019-06-11 23:23:39', '2019-06-11 11:23:39', '2019-06-11 11:23:39');
INSERT INTO `oauth2_refresh_token` VALUES ('93d76971e02c426ca2cb3cbf70e0da3c', 27, 2, 1, '2019-06-18 21:29:42', '2019-06-18 09:29:41', '2019-06-18 09:29:41');
INSERT INTO `oauth2_refresh_token` VALUES ('93edd627ce3d4f9aaae9b9d761703fe8', 27, 2, 1, '2019-06-07 22:34:33', '2019-06-07 10:34:32', '2019-06-07 10:34:32');
INSERT INTO `oauth2_refresh_token` VALUES ('93fd5a8ee4b44c5eb6fe7172242b2d11', 27, 2, 1, '2019-06-25 12:31:02', '2019-06-25 00:31:02', '2019-06-25 00:31:02');
INSERT INTO `oauth2_refresh_token` VALUES ('93fe8a92bb8440e494f0a410710ed556', 27, 2, 1, '2019-06-17 07:29:29', '2019-06-16 19:29:29', '2019-06-16 19:29:29');
INSERT INTO `oauth2_refresh_token` VALUES ('94037f87860f4f17bd2ac18758b36c24', 27, 2, 1, '2019-06-01 03:34:35', '2019-05-31 15:34:34', '2019-05-31 15:34:34');
INSERT INTO `oauth2_refresh_token` VALUES ('94093d3af11d4b0e90c09c8679ca5383', 27, 2, 1, '2019-09-03 21:38:04', '2019-09-03 09:38:04', '2019-09-03 09:38:04');
INSERT INTO `oauth2_refresh_token` VALUES ('9417222071d24f58b367b728ce381465', 27, 2, 1, '2019-06-02 03:27:33', '2019-06-01 15:27:32', '2019-06-01 15:27:32');
INSERT INTO `oauth2_refresh_token` VALUES ('94236051112044789e24bf092750c1a9', 27, 2, 1, '2019-08-16 05:23:38', '2019-08-15 17:23:38', '2019-08-15 17:23:38');
INSERT INTO `oauth2_refresh_token` VALUES ('9437cb167718400881357f9e5e3aa098', 27, 2, 1, '2019-08-21 09:09:59', '2019-08-20 21:09:58', '2019-08-20 21:09:58');
INSERT INTO `oauth2_refresh_token` VALUES ('944581c24a9e405cb8fbf550b08b682c', NULL, NULL, 1, '2019-05-06 11:26:32', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9447a69a384c422f9bef225cabf116f2', 27, 2, 1, '2019-07-07 22:57:41', '2019-07-07 10:57:40', '2019-07-07 10:57:40');
INSERT INTO `oauth2_refresh_token` VALUES ('944e986a683842f1a290b02fb4d5fb93', NULL, NULL, 1, '2019-05-11 01:46:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('94506a1681744a74bf7557e83f5ec420', 27, 2, 1, '2019-07-13 02:28:48', '2019-07-12 14:28:48', '2019-07-12 14:28:48');
INSERT INTO `oauth2_refresh_token` VALUES ('9456f67d399b4ca199e122549f8d6e6b', 27, 2, 1, '2019-08-09 03:02:24', '2019-08-08 15:02:23', '2019-08-08 15:02:23');
INSERT INTO `oauth2_refresh_token` VALUES ('9460dc886c964b6a874312c3d60dc752', 27, 2, 1, '2019-08-04 10:47:29', '2019-08-03 22:47:28', '2019-08-03 22:47:28');
INSERT INTO `oauth2_refresh_token` VALUES ('94623386b3cb4d7fbf5d55c84503ac66', 27, 2, 1, '2019-05-18 06:27:45', '2019-05-17 18:27:44', '2019-05-17 18:27:44');
INSERT INTO `oauth2_refresh_token` VALUES ('947e88ff64894dfe94b58b08e2799aa8', 27, 2, 1, '2019-05-29 05:26:44', '2019-05-28 17:26:43', '2019-05-28 17:26:43');
INSERT INTO `oauth2_refresh_token` VALUES ('94a0a5c1c5294d85869ac3553d4c4605', NULL, NULL, 1, '2019-04-23 06:44:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('94a20594d72244148cc71b8af251f1d7', 27, 2, 1, '2019-08-22 02:41:28', '2019-08-21 14:41:28', '2019-08-21 14:41:28');
INSERT INTO `oauth2_refresh_token` VALUES ('94b710042b9b40eb9c870045589d85eb', NULL, NULL, 1, '2019-04-23 06:34:29', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('94b8ab597abe4fe296f690c4d27ee6f4', 76, 1, 1, '2019-05-20 23:47:51', '2019-05-20 11:47:50', '2019-05-20 11:47:50');
INSERT INTO `oauth2_refresh_token` VALUES ('94bf4f4fcc844f658de2367f3d054ae5', 27, 2, 1, '2019-08-30 22:31:24', '2019-08-30 10:31:23', '2019-08-30 10:31:23');
INSERT INTO `oauth2_refresh_token` VALUES ('94f25351a93b4ddc88c835b8c65c7f2c', 27, 2, 1, '2019-06-03 21:28:05', '2019-06-03 09:28:04', '2019-06-03 09:28:04');
INSERT INTO `oauth2_refresh_token` VALUES ('94fd06496af7477d94ce513560b8b8b3', 27, 2, 1, '2019-05-19 05:59:51', '2019-05-18 17:59:50', '2019-05-18 17:59:50');
INSERT INTO `oauth2_refresh_token` VALUES ('950341f2031240789d6f7c129bd7972b', NULL, NULL, 1, '2019-04-25 10:04:51', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('950adf6d7a004a259a2dedf39930c3bb', 27, 2, 1, '2019-06-19 02:29:33', '2019-06-18 14:29:32', '2019-06-18 14:29:32');
INSERT INTO `oauth2_refresh_token` VALUES ('951557935b6c4cf988fc5fa2713b51fe', 27, 2, 1, '2019-06-14 06:35:01', '2019-06-13 18:35:00', '2019-06-13 18:35:00');
INSERT INTO `oauth2_refresh_token` VALUES ('95172191136e44c9a0d1c696fc4fee82', 27, 2, 1, '2019-06-07 01:45:48', '2019-06-06 13:45:48', '2019-06-06 13:45:48');
INSERT INTO `oauth2_refresh_token` VALUES ('953808a1f21f4850be36d994b0531e0d', 27, 2, 1, '2019-09-09 20:29:47', '2019-09-09 08:29:46', '2019-09-09 08:29:46');
INSERT INTO `oauth2_refresh_token` VALUES ('9549439f445140c4b340bb3e8a3d992a', 27, 2, 1, '2019-06-05 04:53:36', '2019-06-04 16:53:36', '2019-06-04 16:53:36');
INSERT INTO `oauth2_refresh_token` VALUES ('954c03bf529a45508c141b4052d6eaf5', 1, 2, 0, '2019-05-26 23:57:44', '2019-05-26 11:57:44', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('955d9775416c479985869c42ee6edd13', 27, 2, 1, '2019-07-04 04:22:04', '2019-07-03 16:22:03', '2019-07-03 16:22:03');
INSERT INTO `oauth2_refresh_token` VALUES ('957bd3e8da8c481b989300907ffee528', 27, 2, 1, '2019-08-15 09:02:38', '2019-08-14 21:02:37', '2019-08-14 21:02:37');
INSERT INTO `oauth2_refresh_token` VALUES ('9584d03f6d4649fc9f2924f2bdf31de9', NULL, NULL, 1, '2019-05-08 04:48:37', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('958b64476b9a4cbca6000b4a524cc119', 27, 2, 1, '2019-06-22 03:05:00', '2019-06-21 15:05:00', '2019-06-21 15:05:00');
INSERT INTO `oauth2_refresh_token` VALUES ('9593527e19de4ae2a146809247cf57c5', 1, 2, 0, '2019-06-21 22:26:48', '2019-06-21 10:26:47', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('95b48f14841b4a00a5228e787a073d57', NULL, NULL, 1, '2019-03-10 15:34:17', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('95bd8d8fa40443b2a69643ce5b6c7e91', 27, 2, 1, '2019-07-20 01:44:28', '2019-07-19 13:44:27', '2019-07-19 13:44:27');
INSERT INTO `oauth2_refresh_token` VALUES ('95c16668d8404edfb9b33b08a6527a17', 27, 2, 1, '2019-06-21 20:44:50', '2019-06-21 08:44:50', '2019-06-21 08:44:50');
INSERT INTO `oauth2_refresh_token` VALUES ('95d18155c87a418688c4f5388daf55ad', 27, 2, 1, '2019-06-05 02:23:57', '2019-06-04 14:23:57', '2019-06-04 14:23:57');
INSERT INTO `oauth2_refresh_token` VALUES ('95fbe95d14904ee89a83ddd47ee1ee08', NULL, NULL, 1, '2019-05-08 06:02:03', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('960f6157bf104643b395f10016a5a03c', 27, 2, 1, '2019-05-28 00:00:36', '2019-05-27 12:00:35', '2019-05-27 12:00:35');
INSERT INTO `oauth2_refresh_token` VALUES ('960fee6de63f4145b477f8eb0052e516', 27, 2, 1, '2019-07-02 23:00:57', '2019-07-02 11:00:56', '2019-07-02 11:00:56');
INSERT INTO `oauth2_refresh_token` VALUES ('9636c769538140149f268fe545c36dd6', 27, 2, 1, '2019-06-03 23:56:48', '2019-06-03 11:56:48', '2019-06-03 11:56:48');
INSERT INTO `oauth2_refresh_token` VALUES ('964b3fec63f34082b4bc34326db6007a', NULL, NULL, 1, '2019-04-05 03:28:52', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('96512b295fcc49caa13ddd79711d9c5c', 27, 2, 1, '2019-08-28 04:04:01', '2019-08-27 16:04:01', '2019-08-27 16:04:01');
INSERT INTO `oauth2_refresh_token` VALUES ('9667647a0adc411d9159649e0fc40887', 27, 2, 1, '2019-06-04 03:11:06', '2019-06-03 15:11:05', '2019-06-03 15:11:05');
INSERT INTO `oauth2_refresh_token` VALUES ('9669273acd6b46a2aaaf8e85de7d357e', 27, 2, 1, '2019-05-28 07:49:53', '2019-05-27 19:49:52', '2019-05-27 19:49:52');
INSERT INTO `oauth2_refresh_token` VALUES ('966ff7414e9943919867d4284fd64c8d', 27, 2, 1, '2019-06-24 10:26:36', '2019-06-23 22:26:35', '2019-06-23 22:26:35');
INSERT INTO `oauth2_refresh_token` VALUES ('9677b7d3221b4d9e92cd821e960063c8', 27, 2, 1, '2019-06-04 01:43:45', '2019-06-03 13:43:44', '2019-06-03 13:43:44');
INSERT INTO `oauth2_refresh_token` VALUES ('967d019ff7d647678f15912b9ccc1abe', 27, 2, 1, '2019-07-02 04:06:18', '2019-07-01 16:06:18', '2019-07-01 16:06:18');
INSERT INTO `oauth2_refresh_token` VALUES ('96889d39624f437aa304fc95e08e1668', 27, 2, 1, '2019-06-17 22:39:53', '2019-06-17 10:39:53', '2019-06-17 10:39:53');
INSERT INTO `oauth2_refresh_token` VALUES ('96f523ead86c488baf1d0c2dd6933389', 27, 2, 1, '2019-07-04 04:55:52', '2019-07-03 16:55:52', '2019-07-03 16:55:52');
INSERT INTO `oauth2_refresh_token` VALUES ('97025aad07e54edc932f8cf9df304f1b', 27, 2, 1, '2019-09-06 03:15:37', '2019-09-05 15:15:37', '2019-09-05 15:15:37');
INSERT INTO `oauth2_refresh_token` VALUES ('971e55ef22f14184831c4276ddaea009', 27, 2, 1, '2019-06-12 04:13:57', '2019-06-11 16:13:57', '2019-06-11 16:13:57');
INSERT INTO `oauth2_refresh_token` VALUES ('971f20efb73f4d08b7d67193e90ced9e', 27, 2, 1, '2019-06-16 01:27:22', '2019-06-15 13:27:21', '2019-06-15 13:27:21');
INSERT INTO `oauth2_refresh_token` VALUES ('971f588c713e4b2aa435f1a72388a6aa', NULL, NULL, 1, '2019-04-23 06:44:08', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9730ded7920440ca952a57508fda4fc7', 27, 2, 1, '2019-05-23 02:38:05', '2019-05-22 14:38:05', '2019-05-22 14:38:05');
INSERT INTO `oauth2_refresh_token` VALUES ('9735d23edac54675bec32932f58f4128', 27, 2, 1, '2019-07-01 11:17:47', '2019-06-30 23:17:46', '2019-06-30 23:17:46');
INSERT INTO `oauth2_refresh_token` VALUES ('973b4e7933dd4997b947d4a9867d9899', 27, 2, 1, '2019-06-15 03:06:29', '2019-06-14 15:06:28', '2019-06-14 15:06:28');
INSERT INTO `oauth2_refresh_token` VALUES ('973fc25e4c70488787b182676d7cfe0b', 27, 2, 1, '2019-07-08 20:35:15', '2019-07-08 08:35:15', '2019-07-08 08:35:15');
INSERT INTO `oauth2_refresh_token` VALUES ('974836dc2c704f0eafb16bc7f8d65333', 27, 2, 1, '2019-06-02 22:33:05', '2019-06-02 10:33:04', '2019-06-02 10:33:04');
INSERT INTO `oauth2_refresh_token` VALUES ('9758002ef92b44d9812dd1e1958dcaa9', 27, 2, 1, '2019-06-06 07:37:06', '2019-06-05 19:37:06', '2019-06-05 19:37:06');
INSERT INTO `oauth2_refresh_token` VALUES ('9764e9a34d64423f8af66f09b4f24cf7', 27, 2, 1, '2019-08-28 04:43:05', '2019-08-27 16:43:05', '2019-08-27 16:43:05');
INSERT INTO `oauth2_refresh_token` VALUES ('97a81b46cc614518b1733badf7e85dac', NULL, NULL, 1, '2019-05-14 01:41:57', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('97ac51bd647d41f0b12daa40b728a5e8', 27, 2, 1, '2019-06-24 02:28:17', '2019-06-23 14:28:16', '2019-06-23 14:28:16');
INSERT INTO `oauth2_refresh_token` VALUES ('97afa1a4f1d04cd897841a6dc50cbcde', NULL, NULL, 1, '2019-05-07 03:42:15', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('97bad996f74e451d903db5f0ddc3d04d', 27, 2, 1, '2019-07-22 05:32:56', '2019-07-21 17:32:56', '2019-07-21 17:32:56');
INSERT INTO `oauth2_refresh_token` VALUES ('97c644e1e7de4fe48c5fe5da943ebd3c', 27, 2, 1, '2019-05-24 01:32:48', '2019-05-23 13:32:48', '2019-05-23 13:32:48');
INSERT INTO `oauth2_refresh_token` VALUES ('97cc87c6786f46e4a31a2bb794ece753', NULL, NULL, 1, '2019-03-22 12:31:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('97d0ed44db73410c9324e6e05901f16a', 27, 2, 1, '2019-07-06 03:24:10', '2019-07-05 15:24:09', '2019-07-05 15:24:09');
INSERT INTO `oauth2_refresh_token` VALUES ('97d0ee0026b442b99a4dcd34435cd593', 27, 2, 1, '2019-08-29 10:14:06', '2019-08-28 22:14:06', '2019-08-28 22:14:06');
INSERT INTO `oauth2_refresh_token` VALUES ('97d14581e3cb4270a504dfa9d9fc9e20', 127, 1, 1, '2019-06-20 02:30:45', '2019-06-19 14:30:44', '2019-06-19 14:30:44');
INSERT INTO `oauth2_refresh_token` VALUES ('97d1e11b29c7458498a823be63f05482', 1, 1, 1, '2019-05-18 05:47:30', '2019-05-17 17:47:30', '2019-05-17 17:47:30');
INSERT INTO `oauth2_refresh_token` VALUES ('97e1e05edced45d9a9e6ac98ab9e2406', 27, 2, 1, '2019-06-26 05:45:55', '2019-06-25 17:45:55', '2019-06-25 17:45:55');
INSERT INTO `oauth2_refresh_token` VALUES ('97e49df20ea948eba80dfcef5b8e6be9', NULL, NULL, 1, '2019-05-06 10:49:07', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('97f71d12a23f4182a476e7be24d4935a', 27, 2, 1, '2019-06-21 02:08:53', '2019-06-20 14:08:53', '2019-06-20 14:08:53');
INSERT INTO `oauth2_refresh_token` VALUES ('97faa7e5823749829fff66f6b287e085', 27, 2, 1, '2019-07-24 10:16:56', '2019-07-23 22:16:55', '2019-07-23 22:16:55');
INSERT INTO `oauth2_refresh_token` VALUES ('983795b5cc834c50a9a0a839773b9e0d', NULL, NULL, 1, '2019-05-06 02:29:42', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9839a2038f4d46b1b97af5b034857c9f', 74, 1, 1, '2019-05-30 22:02:03', '2019-05-30 10:02:03', '2019-05-30 10:02:03');
INSERT INTO `oauth2_refresh_token` VALUES ('985672546f51453892d527f424b99f5c', 209, 1, 1, '2019-08-21 07:15:43', '2019-08-20 19:15:43', '2019-08-20 19:15:43');
INSERT INTO `oauth2_refresh_token` VALUES ('985ada91c2cc48608a4cf53e96baf4bb', 27, 2, 1, '2019-06-15 22:49:25', '2019-06-15 10:49:25', '2019-06-15 10:49:25');
INSERT INTO `oauth2_refresh_token` VALUES ('985b32b4c1094811aa1265e8dc85c414', 27, 2, 1, '2019-06-04 04:01:58', '2019-06-03 16:01:57', '2019-06-03 16:01:57');
INSERT INTO `oauth2_refresh_token` VALUES ('986e7e9d1a87416ba67af3e3f5d61e54', 27, 2, 1, '2019-07-04 03:50:09', '2019-07-03 15:50:09', '2019-07-03 15:50:09');
INSERT INTO `oauth2_refresh_token` VALUES ('9872d744317c4453877c8b673c6772a2', 27, 2, 1, '2019-05-21 21:45:30', '2019-05-21 09:45:29', '2019-05-21 09:45:29');
INSERT INTO `oauth2_refresh_token` VALUES ('989536df91664c6ca9264b64c1c28245', 27, 2, 1, '2019-06-02 03:53:51', '2019-06-01 15:53:51', '2019-06-01 15:53:51');
INSERT INTO `oauth2_refresh_token` VALUES ('98aa3d03f0664a99a6330024414cf071', 27, 2, 1, '2019-05-21 02:07:22', '2019-05-20 14:07:22', '2019-05-20 14:07:22');
INSERT INTO `oauth2_refresh_token` VALUES ('98d30edbd4584062b384f45497e82e44', 185, 1, 1, '2019-07-31 22:41:00', '2019-07-31 10:41:00', '2019-07-31 10:41:00');
INSERT INTO `oauth2_refresh_token` VALUES ('98e66869e2bf4f1db29dee6b1809f149', 27, 2, 1, '2019-05-21 09:47:17', '2019-05-20 21:47:17', '2019-05-20 21:47:17');
INSERT INTO `oauth2_refresh_token` VALUES ('990df4bb9513415a923a95f2baa6ea07', 27, 2, 1, '2019-07-01 09:11:57', '2019-06-30 21:11:56', '2019-06-30 21:11:56');
INSERT INTO `oauth2_refresh_token` VALUES ('990e4595d09e42fca6c466e6c44a133e', 27, 2, 1, '2019-05-28 23:16:04', '2019-05-28 11:16:04', '2019-05-28 11:16:04');
INSERT INTO `oauth2_refresh_token` VALUES ('9918ad4d161c4640b085725bf72d837a', 115, 1, 1, '2019-06-10 08:15:18', '2019-06-09 20:15:17', '2019-06-09 20:15:17');
INSERT INTO `oauth2_refresh_token` VALUES ('993cd8c1517d495f80dd83d1025db99e', 1, 2, 0, '2019-05-19 00:59:00', '2019-05-18 12:59:00', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('994bae82ae944ae1ba5f23b2018138fe', NULL, NULL, 1, '2019-03-10 22:09:25', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('99547e27385148479ad6b6db51fc9d54', 27, 2, 1, '2019-08-30 10:09:37', '2019-08-29 22:09:37', '2019-08-29 22:09:37');
INSERT INTO `oauth2_refresh_token` VALUES ('9964c1c4d7354965ab80f62bf59750ad', 27, 2, 1, '2019-06-25 20:50:09', '2019-06-25 08:50:08', '2019-06-25 08:50:08');
INSERT INTO `oauth2_refresh_token` VALUES ('998179741da5460f856f175c9f329af1', 27, 2, 1, '2019-06-01 12:24:37', '2019-06-01 00:24:37', '2019-06-01 00:24:37');
INSERT INTO `oauth2_refresh_token` VALUES ('9987db62e5d64b2cbc0a3419f2ae2a3a', 27, 2, 1, '2019-05-24 07:47:29', '2019-05-23 19:47:28', '2019-05-23 19:47:28');
INSERT INTO `oauth2_refresh_token` VALUES ('998914fceb8e467099cae7015ebb6441', 27, 2, 1, '2019-07-24 09:18:05', '2019-07-23 21:18:04', '2019-07-23 21:18:04');
INSERT INTO `oauth2_refresh_token` VALUES ('998b63729f04415fa82ec3b7a69630b8', NULL, NULL, 1, '2019-05-08 23:41:09', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('99990a0da40a4455882cae5f87294b13', 27, 2, 1, '2019-07-18 08:37:54', '2019-07-17 20:37:53', '2019-07-17 20:37:53');
INSERT INTO `oauth2_refresh_token` VALUES ('999a2ebe3faa49f8a335eeb2e154d460', 27, 2, 1, '2019-06-06 02:06:36', '2019-06-05 14:06:35', '2019-06-05 14:06:35');
INSERT INTO `oauth2_refresh_token` VALUES ('99b325a68e4d4c77a6d4b81d1dc6a973', 1, 2, 0, '2019-06-04 01:56:06', '2019-06-03 13:56:06', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('99c88191457a4e26bc2bffe0ddcd310c', 27, 2, 1, '2019-06-03 09:51:44', '2019-06-02 21:51:43', '2019-06-02 21:51:43');
INSERT INTO `oauth2_refresh_token` VALUES ('99f042cc852e42eeb7be5eebcbfd3a16', 1, 2, 0, '2019-07-16 07:51:25', '2019-07-15 19:51:24', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('99faca6f90a54f87a47b6848add767ce', NULL, NULL, 1, '2019-04-02 21:47:07', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9a0a90ee15814f5380eccdde31ecbfa5', 27, 2, 1, '2019-08-14 01:46:05', '2019-08-13 13:46:05', '2019-08-13 13:46:05');
INSERT INTO `oauth2_refresh_token` VALUES ('9a1163f6eced4f9ea3721b71a9b9b3ac', NULL, NULL, 0, '2019-03-06 18:17:40', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9a594759a2ec4fca8e16c40917c4a942', 27, 2, 1, '2019-06-22 02:40:12', '2019-06-21 14:40:11', '2019-06-21 14:40:11');
INSERT INTO `oauth2_refresh_token` VALUES ('9a5b5d6707f94dc7a9cbd4bb2fc79fc1', 184, 1, 1, '2019-07-31 10:30:36', '2019-07-30 22:30:36', '2019-07-30 22:30:36');
INSERT INTO `oauth2_refresh_token` VALUES ('9a6d4a432c0f4e6bbca0d32bb52aae5a', NULL, NULL, 1, '2019-03-31 08:58:10', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9a98c7f40f5e4b1596648115b16e34a3', 27, 2, 1, '2019-06-04 01:54:09', '2019-06-03 13:54:08', '2019-06-03 13:54:08');
INSERT INTO `oauth2_refresh_token` VALUES ('9aa3ae6635bd42fa95303b13c0335db1', 141, 1, 1, '2019-06-27 02:55:31', '2019-06-26 14:55:30', '2019-06-26 14:55:30');
INSERT INTO `oauth2_refresh_token` VALUES ('9aa49276ddda49a5a12953ff0738b67e', 27, 2, 1, '2019-06-07 10:25:06', '2019-06-06 22:25:05', '2019-06-06 22:25:05');
INSERT INTO `oauth2_refresh_token` VALUES ('9aa5658052a543a9a77e2a183b6da3d3', 27, 2, 1, '2019-06-15 03:55:58', '2019-06-14 15:55:58', '2019-06-14 15:55:58');
INSERT INTO `oauth2_refresh_token` VALUES ('9ac5bde5545d453e9fbbae6169059712', 27, 2, 1, '2019-06-06 22:56:21', '2019-06-06 10:56:20', '2019-06-06 10:56:20');
INSERT INTO `oauth2_refresh_token` VALUES ('9acdf618749c4c73a7baadd6e0686808', 27, 2, 1, '2019-06-12 03:01:58', '2019-06-11 15:01:57', '2019-06-11 15:01:57');
INSERT INTO `oauth2_refresh_token` VALUES ('9aeada4f8f7d448dac8fc6ff3ce700ca', 27, 2, 1, '2019-07-04 21:34:19', '2019-07-04 09:34:19', '2019-07-04 09:34:19');
INSERT INTO `oauth2_refresh_token` VALUES ('9b0339e401694645b04b5291482dfc5d', 27, 2, 1, '2019-07-04 21:20:55', '2019-07-04 09:20:54', '2019-07-04 09:20:54');
INSERT INTO `oauth2_refresh_token` VALUES ('9b0958f2727e44668497849610415d1d', 27, 2, 1, '2019-05-25 04:57:59', '2019-05-24 16:57:59', '2019-05-24 16:57:59');
INSERT INTO `oauth2_refresh_token` VALUES ('9b32c289900a431e9a1e4642b5bc908b', 27, 2, 1, '2019-07-10 08:45:45', '2019-07-09 20:45:44', '2019-07-09 20:45:44');
INSERT INTO `oauth2_refresh_token` VALUES ('9b353a7680df4a148fa8035d06b73d56', 27, 2, 1, '2019-08-03 05:05:07', '2019-08-02 17:05:07', '2019-08-02 17:05:07');
INSERT INTO `oauth2_refresh_token` VALUES ('9b36368042e0428aa7f27d878e382239', NULL, NULL, 1, '2019-05-09 04:43:09', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9b386fe97a1d432b8cf4f790930885f4', 27, 2, 1, '2019-06-24 04:13:47', '2019-06-23 16:13:46', '2019-06-23 16:13:46');
INSERT INTO `oauth2_refresh_token` VALUES ('9b3c6925301e46acaa5b757aa9826e88', 27, 2, 1, '2019-05-28 22:55:53', '2019-05-28 10:55:52', '2019-05-28 10:55:52');
INSERT INTO `oauth2_refresh_token` VALUES ('9b46c3a5f2344917a149975880b19912', 27, 2, 1, '2019-06-27 08:52:21', '2019-06-26 20:52:21', '2019-06-26 20:52:21');
INSERT INTO `oauth2_refresh_token` VALUES ('9b53c143ff3749aba3d730032702d308', 27, 2, 1, '2019-06-21 04:48:28', '2019-06-20 16:48:28', '2019-06-20 16:48:28');
INSERT INTO `oauth2_refresh_token` VALUES ('9b9fa17ab2d142c0936f4928a3854504', NULL, NULL, 1, '2019-04-29 01:58:49', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9bae9e30ba1d40449379cef52b746801', 27, 2, 1, '2019-07-30 05:21:36', '2019-07-29 17:21:36', '2019-07-29 17:21:36');
INSERT INTO `oauth2_refresh_token` VALUES ('9bb8a15b957f4c288ecad2ba2c21686d', 27, 2, 1, '2019-07-07 06:25:50', '2019-07-06 18:25:49', '2019-07-06 18:25:49');
INSERT INTO `oauth2_refresh_token` VALUES ('9bbb7f0203064ee1a39eb1521063024f', 27, 2, 1, '2019-06-04 09:10:24', '2019-06-03 21:10:24', '2019-06-03 21:10:24');
INSERT INTO `oauth2_refresh_token` VALUES ('9bbf64d1e9874056a44059d7bff45081', NULL, NULL, 1, '2019-04-26 05:03:38', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9be30425e2ec4c83aabb3f8da98c12f7', NULL, NULL, 1, '2019-05-12 04:57:05', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9bf2abfa1ec8466da463b959adcb3ed1', 27, 2, 1, '2019-06-10 22:39:51', '2019-06-10 10:39:50', '2019-06-10 10:39:50');
INSERT INTO `oauth2_refresh_token` VALUES ('9bfa38bb0b3043ea8af918f333733c5f', 27, 2, 1, '2019-07-02 05:54:11', '2019-07-01 17:54:10', '2019-07-01 17:54:10');
INSERT INTO `oauth2_refresh_token` VALUES ('9c27ebe299fc46d09f864d87aa30bbb4', NULL, NULL, 1, '2019-04-30 00:57:07', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9c2d14ff193e43a5adaefdccfb730435', 192, 1, 1, '2019-08-06 01:29:43', '2019-08-05 13:29:42', '2019-08-05 13:29:42');
INSERT INTO `oauth2_refresh_token` VALUES ('9c3d1888ac9a4c91b9548561cf5b2fad', 27, 2, 1, '2019-06-28 21:35:30', '2019-06-28 09:35:29', '2019-06-28 09:35:29');
INSERT INTO `oauth2_refresh_token` VALUES ('9c63419b82324d75a20617b7b1e3bd45', 27, 2, 1, '2019-07-05 09:17:29', '2019-07-04 21:17:29', '2019-07-04 21:17:29');
INSERT INTO `oauth2_refresh_token` VALUES ('9c67a3d54ab048609bb37840d108d7d8', NULL, NULL, 1, '2019-05-07 05:33:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9c692fb67a964661a0ea3bbc4ecbf723', 27, 2, 1, '2019-08-01 23:16:58', '2019-08-01 11:16:58', '2019-08-01 11:16:58');
INSERT INTO `oauth2_refresh_token` VALUES ('9c99a4a7dfca4dde8fba2a1c9416b176', 27, 2, 1, '2019-05-26 12:09:25', '2019-05-26 00:09:25', '2019-05-26 00:09:25');
INSERT INTO `oauth2_refresh_token` VALUES ('9c99d6bef5e244a7b7b2874060197dce', NULL, NULL, 1, '2019-05-02 22:41:10', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9c9abb4f2c4844b49849137c44be39d7', 27, 2, 1, '2019-06-21 00:33:04', '2019-06-20 12:33:04', '2019-06-20 12:33:04');
INSERT INTO `oauth2_refresh_token` VALUES ('9cb199038b2b4959847d962fb21e5311', 27, 2, 1, '2019-07-15 23:07:09', '2019-07-15 11:07:08', '2019-07-15 11:07:08');
INSERT INTO `oauth2_refresh_token` VALUES ('9cb896d84591427fac7e5262b4191238', 27, 2, 1, '2019-06-04 03:26:45', '2019-06-03 15:26:45', '2019-06-03 15:26:45');
INSERT INTO `oauth2_refresh_token` VALUES ('9cc0adfaba4a4d04a49581407ce36f6e', NULL, NULL, 1, '2019-05-07 03:05:21', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9cc82cbba4c64acf9003fc6cb1f951f1', 27, 2, 1, '2019-09-06 09:40:15', '2019-09-05 21:40:15', '2019-09-05 21:40:15');
INSERT INTO `oauth2_refresh_token` VALUES ('9cd4f90d3e2b44eaa2f488ec34b07236', 27, 2, 1, '2019-07-11 05:49:27', '2019-07-10 17:49:26', '2019-07-10 17:49:26');
INSERT INTO `oauth2_refresh_token` VALUES ('9d0fbb903b504e318cdcde926acfe418', 27, 2, 1, '2019-08-17 03:47:39', '2019-08-16 15:47:39', '2019-08-16 15:47:39');
INSERT INTO `oauth2_refresh_token` VALUES ('9d1eb44ffc1c44d2a6f429f6d95c4614', 27, 2, 1, '2019-06-25 02:41:26', '2019-06-24 14:41:26', '2019-06-24 14:41:26');
INSERT INTO `oauth2_refresh_token` VALUES ('9d1f70f432434b6aaf32f85456f436d1', 27, 2, 1, '2019-06-10 21:56:41', '2019-06-10 09:56:41', '2019-06-10 09:56:41');
INSERT INTO `oauth2_refresh_token` VALUES ('9d4a4d62d5f440b89a57d4bf46d3afb3', 27, 2, 1, '2019-05-21 08:01:31', '2019-05-20 20:01:30', '2019-05-20 20:01:30');
INSERT INTO `oauth2_refresh_token` VALUES ('9d8b3dc0967940d890821a5ea5603ca9', 27, 2, 1, '2019-07-13 12:11:56', '2019-07-13 00:11:55', '2019-07-13 00:11:55');
INSERT INTO `oauth2_refresh_token` VALUES ('9d9e8909e76541f986d2be044771348e', 27, 2, 1, '2019-07-04 04:26:42', '2019-07-03 16:26:41', '2019-07-03 16:26:41');
INSERT INTO `oauth2_refresh_token` VALUES ('9daa1610023745d9abbd197af5cc93b0', 27, 2, 1, '2019-06-19 22:10:36', '2019-06-19 10:10:35', '2019-06-19 10:10:35');
INSERT INTO `oauth2_refresh_token` VALUES ('9db4969b6c8b4d80bf59d0ab12f43ab8', 27, 2, 1, '2019-06-21 02:03:05', '2019-06-20 14:03:05', '2019-06-20 14:03:05');
INSERT INTO `oauth2_refresh_token` VALUES ('9dbca05d30824da7864ccf2dd640f62c', 27, 2, 1, '2019-07-14 05:24:32', '2019-07-13 17:24:31', '2019-07-13 17:24:31');
INSERT INTO `oauth2_refresh_token` VALUES ('9dc2ce724cbf44229163dbcebfa4134a', 27, 2, 1, '2019-06-22 07:35:09', '2019-06-21 19:35:08', '2019-06-21 19:35:08');
INSERT INTO `oauth2_refresh_token` VALUES ('9dc5ed7aac074201a6bf5d6d9df170ae', 27, 2, 1, '2019-09-08 22:48:33', '2019-09-08 10:48:33', '2019-09-08 10:48:33');
INSERT INTO `oauth2_refresh_token` VALUES ('9dd36a3c5d44486ab6e98c03eb5d6c71', 27, 2, 1, '2019-06-01 12:48:40', '2019-06-01 00:48:39', '2019-06-01 00:48:39');
INSERT INTO `oauth2_refresh_token` VALUES ('9dda4b286a7f4470a5beed4e19936463', 27, 2, 1, '2019-06-12 01:58:59', '2019-06-11 13:58:59', '2019-06-11 13:58:59');
INSERT INTO `oauth2_refresh_token` VALUES ('9de0e8a8623e40ed9f9acf5297b120f3', 27, 2, 1, '2019-06-02 07:42:12', '2019-06-01 19:42:12', '2019-06-01 19:42:12');
INSERT INTO `oauth2_refresh_token` VALUES ('9e082530a14243a7a5f55dbd3fdee00b', 27, 2, 1, '2019-06-27 00:05:25', '2019-06-26 12:05:24', '2019-06-26 12:05:24');
INSERT INTO `oauth2_refresh_token` VALUES ('9e0d21cd1a3741d593a150efe812fa4b', 27, 2, 1, '2019-05-24 01:32:38', '2019-05-23 13:32:38', '2019-05-23 13:32:38');
INSERT INTO `oauth2_refresh_token` VALUES ('9e28a3783b7c4c53a3e4a2fd7596fff8', 27, 2, 1, '2019-05-23 04:43:24', '2019-05-22 16:43:24', '2019-05-22 16:43:24');
INSERT INTO `oauth2_refresh_token` VALUES ('9e3f30fd2108451286fde130083f5fe1', 27, 2, 1, '2019-06-04 01:56:24', '2019-06-03 13:56:23', '2019-06-03 13:56:23');
INSERT INTO `oauth2_refresh_token` VALUES ('9e49f58e55974ee48c359d3f50bbf7d3', 149, 1, 1, '2019-07-02 22:09:14', '2019-07-02 10:09:14', '2019-07-02 10:09:14');
INSERT INTO `oauth2_refresh_token` VALUES ('9e4cd6193b814b3a86ba5d2e30b79c53', NULL, NULL, 0, '2019-02-28 21:59:33', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9e66ac64ebf64d20853413c73e372e92', 27, 2, 1, '2019-07-17 21:05:37', '2019-07-17 09:05:36', '2019-07-17 09:05:36');
INSERT INTO `oauth2_refresh_token` VALUES ('9e66ec6a95b74121bde3097b95b2b16f', 27, 2, 1, '2019-08-27 11:15:19', '2019-08-26 23:15:18', '2019-08-26 23:15:18');
INSERT INTO `oauth2_refresh_token` VALUES ('9e847011a5574697b661bdc61089ddbe', 27, 2, 1, '2019-07-04 08:42:13', '2019-07-03 20:42:12', '2019-07-03 20:42:12');
INSERT INTO `oauth2_refresh_token` VALUES ('9e86038cda9d4f2d9cdc93581ab5e2b5', 27, 2, 1, '2019-08-06 05:20:28', '2019-08-05 17:20:27', '2019-08-05 17:20:27');
INSERT INTO `oauth2_refresh_token` VALUES ('9e8a8fec3bc1405b852cf1ec4a130f08', 27, 2, 1, '2019-06-24 01:21:13', '2019-06-23 13:21:12', '2019-06-23 13:21:12');
INSERT INTO `oauth2_refresh_token` VALUES ('9ea6927d931448ff9b9de491505b38d9', 27, 2, 1, '2019-06-12 03:55:55', '2019-06-11 15:55:54', '2019-06-11 15:55:54');
INSERT INTO `oauth2_refresh_token` VALUES ('9eae67fd0bbf41c2a2a7e2e91ebd9177', 27, 2, 1, '2019-06-26 06:31:24', '2019-06-25 18:31:24', '2019-06-25 18:31:24');
INSERT INTO `oauth2_refresh_token` VALUES ('9eb91b10a8c241fd9f791c767b2c8d55', 27, 2, 1, '2019-06-07 21:49:27', '2019-06-07 09:49:26', '2019-06-07 09:49:26');
INSERT INTO `oauth2_refresh_token` VALUES ('9eb9ba7913e640959513ffbd72f5b937', 27, 2, 1, '2019-06-26 21:56:30', '2019-06-26 09:56:29', '2019-06-26 09:56:29');
INSERT INTO `oauth2_refresh_token` VALUES ('9ebea079f16545f3a50889263351297d', NULL, NULL, 1, '2019-05-10 08:47:12', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9ec48259416e49ebb09be59514403c9a', 27, 2, 1, '2019-07-03 23:38:05', '2019-07-03 11:38:04', '2019-07-03 11:38:04');
INSERT INTO `oauth2_refresh_token` VALUES ('9ec4c59916e24b00927bc36b8ccbd659', 27, 2, 1, '2019-06-05 02:15:39', '2019-06-04 14:15:38', '2019-06-04 14:15:38');
INSERT INTO `oauth2_refresh_token` VALUES ('9ed2adca400b4347bbefd10834be9d7a', 27, 2, 1, '2019-09-04 22:08:42', '2019-09-04 10:08:42', '2019-09-04 10:08:42');
INSERT INTO `oauth2_refresh_token` VALUES ('9ed4d95eeb254ebab5f860d30b8b7154', 158, 1, 1, '2019-07-06 23:32:23', '2019-07-06 11:32:23', '2019-07-06 11:32:23');
INSERT INTO `oauth2_refresh_token` VALUES ('9eeb52c8eddf4941b9159eb17122d603', 1, 2, 0, '2019-06-14 04:47:09', '2019-06-13 16:47:08', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('9ef874708f1845c699a844d32070d799', NULL, NULL, 1, '2019-05-08 12:12:01', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9f00df127f9d441eb54085c58b465334', 27, 2, 1, '2019-06-02 01:17:08', '2019-06-01 13:17:07', '2019-06-01 13:17:07');
INSERT INTO `oauth2_refresh_token` VALUES ('9f07724af4fd4ef192b64f2f9677ce73', 27, 2, 1, '2019-06-03 02:38:24', '2019-06-02 14:38:23', '2019-06-02 14:38:23');
INSERT INTO `oauth2_refresh_token` VALUES ('9f1fe1bcd5c94941afabc5bc76e06d61', 1, 2, 0, '2019-05-30 11:08:32', '2019-05-29 23:08:32', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('9f2424ad94cb4aeeafc355944bb7c535', 27, 2, 1, '2019-06-15 22:02:22', '2019-06-15 10:02:21', '2019-06-15 10:02:21');
INSERT INTO `oauth2_refresh_token` VALUES ('9f26de03c4814b73ab3c400cf3a00779', 27, 2, 1, '2019-07-07 19:27:56', '2019-07-07 07:27:55', '2019-07-07 07:27:55');
INSERT INTO `oauth2_refresh_token` VALUES ('9f35db0e118a42b8bd95f11273c1c277', NULL, NULL, 1, '2019-05-01 09:28:52', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9f3e30c0a6a74892af5f965c65f0084a', NULL, NULL, 1, '2019-05-03 12:53:20', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9f65e925f1a8493aa60db5bbf78b094f', 27, 2, 1, '2019-07-18 01:58:23', '2019-07-17 13:58:22', '2019-07-17 13:58:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9f6b8c27783b4e8a8cd5ec0144bbfe72', NULL, NULL, 1, '2019-04-25 05:19:19', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9f781890daf349f2951e4602f2e54296', 27, 2, 1, '2019-06-06 23:55:06', '2019-06-06 11:55:05', '2019-06-06 11:55:05');
INSERT INTO `oauth2_refresh_token` VALUES ('9fd5e0f2086f406a98b48a5dc3ea34b1', NULL, NULL, 1, '2019-05-14 00:37:06', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('9fe30d6440574c0391e1e71133c981fc', 1, 2, 0, '2019-06-01 07:50:56', '2019-05-31 19:50:56', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('9fe7fa2890934fcd9276d5ae2023ff42', 27, 2, 1, '2019-06-01 09:14:14', '2019-05-31 21:14:14', '2019-05-31 21:14:14');
INSERT INTO `oauth2_refresh_token` VALUES ('a02b3959b28340feb6d3444a33ef55b5', 27, 2, 1, '2019-06-01 05:23:55', '2019-05-31 17:23:54', '2019-05-31 17:23:54');
INSERT INTO `oauth2_refresh_token` VALUES ('a0433fb5c9e4488987c2494f19e1d23c', 27, 2, 1, '2019-07-09 23:04:55', '2019-07-09 11:04:55', '2019-07-09 11:04:55');
INSERT INTO `oauth2_refresh_token` VALUES ('a04e690312ef49f48466545f9ec46a29', 27, 2, 1, '2019-07-15 23:25:34', '2019-07-15 11:25:34', '2019-07-15 11:25:34');
INSERT INTO `oauth2_refresh_token` VALUES ('a05431a92f384889b47418ee8c742c4c', 27, 2, 1, '2019-06-18 03:34:02', '2019-06-17 15:34:01', '2019-06-17 15:34:01');
INSERT INTO `oauth2_refresh_token` VALUES ('a06ca1c058f84886ae70d13261a4e7e4', 27, 2, 1, '2019-06-01 09:08:31', '2019-05-31 21:08:30', '2019-05-31 21:08:30');
INSERT INTO `oauth2_refresh_token` VALUES ('a084c83324e54d728d232ad8af1aac80', 27, 2, 1, '2019-07-30 08:52:28', '2019-07-29 20:52:27', '2019-07-29 20:52:27');
INSERT INTO `oauth2_refresh_token` VALUES ('a0bb1538d3a247ab98175a854f2e0790', 30, 1, 1, '2019-07-09 05:22:10', '2019-07-08 17:22:09', '2019-07-08 17:22:09');
INSERT INTO `oauth2_refresh_token` VALUES ('a0bdbc5d990042cfaac3f40ed9459799', 27, 2, 1, '2019-07-04 23:58:29', '2019-07-04 11:58:29', '2019-07-04 11:58:29');
INSERT INTO `oauth2_refresh_token` VALUES ('a0c0b2021c094fd88fa401e609b00c85', 27, 2, 1, '2019-07-03 01:51:02', '2019-07-02 13:51:01', '2019-07-02 13:51:01');
INSERT INTO `oauth2_refresh_token` VALUES ('a0eee55db8d8418bbecf8a37067e17ce', 27, 2, 1, '2019-06-18 02:15:21', '2019-06-17 14:15:20', '2019-06-17 14:15:20');
INSERT INTO `oauth2_refresh_token` VALUES ('a12624fe4ef64838901934ca085db5e6', 27, 2, 1, '2019-08-09 22:44:02', '2019-08-09 10:44:02', '2019-08-09 10:44:02');
INSERT INTO `oauth2_refresh_token` VALUES ('a12e101bbc6b4ce4820a2858a5cd0e32', 27, 2, 1, '2019-07-03 04:25:04', '2019-07-02 16:25:04', '2019-07-02 16:25:04');
INSERT INTO `oauth2_refresh_token` VALUES ('a14210e574ce4717af5950f4af880f5c', 27, 2, 1, '2019-07-05 07:27:20', '2019-07-04 19:27:20', '2019-07-04 19:27:20');
INSERT INTO `oauth2_refresh_token` VALUES ('a14fe853483748019f909b0e5cbd6fa7', 27, 2, 1, '2019-06-01 06:07:31', '2019-05-31 18:07:30', '2019-05-31 18:07:30');
INSERT INTO `oauth2_refresh_token` VALUES ('a1580a70624a41d9b2b008883e8462fb', NULL, NULL, 1, '2019-05-05 21:12:29', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a17aeb8847d041d983c427883e601969', 27, 2, 1, '2019-08-09 12:01:43', '2019-08-09 00:01:43', '2019-08-09 00:01:43');
INSERT INTO `oauth2_refresh_token` VALUES ('a185ed24dbf147848f4a6266dd0d5486', NULL, NULL, 1, '2019-05-13 11:46:40', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a1879903eaab4acea187c0753883fd26', NULL, NULL, 1, '2019-05-10 10:16:17', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a195a9298cc3475183ef7e426c1bc362', 27, 2, 1, '2019-07-06 02:53:32', '2019-07-05 14:53:32', '2019-07-05 14:53:32');
INSERT INTO `oauth2_refresh_token` VALUES ('a1a53cf36b70449fa60379fd11889e97', 27, 2, 1, '2019-08-21 21:26:01', '2019-08-21 09:26:00', '2019-08-21 09:26:00');
INSERT INTO `oauth2_refresh_token` VALUES ('a1b83a379380420995cdb6f3bc062912', NULL, NULL, 1, '2019-03-13 10:18:30', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a1bc1fc667424f09892463137d60e9e7', 27, 2, 1, '2019-06-25 08:06:49', '2019-06-24 20:06:48', '2019-06-24 20:06:48');
INSERT INTO `oauth2_refresh_token` VALUES ('a1c21c0ab6954c8799e338fd20f5e02a', 27, 2, 1, '2019-08-16 22:05:48', '2019-08-16 10:05:47', '2019-08-16 10:05:47');
INSERT INTO `oauth2_refresh_token` VALUES ('a1c7ec710d0942a2b4646496967b8c01', 27, 2, 1, '2019-08-28 07:11:25', '2019-08-27 19:11:24', '2019-08-27 19:11:24');
INSERT INTO `oauth2_refresh_token` VALUES ('a1d149fe8a8f485e9aa553ffa31ea691', 27, 2, 1, '2019-06-26 23:02:04', '2019-06-26 11:02:03', '2019-06-26 11:02:03');
INSERT INTO `oauth2_refresh_token` VALUES ('a1d844480ee646a3aa7fb264cf2336eb', NULL, NULL, 1, '2019-04-05 22:25:37', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a1dbeac5a6e841c3a1af959973cd9592', 27, 2, 1, '2019-07-19 22:50:49', '2019-07-19 10:50:49', '2019-07-19 10:50:49');
INSERT INTO `oauth2_refresh_token` VALUES ('a1e17a525a05484e8193785efae25e37', 27, 2, 1, '2019-08-27 23:23:36', '2019-08-27 11:23:36', '2019-08-27 11:23:36');
INSERT INTO `oauth2_refresh_token` VALUES ('a1f55ec136a746fe8195e8aacbabb8cc', 27, 2, 1, '2019-07-09 03:40:54', '2019-07-08 15:40:53', '2019-07-08 15:40:53');
INSERT INTO `oauth2_refresh_token` VALUES ('a1f7856e95b94d678da95937a2b8614b', 27, 2, 1, '2019-06-03 20:41:21', '2019-06-03 08:41:21', '2019-06-03 08:41:21');
INSERT INTO `oauth2_refresh_token` VALUES ('a20434a6474e493ab3771d49deb6ad04', NULL, NULL, 1, '2019-03-21 10:27:49', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a2185edc2223417dac80fe5090fb2e7c', 164, 1, 1, '2019-07-10 08:49:21', '2019-07-09 20:49:21', '2019-07-09 20:49:21');
INSERT INTO `oauth2_refresh_token` VALUES ('a2198f25731241d8a3aa7e8a6edba76f', 27, 2, 1, '2019-08-09 08:30:34', '2019-08-08 20:30:34', '2019-08-08 20:30:34');
INSERT INTO `oauth2_refresh_token` VALUES ('a23a3ce4c0ed46adbc824cdf4ce2933d', 27, 2, 1, '2019-05-28 06:26:06', '2019-05-27 18:26:05', '2019-05-27 18:26:05');
INSERT INTO `oauth2_refresh_token` VALUES ('a2407c1f0a8d4c8cbadfc55b9797f3ea', 27, 2, 1, '2019-06-01 22:04:48', '2019-06-01 10:04:47', '2019-06-01 10:04:47');
INSERT INTO `oauth2_refresh_token` VALUES ('a257d146531c47b094e7a716c98a0ff4', 27, 2, 1, '2019-08-09 02:06:55', '2019-08-08 14:06:55', '2019-08-08 14:06:55');
INSERT INTO `oauth2_refresh_token` VALUES ('a25fe26fe5da49ffa5f3aa54b4c649dd', 27, 2, 1, '2019-06-18 03:35:51', '2019-06-17 15:35:51', '2019-06-17 15:35:51');
INSERT INTO `oauth2_refresh_token` VALUES ('a284b7d6b6214e26883cbe851ec36f2a', 27, 2, 1, '2019-06-04 09:43:31', '2019-06-03 21:43:31', '2019-06-03 21:43:31');
INSERT INTO `oauth2_refresh_token` VALUES ('a28572275330433c812ae75d50230fd5', NULL, NULL, 1, '2019-05-09 05:22:51', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a296e353d1154f369bb775e2ba516292', 1, 2, 0, '2019-07-12 20:02:40', '2019-07-12 08:02:39', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('a29c1e48fe424368bb422bad1683c912', 27, 2, 1, '2019-08-29 10:10:55', '2019-08-28 22:10:54', '2019-08-28 22:10:54');
INSERT INTO `oauth2_refresh_token` VALUES ('a29d9b638e0a43ea8de6cee962d46d90', NULL, NULL, 1, '2019-05-09 11:44:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a2ccb7308dc145bc90988c0bfd93e09f', 27, 2, 1, '2019-08-27 10:52:52', '2019-08-26 22:52:51', '2019-08-26 22:52:51');
INSERT INTO `oauth2_refresh_token` VALUES ('a2d625c4515c4d8598c7212ac4a989ad', NULL, NULL, 0, '2019-03-01 07:43:09', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a2de75c486114e5ba86b5357324c4977', 1, 1, 1, '2019-05-18 05:58:10', '2019-05-17 17:58:09', '2019-05-17 17:58:09');
INSERT INTO `oauth2_refresh_token` VALUES ('a31c4231dfe244a69c1cc6449a84d9c9', NULL, NULL, 1, '2019-05-09 05:05:48', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a32291e0c3144d5ebaf39efd66889ea9', 27, 2, 1, '2019-06-01 09:22:14', '2019-05-31 21:22:13', '2019-05-31 21:22:13');
INSERT INTO `oauth2_refresh_token` VALUES ('a32c8e9a77464a53aea2cf5efa8c7036', 27, 2, 1, '2019-08-18 01:22:49', '2019-08-17 13:22:48', '2019-08-17 13:22:48');
INSERT INTO `oauth2_refresh_token` VALUES ('a33e9cfbd0994d9597d9c664e7bcaef5', 27, 2, 1, '2019-06-05 21:14:38', '2019-06-05 09:14:37', '2019-06-05 09:14:37');
INSERT INTO `oauth2_refresh_token` VALUES ('a3524bf455d443e2a1e030a1ac2c97e3', 27, 2, 1, '2019-06-12 22:33:23', '2019-06-12 10:33:22', '2019-06-12 10:33:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a364fc82d00b4d35a2e4f0cc40d41f24', 27, 2, 1, '2019-08-29 02:08:35', '2019-08-28 14:08:34', '2019-08-28 14:08:34');
INSERT INTO `oauth2_refresh_token` VALUES ('a367cfa8605f472c82c427b47acf5d15', 27, 2, 1, '2019-07-12 22:13:15', '2019-07-12 10:13:14', '2019-07-12 10:13:14');
INSERT INTO `oauth2_refresh_token` VALUES ('a37846b0897f4451afce50f1c15dcd35', 27, 2, 1, '2019-07-08 23:49:59', '2019-07-08 11:49:58', '2019-07-08 11:49:58');
INSERT INTO `oauth2_refresh_token` VALUES ('a37f3efdd49a4f7f88197f5b4a22d229', NULL, NULL, 0, '2019-03-04 10:11:10', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a38f02d9cd82485baa64b77c03f10ab6', 1, 2, 0, '2019-05-18 04:02:47', '2019-05-17 16:02:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('a3a363b1b71746538713360eb9cb59f4', 27, 2, 1, '2019-08-01 03:25:57', '2019-07-31 15:25:56', '2019-07-31 15:25:56');
INSERT INTO `oauth2_refresh_token` VALUES ('a3a4e6e382c8402e8e82ed733253498f', 27, 2, 1, '2019-08-24 03:05:14', '2019-08-23 15:05:13', '2019-08-23 15:05:13');
INSERT INTO `oauth2_refresh_token` VALUES ('a3e432615b7e4f248a696969400bc5af', 27, 2, 1, '2019-07-02 22:32:08', '2019-07-02 10:32:07', '2019-07-02 10:32:07');
INSERT INTO `oauth2_refresh_token` VALUES ('a3f25565c24549b1a9d6ef5efdf50e85', 27, 2, 1, '2019-06-01 22:38:04', '2019-06-01 10:38:03', '2019-06-01 10:38:03');
INSERT INTO `oauth2_refresh_token` VALUES ('a3f9026b8d85432a986c506b5407ad1a', NULL, NULL, 1, '2019-05-06 09:08:21', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a419152914484c0595d0c4024bf85a2d', NULL, NULL, 1, '2019-03-17 08:18:42', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a419566b878b4beb90dbba9fcea788e9', 27, 2, 1, '2019-06-08 12:45:24', '2019-06-08 00:45:24', '2019-06-08 00:45:24');
INSERT INTO `oauth2_refresh_token` VALUES ('a425de6db62944669350b4a57715392d', 1, 2, 0, '2019-05-27 02:52:29', '2019-05-26 14:52:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('a42ca762bcae4220a30d2abfa2f8c132', 27, 2, 1, '2019-07-12 01:57:04', '2019-07-11 13:57:03', '2019-07-11 13:57:03');
INSERT INTO `oauth2_refresh_token` VALUES ('a4388dbacb274bf0ae72d4f88350d4dd', NULL, NULL, 1, '2019-05-12 10:28:51', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a4548382030447fd9daeb70676a27f18', 27, 2, 1, '2019-07-08 09:01:50', '2019-07-07 21:01:49', '2019-07-07 21:01:49');
INSERT INTO `oauth2_refresh_token` VALUES ('a4583bb9c66449bc86e92ce9e464570b', 27, 2, 1, '2019-06-29 23:23:35', '2019-06-29 11:23:35', '2019-06-29 11:23:35');
INSERT INTO `oauth2_refresh_token` VALUES ('a45c56de25254200abe6b066e58d5167', 27, 2, 1, '2019-06-07 04:31:00', '2019-06-06 16:31:00', '2019-06-06 16:31:00');
INSERT INTO `oauth2_refresh_token` VALUES ('a47d7bf20cd7477a9510c6c92d8067d6', 27, 2, 1, '2019-06-05 21:14:27', '2019-06-05 09:14:27', '2019-06-05 09:14:27');
INSERT INTO `oauth2_refresh_token` VALUES ('a4964d041acc48bd924405218c97a9e2', 27, 2, 1, '2019-06-02 05:02:32', '2019-06-01 17:02:31', '2019-06-01 17:02:31');
INSERT INTO `oauth2_refresh_token` VALUES ('a4a4dde06aac45a8b3ee665f4f4561fd', 27, 2, 1, '2019-05-23 23:09:37', '2019-05-23 11:09:36', '2019-05-23 11:09:36');
INSERT INTO `oauth2_refresh_token` VALUES ('a4a63733bf5948ad9afc48381932f7d3', 1, 2, 0, '2019-08-02 22:14:00', '2019-08-02 10:13:59', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('a4b66897432f47d182cff4a7a900c946', 27, 2, 1, '2019-06-05 09:25:58', '2019-06-04 21:25:57', '2019-06-04 21:25:57');
INSERT INTO `oauth2_refresh_token` VALUES ('a4b88b1db39d42818f9a2d1deacdb19c', 1, 2, 1, '2019-09-09 05:42:09', '2019-09-08 17:42:09', '2019-09-08 17:42:09');
INSERT INTO `oauth2_refresh_token` VALUES ('a4bd94b9cc0f470da3b786a0be000b89', 27, 2, 1, '2019-08-11 23:10:28', '2019-08-11 11:10:27', '2019-08-11 11:10:27');
INSERT INTO `oauth2_refresh_token` VALUES ('a4ca7d84185149a0949781571aa2894a', NULL, NULL, 1, '2019-04-05 06:21:34', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a4dda1c8b48b4c03bd8e43edcc5fdc45', NULL, NULL, 1, '2019-04-25 04:44:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a50e2c0aeaf04524a8b82526e17186f4', NULL, NULL, 1, '2019-05-06 06:40:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a514fe7dcc7a4c66a26d1263c16573fb', 27, 2, 1, '2019-07-23 04:13:37', '2019-07-22 16:13:37', '2019-07-22 16:13:37');
INSERT INTO `oauth2_refresh_token` VALUES ('a51bed5257fc40918108ef61827d658d', NULL, NULL, 1, '2019-05-15 23:32:15', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a52e77f7eeff4f87828db3cfe1c9098d', 27, 2, 1, '2019-08-20 05:34:57', '2019-08-19 17:34:56', '2019-08-19 17:34:56');
INSERT INTO `oauth2_refresh_token` VALUES ('a5341875755640b6995f74bf6e9795be', 27, 2, 1, '2019-08-07 21:26:51', '2019-08-07 09:26:51', '2019-08-07 09:26:51');
INSERT INTO `oauth2_refresh_token` VALUES ('a5406c7a2973453bb8017494949e1485', 27, 2, 1, '2019-08-16 05:22:36', '2019-08-15 17:22:36', '2019-08-15 17:22:36');
INSERT INTO `oauth2_refresh_token` VALUES ('a54ed7d71e8b4d1bbd4c7faca95e917d', 27, 2, 1, '2019-06-11 22:35:59', '2019-06-11 10:35:59', '2019-06-11 10:35:59');
INSERT INTO `oauth2_refresh_token` VALUES ('a569c102f0a64e598fa307e570c45ccb', 85, 1, 1, '2019-05-28 21:09:18', '2019-05-28 09:09:17', '2019-05-28 09:09:17');
INSERT INTO `oauth2_refresh_token` VALUES ('a5a160f40b01414d9bf4b519685fadbb', 27, 2, 1, '2019-05-21 05:53:28', '2019-05-20 17:53:28', '2019-05-20 17:53:28');
INSERT INTO `oauth2_refresh_token` VALUES ('a5d3a44090664bdb9b0a733eba8ea049', 27, 2, 1, '2019-07-18 09:38:12', '2019-07-17 21:38:11', '2019-07-17 21:38:11');
INSERT INTO `oauth2_refresh_token` VALUES ('a5e9470aa62f476b9c3b646a5f834753', 27, 2, 1, '2019-08-03 04:08:47', '2019-08-02 16:08:46', '2019-08-02 16:08:46');
INSERT INTO `oauth2_refresh_token` VALUES ('a5f0f608b33c4b188f0249c145d43e89', 27, 2, 1, '2019-08-25 10:52:59', '2019-08-24 22:52:58', '2019-08-24 22:52:58');
INSERT INTO `oauth2_refresh_token` VALUES ('a5fb9bbda64e4eae9b7d1e662d5f2948', 1, 2, 0, '2019-06-27 08:28:01', '2019-06-26 20:28:00', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('a5fc9dca3e0548b89920633e16433f63', 27, 2, 1, '2019-08-17 05:08:21', '2019-08-16 17:08:21', '2019-08-16 17:08:21');
INSERT INTO `oauth2_refresh_token` VALUES ('a6012b242c5244f1a7deac60f29e0373', 27, 2, 1, '2019-06-28 23:53:14', '2019-06-28 11:53:14', '2019-06-28 11:53:14');
INSERT INTO `oauth2_refresh_token` VALUES ('a609b7043bcb4fa8b325d6415ea50081', 27, 2, 1, '2019-05-18 05:08:58', '2019-05-17 17:08:58', '2019-05-17 17:08:58');
INSERT INTO `oauth2_refresh_token` VALUES ('a6138d02e0cc4247a6629ed2e93a44b9', 27, 2, 1, '2019-06-05 04:04:17', '2019-06-04 16:04:17', '2019-06-04 16:04:17');
INSERT INTO `oauth2_refresh_token` VALUES ('a61d8e00f41e40ac91f32d61494a8294', 1, 2, 0, '2019-07-03 03:18:02', '2019-07-02 15:18:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('a6205f936d1a491f955502d2c6c26088', 27, 2, 1, '2019-08-08 04:55:40', '2019-08-07 16:55:40', '2019-08-07 16:55:40');
INSERT INTO `oauth2_refresh_token` VALUES ('a6253540f86e4aeaaa28b6fab2391162', 108, 1, 1, '2019-06-05 21:31:39', '2019-06-05 09:31:39', '2019-06-05 09:31:39');
INSERT INTO `oauth2_refresh_token` VALUES ('a633edc1fc4d4c3fa6197a63fae6907b', NULL, NULL, 1, '2019-03-13 02:28:49', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a634664950ec4140921b597d71addb62', 27, 2, 1, '2019-08-13 03:33:25', '2019-08-12 15:33:25', '2019-08-12 15:33:25');
INSERT INTO `oauth2_refresh_token` VALUES ('a649c84bfd4943c8b17d3b1a4ca5f049', NULL, NULL, 1, '2019-04-22 23:35:29', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a64e6404a2ab4b34826f3e608a38b092', 27, 2, 1, '2019-06-25 02:04:41', '2019-06-24 14:04:41', '2019-06-24 14:04:41');
INSERT INTO `oauth2_refresh_token` VALUES ('a6a1fe6c6a25492a836982132228d977', 27, 2, 1, '2019-06-02 11:52:52', '2019-06-01 23:52:52', '2019-06-01 23:52:52');
INSERT INTO `oauth2_refresh_token` VALUES ('a6a6ca8c26e44e1ba0e297b842d92221', 27, 2, 1, '2019-07-04 04:30:17', '2019-07-03 16:30:17', '2019-07-03 16:30:17');
INSERT INTO `oauth2_refresh_token` VALUES ('a6c680087f164fc0a65e9c62f8dd659e', 27, 2, 1, '2019-07-08 23:07:42', '2019-07-08 11:07:41', '2019-07-08 11:07:41');
INSERT INTO `oauth2_refresh_token` VALUES ('a6c6cc6242154b53ac0c3fdf5e1e743a', 27, 2, 1, '2019-08-01 08:12:30', '2019-07-31 20:12:29', '2019-07-31 20:12:29');
INSERT INTO `oauth2_refresh_token` VALUES ('a6cefa4f10a74e20ab9566d4a38ac48d', 27, 2, 1, '2019-07-05 02:36:44', '2019-07-04 14:36:43', '2019-07-04 14:36:43');
INSERT INTO `oauth2_refresh_token` VALUES ('a6d9b5f74f4f4e58af9ae73e5b255a5a', 27, 2, 1, '2019-08-28 03:08:01', '2019-08-27 15:08:01', '2019-08-27 15:08:01');
INSERT INTO `oauth2_refresh_token` VALUES ('a6dc13ef65794788b8b6a10460fdf394', 27, 2, 1, '2019-08-18 03:41:22', '2019-08-17 15:41:22', '2019-08-17 15:41:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a6eb8fc9fef4440e805459ea48730d45', 1, 2, 1, '2019-09-09 11:15:13', '2019-09-08 23:15:13', '2019-09-08 23:15:13');
INSERT INTO `oauth2_refresh_token` VALUES ('a6f3837acfde403c8a7618ea147f05aa', 27, 2, 1, '2019-08-08 05:19:07', '2019-08-07 17:19:06', '2019-08-07 17:19:06');
INSERT INTO `oauth2_refresh_token` VALUES ('a6fac9361cce4631b9ae8ac6c57ec62d', 27, 2, 1, '2019-08-09 05:09:15', '2019-08-08 17:09:15', '2019-08-08 17:09:15');
INSERT INTO `oauth2_refresh_token` VALUES ('a70bebd1095d4c6185abedcff05bfe42', 27, 2, 1, '2019-06-15 02:54:44', '2019-06-14 14:54:44', '2019-06-14 14:54:44');
INSERT INTO `oauth2_refresh_token` VALUES ('a7257e5865b640169d98b84efc1255e2', 27, 2, 1, '2019-06-03 21:59:50', '2019-06-03 09:59:49', '2019-06-03 09:59:49');
INSERT INTO `oauth2_refresh_token` VALUES ('a738b4a55cba4690ac0b087ddfc1a9de', 27, 2, 1, '2019-06-21 10:06:39', '2019-06-20 22:06:38', '2019-06-20 22:06:38');
INSERT INTO `oauth2_refresh_token` VALUES ('a73da9612c904af6a97f679c4a744467', 129, 1, 1, '2019-06-20 19:46:15', '2019-06-20 07:46:14', '2019-06-20 07:46:14');
INSERT INTO `oauth2_refresh_token` VALUES ('a74a363bb1c945138b87b84b8eccf4d3', NULL, NULL, 1, '2019-04-24 20:43:13', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a75346b1fe87429a9be9048d861ffb1b', 27, 2, 1, '2019-07-06 10:24:34', '2019-07-05 22:24:33', '2019-07-05 22:24:33');
INSERT INTO `oauth2_refresh_token` VALUES ('a755b62ac46943f4aff9b260116734b5', 119, 1, 1, '2019-06-12 05:28:11', '2019-06-11 17:28:10', '2019-06-11 17:28:10');
INSERT INTO `oauth2_refresh_token` VALUES ('a75951e9bf3f41a5b6700c3c34c34bc7', 27, 2, 1, '2019-06-03 11:44:57', '2019-06-02 23:44:56', '2019-06-02 23:44:56');
INSERT INTO `oauth2_refresh_token` VALUES ('a75cf477eefe4efbb533b6cb6de15cec', NULL, NULL, 0, '2019-03-04 10:13:02', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a75de6da06784fbbad363b21ebc43d79', 27, 2, 1, '2019-06-29 01:52:33', '2019-06-28 13:52:32', '2019-06-28 13:52:32');
INSERT INTO `oauth2_refresh_token` VALUES ('a766628ece174b12b17160bdd1d61762', 27, 2, 1, '2019-06-13 04:01:57', '2019-06-12 16:01:56', '2019-06-12 16:01:56');
INSERT INTO `oauth2_refresh_token` VALUES ('a76dcee6a29d4ffdbe2f5892d9b50dc0', 27, 2, 1, '2019-06-23 10:40:10', '2019-06-22 22:40:10', '2019-06-22 22:40:10');
INSERT INTO `oauth2_refresh_token` VALUES ('a77a44076e4f4c38a9888f38ded2ed3f', 27, 2, 1, '2019-07-12 22:00:30', '2019-07-12 10:00:29', '2019-07-12 10:00:29');
INSERT INTO `oauth2_refresh_token` VALUES ('a782ebd07d72437b880dbf5907aecdc6', 27, 2, 1, '2019-07-13 22:50:44', '2019-07-13 10:50:43', '2019-07-13 10:50:43');
INSERT INTO `oauth2_refresh_token` VALUES ('a78940630e08479789ad07bc23402f82', 27, 2, 1, '2019-07-31 02:35:59', '2019-07-30 14:35:59', '2019-07-30 14:35:59');
INSERT INTO `oauth2_refresh_token` VALUES ('a790a179c178411e971e4374f1584cda', NULL, NULL, 1, '2019-04-06 09:31:20', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a79134b6a0eb4a6dba99d173146a1f47', 27, 2, 1, '2019-08-28 07:11:36', '2019-08-27 19:11:36', '2019-08-27 19:11:36');
INSERT INTO `oauth2_refresh_token` VALUES ('a7a55c3c0ed243e2bb65d5efa59e0953', 27, 2, 1, '2019-07-05 05:31:11', '2019-07-04 17:31:10', '2019-07-04 17:31:10');
INSERT INTO `oauth2_refresh_token` VALUES ('a7b249e6ee734a56a4a34bc4b719d4f7', 27, 2, 1, '2019-09-06 00:49:48', '2019-09-05 12:49:47', '2019-09-05 12:49:47');
INSERT INTO `oauth2_refresh_token` VALUES ('a7b7dc17ebb5434ab016106bab67912f', 27, 2, 1, '2019-08-02 03:43:21', '2019-08-01 15:43:20', '2019-08-01 15:43:20');
INSERT INTO `oauth2_refresh_token` VALUES ('a7c4a12c705f44438ed0adb7b0c2a5ea', 27, 2, 1, '2019-08-25 23:20:27', '2019-08-25 11:20:27', '2019-08-25 11:20:27');
INSERT INTO `oauth2_refresh_token` VALUES ('a7d11c86d446441bb05d51a4464d6a51', 27, 2, 1, '2019-07-02 00:09:59', '2019-07-01 12:09:58', '2019-07-01 12:09:58');
INSERT INTO `oauth2_refresh_token` VALUES ('a7d6f692fad4432e86c1e104c54ba102', 27, 2, 1, '2019-07-05 03:04:44', '2019-07-04 15:04:43', '2019-07-04 15:04:43');
INSERT INTO `oauth2_refresh_token` VALUES ('a7de5ffe4c664f6785c2a9c90d06988f', 27, 2, 1, '2019-07-03 04:35:41', '2019-07-02 16:35:40', '2019-07-02 16:35:40');
INSERT INTO `oauth2_refresh_token` VALUES ('a7e8ec4f26e844bea5623e32740e270e', 27, 2, 1, '2019-05-30 05:18:18', '2019-05-29 17:18:18', '2019-05-29 17:18:18');
INSERT INTO `oauth2_refresh_token` VALUES ('a7f44b317c504668b9a4b9bdb0cd058d', 27, 2, 1, '2019-07-03 01:28:41', '2019-07-02 13:28:41', '2019-07-02 13:28:41');
INSERT INTO `oauth2_refresh_token` VALUES ('a80af1d22acd42b5ad17f99206f504fb', NULL, NULL, 1, '2019-04-25 03:06:08', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a80c7cae68ce437f91daf04dd18acee8', 27, 2, 1, '2019-06-03 01:12:26', '2019-06-02 13:12:26', '2019-06-02 13:12:26');
INSERT INTO `oauth2_refresh_token` VALUES ('a812abd9de5d49038d1ee255a18381d9', 27, 2, 1, '2019-05-25 06:24:40', '2019-05-24 18:24:40', '2019-05-24 18:24:40');
INSERT INTO `oauth2_refresh_token` VALUES ('a828166b66c440f595267083c5d206c3', 27, 2, 1, '2019-05-30 01:04:30', '2019-05-29 13:04:29', '2019-05-29 13:04:29');
INSERT INTO `oauth2_refresh_token` VALUES ('a837dffa592246e7939c7d1a640be5fc', 27, 2, 1, '2019-07-04 04:59:11', '2019-07-03 16:59:11', '2019-07-03 16:59:11');
INSERT INTO `oauth2_refresh_token` VALUES ('a83f12a441d1463e9f3dc49d2c29b555', 27, 2, 1, '2019-08-15 21:01:50', '2019-08-15 09:01:50', '2019-08-15 09:01:50');
INSERT INTO `oauth2_refresh_token` VALUES ('a861eae02d6147ef9853cd64fb7afd7d', 14, 2, 1, '2019-06-12 09:58:44', '2019-06-11 21:58:44', '2019-06-11 21:58:44');
INSERT INTO `oauth2_refresh_token` VALUES ('a86c03dc5ce84d999a0343333cca04ba', 1, 2, 0, '2019-09-02 11:06:51', '2019-09-01 23:06:50', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('a87b0a67b03943fe929072e46c1f0b9b', 27, 2, 1, '2019-06-13 02:43:02', '2019-06-12 14:43:02', '2019-06-12 14:43:02');
INSERT INTO `oauth2_refresh_token` VALUES ('a885cfc0529a4665a9e8d6db6b8b2b42', NULL, NULL, 1, '2019-04-25 04:34:10', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a893a631139746159c6fdfae80eb81e0', NULL, NULL, 1, '2019-05-10 03:13:05', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a8b3b767389b48059881796f0d41eaf3', 27, 2, 1, '2019-07-25 02:28:30', '2019-07-24 14:28:29', '2019-07-24 14:28:29');
INSERT INTO `oauth2_refresh_token` VALUES ('a8bf0346f4014b6297a51a48cebd53dc', NULL, NULL, 1, '2019-04-26 23:05:01', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a8c16ccd94fb4a7d8199f3647113bc01', NULL, NULL, 1, '2019-05-13 21:54:32', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a8cb87dd98dc4c9e8bbe6add027b44e2', 27, 2, 1, '2019-07-17 10:07:20', '2019-07-16 22:07:20', '2019-07-16 22:07:20');
INSERT INTO `oauth2_refresh_token` VALUES ('a8e7d11f04a34c669d6a6c29263f4435', 27, 2, 1, '2019-07-20 21:07:15', '2019-07-20 09:07:15', '2019-07-20 09:07:15');
INSERT INTO `oauth2_refresh_token` VALUES ('a8f334fbbc3f45f895dfdc870dda89d6', 27, 2, 1, '2019-07-02 04:28:58', '2019-07-01 16:28:57', '2019-07-01 16:28:57');
INSERT INTO `oauth2_refresh_token` VALUES ('a8f5d7b450e14b20a4fc97e60f32c235', NULL, NULL, 1, '2019-05-08 04:27:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a90071b6615d4f45980dd3d79974fb7d', 1, 2, 0, '2019-08-05 09:28:46', '2019-08-04 21:28:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('a900f2ac0fc2497eac137ca97866f8c3', NULL, NULL, 1, '2019-05-14 00:36:03', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a906cf3567ff4f48b852630f207ff1a1', 27, 2, 1, '2019-07-09 04:49:38', '2019-07-08 16:49:37', '2019-07-08 16:49:37');
INSERT INTO `oauth2_refresh_token` VALUES ('a953053b07b74f2287fa2b06a9e02d88', 156, 1, 1, '2019-07-03 23:37:02', '2019-07-03 11:37:02', '2019-07-03 11:37:02');
INSERT INTO `oauth2_refresh_token` VALUES ('a966a222a34c4a5a88e11cb2ab5a796f', NULL, NULL, 1, '2019-05-08 10:48:43', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a9914d3d10b643eb91f0658b51439d74', 27, 2, 1, '2019-05-28 02:16:11', '2019-05-27 14:16:10', '2019-05-27 14:16:10');
INSERT INTO `oauth2_refresh_token` VALUES ('a99419f6e460402dbdd17ce176beeeb8', 27, 2, 1, '2019-06-21 21:22:41', '2019-06-21 09:22:40', '2019-06-21 09:22:40');
INSERT INTO `oauth2_refresh_token` VALUES ('a9a89a0510cf41b586fa413347d26966', 27, 2, 1, '2019-06-20 20:46:01', '2019-06-20 08:46:00', '2019-06-20 08:46:00');
INSERT INTO `oauth2_refresh_token` VALUES ('a9d02048412e488f8d16962ab1af2edf', 27, 2, 1, '2019-08-31 05:16:23', '2019-08-30 17:16:23', '2019-08-30 17:16:23');
INSERT INTO `oauth2_refresh_token` VALUES ('a9d0c5cc3772474385366b61463382db', NULL, NULL, 1, '2019-04-27 09:42:19', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('a9e179330ca04d49847ae2f40fa2dac7', 27, 2, 1, '2019-09-06 02:41:38', '2019-09-05 14:41:37', '2019-09-05 14:41:37');
INSERT INTO `oauth2_refresh_token` VALUES ('a9e7e8151ccb44588ee661d77669cc4b', 27, 2, 1, '2019-06-12 01:52:00', '2019-06-11 13:51:59', '2019-06-11 13:51:59');
INSERT INTO `oauth2_refresh_token` VALUES ('a9ebd9d601f24aa096f5e5e38befdef7', 27, 2, 1, '2019-07-18 03:56:15', '2019-07-17 15:56:14', '2019-07-17 15:56:14');
INSERT INTO `oauth2_refresh_token` VALUES ('aa54d20804b841f8b002d29444ee5bc0', NULL, NULL, 1, '2019-03-30 11:31:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('aa57faff327f4f9eb281bc75c794f4c4', 1, 2, 0, '2019-07-23 04:14:00', '2019-07-22 16:13:59', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('aa5ec060a2eb4f8eaf60b9807956f65b', 27, 2, 1, '2019-07-01 23:01:03', '2019-07-01 11:01:02', '2019-07-01 11:01:02');
INSERT INTO `oauth2_refresh_token` VALUES ('aa749c3690c149698f7b0fbe858389a2', 27, 2, 1, '2019-06-27 10:47:38', '2019-06-26 22:47:38', '2019-06-26 22:47:38');
INSERT INTO `oauth2_refresh_token` VALUES ('aa80af7fd5f9402da53e9e24a4ca6195', NULL, NULL, 1, '2019-04-10 03:39:41', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('aaa43a46dc86495e8f7e3eb1458e92aa', 154, 1, 1, '2019-07-03 08:25:00', '2019-07-02 20:25:00', '2019-07-02 20:25:00');
INSERT INTO `oauth2_refresh_token` VALUES ('aaab312210514bd79e7f4f1784037531', 27, 2, 1, '2019-07-06 21:37:00', '2019-07-06 09:37:00', '2019-07-06 09:37:00');
INSERT INTO `oauth2_refresh_token` VALUES ('aab3d359eb6e4e2bb1ab31f05d0de6af', 27, 2, 1, '2019-06-20 22:43:07', '2019-06-20 10:43:06', '2019-06-20 10:43:06');
INSERT INTO `oauth2_refresh_token` VALUES ('aab66488a21b4695886e03968c0d84bb', 27, 2, 1, '2019-08-04 01:28:55', '2019-08-03 13:28:54', '2019-08-03 13:28:54');
INSERT INTO `oauth2_refresh_token` VALUES ('aae014d332554497aae6cf9bcddd8805', 27, 2, 1, '2019-08-24 04:06:42', '2019-08-23 16:06:42', '2019-08-23 16:06:42');
INSERT INTO `oauth2_refresh_token` VALUES ('aaf5238940ea4b75ac321634d173d3f8', 27, 2, 1, '2019-08-19 23:02:27', '2019-08-19 11:02:27', '2019-08-19 11:02:27');
INSERT INTO `oauth2_refresh_token` VALUES ('aaf72e8a29f745cab3176637c48f0910', 27, 2, 1, '2019-06-04 01:23:47', '2019-06-03 13:23:46', '2019-06-03 13:23:46');
INSERT INTO `oauth2_refresh_token` VALUES ('ab02999f1e194a4e986aa132a89992af', 27, 2, 1, '2019-08-28 13:14:01', '2019-08-28 01:14:01', '2019-08-28 01:14:01');
INSERT INTO `oauth2_refresh_token` VALUES ('ab0a02089e214903b139d0205c77901e', 1, 2, 0, '2019-07-06 03:40:29', '2019-07-05 15:40:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ab12f23e48eb42f6ba607e091169983e', 27, 2, 1, '2019-07-27 01:46:45', '2019-07-26 13:46:45', '2019-07-26 13:46:45');
INSERT INTO `oauth2_refresh_token` VALUES ('ab1901e6b881421dbaad0903ea2e2d46', 27, 2, 1, '2019-06-02 23:48:59', '2019-06-02 11:48:59', '2019-06-02 11:48:59');
INSERT INTO `oauth2_refresh_token` VALUES ('ab1fe7008d51409b95cbfb5ee150e69a', 151, 1, 1, '2019-07-02 23:58:04', '2019-07-02 11:58:04', '2019-07-02 11:58:04');
INSERT INTO `oauth2_refresh_token` VALUES ('ab50926b44764fdb9c6a7d76470c2466', 27, 2, 1, '2019-08-15 11:48:20', '2019-08-14 23:48:19', '2019-08-14 23:48:19');
INSERT INTO `oauth2_refresh_token` VALUES ('ab624257f6eb433e8b9c9eb99c7680b4', 27, 2, 1, '2019-05-28 22:15:13', '2019-05-28 10:15:13', '2019-05-28 10:15:13');
INSERT INTO `oauth2_refresh_token` VALUES ('ab6ef9944ca3406583a9238f307e3519', 1, 2, 0, '2019-07-05 22:02:25', '2019-07-05 10:02:24', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ab90aceab1274bb087d6d54dcfed3879', 27, 2, 1, '2019-09-01 02:43:21', '2019-08-31 14:43:20', '2019-08-31 14:43:20');
INSERT INTO `oauth2_refresh_token` VALUES ('ab9e3b87fe6e45c381e365813046deba', 27, 2, 1, '2019-06-04 20:56:29', '2019-06-04 08:56:28', '2019-06-04 08:56:28');
INSERT INTO `oauth2_refresh_token` VALUES ('abaebbc9b3f043069534cffd7f33853d', NULL, NULL, 1, '2019-03-13 02:33:37', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('abc0f3a5925042a1bb08a3ef33f35150', 27, 2, 1, '2019-07-28 08:41:22', '2019-07-27 20:41:21', '2019-07-27 20:41:21');
INSERT INTO `oauth2_refresh_token` VALUES ('abf2fe1038d64015a55bac1bb1ca13bd', NULL, NULL, 1, '2019-05-10 08:47:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('abf6429710ae4b1cb9b414772fa1bbde', NULL, NULL, 1, '2019-05-11 03:41:43', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ac14387b0cca447d9f41f608f1a646ae', 27, 2, 1, '2019-05-21 11:05:03', '2019-05-20 23:05:03', '2019-05-20 23:05:03');
INSERT INTO `oauth2_refresh_token` VALUES ('ac1b13df241d41b9a42d95bd17aecb89', 27, 2, 1, '2019-08-08 22:10:42', '2019-08-08 10:10:42', '2019-08-08 10:10:42');
INSERT INTO `oauth2_refresh_token` VALUES ('ac1ed21a95ed4cde8b48d5a49aa0a089', 27, 2, 1, '2019-07-01 11:32:54', '2019-06-30 23:32:53', '2019-06-30 23:32:53');
INSERT INTO `oauth2_refresh_token` VALUES ('ac2ae2c76e26424da560bed82183dd8c', NULL, NULL, 1, '2019-05-01 04:37:21', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ac31405edfb7493989f7fae57b459722', 27, 2, 1, '2019-06-15 07:00:39', '2019-06-14 19:00:38', '2019-06-14 19:00:38');
INSERT INTO `oauth2_refresh_token` VALUES ('ac327aa3484145a1ac6bc84fa184e466', 27, 2, 1, '2019-06-01 09:03:39', '2019-05-31 21:03:38', '2019-05-31 21:03:38');
INSERT INTO `oauth2_refresh_token` VALUES ('ac35fd137d4a4720af647705df0196f1', NULL, NULL, 1, '2019-05-03 18:31:36', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ac4ac58c4c4c40aeb01bfdfcb0e9e949', 27, 2, 1, '2019-06-26 02:42:43', '2019-06-25 14:42:43', '2019-06-25 14:42:43');
INSERT INTO `oauth2_refresh_token` VALUES ('ac52e966a7a049de8db388100f3f9b00', 27, 2, 1, '2019-05-29 02:27:49', '2019-05-28 14:27:48', '2019-05-28 14:27:48');
INSERT INTO `oauth2_refresh_token` VALUES ('ac57854dbafb481fba81367d2d651b1d', NULL, NULL, 1, '2019-05-16 04:40:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ac5b2e5a49004127b05925683cfd95d8', 27, 2, 1, '2019-08-15 03:15:51', '2019-08-14 15:15:50', '2019-08-14 15:15:50');
INSERT INTO `oauth2_refresh_token` VALUES ('ac5ca340fa9a4565933ce4644bdfc138', 27, 2, 1, '2019-08-01 21:52:18', '2019-08-01 09:52:18', '2019-08-01 09:52:18');
INSERT INTO `oauth2_refresh_token` VALUES ('ac6d35eb791742d48d1f674ece2f36b9', 27, 2, 1, '2019-06-14 04:32:14', '2019-06-13 16:32:14', '2019-06-13 16:32:14');
INSERT INTO `oauth2_refresh_token` VALUES ('acb025164c1d4c0aa63d512a1c2322e8', 27, 2, 1, '2019-08-03 11:08:34', '2019-08-02 23:08:33', '2019-08-02 23:08:33');
INSERT INTO `oauth2_refresh_token` VALUES ('acb2d704c8424a9e875a93c0c05f63d7', 27, 2, 1, '2019-06-14 22:35:31', '2019-06-14 10:35:30', '2019-06-14 10:35:30');
INSERT INTO `oauth2_refresh_token` VALUES ('acb5dff8b2b2497a9966a2322317ccb0', 27, 2, 1, '2019-07-13 05:12:34', '2019-07-12 17:12:34', '2019-07-12 17:12:34');
INSERT INTO `oauth2_refresh_token` VALUES ('ace5f112bb3144af8d62ef1008797571', 27, 2, 1, '2019-08-03 04:20:20', '2019-08-02 16:20:19', '2019-08-02 16:20:19');
INSERT INTO `oauth2_refresh_token` VALUES ('acea6d853f194fbaa43fd0edc973d973', NULL, NULL, 1, '2019-05-08 23:18:23', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ad180e1550304562b2b9ebf63b7ac6c9', 27, 2, 1, '2019-05-25 01:38:18', '2019-05-24 13:37:02', '2019-05-24 13:37:02');
INSERT INTO `oauth2_refresh_token` VALUES ('ad20422b42b24faba033cf9eec70c249', 75, 1, 1, '2019-05-19 03:55:44', '2019-05-18 15:55:43', '2019-05-18 15:55:43');
INSERT INTO `oauth2_refresh_token` VALUES ('ad243c42f88c48f3af25d1950c5d9a9b', 27, 2, 1, '2019-06-04 22:24:36', '2019-06-04 10:24:35', '2019-06-04 10:24:35');
INSERT INTO `oauth2_refresh_token` VALUES ('ad302badcc3b49d58c4b1cd30bef5af2', 27, 2, 1, '2019-06-26 22:23:38', '2019-06-26 10:23:37', '2019-06-26 10:23:37');
INSERT INTO `oauth2_refresh_token` VALUES ('ad30ad871935453a951f4465c58294e7', 27, 2, 1, '2019-08-05 23:14:45', '2019-08-05 11:14:44', '2019-08-05 11:14:44');
INSERT INTO `oauth2_refresh_token` VALUES ('ad53f8f154ae4d478548ac12c995be9b', NULL, NULL, 1, '2019-05-09 11:07:02', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ad5eac111b4a402295df2a619496ea81', 27, 2, 1, '2019-06-06 04:18:30', '2019-06-05 16:18:29', '2019-06-05 16:18:29');
INSERT INTO `oauth2_refresh_token` VALUES ('ad664a2eca0d4a0ba7f485b434ca79a3', 27, 2, 1, '2019-07-25 11:34:04', '2019-07-24 23:34:04', '2019-07-24 23:34:04');
INSERT INTO `oauth2_refresh_token` VALUES ('ad6f5963c76241e1ad08fefdfe7437bb', 27, 2, 1, '2019-08-28 05:10:29', '2019-08-27 17:10:29', '2019-08-27 17:10:29');
INSERT INTO `oauth2_refresh_token` VALUES ('ad7a45ad2a784cfda293ae268745d1ef', 27, 2, 1, '2019-06-16 06:12:24', '2019-06-15 18:12:23', '2019-06-15 18:12:23');
INSERT INTO `oauth2_refresh_token` VALUES ('ad7d427e6bb146b5bc08d055fba60c1e', 27, 2, 1, '2019-08-02 04:52:17', '2019-08-01 16:52:16', '2019-08-01 16:52:16');
INSERT INTO `oauth2_refresh_token` VALUES ('adae51dca04945e6bf3e662a6cf9ac5e', NULL, NULL, 1, '2019-05-08 08:39:02', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('adcb147ab81b4a4b9fe5d2fdc6206145', NULL, NULL, 1, '2019-05-01 08:09:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('addf389141e34dc4b56ccf25a0be31c3', 27, 2, 1, '2019-08-01 02:16:49', '2019-07-31 14:16:49', '2019-07-31 14:16:49');
INSERT INTO `oauth2_refresh_token` VALUES ('ade30a9e376c4368a56998a1a9597431', 1, 2, 0, '2019-09-05 21:22:56', '2019-09-05 09:22:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('adeffc30227546148a7bfba369420f61', 27, 2, 1, '2019-07-27 12:46:57', '2019-07-27 00:46:57', '2019-07-27 00:46:57');
INSERT INTO `oauth2_refresh_token` VALUES ('adfcbbdfe73a41238719e30d8524f49c', 27, 2, 1, '2019-06-04 03:26:28', '2019-06-03 15:26:27', '2019-06-03 15:26:27');
INSERT INTO `oauth2_refresh_token` VALUES ('ae1a9db7f6284a3094085ad11bb44b0a', 27, 2, 1, '2019-05-23 03:24:28', '2019-05-22 15:24:28', '2019-05-22 15:24:28');
INSERT INTO `oauth2_refresh_token` VALUES ('ae20c464788d4f67bbbe1e532327057a', 27, 2, 1, '2019-08-28 03:29:42', '2019-08-27 15:29:42', '2019-08-27 15:29:42');
INSERT INTO `oauth2_refresh_token` VALUES ('ae3df2de5598423db068f55ab1069b7e', NULL, NULL, 1, '2019-04-26 03:38:40', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ae8949548f4c4e638a122e9f5cff0b92', 27, 2, 1, '2019-07-17 02:09:36', '2019-07-16 14:09:35', '2019-07-16 14:09:35');
INSERT INTO `oauth2_refresh_token` VALUES ('ae8b7bc97f564fcbb58767df4a54e61f', 27, 2, 1, '2019-08-22 04:15:53', '2019-08-21 16:15:53', '2019-08-21 16:15:53');
INSERT INTO `oauth2_refresh_token` VALUES ('ae8e18d2f50b4c51ad74a30d0f1990de', 27, 2, 1, '2019-06-27 23:06:01', '2019-06-27 11:06:01', '2019-06-27 11:06:01');
INSERT INTO `oauth2_refresh_token` VALUES ('ae95d55d1356463284c90d38a95dba2e', 27, 2, 1, '2019-06-12 02:11:18', '2019-06-11 14:11:18', '2019-06-11 14:11:18');
INSERT INTO `oauth2_refresh_token` VALUES ('aea8918542714513848c927a57859d1d', 1, 2, 0, '2019-06-05 02:38:17', '2019-06-04 14:38:16', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('aeb17d0b50dd43b68c08333a8eee17fb', 27, 2, 1, '2019-08-03 09:54:31', '2019-08-02 21:54:31', '2019-08-02 21:54:31');
INSERT INTO `oauth2_refresh_token` VALUES ('aef485b9716c4dcd900165f8b143d27c', 27, 2, 1, '2019-07-30 05:41:44', '2019-07-29 17:41:43', '2019-07-29 17:41:43');
INSERT INTO `oauth2_refresh_token` VALUES ('af070f5a743a412eb0e2804becfbea51', 27, 2, 1, '2019-06-14 01:43:42', '2019-06-13 13:43:42', '2019-06-13 13:43:42');
INSERT INTO `oauth2_refresh_token` VALUES ('af07b7bc3a2447c7b090c0c72cf15883', NULL, NULL, 1, '2019-05-12 20:41:10', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('af0f4819d19e470b9aaa6b48f6a6a34e', 27, 2, 1, '2019-06-03 06:47:06', '2019-06-02 18:47:06', '2019-06-02 18:47:06');
INSERT INTO `oauth2_refresh_token` VALUES ('af10b853f3054d5fb58a548b00a44bf6', 1, 2, 0, '2019-05-27 02:02:44', '2019-05-26 14:02:44', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('af20285fe3b146049a911b6f56815458', 27, 2, 1, '2019-08-06 02:21:08', '2019-08-05 14:21:08', '2019-08-05 14:21:08');
INSERT INTO `oauth2_refresh_token` VALUES ('af24ca5b84c94c3ebd17c33da0acb408', NULL, NULL, 1, '2019-05-09 08:20:27', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('af2a7a4680dc4471b72ce6ec5024d644', 1, 2, 0, '2019-06-05 04:28:48', '2019-06-04 16:28:48', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('af2ba05c8c434744981948891d1ca2ad', 123, 1, 1, '2019-06-13 04:32:42', '2019-06-12 16:32:41', '2019-06-12 16:32:41');
INSERT INTO `oauth2_refresh_token` VALUES ('af3c09a7970b4d4f94ba2576d80e496c', NULL, NULL, 1, '2019-05-05 03:13:12', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('af525a50ab764eaeadf62cf249e1bbea', 1, 2, 0, '2019-06-28 10:22:11', '2019-06-27 22:22:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('af8d7b5632a6498e847389d75e0076e0', 27, 2, 1, '2019-06-06 09:17:38', '2019-06-05 21:17:37', '2019-06-05 21:17:37');
INSERT INTO `oauth2_refresh_token` VALUES ('af926d47aa254555a6c8ccc9255ee29a', NULL, NULL, 1, '2019-05-01 08:06:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('afa25c0c9f0047a1a66d99d119197b5a', NULL, NULL, 1, '2019-03-30 11:39:28', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('afb88688aa5e488f9b09bead58c93979', 27, 2, 1, '2019-05-27 10:35:51', '2019-05-26 22:35:51', '2019-05-26 22:35:51');
INSERT INTO `oauth2_refresh_token` VALUES ('afde2b22880447428c4b075f3a083830', NULL, NULL, 1, '2019-03-16 07:23:09', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('afefa066abb34aa8a0026d8466724315', 27, 2, 1, '2019-05-29 02:41:11', '2019-05-28 14:41:11', '2019-05-28 14:41:11');
INSERT INTO `oauth2_refresh_token` VALUES ('affd3c113ec24079918a434ee2221f7b', 1, 2, 0, '2019-06-30 11:20:43', '2019-06-29 23:20:30', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('b035e1049dda4d9d8370342588d34b5b', 27, 2, 1, '2019-06-15 02:33:59', '2019-06-14 14:33:59', '2019-06-14 14:33:59');
INSERT INTO `oauth2_refresh_token` VALUES ('b04ce488566d464bae757383f30241e3', NULL, NULL, 1, '2019-05-06 00:55:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b05908bc65e54c419646fc8b94deacfe', NULL, NULL, 0, '2019-02-28 22:30:33', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b06de39326e54b35979b78b89a269284', 27, 2, 1, '2019-08-19 05:08:32', '2019-08-18 17:08:32', '2019-08-18 17:08:32');
INSERT INTO `oauth2_refresh_token` VALUES ('b0777ddec4a8471899bcd27f6466e6f9', 1, 2, 0, '2019-06-05 21:45:49', '2019-06-05 09:45:48', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('b07c7a3905fe4f1f87cc379f084dd30f', 1, 2, 0, '2019-07-03 02:24:46', '2019-07-02 14:24:45', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('b0935e3724014adb89bd31dbda638417', NULL, NULL, 1, '2019-05-10 02:26:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b0939f1c07a14c4392f77fe32d08d389', 27, 2, 1, '2019-07-30 21:11:01', '2019-07-30 09:11:01', '2019-07-30 09:11:01');
INSERT INTO `oauth2_refresh_token` VALUES ('b0b1d11485d54aa597bfe2087b495c55', 27, 2, 1, '2019-07-03 02:16:33', '2019-07-02 14:16:32', '2019-07-02 14:16:32');
INSERT INTO `oauth2_refresh_token` VALUES ('b0ecf7b7094b4773a8a441f1627da7dc', NULL, NULL, 1, '2019-03-13 11:58:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b0f520088c374276b15b58e22daeac6f', 27, 2, 1, '2019-09-04 20:15:41', '2019-09-04 08:15:40', '2019-09-04 08:15:40');
INSERT INTO `oauth2_refresh_token` VALUES ('b110816197194eeb94d3f000089533a0', 27, 2, 1, '2019-06-28 22:34:56', '2019-06-28 10:34:56', '2019-06-28 10:34:56');
INSERT INTO `oauth2_refresh_token` VALUES ('b14a07e222e44a49a88e229daa4d2d7f', 27, 2, 1, '2019-08-29 05:19:25', '2019-08-28 17:19:24', '2019-08-28 17:19:24');
INSERT INTO `oauth2_refresh_token` VALUES ('b1513569421a436bb39f1629b4707b46', NULL, NULL, 1, '2019-04-02 01:09:13', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b1657c8a04e645c186677367814ce777', 27, 2, 1, '2019-07-18 02:40:19', '2019-07-17 14:40:18', '2019-07-17 14:40:18');
INSERT INTO `oauth2_refresh_token` VALUES ('b166715387574a7fa256b6a9d3b66031', 27, 2, 1, '2019-06-03 21:21:13', '2019-06-03 09:21:13', '2019-06-03 09:21:13');
INSERT INTO `oauth2_refresh_token` VALUES ('b169a3529be0458f80aa5d0fb18b304f', 27, 2, 1, '2019-06-04 03:27:00', '2019-06-03 15:27:00', '2019-06-03 15:27:00');
INSERT INTO `oauth2_refresh_token` VALUES ('b16e8258f3f743e983b2ca63b53d88be', 27, 2, 1, '2019-07-26 01:29:20', '2019-07-25 13:29:19', '2019-07-25 13:29:19');
INSERT INTO `oauth2_refresh_token` VALUES ('b175f039cfc54222bf05376e673e9c15', 27, 2, 1, '2019-07-31 05:28:01', '2019-07-30 17:28:01', '2019-07-30 17:28:01');
INSERT INTO `oauth2_refresh_token` VALUES ('b17bb2a70559489a97d6d77a8a40020a', 27, 2, 1, '2019-06-18 23:33:32', '2019-06-18 11:33:32', '2019-06-18 11:33:32');
INSERT INTO `oauth2_refresh_token` VALUES ('b17c04f01fcd4063b824420eacdda05b', 27, 2, 1, '2019-06-05 07:02:09', '2019-06-04 19:02:08', '2019-06-04 19:02:08');
INSERT INTO `oauth2_refresh_token` VALUES ('b1af96f8cfe741baab18886806c7e92b', NULL, NULL, 1, '2019-05-13 11:26:03', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b1b59a4c0f6e493f84205d18f49a1574', 27, 2, 1, '2019-06-05 03:43:40', '2019-06-04 15:43:40', '2019-06-04 15:43:40');
INSERT INTO `oauth2_refresh_token` VALUES ('b1b903e9a8704c4faa1ce768774c2c56', 27, 2, 1, '2019-07-18 22:35:27', '2019-07-18 10:35:27', '2019-07-18 10:35:27');
INSERT INTO `oauth2_refresh_token` VALUES ('b1d04067565f4967ac2660664fe283f7', NULL, NULL, 1, '2019-04-30 04:17:17', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b1ec41f1c8d442e8b89fc3cac5e458fd', 27, 2, 1, '2019-08-22 05:02:22', '2019-08-21 17:02:22', '2019-08-21 17:02:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b211932b6a1f4bc7bcd6a5f16199d7c5', 22, 2, 1, '2019-07-01 21:54:01', '2019-07-01 09:54:01', '2019-07-01 09:54:01');
INSERT INTO `oauth2_refresh_token` VALUES ('b24e74bad830478097aaa71cbd867950', 27, 2, 1, '2019-06-02 03:04:25', '2019-06-01 15:04:25', '2019-06-01 15:04:25');
INSERT INTO `oauth2_refresh_token` VALUES ('b252ac9721754c5db65667b8e32f1301', 27, 2, 1, '2019-07-25 06:12:45', '2019-07-24 18:12:44', '2019-07-24 18:12:44');
INSERT INTO `oauth2_refresh_token` VALUES ('b272dd3ce156490aac5838687e9894ae', 27, 2, 1, '2019-06-05 08:27:25', '2019-06-04 20:27:25', '2019-06-04 20:27:25');
INSERT INTO `oauth2_refresh_token` VALUES ('b2752390170043a99989ed0ba9b2548d', 1, 2, 0, '2019-09-06 22:55:55', '2019-09-06 10:55:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('b290704811e64877a86efbfb914d1b03', 27, 2, 1, '2019-06-13 02:32:33', '2019-06-12 14:32:33', '2019-06-12 14:32:33');
INSERT INTO `oauth2_refresh_token` VALUES ('b299c368cf594b2ab5f224dd84860aba', 26, 2, 1, '2019-06-05 00:47:38', '2019-06-04 12:47:37', '2019-06-04 12:47:37');
INSERT INTO `oauth2_refresh_token` VALUES ('b2a1abc25f4849199e77df79f9943036', 27, 2, 1, '2019-08-22 23:33:32', '2019-08-22 11:33:31', '2019-08-22 11:33:31');
INSERT INTO `oauth2_refresh_token` VALUES ('b2a8bac9e8ec4338b4111608b6f5a446', 27, 2, 1, '2019-05-18 13:20:28', '2019-05-18 01:20:28', '2019-05-18 01:20:28');
INSERT INTO `oauth2_refresh_token` VALUES ('b2af4e6de41c49fa955ca2b96c3d4ecf', 1, 2, 0, '2019-09-07 11:16:41', '2019-09-06 23:16:40', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('b2c0228878664d059f1f3c87b8f87446', 27, 2, 1, '2019-06-13 07:11:04', '2019-06-12 19:11:03', '2019-06-12 19:11:03');
INSERT INTO `oauth2_refresh_token` VALUES ('b2d0aeb3a1c84a068f40de7da6f90cba', 27, 2, 1, '2019-06-03 06:48:06', '2019-06-02 18:48:06', '2019-06-02 18:48:06');
INSERT INTO `oauth2_refresh_token` VALUES ('b2e22f533e9b4f4c9b943d98c0597cd8', 146, 1, 1, '2019-07-02 07:05:10', '2019-07-01 19:05:09', '2019-07-01 19:05:09');
INSERT INTO `oauth2_refresh_token` VALUES ('b2fed102e1e04bd2a2d90c2a4f3b1e49', 27, 2, 1, '2019-07-19 02:56:05', '2019-07-18 14:56:04', '2019-07-18 14:56:04');
INSERT INTO `oauth2_refresh_token` VALUES ('b3145893956e4da5a354695f3000b578', 27, 2, 1, '2019-07-13 21:26:00', '2019-07-13 09:26:00', '2019-07-13 09:26:00');
INSERT INTO `oauth2_refresh_token` VALUES ('b33b60d6300b490fafb9cc1affc7dc98', 27, 2, 1, '2019-07-02 22:06:28', '2019-07-02 10:06:28', '2019-07-02 10:06:28');
INSERT INTO `oauth2_refresh_token` VALUES ('b3405fbce793425c8c671553c0cc3bde', 27, 2, 1, '2019-06-13 22:57:40', '2019-06-13 10:57:39', '2019-06-13 10:57:39');
INSERT INTO `oauth2_refresh_token` VALUES ('b34cc7a38c414351a0bd0b3e835bca86', 27, 2, 1, '2019-06-02 06:25:36', '2019-06-01 18:25:36', '2019-06-01 18:25:36');
INSERT INTO `oauth2_refresh_token` VALUES ('b35ec70325ef4aed862be4de572d65bc', 27, 2, 1, '2019-07-01 08:20:59', '2019-06-30 20:20:59', '2019-06-30 20:20:59');
INSERT INTO `oauth2_refresh_token` VALUES ('b35f35b6a7214b0aba7958640e6c2f37', 27, 2, 1, '2019-07-17 01:51:54', '2019-07-16 13:51:53', '2019-07-16 13:51:53');
INSERT INTO `oauth2_refresh_token` VALUES ('b3634d149e6e45659fabd57b10b73a95', 27, 2, 1, '2019-06-07 05:27:55', '2019-06-06 17:27:55', '2019-06-06 17:27:55');
INSERT INTO `oauth2_refresh_token` VALUES ('b3868bf7996a4f08bcbeb7ec3e129618', 27, 2, 1, '2019-08-15 06:23:47', '2019-08-14 18:23:47', '2019-08-14 18:23:47');
INSERT INTO `oauth2_refresh_token` VALUES ('b38a30926c8e4dc7afa636b6e15c2843', 27, 2, 1, '2019-06-13 05:28:08', '2019-06-12 17:28:07', '2019-06-12 17:28:07');
INSERT INTO `oauth2_refresh_token` VALUES ('b39ec5b645ba48a49c2d4c66f5970e59', 27, 2, 1, '2019-06-04 23:21:22', '2019-06-04 11:21:21', '2019-06-04 11:21:21');
INSERT INTO `oauth2_refresh_token` VALUES ('b3a613cbfa1f4b1e8659c3d7cf76450f', 27, 2, 1, '2019-07-17 07:21:06', '2019-07-16 19:21:06', '2019-07-16 19:21:06');
INSERT INTO `oauth2_refresh_token` VALUES ('b3afc54787b542a0ba5ecb7e8b4a9367', 27, 2, 1, '2019-08-09 22:18:29', '2019-08-09 10:18:29', '2019-08-09 10:18:29');
INSERT INTO `oauth2_refresh_token` VALUES ('b3e0d6df90274cd4b9c2f98eab6f50a7', NULL, NULL, 1, '2019-04-02 02:00:34', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b3e93531bda34601b4229c5589bfbd6a', 27, 2, 1, '2019-06-03 02:14:38', '2019-06-02 14:14:37', '2019-06-02 14:14:37');
INSERT INTO `oauth2_refresh_token` VALUES ('b400239f362e4327a0e81d818c6293cc', 27, 2, 1, '2019-06-18 22:44:55', '2019-06-18 10:44:55', '2019-06-18 10:44:55');
INSERT INTO `oauth2_refresh_token` VALUES ('b404af2073464cadb77beab09d50ea36', 27, 2, 1, '2019-06-20 21:14:53', '2019-06-20 09:14:53', '2019-06-20 09:14:53');
INSERT INTO `oauth2_refresh_token` VALUES ('b4215804b4c94ba5987534fb8771005e', 106, 1, 1, '2019-06-05 08:26:23', '2019-06-04 20:26:22', '2019-06-04 20:26:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b43690f211ec43f2bab160dd3317ab84', 27, 2, 1, '2019-06-02 01:15:49', '2019-06-01 13:15:48', '2019-06-01 13:15:48');
INSERT INTO `oauth2_refresh_token` VALUES ('b457f3a270044a05b5e4a0640f7e446d', 27, 2, 1, '2019-08-29 10:10:41', '2019-08-28 22:10:41', '2019-08-28 22:10:41');
INSERT INTO `oauth2_refresh_token` VALUES ('b467dc41c7b04a69984f3e54630addc3', 27, 2, 1, '2019-05-29 01:20:00', '2019-05-28 13:19:59', '2019-05-28 13:19:59');
INSERT INTO `oauth2_refresh_token` VALUES ('b47752af455a42e49476c8c1447f3292', 27, 2, 1, '2019-07-06 21:57:22', '2019-07-06 09:57:21', '2019-07-06 09:57:21');
INSERT INTO `oauth2_refresh_token` VALUES ('b48675c496fd4ac1a34318a19ae6cf10', NULL, NULL, 1, '2019-05-06 00:55:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b48cd8184c554ae194197021205d7e00', 27, 2, 1, '2019-06-26 23:04:06', '2019-06-26 11:04:05', '2019-06-26 11:04:05');
INSERT INTO `oauth2_refresh_token` VALUES ('b49560247ab342d98dca2e4c93e8323b', 27, 2, 1, '2019-08-15 21:47:36', '2019-08-15 09:47:35', '2019-08-15 09:47:35');
INSERT INTO `oauth2_refresh_token` VALUES ('b4be2b6648db42a1be6b19d97daa803d', 27, 2, 1, '2019-05-31 03:04:25', '2019-05-30 15:04:25', '2019-05-30 15:04:25');
INSERT INTO `oauth2_refresh_token` VALUES ('b4cdde90e7ed40caba3775bd70403686', 27, 2, 1, '2019-06-01 22:37:47', '2019-06-01 10:37:47', '2019-06-01 10:37:47');
INSERT INTO `oauth2_refresh_token` VALUES ('b4d1839b9228477d84d1cc28728333ea', 27, 2, 1, '2019-05-27 21:26:33', '2019-05-27 09:26:32', '2019-05-27 09:26:32');
INSERT INTO `oauth2_refresh_token` VALUES ('b4fb6c06225544459ade3200befa30fb', 27, 2, 1, '2019-06-05 05:04:29', '2019-06-04 17:04:28', '2019-06-04 17:04:28');
INSERT INTO `oauth2_refresh_token` VALUES ('b5390c6e73e840a6b0f04e4b9f7c56bd', 27, 2, 1, '2019-06-09 23:45:41', '2019-06-09 11:45:41', '2019-06-09 11:45:41');
INSERT INTO `oauth2_refresh_token` VALUES ('b54887d0f6154645846d07e89ca13029', 1, 2, 0, '2019-06-08 06:24:58', '2019-06-07 18:24:58', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('b5609cd856044d93bb38be1d2d1e5778', 27, 2, 1, '2019-06-01 05:36:39', '2019-05-31 17:36:38', '2019-05-31 17:36:38');
INSERT INTO `oauth2_refresh_token` VALUES ('b5714ddf4ea94cb6a42fb1ddf5f68ec7', 27, 2, 1, '2019-08-14 03:40:21', '2019-08-13 15:40:21', '2019-08-13 15:40:21');
INSERT INTO `oauth2_refresh_token` VALUES ('b574b29987f748d288d539e372b6893b', NULL, NULL, 1, '2019-05-11 01:30:17', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b59377af3ca74b4ea5aa0c6266be9b20', 27, 2, 1, '2019-08-30 01:51:41', '2019-08-29 13:51:40', '2019-08-29 13:51:40');
INSERT INTO `oauth2_refresh_token` VALUES ('b5a8ff418b5242998882018d7cf41169', 27, 2, 1, '2019-08-21 05:43:18', '2019-08-20 17:43:17', '2019-08-20 17:43:17');
INSERT INTO `oauth2_refresh_token` VALUES ('b5ff33f75629495b8aedb9ae27dfa04e', 105, 1, 1, '2019-06-05 04:31:46', '2019-06-04 16:31:46', '2019-06-04 16:31:46');
INSERT INTO `oauth2_refresh_token` VALUES ('b6016745db86453fb508ba6eba7258dc', 27, 2, 1, '2019-07-30 06:12:45', '2019-07-29 18:12:44', '2019-07-29 18:12:44');
INSERT INTO `oauth2_refresh_token` VALUES ('b61374200b754c739bf2e2f9c990fc26', 27, 2, 1, '2019-06-13 12:47:31', '2019-06-13 00:47:31', '2019-06-13 00:47:31');
INSERT INTO `oauth2_refresh_token` VALUES ('b630d8c32c924e35b9d11fc8606c17f0', 1, 2, 0, '2019-06-01 03:20:44', '2019-05-31 15:19:24', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('b66c4078985c402da620fad36c43b1a0', 27, 2, 1, '2019-05-25 05:43:26', '2019-05-24 17:43:26', '2019-05-24 17:43:26');
INSERT INTO `oauth2_refresh_token` VALUES ('b677d07daf944b9eb2a86c65a4e564d3', 27, 2, 1, '2019-06-29 10:31:41', '2019-06-28 22:31:41', '2019-06-28 22:31:41');
INSERT INTO `oauth2_refresh_token` VALUES ('b684f41ee7b449059ec49c102dae79eb', 120, 1, 1, '2019-06-12 07:30:48', '2019-06-11 19:30:13', '2019-06-11 19:30:13');
INSERT INTO `oauth2_refresh_token` VALUES ('b696a95c1ef7417a8596b64696d8eabc', NULL, NULL, 1, '2019-05-10 03:38:01', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b6992eb011db4d5fa24758e6f4c5be59', 27, 2, 1, '2019-06-15 11:02:19', '2019-06-14 23:02:18', '2019-06-14 23:02:18');
INSERT INTO `oauth2_refresh_token` VALUES ('b69a667333b04a0fb45b4755f9f13a31', 27, 2, 1, '2019-06-06 10:16:05', '2019-06-05 22:16:04', '2019-06-05 22:16:04');
INSERT INTO `oauth2_refresh_token` VALUES ('b6a1da473a414670a0c662f5872f3cc8', 1, 2, 0, '2019-06-05 04:56:15', '2019-06-04 16:56:15', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('b6b688f7568747f9a1180b8362525774', 27, 2, 1, '2019-08-08 05:44:50', '2019-08-07 17:44:49', '2019-08-07 17:44:49');
INSERT INTO `oauth2_refresh_token` VALUES ('b6dbcd6bedbb49b6ada5657fc49e5bb9', 27, 2, 1, '2019-06-04 02:33:30', '2019-06-03 14:33:30', '2019-06-03 14:33:30');
INSERT INTO `oauth2_refresh_token` VALUES ('b6e7c5af1d3d4cf7bb63f3113de0bcfa', 27, 2, 1, '2019-08-21 23:49:18', '2019-08-21 11:49:18', '2019-08-21 11:49:18');
INSERT INTO `oauth2_refresh_token` VALUES ('b6fab3bfba914bbd8f8035a1d86fb45e', 27, 2, 1, '2019-06-07 02:10:06', '2019-06-06 14:10:06', '2019-06-06 14:10:06');
INSERT INTO `oauth2_refresh_token` VALUES ('b705f4554f1d489e93a8e9eb231a2b08', 27, 2, 1, '2019-08-16 22:27:58', '2019-08-16 10:27:57', '2019-08-16 10:27:57');
INSERT INTO `oauth2_refresh_token` VALUES ('b707f992ddd34c109b2201439e7dc664', 27, 2, 1, '2019-06-03 03:46:22', '2019-06-02 15:46:21', '2019-06-02 15:46:21');
INSERT INTO `oauth2_refresh_token` VALUES ('b70a921b55674c1cb8ce83ee9693a068', 27, 2, 1, '2019-09-04 10:13:53', '2019-09-03 22:13:53', '2019-09-03 22:13:53');
INSERT INTO `oauth2_refresh_token` VALUES ('b70aa00ae0b94ea1aa48e11ed7d08610', 27, 2, 1, '2019-07-07 10:13:31', '2019-07-06 22:13:30', '2019-07-06 22:13:30');
INSERT INTO `oauth2_refresh_token` VALUES ('b710c67478ba4754a2d7deb9da7cb993', 27, 2, 1, '2019-06-01 10:37:54', '2019-05-31 22:37:53', '2019-05-31 22:37:53');
INSERT INTO `oauth2_refresh_token` VALUES ('b72268813a2a40d7a58d758f9938de16', NULL, NULL, 1, '2019-03-31 11:08:52', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b72bc84af39f493097e83b3ccbd84e9d', NULL, NULL, 1, '2019-04-29 03:33:31', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b7454e02d8a2415c92aeb4ba099685f9', 27, 2, 1, '2019-05-30 09:45:51', '2019-05-29 21:45:50', '2019-05-29 21:45:50');
INSERT INTO `oauth2_refresh_token` VALUES ('b74954fd87dd475e9b5ed18b3e8d6ed6', 27, 2, 1, '2019-08-14 20:27:49', '2019-08-14 08:27:48', '2019-08-14 08:27:48');
INSERT INTO `oauth2_refresh_token` VALUES ('b752c451020943cb84dacfc33541146d', NULL, NULL, 1, '2019-04-12 05:33:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b76cbedcad574d0793ca0623afdc08cd', 27, 2, 1, '2019-09-02 23:05:50', '2019-09-02 11:05:49', '2019-09-02 11:05:49');
INSERT INTO `oauth2_refresh_token` VALUES ('b7707bb296cf4671ad11082c4626a7da', 1, 2, 0, '2019-06-12 10:01:14', '2019-06-11 22:01:14', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('b77e4088d81649c69c3200c683456237', NULL, NULL, 1, '2019-05-07 01:02:48', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b797e00a211a4b1cb80e64f52e45d99a', 27, 2, 1, '2019-07-26 22:21:06', '2019-07-26 10:21:06', '2019-07-26 10:21:06');
INSERT INTO `oauth2_refresh_token` VALUES ('b79fe8df74ce48f7b678ad41520f4a83', 27, 2, 1, '2019-06-01 05:31:09', '2019-05-31 17:31:08', '2019-05-31 17:31:08');
INSERT INTO `oauth2_refresh_token` VALUES ('b7a03d9a00644aecba1594dc9824a410', 27, 2, 1, '2019-08-13 05:25:48', '2019-08-12 17:25:47', '2019-08-12 17:25:47');
INSERT INTO `oauth2_refresh_token` VALUES ('b7b3fd12515d41c381353af7129cc5a1', NULL, NULL, 1, '2019-04-28 10:03:42', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b7c40d8627e440fc9a9db0675d5390f5', 27, 2, 1, '2019-08-10 11:24:53', '2019-08-09 23:24:52', '2019-08-09 23:24:52');
INSERT INTO `oauth2_refresh_token` VALUES ('b7e29ab9e28b4d38a4baad569f86f9fe', 27, 2, 1, '2019-06-03 07:36:49', '2019-06-02 19:36:48', '2019-06-02 19:36:48');
INSERT INTO `oauth2_refresh_token` VALUES ('b806e87aad804cd2a20e8fdfbc8368a7', 27, 2, 1, '2019-07-12 21:48:52', '2019-07-12 09:48:52', '2019-07-12 09:48:52');
INSERT INTO `oauth2_refresh_token` VALUES ('b80b7da02fda4afd9be7d36c7ca7bf8e', 27, 2, 1, '2019-06-01 23:19:52', '2019-06-01 11:19:51', '2019-06-01 11:19:51');
INSERT INTO `oauth2_refresh_token` VALUES ('b84b1b4e7350422fb46f57138589a7bd', 27, 2, 1, '2019-08-26 02:12:31', '2019-08-25 14:12:30', '2019-08-25 14:12:30');
INSERT INTO `oauth2_refresh_token` VALUES ('b84e22f153d2497e83ebdd970a0756a7', 27, 2, 1, '2019-08-15 03:45:08', '2019-08-14 15:45:07', '2019-08-14 15:45:07');
INSERT INTO `oauth2_refresh_token` VALUES ('b850806c051040dc886e0f7a7f1dfa30', 27, 2, 1, '2019-08-06 04:10:35', '2019-08-05 16:10:34', '2019-08-05 16:10:34');
INSERT INTO `oauth2_refresh_token` VALUES ('b8555c5374514d9d9d569b5ed54094a9', NULL, NULL, 1, '2019-05-09 02:16:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b870dd124cdd41ef894f2e5b2542920a', NULL, NULL, 0, '2019-03-04 14:17:39', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b894022c0d4243a6aa75d1e3791d6d3c', 27, 2, 1, '2019-07-01 21:52:21', '2019-07-01 09:52:21', '2019-07-01 09:52:21');
INSERT INTO `oauth2_refresh_token` VALUES ('b8ac4e78389649019947d951e490f5d4', 27, 2, 1, '2019-06-15 12:42:20', '2019-06-15 00:42:20', '2019-06-15 00:42:20');
INSERT INTO `oauth2_refresh_token` VALUES ('b8b7b34481ad4119a06c5f03de50f780', 27, 2, 1, '2019-06-25 08:50:21', '2019-06-24 20:50:20', '2019-06-24 20:50:20');
INSERT INTO `oauth2_refresh_token` VALUES ('b8c558def7c749a781bcd52d0fcd96b6', 27, 2, 1, '2019-07-04 23:00:36', '2019-07-04 11:00:35', '2019-07-04 11:00:35');
INSERT INTO `oauth2_refresh_token` VALUES ('b8c5d01ba32b4cf0a9fe8e4a68a8483f', 1, 2, 0, '2019-05-29 04:22:47', '2019-05-28 16:21:28', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('b8cf666f251c45cd8e69fe24c9698100', NULL, NULL, 1, '2019-05-10 03:36:16', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b8d5df0bb9a842268f819da04b88432d', 27, 2, 1, '2019-06-03 21:17:52', '2019-06-03 09:17:51', '2019-06-03 09:17:51');
INSERT INTO `oauth2_refresh_token` VALUES ('b8d91aea0fc04fd38d1f6b9a9b756f95', 27, 2, 1, '2019-06-21 07:19:57', '2019-06-20 19:19:57', '2019-06-20 19:19:57');
INSERT INTO `oauth2_refresh_token` VALUES ('b8da8e150f8b4722b14f57fc1a76b6f1', NULL, NULL, 1, '2019-05-09 02:41:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b8eb3f9638d94effb13eec205977472a', NULL, NULL, 1, '2019-03-31 05:13:03', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b8f4d52f51984a5dacf6ca6668795a32', 27, 2, 1, '2019-07-17 05:00:00', '2019-07-16 16:59:59', '2019-07-16 16:59:59');
INSERT INTO `oauth2_refresh_token` VALUES ('b905d28a26544993a4bc57e1d74a8a48', 27, 2, 1, '2019-06-04 22:26:35', '2019-06-04 10:26:35', '2019-06-04 10:26:35');
INSERT INTO `oauth2_refresh_token` VALUES ('b909ef7462ca4826bb4b9acbee54cc5d', 27, 2, 1, '2019-06-18 04:17:06', '2019-06-17 16:17:06', '2019-06-17 16:17:06');
INSERT INTO `oauth2_refresh_token` VALUES ('b910843332d04f309b557f1a115c3143', 27, 2, 1, '2019-07-08 03:17:48', '2019-07-07 15:17:47', '2019-07-07 15:17:47');
INSERT INTO `oauth2_refresh_token` VALUES ('b92ba63a515c42ccb0aadd3c0f8f5bfb', 27, 2, 1, '2019-06-09 04:13:34', '2019-06-08 16:13:34', '2019-06-08 16:13:34');
INSERT INTO `oauth2_refresh_token` VALUES ('b94e69641eae447ebf1c3260a6e247ff', 27, 2, 1, '2019-06-07 01:19:36', '2019-06-06 13:19:35', '2019-06-06 13:19:35');
INSERT INTO `oauth2_refresh_token` VALUES ('b96758b1dbc144b39a525e8d36f86a5f', 27, 2, 1, '2019-05-30 21:35:43', '2019-05-30 09:35:43', '2019-05-30 09:35:43');
INSERT INTO `oauth2_refresh_token` VALUES ('b96a278fdb2746cda68b4d532cbc15f0', 27, 2, 1, '2019-06-14 21:05:29', '2019-06-14 09:05:28', '2019-06-14 09:05:28');
INSERT INTO `oauth2_refresh_token` VALUES ('b96facf988f0477ba1a369a0caf57549', 27, 2, 1, '2019-06-01 23:19:09', '2019-06-01 11:19:09', '2019-06-01 11:19:09');
INSERT INTO `oauth2_refresh_token` VALUES ('b98845419bdf4ccf92670cb4ba39221b', 159, 1, 1, '2019-07-08 05:57:21', '2019-07-07 17:57:20', '2019-07-07 17:57:20');
INSERT INTO `oauth2_refresh_token` VALUES ('b996bac3fd1343009aba9042d6588475', 27, 2, 1, '2019-08-14 00:26:40', '2019-08-13 12:26:40', '2019-08-13 12:26:40');
INSERT INTO `oauth2_refresh_token` VALUES ('b99b00177a59455fa4c8f33060bfb600', 27, 2, 1, '2019-06-12 02:41:54', '2019-06-11 14:41:53', '2019-06-11 14:41:53');
INSERT INTO `oauth2_refresh_token` VALUES ('b9a35dc5c5054a5bbed3f981c2c738b8', 1, 2, 0, '2019-07-09 05:28:45', '2019-07-08 17:28:45', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('b9a6f0824012420881219b07becb36c6', 27, 2, 1, '2019-07-17 19:34:05', '2019-07-17 07:34:05', '2019-07-17 07:34:05');
INSERT INTO `oauth2_refresh_token` VALUES ('b9b47cec9bb6461c9fd66397efdd86de', 27, 2, 1, '2019-06-04 03:26:51', '2019-06-03 15:26:51', '2019-06-03 15:26:51');
INSERT INTO `oauth2_refresh_token` VALUES ('b9c2915de03f447ab51cec998a9dff8d', 27, 2, 1, '2019-06-01 04:43:36', '2019-05-31 16:43:36', '2019-05-31 16:43:36');
INSERT INTO `oauth2_refresh_token` VALUES ('b9c670ab4dee48a0a5b9a52fd0e54b29', NULL, NULL, 1, '2019-05-11 00:23:27', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('b9e7197ac64941b09bbf0c348095f8e4', 27, 2, 1, '2019-08-30 03:43:02', '2019-08-29 15:43:02', '2019-08-29 15:43:02');
INSERT INTO `oauth2_refresh_token` VALUES ('b9f08e4a5bba4272a8d82c727261af47', 27, 2, 1, '2019-07-17 05:46:07', '2019-07-16 17:46:06', '2019-07-16 17:46:06');
INSERT INTO `oauth2_refresh_token` VALUES ('ba05d3607cf5483694c6b2b5910d1640', 27, 2, 1, '2019-07-10 05:18:39', '2019-07-09 17:18:38', '2019-07-09 17:18:38');
INSERT INTO `oauth2_refresh_token` VALUES ('ba1b2bfa1cd7456b9b382241e6d26488', 128, 1, 1, '2019-07-12 05:29:01', '2019-07-11 17:29:00', '2019-07-11 17:29:00');
INSERT INTO `oauth2_refresh_token` VALUES ('ba1cccd09d4147a582e73c1ab19a88c7', 132, 1, 1, '2019-06-22 02:43:21', '2019-06-21 14:43:20', '2019-06-21 14:43:20');
INSERT INTO `oauth2_refresh_token` VALUES ('ba1fa4c35bc148f3a8ad8b73ef8101a5', 27, 2, 1, '2019-07-13 02:32:41', '2019-07-12 14:32:41', '2019-07-12 14:32:41');
INSERT INTO `oauth2_refresh_token` VALUES ('ba1ffd5d363342cfac0785e2d99f2f1c', 27, 2, 1, '2019-07-09 23:18:51', '2019-07-09 11:18:50', '2019-07-09 11:18:50');
INSERT INTO `oauth2_refresh_token` VALUES ('ba21b6b196ce44378a2682dabdd50ba0', 27, 2, 1, '2019-08-06 02:21:49', '2019-08-05 14:21:48', '2019-08-05 14:21:48');
INSERT INTO `oauth2_refresh_token` VALUES ('ba229229a95c4f319546cdaa76e7d207', 27, 2, 1, '2019-06-02 04:38:17', '2019-06-01 16:38:17', '2019-06-01 16:38:17');
INSERT INTO `oauth2_refresh_token` VALUES ('ba51b8c847c349b5bc189b93fc8738cd', 1, 2, 0, '2019-08-03 02:28:48', '2019-08-02 14:28:48', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ba590a655e1842f6b6cf1b30f640b632', 27, 2, 1, '2019-06-11 05:57:13', '2019-06-10 17:57:13', '2019-06-10 17:57:13');
INSERT INTO `oauth2_refresh_token` VALUES ('ba6783efbb3b433587190f09f6ccb9dd', 27, 2, 1, '2019-06-07 05:17:20', '2019-06-06 17:17:20', '2019-06-06 17:17:20');
INSERT INTO `oauth2_refresh_token` VALUES ('ba6db75b25e24baea14602786b5cd250', 27, 2, 1, '2019-08-26 22:31:57', '2019-08-26 10:31:56', '2019-08-26 10:31:56');
INSERT INTO `oauth2_refresh_token` VALUES ('ba732104c5d047f68ae05c048c2b1b0e', NULL, NULL, 1, '2019-05-09 11:00:54', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ba7a3b271f8944c9a4b773c5e6af12f1', 27, 2, 1, '2019-07-18 23:24:06', '2019-07-18 11:24:05', '2019-07-18 11:24:05');
INSERT INTO `oauth2_refresh_token` VALUES ('ba7b2160a4b6424abfee6d1b62c8c7b0', 27, 2, 1, '2019-06-03 00:57:39', '2019-06-02 12:57:39', '2019-06-02 12:57:39');
INSERT INTO `oauth2_refresh_token` VALUES ('baa06d279ef7475c9a6b6017bb0dc53f', 27, 2, 1, '2019-06-03 20:57:42', '2019-06-03 08:57:42', '2019-06-03 08:57:42');
INSERT INTO `oauth2_refresh_token` VALUES ('baa33d635a9148069e5c92e523d8ac2d', 27, 2, 1, '2019-07-04 02:46:57', '2019-07-03 14:46:56', '2019-07-03 14:46:56');
INSERT INTO `oauth2_refresh_token` VALUES ('baa75298448b4b76a1bad4fd76a0596b', 27, 2, 1, '2019-06-04 23:48:05', '2019-06-04 11:48:04', '2019-06-04 11:48:04');
INSERT INTO `oauth2_refresh_token` VALUES ('bada7f2c258248b1b8278378dca64a6b', NULL, NULL, 0, '2019-03-05 13:26:21', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('bade320c289140ae9ea283f516d2d121', 27, 2, 1, '2019-08-23 21:35:48', '2019-08-23 09:35:48', '2019-08-23 09:35:48');
INSERT INTO `oauth2_refresh_token` VALUES ('bae4139f35ce4dd09ea660c45ebbc07f', 27, 2, 1, '2019-07-05 22:48:21', '2019-07-05 10:48:21', '2019-07-05 10:48:21');
INSERT INTO `oauth2_refresh_token` VALUES ('baf38b2610364bfc9d92a5066f683002', 27, 2, 1, '2019-05-30 05:56:18', '2019-05-29 17:56:17', '2019-05-29 17:56:17');
INSERT INTO `oauth2_refresh_token` VALUES ('baf5844b2fb249378c703044ea998f0e', 27, 2, 1, '2019-08-16 04:45:17', '2019-08-15 16:45:17', '2019-08-15 16:45:17');
INSERT INTO `oauth2_refresh_token` VALUES ('baf5f0c04df749dd946f2fe8b63dcf0a', 27, 2, 1, '2019-07-17 01:58:53', '2019-07-16 13:58:53', '2019-07-16 13:58:53');
INSERT INTO `oauth2_refresh_token` VALUES ('baffedb535b74f5e9191e969ea721762', 27, 2, 1, '2019-08-13 00:06:49', '2019-08-12 12:06:48', '2019-08-12 12:06:48');
INSERT INTO `oauth2_refresh_token` VALUES ('bb0959cea4464780890521c11567db0a', 128, 1, 1, '2019-09-05 06:24:07', '2019-09-04 18:24:06', '2019-09-04 18:24:06');
INSERT INTO `oauth2_refresh_token` VALUES ('bb0da8bd41574deeb5383a4145a45f40', 27, 2, 1, '2019-08-14 00:01:09', '2019-08-13 12:01:08', '2019-08-13 12:01:08');
INSERT INTO `oauth2_refresh_token` VALUES ('bb11d92976204127a390f642341ad093', NULL, NULL, 1, '2019-05-10 11:45:48', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('bb1867b57bed4665aad32fb268b41ffd', 27, 2, 1, '2019-07-18 21:39:48', '2019-07-18 09:39:48', '2019-07-18 09:39:48');
INSERT INTO `oauth2_refresh_token` VALUES ('bb25c1d229bb43fb9f65bffe40b0e860', NULL, NULL, 0, '2019-02-28 21:00:52', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('bb263fed57384ad88a37c39bd4c9eda2', NULL, NULL, 1, '2019-05-01 08:51:06', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('bb3ba34a1bd24647aa82d626796816b7', 27, 2, 1, '2019-07-19 05:23:59', '2019-07-18 17:23:59', '2019-07-18 17:23:59');
INSERT INTO `oauth2_refresh_token` VALUES ('bb6e0c04c41b4da6b8108dd3078893a6', NULL, NULL, 1, '2019-03-31 22:27:37', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('bb7509a6824e4be8b5b2b73a464f6a2a', 27, 2, 1, '2019-06-05 07:55:31', '2019-06-04 19:55:31', '2019-06-04 19:55:31');
INSERT INTO `oauth2_refresh_token` VALUES ('bb7ec167d7ee494ebe5cd35f5d65ef5f', 27, 2, 1, '2019-08-31 03:44:13', '2019-08-30 15:44:13', '2019-08-30 15:44:13');
INSERT INTO `oauth2_refresh_token` VALUES ('bb8dfdde93d241068b47cee0f94ec4a8', NULL, NULL, 1, '2019-03-30 11:42:12', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('bb9246e573f64ddfa7df427b7dce24c0', 27, 2, 1, '2019-06-02 03:10:12', '2019-06-01 15:10:12', '2019-06-01 15:10:12');
INSERT INTO `oauth2_refresh_token` VALUES ('bb93f96a4c5e442396b49b802be3f143', 27, 2, 1, '2019-09-07 23:24:37', '2019-09-07 11:24:36', '2019-09-07 11:24:36');
INSERT INTO `oauth2_refresh_token` VALUES ('bb944a97eb474b8cac8f96a017afefc1', NULL, NULL, 1, '2019-05-09 11:10:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('bb9c24ae96d9406c85c34adc0583866b', 1, 2, 0, '2019-07-03 22:45:47', '2019-07-03 10:45:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('bba68eff954c4da6bb2fa74a39a60954', 1, 2, 0, '2019-06-01 08:37:51', '2019-05-31 20:37:50', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('bbd113a85f34494db1da396f4df9e461', 27, 2, 1, '2019-06-01 21:55:20', '2019-06-01 09:55:20', '2019-06-01 09:55:20');
INSERT INTO `oauth2_refresh_token` VALUES ('bc03e64087b14795a4d53085ef66f664', 27, 2, 1, '2019-06-05 22:50:22', '2019-06-05 10:50:22', '2019-06-05 10:50:22');
INSERT INTO `oauth2_refresh_token` VALUES ('bc077a5bd704424a8be6c5ce6c1647ca', 27, 2, 1, '2019-08-25 23:07:31', '2019-08-25 11:07:30', '2019-08-25 11:07:30');
INSERT INTO `oauth2_refresh_token` VALUES ('bc12908b83674b26ab0219d88ec822e0', 1, 2, 0, '2019-09-05 21:39:49', '2019-09-05 09:39:48', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('bc1a9b57e3bd4417b64ce0c1f2c0e17a', 27, 2, 1, '2019-06-02 17:55:49', '2019-06-02 05:55:48', '2019-06-02 05:55:48');
INSERT INTO `oauth2_refresh_token` VALUES ('bc2af4bec6d647b1affbd4b440f9d30f', 27, 2, 1, '2019-06-25 22:22:25', '2019-06-25 10:22:25', '2019-06-25 10:22:25');
INSERT INTO `oauth2_refresh_token` VALUES ('bc6b9c7a3ac148c080a583b900336156', 27, 2, 1, '2019-08-27 21:28:25', '2019-08-27 09:28:24', '2019-08-27 09:28:24');
INSERT INTO `oauth2_refresh_token` VALUES ('bc6e844e6d3d45df8f2564b40b82e91e', 27, 2, 1, '2019-06-15 09:32:57', '2019-06-14 21:32:57', '2019-06-14 21:32:57');
INSERT INTO `oauth2_refresh_token` VALUES ('bc861bc3aed14b3a9f8cceeba864dc84', 27, 2, 1, '2019-06-01 21:03:15', '2019-06-01 09:03:14', '2019-06-01 09:03:14');
INSERT INTO `oauth2_refresh_token` VALUES ('bca5072d355349c980d27c4caf7dee18', 27, 2, 1, '2019-06-26 04:23:14', '2019-06-25 16:23:13', '2019-06-25 16:23:13');
INSERT INTO `oauth2_refresh_token` VALUES ('bca732e799a94721840f33f6f6fc012f', 27, 2, 1, '2019-05-31 23:42:22', '2019-05-31 11:42:22', '2019-05-31 11:42:22');
INSERT INTO `oauth2_refresh_token` VALUES ('bca7ef714e434e3a816831a2dd4cb879', 27, 2, 1, '2019-07-31 22:42:05', '2019-07-31 10:42:05', '2019-07-31 10:42:05');
INSERT INTO `oauth2_refresh_token` VALUES ('bcadafbdd0c7488cb819f7d873007d52', 27, 2, 1, '2019-06-01 09:49:06', '2019-05-31 21:49:06', '2019-05-31 21:49:06');
INSERT INTO `oauth2_refresh_token` VALUES ('bcb299c6b0fb4175a22d755f40c876f4', 27, 2, 1, '2019-06-18 03:43:15', '2019-06-17 15:43:15', '2019-06-17 15:43:15');
INSERT INTO `oauth2_refresh_token` VALUES ('bcbd1ce93a1144148d6c66d9c9f58242', 27, 2, 1, '2019-08-22 05:01:15', '2019-08-21 17:01:14', '2019-08-21 17:01:14');
INSERT INTO `oauth2_refresh_token` VALUES ('bcbdd857e25e467b9ad85b06211224ac', 27, 2, 1, '2019-07-03 04:52:12', '2019-07-02 16:52:12', '2019-07-02 16:52:12');
INSERT INTO `oauth2_refresh_token` VALUES ('bce5eba9976743949715292f2f6beb37', NULL, NULL, 1, '2019-05-04 06:32:32', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('bd1c40e1fa244117b81377e0a2a37d12', NULL, NULL, 1, '2019-04-30 02:05:38', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('bd1d651fad304496a23c37a87f839df7', 27, 2, 1, '2019-06-22 02:53:40', '2019-06-21 14:53:39', '2019-06-21 14:53:39');
INSERT INTO `oauth2_refresh_token` VALUES ('bd29a45fcf874d82b330058e5382a0d3', 27, 2, 1, '2019-07-06 21:40:33', '2019-07-06 09:40:33', '2019-07-06 09:40:33');
INSERT INTO `oauth2_refresh_token` VALUES ('bd389be11b044916bd542bf2f5a5df79', NULL, NULL, 0, '2019-03-01 14:49:30', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('bd4ee71fe2be4b43a343d783b0ec1f48', 27, 2, 1, '2019-08-27 18:37:59', '2019-08-27 06:37:58', '2019-08-27 06:37:58');
INSERT INTO `oauth2_refresh_token` VALUES ('bd5331bd3361410e8047d8e8cfc7d391', NULL, NULL, 1, '2019-05-10 08:49:13', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('bd559180cb184d04850ef15c91744bd4', 27, 2, 1, '2019-07-17 01:38:47', '2019-07-16 13:38:47', '2019-07-16 13:38:47');
INSERT INTO `oauth2_refresh_token` VALUES ('bd6b7ab64fee470e911c28fd4e198209', 27, 2, 1, '2019-07-15 13:22:27', '2019-07-15 01:22:27', '2019-07-15 01:22:27');
INSERT INTO `oauth2_refresh_token` VALUES ('bd6cd56c85db4ca2b5e71d26052df105', 1, 2, 0, '2019-06-02 11:44:12', '2019-06-01 23:44:12', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('bd7bd18852c841dbbc568e65d22b1270', 1, 2, 0, '2019-07-16 11:20:44', '2019-07-15 23:20:43', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('bd846ed1a02d4a0ea67879a517bbd7b9', 27, 2, 1, '2019-07-20 22:05:47', '2019-07-20 10:05:47', '2019-07-20 10:05:47');
INSERT INTO `oauth2_refresh_token` VALUES ('bd85db53d45243fb9e69e1b231d88876', 27, 2, 1, '2019-08-23 02:04:00', '2019-08-22 14:04:00', '2019-08-22 14:04:00');
INSERT INTO `oauth2_refresh_token` VALUES ('bd878172beab47fa89adcb583fdcced2', 27, 2, 1, '2019-07-29 11:09:12', '2019-07-28 23:09:12', '2019-07-28 23:09:12');
INSERT INTO `oauth2_refresh_token` VALUES ('bd94d9fb47484252bbee2217950ff366', 27, 2, 1, '2019-06-08 04:20:04', '2019-06-07 16:20:04', '2019-06-07 16:20:04');
INSERT INTO `oauth2_refresh_token` VALUES ('bda43292ddc94803a86a7b165074997c', 27, 2, 1, '2019-08-05 22:58:19', '2019-08-05 10:58:18', '2019-08-05 10:58:18');
INSERT INTO `oauth2_refresh_token` VALUES ('bdc905c7cd6041b28b8066d641d0c2ba', 27, 2, 1, '2019-09-03 20:43:29', '2019-09-03 08:43:29', '2019-09-03 08:43:29');
INSERT INTO `oauth2_refresh_token` VALUES ('bdfa215667a644bd9193435f1d7ddcba', 27, 2, 1, '2019-07-16 03:09:29', '2019-07-15 15:09:29', '2019-07-15 15:09:29');
INSERT INTO `oauth2_refresh_token` VALUES ('be011678d0a14f588a4f47a4e9d611fa', 27, 2, 1, '2019-08-31 21:40:40', '2019-08-31 09:40:40', '2019-08-31 09:40:40');
INSERT INTO `oauth2_refresh_token` VALUES ('be01ac0ceae446ae83fe2fd23c4a1ba1', 27, 2, 1, '2019-08-31 03:54:19', '2019-08-30 15:54:19', '2019-08-30 15:54:19');
INSERT INTO `oauth2_refresh_token` VALUES ('be1055da81e84f1e9641e7c2be9090f1', NULL, NULL, 0, '2019-03-06 19:38:03', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('be1b5095d899470f8eeca20d2b89addd', 27, 2, 1, '2019-07-13 03:38:01', '2019-07-12 15:38:01', '2019-07-12 15:38:01');
INSERT INTO `oauth2_refresh_token` VALUES ('be1d0a3a906d4c9b8bfbdb65496f9ac4', 27, 2, 1, '2019-08-28 10:48:35', '2019-08-27 22:48:35', '2019-08-27 22:48:35');
INSERT INTO `oauth2_refresh_token` VALUES ('be37d1fdae064ffcb2d44bc01a522fa8', 27, 2, 1, '2019-06-01 11:33:01', '2019-05-31 23:33:01', '2019-05-31 23:33:01');
INSERT INTO `oauth2_refresh_token` VALUES ('be45de965eca4734ac383bd0ac299f16', 27, 2, 1, '2019-06-20 03:57:46', '2019-06-19 15:57:46', '2019-06-19 15:57:46');
INSERT INTO `oauth2_refresh_token` VALUES ('be4e2ef23ba24ffaa5991885152213db', NULL, NULL, 1, '2019-05-09 11:10:02', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('be4fdcb51c3c479fa45d8cf601426c8f', 27, 2, 1, '2019-06-13 02:01:02', '2019-06-12 14:01:01', '2019-06-12 14:01:01');
INSERT INTO `oauth2_refresh_token` VALUES ('be52bf4548e244fea2ee9645e8f0c92b', 27, 2, 1, '2019-08-15 02:50:35', '2019-08-14 14:50:34', '2019-08-14 14:50:34');
INSERT INTO `oauth2_refresh_token` VALUES ('be575f444a5a4450ae809e00118f6a93', NULL, NULL, 1, '2019-03-22 08:42:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('be67d61805754b618c1ad712e97af4ca', 27, 2, 1, '2019-06-21 00:32:06', '2019-06-20 12:32:05', '2019-06-20 12:32:05');
INSERT INTO `oauth2_refresh_token` VALUES ('be85cdcf119e4d899f4fb7d3a48f4355', NULL, NULL, 1, '2019-04-06 11:16:13', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('be90a143ed8245d29317cff286f0a0e2', 27, 2, 1, '2019-07-23 04:07:45', '2019-07-22 16:07:44', '2019-07-22 16:07:44');
INSERT INTO `oauth2_refresh_token` VALUES ('be9687ccd83a41c6a66cd9ee62c14465', NULL, NULL, 1, '2019-05-17 11:43:13', NULL, '2019-05-16 23:43:12');
INSERT INTO `oauth2_refresh_token` VALUES ('be9a363159c34f568f01e7fcaaff8f35', 27, 2, 1, '2019-08-01 09:09:48', '2019-07-31 21:09:48', '2019-07-31 21:09:48');
INSERT INTO `oauth2_refresh_token` VALUES ('be9d84e5ae044d679c56efd4bae16e81', 27, 2, 1, '2019-07-11 03:35:39', '2019-07-10 15:35:38', '2019-07-10 15:35:38');
INSERT INTO `oauth2_refresh_token` VALUES ('bec3717b296a456190e46a6b2b624773', 27, 2, 1, '2019-05-28 21:08:44', '2019-05-28 09:08:43', '2019-05-28 09:08:43');
INSERT INTO `oauth2_refresh_token` VALUES ('bec6d13bd3a948b2a8c81980732ca4b5', 1, 2, 0, '2019-06-27 06:01:14', '2019-06-26 18:01:13', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('bec8d8ae72ba4bfe9aee9a5e34d1dc63', 27, 2, 1, '2019-08-27 22:02:30', '2019-08-27 10:02:30', '2019-08-27 10:02:30');
INSERT INTO `oauth2_refresh_token` VALUES ('bed9ee45f67c4f2db957662295d6516b', 27, 2, 1, '2019-08-16 09:19:11', '2019-08-15 21:19:11', '2019-08-15 21:19:11');
INSERT INTO `oauth2_refresh_token` VALUES ('bee4b6a90beb4b199aca702f2772995b', 27, 2, 1, '2019-07-19 05:01:12', '2019-07-18 17:01:12', '2019-07-18 17:01:12');
INSERT INTO `oauth2_refresh_token` VALUES ('beeb5274836b47ada2244e787cc7bae2', 1, 2, 0, '2019-05-21 00:08:01', '2019-05-20 12:08:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('bf01df88c5974363aa4323c2121081a3', 27, 2, 1, '2019-08-16 05:07:50', '2019-08-15 17:07:49', '2019-08-15 17:07:49');
INSERT INTO `oauth2_refresh_token` VALUES ('bf174e364e9e4e6093dcaf055ac017e1', 27, 2, 1, '2019-05-18 11:46:26', '2019-05-17 23:46:25', '2019-05-17 23:46:25');
INSERT INTO `oauth2_refresh_token` VALUES ('bf176a27afa44aff8c50021832041a5c', 27, 2, 1, '2019-07-05 03:08:03', '2019-07-04 15:08:02', '2019-07-04 15:08:02');
INSERT INTO `oauth2_refresh_token` VALUES ('bf20068d982940a190202d1ad27486d1', 27, 2, 1, '2019-07-13 21:24:52', '2019-07-13 09:24:52', '2019-07-13 09:24:52');
INSERT INTO `oauth2_refresh_token` VALUES ('bf249b412a0442a48838e99c2563e7b8', 27, 2, 1, '2019-09-04 12:09:01', '2019-09-04 00:09:00', '2019-09-04 00:09:00');
INSERT INTO `oauth2_refresh_token` VALUES ('bf27aeba95ab44c1bef7d9b5e04a31bd', 27, 2, 1, '2019-07-31 05:17:10', '2019-07-30 17:17:10', '2019-07-30 17:17:10');
INSERT INTO `oauth2_refresh_token` VALUES ('bf2f1d0f05624d448cdb1a3d94289211', 27, 2, 1, '2019-09-06 23:41:04', '2019-09-06 11:41:03', '2019-09-06 11:41:03');
INSERT INTO `oauth2_refresh_token` VALUES ('bf4ca79f10bf40488714e65a078d0a92', 27, 2, 1, '2019-06-28 04:21:49', '2019-06-27 16:21:49', '2019-06-27 16:21:49');
INSERT INTO `oauth2_refresh_token` VALUES ('bf5994b4c0c84278b98f3ea26025d84f', 27, 2, 1, '2019-07-10 12:18:50', '2019-07-10 00:18:49', '2019-07-10 00:18:49');
INSERT INTO `oauth2_refresh_token` VALUES ('bf5a97fdab8342f69927197e392c9f5f', 27, 2, 1, '2019-08-06 23:00:16', '2019-08-06 11:00:15', '2019-08-06 11:00:15');
INSERT INTO `oauth2_refresh_token` VALUES ('bf66e44d24854b019b81a9756a55903b', 107, 1, 1, '2019-06-05 09:14:13', '2019-06-04 21:14:13', '2019-06-04 21:14:13');
INSERT INTO `oauth2_refresh_token` VALUES ('bf72519d325542b7a0b81e9b0f5bde36', 27, 2, 1, '2019-08-29 12:21:54', '2019-08-29 00:21:53', '2019-08-29 00:21:53');
INSERT INTO `oauth2_refresh_token` VALUES ('bf73bb15d55140529ca4ab6624a6662f', 27, 2, 1, '2019-07-23 05:49:33', '2019-07-22 17:49:33', '2019-07-22 17:49:33');
INSERT INTO `oauth2_refresh_token` VALUES ('bf7be425eee242709140710ddc629735', 28, 2, 1, '2019-09-09 10:59:07', '2019-09-08 22:59:06', '2019-09-08 22:59:06');
INSERT INTO `oauth2_refresh_token` VALUES ('bf7f6a94b2cb4c9fa4ea7c748936c6aa', 27, 2, 1, '2019-08-11 20:18:41', '2019-08-11 08:18:41', '2019-08-11 08:18:41');
INSERT INTO `oauth2_refresh_token` VALUES ('bf811ab87f7a425f80882f30bcc71317', 27, 2, 1, '2019-07-29 21:21:11', '2019-07-29 09:21:11', '2019-07-29 09:21:11');
INSERT INTO `oauth2_refresh_token` VALUES ('bfba465335f5484795432a38b3769a13', 27, 2, 1, '2019-06-30 07:15:09', '2019-06-29 19:15:08', '2019-06-29 19:15:08');
INSERT INTO `oauth2_refresh_token` VALUES ('bfd8070812ac497b9ddd57a68dadb5ab', 27, 2, 1, '2019-08-29 23:15:25', '2019-08-29 11:15:25', '2019-08-29 11:15:25');
INSERT INTO `oauth2_refresh_token` VALUES ('c0039cec6aba456d8422c64052ae681e', 1, 1, 1, '2019-05-19 08:26:32', '2019-05-18 20:26:32', '2019-05-18 20:26:32');
INSERT INTO `oauth2_refresh_token` VALUES ('c006c54f67764e868f7caaa7fe1d6b61', 1, 2, 0, '2019-07-02 20:43:02', '2019-07-02 08:43:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('c02a0ea3b6f44302b6db5ba34c21806f', NULL, NULL, 1, '2019-05-06 04:09:39', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c02ac9669c524e598706086de9dd2c52', 27, 2, 1, '2019-07-31 06:21:37', '2019-07-30 18:21:36', '2019-07-30 18:21:36');
INSERT INTO `oauth2_refresh_token` VALUES ('c044bba06f9c4271ab09e2c0bb8f7358', 1, 2, 0, '2019-05-24 08:07:03', '2019-05-23 20:07:03', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('c06fe360c3a240f3affdc31ae5c0d290', 27, 2, 1, '2019-07-26 05:01:31', '2019-07-25 17:01:31', '2019-07-25 17:01:31');
INSERT INTO `oauth2_refresh_token` VALUES ('c08175a56fdf477cbfb674af6d7614a3', 27, 2, 1, '2019-07-02 04:47:00', '2019-07-01 16:46:59', '2019-07-01 16:46:59');
INSERT INTO `oauth2_refresh_token` VALUES ('c09205fcdec6490f9c049039ecc6b94b', 27, 2, 1, '2019-06-17 08:24:19', '2019-06-16 20:24:18', '2019-06-16 20:24:18');
INSERT INTO `oauth2_refresh_token` VALUES ('c09bd431ed5b4dd6ae02f51f70f208bb', 27, 2, 1, '2019-08-02 23:22:55', '2019-08-02 11:22:55', '2019-08-02 11:22:55');
INSERT INTO `oauth2_refresh_token` VALUES ('c0af07d9f9f44de6a384b1d681fa9b56', NULL, NULL, 0, '2019-03-04 10:04:25', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c0b1430e2cb24475827d734dd4ddb777', 1, 2, 0, '2019-05-18 02:22:52', '2019-05-17 14:22:52', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('c0c8b939a62e4261b3219c37015218b4', 27, 2, 1, '2019-08-31 04:22:09', '2019-08-30 16:22:09', '2019-08-30 16:22:09');
INSERT INTO `oauth2_refresh_token` VALUES ('c0d8bd526da946309c1b77f505bc3113', 27, 2, 1, '2019-07-16 22:39:33', '2019-07-16 10:39:32', '2019-07-16 10:39:32');
INSERT INTO `oauth2_refresh_token` VALUES ('c10b810d976e435096aefe2d385d72a7', 27, 2, 1, '2019-09-07 07:26:07', '2019-09-06 19:26:07', '2019-09-06 19:26:07');
INSERT INTO `oauth2_refresh_token` VALUES ('c12e2a55fdfa479e8e51d367c96e4ca3', NULL, NULL, 1, '2019-03-10 22:54:27', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c131df94d7a94cfb84f91656a6be589f', 179, 1, 1, '2019-07-21 11:56:28', '2019-07-20 23:56:27', '2019-07-20 23:56:27');
INSERT INTO `oauth2_refresh_token` VALUES ('c135b860062b492aa022e1bb43a7728d', 27, 2, 1, '2019-06-21 06:55:31', '2019-06-20 18:55:30', '2019-06-20 18:55:30');
INSERT INTO `oauth2_refresh_token` VALUES ('c13646d3d137463dba023a52025e9e70', 27, 2, 1, '2019-06-05 22:01:06', '2019-06-05 10:01:05', '2019-06-05 10:01:05');
INSERT INTO `oauth2_refresh_token` VALUES ('c1427ff2c9dc457eb98071c5066a4586', 27, 2, 1, '2019-08-22 02:38:48', '2019-08-21 14:38:47', '2019-08-21 14:38:47');
INSERT INTO `oauth2_refresh_token` VALUES ('c151fb33b2654d37a642501e6019e9f7', 27, 2, 1, '2019-05-28 20:48:15', '2019-05-28 08:48:14', '2019-05-28 08:48:14');
INSERT INTO `oauth2_refresh_token` VALUES ('c1520761214c4086bbfb82865fdd102c', 27, 2, 1, '2019-06-24 00:04:00', '2019-06-23 12:03:59', '2019-06-23 12:03:59');
INSERT INTO `oauth2_refresh_token` VALUES ('c157146f5bfb4940921739f0927e91d6', 27, 2, 1, '2019-09-09 03:21:17', '2019-09-08 15:21:16', '2019-09-08 15:21:16');
INSERT INTO `oauth2_refresh_token` VALUES ('c16fe6b3f5ef435cb06af5cbadcbb463', 27, 2, 1, '2019-07-08 10:36:24', '2019-07-07 22:36:23', '2019-07-07 22:36:23');
INSERT INTO `oauth2_refresh_token` VALUES ('c1716674a9ae482bb19e6a6fccccacf1', NULL, NULL, 1, '2019-05-06 03:56:33', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c18cc2929fcb4355bb59d8b9aa6041c4', NULL, NULL, 1, '2019-04-23 06:25:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c1c06d084faa4fee9bccc2b0315723bf', 27, 2, 1, '2019-06-08 04:52:36', '2019-06-07 16:52:36', '2019-06-07 16:52:36');
INSERT INTO `oauth2_refresh_token` VALUES ('c1ca5add9fc54aafbf82caa5d0edb984', 27, 2, 1, '2019-07-17 03:05:13', '2019-07-16 15:05:12', '2019-07-16 15:05:12');
INSERT INTO `oauth2_refresh_token` VALUES ('c1ca6d07615c4fa789de27ca5a404309', 1, 2, 0, '2019-06-01 04:10:48', '2019-05-31 16:09:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('c1f8950a3f874a9fbdb3f5adc4ad149c', 27, 2, 1, '2019-05-29 11:04:38', '2019-05-28 23:04:38', '2019-05-28 23:04:38');
INSERT INTO `oauth2_refresh_token` VALUES ('c2117efb86954962a7300ef0ec6ca528', 27, 2, 1, '2019-08-16 20:47:05', '2019-08-16 08:47:05', '2019-08-16 08:47:05');
INSERT INTO `oauth2_refresh_token` VALUES ('c277fa5d6f234cf38bf5e027b36bd903', 27, 2, 1, '2019-08-18 22:49:29', '2019-08-18 10:49:29', '2019-08-18 10:49:29');
INSERT INTO `oauth2_refresh_token` VALUES ('c286e653133b4f9fa9787733b67ffe38', 27, 2, 1, '2019-06-11 01:45:37', '2019-06-10 13:45:36', '2019-06-10 13:45:36');
INSERT INTO `oauth2_refresh_token` VALUES ('c28bcc7fcc144a17be713b712c348ed5', 27, 2, 1, '2019-06-29 05:16:16', '2019-06-28 17:16:16', '2019-06-28 17:16:16');
INSERT INTO `oauth2_refresh_token` VALUES ('c2911ba473d54f2fa9c8418b8518b110', 27, 2, 1, '2019-06-02 23:29:55', '2019-06-02 11:29:55', '2019-06-02 11:29:55');
INSERT INTO `oauth2_refresh_token` VALUES ('c293ed4a39634bd9b2fe0675d3a7f097', 27, 2, 1, '2019-06-24 22:07:36', '2019-06-24 10:07:36', '2019-06-24 10:07:36');
INSERT INTO `oauth2_refresh_token` VALUES ('c2a6cb5ce2a342189dcd421bfb9eab1c', 27, 2, 1, '2019-09-06 02:01:58', '2019-09-05 14:01:57', '2019-09-05 14:01:57');
INSERT INTO `oauth2_refresh_token` VALUES ('c2b36f24b3d64dba8409d75b71fac642', 27, 2, 1, '2019-06-18 03:18:05', '2019-06-17 15:18:05', '2019-06-17 15:18:05');
INSERT INTO `oauth2_refresh_token` VALUES ('c2f77df943b04328a90d79dd1bbf54a2', 27, 2, 1, '2019-07-13 01:38:03', '2019-07-12 13:38:02', '2019-07-12 13:38:02');
INSERT INTO `oauth2_refresh_token` VALUES ('c2f9894813694efeb4ba3c448098344b', 27, 2, 1, '2019-06-29 00:08:58', '2019-06-28 12:08:57', '2019-06-28 12:08:57');
INSERT INTO `oauth2_refresh_token` VALUES ('c3117b7990b2443f87606c43b2011809', 27, 2, 1, '2019-06-22 09:26:06', '2019-06-21 21:26:06', '2019-06-21 21:26:06');
INSERT INTO `oauth2_refresh_token` VALUES ('c319c003e0874185a5c0a85e4a3f72d0', 27, 2, 1, '2019-07-20 19:45:51', '2019-07-20 07:45:50', '2019-07-20 07:45:50');
INSERT INTO `oauth2_refresh_token` VALUES ('c3382d92db0d4d9fb2dd34a9dea1faab', 27, 2, 1, '2019-06-13 23:05:49', '2019-06-13 11:05:49', '2019-06-13 11:05:49');
INSERT INTO `oauth2_refresh_token` VALUES ('c33c148e8c5c498d90a8dd23d4184b41', NULL, NULL, 1, '2019-05-07 10:24:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c34c18c2468a4c30815e42fb6f2f7947', 27, 2, 1, '2019-06-06 20:58:33', '2019-06-06 08:58:32', '2019-06-06 08:58:32');
INSERT INTO `oauth2_refresh_token` VALUES ('c34f6c32c4a44e7897b725e712447113', NULL, NULL, 1, '2019-04-17 07:53:33', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c37a1136f8e74d699443fbfe5b1c1f76', NULL, NULL, 1, '2019-04-25 21:36:37', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c3a066ab1a094d21b776159b45a220ca', NULL, NULL, 1, '2019-03-31 11:57:04', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c3a3b0ad7ead4088be56b4763ddca277', NULL, NULL, 1, '2019-04-13 03:56:07', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c3ccd76071d94d81b39dc7e5aed9c6bc', 27, 2, 1, '2019-07-05 10:26:51', '2019-07-04 22:26:51', '2019-07-04 22:26:51');
INSERT INTO `oauth2_refresh_token` VALUES ('c3cfe2bee90a4a5cb2ea1272d64a999d', NULL, NULL, 1, '2019-05-11 02:20:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c3d67fa88ad54831bf44ad78cbf4cbf6', 27, 2, 1, '2019-07-29 23:28:18', '2019-07-29 11:28:18', '2019-07-29 11:28:18');
INSERT INTO `oauth2_refresh_token` VALUES ('c3f665dd40fb4bb48eff78195ba5ee81', 1, 2, 0, '2019-08-13 11:26:26', '2019-08-12 23:26:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('c401c19701204d4cb44fe6a1ac8cd350', 27, 2, 1, '2019-07-04 05:31:54', '2019-07-03 17:31:53', '2019-07-03 17:31:53');
INSERT INTO `oauth2_refresh_token` VALUES ('c41a07104eb94b4d9a06fc9ec97b12d3', 27, 2, 1, '2019-05-28 07:26:21', '2019-05-27 19:26:21', '2019-05-27 19:26:21');
INSERT INTO `oauth2_refresh_token` VALUES ('c41ab15bc47546c3a7f89dc57f0ddfe7', NULL, NULL, 1, '2019-05-15 11:51:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c429f21f1df146cd828bceca58396071', 27, 2, 1, '2019-06-04 03:38:59', '2019-06-03 15:38:58', '2019-06-03 15:38:58');
INSERT INTO `oauth2_refresh_token` VALUES ('c440eb42c9b942d493a0cd719ce1b5c3', 27, 2, 1, '2019-07-04 22:04:15', '2019-07-04 10:04:14', '2019-07-04 10:04:14');
INSERT INTO `oauth2_refresh_token` VALUES ('c453cca343204700890df0d7aed2af23', 27, 2, 1, '2019-08-29 22:47:55', '2019-08-29 10:47:54', '2019-08-29 10:47:54');
INSERT INTO `oauth2_refresh_token` VALUES ('c481e2cd12224372b770a7e545f04691', 1, 2, 1, '2019-09-09 01:40:18', '2019-09-08 13:40:17', '2019-09-08 13:40:17');
INSERT INTO `oauth2_refresh_token` VALUES ('c4a94092756241cbaa84b265e7148adb', 27, 2, 1, '2019-07-25 12:44:11', '2019-07-25 00:44:10', '2019-07-25 00:44:10');
INSERT INTO `oauth2_refresh_token` VALUES ('c4b1f42e46c44c6d92f09d151f9ebae7', 27, 2, 1, '2019-07-16 06:50:50', '2019-07-15 18:50:49', '2019-07-15 18:50:49');
INSERT INTO `oauth2_refresh_token` VALUES ('c4b80eb2b09c4ae18ff934ca36f2b64c', 128, 1, 1, '2019-06-20 02:35:26', '2019-06-19 14:35:26', '2019-06-19 14:35:26');
INSERT INTO `oauth2_refresh_token` VALUES ('c4d99164146847f19921e43e31dfdcf7', NULL, NULL, 1, '2019-05-14 08:22:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c4dacc686ed94611a1a14bce64085e73', 27, 2, 1, '2019-07-08 21:32:20', '2019-07-08 09:32:19', '2019-07-08 09:32:19');
INSERT INTO `oauth2_refresh_token` VALUES ('c4ddc0856fc647348f6f20e0f13cc883', 27, 2, 1, '2019-07-01 12:04:17', '2019-07-01 00:04:16', '2019-07-01 00:04:16');
INSERT INTO `oauth2_refresh_token` VALUES ('c4ef307a2c954e21b8dc55da51421b4c', 27, 2, 1, '2019-06-15 03:09:51', '2019-06-14 15:09:51', '2019-06-14 15:09:51');
INSERT INTO `oauth2_refresh_token` VALUES ('c4f087e9ea17448ba700d92473f49883', 27, 2, 1, '2019-08-13 05:05:15', '2019-08-12 17:05:15', '2019-08-12 17:05:15');
INSERT INTO `oauth2_refresh_token` VALUES ('c4f62ca0170b4067a954d1550f8ee67e', NULL, NULL, 1, '2019-04-23 06:25:31', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c500cbdedf8d45e090630d7620e7929e', 27, 2, 1, '2019-06-04 04:00:06', '2019-06-03 16:00:06', '2019-06-03 16:00:06');
INSERT INTO `oauth2_refresh_token` VALUES ('c5036097fd3e4f53b04388c718a0419d', NULL, NULL, 1, '2019-05-08 04:03:50', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c51f6f02c7884d54ad5dee2c318a56e4', 27, 2, 1, '2019-08-29 10:10:49', '2019-08-28 22:10:49', '2019-08-28 22:10:49');
INSERT INTO `oauth2_refresh_token` VALUES ('c52ccc89afb94822b6c85e28095b565e', 27, 2, 1, '2019-08-17 02:28:28', '2019-08-16 14:28:27', '2019-08-16 14:28:27');
INSERT INTO `oauth2_refresh_token` VALUES ('c5575527e2d24cb8aee43a4ca6efe39d', 27, 2, 1, '2019-06-13 02:04:14', '2019-06-12 14:04:13', '2019-06-12 14:04:13');
INSERT INTO `oauth2_refresh_token` VALUES ('c55cc62fc4dd4fa880fd176dc5fa9683', 27, 2, 1, '2019-06-25 12:07:07', '2019-06-25 00:07:07', '2019-06-25 00:07:07');
INSERT INTO `oauth2_refresh_token` VALUES ('c55fc5e022c74d07867fd6526ff7f1cb', 27, 2, 1, '2019-06-21 19:03:59', '2019-06-21 07:03:59', '2019-06-21 07:03:59');
INSERT INTO `oauth2_refresh_token` VALUES ('c573053067ce4302a5b7875fd20bc582', 27, 2, 1, '2019-07-05 01:12:50', '2019-07-04 13:12:49', '2019-07-04 13:12:49');
INSERT INTO `oauth2_refresh_token` VALUES ('c57bedc5f40b426ab702c0432ace9228', 27, 2, 1, '2019-07-04 05:23:47', '2019-07-03 17:23:46', '2019-07-03 17:23:46');
INSERT INTO `oauth2_refresh_token` VALUES ('c5860e78ccce48d7bae642dedca33cbf', 27, 2, 1, '2019-05-22 04:23:26', '2019-05-21 16:23:26', '2019-05-21 16:23:26');
INSERT INTO `oauth2_refresh_token` VALUES ('c58b4b80580f42ada9dc2f04fadfb2d3', 27, 2, 1, '2019-06-20 23:19:58', '2019-06-20 11:19:58', '2019-06-20 11:19:58');
INSERT INTO `oauth2_refresh_token` VALUES ('c5a5a48ec3dd42a4a1ab7d78f6e3a344', 126, 1, 1, '2019-06-19 03:32:21', '2019-06-18 15:32:20', '2019-06-18 15:32:20');
INSERT INTO `oauth2_refresh_token` VALUES ('c5b988a3c2f04a838310b8d268cecbb7', 194, 1, 1, '2019-08-09 05:34:25', '2019-08-08 17:34:25', '2019-08-08 17:34:25');
INSERT INTO `oauth2_refresh_token` VALUES ('c5c85b222b44451d80b0d60f38adf613', 27, 2, 1, '2019-06-15 06:19:55', '2019-06-14 18:19:54', '2019-06-14 18:19:54');
INSERT INTO `oauth2_refresh_token` VALUES ('c5d4d7d50665460e9b01b5b40d402d9d', 27, 2, 1, '2019-07-12 21:45:12', '2019-07-12 09:45:11', '2019-07-12 09:45:11');
INSERT INTO `oauth2_refresh_token` VALUES ('c5fb93367101410e859ad033f9ac6717', 27, 2, 1, '2019-08-17 23:08:37', '2019-08-17 11:08:37', '2019-08-17 11:08:37');
INSERT INTO `oauth2_refresh_token` VALUES ('c605b7daf43847b3ad00b4f9c024d79f', 27, 2, 1, '2019-07-12 03:56:36', '2019-07-11 15:56:36', '2019-07-11 15:56:36');
INSERT INTO `oauth2_refresh_token` VALUES ('c60827a4027e4d99afb1bc966f897dee', NULL, NULL, 1, '2019-05-10 12:04:26', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c626d816e4c34c43a2da9eddaf88f6c9', 27, 2, 1, '2019-06-06 23:38:27', '2019-06-06 11:38:27', '2019-06-06 11:38:27');
INSERT INTO `oauth2_refresh_token` VALUES ('c62b2358917e4c3a86b48975a347ca5b', 27, 2, 1, '2019-06-21 08:57:23', '2019-06-20 20:57:22', '2019-06-20 20:57:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c6400be52df64b9a9f1bc35ff247506c', 138, 1, 1, '2019-06-25 05:39:36', '2019-06-24 17:39:35', '2019-06-24 17:39:35');
INSERT INTO `oauth2_refresh_token` VALUES ('c65e58b150174f78b38379f646362d5e', 27, 2, 1, '2019-06-01 23:26:11', '2019-06-01 11:26:11', '2019-06-01 11:26:11');
INSERT INTO `oauth2_refresh_token` VALUES ('c66358ca910a4cbf87ce09eb623947ad', 27, 2, 1, '2019-07-19 02:39:04', '2019-07-18 14:39:04', '2019-07-18 14:39:04');
INSERT INTO `oauth2_refresh_token` VALUES ('c664e7cedcc748249ce087d36c15aed1', 1, 2, 0, '2019-06-04 01:51:56', '2019-06-03 13:51:55', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('c66502fca7ac48569aff62dbc77aa5f3', 27, 2, 1, '2019-07-05 08:14:09', '2019-07-04 20:14:08', '2019-07-04 20:14:08');
INSERT INTO `oauth2_refresh_token` VALUES ('c69cb465644c4df68b0e1c6e953991b7', 27, 2, 1, '2019-07-12 23:23:02', '2019-07-12 11:23:01', '2019-07-12 11:23:01');
INSERT INTO `oauth2_refresh_token` VALUES ('c6a57b4c280c4cf38483fdc9525119a7', 72, 1, 1, '2019-05-17 12:25:54', '2019-05-17 00:25:53', '2019-05-17 00:25:53');
INSERT INTO `oauth2_refresh_token` VALUES ('c6b3f578365b4ebd8780cf862498b941', 27, 2, 1, '2019-08-21 07:58:14', '2019-08-20 19:58:13', '2019-08-20 19:58:13');
INSERT INTO `oauth2_refresh_token` VALUES ('c6b45059243f449c8f7f2ecf8b1c3ba0', 27, 2, 1, '2019-06-19 22:10:22', '2019-06-19 10:10:21', '2019-06-19 10:10:21');
INSERT INTO `oauth2_refresh_token` VALUES ('c6c2fa9af67145268a8e0183f99cb286', 27, 2, 1, '2019-07-06 05:48:15', '2019-07-05 17:48:15', '2019-07-05 17:48:15');
INSERT INTO `oauth2_refresh_token` VALUES ('c6c75399bd61401baae34b1f5c1263c5', 27, 2, 1, '2019-05-21 06:05:06', '2019-05-20 18:05:06', '2019-05-20 18:05:06');
INSERT INTO `oauth2_refresh_token` VALUES ('c6cd18e230c446eb9929067fdb5d563d', 27, 2, 1, '2019-06-29 05:18:46', '2019-06-28 17:18:45', '2019-06-28 17:18:45');
INSERT INTO `oauth2_refresh_token` VALUES ('c6fb02257d4c470986eb518d42270367', 27, 2, 1, '2019-06-10 22:19:34', '2019-06-10 10:19:34', '2019-06-10 10:19:34');
INSERT INTO `oauth2_refresh_token` VALUES ('c6fbff5a9b8a468ca12b4bd1fc5047a7', 27, 2, 1, '2019-06-19 02:29:22', '2019-06-18 14:29:22', '2019-06-18 14:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c701201fdfe343f299189970a7272dc4', 27, 2, 1, '2019-09-06 01:57:16', '2019-09-05 13:57:15', '2019-09-05 13:57:15');
INSERT INTO `oauth2_refresh_token` VALUES ('c7046757d5ad4411887e898722ad4af5', NULL, NULL, 1, '2019-05-05 09:18:52', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c70bba37637641f396b3115125f87e06', 27, 2, 1, '2019-07-24 03:04:50', '2019-07-23 15:04:49', '2019-07-23 15:04:49');
INSERT INTO `oauth2_refresh_token` VALUES ('c70ec77a1b9d40a98f2214a15b8e58d0', NULL, NULL, 1, '2019-05-06 04:03:58', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c70ef16bb5654cb98a54989c97f5f1a2', 27, 2, 1, '2019-07-12 05:27:27', '2019-07-11 17:27:26', '2019-07-11 17:27:26');
INSERT INTO `oauth2_refresh_token` VALUES ('c72317d0fd2c4d7686c4f3213daa16e1', 27, 2, 1, '2019-08-23 23:46:31', '2019-08-23 11:46:31', '2019-08-23 11:46:31');
INSERT INTO `oauth2_refresh_token` VALUES ('c72604f5d2aa464c967c840db04f20ad', 27, 2, 1, '2019-07-11 09:52:36', '2019-07-10 21:52:35', '2019-07-10 21:52:35');
INSERT INTO `oauth2_refresh_token` VALUES ('c729d791a9ee4b77b08280ff57a4f725', NULL, NULL, 0, '2019-03-01 14:53:02', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c74198e7c83c4f85a0fecc74ec7a616e', 27, 2, 1, '2019-07-12 22:10:04', '2019-07-12 10:10:04', '2019-07-12 10:10:04');
INSERT INTO `oauth2_refresh_token` VALUES ('c760338e197a4b08ba5762772fc9e251', 27, 2, 1, '2019-06-22 13:52:28', '2019-06-22 01:52:27', '2019-06-22 01:52:27');
INSERT INTO `oauth2_refresh_token` VALUES ('c765d42a39da427494913af3ed058e9a', 27, 2, 1, '2019-07-28 00:02:36', '2019-07-27 12:02:35', '2019-07-27 12:02:35');
INSERT INTO `oauth2_refresh_token` VALUES ('c77a7531ccde46439f9e88457ff4a826', 27, 2, 1, '2019-07-14 01:42:10', '2019-07-13 13:42:10', '2019-07-13 13:42:10');
INSERT INTO `oauth2_refresh_token` VALUES ('c7831dcbd43a450aaebbaf838617f6b9', NULL, NULL, 1, '2019-03-31 09:47:51', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c78ed5e14a62411191d9649739d344cf', 27, 2, 1, '2019-05-24 04:27:00', '2019-05-23 16:26:59', '2019-05-23 16:26:59');
INSERT INTO `oauth2_refresh_token` VALUES ('c7c496c47dec494a9159965a76204c66', 27, 2, 1, '2019-06-08 03:01:26', '2019-06-07 15:01:26', '2019-06-07 15:01:26');
INSERT INTO `oauth2_refresh_token` VALUES ('c7e50eea1875441aa4bd5db14197327e', 27, 2, 1, '2019-07-13 05:55:46', '2019-07-12 17:55:45', '2019-07-12 17:55:45');
INSERT INTO `oauth2_refresh_token` VALUES ('c7f132ca32de410988b247f9522db951', 27, 2, 1, '2019-06-29 04:23:44', '2019-06-28 16:23:44', '2019-06-28 16:23:44');
INSERT INTO `oauth2_refresh_token` VALUES ('c7f28adda4f345b49bf1bdc9d855b9d1', 1, 1, 1, '2019-05-17 12:22:19', '2019-05-17 00:22:18', '2019-05-17 00:22:18');
INSERT INTO `oauth2_refresh_token` VALUES ('c7f72b19363b4d1889bfd774ca50a32e', NULL, NULL, 1, '2019-04-06 04:19:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c7fa2bf927794f5fb58eb1183c884ee1', NULL, NULL, 1, '2019-04-06 03:21:36', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c80e0afccaf84b8bb9f30f09b52bf772', 27, 2, 1, '2019-07-06 05:36:44', '2019-07-05 17:36:44', '2019-07-05 17:36:44');
INSERT INTO `oauth2_refresh_token` VALUES ('c81fb0156cca4c90bc0407a9884c43ad', 27, 2, 1, '2019-07-26 12:20:41', '2019-07-26 00:20:41', '2019-07-26 00:20:41');
INSERT INTO `oauth2_refresh_token` VALUES ('c8205d66dfb445b19d91c17483a9fd1c', 27, 2, 1, '2019-08-23 03:29:58', '2019-08-22 15:29:58', '2019-08-22 15:29:58');
INSERT INTO `oauth2_refresh_token` VALUES ('c84c03d59822410e8073ea4798c4b1a2', NULL, NULL, 1, '2019-04-23 06:20:36', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c85c908fb3e9418bb653533f1656c739', 27, 2, 1, '2019-06-07 10:04:31', '2019-06-06 22:04:31', '2019-06-06 22:04:31');
INSERT INTO `oauth2_refresh_token` VALUES ('c85e6d01c95949e09f0e97edfca268d4', 1, 2, 0, '2019-06-17 22:41:38', '2019-06-17 10:41:38', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('c860d4b60942473797147a0283827576', 27, 2, 1, '2019-06-18 22:39:22', '2019-06-18 10:39:22', '2019-06-18 10:39:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c8621a5f92834838b696ee30b0bf238d', 1, 2, 0, '2019-07-19 07:52:17', '2019-07-18 19:52:17', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('c866701de67d487dae819fd4f250125d', 27, 2, 1, '2019-06-11 00:36:16', '2019-06-10 12:36:15', '2019-06-10 12:36:15');
INSERT INTO `oauth2_refresh_token` VALUES ('c86ce7b18572462ba92a74c76ff6c221', 27, 2, 1, '2019-08-30 09:23:52', '2019-08-29 21:23:51', '2019-08-29 21:23:51');
INSERT INTO `oauth2_refresh_token` VALUES ('c8806a97e1fd49ddb8584f787113a520', 27, 2, 1, '2019-08-17 02:28:14', '2019-08-16 14:28:13', '2019-08-16 14:28:13');
INSERT INTO `oauth2_refresh_token` VALUES ('c89cb2907acf468a8df58007fb0cd052', 27, 2, 1, '2019-07-16 05:51:41', '2019-07-15 17:51:41', '2019-07-15 17:51:41');
INSERT INTO `oauth2_refresh_token` VALUES ('c8a9cadb67cf43bdb07159baca18ba76', 27, 2, 1, '2019-08-28 23:55:43', '2019-08-28 11:55:43', '2019-08-28 11:55:43');
INSERT INTO `oauth2_refresh_token` VALUES ('c8ad295ed96440648ae7b57945f2f729', 27, 2, 1, '2019-06-10 21:24:42', '2019-06-10 09:24:41', '2019-06-10 09:24:41');
INSERT INTO `oauth2_refresh_token` VALUES ('c8be5d9834ad4d21940187f9b8275a1d', 104, 1, 1, '2019-06-05 00:41:14', '2019-06-04 12:41:13', '2019-06-04 12:41:13');
INSERT INTO `oauth2_refresh_token` VALUES ('c8c729202e7d4dbea28bdbaacccb806a', 1, 2, 0, '2019-06-04 04:36:51', '2019-06-03 16:36:51', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('c8ce74d1d2104b41b73f97ff7464e64a', 27, 2, 1, '2019-06-22 02:13:54', '2019-06-21 14:13:54', '2019-06-21 14:13:54');
INSERT INTO `oauth2_refresh_token` VALUES ('c8d4a023da34402883df774dc655da49', NULL, NULL, 1, '2019-05-10 09:15:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c908d40a475349908f752f4820aa9eaa', 1, 2, 0, '2019-06-01 21:05:20', '2019-06-01 09:05:19', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('c9295a36890f445ba724729b1ab9c6d3', 27, 2, 1, '2019-05-30 21:20:51', '2019-05-30 09:20:50', '2019-05-30 09:20:50');
INSERT INTO `oauth2_refresh_token` VALUES ('c93bb17104414cb69441a168f4ff19f1', 1, 2, 0, '2019-06-29 02:49:31', '2019-06-28 14:49:31', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('c94f1c68d3fa46d999fe9dcedd64e0d9', 27, 2, 1, '2019-07-27 03:07:40', '2019-07-26 15:07:39', '2019-07-26 15:07:39');
INSERT INTO `oauth2_refresh_token` VALUES ('c94f3d5af86c43d1946311ad2707b474', 27, 2, 1, '2019-06-10 23:32:07', '2019-06-10 11:32:06', '2019-06-10 11:32:06');
INSERT INTO `oauth2_refresh_token` VALUES ('c972c56b45df4aa9bf6397555b5d9319', 27, 2, 1, '2019-06-01 05:03:51', '2019-05-31 17:03:51', '2019-05-31 17:03:51');
INSERT INTO `oauth2_refresh_token` VALUES ('c984b961bb5b4cb981e416587301b21a', 27, 2, 1, '2019-06-10 22:32:46', '2019-06-10 10:32:45', '2019-06-10 10:32:45');
INSERT INTO `oauth2_refresh_token` VALUES ('c99438bfa2e442a6a4385e294a651d32', 1, 2, 0, '2019-07-23 23:09:54', '2019-07-23 11:09:53', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('c999ce39b10d45fb88d6183272330702', NULL, NULL, 1, '2019-05-10 02:28:38', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('c9c4fefa84124a308d1237ccd246ca47', 27, 2, 1, '2019-07-18 02:44:57', '2019-07-17 14:44:56', '2019-07-17 14:44:56');
INSERT INTO `oauth2_refresh_token` VALUES ('c9cb7830afba43509c8592c507dbd7a2', 27, 2, 1, '2019-06-20 03:39:35', '2019-06-19 15:39:34', '2019-06-19 15:39:34');
INSERT INTO `oauth2_refresh_token` VALUES ('ca03991ab30d4985ac8a1fc0b9186dd9', NULL, NULL, 1, '2019-04-02 11:33:40', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ca0ed997213043b19299725ebf066f52', 27, 2, 1, '2019-06-21 03:13:55', '2019-06-20 15:13:55', '2019-06-20 15:13:55');
INSERT INTO `oauth2_refresh_token` VALUES ('ca130e4516264478b6d60243f9e846b4', 27, 2, 1, '2019-06-11 05:51:53', '2019-06-10 17:51:53', '2019-06-10 17:51:53');
INSERT INTO `oauth2_refresh_token` VALUES ('ca1fb3dc8f114944a86c53bd2bf41c25', 1, 2, 0, '2019-06-07 01:35:09', '2019-06-06 13:35:08', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ca56cf931d074bb2a3fc8f456d857f65', 1, 2, 0, '2019-05-18 06:22:58', '2019-05-17 18:22:58', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ca68cc4ab2f14a66a9a31b42aee97ddf', 27, 2, 1, '2019-08-21 04:51:46', '2019-08-20 16:51:46', '2019-08-20 16:51:46');
INSERT INTO `oauth2_refresh_token` VALUES ('ca6b4b227ec046189d82fc98b9143cce', 27, 2, 1, '2019-05-24 02:24:14', '2019-05-23 14:24:13', '2019-05-23 14:24:13');
INSERT INTO `oauth2_refresh_token` VALUES ('ca83fa9851c84af1844f6f4681b3f1a6', 27, 2, 1, '2019-06-15 03:14:31', '2019-06-14 15:14:30', '2019-06-14 15:14:30');
INSERT INTO `oauth2_refresh_token` VALUES ('ca939da43e894e4489887806121c3b28', 27, 2, 1, '2019-05-23 03:35:05', '2019-05-22 15:35:04', '2019-05-22 15:35:04');
INSERT INTO `oauth2_refresh_token` VALUES ('caa3a5e7f15e465ba47344901323fea2', 27, 2, 1, '2019-07-23 22:53:16', '2019-07-23 10:53:16', '2019-07-23 10:53:16');
INSERT INTO `oauth2_refresh_token` VALUES ('caabe9a844aa41b0868abf0932168393', 27, 2, 1, '2019-07-03 04:51:49', '2019-07-02 16:51:49', '2019-07-02 16:51:49');
INSERT INTO `oauth2_refresh_token` VALUES ('cab636ab00b2451fb37a81b28eac8aaa', 27, 2, 1, '2019-07-09 10:01:17', '2019-07-08 22:01:16', '2019-07-08 22:01:16');
INSERT INTO `oauth2_refresh_token` VALUES ('cacafb970894469bbb2735c25cb15bec', 27, 2, 1, '2019-07-09 04:25:07', '2019-07-08 16:25:07', '2019-07-08 16:25:07');
INSERT INTO `oauth2_refresh_token` VALUES ('cad555cfbe744265be10f9bac7727912', NULL, NULL, 1, '2019-05-01 23:52:48', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('cadcf0524b6746e791b65f8b8bcb636e', 27, 2, 1, '2019-06-22 09:00:26', '2019-06-21 21:00:25', '2019-06-21 21:00:25');
INSERT INTO `oauth2_refresh_token` VALUES ('cb0b239029234636b9459ace17d58ee6', 27, 2, 1, '2019-07-23 05:19:41', '2019-07-22 17:19:41', '2019-07-22 17:19:41');
INSERT INTO `oauth2_refresh_token` VALUES ('cb0d9bfefa7342bba9c975cee018135f', 27, 2, 1, '2019-08-02 05:28:27', '2019-08-01 17:28:26', '2019-08-01 17:28:26');
INSERT INTO `oauth2_refresh_token` VALUES ('cb2062b89ab741908ad97c30bee05b08', 27, 2, 1, '2019-06-02 20:39:30', '2019-06-02 08:39:30', '2019-06-02 08:39:30');
INSERT INTO `oauth2_refresh_token` VALUES ('cb30cf3e82f84a2a86028780dafb7a4d', 27, 2, 1, '2019-06-15 02:23:48', '2019-06-14 14:23:48', '2019-06-14 14:23:48');
INSERT INTO `oauth2_refresh_token` VALUES ('cb3fac57619c478490ba52e56b7f3a5e', 27, 2, 1, '2019-09-06 05:19:51', '2019-09-05 17:19:50', '2019-09-05 17:19:50');
INSERT INTO `oauth2_refresh_token` VALUES ('cb41be022efd4ed1bde610d6afb1f1f3', 27, 2, 1, '2019-08-10 05:57:43', '2019-08-09 17:57:43', '2019-08-09 17:57:43');
INSERT INTO `oauth2_refresh_token` VALUES ('cb4eaae19b8244eea72b16a9a08d92e1', 27, 2, 1, '2019-07-09 04:04:38', '2019-07-08 16:04:37', '2019-07-08 16:04:37');
INSERT INTO `oauth2_refresh_token` VALUES ('cb5c5abcc53941ad9d40c9eea814b6fb', 27, 2, 1, '2019-09-06 12:15:10', '2019-09-06 00:15:10', '2019-09-06 00:15:10');
INSERT INTO `oauth2_refresh_token` VALUES ('cb6bf16d0a584a4a98e85296af8b7965', 27, 2, 1, '2019-08-06 22:06:08', '2019-08-06 10:06:07', '2019-08-06 10:06:07');
INSERT INTO `oauth2_refresh_token` VALUES ('cb7e4defddd943a095ea5f03d6464a63', NULL, NULL, 1, '2019-05-08 23:24:12', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('cb8cb484d6804433a0ab4f1424080138', 27, 2, 1, '2019-05-29 02:41:26', '2019-05-28 14:41:26', '2019-05-28 14:41:26');
INSERT INTO `oauth2_refresh_token` VALUES ('cb972184d20e4190aef3a2ca89567409', 1, 2, 0, '2019-05-31 23:52:27', '2019-05-31 11:51:07', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('cbae6794f60e4d58804f1cf713608ad3', 27, 2, 1, '2019-09-07 12:46:02', '2019-09-07 00:46:01', '2019-09-07 00:46:01');
INSERT INTO `oauth2_refresh_token` VALUES ('cbaee15cd85c4eca8af89fba6e2a5543', NULL, NULL, 1, '2019-04-23 06:25:58', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('cbc03ee559b846b9804f8cce8b7450e3', 27, 2, 1, '2019-06-12 20:40:50', '2019-06-12 08:40:49', '2019-06-12 08:40:49');
INSERT INTO `oauth2_refresh_token` VALUES ('cbc5e56219294ac2a1a505609036517a', 27, 2, 1, '2019-07-03 04:23:44', '2019-07-02 16:23:43', '2019-07-02 16:23:43');
INSERT INTO `oauth2_refresh_token` VALUES ('cbcd096eaa204c54a1f2d49eb8e58568', 27, 2, 1, '2019-06-03 23:56:57', '2019-06-03 11:56:57', '2019-06-03 11:56:57');
INSERT INTO `oauth2_refresh_token` VALUES ('cbdc99ea8557426da35d8507cdf4261d', NULL, NULL, 1, '2019-05-09 03:54:50', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('cc076ee31ae547868f4cf4887f803434', 27, 2, 1, '2019-07-04 00:20:01', '2019-07-03 12:20:01', '2019-07-03 12:20:01');
INSERT INTO `oauth2_refresh_token` VALUES ('cc099c4678654cfea543e16cad524679', 27, 2, 1, '2019-07-23 04:44:43', '2019-07-22 16:44:43', '2019-07-22 16:44:43');
INSERT INTO `oauth2_refresh_token` VALUES ('cc1791eaaeaf423e983451959fda1b17', 27, 2, 1, '2019-08-28 06:08:28', '2019-08-27 18:08:28', '2019-08-27 18:08:28');
INSERT INTO `oauth2_refresh_token` VALUES ('cc3056ed9f4d42bbbc456172317db971', 27, 2, 1, '2019-07-26 21:28:29', '2019-07-26 09:28:28', '2019-07-26 09:28:28');
INSERT INTO `oauth2_refresh_token` VALUES ('cc351eb864dd44958d760c90db091170', NULL, NULL, 1, '2019-05-11 03:46:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('cc3b43ee087c4a12bd665cde28e09786', 27, 2, 1, '2019-06-05 03:53:59', '2019-06-04 15:53:59', '2019-06-04 15:53:59');
INSERT INTO `oauth2_refresh_token` VALUES ('cc3c4c5bd5c7419f811504d652bd3ed7', 27, 2, 1, '2019-06-03 09:49:07', '2019-06-02 21:49:07', '2019-06-02 21:49:07');
INSERT INTO `oauth2_refresh_token` VALUES ('cc46eb3a9e85485a80a207f56e330bad', 27, 2, 1, '2019-07-02 05:42:53', '2019-07-01 17:42:53', '2019-07-01 17:42:53');
INSERT INTO `oauth2_refresh_token` VALUES ('cc48508be8bd4197ae818acf9961dc28', 27, 2, 1, '2019-06-19 01:14:35', '2019-06-18 13:14:35', '2019-06-18 13:14:35');
INSERT INTO `oauth2_refresh_token` VALUES ('cc522e89b3634e18a538314b30a1b855', 27, 2, 1, '2019-06-07 02:46:56', '2019-06-06 14:46:56', '2019-06-06 14:46:56');
INSERT INTO `oauth2_refresh_token` VALUES ('cc574ec23c404a5b9d5b1c92fb8efcbf', 27, 2, 1, '2019-06-30 10:18:19', '2019-06-29 22:18:18', '2019-06-29 22:18:18');
INSERT INTO `oauth2_refresh_token` VALUES ('cc6380aa0db54ba3a05ef8408b5e9e68', 27, 2, 1, '2019-09-06 22:43:36', '2019-09-06 10:43:35', '2019-09-06 10:43:35');
INSERT INTO `oauth2_refresh_token` VALUES ('cc860a7acc73490fa8b78ef0d86667bc', 27, 2, 1, '2019-06-03 08:40:42', '2019-06-02 20:40:41', '2019-06-02 20:40:41');
INSERT INTO `oauth2_refresh_token` VALUES ('cc8a0ba4c7aa41a2ae081c6323540f61', 27, 2, 1, '2019-09-07 02:41:52', '2019-09-06 14:41:52', '2019-09-06 14:41:52');
INSERT INTO `oauth2_refresh_token` VALUES ('cc8a563fe29c4ad3a5ead3fba7b80906', NULL, NULL, 1, '2019-05-06 05:17:01', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('cc912bde993f48d795b15b5189ccfd26', 27, 2, 1, '2019-08-10 04:29:03', '2019-08-09 16:29:03', '2019-08-09 16:29:03');
INSERT INTO `oauth2_refresh_token` VALUES ('cc9edc110d324678a9a535d6e6f58520', 27, 2, 1, '2019-06-20 02:33:53', '2019-06-19 14:33:52', '2019-06-19 14:33:52');
INSERT INTO `oauth2_refresh_token` VALUES ('ccaaaf9e898d472aab0201cc67a7a9fb', NULL, NULL, 1, '2019-03-10 20:48:04', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ccbd25f81f404611b907d9b2cc3fa978', 27, 2, 1, '2019-07-10 23:33:48', '2019-07-10 11:33:48', '2019-07-10 11:33:48');
INSERT INTO `oauth2_refresh_token` VALUES ('ccc3ef94f69b46a6b665cbbc26e83da3', 27, 2, 1, '2019-08-12 20:40:43', '2019-08-12 08:40:42', '2019-08-12 08:40:42');
INSERT INTO `oauth2_refresh_token` VALUES ('cccacecbe359453c933f1cf451b8ec55', NULL, NULL, 1, '2019-05-08 13:16:05', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ccdd8a61ee0b47cd868be41286deee0c', 1, 2, 0, '2019-06-03 00:20:44', '2019-06-02 12:20:44', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ccf94960ea824f09bdf218fbc4e4851f', 27, 2, 1, '2019-08-10 02:55:53', '2019-08-09 14:55:52', '2019-08-09 14:55:52');
INSERT INTO `oauth2_refresh_token` VALUES ('cd284346c8a84473a4b3d57c35a1d9b7', 27, 2, 1, '2019-05-20 23:39:55', '2019-05-20 11:39:54', '2019-05-20 11:39:54');
INSERT INTO `oauth2_refresh_token` VALUES ('cd3673a600ed4066a1fc7ae7af5f5a0d', 27, 2, 1, '2019-08-27 05:40:38', '2019-08-26 17:40:38', '2019-08-26 17:40:38');
INSERT INTO `oauth2_refresh_token` VALUES ('cd5382714c314707ada5b584aba183ff', 27, 2, 1, '2019-07-31 10:31:33', '2019-07-30 22:31:32', '2019-07-30 22:31:32');
INSERT INTO `oauth2_refresh_token` VALUES ('cd5d9043da6148758238b2e22231e244', 1, 2, 0, '2019-08-22 06:03:04', '2019-08-21 18:03:03', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('cd6817012df148138f5b3363c9a3da3c', 27, 2, 1, '2019-06-14 07:37:39', '2019-06-13 19:37:38', '2019-06-13 19:37:38');
INSERT INTO `oauth2_refresh_token` VALUES ('cd7c3ecc540b413da75b1748f80c532b', 27, 2, 1, '2019-05-21 02:45:01', '2019-05-20 14:45:01', '2019-05-20 14:45:01');
INSERT INTO `oauth2_refresh_token` VALUES ('cdc398048fcf43cb9c7c21e5dc6b21cd', 27, 2, 1, '2019-06-22 01:18:47', '2019-06-21 13:18:47', '2019-06-21 13:18:47');
INSERT INTO `oauth2_refresh_token` VALUES ('cdd1cb4506ac4faca7b47032d66ef375', 27, 2, 1, '2019-07-09 06:18:48', '2019-07-08 18:18:47', '2019-07-08 18:18:47');
INSERT INTO `oauth2_refresh_token` VALUES ('cdd7ed2ba23c43bb9344b2e6faaf26ba', NULL, NULL, 0, '2019-03-01 16:21:06', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('cde7243924364a78ae9d35314fe5c568', 155, 1, 1, '2019-07-03 23:15:39', '2019-07-03 11:15:39', '2019-07-03 11:15:39');
INSERT INTO `oauth2_refresh_token` VALUES ('cdf37bc26e5545308b326795df4a9443', 27, 2, 1, '2019-06-01 20:06:27', '2019-06-01 08:06:27', '2019-06-01 08:06:27');
INSERT INTO `oauth2_refresh_token` VALUES ('ce09199ac2484d81a2b7ff34e14615ab', 27, 2, 1, '2019-07-02 07:01:07', '2019-07-01 19:01:06', '2019-07-01 19:01:06');
INSERT INTO `oauth2_refresh_token` VALUES ('ce114d521d1b4ee0a2d4ef242a5a94c1', 27, 2, 1, '2019-08-22 04:17:47', '2019-08-21 16:17:47', '2019-08-21 16:17:47');
INSERT INTO `oauth2_refresh_token` VALUES ('ce3bafcc71394371b377013538775ab8', 27, 2, 1, '2019-08-02 03:40:12', '2019-08-01 15:40:12', '2019-08-01 15:40:12');
INSERT INTO `oauth2_refresh_token` VALUES ('ce40e635677d4fc5b4a44a85dc1b266f', 27, 2, 1, '2019-06-20 04:39:11', '2019-06-19 16:39:11', '2019-06-19 16:39:11');
INSERT INTO `oauth2_refresh_token` VALUES ('ce70a44c6aa34419a5db41e09230a66b', 27, 2, 1, '2019-07-03 23:25:30', '2019-07-03 11:25:29', '2019-07-03 11:25:29');
INSERT INTO `oauth2_refresh_token` VALUES ('ce7f73fbd7bc41ffb0050e3b4239a0b2', 27, 2, 1, '2019-06-02 05:27:31', '2019-06-01 17:27:30', '2019-06-01 17:27:30');
INSERT INTO `oauth2_refresh_token` VALUES ('ce923dec19a84b838672d8f650ecf251', 27, 2, 1, '2019-06-07 04:20:05', '2019-06-06 16:20:05', '2019-06-06 16:20:05');
INSERT INTO `oauth2_refresh_token` VALUES ('ce9ddfe8531c425b9c980543f36c00aa', 27, 2, 1, '2019-07-06 23:02:57', '2019-07-06 11:02:56', '2019-07-06 11:02:56');
INSERT INTO `oauth2_refresh_token` VALUES ('ced6a30658a2430baa53835cc8f49ddf', 1, 2, 0, '2019-08-22 06:02:04', '2019-08-21 18:02:04', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ced7a71322474ec794c7fc86d48d3ef8', 27, 2, 1, '2019-05-30 05:09:16', '2019-05-29 17:09:16', '2019-05-29 17:09:16');
INSERT INTO `oauth2_refresh_token` VALUES ('cedd78c601f34a6482fb9871e461c6d4', 27, 2, 1, '2019-05-25 04:36:55', '2019-05-24 16:36:54', '2019-05-24 16:36:54');
INSERT INTO `oauth2_refresh_token` VALUES ('cee09ead1a3842b69d68db3b8b9ebb04', 27, 2, 1, '2019-08-04 19:49:17', '2019-08-04 07:49:16', '2019-08-04 07:49:16');
INSERT INTO `oauth2_refresh_token` VALUES ('cee88823dad0485980275557b09f99b4', NULL, NULL, 1, '2019-05-08 01:28:30', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('cee9d6363985430899ddaffda32b0772', NULL, NULL, 1, '2019-05-05 21:42:38', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('cf01002ea60548bfaacffd0b29207a58', NULL, NULL, 1, '2019-04-07 00:53:09', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('cf0879abbbb443d3b2ef1c8b3db29468', 27, 2, 1, '2019-06-16 21:41:15', '2019-06-16 09:41:15', '2019-06-16 09:41:15');
INSERT INTO `oauth2_refresh_token` VALUES ('cf1e3256ea8b4e7cb07def84f8792252', 27, 2, 1, '2019-06-24 04:35:46', '2019-06-23 16:35:46', '2019-06-23 16:35:46');
INSERT INTO `oauth2_refresh_token` VALUES ('cf2c0cd7146d481d8dc33b65e8060160', 27, 2, 1, '2019-07-10 07:01:14', '2019-07-09 19:01:13', '2019-07-09 19:01:13');
INSERT INTO `oauth2_refresh_token` VALUES ('cf34052b37e4459fa306d343b0295c89', 27, 2, 1, '2019-07-16 06:15:08', '2019-07-15 18:15:07', '2019-07-15 18:15:07');
INSERT INTO `oauth2_refresh_token` VALUES ('cf5143ad19e34bf9927b38f3d6757601', 27, 2, 1, '2019-07-22 04:13:33', '2019-07-21 16:13:32', '2019-07-21 16:13:32');
INSERT INTO `oauth2_refresh_token` VALUES ('cf7201261c2a4f779f0d155822b62ca9', 27, 2, 1, '2019-08-31 23:45:45', '2019-08-31 11:45:45', '2019-08-31 11:45:45');
INSERT INTO `oauth2_refresh_token` VALUES ('cf7a52d51cab46cbbc5ef9de8bfc23b7', 27, 2, 1, '2019-06-06 20:23:14', '2019-06-06 08:23:14', '2019-06-06 08:23:14');
INSERT INTO `oauth2_refresh_token` VALUES ('cfcd8fc95fa6417a9f652f031e6aac27', 27, 2, 1, '2019-06-04 00:17:33', '2019-06-03 12:17:32', '2019-06-03 12:17:32');
INSERT INTO `oauth2_refresh_token` VALUES ('cfef6841b6a843829059f5ad3fbe65a4', 84, 1, 1, '2019-05-27 21:58:17', '2019-05-27 09:58:16', '2019-05-27 09:58:16');
INSERT INTO `oauth2_refresh_token` VALUES ('cff2ee7d6b2745919dd759a8b9808f06', 95, 1, 1, '2019-06-01 22:09:17', '2019-06-01 10:09:16', '2019-06-01 10:09:16');
INSERT INTO `oauth2_refresh_token` VALUES ('d0020f21794a47868e5841b18f470d79', 27, 2, 1, '2019-06-09 04:12:35', '2019-06-08 16:12:35', '2019-06-08 16:12:35');
INSERT INTO `oauth2_refresh_token` VALUES ('d002797a15be4953b7fa892d4fe5009a', 27, 2, 1, '2019-06-24 05:15:57', '2019-06-23 17:15:56', '2019-06-23 17:15:56');
INSERT INTO `oauth2_refresh_token` VALUES ('d02c29445da04e60aaa036b9c3d8106c', 27, 2, 1, '2019-08-21 01:55:53', '2019-08-20 13:55:52', '2019-08-20 13:55:52');
INSERT INTO `oauth2_refresh_token` VALUES ('d02ebe9ba98b4a9596a2412ac5e7cd10', 27, 2, 1, '2019-05-28 00:26:58', '2019-05-27 12:26:57', '2019-05-27 12:26:57');
INSERT INTO `oauth2_refresh_token` VALUES ('d037c713386c47b6ae71e83639639477', NULL, NULL, 1, '2019-04-30 02:19:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d03bb4f2f8a948c781214b5012a1aa9e', 27, 2, 1, '2019-08-17 04:17:04', '2019-08-16 16:17:04', '2019-08-16 16:17:04');
INSERT INTO `oauth2_refresh_token` VALUES ('d057ac9f67964c6986e874a42f79299f', 27, 2, 1, '2019-07-03 22:48:18', '2019-07-03 10:48:17', '2019-07-03 10:48:17');
INSERT INTO `oauth2_refresh_token` VALUES ('d06eadfd986c439d8878a3f3d12867d5', NULL, NULL, 1, '2019-04-30 00:00:25', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d082c6d2fd8d4c14b78da10741f392e3', 27, 2, 1, '2019-06-08 04:50:15', '2019-06-07 16:50:15', '2019-06-07 16:50:15');
INSERT INTO `oauth2_refresh_token` VALUES ('d09aec34c99343b398bfda888c6752d0', NULL, NULL, 1, '2019-04-26 22:59:17', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d0a2dd29503845508b15edd4531e5989', 27, 2, 1, '2019-06-16 11:34:46', '2019-06-15 23:34:45', '2019-06-15 23:34:45');
INSERT INTO `oauth2_refresh_token` VALUES ('d0a58c742ec840d98fd1af9859e220f9', NULL, NULL, 1, '2019-04-28 08:26:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d0a77ac12de84e0ca7da5fa6921bd3d7', NULL, NULL, 1, '2019-03-16 07:07:52', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d0b86a38f67d426b846713cfd3c3f4f8', 27, 2, 1, '2019-05-25 05:03:59', '2019-05-24 17:03:59', '2019-05-24 17:03:59');
INSERT INTO `oauth2_refresh_token` VALUES ('d0ddb87abdad48f7bdc0f3f0892f0749', 27, 2, 1, '2019-05-22 10:49:05', '2019-05-21 22:49:05', '2019-05-21 22:49:05');
INSERT INTO `oauth2_refresh_token` VALUES ('d0de7b632a8b4e2b9778554abf63c9bb', 153, 1, 1, '2019-07-03 04:10:07', '2019-07-02 16:10:06', '2019-07-02 16:10:06');
INSERT INTO `oauth2_refresh_token` VALUES ('d0e7738c952545ed8c4a2642f5692c36', 27, 2, 1, '2019-06-05 06:10:48', '2019-06-04 18:10:48', '2019-06-04 18:10:48');
INSERT INTO `oauth2_refresh_token` VALUES ('d11f3c2317404cec86467ab5dfdad900', 27, 2, 1, '2019-07-31 21:46:50', '2019-07-31 09:46:50', '2019-07-31 09:46:50');
INSERT INTO `oauth2_refresh_token` VALUES ('d15144b987564a2a829ee4a897cad38d', 27, 2, 1, '2019-08-17 04:08:46', '2019-08-16 16:08:46', '2019-08-16 16:08:46');
INSERT INTO `oauth2_refresh_token` VALUES ('d15667c7b7fa4ef890247d74992008f2', 27, 2, 1, '2019-07-04 05:23:27', '2019-07-03 17:23:26', '2019-07-03 17:23:26');
INSERT INTO `oauth2_refresh_token` VALUES ('d15ab9faaa3345eba925adc3610f2b0f', 27, 2, 1, '2019-05-22 04:41:14', '2019-05-21 16:41:13', '2019-05-21 16:41:13');
INSERT INTO `oauth2_refresh_token` VALUES ('d173084bc8a741d0931658fe2bdb0e6c', 1, 2, 0, '2019-06-05 03:54:11', '2019-06-04 15:54:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('d17af7338f5e4181bb09a9ec5dc1aedf', 195, 1, 1, '2019-08-11 03:36:17', '2019-08-10 15:36:18', '2019-08-10 15:36:18');
INSERT INTO `oauth2_refresh_token` VALUES ('d17f59fa21e943e1b410d220f21bf006', NULL, NULL, 1, '2019-05-06 09:56:36', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d193bd451ec44f3cbbb6aefdb9f84107', 27, 2, 1, '2019-07-11 10:34:54', '2019-07-10 22:34:54', '2019-07-10 22:34:54');
INSERT INTO `oauth2_refresh_token` VALUES ('d19a10765cff4bc9995d3b51df24e94f', 27, 2, 1, '2019-06-23 03:35:49', '2019-06-22 15:35:49', '2019-06-22 15:35:49');
INSERT INTO `oauth2_refresh_token` VALUES ('d1e3a971a10242668ba096be5c376074', 27, 2, 1, '2019-07-09 10:27:02', '2019-07-08 22:27:02', '2019-07-08 22:27:02');
INSERT INTO `oauth2_refresh_token` VALUES ('d1f49cfaf5a940df98c0e96cf1adccd0', NULL, NULL, 1, '2019-05-13 11:25:19', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d1f805d80c94439f829d808fc7235c62', NULL, NULL, 1, '2019-05-05 21:52:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d22bd842c5ed4238b9ce732e1f8b13e9', 27, 2, 1, '2019-06-20 02:24:42', '2019-06-19 14:24:41', '2019-06-19 14:24:41');
INSERT INTO `oauth2_refresh_token` VALUES ('d22e4554183049ba955427c9e656ffc8', 27, 2, 1, '2019-09-08 03:01:46', '2019-09-07 15:01:45', '2019-09-07 15:01:45');
INSERT INTO `oauth2_refresh_token` VALUES ('d235d49c00974e7b929411466996c855', NULL, NULL, 1, '2019-03-13 07:44:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d23f62660387464e95d13a2c480a5692', 27, 2, 1, '2019-05-30 04:21:41', '2019-05-29 16:21:41', '2019-05-29 16:21:41');
INSERT INTO `oauth2_refresh_token` VALUES ('d2522fa286cb454eb51bdb4c5daec68a', 27, 2, 1, '2019-06-04 03:54:45', '2019-06-03 15:54:45', '2019-06-03 15:54:45');
INSERT INTO `oauth2_refresh_token` VALUES ('d26181e72a594673a4479f2560236bbf', 27, 2, 1, '2019-08-19 22:30:40', '2019-08-19 10:30:39', '2019-08-19 10:30:39');
INSERT INTO `oauth2_refresh_token` VALUES ('d28fcd8097464163b5bf3ae5a566230d', 27, 2, 1, '2019-07-25 02:43:27', '2019-07-24 14:43:27', '2019-07-24 14:43:27');
INSERT INTO `oauth2_refresh_token` VALUES ('d29523d51e254b6399914939b567ce48', 212, 1, 1, '2019-08-26 22:24:28', '2019-08-26 10:24:25', '2019-08-26 10:24:25');
INSERT INTO `oauth2_refresh_token` VALUES ('d29eb1158daf43bcb21bcd55f5998ec7', 27, 2, 1, '2019-06-01 04:41:31', '2019-05-31 16:41:31', '2019-05-31 16:41:31');
INSERT INTO `oauth2_refresh_token` VALUES ('d2b3f845a0204713a968e7012b46108b', 27, 2, 1, '2019-06-02 03:02:39', '2019-06-01 15:02:39', '2019-06-01 15:02:39');
INSERT INTO `oauth2_refresh_token` VALUES ('d2b4e37c7dc343db90dc9ee29f2eef78', NULL, NULL, 1, '2019-05-07 21:54:01', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d2cd5bf0803547bcad3ea5dbeebdeec7', 1, 2, 0, '2019-07-13 03:52:45', '2019-07-12 15:52:44', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('d2cdd3373d244994ae1562238fedf3c8', 27, 2, 1, '2019-08-09 02:33:35', '2019-08-08 14:33:35', '2019-08-08 14:33:35');
INSERT INTO `oauth2_refresh_token` VALUES ('d2e0c2cf7e044cb5a1e823fce514afe7', 27, 2, 1, '2019-06-04 20:43:09', '2019-06-04 08:43:08', '2019-06-04 08:43:08');
INSERT INTO `oauth2_refresh_token` VALUES ('d2e3342fb4a8461ebcdea3848928471e', 27, 2, 1, '2019-06-07 23:50:06', '2019-06-07 11:50:05', '2019-06-07 11:50:05');
INSERT INTO `oauth2_refresh_token` VALUES ('d2f1676e992d46f6a7e7fd490605c7db', 27, 2, 1, '2019-07-09 11:32:23', '2019-07-08 23:32:22', '2019-07-08 23:32:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d2f7abdf11e54662a62cbafa34716a79', 27, 2, 1, '2019-06-01 06:19:02', '2019-05-31 18:19:01', '2019-05-31 18:19:01');
INSERT INTO `oauth2_refresh_token` VALUES ('d31602cad048416aa34ba1e1f11deaab', NULL, NULL, 1, '2019-03-14 01:31:06', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d329e5927c5d49e0838489b391a190da', 27, 2, 1, '2019-06-12 05:00:55', '2019-06-11 17:00:55', '2019-06-11 17:00:55');
INSERT INTO `oauth2_refresh_token` VALUES ('d33454eb13a44396b1230b0602cf2785', 27, 2, 1, '2019-07-19 01:53:38', '2019-07-18 13:53:37', '2019-07-18 13:53:37');
INSERT INTO `oauth2_refresh_token` VALUES ('d347c73e04504a09aa630b6e3bd614ea', NULL, NULL, 1, '2019-05-06 04:52:23', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d352c49db6bf4a38ab880c073f648d30', 27, 2, 1, '2019-06-23 22:39:25', '2019-06-23 10:39:24', '2019-06-23 10:39:24');
INSERT INTO `oauth2_refresh_token` VALUES ('d35ad2962c05430dbb5681e8eb208065', NULL, NULL, 1, '2019-05-08 18:21:16', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d3739b01fc2344fa9220b3a8cb1f8fd5', 27, 2, 1, '2019-08-14 21:07:09', '2019-08-14 09:07:08', '2019-08-14 09:07:08');
INSERT INTO `oauth2_refresh_token` VALUES ('d3786e13ffa64b7e99049ca4312f6ebb', 27, 2, 1, '2019-09-06 02:53:10', '2019-09-05 14:53:09', '2019-09-05 14:53:09');
INSERT INTO `oauth2_refresh_token` VALUES ('d38bedfb661f407db22386ea5b6c768f', 27, 2, 1, '2019-07-09 03:14:16', '2019-07-08 15:14:16', '2019-07-08 15:14:16');
INSERT INTO `oauth2_refresh_token` VALUES ('d39a5aa52efe42048aa747d99d6e2500', 27, 2, 1, '2019-08-06 05:19:25', '2019-08-05 17:19:24', '2019-08-05 17:19:24');
INSERT INTO `oauth2_refresh_token` VALUES ('d3ab9560c60b41d692cc34b6ad6c40ec', 27, 2, 1, '2019-07-15 10:41:05', '2019-07-14 22:41:05', '2019-07-14 22:41:05');
INSERT INTO `oauth2_refresh_token` VALUES ('d3c6f8738a2c4463a2d24cc85ac79d01', 27, 2, 1, '2019-07-27 00:00:02', '2019-07-26 12:00:01', '2019-07-26 12:00:01');
INSERT INTO `oauth2_refresh_token` VALUES ('d3ca3d96811a43efbc7b08917ce5fa7f', 27, 2, 1, '2019-07-25 02:51:45', '2019-07-24 14:51:45', '2019-07-24 14:51:45');
INSERT INTO `oauth2_refresh_token` VALUES ('d3daaff2258541c182b694d5b4284e3a', 27, 2, 1, '2019-05-30 04:00:43', '2019-05-29 16:00:42', '2019-05-29 16:00:42');
INSERT INTO `oauth2_refresh_token` VALUES ('d3f4920d20144efca6e5441c628e9940', 27, 2, 1, '2019-07-27 11:32:15', '2019-07-26 23:32:14', '2019-07-26 23:32:14');
INSERT INTO `oauth2_refresh_token` VALUES ('d40039c135d4481a87dd76dc817bd706', 1, 2, 0, '2019-07-08 04:47:00', '2019-07-07 16:46:59', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('d42198893f1b4debaa7f459059c86472', 27, 2, 1, '2019-06-06 03:41:23', '2019-06-05 15:41:23', '2019-06-05 15:41:23');
INSERT INTO `oauth2_refresh_token` VALUES ('d42b9044b0f24332bf23b16283ad2a7a', 1, 2, 0, '2019-05-31 05:42:33', '2019-05-30 17:42:33', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('d42fe0dacc3c4f2f92fb35672e1f38d8', 73, 1, 1, '2019-05-18 05:51:48', '2019-05-17 17:51:47', '2019-05-17 17:51:47');
INSERT INTO `oauth2_refresh_token` VALUES ('d431856829254160b671276ca815b020', 77, 1, 1, '2019-05-22 05:32:38', '2019-05-21 17:32:37', '2019-05-21 17:32:37');
INSERT INTO `oauth2_refresh_token` VALUES ('d4445e1ac5034a439d282ad3dcb3dd74', 78, 1, 1, '2019-05-23 03:51:01', '2019-05-22 15:51:01', '2019-05-22 15:51:01');
INSERT INTO `oauth2_refresh_token` VALUES ('d44e4df391cf45e78b40bd97a87045b4', 27, 2, 1, '2019-07-06 21:38:17', '2019-07-06 09:38:16', '2019-07-06 09:38:16');
INSERT INTO `oauth2_refresh_token` VALUES ('d4568135d95c4f94a3873180840987f8', 27, 2, 1, '2019-06-22 05:02:55', '2019-06-21 17:02:54', '2019-06-21 17:02:54');
INSERT INTO `oauth2_refresh_token` VALUES ('d46293765d47499a985c732df4dfb849', 27, 2, 1, '2019-07-13 02:24:44', '2019-07-12 14:24:43', '2019-07-12 14:24:43');
INSERT INTO `oauth2_refresh_token` VALUES ('d467ef928e464b26ad4eafed25f01253', 27, 2, 1, '2019-06-09 08:13:40', '2019-06-08 20:13:40', '2019-06-08 20:13:40');
INSERT INTO `oauth2_refresh_token` VALUES ('d47b390a25b345c980c27d9350299855', NULL, NULL, 1, '2019-03-16 06:46:06', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d47ce23068514e69b1c43fd54802b2c5', 27, 2, 1, '2019-06-10 22:34:12', '2019-06-10 10:34:11', '2019-06-10 10:34:11');
INSERT INTO `oauth2_refresh_token` VALUES ('d4ab90931e4d42e08695073c3bcfcc20', 27, 2, 1, '2019-06-15 04:35:09', '2019-06-14 16:35:08', '2019-06-14 16:35:08');
INSERT INTO `oauth2_refresh_token` VALUES ('d4ded3ef12f241c0b7b44ab80a11fccc', 27, 2, 1, '2019-06-02 02:47:37', '2019-06-01 14:47:37', '2019-06-01 14:47:37');
INSERT INTO `oauth2_refresh_token` VALUES ('d4ec0f34a7c243b3a283ce4f8a655e26', 27, 2, 1, '2019-06-01 06:17:27', '2019-05-31 18:17:26', '2019-05-31 18:17:26');
INSERT INTO `oauth2_refresh_token` VALUES ('d4ffb898048f44afa689e5eb5739f553', 27, 2, 1, '2019-06-04 22:25:01', '2019-06-04 10:25:00', '2019-06-04 10:25:00');
INSERT INTO `oauth2_refresh_token` VALUES ('d50c7700b0924aa789f8dd40cee640b0', 27, 2, 1, '2019-06-19 02:05:41', '2019-06-18 14:05:40', '2019-06-18 14:05:40');
INSERT INTO `oauth2_refresh_token` VALUES ('d511e2a2896541069884babd7a49bd30', NULL, NULL, 1, '2019-04-29 22:22:07', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d51d2c1ad4ff492aa8f85c97866a5e44', 27, 2, 1, '2019-07-05 05:08:02', '2019-07-04 17:08:01', '2019-07-04 17:08:01');
INSERT INTO `oauth2_refresh_token` VALUES ('d5500833ab8b4d2ca43f37eee3f41d0d', 27, 2, 1, '2019-09-05 23:38:11', '2019-09-05 11:38:11', '2019-09-05 11:38:11');
INSERT INTO `oauth2_refresh_token` VALUES ('d58b81f2fbc44e6d89ff48c471cfab87', 27, 2, 1, '2019-06-11 04:51:15', '2019-06-10 16:51:14', '2019-06-10 16:51:14');
INSERT INTO `oauth2_refresh_token` VALUES ('d58e44f8ccb04866be1cbeaeaf429e55', 27, 2, 1, '2019-09-05 21:13:31', '2019-09-05 09:13:31', '2019-09-05 09:13:31');
INSERT INTO `oauth2_refresh_token` VALUES ('d592b981fa924686a3bb928570adabb6', NULL, NULL, 1, '2019-05-06 23:45:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d595f6dc2bb04eb08e23b1152c4a1057', 1, 2, 1, '2019-09-08 23:38:42', '2019-09-08 11:38:42', '2019-09-08 11:38:42');
INSERT INTO `oauth2_refresh_token` VALUES ('d5a88029fee24e3fa59c6c6230d9c0e4', 27, 2, 1, '2019-06-20 11:10:51', '2019-06-19 23:10:51', '2019-06-19 23:10:51');
INSERT INTO `oauth2_refresh_token` VALUES ('d5c15b12c59b470393bade100411e7dc', 27, 2, 1, '2019-06-21 00:32:17', '2019-06-20 12:32:16', '2019-06-20 12:32:16');
INSERT INTO `oauth2_refresh_token` VALUES ('d5c7cf565a0e4b4ca00bdd4da488660d', 27, 2, 1, '2019-06-20 09:36:22', '2019-06-19 21:36:21', '2019-06-19 21:36:21');
INSERT INTO `oauth2_refresh_token` VALUES ('d5d6f13d9250468a87c5de00148c4f2a', 27, 2, 1, '2019-06-27 23:14:57', '2019-06-27 11:14:56', '2019-06-27 11:14:56');
INSERT INTO `oauth2_refresh_token` VALUES ('d5dad2358600475d81295308e888eb54', 27, 2, 1, '2019-06-27 22:26:58', '2019-06-27 10:26:57', '2019-06-27 10:26:57');
INSERT INTO `oauth2_refresh_token` VALUES ('d6053bde9ca648c78bd6007258403e0e', 1, 2, 0, '2019-06-24 02:30:52', '2019-06-23 14:30:52', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('d60a2a38a92c4defa52f0e96e2cb2ecc', 27, 2, 1, '2019-07-27 12:46:50', '2019-07-27 00:46:49', '2019-07-27 00:46:49');
INSERT INTO `oauth2_refresh_token` VALUES ('d61f249fbbba4d46860dd9d46dfa9a2c', 27, 2, 1, '2019-07-19 04:22:20', '2019-07-18 16:22:20', '2019-07-18 16:22:20');
INSERT INTO `oauth2_refresh_token` VALUES ('d63004e528c24769b65db1ccae36d1dd', 27, 2, 1, '2019-06-15 03:08:50', '2019-06-14 15:08:49', '2019-06-14 15:08:49');
INSERT INTO `oauth2_refresh_token` VALUES ('d63951737c704b58b5863faebd121032', 27, 2, 1, '2019-07-03 01:29:05', '2019-07-02 13:29:05', '2019-07-02 13:29:05');
INSERT INTO `oauth2_refresh_token` VALUES ('d64ee8577a2d45c2987cc24cf65cf1c6', 27, 2, 1, '2019-07-15 22:37:21', '2019-07-15 10:37:20', '2019-07-15 10:37:20');
INSERT INTO `oauth2_refresh_token` VALUES ('d681818e4d944bc5865b63b699e151bd', 1, 2, 1, '2019-09-09 10:04:48', '2019-09-08 22:04:48', '2019-09-08 22:04:48');
INSERT INTO `oauth2_refresh_token` VALUES ('d68e23332ab94e408deab6af2d32284d', 27, 2, 1, '2019-06-01 11:16:07', '2019-05-31 23:16:07', '2019-05-31 23:16:07');
INSERT INTO `oauth2_refresh_token` VALUES ('d68e84002c1041ef952dd3bfcdbf1342', NULL, NULL, 1, '2019-05-10 04:51:12', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d691223d6b974307a3683a391710880c', 27, 2, 1, '2019-06-08 21:59:32', '2019-06-08 09:59:31', '2019-06-08 09:59:31');
INSERT INTO `oauth2_refresh_token` VALUES ('d693e7c5d0924067a9fb97fe7ea6f611', NULL, NULL, 1, '2019-05-11 08:30:36', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d6a60733ae274a3ca928534954950e4e', NULL, NULL, 1, '2019-05-01 08:25:36', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d6aba0392223419e99ef65ede5d0cdd1', 27, 2, 1, '2019-07-03 21:25:11', '2019-07-03 09:25:10', '2019-07-03 09:25:10');
INSERT INTO `oauth2_refresh_token` VALUES ('d6b1ae8fbb3c4c92bf753bfca1ea6f17', 27, 2, 1, '2019-07-06 09:48:50', '2019-07-05 21:48:50', '2019-07-05 21:48:50');
INSERT INTO `oauth2_refresh_token` VALUES ('d6b4f0742a3f4a978dc32c5976c6df85', 27, 2, 1, '2019-06-15 00:34:08', '2019-06-14 12:34:07', '2019-06-14 12:34:07');
INSERT INTO `oauth2_refresh_token` VALUES ('d6b814cdd56e49c699e9856175829faf', 27, 2, 1, '2019-06-04 21:15:01', '2019-06-04 09:15:01', '2019-06-04 09:15:01');
INSERT INTO `oauth2_refresh_token` VALUES ('d6b8a5cbe2ef456a90a12660e0b8635e', NULL, NULL, 1, '2019-03-12 07:43:23', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d6bd3c12350148c5b32cb7f5b60a3e0a', NULL, NULL, 1, '2019-05-05 22:20:47', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d6e1996199e44a979927a47a89024cea', NULL, NULL, 1, '2019-03-21 07:59:25', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d6f02244a5c141ebaa634c02d20ca7a3', 27, 2, 1, '2019-06-13 07:24:27', '2019-06-12 19:24:27', '2019-06-12 19:24:27');
INSERT INTO `oauth2_refresh_token` VALUES ('d6f7510827f34250bfa7a60a014352fd', 27, 2, 1, '2019-08-16 01:22:04', '2019-08-15 13:22:03', '2019-08-15 13:22:03');
INSERT INTO `oauth2_refresh_token` VALUES ('d70d8c35d86f41d89b80d54b0b8f8ae5', 27, 2, 1, '2019-07-10 10:51:26', '2019-07-09 22:51:25', '2019-07-09 22:51:25');
INSERT INTO `oauth2_refresh_token` VALUES ('d70e097f8ef7468298448d1dafc7ce19', 27, 2, 1, '2019-05-22 03:10:08', '2019-05-21 15:10:07', '2019-05-21 15:10:07');
INSERT INTO `oauth2_refresh_token` VALUES ('d74bf3ab6c904eb596fc17b56812af35', 27, 2, 1, '2019-08-04 01:23:20', '2019-08-03 13:23:19', '2019-08-03 13:23:19');
INSERT INTO `oauth2_refresh_token` VALUES ('d776f6182a8543cfb36a931aa4e53c4f', 27, 2, 1, '2019-07-19 04:24:18', '2019-07-18 16:24:17', '2019-07-18 16:24:17');
INSERT INTO `oauth2_refresh_token` VALUES ('d7a5330d67f04908b19a576daf6295aa', 113, 1, 1, '2019-06-09 10:20:00', '2019-06-08 22:20:00', '2019-06-08 22:20:00');
INSERT INTO `oauth2_refresh_token` VALUES ('d7b1e96bfefe4949b9bc12377aaac884', NULL, NULL, 1, '2019-05-10 02:28:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d7f6bd675aee436894d30039abce4b2d', NULL, NULL, 1, '2019-05-11 04:42:50', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d7fbdf002b9449a5a3c7092b45bfeabb', 27, 2, 1, '2019-08-18 06:59:28', '2019-08-17 18:59:27', '2019-08-17 18:59:27');
INSERT INTO `oauth2_refresh_token` VALUES ('d807a142288044e0a7b5d2322a536f3d', NULL, NULL, 1, '2019-05-06 03:48:47', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d80c4b7cc41242f89297b43df1b7ef11', 27, 2, 1, '2019-06-01 21:54:29', '2019-06-01 09:54:28', '2019-06-01 09:54:28');
INSERT INTO `oauth2_refresh_token` VALUES ('d82f6937e2de400a96b59164e3327539', 27, 2, 1, '2019-08-05 23:54:44', '2019-08-05 11:54:43', '2019-08-05 11:54:43');
INSERT INTO `oauth2_refresh_token` VALUES ('d8561121c97540b6bbc0807884ebebb6', NULL, NULL, 1, '2019-04-13 07:27:51', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d857f0a60ca24be0be4123ee9f339b0f', NULL, NULL, 1, '2019-05-14 03:06:21', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d8681ece23c347ebbc72930c7cb98610', 27, 2, 1, '2019-09-09 15:28:06', '2019-09-09 03:28:06', '2019-09-09 03:28:06');
INSERT INTO `oauth2_refresh_token` VALUES ('d8aa376c6f6d4e1f9fa0730dbc45c653', 27, 2, 1, '2019-08-21 00:34:15', '2019-08-20 12:34:15', '2019-08-20 12:34:15');
INSERT INTO `oauth2_refresh_token` VALUES ('d8be74b3a5e1448b82321984d99b9874', 1, 2, 0, '2019-08-29 01:56:26', '2019-08-28 13:56:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('d8bfee7fd32e47f7bc4f8d6aaabf3753', 1, 2, 0, '2019-07-27 22:56:56', '2019-07-27 10:56:56', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('d8ccc7f67790402e97bc4cf134d87a27', 27, 2, 1, '2019-05-23 04:29:22', '2019-05-22 16:29:21', '2019-05-22 16:29:21');
INSERT INTO `oauth2_refresh_token` VALUES ('d8d55c5e53664e3b95082246f6fb1a06', 27, 2, 1, '2019-05-19 23:18:35', '2019-05-19 11:18:35', '2019-05-19 11:18:35');
INSERT INTO `oauth2_refresh_token` VALUES ('d8e04308fc2d4d10aabc1187f66fefcc', 27, 2, 1, '2019-06-10 02:34:05', '2019-06-09 14:34:05', '2019-06-09 14:34:05');
INSERT INTO `oauth2_refresh_token` VALUES ('d8ea7d689ba24217aba90d88b76f3abb', 27, 2, 1, '2019-06-18 03:31:23', '2019-06-17 15:31:23', '2019-06-17 15:31:23');
INSERT INTO `oauth2_refresh_token` VALUES ('d8f3f1c5fde1492ca4530fe6b8d130e7', 27, 2, 1, '2019-07-10 04:04:12', '2019-07-09 16:04:12', '2019-07-09 16:04:12');
INSERT INTO `oauth2_refresh_token` VALUES ('d8f9910398e947f0aa9d6dd179c91282', 27, 2, 1, '2019-07-25 02:35:07', '2019-07-24 14:35:07', '2019-07-24 14:35:07');
INSERT INTO `oauth2_refresh_token` VALUES ('d9112c7574ef42138e50892dcc8349c8', NULL, NULL, 1, '2019-03-16 08:32:04', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d92dd8cd51aa488b89c81bb446a1220e', 27, 2, 1, '2019-05-27 22:43:34', '2019-05-27 10:43:34', '2019-05-27 10:43:34');
INSERT INTO `oauth2_refresh_token` VALUES ('d93c956753c5482aa25eeaf1f4e0cfb4', 27, 2, 1, '2019-06-05 11:47:29', '2019-06-04 23:47:29', '2019-06-04 23:47:29');
INSERT INTO `oauth2_refresh_token` VALUES ('d9409a4477314a9fb9ab82dd4fb39eb6', 27, 2, 1, '2019-08-29 01:39:00', '2019-08-28 13:39:00', '2019-08-28 13:39:00');
INSERT INTO `oauth2_refresh_token` VALUES ('d943c72dbb464933a2c8230ee53e3b38', 27, 2, 1, '2019-05-21 23:17:49', '2019-05-21 11:17:49', '2019-05-21 11:17:49');
INSERT INTO `oauth2_refresh_token` VALUES ('d96429e7a8984895b2668597be418ca1', 27, 2, 1, '2019-08-12 21:37:33', '2019-08-12 09:37:33', '2019-08-12 09:37:33');
INSERT INTO `oauth2_refresh_token` VALUES ('d9678fc1a3224fe9a66572e80e44b40f', 201, 1, 1, '2019-08-14 23:44:44', '2019-08-14 11:44:43', '2019-08-14 11:44:43');
INSERT INTO `oauth2_refresh_token` VALUES ('d9687f98894c41f98f5ceb039fb583ee', 27, 2, 1, '2019-06-03 12:37:09', '2019-06-03 00:37:09', '2019-06-03 00:37:09');
INSERT INTO `oauth2_refresh_token` VALUES ('d970470a3d8340cdae6c6a00e4b4c3b5', NULL, NULL, 1, '2019-05-09 08:17:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d97335100fa44b70914dc5569cbf75fc', 27, 2, 1, '2019-06-02 02:53:32', '2019-06-01 14:53:32', '2019-06-01 14:53:32');
INSERT INTO `oauth2_refresh_token` VALUES ('d986ed871dcb46cabf44fc71daf9eea9', NULL, NULL, 1, '2019-05-06 12:24:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('d993d48b0f23413ebe74156924afc502', 196, 1, 1, '2019-08-13 03:35:59', '2019-08-12 15:35:58', '2019-08-12 15:35:58');
INSERT INTO `oauth2_refresh_token` VALUES ('d9953d3872ea46778d587337628b489c', 27, 2, 1, '2019-06-27 01:45:32', '2019-06-26 13:45:32', '2019-06-26 13:45:32');
INSERT INTO `oauth2_refresh_token` VALUES ('d9acb6ba78d74fbfaa58b86380684d14', 27, 2, 1, '2019-08-08 05:23:06', '2019-08-07 17:23:05', '2019-08-07 17:23:05');
INSERT INTO `oauth2_refresh_token` VALUES ('d9b9ac71ffa843bd9d6568debf315f9a', 1, 2, 0, '2019-06-07 06:06:10', '2019-06-06 18:06:10', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('d9cec5bb87344e15b5e2ba2906ff2d04', 73, 1, 1, '2019-05-18 05:49:25', '2019-05-17 17:49:25', '2019-05-17 17:49:25');
INSERT INTO `oauth2_refresh_token` VALUES ('d9d47089429f4510889e1263290867ce', 27, 2, 1, '2019-08-18 23:28:15', '2019-08-18 11:28:15', '2019-08-18 11:28:15');
INSERT INTO `oauth2_refresh_token` VALUES ('d9f454c0f13042ccba9a7308c8bdaed0', 27, 2, 1, '2019-06-04 08:12:04', '2019-06-03 20:12:03', '2019-06-03 20:12:03');
INSERT INTO `oauth2_refresh_token` VALUES ('da081d16b4394373896a8ba5f2e2e062', 27, 2, 1, '2019-07-24 07:39:45', '2019-07-23 19:39:44', '2019-07-23 19:39:44');
INSERT INTO `oauth2_refresh_token` VALUES ('da0f9e5857d74d48b7cf4404ce73a0f3', 27, 2, 1, '2019-06-04 04:26:27', '2019-06-03 16:26:26', '2019-06-03 16:26:26');
INSERT INTO `oauth2_refresh_token` VALUES ('da1089f6b79348c7b9a4a5f391a3fe9c', 27, 2, 1, '2019-06-12 02:07:14', '2019-06-11 14:07:14', '2019-06-11 14:07:14');
INSERT INTO `oauth2_refresh_token` VALUES ('da1e8b0569674d19bf4f0135ca5f672e', 27, 2, 1, '2019-07-10 21:35:56', '2019-07-10 09:35:55', '2019-07-10 09:35:55');
INSERT INTO `oauth2_refresh_token` VALUES ('da204ebf3c5a4bfcb123f8774ee0b1e5', 27, 2, 1, '2019-07-23 02:34:17', '2019-07-22 14:34:17', '2019-07-22 14:34:17');
INSERT INTO `oauth2_refresh_token` VALUES ('da3712e64f88416996141aa55cb2cbec', 27, 2, 1, '2019-07-01 11:34:54', '2019-06-30 23:34:53', '2019-06-30 23:34:53');
INSERT INTO `oauth2_refresh_token` VALUES ('da3fb22b8c574be0aea75189413c88f5', 27, 2, 1, '2019-06-03 23:42:26', '2019-06-03 11:42:26', '2019-06-03 11:42:26');
INSERT INTO `oauth2_refresh_token` VALUES ('da53533e02f048a5bdcf7d3c0802b57e', NULL, NULL, 1, '2019-05-06 23:02:58', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('da639db8f6d34116b08c455b5fb2e921', 27, 2, 1, '2019-08-09 02:10:37', '2019-08-08 14:10:37', '2019-08-08 14:10:37');
INSERT INTO `oauth2_refresh_token` VALUES ('da63c64f70e24422b7217d1568b26bb1', 27, 2, 1, '2019-08-03 04:11:16', '2019-08-02 16:11:15', '2019-08-02 16:11:15');
INSERT INTO `oauth2_refresh_token` VALUES ('da694ca7b69d47999271a7caf98af3a8', 1, 2, 0, '2019-08-22 06:01:54', '2019-08-21 18:01:54', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('da6b5eba9fd04715a25a2c1a93cb9ab1', 27, 2, 1, '2019-09-07 22:00:12', '2019-09-07 10:00:11', '2019-09-07 10:00:11');
INSERT INTO `oauth2_refresh_token` VALUES ('da7d5c5f9d7640499d058225f747029f', 27, 2, 1, '2019-05-24 02:32:27', '2019-05-23 14:32:26', '2019-05-23 14:32:26');
INSERT INTO `oauth2_refresh_token` VALUES ('da867788c07c4f1197aad2e1a7d932d2', 1, 2, 0, '2019-06-20 22:59:58', '2019-06-20 10:59:57', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('da8c6f986cb347178cb6cf3f2f99bdd5', NULL, NULL, 1, '2019-05-05 21:01:48', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('daa9153c55da402e8dc464e4a041b935', 27, 2, 1, '2019-06-19 03:12:12', '2019-06-18 15:12:12', '2019-06-18 15:12:12');
INSERT INTO `oauth2_refresh_token` VALUES ('dab00ae34d2a40739c8aeb89e9a78eb0', 1, 2, 0, '2019-06-29 03:14:01', '2019-06-28 15:14:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('dad86c9ed67849108132dfbea7d39d7f', 27, 2, 1, '2019-06-16 01:39:59', '2019-06-15 13:39:59', '2019-06-15 13:39:59');
INSERT INTO `oauth2_refresh_token` VALUES ('dadbbbf6e6394d91ba6739bff4b61f96', 27, 2, 1, '2019-07-19 18:11:56', '2019-07-19 06:11:55', '2019-07-19 06:11:55');
INSERT INTO `oauth2_refresh_token` VALUES ('dadd6b47205148aea7d42da8e0b3ce68', 27, 2, 1, '2019-08-03 03:35:07', '2019-08-02 15:35:06', '2019-08-02 15:35:06');
INSERT INTO `oauth2_refresh_token` VALUES ('daea13d977a64201820da137afc4335a', 27, 2, 1, '2019-06-28 08:32:55', '2019-06-27 20:32:55', '2019-06-27 20:32:55');
INSERT INTO `oauth2_refresh_token` VALUES ('daef6b344488480283b0f7ae12abca6c', 27, 2, 1, '2019-08-19 14:11:38', '2019-08-19 02:11:38', '2019-08-19 02:11:38');
INSERT INTO `oauth2_refresh_token` VALUES ('dafe21789e784a2aaa60ddf930853b35', 27, 2, 1, '2019-05-28 05:46:26', '2019-05-27 17:46:25', '2019-05-27 17:46:25');
INSERT INTO `oauth2_refresh_token` VALUES ('db1b40b8514148979e2901d9230c8351', 27, 2, 1, '2019-07-22 22:30:48', '2019-07-22 10:30:48', '2019-07-22 10:30:48');
INSERT INTO `oauth2_refresh_token` VALUES ('db490e224c344fdebaf43a8c5e85fa06', 27, 2, 1, '2019-08-23 22:36:01', '2019-08-23 10:36:00', '2019-08-23 10:36:00');
INSERT INTO `oauth2_refresh_token` VALUES ('db49ed31c43544c9ac321891497cb4c8', NULL, NULL, 1, '2019-05-10 07:52:17', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('db688ad684774f448c21574808530b26', 27, 2, 1, '2019-05-24 22:44:04', '2019-05-24 10:44:03', '2019-05-24 10:44:03');
INSERT INTO `oauth2_refresh_token` VALUES ('dba7cf9263a94cf6a9b367d95f84f3ea', 27, 2, 1, '2019-06-03 07:09:37', '2019-06-02 19:09:37', '2019-06-02 19:09:37');
INSERT INTO `oauth2_refresh_token` VALUES ('dbadd058adbd458ca9b56750dd3dcabf', NULL, NULL, 1, '2019-04-24 22:43:23', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('dbb02b8065814d5990e4a1ecbffcbdd1', NULL, NULL, 1, '2019-05-06 04:58:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('dbd147f7b8bd4ee89f9d5f60243e787b', 216, 1, 1, '2019-08-30 23:37:46', '2019-08-30 11:37:46', '2019-08-30 11:37:46');
INSERT INTO `oauth2_refresh_token` VALUES ('dbde836a94a44eccb652250a044cfc0f', 27, 2, 1, '2019-08-31 04:58:02', '2019-08-30 16:58:01', '2019-08-30 16:58:01');
INSERT INTO `oauth2_refresh_token` VALUES ('dbe83eeb83274794a8b8942c78cca8ed', 27, 2, 1, '2019-06-05 03:09:15', '2019-06-04 15:09:15', '2019-06-04 15:09:15');
INSERT INTO `oauth2_refresh_token` VALUES ('dc13d98e3f034f6dad29ffe459bdf912', 27, 2, 1, '2019-06-09 01:55:18', '2019-06-08 13:55:18', '2019-06-08 13:55:18');
INSERT INTO `oauth2_refresh_token` VALUES ('dc28571562194eb8bea7ae6adc636674', 198, 1, 1, '2019-08-28 03:52:04', '2019-08-27 15:52:04', '2019-08-27 15:52:04');
INSERT INTO `oauth2_refresh_token` VALUES ('dc3890d432cd45d6a398dc214e0bb9c0', 27, 2, 1, '2019-06-06 23:39:35', '2019-06-06 11:39:35', '2019-06-06 11:39:35');
INSERT INTO `oauth2_refresh_token` VALUES ('dc44740dfd284f5abfb72a33bd766f44', 27, 2, 1, '2019-08-20 03:07:35', '2019-08-19 15:07:34', '2019-08-19 15:07:34');
INSERT INTO `oauth2_refresh_token` VALUES ('dc447e2547f24ba1b4e9914de095a7ff', 27, 2, 1, '2019-08-09 03:31:35', '2019-08-08 15:31:35', '2019-08-08 15:31:35');
INSERT INTO `oauth2_refresh_token` VALUES ('dca5b3127a8d441a83c55eccaaa21764', 27, 2, 1, '2019-08-19 21:05:12', '2019-08-19 09:05:12', '2019-08-19 09:05:12');
INSERT INTO `oauth2_refresh_token` VALUES ('dcb2f39d2ef841a5bec6f317c6e75e6b', 27, 2, 1, '2019-05-24 01:32:18', '2019-05-23 13:32:18', '2019-05-23 13:32:18');
INSERT INTO `oauth2_refresh_token` VALUES ('dcbb9dce4cb44ccbb4e5fcdf43455663', NULL, NULL, 1, '2019-04-26 04:53:54', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('dcbc0938b2d947c8880365e6e5a17190', NULL, NULL, 1, '2019-04-05 06:58:51', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('dcbd8f0cebb84c2c99aefb6e9aa3c3dc', NULL, NULL, 1, '2019-04-23 06:20:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('dcc2b80166b14c7f927e685fd15e9935', 27, 2, 1, '2019-09-05 23:31:06', '2019-09-05 11:31:06', '2019-09-05 11:31:06');
INSERT INTO `oauth2_refresh_token` VALUES ('dcc6c6a1a2d9492789de045761e80033', 27, 2, 1, '2019-06-13 05:18:32', '2019-06-12 17:18:32', '2019-06-12 17:18:32');
INSERT INTO `oauth2_refresh_token` VALUES ('dcce34653b7d46f8af95e00f060278e1', 27, 2, 1, '2019-08-17 04:25:35', '2019-08-16 16:25:34', '2019-08-16 16:25:34');
INSERT INTO `oauth2_refresh_token` VALUES ('dcee020127b74f14b829370ee16be15c', NULL, NULL, 1, '2019-04-23 07:42:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('dcf35e0af46a47a493846baad97a3bf9', 222, 1, 1, '2019-09-06 03:13:54', '2019-09-05 15:13:53', '2019-09-05 15:13:53');
INSERT INTO `oauth2_refresh_token` VALUES ('dcf76927270f4bb2bc5cafc67eaa30d1', 27, 2, 1, '2019-07-17 03:22:06', '2019-07-16 15:22:06', '2019-07-16 15:22:06');
INSERT INTO `oauth2_refresh_token` VALUES ('dd0b3658a8c344038314bd89e850b85c', NULL, NULL, 1, '2019-05-10 03:39:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('dd189db271e140eeb427794d0e45b90e', 27, 2, 1, '2019-09-04 05:54:25', '2019-09-03 17:54:24', '2019-09-03 17:54:24');
INSERT INTO `oauth2_refresh_token` VALUES ('dd1bfa3ee9474eff80ded9f94208d7ac', NULL, NULL, 1, '2019-04-28 10:05:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('dd1cfefe1d7b41a495c8b91c0204483d', 27, 2, 1, '2019-06-26 08:23:01', '2019-06-25 20:23:01', '2019-06-25 20:23:01');
INSERT INTO `oauth2_refresh_token` VALUES ('dd20fe554b45435098b495f34a985452', 27, 2, 1, '2019-08-03 12:02:30', '2019-08-03 00:02:29', '2019-08-03 00:02:29');
INSERT INTO `oauth2_refresh_token` VALUES ('dd2543c2b7144b5d8935cc072581cc73', 27, 2, 1, '2019-06-01 11:48:51', '2019-05-31 23:48:50', '2019-05-31 23:48:50');
INSERT INTO `oauth2_refresh_token` VALUES ('dd2cd79360e84957959d12ffd1265f44', 27, 2, 1, '2019-06-25 04:30:26', '2019-06-24 16:30:26', '2019-06-24 16:30:26');
INSERT INTO `oauth2_refresh_token` VALUES ('dd34d3ba368d475d9bd5848df78da3d1', 1, 2, 0, '2019-08-21 11:01:02', '2019-08-20 23:01:01', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('dd43f285813a492fb1566e66164e4944', 27, 2, 1, '2019-08-30 04:03:57', '2019-08-29 16:03:56', '2019-08-29 16:03:56');
INSERT INTO `oauth2_refresh_token` VALUES ('dd548b8fd6ec4d378b254c5aa75960f0', 27, 2, 1, '2019-06-26 02:20:32', '2019-06-25 14:20:31', '2019-06-25 14:20:31');
INSERT INTO `oauth2_refresh_token` VALUES ('dd5e8e5e6f884a41b1c53d901d12e868', 27, 2, 1, '2019-08-07 02:40:09', '2019-08-06 14:40:08', '2019-08-06 14:40:08');
INSERT INTO `oauth2_refresh_token` VALUES ('dd60a55fe0b24f87b0e37bd8459ed0e1', 27, 2, 1, '2019-06-13 07:36:22', '2019-06-12 19:36:22', '2019-06-12 19:36:22');
INSERT INTO `oauth2_refresh_token` VALUES ('dd65bbdf13f44e3080fbaefc9483aafd', 27, 2, 1, '2019-05-29 02:29:16', '2019-05-28 14:29:16', '2019-05-28 14:29:16');
INSERT INTO `oauth2_refresh_token` VALUES ('dd6771b1e0a94a52853f752817527b05', 27, 2, 1, '2019-06-03 05:14:01', '2019-06-02 17:14:01', '2019-06-02 17:14:01');
INSERT INTO `oauth2_refresh_token` VALUES ('dd8be0ecd46640cbb8d3c29d82d49a4b', 27, 2, 1, '2019-08-21 23:52:07', '2019-08-21 11:52:06', '2019-08-21 11:52:06');
INSERT INTO `oauth2_refresh_token` VALUES ('dda5cd98d94a433aad326c37d306858e', 27, 2, 1, '2019-06-20 09:53:58', '2019-06-19 21:53:58', '2019-06-19 21:53:58');
INSERT INTO `oauth2_refresh_token` VALUES ('ddde5ca61fb9410fbe3334bb67434590', 27, 2, 1, '2019-06-29 05:19:48', '2019-06-28 17:19:47', '2019-06-28 17:19:47');
INSERT INTO `oauth2_refresh_token` VALUES ('dde27407c041409c96d80ff0a76c94ff', NULL, NULL, 1, '2019-05-01 23:52:47', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ddeebe7a27b9474abf1d564b01a974ad', 27, 2, 1, '2019-06-06 03:35:38', '2019-06-05 15:35:38', '2019-06-05 15:35:38');
INSERT INTO `oauth2_refresh_token` VALUES ('ddef14f296c04a009a0012f38070d461', 27, 2, 1, '2019-08-23 10:55:21', '2019-08-22 22:55:20', '2019-08-22 22:55:20');
INSERT INTO `oauth2_refresh_token` VALUES ('ddf001ac682848288a685a990e4d24de', 27, 2, 1, '2019-06-17 21:36:09', '2019-06-17 09:36:08', '2019-06-17 09:36:08');
INSERT INTO `oauth2_refresh_token` VALUES ('ddf176f572ad4769a67f77b8da40d204', 27, 2, 1, '2019-07-09 02:39:36', '2019-07-08 14:39:36', '2019-07-08 14:39:36');
INSERT INTO `oauth2_refresh_token` VALUES ('ddf218fd31d546469f7668c6ac9774b0', 92, 1, 1, '2019-05-31 05:51:15', '2019-05-30 17:51:15', '2019-05-30 17:51:15');
INSERT INTO `oauth2_refresh_token` VALUES ('de02702c988a452ba4e84f2b077d7507', 27, 2, 1, '2019-06-26 23:16:11', '2019-06-26 11:16:11', '2019-06-26 11:16:11');
INSERT INTO `oauth2_refresh_token` VALUES ('de03f4e50cd44260bfc88b3580ac3b0c', 1, 2, 0, '2019-08-29 03:54:36', '2019-08-28 15:54:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('de3810037b4c4af09df7e27218c667c2', 27, 2, 1, '2019-08-14 20:38:05', '2019-08-14 08:38:05', '2019-08-14 08:38:05');
INSERT INTO `oauth2_refresh_token` VALUES ('de388e2cd14341c88abab5e106bb160b', 27, 2, 1, '2019-06-03 21:15:56', '2019-06-03 09:15:56', '2019-06-03 09:15:56');
INSERT INTO `oauth2_refresh_token` VALUES ('de5658ad3f4340f69107d203ede451df', 27, 2, 1, '2019-05-23 23:23:59', '2019-05-23 11:23:59', '2019-05-23 11:23:59');
INSERT INTO `oauth2_refresh_token` VALUES ('de63474945d041148c6c100cad67341f', NULL, NULL, 1, '2019-04-29 02:04:32', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('de66a83c542d48e0aa7ea3b2e226c760', 27, 2, 1, '2019-06-14 01:39:27', '2019-06-13 13:39:27', '2019-06-13 13:39:27');
INSERT INTO `oauth2_refresh_token` VALUES ('de71ff388eb74744bbb2bdca2636286e', 27, 2, 1, '2019-06-01 21:19:14', '2019-06-01 09:19:14', '2019-06-01 09:19:14');
INSERT INTO `oauth2_refresh_token` VALUES ('de7910a0383540bb9c5cda3774b63920', 27, 2, 1, '2019-06-29 04:41:39', '2019-06-28 16:41:39', '2019-06-28 16:41:39');
INSERT INTO `oauth2_refresh_token` VALUES ('de84ec58a4ff4e68baf9bb9da2fe26bc', NULL, NULL, 1, '2019-05-01 10:05:25', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('de85d6be7dba4516b7b357f60be98715', 1, 2, 0, '2019-05-18 06:25:27', '2019-05-17 18:25:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('dee3257860e744bbb03b493f24eba9aa', 27, 2, 1, '2019-08-23 22:23:33', '2019-08-23 10:23:33', '2019-08-23 10:23:33');
INSERT INTO `oauth2_refresh_token` VALUES ('def4d7d5eaf248ffb9bde3d73e3a9e36', NULL, NULL, 0, '2019-03-04 10:08:02', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('df0098a2ebb64b1a826763a0779bd15a', 27, 2, 1, '2019-06-24 01:15:59', '2019-06-23 13:15:58', '2019-06-23 13:15:58');
INSERT INTO `oauth2_refresh_token` VALUES ('df15e8ec8f3f4e4b86da9df4580ee250', 27, 2, 1, '2019-07-11 23:14:28', '2019-07-11 11:14:28', '2019-07-11 11:14:28');
INSERT INTO `oauth2_refresh_token` VALUES ('df1ae02fae5e41c880d33dea9c0591f6', NULL, NULL, 1, '2019-04-27 22:50:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('df46991063c344d8b3657c30dee83e8f', 27, 2, 1, '2019-06-05 02:18:34', '2019-06-04 14:18:33', '2019-06-04 14:18:33');
INSERT INTO `oauth2_refresh_token` VALUES ('df5198fd9c314aba84a3147b33548ffa', 27, 2, 1, '2019-05-26 02:34:08', '2019-05-25 14:34:08', '2019-05-25 14:34:08');
INSERT INTO `oauth2_refresh_token` VALUES ('df525a81d4ba46fd92ea5624f4c8bfc2', 27, 2, 1, '2019-08-23 04:46:49', '2019-08-22 16:46:49', '2019-08-22 16:46:49');
INSERT INTO `oauth2_refresh_token` VALUES ('df5895cef8364fb894513dabde041983', 27, 2, 1, '2019-07-17 22:05:04', '2019-07-17 10:05:04', '2019-07-17 10:05:04');
INSERT INTO `oauth2_refresh_token` VALUES ('df688f0f134947e7aae103ae29885969', 27, 2, 1, '2019-06-02 00:52:12', '2019-06-01 12:52:11', '2019-06-01 12:52:11');
INSERT INTO `oauth2_refresh_token` VALUES ('df7422ce577340378136d8ae5f4cc06c', 27, 2, 1, '2019-06-07 03:57:04', '2019-06-06 15:57:04', '2019-06-06 15:57:04');
INSERT INTO `oauth2_refresh_token` VALUES ('df9ff267a0d442a7b7bb676fa31f6cbf', 27, 2, 1, '2019-06-15 01:03:14', '2019-06-14 13:03:13', '2019-06-14 13:03:13');
INSERT INTO `oauth2_refresh_token` VALUES ('dfa007533aaf4ec989ff59a38fd97b74', 27, 2, 1, '2019-08-16 04:29:36', '2019-08-15 16:29:36', '2019-08-15 16:29:36');
INSERT INTO `oauth2_refresh_token` VALUES ('dfa1b2b4be084977849251eb7aaff4bb', 27, 2, 1, '2019-08-17 04:36:09', '2019-08-16 16:36:08', '2019-08-16 16:36:08');
INSERT INTO `oauth2_refresh_token` VALUES ('dfa1f7ab800d45dc997623ffad6064eb', 27, 2, 1, '2019-08-05 21:48:02', '2019-08-05 09:48:02', '2019-08-05 09:48:02');
INSERT INTO `oauth2_refresh_token` VALUES ('dfa952ca4ea04aa6a38a470e3cdf5cbc', 27, 2, 1, '2019-06-22 03:28:03', '2019-06-21 15:28:02', '2019-06-21 15:28:02');
INSERT INTO `oauth2_refresh_token` VALUES ('dfad2db87488411493e7bf11af98af44', 27, 2, 1, '2019-06-06 23:44:26', '2019-06-06 11:44:26', '2019-06-06 11:44:26');
INSERT INTO `oauth2_refresh_token` VALUES ('dfb159480bf64471af6193c2f8e6be6b', 27, 2, 1, '2019-07-19 04:55:56', '2019-07-18 16:55:55', '2019-07-18 16:55:55');
INSERT INTO `oauth2_refresh_token` VALUES ('dfb78452628a4884b8e19d5fb3881e80', NULL, NULL, 1, '2019-03-22 07:51:25', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('dfb7ce63914d456d8b0aee1ff0c96560', 92, 1, 1, '2019-05-31 05:49:37', '2019-05-30 17:49:37', '2019-05-30 17:49:37');
INSERT INTO `oauth2_refresh_token` VALUES ('dfc4e713e7b44918a8ce506286b7621d', 1, 2, 0, '2019-08-22 06:01:52', '2019-08-21 18:01:51', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('dfc5438af81642cb939051404fd71d8f', NULL, NULL, 1, '2019-03-13 11:05:03', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('dfc995299cf84ec6a1b0d75b3cca3713', 27, 2, 1, '2019-06-21 08:26:12', '2019-06-20 20:26:12', '2019-06-20 20:26:12');
INSERT INTO `oauth2_refresh_token` VALUES ('dfd1734edf264f568e69fc273f67fdb5', 27, 2, 1, '2019-08-06 08:19:58', '2019-08-05 20:19:58', '2019-08-05 20:19:58');
INSERT INTO `oauth2_refresh_token` VALUES ('dfd3e891bf2343bbbaf5dc035f0736cd', 27, 2, 1, '2019-06-05 05:09:12', '2019-06-04 17:09:11', '2019-06-04 17:09:11');
INSERT INTO `oauth2_refresh_token` VALUES ('dfe4256855a048fa948059dd404efda1', 27, 2, 1, '2019-06-30 22:17:38', '2019-06-30 10:17:38', '2019-06-30 10:17:38');
INSERT INTO `oauth2_refresh_token` VALUES ('dfe60e5efb174f68bf45154c6266f9f3', 27, 2, 1, '2019-06-04 02:42:03', '2019-06-03 14:42:02', '2019-06-03 14:42:02');
INSERT INTO `oauth2_refresh_token` VALUES ('dffb0566dd6a4b29afcce05c04148acd', 27, 2, 1, '2019-08-10 04:48:17', '2019-08-09 16:48:17', '2019-08-09 16:48:17');
INSERT INTO `oauth2_refresh_token` VALUES ('e002ff1dd2b845678eb4bbad0ea2648f', 27, 2, 1, '2019-07-13 09:10:13', '2019-07-12 21:10:12', '2019-07-12 21:10:12');
INSERT INTO `oauth2_refresh_token` VALUES ('e027ad2c7a0c4dd09419cea24d2b1d60', 1, 2, 0, '2019-06-20 21:08:13', '2019-06-20 09:08:12', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e0505ca71799468697300ce068988ebe', 27, 2, 1, '2019-07-16 23:48:04', '2019-07-16 11:48:04', '2019-07-16 11:48:04');
INSERT INTO `oauth2_refresh_token` VALUES ('e068ea9c3ab2472c8d7a96e939aa9e3a', 27, 2, 1, '2019-07-12 04:41:46', '2019-07-11 16:41:46', '2019-07-11 16:41:46');
INSERT INTO `oauth2_refresh_token` VALUES ('e074968c33bd4317bf64be8e62e089e6', 1, 2, 0, '2019-07-10 02:12:32', '2019-07-09 14:12:31', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e07ad3e7a6434678a329bd14ea0addcf', 27, 2, 1, '2019-09-03 03:08:10', '2019-09-02 15:08:10', '2019-09-02 15:08:10');
INSERT INTO `oauth2_refresh_token` VALUES ('e07bfa1a8f6c4baa8d700529fd0462db', 27, 2, 1, '2019-07-16 06:28:34', '2019-07-15 18:28:34', '2019-07-15 18:28:34');
INSERT INTO `oauth2_refresh_token` VALUES ('e097c9a1dc784169b0fb8120043995ce', 27, 2, 1, '2019-06-20 02:22:35', '2019-06-19 14:22:34', '2019-06-19 14:22:34');
INSERT INTO `oauth2_refresh_token` VALUES ('e0a18604955f48b3b19dae73f1c76e17', NULL, NULL, 1, '2019-03-13 12:01:56', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e0b123b7314b41ab94e4d5ecdf4b1808', 27, 2, 1, '2019-09-03 01:03:28', '2019-09-02 13:03:27', '2019-09-02 13:03:27');
INSERT INTO `oauth2_refresh_token` VALUES ('e0be3e2ebd3e4f2bb47cf6aca4dac92b', 27, 2, 1, '2019-06-01 23:30:57', '2019-06-01 11:30:57', '2019-06-01 11:30:57');
INSERT INTO `oauth2_refresh_token` VALUES ('e0bfd9238f68489fb67fcb156e3d4b53', 27, 2, 1, '2019-06-03 01:33:00', '2019-06-02 13:33:00', '2019-06-02 13:33:00');
INSERT INTO `oauth2_refresh_token` VALUES ('e0cb1545043c43eaaff7d2c3e53508f7', 27, 2, 1, '2019-07-17 07:59:35', '2019-07-16 19:59:35', '2019-07-16 19:59:35');
INSERT INTO `oauth2_refresh_token` VALUES ('e0d53b2d49cd4d7788fbb026c6605565', 27, 2, 1, '2019-07-11 21:25:39', '2019-07-11 09:25:39', '2019-07-11 09:25:39');
INSERT INTO `oauth2_refresh_token` VALUES ('e0e9ac348dc7452aa3a72e23e9c3649e', NULL, NULL, 1, '2019-03-10 15:36:21', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e121a9e2aa134b06b98eb4f8beaf61be', 27, 2, 1, '2019-07-26 12:27:24', '2019-07-26 00:27:23', '2019-07-26 00:27:23');
INSERT INTO `oauth2_refresh_token` VALUES ('e12e31f2ebbe4d2e828d064db8dfe2b8', 27, 2, 1, '2019-06-22 02:10:34', '2019-06-21 14:10:34', '2019-06-21 14:10:34');
INSERT INTO `oauth2_refresh_token` VALUES ('e135c24d9f02452aabc35c63df6f4708', 27, 2, 1, '2019-06-05 23:28:26', '2019-06-05 11:28:26', '2019-06-05 11:28:26');
INSERT INTO `oauth2_refresh_token` VALUES ('e14476177bab41418fe45259ffccb704', 27, 2, 1, '2019-08-12 11:07:32', '2019-08-11 23:07:32', '2019-08-11 23:07:32');
INSERT INTO `oauth2_refresh_token` VALUES ('e14adc26dff2460dbbe2b12b7064f7f9', 27, 2, 1, '2019-07-28 04:00:28', '2019-07-27 16:00:28', '2019-07-27 16:00:28');
INSERT INTO `oauth2_refresh_token` VALUES ('e15c97c6c0ce4a1ebd852785a44aaa71', 27, 2, 1, '2019-06-25 04:25:28', '2019-06-24 16:25:28', '2019-06-24 16:25:28');
INSERT INTO `oauth2_refresh_token` VALUES ('e17fc1b248b84a268fd969cda06307c9', 1, 2, 0, '2019-08-26 22:20:38', '2019-08-26 10:20:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e18075511a4344a7a4593779c4f47f75', 27, 2, 1, '2019-06-30 03:38:41', '2019-06-29 15:38:41', '2019-06-29 15:38:41');
INSERT INTO `oauth2_refresh_token` VALUES ('e18173bd6d9c4f6ba12da47fab688d01', 213, 1, 1, '2019-08-28 03:07:39', '2019-08-27 15:07:39', '2019-08-27 15:07:39');
INSERT INTO `oauth2_refresh_token` VALUES ('e1bf1e58de6445d28f8f9e138a7f79a1', 27, 2, 1, '2019-07-05 05:29:40', '2019-07-04 17:29:39', '2019-07-04 17:29:39');
INSERT INTO `oauth2_refresh_token` VALUES ('e1c9445b3f524726b87517e177f96b7c', NULL, NULL, 1, '2019-05-08 05:13:25', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e1cafec549964231a59c307ab76457b3', 1, 2, 0, '2019-07-08 08:46:33', '2019-07-07 20:46:32', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e206e456450b4cb2a05dcabbd050e4ac', 27, 2, 1, '2019-06-04 03:54:08', '2019-06-03 15:54:08', '2019-06-03 15:54:08');
INSERT INTO `oauth2_refresh_token` VALUES ('e2082ae86e6f4e53821c2322cd7656d7', 27, 2, 1, '2019-06-03 10:49:32', '2019-06-02 22:49:32', '2019-06-02 22:49:32');
INSERT INTO `oauth2_refresh_token` VALUES ('e20a21dde01a441db1990f5791bbd790', 27, 2, 1, '2019-07-14 03:37:55', '2019-07-13 15:37:54', '2019-07-13 15:37:54');
INSERT INTO `oauth2_refresh_token` VALUES ('e20e85c7c9e742ad95c9572e1abc6444', 27, 2, 1, '2019-06-20 22:19:38', '2019-06-20 10:19:37', '2019-06-20 10:19:37');
INSERT INTO `oauth2_refresh_token` VALUES ('e21000adbe9744578c126490b8f0db14', 27, 2, 1, '2019-09-05 05:04:24', '2019-09-04 17:04:24', '2019-09-04 17:04:24');
INSERT INTO `oauth2_refresh_token` VALUES ('e21770e5b69b41dcb4a44c81995c719c', NULL, NULL, 1, '2019-05-08 23:08:19', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e21beefb0ce9486199258c1c742bd0bb', 27, 2, 1, '2019-06-11 23:19:12', '2019-06-11 11:19:11', '2019-06-11 11:19:11');
INSERT INTO `oauth2_refresh_token` VALUES ('e236907aff584598af69c12d4fbb2e18', NULL, NULL, 1, '2019-04-24 22:46:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e237ea58cf594547a1e0731cf843b453', 27, 2, 1, '2019-05-24 02:27:03', '2019-05-23 14:27:03', '2019-05-23 14:27:03');
INSERT INTO `oauth2_refresh_token` VALUES ('e253de09c4924603bda20c43270c3971', 27, 2, 1, '2019-05-19 06:40:55', '2019-05-18 18:40:54', '2019-05-18 18:40:54');
INSERT INTO `oauth2_refresh_token` VALUES ('e265348f53fc4b14b95e7cce66f1a467', 27, 2, 1, '2019-06-24 00:08:16', '2019-06-23 12:08:15', '2019-06-23 12:08:15');
INSERT INTO `oauth2_refresh_token` VALUES ('e26bae8001a740e1837b3f5b908975a7', 27, 2, 1, '2019-06-07 04:08:25', '2019-06-06 16:08:24', '2019-06-06 16:08:24');
INSERT INTO `oauth2_refresh_token` VALUES ('e26cf75082f44fa9bb9a7b1c720efa93', 207, 1, 1, '2019-08-21 00:53:59', '2019-08-20 12:53:58', '2019-08-20 12:53:58');
INSERT INTO `oauth2_refresh_token` VALUES ('e27a22a43b1b416083b6903910bf5cfd', 27, 2, 1, '2019-08-21 22:46:31', '2019-08-21 10:46:31', '2019-08-21 10:46:31');
INSERT INTO `oauth2_refresh_token` VALUES ('e27a86ea5923405784f5b9abfddcbd0c', 1, 2, 0, '2019-08-13 06:11:42', '2019-08-12 18:11:42', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e28625b65bad4860b5c29f4b883503de', 1, 2, 0, '2019-07-08 08:58:33', '2019-07-07 20:58:32', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e2a76723fdf243c6af29ad263475abbc', 27, 2, 1, '2019-05-27 21:59:23', '2019-05-27 09:59:23', '2019-05-27 09:59:23');
INSERT INTO `oauth2_refresh_token` VALUES ('e2b173e1cd2a4579b0f8f12dcb3c8eaa', 133, 1, 1, '2019-06-22 03:39:05', '2019-06-21 15:39:04', '2019-06-21 15:39:04');
INSERT INTO `oauth2_refresh_token` VALUES ('e2b463db16204df694c55c6188050866', 1, 2, 0, '2019-06-01 11:15:44', '2019-05-31 23:15:44', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e2b5562f5358429ca9a7ea7b43e2eaac', NULL, NULL, 1, '2019-03-12 10:43:53', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e2f1fcffa7c1425bb84e156d2af89e20', 27, 2, 1, '2019-06-15 03:08:43', '2019-06-14 15:08:42', '2019-06-14 15:08:42');
INSERT INTO `oauth2_refresh_token` VALUES ('e2f5ab206ec74eda8b00fa43d9bdc7a8', 27, 2, 1, '2019-09-02 03:55:39', '2019-09-01 15:55:38', '2019-09-01 15:55:38');
INSERT INTO `oauth2_refresh_token` VALUES ('e3247029fc1342e8ac1c276139413eeb', 27, 2, 1, '2019-06-01 06:56:18', '2019-05-31 18:56:18', '2019-05-31 18:56:18');
INSERT INTO `oauth2_refresh_token` VALUES ('e34c8fa9a9f64918add95e6c7c79a581', 27, 2, 1, '2019-08-04 07:54:52', '2019-08-03 19:54:52', '2019-08-03 19:54:52');
INSERT INTO `oauth2_refresh_token` VALUES ('e350712bb59947729d210a964396b06c', 27, 2, 1, '2019-06-13 04:02:21', '2019-06-12 16:02:21', '2019-06-12 16:02:21');
INSERT INTO `oauth2_refresh_token` VALUES ('e35145770f054a20856a44ad3bced84f', 1, 2, 0, '2019-05-27 06:07:37', '2019-05-26 18:07:36', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e352404f0841420daa654e9925899a42', NULL, NULL, 1, '2019-04-06 13:07:01', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e357353e345a47f8b68c43b2738fae32', 27, 2, 1, '2019-08-18 01:34:07', '2019-08-17 13:34:06', '2019-08-17 13:34:06');
INSERT INTO `oauth2_refresh_token` VALUES ('e36c76db9a394e5bb9058b88b87ea291', 27, 2, 1, '2019-06-21 01:58:29', '2019-06-20 13:58:28', '2019-06-20 13:58:28');
INSERT INTO `oauth2_refresh_token` VALUES ('e390d3f818a54fb8adc31ea6be58c9bc', 27, 2, 1, '2019-07-12 23:49:48', '2019-07-12 11:49:47', '2019-07-12 11:49:47');
INSERT INTO `oauth2_refresh_token` VALUES ('e3925328393a40518e42864b2924d071', 27, 2, 1, '2019-07-28 06:19:46', '2019-07-27 18:19:45', '2019-07-27 18:19:45');
INSERT INTO `oauth2_refresh_token` VALUES ('e39286d2b753480899f3eef77d1b6a5b', 27, 2, 1, '2019-06-23 15:00:33', '2019-06-23 03:00:32', '2019-06-23 03:00:32');
INSERT INTO `oauth2_refresh_token` VALUES ('e3951384a2734ca9bffb9d2ebddfb138', 27, 2, 1, '2019-06-05 22:24:44', '2019-06-05 10:24:44', '2019-06-05 10:24:44');
INSERT INTO `oauth2_refresh_token` VALUES ('e3a0064a8fd44d69b2552806a2890f22', 1, 2, 0, '2019-06-15 01:46:58', '2019-06-14 13:46:57', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e3bf34f3961947a184e87b8f84ede03b', 27, 2, 1, '2019-07-23 21:34:05', '2019-07-23 09:34:04', '2019-07-23 09:34:04');
INSERT INTO `oauth2_refresh_token` VALUES ('e3c0a25560eb47eeac517a8e8659fb90', 27, 2, 1, '2019-07-17 21:22:01', '2019-07-17 09:22:00', '2019-07-17 09:22:00');
INSERT INTO `oauth2_refresh_token` VALUES ('e3c48034933a42348875c24ba3aa6fd5', 27, 2, 1, '2019-08-10 04:48:44', '2019-08-09 16:48:43', '2019-08-09 16:48:43');
INSERT INTO `oauth2_refresh_token` VALUES ('e3dbd506dad44a599bec494543e6f27b', 27, 2, 1, '2019-07-03 04:35:54', '2019-07-02 16:35:54', '2019-07-02 16:35:54');
INSERT INTO `oauth2_refresh_token` VALUES ('e42c2eff49f9447b8d84e349abecd197', 27, 2, 1, '2019-06-04 20:29:59', '2019-06-04 08:29:59', '2019-06-04 08:29:59');
INSERT INTO `oauth2_refresh_token` VALUES ('e442c83bc5884c2180ef1b95bb1a804a', 27, 2, 1, '2019-06-20 22:02:45', '2019-06-20 10:02:45', '2019-06-20 10:02:45');
INSERT INTO `oauth2_refresh_token` VALUES ('e446ae70a14e4003b2c5878b641abf0c', 27, 2, 1, '2019-06-30 03:17:41', '2019-06-29 15:17:40', '2019-06-29 15:17:40');
INSERT INTO `oauth2_refresh_token` VALUES ('e4686a4bbef0489f9515d0fa2f456477', 27, 2, 1, '2019-07-13 22:51:04', '2019-07-13 10:51:04', '2019-07-13 10:51:04');
INSERT INTO `oauth2_refresh_token` VALUES ('e47c3afce2924163bf2923046f40665c', 27, 2, 1, '2019-09-09 10:46:25', '2019-09-08 22:46:24', '2019-09-08 22:46:24');
INSERT INTO `oauth2_refresh_token` VALUES ('e498d81538884700a2fc67df8042ff5a', 1, 2, 0, '2019-06-12 03:02:15', '2019-06-11 15:02:15', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e4a0b9bb25cc484199f8eacf0989c38d', 27, 2, 1, '2019-07-12 11:47:15', '2019-07-11 23:47:14', '2019-07-11 23:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e4a289fd13204b368cb83dc84f931c21', 1, 2, 0, '2019-07-30 23:51:31', '2019-07-30 11:51:30', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e4a696a03eea4745aa349982feb7f3dd', NULL, NULL, 1, '2019-05-09 12:11:47', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e4c41c51dfa344e7864364664b635895', 27, 2, 1, '2019-09-04 07:26:01', '2019-09-03 19:26:01', '2019-09-03 19:26:01');
INSERT INTO `oauth2_refresh_token` VALUES ('e4e1bf4e19234704a60a6695fc8bc44c', 27, 2, 1, '2019-06-13 21:50:26', '2019-06-13 09:50:26', '2019-06-13 09:50:26');
INSERT INTO `oauth2_refresh_token` VALUES ('e4e7ba106e9e4ceda9f51a9a1bc9c215', 27, 2, 1, '2019-06-26 05:28:33', '2019-06-25 17:28:32', '2019-06-25 17:28:32');
INSERT INTO `oauth2_refresh_token` VALUES ('e50bf80533104b829d6b67c198eaadd1', 27, 2, 1, '2019-06-02 03:33:54', '2019-06-01 15:33:54', '2019-06-01 15:33:54');
INSERT INTO `oauth2_refresh_token` VALUES ('e50e56ce40fa4abeb9131bf50a9e15de', 27, 2, 1, '2019-06-01 04:53:27', '2019-05-31 16:53:27', '2019-05-31 16:53:27');
INSERT INTO `oauth2_refresh_token` VALUES ('e5185ba3de1d4bba82986a7776c1b8f3', NULL, NULL, 1, '2019-05-10 10:30:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e524c7ea86e7494784884f611bcb8163', 27, 2, 1, '2019-07-09 04:35:14', '2019-07-08 16:35:14', '2019-07-08 16:35:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e52e074a8f904ddd8a590e00291956b3', 27, 2, 1, '2019-08-25 07:20:39', '2019-08-24 19:20:38', '2019-08-24 19:20:38');
INSERT INTO `oauth2_refresh_token` VALUES ('e550c5d5af134ae68fb0812554ff6b60', 27, 2, 1, '2019-08-07 08:41:33', '2019-08-06 20:41:32', '2019-08-06 20:41:32');
INSERT INTO `oauth2_refresh_token` VALUES ('e55811f00b264dfc8e9cef76f54a73ed', 27, 2, 1, '2019-09-07 03:33:45', '2019-09-06 15:33:45', '2019-09-06 15:33:45');
INSERT INTO `oauth2_refresh_token` VALUES ('e559e2a33003400caa1d33097639b79c', 27, 2, 1, '2019-06-14 03:00:39', '2019-06-13 15:00:38', '2019-06-13 15:00:38');
INSERT INTO `oauth2_refresh_token` VALUES ('e566831f9111433a99c9db5b2da54ec0', 27, 2, 1, '2019-06-26 05:05:12', '2019-06-25 17:05:11', '2019-06-25 17:05:11');
INSERT INTO `oauth2_refresh_token` VALUES ('e57f0408d82a47a0bce0a216501523b4', 27, 2, 1, '2019-07-30 23:16:53', '2019-07-30 11:16:52', '2019-07-30 11:16:52');
INSERT INTO `oauth2_refresh_token` VALUES ('e59e2372c8b640c8821d79c997f9a926', 27, 2, 1, '2019-07-05 23:03:30', '2019-07-05 11:03:30', '2019-07-05 11:03:30');
INSERT INTO `oauth2_refresh_token` VALUES ('e5bd07d32bee4fe3b48f29c8181b3114', NULL, NULL, 1, '2019-05-07 05:29:58', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e5befd8d7e3b467e99c0b6e7911ddc60', 27, 2, 1, '2019-08-12 21:12:03', '2019-08-12 09:12:03', '2019-08-12 09:12:03');
INSERT INTO `oauth2_refresh_token` VALUES ('e5dab18a376a4f6b95d3ea6f534156b5', 27, 2, 1, '2019-05-29 08:27:21', '2019-05-28 20:27:21', '2019-05-28 20:27:21');
INSERT INTO `oauth2_refresh_token` VALUES ('e5f4fed25bb54dca89651f0c8dece98f', 27, 2, 1, '2019-07-19 03:37:09', '2019-07-18 15:37:09', '2019-07-18 15:37:09');
INSERT INTO `oauth2_refresh_token` VALUES ('e5fec995be0a47919a396bd8092bd35d', 152, 1, 1, '2019-07-03 01:27:55', '2019-07-02 13:27:55', '2019-07-02 13:27:55');
INSERT INTO `oauth2_refresh_token` VALUES ('e6007c15afb048ad851806f355928377', NULL, NULL, 1, '2019-03-08 23:46:16', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e604538d753c4b7eb2d8f7b681773e5a', 27, 2, 1, '2019-06-20 03:06:40', '2019-06-19 15:06:39', '2019-06-19 15:06:39');
INSERT INTO `oauth2_refresh_token` VALUES ('e606cea5bedd4da19f098ad015d28f28', NULL, NULL, 1, '2019-04-10 05:53:00', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e61188ffe9014e7e9b33c89262047367', 27, 2, 1, '2019-06-04 05:39:31', '2019-06-03 17:39:30', '2019-06-03 17:39:30');
INSERT INTO `oauth2_refresh_token` VALUES ('e611df2f4cbd4045acdbaba33489e3af', 1, 2, 0, '2019-06-05 22:55:12', '2019-06-05 10:55:11', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e62856f10bec4a8ebaf70c0b7502742d', NULL, NULL, 1, '2019-04-23 06:44:12', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e6334cd6e31f4029b5c1a8a4417685c9', 180, 1, 1, '2019-07-24 02:42:38', '2019-07-23 14:42:38', '2019-07-23 14:42:38');
INSERT INTO `oauth2_refresh_token` VALUES ('e64cbe60f2f741b593c82074884e339a', NULL, NULL, 1, '2019-04-24 19:25:03', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e64fccc6aa5147f28d8ec4d2629c3da3', 27, 2, 1, '2019-06-05 03:25:19', '2019-06-04 15:25:19', '2019-06-04 15:25:19');
INSERT INTO `oauth2_refresh_token` VALUES ('e65d3fa5413c47c99c80fb9dc042401a', 27, 2, 1, '2019-06-11 09:08:33', '2019-06-10 21:08:32', '2019-06-10 21:08:32');
INSERT INTO `oauth2_refresh_token` VALUES ('e6703048e4854ce086bb51931355c8db', 27, 2, 1, '2019-06-04 15:02:27', '2019-06-04 03:02:26', '2019-06-04 03:02:26');
INSERT INTO `oauth2_refresh_token` VALUES ('e676afbf65614eba8007e2a10b4d92f0', 27, 2, 1, '2019-07-04 14:24:23', '2019-07-04 02:24:23', '2019-07-04 02:24:23');
INSERT INTO `oauth2_refresh_token` VALUES ('e67d30094fb144baaffc3f7f67c8ea49', NULL, NULL, 1, '2019-04-23 06:27:01', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e67e8fdc60a24a32886b959c9167b2b3', NULL, NULL, 1, '2019-05-07 04:11:16', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e68d44e7518447219a1243fd1df8accf', 27, 2, 1, '2019-08-13 02:20:36', '2019-08-12 14:20:35', '2019-08-12 14:20:35');
INSERT INTO `oauth2_refresh_token` VALUES ('e6d50f801ea0434c8d46b3ef933ab788', 27, 2, 1, '2019-06-29 03:20:26', '2019-06-28 15:20:26', '2019-06-28 15:20:26');
INSERT INTO `oauth2_refresh_token` VALUES ('e6de8e53629448b4937f3a6b01c9fbab', 27, 2, 1, '2019-06-04 02:24:32', '2019-06-03 14:24:32', '2019-06-03 14:24:32');
INSERT INTO `oauth2_refresh_token` VALUES ('e702f60b2a224bdda86a6b5108c4cd09', 27, 2, 1, '2019-06-13 00:25:03', '2019-06-12 12:25:03', '2019-06-12 12:25:03');
INSERT INTO `oauth2_refresh_token` VALUES ('e7066152e2a54dd59b0183de7a5729bc', 27, 2, 1, '2019-08-19 02:01:21', '2019-08-18 14:01:21', '2019-08-18 14:01:21');
INSERT INTO `oauth2_refresh_token` VALUES ('e71f5763ec594adfa1a7fe5fd174d132', 1, 2, 0, '2019-08-22 06:01:50', '2019-08-21 18:01:50', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e7281c87a7324261afc8c4871b2463bc', 27, 2, 1, '2019-09-05 04:46:58', '2019-09-04 16:46:57', '2019-09-04 16:46:57');
INSERT INTO `oauth2_refresh_token` VALUES ('e7367714dbaa4ef7b94a9aea4eadc3e2', NULL, NULL, 1, '2019-04-23 06:25:54', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e73f5f3b28994172b7dc2157027d3695', 27, 2, 1, '2019-07-06 05:50:04', '2019-07-05 17:50:03', '2019-07-05 17:50:03');
INSERT INTO `oauth2_refresh_token` VALUES ('e740bff2a7c64f56b928ea43451a036d', 27, 2, 1, '2019-06-03 22:14:06', '2019-06-03 10:14:05', '2019-06-03 10:14:05');
INSERT INTO `oauth2_refresh_token` VALUES ('e750bad0c5c34e6eaf2522cfe167daf8', 27, 2, 1, '2019-05-24 01:37:45', '2019-05-23 13:37:44', '2019-05-23 13:37:44');
INSERT INTO `oauth2_refresh_token` VALUES ('e76c7d8874ec4122b02eb054d2caf842', 27, 2, 1, '2019-07-04 23:01:18', '2019-07-04 11:01:18', '2019-07-04 11:01:18');
INSERT INTO `oauth2_refresh_token` VALUES ('e77b039bf7bc4b359ce66cab97899c31', NULL, NULL, 1, '2019-04-04 07:02:50', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e7945ed2da264d25a863e41446997842', 1, 2, 0, '2019-08-14 19:54:58', '2019-08-14 07:54:58', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e7a36d1b722b4768986906b9d2c370bf', 27, 2, 1, '2019-07-21 12:18:57', '2019-07-21 00:18:57', '2019-07-21 00:18:57');
INSERT INTO `oauth2_refresh_token` VALUES ('e7ac8a480b7740809e36636c2f739668', 27, 2, 1, '2019-05-29 04:08:28', '2019-05-28 16:08:27', '2019-05-28 16:08:27');
INSERT INTO `oauth2_refresh_token` VALUES ('e7c225c3b427442889aae1d0abb6f697', 27, 2, 1, '2019-06-21 05:56:06', '2019-06-20 17:56:05', '2019-06-20 17:56:05');
INSERT INTO `oauth2_refresh_token` VALUES ('e7d44005f1c84bf6a3680590c76d8dc1', NULL, NULL, 1, '2019-05-07 01:06:35', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e7d4f66acee14d6790a6c3627e30a449', NULL, NULL, 1, '2019-04-05 06:03:08', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e7e199ae42ed4004815a48a5b53e0ffa', 1, 2, 0, '2019-07-02 23:18:48', '2019-07-02 11:18:47', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e7f46459eb0e4ae39e2037e018ca365d', 1, 2, 0, '2019-08-12 04:42:36', '2019-08-11 16:42:35', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e80085658a05441e9b8a67758234a4b3', 27, 2, 1, '2019-06-14 23:56:47', '2019-06-14 11:56:47', '2019-06-14 11:56:47');
INSERT INTO `oauth2_refresh_token` VALUES ('e81714ab6e434ed98b9d4ca80a2c4e8e', NULL, NULL, 1, '2019-05-08 21:39:30', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e83f993634b94194aa5a6b8050b57479', 27, 2, 1, '2019-06-06 21:39:53', '2019-06-06 09:39:53', '2019-06-06 09:39:53');
INSERT INTO `oauth2_refresh_token` VALUES ('e84a0af5a621492896e80f2dd2e6151b', 27, 2, 1, '2019-07-30 06:18:25', '2019-07-29 18:18:24', '2019-07-29 18:18:24');
INSERT INTO `oauth2_refresh_token` VALUES ('e84ce2a85c7b48a5a89563ad84c2f19d', 27, 2, 1, '2019-07-12 02:02:09', '2019-07-11 14:02:09', '2019-07-11 14:02:09');
INSERT INTO `oauth2_refresh_token` VALUES ('e8523a5e65d84c4a8327a82c25e76351', 1, 2, 0, '2019-06-30 09:09:24', '2019-06-29 21:09:24', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e853211bd41e488f9ea4efb808e56c79', NULL, NULL, 1, '2019-03-12 11:04:58', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e85ba9d03d694b0c8c0310ce466688f3', 27, 2, 1, '2019-06-01 04:17:28', '2019-05-31 16:17:28', '2019-05-31 16:17:28');
INSERT INTO `oauth2_refresh_token` VALUES ('e865eac54af94e3a82c8aae79200190c', NULL, NULL, 1, '2019-05-17 11:43:09', NULL, '2019-05-16 23:43:08');
INSERT INTO `oauth2_refresh_token` VALUES ('e87425dc5fe54111b4450a56ab1c9a63', NULL, NULL, 1, '2019-05-02 09:56:30', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e8928124979d4f29b8f77c1aa9571936', 27, 2, 1, '2019-06-21 13:59:04', '2019-06-21 01:59:03', '2019-06-21 01:59:03');
INSERT INTO `oauth2_refresh_token` VALUES ('e8a33935b6164e45bcd91dd97ae0246a', NULL, NULL, 1, '2019-05-06 20:55:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e8a86f019a9a484394fa0bb474b715ef', NULL, NULL, 1, '2019-05-07 03:04:38', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e8af3e4aea2c43338643e134e3e94651', NULL, NULL, 1, '2019-05-03 08:29:40', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e8b2612057b246a58a08335481f7c100', 27, 2, 1, '2019-07-11 21:24:37', '2019-07-11 09:24:36', '2019-07-11 09:24:36');
INSERT INTO `oauth2_refresh_token` VALUES ('e8c29d02fe944265bca1d76543844e83', 27, 2, 1, '2019-05-29 10:27:44', '2019-05-28 22:27:44', '2019-05-28 22:27:44');
INSERT INTO `oauth2_refresh_token` VALUES ('e8dc47f9baec4a2786efc6dcba62d47b', 27, 2, 1, '2019-06-05 00:38:56', '2019-06-04 12:38:55', '2019-06-04 12:38:55');
INSERT INTO `oauth2_refresh_token` VALUES ('e8f17f5b25d84dddba55e5cd53f70cef', NULL, NULL, 1, '2019-05-06 04:03:00', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e90bbc21de88486fb41989c132f26a89', NULL, NULL, 1, '2019-05-17 03:24:22', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e91489fc12604b62a6213824cfbadf8c', NULL, NULL, 1, '2019-05-10 05:35:05', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('e91e36216f3a4693a37e13e8a0e7559f', 1, 2, 0, '2019-06-21 22:49:37', '2019-06-21 10:49:37', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('e9319d2ed9394d66a84a86815244de53', 27, 2, 1, '2019-06-02 23:23:25', '2019-06-02 11:23:24', '2019-06-02 11:23:24');
INSERT INTO `oauth2_refresh_token` VALUES ('e95b8f882c38469589c7cfadfe75b5db', 27, 2, 1, '2019-06-30 12:44:18', '2019-06-30 00:44:18', '2019-06-30 00:44:18');
INSERT INTO `oauth2_refresh_token` VALUES ('e96243d4896f4397a520c9cf9f952955', 27, 2, 1, '2019-08-12 21:12:43', '2019-08-12 09:12:43', '2019-08-12 09:12:43');
INSERT INTO `oauth2_refresh_token` VALUES ('e99fbe3623f34fde9dc99d9ccbc034fc', 27, 2, 1, '2019-07-11 05:59:37', '2019-07-10 17:59:37', '2019-07-10 17:59:37');
INSERT INTO `oauth2_refresh_token` VALUES ('e9a7656bc2f341ccb5f8752c36167b7a', 27, 2, 1, '2019-06-24 02:28:04', '2019-06-23 14:28:03', '2019-06-23 14:28:03');
INSERT INTO `oauth2_refresh_token` VALUES ('e9e5fd7f11ce4d2a95a316f77be59a84', 27, 2, 1, '2019-06-25 08:57:13', '2019-06-24 20:57:13', '2019-06-24 20:57:13');
INSERT INTO `oauth2_refresh_token` VALUES ('e9f8654d4ff840e78a70bc8cb7613031', 27, 2, 1, '2019-07-21 08:54:44', '2019-07-20 20:54:43', '2019-07-20 20:54:43');
INSERT INTO `oauth2_refresh_token` VALUES ('ea076f807fb54ec2943f1cb28ff234c7', 27, 2, 1, '2019-08-08 04:58:52', '2019-08-07 16:58:51', '2019-08-07 16:58:51');
INSERT INTO `oauth2_refresh_token` VALUES ('ea100b1b1470468790ee7c9160495b9b', 27, 2, 1, '2019-06-17 06:02:53', '2019-06-16 18:02:52', '2019-06-16 18:02:52');
INSERT INTO `oauth2_refresh_token` VALUES ('ea1ccc1f03434ed9b6fa78d2362c54e0', 1, 2, 0, '2019-08-02 11:54:57', '2019-08-01 23:54:57', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ea1d4ab228354aeabe848cb85083d303', 27, 2, 1, '2019-08-08 03:26:18', '2019-08-07 15:26:18', '2019-08-07 15:26:18');
INSERT INTO `oauth2_refresh_token` VALUES ('ea1e41f2e93a471a954f9cd80324c2a7', 27, 2, 1, '2019-08-17 02:58:22', '2019-08-16 14:58:22', '2019-08-16 14:58:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ea1eefea5f9546af9a724008ef09d774', 27, 2, 1, '2019-08-12 22:47:59', '2019-08-12 10:47:58', '2019-08-12 10:47:58');
INSERT INTO `oauth2_refresh_token` VALUES ('ea29f0a780ce4c0db64ccbc18debfdb0', 27, 2, 1, '2019-07-06 21:40:37', '2019-07-06 09:40:36', '2019-07-06 09:40:36');
INSERT INTO `oauth2_refresh_token` VALUES ('ea421d3b1ee34dcba3d1df17c8b4ec5a', 27, 2, 1, '2019-09-03 02:53:26', '2019-09-02 14:53:26', '2019-09-02 14:53:26');
INSERT INTO `oauth2_refresh_token` VALUES ('ea452ca45b414a65bd23476f4e82f298', 27, 2, 1, '2019-06-22 05:03:02', '2019-06-21 17:03:02', '2019-06-21 17:03:02');
INSERT INTO `oauth2_refresh_token` VALUES ('ea5e48c803bb4ef8abf2e86e6398d2fc', 27, 2, 1, '2019-07-24 04:45:00', '2019-07-23 16:45:00', '2019-07-23 16:45:00');
INSERT INTO `oauth2_refresh_token` VALUES ('ea5f58200c8e4bf48ab418a39da0f4e6', NULL, NULL, 1, '2019-04-25 05:23:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ea877db4ecb748319e3c95a27d6ad3b3', 1, 2, 0, '2019-08-22 06:03:03', '2019-08-21 18:03:02', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ea98b6e695f04461baab69a72f89583a', 27, 2, 1, '2019-06-29 09:20:06', '2019-06-28 21:20:06', '2019-06-28 21:20:06');
INSERT INTO `oauth2_refresh_token` VALUES ('eaa1bab963b740a2b274c672160496b8', 27, 2, 1, '2019-06-14 00:59:13', '2019-06-13 12:59:13', '2019-06-13 12:59:13');
INSERT INTO `oauth2_refresh_token` VALUES ('eab7c057048447b7b17a2bba904f1d89', 27, 2, 1, '2019-06-21 06:51:11', '2019-06-20 18:51:11', '2019-06-20 18:51:11');
INSERT INTO `oauth2_refresh_token` VALUES ('ead54d133c264429ae784c84c1ff5186', 27, 2, 1, '2019-07-03 10:16:25', '2019-07-02 22:16:25', '2019-07-02 22:16:25');
INSERT INTO `oauth2_refresh_token` VALUES ('ead59b5eae8e44419318f0d42681c821', 27, 2, 1, '2019-06-17 00:26:51', '2019-06-16 12:26:50', '2019-06-16 12:26:50');
INSERT INTO `oauth2_refresh_token` VALUES ('eaeb595c78144462abfddf15b06ccba2', 27, 2, 1, '2019-07-06 03:02:44', '2019-07-05 15:02:43', '2019-07-05 15:02:43');
INSERT INTO `oauth2_refresh_token` VALUES ('eb40e2528f1348e9b3dc027e3f0d466e', 27, 2, 1, '2019-08-02 10:59:40', '2019-08-01 22:59:40', '2019-08-01 22:59:40');
INSERT INTO `oauth2_refresh_token` VALUES ('eb6bddc55c22475dbae07a4a542cefa0', 27, 2, 1, '2019-05-22 09:37:30', '2019-05-21 21:37:29', '2019-05-21 21:37:29');
INSERT INTO `oauth2_refresh_token` VALUES ('eb6f4db1cd7547f6921080422af4ef16', 27, 2, 1, '2019-06-05 01:42:43', '2019-06-04 13:42:43', '2019-06-04 13:42:43');
INSERT INTO `oauth2_refresh_token` VALUES ('eb8448caf39844d7ac5433556b77f141', 171, 1, 1, '2019-07-17 03:04:37', '2019-07-16 15:04:36', '2019-07-16 15:04:36');
INSERT INTO `oauth2_refresh_token` VALUES ('eb861c0c107648f4b8831a56da470581', 27, 2, 1, '2019-06-27 01:52:14', '2019-06-26 13:52:14', '2019-06-26 13:52:14');
INSERT INTO `oauth2_refresh_token` VALUES ('eb8bc0d369664cb090537055fd5e9e09', NULL, NULL, 1, '2019-05-08 04:27:54', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('eb91bed0b3704bf08dbfc81bb46ff511', 27, 2, 1, '2019-06-22 20:39:35', '2019-06-22 08:39:35', '2019-06-22 08:39:35');
INSERT INTO `oauth2_refresh_token` VALUES ('ebbe41fa9d994de7aaf0ba69d3fa1441', 27, 2, 1, '2019-06-24 21:50:53', '2019-06-24 09:50:53', '2019-06-24 09:50:53');
INSERT INTO `oauth2_refresh_token` VALUES ('ebc891372feb45d3b00a64e41909d1d4', 174, 1, 1, '2019-07-18 01:14:09', '2019-07-17 13:14:08', '2019-07-17 13:14:08');
INSERT INTO `oauth2_refresh_token` VALUES ('ebc8caeae5da4781bf5b6350340f5b2f', 27, 2, 1, '2019-06-25 22:19:57', '2019-06-25 10:19:57', '2019-06-25 10:19:57');
INSERT INTO `oauth2_refresh_token` VALUES ('ebcff0dccf744d44bb911fe46e349bd3', 27, 2, 1, '2019-05-25 03:20:53', '2019-05-24 15:19:36', '2019-05-24 15:19:36');
INSERT INTO `oauth2_refresh_token` VALUES ('ebe0e86557274a6da966372886c9c78f', 27, 2, 1, '2019-08-01 00:45:28', '2019-07-31 12:45:27', '2019-07-31 12:45:27');
INSERT INTO `oauth2_refresh_token` VALUES ('ec04062c85f840af969edbd33bc29f59', NULL, NULL, 1, '2019-04-06 01:10:58', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ec0812f1a6124af9857dba73cf6ba826', NULL, NULL, 1, '2019-05-09 07:55:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ec1faf263fa74f9d93663c1969ae4d66', 27, 2, 1, '2019-07-13 01:00:14', '2019-07-12 13:00:13', '2019-07-12 13:00:13');
INSERT INTO `oauth2_refresh_token` VALUES ('ec3160fdee8d4610a3fda6f39d001996', 27, 2, 1, '2019-06-04 07:03:27', '2019-06-03 19:03:27', '2019-06-03 19:03:27');
INSERT INTO `oauth2_refresh_token` VALUES ('ec36e1b0c12d41eba0171f7e565cabbf', 1, 2, 0, '2019-09-04 22:16:39', '2019-09-04 10:16:38', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ec4c37f2e33a4479a74fbdbdb253fdd6', 27, 2, 1, '2019-08-21 21:07:10', '2019-08-21 09:07:10', '2019-08-21 09:07:10');
INSERT INTO `oauth2_refresh_token` VALUES ('ec57b7120f4646e898729340ae653f6f', 27, 2, 1, '2019-06-08 03:53:08', '2019-06-07 15:53:08', '2019-06-07 15:53:08');
INSERT INTO `oauth2_refresh_token` VALUES ('ec62223573b4484aa49901287fce8dfb', 27, 2, 1, '2019-07-16 04:50:28', '2019-07-15 16:50:28', '2019-07-15 16:50:28');
INSERT INTO `oauth2_refresh_token` VALUES ('ec708972357149ada3e035799b32e598', 88, 1, 1, '2019-05-29 04:55:36', '2019-05-28 16:55:36', '2019-05-28 16:55:36');
INSERT INTO `oauth2_refresh_token` VALUES ('ec79bc01b7fc4f85a0ebd93fb574b22b', 27, 2, 1, '2019-08-12 23:40:59', '2019-08-12 11:40:58', '2019-08-12 11:40:58');
INSERT INTO `oauth2_refresh_token` VALUES ('ec8f64ca69344b66884bd844a3e9ffce', 27, 2, 1, '2019-06-12 21:50:33', '2019-06-12 09:50:32', '2019-06-12 09:50:32');
INSERT INTO `oauth2_refresh_token` VALUES ('ec959a2a5db9445c8a449ca06901112a', 27, 2, 1, '2019-06-01 01:44:59', '2019-05-31 13:44:59', '2019-05-31 13:44:59');
INSERT INTO `oauth2_refresh_token` VALUES ('eca273c8966e4206893e31f06bfe524f', 1, 2, 0, '2019-07-24 21:35:06', '2019-07-24 09:35:06', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ecbdf7acf7ec4cd9b0b376ef24b78879', NULL, NULL, 1, '2019-05-01 23:51:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ecd59c42c8d24919bab26265d6174918', 27, 2, 1, '2019-08-08 03:28:08', '2019-08-07 15:28:08', '2019-08-07 15:28:08');
INSERT INTO `oauth2_refresh_token` VALUES ('ecf48faa0c7f43c8b7a59afccec9e418', 27, 2, 1, '2019-06-20 04:53:43', '2019-06-19 16:53:43', '2019-06-19 16:53:43');
INSERT INTO `oauth2_refresh_token` VALUES ('ed05365c4aed4a4f9e57509d0a3199b3', 27, 2, 1, '2019-06-30 11:03:20', '2019-06-29 23:03:20', '2019-06-29 23:03:20');
INSERT INTO `oauth2_refresh_token` VALUES ('ed15f9f6433b425298a57c5f35bb44a5', NULL, NULL, 1, '2019-03-14 03:55:50', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ed1d1cdeb5f54e5eb671c9850a138a07', 27, 2, 1, '2019-06-10 00:34:23', '2019-06-09 12:34:23', '2019-06-09 12:34:23');
INSERT INTO `oauth2_refresh_token` VALUES ('ed27252fe767471f8f1a465754187fad', 27, 2, 1, '2019-07-26 11:24:18', '2019-07-25 23:24:17', '2019-07-25 23:24:17');
INSERT INTO `oauth2_refresh_token` VALUES ('ed38d62aa0bf49c9b7dabfc8c5daee0c', 27, 2, 1, '2019-06-02 03:34:02', '2019-06-01 15:34:02', '2019-06-01 15:34:02');
INSERT INTO `oauth2_refresh_token` VALUES ('ed482b4b2fba4ab89b2caebf3c77927b', 27, 2, 1, '2019-08-29 08:18:29', '2019-08-28 20:18:28', '2019-08-28 20:18:28');
INSERT INTO `oauth2_refresh_token` VALUES ('ed5e90d2d1fe460a9ea8330076a386f9', 27, 2, 1, '2019-06-02 11:22:15', '2019-06-01 23:22:15', '2019-06-01 23:22:15');
INSERT INTO `oauth2_refresh_token` VALUES ('ed5eaf9e8dfd4cf4a8d3dd8c9fcc52a5', 27, 2, 1, '2019-09-06 21:18:45', '2019-09-06 09:18:44', '2019-09-06 09:18:44');
INSERT INTO `oauth2_refresh_token` VALUES ('ed68e25a7d0b4dd597be7b4a348aaa26', 27, 2, 1, '2019-05-31 22:17:08', '2019-05-31 10:17:08', '2019-05-31 10:17:08');
INSERT INTO `oauth2_refresh_token` VALUES ('ed79a50b107e4fa89b6316e61d58f15f', 27, 2, 1, '2019-06-28 02:20:34', '2019-06-27 14:20:34', '2019-06-27 14:20:34');
INSERT INTO `oauth2_refresh_token` VALUES ('ed8025e9b6984c23b62fde5ec3637cd5', 27, 2, 1, '2019-07-04 04:22:26', '2019-07-03 16:22:25', '2019-07-03 16:22:25');
INSERT INTO `oauth2_refresh_token` VALUES ('ed83cfd17715497ab08a1503449a5905', 27, 2, 1, '2019-05-27 11:41:26', '2019-05-26 23:41:26', '2019-05-26 23:41:26');
INSERT INTO `oauth2_refresh_token` VALUES ('ed895ddaabdf4026982330304ba66b2e', 27, 2, 1, '2019-09-06 02:21:17', '2019-09-05 14:21:17', '2019-09-05 14:21:17');
INSERT INTO `oauth2_refresh_token` VALUES ('ed999c87e05644e5b0f1f22da22eaf12', 1, 2, 0, '2019-06-28 04:58:57', '2019-06-27 16:58:56', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ed9b4349fa6c4388abed1c6da3dd0878', 27, 2, 1, '2019-05-31 04:11:01', '2019-05-30 16:11:00', '2019-05-30 16:11:00');
INSERT INTO `oauth2_refresh_token` VALUES ('edcc8856293d44b89d1e63fe9d84bad5', 27, 2, 1, '2019-06-06 01:10:58', '2019-06-05 13:10:58', '2019-06-05 13:10:58');
INSERT INTO `oauth2_refresh_token` VALUES ('ede2787b271347669037c08a44448fff', 27, 2, 1, '2019-06-11 23:39:34', '2019-06-11 11:39:33', '2019-06-11 11:39:33');
INSERT INTO `oauth2_refresh_token` VALUES ('ede5adb2be254629b20a6016f6db8652', 27, 2, 1, '2019-07-30 09:08:52', '2019-07-29 21:08:52', '2019-07-29 21:08:52');
INSERT INTO `oauth2_refresh_token` VALUES ('ee006b02b9324410962b1eed96959f66', 27, 2, 1, '2019-08-30 05:53:11', '2019-08-29 17:53:10', '2019-08-29 17:53:10');
INSERT INTO `oauth2_refresh_token` VALUES ('ee096aa6d0e441d4b0ce31ecd02918e8', NULL, NULL, 1, '2019-03-16 09:07:57', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ee0bfbd5ceb44abb9cf0a197a0062730', 210, 1, 1, '2019-08-23 21:59:34', '2019-08-23 09:59:33', '2019-08-23 09:59:33');
INSERT INTO `oauth2_refresh_token` VALUES ('ee27b55e02744c739d1f5fac41458d66', 1, 2, 0, '2019-06-28 08:39:48', '2019-06-27 20:39:48', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ee395426944143de9abb904506a510a3', NULL, NULL, 1, '2019-05-08 21:59:23', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ee5bdc47c64048c79c7932b52375c65a', 27, 2, 1, '2019-06-01 07:27:41', '2019-05-31 19:27:41', '2019-05-31 19:27:41');
INSERT INTO `oauth2_refresh_token` VALUES ('ee5c53ffb8ac49c4a891d2a2bbd1566f', 27, 2, 1, '2019-09-03 03:05:19', '2019-09-02 15:05:19', '2019-09-02 15:05:19');
INSERT INTO `oauth2_refresh_token` VALUES ('ee662620e94f479aa49ac978af6e037a', 1, 2, 0, '2019-06-30 09:56:29', '2019-06-29 21:56:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ee69d2ac17194d688c322e6a26d96552', 27, 2, 1, '2019-08-31 01:57:42', '2019-08-30 13:57:42', '2019-08-30 13:57:42');
INSERT INTO `oauth2_refresh_token` VALUES ('ee7d94668338465dafa712e008b25daa', 27, 2, 1, '2019-07-04 10:31:29', '2019-07-03 22:31:28', '2019-07-03 22:31:28');
INSERT INTO `oauth2_refresh_token` VALUES ('ee85e1f124224eb4a815dcce38936ad5', 27, 2, 1, '2019-07-19 05:02:16', '2019-07-18 17:02:16', '2019-07-18 17:02:16');
INSERT INTO `oauth2_refresh_token` VALUES ('ee95699156fe49aba483ce515918c0ea', 27, 2, 1, '2019-06-22 03:37:42', '2019-06-21 15:37:41', '2019-06-21 15:37:41');
INSERT INTO `oauth2_refresh_token` VALUES ('ee9736a0d00f4449ba2ebcce861ece62', 27, 2, 1, '2019-08-28 20:49:44', '2019-08-28 08:49:43', '2019-08-28 08:49:43');
INSERT INTO `oauth2_refresh_token` VALUES ('eebafb96bd2349bfaca476854bb0c8a6', 27, 2, 1, '2019-07-16 01:29:26', '2019-07-15 13:29:25', '2019-07-15 13:29:25');
INSERT INTO `oauth2_refresh_token` VALUES ('eebe75f3699d4357b9b4a14f0c70e08b', 27, 2, 1, '2019-07-06 01:56:15', '2019-07-05 13:56:14', '2019-07-05 13:56:14');
INSERT INTO `oauth2_refresh_token` VALUES ('eec5bd3af43344c69dc077712c8721bc', 27, 2, 1, '2019-06-04 22:24:44', '2019-06-04 10:24:44', '2019-06-04 10:24:44');
INSERT INTO `oauth2_refresh_token` VALUES ('eed8a7ea17fd499ebc4e413cef4fafaf', 27, 2, 1, '2019-06-09 23:09:01', '2019-06-09 11:09:00', '2019-06-09 11:09:00');
INSERT INTO `oauth2_refresh_token` VALUES ('ef11ce0cb20d48b791fe8de8a2b45bb1', 27, 2, 1, '2019-07-30 00:20:22', '2019-07-29 12:20:21', '2019-07-29 12:20:21');
INSERT INTO `oauth2_refresh_token` VALUES ('ef1a23f1af254860ac967704215a58e4', 27, 2, 1, '2019-05-28 04:35:48', '2019-05-27 16:35:48', '2019-05-27 16:35:48');
INSERT INTO `oauth2_refresh_token` VALUES ('ef29e3ec83f1458d968e55df726dba50', 27, 2, 1, '2019-08-26 03:45:05', '2019-08-25 15:45:04', '2019-08-25 15:45:04');
INSERT INTO `oauth2_refresh_token` VALUES ('ef616f7ef4e9482e884059cffe61b5b1', 27, 2, 1, '2019-06-14 10:57:24', '2019-06-13 22:57:24', '2019-06-13 22:57:24');
INSERT INTO `oauth2_refresh_token` VALUES ('ef8c1ff0390545de88c606afd6484d43', 27, 2, 1, '2019-07-18 04:03:48', '2019-07-17 16:03:48', '2019-07-17 16:03:48');
INSERT INTO `oauth2_refresh_token` VALUES ('ef9d72ecfcf7431a978cf357ce54dbb1', 27, 2, 1, '2019-06-23 09:31:14', '2019-06-22 21:31:14', '2019-06-22 21:31:14');
INSERT INTO `oauth2_refresh_token` VALUES ('efac91c37393427baadb3d902015b4e6', 27, 2, 1, '2019-07-12 21:45:24', '2019-07-12 09:45:24', '2019-07-12 09:45:24');
INSERT INTO `oauth2_refresh_token` VALUES ('efbb7638051942ccaa0c12e7b6411588', 27, 2, 1, '2019-07-24 08:42:44', '2019-07-23 20:42:43', '2019-07-23 20:42:43');
INSERT INTO `oauth2_refresh_token` VALUES ('efbf3844449f40b9ada64b8ef8e854c0', 27, 2, 1, '2019-07-14 08:17:04', '2019-07-13 20:17:04', '2019-07-13 20:17:04');
INSERT INTO `oauth2_refresh_token` VALUES ('efe568813166466dad3026cfaf4b0244', 27, 2, 1, '2019-08-18 06:25:58', '2019-08-17 18:25:57', '2019-08-17 18:25:57');
INSERT INTO `oauth2_refresh_token` VALUES ('efeb1af6b7774118842d2d8147d6846f', 27, 2, 1, '2019-05-30 01:33:30', '2019-05-29 13:33:30', '2019-05-29 13:33:30');
INSERT INTO `oauth2_refresh_token` VALUES ('effb07105a514a918f02a6a4e31b9788', 27, 2, 1, '2019-07-12 22:14:23', '2019-07-12 10:14:23', '2019-07-12 10:14:23');
INSERT INTO `oauth2_refresh_token` VALUES ('f00017bada24462092d869e855ea7d15', 27, 2, 1, '2019-06-12 21:40:25', '2019-06-12 09:40:24', '2019-06-12 09:40:24');
INSERT INTO `oauth2_refresh_token` VALUES ('f01298a699d84ba6b103fb608d8dff80', 140, 1, 1, '2019-06-25 23:27:30', '2019-06-25 11:27:30', '2019-06-25 11:27:30');
INSERT INTO `oauth2_refresh_token` VALUES ('f014fe464c374ab09013090ec631f49b', 27, 2, 1, '2019-06-14 03:17:31', '2019-06-13 15:17:31', '2019-06-13 15:17:31');
INSERT INTO `oauth2_refresh_token` VALUES ('f021def591f243ef98ec1916b40cb2ca', NULL, NULL, 1, '2019-04-28 20:50:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f04d9198eb034b369d901eb79b55876c', 27, 2, 1, '2019-07-04 04:16:25', '2019-07-03 16:16:25', '2019-07-03 16:16:25');
INSERT INTO `oauth2_refresh_token` VALUES ('f06d6c23cd3a4855bb9ee4ddf72c4d66', 27, 2, 1, '2019-06-03 07:10:50', '2019-06-02 19:10:50', '2019-06-02 19:10:50');
INSERT INTO `oauth2_refresh_token` VALUES ('f07596fc05984eeba643189d5fce10e1', 27, 2, 1, '2019-06-03 12:37:03', '2019-06-03 00:37:02', '2019-06-03 00:37:02');
INSERT INTO `oauth2_refresh_token` VALUES ('f075d6d375374a39bef6dc126e6f99ec', 27, 2, 1, '2019-08-30 21:18:47', '2019-08-30 09:18:46', '2019-08-30 09:18:46');
INSERT INTO `oauth2_refresh_token` VALUES ('f08263f0f81c430291a38e3c644675d8', 1, 2, 0, '2019-08-02 00:15:06', '2019-08-01 12:15:06', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('f0d555f69a5848e28ff091d70a7d5667', 27, 2, 1, '2019-06-19 23:57:32', '2019-06-19 11:57:31', '2019-06-19 11:57:31');
INSERT INTO `oauth2_refresh_token` VALUES ('f0e8c46cf9da4edc990fb9541e7b587b', 1, 1, 1, '2019-05-17 12:24:18', '2019-05-17 00:24:17', '2019-05-17 00:24:17');
INSERT INTO `oauth2_refresh_token` VALUES ('f0f6f42c465d4195a18664532e973f17', 27, 2, 1, '2019-08-08 01:40:49', '2019-08-07 13:40:49', '2019-08-07 13:40:49');
INSERT INTO `oauth2_refresh_token` VALUES ('f0f70e95f0114a74b33874dd1946a0e4', 27, 2, 1, '2019-06-09 10:11:55', '2019-06-08 22:11:54', '2019-06-08 22:11:54');
INSERT INTO `oauth2_refresh_token` VALUES ('f0ff136033c44d6da1a696b0b4f523e0', 27, 2, 1, '2019-08-27 02:30:10', '2019-08-26 14:30:09', '2019-08-26 14:30:09');
INSERT INTO `oauth2_refresh_token` VALUES ('f1028dcf551d4c62a442db610dc20502', 1, 2, 0, '2019-08-30 14:42:16', '2019-08-30 02:42:16', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('f108f361f84845868d1c3231337b538c', 27, 2, 1, '2019-07-12 05:55:22', '2019-07-11 17:55:21', '2019-07-11 17:55:21');
INSERT INTO `oauth2_refresh_token` VALUES ('f109dfb5263041fb9ec6a70128a2bdad', 130, 1, 1, '2019-06-21 23:51:25', '2019-06-21 11:51:24', '2019-06-21 11:51:24');
INSERT INTO `oauth2_refresh_token` VALUES ('f1164dc5ada847598364bca7447926dc', 27, 2, 1, '2019-06-25 05:10:46', '2019-06-24 17:10:45', '2019-06-24 17:10:45');
INSERT INTO `oauth2_refresh_token` VALUES ('f120841b55034fe78026f3e8ea646fa8', 27, 2, 1, '2019-05-27 22:45:57', '2019-05-27 10:45:56', '2019-05-27 10:45:56');
INSERT INTO `oauth2_refresh_token` VALUES ('f13c026fa5f1474c92634c761893384f', 27, 2, 1, '2019-08-30 01:55:09', '2019-08-29 13:55:09', '2019-08-29 13:55:09');
INSERT INTO `oauth2_refresh_token` VALUES ('f16f6c6542ff446c811c5c9f5f1acf90', NULL, NULL, 1, '2019-03-27 05:41:49', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f1747cd256ea4d03901309bae1e893f8', NULL, NULL, 0, '2019-03-04 10:10:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f18b11d97c9346f0ac2a3af8b7b932e1', 27, 2, 1, '2019-06-13 02:12:15', '2019-06-12 14:12:14', '2019-06-12 14:12:14');
INSERT INTO `oauth2_refresh_token` VALUES ('f1b6d995851c4c329fe3f6bc6ee18bbc', 27, 2, 1, '2019-06-14 06:33:23', '2019-06-13 18:33:22', '2019-06-13 18:33:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f1c493a66ee34e1e9d42f50ea68e08d7', 27, 2, 1, '2019-07-28 23:03:17', '2019-07-28 11:03:17', '2019-07-28 11:03:17');
INSERT INTO `oauth2_refresh_token` VALUES ('f1e3a30776424f4fbf87fad9b21e44dd', 27, 2, 1, '2019-08-14 02:08:34', '2019-08-13 14:08:33', '2019-08-13 14:08:33');
INSERT INTO `oauth2_refresh_token` VALUES ('f1f22492b2144f55af89c386e3c2f69f', 27, 2, 1, '2019-06-05 21:14:32', '2019-06-05 09:14:31', '2019-06-05 09:14:31');
INSERT INTO `oauth2_refresh_token` VALUES ('f22cec24bce14180be8e43c7d4c7ca29', 27, 2, 1, '2019-08-20 23:53:00', '2019-08-20 11:52:59', '2019-08-20 11:52:59');
INSERT INTO `oauth2_refresh_token` VALUES ('f238ae272dbf4fac94251db8e0305ee6', 1, 2, 0, '2019-06-07 05:34:57', '2019-06-06 17:36:09', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('f252213a43ed4bee8e61526c1836594e', 27, 2, 1, '2019-07-09 07:03:42', '2019-07-08 19:03:42', '2019-07-08 19:03:42');
INSERT INTO `oauth2_refresh_token` VALUES ('f29268dad8944a2c87eecc1339f6cab8', 27, 2, 1, '2019-07-16 04:47:52', '2019-07-15 16:47:51', '2019-07-15 16:47:51');
INSERT INTO `oauth2_refresh_token` VALUES ('f298f87054034d1a8badb491836260e6', 27, 2, 1, '2019-05-18 10:16:53', '2019-05-17 22:16:53', '2019-05-17 22:16:53');
INSERT INTO `oauth2_refresh_token` VALUES ('f299d65230eb41f0862ca4de49a8976a', 27, 2, 1, '2019-07-20 03:09:17', '2019-07-19 15:09:17', '2019-07-19 15:09:17');
INSERT INTO `oauth2_refresh_token` VALUES ('f29a0260aacd47ff9c98b4e006f56e62', 27, 2, 1, '2019-09-05 04:51:25', '2019-09-04 16:51:25', '2019-09-04 16:51:25');
INSERT INTO `oauth2_refresh_token` VALUES ('f2a4df182d1342378afe5bd0de4d3fa4', 27, 2, 1, '2019-08-07 03:25:06', '2019-08-06 15:25:06', '2019-08-06 15:25:06');
INSERT INTO `oauth2_refresh_token` VALUES ('f2b251ea0b124787957403ecd02b3e7e', NULL, NULL, 1, '2019-04-24 20:47:45', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f2bcbd72565544a7b2b586aad4e8c3ab', 27, 2, 1, '2019-06-15 00:38:57', '2019-06-14 12:38:56', '2019-06-14 12:38:56');
INSERT INTO `oauth2_refresh_token` VALUES ('f30023e5678d4688a53a7e9a0b804320', 1, 2, 0, '2019-06-10 21:50:03', '2019-06-10 09:50:02', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('f304eab2a2664ee1841d9a92eecc24c9', 27, 2, 1, '2019-06-22 09:53:08', '2019-06-21 21:53:07', '2019-06-21 21:53:07');
INSERT INTO `oauth2_refresh_token` VALUES ('f314b6a5e2474d92876b2f94696a4590', 27, 2, 1, '2019-09-06 05:53:55', '2019-09-05 17:53:55', '2019-09-05 17:53:55');
INSERT INTO `oauth2_refresh_token` VALUES ('f3336efaf3b2451db15d3c925454c0b0', 27, 2, 1, '2019-06-05 21:10:45', '2019-06-05 09:10:45', '2019-06-05 09:10:45');
INSERT INTO `oauth2_refresh_token` VALUES ('f339511ff0184f08a887451ff596a029', 216, 1, 1, '2019-08-30 23:40:42', '2019-08-30 11:40:42', '2019-08-30 11:40:42');
INSERT INTO `oauth2_refresh_token` VALUES ('f347a72064db4532a366fc2ac6459442', 27, 2, 1, '2019-06-10 22:07:35', '2019-06-10 10:07:34', '2019-06-10 10:07:34');
INSERT INTO `oauth2_refresh_token` VALUES ('f34ca7c66e6a4543acec2baba26871b7', 92, 1, 1, '2019-05-31 05:47:12', '2019-05-30 17:47:11', '2019-05-30 17:47:11');
INSERT INTO `oauth2_refresh_token` VALUES ('f37351e34bae4529a32554c0ad6bab57', 211, 1, 1, '2019-08-24 18:54:18', '2019-08-24 06:54:18', '2019-08-24 06:54:18');
INSERT INTO `oauth2_refresh_token` VALUES ('f3804be0e8aa422790ab1a5ca7ca34cb', NULL, NULL, 1, '2019-03-10 22:13:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f390d49f1af245b5a83f70e536ca2d99', NULL, NULL, 0, '2019-02-28 13:56:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f395dbe9f982465db4e68c4cd9aa6ffe', 27, 2, 1, '2019-07-26 01:29:52', '2019-07-25 13:29:51', '2019-07-25 13:29:51');
INSERT INTO `oauth2_refresh_token` VALUES ('f3a2563ce8fd4f84902f1c2e06597503', 172, 1, 1, '2019-07-17 06:14:40', '2019-07-16 18:14:39', '2019-07-16 18:14:39');
INSERT INTO `oauth2_refresh_token` VALUES ('f42e48e1fb7343e5b00100bb490754ce', 27, 2, 1, '2019-08-22 07:58:53', '2019-08-21 19:58:53', '2019-08-21 19:58:53');
INSERT INTO `oauth2_refresh_token` VALUES ('f431cce162104b4bbdaa0699a0eb9edc', 27, 2, 1, '2019-06-20 00:33:04', '2019-06-19 12:33:03', '2019-06-19 12:33:03');
INSERT INTO `oauth2_refresh_token` VALUES ('f43a5e46185e46118a2f9dd9fe3624d3', 27, 2, 1, '2019-06-12 10:19:39', '2019-06-11 22:19:39', '2019-06-11 22:19:39');
INSERT INTO `oauth2_refresh_token` VALUES ('f445f26fe428400bb0d39772b9a8a5a9', 27, 2, 1, '2019-08-06 03:15:23', '2019-08-05 15:15:22', '2019-08-05 15:15:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f4718d1d51814c15a6e4bfb0e5f23ee3', NULL, NULL, 0, '2019-03-04 10:11:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f47c58ce413d49c1bf5976a4a1bce5d4', 27, 2, 1, '2019-08-27 21:44:18', '2019-08-27 09:44:18', '2019-08-27 09:44:18');
INSERT INTO `oauth2_refresh_token` VALUES ('f498e981a32b4ef8a1ddac617a6748a7', 27, 2, 1, '2019-07-19 22:29:26', '2019-07-19 10:29:26', '2019-07-19 10:29:26');
INSERT INTO `oauth2_refresh_token` VALUES ('f49a1fe77dcf4cd19ea1d69a1f5766a2', 27, 2, 1, '2019-08-24 03:47:00', '2019-08-23 15:47:00', '2019-08-23 15:47:00');
INSERT INTO `oauth2_refresh_token` VALUES ('f4bcde9dd464439db7d05a0a16281d39', 27, 2, 1, '2019-06-25 03:03:00', '2019-06-24 15:02:59', '2019-06-24 15:02:59');
INSERT INTO `oauth2_refresh_token` VALUES ('f4bdcf0abb1f460789c5a6a05aea7288', 1, 2, 0, '2019-08-22 06:01:53', '2019-08-21 18:01:53', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('f4be2a28b8dc4e20a1f3fd8353bc918f', 27, 2, 1, '2019-08-25 03:53:41', '2019-08-24 15:53:40', '2019-08-24 15:53:40');
INSERT INTO `oauth2_refresh_token` VALUES ('f4d0e487cd5e416aa34b70a1516f1c6f', 27, 2, 1, '2019-06-04 04:01:22', '2019-06-03 16:01:22', '2019-06-03 16:01:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f4f923afd24d4dc6874857dc6d0abbc2', 27, 2, 1, '2019-06-15 02:52:35', '2019-06-14 14:52:35', '2019-06-14 14:52:35');
INSERT INTO `oauth2_refresh_token` VALUES ('f50617d52473483f9b0192a70d5ce9ed', NULL, NULL, 1, '2019-03-19 16:09:49', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f506c47f60014117a472d55384dd3352', 27, 2, 1, '2019-05-28 07:49:35', '2019-05-27 19:49:35', '2019-05-27 19:49:35');
INSERT INTO `oauth2_refresh_token` VALUES ('f5145ae1e6b94a339696bc7cd8f09f05', NULL, NULL, 1, '2019-03-22 23:57:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f53417d82e4a4a5fa021070ad0f2d0cb', 27, 2, 1, '2019-07-12 00:02:33', '2019-07-11 12:02:32', '2019-07-11 12:02:32');
INSERT INTO `oauth2_refresh_token` VALUES ('f53c798cdf1c479fb6f61704b076dc3b', 27, 2, 1, '2019-07-05 05:59:10', '2019-07-04 17:59:10', '2019-07-04 17:59:10');
INSERT INTO `oauth2_refresh_token` VALUES ('f53edee4099c43c090cb02609f5a67b3', 27, 2, 1, '2019-08-13 21:50:04', '2019-08-13 09:50:03', '2019-08-13 09:50:03');
INSERT INTO `oauth2_refresh_token` VALUES ('f548296ac2e84a4fb5dcef0cc1e0e051', 27, 2, 1, '2019-06-03 08:47:54', '2019-06-02 20:47:53', '2019-06-02 20:47:53');
INSERT INTO `oauth2_refresh_token` VALUES ('f54c1634a96147558e617d559f97b3b3', 109, 1, 1, '2019-06-06 05:42:21', '2019-06-05 17:42:20', '2019-06-05 17:42:20');
INSERT INTO `oauth2_refresh_token` VALUES ('f5583cb31d8241c8bd3ee23943a1fd7f', 27, 2, 1, '2019-08-28 23:41:35', '2019-08-28 11:41:35', '2019-08-28 11:41:35');
INSERT INTO `oauth2_refresh_token` VALUES ('f56078ca5ddc467b8f6c0e1486d99c4b', 27, 2, 1, '2019-06-03 23:17:33', '2019-06-03 11:17:33', '2019-06-03 11:17:33');
INSERT INTO `oauth2_refresh_token` VALUES ('f5659c3bc2804c209f6a5c490b747abf', 27, 2, 1, '2019-08-20 11:19:11', '2019-08-19 23:19:11', '2019-08-19 23:19:11');
INSERT INTO `oauth2_refresh_token` VALUES ('f591665c19ff403aa7c20ef958f6ae72', 27, 2, 1, '2019-08-24 05:32:53', '2019-08-23 17:32:53', '2019-08-23 17:32:53');
INSERT INTO `oauth2_refresh_token` VALUES ('f5a0e64a279446898542a52c1f21047f', 27, 2, 1, '2019-08-23 05:31:24', '2019-08-22 17:31:24', '2019-08-22 17:31:24');
INSERT INTO `oauth2_refresh_token` VALUES ('f5a863ea55c9448e86cefae58eaa18b1', 27, 2, 1, '2019-06-01 10:49:39', '2019-05-31 22:49:38', '2019-05-31 22:49:38');
INSERT INTO `oauth2_refresh_token` VALUES ('f5b2c37bf39b44958b61c9a4e05f7818', 27, 2, 1, '2019-05-28 05:50:58', '2019-05-27 17:50:58', '2019-05-27 17:50:58');
INSERT INTO `oauth2_refresh_token` VALUES ('f5b66f2a83464842bb8516083af4293d', 27, 2, 1, '2019-07-21 05:22:10', '2019-07-20 17:22:10', '2019-07-20 17:22:10');
INSERT INTO `oauth2_refresh_token` VALUES ('f5bc77acac8847afbddbf0b861f9d587', 1, 2, 0, '2019-09-05 08:39:47', '2019-09-04 20:39:46', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('f5d11dc788d24fe7bf73a49254b38e4d', 27, 2, 1, '2019-06-28 21:35:17', '2019-06-28 09:35:16', '2019-06-28 09:35:16');
INSERT INTO `oauth2_refresh_token` VALUES ('f5d8df4be8c342f7b61358eddb05c7c0', 27, 2, 1, '2019-08-01 02:51:20', '2019-07-31 14:51:19', '2019-07-31 14:51:19');
INSERT INTO `oauth2_refresh_token` VALUES ('f5e803f6d9d94876ae4424eac705fe30', 27, 2, 1, '2019-06-12 10:56:59', '2019-06-11 22:56:59', '2019-06-11 22:56:59');
INSERT INTO `oauth2_refresh_token` VALUES ('f5e88a3f09a34b2a8f3a94384f376a68', 193, 1, 1, '2019-08-08 01:40:20', '2019-08-07 13:40:19', '2019-08-07 13:40:19');
INSERT INTO `oauth2_refresh_token` VALUES ('f606d62293e740d99b369853682a91e1', 27, 2, 1, '2019-06-06 23:39:39', '2019-06-06 11:39:39', '2019-06-06 11:39:39');
INSERT INTO `oauth2_refresh_token` VALUES ('f60a6054c5d247cca2461d5fc7a57183', 27, 2, 1, '2019-06-18 13:17:00', '2019-06-18 01:16:59', '2019-06-18 01:16:59');
INSERT INTO `oauth2_refresh_token` VALUES ('f60d2f39814a4a5ca4ca591fc1798001', 27, 2, 1, '2019-08-03 11:43:00', '2019-08-02 23:43:00', '2019-08-02 23:43:00');
INSERT INTO `oauth2_refresh_token` VALUES ('f6113ae6011b4d0d90258f5473aa7c6d', 27, 2, 1, '2019-08-24 04:12:30', '2019-08-23 16:12:30', '2019-08-23 16:12:30');
INSERT INTO `oauth2_refresh_token` VALUES ('f6348af5f17e4f3c8fa4b1ca362347a3', NULL, NULL, 1, '2019-05-06 01:39:08', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f6496d8ac5a547639e6441571dcba0e3', 27, 2, 1, '2019-06-06 14:37:59', '2019-06-06 02:37:59', '2019-06-06 02:37:59');
INSERT INTO `oauth2_refresh_token` VALUES ('f664f33aa32c49aea9d5ff28f9cfaec4', 27, 2, 1, '2019-06-16 22:27:15', '2019-06-16 10:27:14', '2019-06-16 10:27:14');
INSERT INTO `oauth2_refresh_token` VALUES ('f67b1f8de3c44c8f9bdd2cac037f348d', 27, 2, 1, '2019-05-25 20:59:55', '2019-05-25 08:59:54', '2019-05-25 08:59:54');
INSERT INTO `oauth2_refresh_token` VALUES ('f680bfaa04ed445fbfd932fb8927cfa7', 27, 2, 1, '2019-06-04 20:58:45', '2019-06-04 08:58:45', '2019-06-04 08:58:45');
INSERT INTO `oauth2_refresh_token` VALUES ('f69f49a9c8004c0f8cb3bf15e780a495', 27, 2, 1, '2019-06-06 02:18:52', '2019-06-05 14:18:51', '2019-06-05 14:18:51');
INSERT INTO `oauth2_refresh_token` VALUES ('f6a6c3d5ebbd4e4dba81d6b94bac75ed', 27, 2, 1, '2019-06-06 21:50:44', '2019-06-06 09:50:44', '2019-06-06 09:50:44');
INSERT INTO `oauth2_refresh_token` VALUES ('f6b2caa8f4d74b6480034ee55b09e689', 27, 2, 1, '2019-07-30 02:45:52', '2019-07-29 14:45:51', '2019-07-29 14:45:51');
INSERT INTO `oauth2_refresh_token` VALUES ('f6c36fb78524451d8c56c8f1d972cd50', 27, 2, 1, '2019-07-21 22:18:13', '2019-07-21 10:18:12', '2019-07-21 10:18:12');
INSERT INTO `oauth2_refresh_token` VALUES ('f6cd866cff654730bf03ff628d9f1ccc', 27, 2, 1, '2019-07-19 23:20:08', '2019-07-19 11:20:07', '2019-07-19 11:20:07');
INSERT INTO `oauth2_refresh_token` VALUES ('f6d1108246844728a34e2eadc1c80fc8', 27, 2, 1, '2019-06-06 23:42:41', '2019-06-06 11:42:41', '2019-06-06 11:42:41');
INSERT INTO `oauth2_refresh_token` VALUES ('f6d1ea2cd9ad41ee88fe439df03c553b', 27, 2, 1, '2019-06-18 04:55:07', '2019-06-17 16:55:06', '2019-06-17 16:55:06');
INSERT INTO `oauth2_refresh_token` VALUES ('f6f97fc7ab9749c29ef302754625b6b7', 27, 2, 1, '2019-05-18 09:51:41', '2019-05-17 21:51:41', '2019-05-17 21:51:41');
INSERT INTO `oauth2_refresh_token` VALUES ('f702903de89a44e19de2cf87596d48f0', 27, 2, 1, '2019-07-04 06:47:51', '2019-07-03 18:47:50', '2019-07-03 18:47:50');
INSERT INTO `oauth2_refresh_token` VALUES ('f726549835434967a0f5f61eb22d4808', 27, 2, 1, '2019-06-04 09:08:12', '2019-06-03 21:08:11', '2019-06-03 21:08:11');
INSERT INTO `oauth2_refresh_token` VALUES ('f72c6265d4d04870a80f78c2e1128d86', 27, 2, 1, '2019-08-16 04:29:25', '2019-08-15 16:29:25', '2019-08-15 16:29:25');
INSERT INTO `oauth2_refresh_token` VALUES ('f73271b6a4804653ae12dc0f3d2b6aea', NULL, NULL, 1, '2019-05-14 04:33:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f73865be8dc94adf8f667e744e9982a2', 38, 1, 1, '2019-08-15 03:49:08', '2019-08-14 15:49:08', '2019-08-14 15:49:08');
INSERT INTO `oauth2_refresh_token` VALUES ('f747e37cf63d4f9eb2bbc925991ce268', 27, 2, 1, '2019-07-01 22:27:17', '2019-07-01 10:27:16', '2019-07-01 10:27:16');
INSERT INTO `oauth2_refresh_token` VALUES ('f7598e2b40ae46eba58b7512cdb09fe2', 27, 2, 1, '2019-08-20 06:06:46', '2019-08-19 18:06:46', '2019-08-19 18:06:46');
INSERT INTO `oauth2_refresh_token` VALUES ('f759c5032e0c4760bb082dd60b0bffaa', 27, 2, 1, '2019-08-14 20:34:09', '2019-08-14 08:34:08', '2019-08-14 08:34:08');
INSERT INTO `oauth2_refresh_token` VALUES ('f76509f6d6b6431ebcdc612f39274cf5', 27, 2, 1, '2019-06-01 21:46:57', '2019-06-01 09:46:57', '2019-06-01 09:46:57');
INSERT INTO `oauth2_refresh_token` VALUES ('f766d4b8d8924789ad54e697b19b2420', 27, 2, 1, '2019-07-20 21:35:03', '2019-07-20 09:35:02', '2019-07-20 09:35:02');
INSERT INTO `oauth2_refresh_token` VALUES ('f78785550ca547aaa9f515c15befd36e', 27, 2, 1, '2019-09-03 07:56:27', '2019-09-02 19:56:27', '2019-09-02 19:56:27');
INSERT INTO `oauth2_refresh_token` VALUES ('f7a449eb64d84f968edb66d5eea3258f', NULL, NULL, 1, '2019-03-13 03:38:11', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f7abc4e8cb9542ffb467f9c164cccfc7', 27, 2, 1, '2019-07-23 20:13:49', '2019-07-23 08:13:49', '2019-07-23 08:13:49');
INSERT INTO `oauth2_refresh_token` VALUES ('f7b02549887948c386acfe81bf85275b', 27, 2, 1, '2019-09-07 02:31:17', '2019-09-06 14:31:17', '2019-09-06 14:31:17');
INSERT INTO `oauth2_refresh_token` VALUES ('f7cf8d153158423496c926b4bf0d2259', 27, 2, 1, '2019-05-27 08:14:02', '2019-05-26 20:14:01', '2019-05-26 20:14:01');
INSERT INTO `oauth2_refresh_token` VALUES ('f7ed35cc79414150bcdf1cd04cb9715a', 27, 2, 1, '2019-06-06 01:43:03', '2019-06-05 13:43:02', '2019-06-05 13:43:02');
INSERT INTO `oauth2_refresh_token` VALUES ('f7f2074317c0455bb26b7966475d11e4', 27, 2, 1, '2019-07-02 22:48:04', '2019-07-02 10:48:03', '2019-07-02 10:48:03');
INSERT INTO `oauth2_refresh_token` VALUES ('f7f365b314144840b50d1c0a39651dbd', 27, 2, 1, '2019-07-16 11:07:58', '2019-07-15 23:07:58', '2019-07-15 23:07:58');
INSERT INTO `oauth2_refresh_token` VALUES ('f809848a61d54b9da90c2fc4777e6bab', 27, 2, 1, '2019-08-14 22:16:31', '2019-08-14 10:16:30', '2019-08-14 10:16:30');
INSERT INTO `oauth2_refresh_token` VALUES ('f809da42bcda4d96834c4f24d0b41152', 27, 2, 1, '2019-08-20 11:24:10', '2019-08-19 23:24:09', '2019-08-19 23:24:09');
INSERT INTO `oauth2_refresh_token` VALUES ('f80afe65614a41008a4e83dcfaa39687', 27, 2, 1, '2019-09-05 22:12:21', '2019-09-05 10:12:20', '2019-09-05 10:12:20');
INSERT INTO `oauth2_refresh_token` VALUES ('f8100b4bbc22462881bf2f0e5b613121', 27, 2, 1, '2019-06-03 03:04:41', '2019-06-02 15:04:41', '2019-06-02 15:04:41');
INSERT INTO `oauth2_refresh_token` VALUES ('f81884e537b04372a5cd723634387137', 27, 2, 1, '2019-06-29 05:06:34', '2019-06-28 17:06:33', '2019-06-28 17:06:33');
INSERT INTO `oauth2_refresh_token` VALUES ('f8317f6b8f5c417f9c0767c02945f2e3', 28, 2, 1, '2019-09-05 10:58:23', '2019-09-04 22:58:22', '2019-09-04 22:58:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f858a1e0ea3f455d8b9b84695e172415', 27, 2, 1, '2019-08-08 20:03:41', '2019-08-08 08:03:41', '2019-08-08 08:03:41');
INSERT INTO `oauth2_refresh_token` VALUES ('f85e2af71a6c461e9641f0f9068af030', NULL, NULL, 1, '2019-05-13 22:58:00', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f86daaa5b8ad4ee5a7a1acff6790d509', 27, 2, 1, '2019-07-15 03:28:10', '2019-07-14 15:28:10', '2019-07-14 15:28:10');
INSERT INTO `oauth2_refresh_token` VALUES ('f87a3df538594114af5cec74bbfba691', 27, 2, 1, '2019-05-24 02:06:26', '2019-05-23 14:06:26', '2019-05-23 14:06:26');
INSERT INTO `oauth2_refresh_token` VALUES ('f87b78a251674fcfacf7bd4c5c330c44', 27, 2, 1, '2019-08-08 04:24:42', '2019-08-07 16:24:41', '2019-08-07 16:24:41');
INSERT INTO `oauth2_refresh_token` VALUES ('f87d6a27b7b04c2db8f0123e174a2882', 27, 2, 1, '2019-06-14 22:30:47', '2019-06-14 10:30:47', '2019-06-14 10:30:47');
INSERT INTO `oauth2_refresh_token` VALUES ('f8882fe32e6e445aa90440dca0d94dba', 27, 2, 1, '2019-07-03 05:05:16', '2019-07-02 17:05:15', '2019-07-02 17:05:15');
INSERT INTO `oauth2_refresh_token` VALUES ('f899a01c28314988860fe1fd32f8540d', 27, 2, 1, '2019-08-21 05:26:39', '2019-08-20 17:26:38', '2019-08-20 17:26:38');
INSERT INTO `oauth2_refresh_token` VALUES ('f8a10b93e3e74e97bb20a8037341c881', 27, 2, 1, '2019-07-02 05:53:41', '2019-07-01 17:53:40', '2019-07-01 17:53:40');
INSERT INTO `oauth2_refresh_token` VALUES ('f8a3fddec1654e9ea679f057eaa25b87', 27, 2, 1, '2019-06-06 01:52:56', '2019-06-05 13:52:55', '2019-06-05 13:52:55');
INSERT INTO `oauth2_refresh_token` VALUES ('f8ae3b3f410140958392b5bcf7e68618', 27, 2, 1, '2019-06-19 02:05:49', '2019-06-18 14:05:49', '2019-06-18 14:05:49');
INSERT INTO `oauth2_refresh_token` VALUES ('f8cae7a080314d7c9aa74b49bf9c2a70', 27, 2, 1, '2019-08-28 08:57:20', '2019-08-27 20:57:19', '2019-08-27 20:57:19');
INSERT INTO `oauth2_refresh_token` VALUES ('f8ceb67d697144bf8cff56c1c581909b', 27, 2, 1, '2019-08-24 01:33:30', '2019-08-23 13:33:30', '2019-08-23 13:33:30');
INSERT INTO `oauth2_refresh_token` VALUES ('f8d02b932a7a4580b6f60e33f1fad9b3', 27, 2, 1, '2019-07-09 22:32:04', '2019-07-09 10:32:03', '2019-07-09 10:32:03');
INSERT INTO `oauth2_refresh_token` VALUES ('f8f160bbc5ef4c4e82bb237433e4833a', 27, 2, 1, '2019-08-15 02:55:42', '2019-08-14 14:55:42', '2019-08-14 14:55:42');
INSERT INTO `oauth2_refresh_token` VALUES ('f8f5eabe71d74d94b2c7e78bd547f95f', NULL, NULL, 1, '2019-04-23 07:42:55', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f9242de5946d417896eeed2a16b5d328', 27, 2, 1, '2019-07-03 02:29:58', '2019-07-02 14:29:57', '2019-07-02 14:29:57');
INSERT INTO `oauth2_refresh_token` VALUES ('f926a57d3bba4a39b5340471fc737931', 27, 2, 1, '2019-07-08 09:02:54', '2019-07-07 21:02:54', '2019-07-07 21:02:54');
INSERT INTO `oauth2_refresh_token` VALUES ('f93be936cae5482cbe0aabb57968b913', 27, 2, 1, '2019-07-09 03:45:37', '2019-07-08 15:45:37', '2019-07-08 15:45:37');
INSERT INTO `oauth2_refresh_token` VALUES ('f940d894c4ae44259e54ede745c189c6', 27, 2, 1, '2019-08-23 09:07:16', '2019-08-22 21:07:16', '2019-08-22 21:07:16');
INSERT INTO `oauth2_refresh_token` VALUES ('f94eb3021dd248ff97c2808f3d196a40', 27, 2, 1, '2019-08-29 01:38:52', '2019-08-28 13:38:52', '2019-08-28 13:38:52');
INSERT INTO `oauth2_refresh_token` VALUES ('f95506f90622413b9266769a6085ae46', 27, 2, 1, '2019-06-05 05:06:41', '2019-06-04 17:06:40', '2019-06-04 17:06:40');
INSERT INTO `oauth2_refresh_token` VALUES ('f956b88492b948f4853fd73372b26231', NULL, NULL, 1, '2019-05-07 03:33:39', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f96d0d5622b1425eb760ddc714087d38', 27, 2, 1, '2019-07-18 22:23:01', '2019-07-18 10:23:01', '2019-07-18 10:23:01');
INSERT INTO `oauth2_refresh_token` VALUES ('f97fb48e51834d2dbc670640068f69b8', NULL, NULL, 1, '2019-04-29 22:24:19', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f98a294cc6a24191a13703ff3e806b9d', NULL, NULL, 1, '2019-05-05 05:23:54', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('f996838d12264f1ca727bc27f6a6127d', 27, 2, 1, '2019-08-06 02:56:41', '2019-08-05 14:56:41', '2019-08-05 14:56:41');
INSERT INTO `oauth2_refresh_token` VALUES ('f9ac27490936438fbe1358b34b326415', 27, 2, 1, '2019-06-03 22:18:07', '2019-06-03 10:18:07', '2019-06-03 10:18:07');
INSERT INTO `oauth2_refresh_token` VALUES ('f9b2829acf3848618ccbcf9a7f89f47b', 27, 2, 1, '2019-06-28 07:47:03', '2019-06-27 19:47:02', '2019-06-27 19:47:02');
INSERT INTO `oauth2_refresh_token` VALUES ('f9ed17ff1e9349a2ba100ed5a30429a3', 27, 2, 1, '2019-08-29 20:46:08', '2019-08-29 08:46:07', '2019-08-29 08:46:07');
INSERT INTO `oauth2_refresh_token` VALUES ('f9fa5a26ae054215bbe3c8f5d9c25a45', 27, 2, 1, '2019-07-24 10:53:37', '2019-07-23 22:53:37', '2019-07-23 22:53:37');
INSERT INTO `oauth2_refresh_token` VALUES ('f9fb7c2a05e848fa81fc40043bf295c2', NULL, NULL, 1, '2019-04-23 06:34:36', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('fa0c57ff79684a4c991d89b541582eff', 27, 2, 1, '2019-07-13 02:35:59', '2019-07-12 14:35:59', '2019-07-12 14:35:59');
INSERT INTO `oauth2_refresh_token` VALUES ('fa0f09a9e1394d668739fbd706e962f2', 27, 2, 1, '2019-05-29 21:00:23', '2019-05-29 09:00:23', '2019-05-29 09:00:23');
INSERT INTO `oauth2_refresh_token` VALUES ('fa2c4e4cbe14409d99e84be663b73dd6', 27, 2, 1, '2019-06-05 21:33:42', '2019-06-05 09:33:41', '2019-06-05 09:33:41');
INSERT INTO `oauth2_refresh_token` VALUES ('fa453886ac0549b3bdd0cf1fa7718dfe', 1, 2, 0, '2019-09-03 08:10:06', '2019-09-02 20:10:05', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('fa4a26b7c916441db0b10a10d1e0a0be', 1, 2, 0, '2019-09-08 06:27:14', '2019-09-07 18:27:14', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('fa6ad184680743cc99226ecdcf79c902', 27, 2, 1, '2019-05-24 01:32:56', '2019-05-23 13:32:55', '2019-05-23 13:32:55');
INSERT INTO `oauth2_refresh_token` VALUES ('fa7efaae862347d2891e2b2b99eb7606', NULL, NULL, 1, '2019-05-05 21:49:14', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('fa8f35e9d2364f2e9a7d73f31bfb4039', 27, 2, 1, '2019-06-01 09:59:43', '2019-05-31 21:59:42', '2019-05-31 21:59:42');
INSERT INTO `oauth2_refresh_token` VALUES ('faa8aa641a4f465ea291033952a87398', NULL, NULL, 1, '2019-03-11 21:07:29', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('faae1af83c8b483cbe54392577371469', 1, 2, 0, '2019-06-10 22:40:50', '2019-06-10 10:40:50', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('fac767eb4418429a8d8cb2500c4a4a91', 1, 2, 0, '2019-07-28 08:52:29', '2019-07-27 20:52:29', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('fad8b6334c584bff9fbc779aceabdcd5', 27, 2, 1, '2019-06-03 22:25:55', '2019-06-03 10:25:55', '2019-06-03 10:25:55');
INSERT INTO `oauth2_refresh_token` VALUES ('fae461cc765b47fdbfdb7255aaf763bb', 27, 2, 1, '2019-08-26 00:38:54', '2019-08-25 12:38:53', '2019-08-25 12:38:53');
INSERT INTO `oauth2_refresh_token` VALUES ('fae7ff7cb46f45309284b4f32ccd8925', 27, 2, 1, '2019-07-04 01:32:16', '2019-07-03 13:32:15', '2019-07-03 13:32:15');
INSERT INTO `oauth2_refresh_token` VALUES ('faf08d4d4edd4d37a3294cf452a5bcda', 1, 2, 0, '2019-06-01 06:54:15', '2019-05-31 18:54:14', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('faf4cf268b354ccc97ed570a9a23cb4e', 27, 2, 1, '2019-08-31 04:59:03', '2019-08-30 16:59:02', '2019-08-30 16:59:02');
INSERT INTO `oauth2_refresh_token` VALUES ('fb18ba534f8e4fc8bd9b0c7b73e6b3f5', 27, 2, 1, '2019-08-30 20:42:59', '2019-08-30 08:42:58', '2019-08-30 08:42:58');
INSERT INTO `oauth2_refresh_token` VALUES ('fb34d1c95416427cb453f3a8cc472d65', 27, 2, 1, '2019-07-03 20:39:59', '2019-07-03 08:39:58', '2019-07-03 08:39:58');
INSERT INTO `oauth2_refresh_token` VALUES ('fb3505656d07496bad832dbd01c112bd', 1, 2, 0, '2019-07-06 06:38:50', '2019-07-05 18:38:50', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('fb36895f87df4c5eb3397264fcc8601b', 27, 2, 1, '2019-08-30 22:15:07', '2019-08-30 10:15:07', '2019-08-30 10:15:07');
INSERT INTO `oauth2_refresh_token` VALUES ('fb56082f29024e01b996efd72d582688', 27, 2, 1, '2019-06-05 09:32:56', '2019-06-04 21:32:56', '2019-06-04 21:32:56');
INSERT INTO `oauth2_refresh_token` VALUES ('fb595cac218348feab366b5b356d621a', NULL, NULL, 0, '2019-02-27 04:39:24', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('fb5e774e474e460d9e7075f9cccb41d2', 27, 2, 1, '2019-06-06 03:38:19', '2019-06-05 15:38:19', '2019-06-05 15:38:19');
INSERT INTO `oauth2_refresh_token` VALUES ('fb6ae34d13a34b809d06a865c8f4a4ab', 27, 2, 1, '2019-06-16 02:08:16', '2019-06-15 14:08:16', '2019-06-15 14:08:16');
INSERT INTO `oauth2_refresh_token` VALUES ('fb741736b0de43ebb1df665e4baa91ee', 27, 2, 1, '2019-07-18 04:42:12', '2019-07-17 16:42:11', '2019-07-17 16:42:11');
INSERT INTO `oauth2_refresh_token` VALUES ('fb809803ba584770b758032cace485fc', 27, 2, 1, '2019-06-12 04:14:22', '2019-06-11 16:14:22', '2019-06-11 16:14:22');
INSERT INTO `oauth2_refresh_token` VALUES ('fb82223683c7404eb00d487655a19a87', 27, 2, 1, '2019-09-09 04:59:09', '2019-09-08 16:59:09', '2019-09-08 16:59:09');
INSERT INTO `oauth2_refresh_token` VALUES ('fb9ca2b59cc54eca88ef98bd74e7e715', 27, 2, 1, '2019-09-06 20:38:31', '2019-09-06 08:38:30', '2019-09-06 08:38:30');
INSERT INTO `oauth2_refresh_token` VALUES ('fbc05f9a139546cf9df46b759fb0acca', 1, 2, 0, '2019-08-30 03:47:20', '2019-08-29 15:47:20', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('fbd0d0bdf16945829fdb505934611883', 27, 2, 1, '2019-08-22 10:21:29', '2019-08-21 22:21:28', '2019-08-21 22:21:28');
INSERT INTO `oauth2_refresh_token` VALUES ('fbd883762da247fc9758b4becfc80616', 27, 2, 1, '2019-06-01 21:19:03', '2019-06-01 09:19:02', '2019-06-01 09:19:02');
INSERT INTO `oauth2_refresh_token` VALUES ('fbf8f1cbfd9a45b7a479a09c797a433b', NULL, NULL, 1, '2019-03-10 15:36:18', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('fc2c59b4511b4944ac29fea2f0874147', 27, 2, 1, '2019-07-05 22:24:21', '2019-07-05 10:24:21', '2019-07-05 10:24:21');
INSERT INTO `oauth2_refresh_token` VALUES ('fc302e33c9da40b7862d20379c688d25', 27, 2, 1, '2019-06-29 23:27:07', '2019-06-29 11:27:06', '2019-06-29 11:27:06');
INSERT INTO `oauth2_refresh_token` VALUES ('fc33578905904c56ade3f43d2d221c12', NULL, NULL, 1, '2019-04-24 21:48:08', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('fc5a16bb3b7a40d5bf5697102a7ffcc8', 27, 2, 1, '2019-06-01 21:16:40', '2019-06-01 09:16:40', '2019-06-01 09:16:40');
INSERT INTO `oauth2_refresh_token` VALUES ('fc5dbd3dda9949e48b01733ce5617bf7', 27, 2, 1, '2019-07-11 05:11:24', '2019-07-10 17:11:23', '2019-07-10 17:11:23');
INSERT INTO `oauth2_refresh_token` VALUES ('fc639d8db85f46f2983d4fd729e1fdab', 27, 2, 1, '2019-07-02 02:53:32', '2019-07-01 14:53:31', '2019-07-01 14:53:31');
INSERT INTO `oauth2_refresh_token` VALUES ('fc722fbffe434acba115e1ff15939177', NULL, NULL, 1, '2019-03-23 09:18:47', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('fc7de55c90a14253aed61786c5754317', 27, 2, 1, '2019-07-25 00:13:45', '2019-07-24 12:13:44', '2019-07-24 12:13:44');
INSERT INTO `oauth2_refresh_token` VALUES ('fc87e383a0ca45dd84b89a42676e0956', 27, 2, 1, '2019-07-23 02:59:04', '2019-07-22 14:59:04', '2019-07-22 14:59:04');
INSERT INTO `oauth2_refresh_token` VALUES ('fca4e32a738d4598a9d9a3ea29ee06ba', 27, 2, 1, '2019-06-04 02:57:41', '2019-06-03 14:57:41', '2019-06-03 14:57:41');
INSERT INTO `oauth2_refresh_token` VALUES ('fcace0004711465e813b7b6756ddc40d', 27, 2, 1, '2019-06-03 22:25:13', '2019-06-03 10:25:12', '2019-06-03 10:25:12');
INSERT INTO `oauth2_refresh_token` VALUES ('fcb545dc65e84d4fadfec8f0f292f6be', 182, 1, 1, '2019-07-27 12:45:27', '2019-07-27 00:45:26', '2019-07-27 00:45:26');
INSERT INTO `oauth2_refresh_token` VALUES ('fcbea7ed0ae9421f924d76e4c3a41ed0', 27, 2, 1, '2019-05-30 22:28:24', '2019-05-30 10:28:24', '2019-05-30 10:28:24');
INSERT INTO `oauth2_refresh_token` VALUES ('fcc4acab7c18444a98be3b87c482631c', NULL, NULL, 1, '2019-04-27 03:54:27', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('fcd922f6a60341fe92433023cd13b73a', 27, 2, 1, '2019-05-21 22:07:25', '2019-05-21 10:07:24', '2019-05-21 10:07:24');
INSERT INTO `oauth2_refresh_token` VALUES ('fcf09369ceb94cf88b6027b65bc6dc62', 27, 2, 1, '2019-07-19 05:11:32', '2019-07-18 17:11:31', '2019-07-18 17:11:31');
INSERT INTO `oauth2_refresh_token` VALUES ('fd0961d6c5ae4d71987a12e7f1b7b364', NULL, NULL, 1, '2019-05-10 20:58:59', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('fd0a330853284673bac781de6bd22caf', 27, 2, 1, '2019-05-28 06:04:07', '2019-05-27 18:04:07', '2019-05-27 18:04:07');
INSERT INTO `oauth2_refresh_token` VALUES ('fd1f572de8d24b029feb72ee6fd9f523', 27, 2, 1, '2019-08-21 21:01:45', '2019-08-21 09:01:44', '2019-08-21 09:01:44');
INSERT INTO `oauth2_refresh_token` VALUES ('fd30a7362bf643a8b31951c85ea063b4', 27, 2, 1, '2019-09-09 04:29:04', '2019-09-08 16:29:04', '2019-09-08 16:29:04');
INSERT INTO `oauth2_refresh_token` VALUES ('fd61c94969a648059c5238c58360ff7f', 27, 2, 1, '2019-06-08 09:44:49', '2019-06-07 21:44:48', '2019-06-07 21:44:48');
INSERT INTO `oauth2_refresh_token` VALUES ('fd6fef9433ab49a5a12f597c1b7e0a50', 27, 2, 1, '2019-06-03 09:19:26', '2019-06-02 21:19:26', '2019-06-02 21:19:26');
INSERT INTO `oauth2_refresh_token` VALUES ('fd7c92a5a61341a9b71ed4c973a6fa72', NULL, NULL, 1, '2019-03-10 15:36:25', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('fd8985d6de614993be28a21fe960abd8', 27, 2, 1, '2019-05-28 22:07:35', '2019-05-28 10:07:34', '2019-05-28 10:07:34');
INSERT INTO `oauth2_refresh_token` VALUES ('fd8b80e2958848d09a7ae3680e86e363', 27, 2, 1, '2019-06-17 00:22:09', '2019-06-16 12:22:08', '2019-06-16 12:22:08');
INSERT INTO `oauth2_refresh_token` VALUES ('fd9d4cf14c3a4463a1a3f4ba989ed3e9', 27, 2, 1, '2019-06-23 09:09:08', '2019-06-22 21:09:08', '2019-06-22 21:09:08');
INSERT INTO `oauth2_refresh_token` VALUES ('fda99c255b2a4b2994d46731cdbd8470', 27, 2, 1, '2019-08-18 10:45:37', '2019-08-17 22:45:37', '2019-08-17 22:45:37');
INSERT INTO `oauth2_refresh_token` VALUES ('fdddcd2d0b684f4f81ec3b63d43f76a7', 27, 2, 1, '2019-08-28 02:28:33', '2019-08-27 14:28:33', '2019-08-27 14:28:33');
INSERT INTO `oauth2_refresh_token` VALUES ('fde48eaf0dfa404795524c758ffc2d7d', 27, 2, 1, '2019-06-30 09:37:15', '2019-06-29 21:37:14', '2019-06-29 21:37:14');
INSERT INTO `oauth2_refresh_token` VALUES ('fdf307128685414c92cacb66ce5cb19e', 27, 2, 1, '2019-08-27 03:10:22', '2019-08-26 15:10:21', '2019-08-26 15:10:21');
INSERT INTO `oauth2_refresh_token` VALUES ('fe03589217de4a1f8d1a6aa249eb1aaf', 27, 2, 1, '2019-08-18 01:10:18', '2019-08-17 13:10:18', '2019-08-17 13:10:18');
INSERT INTO `oauth2_refresh_token` VALUES ('fe0a9a927442414e92acd4a640d60c0e', 188, 1, 1, '2019-08-02 10:17:42', '2019-08-01 22:17:41', '2019-08-01 22:17:41');
INSERT INTO `oauth2_refresh_token` VALUES ('fe160604db384a5a9dfc03f73f4f28b8', 27, 2, 1, '2019-06-01 21:57:02', '2019-06-01 09:57:02', '2019-06-01 09:57:02');
INSERT INTO `oauth2_refresh_token` VALUES ('fe20bd72f32d4bf49fad2f5b725ae0c2', NULL, NULL, 1, '2019-03-10 14:26:07', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('fe461a1ee724484797511c27aeb1b108', 27, 2, 1, '2019-06-01 21:58:00', '2019-06-01 09:58:00', '2019-06-01 09:58:00');
INSERT INTO `oauth2_refresh_token` VALUES ('fe69577efeda4da1b3296fee10541153', NULL, NULL, 1, '2019-05-12 04:56:20', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('fe7e04b0c2ca4eadab19784eda28b25c', 27, 2, 1, '2019-07-03 00:37:25', '2019-07-02 12:37:24', '2019-07-02 12:37:24');
INSERT INTO `oauth2_refresh_token` VALUES ('fe848f84d73b4c15a75aa4c789b0043b', 27, 2, 1, '2019-09-05 23:54:18', '2019-09-05 11:54:18', '2019-09-05 11:54:18');
INSERT INTO `oauth2_refresh_token` VALUES ('fe85d96937a94ae192e5f095953c4ee6', 27, 2, 1, '2019-09-03 06:22:00', '2019-09-02 18:21:59', '2019-09-02 18:21:59');
INSERT INTO `oauth2_refresh_token` VALUES ('fe85d98201bc422ab9d515cf60c743c1', 215, 1, 1, '2019-08-30 21:13:12', '2019-08-30 09:13:11', '2019-08-30 09:13:11');
INSERT INTO `oauth2_refresh_token` VALUES ('fea8002073244b0795d593228ab02c51', NULL, NULL, 1, '2019-04-30 02:09:46', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('feabc92363f7479392a75310abf6a542', 27, 2, 1, '2019-06-20 23:39:32', '2019-06-20 11:39:32', '2019-06-20 11:39:32');
INSERT INTO `oauth2_refresh_token` VALUES ('feebdb785c7049aca33ba931ed744b52', 27, 2, 1, '2019-06-21 06:39:43', '2019-06-20 18:39:42', '2019-06-20 18:39:42');
INSERT INTO `oauth2_refresh_token` VALUES ('ff215e32c98b4de1a940cf2b9349b219', 27, 2, 1, '2019-06-03 21:06:45', '2019-06-03 09:06:45', '2019-06-03 09:06:45');
INSERT INTO `oauth2_refresh_token` VALUES ('ff2fe1ce66af41aab17713c47125a22c', 27, 2, 1, '2019-07-11 05:10:00', '2019-07-10 17:10:00', '2019-07-10 17:10:00');
INSERT INTO `oauth2_refresh_token` VALUES ('ff3bfbb7a97840319d728ae3a03a4d2c', 1, 2, 0, '2019-05-27 11:04:26', '2019-05-26 23:04:26', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ff3d70e200854fb3aeac1a20b26e65b8', 1, 2, 0, '2019-06-01 02:23:37', '2019-05-31 14:22:17', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ff53f07456b4406e9bf4a4dbabce0201', 27, 2, 1, '2019-07-13 18:34:41', '2019-07-13 06:34:40', '2019-07-13 06:34:40');
INSERT INTO `oauth2_refresh_token` VALUES ('ff59b0f67cb34f659219677879b532b1', 27, 2, 1, '2019-09-05 23:51:16', '2019-09-05 11:51:15', '2019-09-05 11:51:15');
INSERT INTO `oauth2_refresh_token` VALUES ('ff62d031c7eb4a1285798b7f31fca827', 27, 2, 1, '2019-07-01 11:06:37', '2019-06-30 23:06:37', '2019-06-30 23:06:37');
INSERT INTO `oauth2_refresh_token` VALUES ('ff64d6a9bdc44cf78351f06777a58709', 27, 2, 1, '2019-07-17 02:41:01', '2019-07-16 14:41:00', '2019-07-16 14:41:00');
INSERT INTO `oauth2_refresh_token` VALUES ('ff65b9d7548d4f0e81f0a30e24e7808a', 27, 2, 1, '2019-05-23 10:48:10', '2019-05-22 22:48:09', '2019-05-22 22:48:09');
INSERT INTO `oauth2_refresh_token` VALUES ('ff6efb44987e465f9808772198575f19', 27, 2, 1, '2019-06-13 05:22:38', '2019-06-12 17:22:37', '2019-06-12 17:22:37');
INSERT INTO `oauth2_refresh_token` VALUES ('ff7a828ffc61460c939b6d17b98d2233', 27, 2, 1, '2019-08-20 04:33:46', '2019-08-19 16:33:46', '2019-08-19 16:33:46');
INSERT INTO `oauth2_refresh_token` VALUES ('ff8aeb4e8e49418e85d0f993933c35dc', 27, 2, 1, '2019-05-22 22:02:37', '2019-05-22 10:02:37', '2019-05-22 10:02:37');
INSERT INTO `oauth2_refresh_token` VALUES ('ff92c90db36b42b38bb01775079e11c3', NULL, NULL, 1, '2019-03-23 01:29:06', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ffa271c12b0b4516a0a2c45e109d9a78', 27, 2, 1, '2019-06-11 04:06:04', '2019-06-10 16:06:04', '2019-06-10 16:06:04');
INSERT INTO `oauth2_refresh_token` VALUES ('ffc0bc95a227453dbc89362e99701c02', 27, 2, 1, '2019-06-01 21:53:37', '2019-06-01 09:53:36', '2019-06-01 09:53:36');
INSERT INTO `oauth2_refresh_token` VALUES ('ffc110b447244cf8b4ea30498b712125', 1, 2, 0, '2019-06-22 03:41:49', '2019-06-21 15:41:49', '2019-09-07 22:47:14');
INSERT INTO `oauth2_refresh_token` VALUES ('ffddd31023bf446697aa3ea941ebc073', NULL, NULL, 1, '2019-04-26 01:42:20', NULL, '2019-05-16 16:29:22');
INSERT INTO `oauth2_refresh_token` VALUES ('ffe9975faffd4029ab45da73ddceb929', 27, 2, 1, '2019-07-05 02:48:29', '2019-07-04 14:48:29', '2019-07-04 14:48:29');
INSERT INTO `oauth2_refresh_token` VALUES ('fff43f35fc1047b2b9b1f7a1d15ea6c8', 27, 2, 1, '2019-08-15 05:35:27', '2019-08-14 17:35:26', '2019-08-14 17:35:26');
COMMIT;

-- ----------------------------
-- Table structure for resource
-- ----------------------------
DROP TABLE IF EXISTS `resource`;
CREATE TABLE `resource` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '资源编号',
  `type` int(11) NOT NULL DEFAULT '-1' COMMENT '资源类型',
  `sort` int(11) NOT NULL DEFAULT '-1' COMMENT '排序',
  `display_name` varchar(50) NOT NULL DEFAULT '' COMMENT '展示名',
  `pid` int(11) NOT NULL DEFAULT '-1' COMMENT '父级资源编号(外键：{@link ResourceDO#id})',
  `handler` varchar(50) DEFAULT '' COMMENT '操作\n     *\n     * 当资源类型为【菜单】时，handler 配置为界面 URL ，或者前端组件名\n     * 当资源类型为【操作】时，handler 配置为后端 URL 。举个例子，如果有一个「创建管理员」的表单，那么前端界面上的按钮可以根据这个 url 判断是否展示，后端接收到该 url 的请求时会判断是否有权限。',
  `icon` varchar(50) DEFAULT NULL COMMENT '图标',
  `permissions` varchar(255) DEFAULT NULL COMMENT '权限标识数组，使用逗号分隔',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '添加时间',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
  `deleted` bit(1) NOT NULL DEFAULT b'0',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=55 DEFAULT CHARSET=utf8mb4 COMMENT='resource_d_o';

-- ----------------------------
-- Records of resource
-- ----------------------------
BEGIN;
INSERT INTO `resource` VALUES (1, 2, -1, '管理员信息', 0, '/admin/admin/info', NULL, NULL, '2019-02-24 09:07:43', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (2, 1, 1, '商品', 0, '', NULL, NULL, '2019-02-24 20:40:23', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (3, 1, 1, '商品管理', 2, '/product/list', NULL, NULL, '2019-02-27 23:34:36', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (8, 1, 1, '测试说明', 1, '123', NULL, NULL, '2019-02-28 09:11:15', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (9, 1, 1, '测试说明1', 0, NULL, NULL, NULL, '2019-02-28 10:33:57', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (10, 1, 1, '测试说明', 9, '/123', NULL, NULL, '2019-02-28 10:34:09', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (11, 1, 1, '测试', 9, '/admin/test', NULL, NULL, '2019-03-05 07:04:13', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (12, 1, 1, '首页', 0, NULL, NULL, NULL, '2019-03-10 03:56:58', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (13, 1, 8, '系统管理', 0, NULL, 'desktop', '', '2019-03-10 03:59:07', '2019-05-15 23:48:05', b'0');
INSERT INTO `resource` VALUES (14, 1, 0, '员工列表', 13, '/admin/admin-list', 'team', 'system.admin.page', '2019-03-10 03:59:29', '2019-05-16 10:47:59', b'0');
INSERT INTO `resource` VALUES (15, 1, 2, '权限列表', 13, '/admin/resource-list', NULL, NULL, '2019-03-10 03:59:56', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (16, 1, 1, '角色列表', 13, '/admin/role-list', NULL, NULL, '2019-03-10 04:00:35', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (17, 1, 1, '测试说明', 9, '/123', NULL, NULL, '2019-03-10 10:54:35', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (18, 1, 3, '角色管理', 13, '/admin/role-list', NULL, NULL, '2019-03-12 23:59:44', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (19, 1, 4, '数据字典', 13, '/admin/dictionary-list', 'select', 'system.dataDict.list', '2019-03-15 19:10:30', '2019-05-16 16:03:01', b'0');
INSERT INTO `resource` VALUES (20, 1, 4, '商品管理', 0, NULL, NULL, NULL, '2019-03-15 19:53:09', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (21, 1, 1, '商品列表', 20, '/product/product-spu-list', NULL, NULL, '2019-03-15 19:55:22', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (22, 1, 2, '展示类目', 20, '/product/product-category-list', NULL, NULL, '2019-03-15 19:56:42', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (23, 1, 7, '营销管理', 0, NULL, NULL, NULL, '2019-03-30 22:42:13', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (24, 1, 1, '首页广告', 23, '/promotion/banner-list', NULL, NULL, '2019-03-30 22:54:57', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (25, 1, 2, '商品推荐', 23, '/promotion/product-recommend-list', NULL, NULL, '2019-04-01 13:17:28', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (26, 1, 3, '优惠劵', 23, '/promotion/coupon-card-template-list', NULL, NULL, '2019-04-04 16:02:14', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (27, 1, 5, '订单管理', 0, NULL, NULL, NULL, '2019-04-06 12:53:55', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (28, 1, 1, '订单管理', 27, '/order/order-list', NULL, NULL, '2019-04-06 12:57:17', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (29, 1, 3, '商品品牌', 20, '/product/product-brand-list', NULL, NULL, '2019-04-09 17:58:36', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (30, 1, -99, '发布商品', 20, '/product/product-spu-add', NULL, NULL, '2019-05-01 21:01:38', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (31, 1, 0, '概述', 0, '/home', NULL, NULL, '2019-05-03 00:01:33', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (32, 1, 1, '数据分析', 0, NULL, NULL, NULL, '2019-05-03 00:02:08', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (33, 1, 2, '店铺资产', 0, NULL, 'money-collect', '', '2019-05-03 00:02:57', '2019-05-15 23:23:20', b'0');
INSERT INTO `resource` VALUES (34, 1, 6, '会员管理', 0, NULL, NULL, NULL, '2019-05-03 00:03:55', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (35, 1, 8, 'test', 0, NULL, NULL, NULL, '2019-05-03 13:23:46', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (36, 1, 1, '测试', 0, NULL, NULL, NULL, '2019-05-04 14:28:20', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (37, 1, 2, '测试2', 36, '/http://baidu.com', NULL, NULL, '2019-05-04 14:30:08', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (38, 2, 1, '策士3', 36, '/123213123123', NULL, NULL, '2019-05-04 14:30:37', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (39, 1, 1, 'ceshi', 0, NULL, NULL, NULL, '2019-05-04 14:41:06', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (40, 1, 1, '测试aa', 0, NULL, NULL, NULL, '2019-05-05 16:09:19', '2019-05-15 22:57:30', b'1');
INSERT INTO `resource` VALUES (41, 1, 24, '限时折扣', 23, '/promotion/time-limit-discount-list', NULL, NULL, '2019-05-07 22:34:30', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (42, 1, 25, '满减送', 23, '/promotion/full-privilege-list', NULL, NULL, '2019-05-08 00:05:20', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (43, 1, 1, '会员资料', 34, '/member/user-list', NULL, NULL, '2019-05-08 11:11:22', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (44, 1, 1, '支付单', 33, '/pay/transaction-list', NULL, NULL, '2019-05-08 14:17:15', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (45, 1, 2, '退款单', 33, '/pay/refund-list', NULL, NULL, '2019-05-08 16:58:05', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (46, 1, 1, '订单售后', 27, '/order/order-refunds', NULL, NULL, '2019-05-09 19:57:23', '2019-05-15 22:57:30', b'0');
INSERT INTO `resource` VALUES (47, 2, 1, '新建员工', 14, '', NULL, 'system.admin.add,system.admin.update', '2019-05-15 23:43:58', '2019-05-15 23:45:12', b'0');
INSERT INTO `resource` VALUES (48, 2, 1, '新建字典', 19, '', NULL, 'system.dataDict.add', '2019-05-16 16:00:57', '2019-05-16 16:00:56', b'0');
INSERT INTO `resource` VALUES (49, 2, 2, '编辑字典', 19, '', NULL, 'system.dataDict.update', '2019-05-16 16:01:18', '2019-05-16 16:01:18', b'0');
INSERT INTO `resource` VALUES (50, 2, 3, '删除字典', 19, '', NULL, 'system.dataDict.delete', '2019-05-16 16:01:36', '2019-05-16 16:01:36', b'0');
INSERT INTO `resource` VALUES (51, 1, -1, '短信ss', 0, '', 'user', '', '2019-05-26 12:00:31', '2019-06-03 13:54:54', b'0');
INSERT INTO `resource` VALUES (52, 1, 1, '短信签名', 51, '/sms/sign-list', 'user', '', '2019-05-26 12:01:56', '2019-05-26 12:01:56', b'0');
INSERT INTO `resource` VALUES (53, 1, 2, '短信模板', 51, '/sms/template-list', 'user', '', '2019-05-26 12:02:19', '2019-05-26 12:02:18', b'0');
INSERT INTO `resource` VALUES (54, 1, 6, '拼团购', 23, '/promotion/group-buy-list', ' ', '', '2019-07-07 16:51:47', '2019-07-07 16:54:52', b'0');
COMMIT;

-- ----------------------------
-- Table structure for role
-- ----------------------------
DROP TABLE IF EXISTS `role`;
CREATE TABLE `role` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '角色编号',
  `name` varchar(50) NOT NULL DEFAULT '' COMMENT '角色名',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` datetime DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '最后更新时间',
  `deleted` bit(1) NOT NULL DEFAULT b'0' COMMENT '是否删除',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=utf8mb4 COMMENT='role_d_o';

-- ----------------------------
-- Records of role
-- ----------------------------
BEGIN;
INSERT INTO `role` VALUES (1, '系统管理员', '2019-02-24 09:03:51', '2019-05-15 15:25:49', b'0');
INSERT INTO `role` VALUES (2, '测试角色', '2019-02-28 19:45:17', '2019-06-11 15:10:50', b'1');
INSERT INTO `role` VALUES (3, '我不是测试', '2019-02-28 19:45:21', '2019-05-15 15:25:49', b'1');
INSERT INTO `role` VALUES (4, '123', '2019-03-06 05:58:32', '2019-05-15 15:25:49', b'1');
INSERT INTO `role` VALUES (5, 'admin,', '2019-03-10 04:06:52', '2019-05-15 15:25:49', b'1');
INSERT INTO `role` VALUES (6, 'admin', '2019-03-11 00:02:41', '2019-05-15 15:25:49', b'0');
INSERT INTO `role` VALUES (7, '系统管理员', '2019-05-16 23:44:20', '2019-05-17 17:07:54', b'1');
INSERT INTO `role` VALUES (8, '测试', '2019-06-11 15:03:19', '2019-06-11 15:11:01', b'1');
INSERT INTO `role` VALUES (9, '商品管理员', '2019-07-12 10:14:58', '2019-07-12 10:14:57', b'0');
INSERT INTO `role` VALUES (10, '测试', '2019-09-02 20:15:05', '2019-09-02 20:15:04', b'0');
INSERT INTO `role` VALUES (11, '老张', '2019-09-04 22:56:33', '2019-09-04 22:56:33', b'0');
INSERT INTO `role` VALUES (12, 'aaa', '2019-09-08 22:06:33', '2019-09-08 22:06:43', b'1');
COMMIT;

-- ----------------------------
-- Table structure for role_resource
-- ----------------------------
DROP TABLE IF EXISTS `role_resource`;
CREATE TABLE `role_resource` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '编号',
  `role_id` int(11) NOT NULL DEFAULT '-1' COMMENT '角色编号(外键：{@link RoleDO}',
  `resource_id` int(11) NOT NULL DEFAULT '-1' COMMENT '资源编号',
  `create_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
  `update_time` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',
  `deleted` bit(1) NOT NULL DEFAULT b'0' COMMENT '是否删除',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=719 DEFAULT CHARSET=utf8mb4 COMMENT='role_resource_d_o';

-- ----------------------------
-- Records of role_resource
-- ----------------------------
BEGIN;
INSERT INTO `role_resource` VALUES (1, 1, 1, '2019-02-27 01:10:08', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (2, 1, 2, '2019-02-27 23:40:30', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (3, 1, 3, '2019-02-27 23:40:39', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (4, 1, 8, '2019-02-28 23:45:01', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (5, 2, 1, '2019-03-01 04:58:42', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (6, 2, 2, '2019-03-01 04:58:42', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (7, 2, 1, '2019-03-01 04:58:44', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (8, 2, 2, '2019-03-01 04:58:44', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (9, 2, 1, '2019-03-01 04:58:54', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (10, 2, 2, '2019-03-01 04:58:54', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (11, 5, 1, '2019-03-10 22:20:53', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (12, 5, 2, '2019-03-10 22:20:53', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (13, 5, 1, '2019-03-10 23:57:54', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (14, 5, 2, '2019-03-10 23:57:54', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (15, 5, 1, '2019-03-10 23:58:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (16, 5, 2, '2019-03-10 23:58:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (17, 5, 15, '2019-03-11 00:00:08', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (18, 5, 13, '2019-03-11 00:00:22', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (19, 5, 14, '2019-03-11 00:00:22', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (20, 5, 15, '2019-03-11 00:00:22', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (21, 5, 16, '2019-03-11 00:00:22', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (22, 5, 12, '2019-03-11 00:00:37', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (23, 5, 12, '2019-03-11 00:00:49', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (24, 5, 13, '2019-03-11 00:00:49', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (25, 5, 14, '2019-03-11 00:00:49', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (26, 5, 15, '2019-03-11 00:00:49', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (27, 5, 16, '2019-03-11 00:00:49', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (28, 5, 12, '2019-03-11 00:00:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (29, 5, 13, '2019-03-11 00:00:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (30, 5, 14, '2019-03-11 00:00:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (31, 5, 15, '2019-03-11 00:00:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (32, 5, 16, '2019-03-11 00:00:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (33, 5, 13, '2019-03-11 00:02:13', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (34, 5, 14, '2019-03-11 00:02:13', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (35, 5, 15, '2019-03-11 00:02:13', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (36, 5, 16, '2019-03-11 00:02:13', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (37, 6, 1, '2019-03-11 00:02:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (38, 6, 2, '2019-03-11 00:02:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (39, 6, 9, '2019-03-11 00:02:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (40, 6, 17, '2019-03-11 00:02:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (41, 6, 1, '2019-03-11 00:02:56', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (42, 6, 2, '2019-03-11 00:02:56', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (43, 6, 9, '2019-03-11 00:02:56', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (44, 6, 12, '2019-03-11 00:02:56', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (45, 6, 13, '2019-03-11 00:02:56', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (46, 6, 14, '2019-03-11 00:02:56', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (47, 6, 15, '2019-03-11 00:02:56', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (48, 6, 16, '2019-03-11 00:02:56', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (49, 6, 17, '2019-03-11 00:02:56', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (50, 6, 1, '2019-03-11 00:03:26', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (51, 6, 2, '2019-03-11 00:03:26', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (52, 6, 9, '2019-03-11 00:03:26', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (53, 6, 12, '2019-03-11 00:03:26', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (54, 6, 13, '2019-03-11 00:03:26', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (55, 6, 14, '2019-03-11 00:03:26', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (56, 6, 15, '2019-03-11 00:03:26', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (57, 6, 16, '2019-03-11 00:03:26', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (58, 6, 17, '2019-03-11 00:03:26', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (59, 6, 1, '2019-03-11 00:04:37', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (60, 6, 2, '2019-03-11 00:04:37', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (61, 6, 13, '2019-03-11 00:04:37', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (62, 6, 14, '2019-03-11 00:04:37', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (63, 6, 15, '2019-03-11 00:04:37', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (64, 6, 16, '2019-03-11 00:04:37', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (65, 6, 1, '2019-03-11 00:04:40', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (66, 6, 2, '2019-03-11 00:04:40', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (67, 6, 9, '2019-03-11 00:04:40', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (68, 6, 13, '2019-03-11 00:04:40', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (69, 6, 14, '2019-03-11 00:04:40', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (70, 6, 15, '2019-03-11 00:04:40', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (71, 6, 16, '2019-03-11 00:04:40', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (72, 6, 17, '2019-03-11 00:04:40', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (73, 6, 1, '2019-03-11 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (74, 6, 2, '2019-03-11 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (75, 6, 1, '2019-03-11 00:05:06', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (76, 6, 2, '2019-03-11 00:05:06', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (77, 6, 9, '2019-03-11 00:05:06', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (78, 6, 13, '2019-03-11 00:05:06', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (79, 6, 14, '2019-03-11 00:05:06', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (80, 6, 15, '2019-03-11 00:05:06', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (81, 6, 16, '2019-03-11 00:05:06', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (82, 6, 17, '2019-03-11 00:05:06', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (83, 6, 1, '2019-03-11 00:05:10', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (84, 6, 2, '2019-03-11 00:05:10', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (85, 6, 13, '2019-03-11 00:05:10', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (86, 6, 14, '2019-03-11 00:05:10', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (87, 6, 15, '2019-03-11 00:05:10', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (88, 6, 16, '2019-03-11 00:05:10', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (89, 6, 1, '2019-03-11 00:21:38', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (90, 6, 2, '2019-03-11 00:21:38', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (91, 6, 13, '2019-03-11 00:21:38', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (92, 6, 14, '2019-03-11 00:21:38', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (93, 6, 15, '2019-03-11 00:21:38', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (94, 6, 16, '2019-03-11 00:21:38', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (95, 6, 1, '2019-03-11 00:21:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (96, 6, 2, '2019-03-11 00:21:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (97, 6, 13, '2019-03-11 00:21:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (98, 6, 14, '2019-03-11 00:21:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (99, 6, 15, '2019-03-11 00:21:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (100, 6, 16, '2019-03-11 00:21:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (101, 6, 1, '2019-03-11 00:22:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (102, 6, 2, '2019-03-11 00:22:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (103, 6, 13, '2019-03-11 00:22:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (104, 6, 14, '2019-03-11 00:22:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (105, 6, 15, '2019-03-11 00:22:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (106, 6, 16, '2019-03-11 00:22:55', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (107, 6, 1, '2019-03-11 00:23:27', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (108, 6, 9, '2019-03-11 00:23:44', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (109, 6, 17, '2019-03-11 00:23:44', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (110, 6, 1, '2019-03-11 00:24:04', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (111, 6, 2, '2019-03-11 00:24:04', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (112, 6, 1, '2019-03-11 22:19:08', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (113, 6, 2, '2019-03-11 22:19:08', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (114, 6, 1, '2019-03-11 22:19:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (115, 6, 13, '2019-03-11 22:19:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (116, 6, 14, '2019-03-11 22:19:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (117, 6, 15, '2019-03-11 22:19:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (118, 6, 16, '2019-03-11 22:19:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (119, 6, 1, '2019-03-11 22:20:21', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (120, 6, 9, '2019-03-11 23:05:09', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (121, 6, 17, '2019-03-11 23:05:09', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (122, 6, 14, '2019-03-11 23:05:16', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (123, 6, 14, '2019-03-11 23:05:26', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (124, 6, 14, '2019-03-11 23:05:37', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (125, 6, 15, '2019-03-11 23:05:37', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (126, 6, 16, '2019-03-11 23:06:37', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (127, 6, 9, '2019-03-11 23:06:54', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (128, 6, 17, '2019-03-11 23:06:54', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (129, 6, 15, '2019-03-11 23:12:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (130, 6, 16, '2019-03-11 23:12:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (131, 6, 14, '2019-03-11 23:12:32', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (132, 6, 13, '2019-03-12 01:43:30', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (133, 6, 16, '2019-03-12 01:43:30', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (134, 6, 13, '2019-03-12 01:43:42', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (135, 6, 14, '2019-03-12 01:43:42', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (136, 6, 13, '2019-03-12 01:55:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (137, 6, 14, '2019-03-12 01:55:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (138, 6, 15, '2019-03-12 01:55:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (139, 6, 9, '2019-03-12 01:55:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (140, 6, 13, '2019-03-12 01:55:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (141, 6, 14, '2019-03-12 01:55:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (142, 6, 15, '2019-03-12 01:55:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (143, 6, 17, '2019-03-12 01:55:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (144, 6, 9, '2019-03-13 00:13:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (145, 6, 13, '2019-03-13 00:13:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (146, 6, 16, '2019-03-13 00:13:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (147, 6, 14, '2019-03-13 00:13:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (148, 6, 15, '2019-03-13 00:13:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (149, 6, 9, '2019-03-13 00:13:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (150, 6, 13, '2019-03-13 00:13:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (151, 6, 14, '2019-03-13 00:13:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (152, 6, 15, '2019-03-13 00:13:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (153, 6, 9, '2019-03-13 00:13:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (154, 6, 13, '2019-03-13 00:13:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (155, 6, 14, '2019-03-13 00:13:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (156, 6, 15, '2019-03-13 00:13:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (157, 6, 16, '2019-03-13 00:13:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (158, 6, 9, '2019-03-15 19:10:43', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (159, 6, 13, '2019-03-15 19:10:43', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (160, 6, 14, '2019-03-15 19:10:43', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (161, 6, 15, '2019-03-15 19:10:43', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (162, 6, 16, '2019-03-15 19:10:43', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (163, 6, 19, '2019-03-15 19:10:43', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (164, 6, 20, '2019-03-15 19:56:50', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (165, 6, 21, '2019-03-15 19:56:50', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (166, 6, 22, '2019-03-15 19:56:50', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (167, 6, 20, '2019-03-15 20:05:38', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (168, 6, 21, '2019-03-15 20:05:38', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (169, 6, 22, '2019-03-15 20:05:38', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (170, 6, 20, '2019-03-15 21:07:32', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (171, 6, 21, '2019-03-15 21:07:32', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (172, 6, 22, '2019-03-15 21:07:32', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (173, 6, 20, '2019-03-15 21:08:08', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (174, 6, 21, '2019-03-15 21:08:08', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (175, 6, 22, '2019-03-15 21:08:08', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (176, 6, 20, '2019-03-15 21:08:56', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (177, 6, 21, '2019-03-15 21:08:56', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (178, 6, 22, '2019-03-15 21:08:56', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (179, 6, 20, '2019-03-15 21:14:20', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (180, 6, 21, '2019-03-15 21:14:20', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (181, 6, 22, '2019-03-15 21:14:20', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (182, 6, 20, '2019-03-15 21:14:28', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (183, 6, 21, '2019-03-15 21:14:28', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (184, 6, 22, '2019-03-15 21:14:28', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (185, 6, 20, '2019-03-15 21:14:40', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (186, 6, 21, '2019-03-15 21:14:40', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (187, 6, 22, '2019-03-15 21:14:40', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (188, 6, 20, '2019-03-15 21:16:03', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (189, 6, 21, '2019-03-15 21:16:03', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (190, 6, 22, '2019-03-15 21:16:03', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (191, 6, 20, '2019-03-15 21:16:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (192, 6, 21, '2019-03-15 21:16:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (193, 6, 22, '2019-03-15 21:16:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (194, 6, 20, '2019-03-15 21:20:08', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (195, 6, 21, '2019-03-15 21:20:08', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (196, 6, 22, '2019-03-15 21:20:08', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (197, 6, 20, '2019-03-15 21:20:23', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (198, 6, 21, '2019-03-15 21:20:23', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (199, 6, 22, '2019-03-15 21:20:23', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (200, 6, 20, '2019-03-15 21:22:28', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (201, 6, 21, '2019-03-15 21:22:28', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (202, 6, 22, '2019-03-15 21:22:28', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (203, 6, 20, '2019-03-15 21:24:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (204, 6, 21, '2019-03-15 21:24:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (205, 6, 22, '2019-03-15 21:24:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (206, 6, 13, '2019-03-15 21:24:51', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (207, 6, 14, '2019-03-15 21:24:51', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (208, 6, 15, '2019-03-15 21:24:51', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (209, 6, 16, '2019-03-15 21:24:51', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (210, 6, 19, '2019-03-15 21:24:51', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (211, 6, 20, '2019-03-15 21:24:51', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (212, 6, 21, '2019-03-15 21:24:51', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (213, 6, 22, '2019-03-15 21:24:51', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (214, 6, 13, '2019-03-30 22:55:13', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (215, 6, 14, '2019-03-30 22:55:13', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (216, 6, 15, '2019-03-30 22:55:13', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (217, 6, 16, '2019-03-30 22:55:13', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (218, 6, 19, '2019-03-30 22:55:13', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (219, 6, 20, '2019-03-30 22:55:13', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (220, 6, 21, '2019-03-30 22:55:13', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (221, 6, 22, '2019-03-30 22:55:13', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (222, 6, 23, '2019-03-30 22:55:13', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (223, 6, 24, '2019-03-30 22:55:13', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (224, 6, 13, '2019-04-01 13:17:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (225, 6, 14, '2019-04-01 13:17:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (226, 6, 15, '2019-04-01 13:17:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (227, 6, 16, '2019-04-01 13:17:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (228, 6, 19, '2019-04-01 13:17:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (229, 6, 20, '2019-04-01 13:17:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (230, 6, 21, '2019-04-01 13:17:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (231, 6, 22, '2019-04-01 13:17:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (232, 6, 23, '2019-04-01 13:17:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (233, 6, 24, '2019-04-01 13:17:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (234, 6, 25, '2019-04-01 13:17:41', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (235, 6, 13, '2019-04-04 16:03:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (236, 6, 14, '2019-04-04 16:03:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (237, 6, 15, '2019-04-04 16:03:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (238, 6, 16, '2019-04-04 16:03:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (239, 6, 19, '2019-04-04 16:03:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (240, 6, 20, '2019-04-04 16:03:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (241, 6, 21, '2019-04-04 16:03:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (242, 6, 22, '2019-04-04 16:03:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (243, 6, 23, '2019-04-04 16:03:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (244, 6, 24, '2019-04-04 16:03:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (245, 6, 25, '2019-04-04 16:03:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (246, 6, 26, '2019-04-04 16:03:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (247, 6, 13, '2019-04-06 12:57:29', '2019-05-26 12:03:10', b'1');
INSERT INTO `role_resource` VALUES (248, 6, 14, '2019-04-06 12:57:29', '2019-05-26 12:03:10', b'1');
INSERT INTO `role_resource` VALUES (249, 6, 15, '2019-04-06 12:57:29', '2019-05-26 12:03:10', b'1');
INSERT INTO `role_resource` VALUES (250, 6, 16, '2019-04-06 12:57:29', '2019-05-26 12:03:10', b'1');
INSERT INTO `role_resource` VALUES (251, 6, 19, '2019-04-06 12:57:29', '2019-05-26 12:03:10', b'1');
INSERT INTO `role_resource` VALUES (252, 6, 20, '2019-04-06 12:57:29', '2019-05-26 12:03:10', b'1');
INSERT INTO `role_resource` VALUES (253, 6, 21, '2019-04-06 12:57:29', '2019-05-26 12:03:10', b'1');
INSERT INTO `role_resource` VALUES (254, 6, 22, '2019-04-06 12:57:29', '2019-05-26 12:03:10', b'1');
INSERT INTO `role_resource` VALUES (255, 6, 23, '2019-04-06 12:57:29', '2019-05-26 12:03:10', b'1');
INSERT INTO `role_resource` VALUES (256, 6, 24, '2019-04-06 12:57:29', '2019-05-26 12:03:10', b'1');
INSERT INTO `role_resource` VALUES (257, 6, 25, '2019-04-06 12:57:29', '2019-05-26 12:03:10', b'1');
INSERT INTO `role_resource` VALUES (258, 6, 26, '2019-04-06 12:57:29', '2019-05-26 12:03:10', b'1');
INSERT INTO `role_resource` VALUES (259, 6, 27, '2019-04-06 12:57:29', '2019-05-26 12:03:10', b'1');
INSERT INTO `role_resource` VALUES (260, 6, 28, '2019-04-06 12:57:29', '2019-05-26 12:03:10', b'1');
INSERT INTO `role_resource` VALUES (261, 1, 13, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (262, 1, 14, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (263, 1, 15, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (264, 1, 16, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (265, 1, 19, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (266, 1, 20, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (267, 1, 21, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (268, 1, 22, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (269, 1, 23, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (270, 1, 24, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (271, 1, 25, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (272, 1, 26, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (273, 1, 27, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (274, 1, 28, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (275, 1, 29, '2019-04-09 17:59:24', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (276, 1, 21, '2019-04-27 22:07:33', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (277, 1, 22, '2019-04-27 22:07:33', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (278, 1, 29, '2019-04-27 22:07:33', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (279, 1, 28, '2019-04-27 22:07:33', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (280, 1, 24, '2019-04-27 22:07:33', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (281, 1, 25, '2019-04-27 22:07:33', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (282, 1, 26, '2019-04-27 22:07:33', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (283, 1, 14, '2019-04-27 22:07:33', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (284, 1, 15, '2019-04-27 22:07:33', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (285, 1, 16, '2019-04-27 22:07:33', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (286, 1, 19, '2019-04-27 22:07:33', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (287, 1, 21, '2019-04-29 15:44:57', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (288, 1, 22, '2019-04-29 15:44:57', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (289, 1, 29, '2019-04-29 15:44:57', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (290, 1, 28, '2019-04-29 15:44:57', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (291, 1, 24, '2019-04-29 15:44:57', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (292, 1, 25, '2019-04-29 15:44:57', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (293, 1, 26, '2019-04-29 15:44:57', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (294, 1, 14, '2019-04-29 15:44:57', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (295, 1, 15, '2019-04-29 15:44:57', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (296, 1, 16, '2019-04-29 15:44:57', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (297, 1, 19, '2019-04-29 15:44:57', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (298, 1, 13, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (299, 1, 14, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (300, 1, 15, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (301, 1, 16, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (302, 1, 19, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (303, 1, 20, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (304, 1, 21, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (305, 1, 22, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (306, 1, 23, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (307, 1, 24, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (308, 1, 25, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (309, 1, 26, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (310, 1, 27, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (311, 1, 28, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (312, 1, 29, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (313, 1, 30, '2019-05-01 21:02:18', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (314, 1, 13, '2019-05-01 21:08:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (315, 1, 14, '2019-05-01 21:08:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (316, 1, 15, '2019-05-01 21:08:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (317, 1, 16, '2019-05-01 21:08:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (318, 1, 19, '2019-05-01 21:08:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (319, 1, 21, '2019-05-01 21:08:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (320, 1, 22, '2019-05-01 21:08:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (321, 1, 23, '2019-05-01 21:08:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (322, 1, 24, '2019-05-01 21:08:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (323, 1, 25, '2019-05-01 21:08:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (324, 1, 26, '2019-05-01 21:08:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (325, 1, 27, '2019-05-01 21:08:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (326, 1, 28, '2019-05-01 21:08:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (327, 1, 30, '2019-05-01 21:08:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (328, 1, 13, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (329, 1, 14, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (330, 1, 15, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (331, 1, 16, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (332, 1, 19, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (333, 1, 21, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (334, 1, 22, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (335, 1, 23, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (336, 1, 24, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (337, 1, 25, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (338, 1, 26, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (339, 1, 27, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (340, 1, 28, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (341, 1, 30, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (342, 1, 31, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (343, 1, 32, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (344, 1, 33, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (345, 1, 34, '2019-05-03 00:05:02', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (346, 1, 13, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (347, 1, 14, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (348, 1, 15, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (349, 1, 16, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (350, 1, 19, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (351, 1, 20, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (352, 1, 21, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (353, 1, 22, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (354, 1, 23, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (355, 1, 24, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (356, 1, 25, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (357, 1, 26, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (358, 1, 27, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (359, 1, 28, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (360, 1, 29, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (361, 1, 30, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (362, 1, 31, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (363, 1, 32, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (364, 1, 33, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (365, 1, 34, '2019-05-05 12:57:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (366, 1, 14, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (367, 1, 15, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (368, 1, 16, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (369, 1, 20, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (370, 1, 21, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (371, 1, 22, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (372, 1, 23, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (373, 1, 24, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (374, 1, 25, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (375, 1, 26, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (376, 1, 27, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (377, 1, 28, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (378, 1, 29, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (379, 1, 30, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (380, 1, 31, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (381, 1, 32, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (382, 1, 33, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (383, 1, 34, '2019-05-05 16:04:17', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (384, 1, 13, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (385, 1, 14, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (386, 1, 15, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (387, 1, 16, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (388, 1, 19, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (389, 1, 20, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (390, 1, 21, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (391, 1, 22, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (392, 1, 23, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (393, 1, 24, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (394, 1, 25, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (395, 1, 26, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (396, 1, 27, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (397, 1, 28, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (398, 1, 29, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (399, 1, 30, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (400, 1, 31, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (401, 1, 32, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (402, 1, 33, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (403, 1, 34, '2019-05-05 16:05:15', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (404, 1, 13, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (405, 1, 14, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (406, 1, 15, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (407, 1, 16, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (408, 1, 19, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (409, 1, 20, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (410, 1, 21, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (411, 1, 22, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (412, 1, 23, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (413, 1, 24, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (414, 1, 25, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (415, 1, 26, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (416, 1, 27, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (417, 1, 28, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (418, 1, 29, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (419, 1, 30, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (420, 1, 31, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (421, 1, 32, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (422, 1, 33, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (423, 1, 34, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (424, 1, 40, '2019-05-05 16:09:45', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (425, 1, 13, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (426, 1, 14, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (427, 1, 15, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (428, 1, 16, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (429, 1, 19, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (430, 1, 20, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (431, 1, 21, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (432, 1, 22, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (433, 1, 23, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (434, 1, 24, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (435, 1, 25, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (436, 1, 26, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (437, 1, 27, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (438, 1, 28, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (439, 1, 29, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (440, 1, 30, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (441, 1, 31, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (442, 1, 32, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (443, 1, 33, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (444, 1, 34, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (445, 1, 41, '2019-05-07 22:35:48', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (446, 1, 13, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (447, 1, 14, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (448, 1, 15, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (449, 1, 16, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (450, 1, 19, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (451, 1, 20, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (452, 1, 21, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (453, 1, 22, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (454, 1, 23, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (455, 1, 24, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (456, 1, 25, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (457, 1, 26, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (458, 1, 27, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (459, 1, 28, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (460, 1, 29, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (461, 1, 30, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (462, 1, 31, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (463, 1, 32, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (464, 1, 33, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (465, 1, 34, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (466, 1, 41, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (467, 1, 42, '2019-05-08 00:05:36', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (468, 1, 13, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (469, 1, 14, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (470, 1, 15, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (471, 1, 16, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (472, 1, 19, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (473, 1, 20, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (474, 1, 21, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (475, 1, 22, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (476, 1, 23, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (477, 1, 24, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (478, 1, 25, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (479, 1, 26, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (480, 1, 27, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (481, 1, 28, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (482, 1, 29, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (483, 1, 30, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (484, 1, 31, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (485, 1, 32, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (486, 1, 33, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (487, 1, 34, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (488, 1, 41, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (489, 1, 42, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (490, 1, 43, '2019-05-08 11:12:34', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (491, 1, 13, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (492, 1, 14, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (493, 1, 15, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (494, 1, 16, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (495, 1, 19, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (496, 1, 20, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (497, 1, 21, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (498, 1, 22, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (499, 1, 23, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (500, 1, 24, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (501, 1, 25, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (502, 1, 26, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (503, 1, 27, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (504, 1, 28, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (505, 1, 29, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (506, 1, 30, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (507, 1, 31, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (508, 1, 32, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (509, 1, 33, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (510, 1, 34, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (511, 1, 41, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (512, 1, 42, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (513, 1, 43, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (514, 1, 44, '2019-05-08 14:17:31', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (515, 1, 13, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (516, 1, 14, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (517, 1, 15, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (518, 1, 16, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (519, 1, 19, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (520, 1, 21, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (521, 1, 22, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (522, 1, 23, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (523, 1, 24, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (524, 1, 25, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (525, 1, 26, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (526, 1, 27, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (527, 1, 28, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (528, 1, 30, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (529, 1, 31, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (530, 1, 32, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (531, 1, 33, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (532, 1, 34, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (533, 1, 41, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (534, 1, 42, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (535, 1, 43, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (536, 1, 44, '2019-05-08 16:37:05', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (537, 1, 13, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (538, 1, 14, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (539, 1, 15, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (540, 1, 16, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (541, 1, 19, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (542, 1, 21, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (543, 1, 22, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (544, 1, 23, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (545, 1, 24, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (546, 1, 25, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (547, 1, 26, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (548, 1, 27, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (549, 1, 28, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (550, 1, 30, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (551, 1, 31, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (552, 1, 32, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (553, 1, 33, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (554, 1, 34, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (555, 1, 41, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (556, 1, 42, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (557, 1, 43, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (558, 1, 44, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (559, 1, 45, '2019-05-08 16:58:19', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (560, 1, 13, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (561, 1, 14, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (562, 1, 15, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (563, 1, 16, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (564, 1, 19, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (565, 1, 20, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (566, 1, 21, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (567, 1, 22, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (568, 1, 23, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (569, 1, 24, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (570, 1, 25, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (571, 1, 26, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (572, 1, 27, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (573, 1, 28, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (574, 1, 29, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (575, 1, 30, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (576, 1, 31, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (577, 1, 32, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (578, 1, 33, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (579, 1, 34, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (580, 1, 41, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (581, 1, 42, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (582, 1, 43, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (583, 1, 44, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (584, 1, 45, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (585, 1, 46, '2019-05-09 20:58:00', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (586, 1, 31, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (587, 1, 32, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (588, 1, 44, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (589, 1, 45, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (590, 1, 21, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (591, 1, 22, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (592, 1, 29, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (593, 1, 30, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (594, 1, 28, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (595, 1, 46, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (596, 1, 43, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (597, 1, 24, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (598, 1, 25, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (599, 1, 26, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (600, 1, 41, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (601, 1, 42, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (602, 1, 14, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (603, 1, 15, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (604, 1, 16, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (605, 1, 19, '2019-05-15 16:43:14', '2019-05-16 14:36:13', b'1');
INSERT INTO `role_resource` VALUES (606, 1, 13, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (607, 1, 14, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (608, 1, 15, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (609, 1, 16, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (610, 1, 19, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (611, 1, 20, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (612, 1, 21, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (613, 1, 22, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (614, 1, 23, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (615, 1, 24, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (616, 1, 25, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (617, 1, 26, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (618, 1, 27, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (619, 1, 28, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (620, 1, 29, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (621, 1, 30, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (622, 1, 31, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (623, 1, 32, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (624, 1, 33, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (625, 1, 34, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (626, 1, 41, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (627, 1, 42, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (628, 1, 43, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (629, 1, 44, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (630, 1, 45, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (631, 1, 46, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (632, 1, 47, '2019-05-16 10:49:15', '2019-06-11 15:02:41', b'1');
INSERT INTO `role_resource` VALUES (633, 2, 31, '2019-05-16 17:54:16', '2019-06-11 15:10:50', b'1');
INSERT INTO `role_resource` VALUES (634, 6, 13, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (635, 6, 14, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (636, 6, 15, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (637, 6, 16, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (638, 6, 19, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (639, 6, 20, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (640, 6, 21, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (641, 6, 22, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (642, 6, 23, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (643, 6, 24, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (644, 6, 25, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (645, 6, 26, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (646, 6, 27, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (647, 6, 28, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (648, 6, 29, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (649, 6, 30, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (650, 6, 31, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (651, 6, 32, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (652, 6, 33, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (653, 6, 34, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (654, 6, 41, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (655, 6, 42, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (656, 6, 43, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (657, 6, 44, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (658, 6, 45, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (659, 6, 46, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (660, 6, 47, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (661, 6, 48, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (662, 6, 49, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (663, 6, 50, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (664, 6, 51, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (665, 6, 52, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (666, 6, 53, '2019-05-26 12:03:10', '2019-05-26 12:03:10', b'0');
INSERT INTO `role_resource` VALUES (667, 1, 14, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (668, 1, 15, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (669, 1, 16, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (670, 1, 20, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (671, 1, 21, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (672, 1, 22, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (673, 1, 23, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (674, 1, 24, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (675, 1, 25, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (676, 1, 26, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (677, 1, 27, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (678, 1, 28, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (679, 1, 29, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (680, 1, 30, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (681, 1, 31, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (682, 1, 32, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (683, 1, 33, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (684, 1, 34, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (685, 1, 41, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (686, 1, 42, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (687, 1, 43, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (688, 1, 44, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (689, 1, 45, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (690, 1, 46, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (691, 1, 47, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (692, 1, 51, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (693, 1, 52, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (694, 1, 53, '2019-06-11 15:02:42', '2019-06-11 15:02:41', b'0');
INSERT INTO `role_resource` VALUES (695, 8, 20, '2019-06-11 15:03:47', '2019-06-11 15:11:01', b'1');
INSERT INTO `role_resource` VALUES (696, 8, 21, '2019-06-11 15:03:47', '2019-06-11 15:11:01', b'1');
INSERT INTO `role_resource` VALUES (697, 8, 22, '2019-06-11 15:03:47', '2019-06-11 15:11:01', b'1');
INSERT INTO `role_resource` VALUES (698, 8, 29, '2019-06-11 15:03:47', '2019-06-11 15:11:01', b'1');
INSERT INTO `role_resource` VALUES (699, 8, 30, '2019-06-11 15:03:47', '2019-06-11 15:11:01', b'1');
INSERT INTO `role_resource` VALUES (700, 8, 33, '2019-06-11 15:03:47', '2019-06-11 15:11:01', b'1');
INSERT INTO `role_resource` VALUES (701, 8, 44, '2019-06-11 15:03:47', '2019-06-11 15:11:01', b'1');
INSERT INTO `role_resource` VALUES (702, 8, 45, '2019-06-11 15:03:47', '2019-06-11 15:11:01', b'1');
INSERT INTO `role_resource` VALUES (703, 8, 46, '2019-06-11 15:03:47', '2019-06-11 15:11:01', b'1');
INSERT INTO `role_resource` VALUES (704, 11, 32, '2019-09-04 22:57:15', '2019-09-08 23:00:09', b'1');
INSERT INTO `role_resource` VALUES (705, 11, 34, '2019-09-04 22:57:15', '2019-09-08 23:00:09', b'1');
INSERT INTO `role_resource` VALUES (706, 11, 43, '2019-09-04 22:57:15', '2019-09-08 23:00:09', b'1');
INSERT INTO `role_resource` VALUES (707, 11, 13, '2019-09-08 23:00:09', '2019-09-08 23:00:09', b'0');
INSERT INTO `role_resource` VALUES (708, 11, 14, '2019-09-08 23:00:09', '2019-09-08 23:00:09', b'0');
INSERT INTO `role_resource` VALUES (709, 11, 15, '2019-09-08 23:00:09', '2019-09-08 23:00:09', b'0');
INSERT INTO `role_resource` VALUES (710, 11, 16, '2019-09-08 23:00:09', '2019-09-08 23:00:09', b'0');
INSERT INTO `role_resource` VALUES (711, 11, 19, '2019-09-08 23:00:09', '2019-09-08 23:00:09', b'0');
INSERT INTO `role_resource` VALUES (712, 11, 32, '2019-09-08 23:00:09', '2019-09-08 23:00:09', b'0');
INSERT INTO `role_resource` VALUES (713, 11, 34, '2019-09-08 23:00:09', '2019-09-08 23:00:09', b'0');
INSERT INTO `role_resource` VALUES (714, 11, 43, '2019-09-08 23:00:09', '2019-09-08 23:00:09', b'0');
INSERT INTO `role_resource` VALUES (715, 11, 47, '2019-09-08 23:00:09', '2019-09-08 23:00:09', b'0');
INSERT INTO `role_resource` VALUES (716, 11, 48, '2019-09-08 23:00:09', '2019-09-08 23:00:09', b'0');
INSERT INTO `role_resource` VALUES (717, 11, 49, '2019-09-08 23:00:09', '2019-09-08 23:00:09', b'0');
INSERT INTO `role_resource` VALUES (718, 11, 50, '2019-09-08 23:00:09', '2019-09-08 23:00:09', b'0');
COMMIT;

-- ----------------------------
-- Table structure for sms_sign
-- ----------------------------
DROP TABLE IF EXISTS `sms_sign`;
CREATE TABLE `sms_sign` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sign` varchar(20) NOT NULL COMMENT '签名 如： 【阿里云】',
  `platform` smallint(2) DEFAULT NULL COMMENT '短信平台',
  `apply_status` smallint(2) NOT NULL COMMENT '审核状态',
  `apply_message` varchar(250) DEFAULT NULL COMMENT '审核信息',
  `deleted` smallint(2) NOT NULL COMMENT '删除状态',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  `create_time` datetime NOT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=17 DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Records of sms_sign
-- ----------------------------
BEGIN;
INSERT INTO `sms_sign` VALUES (3, '悦跑运动', 1, 2, NULL, 0, '2019-05-25 16:15:02', '2019-05-25 16:11:12');
INSERT INTO `sms_sign` VALUES (4, '阿里云短信测试专用', 2, 2, NULL, 0, '2019-05-26 10:23:48', '2019-05-26 10:23:48');
INSERT INTO `sms_sign` VALUES (5, 'ggggff', 2, 2, NULL, 0, '2019-05-26 18:08:56', '2019-05-26 16:25:07');
INSERT INTO `sms_sign` VALUES (6, 'asdfasf', 1, 2, NULL, 0, '2019-05-26 18:14:40', '2019-05-26 16:30:52');
INSERT INTO `sms_sign` VALUES (7, 'tttt', 1, 2, NULL, 0, '2019-05-26 18:14:31', '2019-05-26 16:31:33');
INSERT INTO `sms_sign` VALUES (8, '123333', 1, 2, NULL, 0, '2019-05-26 18:08:51', '2019-05-26 16:35:12');
INSERT INTO `sms_sign` VALUES (9, '123', 1, 2, NULL, 0, '2019-05-26 16:35:40', '2019-05-26 16:35:40');
INSERT INTO `sms_sign` VALUES (10, 'tst', 2, 2, NULL, 0, '2019-05-26 16:44:37', '2019-05-26 16:44:37');
INSERT INTO `sms_sign` VALUES (11, 'mid', 2, 2, NULL, 0, '2019-05-26 17:24:38', '2019-05-26 16:48:41');
INSERT INTO `sms_sign` VALUES (12, 'MM', 2, 2, NULL, 0, '2019-05-26 17:34:12', '2019-05-26 17:34:12');
INSERT INTO `sms_sign` VALUES (13, 'gg', 2, 2, NULL, 0, '2019-05-26 17:48:05', '2019-05-26 17:48:05');
INSERT INTO `sms_sign` VALUES (14, 'PP', 2, 2, NULL, 0, '2019-05-26 17:51:46', '2019-05-26 17:51:46');
INSERT INTO `sms_sign` VALUES (15, 'gg', 1, 2, NULL, 0, '2019-05-26 18:02:39', '2019-05-26 18:02:39');
INSERT INTO `sms_sign` VALUES (16, 'ga', 1, 2, NULL, 0, '2019-05-26 18:04:12', '2019-05-26 18:04:12');
COMMIT;

-- ----------------------------
-- Table structure for sms_template
-- ----------------------------
DROP TABLE IF EXISTS `sms_template`;
CREATE TABLE `sms_template` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `sms_sign_id` int(11) NOT NULL COMMENT '短信签名id',
  `template_code` varchar(50) NOT NULL COMMENT '模板code，第三方 code',
  `template` text NOT NULL COMMENT '短信模板',
  `platform` smallint(2) NOT NULL COMMENT '平台',
  `sms_type` smallint(2) NOT NULL COMMENT '短信类型：通知、验证码、营销',
  `apply_status` smallint(2) NOT NULL COMMENT '审核状态',
  `apply_message` varchar(250) DEFAULT NULL COMMENT '审核信息',
  `deleted` smallint(2) NOT NULL COMMENT '是否删除',
  `update_time` datetime DEFAULT NULL COMMENT '更新时间',
  `create_time` datetime NOT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8mb4;

-- ----------------------------
-- Records of sms_template
-- ----------------------------
BEGIN;
INSERT INTO `sms_template` VALUES (5, 3, '0000', '您的验证码是#code#，打死也不告诉别人哦。', 1, 1, 2, '', 0, NULL, '2019-05-25 16:34:29');
INSERT INTO `sms_template` VALUES (6, 4, 'SMS_137110043', '验证码#code#，您正在登录，若非本人操作，请勿泄露。', 2, 1, 2, '', 0, NULL, '2019-05-26 10:26:54');
INSERT INTO `sms_template` VALUES (7, 4, 'SMS_137110043', '验证码#code#，您正在登录，若非本人操作，请勿泄露。', 2, 1, 2, '', 0, NULL, '2019-05-26 10:39:07');
INSERT INTO `sms_template` VALUES (8, 6, 'SM_2323', '短信模板#code#测试，不要', 1, 2, 2, '', 1, '2019-05-27 00:11:18', '2019-05-26 23:53:52');
COMMIT;

SET FOREIGN_KEY_CHECKS = 1;
